/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var f1=["require","exports","vs/base/common/errors","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/arraysFind","vs/base/common/charCode","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/map","vs/base/common/platform","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/cache","vs/base/common/types","vs/base/common/objects","vs/base/common/uint","vs/base/common/strings","vs/base/common/worker/simpleWorker"],h1=function(i1){for(var t=[],m=0,e=i1.length;m<e;m++)t[m]=f1[i1[m]];return t};define(f1[6],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=m,t.findLastIdx=e,t.findLastMonotonous=P,t.findLastIdxMonotonous=p,t.findFirstMonotonous=s1,t.findFirstIdxMonotonousOrArrLen=V,t.findFirstIdxMonotonous=w,t.findFirstMax=M,t.findLastMax=B,t.findFirstMin=G,t.findMaxIdx=r1,t.mapFindFirst=_1;function m(W,j){const S=e(W,j);if(S!==-1)return W[S]}function e(W,j,S=W.length-1){for(let h=S;h>=0;h--){const L=W[h];if(j(L))return h}return-1}function P(W,j){const S=p(W,j);return S===-1?void 0:W[S]}function p(W,j,S=0,h=W.length){let L=S,I=h;for(;L<I;){const g=Math.floor((L+I)/2);j(W[g])?L=g+1:I=g}return L-1}function s1(W,j){const S=V(W,j);return S===W.length?void 0:W[S]}function V(W,j,S=0,h=W.length){let L=S,I=h;for(;L<I;){const g=Math.floor((L+I)/2);j(W[g])?I=g:L=g+1}return L}function w(W,j,S=0,h=W.length){const L=V(W,j,S,h);return L===W.length?-1:L}class A{static{this.assertInvariants=!1}constructor(j){this._array=j,this._findLastMonotonousLastIdx=0}findLastMonotonous(j){if(A.assertInvariants){if(this._prevFindLastPredicate){for(const h of this._array)if(this._prevFindLastPredicate(h)&&!j(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=j}const S=p(this._array,j,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=S+1,S===-1?void 0:this._array[S]}}t.MonotonousArray=A;function M(W,j){if(W.length===0)return;let S=W[0];for(let h=1;h<W.length;h++){const L=W[h];j(L,S)>0&&(S=L)}return S}function B(W,j){if(W.length===0)return;let S=W[0];for(let h=1;h<W.length;h++){const L=W[h];j(L,S)>=0&&(S=L)}return S}function G(W,j){return M(W,(S,h)=>-j(S,h))}function r1(W,j){if(W.length===0)return-1;let S=0;for(let h=1;h<W.length;h++){const L=W[h];j(L,W[S])>0&&(S=h)}return S}function _1(W,j){for(const S of W){const h=j(S);if(h!==void 0)return h}}}),define(f1[7],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var m;(function(e){e[e.Null=0]="Null",e[e.Backspace=8]="Backspace",e[e.Tab=9]="Tab",e[e.LineFeed=10]="LineFeed",e[e.CarriageReturn=13]="CarriageReturn",e[e.Space=32]="Space",e[e.ExclamationMark=33]="ExclamationMark",e[e.DoubleQuote=34]="DoubleQuote",e[e.Hash=35]="Hash",e[e.DollarSign=36]="DollarSign",e[e.PercentSign=37]="PercentSign",e[e.Ampersand=38]="Ampersand",e[e.SingleQuote=39]="SingleQuote",e[e.OpenParen=40]="OpenParen",e[e.CloseParen=41]="CloseParen",e[e.Asterisk=42]="Asterisk",e[e.Plus=43]="Plus",e[e.Comma=44]="Comma",e[e.Dash=45]="Dash",e[e.Period=46]="Period",e[e.Slash=47]="Slash",e[e.Digit0=48]="Digit0",e[e.Digit1=49]="Digit1",e[e.Digit2=50]="Digit2",e[e.Digit3=51]="Digit3",e[e.Digit4=52]="Digit4",e[e.Digit5=53]="Digit5",e[e.Digit6=54]="Digit6",e[e.Digit7=55]="Digit7",e[e.Digit8=56]="Digit8",e[e.Digit9=57]="Digit9",e[e.Colon=58]="Colon",e[e.Semicolon=59]="Semicolon",e[e.LessThan=60]="LessThan",e[e.Equals=61]="Equals",e[e.GreaterThan=62]="GreaterThan",e[e.QuestionMark=63]="QuestionMark",e[e.AtSign=64]="AtSign",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.OpenSquareBracket=91]="OpenSquareBracket",e[e.Backslash=92]="Backslash",e[e.CloseSquareBracket=93]="CloseSquareBracket",e[e.Caret=94]="Caret",e[e.Underline=95]="Underline",e[e.BackTick=96]="BackTick",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.OpenCurlyBrace=123]="OpenCurlyBrace",e[e.Pipe=124]="Pipe",e[e.CloseCurlyBrace=125]="CloseCurlyBrace",e[e.Tilde=126]="Tilde",e[e.NoBreakSpace=160]="NoBreakSpace",e[e.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",e[e.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",e[e.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",e[e.U_Combining_Tilde=771]="U_Combining_Tilde",e[e.U_Combining_Macron=772]="U_Combining_Macron",e[e.U_Combining_Overline=773]="U_Combining_Overline",e[e.U_Combining_Breve=774]="U_Combining_Breve",e[e.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",e[e.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",e[e.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",e[e.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",e[e.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",e[e.U_Combining_Caron=780]="U_Combining_Caron",e[e.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",e[e.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",e[e.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",e[e.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",e[e.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",e[e.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",e[e.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",e[e.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",e[e.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",e[e.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",e[e.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",e[e.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",e[e.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",e[e.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",e[e.U_Combining_Horn=795]="U_Combining_Horn",e[e.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",e[e.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",e[e.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",e[e.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",e[e.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",e[e.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",e[e.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",e[e.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",e[e.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",e[e.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",e[e.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",e[e.U_Combining_Cedilla=807]="U_Combining_Cedilla",e[e.U_Combining_Ogonek=808]="U_Combining_Ogonek",e[e.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",e[e.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",e[e.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",e[e.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",e[e.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",e[e.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",e[e.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",e[e.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",e[e.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",e[e.U_Combining_Low_Line=818]="U_Combining_Low_Line",e[e.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",e[e.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",e[e.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",e[e.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",e[e.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",e[e.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",e[e.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",e[e.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",e[e.U_Combining_Square_Below=827]="U_Combining_Square_Below",e[e.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",e[e.U_Combining_X_Above=829]="U_Combining_X_Above",e[e.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",e[e.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",e[e.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",e[e.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",e[e.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",e[e.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",e[e.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",e[e.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",e[e.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",e[e.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",e[e.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",e[e.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",e[e.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",e[e.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",e[e.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",e[e.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",e[e.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",e[e.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",e[e.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",e[e.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",e[e.U_Combining_Fermata=850]="U_Combining_Fermata",e[e.U_Combining_X_Below=851]="U_Combining_X_Below",e[e.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",e[e.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",e[e.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",e[e.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",e[e.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",e[e.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",e[e.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",e[e.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",e[e.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",e[e.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",e[e.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",e[e.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",e[e.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",e[e.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",e[e.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",e[e.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",e[e.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",e[e.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",e[e.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",e[e.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",e[e.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",e[e.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",e[e.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",e[e.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",e[e.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",e[e.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",e[e.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",e[e.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",e[e.LINE_SEPARATOR=8232]="LINE_SEPARATOR",e[e.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",e[e.NEXT_LINE=133]="NEXT_LINE",e[e.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",e[e.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",e[e.U_DIAERESIS=168]="U_DIAERESIS",e[e.U_MACRON=175]="U_MACRON",e[e.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",e[e.U_CEDILLA=184]="U_CEDILLA",e[e.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",e[e.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",e[e.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",e[e.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",e[e.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",e[e.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",e[e.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",e[e.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",e[e.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",e[e.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",e[e.U_BREVE=728]="U_BREVE",e[e.U_DOT_ABOVE=729]="U_DOT_ABOVE",e[e.U_RING_ABOVE=730]="U_RING_ABOVE",e[e.U_OGONEK=731]="U_OGONEK",e[e.U_SMALL_TILDE=732]="U_SMALL_TILDE",e[e.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",e[e.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",e[e.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",e[e.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",e[e.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",e[e.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",e[e.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",e[e.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",e[e.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",e[e.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",e[e.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",e[e.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",e[e.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",e[e.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",e[e.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",e[e.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",e[e.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",e[e.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",e[e.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",e[e.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",e[e.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",e[e.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",e[e.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",e[e.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",e[e.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",e[e.U_GREEK_TONOS=900]="U_GREEK_TONOS",e[e.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",e[e.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",e[e.U_GREEK_PSILI=8127]="U_GREEK_PSILI",e[e.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",e[e.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",e[e.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",e[e.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",e[e.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",e[e.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",e[e.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",e[e.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",e[e.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",e[e.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",e[e.U_GREEK_VARIA=8175]="U_GREEK_VARIA",e[e.U_GREEK_OXIA=8189]="U_GREEK_OXIA",e[e.U_GREEK_DASIA=8190]="U_GREEK_DASIA",e[e.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",e[e.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",e[e.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",e[e.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",e[e.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",e[e.U_OVERLINE=8254]="U_OVERLINE",e[e.UTF8_BOM=65279]="UTF8_BOM",e[e.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",e[e.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(m||(t.CharCode=m={}))}),define(f1[8],h1([0,1]),function(i1,t){"use strict";var m;Object.defineProperty(t,"__esModule",{value:!0}),t.SetWithKey=void 0,t.groupBy=e,t.diffSets=P,t.diffMaps=p,t.intersection=s1;function e(w,A){const M=Object.create(null);for(const B of w){const G=A(B);let r1=M[G];r1||(r1=M[G]=[]),r1.push(B)}return M}function P(w,A){const M=[],B=[];for(const G of w)A.has(G)||M.push(G);for(const G of A)w.has(G)||B.push(G);return{removed:M,added:B}}function p(w,A){const M=[],B=[];for(const[G,r1]of w)A.has(G)||M.push(r1);for(const[G,r1]of A)w.has(G)||B.push(r1);return{removed:M,added:B}}function s1(w,A){const M=new Set;for(const B of A)w.has(B)&&M.add(B);return M}class V{static{m=Symbol.toStringTag}constructor(A,M){this.toKey=M,this._map=new Map,this[m]="SetWithKey";for(const B of A)this.add(B)}get size(){return this._map.size}add(A){const M=this.toKey(A);return this._map.set(M,A),this}delete(A){return this._map.delete(this.toKey(A))}has(A){return this._map.has(this.toKey(A))}*entries(){for(const A of this._map.values())yield[A,A]}keys(){return this.values()}*values(){for(const A of this._map.values())yield A}clear(){this._map.clear()}forEach(A,M){this._map.forEach(B=>A.call(M,B,B,this))}[Symbol.iterator](){return this.values()}}t.SetWithKey=V}),define(f1[2],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=e,t.isSigPipeError=P,t.onUnexpectedError=p,t.onUnexpectedExternalError=s1,t.transformErrorForSerialization=V,t.transformErrorFromSerialization=w,t.isCancellationError=M,t.canceled=G,t.illegalArgument=r1,t.illegalState=_1,t.getErrorMessage=j;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?I.isErrorNoTelemetry(s)?new I(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(l=>{l(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}t.ErrorHandler=m,t.errorHandler=new m;function e(n){t.errorHandler.setUnexpectedErrorHandler(n)}function P(n){if(!n||typeof n!="object")return!1;const s=n;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}function p(n){M(n)||t.errorHandler.onUnexpectedError(n)}function s1(n){M(n)||t.errorHandler.onUnexpectedExternalError(n)}function V(n){if(n instanceof Error){const{name:s,message:l}=n,o=n.stacktrace||n.stack;return{$isError:!0,name:s,message:l,stack:o,noTelemetry:I.isErrorNoTelemetry(n)}}return n}function w(n){let s;return n.noTelemetry?s=new I:(s=new Error,s.name=n.name),s.message=n.message,s.stack=n.stack,s}const A="Canceled";function M(n){return n instanceof B?!0:n instanceof Error&&n.name===A&&n.message===A}class B extends Error{constructor(){super(A),this.name=this.message}}t.CancellationError=B;function G(){const n=new Error(A);return n.name=n.message,n}function r1(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function _1(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class W extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=W;function j(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class S extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}t.NotImplementedError=S;class h extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}t.NotSupportedError=h;class L extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=L;class I extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof I)return s;const l=new I;return l.message=s.message,l.stack=s.stack,l}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}t.ErrorNoTelemetry=I;class g extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}t.BugIndicatingError=g}),define(f1[9],h1([0,1,2,6]),function(i1,t,m,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=P,t.tail2=p,t.equals=s1,t.removeFastWithoutKeepingOrder=V,t.binarySearch=w,t.binarySearch2=A,t.quickSelect=M,t.groupBy=B,t.groupAdjacentBy=G,t.forEachAdjacent=r1,t.forEachWithNeighbors=_1,t.sortedDiff=W,t.delta=j,t.top=S,t.topAsync=h,t.coalesce=I,t.coalesceInPlace=g,t.move=n,t.isFalsyOrEmpty=s,t.isNonEmptyArray=l,t.distinct=o,t.uniqueFilter=U,t.firstOrDefault=O,t.lastOrDefault=Y,t.commonPrefixLength=d1,t.range=q,t.index=a1,t.insert=F,t.remove=a,t.arrayInsert=y,t.shuffle=H,t.pushToStart=D,t.pushToEnd=d,t.pushMany=N,t.mapArrayOrNot=Z,t.asArray=Q,t.getRandomElement=x,t.insertInto=t1,t.splice=X,t.compareBy=v1,t.tieBreakComparators=I1,t.reverseOrder=G1,t.findAsync=k1;function P(u,_=0){return u[u.length-(1+_)]}function p(u){if(u.length===0)throw new Error("Invalid tail call");return[u.slice(0,u.length-1),u[u.length-1]]}function s1(u,_,c=(E,v)=>E===v){if(u===_)return!0;if(!u||!_||u.length!==_.length)return!1;for(let E=0,v=u.length;E<v;E++)if(!c(u[E],_[E]))return!1;return!0}function V(u,_){const c=u.length-1;_<c&&(u[_]=u[c]),u.pop()}function w(u,_,c){return A(u.length,E=>c(u[E],_))}function A(u,_){let c=0,E=u-1;for(;c<=E;){const v=(c+E)/2|0,J=_(v);if(J<0)c=v+1;else if(J>0)E=v-1;else return v}return-(c+1)}function M(u,_,c){if(u=u|0,u>=_.length)throw new TypeError("invalid index");const E=_[Math.floor(_.length*Math.random())],v=[],J=[],u1=[];for(const m1 of _){const E1=c(m1,E);E1<0?v.push(m1):E1>0?J.push(m1):u1.push(m1)}return u<v.length?M(u,v,c):u<v.length+u1.length?u1[0]:M(u-(v.length+u1.length),J,c)}function B(u,_){const c=[];let E;for(const v of u.slice(0).sort(_))!E||_(E[0],v)!==0?(E=[v],c.push(E)):E.push(v);return c}function*G(u,_){let c,E;for(const v of u)E!==void 0&&_(E,v)?c.push(v):(c&&(yield c),c=[v]),E=v;c&&(yield c)}function r1(u,_){for(let c=0;c<=u.length;c++)_(c===0?void 0:u[c-1],c===u.length?void 0:u[c])}function _1(u,_){for(let c=0;c<u.length;c++)_(c===0?void 0:u[c-1],u[c],c+1===u.length?void 0:u[c+1])}function W(u,_,c){const E=[];function v(m1,E1,p1){if(E1===0&&p1.length===0)return;const T=E[E.length-1];T&&T.start+T.deleteCount===m1?(T.deleteCount+=E1,T.toInsert.push(...p1)):E.push({start:m1,deleteCount:E1,toInsert:p1})}let J=0,u1=0;for(;;){if(J===u.length){v(J,0,_.slice(u1));break}if(u1===_.length){v(J,u.length-J,[]);break}const m1=u[J],E1=_[u1],p1=c(m1,E1);p1===0?(J+=1,u1+=1):p1<0?(v(J,1,[]),J+=1):p1>0&&(v(J,0,[E1]),u1+=1)}return E}function j(u,_,c){const E=W(u,_,c),v=[],J=[];for(const u1 of E)v.push(...u.slice(u1.start,u1.start+u1.deleteCount)),J.push(...u1.toInsert);return{removed:v,added:J}}function S(u,_,c){if(c===0)return[];const E=u.slice(0,c).sort(_);return L(u,_,E,c,u.length),E}function h(u,_,c,E,v){return c===0?Promise.resolve([]):new Promise((J,u1)=>{(async()=>{const m1=u.length,E1=u.slice(0,c).sort(_);for(let p1=c,T=Math.min(c+E,m1);p1<m1;p1=T,T=Math.min(T+E,m1)){if(p1>c&&await new Promise(R=>setTimeout(R)),v&&v.isCancellationRequested)throw new m.CancellationError;L(u,_,E1,p1,T)}return E1})().then(J,u1)})}function L(u,_,c,E,v){for(const J=c.length;E<v;E++){const u1=u[E];if(_(u1,c[J-1])<0){c.pop();const m1=(0,e.findFirstIdxMonotonousOrArrLen)(c,E1=>_(u1,E1)<0);c.splice(m1,0,u1)}}}function I(u){return u.filter(_=>!!_)}function g(u){let _=0;for(let c=0;c<u.length;c++)u[c]&&(u[_]=u[c],_+=1);u.length=_}function n(u,_,c){u.splice(c,0,u.splice(_,1)[0])}function s(u){return!Array.isArray(u)||u.length===0}function l(u){return Array.isArray(u)&&u.length>0}function o(u,_=c=>c){const c=new Set;return u.filter(E=>{const v=_(E);return c.has(v)?!1:(c.add(v),!0)})}function U(u){const _=new Set;return c=>{const E=u(c);return _.has(E)?!1:(_.add(E),!0)}}function O(u,_){return u.length>0?u[0]:_}function Y(u,_){return u.length>0?u[u.length-1]:_}function d1(u,_,c=(E,v)=>E===v){let E=0;for(let v=0,J=Math.min(u.length,_.length);v<J&&c(u[v],_[v]);v++)E++;return E}function q(u,_){let c=typeof _=="number"?u:0;typeof _=="number"?c=u:(c=0,_=u);const E=[];if(c<=_)for(let v=c;v<_;v++)E.push(v);else for(let v=c;v>_;v--)E.push(v);return E}function a1(u,_,c){return u.reduce((E,v)=>(E[_(v)]=c?c(v):v,E),Object.create(null))}function F(u,_){return u.push(_),()=>a(u,_)}function a(u,_){const c=u.indexOf(_);if(c>-1)return u.splice(c,1),_}function y(u,_,c){const E=u.slice(0,_),v=u.slice(_);return E.concat(c,v)}function H(u,_){let c;if(typeof _=="number"){let E=_;c=()=>{const v=Math.sin(E++)*179426549;return v-Math.floor(v)}}else c=Math.random;for(let E=u.length-1;E>0;E-=1){const v=Math.floor(c()*(E+1)),J=u[E];u[E]=u[v],u[v]=J}}function D(u,_){const c=u.indexOf(_);c>-1&&(u.splice(c,1),u.unshift(_))}function d(u,_){const c=u.indexOf(_);c>-1&&(u.splice(c,1),u.push(_))}function N(u,_){for(const c of _)u.push(c)}function Z(u,_){return Array.isArray(u)?u.map(_):_(u)}function Q(u){return Array.isArray(u)?u:[u]}function x(u){return u[Math.floor(Math.random()*u.length)]}function t1(u,_,c){const E=C(u,_),v=u.length,J=c.length;u.length=v+J;for(let u1=v-1;u1>=E;u1--)u[u1+J]=u[u1];for(let u1=0;u1<J;u1++)u[u1+E]=c[u1]}function X(u,_,c,E){const v=C(u,_);let J=u.splice(v,c);return J===void 0&&(J=[]),t1(u,v,E),J}function C(u,_){return _<0?Math.max(_+u.length,0):Math.min(_,u.length)}var c1;(function(u){function _(J){return J<0}u.isLessThan=_;function c(J){return J<=0}u.isLessThanOrEqual=c;function E(J){return J>0}u.isGreaterThan=E;function v(J){return J===0}u.isNeitherLessOrGreaterThan=v,u.greaterThan=1,u.lessThan=-1,u.neitherLessOrGreaterThan=0})(c1||(t.CompareResult=c1={}));function v1(u,_){return(c,E)=>_(u(c),u(E))}function I1(...u){return(_,c)=>{for(const E of u){const v=E(_,c);if(!c1.isNeitherLessOrGreaterThan(v))return v}return c1.neitherLessOrGreaterThan}}const R1=(u,_)=>u-_;t.numberComparator=R1;const N1=(u,_)=>(0,t.numberComparator)(u?1:0,_?1:0);t.booleanComparator=N1;function G1(u){return(_,c)=>-u(_,c)}class q1{constructor(_){this.items=_,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(_){let c=this.firstIdx;for(;c<this.items.length&&_(this.items[c]);)c++;const E=c===this.firstIdx?null:this.items.slice(this.firstIdx,c);return this.firstIdx=c,E}takeFromEndWhile(_){let c=this.lastIdx;for(;c>=0&&_(this.items[c]);)c--;const E=c===this.lastIdx?null:this.items.slice(c+1,this.lastIdx+1);return this.lastIdx=c,E}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const _=this.items[this.firstIdx];return this.firstIdx++,_}removeLast(){const _=this.items[this.lastIdx];return this.lastIdx--,_}takeCount(_){const c=this.items.slice(this.firstIdx,this.firstIdx+_);return this.firstIdx+=_,c}}t.ArrayQueue=q1;class D1{static{this.empty=new D1(_=>{})}constructor(_){this.iterate=_}forEach(_){this.iterate(c=>(_(c),!0))}toArray(){const _=[];return this.iterate(c=>(_.push(c),!0)),_}filter(_){return new D1(c=>this.iterate(E=>_(E)?c(E):!0))}map(_){return new D1(c=>this.iterate(E=>c(_(E))))}some(_){let c=!1;return this.iterate(E=>(c=_(E),!c)),c}findFirst(_){let c;return this.iterate(E=>_(E)?(c=E,!1):!0),c}findLast(_){let c;return this.iterate(E=>(_(E)&&(c=E),!0)),c}findLastMaxBy(_){let c,E=!0;return this.iterate(v=>((E||c1.isGreaterThan(_(v,c)))&&(E=!1,c=v),!0)),c}}t.CallbackIterable=D1;class F1{constructor(_){this._indexMap=_}static createSortPermutation(_,c){const E=Array.from(_.keys()).sort((v,J)=>c(_[v],_[J]));return new F1(E)}apply(_){return _.map((c,E)=>_[this._indexMap[E]])}inverse(){const _=this._indexMap.slice();for(let c=0;c<this._indexMap.length;c++)_[this._indexMap[c]]=c;return new F1(_)}}t.Permutation=F1;async function k1(u,_){return(await Promise.all(u.map(async(E,v)=>({element:E,ok:await _(E,v)})))).find(E=>E.ok)?.element}}),define(f1[3],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=m;function m(e,P){const p=this;let s1=!1,V;return function(){if(s1)return V;if(s1=!0,P)try{V=e.apply(p,arguments)}finally{P()}else V=e.apply(p,arguments);return V}}}),define(f1[10],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var m;(function(e){function P(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}e.is=P;const p=Object.freeze([]);function s1(){return p}e.empty=s1;function*V(s){yield s}e.single=V;function w(s){return P(s)?s:V(s)}e.wrap=w;function A(s){return s||p}e.from=A;function*M(s){for(let l=s.length-1;l>=0;l--)yield s[l]}e.reverse=M;function B(s){return!s||s[Symbol.iterator]().next().done===!0}e.isEmpty=B;function G(s){return s[Symbol.iterator]().next().value}e.first=G;function r1(s,l){let o=0;for(const U of s)if(l(U,o++))return!0;return!1}e.some=r1;function _1(s,l){for(const o of s)if(l(o))return o}e.find=_1;function*W(s,l){for(const o of s)l(o)&&(yield o)}e.filter=W;function*j(s,l){let o=0;for(const U of s)yield l(U,o++)}e.map=j;function*S(s,l){let o=0;for(const U of s)yield*l(U,o++)}e.flatMap=S;function*h(...s){for(const l of s)yield*l}e.concat=h;function L(s,l,o){let U=o;for(const O of s)U=l(U,O);return U}e.reduce=L;function*I(s,l,o=s.length){for(l<0&&(l+=s.length),o<0?o+=s.length:o>s.length&&(o=s.length);l<o;l++)yield s[l]}e.slice=I;function g(s,l=Number.POSITIVE_INFINITY){const o=[];if(l===0)return[o,s];const U=s[Symbol.iterator]();for(let O=0;O<l;O++){const Y=U.next();if(Y.done)return[o,e.empty()];o.push(Y.value)}return[o,{[Symbol.iterator](){return U}}]}e.consume=g;async function n(s){const l=[];for await(const o of s)l.push(o);return Promise.resolve(l)}e.asyncToArray=n})(m||(t.Iterable=m={}))}),define(f1[11],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class m{constructor(P){this.executor=P,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=m}),define(f1[12],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class m{static{this.Undefined=new m(void 0)}constructor(p){this.element=p,this.next=m.Undefined,this.prev=m.Undefined}}class e{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let p=this._first;for(;p!==m.Undefined;){const s1=p.next;p.prev=m.Undefined,p.next=m.Undefined,p=s1}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(p){return this._insert(p,!1)}push(p){return this._insert(p,!0)}_insert(p,s1){const V=new m(p);if(this._first===m.Undefined)this._first=V,this._last=V;else if(s1){const A=this._last;this._last=V,V.prev=A,A.next=V}else{const A=this._first;this._first=V,V.next=A,A.prev=V}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(V))}}shift(){if(this._first!==m.Undefined){const p=this._first.element;return this._remove(this._first),p}}pop(){if(this._last!==m.Undefined){const p=this._last.element;return this._remove(this._last),p}}_remove(p){if(p.prev!==m.Undefined&&p.next!==m.Undefined){const s1=p.prev;s1.next=p.next,p.next.prev=s1}else p.prev===m.Undefined&&p.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):p.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):p.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let p=this._first;for(;p!==m.Undefined;)yield p.element,p=p.next}}t.LinkedList=e}),define(f1[13],h1([0,1]),function(i1,t){"use strict";var m,e,P;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.MRUCache=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=p,t.mapToString=s1,t.setToString=V,t.mapsStrictEqualIgnoreOrder=I;function p(g,n,s){let l=g.get(n);return l===void 0&&(l=s,g.set(n,l)),l}function s1(g){const n=[];return g.forEach((s,l)=>{n.push(`${l} => ${s}`)}),`Map(${g.size}) {${n.join(", ")}}`}function V(g){const n=[];return g.forEach(s=>{n.push(s)}),`Set(${g.size}) {${n.join(", ")}}`}class w{constructor(n,s){this.uri=n,this.value=s}}function A(g){return Array.isArray(g)}class M{static{this.defaultToKey=n=>n.toString()}constructor(n,s){if(this[m]="ResourceMap",n instanceof M)this.map=new Map(n.map),this.toKey=s??M.defaultToKey;else if(A(n)){this.map=new Map,this.toKey=s??M.defaultToKey;for(const[l,o]of n)this.set(l,o)}else this.map=new Map,this.toKey=n??M.defaultToKey}set(n,s){return this.map.set(this.toKey(n),new w(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[l,o]of this.map)n(o.value,o.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(m=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}t.ResourceMap=M;class B{constructor(n,s){this[e]="ResourceSet",!n||typeof n=="function"?this._map=new M(n):(this._map=new M(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((l,o)=>n.call(s,o,o,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(e=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=B;var G;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(G||(t.Touch=G={}));class r1{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=G.None){const l=this._map.get(n);if(l)return s!==G.None&&this.touch(l,s),l.value}set(n,s,l=G.None){let o=this._map.get(n);if(o)o.value=s,l!==G.None&&this.touch(o,l);else{switch(o={key:n,value:s,next:void 0,previous:void 0},l){case G.None:this.addItemLast(o);break;case G.AsOld:this.addItemFirst(o);break;case G.AsNew:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const l=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let l=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const U={value:l.key,done:!1};return l=l.next,U}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let l=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const U={value:l.value,done:!1};return l=l.next,U}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let l=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const U={value:[l.key,l.value],done:!1};return l=l.next,U}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>n;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}trimNew(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._tail,l=this.size;for(;s&&l>n;)this._map.delete(s.key),s=s.previous,l--;this._tail=s,this._size=l,s&&(s.next=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,l=n.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==G.AsOld&&s!==G.AsNew)){if(s===G.AsOld){if(n===this._head)return;const l=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(l.previous=o,o.next=l),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===G.AsNew){if(n===this._tail)return;const l=n.next,o=n.previous;n===this._head?(l.previous=void 0,this._head=l):(l.previous=o,o.next=l),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,l)=>{n.push([l,s])}),n}fromJSON(n){this.clear();for(const[s,l]of n)this.set(s,l)}}t.LinkedMap=r1;class _1 extends r1{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=G.AsNew){return super.get(n,s)}peek(n){return super.get(n,G.None)}set(n,s){return super.set(n,s,G.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class W extends _1{constructor(n,s=1){super(n,s)}trim(n){this.trimOld(n)}set(n,s){return super.set(n,s),this.checkTrim(),this}}t.LRUCache=W;class j extends _1{constructor(n,s=1){super(n,s)}trim(n){this.trimNew(n)}set(n,s){return this._limit<=this.size&&!this.has(n)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(n,s),this}}t.MRUCache=j;class S{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let s=this.map.get(n)||0;return s===0?!1:(s--,s===0?this.map.delete(n):this.map.set(n,s),!0)}has(n){return this.map.has(n)}}t.CounterSet=S;class h{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[s,l]of n)this.set(s,l)}clear(){this._m1.clear(),this._m2.clear()}set(n,s){this._m1.set(n,s),this._m2.set(s,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const s=this._m1.get(n);return s===void 0?!1:(this._m1.delete(n),this._m2.delete(s),!0)}forEach(n,s){this._m1.forEach((l,o)=>{n.call(s,l,o,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=h;class L{constructor(){this.map=new Map}add(n,s){let l=this.map.get(n);l||(l=new Set,this.map.set(n,l)),l.add(s)}delete(n,s){const l=this.map.get(n);l&&(l.delete(s),l.size===0&&this.map.delete(n))}forEach(n,s){const l=this.map.get(n);l&&l.forEach(s)}get(n){const s=this.map.get(n);return s||new Set}}t.SetMap=L;function I(g,n){if(g===n)return!0;if(g.size!==n.size)return!1;for(const[s,l]of g)if(!n.has(s)||n.get(s)!==l)return!1;for(const[s]of n)if(!g.has(s))return!1;return!0}}),define(f1[4],h1([0,1,9,8,13,3,10]),function(i1,t,m,e,P,p,s1){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=M,t.trackDisposable=B,t.markAsDisposed=G,t.markAsSingleton=W,t.isDisposable=j,t.dispose=S,t.disposeIfDisposable=h,t.combinedDisposable=L,t.toDisposable=I,t.disposeOnReturn=q;const V=!1;let w=null;class A{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(a){let y=this.livingDisposables.get(a);return y||(y={parent:null,source:null,isSingleton:!1,value:a,idx:A.idx++},this.livingDisposables.set(a,y)),y}trackDisposable(a){const y=this.getDisposableData(a);y.source||(y.source=new Error().stack)}setParent(a,y){const H=this.getDisposableData(a);H.parent=y}markAsDisposed(a){this.livingDisposables.delete(a)}markAsSingleton(a){this.getDisposableData(a).isSingleton=!0}getRootParent(a,y){const H=y.get(a);if(H)return H;const D=a.parent?this.getRootParent(this.getDisposableData(a.parent),y):a;return y.set(a,D),D}getTrackedDisposables(){const a=new Map;return[...this.livingDisposables.entries()].filter(([,H])=>H.source!==null&&!this.getRootParent(H,a).isSingleton).flatMap(([H])=>H)}computeLeakingDisposables(a=10,y){let H;if(y)H=y;else{const Q=new Map,x=[...this.livingDisposables.values()].filter(X=>X.source!==null&&!this.getRootParent(X,Q).isSingleton);if(x.length===0)return;const t1=new Set(x.map(X=>X.value));if(H=x.filter(X=>!(X.parent&&t1.has(X.parent))),H.length===0)throw new Error("There are cyclic diposable chains!")}if(!H)return;function D(Q){function x(X,C){for(;X.length>0&&C.some(c1=>typeof c1=="string"?c1===X[0]:X[0].match(c1));)X.shift()}const t1=Q.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return x(t1,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),t1.reverse()}const d=new P.SetMap;for(const Q of H){const x=D(Q);for(let t1=0;t1<=x.length;t1++)d.add(x.slice(0,t1).join(`
`),Q)}H.sort((0,m.compareBy)(Q=>Q.idx,m.numberComparator));let N="",Z=0;for(const Q of H.slice(0,a)){Z++;const x=D(Q),t1=[];for(let X=0;X<x.length;X++){let C=x[X];C=`(shared with ${d.get(x.slice(0,X+1).join(`
`)).size}/${H.length} leaks) at ${C}`;const v1=d.get(x.slice(0,X).join(`
`)),I1=(0,e.groupBy)([...v1].map(R1=>D(R1)[X]),R1=>R1);delete I1[x[X]];for(const[R1,N1]of Object.entries(I1))t1.unshift(`    - stacktraces of ${N1.length} other leaks continue with ${R1}`);t1.unshift(C)}N+=`


==================== Leaking disposable ${Z}/${H.length}: ${Q.value.constructor.name} ====================
${t1.join(`
`)}
============================================================

`}return H.length>a&&(N+=`


... and ${H.length-a} more leaking disposables

`),{leaks:H,details:N}}}t.DisposableTracker=A;function M(F){w=F}if(V){const F="__is_disposable_tracked__";M(new class{trackDisposable(a){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[F]||console.log(y)},3e3)}setParent(a,y){if(a&&a!==n.None)try{a[F]=!0}catch{}}markAsDisposed(a){if(a&&a!==n.None)try{a[F]=!0}catch{}}markAsSingleton(a){}})}function B(F){return w?.trackDisposable(F),F}function G(F){w?.markAsDisposed(F)}function r1(F,a){w?.setParent(F,a)}function _1(F,a){if(w)for(const y of F)w.setParent(y,a)}function W(F){return w?.markAsSingleton(F),F}function j(F){return typeof F=="object"&&F!==null&&typeof F.dispose=="function"&&F.dispose.length===0}function S(F){if(s1.Iterable.is(F)){const a=[];for(const y of F)if(y)try{y.dispose()}catch(H){a.push(H)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(F)?[]:F}else if(F)return F.dispose(),F}function h(F){for(const a of F)j(a)&&a.dispose();return[]}function L(...F){const a=I(()=>S(F));return _1(F,a),a}function I(F){const a=B({dispose:(0,p.createSingleCallFunction)(()=>{G(a),F()})});return a}class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,B(this)}dispose(){this._isDisposed||(G(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{S(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return r1(a,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}delete(a){if(a){if(a===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(a),a.dispose()}}deleteAndLeak(a){a&&this._toDispose.has(a)&&(this._toDispose.delete(a),r1(a,null))}}t.DisposableStore=g;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new g,B(this),r1(this._store,this)}dispose(){G(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}t.Disposable=n;class s{constructor(){this._isDisposed=!1,B(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&r1(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,G(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&r1(a,null),a}}t.MutableDisposable=s;class l{constructor(a){this._disposable=new s,this._isDisposed=!1,this._disposable.value=a}get value(){return this._disposable.value}set value(a){this._isDisposed||a===this._disposable.value||(this._disposable.value=a)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=l;class o{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=o;class U{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,B(this)}set(a){let y=a;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,G(this))},this}}t.SafeDisposable=U;class O{constructor(){this.references=new Map}acquire(a,...y){let H=this.references.get(a);H||(H={counter:0,object:this.createReferencedObject(a,...y)},this.references.set(a,H));const{object:D}=H,d=(0,p.createSingleCallFunction)(()=>{--H.counter===0&&(this.destroyReferencedObject(a,H.object),this.references.delete(a))});return H.counter++,{object:D,dispose:d}}}t.ReferenceCollection=O;class Y{constructor(a){this.referenceCollection=a}async acquire(a,...y){const H=this.referenceCollection.acquire(a,...y);try{return{object:await H.object,dispose:()=>H.dispose()}}catch(D){throw H.dispose(),D}}}t.AsyncReferenceCollection=Y;class d1{constructor(a){this.object=a}dispose(){}}t.ImmortalReference=d1;function q(F){const a=new g;try{F(a)}finally{a.dispose()}}class a1{constructor(){this._store=new Map,this._isDisposed=!1,B(this)}dispose(){G(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{S(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get size(){return this._store.size}get(a){return this._store.get(a)}set(a,y,H=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),H||this._store.get(a)?.dispose(),this._store.set(a,y)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}deleteAndLeak(a){const y=this._store.get(a);return this._store.delete(a),y}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=a1}),define(f1[14],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=n,t.isLittleEndian=Y,t.isBigSurOrNewer=d1,t.LANGUAGE_DEFAULT="en";let m=!1,e=!1,P=!1,p=!1,s1=!1,V=!1,w=!1,A=!1,M=!1,B=!1,G,r1=t.LANGUAGE_DEFAULT,_1=t.LANGUAGE_DEFAULT,W,j;const S=globalThis;let h;typeof S.vscode<"u"&&typeof S.vscode.process<"u"?h=S.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(h=process);const L=typeof h?.versions?.electron=="string",I=L&&h?.type==="renderer";if(typeof h=="object"){m=h.platform==="win32",e=h.platform==="darwin",P=h.platform==="linux",p=P&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,w=L,M=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,G=t.LANGUAGE_DEFAULT,r1=t.LANGUAGE_DEFAULT;const q=h.env.VSCODE_NLS_CONFIG;if(q)try{const a1=JSON.parse(q);G=a1.userLocale,_1=a1.osLocale,r1=a1.resolvedLanguage||t.LANGUAGE_DEFAULT,W=a1.languagePack?.translationsConfigFile}catch{}s1=!0}else typeof navigator=="object"&&!I?(j=navigator.userAgent,m=j.indexOf("Windows")>=0,e=j.indexOf("Macintosh")>=0,A=(j.indexOf("Macintosh")>=0||j.indexOf("iPad")>=0||j.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=j.indexOf("Linux")>=0,B=j?.indexOf("Mobi")>=0,V=!0,r1=globalThis._VSCODE_NLS_LANGUAGE||t.LANGUAGE_DEFAULT,G=navigator.language.toLowerCase(),_1=G):console.error("Unable to resolve platform.");var g;(function(q){q[q.Web=0]="Web",q[q.Mac=1]="Mac",q[q.Linux=2]="Linux",q[q.Windows=3]="Windows"})(g||(t.Platform=g={}));function n(q){switch(q){case g.Web:return"Web";case g.Mac:return"Mac";case g.Linux:return"Linux";case g.Windows:return"Windows"}}let s=g.Web;e?s=g.Mac:m?s=g.Windows:P&&(s=g.Linux),t.isWindows=m,t.isMacintosh=e,t.isLinux=P,t.isLinuxSnap=p,t.isNative=s1,t.isElectron=w,t.isWeb=V,t.isWebWorker=V&&typeof S.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?S.origin:void 0,t.isIOS=A,t.isMobile=B,t.isCI=M,t.platform=s,t.userAgent=j,t.language=r1;var l;(function(q){function a1(){return t.language}q.value=a1;function F(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}q.isDefaultVariant=F;function a(){return t.language==="en"}q.isDefault=a})(l||(t.Language=l={})),t.locale=G,t.platformLocale=_1,t.translationsConfigFile=W,t.setTimeout0IsFaster=typeof S.postMessage=="function"&&!S.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const q=[];S.addEventListener("message",F=>{if(F.data&&F.data.vscodeScheduleAsyncWork)for(let a=0,y=q.length;a<y;a++){const H=q[a];if(H.id===F.data.vscodeScheduleAsyncWork){q.splice(a,1),H.callback();return}}});let a1=0;return F=>{const a=++a1;q.push({id:a,callback:F}),S.postMessage({vscodeScheduleAsyncWork:a},"*")}}return q=>setTimeout(q)})();var o;(function(q){q[q.Windows=1]="Windows",q[q.Macintosh=2]="Macintosh",q[q.Linux=3]="Linux"})(o||(t.OperatingSystem=o={})),t.OS=e||A?o.Macintosh:m?o.Windows:o.Linux;let U=!0,O=!1;function Y(){if(!O){O=!0;const q=new Uint8Array(2);q[0]=1,q[1]=2,U=new Uint16Array(q.buffer)[0]===513}return U}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function d1(q){return parseFloat(q)>=20}}),define(f1[15],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const m=globalThis.performance&&typeof globalThis.performance.now=="function";class e{static create(p){return new e(p)}constructor(p){this._now=m&&p===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=e}),define(f1[5],h1([0,1,2,3,4,12,15]),function(i1,t,m,e,P,p,s1){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEvent=t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.ListenerRefusalError=t.ListenerLeakError=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=r1;const V=!1,w=!1,A=!1;var M;(function(D){D.None=()=>P.Disposable.None;function d(T){if(A){const{onDidAddListener:R}=T,K=W.create();let k=0;T.onDidAddListener=()=>{++k===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),R?.()}}}function N(T,R){return R1(T,()=>{},0,void 0,!0,void 0,R)}D.defer=N;function Z(T){return(R,K=null,k)=>{let $=!1,n1;return n1=T(l1=>{if(!$)return n1?n1.dispose():$=!0,R.call(K,l1)},null,k),$&&n1.dispose(),n1}}D.once=Z;function Q(T,R,K){return v1((k,$=null,n1)=>T(l1=>k.call($,R(l1)),null,n1),K)}D.map=Q;function x(T,R,K){return v1((k,$=null,n1)=>T(l1=>{R(l1),k.call($,l1)},null,n1),K)}D.forEach=x;function t1(T,R,K){return v1((k,$=null,n1)=>T(l1=>R(l1)&&k.call($,l1),null,n1),K)}D.filter=t1;function X(T){return T}D.signal=X;function C(...T){return(R,K=null,k)=>{const $=(0,P.combinedDisposable)(...T.map(n1=>n1(l1=>R.call(K,l1))));return I1($,k)}}D.any=C;function c1(T,R,K,k){let $=K;return Q(T,n1=>($=R($,n1),$),k)}D.reduce=c1;function v1(T,R){let K;const k={onWillAddFirstListener(){K=T($.fire,$)},onDidRemoveLastListener(){K?.dispose()}};R||d(k);const $=new s(k);return R?.add($),$.event}function I1(T,R){return R instanceof Array?R.push(T):R&&R.add(T),T}function R1(T,R,K=100,k=!1,$=!1,n1,l1){let g1,b1,M1,e1=0,U1;const K1={leakWarningThreshold:n1,onWillAddFirstListener(){g1=T(j1=>{e1++,b1=R(b1,j1),k&&!M1&&(P1.fire(b1),b1=void 0),U1=()=>{const V1=b1;b1=void 0,M1=void 0,(!k||e1>1)&&P1.fire(V1),e1=0},typeof K=="number"?(clearTimeout(M1),M1=setTimeout(U1,K)):M1===void 0&&(M1=0,queueMicrotask(U1))})},onWillRemoveListener(){$&&e1>0&&U1?.()},onDidRemoveLastListener(){U1=void 0,g1.dispose()}};l1||d(K1);const P1=new s(K1);return l1?.add(P1),P1.event}D.debounce=R1;function N1(T,R=0,K){return D.debounce(T,(k,$)=>k?(k.push($),k):[$],R,void 0,!0,void 0,K)}D.accumulate=N1;function G1(T,R=(k,$)=>k===$,K){let k=!0,$;return t1(T,n1=>{const l1=k||!R(n1,$);return k=!1,$=n1,l1},K)}D.latch=G1;function q1(T,R,K){return[D.filter(T,R,K),D.filter(T,k=>!R(k),K)]}D.split=q1;function D1(T,R=!1,K=[],k){let $=K.slice(),n1=T(b1=>{$?$.push(b1):g1.fire(b1)});k&&k.add(n1);const l1=()=>{$?.forEach(b1=>g1.fire(b1)),$=null},g1=new s({onWillAddFirstListener(){n1||(n1=T(b1=>g1.fire(b1)),k&&k.add(n1))},onDidAddFirstListener(){$&&(R?setTimeout(l1):l1())},onDidRemoveLastListener(){n1&&n1.dispose(),n1=null}});return k&&k.add(g1),g1.event}D.buffer=D1;function F1(T,R){return(k,$,n1)=>{const l1=R(new u);return T(function(g1){const b1=l1.evaluate(g1);b1!==k1&&k.call($,b1)},void 0,n1)}}D.chain=F1;const k1=Symbol("HaltChainable");class u{constructor(){this.steps=[]}map(R){return this.steps.push(R),this}forEach(R){return this.steps.push(K=>(R(K),K)),this}filter(R){return this.steps.push(K=>R(K)?K:k1),this}reduce(R,K){let k=K;return this.steps.push($=>(k=R(k,$),k)),this}latch(R=(K,k)=>K===k){let K=!0,k;return this.steps.push($=>{const n1=K||!R($,k);return K=!1,k=$,n1?$:k1}),this}evaluate(R){for(const K of this.steps)if(R=K(R),R===k1)break;return R}}function _(T,R,K=k=>k){const k=(...g1)=>l1.fire(K(...g1)),$=()=>T.on(R,k),n1=()=>T.removeListener(R,k),l1=new s({onWillAddFirstListener:$,onDidRemoveLastListener:n1});return l1.event}D.fromNodeEventEmitter=_;function c(T,R,K=k=>k){const k=(...g1)=>l1.fire(K(...g1)),$=()=>T.addEventListener(R,k),n1=()=>T.removeEventListener(R,k),l1=new s({onWillAddFirstListener:$,onDidRemoveLastListener:n1});return l1.event}D.fromDOMEventEmitter=c;function E(T){return new Promise(R=>Z(T)(R))}D.toPromise=E;function v(T){const R=new s;return T.then(K=>{R.fire(K)},()=>{R.fire(void 0)}).finally(()=>{R.dispose()}),R.event}D.fromPromise=v;function J(T,R){return T(K=>R.fire(K))}D.forward=J;function u1(T,R,K){return R(K),T(k=>R(k))}D.runAndSubscribe=u1;class m1{constructor(R,K){this._observable=R,this._counter=0,this._hasChanged=!1;const k={onWillAddFirstListener:()=>{R.addObserver(this)},onDidRemoveLastListener:()=>{R.removeObserver(this)}};K||d(k),this.emitter=new s(k),K&&K.add(this.emitter)}beginUpdate(R){this._counter++}handlePossibleChange(R){}handleChange(R,K){this._hasChanged=!0}endUpdate(R){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function E1(T,R){return new m1(T,R).emitter.event}D.fromObservable=E1;function p1(T){return(R,K,k)=>{let $=0,n1=!1;const l1={beginUpdate(){$++},endUpdate(){$--,$===0&&(T.reportChanges(),n1&&(n1=!1,R.call(K)))},handlePossibleChange(){},handleChange(){n1=!0}};T.addObserver(l1),T.reportChanges();const g1={dispose(){T.removeObserver(l1)}};return k instanceof P.DisposableStore?k.add(g1):Array.isArray(k)&&k.push(g1),g1}}D.fromObservableLight=p1})(M||(t.Event=M={}));class B{static{this.all=new Set}static{this._idPool=0}constructor(d){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${d}_${B._idPool++}`,B.all.add(this)}start(d){this._stopWatch=new s1.StopWatch,this.listenerCount=d}stop(){if(this._stopWatch){const d=this._stopWatch.elapsed();this.durations.push(d),this.elapsedOverall+=d,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=B;let G=-1;function r1(D){const d=G;return G=D,{dispose(){G=d}}}class _1{static{this._idPool=1}constructor(d,N,Z=(_1._idPool++).toString(16).padStart(3,"0")){this._errorHandler=d,this.threshold=N,this.name=Z,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(d,N){const Z=this.threshold;if(Z<=0||N<Z)return;this._stacks||(this._stacks=new Map);const Q=this._stacks.get(d.value)||0;if(this._stacks.set(d.value,Q+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=Z*.5;const[x,t1]=this.getMostFrequentStack(),X=`[${this.name}] potential listener LEAK detected, having ${N} listeners already. MOST frequent listener (${t1}):`;console.warn(X),console.warn(x);const C=new j(X,x);this._errorHandler(C)}return()=>{const x=this._stacks.get(d.value)||0;this._stacks.set(d.value,x-1)}}getMostFrequentStack(){if(!this._stacks)return;let d,N=0;for(const[Z,Q]of this._stacks)(!d||N<Q)&&(d=[Z,Q],N=Q);return d}}class W{static create(){const d=new Error;return new W(d.stack??"")}constructor(d){this.value=d}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class j extends Error{constructor(d,N){super(d),this.name="ListenerLeakError",this.stack=N}}t.ListenerLeakError=j;class S extends Error{constructor(d,N){super(d),this.name="ListenerRefusalError",this.stack=N}}t.ListenerRefusalError=S;let h=0;class L{constructor(d){this.value=d,this.id=h++}}const I=2,g=(D,d)=>{if(D instanceof L)d(D);else for(let N=0;N<D.length;N++){const Z=D[N];Z&&d(Z)}};let n;if(V){const D=[];setInterval(()=>{D.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(D.join(`
`)),D.length=0)},3e3),n=new FinalizationRegistry(d=>{typeof d=="string"&&D.push(d)})}class s{constructor(d){this._size=0,this._options=d,this._leakageMon=G>0||this._options?.leakWarningThreshold?new _1(d?.onListenerError??m.onUnexpectedError,this._options?.leakWarningThreshold??G):void 0,this._perfMon=this._options?._profName?new B(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(w){const d=this._listeners;queueMicrotask(()=>{g(d,N=>N.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(d,N,Z)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const C=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(C);const c1=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],v1=new S(`${C}. HINT: Stack shows most frequent listener (${c1[1]}-times)`,c1[0]);return(this._options?.onListenerError||m.onUnexpectedError)(v1),P.Disposable.None}if(this._disposed)return P.Disposable.None;N&&(d=d.bind(N));const Q=new L(d);let x,t1;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(Q.stack=W.create(),x=this._leakageMon.check(Q.stack,this._size+1)),w&&(Q.stack=t1??W.create()),this._listeners?this._listeners instanceof L?(this._deliveryQueue??=new o,this._listeners=[this._listeners,Q]):this._listeners.push(Q):(this._options?.onWillAddFirstListener?.(this),this._listeners=Q,this._options?.onDidAddFirstListener?.(this)),this._size++;const X=(0,P.toDisposable)(()=>{n?.unregister(X),x?.(),this._removeListener(Q)});if(Z instanceof P.DisposableStore?Z.add(X):Array.isArray(Z)&&Z.push(X),n){const C=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),c1=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(C);n.register(X,c1?.[2]??C,X)}return X},this._event}_removeListener(d){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const N=this._listeners,Z=N.indexOf(d);if(Z===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,N[Z]=void 0;const Q=this._deliveryQueue.current===this;if(this._size*I<=N.length){let x=0;for(let t1=0;t1<N.length;t1++)N[t1]?N[x++]=N[t1]:Q&&(this._deliveryQueue.end--,x<this._deliveryQueue.i&&this._deliveryQueue.i--);N.length=x}}_deliver(d,N){if(!d)return;const Z=this._options?.onListenerError||m.onUnexpectedError;if(!Z){d.value(N);return}try{d.value(N)}catch(Q){Z(Q)}}_deliverQueue(d){const N=d.current._listeners;for(;d.i<d.end;)this._deliver(N[d.i++],d.value);d.reset()}fire(d){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof L)this._deliver(this._listeners,d);else{const N=this._deliveryQueue;N.enqueue(this,d,this._listeners.length),this._deliverQueue(N)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=s;const l=()=>new o;t.createEventDeliveryQueue=l;class o{constructor(){this.i=-1,this.end=0}enqueue(d,N,Z){this.i=0,this.end=Z,this.current=d,this.value=N}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class U extends s{async fireAsync(d,N,Z){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new p.LinkedList),g(this._listeners,Q=>this._asyncDeliveryQueue.push([Q.value,d]));this._asyncDeliveryQueue.size>0&&!N.isCancellationRequested;){const[Q,x]=this._asyncDeliveryQueue.shift(),t1=[],X={...x,token:N,waitUntil:C=>{if(Object.isFrozen(t1))throw new Error("waitUntil can NOT be called asynchronous");Z&&(C=Z(C,Q)),t1.push(C)}};try{Q(X)}catch(C){(0,m.onUnexpectedError)(C);continue}Object.freeze(t1),await Promise.allSettled(t1).then(C=>{for(const c1 of C)c1.status==="rejected"&&(0,m.onUnexpectedError)(c1.reason)})}}}t.AsyncEmitter=U;class O extends s{get isPaused(){return this._isPaused!==0}constructor(d){super(d),this._isPaused=0,this._eventQueue=new p.LinkedList,this._mergeFn=d?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const d=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(d))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(d){this._size&&(this._isPaused!==0?this._eventQueue.push(d):super.fire(d))}}t.PauseableEmitter=O;class Y extends O{constructor(d){super(d),this._delay=d.delay??100}fire(d){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(d)}}t.DebounceEmitter=Y;class d1 extends s{constructor(d){super(d),this._queuedEvents=[],this._mergeFn=d?.merge}fire(d){this.hasListeners()&&(this._queuedEvents.push(d),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(N=>super.fire(N)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=d1;class q{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new s({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(d){const N={event:d,listener:null};this.events.push(N),this.hasListeners&&this.hook(N);const Z=()=>{this.hasListeners&&this.unhook(N);const Q=this.events.indexOf(N);this.events.splice(Q,1)};return(0,P.toDisposable)((0,e.createSingleCallFunction)(Z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(d=>this.hook(d))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(d=>this.unhook(d))}hook(d){d.listener=d.event(N=>this.emitter.fire(N))}unhook(d){d.listener?.dispose(),d.listener=null}dispose(){this.emitter.dispose();for(const d of this.events)d.listener?.dispose();this.events=[]}}t.EventMultiplexer=q;class a1{constructor(d,N,Z,Q){this._store=new P.DisposableStore;const x=this._store.add(new q),t1=this._store.add(new P.DisposableMap);function X(C){t1.set(C,x.add(Q(C)))}for(const C of d)X(C);this._store.add(N(C=>{X(C)})),this._store.add(Z(C=>{t1.deleteAndDispose(C)})),this.event=x.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=a1;class F{constructor(){this.data=[]}wrapEvent(d,N,Z){return(Q,x,t1)=>d(X=>{const C=this.data[this.data.length-1];if(!N){C?C.buffers.push(()=>Q.call(x,X)):Q.call(x,X);return}const c1=C;if(!c1){Q.call(x,N(Z,X));return}c1.items??=[],c1.items.push(X),c1.buffers.length===0&&C.buffers.push(()=>{c1.reducedResult??=Z?c1.items.reduce(N,Z):c1.items.reduce(N),Q.call(x,c1.reducedResult)})},void 0,t1)}bufferEvents(d){const N={buffers:new Array};this.data.push(N);const Z=d();return this.data.pop(),N.buffers.forEach(Q=>Q()),Z}}t.EventBufferer=F;class a{constructor(){this.listening=!1,this.inputEvent=M.None,this.inputEventListener=P.Disposable.None,this.emitter=new s({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(d){this.inputEvent=d,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=d(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=a;class y{static const(d){return new H(d)}constructor(d){this._value=d,this._onDidChange=new s,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(d){d!==this._value&&(this._value=d,this._onDidChange.fire(void 0))}}t.ValueWithChangeEvent=y;class H{constructor(d){this.value=d,this.onDidChange=M.None}}}),define(f1[16],h1([0,1,5]),function(i1,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0,t.cancelOnDispose=V;const e=Object.freeze(function(w,A){const M=setTimeout(w.bind(A),0);return{dispose(){clearTimeout(M)}}});var P;(function(w){function A(M){return M===w.None||M===w.Cancelled||M instanceof p?!0:!M||typeof M!="object"?!1:typeof M.isCancellationRequested=="boolean"&&typeof M.onCancellationRequested=="function"}w.isCancellationToken=A,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(P||(t.CancellationToken=P={}));class p{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?e:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class s1{constructor(A){this._token=void 0,this._parentListener=void 0,this._parentListener=A&&A.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new p),this._token}cancel(){this._token?this._token instanceof p&&this._token.cancel():this._token=P.Cancelled}dispose(A=!1){A&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof p&&this._token.dispose():this._token=P.None}}t.CancellationTokenSource=s1;function V(w){const A=new s1;return w.add({dispose(){A.cancel()}}),A.token}}),define(f1[17],h1([0,1,16]),function(i1,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0,t.identity=P;class e{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new m.CancellationTokenSource,A=this.task(w.token);return this.result={promise:A,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}t.Cache=e;function P(V){return V}class p{constructor(w,A){this.lastCache=void 0,this.lastArgKey=void 0,typeof w=="function"?(this._fn=w,this._computeKey=P):(this._fn=A,this._computeKey=w.getCacheKey)}get(w){const A=this._computeKey(w);return this.lastArgKey!==A&&(this.lastArgKey=A,this.lastCache=this._fn(w)),this.lastCache}}t.LRUCachedFunction=p;class s1{get cachedValues(){return this._map}constructor(w,A){this._map=new Map,this._map2=new Map,typeof w=="function"?(this._fn=w,this._computeKey=P):(this._fn=A,this._computeKey=w.getCacheKey)}get(w){const A=this._computeKey(w);if(this._map2.has(A))return this._map2.get(A);const M=this._fn(w);return this._map.set(w,M),this._map2.set(A,M),M}}t.CachedFunction=s1}),define(f1[18],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=m,t.isStringArray=e,t.isObject=P,t.isTypedArray=p,t.isNumber=s1,t.isIterable=V,t.isBoolean=w,t.isUndefined=A,t.isDefined=M,t.isUndefinedOrNull=B,t.assertType=G,t.assertIsDefined=r1,t.assertAllDefined=_1,t.isEmptyObject=j,t.isFunction=S,t.areFunctions=h,t.validateConstraints=L,t.validateConstraint=I,t.upcast=g;function m(n){return typeof n=="string"}function e(n){return Array.isArray(n)&&n.every(s=>m(s))}function P(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}function p(n){const s=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof s}function s1(n){return typeof n=="number"&&!isNaN(n)}function V(n){return!!n&&typeof n[Symbol.iterator]=="function"}function w(n){return n===!0||n===!1}function A(n){return typeof n>"u"}function M(n){return!B(n)}function B(n){return A(n)||n===null}function G(n,s){if(!n)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}function r1(n){if(B(n))throw new Error("Assertion Failed: argument is undefined or null");return n}function _1(...n){const s=[];for(let l=0;l<n.length;l++){const o=n[l];if(B(o))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);s.push(o)}return s}const W=Object.prototype.hasOwnProperty;function j(n){if(!P(n))return!1;for(const s in n)if(W.call(n,s))return!1;return!0}function S(n){return typeof n=="function"}function h(...n){return n.length>0&&n.every(S)}function L(n,s){const l=Math.min(n.length,s.length);for(let o=0;o<l;o++)I(n[o],s[o])}function I(n,s){if(m(s)){if(typeof n!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(S(s)){try{if(n instanceof s)return}catch{}if(!B(n)&&n.constructor===s||s.length===1&&s.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function g(n){return n}}),define(f1[19],h1([0,1,18]),function(i1,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=e,t.deepFreeze=P,t.cloneAndChange=s1,t.mixin=w,t.equals=A,t.safeStringify=M,t.distinct=B,t.getCaseInsensitive=G,t.filter=r1,t.getAllPropertyNames=_1,t.getAllMethodNames=W,t.createProxyObject=j,t.mapValues=S;function e(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const L=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([I,g])=>{L[I]=g&&typeof g=="object"?e(g):g}),L}function P(h){if(!h||typeof h!="object")return h;const L=[h];for(;L.length>0;){const I=L.shift();Object.freeze(I);for(const g in I)if(p.call(I,g)){const n=I[g];typeof n=="object"&&!Object.isFrozen(n)&&!(0,m.isTypedArray)(n)&&L.push(n)}}return h}const p=Object.prototype.hasOwnProperty;function s1(h,L){return V(h,L,new Set)}function V(h,L,I){if((0,m.isUndefinedOrNull)(h))return h;const g=L(h);if(typeof g<"u")return g;if(Array.isArray(h)){const n=[];for(const s of h)n.push(V(s,L,I));return n}if((0,m.isObject)(h)){if(I.has(h))throw new Error("Cannot clone recursive data-structure");I.add(h);const n={};for(const s in h)p.call(h,s)&&(n[s]=V(h[s],L,I));return I.delete(h),n}return h}function w(h,L,I=!0){return(0,m.isObject)(h)?((0,m.isObject)(L)&&Object.keys(L).forEach(g=>{g in h?I&&((0,m.isObject)(h[g])&&(0,m.isObject)(L[g])?w(h[g],L[g],I):h[g]=L[g]):h[g]=L[g]}),h):L}function A(h,L){if(h===L)return!0;if(h==null||L===null||L===void 0||typeof h!=typeof L||typeof h!="object"||Array.isArray(h)!==Array.isArray(L))return!1;let I,g;if(Array.isArray(h)){if(h.length!==L.length)return!1;for(I=0;I<h.length;I++)if(!A(h[I],L[I]))return!1}else{const n=[];for(g in h)n.push(g);n.sort();const s=[];for(g in L)s.push(g);if(s.sort(),!A(n,s))return!1;for(I=0;I<n.length;I++)if(!A(h[n[I]],L[n[I]]))return!1}return!0}function M(h){const L=new Set;return JSON.stringify(h,(I,g)=>{if((0,m.isObject)(g)||Array.isArray(g)){if(L.has(g))return"[Circular]";L.add(g)}return typeof g=="bigint"?`[BigInt ${g.toString()}]`:g})}function B(h,L){const I=Object.create(null);return!h||!L||Object.keys(L).forEach(n=>{const s=h[n],l=L[n];A(s,l)||(I[n]=l)}),I}function G(h,L){const I=L.toLowerCase(),g=Object.keys(h).find(n=>n.toLowerCase()===I);return g?h[g]:h[L]}function r1(h,L){const I=Object.create(null);for(const[g,n]of Object.entries(h))L(g,n)&&(I[g]=n);return I}function _1(h){let L=[];for(;Object.prototype!==h;)L=L.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return L}function W(h){const L=[];for(const I of _1(h))typeof h[I]=="function"&&L.push(I);return L}function j(h,L){const I=n=>function(){const s=Array.prototype.slice.call(arguments,0);return L(n,s)},g={};for(const n of h)g[n]=I(n);return g}function S(h,L){const I={};for(const[g,n]of Object.entries(h))I[g]=L(n,g);return I}}),define(f1[20],h1([0,1]),function(i1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.toUint8=e,t.toUint32=P;var m;(function(p){p[p.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",p[p.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",p[p.MAX_UINT_8=255]="MAX_UINT_8",p[p.MAX_UINT_16=65535]="MAX_UINT_16",p[p.MAX_UINT_32=4294967295]="MAX_UINT_32",p[p.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m||(t.Constants=m={}));function e(p){return p<0?0:p>m.MAX_UINT_8?m.MAX_UINT_8:p|0}function P(p){return p<0?0:p>m.MAX_UINT_32?m.MAX_UINT_32:p|0}}),define(f1[21],h1([0,1,17,7,11,20]),function(i1,t,m,e,P,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=s1,t.format=w,t.format2=M,t.htmlAttributeEncodeValue=B,t.escape=G,t.escapeRegExpCharacters=r1,t.count=_1,t.truncate=W,t.truncateMiddle=j,t.trim=S,t.ltrim=h,t.rtrim=L,t.convertSimple2RegExpPattern=I,t.stripWildcards=g,t.createRegExp=n,t.regExpLeadsToEndlessLoop=s,t.splitLines=l,t.splitLinesIncludeSeparators=o,t.firstNonWhitespaceIndex=U,t.getLeadingWhitespace=O,t.lastNonWhitespaceIndex=Y,t.replaceAsync=d1,t.compare=q,t.compareSubstring=a1,t.compareIgnoreCase=F,t.compareSubstringIgnoreCase=a,t.isAsciiDigit=y,t.isLowerAsciiLetter=H,t.isUpperAsciiLetter=D,t.equalsIgnoreCase=d,t.startsWithIgnoreCase=N,t.commonPrefixLength=Z,t.commonSuffixLength=Q,t.isHighSurrogate=x,t.isLowSurrogate=t1,t.computeCodePoint=X,t.getNextCodePoint=C,t.nextCharLength=R1,t.prevCharLength=N1,t.getCharContainingOffset=G1,t.charCount=q1,t.containsRTL=k1,t.isBasicASCII=_,t.containsUnusualLineTerminators=c,t.isFullWidthCharacter=E,t.isEmojiImprecise=v,t.lcut=J,t.forAnsiStringParts=m1,t.removeAnsiEscapeCodes=E1,t.removeAnsiEscapeCodesFromPrompt=T,t.startsWithUTF8BOM=R,t.stripUTF8BOM=K,t.fuzzyContains=k,t.containsUppercaseCharacter=$,t.uppercaseFirstLetter=n1,t.getNLines=l1,t.singleLetterHash=g1,t.getGraphemeBreakType=b1,t.getLeftDeleteOffset=P1;function s1(i){return!i||typeof i!="string"?!0:i.trim().length===0}const V=/{(\d+)}/g;function w(i,...r){return r.length===0?i:i.replace(V,function(f,b){const z=parseInt(b,10);return isNaN(z)||z<0||z>=r.length?f:r[z]})}const A=/{([^}]+)}/g;function M(i,r){return Object.keys(r).length===0?i:i.replace(A,(f,b)=>r[b]??f)}function B(i){return i.replace(/[<>"'&]/g,r=>{switch(r){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return r})}function G(i){return i.replace(/[<>&]/g,function(r){switch(r){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return r}})}function r1(i){return i.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function _1(i,r){let f=0,b=i.indexOf(r);for(;b!==-1;)f++,b=i.indexOf(r,b+r.length);return f}function W(i,r,f="\u2026"){return i.length<=r?i:`${i.substr(0,r)}${f}`}function j(i,r,f="\u2026"){if(i.length<=r)return i;const b=Math.ceil(r/2)-f.length/2,z=Math.floor(r/2)-f.length/2;return`${i.substr(0,b)}${f}${i.substr(i.length-z)}`}function S(i,r=" "){const f=h(i,r);return L(f,r)}function h(i,r){if(!i||!r)return i;const f=r.length;if(f===0||i.length===0)return i;let b=0;for(;i.indexOf(r,b)===b;)b=b+f;return i.substring(b)}function L(i,r){if(!i||!r)return i;const f=r.length,b=i.length;if(f===0||b===0)return i;let z=b,o1=-1;for(;o1=i.lastIndexOf(r,z-1),!(o1===-1||o1+f!==z);){if(o1===0)return"";z=o1}return i.substring(0,z)}function I(i){return i.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function g(i){return i.replace(/\*/g,"")}function n(i,r,f={}){if(!i)throw new Error("Cannot create regex from empty string");r||(i=r1(i)),f.wholeWord&&(/\B/.test(i.charAt(0))||(i="\\b"+i),/\B/.test(i.charAt(i.length-1))||(i=i+"\\b"));let b="";return f.global&&(b+="g"),f.matchCase||(b+="i"),f.multiline&&(b+="m"),f.unicode&&(b+="u"),new RegExp(i,b)}function s(i){return i.source==="^"||i.source==="^$"||i.source==="$"||i.source==="^\\s*$"?!1:!!(i.exec("")&&i.lastIndex===0)}function l(i){return i.split(/\r\n|\r|\n/)}function o(i){const r=[],f=i.split(/(\r\n|\r|\n)/);for(let b=0;b<Math.ceil(f.length/2);b++)r.push(f[2*b]+(f[2*b+1]??""));return r}function U(i){for(let r=0,f=i.length;r<f;r++){const b=i.charCodeAt(r);if(b!==e.CharCode.Space&&b!==e.CharCode.Tab)return r}return-1}function O(i,r=0,f=i.length){for(let b=r;b<f;b++){const z=i.charCodeAt(b);if(z!==e.CharCode.Space&&z!==e.CharCode.Tab)return i.substring(r,b)}return i.substring(r,f)}function Y(i,r=i.length-1){for(let f=r;f>=0;f--){const b=i.charCodeAt(f);if(b!==e.CharCode.Space&&b!==e.CharCode.Tab)return f}return-1}function d1(i,r,f){const b=[];let z=0;for(const o1 of i.matchAll(r)){if(b.push(i.slice(z,o1.index)),o1.index===void 0)throw new Error("match.index should be defined");z=o1.index+o1[0].length,b.push(f(o1[0],...o1.slice(1),o1.index,i,o1.groups))}return b.push(i.slice(z)),Promise.all(b).then(o1=>o1.join(""))}function q(i,r){return i<r?-1:i>r?1:0}function a1(i,r,f=0,b=i.length,z=0,o1=r.length){for(;f<b&&z<o1;f++,z++){const w1=i.charCodeAt(f),O1=r.charCodeAt(z);if(w1<O1)return-1;if(w1>O1)return 1}const L1=b-f,S1=o1-z;return L1<S1?-1:L1>S1?1:0}function F(i,r){return a(i,r,0,i.length,0,r.length)}function a(i,r,f=0,b=i.length,z=0,o1=r.length){for(;f<b&&z<o1;f++,z++){let w1=i.charCodeAt(f),O1=r.charCodeAt(z);if(w1===O1)continue;if(w1>=128||O1>=128)return a1(i.toLowerCase(),r.toLowerCase(),f,b,z,o1);H(w1)&&(w1-=32),H(O1)&&(O1-=32);const A1=w1-O1;if(A1!==0)return A1}const L1=b-f,S1=o1-z;return L1<S1?-1:L1>S1?1:0}function y(i){return i>=e.CharCode.Digit0&&i<=e.CharCode.Digit9}function H(i){return i>=e.CharCode.a&&i<=e.CharCode.z}function D(i){return i>=e.CharCode.A&&i<=e.CharCode.Z}function d(i,r){return i.length===r.length&&a(i,r)===0}function N(i,r){const f=r.length;return r.length>i.length?!1:a(i,r,0,f)===0}function Z(i,r){const f=Math.min(i.length,r.length);let b;for(b=0;b<f;b++)if(i.charCodeAt(b)!==r.charCodeAt(b))return b;return f}function Q(i,r){const f=Math.min(i.length,r.length);let b;const z=i.length-1,o1=r.length-1;for(b=0;b<f;b++)if(i.charCodeAt(z-b)!==r.charCodeAt(o1-b))return b;return f}function x(i){return 55296<=i&&i<=56319}function t1(i){return 56320<=i&&i<=57343}function X(i,r){return(i-55296<<10)+(r-56320)+65536}function C(i,r,f){const b=i.charCodeAt(f);if(x(b)&&f+1<r){const z=i.charCodeAt(f+1);if(t1(z))return X(b,z)}return b}function c1(i,r){const f=i.charCodeAt(r-1);if(t1(f)&&r>1){const b=i.charCodeAt(r-2);if(x(b))return X(b,f)}return f}class v1{get offset(){return this._offset}constructor(r,f=0){this._str=r,this._len=r.length,this._offset=f}setOffset(r){this._offset=r}prevCodePoint(){const r=c1(this._str,this._offset);return this._offset-=r>=p.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,r}nextCodePoint(){const r=C(this._str,this._len,this._offset);return this._offset+=r>=p.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,r}eol(){return this._offset>=this._len}}t.CodePointIterator=v1;class I1{get offset(){return this._iterator.offset}constructor(r,f=0){this._iterator=new v1(r,f)}nextGraphemeLength(){const r=U1.getInstance(),f=this._iterator,b=f.offset;let z=r.getGraphemeBreakType(f.nextCodePoint());for(;!f.eol();){const o1=f.offset,L1=r.getGraphemeBreakType(f.nextCodePoint());if(M1(z,L1)){f.setOffset(o1);break}z=L1}return f.offset-b}prevGraphemeLength(){const r=U1.getInstance(),f=this._iterator,b=f.offset;let z=r.getGraphemeBreakType(f.prevCodePoint());for(;f.offset>0;){const o1=f.offset,L1=r.getGraphemeBreakType(f.prevCodePoint());if(M1(L1,z)){f.setOffset(o1);break}z=L1}return b-f.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=I1;function R1(i,r){return new I1(i,r).nextGraphemeLength()}function N1(i,r){return new I1(i,r).prevGraphemeLength()}function G1(i,r){r>0&&t1(i.charCodeAt(r))&&r--;const f=r+R1(i,r);return[f-N1(i,f),f]}function q1(i){const r=new I1(i);let f=0;for(;!r.eol();)f++,r.nextGraphemeLength();return f}let D1;function F1(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function k1(i){return D1||(D1=F1()),D1.test(i)}const u=/^[\t\n\r\x20-\x7E]*$/;function _(i){return u.test(i)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function c(i){return t.UNUSUAL_LINE_TERMINATORS.test(i)}function E(i){return i>=11904&&i<=55215||i>=63744&&i<=64255||i>=65281&&i<=65374}function v(i){return i>=127462&&i<=127487||i===8986||i===8987||i===9200||i===9203||i>=9728&&i<=10175||i===11088||i===11093||i>=127744&&i<=128591||i>=128640&&i<=128764||i>=128992&&i<=129008||i>=129280&&i<=129535||i>=129648&&i<=129782}function J(i,r,f=""){const b=i.trimStart();if(b.length<r)return b;const z=/\b/g;let o1=0;for(;z.test(b)&&!(b.length-z.lastIndex<r);)o1=z.lastIndex,z.lastIndex+=1;return o1===0?b:f+b.substring(o1).trimStart()}const u1=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*m1(i){let r=0;for(const f of i.matchAll(u1))r!==f.index&&(yield{isCode:!1,str:i.substring(r,f.index)}),yield{isCode:!0,str:f[0]},r=f.index+f[0].length;r!==i.length&&(yield{isCode:!1,str:i.substring(r)})}function E1(i){return i&&(i=i.replace(u1,"")),i}const p1=/\\\[.*?\\\]/g;function T(i){return E1(i).replace(p1,"")}t.UTF8_BOM_CHARACTER=String.fromCharCode(e.CharCode.UTF8_BOM);function R(i){return!!(i&&i.length>0&&i.charCodeAt(0)===e.CharCode.UTF8_BOM)}function K(i){return R(i)?i.substr(1):i}function k(i,r){if(!i||!r||i.length<r.length)return!1;const f=r.length,b=i.toLowerCase();let z=0,o1=-1;for(;z<f;){const L1=b.indexOf(r[z],o1+1);if(L1<0)return!1;o1=L1,z++}return!0}function $(i,r=!1){return i?(r&&(i=i.replace(/\\./g,"")),i.toLowerCase()!==i):!1}function n1(i){return i.charAt(0).toUpperCase()+i.slice(1)}function l1(i,r=1){if(r===0)return"";let f=-1;do f=i.indexOf(`
`,f+1),r--;while(r>0&&f>=0);return f===-1?i:(i[f-1]==="\r"&&f--,i.substr(0,f))}function g1(i){const r=e.CharCode.Z-e.CharCode.A+1;return i=i%(2*r),i<r?String.fromCharCode(e.CharCode.a+i):String.fromCharCode(e.CharCode.A+i-r)}function b1(i){return U1.getInstance().getGraphemeBreakType(i)}function M1(i,r){return i===e1.Other?r!==e1.Extend&&r!==e1.SpacingMark:i===e1.CR&&r===e1.LF?!1:i===e1.Control||i===e1.CR||i===e1.LF||r===e1.Control||r===e1.CR||r===e1.LF?!0:!(i===e1.L&&(r===e1.L||r===e1.V||r===e1.LV||r===e1.LVT)||(i===e1.LV||i===e1.V)&&(r===e1.V||r===e1.T)||(i===e1.LVT||i===e1.T)&&r===e1.T||r===e1.Extend||r===e1.ZWJ||r===e1.SpacingMark||i===e1.Prepend||i===e1.ZWJ&&r===e1.Extended_Pictographic||i===e1.Regional_Indicator&&r===e1.Regional_Indicator)}var e1;(function(i){i[i.Other=0]="Other",i[i.Prepend=1]="Prepend",i[i.CR=2]="CR",i[i.LF=3]="LF",i[i.Control=4]="Control",i[i.Extend=5]="Extend",i[i.Regional_Indicator=6]="Regional_Indicator",i[i.SpacingMark=7]="SpacingMark",i[i.L=8]="L",i[i.V=9]="V",i[i.T=10]="T",i[i.LV=11]="LV",i[i.LVT=12]="LVT",i[i.ZWJ=13]="ZWJ",i[i.Extended_Pictographic=14]="Extended_Pictographic"})(e1||(t.GraphemeBreakType=e1={}));class U1{static{this._INSTANCE=null}static getInstance(){return U1._INSTANCE||(U1._INSTANCE=new U1),U1._INSTANCE}constructor(){this._data=K1()}getGraphemeBreakType(r){if(r<32)return r===e.CharCode.LineFeed?e1.LF:r===e.CharCode.CarriageReturn?e1.CR:e1.Control;if(r<127)return e1.Other;const f=this._data,b=f.length/3;let z=1;for(;z<=b;)if(r<f[3*z])z=2*z;else if(r>f[3*z+1])z=2*z+1;else return f[3*z+2];return e1.Other}}function K1(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function P1(i,r){if(i===0)return 0;const f=j1(i,r);if(f!==void 0)return f;const b=new v1(r,i);return b.prevCodePoint(),b.offset}function j1(i,r){const f=new v1(r,i);let b=f.prevCodePoint();for(;V1(b)||b===H1.emojiVariantSelector||b===H1.enclosingKeyCap;){if(f.offset===0)return;b=f.prevCodePoint()}if(!v(b))return;let z=f.offset;return z>0&&f.prevCodePoint()===H1.zwj&&(z=f.offset),z}function V1(i){return 127995<=i&&i<=127999}var H1;(function(i){i[i.zwj=8205]="zwj",i[i.emojiVariantSelector=65039]="emojiVariantSelector",i[i.enclosingKeyCap=8419]="enclosingKeyCap"})(H1||(H1={})),t.noBreakWhitespace="\xA0";class B1{static{this.ambiguousCharacterData=new P.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new m.LRUCachedFunction({getCacheKey:JSON.stringify},r=>{function f(A1){const y1=new Map;for(let T1=0;T1<A1.length;T1+=2)y1.set(A1[T1],A1[T1+1]);return y1}function b(A1,y1){const T1=new Map(A1);for(const[z1,$1]of y1)T1.set(z1,$1);return T1}function z(A1,y1){if(!A1)return y1;const T1=new Map;for(const[z1,$1]of A1)y1.has(z1)&&T1.set(z1,$1);return T1}const o1=this.ambiguousCharacterData.value;let L1=r.filter(A1=>!A1.startsWith("_")&&A1 in o1);L1.length===0&&(L1=["_default"]);let S1;for(const A1 of L1){const y1=f(o1[A1]);S1=z(S1,y1)}const w1=f(o1._common),O1=b(w1,S1);return new B1(O1)})}static getInstance(r){return B1.cache.get(Array.from(r))}static{this._locales=new P.Lazy(()=>Object.keys(B1.ambiguousCharacterData.value).filter(r=>!r.startsWith("_")))}static getLocales(){return B1._locales.value}constructor(r){this.confusableDictionary=r}isAmbiguous(r){return this.confusableDictionary.has(r)}containsAmbiguousCharacter(r){for(let f=0;f<r.length;f++){const b=r.codePointAt(f);if(typeof b=="number"&&this.isAmbiguous(b))return!0}return!1}getPrimaryConfusable(r){return this.confusableDictionary.get(r)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=B1;class W1{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(W1.getRawData())),this._data}static isInvisibleCharacter(r){return W1.getData().has(r)}static containsInvisibleCharacter(r){for(let f=0;f<r.length;f++){const b=r.codePointAt(f);if(typeof b=="number"&&W1.isInvisibleCharacter(b))return!0}return!1}static get codePoints(){return W1.getData()}}t.InvisibleCharacters=W1});var Q1=this&&this.__createBinding||(Object.create?function(i1,t,m,e){e===void 0&&(e=m);var P=Object.getOwnPropertyDescriptor(t,m);(!P||("get"in P?!t.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return t[m]}}),Object.defineProperty(i1,e,P)}:function(i1,t,m,e){e===void 0&&(e=m),i1[e]=t[m]}),X1=this&&this.__setModuleDefault||(Object.create?function(i1,t){Object.defineProperty(i1,"default",{enumerable:!0,value:t})}:function(i1,t){i1.default=t}),Y1=this&&this.__importStar||function(i1){if(i1&&i1.__esModule)return i1;var t={};if(i1!=null)for(var m in i1)m!=="default"&&Object.prototype.hasOwnProperty.call(i1,m)&&Q1(t,i1,m);return X1(t,i1),t};define(f1[22],h1([0,1,2,5,4,19,14,21]),function(i1,t,m,e,P,p,s1,V){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=M,t.create=s,V=Y1(V);const w="$initialize";let A=!1;function M(l){s1.isWeb&&(A||(A=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}var B;(function(l){l[l.Request=0]="Request",l[l.Reply=1]="Reply",l[l.SubscribeEvent=2]="SubscribeEvent",l[l.Event=3]="Event",l[l.UnsubscribeEvent=4]="UnsubscribeEvent"})(B||(B={}));class G{constructor(o,U,O,Y){this.vsWorker=o,this.req=U,this.method=O,this.args=Y,this.type=B.Request}}class r1{constructor(o,U,O,Y){this.vsWorker=o,this.seq=U,this.res=O,this.err=Y,this.type=B.Reply}}class _1{constructor(o,U,O,Y){this.vsWorker=o,this.req=U,this.eventName=O,this.arg=Y,this.type=B.SubscribeEvent}}class W{constructor(o,U,O){this.vsWorker=o,this.req=U,this.event=O,this.type=B.Event}}class j{constructor(o,U){this.vsWorker=o,this.req=U,this.type=B.UnsubscribeEvent}}class S{constructor(o){this._workerId=-1,this._handler=o,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(o){this._workerId=o}sendMessage(o,U){const O=String(++this._lastSentReq);return new Promise((Y,d1)=>{this._pendingReplies[O]={resolve:Y,reject:d1},this._send(new G(this._workerId,O,o,U))})}listen(o,U){let O=null;const Y=new e.Emitter({onWillAddFirstListener:()=>{O=String(++this._lastSentReq),this._pendingEmitters.set(O,Y),this._send(new _1(this._workerId,O,o,U))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(O),this._send(new j(this._workerId,O)),O=null}});return Y.event}handleMessage(o){!o||!o.vsWorker||this._workerId!==-1&&o.vsWorker!==this._workerId||this._handleMessage(o)}_handleMessage(o){switch(o.type){case B.Reply:return this._handleReplyMessage(o);case B.Request:return this._handleRequestMessage(o);case B.SubscribeEvent:return this._handleSubscribeEventMessage(o);case B.Event:return this._handleEventMessage(o);case B.UnsubscribeEvent:return this._handleUnsubscribeEventMessage(o)}}_handleReplyMessage(o){if(!this._pendingReplies[o.seq]){console.warn("Got reply to unknown seq");return}const U=this._pendingReplies[o.seq];if(delete this._pendingReplies[o.seq],o.err){let O=o.err;o.err.$isError&&(O=new Error,O.name=o.err.name,O.message=o.err.message,O.stack=o.err.stack),U.reject(O);return}U.resolve(o.res)}_handleRequestMessage(o){const U=o.req;this._handler.handleMessage(o.method,o.args).then(Y=>{this._send(new r1(this._workerId,U,Y,void 0))},Y=>{Y.detail instanceof Error&&(Y.detail=(0,m.transformErrorForSerialization)(Y.detail)),this._send(new r1(this._workerId,U,void 0,(0,m.transformErrorForSerialization)(Y)))})}_handleSubscribeEventMessage(o){const U=o.req,O=this._handler.handleEvent(o.eventName,o.arg)(Y=>{this._send(new W(this._workerId,U,Y))});this._pendingEvents.set(U,O)}_handleEventMessage(o){if(!this._pendingEmitters.has(o.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(o.req).fire(o.event)}_handleUnsubscribeEventMessage(o){if(!this._pendingEvents.has(o.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(o.req).dispose(),this._pendingEvents.delete(o.req)}_send(o){const U=[];if(o.type===B.Request)for(let O=0;O<o.args.length;O++)o.args[O]instanceof ArrayBuffer&&U.push(o.args[O]);else o.type===B.Reply&&o.res instanceof ArrayBuffer&&U.push(o.res);this._handler.sendMessage(o,U)}}class h extends P.Disposable{constructor(o,U,O){super();let Y=null;this._worker=this._register(o.create("vs/base/common/worker/simpleWorker",y=>{this._protocol.handleMessage(y)},y=>{Y?.(y)})),this._protocol=new S({sendMessage:(y,H)=>{this._worker.postMessage(y,H)},handleMessage:(y,H)=>{if(typeof O[y]!="function")return Promise.reject(new Error("Missing method "+y+" on main thread host."));try{return Promise.resolve(O[y].apply(O,H))}catch(D){return Promise.reject(D)}},handleEvent:(y,H)=>{if(I(y)){const D=O[y].call(O,H);if(typeof D!="function")throw new Error(`Missing dynamic event ${y} on main thread host.`);return D}if(L(y)){const D=O[y];if(typeof D!="function")throw new Error(`Missing event ${y} on main thread host.`);return D}throw new Error(`Malformed event name ${y}`)}}),this._protocol.setWorkerId(this._worker.getId());let d1=null;const q=globalThis.require;typeof q<"u"&&typeof q.getConfig=="function"?d1=q.getConfig():typeof globalThis.requirejs<"u"&&(d1=globalThis.requirejs.s.contexts._.config);const a1=(0,p.getAllMethodNames)(O);this._onModuleLoaded=this._protocol.sendMessage(w,[this._worker.getId(),JSON.parse(JSON.stringify(d1)),U,a1]);const F=(y,H)=>this._request(y,H),a=(y,H)=>this._protocol.listen(y,H);this._lazyProxy=new Promise((y,H)=>{Y=H,this._onModuleLoaded.then(D=>{y(g(D,F,a))},D=>{H(D),this._onError("Worker failed to load "+U,D)})})}getProxyObject(){return this._lazyProxy}_request(o,U){return new Promise((O,Y)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(o,U).then(O,Y)},Y)})}_onError(o,U){console.error(o),console.info(U)}}t.SimpleWorkerClient=h;function L(l){return l[0]==="o"&&l[1]==="n"&&V.isUpperAsciiLetter(l.charCodeAt(2))}function I(l){return/^onDynamic/.test(l)&&V.isUpperAsciiLetter(l.charCodeAt(9))}function g(l,o,U){const O=q=>function(){const a1=Array.prototype.slice.call(arguments,0);return o(q,a1)},Y=q=>function(a1){return U(q,a1)},d1={};for(const q of l){if(I(q)){d1[q]=Y(q);continue}if(L(q)){d1[q]=U(q,void 0);continue}d1[q]=O(q)}return d1}class n{constructor(o,U){this._requestHandlerFactory=U,this._requestHandler=null,this._protocol=new S({sendMessage:(O,Y)=>{o(O,Y)},handleMessage:(O,Y)=>this._handleMessage(O,Y),handleEvent:(O,Y)=>this._handleEvent(O,Y)})}onmessage(o){this._protocol.handleMessage(o)}_handleMessage(o,U){if(o===w)return this.initialize(U[0],U[1],U[2],U[3]);if(!this._requestHandler||typeof this._requestHandler[o]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+o));try{return Promise.resolve(this._requestHandler[o].apply(this._requestHandler,U))}catch(O){return Promise.reject(O)}}_handleEvent(o,U){if(!this._requestHandler)throw new Error("Missing requestHandler");if(I(o)){const O=this._requestHandler[o].call(this._requestHandler,U);if(typeof O!="function")throw new Error(`Missing dynamic event ${o} on request handler.`);return O}if(L(o)){const O=this._requestHandler[o];if(typeof O!="function")throw new Error(`Missing event ${o} on request handler.`);return O}throw new Error(`Malformed event name ${o}`)}initialize(o,U,O,Y){this._protocol.setWorkerId(o);const a1=g(Y,(F,a)=>this._protocol.sendMessage(F,a),(F,a)=>this._protocol.listen(F,a));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(a1),Promise.resolve((0,p.getAllMethodNames)(this._requestHandler))):(U&&(typeof U.baseUrl<"u"&&delete U.baseUrl,typeof U.paths<"u"&&typeof U.paths.vs<"u"&&delete U.paths.vs,typeof U.trustedTypesPolicy<"u"&&delete U.trustedTypesPolicy,U.catchError=!0,globalThis.require.config(U)),new Promise((F,a)=>{(globalThis.require||i1)([O],H=>{if(this._requestHandler=H.create(a1),!this._requestHandler){a(new Error("No RequestHandler!"));return}F((0,p.getAllMethodNames)(this._requestHandler))},a)}))}}t.SimpleWorkerServer=n;function s(l){return new n(l,null)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/base/common/worker/simpleWorker.js.map
