/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(W){for(var i=[],t=0,n=W.length;t<n;t++)i[t]=ie[W[t]];return i};const Qe=this,Ze=typeof global=="object"?global:{};var Ee;(function(W){W.global=Qe;class i{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=i._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=i})(Ee||(Ee={}));var Ee;(function(W){class i{constructor(h,p,m){this.type=h,this.detail=p,this.timestamp=m}}W.LoaderEvent=i;class t{constructor(h){this._events=[new i(1,"",h)]}record(h,p){this._events.push(new i(h,p,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=t;class n{record(h,p){}getEvents(){return[]}}n.INSTANCE=new n,W.NullLoaderEventRecorder=n})(Ee||(Ee={}));var Ee;(function(W){class i{static fileUriToFilePath(n,M){if(M=decodeURI(M).replace(/%23/g,"#"),n){if(/^file:\/\/\//.test(M))return M.substr(8);if(/^file:\/\//.test(M))return M.substr(5)}else if(/^file:\/\//.test(M))return M.substr(7);return M}static startsWith(n,M){return n.length>=M.length&&n.substr(0,M.length)===M}static endsWith(n,M){return n.length>=M.length&&n.substr(n.length-M.length)===M}static containsQueryString(n){return/^[^\#]*\?/gi.test(n)}static isAbsolutePath(n){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(n)}static forEachProperty(n,M){if(n){let h;for(h in n)n.hasOwnProperty(h)&&M(h,n[h])}}static isEmpty(n){let M=!0;return i.forEachProperty(n,()=>{M=!1}),M}static recursiveClone(n){if(!n||typeof n!="object"||n instanceof RegExp||!Array.isArray(n)&&Object.getPrototypeOf(n)!==Object.prototype)return n;let M=Array.isArray(n)?[]:{};return i.forEachProperty(n,(h,p)=>{p&&typeof p=="object"?M[h]=i.recursiveClone(p):M[h]=p}),M}static generateAnonymousModule(){return"===anonymous"+i.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(n){return i.startsWith(n,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}i.NEXT_ANONYMOUS_ID=1,i.PERFORMANCE_NOW_PROBED=!1,i.HAS_PERFORMANCE_NOW=!1,W.Utilities=i})(Ee||(Ee={}));var Ee;(function(W){function i(M){if(M instanceof Error)return M;const h=new Error(M.message||String(M)||"Unknown Error");return M.stack&&(h.stack=M.stack),h}W.ensureError=i;class t{static validateConfigurationOptions(h){function p(m){if(m.phase==="loading"){console.error('Loading "'+m.moduleId+'" failed'),console.error(m),console.error("Here are the modules that depend on it:"),console.error(m.neededBy);return}if(m.phase==="factory"){console.error('The factory function of "'+m.moduleId+'" has thrown an exception'),console.error(m),console.error("Here are the modules that depend on it:"),console.error(m.neededBy);return}}if(h=h||{},typeof h.baseUrl!="string"&&(h.baseUrl=""),typeof h.isBuild!="boolean"&&(h.isBuild=!1),typeof h.paths!="object"&&(h.paths={}),typeof h.config!="object"&&(h.config={}),typeof h.catchError>"u"&&(h.catchError=!1),typeof h.recordStats>"u"&&(h.recordStats=!1),typeof h.urlArgs!="string"&&(h.urlArgs=""),typeof h.onError!="function"&&(h.onError=p),Array.isArray(h.ignoreDuplicateModules)||(h.ignoreDuplicateModules=[]),h.baseUrl.length>0&&(W.Utilities.endsWith(h.baseUrl,"/")||(h.baseUrl+="/")),typeof h.cspNonce!="string"&&(h.cspNonce=""),typeof h.preferScriptTags>"u"&&(h.preferScriptTags=!1),h.nodeCachedData&&typeof h.nodeCachedData=="object"&&(typeof h.nodeCachedData.seed!="string"&&(h.nodeCachedData.seed="seed"),(typeof h.nodeCachedData.writeDelay!="number"||h.nodeCachedData.writeDelay<0)&&(h.nodeCachedData.writeDelay=1e3*7),!h.nodeCachedData.path||typeof h.nodeCachedData.path!="string")){const m=i(new Error("INVALID cached data configuration, 'path' MUST be set"));m.phase="configuration",h.onError(m),h.nodeCachedData=void 0}return h}static mergeConfigurationOptions(h=null,p=null){let m=W.Utilities.recursiveClone(p||{});return W.Utilities.forEachProperty(h,(l,a)=>{l==="ignoreDuplicateModules"&&typeof m.ignoreDuplicateModules<"u"?m.ignoreDuplicateModules=m.ignoreDuplicateModules.concat(a):l==="paths"&&typeof m.paths<"u"?W.Utilities.forEachProperty(a,(c,_)=>m.paths[c]=_):l==="config"&&typeof m.config<"u"?W.Utilities.forEachProperty(a,(c,_)=>m.config[c]=_):m[l]=W.Utilities.recursiveClone(a)}),t.validateConfigurationOptions(m)}}W.ConfigurationOptionsUtil=t;class n{constructor(h,p){if(this._env=h,this.options=t.mergeConfigurationOptions(p),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let m=this.options.nodeRequire.main.filename,l=Math.max(m.lastIndexOf("/"),m.lastIndexOf("\\"));this.options.baseUrl=m.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let h=0;h<this.options.ignoreDuplicateModules.length;h++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[h]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(h,p)=>{Array.isArray(p)?this.sortedPathsRules.push({from:h,to:p}):this.sortedPathsRules.push({from:h,to:[p]})}),this.sortedPathsRules.sort((h,p)=>p.from.length-h.from.length)}cloneAndMerge(h){return new n(this._env,t.mergeConfigurationOptions(h,this.options))}getOptionsLiteral(){return this.options}_applyPaths(h){let p;for(let m=0,l=this.sortedPathsRules.length;m<l;m++)if(p=this.sortedPathsRules[m],W.Utilities.startsWith(h,p.from)){let a=[];for(let c=0,_=p.to.length;c<_;c++)a.push(p.to[c]+h.substr(p.from.length));return a}return[h]}_addUrlArgsToUrl(h){return W.Utilities.containsQueryString(h)?h+"&"+this.options.urlArgs:h+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(h){return this.options.urlArgs?this._addUrlArgsToUrl(h):h}_addUrlArgsIfNecessaryToUrls(h){if(this.options.urlArgs)for(let p=0,m=h.length;p<m;p++)h[p]=this._addUrlArgsToUrl(h[p]);return h}moduleIdToPaths(h){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(h))return this.isBuild()?["empty:"]:["node|"+h];let p=h,m;if(!W.Utilities.endsWith(p,".js")&&!W.Utilities.isAbsolutePath(p)){m=this._applyPaths(p);for(let l=0,a=m.length;l<a;l++)this.isBuild()&&m[l]==="empty:"||(W.Utilities.isAbsolutePath(m[l])||(m[l]=this.options.baseUrl+m[l]),!W.Utilities.endsWith(m[l],".js")&&!W.Utilities.containsQueryString(m[l])&&(m[l]=m[l]+".js"))}else!W.Utilities.endsWith(p,".js")&&!W.Utilities.containsQueryString(p)&&(p=p+".js"),m=[p];return this._addUrlArgsIfNecessaryToUrls(m)}requireToUrl(h){let p=h;return W.Utilities.isAbsolutePath(p)||(p=this._applyPaths(p)[0],W.Utilities.isAbsolutePath(p)||(p=this.options.baseUrl+p)),this._addUrlArgsIfNecessaryToUrl(p)}isBuild(){return this.options.isBuild}shouldInvokeFactory(h){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(h)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[h])}isDuplicateMessageIgnoredFor(h){return this.ignoreDuplicateModulesMap.hasOwnProperty(h)}getConfigForModule(h){if(this.options.config)return this.options.config[h]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(h){this.options.onError(h)}}W.Configuration=n})(Ee||(Ee={}));var Ee;(function(W){class i{constructor(a){this._env=a,this._scriptLoader=null,this._callbackMap={}}load(a,c,_,g){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=a.getConfig().getOptionsLiteral();e?this._scriptLoader=new t:this._scriptLoader=new h(this._env)}else this._env.isNode?this._scriptLoader=new h(this._env):this._scriptLoader=new t;let b={callback:_,errorback:g};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(b);return}this._callbackMap[c]=[b],this._scriptLoader.load(a,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(a){let c=this._callbackMap[a];delete this._callbackMap[a];for(let _=0;_<c.length;_++)c[_].callback()}triggerErrorback(a,c){let _=this._callbackMap[a];delete this._callbackMap[a];for(let g=0;g<_.length;g++)_[g].errorback(c)}}class t{attachListeners(a,c,_){let g=()=>{a.removeEventListener("load",b),a.removeEventListener("error",e)},b=L=>{g(),c()},e=L=>{g(),_(L)};a.addEventListener("load",b),a.addEventListener("error",e)}load(a,c,_,g){if(/^node\|/.test(c)){let b=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),b.nodeRequire||W.global.nodeRequire),L=c.split("|"),E=null;try{E=e(L[1])}catch(N){g(N);return}a.enqueueDefineAnonymousModule([],()=>E),_()}else{let b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript"),this.attachListeners(b,_,g);const{trustedTypesPolicy:e}=a.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),b.setAttribute("src",c);const{cspNonce:L}=a.getConfig().getOptionsLiteral();L&&b.setAttribute("nonce",L),document.getElementsByTagName("head")[0].appendChild(b)}}}function n(l){const{trustedTypesPolicy:a}=l.getConfig().getOptionsLiteral();try{return(a?self.eval(a.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class M{constructor(){this._cachedCanUseEval=null}_canUseEval(a){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=n(a)),this._cachedCanUseEval}load(a,c,_,g){if(/^node\|/.test(c)){const b=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),b.nodeRequire||W.global.nodeRequire),L=c.split("|");let E=null;try{E=e(L[1])}catch(N){g(N);return}a.enqueueDefineAnonymousModule([],function(){return E}),_()}else{const{trustedTypesPolicy:b}=a.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(a)){fetch(c).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${c}`,(b?self.eval(b.createScript("",L)):new Function(L)).call(self),_()}).then(void 0,g);return}try{b&&(c=b.createScriptURL(c)),importScripts(c),_()}catch(L){g(L)}}}}class h{constructor(a){this._env=a,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(a){this._didInitialize||(this._didInitialize=!0,this._fs=a("fs"),this._vm=a("vm"),this._path=a("path"),this._crypto=a("crypto"))}_initNodeRequire(a,c){const{nodeCachedData:_}=c.getConfig().getOptionsLiteral();if(!_||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const g=this,b=a("module");function e(L){const E=L.constructor;let N=function(v){try{return L.require(v)}finally{}};return N.resolve=function(v,A){return E._resolveFilename(v,L,!1,A)},N.resolve.paths=function(v){return E._resolveLookupPaths(v,L)},N.main=process.mainModule,N.extensions=E._extensions,N.cache=E._cache,N}b.prototype._compile=function(L,E){const N=b.wrap(L.replace(/^#!.*/,"")),w=c.getRecorder(),v=g._getCachedDataPath(_,E),A={filename:E};let d;try{const S=g._fs.readFileSync(v);d=S.slice(0,16),A.cachedData=S.slice(16),w.record(60,v)}catch{w.record(61,v)}const o=new g._vm.Script(N,A),r=o.runInThisContext(A),u=g._path.dirname(E),f=e(this),D=[this.exports,f,this,E,u,process,Ze,Buffer],R=r.apply(this.exports,D);return g._handleCachedData(o,N,v,!A.cachedData,c),g._verifyCachedData(o,N,v,d,c),R}}load(a,c,_,g){const b=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),b.nodeRequire||W.global.nodeRequire),L=b.nodeInstrumenter||function(N){return N};this._init(e),this._initNodeRequire(e,a);let E=a.getRecorder();if(/^node\|/.test(c)){let N=c.split("|"),w=null;try{w=e(N[1])}catch(v){g(v);return}a.enqueueDefineAnonymousModule([],()=>w),_()}else{c=W.Utilities.fileUriToFilePath(this._env.isWindows,c);const N=this._path.normalize(c),w=this._getElectronRendererScriptPathOrUri(N),v=!!b.nodeCachedData,A=v?this._getCachedDataPath(b.nodeCachedData,c):void 0;this._readSourceAndCachedData(N,A,E,(d,o,r,u)=>{if(d){g(d);return}let f;o.charCodeAt(0)===h._BOM?f=h._PREFIX+o.substring(1)+h._SUFFIX:f=h._PREFIX+o+h._SUFFIX,f=L(f,N);const D={filename:w,cachedData:r},R=this._createAndEvalScript(a,f,D,_,g);this._handleCachedData(R,f,A,v&&!r,a),this._verifyCachedData(R,f,A,u,a)})}}_createAndEvalScript(a,c,_,g,b){const e=a.getRecorder();e.record(31,_.filename);const L=new this._vm.Script(c,_),E=L.runInThisContext(_),N=a.getGlobalAMDDefineFunc();let w=!1;const v=function(){return w=!0,N.apply(null,arguments)};return v.amd=N.amd,E.call(W.global,a.getGlobalAMDRequireFunc(),v,_.filename,this._path.dirname(_.filename)),e.record(32,_.filename),w?g():b(new Error(`Didn't receive define call in ${_.filename}!`)),L}_getElectronRendererScriptPathOrUri(a){if(!this._env.isElectronRenderer)return a;let c=a.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${a}`}_getCachedDataPath(a,c){const _=this._crypto.createHash("md5").update(c,"utf8").update(a.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(c).replace(/\.js$/,"");return this._path.join(a.path,`${g}-${_}.code`)}_handleCachedData(a,c,_,g,b){a.cachedDataRejected?this._fs.unlink(_,e=>{b.getRecorder().record(62,_),this._createAndWriteCachedData(a,c,_,b),e&&b.getConfig().onError(e)}):g&&this._createAndWriteCachedData(a,c,_,b)}_createAndWriteCachedData(a,c,_,g){let b=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,L=0,E;const N=()=>{setTimeout(()=>{E||(E=this._crypto.createHash("md5").update(c,"utf8").digest());const w=a.createCachedData();if(!(w.length===0||w.length===e||L>=5)){if(w.length<e){N();return}e=w.length,this._fs.writeFile(_,Buffer.concat([E,w]),v=>{v&&g.getConfig().onError(v),g.getRecorder().record(63,_),N()})}},b*Math.pow(4,L++))};N()}_readSourceAndCachedData(a,c,_,g){if(!c)this._fs.readFile(a,{encoding:"utf8"},g);else{let b,e,L,E=2;const N=w=>{w?g(w):--E===0&&g(void 0,b,e,L)};this._fs.readFile(a,{encoding:"utf8"},(w,v)=>{b=v,N(w)}),this._fs.readFile(c,(w,v)=>{!w&&v&&v.length>0?(L=v.slice(0,16),e=v.slice(16),_.record(60,c)):_.record(61,c),N()})}}_verifyCachedData(a,c,_,g,b){g&&(a.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();g.equals(e)||(b.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${_}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(_,L=>{L&&b.getConfig().onError(L)}))},Math.ceil(5e3*(1+Math.random()))))}}h._BOM=65279,h._PREFIX="(function (require, define, __filename, __dirname) { ",h._SUFFIX=`
});`;function p(l,a){if(a.__$__isRecorded)return a;const c=function(g){l.record(33,g);try{return a(g)}finally{l.record(34,g)}};return c.__$__isRecorded=!0,c}W.ensureRecordedNodeRequire=p;function m(l){return new i(l)}W.createScriptLoader=m})(Ee||(Ee={}));var Ee;(function(W){class i{constructor(l){let a=l.lastIndexOf("/");a!==-1?this.fromModulePath=l.substr(0,a+1):this.fromModulePath=""}static _normalizeModuleId(l){let a=l,c;for(c=/\/\.\//;c.test(a);)a=a.replace(c,"/");for(a=a.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(a);)a=a.replace(c,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a}resolveModule(l){let a=l;return W.Utilities.isAbsolutePath(a)||(W.Utilities.startsWith(a,"./")||W.Utilities.startsWith(a,"../"))&&(a=i._normalizeModuleId(this.fromModulePath+a)),a}}i.ROOT=new i(""),W.ModuleIdResolver=i;class t{constructor(l,a,c,_,g,b){this.id=l,this.strId=a,this.dependencies=c,this._callback=_,this._errorback=g,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,a){try{return{returnedValue:l.apply(W.global,a),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(l,a,c,_){return l.shouldInvokeFactory(a)?l.shouldCatchError()?this._safeInvokeFunction(c,_):{returnedValue:c.apply(W.global,_),producedError:null}:{returnedValue:null,producedError:null}}complete(l,a,c,_){this._isComplete=!0;let g=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let b=t._invokeFactory(a,this.strId,this._callback,c);g=b.producedError,l.record(22,this.strId),!g&&typeof b.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if(g){let b=W.ensureError(g);b.phase="factory",b.moduleId=this.strId,b.neededBy=_(this.id),this.error=b,a.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}W.Module=t;class n{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let a=this._strModuleIdToIntModuleId.get(l);return typeof a>"u"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(l,a),this._intModuleIdToStrModuleId[a]=l),a}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class M{constructor(l){this.id=l}}M.EXPORTS=new M(0),M.MODULE=new M(1),M.REQUIRE=new M(2),W.RegularDependency=M;class h{constructor(l,a,c){this.id=l,this.pluginId=a,this.pluginParam=c}}W.PluginDependency=h;class p{constructor(l,a,c,_,g=0){this._env=l,this._scriptLoader=a,this._loaderAvailableTimestamp=g,this._defineFunc=c,this._requireFunc=_,this._moduleIdProvider=new n,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new p(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,a){let c=b=>b.replace(/\\/g,"/"),_=c(l),g=a.split(/\n/);for(let b=0;b<g.length;b++){let e=g[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){let L=e[1],E=e[2],N=e[3],w=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(w),L=c(L),L===_){let v={line:parseInt(E,10),col:parseInt(N,10)};return v.line===1&&(v.col-=53),v}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],a=0;for(let c=0,_=this._modules2.length;c<_;c++){let g=this._modules2[c];if(!g)continue;let b=this._buildInfoPath[g.id]||null,e=this._buildInfoDefineStack[g.id]||null,L=this._buildInfoDependencies[g.id];l[a++]={id:g.strId,path:b,defineLocation:b&&e?p._findRelevantLocationInStack(b,e):null,dependencies:L,shim:null,exports:g.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,a){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:l,callback:a}}defineModule(l,a,c,_,g,b=new i(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let L=new t(e,l,this._normalizeDependencies(a,b),c,_,b);this._modules2[e]=L,this._config.isBuild()&&(this._buildInfoDefineStack[e]=g,this._buildInfoDependencies[e]=(L.dependencies||[]).map(E=>this._moduleIdProvider.getStrModuleId(E.id))),this._resolve(L)}_normalizeDependency(l,a){if(l==="exports")return M.EXPORTS;if(l==="module")return M.MODULE;if(l==="require")return M.REQUIRE;let c=l.indexOf("!");if(c>=0){let _=a.resolveModule(l.substr(0,c)),g=a.resolveModule(l.substr(c+1)),b=this._moduleIdProvider.getModuleId(_+"!"+g),e=this._moduleIdProvider.getModuleId(_);return new h(b,e,g)}return new M(this._moduleIdProvider.getModuleId(a.resolveModule(l)))}_normalizeDependencies(l,a){let c=[],_=0;for(let g=0,b=l.length;g<b;g++)c[_++]=this._normalizeDependency(l[g],a);return c}_relativeRequire(l,a,c,_){if(typeof a=="string")return this.synchronousRequire(a,l);this.defineModule(W.Utilities.generateAnonymousModule(),a,c,_,null,l)}synchronousRequire(l,a=new i(l)){let c=this._normalizeDependency(l,a),_=this._modules2[c.id];if(!_)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!_.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(_.error)throw _.error;return _.exports}configure(l,a){let c=this._config.shouldRecordStats();a?this._config=new W.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let a=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),a.dependencies,a.callback,null,a.stack)}}_createLoadError(l,a){let c=this._moduleIdProvider.getStrModuleId(l),_=(this._inverseDependencies2[l]||[]).map(b=>this._moduleIdProvider.getStrModuleId(b));const g=W.ensureError(a);return g.phase="loading",g.moduleId=c,g.neededBy=_,g}_onLoadError(l,a){const c=this._createLoadError(l,a);this._modules2[l]||(this._modules2[l]=new t(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let _=[];for(let e=0,L=this._moduleIdProvider.getMaxModuleId();e<L;e++)_[e]=!1;let g=!1,b=[];for(b.push(l),_[l]=!0;b.length>0;){let e=b.shift(),L=this._modules2[e];L&&(g=L.onDependencyError(c)||g);let E=this._inverseDependencies2[e];if(E)for(let N=0,w=E.length;N<w;N++){let v=E[N];_[v]||(b.push(v),_[v]=!0)}}g||this._config.onError(c)}_hasDependencyPath(l,a){let c=this._modules2[l];if(!c)return!1;let _=[];for(let b=0,e=this._moduleIdProvider.getMaxModuleId();b<e;b++)_[b]=!1;let g=[];for(g.push(c),_[l]=!0;g.length>0;){let e=g.shift().dependencies;if(e)for(let L=0,E=e.length;L<E;L++){let N=e[L];if(N.id===a)return!0;let w=this._modules2[N.id];w&&!_[N.id]&&(_[N.id]=!0,g.push(w))}}return!1}_findCyclePath(l,a,c){if(l===a||c===50)return[l];let _=this._modules2[l];if(!_)return null;let g=_.dependencies;if(g)for(let b=0,e=g.length;b<e;b++){let L=this._findCyclePath(g[b].id,a,c+1);if(L!==null)return L.push(l),L}return null}_createRequire(l){let a=(c,_,g)=>this._relativeRequire(l,c,_,g);return a.toUrl=c=>this._config.requireToUrl(l.resolveModule(c)),a.getStats=()=>this.getLoaderEvents(),a.hasDependencyCycle=()=>this._hasDependencyCycle,a.config=(c,_=!1)=>{this.configure(c,_)},a.__$__nodeRequire=W.global.nodeRequire,a}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let a=this._moduleIdProvider.getStrModuleId(l),c=this._config.moduleIdToPaths(a),_=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(a.indexOf("/")===-1||_.test(a))&&c.push("node|"+a);let g=-1,b=e=>{if(g++,g>=c.length)this._onLoadError(l,e);else{let L=c[g],E=this.getRecorder();if(this._config.isBuild()&&L==="empty:"){this._buildInfoPath[l]=L,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}E.record(10,L),this._scriptLoader.load(this,L,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=L),E.record(11,L),this._onLoad(l)},N=>{E.record(12,L),b(N)})}};b(null)}_loadPluginDependency(l,a){if(this._modules2[a.id]||this._knownModules2[a.id])return;this._knownModules2[a.id]=!0;let c=_=>{this.defineModule(this._moduleIdProvider.getStrModuleId(a.id),[],_,null,null)};c.error=_=>{this._config.onError(this._createLoadError(a.id,_))},l.load(a.pluginParam,this._createRequire(i.ROOT),c,this._config.getOptionsLiteral())}_resolve(l){let a=l.dependencies;if(a)for(let c=0,_=a.length;c<_;c++){let g=a[c];if(g===M.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(g===M.MODULE){l.unresolvedDependenciesCount--;continue}if(g===M.REQUIRE){l.unresolvedDependenciesCount--;continue}let b=this._modules2[g.id];if(b&&b.isComplete()){if(b.error){l.onDependencyError(b.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(g.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(g.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(g.id,l.id,0)||[];e.reverse(),e.push(g.id),console.warn(e.map(L=>this._moduleIdProvider.getStrModuleId(L)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[g.id]=this._inverseDependencies2[g.id]||[],this._inverseDependencies2[g.id].push(l.id),g instanceof h){let e=this._modules2[g.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,g);continue}let L=this._inversePluginDependencies2.get(g.pluginId);L||(L=[],this._inversePluginDependencies2.set(g.pluginId,L)),L.push(g),this._loadModule(g.pluginId);continue}this._loadModule(g.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let a=this.getRecorder();if(l.isComplete())return;let c=l.dependencies,_=[];if(c)for(let L=0,E=c.length;L<E;L++){let N=c[L];if(N===M.EXPORTS){_[L]=l.exports;continue}if(N===M.MODULE){_[L]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(N===M.REQUIRE){_[L]=this._createRequire(l.moduleIdResolver);continue}let w=this._modules2[N.id];if(w){_[L]=w.exports;continue}_[L]=null}const g=L=>(this._inverseDependencies2[L]||[]).map(E=>this._moduleIdProvider.getStrModuleId(E));l.complete(a,this._config,_,g);let b=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,b)for(let L=0,E=b.length;L<E;L++){let N=b[L],w=this._modules2[N];w.unresolvedDependenciesCount--,w.unresolvedDependenciesCount===0&&this._onModuleComplete(w)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let L=0,E=e.length;L<E;L++)this._loadPluginDependency(l.exports,e[L])}}}W.ModuleManager=p})(Ee||(Ee={}));var ne,Ee;(function(W){const i=new W.Environment;let t=null;const n=function(m,l,a){typeof m!="string"&&(a=l,l=m,m=null),(typeof l!="object"||!Array.isArray(l))&&(a=l,l=null),l||(l=["require","exports","module"]),m?t.defineModule(m,l,a,null,null):t.enqueueDefineAnonymousModule(l,a)};n.amd={jQuery:!0};const M=function(m,l=!1){t.configure(m,l)},h=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){M(arguments[0]);return}if(typeof arguments[0]=="string")return t.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){t.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};h.config=M,h.getConfig=function(){return t.getConfig().getOptionsLiteral()},h.reset=function(){t=t.reset()},h.getBuildInfo=function(){return t.getBuildInfo()},h.getStats=function(){return t.getLoaderEvents()},h.define=n;function p(){if(typeof W.global.require<"u"||typeof require<"u"){const m=W.global.require||require;if(typeof m=="function"&&typeof m.resolve=="function"){const l=W.ensureRecordedNodeRequire(t.getRecorder(),m);W.global.nodeRequire=l,h.nodeRequire=l,h.__$__nodeRequire=l}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=h:(i.isElectronRenderer||(W.global.define=n),W.global.require=h)}W.init=p,(typeof W.global.define!="function"||!W.global.define.amd)&&(t=new W.ModuleManager(i,W.createScriptLoader(i),n,h,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&h.config(W.global.require),ne=function(){return n.apply(null,arguments)},ne.amd=n.amd,typeof doNotInitLoader>"u"&&p())})(Ee||(Ee={})),ne(ie[75],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=t;function t(m,l,a,c){if(c=c||{},(c["vs/css"]||{}).disabled){a({});return}const g=l.toUrl(m+".css");n(m,g,()=>{a({})},b=>{typeof a.error=="function"&&a.error("Could not find "+g+".")})}function n(m,l,a,c){if(M(m,l)){a();return}h(m,l,a,c)}function M(m,l){const a=window.document.getElementsByTagName("link");for(let c=0,_=a.length;c<_;c++){const g=a[c].getAttribute("data-name"),b=a[c].getAttribute("href");if(g===m||b===l)return!0}return!1}function h(m,l,a,c){const _=document.createElement("link");_.setAttribute("rel","stylesheet"),_.setAttribute("type","text/css"),_.setAttribute("data-name",m),p(m,_,a,c),_.setAttribute("href",l),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(_)}function p(m,l,a,c){const _=()=>{l.removeEventListener("load",g),l.removeEventListener("error",b)},g=e=>{_(),a()},b=e=>{_(),c(e)};l.addEventListener("load",g),l.addEventListener("error",b)}}),function(){const W=globalThis.MonacoEnvironment,i=W&&W.baseUrl?W.baseUrl:"../../../";function t(c,_){if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy(c,_)}catch(g){console.warn(g);return}try{return self.trustedTypes?.createPolicy(c,_)}catch(g){console.warn(g);return}}const n=t("amdLoader",{createScriptURL:c=>c,createScript:(c,..._)=>{const g=_.slice(0,-1).join(","),b=_.pop().toString();return`(function anonymous(${g}) { ${b}
})`}});function M(){try{return(n?globalThis.eval(n.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function h(){return new Promise((c,_)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const g=i+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,globalThis.origin.length)!==globalThis.origin)&&M()){fetch(g).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${g}`,(n?globalThis.eval(n.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,_);return}n?importScripts(n.createScriptURL(g)):importScripts(g),c()})}function p(){require.config({baseUrl:i,catchError:!0,trustedTypesPolicy:n,amdModulesPattern:/^vs\//})}function m(c){h().then(()=>{p(),require([c],function(_){setTimeout(function(){const g=_.create((b,e)=>{globalThis.postMessage(b,e)},null);for(globalThis.onmessage=b=>g.onmessage(b.data,b.ports);a.length>0;){const b=a.shift();g.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&p();let l=!0;const a=[];globalThis.onmessage=c=>{if(!l){a.push(c);return}l=!1,m(c.data)}}(),ne(ie[9],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MonotonousArray=void 0,i.findLast=t,i.findLastIdx=n,i.findLastMonotonous=M,i.findLastIdxMonotonous=h,i.findFirstMonotonous=p,i.findFirstIdxMonotonousOrArrLen=m,i.findFirstIdxMonotonous=l,i.findFirstMax=c,i.findLastMax=_,i.findFirstMin=g,i.findMaxIdx=b,i.mapFindFirst=e;function t(L,E){const N=n(L,E);if(N!==-1)return L[N]}function n(L,E,N=L.length-1){for(let w=N;w>=0;w--){const v=L[w];if(E(v))return w}return-1}function M(L,E){const N=h(L,E);return N===-1?void 0:L[N]}function h(L,E,N=0,w=L.length){let v=N,A=w;for(;v<A;){const d=Math.floor((v+A)/2);E(L[d])?v=d+1:A=d}return v-1}function p(L,E){const N=m(L,E);return N===L.length?void 0:L[N]}function m(L,E,N=0,w=L.length){let v=N,A=w;for(;v<A;){const d=Math.floor((v+A)/2);E(L[d])?A=d:v=d+1}return v}function l(L,E,N=0,w=L.length){const v=m(L,E,N,w);return v===L.length?-1:v}class a{static{this.assertInvariants=!1}constructor(E){this._array=E,this._findLastMonotonousLastIdx=0}findLastMonotonous(E){if(a.assertInvariants){if(this._prevFindLastPredicate){for(const w of this._array)if(this._prevFindLastPredicate(w)&&!E(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=E}const N=h(this._array,E,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=N+1,N===-1?void 0:this._array[N]}}i.MonotonousArray=a;function c(L,E){if(L.length===0)return;let N=L[0];for(let w=1;w<L.length;w++){const v=L[w];E(v,N)>0&&(N=v)}return N}function _(L,E){if(L.length===0)return;let N=L[0];for(let w=1;w<L.length;w++){const v=L[w];E(v,N)>=0&&(N=v)}return N}function g(L,E){return c(L,(N,w)=>-E(N,w))}function b(L,E){if(L.length===0)return-1;let N=0;for(let w=1;w<L.length;w++){const v=L[w];E(v,L[N])>0&&(N=w)}return N}function e(L,E){for(const N of L){const w=E(N);if(w!==void 0)return w}}}),ne(ie[4],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharCode=void 0;var t;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(i.CharCode=t={}))}),ne(ie[37],re([0,1]),function(W,i){"use strict";var t;Object.defineProperty(i,"__esModule",{value:!0}),i.SetWithKey=void 0,i.groupBy=n,i.diffSets=M,i.diffMaps=h,i.intersection=p;function n(l,a){const c=Object.create(null);for(const _ of l){const g=a(_);let b=c[g];b||(b=c[g]=[]),b.push(_)}return c}function M(l,a){const c=[],_=[];for(const g of l)a.has(g)||c.push(g);for(const g of a)l.has(g)||_.push(g);return{removed:c,added:_}}function h(l,a){const c=[],_=[];for(const[g,b]of l)a.has(g)||c.push(b);for(const[g,b]of a)l.has(g)||_.push(b);return{removed:c,added:_}}function p(l,a){const c=new Set;for(const _ of a)l.has(_)&&c.add(_);return c}class m{static{t=Symbol.toStringTag}constructor(a,c){this.toKey=c,this._map=new Map,this[t]="SetWithKey";for(const _ of a)this.add(_)}get size(){return this._map.size}add(a){const c=this.toKey(a);return this._map.set(c,a),this}delete(a){return this._map.delete(this.toKey(a))}has(a){return this._map.has(this.toKey(a))}*entries(){for(const a of this._map.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this._map.values())yield a}clear(){this._map.clear()}forEach(a,c){this._map.forEach(_=>a.call(c,_,_,this))}[Symbol.iterator](){return this.values()}}i.SetWithKey=m}),ne(ie[38],re([0,1,4]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Color=i.HSVA=i.HSLA=i.RGBA=void 0;function n(l,a){const c=Math.pow(10,a);return Math.round(l*c)/c}class M{constructor(a,c,_,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,_))|0,this.a=n(Math.max(Math.min(1,g),0),3)}static equals(a,c){return a.r===c.r&&a.g===c.g&&a.b===c.b&&a.a===c.a}}i.RGBA=M;class h{constructor(a,c,_,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,_),0),3),this.a=n(Math.max(Math.min(1,g),0),3)}static equals(a,c){return a.h===c.h&&a.s===c.s&&a.l===c.l&&a.a===c.a}static fromRGBA(a){const c=a.r/255,_=a.g/255,g=a.b/255,b=a.a,e=Math.max(c,_,g),L=Math.min(c,_,g);let E=0,N=0;const w=(L+e)/2,v=e-L;if(v>0){switch(N=Math.min(w<=.5?v/(2*w):v/(2-2*w),1),e){case c:E=(_-g)/v+(_<g?6:0);break;case _:E=(g-c)/v+2;break;case g:E=(c-_)/v+4;break}E*=60,E=Math.round(E)}return new h(E,N,w,b)}static _hue2rgb(a,c,_){return _<0&&(_+=1),_>1&&(_-=1),_<1/6?a+(c-a)*6*_:_<1/2?c:_<2/3?a+(c-a)*(2/3-_)*6:a}static toRGBA(a){const c=a.h/360,{s:_,l:g,a:b}=a;let e,L,E;if(_===0)e=L=E=g;else{const N=g<.5?g*(1+_):g+_-g*_,w=2*g-N;e=h._hue2rgb(w,N,c+1/3),L=h._hue2rgb(w,N,c),E=h._hue2rgb(w,N,c-1/3)}return new M(Math.round(e*255),Math.round(L*255),Math.round(E*255),b)}}i.HSLA=h;class p{constructor(a,c,_,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,_),0),3),this.a=n(Math.max(Math.min(1,g),0),3)}static equals(a,c){return a.h===c.h&&a.s===c.s&&a.v===c.v&&a.a===c.a}static fromRGBA(a){const c=a.r/255,_=a.g/255,g=a.b/255,b=Math.max(c,_,g),e=Math.min(c,_,g),L=b-e,E=b===0?0:L/b;let N;return L===0?N=0:b===c?N=((_-g)/L%6+6)%6:b===_?N=(g-c)/L+2:N=(c-_)/L+4,new p(Math.round(N*60),E,b,a.a)}static toRGBA(a){const{h:c,s:_,v:g,a:b}=a,e=g*_,L=e*(1-Math.abs(c/60%2-1)),E=g-e;let[N,w,v]=[0,0,0];return c<60?(N=e,w=L):c<120?(N=L,w=e):c<180?(w=e,v=L):c<240?(w=L,v=e):c<300?(N=L,v=e):c<=360&&(N=e,v=L),N=Math.round((N+E)*255),w=Math.round((w+E)*255),v=Math.round((v+E)*255),new M(N,w,v,b)}}i.HSVA=p;class m{static fromHex(a){return m.Format.CSS.parseHex(a)||m.red}static equals(a,c){return!a&&!c?!0:!a||!c?!1:a.equals(c)}get hsla(){return this._hsla?this._hsla:h.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:p.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof M)this.rgba=a;else if(a instanceof h)this._hsla=a,this.rgba=h.toRGBA(a);else if(a instanceof p)this._hsva=a,this.rgba=p.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&M.equals(this.rgba,a.rgba)&&h.equals(this.hsla,a.hsla)&&p.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=m._relativeLuminanceForComponent(this.rgba.r),c=m._relativeLuminanceForComponent(this.rgba.g),_=m._relativeLuminanceForComponent(this.rgba.b),g=.2126*a+.7152*c+.0722*_;return n(g,4)}static _relativeLuminanceForComponent(a){const c=a/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(a){const c=this.getRelativeLuminance(),_=a.getRelativeLuminance();return c>_?(c+.05)/(_+.05):(_+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const c=this.getRelativeLuminance(),_=a.getRelativeLuminance();return c>_}isDarkerThan(a){const c=this.getRelativeLuminance(),_=a.getRelativeLuminance();return c<_}lighten(a){return new m(new h(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new m(new h(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:c,g:_,b:g,a:b}=this.rgba;return new m(new M(c,_,g,b*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new m(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const c=a.rgba,_=this.rgba.a,g=c.a,b=_+g*(1-_);if(b<1e-6)return m.transparent;const e=this.rgba.r*_/b+c.r*g*(1-_)/b,L=this.rgba.g*_/b+c.g*g*(1-_)/b,E=this.rgba.b*_/b+c.b*g*(1-_)/b;return new m(new M(e,L,E,b))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:c,g:_,b:g,a:b}=this.rgba;return new m(new M(a.rgba.r-b*(a.rgba.r-c),a.rgba.g-b*(a.rgba.g-_),a.rgba.b-b*(a.rgba.b-g),1))}flatten(...a){const c=a.reduceRight((_,g)=>m._flatten(g,_));return m._flatten(this,c)}static _flatten(a,c){const _=1-a.rgba.a;return new m(new M(_*c.rgba.r+a.rgba.a*a.rgba.r,_*c.rgba.g+a.rgba.a*a.rgba.g,_*c.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this._toString||(this._toString=m.Format.CSS.format(this)),this._toString}static getLighterColor(a,c,_){if(a.isLighterThan(c))return a;_=_||.5;const g=a.getRelativeLuminance(),b=c.getRelativeLuminance();return _=_*(b-g)/b,a.lighten(_)}static getDarkerColor(a,c,_){if(a.isDarkerThan(c))return a;_=_||.5;const g=a.getRelativeLuminance(),b=c.getRelativeLuminance();return _=_*(g-b)/g,a.darken(_)}static{this.white=new m(new M(255,255,255,1))}static{this.black=new m(new M(0,0,0,1))}static{this.red=new m(new M(255,0,0,1))}static{this.blue=new m(new M(0,0,255,1))}static{this.green=new m(new M(0,255,0,1))}static{this.cyan=new m(new M(0,255,255,1))}static{this.lightgrey=new m(new M(211,211,211,1))}static{this.transparent=new m(new M(0,0,0,0))}}i.Color=m,function(l){let a;(function(c){let _;(function(g){function b(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:l.Format.CSS.formatRGBA(r)}g.formatRGB=b;function e(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}g.formatRGBA=e;function L(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:l.Format.CSS.formatHSLA(r)}g.formatHSL=L;function E(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}g.formatHSLA=E;function N(r){const u=r.toString(16);return u.length!==2?"0"+u:u}function w(r){return`#${N(r.rgba.r)}${N(r.rgba.g)}${N(r.rgba.b)}`}g.formatHex=w;function v(r,u=!1){return u&&r.rgba.a===1?l.Format.CSS.formatHex(r):`#${N(r.rgba.r)}${N(r.rgba.g)}${N(r.rgba.b)}${N(Math.round(r.rgba.a*255))}`}g.formatHexA=v;function A(r){return r.isOpaque()?l.Format.CSS.formatHex(r):l.Format.CSS.formatRGBA(r)}g.format=A;function d(r){const u=r.length;if(u===0||r.charCodeAt(0)!==t.CharCode.Hash)return null;if(u===7){const f=16*o(r.charCodeAt(1))+o(r.charCodeAt(2)),D=16*o(r.charCodeAt(3))+o(r.charCodeAt(4)),R=16*o(r.charCodeAt(5))+o(r.charCodeAt(6));return new l(new M(f,D,R,1))}if(u===9){const f=16*o(r.charCodeAt(1))+o(r.charCodeAt(2)),D=16*o(r.charCodeAt(3))+o(r.charCodeAt(4)),R=16*o(r.charCodeAt(5))+o(r.charCodeAt(6)),S=16*o(r.charCodeAt(7))+o(r.charCodeAt(8));return new l(new M(f,D,R,S/255))}if(u===4){const f=o(r.charCodeAt(1)),D=o(r.charCodeAt(2)),R=o(r.charCodeAt(3));return new l(new M(16*f+f,16*D+D,16*R+R))}if(u===5){const f=o(r.charCodeAt(1)),D=o(r.charCodeAt(2)),R=o(r.charCodeAt(3)),S=o(r.charCodeAt(4));return new l(new M(16*f+f,16*D+D,16*R+R,(16*S+S)/255))}return null}g.parseHex=d;function o(r){switch(r){case t.CharCode.Digit0:return 0;case t.CharCode.Digit1:return 1;case t.CharCode.Digit2:return 2;case t.CharCode.Digit3:return 3;case t.CharCode.Digit4:return 4;case t.CharCode.Digit5:return 5;case t.CharCode.Digit6:return 6;case t.CharCode.Digit7:return 7;case t.CharCode.Digit8:return 8;case t.CharCode.Digit9:return 9;case t.CharCode.a:return 10;case t.CharCode.A:return 10;case t.CharCode.b:return 11;case t.CharCode.B:return 11;case t.CharCode.c:return 12;case t.CharCode.C:return 12;case t.CharCode.d:return 13;case t.CharCode.D:return 13;case t.CharCode.e:return 14;case t.CharCode.E:return 14;case t.CharCode.f:return 15;case t.CharCode.F:return 15}return 0}})(_=c.CSS||(c.CSS={}))})(a=l.Format||(l.Format={}))}(m||(i.Color=m={}))}),ne(ie[39],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiffChange=void 0;class t{constructor(M,h,p,m){this.originalStart=M,this.originalLength=h,this.modifiedStart=p,this.modifiedLength=m}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.DiffChange=t}),ne(ie[5],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.BugIndicatingError=i.ErrorNoTelemetry=i.ExpectedError=i.NotSupportedError=i.NotImplementedError=i.ReadonlyError=i.CancellationError=i.errorHandler=i.ErrorHandler=void 0,i.setUnexpectedErrorHandler=n,i.isSigPipeError=M,i.onUnexpectedError=h,i.onUnexpectedExternalError=p,i.transformErrorForSerialization=m,i.transformErrorFromSerialization=l,i.isCancellationError=c,i.canceled=g,i.illegalArgument=b,i.illegalState=e,i.getErrorMessage=E;class t{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?A.isErrorNoTelemetry(r)?new A(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(u=>{u(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}i.ErrorHandler=t,i.errorHandler=new t;function n(o){i.errorHandler.setUnexpectedErrorHandler(o)}function M(o){if(!o||typeof o!="object")return!1;const r=o;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function h(o){c(o)||i.errorHandler.onUnexpectedError(o)}function p(o){c(o)||i.errorHandler.onUnexpectedExternalError(o)}function m(o){if(o instanceof Error){const{name:r,message:u}=o,f=o.stacktrace||o.stack;return{$isError:!0,name:r,message:u,stack:f,noTelemetry:A.isErrorNoTelemetry(o)}}return o}function l(o){let r;return o.noTelemetry?r=new A:(r=new Error,r.name=o.name),r.message=o.message,r.stack=o.stack,r}const a="Canceled";function c(o){return o instanceof _?!0:o instanceof Error&&o.name===a&&o.message===a}class _ extends Error{constructor(){super(a),this.name=this.message}}i.CancellationError=_;function g(){const o=new Error(a);return o.name=o.message,o}function b(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function e(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class L extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}i.ReadonlyError=L;function E(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class N extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}i.NotImplementedError=N;class w extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}i.NotSupportedError=w;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}i.ExpectedError=v;class A extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof A)return r;const u=new A;return u.message=r.message,u.stack=r.stack,u}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}i.ErrorNoTelemetry=A;class d extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}i.BugIndicatingError=d}),ne(ie[7],re([0,1,5,9]),function(W,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Permutation=i.CallbackIterable=i.ArrayQueue=i.booleanComparator=i.numberComparator=i.CompareResult=void 0,i.tail=M,i.tail2=h,i.equals=p,i.removeFastWithoutKeepingOrder=m,i.binarySearch=l,i.binarySearch2=a,i.quickSelect=c,i.groupBy=_,i.groupAdjacentBy=g,i.forEachAdjacent=b,i.forEachWithNeighbors=e,i.sortedDiff=L,i.delta=E,i.top=N,i.topAsync=w,i.coalesce=A,i.coalesceInPlace=d,i.move=o,i.isFalsyOrEmpty=r,i.isNonEmptyArray=u,i.distinct=f,i.uniqueFilter=D,i.firstOrDefault=R,i.lastOrDefault=S,i.commonPrefixLength=I,i.range=T,i.index=O,i.insert=P,i.remove=y,i.arrayInsert=x,i.shuffle=G,i.pushToStart=U,i.pushToEnd=B,i.pushMany=X,i.mapArrayOrNot=Y,i.asArray=$,i.getRandomElement=Z,i.insertInto=ee,i.splice=F,i.compareBy=oe,i.tieBreakComparators=Le,i.reverseOrder=Pe,i.findAsync=Ue;function M(V,z=0){return V[V.length-(1+z)]}function h(V){if(V.length===0)throw new Error("Invalid tail call");return[V.slice(0,V.length-1),V[V.length-1]]}function p(V,z,H=(Q,K)=>Q===K){if(V===z)return!0;if(!V||!z||V.length!==z.length)return!1;for(let Q=0,K=V.length;Q<K;Q++)if(!H(V[Q],z[Q]))return!1;return!0}function m(V,z){const H=V.length-1;z<H&&(V[z]=V[H]),V.pop()}function l(V,z,H){return a(V.length,Q=>H(V[Q],z))}function a(V,z){let H=0,Q=V-1;for(;H<=Q;){const K=(H+Q)/2|0,he=z(K);if(he<0)H=K+1;else if(he>0)Q=K-1;else return K}return-(H+1)}function c(V,z,H){if(V=V|0,V>=z.length)throw new TypeError("invalid index");const Q=z[Math.floor(z.length*Math.random())],K=[],he=[],be=[];for(const ve of z){const we=H(ve,Q);we<0?K.push(ve):we>0?he.push(ve):be.push(ve)}return V<K.length?c(V,K,H):V<K.length+be.length?be[0]:c(V-(K.length+be.length),he,H)}function _(V,z){const H=[];let Q;for(const K of V.slice(0).sort(z))!Q||z(Q[0],K)!==0?(Q=[K],H.push(Q)):Q.push(K);return H}function*g(V,z){let H,Q;for(const K of V)Q!==void 0&&z(Q,K)?H.push(K):(H&&(yield H),H=[K]),Q=K;H&&(yield H)}function b(V,z){for(let H=0;H<=V.length;H++)z(H===0?void 0:V[H-1],H===V.length?void 0:V[H])}function e(V,z){for(let H=0;H<V.length;H++)z(H===0?void 0:V[H-1],V[H],H+1===V.length?void 0:V[H+1])}function L(V,z,H){const Q=[];function K(ve,we,Re){if(we===0&&Re.length===0)return;const se=Q[Q.length-1];se&&se.start+se.deleteCount===ve?(se.deleteCount+=we,se.toInsert.push(...Re)):Q.push({start:ve,deleteCount:we,toInsert:Re})}let he=0,be=0;for(;;){if(he===V.length){K(he,0,z.slice(be));break}if(be===z.length){K(he,V.length-he,[]);break}const ve=V[he],we=z[be],Re=H(ve,we);Re===0?(he+=1,be+=1):Re<0?(K(he,1,[]),he+=1):Re>0&&(K(he,0,[we]),be+=1)}return Q}function E(V,z,H){const Q=L(V,z,H),K=[],he=[];for(const be of Q)K.push(...V.slice(be.start,be.start+be.deleteCount)),he.push(...be.toInsert);return{removed:K,added:he}}function N(V,z,H){if(H===0)return[];const Q=V.slice(0,H).sort(z);return v(V,z,Q,H,V.length),Q}function w(V,z,H,Q,K){return H===0?Promise.resolve([]):new Promise((he,be)=>{(async()=>{const ve=V.length,we=V.slice(0,H).sort(z);for(let Re=H,se=Math.min(H+Q,ve);Re<ve;Re=se,se=Math.min(se+Q,ve)){if(Re>H&&await new Promise(te=>setTimeout(te)),K&&K.isCancellationRequested)throw new t.CancellationError;v(V,z,we,Re,se)}return we})().then(he,be)})}function v(V,z,H,Q,K){for(const he=H.length;Q<K;Q++){const be=V[Q];if(z(be,H[he-1])<0){H.pop();const ve=(0,n.findFirstIdxMonotonousOrArrLen)(H,we=>z(be,we)<0);H.splice(ve,0,be)}}}function A(V){return V.filter(z=>!!z)}function d(V){let z=0;for(let H=0;H<V.length;H++)V[H]&&(V[z]=V[H],z+=1);V.length=z}function o(V,z,H){V.splice(H,0,V.splice(z,1)[0])}function r(V){return!Array.isArray(V)||V.length===0}function u(V){return Array.isArray(V)&&V.length>0}function f(V,z=H=>H){const H=new Set;return V.filter(Q=>{const K=z(Q);return H.has(K)?!1:(H.add(K),!0)})}function D(V){const z=new Set;return H=>{const Q=V(H);return z.has(Q)?!1:(z.add(Q),!0)}}function R(V,z){return V.length>0?V[0]:z}function S(V,z){return V.length>0?V[V.length-1]:z}function I(V,z,H=(Q,K)=>Q===K){let Q=0;for(let K=0,he=Math.min(V.length,z.length);K<he&&H(V[K],z[K]);K++)Q++;return Q}function T(V,z){let H=typeof z=="number"?V:0;typeof z=="number"?H=V:(H=0,z=V);const Q=[];if(H<=z)for(let K=H;K<z;K++)Q.push(K);else for(let K=H;K>z;K--)Q.push(K);return Q}function O(V,z,H){return V.reduce((Q,K)=>(Q[z(K)]=H?H(K):K,Q),Object.create(null))}function P(V,z){return V.push(z),()=>y(V,z)}function y(V,z){const H=V.indexOf(z);if(H>-1)return V.splice(H,1),z}function x(V,z,H){const Q=V.slice(0,z),K=V.slice(z);return Q.concat(H,K)}function G(V,z){let H;if(typeof z=="number"){let Q=z;H=()=>{const K=Math.sin(Q++)*179426549;return K-Math.floor(K)}}else H=Math.random;for(let Q=V.length-1;Q>0;Q-=1){const K=Math.floor(H()*(Q+1)),he=V[Q];V[Q]=V[K],V[K]=he}}function U(V,z){const H=V.indexOf(z);H>-1&&(V.splice(H,1),V.unshift(z))}function B(V,z){const H=V.indexOf(z);H>-1&&(V.splice(H,1),V.push(z))}function X(V,z){for(const H of z)V.push(H)}function Y(V,z){return Array.isArray(V)?V.map(z):z(V)}function $(V){return Array.isArray(V)?V:[V]}function Z(V){return V[Math.floor(Math.random()*V.length)]}function ee(V,z,H){const Q=C(V,z),K=V.length,he=H.length;V.length=K+he;for(let be=K-1;be>=Q;be--)V[be+he]=V[be];for(let be=0;be<he;be++)V[be+Q]=H[be]}function F(V,z,H,Q){const K=C(V,z);let he=V.splice(K,H);return he===void 0&&(he=[]),ee(V,K,Q),he}function C(V,z){return z<0?Math.max(z+V.length,0):Math.min(z,V.length)}var ce;(function(V){function z(he){return he<0}V.isLessThan=z;function H(he){return he<=0}V.isLessThanOrEqual=H;function Q(he){return he>0}V.isGreaterThan=Q;function K(he){return he===0}V.isNeitherLessOrGreaterThan=K,V.greaterThan=1,V.lessThan=-1,V.neitherLessOrGreaterThan=0})(ce||(i.CompareResult=ce={}));function oe(V,z){return(H,Q)=>z(V(H),V(Q))}function Le(...V){return(z,H)=>{for(const Q of V){const K=Q(z,H);if(!ce.isNeitherLessOrGreaterThan(K))return K}return ce.neitherLessOrGreaterThan}}const s=(V,z)=>V-z;i.numberComparator=s;const Se=(V,z)=>(0,i.numberComparator)(V?1:0,z?1:0);i.booleanComparator=Se;function Pe(V){return(z,H)=>-V(z,H)}class ze{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let H=this.firstIdx;for(;H<this.items.length&&z(this.items[H]);)H++;const Q=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,Q}takeFromEndWhile(z){let H=this.lastIdx;for(;H>=0&&z(this.items[H]);)H--;const Q=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,Q}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const H=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,H}}i.ArrayQueue=ze;class Te{static{this.empty=new Te(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(H=>(z(H),!0))}toArray(){const z=[];return this.iterate(H=>(z.push(H),!0)),z}filter(z){return new Te(H=>this.iterate(Q=>z(Q)?H(Q):!0))}map(z){return new Te(H=>this.iterate(Q=>H(z(Q))))}some(z){let H=!1;return this.iterate(Q=>(H=z(Q),!H)),H}findFirst(z){let H;return this.iterate(Q=>z(Q)?(H=Q,!1):!0),H}findLast(z){let H;return this.iterate(Q=>(z(Q)&&(H=Q),!0)),H}findLastMaxBy(z){let H,Q=!0;return this.iterate(K=>((Q||ce.isGreaterThan(z(K,H)))&&(Q=!1,H=K),!0)),H}}i.CallbackIterable=Te;class qe{constructor(z){this._indexMap=z}static createSortPermutation(z,H){const Q=Array.from(z.keys()).sort((K,he)=>H(z[K],z[he]));return new qe(Q)}apply(z){return z.map((H,Q)=>z[this._indexMap[Q]])}inverse(){const z=this._indexMap.slice();for(let H=0;H<this._indexMap.length;H++)z[this._indexMap[H]]=H;return new qe(z)}}i.Permutation=qe;async function Ue(V,z){return(await Promise.all(V.map(async(Q,K)=>({element:Q,ok:await z(Q,K)})))).find(Q=>Q.ok)?.element}}),ne(ie[11],re([0,1,5]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=n,i.assertNever=M,i.assert=h,i.softAssert=p,i.assertFn=m,i.checkAdjacentItems=l;function n(a,c){if(!a)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function M(a,c="Unreachable"){throw new Error(c)}function h(a,c="unexpected state"){if(!a)throw new t.BugIndicatingError(`Assertion Failed: ${c}`)}function p(a){a||(0,t.onUnexpectedError)(new t.BugIndicatingError("Soft Assertion Failed"))}function m(a){if(!a()){debugger;a(),(0,t.onUnexpectedError)(new t.BugIndicatingError("Assertion Failed"))}}function l(a,c){let _=0;for(;_<a.length-1;){const g=a[_],b=a[_+1];if(!c(g,b))return!1;_++}return!0}}),ne(ie[22],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createSingleCallFunction=t;function t(n,M){const h=this;let p=!1,m;return function(){if(p)return m;if(p=!0,M)try{m=n.apply(h,arguments)}finally{M()}else m=n.apply(h,arguments);return m}}}),ne(ie[23],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var t;(function(n){function M(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=M;const h=Object.freeze([]);function p(){return h}n.empty=p;function*m(r){yield r}n.single=m;function l(r){return M(r)?r:m(r)}n.wrap=l;function a(r){return r||h}n.from=a;function*c(r){for(let u=r.length-1;u>=0;u--)yield r[u]}n.reverse=c;function _(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=_;function g(r){return r[Symbol.iterator]().next().value}n.first=g;function b(r,u){let f=0;for(const D of r)if(u(D,f++))return!0;return!1}n.some=b;function e(r,u){for(const f of r)if(u(f))return f}n.find=e;function*L(r,u){for(const f of r)u(f)&&(yield f)}n.filter=L;function*E(r,u){let f=0;for(const D of r)yield u(D,f++)}n.map=E;function*N(r,u){let f=0;for(const D of r)yield*u(D,f++)}n.flatMap=N;function*w(...r){for(const u of r)yield*u}n.concat=w;function v(r,u,f){let D=f;for(const R of r)D=u(D,R);return D}n.reduce=v;function*A(r,u,f=r.length){for(u<0&&(u+=r.length),f<0?f+=r.length:f>r.length&&(f=r.length);u<f;u++)yield r[u]}n.slice=A;function d(r,u=Number.POSITIVE_INFINITY){const f=[];if(u===0)return[f,r];const D=r[Symbol.iterator]();for(let R=0;R<u;R++){const S=D.next();if(S.done)return[f,n.empty()];f.push(S.value)}return[f,{[Symbol.iterator](){return D}}]}n.consume=d;async function o(r){const u=[];for await(const f of r)u.push(f);return Promise.resolve(u)}n.asyncToArray=o})(t||(i.Iterable=t={}))}),ne(ie[40],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=i.KeyCodeUtils=i.IMMUTABLE_KEY_CODE_TO_CODE=i.IMMUTABLE_CODE_TO_KEY_CODE=i.ScanCodeUtils=i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=i.EVENT_KEY_CODE_MAP=i.ScanCode=i.KeyCode=void 0,i.KeyChord=b;var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(t||(i.KeyCode=t={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(i.ScanCode=n={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(L,E){this._keyCodeToStr[L]=E,this._strToKeyCode[E.toLowerCase()]=L}keyCodeToStr(L){return this._keyCodeToStr[L]}strToKeyCode(L){return this._strToKeyCode[L.toLowerCase()]||t.Unknown}}const h=new M,p=new M,m=new M;i.EVENT_KEY_CODE_MAP=new Array(230),i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const l=[],a=Object.create(null),c=Object.create(null);i.ScanCodeUtils={lowerCaseToEnum:e=>c[e]||n.None,toEnum:e=>a[e]||n.None,toString:e=>l[e]||"None"},i.IMMUTABLE_CODE_TO_KEY_CODE=[],i.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=n.MAX_VALUE;e++)i.IMMUTABLE_CODE_TO_KEY_CODE[e]=t.DependsOnKbLayout;for(let e=0;e<=t.MAX_VALUE;e++)i.IMMUTABLE_KEY_CODE_TO_CODE[e]=n.DependsOnKbLayout;(function(){const e="",L=[[1,n.None,"None",t.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",t.Unknown,e,0,e,e,e],[1,n.Super,"Super",t.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",t.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",t.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",t.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",t.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",t.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",t.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",t.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",t.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",t.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",t.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",t.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",t.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",t.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",t.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",t.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",t.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",t.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",t.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",t.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",t.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",t.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",t.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",t.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",t.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",t.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",t.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",t.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",t.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",t.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",t.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",t.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",t.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",t.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",t.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",t.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",t.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",t.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",t.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",t.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",t.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",t.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",t.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",t.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",t.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",t.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",t.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",t.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",t.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",t.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",t.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",t.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",t.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",t.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",t.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",t.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",t.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",t.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",t.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",t.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",t.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",t.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",t.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",t.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",t.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",t.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",t.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",t.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",t.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",t.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",t.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",t.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",t.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",t.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",t.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",t.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",t.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",t.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",t.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",t.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",t.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",t.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",t.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",t.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",t.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",t.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",t.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",t.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",t.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",t.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",t.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",t.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",t.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",t.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",t.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",t.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",t.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",t.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",t.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",t.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",t.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",t.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",t.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",t.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",t.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",t.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",t.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",t.Unknown,e,0,e,e,e],[1,n.F13,"F13",t.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",t.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",t.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",t.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",t.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",t.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",t.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",t.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",t.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",t.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",t.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",t.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",t.Unknown,e,0,e,e,e],[1,n.Help,"Help",t.Unknown,e,0,e,e,e],[1,n.Select,"Select",t.Unknown,e,0,e,e,e],[1,n.Again,"Again",t.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",t.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",t.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",t.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",t.Unknown,e,0,e,e,e],[1,n.Find,"Find",t.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",t.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",t.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",t.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",t.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",t.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",t.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",t.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",t.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",t.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",t.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",t.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",t.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",t.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",t.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",t.Unknown,e,0,e,e,e],[1,n.Props,"Props",t.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",t.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",t.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",t.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",t.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",t.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",t.Unknown,e,0,e,e,e],[1,n.None,e,t.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,t.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,t.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,t.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",t.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",t.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",t.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",t.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",t.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",t.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",t.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",t.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",t.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",t.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",t.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",t.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",t.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",t.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",t.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",t.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",t.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",t.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",t.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",t.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",t.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",t.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",t.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",t.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",t.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",t.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",t.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",t.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",t.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",t.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",t.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",t.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",t.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",t.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",t.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",t.Unknown,e,0,e,e,e],[1,n.None,e,t.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,t.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,t.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,t.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,t.Unknown,e,0,"VK_OEM_CLEAR",e,e]],E=[],N=[];for(const w of L){const[v,A,d,o,r,u,f,D,R]=w;if(N[A]||(N[A]=!0,l[A]=d,a[d]=A,c[d.toLowerCase()]=A,v&&(i.IMMUTABLE_CODE_TO_KEY_CODE[A]=o,o!==t.Unknown&&o!==t.Enter&&o!==t.Ctrl&&o!==t.Shift&&o!==t.Alt&&o!==t.Meta&&(i.IMMUTABLE_KEY_CODE_TO_CODE[o]=A))),!E[o]){if(E[o]=!0,!r)throw new Error(`String representation missing for key code ${o} around scan code ${d}`);h.define(o,r),p.define(o,D||r),m.define(o,R||D||r)}u&&(i.EVENT_KEY_CODE_MAP[u]=o),f&&(i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[f]=o)}i.IMMUTABLE_KEY_CODE_TO_CODE[t.Enter]=n.Enter})();var _;(function(e){function L(d){return h.keyCodeToStr(d)}e.toString=L;function E(d){return h.strToKeyCode(d)}e.fromString=E;function N(d){return p.keyCodeToStr(d)}e.toUserSettingsUS=N;function w(d){return m.keyCodeToStr(d)}e.toUserSettingsGeneral=w;function v(d){return p.strToKeyCode(d)||m.strToKeyCode(d)}e.fromUserSettings=v;function A(d){if(d>=t.Numpad0&&d<=t.NumpadDivide)return null;switch(d){case t.UpArrow:return"Up";case t.DownArrow:return"Down";case t.LeftArrow:return"Left";case t.RightArrow:return"Right"}return h.keyCodeToStr(d)}e.toElectronAccelerator=A})(_||(i.KeyCodeUtils=_={}));var g;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(g||(i.KeyMod=g={}));function b(e,L){const E=(L&65535)<<16>>>0;return(e|E)>>>0}}),ne(ie[41],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Lazy=void 0;class t{constructor(M){this.executor=M,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(M){this._error=M}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}i.Lazy=t}),ne(ie[24],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LinkedList=void 0;class t{static{this.Undefined=new t(void 0)}constructor(h){this.element=h,this.next=t.Undefined,this.prev=t.Undefined}}class n{constructor(){this._first=t.Undefined,this._last=t.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===t.Undefined}clear(){let h=this._first;for(;h!==t.Undefined;){const p=h.next;h.prev=t.Undefined,h.next=t.Undefined,h=p}this._first=t.Undefined,this._last=t.Undefined,this._size=0}unshift(h){return this._insert(h,!1)}push(h){return this._insert(h,!0)}_insert(h,p){const m=new t(h);if(this._first===t.Undefined)this._first=m,this._last=m;else if(p){const a=this._last;this._last=m,m.prev=a,a.next=m}else{const a=this._first;this._first=m,m.next=a,a.prev=m}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(m))}}shift(){if(this._first!==t.Undefined){const h=this._first.element;return this._remove(this._first),h}}pop(){if(this._last!==t.Undefined){const h=this._last.element;return this._remove(this._last),h}}_remove(h){if(h.prev!==t.Undefined&&h.next!==t.Undefined){const p=h.prev;p.next=h.next,h.next.prev=p}else h.prev===t.Undefined&&h.next===t.Undefined?(this._first=t.Undefined,this._last=t.Undefined):h.next===t.Undefined?(this._last=this._last.prev,this._last.next=t.Undefined):h.prev===t.Undefined&&(this._first=this._first.next,this._first.prev=t.Undefined);this._size-=1}*[Symbol.iterator](){let h=this._first;for(;h!==t.Undefined;)yield h.element,h=h.next}}i.LinkedList=n}),ne(ie[16],re([0,1]),function(W,i){"use strict";var t,n,M;Object.defineProperty(i,"__esModule",{value:!0}),i.SetMap=i.BidirectionalMap=i.CounterSet=i.MRUCache=i.LRUCache=i.LinkedMap=i.Touch=i.ResourceSet=i.ResourceMap=void 0,i.getOrSet=h,i.mapToString=p,i.setToString=m,i.mapsStrictEqualIgnoreOrder=A;function h(d,o,r){let u=d.get(o);return u===void 0&&(u=r,d.set(o,u)),u}function p(d){const o=[];return d.forEach((r,u)=>{o.push(`${u} => ${r}`)}),`Map(${d.size}) {${o.join(", ")}}`}function m(d){const o=[];return d.forEach(r=>{o.push(r)}),`Set(${d.size}) {${o.join(", ")}}`}class l{constructor(o,r){this.uri=o,this.value=r}}function a(d){return Array.isArray(d)}class c{static{this.defaultToKey=o=>o.toString()}constructor(o,r){if(this[t]="ResourceMap",o instanceof c)this.map=new Map(o.map),this.toKey=r??c.defaultToKey;else if(a(o)){this.map=new Map,this.toKey=r??c.defaultToKey;for(const[u,f]of o)this.set(u,f)}else this.map=new Map,this.toKey=o??c.defaultToKey}set(o,r){return this.map.set(this.toKey(o),new l(o,r)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,r){typeof r<"u"&&(o=o.bind(r));for(const[u,f]of this.map)o(f.value,f.uri,this)}*values(){for(const o of this.map.values())yield o.value}*keys(){for(const o of this.map.values())yield o.uri}*entries(){for(const o of this.map.values())yield[o.uri,o.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.map)yield[o.uri,o.value]}}i.ResourceMap=c;class _{constructor(o,r){this[n]="ResourceSet",!o||typeof o=="function"?this._map=new c(o):(this._map=new c(r),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,r){this._map.forEach((u,f)=>o.call(r,f,f,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}i.ResourceSet=_;var g;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(g||(i.Touch=g={}));class b{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,r=g.None){const u=this._map.get(o);if(u)return r!==g.None&&this.touch(u,r),u.value}set(o,r,u=g.None){let f=this._map.get(o);if(f)f.value=r,u!==g.None&&this.touch(f,u);else{switch(f={key:o,value:r,next:void 0,previous:void 0},u){case g.None:this.addItemLast(f);break;case g.AsOld:this.addItemFirst(f);break;case g.AsNew:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(o,f),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const r=this._map.get(o);if(r)return this._map.delete(o),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,r){const u=this._state;let f=this._head;for(;f;){if(r?o.bind(r)(f.value,f.key,this):o(f.value,f.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const o=this,r=this._state;let u=this._head;const f={[Symbol.iterator](){return f},next(){if(o._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const D={value:u.key,done:!1};return u=u.next,D}else return{value:void 0,done:!0}}};return f}values(){const o=this,r=this._state;let u=this._head;const f={[Symbol.iterator](){return f},next(){if(o._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const D={value:u.value,done:!1};return u=u.next,D}else return{value:void 0,done:!0}}};return f}entries(){const o=this,r=this._state;let u=this._head;const f={[Symbol.iterator](){return f},next(){if(o._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const D={value:[u.key,u.value],done:!1};return u=u.next,D}else return{value:void 0,done:!0}}};return f}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let r=this._head,u=this.size;for(;r&&u>o;)this._map.delete(r.key),r=r.next,u--;this._head=r,this._size=u,r&&(r.previous=void 0),this._state++}trimNew(o){if(o>=this.size)return;if(o===0){this.clear();return}let r=this._tail,u=this.size;for(;r&&u>o;)this._map.delete(r.key),r=r.previous,u--;this._tail=r,this._size=u,r&&(r.next=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const r=o.next,u=o.previous;if(!r||!u)throw new Error("Invalid list");r.previous=u,u.next=r}o.next=void 0,o.previous=void 0,this._state++}touch(o,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==g.AsOld&&r!==g.AsNew)){if(r===g.AsOld){if(o===this._head)return;const u=o.next,f=o.previous;o===this._tail?(f.next=void 0,this._tail=f):(u.previous=f,f.next=u),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(r===g.AsNew){if(o===this._tail)return;const u=o.next,f=o.previous;o===this._head?(u.previous=void 0,this._head=u):(u.previous=f,f.next=u),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((r,u)=>{o.push([u,r])}),o}fromJSON(o){this.clear();for(const[r,u]of o)this.set(r,u)}}i.LinkedMap=b;class e extends b{constructor(o,r=1){super(),this._limit=o,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,r=g.AsNew){return super.get(o,r)}peek(o){return super.get(o,g.None)}set(o,r){return super.set(o,r,g.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class L extends e{constructor(o,r=1){super(o,r)}trim(o){this.trimOld(o)}set(o,r){return super.set(o,r),this.checkTrim(),this}}i.LRUCache=L;class E extends e{constructor(o,r=1){super(o,r)}trim(o){this.trimNew(o)}set(o,r){return this._limit<=this.size&&!this.has(o)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(o,r),this}}i.MRUCache=E;class N{constructor(){this.map=new Map}add(o){return this.map.set(o,(this.map.get(o)||0)+1),this}delete(o){let r=this.map.get(o)||0;return r===0?!1:(r--,r===0?this.map.delete(o):this.map.set(o,r),!0)}has(o){return this.map.has(o)}}i.CounterSet=N;class w{constructor(o){if(this._m1=new Map,this._m2=new Map,o)for(const[r,u]of o)this.set(r,u)}clear(){this._m1.clear(),this._m2.clear()}set(o,r){this._m1.set(o,r),this._m2.set(r,o)}get(o){return this._m1.get(o)}getKey(o){return this._m2.get(o)}delete(o){const r=this._m1.get(o);return r===void 0?!1:(this._m1.delete(o),this._m2.delete(r),!0)}forEach(o,r){this._m1.forEach((u,f)=>{o.call(r,u,f,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}i.BidirectionalMap=w;class v{constructor(){this.map=new Map}add(o,r){let u=this.map.get(o);u||(u=new Set,this.map.set(o,u)),u.add(r)}delete(o,r){const u=this.map.get(o);u&&(u.delete(r),u.size===0&&this.map.delete(o))}forEach(o,r){const u=this.map.get(o);u&&u.forEach(r)}get(o){const r=this.map.get(o);return r||new Set}}i.SetMap=v;function A(d,o){if(d===o)return!0;if(d.size!==o.size)return!1;for(const[r,u]of d)if(!o.has(r)||o.get(r)!==u)return!1;for(const[r]of o)if(!d.has(r))return!1;return!0}}),ne(ie[12],re([0,1,7,37,16,22,23]),function(W,i,t,n,M,h,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DisposableMap=i.ImmortalReference=i.AsyncReferenceCollection=i.ReferenceCollection=i.SafeDisposable=i.RefCountedDisposable=i.MandatoryMutableDisposable=i.MutableDisposable=i.Disposable=i.DisposableStore=i.DisposableTracker=void 0,i.setDisposableTracker=c,i.trackDisposable=_,i.markAsDisposed=g,i.markAsSingleton=L,i.isDisposable=E,i.dispose=N,i.disposeIfDisposable=w,i.combinedDisposable=v,i.toDisposable=A,i.disposeOnReturn=T;const m=!1;let l=null;class a{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(y){let x=this.livingDisposables.get(y);return x||(x={parent:null,source:null,isSingleton:!1,value:y,idx:a.idx++},this.livingDisposables.set(y,x)),x}trackDisposable(y){const x=this.getDisposableData(y);x.source||(x.source=new Error().stack)}setParent(y,x){const G=this.getDisposableData(y);G.parent=x}markAsDisposed(y){this.livingDisposables.delete(y)}markAsSingleton(y){this.getDisposableData(y).isSingleton=!0}getRootParent(y,x){const G=x.get(y);if(G)return G;const U=y.parent?this.getRootParent(this.getDisposableData(y.parent),x):y;return x.set(y,U),U}getTrackedDisposables(){const y=new Map;return[...this.livingDisposables.entries()].filter(([,G])=>G.source!==null&&!this.getRootParent(G,y).isSingleton).flatMap(([G])=>G)}computeLeakingDisposables(y=10,x){let G;if(x)G=x;else{const $=new Map,Z=[...this.livingDisposables.values()].filter(F=>F.source!==null&&!this.getRootParent(F,$).isSingleton);if(Z.length===0)return;const ee=new Set(Z.map(F=>F.value));if(G=Z.filter(F=>!(F.parent&&ee.has(F.parent))),G.length===0)throw new Error("There are cyclic diposable chains!")}if(!G)return;function U($){function Z(F,C){for(;F.length>0&&C.some(ce=>typeof ce=="string"?ce===F[0]:F[0].match(ce));)F.shift()}const ee=$.source.split(`
`).map(F=>F.trim().replace("at ","")).filter(F=>F!=="");return Z(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const B=new M.SetMap;for(const $ of G){const Z=U($);for(let ee=0;ee<=Z.length;ee++)B.add(Z.slice(0,ee).join(`
`),$)}G.sort((0,t.compareBy)($=>$.idx,t.numberComparator));let X="",Y=0;for(const $ of G.slice(0,y)){Y++;const Z=U($),ee=[];for(let F=0;F<Z.length;F++){let C=Z[F];C=`(shared with ${B.get(Z.slice(0,F+1).join(`
`)).size}/${G.length} leaks) at ${C}`;const oe=B.get(Z.slice(0,F).join(`
`)),Le=(0,n.groupBy)([...oe].map(s=>U(s)[F]),s=>s);delete Le[Z[F]];for(const[s,Se]of Object.entries(Le))ee.unshift(`    - stacktraces of ${Se.length} other leaks continue with ${s}`);ee.unshift(C)}X+=`


==================== Leaking disposable ${Y}/${G.length}: ${$.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return G.length>y&&(X+=`


... and ${G.length-y} more leaking disposables

`),{leaks:G,details:X}}}i.DisposableTracker=a;function c(P){l=P}if(m){const P="__is_disposable_tracked__";c(new class{trackDisposable(y){const x=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[P]||console.log(x)},3e3)}setParent(y,x){if(y&&y!==o.None)try{y[P]=!0}catch{}}markAsDisposed(y){if(y&&y!==o.None)try{y[P]=!0}catch{}}markAsSingleton(y){}})}function _(P){return l?.trackDisposable(P),P}function g(P){l?.markAsDisposed(P)}function b(P,y){l?.setParent(P,y)}function e(P,y){if(l)for(const x of P)l.setParent(x,y)}function L(P){return l?.markAsSingleton(P),P}function E(P){return typeof P=="object"&&P!==null&&typeof P.dispose=="function"&&P.dispose.length===0}function N(P){if(p.Iterable.is(P)){const y=[];for(const x of P)if(x)try{x.dispose()}catch(G){y.push(G)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}function w(P){for(const y of P)E(y)&&y.dispose();return[]}function v(...P){const y=A(()=>N(P));return e(P,y),y}function A(P){const y=_({dispose:(0,h.createSingleCallFunction)(()=>{g(y),P()})});return y}class d{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{N(this._toDispose)}finally{this._toDispose.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return b(y,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(y),y.dispose()}}deleteAndLeak(y){y&&this._toDispose.has(y)&&(this._toDispose.delete(y),b(y,null))}}i.DisposableStore=d;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new d,_(this),b(this._store,this)}dispose(){g(this),this._store.dispose()}_register(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(y)}}i.Disposable=o;class r{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(y){this._isDisposed||y===this._value||(this._value?.dispose(),y&&b(y,this),this._value=y)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const y=this._value;return this._value=void 0,y&&b(y,null),y}}i.MutableDisposable=r;class u{constructor(y){this._disposable=new r,this._isDisposed=!1,this._disposable.value=y}get value(){return this._disposable.value}set value(y){this._isDisposed||y===this._disposable.value||(this._disposable.value=y)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}i.MandatoryMutableDisposable=u;class f{constructor(y){this._disposable=y,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}i.RefCountedDisposable=f;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(y){let x=y;return this.unset=()=>x=void 0,this.isset=()=>x!==void 0,this.dispose=()=>{x&&(x(),x=void 0,g(this))},this}}i.SafeDisposable=D;class R{constructor(){this.references=new Map}acquire(y,...x){let G=this.references.get(y);G||(G={counter:0,object:this.createReferencedObject(y,...x)},this.references.set(y,G));const{object:U}=G,B=(0,h.createSingleCallFunction)(()=>{--G.counter===0&&(this.destroyReferencedObject(y,G.object),this.references.delete(y))});return G.counter++,{object:U,dispose:B}}}i.ReferenceCollection=R;class S{constructor(y){this.referenceCollection=y}async acquire(y,...x){const G=this.referenceCollection.acquire(y,...x);try{return{object:await G.object,dispose:()=>G.dispose()}}catch(U){throw G.dispose(),U}}}i.AsyncReferenceCollection=S;class I{constructor(y){this.object=y}dispose(){}}i.ImmortalReference=I;function T(P){const y=new d;try{P(y)}finally{y.dispose()}}class O{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){g(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{N(this._store.values())}finally{this._store.clear()}}has(y){return this._store.has(y)}get size(){return this._store.size}get(y){return this._store.get(y)}set(y,x,G=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),G||this._store.get(y)?.dispose(),this._store.set(y,x)}deleteAndDispose(y){this._store.get(y)?.dispose(),this._store.delete(y)}deleteAndLeak(y){const x=this._store.get(y);return this._store.delete(y),x}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}i.DisposableMap=O}),ne(ie[42],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MarshalledId=void 0;var t;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(i.MarshalledId=t={}))}),ne(ie[17],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isAndroid=i.isEdge=i.isSafari=i.isFirefox=i.isChrome=i.OS=i.OperatingSystem=i.setTimeout0=i.setTimeout0IsFaster=i.translationsConfigFile=i.platformLocale=i.locale=i.Language=i.language=i.userAgent=i.platform=i.isCI=i.isMobile=i.isIOS=i.webWorkerOrigin=i.isWebWorker=i.isWeb=i.isElectron=i.isNative=i.isLinuxSnap=i.isLinux=i.isMacintosh=i.isWindows=i.Platform=i.LANGUAGE_DEFAULT=void 0,i.PlatformToString=o,i.isLittleEndian=S,i.isBigSurOrNewer=I,i.LANGUAGE_DEFAULT="en";let t=!1,n=!1,M=!1,h=!1,p=!1,m=!1,l=!1,a=!1,c=!1,_=!1,g,b=i.LANGUAGE_DEFAULT,e=i.LANGUAGE_DEFAULT,L,E;const N=globalThis;let w;typeof N.vscode<"u"&&typeof N.vscode.process<"u"?w=N.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const v=typeof w?.versions?.electron=="string",A=v&&w?.type==="renderer";if(typeof w=="object"){t=w.platform==="win32",n=w.platform==="darwin",M=w.platform==="linux",h=M&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,l=v,c=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=i.LANGUAGE_DEFAULT,b=i.LANGUAGE_DEFAULT;const T=w.env.VSCODE_NLS_CONFIG;if(T)try{const O=JSON.parse(T);g=O.userLocale,e=O.osLocale,b=O.resolvedLanguage||i.LANGUAGE_DEFAULT,L=O.languagePack?.translationsConfigFile}catch{}p=!0}else typeof navigator=="object"&&!A?(E=navigator.userAgent,t=E.indexOf("Windows")>=0,n=E.indexOf("Macintosh")>=0,a=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=E.indexOf("Linux")>=0,_=E?.indexOf("Mobi")>=0,m=!0,b=globalThis._VSCODE_NLS_LANGUAGE||i.LANGUAGE_DEFAULT,g=navigator.language.toLowerCase(),e=g):console.error("Unable to resolve platform.");var d;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(d||(i.Platform=d={}));function o(T){switch(T){case d.Web:return"Web";case d.Mac:return"Mac";case d.Linux:return"Linux";case d.Windows:return"Windows"}}let r=d.Web;n?r=d.Mac:t?r=d.Windows:M&&(r=d.Linux),i.isWindows=t,i.isMacintosh=n,i.isLinux=M,i.isLinuxSnap=h,i.isNative=p,i.isElectron=l,i.isWeb=m,i.isWebWorker=m&&typeof N.importScripts=="function",i.webWorkerOrigin=i.isWebWorker?N.origin:void 0,i.isIOS=a,i.isMobile=_,i.isCI=c,i.platform=r,i.userAgent=E,i.language=b;var u;(function(T){function O(){return i.language}T.value=O;function P(){return i.language.length===2?i.language==="en":i.language.length>=3?i.language[0]==="e"&&i.language[1]==="n"&&i.language[2]==="-":!1}T.isDefaultVariant=P;function y(){return i.language==="en"}T.isDefault=y})(u||(i.Language=u={})),i.locale=g,i.platformLocale=e,i.translationsConfigFile=L,i.setTimeout0IsFaster=typeof N.postMessage=="function"&&!N.importScripts,i.setTimeout0=(()=>{if(i.setTimeout0IsFaster){const T=[];N.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let y=0,x=T.length;y<x;y++){const G=T[y];if(G.id===P.data.vscodeScheduleAsyncWork){T.splice(y,1),G.callback();return}}});let O=0;return P=>{const y=++O;T.push({id:y,callback:P}),N.postMessage({vscodeScheduleAsyncWork:y},"*")}}return T=>setTimeout(T)})();var f;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(f||(i.OperatingSystem=f={})),i.OS=n||a?f.Macintosh:t?f.Windows:f.Linux;let D=!0,R=!1;function S(){if(!R){R=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,D=new Uint16Array(T.buffer)[0]===513}return D}i.isChrome=!!(i.userAgent&&i.userAgent.indexOf("Chrome")>=0),i.isFirefox=!!(i.userAgent&&i.userAgent.indexOf("Firefox")>=0),i.isSafari=!!(!i.isChrome&&i.userAgent&&i.userAgent.indexOf("Safari")>=0),i.isEdge=!!(i.userAgent&&i.userAgent.indexOf("Edg/")>=0),i.isAndroid=!!(i.userAgent&&i.userAgent.indexOf("Android")>=0);function I(T){return parseFloat(T)>=20}}),ne(ie[43],re([0,1,17]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.arch=i.platform=i.env=i.cwd=void 0;let n;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const h=M.process;n={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return t.isWindows?"win32":t.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=n.cwd,i.env=n.env,i.platform=n.platform,i.arch=n.arch});var Je=this&&this.__createBinding||(Object.create?function(W,i,t,n){n===void 0&&(n=t);var M=Object.getOwnPropertyDescriptor(i,t);(!M||("get"in M?!i.__esModule:M.writable||M.configurable))&&(M={enumerable:!0,get:function(){return i[t]}}),Object.defineProperty(W,n,M)}:function(W,i,t,n){n===void 0&&(n=t),W[n]=i[t]}),Ke=this&&this.__setModuleDefault||(Object.create?function(W,i){Object.defineProperty(W,"default",{enumerable:!0,value:i})}:function(W,i){W.default=i}),Be=this&&this.__importStar||function(W){if(W&&W.__esModule)return W;var i={};if(W!=null)for(var t in W)t!=="default"&&Object.prototype.hasOwnProperty.call(W,t)&&Je(i,W,t);return Ke(i,W),i};ne(ie[44],re([0,1,43]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.delimiter=i.sep=i.toNamespacedPath=i.parse=i.format=i.extname=i.basename=i.dirname=i.relative=i.resolve=i.join=i.isAbsolute=i.normalize=i.posix=i.win32=void 0,t=Be(t);const n=65,M=97,h=90,p=122,m=46,l=47,a=92,c=58,_=63;class g extends Error{constructor(u,f,D){let R;typeof f=="string"&&f.indexOf("not ")===0?(R="must not be",f=f.replace(/^not /,"")):R="must be";const S=u.indexOf(".")!==-1?"property":"argument";let I=`The "${u}" ${S} ${R} of type ${f}`;I+=`. Received type ${typeof D}`,super(I),this.code="ERR_INVALID_ARG_TYPE"}}function b(r,u){if(r===null||typeof r!="object")throw new g(u,"Object",r)}function e(r,u){if(typeof r!="string")throw new g(u,"string",r)}const L=t.platform==="win32";function E(r){return r===l||r===a}function N(r){return r===l}function w(r){return r>=n&&r<=h||r>=M&&r<=p}function v(r,u,f,D){let R="",S=0,I=-1,T=0,O=0;for(let P=0;P<=r.length;++P){if(P<r.length)O=r.charCodeAt(P);else{if(D(O))break;O=l}if(D(O)){if(!(I===P-1||T===1))if(T===2){if(R.length<2||S!==2||R.charCodeAt(R.length-1)!==m||R.charCodeAt(R.length-2)!==m){if(R.length>2){const y=R.lastIndexOf(f);y===-1?(R="",S=0):(R=R.slice(0,y),S=R.length-1-R.lastIndexOf(f)),I=P,T=0;continue}else if(R.length!==0){R="",S=0,I=P,T=0;continue}}u&&(R+=R.length>0?`${f}..`:"..",S=2)}else R.length>0?R+=`${f}${r.slice(I+1,P)}`:R=r.slice(I+1,P),S=P-I-1;I=P,T=0}else O===m&&T!==-1?++T:T=-1}return R}function A(r){return r?`${r[0]==="."?"":"."}${r}`:""}function d(r,u){b(u,"pathObject");const f=u.dir||u.root,D=u.base||`${u.name||""}${A(u.ext)}`;return f?f===u.root?`${f}${D}`:`${f}${r}${D}`:D}i.win32={resolve(...r){let u="",f="",D=!1;for(let R=r.length-1;R>=-1;R--){let S;if(R>=0){if(S=r[R],e(S,`paths[${R}]`),S.length===0)continue}else u.length===0?S=t.cwd():(S=t.env[`=${u}`]||t.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==u.toLowerCase()&&S.charCodeAt(2)===a)&&(S=`${u}\\`));const I=S.length;let T=0,O="",P=!1;const y=S.charCodeAt(0);if(I===1)E(y)&&(T=1,P=!0);else if(E(y))if(P=!0,E(S.charCodeAt(1))){let x=2,G=x;for(;x<I&&!E(S.charCodeAt(x));)x++;if(x<I&&x!==G){const U=S.slice(G,x);for(G=x;x<I&&E(S.charCodeAt(x));)x++;if(x<I&&x!==G){for(G=x;x<I&&!E(S.charCodeAt(x));)x++;(x===I||x!==G)&&(O=`\\\\${U}\\${S.slice(G,x)}`,T=x)}}}else T=1;else w(y)&&S.charCodeAt(1)===c&&(O=S.slice(0,2),T=2,I>2&&E(S.charCodeAt(2))&&(P=!0,T=3));if(O.length>0)if(u.length>0){if(O.toLowerCase()!==u.toLowerCase())continue}else u=O;if(D){if(u.length>0)break}else if(f=`${S.slice(T)}\\${f}`,D=P,P&&u.length>0)break}return f=v(f,!D,"\\",E),D?`${u}\\${f}`:`${u}${f}`||"."},normalize(r){e(r,"path");const u=r.length;if(u===0)return".";let f=0,D,R=!1;const S=r.charCodeAt(0);if(u===1)return N(S)?"\\":r;if(E(S))if(R=!0,E(r.charCodeAt(1))){let T=2,O=T;for(;T<u&&!E(r.charCodeAt(T));)T++;if(T<u&&T!==O){const P=r.slice(O,T);for(O=T;T<u&&E(r.charCodeAt(T));)T++;if(T<u&&T!==O){for(O=T;T<u&&!E(r.charCodeAt(T));)T++;if(T===u)return`\\\\${P}\\${r.slice(O)}\\`;T!==O&&(D=`\\\\${P}\\${r.slice(O,T)}`,f=T)}}}else f=1;else w(S)&&r.charCodeAt(1)===c&&(D=r.slice(0,2),f=2,u>2&&E(r.charCodeAt(2))&&(R=!0,f=3));let I=f<u?v(r.slice(f),!R,"\\",E):"";return I.length===0&&!R&&(I="."),I.length>0&&E(r.charCodeAt(u-1))&&(I+="\\"),D===void 0?R?`\\${I}`:I:R?`${D}\\${I}`:`${D}${I}`},isAbsolute(r){e(r,"path");const u=r.length;if(u===0)return!1;const f=r.charCodeAt(0);return E(f)||u>2&&w(f)&&r.charCodeAt(1)===c&&E(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let u,f;for(let S=0;S<r.length;++S){const I=r[S];e(I,"path"),I.length>0&&(u===void 0?u=f=I:u+=`\\${I}`)}if(u===void 0)return".";let D=!0,R=0;if(typeof f=="string"&&E(f.charCodeAt(0))){++R;const S=f.length;S>1&&E(f.charCodeAt(1))&&(++R,S>2&&(E(f.charCodeAt(2))?++R:D=!1))}if(D){for(;R<u.length&&E(u.charCodeAt(R));)R++;R>=2&&(u=`\\${u.slice(R)}`)}return i.win32.normalize(u)},relative(r,u){if(e(r,"from"),e(u,"to"),r===u)return"";const f=i.win32.resolve(r),D=i.win32.resolve(u);if(f===D||(r=f.toLowerCase(),u=D.toLowerCase(),r===u))return"";let R=0;for(;R<r.length&&r.charCodeAt(R)===a;)R++;let S=r.length;for(;S-1>R&&r.charCodeAt(S-1)===a;)S--;const I=S-R;let T=0;for(;T<u.length&&u.charCodeAt(T)===a;)T++;let O=u.length;for(;O-1>T&&u.charCodeAt(O-1)===a;)O--;const P=O-T,y=I<P?I:P;let x=-1,G=0;for(;G<y;G++){const B=r.charCodeAt(R+G);if(B!==u.charCodeAt(T+G))break;B===a&&(x=G)}if(G!==y){if(x===-1)return D}else{if(P>y){if(u.charCodeAt(T+G)===a)return D.slice(T+G+1);if(G===2)return D.slice(T+G)}I>y&&(r.charCodeAt(R+G)===a?x=G:G===2&&(x=3)),x===-1&&(x=0)}let U="";for(G=R+x+1;G<=S;++G)(G===S||r.charCodeAt(G)===a)&&(U+=U.length===0?"..":"\\..");return T+=x,U.length>0?`${U}${D.slice(T,O)}`:(D.charCodeAt(T)===a&&++T,D.slice(T,O))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const u=i.win32.resolve(r);if(u.length<=2)return r;if(u.charCodeAt(0)===a){if(u.charCodeAt(1)===a){const f=u.charCodeAt(2);if(f!==_&&f!==m)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(w(u.charCodeAt(0))&&u.charCodeAt(1)===c&&u.charCodeAt(2)===a)return`\\\\?\\${u}`;return r},dirname(r){e(r,"path");const u=r.length;if(u===0)return".";let f=-1,D=0;const R=r.charCodeAt(0);if(u===1)return E(R)?r:".";if(E(R)){if(f=D=1,E(r.charCodeAt(1))){let T=2,O=T;for(;T<u&&!E(r.charCodeAt(T));)T++;if(T<u&&T!==O){for(O=T;T<u&&E(r.charCodeAt(T));)T++;if(T<u&&T!==O){for(O=T;T<u&&!E(r.charCodeAt(T));)T++;if(T===u)return r;T!==O&&(f=D=T+1)}}}}else w(R)&&r.charCodeAt(1)===c&&(f=u>2&&E(r.charCodeAt(2))?3:2,D=f);let S=-1,I=!0;for(let T=u-1;T>=D;--T)if(E(r.charCodeAt(T))){if(!I){S=T;break}}else I=!1;if(S===-1){if(f===-1)return".";S=f}return r.slice(0,S)},basename(r,u){u!==void 0&&e(u,"suffix"),e(r,"path");let f=0,D=-1,R=!0,S;if(r.length>=2&&w(r.charCodeAt(0))&&r.charCodeAt(1)===c&&(f=2),u!==void 0&&u.length>0&&u.length<=r.length){if(u===r)return"";let I=u.length-1,T=-1;for(S=r.length-1;S>=f;--S){const O=r.charCodeAt(S);if(E(O)){if(!R){f=S+1;break}}else T===-1&&(R=!1,T=S+1),I>=0&&(O===u.charCodeAt(I)?--I===-1&&(D=S):(I=-1,D=T))}return f===D?D=T:D===-1&&(D=r.length),r.slice(f,D)}for(S=r.length-1;S>=f;--S)if(E(r.charCodeAt(S))){if(!R){f=S+1;break}}else D===-1&&(R=!1,D=S+1);return D===-1?"":r.slice(f,D)},extname(r){e(r,"path");let u=0,f=-1,D=0,R=-1,S=!0,I=0;r.length>=2&&r.charCodeAt(1)===c&&w(r.charCodeAt(0))&&(u=D=2);for(let T=r.length-1;T>=u;--T){const O=r.charCodeAt(T);if(E(O)){if(!S){D=T+1;break}continue}R===-1&&(S=!1,R=T+1),O===m?f===-1?f=T:I!==1&&(I=1):f!==-1&&(I=-1)}return f===-1||R===-1||I===0||I===1&&f===R-1&&f===D+1?"":r.slice(f,R)},format:d.bind(null,"\\"),parse(r){e(r,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return u;const f=r.length;let D=0,R=r.charCodeAt(0);if(f===1)return E(R)?(u.root=u.dir=r,u):(u.base=u.name=r,u);if(E(R)){if(D=1,E(r.charCodeAt(1))){let x=2,G=x;for(;x<f&&!E(r.charCodeAt(x));)x++;if(x<f&&x!==G){for(G=x;x<f&&E(r.charCodeAt(x));)x++;if(x<f&&x!==G){for(G=x;x<f&&!E(r.charCodeAt(x));)x++;x===f?D=x:x!==G&&(D=x+1)}}}}else if(w(R)&&r.charCodeAt(1)===c){if(f<=2)return u.root=u.dir=r,u;if(D=2,E(r.charCodeAt(2))){if(f===3)return u.root=u.dir=r,u;D=3}}D>0&&(u.root=r.slice(0,D));let S=-1,I=D,T=-1,O=!0,P=r.length-1,y=0;for(;P>=D;--P){if(R=r.charCodeAt(P),E(R)){if(!O){I=P+1;break}continue}T===-1&&(O=!1,T=P+1),R===m?S===-1?S=P:y!==1&&(y=1):S!==-1&&(y=-1)}return T!==-1&&(S===-1||y===0||y===1&&S===T-1&&S===I+1?u.base=u.name=r.slice(I,T):(u.name=r.slice(I,S),u.base=r.slice(I,T),u.ext=r.slice(S,T))),I>0&&I!==D?u.dir=r.slice(0,I-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(L){const r=/\\/g;return()=>{const u=t.cwd().replace(r,"/");return u.slice(u.indexOf("/"))}}return()=>t.cwd()})();i.posix={resolve(...r){let u="",f=!1;for(let D=r.length-1;D>=-1&&!f;D--){const R=D>=0?r[D]:o();e(R,`paths[${D}]`),R.length!==0&&(u=`${R}/${u}`,f=R.charCodeAt(0)===l)}return u=v(u,!f,"/",N),f?`/${u}`:u.length>0?u:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const u=r.charCodeAt(0)===l,f=r.charCodeAt(r.length-1)===l;return r=v(r,!u,"/",N),r.length===0?u?"/":f?"./":".":(f&&(r+="/"),u?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===l},join(...r){if(r.length===0)return".";let u;for(let f=0;f<r.length;++f){const D=r[f];e(D,"path"),D.length>0&&(u===void 0?u=D:u+=`/${D}`)}return u===void 0?".":i.posix.normalize(u)},relative(r,u){if(e(r,"from"),e(u,"to"),r===u||(r=i.posix.resolve(r),u=i.posix.resolve(u),r===u))return"";const f=1,D=r.length,R=D-f,S=1,I=u.length-S,T=R<I?R:I;let O=-1,P=0;for(;P<T;P++){const x=r.charCodeAt(f+P);if(x!==u.charCodeAt(S+P))break;x===l&&(O=P)}if(P===T)if(I>T){if(u.charCodeAt(S+P)===l)return u.slice(S+P+1);if(P===0)return u.slice(S+P)}else R>T&&(r.charCodeAt(f+P)===l?O=P:P===0&&(O=0));let y="";for(P=f+O+1;P<=D;++P)(P===D||r.charCodeAt(P)===l)&&(y+=y.length===0?"..":"/..");return`${y}${u.slice(S+O)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const u=r.charCodeAt(0)===l;let f=-1,D=!0;for(let R=r.length-1;R>=1;--R)if(r.charCodeAt(R)===l){if(!D){f=R;break}}else D=!1;return f===-1?u?"/":".":u&&f===1?"//":r.slice(0,f)},basename(r,u){u!==void 0&&e(u,"ext"),e(r,"path");let f=0,D=-1,R=!0,S;if(u!==void 0&&u.length>0&&u.length<=r.length){if(u===r)return"";let I=u.length-1,T=-1;for(S=r.length-1;S>=0;--S){const O=r.charCodeAt(S);if(O===l){if(!R){f=S+1;break}}else T===-1&&(R=!1,T=S+1),I>=0&&(O===u.charCodeAt(I)?--I===-1&&(D=S):(I=-1,D=T))}return f===D?D=T:D===-1&&(D=r.length),r.slice(f,D)}for(S=r.length-1;S>=0;--S)if(r.charCodeAt(S)===l){if(!R){f=S+1;break}}else D===-1&&(R=!1,D=S+1);return D===-1?"":r.slice(f,D)},extname(r){e(r,"path");let u=-1,f=0,D=-1,R=!0,S=0;for(let I=r.length-1;I>=0;--I){const T=r.charCodeAt(I);if(T===l){if(!R){f=I+1;break}continue}D===-1&&(R=!1,D=I+1),T===m?u===-1?u=I:S!==1&&(S=1):u!==-1&&(S=-1)}return u===-1||D===-1||S===0||S===1&&u===D-1&&u===f+1?"":r.slice(u,D)},format:d.bind(null,"/"),parse(r){e(r,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return u;const f=r.charCodeAt(0)===l;let D;f?(u.root="/",D=1):D=0;let R=-1,S=0,I=-1,T=!0,O=r.length-1,P=0;for(;O>=D;--O){const y=r.charCodeAt(O);if(y===l){if(!T){S=O+1;break}continue}I===-1&&(T=!1,I=O+1),y===m?R===-1?R=O:P!==1&&(P=1):R!==-1&&(P=-1)}if(I!==-1){const y=S===0&&f?1:S;R===-1||P===0||P===1&&R===I-1&&R===S+1?u.base=u.name=r.slice(y,I):(u.name=r.slice(y,R),u.base=r.slice(y,I),u.ext=r.slice(R,I))}return S>0?u.dir=r.slice(0,S-1):f&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},i.posix.win32=i.win32.win32=i.win32,i.posix.posix=i.win32.posix=i.posix,i.normalize=L?i.win32.normalize:i.posix.normalize,i.isAbsolute=L?i.win32.isAbsolute:i.posix.isAbsolute,i.join=L?i.win32.join:i.posix.join,i.resolve=L?i.win32.resolve:i.posix.resolve,i.relative=L?i.win32.relative:i.posix.relative,i.dirname=L?i.win32.dirname:i.posix.dirname,i.basename=L?i.win32.basename:i.posix.basename,i.extname=L?i.win32.extname:i.posix.extname,i.format=L?i.win32.format:i.posix.format,i.parse=L?i.win32.parse:i.posix.parse,i.toNamespacedPath=L?i.win32.toNamespacedPath:i.posix.toNamespacedPath,i.sep=L?i.win32.sep:i.posix.sep,i.delimiter=L?i.win32.delimiter:i.posix.delimiter}),ne(ie[25],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StopWatch=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(h){return new n(h)}constructor(h){this._now=t&&h===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}i.StopWatch=n}),ne(ie[13],re([0,1,5,22,12,24,25]),function(W,i,t,n,M,h,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ValueWithChangeEvent=i.Relay=i.EventBufferer=i.DynamicListEventMultiplexer=i.EventMultiplexer=i.MicrotaskEmitter=i.DebounceEmitter=i.PauseableEmitter=i.AsyncEmitter=i.createEventDeliveryQueue=i.Emitter=i.ListenerRefusalError=i.ListenerLeakError=i.EventProfiling=i.Event=void 0,i.setGlobalLeakWarningThreshold=b;const m=!1,l=!1,a=!1;var c;(function(U){U.None=()=>M.Disposable.None;function B(se){if(a){const{onDidAddListener:te}=se,ue=L.create();let ae=0;se.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),te?.()}}}function X(se,te){return s(se,()=>{},0,void 0,!0,void 0,te)}U.defer=X;function Y(se){return(te,ue=null,ae)=>{let fe=!1,me;return me=se(_e=>{if(!fe)return me?me.dispose():fe=!0,te.call(ue,_e)},null,ae),fe&&me.dispose(),me}}U.once=Y;function $(se,te,ue){return oe((ae,fe=null,me)=>se(_e=>ae.call(fe,te(_e)),null,me),ue)}U.map=$;function Z(se,te,ue){return oe((ae,fe=null,me)=>se(_e=>{te(_e),ae.call(fe,_e)},null,me),ue)}U.forEach=Z;function ee(se,te,ue){return oe((ae,fe=null,me)=>se(_e=>te(_e)&&ae.call(fe,_e),null,me),ue)}U.filter=ee;function F(se){return se}U.signal=F;function C(...se){return(te,ue=null,ae)=>{const fe=(0,M.combinedDisposable)(...se.map(me=>me(_e=>te.call(ue,_e))));return Le(fe,ae)}}U.any=C;function ce(se,te,ue,ae){let fe=ue;return $(se,me=>(fe=te(fe,me),fe),ae)}U.reduce=ce;function oe(se,te){let ue;const ae={onWillAddFirstListener(){ue=se(fe.fire,fe)},onDidRemoveLastListener(){ue?.dispose()}};te||B(ae);const fe=new r(ae);return te?.add(fe),fe.event}function Le(se,te){return te instanceof Array?te.push(se):te&&te.add(se),se}function s(se,te,ue=100,ae=!1,fe=!1,me,_e){let pe,Ne,ke,ge=0,De;const Ce={leakWarningThreshold:me,onWillAddFirstListener(){pe=se($e=>{ge++,Ne=te(Ne,$e),ae&&!ke&&(We.fire(Ne),Ne=void 0),De=()=>{const Xe=Ne;Ne=void 0,ke=void 0,(!ae||ge>1)&&We.fire(Xe),ge=0},typeof ue=="number"?(clearTimeout(ke),ke=setTimeout(De,ue)):ke===void 0&&(ke=0,queueMicrotask(De))})},onWillRemoveListener(){fe&&ge>0&&De?.()},onDidRemoveLastListener(){De=void 0,pe.dispose()}};_e||B(Ce);const We=new r(Ce);return _e?.add(We),We.event}U.debounce=s;function Se(se,te=0,ue){return U.debounce(se,(ae,fe)=>ae?(ae.push(fe),ae):[fe],te,void 0,!0,void 0,ue)}U.accumulate=Se;function Pe(se,te=(ae,fe)=>ae===fe,ue){let ae=!0,fe;return ee(se,me=>{const _e=ae||!te(me,fe);return ae=!1,fe=me,_e},ue)}U.latch=Pe;function ze(se,te,ue){return[U.filter(se,te,ue),U.filter(se,ae=>!te(ae),ue)]}U.split=ze;function Te(se,te=!1,ue=[],ae){let fe=ue.slice(),me=se(Ne=>{fe?fe.push(Ne):pe.fire(Ne)});ae&&ae.add(me);const _e=()=>{fe?.forEach(Ne=>pe.fire(Ne)),fe=null},pe=new r({onWillAddFirstListener(){me||(me=se(Ne=>pe.fire(Ne)),ae&&ae.add(me))},onDidAddFirstListener(){fe&&(te?setTimeout(_e):_e())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return ae&&ae.add(pe),pe.event}U.buffer=Te;function qe(se,te){return(ae,fe,me)=>{const _e=te(new V);return se(function(pe){const Ne=_e.evaluate(pe);Ne!==Ue&&ae.call(fe,Ne)},void 0,me)}}U.chain=qe;const Ue=Symbol("HaltChainable");class V{constructor(){this.steps=[]}map(te){return this.steps.push(te),this}forEach(te){return this.steps.push(ue=>(te(ue),ue)),this}filter(te){return this.steps.push(ue=>te(ue)?ue:Ue),this}reduce(te,ue){let ae=ue;return this.steps.push(fe=>(ae=te(ae,fe),ae)),this}latch(te=(ue,ae)=>ue===ae){let ue=!0,ae;return this.steps.push(fe=>{const me=ue||!te(fe,ae);return ue=!1,ae=fe,me?fe:Ue}),this}evaluate(te){for(const ue of this.steps)if(te=ue(te),te===Ue)break;return te}}function z(se,te,ue=ae=>ae){const ae=(...pe)=>_e.fire(ue(...pe)),fe=()=>se.on(te,ae),me=()=>se.removeListener(te,ae),_e=new r({onWillAddFirstListener:fe,onDidRemoveLastListener:me});return _e.event}U.fromNodeEventEmitter=z;function H(se,te,ue=ae=>ae){const ae=(...pe)=>_e.fire(ue(...pe)),fe=()=>se.addEventListener(te,ae),me=()=>se.removeEventListener(te,ae),_e=new r({onWillAddFirstListener:fe,onDidRemoveLastListener:me});return _e.event}U.fromDOMEventEmitter=H;function Q(se){return new Promise(te=>Y(se)(te))}U.toPromise=Q;function K(se){const te=new r;return se.then(ue=>{te.fire(ue)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}U.fromPromise=K;function he(se,te){return se(ue=>te.fire(ue))}U.forward=he;function be(se,te,ue){return te(ue),se(ae=>te(ae))}U.runAndSubscribe=be;class ve{constructor(te,ue){this._observable=te,this._counter=0,this._hasChanged=!1;const ae={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ue||B(ae),this.emitter=new r(ae),ue&&ue.add(this.emitter)}beginUpdate(te){this._counter++}handlePossibleChange(te){}handleChange(te,ue){this._hasChanged=!0}endUpdate(te){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function we(se,te){return new ve(se,te).emitter.event}U.fromObservable=we;function Re(se){return(te,ue,ae)=>{let fe=0,me=!1;const _e={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(se.reportChanges(),me&&(me=!1,te.call(ue)))},handlePossibleChange(){},handleChange(){me=!0}};se.addObserver(_e),se.reportChanges();const pe={dispose(){se.removeObserver(_e)}};return ae instanceof M.DisposableStore?ae.add(pe):Array.isArray(ae)&&ae.push(pe),pe}}U.fromObservableLight=Re})(c||(i.Event=c={}));class _{static{this.all=new Set}static{this._idPool=0}constructor(B){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${B}_${_._idPool++}`,_.all.add(this)}start(B){this._stopWatch=new p.StopWatch,this.listenerCount=B}stop(){if(this._stopWatch){const B=this._stopWatch.elapsed();this.durations.push(B),this.elapsedOverall+=B,this.invocationCount+=1,this._stopWatch=void 0}}}i.EventProfiling=_;let g=-1;function b(U){const B=g;return g=U,{dispose(){g=B}}}class e{static{this._idPool=1}constructor(B,X,Y=(e._idPool++).toString(16).padStart(3,"0")){this._errorHandler=B,this.threshold=X,this.name=Y,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(B,X){const Y=this.threshold;if(Y<=0||X<Y)return;this._stacks||(this._stacks=new Map);const $=this._stacks.get(B.value)||0;if(this._stacks.set(B.value,$+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=Y*.5;const[Z,ee]=this.getMostFrequentStack(),F=`[${this.name}] potential listener LEAK detected, having ${X} listeners already. MOST frequent listener (${ee}):`;console.warn(F),console.warn(Z);const C=new E(F,Z);this._errorHandler(C)}return()=>{const Z=this._stacks.get(B.value)||0;this._stacks.set(B.value,Z-1)}}getMostFrequentStack(){if(!this._stacks)return;let B,X=0;for(const[Y,$]of this._stacks)(!B||X<$)&&(B=[Y,$],X=$);return B}}class L{static create(){const B=new Error;return new L(B.stack??"")}constructor(B){this.value=B}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(B,X){super(B),this.name="ListenerLeakError",this.stack=X}}i.ListenerLeakError=E;class N extends Error{constructor(B,X){super(B),this.name="ListenerRefusalError",this.stack=X}}i.ListenerRefusalError=N;let w=0;class v{constructor(B){this.value=B,this.id=w++}}const A=2,d=(U,B)=>{if(U instanceof v)B(U);else for(let X=0;X<U.length;X++){const Y=U[X];Y&&B(Y)}};let o;if(m){const U=[];setInterval(()=>{U.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(U.join(`
`)),U.length=0)},3e3),o=new FinalizationRegistry(B=>{typeof B=="string"&&U.push(B)})}class r{constructor(B){this._size=0,this._options=B,this._leakageMon=g>0||this._options?.leakWarningThreshold?new e(B?.onListenerError??t.onUnexpectedError,this._options?.leakWarningThreshold??g):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(l){const B=this._listeners;queueMicrotask(()=>{d(B,X=>X.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(B,X,Y)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const C=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(C);const ce=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],oe=new N(`${C}. HINT: Stack shows most frequent listener (${ce[1]}-times)`,ce[0]);return(this._options?.onListenerError||t.onUnexpectedError)(oe),M.Disposable.None}if(this._disposed)return M.Disposable.None;X&&(B=B.bind(X));const $=new v(B);let Z,ee;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&($.stack=L.create(),Z=this._leakageMon.check($.stack,this._size+1)),l&&($.stack=ee??L.create()),this._listeners?this._listeners instanceof v?(this._deliveryQueue??=new f,this._listeners=[this._listeners,$]):this._listeners.push($):(this._options?.onWillAddFirstListener?.(this),this._listeners=$,this._options?.onDidAddFirstListener?.(this)),this._size++;const F=(0,M.toDisposable)(()=>{o?.unregister(F),Z?.(),this._removeListener($)});if(Y instanceof M.DisposableStore?Y.add(F):Array.isArray(Y)&&Y.push(F),o){const C=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ce=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(C);o.register(F,ce?.[2]??C,F)}return F},this._event}_removeListener(B){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const X=this._listeners,Y=X.indexOf(B);if(Y===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,X[Y]=void 0;const $=this._deliveryQueue.current===this;if(this._size*A<=X.length){let Z=0;for(let ee=0;ee<X.length;ee++)X[ee]?X[Z++]=X[ee]:$&&(this._deliveryQueue.end--,Z<this._deliveryQueue.i&&this._deliveryQueue.i--);X.length=Z}}_deliver(B,X){if(!B)return;const Y=this._options?.onListenerError||t.onUnexpectedError;if(!Y){B.value(X);return}try{B.value(X)}catch($){Y($)}}_deliverQueue(B){const X=B.current._listeners;for(;B.i<B.end;)this._deliver(X[B.i++],B.value);B.reset()}fire(B){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof v)this._deliver(this._listeners,B);else{const X=this._deliveryQueue;X.enqueue(this,B,this._listeners.length),this._deliverQueue(X)}this._perfMon?.stop()}hasListeners(){return this._size>0}}i.Emitter=r;const u=()=>new f;i.createEventDeliveryQueue=u;class f{constructor(){this.i=-1,this.end=0}enqueue(B,X,Y){this.i=0,this.end=Y,this.current=B,this.value=X}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class D extends r{async fireAsync(B,X,Y){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new h.LinkedList),d(this._listeners,$=>this._asyncDeliveryQueue.push([$.value,B]));this._asyncDeliveryQueue.size>0&&!X.isCancellationRequested;){const[$,Z]=this._asyncDeliveryQueue.shift(),ee=[],F={...Z,token:X,waitUntil:C=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Y&&(C=Y(C,$)),ee.push(C)}};try{$(F)}catch(C){(0,t.onUnexpectedError)(C);continue}Object.freeze(ee),await Promise.allSettled(ee).then(C=>{for(const ce of C)ce.status==="rejected"&&(0,t.onUnexpectedError)(ce.reason)})}}}i.AsyncEmitter=D;class R extends r{get isPaused(){return this._isPaused!==0}constructor(B){super(B),this._isPaused=0,this._eventQueue=new h.LinkedList,this._mergeFn=B?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const B=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(B))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(B){this._size&&(this._isPaused!==0?this._eventQueue.push(B):super.fire(B))}}i.PauseableEmitter=R;class S extends R{constructor(B){super(B),this._delay=B.delay??100}fire(B){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(B)}}i.DebounceEmitter=S;class I extends r{constructor(B){super(B),this._queuedEvents=[],this._mergeFn=B?.merge}fire(B){this.hasListeners()&&(this._queuedEvents.push(B),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(X=>super.fire(X)),this._queuedEvents=[]}))}}i.MicrotaskEmitter=I;class T{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new r({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(B){const X={event:B,listener:null};this.events.push(X),this.hasListeners&&this.hook(X);const Y=()=>{this.hasListeners&&this.unhook(X);const $=this.events.indexOf(X);this.events.splice($,1)};return(0,M.toDisposable)((0,n.createSingleCallFunction)(Y))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(B=>this.hook(B))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(B=>this.unhook(B))}hook(B){B.listener=B.event(X=>this.emitter.fire(X))}unhook(B){B.listener?.dispose(),B.listener=null}dispose(){this.emitter.dispose();for(const B of this.events)B.listener?.dispose();this.events=[]}}i.EventMultiplexer=T;class O{constructor(B,X,Y,$){this._store=new M.DisposableStore;const Z=this._store.add(new T),ee=this._store.add(new M.DisposableMap);function F(C){ee.set(C,Z.add($(C)))}for(const C of B)F(C);this._store.add(X(C=>{F(C)})),this._store.add(Y(C=>{ee.deleteAndDispose(C)})),this.event=Z.event}dispose(){this._store.dispose()}}i.DynamicListEventMultiplexer=O;class P{constructor(){this.data=[]}wrapEvent(B,X,Y){return($,Z,ee)=>B(F=>{const C=this.data[this.data.length-1];if(!X){C?C.buffers.push(()=>$.call(Z,F)):$.call(Z,F);return}const ce=C;if(!ce){$.call(Z,X(Y,F));return}ce.items??=[],ce.items.push(F),ce.buffers.length===0&&C.buffers.push(()=>{ce.reducedResult??=Y?ce.items.reduce(X,Y):ce.items.reduce(X),$.call(Z,ce.reducedResult)})},void 0,ee)}bufferEvents(B){const X={buffers:new Array};this.data.push(X);const Y=B();return this.data.pop(),X.buffers.forEach($=>$()),Y}}i.EventBufferer=P;class y{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=M.Disposable.None,this.emitter=new r({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(B){this.inputEvent=B,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=B(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}i.Relay=y;class x{static const(B){return new G(B)}constructor(B){this._value=B,this._onDidChange=new r,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(B){B!==this._value&&(this._value=B,this._onDidChange.fire(void 0))}}i.ValueWithChangeEvent=x;class G{constructor(B){this.value=B,this.onDidChange=c.None}}}),ne(ie[26],re([0,1,13]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CancellationTokenSource=i.CancellationToken=void 0,i.cancelOnDispose=m;const n=Object.freeze(function(l,a){const c=setTimeout(l.bind(a),0);return{dispose(){clearTimeout(c)}}});var M;(function(l){function a(c){return c===l.None||c===l.Cancelled||c instanceof h?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}l.isCancellationToken=a,l.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),l.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(M||(i.CancellationToken=M={}));class h{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new t.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class p{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new h),this._token}cancel(){this._token?this._token instanceof h&&this._token.cancel():this._token=M.Cancelled}dispose(a=!1){a&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof h&&this._token.dispose():this._token=M.None}}i.CancellationTokenSource=p;function m(l){const a=new p;return l.add({dispose(){a.cancel()}}),a.token}}),ne(ie[45],re([0,1,26]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CachedFunction=i.LRUCachedFunction=i.Cache=void 0,i.identity=M;class n{constructor(l){this.task=l,this.result=null}get(){if(this.result)return this.result;const l=new t.CancellationTokenSource,a=this.task(l.token);return this.result={promise:a,dispose:()=>{this.result=null,l.cancel(),l.dispose()}},this.result}}i.Cache=n;function M(m){return m}class h{constructor(l,a){this.lastCache=void 0,this.lastArgKey=void 0,typeof l=="function"?(this._fn=l,this._computeKey=M):(this._fn=a,this._computeKey=l.getCacheKey)}get(l){const a=this._computeKey(l);return this.lastArgKey!==a&&(this.lastArgKey=a,this.lastCache=this._fn(l)),this.lastCache}}i.LRUCachedFunction=h;class p{get cachedValues(){return this._map}constructor(l,a){this._map=new Map,this._map2=new Map,typeof l=="function"?(this._fn=l,this._computeKey=M):(this._fn=a,this._computeKey=l.getCacheKey)}get(l){const a=this._computeKey(l);if(this._map2.has(a))return this._map2.get(a);const c=this._fn(l);return this._map.set(l,c),this._map2.set(a,c),c}}i.CachedFunction=p}),ne(ie[27],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isString=t,i.isStringArray=n,i.isObject=M,i.isTypedArray=h,i.isNumber=p,i.isIterable=m,i.isBoolean=l,i.isUndefined=a,i.isDefined=c,i.isUndefinedOrNull=_,i.assertType=g,i.assertIsDefined=b,i.assertAllDefined=e,i.isEmptyObject=E,i.isFunction=N,i.areFunctions=w,i.validateConstraints=v,i.validateConstraint=A,i.upcast=d;function t(o){return typeof o=="string"}function n(o){return Array.isArray(o)&&o.every(r=>t(r))}function M(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function h(o){const r=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof r}function p(o){return typeof o=="number"&&!isNaN(o)}function m(o){return!!o&&typeof o[Symbol.iterator]=="function"}function l(o){return o===!0||o===!1}function a(o){return typeof o>"u"}function c(o){return!_(o)}function _(o){return a(o)||o===null}function g(o,r){if(!o)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function b(o){if(_(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function e(...o){const r=[];for(let u=0;u<o.length;u++){const f=o[u];if(_(f))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);r.push(f)}return r}const L=Object.prototype.hasOwnProperty;function E(o){if(!M(o))return!1;for(const r in o)if(L.call(o,r))return!1;return!0}function N(o){return typeof o=="function"}function w(...o){return o.length>0&&o.every(N)}function v(o,r){const u=Math.min(o.length,r.length);for(let f=0;f<u;f++)A(o[f],r[f])}function A(o,r){if(t(r)){if(typeof o!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(N(r)){try{if(o instanceof r)return}catch{}if(!_(o)&&o.constructor===r||r.length===1&&r.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function d(o){return o}}),ne(ie[28],re([0,1,27]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.register=M,i.getCodiconFontCharacters=h;const n=Object.create(null);function M(p,m){if((0,t.isString)(m)){const l=n[m];if(l===void 0)throw new Error(`${p} references an unknown codicon: ${m}`);m=l}return n[p]=m,{id:p}}function h(){return n}}),ne(ie[46],re([0,1,28]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.codiconsLibrary=void 0,i.codiconsLibrary={add:(0,t.register)("add",6e4),plus:(0,t.register)("plus",6e4),gistNew:(0,t.register)("gist-new",6e4),repoCreate:(0,t.register)("repo-create",6e4),lightbulb:(0,t.register)("lightbulb",60001),lightBulb:(0,t.register)("light-bulb",60001),repo:(0,t.register)("repo",60002),repoDelete:(0,t.register)("repo-delete",60002),gistFork:(0,t.register)("gist-fork",60003),repoForked:(0,t.register)("repo-forked",60003),gitPullRequest:(0,t.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.register)("git-pull-request-abandoned",60004),recordKeys:(0,t.register)("record-keys",60005),keyboard:(0,t.register)("keyboard",60005),tag:(0,t.register)("tag",60006),gitPullRequestLabel:(0,t.register)("git-pull-request-label",60006),tagAdd:(0,t.register)("tag-add",60006),tagRemove:(0,t.register)("tag-remove",60006),person:(0,t.register)("person",60007),personFollow:(0,t.register)("person-follow",60007),personOutline:(0,t.register)("person-outline",60007),personFilled:(0,t.register)("person-filled",60007),gitBranch:(0,t.register)("git-branch",60008),gitBranchCreate:(0,t.register)("git-branch-create",60008),gitBranchDelete:(0,t.register)("git-branch-delete",60008),sourceControl:(0,t.register)("source-control",60008),mirror:(0,t.register)("mirror",60009),mirrorPublic:(0,t.register)("mirror-public",60009),star:(0,t.register)("star",60010),starAdd:(0,t.register)("star-add",60010),starDelete:(0,t.register)("star-delete",60010),starEmpty:(0,t.register)("star-empty",60010),comment:(0,t.register)("comment",60011),commentAdd:(0,t.register)("comment-add",60011),alert:(0,t.register)("alert",60012),warning:(0,t.register)("warning",60012),search:(0,t.register)("search",60013),searchSave:(0,t.register)("search-save",60013),logOut:(0,t.register)("log-out",60014),signOut:(0,t.register)("sign-out",60014),logIn:(0,t.register)("log-in",60015),signIn:(0,t.register)("sign-in",60015),eye:(0,t.register)("eye",60016),eyeUnwatch:(0,t.register)("eye-unwatch",60016),eyeWatch:(0,t.register)("eye-watch",60016),circleFilled:(0,t.register)("circle-filled",60017),primitiveDot:(0,t.register)("primitive-dot",60017),closeDirty:(0,t.register)("close-dirty",60017),debugBreakpoint:(0,t.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.register)("debug-breakpoint-disabled",60017),debugHint:(0,t.register)("debug-hint",60017),terminalDecorationSuccess:(0,t.register)("terminal-decoration-success",60017),primitiveSquare:(0,t.register)("primitive-square",60018),edit:(0,t.register)("edit",60019),pencil:(0,t.register)("pencil",60019),info:(0,t.register)("info",60020),issueOpened:(0,t.register)("issue-opened",60020),gistPrivate:(0,t.register)("gist-private",60021),gitForkPrivate:(0,t.register)("git-fork-private",60021),lock:(0,t.register)("lock",60021),mirrorPrivate:(0,t.register)("mirror-private",60021),close:(0,t.register)("close",60022),removeClose:(0,t.register)("remove-close",60022),x:(0,t.register)("x",60022),repoSync:(0,t.register)("repo-sync",60023),sync:(0,t.register)("sync",60023),clone:(0,t.register)("clone",60024),desktopDownload:(0,t.register)("desktop-download",60024),beaker:(0,t.register)("beaker",60025),microscope:(0,t.register)("microscope",60025),vm:(0,t.register)("vm",60026),deviceDesktop:(0,t.register)("device-desktop",60026),file:(0,t.register)("file",60027),fileText:(0,t.register)("file-text",60027),more:(0,t.register)("more",60028),ellipsis:(0,t.register)("ellipsis",60028),kebabHorizontal:(0,t.register)("kebab-horizontal",60028),mailReply:(0,t.register)("mail-reply",60029),reply:(0,t.register)("reply",60029),organization:(0,t.register)("organization",60030),organizationFilled:(0,t.register)("organization-filled",60030),organizationOutline:(0,t.register)("organization-outline",60030),newFile:(0,t.register)("new-file",60031),fileAdd:(0,t.register)("file-add",60031),newFolder:(0,t.register)("new-folder",60032),fileDirectoryCreate:(0,t.register)("file-directory-create",60032),trash:(0,t.register)("trash",60033),trashcan:(0,t.register)("trashcan",60033),history:(0,t.register)("history",60034),clock:(0,t.register)("clock",60034),folder:(0,t.register)("folder",60035),fileDirectory:(0,t.register)("file-directory",60035),symbolFolder:(0,t.register)("symbol-folder",60035),logoGithub:(0,t.register)("logo-github",60036),markGithub:(0,t.register)("mark-github",60036),github:(0,t.register)("github",60036),terminal:(0,t.register)("terminal",60037),console:(0,t.register)("console",60037),repl:(0,t.register)("repl",60037),zap:(0,t.register)("zap",60038),symbolEvent:(0,t.register)("symbol-event",60038),error:(0,t.register)("error",60039),stop:(0,t.register)("stop",60039),variable:(0,t.register)("variable",60040),symbolVariable:(0,t.register)("symbol-variable",60040),array:(0,t.register)("array",60042),symbolArray:(0,t.register)("symbol-array",60042),symbolModule:(0,t.register)("symbol-module",60043),symbolPackage:(0,t.register)("symbol-package",60043),symbolNamespace:(0,t.register)("symbol-namespace",60043),symbolObject:(0,t.register)("symbol-object",60043),symbolMethod:(0,t.register)("symbol-method",60044),symbolFunction:(0,t.register)("symbol-function",60044),symbolConstructor:(0,t.register)("symbol-constructor",60044),symbolBoolean:(0,t.register)("symbol-boolean",60047),symbolNull:(0,t.register)("symbol-null",60047),symbolNumeric:(0,t.register)("symbol-numeric",60048),symbolNumber:(0,t.register)("symbol-number",60048),symbolStructure:(0,t.register)("symbol-structure",60049),symbolStruct:(0,t.register)("symbol-struct",60049),symbolParameter:(0,t.register)("symbol-parameter",60050),symbolTypeParameter:(0,t.register)("symbol-type-parameter",60050),symbolKey:(0,t.register)("symbol-key",60051),symbolText:(0,t.register)("symbol-text",60051),symbolReference:(0,t.register)("symbol-reference",60052),goToFile:(0,t.register)("go-to-file",60052),symbolEnum:(0,t.register)("symbol-enum",60053),symbolValue:(0,t.register)("symbol-value",60053),symbolRuler:(0,t.register)("symbol-ruler",60054),symbolUnit:(0,t.register)("symbol-unit",60054),activateBreakpoints:(0,t.register)("activate-breakpoints",60055),archive:(0,t.register)("archive",60056),arrowBoth:(0,t.register)("arrow-both",60057),arrowDown:(0,t.register)("arrow-down",60058),arrowLeft:(0,t.register)("arrow-left",60059),arrowRight:(0,t.register)("arrow-right",60060),arrowSmallDown:(0,t.register)("arrow-small-down",60061),arrowSmallLeft:(0,t.register)("arrow-small-left",60062),arrowSmallRight:(0,t.register)("arrow-small-right",60063),arrowSmallUp:(0,t.register)("arrow-small-up",60064),arrowUp:(0,t.register)("arrow-up",60065),bell:(0,t.register)("bell",60066),bold:(0,t.register)("bold",60067),book:(0,t.register)("book",60068),bookmark:(0,t.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.register)("briefcase",60076),broadcast:(0,t.register)("broadcast",60077),browser:(0,t.register)("browser",60078),bug:(0,t.register)("bug",60079),calendar:(0,t.register)("calendar",60080),caseSensitive:(0,t.register)("case-sensitive",60081),check:(0,t.register)("check",60082),checklist:(0,t.register)("checklist",60083),chevronDown:(0,t.register)("chevron-down",60084),chevronLeft:(0,t.register)("chevron-left",60085),chevronRight:(0,t.register)("chevron-right",60086),chevronUp:(0,t.register)("chevron-up",60087),chromeClose:(0,t.register)("chrome-close",60088),chromeMaximize:(0,t.register)("chrome-maximize",60089),chromeMinimize:(0,t.register)("chrome-minimize",60090),chromeRestore:(0,t.register)("chrome-restore",60091),circleOutline:(0,t.register)("circle-outline",60092),circle:(0,t.register)("circle",60092),debugBreakpointUnverified:(0,t.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.register)("terminal-decoration-incomplete",60092),circleSlash:(0,t.register)("circle-slash",60093),circuitBoard:(0,t.register)("circuit-board",60094),clearAll:(0,t.register)("clear-all",60095),clippy:(0,t.register)("clippy",60096),closeAll:(0,t.register)("close-all",60097),cloudDownload:(0,t.register)("cloud-download",60098),cloudUpload:(0,t.register)("cloud-upload",60099),code:(0,t.register)("code",60100),collapseAll:(0,t.register)("collapse-all",60101),colorMode:(0,t.register)("color-mode",60102),commentDiscussion:(0,t.register)("comment-discussion",60103),creditCard:(0,t.register)("credit-card",60105),dash:(0,t.register)("dash",60108),dashboard:(0,t.register)("dashboard",60109),database:(0,t.register)("database",60110),debugContinue:(0,t.register)("debug-continue",60111),debugDisconnect:(0,t.register)("debug-disconnect",60112),debugPause:(0,t.register)("debug-pause",60113),debugRestart:(0,t.register)("debug-restart",60114),debugStart:(0,t.register)("debug-start",60115),debugStepInto:(0,t.register)("debug-step-into",60116),debugStepOut:(0,t.register)("debug-step-out",60117),debugStepOver:(0,t.register)("debug-step-over",60118),debugStop:(0,t.register)("debug-stop",60119),debug:(0,t.register)("debug",60120),deviceCameraVideo:(0,t.register)("device-camera-video",60121),deviceCamera:(0,t.register)("device-camera",60122),deviceMobile:(0,t.register)("device-mobile",60123),diffAdded:(0,t.register)("diff-added",60124),diffIgnored:(0,t.register)("diff-ignored",60125),diffModified:(0,t.register)("diff-modified",60126),diffRemoved:(0,t.register)("diff-removed",60127),diffRenamed:(0,t.register)("diff-renamed",60128),diff:(0,t.register)("diff",60129),diffSidebyside:(0,t.register)("diff-sidebyside",60129),discard:(0,t.register)("discard",60130),editorLayout:(0,t.register)("editor-layout",60131),emptyWindow:(0,t.register)("empty-window",60132),exclude:(0,t.register)("exclude",60133),extensions:(0,t.register)("extensions",60134),eyeClosed:(0,t.register)("eye-closed",60135),fileBinary:(0,t.register)("file-binary",60136),fileCode:(0,t.register)("file-code",60137),fileMedia:(0,t.register)("file-media",60138),filePdf:(0,t.register)("file-pdf",60139),fileSubmodule:(0,t.register)("file-submodule",60140),fileSymlinkDirectory:(0,t.register)("file-symlink-directory",60141),fileSymlinkFile:(0,t.register)("file-symlink-file",60142),fileZip:(0,t.register)("file-zip",60143),files:(0,t.register)("files",60144),filter:(0,t.register)("filter",60145),flame:(0,t.register)("flame",60146),foldDown:(0,t.register)("fold-down",60147),foldUp:(0,t.register)("fold-up",60148),fold:(0,t.register)("fold",60149),folderActive:(0,t.register)("folder-active",60150),folderOpened:(0,t.register)("folder-opened",60151),gear:(0,t.register)("gear",60152),gift:(0,t.register)("gift",60153),gistSecret:(0,t.register)("gist-secret",60154),gist:(0,t.register)("gist",60155),gitCommit:(0,t.register)("git-commit",60156),gitCompare:(0,t.register)("git-compare",60157),compareChanges:(0,t.register)("compare-changes",60157),gitMerge:(0,t.register)("git-merge",60158),githubAction:(0,t.register)("github-action",60159),githubAlt:(0,t.register)("github-alt",60160),globe:(0,t.register)("globe",60161),grabber:(0,t.register)("grabber",60162),graph:(0,t.register)("graph",60163),gripper:(0,t.register)("gripper",60164),heart:(0,t.register)("heart",60165),home:(0,t.register)("home",60166),horizontalRule:(0,t.register)("horizontal-rule",60167),hubot:(0,t.register)("hubot",60168),inbox:(0,t.register)("inbox",60169),issueReopened:(0,t.register)("issue-reopened",60171),issues:(0,t.register)("issues",60172),italic:(0,t.register)("italic",60173),jersey:(0,t.register)("jersey",60174),json:(0,t.register)("json",60175),kebabVertical:(0,t.register)("kebab-vertical",60176),key:(0,t.register)("key",60177),law:(0,t.register)("law",60178),lightbulbAutofix:(0,t.register)("lightbulb-autofix",60179),linkExternal:(0,t.register)("link-external",60180),link:(0,t.register)("link",60181),listOrdered:(0,t.register)("list-ordered",60182),listUnordered:(0,t.register)("list-unordered",60183),liveShare:(0,t.register)("live-share",60184),loading:(0,t.register)("loading",60185),location:(0,t.register)("location",60186),mailRead:(0,t.register)("mail-read",60187),mail:(0,t.register)("mail",60188),markdown:(0,t.register)("markdown",60189),megaphone:(0,t.register)("megaphone",60190),mention:(0,t.register)("mention",60191),milestone:(0,t.register)("milestone",60192),gitPullRequestMilestone:(0,t.register)("git-pull-request-milestone",60192),mortarBoard:(0,t.register)("mortar-board",60193),move:(0,t.register)("move",60194),multipleWindows:(0,t.register)("multiple-windows",60195),mute:(0,t.register)("mute",60196),noNewline:(0,t.register)("no-newline",60197),note:(0,t.register)("note",60198),octoface:(0,t.register)("octoface",60199),openPreview:(0,t.register)("open-preview",60200),package:(0,t.register)("package",60201),paintcan:(0,t.register)("paintcan",60202),pin:(0,t.register)("pin",60203),play:(0,t.register)("play",60204),run:(0,t.register)("run",60204),plug:(0,t.register)("plug",60205),preserveCase:(0,t.register)("preserve-case",60206),preview:(0,t.register)("preview",60207),project:(0,t.register)("project",60208),pulse:(0,t.register)("pulse",60209),question:(0,t.register)("question",60210),quote:(0,t.register)("quote",60211),radioTower:(0,t.register)("radio-tower",60212),reactions:(0,t.register)("reactions",60213),references:(0,t.register)("references",60214),refresh:(0,t.register)("refresh",60215),regex:(0,t.register)("regex",60216),remoteExplorer:(0,t.register)("remote-explorer",60217),remote:(0,t.register)("remote",60218),remove:(0,t.register)("remove",60219),replaceAll:(0,t.register)("replace-all",60220),replace:(0,t.register)("replace",60221),repoClone:(0,t.register)("repo-clone",60222),repoForcePush:(0,t.register)("repo-force-push",60223),repoPull:(0,t.register)("repo-pull",60224),repoPush:(0,t.register)("repo-push",60225),report:(0,t.register)("report",60226),requestChanges:(0,t.register)("request-changes",60227),rocket:(0,t.register)("rocket",60228),rootFolderOpened:(0,t.register)("root-folder-opened",60229),rootFolder:(0,t.register)("root-folder",60230),rss:(0,t.register)("rss",60231),ruby:(0,t.register)("ruby",60232),saveAll:(0,t.register)("save-all",60233),saveAs:(0,t.register)("save-as",60234),save:(0,t.register)("save",60235),screenFull:(0,t.register)("screen-full",60236),screenNormal:(0,t.register)("screen-normal",60237),searchStop:(0,t.register)("search-stop",60238),server:(0,t.register)("server",60240),settingsGear:(0,t.register)("settings-gear",60241),settings:(0,t.register)("settings",60242),shield:(0,t.register)("shield",60243),smiley:(0,t.register)("smiley",60244),sortPrecedence:(0,t.register)("sort-precedence",60245),splitHorizontal:(0,t.register)("split-horizontal",60246),splitVertical:(0,t.register)("split-vertical",60247),squirrel:(0,t.register)("squirrel",60248),starFull:(0,t.register)("star-full",60249),starHalf:(0,t.register)("star-half",60250),symbolClass:(0,t.register)("symbol-class",60251),symbolColor:(0,t.register)("symbol-color",60252),symbolConstant:(0,t.register)("symbol-constant",60253),symbolEnumMember:(0,t.register)("symbol-enum-member",60254),symbolField:(0,t.register)("symbol-field",60255),symbolFile:(0,t.register)("symbol-file",60256),symbolInterface:(0,t.register)("symbol-interface",60257),symbolKeyword:(0,t.register)("symbol-keyword",60258),symbolMisc:(0,t.register)("symbol-misc",60259),symbolOperator:(0,t.register)("symbol-operator",60260),symbolProperty:(0,t.register)("symbol-property",60261),wrench:(0,t.register)("wrench",60261),wrenchSubaction:(0,t.register)("wrench-subaction",60261),symbolSnippet:(0,t.register)("symbol-snippet",60262),tasklist:(0,t.register)("tasklist",60263),telescope:(0,t.register)("telescope",60264),textSize:(0,t.register)("text-size",60265),threeBars:(0,t.register)("three-bars",60266),thumbsdown:(0,t.register)("thumbsdown",60267),thumbsup:(0,t.register)("thumbsup",60268),tools:(0,t.register)("tools",60269),triangleDown:(0,t.register)("triangle-down",60270),triangleLeft:(0,t.register)("triangle-left",60271),triangleRight:(0,t.register)("triangle-right",60272),triangleUp:(0,t.register)("triangle-up",60273),twitter:(0,t.register)("twitter",60274),unfold:(0,t.register)("unfold",60275),unlock:(0,t.register)("unlock",60276),unmute:(0,t.register)("unmute",60277),unverified:(0,t.register)("unverified",60278),verified:(0,t.register)("verified",60279),versions:(0,t.register)("versions",60280),vmActive:(0,t.register)("vm-active",60281),vmOutline:(0,t.register)("vm-outline",60282),vmRunning:(0,t.register)("vm-running",60283),watch:(0,t.register)("watch",60284),whitespace:(0,t.register)("whitespace",60285),wholeWord:(0,t.register)("whole-word",60286),window:(0,t.register)("window",60287),wordWrap:(0,t.register)("word-wrap",60288),zoomIn:(0,t.register)("zoom-in",60289),zoomOut:(0,t.register)("zoom-out",60290),listFilter:(0,t.register)("list-filter",60291),listFlat:(0,t.register)("list-flat",60292),listSelection:(0,t.register)("list-selection",60293),selection:(0,t.register)("selection",60293),listTree:(0,t.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.register)("debug-stackframe-active",60297),circleSmallFilled:(0,t.register)("circle-small-filled",60298),debugStackframeDot:(0,t.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.register)("terminal-decoration-mark",60298),debugStackframe:(0,t.register)("debug-stackframe",60299),debugStackframeFocused:(0,t.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.register)("debug-breakpoint-unsupported",60300),symbolString:(0,t.register)("symbol-string",60301),debugReverseContinue:(0,t.register)("debug-reverse-continue",60302),debugStepBack:(0,t.register)("debug-step-back",60303),debugRestartFrame:(0,t.register)("debug-restart-frame",60304),debugAlt:(0,t.register)("debug-alt",60305),callIncoming:(0,t.register)("call-incoming",60306),callOutgoing:(0,t.register)("call-outgoing",60307),menu:(0,t.register)("menu",60308),expandAll:(0,t.register)("expand-all",60309),feedback:(0,t.register)("feedback",60310),gitPullRequestReviewer:(0,t.register)("git-pull-request-reviewer",60310),groupByRefType:(0,t.register)("group-by-ref-type",60311),ungroupByRefType:(0,t.register)("ungroup-by-ref-type",60312),account:(0,t.register)("account",60313),gitPullRequestAssignee:(0,t.register)("git-pull-request-assignee",60313),bellDot:(0,t.register)("bell-dot",60314),debugConsole:(0,t.register)("debug-console",60315),library:(0,t.register)("library",60316),output:(0,t.register)("output",60317),runAll:(0,t.register)("run-all",60318),syncIgnored:(0,t.register)("sync-ignored",60319),pinned:(0,t.register)("pinned",60320),githubInverted:(0,t.register)("github-inverted",60321),serverProcess:(0,t.register)("server-process",60322),serverEnvironment:(0,t.register)("server-environment",60323),pass:(0,t.register)("pass",60324),issueClosed:(0,t.register)("issue-closed",60324),stopCircle:(0,t.register)("stop-circle",60325),playCircle:(0,t.register)("play-circle",60326),record:(0,t.register)("record",60327),debugAltSmall:(0,t.register)("debug-alt-small",60328),vmConnect:(0,t.register)("vm-connect",60329),cloud:(0,t.register)("cloud",60330),merge:(0,t.register)("merge",60331),export:(0,t.register)("export",60332),graphLeft:(0,t.register)("graph-left",60333),magnet:(0,t.register)("magnet",60334),notebook:(0,t.register)("notebook",60335),redo:(0,t.register)("redo",60336),checkAll:(0,t.register)("check-all",60337),pinnedDirty:(0,t.register)("pinned-dirty",60338),passFilled:(0,t.register)("pass-filled",60339),circleLargeFilled:(0,t.register)("circle-large-filled",60340),circleLarge:(0,t.register)("circle-large",60341),circleLargeOutline:(0,t.register)("circle-large-outline",60341),combine:(0,t.register)("combine",60342),gather:(0,t.register)("gather",60342),table:(0,t.register)("table",60343),variableGroup:(0,t.register)("variable-group",60344),typeHierarchy:(0,t.register)("type-hierarchy",60345),typeHierarchySub:(0,t.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.register)("git-pull-request-create",60348),runAbove:(0,t.register)("run-above",60349),runBelow:(0,t.register)("run-below",60350),notebookTemplate:(0,t.register)("notebook-template",60351),debugRerun:(0,t.register)("debug-rerun",60352),workspaceTrusted:(0,t.register)("workspace-trusted",60353),workspaceUntrusted:(0,t.register)("workspace-untrusted",60354),workspaceUnknown:(0,t.register)("workspace-unknown",60355),terminalCmd:(0,t.register)("terminal-cmd",60356),terminalDebian:(0,t.register)("terminal-debian",60357),terminalLinux:(0,t.register)("terminal-linux",60358),terminalPowershell:(0,t.register)("terminal-powershell",60359),terminalTmux:(0,t.register)("terminal-tmux",60360),terminalUbuntu:(0,t.register)("terminal-ubuntu",60361),terminalBash:(0,t.register)("terminal-bash",60362),arrowSwap:(0,t.register)("arrow-swap",60363),copy:(0,t.register)("copy",60364),personAdd:(0,t.register)("person-add",60365),filterFilled:(0,t.register)("filter-filled",60366),wand:(0,t.register)("wand",60367),debugLineByLine:(0,t.register)("debug-line-by-line",60368),inspect:(0,t.register)("inspect",60369),layers:(0,t.register)("layers",60370),layersDot:(0,t.register)("layers-dot",60371),layersActive:(0,t.register)("layers-active",60372),compass:(0,t.register)("compass",60373),compassDot:(0,t.register)("compass-dot",60374),compassActive:(0,t.register)("compass-active",60375),azure:(0,t.register)("azure",60376),issueDraft:(0,t.register)("issue-draft",60377),gitPullRequestClosed:(0,t.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.register)("git-pull-request-draft",60379),debugAll:(0,t.register)("debug-all",60380),debugCoverage:(0,t.register)("debug-coverage",60381),runErrors:(0,t.register)("run-errors",60382),folderLibrary:(0,t.register)("folder-library",60383),debugContinueSmall:(0,t.register)("debug-continue-small",60384),beakerStop:(0,t.register)("beaker-stop",60385),graphLine:(0,t.register)("graph-line",60386),graphScatter:(0,t.register)("graph-scatter",60387),pieChart:(0,t.register)("pie-chart",60388),bracket:(0,t.register)("bracket",60175),bracketDot:(0,t.register)("bracket-dot",60389),bracketError:(0,t.register)("bracket-error",60390),lockSmall:(0,t.register)("lock-small",60391),azureDevops:(0,t.register)("azure-devops",60392),verifiedFilled:(0,t.register)("verified-filled",60393),newline:(0,t.register)("newline",60394),layout:(0,t.register)("layout",60395),layoutActivitybarLeft:(0,t.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.register)("layout-panel-left",60398),layoutPanelCenter:(0,t.register)("layout-panel-center",60399),layoutPanelJustify:(0,t.register)("layout-panel-justify",60400),layoutPanelRight:(0,t.register)("layout-panel-right",60401),layoutPanel:(0,t.register)("layout-panel",60402),layoutSidebarLeft:(0,t.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.register)("layout-sidebar-right",60404),layoutStatusbar:(0,t.register)("layout-statusbar",60405),layoutMenubar:(0,t.register)("layout-menubar",60406),layoutCentered:(0,t.register)("layout-centered",60407),target:(0,t.register)("target",60408),indent:(0,t.register)("indent",60409),recordSmall:(0,t.register)("record-small",60410),errorSmall:(0,t.register)("error-small",60411),terminalDecorationError:(0,t.register)("terminal-decoration-error",60411),arrowCircleDown:(0,t.register)("arrow-circle-down",60412),arrowCircleLeft:(0,t.register)("arrow-circle-left",60413),arrowCircleRight:(0,t.register)("arrow-circle-right",60414),arrowCircleUp:(0,t.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.register)("layout-sidebar-left-off",60418),blank:(0,t.register)("blank",60419),heartFilled:(0,t.register)("heart-filled",60420),map:(0,t.register)("map",60421),mapHorizontal:(0,t.register)("map-horizontal",60421),foldHorizontal:(0,t.register)("fold-horizontal",60421),mapFilled:(0,t.register)("map-filled",60422),mapHorizontalFilled:(0,t.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.register)("fold-horizontal-filled",60422),circleSmall:(0,t.register)("circle-small",60423),bellSlash:(0,t.register)("bell-slash",60424),bellSlashDot:(0,t.register)("bell-slash-dot",60425),commentUnresolved:(0,t.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.register)("search-fuzzy",60429),commentDraft:(0,t.register)("comment-draft",60430),send:(0,t.register)("send",60431),sparkle:(0,t.register)("sparkle",60432),insert:(0,t.register)("insert",60433),mic:(0,t.register)("mic",60434),thumbsdownFilled:(0,t.register)("thumbsdown-filled",60435),thumbsupFilled:(0,t.register)("thumbsup-filled",60436),coffee:(0,t.register)("coffee",60437),snake:(0,t.register)("snake",60438),game:(0,t.register)("game",60439),vr:(0,t.register)("vr",60440),chip:(0,t.register)("chip",60441),piano:(0,t.register)("piano",60442),music:(0,t.register)("music",60443),micFilled:(0,t.register)("mic-filled",60444),repoFetch:(0,t.register)("repo-fetch",60445),copilot:(0,t.register)("copilot",60446),lightbulbSparkle:(0,t.register)("lightbulb-sparkle",60447),robot:(0,t.register)("robot",60448),sparkleFilled:(0,t.register)("sparkle-filled",60449),diffSingle:(0,t.register)("diff-single",60450),diffMultiple:(0,t.register)("diff-multiple",60451),surroundWith:(0,t.register)("surround-with",60452),share:(0,t.register)("share",60453),gitStash:(0,t.register)("git-stash",60454),gitStashApply:(0,t.register)("git-stash-apply",60455),gitStashPop:(0,t.register)("git-stash-pop",60456),vscode:(0,t.register)("vscode",60457),vscodeInsiders:(0,t.register)("vscode-insiders",60458),codeOss:(0,t.register)("code-oss",60459),runCoverage:(0,t.register)("run-coverage",60460),runAllCoverage:(0,t.register)("run-all-coverage",60461),coverage:(0,t.register)("coverage",60462),githubProject:(0,t.register)("github-project",60463),mapVertical:(0,t.register)("map-vertical",60464),foldVertical:(0,t.register)("fold-vertical",60464),mapVerticalFilled:(0,t.register)("map-vertical-filled",60465),foldVerticalFilled:(0,t.register)("fold-vertical-filled",60465),goToSearch:(0,t.register)("go-to-search",60466),percentage:(0,t.register)("percentage",60467),sortPercentage:(0,t.register)("sort-percentage",60467),attach:(0,t.register)("attach",60468)}}),ne(ie[47],re([0,1,28,46]),function(W,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Codicon=i.codiconsDerived=void 0,i.getAllCodicons=M;function M(){return Object.values(i.Codicon)}i.codiconsDerived={dialogError:(0,t.register)("dialog-error","error"),dialogWarning:(0,t.register)("dialog-warning","warning"),dialogInfo:(0,t.register)("dialog-info","info"),dialogClose:(0,t.register)("dialog-close","close"),treeItemExpanded:(0,t.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.register)("tree-filter-clear","close"),treeItemLoading:(0,t.register)("tree-item-loading","loading"),menuSelection:(0,t.register)("menu-selection","check"),menuSubmenu:(0,t.register)("menu-submenu","chevron-right"),menuBarMore:(0,t.register)("menubar-more","more"),scrollbarButtonLeft:(0,t.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.register)("toolbar-more","more"),quickInputBack:(0,t.register)("quick-input-back","arrow-left"),dropDownButton:(0,t.register)("drop-down-button",60084),symbolCustomColor:(0,t.register)("symbol-customcolor",60252),exportIcon:(0,t.register)("export",60332),workspaceUnspecified:(0,t.register)("workspace-unspecified",60355),newLine:(0,t.register)("newline",60394),thumbsDownFilled:(0,t.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.register)("thumbsup-filled",60436),gitFetch:(0,t.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.register)("debug-breakpoint-pending",60377)},i.Codicon={...n.codiconsLibrary,...i.codiconsDerived}}),ne(ie[18],re([0,1,27]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.deepClone=n,i.deepFreeze=M,i.cloneAndChange=p,i.mixin=l,i.equals=a,i.safeStringify=c,i.distinct=_,i.getCaseInsensitive=g,i.filter=b,i.getAllPropertyNames=e,i.getAllMethodNames=L,i.createProxyObject=E,i.mapValues=N;function n(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const v=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([A,d])=>{v[A]=d&&typeof d=="object"?n(d):d}),v}function M(w){if(!w||typeof w!="object")return w;const v=[w];for(;v.length>0;){const A=v.shift();Object.freeze(A);for(const d in A)if(h.call(A,d)){const o=A[d];typeof o=="object"&&!Object.isFrozen(o)&&!(0,t.isTypedArray)(o)&&v.push(o)}}return w}const h=Object.prototype.hasOwnProperty;function p(w,v){return m(w,v,new Set)}function m(w,v,A){if((0,t.isUndefinedOrNull)(w))return w;const d=v(w);if(typeof d<"u")return d;if(Array.isArray(w)){const o=[];for(const r of w)o.push(m(r,v,A));return o}if((0,t.isObject)(w)){if(A.has(w))throw new Error("Cannot clone recursive data-structure");A.add(w);const o={};for(const r in w)h.call(w,r)&&(o[r]=m(w[r],v,A));return A.delete(w),o}return w}function l(w,v,A=!0){return(0,t.isObject)(w)?((0,t.isObject)(v)&&Object.keys(v).forEach(d=>{d in w?A&&((0,t.isObject)(w[d])&&(0,t.isObject)(v[d])?l(w[d],v[d],A):w[d]=v[d]):w[d]=v[d]}),w):v}function a(w,v){if(w===v)return!0;if(w==null||v===null||v===void 0||typeof w!=typeof v||typeof w!="object"||Array.isArray(w)!==Array.isArray(v))return!1;let A,d;if(Array.isArray(w)){if(w.length!==v.length)return!1;for(A=0;A<w.length;A++)if(!a(w[A],v[A]))return!1}else{const o=[];for(d in w)o.push(d);o.sort();const r=[];for(d in v)r.push(d);if(r.sort(),!a(o,r))return!1;for(A=0;A<o.length;A++)if(!a(w[o[A]],v[o[A]]))return!1}return!0}function c(w){const v=new Set;return JSON.stringify(w,(A,d)=>{if((0,t.isObject)(d)||Array.isArray(d)){if(v.has(d))return"[Circular]";v.add(d)}return typeof d=="bigint"?`[BigInt ${d.toString()}]`:d})}function _(w,v){const A=Object.create(null);return!w||!v||Object.keys(v).forEach(o=>{const r=w[o],u=v[o];a(r,u)||(A[o]=u)}),A}function g(w,v){const A=v.toLowerCase(),d=Object.keys(w).find(o=>o.toLowerCase()===A);return d?w[d]:w[v]}function b(w,v){const A=Object.create(null);for(const[d,o]of Object.entries(w))v(d,o)&&(A[d]=o);return A}function e(w){let v=[];for(;Object.prototype!==w;)v=v.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return v}function L(w){const v=[];for(const A of e(w))typeof w[A]=="function"&&v.push(A);return v}function E(w,v){const A=o=>function(){const r=Array.prototype.slice.call(arguments,0);return v(o,r)},d={};for(const o of w)d[o]=A(o);return d}function N(w,v){const A={};for(const[d,o]of Object.entries(w))A[d]=v(o,d);return A}}),ne(ie[14],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Constants=void 0,i.toUint8=n,i.toUint32=M;var t;(function(h){h[h.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",h[h.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",h[h.MAX_UINT_8=255]="MAX_UINT_8",h[h.MAX_UINT_16=65535]="MAX_UINT_16",h[h.MAX_UINT_32=4294967295]="MAX_UINT_32",h[h.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(i.Constants=t={}));function n(h){return h<0?0:h>t.MAX_UINT_8?t.MAX_UINT_8:h|0}function M(h){return h<0?0:h>t.MAX_UINT_32?t.MAX_UINT_32:h|0}}),ne(ie[8],re([0,1,45,4,41,14]),function(W,i,t,n,M,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InvisibleCharacters=i.AmbiguousCharacters=i.noBreakWhitespace=i.GraphemeBreakType=i.UTF8_BOM_CHARACTER=i.UNUSUAL_LINE_TERMINATORS=i.GraphemeIterator=i.CodePointIterator=void 0,i.isFalsyOrWhitespace=p,i.format=l,i.format2=c,i.htmlAttributeEncodeValue=_,i.escape=g,i.escapeRegExpCharacters=b,i.count=e,i.truncate=L,i.truncateMiddle=E,i.trim=N,i.ltrim=w,i.rtrim=v,i.convertSimple2RegExpPattern=A,i.stripWildcards=d,i.createRegExp=o,i.regExpLeadsToEndlessLoop=r,i.splitLines=u,i.splitLinesIncludeSeparators=f,i.firstNonWhitespaceIndex=D,i.getLeadingWhitespace=R,i.lastNonWhitespaceIndex=S,i.replaceAsync=I,i.compare=T,i.compareSubstring=O,i.compareIgnoreCase=P,i.compareSubstringIgnoreCase=y,i.isAsciiDigit=x,i.isLowerAsciiLetter=G,i.isUpperAsciiLetter=U,i.equalsIgnoreCase=B,i.startsWithIgnoreCase=X,i.commonPrefixLength=Y,i.commonSuffixLength=$,i.isHighSurrogate=Z,i.isLowSurrogate=ee,i.computeCodePoint=F,i.getNextCodePoint=C,i.nextCharLength=s,i.prevCharLength=Se,i.getCharContainingOffset=Pe,i.charCount=ze,i.containsRTL=Ue,i.isBasicASCII=z,i.containsUnusualLineTerminators=H,i.isFullWidthCharacter=Q,i.isEmojiImprecise=K,i.lcut=he,i.forAnsiStringParts=ve,i.removeAnsiEscapeCodes=we,i.removeAnsiEscapeCodesFromPrompt=se,i.startsWithUTF8BOM=te,i.stripUTF8BOM=ue,i.fuzzyContains=ae,i.containsUppercaseCharacter=fe,i.uppercaseFirstLetter=me,i.getNLines=_e,i.singleLetterHash=pe,i.getGraphemeBreakType=Ne,i.getLeftDeleteOffset=We;function p(k){return!k||typeof k!="string"?!0:k.trim().length===0}const m=/{(\d+)}/g;function l(k,...q){return q.length===0?k:k.replace(m,function(j,J){const le=parseInt(J,10);return isNaN(le)||le<0||le>=q.length?j:q[le]})}const a=/{([^}]+)}/g;function c(k,q){return Object.keys(q).length===0?k:k.replace(a,(j,J)=>q[J]??j)}function _(k){return k.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function g(k){return k.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function b(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(k,q){let j=0,J=k.indexOf(q);for(;J!==-1;)j++,J=k.indexOf(q,J+q.length);return j}function L(k,q,j="\u2026"){return k.length<=q?k:`${k.substr(0,q)}${j}`}function E(k,q,j="\u2026"){if(k.length<=q)return k;const J=Math.ceil(q/2)-j.length/2,le=Math.floor(q/2)-j.length/2;return`${k.substr(0,J)}${j}${k.substr(k.length-le)}`}function N(k,q=" "){const j=w(k,q);return v(j,q)}function w(k,q){if(!k||!q)return k;const j=q.length;if(j===0||k.length===0)return k;let J=0;for(;k.indexOf(q,J)===J;)J=J+j;return k.substring(J)}function v(k,q){if(!k||!q)return k;const j=q.length,J=k.length;if(j===0||J===0)return k;let le=J,de=-1;for(;de=k.lastIndexOf(q,le-1),!(de===-1||de+j!==le);){if(de===0)return"";le=de}return k.substring(0,le)}function A(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function d(k){return k.replace(/\*/g,"")}function o(k,q,j={}){if(!k)throw new Error("Cannot create regex from empty string");q||(k=b(k)),j.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let J="";return j.global&&(J+="g"),j.matchCase||(J+="i"),j.multiline&&(J+="m"),j.unicode&&(J+="u"),new RegExp(k,J)}function r(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}function u(k){return k.split(/\r\n|\r|\n/)}function f(k){const q=[],j=k.split(/(\r\n|\r|\n)/);for(let J=0;J<Math.ceil(j.length/2);J++)q.push(j[2*J]+(j[2*J+1]??""));return q}function D(k){for(let q=0,j=k.length;q<j;q++){const J=k.charCodeAt(q);if(J!==n.CharCode.Space&&J!==n.CharCode.Tab)return q}return-1}function R(k,q=0,j=k.length){for(let J=q;J<j;J++){const le=k.charCodeAt(J);if(le!==n.CharCode.Space&&le!==n.CharCode.Tab)return k.substring(q,J)}return k.substring(q,j)}function S(k,q=k.length-1){for(let j=q;j>=0;j--){const J=k.charCodeAt(j);if(J!==n.CharCode.Space&&J!==n.CharCode.Tab)return j}return-1}function I(k,q,j){const J=[];let le=0;for(const de of k.matchAll(q)){if(J.push(k.slice(le,de.index)),de.index===void 0)throw new Error("match.index should be defined");le=de.index+de[0].length,J.push(j(de[0],...de.slice(1),de.index,k,de.groups))}return J.push(k.slice(le)),Promise.all(J).then(de=>de.join(""))}function T(k,q){return k<q?-1:k>q?1:0}function O(k,q,j=0,J=k.length,le=0,de=q.length){for(;j<J&&le<de;j++,le++){const Ie=k.charCodeAt(j),ye=q.charCodeAt(le);if(Ie<ye)return-1;if(Ie>ye)return 1}const Ae=J-j,Oe=de-le;return Ae<Oe?-1:Ae>Oe?1:0}function P(k,q){return y(k,q,0,k.length,0,q.length)}function y(k,q,j=0,J=k.length,le=0,de=q.length){for(;j<J&&le<de;j++,le++){let Ie=k.charCodeAt(j),ye=q.charCodeAt(le);if(Ie===ye)continue;if(Ie>=128||ye>=128)return O(k.toLowerCase(),q.toLowerCase(),j,J,le,de);G(Ie)&&(Ie-=32),G(ye)&&(ye-=32);const Me=Ie-ye;if(Me!==0)return Me}const Ae=J-j,Oe=de-le;return Ae<Oe?-1:Ae>Oe?1:0}function x(k){return k>=n.CharCode.Digit0&&k<=n.CharCode.Digit9}function G(k){return k>=n.CharCode.a&&k<=n.CharCode.z}function U(k){return k>=n.CharCode.A&&k<=n.CharCode.Z}function B(k,q){return k.length===q.length&&y(k,q)===0}function X(k,q){const j=q.length;return q.length>k.length?!1:y(k,q,0,j)===0}function Y(k,q){const j=Math.min(k.length,q.length);let J;for(J=0;J<j;J++)if(k.charCodeAt(J)!==q.charCodeAt(J))return J;return j}function $(k,q){const j=Math.min(k.length,q.length);let J;const le=k.length-1,de=q.length-1;for(J=0;J<j;J++)if(k.charCodeAt(le-J)!==q.charCodeAt(de-J))return J;return j}function Z(k){return 55296<=k&&k<=56319}function ee(k){return 56320<=k&&k<=57343}function F(k,q){return(k-55296<<10)+(q-56320)+65536}function C(k,q,j){const J=k.charCodeAt(j);if(Z(J)&&j+1<q){const le=k.charCodeAt(j+1);if(ee(le))return F(J,le)}return J}function ce(k,q){const j=k.charCodeAt(q-1);if(ee(j)&&q>1){const J=k.charCodeAt(q-2);if(Z(J))return F(J,j)}return j}class oe{get offset(){return this._offset}constructor(q,j=0){this._str=q,this._len=q.length,this._offset=j}setOffset(q){this._offset=q}prevCodePoint(){const q=ce(this._str,this._offset);return this._offset-=q>=h.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,q}nextCodePoint(){const q=C(this._str,this._len,this._offset);return this._offset+=q>=h.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,q}eol(){return this._offset>=this._len}}i.CodePointIterator=oe;class Le{get offset(){return this._iterator.offset}constructor(q,j=0){this._iterator=new oe(q,j)}nextGraphemeLength(){const q=De.getInstance(),j=this._iterator,J=j.offset;let le=q.getGraphemeBreakType(j.nextCodePoint());for(;!j.eol();){const de=j.offset,Ae=q.getGraphemeBreakType(j.nextCodePoint());if(ke(le,Ae)){j.setOffset(de);break}le=Ae}return j.offset-J}prevGraphemeLength(){const q=De.getInstance(),j=this._iterator,J=j.offset;let le=q.getGraphemeBreakType(j.prevCodePoint());for(;j.offset>0;){const de=j.offset,Ae=q.getGraphemeBreakType(j.prevCodePoint());if(ke(Ae,le)){j.setOffset(de);break}le=Ae}return J-j.offset}eol(){return this._iterator.eol()}}i.GraphemeIterator=Le;function s(k,q){return new Le(k,q).nextGraphemeLength()}function Se(k,q){return new Le(k,q).prevGraphemeLength()}function Pe(k,q){q>0&&ee(k.charCodeAt(q))&&q--;const j=q+s(k,q);return[j-Se(k,j),j]}function ze(k){const q=new Le(k);let j=0;for(;!q.eol();)j++,q.nextGraphemeLength();return j}let Te;function qe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ue(k){return Te||(Te=qe()),Te.test(k)}const V=/^[\t\n\r\x20-\x7E]*$/;function z(k){return V.test(k)}i.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(k){return i.UNUSUAL_LINE_TERMINATORS.test(k)}function Q(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}function K(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}function he(k,q,j=""){const J=k.trimStart();if(J.length<q)return J;const le=/\b/g;let de=0;for(;le.test(J)&&!(J.length-le.lastIndex<q);)de=le.lastIndex,le.lastIndex+=1;return de===0?J:j+J.substring(de).trimStart()}const be=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ve(k){let q=0;for(const j of k.matchAll(be))q!==j.index&&(yield{isCode:!1,str:k.substring(q,j.index)}),yield{isCode:!0,str:j[0]},q=j.index+j[0].length;q!==k.length&&(yield{isCode:!1,str:k.substring(q)})}function we(k){return k&&(k=k.replace(be,"")),k}const Re=/\\\[.*?\\\]/g;function se(k){return we(k).replace(Re,"")}i.UTF8_BOM_CHARACTER=String.fromCharCode(n.CharCode.UTF8_BOM);function te(k){return!!(k&&k.length>0&&k.charCodeAt(0)===n.CharCode.UTF8_BOM)}function ue(k){return te(k)?k.substr(1):k}function ae(k,q){if(!k||!q||k.length<q.length)return!1;const j=q.length,J=k.toLowerCase();let le=0,de=-1;for(;le<j;){const Ae=J.indexOf(q[le],de+1);if(Ae<0)return!1;de=Ae,le++}return!0}function fe(k,q=!1){return k?(q&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}function me(k){return k.charAt(0).toUpperCase()+k.slice(1)}function _e(k,q=1){if(q===0)return"";let j=-1;do j=k.indexOf(`
`,j+1),q--;while(q>0&&j>=0);return j===-1?k:(k[j-1]==="\r"&&j--,k.substr(0,j))}function pe(k){const q=n.CharCode.Z-n.CharCode.A+1;return k=k%(2*q),k<q?String.fromCharCode(n.CharCode.a+k):String.fromCharCode(n.CharCode.A+k-q)}function Ne(k){return De.getInstance().getGraphemeBreakType(k)}function ke(k,q){return k===ge.Other?q!==ge.Extend&&q!==ge.SpacingMark:k===ge.CR&&q===ge.LF?!1:k===ge.Control||k===ge.CR||k===ge.LF||q===ge.Control||q===ge.CR||q===ge.LF?!0:!(k===ge.L&&(q===ge.L||q===ge.V||q===ge.LV||q===ge.LVT)||(k===ge.LV||k===ge.V)&&(q===ge.V||q===ge.T)||(k===ge.LVT||k===ge.T)&&q===ge.T||q===ge.Extend||q===ge.ZWJ||q===ge.SpacingMark||k===ge.Prepend||k===ge.ZWJ&&q===ge.Extended_Pictographic||k===ge.Regional_Indicator&&q===ge.Regional_Indicator)}var ge;(function(k){k[k.Other=0]="Other",k[k.Prepend=1]="Prepend",k[k.CR=2]="CR",k[k.LF=3]="LF",k[k.Control=4]="Control",k[k.Extend=5]="Extend",k[k.Regional_Indicator=6]="Regional_Indicator",k[k.SpacingMark=7]="SpacingMark",k[k.L=8]="L",k[k.V=9]="V",k[k.T=10]="T",k[k.LV=11]="LV",k[k.LVT=12]="LVT",k[k.ZWJ=13]="ZWJ",k[k.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(i.GraphemeBreakType=ge={}));class De{static{this._INSTANCE=null}static getInstance(){return De._INSTANCE||(De._INSTANCE=new De),De._INSTANCE}constructor(){this._data=Ce()}getGraphemeBreakType(q){if(q<32)return q===n.CharCode.LineFeed?ge.LF:q===n.CharCode.CarriageReturn?ge.CR:ge.Control;if(q<127)return ge.Other;const j=this._data,J=j.length/3;let le=1;for(;le<=J;)if(q<j[3*le])le=2*le;else if(q>j[3*le+1])le=2*le+1;else return j[3*le+2];return ge.Other}}function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(k,q){if(k===0)return 0;const j=$e(k,q);if(j!==void 0)return j;const J=new oe(q,k);return J.prevCodePoint(),J.offset}function $e(k,q){const j=new oe(q,k);let J=j.prevCodePoint();for(;Xe(J)||J===Ge.emojiVariantSelector||J===Ge.enclosingKeyCap;){if(j.offset===0)return;J=j.prevCodePoint()}if(!K(J))return;let le=j.offset;return le>0&&j.prevCodePoint()===Ge.zwj&&(le=j.offset),le}function Xe(k){return 127995<=k&&k<=127999}var Ge;(function(k){k[k.zwj=8205]="zwj",k[k.emojiVariantSelector=65039]="emojiVariantSelector",k[k.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),i.noBreakWhitespace="\xA0";class Ve{static{this.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new t.LRUCachedFunction({getCacheKey:JSON.stringify},q=>{function j(Me){const xe=new Map;for(let Fe=0;Fe<Me.length;Fe+=2)xe.set(Me[Fe],Me[Fe+1]);return xe}function J(Me,xe){const Fe=new Map(Me);for(const[je,Ye]of xe)Fe.set(je,Ye);return Fe}function le(Me,xe){if(!Me)return xe;const Fe=new Map;for(const[je,Ye]of Me)xe.has(je)&&Fe.set(je,Ye);return Fe}const de=this.ambiguousCharacterData.value;let Ae=q.filter(Me=>!Me.startsWith("_")&&Me in de);Ae.length===0&&(Ae=["_default"]);let Oe;for(const Me of Ae){const xe=j(de[Me]);Oe=le(Oe,xe)}const Ie=j(de._common),ye=J(Ie,Oe);return new Ve(ye)})}static getInstance(q){return Ve.cache.get(Array.from(q))}static{this._locales=new M.Lazy(()=>Object.keys(Ve.ambiguousCharacterData.value).filter(q=>!q.startsWith("_")))}static getLocales(){return Ve._locales.value}constructor(q){this.confusableDictionary=q}isAmbiguous(q){return this.confusableDictionary.has(q)}containsAmbiguousCharacter(q){for(let j=0;j<q.length;j++){const J=q.codePointAt(j);if(typeof J=="number"&&this.isAmbiguous(J))return!0}return!1}getPrimaryConfusable(q){return this.confusableDictionary.get(q)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}i.AmbiguousCharacters=Ve;class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(q){return He.getData().has(q)}static containsInvisibleCharacter(q){for(let j=0;j<q.length;j++){const J=q.codePointAt(j);if(typeof J=="number"&&He.isInvisibleCharacter(J))return!0}return!1}static get codePoints(){return He.getData()}}i.InvisibleCharacters=He}),ne(ie[48],re([0,1,8]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.Hasher=void 0,i.hash=n,i.doHash=M,i.numberHash=h,i.stringHash=m,i.toHexString=L,t=Be(t);function n(N){return M(N,0)}function M(N,w){switch(typeof N){case"object":return N===null?h(349,w):Array.isArray(N)?l(N,w):a(N,w);case"string":return m(N,w);case"boolean":return p(N,w);case"number":return h(N,w);case"undefined":return h(937,w);default:return h(617,w)}}function h(N,w){return(w<<5)-w+N|0}function p(N,w){return h(N?433:863,w)}function m(N,w){w=h(149417,w);for(let v=0,A=N.length;v<A;v++)w=h(N.charCodeAt(v),w);return w}function l(N,w){return w=h(104579,w),N.reduce((v,A)=>M(A,v),w)}function a(N,w){return w=h(181387,w),Object.keys(N).sort().reduce((v,A)=>(v=m(A,v),M(N[A],v)),w)}class c{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=M(w,this._value),this._value}}i.Hasher=c;var _;(function(N){N[N.BLOCK_SIZE=64]="BLOCK_SIZE",N[N.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(_||(_={}));function g(N,w,v=32){const A=v-w,d=~((1<<A)-1);return(N<<w|(d&N)>>>A)>>>0}function b(N,w=0,v=N.byteLength,A=0){for(let d=0;d<v;d++)N[w+d]=A}function e(N,w,v="0"){for(;N.length<w;)N=v+N;return N}function L(N,w=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((N>>>0).toString(16),w/4)}class E{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(_.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const v=w.length;if(v===0)return;const A=this._buff;let d=this._buffLen,o=this._leftoverHighSurrogate,r,u;for(o!==0?(r=o,u=-1,o=0):(r=w.charCodeAt(0),u=0);;){let f=r;if(t.isHighSurrogate(r))if(u+1<v){const D=w.charCodeAt(u+1);t.isLowSurrogate(D)?(u++,f=t.computeCodePoint(r,D)):f=_.UNICODE_REPLACEMENT}else{o=r;break}else t.isLowSurrogate(r)&&(f=_.UNICODE_REPLACEMENT);if(d=this._push(A,d,f),u++,u<v)r=w.charCodeAt(u);else break}this._buffLen=d,this._leftoverHighSurrogate=o}_push(w,v,A){return A<128?w[v++]=A:A<2048?(w[v++]=192|(A&1984)>>>6,w[v++]=128|(A&63)>>>0):A<65536?(w[v++]=224|(A&61440)>>>12,w[v++]=128|(A&4032)>>>6,w[v++]=128|(A&63)>>>0):(w[v++]=240|(A&1835008)>>>18,w[v++]=128|(A&258048)>>>12,w[v++]=128|(A&4032)>>>6,w[v++]=128|(A&63)>>>0),v>=_.BLOCK_SIZE&&(this._step(),v-=_.BLOCK_SIZE,this._totalLen+=_.BLOCK_SIZE,w[0]=w[_.BLOCK_SIZE+0],w[1]=w[_.BLOCK_SIZE+1],w[2]=w[_.BLOCK_SIZE+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,_.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),L(this._h0)+L(this._h1)+L(this._h2)+L(this._h3)+L(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=E._bigBlock32,v=this._buffDV;for(let S=0;S<64;S+=4)w.setUint32(S,v.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)w.setUint32(S,g(w.getUint32(S-12,!1)^w.getUint32(S-32,!1)^w.getUint32(S-56,!1)^w.getUint32(S-64,!1),1),!1);let A=this._h0,d=this._h1,o=this._h2,r=this._h3,u=this._h4,f,D,R;for(let S=0;S<80;S++)S<20?(f=d&o|~d&r,D=1518500249):S<40?(f=d^o^r,D=1859775393):S<60?(f=d&o|d&r|o&r,D=2400959708):(f=d^o^r,D=3395469782),R=g(A,5)+f+u+D+w.getUint32(S*4,!1)&4294967295,u=r,r=o,o=g(d,30),d=A,A=R;this._h0=this._h0+A&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+u&4294967295}}i.StringSHA1=E}),ne(ie[29],re([0,1,39,48,14]),function(W,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LcsDiff=i.StringDiffSequence=void 0,i.stringDiff=p;class h{constructor(b){this.source=b}getElements(){const b=this.source,e=new Int32Array(b.length);for(let L=0,E=b.length;L<E;L++)e[L]=b.charCodeAt(L);return e}}i.StringDiffSequence=h;function p(g,b,e){return new _(new h(g),new h(b)).ComputeDiff(e).changes}class m{static Assert(b,e){if(!b)throw new Error(e)}}class l{static Copy(b,e,L,E,N){for(let w=0;w<N;w++)L[E+w]=b[e+w]}static Copy2(b,e,L,E,N){for(let w=0;w<N;w++)L[E+w]=b[e+w]}}var a;(function(g){g[g.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class c{constructor(){this.m_changes=[],this.m_originalStart=M.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=M.Constants.MAX_SAFE_SMALL_INTEGER,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new t.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=M.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=M.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(b,e){this.m_originalStart=Math.min(this.m_originalStart,b),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_originalCount++}AddModifiedElement(b,e){this.m_originalStart=Math.min(this.m_originalStart,b),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class _{constructor(b,e,L=null){this.ContinueProcessingPredicate=L,this._originalSequence=b,this._modifiedSequence=e;const[E,N,w]=_._getElements(b),[v,A,d]=_._getElements(e);this._hasStrings=w&&d,this._originalStringElements=E,this._originalElementsOrHash=N,this._modifiedStringElements=v,this._modifiedElementsOrHash=A,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(b){return b.length>0&&typeof b[0]=="string"}static _getElements(b){const e=b.getElements();if(_._isStringArray(e)){const L=new Int32Array(e.length);for(let E=0,N=e.length;E<N;E++)L[E]=(0,n.stringHash)(e[E],0);return[e,L,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}ElementsAreEqual(b,e){return this._originalElementsOrHash[b]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[b]===this._modifiedStringElements[e]:!0}ElementsAreStrictEqual(b,e){if(!this.ElementsAreEqual(b,e))return!1;const L=_._getStrictElement(this._originalSequence,b),E=_._getStrictElement(this._modifiedSequence,e);return L===E}static _getStrictElement(b,e){return typeof b.getStrictElement=="function"?b.getStrictElement(e):null}OriginalElementsAreEqual(b,e){return this._originalElementsOrHash[b]!==this._originalElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[b]===this._originalStringElements[e]:!0}ModifiedElementsAreEqual(b,e){return this._modifiedElementsOrHash[b]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._modifiedStringElements[b]===this._modifiedStringElements[e]:!0}ComputeDiff(b){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,b)}_ComputeDiff(b,e,L,E,N){const w=[!1];let v=this.ComputeDiffRecursive(b,e,L,E,w);return N&&(v=this.PrettifyChanges(v)),{quitEarly:w[0],changes:v}}ComputeDiffRecursive(b,e,L,E,N){for(N[0]=!1;b<=e&&L<=E&&this.ElementsAreEqual(b,L);)b++,L++;for(;e>=b&&E>=L&&this.ElementsAreEqual(e,E);)e--,E--;if(b>e||L>E){let r;return L<=E?(m.Assert(b===e+1,"originalStart should only be one more than originalEnd"),r=[new t.DiffChange(b,0,L,E-L+1)]):b<=e?(m.Assert(L===E+1,"modifiedStart should only be one more than modifiedEnd"),r=[new t.DiffChange(b,e-b+1,L,0)]):(m.Assert(b===e+1,"originalStart should only be one more than originalEnd"),m.Assert(L===E+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const w=[0],v=[0],A=this.ComputeRecursionPoint(b,e,L,E,w,v,N),d=w[0],o=v[0];if(A!==null)return A;if(!N[0]){const r=this.ComputeDiffRecursive(b,d,L,o,N);let u=[];return N[0]?u=[new t.DiffChange(d+1,e-(d+1)+1,o+1,E-(o+1)+1)]:u=this.ComputeDiffRecursive(d+1,e,o+1,E,N),this.ConcatenateChanges(r,u)}return[new t.DiffChange(b,e-b+1,L,E-L+1)]}WALKTRACE(b,e,L,E,N,w,v,A,d,o,r,u,f,D,R,S,I,T){let O=null,P=null,y=new c,x=e,G=L,U=f[0]-S[0]-E,B=M.Constants.MIN_SAFE_SMALL_INTEGER,X=this.m_forwardHistory.length-1;do{const Y=U+b;Y===x||Y<G&&d[Y-1]<d[Y+1]?(r=d[Y+1],D=r-U-E,r<B&&y.MarkNextChange(),B=r,y.AddModifiedElement(r+1,D),U=Y+1-b):(r=d[Y-1]+1,D=r-U-E,r<B&&y.MarkNextChange(),B=r-1,y.AddOriginalElement(r,D+1),U=Y-1-b),X>=0&&(d=this.m_forwardHistory[X],b=d[0],x=1,G=d.length-1)}while(--X>=-1);if(O=y.getReverseChanges(),T[0]){let Y=f[0]+1,$=S[0]+1;if(O!==null&&O.length>0){const Z=O[O.length-1];Y=Math.max(Y,Z.getOriginalEnd()),$=Math.max($,Z.getModifiedEnd())}P=[new t.DiffChange(Y,u-Y+1,$,R-$+1)]}else{y=new c,x=w,G=v,U=f[0]-S[0]-A,B=M.Constants.MAX_SAFE_SMALL_INTEGER,X=I?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const Y=U+N;Y===x||Y<G&&o[Y-1]>=o[Y+1]?(r=o[Y+1]-1,D=r-U-A,r>B&&y.MarkNextChange(),B=r+1,y.AddOriginalElement(r+1,D+1),U=Y+1-N):(r=o[Y-1],D=r-U-A,r>B&&y.MarkNextChange(),B=r,y.AddModifiedElement(r+1,D+1),U=Y-1-N),X>=0&&(o=this.m_reverseHistory[X],N=o[0],x=1,G=o.length-1)}while(--X>=-1);P=y.getChanges()}return this.ConcatenateChanges(O,P)}ComputeRecursionPoint(b,e,L,E,N,w,v){let A=0,d=0,o=0,r=0,u=0,f=0;b--,L--,N[0]=0,w[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const D=e-b+(E-L),R=D+1,S=new Int32Array(R),I=new Int32Array(R),T=E-L,O=e-b,P=b-L,y=e-E,G=(O-T)%2===0;S[T]=b,I[O]=e,v[0]=!1;for(let U=1;U<=D/2+1;U++){let B=0,X=0;o=this.ClipDiagonalBound(T-U,U,T,R),r=this.ClipDiagonalBound(T+U,U,T,R);for(let $=o;$<=r;$+=2){$===o||$<r&&S[$-1]<S[$+1]?A=S[$+1]:A=S[$-1]+1,d=A-($-T)-P;const Z=A;for(;A<e&&d<E&&this.ElementsAreEqual(A+1,d+1);)A++,d++;if(S[$]=A,A+d>B+X&&(B=A,X=d),!G&&Math.abs($-O)<=U-1&&A>=I[$])return N[0]=A,w[0]=d,Z<=I[$]&&a.MaxDifferencesHistory>0&&U<=a.MaxDifferencesHistory+1?this.WALKTRACE(T,o,r,P,O,u,f,y,S,I,A,e,N,d,E,w,G,v):null}const Y=(B-b+(X-L)-U)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(B,Y))return v[0]=!0,N[0]=B,w[0]=X,Y>0&&a.MaxDifferencesHistory>0&&U<=a.MaxDifferencesHistory+1?this.WALKTRACE(T,o,r,P,O,u,f,y,S,I,A,e,N,d,E,w,G,v):(b++,L++,[new t.DiffChange(b,e-b+1,L,E-L+1)]);u=this.ClipDiagonalBound(O-U,U,O,R),f=this.ClipDiagonalBound(O+U,U,O,R);for(let $=u;$<=f;$+=2){$===u||$<f&&I[$-1]>=I[$+1]?A=I[$+1]-1:A=I[$-1],d=A-($-O)-y;const Z=A;for(;A>b&&d>L&&this.ElementsAreEqual(A,d);)A--,d--;if(I[$]=A,G&&Math.abs($-T)<=U&&A<=S[$])return N[0]=A,w[0]=d,Z>=S[$]&&a.MaxDifferencesHistory>0&&U<=a.MaxDifferencesHistory+1?this.WALKTRACE(T,o,r,P,O,u,f,y,S,I,A,e,N,d,E,w,G,v):null}if(U<=a.MaxDifferencesHistory){let $=new Int32Array(r-o+2);$[0]=T-o+1,l.Copy2(S,o,$,1,r-o+1),this.m_forwardHistory.push($),$=new Int32Array(f-u+2),$[0]=O-u+1,l.Copy2(I,u,$,1,f-u+1),this.m_reverseHistory.push($)}}return this.WALKTRACE(T,o,r,P,O,u,f,y,S,I,A,e,N,d,E,w,G,v)}PrettifyChanges(b){for(let e=0;e<b.length;e++){const L=b[e],E=e<b.length-1?b[e+1].originalStart:this._originalElementsOrHash.length,N=e<b.length-1?b[e+1].modifiedStart:this._modifiedElementsOrHash.length,w=L.originalLength>0,v=L.modifiedLength>0;for(;L.originalStart+L.originalLength<E&&L.modifiedStart+L.modifiedLength<N&&(!w||this.OriginalElementsAreEqual(L.originalStart,L.originalStart+L.originalLength))&&(!v||this.ModifiedElementsAreEqual(L.modifiedStart,L.modifiedStart+L.modifiedLength));){const d=this.ElementsAreStrictEqual(L.originalStart,L.modifiedStart);if(this.ElementsAreStrictEqual(L.originalStart+L.originalLength,L.modifiedStart+L.modifiedLength)&&!d)break;L.originalStart++,L.modifiedStart++}const A=[null];if(e<b.length-1&&this.ChangesOverlap(b[e],b[e+1],A)){b[e]=A[0],b.splice(e+1,1),e--;continue}}for(let e=b.length-1;e>=0;e--){const L=b[e];let E=0,N=0;if(e>0){const r=b[e-1];E=r.originalStart+r.originalLength,N=r.modifiedStart+r.modifiedLength}const w=L.originalLength>0,v=L.modifiedLength>0;let A=0,d=this._boundaryScore(L.originalStart,L.originalLength,L.modifiedStart,L.modifiedLength);for(let r=1;;r++){const u=L.originalStart-r,f=L.modifiedStart-r;if(u<E||f<N||w&&!this.OriginalElementsAreEqual(u,u+L.originalLength)||v&&!this.ModifiedElementsAreEqual(f,f+L.modifiedLength))break;const R=(u===E&&f===N?5:0)+this._boundaryScore(u,L.originalLength,f,L.modifiedLength);R>d&&(d=R,A=r)}L.originalStart-=A,L.modifiedStart-=A;const o=[null];if(e>0&&this.ChangesOverlap(b[e-1],b[e],o)){b[e-1]=o[0],b.splice(e,1),e++;continue}}if(this._hasStrings)for(let e=1,L=b.length;e<L;e++){const E=b[e-1],N=b[e],w=N.originalStart-E.originalStart-E.originalLength,v=E.originalStart,A=N.originalStart+N.originalLength,d=A-v,o=E.modifiedStart,r=N.modifiedStart+N.modifiedLength,u=r-o;if(w<5&&d<20&&u<20){const f=this._findBetterContiguousSequence(v,d,o,u,w);if(f){const[D,R]=f;(D!==E.originalStart+E.originalLength||R!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=D-E.originalStart,E.modifiedLength=R-E.modifiedStart,N.originalStart=D+w,N.modifiedStart=R+w,N.originalLength=A-N.originalStart,N.modifiedLength=r-N.modifiedStart)}}}return b}_findBetterContiguousSequence(b,e,L,E,N){if(e<N||E<N)return null;const w=b+e-N+1,v=L+E-N+1;let A=0,d=0,o=0;for(let r=b;r<w;r++)for(let u=L;u<v;u++){const f=this._contiguousSequenceScore(r,u,N);f>0&&f>A&&(A=f,d=r,o=u)}return A>0?[d,o]:null}_contiguousSequenceScore(b,e,L){let E=0;for(let N=0;N<L;N++){if(!this.ElementsAreEqual(b+N,e+N))return 0;E+=this._originalStringElements[b+N].length}return E}_OriginalIsBoundary(b){return b<=0||b>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[b])}_OriginalRegionIsBoundary(b,e){if(this._OriginalIsBoundary(b)||this._OriginalIsBoundary(b-1))return!0;if(e>0){const L=b+e;if(this._OriginalIsBoundary(L-1)||this._OriginalIsBoundary(L))return!0}return!1}_ModifiedIsBoundary(b){return b<=0||b>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[b])}_ModifiedRegionIsBoundary(b,e){if(this._ModifiedIsBoundary(b)||this._ModifiedIsBoundary(b-1))return!0;if(e>0){const L=b+e;if(this._ModifiedIsBoundary(L-1)||this._ModifiedIsBoundary(L))return!0}return!1}_boundaryScore(b,e,L,E){const N=this._OriginalRegionIsBoundary(b,e)?1:0,w=this._ModifiedRegionIsBoundary(L,E)?1:0;return N+w}ConcatenateChanges(b,e){const L=[];if(b.length===0||e.length===0)return e.length>0?e:b;if(this.ChangesOverlap(b[b.length-1],e[0],L)){const E=new Array(b.length+e.length-1);return l.Copy(b,0,E,0,b.length-1),E[b.length-1]=L[0],l.Copy(e,1,E,b.length,e.length-1),E}else{const E=new Array(b.length+e.length);return l.Copy(b,0,E,0,b.length),l.Copy(e,0,E,b.length,e.length),E}}ChangesOverlap(b,e,L){if(m.Assert(b.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),m.Assert(b.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=e.originalStart||b.modifiedStart+b.modifiedLength>=e.modifiedStart){const E=b.originalStart;let N=b.originalLength;const w=b.modifiedStart;let v=b.modifiedLength;return b.originalStart+b.originalLength>=e.originalStart&&(N=e.originalStart+e.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=e.modifiedStart&&(v=e.modifiedStart+e.modifiedLength-b.modifiedStart),L[0]=new t.DiffChange(E,N,w,v),!0}else return L[0]=null,!1}ClipDiagonalBound(b,e,L,E){if(b>=0&&b<E)return b;const N=L,w=E-L-1,v=e%2===0;if(b<0){const A=N%2===0;return v===A?0:1}else{const A=w%2===0;return v===A?E-1:E-2}}}i.LcsDiff=_}),ne(ie[19],re([0,1,4,42,44,17]),function(W,i,t,n,M,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.URI=void 0,i.isUriComponents=E,i.uriToFsPath=o,M=Be(M);const p=/^\w[\w\d+.-]*$/,m=/^\//,l=/^\/\//;function a(R,S){if(!R.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!p.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!m.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(l.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(R,S){return!R&&!S?"file":R}function _(R,S){switch(R){case"https":case"http":case"file":S?S[0]!==b&&(S=b+S):S=b;break}return S}const g="",b="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class L{static isUri(S){return S instanceof L?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,I,T,O,P,y=!1){typeof S=="object"?(this.scheme=S.scheme||g,this.authority=S.authority||g,this.path=S.path||g,this.query=S.query||g,this.fragment=S.fragment||g):(this.scheme=c(S,y),this.authority=I||g,this.path=_(this.scheme,T||g),this.query=O||g,this.fragment=P||g,a(this,y))}get fsPath(){return o(this,!1)}with(S){if(!S)return this;let{scheme:I,authority:T,path:O,query:P,fragment:y}=S;return I===void 0?I=this.scheme:I===null&&(I=g),T===void 0?T=this.authority:T===null&&(T=g),O===void 0?O=this.path:O===null&&(O=g),P===void 0?P=this.query:P===null&&(P=g),y===void 0?y=this.fragment:y===null&&(y=g),I===this.scheme&&T===this.authority&&O===this.path&&P===this.query&&y===this.fragment?this:new w(I,T,O,P,y)}static parse(S,I=!1){const T=e.exec(S);return T?new w(T[2]||g,D(T[4]||g),D(T[5]||g),D(T[7]||g),D(T[9]||g),I):new w(g,g,g,g,g)}static file(S){let I=g;if(h.isWindows&&(S=S.replace(/\\/g,b)),S[0]===b&&S[1]===b){const T=S.indexOf(b,2);T===-1?(I=S.substring(2),S=b):(I=S.substring(2,T),S=S.substring(T)||b)}return new w("file",I,S,g,g)}static from(S,I){return new w(S.scheme,S.authority,S.path,S.query,S.fragment,I)}static joinPath(S,...I){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let T;return h.isWindows&&S.scheme==="file"?T=L.file(M.win32.join(o(S,!0),...I)).path:T=M.posix.join(S.path,...I),S.with({path:T})}toString(S=!1){return r(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof L)return S;{const I=new w(S);return I._formatted=S.external??null,I._fsPath=S._sep===N?S.fsPath??null:null,I}}else return S}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}i.URI=L;function E(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}const N=h.isWindows?1:void 0;class w extends L{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(S=!1){return S?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const S={$mid:n.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=N),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const v={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function A(R,S,I){let T,O=-1;for(let P=0;P<R.length;P++){const y=R.charCodeAt(P);if(y>=t.CharCode.a&&y<=t.CharCode.z||y>=t.CharCode.A&&y<=t.CharCode.Z||y>=t.CharCode.Digit0&&y<=t.CharCode.Digit9||y===t.CharCode.Dash||y===t.CharCode.Period||y===t.CharCode.Underline||y===t.CharCode.Tilde||S&&y===t.CharCode.Slash||I&&y===t.CharCode.OpenSquareBracket||I&&y===t.CharCode.CloseSquareBracket||I&&y===t.CharCode.Colon)O!==-1&&(T+=encodeURIComponent(R.substring(O,P)),O=-1),T!==void 0&&(T+=R.charAt(P));else{T===void 0&&(T=R.substr(0,P));const x=v[y];x!==void 0?(O!==-1&&(T+=encodeURIComponent(R.substring(O,P)),O=-1),T+=x):O===-1&&(O=P)}}return O!==-1&&(T+=encodeURIComponent(R.substring(O))),T!==void 0?T:R}function d(R){let S;for(let I=0;I<R.length;I++){const T=R.charCodeAt(I);T===t.CharCode.Hash||T===t.CharCode.QuestionMark?(S===void 0&&(S=R.substr(0,I)),S+=v[T]):S!==void 0&&(S+=R[I])}return S!==void 0?S:R}function o(R,S){let I;return R.authority&&R.path.length>1&&R.scheme==="file"?I=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===t.CharCode.Slash&&(R.path.charCodeAt(1)>=t.CharCode.A&&R.path.charCodeAt(1)<=t.CharCode.Z||R.path.charCodeAt(1)>=t.CharCode.a&&R.path.charCodeAt(1)<=t.CharCode.z)&&R.path.charCodeAt(2)===t.CharCode.Colon?S?I=R.path.substr(1):I=R.path[1].toLowerCase()+R.path.substr(2):I=R.path,h.isWindows&&(I=I.replace(/\//g,"\\")),I}function r(R,S){const I=S?d:A;let T="",{scheme:O,authority:P,path:y,query:x,fragment:G}=R;if(O&&(T+=O,T+=":"),(P||O==="file")&&(T+=b,T+=b),P){let U=P.indexOf("@");if(U!==-1){const B=P.substr(0,U);P=P.substr(U+1),U=B.lastIndexOf(":"),U===-1?T+=I(B,!1,!1):(T+=I(B.substr(0,U),!1,!1),T+=":",T+=I(B.substr(U+1),!1,!0)),T+="@"}P=P.toLowerCase(),U=P.lastIndexOf(":"),U===-1?T+=I(P,!1,!0):(T+=I(P.substr(0,U),!1,!0),T+=P.substr(U))}if(y){if(y.length>=3&&y.charCodeAt(0)===t.CharCode.Slash&&y.charCodeAt(2)===t.CharCode.Colon){const U=y.charCodeAt(1);U>=t.CharCode.A&&U<=t.CharCode.Z&&(y=`/${String.fromCharCode(U+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===t.CharCode.Colon){const U=y.charCodeAt(0);U>=t.CharCode.A&&U<=t.CharCode.Z&&(y=`${String.fromCharCode(U+32)}:${y.substr(2)}`)}T+=I(y,!0,!1)}return x&&(T+="?",T+=I(x,!1,!1)),G&&(T+="#",T+=S?G:A(G,!1,!1)),T}function u(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+u(R.substr(3)):R}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function D(R){return R.match(f)?R.replace(f,S=>u(S)):R}}),ne(ie[76],re([0,1,5,13,12,18,17,8]),function(W,i,t,n,M,h,p,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SimpleWorkerServer=i.SimpleWorkerClient=void 0,i.logOnceWebWorkerWarning=c,i.create=r,m=Be(m);const l="$initialize";let a=!1;function c(u){p.isWeb&&(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(u.message))}var _;(function(u){u[u.Request=0]="Request",u[u.Reply=1]="Reply",u[u.SubscribeEvent=2]="SubscribeEvent",u[u.Event=3]="Event",u[u.UnsubscribeEvent=4]="UnsubscribeEvent"})(_||(_={}));class g{constructor(f,D,R,S){this.vsWorker=f,this.req=D,this.method=R,this.args=S,this.type=_.Request}}class b{constructor(f,D,R,S){this.vsWorker=f,this.seq=D,this.res=R,this.err=S,this.type=_.Reply}}class e{constructor(f,D,R,S){this.vsWorker=f,this.req=D,this.eventName=R,this.arg=S,this.type=_.SubscribeEvent}}class L{constructor(f,D,R){this.vsWorker=f,this.req=D,this.event=R,this.type=_.Event}}class E{constructor(f,D){this.vsWorker=f,this.req=D,this.type=_.UnsubscribeEvent}}class N{constructor(f){this._workerId=-1,this._handler=f,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(f){this._workerId=f}sendMessage(f,D){const R=String(++this._lastSentReq);return new Promise((S,I)=>{this._pendingReplies[R]={resolve:S,reject:I},this._send(new g(this._workerId,R,f,D))})}listen(f,D){let R=null;const S=new n.Emitter({onWillAddFirstListener:()=>{R=String(++this._lastSentReq),this._pendingEmitters.set(R,S),this._send(new e(this._workerId,R,f,D))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(R),this._send(new E(this._workerId,R)),R=null}});return S.event}handleMessage(f){!f||!f.vsWorker||this._workerId!==-1&&f.vsWorker!==this._workerId||this._handleMessage(f)}_handleMessage(f){switch(f.type){case _.Reply:return this._handleReplyMessage(f);case _.Request:return this._handleRequestMessage(f);case _.SubscribeEvent:return this._handleSubscribeEventMessage(f);case _.Event:return this._handleEventMessage(f);case _.UnsubscribeEvent:return this._handleUnsubscribeEventMessage(f)}}_handleReplyMessage(f){if(!this._pendingReplies[f.seq]){console.warn("Got reply to unknown seq");return}const D=this._pendingReplies[f.seq];if(delete this._pendingReplies[f.seq],f.err){let R=f.err;f.err.$isError&&(R=new Error,R.name=f.err.name,R.message=f.err.message,R.stack=f.err.stack),D.reject(R);return}D.resolve(f.res)}_handleRequestMessage(f){const D=f.req;this._handler.handleMessage(f.method,f.args).then(S=>{this._send(new b(this._workerId,D,S,void 0))},S=>{S.detail instanceof Error&&(S.detail=(0,t.transformErrorForSerialization)(S.detail)),this._send(new b(this._workerId,D,void 0,(0,t.transformErrorForSerialization)(S)))})}_handleSubscribeEventMessage(f){const D=f.req,R=this._handler.handleEvent(f.eventName,f.arg)(S=>{this._send(new L(this._workerId,D,S))});this._pendingEvents.set(D,R)}_handleEventMessage(f){if(!this._pendingEmitters.has(f.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(f.req).fire(f.event)}_handleUnsubscribeEventMessage(f){if(!this._pendingEvents.has(f.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(f.req).dispose(),this._pendingEvents.delete(f.req)}_send(f){const D=[];if(f.type===_.Request)for(let R=0;R<f.args.length;R++)f.args[R]instanceof ArrayBuffer&&D.push(f.args[R]);else f.type===_.Reply&&f.res instanceof ArrayBuffer&&D.push(f.res);this._handler.sendMessage(f,D)}}class w extends M.Disposable{constructor(f,D,R){super();let S=null;this._worker=this._register(f.create("vs/base/common/worker/simpleWorker",x=>{this._protocol.handleMessage(x)},x=>{S?.(x)})),this._protocol=new N({sendMessage:(x,G)=>{this._worker.postMessage(x,G)},handleMessage:(x,G)=>{if(typeof R[x]!="function")return Promise.reject(new Error("Missing method "+x+" on main thread host."));try{return Promise.resolve(R[x].apply(R,G))}catch(U){return Promise.reject(U)}},handleEvent:(x,G)=>{if(A(x)){const U=R[x].call(R,G);if(typeof U!="function")throw new Error(`Missing dynamic event ${x} on main thread host.`);return U}if(v(x)){const U=R[x];if(typeof U!="function")throw new Error(`Missing event ${x} on main thread host.`);return U}throw new Error(`Malformed event name ${x}`)}}),this._protocol.setWorkerId(this._worker.getId());let I=null;const T=globalThis.require;typeof T<"u"&&typeof T.getConfig=="function"?I=T.getConfig():typeof globalThis.requirejs<"u"&&(I=globalThis.requirejs.s.contexts._.config);const O=(0,h.getAllMethodNames)(R);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(I)),D,O]);const P=(x,G)=>this._request(x,G),y=(x,G)=>this._protocol.listen(x,G);this._lazyProxy=new Promise((x,G)=>{S=G,this._onModuleLoaded.then(U=>{x(d(U,P,y))},U=>{G(U),this._onError("Worker failed to load "+D,U)})})}getProxyObject(){return this._lazyProxy}_request(f,D){return new Promise((R,S)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(f,D).then(R,S)},S)})}_onError(f,D){console.error(f),console.info(D)}}i.SimpleWorkerClient=w;function v(u){return u[0]==="o"&&u[1]==="n"&&m.isUpperAsciiLetter(u.charCodeAt(2))}function A(u){return/^onDynamic/.test(u)&&m.isUpperAsciiLetter(u.charCodeAt(9))}function d(u,f,D){const R=T=>function(){const O=Array.prototype.slice.call(arguments,0);return f(T,O)},S=T=>function(O){return D(T,O)},I={};for(const T of u){if(A(T)){I[T]=S(T);continue}if(v(T)){I[T]=D(T,void 0);continue}I[T]=R(T)}return I}class o{constructor(f,D){this._requestHandlerFactory=D,this._requestHandler=null,this._protocol=new N({sendMessage:(R,S)=>{f(R,S)},handleMessage:(R,S)=>this._handleMessage(R,S),handleEvent:(R,S)=>this._handleEvent(R,S)})}onmessage(f){this._protocol.handleMessage(f)}_handleMessage(f,D){if(f===l)return this.initialize(D[0],D[1],D[2],D[3]);if(!this._requestHandler||typeof this._requestHandler[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this._requestHandler[f].apply(this._requestHandler,D))}catch(R){return Promise.reject(R)}}_handleEvent(f,D){if(!this._requestHandler)throw new Error("Missing requestHandler");if(A(f)){const R=this._requestHandler[f].call(this._requestHandler,D);if(typeof R!="function")throw new Error(`Missing dynamic event ${f} on request handler.`);return R}if(v(f)){const R=this._requestHandler[f];if(typeof R!="function")throw new Error(`Missing event ${f} on request handler.`);return R}throw new Error(`Malformed event name ${f}`)}initialize(f,D,R,S){this._protocol.setWorkerId(f);const O=d(S,(P,y)=>this._protocol.sendMessage(P,y),(P,y)=>this._protocol.listen(P,y));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(O),Promise.resolve((0,h.getAllMethodNames)(this._requestHandler))):(D&&(typeof D.baseUrl<"u"&&delete D.baseUrl,typeof D.paths<"u"&&typeof D.paths.vs<"u"&&delete D.paths.vs,typeof D.trustedTypesPolicy<"u"&&delete D.trustedTypesPolicy,D.catchError=!0,globalThis.require.config(D)),new Promise((P,y)=>{(globalThis.require||W)([R],G=>{if(this._requestHandler=G.create(O),!this._requestHandler){y(new Error("No RequestHandler!"));return}P((0,h.getAllMethodNames)(this._requestHandler))},y)}))}}i.SimpleWorkerServer=o;function r(u){return new o(u,null)}}),ne(ie[30],re([0,1,14]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharacterSet=i.CharacterClassifier=void 0;class n{constructor(m){const l=(0,t.toUint8)(m);this._defaultValue=l,this._asciiMap=n._createAsciiMap(l),this._map=new Map}static _createAsciiMap(m){const l=new Uint8Array(256);return l.fill(m),l}set(m,l){const a=(0,t.toUint8)(l);m>=0&&m<256?this._asciiMap[m]=a:this._map.set(m,a)}get(m){return m>=0&&m<256?this._asciiMap[m]:this._map.get(m)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}i.CharacterClassifier=n;var M;(function(p){p[p.False=0]="False",p[p.True=1]="True"})(M||(M={}));class h{constructor(){this._actual=new n(M.False)}add(m){this._actual.set(m,M.True)}has(m){return this._actual.get(m)===M.True}clear(){return this._actual.clear()}}i.CharacterSet=h}),ne(ie[6],re([0,1,5]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.OffsetRangeSet=i.OffsetRange=void 0;class n{static addRange(p,m){let l=0;for(;l<m.length&&m[l].endExclusive<p.start;)l++;let a=l;for(;a<m.length&&m[a].start<=p.endExclusive;)a++;if(l===a)m.splice(l,0,p);else{const c=Math.min(p.start,m[l].start),_=Math.max(p.endExclusive,m[a-1].endExclusive);m.splice(l,a-l,new n(c,_))}}static tryCreate(p,m){if(!(p>m))return new n(p,m)}static ofLength(p){return new n(0,p)}static ofStartAndLength(p,m){return new n(p,p+m)}constructor(p,m){if(this.start=p,this.endExclusive=m,p>m)throw new t.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(p){return new n(this.start+p,this.endExclusive+p)}deltaStart(p){return new n(this.start+p,this.endExclusive)}deltaEnd(p){return new n(this.start,this.endExclusive+p)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(p){return this.start===p.start&&this.endExclusive===p.endExclusive}containsRange(p){return this.start<=p.start&&p.endExclusive<=this.endExclusive}contains(p){return this.start<=p&&p<this.endExclusive}join(p){return new n(Math.min(this.start,p.start),Math.max(this.endExclusive,p.endExclusive))}intersect(p){const m=Math.max(this.start,p.start),l=Math.min(this.endExclusive,p.endExclusive);if(m<=l)return new n(m,l)}intersects(p){const m=Math.max(this.start,p.start),l=Math.min(this.endExclusive,p.endExclusive);return m<l}intersectsOrTouches(p){const m=Math.max(this.start,p.start),l=Math.min(this.endExclusive,p.endExclusive);return m<=l}isBefore(p){return this.endExclusive<=p.start}isAfter(p){return this.start>=p.endExclusive}slice(p){return p.slice(this.start,this.endExclusive)}substring(p){return p.substring(this.start,this.endExclusive)}clip(p){if(this.isEmpty)throw new t.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,p))}clipCyclic(p){if(this.isEmpty)throw new t.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return p<this.start?this.endExclusive-(this.start-p)%this.length:p>=this.endExclusive?this.start+(p-this.start)%this.length:p}map(p){const m=[];for(let l=this.start;l<this.endExclusive;l++)m.push(p(l));return m}forEach(p){for(let m=this.start;m<this.endExclusive;m++)p(m)}}i.OffsetRange=n;class M{constructor(){this._sortedRanges=[]}addRange(p){let m=0;for(;m<this._sortedRanges.length&&this._sortedRanges[m].endExclusive<p.start;)m++;let l=m;for(;l<this._sortedRanges.length&&this._sortedRanges[l].start<=p.endExclusive;)l++;if(m===l)this._sortedRanges.splice(m,0,p);else{const a=Math.min(p.start,this._sortedRanges[m].start),c=Math.max(p.endExclusive,this._sortedRanges[l-1].endExclusive);this._sortedRanges.splice(m,l-m,new n(a,c))}}toString(){return this._sortedRanges.map(p=>p.toString()).join(", ")}intersectsStrict(p){let m=0;for(;m<this._sortedRanges.length&&this._sortedRanges[m].endExclusive<=p.start;)m++;return m<this._sortedRanges.length&&this._sortedRanges[m].start<p.endExclusive}intersectWithRange(p){const m=new M;for(const l of this._sortedRanges){const a=l.intersect(p);a&&m.addRange(a)}return m}intersectWithRangeLength(p){return this.intersectWithRange(p).length}get length(){return this._sortedRanges.reduce((p,m)=>p+m.length,0)}}i.OffsetRangeSet=M}),ne(ie[3],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Position=void 0;class t{constructor(M,h){this.lineNumber=M,this.column=h}with(M=this.lineNumber,h=this.column){return M===this.lineNumber&&h===this.column?this:new t(M,h)}delta(M=0,h=0){return this.with(this.lineNumber+M,this.column+h)}equals(M){return t.equals(this,M)}static equals(M,h){return!M&&!h?!0:!!M&&!!h&&M.lineNumber===h.lineNumber&&M.column===h.column}isBefore(M){return t.isBefore(this,M)}static isBefore(M,h){return M.lineNumber<h.lineNumber?!0:h.lineNumber<M.lineNumber?!1:M.column<h.column}isBeforeOrEqual(M){return t.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,h){return M.lineNumber<h.lineNumber?!0:h.lineNumber<M.lineNumber?!1:M.column<=h.column}static compare(M,h){const p=M.lineNumber|0,m=h.lineNumber|0;if(p===m){const l=M.column|0,a=h.column|0;return l-a}return p-m}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new t(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}i.Position=t}),ne(ie[2],re([0,1,3]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Range=void 0;class n{constructor(h,p,m,l){h>m||h===m&&p>l?(this.startLineNumber=m,this.startColumn=l,this.endLineNumber=h,this.endColumn=p):(this.startLineNumber=h,this.startColumn=p,this.endLineNumber=m,this.endColumn=l)}isEmpty(){return n.isEmpty(this)}static isEmpty(h){return h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn}containsPosition(h){return n.containsPosition(this,h)}static containsPosition(h,p){return!(p.lineNumber<h.startLineNumber||p.lineNumber>h.endLineNumber||p.lineNumber===h.startLineNumber&&p.column<h.startColumn||p.lineNumber===h.endLineNumber&&p.column>h.endColumn)}static strictContainsPosition(h,p){return!(p.lineNumber<h.startLineNumber||p.lineNumber>h.endLineNumber||p.lineNumber===h.startLineNumber&&p.column<=h.startColumn||p.lineNumber===h.endLineNumber&&p.column>=h.endColumn)}containsRange(h){return n.containsRange(this,h)}static containsRange(h,p){return!(p.startLineNumber<h.startLineNumber||p.endLineNumber<h.startLineNumber||p.startLineNumber>h.endLineNumber||p.endLineNumber>h.endLineNumber||p.startLineNumber===h.startLineNumber&&p.startColumn<h.startColumn||p.endLineNumber===h.endLineNumber&&p.endColumn>h.endColumn)}strictContainsRange(h){return n.strictContainsRange(this,h)}static strictContainsRange(h,p){return!(p.startLineNumber<h.startLineNumber||p.endLineNumber<h.startLineNumber||p.startLineNumber>h.endLineNumber||p.endLineNumber>h.endLineNumber||p.startLineNumber===h.startLineNumber&&p.startColumn<=h.startColumn||p.endLineNumber===h.endLineNumber&&p.endColumn>=h.endColumn)}plusRange(h){return n.plusRange(this,h)}static plusRange(h,p){let m,l,a,c;return p.startLineNumber<h.startLineNumber?(m=p.startLineNumber,l=p.startColumn):p.startLineNumber===h.startLineNumber?(m=p.startLineNumber,l=Math.min(p.startColumn,h.startColumn)):(m=h.startLineNumber,l=h.startColumn),p.endLineNumber>h.endLineNumber?(a=p.endLineNumber,c=p.endColumn):p.endLineNumber===h.endLineNumber?(a=p.endLineNumber,c=Math.max(p.endColumn,h.endColumn)):(a=h.endLineNumber,c=h.endColumn),new n(m,l,a,c)}intersectRanges(h){return n.intersectRanges(this,h)}static intersectRanges(h,p){let m=h.startLineNumber,l=h.startColumn,a=h.endLineNumber,c=h.endColumn;const _=p.startLineNumber,g=p.startColumn,b=p.endLineNumber,e=p.endColumn;return m<_?(m=_,l=g):m===_&&(l=Math.max(l,g)),a>b?(a=b,c=e):a===b&&(c=Math.min(c,e)),m>a||m===a&&l>c?null:new n(m,l,a,c)}equalsRange(h){return n.equalsRange(this,h)}static equalsRange(h,p){return!h&&!p?!0:!!h&&!!p&&h.startLineNumber===p.startLineNumber&&h.startColumn===p.startColumn&&h.endLineNumber===p.endLineNumber&&h.endColumn===p.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(h){return new t.Position(h.endLineNumber,h.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(h){return new t.Position(h.startLineNumber,h.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(h,p){return new n(this.startLineNumber,this.startColumn,h,p)}setStartPosition(h,p){return new n(h,p,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(h){return new n(h.startLineNumber,h.startColumn,h.startLineNumber,h.startColumn)}collapseToEnd(){return n.collapseToEnd(this)}static collapseToEnd(h){return new n(h.endLineNumber,h.endColumn,h.endLineNumber,h.endColumn)}delta(h){return new n(this.startLineNumber+h,this.startColumn,this.endLineNumber+h,this.endColumn)}static fromPositions(h,p=h){return new n(h.lineNumber,h.column,p.lineNumber,p.column)}static lift(h){return h?new n(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):null}static isIRange(h){return h&&typeof h.startLineNumber=="number"&&typeof h.startColumn=="number"&&typeof h.endLineNumber=="number"&&typeof h.endColumn=="number"}static areIntersectingOrTouching(h,p){return!(h.endLineNumber<p.startLineNumber||h.endLineNumber===p.startLineNumber&&h.endColumn<p.startColumn||p.endLineNumber<h.startLineNumber||p.endLineNumber===h.startLineNumber&&p.endColumn<h.startColumn)}static areIntersecting(h,p){return!(h.endLineNumber<p.startLineNumber||h.endLineNumber===p.startLineNumber&&h.endColumn<=p.startColumn||p.endLineNumber<h.startLineNumber||p.endLineNumber===h.startLineNumber&&p.endColumn<=h.startColumn)}static compareRangesUsingStarts(h,p){if(h&&p){const a=h.startLineNumber|0,c=p.startLineNumber|0;if(a===c){const _=h.startColumn|0,g=p.startColumn|0;if(_===g){const b=h.endLineNumber|0,e=p.endLineNumber|0;if(b===e){const L=h.endColumn|0,E=p.endColumn|0;return L-E}return b-e}return _-g}return a-c}return(h?1:0)-(p?1:0)}static compareRangesUsingEnds(h,p){return h.endLineNumber===p.endLineNumber?h.endColumn===p.endColumn?h.startLineNumber===p.startLineNumber?h.startColumn-p.startColumn:h.startLineNumber-p.startLineNumber:h.endColumn-p.endColumn:h.endLineNumber-p.endLineNumber}static spansMultipleLines(h){return h.endLineNumber>h.startLineNumber}toJSON(){return this}}i.Range=n}),ne(ie[49],re([0,1,2]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditOperation=void 0;class n{static insert(h,p){return{range:new t.Range(h.lineNumber,h.column,h.lineNumber,h.column),text:p,forceMoveMarkers:!0}}static delete(h){return{range:h,text:null}}static replace(h,p){return{range:h,text:p}}static replaceMove(h,p){return{range:h,text:p,forceMoveMarkers:!0}}}i.EditOperation=n}),ne(ie[15],re([0,1,5,6,2,9]),function(W,i,t,n,M,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineRangeSet=i.LineRange=void 0;class p{static fromRange(a){return new p(a.startLineNumber,a.endLineNumber)}static fromRangeInclusive(a){return new p(a.startLineNumber,a.endLineNumber+1)}static subtract(a,c){return c?a.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<a.endLineNumberExclusive?[new p(a.startLineNumber,c.startLineNumber),new p(c.endLineNumberExclusive,a.endLineNumberExclusive)]:c.startLineNumber<=a.startLineNumber&&a.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<a.endLineNumberExclusive?[new p(Math.max(c.endLineNumberExclusive,a.startLineNumber),a.endLineNumberExclusive)]:[new p(a.startLineNumber,Math.min(c.startLineNumber,a.endLineNumberExclusive))]:[a]}static joinMany(a){if(a.length===0)return[];let c=new m(a[0].slice());for(let _=1;_<a.length;_++)c=c.getUnion(new m(a[_].slice()));return c.ranges}static join(a){if(a.length===0)throw new t.BugIndicatingError("lineRanges cannot be empty");let c=a[0].startLineNumber,_=a[0].endLineNumberExclusive;for(let g=1;g<a.length;g++)c=Math.min(c,a[g].startLineNumber),_=Math.max(_,a[g].endLineNumberExclusive);return new p(c,_)}static ofLength(a,c){return new p(a,a+c)}static deserialize(a){return new p(a[0],a[1])}constructor(a,c){if(a>c)throw new t.BugIndicatingError(`startLineNumber ${a} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=a,this.endLineNumberExclusive=c}contains(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(a){return new p(this.startLineNumber+a,this.endLineNumberExclusive+a)}deltaLength(a){return new p(this.startLineNumber,this.endLineNumberExclusive+a)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(a){return new p(Math.min(this.startLineNumber,a.startLineNumber),Math.max(this.endLineNumberExclusive,a.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(a){const c=Math.max(this.startLineNumber,a.startLineNumber),_=Math.min(this.endLineNumberExclusive,a.endLineNumberExclusive);if(c<=_)return new p(c,_)}intersectsStrict(a){return this.startLineNumber<a.endLineNumberExclusive&&a.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(a){return this.startLineNumber<=a.endLineNumberExclusive&&a.startLineNumber<=this.endLineNumberExclusive}equals(a){return this.startLineNumber===a.startLineNumber&&this.endLineNumberExclusive===a.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new M.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new M.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(a){const c=[];for(let _=this.startLineNumber;_<this.endLineNumberExclusive;_++)c.push(a(_));return c}forEach(a){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)a(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}toOffsetRange(){return new n.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}i.LineRange=p;class m{constructor(a=[]){this._normalizedRanges=a}get ranges(){return this._normalizedRanges}addRange(a){if(a.length===0)return;const c=(0,h.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,g=>g.endLineNumberExclusive>=a.startLineNumber),_=(0,h.findLastIdxMonotonous)(this._normalizedRanges,g=>g.startLineNumber<=a.endLineNumberExclusive)+1;if(c===_)this._normalizedRanges.splice(c,0,a);else if(c===_-1){const g=this._normalizedRanges[c];this._normalizedRanges[c]=g.join(a)}else{const g=this._normalizedRanges[c].join(this._normalizedRanges[_-1]).join(a);this._normalizedRanges.splice(c,_-c,g)}}contains(a){const c=(0,h.findLastMonotonous)(this._normalizedRanges,_=>_.startLineNumber<=a);return!!c&&c.endLineNumberExclusive>a}intersects(a){const c=(0,h.findLastMonotonous)(this._normalizedRanges,_=>_.startLineNumber<a.endLineNumberExclusive);return!!c&&c.endLineNumberExclusive>a.startLineNumber}getUnion(a){if(this._normalizedRanges.length===0)return a;if(a._normalizedRanges.length===0)return this;const c=[];let _=0,g=0,b=null;for(;_<this._normalizedRanges.length||g<a._normalizedRanges.length;){let e=null;if(_<this._normalizedRanges.length&&g<a._normalizedRanges.length){const L=this._normalizedRanges[_],E=a._normalizedRanges[g];L.startLineNumber<E.startLineNumber?(e=L,_++):(e=E,g++)}else _<this._normalizedRanges.length?(e=this._normalizedRanges[_],_++):(e=a._normalizedRanges[g],g++);b===null?b=e:b.endLineNumberExclusive>=e.startLineNumber?b=new p(b.startLineNumber,Math.max(b.endLineNumberExclusive,e.endLineNumberExclusive)):(c.push(b),b=e)}return b!==null&&c.push(b),new m(c)}subtractFrom(a){const c=(0,h.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,e=>e.endLineNumberExclusive>=a.startLineNumber),_=(0,h.findLastIdxMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=a.endLineNumberExclusive)+1;if(c===_)return new m([a]);const g=[];let b=a.startLineNumber;for(let e=c;e<_;e++){const L=this._normalizedRanges[e];L.startLineNumber>b&&g.push(new p(b,L.startLineNumber)),b=L.endLineNumberExclusive}return b<a.endLineNumberExclusive&&g.push(new p(b,a.endLineNumberExclusive)),new m(g)}toString(){return this._normalizedRanges.map(a=>a.toString()).join(", ")}getIntersection(a){const c=[];let _=0,g=0;for(;_<this._normalizedRanges.length&&g<a._normalizedRanges.length;){const b=this._normalizedRanges[_],e=a._normalizedRanges[g],L=b.intersect(e);L&&!L.isEmpty&&c.push(L),b.endLineNumberExclusive<e.endLineNumberExclusive?_++:g++}return new m(c)}getWithDelta(a){return new m(this._normalizedRanges.map(c=>c.delta(a)))}}i.LineRangeSet=m}),ne(ie[50],re([0,1,3,2]),function(W,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Selection=i.SelectionDirection=void 0;var M;(function(p){p[p.LTR=0]="LTR",p[p.RTL=1]="RTL"})(M||(i.SelectionDirection=M={}));class h extends n.Range{constructor(m,l,a,c){super(m,l,a,c),this.selectionStartLineNumber=m,this.selectionStartColumn=l,this.positionLineNumber=a,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return h.selectionsEqual(this,m)}static selectionsEqual(m,l){return m.selectionStartLineNumber===l.selectionStartLineNumber&&m.selectionStartColumn===l.selectionStartColumn&&m.positionLineNumber===l.positionLineNumber&&m.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?M.LTR:M.RTL}setEndPosition(m,l){return this.getDirection()===M.LTR?new h(this.startLineNumber,this.startColumn,m,l):new h(m,l,this.startLineNumber,this.startColumn)}getPosition(){return new t.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new t.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,l){return this.getDirection()===M.LTR?new h(m,l,this.endLineNumber,this.endColumn):new h(this.endLineNumber,this.endColumn,m,l)}static fromPositions(m,l=m){return new h(m.lineNumber,m.column,l.lineNumber,l.column)}static fromRange(m,l){return l===M.LTR?new h(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new h(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new h(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,l){if(m&&!l||!m&&l)return!1;if(!m&&!l)return!0;if(m.length!==l.length)return!1;for(let a=0,c=m.length;a<c;a++)if(!this.selectionsEqual(m[a],l[a]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,l,a,c,_){return _===M.LTR?new h(m,l,a,c):new h(a,c,m,l)}}i.Selection=h}),ne(ie[31],re([0,1,3,2]),function(W,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TextLength=void 0;class M{static{this.zero=new M(0,0)}static lengthDiffNonNegative(p,m){return m.isLessThan(p)?M.zero:p.lineCount===m.lineCount?new M(0,m.columnCount-p.columnCount):new M(m.lineCount-p.lineCount,m.columnCount)}static betweenPositions(p,m){return p.lineNumber===m.lineNumber?new M(0,m.column-p.column):new M(m.lineNumber-p.lineNumber,m.column-1)}static ofRange(p){return M.betweenPositions(p.getStartPosition(),p.getEndPosition())}static ofText(p){let m=0,l=0;for(const a of p)a===`
`?(m++,l=0):l++;return new M(m,l)}constructor(p,m){this.lineCount=p,this.columnCount=m}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(p){return this.lineCount!==p.lineCount?this.lineCount<p.lineCount:this.columnCount<p.columnCount}isGreaterThan(p){return this.lineCount!==p.lineCount?this.lineCount>p.lineCount:this.columnCount>p.columnCount}isGreaterThanOrEqualTo(p){return this.lineCount!==p.lineCount?this.lineCount>p.lineCount:this.columnCount>=p.columnCount}equals(p){return this.lineCount===p.lineCount&&this.columnCount===p.columnCount}compare(p){return this.lineCount!==p.lineCount?this.lineCount-p.lineCount:this.columnCount-p.columnCount}add(p){return p.lineCount===0?new M(this.lineCount,this.columnCount+p.columnCount):new M(this.lineCount+p.lineCount,p.columnCount)}createRange(p){return this.lineCount===0?new n.Range(p.lineNumber,p.column,p.lineNumber,p.column+this.columnCount):new n.Range(p.lineNumber,p.column,p.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new n.Range(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(p){return this.lineCount===0?new t.Position(p.lineNumber,p.column+this.columnCount):new t.Position(p.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}i.TextLength=M}),ne(ie[51],re([0,1,9,6,3,2,31]),function(W,i,t,n,M,h,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PositionOffsetTransformer=void 0;class m{constructor(a){this.text=a,this.lineStartOffsetByLineIdx=[],this.lineStartOffsetByLineIdx.push(0);for(let c=0;c<a.length;c++)a.charAt(c)===`
`&&this.lineStartOffsetByLineIdx.push(c+1)}getOffset(a){return this.lineStartOffsetByLineIdx[a.lineNumber-1]+a.column-1}getOffsetRange(a){return new n.OffsetRange(this.getOffset(a.getStartPosition()),this.getOffset(a.getEndPosition()))}getPosition(a){const c=(0,t.findLastIdxMonotonous)(this.lineStartOffsetByLineIdx,b=>b<=a),_=c+1,g=a-this.lineStartOffsetByLineIdx[c]+1;return new M.Position(_,g)}getRange(a){return h.Range.fromPositions(this.getPosition(a.start),this.getPosition(a.endExclusive))}getTextLength(a){return p.TextLength.ofRange(this.getRange(a))}get textLength(){const a=this.lineStartOffsetByLineIdx.length-1;return new p.TextLength(a,this.text.length-this.lineStartOffsetByLineIdx[a])}}i.PositionOffsetTransformer=m}),ne(ie[52],re([0,1,11,5,3,51,2,31]),function(W,i,t,n,M,h,p,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringText=i.ArrayText=i.LineBasedText=i.AbstractText=i.SingleTextEdit=i.TextEdit=void 0;class l{static single(E,N){return new l([new a(E,N)])}constructor(E){this.edits=E,(0,t.assertFn)(()=>(0,t.checkAdjacentItems)(E,(N,w)=>N.range.getEndPosition().isBeforeOrEqual(w.range.getStartPosition())))}normalize(){const E=[];for(const N of this.edits)if(E.length>0&&E[E.length-1].range.getEndPosition().equals(N.range.getStartPosition())){const w=E[E.length-1];E[E.length-1]=new a(w.range.plusRange(N.range),w.text+N.text)}else N.isEmpty||E.push(N);return new l(E)}mapPosition(E){let N=0,w=0,v=0;for(const A of this.edits){const d=A.range.getStartPosition(),o=A.range.getEndPosition();if(E.isBeforeOrEqual(d))break;const r=m.TextLength.ofText(A.text);if(E.isBefore(o)){const u=new M.Position(d.lineNumber+N,d.column+(d.lineNumber+N===w?v:0)),f=r.addToPosition(u);return c(u,f)}N+=r.lineCount-(A.range.endLineNumber-A.range.startLineNumber),r.lineCount===0?o.lineNumber!==d.lineNumber?v+=r.columnCount-(o.column-1):v+=r.columnCount-(o.column-d.column):v=r.columnCount,w=o.lineNumber+N}return new M.Position(E.lineNumber+N,E.column+(E.lineNumber+N===w?v:0))}mapRange(E){function N(d){return d instanceof M.Position?d:d.getStartPosition()}function w(d){return d instanceof M.Position?d:d.getEndPosition()}const v=N(this.mapPosition(E.getStartPosition())),A=w(this.mapPosition(E.getEndPosition()));return c(v,A)}inverseMapPosition(E,N){return this.inverse(N).mapPosition(E)}inverseMapRange(E,N){return this.inverse(N).mapRange(E)}apply(E){let N="",w=new M.Position(1,1);for(const A of this.edits){const d=A.range,o=d.getStartPosition(),r=d.getEndPosition(),u=c(w,o);u.isEmpty()||(N+=E.getValueOfRange(u)),N+=A.text,w=r}const v=c(w,E.endPositionExclusive);return v.isEmpty()||(N+=E.getValueOfRange(v)),N}applyToString(E){const N=new e(E);return this.apply(N)}inverse(E){const N=this.getNewRanges();return new l(this.edits.map((w,v)=>new a(N[v],E.getValueOfRange(w.range))))}getNewRanges(){const E=[];let N=0,w=0,v=0;for(const A of this.edits){const d=m.TextLength.ofText(A.text),o=M.Position.lift({lineNumber:A.range.startLineNumber+w,column:A.range.startColumn+(A.range.startLineNumber===N?v:0)}),r=d.createRange(o);E.push(r),w=r.endLineNumber-A.range.endLineNumber,v=r.endColumn-A.range.endColumn,N=A.range.endLineNumber}return E}}i.TextEdit=l;class a{constructor(E,N){this.range=E,this.text=N}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(E,N){return E.range.equalsRange(N.range)&&E.text===N.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}i.SingleTextEdit=a;function c(L,E){if(L.lineNumber===E.lineNumber&&L.column===Number.MAX_SAFE_INTEGER)return p.Range.fromPositions(E,E);if(!L.isBeforeOrEqual(E))throw new n.BugIndicatingError("start must be before end");return new p.Range(L.lineNumber,L.column,E.lineNumber,E.column)}class _{get endPositionExclusive(){return this.length.addToPosition(new M.Position(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}i.AbstractText=_;class g extends _{constructor(E,N){(0,t.assert)(N>=1),super(),this._getLineContent=E,this._lineCount=N}getValueOfRange(E){if(E.startLineNumber===E.endLineNumber)return this._getLineContent(E.startLineNumber).substring(E.startColumn-1,E.endColumn-1);let N=this._getLineContent(E.startLineNumber).substring(E.startColumn-1);for(let w=E.startLineNumber+1;w<E.endLineNumber;w++)N+=`
`+this._getLineContent(w);return N+=`
`+this._getLineContent(E.endLineNumber).substring(0,E.endColumn-1),N}get length(){const E=this._getLineContent(this._lineCount);return new m.TextLength(this._lineCount-1,E.length)}}i.LineBasedText=g;class b extends g{constructor(E){super(N=>E[N-1],E.length)}}i.ArrayText=b;class e extends _{constructor(E){super(),this.value=E,this._t=new h.PositionOffsetTransformer(this.value)}getValueOfRange(E){return this._t.getOffsetRange(E).substring(this.value)}get length(){return this._t.textLength}}i.StringText=e}),ne(ie[53],re([0,1,4,16,30]),function(W,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WordCharacterClassifier=i.WordCharacterClass=void 0,i.getMapForWordSeparators=l;var h;(function(a){a[a.Regular=0]="Regular",a[a.Whitespace=1]="Whitespace",a[a.WordSeparator=2]="WordSeparator"})(h||(i.WordCharacterClass=h={}));class p extends M.CharacterClassifier{constructor(c,_){super(h.Regular),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=_,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let g=0,b=c.length;g<b;g++)this.set(c.charCodeAt(g),h.WordSeparator);this.set(t.CharCode.Space,h.Whitespace),this.set(t.CharCode.Tab,h.Whitespace)}findPrevIntlWordBeforeOrAtOffset(c,_){let g=null;for(const b of this._getIntlSegmenterWordsOnLine(c)){if(b.index>_)break;g=b}return g}findNextIntlWordAtOrAfterOffset(c,_){for(const g of this._getIntlSegmenterWordsOnLine(c))if(!(g.index<_))return g;return null}_getIntlSegmenterWordsOnLine(c){return this._segmenter?this._cachedLine===c?this._cachedSegments:(this._cachedLine=c,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(c)),this._cachedSegments):[]}_filterWordSegments(c){const _=[];for(const g of c)this._isWordLike(g)&&_.push(g);return _}_isWordLike(c){return!!c.isWordLike}}i.WordCharacterClassifier=p;const m=new n.LRUCache(10);function l(a,c){const _=`${a}/${c.join(",")}`;let g=m.get(_);return g||(g=new p(a,c),m.set(_,g)),g}}),ne(ie[32],re([0,1,23,12,24]),function(W,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DEFAULT_WORD_REGEXP=i.USUAL_WORD_SEPARATORS=void 0,i.ensureValidWordDefinition=p,i.setDefaultGetWordAtTextConfig=l,i.getWordAtText=a,i.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(_=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const b of i.USUAL_WORD_SEPARATORS)_.indexOf(b)>=0||(g+="\\"+b);return g+="\\s]+)",new RegExp(g,"g")}i.DEFAULT_WORD_REGEXP=h();function p(_){let g=i.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)g=_;else{let b="g";_.ignoreCase&&(b+="i"),_.multiline&&(b+="m"),_.unicode&&(b+="u"),g=new RegExp(_.source,b)}return g.lastIndex=0,g}const m=new M.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(_){const g=m.unshift(_);return(0,n.toDisposable)(g)}function a(_,g,b,e,L){if(g=p(g),L||(L=t.Iterable.first(m)),b.length>L.maxLen){let A=_-L.maxLen/2;return A<0?A=0:e+=A,b=b.substring(A,_+L.maxLen/2),a(_,g,b,e,L)}const E=Date.now(),N=_-1-e;let w=-1,v=null;for(let A=1;!(Date.now()-E>=L.timeBudget);A++){const d=N-L.windowSize*A;g.lastIndex=Math.max(0,d);const o=c(g,b,N,w);if(!o&&v||(v=o,d<=0))break;w=d}if(v){const A={word:v[0],startColumn:e+1+v.index,endColumn:e+1+v.index+v[0].length};return g.lastIndex=0,A}return null}function c(_,g,b,e){let L;for(;L=_.exec(g);){const E=L.index||0;if(E<=b&&_.lastIndex>=b)return L;if(e>0&&E>e)return null}return null}}),ne(ie[10],re([0,1,7,5,6]),function(W,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DateTimeout=i.InfiniteTimeout=i.OffsetPair=i.SequenceDiff=i.DiffAlgorithmResult=void 0;class h{static trivial(_,g){return new h([new p(M.OffsetRange.ofLength(_.length),M.OffsetRange.ofLength(g.length))],!1)}static trivialTimedOut(_,g){return new h([new p(M.OffsetRange.ofLength(_.length),M.OffsetRange.ofLength(g.length))],!0)}constructor(_,g){this.diffs=_,this.hitTimeout=g}}i.DiffAlgorithmResult=h;class p{static invert(_,g){const b=[];return(0,t.forEachAdjacent)(_,(e,L)=>{b.push(p.fromOffsetPairs(e?e.getEndExclusives():m.zero,L?L.getStarts():new m(g,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+g)))}),b}static fromOffsetPairs(_,g){return new p(new M.OffsetRange(_.offset1,g.offset1),new M.OffsetRange(_.offset2,g.offset2))}static assertSorted(_){let g;for(const b of _){if(g&&!(g.seq1Range.endExclusive<=b.seq1Range.start&&g.seq2Range.endExclusive<=b.seq2Range.start))throw new n.BugIndicatingError("Sequence diffs must be sorted");g=b}}constructor(_,g){this.seq1Range=_,this.seq2Range=g}swap(){return new p(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(_){return new p(this.seq1Range.join(_.seq1Range),this.seq2Range.join(_.seq2Range))}delta(_){return _===0?this:new p(this.seq1Range.delta(_),this.seq2Range.delta(_))}deltaStart(_){return _===0?this:new p(this.seq1Range.deltaStart(_),this.seq2Range.deltaStart(_))}deltaEnd(_){return _===0?this:new p(this.seq1Range.deltaEnd(_),this.seq2Range.deltaEnd(_))}intersectsOrTouches(_){return this.seq1Range.intersectsOrTouches(_.seq1Range)||this.seq2Range.intersectsOrTouches(_.seq2Range)}intersect(_){const g=this.seq1Range.intersect(_.seq1Range),b=this.seq2Range.intersect(_.seq2Range);if(!(!g||!b))return new p(g,b)}getStarts(){return new m(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new m(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}i.SequenceDiff=p;class m{static{this.zero=new m(0,0)}static{this.max=new m(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(_,g){this.offset1=_,this.offset2=g}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(_){return _===0?this:new m(this.offset1+_,this.offset2+_)}equals(_){return this.offset1===_.offset1&&this.offset2===_.offset2}}i.OffsetPair=m;class l{static{this.instance=new l}isValid(){return!0}}i.InfiniteTimeout=l;class a{constructor(_){if(this.timeout=_,this.startTime=Date.now(),this.valid=!0,_<=0)throw new n.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}i.DateTimeout=a}),ne(ie[33],re([0,1,6,10]),function(W,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MyersDiffAlgorithm=void 0;class M{compute(a,c,_=n.InfiniteTimeout.instance){if(a.length===0||c.length===0)return n.DiffAlgorithmResult.trivial(a,c);const g=a,b=c;function e(r,u){for(;r<g.length&&u<b.length&&g.getElement(r)===b.getElement(u);)r++,u++;return r}let L=0;const E=new p;E.set(0,e(0,0));const N=new m;N.set(0,E.get(0)===0?null:new h(null,0,0,E.get(0)));let w=0;e:for(;;){if(L++,!_.isValid())return n.DiffAlgorithmResult.trivialTimedOut(g,b);const r=-Math.min(L,b.length+L%2),u=Math.min(L,g.length+L%2);for(w=r;w<=u;w+=2){let f=0;const D=w===u?-1:E.get(w+1),R=w===r?-1:E.get(w-1)+1;f++;const S=Math.min(Math.max(D,R),g.length),I=S-w;if(f++,S>g.length||I>b.length)continue;const T=e(S,I);E.set(w,T);const O=S===D?N.get(w+1):N.get(w-1);if(N.set(w,T!==S?new h(O,S,I,T-S):O),E.get(w)===g.length&&E.get(w)-w===b.length)break e}}let v=N.get(w);const A=[];let d=g.length,o=b.length;for(;;){const r=v?v.x+v.length:0,u=v?v.y+v.length:0;if((r!==d||u!==o)&&A.push(new n.SequenceDiff(new t.OffsetRange(r,d),new t.OffsetRange(u,o))),!v)break;d=v.x,o=v.y,v=v.prev}return A.reverse(),new n.DiffAlgorithmResult(A,!1)}}i.MyersDiffAlgorithm=M;class h{constructor(a,c,_,g){this.prev=a,this.x=c,this.y=_,this.length=g}}class p{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,c){if(a<0){if(a=-a-1,a>=this.negativeArr.length){const _=this.negativeArr;this.negativeArr=new Int32Array(_.length*2),this.negativeArr.set(_)}this.negativeArr[a]=c}else{if(a>=this.positiveArr.length){const _=this.positiveArr;this.positiveArr=new Int32Array(_.length*2),this.positiveArr.set(_)}this.positiveArr[a]=c}}}class m{constructor(){this.positiveArr=[],this.negativeArr=[]}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,c){a<0?(a=-a-1,this.negativeArr[a]=c):this.positiveArr[a]=c}}}),ne(ie[54],re([0,1,7,6,10]),function(W,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.optimizeSequenceDiffs=h,i.removeShortMatches=a,i.extendDiffsToEntireWordIfAppropriate=c,i.removeVeryShortMatchingLinesBetweenDiffs=g,i.removeVeryShortMatchingTextBetweenLongDiffs=b;function h(e,L,E){let N=E;return N=p(e,L,N),N=p(e,L,N),N=m(e,L,N),N}function p(e,L,E){if(E.length===0)return E;const N=[];N.push(E[0]);for(let v=1;v<E.length;v++){const A=N[N.length-1];let d=E[v];if(d.seq1Range.isEmpty||d.seq2Range.isEmpty){const o=d.seq1Range.start-A.seq1Range.endExclusive;let r;for(r=1;r<=o&&!(e.getElement(d.seq1Range.start-r)!==e.getElement(d.seq1Range.endExclusive-r)||L.getElement(d.seq2Range.start-r)!==L.getElement(d.seq2Range.endExclusive-r));r++);if(r--,r===o){N[N.length-1]=new M.SequenceDiff(new n.OffsetRange(A.seq1Range.start,d.seq1Range.endExclusive-o),new n.OffsetRange(A.seq2Range.start,d.seq2Range.endExclusive-o));continue}d=d.delta(-r)}N.push(d)}const w=[];for(let v=0;v<N.length-1;v++){const A=N[v+1];let d=N[v];if(d.seq1Range.isEmpty||d.seq2Range.isEmpty){const o=A.seq1Range.start-d.seq1Range.endExclusive;let r;for(r=0;r<o&&!(!e.isStronglyEqual(d.seq1Range.start+r,d.seq1Range.endExclusive+r)||!L.isStronglyEqual(d.seq2Range.start+r,d.seq2Range.endExclusive+r));r++);if(r===o){N[v+1]=new M.SequenceDiff(new n.OffsetRange(d.seq1Range.start+o,A.seq1Range.endExclusive),new n.OffsetRange(d.seq2Range.start+o,A.seq2Range.endExclusive));continue}r>0&&(d=d.delta(r))}w.push(d)}return N.length>0&&w.push(N[N.length-1]),w}function m(e,L,E){if(!e.getBoundaryScore||!L.getBoundaryScore)return E;for(let N=0;N<E.length;N++){const w=N>0?E[N-1]:void 0,v=E[N],A=N+1<E.length?E[N+1]:void 0,d=new n.OffsetRange(w?w.seq1Range.endExclusive+1:0,A?A.seq1Range.start-1:e.length),o=new n.OffsetRange(w?w.seq2Range.endExclusive+1:0,A?A.seq2Range.start-1:L.length);v.seq1Range.isEmpty?E[N]=l(v,e,L,d,o):v.seq2Range.isEmpty&&(E[N]=l(v.swap(),L,e,o,d).swap())}return E}function l(e,L,E,N,w){let A=1;for(;e.seq1Range.start-A>=N.start&&e.seq2Range.start-A>=w.start&&E.isStronglyEqual(e.seq2Range.start-A,e.seq2Range.endExclusive-A)&&A<100;)A++;A--;let d=0;for(;e.seq1Range.start+d<N.endExclusive&&e.seq2Range.endExclusive+d<w.endExclusive&&E.isStronglyEqual(e.seq2Range.start+d,e.seq2Range.endExclusive+d)&&d<100;)d++;if(A===0&&d===0)return e;let o=0,r=-1;for(let u=-A;u<=d;u++){const f=e.seq2Range.start+u,D=e.seq2Range.endExclusive+u,R=e.seq1Range.start+u,S=L.getBoundaryScore(R)+E.getBoundaryScore(f)+E.getBoundaryScore(D);S>r&&(r=S,o=u)}return e.delta(o)}function a(e,L,E){const N=[];for(const w of E){const v=N[N.length-1];if(!v){N.push(w);continue}w.seq1Range.start-v.seq1Range.endExclusive<=2||w.seq2Range.start-v.seq2Range.endExclusive<=2?N[N.length-1]=new M.SequenceDiff(v.seq1Range.join(w.seq1Range),v.seq2Range.join(w.seq2Range)):N.push(w)}return N}function c(e,L,E){const N=M.SequenceDiff.invert(E,e.length),w=[];let v=new M.OffsetPair(0,0);function A(o,r){if(o.offset1<v.offset1||o.offset2<v.offset2)return;const u=e.findWordContaining(o.offset1),f=L.findWordContaining(o.offset2);if(!u||!f)return;let D=new M.SequenceDiff(u,f);const R=D.intersect(r);let S=R.seq1Range.length,I=R.seq2Range.length;for(;N.length>0;){const T=N[0];if(!(T.seq1Range.intersects(D.seq1Range)||T.seq2Range.intersects(D.seq2Range)))break;const P=e.findWordContaining(T.seq1Range.start),y=L.findWordContaining(T.seq2Range.start),x=new M.SequenceDiff(P,y),G=x.intersect(T);if(S+=G.seq1Range.length,I+=G.seq2Range.length,D=D.join(x),D.seq1Range.endExclusive>=T.seq1Range.endExclusive)N.shift();else break}S+I<(D.seq1Range.length+D.seq2Range.length)*2/3&&w.push(D),v=D.getEndExclusives()}for(;N.length>0;){const o=N.shift();o.seq1Range.isEmpty||(A(o.getStarts(),o),A(o.getEndExclusives().delta(-1),o))}return _(E,w)}function _(e,L){const E=[];for(;e.length>0||L.length>0;){const N=e[0],w=L[0];let v;N&&(!w||N.seq1Range.start<w.seq1Range.start)?v=e.shift():v=L.shift(),E.length>0&&E[E.length-1].seq1Range.endExclusive>=v.seq1Range.start?E[E.length-1]=E[E.length-1].join(v):E.push(v)}return E}function g(e,L,E){let N=E;if(N.length===0)return N;let w=0,v;do{v=!1;const A=[N[0]];for(let d=1;d<N.length;d++){let u=function(D,R){const S=new n.OffsetRange(r.seq1Range.endExclusive,o.seq1Range.start);return e.getText(S).replace(/\s/g,"").length<=4&&(D.seq1Range.length+D.seq2Range.length>5||R.seq1Range.length+R.seq2Range.length>5)};const o=N[d],r=A[A.length-1];u(r,o)?(v=!0,A[A.length-1]=A[A.length-1].join(o)):A.push(o)}N=A}while(w++<10&&v);return N}function b(e,L,E){let N=E;if(N.length===0)return N;let w=0,v;do{v=!1;const d=[N[0]];for(let o=1;o<N.length;o++){let f=function(R,S){const I=new n.OffsetRange(u.seq1Range.endExclusive,r.seq1Range.start);if(e.countLinesIn(I)>5||I.length>500)return!1;const O=e.getText(I).trim();if(O.length>20||O.split(/\r\n|\r|\n/).length>1)return!1;const P=e.countLinesIn(R.seq1Range),y=R.seq1Range.length,x=L.countLinesIn(R.seq2Range),G=R.seq2Range.length,U=e.countLinesIn(S.seq1Range),B=S.seq1Range.length,X=L.countLinesIn(S.seq2Range),Y=S.seq2Range.length,$=2*40+50;function Z(ee){return Math.min(ee,$)}return Math.pow(Math.pow(Z(P*40+y),1.5)+Math.pow(Z(x*40+G),1.5),1.5)+Math.pow(Math.pow(Z(U*40+B),1.5)+Math.pow(Z(X*40+Y),1.5),1.5)>($**1.5)**1.5*1.3};const r=N[o],u=d[d.length-1];f(u,r)?(v=!0,d[d.length-1]=d[d.length-1].join(r)):d.push(r)}N=d}while(w++<10&&v);const A=[];return(0,t.forEachWithNeighbors)(N,(d,o,r)=>{let u=o;function f(O){return O.length>0&&O.trim().length<=3&&o.seq1Range.length+o.seq2Range.length>100}const D=e.extendToFullLines(o.seq1Range),R=e.getText(new n.OffsetRange(D.start,o.seq1Range.start));f(R)&&(u=u.deltaStart(-R.length));const S=e.getText(new n.OffsetRange(o.seq1Range.endExclusive,D.endExclusive));f(S)&&(u=u.deltaEnd(S.length));const I=M.SequenceDiff.fromOffsetPairs(d?d.getEndExclusives():M.OffsetPair.zero,r?r.getStarts():M.OffsetPair.max),T=u.intersect(I);A.length>0&&T.getStarts().equals(A[A.length-1].getEndExclusives())?A[A.length-1]=A[A.length-1].join(T):A.push(T)}),A}}),ne(ie[55],re([0,1,4]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineSequence=void 0;class n{constructor(p,m){this.trimmedHash=p,this.lines=m}getElement(p){return this.trimmedHash[p]}get length(){return this.trimmedHash.length}getBoundaryScore(p){const m=p===0?0:M(this.lines[p-1]),l=p===this.lines.length?0:M(this.lines[p]);return 1e3-(m+l)}getText(p){return this.lines.slice(p.start,p.endExclusive).join(`
`)}isStronglyEqual(p,m){return this.lines[p]===this.lines[m]}}i.LineSequence=n;function M(h){let p=0;for(;p<h.length&&(h.charCodeAt(p)===t.CharCode.Space||h.charCodeAt(p)===t.CharCode.Tab);)p++;return p}}),ne(ie[20],re([0,1,4]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineRangeFragment=i.Array2D=void 0,i.isSpace=M;class n{constructor(m,l){this.width=m,this.height=l,this.array=[],this.array=new Array(m*l)}get(m,l){return this.array[m+l*this.width]}set(m,l,a){this.array[m+l*this.width]=a}}i.Array2D=n;function M(p){return p===t.CharCode.Space||p===t.CharCode.Tab}class h{static{this.chrKeys=new Map}static getKey(m){let l=this.chrKeys.get(m);return l===void 0&&(l=this.chrKeys.size,this.chrKeys.set(m,l)),l}constructor(m,l,a){this.range=m,this.lines=l,this.source=a,this.histogram=[];let c=0;for(let _=m.startLineNumber-1;_<m.endLineNumberExclusive-1;_++){const g=l[_];for(let e=0;e<g.length;e++){c++;const L=g[e],E=h.getKey(L);this.histogram[E]=(this.histogram[E]||0)+1}c++;const b=h.getKey(`
`);this.histogram[b]=(this.histogram[b]||0)+1}this.totalCount=c}computeSimilarity(m){let l=0;const a=Math.max(this.histogram.length,m.histogram.length);for(let c=0;c<a;c++)l+=Math.abs((this.histogram[c]??0)-(m.histogram[c]??0));return 1-l/(this.totalCount+m.totalCount)}}i.LineRangeFragment=h}),ne(ie[56],re([0,1,6,10,20]),function(W,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DynamicProgrammingDiffing=void 0;class h{compute(m,l,a=n.InfiniteTimeout.instance,c){if(m.length===0||l.length===0)return n.DiffAlgorithmResult.trivial(m,l);const _=new M.Array2D(m.length,l.length),g=new M.Array2D(m.length,l.length),b=new M.Array2D(m.length,l.length);for(let A=0;A<m.length;A++)for(let d=0;d<l.length;d++){if(!a.isValid())return n.DiffAlgorithmResult.trivialTimedOut(m,l);const o=A===0?0:_.get(A-1,d),r=d===0?0:_.get(A,d-1);let u;m.getElement(A)===l.getElement(d)?(A===0||d===0?u=0:u=_.get(A-1,d-1),A>0&&d>0&&g.get(A-1,d-1)===3&&(u+=b.get(A-1,d-1)),u+=c?c(A,d):1):u=-1;const f=Math.max(o,r,u);if(f===u){const D=A>0&&d>0?b.get(A-1,d-1):0;b.set(A,d,D+1),g.set(A,d,3)}else f===o?(b.set(A,d,0),g.set(A,d,1)):f===r&&(b.set(A,d,0),g.set(A,d,2));_.set(A,d,f)}const e=[];let L=m.length,E=l.length;function N(A,d){(A+1!==L||d+1!==E)&&e.push(new n.SequenceDiff(new t.OffsetRange(A+1,L),new t.OffsetRange(d+1,E))),L=A,E=d}let w=m.length-1,v=l.length-1;for(;w>=0&&v>=0;)g.get(w,v)===3?(N(w,v),w--,v--):g.get(w,v)===1?w--:v--;return N(-1,-1),e.reverse(),new n.DiffAlgorithmResult(e,!1)}}i.DynamicProgrammingDiffing=h}),ne(ie[34],re([0,1,9,4,6,3,2,20]),function(W,i,t,n,M,h,p,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LinesSliceCharSequence=void 0;class l{constructor(L,E,N){this.lines=L,this.range=E,this.considerWhitespaceChanges=N,this.elements=[],this.firstElementOffsetByLineIdx=[],this.lineStartOffsets=[],this.trimmedWsLengthsByLineIdx=[],this.firstElementOffsetByLineIdx.push(0);for(let w=this.range.startLineNumber;w<=this.range.endLineNumber;w++){let v=L[w-1],A=0;w===this.range.startLineNumber&&this.range.startColumn>1&&(A=this.range.startColumn-1,v=v.substring(A)),this.lineStartOffsets.push(A);let d=0;if(!N){const r=v.trimStart();d=v.length-r.length,v=r.trimEnd()}this.trimmedWsLengthsByLineIdx.push(d);const o=w===this.range.endLineNumber?Math.min(this.range.endColumn-1-A-d,v.length):v.length;for(let r=0;r<o;r++)this.elements.push(v.charCodeAt(r));w<this.range.endLineNumber&&(this.elements.push(10),this.firstElementOffsetByLineIdx.push(this.elements.length))}}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new M.OffsetRange(0,this.length))}getText(L){return this.elements.slice(L.start,L.endExclusive).map(E=>String.fromCharCode(E)).join("")}getElement(L){return this.elements[L]}get length(){return this.elements.length}getBoundaryScore(L){const E=b(L>0?this.elements[L-1]:-1),N=b(L<this.elements.length?this.elements[L]:-1);if(E===c.LineBreakCR&&N===c.LineBreakLF)return 0;if(E===c.LineBreakLF)return 150;let w=0;return E!==N&&(w+=10,E===c.WordLower&&N===c.WordUpper&&(w+=1)),w+=g(E),w+=g(N),w}translateOffset(L,E="right"){const N=(0,t.findLastIdxMonotonous)(this.firstElementOffsetByLineIdx,v=>v<=L),w=L-this.firstElementOffsetByLineIdx[N];return new h.Position(this.range.startLineNumber+N,1+this.lineStartOffsets[N]+w+(w===0&&E==="left"?0:this.trimmedWsLengthsByLineIdx[N]))}translateRange(L){const E=this.translateOffset(L.start,"right"),N=this.translateOffset(L.endExclusive,"left");return N.isBefore(E)?p.Range.fromPositions(N,N):p.Range.fromPositions(E,N)}findWordContaining(L){if(L<0||L>=this.elements.length||!a(this.elements[L]))return;let E=L;for(;E>0&&a(this.elements[E-1]);)E--;let N=L;for(;N<this.elements.length&&a(this.elements[N]);)N++;return new M.OffsetRange(E,N)}countLinesIn(L){return this.translateOffset(L.endExclusive).lineNumber-this.translateOffset(L.start).lineNumber}isStronglyEqual(L,E){return this.elements[L]===this.elements[E]}extendToFullLines(L){const E=(0,t.findLastMonotonous)(this.firstElementOffsetByLineIdx,w=>w<=L.start)??0,N=(0,t.findFirstMonotonous)(this.firstElementOffsetByLineIdx,w=>L.endExclusive<=w)??this.elements.length;return new M.OffsetRange(E,N)}}i.LinesSliceCharSequence=l;function a(e){return e>=n.CharCode.a&&e<=n.CharCode.z||e>=n.CharCode.A&&e<=n.CharCode.Z||e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9}var c;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(c||(c={}));const _={[c.WordLower]:0,[c.WordUpper]:0,[c.WordNumber]:0,[c.End]:10,[c.Other]:2,[c.Separator]:30,[c.Space]:3,[c.LineBreakCR]:10,[c.LineBreakLF]:10};function g(e){return _[e]}function b(e){return e===n.CharCode.LineFeed?c.LineBreakLF:e===n.CharCode.CarriageReturn?c.LineBreakCR:(0,m.isSpace)(e)?c.Space:e>=n.CharCode.a&&e<=n.CharCode.z?c.WordLower:e>=n.CharCode.A&&e<=n.CharCode.Z?c.WordUpper:e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9?c.WordNumber:e===-1?c.End:e===n.CharCode.Comma||e===n.CharCode.Semicolon?c.Separator:c.Other}}),ne(ie[35],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MovedText=i.LinesDiff=void 0;class t{constructor(h,p,m){this.changes=h,this.moves=p,this.hitTimeout=m}}i.LinesDiff=t;class n{constructor(h,p){this.lineRangeMapping=h,this.changes=p}flip(){return new n(this.lineRangeMapping.flip(),this.changes.map(h=>h.flip()))}}i.MovedText=n}),ne(ie[21],re([0,1,5,15,3,2,52]),function(W,i,t,n,M,h,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RangeMapping=i.DetailedLineRangeMapping=i.LineRangeMapping=void 0;class m{static inverse(b,e,L){const E=[];let N=1,w=1;for(const A of b){const d=new m(new n.LineRange(N,A.original.startLineNumber),new n.LineRange(w,A.modified.startLineNumber));d.modified.isEmpty||E.push(d),N=A.original.endLineNumberExclusive,w=A.modified.endLineNumberExclusive}const v=new m(new n.LineRange(N,e+1),new n.LineRange(w,L+1));return v.modified.isEmpty||E.push(v),E}static clip(b,e,L){const E=[];for(const N of b){const w=N.original.intersect(e),v=N.modified.intersect(L);w&&!w.isEmpty&&v&&!v.isEmpty&&E.push(new m(w,v))}return E}constructor(b,e){this.original=b,this.modified=e}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new m(this.modified,this.original)}join(b){return new m(this.original.join(b.original),this.modified.join(b.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const b=this.original.toInclusiveRange(),e=this.modified.toInclusiveRange();if(b&&e)return new _(b,e);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new t.BugIndicatingError("not a valid diff");return new _(new h.Range(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new h.Range(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new _(new h.Range(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new h.Range(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}toRangeMapping2(b,e){if(a(this.original.endLineNumberExclusive,b)&&a(this.modified.endLineNumberExclusive,e))return new _(new h.Range(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new h.Range(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1));if(!this.original.isEmpty&&!this.modified.isEmpty)return new _(h.Range.fromPositions(new M.Position(this.original.startLineNumber,1),l(new M.Position(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),b)),h.Range.fromPositions(new M.Position(this.modified.startLineNumber,1),l(new M.Position(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));if(this.original.startLineNumber>1&&this.modified.startLineNumber>1)return new _(h.Range.fromPositions(l(new M.Position(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER),b),l(new M.Position(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),b)),h.Range.fromPositions(l(new M.Position(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER),e),l(new M.Position(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));throw new t.BugIndicatingError}}i.LineRangeMapping=m;function l(g,b){if(g.lineNumber<1)return new M.Position(1,1);if(g.lineNumber>b.length)return new M.Position(b.length,b[b.length-1].length+1);const e=b[g.lineNumber-1];return g.column>e.length+1?new M.Position(g.lineNumber,e.length+1):g}function a(g,b){return g>=1&&g<=b.length}class c extends m{static fromRangeMappings(b){const e=n.LineRange.join(b.map(E=>n.LineRange.fromRangeInclusive(E.originalRange))),L=n.LineRange.join(b.map(E=>n.LineRange.fromRangeInclusive(E.modifiedRange)));return new c(e,L,b)}constructor(b,e,L){super(b,e),this.innerChanges=L}flip(){return new c(this.modified,this.original,this.innerChanges?.map(b=>b.flip()))}withInnerChangesFromLineRanges(){return new c(this.original,this.modified,[this.toRangeMapping()])}}i.DetailedLineRangeMapping=c;class _{static assertSorted(b){for(let e=1;e<b.length;e++){const L=b[e-1],E=b[e];if(!(L.originalRange.getEndPosition().isBeforeOrEqual(E.originalRange.getStartPosition())&&L.modifiedRange.getEndPosition().isBeforeOrEqual(E.modifiedRange.getStartPosition())))throw new t.BugIndicatingError("Range mappings must be sorted")}}constructor(b,e){this.originalRange=b,this.modifiedRange=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new _(this.modifiedRange,this.originalRange)}toTextEdit(b){const e=b.getValueOfRange(this.modifiedRange);return new p.SingleTextEdit(this.originalRange,e)}}i.RangeMapping=_}),ne(ie[57],re([0,1,10,21,7,9,16,15,34,20,33,2]),function(W,i,t,n,M,h,p,m,l,a,c,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeMovedLines=g;function g(v,A,d,o,r,u){let{moves:f,excludedChanges:D}=e(v,A,d,u);if(!u.isValid())return[];const R=v.filter(I=>!D.has(I)),S=L(R,o,r,A,d,u);return(0,M.pushMany)(f,S),f=N(f),f=f.filter(I=>{const T=I.original.toOffsetRange().slice(A).map(P=>P.trim());return T.join(`
`).length>=15&&b(T,P=>P.length>=2)>=2}),f=w(v,f),f}function b(v,A){let d=0;for(const o of v)A(o)&&d++;return d}function e(v,A,d,o){const r=[],u=v.filter(R=>R.modified.isEmpty&&R.original.length>=3).map(R=>new a.LineRangeFragment(R.original,A,R)),f=new Set(v.filter(R=>R.original.isEmpty&&R.modified.length>=3).map(R=>new a.LineRangeFragment(R.modified,d,R))),D=new Set;for(const R of u){let S=-1,I;for(const T of f){const O=R.computeSimilarity(T);O>S&&(S=O,I=T)}if(S>.9&&I&&(f.delete(I),r.push(new n.LineRangeMapping(R.range,I.range)),D.add(R.source),D.add(I.source)),!o.isValid())return{moves:r,excludedChanges:D}}return{moves:r,excludedChanges:D}}function L(v,A,d,o,r,u){const f=[],D=new p.SetMap;for(const O of v)for(let P=O.original.startLineNumber;P<O.original.endLineNumberExclusive-2;P++){const y=`${A[P-1]}:${A[P+1-1]}:${A[P+2-1]}`;D.add(y,{range:new m.LineRange(P,P+3)})}const R=[];v.sort((0,M.compareBy)(O=>O.modified.startLineNumber,M.numberComparator));for(const O of v){let P=[];for(let y=O.modified.startLineNumber;y<O.modified.endLineNumberExclusive-2;y++){const x=`${d[y-1]}:${d[y+1-1]}:${d[y+2-1]}`,G=new m.LineRange(y,y+3),U=[];D.forEach(x,({range:B})=>{for(const Y of P)if(Y.originalLineRange.endLineNumberExclusive+1===B.endLineNumberExclusive&&Y.modifiedLineRange.endLineNumberExclusive+1===G.endLineNumberExclusive){Y.originalLineRange=new m.LineRange(Y.originalLineRange.startLineNumber,B.endLineNumberExclusive),Y.modifiedLineRange=new m.LineRange(Y.modifiedLineRange.startLineNumber,G.endLineNumberExclusive),U.push(Y);return}const X={modifiedLineRange:G,originalLineRange:B};R.push(X),U.push(X)}),P=U}if(!u.isValid())return[]}R.sort((0,M.reverseOrder)((0,M.compareBy)(O=>O.modifiedLineRange.length,M.numberComparator)));const S=new m.LineRangeSet,I=new m.LineRangeSet;for(const O of R){const P=O.modifiedLineRange.startLineNumber-O.originalLineRange.startLineNumber,y=S.subtractFrom(O.modifiedLineRange),x=I.subtractFrom(O.originalLineRange).getWithDelta(P),G=y.getIntersection(x);for(const U of G.ranges){if(U.length<3)continue;const B=U,X=U.delta(-P);f.push(new n.LineRangeMapping(X,B)),S.addRange(B),I.addRange(X)}}f.sort((0,M.compareBy)(O=>O.original.startLineNumber,M.numberComparator));const T=new h.MonotonousArray(v);for(let O=0;O<f.length;O++){const P=f[O],y=T.findLastMonotonous(Z=>Z.original.startLineNumber<=P.original.startLineNumber),x=(0,h.findLastMonotonous)(v,Z=>Z.modified.startLineNumber<=P.modified.startLineNumber),G=Math.max(P.original.startLineNumber-y.original.startLineNumber,P.modified.startLineNumber-x.modified.startLineNumber),U=T.findLastMonotonous(Z=>Z.original.startLineNumber<P.original.endLineNumberExclusive),B=(0,h.findLastMonotonous)(v,Z=>Z.modified.startLineNumber<P.modified.endLineNumberExclusive),X=Math.max(U.original.endLineNumberExclusive-P.original.endLineNumberExclusive,B.modified.endLineNumberExclusive-P.modified.endLineNumberExclusive);let Y;for(Y=0;Y<G;Y++){const Z=P.original.startLineNumber-Y-1,ee=P.modified.startLineNumber-Y-1;if(Z>o.length||ee>r.length||S.contains(ee)||I.contains(Z)||!E(o[Z-1],r[ee-1],u))break}Y>0&&(I.addRange(new m.LineRange(P.original.startLineNumber-Y,P.original.startLineNumber)),S.addRange(new m.LineRange(P.modified.startLineNumber-Y,P.modified.startLineNumber)));let $;for($=0;$<X;$++){const Z=P.original.endLineNumberExclusive+$,ee=P.modified.endLineNumberExclusive+$;if(Z>o.length||ee>r.length||S.contains(ee)||I.contains(Z)||!E(o[Z-1],r[ee-1],u))break}$>0&&(I.addRange(new m.LineRange(P.original.endLineNumberExclusive,P.original.endLineNumberExclusive+$)),S.addRange(new m.LineRange(P.modified.endLineNumberExclusive,P.modified.endLineNumberExclusive+$))),(Y>0||$>0)&&(f[O]=new n.LineRangeMapping(new m.LineRange(P.original.startLineNumber-Y,P.original.endLineNumberExclusive+$),new m.LineRange(P.modified.startLineNumber-Y,P.modified.endLineNumberExclusive+$)))}return f}function E(v,A,d){if(v.trim()===A.trim())return!0;if(v.length>300&&A.length>300)return!1;const r=new c.MyersDiffAlgorithm().compute(new l.LinesSliceCharSequence([v],new _.Range(1,1,1,v.length),!1),new l.LinesSliceCharSequence([A],new _.Range(1,1,1,A.length),!1),d);let u=0;const f=t.SequenceDiff.invert(r.diffs,v.length);for(const I of f)I.seq1Range.forEach(T=>{(0,a.isSpace)(v.charCodeAt(T))||u++});function D(I){let T=0;for(let O=0;O<v.length;O++)(0,a.isSpace)(I.charCodeAt(O))||T++;return T}const R=D(v.length>A.length?v:A);return u/R>.6&&R>10}function N(v){if(v.length===0)return v;v.sort((0,M.compareBy)(d=>d.original.startLineNumber,M.numberComparator));const A=[v[0]];for(let d=1;d<v.length;d++){const o=A[A.length-1],r=v[d],u=r.original.startLineNumber-o.original.endLineNumberExclusive,f=r.modified.startLineNumber-o.modified.endLineNumberExclusive;if(u>=0&&f>=0&&u+f<=2){A[A.length-1]=o.join(r);continue}A.push(r)}return A}function w(v,A){const d=new h.MonotonousArray(v);return A=A.filter(o=>{const r=d.findLastMonotonous(D=>D.original.startLineNumber<o.original.endLineNumberExclusive)||new n.LineRangeMapping(new m.LineRange(1,1),new m.LineRange(1,1)),u=(0,h.findLastMonotonous)(v,D=>D.modified.startLineNumber<o.modified.endLineNumberExclusive);return r!==u}),A}}),ne(ie[58],re([0,1,7,11,15,6,2,10,56,33,57,54,55,34,35,21]),function(W,i,t,n,M,h,p,m,l,a,c,_,g,b,e,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DefaultLinesDiffComputer=void 0,i.lineRangeMappingFromRangeMappings=N,i.getLineRangeMapping=w;class E{constructor(){this.dynamicProgrammingDiffing=new l.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new a.MyersDiffAlgorithm}computeDiff(d,o,r){if(d.length<=1&&(0,t.equals)(d,o,(Z,ee)=>Z===ee))return new e.LinesDiff([],[],!1);if(d.length===1&&d[0].length===0||o.length===1&&o[0].length===0)return new e.LinesDiff([new L.DetailedLineRangeMapping(new M.LineRange(1,d.length+1),new M.LineRange(1,o.length+1),[new L.RangeMapping(new p.Range(1,1,d.length,d[d.length-1].length+1),new p.Range(1,1,o.length,o[o.length-1].length+1))])],[],!1);const u=r.maxComputationTimeMs===0?m.InfiniteTimeout.instance:new m.DateTimeout(r.maxComputationTimeMs),f=!r.ignoreTrimWhitespace,D=new Map;function R(Z){let ee=D.get(Z);return ee===void 0&&(ee=D.size,D.set(Z,ee)),ee}const S=d.map(Z=>R(Z.trim())),I=o.map(Z=>R(Z.trim())),T=new g.LineSequence(S,d),O=new g.LineSequence(I,o),P=T.length+O.length<1700?this.dynamicProgrammingDiffing.compute(T,O,u,(Z,ee)=>d[Z]===o[ee]?o[ee].length===0?.1:1+Math.log(1+o[ee].length):.99):this.myersDiffingAlgorithm.compute(T,O,u);let y=P.diffs,x=P.hitTimeout;y=(0,_.optimizeSequenceDiffs)(T,O,y),y=(0,_.removeVeryShortMatchingLinesBetweenDiffs)(T,O,y);const G=[],U=Z=>{if(f)for(let ee=0;ee<Z;ee++){const F=B+ee,C=X+ee;if(d[F]!==o[C]){const ce=this.refineDiff(d,o,new m.SequenceDiff(new h.OffsetRange(F,F+1),new h.OffsetRange(C,C+1)),u,f);for(const oe of ce.mappings)G.push(oe);ce.hitTimeout&&(x=!0)}}};let B=0,X=0;for(const Z of y){(0,n.assertFn)(()=>Z.seq1Range.start-B===Z.seq2Range.start-X);const ee=Z.seq1Range.start-B;U(ee),B=Z.seq1Range.endExclusive,X=Z.seq2Range.endExclusive;const F=this.refineDiff(d,o,Z,u,f);F.hitTimeout&&(x=!0);for(const C of F.mappings)G.push(C)}U(d.length-B);const Y=N(G,d,o);let $=[];return r.computeMoves&&($=this.computeMoves(Y,d,o,S,I,u,f)),(0,n.assertFn)(()=>{function Z(F,C){if(F.lineNumber<1||F.lineNumber>C.length)return!1;const ce=C[F.lineNumber-1];return!(F.column<1||F.column>ce.length+1)}function ee(F,C){return!(F.startLineNumber<1||F.startLineNumber>C.length+1||F.endLineNumberExclusive<1||F.endLineNumberExclusive>C.length+1)}for(const F of Y){if(!F.innerChanges)return!1;for(const C of F.innerChanges)if(!(Z(C.modifiedRange.getStartPosition(),o)&&Z(C.modifiedRange.getEndPosition(),o)&&Z(C.originalRange.getStartPosition(),d)&&Z(C.originalRange.getEndPosition(),d)))return!1;if(!ee(F.modified,o)||!ee(F.original,d))return!1}return!0}),new e.LinesDiff(Y,$,x)}computeMoves(d,o,r,u,f,D,R){return(0,c.computeMovedLines)(d,o,r,u,f,D).map(T=>{const O=this.refineDiff(o,r,new m.SequenceDiff(T.original.toOffsetRange(),T.modified.toOffsetRange()),D,R),P=N(O.mappings,o,r,!0);return new e.MovedText(T,P)})}refineDiff(d,o,r,u,f){const R=v(r).toRangeMapping2(d,o),S=new b.LinesSliceCharSequence(d,R.originalRange,f),I=new b.LinesSliceCharSequence(o,R.modifiedRange,f),T=S.length+I.length<500?this.dynamicProgrammingDiffing.compute(S,I,u):this.myersDiffingAlgorithm.compute(S,I,u),O=!1;let P=T.diffs;O&&m.SequenceDiff.assertSorted(P),P=(0,_.optimizeSequenceDiffs)(S,I,P),O&&m.SequenceDiff.assertSorted(P),P=(0,_.extendDiffsToEntireWordIfAppropriate)(S,I,P),O&&m.SequenceDiff.assertSorted(P),P=(0,_.removeShortMatches)(S,I,P),O&&m.SequenceDiff.assertSorted(P),P=(0,_.removeVeryShortMatchingTextBetweenLongDiffs)(S,I,P),O&&m.SequenceDiff.assertSorted(P);const y=P.map(x=>new L.RangeMapping(S.translateRange(x.seq1Range),I.translateRange(x.seq2Range)));return O&&L.RangeMapping.assertSorted(y),{mappings:y,hitTimeout:T.hitTimeout}}}i.DefaultLinesDiffComputer=E;function N(A,d,o,r=!1){const u=[];for(const f of(0,t.groupAdjacentBy)(A.map(D=>w(D,d,o)),(D,R)=>D.original.overlapOrTouch(R.original)||D.modified.overlapOrTouch(R.modified))){const D=f[0],R=f[f.length-1];u.push(new L.DetailedLineRangeMapping(D.original.join(R.original),D.modified.join(R.modified),f.map(S=>S.innerChanges[0])))}return(0,n.assertFn)(()=>!r&&u.length>0&&(u[0].modified.startLineNumber!==u[0].original.startLineNumber||o.length-u[u.length-1].modified.endLineNumberExclusive!==d.length-u[u.length-1].original.endLineNumberExclusive)?!1:(0,n.checkAdjacentItems)(u,(f,D)=>D.original.startLineNumber-f.original.endLineNumberExclusive===D.modified.startLineNumber-f.modified.endLineNumberExclusive&&f.original.endLineNumberExclusive<D.original.startLineNumber&&f.modified.endLineNumberExclusive<D.modified.startLineNumber)),u}function w(A,d,o){let r=0,u=0;A.modifiedRange.endColumn===1&&A.originalRange.endColumn===1&&A.originalRange.startLineNumber+r<=A.originalRange.endLineNumber&&A.modifiedRange.startLineNumber+r<=A.modifiedRange.endLineNumber&&(u=-1),A.modifiedRange.startColumn-1>=o[A.modifiedRange.startLineNumber-1].length&&A.originalRange.startColumn-1>=d[A.originalRange.startLineNumber-1].length&&A.originalRange.startLineNumber<=A.originalRange.endLineNumber+u&&A.modifiedRange.startLineNumber<=A.modifiedRange.endLineNumber+u&&(r=1);const f=new M.LineRange(A.originalRange.startLineNumber+r,A.originalRange.endLineNumber+1+u),D=new M.LineRange(A.modifiedRange.startLineNumber+r,A.modifiedRange.endLineNumber+1+u);return new L.DetailedLineRangeMapping(f,D,[A])}function v(A){return new L.LineRangeMapping(new M.LineRange(A.seq1Range.start+1,A.seq1Range.endExclusive+1),new M.LineRange(A.seq2Range.start+1,A.seq2Range.endExclusive+1))}}),ne(ie[36],re([0,1,4,29,35,21,8,2,11,15]),function(W,i,t,n,M,h,p,m,l,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiffComputer=i.LegacyLinesDiffComputer=void 0,p=Be(p);const c=3;class _{computeDiff(r,u,f){const R=new w(r,u,{maxComputationTime:f.maxComputationTimeMs,shouldIgnoreTrimWhitespace:f.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),S=[];let I=null;for(const T of R.changes){let O;T.originalEndLineNumber===0?O=new a.LineRange(T.originalStartLineNumber+1,T.originalStartLineNumber+1):O=new a.LineRange(T.originalStartLineNumber,T.originalEndLineNumber+1);let P;T.modifiedEndLineNumber===0?P=new a.LineRange(T.modifiedStartLineNumber+1,T.modifiedStartLineNumber+1):P=new a.LineRange(T.modifiedStartLineNumber,T.modifiedEndLineNumber+1);let y=new h.DetailedLineRangeMapping(O,P,T.charChanges?.map(x=>new h.RangeMapping(new m.Range(x.originalStartLineNumber,x.originalStartColumn,x.originalEndLineNumber,x.originalEndColumn),new m.Range(x.modifiedStartLineNumber,x.modifiedStartColumn,x.modifiedEndLineNumber,x.modifiedEndColumn))));I&&(I.modified.endLineNumberExclusive===y.modified.startLineNumber||I.original.endLineNumberExclusive===y.original.startLineNumber)&&(y=new h.DetailedLineRangeMapping(I.original.join(y.original),I.modified.join(y.modified),I.innerChanges&&y.innerChanges?I.innerChanges.concat(y.innerChanges):void 0),S.pop()),S.push(y),I=y}return(0,l.assertFn)(()=>(0,l.checkAdjacentItems)(S,(T,O)=>O.original.startLineNumber-T.original.endLineNumberExclusive===O.modified.startLineNumber-T.modified.endLineNumberExclusive&&T.original.endLineNumberExclusive<O.original.startLineNumber&&T.modified.endLineNumberExclusive<O.modified.startLineNumber)),new M.LinesDiff(S,[],R.quitEarly)}}i.LegacyLinesDiffComputer=_;function g(o,r,u,f){return new n.LcsDiff(o,r,u).ComputeDiff(f)}class b{constructor(r){const u=[],f=[];for(let D=0,R=r.length;D<R;D++)u[D]=v(r[D],1),f[D]=A(r[D],1);this.lines=r,this._startColumns=u,this._endColumns=f}getElements(){const r=[];for(let u=0,f=this.lines.length;u<f;u++)r[u]=this.lines[u].substring(this._startColumns[u]-1,this._endColumns[u]-1);return r}getStrictElement(r){return this.lines[r]}getStartLineNumber(r){return r+1}getEndLineNumber(r){return r+1}createCharSequence(r,u,f){const D=[],R=[],S=[];let I=0;for(let T=u;T<=f;T++){const O=this.lines[T],P=r?this._startColumns[T]:1,y=r?this._endColumns[T]:O.length+1;for(let x=P;x<y;x++)D[I]=O.charCodeAt(x-1),R[I]=T+1,S[I]=x,I++;!r&&T<f&&(D[I]=t.CharCode.LineFeed,R[I]=T+1,S[I]=O.length+1,I++)}return new e(D,R,S)}}class e{constructor(r,u,f){this._charCodes=r,this._lineNumbers=u,this._columns=f}toString(){return"["+this._charCodes.map((r,u)=>(r===t.CharCode.LineFeed?"\\n":String.fromCharCode(r))+`-(${this._lineNumbers[u]},${this._columns[u]})`).join(", ")+"]"}_assertIndex(r,u){if(r<0||r>=u.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(r){return r>0&&r===this._lineNumbers.length?this.getEndLineNumber(r-1):(this._assertIndex(r,this._lineNumbers),this._lineNumbers[r])}getEndLineNumber(r){return r===-1?this.getStartLineNumber(r+1):(this._assertIndex(r,this._lineNumbers),this._charCodes[r]===t.CharCode.LineFeed?this._lineNumbers[r]+1:this._lineNumbers[r])}getStartColumn(r){return r>0&&r===this._columns.length?this.getEndColumn(r-1):(this._assertIndex(r,this._columns),this._columns[r])}getEndColumn(r){return r===-1?this.getStartColumn(r+1):(this._assertIndex(r,this._columns),this._charCodes[r]===t.CharCode.LineFeed?1:this._columns[r]+1)}}class L{constructor(r,u,f,D,R,S,I,T){this.originalStartLineNumber=r,this.originalStartColumn=u,this.originalEndLineNumber=f,this.originalEndColumn=D,this.modifiedStartLineNumber=R,this.modifiedStartColumn=S,this.modifiedEndLineNumber=I,this.modifiedEndColumn=T}static createFromDiffChange(r,u,f){const D=u.getStartLineNumber(r.originalStart),R=u.getStartColumn(r.originalStart),S=u.getEndLineNumber(r.originalStart+r.originalLength-1),I=u.getEndColumn(r.originalStart+r.originalLength-1),T=f.getStartLineNumber(r.modifiedStart),O=f.getStartColumn(r.modifiedStart),P=f.getEndLineNumber(r.modifiedStart+r.modifiedLength-1),y=f.getEndColumn(r.modifiedStart+r.modifiedLength-1);return new L(D,R,S,I,T,O,P,y)}}function E(o){if(o.length<=1)return o;const r=[o[0]];let u=r[0];for(let f=1,D=o.length;f<D;f++){const R=o[f],S=R.originalStart-(u.originalStart+u.originalLength),I=R.modifiedStart-(u.modifiedStart+u.modifiedLength);Math.min(S,I)<c?(u.originalLength=R.originalStart+R.originalLength-u.originalStart,u.modifiedLength=R.modifiedStart+R.modifiedLength-u.modifiedStart):(r.push(R),u=R)}return r}class N{constructor(r,u,f,D,R){this.originalStartLineNumber=r,this.originalEndLineNumber=u,this.modifiedStartLineNumber=f,this.modifiedEndLineNumber=D,this.charChanges=R}static createFromDiffResult(r,u,f,D,R,S,I){let T,O,P,y,x;if(u.originalLength===0?(T=f.getStartLineNumber(u.originalStart)-1,O=0):(T=f.getStartLineNumber(u.originalStart),O=f.getEndLineNumber(u.originalStart+u.originalLength-1)),u.modifiedLength===0?(P=D.getStartLineNumber(u.modifiedStart)-1,y=0):(P=D.getStartLineNumber(u.modifiedStart),y=D.getEndLineNumber(u.modifiedStart+u.modifiedLength-1)),S&&u.originalLength>0&&u.originalLength<20&&u.modifiedLength>0&&u.modifiedLength<20&&R()){const G=f.createCharSequence(r,u.originalStart,u.originalStart+u.originalLength-1),U=D.createCharSequence(r,u.modifiedStart,u.modifiedStart+u.modifiedLength-1);if(G.getElements().length>0&&U.getElements().length>0){let B=g(G,U,R,!0).changes;I&&(B=E(B)),x=[];for(let X=0,Y=B.length;X<Y;X++)x.push(L.createFromDiffChange(B[X],G,U))}}return new N(T,O,P,y,x)}}class w{constructor(r,u,f){this.shouldComputeCharChanges=f.shouldComputeCharChanges,this.shouldPostProcessCharChanges=f.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=f.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=f.shouldMakePrettyDiff,this.originalLines=r,this.modifiedLines=u,this.original=new b(r),this.modified=new b(u),this.continueLineDiff=d(f.maxComputationTime),this.continueCharDiff=d(f.maxComputationTime===0?0:Math.min(f.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const r=g(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),u=r.changes,f=r.quitEarly;if(this.shouldIgnoreTrimWhitespace){const I=[];for(let T=0,O=u.length;T<O;T++)I.push(N.createFromDiffResult(this.shouldIgnoreTrimWhitespace,u[T],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:f,changes:I}}const D=[];let R=0,S=0;for(let I=-1,T=u.length;I<T;I++){const O=I+1<T?u[I+1]:null,P=O?O.originalStart:this.originalLines.length,y=O?O.modifiedStart:this.modifiedLines.length;for(;R<P&&S<y;){const x=this.originalLines[R],G=this.modifiedLines[S];if(x!==G){{let U=v(x,1),B=v(G,1);for(;U>1&&B>1;){const X=x.charCodeAt(U-2),Y=G.charCodeAt(B-2);if(X!==Y)break;U--,B--}(U>1||B>1)&&this._pushTrimWhitespaceCharChange(D,R+1,1,U,S+1,1,B)}{let U=A(x,1),B=A(G,1);const X=x.length+1,Y=G.length+1;for(;U<X&&B<Y;){const $=x.charCodeAt(U-1),Z=x.charCodeAt(B-1);if($!==Z)break;U++,B++}(U<X||B<Y)&&this._pushTrimWhitespaceCharChange(D,R+1,U,X,S+1,B,Y)}}R++,S++}O&&(D.push(N.createFromDiffResult(this.shouldIgnoreTrimWhitespace,O,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),R+=O.originalLength,S+=O.modifiedLength)}return{quitEarly:f,changes:D}}_pushTrimWhitespaceCharChange(r,u,f,D,R,S,I){if(this._mergeTrimWhitespaceCharChange(r,u,f,D,R,S,I))return;let T;this.shouldComputeCharChanges&&(T=[new L(u,f,u,D,R,S,R,I)]),r.push(new N(u,u,R,R,T))}_mergeTrimWhitespaceCharChange(r,u,f,D,R,S,I){const T=r.length;if(T===0)return!1;const O=r[T-1];return O.originalEndLineNumber===0||O.modifiedEndLineNumber===0?!1:O.originalEndLineNumber===u&&O.modifiedEndLineNumber===R?(this.shouldComputeCharChanges&&O.charChanges&&O.charChanges.push(new L(u,f,u,D,R,S,R,I)),!0):O.originalEndLineNumber+1===u&&O.modifiedEndLineNumber+1===R?(O.originalEndLineNumber=u,O.modifiedEndLineNumber=R,this.shouldComputeCharChanges&&O.charChanges&&O.charChanges.push(new L(u,f,u,D,R,S,R,I)),!0):!1}}i.DiffComputer=w;function v(o,r){const u=p.firstNonWhitespaceIndex(o);return u===-1?r:u+1}function A(o,r){const u=p.lastNonWhitespaceIndex(o);return u===-1?r:u+2}function d(o){if(o===0)return()=>!0;const r=Date.now();return()=>Date.now()-r<o}}),ne(ie[59],re([0,1,36,58]),function(W,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.linesDiffComputers=void 0,i.linesDiffComputers={getLegacy:()=>new t.LegacyLinesDiffComputer,getDefault:()=>new n.DefaultLinesDiffComputer}}),ne(ie[60],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TokenMetadata=i.MetadataConsts=i.StandardTokenType=i.ColorId=i.FontStyle=i.LanguageId=void 0;var t;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(t||(i.LanguageId=t={}));var n;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline",l[l.Strikethrough=8]="Strikethrough"})(n||(i.FontStyle=n={}));var M;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(M||(i.ColorId=M={}));var h;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=3]="RegEx"})(h||(i.StandardTokenType=h={}));var p;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",l[l.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",l[l.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",l[l.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(p||(i.MetadataConsts=p={}));class m{static getLanguageId(a){return(a&p.LANGUAGEID_MASK)>>>p.LANGUAGEID_OFFSET}static getTokenType(a){return(a&p.TOKEN_TYPE_MASK)>>>p.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(a){return(a&p.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(a){return(a&p.FONT_STYLE_MASK)>>>p.FONT_STYLE_OFFSET}static getForeground(a){return(a&p.FOREGROUND_MASK)>>>p.FOREGROUND_OFFSET}static getBackground(a){return(a&p.BACKGROUND_MASK)>>>p.BACKGROUND_OFFSET}static getClassNameFromMetadata(a){let _="mtk"+this.getForeground(a);const g=this.getFontStyle(a);return g&n.Italic&&(_+=" mtki"),g&n.Bold&&(_+=" mtkb"),g&n.Underline&&(_+=" mtku"),g&n.Strikethrough&&(_+=" mtks"),_}static getInlineStyleFromMetadata(a,c){const _=this.getForeground(a),g=this.getFontStyle(a);let b=`color: ${c[_]};`;g&n.Italic&&(b+="font-style: italic;"),g&n.Bold&&(b+="font-weight: bold;");let e="";return g&n.Underline&&(e+=" underline"),g&n.Strikethrough&&(e+=" line-through"),e&&(b+=`text-decoration:${e};`),b}static getPresentationFromMetadata(a){const c=this.getForeground(a),_=this.getFontStyle(a);return{foreground:c,italic:!!(_&n.Italic),bold:!!(_&n.Bold),underline:!!(_&n.Underline),strikethrough:!!(_&n.Strikethrough)}}}i.TokenMetadata=m}),ne(ie[61],re([0,1,38]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeDefaultDocumentColors=_;function n(g){const b=[];for(const e of g){const L=Number(e);(L||L===0&&e.replace(/\s/g,"")!=="")&&b.push(L)}return b}function M(g,b,e,L){return{red:g/255,blue:e/255,green:b/255,alpha:L}}function h(g,b){const e=b.index,L=b[0].length;if(!e)return;const E=g.positionAt(e);return{startLineNumber:E.lineNumber,startColumn:E.column,endLineNumber:E.lineNumber,endColumn:E.column+L}}function p(g,b){if(!g)return;const e=t.Color.Format.CSS.parseHex(b);if(e)return{range:g,color:M(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function m(g,b,e){if(!g||b.length!==1)return;const E=b[0].values(),N=n(E);return{range:g,color:M(N[0],N[1],N[2],e?N[3]:1)}}function l(g,b,e){if(!g||b.length!==1)return;const E=b[0].values(),N=n(E),w=new t.Color(new t.HSLA(N[0],N[1]/100,N[2]/100,e?N[3]:1));return{range:g,color:M(w.rgba.r,w.rgba.g,w.rgba.b,w.rgba.a)}}function a(g,b){return typeof g=="string"?[...g.matchAll(b)]:g.findMatches(b)}function c(g){const b=[],L=a(g,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(L.length>0)for(const E of L){const N=E.filter(d=>d!==void 0),w=N[1],v=N[2];if(!v)continue;let A;if(w==="rgb"){const d=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;A=m(h(g,E),a(v,d),!1)}else if(w==="rgba"){const d=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;A=m(h(g,E),a(v,d),!0)}else if(w==="hsl"){const d=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;A=l(h(g,E),a(v,d),!1)}else if(w==="hsla"){const d=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;A=l(h(g,E),a(v,d),!0)}else w==="#"&&(A=p(h(g,E),w+v));A&&b.push(A)}return b}function _(g){return!g||typeof g.getValue!="function"||typeof g.positionAt!="function"?[]:c(g)}}),ne(ie[62],re([0,1,4,30]),function(W,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LinkComputer=i.StateMachine=i.State=void 0,i.computeLinks=b;var M;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(M||(i.State=M={}));class h{constructor(L,E,N){const w=new Uint8Array(L*E);for(let v=0,A=L*E;v<A;v++)w[v]=N;this._data=w,this.rows=L,this.cols=E}get(L,E){return this._data[L*this.cols+E]}set(L,E,N){this._data[L*this.cols+E]=N}}class p{constructor(L){let E=0,N=M.Invalid;for(let v=0,A=L.length;v<A;v++){const[d,o,r]=L[v];o>E&&(E=o),d>N&&(N=d),r>N&&(N=r)}E++,N++;const w=new h(N,E,M.Invalid);for(let v=0,A=L.length;v<A;v++){const[d,o,r]=L[v];w.set(d,o,r)}this._states=w,this._maxCharCode=E}nextState(L,E){return E<0||E>=this._maxCharCode?M.Invalid:this._states.get(L,E)}}i.StateMachine=p;let m=null;function l(){return m===null&&(m=new p([[M.Start,t.CharCode.h,M.H],[M.Start,t.CharCode.H,M.H],[M.Start,t.CharCode.f,M.F],[M.Start,t.CharCode.F,M.F],[M.H,t.CharCode.t,M.HT],[M.H,t.CharCode.T,M.HT],[M.HT,t.CharCode.t,M.HTT],[M.HT,t.CharCode.T,M.HTT],[M.HTT,t.CharCode.p,M.HTTP],[M.HTT,t.CharCode.P,M.HTTP],[M.HTTP,t.CharCode.s,M.BeforeColon],[M.HTTP,t.CharCode.S,M.BeforeColon],[M.HTTP,t.CharCode.Colon,M.AfterColon],[M.F,t.CharCode.i,M.FI],[M.F,t.CharCode.I,M.FI],[M.FI,t.CharCode.l,M.FIL],[M.FI,t.CharCode.L,M.FIL],[M.FIL,t.CharCode.e,M.BeforeColon],[M.FIL,t.CharCode.E,M.BeforeColon],[M.BeforeColon,t.CharCode.Colon,M.AfterColon],[M.AfterColon,t.CharCode.Slash,M.AlmostThere],[M.AlmostThere,t.CharCode.Slash,M.End]])),m}var a;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let c=null;function _(){if(c===null){c=new n.CharacterClassifier(a.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<e.length;E++)c.set(e.charCodeAt(E),a.ForceTermination);const L=".,;:";for(let E=0;E<L.length;E++)c.set(L.charCodeAt(E),a.CannotEndIn)}return c}class g{static _createLink(L,E,N,w,v){let A=v-1;do{const d=E.charCodeAt(A);if(L.get(d)!==a.CannotEndIn)break;A--}while(A>w);if(w>0){const d=E.charCodeAt(w-1),o=E.charCodeAt(A);(d===t.CharCode.OpenParen&&o===t.CharCode.CloseParen||d===t.CharCode.OpenSquareBracket&&o===t.CharCode.CloseSquareBracket||d===t.CharCode.OpenCurlyBrace&&o===t.CharCode.CloseCurlyBrace)&&A--}return{range:{startLineNumber:N,startColumn:w+1,endLineNumber:N,endColumn:A+2},url:E.substring(w,A+1)}}static computeLinks(L,E=l()){const N=_(),w=[];for(let v=1,A=L.getLineCount();v<=A;v++){const d=L.getLineContent(v),o=d.length;let r=0,u=0,f=0,D=M.Start,R=!1,S=!1,I=!1,T=!1;for(;r<o;){let O=!1;const P=d.charCodeAt(r);if(D===M.Accept){let y;switch(P){case t.CharCode.OpenParen:R=!0,y=a.None;break;case t.CharCode.CloseParen:y=R?a.None:a.ForceTermination;break;case t.CharCode.OpenSquareBracket:I=!0,S=!0,y=a.None;break;case t.CharCode.CloseSquareBracket:I=!1,y=S?a.None:a.ForceTermination;break;case t.CharCode.OpenCurlyBrace:T=!0,y=a.None;break;case t.CharCode.CloseCurlyBrace:y=T?a.None:a.ForceTermination;break;case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.BackTick:f===P?y=a.ForceTermination:f===t.CharCode.SingleQuote||f===t.CharCode.DoubleQuote||f===t.CharCode.BackTick?y=a.None:y=a.ForceTermination;break;case t.CharCode.Asterisk:y=f===t.CharCode.Asterisk?a.ForceTermination:a.None;break;case t.CharCode.Pipe:y=f===t.CharCode.Pipe?a.ForceTermination:a.None;break;case t.CharCode.Space:y=I?a.None:a.ForceTermination;break;default:y=N.get(P)}y===a.ForceTermination&&(w.push(g._createLink(N,d,v,u,r)),O=!0)}else if(D===M.End){let y;P===t.CharCode.OpenSquareBracket?(S=!0,y=a.None):y=N.get(P),y===a.ForceTermination?O=!0:D=M.Accept}else D=E.nextState(D,P),D===M.Invalid&&(O=!0);O&&(D=M.Start,R=!1,S=!1,T=!1,u=r+1,f=P),r++}D===M.Accept&&w.push(g._createLink(N,d,v,u,o))}return w}}i.LinkComputer=g;function b(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:g.computeLinks(e)}}),ne(ie[63],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.BasicInplaceReplace=void 0;class t{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new t}navigateValueSet(M,h,p,m,l){if(M&&h){const a=this.doNavigateValueSet(h,l);if(a)return{range:M,value:a}}if(p&&m){const a=this.doNavigateValueSet(m,l);if(a)return{range:p,value:a}}return null}doNavigateValueSet(M,h){const p=this.numberReplace(M,h);return p!==null?p:this.textReplace(M,h)}numberReplace(M,h){const p=Math.pow(10,M.length-(M.lastIndexOf(".")+1));let m=Number(M);const l=parseFloat(M);return!isNaN(m)&&!isNaN(l)&&m===l?m===0&&!h?null:(m=Math.floor(m*p),m+=h?p:-p,String(m/p)):null}textReplace(M,h){return this.valueSetsReplace(this._defaultValueSet,M,h)}valueSetsReplace(M,h,p){let m=null;for(let l=0,a=M.length;m===null&&l<a;l++)m=this.valueSetReplace(M[l],h,p);return m}valueSetReplace(M,h,p){let m=M.indexOf(h);return m>=0?(m+=p?1:-1,m<0?m=M.length-1:m%=M.length,M[m]):null}}i.BasicInplaceReplace=t}),ne(ie[64],re([0,1,18]),function(W,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ApplyEditsResult=i.SearchData=i.ValidAnnotatedEditOperation=i.ModelConstants=i.PositionAffinity=i.TrackedRangeStickiness=i.FindMatch=i.TextModelResolvedOptions=i.EndOfLineSequence=i.DefaultEndOfLine=i.EndOfLinePreference=i.InjectedTextCursorStops=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.GlyphMarginLane=i.OverviewRulerLane=void 0,i.isITextSnapshot=e,i.shouldSynchronizeModel=A;var n;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(n||(i.OverviewRulerLane=n={}));var M;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=3]="Right"})(M||(i.GlyphMarginLane=M={}));var h;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(h||(i.MinimapPosition=h={}));var p;(function(d){d[d.Normal=1]="Normal",d[d.Underlined=2]="Underlined"})(p||(i.MinimapSectionHeaderStyle=p={}));var m;(function(d){d[d.Both=0]="Both",d[d.Right=1]="Right",d[d.Left=2]="Left",d[d.None=3]="None"})(m||(i.InjectedTextCursorStops=m={}));var l;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(l||(i.EndOfLinePreference=l={}));var a;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(a||(i.DefaultEndOfLine=a={}));var c;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(c||(i.EndOfLineSequence=c={}));class _{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,o.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this._indentSizeIsTabSize===o._indentSizeIsTabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,t.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}i.TextModelResolvedOptions=_;class g{constructor(o,r){this._findMatchBrand=void 0,this.range=o,this.matches=r}}i.FindMatch=g;var b;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(i.TrackedRangeStickiness=b={}));function e(d){return d&&typeof d.read=="function"}var L;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right",d[d.None=2]="None",d[d.LeftOfInjectedText=3]="LeftOfInjectedText",d[d.RightOfInjectedText=4]="RightOfInjectedText"})(L||(i.PositionAffinity=L={}));var E;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(i.ModelConstants=E={}));class N{constructor(o,r,u,f,D,R){this.identifier=o,this.range=r,this.text=u,this.forceMoveMarkers=f,this.isAutoWhitespaceEdit=D,this._isTracked=R}}i.ValidAnnotatedEditOperation=N;class w{constructor(o,r,u){this.regex=o,this.wordSeparators=r,this.simpleSearch=u}}i.SearchData=w;class v{constructor(o,r,u){this.reverseEdits=o,this.changes=r,this.trimAutoWhitespaceLineNumbers=u}}i.ApplyEditsResult=v;function A(d){return!d.isTooLargeForSyncing()&&!d.isForSimpleWidget}}),ne(ie[65],re([0,1,7,14]),function(W,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PrefixSumIndexOfResult=i.ConstantTimePrefixSumComputer=i.PrefixSumComputer=void 0;class M{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(l,a){l=(0,n.toUint32)(l);const c=this.values,_=this.prefixSum,g=a.length;return g===0?!1:(this.values=new Uint32Array(c.length+g),this.values.set(c.subarray(0,l),0),this.values.set(c.subarray(l),l+g),this.values.set(a,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(_.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,a){return l=(0,n.toUint32)(l),a=(0,n.toUint32)(a),this.values[l]===a?!1:(this.values[l]=a,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,a){l=(0,n.toUint32)(l),a=(0,n.toUint32)(a);const c=this.values,_=this.prefixSum;if(l>=c.length)return!1;const g=c.length-l;return a>=g&&(a=g),a===0?!1:(this.values=new Uint32Array(c.length-a),this.values.set(c.subarray(0,l),0),this.values.set(c.subarray(l+a),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(_.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,n.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),l>=this.values.length&&(l=this.values.length-1);for(let c=a;c<=l;c++)this.prefixSum[c]=this.prefixSum[c-1]+this.values[c];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let a=0,c=this.values.length-1,_=0,g=0,b=0;for(;a<=c;)if(_=a+(c-a)/2|0,g=this.prefixSum[_],b=g-this.values[_],l<b)c=_-1;else if(l>=g)a=_+1;else break;return new p(_,l-b)}}i.PrefixSumComputer=M;class h{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const a=this._indexBySum[l],c=a>0?this._prefixSum[a-1]:0;return new p(a,l-c)}removeValues(l,a){this._values.splice(l,a),this._invalidate(l)}insertValues(l,a){this._values=(0,t.arrayInsert)(this._values,l,a),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,a=this._values.length;l<a;l++){const c=this._values[l],_=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=_+c;for(let g=0;g<c;g++)this._indexBySum[_+g]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,a){this._values[l]!==a&&(this._values[l]=a,this._invalidate(l))}}i.ConstantTimePrefixSumComputer=h;class p{constructor(l,a){this.index=l,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=a}}i.PrefixSumIndexOfResult=p}),ne(ie[66],re([0,1,8,3,65]),function(W,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MirrorTextModel=void 0;class h{constructor(m,l,a,c){this._uri=m,this._lines=l,this._eol=a,this._versionId=c,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(m){m.eol&&m.eol!==this._eol&&(this._eol=m.eol,this._lineStarts=null);const l=m.changes;for(const a of l)this._acceptDeleteRange(a.range),this._acceptInsertText(new n.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=m.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const m=this._eol.length,l=this._lines.length,a=new Uint32Array(l);for(let c=0;c<l;c++)a[c]=this._lines[c].length+m;this._lineStarts=new M.PrefixSumComputer(a)}}_setLineText(m,l){this._lines[m]=l,this._lineStarts&&this._lineStarts.setValue(m,this._lines[m].length+this._eol.length)}_acceptDeleteRange(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this._setLineText(m.startLineNumber-1,this._lines[m.startLineNumber-1].substring(0,m.startColumn-1)+this._lines[m.startLineNumber-1].substring(m.endColumn-1));return}this._setLineText(m.startLineNumber-1,this._lines[m.startLineNumber-1].substring(0,m.startColumn-1)+this._lines[m.endLineNumber-1].substring(m.endColumn-1)),this._lines.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}_acceptInsertText(m,l){if(l.length===0)return;const a=(0,t.splitLines)(l);if(a.length===1){this._setLineText(m.lineNumber-1,this._lines[m.lineNumber-1].substring(0,m.column-1)+a[0]+this._lines[m.lineNumber-1].substring(m.column-1));return}a[a.length-1]+=this._lines[m.lineNumber-1].substring(m.column-1),this._setLineText(m.lineNumber-1,this._lines[m.lineNumber-1].substring(0,m.column-1)+a[0]);const c=new Uint32Array(a.length-1);for(let _=1;_<a.length;_++)this._lines.splice(m.lineNumber+_-1,0,a[_]),c[_-1]=a[_].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(m.lineNumber,c)}}i.MirrorTextModel=h}),ne(ie[67],re([0,1,4,8,53,3,2,64]),function(W,i,t,n,M,h,p,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Searcher=i.TextModelSearch=i.SearchParams=void 0,i.isMultilineRegexSource=c,i.createFindMatch=_,i.isValidMatch=E,n=Be(n);const l=999;class a{constructor(v,A,d,o){this.searchString=v,this.isRegex=A,this.matchCase=d,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=c(this.searchString):v=this.searchString.indexOf(`
`)>=0;let A=null;try{A=n.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!A)return null;let d=!this.isRegex&&!v;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new m.SearchData(A,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators,[]):null,d?this.searchString:null)}}i.SearchParams=a;function c(w){if(!w||w.length===0)return!1;for(let v=0,A=w.length;v<A;v++){const d=w.charCodeAt(v);if(d===t.CharCode.LineFeed)return!0;if(d===t.CharCode.Backslash){if(v++,v>=A)break;const o=w.charCodeAt(v);if(o===t.CharCode.n||o===t.CharCode.r||o===t.CharCode.W)return!0}}return!1}function _(w,v,A){if(!A)return new m.FindMatch(w,null);const d=[];for(let o=0,r=v.length;o<r;o++)d[o]=v[o];return new m.FindMatch(w,d)}class g{constructor(v){const A=[];let d=0;for(let o=0,r=v.length;o<r;o++)v.charCodeAt(o)===t.CharCode.LineFeed&&(A[d++]=o);this._lineFeedsOffsets=A}findLineFeedCountBeforeOffset(v){const A=this._lineFeedsOffsets;let d=0,o=A.length-1;if(o===-1||v<=A[0])return 0;for(;d<o;){const r=d+((o-d)/2>>0);A[r]>=v?o=r-1:A[r+1]>=v?(d=r,o=r):d=r+1}return d+1}}class b{static findMatches(v,A,d,o,r){const u=A.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(v,d,new N(u.wordSeparators,u.regex),o,r):this._doFindMatchesLineByLine(v,d,u,o,r):[]}static _getMultilineMatchRange(v,A,d,o,r,u){let f,D=0;o?(D=o.findLineFeedCountBeforeOffset(r),f=A+r+D):f=A+r;let R;if(o){const O=o.findLineFeedCountBeforeOffset(r+u.length)-D;R=f+u.length+O}else R=f+u.length;const S=v.getPositionAt(f),I=v.getPositionAt(R);return new p.Range(S.lineNumber,S.column,I.lineNumber,I.column)}static _doFindMatchesMultiline(v,A,d,o,r){const u=v.getOffsetAt(A.getStartPosition()),f=v.getValueInRange(A,m.EndOfLinePreference.LF),D=v.getEOL()===`\r
`?new g(f):null,R=[];let S=0,I;for(d.reset(0);I=d.next(f);)if(R[S++]=_(this._getMultilineMatchRange(v,u,f,D,I.index,I[0]),I,o),S>=r)return R;return R}static _doFindMatchesLineByLine(v,A,d,o,r){const u=[];let f=0;if(A.startLineNumber===A.endLineNumber){const R=v.getLineContent(A.startLineNumber).substring(A.startColumn-1,A.endColumn-1);return f=this._findMatchesInLine(d,R,A.startLineNumber,A.startColumn-1,f,u,o,r),u}const D=v.getLineContent(A.startLineNumber).substring(A.startColumn-1);f=this._findMatchesInLine(d,D,A.startLineNumber,A.startColumn-1,f,u,o,r);for(let R=A.startLineNumber+1;R<A.endLineNumber&&f<r;R++)f=this._findMatchesInLine(d,v.getLineContent(R),R,0,f,u,o,r);if(f<r){const R=v.getLineContent(A.endLineNumber).substring(0,A.endColumn-1);f=this._findMatchesInLine(d,R,A.endLineNumber,0,f,u,o,r)}return u}static _findMatchesInLine(v,A,d,o,r,u,f,D){const R=v.wordSeparators;if(!f&&v.simpleSearch){const T=v.simpleSearch,O=T.length,P=A.length;let y=-O;for(;(y=A.indexOf(T,y+O))!==-1;)if((!R||E(R,A,P,y,O))&&(u[r++]=new m.FindMatch(new p.Range(d,y+1+o,d,y+1+O+o),null),r>=D))return r;return r}const S=new N(v.wordSeparators,v.regex);let I;S.reset(0);do if(I=S.next(A),I&&(u[r++]=_(new p.Range(d,I.index+1+o,d,I.index+1+I[0].length+o),I,f),r>=D))return r;while(I);return r}static findNextMatch(v,A,d,o){const r=A.parseSearchRequest();if(!r)return null;const u=new N(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(v,d,u,o):this._doFindNextMatchLineByLine(v,d,u,o)}static _doFindNextMatchMultiline(v,A,d,o){const r=new h.Position(A.lineNumber,1),u=v.getOffsetAt(r),f=v.getLineCount(),D=v.getValueInRange(new p.Range(r.lineNumber,r.column,f,v.getLineMaxColumn(f)),m.EndOfLinePreference.LF),R=v.getEOL()===`\r
`?new g(D):null;d.reset(A.column-1);const S=d.next(D);return S?_(this._getMultilineMatchRange(v,u,D,R,S.index,S[0]),S,o):A.lineNumber!==1||A.column!==1?this._doFindNextMatchMultiline(v,new h.Position(1,1),d,o):null}static _doFindNextMatchLineByLine(v,A,d,o){const r=v.getLineCount(),u=A.lineNumber,f=v.getLineContent(u),D=this._findFirstMatchInLine(d,f,u,A.column,o);if(D)return D;for(let R=1;R<=r;R++){const S=(u+R-1)%r,I=v.getLineContent(S+1),T=this._findFirstMatchInLine(d,I,S+1,1,o);if(T)return T}return null}static _findFirstMatchInLine(v,A,d,o,r){v.reset(o-1);const u=v.next(A);return u?_(new p.Range(d,u.index+1,d,u.index+1+u[0].length),u,r):null}static findPreviousMatch(v,A,d,o){const r=A.parseSearchRequest();if(!r)return null;const u=new N(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(v,d,u,o):this._doFindPreviousMatchLineByLine(v,d,u,o)}static _doFindPreviousMatchMultiline(v,A,d,o){const r=this._doFindMatchesMultiline(v,new p.Range(1,1,A.lineNumber,A.column),d,o,10*l);if(r.length>0)return r[r.length-1];const u=v.getLineCount();return A.lineNumber!==u||A.column!==v.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(v,new h.Position(u,v.getLineMaxColumn(u)),d,o):null}static _doFindPreviousMatchLineByLine(v,A,d,o){const r=v.getLineCount(),u=A.lineNumber,f=v.getLineContent(u).substring(0,A.column-1),D=this._findLastMatchInLine(d,f,u,o);if(D)return D;for(let R=1;R<=r;R++){const S=(r+u-R-1)%r,I=v.getLineContent(S+1),T=this._findLastMatchInLine(d,I,S+1,o);if(T)return T}return null}static _findLastMatchInLine(v,A,d,o){let r=null,u;for(v.reset(0);u=v.next(A);)r=_(new p.Range(d,u.index+1,d,u.index+1+u[0].length),u,o);return r}}i.TextModelSearch=b;function e(w,v,A,d,o){if(d===0)return!0;const r=v.charCodeAt(d-1);if(w.get(r)!==M.WordCharacterClass.Regular||r===t.CharCode.CarriageReturn||r===t.CharCode.LineFeed)return!0;if(o>0){const u=v.charCodeAt(d);if(w.get(u)!==M.WordCharacterClass.Regular)return!0}return!1}function L(w,v,A,d,o){if(d+o===A)return!0;const r=v.charCodeAt(d+o);if(w.get(r)!==M.WordCharacterClass.Regular||r===t.CharCode.CarriageReturn||r===t.CharCode.LineFeed)return!0;if(o>0){const u=v.charCodeAt(d+o-1);if(w.get(u)!==M.WordCharacterClass.Regular)return!0}return!1}function E(w,v,A,d,o){return e(w,v,A,d,o)&&L(w,v,A,d,o)}class N{constructor(v,A){this._wordSeparators=v,this._searchRegex=A,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const A=v.length;let d;do{if(this._prevMatchStartIndex+this._prevMatchLength===A||(d=this._searchRegex.exec(v),!d))return null;const o=d.index,r=d[0].length;if(o===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){n.getNextCodePoint(v,A,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=r,!this._wordSeparators||E(this._wordSeparators,v,A,o,r))return d}while(d);return null}}i.Searcher=N}),ne(ie[68],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.findSectionHeaders=M;const t=new RegExp("\\bMARK:\\s*(.*)$","d"),n=/^-+|-+$/g;function M(a,c){let _=[];if(c.findRegionSectionHeaders&&c.foldingRules?.markers){const g=h(a,c);_=_.concat(g)}if(c.findMarkSectionHeaders){const g=p(a);_=_.concat(g)}return _}function h(a,c){const _=[],g=a.getLineCount();for(let b=1;b<=g;b++){const e=a.getLineContent(b),L=e.match(c.foldingRules.markers.start);if(L){const E={startLineNumber:b,startColumn:L[0].length+1,endLineNumber:b,endColumn:e.length+1};if(E.endColumn>E.startColumn){const N={range:E,...l(e.substring(L[0].length)),shouldBeInComments:!1};(N.text||N.hasSeparatorLine)&&_.push(N)}}}return _}function p(a){const c=[],_=a.getLineCount();for(let g=1;g<=_;g++){const b=a.getLineContent(g);m(b,g,c)}return c}function m(a,c,_){t.lastIndex=0;const g=t.exec(a);if(g){const b=g.indices[1][0]+1,e=g.indices[1][1]+1,L={startLineNumber:c,startColumn:b,endLineNumber:c,endColumn:e};if(L.endColumn>L.startColumn){const E={range:L,...l(g[1]),shouldBeInComments:!0};(E.text||E.hasSeparatorLine)&&_.push(E)}}}function l(a){a=a.trim();const c=a.startsWith("-");return a=a.replace(n,""),{text:a,hasSeparatorLine:c}}}),ne(ie[69],re([0,1,2,67,8,11,32]),function(W,i,t,n,M,h,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeHighlighterReasonKind=i.UnicodeTextModelHighlighter=void 0,M=Be(M);class m{static computeUnicodeHighlights(e,L,E){const N=E?E.startLineNumber:1,w=E?E.endLineNumber:e.getLineCount(),v=new c(L),A=v.getCandidateCodePoints();let d;A==="allNonBasicAscii"?d=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):d=new RegExp(`${l(Array.from(A))}`,"g");const o=new n.Searcher(null,d),r=[];let u=!1,f,D=0,R=0,S=0;e:for(let I=N,T=w;I<=T;I++){const O=e.getLineContent(I),P=O.length;o.reset(0);do if(f=o.next(O),f){let y=f.index,x=f.index+f[0].length;if(y>0){const X=O.charCodeAt(y-1);M.isHighSurrogate(X)&&y--}if(x+1<P){const X=O.charCodeAt(x-1);M.isHighSurrogate(X)&&x++}const G=O.substring(y,x);let U=(0,p.getWordAtText)(y+1,p.DEFAULT_WORD_REGEXP,O,0);U&&U.endColumn<=y+1&&(U=null);const B=v.shouldHighlightNonBasicASCII(G,U?U.word:null);if(B!==g.None){if(B===g.Ambiguous?D++:B===g.Invisible?R++:B===g.NonBasicASCII?S++:(0,h.assertNever)(B),r.length>=1e3){u=!0;break e}r.push(new t.Range(I,y+1,I,x+1))}}while(f)}return{ranges:r,hasMore:u,ambiguousCharacterCount:D,invisibleCharacterCount:R,nonBasicAsciiCharacterCount:S}}static computeUnicodeHighlightReason(e,L){const E=new c(L);switch(E.shouldHighlightNonBasicASCII(e,null)){case g.None:return null;case g.Invisible:return{kind:a.Invisible};case g.Ambiguous:{const w=e.codePointAt(0),v=E.ambiguousCharacters.getPrimaryConfusable(w),A=M.AmbiguousCharacters.getLocales().filter(d=>!M.AmbiguousCharacters.getInstance(new Set([...L.allowedLocales,d])).isAmbiguous(w));return{kind:a.Ambiguous,confusableWith:String.fromCodePoint(v),notAmbiguousInLocales:A}}case g.NonBasicASCII:return{kind:a.NonBasicAscii}}}}i.UnicodeTextModelHighlighter=m;function l(b,e){return`[${M.escapeRegExpCharacters(b.map(E=>String.fromCodePoint(E)).join(""))}]`}var a;(function(b){b[b.Ambiguous=0]="Ambiguous",b[b.Invisible=1]="Invisible",b[b.NonBasicAscii=2]="NonBasicAscii"})(a||(i.UnicodeHighlighterReasonKind=a={}));class c{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=M.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const L of M.InvisibleCharacters.codePoints)_(String.fromCodePoint(L))||e.add(L);if(this.options.ambiguousCharacters)for(const L of this.ambiguousCharacters.getConfusableCodePoints())e.add(L);for(const L of this.allowedCodePoints)e.delete(L);return e}shouldHighlightNonBasicASCII(e,L){const E=e.codePointAt(0);if(this.allowedCodePoints.has(E))return g.None;if(this.options.nonBasicASCII)return g.NonBasicASCII;let N=!1,w=!1;if(L)for(const v of L){const A=v.codePointAt(0),d=M.isBasicASCII(v);N=N||d,!d&&!this.ambiguousCharacters.isAmbiguous(A)&&!M.InvisibleCharacters.isInvisibleCharacter(A)&&(w=!0)}return!N&&w?g.None:this.options.invisibleCharacters&&!_(e)&&M.InvisibleCharacters.isInvisibleCharacter(E)?g.Invisible:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(E)?g.Ambiguous:g.None}}function _(b){return b===" "||b===`
`||b==="	"}var g;(function(b){b[b.None=0]="None",b[b.NonBasicASCII=1]="NonBasicASCII",b[b.Invisible=2]="Invisible",b[b.Ambiguous=3]="Ambiguous"})(g||(g={}))}),ne(ie[70],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.ShowLightbulbIconMode=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.PartialAcceptTriggerKind=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.MouseTargetType=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineEditTriggerKind=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.HoverVerbosityAction=i.GlyphMarginLane=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var t;(function(s){s[s.Unknown=0]="Unknown",s[s.Disabled=1]="Disabled",s[s.Enabled=2]="Enabled"})(t||(i.AccessibilitySupport=t={}));var n;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(n||(i.CodeActionTriggerType=n={}));var M;(function(s){s[s.None=0]="None",s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(M||(i.CompletionItemInsertTextRule=M={}));var h;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(h||(i.CompletionItemKind=h={}));var p;(function(s){s[s.Deprecated=1]="Deprecated"})(p||(i.CompletionItemTag=p={}));var m;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(i.CompletionTriggerKind=m={}));var l;(function(s){s[s.EXACT=0]="EXACT",s[s.ABOVE=1]="ABOVE",s[s.BELOW=2]="BELOW"})(l||(i.ContentWidgetPositionPreference=l={}));var a;(function(s){s[s.NotSet=0]="NotSet",s[s.ContentFlush=1]="ContentFlush",s[s.RecoverFromMarkers=2]="RecoverFromMarkers",s[s.Explicit=3]="Explicit",s[s.Paste=4]="Paste",s[s.Undo=5]="Undo",s[s.Redo=6]="Redo"})(a||(i.CursorChangeReason=a={}));var c;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(c||(i.DefaultEndOfLine=c={}));var _;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(_||(i.DocumentHighlightKind=_={}));var g;(function(s){s[s.None=0]="None",s[s.Keep=1]="Keep",s[s.Brackets=2]="Brackets",s[s.Advanced=3]="Advanced",s[s.Full=4]="Full"})(g||(i.EditorAutoIndentStrategy=g={}));var b;(function(s){s[s.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",s[s.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",s[s.accessibilitySupport=2]="accessibilitySupport",s[s.accessibilityPageSize=3]="accessibilityPageSize",s[s.ariaLabel=4]="ariaLabel",s[s.ariaRequired=5]="ariaRequired",s[s.autoClosingBrackets=6]="autoClosingBrackets",s[s.autoClosingComments=7]="autoClosingComments",s[s.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",s[s.autoClosingDelete=9]="autoClosingDelete",s[s.autoClosingOvertype=10]="autoClosingOvertype",s[s.autoClosingQuotes=11]="autoClosingQuotes",s[s.autoIndent=12]="autoIndent",s[s.automaticLayout=13]="automaticLayout",s[s.autoSurround=14]="autoSurround",s[s.bracketPairColorization=15]="bracketPairColorization",s[s.guides=16]="guides",s[s.codeLens=17]="codeLens",s[s.codeLensFontFamily=18]="codeLensFontFamily",s[s.codeLensFontSize=19]="codeLensFontSize",s[s.colorDecorators=20]="colorDecorators",s[s.colorDecoratorsLimit=21]="colorDecoratorsLimit",s[s.columnSelection=22]="columnSelection",s[s.comments=23]="comments",s[s.contextmenu=24]="contextmenu",s[s.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",s[s.cursorBlinking=26]="cursorBlinking",s[s.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",s[s.cursorStyle=28]="cursorStyle",s[s.cursorSurroundingLines=29]="cursorSurroundingLines",s[s.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",s[s.cursorWidth=31]="cursorWidth",s[s.disableLayerHinting=32]="disableLayerHinting",s[s.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",s[s.domReadOnly=34]="domReadOnly",s[s.dragAndDrop=35]="dragAndDrop",s[s.dropIntoEditor=36]="dropIntoEditor",s[s.emptySelectionClipboard=37]="emptySelectionClipboard",s[s.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",s[s.extraEditorClassName=39]="extraEditorClassName",s[s.fastScrollSensitivity=40]="fastScrollSensitivity",s[s.find=41]="find",s[s.fixedOverflowWidgets=42]="fixedOverflowWidgets",s[s.folding=43]="folding",s[s.foldingStrategy=44]="foldingStrategy",s[s.foldingHighlight=45]="foldingHighlight",s[s.foldingImportsByDefault=46]="foldingImportsByDefault",s[s.foldingMaximumRegions=47]="foldingMaximumRegions",s[s.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",s[s.fontFamily=49]="fontFamily",s[s.fontInfo=50]="fontInfo",s[s.fontLigatures=51]="fontLigatures",s[s.fontSize=52]="fontSize",s[s.fontWeight=53]="fontWeight",s[s.fontVariations=54]="fontVariations",s[s.formatOnPaste=55]="formatOnPaste",s[s.formatOnType=56]="formatOnType",s[s.glyphMargin=57]="glyphMargin",s[s.gotoLocation=58]="gotoLocation",s[s.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",s[s.hover=60]="hover",s[s.inDiffEditor=61]="inDiffEditor",s[s.inlineSuggest=62]="inlineSuggest",s[s.inlineEdit=63]="inlineEdit",s[s.letterSpacing=64]="letterSpacing",s[s.lightbulb=65]="lightbulb",s[s.lineDecorationsWidth=66]="lineDecorationsWidth",s[s.lineHeight=67]="lineHeight",s[s.lineNumbers=68]="lineNumbers",s[s.lineNumbersMinChars=69]="lineNumbersMinChars",s[s.linkedEditing=70]="linkedEditing",s[s.links=71]="links",s[s.matchBrackets=72]="matchBrackets",s[s.minimap=73]="minimap",s[s.mouseStyle=74]="mouseStyle",s[s.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",s[s.mouseWheelZoom=76]="mouseWheelZoom",s[s.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",s[s.multiCursorModifier=78]="multiCursorModifier",s[s.multiCursorPaste=79]="multiCursorPaste",s[s.multiCursorLimit=80]="multiCursorLimit",s[s.occurrencesHighlight=81]="occurrencesHighlight",s[s.overviewRulerBorder=82]="overviewRulerBorder",s[s.overviewRulerLanes=83]="overviewRulerLanes",s[s.padding=84]="padding",s[s.pasteAs=85]="pasteAs",s[s.parameterHints=86]="parameterHints",s[s.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",s[s.placeholder=88]="placeholder",s[s.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",s[s.quickSuggestions=90]="quickSuggestions",s[s.quickSuggestionsDelay=91]="quickSuggestionsDelay",s[s.readOnly=92]="readOnly",s[s.readOnlyMessage=93]="readOnlyMessage",s[s.renameOnType=94]="renameOnType",s[s.renderControlCharacters=95]="renderControlCharacters",s[s.renderFinalNewline=96]="renderFinalNewline",s[s.renderLineHighlight=97]="renderLineHighlight",s[s.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",s[s.renderValidationDecorations=99]="renderValidationDecorations",s[s.renderWhitespace=100]="renderWhitespace",s[s.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",s[s.roundedSelection=102]="roundedSelection",s[s.rulers=103]="rulers",s[s.scrollbar=104]="scrollbar",s[s.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",s[s.scrollBeyondLastLine=106]="scrollBeyondLastLine",s[s.scrollPredominantAxis=107]="scrollPredominantAxis",s[s.selectionClipboard=108]="selectionClipboard",s[s.selectionHighlight=109]="selectionHighlight",s[s.selectOnLineNumbers=110]="selectOnLineNumbers",s[s.showFoldingControls=111]="showFoldingControls",s[s.showUnused=112]="showUnused",s[s.snippetSuggestions=113]="snippetSuggestions",s[s.smartSelect=114]="smartSelect",s[s.smoothScrolling=115]="smoothScrolling",s[s.stickyScroll=116]="stickyScroll",s[s.stickyTabStops=117]="stickyTabStops",s[s.stopRenderingLineAfter=118]="stopRenderingLineAfter",s[s.suggest=119]="suggest",s[s.suggestFontSize=120]="suggestFontSize",s[s.suggestLineHeight=121]="suggestLineHeight",s[s.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",s[s.suggestSelection=123]="suggestSelection",s[s.tabCompletion=124]="tabCompletion",s[s.tabIndex=125]="tabIndex",s[s.unicodeHighlighting=126]="unicodeHighlighting",s[s.unusualLineTerminators=127]="unusualLineTerminators",s[s.useShadowDOM=128]="useShadowDOM",s[s.useTabStops=129]="useTabStops",s[s.wordBreak=130]="wordBreak",s[s.wordSegmenterLocales=131]="wordSegmenterLocales",s[s.wordSeparators=132]="wordSeparators",s[s.wordWrap=133]="wordWrap",s[s.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",s[s.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",s[s.wordWrapColumn=136]="wordWrapColumn",s[s.wordWrapOverride1=137]="wordWrapOverride1",s[s.wordWrapOverride2=138]="wordWrapOverride2",s[s.wrappingIndent=139]="wrappingIndent",s[s.wrappingStrategy=140]="wrappingStrategy",s[s.showDeprecated=141]="showDeprecated",s[s.inlayHints=142]="inlayHints",s[s.editorClassName=143]="editorClassName",s[s.pixelRatio=144]="pixelRatio",s[s.tabFocusMode=145]="tabFocusMode",s[s.layoutInfo=146]="layoutInfo",s[s.wrappingInfo=147]="wrappingInfo",s[s.defaultColorDecorators=148]="defaultColorDecorators",s[s.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",s[s.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(b||(i.EditorOption=b={}));var e;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(e||(i.EndOfLinePreference=e={}));var L;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(L||(i.EndOfLineSequence=L={}));var E;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(E||(i.GlyphMarginLane=E={}));var N;(function(s){s[s.Increase=0]="Increase",s[s.Decrease=1]="Decrease"})(N||(i.HoverVerbosityAction=N={}));var w;(function(s){s[s.None=0]="None",s[s.Indent=1]="Indent",s[s.IndentOutdent=2]="IndentOutdent",s[s.Outdent=3]="Outdent"})(w||(i.IndentAction=w={}));var v;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(v||(i.InjectedTextCursorStops=v={}));var A;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(A||(i.InlayHintKind=A={}));var d;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(d||(i.InlineCompletionTriggerKind=d={}));var o;(function(s){s[s.Invoke=0]="Invoke",s[s.Automatic=1]="Automatic"})(o||(i.InlineEditTriggerKind=o={}));var r;(function(s){s[s.DependsOnKbLayout=-1]="DependsOnKbLayout",s[s.Unknown=0]="Unknown",s[s.Backspace=1]="Backspace",s[s.Tab=2]="Tab",s[s.Enter=3]="Enter",s[s.Shift=4]="Shift",s[s.Ctrl=5]="Ctrl",s[s.Alt=6]="Alt",s[s.PauseBreak=7]="PauseBreak",s[s.CapsLock=8]="CapsLock",s[s.Escape=9]="Escape",s[s.Space=10]="Space",s[s.PageUp=11]="PageUp",s[s.PageDown=12]="PageDown",s[s.End=13]="End",s[s.Home=14]="Home",s[s.LeftArrow=15]="LeftArrow",s[s.UpArrow=16]="UpArrow",s[s.RightArrow=17]="RightArrow",s[s.DownArrow=18]="DownArrow",s[s.Insert=19]="Insert",s[s.Delete=20]="Delete",s[s.Digit0=21]="Digit0",s[s.Digit1=22]="Digit1",s[s.Digit2=23]="Digit2",s[s.Digit3=24]="Digit3",s[s.Digit4=25]="Digit4",s[s.Digit5=26]="Digit5",s[s.Digit6=27]="Digit6",s[s.Digit7=28]="Digit7",s[s.Digit8=29]="Digit8",s[s.Digit9=30]="Digit9",s[s.KeyA=31]="KeyA",s[s.KeyB=32]="KeyB",s[s.KeyC=33]="KeyC",s[s.KeyD=34]="KeyD",s[s.KeyE=35]="KeyE",s[s.KeyF=36]="KeyF",s[s.KeyG=37]="KeyG",s[s.KeyH=38]="KeyH",s[s.KeyI=39]="KeyI",s[s.KeyJ=40]="KeyJ",s[s.KeyK=41]="KeyK",s[s.KeyL=42]="KeyL",s[s.KeyM=43]="KeyM",s[s.KeyN=44]="KeyN",s[s.KeyO=45]="KeyO",s[s.KeyP=46]="KeyP",s[s.KeyQ=47]="KeyQ",s[s.KeyR=48]="KeyR",s[s.KeyS=49]="KeyS",s[s.KeyT=50]="KeyT",s[s.KeyU=51]="KeyU",s[s.KeyV=52]="KeyV",s[s.KeyW=53]="KeyW",s[s.KeyX=54]="KeyX",s[s.KeyY=55]="KeyY",s[s.KeyZ=56]="KeyZ",s[s.Meta=57]="Meta",s[s.ContextMenu=58]="ContextMenu",s[s.F1=59]="F1",s[s.F2=60]="F2",s[s.F3=61]="F3",s[s.F4=62]="F4",s[s.F5=63]="F5",s[s.F6=64]="F6",s[s.F7=65]="F7",s[s.F8=66]="F8",s[s.F9=67]="F9",s[s.F10=68]="F10",s[s.F11=69]="F11",s[s.F12=70]="F12",s[s.F13=71]="F13",s[s.F14=72]="F14",s[s.F15=73]="F15",s[s.F16=74]="F16",s[s.F17=75]="F17",s[s.F18=76]="F18",s[s.F19=77]="F19",s[s.F20=78]="F20",s[s.F21=79]="F21",s[s.F22=80]="F22",s[s.F23=81]="F23",s[s.F24=82]="F24",s[s.NumLock=83]="NumLock",s[s.ScrollLock=84]="ScrollLock",s[s.Semicolon=85]="Semicolon",s[s.Equal=86]="Equal",s[s.Comma=87]="Comma",s[s.Minus=88]="Minus",s[s.Period=89]="Period",s[s.Slash=90]="Slash",s[s.Backquote=91]="Backquote",s[s.BracketLeft=92]="BracketLeft",s[s.Backslash=93]="Backslash",s[s.BracketRight=94]="BracketRight",s[s.Quote=95]="Quote",s[s.OEM_8=96]="OEM_8",s[s.IntlBackslash=97]="IntlBackslash",s[s.Numpad0=98]="Numpad0",s[s.Numpad1=99]="Numpad1",s[s.Numpad2=100]="Numpad2",s[s.Numpad3=101]="Numpad3",s[s.Numpad4=102]="Numpad4",s[s.Numpad5=103]="Numpad5",s[s.Numpad6=104]="Numpad6",s[s.Numpad7=105]="Numpad7",s[s.Numpad8=106]="Numpad8",s[s.Numpad9=107]="Numpad9",s[s.NumpadMultiply=108]="NumpadMultiply",s[s.NumpadAdd=109]="NumpadAdd",s[s.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",s[s.NumpadSubtract=111]="NumpadSubtract",s[s.NumpadDecimal=112]="NumpadDecimal",s[s.NumpadDivide=113]="NumpadDivide",s[s.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",s[s.ABNT_C1=115]="ABNT_C1",s[s.ABNT_C2=116]="ABNT_C2",s[s.AudioVolumeMute=117]="AudioVolumeMute",s[s.AudioVolumeUp=118]="AudioVolumeUp",s[s.AudioVolumeDown=119]="AudioVolumeDown",s[s.BrowserSearch=120]="BrowserSearch",s[s.BrowserHome=121]="BrowserHome",s[s.BrowserBack=122]="BrowserBack",s[s.BrowserForward=123]="BrowserForward",s[s.MediaTrackNext=124]="MediaTrackNext",s[s.MediaTrackPrevious=125]="MediaTrackPrevious",s[s.MediaStop=126]="MediaStop",s[s.MediaPlayPause=127]="MediaPlayPause",s[s.LaunchMediaPlayer=128]="LaunchMediaPlayer",s[s.LaunchMail=129]="LaunchMail",s[s.LaunchApp2=130]="LaunchApp2",s[s.Clear=131]="Clear",s[s.MAX_VALUE=132]="MAX_VALUE"})(r||(i.KeyCode=r={}));var u;(function(s){s[s.Hint=1]="Hint",s[s.Info=2]="Info",s[s.Warning=4]="Warning",s[s.Error=8]="Error"})(u||(i.MarkerSeverity=u={}));var f;(function(s){s[s.Unnecessary=1]="Unnecessary",s[s.Deprecated=2]="Deprecated"})(f||(i.MarkerTag=f={}));var D;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(D||(i.MinimapPosition=D={}));var R;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(R||(i.MinimapSectionHeaderStyle=R={}));var S;(function(s){s[s.UNKNOWN=0]="UNKNOWN",s[s.TEXTAREA=1]="TEXTAREA",s[s.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",s[s.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",s[s.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",s[s.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",s[s.CONTENT_TEXT=6]="CONTENT_TEXT",s[s.CONTENT_EMPTY=7]="CONTENT_EMPTY",s[s.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",s[s.CONTENT_WIDGET=9]="CONTENT_WIDGET",s[s.OVERVIEW_RULER=10]="OVERVIEW_RULER",s[s.SCROLLBAR=11]="SCROLLBAR",s[s.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",s[s.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(S||(i.MouseTargetType=S={}));var I;(function(s){s[s.AIGenerated=1]="AIGenerated"})(I||(i.NewSymbolNameTag=I={}));var T;(function(s){s[s.Invoke=0]="Invoke",s[s.Automatic=1]="Automatic"})(T||(i.NewSymbolNameTriggerKind=T={}));var O;(function(s){s[s.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",s[s.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",s[s.TOP_CENTER=2]="TOP_CENTER"})(O||(i.OverlayWidgetPositionPreference=O={}));var P;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(P||(i.OverviewRulerLane=P={}));var y;(function(s){s[s.Word=0]="Word",s[s.Line=1]="Line",s[s.Suggest=2]="Suggest"})(y||(i.PartialAcceptTriggerKind=y={}));var x;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(x||(i.PositionAffinity=x={}));var G;(function(s){s[s.Off=0]="Off",s[s.On=1]="On",s[s.Relative=2]="Relative",s[s.Interval=3]="Interval",s[s.Custom=4]="Custom"})(G||(i.RenderLineNumbersType=G={}));var U;(function(s){s[s.None=0]="None",s[s.Text=1]="Text",s[s.Blocks=2]="Blocks"})(U||(i.RenderMinimap=U={}));var B;(function(s){s[s.Smooth=0]="Smooth",s[s.Immediate=1]="Immediate"})(B||(i.ScrollType=B={}));var X;(function(s){s[s.Auto=1]="Auto",s[s.Hidden=2]="Hidden",s[s.Visible=3]="Visible"})(X||(i.ScrollbarVisibility=X={}));var Y;(function(s){s[s.LTR=0]="LTR",s[s.RTL=1]="RTL"})(Y||(i.SelectionDirection=Y={}));var $;(function(s){s.Off="off",s.OnCode="onCode",s.On="on"})($||(i.ShowLightbulbIconMode=$={}));var Z;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(Z||(i.SignatureHelpTriggerKind=Z={}));var ee;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(ee||(i.SymbolKind=ee={}));var F;(function(s){s[s.Deprecated=1]="Deprecated"})(F||(i.SymbolTag=F={}));var C;(function(s){s[s.Hidden=0]="Hidden",s[s.Blink=1]="Blink",s[s.Smooth=2]="Smooth",s[s.Phase=3]="Phase",s[s.Expand=4]="Expand",s[s.Solid=5]="Solid"})(C||(i.TextEditorCursorBlinkingStyle=C={}));var ce;(function(s){s[s.Line=1]="Line",s[s.Block=2]="Block",s[s.Underline=3]="Underline",s[s.LineThin=4]="LineThin",s[s.BlockOutline=5]="BlockOutline",s[s.UnderlineThin=6]="UnderlineThin"})(ce||(i.TextEditorCursorStyle=ce={}));var oe;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(oe||(i.TrackedRangeStickiness=oe={}));var Le;(function(s){s[s.None=0]="None",s[s.Same=1]="Same",s[s.Indent=2]="Indent",s[s.DeepIndent=3]="DeepIndent"})(Le||(i.WrappingIndent=Le={}))}),ne(ie[71],re([0,1,13,12,60]),function(W,i,t,n,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TokenizationRegistry=void 0;class h{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(l){this._onDidChange.fire({changedLanguages:l,changedColorMap:!1})}register(l,a){return this._tokenizationSupports.set(l,a),this.handleChange([l]),(0,n.toDisposable)(()=>{this._tokenizationSupports.get(l)===a&&(this._tokenizationSupports.delete(l),this.handleChange([l]))})}get(l){return this._tokenizationSupports.get(l)||null}registerFactory(l,a){this._factories.get(l)?.dispose();const c=new p(this,l,a);return this._factories.set(l,c),(0,n.toDisposable)(()=>{const _=this._factories.get(l);!_||_!==c||(this._factories.delete(l),_.dispose())})}async getOrCreate(l){const a=this.get(l);if(a)return a;const c=this._factories.get(l);return!c||c.isResolved?null:(await c.resolve(),this.get(l))}isResolved(l){if(this.get(l))return!0;const c=this._factories.get(l);return!!(!c||c.isResolved)}setColorMap(l){this._colorMap=l,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>M.ColorId.DefaultBackground?this._colorMap[M.ColorId.DefaultBackground]:null}}i.TokenizationRegistry=h;class p extends n.Disposable{get isResolved(){return this._isResolved}constructor(l,a,c){super(),this._registry=l,this._languageId=a,this._factory=c,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const l=await this._factory.tokenizationSupport;this._isResolved=!0,l&&!this._isDisposed&&this._register(this._registry.register(this._languageId,l))}}}),ne(ie[72],re([0,1]),function(W,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localize=M,i.localize2=p;const t=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function n(m,l){let a;return l.length===0?a=m:a=m.replace(/\{(\d+)\}/g,(c,_)=>{const g=_[0],b=l[g];let e=c;return typeof b=="string"?e=b:(typeof b=="number"||typeof b=="boolean"||b===void 0||b===null)&&(e=String(b)),e}),t&&(a="\uFF3B"+a.replace(/[aouei]/g,"$&$&")+"\uFF3D"),a}function M(m,l,...a){return n(typeof m=="number"?h(m,l):l,a)}function h(m,l){const a=globalThis._VSCODE_NLS_MESSAGES?.[m];if(typeof a!="string"){if(typeof l=="string")return l;throw new Error(`!!! NLS MISSING: ${m} !!!`)}return a}function p(m,l,...a){let c;typeof m=="number"?c=h(m,l):c=l;const _=n(c,a);return{value:_,original:l===c?_:n(l,a)}}}),ne(ie[73],re([0,1,47,19,49,2,71,72]),function(W,i,t,n,M,h,p,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InlineEditTriggerKind=i.ExternalUriOpenerPriority=i.TokenizationRegistry=i.LazyTokenizationSupport=i.InlayHintKind=i.CommentState=i.CommentMode=i.CommentThreadApplicability=i.CommentThreadState=i.CommentThreadCollapsibleState=i.Command=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.FoldingRangeKind=i.TextEdit=i.SymbolKinds=i.SymbolTag=i.symbolKindNames=i.SymbolKind=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.DocumentPasteTriggerKind=i.CodeActionTriggerType=i.SelectedSuggestionInfo=i.InlineCompletionTriggerKind=i.CompletionTriggerKind=i.PartialAcceptTriggerKind=i.CompletionItemInsertTextRule=i.CompletionItemTag=i.CompletionItemKinds=i.CompletionItemKind=i.HoverVerbosityAction=i.EncodedTokenizationResult=i.TokenizationResult=i.Token=void 0,i.isLocationLink=u,i.getAriaLabelForSymbol=D;class l{constructor(C,ce,oe){this.offset=C,this.type=ce,this.language=oe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}i.Token=l;class a{constructor(C,ce){this.tokens=C,this.endState=ce,this._tokenizationResultBrand=void 0}}i.TokenizationResult=a;class c{constructor(C,ce){this.tokens=C,this.endState=ce,this._encodedTokenizationResultBrand=void 0}}i.EncodedTokenizationResult=c;var _;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})(_||(i.HoverVerbosityAction=_={}));var g;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(g||(i.CompletionItemKind=g={}));var b;(function(F){const C=new Map;C.set(g.Method,t.Codicon.symbolMethod),C.set(g.Function,t.Codicon.symbolFunction),C.set(g.Constructor,t.Codicon.symbolConstructor),C.set(g.Field,t.Codicon.symbolField),C.set(g.Variable,t.Codicon.symbolVariable),C.set(g.Class,t.Codicon.symbolClass),C.set(g.Struct,t.Codicon.symbolStruct),C.set(g.Interface,t.Codicon.symbolInterface),C.set(g.Module,t.Codicon.symbolModule),C.set(g.Property,t.Codicon.symbolProperty),C.set(g.Event,t.Codicon.symbolEvent),C.set(g.Operator,t.Codicon.symbolOperator),C.set(g.Unit,t.Codicon.symbolUnit),C.set(g.Value,t.Codicon.symbolValue),C.set(g.Enum,t.Codicon.symbolEnum),C.set(g.Constant,t.Codicon.symbolConstant),C.set(g.Enum,t.Codicon.symbolEnum),C.set(g.EnumMember,t.Codicon.symbolEnumMember),C.set(g.Keyword,t.Codicon.symbolKeyword),C.set(g.Snippet,t.Codicon.symbolSnippet),C.set(g.Text,t.Codicon.symbolText),C.set(g.Color,t.Codicon.symbolColor),C.set(g.File,t.Codicon.symbolFile),C.set(g.Reference,t.Codicon.symbolReference),C.set(g.Customcolor,t.Codicon.symbolCustomColor),C.set(g.Folder,t.Codicon.symbolFolder),C.set(g.TypeParameter,t.Codicon.symbolTypeParameter),C.set(g.User,t.Codicon.account),C.set(g.Issue,t.Codicon.issues);function ce(s){let Se=C.get(s);return Se||(console.info("No codicon found for CompletionItemKind "+s),Se=t.Codicon.symbolProperty),Se}F.toIcon=ce;const oe=new Map;oe.set("method",g.Method),oe.set("function",g.Function),oe.set("constructor",g.Constructor),oe.set("field",g.Field),oe.set("variable",g.Variable),oe.set("class",g.Class),oe.set("struct",g.Struct),oe.set("interface",g.Interface),oe.set("module",g.Module),oe.set("property",g.Property),oe.set("event",g.Event),oe.set("operator",g.Operator),oe.set("unit",g.Unit),oe.set("value",g.Value),oe.set("constant",g.Constant),oe.set("enum",g.Enum),oe.set("enum-member",g.EnumMember),oe.set("enumMember",g.EnumMember),oe.set("keyword",g.Keyword),oe.set("snippet",g.Snippet),oe.set("text",g.Text),oe.set("color",g.Color),oe.set("file",g.File),oe.set("reference",g.Reference),oe.set("customcolor",g.Customcolor),oe.set("folder",g.Folder),oe.set("type-parameter",g.TypeParameter),oe.set("typeParameter",g.TypeParameter),oe.set("account",g.User),oe.set("issue",g.Issue);function Le(s,Se){let Pe=oe.get(s);return typeof Pe>"u"&&!Se&&(Pe=g.Property),Pe}F.fromString=Le})(b||(i.CompletionItemKinds=b={}));var e;(function(F){F[F.Deprecated=1]="Deprecated"})(e||(i.CompletionItemTag=e={}));var L;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(L||(i.CompletionItemInsertTextRule=L={}));var E;(function(F){F[F.Word=0]="Word",F[F.Line=1]="Line",F[F.Suggest=2]="Suggest"})(E||(i.PartialAcceptTriggerKind=E={}));var N;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(N||(i.CompletionTriggerKind=N={}));var w;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(w||(i.InlineCompletionTriggerKind=w={}));class v{constructor(C,ce,oe,Le){this.range=C,this.text=ce,this.completionKind=oe,this.isSnippetText=Le}equals(C){return h.Range.lift(this.range).equalsRange(C.range)&&this.text===C.text&&this.completionKind===C.completionKind&&this.isSnippetText===C.isSnippetText}}i.SelectedSuggestionInfo=v;var A;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(A||(i.CodeActionTriggerType=A={}));var d;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(d||(i.DocumentPasteTriggerKind=d={}));var o;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(o||(i.SignatureHelpTriggerKind=o={}));var r;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(r||(i.DocumentHighlightKind=r={}));function u(F){return F&&n.URI.isUri(F.uri)&&h.Range.isIRange(F.range)&&(h.Range.isIRange(F.originSelectionRange)||h.Range.isIRange(F.targetSelectionRange))}var f;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(f||(i.SymbolKind=f={})),i.symbolKindNames={[f.Array]:(0,m.localize)(12849,null),[f.Boolean]:(0,m.localize)(12850,null),[f.Class]:(0,m.localize)(12851,null),[f.Constant]:(0,m.localize)(12852,null),[f.Constructor]:(0,m.localize)(12853,null),[f.Enum]:(0,m.localize)(12854,null),[f.EnumMember]:(0,m.localize)(12855,null),[f.Event]:(0,m.localize)(12856,null),[f.Field]:(0,m.localize)(12857,null),[f.File]:(0,m.localize)(12858,null),[f.Function]:(0,m.localize)(12859,null),[f.Interface]:(0,m.localize)(12860,null),[f.Key]:(0,m.localize)(12861,null),[f.Method]:(0,m.localize)(12862,null),[f.Module]:(0,m.localize)(12863,null),[f.Namespace]:(0,m.localize)(12864,null),[f.Null]:(0,m.localize)(12865,null),[f.Number]:(0,m.localize)(12866,null),[f.Object]:(0,m.localize)(12867,null),[f.Operator]:(0,m.localize)(12868,null),[f.Package]:(0,m.localize)(12869,null),[f.Property]:(0,m.localize)(12870,null),[f.String]:(0,m.localize)(12871,null),[f.Struct]:(0,m.localize)(12872,null),[f.TypeParameter]:(0,m.localize)(12873,null),[f.Variable]:(0,m.localize)(12874,null)};function D(F,C){return(0,m.localize)(12875,null,F,i.symbolKindNames[C])}var R;(function(F){F[F.Deprecated=1]="Deprecated"})(R||(i.SymbolTag=R={}));var S;(function(F){const C=new Map;C.set(f.File,t.Codicon.symbolFile),C.set(f.Module,t.Codicon.symbolModule),C.set(f.Namespace,t.Codicon.symbolNamespace),C.set(f.Package,t.Codicon.symbolPackage),C.set(f.Class,t.Codicon.symbolClass),C.set(f.Method,t.Codicon.symbolMethod),C.set(f.Property,t.Codicon.symbolProperty),C.set(f.Field,t.Codicon.symbolField),C.set(f.Constructor,t.Codicon.symbolConstructor),C.set(f.Enum,t.Codicon.symbolEnum),C.set(f.Interface,t.Codicon.symbolInterface),C.set(f.Function,t.Codicon.symbolFunction),C.set(f.Variable,t.Codicon.symbolVariable),C.set(f.Constant,t.Codicon.symbolConstant),C.set(f.String,t.Codicon.symbolString),C.set(f.Number,t.Codicon.symbolNumber),C.set(f.Boolean,t.Codicon.symbolBoolean),C.set(f.Array,t.Codicon.symbolArray),C.set(f.Object,t.Codicon.symbolObject),C.set(f.Key,t.Codicon.symbolKey),C.set(f.Null,t.Codicon.symbolNull),C.set(f.EnumMember,t.Codicon.symbolEnumMember),C.set(f.Struct,t.Codicon.symbolStruct),C.set(f.Event,t.Codicon.symbolEvent),C.set(f.Operator,t.Codicon.symbolOperator),C.set(f.TypeParameter,t.Codicon.symbolTypeParameter);function ce(oe){let Le=C.get(oe);return Le||(console.info("No codicon found for SymbolKind "+oe),Le=t.Codicon.symbolProperty),Le}F.toIcon=ce})(S||(i.SymbolKinds=S={}));class I{static asEditOperation(C){return M.EditOperation.replace(h.Range.lift(C.range),C.text)}}i.TextEdit=I;class T{static{this.Comment=new T("comment")}static{this.Imports=new T("imports")}static{this.Region=new T("region")}static fromValue(C){switch(C){case"comment":return T.Comment;case"imports":return T.Imports;case"region":return T.Region}return new T(C)}constructor(C){this.value=C}}i.FoldingRangeKind=T;var O;(function(F){F[F.AIGenerated=1]="AIGenerated"})(O||(i.NewSymbolNameTag=O={}));var P;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(P||(i.NewSymbolNameTriggerKind=P={}));var y;(function(F){function C(ce){return!ce||typeof ce!="object"?!1:typeof ce.id=="string"&&typeof ce.title=="string"}F.is=C})(y||(i.Command=y={}));var x;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(x||(i.CommentThreadCollapsibleState=x={}));var G;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(G||(i.CommentThreadState=G={}));var U;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(U||(i.CommentThreadApplicability=U={}));var B;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(B||(i.CommentMode=B={}));var X;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(X||(i.CommentState=X={}));var Y;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(Y||(i.InlayHintKind=Y={}));class ${constructor(C){this.createSupport=C,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(C=>{C&&C.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}i.LazyTokenizationSupport=$,i.TokenizationRegistry=new p.TokenizationRegistry;var Z;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(Z||(i.ExternalUriOpenerPriority=Z={}));var ee;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(ee||(i.InlineEditTriggerKind=ee={}))}),ne(ie[74],re([0,1,26,13,40,19,3,2,50,73,70]),function(W,i,t,n,M,h,p,m,l,a,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=void 0,i.createMonacoBaseAPI=g,c=Be(c);class _{static{this.CtrlCmd=M.KeyMod.CtrlCmd}static{this.Shift=M.KeyMod.Shift}static{this.Alt=M.KeyMod.Alt}static{this.WinCtrl=M.KeyMod.WinCtrl}static chord(e,L){return(0,M.KeyChord)(e,L)}}i.KeyMod=_;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.CancellationTokenSource,Emitter:n.Emitter,KeyCode:c.KeyCode,KeyMod:_,Position:p.Position,Range:m.Range,Selection:l.Selection,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:h.URI,Token:a.Token}}}),ne(ie[77],re([0,1,29,19,3,2,66,32,62,63,74,25,69,36,59,18,5,61,68]),function(W,i,t,n,M,h,p,m,l,a,c,_,g,b,e,L,E,N,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditorSimpleWorker=void 0,i.create=d;class v extends p.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(r){const u=[];for(let f=0;f<this._lines.length;f++){const D=this._lines[f],R=this.offsetAt(new M.Position(f+1,1)),S=D.matchAll(r);for(const I of S)(I.index||I.index===0)&&(I.index=I.index+R),u.push(I)}return u}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(r){return this._lines[r-1]}getWordAtPosition(r,u){const f=(0,m.getWordAtText)(r.column,(0,m.ensureValidWordDefinition)(u),this._lines[r.lineNumber-1],0);return f?new h.Range(r.lineNumber,f.startColumn,r.lineNumber,f.endColumn):null}getWordUntilPosition(r,u){const f=this.getWordAtPosition(r,u);return f?{word:this._lines[r.lineNumber-1].substring(f.startColumn-1,r.column-1),startColumn:f.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const u=this._lines,f=this._wordenize.bind(this);let D=0,R="",S=0,I=[];return{*[Symbol.iterator](){for(;;)if(S<I.length){const T=R.substring(I[S].start,I[S].end);S+=1,yield T}else if(D<u.length)R=u[D],I=f(R,r),S=0,D+=1;else break}}}getLineWords(r,u){const f=this._lines[r-1],D=this._wordenize(f,u),R=[];for(const S of D)R.push({word:f.substring(S.start,S.end),startColumn:S.start+1,endColumn:S.end+1});return R}_wordenize(r,u){const f=[];let D;for(u.lastIndex=0;(D=u.exec(r))&&D[0].length!==0;)f.push({start:D.index,end:D.index+D[0].length});return f}getValueInRange(r){if(r=this._validateRange(r),r.startLineNumber===r.endLineNumber)return this._lines[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const u=this._eol,f=r.startLineNumber-1,D=r.endLineNumber-1,R=[];R.push(this._lines[f].substring(r.startColumn-1));for(let S=f+1;S<D;S++)R.push(this._lines[S]);return R.push(this._lines[D].substring(0,r.endColumn-1)),R.join(u)}offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(r),f=this._lines[u.index].length;return{lineNumber:1+u.index,column:1+Math.min(u.remainder,f)}}_validateRange(r){const u=this._validatePosition({lineNumber:r.startLineNumber,column:r.startColumn}),f=this._validatePosition({lineNumber:r.endLineNumber,column:r.endColumn});return u.lineNumber!==r.startLineNumber||u.column!==r.startColumn||f.lineNumber!==r.endLineNumber||f.column!==r.endColumn?{startLineNumber:u.lineNumber,startColumn:u.column,endLineNumber:f.lineNumber,endColumn:f.column}:r}_validatePosition(r){if(!M.Position.isIPosition(r))throw new Error("bad position");let{lineNumber:u,column:f}=r,D=!1;if(u<1)u=1,f=1,D=!0;else if(u>this._lines.length)u=this._lines.length,f=this._lines[u-1].length+1,D=!0;else{const R=this._lines[u-1].length+1;f<1?(f=1,D=!0):f>R&&(f=R,D=!0)}return D?{lineNumber:u,column:f}:r}}class A{constructor(r,u){this._host=r,this._models=Object.create(null),this._foreignModuleFactory=u,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(r){return this._models[r]}_getModels(){const r=[];return Object.keys(this._models).forEach(u=>r.push(this._models[u])),r}acceptNewModel(r){this._models[r.url]=new v(n.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,u){if(!this._models[r])return;this._models[r].onEvents(u)}acceptRemovedModel(r){this._models[r]&&delete this._models[r]}async computeUnicodeHighlights(r,u,f){const D=this._getModel(r);return D?g.UnicodeTextModelHighlighter.computeUnicodeHighlights(D,u,f):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(r,u){const f=this._getModel(r);return f?(0,w.findSectionHeaders)(f,u):[]}async computeDiff(r,u,f,D){const R=this._getModel(r),S=this._getModel(u);return!R||!S?null:A.computeDiff(R,S,f,D)}static computeDiff(r,u,f,D){const R=D==="advanced"?e.linesDiffComputers.getDefault():e.linesDiffComputers.getLegacy(),S=r.getLinesContent(),I=u.getLinesContent(),T=R.computeDiff(S,I,f),O=T.changes.length>0?!1:this._modelsAreIdentical(r,u);function P(y){return y.map(x=>[x.original.startLineNumber,x.original.endLineNumberExclusive,x.modified.startLineNumber,x.modified.endLineNumberExclusive,x.innerChanges?.map(G=>[G.originalRange.startLineNumber,G.originalRange.startColumn,G.originalRange.endLineNumber,G.originalRange.endColumn,G.modifiedRange.startLineNumber,G.modifiedRange.startColumn,G.modifiedRange.endLineNumber,G.modifiedRange.endColumn])])}return{identical:O,quitEarly:T.hitTimeout,changes:P(T.changes),moves:T.moves.map(y=>[y.lineRangeMapping.original.startLineNumber,y.lineRangeMapping.original.endLineNumberExclusive,y.lineRangeMapping.modified.startLineNumber,y.lineRangeMapping.modified.endLineNumberExclusive,P(y.changes)])}}static _modelsAreIdentical(r,u){const f=r.getLineCount(),D=u.getLineCount();if(f!==D)return!1;for(let R=1;R<=f;R++){const S=r.getLineContent(R),I=u.getLineContent(R);if(S!==I)return!1}return!0}async computeDirtyDiff(r,u,f){const D=this._getModel(r),R=this._getModel(u);if(!D||!R)return null;const S=D.getLinesContent(),I=R.getLinesContent();return new b.DiffComputer(S,I,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:f,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this._diffLimit=1e5}async computeMoreMinimalEdits(r,u,f){const D=this._getModel(r);if(!D)return u;const R=[];let S;u=u.slice(0).sort((T,O)=>{if(T.range&&O.range)return h.Range.compareRangesUsingStarts(T.range,O.range);const P=T.range?0:1,y=O.range?0:1;return P-y});let I=0;for(let T=1;T<u.length;T++)h.Range.getEndPosition(u[I].range).equals(h.Range.getStartPosition(u[T].range))?(u[I].range=h.Range.fromPositions(h.Range.getStartPosition(u[I].range),h.Range.getEndPosition(u[T].range)),u[I].text+=u[T].text):(I++,u[I]=u[T]);u.length=I+1;for(let{range:T,text:O,eol:P}of u){if(typeof P=="number"&&(S=P),h.Range.isEmpty(T)&&!O)continue;const y=D.getValueInRange(T);if(O=O.replace(/\r\n|\n|\r/g,D.eol),y===O)continue;if(Math.max(O.length,y.length)>A._diffLimit){R.push({range:T,text:O});continue}const x=(0,t.stringDiff)(y,O,f),G=D.offsetAt(h.Range.lift(T).getStartPosition());for(const U of x){const B=D.positionAt(G+U.originalStart),X=D.positionAt(G+U.originalStart+U.originalLength),Y={text:O.substr(U.modifiedStart,U.modifiedLength),range:{startLineNumber:B.lineNumber,startColumn:B.column,endLineNumber:X.lineNumber,endColumn:X.column}};D.getValueInRange(Y.range)!==Y.text&&R.push(Y)}}return typeof S=="number"&&R.push({eol:S,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),R}computeHumanReadableDiff(r,u,f){const D=this._getModel(r);if(!D)return u;const R=[];let S;u=u.slice(0).sort((I,T)=>{if(I.range&&T.range)return h.Range.compareRangesUsingStarts(I.range,T.range);const O=I.range?0:1,P=T.range?0:1;return O-P});for(let{range:I,text:T,eol:O}of u){let B=function(Y,$){return new M.Position(Y.lineNumber+$.lineNumber-1,$.lineNumber===1?Y.column+$.column-1:$.column)},X=function(Y,$){const Z=[];for(let ee=$.startLineNumber;ee<=$.endLineNumber;ee++){const F=Y[ee-1];ee===$.startLineNumber&&ee===$.endLineNumber?Z.push(F.substring($.startColumn-1,$.endColumn-1)):ee===$.startLineNumber?Z.push(F.substring($.startColumn-1)):ee===$.endLineNumber?Z.push(F.substring(0,$.endColumn-1)):Z.push(F)}return Z};if(typeof O=="number"&&(S=O),h.Range.isEmpty(I)&&!T)continue;const P=D.getValueInRange(I);if(T=T.replace(/\r\n|\n|\r/g,D.eol),P===T)continue;if(Math.max(T.length,P.length)>A._diffLimit){R.push({range:I,text:T});continue}const y=P.split(/\r\n|\n|\r/),x=T.split(/\r\n|\n|\r/),G=e.linesDiffComputers.getDefault().computeDiff(y,x,f),U=h.Range.lift(I).getStartPosition();for(const Y of G.changes)if(Y.innerChanges)for(const $ of Y.innerChanges)R.push({range:h.Range.fromPositions(B(U,$.originalRange.getStartPosition()),B(U,$.originalRange.getEndPosition())),text:X(x,$.modifiedRange).join(D.eol)});else throw new E.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof S=="number"&&R.push({eol:S,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),R}async computeLinks(r){const u=this._getModel(r);return u?(0,l.computeLinks)(u):null}async computeDefaultDocumentColors(r){const u=this._getModel(r);return u?(0,N.computeDefaultDocumentColors)(u):null}static{this._suggestionsLimit=1e4}async textualSuggest(r,u,f,D){const R=new _.StopWatch,S=new RegExp(f,D),I=new Set;e:for(const T of r){const O=this._getModel(T);if(O){for(const P of O.words(S))if(!(P===u||!isNaN(Number(P)))&&(I.add(P),I.size>A._suggestionsLimit))break e}}return{words:Array.from(I),duration:R.elapsed()}}async computeWordRanges(r,u,f,D){const R=this._getModel(r);if(!R)return Object.create(null);const S=new RegExp(f,D),I=Object.create(null);for(let T=u.startLineNumber;T<u.endLineNumber;T++){const O=R.getLineWords(T,S);for(const P of O){if(!isNaN(Number(P.word)))continue;let y=I[P.word];y||(y=[],I[P.word]=y),y.push({startLineNumber:T,startColumn:P.startColumn,endLineNumber:T,endColumn:P.endColumn})}}return I}async navigateValueSet(r,u,f,D,R){const S=this._getModel(r);if(!S)return null;const I=new RegExp(D,R);u.startColumn===u.endColumn&&(u={startLineNumber:u.startLineNumber,startColumn:u.startColumn,endLineNumber:u.endLineNumber,endColumn:u.endColumn+1});const T=S.getValueInRange(u),O=S.getWordAtPosition({lineNumber:u.startLineNumber,column:u.startColumn},I);if(!O)return null;const P=S.getValueInRange(O);return a.BasicInplaceReplace.INSTANCE.navigateValueSet(u,T,O,P,f)}loadForeignModule(r,u,f){const D=(I,T)=>this._host.fhr(I,T),S={host:(0,L.createProxyObject)(f,D),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(S,u),Promise.resolve((0,L.getAllMethodNames)(this._foreignModule))):new Promise((I,T)=>{W([r],O=>{this._foreignModule=O.create(S,u),I((0,L.getAllMethodNames)(this._foreignModule))},T)})}fmr(r,u){if(!this._foreignModule||typeof this._foreignModule[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this._foreignModule[r].apply(this._foreignModule,u))}catch(f){return Promise.reject(f)}}}i.EditorSimpleWorker=A;function d(o){return new A(o,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,c.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/base/worker/workerMain.js.map
