/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/process","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","child_process","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/processes","vs/base/common/codicons","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],le=function(V){for(var e=[],n=0,s=V.length;n<s;n++)e[n]=ce[V[n]];return e};define(ce[138],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=n,e.findLastIdx=s,e.findLastMonotonous=b,e.findLastIdxMonotonous=M,e.findFirstMonotonous=L,e.findFirstIdxMonotonousOrArrLen=R,e.findFirstIdxMonotonous=w,e.findFirstMax=m,e.findLastMax=u,e.findFirstMin=f,e.findMaxIdx=v,e.mapFindFirst=h;function n(g,E){const S=s(g,E);if(S!==-1)return g[S]}function s(g,E,S=g.length-1){for(let p=S;p>=0;p--){const D=g[p];if(E(D))return p}return-1}function b(g,E){const S=M(g,E);return S===-1?void 0:g[S]}function M(g,E,S=0,p=g.length){let D=S,I=p;for(;D<I;){const i=Math.floor((D+I)/2);E(g[i])?D=i+1:I=i}return D-1}function L(g,E){const S=R(g,E);return S===g.length?void 0:g[S]}function R(g,E,S=0,p=g.length){let D=S,I=p;for(;D<I;){const i=Math.floor((D+I)/2);E(g[i])?I=i:D=i+1}return D}function w(g,E,S=0,p=g.length){const D=R(g,E,S,p);return D===g.length?-1:D}class c{static{this.assertInvariants=!1}constructor(E){this._array=E,this._findLastMonotonousLastIdx=0}findLastMonotonous(E){if(c.assertInvariants){if(this._prevFindLastPredicate){for(const p of this._array)if(this._prevFindLastPredicate(p)&&!E(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=E}const S=M(this._array,E,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=S+1,S===-1?void 0:this._array[S]}}e.MonotonousArray=c;function m(g,E){if(g.length===0)return;let S=g[0];for(let p=1;p<g.length;p++){const D=g[p];E(D,S)>0&&(S=D)}return S}function u(g,E){if(g.length===0)return;let S=g[0];for(let p=1;p<g.length;p++){const D=g[p];E(D,S)>=0&&(S=D)}return S}function f(g,E){return m(g,(S,p)=>-E(S,p))}function v(g,E){if(g.length===0)return-1;let S=0;for(let p=1;p<g.length;p++){const D=g[p];E(D,g[S])>0&&(S=p)}return S}function h(g,E){for(const S of g){const p=E(S);if(p!==void 0)return p}}}),define(ce[39],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(s){s[s.Null=0]="Null",s[s.Backspace=8]="Backspace",s[s.Tab=9]="Tab",s[s.LineFeed=10]="LineFeed",s[s.CarriageReturn=13]="CarriageReturn",s[s.Space=32]="Space",s[s.ExclamationMark=33]="ExclamationMark",s[s.DoubleQuote=34]="DoubleQuote",s[s.Hash=35]="Hash",s[s.DollarSign=36]="DollarSign",s[s.PercentSign=37]="PercentSign",s[s.Ampersand=38]="Ampersand",s[s.SingleQuote=39]="SingleQuote",s[s.OpenParen=40]="OpenParen",s[s.CloseParen=41]="CloseParen",s[s.Asterisk=42]="Asterisk",s[s.Plus=43]="Plus",s[s.Comma=44]="Comma",s[s.Dash=45]="Dash",s[s.Period=46]="Period",s[s.Slash=47]="Slash",s[s.Digit0=48]="Digit0",s[s.Digit1=49]="Digit1",s[s.Digit2=50]="Digit2",s[s.Digit3=51]="Digit3",s[s.Digit4=52]="Digit4",s[s.Digit5=53]="Digit5",s[s.Digit6=54]="Digit6",s[s.Digit7=55]="Digit7",s[s.Digit8=56]="Digit8",s[s.Digit9=57]="Digit9",s[s.Colon=58]="Colon",s[s.Semicolon=59]="Semicolon",s[s.LessThan=60]="LessThan",s[s.Equals=61]="Equals",s[s.GreaterThan=62]="GreaterThan",s[s.QuestionMark=63]="QuestionMark",s[s.AtSign=64]="AtSign",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.OpenSquareBracket=91]="OpenSquareBracket",s[s.Backslash=92]="Backslash",s[s.CloseSquareBracket=93]="CloseSquareBracket",s[s.Caret=94]="Caret",s[s.Underline=95]="Underline",s[s.BackTick=96]="BackTick",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.OpenCurlyBrace=123]="OpenCurlyBrace",s[s.Pipe=124]="Pipe",s[s.CloseCurlyBrace=125]="CloseCurlyBrace",s[s.Tilde=126]="Tilde",s[s.NoBreakSpace=160]="NoBreakSpace",s[s.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",s[s.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",s[s.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",s[s.U_Combining_Tilde=771]="U_Combining_Tilde",s[s.U_Combining_Macron=772]="U_Combining_Macron",s[s.U_Combining_Overline=773]="U_Combining_Overline",s[s.U_Combining_Breve=774]="U_Combining_Breve",s[s.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",s[s.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",s[s.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",s[s.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",s[s.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",s[s.U_Combining_Caron=780]="U_Combining_Caron",s[s.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",s[s.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",s[s.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",s[s.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",s[s.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",s[s.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",s[s.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",s[s.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",s[s.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",s[s.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",s[s.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",s[s.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",s[s.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",s[s.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",s[s.U_Combining_Horn=795]="U_Combining_Horn",s[s.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",s[s.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",s[s.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",s[s.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",s[s.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",s[s.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",s[s.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",s[s.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",s[s.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",s[s.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",s[s.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",s[s.U_Combining_Cedilla=807]="U_Combining_Cedilla",s[s.U_Combining_Ogonek=808]="U_Combining_Ogonek",s[s.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",s[s.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",s[s.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",s[s.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",s[s.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",s[s.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",s[s.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",s[s.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",s[s.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",s[s.U_Combining_Low_Line=818]="U_Combining_Low_Line",s[s.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",s[s.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",s[s.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",s[s.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",s[s.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",s[s.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",s[s.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",s[s.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",s[s.U_Combining_Square_Below=827]="U_Combining_Square_Below",s[s.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",s[s.U_Combining_X_Above=829]="U_Combining_X_Above",s[s.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",s[s.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",s[s.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",s[s.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",s[s.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",s[s.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",s[s.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",s[s.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",s[s.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",s[s.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",s[s.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",s[s.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",s[s.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",s[s.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",s[s.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",s[s.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",s[s.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",s[s.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",s[s.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",s[s.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",s[s.U_Combining_Fermata=850]="U_Combining_Fermata",s[s.U_Combining_X_Below=851]="U_Combining_X_Below",s[s.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",s[s.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",s[s.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",s[s.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",s[s.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",s[s.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",s[s.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",s[s.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",s[s.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",s[s.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",s[s.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",s[s.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",s[s.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",s[s.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",s[s.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",s[s.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",s[s.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",s[s.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",s[s.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",s[s.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",s[s.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",s[s.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",s[s.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",s[s.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",s[s.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",s[s.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",s[s.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",s[s.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",s[s.LINE_SEPARATOR=8232]="LINE_SEPARATOR",s[s.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",s[s.NEXT_LINE=133]="NEXT_LINE",s[s.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",s[s.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",s[s.U_DIAERESIS=168]="U_DIAERESIS",s[s.U_MACRON=175]="U_MACRON",s[s.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",s[s.U_CEDILLA=184]="U_CEDILLA",s[s.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",s[s.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",s[s.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",s[s.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",s[s.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",s[s.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",s[s.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",s[s.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",s[s.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",s[s.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",s[s.U_BREVE=728]="U_BREVE",s[s.U_DOT_ABOVE=729]="U_DOT_ABOVE",s[s.U_RING_ABOVE=730]="U_RING_ABOVE",s[s.U_OGONEK=731]="U_OGONEK",s[s.U_SMALL_TILDE=732]="U_SMALL_TILDE",s[s.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",s[s.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",s[s.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",s[s.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",s[s.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",s[s.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",s[s.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",s[s.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",s[s.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",s[s.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",s[s.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",s[s.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",s[s.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",s[s.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",s[s.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",s[s.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",s[s.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",s[s.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",s[s.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",s[s.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",s[s.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",s[s.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",s[s.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",s[s.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",s[s.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",s[s.U_GREEK_TONOS=900]="U_GREEK_TONOS",s[s.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",s[s.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",s[s.U_GREEK_PSILI=8127]="U_GREEK_PSILI",s[s.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",s[s.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",s[s.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",s[s.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",s[s.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",s[s.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",s[s.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",s[s.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",s[s.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",s[s.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",s[s.U_GREEK_VARIA=8175]="U_GREEK_VARIA",s[s.U_GREEK_OXIA=8189]="U_GREEK_OXIA",s[s.U_GREEK_DASIA=8190]="U_GREEK_DASIA",s[s.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",s[s.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",s[s.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",s[s.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",s[s.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",s[s.U_OVERLINE=8254]="U_OVERLINE",s[s.UTF8_BOM=65279]="UTF8_BOM",s[s.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",s[s.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(ce[139],le([0,1]),function(V,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=s,e.diffSets=b,e.diffMaps=M,e.intersection=L;function s(w,c){const m=Object.create(null);for(const u of w){const f=c(u);let v=m[f];v||(v=m[f]=[]),v.push(u)}return m}function b(w,c){const m=[],u=[];for(const f of w)c.has(f)||m.push(f);for(const f of c)w.has(f)||u.push(f);return{removed:m,added:u}}function M(w,c){const m=[],u=[];for(const[f,v]of w)c.has(f)||m.push(v);for(const[f,v]of c)w.has(f)||u.push(v);return{removed:m,added:u}}function L(w,c){const m=new Set;for(const u of c)w.has(u)&&m.add(u);return m}class R{static{n=Symbol.toStringTag}constructor(c,m){this.toKey=m,this._map=new Map,this[n]="SetWithKey";for(const u of c)this.add(u)}get size(){return this._map.size}add(c){const m=this.toKey(c);return this._map.set(m,c),this}delete(c){return this._map.delete(this.toKey(c))}has(c){return this._map.has(this.toKey(c))}*entries(){for(const c of this._map.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this._map.values())yield c}clear(){this._map.clear()}forEach(c,m){this._map.forEach(u=>c.call(m,u,u,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=R}),define(ce[140],le([0,1,39]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function s(w,c){const m=Math.pow(10,c);return Math.round(w*m)/m}class b{constructor(c,m,u,f=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,u))|0,this.a=s(Math.max(Math.min(1,f),0),3)}static equals(c,m){return c.r===m.r&&c.g===m.g&&c.b===m.b&&c.a===m.a}}e.RGBA=b;class M{constructor(c,m,u,f){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=s(Math.max(Math.min(1,m),0),3),this.l=s(Math.max(Math.min(1,u),0),3),this.a=s(Math.max(Math.min(1,f),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.l===m.l&&c.a===m.a}static fromRGBA(c){const m=c.r/255,u=c.g/255,f=c.b/255,v=c.a,h=Math.max(m,u,f),g=Math.min(m,u,f);let E=0,S=0;const p=(g+h)/2,D=h-g;if(D>0){switch(S=Math.min(p<=.5?D/(2*p):D/(2-2*p),1),h){case m:E=(u-f)/D+(u<f?6:0);break;case u:E=(f-m)/D+2;break;case f:E=(m-u)/D+4;break}E*=60,E=Math.round(E)}return new M(E,S,p,v)}static _hue2rgb(c,m,u){return u<0&&(u+=1),u>1&&(u-=1),u<1/6?c+(m-c)*6*u:u<1/2?m:u<2/3?c+(m-c)*(2/3-u)*6:c}static toRGBA(c){const m=c.h/360,{s:u,l:f,a:v}=c;let h,g,E;if(u===0)h=g=E=f;else{const S=f<.5?f*(1+u):f+u-f*u,p=2*f-S;h=M._hue2rgb(p,S,m+1/3),g=M._hue2rgb(p,S,m),E=M._hue2rgb(p,S,m-1/3)}return new b(Math.round(h*255),Math.round(g*255),Math.round(E*255),v)}}e.HSLA=M;class L{constructor(c,m,u,f){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=s(Math.max(Math.min(1,m),0),3),this.v=s(Math.max(Math.min(1,u),0),3),this.a=s(Math.max(Math.min(1,f),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.v===m.v&&c.a===m.a}static fromRGBA(c){const m=c.r/255,u=c.g/255,f=c.b/255,v=Math.max(m,u,f),h=Math.min(m,u,f),g=v-h,E=v===0?0:g/v;let S;return g===0?S=0:v===m?S=((u-f)/g%6+6)%6:v===u?S=(f-m)/g+2:S=(m-u)/g+4,new L(Math.round(S*60),E,v,c.a)}static toRGBA(c){const{h:m,s:u,v:f,a:v}=c,h=f*u,g=h*(1-Math.abs(m/60%2-1)),E=f-h;let[S,p,D]=[0,0,0];return m<60?(S=h,p=g):m<120?(S=g,p=h):m<180?(p=h,D=g):m<240?(p=g,D=h):m<300?(S=g,D=h):m<=360&&(S=h,D=g),S=Math.round((S+E)*255),p=Math.round((p+E)*255),D=Math.round((D+E)*255),new b(S,p,D,v)}}e.HSVA=L;class R{static fromHex(c){return R.Format.CSS.parseHex(c)||R.red}static equals(c,m){return!c&&!m?!0:!c||!m?!1:c.equals(m)}get hsla(){return this._hsla?this._hsla:M.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:L.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof b)this.rgba=c;else if(c instanceof M)this._hsla=c,this.rgba=M.toRGBA(c);else if(c instanceof L)this._hsva=c,this.rgba=L.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&b.equals(this.rgba,c.rgba)&&M.equals(this.hsla,c.hsla)&&L.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=R._relativeLuminanceForComponent(this.rgba.r),m=R._relativeLuminanceForComponent(this.rgba.g),u=R._relativeLuminanceForComponent(this.rgba.b),f=.2126*c+.7152*m+.0722*u;return s(f,4)}static _relativeLuminanceForComponent(c){const m=c/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(c){const m=this.getRelativeLuminance(),u=c.getRelativeLuminance();return m>u?(m+.05)/(u+.05):(u+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const m=this.getRelativeLuminance(),u=c.getRelativeLuminance();return m>u}isDarkerThan(c){const m=this.getRelativeLuminance(),u=c.getRelativeLuminance();return m<u}lighten(c){return new R(new M(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new R(new M(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:m,g:u,b:f,a:v}=this.rgba;return new R(new b(m,u,f,v*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new b(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const m=c.rgba,u=this.rgba.a,f=m.a,v=u+f*(1-u);if(v<1e-6)return R.transparent;const h=this.rgba.r*u/v+m.r*f*(1-u)/v,g=this.rgba.g*u/v+m.g*f*(1-u)/v,E=this.rgba.b*u/v+m.b*f*(1-u)/v;return new R(new b(h,g,E,v))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:m,g:u,b:f,a:v}=this.rgba;return new R(new b(c.rgba.r-v*(c.rgba.r-m),c.rgba.g-v*(c.rgba.g-u),c.rgba.b-v*(c.rgba.b-f),1))}flatten(...c){const m=c.reduceRight((u,f)=>R._flatten(f,u));return R._flatten(this,m)}static _flatten(c,m){const u=1-c.rgba.a;return new R(new b(u*m.rgba.r+c.rgba.a*c.rgba.r,u*m.rgba.g+c.rgba.a*c.rgba.g,u*m.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this._toString||(this._toString=R.Format.CSS.format(this)),this._toString}static getLighterColor(c,m,u){if(c.isLighterThan(m))return c;u=u||.5;const f=c.getRelativeLuminance(),v=m.getRelativeLuminance();return u=u*(v-f)/v,c.lighten(u)}static getDarkerColor(c,m,u){if(c.isDarkerThan(m))return c;u=u||.5;const f=c.getRelativeLuminance(),v=m.getRelativeLuminance();return u=u*(f-v)/f,c.darken(u)}static{this.white=new R(new b(255,255,255,1))}static{this.black=new R(new b(0,0,0,1))}static{this.red=new R(new b(255,0,0,1))}static{this.blue=new R(new b(0,0,255,1))}static{this.green=new R(new b(0,255,0,1))}static{this.cyan=new R(new b(0,255,255,1))}static{this.lightgrey=new R(new b(211,211,211,1))}static{this.transparent=new R(new b(0,0,0,0))}}e.Color=R,function(w){let c;(function(m){let u;(function(f){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:w.Format.CSS.formatRGBA(t)}f.formatRGB=v;function h(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}f.formatRGBA=h;function g(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(t)}f.formatHSL=g;function E(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}f.formatHSLA=E;function S(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function p(t){return`#${S(t.rgba.r)}${S(t.rgba.g)}${S(t.rgba.b)}`}f.formatHex=p;function D(t,o=!1){return o&&t.rgba.a===1?w.Format.CSS.formatHex(t):`#${S(t.rgba.r)}${S(t.rgba.g)}${S(t.rgba.b)}${S(Math.round(t.rgba.a*255))}`}f.formatHexA=D;function I(t){return t.isOpaque()?w.Format.CSS.formatHex(t):w.Format.CSS.formatRGBA(t)}f.format=I;function i(t){const o=t.length;if(o===0||t.charCodeAt(0)!==n.CharCode.Hash)return null;if(o===7){const r=16*d(t.charCodeAt(1))+d(t.charCodeAt(2)),a=16*d(t.charCodeAt(3))+d(t.charCodeAt(4)),l=16*d(t.charCodeAt(5))+d(t.charCodeAt(6));return new w(new b(r,a,l,1))}if(o===9){const r=16*d(t.charCodeAt(1))+d(t.charCodeAt(2)),a=16*d(t.charCodeAt(3))+d(t.charCodeAt(4)),l=16*d(t.charCodeAt(5))+d(t.charCodeAt(6)),P=16*d(t.charCodeAt(7))+d(t.charCodeAt(8));return new w(new b(r,a,l,P/255))}if(o===4){const r=d(t.charCodeAt(1)),a=d(t.charCodeAt(2)),l=d(t.charCodeAt(3));return new w(new b(16*r+r,16*a+a,16*l+l))}if(o===5){const r=d(t.charCodeAt(1)),a=d(t.charCodeAt(2)),l=d(t.charCodeAt(3)),P=d(t.charCodeAt(4));return new w(new b(16*r+r,16*a+a,16*l+l,(16*P+P)/255))}return null}f.parseHex=i;function d(t){switch(t){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(u=m.CSS||(m.CSS={}))})(c=w.Format||(w.Format={}))}(R||(e.Color=R={}))}),define(ce[54],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=s,e.debounce=b,e.throttle=M;function n(L){return(R,w,c)=>{let m=null,u=null;if(typeof c.value=="function"?(m="value",u=c.value):typeof c.get=="function"&&(m="get",u=c.get),!u)throw new Error("not supported");c[m]=L(u,w)}}function s(L,R,w){let c=null,m=null;if(typeof w.value=="function"?(c="value",m=w.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(c="get",m=w.get),!m)throw new Error("not supported");const u=`$memoize$${R}`;w[c]=function(...f){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,f)}),this[u]}}function b(L,R,w){return n((c,m)=>{const u=`$debounce$${m}`,f=`$debounce$result$${m}`;return function(...v){this[f]||(this[f]=w?w():void 0),clearTimeout(this[u]),R&&(this[f]=R(this[f],...v),v=[this[f]]),this[u]=setTimeout(()=>{c.apply(this,v),this[f]=w?w():void 0},L)}})}function M(L,R,w){return n((c,m)=>{const u=`$throttle$timer$${m}`,f=`$throttle$result$${m}`,v=`$throttle$lastRun$${m}`,h=`$throttle$pending$${m}`;return function(...g){if(this[f]||(this[f]=w?w():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...g)),this[h])return;const E=this[v]+L;E<=Date.now()?(this[v]=Date.now(),c.apply(this,[this[f]]),this[f]=w?w():void 0):(this[h]=!0,this[u]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),c.apply(this,[this[f]]),this[f]=w?w():void 0},E-Date.now()))}})}}),define(ce[15],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=s,e.isSigPipeError=b,e.onUnexpectedError=M,e.onUnexpectedExternalError=L,e.transformErrorForSerialization=R,e.transformErrorFromSerialization=w,e.isCancellationError=m,e.canceled=f,e.illegalArgument=v,e.illegalState=h,e.getErrorMessage=E;class n{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?I.isErrorNoTelemetry(t)?new I(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(o=>{o(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=n,e.errorHandler=new n;function s(d){e.errorHandler.setUnexpectedErrorHandler(d)}function b(d){if(!d||typeof d!="object")return!1;const t=d;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function M(d){m(d)||e.errorHandler.onUnexpectedError(d)}function L(d){m(d)||e.errorHandler.onUnexpectedExternalError(d)}function R(d){if(d instanceof Error){const{name:t,message:o}=d,r=d.stacktrace||d.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:I.isErrorNoTelemetry(d)}}return d}function w(d){let t;return d.noTelemetry?t=new I:(t=new Error,t.name=d.name),t.message=d.message,t.stack=d.stack,t}const c="Canceled";function m(d){return d instanceof u?!0:d instanceof Error&&d.name===c&&d.message===c}class u extends Error{constructor(){super(c),this.name=this.message}}e.CancellationError=u;function f(){const d=new Error(c);return d.name=d.message,d}function v(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function h(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class g extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=g;function E(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}class S extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=S;class p extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=p;class D extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=D;class I extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof I)return t;const o=new I;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=I;class i extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,i.prototype)}}e.BugIndicatingError=i}),define(ce[21],le([0,1,15,138]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=b,e.tail2=M,e.equals=L,e.removeFastWithoutKeepingOrder=R,e.binarySearch=w,e.binarySearch2=c,e.quickSelect=m,e.groupBy=u,e.groupAdjacentBy=f,e.forEachAdjacent=v,e.forEachWithNeighbors=h,e.sortedDiff=g,e.delta=E,e.top=S,e.topAsync=p,e.coalesce=I,e.coalesceInPlace=i,e.move=d,e.isFalsyOrEmpty=t,e.isNonEmptyArray=o,e.distinct=r,e.uniqueFilter=a,e.firstOrDefault=l,e.lastOrDefault=P,e.commonPrefixLength=y,e.range=k,e.index=T,e.insert=A,e.remove=C,e.arrayInsert=_,e.shuffle=H,e.pushToStart=q,e.pushToEnd=K,e.pushMany=fe,e.mapArrayOrNot=$,e.asArray=X,e.getRandomElement=B,e.insertInto=J,e.splice=U,e.compareBy=Q,e.tieBreakComparators=oe,e.reverseOrder=se,e.findAsync=Z;function b(z,ie=0){return z[z.length-(1+ie)]}function M(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function L(z,ie,G=(x,te)=>x===te){if(z===ie)return!0;if(!z||!ie||z.length!==ie.length)return!1;for(let x=0,te=z.length;x<te;x++)if(!G(z[x],ie[x]))return!1;return!0}function R(z,ie){const G=z.length-1;ie<G&&(z[ie]=z[G]),z.pop()}function w(z,ie,G){return c(z.length,x=>G(z[x],ie))}function c(z,ie){let G=0,x=z-1;for(;G<=x;){const te=(G+x)/2|0,de=ie(te);if(de<0)G=te+1;else if(de>0)x=te-1;else return te}return-(G+1)}function m(z,ie,G){if(z=z|0,z>=ie.length)throw new TypeError("invalid index");const x=ie[Math.floor(ie.length*Math.random())],te=[],de=[],me=[];for(const we of ie){const Re=G(we,x);Re<0?te.push(we):Re>0?de.push(we):me.push(we)}return z<te.length?m(z,te,G):z<te.length+me.length?me[0]:m(z-(te.length+me.length),de,G)}function u(z,ie){const G=[];let x;for(const te of z.slice(0).sort(ie))!x||ie(x[0],te)!==0?(x=[te],G.push(x)):x.push(te);return G}function*f(z,ie){let G,x;for(const te of z)x!==void 0&&ie(x,te)?G.push(te):(G&&(yield G),G=[te]),x=te;G&&(yield G)}function v(z,ie){for(let G=0;G<=z.length;G++)ie(G===0?void 0:z[G-1],G===z.length?void 0:z[G])}function h(z,ie){for(let G=0;G<z.length;G++)ie(G===0?void 0:z[G-1],z[G],G+1===z.length?void 0:z[G+1])}function g(z,ie,G){const x=[];function te(we,Re,Ne){if(Re===0&&Ne.length===0)return;const ke=x[x.length-1];ke&&ke.start+ke.deleteCount===we?(ke.deleteCount+=Re,ke.toInsert.push(...Ne)):x.push({start:we,deleteCount:Re,toInsert:Ne})}let de=0,me=0;for(;;){if(de===z.length){te(de,0,ie.slice(me));break}if(me===ie.length){te(de,z.length-de,[]);break}const we=z[de],Re=ie[me],Ne=G(we,Re);Ne===0?(de+=1,me+=1):Ne<0?(te(de,1,[]),de+=1):Ne>0&&(te(de,0,[Re]),me+=1)}return x}function E(z,ie,G){const x=g(z,ie,G),te=[],de=[];for(const me of x)te.push(...z.slice(me.start,me.start+me.deleteCount)),de.push(...me.toInsert);return{removed:te,added:de}}function S(z,ie,G){if(G===0)return[];const x=z.slice(0,G).sort(ie);return D(z,ie,x,G,z.length),x}function p(z,ie,G,x,te){return G===0?Promise.resolve([]):new Promise((de,me)=>{(async()=>{const we=z.length,Re=z.slice(0,G).sort(ie);for(let Ne=G,ke=Math.min(G+x,we);Ne<we;Ne=ke,ke=Math.min(ke+x,we)){if(Ne>G&&await new Promise(Ee=>setTimeout(Ee)),te&&te.isCancellationRequested)throw new n.CancellationError;D(z,ie,Re,Ne,ke)}return Re})().then(de,me)})}function D(z,ie,G,x,te){for(const de=G.length;x<te;x++){const me=z[x];if(ie(me,G[de-1])<0){G.pop();const we=(0,s.findFirstIdxMonotonousOrArrLen)(G,Re=>ie(me,Re)<0);G.splice(we,0,me)}}}function I(z){return z.filter(ie=>!!ie)}function i(z){let ie=0;for(let G=0;G<z.length;G++)z[G]&&(z[ie]=z[G],ie+=1);z.length=ie}function d(z,ie,G){z.splice(G,0,z.splice(ie,1)[0])}function t(z){return!Array.isArray(z)||z.length===0}function o(z){return Array.isArray(z)&&z.length>0}function r(z,ie=G=>G){const G=new Set;return z.filter(x=>{const te=ie(x);return G.has(te)?!1:(G.add(te),!0)})}function a(z){const ie=new Set;return G=>{const x=z(G);return ie.has(x)?!1:(ie.add(x),!0)}}function l(z,ie){return z.length>0?z[0]:ie}function P(z,ie){return z.length>0?z[z.length-1]:ie}function y(z,ie,G=(x,te)=>x===te){let x=0;for(let te=0,de=Math.min(z.length,ie.length);te<de&&G(z[te],ie[te]);te++)x++;return x}function k(z,ie){let G=typeof ie=="number"?z:0;typeof ie=="number"?G=z:(G=0,ie=z);const x=[];if(G<=ie)for(let te=G;te<ie;te++)x.push(te);else for(let te=G;te>ie;te--)x.push(te);return x}function T(z,ie,G){return z.reduce((x,te)=>(x[ie(te)]=G?G(te):te,x),Object.create(null))}function A(z,ie){return z.push(ie),()=>C(z,ie)}function C(z,ie){const G=z.indexOf(ie);if(G>-1)return z.splice(G,1),ie}function _(z,ie,G){const x=z.slice(0,ie),te=z.slice(ie);return x.concat(G,te)}function H(z,ie){let G;if(typeof ie=="number"){let x=ie;G=()=>{const te=Math.sin(x++)*179426549;return te-Math.floor(te)}}else G=Math.random;for(let x=z.length-1;x>0;x-=1){const te=Math.floor(G()*(x+1)),de=z[x];z[x]=z[te],z[te]=de}}function q(z,ie){const G=z.indexOf(ie);G>-1&&(z.splice(G,1),z.unshift(ie))}function K(z,ie){const G=z.indexOf(ie);G>-1&&(z.splice(G,1),z.push(ie))}function fe(z,ie){for(const G of ie)z.push(G)}function $(z,ie){return Array.isArray(z)?z.map(ie):ie(z)}function X(z){return Array.isArray(z)?z:[z]}function B(z){return z[Math.floor(Math.random()*z.length)]}function J(z,ie,G){const x=O(z,ie),te=z.length,de=G.length;z.length=te+de;for(let me=te-1;me>=x;me--)z[me+de]=z[me];for(let me=0;me<de;me++)z[me+x]=G[me]}function U(z,ie,G,x){const te=O(z,ie);let de=z.splice(te,G);return de===void 0&&(de=[]),J(z,te,x),de}function O(z,ie){return ie<0?Math.max(ie+z.length,0):Math.min(ie,z.length)}var N;(function(z){function ie(de){return de<0}z.isLessThan=ie;function G(de){return de<=0}z.isLessThanOrEqual=G;function x(de){return de>0}z.isGreaterThan=x;function te(de){return de===0}z.isNeitherLessOrGreaterThan=te,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(N||(e.CompareResult=N={}));function Q(z,ie){return(G,x)=>ie(z(G),z(x))}function oe(...z){return(ie,G)=>{for(const x of z){const te=x(ie,G);if(!N.isNeitherLessOrGreaterThan(te))return te}return N.neitherLessOrGreaterThan}}const j=(z,ie)=>z-ie;e.numberComparator=j;const ue=(z,ie)=>(0,e.numberComparator)(z?1:0,ie?1:0);e.booleanComparator=ue;function se(z){return(ie,G)=>-z(ie,G)}class Y{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let G=this.firstIdx;for(;G<this.items.length&&ie(this.items[G]);)G++;const x=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,x}takeFromEndWhile(ie){let G=this.lastIdx;for(;G>=0&&ie(this.items[G]);)G--;const x=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,x}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const G=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,G}}e.ArrayQueue=Y;class W{static{this.empty=new W(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(G=>(ie(G),!0))}toArray(){const ie=[];return this.iterate(G=>(ie.push(G),!0)),ie}filter(ie){return new W(G=>this.iterate(x=>ie(x)?G(x):!0))}map(ie){return new W(G=>this.iterate(x=>G(ie(x))))}some(ie){let G=!1;return this.iterate(x=>(G=ie(x),!G)),G}findFirst(ie){let G;return this.iterate(x=>ie(x)?(G=x,!1):!0),G}findLast(ie){let G;return this.iterate(x=>(ie(x)&&(G=x),!0)),G}findLastMaxBy(ie){let G,x=!0;return this.iterate(te=>((x||N.isGreaterThan(ie(te,G)))&&(x=!1,G=te),!0)),G}}e.CallbackIterable=W;class F{constructor(ie){this._indexMap=ie}static createSortPermutation(ie,G){const x=Array.from(ie.keys()).sort((te,de)=>G(ie[te],ie[de]));return new F(x)}apply(ie){return ie.map((G,x)=>ie[this._indexMap[x]])}inverse(){const ie=this._indexMap.slice();for(let G=0;G<this._indexMap.length;G++)ie[this._indexMap[G]]=G;return new F(ie)}}e.Permutation=F;async function Z(z,ie){return(await Promise.all(z.map(async(x,te)=>({element:x,ok:await ie(x,te)})))).find(x=>x.ok)?.element}}),define(ce[141],le([0,1,15]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=s,e.assertNever=b,e.assert=M,e.softAssert=L,e.assertFn=R,e.checkAdjacentItems=w;function s(c,m){if(!c)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}function b(c,m="Unreachable"){throw new Error(m)}function M(c,m="unexpected state"){if(!c)throw new n.BugIndicatingError(`Assertion Failed: ${m}`)}function L(c){c||(0,n.onUnexpectedError)(new n.BugIndicatingError("Soft Assertion Failed"))}function R(c){if(!c()){debugger;c(),(0,n.onUnexpectedError)(new n.BugIndicatingError("Assertion Failed"))}}function w(c,m){let u=0;for(;u<c.length-1;){const f=c[u],v=c[u+1];if(!m(f,v))return!1;u++}return!0}}),define(ce[89],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=n;function n(s,b){const M=this;let L=!1,R;return function(){if(L)return R;if(L=!0,b)try{R=s.apply(M,arguments)}finally{b()}else R=s.apply(M,arguments);return R}}}),define(ce[77],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(s){function b(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}s.is=b;const M=Object.freeze([]);function L(){return M}s.empty=L;function*R(t){yield t}s.single=R;function w(t){return b(t)?t:R(t)}s.wrap=w;function c(t){return t||M}s.from=c;function*m(t){for(let o=t.length-1;o>=0;o--)yield t[o]}s.reverse=m;function u(t){return!t||t[Symbol.iterator]().next().done===!0}s.isEmpty=u;function f(t){return t[Symbol.iterator]().next().value}s.first=f;function v(t,o){let r=0;for(const a of t)if(o(a,r++))return!0;return!1}s.some=v;function h(t,o){for(const r of t)if(o(r))return r}s.find=h;function*g(t,o){for(const r of t)o(r)&&(yield r)}s.filter=g;function*E(t,o){let r=0;for(const a of t)yield o(a,r++)}s.map=E;function*S(t,o){let r=0;for(const a of t)yield*o(a,r++)}s.flatMap=S;function*p(...t){for(const o of t)yield*o}s.concat=p;function D(t,o,r){let a=r;for(const l of t)a=o(a,l);return a}s.reduce=D;function*I(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}s.slice=I;function i(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const a=t[Symbol.iterator]();for(let l=0;l<o;l++){const P=a.next();if(P.done)return[r,s.empty()];r.push(P.value)}return[r,{[Symbol.iterator](){return a}}]}s.consume=i;async function d(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}s.asyncToArray=d})(n||(e.Iterable=n={}))}),define(ce[43],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=L,e.getLocation=u,e.parse=f,e.parseTree=v,e.findNodeAtLocation=h,e.getNodePath=g,e.getNodeValue=E,e.contains=S,e.findNodeAtOffset=p,e.visit=D,e.getNodeType=I;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var s;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(s||(e.SyntaxKind=s={}));var b;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(b||(e.ParseErrorCode=b={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function L(i,d=!1){let t=0;const o=i.length;let r="",a=0,l=s.Unknown,P=n.None;function y(q){let K=0,fe=0;for(;K<q;){const $=i.charCodeAt(t);if($>=m._0&&$<=m._9)fe=fe*16+$-m._0;else if($>=m.A&&$<=m.F)fe=fe*16+$-m.A+10;else if($>=m.a&&$<=m.f)fe=fe*16+$-m.a+10;else break;t++,K++}return K<q&&(fe=-1),fe}function k(q){t=q,r="",a=0,l=s.Unknown,P=n.None}function T(){const q=t;if(i.charCodeAt(t)===m._0)t++;else for(t++;t<i.length&&c(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===m.dot)if(t++,t<i.length&&c(i.charCodeAt(t)))for(t++;t<i.length&&c(i.charCodeAt(t));)t++;else return P=n.UnexpectedEndOfNumber,i.substring(q,t);let K=t;if(t<i.length&&(i.charCodeAt(t)===m.E||i.charCodeAt(t)===m.e))if(t++,(t<i.length&&i.charCodeAt(t)===m.plus||i.charCodeAt(t)===m.minus)&&t++,t<i.length&&c(i.charCodeAt(t))){for(t++;t<i.length&&c(i.charCodeAt(t));)t++;K=t}else P=n.UnexpectedEndOfNumber;return i.substring(q,K)}function A(){let q="",K=t;for(;;){if(t>=o){q+=i.substring(K,t),P=n.UnexpectedEndOfString;break}const fe=i.charCodeAt(t);if(fe===m.doubleQuote){q+=i.substring(K,t),t++;break}if(fe===m.backslash){if(q+=i.substring(K,t),t++,t>=o){P=n.UnexpectedEndOfString;break}switch(i.charCodeAt(t++)){case m.doubleQuote:q+='"';break;case m.backslash:q+="\\";break;case m.slash:q+="/";break;case m.b:q+="\b";break;case m.f:q+="\f";break;case m.n:q+=`
`;break;case m.r:q+="\r";break;case m.t:q+="	";break;case m.u:{const X=y(4);X>=0?q+=String.fromCharCode(X):P=n.InvalidUnicode;break}default:P=n.InvalidEscapeCharacter}K=t;continue}if(fe>=0&&fe<=31)if(w(fe)){q+=i.substring(K,t),P=n.UnexpectedEndOfString;break}else P=n.InvalidCharacter;t++}return q}function C(){if(r="",P=n.None,a=t,t>=o)return a=o,l=s.EOF;let q=i.charCodeAt(t);if(R(q)){do t++,r+=String.fromCharCode(q),q=i.charCodeAt(t);while(R(q));return l=s.Trivia}if(w(q))return t++,r+=String.fromCharCode(q),q===m.carriageReturn&&i.charCodeAt(t)===m.lineFeed&&(t++,r+=`
`),l=s.LineBreakTrivia;switch(q){case m.openBrace:return t++,l=s.OpenBraceToken;case m.closeBrace:return t++,l=s.CloseBraceToken;case m.openBracket:return t++,l=s.OpenBracketToken;case m.closeBracket:return t++,l=s.CloseBracketToken;case m.colon:return t++,l=s.ColonToken;case m.comma:return t++,l=s.CommaToken;case m.doubleQuote:return t++,r=A(),l=s.StringLiteral;case m.slash:{const K=t-1;if(i.charCodeAt(t+1)===m.slash){for(t+=2;t<o&&!w(i.charCodeAt(t));)t++;return r=i.substring(K,t),l=s.LineCommentTrivia}if(i.charCodeAt(t+1)===m.asterisk){t+=2;const fe=o-1;let $=!1;for(;t<fe;){if(i.charCodeAt(t)===m.asterisk&&i.charCodeAt(t+1)===m.slash){t+=2,$=!0;break}t++}return $||(t++,P=n.UnexpectedEndOfComment),r=i.substring(K,t),l=s.BlockCommentTrivia}return r+=String.fromCharCode(q),t++,l=s.Unknown}case m.minus:if(r+=String.fromCharCode(q),t++,t===o||!c(i.charCodeAt(t)))return l=s.Unknown;case m._0:case m._1:case m._2:case m._3:case m._4:case m._5:case m._6:case m._7:case m._8:case m._9:return r+=T(),l=s.NumericLiteral;default:for(;t<o&&_(q);)t++,q=i.charCodeAt(t);if(a!==t){switch(r=i.substring(a,t),r){case"true":return l=s.TrueKeyword;case"false":return l=s.FalseKeyword;case"null":return l=s.NullKeyword}return l=s.Unknown}return r+=String.fromCharCode(q),t++,l=s.Unknown}}function _(q){if(R(q)||w(q))return!1;switch(q){case m.closeBrace:case m.closeBracket:case m.openBrace:case m.openBracket:case m.doubleQuote:case m.colon:case m.comma:case m.slash:return!1}return!0}function H(){let q;do q=C();while(q>=s.LineCommentTrivia&&q<=s.Trivia);return q}return{setPosition:k,getPosition:()=>t,scan:d?H:C,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>P}}function R(i){return i===m.space||i===m.tab||i===m.verticalTab||i===m.formFeed||i===m.nonBreakingSpace||i===m.ogham||i>=m.enQuad&&i<=m.zeroWidthSpace||i===m.narrowNoBreakSpace||i===m.mathematicalSpace||i===m.ideographicSpace||i===m.byteOrderMark}function w(i){return i===m.lineFeed||i===m.carriageReturn||i===m.lineSeparator||i===m.paragraphSeparator}function c(i){return i>=m._0&&i<=m._9}var m;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(m||(m={}));function u(i,d){const t=[],o=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(y,k,T,A){a.value=y,a.offset=k,a.length=T,a.type=A,a.colonOffset=void 0,r=a}try{D(i,{onObjectBegin:(y,k)=>{if(d<=y)throw o;r=void 0,l=d>y,t.push("")},onObjectProperty:(y,k,T)=>{if(d<k||(P(y,k,T,"property"),t[t.length-1]=y,d<=k+T))throw o},onObjectEnd:(y,k)=>{if(d<=y)throw o;r=void 0,t.pop()},onArrayBegin:(y,k)=>{if(d<=y)throw o;r=void 0,t.push(0)},onArrayEnd:(y,k)=>{if(d<=y)throw o;r=void 0,t.pop()},onLiteralValue:(y,k,T)=>{if(d<k||(P(y,k,T,I(y)),d<=k+T))throw o},onSeparator:(y,k,T)=>{if(d<=k)throw o;if(y===":"&&r&&r.type==="property")r.colonOffset=k,l=!1,r=void 0;else if(y===","){const A=t[t.length-1];typeof A=="number"?t[t.length-1]=A+1:(l=!0,t[t.length-1]=""),r=void 0}}})}catch(y){if(y!==o)throw y}return{path:t,previousNode:r,isAtPropertyKey:l,matches:y=>{let k=0;for(let T=0;k<y.length&&T<t.length;T++)if(y[k]===t[T]||y[k]==="*")k++;else if(y[k]!=="**")return!1;return k===y.length}}}function f(i,d=[],t=M.DEFAULT){let o=null,r=[];const a=[];function l(y){Array.isArray(r)?r.push(y):o!==null&&(r[o]=y)}return D(i,{onObjectBegin:()=>{const y={};l(y),a.push(r),r=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const y=[];l(y),a.push(r),r=y,o=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:l,onError:(y,k,T)=>{d.push({error:y,offset:k,length:T})}},t),r[0]}function v(i,d=[],t=M.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(y){o.type==="property"&&(o.length=y-o.offset,o=o.parent)}function a(y){return o.children.push(y),y}D(i,{onObjectBegin:y=>{o=a({type:"object",offset:y,length:-1,parent:o,children:[]})},onObjectProperty:(y,k,T)=>{o=a({type:"property",offset:k,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:y,offset:k,length:T,parent:o})},onObjectEnd:(y,k)=>{o.length=y+k-o.offset,o=o.parent,r(y+k)},onArrayBegin:(y,k)=>{o=a({type:"array",offset:y,length:-1,parent:o,children:[]})},onArrayEnd:(y,k)=>{o.length=y+k-o.offset,o=o.parent,r(y+k)},onLiteralValue:(y,k,T)=>{a({type:I(y),offset:k,length:T,parent:o,value:y}),r(k+T)},onSeparator:(y,k,T)=>{o.type==="property"&&(y===":"?o.colonOffset=k:y===","&&r(k))},onError:(y,k,T)=>{d.push({error:y,offset:k,length:T})}},t);const P=o.children[0];return P&&delete P.parent,P}function h(i,d){if(!i)return;let t=i;for(const o of d)if(typeof o=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===o){t=a.children[1],r=!0;break}if(!r)return}else{const r=o;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}function g(i){if(!i.parent||!i.parent.children)return[];const d=g(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;d.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&d.push(t)}return d}function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const d=Object.create(null);for(const t of i.children){const o=t.children[1];o&&(d[t.children[0].value]=E(o))}return d}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function S(i,d,t=!1){return d>=i.offset&&d<i.offset+i.length||t&&d===i.offset+i.length}function p(i,d,t=!1){if(S(i,d,t)){const o=i.children;if(Array.isArray(o))for(let r=0;r<o.length&&o[r].offset<=d;r++){const a=p(o[r],d,t);if(a)return a}return i}}function D(i,d,t=M.DEFAULT){const o=L(i,!1);function r(Q){return Q?()=>Q(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(Q){return Q?oe=>Q(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=r(d.onObjectBegin),P=a(d.onObjectProperty),y=r(d.onObjectEnd),k=r(d.onArrayBegin),T=r(d.onArrayEnd),A=a(d.onLiteralValue),C=a(d.onSeparator),_=r(d.onComment),H=a(d.onError),q=t&&t.disallowComments,K=t&&t.allowTrailingComma;function fe(){for(;;){const Q=o.scan();switch(o.getTokenError()){case n.InvalidUnicode:$(b.InvalidUnicode);break;case n.InvalidEscapeCharacter:$(b.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:$(b.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:q||$(b.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:$(b.UnexpectedEndOfString);break;case n.InvalidCharacter:$(b.InvalidCharacter);break}switch(Q){case s.LineCommentTrivia:case s.BlockCommentTrivia:q?$(b.InvalidCommentToken):_();break;case s.Unknown:$(b.InvalidSymbol);break;case s.Trivia:case s.LineBreakTrivia:break;default:return Q}}}function $(Q,oe=[],j=[]){if(H(Q),oe.length+j.length>0){let ue=o.getToken();for(;ue!==s.EOF;){if(oe.indexOf(ue)!==-1){fe();break}else if(j.indexOf(ue)!==-1)break;ue=fe()}}}function X(Q){const oe=o.getTokenValue();return Q?A(oe):P(oe),fe(),!0}function B(){switch(o.getToken()){case s.NumericLiteral:{let Q=0;try{Q=JSON.parse(o.getTokenValue()),typeof Q!="number"&&($(b.InvalidNumberFormat),Q=0)}catch{$(b.InvalidNumberFormat)}A(Q);break}case s.NullKeyword:A(null);break;case s.TrueKeyword:A(!0);break;case s.FalseKeyword:A(!1);break;default:return!1}return fe(),!0}function J(){return o.getToken()!==s.StringLiteral?($(b.PropertyNameExpected,[],[s.CloseBraceToken,s.CommaToken]),!1):(X(!1),o.getToken()===s.ColonToken?(C(":"),fe(),N()||$(b.ValueExpected,[],[s.CloseBraceToken,s.CommaToken])):$(b.ColonExpected,[],[s.CloseBraceToken,s.CommaToken]),!0)}function U(){l(),fe();let Q=!1;for(;o.getToken()!==s.CloseBraceToken&&o.getToken()!==s.EOF;){if(o.getToken()===s.CommaToken){if(Q||$(b.ValueExpected,[],[]),C(","),fe(),o.getToken()===s.CloseBraceToken&&K)break}else Q&&$(b.CommaExpected,[],[]);J()||$(b.ValueExpected,[],[s.CloseBraceToken,s.CommaToken]),Q=!0}return y(),o.getToken()!==s.CloseBraceToken?$(b.CloseBraceExpected,[s.CloseBraceToken],[]):fe(),!0}function O(){k(),fe();let Q=!1;for(;o.getToken()!==s.CloseBracketToken&&o.getToken()!==s.EOF;){if(o.getToken()===s.CommaToken){if(Q||$(b.ValueExpected,[],[]),C(","),fe(),o.getToken()===s.CloseBracketToken&&K)break}else Q&&$(b.CommaExpected,[],[]);N()||$(b.ValueExpected,[],[s.CloseBracketToken,s.CommaToken]),Q=!0}return T(),o.getToken()!==s.CloseBracketToken?$(b.CloseBracketExpected,[s.CloseBracketToken],[]):fe(),!0}function N(){switch(o.getToken()){case s.OpenBracketToken:return O();case s.OpenBraceToken:return U();case s.StringLiteral:return X(!0);default:return B()}}return fe(),o.getToken()===s.EOF?t.allowEmptyContent?!0:($(b.ValueExpected,[],[]),!1):N()?(o.getToken()!==s.EOF&&$(b.EndOfFileExpected,[],[]),!0):($(b.ValueExpected,[],[]),!1)}function I(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[142],le([0,1,43]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=s,e.toFormattedString=b,e.getEOL=R,e.isEOL=w;function s(c,m,u){let f,v,h,g,E;if(m){for(g=m.offset,E=g+m.length,h=g;h>0&&!w(c,h-1);)h--;let P=E;for(;P<c.length&&!w(c,P);)P++;v=c.substring(h,P),f=L(v,u)}else v=c,f=0,h=0,g=0,E=c.length;const S=R(u,c);let p=!1,D=0,I;u.insertSpaces?I=M(" ",u.tabSize||4):I="	";const i=(0,n.createScanner)(v,!1);let d=!1;function t(){return S+M(I,f+D)}function o(){let P=i.scan();for(p=!1;P===n.SyntaxKind.Trivia||P===n.SyntaxKind.LineBreakTrivia;)p=p||P===n.SyntaxKind.LineBreakTrivia,P=i.scan();return d=P===n.SyntaxKind.Unknown||i.getTokenError()!==n.ScanError.None,P}const r=[];function a(P,y,k){!d&&y<E&&k>g&&c.substring(y,k)!==P&&r.push({offset:y,length:k-y,content:P})}let l=o();if(l!==n.SyntaxKind.EOF){const P=i.getTokenOffset()+h,y=M(I,f);a(y,h,P)}for(;l!==n.SyntaxKind.EOF;){let P=i.getTokenOffset()+i.getTokenLength()+h,y=o(),k="";for(;!p&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia);){const A=i.getTokenOffset()+h;a(" ",P,A),P=i.getTokenOffset()+i.getTokenLength()+h,k=y===n.SyntaxKind.LineCommentTrivia?t():"",y=o()}if(y===n.SyntaxKind.CloseBraceToken)l!==n.SyntaxKind.OpenBraceToken&&(D--,k=t());else if(y===n.SyntaxKind.CloseBracketToken)l!==n.SyntaxKind.OpenBracketToken&&(D--,k=t());else{switch(l){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:D++,k=t();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:k=t();break;case n.SyntaxKind.BlockCommentTrivia:p?k=t():k=" ";break;case n.SyntaxKind.ColonToken:k=" ";break;case n.SyntaxKind.StringLiteral:if(y===n.SyntaxKind.ColonToken){k="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia?k=" ":y!==n.SyntaxKind.CommaToken&&y!==n.SyntaxKind.EOF&&(d=!0);break;case n.SyntaxKind.Unknown:d=!0;break}p&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia)&&(k=t())}const T=i.getTokenOffset()+h;a(k,P,T),l=y}return r}function b(c,m){const u=JSON.stringify(c,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?u.replace(/\r\n|\r|\n/g,m.eol):u}function M(c,m){let u="";for(let f=0;f<m;f++)u+=c;return u}function L(c,m){let u=0,f=0;const v=m.tabSize||4;for(;u<c.length;){const h=c.charAt(u);if(h===" ")f++;else if(h==="	")f+=v;else break;u++}return Math.floor(f/v)}function R(c,m){for(let u=0;u<m.length;u++){const f=m.charAt(u);if(f==="\r")return u+1<m.length&&m.charAt(u+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return c&&c.eol||`
`}function w(c,m){return`\r
`.indexOf(c.charAt(m))!==-1}}),define(ce[107],le([0,1,43,142]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=b,e.setProperty=M,e.withFormatting=L,e.applyEdit=R,e.applyEdits=w;function b(c,m,u){return M(c,m,void 0,u)}function M(c,m,u,f,v){const h=m.slice(),g=[],E=(0,n.parseTree)(c,g);let S,p;for(;h.length>0&&(p=h.pop(),S=(0,n.findNodeAtLocation)(E,h),S===void 0&&u!==void 0);)typeof p=="string"?u={[p]:u}:u=[u];if(S)if(S.type==="object"&&typeof p=="string"&&Array.isArray(S.children)){const D=(0,n.findNodeAtLocation)(S,[p]);if(D!==void 0)if(u===void 0){if(!D.parent)throw new Error("Malformed AST");const I=S.children.indexOf(D.parent);let i,d=D.parent.offset+D.parent.length;if(I>0){const t=S.children[I-1];i=t.offset+t.length}else i=S.offset+1,S.children.length>1&&(d=S.children[1].offset);return L(c,{offset:i,length:d-i,content:""},f)}else return L(c,{offset:D.offset,length:D.length,content:JSON.stringify(u)},f);else{if(u===void 0)return[];const I=`${JSON.stringify(p)}: ${JSON.stringify(u)}`,i=v?v(S.children.map(t=>t.children[0].value)):S.children.length;let d;if(i>0){const t=S.children[i-1];d={offset:t.offset+t.length,length:0,content:","+I}}else S.children.length===0?d={offset:S.offset+1,length:0,content:I}:d={offset:S.offset+1,length:0,content:I+","};return L(c,d,f)}}else if(S.type==="array"&&typeof p=="number"&&Array.isArray(S.children))if(u!==void 0){const D=`${JSON.stringify(u)}`;let I;if(S.children.length===0||p===0)I={offset:S.offset+1,length:0,content:S.children.length===0?D:D+","};else{const i=p===-1||p>S.children.length?S.children.length:p,d=S.children[i-1];I={offset:d.offset+d.length,length:0,content:","+D}}return L(c,I,f)}else{const D=p,I=S.children[D];let i;if(S.children.length===1)i={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===D){const d=S.children[D-1],t=d.offset+d.length,o=S.offset+S.length;i={offset:t,length:o-2-t,content:""}}else i={offset:I.offset,length:S.children[D+1].offset-I.offset,content:""};return L(c,i,f)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${S.type}`);else return u===void 0?[]:L(c,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(u)},f)}function L(c,m,u){let f=R(c,m),v=m.offset,h=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;v>0&&!(0,s.isEOL)(f,v-1);)v--;for(;h<f.length&&!(0,s.isEOL)(f,h);)h++}const g=(0,s.format)(f,{offset:v,length:h-v},u);for(let S=g.length-1;S>=0;S--){const p=g[S];f=R(f,p),v=Math.min(v,p.offset),h=Math.max(h,p.offset+p.length),h+=p.content.length-p.length}const E=c.length-(f.length-h)-v;return[{offset:v,length:E,content:f.substring(v,h)}]}function R(c,m){return c.substring(0,m.offset)+m.content+c.substring(m.offset+m.length)}function w(c,m){const u=m.slice(0).sort((v,h)=>{const g=v.offset-h.offset;return g===0?v.length-h.length:g});let f=c.length;for(let v=u.length-1;v>=0;v--){const h=u[v];if(h.offset+h.length<=f)c=R(c,h);else throw new Error("Overlapping edit");f=h.offset}return c}}),define(ce[143],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCompressedContent=n;function n(M){let L=!1;const R=new Map,w=new Map;if(b(M,g=>{if(M===g)return!0;const E=JSON.stringify(g);if(E.length<30)return!0;const S=R.get(E);if(!S){const p={schemas:[g]};return R.set(E,p),w.set(g,p),!0}return S.schemas.push(g),w.set(g,S),L=!0,!1}),R.clear(),!L)return JSON.stringify(M);let m="$defs";for(;M.hasOwnProperty(m);)m+="_";const u=[];function f(g){return JSON.stringify(g,(E,S)=>{if(S!==g){const p=w.get(S);if(p&&p.schemas.length>1)return p.id||(p.id=`_${u.length}`,u.push(p.schemas[0])),{$ref:`#/${m}/${p.id}`}}return S})}const v=f(M),h=[];for(let g=0;g<u.length;g++)h.push(`"_${g}":${f(u[g])}`);return h.length?`${v.substring(0,v.length-1)},"${m}":{${h.join(",")}}}`:v}function s(M){return typeof M=="object"&&M!==null}function b(M,L){if(!M||typeof M!="object")return;const R=(...v)=>{for(const h of v)s(h)&&u.push(h)},w=(...v)=>{for(const h of v)if(s(h))for(const g in h){const E=h[g];s(E)&&u.push(E)}},c=(...v)=>{for(const h of v)if(Array.isArray(h))for(const g of h)s(g)&&u.push(g)},m=v=>{if(Array.isArray(v))for(const h of v)s(h)&&u.push(h);else s(v)&&u.push(v)},u=[M];let f=u.pop();for(;f;)L(f)&&(R(f.additionalItems,f.additionalProperties,f.not,f.contains,f.propertyNames,f.if,f.then,f.else,f.unevaluatedItems,f.unevaluatedProperties),w(f.definitions,f.$defs,f.properties,f.patternProperties,f.dependencies,f.dependentSchemas),c(f.anyOf,f.allOf,f.oneOf,f.prefixItems),m(f.items)),f=u.pop()}}),function(){function V(){const e=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function n(b){return b.replace(e,function(M,L,R,w,c,m){if(w)return"";if(c){const u=c.length;return c[u-1]===`
`?c[u-2]==="\r"?`\r
`:`
`:""}else return m?M.substring(1):M})}function s(b){const M=n(b);try{return JSON.parse(M)}catch{const R=M.replace(/,\s*([}\]])/g,"$1");return JSON.parse(R)}}return{stripComments:n,parse:s}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[65],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class n{constructor(b){this.executor=b,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(b){this._error=b}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=n}),define(ce[108],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class n{static{this.Undefined=new n(void 0)}constructor(M){this.element=M,this.next=n.Undefined,this.prev=n.Undefined}}class s{constructor(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===n.Undefined}clear(){let M=this._first;for(;M!==n.Undefined;){const L=M.next;M.prev=n.Undefined,M.next=n.Undefined,M=L}this._first=n.Undefined,this._last=n.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,L){const R=new n(M);if(this._first===n.Undefined)this._first=R,this._last=R;else if(L){const c=this._last;this._last=R,R.prev=c,c.next=R}else{const c=this._first;this._first=R,R.next=c,c.prev=R}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(R))}}shift(){if(this._first!==n.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==n.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==n.Undefined&&M.next!==n.Undefined){const L=M.prev;L.next=M.next,M.next.prev=L}else M.prev===n.Undefined&&M.next===n.Undefined?(this._first=n.Undefined,this._last=n.Undefined):M.next===n.Undefined?(this._last=this._last.prev,this._last.next=n.Undefined):M.prev===n.Undefined&&(this._first=this._first.next,this._first.prev=n.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==n.Undefined;)yield M.element,M=M.next}}e.LinkedList=s}),define(ce[31],le([0,1]),function(V,e){"use strict";var n,s,b;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=M,e.mapToString=L,e.setToString=R,e.mapsStrictEqualIgnoreOrder=I;function M(i,d,t){let o=i.get(d);return o===void 0&&(o=t,i.set(d,o)),o}function L(i){const d=[];return i.forEach((t,o)=>{d.push(`${o} => ${t}`)}),`Map(${i.size}) {${d.join(", ")}}`}function R(i){const d=[];return i.forEach(t=>{d.push(t)}),`Set(${i.size}) {${d.join(", ")}}`}class w{constructor(d,t){this.uri=d,this.value=t}}function c(i){return Array.isArray(i)}class m{static{this.defaultToKey=d=>d.toString()}constructor(d,t){if(this[n]="ResourceMap",d instanceof m)this.map=new Map(d.map),this.toKey=t??m.defaultToKey;else if(c(d)){this.map=new Map,this.toKey=t??m.defaultToKey;for(const[o,r]of d)this.set(o,r)}else this.map=new Map,this.toKey=d??m.defaultToKey}set(d,t){return this.map.set(this.toKey(d),new w(d,t)),this}get(d){return this.map.get(this.toKey(d))?.value}has(d){return this.map.has(this.toKey(d))}get size(){return this.map.size}clear(){this.map.clear()}delete(d){return this.map.delete(this.toKey(d))}forEach(d,t){typeof t<"u"&&(d=d.bind(t));for(const[o,r]of this.map)d(r.value,r.uri,this)}*values(){for(const d of this.map.values())yield d.value}*keys(){for(const d of this.map.values())yield d.uri}*entries(){for(const d of this.map.values())yield[d.uri,d.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.map)yield[d.uri,d.value]}}e.ResourceMap=m;class u{constructor(d,t){this[s]="ResourceSet",!d||typeof d=="function"?this._map=new m(d):(this._map=new m(t),d.forEach(this.add,this))}get size(){return this._map.size}add(d){return this._map.set(d,d),this}clear(){this._map.clear()}delete(d){return this._map.delete(d)}forEach(d,t){this._map.forEach((o,r)=>d.call(t,r,r,this))}has(d){return this._map.has(d)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var f;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class v{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(d){return this._map.has(d)}get(d,t=f.None){const o=this._map.get(d);if(o)return t!==f.None&&this.touch(o,t),o.value}set(d,t,o=f.None){let r=this._map.get(d);if(r)r.value=t,o!==f.None&&this.touch(r,o);else{switch(r={key:d,value:t,next:void 0,previous:void 0},o){case f.None:this.addItemLast(r);break;case f.AsOld:this.addItemFirst(r);break;case f.AsNew:this.addItemLast(r);break;default:this.addItemLast(r);break}this._map.set(d,r),this._size++}return this}delete(d){return!!this.remove(d)}remove(d){const t=this._map.get(d);if(t)return this._map.delete(d),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const d=this._head;return this._map.delete(d.key),this.removeItem(d),this._size--,d.value}forEach(d,t){const o=this._state;let r=this._head;for(;r;){if(t?d.bind(t)(r.value,r.key,this):d(r.value,r.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const d=this,t=this._state;let o=this._head;const r={[Symbol.iterator](){return r},next(){if(d._state!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.key,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return r}values(){const d=this,t=this._state;let o=this._head;const r={[Symbol.iterator](){return r},next(){if(d._state!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.value,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return r}entries(){const d=this,t=this._state;let o=this._head;const r={[Symbol.iterator](){return r},next(){if(d._state!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:[o.key,o.value],done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return r}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(d){if(d>=this.size)return;if(d===0){this.clear();return}let t=this._head,o=this.size;for(;t&&o>d;)this._map.delete(t.key),t=t.next,o--;this._head=t,this._size=o,t&&(t.previous=void 0),this._state++}trimNew(d){if(d>=this.size)return;if(d===0){this.clear();return}let t=this._tail,o=this.size;for(;t&&o>d;)this._map.delete(t.key),t=t.previous,o--;this._tail=t,this._size=o,t&&(t.next=void 0),this._state++}addItemFirst(d){if(!this._head&&!this._tail)this._tail=d;else if(this._head)d.next=this._head,this._head.previous=d;else throw new Error("Invalid list");this._head=d,this._state++}addItemLast(d){if(!this._head&&!this._tail)this._head=d;else if(this._tail)d.previous=this._tail,this._tail.next=d;else throw new Error("Invalid list");this._tail=d,this._state++}removeItem(d){if(d===this._head&&d===this._tail)this._head=void 0,this._tail=void 0;else if(d===this._head){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this._head=d.next}else if(d===this._tail){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this._tail=d.previous}else{const t=d.next,o=d.previous;if(!t||!o)throw new Error("Invalid list");t.previous=o,o.next=t}d.next=void 0,d.previous=void 0,this._state++}touch(d,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==f.AsOld&&t!==f.AsNew)){if(t===f.AsOld){if(d===this._head)return;const o=d.next,r=d.previous;d===this._tail?(r.next=void 0,this._tail=r):(o.previous=r,r.next=o),d.previous=void 0,d.next=this._head,this._head.previous=d,this._head=d,this._state++}else if(t===f.AsNew){if(d===this._tail)return;const o=d.next,r=d.previous;d===this._head?(o.previous=void 0,this._head=o):(o.previous=r,r.next=o),d.next=void 0,d.previous=this._tail,this._tail.next=d,this._tail=d,this._state++}}}toJSON(){const d=[];return this.forEach((t,o)=>{d.push([o,t])}),d}fromJSON(d){this.clear();for(const[t,o]of d)this.set(t,o)}}e.LinkedMap=v;class h extends v{constructor(d,t=1){super(),this._limit=d,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(d){this._limit=d,this.checkTrim()}get ratio(){return this._ratio}set ratio(d){this._ratio=Math.min(Math.max(0,d),1),this.checkTrim()}get(d,t=f.AsNew){return super.get(d,t)}peek(d){return super.get(d,f.None)}set(d,t){return super.set(d,t,f.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class g extends h{constructor(d,t=1){super(d,t)}trim(d){this.trimOld(d)}set(d,t){return super.set(d,t),this.checkTrim(),this}}e.LRUCache=g;class E extends h{constructor(d,t=1){super(d,t)}trim(d){this.trimNew(d)}set(d,t){return this._limit<=this.size&&!this.has(d)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(d,t),this}}e.MRUCache=E;class S{constructor(){this.map=new Map}add(d){return this.map.set(d,(this.map.get(d)||0)+1),this}delete(d){let t=this.map.get(d)||0;return t===0?!1:(t--,t===0?this.map.delete(d):this.map.set(d,t),!0)}has(d){return this.map.has(d)}}e.CounterSet=S;class p{constructor(d){if(this._m1=new Map,this._m2=new Map,d)for(const[t,o]of d)this.set(t,o)}clear(){this._m1.clear(),this._m2.clear()}set(d,t){this._m1.set(d,t),this._m2.set(t,d)}get(d){return this._m1.get(d)}getKey(d){return this._m2.get(d)}delete(d){const t=this._m1.get(d);return t===void 0?!1:(this._m1.delete(d),this._m2.delete(t),!0)}forEach(d,t){this._m1.forEach((o,r)=>{d.call(t,o,r,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=p;class D{constructor(){this.map=new Map}add(d,t){let o=this.map.get(d);o||(o=new Set,this.map.set(d,o)),o.add(t)}delete(d,t){const o=this.map.get(d);o&&(o.delete(t),o.size===0&&this.map.delete(d))}forEach(d,t){const o=this.map.get(d);o&&o.forEach(t)}get(d){const t=this.map.get(d);return t||new Set}}e.SetMap=D;function I(i,d){if(i===d)return!0;if(i.size!==d.size)return!1;for(const[t,o]of i)if(!d.has(t)||d.get(t)!==o)return!1;for(const[t]of d)if(!i.has(t))return!1;return!0}}),define(ce[2],le([0,1,21,139,31,89,77]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=m,e.trackDisposable=u,e.markAsDisposed=f,e.markAsSingleton=g,e.isDisposable=E,e.dispose=S,e.disposeIfDisposable=p,e.combinedDisposable=D,e.toDisposable=I,e.disposeOnReturn=k;const R=!1;let w=null;class c{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(C){let _=this.livingDisposables.get(C);return _||(_={parent:null,source:null,isSingleton:!1,value:C,idx:c.idx++},this.livingDisposables.set(C,_)),_}trackDisposable(C){const _=this.getDisposableData(C);_.source||(_.source=new Error().stack)}setParent(C,_){const H=this.getDisposableData(C);H.parent=_}markAsDisposed(C){this.livingDisposables.delete(C)}markAsSingleton(C){this.getDisposableData(C).isSingleton=!0}getRootParent(C,_){const H=_.get(C);if(H)return H;const q=C.parent?this.getRootParent(this.getDisposableData(C.parent),_):C;return _.set(C,q),q}getTrackedDisposables(){const C=new Map;return[...this.livingDisposables.entries()].filter(([,H])=>H.source!==null&&!this.getRootParent(H,C).isSingleton).flatMap(([H])=>H)}computeLeakingDisposables(C=10,_){let H;if(_)H=_;else{const X=new Map,B=[...this.livingDisposables.values()].filter(U=>U.source!==null&&!this.getRootParent(U,X).isSingleton);if(B.length===0)return;const J=new Set(B.map(U=>U.value));if(H=B.filter(U=>!(U.parent&&J.has(U.parent))),H.length===0)throw new Error("There are cyclic diposable chains!")}if(!H)return;function q(X){function B(U,O){for(;U.length>0&&O.some(N=>typeof N=="string"?N===U[0]:U[0].match(N));)U.shift()}const J=X.source.split(`
`).map(U=>U.trim().replace("at ","")).filter(U=>U!=="");return B(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const K=new b.SetMap;for(const X of H){const B=q(X);for(let J=0;J<=B.length;J++)K.add(B.slice(0,J).join(`
`),X)}H.sort((0,n.compareBy)(X=>X.idx,n.numberComparator));let fe="",$=0;for(const X of H.slice(0,C)){$++;const B=q(X),J=[];for(let U=0;U<B.length;U++){let O=B[U];O=`(shared with ${K.get(B.slice(0,U+1).join(`
`)).size}/${H.length} leaks) at ${O}`;const Q=K.get(B.slice(0,U).join(`
`)),oe=(0,s.groupBy)([...Q].map(j=>q(j)[U]),j=>j);delete oe[B[U]];for(const[j,ue]of Object.entries(oe))J.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${j}`);J.unshift(O)}fe+=`


==================== Leaking disposable ${$}/${H.length}: ${X.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return H.length>C&&(fe+=`


... and ${H.length-C} more leaking disposables

`),{leaks:H,details:fe}}}e.DisposableTracker=c;function m(A){w=A}if(R){const A="__is_disposable_tracked__";m(new class{trackDisposable(C){const _=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[A]||console.log(_)},3e3)}setParent(C,_){if(C&&C!==d.None)try{C[A]=!0}catch{}}markAsDisposed(C){if(C&&C!==d.None)try{C[A]=!0}catch{}}markAsSingleton(C){}})}function u(A){return w?.trackDisposable(A),A}function f(A){w?.markAsDisposed(A)}function v(A,C){w?.setParent(A,C)}function h(A,C){if(w)for(const _ of A)w.setParent(_,C)}function g(A){return w?.markAsSingleton(A),A}function E(A){return typeof A=="object"&&A!==null&&typeof A.dispose=="function"&&A.dispose.length===0}function S(A){if(L.Iterable.is(A)){const C=[];for(const _ of A)if(_)try{_.dispose()}catch(H){C.push(H)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}function p(A){for(const C of A)E(C)&&C.dispose();return[]}function D(...A){const C=I(()=>S(A));return h(A,C),C}function I(A){const C=u({dispose:(0,M.createSingleCallFunction)(()=>{f(C),A()})});return C}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,u(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{S(this._toDispose)}finally{this._toDispose.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return v(C,this),this._isDisposed?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(C),C.dispose()}}deleteAndLeak(C){C&&this._toDispose.has(C)&&(this._toDispose.delete(C),v(C,null))}}e.DisposableStore=i;class d{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new i,u(this),v(this._store,this)}dispose(){f(this),this._store.dispose()}_register(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(C)}}e.Disposable=d;class t{constructor(){this._isDisposed=!1,u(this)}get value(){return this._isDisposed?void 0:this._value}set value(C){this._isDisposed||C===this._value||(this._value?.dispose(),C&&v(C,this),this._value=C)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const C=this._value;return this._value=void 0,C&&v(C,null),C}}e.MutableDisposable=t;class o{constructor(C){this._disposable=new t,this._isDisposed=!1,this._disposable.value=C}get value(){return this._disposable.value}set value(C){this._isDisposed||C===this._disposable.value||(this._disposable.value=C)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=o;class r{constructor(C){this._disposable=C,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(C){let _=C;return this.unset=()=>_=void 0,this.isset=()=>_!==void 0,this.dispose=()=>{_&&(_(),_=void 0,f(this))},this}}e.SafeDisposable=a;class l{constructor(){this.references=new Map}acquire(C,..._){let H=this.references.get(C);H||(H={counter:0,object:this.createReferencedObject(C,..._)},this.references.set(C,H));const{object:q}=H,K=(0,M.createSingleCallFunction)(()=>{--H.counter===0&&(this.destroyReferencedObject(C,H.object),this.references.delete(C))});return H.counter++,{object:q,dispose:K}}}e.ReferenceCollection=l;class P{constructor(C){this.referenceCollection=C}async acquire(C,..._){const H=this.referenceCollection.acquire(C,..._);try{return{object:await H.object,dispose:()=>H.dispose()}}catch(q){throw H.dispose(),q}}}e.AsyncReferenceCollection=P;class y{constructor(C){this.object=C}dispose(){}}e.ImmortalReference=y;function k(A){const C=new i;try{A(C)}finally{C.dispose()}}class T{constructor(){this._store=new Map,this._isDisposed=!1,u(this)}dispose(){f(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{S(this._store.values())}finally{this._store.clear()}}has(C){return this._store.has(C)}get size(){return this._store.size}get(C){return this._store.get(C)}set(C,_,H=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),H||this._store.get(C)?.dispose(),this._store.set(C,_)}deleteAndDispose(C){this._store.get(C)?.dispose(),this._store.delete(C)}deleteAndLeak(C){const _=this._store.get(C);return this._store.delete(C),_}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=T}),define(ce[90],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(s){s[s.Uri=1]="Uri",s[s.Regexp=2]="Regexp",s[s.ScmResource=3]="ScmResource",s[s.ScmResourceGroup=4]="ScmResourceGroup",s[s.ScmProvider=5]="ScmProvider",s[s.CommentController=6]="CommentController",s[s.CommentThread=7]="CommentThread",s[s.CommentThreadInstance=8]="CommentThreadInstance",s[s.CommentThreadReply=9]="CommentThreadReply",s[s.CommentNode=10]="CommentNode",s[s.CommentThreadNode=11]="CommentThreadNode",s[s.TimelineActionContext=12]="TimelineActionContext",s[s.NotebookCellActionContext=13]="NotebookCellActionContext",s[s.NotebookActionContext=14]="NotebookActionContext",s[s.TerminalContext=15]="TerminalContext",s[s.TestItemContext=16]="TestItemContext",s[s.Date=17]="Date",s[s.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(ce[78],le([0,1,31]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=b,e.normalizeNFD=L;const s=new n.LRUCache(1e4);function b(c){return w(c,"NFC",s)}const M=new n.LRUCache(1e4);function L(c){return w(c,"NFD",M)}const R=/[^\u0000-\u0080]/;function w(c,m,u){if(!c)return c;const f=u.get(c);if(f)return f;let v;return R.test(c)?v=c.normalize(m):v=c,u.set(c,v),v}e.removeAccents=function(){const c=/[\u0300-\u036f]/g;return function(m){return L(m).replace(c,"")}}()}),define(ce[144],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=n,e.rot=s,e.isPointWithinTriangle=R;function n(w,c,m){return Math.min(Math.max(w,c),m)}function s(w,c){return(c+w%c)%c}class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class M{constructor(){this._n=1,this._val=0}update(c){return this._val=this._val+(c-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class L{constructor(c){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(c),this._values.fill(0,0,c)}update(c){const m=this._values[this._index];return this._values[this._index]=c,this._index=(this._index+1)%this._values.length,this._sum-=m,this._sum+=c,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=L;function R(w,c,m,u,f,v,h,g){const E=h-m,S=g-u,p=f-m,D=v-u,I=w-m,i=c-u,d=E*E+S*S,t=E*p+S*D,o=E*I+S*i,r=p*p+D*D,a=p*I+D*i,l=1/(d*r-t*t),P=(r*o-t*a)*l,y=(d*a-t*o)*l;return P>=0&&y>=0&&P+y<1}}),function(){function V(b){const M=[];typeof b=="number"&&M.push("code/timeOrigin",b);function L(w){M.push(w,Date.now())}function R(){const w=[];for(let c=0;c<M.length;c+=2)w.push({name:M[c],startTime:M[c+1]});return w}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const L of performance.getEntriesByType("mark"))M.push({name:L.name,startTime:Math.round(b+L.startTime)});return M}};if(typeof process=="object"){const b=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function n(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var s;typeof global=="object"?s=global:typeof self=="object"?s=self:s={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(s)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(s):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),s.perf=n(s))}(),define(ce[3],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=d,e.isLittleEndian=P,e.isBigSurOrNewer=y,e.LANGUAGE_DEFAULT="en";let n=!1,s=!1,b=!1,M=!1,L=!1,R=!1,w=!1,c=!1,m=!1,u=!1,f,v=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT,g,E;const S=globalThis;let p;typeof S.vscode<"u"&&typeof S.vscode.process<"u"?p=S.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(p=process);const D=typeof p?.versions?.electron=="string",I=D&&p?.type==="renderer";if(typeof p=="object"){n=p.platform==="win32",s=p.platform==="darwin",b=p.platform==="linux",M=b&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,w=D,m=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT;const k=p.env.VSCODE_NLS_CONFIG;if(k)try{const T=JSON.parse(k);f=T.userLocale,h=T.osLocale,v=T.resolvedLanguage||e.LANGUAGE_DEFAULT,g=T.languagePack?.translationsConfigFile}catch{}L=!0}else typeof navigator=="object"&&!I?(E=navigator.userAgent,n=E.indexOf("Windows")>=0,s=E.indexOf("Macintosh")>=0,c=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,b=E.indexOf("Linux")>=0,u=E?.indexOf("Mobi")>=0,R=!0,v=globalThis._VSCODE_NLS_LANGUAGE||e.LANGUAGE_DEFAULT,f=navigator.language.toLowerCase(),h=f):console.error("Unable to resolve platform.");var i;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(i||(e.Platform=i={}));function d(k){switch(k){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let t=i.Web;s?t=i.Mac:n?t=i.Windows:b&&(t=i.Linux),e.isWindows=n,e.isMacintosh=s,e.isLinux=b,e.isLinuxSnap=M,e.isNative=L,e.isElectron=w,e.isWeb=R,e.isWebWorker=R&&typeof S.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?S.origin:void 0,e.isIOS=c,e.isMobile=u,e.isCI=m,e.platform=t,e.userAgent=E,e.language=v;var o;(function(k){function T(){return e.language}k.value=T;function A(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}k.isDefaultVariant=A;function C(){return e.language==="en"}k.isDefault=C})(o||(e.Language=o={})),e.locale=f,e.platformLocale=h,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof S.postMessage=="function"&&!S.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const k=[];S.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let C=0,_=k.length;C<_;C++){const H=k[C];if(H.id===A.data.vscodeScheduleAsyncWork){k.splice(C,1),H.callback();return}}});let T=0;return A=>{const C=++T;k.push({id:C,callback:A}),S.postMessage({vscodeScheduleAsyncWork:C},"*")}}return k=>setTimeout(k)})();var r;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=s||c?r.Macintosh:n?r.Windows:r.Linux;let a=!0,l=!1;function P(){if(!l){l=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,a=new Uint16Array(k.buffer)[0]===513}return a}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function y(k){return parseFloat(k)>=20}}),define(ce[36],le([0,1,3]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let s;const b=globalThis.vscode;if(typeof b<"u"&&typeof b.process<"u"){const M=b.process;s={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?s={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:s={get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=s.cwd,e.env=s.env,e.platform=s.platform,e.arch=s.arch});var Mt=this&&this.__createBinding||(Object.create?function(V,e,n,s){s===void 0&&(s=n);var b=Object.getOwnPropertyDescriptor(e,n);(!b||("get"in b?!e.__esModule:b.writable||b.configurable))&&(b={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(V,s,b)}:function(V,e,n,s){s===void 0&&(s=n),V[s]=e[n]}),At=this&&this.__setModuleDefault||(Object.create?function(V,e){Object.defineProperty(V,"default",{enumerable:!0,value:e})}:function(V,e){V.default=e}),De=this&&this.__importStar||function(V){if(V&&V.__esModule)return V;var e={};if(V!=null)for(var n in V)n!=="default"&&Object.prototype.hasOwnProperty.call(V,n)&&Mt(e,V,n);return At(e,V),e};define(ce[9],le([0,1,36]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,n=De(n);const s=65,b=97,M=90,L=122,R=46,w=47,c=92,m=58,u=63;class f extends Error{constructor(o,r,a){let l;typeof r=="string"&&r.indexOf("not ")===0?(l="must not be",r=r.replace(/^not /,"")):l="must be";const P=o.indexOf(".")!==-1?"property":"argument";let y=`The "${o}" ${P} ${l} of type ${r}`;y+=`. Received type ${typeof a}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,o){if(t===null||typeof t!="object")throw new f(o,"Object",t)}function h(t,o){if(typeof t!="string")throw new f(o,"string",t)}const g=n.platform==="win32";function E(t){return t===w||t===c}function S(t){return t===w}function p(t){return t>=s&&t<=M||t>=b&&t<=L}function D(t,o,r,a){let l="",P=0,y=-1,k=0,T=0;for(let A=0;A<=t.length;++A){if(A<t.length)T=t.charCodeAt(A);else{if(a(T))break;T=w}if(a(T)){if(!(y===A-1||k===1))if(k===2){if(l.length<2||P!==2||l.charCodeAt(l.length-1)!==R||l.charCodeAt(l.length-2)!==R){if(l.length>2){const C=l.lastIndexOf(r);C===-1?(l="",P=0):(l=l.slice(0,C),P=l.length-1-l.lastIndexOf(r)),y=A,k=0;continue}else if(l.length!==0){l="",P=0,y=A,k=0;continue}}o&&(l+=l.length>0?`${r}..`:"..",P=2)}else l.length>0?l+=`${r}${t.slice(y+1,A)}`:l=t.slice(y+1,A),P=A-y-1;y=A,k=0}else T===R&&k!==-1?++k:k=-1}return l}function I(t){return t?`${t[0]==="."?"":"."}${t}`:""}function i(t,o){v(o,"pathObject");const r=o.dir||o.root,a=o.base||`${o.name||""}${I(o.ext)}`;return r?r===o.root?`${r}${a}`:`${r}${t}${a}`:a}e.win32={resolve(...t){let o="",r="",a=!1;for(let l=t.length-1;l>=-1;l--){let P;if(l>=0){if(P=t[l],h(P,`paths[${l}]`),P.length===0)continue}else o.length===0?P=n.cwd():(P=n.env[`=${o}`]||n.cwd(),(P===void 0||P.slice(0,2).toLowerCase()!==o.toLowerCase()&&P.charCodeAt(2)===c)&&(P=`${o}\\`));const y=P.length;let k=0,T="",A=!1;const C=P.charCodeAt(0);if(y===1)E(C)&&(k=1,A=!0);else if(E(C))if(A=!0,E(P.charCodeAt(1))){let _=2,H=_;for(;_<y&&!E(P.charCodeAt(_));)_++;if(_<y&&_!==H){const q=P.slice(H,_);for(H=_;_<y&&E(P.charCodeAt(_));)_++;if(_<y&&_!==H){for(H=_;_<y&&!E(P.charCodeAt(_));)_++;(_===y||_!==H)&&(T=`\\\\${q}\\${P.slice(H,_)}`,k=_)}}}else k=1;else p(C)&&P.charCodeAt(1)===m&&(T=P.slice(0,2),k=2,y>2&&E(P.charCodeAt(2))&&(A=!0,k=3));if(T.length>0)if(o.length>0){if(T.toLowerCase()!==o.toLowerCase())continue}else o=T;if(a){if(o.length>0)break}else if(r=`${P.slice(k)}\\${r}`,a=A,A&&o.length>0)break}return r=D(r,!a,"\\",E),a?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){h(t,"path");const o=t.length;if(o===0)return".";let r=0,a,l=!1;const P=t.charCodeAt(0);if(o===1)return S(P)?"\\":t;if(E(P))if(l=!0,E(t.charCodeAt(1))){let k=2,T=k;for(;k<o&&!E(t.charCodeAt(k));)k++;if(k<o&&k!==T){const A=t.slice(T,k);for(T=k;k<o&&E(t.charCodeAt(k));)k++;if(k<o&&k!==T){for(T=k;k<o&&!E(t.charCodeAt(k));)k++;if(k===o)return`\\\\${A}\\${t.slice(T)}\\`;k!==T&&(a=`\\\\${A}\\${t.slice(T,k)}`,r=k)}}}else r=1;else p(P)&&t.charCodeAt(1)===m&&(a=t.slice(0,2),r=2,o>2&&E(t.charCodeAt(2))&&(l=!0,r=3));let y=r<o?D(t.slice(r),!l,"\\",E):"";return y.length===0&&!l&&(y="."),y.length>0&&E(t.charCodeAt(o-1))&&(y+="\\"),a===void 0?l?`\\${y}`:y:l?`${a}\\${y}`:`${a}${y}`},isAbsolute(t){h(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return E(r)||o>2&&p(r)&&t.charCodeAt(1)===m&&E(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let P=0;P<t.length;++P){const y=t[P];h(y,"path"),y.length>0&&(o===void 0?o=r=y:o+=`\\${y}`)}if(o===void 0)return".";let a=!0,l=0;if(typeof r=="string"&&E(r.charCodeAt(0))){++l;const P=r.length;P>1&&E(r.charCodeAt(1))&&(++l,P>2&&(E(r.charCodeAt(2))?++l:a=!1))}if(a){for(;l<o.length&&E(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.win32.normalize(o)},relative(t,o){if(h(t,"from"),h(o,"to"),t===o)return"";const r=e.win32.resolve(t),a=e.win32.resolve(o);if(r===a||(t=r.toLowerCase(),o=a.toLowerCase(),t===o))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===c;)l++;let P=t.length;for(;P-1>l&&t.charCodeAt(P-1)===c;)P--;const y=P-l;let k=0;for(;k<o.length&&o.charCodeAt(k)===c;)k++;let T=o.length;for(;T-1>k&&o.charCodeAt(T-1)===c;)T--;const A=T-k,C=y<A?y:A;let _=-1,H=0;for(;H<C;H++){const K=t.charCodeAt(l+H);if(K!==o.charCodeAt(k+H))break;K===c&&(_=H)}if(H!==C){if(_===-1)return a}else{if(A>C){if(o.charCodeAt(k+H)===c)return a.slice(k+H+1);if(H===2)return a.slice(k+H)}y>C&&(t.charCodeAt(l+H)===c?_=H:H===2&&(_=3)),_===-1&&(_=0)}let q="";for(H=l+_+1;H<=P;++H)(H===P||t.charCodeAt(H)===c)&&(q+=q.length===0?"..":"\\..");return k+=_,q.length>0?`${q}${a.slice(k,T)}`:(a.charCodeAt(k)===c&&++k,a.slice(k,T))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const r=o.charCodeAt(2);if(r!==u&&r!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(p(o.charCodeAt(0))&&o.charCodeAt(1)===m&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){h(t,"path");const o=t.length;if(o===0)return".";let r=-1,a=0;const l=t.charCodeAt(0);if(o===1)return E(l)?t:".";if(E(l)){if(r=a=1,E(t.charCodeAt(1))){let k=2,T=k;for(;k<o&&!E(t.charCodeAt(k));)k++;if(k<o&&k!==T){for(T=k;k<o&&E(t.charCodeAt(k));)k++;if(k<o&&k!==T){for(T=k;k<o&&!E(t.charCodeAt(k));)k++;if(k===o)return t;k!==T&&(r=a=k+1)}}}}else p(l)&&t.charCodeAt(1)===m&&(r=o>2&&E(t.charCodeAt(2))?3:2,a=r);let P=-1,y=!0;for(let k=o-1;k>=a;--k)if(E(t.charCodeAt(k))){if(!y){P=k;break}}else y=!1;if(P===-1){if(r===-1)return".";P=r}return t.slice(0,P)},basename(t,o){o!==void 0&&h(o,"suffix"),h(t,"path");let r=0,a=-1,l=!0,P;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let y=o.length-1,k=-1;for(P=t.length-1;P>=r;--P){const T=t.charCodeAt(P);if(E(T)){if(!l){r=P+1;break}}else k===-1&&(l=!1,k=P+1),y>=0&&(T===o.charCodeAt(y)?--y===-1&&(a=P):(y=-1,a=k))}return r===a?a=k:a===-1&&(a=t.length),t.slice(r,a)}for(P=t.length-1;P>=r;--P)if(E(t.charCodeAt(P))){if(!l){r=P+1;break}}else a===-1&&(l=!1,a=P+1);return a===-1?"":t.slice(r,a)},extname(t){h(t,"path");let o=0,r=-1,a=0,l=-1,P=!0,y=0;t.length>=2&&t.charCodeAt(1)===m&&p(t.charCodeAt(0))&&(o=a=2);for(let k=t.length-1;k>=o;--k){const T=t.charCodeAt(k);if(E(T)){if(!P){a=k+1;break}continue}l===-1&&(P=!1,l=k+1),T===R?r===-1?r=k:y!==1&&(y=1):r!==-1&&(y=-1)}return r===-1||l===-1||y===0||y===1&&r===l-1&&r===a+1?"":t.slice(r,l)},format:i.bind(null,"\\"),parse(t){h(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let a=0,l=t.charCodeAt(0);if(r===1)return E(l)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(E(l)){if(a=1,E(t.charCodeAt(1))){let _=2,H=_;for(;_<r&&!E(t.charCodeAt(_));)_++;if(_<r&&_!==H){for(H=_;_<r&&E(t.charCodeAt(_));)_++;if(_<r&&_!==H){for(H=_;_<r&&!E(t.charCodeAt(_));)_++;_===r?a=_:_!==H&&(a=_+1)}}}}else if(p(l)&&t.charCodeAt(1)===m){if(r<=2)return o.root=o.dir=t,o;if(a=2,E(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;a=3}}a>0&&(o.root=t.slice(0,a));let P=-1,y=a,k=-1,T=!0,A=t.length-1,C=0;for(;A>=a;--A){if(l=t.charCodeAt(A),E(l)){if(!T){y=A+1;break}continue}k===-1&&(T=!1,k=A+1),l===R?P===-1?P=A:C!==1&&(C=1):P!==-1&&(C=-1)}return k!==-1&&(P===-1||C===0||C===1&&P===k-1&&P===y+1?o.base=o.name=t.slice(y,k):(o.name=t.slice(y,P),o.base=t.slice(y,k),o.ext=t.slice(P,k))),y>0&&y!==a?o.dir=t.slice(0,y-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(g){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.posix={resolve(...t){let o="",r=!1;for(let a=t.length-1;a>=-1&&!r;a--){const l=a>=0?t[a]:d();h(l,`paths[${a}]`),l.length!==0&&(o=`${l}/${o}`,r=l.charCodeAt(0)===w)}return o=D(o,!r,"/",S),r?`/${o}`:o.length>0?o:"."},normalize(t){if(h(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===w,r=t.charCodeAt(t.length-1)===w;return t=D(t,!o,"/",S),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return h(t,"path"),t.length>0&&t.charCodeAt(0)===w},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const a=t[r];h(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(h(t,"from"),h(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const r=1,a=t.length,l=a-r,P=1,y=o.length-P,k=l<y?l:y;let T=-1,A=0;for(;A<k;A++){const _=t.charCodeAt(r+A);if(_!==o.charCodeAt(P+A))break;_===w&&(T=A)}if(A===k)if(y>k){if(o.charCodeAt(P+A)===w)return o.slice(P+A+1);if(A===0)return o.slice(P+A)}else l>k&&(t.charCodeAt(r+A)===w?T=A:A===0&&(T=0));let C="";for(A=r+T+1;A<=a;++A)(A===a||t.charCodeAt(A)===w)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(P+T)}`},toNamespacedPath(t){return t},dirname(t){if(h(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===w;let r=-1,a=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===w){if(!a){r=l;break}}else a=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&h(o,"ext"),h(t,"path");let r=0,a=-1,l=!0,P;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let y=o.length-1,k=-1;for(P=t.length-1;P>=0;--P){const T=t.charCodeAt(P);if(T===w){if(!l){r=P+1;break}}else k===-1&&(l=!1,k=P+1),y>=0&&(T===o.charCodeAt(y)?--y===-1&&(a=P):(y=-1,a=k))}return r===a?a=k:a===-1&&(a=t.length),t.slice(r,a)}for(P=t.length-1;P>=0;--P)if(t.charCodeAt(P)===w){if(!l){r=P+1;break}}else a===-1&&(l=!1,a=P+1);return a===-1?"":t.slice(r,a)},extname(t){h(t,"path");let o=-1,r=0,a=-1,l=!0,P=0;for(let y=t.length-1;y>=0;--y){const k=t.charCodeAt(y);if(k===w){if(!l){r=y+1;break}continue}a===-1&&(l=!1,a=y+1),k===R?o===-1?o=y:P!==1&&(P=1):o!==-1&&(P=-1)}return o===-1||a===-1||P===0||P===1&&o===a-1&&o===r+1?"":t.slice(o,a)},format:i.bind(null,"/"),parse(t){h(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===w;let a;r?(o.root="/",a=1):a=0;let l=-1,P=0,y=-1,k=!0,T=t.length-1,A=0;for(;T>=a;--T){const C=t.charCodeAt(T);if(C===w){if(!k){P=T+1;break}continue}y===-1&&(k=!1,y=T+1),C===R?l===-1?l=T:A!==1&&(A=1):l!==-1&&(A=-1)}if(y!==-1){const C=P===0&&r?1:P;l===-1||A===0||A===1&&l===y-1&&l===P+1?o.base=o.name=t.slice(C,y):(o.name=t.slice(C,l),o.base=t.slice(C,y),o.ext=t.slice(l,y))}return P>0?o.dir=t.slice(0,P-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g?e.win32.normalize:e.posix.normalize,e.isAbsolute=g?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g?e.win32.join:e.posix.join,e.resolve=g?e.win32.resolve:e.posix.resolve,e.relative=g?e.win32.relative:e.posix.relative,e.dirname=g?e.win32.dirname:e.posix.dirname,e.basename=g?e.win32.basename:e.posix.basename,e.extname=g?e.win32.extname:e.posix.extname,e.format=g?e.win32.format:e.posix.format,e.parse=g?e.win32.parse:e.posix.parse,e.toNamespacedPath=g?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g?e.win32.sep:e.posix.sep,e.delimiter=g?e.win32.delimiter:e.posix.delimiter}),define(ce[79],le([0,1,3]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=M,e.removeDangerousEnvVariables=L;var s;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(s||(e.Source=s={}));var b;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(b||(e.TerminateResponseCode=b={}));function M(R,...w){const c=w.reduce((f,v)=>(f[v]=!0,f),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(f=>!c[f]).forEach(f=>{for(let v=0;v<m.length;v++)if(f.search(m[v])!==-1){delete R[f];break}})}function L(R){R&&(delete R.DEBUG,n.isLinux&&delete R.LD_PRELOAD)}}),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var s in n)(typeof exports=="object"?exports:V)[s]=n[s]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function n(s){if(e[s])return e[s].exports;var b=e[s]={i:s,l:!1,exports:{}};return V[s].call(b.exports,b,b.exports,n),b.l=!0,b.exports}return n.m=V,n.c=e,n.d=function(s,b,M){n.o(s,b)||Object.defineProperty(s,b,{enumerable:!0,get:M})},n.r=function(s){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(s,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(s,"__esModule",{value:!0})},n.t=function(s,b){if(1&b&&(s=n(s)),8&b||4&b&&typeof s=="object"&&s&&s.__esModule)return s;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:s}),2&b&&typeof s!="string")for(var L in s)n.d(M,L,function(R){return s[R]}.bind(null,L));return M},n.n=function(s){var b=s&&s.__esModule?function(){return s.default}:function(){return s};return n.d(b,"a",b),b},n.o=function(s,b){return Object.prototype.hasOwnProperty.call(s,b)},n.p="",n(n.s=0)}([function(V,e,n){(function(s){var b;e=V.exports=ue,b=typeof s=="object"&&s.env&&s.env.NODE_DEBUG&&/\bsemver\b/i.test(s.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],w=e.src=[],c=0,m=c++;w[m]="0|[1-9]\\d*";var u=c++;w[u]="[0-9]+";var f=c++;w[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=c++;w[v]="("+w[m]+")\\.("+w[m]+")\\.("+w[m]+")";var h=c++;w[h]="("+w[u]+")\\.("+w[u]+")\\.("+w[u]+")";var g=c++;w[g]="(?:"+w[m]+"|"+w[f]+")";var E=c++;w[E]="(?:"+w[u]+"|"+w[f]+")";var S=c++;w[S]="(?:-("+w[g]+"(?:\\."+w[g]+")*))";var p=c++;w[p]="(?:-?("+w[E]+"(?:\\."+w[E]+")*))";var D=c++;w[D]="[0-9A-Za-z-]+";var I=c++;w[I]="(?:\\+("+w[D]+"(?:\\."+w[D]+")*))";var i=c++,d="v?"+w[v]+w[S]+"?"+w[I]+"?";w[i]="^"+d+"$";var t="[v=\\s]*"+w[h]+w[p]+"?"+w[I]+"?",o=c++;w[o]="^"+t+"$";var r=c++;w[r]="((?:<|>)?=?)";var a=c++;w[a]=w[u]+"|x|X|\\*";var l=c++;w[l]=w[m]+"|x|X|\\*";var P=c++;w[P]="[v=\\s]*("+w[l]+")(?:\\.("+w[l]+")(?:\\.("+w[l]+")(?:"+w[S]+")?"+w[I]+"?)?)?";var y=c++;w[y]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[p]+")?"+w[I]+"?)?)?";var k=c++;w[k]="^"+w[r]+"\\s*"+w[P]+"$";var T=c++;w[T]="^"+w[r]+"\\s*"+w[y]+"$";var A=c++;w[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=c++;w[C]="(?:~>?)";var _=c++;w[_]="(\\s*)"+w[C]+"\\s+",R[_]=new RegExp(w[_],"g");var H=c++;w[H]="^"+w[C]+w[P]+"$";var q=c++;w[q]="^"+w[C]+w[y]+"$";var K=c++;w[K]="(?:\\^)";var fe=c++;w[fe]="(\\s*)"+w[K]+"\\s+",R[fe]=new RegExp(w[fe],"g");var $=c++;w[$]="^"+w[K]+w[P]+"$";var X=c++;w[X]="^"+w[K]+w[y]+"$";var B=c++;w[B]="^"+w[r]+"\\s*("+t+")$|^$";var J=c++;w[J]="^"+w[r]+"\\s*("+d+")$|^$";var U=c++;w[U]="(\\s*)"+w[r]+"\\s*("+t+"|"+w[P]+")",R[U]=new RegExp(w[U],"g");var O=c++;w[O]="^\\s*("+w[P]+")\\s+-\\s+("+w[P]+")\\s*$";var N=c++;w[N]="^\\s*("+w[y]+")\\s+-\\s+("+w[y]+")\\s*$";var Q=c++;w[Q]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)b(oe,w[oe]),R[oe]||(R[oe]=new RegExp(w[oe]));function j(ee,ae){if(ee instanceof ue)return ee;if(typeof ee!="string"||ee.length>M||!(ae?R[o]:R[i]).test(ee))return null;try{return new ue(ee,ae)}catch{return null}}function ue(ee,ae){if(ee instanceof ue){if(ee.loose===ae)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ue))return new ue(ee,ae);b("SemVer",ee,ae),this.loose=ae;var he=ee.trim().match(ae?R[o]:R[i]);if(!he)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Me=+Se;if(Me>=0&&Me<L)return Me}return Se}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=j,e.valid=function(ee,ae){var he=j(ee,ae);return he?he.version:null},e.clean=function(ee,ae){var he=j(ee.trim().replace(/^[=v]+/,""),ae);return he?he.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(ee){return b("SemVer.compare",this.version,this.loose,ee),ee instanceof ue||(ee=new ue(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},ue.prototype.compareMain=function(ee){return ee instanceof ue||(ee=new ue(ee,this.loose)),Y(this.major,ee.major)||Y(this.minor,ee.minor)||Y(this.patch,ee.patch)},ue.prototype.comparePre=function(ee){if(ee instanceof ue||(ee=new ue(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ae=0;do{var he=this.prerelease[ae],Se=ee.prerelease[ae];if(b("prerelease compare",ae,he,Se),he===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(he===void 0)return-1;if(he!==Se)return Y(he,Se)}while(++ae)},ue.prototype.inc=function(ee,ae){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ae,he,Se){typeof he=="string"&&(Se=he,he=void 0);try{return new ue(ee,he).inc(ae,Se).version}catch{return null}},e.diff=function(ee,ae){if(z(ee,ae))return null;var he=j(ee),Se=j(ae);if(he.prerelease.length||Se.prerelease.length){for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==Se[Me])return"pre"+Me;return"prerelease"}for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==Se[Me])return Me},e.compareIdentifiers=Y;var se=/^[0-9]+$/;function Y(ee,ae){var he=se.test(ee),Se=se.test(ae);return he&&Se&&(ee=+ee,ae=+ae),he&&!Se?-1:Se&&!he?1:ee<ae?-1:ee>ae?1:0}function W(ee,ae,he){return new ue(ee,he).compare(new ue(ae,he))}function F(ee,ae,he){return W(ee,ae,he)>0}function Z(ee,ae,he){return W(ee,ae,he)<0}function z(ee,ae,he){return W(ee,ae,he)===0}function ie(ee,ae,he){return W(ee,ae,he)!==0}function G(ee,ae,he){return W(ee,ae,he)>=0}function x(ee,ae,he){return W(ee,ae,he)<=0}function te(ee,ae,he,Se){var Me;switch(ae){case"===":typeof ee=="object"&&(ee=ee.version),typeof he=="object"&&(he=he.version),Me=ee===he;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof he=="object"&&(he=he.version),Me=ee!==he;break;case"":case"=":case"==":Me=z(ee,he,Se);break;case"!=":Me=ie(ee,he,Se);break;case">":Me=F(ee,he,Se);break;case">=":Me=G(ee,he,Se);break;case"<":Me=Z(ee,he,Se);break;case"<=":Me=x(ee,he,Se);break;default:throw new TypeError("Invalid operator: "+ae)}return Me}function de(ee,ae){if(ee instanceof de){if(ee.loose===ae)return ee;ee=ee.value}if(!(this instanceof de))return new de(ee,ae);b("comparator",ee,ae),this.loose=ae,this.parse(ee),this.semver===me?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(ee,ae){return Y(ae,ee)},e.major=function(ee,ae){return new ue(ee,ae).major},e.minor=function(ee,ae){return new ue(ee,ae).minor},e.patch=function(ee,ae){return new ue(ee,ae).patch},e.compare=W,e.compareLoose=function(ee,ae){return W(ee,ae,!0)},e.rcompare=function(ee,ae,he){return W(ae,ee,he)},e.sort=function(ee,ae){return ee.sort(function(he,Se){return e.compare(he,Se,ae)})},e.rsort=function(ee,ae){return ee.sort(function(he,Se){return e.rcompare(he,Se,ae)})},e.gt=F,e.lt=Z,e.eq=z,e.neq=ie,e.gte=G,e.lte=x,e.cmp=te,e.Comparator=de;var me={};function we(ee,ae){if(ee instanceof we)return ee.loose===ae?ee:new we(ee.raw,ae);if(ee instanceof de)return new we(ee.value,ae);if(!(this instanceof we))return new we(ee,ae);if(this.loose=ae,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Re(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Ne(ee,ae,he,Se,Me,We,_e,Ae,xe,Ge,Je,qe,Qe){return((ae=Re(he)?"":Re(Se)?">="+he+".0.0":Re(Me)?">="+he+"."+Se+".0":">="+ae)+" "+(Ae=Re(xe)?"":Re(Ge)?"<"+(+xe+1)+".0.0":Re(Je)?"<"+xe+"."+(+Ge+1)+".0":qe?"<="+xe+"."+Ge+"."+Je+"-"+qe:"<="+Ae)).trim()}function ke(ee,ae){for(var he=0;he<ee.length;he++)if(!ee[he].test(ae))return!1;if(ae.prerelease.length){for(he=0;he<ee.length;he++)if(b(ee[he].semver),ee[he].semver!==me&&ee[he].semver.prerelease.length>0){var Se=ee[he].semver;if(Se.major===ae.major&&Se.minor===ae.minor&&Se.patch===ae.patch)return!0}return!1}return!0}function Ee(ee,ae,he){try{ae=new we(ae,he)}catch{return!1}return ae.test(ee)}function pe(ee,ae,he,Se){var Me,We,_e,Ae,xe;switch(ee=new ue(ee,Se),ae=new we(ae,Se),he){case">":Me=F,We=x,_e=Z,Ae=">",xe=">=";break;case"<":Me=Z,We=G,_e=F,Ae="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(ee,ae,Se))return!1;for(var Ge=0;Ge<ae.set.length;++Ge){var Je=ae.set[Ge],qe=null,Qe=null;if(Je.forEach(function(Ye){Ye.semver===me&&(Ye=new de(">=0.0.0")),qe=qe||Ye,Qe=Qe||Ye,Me(Ye.semver,qe.semver,Se)?qe=Ye:_e(Ye.semver,Qe.semver,Se)&&(Qe=Ye)}),qe.operator===Ae||qe.operator===xe||(!Qe.operator||Qe.operator===Ae)&&We(ee,Qe.semver)||Qe.operator===xe&&_e(ee,Qe.semver))return!1}return!0}de.prototype.parse=function(ee){var ae=this.loose?R[B]:R[J],he=ee.match(ae);if(!he)throw new TypeError("Invalid comparator: "+ee);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new ue(he[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(ee){return b("Comparator.test",ee,this.loose),this.semver===me||(typeof ee=="string"&&(ee=new ue(ee,this.loose)),te(ee,this.operator,this.semver,this.loose))},de.prototype.intersects=function(ee,ae){if(!(ee instanceof de))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new we(ee.value,ae),Ee(this.value,he,ae);if(ee.operator==="")return he=new we(this.value,ae),Ee(ee.semver,he,ae);var Se=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),We=this.semver.version===ee.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Ae=te(this.semver,"<",ee.semver,ae)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),xe=te(this.semver,">",ee.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Se||Me||We&&_e||Ae||xe},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(ee){var ae=this.loose;ee=ee.trim(),b("range",ee,ae);var he=ae?R[N]:R[O];ee=ee.replace(he,Ne),b("hyphen replace",ee),ee=ee.replace(R[U],"$1$2$3"),b("comparator trim",ee,R[U]),ee=(ee=(ee=ee.replace(R[_],"$1~")).replace(R[fe],"$1^")).split(/\s+/).join(" ");var Se=ae?R[B]:R[J],Me=ee.split(" ").map(function(We){return function(_e,Ae){return b("comp",_e),_e=function(xe,Ge){return xe.trim().split(/\s+/).map(function(Je){return function(qe,Qe){b("caret",qe,Qe);var Ye=Qe?R[X]:R[$];return qe.replace(Ye,function(Xe,Ue,ne,ge,ve){var ye;return b("caret",qe,Xe,Ue,ne,ge,ve),Re(Ue)?ye="":Re(ne)?ye=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":Re(ge)?ye=Ue==="0"?">="+Ue+"."+ne+".0 <"+Ue+"."+(+ne+1)+".0":">="+Ue+"."+ne+".0 <"+(+Ue+1)+".0.0":ve?(b("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ye=Ue==="0"?ne==="0"?">="+Ue+"."+ne+"."+ge+ve+" <"+Ue+"."+ne+"."+(+ge+1):">="+Ue+"."+ne+"."+ge+ve+" <"+Ue+"."+(+ne+1)+".0":">="+Ue+"."+ne+"."+ge+ve+" <"+(+Ue+1)+".0.0"):(b("no pr"),ye=Ue==="0"?ne==="0"?">="+Ue+"."+ne+"."+ge+" <"+Ue+"."+ne+"."+(+ge+1):">="+Ue+"."+ne+"."+ge+" <"+Ue+"."+(+ne+1)+".0":">="+Ue+"."+ne+"."+ge+" <"+(+Ue+1)+".0.0"),b("caret return",ye),ye})}(Je,Ge)}).join(" ")}(_e,Ae),b("caret",_e),_e=function(xe,Ge){return xe.trim().split(/\s+/).map(function(Je){return function(qe,Qe){var Ye=Qe?R[q]:R[H];return qe.replace(Ye,function(Xe,Ue,ne,ge,ve){var ye;return b("tilde",qe,Xe,Ue,ne,ge,ve),Re(Ue)?ye="":Re(ne)?ye=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":Re(ge)?ye=">="+Ue+"."+ne+".0 <"+Ue+"."+(+ne+1)+".0":ve?(b("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ye=">="+Ue+"."+ne+"."+ge+ve+" <"+Ue+"."+(+ne+1)+".0"):ye=">="+Ue+"."+ne+"."+ge+" <"+Ue+"."+(+ne+1)+".0",b("tilde return",ye),ye})}(Je,Ge)}).join(" ")}(_e,Ae),b("tildes",_e),_e=function(xe,Ge){return b("replaceXRanges",xe,Ge),xe.split(/\s+/).map(function(Je){return function(qe,Qe){qe=qe.trim();var Ye=Qe?R[T]:R[k];return qe.replace(Ye,function(Xe,Ue,ne,ge,ve,ye){b("xRange",qe,Xe,Ue,ne,ge,ve,ye);var Oe=Re(ne),Be=Oe||Re(ge),Ze=Be||Re(ve);return Ue==="="&&Ze&&(Ue=""),Oe?Xe=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&Ze?(Be&&(ge=0),Ze&&(ve=0),Ue===">"?(Ue=">=",Be?(ne=+ne+1,ge=0,ve=0):Ze&&(ge=+ge+1,ve=0)):Ue==="<="&&(Ue="<",Be?ne=+ne+1:ge=+ge+1),Xe=Ue+ne+"."+ge+"."+ve):Be?Xe=">="+ne+".0.0 <"+(+ne+1)+".0.0":Ze&&(Xe=">="+ne+"."+ge+".0 <"+ne+"."+(+ge+1)+".0"),b("xRange return",Xe),Xe})}(Je,Ge)}).join(" ")}(_e,Ae),b("xrange",_e),_e=function(xe,Ge){return b("replaceStars",xe,Ge),xe.trim().replace(R[Q],"")}(_e,Ae),b("stars",_e),_e}(We,ae)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(We){return!!We.match(Se)})),Me=Me.map(function(We){return new de(We,ae)})},we.prototype.intersects=function(ee,ae){if(!(ee instanceof we))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Se){return ee.set.some(function(Me){return Me.every(function(We){return Se.intersects(We,ae)})})})})},e.toComparators=function(ee,ae){return new we(ee,ae).set.map(function(he){return he.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},we.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new ue(ee,this.loose));for(var ae=0;ae<this.set.length;ae++)if(ke(this.set[ae],ee))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(ee,ae,he){var Se=null,Me=null;try{var We=new we(ae,he)}catch{return null}return ee.forEach(function(_e){We.test(_e)&&(Se&&Me.compare(_e)!==-1||(Me=new ue(Se=_e,he)))}),Se},e.minSatisfying=function(ee,ae,he){var Se=null,Me=null;try{var We=new we(ae,he)}catch{return null}return ee.forEach(function(_e){We.test(_e)&&(Se&&Me.compare(_e)!==1||(Me=new ue(Se=_e,he)))}),Se},e.validRange=function(ee,ae){try{return new we(ee,ae).range||"*"}catch{return null}},e.ltr=function(ee,ae,he){return pe(ee,ae,"<",he)},e.gtr=function(ee,ae,he){return pe(ee,ae,">",he)},e.outside=pe,e.prerelease=function(ee,ae){var he=j(ee,ae);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(ee,ae,he){return ee=new we(ee,he),ae=new we(ae,he),ee.intersects(ae)},e.coerce=function(ee){if(ee instanceof ue)return ee;if(typeof ee!="string")return null;var ae=ee.match(R[A]);return ae==null?null:j((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,n(1))},function(V,e){var n,s,b=V.exports={};function M(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(E){if(n===setTimeout)return setTimeout(E,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(E,0);try{return n(E,0)}catch{try{return n.call(null,E,0)}catch{return n.call(this,E,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{s=typeof clearTimeout=="function"?clearTimeout:L}catch{s=L}})();var w,c=[],m=!1,u=-1;function f(){m&&w&&(m=!1,w.length?c=w.concat(c):u=-1,c.length&&v())}function v(){if(!m){var E=R(f);m=!0;for(var S=c.length;S;){for(w=c,c=[];++u<S;)w&&w[u].run();u=-1,S=c.length}w=null,m=!1,function(p){if(s===clearTimeout)return clearTimeout(p);if((s===L||!s)&&clearTimeout)return s=clearTimeout,clearTimeout(p);try{s(p)}catch{try{return s.call(null,p)}catch{return s.call(this,p)}}}(E)}}function h(E,S){this.fun=E,this.array=S}function g(){}b.nextTick=function(E){var S=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)S[p-1]=arguments[p];c.push(new h(E,S)),c.length!==1||m||R(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=g,b.addListener=g,b.once=g,b.off=g,b.removeListener=g,b.removeAllListeners=g,b.emit=g,b.prependListener=g,b.prependOnceListener=g,b.listeners=function(E){return[]},b.binding=function(E){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(E){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(ce[145],le([0,1]),function(V,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class s{constructor(R,w,c){this.level=R,this.key=w,this.value=c,this.forward=[]}}const b=void 0;class M{constructor(R,w=2**16){this.comparator=R,this[n]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(w)|0),this._header=new s(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new s(this._maxLevel,b,b),this._size=0}has(R){return!!M._search(this,R,this.comparator)}get(R){return M._search(this,R,this.comparator)?.value}set(R,w){return M._insert(this,R,w,this.comparator)&&(this._size+=1),this}delete(R){const w=M._delete(this,R,this.comparator);return w&&(this._size-=1),w}forEach(R,w){let c=this._header.forward[0];for(;c;)R.call(w,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",w=this._header.forward[0];for(;w;)R+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return R}static _search(R,w,c){let m=R._header;for(let u=R._level-1;u>=0;u--)for(;m.forward[u]&&c(m.forward[u].key,w)<0;)m=m.forward[u];if(m=m.forward[0],m&&c(m.key,w)===0)return m}static _insert(R,w,c,m){const u=[];let f=R._header;for(let v=R._level-1;v>=0;v--){for(;f.forward[v]&&m(f.forward[v].key,w)<0;)f=f.forward[v];u[v]=f}if(f=f.forward[0],f&&m(f.key,w)===0)return f.value=c,!1;{const v=M._randomLevel(R);if(v>R._level){for(let h=R._level;h<v;h++)u[h]=R._header;R._level=v}f=new s(v,w,c);for(let h=0;h<v;h++)f.forward[h]=u[h].forward[h],u[h].forward[h]=f;return!0}}static _randomLevel(R,w=.5){let c=1;for(;Math.random()<w&&c<R._maxLevel;)c+=1;return c}static _delete(R,w,c){const m=[];let u=R._header;for(let f=R._level-1;f>=0;f--){for(;u.forward[f]&&c(u.forward[f].key,w)<0;)u=u.forward[f];m[f]=u}if(u=u.forward[0],!u||c(u.key,w)!==0)return!1;for(let f=0;f<R._level&&m[f].forward[f]===u;f++)m[f].forward[f]=u.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===b;)R._level-=1;return!0}}e.SkipList=M}),define(ce[66],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class s{static create(M){return new s(M)}constructor(M){this._now=n&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=s}),define(ce[4],le([0,1,15,89,2,108,66]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=v;const R=!1,w=!1,c=!1;var m;(function(q){q.None=()=>b.Disposable.None;function K(ke){if(c){const{onDidAddListener:Ee}=ke,pe=g.create();let ee=0;ke.onDidAddListener=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),pe.print()),Ee?.()}}}function fe(ke,Ee){return j(ke,()=>{},0,void 0,!0,void 0,Ee)}q.defer=fe;function $(ke){return(Ee,pe=null,ee)=>{let ae=!1,he;return he=ke(Se=>{if(!ae)return he?he.dispose():ae=!0,Ee.call(pe,Se)},null,ee),ae&&he.dispose(),he}}q.once=$;function X(ke,Ee,pe){return Q((ee,ae=null,he)=>ke(Se=>ee.call(ae,Ee(Se)),null,he),pe)}q.map=X;function B(ke,Ee,pe){return Q((ee,ae=null,he)=>ke(Se=>{Ee(Se),ee.call(ae,Se)},null,he),pe)}q.forEach=B;function J(ke,Ee,pe){return Q((ee,ae=null,he)=>ke(Se=>Ee(Se)&&ee.call(ae,Se),null,he),pe)}q.filter=J;function U(ke){return ke}q.signal=U;function O(...ke){return(Ee,pe=null,ee)=>{const ae=(0,b.combinedDisposable)(...ke.map(he=>he(Se=>Ee.call(pe,Se))));return oe(ae,ee)}}q.any=O;function N(ke,Ee,pe,ee){let ae=pe;return X(ke,he=>(ae=Ee(ae,he),ae),ee)}q.reduce=N;function Q(ke,Ee){let pe;const ee={onWillAddFirstListener(){pe=ke(ae.fire,ae)},onDidRemoveLastListener(){pe?.dispose()}};Ee||K(ee);const ae=new t(ee);return Ee?.add(ae),ae.event}function oe(ke,Ee){return Ee instanceof Array?Ee.push(ke):Ee&&Ee.add(ke),ke}function j(ke,Ee,pe=100,ee=!1,ae=!1,he,Se){let Me,We,_e,Ae=0,xe;const Ge={leakWarningThreshold:he,onWillAddFirstListener(){Me=ke(qe=>{Ae++,We=Ee(We,qe),ee&&!_e&&(Je.fire(We),We=void 0),xe=()=>{const Qe=We;We=void 0,_e=void 0,(!ee||Ae>1)&&Je.fire(Qe),Ae=0},typeof pe=="number"?(clearTimeout(_e),_e=setTimeout(xe,pe)):_e===void 0&&(_e=0,queueMicrotask(xe))})},onWillRemoveListener(){ae&&Ae>0&&xe?.()},onDidRemoveLastListener(){xe=void 0,Me.dispose()}};Se||K(Ge);const Je=new t(Ge);return Se?.add(Je),Je.event}q.debounce=j;function ue(ke,Ee=0,pe){return q.debounce(ke,(ee,ae)=>ee?(ee.push(ae),ee):[ae],Ee,void 0,!0,void 0,pe)}q.accumulate=ue;function se(ke,Ee=(ee,ae)=>ee===ae,pe){let ee=!0,ae;return J(ke,he=>{const Se=ee||!Ee(he,ae);return ee=!1,ae=he,Se},pe)}q.latch=se;function Y(ke,Ee,pe){return[q.filter(ke,Ee,pe),q.filter(ke,ee=>!Ee(ee),pe)]}q.split=Y;function W(ke,Ee=!1,pe=[],ee){let ae=pe.slice(),he=ke(We=>{ae?ae.push(We):Me.fire(We)});ee&&ee.add(he);const Se=()=>{ae?.forEach(We=>Me.fire(We)),ae=null},Me=new t({onWillAddFirstListener(){he||(he=ke(We=>Me.fire(We)),ee&&ee.add(he))},onDidAddFirstListener(){ae&&(Ee?setTimeout(Se):Se())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return ee&&ee.add(Me),Me.event}q.buffer=W;function F(ke,Ee){return(ee,ae,he)=>{const Se=Ee(new z);return ke(function(Me){const We=Se.evaluate(Me);We!==Z&&ee.call(ae,We)},void 0,he)}}q.chain=F;const Z=Symbol("HaltChainable");class z{constructor(){this.steps=[]}map(Ee){return this.steps.push(Ee),this}forEach(Ee){return this.steps.push(pe=>(Ee(pe),pe)),this}filter(Ee){return this.steps.push(pe=>Ee(pe)?pe:Z),this}reduce(Ee,pe){let ee=pe;return this.steps.push(ae=>(ee=Ee(ee,ae),ee)),this}latch(Ee=(pe,ee)=>pe===ee){let pe=!0,ee;return this.steps.push(ae=>{const he=pe||!Ee(ae,ee);return pe=!1,ee=ae,he?ae:Z}),this}evaluate(Ee){for(const pe of this.steps)if(Ee=pe(Ee),Ee===Z)break;return Ee}}function ie(ke,Ee,pe=ee=>ee){const ee=(...Me)=>Se.fire(pe(...Me)),ae=()=>ke.on(Ee,ee),he=()=>ke.removeListener(Ee,ee),Se=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:he});return Se.event}q.fromNodeEventEmitter=ie;function G(ke,Ee,pe=ee=>ee){const ee=(...Me)=>Se.fire(pe(...Me)),ae=()=>ke.addEventListener(Ee,ee),he=()=>ke.removeEventListener(Ee,ee),Se=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:he});return Se.event}q.fromDOMEventEmitter=G;function x(ke){return new Promise(Ee=>$(ke)(Ee))}q.toPromise=x;function te(ke){const Ee=new t;return ke.then(pe=>{Ee.fire(pe)},()=>{Ee.fire(void 0)}).finally(()=>{Ee.dispose()}),Ee.event}q.fromPromise=te;function de(ke,Ee){return ke(pe=>Ee.fire(pe))}q.forward=de;function me(ke,Ee,pe){return Ee(pe),ke(ee=>Ee(ee))}q.runAndSubscribe=me;class we{constructor(Ee,pe){this._observable=Ee,this._counter=0,this._hasChanged=!1;const ee={onWillAddFirstListener:()=>{Ee.addObserver(this)},onDidRemoveLastListener:()=>{Ee.removeObserver(this)}};pe||K(ee),this.emitter=new t(ee),pe&&pe.add(this.emitter)}beginUpdate(Ee){this._counter++}handlePossibleChange(Ee){}handleChange(Ee,pe){this._hasChanged=!0}endUpdate(Ee){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Re(ke,Ee){return new we(ke,Ee).emitter.event}q.fromObservable=Re;function Ne(ke){return(Ee,pe,ee)=>{let ae=0,he=!1;const Se={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(ke.reportChanges(),he&&(he=!1,Ee.call(pe)))},handlePossibleChange(){},handleChange(){he=!0}};ke.addObserver(Se),ke.reportChanges();const Me={dispose(){ke.removeObserver(Se)}};return ee instanceof b.DisposableStore?ee.add(Me):Array.isArray(ee)&&ee.push(Me),Me}}q.fromObservableLight=Ne})(m||(e.Event=m={}));class u{static{this.all=new Set}static{this._idPool=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${u._idPool++}`,u.all.add(this)}start(K){this._stopWatch=new L.StopWatch,this.listenerCount=K}stop(){if(this._stopWatch){const K=this._stopWatch.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=u;let f=-1;function v(q){const K=f;return f=q,{dispose(){f=K}}}class h{static{this._idPool=1}constructor(K,fe,$=(h._idPool++).toString(16).padStart(3,"0")){this._errorHandler=K,this.threshold=fe,this.name=$,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(K,fe){const $=this.threshold;if($<=0||fe<$)return;this._stacks||(this._stacks=new Map);const X=this._stacks.get(K.value)||0;if(this._stacks.set(K.value,X+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=$*.5;const[B,J]=this.getMostFrequentStack(),U=`[${this.name}] potential listener LEAK detected, having ${fe} listeners already. MOST frequent listener (${J}):`;console.warn(U),console.warn(B);const O=new E(U,B);this._errorHandler(O)}return()=>{const B=this._stacks.get(K.value)||0;this._stacks.set(K.value,B-1)}}getMostFrequentStack(){if(!this._stacks)return;let K,fe=0;for(const[$,X]of this._stacks)(!K||fe<X)&&(K=[$,X],fe=X);return K}}class g{static create(){const K=new Error;return new g(K.stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(K,fe){super(K),this.name="ListenerLeakError",this.stack=fe}}e.ListenerLeakError=E;class S extends Error{constructor(K,fe){super(K),this.name="ListenerRefusalError",this.stack=fe}}e.ListenerRefusalError=S;let p=0;class D{constructor(K){this.value=K,this.id=p++}}const I=2,i=(q,K)=>{if(q instanceof D)K(q);else for(let fe=0;fe<q.length;fe++){const $=q[fe];$&&K($)}};let d;if(R){const q=[];setInterval(()=>{q.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(q.join(`
`)),q.length=0)},3e3),d=new FinalizationRegistry(K=>{typeof K=="string"&&q.push(K)})}class t{constructor(K){this._size=0,this._options=K,this._leakageMon=f>0||this._options?.leakWarningThreshold?new h(K?.onListenerError??n.onUnexpectedError,this._options?.leakWarningThreshold??f):void 0,this._perfMon=this._options?._profName?new u(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(w){const K=this._listeners;queueMicrotask(()=>{i(K,fe=>fe.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(K,fe,$)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const O=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(O);const N=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],Q=new S(`${O}. HINT: Stack shows most frequent listener (${N[1]}-times)`,N[0]);return(this._options?.onListenerError||n.onUnexpectedError)(Q),b.Disposable.None}if(this._disposed)return b.Disposable.None;fe&&(K=K.bind(fe));const X=new D(K);let B,J;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(X.stack=g.create(),B=this._leakageMon.check(X.stack,this._size+1)),w&&(X.stack=J??g.create()),this._listeners?this._listeners instanceof D?(this._deliveryQueue??=new r,this._listeners=[this._listeners,X]):this._listeners.push(X):(this._options?.onWillAddFirstListener?.(this),this._listeners=X,this._options?.onDidAddFirstListener?.(this)),this._size++;const U=(0,b.toDisposable)(()=>{d?.unregister(U),B?.(),this._removeListener(X)});if($ instanceof b.DisposableStore?$.add(U):Array.isArray($)&&$.push(U),d){const O=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),N=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(O);d.register(U,N?.[2]??O,U)}return U},this._event}_removeListener(K){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const fe=this._listeners,$=fe.indexOf(K);if($===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,fe[$]=void 0;const X=this._deliveryQueue.current===this;if(this._size*I<=fe.length){let B=0;for(let J=0;J<fe.length;J++)fe[J]?fe[B++]=fe[J]:X&&(this._deliveryQueue.end--,B<this._deliveryQueue.i&&this._deliveryQueue.i--);fe.length=B}}_deliver(K,fe){if(!K)return;const $=this._options?.onListenerError||n.onUnexpectedError;if(!$){K.value(fe);return}try{K.value(fe)}catch(X){$(X)}}_deliverQueue(K){const fe=K.current._listeners;for(;K.i<K.end;)this._deliver(fe[K.i++],K.value);K.reset()}fire(K){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof D)this._deliver(this._listeners,K);else{const fe=this._deliveryQueue;fe.enqueue(this,K,this._listeners.length),this._deliverQueue(fe)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=t;const o=()=>new r;e.createEventDeliveryQueue=o;class r{constructor(){this.i=-1,this.end=0}enqueue(K,fe,$){this.i=0,this.end=$,this.current=K,this.value=fe}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends t{async fireAsync(K,fe,$){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList),i(this._listeners,X=>this._asyncDeliveryQueue.push([X.value,K]));this._asyncDeliveryQueue.size>0&&!fe.isCancellationRequested;){const[X,B]=this._asyncDeliveryQueue.shift(),J=[],U={...B,token:fe,waitUntil:O=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");$&&(O=$(O,X)),J.push(O)}};try{X(U)}catch(O){(0,n.onUnexpectedError)(O);continue}Object.freeze(J),await Promise.allSettled(J).then(O=>{for(const N of O)N.status==="rejected"&&(0,n.onUnexpectedError)(N.reason)})}}}e.AsyncEmitter=a;class l extends t{get isPaused(){return this._isPaused!==0}constructor(K){super(K),this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=K?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const K=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(K))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(K){this._size&&(this._isPaused!==0?this._eventQueue.push(K):super.fire(K))}}e.PauseableEmitter=l;class P extends l{constructor(K){super(K),this._delay=K.delay??100}fire(K){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(K)}}e.DebounceEmitter=P;class y extends t{constructor(K){super(K),this._queuedEvents=[],this._mergeFn=K?.merge}fire(K){this.hasListeners()&&(this._queuedEvents.push(K),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(fe=>super.fire(fe)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=y;class k{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new t({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(K){const fe={event:K,listener:null};this.events.push(fe),this.hasListeners&&this.hook(fe);const $=()=>{this.hasListeners&&this.unhook(fe);const X=this.events.indexOf(fe);this.events.splice(X,1)};return(0,b.toDisposable)((0,s.createSingleCallFunction)($))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(K=>this.hook(K))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(K=>this.unhook(K))}hook(K){K.listener=K.event(fe=>this.emitter.fire(fe))}unhook(K){K.listener?.dispose(),K.listener=null}dispose(){this.emitter.dispose();for(const K of this.events)K.listener?.dispose();this.events=[]}}e.EventMultiplexer=k;class T{constructor(K,fe,$,X){this._store=new b.DisposableStore;const B=this._store.add(new k),J=this._store.add(new b.DisposableMap);function U(O){J.set(O,B.add(X(O)))}for(const O of K)U(O);this._store.add(fe(O=>{U(O)})),this._store.add($(O=>{J.deleteAndDispose(O)})),this.event=B.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=T;class A{constructor(){this.data=[]}wrapEvent(K,fe,$){return(X,B,J)=>K(U=>{const O=this.data[this.data.length-1];if(!fe){O?O.buffers.push(()=>X.call(B,U)):X.call(B,U);return}const N=O;if(!N){X.call(B,fe($,U));return}N.items??=[],N.items.push(U),N.buffers.length===0&&O.buffers.push(()=>{N.reducedResult??=$?N.items.reduce(fe,$):N.items.reduce(fe),X.call(B,N.reducedResult)})},void 0,J)}bufferEvents(K){const fe={buffers:new Array};this.data.push(fe);const $=K();return this.data.pop(),fe.buffers.forEach(X=>X()),$}}e.EventBufferer=A;class C{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=b.Disposable.None,this.emitter=new t({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(K){this.inputEvent=K,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=K(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C;class _{static const(K){return new H(K)}constructor(K){this._value=K,this._onDidChange=new t,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(K){K!==this._value&&(this._value=K,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=_;class H{constructor(K){this.value=K,this.onDidChange=m.None}}}),define(ce[22],le([0,1,4]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=R;const s=Object.freeze(function(w,c){const m=setTimeout(w.bind(c),0);return{dispose(){clearTimeout(m)}}});var b;(function(w){function c(m){return m===w.None||m===w.Cancelled||m instanceof M?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}w.isCancellationToken=c,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:s})})(b||(e.CancellationToken=b={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?s:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(c){this._token=void 0,this._parentListener=void 0,this._parentListener=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=b.Cancelled}dispose(c=!1){c&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=b.None}}e.CancellationTokenSource=L;function R(w){const c=new L;return w.add({dispose(){c.cancel()}}),c.token}}),define(ce[146],le([0,1,22]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=b;class s{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new n.CancellationTokenSource,c=this.task(w.token);return this.result={promise:c,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}e.Cache=s;function b(R){return R}class M{constructor(w,c){this.lastCache=void 0,this.lastArgKey=void 0,typeof w=="function"?(this._fn=w,this._computeKey=b):(this._fn=c,this._computeKey=w.getCacheKey)}get(w){const c=this._computeKey(w);return this.lastArgKey!==c&&(this.lastArgKey=c,this.lastCache=this._fn(w)),this.lastCache}}e.LRUCachedFunction=M;class L{get cachedValues(){return this._map}constructor(w,c){this._map=new Map,this._map2=new Map,typeof w=="function"?(this._fn=w,this._computeKey=b):(this._fn=c,this._computeKey=w.getCacheKey)}get(w){const c=this._computeKey(w);if(this._map2.has(c))return this._map2.get(c);const m=this._fn(w);return this._map.set(w,m),this._map2.set(c,m),m}}e.CachedFunction=L}),define(ce[67],le([0,1,15,2]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=b,e.isReadableStream=M,e.isReadableBufferedStream=L,e.newWriteableStream=R,e.consumeReadable=c,e.peekReadable=m,e.consumeStream=u,e.listenStream=f,e.peekStream=v,e.toStream=h,e.emptyStream=g,e.toReadable=E,e.transform=S,e.prefixedReadable=p,e.prefixedStream=D;function b(I){const i=I;return i?typeof i.read=="function":!1}function M(I){const i=I;return i?[i.on,i.pause,i.resume,i.destroy].every(d=>typeof d=="function"):!1}function L(I){const i=I;return i?M(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function R(I,i){return new w(I,i)}class w{constructor(i,d){this.reducer=i,this.options=d,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(i){if(!this.state.destroyed){if(this.state.flowing)this.emitData(i);else if(this.buffer.data.push(i),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(i){this.state.destroyed||(this.state.flowing?this.emitError(i):this.buffer.error.push(i))}end(i){this.state.destroyed||(typeof i<"u"&&this.write(i),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(i){this.listeners.data.slice(0).forEach(d=>d(i))}emitError(i){this.listeners.error.length===0?(0,n.onUnexpectedError)(i):this.listeners.error.slice(0).forEach(d=>d(i))}emitEnd(){this.listeners.end.slice(0).forEach(i=>i())}on(i,d){if(!this.state.destroyed)switch(i){case"data":this.listeners.data.push(d),this.resume();break;case"end":this.listeners.end.push(d),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(d),this.state.flowing&&this.flowErrors();break}}removeListener(i,d){if(this.state.destroyed)return;let t;switch(i){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const o=t.indexOf(d);o>=0&&t.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const i=this.reducer(this.buffer.data);this.emitData(i),this.buffer.data.length=0;const d=[...this.pendingWritePromises];this.pendingWritePromises.length=0,d.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const i of this.buffer.error)this.emitError(i);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(I,i){const d=[];let t;for(;(t=I.read())!==null;)d.push(t);return i(d)}function m(I,i,d){const t=[];let o;for(;(o=I.read())!==null&&t.length<d;)t.push(o);return o===null&&t.length>0?i(t):{read:()=>{if(t.length>0)return t.shift();if(typeof o<"u"){const r=o;return o=void 0,r}return I.read()}}}function u(I,i){return new Promise((d,t)=>{const o=[];f(I,{onData:r=>{i&&o.push(r)},onError:r=>{i?t(r):d(void 0)},onEnd:()=>{d(i?i(o):void 0)}})})}function f(I,i,d){I.on("error",t=>{d?.isCancellationRequested||i.onError(t)}),I.on("end",()=>{d?.isCancellationRequested||i.onEnd()}),I.on("data",t=>{d?.isCancellationRequested||i.onData(t)})}function v(I,i){return new Promise((d,t)=>{const o=new s.DisposableStore,r=[],a=y=>{if(r.push(y),r.length>i)return o.dispose(),I.pause(),d({stream:I,buffer:r,ended:!1})},l=y=>(o.dispose(),t(y)),P=()=>(o.dispose(),d({stream:I,buffer:r,ended:!0}));o.add((0,s.toDisposable)(()=>I.removeListener("error",l))),I.on("error",l),o.add((0,s.toDisposable)(()=>I.removeListener("end",P))),I.on("end",P),o.add((0,s.toDisposable)(()=>I.removeListener("data",a))),I.on("data",a)})}function h(I,i){const d=R(i);return d.end(I),d}function g(){const I=R(()=>{throw new Error("not supported")});return I.end(),I}function E(I){let i=!1;return{read:()=>i?null:(i=!0,I)}}function S(I,i,d){const t=R(d);return f(I,{onData:o=>t.write(i.data(o)),onError:o=>t.error(i.error?i.error(o):o),onEnd:()=>t.end()}),t}function p(I,i,d){let t=!1;return{read:()=>{const o=i.read();return t?o:(t=!0,o!==null?d([I,o]):I)}}}function D(I,i,d){let t=!1;const o=R(d);return f(i,{onData:r=>t?o.write(r):(t=!0,o.write(d([I,r]))),onError:r=>o.error(r),onEnd:()=>{t||(t=!0,o.write(I)),o.end()}}),o}}),define(ce[17],le([0,1,65,67]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=c,e.readUInt16LE=m,e.writeUInt16LE=u,e.readUInt32BE=f,e.writeUInt32BE=v,e.readUInt32LE=h,e.writeUInt32LE=g,e.readUInt8=E,e.writeUInt8=S,e.readableToBuffer=p,e.bufferToReadable=D,e.streamToBuffer=I,e.bufferedStreamToBuffer=i,e.bufferToStream=d,e.streamToBufferReadableStream=t,e.newWriteableBufferStream=o,e.prefixedBufferReadable=r,e.prefixedBufferStream=a,e.decodeBase64=l,e.encodeBase64=k,s=De(s);const b=typeof Buffer<"u",M=new n.Lazy(()=>new Uint8Array(256));let L,R;class w{static alloc(A){return b?new w(Buffer.allocUnsafe(A)):new w(new Uint8Array(A))}static wrap(A){return b&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new w(A)}static fromString(A,C){return!(C?.dontUseNodeBuffer||!1)&&b?new w(Buffer.from(A)):(L||(L=new TextEncoder),new w(L.encode(A)))}static fromByteArray(A){const C=w.alloc(A.length);for(let _=0,H=A.length;_<H;_++)C.buffer[_]=A[_];return C}static concat(A,C){if(typeof C>"u"){C=0;for(let q=0,K=A.length;q<K;q++)C+=A[q].byteLength}const _=w.alloc(C);let H=0;for(let q=0,K=A.length;q<K;q++){const fe=A[q];_.set(fe,H),H+=fe.byteLength}return _}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=w.alloc(this.byteLength);return A.set(this),A}toString(){return b?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(A,C){return new w(this.buffer.subarray(A,C))}set(A,C){if(A instanceof w)this.buffer.set(A.buffer,C);else if(A instanceof Uint8Array)this.buffer.set(A,C);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),C);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return f(this.buffer,A)}writeUInt32BE(A,C){v(this.buffer,A,C)}readUInt32LE(A){return h(this.buffer,A)}writeUInt32LE(A,C){g(this.buffer,A,C)}readUInt8(A){return E(this.buffer,A)}writeUInt8(A,C){S(this.buffer,A,C)}indexOf(A,C=0){return c(this.buffer,A instanceof w?A.buffer:A,C)}}e.VSBuffer=w;function c(T,A,C=0){const _=A.byteLength,H=T.byteLength;if(_===0)return 0;if(_===1)return T.indexOf(A[0]);if(_>H-C)return-1;const q=M.value;q.fill(A.length);for(let X=0;X<A.length;X++)q[A[X]]=A.length-X-1;let K=C+A.length-1,fe=K,$=-1;for(;K<H;)if(T[K]===A[fe]){if(fe===0){$=K;break}K--,fe--}else K+=Math.max(A.length-fe,q[T[K]]),fe=A.length-1;return $}function m(T,A){return T[A+0]<<0>>>0|T[A+1]<<8>>>0}function u(T,A,C){T[C+0]=A&255,A=A>>>8,T[C+1]=A&255}function f(T,A){return T[A]*2**24+T[A+1]*2**16+T[A+2]*2**8+T[A+3]}function v(T,A,C){T[C+3]=A,A=A>>>8,T[C+2]=A,A=A>>>8,T[C+1]=A,A=A>>>8,T[C]=A}function h(T,A){return T[A+0]<<0>>>0|T[A+1]<<8>>>0|T[A+2]<<16>>>0|T[A+3]<<24>>>0}function g(T,A,C){T[C+0]=A&255,A=A>>>8,T[C+1]=A&255,A=A>>>8,T[C+2]=A&255,A=A>>>8,T[C+3]=A&255}function E(T,A){return T[A]}function S(T,A,C){T[C]=A}function p(T){return s.consumeReadable(T,A=>w.concat(A))}function D(T){return s.toReadable(T)}function I(T){return s.consumeStream(T,A=>w.concat(A))}async function i(T){return T.ended?w.concat(T.buffer):w.concat([...T.buffer,await I(T.stream)])}function d(T){return s.toStream(T,A=>w.concat(A))}function t(T){return s.transform(T,{data:A=>typeof A=="string"?w.fromString(A):w.wrap(A)},A=>w.concat(A))}function o(T){return s.newWriteableStream(A=>w.concat(A),T)}function r(T,A){return s.prefixedReadable(T,A,C=>w.concat(C))}function a(T,A){return s.prefixedStream(T,A,C=>w.concat(C))}function l(T){let A=0,C=0,_=0;const H=new Uint8Array(Math.floor(T.length/4*3)),q=fe=>{switch(C){case 3:H[_++]=A|fe,C=0;break;case 2:H[_++]=A|fe>>>2,A=fe<<6,C=3;break;case 1:H[_++]=A|fe>>>4,A=fe<<4,C=2;break;default:A=fe<<2,C=1}};for(let fe=0;fe<T.length;fe++){const $=T.charCodeAt(fe);if($>=65&&$<=90)q($-65);else if($>=97&&$<=122)q($-97+26);else if($>=48&&$<=57)q($-48+52);else if($===43||$===45)q(62);else if($===47||$===95)q(63);else{if($===61)break;throw new SyntaxError(`Unexpected base64 character ${T[fe]}`)}}const K=_;for(;C>0;)q(0);return w.wrap(H).slice(0,K)}const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:T},A=!0,C=!1){const _=C?y:P;let H="";const q=T.byteLength%3;let K=0;for(;K<T.byteLength-q;K+=3){const fe=T[K+0],$=T[K+1],X=T[K+2];H+=_[fe>>>2],H+=_[(fe<<4|$>>>4)&63],H+=_[($<<2|X>>>6)&63],H+=_[X&63]}if(q===1){const fe=T[K+0];H+=_[fe>>>2],H+=_[fe<<4&63],A&&(H+="==")}else if(q===2){const fe=T[K+0],$=T[K+1];H+=_[fe>>>2],H+=_[(fe<<4|$>>>4)&63],H+=_[$<<2&63],A&&(H+="=")}return H}}),define(ce[147],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ce[11],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=n,e.isStringArray=s,e.isObject=b,e.isTypedArray=M,e.isNumber=L,e.isIterable=R,e.isBoolean=w,e.isUndefined=c,e.isDefined=m,e.isUndefinedOrNull=u,e.assertType=f,e.assertIsDefined=v,e.assertAllDefined=h,e.isEmptyObject=E,e.isFunction=S,e.areFunctions=p,e.validateConstraints=D,e.validateConstraint=I,e.upcast=i;function n(d){return typeof d=="string"}function s(d){return Array.isArray(d)&&d.every(t=>n(t))}function b(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}function M(d){const t=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof t}function L(d){return typeof d=="number"&&!isNaN(d)}function R(d){return!!d&&typeof d[Symbol.iterator]=="function"}function w(d){return d===!0||d===!1}function c(d){return typeof d>"u"}function m(d){return!u(d)}function u(d){return c(d)||d===null}function f(d,t){if(!d)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function v(d){if(u(d))throw new Error("Assertion Failed: argument is undefined or null");return d}function h(...d){const t=[];for(let o=0;o<d.length;o++){const r=d[o];if(u(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}const g=Object.prototype.hasOwnProperty;function E(d){if(!b(d))return!1;for(const t in d)if(g.call(d,t))return!1;return!0}function S(d){return typeof d=="function"}function p(...d){return d.length>0&&d.every(S)}function D(d,t){const o=Math.min(d.length,t.length);for(let r=0;r<o;r++)I(d[r],t[r])}function I(d,t){if(n(t)){if(typeof d!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(S(t)){try{if(d instanceof t)return}catch{}if(!u(d)&&d.constructor===t||t.length===1&&t.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function i(d){return d}}),define(ce[109],le([0,1,11]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=b,e.getCodiconFontCharacters=M;const s=Object.create(null);function b(L,R){if((0,n.isString)(R)){const w=s[R];if(w===void 0)throw new Error(`${L} references an unknown codicon: ${R}`);R=w}return s[L]=R,{id:L}}function M(){return s}}),define(ce[148],le([0,1,109]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,n.register)("add",6e4),plus:(0,n.register)("plus",6e4),gistNew:(0,n.register)("gist-new",6e4),repoCreate:(0,n.register)("repo-create",6e4),lightbulb:(0,n.register)("lightbulb",60001),lightBulb:(0,n.register)("light-bulb",60001),repo:(0,n.register)("repo",60002),repoDelete:(0,n.register)("repo-delete",60002),gistFork:(0,n.register)("gist-fork",60003),repoForked:(0,n.register)("repo-forked",60003),gitPullRequest:(0,n.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.register)("git-pull-request-abandoned",60004),recordKeys:(0,n.register)("record-keys",60005),keyboard:(0,n.register)("keyboard",60005),tag:(0,n.register)("tag",60006),gitPullRequestLabel:(0,n.register)("git-pull-request-label",60006),tagAdd:(0,n.register)("tag-add",60006),tagRemove:(0,n.register)("tag-remove",60006),person:(0,n.register)("person",60007),personFollow:(0,n.register)("person-follow",60007),personOutline:(0,n.register)("person-outline",60007),personFilled:(0,n.register)("person-filled",60007),gitBranch:(0,n.register)("git-branch",60008),gitBranchCreate:(0,n.register)("git-branch-create",60008),gitBranchDelete:(0,n.register)("git-branch-delete",60008),sourceControl:(0,n.register)("source-control",60008),mirror:(0,n.register)("mirror",60009),mirrorPublic:(0,n.register)("mirror-public",60009),star:(0,n.register)("star",60010),starAdd:(0,n.register)("star-add",60010),starDelete:(0,n.register)("star-delete",60010),starEmpty:(0,n.register)("star-empty",60010),comment:(0,n.register)("comment",60011),commentAdd:(0,n.register)("comment-add",60011),alert:(0,n.register)("alert",60012),warning:(0,n.register)("warning",60012),search:(0,n.register)("search",60013),searchSave:(0,n.register)("search-save",60013),logOut:(0,n.register)("log-out",60014),signOut:(0,n.register)("sign-out",60014),logIn:(0,n.register)("log-in",60015),signIn:(0,n.register)("sign-in",60015),eye:(0,n.register)("eye",60016),eyeUnwatch:(0,n.register)("eye-unwatch",60016),eyeWatch:(0,n.register)("eye-watch",60016),circleFilled:(0,n.register)("circle-filled",60017),primitiveDot:(0,n.register)("primitive-dot",60017),closeDirty:(0,n.register)("close-dirty",60017),debugBreakpoint:(0,n.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.register)("debug-breakpoint-disabled",60017),debugHint:(0,n.register)("debug-hint",60017),terminalDecorationSuccess:(0,n.register)("terminal-decoration-success",60017),primitiveSquare:(0,n.register)("primitive-square",60018),edit:(0,n.register)("edit",60019),pencil:(0,n.register)("pencil",60019),info:(0,n.register)("info",60020),issueOpened:(0,n.register)("issue-opened",60020),gistPrivate:(0,n.register)("gist-private",60021),gitForkPrivate:(0,n.register)("git-fork-private",60021),lock:(0,n.register)("lock",60021),mirrorPrivate:(0,n.register)("mirror-private",60021),close:(0,n.register)("close",60022),removeClose:(0,n.register)("remove-close",60022),x:(0,n.register)("x",60022),repoSync:(0,n.register)("repo-sync",60023),sync:(0,n.register)("sync",60023),clone:(0,n.register)("clone",60024),desktopDownload:(0,n.register)("desktop-download",60024),beaker:(0,n.register)("beaker",60025),microscope:(0,n.register)("microscope",60025),vm:(0,n.register)("vm",60026),deviceDesktop:(0,n.register)("device-desktop",60026),file:(0,n.register)("file",60027),fileText:(0,n.register)("file-text",60027),more:(0,n.register)("more",60028),ellipsis:(0,n.register)("ellipsis",60028),kebabHorizontal:(0,n.register)("kebab-horizontal",60028),mailReply:(0,n.register)("mail-reply",60029),reply:(0,n.register)("reply",60029),organization:(0,n.register)("organization",60030),organizationFilled:(0,n.register)("organization-filled",60030),organizationOutline:(0,n.register)("organization-outline",60030),newFile:(0,n.register)("new-file",60031),fileAdd:(0,n.register)("file-add",60031),newFolder:(0,n.register)("new-folder",60032),fileDirectoryCreate:(0,n.register)("file-directory-create",60032),trash:(0,n.register)("trash",60033),trashcan:(0,n.register)("trashcan",60033),history:(0,n.register)("history",60034),clock:(0,n.register)("clock",60034),folder:(0,n.register)("folder",60035),fileDirectory:(0,n.register)("file-directory",60035),symbolFolder:(0,n.register)("symbol-folder",60035),logoGithub:(0,n.register)("logo-github",60036),markGithub:(0,n.register)("mark-github",60036),github:(0,n.register)("github",60036),terminal:(0,n.register)("terminal",60037),console:(0,n.register)("console",60037),repl:(0,n.register)("repl",60037),zap:(0,n.register)("zap",60038),symbolEvent:(0,n.register)("symbol-event",60038),error:(0,n.register)("error",60039),stop:(0,n.register)("stop",60039),variable:(0,n.register)("variable",60040),symbolVariable:(0,n.register)("symbol-variable",60040),array:(0,n.register)("array",60042),symbolArray:(0,n.register)("symbol-array",60042),symbolModule:(0,n.register)("symbol-module",60043),symbolPackage:(0,n.register)("symbol-package",60043),symbolNamespace:(0,n.register)("symbol-namespace",60043),symbolObject:(0,n.register)("symbol-object",60043),symbolMethod:(0,n.register)("symbol-method",60044),symbolFunction:(0,n.register)("symbol-function",60044),symbolConstructor:(0,n.register)("symbol-constructor",60044),symbolBoolean:(0,n.register)("symbol-boolean",60047),symbolNull:(0,n.register)("symbol-null",60047),symbolNumeric:(0,n.register)("symbol-numeric",60048),symbolNumber:(0,n.register)("symbol-number",60048),symbolStructure:(0,n.register)("symbol-structure",60049),symbolStruct:(0,n.register)("symbol-struct",60049),symbolParameter:(0,n.register)("symbol-parameter",60050),symbolTypeParameter:(0,n.register)("symbol-type-parameter",60050),symbolKey:(0,n.register)("symbol-key",60051),symbolText:(0,n.register)("symbol-text",60051),symbolReference:(0,n.register)("symbol-reference",60052),goToFile:(0,n.register)("go-to-file",60052),symbolEnum:(0,n.register)("symbol-enum",60053),symbolValue:(0,n.register)("symbol-value",60053),symbolRuler:(0,n.register)("symbol-ruler",60054),symbolUnit:(0,n.register)("symbol-unit",60054),activateBreakpoints:(0,n.register)("activate-breakpoints",60055),archive:(0,n.register)("archive",60056),arrowBoth:(0,n.register)("arrow-both",60057),arrowDown:(0,n.register)("arrow-down",60058),arrowLeft:(0,n.register)("arrow-left",60059),arrowRight:(0,n.register)("arrow-right",60060),arrowSmallDown:(0,n.register)("arrow-small-down",60061),arrowSmallLeft:(0,n.register)("arrow-small-left",60062),arrowSmallRight:(0,n.register)("arrow-small-right",60063),arrowSmallUp:(0,n.register)("arrow-small-up",60064),arrowUp:(0,n.register)("arrow-up",60065),bell:(0,n.register)("bell",60066),bold:(0,n.register)("bold",60067),book:(0,n.register)("book",60068),bookmark:(0,n.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.register)("briefcase",60076),broadcast:(0,n.register)("broadcast",60077),browser:(0,n.register)("browser",60078),bug:(0,n.register)("bug",60079),calendar:(0,n.register)("calendar",60080),caseSensitive:(0,n.register)("case-sensitive",60081),check:(0,n.register)("check",60082),checklist:(0,n.register)("checklist",60083),chevronDown:(0,n.register)("chevron-down",60084),chevronLeft:(0,n.register)("chevron-left",60085),chevronRight:(0,n.register)("chevron-right",60086),chevronUp:(0,n.register)("chevron-up",60087),chromeClose:(0,n.register)("chrome-close",60088),chromeMaximize:(0,n.register)("chrome-maximize",60089),chromeMinimize:(0,n.register)("chrome-minimize",60090),chromeRestore:(0,n.register)("chrome-restore",60091),circleOutline:(0,n.register)("circle-outline",60092),circle:(0,n.register)("circle",60092),debugBreakpointUnverified:(0,n.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.register)("terminal-decoration-incomplete",60092),circleSlash:(0,n.register)("circle-slash",60093),circuitBoard:(0,n.register)("circuit-board",60094),clearAll:(0,n.register)("clear-all",60095),clippy:(0,n.register)("clippy",60096),closeAll:(0,n.register)("close-all",60097),cloudDownload:(0,n.register)("cloud-download",60098),cloudUpload:(0,n.register)("cloud-upload",60099),code:(0,n.register)("code",60100),collapseAll:(0,n.register)("collapse-all",60101),colorMode:(0,n.register)("color-mode",60102),commentDiscussion:(0,n.register)("comment-discussion",60103),creditCard:(0,n.register)("credit-card",60105),dash:(0,n.register)("dash",60108),dashboard:(0,n.register)("dashboard",60109),database:(0,n.register)("database",60110),debugContinue:(0,n.register)("debug-continue",60111),debugDisconnect:(0,n.register)("debug-disconnect",60112),debugPause:(0,n.register)("debug-pause",60113),debugRestart:(0,n.register)("debug-restart",60114),debugStart:(0,n.register)("debug-start",60115),debugStepInto:(0,n.register)("debug-step-into",60116),debugStepOut:(0,n.register)("debug-step-out",60117),debugStepOver:(0,n.register)("debug-step-over",60118),debugStop:(0,n.register)("debug-stop",60119),debug:(0,n.register)("debug",60120),deviceCameraVideo:(0,n.register)("device-camera-video",60121),deviceCamera:(0,n.register)("device-camera",60122),deviceMobile:(0,n.register)("device-mobile",60123),diffAdded:(0,n.register)("diff-added",60124),diffIgnored:(0,n.register)("diff-ignored",60125),diffModified:(0,n.register)("diff-modified",60126),diffRemoved:(0,n.register)("diff-removed",60127),diffRenamed:(0,n.register)("diff-renamed",60128),diff:(0,n.register)("diff",60129),diffSidebyside:(0,n.register)("diff-sidebyside",60129),discard:(0,n.register)("discard",60130),editorLayout:(0,n.register)("editor-layout",60131),emptyWindow:(0,n.register)("empty-window",60132),exclude:(0,n.register)("exclude",60133),extensions:(0,n.register)("extensions",60134),eyeClosed:(0,n.register)("eye-closed",60135),fileBinary:(0,n.register)("file-binary",60136),fileCode:(0,n.register)("file-code",60137),fileMedia:(0,n.register)("file-media",60138),filePdf:(0,n.register)("file-pdf",60139),fileSubmodule:(0,n.register)("file-submodule",60140),fileSymlinkDirectory:(0,n.register)("file-symlink-directory",60141),fileSymlinkFile:(0,n.register)("file-symlink-file",60142),fileZip:(0,n.register)("file-zip",60143),files:(0,n.register)("files",60144),filter:(0,n.register)("filter",60145),flame:(0,n.register)("flame",60146),foldDown:(0,n.register)("fold-down",60147),foldUp:(0,n.register)("fold-up",60148),fold:(0,n.register)("fold",60149),folderActive:(0,n.register)("folder-active",60150),folderOpened:(0,n.register)("folder-opened",60151),gear:(0,n.register)("gear",60152),gift:(0,n.register)("gift",60153),gistSecret:(0,n.register)("gist-secret",60154),gist:(0,n.register)("gist",60155),gitCommit:(0,n.register)("git-commit",60156),gitCompare:(0,n.register)("git-compare",60157),compareChanges:(0,n.register)("compare-changes",60157),gitMerge:(0,n.register)("git-merge",60158),githubAction:(0,n.register)("github-action",60159),githubAlt:(0,n.register)("github-alt",60160),globe:(0,n.register)("globe",60161),grabber:(0,n.register)("grabber",60162),graph:(0,n.register)("graph",60163),gripper:(0,n.register)("gripper",60164),heart:(0,n.register)("heart",60165),home:(0,n.register)("home",60166),horizontalRule:(0,n.register)("horizontal-rule",60167),hubot:(0,n.register)("hubot",60168),inbox:(0,n.register)("inbox",60169),issueReopened:(0,n.register)("issue-reopened",60171),issues:(0,n.register)("issues",60172),italic:(0,n.register)("italic",60173),jersey:(0,n.register)("jersey",60174),json:(0,n.register)("json",60175),kebabVertical:(0,n.register)("kebab-vertical",60176),key:(0,n.register)("key",60177),law:(0,n.register)("law",60178),lightbulbAutofix:(0,n.register)("lightbulb-autofix",60179),linkExternal:(0,n.register)("link-external",60180),link:(0,n.register)("link",60181),listOrdered:(0,n.register)("list-ordered",60182),listUnordered:(0,n.register)("list-unordered",60183),liveShare:(0,n.register)("live-share",60184),loading:(0,n.register)("loading",60185),location:(0,n.register)("location",60186),mailRead:(0,n.register)("mail-read",60187),mail:(0,n.register)("mail",60188),markdown:(0,n.register)("markdown",60189),megaphone:(0,n.register)("megaphone",60190),mention:(0,n.register)("mention",60191),milestone:(0,n.register)("milestone",60192),gitPullRequestMilestone:(0,n.register)("git-pull-request-milestone",60192),mortarBoard:(0,n.register)("mortar-board",60193),move:(0,n.register)("move",60194),multipleWindows:(0,n.register)("multiple-windows",60195),mute:(0,n.register)("mute",60196),noNewline:(0,n.register)("no-newline",60197),note:(0,n.register)("note",60198),octoface:(0,n.register)("octoface",60199),openPreview:(0,n.register)("open-preview",60200),package:(0,n.register)("package",60201),paintcan:(0,n.register)("paintcan",60202),pin:(0,n.register)("pin",60203),play:(0,n.register)("play",60204),run:(0,n.register)("run",60204),plug:(0,n.register)("plug",60205),preserveCase:(0,n.register)("preserve-case",60206),preview:(0,n.register)("preview",60207),project:(0,n.register)("project",60208),pulse:(0,n.register)("pulse",60209),question:(0,n.register)("question",60210),quote:(0,n.register)("quote",60211),radioTower:(0,n.register)("radio-tower",60212),reactions:(0,n.register)("reactions",60213),references:(0,n.register)("references",60214),refresh:(0,n.register)("refresh",60215),regex:(0,n.register)("regex",60216),remoteExplorer:(0,n.register)("remote-explorer",60217),remote:(0,n.register)("remote",60218),remove:(0,n.register)("remove",60219),replaceAll:(0,n.register)("replace-all",60220),replace:(0,n.register)("replace",60221),repoClone:(0,n.register)("repo-clone",60222),repoForcePush:(0,n.register)("repo-force-push",60223),repoPull:(0,n.register)("repo-pull",60224),repoPush:(0,n.register)("repo-push",60225),report:(0,n.register)("report",60226),requestChanges:(0,n.register)("request-changes",60227),rocket:(0,n.register)("rocket",60228),rootFolderOpened:(0,n.register)("root-folder-opened",60229),rootFolder:(0,n.register)("root-folder",60230),rss:(0,n.register)("rss",60231),ruby:(0,n.register)("ruby",60232),saveAll:(0,n.register)("save-all",60233),saveAs:(0,n.register)("save-as",60234),save:(0,n.register)("save",60235),screenFull:(0,n.register)("screen-full",60236),screenNormal:(0,n.register)("screen-normal",60237),searchStop:(0,n.register)("search-stop",60238),server:(0,n.register)("server",60240),settingsGear:(0,n.register)("settings-gear",60241),settings:(0,n.register)("settings",60242),shield:(0,n.register)("shield",60243),smiley:(0,n.register)("smiley",60244),sortPrecedence:(0,n.register)("sort-precedence",60245),splitHorizontal:(0,n.register)("split-horizontal",60246),splitVertical:(0,n.register)("split-vertical",60247),squirrel:(0,n.register)("squirrel",60248),starFull:(0,n.register)("star-full",60249),starHalf:(0,n.register)("star-half",60250),symbolClass:(0,n.register)("symbol-class",60251),symbolColor:(0,n.register)("symbol-color",60252),symbolConstant:(0,n.register)("symbol-constant",60253),symbolEnumMember:(0,n.register)("symbol-enum-member",60254),symbolField:(0,n.register)("symbol-field",60255),symbolFile:(0,n.register)("symbol-file",60256),symbolInterface:(0,n.register)("symbol-interface",60257),symbolKeyword:(0,n.register)("symbol-keyword",60258),symbolMisc:(0,n.register)("symbol-misc",60259),symbolOperator:(0,n.register)("symbol-operator",60260),symbolProperty:(0,n.register)("symbol-property",60261),wrench:(0,n.register)("wrench",60261),wrenchSubaction:(0,n.register)("wrench-subaction",60261),symbolSnippet:(0,n.register)("symbol-snippet",60262),tasklist:(0,n.register)("tasklist",60263),telescope:(0,n.register)("telescope",60264),textSize:(0,n.register)("text-size",60265),threeBars:(0,n.register)("three-bars",60266),thumbsdown:(0,n.register)("thumbsdown",60267),thumbsup:(0,n.register)("thumbsup",60268),tools:(0,n.register)("tools",60269),triangleDown:(0,n.register)("triangle-down",60270),triangleLeft:(0,n.register)("triangle-left",60271),triangleRight:(0,n.register)("triangle-right",60272),triangleUp:(0,n.register)("triangle-up",60273),twitter:(0,n.register)("twitter",60274),unfold:(0,n.register)("unfold",60275),unlock:(0,n.register)("unlock",60276),unmute:(0,n.register)("unmute",60277),unverified:(0,n.register)("unverified",60278),verified:(0,n.register)("verified",60279),versions:(0,n.register)("versions",60280),vmActive:(0,n.register)("vm-active",60281),vmOutline:(0,n.register)("vm-outline",60282),vmRunning:(0,n.register)("vm-running",60283),watch:(0,n.register)("watch",60284),whitespace:(0,n.register)("whitespace",60285),wholeWord:(0,n.register)("whole-word",60286),window:(0,n.register)("window",60287),wordWrap:(0,n.register)("word-wrap",60288),zoomIn:(0,n.register)("zoom-in",60289),zoomOut:(0,n.register)("zoom-out",60290),listFilter:(0,n.register)("list-filter",60291),listFlat:(0,n.register)("list-flat",60292),listSelection:(0,n.register)("list-selection",60293),selection:(0,n.register)("selection",60293),listTree:(0,n.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.register)("debug-stackframe-active",60297),circleSmallFilled:(0,n.register)("circle-small-filled",60298),debugStackframeDot:(0,n.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.register)("terminal-decoration-mark",60298),debugStackframe:(0,n.register)("debug-stackframe",60299),debugStackframeFocused:(0,n.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.register)("debug-breakpoint-unsupported",60300),symbolString:(0,n.register)("symbol-string",60301),debugReverseContinue:(0,n.register)("debug-reverse-continue",60302),debugStepBack:(0,n.register)("debug-step-back",60303),debugRestartFrame:(0,n.register)("debug-restart-frame",60304),debugAlt:(0,n.register)("debug-alt",60305),callIncoming:(0,n.register)("call-incoming",60306),callOutgoing:(0,n.register)("call-outgoing",60307),menu:(0,n.register)("menu",60308),expandAll:(0,n.register)("expand-all",60309),feedback:(0,n.register)("feedback",60310),gitPullRequestReviewer:(0,n.register)("git-pull-request-reviewer",60310),groupByRefType:(0,n.register)("group-by-ref-type",60311),ungroupByRefType:(0,n.register)("ungroup-by-ref-type",60312),account:(0,n.register)("account",60313),gitPullRequestAssignee:(0,n.register)("git-pull-request-assignee",60313),bellDot:(0,n.register)("bell-dot",60314),debugConsole:(0,n.register)("debug-console",60315),library:(0,n.register)("library",60316),output:(0,n.register)("output",60317),runAll:(0,n.register)("run-all",60318),syncIgnored:(0,n.register)("sync-ignored",60319),pinned:(0,n.register)("pinned",60320),githubInverted:(0,n.register)("github-inverted",60321),serverProcess:(0,n.register)("server-process",60322),serverEnvironment:(0,n.register)("server-environment",60323),pass:(0,n.register)("pass",60324),issueClosed:(0,n.register)("issue-closed",60324),stopCircle:(0,n.register)("stop-circle",60325),playCircle:(0,n.register)("play-circle",60326),record:(0,n.register)("record",60327),debugAltSmall:(0,n.register)("debug-alt-small",60328),vmConnect:(0,n.register)("vm-connect",60329),cloud:(0,n.register)("cloud",60330),merge:(0,n.register)("merge",60331),export:(0,n.register)("export",60332),graphLeft:(0,n.register)("graph-left",60333),magnet:(0,n.register)("magnet",60334),notebook:(0,n.register)("notebook",60335),redo:(0,n.register)("redo",60336),checkAll:(0,n.register)("check-all",60337),pinnedDirty:(0,n.register)("pinned-dirty",60338),passFilled:(0,n.register)("pass-filled",60339),circleLargeFilled:(0,n.register)("circle-large-filled",60340),circleLarge:(0,n.register)("circle-large",60341),circleLargeOutline:(0,n.register)("circle-large-outline",60341),combine:(0,n.register)("combine",60342),gather:(0,n.register)("gather",60342),table:(0,n.register)("table",60343),variableGroup:(0,n.register)("variable-group",60344),typeHierarchy:(0,n.register)("type-hierarchy",60345),typeHierarchySub:(0,n.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.register)("git-pull-request-create",60348),runAbove:(0,n.register)("run-above",60349),runBelow:(0,n.register)("run-below",60350),notebookTemplate:(0,n.register)("notebook-template",60351),debugRerun:(0,n.register)("debug-rerun",60352),workspaceTrusted:(0,n.register)("workspace-trusted",60353),workspaceUntrusted:(0,n.register)("workspace-untrusted",60354),workspaceUnknown:(0,n.register)("workspace-unknown",60355),terminalCmd:(0,n.register)("terminal-cmd",60356),terminalDebian:(0,n.register)("terminal-debian",60357),terminalLinux:(0,n.register)("terminal-linux",60358),terminalPowershell:(0,n.register)("terminal-powershell",60359),terminalTmux:(0,n.register)("terminal-tmux",60360),terminalUbuntu:(0,n.register)("terminal-ubuntu",60361),terminalBash:(0,n.register)("terminal-bash",60362),arrowSwap:(0,n.register)("arrow-swap",60363),copy:(0,n.register)("copy",60364),personAdd:(0,n.register)("person-add",60365),filterFilled:(0,n.register)("filter-filled",60366),wand:(0,n.register)("wand",60367),debugLineByLine:(0,n.register)("debug-line-by-line",60368),inspect:(0,n.register)("inspect",60369),layers:(0,n.register)("layers",60370),layersDot:(0,n.register)("layers-dot",60371),layersActive:(0,n.register)("layers-active",60372),compass:(0,n.register)("compass",60373),compassDot:(0,n.register)("compass-dot",60374),compassActive:(0,n.register)("compass-active",60375),azure:(0,n.register)("azure",60376),issueDraft:(0,n.register)("issue-draft",60377),gitPullRequestClosed:(0,n.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.register)("git-pull-request-draft",60379),debugAll:(0,n.register)("debug-all",60380),debugCoverage:(0,n.register)("debug-coverage",60381),runErrors:(0,n.register)("run-errors",60382),folderLibrary:(0,n.register)("folder-library",60383),debugContinueSmall:(0,n.register)("debug-continue-small",60384),beakerStop:(0,n.register)("beaker-stop",60385),graphLine:(0,n.register)("graph-line",60386),graphScatter:(0,n.register)("graph-scatter",60387),pieChart:(0,n.register)("pie-chart",60388),bracket:(0,n.register)("bracket",60175),bracketDot:(0,n.register)("bracket-dot",60389),bracketError:(0,n.register)("bracket-error",60390),lockSmall:(0,n.register)("lock-small",60391),azureDevops:(0,n.register)("azure-devops",60392),verifiedFilled:(0,n.register)("verified-filled",60393),newline:(0,n.register)("newline",60394),layout:(0,n.register)("layout",60395),layoutActivitybarLeft:(0,n.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.register)("layout-panel-left",60398),layoutPanelCenter:(0,n.register)("layout-panel-center",60399),layoutPanelJustify:(0,n.register)("layout-panel-justify",60400),layoutPanelRight:(0,n.register)("layout-panel-right",60401),layoutPanel:(0,n.register)("layout-panel",60402),layoutSidebarLeft:(0,n.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.register)("layout-sidebar-right",60404),layoutStatusbar:(0,n.register)("layout-statusbar",60405),layoutMenubar:(0,n.register)("layout-menubar",60406),layoutCentered:(0,n.register)("layout-centered",60407),target:(0,n.register)("target",60408),indent:(0,n.register)("indent",60409),recordSmall:(0,n.register)("record-small",60410),errorSmall:(0,n.register)("error-small",60411),terminalDecorationError:(0,n.register)("terminal-decoration-error",60411),arrowCircleDown:(0,n.register)("arrow-circle-down",60412),arrowCircleLeft:(0,n.register)("arrow-circle-left",60413),arrowCircleRight:(0,n.register)("arrow-circle-right",60414),arrowCircleUp:(0,n.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.register)("layout-sidebar-left-off",60418),blank:(0,n.register)("blank",60419),heartFilled:(0,n.register)("heart-filled",60420),map:(0,n.register)("map",60421),mapHorizontal:(0,n.register)("map-horizontal",60421),foldHorizontal:(0,n.register)("fold-horizontal",60421),mapFilled:(0,n.register)("map-filled",60422),mapHorizontalFilled:(0,n.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.register)("fold-horizontal-filled",60422),circleSmall:(0,n.register)("circle-small",60423),bellSlash:(0,n.register)("bell-slash",60424),bellSlashDot:(0,n.register)("bell-slash-dot",60425),commentUnresolved:(0,n.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.register)("search-fuzzy",60429),commentDraft:(0,n.register)("comment-draft",60430),send:(0,n.register)("send",60431),sparkle:(0,n.register)("sparkle",60432),insert:(0,n.register)("insert",60433),mic:(0,n.register)("mic",60434),thumbsdownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsupFilled:(0,n.register)("thumbsup-filled",60436),coffee:(0,n.register)("coffee",60437),snake:(0,n.register)("snake",60438),game:(0,n.register)("game",60439),vr:(0,n.register)("vr",60440),chip:(0,n.register)("chip",60441),piano:(0,n.register)("piano",60442),music:(0,n.register)("music",60443),micFilled:(0,n.register)("mic-filled",60444),repoFetch:(0,n.register)("repo-fetch",60445),copilot:(0,n.register)("copilot",60446),lightbulbSparkle:(0,n.register)("lightbulb-sparkle",60447),robot:(0,n.register)("robot",60448),sparkleFilled:(0,n.register)("sparkle-filled",60449),diffSingle:(0,n.register)("diff-single",60450),diffMultiple:(0,n.register)("diff-multiple",60451),surroundWith:(0,n.register)("surround-with",60452),share:(0,n.register)("share",60453),gitStash:(0,n.register)("git-stash",60454),gitStashApply:(0,n.register)("git-stash-apply",60455),gitStashPop:(0,n.register)("git-stash-pop",60456),vscode:(0,n.register)("vscode",60457),vscodeInsiders:(0,n.register)("vscode-insiders",60458),codeOss:(0,n.register)("code-oss",60459),runCoverage:(0,n.register)("run-coverage",60460),runAllCoverage:(0,n.register)("run-all-coverage",60461),coverage:(0,n.register)("coverage",60462),githubProject:(0,n.register)("github-project",60463),mapVertical:(0,n.register)("map-vertical",60464),foldVertical:(0,n.register)("fold-vertical",60464),mapVerticalFilled:(0,n.register)("map-vertical-filled",60465),foldVerticalFilled:(0,n.register)("fold-vertical-filled",60465),goToSearch:(0,n.register)("go-to-search",60466),percentage:(0,n.register)("percentage",60467),sortPercentage:(0,n.register)("sort-percentage",60467),attach:(0,n.register)("attach",60468)}}),define(ce[80],le([0,1,109,148]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=b;function b(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,n.register)("dialog-error","error"),dialogWarning:(0,n.register)("dialog-warning","warning"),dialogInfo:(0,n.register)("dialog-info","info"),dialogClose:(0,n.register)("dialog-close","close"),treeItemExpanded:(0,n.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.register)("tree-filter-clear","close"),treeItemLoading:(0,n.register)("tree-item-loading","loading"),menuSelection:(0,n.register)("menu-selection","check"),menuSubmenu:(0,n.register)("menu-submenu","chevron-right"),menuBarMore:(0,n.register)("menubar-more","more"),scrollbarButtonLeft:(0,n.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.register)("toolbar-more","more"),quickInputBack:(0,n.register)("quick-input-back","arrow-left"),dropDownButton:(0,n.register)("drop-down-button",60084),symbolCustomColor:(0,n.register)("symbol-customcolor",60252),exportIcon:(0,n.register)("export",60332),workspaceUnspecified:(0,n.register)("workspace-unspecified",60355),newLine:(0,n.register)("newline",60394),thumbsDownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.register)("thumbsup-filled",60436),gitFetch:(0,n.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.register)("debug-breakpoint-pending",60377)},e.Codicon={...s.codiconsLibrary,...e.codiconsDerived}}),define(ce[37],le([0,1,11]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=s,e.deepFreeze=b,e.cloneAndChange=L,e.mixin=w,e.equals=c,e.safeStringify=m,e.distinct=u,e.getCaseInsensitive=f,e.filter=v,e.getAllPropertyNames=h,e.getAllMethodNames=g,e.createProxyObject=E,e.mapValues=S;function s(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const D=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([I,i])=>{D[I]=i&&typeof i=="object"?s(i):i}),D}function b(p){if(!p||typeof p!="object")return p;const D=[p];for(;D.length>0;){const I=D.shift();Object.freeze(I);for(const i in I)if(M.call(I,i)){const d=I[i];typeof d=="object"&&!Object.isFrozen(d)&&!(0,n.isTypedArray)(d)&&D.push(d)}}return p}const M=Object.prototype.hasOwnProperty;function L(p,D){return R(p,D,new Set)}function R(p,D,I){if((0,n.isUndefinedOrNull)(p))return p;const i=D(p);if(typeof i<"u")return i;if(Array.isArray(p)){const d=[];for(const t of p)d.push(R(t,D,I));return d}if((0,n.isObject)(p)){if(I.has(p))throw new Error("Cannot clone recursive data-structure");I.add(p);const d={};for(const t in p)M.call(p,t)&&(d[t]=R(p[t],D,I));return I.delete(p),d}return p}function w(p,D,I=!0){return(0,n.isObject)(p)?((0,n.isObject)(D)&&Object.keys(D).forEach(i=>{i in p?I&&((0,n.isObject)(p[i])&&(0,n.isObject)(D[i])?w(p[i],D[i],I):p[i]=D[i]):p[i]=D[i]}),p):D}function c(p,D){if(p===D)return!0;if(p==null||D===null||D===void 0||typeof p!=typeof D||typeof p!="object"||Array.isArray(p)!==Array.isArray(D))return!1;let I,i;if(Array.isArray(p)){if(p.length!==D.length)return!1;for(I=0;I<p.length;I++)if(!c(p[I],D[I]))return!1}else{const d=[];for(i in p)d.push(i);d.sort();const t=[];for(i in D)t.push(i);if(t.sort(),!c(d,t))return!1;for(I=0;I<d.length;I++)if(!c(p[d[I]],D[d[I]]))return!1}return!0}function m(p){const D=new Set;return JSON.stringify(p,(I,i)=>{if((0,n.isObject)(i)||Array.isArray(i)){if(D.has(i))return"[Circular]";D.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function u(p,D){const I=Object.create(null);return!p||!D||Object.keys(D).forEach(d=>{const t=p[d],o=D[d];c(t,o)||(I[d]=o)}),I}function f(p,D){const I=D.toLowerCase(),i=Object.keys(p).find(d=>d.toLowerCase()===I);return i?p[i]:p[D]}function v(p,D){const I=Object.create(null);for(const[i,d]of Object.entries(p))D(i,d)&&(I[i]=d);return I}function h(p){let D=[];for(;Object.prototype!==p;)D=D.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return D}function g(p){const D=[];for(const I of h(p))typeof p[I]=="function"&&D.push(I);return D}function E(p,D){const I=d=>function(){const t=Array.prototype.slice.call(arguments,0);return D(d,t)},i={};for(const d of p)i[d]=I(d);return i}function S(p,D){const I={};for(const[i,d]of Object.entries(p))I[i]=D(d,i);return I}}),define(ce[110],le([0,1,80]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=b;var s;(function(L){function R(w){return w&&typeof w=="object"&&typeof w.id=="string"}L.isThemeColor=R})(s||(e.ThemeColor=s={}));function b(L){return{id:L}}var M;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function w(p){const D=R.exec(p.id);if(!D)return w(n.Codicon.error);const[,I,i]=D,d=["codicon","codicon-"+I];return i&&d.push("codicon-modifier-"+i.substring(1)),d}L.asClassNameArray=w;function c(p){return w(p).join(" ")}L.asClassName=c;function m(p){return"."+w(p).join(".")}L.asCSSSelector=m;function u(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||s.isThemeColor(p.color))}L.isThemeIcon=u;const f=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function v(p){const D=f.exec(p);if(!D)return;const[,I]=D;return{id:I}}L.fromString=v;function h(p){return{id:p}}L.fromId=h;function g(p,D){let I=p.id;const i=I.lastIndexOf("~");return i!==-1&&(I=I.substring(0,i)),D&&(I=`${I}~${D}`),{id:I}}L.modify=g;function E(p){const D=p.id.lastIndexOf("~");if(D!==-1)return p.id.substring(D+1)}L.getModifier=E;function S(p,D){return p.id===D.id&&p.color?.id===D.color?.id}L.isEqual=S})(M||(e.ThemeIcon=M={}))}),define(ce[149],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=s,e.toUint32=b;var n;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function s(M){return M<0?0:M>n.MAX_UINT_8?n.MAX_UINT_8:M|0}function b(M){return M<0?0:M>n.MAX_UINT_32?n.MAX_UINT_32:M|0}}),define(ce[25],le([0,1,146,39,65,149]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=L,e.format=w,e.format2=m,e.htmlAttributeEncodeValue=u,e.escape=f,e.escapeRegExpCharacters=v,e.count=h,e.truncate=g,e.truncateMiddle=E,e.trim=S,e.ltrim=p,e.rtrim=D,e.convertSimple2RegExpPattern=I,e.stripWildcards=i,e.createRegExp=d,e.regExpLeadsToEndlessLoop=t,e.splitLines=o,e.splitLinesIncludeSeparators=r,e.firstNonWhitespaceIndex=a,e.getLeadingWhitespace=l,e.lastNonWhitespaceIndex=P,e.replaceAsync=y,e.compare=k,e.compareSubstring=T,e.compareIgnoreCase=A,e.compareSubstringIgnoreCase=C,e.isAsciiDigit=_,e.isLowerAsciiLetter=H,e.isUpperAsciiLetter=q,e.equalsIgnoreCase=K,e.startsWithIgnoreCase=fe,e.commonPrefixLength=$,e.commonSuffixLength=X,e.isHighSurrogate=B,e.isLowSurrogate=J,e.computeCodePoint=U,e.getNextCodePoint=O,e.nextCharLength=j,e.prevCharLength=ue,e.getCharContainingOffset=se,e.charCount=Y,e.containsRTL=Z,e.isBasicASCII=ie,e.containsUnusualLineTerminators=G,e.isFullWidthCharacter=x,e.isEmojiImprecise=te,e.lcut=de,e.forAnsiStringParts=we,e.removeAnsiEscapeCodes=Re,e.removeAnsiEscapeCodesFromPrompt=ke,e.startsWithUTF8BOM=Ee,e.stripUTF8BOM=pe,e.fuzzyContains=ee,e.containsUppercaseCharacter=ae,e.uppercaseFirstLetter=he,e.getNLines=Se,e.singleLetterHash=Me,e.getGraphemeBreakType=We,e.getLeftDeleteOffset=Je;function L(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const R=/{(\d+)}/g;function w(ne,...ge){return ge.length===0?ne:ne.replace(R,function(ve,ye){const Oe=parseInt(ye,10);return isNaN(Oe)||Oe<0||Oe>=ge.length?ve:ge[Oe]})}const c=/{([^}]+)}/g;function m(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(c,(ve,ye)=>ge[ye]??ve)}function u(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function f(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function v(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function h(ne,ge){let ve=0,ye=ne.indexOf(ge);for(;ye!==-1;)ve++,ye=ne.indexOf(ge,ye+ge.length);return ve}function g(ne,ge,ve="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${ve}`}function E(ne,ge,ve="\u2026"){if(ne.length<=ge)return ne;const ye=Math.ceil(ge/2)-ve.length/2,Oe=Math.floor(ge/2)-ve.length/2;return`${ne.substr(0,ye)}${ve}${ne.substr(ne.length-Oe)}`}function S(ne,ge=" "){const ve=p(ne,ge);return D(ve,ge)}function p(ne,ge){if(!ne||!ge)return ne;const ve=ge.length;if(ve===0||ne.length===0)return ne;let ye=0;for(;ne.indexOf(ge,ye)===ye;)ye=ye+ve;return ne.substring(ye)}function D(ne,ge){if(!ne||!ge)return ne;const ve=ge.length,ye=ne.length;if(ve===0||ye===0)return ne;let Oe=ye,Be=-1;for(;Be=ne.lastIndexOf(ge,Oe-1),!(Be===-1||Be+ve!==Oe);){if(Be===0)return"";Oe=Be}return ne.substring(0,Oe)}function I(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(ne){return ne.replace(/\*/g,"")}function d(ne,ge,ve={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=v(ne)),ve.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let ye="";return ve.global&&(ye+="g"),ve.matchCase||(ye+="i"),ve.multiline&&(ye+="m"),ve.unicode&&(ye+="u"),new RegExp(ne,ye)}function t(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function o(ne){return ne.split(/\r\n|\r|\n/)}function r(ne){const ge=[],ve=ne.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(ve.length/2);ye++)ge.push(ve[2*ye]+(ve[2*ye+1]??""));return ge}function a(ne){for(let ge=0,ve=ne.length;ge<ve;ge++){const ye=ne.charCodeAt(ge);if(ye!==s.CharCode.Space&&ye!==s.CharCode.Tab)return ge}return-1}function l(ne,ge=0,ve=ne.length){for(let ye=ge;ye<ve;ye++){const Oe=ne.charCodeAt(ye);if(Oe!==s.CharCode.Space&&Oe!==s.CharCode.Tab)return ne.substring(ge,ye)}return ne.substring(ge,ve)}function P(ne,ge=ne.length-1){for(let ve=ge;ve>=0;ve--){const ye=ne.charCodeAt(ve);if(ye!==s.CharCode.Space&&ye!==s.CharCode.Tab)return ve}return-1}function y(ne,ge,ve){const ye=[];let Oe=0;for(const Be of ne.matchAll(ge)){if(ye.push(ne.slice(Oe,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Oe=Be.index+Be[0].length,ye.push(ve(Be[0],...Be.slice(1),Be.index,ne,Be.groups))}return ye.push(ne.slice(Oe)),Promise.all(ye).then(Be=>Be.join(""))}function k(ne,ge){return ne<ge?-1:ne>ge?1:0}function T(ne,ge,ve=0,ye=ne.length,Oe=0,Be=ge.length){for(;ve<ye&&Oe<Be;ve++,Oe++){const st=ne.charCodeAt(ve),at=ge.charCodeAt(Oe);if(st<at)return-1;if(st>at)return 1}const Ze=ye-ve,lt=Be-Oe;return Ze<lt?-1:Ze>lt?1:0}function A(ne,ge){return C(ne,ge,0,ne.length,0,ge.length)}function C(ne,ge,ve=0,ye=ne.length,Oe=0,Be=ge.length){for(;ve<ye&&Oe<Be;ve++,Oe++){let st=ne.charCodeAt(ve),at=ge.charCodeAt(Oe);if(st===at)continue;if(st>=128||at>=128)return T(ne.toLowerCase(),ge.toLowerCase(),ve,ye,Oe,Be);H(st)&&(st-=32),H(at)&&(at-=32);const tt=st-at;if(tt!==0)return tt}const Ze=ye-ve,lt=Be-Oe;return Ze<lt?-1:Ze>lt?1:0}function _(ne){return ne>=s.CharCode.Digit0&&ne<=s.CharCode.Digit9}function H(ne){return ne>=s.CharCode.a&&ne<=s.CharCode.z}function q(ne){return ne>=s.CharCode.A&&ne<=s.CharCode.Z}function K(ne,ge){return ne.length===ge.length&&C(ne,ge)===0}function fe(ne,ge){const ve=ge.length;return ge.length>ne.length?!1:C(ne,ge,0,ve)===0}function $(ne,ge){const ve=Math.min(ne.length,ge.length);let ye;for(ye=0;ye<ve;ye++)if(ne.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return ve}function X(ne,ge){const ve=Math.min(ne.length,ge.length);let ye;const Oe=ne.length-1,Be=ge.length-1;for(ye=0;ye<ve;ye++)if(ne.charCodeAt(Oe-ye)!==ge.charCodeAt(Be-ye))return ye;return ve}function B(ne){return 55296<=ne&&ne<=56319}function J(ne){return 56320<=ne&&ne<=57343}function U(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}function O(ne,ge,ve){const ye=ne.charCodeAt(ve);if(B(ye)&&ve+1<ge){const Oe=ne.charCodeAt(ve+1);if(J(Oe))return U(ye,Oe)}return ye}function N(ne,ge){const ve=ne.charCodeAt(ge-1);if(J(ve)&&ge>1){const ye=ne.charCodeAt(ge-2);if(B(ye))return U(ye,ve)}return ve}class Q{get offset(){return this._offset}constructor(ge,ve=0){this._str=ge,this._len=ge.length,this._offset=ve}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=N(this._str,this._offset);return this._offset-=ge>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=O(this._str,this._len,this._offset);return this._offset+=ge>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class oe{get offset(){return this._iterator.offset}constructor(ge,ve=0){this._iterator=new Q(ge,ve)}nextGraphemeLength(){const ge=xe.getInstance(),ve=this._iterator,ye=ve.offset;let Oe=ge.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const Be=ve.offset,Ze=ge.getGraphemeBreakType(ve.nextCodePoint());if(_e(Oe,Ze)){ve.setOffset(Be);break}Oe=Ze}return ve.offset-ye}prevGraphemeLength(){const ge=xe.getInstance(),ve=this._iterator,ye=ve.offset;let Oe=ge.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const Be=ve.offset,Ze=ge.getGraphemeBreakType(ve.prevCodePoint());if(_e(Ze,Oe)){ve.setOffset(Be);break}Oe=Ze}return ye-ve.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=oe;function j(ne,ge){return new oe(ne,ge).nextGraphemeLength()}function ue(ne,ge){return new oe(ne,ge).prevGraphemeLength()}function se(ne,ge){ge>0&&J(ne.charCodeAt(ge))&&ge--;const ve=ge+j(ne,ge);return[ve-ue(ne,ve),ve]}function Y(ne){const ge=new oe(ne);let ve=0;for(;!ge.eol();)ve++,ge.nextGraphemeLength();return ve}let W;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Z(ne){return W||(W=F()),W.test(ne)}const z=/^[\t\n\r\x20-\x7E]*$/;function ie(ne){return z.test(ne)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}function x(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function te(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function de(ne,ge,ve=""){const ye=ne.trimStart();if(ye.length<ge)return ye;const Oe=/\b/g;let Be=0;for(;Oe.test(ye)&&!(ye.length-Oe.lastIndex<ge);)Be=Oe.lastIndex,Oe.lastIndex+=1;return Be===0?ye:ve+ye.substring(Be).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(ne){let ge=0;for(const ve of ne.matchAll(me))ge!==ve.index&&(yield{isCode:!1,str:ne.substring(ge,ve.index)}),yield{isCode:!0,str:ve[0]},ge=ve.index+ve[0].length;ge!==ne.length&&(yield{isCode:!1,str:ne.substring(ge)})}function Re(ne){return ne&&(ne=ne.replace(me,"")),ne}const Ne=/\\\[.*?\\\]/g;function ke(ne){return Re(ne).replace(Ne,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(s.CharCode.UTF8_BOM);function Ee(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===s.CharCode.UTF8_BOM)}function pe(ne){return Ee(ne)?ne.substr(1):ne}function ee(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const ve=ge.length,ye=ne.toLowerCase();let Oe=0,Be=-1;for(;Oe<ve;){const Ze=ye.indexOf(ge[Oe],Be+1);if(Ze<0)return!1;Be=Ze,Oe++}return!0}function ae(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function he(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function Se(ne,ge=1){if(ge===0)return"";let ve=-1;do ve=ne.indexOf(`
`,ve+1),ge--;while(ge>0&&ve>=0);return ve===-1?ne:(ne[ve-1]==="\r"&&ve--,ne.substr(0,ve))}function Me(ne){const ge=s.CharCode.Z-s.CharCode.A+1;return ne=ne%(2*ge),ne<ge?String.fromCharCode(s.CharCode.a+ne):String.fromCharCode(s.CharCode.A+ne-ge)}function We(ne){return xe.getInstance().getGraphemeBreakType(ne)}function _e(ne,ge){return ne===Ae.Other?ge!==Ae.Extend&&ge!==Ae.SpacingMark:ne===Ae.CR&&ge===Ae.LF?!1:ne===Ae.Control||ne===Ae.CR||ne===Ae.LF||ge===Ae.Control||ge===Ae.CR||ge===Ae.LF?!0:!(ne===Ae.L&&(ge===Ae.L||ge===Ae.V||ge===Ae.LV||ge===Ae.LVT)||(ne===Ae.LV||ne===Ae.V)&&(ge===Ae.V||ge===Ae.T)||(ne===Ae.LVT||ne===Ae.T)&&ge===Ae.T||ge===Ae.Extend||ge===Ae.ZWJ||ge===Ae.SpacingMark||ne===Ae.Prepend||ne===Ae.ZWJ&&ge===Ae.Extended_Pictographic||ne===Ae.Regional_Indicator&&ge===Ae.Regional_Indicator)}var Ae;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class xe{static{this._INSTANCE=null}static getInstance(){return xe._INSTANCE||(xe._INSTANCE=new xe),xe._INSTANCE}constructor(){this._data=Ge()}getGraphemeBreakType(ge){if(ge<32)return ge===s.CharCode.LineFeed?Ae.LF:ge===s.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(ge<127)return Ae.Other;const ve=this._data,ye=ve.length/3;let Oe=1;for(;Oe<=ye;)if(ge<ve[3*Oe])Oe=2*Oe;else if(ge>ve[3*Oe+1])Oe=2*Oe+1;else return ve[3*Oe+2];return Ae.Other}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(ne,ge){if(ne===0)return 0;const ve=qe(ne,ge);if(ve!==void 0)return ve;const ye=new Q(ge,ne);return ye.prevCodePoint(),ye.offset}function qe(ne,ge){const ve=new Q(ge,ne);let ye=ve.prevCodePoint();for(;Qe(ye)||ye===Ye.emojiVariantSelector||ye===Ye.enclosingKeyCap;){if(ve.offset===0)return;ye=ve.prevCodePoint()}if(!te(ye))return;let Oe=ve.offset;return Oe>0&&ve.prevCodePoint()===Ye.zwj&&(Oe=ve.offset),Oe}function Qe(ne){return 127995<=ne&&ne<=127999}var Ye;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.noBreakWhitespace="\xA0";class Xe{static{this.ambiguousCharacterData=new b.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new n.LRUCachedFunction({getCacheKey:JSON.stringify},ge=>{function ve(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ht,gt]of ut)ct.set(ht,gt);return ct}function Oe(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ht,gt]of tt)ut.has(ht)&&ct.set(ht,gt);return ct}const Be=this.ambiguousCharacterData.value;let Ze=ge.filter(tt=>!tt.startsWith("_")&&tt in Be);Ze.length===0&&(Ze=["_default"]);let lt;for(const tt of Ze){const ut=ve(Be[tt]);lt=Oe(lt,ut)}const st=ve(Be._common),at=ye(st,lt);return new Xe(at)})}static getInstance(ge){return Xe.cache.get(Array.from(ge))}static{this._locales=new b.Lazy(()=>Object.keys(Xe.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Xe._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}containsAmbiguousCharacter(ge){for(let ve=0;ve<ge.length;ve++){const ye=ge.codePointAt(ve);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Xe;class Ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ue.getRawData())),this._data}static isInvisibleCharacter(ge){return Ue.getData().has(ge)}static containsInvisibleCharacter(ge){for(let ve=0;ve<ge.length;ve++){const ye=ge.codePointAt(ve);if(typeof ye=="number"&&Ue.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ue.getData()}}e.InvisibleCharacters=Ue}),define(ce[32],le([0,1,39,9,3,25,11]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=w,e.toPosixPath=c,e.getRoot=m,e.isUNC=u,e.isValidBasename=g,e.isEqual=E,e.isEqualOrParent=S,e.isWindowsDriveLetter=p,e.sanitizeFilePath=D,e.removeTrailingPathSeparator=I,e.isRootOrDriveLetter=i,e.hasDriveLetter=d,e.getDriveLetter=t,e.indexOfPath=o,e.parseLineAndColumnAware=r,e.randomPath=P;function R(y){return y===n.CharCode.Slash||y===n.CharCode.Backslash}function w(y){return y.replace(/[\\/]/g,s.posix.sep)}function c(y){return y.indexOf("/")===-1&&(y=w(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function m(y,k=s.posix.sep){if(!y)return"";const T=y.length,A=y.charCodeAt(0);if(R(A)){if(R(y.charCodeAt(1))&&!R(y.charCodeAt(2))){let _=3;const H=_;for(;_<T&&!R(y.charCodeAt(_));_++);if(H!==_&&!R(y.charCodeAt(_+1))){for(_+=1;_<T;_++)if(R(y.charCodeAt(_)))return y.slice(0,_+1).replace(/[\\/]/g,k)}}return k}else if(p(A)&&y.charCodeAt(1)===n.CharCode.Colon)return R(y.charCodeAt(2))?y.slice(0,2)+k:y.slice(0,2);let C=y.indexOf("://");if(C!==-1){for(C+=3;C<T;C++)if(R(y.charCodeAt(C)))return y.slice(0,C+1)}return""}function u(y){if(!b.isWindows||!y||y.length<5)return!1;let k=y.charCodeAt(0);if(k!==n.CharCode.Backslash||(k=y.charCodeAt(1),k!==n.CharCode.Backslash))return!1;let T=2;const A=T;for(;T<y.length&&(k=y.charCodeAt(T),k!==n.CharCode.Backslash);T++);return!(A===T||(k=y.charCodeAt(T+1),isNaN(k)||k===n.CharCode.Backslash))}const f=/[\\/:\*\?"<>\|]/g,v=/[/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(y,k=b.isWindows){const T=k?f:v;return!(!y||y.length===0||/^\s+$/.test(y)||(T.lastIndex=0,T.test(y))||k&&h.test(y)||y==="."||y===".."||k&&y[y.length-1]==="."||k&&y.length!==y.trim().length||y.length>255)}function E(y,k,T){const A=y===k;return!T||A?A:!y||!k?!1:(0,M.equalsIgnoreCase)(y,k)}function S(y,k,T,A=s.sep){if(y===k)return!0;if(!y||!k||k.length>y.length)return!1;if(T){if(!(0,M.startsWithIgnoreCase)(y,k))return!1;if(k.length===y.length)return!0;let _=k.length;return k.charAt(k.length-1)===A&&_--,y.charAt(_)===A}return k.charAt(k.length-1)!==A&&(k+=A),y.indexOf(k)===0}function p(y){return y>=n.CharCode.A&&y<=n.CharCode.Z||y>=n.CharCode.a&&y<=n.CharCode.z}function D(y,k){return b.isWindows&&y.endsWith(":")&&(y+=s.sep),(0,s.isAbsolute)(y)||(y=(0,s.join)(k,y)),y=(0,s.normalize)(y),I(y)}function I(y){return b.isWindows?(y=(0,M.rtrim)(y,s.sep),y.endsWith(":")&&(y+=s.sep)):(y=(0,M.rtrim)(y,s.sep),y||(y=s.sep)),y}function i(y){const k=(0,s.normalize)(y);return b.isWindows?y.length>3?!1:d(k)&&(y.length===2||k.charCodeAt(2)===n.CharCode.Backslash):k===s.posix.sep}function d(y,k=b.isWindows){return k?p(y.charCodeAt(0))&&y.charCodeAt(1)===n.CharCode.Colon:!1}function t(y,k=b.isWindows){return d(y,k)?y[0]:void 0}function o(y,k,T){return k.length>y.length?-1:y===k?0:(T&&(y=y.toLowerCase(),k=k.toLowerCase()),y.indexOf(k))}function r(y){const k=y.split(":");let T,A,C;for(const _ of k){const H=Number(_);(0,L.isNumber)(H)?A===void 0?A=H:C===void 0&&(C=H):T=T?[T,_].join(":"):_}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:A!==void 0?A:void 0,column:C!==void 0?C:A!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function P(y,k,T=8){let A="";for(let _=0;_<T;_++){let H;_===0&&b.isWindows&&!k&&(T===3||T===4)?H=l:H=a,A+=H.charAt(Math.floor(Math.random()*H.length))}let C;return k?C=`${k}-${A}`:C=A,y?(0,s.join)(y,C):C}}),define(ce[46],le([0,1,25]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=s,e.doHash=b,e.numberHash=M,e.stringHash=R,e.toHexString=g,n=De(n);function s(S){return b(S,0)}function b(S,p){switch(typeof S){case"object":return S===null?M(349,p):Array.isArray(S)?w(S,p):c(S,p);case"string":return R(S,p);case"boolean":return L(S,p);case"number":return M(S,p);case"undefined":return M(937,p);default:return M(617,p)}}function M(S,p){return(p<<5)-p+S|0}function L(S,p){return M(S?433:863,p)}function R(S,p){p=M(149417,p);for(let D=0,I=S.length;D<I;D++)p=M(S.charCodeAt(D),p);return p}function w(S,p){return p=M(104579,p),S.reduce((D,I)=>b(I,D),p)}function c(S,p){return p=M(181387,p),Object.keys(S).sort().reduce((D,I)=>(D=R(I,D),b(S[I],D)),p)}class m{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=b(p,this._value),this._value}}e.Hasher=m;var u;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function f(S,p,D=32){const I=D-p,i=~((1<<I)-1);return(S<<p|(i&S)>>>I)>>>0}function v(S,p=0,D=S.byteLength,I=0){for(let i=0;i<D;i++)S[p+i]=I}function h(S,p,D="0"){for(;S.length<p;)S=D+S;return S}function g(S,p=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(D=>D.toString(16).padStart(2,"0")).join(""):h((S>>>0).toString(16),p/4)}class E{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(u.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const D=p.length;if(D===0)return;const I=this._buff;let i=this._buffLen,d=this._leftoverHighSurrogate,t,o;for(d!==0?(t=d,o=-1,d=0):(t=p.charCodeAt(0),o=0);;){let r=t;if(n.isHighSurrogate(t))if(o+1<D){const a=p.charCodeAt(o+1);n.isLowSurrogate(a)?(o++,r=n.computeCodePoint(t,a)):r=u.UNICODE_REPLACEMENT}else{d=t;break}else n.isLowSurrogate(t)&&(r=u.UNICODE_REPLACEMENT);if(i=this._push(I,i,r),o++,o<D)t=p.charCodeAt(o);else break}this._buffLen=i,this._leftoverHighSurrogate=d}_push(p,D,I){return I<128?p[D++]=I:I<2048?(p[D++]=192|(I&1984)>>>6,p[D++]=128|(I&63)>>>0):I<65536?(p[D++]=224|(I&61440)>>>12,p[D++]=128|(I&4032)>>>6,p[D++]=128|(I&63)>>>0):(p[D++]=240|(I&1835008)>>>18,p[D++]=128|(I&258048)>>>12,p[D++]=128|(I&4032)>>>6,p[D++]=128|(I&63)>>>0),D>=u.BLOCK_SIZE&&(this._step(),D-=u.BLOCK_SIZE,this._totalLen+=u.BLOCK_SIZE,p[0]=p[u.BLOCK_SIZE+0],p[1]=p[u.BLOCK_SIZE+1],p[2]=p[u.BLOCK_SIZE+2]),D}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,u.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=E._bigBlock32,D=this._buffDV;for(let P=0;P<64;P+=4)p.setUint32(P,D.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)p.setUint32(P,f(p.getUint32(P-12,!1)^p.getUint32(P-32,!1)^p.getUint32(P-56,!1)^p.getUint32(P-64,!1),1),!1);let I=this._h0,i=this._h1,d=this._h2,t=this._h3,o=this._h4,r,a,l;for(let P=0;P<80;P++)P<20?(r=i&d|~i&t,a=1518500249):P<40?(r=i^d^t,a=1859775393):P<60?(r=i&d|i&t|d&t,a=2400959708):(r=i^d^t,a=3395469782),l=f(I,5)+r+o+a+p.getUint32(P*4,!1)&4294967295,o=t,t=d,d=f(i,30),i=I,I=l;this._h0=this._h0+I&4294967295,this._h1=this._h1+i&4294967295,this._h2=this._h2+d&4294967295,this._h3=this._h3+t&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=E}),define(ce[81],le([0,1,25]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=De(n);var s;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(s||(s={})),function(b){const M="error",L="warning",R="warn",w="info",c="ignore";function m(f){return f?n.equalsIgnoreCase(M,f)?b.Error:n.equalsIgnoreCase(L,f)||n.equalsIgnoreCase(R,f)?b.Warning:n.equalsIgnoreCase(w,f)?b.Info:b.Ignore:b.Ignore}b.fromValue=m;function u(f){switch(f){case b.Error:return M;case b.Warning:return L;case b.Info:return w;default:return c}}b.toString=u}(s||(s={})),e.default=s}),define(ce[60],le([0,1,21,39,25]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class M{constructor(){this._value="",this._pos=0}reset(h){return this._value=h,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(h){const g=h.charCodeAt(0),E=this._value.charCodeAt(this._pos);return g-E}value(){return this._value[this._pos]}}e.StringIterator=M;class L{constructor(h=!0){this._caseSensitive=h}reset(h){return this._value=h,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let h=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===s.CharCode.Period)if(h)this._from++;else break;else h=!1;return this}cmp(h){return this._caseSensitive?(0,b.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,b.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class R{constructor(h=!0,g=!0){this._splitOnBackslash=h,this._caseSensitive=g}reset(h){this._from=0,this._to=0,this._value=h,this._valueLen=h.length;for(let g=h.length-1;g>=0;g--,this._valueLen--){const E=this._value.charCodeAt(g);if(!(E===s.CharCode.Slash||this._splitOnBackslash&&E===s.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let h=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===s.CharCode.Slash||this._splitOnBackslash&&g===s.CharCode.Backslash)if(h)this._from++;else break;else h=!1}return this}cmp(h){return this._caseSensitive?(0,b.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,b.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var w;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(w||(w={}));class c{constructor(h,g){this._ignorePathCasing=h,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(h){return this._value=h,this._states=[],this._value.scheme&&this._states.push(w.Scheme),this._value.authority&&this._states.push(w.Authority),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(h)),this._pathIterator.reset(h.path),this._pathIterator.value()&&this._states.push(w.Path)),this._ignoreQueryAndFragment(h)||(this._value.query&&this._states.push(w.Query),this._value.fragment&&this._states.push(w.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===w.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===w.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(h){if(this._states[this._stateIdx]===w.Scheme)return(0,b.compareIgnoreCase)(h,this._value.scheme);if(this._states[this._stateIdx]===w.Authority)return(0,b.compareIgnoreCase)(h,this._value.authority);if(this._states[this._stateIdx]===w.Path)return this._pathIterator.cmp(h);if(this._states[this._stateIdx]===w.Query)return(0,b.compare)(h,this._value.query);if(this._states[this._stateIdx]===w.Fragment)return(0,b.compare)(h,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===w.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===w.Authority)return this._value.authority;if(this._states[this._stateIdx]===w.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===w.Query)return this._value.query;if(this._states[this._stateIdx]===w.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=c;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(u||(u={}));class f{static forUris(h=()=>!1,g=()=>!1){return new f(new c(h,g))}static forPaths(h=!1){return new f(new R(void 0,!h))}static forStrings(){return new f(new M)}static forConfigKeys(){return new f(new L)}constructor(h){this._iter=h}clear(){this._root=void 0}fill(h,g){if(g){const E=g.slice(0);(0,n.shuffle)(E);for(const S of E)this.set(S,h)}else{const E=h.slice(0);(0,n.shuffle)(E);for(const S of E)this.set(S[0],S[1])}}set(h,g){const E=this._iter.reset(h);let S;this._root||(this._root=new m,this._root.segment=E.value());const p=[];for(S=this._root;;){const I=E.cmp(S.segment);if(I>0)S.left||(S.left=new m,S.left.segment=E.value()),p.push([u.Left,S]),S=S.left;else if(I<0)S.right||(S.right=new m,S.right.segment=E.value()),p.push([u.Right,S]),S=S.right;else if(E.hasNext())E.next(),S.mid||(S.mid=new m,S.mid.segment=E.value()),p.push([u.Mid,S]),S=S.mid;else break}const D=S.value;S.value=g,S.key=h;for(let I=p.length-1;I>=0;I--){const i=p[I][1];i.updateHeight();const d=i.balanceFactor();if(d<-1||d>1){const t=p[I][0],o=p[I+1][0];if(t===u.Right&&o===u.Right)p[I][1]=i.rotateLeft();else if(t===u.Left&&o===u.Left)p[I][1]=i.rotateRight();else if(t===u.Right&&o===u.Left)i.right=p[I+1][1]=p[I+1][1].rotateRight(),p[I][1]=i.rotateLeft();else if(t===u.Left&&o===u.Right)i.left=p[I+1][1]=p[I+1][1].rotateLeft(),p[I][1]=i.rotateRight();else throw new Error;if(I>0)switch(p[I-1][0]){case u.Left:p[I-1][1].left=p[I][1];break;case u.Right:p[I-1][1].right=p[I][1];break;case u.Mid:p[I-1][1].mid=p[I][1];break}else this._root=p[0][1]}}return D}get(h){return this._getNode(h)?.value}_getNode(h){const g=this._iter.reset(h);let E=this._root;for(;E;){const S=g.cmp(E.segment);if(S>0)E=E.left;else if(S<0)E=E.right;else if(g.hasNext())g.next(),E=E.mid;else break}return E}has(h){const g=this._getNode(h);return!(g?.value===void 0&&g?.mid===void 0)}delete(h){return this._delete(h,!1)}deleteSuperstr(h){return this._delete(h,!0)}_delete(h,g){const E=this._iter.reset(h),S=[];let p=this._root;for(;p;){const D=E.cmp(p.segment);if(D>0)S.push([u.Left,p]),p=p.left;else if(D<0)S.push([u.Right,p]),p=p.right;else if(E.hasNext())E.next(),S.push([u.Mid,p]),p=p.mid;else break}if(p){if(g?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const D=this._min(p.right);if(D.key){const{key:I,value:i,segment:d}=D;this._delete(D.key,!1),p.key=I,p.value=i,p.segment=d}}else{const D=p.left??p.right;if(S.length>0){const[I,i]=S[S.length-1];switch(I){case u.Left:i.left=D;break;case u.Mid:i.mid=D;break;case u.Right:i.right=D;break}}else this._root=D}for(let D=S.length-1;D>=0;D--){const I=S[D][1];I.updateHeight();const i=I.balanceFactor();if(i>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),S[D][1]=I.rotateLeft()):i<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),S[D][1]=I.rotateRight()),D>0)switch(S[D-1][0]){case u.Left:S[D-1][1].left=S[D][1];break;case u.Right:S[D-1][1].right=S[D][1];break;case u.Mid:S[D-1][1].mid=S[D][1];break}else this._root=S[0][1]}}}_min(h){for(;h.left;)h=h.left;return h}findSubstr(h){const g=this._iter.reset(h);let E=this._root,S;for(;E;){const p=g.cmp(E.segment);if(p>0)E=E.left;else if(p<0)E=E.right;else if(g.hasNext())g.next(),S=E.value||S,E=E.mid;else break}return E&&E.value||S}findSuperstr(h){return this._findSuperstrOrElement(h,!1)}_findSuperstrOrElement(h,g){const E=this._iter.reset(h);let S=this._root;for(;S;){const p=E.cmp(S.segment);if(p>0)S=S.left;else if(p<0)S=S.right;else if(E.hasNext())E.next(),S=S.mid;else return S.mid?this._entries(S.mid):g?S.value:void 0}}hasElementOrSubtree(h){return this._findSuperstrOrElement(h,!0)!==void 0}forEach(h){for(const[g,E]of this)h(E,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(h){const g=[];return this._dfsEntries(h,g),g[Symbol.iterator]()}_dfsEntries(h,g){h&&(h.left&&this._dfsEntries(h.left,g),h.value&&g.push([h.key,h.value]),h.mid&&this._dfsEntries(h.mid,g),h.right&&this._dfsEntries(h.right,g))}_isBalanced(){const h=g=>{if(!g)return!0;const E=g.balanceFactor();return E<-1||E>1?!1:h(g.left)&&h(g.right)};return h(this._root)}}e.TernarySearchTree=f}),define(ce[7],le([0,1,39,90,9,3]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=E,e.uriToFsPath=d,b=De(b);const L=/^\w[\w\d+.-]*$/,R=/^\//,w=/^\/\//;function c(l,P){if(!l.scheme&&P)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!L.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!R.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(l,P){return!l&&!P?"file":l}function u(l,P){switch(l){case"https":case"http":case"file":P?P[0]!==v&&(P=v+P):P=v;break}return P}const f="",v="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(P){return P instanceof g?!0:P?typeof P.authority=="string"&&typeof P.fragment=="string"&&typeof P.path=="string"&&typeof P.query=="string"&&typeof P.scheme=="string"&&typeof P.fsPath=="string"&&typeof P.with=="function"&&typeof P.toString=="function":!1}constructor(P,y,k,T,A,C=!1){typeof P=="object"?(this.scheme=P.scheme||f,this.authority=P.authority||f,this.path=P.path||f,this.query=P.query||f,this.fragment=P.fragment||f):(this.scheme=m(P,C),this.authority=y||f,this.path=u(this.scheme,k||f),this.query=T||f,this.fragment=A||f,c(this,C))}get fsPath(){return d(this,!1)}with(P){if(!P)return this;let{scheme:y,authority:k,path:T,query:A,fragment:C}=P;return y===void 0?y=this.scheme:y===null&&(y=f),k===void 0?k=this.authority:k===null&&(k=f),T===void 0?T=this.path:T===null&&(T=f),A===void 0?A=this.query:A===null&&(A=f),C===void 0?C=this.fragment:C===null&&(C=f),y===this.scheme&&k===this.authority&&T===this.path&&A===this.query&&C===this.fragment?this:new p(y,k,T,A,C)}static parse(P,y=!1){const k=h.exec(P);return k?new p(k[2]||f,a(k[4]||f),a(k[5]||f),a(k[7]||f),a(k[9]||f),y):new p(f,f,f,f,f)}static file(P){let y=f;if(M.isWindows&&(P=P.replace(/\\/g,v)),P[0]===v&&P[1]===v){const k=P.indexOf(v,2);k===-1?(y=P.substring(2),P=v):(y=P.substring(2,k),P=P.substring(k)||v)}return new p("file",y,P,f,f)}static from(P,y){return new p(P.scheme,P.authority,P.path,P.query,P.fragment,y)}static joinPath(P,...y){if(!P.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return M.isWindows&&P.scheme==="file"?k=g.file(b.win32.join(d(P,!0),...y)).path:k=b.posix.join(P.path,...y),P.with({path:k})}toString(P=!1){return t(this,P)}toJSON(){return this}static revive(P){if(P){if(P instanceof g)return P;{const y=new p(P);return y._formatted=P.external??null,y._fsPath=P._sep===S?P.fsPath??null:null,y}}else return P}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=g;function E(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const S=M.isWindows?1:void 0;class p extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(P=!1){return P?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const P={$mid:s.MarshalledId.Uri};return this._fsPath&&(P.fsPath=this._fsPath,P._sep=S),this._formatted&&(P.external=this._formatted),this.path&&(P.path=this.path),this.scheme&&(P.scheme=this.scheme),this.authority&&(P.authority=this.authority),this.query&&(P.query=this.query),this.fragment&&(P.fragment=this.fragment),P}}const D={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function I(l,P,y){let k,T=-1;for(let A=0;A<l.length;A++){const C=l.charCodeAt(A);if(C>=n.CharCode.a&&C<=n.CharCode.z||C>=n.CharCode.A&&C<=n.CharCode.Z||C>=n.CharCode.Digit0&&C<=n.CharCode.Digit9||C===n.CharCode.Dash||C===n.CharCode.Period||C===n.CharCode.Underline||C===n.CharCode.Tilde||P&&C===n.CharCode.Slash||y&&C===n.CharCode.OpenSquareBracket||y&&C===n.CharCode.CloseSquareBracket||y&&C===n.CharCode.Colon)T!==-1&&(k+=encodeURIComponent(l.substring(T,A)),T=-1),k!==void 0&&(k+=l.charAt(A));else{k===void 0&&(k=l.substr(0,A));const _=D[C];_!==void 0?(T!==-1&&(k+=encodeURIComponent(l.substring(T,A)),T=-1),k+=_):T===-1&&(T=A)}}return T!==-1&&(k+=encodeURIComponent(l.substring(T))),k!==void 0?k:l}function i(l){let P;for(let y=0;y<l.length;y++){const k=l.charCodeAt(y);k===n.CharCode.Hash||k===n.CharCode.QuestionMark?(P===void 0&&(P=l.substr(0,y)),P+=D[k]):P!==void 0&&(P+=l[y])}return P!==void 0?P:l}function d(l,P){let y;return l.authority&&l.path.length>1&&l.scheme==="file"?y=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===n.CharCode.Slash&&(l.path.charCodeAt(1)>=n.CharCode.A&&l.path.charCodeAt(1)<=n.CharCode.Z||l.path.charCodeAt(1)>=n.CharCode.a&&l.path.charCodeAt(1)<=n.CharCode.z)&&l.path.charCodeAt(2)===n.CharCode.Colon?P?y=l.path.substr(1):y=l.path[1].toLowerCase()+l.path.substr(2):y=l.path,M.isWindows&&(y=y.replace(/\//g,"\\")),y}function t(l,P){const y=P?i:I;let k="",{scheme:T,authority:A,path:C,query:_,fragment:H}=l;if(T&&(k+=T,k+=":"),(A||T==="file")&&(k+=v,k+=v),A){let q=A.indexOf("@");if(q!==-1){const K=A.substr(0,q);A=A.substr(q+1),q=K.lastIndexOf(":"),q===-1?k+=y(K,!1,!1):(k+=y(K.substr(0,q),!1,!1),k+=":",k+=y(K.substr(q+1),!1,!0)),k+="@"}A=A.toLowerCase(),q=A.lastIndexOf(":"),q===-1?k+=y(A,!1,!0):(k+=y(A.substr(0,q),!1,!0),k+=A.substr(q))}if(C){if(C.length>=3&&C.charCodeAt(0)===n.CharCode.Slash&&C.charCodeAt(2)===n.CharCode.Colon){const q=C.charCodeAt(1);q>=n.CharCode.A&&q<=n.CharCode.Z&&(C=`/${String.fromCharCode(q+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===n.CharCode.Colon){const q=C.charCodeAt(0);q>=n.CharCode.A&&q<=n.CharCode.Z&&(C=`${String.fromCharCode(q+32)}:${C.substr(2)}`)}k+=y(C,!0,!1)}return _&&(k+="?",k+=y(_,!1,!1)),H&&(k+="#",k+=P?H:I(H,!1,!1)),k}function o(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+o(l.substr(3)):l}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(l){return l.match(r)?l.replace(r,P=>o(P)):l}}),define(ce[150],le([0,1,7]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=s,e.parse=b,e.getFirstFrame=M,e.log=R;function s(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}function b(c){const m=[];let u;try{const f=JSON.parse(c.arguments),v=f[f.length-1];v&&v.__$stack&&(f.pop(),u=v.__$stack),m.push(...f)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:u}}function M(c){if(typeof c!="string")return M(b(c).stack);const m=c;if(m){const u=L(m),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(f&&f.length===4)return{uri:n.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function L(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function R(c,m){const{args:u,stack:f}=b(c),v=typeof u[0]=="string"&&u.length===1;let h=L(f);h&&(h=`(${h.trim()})`);let g=[];if(typeof u[0]=="string"?h&&v?g=[`%c[${m}] %c${u[0]} %c${h}`,w("blue"),w(""),w("grey")]:g=[`%c[${m}] %c${u[0]}`,w("blue"),w(""),...u.slice(1)]:g=[`%c[${m}]%`,w("blue"),...u],h&&!v&&g.push(h),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,g)}function w(c){return`color: ${c}`}}),define(ce[82],le([0,1,17,7,90]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=M,e.parse=L,e.revive=w;function M(c){return JSON.stringify(c,R)}function L(c){let m=JSON.parse(c);return m=w(m),m}function R(c,m){return m instanceof RegExp?{$mid:b.MarshalledId.Regexp,source:m.source,flags:m.flags}:m}function w(c,m=0){if(!c||m>200)return c;if(typeof c=="object"){switch(c.$mid){case b.MarshalledId.Uri:return s.URI.revive(c);case b.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case b.MarshalledId.Date:return new Date(c.source)}if(c instanceof n.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let u=0;u<c.length;++u)c[u]=w(c[u],m+1);else for(const u in c)Object.hasOwnProperty.call(c,u)&&(c[u]=w(c[u],m+1))}return c}}),define(ce[12],le([0,1,15,3,25,7,9]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=w,e.matchesSomeScheme=c,e.getServerRootPath=u,n=De(n),s=De(s),L=De(L);var R;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",h.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(R||(e.Schemas=R={}));function w(h,g){return M.URI.isUri(h)?(0,b.equalsIgnoreCase)(h.scheme,g):(0,b.startsWithIgnoreCase)(h,g+":")}function c(h,...g){return g.some(E=>w(h,E))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class m{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g,E){this._serverRootPath=u(g,E)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return L.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(g,E,S){this._hosts[g]=E,this._ports[g]=S}setConnectionToken(g,E){this._connectionTokens[g]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)try{return this._delegate(g)}catch(i){return n.onUnexpectedError(i),g}const E=g.authority;let S=this._hosts[E];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const p=this._ports[E],D=this._connectionTokens[E];let I=`path=${encodeURIComponent(g.path)}`;return typeof D=="string"&&(I+=`&${e.connectionTokenQueryName}=${encodeURIComponent(D)}`),M.URI.from({scheme:s.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${S}:${p}`,path:this._remoteResourcesPath,query:I})}}e.RemoteAuthorities=new m;function u(h,g){return L.posix.join(g??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class f{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(g){const E=this.toUri(g,V);return this.uriToBrowserUri(E)}uriToBrowserUri(g){return g.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(g):g.scheme===R.file&&(s.isNative||s.webWorkerOrigin===`${R.vscodeFileResource}://${f.FALLBACK_AUTHORITY}`)?g.with({scheme:R.vscodeFileResource,authority:g.authority||f.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(g){const E=this.toUri(g,V);return this.uriToFileUri(E)}uriToFileUri(g){return g.scheme===R.vscodeFileResource?g.with({scheme:R.file,authority:g.authority!==f.FALLBACK_AUTHORITY?g.authority:null,query:null,fragment:null}):g}toUri(g,E){return M.URI.isUri(g)?g:M.URI.parse(E.toUrl(g))}}e.FileAccess=new f;var v;(function(h){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(g.get("3"));const E="vscode-coi";function S(D){let I;typeof D=="string"?I=new URL(D).searchParams:D instanceof URL?I=D.searchParams:M.URI.isUri(D)&&(I=new URL(D.toString(!0)).searchParams);const i=I?.get(E);if(i)return g.get(i)}h.getHeadersFromQuery=S;function p(D,I,i){if(!globalThis.crossOriginIsolated)return;const d=I&&i?"3":i?"2":"1";D instanceof URLSearchParams?D.set(E,d):D[E]=d}h.addSearchParam=p})(v||(e.COI=v={}))}),define(ce[18],le([0,1,39,32,12,9,3,25,7]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=c,e.distinctParents=u,e.toLocalResource=v,s=De(s),M=De(M);function c(h){return(0,w.uriToFsPath)(h,!0)}class m{constructor(g){this._ignorePathCasing=g}compare(g,E,S=!1){return g===E?0:(0,R.compare)(this.getComparisonKey(g,S),this.getComparisonKey(E,S))}isEqual(g,E,S=!1){return g===E?!0:!g||!E?!1:this.getComparisonKey(g,S)===this.getComparisonKey(E,S)}getComparisonKey(g,E=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,E,S=!1){if(g.scheme===E.scheme){if(g.scheme===b.Schemas.file)return s.isEqualOrParent(c(g),c(E),this._ignorePathCasing(g))&&g.query===E.query&&(S||g.fragment===E.fragment);if((0,e.isEqualAuthority)(g.authority,E.authority))return s.isEqualOrParent(g.path,E.path,this._ignorePathCasing(g),"/")&&g.query===E.query&&(S||g.fragment===E.fragment)}return!1}joinPath(g,...E){return w.URI.joinPath(g,...E)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return M.posix.basename(g.path)}extname(g){return M.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let E;return g.scheme===b.Schemas.file?E=w.URI.file(M.dirname(c(g))).path:(E=M.posix.dirname(g.path),g.authority&&E.length&&E.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),E="/")),g.with({path:E})}normalizePath(g){if(!g.path.length)return g;let E;return g.scheme===b.Schemas.file?E=w.URI.file(M.normalize(c(g))).path:E=M.posix.normalize(g.path),g.with({path:E})}relativePath(g,E){if(g.scheme!==E.scheme||!(0,e.isEqualAuthority)(g.authority,E.authority))return;if(g.scheme===b.Schemas.file){const D=M.relative(c(g),c(E));return L.isWindows?s.toSlashes(D):D}let S=g.path||"/";const p=E.path||"/";if(this._ignorePathCasing(g)){let D=0;for(const I=Math.min(S.length,p.length);D<I&&!(S.charCodeAt(D)!==p.charCodeAt(D)&&S.charAt(D).toLowerCase()!==p.charAt(D).toLowerCase());D++);S=p.substr(0,D)+S.substr(D)}return M.posix.relative(S,p)}resolvePath(g,E){if(g.scheme===b.Schemas.file){const S=w.URI.file(M.resolve(c(g),E));return g.with({authority:S.authority,path:S.path})}return E=s.toPosixPath(E),g.with({path:M.posix.resolve(g.path,E)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,E){return g===E||g!==void 0&&E!==void 0&&(0,R.equalsIgnoreCase)(g,E)}hasTrailingPathSeparator(g,E=M.sep){if(g.scheme===b.Schemas.file){const S=c(g);return S.length>s.getRoot(S).length&&S[S.length-1]===E}else{const S=g.path;return S.length>1&&S.charCodeAt(S.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,E=M.sep){return(0,e.hasTrailingPathSeparator)(g,E)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,E=M.sep){let S=!1;if(g.scheme===b.Schemas.file){const p=c(g);S=p!==void 0&&p.length===s.getRoot(p).length&&p[p.length-1]===E}else{E="/";const p=g.path;S=p.length===1&&p.charCodeAt(p.length-1)===n.CharCode.Slash}return!S&&!(0,e.hasTrailingPathSeparator)(g,E)?g.with({path:g.path+"/"}):g}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(h=>h.scheme===b.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new m(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function u(h,g){const E=[];for(let S=0;S<h.length;S++){const p=g(h[S]);h.some((D,I)=>I===S?!1:(0,e.isEqualOrParent)(p,g(D)))||E.push(h[S])}return E}var f;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function g(E){const S=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(I=>{const[i,d]=I.split(":");i&&d&&S.set(i,d)});const D=E.path.substring(0,E.path.indexOf(";"));return D&&S.set(h.META_DATA_MIME,D),S}h.parseMetaData=g})(f||(e.DataUri=f={}));function v(h,g,E){if(g){let S=h.path;return S&&S[0]!==M.posix.sep&&(S=M.posix.sep+S),h.with({scheme:E,authority:g,path:S})}return h.with({scheme:E})}}),define(ce[8],le([0,1,22,15,4,2,18,3,147,65]),function(V,e,n,s,b,M,L,R,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=m,e.createCancelablePromise=u,e.raceCancellation=f,e.raceCancellationError=v,e.raceCancellablePromises=h,e.raceTimeout=g,e.asPromise=E,e.promiseWithResolvers=S,e.timeout=l,e.disposableTimeout=P,e.sequence=y,e.first=k,e.firstParallel=T,e.retry=O,e.createCancelableAsyncIterable=z;function m(G){return!!G&&typeof G.then=="function"}function u(G){const x=new n.CancellationTokenSource,te=G(x.token),de=new Promise((me,we)=>{const Re=x.token.onCancellationRequested(()=>{Re.dispose(),we(new s.CancellationError)});Promise.resolve(te).then(Ne=>{Re.dispose(),x.dispose(),me(Ne)},Ne=>{Re.dispose(),x.dispose(),we(Ne)})});return new class{cancel(){x.cancel(),x.dispose()}then(me,we){return de.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function f(G,x,te){return new Promise((de,me)=>{const we=x.onCancellationRequested(()=>{we.dispose(),de(te)});G.then(de,me).finally(()=>we.dispose())})}function v(G,x){return new Promise((te,de)=>{const me=x.onCancellationRequested(()=>{me.dispose(),de(new s.CancellationError)});G.then(te,de).finally(()=>me.dispose())})}async function h(G){let x=-1;const te=G.map((de,me)=>de.then(we=>(x=me,we)));try{return await Promise.race(te)}finally{G.forEach((de,me)=>{me!==x&&de.cancel()})}}function g(G,x,te){let de;const me=setTimeout(()=>{de?.(void 0),te?.()},x);return Promise.race([G.finally(()=>clearTimeout(me)),new Promise(we=>de=we)])}function E(G){return new Promise((x,te)=>{const de=G();m(de)?de.then(x,te):x(de)})}function S(){let G,x;return{promise:new Promise((de,me)=>{G=de,x=me}),resolve:G,reject:x}}class p{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const te=()=>{if(this.queuedPromise=null,this.isDisposed)return;const de=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,de};this.queuedPromise=new Promise(de=>{this.activePromise.then(te,te).then(de)})}return new Promise((te,de)=>{this.queuedPromise.then(te,de)})}return this.activePromise=x(),new Promise((te,de)=>{this.activePromise.then(me=>{this.activePromise=null,te(me)},me=>{this.activePromise=null,de(me)})})}dispose(){this.isDisposed=!0}}e.Throttler=p;class D{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=D;class I{constructor(){this.promiseMap=new Map}queue(x,te){const me=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.promiseMap.get(x)===me&&this.promiseMap.delete(x)});return this.promiseMap.set(x,me),me}}e.SequencerByKey=I;const i=(G,x)=>{let te=!0;const de=setTimeout(()=>{te=!1,x()},G);return{isTriggered:()=>te,dispose:()=>{clearTimeout(de),te=!1}}},d=G=>{let x=!0;return queueMicrotask(()=>{x&&(x=!1,G())}),{isTriggered:()=>x,dispose:()=>{x=!1}}};class t{constructor(x){this.defaultDelay=x,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,te=this.defaultDelay){this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((me,we)=>{this.doResolve=me,this.doReject=we}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const me=this.task;return this.task=null,me()}}));const de=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=te===w.MicrotaskDelay?d(de):i(te,de),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new s.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=t;class o{constructor(x){this.delayer=new t(x),this.throttler=new p}trigger(x,te){return this.delayer.trigger(()=>this.throttler.queue(x),te)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=o;class r{constructor(){this._isOpen=!1,this._promise=new Promise((x,te)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class a extends r{constructor(x){super(),this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(G,x){return x?new Promise((te,de)=>{const me=setTimeout(()=>{we.dispose(),te()},G),we=x.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),de(new s.CancellationError)})}):u(te=>l(G,te))}function P(G,x=0,te){const de=setTimeout(()=>{G(),te&&me.dispose()},x),me=(0,M.toDisposable)(()=>{clearTimeout(de),te?.deleteAndLeak(me)});return te?.add(me),me}function y(G){const x=[];let te=0;const de=G.length;function me(){return te<de?G[te++]():null}function we(Re){Re!=null&&x.push(Re);const Ne=me();return Ne?Ne.then(we):Promise.resolve(x)}return Promise.resolve(null).then(we)}function k(G,x=de=>!!de,te=null){let de=0;const me=G.length,we=()=>{if(de>=me)return Promise.resolve(te);const Re=G[de++];return Promise.resolve(Re()).then(ke=>x(ke)?Promise.resolve(ke):we())};return we()}function T(G,x=de=>!!de,te=null){if(G.length===0)return Promise.resolve(te);let de=G.length;const me=()=>{de=-1;for(const we of G)we.cancel?.()};return new Promise((we,Re)=>{for(const Ne of G)Ne.then(ke=>{--de>=0&&x(ke)?(me(),we(ke)):de===0&&we(te)}).catch(ke=>{--de>=0&&(me(),Re(ke))})})}class A{constructor(x){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new b.Emitter}whenIdle(){return this.size>0?b.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(x){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((te,de)=>{this.outstandingPromises.push({factory:x,c:te,e:de}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const te=x.factory();te.then(x.c,x.e),te.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=A;class C extends A{constructor(){super(1)}}e.Queue=C;class _{constructor(){this.sequentializer=new N,this.tasks=0}queue(x){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,x())):this.sequentializer.run(this.tasks++,x())}}e.LimitedQueue=_;class H{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const x=new j;return this.drainers.add(x),x.p}isDrained(){for(const[,x]of this.queues)if(x.size>0)return!1;return!0}queueSize(x,te=L.extUri){const de=te.getComparisonKey(x);return this.queues.get(de)?.size??0}queueFor(x,te,de=L.extUri){const me=de.getComparisonKey(x);let we=this.queues.get(me);if(!we){we=new C;const Re=this.drainListenerCount++,Ne=b.Event.once(we.onDrained)(()=>{we?.dispose(),this.queues.delete(me),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Re),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new M.DisposableMap),this.drainListeners.set(Re,Ne),this.queues.set(me,we)}return we.queue(te)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const x of this.drainers)x.complete();this.drainers.clear()}dispose(){for(const[,x]of this.queues)x.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=H;class q{constructor(x,te){this._isDisposed=!1,this._token=-1,typeof x=="function"&&typeof te=="number"&&this.setIfNotSet(x,te)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,te){if(this._isDisposed)throw new s.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},te)}setIfNotSet(x,te){if(this._isDisposed)throw new s.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},te))}}e.TimeoutTimer=q;class K{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(x,te,de=globalThis){if(this.isDisposed)throw new s.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{x()},te);this.disposable=(0,M.toDisposable)(()=>{de.clearInterval(me),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=K;class fe{constructor(x,te){this.timeoutToken=-1,this.runner=x,this.timeout=te,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=fe;class ${constructor(x,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=te,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class X extends fe{constructor(x,te){super(x,te),this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner?.(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X;class B extends M.Disposable{constructor(x,te){super(),this.options=x,this.handler=te,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.options.maxBufferedWork)return!1}else if(this.pending+x.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const te of x)this.pendingWork.push(te);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new fe(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(G,x)=>{(0,R.setTimeout0)(()=>{if(te)return;const de=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e._runWhenIdle=(G,x,te)=>{const de=G.requestIdleCallback(x,typeof te=="number"?{timeout:te}:void 0);let me=!1;return{dispose(){me||(me=!0,G.cancelIdleCallback(de))}}},e.runWhenGlobalIdle=G=>(0,e._runWhenIdle)(globalThis,G)}();class J{constructor(x,te){this._didRun=!1,this._executor=()=>{try{this._value=te()}catch(de){this._error=de}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(x,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=J;class U extends J{constructor(x){super(globalThis,x)}}e.GlobalIdleValue=U;async function O(G,x,te){let de;for(let me=0;me<te;me++)try{return await G()}catch(we){de=we,await l(x)}throw de}class N{isRunning(x){return typeof x=="number"?this._running?.taskId===x:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(x,te,de){return this._running={taskId:x,cancel:()=>de?.(),promise:te},te.then(()=>this.doneRunning(x),()=>this.doneRunning(x)),te}doneRunning(x){this._running&&x===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const x=this._queued;this._queued=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}queue(x){if(this._queued)this._queued.run=x;else{const{promise:te,resolve:de,reject:me}=S();this._queued={run:x,promise:te,promiseResolve:de,promiseReject:me}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=N;class Q{constructor(x,te=()=>Date.now()){this.interval=x,this.nowFn=te,this.lastIncrementTime=0,this.value=0}increment(){const x=this.nowFn();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;var oe;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(oe||(oe={}));class j{get isRejected(){return this.outcome?.outcome===oe.Rejected}get isResolved(){return this.outcome?.outcome===oe.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===oe.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((x,te)=>{this.completeCallback=x,this.errorCallback=te})}complete(x){return new Promise(te=>{this.completeCallback(x),this.outcome={outcome:oe.Resolved,value:x},te()})}error(x){return new Promise(te=>{this.errorCallback(x),this.outcome={outcome:oe.Rejected,value:x},te()})}cancel(){return this.error(new s.CancellationError)}}e.DeferredPromise=j;var ue;(function(G){async function x(de){let me;const we=await Promise.all(de.map(Re=>Re.then(Ne=>Ne,Ne=>{me||(me=Ne)})));if(typeof me<"u")throw me;return we}G.settled=x;function te(de){return new Promise(async(me,we)=>{try{await de(me,we)}catch(Re){we(Re)}})}G.withAsyncBody=te})(ue||(e.Promises=ue={}));class se{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(x){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=x.then(te=>(this._value=te,this._isResolved=!0,te),te=>{throw this._error=te,this._isResolved=!0,te})}requireValue(){if(!this._isResolved)throw new s.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=se;class Y{constructor(x){this._compute=x,this._promise=new c.Lazy(()=>new se(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=Y;var W;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(W||(W={}));class F{static fromArray(x){return new F(te=>{te.emitMany(x)})}static fromPromise(x){return new F(async te=>{te.emitMany(await x)})}static fromPromises(x){return new F(async te=>{await Promise.all(x.map(async de=>te.emitOne(await de)))})}static merge(x){return new F(async te=>{await Promise.all(x.map(async de=>{for await(const me of de)te.emitOne(me)}))})}static{this.EMPTY=F.fromArray([])}constructor(x,te){this._state=W.Initial,this._results=[],this._error=null,this._onReturn=te,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const de={emitOne:me=>this.emitOne(me),emitMany:me=>this.emitMany(me),reject:me=>this.reject(me)};try{await Promise.resolve(x(de)),this.resolve()}catch(me){this.reject(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let x=0;return{next:async()=>{do{if(this._state===W.DoneError)throw this._error;if(x<this._results.length)return{done:!1,value:this._results[x++]};if(this._state===W.DoneOK)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(x,te){return new F(async de=>{for await(const me of x)de.emitOne(te(me))})}map(x){return F.map(this,x)}static filter(x,te){return new F(async de=>{for await(const me of x)te(me)&&de.emitOne(me)})}filter(x){return F.filter(this,x)}static coalesce(x){return F.filter(x,te=>!!te)}coalesce(){return F.coalesce(this)}static async toPromise(x){const te=[];for await(const de of x)te.push(de);return te}toPromise(){return F.toPromise(this)}emitOne(x){this._state===W.Initial&&(this._results.push(x),this._onStateChanged.fire())}emitMany(x){this._state===W.Initial&&(this._results=this._results.concat(x),this._onStateChanged.fire())}resolve(){this._state===W.Initial&&(this._state=W.DoneOK,this._onStateChanged.fire())}reject(x){this._state===W.Initial&&(this._state=W.DoneError,this._error=x,this._onStateChanged.fire())}}e.AsyncIterableObject=F;class Z extends F{constructor(x,te){super(te),this._source=x}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function z(G){const x=new n.CancellationTokenSource,te=G(x.token);return new Z(x,async de=>{const me=x.token.onCancellationRequested(()=>{me.dispose(),x.dispose(),de.reject(new s.CancellationError)});try{for await(const we of te){if(x.token.isCancellationRequested)return;de.emitOne(we)}me.dispose(),x.dispose()}catch(we){me.dispose(),x.dispose(),de.reject(we)}})}class ie{constructor(x){this._deferred=new j,this._asyncIterable=new F(me=>{if(te){me.reject(te);return}return de&&me.emitMany(de),this._errorFn=we=>me.reject(we),this._emitFn=we=>me.emitOne(we),this._deferred.p},x);let te,de;this._emitFn=me=>{de||(de=[]),de.push(me)},this._errorFn=me=>{te||(te=me)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(x){this._errorFn(x),this._deferred.complete()}emitOne(x){this._emitFn(x)}}e.AsyncIterableSource=ie}),define(ce[111],le([0,1,21,8,39,32,31,9,3,25]),function(V,e,n,s,b,M,L,R,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=m,e.splitGlobAware=g,e.match=_,e.parse=H,e.isRelativePattern=q,e.getBasenameTerms=K,e.getPathTerms=fe,e.patternsEquals=J;function m(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const u="[/\\\\]",f="[^/\\\\]",v=/\//g;function h(U,O){switch(U){case 0:return"";case 1:return`${f}*?`;default:return`(?:${u}|${f}+${u}${O?`|${u}${f}+`:""})*?`}}function g(U,O){if(!U)return[];const N=[];let Q=!1,oe=!1,j="";for(const ue of U){switch(ue){case O:if(!Q&&!oe){N.push(j),j="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}j+=ue}return j&&N.push(j),N}function E(U){if(!U)return"";let O="";const N=g(U,e.GLOB_SPLIT);if(N.every(Q=>Q===e.GLOBSTAR))O=".*";else{let Q=!1;N.forEach((oe,j)=>{if(oe===e.GLOBSTAR){if(Q)return;O+=h(2,j===N.length-1)}else{let ue=!1,se="",Y=!1,W="";for(const F of oe){if(F!=="}"&&ue){se+=F;continue}if(Y&&(F!=="]"||!W)){let Z;F==="-"?Z=F:(F==="^"||F==="!")&&!W?Z="^":F===e.GLOB_SPLIT?Z="":Z=(0,c.escapeRegExpCharacters)(F),W+=Z;continue}switch(F){case"{":ue=!0;continue;case"[":Y=!0;continue;case"}":{const z=`(?:${g(se,",").map(ie=>E(ie)).join("|")})`;O+=z,ue=!1,se="";break}case"]":{O+="["+W+"]",Y=!1,W="";break}case"?":O+=f;continue;case"*":O+=h(1);continue;default:O+=(0,c.escapeRegExpCharacters)(F)}}j<N.length-1&&(N[j+1]!==e.GLOBSTAR||j+2<N.length)&&(O+=u)}Q=oe===e.GLOBSTAR})}return O}const S=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,I=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),o=function(){return!1},r=function(){return null};function a(U,O){if(!U)return r;let N;typeof U!="string"?N=U.pattern:N=U,N=N.trim();const Q=`${N}_${!!O.trimForExclusions}`;let oe=t.get(Q);if(oe)return l(oe,U);let j;return S.test(N)?oe=y(N.substr(4),N):(j=p.exec(P(N,O)))?oe=k(j[1],N):(O.trimForExclusions?I:D).test(N)?oe=T(N,O):(j=i.exec(P(N,O)))?oe=A(j[1].substr(1),N,!0):(j=d.exec(P(N,O)))?oe=A(j[1],N,!1):oe=C(N),t.set(Q,oe),l(oe,U)}function l(U,O){if(typeof O=="string")return U;const N=function(Q,oe){return(0,M.isEqualOrParent)(Q,O.base,!w.isLinux)?U((0,c.ltrim)(Q.substr(O.base.length),R.sep),oe):null};return N.allBasenames=U.allBasenames,N.allPaths=U.allPaths,N.basenames=U.basenames,N.patterns=U.patterns,N}function P(U,O){return O.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function y(U,O){return function(N,Q){return typeof N=="string"&&N.endsWith(U)?O:null}}function k(U,O){const N=`/${U}`,Q=`\\${U}`,oe=function(ue,se){return typeof ue!="string"?null:se?se===U?O:null:ue===U||ue.endsWith(N)||ue.endsWith(Q)?O:null},j=[U];return oe.basenames=j,oe.patterns=[O],oe.allBasenames=j,oe}function T(U,O){const N=B(U.slice(1,-1).split(",").map(se=>a(se,O)).filter(se=>se!==r),U),Q=N.length;if(!Q)return r;if(Q===1)return N[0];const oe=function(se,Y){for(let W=0,F=N.length;W<F;W++)if(N[W](se,Y))return U;return null},j=N.find(se=>!!se.allBasenames);j&&(oe.allBasenames=j.allBasenames);const ue=N.reduce((se,Y)=>Y.allPaths?se.concat(Y.allPaths):se,[]);return ue.length&&(oe.allPaths=ue),oe}function A(U,O,N){const Q=R.sep===R.posix.sep,oe=Q?U:U.replace(v,R.sep),j=R.sep+oe,ue=R.posix.sep+U;let se;return N?se=function(Y,W){return typeof Y=="string"&&(Y===oe||Y.endsWith(j)||!Q&&(Y===U||Y.endsWith(ue)))?O:null}:se=function(Y,W){return typeof Y=="string"&&(Y===oe||!Q&&Y===U)?O:null},se.allPaths=[(N?"*/":"./")+U],se}function C(U){try{const O=new RegExp(`^${E(U)}$`);return function(N){return O.lastIndex=0,typeof N=="string"&&O.test(N)?U:null}}catch{return r}}function _(U,O,N){return!U||typeof O!="string"?!1:H(U)(O,void 0,N)}function H(U,O={}){if(!U)return o;if(typeof U=="string"||q(U)){const N=a(U,O);if(N===r)return o;const Q=function(oe,j){return!!N(oe,j)};return N.allBasenames&&(Q.allBasenames=N.allBasenames),N.allPaths&&(Q.allPaths=N.allPaths),Q}return $(U,O)}function q(U){const O=U;return O?typeof O.base=="string"&&typeof O.pattern=="string":!1}function K(U){return U.allBasenames||[]}function fe(U){return U.allPaths||[]}function $(U,O){const N=B(Object.getOwnPropertyNames(U).map(se=>X(se,U[se],O)).filter(se=>se!==r)),Q=N.length;if(!Q)return r;if(!N.some(se=>!!se.requiresSiblings)){if(Q===1)return N[0];const se=function(F,Z){let z;for(let ie=0,G=N.length;ie<G;ie++){const x=N[ie](F,Z);if(typeof x=="string")return x;(0,s.isThenable)(x)&&(z||(z=[]),z.push(x))}return z?(async()=>{for(const ie of z){const G=await ie;if(typeof G=="string")return G}return null})():null},Y=N.find(F=>!!F.allBasenames);Y&&(se.allBasenames=Y.allBasenames);const W=N.reduce((F,Z)=>Z.allPaths?F.concat(Z.allPaths):F,[]);return W.length&&(se.allPaths=W),se}const oe=function(se,Y,W){let F,Z;for(let z=0,ie=N.length;z<ie;z++){const G=N[z];G.requiresSiblings&&W&&(Y||(Y=(0,R.basename)(se)),F||(F=Y.substr(0,Y.length-(0,R.extname)(se).length)));const x=G(se,Y,F,W);if(typeof x=="string")return x;(0,s.isThenable)(x)&&(Z||(Z=[]),Z.push(x))}return Z?(async()=>{for(const z of Z){const ie=await z;if(typeof ie=="string")return ie}return null})():null},j=N.find(se=>!!se.allBasenames);j&&(oe.allBasenames=j.allBasenames);const ue=N.reduce((se,Y)=>Y.allPaths?se.concat(Y.allPaths):se,[]);return ue.length&&(oe.allPaths=ue),oe}function X(U,O,N){if(O===!1)return r;const Q=a(U,N);if(Q===r)return r;if(typeof O=="boolean")return Q;if(O){const oe=O.when;if(typeof oe=="string"){const j=(ue,se,Y,W)=>{if(!W||!Q(ue,se))return null;const F=oe.replace("$(basename)",()=>Y),Z=W(F);return(0,s.isThenable)(Z)?Z.then(z=>z?U:null):Z?U:null};return j.requiresSiblings=!0,j}}return Q}function B(U,O){const N=U.filter(se=>!!se.basenames);if(N.length<2)return U;const Q=N.reduce((se,Y)=>{const W=Y.basenames;return W?se.concat(W):se},[]);let oe;if(O){oe=[];for(let se=0,Y=Q.length;se<Y;se++)oe.push(O)}else oe=N.reduce((se,Y)=>{const W=Y.patterns;return W?se.concat(W):se},[]);const j=function(se,Y){if(typeof se!="string")return null;if(!Y){let F;for(F=se.length;F>0;F--){const Z=se.charCodeAt(F-1);if(Z===b.CharCode.Slash||Z===b.CharCode.Backslash)break}Y=se.substr(F)}const W=Q.indexOf(Y);return W!==-1?oe[W]:null};j.basenames=Q,j.patterns=oe,j.allBasenames=Q;const ue=U.filter(se=>!se.basenames);return ue.push(j),ue}function J(U,O){return(0,n.equals)(U,O,(N,Q)=>typeof N=="string"&&typeof Q=="string"?N===Q:typeof N!="string"&&typeof Q!="string"?N.base===Q.base&&N.pattern===Q.pattern:!1)}}),define(ce[47],le([0,1,21,32,9,3,18,25]),function(V,e,n,s,b,M,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=w,e.normalizeDriveLetter=m,e.tildify=f,e.untildify=v,e.shorten=S,e.template=D,e.mnemonicMenuLabel=I,e.mnemonicButtonLabel=i,e.unmnemonicLabel=d,e.splitRecentLabel=t;function w(r,a){const{os:l,tildify:P,relative:y}=a;if(y){const A=c(r,y,l);if(typeof A=="string")return A}let k=r.fsPath;if(l===M.OperatingSystem.Windows&&!M.isWindows?k=k.replace(/\//g,"\\"):l!==M.OperatingSystem.Windows&&M.isWindows&&(k=k.replace(/\\/g,"/")),l!==M.OperatingSystem.Windows&&P?.userHome){const A=P.userHome.fsPath;let C;r.scheme!==P.userHome.scheme&&r.path[0]===b.posix.sep&&r.path[1]!==b.posix.sep?C=P.userHome.with({path:r.path}).fsPath:C=k,k=f(C,A,l)}return(l===M.OperatingSystem.Windows?b.win32:b.posix).normalize(m(k,l===M.OperatingSystem.Windows))}function c(r,a,l){const P=l===M.OperatingSystem.Windows?b.win32:b.posix,y=l===M.OperatingSystem.Linux?L.extUri:L.extUriIgnorePathCase,k=a.getWorkspace(),T=(0,n.firstOrDefault)(k.folders);if(!T)return;r.scheme!==T.uri.scheme&&r.path[0]===b.posix.sep&&r.path[1]!==b.posix.sep&&(r=T.uri.with({path:r.path}));const A=a.getWorkspaceFolder(r);if(!A)return;let C;if(y.isEqual(A.uri,r)?C="":C=y.relativePath(A.uri,r)??"",C&&(C=P.normalize(C)),k.folders.length>1&&!a.noPrefix){const _=A.name?A.name:y.basenameOrAuthority(A.uri);C=C?`${_} \u2022 ${C}`:_}return C}function m(r,a=M.isWindows){return(0,s.hasDriveLetter)(r,a)?r.charAt(0).toUpperCase()+r.slice(1):r}let u=Object.create(null);function f(r,a,l=M.OS){if(l===M.OperatingSystem.Windows||!r||!a)return r;let P=u.original===a?u.normalized:void 0;P||(P=a,M.isWindows&&(P=(0,s.toSlashes)(P)),P=`${(0,R.rtrim)(P,b.posix.sep)}${b.posix.sep}`,u={original:a,normalized:P});let y=r;return M.isWindows&&(y=(0,s.toSlashes)(y)),(l===M.OperatingSystem.Linux?y.startsWith(P):(0,R.startsWithIgnoreCase)(y,P))?`~/${y.substr(P.length)}`:r}function v(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}const h="\u2026",g="\\\\",E="~";function S(r,a=b.sep){const l=new Array(r.length);let P=!1;for(let y=0;y<r.length;y++){const k=r[y];if(k===""){l[y]=`.${a}`;continue}if(!k){l[y]=k;continue}P=!0;let T="",A=k;A.indexOf(g)===0?(T=A.substr(0,A.indexOf(g)+g.length),A=A.substr(A.indexOf(g)+g.length)):A.indexOf(a)===0?(T=A.substr(0,A.indexOf(a)+a.length),A=A.substr(A.indexOf(a)+a.length)):A.indexOf(E)===0&&(T=A.substr(0,A.indexOf(E)+E.length),A=A.substr(A.indexOf(E)+E.length));const C=A.split(a);for(let _=1;P&&_<=C.length;_++)for(let H=C.length-_;P&&H>=0;H--){P=!1;let q=C.slice(H,H+_).join(a);for(let K=0;!P&&K<r.length;K++)if(K!==y&&r[K]&&r[K].indexOf(q)>-1){const fe=H+_===C.length,$=H>0&&r[K].indexOf(a)>-1?a+q:q,X=r[K].endsWith($);P=!fe||X}if(!P){let K="";(C[0].endsWith(":")||T!=="")&&(H===1&&(H=0,_++,q=C[0]+a+q),H>0&&(K=C[0]+a),K=T+K),H>0&&(K=K+h+a),K=K+q,H+_<C.length&&(K=K+a+h),l[y]=K}}P&&(l[y]=k)}return l}var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function D(r,a=Object.create(null)){const l=[];let P=!1,y="";for(const k of r)if(k==="$"||P&&k==="{")y&&l.push({value:y,type:p.TEXT}),y="",P=!0;else if(k==="}"&&P){const T=a[y];if(typeof T=="string")T.length&&l.push({value:T,type:p.VARIABLE});else if(T){const A=l[l.length-1];(!A||A.type!==p.SEPARATOR)&&l.push({value:T.label,type:p.SEPARATOR})}y="",P=!1}else y+=k;return y&&!P&&l.push({value:y,type:p.TEXT}),l.filter((k,T)=>{if(k.type===p.SEPARATOR){const A=l[T-1],C=l[T+1];return[A,C].every(_=>_&&(_.type===p.VARIABLE||_.type===p.TEXT)&&_.value.length>0)}return!0}).map(k=>k.value).join("")}function I(r,a){return M.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function i(r,a){return M.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,l=>l==="&"?"&&":"&"):r.replace(/&&/g,"_")}function d(r){return r.replace(/&/g,"&&")}function t(r){if(r.endsWith("]")){const a=r.lastIndexOf(" [",r.length-2);if(a!==-1){const l=o(r.substring(0,a)),P=r.substring(a);return{name:l.name+P,parentPath:l.parentPath}}}return o(r)}function o(r){const a=r.indexOf("/")!==-1?b.posix:b.win32,l=a.basename(r),P=a.dirname(r);return l.length?{name:l,parentPath:P}:{name:P,parentPath:""}}}),define(ce[151],le([0,1,17,90,7]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=w,e.transformIncomingURIs=m,e.transformAndReviveIncomingURIs=u;function M(f){return f.toJSON()}class L{constructor(v){this._uriTransformer=v}transformIncoming(v){const h=this._uriTransformer.transformIncoming(v);return h===v?v:M(b.URI.from(h))}transformOutgoing(v){const h=this._uriTransformer.transformOutgoing(v);return h===v?v:M(b.URI.from(h))}transformOutgoingURI(v){const h=this._uriTransformer.transformOutgoing(v);return h===v?v:b.URI.from(h)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function R(f,v,h){if(!f||h>200)return null;if(typeof f=="object"){if(f instanceof b.URI)return v.transformOutgoing(f);for(const g in f)if(Object.hasOwnProperty.call(f,g)){const E=R(f[g],v,h+1);E!==null&&(f[g]=E)}}return null}function w(f,v){const h=R(f,v,0);return h===null?f:h}function c(f,v,h,g){if(!f||g>200)return null;if(typeof f=="object"){if(f.$mid===s.MarshalledId.Uri)return h?b.URI.revive(v.transformIncoming(f)):v.transformIncoming(f);if(f instanceof n.VSBuffer)return null;for(const E in f)if(Object.hasOwnProperty.call(f,E)){const S=c(f[E],v,h,g+1);S!==null&&(f[E]=S)}}return null}function m(f,v){const h=c(f,v,!1,0);return h===null?f:h}function u(f,v){const h=c(f,v,!0,0);return h===null?f:h}}),define(ce[33],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=s;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function s(b){return n.test(b)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(R){for(let w=0;w<R.length;w++)R[w]=Math.floor(Math.random()*256);return R};const M=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){b(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let w=0,c="";return c+=L[M[w++]],c+=L[M[w++]],c+=L[M[w++]],c+=L[M[w++]],c+="-",c+=L[M[w++]],c+=L[M[w++]],c+="-",c+=L[M[w++]],c+=L[M[w++]],c+="-",c+=L[M[w++]],c+=L[M[w++]],c+="-",c+=L[M[w++]],c+=L[M[w++]],c+=L[M[w++]],c+=L[M[w++]],c+=L[M[w++]],c+=L[M[w++]],c}}()}),define(ce[152],le([0,1,91,26,89]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=M,n=De(n),s=De(s);async function M(L,R){if(await new Promise((m,u)=>{const f=s.createReadStream(L),v=n.createHash("sha256");f.pipe(v);const h=(0,b.createSingleCallFunction)((g,E)=>{f.removeAllListeners(),v.removeAllListeners(),g?u(g):m(E)});f.once("error",h),f.once("end",h),v.once("error",h),v.once("data",g=>h(void 0,g.toString("hex")))})!==R)throw new Error("Hash mismatch")}}),define(ce[153],le([0,1,27]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=M;const s=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function b(L){const R=L.replace(/\-/g,":").toLowerCase();return!s.has(R)}function M(){const L=(0,n.networkInterfaces)();for(const R in L){const w=L[R];if(w){for(const{mac:c}of w)if(b(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[92],le([0,1,27,60,33,153,3]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=w,e.getSqmMachineId=u,e.getdevDeviceId=f,b=De(b),e.virtualMachineHint=new class{_isVirtualMachineMacAddress(v){return this._virtualMachineOUIs||(this._virtualMachineOUIs=s.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(v)}value(){if(this._value===void 0){let v=0,h=0;const g=(0,n.networkInterfaces)();for(const E in g){const S=g[E];if(S)for(const{mac:p,internal:D}of S)D||(h+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(v+=1))}this._value=h>0?v/h:0}return this._value}};let R;async function w(v){return R||(R=(async()=>await c(v)||b.generateUuid())()),R}async function c(v){try{const h=await new Promise((E,S)=>{V(["crypto"],E,S)}).then(De),g=(0,M.getMac)();return h.createHash("sha256").update(g,"utf8").digest("hex")}catch(h){v(h);return}}const m="Software\\Microsoft\\SQMClient";async function u(v){if(L.isWindows){const h=await new Promise((g,E)=>{V(["@vscode/windows-registry"],g,E)}).then(De);try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",m,"MachineId")||""}catch(g){return v(g),""}}return""}async function f(v){try{return await(await new Promise((E,S)=>{V(["@vscode/deviceid"],E,S)}).then(De)).getDeviceId()}catch(h){return v(h),""}}}),define(ce[23],le([0,1,26,27,154,8,32,78,9,3,18,7]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=E,e.readdirSync=D,e.whenDeleted=d,e.configureFlushOnWrite=l,e.writeFileSync=y,n=De(n);var f;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function v($,X=f.UNLINK,B){if((0,L.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return X===f.UNLINK?g($):h($,B)}async function h($,X=(0,L.randomPath)((0,s.tmpdir)())){try{try{await n.promises.rename($,X)}catch(B){return B.code==="ENOENT"?void 0:g($)}g(X).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function g($){return n.promises.rm($,{recursive:!0,force:!0,maxRetries:3})}function E($){if((0,L.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync($,{recursive:!0,force:!0,maxRetries:3})}async function S($,X){return I(await(X?p($):n.promises.readdir($)))}async function p($){try{return await n.promises.readdir($,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const X=[],B=await S($);for(const J of B){let U=!1,O=!1,N=!1;try{const Q=await n.promises.lstat((0,w.join)($,J));U=Q.isFile(),O=Q.isDirectory(),N=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}X.push({name:J,isFile:()=>U,isDirectory:()=>O,isSymbolicLink:()=>N})}return X}function D($){return I(n.readdirSync($))}function I($){return $.map(X=>typeof X=="string"?c.isMacintosh?(0,R.normalizeNFC)(X):X:(X.name=c.isMacintosh?(0,R.normalizeNFC)(X.name):X.name,X))}async function i($){const X=await S($),B=[];for(const J of X)await t.existsDirectory((0,w.join)($,J))&&B.push(J);return B}function d($,X=1e3){return new Promise(B=>{let J=!1;const U=setInterval(()=>{J||(J=!0,n.access($,O=>{J=!1,O&&(clearInterval(U),B(void 0))}))},X)})}var t;(function($){async function X(U){let O;try{if(O=await n.promises.lstat(U),!O.isSymbolicLink())return{stat:O}}catch{}try{return{stat:await n.promises.stat(U),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(c.isWindows&&N.code==="EACCES")try{return{stat:await n.promises.stat(await n.promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw Q}throw N}}$.stat=X;async function B(U){try{const{stat:O,symbolicLink:N}=await $.stat(U);return O.isFile()&&N?.dangling!==!0}catch{}return!1}$.existsFile=B;async function J(U){try{const{stat:O,symbolicLink:N}=await $.stat(U);return O.isDirectory()&&N?.dangling!==!0}catch{}return!1}$.existsDirectory=J})(t||(e.SymlinkSupport=t={}));const o=new M.ResourceQueue;function r($,X,B){return o.queueFor(u.URI.file($),()=>{const J=k(B);return new Promise((U,O)=>P($,X,J,N=>N?O(N):U()))},m.extUriBiasedIgnorePathCase)}let a=!0;function l($){a=$}function P($,X,B,J){if(!a)return n.writeFile($,X,{mode:B.mode,flag:B.flag},J);n.open($,B.flag,B.mode,(U,O)=>{if(U)return J(U);n.writeFile(O,X,N=>{if(N)return n.close(O,()=>J(N));n.fdatasync(O,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),l(!1)),n.close(O,oe=>J(oe))))})})}function y($,X,B){const J=k(B);if(!a)return n.writeFileSync($,X,{mode:J.mode,flag:J.flag});const U=n.openSync($,J.flag,J.mode);try{n.writeFileSync(U,X);try{n.fdatasyncSync(U)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),l(!1)}}finally{n.closeSync(U)}}function k($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function T($,X,B=6e4){if($!==X)try{c.isWindows&&typeof B=="number"?await A($,X,Date.now(),B):await n.promises.rename($,X)}catch(J){if($.toLowerCase()!==X.toLowerCase()&&J.code==="EXDEV"||$.endsWith("."))await C($,X,{preserveSymlinks:!1}),await v($,f.MOVE);else throw J}}async function A($,X,B,J,U=0){try{return await n.promises.rename($,X)}catch(O){if(O.code!=="EACCES"&&O.code!=="EPERM"&&O.code!=="EBUSY")throw O;if(Date.now()-B>=J)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${O}`),O;if(U===0){let N=!1;try{const{stat:Q}=await t.stat(X);Q.isFile()||(N=!0)}catch{}if(N)throw O}return await(0,M.timeout)(Math.min(100,U*10)),A($,X,B,J,U+1)}}async function C($,X,B){return H($,X,{root:{source:$,target:X},options:B,handledSourcePaths:new Set})}const _=511;async function H($,X,B){if(B.handledSourcePaths.has($))return;B.handledSourcePaths.add($);const{stat:J,symbolicLink:U}=await t.stat($);if(U){if(B.options.preserveSymlinks)try{return await fe($,X,B)}catch{}if(U.dangling)return}return J.isDirectory()?q($,X,J.mode&_,B):K($,X,J.mode&_)}async function q($,X,B,J){await n.promises.mkdir(X,{recursive:!0,mode:B});const U=await S($);for(const O of U)await H((0,w.join)($,O),(0,w.join)(X,O),J)}async function K($,X,B){await n.promises.copyFile($,X),await n.promises.chmod(X,B)}async function fe($,X,B){let J=await n.promises.readlink($);(0,L.isEqualOrParent)(J,B.root.source,!c.isLinux)&&(J=(0,w.join)(B.root.target,J.substr(B.root.source.length+1))),await n.promises.symlink(J,X)}e.Promises=new class{get read(){return($,X,B,J,U)=>new Promise((O,N)=>{n.read($,X,B,J,U,(Q,oe,j)=>Q?N(Q):O({bytesRead:oe,buffer:j}))})}get write(){return($,X,B,J,U)=>new Promise((O,N)=>{n.write($,X,B,J,U,(Q,oe,j)=>Q?N(Q):O({bytesWritten:oe,buffer:j}))})}get fdatasync(){return(0,b.promisify)(n.fdatasync)}get open(){return(0,b.promisify)(n.open)}get close(){return(0,b.promisify)(n.close)}get realpath(){return(0,b.promisify)(n.realpath)}async exists($){try{return await n.promises.access($),!0}catch{return!1}}get readdir(){return S}get readDirsInDir(){return i}get writeFile(){return r}get rm(){return v}get rename(){return T}get copy(){return C}}}),define(ce[112],le([0,1,26,9,3,25,23]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=R,e.realcase=w,e.realpath=c,e.realpathSync=m,n=De(n);function R(f){if(b.isLinux)return f;const v=(0,s.dirname)(f);if(f===v)return f;const h=((0,s.basename)(f)||f).toLowerCase();try{const E=(0,L.readdirSync)(v).filter(S=>S.toLowerCase()===h);if(E.length===1){const S=R(v);if(S)return(0,s.join)(S,E[0])}else if(E.length>1){const S=E.indexOf(h);if(S>=0){const p=R(v);if(p)return(0,s.join)(p,E[S])}}}catch{}return null}async function w(f,v){if(b.isLinux)return f;const h=(0,s.dirname)(f);if(f===h)return f;const g=((0,s.basename)(f)||f).toLowerCase();try{if(v?.isCancellationRequested)return null;const S=(await L.Promises.readdir(h)).filter(p=>p.toLowerCase()===g);if(S.length===1){const p=await w(h,v);if(p)return(0,s.join)(p,S[0])}else if(S.length>1){const p=S.indexOf(g);if(p>=0){const D=await w(h,v);if(D)return(0,s.join)(D,S[p])}}}catch{}return null}async function c(f){try{return await L.Promises.realpath(f)}catch{const h=u(f);return await n.promises.access(h,n.constants.R_OK),h}}function m(f){try{return n.realpathSync(f)}catch{const h=u(f);return n.accessSync(h,n.constants.R_OK),h}}function u(f){return(0,M.rtrim)((0,s.normalize)(f),s.sep)}}),define(ce[113],le([0,1,93]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=s,e.findFreePortFaster=M,n=De(n);function s(R,w,c,m=1){let u=!1;return new Promise(f=>{const v=setTimeout(()=>{if(!u)return u=!0,f(0)},c);b(R,w,m,h=>{if(!u)return u=!0,clearTimeout(v),f(h)})})}function b(R,w,c,m){if(w===0)return m(0);const u=new n.Socket;u.once("connect",()=>(L(u),b(R+c,w-1,c,m))),u.once("data",()=>{}),u.once("error",f=>(L(u),f.code!=="ECONNREFUSED"?b(R+c,w-1,c,m):m(R))),u.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(R,w,c,m="127.0.0.1"){let u=!1,f,v=1;const h=n.createServer({pauseOnConnect:!0});function g(E,S){u||(u=!0,h.removeAllListeners(),h.close(),f&&clearTimeout(f),S(E))}return new Promise(E=>{f=setTimeout(()=>{g(0,E)},c),h.on("listening",()=>{g(R,E)}),h.on("error",S=>{S&&(S.code==="EADDRINUSE"||S.code==="EACCES")&&v<w?(R++,v++,h.listen(R,m)):g(0,E)}),h.on("close",()=>{g(0,E)}),h.listen(R,m)})}function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(w){console.error(w)}}}),define(ce[114],le([0,1,27,9,23]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=p,e.getFirstAvailablePowerShellInstallation=D,n=De(n),s=De(s),b=De(b);const M=/^\d+$/,L=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var w;(function(I){I[I.x64=0]="x64",I[I.x86=1]="x86",I[I.ARM=2]="ARM"})(w||(w={}));let c;switch(process.arch){case"ia32":c=w.x86;break;case"arm":case"arm64":c=w.ARM;break;default:c=w.x64;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?w.ARM:w.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=w.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=w.x86:m=w.x64;class u{constructor(i,d,t){this.exePath=i,this.displayName=d,this.knownToExist=t}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:I=!1}={}){return I?c===w.x64?process.env["ProgramFiles(x86)"]||null:m===w.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:I=!1,findPreview:i=!1}={}){const d=f({useAlternateBitness:I});if(!d)return null;const t=s.join(d,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(t))return null;let o=-1,r=null;for(const P of await b.Promises.readdir(t)){let y=-1;if(i){const T=P.indexOf("-");if(T<0)continue;const A=P.substring(0,T);if(!M.test(A)||P.substring(T+1)!=="preview")continue;y=parseInt(A,10)}else{if(!M.test(P))continue;y=parseInt(P,10)}if(y<=o)continue;const k=s.join(t,P,"pwsh.exe");await b.SymlinkSupport.existsFile(k)&&(r=k,o=y)}if(!r)return null;const a=d.includes("x86")?" (x86)":"",l=i?" Preview":"";return new u(r,`PowerShell${l}${a}`,!0)}async function h({findPreview:I}={}){if(!process.env.LOCALAPPDATA)return null;const i=s.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:d,pwshMsixName:t}=I?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const o of await b.Promises.readdir(i))if(d.test(o)){const r=s.join(i,o,"pwsh.exe");return new u(r,t)}return null}function g(){const I=s.join(n.homedir(),".dotnet","tools","pwsh.exe");return new u(I,".NET Core PowerShell Global Tool")}function E(){const I=s.join(process.env.windir,c===w.x86&&m!==w.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(I,"Windows PowerShell",!0)}async function*S(){let I=await v();I&&(yield I),I=await v({useAlternateBitness:!0}),I&&(yield I),I=await h(),I&&(yield I),I=g(),I&&(yield I),I=await v({findPreview:!0}),I&&(yield I),I=await h({findPreview:!0}),I&&(yield I),I=await v({useAlternateBitness:!0,findPreview:!0}),I&&(yield I),I=E(),I&&(yield I)}async function*p(){for await(const I of S())await I.exists()&&(yield I)}async function D(){for await(const I of p())return I;return null}}),define(ce[94],le([0,1,26,9,3,36,79,11,23]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=c,e.createQueuedSender=m,s=De(s),b=De(b),M=De(M),R=De(R),w=De(w),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function c(f=M.env){return f.comspec||"cmd.exe"}function m(f){let v=[],h=!1;const g=function(E){if(h){v.push(E);return}(!f.send(E,p=>{if(p&&console.error(p),h=!1,v.length>0){const D=v.slice(0);v=[],D.forEach(I=>g(I))}})||b.isWindows)&&(h=!0)};return{send:g}}var u;(function(f){async function v(h,g,E){if(s.isAbsolute(h))return h;if(g===void 0&&(g=M.cwd()),s.dirname(h)!=="."||(E===void 0&&R.isString(M.env.PATH)&&(E=M.env.PATH.split(s.delimiter)),E===void 0||E.length===0))return s.join(g,h);async function p(D){if(await w.Promises.exists(D)){let I;try{I=await n.promises.stat(D)}catch(i){i.message.startsWith("EACCES")&&(I=await n.promises.lstat(D))}return I?!I.isDirectory():!1}return!1}for(const D of E){let I;if(s.isAbsolute(D)?I=s.join(D,h):I=s.join(g,D,h),await p(I))return I;let i=I+".com";if(await p(i)||(i=I+".exe",await p(i)))return i}return s.join(g,h)}f.findExecutable=v})(u||(e.win32=u={}))}),define(ce[115],le([0,1,48,12]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=b;function b(L){return new Promise((R,w)=>{let c;const m=new Map;function u(v,h,g,E,S){const p=m.get(h);if(v===L||p){const D={name:f(g),cmd:g,pid:v,ppid:h,load:E,mem:S};m.set(v,D),v===L&&(c=D),p&&(p.children||(p.children=[]),p.children.push(D),p.children.length>1&&(p.children=p.children.sort((I,i)=>I.pid-i.pid)))}}function f(v){const h=/--utility-sub-type=network/i,g=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,S=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(g.exec(v))return"electron-crash-reporter";if(E.exec(v))return"winpty-agent";if(S.exec(v))return"conpty-agent";let D=p.exec(v);if(D&&D.length===2)return D[1]==="renderer"?"window":D[1]==="utility"?h.exec(v)?"utility-network-service":"utility-process":D[1]==="extensionHost"?"extension-host":D[1];const I=/[a-zA-Z-]+\.js/g;let i="";do D=I.exec(v),D&&(i+=D+" ");while(D);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron-nodejs (${i})`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substring(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substring(5):h;new Promise((h,g)=>{V(["@vscode/windows-process-tree"],h,g)}).then(De).then(h=>{h.getProcessList(L,g=>{if(!g){w(new Error(`Root process ${L} not found`));return}h.getProcessCpuUsage(g,E=>{const S=new Map;E.forEach(p=>{const D=v(p.commandLine||"");S.set(p.pid,{name:f(D),cmd:D,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),c=S.get(L),c?(S.forEach(p=>{const D=S.get(p.ppid);D&&(D.children||(D.children=[]),D.children.push(p))}),S.forEach(p=>{p.children&&(p.children=p.children.sort((D,I)=>D.pid-I.pid))}),R(c)):w(new Error(`Root process ${L} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[c];const g=[];for(;h.length;){const S=h.shift();S&&(g.push(S.pid),S.children&&(h=h.concat(S.children)))}let E=JSON.stringify(s.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+g.join(" "),(0,n.exec)(E,{},(S,p,D)=>{if(S||D)w(S||new Error(D.toString()));else{const I=p.toString().split(`
`);for(let i=0;i<g.length;i++){const d=m.get(g[i]);d.load=parseFloat(I[i])}if(!c){w(new Error(`Root process ${L} not found`));return}R(c)}})};(0,n.exec)("which ps",{},(h,g,E)=>{if(h||E)if(process.platform!=="linux")w(h||new Error(E.toString()));else{const S=JSON.stringify(s.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(S,{},(p,D,I)=>{p||I?w(p||new Error(I.toString())):(M(D,u),v())})}else{const S=g.toString().trim();(0,n.exec)(`${S} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(D,I,i)=>{D||i&&!i.includes("screen size is bogus")?w(D||new Error(i.toString())):(M(I,u),process.platform==="linux"?v():c?R(c):w(new Error(`Root process ${L} not found`)))})}})}})}function M(L,R){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=L.toString().split(`
`);for(const m of c){const u=w.exec(m.trim());u&&u.length===6&&R(parseInt(u[1]),parseInt(u[2]),u[5],parseFloat(u[3]),parseFloat(u[4]))}}}),define(ce[116],le([0,1,27,3,114,94]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=L,s=De(s),M=De(M);async function L(u,f){return u===s.OperatingSystem.Windows?s.isWindows?m():M.getWindowsShell(f):w(u,f)}let R=null;function w(u,f){if(s.isLinux&&u===s.OperatingSystem.Macintosh||s.isMacintosh&&u===s.OperatingSystem.Linux)return"/bin/bash";if(!R){let v;if(s.isWindows)v="/bin/bash";else{if(v=f.SHELL,!v)try{v=(0,n.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}R=v}return R}let c=null;async function m(){return c||(c=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),c}}),function(){function V(){function e(){return process.uncHostAllowlist}function n(w){const c=new Set;if(Array.isArray(w))for(const m of w)typeof m=="string"&&c.add(m);return Array.from(c)}function s(){const w=e();return w?Array.from(w):[]}function b(w){if(process.platform!=="win32")return;const c=e();if(c)if(typeof w=="string")c.add(w.toLowerCase());else for(const m of n(w))b(m)}function M(w){if(typeof w!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const u of c){if(w.indexOf(u)!==0)continue;const v=w.indexOf("\\",u.length);if(v===-1)continue;const h=w.substring(u.length,v);if(h){m=h;break}}return m}function L(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function R(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:s,addUNCHostToAllowlist:b,getUNCHost:M,disableUNCAccessRestrictions:L,isUNCAccessRestrictionsDisabled:R}}typeof define=="function"?define("vs/base/node/unc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[155],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"});var Ie=this&&this.__decorate||function(V,e,n,s){var b=arguments.length,M=b<3?e:s===null?s=Object.getOwnPropertyDescriptor(e,n):s,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(V,e,n,s);else for(var R=V.length-1;R>=0;R--)(L=V[R])&&(M=(b<3?L(M):b>3?L(e,n,M):L(e,n))||M);return b>3&&M&&Object.defineProperty(e,n,M),M};define(ce[44],le([0,1,21,8,17,22,54,15,4,2,82,25,11]),function(V,e,n,s,b,M,L,R,w,c,m,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=l,e.deserialize=P,e.getDelayedChannel=_,e.getNextTickChannel=H,u=De(u);var v;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(v||(v={}));function h(U){switch(U){case v.Promise:return"req";case v.PromiseCancel:return"cancel";case v.EventListen:return"subscribe";case v.EventDispose:return"unsubscribe"}}var g;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(g||(g={}));function E(U){switch(U){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var S;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(S||(S={}));function p(U){let O=0;for(let N=0;;N+=7){const Q=U.read(1);if(O|=(Q.buffer[0]&127)<<N,!(Q.buffer[0]&128))return O}}const D=o(0);function I(U,O){if(O===0){U.write(D);return}let N=0;for(let oe=O;oe!==0;oe=oe>>>7)N++;const Q=b.VSBuffer.alloc(N);for(let oe=0;O!==0;oe++)Q.buffer[oe]=O&127,O=O>>>7,O>0&&(Q.buffer[oe]|=128);U.write(Q)}class i{constructor(O){this.buffer=O,this.pos=0}read(O){const N=this.buffer.slice(this.pos,this.pos+O);return this.pos+=N.byteLength,N}}e.BufferReader=i;class d{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}e.BufferWriter=d;var t;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(t||(t={}));function o(U){const O=b.VSBuffer.alloc(1);return O.writeUInt8(U,0),O}const r={Undefined:o(t.Undefined),String:o(t.String),Buffer:o(t.Buffer),VSBuffer:o(t.VSBuffer),Array:o(t.Array),Object:o(t.Object),Uint:o(t.Int)},a=typeof Buffer<"u";function l(U,O){if(typeof O>"u")U.write(r.Undefined);else if(typeof O=="string"){const N=b.VSBuffer.fromString(O);U.write(r.String),I(U,N.byteLength),U.write(N)}else if(a&&Buffer.isBuffer(O)){const N=b.VSBuffer.wrap(O);U.write(r.Buffer),I(U,N.byteLength),U.write(N)}else if(O instanceof b.VSBuffer)U.write(r.VSBuffer),I(U,O.byteLength),U.write(O);else if(Array.isArray(O)){U.write(r.Array),I(U,O.length);for(const N of O)l(U,N)}else if(typeof O=="number"&&(O|0)===O)U.write(r.Uint),I(U,O);else{const N=b.VSBuffer.fromString(JSON.stringify(O));U.write(r.Object),I(U,N.byteLength),U.write(N)}}function P(U){switch(U.read(1).readUInt8(0)){case t.Undefined:return;case t.String:return U.read(p(U)).toString();case t.Buffer:return U.read(p(U)).buffer;case t.VSBuffer:return U.read(p(U));case t.Array:{const N=p(U),Q=[];for(let oe=0;oe<N;oe++)Q.push(P(U));return Q}case t.Object:return JSON.parse(U.read(p(U)).toString());case t.Int:return p(U)}}class y{constructor(O,N,Q=null,oe=1e3){this.protocol=O,this.ctx=N,this.logger=Q,this.timeoutDelay=oe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(j=>this.onRawMessage(j)),this.sendResponse({type:g.Initialize})}registerChannel(O,N){this.channels.set(O,N),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case g.Initialize:{const N=this.send([O.type]);this.logger?.logOutgoing(N,0,k.OtherSide,E(O.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const N=this.send([O.type,O.id],O.data);this.logger?.logOutgoing(N,O.id,k.OtherSide,E(O.type),O.data);return}}}send(O,N=void 0){const Q=new d;return l(Q,O),l(Q,N),this.sendBuffer(Q.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onRawMessage(O){const N=new i(O),Q=P(N),oe=P(N),j=Q[0];switch(j){case v.Promise:return this.logger?.logIncoming(O.byteLength,Q[1],k.OtherSide,`${h(j)}: ${Q[2]}.${Q[3]}`,oe),this.onPromise({type:j,id:Q[1],channelName:Q[2],name:Q[3],arg:oe});case v.EventListen:return this.logger?.logIncoming(O.byteLength,Q[1],k.OtherSide,`${h(j)}: ${Q[2]}.${Q[3]}`,oe),this.onEventListen({type:j,id:Q[1],channelName:Q[2],name:Q[3],arg:oe});case v.PromiseCancel:return this.logger?.logIncoming(O.byteLength,Q[1],k.OtherSide,`${h(j)}`),this.disposeActiveRequest({type:j,id:Q[1]});case v.EventDispose:return this.logger?.logIncoming(O.byteLength,Q[1],k.OtherSide,`${h(j)}`),this.disposeActiveRequest({type:j,id:Q[1]})}}onPromise(O){const N=this.channels.get(O.channelName);if(!N){this.collectPendingRequest(O);return}const Q=new M.CancellationTokenSource;let oe;try{oe=N.call(this.ctx,O.name,O.arg,Q.token)}catch(se){oe=Promise.reject(se)}const j=O.id;oe.then(se=>{this.sendResponse({id:j,data:se,type:g.PromiseSuccess})},se=>{se instanceof Error?this.sendResponse({id:j,data:{message:se.message,name:se.name,stack:se.stack?se.stack.split(`
`):void 0},type:g.PromiseError}):this.sendResponse({id:j,data:se,type:g.PromiseErrorObj})}).finally(()=>{ue.dispose(),this.activeRequests.delete(O.id)});const ue=(0,c.toDisposable)(()=>Q.cancel());this.activeRequests.set(O.id,ue)}onEventListen(O){const N=this.channels.get(O.channelName);if(!N){this.collectPendingRequest(O);return}const Q=O.id,j=N.listen(this.ctx,O.name,O.arg)(ue=>this.sendResponse({id:Q,data:ue,type:g.EventFire}));this.activeRequests.set(O.id,j)}disposeActiveRequest(O){const N=this.activeRequests.get(O.id);N&&(N.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let N=this.pendingRequests.get(O.channelName);N||(N=[],this.pendingRequests.set(O.channelName,N));const Q=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===v.Promise&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:g.PromiseError})},this.timeoutDelay);N.push({request:O,timeoutTimer:Q})}flushPendingRequests(O){const N=this.pendingRequests.get(O);if(N){for(const Q of N)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case v.Promise:this.onPromise(Q.request);break;case v.EventListen:this.onEventListen(Q.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=y;var k;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class T{constructor(O,N=null){this.protocol=O,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=N}getChannel(O){const N=this;return{call(Q,oe,j){return N.isDisposed?Promise.reject(new R.CancellationError):N.requestPromise(O,Q,oe,j)},listen(Q,oe){return N.isDisposed?w.Event.None:N.requestEvent(O,Q,oe)}}}requestPromise(O,N,Q,oe=M.CancellationToken.None){const j=this.lastRequestId++,ue=v.Promise,se={id:j,type:ue,channelName:O,name:N,arg:Q};if(oe.isCancellationRequested)return Promise.reject(new R.CancellationError);let Y;return new Promise((F,Z)=>{if(oe.isCancellationRequested)return Z(new R.CancellationError);const z=()=>{const te=de=>{switch(de.type){case g.PromiseSuccess:this.handlers.delete(j),F(de.data);break;case g.PromiseError:{this.handlers.delete(j);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,Z(me);break}case g.PromiseErrorObj:this.handlers.delete(j),Z(de.data);break}};this.handlers.set(j,te),this.sendRequest(se)};let ie=null;this.state===S.Idle?z():(ie=(0,s.createCancelablePromise)(te=>this.whenInitialized()),ie.then(()=>{ie=null,z()}));const G=()=>{ie?(ie.cancel(),ie=null):this.sendRequest({id:j,type:v.PromiseCancel}),Z(new R.CancellationError)},x=oe.onCancellationRequested(G);Y=(0,c.combinedDisposable)((0,c.toDisposable)(G),x),this.activeRequests.add(Y)}).finally(()=>{Y.dispose(),this.activeRequests.delete(Y)})}requestEvent(O,N,Q){const oe=this.lastRequestId++,j=v.EventListen,ue={id:oe,type:j,channelName:O,name:N,arg:Q};let se=null;const Y=new w.Emitter({onWillAddFirstListener:()=>{se=(0,s.createCancelablePromise)(F=>this.whenInitialized()),se.then(()=>{se=null,this.activeRequests.add(Y),this.sendRequest(ue)})},onDidRemoveLastListener:()=>{se?(se.cancel(),se=null):(this.activeRequests.delete(Y),this.sendRequest({id:oe,type:v.EventDispose}))}}),W=F=>Y.fire(F.data);return this.handlers.set(oe,W),Y.event}sendRequest(O){switch(O.type){case v.Promise:case v.EventListen:{const N=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger?.logOutgoing(N,O.id,k.LocalSide,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case v.PromiseCancel:case v.EventDispose:{const N=this.send([O.type,O.id]);this.logger?.logOutgoing(N,O.id,k.LocalSide,h(O.type));return}}}send(O,N=void 0){const Q=new d;return l(Q,O),l(Q,N),this.sendBuffer(Q.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onBuffer(O){const N=new i(O),Q=P(N),oe=P(N),j=Q[0];switch(j){case g.Initialize:return this.logger?.logIncoming(O.byteLength,0,k.LocalSide,E(j)),this.onResponse({type:Q[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.logger?.logIncoming(O.byteLength,Q[1],k.LocalSide,E(j),oe),this.onResponse({type:Q[0],id:Q[1],data:oe})}}onResponse(O){if(O.type===g.Initialize){this.state=S.Idle,this._onDidInitialize.fire();return}this.handlers.get(O.id)?.(O)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=T,Ie([L.memoize],T.prototype,"onDidInitializePromise",null);class A{get connections(){const O=[];return this._connections.forEach(N=>O.push(N)),O}constructor(O,N,Q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new c.DisposableStore,this.disposables.add(O(({protocol:oe,onDidClientDisconnect:j})=>{const ue=w.Event.once(oe.onMessage);this.disposables.add(ue(se=>{const Y=new i(se),W=P(Y),F=new y(oe,W,N,Q),Z=new T(oe,N);this.channels.forEach((ie,G)=>F.registerChannel(G,ie));const z={channelServer:F,channelClient:Z,ctx:W};this._connections.add(z),this._onDidAddConnection.fire(z),this.disposables.add(j(()=>{F.dispose(),Z.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)}))}))}))}getChannel(O,N){const Q=this;return{call(oe,j,ue){let se;if((0,f.isFunction)(N)){const W=(0,n.getRandomElement)(Q.connections.filter(N));se=W?Promise.resolve(W):w.Event.toPromise(w.Event.filter(Q.onDidAddConnection,N))}else se=N.routeCall(Q,oe,j);const Y=se.then(W=>W.channelClient.getChannel(O));return _(Y).call(oe,j,ue)},listen(oe,j){if((0,f.isFunction)(N))return Q.getMulticastEvent(O,N,oe,j);const ue=N.routeEvent(Q,oe,j).then(se=>se.channelClient.getChannel(O));return _(ue).listen(oe,j)}}}getMulticastEvent(O,N,Q,oe){const j=this;let ue;const se=new w.Emitter({onWillAddFirstListener:()=>{ue=new c.DisposableStore;const Y=new w.EventMultiplexer,W=new Map,F=z=>{const G=z.channelClient.getChannel(O).listen(Q,oe),x=Y.add(G);W.set(z,x)},Z=z=>{const ie=W.get(z);ie&&(ie.dispose(),W.delete(z))};j.connections.filter(N).forEach(F),w.Event.filter(j.onDidAddConnection,N)(F,void 0,ue),j.onDidRemoveConnection(Z,void 0,ue),Y.event(se.fire,se,ue),ue.add(Y)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return se.event}registerChannel(O,N){this.channels.set(O,N);for(const Q of this._connections)Q.channelServer.registerChannel(O,N)}dispose(){this.disposables.dispose();for(const O of this._connections)O.channelClient.dispose(),O.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class C{constructor(O,N,Q=null){const oe=new d;l(oe,N),O.send(oe.buffer),this.channelClient=new T(O,Q),this.channelServer=new y(O,N,Q)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,N){this.channelServer.registerChannel(O,N)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function _(U){return{call(O,N,Q){return U.then(oe=>oe.call(O,N,Q))},listen(O,N){const Q=new w.Relay;return U.then(oe=>Q.input=oe.listen(O,N)),Q.event}}}function H(U){let O=!1;return{call(N,Q,oe){return O?U.call(N,Q,oe):(0,s.timeout)(0).then(()=>O=!0).then(()=>U.call(N,Q,oe))},listen(N,Q){if(O)return U.listen(N,Q);const oe=new w.Relay;return(0,s.timeout)(0).then(()=>O=!0).then(()=>oe.input=U.listen(N,Q)),oe.event}}}class q{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const N of O.connections)if(await Promise.resolve(this.fn(N.ctx)))return Promise.resolve(N);return await w.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=q;var K;(function(U){function O(j,ue,se){const Y=j,W=se&&se.disableMarshalling,F=new Map;for(const Z in Y)Q(Z)&&F.set(Z,w.Event.buffer(Y[Z],!0,void 0,ue));return new class{listen(Z,z,ie){const G=F.get(z);if(G)return G;const x=Y[z];if(typeof x=="function"){if(oe(z))return x.call(Y,ie);if(Q(z))return F.set(z,w.Event.buffer(Y[z],!0,void 0,ue)),F.get(z)}throw new R.ErrorNoTelemetry(`Event not found: ${z}`)}call(Z,z,ie){const G=Y[z];if(typeof G=="function"){if(!W&&Array.isArray(ie))for(let te=0;te<ie.length;te++)ie[te]=(0,m.revive)(ie[te]);let x=G.apply(Y,ie);return x instanceof Promise||(x=Promise.resolve(x)),x}throw new R.ErrorNoTelemetry(`Method not found: ${z}`)}}}U.fromService=O;function N(j,ue){const se=ue&&ue.disableMarshalling;return new Proxy({},{get(Y,W){if(typeof W=="string")return ue?.properties?.has(W)?ue.properties.get(W):oe(W)?function(F){return j.listen(W,F)}:Q(W)?j.listen(W):async function(...F){let Z;ue&&!(0,f.isUndefinedOrNull)(ue.context)?Z=[ue.context,...F]:Z=F;const z=await j.call(W,Z);return se?z:(0,m.revive)(z)};throw new R.ErrorNoTelemetry(`Property not found: ${String(W)}`)}})}U.toService=N;function Q(j){return j[0]==="o"&&j[1]==="n"&&u.isUpperAsciiLetter(j.charCodeAt(2))}function oe(j){return/^onDynamic/.test(j)&&u.isUpperAsciiLetter(j.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const O=U.toString();if(O!=="[object Object]")return O}return U}function X(U){return Array.isArray(U)?U.map($):$(U)}function B(U,O,N,Q,oe,j,ue){ue=X(ue);const se=fe[oe],Y=se[Q%se.length];let W=[`%c[${U}]%c[${String(O).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(j)?(W=W.concat(ue),W.push(")")):W.push(ue),console.log.apply(console,W)}class J{constructor(O,N){this._outgoingPrefix=O,this._incomingPrefix=N,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,N,Q,oe,j){this._totalOutgoing+=O,B(this._outgoingPrefix,this._totalOutgoing,O,N,Q,oe,j)}logIncoming(O,N,Q,oe,j){this._totalIncoming+=O,B(this._incomingPrefix,this._totalIncoming,O,N,Q,oe,j)}}e.IPCLogger=J}),define(ce[156],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class n{constructor(b,M){this.sender=b,this.onMessage=M}send(b){try{this.sender.send("vscode:message",b.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=n}),define(ce[157],le([0,1,17,4,44]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(w){this.port=w,this.onMessage=s.Event.fromDOMEventEmitter(this.port,"message",c=>c.data?n.VSBuffer.wrap(c.data):n.VSBuffer.alloc(0)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class L extends b.IPCClient{constructor(w,c){const m=new M(w);super(m,c),this.protocol=m}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=L}),define(ce[117],le([0,1,17,4,2,44]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var R;(function(r){r.enableDiagnostics=!1,r.records=[];const a=new WeakMap;let l=0;function P(k,T){if(!a.has(k)){const A=String(++l);a.set(k,A)}return a.get(k)}function y(k,T,A,C){if(!r.enableDiagnostics)return;const _=P(k,T);if(C instanceof n.VSBuffer||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const H=n.VSBuffer.alloc(C.byteLength);H.set(C),r.records.push({timestamp:Date.now(),id:_,label:T,type:A,buff:H})}else r.records.push({timestamp:Date.now(),id:_,label:T,type:A,data:C})}r.traceSocketEvent=y})(R||(e.SocketDiagnostics=R={}));var w;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w||(e.SocketCloseEventType=w={}));let c=null;function m(){return c||(c=n.VSBuffer.alloc(0)),c}class u{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,l){if(a===0)return m();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const T=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=a),T}if(this._chunks[0].byteLength>a){const T=this._chunks[0].slice(0,a);return l&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),T}const P=n.VSBuffer.alloc(a);let y=0,k=0;for(;a>0;){const T=this._chunks[k];if(T.byteLength>a){const A=T.slice(0,a);P.set(A,y),y+=a,l&&(this._chunks[k]=T.slice(a),this._totalLength-=a),a-=a}else P.set(T,y),y+=T.byteLength,l?(this._chunks.shift(),this._totalLength-=T.byteLength):k++,a-=T.byteLength}return P}}e.ChunkStream=u;var f;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(f||(f={}));function v(r){switch(r){case f.None:return"None";case f.Regular:return"Regular";case f.Control:return"Control";case f.Ack:return"Ack";case f.Disconnect:return"Disconnect";case f.ReplayRequest:return"ReplayRequest";case f.Pause:return"PauseWriting";case f.Resume:return"ResumeWriting";case f.KeepAlive:return"KeepAlive"}}var h;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",r[r.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(h||(e.ProtocolConstants=h={}));class g{constructor(a,l,P,y){this.type=a,this.id=l,this.ack=P,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends b.Disposable{constructor(a){super(),this._onMessage=this._register(new s.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:h.HeaderLength,messageType:f.None,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new u,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent(L.ProtocolHeaderRead,{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const P=this._state.messageType,y=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=h.HeaderLength,this._state.messageType=f.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(L.ProtocolMessageRead,l),this._onMessage.fire(new g(P,y,k,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.VSBuffer.alloc(h.HeaderLength);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:v(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent(L.ProtocolMessageWrite,a.data),this._writeSoon(l,a.data)}_bufferAdd(a,l){const P=this._totalLength===0;return this._data.push(a,l),this._totalLength+=a.byteLength+l.byteLength,P}_bufferTake(){const a=n.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,l){this._bufferAdd(a,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent(L.ProtocolWrite,{byteLength:a.byteLength}),this._socket.write(a)}}class p extends b.Disposable{constructor(a){super(),this._onMessage=new s.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new s.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===f.Regular&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new g(f.Regular,0,0,a))}}e.Protocol=p;class D extends M.IPCClient{static fromSocket(a,l){return new D(new p(a),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(a,l,P=null){super(a,l,P),this.protocol=a}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=D;class I{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new s.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=I;class i{constructor(a){this.data=a,this.next=null}}class d{constructor(){this._first=null,this._last=null}length(){let a=0,l=this._first;for(;l;)l=l.next,a++;return a}peek(){return this._first?this._first.data:null}toArray(){const a=[];let l=0,P=this._first;for(;P;)a[l++]=P.data,P=P.next;return a}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const l=new i(a);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class t{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}constructor(){this.lastRuns=[];const a=Date.now();for(let l=0;l<t._HISTORY_LENGTH;l++)this.lastRuns[l]=a-1e3*l;setInterval(()=>{for(let l=t._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const a=Date.now(),l=(1+t._HISTORY_LENGTH)*1e3;let P=0;for(let y=0;y<t._HISTORY_LENGTH;y++)a-this.lastRuns[y]<=l&&P++;return 1-P/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class o{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(a){this._onControlMessage=new I,this.onControlMessage=this._onControlMessage.event,this._onMessage=new I,this.onMessage=this._onMessage.event,this._onDidDispose=new I,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new I,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new I,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a.loadEstimator??t.getInstance(),this._shouldSendKeepAlive=a.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new d,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new b.DisposableStore,this._socket=a.socket,this._socketWriter=this._socketDisposables.add(new S(this._socket)),this._socketReader=this._socketDisposables.add(new E(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.add(this._socket.onClose(l=>this._onSocketClose.fire(l))),a.initialChunk&&this._socketReader.acceptChunk(a.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},h.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){if(!this._didSendDisconnect){this._didSendDisconnect=!0;const a=new g(f.Disconnect,0,0,m());this._socketWriter.write(a),this._socketWriter.flush()}}sendPause(){const a=new g(f.Pause,0,0,m());this._socketWriter.write(a)}sendResume(){const a=new g(f.Resume,0,0,m());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,l){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new b.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=this._socketDisposables.add(new S(this._socket)),this._socketReader=this._socketDisposables.add(new E(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.add(this._socket.onClose(P=>this._onSocketClose.fire(P))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new g(f.Ack,0,this._incomingAckId,m());this._socketWriter.write(a);const l=this._outgoingUnackMsg.toArray();for(let P=0,y=l.length;P<y;P++)this._socketWriter.write(l[P]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case f.None:break;case f.Regular:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new g(f.ReplayRequest,0,0,m())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case f.Control:{this._onControlMessage.fire(a.data);break}case f.Ack:break;case f.Disconnect:{this._onDidDispose.fire();break}case f.ReplayRequest:{const l=this._outgoingUnackMsg.toArray();for(let P=0,y=l.length;P<y;P++)this._socketWriter.write(l[P]);this._recvAckCheck();break}case f.Pause:{this._socketWriter.pause();break}case f.Resume:{this._socketWriter.resume();break}case f.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const P=new g(f.Regular,l,this._incomingAckId,a);this._outgoingUnackMsg.push(P),this._isReconnecting||(this._socketWriter.write(P),this._recvAckCheck())}sendControl(a){const l=new g(f.Control,0,0,a);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=h.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},h.AcknowledgeTime-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),l=Date.now()-a.writtenTime,P=Date.now()-this._socketReader.lastReadTime,y=Date.now()-this._lastSocketTimeoutTime;if(l>=h.TimeoutTime&&P>=h.TimeoutTime&&y>=h.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:P});return}const k=Math.max(h.TimeoutTime-l,h.TimeoutTime-P,h.TimeoutTime-y,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new g(f.Ack,0,this._incomingAckId,m());this._socketWriter.write(a)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const a=new g(f.KeepAlive,0,this._incomingAckId,m());this._socketWriter.write(a)}}e.PersistentProtocol=o});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[35],le([0,1,13,15,12]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0,n=je(n);class M{constructor(){this.mapListenerToWrapper=new WeakMap}on(R,w){const c=(m,...u)=>{this.validateEvent(R,m)&&w(m,...u)};return this.mapListenerToWrapper.set(w,c),n.default.ipcMain.on(R,c),this}once(R,w){return n.default.ipcMain.once(R,(c,...m)=>{this.validateEvent(R,c)&&w(c,...m)}),this}handle(R,w){return n.default.ipcMain.handle(R,(c,...m)=>this.validateEvent(R,c)?w(c,...m):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return n.default.ipcMain.removeHandler(R),this}removeListener(R,w){const c=this.mapListenerToWrapper.get(w);return c&&(n.default.ipcMain.removeListener(R,c),this.mapListenerToWrapper.delete(w)),this}validateEvent(R,w){if(!R||!R.startsWith("vscode:"))return(0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const c=w.senderFrame,m=c.url;if(!m||m==="about:blank")return!0;let u="unknown";try{u=new URL(m).host}catch{return(0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${m}'.`),!1}return u!==b.VSCODE_AUTHORITY?((0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${u}'.`),!1):c.parent!==null?((0,s.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${u}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new M}),define(ce[158],le([0,1,13,35,155]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=M;function M(){s.validatedIpcMain.on(b.CONTEXT_MENU_CHANNEL,(R,w,c,m,u)=>{const f=L(R,m,c);f.popup({x:u?u.x:void 0,y:u?u.y:void 0,positioningItem:u?u.positioningItem:void 0,callback:()=>{f&&R.sender.send(b.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}function L(R,w,c){const m=new n.Menu;return c.forEach(u=>{let f;u.type==="separator"?f=new n.MenuItem({type:u.type}):Array.isArray(u.submenu)?f=new n.MenuItem({submenu:L(R,w,u.submenu),label:u.label}):f=new n.MenuItem({label:u.label,type:u.type,accelerator:u.accelerator,checked:u.checked,enabled:u.enabled,visible:u.visible,click:(v,h,g)=>R.sender.send(w,u.id,g)}),m.append(f)}),m}}),define(ce[159],le([0,1,35,17,4,2,44,156]),function(V,e,n,s,b,M,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(m,u){const f=b.Event.fromNodeEventEmitter(n.validatedIpcMain,u,(h,g)=>({event:h,message:g})),v=b.Event.filter(f,({event:h})=>h.sender.id===m);return b.Event.map(v,({message:h})=>h&&s.VSBuffer.wrap(h))}class c extends L.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const u=b.Event.fromNodeEventEmitter(n.validatedIpcMain,"vscode:hello",({sender:f})=>f);return b.Event.map(u,f=>{const v=f.id;c.Clients.get(v)?.dispose();const g=new b.Emitter;c.Clients.set(v,(0,M.toDisposable)(()=>g.fire()));const E=w(v,"vscode:message"),S=b.Event.any(b.Event.signal(w(v,"vscode:disconnect")),g.event);return{protocol:new R.Protocol(f,E),onDidClientDisconnect:S}})}constructor(){super(c.getOnDidClientConnect())}}e.Server=c}),define(ce[118],le([0,1,35,4,33,157]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=void 0,e.connect=R;class L extends M.Client{constructor(c,m){super({addEventListener:(u,f)=>c.addListener(u,f),removeEventListener:(u,f)=>c.removeListener(u,f),postMessage:u=>c.postMessage(u),start:()=>c.start(),close:()=>c.close()},m)}}e.Client=L;async function R(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,b.generateUuid)();w.webContents.send("vscode:createMessageChannel",c);const m=s.Event.fromNodeEventEmitter(n.validatedIpcMain,"vscode:createMessageChannelResult",(f,v)=>({nonce:v,port:f.ports[0]})),{port:u}=await s.Event.toPromise(s.Event.once(s.Event.filter(m,f=>f.nonce===c)));return u}}),define(ce[160],le([0,1,48,8,17,22,150,15,4,2,37,94,79,44]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,R=De(R);class h extends v.ChannelServer{constructor(S){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",p=>b.VSBuffer.wrap(Buffer.from(p,"base64")))},S),process.once("disconnect",()=>this.dispose())}}e.Server=h;class g{constructor(S,p){this.modulePath=S,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const D=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new s.Delayer(D),this.child=null,this._client=null}getChannel(S){const p=this;return{call(D,I,i){return p.requestPromise(S,D,I,i)},listen(D,I){return p.requestEvent(S,D,I)}}}requestPromise(S,p,D,I=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(I.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(S),d=(0,s.createCancelablePromise)(r=>i.call(p,D,r)),t=I.onCancellationRequested(()=>d.cancel()),o=(0,c.toDisposable)(()=>d.cancel());return this.activeRequests.add(o),d.finally(()=>{t.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),d}requestEvent(S,p,D){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let I;const i=new w.Emitter({onWillAddFirstListener:()=>{I=this.getCachedChannel(S).listen(p,D)(i.fire,i),this.activeRequests.add(I)},onDidRemoveLastListener:()=>{this.activeRequests.delete(I),I.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,f.removeDangerousEnvVariables)(p.env),this.child=(0,n.fork)(this.modulePath,S,p);const D=new w.Emitter,i=w.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,L.isRemoteConsoleLog)(l)){(0,L.log)(l,`IPC Library: ${this.options.serverName}`);return}D.fire(b.VSBuffer.wrap(Buffer.from(l,"base64")))}),d=this.options.useQueue?(0,u.createQueuedSender)(this.child):this.child,t=l=>this.child&&this.child.connected&&d.send(l.buffer.toString("base64")),o=D.event,r={send:t,onMessage:o};this._client=new v.ChannelClient(r);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,P)=>{process.removeListener("exit",a),i.dispose(),this.activeRequests.forEach(y=>(0,c.dispose)(y)),this.activeRequests.clear(),l!==0&&P!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+P),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:P})})}return this._client}getCachedChannel(S){let p=this.channels.get(S);return p||(p=this.client.getChannel(S),this.channels.set(S,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(ce[119],le([0,1,8,4,2,82,11]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=w;var R;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function w(f){const v=f;return v?.changed instanceof Map||v?.deleted instanceof Set}var c;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(c||(e.StorageState=c={}));class m extends b.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(v,h=Object.create(null)){super(),this.database=v,this.options=h,this._onDidChangeStorage=this._register(new s.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=this._register(new n.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){this._onDidChangeStorage.pause();try{v.changed?.forEach((h,g)=>this.acceptExternal(g,h)),v.deleted?.forEach(h=>this.acceptExternal(h,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(v,h){if(this.state===c.Closed)return;let g=!1;(0,L.isUndefinedOrNull)(h)?g=this.cache.delete(v):this.cache.get(v)!==h&&(this.cache.set(v,h),g=!0),g&&this._onDidChangeStorage.fire({key:v,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,h){const g=this.cache.get(v);return(0,L.isUndefinedOrNull)(g)?h:g}getBoolean(v,h){const g=this.get(v);return(0,L.isUndefinedOrNull)(g)?h:g==="true"}getNumber(v,h){const g=this.get(v);return(0,L.isUndefinedOrNull)(g)?h:parseInt(g,10)}getObject(v,h){const g=this.get(v);return(0,L.isUndefinedOrNull)(g)?h:(0,M.parse)(g)}async set(v,h,g=!1){if(this.state===c.Closed)return;if((0,L.isUndefinedOrNull)(h))return this.delete(v,g);const E=(0,L.isObject)(h)||Array.isArray(h)?(0,M.stringify)(h):String(h);if(this.cache.get(v)!==E)return this.cache.set(v,E),this.pendingInserts.set(v,E),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire({key:v,external:g}),this.doFlush()}async delete(v,h=!1){if(!(this.state===c.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire({key:v,external:h}),this.doFlush()}async optimize(){if(this.state!==c.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(v){if(!(this.state===c.Closed||this.pendingClose))return this.doFlush(v)}async doFlush(v){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),v)}async whenFlushed(){if(this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=m;class u{constructor(){this.onDidChangeItemsExternal=s.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert?.forEach((h,g)=>this.items.set(g,h)),v.delete?.forEach(h=>this.items.delete(h))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=u}),define(ce[161],le([0,1,26,8,4,31,9,23]),function(V,e,n,s,b,M,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0,n=De(n);class w{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return b.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(u,f=Object.create(null)){this.path=u,this.options=f,this.name=(0,L.basename)(this.path),this.logger=new c(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const u=await this.whenConnected,f=new Map;return(await this.all(u,"SELECT * FROM ItemTable")).forEach(h=>f.set(h.key,h.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${f.size} rows`),f}async updateItems(u){const f=await this.whenConnected;return this.doUpdateItems(f,u)}doUpdateItems(u,f){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${f.insert?(0,M.mapToString)(f.insert):"0"}), delete(${f.delete?(0,M.setToString)(f.delete):"0"})`),this.transaction(u,()=>{const v=f.insert,h=f.delete;if(v&&v.size>0){const g=[];g.push([]);let E=0;v.forEach((S,p)=>{let D=g[E];D.length>w.MAX_HOST_PARAMETERS&&(E++,D=[],g.push(D)),D.push(p,S)}),g.forEach(S=>{this.prepare(u,`INSERT INTO ItemTable VALUES ${new Array(S.length/2).fill("(?,?)").join(",")}`,p=>p.run(S),()=>{const p=[];let D=0;return v.forEach((I,i)=>{p.push(i),D+=I.length}),`Keys: ${p.join(", ")} Length: ${D}`})})}if(h&&h.size){const g=[];g.push([]);let E=0;h.forEach(S=>{let p=g[E];p.length>w.MAX_HOST_PARAMETERS&&(E++,p=[],g.push(p)),p.push(S)}),g.forEach(S=>{this.prepare(u,`DELETE FROM ItemTable WHERE key IN (${new Array(S.length).fill("?").join(",")})`,p=>p.run(S),()=>{const p=[];return h.forEach(D=>{p.push(D)}),`Keys: ${p.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const u=await this.whenConnected;return this.exec(u,"VACUUM")}async close(u){this.logger.trace(`[storage ${this.name}] close()`);const f=await this.whenConnected;return this.doClose(f,u)}doClose(u,f){return new Promise((v,h)=>{u.db.close(g=>(g&&this.handleSQLiteError(u,`[storage ${this.name}] close(): ${g}`),this.path===w.IN_MEMORY_PATH?v():!u.isErroneous&&!u.isInMemory?this.backup().then(v,E=>(this.logger.error(`[storage ${this.name}] backup(): ${E}`),v())):typeof f=="function"?n.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(E=>{const S=()=>this.doClose(E,void 0);return this.doUpdateItems(E,{insert:f()}).then(()=>S(),p=>(S(),Promise.reject(p)))})).then(v,h):h(g||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const u=this.toBackupPath(this.path);return R.Promises.copy(this.path,u,{preserveSymlinks:!1})}toBackupPath(u){return`${u}.backup`}async checkIntegrity(u){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${u})`);const f=await this.whenConnected,v=await this.get(f,u?"PRAGMA integrity_check":"PRAGMA quick_check"),h=u?v.integrity_check:v.quick_check;return f.isErroneous?`${h} (last error: ${f.lastError})`:f.isInMemory?`${h} (in-memory!)`:h}async connect(u,f=!0){this.logger.trace(`[storage ${this.name}] open(${u}, retryOnBusy: ${f})`);try{return await this.doConnect(u)}catch(v){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&f)return await(0,s.timeout)(w.BUSY_OPEN_TIMEOUT),this.connect(u,!1);try{await n.promises.unlink(u);try{await R.Promises.rename(this.toBackupPath(u),u,!1)}catch{}return await this.doConnect(u)}catch(h){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${h}`),this.doConnect(w.IN_MEMORY_PATH)}}}handleSQLiteError(u,f){u.isErroneous=!0,u.lastError=f,this.logger.error(f)}doConnect(u){return new Promise((f,v)=>{new Promise((h,g)=>{V(["@vscode/sqlite3"],h,g)}).then(De).then(h=>{const g=this.logger.isTracing?h.verbose().Database:h.Database,E={db:new g(u,S=>S?E.db&&S.code!=="SQLITE_CANTOPEN"?E.db.close(()=>v(S)):v(S):this.exec(E,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>f(E),p=>E.db.close(()=>v(p)))),isInMemory:u===w.IN_MEMORY_PATH};E.db.on("error",S=>this.handleSQLiteError(E,`[storage ${this.name}] Error (event): ${S}`)),this.logger.isTracing&&E.db.on("trace",S=>this.logger.trace(`[storage ${this.name}] Trace (event): ${S}`))},v)})}exec(u,f){return new Promise((v,h)=>{u.db.exec(f,g=>g?(this.handleSQLiteError(u,`[storage ${this.name}] exec(): ${g}`),h(g)):v())})}get(u,f){return new Promise((v,h)=>{u.db.get(f,(g,E)=>g?(this.handleSQLiteError(u,`[storage ${this.name}] get(): ${g}`),h(g)):v(E))})}all(u,f){return new Promise((v,h)=>{u.db.all(f,(g,E)=>g?(this.handleSQLiteError(u,`[storage ${this.name}] all(): ${g}`),h(g)):v(E))})}transaction(u,f){return new Promise((v,h)=>{u.db.serialize(()=>{u.db.run("BEGIN TRANSACTION"),f(),u.db.run("END TRANSACTION",g=>g?(this.handleSQLiteError(u,`[storage ${this.name}] transaction(): ${g}`),h(g)):v())})})}prepare(u,f,v,h){const g=u.db.prepare(f),E=S=>{this.handleSQLiteError(u,`[storage ${this.name}] prepare(): ${S} (${f}). Details: ${h()}`)};g.on("error",E),v(g),g.finalize(S=>{S&&E(S),g.removeListener("error",E)})}}e.SQLiteStorageDatabase=w;class c{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(u){u&&typeof u.logTrace=="function"&&process.env[c.VSCODE_TRACE_STORAGE]&&(this.logTrace=u.logTrace),u&&typeof u.logError=="function"&&(this.logError=u.logError)}get isTracing(){return!!this.logTrace}trace(u){this.logTrace?.(u)}error(u){this.logError?.(u)}}}),define(ce[10],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=b,e.localize2=L;const n=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function s(R,w){let c;return w.length===0?c=R:c=R.replace(/\{(\d+)\}/g,(m,u)=>{const f=u[0],v=w[f];let h=m;return typeof v=="string"?h=v:(typeof v=="number"||typeof v=="boolean"||v===void 0||v===null)&&(h=String(v)),h}),n&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function b(R,w,...c){return s(typeof R=="number"?M(R,w):w,c)}function M(R,w){const c=globalThis._VSCODE_NLS_MESSAGES?.[R];if(typeof c!="string"){if(typeof w=="string")return w;throw new Error(`!!! NLS MISSING: ${R} !!!`)}return c}function L(R,w,...c){let m;typeof R=="number"?m=M(R,w):m=w;const u=s(m,c);return{value:u,original:w===m?u:s(w,c)}}}),define(ce[162],le([0,1,10]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=c,e.getDurationString=m,e.toLocalISOString=u;const s=60,b=s*60,M=b*24,L=M*7,R=M*30,w=M*365;function c(f,v,h,g){typeof f!="number"&&(f=f.getTime());const E=Math.round((new Date().getTime()-f)/1e3);if(E<-30)return(0,n.localize)(12985,null,c(new Date().getTime()+E*1e3,!1));if(!g&&E<30)return(0,n.localize)(12986,null);let S;return E<s?(S=E,v?S===1?h?(0,n.localize)(12987,null,S):(0,n.localize)(12988,null,S):h?(0,n.localize)(12989,null,S):(0,n.localize)(12990,null,S):S===1?h?(0,n.localize)(12991,null,S):(0,n.localize)(12992,null,S):h?(0,n.localize)(12993,null,S):(0,n.localize)(12994,null,S)):E<b?(S=Math.floor(E/s),v?S===1?h?(0,n.localize)(12995,null,S):(0,n.localize)(12996,null,S):h?(0,n.localize)(12997,null,S):(0,n.localize)(12998,null,S):S===1?h?(0,n.localize)(12999,null,S):(0,n.localize)(13e3,null,S):h?(0,n.localize)(13001,null,S):(0,n.localize)(13002,null,S)):E<M?(S=Math.floor(E/b),v?S===1?h?(0,n.localize)(13003,null,S):(0,n.localize)(13004,null,S):h?(0,n.localize)(13005,null,S):(0,n.localize)(13006,null,S):S===1?h?(0,n.localize)(13007,null,S):(0,n.localize)(13008,null,S):h?(0,n.localize)(13009,null,S):(0,n.localize)(13010,null,S)):E<L?(S=Math.floor(E/M),v?S===1?(0,n.localize)(13011,null,S):(0,n.localize)(13012,null,S):S===1?(0,n.localize)(13013,null,S):(0,n.localize)(13014,null,S)):E<R?(S=Math.floor(E/L),v?S===1?h?(0,n.localize)(13015,null,S):(0,n.localize)(13016,null,S):h?(0,n.localize)(13017,null,S):(0,n.localize)(13018,null,S):S===1?h?(0,n.localize)(13019,null,S):(0,n.localize)(13020,null,S):h?(0,n.localize)(13021,null,S):(0,n.localize)(13022,null,S)):E<w?(S=Math.floor(E/R),v?S===1?h?(0,n.localize)(13023,null,S):(0,n.localize)(13024,null,S):h?(0,n.localize)(13025,null,S):(0,n.localize)(13026,null,S):S===1?h?(0,n.localize)(13027,null,S):(0,n.localize)(13028,null,S):h?(0,n.localize)(13029,null,S):(0,n.localize)(13030,null,S)):(S=Math.floor(E/w),v?S===1?h?(0,n.localize)(13031,null,S):(0,n.localize)(13032,null,S):h?(0,n.localize)(13033,null,S):(0,n.localize)(13034,null,S):S===1?h?(0,n.localize)(13035,null,S):(0,n.localize)(13036,null,S):h?(0,n.localize)(13037,null,S):(0,n.localize)(13038,null,S))}function m(f,v){const h=Math.abs(f/1e3);return h<1?v?(0,n.localize)(13039,null,f):(0,n.localize)(13040,null,f):h<s?v?(0,n.localize)(13041,null,Math.round(f)/1e3):(0,n.localize)(13042,null,Math.round(f)/1e3):h<b?v?(0,n.localize)(13043,null,Math.round(f/(1e3*s))):(0,n.localize)(13044,null,Math.round(f/(1e3*s))):h<M?v?(0,n.localize)(13045,null,Math.round(f/(1e3*b))):(0,n.localize)(13046,null,Math.round(f/(1e3*b))):(0,n.localize)(13047,null,Math.round(f/(1e3*M)))}function u(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[55],le([0,1,21,11,10]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=w,e.isErrorWithActions=c,e.createErrorWithActions=m,n=De(n),s=De(s),b=De(b);function M(u,f){return f&&(u.stack||u.stacktrace)?b.localize(12979,null,R(u),L(u.stack)||L(u.stacktrace)):R(u)}function L(u){return Array.isArray(u)?u.join(`
`):u}function R(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?b.localize(12980,null,u.message):u.message||b.localize(12981,null)}function w(u=null,f=!1){if(!u)return b.localize(12982,null);if(Array.isArray(u)){const v=n.coalesce(u),h=w(v[0],f);return v.length>1?b.localize(12983,null,h,v.length):h}if(s.isString(u))return u;if(u.detail){const v=u.detail;if(v.error)return M(v.error,f);if(v.exception)return M(v.exception,f)}return u.stack?M(u,f):u.message?u.message:b.localize(12984,null)}function c(u){const f=u;return f instanceof Error&&Array.isArray(f.actions)}function m(u,f){let v;return typeof u=="string"?v=new Error(u):v=u,v.actions=f,v}}),define(ce[163],le([0,1,10,43]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=b;function b(M){switch(M){case s.ParseErrorCode.InvalidSymbol:return(0,n.localize)(12970,null);case s.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(12971,null);case s.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(12972,null);case s.ParseErrorCode.ValueExpected:return(0,n.localize)(12973,null);case s.ParseErrorCode.ColonExpected:return(0,n.localize)(12974,null);case s.ParseErrorCode.CommaExpected:return(0,n.localize)(12975,null);case s.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(12976,null);case s.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(12977,null);case s.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(12978,null);default:return""}}}),define(ce[164],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isFolderBackupInfo=n,e.isWorkspaceBackupInfo=s;function n(b){return b&&b.hasOwnProperty("folderUri")}function s(b){return b&&b.hasOwnProperty("workspace")}}),define(ce[165],le([0,1,7]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=s,e.deserializeWorkspaceInfos=b,e.deserializeFolderInfos=M;function s(L){return typeof L?.backupFolder=="string"}function b(L){let R=[];try{Array.isArray(L.workspaces)&&(R=L.workspaces.map(w=>({workspace:{id:w.id,configPath:n.URI.parse(w.configURIPath)},remoteAuthority:w.remoteAuthority})))}catch{}return R}function M(L){let R=[];try{Array.isArray(L.folders)&&(R=L.folders.map(w=>({folderUri:n.URI.parse(w.folderUri),remoteAuthority:w.remoteAuthority})))}catch{}return R}}),define(ce[166],le([0,1,39,15,10]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var M;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(M||(e.TokenType=M={}));function L(...m){switch(m.length){case 1:return(0,b.localize)(11586,null,m[0]);case 2:return(0,b.localize)(11587,null,m[0],m[1]);case 3:return(0,b.localize)(11588,null,m[0],m[1],m[2]);default:return}}const R=(0,b.localize)(11589,null),w=(0,b.localize)(11590,null);class c{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case M.LParen:return"(";case M.RParen:return")";case M.Neg:return"!";case M.Eq:return u.isTripleEq?"===":"==";case M.NotEq:return u.isTripleEq?"!==":"!=";case M.Lt:return"<";case M.LtEq:return"<=";case M.Gt:return">=";case M.GtEq:return">=";case M.RegexOp:return"=~";case M.RegexStr:return u.lexeme;case M.True:return"true";case M.False:return"false";case M.In:return"in";case M.Not:return"not";case M.And:return"&&";case M.Or:return"||";case M.Str:return u.lexeme;case M.QuotedStr:return u.lexeme;case M.Error:return u.lexeme;case M.EOF:return"EOF";default:throw(0,s.illegalState)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this._keywords=new Map([["not",M.Not],["in",M.In],["false",M.False],["true",M.True]])}get errors(){return this._errors}reset(u){return this._input=u,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case n.CharCode.OpenParen:this._addToken(M.LParen);break;case n.CharCode.CloseParen:this._addToken(M.RParen);break;case n.CharCode.ExclamationMark:if(this._match(n.CharCode.Equals)){const f=this._match(n.CharCode.Equals);this._tokens.push({type:M.NotEq,offset:this._start,isTripleEq:f})}else this._addToken(M.Neg);break;case n.CharCode.SingleQuote:this._quotedString();break;case n.CharCode.Slash:this._regex();break;case n.CharCode.Equals:if(this._match(n.CharCode.Equals)){const f=this._match(n.CharCode.Equals);this._tokens.push({type:M.Eq,offset:this._start,isTripleEq:f})}else this._match(n.CharCode.Tilde)?this._addToken(M.RegexOp):this._error(L("==","=~"));break;case n.CharCode.LessThan:this._addToken(this._match(n.CharCode.Equals)?M.LtEq:M.Lt);break;case n.CharCode.GreaterThan:this._addToken(this._match(n.CharCode.Equals)?M.GtEq:M.Gt);break;case n.CharCode.Ampersand:this._match(n.CharCode.Ampersand)?this._addToken(M.And):this._error(L("&&"));break;case n.CharCode.Pipe:this._match(n.CharCode.Pipe)?this._addToken(M.Or):this._error(L("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(M.EOF),Array.from(this._tokens)}_match(u){return this._isAtEnd()||this._input.charCodeAt(this._current)!==u?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?n.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(u){this._tokens.push({type:u,offset:this._start})}_error(u){const f=this._start,v=this._input.substring(this._start,this._current),h={type:M.Error,offset:this._start,lexeme:v};this._errors.push({offset:f,lexeme:v,additionalInfo:u}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const u=this.stringRe.exec(this._input);if(u){this._current=this._start+u[0].length;const f=this._input.substring(this._start,this._current),v=c._keywords.get(f);v?this._addToken(v):this._tokens.push({type:M.Str,lexeme:f,offset:this._start})}}_quotedString(){for(;this._peek()!==n.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:M.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let u=this._current,f=!1,v=!1;for(;;){if(u>=this._input.length){this._current=u,this._error(w);return}const g=this._input.charCodeAt(u);if(f)f=!1;else if(g===n.CharCode.Slash&&!v){u++;break}else g===n.CharCode.OpenSquareBracket?v=!0:g===n.CharCode.Backslash?f=!0:g===n.CharCode.CloseSquareBracket&&(v=!1);u++}for(;u<this._input.length&&c._regexFlags.has(this._input.charCodeAt(u));)u++;this._current=u;const h=this._input.substring(this._start,this._current);this._tokens.push({type:M.RegexStr,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=c}),define(ce[167],le([0,1,4,2]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class b{constructor(){this._onCloseEmitter=new n.Emitter,this._onReloadEmitter=new n.Emitter,this._onTerminateEmitter=new n.Emitter,this._onAttachEmitter=new n.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(R,w,c){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(R,w,c){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=b;class M extends s.Disposable{constructor(R){super(),this.channel=R}reload(R){this.channel.call("reload",[R])}get onReload(){return this.channel.listen("reload")}close(R){this.channel.call("close",[R])}get onClose(){return this.channel.listen("close")}attachSession(R,w,c){this.channel.call("attach",[R,w,c])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(R,w){this.channel.call("terminate",[R,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(R,w){return this.channel.call("openExtensionDevelopmentHostWindow",[R,w])}}e.ExtensionHostDebugChannelClient=M}),define(ce[168],le([0,1,162,54,12,9,36,18,7]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=m,e.parseDebugParams=u,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,M.dirname)(b.FileAccess.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:b.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const v=(0,n.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",v)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(w.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=L.env.VSCODE_PORTABLE;return v?w.URI.file((0,M.join)(v,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,M.resolve)(v):(0,M.normalize)((0,M.join)(b.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?w.URI.file((0,M.resolve)(v)):w.URI.file((0,M.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,M.resolve)(v);const h=L.env.VSCODE_EXTENSIONS;if(h)return h;const g=L.env.VSCODE_PORTABLE;return g?(0,M.join)(g,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(h=>/^[^:/?#]+?:\/\//.test(h)?w.URI.parse(h):w.URI.file((0,M.normalize)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?w.URI.parse(v):w.URI.file((0,M.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const h of this.args.log||[]){const g=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(h);g&&g[1]&&g[2]&&v.push([g[1],g[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=L.env.VSCODE_PORTABLE;return v?w.URI.file((0,M.join)(v,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this._args}constructor(v,h,g){this._args=v,this.paths=h,this.productService=g,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=c,Ie([s.memoize],c.prototype,"appRoot",null),Ie([s.memoize],c.prototype,"userHome",null),Ie([s.memoize],c.prototype,"userDataPath",null),Ie([s.memoize],c.prototype,"appSettingsHome",null),Ie([s.memoize],c.prototype,"tmpDir",null),Ie([s.memoize],c.prototype,"cacheHome",null),Ie([s.memoize],c.prototype,"stateResource",null),Ie([s.memoize],c.prototype,"userRoamingDataHome",null),Ie([s.memoize],c.prototype,"userDataSyncHome",null),Ie([s.memoize],c.prototype,"sync",null),Ie([s.memoize],c.prototype,"machineSettingsResource",null),Ie([s.memoize],c.prototype,"workspaceStorageHome",null),Ie([s.memoize],c.prototype,"localHistoryHome",null),Ie([s.memoize],c.prototype,"keyboardLayoutResource",null),Ie([s.memoize],c.prototype,"argvResource",null),Ie([s.memoize],c.prototype,"isExtensionDevelopment",null),Ie([s.memoize],c.prototype,"untitledWorkspacesHome",null),Ie([s.memoize],c.prototype,"builtinExtensionsPath",null),Ie([s.memoize],c.prototype,"extensionsPath",null),Ie([s.memoize],c.prototype,"extensionDevelopmentLocationURI",null),Ie([s.memoize],c.prototype,"extensionDevelopmentKind",null),Ie([s.memoize],c.prototype,"extensionTestsLocationURI",null),Ie([s.memoize],c.prototype,"debugExtensionHost",null),Ie([s.memoize],c.prototype,"logLevel",null),Ie([s.memoize],c.prototype,"extensionLogLevel",null),Ie([s.memoize],c.prototype,"serviceMachineIdResource",null),Ie([s.memoize],c.prototype,"disableTelemetry",null),Ie([s.memoize],c.prototype,"disableWorkspaceTrust",null),Ie([s.memoize],c.prototype,"useInMemorySecretStorage",null),Ie([s.memoize],c.prototype,"policyFile",null);function m(f,v){return u(f["inspect-extensions"],f["inspect-brk-extensions"],5870,v,f.debugId,f.extensionEnvironment)}function u(f,v,h,g,E,S){const D=Number(v||f)||(g?null:h),I=D?!!v:!1;let i;if(S)try{i=JSON.parse(S)}catch{}return{port:D,break:I,debugId:E,env:i}}});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[120],le([0,1,280,3,10]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=R,e.formatOptions=c,e.buildHelpMessage=v,e.buildVersionMessage=h,n=je(n);const M={o:(0,b.localize)(11523,null),e:(0,b.localize)(11524,null),t:(0,b.localize)(11525,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,b.localize)(11526,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,b.localize)(11527,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,b.localize)(11528,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,b.localize)(11529,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,b.localize)(11530,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,b.localize)(11531,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,b.localize)(11532,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,b.localize)(11533,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,b.localize)(11534,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,b.localize)(11535,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,b.localize)(11536,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,b.localize)(11537,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,b.localize)(11538,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,b.localize)(11539,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,b.localize)(11540,null)},"show-versions":{type:"boolean",cat:"e",description:(0,b.localize)(11541,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,b.localize)(11542,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,b.localize)(11543,null)},"pre-release":{type:"boolean",cat:"e",description:(0,b.localize)(11544,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,b.localize)(11545,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,b.localize)(11546,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,b.localize)(11547,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,b.localize)(11548,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,b.localize)(11549,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,b.localize)(11550,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,b.localize)(11551,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,b.localize)(11552,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,b.localize)(11553,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,b.localize)(11554,null)},sync:{type:"string",cat:"t",description:(0,b.localize)(11555,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,b.localize)(11556,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,b.localize)(11557,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,b.localize)(11558,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,b.localize)(11559,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,b.localize)(11560,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,b.localize)(11561,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(g,E,S=L){const p=g.find(l=>l.length>0&&l[0]!=="-"),D={},I=["_"],i=[],d={};let t;for(const l in E){const P=E[l];P.type==="subcommand"?l===p&&(t=P):(P.alias&&(D[l]=P.alias),P.type==="string"||P.type==="string[]"?(I.push(l),P.deprecates&&I.push(...P.deprecates)):P.type==="boolean"&&(i.push(l),P.deprecates&&i.push(...P.deprecates)),P.global&&(d[l]=P))}if(t&&p){const l=d;for(const T in t.options)l[T]=t.options[T];const P=g.filter(T=>T!==p),y=S.getSubcommandReporter?S.getSubcommandReporter(p):void 0,k=R(P,l,y);return{[p]:k,_:[]}}const o=(0,n.default)(g,{string:I,boolean:i,alias:D}),r={},a=o;r._=o._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in E){const P=E[l];if(P.type==="subcommand")continue;P.alias&&delete a[P.alias];let y=a[l];if(P.deprecates)for(const k of P.deprecates)a.hasOwnProperty(k)&&(y||(y=a[k],y&&S.onDeprecatedOption(k,P.deprecationMessage||(0,b.localize)(11562,null,l))),delete a[k]);if(typeof y<"u"){if(P.type==="string[]"){if(Array.isArray(y)||(y=[y]),!P.allowEmptyValue){const k=y.filter(T=>T.length>0);k.length!==y.length&&(S.onEmptyValue(l),y=k.length>0?k:void 0)}}else P.type==="string"&&(Array.isArray(y)?(y=y.pop(),S.onMultipleValues(l,y)):!y&&!P.allowEmptyValue&&(S.onEmptyValue(l),y=void 0));r[l]=y,P.deprecationMessage&&S.onDeprecatedOption(l,P.deprecationMessage)}delete a[l]}for(const l in a)S.onUnknownOption(l);return r}function w(g,E){let S="";return E.args&&(Array.isArray(E.args)?S=` <${E.args.join("> <")}>`:S=` <${E.args}>`),E.alias?`-${E.alias} --${g}${S}`:`--${g}${S}`}function c(g,E){const S=[];for(const p in g){const D=g[p],I=w(p,D);S.push([I,D.description])}return m(S,E)}function m(g,E){const p=g.reduce((i,d)=>Math.max(i,d[0].length),12)+2+1;if(E-p<25)return g.reduce((i,d)=>i.concat([`  ${d[0]}`,`      ${d[1]}`]),[]);const D=E-p-1,I=[];for(const i of g){const d=i[0],t=f(i[1],D),o=u(p-d.length-2);I.push("  "+d+o+t[0]);for(let r=1;r<t.length;r++)I.push(u(p)+t[r])}return I}function u(g){return" ".repeat(g)}function f(g,E){const S=[];for(;g.length;){const p=g.length<E?g.length:g.lastIndexOf(" ",E),D=g.slice(0,p).trim();g=g.slice(p),S.push(D)}return S}function v(g,E,S,p,D){const I=process.stdout.isTTY&&process.stdout.columns||80,i=D?.noInputFiles!==!0?`[${(0,b.localize)(11563,null)}...]`:"",d=[`${g} ${S}`];d.push(""),d.push(`${(0,b.localize)(11564,null)}: ${E} [${(0,b.localize)(11565,null)}]${i}`),d.push(""),D?.noPipe!==!0&&(s.isWindows?d.push((0,b.localize)(11566,null,E)):d.push((0,b.localize)(11567,null,E)),d.push(""));const t={},o=[];for(const r in p){const a=p[r];if(a.type==="subcommand")a.description&&o.push({command:r,description:a.description});else if(a.description&&a.cat){let l=t[a.cat];l||(t[a.cat]=l={}),l[r]=a}}for(const r in t){const a=r,l=t[a];l&&(d.push(M[a]),d.push(...c(l,I)),d.push(""))}return o.length&&(d.push((0,b.localize)(11568,null)),d.push(...m(o.map(r=>[r.command,r.description]),I)),d.push("")),d.join(`
`)}function h(g,E){return`${g||(0,b.localize)(11569,null)}
${E||(0,b.localize)(11570,null)}
${process.arch}`}});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[68],le([0,1,281,10,120]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMainProcessArgv=R,e.parseCLIProcessArgv=w,e.addArg=c,e.isLaunchedFromCli=m,n=je(n);function M(u,f){const v=(D,I)=>{console.warn((0,s.localize)(11517,null,D,I))},h=D=>{console.warn((0,s.localize)(11518,null,D))},g=(D,I)=>{console.warn((0,s.localize)(11519,null,D,I))},E=D=>({onUnknownOption:I=>{b.NATIVE_CLI_COMMANDS.includes(D)||console.warn((0,s.localize)(11520,null,I,D))},onMultipleValues:v,onEmptyValue:h,onDeprecatedOption:g,getSubcommandReporter:b.NATIVE_CLI_COMMANDS.includes(D)?E:void 0}),S={onUnknownOption:D=>{console.warn((0,s.localize)(11521,null,D))},onMultipleValues:v,onEmptyValue:h,onDeprecatedOption:g,getSubcommandReporter:E},p=(0,b.parseArgs)(u,b.OPTIONS,f?S:void 0);return p.goto&&p._.forEach(D=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(D),(0,s.localize)(11522,null))),p}function L(u){const f=u.findIndex(v=>!/^-/.test(v));if(f>-1)return[...u.slice(0,f),...u.slice(f+1)]}function R(u){let[,...f]=u;process.env.VSCODE_DEV&&(f=L(f)||[]);const v=!m(process.env);return M(f,v)}function w(u){let[,,...f]=u;return process.env.VSCODE_DEV&&(f=L(f)||[]),M(f,!0)}function c(u,...f){const v=u.indexOf("--");return v===-1?u.push(...f):u.splice(v,0,...f),u}function m(u){return u.VSCODE_CLI==="1"}}),function(){function V(e,n,s){function b(L,R){const w=M(L,R),c=[w];return e.isAbsolute(w)||c.unshift(s),e.resolve(...c)}function M(L,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,R);const m=L["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(u,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,R)}return{getUserDataPath:b}}if(typeof define=="function")define(ce[169],le([121,27,36]),function(e,n,s){return V(e,n,s.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=V(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[95],le([0,1,27,168,169]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=L,e.parseSharedProcessDebugPort=R;class M extends s.AbstractNativeEnvironmentService{constructor(c,m){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,b.getUserDataPath)(c,m.nameShort)},m)}}e.NativeEnvironmentService=M;function L(w,c){return(0,s.parseDebugParams)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,c,w.extensionEnvironment)}function R(w,c){return(0,s.parseDebugParams)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,c,w.extensionEnvironment)}}),define(ce[170],le([0,1,26,27,32]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=M;function M(L){const R=(0,b.randomPath)((0,s.tmpdir)());try{return(0,n.writeFileSync)(R,""),L&&console.log(`Marker file for --wait created: ${R}`),R}catch(w){L&&console.error(`Failed to create marker file for --wait: ${w}`);return}}}),define(ce[171],le([0,1,11,10]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=b;function b(L,R,w,c){try{M(L,R,w,c)}catch(m){L.error(m?.message??m)}return R}function M(L,R,w,c){const m=(u,f,v)=>{const h=u[f];if((0,n.isString)(h)){const g=h,E=g.length;if(E>1&&g[0]==="%"&&g[E-1]==="%"){const S=g.substr(1,E-2);let p=w[S];p===void 0&&c&&(p=c[S]);const D=typeof p=="string"?p:p?.message,I=c?.[S],i=typeof I=="string"?I:I?.message;if(!D){i||L.warn(`[${R.name}]: ${(0,s.localize)(11469,null,S)}`);return}if(v&&(f==="title"||f==="category")&&i&&i!==D){const d={value:D,original:i};u[f]=d}else u[f]=D}}else if((0,n.isObject)(h))for(const g in h)h.hasOwnProperty(g)&&(g==="commands"?m(h,g,!0):m(h,g,v));else if(Array.isArray(h))for(let g=0;g<h.length;g++)m(h,g,v)};for(const u in R)R.hasOwnProperty(u)&&m(R,u)}}),define(ce[172],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(ce[83],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(b,M=[],L=!1){this.ctor=b,this.staticArguments=M,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=n}),define(ce[173],le([0,1,83]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=M,e.getSingletonServiceDescriptors=L;const s=[];var b;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(b||(e.InstantiationType=b={}));function M(R,w,c){w instanceof n.SyncDescriptor||(w=new n.SyncDescriptor(w,[],!!c)),s.push([R,w])}function L(){return s}}),define(ce[174],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(M,L){this.key=M,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class s{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const L of this._nodes.values())L.outgoing.size===0&&M.push(L);return M}insertEdge(M,L){const R=this.lookupOrInsertNode(M),w=this.lookupOrInsertNode(L);R.outgoing.set(w.key,w),w.incoming.set(R.key,R)}removeNode(M){const L=this._hashFn(M);this._nodes.delete(L);for(const R of this._nodes.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(M){const L=this._hashFn(M);let R=this._nodes.get(L);return R||(R=new n(L,M),this._nodes.set(L,R)),R}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[L,R]of this._nodes)M.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,L]of this._nodes){const R=new Set([M]),w=this._findCycle(L,R);if(w)return w}}_findCycle(M,L){for(const[R,w]of M.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const c=this._findCycle(w,L);if(c)return c;L.delete(R)}}}e.Graph=s}),define(ce[6],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=b,e.refineServiceDecorator=M;var n;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R(w){return w[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(n||(e._util=n={})),e.IInstantiationService=b("instantiationService");function s(L,R,w){R[n.DI_TARGET]===R?R[n.DI_DEPENDENCIES].push({id:L,index:w}):(R[n.DI_DEPENDENCIES]=[{id:L,index:w}],R[n.DI_TARGET]=R)}function b(L){if(n.serviceIds.has(L))return n.serviceIds.get(L);const R=function(w,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");s(R,w,m)};return R.toString=()=>L,n.serviceIds.set(L,R),R}function M(L){return L}}),define(ce[84],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuxiliaryWindowsMainService=void 0,e.IAuxiliaryWindowsMainService=(0,n.createDecorator)("auxiliaryWindowsMainService")}),define(ce[69],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,n.createDecorator)("backupMainService")}),define(ce[16],le([0,1,11,7,6]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=M,e.isConfigurationUpdateOverrides=L,e.ConfigurationTargetToString=w,e.isConfigured=c,e.toValuesTree=m,e.addToValueTree=u,e.removeFromValueTree=f,e.getConfigurationValue=h,e.merge=g,e.getLanguageTagSettingPlainKey=E,n=De(n),e.IConfigurationService=(0,b.createDecorator)("configurationService");function M(S){return S&&typeof S=="object"&&(!S.overrideIdentifier||typeof S.overrideIdentifier=="string")&&(!S.resource||S.resource instanceof s.URI)}function L(S){return S&&typeof S=="object"&&(!S.overrideIdentifiers||Array.isArray(S.overrideIdentifiers))&&!S.overrideIdentifier&&(!S.resource||S.resource instanceof s.URI)}var R;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.USER=2]="USER",S[S.USER_LOCAL=3]="USER_LOCAL",S[S.USER_REMOTE=4]="USER_REMOTE",S[S.WORKSPACE=5]="WORKSPACE",S[S.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",S[S.DEFAULT=7]="DEFAULT",S[S.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function w(S){switch(S){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function c(S){return S.applicationValue!==void 0||S.userValue!==void 0||S.userLocalValue!==void 0||S.userRemoteValue!==void 0||S.workspaceValue!==void 0||S.workspaceFolderValue!==void 0}function m(S,p){const D=Object.create(null);for(const I in S)u(D,I,S[I],p);return D}function u(S,p,D,I){const i=p.split("."),d=i.pop();let t=S;for(let o=0;o<i.length;o++){const r=i[o];let a=t[r];switch(typeof a){case"undefined":a=t[r]=Object.create(null);break;case"object":if(a===null){I(`Ignoring ${p} as ${i.slice(0,o+1).join(".")} is null`);return}break;default:I(`Ignoring ${p} as ${i.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}t=a}if(typeof t=="object"&&t!==null)try{t[d]=D}catch{I(`Ignoring ${p} as ${i.join(".")} is ${JSON.stringify(t)}`)}else I(`Ignoring ${p} as ${i.join(".")} is ${JSON.stringify(t)}`)}function f(S,p){const D=p.split(".");v(S,D)}function v(S,p){const D=p.shift();if(p.length===0){delete S[D];return}if(Object.keys(S).indexOf(D)!==-1){const I=S[D];typeof I=="object"&&!Array.isArray(I)&&(v(I,p),Object.keys(I).length===0&&delete S[D])}}function h(S,p,D){function I(t,o){let r=t;for(const a of o){if(typeof r!="object"||r===null)return;r=r[a]}return r}const i=p.split("."),d=I(S,i);return typeof d>"u"?D:d}function g(S,p,D){Object.keys(p).forEach(I=>{I!=="__proto__"&&(I in S?n.isObject(S[I])&&n.isObject(p[I])?g(S[I],p[I],D):D&&(S[I]=p[I]):S[I]=p[I])})}function E(S){return S.replace(/[\[\]]/g,"")}}),define(ce[122],le([0,1,39,3,25,166,6,10,15]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=m,e.validateWhenClauses=o,e.expressionsAreEqualWithConstantSubstitution=r,e.implies=j;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",s.isMacintosh),c.set("isLinux",s.isLinux),c.set("isWindows",s.isWindows),c.set("isWeb",s.isWeb),c.set("isMacNative",s.isMacintosh&&!s.isWeb),c.set("isEdge",s.isEdge),c.set("isFirefox",s.isFirefox),c.set("isChrome",s.isChrome),c.set("isSafari",s.isSafari);function m(Y,W){if(c.get(Y)!==void 0)throw(0,w.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Y,W)}const u=Object.prototype.hasOwnProperty;var f;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const v={regexParsingWithErrorRecovery:!0},h=(0,R.localize)(11600,null),g=(0,R.localize)(11601,null),E=(0,R.localize)(11602,null),S=(0,R.localize)(11603,null),p=(0,R.localize)(11604,null),D=(0,R.localize)(11605,null),I=(0,R.localize)(11606,null),i=(0,R.localize)(11607,null);class d{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(W=v){this._config=W,this._scanner=new M.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(W){if(W===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(W).scan(),this._current=0,this._parsingErrors=[];try{const F=this._expr();if(!this._isAtEnd()){const Z=this._peek(),z=Z.type===M.TokenType.Str?D:void 0;throw this._parsingErrors.push({message:p,offset:Z.offset,lexeme:M.Scanner.getLexeme(Z),additionalInfo:z}),d._parseError}return F}catch(F){if(F!==d._parseError)throw F;return}}_expr(){return this._or()}_or(){const W=[this._and()];for(;this._matchOne(M.TokenType.Or);){const F=this._and();W.push(F)}return W.length===1?W[0]:t.or(...W)}_and(){const W=[this._term()];for(;this._matchOne(M.TokenType.And);){const F=this._term();W.push(F)}return W.length===1?W[0]:t.and(...W)}_term(){if(this._matchOne(M.TokenType.Neg)){const W=this._peek();switch(W.type){case M.TokenType.True:return this._advance(),l.INSTANCE;case M.TokenType.False:return this._advance(),P.INSTANCE;case M.TokenType.LParen:{this._advance();const F=this._expr();return this._consume(M.TokenType.RParen,S),F?.negate()}case M.TokenType.Str:return this._advance(),_.create(W.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",W)}}return this._primary()}_primary(){const W=this._peek();switch(W.type){case M.TokenType.True:return this._advance(),t.true();case M.TokenType.False:return this._advance(),t.false();case M.TokenType.LParen:{this._advance();const F=this._expr();return this._consume(M.TokenType.RParen,S),F}case M.TokenType.Str:{const F=W.lexeme;if(this._advance(),this._matchOne(M.TokenType.RegexOp)){const z=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),z.type!==M.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",z);const ie=z.lexeme,G=ie.lastIndexOf("/"),x=G===ie.length-1?void 0:this._removeFlagsGY(ie.substring(G+1));let te;try{te=new RegExp(ie.substring(1,G),x)}catch{throw this._errExpectedButGot("REGEX",z)}return X.create(F,te)}switch(z.type){case M.TokenType.RegexStr:case M.TokenType.Error:{const ie=[z.lexeme];this._advance();let G=this._peek(),x=0;for(let Re=0;Re<z.lexeme.length;Re++)z.lexeme.charCodeAt(Re)===n.CharCode.OpenParen?x++:z.lexeme.charCodeAt(Re)===n.CharCode.CloseParen&&x--;for(;!this._isAtEnd()&&G.type!==M.TokenType.And&&G.type!==M.TokenType.Or;){switch(G.type){case M.TokenType.LParen:x++;break;case M.TokenType.RParen:x--;break;case M.TokenType.RegexStr:case M.TokenType.QuotedStr:for(let Re=0;Re<G.lexeme.length;Re++)G.lexeme.charCodeAt(Re)===n.CharCode.OpenParen?x++:z.lexeme.charCodeAt(Re)===n.CharCode.CloseParen&&x--}if(x<0)break;ie.push(M.Scanner.getLexeme(G)),this._advance(),G=this._peek()}const te=ie.join(""),de=te.lastIndexOf("/"),me=de===te.length-1?void 0:this._removeFlagsGY(te.substring(de+1));let we;try{we=new RegExp(te.substring(1,de),me)}catch{throw this._errExpectedButGot("REGEX",z)}return t.regex(F,we)}case M.TokenType.QuotedStr:{const ie=z.lexeme;this._advance();let G=null;if(!(0,b.isFalsyOrWhitespace)(ie)){const x=ie.indexOf("/"),te=ie.lastIndexOf("/");if(x!==te&&x>=0){const de=ie.slice(x+1,te),me=ie[te+1]==="i"?"i":"";try{G=new RegExp(de,me)}catch{throw this._errExpectedButGot("REGEX",z)}}}if(G===null)throw this._errExpectedButGot("REGEX",z);return X.create(F,G)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(M.TokenType.Not)){this._consume(M.TokenType.In,E);const z=this._value();return t.notIn(F,z)}switch(this._peek().type){case M.TokenType.Eq:{this._advance();const z=this._value();if(this._previous().type===M.TokenType.QuotedStr)return t.equals(F,z);switch(z){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,z)}}case M.TokenType.NotEq:{this._advance();const z=this._value();if(this._previous().type===M.TokenType.QuotedStr)return t.notEquals(F,z);switch(z){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,z)}}case M.TokenType.Lt:return this._advance(),fe.create(F,this._value());case M.TokenType.LtEq:return this._advance(),$.create(F,this._value());case M.TokenType.Gt:return this._advance(),q.create(F,this._value());case M.TokenType.GtEq:return this._advance(),K.create(F,this._value());case M.TokenType.In:return this._advance(),t.in(F,this._value());default:return t.has(F)}}case M.TokenType.EOF:throw this._parsingErrors.push({message:I,offset:W.offset,lexeme:"",additionalInfo:i}),d._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const W=this._peek();switch(W.type){case M.TokenType.Str:case M.TokenType.QuotedStr:return this._advance(),W.lexeme;case M.TokenType.True:return this._advance(),"true";case M.TokenType.False:return this._advance(),"false";case M.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(W){return W.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(W){return this._check(W)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(W,F){if(this._check(W))return this._advance();throw this._errExpectedButGot(F,this._peek())}_errExpectedButGot(W,F,Z){const z=(0,R.localize)(11608,null,W,M.Scanner.getLexeme(F)),ie=F.offset,G=M.Scanner.getLexeme(F);return this._parsingErrors.push({message:z,offset:ie,lexeme:G,additionalInfo:Z}),d._parseError}_check(W){return this._peek().type===W}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===M.TokenType.EOF}}e.Parser=d;class t{static false(){return l.INSTANCE}static true(){return P.INSTANCE}static has(W){return y.create(W)}static equals(W,F){return k.create(W,F)}static notEquals(W,F){return C.create(W,F)}static regex(W,F){return X.create(W,F)}static in(W,F){return T.create(W,F)}static notIn(W,F){return A.create(W,F)}static not(W){return _.create(W)}static and(...W){return U.create(W,null,!0)}static or(...W){return O.create(W,null,!0)}static greater(W,F){return q.create(W,F)}static greaterEquals(W,F){return K.create(W,F)}static smaller(W,F){return fe.create(W,F)}static smallerEquals(W,F){return $.create(W,F)}static{this._parser=new d({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this._parser.parse(W)}}e.ContextKeyExpr=t;function o(Y){const W=new d({regexParsingWithErrorRecovery:!1});return Y.map(F=>(W.parse(F),W.lexingErrors.length>0?W.lexingErrors.map(Z=>({errorMessage:Z.additionalInfo?(0,R.localize)(11609,null,Z.additionalInfo):(0,R.localize)(11610,null),offset:Z.offset,length:Z.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(Z=>({errorMessage:Z.additionalInfo?`${Z.message}. ${Z.additionalInfo}`:Z.message,offset:Z.offset,length:Z.lexeme.length})):[]))}function r(Y,W){const F=Y?Y.substituteConstants():void 0,Z=W?W.substituteConstants():void 0;return!F&&!Z?!0:!F||!Z?!1:F.equals(Z)}function a(Y,W){return Y.cmp(W)}class l{static{this.INSTANCE=new l}constructor(){this.type=f.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return P.INSTANCE}}e.ContextKeyFalseExpr=l;class P{static{this.INSTANCE=new P}constructor(){this.type=f.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=P;class y{static create(W,F=null){const Z=c.get(W);return typeof Z=="boolean"?Z?P.INSTANCE:l.INSTANCE:new y(W,F)}constructor(W,F){this.key=W,this.negated=F,this.type=f.Defined}cmp(W){return W.type!==this.type?this.type-W.type:Q(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=c.get(this.key);return typeof W=="boolean"?W?P.INSTANCE:l.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class k{static create(W,F,Z=null){if(typeof F=="boolean")return F?y.create(W,Z):_.create(W,Z);const z=c.get(W);return typeof z=="boolean"?F===(z?"true":"false")?P.INSTANCE:l.INSTANCE:new k(W,F,Z)}constructor(W,F,Z){this.key=W,this.value=F,this.negated=Z,this.type=f.Equals}cmp(W){return W.type!==this.type?this.type-W.type:oe(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=c.get(this.key);if(typeof W=="boolean"){const F=W?"true":"false";return this.value===F?P.INSTANCE:l.INSTANCE}return this}evaluate(W){return W.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(W){return W.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=k;class T{static create(W,F){return new T(W,F)}constructor(W,F){this.key=W,this.valueKey=F,this.type=f.In,this.negated=null}cmp(W){return W.type!==this.type?this.type-W.type:oe(this.key,this.valueKey,W.key,W.valueKey)}equals(W){return W.type===this.type?this.key===W.key&&this.valueKey===W.valueKey:!1}substituteConstants(){return this}evaluate(W){const F=W.getValue(this.valueKey),Z=W.getValue(this.key);return Array.isArray(F)?F.includes(Z):typeof Z=="string"&&typeof F=="object"&&F!==null?u.call(F,Z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(W){return W.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=A.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=T;class A{static create(W,F){return new A(W,F)}constructor(W,F){this.key=W,this.valueKey=F,this.type=f.NotIn,this._negated=T.create(W,F)}cmp(W){return W.type!==this.type?this.type-W.type:this._negated.cmp(W._negated)}equals(W){return W.type===this.type?this._negated.equals(W._negated):!1}substituteConstants(){return this}evaluate(W){return!this._negated.evaluate(W)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(W){return W.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=A;class C{static create(W,F,Z=null){if(typeof F=="boolean")return F?_.create(W,Z):y.create(W,Z);const z=c.get(W);return typeof z=="boolean"?F===(z?"true":"false")?l.INSTANCE:P.INSTANCE:new C(W,F,Z)}constructor(W,F,Z){this.key=W,this.value=F,this.negated=Z,this.type=f.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:oe(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=c.get(this.key);if(typeof W=="boolean"){const F=W?"true":"false";return this.value===F?l.INSTANCE:P.INSTANCE}return this}evaluate(W){return W.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(W){return W.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=C;class _{static create(W,F=null){const Z=c.get(W);return typeof Z=="boolean"?Z?l.INSTANCE:P.INSTANCE:new _(W,F)}constructor(W,F){this.key=W,this.negated=F,this.type=f.Not}cmp(W){return W.type!==this.type?this.type-W.type:Q(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=c.get(this.key);return typeof W=="boolean"?W?l.INSTANCE:P.INSTANCE:this}evaluate(W){return!W.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(W){return W.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function H(Y,W){if(typeof Y=="string"){const F=parseFloat(Y);isNaN(F)||(Y=F)}return typeof Y=="string"||typeof Y=="number"?W(Y):l.INSTANCE}class q{static create(W,F,Z=null){return H(F,z=>new q(W,z,Z))}constructor(W,F,Z){this.key=W,this.value=F,this.negated=Z,this.type=f.Greater}cmp(W){return W.type!==this.type?this.type-W.type:oe(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=q;class K{static create(W,F,Z=null){return H(F,z=>new K(W,z,Z))}constructor(W,F,Z){this.key=W,this.value=F,this.negated=Z,this.type=f.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:oe(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=fe.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=K;class fe{static create(W,F,Z=null){return H(F,z=>new fe(W,z,Z))}constructor(W,F,Z){this.key=W,this.value=F,this.negated=Z,this.type=f.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:oe(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=K.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=fe;class ${static create(W,F,Z=null){return H(F,z=>new $(W,z,Z))}constructor(W,F,Z){this.key=W,this.value=F,this.negated=Z,this.type=f.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:oe(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=$;class X{static create(W,F){return new X(W,F)}constructor(W,F){this.key=W,this.regexp=F,this.type=f.Regex,this.negated=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.key<W.key)return-1;if(this.key>W.key)return 1;const F=this.regexp?this.regexp.source:"",Z=W.regexp?W.regexp.source:"";return F<Z?-1:F>Z?1:0}equals(W){if(W.type===this.type){const F=this.regexp?this.regexp.source:"",Z=W.regexp?W.regexp.source:"";return this.key===W.key&&F===Z}return!1}substituteConstants(){return this}evaluate(W){const F=W.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const W=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${W}`}keys(){return[this.key]}map(W){return W.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=B.create(this)),this.negated}}e.ContextKeyRegexExpr=X;class B{static create(W){return new B(W)}constructor(W){this._actual=W,this.type=f.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this._actual.cmp(W._actual)}equals(W){return W.type===this.type?this._actual.equals(W._actual):!1}substituteConstants(){return this}evaluate(W){return!this._actual.evaluate(W)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(W){return new B(this._actual.map(W))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=B;function J(Y){let W=null;for(let F=0,Z=Y.length;F<Z;F++){const z=Y[F].substituteConstants();if(Y[F]!==z&&W===null){W=[];for(let ie=0;ie<F;ie++)W[ie]=Y[ie]}W!==null&&(W[F]=z)}return W===null?Y:W}class U{static create(W,F,Z){return U._normalizeArr(W,F,Z)}constructor(W,F){this.expr=W,this.negated=F,this.type=f.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let F=0,Z=this.expr.length;F<Z;F++){const z=a(this.expr[F],W.expr[F]);if(z!==0)return z}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let F=0,Z=this.expr.length;F<Z;F++)if(!this.expr[F].equals(W.expr[F]))return!1;return!0}return!1}substituteConstants(){const W=J(this.expr);return W===this.expr?this:U.create(W,this.negated,!1)}evaluate(W){for(let F=0,Z=this.expr.length;F<Z;F++)if(!this.expr[F].evaluate(W))return!1;return!0}static _normalizeArr(W,F,Z){const z=[];let ie=!1;for(const G of W)if(G){if(G.type===f.True){ie=!0;continue}if(G.type===f.False)return l.INSTANCE;if(G.type===f.And){z.push(...G.expr);continue}z.push(G)}if(z.length===0&&ie)return P.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(a);for(let G=1;G<z.length;G++)z[G-1].equals(z[G])&&(z.splice(G,1),G--);if(z.length===1)return z[0];for(;z.length>1;){const G=z[z.length-1];if(G.type!==f.Or)break;z.pop();const x=z.pop(),te=z.length===0,de=O.create(G.expr.map(me=>U.create([me,x],null,Z)),null,te);de&&(z.push(de),z.sort(a))}if(z.length===1)return z[0];if(Z){for(let G=0;G<z.length;G++)for(let x=G+1;x<z.length;x++)if(z[G].negate().equals(z[x]))return l.INSTANCE;if(z.length===1)return z[0]}return new U(z,F)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const F of this.expr)W.push(...F.keys());return W}map(W){return new U(this.expr.map(F=>F.map(W)),null)}negate(){if(!this.negated){const W=[];for(const F of this.expr)W.push(F.negate());this.negated=O.create(W,this,!0)}return this.negated}}e.ContextKeyAndExpr=U;class O{static create(W,F,Z){return O._normalizeArr(W,F,Z)}constructor(W,F){this.expr=W,this.negated=F,this.type=f.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let F=0,Z=this.expr.length;F<Z;F++){const z=a(this.expr[F],W.expr[F]);if(z!==0)return z}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let F=0,Z=this.expr.length;F<Z;F++)if(!this.expr[F].equals(W.expr[F]))return!1;return!0}return!1}substituteConstants(){const W=J(this.expr);return W===this.expr?this:O.create(W,this.negated,!1)}evaluate(W){for(let F=0,Z=this.expr.length;F<Z;F++)if(this.expr[F].evaluate(W))return!0;return!1}static _normalizeArr(W,F,Z){let z=[],ie=!1;if(W){for(let G=0,x=W.length;G<x;G++){const te=W[G];if(te){if(te.type===f.False){ie=!0;continue}if(te.type===f.True)return P.INSTANCE;if(te.type===f.Or){z=z.concat(te.expr);continue}z.push(te)}}if(z.length===0&&ie)return l.INSTANCE;z.sort(a)}if(z.length!==0){if(z.length===1)return z[0];for(let G=1;G<z.length;G++)z[G-1].equals(z[G])&&(z.splice(G,1),G--);if(z.length===1)return z[0];if(Z){for(let G=0;G<z.length;G++)for(let x=G+1;x<z.length;x++)if(z[G].negate().equals(z[x]))return P.INSTANCE;if(z.length===1)return z[0]}return new O(z,F)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const F of this.expr)W.push(...F.keys());return W}map(W){return new O(this.expr.map(F=>F.map(W)),null)}negate(){if(!this.negated){const W=[];for(const F of this.expr)W.push(F.negate());for(;W.length>1;){const F=W.shift(),Z=W.shift(),z=[];for(const ie of se(F))for(const G of se(Z))z.push(U.create([ie,G],null,!1));W.unshift(O.create(z,null,!1))}this.negated=O.create(W,this,!0)}return this.negated}}e.ContextKeyOrExpr=O;class N extends y{static{this._info=[]}static all(){return N._info.values()}constructor(W,F,Z){super(W,null),this._defaultValue=F,typeof Z=="object"?N._info.push({...Z,key:W}):Z!==!0&&N._info.push({key:W,description:Z,type:F!=null?typeof F:void 0})}bindTo(W){return W.createKey(this.key,this._defaultValue)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return k.create(this.key,W)}notEqualsTo(W){return C.create(this.key,W)}}e.RawContextKey=N,e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function Q(Y,W){return Y<W?-1:Y>W?1:0}function oe(Y,W,F,Z){return Y<F?-1:Y>F?1:W<Z?-1:W>Z?1:0}function j(Y,W){if(Y.type===f.False||W.type===f.True)return!0;if(Y.type===f.Or)return W.type===f.Or?ue(Y.expr,W.expr):!1;if(W.type===f.Or){for(const F of W.expr)if(j(Y,F))return!0;return!1}if(Y.type===f.And){if(W.type===f.And)return ue(W.expr,Y.expr);for(const F of Y.expr)if(j(F,W))return!0;return!1}return Y.equals(W)}function ue(Y,W){let F=0,Z=0;for(;F<Y.length&&Z<W.length;){const z=Y[F].cmp(W[Z]);if(z<0)return!1;z===0&&F++,Z++}return F===Y.length}function se(Y){return Y.type===f.Or?Y.expr:[Y]}}),define(ce[96],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=s,e.ID="diagnosticsService",e.IDiagnosticsService=(0,n.createDecorator)(e.ID);function s(M){return!!M.hostName&&!!M.errorMessage}class b{async getPerformanceInfo(L,R){return{}}async getSystemInfo(L,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,R){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.NullDiagnosticsService=b});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[123],le([0,1,18,81,10,6,47,3,37]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=v,e.massageMessageBoxOptions=h,s=je(s),e.IDialogService=(0,M.createDecorator)("dialogService");var c;(function(g){g[g.Confirmation=1]="Confirmation",g[g.Prompt=2]="Prompt",g[g.Input=3]="Input"})(c||(c={}));class m{getConfirmationButtons(E){return this.getButtons(E,c.Confirmation)}getPromptButtons(E){return this.getButtons(E,c.Prompt)}getInputButtons(E){return this.getButtons(E,c.Input)}getButtons(E,S){const p=[];switch(S){case c.Confirmation:{const D=E;D.primaryButton?p.push(D.primaryButton):p.push((0,b.localize)(11577,null)),D.cancelButton?p.push(D.cancelButton):p.push((0,b.localize)(11578,null));break}case c.Prompt:{const D=E;Array.isArray(D.buttons)&&D.buttons.length>0&&p.push(...D.buttons.map(I=>I.label)),D.cancelButton&&(D.cancelButton===!0?p.push((0,b.localize)(11579,null)):typeof D.cancelButton=="string"?p.push(D.cancelButton):D.cancelButton.label?p.push(D.cancelButton.label):p.push((0,b.localize)(11580,null))),p.length===0&&p.push((0,b.localize)(11581,null));break}case c.Input:{const D=E;D.primaryButton?p.push(D.primaryButton):p.push((0,b.localize)(11582,null)),D.cancelButton?p.push(D.cancelButton):p.push((0,b.localize)(11583,null));break}}return p}getDialogType(E){if(typeof E=="string")return E;if(typeof E=="number")return E===s.default.Info?"info":E===s.default.Error?"error":E===s.default.Warning?"warning":"none"}getPromptResult(E,S,p){const D=[...E.buttons??[]];E.cancelButton&&typeof E.cancelButton!="string"&&typeof E.cancelButton!="boolean"&&D.push(E.cancelButton);let I=D[S]?.run({checkboxChecked:p});return I instanceof Promise||(I=Promise.resolve(I)),{result:I,checkboxChecked:p}}}e.AbstractDialogHandler=m,e.IFileDialogService=(0,M.createDecorator)("fileDialogService");var u;(function(g){g[g.SAVE=0]="SAVE",g[g.DONT_SAVE=1]="DONT_SAVE",g[g.CANCEL=2]="CANCEL"})(u||(e.ConfirmResult=u={}));const f=10;function v(g){const E=[];return E.push(...g.slice(0,f).map(S=>typeof S=="string"?S:(0,n.basename)(S))),g.length>f&&(g.length-f===1?E.push((0,b.localize)(11584,null)):E.push((0,b.localize)(11585,null,g.length-f))),E.push(""),E.join(`
`)}function h(g,E){const S=(0,w.deepClone)(g);let p=(S.buttons??[]).map(d=>(0,L.mnemonicButtonLabel)(d)),D=(g.buttons||[]).map((d,t)=>t),I=0,i=S.cancelId??p.length-1;if(p.length>1){const d=typeof i=="number"?p[i]:void 0;if(R.isLinux||R.isMacintosh){if(typeof d=="string"&&p.length>1&&i!==1){p.splice(i,1),p.splice(1,0,d);const t=D[i];D.splice(i,1),D.splice(1,0,t),i=1}R.isLinux&&p.length>1&&(p=p.reverse(),D=D.reverse(),I=p.length-1,typeof d=="string"&&(i=I-1))}else if(R.isWindows&&typeof d=="string"&&p.length>1&&i!==p.length-1){p.splice(i,1),p.push(d);const t=D[i];D.splice(i,1),D.push(t),i=p.length-1}}return S.buttons=p,S.defaultId=I,S.cancelId=i,S.noLink=!0,S.title=S.title||E.nameLong,{options:S,buttonIndeces:D}}}),define(ce[97],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.isKwallet=M,e.isGnome=L,e.IEncryptionService=(0,n.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,n.createDecorator)("encryptionMainService");var s;(function(R){R.kwallet="kwallet",R.kwallet5="kwallet5",R.gnomeLibsecret="gnome-libsecret",R.basic="basic"})(s||(e.PasswordStoreCLIOption=s={}));var b;(function(R){R.unknown="unknown",R.basicText="basic_text",R.gnomeAny="gnome_any",R.gnomeLibsecret="gnome_libsecret",R.gnomeKeyring="gnome_keyring",R.kwallet="kwallet",R.kwallet5="kwallet5",R.kwallet6="kwallet6",R.dplib="dpapi",R.keychainAccess="keychain_access"})(b||(e.KnownStorageProvider=b={}));function M(R){return R===b.kwallet||R===b.kwallet5||R===b.kwallet6}function L(R){return R===b.gnomeAny||R===b.gnomeLibsecret||R===b.gnomeKeyring}}),define(ce[38],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(ce[175],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,n.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ce[176],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,n.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ce[177],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,n.createDecorator)("externalTerminal")}),define(ce[178],le([0,1,48,54,12,9,3,79,23,94,10,176]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0,n=De(n),M=De(M),L=De(L),w=De(w),c=De(c),m=De(m);const f=m.localize(11427,null);class v{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends v{static{this.CMD="cmd.exe"}openTerminal(i,d){return this.spawnTerminal(n,i,c.getWindowsShell(),d)}spawnTerminal(i,d,t,o){const r=d.windowsExec||h.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const a=M.basename(r,".exe").toLowerCase();if(a==="cmder")return i.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push(r),l.push(r),a==="wt"&&l.push("-d ."),new Promise((P,y)=>{const k=S(process),T=i.spawn(t,l,{cwd:o,env:k,detached:!0});T.on("error",y),T.on("exit",()=>P())})}async runInTerminal(i,d,t,o,r){const a="windowsExec"in r&&r.windowsExec?r.windowsExec:h.getDefaultTerminalWindows(),l=await h.getWtExePath();return new Promise((P,y)=>{const k=`"${d} - ${f}"`,T=`"${t.join('" "')}" & pause`,A=Object.assign({},S(process),o);Object.keys(A).filter(K=>A[K]===null).forEach(K=>delete A[K]);const C={cwd:d,env:A,windowsVerbatimArguments:!0};let _,H;M.basename(a,".exe")==="wt"?(_=a,H=["-d",".",h.CMD,"/c",T]):l?(_=l,H=["-d",".",a,"/c",T]):(_=h.CMD,H=["/c","start",k,"/wait",a,"/c",`"${T}"`]),n.spawn(_,H,C).on("error",K=>{y(p(K))}),P(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const i=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${i?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const i=await c.win32.findExecutable("wt");return await w.Promises.exists(i)?i:void 0}catch{return}}}e.WindowsExternalTerminalService=h,Ie([s.memoize],h,"getWtExePath",null);class g extends v{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(i,d){return this.spawnTerminal(n,i,d)}runInTerminal(i,d,t,o,r){const a=r.osxExec||u.DEFAULT_TERMINAL_OSX;return new Promise((l,P)=>{if(a===u.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const y=a===u.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",T=[b.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",i||f,"-w",d];for(const _ of t)T.push("-a"),T.push(_);if(o){const _=Object.assign({},S(process),o);for(const H in _){const q=_[H];q===null?(T.push("-u"),T.push(H)):(T.push("-e"),T.push(`${H}=${q}`))}}let A="";const C=n.spawn(g.OSASCRIPT,T);C.on("error",_=>{P(p(_))}),C.stderr.on("data",_=>{A+=_.toString()}),C.on("exit",_=>{if(_===0)l(void 0);else if(A){const H=A.split(`
`,1);P(new Error(H[0]))}else P(new Error(m.localize(11428,null,y,_)))})}else P(new Error(m.localize(11429,null,a)))})}spawnTerminal(i,d,t){const o=d.osxExec||u.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{const l=["-a",o];t&&l.push(t);const P=S(process),y=i.spawn("/usr/bin/open",l,{cwd:t,env:P});y.on("error",a),y.on("exit",()=>r())})}}e.MacExternalTerminalService=g;class E extends v{static{this.WAIT_MESSAGE=m.localize(11430,null)}openTerminal(i,d){return this.spawnTerminal(n,i,d)}runInTerminal(i,d,t,o,r){const a=r.linuxExec?Promise.resolve(r.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((l,P)=>{const y=[];a.then(k=>{k.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const T=`${D(t)}; echo; read -p "${E.WAIT_MESSAGE}" -n1;`;y.push(`''${T}''`);const A=Object.assign({},S(process),o);Object.keys(A).filter(q=>A[q]===null).forEach(q=>delete A[q]);const C={cwd:d,env:A};let _="";const H=n.spawn(k,y,C);H.on("error",q=>{P(p(q))}),H.stderr.on("data",q=>{_+=q.toString()}),H.on("exit",q=>{if(q===0)l(void 0);else if(_){const K=_.split(`
`,1);P(new Error(K[0]))}else P(new Error(m.localize(11431,null,k,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!E._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)E._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const i=await w.Promises.exists("/etc/debian_version");E._DEFAULT_TERMINAL_LINUX_READY=new Promise(d=>{i?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm")})}return E._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(i,d,t){const o=d.linuxExec?Promise.resolve(d.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{o.then(l=>{const P=S(process),y=i.spawn(l,[],{cwd:t,env:P});y.on("error",a),y.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=E;function S(I){const i={...I.env};return(0,R.sanitizeProcessEnvironment)(i),i}function p(I){return"errno"in I&&I.errno==="ENOENT"&&"path"in I&&typeof I.path=="string"?new Error(m.localize(11432,null,I.path)):I}function D(I){let i="";for(const d of I)d.indexOf(" ")>=0?i+='"'+d+'"':i+=d,i+=" ";return i}}),define(ce[14],le([0,1,60,9,25,11,7,10,6,3,12,65]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=f,e.isFileSystemWatcher=E,e.hasReadWriteCapability=p,e.hasFileFolderCopyCapability=D,e.hasFileCloneCapability=I,e.hasOpenReadWriteCloseCapability=i,e.hasFileReadStreamCapability=d,e.hasFileAtomicReadCapability=t,e.hasFileAtomicWriteCapability=o,e.hasFileAtomicDeleteCapability=r,e.hasReadonlyCapability=a,e.createFileSystemProviderError=y,e.ensureFileSystemProviderError=k,e.markAsFileSystemProviderError=T,e.toFileSystemProviderErrorCode=A,e.toFileOperationResult=C,e.isParent=fe,e.etag=O,e.whenProviderRegistered=N,e.getLargeFileConfirmationLimit=oe,e.IFileService=(0,w.createDecorator)("fileService");function f(j){return j.create===!0}var v;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var h;(function(j){j[j.Readonly=1]="Readonly",j[j.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var g;(function(j){j[j.UPDATED=2]="UPDATED",j[j.ADDED=4]="ADDED",j[j.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function E(j){const ue=j;return!!ue&&typeof ue.onDidChange=="function"}var S;(function(j){j[j.None=0]="None",j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileAtomicWrite=32768]="FileAtomicWrite",j[j.FileAtomicDelete=65536]="FileAtomicDelete",j[j.FileClone=131072]="FileClone"})(S||(e.FileSystemProviderCapabilities=S={}));function p(j){return!!(j.capabilities&S.FileReadWrite)}function D(j){return!!(j.capabilities&S.FileFolderCopy)}function I(j){return!!(j.capabilities&S.FileClone)}function i(j){return!!(j.capabilities&S.FileOpenReadWriteClose)}function d(j){return!!(j.capabilities&S.FileReadStream)}function t(j){return p(j)?!!(j.capabilities&S.FileAtomicRead):!1}function o(j){return p(j)?!!(j.capabilities&S.FileAtomicWrite):!1}function r(j){return!!(j.capabilities&S.FileAtomicDelete)}function a(j){return!!(j.capabilities&S.Readonly)}var l;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsStorageQuota="EntryExceedsStorageQuota",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class P extends Error{static create(ue,se){const Y=new P(ue.toString(),se);return T(Y,se),Y}constructor(ue,se){super(ue),this.code=se}}e.FileSystemProviderError=P;function y(j,ue){return P.create(j,ue)}function k(j){return j||y((0,R.localize)(11386,null),l.Unknown)}function T(j,ue){return j.name=ue?`${ue} (FileSystemError)`:"FileSystemError",j}function A(j){if(!j)return l.Unknown;if(j instanceof P)return j.code;const ue=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!ue)return l.Unknown;switch(ue[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function C(j){if(j instanceof $)return j.fileOperationResult;switch(A(j)){case l.FileNotFound:return J.FILE_NOT_FOUND;case l.FileIsADirectory:return J.FILE_IS_DIRECTORY;case l.FileNotADirectory:return J.FILE_NOT_DIRECTORY;case l.FileWriteLocked:return J.FILE_WRITE_LOCKED;case l.NoPermissions:return J.FILE_PERMISSION_DENIED;case l.FileExists:return J.FILE_MOVE_CONFLICT;case l.FileTooLarge:return J.FILE_TOO_LARGE;default:return J.FILE_OTHER_ERROR}}var _;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(_||(e.FileOperation=_={}));class H{constructor(ue,se,Y){this.resource=ue,this.operation=se,this.target=Y}isOperation(ue){return this.operation===ue}}e.FileOperationEvent=H;var q;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class K{static{this.MIXED_CORRELATION=null}constructor(ue,se){this.ignorePathCasing=se,this.correlationId=void 0,this.added=new u.Lazy(()=>{const Y=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Y.fill(this.rawAdded.map(W=>[W,!0])),Y}),this.updated=new u.Lazy(()=>{const Y=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Y.fill(this.rawUpdated.map(W=>[W,!0])),Y}),this.deleted=new u.Lazy(()=>{const Y=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Y.fill(this.rawDeleted.map(W=>[W,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of ue){switch(Y.type){case q.ADDED:this.rawAdded.push(Y.resource);break;case q.UPDATED:this.rawUpdated.push(Y.resource);break;case q.DELETED:this.rawDeleted.push(Y.resource);break}this.correlationId!==K.MIXED_CORRELATION&&(typeof Y.cId=="number"?this.correlationId===void 0?this.correlationId=Y.cId:this.correlationId!==Y.cId&&(this.correlationId=K.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=K.MIXED_CORRELATION))}}contains(ue,...se){return this.doContains(ue,{includeChildren:!1},...se)}affects(ue,...se){return this.doContains(ue,{includeChildren:!0},...se)}doContains(ue,se,...Y){if(!ue)return!1;const W=Y.length>0;return!!((!W||Y.includes(q.ADDED))&&(this.added.value.get(ue)||se.includeChildren&&this.added.value.findSuperstr(ue))||(!W||Y.includes(q.UPDATED))&&(this.updated.value.get(ue)||se.includeChildren&&this.updated.value.findSuperstr(ue))||(!W||Y.includes(q.DELETED))&&(this.deleted.value.findSubstr(ue)||se.includeChildren&&this.deleted.value.findSuperstr(ue)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ue){return this.correlationId===ue}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=K;function fe(j,ue,se){return!j||!ue||j===ue||ue.length>j.length?!1:(ue.charAt(ue.length-1)!==s.sep&&(ue+=s.sep),se?(0,b.startsWithIgnoreCase)(j,ue):j.indexOf(ue)===0)}class $ extends Error{constructor(ue,se,Y){super(ue),this.fileOperationResult=se,this.options=Y}}e.FileOperationError=$;class X extends ${constructor(ue,se,Y,W){super(ue,se,W),this.fileOperationResult=se,this.size=Y}}e.TooLargeFileOperationError=X;class B extends ${constructor(ue,se,Y){super(ue,J.FILE_NOT_MODIFIED_SINCE,Y),this.stat=se}}e.NotModifiedSinceFileOperationError=B;var J;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var U;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(U||(e.FileKind=U={})),e.ETAG_DISABLED="";function O(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}async function N(j,ue){if(!ue.hasProvider(L.URI.from({scheme:j.scheme})))return new Promise(se=>{const Y=ue.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===j.scheme&&W.added&&(Y.dispose(),se())})})}class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(ue){return(0,M.isNumber)(ue)||(ue=0),ue<Q.KB?(0,R.localize)(11387,null,ue.toFixed(0)):ue<Q.MB?(0,R.localize)(11388,null,(ue/Q.KB).toFixed(2)):ue<Q.GB?(0,R.localize)(11389,null,(ue/Q.MB).toFixed(2)):ue<Q.TB?(0,R.localize)(11390,null,(ue/Q.GB).toFixed(2)):(0,R.localize)(11391,null,(ue/Q.TB).toFixed(2))}}e.ByteSize=Q;function oe(j){const ue=typeof j=="string"||j?.scheme===m.Schemas.vscodeRemote;return typeof j!="string"&&j?.scheme===m.Schemas.file?1024*Q.MB:ue?10*Q.MB:c.isWeb?50*Q.MB:1024*Q.MB}}),define(ce[124],le([0,1,17,15,10,14]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=L;async function L(m,u,f,v,h,g){let E;try{await R(m,u,f,v,h,g)}catch(S){E=S}finally{E&&h.errorTransformer&&(E=h.errorTransformer(E)),typeof E<"u"&&f.error(E),f.end()}}async function R(m,u,f,v,h,g){w(g);const E=await m.open(u,{create:!1});try{w(g);let S=0,p=0,D=h&&typeof h.length=="number"?h.length:void 0,I=n.VSBuffer.alloc(Math.min(h.bufferSize,typeof D=="number"?D:h.bufferSize)),i=h&&typeof h.position=="number"?h.position:0,d=0;do p=await m.read(E,i,I.buffer,d,I.byteLength-d),i+=p,d+=p,S+=p,typeof D=="number"&&(D-=p),d===I.byteLength&&(await f.write(v(I)),I=n.VSBuffer.alloc(Math.min(h.bufferSize,typeof D=="number"?D:h.bufferSize)),d=0);while(p>0&&(typeof D!="number"||D>0)&&w(g)&&c(S,h));if(d>0){let t=d;typeof D=="number"&&(t=Math.min(d,D)),f.write(v(I.slice(0,t)))}}catch(S){throw(0,M.ensureFileSystemProviderError)(S)}finally{await m.close(E)}}function w(m){if(m.isCancellationRequested)throw(0,s.canceled)();return!0}function c(m,u){if(typeof u?.limits?.size=="number"&&m>u.limits.size)throw(0,M.createFileSystemProviderError)((0,b.localize)(11385,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[61],le([0,1,111,2,9,3,7,14]),function(V,e,n,s,b,M,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=w,e.isRecursiveWatchRequest=c,e.reviveFileChanges=v,e.coalesceEvents=h,e.normalizeWatcherPattern=g,e.parseWatcherPatterns=E,e.isFiltered=p,e.requestFilterToString=D;function w(I){return typeof I.correlationId=="number"}function c(I){return I.recursive===!0}class m extends s.Disposable{static{this.MAX_RESTARTS=5}constructor(i,d,t,o){super(),this.onFileChanges=i,this.onLogMessage=d,this.verboseLogging=t,this.options=o,this.watcherDisposables=this._register(new s.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const i=new s.DisposableStore;this.watcherDisposables.value=i,this.watcher=this.createWatcher(i),this.watcher.setVerboseLogging(this.verboseLogging),i.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),i.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),i.add(this.watcher.onDidError(d=>this.onError(d.error,d.request)))}onError(i,d){this.canRestart(i,d)?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${i}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${i}`):this.error(i)}canRestart(i,d){return!(!this.options.restartOnError||d||i.indexOf("No space left on device")!==-1||i.indexOf("EMFILE")!==-1)}restart(i){this.restartCounter++,this.init(),this.watch(i)}async watch(i){this.requests=i,await this.watcher?.watch(i)}async setVerboseLogging(i){this.verboseLogging=i,await this.watcher?.setVerboseLogging(i)}error(i){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${i}`})}trace(i){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${i}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m;class u extends m{constructor(i,d,t){super(i,d,t,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=u;class f extends m{constructor(i,d,t){super(i,d,t,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=f;function v(I){return I.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}function h(I){const i=new S;for(const d of I)i.processEvent(d);return i.coalesce()}function g(I,i){return typeof i=="string"&&!i.startsWith(n.GLOBSTAR)&&!(0,b.isAbsolute)(i)?{base:I,pattern:i}:i}function E(I,i){const d=[];for(const t of i)d.push((0,n.parse)(g(I,t)));return d}class S{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(i){return M.isLinux?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const d=this.mapPathToChange.get(this.toKey(i));let t=!1;if(d){const o=d.type,r=i.type;d.resource.fsPath!==i.resource.fsPath&&(i.type===R.FileChangeType.DELETED||i.type===R.FileChangeType.ADDED)?t=!0:o===R.FileChangeType.ADDED&&r===R.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(i)),this.coalesced.delete(d)):o===R.FileChangeType.DELETED&&r===R.FileChangeType.ADDED?d.type=R.FileChangeType.UPDATED:o===R.FileChangeType.ADDED&&r===R.FileChangeType.UPDATED||(d.type=r)}else t=!0;t&&(this.coalesced.add(i),this.mapPathToChange.set(this.toKey(i),i))}coalesce(){const i=[],d=[];return Array.from(this.coalesced).filter(t=>t.type!==R.FileChangeType.DELETED?(i.push(t),!1):!0).sort((t,o)=>t.resource.fsPath.length-o.resource.fsPath.length).filter(t=>d.some(o=>(0,R.isParent)(t.resource.fsPath,o,!M.isLinux))?!1:(d.push(t.resource.fsPath),!0)).concat(i)}}function p(I,i){if(typeof i=="number")switch(I.type){case R.FileChangeType.ADDED:return(i&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(i&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(i&R.FileChangeFilter.UPDATED)===0}return!1}function D(I){if(typeof I=="number"){const i=[];return I&R.FileChangeFilter.ADDED&&i.push("Added"),I&R.FileChangeFilter.DELETED&&i.push("Deleted"),I&R.FileChangeFilter.UPDATED&&i.push("Updated"),i.length===0?"<all>":`[${i.join(", ")}]`}return"<none>"}}),define(ce[179],le([0,1,17,55,15,4,2,67,33,14,61]),function(V,e,n,s,b,M,L,R,w,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class u extends L.Disposable{constructor(v,h){super(),this.channel=v,this.extraCapabilities=h,this.onDidChangeCapabilities=M.Event.None,this._onDidChange=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=c.FileSystemProviderCapabilities.PathCaseSensitive),this.extraCapabilities.trash&&(this._capabilities|=c.FileSystemProviderCapabilities.Trash)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,h){const{buffer:g}=await this.channel.call("readFile",[v,h]);return g}readFileStream(v,h,g){const E=(0,R.newWriteableStream)(p=>n.VSBuffer.concat(p.map(D=>n.VSBuffer.wrap(D))).buffer),S=new L.DisposableStore;return S.add(this.channel.listen("readFileStream",[v,h])(p=>{if(p instanceof n.VSBuffer)E.write(p.buffer);else{if(p==="end")E.end();else{let D;if(p instanceof Error)D=p;else{const I=p;D=(0,c.createFileSystemProviderError)(I.message??(0,s.toErrorMessage)(I),I.code??c.FileSystemProviderErrorCode.Unknown)}E.error(D),E.end()}S.dispose()}})),S.add(g.onCancellationRequested(()=>{E.error((0,b.canceled)()),E.end(),S.dispose()})),E}writeFile(v,h,g){return this.channel.call("writeFile",[v,n.VSBuffer.wrap(h),g])}open(v,h){return this.channel.call("open",[v,h])}close(v){return this.channel.call("close",[v])}async read(v,h,g,E,S){const[p,D]=await this.channel.call("read",[v,h,S]);return g.set(p.buffer.slice(0,D),E),D}write(v,h,g,E,S){return this.channel.call("write",[v,h,n.VSBuffer.wrap(g),E,S])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,h){return this.channel.call("delete",[v,h])}rename(v,h,g){return this.channel.call("rename",[v,h,g])}copy(v,h,g){return this.channel.call("copy",[v,h,g])}cloneFile(v,h){return this.channel.call("cloneFile",[v,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const h=v;this._onDidChange.fire((0,m.reviveFileChanges)(h))}else{const h=v;this._onDidWatchError.fire(h)}}))}watch(v,h){const g=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,g,v,h]),(0,L.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,g]))}}e.DiskFileSystemProviderClient=u}),define(ce[180],le([0,1,26,2,61,4,14,7,8]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class c extends s.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new M.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new M.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new s.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new w.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new w.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(u=>this.handleDidWatchFail(u)))}handleDidWatchFail(u){this.isCorrelated(u)&&this.suspendWatchRequest(u)}isCorrelated(u){return(0,b.isWatchRequestWithCorrelation)(u)}async watch(u){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new w.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const f of u)this.isCorrelated(f)?this.allCorrelatedWatchRequests.set(f.correlationId,f):this.allNonCorrelatedWatchRequests.add(f);for(const[f]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(f)||(this.suspendedWatchRequests.deleteAndDispose(f),this.suspendedWatchRequestsWithPolling.delete(f));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(u){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(f=>!this.suspendedWatchRequests.has(f.correlationId))]),u?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(u.correlationId)?"polling":this.suspendedWatchRequests.has(u.correlationId)}async suspendWatchRequest(u){if(this.suspendedWatchRequests.has(u.correlationId))return;const f=new s.DisposableStore;this.suspendedWatchRequests.set(u.correlationId,f),await this.joinWatch.p,!f.isDisposed&&(this.monitorSuspendedWatchRequest(u,f),this.updateWatchers(!0))}resumeWatchRequest(u){this.suspendedWatchRequests.deleteAndDispose(u.correlationId),this.suspendedWatchRequestsWithPolling.delete(u.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(u,f){this.doMonitorWithExistingWatcher(u,f)?(this.trace(`reusing an existing recursive watcher to monitor ${u.path}`),this.suspendedWatchRequestsWithPolling.delete(u.correlationId)):(this.doMonitorWithNodeJS(u,f),this.suspendedWatchRequestsWithPolling.add(u.correlationId))}doMonitorWithExistingWatcher(u,f){const v=this.recursiveWatcher?.subscribe(u.path,(h,g)=>{f.isDisposed||(h?this.monitorSuspendedWatchRequest(u,f):g?.type===L.FileChangeType.ADDED&&this.onMonitoredPathAdded(u))});return v?(f.add(v),!0):!1}doMonitorWithNodeJS(u,f){let v=!1;const h=(g,E)=>{if(f.isDisposed)return;const S=this.isPathNotFound(g),p=this.isPathNotFound(E),D=v;v=S,!S&&(p||D)&&this.onMonitoredPathAdded(u)};this.trace(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,n.watchFile)(u.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},h)}catch(g){this.warn(`fs.watchFile() failed with error ${g} on path ${u.path} (correlationId: ${u.correlationId})`)}f.add((0,s.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,n.unwatchFile)(u.path,h)}catch(g){this.warn(`fs.unwatchFile() failed with error ${g} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}onMonitoredPathAdded(u){this.trace(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const f={resource:R.URI.file(u.path),type:L.FileChangeType.ADDED,cId:u.correlationId};this._onDidChangeFile.fire([f]),this.traceEvent(f,u),this.resumeWatchRequest(u)}isPathNotFound(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(u,f){if(this.verboseLogging){const v=` >> normalized ${u.type===L.FileChangeType.ADDED?"[ADDED]":u.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.traceWithCorrelation(v,f)}}traceWithCorrelation(u,f){this.verboseLogging&&this.trace(`${u}${typeof f.correlationId=="number"?` <${f.correlationId}> `:""}`)}requestToString(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,b.requestFilterToString)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.verboseLogging=u}}e.BaseWatcher=c}),define(ce[181],le([0,1,26,8,22,32,2,78,9,3,18,7,112,23,14,61]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=S;class E extends L.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(D,I,i,d,t,o){super(),this.request=D,this.recursiveWatcher=I,this.onDidFilesChange=i,this.onDidWatchFail=d,this.onLogMessage=t,this.verboseLogging=o,this.throttledFileChangesEmitter=this._register(new s.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.onDidFilesChange(r))),this.fileChangesAggregator=this._register(new s.RunOnceWorker(r=>this.handleFileChanges(r),E.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,g.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,g.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,g.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new b.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const D=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const I=await n.promises.stat(D);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(D,I.isDirectory()))}catch(D){D.code!=="ENOENT"?this.error(D):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${D})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(D){let I=D.path;try{I=await v.Promises.realpath(D.path),D.path===I&&(I=await(0,f.realcase)(D.path,this.cts.token)??D.path),D.path!==I&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${D.path}, real: ${I})`)}catch{}return I}async doWatch(D,I){const i=new L.DisposableStore;return this.doWatchWithExistingWatcher(D,I,i)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(D,I,i)),i}doWatchWithExistingWatcher(D,I,i){if(I)return!1;const d=u.URI.file(this.request.path),t=this.recursiveWatcher?.subscribe(this.request.path,async(o,r)=>{if(!i.isDisposed)if(o){const a=await this.doWatch(D,I);i.isDisposed?a.dispose():i.add(a)}else r&&(typeof r.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:d,type:r.type,cId:this.request.correlationId},!0)});return t?(i.add(t),!0):!1}async doWatchWithNodeJS(D,I,i){if(c.isMacintosh&&(0,M.isEqualOrParent)(D,"/Volumes/",!0)){this.error(`Refusing to watch ${D} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const d=new b.CancellationTokenSource(this.cts.token);i.add((0,L.toDisposable)(()=>d.dispose(!0)));const t=new L.DisposableStore;i.add(t);try{const o=u.URI.file(this.request.path),r=(0,w.basename)(D),a=(0,n.watch)(D);t.add((0,L.toDisposable)(()=>{a.removeAllListeners(),a.close()})),this.trace(`Started watching: '${D}'`);const l=new Set;if(I)try{for(const y of await v.Promises.readdir(D))l.add(y)}catch(y){this.error(y)}if(d.token.isCancellationRequested)return;const P=new Map;t.add((0,L.toDisposable)(()=>{for(const[,y]of P)y.dispose();P.clear()})),a.on("error",(y,k)=>{d.token.isCancellationRequested||(this.error(`Failed to watch ${D} for changes using fs.watch() (${y}, ${k})`),this.notifyWatchFailed())}),a.on("change",(y,k)=>{if(d.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${y}"] ${k}`);let T="";if(k&&(T=k.toString(),c.isMacintosh&&(T=(0,R.normalizeNFC)(T))),!(!T||y!=="change"&&y!=="rename"))if(I)if(y==="rename"){P.get(T)?.dispose();const A=setTimeout(async()=>{if(P.delete(T),T===r&&!await v.Promises.exists(D)){this.onWatchedPathDeleted(o);return}if(d.token.isCancellationRequested)return;const C=await this.existsChildStrictCase((0,w.join)(D,T));if(d.token.isCancellationRequested)return;let _;C?l.has(T)?_=h.FileChangeType.UPDATED:(_=h.FileChangeType.ADDED,l.add(T)):(l.delete(T),_=h.FileChangeType.DELETED),this.onFileChange({resource:(0,m.joinPath)(o,T),type:_,cId:this.request.correlationId})},E.FILE_DELETE_HANDLER_DELAY);P.set(T,(0,L.toDisposable)(()=>clearTimeout(A)))}else{let A;l.has(T)?A=h.FileChangeType.UPDATED:(A=h.FileChangeType.ADDED,l.add(T)),this.onFileChange({resource:(0,m.joinPath)(o,T),type:A,cId:this.request.correlationId})}else if(y==="rename"||T!==r){const A=setTimeout(async()=>{const C=await v.Promises.exists(D);d.token.isCancellationRequested||(C?(this.onFileChange({resource:o,type:h.FileChangeType.UPDATED,cId:this.request.correlationId},!0),t.add(await this.doWatch(D,!1))):this.onWatchedPathDeleted(o))},E.FILE_DELETE_HANDLER_DELAY);t.clear(),t.add((0,L.toDisposable)(()=>clearTimeout(A)))}else this.onFileChange({resource:o,type:h.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(o){d.token.isCancellationRequested||this.error(`Failed to watch ${D} for changes using fs.watch() (${o.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(D){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:D,type:h.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(D,I=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${D.type===h.FileChangeType.ADDED?"[ADDED]":D.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${D.resource.fsPath}`),!I&&this.excludes.some(i=>i(D.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${D.resource.fsPath}`):!I&&this.includes&&this.includes.length>0&&!this.includes.some(i=>i(D.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${D.resource.fsPath}`):this.fileChangesAggregator.work(D))}handleFileChanges(D){const I=(0,g.coalesceEvents)(D),i=[];for(const t of I){if((0,g.isFiltered)(t,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${t.resource.fsPath}`);continue}i.push(t)}if(i.length===0)return;if(this.verboseLogging)for(const t of i)this.traceWithCorrelation(` >> normalized ${t.type===h.FileChangeType.ADDED?"[ADDED]":t.type===h.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.throttledFileChangesEmitter.work(i)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(D){if(c.isLinux)return v.Promises.exists(D);try{const I=(0,w.basename)(D);return(await v.Promises.readdir((0,w.dirname)(D))).some(d=>d===I)}catch(I){return this.trace(I),!1}}setVerboseLogging(D){this.verboseLogging=D}error(D){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${D}`})}warn(D){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${D}`})}trace(D){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${D}`})}traceWithCorrelation(D){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${D}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=E;async function S(p,D,I,i,d=512){const t=await v.Promises.open(p,"r"),o=Buffer.allocUnsafe(d),r=new b.CancellationTokenSource(i);let a,l=!1;const P={path:p,excludes:[],recursive:!1},y=new E(P,void 0,k=>{(async()=>{for(const{type:T}of k)if(T===h.FileChangeType.UPDATED){if(l)return;l=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:A}=await v.Promises.read(t,o,0,d,null);if(!A||r.token.isCancellationRequested)break;D(o.slice(0,A))}}catch(A){a=new Error(A),r.dispose(!0)}finally{l=!1}}})()});return await y.ready,I(),new Promise((k,T)=>{r.token.onCancellationRequested(async()=>{y.dispose();try{await v.Promises.close(t)}catch(A){a=new Error(A)}a?T(a):k()})})}}),define(ce[182],le([0,1,4,111,180,3,181,32]),function(V,e,n,s,b,M,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class w extends b.BaseWatcher{constructor(m){super(),this.recursiveWatcher=m,this.onDidError=n.Event.None,this.watchers=new Set}async doWatch(m){m=this.removeDuplicateRequests(m);const u=[],f=new Set(Array.from(this.watchers));for(const v of m){const h=this.findWatcher(v);h&&(0,s.patternsEquals)(h.request.excludes,v.excludes)&&(0,s.patternsEquals)(h.request.includes,v.includes)?f.delete(h):u.push(v)}u.length&&this.trace(`Request to start watching: ${u.map(v=>this.requestToString(v)).join(",")}`),f.size&&this.trace(`Request to stop watching: ${Array.from(f).map(v=>this.requestToString(v.request)).join(",")}`);for(const v of f)this.stopWatching(v);for(const v of u)this.startWatching(v)}findWatcher(m){for(const u of this.watchers)if(typeof m.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===m.correlationId)return u}else if((0,R.isEqual)(u.request.path,m.path,!M.isLinux))return u}startWatching(m){const u=new L.NodeJSFileWatcherLibrary(m,this.recursiveWatcher,v=>this._onDidChangeFile.fire(v),()=>this._onDidWatchFail.fire(m),v=>this._onDidLogMessage.fire(v),this.verboseLogging),f={request:m,instance:u};this.watchers.add(f)}async stop(){await super.stop();for(const m of this.watchers)this.stopWatching(m)}stopWatching(m){this.trace("stopping file watcher",m),this.watchers.delete(m),m.instance.dispose()}removeDuplicateRequests(m){const u=new Map;for(const f of m){const v=M.isLinux?f.path:f.path.toLowerCase();let h=u.get(f.correlationId);h||(h=new Map,u.set(f.correlationId,h)),h.has(v)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(f)}`),h.set(v,f)}return Array.from(u.values()).map(f=>Array.from(f.values())).flat()}async setVerboseLogging(m){super.setVerboseLogging(m);for(const u of this.watchers)u.instance.setVerboseLogging(m)}trace(m,u){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m,u)})}warn(m){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(m)})}toMessage(m,u){return u?`[File Watcher (node.js)] ${m} (${this.requestToString(u.request)})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=w}),define(ce[183],le([0,1,61,182]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class b extends n.AbstractNonRecursiveWatcherClient{constructor(L,R,w){super(L,R,w),this.init()}createWatcher(L){return L.add(new s.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=b}),define(ce[184],le([0,1,12,44,160,61]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends M.AbstractUniversalWatcherClient{constructor(w,c,m){super(w,c,m),this.init()}createWatcher(w){const c=w.add(new b.Client(n.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(c.onDidProcessExit(({code:m,signal:u})=>this.onError(`terminated by itself with code ${m}, signal: ${u} (ETERM)`))),s.ProxyChannel.toService((0,s.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(ce[98],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...b){this._entries=new Map;for(const[M,L]of b)this.set(M,L)}set(b,M){const L=this._entries.get(b);return this._entries.set(b,M),L}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=n}),define(ce[185],le([0,1,8,15,2,83,174,6,98,108]),function(V,e,n,s,b,M,L,R,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class u extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class f{constructor(E=new w.ServiceCollection,S=!1,p,D=m){this._services=E,this._strict=S,this._parent=p,this._enableTracing=D,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=D?p?._globalGraph??new L.Graph(I=>I):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,b.dispose)(this._children),this._children.clear();for(const E of this._servicesToMaybeDispose)(0,b.isDisposable)(E)&&E.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(E,S){this._throwIfDisposed();const p=this,D=new class extends f{dispose(){p._children.delete(D),super.dispose()}}(E,this._strict,this,this._enableTracing);return this._children.add(D),S?.add(D),D}invokeFunction(E,...S){this._throwIfDisposed();const p=h.traceInvocation(this._enableTracing,E);let D=!1;try{return E({get:i=>{if(D)throw(0,s.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(i,p);if(!d)throw new Error(`[invokeFunction] unknown service '${i}'`);return d}},...S)}finally{D=!0,p.stop()}}createInstance(E,...S){this._throwIfDisposed();let p,D;return E instanceof M.SyncDescriptor?(p=h.traceCreation(this._enableTracing,E.ctor),D=this._createInstance(E.ctor,E.staticArguments.concat(S),p)):(p=h.traceCreation(this._enableTracing,E),D=this._createInstance(E,S,p)),p.stop(),D}_createInstance(E,S=[],p){const D=R._util.getServiceDependencies(E).sort((d,t)=>d.index-t.index),I=[];for(const d of D){const t=this._getOrCreateServiceInstance(d.id,p);t||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${d.id}.`,!1),I.push(t)}const i=D.length>0?D[0].index:S.length;if(S.length!==i){console.trace(`[createInstance] First service dependency of ${E.name} at position ${i+1} conflicts with ${S.length} static arguments`);const d=i-S.length;d>0?S=S.concat(new Array(d)):S=S.slice(0,i)}return Reflect.construct(E,S.concat(I))}_setCreatedServiceInstance(E,S){if(this._services.get(E)instanceof M.SyncDescriptor)this._services.set(E,S);else if(this._parent)this._parent._setCreatedServiceInstance(E,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const S=this._services.get(E);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):S}_getOrCreateServiceInstance(E,S){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(E));const p=this._getServiceInstanceOrDescriptor(E);return p instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,p,S.branch(E,!0)):(S.branch(E,!1),p)}_safeCreateAndCacheServiceInstance(E,S,p){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,S,p)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,S,p){const D=new L.Graph(t=>t.id.toString());let I=0;const i=[{id:E,desc:S,_trace:p}],d=new Set;for(;i.length;){const t=i.pop();if(!d.has(String(t.id))){if(d.add(String(t.id)),D.lookupOrInsertNode(t),I++>1e3)throw new u(D);for(const o of R._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(o.id);if(r||this._throwIfStrict(`[createInstance] ${E} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof M.SyncDescriptor){const a={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};D.insertEdge(t,a),i.push(a)}}}}for(;;){const t=D.roots();if(t.length===0){if(!D.isEmpty())throw new u(D);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof M.SyncDescriptor){const a=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setCreatedServiceInstance(o.id,a)}D.removeNode(o)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,S,p=[],D,I){if(this._services.get(E)instanceof M.SyncDescriptor)return this._createServiceInstance(E,S,p,D,I,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,S,p,D,I);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(E,S,p=[],D,I,i){if(D){const d=new f(void 0,this._strict,this,this._enableTracing);d._globalGraphImplicitDependency=String(E);const t=new Map,o=new n.GlobalIdleValue(()=>{const r=d._createInstance(S,p,I);for(const[a,l]of t){const P=r[a];if(typeof P=="function")for(const y of l)y.disposable=P.apply(r,y.listener)}return t.clear(),i.add(r),r});return new Proxy(Object.create(null),{get(r,a){if(!o.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let y=t.get(a);return y||(y=new c.LinkedList,t.set(a,y)),(T,A,C)=>{if(o.isInitialized)return o.value[a](T,A,C);{const _={listener:[T,A,C],disposable:void 0},H=y.push(_);return(0,b.toDisposable)(()=>{H(),_.disposable?.dispose()})}}}if(a in r)return r[a];const l=o.value;let P=l[a];return typeof P!="function"||(P=P.bind(l),r[a]=P),P},set(r,a,l){return o.value[a]=l,!0},getPrototypeOf(r){return S.prototype}})}else{const d=this._createInstance(S,p,I);return i.add(d),d}}_throwIfStrict(E,S){if(S&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=f;var v;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(v||(v={}));class h{static{this.all=new Set}static{this._None=new class extends h{constructor(){super(v.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,S){return E?new h(v.Invocation,S.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h._None}static traceCreation(E,S){return E?new h(v.Creation,S.name):h._None}static{this._totals=0}constructor(E,S){this.type=E,this.name=S,this._start=Date.now(),this._dep=[]}branch(E,S){const p=new h(v.Branch,E.toString());return this._dep.push([E,S,p]),p}stop(){const E=Date.now()-this._start;h._totals+=E;let S=!1;function p(I,i){const d=[],t=new Array(I+1).join("	");for(const[o,r,a]of i._dep)if(r&&a){S=!0,d.push(`${t}CREATES -> ${o}`);const l=p(I+1,a);l&&d.push(l)}else d.push(`${t}uses -> ${o}`);return d.join(`
`)}const D=[`${this.type===v.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(E>2||S)&&h.all.add(D.join(`
`))}}e.Trace=h}),define(ce[186],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProcessMainService=e.IIssueMainService=e.IssueSource=e.OldIssueType=void 0;var s;(function(M){M[M.Bug=0]="Bug",M[M.PerformanceIssue=1]="PerformanceIssue",M[M.FeatureRequest=2]="FeatureRequest"})(s||(e.OldIssueType=s={}));var b;(function(M){M.VSCode="vscode",M.Extension="extension",M.Marketplace="marketplace"})(b||(e.IssueSource=b={})),e.IIssueMainService=(0,n.createDecorator)("issueService"),e.IProcessMainService=(0,n.createDecorator)("processService")}),define(ce[5],le([0,1,10,55,4,46,2,31,3,18,11,7,122,6]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=g,e.log=S,e.getLogLevel=P,e.LogLevelToString=y,e.LogLevelToLocalizedString=k,e.parseLogLevel=T,n=De(n),e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function h(){return new Date().toISOString()}function g(A){return(0,m.isNumber)(A)}var E;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(E||(e.LogLevel=E={})),e.DEFAULT_LOG_LEVEL=E.Info;function S(A,C,_){switch(C){case E.Trace:A.trace(_);break;case E.Debug:A.debug(_);break;case E.Info:A.info(_);break;case E.Warning:A.warn(_);break;case E.Error:A.error(_);break;case E.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function p(A,C=!1){let _="";for(let H=0;H<A.length;H++){let q=A[H];if(q instanceof Error&&(q=(0,s.toErrorMessage)(q,C)),typeof q=="object")try{q=JSON.stringify(q)}catch{}_+=(H>0?" ":"")+q}return _}class D extends L.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(C){this.level!==C&&(this.level=C,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(C){return this.level!==E.Off&&this.level<=C}}e.AbstractLogger=D;class I extends D{constructor(C){super(),this.logAlways=C}checkLogLevel(C){return this.logAlways||super.checkLogLevel(C)}trace(C,..._){this.checkLogLevel(E.Trace)&&this.log(E.Trace,p([C,..._],!0))}debug(C,..._){this.checkLogLevel(E.Debug)&&this.log(E.Debug,p([C,..._]))}info(C,..._){this.checkLogLevel(E.Info)&&this.log(E.Info,p([C,..._]))}warn(C,..._){this.checkLogLevel(E.Warning)&&this.log(E.Warning,p([C,..._]))}error(C,..._){if(this.checkLogLevel(E.Error))if(C instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=C.stack,this.log(E.Error,p(H))}else this.log(E.Error,p([C,..._]))}flush(){}}e.AbstractMessageLogger=I;class i extends D{constructor(C=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(C),this.useColors=!w.isWindows}trace(C,..._){this.checkLogLevel(E.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,C,..._):console.log(`[main ${h()}]`,C,..._))}debug(C,..._){this.checkLogLevel(E.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,C,..._):console.log(`[main ${h()}]`,C,..._))}info(C,..._){this.checkLogLevel(E.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,C,..._):console.log(`[main ${h()}]`,C,..._))}warn(C,..._){this.checkLogLevel(E.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,C,..._):console.warn(`[main ${h()}]`,C,..._))}error(C,..._){this.checkLogLevel(E.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,C,..._):console.error(`[main ${h()}]`,C,..._))}flush(){}}e.ConsoleMainLogger=i;class d extends D{constructor(C=e.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(C)}trace(C,..._){this.checkLogLevel(E.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",C,..._):console.log(C,..._))}debug(C,..._){this.checkLogLevel(E.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",C,..._):console.log(C,..._))}info(C,..._){this.checkLogLevel(E.Info)&&(this.useColors?console.log("%c INFO","color: #33f",C,..._):console.log(C,..._))}warn(C,..._){this.checkLogLevel(E.Warning)&&(this.useColors?console.log("%c WARN","color: #993",C,..._):console.log(C,..._))}error(C,..._){this.checkLogLevel(E.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",C,..._):console.error(C,..._))}flush(){}}e.ConsoleLogger=d;class t extends D{constructor(C,_=e.DEFAULT_LOG_LEVEL){super(),this.adapter=C,this.setLevel(_)}trace(C,..._){this.checkLogLevel(E.Trace)&&this.adapter.log(E.Trace,[this.extractMessage(C),..._])}debug(C,..._){this.checkLogLevel(E.Debug)&&this.adapter.log(E.Debug,[this.extractMessage(C),..._])}info(C,..._){this.checkLogLevel(E.Info)&&this.adapter.log(E.Info,[this.extractMessage(C),..._])}warn(C,..._){this.checkLogLevel(E.Warning)&&this.adapter.log(E.Warning,[this.extractMessage(C),..._])}error(C,..._){this.checkLogLevel(E.Error)&&this.adapter.log(E.Error,[this.extractMessage(C),..._])}extractMessage(C){return typeof C=="string"?C:(0,s.toErrorMessage)(C,this.checkLogLevel(E.Trace))}flush(){}}e.AdapterLogger=t;class o extends D{constructor(C){super(),this.loggers=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const _ of this.loggers)_.setLevel(C);super.setLevel(C)}trace(C,..._){for(const H of this.loggers)H.trace(C,..._)}debug(C,..._){for(const H of this.loggers)H.debug(C,..._)}info(C,..._){for(const H of this.loggers)H.info(C,..._)}warn(C,..._){for(const H of this.loggers)H.warn(C,..._)}error(C,..._){for(const H of this.loggers)H.error(C,..._)}flush(){for(const C of this.loggers)C.flush()}dispose(){for(const C of this.loggers)C.dispose();super.dispose()}}e.MultiplexLogger=o;class r extends L.Disposable{constructor(C,_,H){if(super(),this.logLevel=C,this.logsHome=_,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new b.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new b.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,H)for(const q of H)this._loggers.set(q.resource,{logger:void 0,info:q})}getLoggerEntry(C){return(0,m.isString)(C)?[...this._loggers.values()].find(_=>_.info.id===C):this._loggers.get(C)}getLogger(C){return this.getLoggerEntry(C)?.logger}createLogger(C,_){const H=this.toResource(C),q=(0,m.isString)(C)?C:_?.id??(0,M.hash)(H.toString()).toString(16);let K=this._loggers.get(H)?.logger;const fe=_?.logLevel==="always"?E.Trace:_?.logLevel;K||(K=this.doCreateLogger(H,fe??this.getLogLevel(H)??this.logLevel,{..._,id:q}));const $={logger:K,info:{resource:H,id:q,logLevel:fe,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger($.info),this._loggers.set(H,$),K}toResource(C){return(0,m.isString)(C)?(0,c.joinPath)(this.logsHome,`${C}.log`):C}setLogLevel(C,_){if(u.URI.isUri(C)){const H=C,q=_,K=this._loggers.get(H);K&&q!==K.info.logLevel&&(K.info.logLevel=q===this.logLevel?void 0:q,K.logger?.setLevel(q),this._loggers.set(K.info.resource,K),this._onDidChangeLogLevel.fire([H,q]))}else{this.logLevel=C;for(const[H,q]of this._loggers.entries())this._loggers.get(H)?.info.logLevel===void 0&&q.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(C,_){const H=this.getLoggerEntry(C);H&&_!==!H.info.hidden&&(H.info.hidden=!_,this._loggers.set(H.info.resource,H),this._onDidChangeVisibility.fire([H.info.resource,_]))}getLogLevel(C){let _;return C&&(_=this._loggers.get(C)?.info.logLevel),_??this.logLevel}registerLogger(C){const _=this._loggers.get(C.resource);_?_.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this._loggers.set(C.resource,{info:C,logger:void 0}),this._onDidChangeLoggers.fire({added:[C],removed:[]}))}deregisterLogger(C){const _=this._loggers.get(C);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(C),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const C of this._loggers.values())yield C.info}getRegisteredLogger(C){return this._loggers.get(C)?.info}dispose(){this._loggers.forEach(C=>C.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class a{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(C){}getLevel(){return E.Info}trace(C,..._){}debug(C,..._){}info(C,..._){}warn(C,..._){}error(C,..._){}critical(C,..._){}dispose(){}flush(){}}e.NullLogger=a;class l extends a{}e.NullLogService=l;function P(A){if(A.verbose)return E.Trace;if(typeof A.logLevel=="string"){const C=T(A.logLevel.toLowerCase());if(C!==void 0)return C}return e.DEFAULT_LOG_LEVEL}function y(A){switch(A){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function k(A){switch(A){case E.Trace:return{original:"Trace",value:n.localize(11319,null)};case E.Debug:return{original:"Debug",value:n.localize(11320,null)};case E.Info:return{original:"Info",value:n.localize(11321,null)};case E.Warning:return{original:"Warning",value:n.localize(11322,null)};case E.Error:return{original:"Error",value:n.localize(11323,null)};case E.Off:return{original:"Off",value:n.localize(11324,null)}}}function T(A){switch(A){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.CONTEXT_LOG_LEVEL=new f.RawContextKey("logLevel",y(E.Info))});var re=this&&this.__param||function(V,e){return function(n,s){e(n,s,V)}};define(ce[187],le([0,1,13,3,97,5]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const L=n.safeStorage;let R=class{constructor(c){this.logService=c,n.app.commandLine.getSwitchValue("password-store")===b.PasswordStoreCLIOption.basic&&(this.logService.trace("[EncryptionMainService] setting usePlainTextEncryption to true..."),L.setUsePlainTextEncryption?.(!0),this.logService.trace("[EncryptionMainService] set usePlainTextEncryption to true"))}async encrypt(c){this.logService.trace("[EncryptionMainService] Encrypting value...");try{const m=JSON.stringify(L.encryptString(c));return this.logService.trace("[EncryptionMainService] Encrypted value."),m}catch(m){throw this.logService.error(m),m}}async decrypt(c){let m;try{if(m=JSON.parse(c),!m.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${c}`);const u=Buffer.from(m.data);this.logService.trace("[EncryptionMainService] Decrypting value...");const f=L.decryptString(u);return this.logService.trace("[EncryptionMainService] Decrypted value."),f}catch(u){throw this.logService.error(u),u}}isEncryptionAvailable(){this.logService.trace("[EncryptionMainService] Checking if encryption is available...");const c=L.isEncryptionAvailable();return this.logService.trace("[EncryptionMainService] Encryption is available: ",c),Promise.resolve(c)}getKeyStorageProvider(){if(s.isWindows)return Promise.resolve(b.KnownStorageProvider.dplib);if(s.isMacintosh)return Promise.resolve(b.KnownStorageProvider.keychainAccess);if(L.getSelectedStorageBackend)try{this.logService.trace("[EncryptionMainService] Getting selected storage backend...");const c=L.getSelectedStorageBackend();return this.logService.trace("[EncryptionMainService] Selected storage backend: ",c),Promise.resolve(c)}catch(c){this.logService.error(c)}return Promise.resolve(b.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(s.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(s.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!L.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");this.logService.trace("[EncryptionMainService] Setting usePlainTextEncryption to true..."),L.setUsePlainTextEncryption(!0),this.logService.trace("[EncryptionMainService] Set usePlainTextEncryption to true")}};e.EncryptionMainService=R,e.EncryptionMainService=R=Ie([re(0,M.ILogService)],R)}),define(ce[188],le([0,1,21,8,15,4,32,2,9,61,5]),function(V,e,n,s,b,M,L,R,w,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class u extends R.Disposable{constructor(v,h){super(),this.logService=v,this.options=h,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new s.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new s.ThrottledDelayer(0))}watch(v,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,h):this.watchNonRecursive(v,h)}watchUniversal(v,h){const g={path:this.toWatchPath(v),excludes:h.excludes,includes:h.includes,recursive:h.recursive,filter:h.filter,correlationId:h.correlationId},E=(0,n.insert)(this.universalWatchRequests,g);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,b.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,c.reviveFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const h of this.universalWatchRequests)(0,c.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const h of this.universalWatchRequests)(0,c.isRecursiveWatchRequest)(h)&&v.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(v,h){const g={path:this.toWatchPath(v),excludes:h.excludes,includes:h.includes,recursive:!1,filter:h.filter,correlationId:h.correlationId},E=(0,n.insert)(this.nonRecursiveWatchRequests,g);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,b.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,c.reviveFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logWatcherMessage(v)}logWatcherMessage(v){this.logService[v.type](v.message)}toFilePath(v){return(0,w.normalize)(v.fsPath)}toWatchPath(v){const h=this.toFilePath(v);return(0,L.removeTrailingPathSeparator)(h)}}e.AbstractDiskFileSystemProvider=u}),define(ce[189],le([0,1,21,8,17,22,4,46,77,2,60,12,70,18,67,10,14,124,5,15]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let i=class extends c.Disposable{static{I=this}constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new L.Emitter),this._onDidUncorrelatedFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new s.ResourceQueue)}registerProvider(t,o){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${t}`);const r=new c.DisposableStore;return this.provider.set(t,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:o}),r.add(o.onDidChangeFile(a=>{const l=new E.FileChangesEvent(a,!this.isPathCaseSensitive(o));this.internalOnDidFilesChange.fire(l),l.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(l)})),typeof o.onDidWatchError=="function"&&r.add(o.onDidWatchError(a=>this._onDidWatchError.fire(new Error(a)))),r.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:t}))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:o}),this.provider.delete(t),(0,c.dispose)(r)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(r){o.push(r)}}),!this.provider.has(t)&&await s.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,o){const r=this.provider.get(t.scheme);return!!(r&&r.capabilities&o)}listCapabilities(){return w.Iterable.map(this.provider,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async withProvider(t){if(!(0,v.isAbsolutePath)(t))throw new E.FileOperationError((0,g.localize)(11392,null,this.resourceForError(t)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(t.scheme);const o=this.provider.get(t.scheme);if(!o){const r=new D.ErrorNoTelemetry;throw r.message=(0,g.localize)(11393,null,t.toString()),r}return o}async withReadProvider(t){const o=await this.withProvider(t);if((0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasReadWriteCapability)(o)||(0,E.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const o=await this.withProvider(t);if((0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.doResolveFile(t,o)}catch(r){throw(0,E.toFileSystemProviderErrorCode)(r)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,g.localize)(11394,null,this.resourceForError(t)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.ensureFileSystemProviderError)(r)}}async doResolveFile(t,o){const r=await this.withProvider(t),a=this.isPathCaseSensitive(r),l=o?.resolveTo,P=o?.resolveSingleChildDescendants,y=o?.resolveMetadata,k=await r.stat(t);let T;return this.toFileStat(r,t,k,void 0,!!y,(A,C)=>(T||(T=m.TernarySearchTree.forUris(()=>!a),T.set(t,!0),l&&T.fill(!0,l)),T.get(A.resource)||T.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&P?C===1:!1))}async toFileStat(t,o,r,a,l,P){const{providerExtUri:y}=this.getExtUri(t),k={resource:o,name:y.basename(o),isFile:(r.type&E.FileType.File)!==0,isDirectory:(r.type&E.FileType.Directory)!==0,isSymbolicLink:(r.type&E.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&E.FilePermission.Readonly)||!!(t.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((r.permissions??0)&E.FilePermission.Locked),etag:(0,E.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(k.isDirectory&&P(k,a)){try{const T=await t.readdir(o),A=await s.Promises.settled(T.map(async([C,_])=>{try{const H=y.joinPath(o,C),q=l?await t.stat(H):{type:_};return await this.toFileStat(t,H,q,T.length,l,P)}catch(H){return this.logService.trace(H),null}}));k.children=(0,n.coalesce)(A)}catch(T){this.logService.trace(T),k.children=[]}return k}return k}async resolveAll(t){return s.Promises.settled(t.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.withProvider(t),r=await o.stat(t);return this.toFileStat(o,t,r,void 0,!0,()=>!1)}async exists(t){const o=await this.withProvider(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.doValidateCreateFile(t,o)}catch(r){return r}return!0}async doValidateCreateFile(t,o){if(!o?.overwrite&&await this.exists(t))throw new E.FileOperationError((0,g.localize)(11395,null,this.resourceForError(t)),E.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(t,o=b.VSBuffer.fromString(""),r){await this.doValidateCreateFile(t,r);const a=await this.writeFile(t,o);return this._onDidRunOperation.fire(new E.FileOperationEvent(t,E.FileOperation.CREATE,a)),a}async writeFile(t,o,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:l}=this.getExtUri(a);let P=r;if((0,E.hasFileAtomicWriteCapability)(a)&&!P?.atomic){const y=a.enforceAtomicWriteFile?.(t);y&&(P={...r,atomic:y})}try{await this.validateWriteFile(a,t,P)||await this.mkdirp(a,l.dirname(t));let k;if((0,E.hasReadWriteCapability)(a)&&!(o instanceof b.VSBuffer))if((0,h.isReadableStream)(o)){const T=await(0,h.peekStream)(o,3);T.ended?k=b.VSBuffer.concat(T.buffer):k=T}else k=(0,h.peekReadable)(o,T=>b.VSBuffer.concat(T),3);else k=o;!(0,E.hasOpenReadWriteCloseCapability)(a)||(0,E.hasReadWriteCapability)(a)&&k instanceof b.VSBuffer||(0,E.hasReadWriteCapability)(a)&&(0,E.hasFileAtomicWriteCapability)(a)&&P?.atomic?await this.doWriteUnbuffered(a,t,P,k):await this.doWriteBuffered(a,t,P,k instanceof b.VSBuffer?(0,b.bufferToReadable)(k):k),this._onDidRunOperation.fire(new E.FileOperationEvent(t,E.FileOperation.WRITE))}catch(y){throw new E.FileOperationError((0,g.localize)(11396,null,this.resourceForError(t),(0,E.ensureFileSystemProviderError)(y).toString()),(0,E.toFileOperationResult)(y),P)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,o,r){const a=!!r?.unlock;if(a&&!(t.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(11397,null,this.resourceForError(o)));if(!!r?.atomic){if(!(t.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(11398,null,this.resourceForError(o)));if(!(t.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(11399,null,this.resourceForError(o)));if(a)throw new Error((0,g.localize)(11400,null,this.resourceForError(o)))}let P;try{P=await t.stat(o)}catch{return}if(P.type&E.FileType.Directory)throw new E.FileOperationError((0,g.localize)(11401,null,this.resourceForError(o)),E.FileOperationResult.FILE_IS_DIRECTORY,r);if(this.throwIfFileIsReadonly(o,P),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==E.ETAG_DISABLED&&typeof P.mtime=="number"&&typeof P.size=="number"&&r.mtime<P.mtime&&r.etag!==(0,E.etag)({mtime:r.mtime,size:P.size}))throw new E.FileOperationError((0,g.localize)(11402,null),E.FileOperationResult.FILE_MODIFIED_SINCE,r);return P}async readFile(t,o,r){const a=await this.withReadProvider(t);return o?.atomic?this.doReadFileAtomic(a,t,o,r):this.doReadFile(a,t,o,r)}async doReadFileAtomic(t,o,r,a){return new Promise((l,P)=>{this.writeQueue.queueFor(o,async()=>{try{const y=await this.doReadFile(t,o,r,a);l(y)}catch(y){P(y)}},this.getExtUri(t).providerExtUri)})}async doReadFile(t,o,r,a){const l=await this.doReadFileStream(t,o,{...r,preferUnbuffered:!0},a);return{...l,value:await(0,b.streamToBuffer)(l.value)}}async readFileStream(t,o,r){const a=await this.withReadProvider(t);return this.doReadFileStream(a,t,o,r)}async doReadFileStream(t,o,r,a){const l=new M.CancellationTokenSource(a);let P=r;(0,E.hasFileAtomicReadCapability)(t)&&t.enforceAtomicReadFile?.(o)&&(P={...r,atomic:!0});const y=this.validateReadFile(o,P).then(T=>T,T=>{throw l.dispose(!0),T});let k;try{return typeof P?.etag=="string"&&P.etag!==E.ETAG_DISABLED&&await y,P?.atomic&&(0,E.hasFileAtomicReadCapability)(t)||!((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasFileReadStreamCapability)(t))||(0,E.hasReadWriteCapability)(t)&&P?.preferUnbuffered?k=this.readFileUnbuffered(t,o,P):(0,E.hasFileReadStreamCapability)(t)?k=this.readFileStreamed(t,o,l.token,P):k=this.readFileBuffered(t,o,l.token,P),k.on("end",()=>l.dispose()),k.on("error",()=>l.dispose()),{...await y,value:k}}catch(T){throw k&&await(0,h.consumeStream)(k),this.restoreReadError(T,o,P)}}restoreReadError(t,o,r){const a=(0,g.localize)(11403,null,this.resourceForError(o),(0,E.ensureFileSystemProviderError)(t).toString());return t instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(a,t.stat,r):t instanceof E.TooLargeFileOperationError?new E.TooLargeFileOperationError(a,t.fileOperationResult,t.size,t.options):new E.FileOperationError(a,(0,E.toFileOperationResult)(t),r)}readFileStreamed(t,o,r,a=Object.create(null)){const l=t.readFileStream(o,a,r);return(0,h.transform)(l,{data:P=>P instanceof b.VSBuffer?P:b.VSBuffer.wrap(P),error:P=>this.restoreReadError(P,o,a)},P=>b.VSBuffer.concat(P))}readFileBuffered(t,o,r,a=Object.create(null)){const l=(0,b.newWriteableBufferStream)();return(0,S.readFileIntoStream)(t,o,l,P=>P,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:P=>this.restoreReadError(P,o,a)},r),l}readFileUnbuffered(t,o,r){const a=(0,h.newWriteableStream)(l=>b.VSBuffer.concat(l));return(async()=>{try{let l;r?.atomic&&(0,E.hasFileAtomicReadCapability)(t)?l=await t.readFile(o,{atomic:!0}):l=await t.readFile(o),typeof r?.position=="number"&&(l=l.slice(r.position)),typeof r?.length=="number"&&(l=l.slice(0,r.length)),this.validateReadFileLimits(o,l.byteLength,r),a.end(b.VSBuffer.wrap(l))}catch(l){a.error(l),a.end()}})(),a}async validateReadFile(t,o){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new E.FileOperationError((0,g.localize)(11404,null,this.resourceForError(t)),E.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==E.ETAG_DISABLED&&o.etag===r.etag)throw new E.NotModifiedSinceFileOperationError((0,g.localize)(11405,null),r,o);return this.validateReadFileLimits(t,r.size,o),r}validateReadFileLimits(t,o,r){if(typeof r?.limits?.size=="number"&&o>r.limits.size)throw new E.TooLargeFileOperationError((0,g.localize)(11406,null,this.resourceForError(t)),E.FileOperationResult.FILE_TOO_LARGE,o,r)}async canMove(t,o,r){return this.doCanMoveCopy(t,o,"move",r)}async canCopy(t,o,r){return this.doCanMoveCopy(t,o,"copy",r)}async doCanMoveCopy(t,o,r,a){if(t.toString()!==o.toString())try{const l=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),P=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(l,t,P,o,r,a)}catch(l){return l}return!0}async move(t,o,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),P=await this.doMoveCopy(a,t,l,o,"move",!!r),y=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(t,P==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,y)),y}async copy(t,o,r){const a=await this.withReadProvider(t),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),P=await this.doMoveCopy(a,t,l,o,"copy",!!r),y=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(t,P==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,y)),y}async doMoveCopy(t,o,r,a,l,P){if(o.toString()===a.toString())return l;const{exists:y,isSameResourceWithDifferentPathCase:k}=await this.doValidateMoveCopy(t,o,r,a,l,P);if(y&&!k&&P&&await this.del(a,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(a)),l==="copy"){if(t===r&&(0,E.hasFileFolderCopyCapability)(t))await t.copy(o,a,{overwrite:P});else{const T=await this.resolve(o);T.isDirectory?await this.doCopyFolder(t,T,r,a):await this.doCopyFile(t,o,r,a)}return l}else return t===r?(await t.rename(o,a,{overwrite:P}),l):(await this.doMoveCopy(t,o,r,a,"copy",P),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(t,o,r,a){if((0,E.hasOpenReadWriteCloseCapability)(t)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(t,o,r,a);if((0,E.hasOpenReadWriteCloseCapability)(t)&&(0,E.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(t,o,r,a);if((0,E.hasReadWriteCapability)(t)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(t,o,r,a);if((0,E.hasReadWriteCapability)(t)&&(0,E.hasReadWriteCapability)(r))return this.doPipeUnbuffered(t,o,r,a)}async doCopyFolder(t,o,r,a){await r.mkdir(a),Array.isArray(o.children)&&await s.Promises.settled(o.children.map(async l=>{const P=this.getExtUri(r).providerExtUri.joinPath(a,l.name);return l.isDirectory?this.doCopyFolder(t,await this.resolve(l.resource),r,P):this.doCopyFile(t,l.resource,r,P)}))}async doValidateMoveCopy(t,o,r,a,l,P){let y=!1;if(t===r){const{providerExtUri:T,isPathCaseSensitive:A}=this.getExtUri(t);if(A||(y=T.isEqual(o,a)),y&&l==="copy")throw new Error((0,g.localize)(11407,null,this.resourceForError(o),this.resourceForError(a)));if(!y&&T.isEqualOrParent(a,o))throw new Error((0,g.localize)(11408,null,this.resourceForError(o),this.resourceForError(a)))}const k=await this.exists(a);if(k&&!y){if(!P)throw new E.FileOperationError((0,g.localize)(11409,null,this.resourceForError(o),this.resourceForError(a)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(t===r){const{providerExtUri:T}=this.getExtUri(t);if(T.isEqualOrParent(o,a))throw new Error((0,g.localize)(11410,null,this.resourceForError(o),this.resourceForError(a)))}}return{exists:k,isSameResourceWithDifferentPathCase:y}}getExtUri(t){const o=this.isPathCaseSensitive(t);return{providerExtUri:o?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(t){return!!(t.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(t){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(o,t);const r=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(t,E.FileOperation.CREATE,r)),r}async mkdirp(t,o){const r=[],{providerExtUri:a}=this.getExtUri(t);for(;!a.isEqual(o,a.dirname(o));)try{if(!((await t.stat(o)).type&E.FileType.Directory))throw new Error((0,g.localize)(11411,null,this.resourceForError(o)));break}catch(l){if((0,E.toFileSystemProviderErrorCode)(l)!==E.FileSystemProviderErrorCode.FileNotFound)throw l;r.push(a.basename(o)),o=a.dirname(o)}for(let l=r.length-1;l>=0;l--){o=a.joinPath(o,r[l]);try{await t.mkdir(o)}catch(P){if((0,E.toFileSystemProviderErrorCode)(P)!==E.FileSystemProviderErrorCode.FileExists)throw P}}}async canDelete(t,o){try{await this.doValidateDelete(t,o)}catch(r){return r}return!0}async doValidateDelete(t,o){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t),a=!!o?.useTrash;if(a&&!(r.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(11412,null,this.resourceForError(t)));const l=o?.atomic;if(l&&!(r.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(11413,null,this.resourceForError(t)));if(a&&l)throw new Error((0,g.localize)(11414,null,this.resourceForError(t)));let P;try{P=await r.stat(t)}catch{}if(P)this.throwIfFileIsReadonly(t,P);else throw new E.FileOperationError((0,g.localize)(11415,null,this.resourceForError(t)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const k=await this.resolve(t);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,g.localize)(11416,null,this.resourceForError(t)))}return r}async del(t,o){const r=await this.doValidateDelete(t,o);let a=o;if((0,E.hasFileAtomicDeleteCapability)(r)&&!a?.atomic){const k=r.enforceAtomicDelete?.(t);k&&(a={...o,atomic:k})}const l=!!a?.useTrash,P=!!a?.recursive,y=a?.atomic??!1;await r.delete(t,{recursive:P,useTrash:l,atomic:y}),this._onDidRunOperation.fire(new E.FileOperationEvent(t,E.FileOperation.DELETE))}async cloneFile(t,o){const r=await this.withProvider(t),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(!(r===a&&this.getExtUri(r).providerExtUri.isEqual(t,o)))return r===a&&(0,E.hasFileCloneCapability)(r)?r.cloneFile(t,o):(await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(o)),r===a&&(0,E.hasFileFolderCopyCapability)(r)?this.writeQueue.queueFor(t,()=>r.copy(t,o,{overwrite:!0}),this.getExtUri(r).providerExtUri):this.writeQueue.queueFor(t,()=>this.doCopyFile(r,t,a,o),this.getExtUri(r).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(t,o){return this.watch(t,{...o,correlationId:I.WATCHER_CORRELATION_IDS++})}watch(t,o={recursive:!1,excludes:[]}){const r=new c.DisposableStore;let a=!1,l=()=>{a=!0};r.add((0,c.toDisposable)(()=>l())),(async()=>{try{const y=await this.doWatch(t,o);a?(0,c.dispose)(y):l=()=>(0,c.dispose)(y)}catch(y){this.logService.error(y)}})();const P=o.correlationId;if(typeof P=="number"){const y=r.add(new L.Emitter);return r.add(this.internalOnDidFilesChange.event(T=>{T.correlates(P)&&y.fire(T)})),{onDidChange:y.event,dispose:()=>r.dispose()}}return r}async doWatch(t,o){const r=await this.withProvider(t),a=(0,R.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(t),o]);let l=this.activeWatchers.get(a);return l||(l={count:0,disposable:r.watch(t,o)},this.activeWatchers.set(a,l)),l.count+=1,(0,c.toDisposable)(()=>{l&&(l.count--,l.count===0&&((0,c.dispose)(l.disposable),this.activeWatchers.delete(a)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,c.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,o,r,a){return this.writeQueue.queueFor(o,async()=>{const l=await t.open(o,{create:!0,unlock:r?.unlock??!1});try{(0,h.isReadableStream)(a)||(0,h.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(t,l,a):await this.doWriteReadableBufferedQueued(t,l,a)}catch(P){throw(0,E.ensureFileSystemProviderError)(P)}finally{await t.close(l)}},this.getExtUri(t).providerExtUri)}async doWriteStreamBufferedQueued(t,o,r){let a=0,l;if((0,h.isReadableBufferedStream)(r)){if(r.buffer.length>0){const P=b.VSBuffer.concat(r.buffer);await this.doWriteBuffer(t,o,P,P.byteLength,a,0),a+=P.byteLength}if(r.ended)return;l=r.stream}else l=r;return new Promise((P,y)=>{(0,h.listenStream)(l,{onData:async k=>{l.pause();try{await this.doWriteBuffer(t,o,k,k.byteLength,a,0)}catch(T){return y(T)}a+=k.byteLength,setTimeout(()=>l.resume())},onError:k=>y(k),onEnd:()=>P()})})}async doWriteReadableBufferedQueued(t,o,r){let a=0,l;for(;(l=r.read())!==null;)await this.doWriteBuffer(t,o,l,l.byteLength,a,0),a+=l.byteLength}async doWriteBuffer(t,o,r,a,l,P){let y=0;for(;y<a;){const k=await t.write(o,l+y,r.buffer,P+y,a-y);y+=k}}async doWriteUnbuffered(t,o,r,a){return this.writeQueue.queueFor(o,()=>this.doWriteUnbufferedQueued(t,o,r,a),this.getExtUri(t).providerExtUri)}async doWriteUnbufferedQueued(t,o,r,a){let l;a instanceof b.VSBuffer?l=a:(0,h.isReadableStream)(a)?l=await(0,b.streamToBuffer)(a):(0,h.isReadableBufferedStream)(a)?l=await(0,b.bufferedStreamToBuffer)(a):l=(0,b.readableToBuffer)(a),await t.writeFile(o,l.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async doPipeBuffered(t,o,r,a){return this.writeQueue.queueFor(a,()=>this.doPipeBufferedQueued(t,o,r,a),this.getExtUri(r).providerExtUri)}async doPipeBufferedQueued(t,o,r,a){let l,P;try{l=await t.open(o,{create:!1}),P=await r.open(a,{create:!0,unlock:!1});const y=b.VSBuffer.alloc(this.BUFFER_SIZE);let k=0,T=0,A=0;do A=await t.read(l,k,y.buffer,T,y.byteLength-T),await this.doWriteBuffer(r,P,y,A,k,T),k+=A,T+=A,T===y.byteLength&&(T=0);while(A>0)}catch(y){throw(0,E.ensureFileSystemProviderError)(y)}finally{await s.Promises.settled([typeof l=="number"?t.close(l):Promise.resolve(),typeof P=="number"?r.close(P):Promise.resolve()])}}async doPipeUnbuffered(t,o,r,a){return this.writeQueue.queueFor(a,()=>this.doPipeUnbufferedQueued(t,o,r,a),this.getExtUri(r).providerExtUri)}async doPipeUnbufferedQueued(t,o,r,a){return r.writeFile(a,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(t,o,r,a){return this.writeQueue.queueFor(a,()=>this.doPipeUnbufferedToBufferedQueued(t,o,r,a),this.getExtUri(r).providerExtUri)}async doPipeUnbufferedToBufferedQueued(t,o,r,a){const l=await r.open(a,{create:!0,unlock:!1});try{const P=await t.readFile(o);await this.doWriteBuffer(r,l,b.VSBuffer.wrap(P),P.byteLength,0,0)}catch(P){throw(0,E.ensureFileSystemProviderError)(P)}finally{await r.close(l)}}async doPipeBufferedToUnbuffered(t,o,r,a){const l=await(0,b.streamToBuffer)(this.readFileBuffered(t,o,M.CancellationToken.None));await this.doWriteUnbuffered(r,a,void 0,l)}throwIfFileSystemIsReadonly(t,o){if(t.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.FileOperationError((0,g.localize)(11417,null,this.resourceForError(o)),E.FileOperationResult.FILE_PERMISSION_DENIED);return t}throwIfFileIsReadonly(t,o){if((o.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,g.localize)(11418,null,this.resourceForError(t)),E.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(t){return t.scheme===u.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=i,e.FileService=i=I=Ie([re(0,p.ILogService)],i)}),define(ce[99],le([0,1,26,8,31,17,4,32,2,9,3,18,67,23,10,14,124,188,184,183]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class I extends S.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(d,t){super(d,t),this.onDidChangeCapabilities=L.Event.None,this.resourceLocks=new b.ResourceMap(o=>u.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,m.isLinux&&(this._capabilities|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(d){try{const{stat:t,symbolicLink:o}=await v.SymlinkSupport.stat(this.toFilePath(d));return{type:this.toType(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:g.FilePermission.Locked}}catch(t){throw this.toFileSystemProviderError(t)}}async statIgnoreError(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const t=await v.Promises.readdir(this.toFilePath(d),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,u.joinPath)(d,r.name))).type:a=this.toType(r),o.push([r.name,a])}catch(a){this.logService.trace(a)}})),o}catch(t){throw this.toFileSystemProviderError(t)}}toType(d,t){let o;return t?.dangling?o=g.FileType.Unknown:d.isFile()?o=g.FileType.File:d.isDirectory()?o=g.FileType.Directory:o=g.FileType.Unknown,t&&(o|=g.FileType.SymbolicLink),o}async createResourceLock(d){const t=this.toFilePath(d);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let o;for(;o=this.resourceLocks.get(d);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await o.wait();const r=new s.Barrier;return this.resourceLocks.set(d,r),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,w.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(d)===r&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(d)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),r.open()})}async readFile(d,t){let o;try{t?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(d)})`),o=await this.createResourceLock(d));const r=this.toFilePath(d);return await n.promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{o?.dispose()}}traceLock(d){I.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(d)}readFileStream(d,t,o){const r=(0,f.newWriteableStream)(a=>M.VSBuffer.concat(a.map(l=>M.VSBuffer.wrap(l))).buffer);return(0,E.readFileIntoStream)(this,d,r,a=>a.buffer,{...t,bufferSize:256*1024},o),r}async writeFile(d,t,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.canWriteFileAtomic(d)?this.doWriteFileAtomic(d,(0,u.joinPath)((0,u.dirname)(d),`${(0,u.basename)(d)}${o.atomic.postfix}`),t,o):this.doWriteFile(d,t,o)}async canWriteFileAtomic(d){try{const t=this.toFilePath(d),{symbolicLink:o}=await v.SymlinkSupport.stat(t);if(o)return!1}catch{}return!0}async doWriteFileAtomic(d,t,o,r){const a=new w.DisposableStore;try{a.add(await this.createResourceLock(d)),a.add(await this.createResourceLock(t)),await this.doWriteFile(t,o,r,!0);try{await this.rename(t,d,{overwrite:!0})}catch(l){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{a.dispose()}}async doWriteFile(d,t,o,r){let a;try{const l=this.toFilePath(d);if(!o.create||!o.overwrite){if(await v.Promises.exists(l)){if(!o.overwrite)throw(0,g.createFileSystemProviderError)((0,h.localize)(11376,null),g.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,g.createFileSystemProviderError)((0,h.localize)(11377,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(d,{create:!0,unlock:o.unlock},r),await this.write(a,0,t,0,t.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(d,l)}finally{typeof a=="number"&&await this.close(a)}}static{this.canFlush=!0}static configureFlushOnWrite(d){I.canFlush=d}async open(d,t,o){const r=this.toFilePath(d);let a;(0,g.isFileOpenForWriteOptions)(t)&&!o&&(a=await this.createResourceLock(d));let l;try{if((0,g.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:y}=await v.SymlinkSupport.stat(r);y.mode&128||await n.promises.chmod(r,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}let P;if((0,g.isFileOpenForWriteOptions)(t)){if(m.isWindows)try{await n.promises.truncate(r,0),P="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}P||(P="w")}else P="r";l=await v.Promises.open(r,P)}catch(P){throw a?.dispose(),(0,g.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(d,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(l,0),(0,g.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(l,d),a){const P=this.mapHandleToLock.get(l);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${r})`),this.mapHandleToLock.set(l,a),P&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${r})`),P.dispose())}return l}async close(d){const t=this.mapHandleToLock.get(d);try{if(this.mapHandleToPos.delete(d),this.writeHandles.delete(d)&&I.canFlush)try{await v.Promises.fdatasync(d)}catch(o){I.configureFlushOnWrite(!1),this.logService.error(o)}return await v.Promises.close(d)}catch(o){throw this.toFileSystemProviderError(o)}finally{t&&(this.mapHandleToLock.get(d)===t&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.mapHandleToLock.delete(d)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),t.dispose())}}async read(d,t,o,r,a){const l=this.normalizePos(d,t);let P=null;try{P=(await v.Promises.read(d,o,r,a,l)).bytesRead}catch(y){throw this.toFileSystemProviderError(y)}finally{this.updatePos(d,l,P)}return P}normalizePos(d,t){return t===this.mapHandleToPos.get(d)?null:t}updatePos(d,t,o){const r=this.mapHandleToPos.get(d);typeof r=="number"&&(typeof t=="number"||(typeof o=="number"?this.mapHandleToPos.set(d,r+o):this.mapHandleToPos.delete(d)))}async write(d,t,o,r,a){return(0,s.retry)(()=>this.doWrite(d,t,o,r,a),100,3)}async doWrite(d,t,o,r,a){const l=this.normalizePos(d,t);let P=null;try{P=(await v.Promises.write(d,o,r,a,l)).bytesWritten}catch(y){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(d),y)}finally{this.updatePos(d,l,P)}return P}async mkdir(d){try{await n.promises.mkdir(this.toFilePath(d))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(d,t){try{const o=this.toFilePath(d);if(t.recursive){let r;t?.atomic!==!1&&t.atomic.postfix&&(r=(0,c.join)((0,c.dirname)(o),`${(0,c.basename)(o)}${t.atomic.postfix}`)),await v.Promises.rm(o,v.RimRafMode.MOVE,r)}else try{await n.promises.unlink(o)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:l,symbolicLink:P}=await v.SymlinkSupport.stat(o);a=l.isDirectory()&&!P}catch{}if(a)await n.promises.rmdir(o);else throw r}else throw r}}catch(o){throw this.toFileSystemProviderError(o)}}async rename(d,t,o){const r=this.toFilePath(d),a=this.toFilePath(t);if(r!==a)try{await this.validateMoveCopy(d,t,"move",o.overwrite),await v.Promises.rename(r,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,h.localize)(11378,null,(0,c.basename)(r),(0,c.basename)((0,c.dirname)(a)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(d,t,o){const r=this.toFilePath(d),a=this.toFilePath(t);if(r!==a)try{await this.validateMoveCopy(d,t,"copy",o.overwrite),await v.Promises.copy(r,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,h.localize)(11379,null,(0,c.basename)(r),(0,c.basename)((0,c.dirname)(a)),l.toString()))),this.toFileSystemProviderError(l)}}async validateMoveCopy(d,t,o,r){const a=this.toFilePath(d),l=this.toFilePath(t);let P=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(P=(0,R.isEqual)(a,l,!0)),P){if(o==="copy")throw(0,g.createFileSystemProviderError)((0,h.localize)(11380,null),g.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const k=await this.statIgnoreError(d);if(!k)throw(0,g.createFileSystemProviderError)((0,h.localize)(11381,null),g.FileSystemProviderErrorCode.FileNotFound);const T=await this.statIgnoreError(t);if(T){if(!r)throw(0,g.createFileSystemProviderError)((0,h.localize)(11382,null),g.FileSystemProviderErrorCode.FileExists);k.type&g.FileType.File&&T.type&g.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,t){return this.doCloneFile(d,t,!1)}async doCloneFile(d,t,o){const r=this.toFilePath(d),a=this.toFilePath(t),l=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.isEqual)(r,a,!l))return;const P=new w.DisposableStore;try{P.add(await this.createResourceLock(d)),P.add(await this.createResourceLock(t)),o&&await n.promises.mkdir((0,c.dirname)(a),{recursive:!0}),await n.promises.copyFile(r,a)}catch(y){if(y.code==="ENOENT"&&!o)return this.doCloneFile(d,t,!0);throw this.toFileSystemProviderError(y)}finally{P.dispose()}}createUniversalWatcher(d,t,o){return new p.UniversalWatcherClient(r=>d(r),r=>t(r),o)}createNonRecursiveWatcher(d,t,o){return new D.NodeJSWatcherClient(r=>d(r),r=>t(r),o)}toFileSystemProviderError(d){if(d instanceof g.FileSystemProviderError)return d;let t=d,o;switch(d.code){case"ENOENT":o=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=g.FileSystemProviderErrorCode.Unknown;break;default:o=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(t,o)}async toFileSystemProviderWriteError(d,t){let o=this.toFileSystemProviderError(t);if(d&&o.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await v.SymlinkSupport.stat(this.toFilePath(d));r.mode&128||(o=(0,g.createFileSystemProviderError)(t,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return o}}e.DiskFileSystemProvider=I}),define(ce[190],le([0,1,4,99,2,17,67,22]),function(V,e,n,s,b,M,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends b.Disposable{constructor(u,f){super(),this.provider=u,this.logService=f,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(u,f,v){const h=this.getUriTransformer(u);switch(f){case"stat":return this.stat(h,v[0]);case"readdir":return this.readdir(h,v[0]);case"open":return this.open(h,v[0],v[1]);case"close":return this.close(v[0]);case"read":return this.read(v[0],v[1],v[2]);case"readFile":return this.readFile(h,v[0],v[1]);case"write":return this.write(v[0],v[1],v[2],v[3],v[4]);case"writeFile":return this.writeFile(h,v[0],v[1],v[2]);case"rename":return this.rename(h,v[0],v[1],v[2]);case"copy":return this.copy(h,v[0],v[1],v[2]);case"cloneFile":return this.cloneFile(h,v[0],v[1]);case"mkdir":return this.mkdir(h,v[0]);case"delete":return this.delete(h,v[0],v[1]);case"watch":return this.watch(h,v[0],v[1],v[2],v[3]);case"unwatch":return this.unwatch(v[0],v[1])}throw new Error(`IPC Command ${f} not found`)}listen(u,f,v){const h=this.getUriTransformer(u);switch(f){case"fileChange":return this.onFileChange(h,v[0]);case"readFileStream":return this.onReadFileStream(h,v[0],v[1])}throw new Error(`Unknown event ${f}`)}stat(u,f){const v=this.transformIncoming(u,f,!0);return this.provider.stat(v)}readdir(u,f){const v=this.transformIncoming(u,f);return this.provider.readdir(v)}async readFile(u,f,v){const h=this.transformIncoming(u,f,!0),g=await this.provider.readFile(h,v);return M.VSBuffer.wrap(g)}onReadFileStream(u,f,v){const h=this.transformIncoming(u,f,!0),g=new R.CancellationTokenSource,E=new n.Emitter({onDidRemoveLastListener:()=>{g.cancel()}}),S=this.provider.readFileStream(h,v,g.token);return(0,L.listenStream)(S,{onData:p=>E.fire(M.VSBuffer.wrap(p)),onError:p=>E.fire(p),onEnd:()=>{E.fire("end"),E.dispose(),g.dispose()}}),E.event}writeFile(u,f,v,h){const g=this.transformIncoming(u,f);return this.provider.writeFile(g,v.buffer,h)}open(u,f,v){const h=this.transformIncoming(u,f,!0);return this.provider.open(h,v)}close(u){return this.provider.close(u)}async read(u,f,v){const h=M.VSBuffer.alloc(v),E=await this.provider.read(u,f,h.buffer,0,v);return[h,E]}write(u,f,v,h,g){return this.provider.write(u,f,v.buffer,h,g)}mkdir(u,f){const v=this.transformIncoming(u,f);return this.provider.mkdir(v)}delete(u,f,v){const h=this.transformIncoming(u,f);return this.provider.delete(h,v)}rename(u,f,v,h){const g=this.transformIncoming(u,f),E=this.transformIncoming(u,v);return this.provider.rename(g,E,h)}copy(u,f,v,h){const g=this.transformIncoming(u,f),E=this.transformIncoming(u,v);return this.provider.copy(g,E,h)}cloneFile(u,f,v){const h=this.transformIncoming(u,f),g=this.transformIncoming(u,v);return this.provider.cloneFile(h,g)}onFileChange(u,f){const v=new n.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(f,this.createSessionFileWatcher(u,v))},onDidRemoveLastListener:()=>{(0,b.dispose)(this.sessionToWatcher.get(f)),this.sessionToWatcher.delete(f)}});return v.event}async watch(u,f,v,h,g){const E=this.sessionToWatcher.get(f);if(E){const S=this.transformIncoming(u,h),p=E.watch(v,S,g);this.watchRequests.set(f+v,p)}}async unwatch(u,f){const v=u+f,h=this.watchRequests.get(v);h&&((0,b.dispose)(h),this.watchRequests.delete(v))}dispose(){super.dispose();for(const[,u]of this.watchRequests)u.dispose();this.watchRequests.clear();for(const[,u]of this.sessionToWatcher)u.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class c extends b.Disposable{constructor(u,f,v,h){super(),this.uriTransformer=u,this.logService=v,this.environmentService=h,this.watcherRequests=new Map,this.fileWatcher=this._register(new s.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(f)}registerListeners(u){const f=this._register(new n.Emitter);this._register(f.event(v=>{u.fire(v.map(h=>({resource:this.uriTransformer.transformOutgoingURI(h.resource),type:h.type,cId:h.cId})))})),this._register(this.fileWatcher.onDidChangeFile(v=>f.fire(v))),this._register(this.fileWatcher.onDidWatchError(v=>u.fire(v)))}getRecursiveWatcherOptions(u){}getExtraExcludes(u){}watch(u,f,v){const h=this.getExtraExcludes(this.environmentService);return Array.isArray(h)&&(v.excludes=[...v.excludes,...h]),this.watcherRequests.set(u,this.fileWatcher.watch(f,v)),(0,b.toDisposable)(()=>{(0,b.dispose)(this.watcherRequests.get(u)),this.watcherRequests.delete(u)})}dispose(){for(const[,u]of this.watcherRequests)u.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=c}),define(ce[191],le([0,1,13,10,3,7,14,9,190,151,55]),function(V,e,n,s,b,M,L,R,w,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class u extends w.AbstractDiskFileSystemProviderChannel{constructor(h,g,E){super(h,g),this.environmentService=E}getUriTransformer(h){return c.DefaultURITransformer}transformIncoming(h,g){return M.URI.revive(g)}async delete(h,g,E){if(!E.useTrash)return super.delete(h,g,E);const S=this.transformIncoming(h,g),p=(0,R.normalize)(S.fsPath);try{await n.shell.trashItem(p)}catch(D){throw(0,L.createFileSystemProviderError)(b.isWindows?(0,s.localize)(11383,null,(0,R.basename)(p),(0,m.toErrorMessage)(D)):(0,s.localize)(11384,null,(0,R.basename)(p),(0,m.toErrorMessage)(D)),L.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(h,g){return new f(h,g,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=u;class f extends w.AbstractSessionFileWatcher{watch(h,g,E){if(E.recursive)throw(0,L.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",L.FileSystemProviderErrorCode.Unavailable);return super.watch(h,g,E)}}}),define(ce[192],le([0,1,5]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class s extends n.AbstractMessageLogger{constructor(M=n.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(L=>{this._logger?.setLevel(L)}))}set logger(M){this._logger=M;for(const{level:L,message:R}of this.buffer)(0,n.log)(M,L,R);this.buffer=[]}log(M,L){this._logger?(0,n.log)(this._logger,M,L):this.getLevel()<=M&&this.buffer.push({level:M,message:L})}dispose(){this._logger?.dispose(),super.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=s}),define(ce[193],le([0,1,7,4,5,2]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class L extends b.AbstractLoggerService{constructor(u,f,v,h,g){super(f,v,h),this.windowId=u,this.channel=g,this._register(g.listen("onDidChangeLogLevel",u)(E=>{(0,b.isLogLevel)(E)?super.setLogLevel(E):super.setLogLevel(n.URI.revive(E[0]),E[1])})),this._register(g.listen("onDidChangeVisibility",u)(([E,S])=>super.setVisibility(n.URI.revive(E),S))),this._register(g.listen("onDidChangeLoggers",u)(({added:E,removed:S})=>{for(const p of E)super.registerLogger({...p,resource:n.URI.revive(p.resource)});for(const p of S)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new b.AdapterLogger({log:(u,f)=>{this.channel.call("consoleLog",[u,f])}})}registerLogger(u){super.registerLogger(u),this.channel.call("registerLogger",[u,this.windowId])}deregisterLogger(u){super.deregisterLogger(u),this.channel.call("deregisterLogger",[u,this.windowId])}setLogLevel(u,f){super.setLogLevel(u,f),this.channel.call("setLogLevel",[u,f])}setVisibility(u,f){super.setVisibility(u,f),this.channel.call("setVisibility",[this.toResource(u),f])}doCreateLogger(u,f,v){return new R(this.channel,u,f,v,this.windowId)}static setLogLevel(u,f,v){return u.call("setLogLevel",[f,v])}}e.LoggerChannelClient=L;class R extends b.AbstractMessageLogger{constructor(u,f,v,h,g){super(h?.logLevel==="always"),this.channel=u,this.file=f,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(v),this.channel.call("createLogger",[f,h,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(u,f){const v=[[u,f]];this.isLoggerCreated?this.doLog(v):this.buffer.push(...v)}doLog(u){this.channel.call("log",[this.file,u])}}class w{constructor(u,f){this.loggerService=u,this.getUriTransformer=f}listen(u,f){const v=this.getUriTransformer(u);switch(f){case"onDidChangeLoggers":return s.Event.map(this.loggerService.onDidChangeLoggers,h=>({added:[...h.added].map(g=>this.transformLogger(g,v)),removed:[...h.removed].map(g=>this.transformLogger(g,v))}));case"onDidChangeVisibility":return s.Event.map(this.loggerService.onDidChangeVisibility,h=>[v.transformOutgoingURI(h[0]),h[1]]);case"onDidChangeLogLevel":return s.Event.map(this.loggerService.onDidChangeLogLevel,h=>(0,b.isLogLevel)(h)?h:[v.transformOutgoingURI(h[0]),h[1]])}throw new Error(`Event not found: ${f}`)}async call(u,f,v){const h=this.getUriTransformer(u);switch(f){case"setLogLevel":return(0,b.isLogLevel)(v[0])?this.loggerService.setLogLevel(v[0]):this.loggerService.setLogLevel(n.URI.revive(h.transformIncoming(v[0][0])),v[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(g=>this.transformLogger(g,h)))}throw new Error(`Call not found: ${f}`)}transformLogger(u,f){return{...u,resource:f.transformOutgoingURI(u.resource)}}}e.LoggerChannel=w;class c extends M.Disposable{constructor(u,f){super(),f.call("setLogLevel",[u.getLogLevel()]),this._register(u.onDidChangeLogLevel(v=>f.call("setLogLevel",[v]))),f.call("getRegisteredLoggers").then(v=>{for(const h of v)u.registerLogger({...h,resource:n.URI.revive(h.resource)})}),this._register(f.listen("onDidChangeVisibility")(([v,h])=>u.setVisibility(n.URI.revive(v),h))),this._register(f.listen("onDidChangeLoggers")(({added:v,removed:h})=>{for(const g of v)u.registerLogger({...g,resource:n.URI.revive(g.resource)});for(const g of h)u.deregisterLogger(g.resource)}))}}e.RemoteLoggerChannelClient=c}),define(ce[194],le([0,1,2,5]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class b extends n.Disposable{constructor(L,R=[]){super(),this.logger=new s.MultiplexLogger([L,...R]),this._register(L.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(L){this.logger.setLevel(L)}getLevel(){return this.logger.getLevel()}trace(L,...R){this.logger.trace(L,...R)}debug(L,...R){this.logger.debug(L,...R)}info(L,...R){this.logger.info(L,...R)}warn(L,...R){this.logger.warn(L,...R)}error(L,...R){this.logger.error(L,...R)}flush(){this.logger.flush()}}e.LogService=b}),define(ce[195],le([0,1,31,7,5]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class M{constructor(R){this.loggerService=R,this.loggers=new n.ResourceMap}listen(R,w,c){switch(w){case"onDidChangeLoggers":return c?this.loggerService.getOnDidChangeLoggersEvent(c):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.loggerService.getOnDidChangeLogLevelEvent(c):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.loggerService.getOnDidChangeVisibilityEvent(c):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${w}`)}async call(R,w,c){switch(w){case"createLogger":this.createLogger(s.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.log(s.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1]);case"setLogLevel":return(0,b.isLogLevel)(c[0])?this.loggerService.setLogLevel(c[0]):this.loggerService.setLogLevel(s.URI.revive(c[0]),c[1]);case"setVisibility":return this.loggerService.setVisibility(s.URI.revive(c[0]),c[1]);case"registerLogger":return this.loggerService.registerLogger({...c[0],resource:s.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(s.URI.revive(c[0]))}throw new Error(`Call not found: ${w}`)}createLogger(R,w,c){this.loggers.set(R,this.loggerService.createLogger(R,w,c))}consoleLog(R,w){let c=console.log;switch(R){case b.LogLevel.Error:c=console.error;break;case b.LogLevel.Warning:c=console.warn;break;case b.LogLevel.Info:c=console.info;break}c.call(console,...w)}log(R,w){const c=this.loggers.get(R);if(!c)throw new Error("Create the logger before logging");for(const[m,u]of w)(0,b.log)(c,m,u)}}e.LoggerChannel=M}),define(ce[196],le([0,1,14,5]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var b;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(b||(b={}));async function M(c,m,u,f,v){try{const h=await new Promise((E,S)=>{V(["@vscode/spdlog"],E,S)}).then(De);h.setFlushOn(b.Trace);const g=await h.createAsyncRotatingLogger(c,m,u,f);return v?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(h){console.error(h)}return null}function L(c,m,u){switch(m){case s.LogLevel.Trace:c.trace(u);break;case s.LogLevel.Debug:c.debug(u);break;case s.LogLevel.Info:c.info(u);break;case s.LogLevel.Warning:c.warn(u);break;case s.LogLevel.Error:c.error(u);break;case s.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function R(c,m){switch(m){case s.LogLevel.Trace:c.setLevel(b.Trace);break;case s.LogLevel.Debug:c.setLevel(b.Debug);break;case s.LogLevel.Info:c.setLevel(b.Info);break;case s.LogLevel.Warning:c.setLevel(b.Warning);break;case s.LogLevel.Error:c.setLevel(b.Error);break;case s.LogLevel.Off:c.setLevel(b.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class w extends s.AbstractMessageLogger{constructor(m,u,f,v,h){super(),this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(m,u,f,v),this._register(this.onDidChangeLogLevel(g=>{this._logger&&R(this._logger,g)}))}async _createSpdLogLogger(m,u,f,v){const h=f?6:1,g=30/h*n.ByteSize.MB,E=await M(m,u,g,h,v);if(E){this._logger=E,R(this._logger,this.getLevel());for(const{level:S,message:p}of this.buffer)L(this._logger,S,p);this.buffer=[]}}log(m,u){this._logger?L(this._logger,m,u):this.getLevel()<=m&&this.buffer.push({level:m,message:u})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=w}),define(ce[197],le([0,1,33,5,196]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class M extends s.AbstractLoggerService{doCreateLogger(R,w,c){return new b.SpdLogLogger((0,n.generateUuid)(),R.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,w)}}e.LoggerService=M}),define(ce[71],le([0,1,31,4,6,5,197]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,b.refineServiceDecorator)(M.ILoggerService);class R extends L.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new n.ResourceMap}createLogger(c,m,u){u!==void 0&&this.loggerResourcesByWindow.set(this.toResource(c),u);try{return super.createLogger(c,m)}catch(f){throw this.loggerResourcesByWindow.delete(this.toResource(c)),f}}registerLogger(c,m){m!==void 0&&this.loggerResourcesByWindow.set(c.resource,m),super.registerLogger(c)}deregisterLogger(c){this.loggerResourcesByWindow.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const m=[];for(const u of super.getRegisteredLoggers())c===this.loggerResourcesByWindow.get(u.resource)&&m.push(u);return m}getOnDidChangeLogLevelEvent(c){return s.Event.filter(this.onDidChangeLogLevel,m=>(0,M.isLogLevel)(m)||this.isInterestedLoggerResource(m[0],c))}getOnDidChangeVisibilityEvent(c){return s.Event.filter(this.onDidChangeVisibility,([m])=>this.isInterestedLoggerResource(m,c))}getOnDidChangeLoggersEvent(c){return s.Event.filter(s.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(f=>this.isInterestedLoggerResource(f.resource,c)),removed:[...m.removed].filter(f=>this.isInterestedLoggerResource(f.resource,c))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(c){for(const[m,u]of this.loggerResourcesByWindow)u===c&&this.deregisterLogger(m)}isInterestedLoggerResource(c,m){const u=this.loggerResourcesByWindow.get(c);return u===void 0||u===m}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=R}),define(ce[198],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemSubmenu=n,e.isMenubarMenuItemSeparator=s,e.isMenubarMenuItemRecentAction=b,e.isMenubarMenuItemAction=M;function n(L){return L.submenu!==void 0}function s(L){return L.id==="vscode.menubar.separator"}function b(L){return L.uri!==void 0}function M(L){return!n(L)&&!s(L)&&!b(L)}}),define(ce[40],le([0,1,4,77,2,6]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,M.createDecorator)("policy");class L extends b.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(c){const m=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...c,...this.policyDefinitions},m!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(c),s.Iterable.reduce(this.policies.entries(),(u,[f,v])=>({...u,[f]:v}),{})}getPolicyValue(c){return this.policies.get(c)}serialize(){return s.Iterable.reduce(Object.entries(this.policyDefinitions),(c,[m,u])=>({...c,[m]:{definition:u,value:this.policies.get(m)}}),{})}}e.AbstractPolicyService=L;class R{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(ce[199],le([0,1,8,4,77,11,14,5,40]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(u,f){const v=[];for(const h of new Set(b.Iterable.concat(u.keys(),f.keys())))u.get(h)!==f.get(h)&&v.push(h);return v}let m=class extends w.AbstractPolicyService{constructor(f,v,h){super(),this.file=f,this.fileService=v,this.logService=h,this.throttledDelayer=this._register(new n.ThrottledDelayer(500));const g=s.Event.filter(v.onDidFilesChange,E=>E.affects(f));this._register(v.watch(f)),this._register(g(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const f=new Map;try{const v=await this.fileService.readFile(this.file),h=JSON.parse(v.value.toString());if(!(0,M.isObject)(h))throw new Error("Policy file isn't a JSON object");for(const g of Object.keys(h))this.policyDefinitions[g]&&f.set(g,h[g])}catch(v){v.fileOperationResult!==L.FileOperationResult.FILE_NOT_FOUND&&this.logService.error("[FilePolicyService] Failed to read policies",v)}return f}async refresh(){const f=await this.read(),v=c(this.policies,f);this.policies=f,v.length>0&&this._onDidChange.fire(v)}};e.FilePolicyService=m,e.FilePolicyService=m=Ie([re(1,L.IFileService),re(2,R.ILogService)],m)}),define(ce[200],le([0,1,4,2,40]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class M{constructor(w){this.service=w,this.disposables=new s.DisposableStore}listen(w,c){switch(c){case"onDidChange":return n.Event.map(this.service.onDidChange,m=>m.reduce((u,f)=>({...u,[f]:this.service.getPolicyValue(f)??null}),{}),this.disposables)}throw new Error(`Event not found: ${c}`)}call(w,c,m){switch(c){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${c}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=M;class L extends b.AbstractPolicyService{constructor(w,c){super(),this.channel=c;for(const m in w){const{definition:u,value:f}=w[m];this.policyDefinitions[m]=u,f!==void 0&&this.policies.set(m,f)}this.channel.listen("onDidChange")(m=>{for(const u in m){const f=m[u];f===null?this.policies.delete(u):this.policies.set(u,f)}this._onDidChange.fire(Object.keys(m))})}async _updatePolicyDefinitions(w){const c=await this.channel.call("updatePolicyDefinitions",w);for(const m in c)this.policies.set(m,c[m])}}e.PolicyChannelClient=L}),define(ce[201],le([0,1,40,8,2,5]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let L=class extends n.AbstractPolicyService{constructor(w,c){super(),this.logService=w,this.productName=c,this.throttler=new s.Throttler,this.watcher=this._register(new b.MutableDisposable)}async _updatePolicyDefinitions(w){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(w).length} policy definitions`);const{createWatcher:c}=await new Promise((m,u)=>{V(["@vscode/policy-watcher"],m,u)}).then(De);await this.throttler.queue(()=>new Promise((m,u)=>{try{this.watcher.value=c(this.productName,w,f=>{this._onDidPolicyChange(f),m()})}catch(f){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",f),u(f)}}))}_onDidPolicyChange(w){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(w)}`);for(const c in w){const m=w[c];m===void 0?this.policies.delete(c):this.policies.set(c,m)}this._onDidChange.fire(Object.keys(w))}};e.NativePolicyService=L,e.NativePolicyService=L=Ie([re(0,M.ILogService)],L)}),define(ce[72],le([0,1,36]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;const b=globalThis.vscode;if(typeof b<"u"&&typeof b.context<"u"){const M=b.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){s=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:M,searchUrl:L,itemUrl:R,controlUrl:w}=s.extensionsGallery||{};Object.assign(s,{extensionsGallery:{serviceUrl:n.env.VSCODE_GALLERY_SERVICE_URL||M,searchUrl:n.env.VSCODE_GALLERY_SEARCH_URL||L,itemUrl:n.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:n.env.VSCODE_GALLERY_CONTROL_URL||w}});try{const c=(...u)=>u.reduce((f,v)=>(Object.keys(v).forEach(h=>{Array.isArray(f[h])&&Array.isArray(v[h])?f[h]=v[h]:typeof f[h]=="object"&&typeof v[h]=="object"?f[h]=c(f[h],v[h]):f[h]=v[h]}),f),{}),m=globalThis._VSCODE_USER_PRODUCT_JSON||{};s=c(s,m)}catch{}if(n.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const c=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:c.version,release:c.release})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ce[28],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ce[202],le([0,1,8,5]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let b=class{constructor(L,R,w){this._window=L,this._sessionId=R,this._logService=w}async inspect(L){await this._connect();const R=this._window.webContents.debugger;await R.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,n.timeout)(L);const w=await R.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),w.profile}async _connect(){const L=this._window.webContents.debugger;L.attach(),await L.sendCommand("Profiler.enable")}async _disconnect(){const L=this._window.webContents.debugger;await L.sendCommand("Profiler.disable"),L.detach()}};e.WindowProfiler=b,e.WindowProfiler=b=Ie([re(2,s.ILogService)],b)}),define(ce[73],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,n.createDecorator)("protocolMainService")}),define(ce[45],le([0,1,141,11]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,n=De(n),s=De(s);class b{constructor(){this.data=new Map}add(L,R){n.ok(s.isString(L)),n.ok(s.isObject(R)),n.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,R)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new b}),define(ce[203],le([0,1,4,143,45]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,b=De(b),e.Extensions={JSONContribution:"base.contributions.json"};function M(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class L{constructor(){this._onDidChangeSchema=new n.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,m){this.schemasById[M(c)]=m,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(c){const m=this.schemasById[c];return m?(0,s.getCompressedContent)(m):void 0}hasSchemaContent(c){return!!this.schemasById[c]}}const R=new L;b.Registry.add(e.Extensions.JSONContribution,R)}),define(ce[56],le([0,1,21,4,11,10,16,203,45]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=g,e.keyFromOverrideIdentifiers=E,e.getDefaultValue=S,e.validateProperty=D,e.getScopes=I,e.getAllConfigurationProperties=i,e.parseScope=d,b=De(b),M=De(M);var c;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const u=w.Registry.as(R.Extensions.JSONContribution);class f{constructor(){this.registeredConfigurationDefaults=[],this.overrideIdentifiers=new Set,this._onDidSchemaChange=new s.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new s.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(11612,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,r=!0){this.registerConfigurations([o],r)}registerConfigurations(o,r=!0){const a=new Set;this.doRegisterConfigurations(o,r,a),u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(o){const r=new Set;this.doDeregisterConfigurations(o,r),u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:o,remove:r}){const a=new Set;this.doDeregisterConfigurations(r,a),this.doRegisterConfigurations(o,!1,a),u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}registerDefaultConfigurations(o){const r=new Set;this.doRegisterDefaultConfigurations(o,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doRegisterDefaultConfigurations(o,r){this.registeredConfigurationDefaults.push(...o);const a=[];for(const{overrides:l,source:P}of o)for(const y in l){r.add(y);const k=this.configurationDefaultsOverrides.get(y)??this.configurationDefaultsOverrides.set(y,{configurationDefaultOverrides:[]}).get(y),T=l[y];if(k.configurationDefaultOverrides.push({value:T,source:P}),e.OVERRIDE_PROPERTY_REGEX.test(y)){const A=this.mergeDefaultConfigurationsForOverrideIdentifier(y,T,P,k.configurationDefaultOverrideValue);if(!A)continue;k.configurationDefaultOverrideValue=A,this.updateDefaultOverrideProperty(y,A,P),a.push(...g(y))}else{const A=this.mergeDefaultConfigurationsForConfigurationProperty(y,T,P,k.configurationDefaultOverrideValue);if(!A)continue;k.configurationDefaultOverrideValue=A;const C=this.configurationProperties[y];C&&(this.updatePropertyDefaultValue(y,C),this.updateSchema(y,C))}}this.doRegisterOverrideIdentifiers(a)}deregisterDefaultConfigurations(o){const r=new Set;this.doDeregisterDefaultConfigurations(o,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(o,r){for(const a of o){const l=this.registeredConfigurationDefaults.indexOf(a);l!==-1&&this.registeredConfigurationDefaults.splice(l,1)}for(const{overrides:a,source:l}of o)for(const P in a){const y=this.configurationDefaultsOverrides.get(P);if(!y)continue;const k=y.configurationDefaultOverrides.findIndex(T=>l?T.source?.id===l.id:T.value===a[P]);if(k!==-1){if(y.configurationDefaultOverrides.splice(k,1),y.configurationDefaultOverrides.length===0&&this.configurationDefaultsOverrides.delete(P),e.OVERRIDE_PROPERTY_REGEX.test(P)){let T;for(const A of y.configurationDefaultOverrides)T=this.mergeDefaultConfigurationsForOverrideIdentifier(P,A.value,A.source,T);T&&!b.isEmptyObject(T.value)?(y.configurationDefaultOverrideValue=T,this.updateDefaultOverrideProperty(P,T,l)):(this.configurationDefaultsOverrides.delete(P),delete this.configurationProperties[P],delete this.defaultLanguageConfigurationOverridesNode.properties[P])}else{let T;for(const C of y.configurationDefaultOverrides)T=this.mergeDefaultConfigurationsForConfigurationProperty(P,C.value,C.source,T);y.configurationDefaultOverrideValue=T;const A=this.configurationProperties[P];A&&(this.updatePropertyDefaultValue(P,A),this.updateSchema(P,A))}r.add(P)}}this.updateOverridePropertyPatternKey()}updateDefaultOverrideProperty(o,r,a){const l={type:"object",default:r.value,description:M.localize(11613,null,(0,L.getLanguageTagSettingPlainKey)(o)),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:r.value,source:a,defaultValueSource:a};this.configurationProperties[o]=l,this.defaultLanguageConfigurationOverridesNode.properties[o]=l}mergeDefaultConfigurationsForOverrideIdentifier(o,r,a,l){const P=l?.value||{},y=l?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const k of Object.keys(r)){const T=r[k];if(b.isObject(T)&&(b.isUndefined(P[k])||b.isObject(P[k]))){if(P[k]={...P[k]??{},...T},a)for(const C in T)y.set(`${k}.${C}`,a)}else P[k]=T,a?y.set(k,a):y.delete(k)}return{value:P,source:y}}mergeDefaultConfigurationsForConfigurationProperty(o,r,a,l){const P=this.configurationProperties[o],y=l?.value??P?.defaultDefaultValue;let k=a;if(b.isObject(r)&&(P!==void 0&&P.type==="object"||P===void 0&&(b.isUndefined(y)||b.isObject(y)))){if(k=l?.source??new Map,!(k instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in r)a&&k.set(`${o}.${A}`,a);r={...b.isObject(y)?y:{},...r}}return{value:r,source:k}}deltaConfiguration(o){let r=!1;const a=new Set;o.removedDefaults&&(this.doDeregisterDefaultConfigurations(o.removedDefaults,a),r=!0),o.addedDefaults&&(this.doRegisterDefaultConfigurations(o.addedDefaults,a),r=!0),o.removedConfigurations&&this.doDeregisterConfigurations(o.removedConfigurations,a),o.addedConfigurations&&this.doRegisterConfigurations(o.addedConfigurations,!1,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){this.doRegisterOverrideIdentifiers(o),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(o){for(const r of o)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,r,a){o.forEach(l=>{this.validateAndRegisterProperties(l,r,l.extensionInfo,l.restrictedProperties,void 0,a),this.configurationContributors.push(l),this.registerJSONConfiguration(l)})}doDeregisterConfigurations(o,r){const a=l=>{if(l.properties)for(const P in l.properties){r.add(P);const y=this.configurationProperties[P];y?.policy?.name&&this.policyConfigurations.delete(y.policy.name),delete this.configurationProperties[P],this.removeFromSchema(P,l.properties[P])}l.allOf?.forEach(P=>a(P))};for(const l of o){a(l);const P=this.configurationContributors.indexOf(l);P!==-1&&this.configurationContributors.splice(P,1)}}validateAndRegisterProperties(o,r=!0,a,l,P=m.WINDOW,y){P=b.isUndefinedOrNull(o.scope)?P:o.scope;const k=o.properties;if(k)for(const A in k){const C=k[A];if(r&&D(A,C)){delete k[A];continue}if(C.source=a,C.defaultDefaultValue=k[A].default,this.updatePropertyDefaultValue(A,C),e.OVERRIDE_PROPERTY_REGEX.test(A)?C.scope=void 0:(C.scope=b.isUndefinedOrNull(C.scope)?P:C.scope,C.restricted=b.isUndefinedOrNull(C.restricted)?!!l?.includes(A):C.restricted),k[A].hasOwnProperty("included")&&!k[A].included){this.excludedConfigurationProperties[A]=k[A],delete k[A];continue}else this.configurationProperties[A]=k[A],k[A].policy?.name&&this.policyConfigurations.set(k[A].policy.name,A);!k[A].deprecationMessage&&k[A].markdownDeprecationMessage&&(k[A].deprecationMessage=k[A].markdownDeprecationMessage),y.add(A)}const T=o.allOf;if(T)for(const A of T)this.validateAndRegisterProperties(A,r,a,l,P,y)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getRegisteredDefaultConfigurations(){return[...this.registeredConfigurationDefaults]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[r,a]of this.configurationDefaultsOverrides)a.configurationDefaultOverrideValue&&o.set(r,a.configurationDefaultOverrideValue);return o}registerJSONConfiguration(o){const r=a=>{const l=a.properties;if(l)for(const y in l)this.updateSchema(y,l[y]);a.allOf?.forEach(r)};r(o)}updateSchema(o,r){switch(e.allSettings.properties[o]=r,r.scope){case m.APPLICATION:e.applicationSettings.properties[o]=r;break;case m.MACHINE:e.machineSettings.properties[o]=r;break;case m.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[o]=r;break;case m.WINDOW:e.windowSettings.properties[o]=r;break;case m.RESOURCE:e.resourceSettings.properties[o]=r;break;case m.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[o]=r,this.resourceLanguageSettingsSchema.properties[o]=r;break}}removeFromSchema(o,r){switch(delete e.allSettings.properties[o],r.scope){case m.APPLICATION:delete e.applicationSettings.properties[o];break;case m.MACHINE:delete e.machineSettings.properties[o];break;case m.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[o];break;case m.WINDOW:delete e.windowSettings.properties[o];break;case m.RESOURCE:case m.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const r=`[${o}]`,a={type:"object",description:M.localize(11614,null),errorMessage:M.localize(11615,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}}registerOverridePropertyPatternKey(){const o={type:"object",description:M.localize(11616,null),errorMessage:M.localize(11617,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,r){const a=this.configurationDefaultsOverrides.get(o)?.configurationDefaultOverrideValue;let l,P;a&&(!r.disallowConfigurationDefault||!a.source)&&(l=a.value,P=a.source),b.isUndefined(l)&&(l=r.defaultDefaultValue,P=void 0),b.isUndefined(l)&&(l=S(r.type)),r.default=l,r.defaultValueSource=P}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(t){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(t)){let r=h.exec(t);for(;r?.length;){const a=r[1].trim();a&&o.push(a),r=h.exec(t)}}return(0,n.distinct)(o)}function E(t){return t.reduce((o,r)=>`${o}[${r}]`,"")}function S(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new f;w.Registry.add(e.Extensions.Configuration,p);function D(t,o){return t.trim()?e.OVERRIDE_PROPERTY_REGEX.test(t)?M.localize(11619,null,t):p.getConfigurationProperties()[t]!==void 0?M.localize(11620,null,t):o.policy?.name&&p.getPolicyConfigurations().get(o.policy?.name)!==void 0?M.localize(11621,null,t,o.policy?.name,p.getPolicyConfigurations().get(o.policy?.name)):null:M.localize(11618,null)}function I(){const t=[],o=p.getConfigurationProperties();for(const r of Object.keys(o))t.push([r,o[r].scope]);return t.push(["launch",m.RESOURCE]),t.push(["task",m.RESOURCE]),t}function i(t){const o={};for(const r of t){const a=r.properties;if(b.isObject(a))for(const l in a)o[l]=a[l];r.allOf&&Object.assign(o,i(r.allOf))}return o}function d(t){switch(t){case"application":return m.APPLICATION;case"machine":return m.MACHINE;case"resource":return m.RESOURCE;case"machine-overridable":return m.MACHINE_OVERRIDABLE;case"language-overridable":return m.LANGUAGE_OVERRIDABLE;default:return m.WINDOW}}}),define(ce[125],le([0,1,21,4,43,2,31,37,11,7,16,56,14,45]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=I,n=De(n),b=De(b),R=De(R),w=De(w);function h(o){return Object.isFrozen(o)?o:R.deepFreeze(o)}class g{static createEmptyModel(r){return new g({},[],[],void 0,r)}constructor(r,a,l,P,y){this._contents=r,this._keys=a,this._overrides=l,this.raw=P,this.logService=y,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof g)return a;const l=new E("",this.logService);return l.parseRaw(a),l.configurationModel});this._rawConfiguration=r.reduce((a,l)=>l===a?l:a.merge(l),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,m.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const l=this;return{get value(){return h(l.rawConfiguration.getValue(r))},get override(){return a?h(l.rawConfiguration.getOverrideValue(r,a)):void 0},get merged(){return h(a?l.rawConfiguration.override(a).getValue(r):l.rawConfiguration.getValue(r))},get overrides(){const P=[];for(const{contents:y,identifiers:k,keys:T}of l.rawConfiguration.overrides){const A=new g(y,T,[],void 0,l.logService).getValue(r);A!==void 0&&P.push({identifiers:k,value:A})}return P.length?h(P):void 0}}}getOverrideValue(r,a){const l=this.getContentsForOverrideIdentifer(a);return l?r?(0,m.getConfigurationValue)(l,r):l:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const l of this.overrides)l.identifiers.includes(r)&&a.push(...l.keys);return n.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return n.distinct(r)}override(r){let a=this.overrideConfigurations.get(r);return a||(a=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,a)),a}merge(...r){const a=R.deepClone(this.contents),l=R.deepClone(this.overrides),P=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const k of r)if(y.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.mergeContents(a,k.contents);for(const T of k.overrides){const[A]=l.filter(C=>n.equals(C.identifiers,T.identifiers));A?(this.mergeContents(A.contents,T.contents),A.keys.push(...T.keys),A.keys=n.distinct(A.keys)):l.push(R.deepClone(T))}for(const T of k.keys)P.indexOf(T)===-1&&P.push(T)}return new g(a,P,l,y.every(k=>k instanceof g)?void 0:y,this.logService)}createOverrideConfigurationModel(r){const a=this.getContentsForOverrideIdentifer(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const l={};for(const P of n.distinct([...Object.keys(this.contents),...Object.keys(a)])){let y=this.contents[P];const k=a[P];k&&(typeof y=="object"&&typeof k=="object"?(y=R.deepClone(y),this.mergeContents(y,k)):y=k),l[P]=y}return new g(l,this.keys,this.overrides,void 0,this.logService)}mergeContents(r,a){for(const l of Object.keys(a)){if(l in r&&w.isObject(r[l])&&w.isObject(a[l])){this.mergeContents(r[l],a[l]);continue}r[l]=R.deepClone(a[l])}}getContentsForOverrideIdentifer(r){let a=null,l=null;const P=y=>{y&&(l?this.mergeContents(l,y):l=R.deepClone(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===r?a=y.contents:y.identifiers.includes(r)&&P(y.contents);return P(a),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,a){this.updateValue(r,a,!0)}setValue(r,a){this.updateValue(r,a,!1)}removeValue(r){const a=this.keys.indexOf(r);a!==-1&&(this.keys.splice(a,1),(0,m.removeFromValueTree)(this.contents,r),u.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(l=>n.equals(l.identifiers,(0,u.overrideIdentifiersFromKey)(r))),1))}updateValue(r,a,l){if((0,m.addToValueTree)(this.contents,r,a,P=>this.logService.error(P)),l=l||this.keys.indexOf(r)===-1,l&&this.keys.push(r),u.OVERRIDE_PROPERTY_REGEX.test(r)){const P=(0,u.overrideIdentifiersFromKey)(r),y={identifiers:P,keys:Object.keys(this.contents[r]),contents:(0,m.toValuesTree)(this.contents[r],T=>this.logService.error(T))},k=this.overrides.findIndex(T=>n.equals(T.identifiers,P));k!==-1?this.overrides[k]=y:this.overrides.push(y)}}}e.ConfigurationModel=g;class E{constructor(r,a){this._name=r,this.logService=a,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||g.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,a){if(!w.isUndefinedOrNull(r)){const l=this.doParseContent(r);this.parseRaw(l,a)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,a){this._raw=r;const{contents:l,keys:P,overrides:y,restricted:k,hasExcludedProperties:T}=this.doParseRaw(r,a);this._configurationModel=new g(l,P,y,T?[r]:void 0,this.logService),this._restrictedConfigurations=k||[]}doParseContent(r){let a={},l=null,P=[];const y=[],k=[];function T(C){Array.isArray(P)?P.push(C):l!==null&&(P[l]=C)}const A={onObjectBegin:()=>{const C={};T(C),y.push(P),P=C,l=null},onObjectProperty:C=>{l=C},onObjectEnd:()=>{P=y.pop()},onArrayBegin:()=>{const C=[];T(C),y.push(P),P=C,l=null},onArrayEnd:()=>{P=y.pop()},onLiteralValue:T,onError:(C,_,H)=>{k.push({error:C,offset:_,length:H})}};if(r)try{b.visit(r,A),a=P[0]||{}}catch(C){this.logService.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return a}doParseRaw(r,a){const l=v.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),P=this.filter(r,l,!0,a);r=P.raw;const y=(0,m.toValuesTree)(r,A=>this.logService.error(`Conflict in settings file ${this._name}: ${A}`)),k=Object.keys(r),T=this.toOverrides(r,A=>this.logService.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:y,keys:k,overrides:T,restricted:P.restricted,hasExcludedProperties:P.hasExcludedProperties}}filter(r,a,l,P){let y=!1;if(!P?.scopes&&!P?.skipRestricted&&!P?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:y};const k={},T=[];for(const A in r)if(u.OVERRIDE_PROPERTY_REGEX.test(A)&&l){const C=this.filter(r[A],a,!1,P);k[A]=C.raw,y=y||C.hasExcludedProperties,T.push(...C.restricted)}else{const C=a[A],_=C?typeof C.scope<"u"?C.scope:u.ConfigurationScope.WINDOW:void 0;C?.restricted&&T.push(A),!P.exclude?.includes(A)&&(P.include?.includes(A)||(_===void 0||P.scopes===void 0||P.scopes.includes(_))&&!(P.skipRestricted&&C?.restricted))?k[A]=r[A]:y=!0}return{raw:k,restricted:T,hasExcludedProperties:y}}toOverrides(r,a){const l=[];for(const P of Object.keys(r))if(u.OVERRIDE_PROPERTY_REGEX.test(P)){const y={};for(const k in r[P])y[k]=r[P][k];l.push({identifiers:(0,u.overrideIdentifiersFromKey)(P),keys:Object.keys(y),contents:(0,m.toValuesTree)(y,a)})}return l}}e.ConfigurationModelParser=E;class S extends M.Disposable{constructor(r,a,l,P,y){super(),this.userSettingsResource=r,this.parseOptions=a,this.fileService=P,this.logService=y,this._onDidChange=this._register(new s.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString(),y),this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(s.Event.any(s.Event.filter(this.fileService.onDidFilesChange,k=>k.contains(this.userSettingsResource)),s.Event.filter(this.fileService.onDidRunOperation,k=>(k.isOperation(f.FileOperation.CREATE)||k.isOperation(f.FileOperation.COPY)||k.isOperation(f.FileOperation.DELETE)||k.isOperation(f.FileOperation.WRITE))&&l.isEqual(k.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return g.createEmptyModel(this.logService)}}reparse(r){return r&&(this.parseOptions=r),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class p{constructor(r,a,l,P,y,k,T,A,C,_,H,q,K){this.key=r,this.overrides=a,this._value=l,this.overrideIdentifiers=P,this.defaultConfiguration=y,this.policyConfiguration=k,this.applicationConfiguration=T,this.userConfiguration=A,this.localUserConfiguration=C,this.remoteUserConfiguration=_,this.workspaceConfiguration=H,this.folderConfigurationModel=q,this.memoryConfigurationModel=K}get value(){return h(this._value)}toInspectValue(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class D{constructor(r,a,l,P,y,k,T,A,C,_){this._defaultConfiguration=r,this._policyConfiguration=a,this._applicationConfiguration=l,this._localUserConfiguration=P,this._remoteUserConfiguration=y,this._workspaceConfiguration=k,this._folderConfigurations=T,this._memoryConfiguration=A,this._memoryConfigurationByResource=C,this.logService=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(r,a,l){return this.getConsolidatedConfigurationModel(r,a,l).getValue(r)}updateValue(r,a,l={}){let P;l.resource?(P=this._memoryConfigurationByResource.get(l.resource),P||(P=g.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(l.resource,P))):P=this._memoryConfiguration,a===void 0?P.removeValue(r):P.setValue(r,a),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,a,l){const P=this.getConsolidatedConfigurationModel(r,a,l),y=this.getFolderConfigurationModelForResource(a.resource,l),k=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,T=new Set;for(const A of P.overrides)for(const C of A.identifiers)P.getOverrideValue(r,C)!==void 0&&T.add(C);return new p(r,a,P.getValue(r),T.size?[...T]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this._workspaceConfiguration:void 0,y||void 0,k)}keys(r){const a=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,a){this._folderConfigurations.set(r,a),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const l=[];if(!a){const{added:P,updated:y,removed:k}=d(this._defaultConfiguration,r);a=[...P,...y,...k]}for(const P of a)for(const y of(0,u.overrideIdentifiersFromKey)(P)){const k=this._defaultConfiguration.getKeysForOverrideIdentifier(y),T=r.getKeysForOverrideIdentifier(y),A=[...T.filter(C=>k.indexOf(C)===-1),...k.filter(C=>T.indexOf(C)===-1),...k.filter(C=>!R.equals(this._defaultConfiguration.override(y).getValue(C),r.override(y).getValue(C)))];l.push([y,A])}return this.updateDefaultConfiguration(r),{keys:a,overrides:l}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:l,removed:P}=d(this._policyConfiguration,r),y=[...a,...l,...P];return y.length&&this.updatePolicyConfiguration(r),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:l,removed:P,overrides:y}=d(this.applicationConfiguration,r),k=[...a,...l,...P];return k.length&&this.updateApplicationConfiguration(r),{keys:k,overrides:y}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:l,removed:P,overrides:y}=d(this.localUserConfiguration,r),k=[...a,...l,...P];return k.length&&this.updateLocalUserConfiguration(r),{keys:k,overrides:y}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:l,removed:P,overrides:y}=d(this.remoteUserConfiguration,r),k=[...a,...l,...P];return k.length&&this.updateRemoteUserConfiguration(r),{keys:k,overrides:y}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:l,removed:P,overrides:y}=d(this.workspaceConfiguration,r),k=[...a,...l,...P];return k.length&&this.updateWorkspaceConfiguration(r),{keys:k,overrides:y}}compareAndUpdateFolderConfiguration(r,a){const l=this.folderConfigurations.get(r),{added:P,updated:y,removed:k,overrides:T}=d(l,a),A=[...P,...y,...k];return(A.length||!l)&&this.updateFolderConfiguration(r,a),{keys:A,overrides:T}}compareAndDeleteFolderConfiguration(r){const a=this.folderConfigurations.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:l,updated:P,removed:y,overrides:k}=d(a,void 0);return{keys:[...l,...P,...y],overrides:k}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,a,l){let P=this.getConsolidatedConfigurationModelForResource(a,l);return a.overrideIdentifier&&(P=P.override(a.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(P=P.merge(this._policyConfiguration)),P}getConsolidatedConfigurationModelForResource({resource:r},a){let l=this.getWorkspaceConsolidatedConfiguration();if(a&&r){const P=a.getFolder(r);P&&(l=this.getFolderConsolidatedConfiguration(P.uri)||l);const y=this._memoryConfigurationByResource.get(r);y&&(l=l.merge(y))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let a=this._foldersConsolidatedConfigurations.get(r);if(!a){const l=this.getWorkspaceConsolidatedConfiguration(),P=this._folderConfigurations.get(r);P?(a=l.merge(P),this._foldersConsolidatedConfigurations.set(r,a)):a=l}return a}getFolderConfigurationModelForResource(r,a){if(a&&r){const l=a.getFolder(r);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,a)=>{const{contents:l,overrides:P,keys:y}=this._folderConfigurations.get(a);return r.push([a,{contents:l,overrides:P,keys:y}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(a=>r.add(a)),this.userConfiguration.keys.forEach(a=>r.add(a)),this._workspaceConfiguration.keys.forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.keys.forEach(l=>r.add(l))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.getAllOverrideIdentifiers().forEach(l=>r.add(l))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(l=>a.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(l=>a.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(l=>a.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(r).forEach(P=>a.add(P))),[...a.values()]}static parse(r,a){const l=this.parseConfigurationModel(r.defaults,a),P=this.parseConfigurationModel(r.policy,a),y=this.parseConfigurationModel(r.application,a),k=this.parseConfigurationModel(r.user,a),T=this.parseConfigurationModel(r.workspace,a),A=r.folders.reduce((C,_)=>(C.set(c.URI.revive(_[0]),this.parseConfigurationModel(_[1],a)),C),new L.ResourceMap);return new D(l,P,y,k,g.createEmptyModel(a),T,A,g.createEmptyModel(a),new L.ResourceMap,a)}static parseConfigurationModel(r,a){return new g(r.contents,r.keys,r.overrides,void 0,a)}}e.Configuration=D;function I(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,a=new Map;for(const P of o)P.keys.forEach(y=>r.add(y)),P.overrides.forEach(([y,k])=>{const T=(0,L.getOrSet)(a,y,new Set);k.forEach(A=>T.add(A))});const l=[];return a.forEach((P,y)=>l.push([y,[...P.values()]])),{keys:[...r.values()],overrides:l}}class i{constructor(r,a,l,P,y){this.change=r,this.previous=a,this.currentConfiguraiton=l,this.currentWorkspace=P,this.logService=y,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const k of r.keys)this.affectedKeys.add(k);for(const[,k]of r.overrides)for(const T of k)this.affectedKeys.add(T);this._affectsConfigStr=this._marker;for(const k of this.affectedKeys)this._affectsConfigStr+=k+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(r,a){const l=this._marker+r,P=this._affectsConfigStr.indexOf(l);if(P<0)return!1;const y=P+l.length;if(y>=this._affectsConfigStr.length)return!1;const k=this._affectsConfigStr.charCodeAt(y);if(k!==this._markerCode1&&k!==this._markerCode2)return!1;if(a){const T=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.previous?.workspace):void 0,A=this.currentConfiguraiton.getValue(r,a,this.currentWorkspace);return!R.equals(T,A)}return!0}}e.ConfigurationChangeEvent=i;function d(o,r){const{added:a,removed:l,updated:P}=t(r?.rawConfiguration,o?.rawConfiguration),y=[],k=o?.getAllOverrideIdentifiers()||[],T=r?.getAllOverrideIdentifiers()||[];if(r){const A=T.filter(C=>!k.includes(C));for(const C of A)y.push([C,r.getKeysForOverrideIdentifier(C)])}if(o){const A=k.filter(C=>!T.includes(C));for(const C of A)y.push([C,o.getKeysForOverrideIdentifier(C)])}if(r&&o){for(const A of k)if(T.includes(A)){const C=t({contents:o.getOverrideValue(void 0,A)||{},keys:o.getKeysForOverrideIdentifier(A)},{contents:r.getOverrideValue(void 0,A)||{},keys:r.getKeysForOverrideIdentifier(A)});y.push([A,[...C.added,...C.removed,...C.updated]])}}return{added:a,removed:l,updated:P,overrides:y}}function t(o,r){const a=o?r?o.keys.filter(y=>r.keys.indexOf(y)===-1):[...o.keys]:[],l=r?o?r.keys.filter(y=>o.keys.indexOf(y)===-1):[...r.keys]:[],P=[];if(o&&r){for(const y of r.keys)if(o.keys.indexOf(y)!==-1){const k=(0,m.getConfigurationValue)(r.contents,y),T=(0,m.getConfigurationValue)(o.contents,y);R.equals(k,T)||P.push(y)}}return{added:a,removed:l,updated:P}}}),define(ce[204],le([0,1,21,4,2,37,11,125,56,5,40,45]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class f extends b.Disposable{get configurationModel(){return this._configurationModel}constructor(E){super(),this.logService=E,this._onDidChangeConfiguration=this._register(new s.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(u.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:S})=>this.onDidUpdateConfiguration(Array.from(E),S))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(E,S){this.updateConfigurationModel(E,u.Registry.as(w.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:E})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService);const E=u.Registry.as(w.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(E),E)}updateConfigurationModel(E,S){const p=this.getConfigurationDefaultOverrides();for(const D of E){const I=p[D],i=S[D];I!==void 0?this._configurationModel.setValue(D,I):i?this._configurationModel.setValue(D,i.default):this._configurationModel.removeValue(D)}}}e.DefaultConfiguration=f;class v{constructor(){this.onDidChangeConfiguration=s.Event.None,this.configurationModel=R.ConfigurationModel.createEmptyModel(new c.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let h=class extends b.Disposable{get configurationModel(){return this._configurationModel}constructor(E,S,p){super(),this.defaultConfiguration=E,this.policyService=S,this.logService=p,this._onDidChangeConfiguration=this._register(new s.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(E=>this.onDidChangePolicies(E))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:E})=>this.update(await this.updatePolicyDefinitions(E),!0))),this._configurationModel}async updatePolicyDefinitions(E){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",E);const S={},p=[],D=u.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const I of E){const i=D[I];if(!i){p.push(I);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.logService.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}p.push(I),S[i.policy.name]={type:i.type}}}return(0,L.isEmptyObject)(S)||await this.policyService.updatePolicyDefinitions(S),p}onDidChangePolicies(E){this.logService.trace("PolicyConfiguration#onDidChangePolicies",E);const S=u.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),p=(0,n.coalesce)(E.map(D=>S.get(D)));this.update(p,!0)}update(E,S){this.logService.trace("PolicyConfiguration#update",E);const p=u.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),D=[],I=this._configurationModel.isEmpty();for(const i of E){const d=p[i]?.policy?.name;if(d){const t=this.policyService.getPolicyValue(d);(I?t!==void 0:!(0,M.equals)(this._configurationModel.getValue(i),t))&&D.push([i,t])}else this._configurationModel.getValue(i)!==void 0&&D.push([i,void 0])}if(D.length){this.logService.trace("PolicyConfiguration#changed",D);const i=this._configurationModel;this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService);for(const d of i.keys)this._configurationModel.setValue(d,i.getValue(d));for(const[d,t]of D)t===void 0?this._configurationModel.removeValue(d):this._configurationModel.setValue(d,t);S&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=h,e.PolicyConfiguration=h=Ie([re(1,m.IPolicyService),re(2,c.ILogService)],h)}),define(ce[205],le([0,1,21,8,17,4,43,107,2,31,37,3,18,16,125,56,204,14,40]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends w.Disposable{constructor(d,t,o,r){super(),this.settingsResource=d,this.logService=r,this._onDidChangeConfiguration=this._register(new M.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration(r)),this.policyConfiguration=o instanceof p.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,o,r)),this.userConfiguration=this._register(new h.UserSettings(this.settingsResource,{},f.extUriBiasedIgnorePathCase,t,r)),this.configuration=new h.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,h.ConfigurationModel.createEmptyModel(r),h.ConfigurationModel.createEmptyModel(r),h.ConfigurationModel.createEmptyModel(r),h.ConfigurationModel.createEmptyModel(r),new c.ResourceMap,h.ConfigurationModel.createEmptyModel(r),new c.ResourceMap,r),this.configurationEditing=new I(d,t,this),this.reloadConfigurationScheduler=this._register(new s.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:a,properties:l})=>this.onDidDefaultConfigurationChange(a,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(a=>this.onDidPolicyConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[d,t,o]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new h.Configuration(d,t,h.ConfigurationModel.createEmptyModel(this.logService),o,h.ConfigurationModel.createEmptyModel(this.logService),h.ConfigurationModel.createEmptyModel(this.logService),new c.ResourceMap,h.ConfigurationModel.createEmptyModel(this.logService),new c.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(d,t){const o=typeof d=="string"?d:void 0,r=(0,v.isConfigurationOverrides)(d)?d:(0,v.isConfigurationOverrides)(t)?t:{};return this.configuration.getValue(o,r,void 0)}async updateValue(d,t,o,r,a){const l=(0,v.isConfigurationUpdateOverrides)(o)?o:(0,v.isConfigurationOverrides)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,P=l?r:o;if(P!==void 0&&P!==v.ConfigurationTarget.USER_LOCAL&&P!==v.ConfigurationTarget.USER)throw new Error(`Unable to write ${d} to target ${P}.`);l?.overrideIdentifiers&&(l.overrideIdentifiers=(0,n.distinct)(l.overrideIdentifiers),l.overrideIdentifiers=l.overrideIdentifiers.length?l.overrideIdentifiers:void 0);const y=this.inspect(d,{resource:l?.resource,overrideIdentifier:l?.overrideIdentifiers?l.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${d} because it is configured in system policy.`);if((0,m.equals)(t,y.defaultValue)&&(t=void 0),l?.overrideIdentifiers?.length&&l.overrideIdentifiers.length>1){const T=l.overrideIdentifiers.sort(),A=this.configuration.localUserConfiguration.overrides.find(C=>(0,n.equals)([...C.identifiers].sort(),T));A&&(l.overrideIdentifiers=A.identifiers)}const k=l?.overrideIdentifiers?.length?[(0,g.keyFromOverrideIdentifiers)(l.overrideIdentifiers),d]:[d];await this.configurationEditing.write(k,t),await this.reloadConfiguration()}inspect(d,t={}){return this.configuration.inspect(d,t,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const t=this.configuration.toData(),o=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(o,t,v.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(d,t){const o=this.configuration.toData(),r=this.configuration.compareAndUpdateDefaultConfiguration(d,t);this.trigger(r,o,v.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(d){const t=this.configuration.toData(),o=this.configuration.compareAndUpdatePolicyConfiguration(d);this.trigger(o,t,v.ConfigurationTarget.DEFAULT)}trigger(d,t,o){const r=new h.ConfigurationChangeEvent(d,{data:t},this.configuration,void 0,this.logService);r.source=o,this._onDidChangeConfiguration.fire(r)}}e.ConfigurationService=D;class I{constructor(d,t,o){this.settingsResource=d,this.fileService=t,this.configurationService=o,this.queue=new s.Queue}write(d,t){return this.queue.queue(()=>this.doWriteConfiguration(d,t))}async doWriteConfiguration(d,t){let o;try{o=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(l){if(l.fileOperationResult===S.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw l}const r=[];if((0,L.parse)(o,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const a=this.getEdits(o,d,t);o=(0,R.applyEdits)(o,a),await this.fileService.writeFile(this.settingsResource,b.VSBuffer.fromString(o))}getEdits(d,t,o){const{tabSize:r,insertSpaces:a,eol:l}=this.formattingOptions;if(!t.length){const P=JSON.stringify(o,null,a?" ".repeat(r):"	");return[{content:P,length:P.length,offset:0}]}return(0,R.setProperty)(d,t,o,{tabSize:r,insertSpaces:a,eol:l})}get formattingOptions(){if(!this._formattingOptions){let d=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const t=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(d=t),this._formattingOptions={eol:d,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ce[206],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class n{async routeCall(b,M,L){if(M!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${M}`);const R=L[0];if(R?.authority){const w=b.connections.find(c=>c.ctx===R.authority);if(w)return w}throw new Error("Caller not found")}routeEvent(b,M){throw new Error(`Event not found: ${M}`)}}e.NodeRemoteResourceRouter=n}),define(ce[207],le([0,1,15,6]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=c,e.IRemoteAuthorityResolverService=(0,s.createDecorator)("remoteAuthorityResolverService");var b;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(b||(e.RemoteConnectionType=b={}));class M{constructor(u){this.id=u,this.type=b.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=M;class L{constructor(u,f){this.host=u,this.port=f,this.type=b.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=L;var R;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class w extends n.ErrorNoTelemetry{static isNotAvailable(u){return u instanceof w&&u._code===R.NotAvailable}static isTemporarilyNotAvailable(u){return u instanceof w&&u._code===R.TemporarilyNotAvailable}static isNoResolverFound(u){return u instanceof w&&u._code===R.NoResolverFound}static isInvalidAuthority(u){return u instanceof w&&u._code===R.InvalidAuthority}static isHandled(u){return u instanceof w&&u.isHandled}constructor(u,f=R.Unknown,v){super(u),this._message=u,this._code=f,this._detail=v,this.isHandled=f===R.NotAvailable&&v===!0,Object.setPrototypeOf(this,w.prototype)}}e.RemoteAuthorityResolverError=w;function c(m){const u=m.indexOf("+");return u===-1?m:m.substring(0,u)}}),define(ce[208],le([0,1,8,17,22,15,4,2,12,70,66,33,117,207]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=y,e.connectRemoteAgentExtensionHost=k,e.connectRemoteAgentTunnel=A,c=De(c);const h=30*1e3;var g;(function(se){se[se.Management=1]="Management",se[se.ExtensionHost=2]="ExtensionHost",se[se.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function E(se){switch(se){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function S(se){const Y=new b.CancellationTokenSource;return setTimeout(()=>Y.cancel(),se),Y.token}function p(se,Y){if(se.isCancellationRequested||Y.isCancellationRequested)return b.CancellationToken.Cancelled;const W=new b.CancellationTokenSource;return se.onCancellationRequested(()=>W.cancel()),Y.onCancellationRequested(()=>W.cancel()),W.token}class D{get didTimeout(){return this._state==="timedout"}constructor(Y){this._state="pending",this._disposables=new R.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,n.promiseWithResolvers)(),Y.isCancellationRequested?this._timeout():this._disposables.add(Y.onCancellationRequested(()=>this._timeout()))}registerDisposable(Y){this._state==="pending"?this._disposables.add(Y):Y.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Y=new Error("Time limit reached");return Y.code="ETIMEDOUT",Y.syscall="connect",Y}resolve(Y){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Y))}reject(Y){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Y))}}function I(se,Y){const W=new D(Y);return W.registerDisposable(se.onControlMessage(F=>{const Z=JSON.parse(F.toString()),z=O(Z);z?W.reject(z):W.resolve(Z)})),W.promise}function i(se,Y,W,F,Z,z,ie,G){const x=new D(G),te=m.StopWatch.create(!1);return se.info(`Creating a socket (${ie})...`),c.mark(`code/willCreateSocket/${z}`),Y.connect(W,F,Z,ie).then(de=>{x.didTimeout?(c.mark(`code/didCreateSocketError/${z}`),se.info(`Creating a socket (${ie}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(c.mark(`code/didCreateSocketOK/${z}`),se.info(`Creating a socket (${ie}) was successful after ${te.elapsed()} ms.`),x.resolve(de))},de=>{c.mark(`code/didCreateSocketError/${z}`),se.info(`Creating a socket (${ie}) returned an error after ${te.elapsed()} ms.`),se.error(de),x.reject(de)}),x.promise}function d(se,Y){const W=new D(Y);return se.then(F=>{W.didTimeout||W.resolve(F)},F=>{W.didTimeout||W.reject(F)}),W.promise}async function t(se,Y,W,F){const Z=j(se,Y);se.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let z;try{z=await i(se.logService,se.remoteSocketFactoryService,se.connectTo,w.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${se.reconnectionToken}&reconnection=${se.reconnectionProtocol?"true":"false"}`,E(Y),`renderer-${E(Y)}-${se.reconnectionToken}`,F)}catch(de){throw se.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),se.logService.error(de),de}se.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let ie,G;se.reconnectionProtocol?(se.reconnectionProtocol.beginAcceptReconnection(z,null),ie=se.reconnectionProtocol,G=!1):(ie=new f.PersistentProtocol({socket:z}),G=!0),se.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const x=await d(se.signService.createNewMessage((0,u.generateUuid)()),F),te={type:"auth",auth:se.connectionToken||"00000000000000000000",data:x.data};ie.sendControl(s.VSBuffer.fromString(JSON.stringify(te)));try{const de=await I(ie,p(F,S(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const Ne=new Error("Unexpected handshake message");throw Ne.code="VSCODE_CONNECTION_ERROR",Ne}if(se.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await d(se.signService.validate(x,de.signedData),F)){const Ne=new Error("Refused to connect to unsupported server");throw Ne.code="VSCODE_CONNECTION_ERROR",Ne}const we=await d(se.signService.sign(de.data),F),Re={type:"connectionType",commit:se.commit,signedData:we,desiredConnectionType:Y};return W&&(Re.args=W),se.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(s.VSBuffer.fromString(JSON.stringify(Re))),{protocol:ie,ownsProtocol:G}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(se.logService.error(`${Z} the handshake timed out. Error:`),se.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(se.logService.error(`${Z} received error control message when negotiating connection. Error:`),se.logService.error(de)),G&&U(ie),de}}async function o(se,Y,W,F){const Z=Date.now(),z=j(se,Y),{protocol:ie,ownsProtocol:G}=await t(se,Y,W,F),x=new D(F);return x.registerDisposable(ie.onControlMessage(te=>{const de=JSON.parse(te.toString()),me=O(de);me?(se.logService.error(`${z} received error control message when negotiating connection. Error:`),se.logService.error(me),G&&U(ie),x.reject(me)):(se.reconnectionProtocol?.endAcceptReconnection(),se.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${ue(Z)}!`),x.resolve({protocol:ie,firstMessage:de}))})),x.promise}async function r(se,Y){const{protocol:W}=await o(se,g.Management,void 0,Y);return{protocol:W}}async function a(se,Y,W){const{protocol:F,firstMessage:Z}=await o(se,g.ExtensionHost,Y,W),z=Z&&Z.debugPort;return{protocol:F,debugPort:z}}async function l(se,Y,W){const F=Date.now(),Z=j(se,g.Tunnel),{protocol:z}=await t(se,g.Tunnel,Y,W);return se.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${ue(F)}!`),z}async function P(se,Y,W){const{connectTo:F,connectionToken:Z}=await se.addressProvider.getAddress();return{commit:se.commit,quality:se.quality,connectTo:F,connectionToken:Z,reconnectionToken:Y,reconnectionProtocol:W,remoteSocketFactoryService:se.remoteSocketFactoryService,signService:se.signService,logService:se.logService}}async function y(se,Y,W){return T(se,async F=>{const{protocol:Z}=await r(F,b.CancellationToken.None);return new B(se,Y,W,F.reconnectionToken,Z)})}async function k(se,Y){return T(se,async W=>{const{protocol:F,debugPort:Z}=await a(W,Y,b.CancellationToken.None);return new J(se,Y,W.reconnectionToken,F,Z)})}async function T(se,Y){for(let F=1;;F++)try{const Z=(0,u.generateUuid)(),z=await P(se,Z,null);return await Y(z)}catch(Z){if(F<5)se.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),se.logService.error(Z);else throw se.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),se.logService.error(Z),X.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(Z)),Z}}async function A(se,Y,W){const F=await P(se,(0,u.generateUuid)(),null);return await l(F,{host:Y,port:W},b.CancellationToken.None)}function C(se){return(0,n.createCancelablePromise)(Y=>new Promise((W,F)=>{const Z=setTimeout(W,se*1e3);Y.onCancellationRequested(()=>{clearTimeout(Z),W()})}))}var _;(function(se){se[se.ConnectionLost=0]="ConnectionLost",se[se.ReconnectionWait=1]="ReconnectionWait",se[se.ReconnectionRunning=2]="ReconnectionRunning",se[se.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",se[se.ConnectionGain=4]="ConnectionGain"})(_||(e.PersistentConnectionEventType=_={}));class H{constructor(Y,W){this.reconnectionToken=Y,this.millisSinceLastIncomingData=W,this.type=_.ConnectionLost}}e.ConnectionLostEvent=H;class q{constructor(Y,W,F,Z){this.reconnectionToken=Y,this.millisSinceLastIncomingData=W,this.durationSeconds=F,this.cancellableTimer=Z,this.type=_.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=q;class K{constructor(Y,W,F){this.reconnectionToken=Y,this.millisSinceLastIncomingData=W,this.attempt=F,this.type=_.ReconnectionRunning}}e.ReconnectionRunningEvent=K;class fe{constructor(Y,W,F){this.reconnectionToken=Y,this.millisSinceLastIncomingData=W,this.attempt=F,this.type=_.ConnectionGain}}e.ConnectionGainEvent=fe;class ${constructor(Y,W,F,Z){this.reconnectionToken=Y,this.millisSinceLastIncomingData=W,this.attempt=F,this.handled=Z,this.type=_.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=$;class X extends R.Disposable{static triggerPermanentFailure(Y,W,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Y,this._permanentFailureAttempt=W,this._permanentFailureHandled=F,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Y=>Y._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Y=>Y._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||X._permanentFailure}constructor(Y,W,F,Z,z){super(),this._connectionType=Y,this._options=W,this.reconnectionToken=F,this.protocol=Z,this._reconnectionFailureIsFatal=z,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new fe(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(ie=>{const G=oe(this._connectionType,this.reconnectionToken,!0);ie?ie.type===f.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${G} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this._options.logService.error(ie.error)):(this._options.logService.info(`${G} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this._options.logService.error(ie.event)):this._options.logService.info(`${G} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(ie=>{const G=oe(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${G} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),X._instances.push(this),this._register((0,R.toDisposable)(()=>{const ie=X._instances.indexOf(this);ie>=0&&X._instances.splice(ie,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(X._permanentFailureMillisSinceLastIncomingData,X._permanentFailureAttempt,X._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const Y=oe(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Y} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const Z=F<W.length?W[F]:W[W.length-1];try{if(Z>0){const ie=C(Z);this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,ie)),this._options.logService.info(`${Y} waiting for ${Z} seconds before reconnecting...`);try{await ie}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${Y} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${Y} resolving connection...`);const z=await P(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Y} connecting to ${z.connectTo}...`),await this._reconnect(z,S(h)),this._options.logService.info(`${Y} reconnected!`),this._onDidStateChange.fire(new fe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Y} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${Y} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this._options.logService.info(`${Y} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this._options.logService.info(`${Y} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((0,M.isCancellationError)(z)){this._options.logService.info(`${Y} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if(z instanceof v.RemoteAuthorityResolverError){this._options.logService.error(`${Y} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,v.RemoteAuthorityResolverError.isHandled(z));break}this._options.logService.error(`${Y} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(Y,W,F){this._reconnectionFailureIsFatal?X.triggerPermanentFailure(Y,W,F):this._gotoPermanentFailure(Y,W,F)}_gotoPermanentFailure(Y,W,F){this._onDidStateChange.fire(new $(this.reconnectionToken,Y,W,F)),U(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=X;class B extends X{constructor(Y,W,F,Z,z){super(g.Management,Y,Z,z,!0),this.client=this._register(new f.Client(z,{remoteAuthority:W,clientId:F},Y.ipcLogger))}async _reconnect(Y,W){await r(Y,W)}}e.ManagementPersistentConnection=B;class J extends X{constructor(Y,W,F,Z,z){super(g.ExtensionHost,Y,F,Z,!1),this._startArguments=W,this.debugPort=z}async _reconnect(Y,W){await a(Y,this._startArguments,W)}}e.ExtensionHostPersistentConnection=J;function U(se){try{se.acceptDisconnect();const Y=se.getSocket();se.dispose(),Y.dispose()}catch(Y){(0,M.onUnexpectedError)(Y)}}function O(se){if(se&&se.type==="error"){const Y=new Error(`Connection error: ${se.reason}`);return Y.code="VSCODE_CONNECTION_ERROR",Y}return null}function N(se,Y){for(;se.length<Y;)se+=" ";return se}function Q(se,Y){return`[remote-connection][${N(E(se),13)}][${Y.substr(0,5)}\u2026]`}function oe(se,Y,W){return`${Q(se,Y)}[${W?"reconnect":"initial"}]`}function j(se,Y){return`${oe(Y,se.reconnectionToken,!!se.reconnectionProtocol)}[${se.connectTo}]`}function ue(se){return`${Date.now()-se} ms`}}),define(ce[74],le([0,1,12]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=s,e.getRemoteName=b,e.parseAuthorityWithPort=M,e.parseAuthorityWithOptionalPort=L;function s(w){return w.scheme===n.Schemas.vscodeRemote?w.authority:void 0}function b(w){if(!w)return;const c=w.indexOf("+");return c<0?w:w.substr(0,c)}function M(w){const{host:c,port:m}=R(w);if(typeof m>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:m}}function L(w,c){let{host:m,port:u}=R(w);return typeof u>"u"&&(u=c),{host:m,port:u}}function R(w){const c=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const m=w.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const u=w.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:w,port:void 0}}}),define(ce[85],le([0,1,25,6,74]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=M,e.isApplicationScopedExtension=u,e.isLanguagePackExtension=f,e.isAuthenticationProviderExtension=v,e.isResolverExtension=h,e.parseApiProposals=g,e.parseEnabledApiProposalNames=E,n=De(n),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function(S){S.WIN32_X64="win32-x64",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.LINUX_PPC64LE="linux-ppc64le",S.LINUX_RISCV64="linux-riscv64",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class w{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,D){if(typeof p>"u"||p===null)return typeof D>"u"||D===null;if(typeof D>"u"||D===null)return!1;if(typeof p=="string"||typeof D=="string"){const I=typeof p=="string"?p:p.value,i=typeof D=="string"?D:D.value;return n.equalsIgnoreCase(I,i)}return p._lower===D._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=w;class c{get size(){return this._set.size}constructor(p){if(this._set=new Set,p)for(const D of p)this.add(D)}add(p){this._set.add(w.toKey(p))}delete(p){return this._set.delete(w.toKey(p))}has(p){return this._set.has(w.toKey(p))}}e.ExtensionIdentifierSet=c;class m{constructor(){this._map=new Map}clear(){this._map.clear()}delete(p){this._map.delete(w.toKey(p))}get(p){return this._map.get(w.toKey(p))}has(p){return this._map.has(w.toKey(p))}set(p,D){this._map.set(w.toKey(p),D)}values(){return this._map.values()}forEach(p){this._map.forEach(p)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=m;function u(S){return f(S)}function f(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}function v(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}function h(S,p){if(p){const D=`onResolveRemoteAuthority:${(0,b.getRemoteName)(p)}`;return!!S.activationEvents?.includes(D)}return!1}function g(S){return S.map(p=>{const[D,I]=p.split("@");return{proposalName:D,version:I?parseInt(I):void 0}})}function E(S){return S.map(p=>p.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,s.createDecorator)("IBuiltinExtensionsScannerService")}),define(ce[126],le([0,1,3,10,85,6]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=R,e.toTargetPlatform=w,e.getTargetPlatform=c,e.isNotWebExtensionInWebTargetPlatform=m,e.isTargetPlatformCompatible=u,e.isIExtensionIdentifier=f,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function R(i){switch(i){case b.TargetPlatform.WIN32_X64:return"Windows 64 bit";case b.TargetPlatform.WIN32_ARM64:return"Windows ARM";case b.TargetPlatform.LINUX_X64:return"Linux 64 bit";case b.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case b.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case b.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case b.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case b.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case b.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case b.TargetPlatform.DARWIN_X64:return"Mac";case b.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case b.TargetPlatform.WEB:return"Web";case b.TargetPlatform.UNIVERSAL:return b.TargetPlatform.UNIVERSAL;case b.TargetPlatform.UNKNOWN:return b.TargetPlatform.UNKNOWN;case b.TargetPlatform.UNDEFINED:return b.TargetPlatform.UNDEFINED}}function w(i){switch(i){case b.TargetPlatform.WIN32_X64:return b.TargetPlatform.WIN32_X64;case b.TargetPlatform.WIN32_ARM64:return b.TargetPlatform.WIN32_ARM64;case b.TargetPlatform.LINUX_X64:return b.TargetPlatform.LINUX_X64;case b.TargetPlatform.LINUX_ARM64:return b.TargetPlatform.LINUX_ARM64;case b.TargetPlatform.LINUX_ARMHF:return b.TargetPlatform.LINUX_ARMHF;case b.TargetPlatform.LINUX_PPC64LE:return b.TargetPlatform.LINUX_PPC64LE;case b.TargetPlatform.LINUX_RISCV64:return b.TargetPlatform.LINUX_RISCV64;case b.TargetPlatform.ALPINE_X64:return b.TargetPlatform.ALPINE_X64;case b.TargetPlatform.ALPINE_ARM64:return b.TargetPlatform.ALPINE_ARM64;case b.TargetPlatform.DARWIN_X64:return b.TargetPlatform.DARWIN_X64;case b.TargetPlatform.DARWIN_ARM64:return b.TargetPlatform.DARWIN_ARM64;case b.TargetPlatform.WEB:return b.TargetPlatform.WEB;case b.TargetPlatform.UNIVERSAL:return b.TargetPlatform.UNIVERSAL;default:return b.TargetPlatform.UNKNOWN}}function c(i,d){switch(i){case n.Platform.Windows:return d==="x64"?b.TargetPlatform.WIN32_X64:d==="arm64"?b.TargetPlatform.WIN32_ARM64:b.TargetPlatform.UNKNOWN;case n.Platform.Linux:return d==="x64"?b.TargetPlatform.LINUX_X64:d==="arm64"?b.TargetPlatform.LINUX_ARM64:d==="arm"?b.TargetPlatform.LINUX_ARMHF:d==="ppc64le"?b.TargetPlatform.LINUX_PPC64LE:d==="riscv64"?b.TargetPlatform.LINUX_RISCV64:b.TargetPlatform.UNKNOWN;case"alpine":return d==="x64"?b.TargetPlatform.ALPINE_X64:d==="arm64"?b.TargetPlatform.ALPINE_ARM64:b.TargetPlatform.UNKNOWN;case n.Platform.Mac:return d==="x64"?b.TargetPlatform.DARWIN_X64:d==="arm64"?b.TargetPlatform.DARWIN_ARM64:b.TargetPlatform.UNKNOWN;case n.Platform.Web:return b.TargetPlatform.WEB}}function m(i,d){return d===b.TargetPlatform.WEB&&!i.includes(b.TargetPlatform.WEB)}function u(i,d,t){return m(d,t)?!1:i===b.TargetPlatform.UNDEFINED||i===b.TargetPlatform.UNIVERSAL?!0:i===b.TargetPlatform.UNKNOWN?!1:i===t}function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var v;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(v||(e.SortBy=v={}));var h;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var g;(function(i){i.Install="install",i.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var E;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var S;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(S||(e.ExtensionGalleryErrorCode=S={}));class p extends Error{constructor(d,t){super(d),this.code=t,this.name=t}}e.ExtensionGalleryError=p;var D;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(D||(e.ExtensionManagementErrorCode=D={}));class I extends Error{constructor(d,t){super(d),this.code=t,this.name=t}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,s.localize2)(11502,"Extensions"),e.PreferencesLocalizedLabel=(0,s.localize2)(11503,"Preferences")});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[209],le([0,1,18,81,10,210,85,172]),function(V,e,n,s,b,M,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=m,e.parseVersion=u,e.normalizeVersion=f,e.isValidVersion=v,e.validateExtensionManifest=h,e.isValidExtensionVersion=g,e.isEngineValid=E,e.areApiProposalsCompatible=S,s=je(s),b=De(b),M=De(M);const w=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function m(I){return I=I.trim(),I==="*"||w.test(I)}function u(I){if(!m(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=I.match(w);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function f(I){if(!I)return null;const i=I.majorBase,d=I.majorMustEqual,t=I.minorBase;let o=I.minorMustEqual;const r=I.patchBase;let a=I.patchMustEqual;I.hasCaret&&(i===0||(o=!1),a=!1);let l=0;if(I.preRelease){const P=c.exec(I.preRelease);if(P){const[,y,k,T]=P;l=Date.UTC(Number(y),Number(k)-1,Number(T))}}return{majorBase:i,majorMustEqual:d,minorBase:t,minorMustEqual:o,patchBase:r,patchMustEqual:a,isMinimum:I.hasGreaterEquals,notBefore:l}}function v(I,i,d){let t;typeof I=="string"?t=f(u(I)):t=I;let o;i instanceof Date?o=i.getTime():typeof i=="string"&&(o=new Date(i).getTime());let r;if(typeof d=="string"?r=f(u(d)):r=d,!t||!r)return!1;const a=t.majorBase,l=t.minorBase,P=t.patchBase;let y=r.majorBase,k=r.minorBase,T=r.patchBase;const A=r.notBefore;let C=r.majorMustEqual,_=r.minorMustEqual,H=r.patchMustEqual;return r.isMinimum?a>y?!0:a<y?!1:l>k?!0:l<k||o&&o<A?!1:P>=T:(a===1&&y===0&&(!C||!_||!H)&&(y=1,k=0,T=0,C=!0,_=!1,H=!1),a<y?!1:a>y?!C:l<k?!1:l>k?!_:P<T?!1:P>T?!H:!(o&&o<A))}function h(I,i,d,t,o,r){const a=[];if(typeof t.publisher<"u"&&typeof t.publisher!="string")return a.push([s.default.Error,b.localize(11433,null)]),a;if(typeof t.name!="string")return a.push([s.default.Error,b.localize(11434,null,"name")]),a;if(typeof t.version!="string")return a.push([s.default.Error,b.localize(11435,null,"version")]),a;if(!t.engines)return a.push([s.default.Error,b.localize(11436,null,"engines")]),a;if(typeof t.engines.vscode!="string")return a.push([s.default.Error,b.localize(11437,null,"engines.vscode")]),a;if(typeof t.extensionDependencies<"u"&&!D(t.extensionDependencies))return a.push([s.default.Error,b.localize(11438,null,"extensionDependencies")]),a;if(typeof t.activationEvents<"u"){if(!D(t.activationEvents))return a.push([s.default.Error,b.localize(11439,null,"activationEvents")]),a;if(typeof t.main>"u"&&typeof t.browser>"u")return a.push([s.default.Error,b.localize(11440,null,"activationEvents","main","browser")]),a}if(typeof t.extensionKind<"u"&&typeof t.main>"u"&&a.push([s.default.Warning,b.localize(11441,null,"extensionKind")]),typeof t.main<"u"){if(typeof t.main!="string")return a.push([s.default.Error,b.localize(11442,null,"main")]),a;{const y=(0,n.joinPath)(d,t.main);(0,n.isEqualOrParent)(y,d)||a.push([s.default.Warning,b.localize(11443,null,y.path,d.path)])}}if(typeof t.browser<"u"){if(typeof t.browser!="string")return a.push([s.default.Error,b.localize(11444,null,"browser")]),a;{const y=(0,n.joinPath)(d,t.browser);(0,n.isEqualOrParent)(y,d)||a.push([s.default.Warning,b.localize(11445,null,y.path,d.path)])}}if(!M.valid(t.version))return a.push([s.default.Error,b.localize(11446,null)]),a;const l=[];if(!g(I,i,t,o,l))for(const y of l)a.push([s.default.Error,y]);if(r&&t.enabledApiProposals?.length){const y=[];if(!S([...t.enabledApiProposals],y))for(const k of y)a.push([s.default.Error,k])}return a}function g(I,i,d,t,o){return t||typeof d.main>"u"&&typeof d.browser>"u"?!0:p(I,i,d.engines.vscode,o)}function E(I,i,d){return I==="*"||p(i,d,I)}function S(I,i){if(I.length===0)return!0;const d=Array.isArray(i)?i:void 0,t=(d?void 0:i)??R.allApiProposals,o=[],r=(0,L.parseApiProposals)(I);for(const{proposalName:a,version:l}of r){const P=t[a];P&&l&&P.version!==l&&o.push(b.localize(11447,null,a))}return d?.push(...o),o.length===0}function p(I,i,d,t=[]){const o=f(u(d));if(!o)return t.push(b.localize(11448,null,d)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return t.push(b.localize(11449,null,d)),!1}else if(!o.majorMustEqual)return t.push(b.localize(11450,null,d)),!1;return v(I,i,o)?!0:(t.push(b.localize(11451,null,I,d)),!1)}function D(I){if(!Array.isArray(I))return!1;for(let i=0,d=I.length;i<d;i++)if(typeof I[i]!="string")return!1;return!0}}),define(ce[211],le([0,1,2,6]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,s.createDecorator)("remoteSocketFactoryService");class b{constructor(){this.factories={}}register(L,R){return this.factories[L]??=[],this.factories[L].push(R),(0,n.toDisposable)(()=>{const w=this.factories[L]?.indexOf(R);typeof w=="number"&&w>=0&&this.factories[L]?.splice(w,1)})}getSocketFactory(L){return(this.factories[L.type]||[]).find(w=>w.supports(L))}connect(L,R,w,c){const m=this.getSocketFactory(L);if(!m)throw new Error(`No socket factory found for ${L}`);return m.connect(L,R,w,c)}}e.RemoteSocketFactoryService=b}),define(ce[212],le([0,1,26,27,48,121]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=R,n=De(n),s=De(s),b=De(b),M=De(M);let L;async function R(v=!1){return(L===void 0||v)&&(L=w()),L}async function w(){const v=c();if(v===void 0)return!1;if(v>=22e3){const h=u();if(h)return new Promise(g=>{b.execFile(h,["--status"],E=>g(!E))})}else{const h=f();if(h)try{if((await n.promises.stat(h)).isFile())return!0}catch{}}return!1}function c(){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(s.release());if(v)return parseInt(v[3])}function m(v){const h=process.env.SystemRoot;if(h){const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(h,g?"Sysnative":"System32",v)}}function u(){return m("wsl.exe")}function f(){return m("lxss\\LxssManager.dll")}}),define(ce[49],le([0,1,17,15,2,10,56,6,5,45]),function(V,e,n,s,b,M,L,R,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=f,e.hasNoContent=v,e.asText=h,e.asTextOrError=g,e.asJson=E,e.updateProxyConfigurationsScope=S,e.IRequestService=(0,R.createDecorator)("requestService");class m{constructor(i){this.original=i}toJSON(){if(!this.headers){const i=Object.create(null);for(const d in this.original)d.toLowerCase()==="authorization"||d.toLowerCase()==="proxy-authorization"?i[d]="*****":i[d]=this.original[d];this.headers=i}return this.headers}}class u extends b.Disposable{constructor(i){super(),this.counter=0,this.logger=i.createLogger("network",{name:(0,M.localize)(11220,null),when:w.CONTEXT_LOG_LEVEL.isEqualTo((0,w.LogLevelToString)(w.LogLevel.Trace)).serialize()})}async logAndRequest(i,d,t){const o=`${i} #${++this.counter}: ${d.url}`;this.logger.trace(`${o} - begin`,d.type,new m(d.headers??{}));try{const r=await t();return this.logger.trace(`${o} - end`,d.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.logger.error(`${o} - error`,d.type,(0,s.getErrorMessage)(r)),r}}}e.AbstractRequestService=u;function f(I){return I.res.statusCode&&I.res.statusCode>=200&&I.res.statusCode<300||I.res.statusCode===1223}function v(I){return I.res.statusCode===204}async function h(I){return v(I)?null:(await(0,n.streamToBuffer)(I.stream)).toString()}async function g(I){if(!f(I))throw new Error("Server returned "+I.res.statusCode);return h(I)}async function E(I){if(!f(I))throw new Error("Server returned "+I.res.statusCode);if(v(I))return null;const d=(await(0,n.streamToBuffer)(I.stream)).toString();try{return JSON.parse(d)}catch(t){throw t.message+=`:
`+d,t}}function S(I){D(I)}let p;function D(I){const i=c.Registry.as(L.Extensions.Configuration),d=p;p={id:"http",order:15,title:(0,M.localize)(11221,null),type:"object",scope:I,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(11222,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(11223,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(11224,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,M.localize)(11225,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(11226,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(11227,null),(0,M.localize)(11228,null),(0,M.localize)(11229,null),(0,M.localize)(11230,null)],default:"override",description:(0,M.localize)(11231,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11232,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(11233,null),restricted:!0}}},i.updateConfigurations({add:[p],remove:d?[d]:[]})}D(L.ConfigurationScope.APPLICATION)}),define(ce[213],le([0,1,17,22]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class b{constructor(R){this.service=R}listen(R,w){throw new Error("Invalid listen")}call(R,w,c,m=s.CancellationToken.None){switch(w){case"request":return this.service.request(c[0],m).then(async({res:u,stream:f})=>{const v=await(0,n.streamToBuffer)(f);return[{statusCode:u.statusCode,headers:u.headers},v]});case"resolveProxy":return this.service.resolveProxy(c[0]);case"lookupAuthorization":return this.service.lookupAuthorization(c[0]);case"lookupKerberosAuthorization":return this.service.lookupKerberosAuthorization(c[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=b;class M{constructor(R){this.channel=R}async request(R,w){const[c,m]=await this.channel.call("request",[R],w);return{res:c,stream:(0,n.bufferToStream)(m)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}async lookupAuthorization(R){return this.channel.call("lookupAuthorization",[R])}async lookupKerberosAuthorization(R){return this.channel.call("lookupKerberosAuthorization",[R])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=M}),define(ce[214],le([0,1,215,11]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=M;function b(L,R){return L.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:L.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function M(L,R,w={}){const c=(0,n.parse)(L),m=w.proxyUrl||b(c,R);if(!m)return null;const u=(0,n.parse)(m);if(!/^https?:$/.test(u.protocol||""))return null;const f={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,s.isBoolean)(w.strictSSL)?w.strictSSL:!0};if(c.protocol==="http:"){const v=await new Promise((h,g)=>{V(["http-proxy-agent"],h,g)}).then(De);return new v.HttpProxyAgent(m,f)}else{const v=await new Promise((h,g)=>{V(["https-proxy-agent"],h,g)}).then(De);return new v.HttpsProxyAgent(m,f)}}}),define(ce[216],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[100],le([0,1,48,9,10,22,55,15,3,33,116,68,8,144]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=g;let h;async function g(S,p,D,I){return D["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.isLaunchedFromCli)(I)&&!D["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.isLaunchedFromCli)(I)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=f.Promises.withAsyncBody(async(i,d)=>{const t=new M.CancellationTokenSource;let o=1e4;const r=S.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(o=(0,v.clamp)(r,1,120)*1e3);const a=setTimeout(()=>{t.dispose(!0),d(new Error((0,b.localize)(11217,null)))},o);try{i(await E(p,t.token))}catch(l){!(0,R.isCancellationError)(l)&&!t.token.isCancellationRequested?d(new Error((0,b.localize)(11218,null,(0,L.toErrorMessage)(l)))):i({})}finally{clearTimeout(a),t.dispose()}})),h)}async function E(S,p){const D=process.env.ELECTRON_RUN_AS_NODE;S.trace("getUnixShellEnvironment#runAsNode",D);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;S.trace("getUnixShellEnvironment#noAttach",I);const i=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),d=new RegExp(i+"({.*})"+i),t={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};S.trace("getUnixShellEnvironment#env",t);const o=await(0,m.getSystemShell)(w.OS,t);return S.trace("getUnixShellEnvironment#shell",o),new Promise((r,a)=>{if(p.isCancellationRequested)return a(new R.CancellationError);const l=(0,s.basename)(o);let P,y;const k="";/^pwsh(-preview)?$/.test(l)?(P=`& '${process.execPath}' ${k} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,y=["-Login","-Command"]):l==="nu"?(P=`^'${process.execPath}' ${k} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,y=["-i","-l","-c"]):l==="xonsh"?(P=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,y=["-i","-l","-c"]):(P=`'${process.execPath}' ${k} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,l==="tcsh"||l==="csh"?y=["-ic"]:y=["-i","-l","-c"]),S.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),P);const T=(0,n.spawn)(o,[...y,P],{detached:!0,stdio:["ignore","pipe","pipe"],env:t});p.onCancellationRequested(()=>(T.kill(),a(new R.CancellationError))),T.on("error",_=>{S.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(_)),a(_)});const A=[];T.stdout.on("data",_=>A.push(_));const C=[];T.stderr.on("data",_=>C.push(_)),T.on("close",(_,H)=>{const q=Buffer.concat(A).toString("utf8");S.trace("getUnixShellEnvironment#raw",q);const K=Buffer.concat(C).toString("utf8");if(K.trim()&&S.trace("getUnixShellEnvironment#stderr",K),_||H)return a(new Error((0,b.localize)(11219,null,_,H)));const fe=d.exec(q),$=fe?fe[1]:"{}";try{const X=JSON.parse($);D?X.ELECTRON_RUN_AS_NODE=D:delete X.ELECTRON_RUN_AS_NODE,I?X.ELECTRON_NO_ATTACH_CONSOLE=I:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.VSCODE_RESOLVING_ENVIRONMENT,delete X.XDG_RUNTIME_DIR,S.trace("getUnixShellEnvironment#result",X),r(X)}catch(X){S.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(X)),a(X)}})})}}),define(ce[217],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class n{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(b){try{const M=await this.getValidator();if(M){const L=String(n._nextId++);return this.validators.set(L,M),{id:L,data:M.createNewMessage(b)}}}catch{}return{id:"",data:b}}async validate(b,M){if(!b.id)return!0;const L=this.validators.get(b.id);if(!L)return!1;this.validators.delete(b.id);try{return L.validate(M)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(b){try{return await this.signValue(b)}catch{}return b}}e.AbstractSignService=n}),define(ce[101],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,n.createDecorator)(e.SIGN_SERVICE_ID)}),define(ce[218],le([0,1,217]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class s extends n.AbstractSignService{getValidator(){return this.vsda().then(M=>new M.validator)}signValue(M){return this.vsda().then(L=>new L.signer().sign(M))}vsda(){return new Promise((M,L)=>V(["vsda"],M,L))}}e.SignService=s}),define(ce[34],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,n.createDecorator)("stateReadService"),e.IStateService=(0,n.createDecorator)("stateService")}),define(ce[127],le([0,1,8,17,2,11,38,14,5]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var c;(function(v){v[v.IMMEDIATE=0]="IMMEDIATE",v[v.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class m extends b.Disposable{constructor(h,g,E,S){super(),this.storagePath=h,this.saveStrategy=g,this.logService=E,this.fileService=S,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new n.ThrottledDelayer(this.saveStrategy===c.IMMEDIATE?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(h){h.fileOperationResult!==R.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(h)}}getItem(h,g){const E=this.storage[h];return(0,M.isUndefinedOrNull)(E)?g:E}setItem(h,g){this.setItems([{key:h,data:g}])}setItems(h){let g=!1;for(const{key:E,data:S}of h)this.storage[E]!==S&&((0,M.isUndefinedOrNull)(S)?(0,M.isUndefined)(this.storage[E])||(this.storage[E]=void 0,g=!0):(this.storage[E]=S,g=!0));g&&this.save()}removeItem(h){(0,M.isUndefined)(this.storage[h])||(this.storage[h]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const h=JSON.stringify(this.storage,null,4);if(h!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,s.VSBuffer.fromString(h),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=h}catch(g){this.logService.error(g)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=m;let u=class extends b.Disposable{constructor(h,g,E,S){super(),this.fileStorage=this._register(new m(g.stateResource,h,E,S))}async init(){await this.fileStorage.init()}getItem(h,g){return this.fileStorage.getItem(h,g)}};e.StateReadonlyService=u,e.StateReadonlyService=u=Ie([re(1,L.IEnvironmentService),re(2,w.ILogService),re(3,R.IFileService)],u);class f extends u{setItem(h,g){this.fileStorage.setItem(h,g)}setItems(h){this.fileStorage.setItems(h)}removeItem(h){this.fileStorage.removeItem(h)}close(){return this.fileStorage.close()}}e.StateService=f}),define(ce[128],le([0,1,3,36,33]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=L,e.verifyMicrosoftInternalDomain=R;function M(w){if(n.platform===n.Platform.Linux&&/^penguin(\.|$)/i.test(w))return"chromebook"}function L(w,c,m,u,f,v,h,g,E,S){const p=Object.create(null);p["common.machineId"]=v,p["common.sqmId"]=h,p["common.devDeviceId"]=g,p.sessionID=(0,b.generateUuid)()+Date.now(),p.commitHash=u,p.version=f,p["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,n.PlatformToString)(n.platform),p["common.nodePlatform"]=s.platform,p["common.nodeArch"]=m,p["common.product"]=S||"desktop",E&&(p["common.msftInternal"]=E);let D=0;const I=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>D++,enumerable:!0}}),n.isLinuxSnap&&(p["common.snap"]="true");const i=M(c);return i&&(p["common.platformDetail"]=i),p}function R(w){const c=s.env.USERDNSDOMAIN;if(!c)return!1;const m=c.toLowerCase();return w.some(u=>m===u)}}),define(ce[24],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var s;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(s||(e.TelemetryLevel=s={}));var b;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(b||(e.TelemetryConfiguration=b={}))}),define(ce[219],le([0,1,26,27,8,43,12,9,3,66,7,92,23,115,96,14,28,24]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=D,e.getMachineInfo=i,e.collectLaunchConfigs=d,n=De(n),s=De(s);const p=new Map;async function D(o,r){const a=`${o}::${r.join(":")}`,l=p.get(a);if(l)return l;const P=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],y=new Map,k=new Map,T=2e4;function A(_,H,q,K){const fe=H.substring(_.length+1);return b.Promises.withAsyncBody(async $=>{let X;K.readdirCount++;try{X=await f.Promises.readdir(H,{withFileTypes:!0})}catch{$();return}if(K.count>=T){K.count+=X.length,K.maxReached=!0,$();return}let B=X.length;if(B===0){$();return}let J=X;K.count+X.length>T&&(K.maxReached=!0,B=T-K.count,J=X.slice(0,B)),K.count+=X.length;for(const U of J)if(U.isDirectory()){if(q.includes(U.name)||await A(_,(0,R.join)(H,U.name),q,K),--B===0){$();return}}else{const O=U.name.lastIndexOf(".");if(O>=0){const N=U.name.substring(O+1);N&&y.set(N,(y.get(N)??0)+1)}for(const N of P)N.relativePathPattern?.test(fe)!==!1&&N.filePattern.test(U.name)&&k.set(N.tag,(k.get(N.tag)??0)+1);if(--B===0){$();return}}})}const C=b.Promises.withAsyncBody(async _=>{const H={count:0,maxReached:!1,readdirCount:0},q=new c.StopWatch(!0);await A(o,o,r,H);const K=await d(o);_({configFiles:I(k),fileTypes:I(y),fileCount:H.count,maxFilesReached:H.maxReached,launchConfigFiles:K,totalScanTime:q.elapsed(),totalReaddirCount:H.readdirCount})});return p.set(a,C),C}function I(o){return Array.from(o.entries(),([r,a])=>({name:r,count:a})).sort((r,a)=>a.count-r.count)}function i(){const o={os:`${s.type()} ${s.arch()} ${s.release()}`,memory:`${(s.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(s.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.virtualMachineHint.value()*100)}%`},r=s.cpus();return r&&r.length>0&&(o.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),o}async function d(o){try{const r=new Map,a=(0,R.join)(o,".vscode","launch.json"),l=await n.promises.readFile(a),P=[],y=(0,M.parse)(l.toString(),P);if(P.length)return console.log(`Unable to parse ${a}`),[];if((0,M.getNodeType)(y)==="object"&&y.configurations)for(const k of y.configurations){const T=k.type;T&&(r.has(T)?r.set(T,r.get(T)+1):r.set(T,1))}return I(r)}catch{return[]}}let t=class{constructor(r,a){this.telemetryService=r,this.productService=a}formatMachineInfo(r){const a=[];return a.push(`OS Version:       ${r.os}`),a.push(`CPUs:             ${r.cpus}`),a.push(`Memory (System):  ${r.memory}`),a.push(`VM:               ${r.vmHint}`),a.join(`
`)}formatEnvironment(r){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${s.type()} ${s.arch()} ${s.release()}`);const l=s.cpus();return l&&l.length>0&&a.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),a.push(`Memory (System):  ${(s.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(s.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||a.push(`Load (avg):       ${s.loadavg().map(P=>Math.round(P)).join(", ")}`),a.push(`VM:               ${Math.round(u.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${r.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(r,a){return Promise.all([(0,v.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async l=>{let[P,y]=l,k=this.formatProcessList(r,P);return a.forEach(T=>{if((0,h.isRemoteDiagnosticError)(T))k+=`
${T.errorMessage}`,y+=`
${T.errorMessage}`;else if(k+=`

Remote: ${T.hostName}`,T.processes&&(k+=`
${this.formatProcessList(r,T.processes)}`),T.workspaceMetadata){y+=`
|  Remote: ${T.hostName}`;for(const A of Object.keys(T.workspaceMetadata)){const C=T.workspaceMetadata[A];let _=`${C.fileCount} files`;C.maxFilesReached&&(_=`more than ${_}`),y+=`|    Folder (${A}): ${_}`,y+=this.formatWorkspaceStats(C)}}}),{processInfo:k,workspaceInfo:y}})}async getSystemInfo(r,a){const{memory:l,vmHint:P,os:y,cpus:k}=i(),T={os:y,memory:l,cpus:k,vmHint:P,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:a};return w.isWindows||(T.load=`${s.loadavg().map(A=>Math.round(A)).join(", ")}`),w.isLinux&&(T.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(T)}async getDiagnostics(r,a){const l=[];return(0,v.listProcesses)(r.mainPID).then(async P=>(l.push(""),l.push(this.formatEnvironment(r)),l.push(""),l.push(this.formatProcessList(r,P)),r.windows.some(y=>y.folderURIs&&y.folderURIs.length>0&&!y.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.formatWorkspaceMetadata(r))),a.forEach(y=>{if((0,h.isRemoteDiagnosticError)(y))l.push(`
${y.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${y.hostName}`),l.push(this.formatMachineInfo(y.machineInfo)),y.processes&&l.push(this.formatProcessList(r,y.processes)),y.workspaceMetadata)for(const k of Object.keys(y.workspaceMetadata)){const T=y.workspaceMetadata[k];let A=`${T.fileCount} files`;T.maxFilesReached&&(A=`more than ${A}`),l.push(`Folder (${k}): ${A}`),l.push(this.formatWorkspaceStats(T))}}),l.push(""),l.push(""),l.join(`
`)))}formatWorkspaceStats(r){const a=[];let P=0;const y=(C,_)=>{const H=` ${C}(${_})`;P+H.length>60?(a.push(k),k="|                 ",P=k.length):P+=H.length,k+=H};let k="|      File types:";const T=10,A=r.fileTypes.length>T?T:r.fileTypes.length;for(let C=0;C<A;C++){const _=r.fileTypes[C];y(_.name,_.count)}if(a.push(k),r.configFiles.length>=0&&(k="|      Conf files:",P=0,r.configFiles.forEach(C=>{y(C.name,C.count)}),a.push(k)),r.launchConfigFiles.length>0){let C="|      Launch Configs:";r.launchConfigFiles.forEach(_=>{const H=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`;C+=H}),a.push(C)}return a.join(`
`)}expandGPUFeatures(r){const a=Math.max(...Object.keys(r).map(l=>l.length));return Object.keys(r).map(l=>`${l}:  ${" ".repeat(a-l.length)}  ${r[l]}`).join(`
                  `)}formatWorkspaceMetadata(r){const a=[],l=[];return r.windows.forEach(P=>{P.folderURIs.length===0||P.remoteAuthority||(a.push(`|  Window (${P.title})`),P.folderURIs.forEach(y=>{const k=m.URI.revive(y);if(k.scheme===L.Schemas.file){const T=k.fsPath;l.push(D(T,["node_modules",".git"]).then(A=>{let C=`${A.fileCount} files`;A.maxFilesReached&&(C=`more than ${C}`),a.push(`|    Folder (${(0,R.basename)(T)}): ${C}`),a.push(this.formatWorkspaceStats(A))}).catch(A=>{a.push(`|      Error: Unable to collect workspace stats for folder ${T} (${A.toString()})`)}))}else a.push(`|    Folder (${k.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(P=>a.join(`
`)).catch(P=>`Unable to collect workspace stats: ${P}`)}formatProcessList(r,a){const l=new Map;r.windows.forEach(y=>l.set(y.pid,`window [${y.id}] (${y.title})`)),r.pidToNames.forEach(({pid:y,name:k})=>l.set(y,k));const P=[];return P.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(r.mainPID,l,P,a,0),P.join(`
`)}formatProcessItem(r,a,l,P,y){const k=y===0;let T;k?T=P.pid===r?`${this.productService.applicationName} main`:"remote agent":a.has(P.pid)?T=a.get(P.pid):T=`${"  ".repeat(y)} ${P.name}`;const A=process.platform==="win32"?P.mem:s.totalmem()*(P.mem/100);l.push(`${P.load.toFixed(0).padStart(5," ")}	${(A/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${P.pid.toFixed(0).padStart(6," ")}	${T}`),Array.isArray(P.children)&&P.children.forEach(C=>this.formatProcessItem(r,a,l,C,y+1))}async getWorkspaceFileExtensions(r){const a=new Set;for(const{uri:l}of r.folders){const P=m.URI.revive(l);if(P.scheme!==L.Schemas.file)continue;const y=P.fsPath;try{(await D(y,["node_modules",".git"])).fileTypes.forEach(T=>a.add(T.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(r){for(const{uri:a}of r.folders){const l=m.URI.revive(a);if(l.scheme!==L.Schemas.file)continue;const P=l.fsPath;try{const y=await D(P,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),y.fileTypes.forEach(k=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:k.name,count:k.count})}),y.launchConfigFiles.forEach(k=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:k.name,count:k.count})}),y.configFiles.forEach(k=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:k.name,count:k.count})}),this.telemetryService.publicLog2("workspace.stats.metadata",{duration:y.totalScanTime,reachedLimit:y.maxFilesReached,fileCount:y.fileCount,readdirCount:y.totalReaddirCount})}catch{}}}};e.DiagnosticsService=t,e.DiagnosticsService=t=Ie([re(0,S.ITelemetryService),re(1,E.IProductService)],t)}),define(ce[220],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class n{constructor(M){this.appenders=M}listen(M,L){throw new Error(`Event not found: ${L}`)}call(M,L,{eventName:R,data:w}){return this.appenders.forEach(c=>c.log(R,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=n;class s{constructor(M){this.channel=M}log(M,L){return this.channel.call("log",{eventName:M,data:L}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=s}),define(ce[57],le([0,1,37,11,74,128,24]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=m,e.isLoggingOnly=u,e.getTelemetryLevel=f,e.validateTelemetryData=v,e.cleanRemoteAuthority=g,e.isInternalTelemetry=S,e.getPiiPathsFromEnvironment=p,e.cleanData=i;class R{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class w{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class c{async publicLog(t,o,r){}async publicLogError(t,o,r){}}e.NullEndpointTelemetryService=c,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(d,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!d.enableTelemetry)}function u(d,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}function f(d){const t=d.getValue(L.TELEMETRY_SETTING_ID),o=d.getValue(L.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(d.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return L.TelemetryLevel.NONE;switch(t??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function v(d){const t={},o={},r={};E(d,r);for(let a in r){a=a.length>150?a.substr(a.length-149):a;const l=r[a];typeof l=="number"?o[a]=l:typeof l=="boolean"?o[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),t[a]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(t[a]=l)}return{properties:t,measurements:o}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(d){if(!d)return"none";const t=(0,b.getRemoteName)(d);return h.has(t)?t:"other"}function E(d,t,o=0,r){if(d)for(const a of Object.getOwnPropertyNames(d)){const l=d[a],P=r?r+a:a;Array.isArray(l)?t[P]=(0,n.safeStringify)(l):l instanceof Date?t[P]=l.toISOString():(0,s.isObject)(l)?o<2?E(l,t,o+1,P+"."):t[P]=(0,n.safeStringify)(l):t[P]=l}}function S(d,t){const o=d.msftInternalDomains||[],r=t.getValue("telemetry.internalTesting");return(0,M.verifyMicrosoftInternalDomain)(o)||r}function p(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}function D(d,t){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let o=d;const r=[];for(const y of t)for(;;){const k=y.exec(d);if(!k)break;r.push([k.index,y.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(o="";;){const y=l.exec(d);if(!y)break;const k=r.some(([T,A])=>y.index<A&&T<l.lastIndex);!a.test(y[0])&&!k&&(o+=d.substring(P,y.index)+"<REDACTED: user-file-path>",P=l.lastIndex)}return P<d.length&&(o+=d.substr(P)),o}function I(d){if(!d)return d;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of t)if(o.regex.test(d))return`<REDACTED: ${o.label}>`;return d}function i(d,t){return(0,n.cloneAndChange)(d,o=>{if(o instanceof R||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let r=o.replaceAll("%20"," ");r=D(r,t);for(const a of t)r=r.replace(a,"");return r=I(r),r}})}}),define(ce[129],le([0,1,25,126,85,3,7,15,36,57]),function(V,e,n,s,b,M,L,R,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=m,e.getIdAndVersion=h,e.getExtensionId=g,e.adoptToGalleryExtensionId=E,e.getGalleryExtensionId=S,e.groupByExtension=p,e.getLocalExtensionTelemetryData=D,e.getGalleryExtensionTelemetryData=I,e.getExtensionDependencies=i,e.computeTargetPlatform=t;function m(o,r){return o.uuid&&r.uuid?o.uuid===r.uuid:o.id===r.id?!0:(0,n.compareIgnoreCase)(o.id,r.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(r){const a=r.manifest?r.manifest.version:r.version,l=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new f(r.identifier,a,l)}static parse(r){const a=u.exec(r);return a&&a[1]&&a[2]?new f({id:a[1]},a[2],a[4]||void 0):null}constructor(r,a,l=b.TargetPlatform.UNDEFINED){this.identifier=r,this.version=a,this.targetPlatform=l,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==b.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof f?m(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=f;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(o){const r=v.exec(o);return r&&r[1]?[E(r[1]),r[2]]:[E(o),void 0]}function g(o,r){return`${o}.${r}`}function E(o){return o.toLowerCase()}function S(o,r){return E(g(o??b.UNDEFINED_PUBLISHER,r))}function p(o,r){const a=[],l=P=>{for(const y of a)if(y.some(k=>m(r(k),r(P))))return y;return null};for(const P of o){const y=l(P);y?y.push(P):a.push([P])}return a}function D(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function I(o){return{id:new c.TelemetryTrustedValue(o.identifier.id),name:new c.TelemetryTrustedValue(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function i(o,r){const a=[],l=r.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const P=l.shift();if(P&&a.every(y=>!m(y.identifier,{id:P}))){const y=o.filter(k=>m(k.identifier,{id:P}));y.length===1&&(a.push(y[0]),l.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function d(o,r){if(!M.isLinux)return!1;let a;try{a=(await o.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await o.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(P){r.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(P))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function t(o,r){const a=await d(o,r),l=(0,s.getTargetPlatform)(a?"alpine":M.platform,w.arch);return r.debug("ComputeTargetPlatform:",l),l}});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[221],le([0,1,2,37,3,25,10,16,56,72,28,45,24,57]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0,c=je(c);let h=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(S,p,D){this._configurationService=p,this._productService=D,this._experimentProperties={},this._disposables=new n.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=S.piiPaths||[],this._telemetryLevel=f.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(I),"gi")),I.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(I.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(I=>{(I.affectsConfiguration(f.TELEMETRY_SETTING_ID)||I.affectsConfiguration(f.TELEMETRY_OLD_SETTING_ID)||I.affectsConfiguration(f.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(S,p){this._experimentProperties[S]=p}_updateTelemetryLevel(){let S=(0,v.getTelemetryLevel)(this._configurationService);const p=this._productService.enabledTelemetryLevels;if(p){this._sendErrorTelemetry=this.sendErrorTelemetry?p.error:!1;const D=p.usage?f.TelemetryLevel.USAGE:p.error?f.TelemetryLevel.ERROR:f.TelemetryLevel.NONE;S=Math.min(S,D)}this._telemetryLevel=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(S,p,D){this._telemetryLevel<p||(D=(0,s.mixin)(D,this._experimentProperties),D=(0,v.cleanData)(D,this._cleanupPatterns),D=(0,s.mixin)(D,this._commonProperties),this._appenders.forEach(I=>I.log(S,D)))}publicLog(S,p){this._log(S,f.TelemetryLevel.USAGE,p)}publicLog2(S,p){this.publicLog(S,p)}publicLogError(S,p){this._sendErrorTelemetry&&this._log(S,f.TelemetryLevel.ERROR,p)}publicLogError2(S,p){this.publicLogError(S,p)}};e.TelemetryService=h,e.TelemetryService=h=Ie([re(1,R.IConfigurationService),re(2,m.IProductService)],h);function g(){const E=(0,L.localize)(11198,null,c.default.nameLong),S=c.default.privacyStatementUrl?(0,L.localize)(11200,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,L.localize)(11199,null,"https://aka.ms/vscode-telemetry"),p=b.isWeb?"":(0,L.localize)(11201,null),D=(0,L.localize)(11202,null),I=(0,L.localize)(11203,null),i=(0,L.localize)(11204,null),d=(0,L.localize)(11205,null),t=`
|       | ${D} | ${I} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,L.localize)(11206,null);return`
${E} ${S} ${p}

&nbsp;

${d}
${t}

&nbsp;

${o}
`}u.Registry.as(w.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,L.localize)(11207,null),properties:{[f.TELEMETRY_SETTING_ID]:{type:"string",enum:[f.TelemetryConfiguration.ON,f.TelemetryConfiguration.ERROR,f.TelemetryConfiguration.CRASH,f.TelemetryConfiguration.OFF],enumDescriptions:[(0,L.localize)(11208,null),(0,L.localize)(11209,null),(0,L.localize)(11210,null),(0,L.localize)(11211,null)],markdownDescription:g(),default:f.TelemetryConfiguration.OFF,restricted:!0,scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.Registry.as(w.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(11212,null),properties:{[f.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,L.localize)(11214,null,c.default.nameLong,c.default.privacyStatementUrl):(0,L.localize)(11213,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(11215,null,`\`#${f.TELEMETRY_SETTING_ID}#\``),scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[222],le([0,1,3,92,24]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=M,e.resolveSqmId=L,e.resolvedevDeviceId=R;async function M(w,c){let m=w.getItem(b.machineIdKey);return(typeof m!="string"||n.isMacintosh&&m==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(m=await(0,s.getMachineId)(c.error.bind(c))),m}async function L(w,c){let m=w.getItem(b.sqmIdKey);return typeof m!="string"&&(m=await(0,s.getSqmMachineId)(c.error.bind(c))),m}async function R(w,c){let m=w.getItem(b.devDeviceIdKey);return typeof m!="string"&&(m=await(0,s.getdevDeviceId)(c.error.bind(c))),m}}),define(ce[223],le([0,1,24,222]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=b,e.resolveSqmId=M,e.resolvedevDeviceId=L;async function b(R,w){const c=await(0,s.resolveMachineId)(R,w);return R.setItem(n.machineIdKey,c),c}async function M(R,w){const c=await(0,s.resolveSqmId)(R,w);return R.setItem(n.sqmIdKey,c),c}async function L(R,w){const c=await(0,s.resolvedevDeviceId)(R,w);return R.setItem(n.devDeviceIdKey,c),c}}),define(ce[130],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(s){s[s.Replace=1]="Replace",s[s.Append=2]="Append",s[s.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(ce[224],le([0,1,3,130]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const b=new Map([[s.EnvironmentVariableMutatorType.Append,"APPEND"],[s.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[s.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(m){this.collections=m,this.map=new Map,this.descriptionMap=new Map,m.forEach((u,f)=>{this.populateDescriptionMap(u,f);const v=u.map.entries();let h=v.next();for(;!h.done;){const g=h.value[1],E=h.value[0];let S=this.map.get(E);if(S||(S=[],this.map.set(E,S)),S.length>0&&S[0].type===s.EnvironmentVariableMutatorType.Replace){h=v.next();continue}const p={extensionIdentifier:f,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};p.scope||delete p.scope,S.unshift(p),h=v.next()}})}async applyToProcessEnvironment(m,u,f){let v;n.isWindows&&(v={},Object.keys(m).forEach(h=>v[h.toLowerCase()]=h));for(const[h,g]of this.getVariableMap(u)){const E=n.isWindows&&v[h.toLowerCase()]||h;for(const S of g){const p=f?await f(S.value):S.value;if(S.options?.applyAtProcessCreation??!0)switch(S.type){case s.EnvironmentVariableMutatorType.Append:m[E]=(m[E]||"")+p;break;case s.EnvironmentVariableMutatorType.Prepend:m[E]=p+(m[E]||"");break;case s.EnvironmentVariableMutatorType.Replace:m[E]=p;break}if(S.options?.applyAtShellIntegration??!1){const D=`VSCODE_ENV_${b.get(S.type)}`;m[D]=(m[D]?m[D]+":":"")+h+"="+this._encodeColons(p)}}}}_encodeColons(m){return m.replaceAll(":","\\x3a")}diff(m,u){const f=new Map,v=new Map,h=new Map;if(m.getVariableMap(u).forEach((g,E)=>{const S=this.getVariableMap(u).get(E),p=R(g,S);p&&f.set(E,p)}),this.getVariableMap(u).forEach((g,E)=>{const S=m.getVariableMap(u).get(E),p=R(g,S);p&&h.set(E,p)}),this.getVariableMap(u).forEach((g,E)=>{const S=m.getVariableMap(u).get(E),p=w(g,S);p&&v.set(E,p)}),!(f.size===0&&v.size===0&&h.size===0))return{added:f,changed:v,removed:h}}getVariableMap(m){const u=new Map;for(const f of this.map.values()){const v=f.filter(h=>L(h,m));v.length>0&&u.set(v[0].variable,v)}return u}getDescriptionMap(m){const u=new Map;for(const f of this.descriptionMap.values()){const v=f.filter(h=>L(h,m,!0));for(const h of v)u.set(h.extensionIdentifier,h.description)}return u}populateDescriptionMap(m,u){if(!m.descriptionMap)return;const f=m.descriptionMap.entries();let v=f.next();for(;!v.done;){const h=v.value[1],g=v.value[0];let E=this.descriptionMap.get(g);E||(E=[],this.descriptionMap.set(g,E));const S={extensionIdentifier:u,scope:h.scope,description:h.description};S.scope||delete S.scope,E.push(S),v=f.next()}}}e.MergedEnvironmentVariableCollection=M;function L(c,m,u=!1){return c.scope?!!(c.scope.workspaceFolder&&m?.workspaceFolder&&c.scope.workspaceFolder.index===m.workspaceFolder.index):u?m===c.scope:!0}function R(c,m){if(!m)return c;const u=new Set;m.forEach(v=>u.add(v.extensionIdentifier));const f=[];return c.forEach(v=>{u.has(v.extensionIdentifier)||f.push(v)}),f.length===0?void 0:f}function w(c,m){if(!m)return;const u=new Map;m.forEach(v=>u.set(v.extensionIdentifier,v));const f=[];return c.forEach(v=>{const h=u.get(v.extensionIdentifier);h&&(v.type!==h.type||v.value!==h.value||v.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index)&&f.push(h)}),f.length===0?void 0:f}}),define(ce[225],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=n,e.serializeEnvironmentDescriptionMap=s,e.deserializeEnvironmentVariableCollection=b,e.deserializeEnvironmentDescriptionMap=M,e.serializeEnvironmentVariableCollections=L,e.deserializeEnvironmentVariableCollections=R;function n(w){return[...w.entries()]}function s(w){return w?[...w.entries()]:[]}function b(w){return new Map(w)}function M(w){return new Map(w??[])}function L(w){return Array.from(w.entries()).map(c=>[c[0],n(c[1].map),s(c[1].descriptionMap)])}function R(w){return new Map(w.map(c=>[c[0],{map:b(c[1]),descriptionMap:M(c[2])}]))}}),define(ce[226],le([0,1,8,22,4,2,5]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends M.Disposable{constructor(c,m){super(),this._logService=m,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new b.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=c===void 0?15e3:c,this._register((0,M.toDisposable)(()=>{for(const u of this._pendingRequestDisposables.values())(0,M.dispose)(u)}))}createRequest(c){return new Promise((m,u)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,m),this._onCreateRequest.fire({requestId:f,...c});const v=new s.CancellationTokenSource;(0,n.timeout)(this._timeout,v.token).then(()=>u(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,M.toDisposable)(()=>v.cancel())])})}acceptReply(c,m){const u=this._pendingRequests.get(c);u?(this._pendingRequests.delete(c),(0,M.dispose)(this._pendingRequestDisposables.get(c)||[]),this._pendingRequestDisposables.delete(c),u(m)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.RequestStore=R,e.RequestStore=R=Ie([re(1,L.ILogService)],R)}),define(ce[75],le([0,1,6,122,45]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new s.RawContextKey("terminalTabFocusMode",!1,!0);var M;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var L;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var R;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(R||(e.PosixShellType=R={}));var w;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(w||(e.WindowsShellType=w={}));var c;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var m;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var u;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.IPtyService=(0,n.createDecorator)("ptyService");var f;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(f||(e.HeartbeatConstants=f={}));var v;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(v||(e.TerminalLocation=v={}));var h;(function(i){i.TerminalView="view",i.Editor="editor"})(h||(e.TerminalLocationString=h={}));var g;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var E;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(E||(e.FlowControlConstants=E={}));var S;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(S||(e.ProfileSource=S={}));var p;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(p||(e.ShellIntegrationStatus=p={}));var D;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(D||(e.TerminalExitReason=D={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class I{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(d){const t=this._sanitizeRemoteAuthority(d.remoteAuthority);if(this._backends.has(t))throw new Error(`A terminal backend with remote authority '${t}' was already registered.`);this._backends.set(t,d)}getTerminalBackend(d){return this._backends.get(this._sanitizeRemoteAuthority(d))}_sanitizeRemoteAuthority(d){return d?.toLowerCase()??""}}b.Registry.add(e.TerminalExtensions.Backend,new I),e.ILocalPtyService=(0,n.createDecorator)("localPtyService"),e.ITerminalLogService=(0,n.createDecorator)("terminalLogService")}),define(ce[227],le([0,1,80,7,10,110]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=L,e.terminalProfileArgsMatch=c,e.terminalIconsEqual=m,e.isUriComponents=u;function L(f,v){const h=[{name:null,description:(0,b.localize)(11165,null)}];return h.push(...f.map(g=>({name:g.profileName,description:R(g)}))),v&&h.push(...v.map(g=>({name:g.title,description:w(g)}))),{values:h.map(g=>g.name),markdownDescriptions:h.map(g=>g.description)}}function R(f){let v=`$(${M.ThemeIcon.isThemeIcon(f.icon)?f.icon.id:f.icon?f.icon:n.Codicon.terminal.id}) ${f.profileName}
- path: ${f.path}`;return f.args&&(typeof f.args=="string"?v+=`
- args: "${f.args}"`:v+=`
- args: [${f.args.length===0?"":`'${f.args.join("','")}'`}]`),f.overrideName!==void 0&&(v+=`
- overrideName: ${f.overrideName}`),f.color&&(v+=`
- color: ${f.color}`),f.env&&(v+=`
- env: ${JSON.stringify(f.env)}`),v}function w(f){return`$(${M.ThemeIcon.isThemeIcon(f.icon)?f.icon.id:f.icon?f.icon:n.Codicon.terminal.id}) ${f.title}
- extensionIdentifier: ${f.extensionIdentifier}`}function c(f,v){if(!f&&!v)return!0;if(typeof f=="string"&&typeof v=="string")return f===v;if(Array.isArray(f)&&Array.isArray(v)){if(f.length!==v.length)return!1;for(let h=0;h<f.length;h++)if(f[h]!==v[h])return!1;return!0}return!1}function m(f,v){if(!f&&!v)return!0;if(!f||!v)return!1;if(M.ThemeIcon.isThemeIcon(f)&&M.ThemeIcon.isThemeIcon(v))return f.id===v.id&&f.color===v.color;if(typeof f=="object"&&"light"in f&&"dark"in f&&typeof v=="object"&&"light"in v&&"dark"in v){const h=f,g=v;if((s.URI.isUri(h.light)||u(h.light))&&(s.URI.isUri(h.dark)||u(h.dark))&&(s.URI.isUri(g.light)||u(g.light))&&(s.URI.isUri(g.dark)||u(g.dark)))return h.light.path===g.light.path&&h.dark.path===g.dark.path}if(s.URI.isUri(f)&&s.URI.isUri(v)||u(f)||u(v)){const h=f,g=v;return h.path===g.path&&h.scheme===g.scheme}return!1}function u(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}}),define(ce[228],le([0,1,80,3,10,56,45,75,227]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalIconSchema=e.terminalColorSchema=void 0,e.registerTerminalPlatformConfiguration=h,e.registerTerminalDefaultProfileConfiguration=E,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,n.getAllCodicons)(),S=>S.id),markdownEnumDescriptions:Array.from((0,n.getAllCodicons)(),S=>`$(${S.id})`)};const c={args:{description:(0,b.localize)(11166,null),type:"array",items:{type:"string"}},overrideName:{description:(0,b.localize)(11167,null),type:"boolean"},icon:{description:(0,b.localize)(11168,null),...e.terminalIconSchema},color:{description:(0,b.localize)(11169,null),...e.terminalColorSchema},env:{markdownDescription:(0,b.localize)(11170,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,b.localize)(11171,null),type:["string","array"],items:{type:"string"}},...c}},u={type:"object",required:["path"],properties:{path:{description:(0,b.localize)(11172,null),type:["string"],items:{type:"string"}},...c}};function f(S){const p=S===s.Platform.Linux?"linux":S===s.Platform.Mac?"osx":"windows";return(0,b.localize)(11173,null,(0,s.PlatformToString)(S),'```json\n"terminal.integrated.profile.'+p+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,b.localize)(11174,null),type:"object",properties:{[R.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,b.localize)(11175,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,b.localize)(11176,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,b.localize)(11177,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:f(s.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,b.localize)(11178,null),enum:["PowerShell","Git Bash"]},...c}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,b.localize)(11179,null),type:"string"},id:{description:(0,b.localize)(11180,null),type:"string"},title:{description:(0,b.localize)(11181,null),type:"string"},...c}},{type:"null"},m]}},[R.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:f(s.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,b.localize)(11182,null),type:"string"},id:{description:(0,b.localize)(11183,null),type:"string"},title:{description:(0,b.localize)(11184,null),type:"string"},...c}},{type:"null"},m]}},[R.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:f(s.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,b.localize)(11185,null),type:"string"},id:{description:(0,b.localize)(11186,null),type:"string"},title:{description:(0,b.localize)(11187,null),type:"string"},...c}},{type:"null"},m]}},[R.TerminalSettingId.UseWslProfiles]:{description:(0,b.localize)(11188,null),type:"boolean",default:!0},[R.TerminalSettingId.InheritEnv]:{scope:M.ConfigurationScope.APPLICATION,description:(0,b.localize)(11189,null),type:"boolean",default:!0},[R.TerminalSettingId.PersistentSessionScrollback]:{scope:M.ConfigurationScope.APPLICATION,markdownDescription:(0,b.localize)(11190,null),type:"number",default:100},[R.TerminalSettingId.ShowLinkHover]:{scope:M.ConfigurationScope.APPLICATION,description:(0,b.localize)(11191,null),type:"boolean",default:!0},[R.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,b.localize)(11192,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){L.Registry.as(M.Extensions.Configuration).registerConfiguration(v),E()}let g;function E(S,p){const D=L.Registry.as(M.Extensions.Configuration);let I;S&&(I=(0,w.createProfileSchemaEnums)(S?.profiles,p));const i=g;g={id:"terminal",order:100,title:(0,b.localize)(11193,null),type:"object",properties:{[R.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,b.localize)(11194,null),type:["string","null"],default:null,enum:S?.os===s.OperatingSystem.Linux?I?.values:void 0,markdownEnumDescriptions:S?.os===s.OperatingSystem.Linux?I?.markdownDescriptions:void 0},[R.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,b.localize)(11195,null),type:["string","null"],default:null,enum:S?.os===s.OperatingSystem.Macintosh?I?.values:void 0,markdownEnumDescriptions:S?.os===s.OperatingSystem.Macintosh?I?.markdownDescriptions:void 0},[R.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,b.localize)(11196,null),type:["string","null"],default:null,enum:S?.os===s.OperatingSystem.Windows?I?.values:void 0,markdownEnumDescriptions:S?.os===s.OperatingSystem.Windows?I?.markdownDescriptions:void 0}}},D.updateConfigurations({add:[g],remove:i?[i]:[]})}}),define(ce[229],le([0,1,27,12,37,9,3,36,25,11,23,130,225,224]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=h,e.findExecutable=g,e.getShellIntegrationInjection=E,n=De(n),M=De(M),R=De(R),m=De(m);function h(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let P=0;return l&&l.length===4&&(P=parseInt(l[3])),P}async function g(l,P,y,k=R.env,T=m.Promises.exists){if(M.isAbsolute(l))return await T(l)?l:void 0;if(P===void 0&&(P=R.cwd()),M.dirname(l)!=="."){const H=M.join(P,l);return await T(H)?H:void 0}const C=(0,b.getCaseInsensitive)(k,"PATH");if(y===void 0&&(0,c.isString)(C)&&(y=C.split(M.delimiter)),y===void 0||y.length===0){const H=M.join(P,l);return await T(H)?H:void 0}for(const H of y){let q;if(M.isAbsolute(H)?q=M.join(H,l):q=M.join(P,H,l),await T(q))return q;if(L.isWindows){let K=q+".com";if(await T(K)||(K=q+".exe",await T(K)))return K}}const _=M.join(P,l);return await T(_)?_:void 0}function E(l,P,y,k,T){const A=L.isWindows&&(!P.windowsEnableConpty||h()<18309);if(!P.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||A)return;const C=l.args,_=R.platform==="win32"?M.basename(l.executable).toLowerCase():M.basename(l.executable),H=M.dirname(s.FileAccess.asFileUri("").fsPath);let q;const K={VSCODE_INJECTION:"1"};if(P.shellIntegration.nonce&&(K.VSCODE_NONCE=P.shellIntegration.nonce),L.isWindows){if(_==="pwsh.exe"||_==="powershell.exe")return!C||r(C)?q=D.get(p.WindowsPwsh):o(C)&&(q=D.get(p.WindowsPwshLogin)),q?(q=[...q],q[q.length-1]=(0,w.format)(q[q.length-1],H,""),K.VSCODE_STABLE=T.quality==="stable"?"1":"0",P.shellIntegration.suggestEnabled&&(K.VSCODE_SUGGEST="1"),{newArgs:q,envMixin:K}):void 0;if(_==="bash.exe")return!C||C.length===0?q=D.get(p.Bash):a(C)&&(K.VSCODE_SHELL_LOGIN="1",S(P,K),q=D.get(p.Bash)),q?(q=[...q],q[q.length-1]=(0,w.format)(q[q.length-1],H),K.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:q,envMixin:K}):void 0;k.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(_){case"bash":return!C||C.length===0?q=D.get(p.Bash):a(C)&&(K.VSCODE_SHELL_LOGIN="1",S(P,K),q=D.get(p.Bash)),q?(q=[...q],q[q.length-1]=(0,w.format)(q[q.length-1],H),K.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:q,envMixin:K}):void 0;case"fish":{const fe=y?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",$=M.join(H,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return K.XDG_DATA_DIRS=`${fe}:${$}`,S(P,K),{newArgs:void 0,envMixin:K}}case"pwsh":return!C||r(C)?q=D.get(p.Pwsh):o(C)&&(q=D.get(p.PwshLogin)),q?(P.shellIntegration.suggestEnabled&&(K.VSCODE_SUGGEST="1"),q=[...q],q[q.length-1]=(0,w.format)(q[q.length-1],H,""),K.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:q,envMixin:K}):void 0;case"zsh":{if(!C||C.length===0?q=D.get(p.Zsh):a(C)?(q=D.get(p.ZshLogin),S(P,K)):(C===D.get(p.Zsh)||C===D.get(p.ZshLogin))&&(q=C),!q)return;q=[...q],q[q.length-1]=(0,w.format)(q[q.length-1],H);let fe;try{fe=n.userInfo().username}catch{fe="unknown"}const $=M.join(n.tmpdir(),`${fe}-${T.applicationName}-zsh`);K.ZDOTDIR=$;const X=y?.ZDOTDIR??n.homedir()??"~";K.USER_ZDOTDIR=X;const B=[];return B.push({source:M.join(H,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.join($,".zshrc")}),B.push({source:M.join(H,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.join($,".zprofile")}),B.push({source:M.join(H,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.join($,".zshenv")}),B.push({source:M.join(H,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.join($,".zlogin")}),{newArgs:q,envMixin:K,filesToCopy:B}}}k.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function S(l,P){if(L.isMacintosh&&l.environmentVariableCollections){const y=(0,f.deserializeEnvironmentVariableCollections)(l.environmentVariableCollections),T=new v.MergedEnvironmentVariableCollection(y).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),A=[];if(T)for(const C of T)C.type===u.EnvironmentVariableMutatorType.Prepend&&A.push(C.value);A.length>0&&(P.VSCODE_PATH_PREFIX=A.join(""))}}var p;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(p||(p={}));const D=new Map;D.set(p.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),D.set(p.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),D.set(p.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),D.set(p.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),D.set(p.Zsh,["-i"]),D.set(p.ZshLogin,["-il"]),D.set(p.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const I=["-login","-l"],i=["--login","-l"],d=["-i","--interactive"],t=["-nol","-nologo"];function o(l){return typeof l=="string"?I.includes(l.toLowerCase()):l.length===1&&I.includes(l[0].toLowerCase())||l.length===2&&(I.includes(l[0].toLowerCase())||I.includes(l[1].toLowerCase()))&&(t.includes(l[0].toLowerCase())||t.includes(l[1].toLowerCase()))}function r(l){return typeof l=="string"?t.includes(l.toLowerCase()):l.length===0||l?.length===1&&t.includes(l[0].toLowerCase())}function a(l){return typeof l!="string"&&(l=l.filter(P=>!d.includes(P.toLowerCase()))),l==="string"&&i.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&i.includes(l[0].toLowerCase())}}),define(ce[230],le([0,1,26,48,80,9,3,11,23,114,75,229,121]),function(V,e,n,s,b,M,L,R,w,c,m,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=E,n=De(n),s=De(s),w=De(w);var v;(function(y){y.UnixShellsPath="/etc/shells"})(v||(v={}));let h,g=!0;function E(y,k,T,A,C=process.env,_,H,q,K){return _=_||{existsFile:w.SymlinkSupport.existsFile,readFile:n.promises.readFile},L.isWindows?S(T,_,C,H,A.getValue(m.TerminalSettingId.UseWslProfiles)!==!1,y&&typeof y=="object"?{...y}:A.getValue(m.TerminalSettingId.ProfilesWindows),typeof k=="string"?k:A.getValue(m.TerminalSettingId.DefaultProfileWindows),K,q):a(_,H,T,y&&typeof y=="object"?{...y}:A.getValue(L.isLinux?m.TerminalSettingId.ProfilesLinux:m.TerminalSettingId.ProfilesMacOs),typeof k=="string"?k:A.getValue(L.isLinux?m.TerminalSettingId.DefaultProfileLinux:m.TerminalSettingId.DefaultProfileMacOs),K,q,C)}async function S(y,k,T,A,C,_,H,q,K){const fe=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),$=`${process.env.windir}\\${fe?"Sysnative":"System32"}`;let X=!1;(0,u.getWindowsBuildNumber)()>=16299&&(X=!0),await i(q);const B=new Map;if(y){B.set("PowerShell",{source:m.ProfileSource.Pwsh,icon:b.Codicon.terminalPowershell,isAutoDetected:!0}),B.set("Windows PowerShell",{path:`${$}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:b.Codicon.terminalPowershell,isAutoDetected:!0}),B.set("Git Bash",{source:m.ProfileSource.GitBash,isAutoDetected:!0}),B.set("Command Prompt",{path:`${$}\\cmd.exe`,icon:b.Codicon.terminalCmd,isAutoDetected:!0}),B.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),B.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:b.Codicon.terminalBash,isAutoDetected:!0});const U=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;B.set("Cmder",{path:`${$}\\cmd.exe`,args:["/K",U],requiresPath:process.env.CMDER_ROOT?U:{path:U,isUnsafe:!0},isAutoDetected:!0})}l(_,B);const J=await p(B.entries(),H,k,T,A,K);if(y&&C)try{const U=await o(`${$}\\${X?"wsl":"bash"}.exe`,H);for(const O of U)(!_||!(O.profileName in _))&&J.push(O)}catch{g&&(A?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return J}async function p(y,k,T,A=process.env,C,_){const H=[];for(const[q,K]of y)H.push(D(q,K,k,T,A,C,_));return(await Promise.all(H)).filter(q=>!!q)}async function D(y,k,T,A,C=process.env,_,H){if(k===null)return;let q,K,fe;if("source"in k&&!("path"in k)){const J=h?.get(k.source);if(!J)return;q=J.paths,K=k.args||J.args,k.icon?fe=I(k.icon):J.icon&&(fe=J.icon)}else q=Array.isArray(k.path)?k.path:[k.path],K=L.isWindows||Array.isArray(k.args)?k.args:void 0,fe=I(k.icon);let $;if(H){const J=q.map(O=>typeof O=="string"?O:O.path),U=await H(J);$=new Array(q.length);for(let O=0;O<q.length;O++)typeof q[O]=="string"?$[O]=U[O]:$[O]={path:U[O],isUnsafe:!0}}else $=q.slice();let X;if(k.requiresPath){let J;if((0,R.isString)(k.requiresPath)?J=k.requiresPath:(J=k.requiresPath.path,k.requiresPath.isUnsafe&&(X=J)),!await A.existsFile(J))return}const B=await P(y,T,$,A,C,K,k.env,k.overrideName,k.isAutoDetected,X);if(!B){_?.debug("Terminal profile not validated",y,q);return}return B.isAutoDetected=k.isAutoDetected,B.icon=fe,B.color=k.color,B}function I(y){return typeof y=="string"?{id:y}:y}async function i(y){if(h&&!y)return;const[k,T]=await Promise.all([d(),y||t()]);h=new Map,h.set(m.ProfileSource.GitBash,{profileName:"Git Bash",paths:k,args:["--login","-i"]}),h.set(m.ProfileSource.Pwsh,{profileName:"PowerShell",paths:T,icon:b.Codicon.terminalPowershell})}async function d(){const y=new Set,k=await(0,u.findExecutable)("git.exe");if(k){const C=(0,f.dirname)(k);y.add((0,f.resolve)(C,"../.."))}function T(C,_){_&&C.add(_)}T(y,process.env.ProgramW6432),T(y,process.env.ProgramFiles),T(y,process.env["ProgramFiles(X86)"]),T(y,`${process.env.LocalAppData}\\Program`);const A=[];for(const C of y)A.push(`${C}\\Git\\bin\\bash.exe`,`${C}\\Git\\usr\\bin\\bash.exe`,`${C}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function t(){const y=[];for await(const k of(0,c.enumeratePowerShellInstallations)())y.push(k.exePath);return y}async function o(y,k){const T=[],A=await new Promise((H,q)=>{s.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(K,fe)=>{if(K)return q("Problem occurred when getting wsl distros");H(fe)})});if(!A)return[];const C=new RegExp(/[\r?\n]/),_=A.split(C).filter(H=>H.trim().length>0&&H!=="");for(const H of _){if(H===""||H.startsWith("docker-desktop"))continue;const q=`${H} (WSL)`,K={profileName:q,path:y,args:["-d",`${H}`],isDefault:q===k,icon:r(H),isAutoDetected:!1};T.push(K)}return T}function r(y){return y.includes("Ubuntu")?b.Codicon.terminalUbuntu:y.includes("Debian")?b.Codicon.terminalDebian:b.Codicon.terminalLinux}async function a(y,k,T,A,C,_,H,q){const K=new Map;if(T&&await y.existsFile(v.UnixShellsPath)){const fe=(await y.readFile(v.UnixShellsPath)).toString(),$=(_||fe.split(`
`)).map(B=>{const J=B.indexOf("#");return J===-1?B:B.substring(0,J)}).filter(B=>B.trim().length>0),X=new Map;for(const B of $){let J=(0,M.basename)(B),U=X.get(J)||0;U++,U>1&&(J=`${J} (${U})`),X.set(J,U),K.set(J,{path:B,isAutoDetected:!0})}}return l(A,K),await p(K.entries(),C,y,q,k,H)}function l(y,k){if(y)for(const[T,A]of Object.entries(y))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?k.delete(T):(A.icon=A.icon||k.get(T)?.icon,k.set(T,A))}async function P(y,k,T,A,C,_,H,q,K,fe){if(T.length===0)return Promise.resolve(void 0);const $=T.shift();if($==="")return P(y,k,T,A,C,_,H,q,K);const X=typeof $!="string"&&$.isUnsafe,B=typeof $=="string"?$:$.path,J={profileName:y,path:B,args:_,env:H,overrideName:q,isAutoDetected:K,isDefault:y===k,isUnsafePath:X,requiresUnsafePath:fe};if((0,M.basename)(B)===B){const O=C.PATH?C.PATH.split(M.delimiter):void 0,N=await(0,u.findExecutable)(B,void 0,O,void 0,A.existsFile);return N?(J.path=N,J.isFromPath=!0,J):P(y,k,T,A,C,_)}return await A.existsFile((0,M.normalize)(B))?J:P(y,k,T,A,C,_,H,q,K)}}),define(ce[231],le([0,1,4,2,3,44,16,5,193,100,226,75,228,230,116,66]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var E;(function(p){p[p.MaxRestarts=5]="MaxRestarts"})(E||(E={}));let S=class extends s.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(D,I,i,d){super(),this._ptyHostStarter=D,this._configurationService=I,this._logService=i,this._loggerService=d,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new n.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new n.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new n.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new n.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new n.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new n.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new n.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new n.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new n.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new n.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new n.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new n.Emitter),this.onProcessExit=this._onProcessExit.event,(0,f.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,s.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new m.RequestStore(void 0,this._logService)),this._register(this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables)),this._ptyHostStarter.onRequestConnection&&this._register(n.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost())),this._ptyHostStarter.onWillShutdown&&this._register(this._ptyHostStarter.onWillShutdown(()=>this._wasQuitRequested=!0))}get _ignoreProcessNames(){return this._configurationService.getValue(u.TerminalSettingId.IgnoreProcessNames)}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(b.isWindows)return process.env;try{return await(0,c.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(D){return this._logService.error("ptyHost was unable to resolve shell environment",D),{}}}_startPtyHost(){const D=this._ptyHostStarter.start(),I=D.client;this._logService.getLevel()===R.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(I.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(D.onDidProcessExit(t=>{this._onPtyHostExit.fire(t.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=E.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${t.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const d=M.ProxyChannel.toService(I.getChannel(u.TerminalIpcChannels.PtyHost));return this._register(d.onProcessData(t=>this._onProcessData.fire(t))),this._register(d.onProcessReady(t=>this._onProcessReady.fire(t))),this._register(d.onProcessExit(t=>this._onProcessExit.fire(t))),this._register(d.onDidChangeProperty(t=>this._onDidChangeProperty.fire(t))),this._register(d.onProcessReplay(t=>this._onProcessReplay.fire(t))),this._register(d.onProcessOrphanQuestion(t=>this._onProcessOrphanQuestion.fire(t))),this._register(d.onDidRequestDetach(t=>this._onDidRequestDetach.fire(t))),this._register(new w.RemoteLoggerChannelClient(this._loggerService,I.getChannel(u.TerminalIpcChannels.Logger))),this.__connection=D,this.__proxy=d,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async t=>{t.affectsConfiguration(u.TerminalSettingId.IgnoreProcessNames)&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[D,d]}async createProcess(D,I,i,d,t,o,r,a,l,P,y){const k=setTimeout(()=>this._handleUnresponsiveCreateProcess(),u.HeartbeatConstants.CreateProcessTimeout),T=await this._proxy.createProcess(D,I,i,d,t,o,r,a,l,P,y);return clearTimeout(k),T}updateTitle(D,I,i){return this._proxy.updateTitle(D,I,i)}updateIcon(D,I,i,d){return this._proxy.updateIcon(D,I,i,d)}attachToProcess(D){return this._proxy.attachToProcess(D)}detachFromProcess(D,I){return this._proxy.detachFromProcess(D,I)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(D){return this._proxy.start(D)}shutdown(D,I){return this._proxy.shutdown(D,I)}input(D,I){return this._proxy.input(D,I)}processBinary(D,I){return this._proxy.processBinary(D,I)}resize(D,I,i){return this._proxy.resize(D,I,i)}clearBuffer(D){return this._proxy.clearBuffer(D)}acknowledgeDataEvent(D,I){return this._proxy.acknowledgeDataEvent(D,I)}setUnicodeVersion(D,I){return this._proxy.setUnicodeVersion(D,I)}getInitialCwd(D){return this._proxy.getInitialCwd(D)}getCwd(D){return this._proxy.getCwd(D)}async getLatency(){const D=new g.StopWatch,I=await this._proxy.getLatency();return D.stop(),[{label:"ptyhostservice<->ptyhost",latency:D.elapsed()},...I]}orphanQuestionReply(D){return this._proxy.orphanQuestionReply(D)}installAutoReply(D,I){return this._proxy.installAutoReply(D,I)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(D){return this._proxy.uninstallAutoReply(D)}getDefaultSystemShell(D){return this._optionalProxy?.getDefaultSystemShell(D)??(0,h.getSystemShell)(D??b.OS,process.env)}async getProfiles(D,I,i,d=!1){const t=await this._resolveShellEnv();return(0,v.detectAvailableProfiles)(I,i,d,this._configurationService,t,void 0,this._logService,this._resolveVariables.bind(this,D))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(D,I){return this._proxy.getWslPath(D,I)}getRevivedPtyNewId(D,I){return this._proxy.getRevivedPtyNewId(D,I)}setTerminalLayoutInfo(D){return this._proxy.setTerminalLayoutInfo(D)}async getTerminalLayoutInfo(D){return this._optionalProxy?.getTerminalLayoutInfo(D)}async requestDetachInstance(D,I){return this._proxy.requestDetachInstance(D,I)}async acceptDetachInstanceReply(D,I){return this._proxy.acceptDetachInstanceReply(D,I)}async freePortKillProcess(D){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(D)}async serializeTerminalState(D){return this._proxy.serializeTerminalState(D)}async reviveTerminalProcesses(D,I,i){return this._proxy.reviveTerminalProcesses(D,I,i)}async refreshProperty(D,I){return this._proxy.refreshProperty(D,I)}async updateProperty(D,I,i){return this._proxy.updateProperty(D,I,i)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(D){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),D?u.HeartbeatConstants.ConnectingBeatInterval:u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(D,I){return this._resolveVariablesRequestStore.createRequest({workspaceId:D,originalText:I})}async acceptPtyHostResolvedVariables(D,I){this._resolveVariablesRequestStore.acceptReply(D,I)}};e.PtyHostService=S,e.PtyHostService=S=Ie([re(1,L.IConfigurationService),re(2,R.ILogService),re(3,R.ILoggerService)],S)});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[76],le([0,1,13,4,2,3,16,6,34]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0,n=je(n);const c="#FFFFFF",m="#1E1E1E",u="#000000",f="#FFFFFF",v="theme",h="themeBackground",g="windowSplash";var E;(function(p){p.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",p.SYSTEM_COLOR_THEME="window.systemColorTheme"})(E||(E={})),e.IThemeMainService=(0,R.createDecorator)("themeMainService");let S=class extends b.Disposable{constructor(D,I){super(),this.stateService=D,this.configurationService=I,this._onDidChangeColorScheme=this._register(new s.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,M.isLinux||this._register(this.configurationService.onDidChangeConfiguration(i=>{(i.affectsConfiguration(E.SYSTEM_COLOR_THEME)||i.affectsConfiguration(E.DETECT_COLOR_SCHEME))&&this.updateSystemColorTheme()})),this.updateSystemColorTheme(),this._register(s.Event.fromNodeEventEmitter(n.default.nativeTheme,"updated")(()=>this._onDidChangeColorScheme.fire(this.getColorScheme())))}updateSystemColorTheme(){if(M.isLinux||this.configurationService.getValue(E.DETECT_COLOR_SCHEME))n.default.nativeTheme.themeSource="system";else switch(this.configurationService.getValue(E.SYSTEM_COLOR_THEME)){case"dark":n.default.nativeTheme.themeSource="dark";break;case"light":n.default.nativeTheme.themeSource="light";break;case"auto":switch(this.getBaseTheme()){case"vs":n.default.nativeTheme.themeSource="light";break;case"vs-dark":n.default.nativeTheme.themeSource="dark";break;default:n.default.nativeTheme.themeSource="system"}break;default:n.default.nativeTheme.themeSource="system";break}}getColorScheme(){if(M.isWindows){if(n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.isMacintosh){if(n.default.nativeTheme.shouldUseInvertedColorScheme||n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.isLinux&&n.default.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const D=this.getColorScheme();if(D.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return D.dark?u:f;let I=this.stateService.getItem(h,null);if(!I)switch(this.getBaseTheme()){case"vs":I=c;break;case"hc-black":I=u;break;case"hc-light":I=f;break;default:I=m}return M.isMacintosh&&I.toUpperCase()===m&&(I="#171717"),I}getBaseTheme(){switch(this.stateService.getItem(v,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(D,I){this.stateService.setItems([{key:v,data:I.baseTheme},{key:h,data:I.colorInfo.background},{key:g,data:I}]),typeof D=="number"&&this.updateBackgroundColor(D,I),this.updateSystemColorTheme()}updateBackgroundColor(D,I){for(const i of n.default.BrowserWindow.getAllWindows())if(i.id===D){i.setBackgroundColor(I.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(g)}};e.ThemeMainService=S,e.ThemeMainService=S=Ie([re(0,w.IStateService),re(1,L.IConfigurationService)],S)}),define(ce[131],le([0,1,4,2,3,7,16,6,5]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=u,e.extractLocalHostUriMetaDataForPortMapping=v,e.extractQueryLocalHostUriMetaDataForPortMapping=h,e.isLocalhost=g,e.isAllInterfaces=E,e.isPortPrivileged=S,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var c;(function(I){I.Http="http",I.Https="https"})(c||(e.TunnelProtocol=c={}));var m;(function(I){I.ConstantPrivate="constantPrivate",I.Private="private",I.Public="public"})(m||(e.TunnelPrivacyId=m={}));function u(I){return!!I.forwardPort}var f;(function(I){I[I.Notify=1]="Notify",I[I.OpenBrowser=2]="OpenBrowser",I[I.OpenPreview=3]="OpenPreview",I[I.Silent=4]="Silent",I[I.Ignore=5]="Ignore",I[I.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function v(I){if(I.scheme!=="http"&&I.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(I.authority);if(i)return{address:i[1],port:+i[2]}}function h(I){if(I.scheme!=="http"&&I.scheme!=="https"||!I.query)return;const i=I.query.split("&");for(const d of i){const t=d.split("=")[1];if(/^https?:/.exec(t)){const o=v(M.URI.parse(t));if(o)return o}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(I){return e.LOCALHOST_ADDRESSES.indexOf(I)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(I){return e.ALL_INTERFACES_ADDRESSES.indexOf(I)>=0}function S(I,i,d,t){if(d===b.OperatingSystem.Windows)return!1;if(d===b.OperatingSystem.Macintosh&&E(i)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(o?.length===4&&parseInt(o[1])>=18)return!1}return I<1024}class p{constructor(i,d,t){this.remoteAddress=i,this.localAddress=d,this._dispose=t,this._onDispose=new n.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=p;let D=class extends s.Disposable{constructor(i,d){super(),this.logService=i,this.configurationService=d,this._onTunnelOpened=new n.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new n.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new n.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const i=this.configurationService.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions,this._canChangeProtocol=i.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],d=Array.from(this._tunnels.values());for(const t of d){const o=Array.from(t.values());for(const r of o){const a=await r.value;a&&typeof a!="string"&&i.push(a)}}return i}async dispose(){super.dispose();for(const i of this._tunnels.values()){for(const{value:d}of i.values())await d.then(t=>typeof t!="string"?t?.dispose():void 0);i.clear()}this._tunnels.clear()}setEnvironmentTunnel(i,d,t,o,r){this.addTunnelToMap(i,d,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:d,localAddress:t,privacy:o,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,d){(E(i)||g(i))&&(i=e.LOCALHOST_ADDRESSES[0]);const t=this.getTunnelFromMap(i,d);if(t)return++t.refcount,t.value}openTunnel(i,d,t,o,r,a=!1,l,P){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${t} on local port ${r}.`);const y=this._tunnelProvider??i;if(!y)return;if(d||(d="localhost"),o||(o=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(t)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.retainOrCreateTunnel(y,d,t,o,r,a,l,P);return k?k.then(T=>{if(T){if(typeof T=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(d,t),T}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(d,t);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const A=this.makeTunnel(T);return(T.tunnelRemoteHost!==d||T.tunnelRemotePort!==t)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&T.privacy!==l&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(A),A}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const d=this._tunnels.get(i.tunnelRemoteHost);if(d){const t=d.get(i.tunnelRemotePort);t&&(t.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,t))}}}}async tryDisposeTunnel(i,d,t){if(t.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${d}.`);const o=t.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this._onTunnelClosed.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(d),o}}async closeTunnel(i,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${d} `);const t=this._tunnels.get(i);if(t&&t.has(d)){const o=t.get(d);o.refcount=0,await this.tryDisposeTunnel(i,d,o)}}addTunnelToMap(i,d,t){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(d,{refcount:1,value:t})}async removeEmptyOrErrorTunnelFromMap(i,d){const t=this._tunnels.get(i);if(t){const o=t.get(d),r=o?await o.value:void 0;(!r||typeof r=="string")&&t.delete(d),t.size===0&&this._tunnels.delete(i)}}getTunnelFromMap(i,d){const t=[i];g(i)?(t.push(...e.LOCALHOST_ADDRESSES),t.push(...e.ALL_INTERFACES_ADDRESSES)):E(i)&&t.push(...e.ALL_INTERFACES_ADDRESSES);const o=t.map(r=>this._tunnels.get(r));for(const r of o){const a=r?.get(d);if(a)return a}}canTunnel(i){return!!v(i)}createWithProvider(i,d,t,o,r,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${t} on local port ${o}.`);const P=t;this._factoryInProgress.add(P);const y=o===void 0?t:o,k={elevationRequired:r?this.isPortPrivileged(y):!1},T={remoteAddress:{host:d,port:t},localAddressPort:o,privacy:a,public:a?a!==m.Private:void 0,protocol:l},A=i.forwardPort(T,k);return A?(this.addTunnelToMap(d,t,A),A.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(P)})):this._factoryInProgress.delete(P),A}};e.AbstractTunnelService=D,e.AbstractTunnelService=D=Ie([re(0,w.ILogService),re(1,L.IConfigurationService)],D)}),define(ce[50],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var s;(function(L){L.Uninitialized="uninitialized",L.Idle="idle",L.Disabled="disabled",L.CheckingForUpdates="checking for updates",L.AvailableForDownload="available for download",L.Downloading="downloading",L.Downloaded="downloaded",L.Updating="updating",L.Ready="ready"})(s||(e.StateType=s={}));var b;(function(L){L[L.Setup=0]="Setup",L[L.Archive=1]="Archive",L[L.Snap=2]="Snap"})(b||(e.UpdateType=b={}));var M;(function(L){L[L.NotBuilt=0]="NotBuilt",L[L.DisabledByEnvironment=1]="DisabledByEnvironment",L[L.ManuallyDisabled=2]="ManuallyDisabled",L[L.MissingConfiguration=3]="MissingConfiguration",L[L.InvalidConfiguration=4]="InvalidConfiguration",L[L.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.State={Uninitialized:{type:s.Uninitialized},Disabled:L=>({type:s.Disabled,reason:L}),Idle:(L,R)=>({type:s.Idle,updateType:L,error:R}),CheckingForUpdates:L=>({type:s.CheckingForUpdates,explicit:L}),AvailableForDownload:L=>({type:s.AvailableForDownload,update:L}),Downloading:{type:s.Downloading},Downloaded:L=>({type:s.Downloaded,update:L}),Updating:L=>({type:s.Updating,update:L}),Ready:L=>({type:s.Ready,update:L})},e.IUpdateService=(0,n.createDecorator)("updateService")}),define(ce[232],le([0,1,3,10,56,45]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(b.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,s.localize)(11079,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:b.ConfigurationScope.APPLICATION,description:(0,s.localize)(11080,null),tags:["usesOnlineServices"],enumDescriptions:[(0,s.localize)(11081,null),(0,s.localize)(11082,null),(0,s.localize)(11083,null),(0,s.localize)(11084,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:b.ConfigurationScope.APPLICATION,description:(0,s.localize)(11085,null),deprecationMessage:(0,s.localize)(11086,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:b.ConfigurationScope.APPLICATION,title:(0,s.localize)(11087,null),description:(0,s.localize)(11088,null),included:n.isWindows&&!n.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:b.ConfigurationScope.APPLICATION,description:(0,s.localize)(11089,null),tags:["usesOnlineServices"]}}})}),define(ce[233],le([0,1,4,50]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class b{constructor(R){this.service=R}listen(R,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(R,w,c){switch(w){case"checkForUpdates":return this.service.checkForUpdates(c);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(c)}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=b;class M{get state(){return this._state}set state(R){this._state=R,this._onStateChange.fire(R)}constructor(R){this.channel=R,this._onStateChange=new n.Emitter,this.onStateChange=this._onStateChange.event,this._state=s.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}checkForUpdates(R){return this.channel.call("checkForUpdates",R)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(R){return this.channel.call("_applySpecificUpdate",R)}}e.UpdateChannelClient=M}),define(ce[41],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,n.createDecorator)("IUriIdentityService")}),define(ce[234],le([0,1,41,173,14,18,145,4,2]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{static{this._clock=0}constructor(f){this.uri=f,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let m=class{constructor(f){this._fileService=f,this._dispooables=new w.DisposableStore,this._limit=2**16;const v=new Map,h=g=>{let E=v.get(g.scheme);return E===void 0&&(E=f.hasProvider(g)&&!this._fileService.hasCapability(g,b.FileSystemProviderCapabilities.PathCaseSensitive),v.set(g.scheme,E)),E};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(g=>{v.delete(g.scheme)})),this.extUri=new M.ExtUri(h),this._canonicalUris=new L.SkipList((g,E)=>this.extUri.compare(g,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,M.normalizePath)(f));const v=this._canonicalUris.get(f);return v?v.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new c(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((h,g)=>h[1].time<g[1].time?1:h[1].time>g[1].time?-1:0);c._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(f[h][0],f[h][1].touch())}};e.UriIdentityService=m,e.UriIdentityService=m=Ie([re(0,b.IFileService)],m),(0,s.registerSingleton)(n.IUriIdentityService,m,s.InstantiationType.Delayed)}),define(ce[132],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,n.createDecorator)("urlService")}),define(ce[235],le([0,1,7]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class s{constructor(R){this.handler=R}listen(R,w){throw new Error(`Event not found: ${w}`)}call(R,w,c){switch(w){case"handleURL":return this.handler.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=s;class b{constructor(R){this.channel=R}handleURL(R,w){return this.channel.call("handleURL",[R.toJSON(),w])}}e.URLHandlerChannelClient=b;class M{constructor(R,w){this.next=R,this.logService=w}async routeCall(R,w,c,m){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(Array.isArray(c)&&c.length>0){const u=n.URI.revive(c[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",u.toString(!0)),u.query){const f=/\bwindowId=(\d+)/.exec(u.query);if(f){const v=f[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${v}"`,u.toString(!0));const h=new RegExp(`window:${v}`),g=R.connections.find(E=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",E.ctx),h.test(E.ctx)));if(g)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",u.toString(!0)),g;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",u.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",u.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(R,w,c,m)}routeEvent(R,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=M}),define(ce[236],le([0,1,8,2,7,28]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class L extends s.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(c,m){const u=[...this.handlers.values()];return(0,n.first)(u.map(f=>()=>f.handleURL(c,m)),void 0,!1).then(f=>f||!1)}registerHandler(c){return this.handlers.add(c),(0,s.toDisposable)(()=>this.handlers.delete(c))}}e.AbstractURLService=L;let R=class extends L{constructor(c){super(),this.productService=c}create(c){let{authority:m,path:u,query:f,fragment:v}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&u&&u.indexOf("/")!==0&&(u=`/${u}`),b.URI.from({scheme:this.productService.urlProtocol,authority:m,path:u,query:f,fragment:v})}};e.NativeURLService=R,e.NativeURLService=R=Ie([re(0,M.IProductService)],R)}),define(ce[237],le([0,1,13,8,4,2,3,7]),function(V,e,n,s,b,M,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class w extends M.Disposable{constructor(m,u,f,v,h,g){if(super(),this.urlService=u,this.logService=g,this.uris=[],this.retryCount=0,m&&(g.trace("ElectronURLListener initialUrisToHandle:",m.map(p=>p.originalUrl)),this.uris=m),L.isWindows){const p=v.isBuilt?[]:[`"${v.appRoot}"`];p.push("--open-url","--"),n.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,p)}const E=b.Event.map(b.Event.fromNodeEventEmitter(n.app,"open-url",(p,D)=>({event:p,url:D})),({event:p,url:D})=>(p.preventDefault(),D));this._register(E(p=>{const D=this.uriFromRawUrl(p);D&&this.urlService.open(D,{originalUrl:p})})),f.getWindows().filter(p=>p.isReady).length>0?(g.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(g.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(b.Event.once(f.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(m){try{return R.URI.parse(m)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const u of this.uris)await this.urlService.open(u.uri,{originalUrl:u.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",u.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",u.originalUrl),m.push(u));m.length!==0&&(this.uris=m,(0,s.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=w}),define(ce[238],le([0,1,4,2,14,60,31]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends s.Disposable{constructor(c,m,u,f,v,h){super(),this.fileSystemScheme=c,this.fileSystemProvider=m,this.userDataScheme=u,this.userDataProfilesService=f,this.uriIdentityService=v,this.logService=h,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=M.TernarySearchTree.forUris(()=>!(this.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new L.ResourceSet(g=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(g))),this.updateAtomicReadWritesResources(),this._register(f.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(g=>this.handleFileChanges(g)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const c of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(c.settingsResource),this.atomicReadWriteResources.add(c.keybindingsResource),this.atomicReadWriteResources.add(c.tasksResource),this.atomicReadWriteResources.add(c.extensionsResource)}open(c,m){return this.fileSystemProvider.open(this.toFileSystemResource(c),m)}close(c){return this.fileSystemProvider.close(c)}read(c,m,u,f,v){return this.fileSystemProvider.read(c,m,u,f,v)}write(c,m,u,f,v){return this.fileSystemProvider.write(c,m,u,f,v)}watch(c,m){this.watchResources.set(c,c);const u=this.fileSystemProvider.watch(this.toFileSystemResource(c),m);return(0,s.toDisposable)(()=>{this.watchResources.delete(c),u.dispose()})}stat(c){return this.fileSystemProvider.stat(this.toFileSystemResource(c))}mkdir(c){return this.fileSystemProvider.mkdir(this.toFileSystemResource(c))}rename(c,m,u){return this.fileSystemProvider.rename(this.toFileSystemResource(c),this.toFileSystemResource(m),u)}readFile(c,m){return this.fileSystemProvider.readFile(this.toFileSystemResource(c),m)}readFileStream(c,m,u){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(c),m,u)}readdir(c){return this.fileSystemProvider.readdir(this.toFileSystemResource(c))}enforceAtomicReadFile(c){return this.atomicReadWriteResources.has(c)}writeFile(c,m,u){return this.fileSystemProvider.writeFile(this.toFileSystemResource(c),m,u)}enforceAtomicWriteFile(c){return this.atomicReadWriteResources.has(c)?{postfix:".vsctmp"}:!1}delete(c,m){return this.fileSystemProvider.delete(this.toFileSystemResource(c),m)}copy(c,m,u){if((0,b.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(c),this.toFileSystemResource(m),u);throw new Error("copy not supported")}cloneFile(c,m){if((0,b.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(c),this.toFileSystemResource(m));throw new Error("clone not supported")}handleFileChanges(c){const m=[];for(const u of c){if(u.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(u.resource);this.watchResources.findSubstr(f)&&m.push({resource:f,type:u.type,cId:u.cId})}m.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(m))}toFileSystemResource(c){return c.with({scheme:this.fileSystemScheme})}toUserDataResource(c){return c.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ce[239],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ce[240],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,n.createDecorator)("webviewManagerService")}),define(ce[241],le([0,1,13,2,12,7]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class L extends s.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const w=this.handleWebviewRequest.bind(this);n.protocol.registerFileProtocol(b.Schemas.vscodeWebview,w)}handleWebviewRequest(w,c){try{const m=M.URI.parse(w.url),u=L.validWebviewFilePaths.get(m.path);if(typeof u=="string"){const f=`vs/workbench/contrib/webview/browser/pre/${u}`,v=b.FileAccess.asFileUri(f);return c({path:v.fsPath,headers:{...b.COI.getHeadersFromQuery(w.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.WebviewProtocolProvider=L}),define(ce[51],le([0,1,3]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.WindowMinimumSize=void 0,e.isOpenedAuxiliaryWindow=s,e.isWorkspaceToOpen=b,e.isFolderToOpen=M,e.isFileToOpen=L,e.getMenuBarVisibility=R,e.hasCustomTitlebar=u,e.hasNativeTitlebar=f,e.getTitleBarStyle=v,e.useWindowControlsOverlay=h,e.useNativeFullScreen=g,e.zoomLevelToZoomFactor=E,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function s(S){return typeof S.parentId=="number"}function b(S){return!!S.workspaceUri}function M(S){return!!S.folderUri}function L(S){return!!S.fileUri}function R(S){const p=f(S),D=S.getValue("window.menuBarVisibility");return D==="default"||p&&D==="compact"||n.isMacintosh&&n.isNative?"classic":D}var w;(function(S){S.TITLE_BAR_STYLE="window.titleBarStyle",S.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(w||(e.TitleBarSetting=w={}));var c;(function(S){S.NATIVE="native",S.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var m;(function(S){S.AUTO="auto",S.WINDOWED="windowed",S.NEVER="never"})(m||(e.CustomTitleBarVisibility=m={}));function u(S,p){return!0}function f(S,p){return p||(p=v(S)),p===c.NATIVE}function v(S){if(n.isWeb)return c.CUSTOM;const p=S.getValue("window");if(p){if(n.isMacintosh&&p.nativeTabs===!0||n.isMacintosh&&p.nativeFullScreen===!1)return c.NATIVE;const i=p.titleBarStyle;if(i===c.NATIVE||i===c.CUSTOM)return i}return n.isLinux?c.NATIVE:c.CUSTOM}e.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=35;function h(S){return!(!n.isWindows||n.isWeb||f(S))}function g(S){const p=S.getValue("window");return!p||typeof p.nativeFullScreen!="boolean"||p.nativeTabs?!0:p.nativeFullScreen!==!1}function E(S=0){return Math.pow(1.2,S)}});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[52],le([0,1,13]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultAuxWindowState=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0,n=je(n);var s;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(s||(e.LoadReason=s={}));var b;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(b||(e.UnloadReason=b={}));const M=function(c=R.Normal){return{width:1024,height:768,mode:c}};e.defaultWindowState=M;const L=function(){const u=n.default.screen.getPrimaryDisplay().workArea,f=Math.max(u.x+u.width/2-800/2,0),v=Math.max(u.y+u.height/2-600/2,0);return{x:f,y:v,width:800,height:600,mode:R.Normal}};e.defaultAuxWindowState=L;var R;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen",c[c.Custom=4]="Custom"})(R||(e.WindowMode=R={}));var w;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(w||(e.WindowError=w={}))}),define(ce[242],le([0,1,8,4,2]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends b.Disposable{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:w,getActiveWindowId:c}){super(),this.disposables=this._register(new b.DisposableStore),s.Event.latch(s.Event.any(R,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,n.createCancelablePromise)(()=>c()),(async()=>{try{const u=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:u}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(ce[30],le([0,1,10,9,60,18,7,6,12]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=c,e.isEmptyWorkspaceIdentifier=m,e.toWorkspaceIdentifier=u,e.isWorkspaceIdentifier=f,e.reviveIdentifier=v,e.isWorkspace=g,e.isWorkspaceFolder=E,e.toWorkspaceFolder=D,e.isUntitledWorkspace=I,e.isTemporaryWorkspace=i,e.isStandaloneEditorWorkspace=d,e.isSavedWorkspace=t,e.hasWorkspaceFileExtension=o,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function c(r){const a=r;return typeof a?.id=="string"&&L.URI.isUri(a.uri)}function m(r){return typeof r?.id=="string"&&!c(r)&&!f(r)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function u(r,a){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,s.basename)(r)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=r;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function f(r){const a=r;return typeof a?.id=="string"&&L.URI.isUri(a.configPath)}function v(r){const a=r;if(a?.uri)return{id:a.id,uri:L.URI.revive(a.uri)};const l=r;if(l?.configPath)return{id:l.id,configPath:L.URI.revive(l.configPath)};if(r?.id)return{id:r.id}}var h;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function g(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function E(r){const a=r;return!!(a&&typeof a=="object"&&L.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class S{constructor(a,l,P,y,k){this._id=a,this._transient=P,this._configuration=y,this._ignorePathCasing=k,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=l}update(a){this._id=a.id,this._configuration=a.configuration,this._transient=a.transient,this._ignorePathCasing=a._ignorePathCasing,this.folders=a.folders}get folders(){return this._folders}set folders(a){this._folders=a,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(a){this._configuration=a}getFolder(a){return a&&this._foldersMap.findSubstr(a)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const a of this.folders)this._foldersMap.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=S;class p{constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,M.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function D(r){return new p({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(11031,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(r,a){return M.extUriBiasedIgnorePathCase.isEqualOrParent(r,a.untitledWorkspacesHome)}function i(r){let a;return L.URI.isUri(r)?a=r:a=r.configuration,a?.scheme===w.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function d(r){return r.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function t(r,a){return!I(r,a)&&!i(r)}function o(r){return(typeof r=="string"?(0,s.extname)(r):(0,M.extname)(r))===e.WORKSPACE_SUFFIX}});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[53],le([0,1,13,8,46,47,2,78,3,23,10,123,6,5,28,30]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,n=je(n),e.IDialogMainService=(0,f.createDecorator)("dialogMainService");let E=class{constructor(p,D){this.logService=p,this.productService=D,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new s.Queue}pickFileFolder(p,D){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(11572,null)},D)}pickFolder(p,D){return this.doPick({...p,pickFolders:!0,title:(0,m.localize)(11573,null)},D)}pickFile(p,D){return this.doPick({...p,pickFiles:!0,title:(0,m.localize)(11574,null)},D)}pickWorkspace(p,D){const I=(0,m.localize)(11575,null),i=(0,M.mnemonicButtonLabel)((0,m.localize)(11576,null)),d=g.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:I,filters:d,buttonLabel:i},D)}async doPick(p,D){const I={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(I.properties=void 0,p.pickFiles&&p.pickFolders&&(I.properties=["multiSelections","openDirectory","openFile","createDirectory"])),I.properties||(I.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&I.properties.push("treatPackageAsDirectory");const i=await this.showOpenDialog(I,(D||n.default.BrowserWindow.getFocusedWindow())??void 0);if(i&&i.filePaths&&i.filePaths.length>0)return i.filePaths}getWindowDialogQueue(p){if(p){let D=this.windowDialogQueues.get(p.id);return D||(D=new s.Queue,this.windowDialogQueues.set(p.id,D)),D}else return this.noWindowDialogueQueue}showMessageBox(p,D){return this.getWindowDialogQueue(D).queue(async()=>{const{options:I,buttonIndeces:i}=(0,u.massageMessageBoxOptions)(p,this.productService);let d;return D?d=await n.default.dialog.showMessageBox(D,I):d=await n.default.dialog.showMessageBox(I),{response:i[d.response],checkboxChecked:d.checkboxChecked}})}async showSaveDialog(p,D){const I=this.acquireFileDialogLock(p,D);if(!I)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.getWindowDialogQueue(D).queue(async()=>{let i;return D?i=await n.default.dialog.showSaveDialog(D,p):i=await n.default.dialog.showSaveDialog(p),i.filePath=this.normalizePath(i.filePath),i})}finally{(0,L.dispose)(I)}}normalizePath(p){return p&&w.isMacintosh&&(p=(0,R.normalizeNFC)(p)),p}normalizePaths(p){return p.map(D=>this.normalizePath(D))}async showOpenDialog(p,D){p.defaultPath&&(await c.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const I=this.acquireFileDialogLock(p,D);if(!I)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(D).queue(async()=>{let i;return D?i=await n.default.dialog.showOpenDialog(D,p):i=await n.default.dialog.showOpenDialog(p),i.filePaths=this.normalizePaths(i.filePaths),i})}finally{(0,L.dispose)(I)}}acquireFileDialogLock(p,D){if(!D)return L.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let I=this.windowFileDialogLocks.get(D.id);I||(I=new Set,this.windowFileDialogLocks.set(D.id,I));const i=(0,b.hash)(p);if(!I.has(i))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),I.add(i),(0,L.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),I?.delete(i),I?.size===0&&this.windowFileDialogLocks.delete(D.id)})}};e.DialogMainService=E,e.DialogMainService=E=Ie([re(0,v.ILogService),re(1,h.IProductService)],E)}),define(ce[243],le([0,1,4,2,82,30]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class L extends s.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(w,c){super(),this.logService=w,this.storageMainService=c,this.onDidChangeApplicationStorageEmitter=this._register(new n.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(c.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(w,c){this._register(n.Event.debounce(w.onDidChangeStorage,(m,u)=>(m?m.push(u):m=[u],m),L.STORAGE_CHANGE_DEBOUNCE_TIME)(m=>{m.length&&c.fire(this.serializeStorageChangeEvents(m,w))}))}serializeStorageChangeEvents(w,c){const m=new Map,u=new Set;return w.forEach(f=>{const v=c.get(f.key);typeof v=="string"?m.set(f.key,v):u.add(f.key)}),{changed:Array.from(m.entries()),deleted:Array.from(u.values())}}listen(w,c,m){switch(c){case"onDidChangeStorage":{const u=m.profile?(0,b.revive)(m.profile):void 0;if(!u)return this.onDidChangeApplicationStorageEmitter.event;let f=this.mapProfileToOnDidChangeProfileStorageEmitter.get(u.id);return f||(f=this._register(new n.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(u),f),this.mapProfileToOnDidChangeProfileStorageEmitter.set(u.id,f)),f.event}}throw new Error(`Event not found: ${c}`)}async call(w,c,m){const u=m.profile?(0,b.revive)(m.profile):void 0,f=(0,M.reviveIdentifier)(m.workspace),v=await this.withStorageInitialized(u,f);switch(c){case"getItems":return Array.from(v.items.entries());case"updateItems":{const h=m;if(h.insert)for(const[g,E]of h.insert)v.set(g,E);h.delete?.forEach(g=>v.delete(g));break}case"optimize":return v.optimize();case"isUsed":{const h=m.payload;if(typeof h=="string")return this.storageMainService.isUsed(h)}default:throw new Error(`Call not found: ${c}`)}}async withStorageInitialized(w,c){let m;c?m=this.storageMainService.workspaceStorage(c):w?m=this.storageMainService.profileStorage(w):m=this.storageMainService.applicationStorage;try{await m.init()}catch(u){this.logService.error(`StorageIPC#init: Unable to init ${c?"workspace":w?"profile":"application"} storage due to ${u}`)}return m}}e.StorageDatabaseChannel=L}),define(ce[42],le([0,1,46,4,2,18,7,10,38,14,6,5,30,31,41,8,33,25,11]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=I,e.reviveProfile=i,e.toUserDataProfile=d;var D;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(D||(e.ProfileResourceType=D={}));function I(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&L.URI.isUri(a.location)&&L.URI.isUri(a.globalStorageHome)&&L.URI.isUri(a.settingsResource)&&L.URI.isUri(a.keybindingsResource)&&L.URI.isUri(a.tasksResource)&&L.URI.isUri(a.snippetsHome)&&L.URI.isUri(a.extensionsResource))}e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function i(r,a){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:L.URI.revive(r.location).with({scheme:a}),globalStorageHome:L.URI.revive(r.globalStorageHome).with({scheme:a}),settingsResource:L.URI.revive(r.settingsResource).with({scheme:a}),keybindingsResource:L.URI.revive(r.keybindingsResource).with({scheme:a}),tasksResource:L.URI.revive(r.tasksResource).with({scheme:a}),snippetsHome:L.URI.revive(r.snippetsHome).with({scheme:a}),extensionsResource:L.URI.revive(r.extensionsResource).with({scheme:a}),cacheHome:L.URI.revive(r.cacheHome).with({scheme:a}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}function d(r,a,l,P,y,k){return{id:r,name:a,location:l,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:k&&y?.useDefaultFlags?.globalState?k.globalStorageHome:(0,M.joinPath)(l,"globalStorage"),settingsResource:k&&y?.useDefaultFlags?.settings?k.settingsResource:(0,M.joinPath)(l,"settings.json"),keybindingsResource:k&&y?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,M.joinPath)(l,"keybindings.json"),tasksResource:k&&y?.useDefaultFlags?.tasks?k.tasksResource:(0,M.joinPath)(l,"tasks.json"),snippetsHome:k&&y?.useDefaultFlags?.snippets?k.snippetsHome:(0,M.joinPath)(l,"snippets"),extensionsResource:k&&y?.useDefaultFlags?.extensions?k.extensionsResource:(0,M.joinPath)(l,"extensions.json"),cacheHome:(0,M.joinPath)(P,r),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let t=class extends b.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(a,l,P,y){super(),this.environmentService=a,this.fileService=l,this.uriIdentityService=P,this.logService=y,this.enabled=!0,this._onDidChangeProfiles=this._register(new s.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new s.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new s.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new s.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new v.ResourceMap,workspaces:new v.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,M.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,M.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(a){this.enabled!==a&&(this._profilesObject=void 0,this.enabled=a)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const a=this.createDefaultProfile(),l=[a];if(this.enabled)try{for(const k of this.getStoredProfiles()){if(!k.name||!(0,p.isString)(k.name)||!k.location){this.logService.warn("Skipping the invalid stored profile",k.location||k.name);continue}l.push(d((0,M.basename)(k.location),k.name,k.location,this.profilesCacheHome,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},a))}}catch(k){this.logService.error(k)}const P=new v.ResourceMap,y=new Map;if(l.length)try{const k=this.getStoredProfileAssociations();if(k.workspaces)for(const[T,A]of Object.entries(k.workspaces)){const C=L.URI.parse(T),_=l.find(H=>H.id===A);_&&P.set(C,_)}if(k.emptyWindows)for(const[T,A]of Object.entries(k.emptyWindows)){const C=l.find(_=>_.id===A);C&&y.set(T,C)}}catch(k){this.logService.error(k)}this._profilesObject={profiles:l,workspaces:P,emptyWindows:y}}return this._profilesObject}createDefaultProfile(){const a=d("__default__profile__",(0,R.localize)(11078,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...a,extensionsResource:this.getDefaultProfileExtensionsLocation()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",P=new RegExp(`${(0,S.escapeRegExpCharacters)(l)}\\s(\\d+)`);let y=0;for(const T of this.profiles){const A=P.exec(T.name),C=A?parseInt(A[1]):0;y=C>y?C:y}const k=`${l} ${y+1}`;return this.createProfile((0,n.hash)((0,E.generateUuid)()).toString(16),k,{transient:!0},a)}async createNamedProfile(a,l,P){return this.createProfile((0,n.hash)((0,E.generateUuid)()).toString(16),a,l,P)}async createProfile(a,l,P,y){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const k=await this.doCreateProfile(a,l,P);return y&&await this.setProfileForWorkspace(y,k),k}async doCreateProfile(a,l,P){if(!(0,p.isString)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.profileCreationPromises.get(l);return y||(y=(async()=>{try{if(this.profiles.find(C=>C.name===l||C.id===a))throw new Error(`Profile with ${l} name already exists`);const T=d(a,l,(0,M.joinPath)(this.profilesHome,a),this.profilesCacheHome,P,this.defaultProfile);await this.fileService.createFolder(T.location);const A=[];return this._onWillCreateProfile.fire({profile:T,join(C){A.push(C)}}),await g.Promises.settled(A),this.updateProfiles([T],[],[]),T}finally{this.profileCreationPromises.delete(l)}})(),this.profileCreationPromises.set(l,y)),y}async updateProfile(a,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let P=this.profiles.find(y=>y.id===a.id);if(!P)throw new Error(`Profile '${a.name}' does not exist`);return P=d(P.id,l.name??P.name,P.location,this.profilesCacheHome,{shortName:l.shortName??P.shortName,icon:l.icon===null?void 0:l.icon??P.icon,transient:l.transient??P.isTransient,useDefaultFlags:l.useDefaultFlags??P.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[P]),P}async removeProfile(a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(y=>y.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const P=[];this._onWillRemoveProfile.fire({profile:l,join(y){P.push(y)}});try{await Promise.allSettled(P)}catch(y){this.logService.error(y)}for(const y of[...this.profilesObject.emptyWindows.keys()])l.id===this.profilesObject.emptyWindows.get(y)?.id&&this.profilesObject.emptyWindows.delete(y);for(const y of[...this.profilesObject.workspaces.keys()])l.id===this.profilesObject.workspaces.get(y)?.id&&this.profilesObject.workspaces.delete(y);this.updateStoredProfileAssociations(),this.updateProfiles([],[l],[]);try{await this.fileService.del(l.cacheHome,{recursive:!0})}catch(y){(0,c.toFileOperationResult)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(y)}}async setProfileForWorkspace(a,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const P=this.profiles.find(y=>y.id===l.id);if(!P)throw new Error(`Profile '${l.name}' does not exist`);this.updateWorkspaceAssociation(a,P)}unsetWorkspace(a,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(a,void 0,l)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const a=await this.fileService.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(P=>!this.uriIdentityService.extUri.isEqual(P.location,l.resource))).map(l=>this.fileService.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const a=this.transientProfilesObject.profiles.filter(l=>!this.isProfileAssociatedToWorkspace(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.getWorkspace(a),P=L.URI.isUri(l)?this.profilesObject.workspaces.get(l):this.profilesObject.emptyWindows.get(l);return P||((0,f.isSingleFolderWorkspaceIdentifier)(a)?this.transientProfilesObject.folders.get(a.uri):(0,f.isWorkspaceIdentifier)(a)?this.transientProfilesObject.workspaces.get(a.configPath):this.transientProfilesObject.emptyWindows.get(a.id))}getWorkspace(a){return(0,f.isSingleFolderWorkspaceIdentifier)(a)?a.uri:(0,f.isWorkspaceIdentifier)(a)?a.configPath:a.id}isProfileAssociatedToWorkspace(a){return!!([...this.profilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,a.location))||[...this.profilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,a.location))||[...this.transientProfilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,a.location))||[...this.transientProfilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,a.location))||[...this.transientProfilesObject.folders.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,a.location)))}updateProfiles(a,l,P){const y=[...this.profiles,...a],k=[],T=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let A of y){if(A.isDefault||l.some(_=>A.id===_.id))continue;A=P.find(_=>A.id===_.id)??A;const C=T.find(_=>A.id===_.id);if(A.isTransient)this.transientProfilesObject.profiles.push(A);else{if(C){for(const[_,H]of this.transientProfilesObject.emptyWindows.entries())if(A.id===H.id){this.updateWorkspaceAssociation({id:_},A);break}for(const[_,H]of this.transientProfilesObject.workspaces.entries())if(A.id===H.id){this.updateWorkspaceAssociation({id:"",configPath:_},A);break}for(const[_,H]of this.transientProfilesObject.folders.entries())if(A.id===H.id){this.updateWorkspaceAssociation({id:"",uri:_},A);break}}k.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.saveStoredProfiles(k),this._profilesObject=void 0,this.triggerProfilesChanges(a,l,P)}triggerProfilesChanges(a,l,P){this._onDidChangeProfiles.fire({added:a,removed:l,updated:P,all:this.profiles})}updateWorkspaceAssociation(a,l,P){if(P=l?.isTransient?!0:P,P)(0,f.isSingleFolderWorkspaceIdentifier)(a)?(this.transientProfilesObject.folders.delete(a.uri),l&&this.transientProfilesObject.folders.set(a.uri,l)):(0,f.isWorkspaceIdentifier)(a)?(this.transientProfilesObject.workspaces.delete(a.configPath),l&&this.transientProfilesObject.workspaces.set(a.configPath,l)):(this.transientProfilesObject.emptyWindows.delete(a.id),l&&this.transientProfilesObject.emptyWindows.set(a.id,l));else{this.updateWorkspaceAssociation(a,void 0,!0);const y=this.getWorkspace(a);L.URI.isUri(y)?(this.profilesObject.workspaces.delete(y),l&&this.profilesObject.workspaces.set(y,l)):(this.profilesObject.emptyWindows.delete(y),l&&this.profilesObject.emptyWindows.set(y,l)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const a={};for(const[P,y]of this.profilesObject.workspaces.entries())a[P.toString()]=y.id;const l={};for(const[P,y]of this.profilesObject.emptyWindows.entries())l[P.toString()]=y.id;this.saveStoredProfileAssociations({workspaces:a,emptyWindows:l}),this._profilesObject=void 0}migrateStoredProfileAssociations(a){const l={},P=this.createDefaultProfile();if(a.workspaces)for(const[k,T]of Object.entries(a.workspaces)){const A=L.URI.parse(T);l[k]=this.uriIdentityService.extUri.isEqual(A,P.location)?P.id:this.uriIdentityService.extUri.basename(A)}const y={};if(a.emptyWindows)for(const[k,T]of Object.entries(a.emptyWindows)){const A=L.URI.parse(T);y[k]=this.uriIdentityService.extUri.isEqual(A,P.location)?P.id:this.uriIdentityService.extUri.basename(A)}return{workspaces:l,emptyWindows:y}}getStoredProfiles(){return[]}saveStoredProfiles(a){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(a){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=t,e.UserDataProfilesService=t=Ie([re(0,w.IEnvironmentService),re(1,c.IFileService),re(2,h.IUriIdentityService),re(3,u.ILogService)],t);class o extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(a){this.storedProfiles=a}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(a){this.storedProfileAssociations=a}}e.InMemoryUserDataProfilesService=o}),define(ce[86],le([0,1,8,17,2,4,31,7,126,129,14,6,5,42,41,11,15,24]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class D extends Error{constructor(o,r){super(o),this.code=r}}e.ExtensionsProfileScanningError=D,e.IExtensionsProfileScannerService=(0,u.createDecorator)("IExtensionsProfileScannerService");let I=class extends b.Disposable{constructor(o,r,a,l,P,y){super(),this.extensionsLocation=o,this.fileService=r,this.userDataProfilesService=a,this.uriIdentityService=l,this.telemetryService=P,this.logService=y,this._onAddExtensions=this._register(new M.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new M.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new M.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new M.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(o,r){return this.withProfileExtensions(o,void 0,r)}async addExtensionsToProfile(o,r,a){const l=[],P=[];try{return await this.withProfileExtensions(r,y=>{const k=[];if(a)k.push(...y);else for(const T of y)o.some(([A])=>(0,c.areSameExtensions)(A.identifier,T.identifier)&&A.manifest.version!==T.version)?l.push(T):k.push(T);for(const[T,A]of o){const C=k.findIndex(H=>(0,c.areSameExtensions)(H.identifier,T.identifier)&&H.version===T.manifest.version),_={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:A};C===-1?(P.push(_),k.push(_)):k.splice(C,1,_)}return P.length&&this._onAddExtensions.fire({extensions:P,profileLocation:r}),l.length&&this._onRemoveExtensions.fire({extensions:l,profileLocation:r}),k}),P.length&&this._onDidAddExtensions.fire({extensions:P,profileLocation:r}),l.length&&this._onDidRemoveExtensions.fire({extensions:l,profileLocation:r}),P}catch(y){throw P.length&&this._onDidAddExtensions.fire({extensions:P,error:y,profileLocation:r}),l.length&&this._onDidRemoveExtensions.fire({extensions:l,error:y,profileLocation:r}),y}}async updateMetadata(o,r){const a=[];return await this.withProfileExtensions(r,l=>{const P=[];for(const y of l){const k=o.find(([T])=>(0,c.areSameExtensions)(T.identifier,y.identifier)&&T.manifest.version===y.version);k&&(y.metadata={...y.metadata,...k[1]},a.push(y)),P.push(y)}return P}),a}async removeExtensionFromProfile(o,r){const a=[];try{await this.withProfileExtensions(r,l=>{const P=[];for(const y of l)(0,c.areSameExtensions)(y.identifier,o.identifier)?a.push(y):P.push(y);return a.length&&this._onRemoveExtensions.fire({extensions:a,profileLocation:r}),P}),a.length&&this._onDidRemoveExtensions.fire({extensions:a,profileLocation:r})}catch(l){throw a.length&&this._onDidRemoveExtensions.fire({extensions:a,error:l,profileLocation:r}),l}}async withProfileExtensions(o,r,a){return this.getResourceAccessQueue(o).queue(async()=>{let l=[],P;try{const y=await this.fileService.readFile(o);P=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,m.toFileOperationResult)(y)!==m.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)&&(P=await this.migrateFromOldDefaultProfileExtensionsLocation()),!P&&a?.bailOutWhenFileNotFound)throw new D((0,E.getErrorMessage)(y),p.ERROR_PROFILE_NOT_FOUND)}if(P){Array.isArray(P)||this.reportAndThrowInvalidConentError(o);let y=!1;for(const k of P){i(k)||this.reportAndThrowInvalidConentError(o);let T;if((0,g.isString)(k.relativeLocation)&&k.relativeLocation)T=this.resolveExtensionLocation(k.relativeLocation);else if((0,g.isString)(k.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${k.location}`);continue}else{T=R.URI.revive(k.location);const A=this.toRelativePath(T);A&&(y=!0,k.relativeLocation=A)}(0,g.isUndefined)(k.metadata?.hasPreReleaseVersion)&&k.metadata?.preRelease&&(y=!0,k.metadata.hasPreReleaseVersion=!0),l.push({identifier:k.identifier,location:T,version:k.version,metadata:k.metadata})}y&&await this.fileService.writeFile(o,s.VSBuffer.fromString(JSON.stringify(P)))}if(r){l=r(l);const y=l.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.toRelativePath(k.location),metadata:k.metadata}));await this.fileService.writeFile(o,s.VSBuffer.fromString(JSON.stringify(y)))}return l})}reportAndThrowInvalidConentError(o){const r=new D(`Invalid extensions content in ${o.toString()}`,p.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}toRelativePath(o){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(o),this.extensionsLocation)?this.uriIdentityService.extUri.basename(o):void 0}resolveExtensionLocation(o){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,o)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const o=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),r=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let a;try{a=(await this.fileService.readFile(o)).value.toString()}catch(P){if((0,m.toFileOperationResult)(P)===m.FileOperationResult.FILE_NOT_FOUND)return;throw P}this.logService.info("Migrating extensions from old default profile location",o.toString());let l;try{const P=JSON.parse(a);Array.isArray(P)&&P.every(y=>i(y))?l=P:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",P)}catch(P){this.logService.error(P)}if(l)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,s.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",o.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(P){if((0,m.toFileOperationResult)(P)===m.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",o.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw P}try{await this.fileService.del(o)}catch(P){(0,m.toFileOperationResult)(P)!==m.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(P)}try{await this.fileService.del(r)}catch(P){(0,m.toFileOperationResult)(P)!==m.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(P)}return l})()),this._migrationPromise}getResourceAccessQueue(o){let r=this.resourcesAccessQueueMap.get(o);return r||(r=new n.Queue,this.resourcesAccessQueueMap.set(o,r)),r}};e.AbstractExtensionsProfileScannerService=I,e.AbstractExtensionsProfileScannerService=I=Ie([re(1,m.IFileService),re(2,v.IUserDataProfilesService),re(3,h.IUriIdentityService),re(4,S.ITelemetryService),re(5,f.ILogService)],I);function i(t){return(0,g.isObject)(t)&&(0,w.isIExtensionIdentifier)(t.identifier)&&(d(t.location)||(0,g.isString)(t.location)&&t.location)&&((0,g.isUndefined)(t.relativeLocation)||(0,g.isString)(t.relativeLocation))&&t.version&&(0,g.isString)(t.version)}function d(t){return t?(0,g.isString)(t.path)&&(0,g.isString)(t.scheme):!1}});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[133],le([0,1,21,8,37,17,15,43,163,2,12,9,3,18,210,81,11,7,10,38,129,85,209,14,6,5,28,4,82,86,42,41,171]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i,d,t,o,r,a,l,P,y,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=fe,b=De(b),u=De(u),f=De(f),h=De(h),g=je(g);var C;(function(X){function B(J,U){if(J===U)return!0;const O=Object.keys(J),N=new Set;for(const Q of Object.keys(U))N.add(Q);if(O.length!==N.size)return!1;for(const Q of O){if(J[Q]!==U[Q])return!1;N.delete(Q)}return N.size===0}X.equals=B})(C||(e.Translations=C={})),e.IExtensionsScannerService=(0,o.createDecorator)("IExtensionsScannerService");let _=class extends c.Disposable{constructor(B,J,U,O,N,Q,oe,j,ue,se,Y,W){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=J,this.extensionsControlLocation=U,this.currentProfile=O,this.userDataProfilesService=N,this.extensionsProfileScannerService=Q,this.fileService=oe,this.logService=j,this.environmentService=ue,this.productService=se,this.uriIdentityService=Y,this.instantiationService=W,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(K,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(K,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(q,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(i.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(i.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,I.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(B,J,U){const[O,N]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(J)]),Q=U?await this.scanExtensionsUnderDevelopment(B,[...O,...N]):[];return this.dedupExtensions(O,N,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const J=[];J.push(this.scanDefaultSystemExtensions(!!B.useCache,B.language)),J.push(this.scanDevSystemExtensions(B.language,!!B.checkControlFile));const[U,O]=await Promise.all(J);return this.applyScanOptions([...U,...O],i.ExtensionType.System,B,!1)}async scanUserExtensions(B){const J=B.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",J);const U=this.uriIdentityService.extUri.isEqual(B.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,O=await this.createExtensionScannerInput(J,!!B.profileLocation,i.ExtensionType.User,!B.includeUninstalled,B.language,!0,U,B.productVersion??this.getProductVersion()),N=B.useCache&&!O.devMode&&O.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let Q;try{Q=await N.scanExtensions(O)}catch(oe){if(oe instanceof y.ExtensionsProfileScanningError&&oe.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),Q=await N.scanExtensions(O);else throw oe}return Q=await this.applyScanOptions(Q,i.ExtensionType.User,B,!0),this.logService.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(B,J){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const U=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(O=>O.scheme===m.Schemas.file).map(async O=>{const N=await this.createExtensionScannerInput(O,!1,i.ExtensionType.User,!0,B.language,!1,void 0,B.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(N)).map(oe=>(oe.type=J.find(j=>(0,I.areSameExtensions)(j.identifier,oe.identifier))?.type??oe.type,this.extensionsScanner.validate(oe,N)))}))).flat();return this.applyScanOptions(U,"development",B,!0)}return[]}async scanExistingExtension(B,J,U){const O=await this.createExtensionScannerInput(B,!1,J,!0,U.language,!0,void 0,U.productVersion??this.getProductVersion()),N=await this.extensionsScanner.scanExtension(O);return!N||!U.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(B,J,U){const O=await this.createExtensionScannerInput(B,!1,J,!0,U.language,!0,void 0,U.productVersion??this.getProductVersion()),N=await this.extensionsScanner.scanOneOrMultipleExtensions(O);return this.applyScanOptions(N,J,U,!0)}async scanMultipleExtensions(B,J,U){const O=[];return await Promise.all(B.map(async N=>{const Q=await this.scanOneOrMultipleExtensions(N,J,U);O.push(...Q)})),this.applyScanOptions(O,J,U,!0)}async scanMetadata(B){const J=(0,v.joinPath)(B,"package.json"),U=(await this.fileService.readFile(J)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(B,J){const U=(0,v.joinPath)(B,"package.json"),O=(await this.fileService.readFile(U)).value.toString(),N=JSON.parse(O);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,N.__metadata={...N.__metadata,...J},await this.fileService.writeFile((0,v.joinPath)(B,"package.json"),M.VSBuffer.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof y.ExtensionsProfileScanningError&&B.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw B}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.extensionsProfileScannerService.addExtensionsToProfile(B.map(J=>[J,J.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,M.VSBuffer.fromString(JSON.stringify([])))}catch(J){(0,t.toFileOperationResult)(J)!==t.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.getErrorMessage)(J))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.logService.error(B)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(B,J,U,O){return U.includeAllVersions||(B=this.dedupExtensions(J===i.ExtensionType.System?B:void 0,J===i.ExtensionType.User?B:void 0,J==="development"?B:void 0,await this.getTargetPlatform(),O)),U.includeInvalid||(B=B.filter(N=>N.isValid)),B.sort((N,Q)=>{const oe=u.basename(N.location.fsPath),j=u.basename(Q.location.fsPath);return oe<j?-1:oe>j?1:0})}dedupExtensions(B,J,U,O,N){const Q=(j,ue,se)=>{if(j.isValid&&!ue.isValid)return!1;if(j.isValid===ue.isValid){if(N&&h.gt(j.manifest.version,ue.manifest.version))return this.logService.debug(`Skipping extension ${ue.location.path} with lower version ${ue.manifest.version} in favour of ${j.location.path} with version ${j.manifest.version}`),!1;if(h.eq(j.manifest.version,ue.manifest.version)){if(j.type===i.ExtensionType.System)return this.logService.debug(`Skipping extension ${ue.location.path} in favour of system extension ${j.location.path} with same version`),!1;if(j.targetPlatform===O)return this.logService.debug(`Skipping extension ${ue.location.path} from different target platform ${ue.targetPlatform}`),!1}}return se?this.logService.warn(`Overwriting user extension ${j.location.path} with ${ue.location.path}.`):this.logService.debug(`Overwriting user extension ${j.location.path} with ${ue.location.path}.`),!0},oe=new i.ExtensionIdentifierMap;return B?.forEach(j=>{const ue=oe.get(j.identifier.id);(!ue||Q(ue,j,!1))&&oe.set(j.identifier.id,j)}),J?.forEach(j=>{const ue=oe.get(j.identifier.id);if(!ue&&B&&j.type===i.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${j.location.path}.`);return}(!ue||Q(ue,j,!1))&&oe.set(j.identifier.id,j)}),U?.forEach(j=>{const ue=oe.get(j.identifier.id);(!ue||Q(ue,j,!0))&&oe.set(j.identifier.id,j),oe.set(j.identifier.id,j)}),[...oe.values()]}async scanDefaultSystemExtensions(B,J){this.logService.trace("Started scanning system extensions");const U=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,J,!0,void 0,this.getProductVersion()),N=await(B&&!U.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(U);return this.logService.trace("Scanned system extensions:",N.length),N}async scanDevSystemExtensions(B,J){const U=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!U?.length)return[];this.logService.trace("Started scanning dev system extensions");const O=J?await this.getBuiltInExtensionControl():{},N=[],Q=S.URI.file(u.normalize(u.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const j of U){const ue=O[j.name]||"marketplace";switch(ue){case"disabled":break;case"marketplace":N.push((0,v.joinPath)(Q,j.name));break;default:N.push(S.URI.file(ue));break}}const oe=await Promise.all(N.map(async j=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(j,!1,i.ExtensionType.System,!0,B,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",oe.length),(0,n.coalesce)(oe)}async getBuiltInExtensionControl(){try{const B=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(B.value.toString())}catch{return{}}}async createExtensionScannerInput(B,J,U,O,N,Q,oe,j){const ue=await this.getTranslations(N??f.language),se=await this.getMtime(B),Y=J&&!this.uriIdentityService.extUri.isEqual(B,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,W=Y?await this.getMtime(Y):void 0;return new H(B,se,Y,W,J,oe,U,O,Q,j.version,j.date,this.productService.commit,!this.environmentService.isBuilt,N,ue)}async getMtime(B){try{const J=await this.fileService.stat(B);if(typeof J.mtime=="number")return J.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=_,e.AbstractExtensionsScannerService=_=Ie([re(4,k.IUserDataProfilesService),re(5,y.IExtensionsProfileScannerService),re(6,t.IFileService),re(7,r.ILogService),re(8,D.IEnvironmentService),re(9,a.IProductService),re(10,T.IUriIdentityService),re(11,o.IInstantiationService)],_);class H{constructor(B,J,U,O,N,Q,oe,j,ue,se,Y,W,F,Z,z){this.location=B,this.mtime=J,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=O,this.profile=N,this.profileScanOptions=Q,this.type=oe,this.excludeObsolete=j,this.validate=ue,this.productVersion=se,this.productDate=Y,this.productCommit=W,this.devMode=F,this.language=Z,this.translations=z}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,J){return(0,v.isEqual)(B.location,J.location)&&B.mtime===J.mtime&&(0,v.isEqual)(B.applicationExtensionslocation,J.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&B.profile===J.profile&&b.equals(B.profileScanOptions,J.profileScanOptions)&&B.type===J.type&&B.excludeObsolete===J.excludeObsolete&&B.validate===J.validate&&B.productVersion===J.productVersion&&B.productDate===J.productDate&&B.productCommit===J.productCommit&&B.devMode===J.devMode&&B.language===J.language&&C.equals(B.translations,J.translations)}}e.ExtensionScannerInput=H;let q=class extends c.Disposable{constructor(B,J,U,O,N,Q,oe){super(),this.obsoleteFile=B,this.extensionsProfileScannerService=J,this.uriIdentityService=U,this.fileService=O,this.environmentService=Q,this.logService=oe,this.extensionsEnabledWithApiProposalVersion=N.extensionsEnabledWithApiProposalVersion?.map(j=>j.toLowerCase())??[]}async scanExtensions(B){const J=B.profile?await this.scanExtensionsFromProfile(B):await this.scanExtensionsFromLocation(B);let U={};if(B.excludeObsolete&&B.type===i.ExtensionType.User)try{const O=(await this.fileService.readFile(this.obsoleteFile)).value.toString();U=JSON.parse(O)}catch{}return(0,E.isEmptyObject)(U)?J:J.filter(O=>!U[I.ExtensionKey.create(O).toString()])}async scanExtensionsFromLocation(B){const J=await this.fileService.resolve(B.location);if(!J.children?.length)return[];const U=await Promise.all(J.children.map(async O=>{if(!O.isDirectory||B.type===i.ExtensionType.User&&(0,v.basename)(O.resource).indexOf(".")===0)return null;const N=new H(O.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(N)}));return(0,n.coalesce)(U).sort((O,N)=>O.location.path<N.location.path?-1:1)}async scanExtensionsFromProfile(B){let J=await this.scanExtensionsFromProfileResource(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(B.location,B.applicationExtensionslocation)){J=J.filter(O=>!O.metadata?.isApplicationScoped);const U=await this.scanExtensionsFromProfileResource(B.applicationExtensionslocation,O=>!!O.metadata?.isBuiltin||!!O.metadata?.isApplicationScoped,B);J.push(...U)}return J}async scanExtensionsFromProfileResource(B,J,U){const O=await this.extensionsProfileScannerService.scanProfileExtensions(B,U.profileScanOptions);if(!O.length)return[];const N=await Promise.all(O.map(async Q=>{if(J(Q)){const oe=new H(Q.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(oe,Q.metadata)}return null}));return(0,n.coalesce)(N)}async scanOneOrMultipleExtensions(B){try{if(await this.fileService.exists((0,v.joinPath)(B.location,"package.json"))){const J=await this.scanExtension(B);return J?[J]:[]}else return await this.scanExtensions(B)}catch(J){return this.logService.error(`Error scanning extensions at ${B.location.path}:`,(0,L.getErrorMessage)(J)),[]}}async scanExtension(B,J){try{let U=await this.scanExtensionManifest(B.location);if(U){U.publisher||(U.publisher=i.UNDEFINED_PUBLISHER),J=J??U.__metadata,delete U.__metadata;const O=(0,I.getGalleryExtensionId)(U.publisher,U.name),N=J?.id?{id:O,uuid:J.id}:{id:O},Q=J?.isSystem?i.ExtensionType.System:B.type,oe=Q===i.ExtensionType.System||!!J?.isBuiltin;U=await this.translateManifest(B.location,U,H.createNlsConfiguration(B));let j={type:Q,identifier:N,manifest:U,location:B.location,isBuiltin:oe,targetPlatform:J?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:J?.publisherDisplayName,metadata:J,isValid:!0,validations:[]};return B.validate&&(j=this.validate(j,B)),U.enabledApiProposals&&(!this.environmentService.isBuilt||this.extensionsEnabledWithApiProposalVersion.includes(O.toLowerCase()))&&(U.originalEnabledApiProposals=U.enabledApiProposals,U.enabledApiProposals=(0,i.parseEnabledApiProposalNames)([...U.enabledApiProposals])),j}}catch(U){B.type!==i.ExtensionType.System&&this.logService.error(U)}return null}validate(B,J){let U=!0;const O=this.environmentService.isBuilt&&this.extensionsEnabledWithApiProposalVersion.includes(B.identifier.id.toLowerCase()),N=(0,d.validateExtensionManifest)(J.productVersion,J.productDate,J.location,B.manifest,B.isBuiltin,O);for(const[Q,oe]of N)Q===g.default.Error&&(U=!1,this.logService.error(this.formatMessage(J.location,oe)));return B.isValid=U,B.validations=N,B}async scanExtensionManifest(B){const J=(0,v.joinPath)(B,"package.json");let U;try{U=(await this.fileService.readFile(J)).value.toString()}catch(N){return(0,t.toFileOperationResult)(N)!==t.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(B,(0,p.localize)(11462,null,J.path,N.message))),null}let O;try{O=JSON.parse(U)}catch{const Q=[];(0,R.parse)(U,Q);for(const oe of Q)this.logService.error(this.formatMessage(B,(0,p.localize)(11463,null,J.path,oe.offset,oe.length,(0,w.getParseErrorMessage)(oe.error))));return null}return(0,R.getNodeType)(O)!=="object"?(this.logService.error(this.formatMessage(B,(0,p.localize)(11464,null,J.path))),null):O}async translateManifest(B,J,U){const O=await this.getLocalizedMessages(B,J,U);if(O)try{const N=[],Q=await this.resolveOriginalMessageBundle(O.default,N);if(N.length>0)return N.forEach(j=>{this.logService.error(this.formatMessage(B,(0,p.localize)(11465,null,O.default?.path,(0,w.getParseErrorMessage)(j.error))))}),J;if((0,R.getNodeType)(O)!=="object")return this.logService.error(this.formatMessage(B,(0,p.localize)(11466,null,O.default?.path))),J;const oe=O.values||Object.create(null);return(0,A.localizeManifest)(this.logService,J,oe,Q)}catch{}return J}async getLocalizedMessages(B,J,U){const O=(0,v.joinPath)(B,"package.nls.json"),N=(ue,se)=>{se.forEach(Y=>{this.logService.error(this.formatMessage(B,(0,p.localize)(11467,null,ue?.path,(0,w.getParseErrorMessage)(Y.error))))})},Q=ue=>{this.logService.error(this.formatMessage(B,(0,p.localize)(11468,null,ue?.path)))},oe=`${J.publisher}.${J.name}`,j=U.translations[oe];if(j)try{const ue=S.URI.file(j),se=(await this.fileService.readFile(ue)).value.toString(),Y=[],W=(0,R.parse)(se,Y);return Y.length>0?(N(ue,Y),{values:void 0,default:O}):(0,R.getNodeType)(W)!=="object"?(Q(ue),{values:void 0,default:O}):{values:W.contents?W.contents.package:void 0,default:O}}catch{return{values:void 0,default:O}}else{if(!await this.fileService.exists(O))return;let se;try{se=await this.findMessageBundles(B,U)}catch{return}if(!se.localized)return{values:void 0,default:se.original};try{const Y=(await this.fileService.readFile(se.localized)).value.toString(),W=[],F=(0,R.parse)(Y,W);return W.length>0?(N(se.localized,W),{values:void 0,default:se.original}):(0,R.getNodeType)(F)!=="object"?(Q(se.localized),{values:void 0,default:se.original}):{values:F,default:se.original}}catch{return{values:void 0,default:se.original}}}}async resolveOriginalMessageBundle(B,J){if(B)try{const U=(await this.fileService.readFile(B)).value.toString();return(0,R.parse)(U,J)}catch{}}findMessageBundles(B,J){return new Promise((U,O)=>{const N=Q=>{const oe=(0,v.joinPath)(B,`package.nls.${Q}.json`);this.fileService.exists(oe).then(j=>{j&&U({localized:oe,original:(0,v.joinPath)(B,"package.nls.json")});const ue=Q.lastIndexOf("-");ue===-1?U({localized:(0,v.joinPath)(B,"package.nls.json"),original:null}):(Q=Q.substring(0,ue),N(Q))})};if(J.devMode||J.pseudo||!J.language)return U({localized:(0,v.joinPath)(B,"package.nls.json"),original:null});N(J.language)})}formatMessage(B,J){return`[${B.path}]: ${J}`}};q=Ie([re(1,y.IExtensionsProfileScannerService),re(2,T.IUriIdentityService),re(3,t.IFileService),re(4,a.IProductService),re(5,D.IEnvironmentService),re(6,r.ILogService)],q);let K=class extends q{constructor(B,J,U,O,N,Q,oe,j,ue){super(J,O,N,Q,oe,j,ue),this.currentProfile=B,this.userDataProfilesService=U,this.cacheValidatorThrottler=this._register(new s.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(B){const J=this.getCacheFile(B),U=await this.readExtensionCache(J);if(this.input=B,U&&U.input&&H.equals(U.input,this.input))return this.logService.debug("Using cached extensions scan result",B.type===i.ExtensionType.System?"system":"user",B.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),U.result.map(N=>(N.location=S.URI.revive(N.location),N));const O=await super.scanExtensions(B);return await this.writeExtensionCache(J,{input:B,result:O}),O}async readExtensionCache(B){try{const J=await this.fileService.readFile(B),U=JSON.parse(J.value.toString());return{result:U.result,input:(0,P.revive)(U.input)}}catch(J){this.logService.debug("Error while reading the extension cache file:",B.path,(0,L.getErrorMessage)(J))}return null}async writeExtensionCache(B,J){try{await this.fileService.writeFile(B,M.VSBuffer.fromString(JSON.stringify(J)))}catch(U){this.logService.debug("Error while writing the extension cache file:",B.path,(0,L.getErrorMessage)(U))}}async validateCache(){if(!this.input)return;const B=this.getCacheFile(this.input),J=await this.readExtensionCache(B);if(!J)return;const U=J.result,O=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!b.equals(O,U))try{this.logService.info("Invalidating Cache",U,O),await this.fileService.del(B),this._onDidChangeCache.fire()}catch(N){this.logService.error(N)}}getCacheFile(B){const J=this.getProfile(B);return this.uriIdentityService.extUri.joinPath(J.cacheHome,B.type===i.ExtensionType.System?i.BUILTIN_MANIFEST_CACHE_FILE:i.USER_MANIFEST_CACHE_FILE)}getProfile(B){return B.type===i.ExtensionType.System?this.userDataProfilesService.defaultProfile:B.profile?this.uriIdentityService.extUri.isEqual(B.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(J=>this.uriIdentityService.extUri.isEqual(B.location,J.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};K=Ie([re(2,k.IUserDataProfilesService),re(3,y.IExtensionsProfileScannerService),re(4,T.IUriIdentityService),re(5,t.IFileService),re(6,a.IProductService),re(7,D.IEnvironmentService),re(8,r.ILogService)],K);function fe(X,B){const J=(0,I.getExtensionId)(X.manifest.publisher,X.manifest.name);return{id:J,identifier:new i.ExtensionIdentifier(J),isBuiltin:X.type===i.ExtensionType.System,isUserBuiltin:X.type===i.ExtensionType.User&&X.isBuiltin,isUnderDevelopment:B,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,publisherDisplayName:X.publisherDisplayName,...X.manifest}}class $ extends _{constructor(B,J,U,O,N,Q,oe,j,ue,se,Y,W){super(B,J,(0,v.joinPath)(U,".vscode-oss-dev","extensions","control.json"),O,N,Q,oe,j,ue,se,Y,W),this.translationsPromise=(async()=>{if(f.translationsConfigFile)try{const F=await this.fileService.readFile(S.URI.file(f.translationsConfigFile));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}getTranslations(B){return this.translationsPromise}}e.NativeExtensionsScannerService=$}),define(ce[244],le([0,1,5,42,41,24,86,14,38,7]),function(V,e,n,s,b,M,L,R,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let m=class extends L.AbstractExtensionsProfileScannerService{constructor(f,v,h,g,E,S){super(c.URI.file(f.extensionsPath),v,h,g,E,S)}};e.ExtensionsProfileScannerService=m,e.ExtensionsProfileScannerService=m=Ie([re(0,w.INativeEnvironmentService),re(1,R.IFileService),re(2,s.IUserDataProfilesService),re(3,b.IUriIdentityService),re(4,M.ITelemetryService),re(5,n.ILogService)],m)}),define(ce[245],le([0,1,7,38,86,133,14,6,5,28,41,42]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let f=class extends M.NativeExtensionsScannerService{constructor(h,g,E,S,p,D,I,i){super(n.URI.file(p.builtinExtensionsPath),n.URI.file(p.extensionsPath),p.userHome,h.defaultProfile,h,g,E,S,p,D,I,i)}};e.ExtensionsScannerService=f,e.ExtensionsScannerService=f=Ie([re(0,u.IUserDataProfilesService),re(1,b.IExtensionsProfileScannerService),re(2,L.IFileService),re(3,w.ILogService),re(4,s.INativeEnvironmentService),re(5,c.IProductService),re(6,m.IUriIdentityService),re(7,R.IInstantiationService)],f)}),define(ce[246],le([0,1,13,2,12,9,3,60,7,33,35,38,5,42]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let h=class extends s.Disposable{constructor(E,S,p){super(),this.environmentService=E,this.logService=p,this.validRoots=R.TernarySearchTree.forPaths(!L.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(E.appRoot),this.addValidFileRoot(E.extensionsPath),this.addValidFileRoot(S.defaultProfile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath),this.addValidFileRoot(E.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:E}=n.session;E.protocol.registerFileProtocol(b.Schemas.vscodeFileResource,(S,p)=>this.handleResourceRequest(S,p)),E.protocol.interceptFileProtocol(b.Schemas.file,(S,p)=>this.handleFileRequest(S,p)),this._register((0,s.toDisposable)(()=>{E.protocol.unregisterProtocol(b.Schemas.vscodeFileResource),E.protocol.uninterceptProtocol(b.Schemas.file)}))}addValidFileRoot(E){const S=(0,M.normalize)(E);return this.validRoots.get(S)?s.Disposable.None:(this.validRoots.set(S,!0),(0,s.toDisposable)(()=>this.validRoots.delete(S)))}handleFileRequest(E,S){const p=w.URI.parse(E.url);return this.logService.error(`Refused to load resource ${p.fsPath} from ${b.Schemas.file}: protocol (original URL: ${E.url})`),S({error:-3})}handleResourceRequest(E,S){const p=this.requestToNormalizedFilePath(E);let D;return this.environmentService.crossOriginIsolated&&((0,M.basename)(p)==="workbench.html"||(0,M.basename)(p)==="workbench-dev.html"?D=b.COI.CoopAndCoep:D=b.COI.getHeadersFromQuery(E.url)),this.validRoots.findSubstr(p)?S({path:p,headers:D}):this.validExtensions.has((0,M.extname)(p).toLowerCase())?S({path:p}):(this.logService.error(`${b.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${b.Schemas.vscodeFileResource}: protocol (original URL: ${E.url})`),S({error:-3}))}requestToNormalizedFilePath(E){const S=w.URI.parse(E.url),p=b.FileAccess.uriToFileUri(S);return(0,M.normalize)(p.fsPath)}createIPCObjectUrl(){let E;const S=w.URI.from({scheme:"vscode",path:(0,c.generateUuid)()}),p=S.toString(),D=async()=>E;return m.validatedIpcMain.handle(p,D),this.logService.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:S,update:I=>E=I,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${p}.`),m.validatedIpcMain.removeHandler(p)}}}};e.ProtocolMainService=h,e.ProtocolMainService=h=Ie([re(0,u.INativeEnvironmentService),re(1,v.IUserDataProfilesService),re(2,f.ILogService)],h)}),define(ce[62],le([0,1,8,4,2,70,11,119,6,42]),function(V,e,n,s,b,M,L,R,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=v,e.isProfileUsingDefaultStorage=g,e.logStorage=S,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,w.createDecorator)("storageService");var m;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var u;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var f;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(f||(e.StorageTarget=f={}));function v(p){const D=p.get(e.TARGET_KEY);if(D)try{return JSON.parse(D)}catch{}return Object.create(null)}class h extends b.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(D={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=D,this._onDidChangeValue=this._register(new s.PauseableEmitter),this._onDidChangeTarget=this._register(new s.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new s.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(D,I,i){return s.Event.filter(this._onDidChangeValue.event,d=>d.scope===D&&(I===void 0||d.key===I),i)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,M.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,I){const{key:i,external:d}=I;if(i===e.TARGET_KEY){switch(D){case u.APPLICATION:this._applicationKeyTargets=void 0;break;case u.PROFILE:this._profileKeyTargets=void 0;break;case u.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:D})}else this._onDidChangeValue.fire({scope:D,key:i,target:this.getKeyTargets(D)[i],external:d})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,I,i){return this.getStorage(I)?.get(D,i)}getBoolean(D,I,i){return this.getStorage(I)?.getBoolean(D,i)}getNumber(D,I,i){return this.getStorage(I)?.getNumber(D,i)}getObject(D,I,i){return this.getStorage(I)?.getObject(D,i)}storeAll(D,I){this.withPausedEmitters(()=>{for(const i of D)this.store(i.key,i.value,i.scope,i.target,I)})}store(D,I,i,d,t=!1){if((0,L.isUndefinedOrNull)(I)){this.remove(D,i,t);return}this.withPausedEmitters(()=>{this.updateKeyTarget(D,i,d),this.getStorage(i)?.set(D,I,t)})}remove(D,I,i=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(D,I,void 0),this.getStorage(I)?.delete(D,i)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,I){const i=[],d=this.getKeyTargets(D);for(const t of Object.keys(d))d[t]===I&&i.push(t);return i}updateKeyTarget(D,I,i,d=!1){const t=this.getKeyTargets(I);typeof i=="number"?t[D]!==i&&(t[D]=i,this.getStorage(I)?.set(e.TARGET_KEY,JSON.stringify(t),d)):typeof t[D]=="number"&&(delete t[D],this.getStorage(I)?.set(e.TARGET_KEY,JSON.stringify(t),d))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(u.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(u.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(u.APPLICATION)),this._applicationKeyTargets}getKeyTargets(D){switch(D){case u.APPLICATION:return this.applicationKeyTargets;case u.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(D){const I=this.getStorage(D);return I?v(I):Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(D=m.NONE){this._onWillSaveState.fire({reason:D});const I=this.getStorage(u.APPLICATION),i=this.getStorage(u.PROFILE),d=this.getStorage(u.WORKSPACE);switch(D){case m.NONE:await n.Promises.settled([I?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await n.Promises.settled([I?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve()]);break}}async log(){const D=this.getStorage(u.APPLICATION)?.items??new Map,I=this.getStorage(u.PROFILE)?.items??new Map,i=this.getStorage(u.WORKSPACE)?.items??new Map;return S(D,I,i,this.getLogDetails(u.APPLICATION)??"",this.getLogDetails(u.PROFILE)??"",this.getLogDetails(u.WORKSPACE)??"")}async optimize(D){return await this.flush(),this.getStorage(D)?.optimize()}async switch(D,I){return this.emitWillSaveState(m.NONE),(0,c.isUserDataProfile)(D)?this.switchToProfile(D,I):this.switchToWorkspace(D,I)}canSwitchProfile(D,I){return!(D.id===I.id||g(I)&&g(D))}switchData(D,I,i){this.withPausedEmitters(()=>{const d=new Set;for(const[t,o]of D)d.add(t),I.get(t)!==o&&this.emitDidChangeValue(i,{key:t,external:!0});for(const[t]of I.items)d.has(t)||this.emitDidChangeValue(i,{key:t,external:!0})})}}e.AbstractStorageService=h;function g(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class E extends h{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(u.WORKSPACE,D))),this._register(this.profileStorage.onDidChangeStorage(D=>this.emitDidChangeValue(u.PROFILE,D))),this._register(this.applicationStorage.onDidChangeStorage(D=>this.emitDidChangeValue(u.APPLICATION,D)))}getStorage(D){switch(D){case u.APPLICATION:return this.applicationStorage;case u.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(D){switch(D){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(D){return!1}}e.InMemoryStorageService=E;async function S(p,D,I,i,d,t){const o=C=>{try{return JSON.parse(C)}catch{return C}},r=new Map,a=new Map;p.forEach((C,_)=>{r.set(_,C),a.set(_,o(C))});const l=new Map,P=new Map;D.forEach((C,_)=>{l.set(_,C),P.set(_,o(C))});const y=new Map,k=new Map;I.forEach((C,_)=>{y.set(_,C),k.set(_,o(C))}),console.group(i!==d?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const T=[];if(r.forEach((C,_)=>{T.push({key:_,value:C})}),console.table(T),console.groupEnd(),console.log(a),i!==d){console.group(`Storage: Profile (path: ${d}, profile specific)`);const C=[];l.forEach((_,H)=>{C.push({key:H,value:_})}),console.table(C),console.groupEnd(),console.log(P)}console.group(`Storage: Workspace (path: ${t})`);const A=[];y.forEach((C,_)=>{A.push({key:_,value:C})}),console.table(A),console.groupEnd(),console.log(k)}}),define(ce[247],le([0,1,17,33,62]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=M;async function M(L,R,w){let c=w&&w.get("storage.serviceMachineId",b.StorageScope.APPLICATION)||null;if(c)return c;try{const u=(await R.readFile(L.serviceMachineIdResource)).value.toString();c=(0,s.isUUID)(u)?u:null}catch{c=null}if(!c){c=(0,s.generateUuid)();try{await R.writeFile(L.serviceMachineIdResource,n.VSBuffer.fromString(c))}catch{}}return w?.store("storage.serviceMachineId",c,b.StorageScope.APPLICATION,b.StorageTarget.MACHINE),c}}),define(ce[248],le([0,1,247,24,57]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=M;async function M(L,R,w,c,m,u,f){const v={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${R.nameShort})`};if((0,b.supportsTelemetry)(R,w)&&(0,b.getTelemetryLevel)(c)===s.TelemetryLevel.USAGE){const h=await(0,n.getServiceMachineId)(w,m,u);v["X-Market-User-Id"]=h,v["VSCode-SessionId"]=f.machineId||h}return v}}),define(ce[249],le([0,1,26,21,8,4,2,9,66,7,23,119,161,5,62,24,30,12]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0,n=De(n);class p extends L.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(r,a){super(),this.logService=r,this.fileService=a,this._onDidChangeStorage=this._register(new M.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new M.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new u.Storage(new u.InMemoryStorageDatabase,{hint:u.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new b.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=u.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===u.StorageState.None)try{const r=this._register(await this.doCreate());this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(l=>this._onDidChangeStorage.fire(l))),await this.doInit(r);const a=r.getBoolean(h.IS_NEW_KEY);a===void 0?r.set(h.IS_NEW_KEY,!0):a&&r.set(h.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=u.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===v.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,a){return this._storage.get(r,a)}set(r,a){return this._storage.set(r,a)}delete(r){return this._storage.delete(r)}optimize(){return this._storage.optimize()}async close(){const r=new w.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>p.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(this.path)try{const a=(0,s.top)(Array.from(this._storage.items.entries()).map(([P,y])=>({key:P,length:y.length})),(P,y)=>y.length-P.length,5).map(P=>`${P.key}:${P.length}`).join(", "),l=(await this.fileService.stat(c.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${l}b, Large Keys: ${a}`)}catch(a){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",a)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=u.StorageState.Closed,await this._storage.close()}}class D extends p{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.profile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath,D.STORAGE_NAME)}constructor(r,a,l,P){super(l,P),this.profile=r,this.options=a}async doCreate(){return new u.Storage(new f.SQLiteStorageDatabase(this.path??f.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:u.StorageHint.STORAGE_IN_MEMORY})}}class I extends D{constructor(r,a,l,P){super(r,a,l,P)}}e.ProfileStorageMain=I;class i extends D{constructor(r,a,l,P){super(a.defaultProfile,r,l,P)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(g.firstSessionDateStorageKey,void 0)===void 0&&r.set(g.firstSessionDateStorageKey,new Date().toUTCString());const l=r.get(g.currentSessionDateStorageKey,void 0),P=new Date().toUTCString();r.set(g.lastSessionDateStorageKey,typeof l>"u"?null:l),r.set(g.currentSessionDateStorageKey,P)}}e.ApplicationStorageMain=i;class d extends p{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,R.join)(this.environmentService.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath,this.workspace.id,d.WORKSPACE_STORAGE_NAME)}constructor(r,a,l,P,y){super(l,y),this.workspace=r,this.options=a,this.environmentService=P}async doCreate(){const{storageFilePath:r,wasCreated:a}=await this.prepareWorkspaceStorageFolder();return new u.Storage(new f.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?u.StorageHint.STORAGE_IN_MEMORY:a?u.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,R.join)(this.environmentService.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath,this.workspace.id),a=(0,R.join)(r,d.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(r)?{storageFilePath:a,wasCreated:!1}:(await n.promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:a,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let a;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?a={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(a={workspace:this.workspace.configPath.toString()}),a)try{const l=(0,R.join)(r,d.WORKSPACE_META_NAME);await m.Promises.exists(l)||await m.Promises.writeFile(l,JSON.stringify(a,void 0,2))}catch(l){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=d;class t extends p{get path(){}async doCreate(){return new u.Storage(new u.InMemoryStorageDatabase,{hint:u.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=t}),define(ce[250],le([0,1,4,2,62]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class M extends s.Disposable{constructor(R,w,c){super(),this.storageMainService=R,this.userDataProfilesService=w,this.logService=c;const m=this._register(new s.MutableDisposable);this._onDidChange=this._register(new n.Emitter({onWillAddFirstListener:()=>m.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>m.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const R=new s.DisposableStore;return R.add(n.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(w,c)=>(w?w.push(c.key):w=[c.key],w),100)(w=>this.onDidChangeApplicationStorage(w))),R.add(n.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(w,c)=>{w||(w=new Map);let m=w.get(c.profile.id);return m||w.set(c.profile.id,m={profile:c.profile,keys:[],storage:c.storage}),m.keys.push(c.key),w},100)(w=>this.onDidChangeProfileStorage(w))),R}onDidChangeApplicationStorage(R){const w=R.includes(b.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],c=[];if(R=R.filter(m=>m!==b.TARGET_KEY),R.length){const m=(0,b.loadKeyTargets)(this.storageMainService.applicationStorage.storage);c.push({profile:this.userDataProfilesService.defaultProfile,changes:R.map(u=>({key:u,scope:b.StorageScope.PROFILE,target:m[u]}))})}this.triggerEvents(w,c)}onDidChangeProfileStorage(R){const w=[],c=new Map;for(const[m,u]of R.entries()){u.keys.includes(b.TARGET_KEY)&&w.push(u.profile);const f=u.keys.filter(v=>v!==b.TARGET_KEY);if(f.length){const v=(0,b.loadKeyTargets)(u.storage.storage);c.set(m,{profile:u.profile,changes:f.map(h=>({key:h,scope:b.StorageScope.PROFILE,target:v[h]}))})}}this.triggerEvents(w,[...c.values()])}triggerEvents(R,w){(R.length||w.length)&&this._onDidChange.fire({valueChanges:w,targetChanges:R})}listen(R,w,c){switch(w){case"onDidChange":return this._onDidChange.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${w}`)}async call(R,w){throw new Error(`Call not found: ${w}`)}}e.ProfileStorageChangesListenerChannel=M}),define(ce[251],le([0,1,7,38,14,5,34,41,42,11,127]),function(V,e,n,s,b,M,L,R,w,c,m){"use strict";var u,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let v=class extends w.UserDataProfilesService{static{u=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(S,p,D,I,i){super(D,I,p,i),this.stateReadonlyService=S,this.nativeEnvironmentService=D}getStoredProfiles(){return this.stateReadonlyService.getItem(u.PROFILES_KEY,[]).map(p=>({...p,location:(0,c.isString)(p.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,p.location):n.URI.revive(p.location)}))}getStoredProfileAssociations(){const S=this.stateReadonlyService.getItem(u.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(u.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?S:this.migrateStoredProfileAssociations(S)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(n.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=v,e.UserDataProfilesReadonlyService=v=u=Ie([re(0,L.IStateReadService),re(1,R.IUriIdentityService),re(2,s.INativeEnvironmentService),re(3,b.IFileService),re(4,M.ILogService)],v);let h=f=class extends v{constructor(S,p,D,I,i){super(S,p,D,I,i),this.stateService=S}saveStoredProfiles(S){S.length?this.stateService.setItem(f.PROFILES_KEY,S.map(p=>({...p,location:this.uriIdentityService.extUri.basename(p.location)}))):this.stateService.removeItem(f.PROFILES_KEY)}getStoredProfiles(){const S=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(S),this.stateService.setItem("userDataProfilesMigration",!0)),S}saveStoredProfileAssociations(S){S.emptyWindows||S.workspaces?this.stateService.setItem(f.PROFILE_ASSOCIATIONS_KEY,S):this.stateService.removeItem(f.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const S="workspaceAndProfileInfo",p=this.stateService.getItem(S,void 0);if(p){this.stateService.removeItem(S);const I=p.reduce((i,{workspace:d,profile:t})=>(i[n.URI.revive(d).toString()]=n.URI.revive(t).toString(),i),{});this.stateService.setItem(f.PROFILE_ASSOCIATIONS_KEY,{workspaces:I})}const D=super.getStoredProfileAssociations();return this.stateService.getItem(f.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(D),this.stateService.setItem(f.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),D}};e.UserDataProfilesService=h,e.UserDataProfilesService=h=f=Ie([re(0,L.IStateService),re(1,R.IUriIdentityService),re(2,s.INativeEnvironmentService),re(3,b.IFileService),re(4,M.ILogService)],h);let g=class extends h{constructor(S,p,D,I){super(new m.StateService(m.SaveStrategy.IMMEDIATE,p,I,D),S,p,D,I)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=g,e.ServerUserDataProfilesService=g=Ie([re(0,R.IUriIdentityService),re(1,s.INativeEnvironmentService),re(2,b.IFileService),re(3,M.ILogService)],g)}),define(ce[58],le([0,1,38,14,6,5,41,42,251,34]),function(V,e,n,s,b,M,L,R,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,b.refineServiceDecorator)(R.IUserDataProfilesService);let m=class extends w.UserDataProfilesService{constructor(f,v,h,g,E){super(f,v,h,g,E)}getAssociatedEmptyWindows(){const f=[];for(const v of this.profilesObject.emptyWindows.keys())f.push({id:v});return f}};e.UserDataProfilesMainService=m,e.UserDataProfilesMainService=m=Ie([re(0,c.IStateService),re(1,L.IUriIdentityService),re(2,n.INativeEnvironmentService),re(3,s.IFileService),re(4,M.ILogService)],m)}),define(ce[134],le([0,1,18,7,30]),function(V,e,n,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnFile=M,e.findWindowOnWorkspaceOrFolder=L,e.findWindowOnExtensionDevelopmentPath=R;async function M(w,c,m){for(const f of w){const v=f.openedWorkspace;if((0,b.isWorkspaceIdentifier)(v)){const h=await m(v);if(h){if(h.folders.some(g=>n.extUriBiasedIgnorePathCase.isEqualOrParent(c,g.uri)))return f}else if(n.extUriBiasedIgnorePathCase.isEqualOrParent(c,v.configPath))return f}}const u=w.filter(f=>(0,b.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqualOrParent(c,f.openedWorkspace.uri));if(u.length)return u.sort((f,v)=>-(f.openedWorkspace.uri.path.length-v.openedWorkspace.uri.path.length))[0]}function L(w,c){for(const m of w)if((0,b.isWorkspaceIdentifier)(m.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.configPath,c)||(0,b.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.uri,c))return m}function R(w,c){const m=u=>c.some(f=>n.extUriBiasedIgnorePathCase.isEqual(s.URI.file(f),s.URI.file(u)));for(const u of w)if(u.config?.extensionDevelopmentPath?.some(f=>m(f)))return u}}),define(ce[102],le([0,1,32,43,107,47,12,9,3,18,7,6,74,30]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkspacesService=void 0,e.isRecentWorkspace=h,e.isRecentFolder=g,e.isRecentFile=E,e.isStoredWorkspaceFolder=S,e.getStoredWorkspaceFolder=I,e.toWorkspaceFolders=d,e.rewriteWorkspaceFileForNewLocation=t,e.restoreRecentlyOpened=P,e.toStoreData=y,s=De(s),b=De(b),e.IWorkspacesService=(0,u.createDecorator)("workspacesService");function h(k){return k.hasOwnProperty("workspace")}function g(k){return k.hasOwnProperty("folderUri")}function E(k){return k.hasOwnProperty("fileUri")}function S(k){return p(k)||D(k)}function p(k){const T=k;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function D(k){const T=k;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function I(k,T,A,C,_){if(k.scheme!==C.scheme)return{name:A,uri:k.toString(!0)};let H=T?void 0:_.relativePath(C,k);if(H!==void 0)H.length===0?H=".":w.isWindows&&(H=i(H));else if(k.scheme===L.Schemas.file)H=k.fsPath,w.isWindows&&(H=i(H));else if(_.isEqualAuthority(k.authority,C.authority))H=k.path;else return{name:A,uri:k.toString(!0)};return{name:A,path:H}}function i(k){return k=(0,M.normalizeDriveLetter)(k),(0,n.isUNC)(k)||(k=(0,n.toSlashes)(k)),k}function d(k,T,A){const C=[],_=new Set,H=A.dirname(T);for(const q of k){let K;if(p(q))q.path&&(K=A.resolvePath(H,q.path));else if(D(q))try{K=m.URI.parse(q.uri),K.path[0]!==R.posix.sep&&(K=K.with({path:R.posix.sep+K.path}))}catch(fe){console.warn(fe)}if(K){const fe=A.getComparisonKey(K);if(!_.has(fe)){_.add(fe);const $=q.name||A.basenameOrAuthority(K);C.push(new v.WorkspaceFolder({uri:K,name:$,index:C.length},q))}}}return C}function t(k,T,A,C,_){const H=o(T,k),q=_.dirname(T),K=_.dirname(C),fe=[];for(const J of H.folders){const U=p(J)?_.resolvePath(q,J.path):m.URI.parse(J.uri);let O;A?O=!1:O=!p(J)||(0,R.isAbsolute)(J.path),fe.push(I(U,O,J.name,K,_))}const $={insertSpaces:!1,tabSize:4,eol:w.isLinux||w.isMacintosh?`
`:`\r
`},X=b.setProperty(k,["folders"],fe,$);let B=b.applyEdits(k,X);return(0,c.isEqualAuthority)(H.remoteAuthority,(0,f.getRemoteAuthority)(C))&&(B=b.applyEdits(B,b.removeProperty(B,["remoteAuthority"],$))),B}function o(k,T){const A=s.parse(T);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(C=>S(C));else throw new Error(`${k} looks like an invalid workspace file.`);return A}function r(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function a(k){return typeof k.folderUri=="string"}function l(k){return typeof k.fileUri=="string"}function P(k,T){const A={workspaces:[],files:[]};if(k){const C=function(H,q){for(let K=0;K<H.length;K++)try{q(H[K],K)}catch(fe){T.warn(`Error restoring recent entry ${JSON.stringify(H[K])}: ${fe.toString()}. Skip entry.`)}},_=k;Array.isArray(_.entries)&&C(_.entries,H=>{const q=H.label,K=H.remoteAuthority;r(H)?A.workspaces.push({label:q,remoteAuthority:K,workspace:{id:H.workspace.id,configPath:m.URI.parse(H.workspace.configPath)}}):a(H)?A.workspaces.push({label:q,remoteAuthority:K,folderUri:m.URI.parse(H.folderUri)}):l(H)&&A.files.push({label:q,remoteAuthority:K,fileUri:m.URI.parse(H.fileUri)})})}return A}function y(k){const T={entries:[]};for(const A of k.workspaces)g(A)?T.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):T.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of k.files)T.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return T}}),define(ce[103],le([0,1,91,12,3,18]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=L,e.getSingleFolderWorkspaceIdentifier=R,e.createEmptyWorkspaceIdentifier=w,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function L(c){function m(){let u=c.scheme===s.Schemas.file?(0,M.originalFSPath)(c):c.toString();return b.isLinux||(u=u.toLowerCase()),(0,n.createHash)("md5").update(u).digest("hex")}return{id:m(),configPath:c}}function R(c,m){function u(){if(c.scheme!==s.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!m)return;let v;return b.isLinux?v=m.ino:b.isMacintosh?v=m.birthtime.getTime():b.isWindows&&(typeof m.birthtimeMs=="number"?v=Math.floor(m.birthtimeMs):v=m.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(v?String(v):"").digest("hex")}const f=u();if(typeof f=="string")return{id:f,uri:c}}function w(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[104],le([0,1,91,93,27,252,17,15,4,2,9,3,33,44,117]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=r,e.createStaticIPCHandle=a,e.serve=y,e.connect=k;const g=3e4;class E{traceSocketEvent(A,C){h.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,C)}constructor(A,C=""){this._canWrite=!0,this.debugLabel=C,this.socket=A,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=H=>{if(this.traceSocketEvent(h.SocketDiagnosticsEventType.Error,{code:H?.code,message:H?.message}),H){if(H.code==="EPIPE")return;(0,R.onUnexpectedError)(H)}},this.socket.on("error",this._errorListener);let _;this._closeListener=H=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Close,{hadError:H}),this._canWrite=!1,_&&clearTimeout(_)},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1,_=setTimeout(()=>A.destroy(),g)},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(A){const C=_=>{this.traceSocketEvent(h.SocketDiagnosticsEventType.Read,_),A(L.VSBuffer.wrap(_))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(A){const C=_=>{A({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:_,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(A){const C=()=>{A()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(A){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(h.SocketDiagnosticsEventType.Write,A),this.socket.write(A.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,R.onUnexpectedError)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,R.onUnexpectedError)(C)}}end(){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((A,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),A();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent(h.SocketDiagnosticsEventType.NodeDrainEnd),A()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=E;var S;(function(T){T[T.MinHeaderByteSize=2]="MinHeaderByteSize",T[T.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(S||(S={}));var p;(function(T){T[T.PeekHeader=1]="PeekHeader",T[T.ReadHeader=2]="ReadHeader",T[T.ReadBody=3]="ReadBody",T[T.Fin=4]="Fin"})(p||(p={}));class D extends c.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(A,C){this.socket.traceSocketEvent(A,C)}constructor(A,C,_,H){super(),this._onData=this._register(new w.Emitter),this._onClose=this._register(new w.Emitter),this._isEnded=!1,this._state={state:p.PeekHeader,readLen:S.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=A,this.traceSocketEvent(h.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:_?.byteLength||0,recordInflateBytes:H}),this._flowManager=this._register(new I(this,C,_,H,this._onData,(q,K)=>this._write(q,K))),this._register(this._flowManager.onError(q=>{console.error(q),(0,R.onUnexpectedError)(q),this._onClose.fire({type:h.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:q})})),this._incomingData=new h.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(async q=>{this._flowManager.isProcessingReadQueue()&&await w.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(q)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this._onData.event(A)}onClose(A){return this._onClose.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){let C=0;for(;C<A.byteLength;)this._flowManager.writeMessage(A.slice(C,Math.min(C+S.MaxWebSocketMessageLength,A.byteLength)),{compressed:!0,opcode:2}),C+=S.MaxWebSocketMessageLength}_write(A,{compressed:C,opcode:_}){if(this._isEnded)return;this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,A);let H=S.MinHeaderByteSize;A.byteLength<126?H+=0:A.byteLength<2**16?H+=2:H+=8;const q=L.VSBuffer.alloc(H),K=C?64:0,fe=_&15;if(q.writeUInt8(128|K|fe,0),A.byteLength<126)q.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){q.writeUInt8(126,1);let $=1;q.writeUInt8(A.byteLength>>>8&255,++$),q.writeUInt8(A.byteLength>>>0&255,++$)}else{q.writeUInt8(127,1);let $=1;q.writeUInt8(0,++$),q.writeUInt8(0,++$),q.writeUInt8(0,++$),q.writeUInt8(0,++$),q.writeUInt8(A.byteLength>>>24&255,++$),q.writeUInt8(A.byteLength>>>16&255,++$),q.writeUInt8(A.byteLength>>>8&255,++$),q.writeUInt8(A.byteLength>>>0&255,++$)}this.socket.write(L.VSBuffer.concat([q,A]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(A){if(A.byteLength!==0){for(this._incomingData.acceptChunk(A);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===p.PeekHeader){const C=this._incomingData.peek(this._state.readLen),_=C.readUInt8(0),H=(_&128)>>>7,q=(_&64)>>>6,K=_&15,fe=C.readUInt8(1),$=(fe&128)>>>7,X=fe&127;this._state.state=p.ReadHeader,this._state.readLen=S.MinHeaderByteSize+($?4:0)+(X===126?2:0)+(X===127?8:0),this._state.fin=H,this._state.firstFrameOfMessage&&(this._state.compressed=!!q),this._state.firstFrameOfMessage=!!H,this._state.mask=0,this._state.opcode=K,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===p.ReadHeader){const C=this._incomingData.read(this._state.readLen),_=C.readUInt8(1),H=(_&128)>>>7;let q=_&127,K=1;q===126?q=C.readUInt8(++K)*2**8+C.readUInt8(++K):q===127&&(q=C.readUInt8(++K)*0+C.readUInt8(++K)*0+C.readUInt8(++K)*0+C.readUInt8(++K)*0+C.readUInt8(++K)*2**24+C.readUInt8(++K)*2**16+C.readUInt8(++K)*2**8+C.readUInt8(++K));let fe=0;H&&(fe=C.readUInt8(++K)*2**24+C.readUInt8(++K)*2**16+C.readUInt8(++K)*2**8+C.readUInt8(++K)),this._state.state=p.ReadBody,this._state.readLen=q,this._state.mask=fe,this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===p.ReadBody){const C=this._incomingData.read(this._state.readLen);this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,C),t(C,this._state.mask),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,C),this._state.state=p.PeekHeader,this._state.readLen=S.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(C,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await w.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(h.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=D;class I extends c.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(A,C,_,H,q,K){super(),this._tracer=A,this._onData=q,this._writeFn=K,this._onError=this._register(new w.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new w.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new w.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,C?(this._zlibInflateStream=this._register(new i(this._tracer,H,_,{windowBits:15})),this._zlibDeflateStream=this._register(new d(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(fe=>this._onError.fire(fe))),this._register(this._zlibDeflateStream.onError(fe=>this._onError.fire(fe)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(A,C){this._writeQueue.push({data:A,options:C}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:A,options:C}=this._writeQueue.shift();if(this._zlibDeflateStream&&C.compressed){const _=await this._deflateMessage(this._zlibDeflateStream,A);this._writeFn(_,C)}else this._writeFn(A,{...C,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(A,C){return new Promise((_,H)=>{A.write(C),A.flush(q=>_(q))})}acceptFrame(A,C,_){this._readQueue.push({data:A,isCompressed:C,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const A=this._readQueue.shift();if(this._zlibInflateStream&&A.isCompressed){const C=await this._inflateFrame(this._zlibInflateStream,A.data,A.isLastFrameOfMessage);this._onData.fire(C)}else this._onData.fire(A.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(A,C,_){return new Promise((H,q)=>{A.write(C),_&&A.write(L.VSBuffer.fromByteArray([0,0,255,255])),A.flush(K=>H(K))})}}class i extends c.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}constructor(A,C,_,H){super(),this._tracer=A,this._recordInflateBytes=C,this._onError=this._register(new w.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,M.createInflateRaw)(H),this._zlibInflate.on("error",q=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateError,{message:q?.message,code:q?.code}),this._onError.fire(q)}),this._zlibInflate.on("data",q=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateData,q),this._pendingInflateData.push(L.VSBuffer.wrap(q))}),_&&(this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialWrite,_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(A){this._recordInflateBytes&&this._recordedInflateBytes.push(A.clone()),this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateWrite,A),this._zlibInflate.write(A.buffer)}flush(A){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibInflateFlushFired);const C=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,A(C)})}}class d extends c.Disposable{constructor(A,C){super(),this._tracer=A,this._onError=this._register(new w.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,M.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateError,{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateData,_),this._pendingDeflateData.push(L.VSBuffer.wrap(_))})}write(A){this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateWrite,A.buffer),this._zlibDeflate.write(A.buffer)}flush(A){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(h.SocketDiagnosticsEventType.zlibDeflateFlushFired);let C=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,C=C.slice(0,C.byteLength-4),A(C)})}}function t(T,A){if(A===0)return;const C=T.byteLength>>>2;for(let $=0;$<C;$++){const X=T.readUInt32BE($*4);T.writeUInt32BE(X^A,$*4)}const _=C*4,H=T.byteLength-_,q=A>>>24&255,K=A>>>16&255,fe=A>>>8&255;H>=1&&T.writeUInt8(T.readUInt8(_)^q,_),H>=2&&T.writeUInt8(T.readUInt8(_+1)^K,_+1),H>=3&&T.writeUInt8(T.readUInt8(_+2)^fe,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[u.Platform.Linux]:107,[u.Platform.Mac]:103};function r(){const T=(0,f.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${T}-sock`;const A=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,b.tmpdir)(),C=(0,m.join)(A,`vscode-ipc-${T}.sock`);return l(C),C}function a(T,A,C){const H=(0,n.createHash)("sha256").update(T).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${H}-${C}-${A}-sock`;const q=C.substr(0,4),K=A.substr(0,6);let fe;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?fe=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${H}-${q}-${K}.sock`):fe=(0,m.join)(T,`${q}-${K}.sock`),l(fe),fe}function l(T){const A=o[u.platform];typeof A=="number"&&T.length>=A&&console.warn(`WARNING: IPC handle "${T}" is longer than ${A} chars, try a shorter --user-data-dir`)}class P extends v.IPCServer{static toClientConnectionEvent(A){const C=w.Event.fromNodeEventEmitter(A,"connection");return w.Event.map(C,_=>({protocol:new h.Protocol(new E(_,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter(_,"close"))}))}constructor(A){super(P.toClientConnectionEvent(A)),this.server=A}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=P;function y(T){return new Promise((A,C)=>{const _=(0,s.createServer)();_.on("error",C),_.listen(T,()=>{_.removeListener("error",C),A(new P(_))})})}function k(T,A){return new Promise((C,_)=>{const H=(0,s.createConnection)(T,()=>{H.removeListener("error",_),C(h.Client.fromSocket(new E(H,`ipc-client${A}`),A))});H.once("error",_)})}}),define(ce[20],le([0,1,54,9,3,104,38,95,6]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,w.refineServiceDecorator)(L.IEnvironmentService);class c extends R.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get backupHome(){return(0,s.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,s.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(b.isLinux){for(const u in process.env)if(u.endsWith("_VSCODE_SNAP_ORIG")){const f=u.slice(0,-17);if(this._snapEnv[f])continue;process.env[f]&&(this._snapEnv[f]=process.env[f]),process.env[u]?process.env[f]=process.env[u]:delete process.env[f]}}}restoreSnapExportedVariables(){if(b.isLinux)for(const u in this._snapEnv)process.env[u]=this._snapEnv[u],delete this._snapEnv[u]}}e.EnvironmentMainService=c,Ie([n.memoize],c.prototype,"backupHome",null),Ie([n.memoize],c.prototype,"mainIPCHandle",null),Ie([n.memoize],c.prototype,"mainLockfile",null),Ie([n.memoize],c.prototype,"disableUpdates",null),Ie([n.memoize],c.prototype,"crossOriginIsolated",null),Ie([n.memoize],c.prototype,"codeCachePath",null),Ie([n.memoize],c.prototype,"useCodeCache",null)}),define(ce[253],le([0,1,91,32,12,9,3,18,23,165,16,20,34,14,5,164,30,103]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let D=class{static{p=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(i,d,t,o){this.environmentMainService=i,this.configurationService=d,this.logService=t,this.stateService=o,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=R.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,a)=>(0,s.isEqual)(r,a,!L.isLinux)}}async initialize(){const i=this.stateService.getItem(p.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(i.emptyWindows),this.workspaces=await this.validateWorkspaces((0,c.deserializeWorkspaceInfos)(i)),this.folders=await this.validateFolders((0,c.deserializeFolderInfos)(i)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==v.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===v.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||v.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(i,d){this.workspaces.some(o=>i.workspace.id===o.workspace.id)||(this.workspaces.push(i),this.storeWorkspacesMetadata());const t=(0,M.join)(this.backupHome,i.workspace.id);return d?this.moveBackupFolder(t,d).then(()=>t):t}async moveBackupFolder(i,d){if(await w.Promises.exists(i)&&await this.convertToEmptyWindowBackup(i),await w.Promises.exists(d))try{await w.Promises.rename(d,i,!1)}catch(t){this.logService.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(i){return this.folders.some(d=>this.backupUriComparer.isEqual(i.folderUri,d.folderUri))||(this.folders.push(i),this.storeWorkspacesMetadata()),(0,M.join)(this.backupHome,this.getFolderHash(i))}registerEmptyWindowBackup(i){return this.emptyWindows.some(d=>!!d.backupFolder&&this.backupPathComparer.isEqual(d.backupFolder,i.backupFolder))||(this.emptyWindows.push(i),this.storeWorkspacesMetadata()),(0,M.join)(this.backupHome,i.backupFolder)}async validateWorkspaces(i){if(!Array.isArray(i))return[];const d=new Set,t=[];for(const o of i){const r=o.workspace;if(!(0,E.isWorkspaceIdentifier)(r))return[];if(!d.has(r.id)){d.add(r.id);const a=(0,M.join)(this.backupHome,r.id);await this.doHasBackups(a)?r.configPath.scheme!==b.Schemas.file||await w.Promises.exists(r.configPath.fsPath)?t.push(o):await this.convertToEmptyWindowBackup(a):await this.deleteStaleBackup(a)}}return t}async validateFolders(i){if(!Array.isArray(i))return[];const d=[],t=new Set;for(const o of i){const r=o.folderUri,a=this.backupUriComparer.getComparisonKey(r);if(!t.has(a)){t.add(a);const l=(0,M.join)(this.backupHome,this.getFolderHash(o));await this.doHasBackups(l)?r.scheme!==b.Schemas.file||await w.Promises.exists(r.fsPath)?d.push(o):await this.convertToEmptyWindowBackup(l):await this.deleteStaleBackup(l)}}return d}async validateEmptyWorkspaces(i){if(!Array.isArray(i))return[];const d=[],t=new Set;for(const o of i){const r=o.backupFolder;if(typeof r!="string")return[];if(!t.has(r)){t.add(r);const a=(0,M.join)(this.backupHome,r);await this.doHasBackups(a)?d.push(o):await this.deleteStaleBackup(a)}}return d}async deleteStaleBackup(i){try{await w.Promises.rm(i,w.RimRafMode.MOVE)}catch(d){this.logService.error(`Backup: Could not delete stale backup: ${d.toString()}`)}}prepareNewEmptyWindowBackup(){let i=(0,S.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(d=>!!d.backupFolder&&this.backupPathComparer.isEqual(d.backupFolder,i.id));)i=(0,S.createEmptyWorkspaceIdentifier)();return{backupFolder:i.id}}async convertToEmptyWindowBackup(i){const d=this.prepareNewEmptyWindowBackup(),t=(0,M.join)(this.backupHome,d.backupFolder);try{await w.Promises.rename(i,t,!1)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push(d),!0}async getDirtyWorkspaces(){const i=[];for(const d of this.workspaces)await this.hasBackups(d)&&i.push(d);for(const d of this.folders)await this.hasBackups(d)&&i.push(d);return i}hasBackups(i){let d;return(0,c.isEmptyWindowBackupInfo)(i)?d=(0,M.join)(this.backupHome,i.backupFolder):(0,g.isFolderBackupInfo)(i)?d=(0,M.join)(this.backupHome,this.getFolderHash(i)):d=(0,M.join)(this.backupHome,i.workspace.id),this.doHasBackups(d)}async doHasBackups(i){try{const d=await w.Promises.readdir(i);for(const t of d)try{if((await w.Promises.readdir((0,M.join)(i,t))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const i={workspaces:this.workspaces.map(({workspace:d,remoteAuthority:t})=>{const o={id:d.id,configURIPath:d.configPath.toString()};return t&&(o.remoteAuthority=t),o}),folders:this.folders.map(({folderUri:d,remoteAuthority:t})=>{const o={folderUri:d.toString()};return t&&(o.remoteAuthority=t),o}),emptyWindows:this.emptyWindows.map(({backupFolder:d,remoteAuthority:t})=>{const o={backupFolder:d};return t&&(o.remoteAuthority=t),o})};this.stateService.setItem(p.backupWorkspacesMetadataStorageKey,i)}getFolderHash(i){const d=i.folderUri;let t;return d.scheme===b.Schemas.file?t=L.isLinux?d.fsPath:d.fsPath.toLowerCase():t=d.toString().toLowerCase(),(0,n.createHash)("md5").update(t).digest("hex")}};e.BackupMainService=D,e.BackupMainService=D=p=Ie([re(0,u.IEnvironmentMainService),re(1,m.IConfigurationService),re(2,h.ILogService),re(3,f.IStateService)],D)});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[19],le([0,1,13,35,8,4,2,3,36,11,6,5,34,52,20]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,n=je(n),e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var E;(function(D){D[D.QUIT=1]="QUIT",D[D.KILL=2]="KILL"})(E||(e.ShutdownReason=E={}));var S;(function(D){D[D.Starting=1]="Starting",D[D.Ready=2]="Ready",D[D.AfterWindowOpen=3]="AfterWindowOpen",D[D.Eventually=4]="Eventually"})(S||(e.LifecycleMainPhase=S={}));let p=class extends L.Disposable{static{g=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(I,i,d){super(),this.logService=I,this.stateService=i,this.environmentMainService=d,this._onBeforeShutdown=this._register(new M.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new M.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new M.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new M.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=S.Starting,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(S.Ready).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(g.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(g.QUIT_AND_RESTART_KEY)}registerListeners(){const I=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),R.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(E.QUIT))};n.default.app.addListener("before-quit",I);const i=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!R.isMacintosh)&&n.default.app.quit()};n.default.app.addListener("window-all-closed",i),n.default.app.once("will-quit",d=>{this.trace("Lifecycle#app.on(will-quit) - begin"),d.preventDefault(),this.fireOnWillShutdown(E.QUIT).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),n.default.app.removeListener("before-quit",I),n.default.app.removeListener("window-all-closed",i),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),n.default.app.quit()})})}fireOnWillShutdown(I){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const i=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const d=[];return this._onWillShutdown.fire({reason:I,join(t,o){i.trace(`Lifecycle#onWillShutdown - begin '${t}'`),d.push(o.finally(()=>{i.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await b.Promises.settled(d)}catch(t){this.logService.error(t)}try{await this.stateService.close()}catch(t){this.logService.error(t)}})(),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===I)return;this.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const i=this.phaseWhen.get(this._phase);i&&(i.open(),this.phaseWhen.delete(this._phase))}async when(I){if(I<=this._phase)return;let i=this.phaseWhen.get(I);i||(i=new b.Barrier,this.phaseWhen.set(I,i)),await i.wait()}registerWindow(I){const i=new L.DisposableStore;this.windowCounter++,i.add(I.onWillLoad(t=>this._onWillLoadWindow.fire({window:I,workspace:t.workspace,reason:t.reason})));const d=(0,c.assertIsDefined)(I.win);i.add(M.Event.fromNodeEventEmitter(d,"close")(t=>{const o=I.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),t.preventDefault(),this.unload(I,v.UnloadReason.CLOSE).then(r=>{if(r){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(I),I.close()})})),i.add(M.Event.fromNodeEventEmitter(d,"closed")(()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,i.dispose(),this.windowCounter===0&&(!R.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(E.QUIT)}))}registerAuxWindow(I){const i=(0,c.assertIsDefined)(I.win),d=new L.DisposableStore;d.add(M.Event.fromNodeEventEmitter(i,"close")(t=>{this.trace(`Lifecycle#auxWindow.on('close') - window ID ${I.id}`),this._quitRequested&&(this.trace("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),d.add(M.Event.fromNodeEventEmitter(i,"closed")(()=>{this.trace(`Lifecycle#auxWindow.on('closed') - window ID ${I.id}`),d.dispose()}))}async reload(I,i){await this.unload(I,v.UnloadReason.RELOAD)||I.reload(i)}unload(I,i){const d=this.mapWindowIdToPendingUnload.get(I.id);if(d)return d;const t=this.doUnload(I,i).finally(()=>{this.mapWindowIdToPendingUnload.delete(I.id)});return this.mapWindowIdToPendingUnload.set(I.id,t),t}async doUnload(I,i){if(!I.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${I.id}`);const d=this._quitRequested?v.UnloadReason.QUIT:i,t=await this.onBeforeUnloadWindowInRenderer(I,d);return t?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(t)):(await this.onWillUnloadWindowInRenderer(I,d),!1)}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(I,i){return new Promise(d=>{const t=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;s.validatedIpcMain.once(o,()=>{d(!1)}),s.validatedIpcMain.once(r,()=>{d(!0)}),I.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:i})})}onWillUnloadWindowInRenderer(I,i){return new Promise(d=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;s.validatedIpcMain.once(o,()=>d()),I.send("vscode:onWillUnload",{replyChannel:o,reason:i})})}quit(I){return this.doQuit(I).then(i=>{if(!i&&I)try{if(R.isWindows){const d=(0,w.cwd)();d!==process.cwd()&&process.chdir(d)}}catch(d){this.logService.error(d)}return i})}doQuit(I){return this.trace(`Lifecycle#quit() - begin (willRestart: ${I})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(I&&this.stateService.setItem(g.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(i=>{this.pendingQuitPromiseResolve=i,this.trace("Lifecycle#quit() - calling app.quit()"),n.default.app.quit()}),this.pendingQuitPromise)}trace(I){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(I):this.logService.trace(I)}setRelaunchHandler(I){this.relaunchHandler=I}async relaunch(I){this.trace("Lifecycle#relaunch()");const i=process.argv.slice(1);if(I?.addArgs&&i.push(...I.addArgs),I?.removeArgs)for(const o of I.removeArgs){const r=i.indexOf(o);r>=0&&i.splice(r,1)}const d=()=>{this.relaunchHandler?.handleRelaunch(I)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),n.default.app.relaunch({args:i}))};n.default.app.once("quit",d),await this.quit(!0)&&n.default.app.removeListener("quit",d)}async kill(I){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(E.KILL),await Promise.race([(0,b.timeout)(1e3),(async()=>{for(const i of n.default.BrowserWindow.getAllWindows())if(i&&!i.isDestroyed()){let d;i.webContents&&!i.webContents.isDestroyed()?d=new Promise(t=>i.once("closed",t)):d=Promise.resolve(),i.destroy(),await d}})()]),n.default.app.exit(I)}};e.LifecycleMainService=p,e.LifecycleMainService=p=g=Ie([re(0,u.ILogService),re(1,f.IStateService),re(2,h.IEnvironmentMainService)],p)}),define(ce[254],le([0,1,3,4,2,6,19]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,n=De(n),e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let R=class extends b.Disposable{constructor(m){super(),this._onDidChangeKeyboardLayout=this._register(new s.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(L.LifecycleMainPhase.AfterWindowOpen).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((u,f)=>{V(["native-keymap"],u,f)}).then(De);this._keyboardLayoutData=w(m),n.isCI||m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=w(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=R,e.KeyboardLayoutMainService=R=Ie([re(0,L.ILifecycleMainService)],R);function w(c){const m=c.getKeyMap(),u=c.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:u}}}),define(ce[255],le([0,1,215,8,17,15,11,16,38,100,5,49,214,252]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=E;let h=class extends u.AbstractRequestService{constructor(p,D,I,i){super(i),this.configurationService=p,this.environmentService=D,this.logService=I,this.configure(),this._register(p.onDidChangeConfiguration(d=>{d.affectsConfiguration("http")&&this.configure()}))}configure(){const p=this.configurationService.getValue("http");this.proxyUrl=p?.proxy,this.strictSSL=!!p?.proxyStrictSSL,this.authorization=p?.proxyAuthorization}async request(p,D){const{proxyUrl:I,strictSSL:i}=this;let d;try{d=await(0,c.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,M.getErrorMessage)(r)))}const t={...process.env,...d},o=p.agent?p.agent:await(0,f.getProxyAgent)(p.url||"",t,{proxyUrl:I,strictSSL:i});return p.agent=o,p.strictSSL=i,this.authorization&&(p.headers={...p.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(p.isChromiumNetwork?"electron":"node",p,()=>E(p,D))}async resolveProxy(p){}async lookupAuthorization(p){}async lookupKerberosAuthorization(p){try{const D=await new Promise((o,r)=>{V(["kerberos"],o,r)}).then(De),I=new URL(p),i=this.configurationService.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${I.hostname}`:`HTTP@${I.hostname}`);return this.logService.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${I}`,`spn:${i}`),"Negotiate "+await(await D.initializeClient(i)).step("")}catch(D){this.logService.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",D);return}}async loadCertificates(){return(await new Promise((D,I)=>{V(["@vscode/proxy-agent"],D,I)}).then(De)).loadSystemCertificates({log:this.logService})}};e.RequestService=h,e.RequestService=h=Ie([re(0,R.IConfigurationService),re(1,w.INativeEnvironmentService),re(2,m.ILogService),re(3,m.ILoggerService)],h);async function g(S){return((0,n.parse)(S.url).protocol==="https:"?await new Promise((I,i)=>{V(["https"],I,i)}).then(De):await new Promise((I,i)=>{V(["http"],I,i)}).then(De)).request}async function E(S,p){return s.Promises.withAsyncBody(async(D,I)=>{const i=(0,n.parse)(S.url),d=S.getRawRequest?S.getRawRequest(S):await g(S),t={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:S.type||"GET",headers:S.headers,agent:S.agent,rejectUnauthorized:(0,L.isBoolean)(S.strictSSL)?S.strictSSL:!0};S.user&&S.password&&(t.auth=S.user+":"+S.password);const o=d(t,r=>{const a=(0,L.isNumber)(S.followRedirects)?S.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&a>0&&r.headers.location)E({...S,url:r.headers.location,followRedirects:a-1},p).then(D,I);else{let l=r;!S.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(l=r.pipe((0,v.createGunzip)())),D({res:r,stream:(0,b.streamToBufferReadableStream)(l)})}});o.on("error",I),S.timeout&&o.setTimeout(S.timeout),S.isChromiumNetwork&&o.removeHeader("Content-Length"),S.data&&typeof S.data=="string"&&o.write(S.data),o.end(),p.onCancellationRequested(()=>{o.abort(),I(new M.CancellationError)})})}}),define(ce[256],le([0,1,13,255]),function(V,e,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function b(L){return n.net.request}class M extends s.RequestService{request(R,w){return super.request({...R||{},getRawRequest:b,isChromiumNetwork:!0},w)}}e.RequestMainService=M}),define(ce[87],le([0,1,7,4,2,38,14,6,19,5,62,249,42,58,41,12]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,R.createDecorator)("storageMainService");let E=class extends b.Disposable{constructor(D,I,i,d,t,o){super(),this.logService=D,this.environmentService=I,this.userDataProfilesService=i,this.lifecycleMainService=d,this.fileService=t,this.uriIdentityService=o,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new s.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(w.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(D=>{D.window.profile&&this.profileStorage(D.window.profile).init(),D.workspace&&this.workspaceStorage(D.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(D=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=D.reason,D.join("applicationStorage",this.applicationStorage.close());for(const[,I]of this.mapProfileToStorage)D.join("profileStorage",I.close());for(const[,I]of this.mapWorkspaceToStorage)D.join("workspaceStorage",I.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(D=>{D.join((async()=>{await this.fileService.exists(D.profile.globalStorageHome)||await this.fileService.createFolder(D.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(D=>{const I=this.mapProfileToStorage.get(D.profile.id);I&&D.join(I.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const D=new u.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(s.Event.once(D.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),D}profileStorage(D){if((0,m.isProfileUsingDefaultStorage)(D))return this.applicationStorage;let I=this.mapProfileToStorage.get(D.id);if(!I){this.logService.trace(`StorageMainService: creating profile storage (${D.name})`),I=this._register(this.createProfileStorage(D)),this.mapProfileToStorage.set(D.id,I);const i=this._register(I.onDidChangeStorage(d=>this._onDidChangeProfileStorage.fire({...d,storage:I,profile:D})));this._register(s.Event.once(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${D.name})`),this.mapProfileToStorage.delete(D.id),i.dispose()}))}return I}createProfileStorage(D){return this.shutdownReason===w.ShutdownReason.KILL?new u.InMemoryStorageMain(this.logService,this.fileService):new u.ProfileStorageMain(D,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(D){let I=this.mapWorkspaceToStorage.get(D.id);return I||(this.logService.trace(`StorageMainService: creating workspace storage (${D.id})`),I=this._register(this.createWorkspaceStorage(D)),this.mapWorkspaceToStorage.set(D.id,I),this._register(s.Event.once(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${D.id})`),this.mapWorkspaceToStorage.delete(D.id)}))),I}createWorkspaceStorage(D){return this.shutdownReason===w.ShutdownReason.KILL?new u.InMemoryStorageMain(this.logService,this.fileService):new u.WorkspaceStorageMain(D,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(D){const I=n.URI.file(D);for(const i of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(i.path&&this.uriIdentityService.extUri.isEqualOrParent(n.URI.file(i.path),I))return!0;return!1}};e.StorageMainService=E,e.StorageMainService=E=Ie([re(0,c.ILogService),re(1,M.IEnvironmentService),re(2,v.IUserDataProfilesMainService),re(3,w.ILifecycleMainService),re(4,L.IFileService),re(5,h.IUriIdentityService)],E),e.IApplicationStorageMainService=(0,R.createDecorator)("applicationStorageMainService");let S=class extends m.AbstractStorageService{constructor(D,I){super(),this.userDataProfilesService=D,this.storageMainService=I,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(D){if(D===m.StorageScope.APPLICATION)return this.storageMainService.applicationStorage.storage}getLogDetails(D){if(D===m.StorageScope.APPLICATION)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=S,e.ApplicationStorageMainService=S=Ie([re(0,f.IUserDataProfilesService),re(1,e.IStorageMainService)],S)}),define(ce[257],le([0,1,93,27,113,104,8,2,3,16,5,28,208,211,101,131,17]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0,n=De(n),s=De(s);async function S(d,t,o,r,a){let l;for(let P=3;P&&(l?.dispose(),l=await new p(d,t,o,r,a).waitForReady(),!(a&&b.BROWSER_RESTRICTED_PORTS[a]||!b.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));P--);return l}class p extends R.Disposable{constructor(t,o,r,a,l){super(),this.defaultTunnelHost=o,this.suggestedLocalPort=l,this.privacy=g.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=t,this._server=n.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=P=>this._onConnection(P),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){const t=this.suggestedLocalPort??this.tunnelRemotePort,o=(0,g.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let r=await(0,b.findFreePortFaster)(t,2,1e3,o),a=null;return this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(r=0,this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(t){t.pause();const o=(0,g.isLocalhost)(this.tunnelRemoteHost)||(0,g.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,f.connectRemoteAgentTunnel)(this._options,o,this.tunnelRemotePort),a=r.getSocket(),l=r.readEntireBuffer();r.dispose(),l.byteLength>0&&t.write(l.buffer),t.on("end",()=>{t.localAddress&&this._socketsDispose.delete(t.localAddress),a.end()}),t.on("close",()=>a.end()),t.on("error",()=>{t.localAddress&&this._socketsDispose.delete(t.localAddress),a instanceof M.NodeSocket?a.socket.destroy():a.end()}),a instanceof M.NodeSocket?this._mirrorNodeSocket(t,a):this._mirrorGenericSocket(t,a),t.localAddress&&this._socketsDispose.set(t.localAddress,()=>{t.end(),a.end()})}_mirrorGenericSocket(t,o){o.onClose(()=>t.destroy()),o.onEnd(()=>t.end()),o.onData(r=>t.write(r.buffer)),t.on("data",r=>o.write(E.VSBuffer.wrap(r))),t.resume()}_mirrorNodeSocket(t,o){const r=o.socket;r.on("end",()=>t.end()),r.on("close",()=>t.end()),r.on("error",()=>{t.destroy()}),r.pipe(t),t.pipe(r)}}e.NodeRemoteTunnel=p;let D=class extends g.AbstractTunnelService{constructor(t,o,r,a,l){super(o,l),this.remoteSocketFactoryService=t,this.signService=r,this.productService=a}isPortPrivileged(t){return(0,g.isPortPrivileged)(t,this.defaultTunnelHost,w.OS,s.release())}retainOrCreateTunnel(t,o,r,a,l,P,y,k){const T=this.getTunnelFromMap(o,r);if(T)return++T.refcount,T.value;if((0,g.isTunnelProvider)(t))return this.createWithProvider(t,o,r,l,P,y,k);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${r} on local port ${l}.`);const A={commit:this.productService.commit,quality:this.productService.quality,addressProvider:t,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},C=S(A,a,o,r,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,r,C),C}}};e.BaseTunnelService=D,e.BaseTunnelService=D=Ie([re(0,v.IRemoteSocketFactoryService),re(1,m.ILogService),re(2,h.ISignService),re(3,u.IProductService),re(4,c.IConfigurationService)],D);let I=class extends D{constructor(t,o,r,a,l){super(t,o,r,a,l)}};e.TunnelService=I,e.TunnelService=I=Ie([re(0,v.IRemoteSocketFactoryService),re(1,m.ILogService),re(2,h.ISignService),re(3,u.IProductService),re(4,c.IConfigurationService)],I);let i=class extends R.Disposable{constructor(t,o,r,a,l){super(),this.remoteSocketFactoryService=t,this.logService=o,this.productService=r,this.signService=a,this.configurationService=l,this._tunnelServices=new Map}async openTunnel(t,o,r,a,l,P,y,k,T){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${a} on local port ${P}.`),!this._tunnelServices.has(t)){const A=new I(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(A),this._tunnelServices.set(t,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this._tunnelServices.delete(t))})}return this._tunnelServices.get(t).openTunnel(o,r,a,l,P,y,k,T)}};e.SharedTunnelsService=i,e.SharedTunnelsService=i=Ie([re(0,v.IRemoteSocketFactoryService),re(1,m.ILogService),re(2,u.IProductService),re(3,h.ISignService),re(4,c.IConfigurationService)],i)}),define(ce[105],le([0,1,8,22,4,16,20,19,5,28,49,50]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=void 0,e.createUpdateURL=f;function f(h,g,E){return`${E.updateUrl}/api/update/${h}/${g}/${E.commit}`}let v=class{get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}constructor(g,E,S,p,D,I){this.lifecycleMainService=g,this.configurationService=E,this.environmentMainService=S,this.requestService=p,this.logService=D,this.productService=I,this._state=u.State.Uninitialized,this._onStateChange=new b.Emitter,this.onStateChange=this._onStateChange.event,g.when(R.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(u.State.Disabled(u.DisablementReason.NotBuilt));return}if(this.environmentMainService.disableUpdates){this.setState(u.State.Disabled(u.DisablementReason.DisabledByEnvironment)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(u.State.Disabled(u.DisablementReason.MissingConfiguration)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.configurationService.getValue("update.mode"),E=this.getProductQuality(g);if(!E){this.setState(u.State.Disabled(u.DisablementReason.ManuallyDisabled)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.setState(u.State.Disabled(u.DisablementReason.InvalidConfiguration)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.configurationService.getValue("_update.prss")){const S=new URL(this.url);S.searchParams.set("prss","true"),this.url=S.toString()}if(this.setState(u.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,n.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},s.CancellationToken.None)).res.statusCode===204}catch(E){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(E);return}}async _applySpecificUpdate(g){}getUpdateType(){return u.UpdateType.Archive}doQuitAndInstall(){}};e.AbstractUpdateService=v,e.AbstractUpdateService=v=Ie([re(0,R.ILifecycleMainService),re(1,M.IConfigurationService),re(2,L.IEnvironmentMainService),re(3,m.IRequestService),re(4,w.ILogService),re(5,c.IProductService)],v)}),define(ce[258],le([0,1,13,54,4,46,2,16,20,19,5,28,49,24,50,105]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0,n=De(n);let E=class extends g.AbstractUpdateService{get onRawError(){return b.Event.fromNodeEventEmitter(n.autoUpdater,"error",(p,D)=>D)}get onRawUpdateNotAvailable(){return b.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return b.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get onRawUpdateDownloaded(){return b.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(p,D,I,i)=>({version:I,productVersion:I,timestamp:i}))}constructor(p,D,I,i,d,t,o){super(p,D,i,d,t,o),this.telemetryService=I,this.disposables=new L.DisposableStore,p.setRelaunchHandler(this)}handleRelaunch(p){return p?.addArgs||p?.removeArgs||this.state.type!==h.StateType.Ready?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.telemetryService.publicLog2("update:error",{messageHash:String((0,M.hash)(String(p)))}),this.logService.error("UpdateService error:",p);const D=this.state.type===h.StateType.CheckingForUpdates&&this.state.explicit?p:void 0;this.setState(h.State.Idle(h.UpdateType.Archive,D))}buildUpdateFeedUrl(p){let D;this.productService.darwinUniversalAssetId?D=this.productService.darwinUniversalAssetId:D=process.arch==="x64"?"darwin":"darwin-arm64";const I=(0,g.createUpdateURL)(D,p,this.productService);try{n.autoUpdater.setFeedURL({url:I})}catch(i){this.logService.error("Failed to set update feed URL",i);return}return I}doCheckForUpdates(p){this.setState(h.State.CheckingForUpdates(p)),n.autoUpdater.checkForUpdates()}onUpdateAvailable(){this.state.type===h.StateType.CheckingForUpdates&&this.setState(h.State.Downloading)}onUpdateDownloaded(p){this.state.type===h.StateType.Downloading&&(this.setState(h.State.Downloaded(p)),this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(h.State.Ready(p)))}onUpdateNotAvailable(){this.state.type===h.StateType.CheckingForUpdates&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(h.State.Idle(h.UpdateType.Archive)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=E,Ie([s.memoize],E.prototype,"onRawError",null),Ie([s.memoize],E.prototype,"onRawUpdateNotAvailable",null),Ie([s.memoize],E.prototype,"onRawUpdateAvailable",null),Ie([s.memoize],E.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=E=Ie([re(0,c.ILifecycleMainService),re(1,R.IConfigurationService),re(2,v.ITelemetryService),re(3,w.IEnvironmentMainService),re(4,f.IRequestService),re(5,m.ILogService),re(6,u.IProductService)],E)}),define(ce[259],le([0,1,48,26,8,4,9,20,19,5,24,50]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0,L=De(L);let f=class{get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}constructor(g,E,S){if(this.lifecycleMainService=g,this.logService=S,this._state=u.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(u.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}scheduleCheckForUpdates(g=60*60*1e3){return(0,b.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return u.UpdateType.Snap}doQuitAndInstall(){}async _applySpecificUpdate(g){}};f=Ie([re(0,w.ILifecycleMainService),re(1,R.IEnvironmentMainService),re(2,c.ILogService)],f);let v=class extends f{constructor(g,E,S,p,D,I){super(S,p,D),this.snap=g,this.snapRevision=E,this.telemetryService=I;const i=(0,s.watch)(L.dirname(this.snap)),d=M.Event.fromNodeEventEmitter(i,"change",(a,l)=>l),t=M.Event.filter(d,a=>a==="current"),r=M.Event.debounce(t,(a,l)=>l,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{r.dispose(),i.close()})}doCheckForUpdates(){this.setState(u.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(u.State.Ready({version:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(u.State.Idle(u.UpdateType.Snap)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(u.State.Idle(u.UpdateType.Snap,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+L.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((S,p)=>(0,s.realpath)(`${L.dirname(this.snap)}/current`,(D,I)=>D?p(D):S(I))),E=L.basename(g);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=v,e.SnapUpdateService=v=Ie([re(2,w.ILifecycleMainService),re(3,R.IEnvironmentMainService),re(4,c.ILogService),re(5,m.ITelemetryService)],v)});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[29],le([0,1,13,140,9,3,16,20,6,28,76,51,52]),function(V,e,n,s,b,M,L,R,w,c,m,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.IWindowsMainService=void 0,e.defaultBrowserWindowOptions=h,e.getLastFocused=g,n=je(n),e.IWindowsMainService=(0,w.createDecorator)("windowsMainService");var v;(function(S){S[S.CLI=0]="CLI",S[S.DOCK=1]="DOCK",S[S.MENU=2]="MENU",S[S.DIALOG=3]="DIALOG",S[S.DESKTOP=4]="DESKTOP",S[S.API=5]="API"})(v||(e.OpenContext=v={}));function h(S,p,D){const I=S.get(m.IThemeMainService),i=S.get(c.IProductService),d=S.get(L.IConfigurationService),t=S.get(R.IEnvironmentMainService),o=d.getValue("window"),r={backgroundColor:I.getBackgroundColor(),minWidth:u.WindowMinimumSize.WIDTH,minHeight:u.WindowMinimumSize.HEIGHT,title:i.nameLong,show:p.mode!==f.WindowMode.Maximized&&p.mode!==f.WindowMode.Fullscreen,x:p.x,y:p.y,width:p.width,height:p.height,webPreferences:{...D,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,u.zoomLevelToZoomFactor)(p.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(M.isLinux?r.icon=(0,b.join)(t.appRoot,"resources/linux/code.png"):M.isWindows&&!t.isBuilt&&(r.icon=(0,b.join)(t.appRoot,"resources/win32/code_150x150.png")),M.isMacintosh&&(r.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(r.acceptFirstMouse=!1)),M.isMacintosh&&!(0,u.useNativeFullScreen)(d)&&(r.fullscreenable=!1),M.isMacintosh&&o?.nativeTabs===!0&&(r.tabbingIdentifier=i.nameShort),!(0,u.hasNativeTitlebar)(d)&&p.mode!==f.WindowMode.Custom&&(r.titleBarStyle="hidden",M.isMacintosh||(r.frame=!1),(0,u.useWindowControlsOverlay)(d))){const P=I.getWindowSplash()?.colorInfo.titleBarBackground??I.getBackgroundColor(),y=s.Color.fromHex(P).isDarker()?"#FFFFFF":"#000000";r.titleBarOverlay={height:29,color:P,symbolColor:y}}return r}function g(S){let p,D=Number.MIN_VALUE;for(const I of S)I.lastFocusTime>D&&(D=I.lastFocusTime,p=I);return p}var E;(function(S){function p(I,i,d=n.default.screen.getAllDisplays()){if(I.trace(`window#validateWindowState: validating window state on ${d.length} display(s)`,i),typeof i.x!="number"||typeof i.y!="number"||typeof i.width!="number"||typeof i.height!="number"){I.trace("window#validateWindowState: unexpected type of state values");return}if(i.width<=0||i.height<=0){I.trace("window#validateWindowState: unexpected negative values");return}if(d.length===1){const r=D(d[0]);if(I.trace("window#validateWindowState: single monitor working area",r),r){let a=function(){!i||typeof i.x!="number"||typeof i.y!="number"||!r||(i.x<r.x&&(i.x=r.x),i.y<r.y&&(i.y=r.y))};a(),i.width>r.width&&(i.width=r.width),i.height>r.height&&(i.height=r.height),i.x>r.x+r.width-128&&(i.x=r.x+r.width-i.width),i.y>r.y+r.height-128&&(i.y=r.y+r.height-i.height),a()}return i}if(i.display&&i.mode===f.WindowMode.Fullscreen){const r=d.find(a=>a.id===i.display);if(r&&typeof r.bounds?.x=="number"&&typeof r.bounds?.y=="number"){I.trace("window#validateWindowState: restoring fullscreen to previous display");const a=(0,f.defaultWindowState)(f.WindowMode.Fullscreen);return a.x=r.bounds.x,a.y=r.bounds.y,a}}let t,o;try{t=n.default.screen.getDisplayMatching({x:i.x,y:i.y,width:i.width,height:i.height}),o=D(t),I.trace("window#validateWindowState: multi-monitor working area",o)}catch(r){I.error("window#validateWindowState: error finding display for window state",r)}if(t&&o&&i.x+i.width>o.x&&i.y+i.height>o.y&&i.x<o.x+o.width&&i.y<o.y+o.height)return i;I.trace("window#validateWindowState: state is outside of the multi-monitor working area")}S.validateWindowState=p;function D(I){if(I.workArea.width>0&&I.workArea.height>0)return I.workArea;if(I.bounds.width>0&&I.bounds.height>0)return I.bounds}})(E||(e.WindowStateValidator=E={}))}),define(ce[260],le([0,1,93,167,120,29]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class L extends s.ExtensionHostDebugBroadcastChannel{constructor(w){super(),this.windowsMainService=w}call(w,c,m){return c==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(w,c,m)}async openExtensionDevelopmentHostWindow(w,c){const m=(0,b.parseArgs)(w,b.OPTIONS);m.debugRenderer=c;const u=m.extensionDevelopmentPath;if(!u)return{success:!1};const[f]=await this.windowsMainService.openExtensionDevelopmentHostWindow(u,{context:M.OpenContext.API,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!c)return{success:!0};const v=f.win;if(!v)return{success:!0};const h=v.webContents.debugger;let g=h.isAttached()?1/0:0;const E=(0,n.createServer)(S=>{g++===0&&h.attach();let p=!1;const D=d=>{p||S.write(JSON.stringify(d)+"\0")},I=(d,t,o,r)=>D({method:t,params:o,sessionId:r});v.on("close",()=>{h.removeListener("message",I),S.end(),p=!0}),h.addListener("message",I);let i=Buffer.alloc(0);S.on("data",d=>{i=Buffer.concat([i,d]);for(let t=i.indexOf(0);t!==-1;t=i.indexOf(0)){let o;try{const r=i.slice(0,t).toString("utf8");i=i.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}h.sendCommand(o.method,o.params,o.sessionId).then(r=>D({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>D({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),S.on("error",d=>{console.error("error on cdp pipe:",d)}),S.on("close",()=>{p=!0,--g===0&&h.detach()})});return await new Promise(S=>E.listen(0,S)),v.on("close",()=>E.close()),{rendererDebugPort:E.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=L}),define(ce[261],le([0,1,13,21,3,7,23,16,68,6,5,132,29]),function(V,e,n,s,b,M,L,R,w,c,m,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,c.createDecorator)(e.ID);let v=class{constructor(g,E,S,p){this.logService=g,this.windowsMainService=E,this.urlService=S,this.configurationService=p}async start(g,E){this.logService.trace("Received data from other instance: ",g,E),b.isMacintosh&&n.app.focus({steal:!0});const S=this.parseOpenUrl(g);if(S.length){let p=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const D=(0,s.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:f.OpenContext.DESKTOP}));D&&(p=D.ready())}p.then(()=>{for(const{uri:D,originalUrl:I}of S)this.urlService.open(D,{originalUrl:I})})}else return this.startOpenWindow(g,E)}parseOpenUrl(g){return g["open-url"]&&g._urls&&g._urls.length>0?(0,s.coalesce)(g._urls.map(E=>{try{return{uri:M.URI.parse(E),originalUrl:E}}catch{return null}})):[]}async startOpenWindow(g,E){const S=(0,w.isLaunchedFromCli)(E)?f.OpenContext.CLI:f.OpenContext.DESKTOP;let p=[];const D=g.wait&&g.waitMarkerFilePath?M.URI.file(g.waitMarkerFilePath):void 0,I=g.remote||void 0,i={context:S,cli:g,userEnv:g["preserve-env"]||S===f.OpenContext.CLI?E:void 0,waitMarkerFileURI:D,remoteAuthority:I,forceProfile:g.profile,forceTempProfile:g["profile-temp"]};if(g.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(g.extensionDevelopmentPath,i);else if(!g._.length&&!g["folder-uri"]&&!g["file-uri"]){let d=!1;if(g["new-window"]||i.forceProfile||i.forceTempProfile)d=!0;else if(g["reuse-window"])d=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":d=!0;break;case"off":d=!1;break;default:d=!b.isMacintosh}if(d)p=await this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const t=this.windowsMainService.getLastActiveWindow();t?(this.windowsMainService.openExistingWindow(t,i),p=[t]):p=await this.windowsMainService.open({...i,forceEmpty:!0})}}else p=await this.windowsMainService.open({...i,forceNewWindow:g["new-window"],preferNewWindow:!g["reuse-window"]&&!g.wait,forceReuseWindow:g["reuse-window"],diffMode:g.diff,mergeMode:g.merge,addMode:g.add,noRecentEntry:!!g["skip-add-to-recently-opened"],gotoLineMode:g.goto});if(D&&p.length===1&&p[0])return Promise.race([p[0].whenClosedOrLoaded,(0,L.whenDeleted)(D.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=v,e.LaunchMainService=v=Ie([re(0,m.ILogService),re(1,f.IWindowsMainService),re(2,u.IURLService),re(3,R.IConfigurationService)],v)}),define(ce[135],le([0,1,13,22,4,46,2,7,33,16,97,20,6,5,62,87,29]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthService=e.IProxyAuthService=void 0,e.IProxyAuthService=(0,f.createDecorator)("proxyAuthService");let S=class extends L.Disposable{constructor(D,I,i,d,t,o){super(),this.logService=D,this.windowsMainService=I,this.encryptionMainService=i,this.applicationStorageMainService=d,this.configurationService=t,this.environmentMainService=o,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolves=new Map,this.currentDialog=void 0,this.cancelledAuthInfoHashes=new Set,this.sessionCredentials=new Map,this.registerListeners()}registerListeners(){const D=b.Event.fromNodeEventEmitter(n.app,"login",(I,i,d,t,o)=>({event:I,authInfo:{...t,attempt:d.firstAuthAttempt?1:2},callback:o}));this._register(D(this.onLogin,this))}async lookupAuthorization(D){return this.onLogin({authInfo:D})}async onLogin({event:D,authInfo:I,callback:i}){if(!I.isProxy)return;D?.preventDefault();const d=String((0,M.hash)({scheme:I.scheme,host:I.host,port:I.port}));let t,o=this.pendingProxyResolves.get(d);if(o)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),t=await o;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),o=this.resolveProxyCredentials(I,d),this.pendingProxyResolves.set(d,o);try{t=await o}finally{this.pendingProxyResolves.delete(d)}}return i?.(t?.username,t?.password),t}async resolveProxyCredentials(D,I){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const i=await this.doResolveProxyCredentials(D,I);if(i)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),i;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(D,I){if(this.logService.trace("auth#doResolveProxyCredentials - enter",D),this.environmentMainService.extensionTestsLocationURI){const l=this.configurationService.getValue("integration-test.http.proxyAuth");if(l){const P=l.indexOf(":");return P!==-1?{username:l.substring(0,P),password:l.substring(P+1)}:{username:l,password:""}}return}const i=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(i?.indexOf("@")!==-1){const l=R.URI.parse(i),P=l.authority.indexOf("@");if(P!==-1){if(D.attempt>1){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - ignoring previously used config/envvar credentials");return}this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found config/envvar credentials to use");const y=l.authority.substring(0,P),k=y.indexOf(":");return k!==-1?{username:y.substring(0,k),password:y.substring(k+1)}:{username:y,password:""}}}const d=D.attempt===1&&this.sessionCredentials.get(I);if(d){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:l,password:P}=d;return{username:l,password:P}}let t,o;try{const l=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+I,h.StorageScope.APPLICATION);if(l){const P=JSON.parse(await this.encryptionMainService.decrypt(l));t=P.username,o=P.password}}catch(l){this.logService.error(l)}if(D.attempt===1&&typeof t=="string"&&typeof o=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.sessionCredentials.set(I,{username:t,password:o}),{username:t,password:o};const r=this.currentDialog,a=this.currentDialog=(async()=>{await r;const l=await this.showProxyCredentialsDialog(D,I,t,o);return this.currentDialog===a&&(this.currentDialog=void 0),l})();return a}async showProxyCredentialsDialog(D,I,i,d){if(this.cancelledAuthInfoHashes.has(I)){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const t=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!t){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${t.id} to handle proxy login`);const o=this.sessionCredentials.get(I),r={authInfo:D,username:o?.username??i,password:o?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,w.generateUuid)()}`};t.sendWhenReady("vscode:openProxyAuthenticationDialog",s.CancellationToken.None,r);const a=await new Promise(l=>{const P=async(y,k,T)=>{if(k===r.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${t.id}`),t.win?.webContents.off("ipc-message",P),T){const A={username:T.username,password:T.password};try{if(T.remember){const C=await this.encryptionMainService.encrypt(JSON.stringify(A));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+I,C,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+I,h.StorageScope.APPLICATION)}catch(C){this.logService.error(C)}l({username:A.username,password:A.password})}else this.cancelledAuthInfoHashes.add(I),l(void 0)};t.win?.webContents.on("ipc-message",P)});return this.sessionCredentials.set(I,a),a}};e.ProxyAuthService=S,e.ProxyAuthService=S=Ie([re(0,v.ILogService),re(1,E.IWindowsMainService),re(2,m.IEncryptionMainService),re(3,g.IApplicationStorageMainService),re(4,c.IConfigurationService),re(5,u.IEnvironmentMainService)],S)}),define(ce[262],le([0,1,2,19,52,58,30,8,29]),function(V,e,n,s,b,M,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let c=class extends n.Disposable{constructor(u,f,v){super(),this.userDataProfilesService=f,this.windowsMainService=v,this._register(u.onWillLoadWindow(h=>{h.reason===b.LoadReason.LOAD&&this.unsetProfileForWorkspace(h.window)})),this._register(u.onBeforeCloseWindow(h=>this.unsetProfileForWorkspace(h))),this._register(new R.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(u){const f=this.getWorkspace(u),v=this.userDataProfilesService.getProfileForWorkspace(f);v?.isTransient&&(this.userDataProfilesService.unsetWorkspace(f,v.isTransient),v.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(u){return u.openedWorkspace??(0,L.toWorkspaceIdentifier)(u.backupPath,u.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const u=this.userDataProfilesService.getAssociatedEmptyWindows();if(u.length===0)return;const f=this.windowsMainService.getWindows().map(v=>this.getWorkspace(v));for(const v of u)f.some(h=>h.id===v.id)||this.userDataProfilesService.unsetWorkspace(v,!1)}};e.UserDataProfilesHandler=c,e.UserDataProfilesHandler=c=Ie([re(0,s.ILifecycleMainService),re(1,M.IUserDataProfilesMainService),re(2,w.IWindowsMainService)],c)});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[63],le([0,1,13,2,4,5,282,8,12,29,81,24,19,79,37,3,106,11]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0,m=je(m);function D(d){return typeof d.responseWindowId=="number"}let I=class extends s.Disposable{static{p=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(p.all.values())}constructor(t,o,r){super(),this.logService=t,this.telemetryService=o,this.lifecycleMainService=r,this.id=String(++p.ID_COUNTER),this._onStdout=this._register(new b.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new b.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new b.Emitter),this.onMessage=this._onMessage.event,this._onSpawn=this._register(new b.Emitter),this.onSpawn=this._onSpawn.event,this._onExit=this._register(new b.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new b.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0,this.killed=!1}log(t,o){let r;switch(this.configuration?.correlationId?r=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`,o){case m.default.Error:this.logService.error(r);break;case m.default.Warning:this.logService.warn(r);break;case m.default.Info:this.logService.trace(r);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(t){const o=this.doStart(t);return o&&t.payload&&this.postMessage(t.payload)&&this.log("payload sent via postMessage()",m.default.Info),o}doStart(t){if(!this.validateCanStart())return!1;this.configuration=t;const o=`${this.configuration.type}-${this.id}`,r=w.FileAccess.asFileUri("bootstrap-fork.js").fsPath,a=this.configuration.args??[],l=this.configuration.execArgv??[],P=this.configuration.allowLoadingUnsignedLibraries,y=this.configuration.forceAllocationsToV8Sandbox,k=this.configuration.respondToAuthRequestsFromMainProcess,T="pipe",A=this.createEnv(t);return this.log("creating new...",m.default.Info),this.process=n.utilityProcess.fork(r,a,(0,S.upcast)({serviceName:o,env:A,execArgv:l,allowLoadingUnsignedLibraries:P,forceAllocationsToV8Sandbox:y,respondToAuthRequestsFromMainProcess:k,stdio:T})),this.registerListeners(this.process,this.configuration,o),!0}createEnv(t){const o=t.env?{...t.env}:{...(0,h.deepClone)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,g.isWindows&&((0,E.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,E.getUNCHostAllowlist)().join("\\")),(0,v.removeDangerousEnvVariables)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}registerListeners(t,o,r){if(t.stdout){const a=new L.StringDecoder("utf-8");this._register(b.Event.fromNodeEventEmitter(t.stdout,"data")(l=>this._onStdout.fire(typeof l=="string"?l:a.write(l))))}if(t.stderr){const a=new L.StringDecoder("utf-8");this._register(b.Event.fromNodeEventEmitter(t.stderr,"data")(l=>this._onStderr.fire(typeof l=="string"?l:a.write(l))))}this._register(b.Event.fromNodeEventEmitter(t,"message")(a=>this._onMessage.fire(a))),this._register(b.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.processPid=t.pid,typeof t.pid=="number"&&p.all.set(t.pid,{pid:t.pid,name:D(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.log("successfully created",m.default.Info),this._onSpawn.fire(t.pid)})),this._register(b.Event.fromNodeEventEmitter(t,"exit")(a=>{const l=this.isNormalExit(a)?0:a;this.log(`received exit event with code ${l}`,m.default.Info),this._onExit.fire({pid:this.processPid,code:l,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(b.Event.fromNodeEventEmitter(n.app,"child-process-gone",(a,l)=>({event:a,details:l}))(({details:a})=>{a.type==="Utility"&&a.name===r&&!this.isNormalExit(a.exitCode)&&(this.log(`crashed with code ${a.exitCode} and reason '${a.reason}'`,m.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:o.type,reason:a.reason,code:a.exitCode}),this._onCrash.fire({pid:this.processPid,code:a.exitCode,reason:a.reason}),this.onDidExitOrCrashOrKill())}))}once(t,o){const r=this._register(this._onMessage.event(a=>{a===t&&(r.dispose(),o())}))}postMessage(t,o){return this.process?(this.process.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:r}=new n.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",m.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",m.default.Info),this.process.kill()?(this.log("successfully killed the process",m.default.Info),this.killed=!0,this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",m.default.Warning)}isNormalExit(t){return t===0?!0:this.killed&&t===15}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&p.all.delete(this.processPid),this.process=void 0}async waitForExit(t){this.process&&(this.log("waiting to exit...",m.default.Info),await Promise.race([b.Event.toPromise(this.onExit),(0,R.timeout)(t)]),this.process&&(this.log(`did not exit within ${t}ms, will kill it now...`,m.default.Info),this.kill()))}};e.UtilityProcess=I,e.UtilityProcess=I=p=Ie([re(0,M.ILogService),re(1,u.ITelemetryService),re(2,f.ILifecycleMainService)],I);let i=class extends I{constructor(t,o,r,a){super(t,r,a),this.windowsMainService=o}start(t){const o=this.windowsMainService.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.doStart(t))return!1;this.registerWindowListeners(o.win,t);const a=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[a]),!0}registerWindowListeners(t,o){o.windowLifecycleBound&&(this._register(b.Event.filter(this.lifecycleMainService.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this._register(b.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=i,e.WindowUtilityProcess=i=Ie([re(0,M.ILogService),re(1,c.IWindowsMainService),re(2,u.ITelemetryService),re(3,f.ILifecycleMainService)],i)}),define(ce[263],le([0,1,8,15,4,2,19,5,24,63,29]),function(V,e,n,s,b,M,L,R,w,c,m){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let f=class extends M.Disposable{static{u=this}static{this._lastId=0}constructor(h,g,E,S){super(),this._logService=h,this._lifecycleMainService=g,this._windowsMainService=E,this._telemetryService=S,this._extHosts=new Map,this._shutdown=!1,this._register(this._lifecycleMainService.onWillShutdown(p=>{this._shutdown=!0,p.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}_getExtHost(h){const g=this._extHosts.get(h);if(!g)throw new Error("Unknown extension host!");return g}onDynamicStdout(h){return this._getExtHost(h).onStdout}onDynamicStderr(h){return this._getExtHost(h).onStderr}onDynamicMessage(h){return this._getExtHost(h).onMessage}onDynamicExit(h){return this._getExtHost(h).onExit}async createExtensionHost(){if(this._shutdown)throw(0,s.canceled)();const h=String(++u._lastId),g=new c.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);this._extHosts.set(h,g);const E=g.onExit(({pid:S,code:p,signal:D})=>{E.dispose(),this._logService.info(`Extension host with pid ${S} exited with code: ${p}, signal: ${D}.`),setTimeout(()=>{g.dispose(),this._extHosts.delete(h)}),setTimeout(()=>{try{process.kill(S,0),this._logService.error(`Extension host with pid ${S} still exists, forcefully killing it...`),process.kill(S)}catch{}},1e3)});return{id:h}}async start(h,g){if(this._shutdown)throw(0,s.canceled)();const E=this._getExtHost(h);return E.start({...g,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:g.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,respondToAuthRequestsFromMainProcess:!0,correlationId:h}),{pid:await b.Event.toPromise(E.onSpawn)}}async enableInspectPort(h){if(this._shutdown)throw(0,s.canceled)();const g=this._extHosts.get(h);return g?g.enableInspectPort():!1}async kill(h){if(this._shutdown)throw(0,s.canceled)();const g=this._extHosts.get(h);g&&g.kill()}async _killAllNow(){for(const[,h]of this._extHosts)h.kill()}async _waitForAllExit(h){const g=[];for(const[,E]of this._extHosts)g.push(E.waitForExit(h));return n.Promises.settled(g).then(()=>{})}};e.ExtensionHostStarter=f,e.ExtensionHostStarter=f=u=Ie([re(0,R.ILogService),re(1,L.ILifecycleMainService),re(2,m.IWindowsMainService),re(3,w.ITelemetryService)],f)}),define(ce[264],le([0,1,35,8,2,20,19,5,42,40,71,63,57,95,11,216,4]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let S=class extends b.Disposable{constructor(D,I,i,d,t,o,r,a,l){super(),this.machineId=D,this.sqmId=I,this.devDeviceId=i,this.environmentMainService=d,this.userDataProfilesService=t,this.lifecycleMainService=o,this.logService=r,this.loggerMainService=a,this.policyService=l,this.firstWindowConnectionBarrier=new s.Barrier,this.utilityProcess=void 0,this.utilityProcessLogListener=void 0,this._onDidCrash=this._register(new E.Emitter),this.onDidCrash=this._onDidCrash.event,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){n.validatedIpcMain.on(g.SharedProcessChannelConnection.request,(D,I)=>this.onWindowConnection(D,I,g.SharedProcessChannelConnection.response)),n.validatedIpcMain.on(g.SharedProcessRawConnection.request,(D,I)=>this.onWindowConnection(D,I,g.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(D,I,i){this.logService.trace(`[SharedProcess] onWindowConnection for: ${i}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const d=await this.connect(i);if(D.sender.isDestroyed())return d.close();D.sender.postMessage(i,I,[d])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(g.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const D=new s.DeferredPromise;this.utilityProcess?.once(g.SharedProcessLifecycle.initDone,()=>D.complete()),await D.p,this.utilityProcessLogListener?.dispose(),this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const D=new s.DeferredPromise;this.utilityProcess?.once(g.SharedProcessLifecycle.ipcReady,()=>D.complete()),await D.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new u.UtilityProcess(this.logService,f.NullTelemetryService,this.lifecycleMainService)),this.utilityProcessLogListener=this.utilityProcess.onMessage(i=>{typeof i.warning=="string"?this.logService.warn(i.warning):typeof i.error=="string"&&this.logService.error(i.error)});const D=(0,v.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let I;D.port&&(I=["--nolazy"],D.break?I.push(`--inspect-brk=${D.port}`):I.push(`--inspect=${D.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:I}),this._register(this.utilityProcess.onCrash(()=>this._onDidCrash.fire()))}createSharedProcessConfiguration(){return{machineId:this.machineId,sqmId:this.sqmId,devDeviceId:this.devDeviceId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(D){return await this.whenIpcReady,(0,h.assertIsDefined)(this.utilityProcess).connect(D)}};e.SharedProcess=S,e.SharedProcess=S=Ie([re(3,M.IEnvironmentMainService),re(4,w.IUserDataProfilesService),re(5,L.ILifecycleMainService),re(6,R.ILogService),re(7,m.ILoggerMainService),re(8,c.IPolicyService)],S)}),define(ce[265],le([0,1,20,95,19,5,57,75,63,118,35,2,4,37,16,12]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let E=class extends u.Disposable{constructor(p,D,I,i,d){super(),this._reconnectConstants=p,this._configurationService=D,this._environmentMainService=I,this._lifecycleMainService=i,this._logService=d,this.utilityProcess=void 0,this._onRequestConnection=new f.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new f.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._register(this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire())),m.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(t,o)=>this._onWindowConnection(t,o)),this._register((0,u.toDisposable)(()=>{m.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new w.UtilityProcess(this._logService,L.NullTelemetryService,this._lifecycleMainService);const p=(0,s.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),D=p.port?["--nolazy",`--inspect${p.break?"-brk":""}=${p.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:D,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:g.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const I=this.utilityProcess.connect(),i=new c.Client(I,"ptyHost"),d=new u.DisposableStore;return d.add(i),d.add((0,u.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:i,store:d,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const p={...(0,v.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},D=this._configurationService.getValue(R.TerminalSettingId.DeveloperPtyHostLatency);D&&typeof D=="number"&&(p.VSCODE_LATENCY=String(D));const I=this._configurationService.getValue(R.TerminalSettingId.DeveloperPtyHostStartupDelay);return I&&typeof I=="number"&&(p.VSCODE_STARTUP_DELAY=String(I)),this._environmentMainService.restoreSnapExportedVariables(),p}_onWindowConnection(p,D){this._onRequestConnection.fire();const I=this.utilityProcess.connect();if(p.sender.isDestroyed()){I.close();return}p.sender.postMessage("vscode:createPtyHostMessageChannelResult",D,[I])}};e.ElectronPtyHostStarter=E,e.ElectronPtyHostStarter=E=Ie([re(1,h.IConfigurationService),re(2,n.IEnvironmentMainService),re(3,b.ILifecycleMainService),re(4,M.ILogService)],E)}),define(ce[266],le([0,1,2,6,5,29,63,24,46,4,8,19]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,s.createDecorator)("utilityProcessWorker");let f=class extends n.Disposable{constructor(g,E,S,p){super(),this.logService=g,this.windowsMainService=E,this.telemetryService=S,this.lifecycleMainService=p,this.workers=new Map}async createWorker(g){const E=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${E})`);const S=this.hash(g);this.workers.has(S)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${E})`),this.disposeWorker(g));const p=new v(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,g);if(!p.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(S,p);const D=new m.DeferredPromise;return c.Event.once(p.onDidTerminate)(I=>{I.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${I.code}, signal: ${I.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${I.code}, signal: ${I.signal}`),this.workers.delete(S),D.complete({reason:I})}),D.p}hash(g){return(0,w.hash)({moduleId:g.process.moduleId,windowId:g.reply.windowId})}async disposeWorker(g){const E=this.hash(g),S=this.workers.get(E);S&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),S.kill(),S.dispose(),this.workers.delete(E))}};e.UtilityProcessWorkerMainService=f,e.UtilityProcessWorkerMainService=f=Ie([re(0,b.ILogService),re(1,M.IWindowsMainService),re(2,R.ITelemetryService),re(3,u.ILifecycleMainService)],f);let v=class extends n.Disposable{constructor(g,E,S,p,D){super(),this.logService=g,this.windowsMainService=E,this.telemetryService=S,this.lifecycleMainService=p,this.configuration=D,this._onDidTerminate=this._register(new c.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=this._register(new L.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService)),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(g=>this._onDidTerminate.fire({code:g.code,signal:g.signal}))),this._register(this.utilityProcess.onCrash(g=>this._onDidTerminate.fire({code:g.code,signal:"ECRASH"})))}spawn(){const E=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:E,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};v=Ie([re(0,b.ILogService),re(1,M.IWindowsMainService),re(2,R.ITelemetryService),re(3,u.ILifecycleMainService)],v)}),define(ce[267],le([0,1,13,4,2,241,29]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let R=class extends b.Disposable{constructor(c){super(),this.windowsMainService=c,this._onFoundInFrame=this._register(new s.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(c,m){let u;if(typeof c.windowId=="number"){const{windowId:f}=c,v=this.windowsMainService.getWindowById(f);if(!v?.win)throw new Error(`Invalid windowId: ${f}`);u=v.win.webContents}else{const{webContentsId:f}=c;if(u=n.webContents.fromId(f),!u)throw new Error(`Invalid webContentsId: ${f}`)}u.isDestroyed()||u.setIgnoreMenuShortcuts(m)}async findInFrame(c,m,u,f){const h=this.getFrameByName(c,m);if(typeof h.findInFrame=="function"){h.findInFrame(u,{findNext:f.findNext,forward:f.forward});const g=(E,S)=>{S.finalUpdate&&(this._onFoundInFrame.fire(S),h.removeListener("found-in-frame",g))};h.on("found-in-frame",g)}}async stopFindInFrame(c,m,u){const v=this.getFrameByName(c,m);typeof v.stopFindInFrame=="function"&&v.stopFindInFrame(u.keepSelection?"keepSelection":"clearSelection")}getFrameByName(c,m){const u=this.windowsMainService.getWindowById(c.windowId);if(!u?.win)throw new Error(`Invalid windowId: ${c}`);const f=u.win.webContents.mainFrame.framesInSubtree.find(v=>v.name===m);if(!f)throw new Error(`Unknown frame: ${m}`);return f}};e.WebviewMainService=R,e.WebviewMainService=R=Ie([re(0,L.IWindowsMainService)],R)});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[268],le([0,1,13,2,3,18,7,16,19,5,34,29,52,30]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsStateHandler=void 0,e.restoreWindowsState=E,e.getWindowsStateStoreData=p,n=je(n);let g=class extends s.Disposable{static{h=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(i,d,t,o,r){super(),this.windowsMainService=i,this.stateService=d,this.lifecycleMainService=t,this.logService=o,this.configurationService=r,this._state=E(this.stateService.getItem(h.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){n.default.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this._register(this.lifecycleMainService.onBeforeCloseWindow(i=>this.onBeforeCloseWindow(i))),this._register(this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown())),this._register(this.windowsMainService.onDidChangeWindowsCount(i=>{i.newCount-i.oldCount>0&&(this.lastClosedState=void 0)})),this._register(this.windowsMainService.onDidDestroyWindow(i=>this.onBeforeCloseWindow(i)))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const i=new Set,d={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!d.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),r&&(d.lastActiveWindow=this.toWindowState(r),d.lastActiveWindow.uiState.mode===f.WindowMode.Fullscreen&&i.add(d.lastActiveWindow.uiState.display))}const t=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);t&&(d.lastPluginDevelopmentHostWindow=this.toWindowState(t),d.lastPluginDevelopmentHostWindow.uiState.mode===f.WindowMode.Fullscreen&&(i.has(d.lastPluginDevelopmentHostWindow.uiState.display)?b.isMacintosh&&!t.win?.isSimpleFullScreen()&&(d.lastPluginDevelopmentHostWindow.uiState.mode=f.WindowMode.Normal):i.add(d.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(d.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>{const a=this.toWindowState(r);return a.uiState.mode===f.WindowMode.Fullscreen&&(i.has(a.uiState.display)?b.isMacintosh&&a.windowId!==d.lastActiveWindow?.windowId&&!r.win?.isSimpleFullScreen()&&(a.uiState.mode=f.WindowMode.Normal):i.add(a.uiState.display)),a}));const o=p(d);this.stateService.setItem(h.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(i){if(this.lifecycleMainService.quitRequested)return;const d=this.toWindowState(i);i.isExtensionDevelopmentHost&&!i.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=d:!i.isExtensionDevelopmentHost&&i.openedWorkspace&&this._state.openedWindows.forEach(t=>{const o=(0,v.isWorkspaceIdentifier)(i.openedWorkspace)&&t.workspace?.id===i.openedWorkspace.id,r=(0,v.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&t.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(t.folderUri,i.openedWorkspace.uri);(o||r)&&(t.uiState=d.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=d)}toWindowState(i){return{windowId:i.id,workspace:(0,v.isWorkspaceIdentifier)(i.openedWorkspace)?i.openedWorkspace:void 0,folderUri:(0,v.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)?i.openedWorkspace.uri:void 0,backupPath:i.backupPath,remoteAuthority:i.remoteAuthority,uiState:i.serializeWindowState()}}getNewWindowState(i){const d=this.doGetNewWindowState(i),t=this.configurationService.getValue("window");if(d.mode===f.WindowMode.Fullscreen){let o;d.hasDefaultState?o=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||t?.restoreFullscreen),o||(d.mode=f.WindowMode.Normal)}return d}doGetNewWindowState(i){const d=this.windowsMainService.getLastActiveWindow();if(!i.extensionTestsPath){if(i.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const P=i.workspace;if((0,v.isWorkspaceIdentifier)(P)){const k=this.state.openedWindows.filter(T=>T.workspace&&T.workspace.id===P.id).map(T=>T.uiState);if(k.length)return k[0]}if((0,v.isSingleFolderWorkspaceIdentifier)(P)){const k=this.state.openedWindows.filter(T=>T.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(T.folderUri,P.uri)).map(T=>T.uiState);if(k.length)return k[0]}else if(i.backupPath){const k=this.state.openedWindows.filter(T=>T.backupPath===i.backupPath).map(T=>T.uiState);if(k.length)return k[0]}const y=this.lastClosedState||this.state.lastActiveWindow;if(!d&&y)return y.uiState}let t;const o=n.default.screen.getAllDisplays();if(o.length===1)t=o[0];else{if(b.isMacintosh){const P=n.default.screen.getCursorScreenPoint();t=n.default.screen.getDisplayNearestPoint(P)}!t&&d&&(t=n.default.screen.getDisplayMatching(d.getBounds())),t||(t=n.default.screen.getPrimaryDisplay()||o[0])}let r=(0,f.defaultWindowState)();r.x=Math.round(t.bounds.x+t.bounds.width/2-r.width/2),r.y=Math.round(t.bounds.y+t.bounds.height/2-r.height/2);const a=this.configurationService.getValue("window");let l=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")r.mode=f.WindowMode.Maximized,l=!1;else if(a.newWindowDimensions==="fullscreen")r.mode=f.WindowMode.Fullscreen,l=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&d){const P=d.serializeWindowState();P.mode===f.WindowMode.Fullscreen?r.mode=f.WindowMode.Fullscreen:r={...P,zoomLevel:void 0},l=r.mode!==f.WindowMode.Fullscreen&&a.newWindowDimensions==="offset"}}return l&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(i){if(this.windowsMainService.getWindows().length===0)return i;i.x=typeof i.x=="number"?i.x:0,i.y=typeof i.y=="number"?i.y:0;const d=this.windowsMainService.getWindows().map(t=>t.getBounds());for(;d.some(t=>t.x===i.x||t.y===i.y);)i.x+=30,i.y+=30;return i}};e.WindowsStateHandler=g,e.WindowsStateHandler=g=h=Ie([re(0,u.IWindowsMainService),re(1,m.IStateService),re(2,w.ILifecycleMainService),re(3,c.ILogService),re(4,R.IConfigurationService)],g);function E(I){const i={openedWindows:[]},d=I||{openedWindows:[]};return d.lastActiveWindow&&(i.lastActiveWindow=S(d.lastActiveWindow)),d.lastPluginDevelopmentHostWindow&&(i.lastPluginDevelopmentHostWindow=S(d.lastPluginDevelopmentHostWindow)),Array.isArray(d.openedWindows)&&(i.openedWindows=d.openedWindows.map(t=>S(t))),i}function S(I){const i={uiState:I.uiState};return I.backupPath&&(i.backupPath=I.backupPath),I.remoteAuthority&&(i.remoteAuthority=I.remoteAuthority),I.folder&&(i.folderUri=L.URI.parse(I.folder)),I.workspaceIdentifier&&(i.workspace={id:I.workspaceIdentifier.id,configPath:L.URI.parse(I.workspaceIdentifier.configURIPath)}),i}function p(I){return{lastActiveWindow:I.lastActiveWindow&&D(I.lastActiveWindow),lastPluginDevelopmentHostWindow:I.lastPluginDevelopmentHostWindow&&D(I.lastPluginDevelopmentHostWindow),openedWindows:I.openedWindows.map(i=>D(i))}}function D(I){return{workspaceIdentifier:I.workspace&&{id:I.workspace.id,configURIPath:I.workspace.configPath.toString()},folder:I.folderUri&&I.folderUri.toString(),backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.uiState}}});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[59],le([0,1,26,13,4,43,2,12,9,18,23,10,69,53,20,6,5,58,134,30,102,103]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,n=De(n),s=je(s),e.IWorkspacesManagementMainService=(0,g.createDecorator)("workspacesManagementMainService");let d=class extends L.Disposable{constructor(o,r,a,l,P){super(),this.environmentMainService=o,this.logService=r,this.userDataProfilesMainService=a,this.backupMainService=l,this.dialogMainService=P,this._onDidDeleteUntitledWorkspace=this._register(new b.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new b.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const o=(await m.Promises.readdir(this.untitledWorkspacesHome.with({scheme:R.Schemas.file}).fsPath)).map(r=>(0,c.joinPath)(this.untitledWorkspacesHome,r,D.UNTITLED_WORKSPACE_NAME));for(const r of o){const a=(0,i.getWorkspaceIdentifier)(r),l=await this.resolveLocalWorkspace(r);l?this.untitledWorkspaces.push({workspace:a,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(o){o.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${o}).`)}}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,r=>n.promises.readFile(r,"utf8"))}doResolveLocalWorkspace(o,r){if(this.isWorkspacePath(o)&&o.scheme===R.Schemas.file)try{const a=r(o.fsPath);return a instanceof Promise?a.then(l=>this.doResolveWorkspace(o,l),l=>{}):this.doResolveWorkspace(o,a)}catch{return}}isWorkspacePath(o){return(0,D.isUntitledWorkspace)(o,this.environmentMainService)||(0,D.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,r){try{const a=this.doParseStoredWorkspace(o,r),l=(0,i.getWorkspaceIdentifier)(o);return{id:l.id,configPath:l.configPath,folders:(0,I.toWorkspaceFolders)(a.folders,l.configPath,c.extUriBiasedIgnorePathCase),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.logService.warn(a.toString())}}doParseStoredWorkspace(o,r){const a=(0,M.parse)(r);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(l=>(0,I.isStoredWorkspaceFolder)(l));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(o,r){const{workspace:a,storedWorkspace:l}=this.newUntitledWorkspace(o,r),P=a.configPath.fsPath;return await n.promises.mkdir((0,w.dirname)(P),{recursive:!0}),await m.Promises.writeFile(P,JSON.stringify(l,null,"	")),this.untitledWorkspaces.push({workspace:a,remoteAuthority:r}),a}newUntitledWorkspace(o=[],r){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,c.joinPath)(this.untitledWorkspacesHome,a),P=(0,c.joinPath)(l,D.UNTITLED_WORKSPACE_NAME),y=[];for(const k of o)y.push((0,I.getStoredWorkspaceFolder)(k.uri,!0,k.name,l,c.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(P),storedWorkspace:{folders:y,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,i.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,D.isUntitledWorkspace)(o.configPath,this.environmentMainService)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.doDeleteUntitledWorkspace(o),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(o),this._onDidDeleteUntitledWorkspace.fire(o))}async doDeleteUntitledWorkspace(o){const r=(0,c.originalFSPath)(o.configPath);try{await m.Promises.rm((0,w.dirname)(r));const a=(0,w.join)(this.environmentMainService.workspaceStorageHome.with({scheme:R.Schemas.file}).fsPath,o.id);await m.Promises.exists(a)&&await m.Promises.writeFile((0,w.join)(a,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(l=>l.workspace.id!==o.id)}catch(a){this.logService.warn(`Unable to delete untitled workspace ${r} (${a}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(o,r,a){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,r,a))return;const P=await this.doEnterWorkspace(o,(0,i.getWorkspaceIdentifier)(a));if(P)return this._onDidEnterWorkspace.fire({window:o,workspace:P.workspace}),P}async isValidTargetWorkspacePath(o,r,a){return a?(0,D.isWorkspaceIdentifier)(o.openedWorkspace)&&c.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,a)?!1:(0,p.findWindowOnWorkspaceOrFolder)(r,a)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,u.localize)(11018,null)],message:(0,u.localize)(11019,null,(0,c.basename)(a)),detail:(0,u.localize)(11020,null)},s.default.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(o,r){if(!o.config)return;o.focus();let a;return o.config.extensionDevelopmentPath||(o.config.backupPath?a=await this.backupMainService.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):a=this.backupMainService.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,D.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=a,{workspace:r,backupPath:a}}};e.WorkspacesManagementMainService=d,e.WorkspacesManagementMainService=d=Ie([re(0,h.IEnvironmentMainService),re(1,E.ILogService),re(2,S.IUserDataProfilesMainService),re(3,f.IBackupMainService),re(4,v.IDialogMainService)],d)}),define(ce[136],le([0,1,13,35,22,6,29,30,59,11,5,63]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,M.createDecorator)(e.ID);let f=class{constructor(h,g,E){this.windowsMainService=h,this.workspacesManagementMainService=g,this.logService=E}async getRemoteDiagnostics(h){const g=this.windowsMainService.getWindows();return(await Promise.all(g.map(async S=>{const p=S.remoteAuthority;if(!p)return;const D=`vscode:getDiagnosticInfoResponse${S.id}`,I={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.getFolderURIs(S):void 0};return new Promise(i=>{S.sendWhenReady("vscode:getDiagnosticInfo",b.CancellationToken.None,{replyChannel:D,args:I}),s.validatedIpcMain.once(D,(d,t)=>{t||i({hostName:p,errorMessage:`Unable to resolve connection to '${p}'.`}),i(t)}),setTimeout(()=>{i({hostName:p,errorMessage:`Connection to '${p}' could not be established`})},5e3)})}))).filter(S=>!!S)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const h=[];for(const E of n.BrowserWindow.getAllWindows()){const S=this.windowsMainService.getWindowById(E.id);S?h.push(await this.codeWindowToInfo(S)):h.push(this.browserWindowToInfo(E))}const g=[];for(const{pid:E,name:S}of u.UtilityProcess.getAll())g.push({pid:E,name:S});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,pidToNames:g,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async codeWindowToInfo(h){const g=await this.getFolderURIs(h),E=(0,c.assertIsDefined)(h.win);return this.browserWindowToInfo(E,g,h.remoteAuthority)}browserWindowToInfo(h,g=[],E){return{id:h.id,pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:g,remoteAuthority:E}}async getFolderURIs(h){const g=[],E=h.openedWorkspace;if((0,R.isSingleFolderWorkspaceIdentifier)(E))g.push(E.uri);else if((0,R.isWorkspaceIdentifier)(E)){const S=await this.workspacesManagementMainService.resolveLocalWorkspace(E.configPath);S&&S.folders.forEach(D=>{g.push(D.uri)})}return g}};e.DiagnosticsMainService=f,e.DiagnosticsMainService=f=Ie([re(0,L.IWindowsMainService),re(1,w.IWorkspacesManagementMainService),re(2,m.ILogService)],f)}),define(ce[64],le([0,1,26,48,13,27,154,54,4,2,12,9,3,7,112,92,23,113,10,53,20,6,19,5,28,76,29,30,59,17,212,202,84,15,16,135,49]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i,d,t,o,r,a,l,P,y,k,T,A,C,_,H,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,n=De(n),e.INativeHostMainService=(0,i.createDecorator)("nativeHostMainService");let K=class extends c.Disposable{constructor($,X,B,J,U,O,N,Q,oe,j,ue,se){super(),this.windowsMainService=$,this.auxiliaryWindowsMainService=X,this.dialogMainService=B,this.lifecycleMainService=J,this.environmentMainService=U,this.logService=O,this.productService=N,this.themeMainService=Q,this.workspacesManagementMainService=oe,this.configurationService=j,this.requestService=ue,this.proxyAuthService=se,this.onDidOpenMainWindow=w.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidTriggerWindowSystemContextMenu=w.Event.any(w.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:Y,x:W,y:F})=>({windowId:Y.id,x:W,y:F})),w.Event.map(this.auxiliaryWindowsMainService.onDidTriggerSystemContextMenu,({window:Y,x:W,y:F})=>({windowId:Y.id,x:W,y:F}))),this.onDidMaximizeWindow=w.Event.any(w.Event.map(this.windowsMainService.onDidMaximizeWindow,Y=>Y.id),w.Event.map(this.auxiliaryWindowsMainService.onDidMaximizeWindow,Y=>Y.id)),this.onDidUnmaximizeWindow=w.Event.any(w.Event.map(this.windowsMainService.onDidUnmaximizeWindow,Y=>Y.id),w.Event.map(this.auxiliaryWindowsMainService.onDidUnmaximizeWindow,Y=>Y.id)),this.onDidChangeWindowFullScreen=w.Event.any(w.Event.map(this.windowsMainService.onDidChangeFullScreen,Y=>({windowId:Y.window.id,fullscreen:Y.fullscreen})),w.Event.map(this.auxiliaryWindowsMainService.onDidChangeFullScreen,Y=>({windowId:Y.window.id,fullscreen:Y.fullscreen}))),this.onDidBlurMainWindow=w.Event.filter(w.Event.fromNodeEventEmitter(b.app,"browser-window-blur",(Y,W)=>W.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusMainWindow=w.Event.any(w.Event.map(w.Event.filter(w.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),w.Event.filter(w.Event.fromNodeEventEmitter(b.app,"browser-window-focus",(Y,W)=>W.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidBlurMainOrAuxiliaryWindow=w.Event.any(this.onDidBlurMainWindow,w.Event.map(w.Event.filter(w.Event.fromNodeEventEmitter(b.app,"browser-window-blur",(Y,W)=>this.auxiliaryWindowsMainService.getWindowByWebContents(W.webContents)),Y=>!!Y),Y=>Y.id)),this.onDidFocusMainOrAuxiliaryWindow=w.Event.any(this.onDidFocusMainWindow,w.Event.map(w.Event.filter(w.Event.fromNodeEventEmitter(b.app,"browser-window-focus",(Y,W)=>this.auxiliaryWindowsMainService.getWindowByWebContents(W.webContents)),Y=>!!Y),Y=>Y.id)),this.onDidResumeOS=w.Event.fromNodeEventEmitter(b.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new w.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=w.Event.debounce(w.Event.any(w.Event.filter(w.Event.fromNodeEventEmitter(b.screen,"display-metrics-changed",(Y,W,F)=>F),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),w.Event.fromNodeEventEmitter(b.screen,"display-added"),w.Event.fromNodeEventEmitter(b.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows($,X){const B=this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,l.toWorkspaceIdentifier)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()})),J=[];return X.includeAuxiliaryWindows&&J.push(...this.auxiliaryWindowsMainService.getWindows().map(U=>({id:U.id,parentId:U.parentId,title:U.win?.getTitle()??"",filename:U.getRepresentedFilename()}))),[...B,...J]}async getWindowCount($){return this.windowsMainService.getWindowCount()}async getActiveWindowId($){const X=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(X)return X.id}openWindow($,X,B){return Array.isArray(X)?this.doOpenWindow($,X,B):this.doOpenEmptyWindow($,X)}async doOpenWindow($,X,B=Object.create(null)){X.length>0&&await this.windowsMainService.open({context:a.OpenContext.API,contextWindowId:$,urisToOpen:X,cli:this.environmentMainService.args,forceNewWindow:B.forceNewWindow,forceReuseWindow:B.forceReuseWindow,preferNewWindow:B.preferNewWindow,diffMode:B.diffMode,mergeMode:B.mergeMode,addMode:B.addMode,gotoLineMode:B.gotoLineMode,noRecentEntry:B.noRecentEntry,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:B.remoteAuthority||void 0,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async doOpenEmptyWindow($,X){await this.windowsMainService.openEmptyWindow({context:a.OpenContext.API,contextWindowId:$},X)}async isFullScreen($,X){return this.windowById(X?.targetWindowId,$)?.isFullScreen??!1}async toggleFullScreen($,X){this.windowById(X?.targetWindowId,$)?.toggleFullScreen()}async handleTitleDoubleClick($,X){this.windowById(X?.targetWindowId,$)?.handleTitleDoubleClick()}async getCursorScreenPoint($){const X=b.screen.getCursorScreenPoint(),B=b.screen.getDisplayNearestPoint(X);return{point:X,display:B.bounds}}async isMaximized($,X){return this.windowById(X?.targetWindowId,$)?.win?.isMaximized()??!1}async maximizeWindow($,X){this.windowById(X?.targetWindowId,$)?.win?.maximize()}async unmaximizeWindow($,X){this.windowById(X?.targetWindowId,$)?.win?.unmaximize()}async minimizeWindow($,X){this.windowById(X?.targetWindowId,$)?.win?.minimize()}async moveWindowTop($,X){this.windowById(X?.targetWindowId,$)?.win?.moveTop()}async positionWindow($,X,B){const J=this.windowById(B?.targetWindowId,$);if(J?.win){if(J.win.isFullScreen()){const U=w.Event.toPromise(w.Event.once(w.Event.fromNodeEventEmitter(J.win,"leave-full-screen")));J.win.setFullScreen(!1),await U}J.win.setBounds(X)}}async updateWindowControls($,X){this.windowById(X?.targetWindowId,$)?.updateWindowControls(X)}async focusWindow($,X){this.windowById(X?.targetWindowId,$)?.focus({force:X?.force??!1})}async setMinimumSize($,X,B){const J=this.codeWindowById($);if(J?.win){const[U,O]=J.win.getSize(),[N,Q]=J.win.getMinimumSize(),[oe,j]=[X??N,B??Q],[ue,se]=[Math.max(U,oe),Math.max(O,j)];(N!==oe||Q!==j)&&J.win.setMinimumSize(oe,j),(U!==ue||O!==se)&&J.win.setSize(ue,se)}}async saveWindowSplash($,X){this.themeMainService.saveWindowSplash($,X)}async installShellCommand($){const{source:X,target:B}=await this.getShellCommandLink();try{const{symbolicLink:J}=await E.SymlinkSupport.stat(X);if(J&&!J.dangling){const U=await(0,h.realpath)(X);if(B===U)return}await n.promises.unlink(X)}catch(J){if(J.code!=="ENOENT")throw J}try{await n.promises.symlink(B,X)}catch(J){if(J.code!=="EACCES"&&J.code!=="ENOENT")throw J;const{response:U}=await this.showMessageBox($,{type:"info",message:(0,p.localize)(11271,null,this.productService.nameShort),buttons:[(0,p.localize)(11272,null),(0,p.localize)(11273,null)]});if(U===1)throw new C.CancellationError;try{const O=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${B}' '${X}'\\" with administrator privileges"`;await(0,L.promisify)(s.exec)(O)}catch{throw new Error((0,p.localize)(11274,null,X))}}}async uninstallShellCommand($){const{source:X}=await this.getShellCommandLink();try{await n.promises.unlink(X)}catch(B){switch(B.code){case"EACCES":{const{response:J}=await this.showMessageBox($,{type:"info",message:(0,p.localize)(11275,null,this.productService.nameShort),buttons:[(0,p.localize)(11276,null),(0,p.localize)(11277,null)]});if(J===1)throw new C.CancellationError;try{const U=`osascript -e "do shell script \\"rm '${X}'\\" with administrator privileges"`;await(0,L.promisify)(s.exec)(U)}catch{throw new Error((0,p.localize)(11278,null,X))}break}case"ENOENT":break;default:throw B}}}async getShellCommandLink(){const $=(0,u.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),X=`/usr/local/bin/${this.productService.applicationName}`;if(!await E.Promises.exists($))throw new Error((0,p.localize)(11279,null,$));return{source:X,target:$}}async showMessageBox($,X){const B=this.windowById(X?.targetWindowId,$);return this.dialogMainService.showMessageBox(X,B?.win??void 0)}async showSaveDialog($,X){const B=this.windowById(X?.targetWindowId,$);return this.dialogMainService.showSaveDialog(X,B?.win??void 0)}async showOpenDialog($,X){const B=this.windowById(X?.targetWindowId,$);return this.dialogMainService.showOpenDialog(X,B?.win??void 0)}async pickFileFolderAndOpen($,X){const B=await this.dialogMainService.pickFileFolder(X);B&&await this.doOpenPicked(await Promise.all(B.map(async J=>await E.SymlinkSupport.existsDirectory(J)?{folderUri:v.URI.file(J)}:{fileUri:v.URI.file(J)})),X,$)}async pickFolderAndOpen($,X){const B=await this.dialogMainService.pickFolder(X);B&&await this.doOpenPicked(B.map(J=>({folderUri:v.URI.file(J)})),X,$)}async pickFileAndOpen($,X){const B=await this.dialogMainService.pickFile(X);B&&await this.doOpenPicked(B.map(J=>({fileUri:v.URI.file(J)})),X,$)}async pickWorkspaceAndOpen($,X){const B=await this.dialogMainService.pickWorkspace(X);B&&await this.doOpenPicked(B.map(J=>({workspaceUri:v.URI.file(J)})),X,$)}async doOpenPicked($,X,B){await this.windowsMainService.open({context:a.OpenContext.DIALOG,contextWindowId:B,cli:this.environmentMainService.args,urisToOpen:$,forceNewWindow:X.forceNewWindow})}async showItemInFolder($,X){b.shell.showItemInFolder(X)}async setRepresentedFilename($,X,B){this.windowById(B?.targetWindowId,$)?.setRepresentedFilename(X)}async setDocumentEdited($,X,B){this.windowById(B?.targetWindowId,$)?.setDocumentEdited(X)}async openExternal($,X,B){this.environmentMainService.unsetSnapExportedVariables();try{(0,m.matchesSomeScheme)(X,m.Schemas.http,m.Schemas.https)?this.openExternalBrowser(X,B):b.shell.openExternal(X)}finally{this.environmentMainService.restoreSnapExportedVariables()}return!0}async openExternalBrowser($,X){const B=X??this.configurationService.getValue("workbench.externalBrowser");if(!B)return b.shell.openExternal($);if((B.includes(u.posix.sep)||B.includes(u.win32.sep))&&!await E.Promises.exists(B))return this.logService.error(`Configured external browser path does not exist: ${B}`),b.shell.openExternal($);try{const{default:J}=await new Promise((U,O)=>{V(["open"],U,O)}).then(De);await J($,{app:{name:Object.hasOwn(J.apps,B)?J.apps[B]:B}})}catch(J){return this.logService.error(`Unable to open external URL '${$}' using browser '${B}' due to ${J}.`),b.shell.openExternal($)}}moveItemToTrash($,X){return b.shell.trashItem(X)}async isAdmin(){let $;return f.isWindows?$=(await new Promise((X,B)=>{V(["native-is-elevated"],X,B)}).then(De)).default():$=process.getuid?.()===0,$}async writeElevated($,X,B,J){const U=await new Promise((O,N)=>{V(["@vscode/sudo-prompt"],O,N)}).then(De);return new Promise((O,N)=>{const Q=[`"${this.cliPath}"`];J?.unlock&&Q.push("--file-chmod"),Q.push("--file-write",`"${X.fsPath}"`,`"${B.fsPath}"`);const oe={name:this.productService.nameLong.replace("-",""),icns:f.isMacintosh&&this.environmentMainService.isBuilt?(0,u.join)((0,u.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};U.exec(Q.join(" "),oe,(j,ue,se)=>{ue&&this.logService.trace(`[sudo-prompt] received stdout: ${ue}`),se&&this.logService.trace(`[sudo-prompt] received stderr: ${se}`),j?N(j):O(void 0)})})}async isRunningUnderARM64Translation(){return f.isLinux||f.isWindows?!1:b.app.runningUnderARM64Translation}get cliPath(){return f.isWindows?this.environmentMainService.isBuilt?(0,u.join)((0,u.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,u.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):f.isLinux?this.environmentMainService.isBuilt?(0,u.join)((0,u.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,u.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,u.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,u.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,M.totalmem)(),freemem:(0,M.freemem)(),loadavg:(0,M.loadavg)()}}async getOSProperties(){return{arch:(0,M.arch)(),platform:(0,M.platform)(),release:(0,M.release)(),type:(0,M.type)(),cpus:(0,M.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return f.isWindows&&(0,k.hasWSLFeatureInstalled)()}async getProcessId($){return this.windowById(void 0,$)?.win?.webContents.getOSProcessId()}async killProcess($,X,B){process.kill(X,B)}async readClipboardText($,X){return b.clipboard.readText(X)}async writeClipboardText($,X,B){return b.clipboard.writeText(X,B)}async readClipboardFindText($){return b.clipboard.readFindText()}async writeClipboardFindText($,X){return b.clipboard.writeFindText(X)}async writeClipboardBuffer($,X,B,J){return b.clipboard.writeBuffer(X,Buffer.from(B.buffer),J)}async readClipboardBuffer($,X){return y.VSBuffer.wrap(b.clipboard.readBuffer(X))}async hasClipboard($,X,B){return b.clipboard.has(X,B)}async newWindowTab(){await this.windowsMainService.open({context:a.OpenContext.API,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){b.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){b.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){b.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){b.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){b.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar($,X){this.codeWindowById($)?.updateTouchBar(X)}async notifyReady($){this.codeWindowById($)?.setReady()}async relaunch($,X){return this.lifecycleMainService.relaunch(X)}async reload($,X){const B=this.codeWindowById($);if(B){if((0,l.isWorkspaceIdentifier)(B.openedWorkspace)){const J=B.openedWorkspace.configPath;if(J.scheme===m.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(J))?.transient)return this.openWindow(B.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(B,X?.disableExtensions!==void 0?{_:[],"disable-extensions":X.disableExtensions}:void 0)}}async closeWindow($,X){return this.windowById(X?.targetWindowId,$)?.win?.close()}async quit($){const X=this.windowsMainService.getLastActiveWindow();X?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&X.win?X.win.close():this.lifecycleMainService.quit()}async exit($,X){await this.lifecycleMainService.kill(X)}async resolveProxy($,X){if(this.environmentMainService.extensionTestsLocationURI){const U=this.configurationService.getValue("integration-test.http.proxy");if(U)return U}return this.codeWindowById($)?.win?.webContents?.session?.resolveProxy(X)}async lookupAuthorization($,X){return this.proxyAuthService.lookupAuthorization(X)}async lookupKerberosAuthorization($,X){return this.requestService.lookupKerberosAuthorization(X)}async loadCertificates($){return this.requestService.loadCertificates()}findFreePort($,X,B,J,U=1){return(0,S.findFreePort)(X,B,J,U)}async openDevTools($,X){this.windowById(X?.targetWindowId,$)?.win?.webContents.openDevTools(X?.mode?{mode:X.mode,activate:X.activate}:void 0)}async toggleDevTools($,X){this.windowById(X?.targetWindowId,$)?.win?.webContents.toggleDevTools()}async profileRenderer($,X,B){const J=this.codeWindowById($);if(!J||!J.win)throw new Error;return await new T.WindowProfiler(J.win,X,this.logService).inspect(B)}async windowsGetStringRegKey($,X,B,J){if(!f.isWindows)return;const U=await new Promise((O,N)=>{V(["@vscode/windows-registry"],O,N)}).then(De);try{return U.GetStringRegKey(X,B,J)}catch{return}}windowById($,X){return this.codeWindowById($)??this.auxiliaryWindowById($)??this.codeWindowById(X)}codeWindowById($){if(typeof $=="number")return this.windowsMainService.getWindowById($)}auxiliaryWindowById($){if(typeof $!="number")return;const X=b.webContents.fromId($);if(X)return this.auxiliaryWindowsMainService.getWindowByWebContents(X)}};e.NativeHostMainService=K,Ie([R.memoize],K.prototype,"cliPath",null),e.NativeHostMainService=K=Ie([re(0,a.IWindowsMainService),re(1,A.IAuxiliaryWindowsMainService),re(2,D.IDialogMainService),re(3,d.ILifecycleMainService),re(4,I.IEnvironmentMainService),re(5,t.ILogService),re(6,o.IProductService),re(7,r.IThemeMainService),re(8,P.IWorkspacesManagementMainService),re(9,_.IConfigurationService),re(10,q.IRequestService),re(11,H.IProxyAuthService)],K)});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[269],le([0,1,13,27,8,22,2,12,3,35,10,53,20,5,64,72,73,51,29]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0,g=je(g);let I=class{static{D=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(d,t,o,r,a,l,P){this.userEnv=d,this.environmentMainService=t,this.logService=o,this.dialogMainService=r,this.nativeHostMainService=a,this.protocolMainService=l,this.windowsMainService=P,this.issueReporterWindow=null,this.issueReporterParentWindow=null}async openReporter(d){if(this.issueReporterWindow)this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow);else if(this.issueReporterParentWindow=n.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow){const t=new L.DisposableStore,o=t.add(this.protocolMainService.createIPCObjectUrl()),r=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(r,o,{backgroundColor:d.styles.backgroundColor,title:(0,m.localize)(11368,null),zoomLevel:d.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:d,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:g.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.issueReporterWindow.loadURL(R.FileAccess.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,t.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,t.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(d){this.logService.error(d)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:d}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,m.localize)(11369,null),buttons:[(0,m.localize)(11370,null),(0,m.localize)(11371,null)]},this.issueReporterWindow);d===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:d}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,m.localize)(11372,null),buttons:[(0,m.localize)(11373,null),(0,m.localize)(11374,null)]},this.issueReporterWindow);return d===0}return!1}issueReporterWindowCheck(){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const d=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!d)throw new Error("Window not found");return d}async $sendReporterMenu(d,t){const o=this.issueReporterWindowCheck(),r="vscode:triggerReporterMenu",a=new M.CancellationTokenSource;return o.sendWhenReady(r,a.token,{replyChannel:r,extensionId:d,extensionName:t}),await(0,b.raceTimeout)(new Promise(P=>c.validatedIpcMain.once(`vscode:triggerReporterMenuResponse:${d}`,(y,k)=>P(k))),5e3,()=>{this.logService.error(`Error: Extension ${d} timed out waiting for menu response`),a.cancel()})}async $closeReporter(){this.issueReporterWindow?.close()}focusWindow(d){d.isMinimized()&&d.restore(),d.focus()}createBrowserWindow(d,t,o,r){const a=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:d.width,height:d.height,minWidth:300,minHeight:200,x:d.x,y:d.y,title:o.title,backgroundColor:o.backgroundColor||D.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:R.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,S.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return a.setMenuBarVisibility(!1),a}getWindowPosition(d,t,o){let r;const a=n.screen.getAllDisplays();if(a.length===1)r=a[0];else{if(w.isMacintosh){const y=n.screen.getCursorScreenPoint();r=n.screen.getDisplayNearestPoint(y)}!r&&d&&(r=n.screen.getDisplayMatching(d.getBounds())),r||(r=n.screen.getPrimaryDisplay()||a[0])}const l=r.bounds,P={width:t,height:o,x:l.x+l.width/2-t/2,y:l.y+l.height/2-o/2};return l.width>0&&l.height>0&&(P.x<l.x&&(P.x=l.x),P.y<l.y&&(P.y=l.y),P.x>l.x+l.width&&(P.x=l.x),P.y>l.y+l.height&&(P.y=l.y),P.width>l.width&&(P.width=l.width),P.height>l.height&&(P.height=l.height)),P}};e.IssueMainService=I,e.IssueMainService=I=D=Ie([re(1,f.IEnvironmentMainService),re(2,v.ILogService),re(3,u.IDialogMainService),re(4,h.INativeHostMainService),re(5,E.IProtocolMainService),re(6,p.IWindowsMainService)],I)});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[270],le([0,1,13,32,2,12,3,115,35,10,96,136,53,20,5,64,72,28,73,34,63,51]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ProcessMainService=void 0,E=je(E);const t="issue.processExplorerWindowState";let o=class{static{d=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(l,P,y,k,T,A,C,_,H,q){this.userEnv=l,this.environmentMainService=P,this.logService=y,this.diagnosticsService=k,this.diagnosticsMainService=T,this.dialogMainService=A,this.nativeHostMainService=C,this.protocolMainService=_,this.productService=H,this.stateService=q,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.validatedIpcMain.on("vscode:listProcesses",async l=>{const P=[];try{P.push({name:(0,c.localize)(11363,null),rootProcess:await(0,R.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(k=>{(0,m.isRemoteDiagnosticError)(k)?P.push({name:k.hostName,rootProcess:k}):k.processes&&P.push({name:k.hostName,rootProcess:k.processes})})}catch(y){this.logService.error(`Listing processes failed: ${y}`)}this.safeSend(l,"vscode:listProcessesResponse",P)}),w.validatedIpcMain.on("vscode:workbenchCommand",(l,P)=>{const{id:y,from:k,args:T}=P;let A;switch(k){case"processExplorer":A=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${k}`)}A?.webContents.send("vscode:runAction",{id:y,from:k,args:T})}),w.validatedIpcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow?.close()}),w.validatedIpcMain.on("vscode:pidToNameRequest",async l=>{const P=await this.diagnosticsMainService.getMainDiagnostics(),y=[];for(const k of P.windows)y.push([k.pid,`window [${k.id}] (${k.title})`]);for(const{pid:k,name:T}of I.UtilityProcess.getAll())y.push([k,T]);this.safeSend(l,"vscode:pidToNameResponse",y)})}async openProcessExplorer(l){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=n.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const P=new b.DisposableStore,y=P.add(this.protocolMainService.createIPCObjectUrl()),k=this.stateService.getItem(t,void 0),T=r(k)?k:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(T,y,{backgroundColor:l.styles.backgroundColor,title:(0,c.localize)(11364,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),y.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:E.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.processExplorerWindow.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,P.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,P.dispose())});const A=()=>{if(!this.processExplorerWindow)return;const C=this.processExplorerWindow.getSize(),_=this.processExplorerWindow.getPosition();if(!C||!_)return;const H={width:C[0],height:C[1],x:_[0],y:_[1]};this.stateService.setItem(t,H)};this.processExplorerWindow.on("moved",A),this.processExplorerWindow.on("resized",A)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(l){l.isMinimized()&&l.restore(),l.focus()}getWindowPosition(l,P,y){let k;const T=n.screen.getAllDisplays();if(T.length===1)k=T[0];else{if(L.isMacintosh){const _=n.screen.getCursorScreenPoint();k=n.screen.getDisplayNearestPoint(_)}!k&&l&&(k=n.screen.getDisplayMatching(l.getBounds())),k||(k=n.screen.getPrimaryDisplay()||T[0])}const A=k.bounds,C={width:P,height:y,x:A.x+A.width/2-P/2,y:A.y+A.height/2-y/2};return A.width>0&&A.height>0&&(C.x<A.x&&(C.x=A.x),C.y<A.y&&(C.y=A.y),C.x>A.x+A.width&&(C.x=A.x),C.y>A.y+A.height&&(C.y=A.y),C.width>A.width&&(C.width=A.width),C.height>A.height&&(C.height=A.height)),C}async stopTracing(){if(!this.environmentMainService.args.trace)return;const l=await n.contentTracing.stopRecording(`${(0,s.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,c.localize)(11365,null),detail:(0,c.localize)(11366,null,l),buttons:[(0,c.localize)(11367,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,l)}async getSystemStatus(){const[l,P]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,P)}async $getSystemInfo(){const[l,P]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(l,P)}async $getPerformanceInfo(){try{const[l,P]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,P)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}createBrowserWindow(l,P,y,k){const T=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:y.title,backgroundColor:y.backgroundColor||d.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.zoomLevelToZoomFactor)(y.zoomLevel),sandbox:!0},alwaysOnTop:y.alwaysOnTop,experimentalDarkMode:!0});return T.setMenuBarVisibility(!1),T}safeSend(l,P,...y){l.sender.isDestroyed()||l.sender.send(P,...y)}async closeProcessExplorer(){this.processExplorerWindow?.close()}};e.ProcessMainService=o,e.ProcessMainService=o=d=Ie([re(1,v.IEnvironmentMainService),re(2,h.ILogService),re(3,m.IDiagnosticsService),re(4,u.IDiagnosticsMainService),re(5,f.IDialogMainService),re(6,g.INativeHostMainService),re(7,p.IProtocolMainService),re(8,S.IProductService),re(9,D.IStateService)],o);function r(a){return typeof a!="object"||a===null?!1:"x"in a&&"y"in a&&"width"in a&&"height"in a}}),define(ce[271],le([0,1,22,16,20,19,5,64,28,49,24,50,105]),function(V,e,n,s,b,M,L,R,w,c,m,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let v=class extends f.AbstractUpdateService{constructor(g,E,S,p,D,I,i,d){super(g,E,p,D,I,d),this.telemetryService=S,this.nativeHostMainService=i}buildUpdateFeedUrl(g){return(0,f.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){this.url&&(this.setState(u.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},n.CancellationToken.None).then(c.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(u.State.Idle(u.UpdateType.Archive))):this.setState(u.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E);const S=g?E.message||E:void 0;this.setState(u.State.Idle(u.UpdateType.Archive,S))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(u.State.Idle(u.UpdateType.Archive))}};e.LinuxUpdateService=v,e.LinuxUpdateService=v=Ie([re(0,M.ILifecycleMainService),re(1,s.IConfigurationService),re(2,m.ITelemetryService),re(3,b.IEnvironmentMainService),re(4,c.IRequestService),re(5,L.ILogService),re(6,R.INativeHostMainService),re(7,w.IProductService)],v)}),define(ce[272],le([0,1,48,26,27,8,22,54,46,9,7,152,23,16,20,14,19,5,64,28,49,24,50,105]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0,s=De(s),c=De(c),f=De(f);async function o(P,y=1e3){for(;!P();)await(0,M.timeout)(y)}let r;function a(){return typeof r>"u"&&(r=s.existsSync(c.join(c.dirname(process.execPath),"unins000.exe"))?d.UpdateType.Setup:d.UpdateType.Archive),r}let l=class extends t.AbstractUpdateService{get cachePath(){const y=c.join((0,b.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return s.promises.mkdir(y,{recursive:!0}).then(()=>y)}constructor(y,k,T,A,C,_,H,q,K){super(y,k,A,C,_,K),this.telemetryService=T,this.fileService=H,this.nativeHostMainService=q,y.setRelaunchHandler(this)}handleRelaunch(y){return y?.addArgs||y?.removeArgs||this.state.type!==d.StateType.Ready||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(d.State.Disabled(d.DisablementReason.RunningAsAdmin)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(y){let k=`win32-${process.arch}`;return a()===d.UpdateType.Archive?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,t.createUpdateURL)(k,y,this.productService)}doCheckForUpdates(y){this.url&&(this.setState(d.State.CheckingForUpdates(y)),this.requestService.request({url:this.url},L.CancellationToken.None).then(I.asJson).then(k=>{const T=a();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y}),this.setState(d.State.Idle(T)),Promise.resolve(null)):T===d.UpdateType.Archive?(this.setState(d.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(d.State.Downloading),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(A=>f.Promises.exists(A).then(C=>{if(C)return Promise.resolve(A);const _=`${A}.tmp`;return this.requestService.request({url:k.url},L.CancellationToken.None).then(H=>this.fileService.writeFile(m.URI.file(_),H.stream)).then(k.sha256hash?()=>(0,u.checksum)(_,k.sha256hash):()=>{}).then(()=>f.Promises.rename(_,A,!1)).then(()=>A)})).then(A=>{this.availableUpdate={packagePath:A},this.setState(d.State.Downloaded(k)),this.configurationService.getValue("update.enableWindowsBackgroundUpdates")?this.productService.target==="user"&&this.doApplyUpdate():this.setState(d.State.Ready(k))})))}).then(void 0,k=>{this.telemetryService.publicLog2("update:error",{messageHash:String((0,w.hash)(String(k)))}),this.logService.error(k);const T=y?k.message||k:void 0;this.setState(d.State.Idle(a(),T))}))}async doDownloadUpdate(y){y.update.url&&this.nativeHostMainService.openExternal(void 0,y.update.url),this.setState(d.State.Idle(a()))}async getUpdatePackagePath(y){const k=await this.cachePath;return c.join(k,`CodeSetup-${this.productService.quality}-${y}.exe`)}async cleanup(y=null){const k=y?_=>!new RegExp(`${this.productService.quality}-${y}\\.exe$`).test(_):()=>!0,T=await this.cachePath,C=(await f.Promises.readdir(T)).filter(k).map(async _=>{try{await s.promises.unlink(c.join(T,_))}catch{}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!==d.StateType.Downloaded||!this.availableUpdate)return Promise.resolve(void 0);const y=this.state.update;this.setState(d.State.Updating(y));const k=await this.cachePath;this.availableUpdate.updateFilePath=c.join(k,`CodeSetup-${this.productService.quality}-${y.version}.flag`),await f.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,n.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(d.State.Idle(a()))});const A=`${this.productService.win32MutexName}-ready`,C=await new Promise((_,H)=>{V(["@vscode/windows-mutex"],_,H)}).then(De);o(()=>C.isActive(A)).then(()=>this.setState(d.State.Ready(y)))}doQuitAndInstall(){this.state.type!==d.StateType.Ready||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?s.unlinkSync(this.availableUpdate.updateFilePath):(0,n.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return a()}async _applySpecificUpdate(y){if(this.state.type!==d.StateType.Idle)return;const k=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),T={version:"unknown",productVersion:"unknown"};this.setState(d.State.Downloading),this.availableUpdate={packagePath:y},this.setState(d.State.Downloaded(T)),k?this.productService.target==="user"&&this.doApplyUpdate():this.setState(d.State.Ready(T))}};e.Win32UpdateService=l,Ie([R.memoize],l.prototype,"cachePath",null),e.Win32UpdateService=l=Ie([re(0,E.ILifecycleMainService),re(1,v.IConfigurationService),re(2,i.ITelemetryService),re(3,h.IEnvironmentMainService),re(4,I.IRequestService),re(5,S.ILogService),re(6,g.IFileService),re(7,p.INativeHostMainService),re(8,D.IProductService)],l)});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[137],le([0,1,13,8,22,55,4,2,12,70,3,7,10,27,69,16,53,20,68,14,19,5,28,73,248,87,24,110,76,51,29,30,59,52,40,34,58,71,21,6]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i,d,t,o,r,a,l,P,y,k,T,A,C,_,H,q,K,fe,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.BaseWindow=void 0,n=je(n);var X;(function(U){U[U.NONE=0]="NONE",U[U.NAVIGATING=1]="NAVIGATING",U[U.READY=2]="READY"})(X||(X={}));class B extends R.Disposable{get lastFocusTime(){return this._lastFocusTime}get win(){return this._win}setWin(O){this._win=O,this._register(L.Event.fromNodeEventEmitter(O,"maximize")(()=>this._onDidMaximize.fire())),this._register(L.Event.fromNodeEventEmitter(O,"unmaximize")(()=>this._onDidUnmaximize.fire())),this._register(L.Event.fromNodeEventEmitter(O,"closed")(()=>{this._onDidClose.fire(),this.dispose()})),this._register(L.Event.fromNodeEventEmitter(O,"focus")(()=>{this._lastFocusTime=Date.now()})),this._register(L.Event.fromNodeEventEmitter(this._win,"enter-full-screen")(()=>this._onDidEnterFullScreen.fire())),this._register(L.Event.fromNodeEventEmitter(this._win,"leave-full-screen")(()=>this._onDidLeaveFullScreen.fire()));const N=!(0,y.hasNativeTitlebar)(this.configurationService);if(m.isMacintosh&&N&&O.setSheetOffset((0,m.isBigSurOrNewer)((0,v.release)())?28:22),N&&(m.isWindows&&(0,y.useWindowControlsOverlay)(this.configurationService)||m.isMacintosh)){const Q=this.stateService.getItem(B.windowControlHeightStateStorageKey);Q?this.updateWindowControls({height:Q}):this.updateWindowControls({height:y.DEFAULT_CUSTOM_TITLEBAR_HEIGHT})}m.isWindows&&N&&O.hookWindowMessage(278,()=>{const[oe,j]=O.getPosition(),ue=n.default.screen.getCursorScreenPoint(),se=ue.x-oe,Y=ue.y-j;return!(se>30&&Y>=0&&Y<=Math.max(O.getBounds().height*.15,35))||(O.setEnabled(!1),O.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:se,y:Y})),0}),this.environmentMainService.args["open-devtools"]===!0&&O.webContents.openDevTools(),m.isMacintosh&&(this._register(this.onDidEnterFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})),this._register(this.onDidLeaveFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})))}constructor(O,N,Q,oe){super(),this.configurationService=O,this.stateService=N,this.environmentMainService=Q,this.logService=oe,this._onDidClose=this._register(new L.Emitter),this.onDidClose=this._onDidClose.event,this._onDidMaximize=this._register(new L.Emitter),this.onDidMaximize=this._onDidMaximize.event,this._onDidUnmaximize=this._register(new L.Emitter),this.onDidUnmaximize=this._onDidUnmaximize.event,this._onDidTriggerSystemContextMenu=this._register(new L.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidEnterFullScreen=this._register(new L.Emitter),this.onDidEnterFullScreen=this._onDidEnterFullScreen.event,this._onDidLeaveFullScreen=this._register(new L.Emitter),this.onDidLeaveFullScreen=this._onDidLeaveFullScreen.event,this._lastFocusTime=Date.now(),this._win=null,this.hasWindowControlOverlay=(0,y.useWindowControlsOverlay)(this.configurationService),this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0}applyState(O,N=n.default.screen.getAllDisplays().length>0){const Q=this.configurationService.getValue("window"),oe=m.isMacintosh&&Q?.nativeTabs===!0;(m.isMacintosh||m.isWindows)&&N&&(!oe||n.default.BrowserWindow.getAllWindows().length===1)&&[O.width,O.height,O.x,O.y].every(j=>typeof j=="number")&&this._win?.setBounds({width:O.width,height:O.height,x:O.x,y:O.y}),(O.mode===C.WindowMode.Maximized||O.mode===C.WindowMode.Fullscreen)&&(this._win?.maximize(),O.mode===C.WindowMode.Fullscreen&&this.setFullScreen(!0,!0),this._win?.show())}setRepresentedFilename(O){m.isMacintosh?this.win?.setRepresentedFilename(O):this.representedFilename=O}getRepresentedFilename(){return m.isMacintosh?this.win?.getRepresentedFilename():this.representedFilename}setDocumentEdited(O){m.isMacintosh&&this.win?.setDocumentEdited(O),this.documentEdited=O}isDocumentEdited(){return m.isMacintosh?!!this.win?.isDocumentEdited():!!this.documentEdited}focus(O){m.isMacintosh&&O?.force&&n.default.app.focus({steal:!0});const N=this.win;N&&(N.isMinimized()&&N.restore(),N.focus())}handleTitleDoubleClick(){const O=this.win;if(O)if(m.isMacintosh)switch(n.default.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":O.minimize();break;case"None":break;case"Maximize":default:O.isMaximized()?O.unmaximize():O.maximize()}else O.isMaximized()?O.unmaximize():O.maximize()}static{this.windowControlHeightStateStorageKey="windowControlHeight"}updateWindowControls(O){const N=this.win;if(N){if(O.height&&this.stateService.setItem(J.windowControlHeightStateStorageKey,O.height),m.isWindows&&this.hasWindowControlOverlay)N.setTitleBarOverlay({color:O.backgroundColor?.trim()===""?void 0:O.backgroundColor,symbolColor:O.foregroundColor?.trim()===""?void 0:O.foregroundColor,height:O.height?O.height-1:void 0});else if(m.isMacintosh&&O.height!==void 0){const Q=(O.height-15)/2;Q?N.setWindowButtonPosition({x:Q,y:Q}):N.setWindowButtonPosition(null)}}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen,!1)}setFullScreen(O,N){(0,y.useNativeFullScreen)(this.configurationService)?this.setNativeFullScreen(O,N):this.setSimpleFullScreen(O)}get isFullScreen(){if(m.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.transientIsNativeFullScreen;const O=this.win,N=O?.isFullScreen(),Q=O?.isSimpleFullScreen();return!!(N||Q)}setNativeFullScreen(O,N){const Q=this.win;Q?.isSimpleFullScreen()&&Q?.setSimpleFullScreen(!1),this.doSetNativeFullScreen(O,N)}doSetNativeFullScreen(O,N){if(m.isMacintosh){this.transientIsNativeFullScreen=O;const oe=this.joinNativeFullScreenTransition=new s.DeferredPromise;(async()=>{const j=await Promise.race([oe.p,(0,s.timeout)(1e4).then(()=>!1)]);this.joinNativeFullScreenTransition===oe&&(this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,!j&&O&&N&&this.win&&!this.win.isFullScreen()&&(this.logService.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this._onDidLeaveFullScreen.fire()))})()}this.win?.setFullScreen(O)}setSimpleFullScreen(O){const N=this.win;N?.isFullScreen()&&this.doSetNativeFullScreen(!1,!1),N?.setSimpleFullScreen(O),N?.webContents.focus()}dispose(){super.dispose(),this._win=null}}e.BaseWindow=B;let J=class extends B{get id(){return this._id}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const O=this.userDataProfilesService.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&O?O:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,T.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(O,N,Q,oe,j,ue,se,Y,W,F,Z,z,ie,G,x,te,de,me,we,Re,Ne){super(F,Re,oe,N),this.loggerMainService=Q,this.policyService=j,this.userDataProfilesService=ue,this.fileService=se,this.applicationStorageMainService=Y,this.storageMainService=W,this.themeMainService=Z,this.workspacesManagementMainService=z,this.backupMainService=ie,this.telemetryService=G,this.dialogMainService=x,this.lifecycleMainService=te,this.productService=de,this.protocolMainService=me,this.windowsMainService=we,this._onWillLoad=this._register(new L.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new L.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidDestroy=this._register(new L.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.customZoomLevel=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=X.NONE;{const[ke,Ee]=this.restoreWindowState(O.state);this.windowState=ke,this.logService.trace("window#ctor: using window state",ke);const pe=Ne.invokeFunction(k.defaultBrowserWindowOptions,this.windowState,{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this._win=new n.default.BrowserWindow(pe),(0,c.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.setWin(this._win),this.applyState(this.windowState,Ee),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=X.READY;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.whenReadyCallbacks.push(O)})}get isReady(){return this.readyState===X.READY}get whenClosedOrLoaded(){return new Promise(O=>{function N(){Q.dispose(),oe.dispose(),O()}const Q=this.onDidClose(()=>N()),oe=this.onWillLoad(()=>N())})}registerListeners(){this._register(L.Event.fromNodeEventEmitter(this._win,"unresponsive")(()=>this.onWindowError(C.WindowError.UNRESPONSIVE))),this._register(L.Event.fromNodeEventEmitter(this._win.webContents,"render-process-gone",(N,Q)=>Q)(N=>this.onWindowError(C.WindowError.PROCESS_GONE,{...N}))),this._register(L.Event.fromNodeEventEmitter(this._win.webContents,"did-fail-load",(N,Q,oe)=>({exitCode:Q,reason:oe}))(({exitCode:N,reason:Q})=>this.onWindowError(C.WindowError.LOAD,{reason:Q,exitCode:N}))),this._register(L.Event.fromNodeEventEmitter(this._win.webContents,"will-prevent-unload")(N=>N.preventDefault())),this._register(L.Event.fromNodeEventEmitter(this._win.webContents,"did-finish-load")(()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)})),this._register(this.onDidMaximize(()=>{this._config&&(this._config.maximized=!0)})),this._register(this.onDidUnmaximize(()=>{this._config&&(this._config.maximized=!1)})),this._register(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",b.CancellationToken.None)})),this._register(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",b.CancellationToken.None)})),this._register(this.configurationService.onDidChangeConfiguration(N=>this.onConfigurationUpdated(N))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(N=>this.onDidDeleteUntitledWorkspace(N)));const O=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:O},async(N,Q)=>{const oe=await this.getMarketplaceHeaders();Q({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,oe)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,o.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(O,N){switch(O){case C.WindowError.PROCESS_GONE:this.logService.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case C.WindowError.UNRESPONSIVE:this.logService.error("CodeWindow: detected unresponsive");break;case C.WindowError.LOAD:this.logService.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:O,reason:N?.reason,code:N?.exitCode}),O){case C.WindowError.UNRESPONSIVE:case C.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(O===C.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:Q,checkboxChecked:oe}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,f.localize)(11043,null),(0,f.localize)(11044,null),(0,f.localize)(11045,null)],message:(0,f.localize)(11046,null),detail:(0,f.localize)(11047,null),checkboxLabel:this._config?.workspace?(0,f.localize)(11048,null):void 0},this._win);if(Q!==2){const j=Q===0;await this.destroyWindow(j,oe)}}else if(O===C.WindowError.PROCESS_GONE){let Q;N?Q=(0,f.localize)(11050,null,N.reason,N.exitCode??"<unknown>"):Q=(0,f.localize)(11049,null);const{response:oe,checkboxChecked:j}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,f.localize)(11051,null):(0,f.localize)(11052,null),(0,f.localize)(11053,null)],message:Q,detail:this._config?.workspace?(0,f.localize)(11054,null):(0,f.localize)(11055,null),checkboxLabel:this._config?.workspace?(0,f.localize)(11056,null):void 0},this._win),ue=oe===0;await this.destroyWindow(ue,j)}break}}async destroyWindow(O,N){const Q=this._config?.workspace;if(N&&Q)try{const oe=this.storageMainService.workspaceStorage(Q);await oe.init(),oe.delete("memento/workbench.parts.editor"),await oe.close()}catch(oe){this.logService.error(oe)}this._onDidDestroy.fire();try{if(O&&this._config){let oe,j;(0,T.isSingleFolderWorkspaceIdentifier)(Q)?oe={folderUri:Q.uri}:(0,T.isWorkspaceIdentifier)(Q)?oe={workspaceUri:Q.configPath}:j=!0,(0,fe.firstOrDefault)(await this.windowsMainService.open({context:k.OpenContext.API,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:oe?[oe]:void 0,forceEmpty:j,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this._win?.destroy()}}onDidDeleteUntitledWorkspace(O){this._config?.workspace?.id===O.id&&(this._config.workspace=void 0)}onConfigurationUpdated(O){if(!O||O.affectsConfiguration("window.menuBarVisibility")){const N=this.getMenuBarVisibility();N!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=N,this.setMenuBarVisibility(N))}if(!O||O.affectsConfiguration("http.proxy")||O.affectsConfiguration("http.noProxy")){let N=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(N?.indexOf("@")!==-1){const oe=u.URI.parse(N),j=oe.authority.indexOf("@");j!==-1&&(N=oe.with({authority:oe.authority.substring(j+1)}).toString())}N?.endsWith("/")&&(N=N.substr(0,N.length-1));const Q=(this.configurationService.getValue("http.noProxy")||[]).map(oe=>oe.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.currentHttpProxy||Q!==this.currentNoProxy)){this.currentHttpProxy=N,this.currentNoProxy=Q;const oe=N||"",j=Q?`${Q},<local>`:"<local>";this.logService.trace(`Setting proxy to '${oe}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:oe,proxyBypassRules:j,pacScript:""}),n.default.app.setProxy({proxyRules:oe,proxyBypassRules:j,pacScript:""})}}}addTabbedWindow(O){m.isMacintosh&&O.win&&this._win.addTabbedWindow(O.win)}load(O,N=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!N.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(O,N),this.readyState===X.NONE?this._config=O:this.pendingLoadConfig=O,this.readyState=X.NAVIGATING,this._win.loadURL(w.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const Q=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new s.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:O.workspace,reason:N.isReload?C.LoadReason.RELOAD:Q?C.LoadReason.LOAD:C.LoadReason.INITIAL})}updateConfiguration(O,N){const Q=(this._config??this.pendingLoadConfig)?.userEnv;if(Q){const oe=(0,p.isLaunchedFromCli)(Q)&&!(0,p.isLaunchedFromCli)(O.userEnv),j=this.isExtensionDevelopmentHost;(oe||j)&&(O.userEnv={...Q,...O.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(O["disable-extensions"]=N.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this._win.isMaximized(),O.partsSplash=this.themeMainService.getWindowSplash(),O.zoomLevel=this.getZoomLevel(),O.isCustomZoomLevel=typeof this.customZoomLevel=="number",O.isCustomZoomLevel&&O.partsSplash&&(O.partsSplash.zoomLevel=O.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),O.perfMarks=(0,c.getMarks)(),this.configObjectUrl.update(O)}async reload(O){const N=Object.assign({},this._config);N.workspace=await this.validateWorkspaceBeforeReload(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&O&&(N.verbose=O.verbose,N.debugId=O.debugId,N.extensionEnvironment=O.extensionEnvironment,N["inspect-extensions"]=O["inspect-extensions"],N["inspect-brk-extensions"]=O["inspect-brk-extensions"],N["extensions-dir"]=O["extensions-dir"]),N.accessibilitySupport=n.default.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.policyService.serialize(),N.continueOn=this.environmentMainService.continueOn,N.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},N.logLevel=this.loggerMainService.getLogLevel(),N.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:O?.["disable-extensions"]})}async validateWorkspaceBeforeReload(O){if((0,T.isWorkspaceIdentifier)(O.workspace)){const N=O.workspace.configPath;if(N.scheme===w.Schemas.file&&!await this.fileService.exists(N))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(O.workspace)){const N=O.workspace.uri;if(N.scheme===w.Schemas.file&&!await this.fileService.exists(N))return}return O.workspace}serializeWindowState(){if(!this._win)return(0,C.defaultWindowState)();if(this.isFullScreen){let Q;try{Q=n.default.screen.getDisplayMatching(this.getBounds())}catch{}const oe=(0,C.defaultWindowState)();return{mode:C.WindowMode.Fullscreen,display:Q?Q.id:void 0,width:this.windowState.width||oe.width,height:this.windowState.height||oe.height,x:this.windowState.x||0,y:this.windowState.y||0,zoomLevel:this.customZoomLevel}}const O=Object.create(null);let N;if(!m.isMacintosh&&this._win.isMaximized()?N=C.WindowMode.Maximized:N=C.WindowMode.Normal,N===C.WindowMode.Maximized?O.mode=C.WindowMode.Maximized:O.mode=C.WindowMode.Normal,N===C.WindowMode.Normal||N===C.WindowMode.Maximized){let Q;N===C.WindowMode.Normal?Q=this.getBounds():Q=this._win.getNormalBounds(),O.x=Q.x,O.y=Q.y,O.width=Q.width,O.height=Q.height}return O.zoomLevel=this.customZoomLevel,O}restoreWindowState(O){(0,c.mark)("code/willRestoreCodeWindowState");let N=!1;if(O){this.customZoomLevel=O.zoomLevel;try{const Q=n.default.screen.getAllDisplays();N=Q.length>1,O=k.WindowStateValidator.validateWindowState(this.logService,O,Q)}catch(Q){this.logService.warn(`Unexpected error validating window state: ${Q}
${Q.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[O||(0,C.defaultWindowState)(),N]}getBounds(){const[O,N]=this._win.getPosition(),[Q,oe]=this._win.getSize();return{x:O,y:N,width:Q,height:oe}}setFullScreen(O,N){super.setFullScreen(O,N),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",b.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}getMenuBarVisibility(){let O=(0,y.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}setMenuBarVisibility(O,N=!0){m.isMacintosh||(O==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,f.localize)(11057,null)),O==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(O)}):this.doSetMenuBarVisibility(O))}doSetMenuBarVisibility(O){const N=this.isFullScreen;switch(O){case"classic":this._win.setMenuBarVisibility(!N),this._win.autoHideMenuBar=N;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}notifyZoomLevel(O){this.customZoomLevel=O}getZoomLevel(){return typeof this.customZoomLevel=="number"?this.customZoomLevel:this.configurationService.getValue("window")?.zoomLevel}close(){this._win?.close()}sendWhenReady(O,N,...Q){this.isReady?this.send(O,...Q):this.ready().then(()=>{N.isCancellationRequested||this.send(O,...Q)})}send(O,...N){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${O}' for window that is destroyed`);return}try{this._win.webContents.send(O,...N)}catch(Q){this.logService.warn(`Error sending IPC message to channel '${O}' of window ${this._id}: ${(0,M.toErrorMessage)(Q)}`)}}}updateTouchBar(O){m.isMacintosh&&this.touchBarGroups.forEach((N,Q)=>{const oe=O[Q];N.segments=this.createTouchBarGroupSegments(oe)})}createTouchBar(){if(m.isMacintosh){for(let O=0;O<10;O++){const N=this.createTouchBarGroup();this.touchBarGroups.push(N)}this._win.setTouchBar(new n.default.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(O=[]){const N=this.createTouchBarGroupSegments(O),Q=new n.default.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:oe=>{this.sendWhenReady("vscode:runAction",b.CancellationToken.None,{id:Q.segments[oe].id,from:"touchbar"})}});return Q}createTouchBarGroupSegments(O=[]){return O.map(Q=>{let oe;Q.icon&&!l.ThemeIcon.isThemeIcon(Q.icon)&&Q.icon?.dark?.scheme===w.Schemas.file&&(oe=n.default.nativeImage.createFromPath(u.URI.revive(Q.icon.dark).fsPath),oe.isEmpty()&&(oe=void 0));let j;return typeof Q.title=="string"?j=Q.title:j=Q.title.value,{id:Q.id,label:oe?void 0:j,icon:oe}})}matches(O){return this._win?.webContents.id===O.id}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id)}};e.CodeWindow=J,e.CodeWindow=J=Ie([re(1,i.ILogService),re(2,K.ILoggerMainService),re(3,S.IEnvironmentMainService),re(4,_.IPolicyService),re(5,q.IUserDataProfilesMainService),re(6,D.IFileService),re(7,r.IApplicationStorageMainService),re(8,r.IStorageMainService),re(9,g.IConfigurationService),re(10,P.IThemeMainService),re(11,A.IWorkspacesManagementMainService),re(12,h.IBackupMainService),re(13,a.ITelemetryService),re(14,E.IDialogMainService),re(15,I.ILifecycleMainService),re(16,d.IProductService),re(17,t.IProtocolMainService),re(18,k.IWindowsMainService),re(19,H.IStateService),re(20,$.IInstantiationService)],J)}),define(ce[273],le([0,1,13,3,16,20,19,5,34,51,52,137]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let f=class extends u.BaseWindow{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(h,g,E,S,p,D){super(S,p,g,E),this.webContents=h,this.lifecycleMainService=D,this.id=this.webContents.id,this.parentId=-1,this.stateApplied=!1,this.tryClaimWindow()}tryClaimWindow(h){this._store.isDisposed||this.webContents.isDestroyed()||(this.doTryClaimWindow(),h&&!this.stateApplied&&(this.stateApplied=!0,this.applyState({x:h.x,y:h.y,width:h.width,height:h.height,mode:h.show===!1?m.WindowMode.Maximized:m.WindowMode.Normal})))}doTryClaimWindow(){if(this._win)return;const h=n.BrowserWindow.fromWebContents(this.webContents);h&&(this.logService.trace("[aux window] Claimed browser window instance"),this.setWin(h),h.setMenu(null),(s.isWindows||s.isLinux)&&(0,c.hasNativeTitlebar)(this.configurationService)&&h.setAutoHideMenuBar(!0),this.lifecycleMainService.registerAuxWindow(this))}matches(h){return this.webContents.id===h.id}};e.AuxiliaryWindow=f,e.AuxiliaryWindow=f=Ie([re(1,M.IEnvironmentMainService),re(2,R.ILogService),re(3,b.IConfigurationService),re(4,w.IStateService),re(5,L.ILifecycleMainService)],f)}),define(ce[274],le([0,1,13,4,2,12,35,273,6,5,52,29]),function(V,e,n,s,b,M,L,R,w,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindowsMainService=void 0;let f=class extends b.Disposable{constructor(h,g){super(),this.instantiationService=h,this.logService=g,this._onDidMaximizeWindow=this._register(new s.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new s.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new s.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new s.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.registerListeners()}registerListeners(){n.app.on("browser-window-created",(h,g)=>{const E=this.getWindowByWebContents(g.webContents);if(E)this.logService.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),E.tryClaimWindow();else{const S=new b.DisposableStore;S.add(s.Event.fromNodeEventEmitter(g.webContents,"did-create-window",(p,D)=>({browserWindow:p,details:D}))(({browserWindow:p,details:D})=>{const I=this.getWindowByWebContents(p.webContents);I&&(this.logService.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),I.tryClaimWindow(D.options))})),S.add(s.Event.fromNodeEventEmitter(g,"closed")(()=>S.dispose()))}}),L.validatedIpcMain.handle("vscode:registerAuxiliaryWindow",async(h,g)=>{const E=this.getWindowByWebContents(h.sender);return E&&(this.logService.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),E.parentId=g),h.sender.id})}createWindow(h){return this.instantiationService.invokeFunction(u.defaultBrowserWindowOptions,this.validateWindowState(h),{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}validateWindowState(h){const g={},E=h.features.split(",");for(const p of E){const[D,I]=p.split("=");switch(D){case"width":g.width=parseInt(I,10);break;case"height":g.height=parseInt(I,10);break;case"left":g.x=parseInt(I,10);break;case"top":g.y=parseInt(I,10);break;case"window-maximized":g.mode=m.WindowMode.Maximized;break;case"window-fullscreen":g.mode=m.WindowMode.Fullscreen;break;case"titlebar":g.mode=m.WindowMode.Custom;break}}const S=u.WindowStateValidator.validateWindowState(this.logService,g)??(0,m.defaultAuxWindowState)();return this.logService.trace("[aux window] using window state",S),S}registerWindow(h){const g=new b.DisposableStore,E=this.instantiationService.createInstance(R.AuxiliaryWindow,h);this.windows.set(E.id,E),g.add((0,b.toDisposable)(()=>this.windows.delete(E.id))),g.add(E.onDidMaximize(()=>this._onDidMaximizeWindow.fire(E))),g.add(E.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(E))),g.add(E.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:E,fullscreen:!0}))),g.add(E.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:E,fullscreen:!1}))),g.add(E.onDidTriggerSystemContextMenu(({x:S,y:p})=>this._onDidTriggerSystemContextMenu.fire({window:E,x:S,y:p}))),s.Event.once(E.onDidClose)(()=>g.dispose())}getWindowByWebContents(h){const g=this.windows.get(h.id);return g?.matches(h)?g:void 0}getFocusedWindow(){const h=n.BrowserWindow.getFocusedWindow();if(h)return this.getWindowByWebContents(h.webContents)}getLastActiveWindow(){return(0,u.getLastFocused)(Array.from(this.windows.values()))}getWindows(){return Array.from(this.windows.values())}};e.AuxiliaryWindowsMainService=f,e.AuxiliaryWindowsMainService=f=Ie([re(0,w.IInstantiationService),re(1,c.ILogService)],f)}),define(ce[88],le([0,1,13,21,8,4,47,2,12,3,18,7,23,10,6,19,5,62,87,102,30,59,31,53]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i,d,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,h.createDecorator)("workspacesHistoryMainService");let r=class extends R.Disposable{static{o=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(l,P,y,k,T){super(),this.logService=l,this.workspacesManagementMainService=P,this.lifecycleMainService=y,this.applicationStorageMainService=k,this.dialogMainService=T,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new b.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(g.LifecycleMainPhase.Eventually).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){let P=[],y=[];for(const T of l)if((0,D.isRecentWorkspace)(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&!this.containsWorkspace(P,T.workspace)&&P.push(T);else if((0,D.isRecentFolder)(T))this.containsFolder(P,T.folderUri)||P.push(T);else{const A=this.containsFile(y,T.fileUri),C=T.fileUri.scheme===w.Schemas.file&&o.COMMON_FILES_FILTER.indexOf((0,m.basename)(T.fileUri))>=0;!A&&!C&&(y.push(T),c.isWindows&&T.fileUri.scheme===w.Schemas.file&&n.app.addRecentDocument(T.fileUri.fsPath))}const k=await this.mergeEntriesFromStorage({workspaces:P,files:y});P=k.workspaces,y=k.files,P.length>o.MAX_TOTAL_RECENT_ENTRIES&&(P.length=o.MAX_TOTAL_RECENT_ENTRIES),y.length>o.MAX_TOTAL_RECENT_ENTRIES&&(y.length=o.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:P,files:y}),this._onDidChangeRecentlyOpened.fire(),c.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(l){const P=A=>{const C=this.location(A);for(const _ of l)if(m.extUriBiasedIgnorePathCase.isEqual(_,C))return!1;return!0},y=await this.getRecentlyOpened(),k=y.workspaces.filter(P),T=y.files.filter(P);(k.length!==y.workspaces.length||T.length!==y.files.length)&&(await this.saveRecentlyOpened({files:T,workspaces:k}),this._onDidChangeRecentlyOpened.fire(),c.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(l){if(l?.confirm){const{response:P}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,v.localize)(11021,null),(0,v.localize)(11022,null)],message:(0,v.localize)(11023,null),detail:(0,v.localize)(11024,null),cancelId:1});if(P!==0)return}await this.saveRecentlyOpened({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(l){const P=new d.ResourceMap(T=>m.extUriBiasedIgnorePathCase.getComparisonKey(T));if(l?.workspaces)for(const T of l.workspaces)P.set(this.location(T),T);const y=new d.ResourceMap(T=>m.extUriBiasedIgnorePathCase.getComparisonKey(T));if(l?.files)for(const T of l.files)y.set(this.location(T),T);const k=await this.getRecentlyOpenedFromStorage();for(const T of k.workspaces){const A=P.get(this.location(T));A?A.label=A.label??T.label:P.set(this.location(T),T)}for(const T of k.files){const A=y.get(this.location(T));A?A.label=A.label??T.label:y.set(this.location(T),T)}return{workspaces:[...P.values()],files:[...y.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let l;const P=this.applicationStorageMainService.get(o.RECENTLY_OPENED_STORAGE_KEY,S.StorageScope.APPLICATION);if(typeof P=="string")try{l=JSON.parse(P)}catch(y){this.logService.error("Unexpected error parsing opened paths list",y)}return(0,D.restoreRecentlyOpened)(l,this.logService)}async saveRecentlyOpened(l){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(o.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,D.toStoreData)(l)),S.StorageScope.APPLICATION,S.StorageTarget.MACHINE)}location(l){return(0,D.isRecentFolder)(l)?l.folderUri:(0,D.isRecentFile)(l)?l.fileUri:l.workspace.configPath}containsWorkspace(l,P){return!!l.find(y=>(0,D.isRecentWorkspace)(y)&&y.workspace.id===P.id)}containsFolder(l,P){return!!l.find(y=>(0,D.isRecentFolder)(y)&&m.extUriBiasedIgnorePathCase.isEqual(y.folderUri,P))}containsFile(l,P){return!!l.find(y=>m.extUriBiasedIgnorePathCase.isEqual(y.fileUri,P))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async handleWindowsJumpList(){c.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!c.isWindows)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(11025,null),description:(0,v.localize)(11026,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const P=[];for(const T of n.app.getJumpListSettings().removedItems){const A=T.args;if(A){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);C&&P.push(u.URI.parse(C[2]))}}await this.removeRecentlyOpened(P);let y=!1;const k=(0,s.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,o.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(T=>{const A=(0,D.isRecentWorkspace)(T)?T.workspace:T.folderUri,{title:C,description:_}=this.getWindowsJumpListLabel(A,T.label);let H;return u.URI.isUri(A)?H=`--folder-uri "${A.toString()}"`:(y=!0,H=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:_.substr(0,255),program:process.execPath,args:H,iconPath:"explorer.exe",iconIndex:0}}));k.length>0&&l.push({type:"custom",name:y?(0,v.localize)(11027,null):(0,v.localize)(11028,null),items:k})}l.push({type:"recent"});try{const P=n.app.setJumpList(l);P&&P!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${P}`)}catch(P){this.logService.warn("updateWindowsJumpList#setJumpList",P)}}getWindowsJumpListLabel(l,P){if(P)return{title:(0,L.splitRecentLabel)(P).name,description:P};if(u.URI.isUri(l))return{title:(0,m.basename)(l),description:this.renderJumpListPathDescription(l)};if(this.workspacesManagementMainService.isUntitledWorkspace(l))return{title:(0,v.localize)(11029,null),description:""};let y=(0,m.basename)(l.configPath);return y.endsWith(I.WORKSPACE_EXTENSION)&&(y=y.substr(0,y.length-I.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(11030,null,y),description:this.renderJumpListPathDescription(l.configPath)}}renderJumpListPathDescription(l){return l.scheme==="file"?(0,L.normalizeDriveLetter)(l.fsPath):l.toString()}async updateMacOSRecentDocuments(){if(!c.isMacintosh)return;n.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),P=[];let y=0;for(let T=0;T<l.workspaces.length&&y<o.MAX_MACOS_DOCK_RECENT_WORKSPACES;T++){const A=this.location(l.workspaces[T]);if(A.scheme===w.Schemas.file){const C=(0,m.originalFSPath)(A);await f.Promises.exists(C)&&(P.push(C),y++)}}const k=[];for(let T=0;T<l.files.length&&y<o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;T++){const A=this.location(l.files[T]);if(A.scheme===w.Schemas.file){const C=(0,m.originalFSPath)(A);if(o.COMMON_FILES_FILTER.includes((0,m.basename)(A))||P.includes(C))continue;await f.Promises.exists(C)&&(k.push(C),y++)}}k.reverse().forEach(T=>n.app.addRecentDocument(T)),P.reverse().forEach(T=>n.app.addRecentDocument(T))}};e.WorkspacesHistoryMainService=r,e.WorkspacesHistoryMainService=r=o=Ie([re(0,E.ILogService),re(1,i.IWorkspacesManagementMainService),re(2,g.ILifecycleMainService),re(3,p.IApplicationStorageMainService),re(4,t.IDialogMainService)],r)}),define(ce[275],le([0,1,13,8,22,47,3,7,10,84,16,20,19,5,198,64,28,34,24,50,51,29,88,2]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i,d,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0,w=De(w);const r="menu";let a=class extends t.Disposable{static{o=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(y,k,T,A,C,_,H,q,K,fe,$,X){super(),this.updateService=y,this.configurationService=k,this.windowsMainService=T,this.environmentMainService=A,this.telemetryService=C,this.workspacesHistoryMainService=_,this.stateService=H,this.lifecycleMainService=q,this.logService=K,this.nativeHostMainService=fe,this.productService=$,this.auxiliaryWindowsMainService=X,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new s.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new s.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(L.isMacintosh||(0,I.hasNativeTitlebar)(k))&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveMainWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const y=this.stateService.getItem(o.lastKnownMenubarStorageKey);y&&(y.menus&&(this.menubarMenus=y.menus),y.keybindings&&(this.keybindings=y.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,H,q)=>{this.runActionInRenderer({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.windowsMainService.openEmptyWindow({context:i.OpenContext.MENU,contextWindowId:H?.id})},this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,H,q)=>this.windowsMainService.openEmptyWindow({context:i.OpenContext.MENU,contextWindowId:H?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,H,q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(q),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(_,H,q)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(q),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,H,q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(q),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened({confirm:!0});const y=this.productService.youTubeUrl;y&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(y,"openYouTubeUrl"));const k=this.productService.requestFeatureUrl;k&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(k,"openUserVoiceUrl"));const T=this.productService.reportIssueUrl;T&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(T,"openReportIssues"));const A=this.productService.licenseUrl;A&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(L.language){const _=A.indexOf("?")>0?"&":"?";this.openUrl(`${A}${_}lang=${L.language}`,"openLicenseUrl")}else this.openUrl(A,"openLicenseUrl")});const C=this.productService.privacyStatementUrl;C&&A&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(C,"openPrivacyStatement")})}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0)),this._register(this.windowsMainService.onDidChangeWindowsCount(y=>this.onDidChangeWindowsCount(y))),this._register(this.nativeHostMainService.onDidBlurMainWindow(()=>this.onDidChangeWindowFocus())),this._register(this.nativeHostMainService.onDidFocusMainWindow(()=>this.onDidChangeWindowFocus()))}get currentEnableMenuBarMnemonics(){const y=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof y!="boolean"?!0:y}get currentEnableNativeTabs(){if(!L.isMacintosh)return!1;const y=this.configurationService.getValue("window.nativeTabs");return typeof y!="boolean"?!1:y}updateMenu(y,k){this.menubarMenus=y.menus,this.keybindings=y.keybindings,this.stateService.setItem(o.lastKnownMenubarStorageKey,y),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(y){L.isMacintosh&&(y.oldCount===0&&y.newCount>0||y.oldCount>0&&y.newCount===0)&&(this.closedLastWindow=y.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){if(!L.isMacintosh)return;const y=n.BrowserWindow.getFocusedWindow();this.noActiveMainWindow=!y||!!this.auxiliaryWindowsMainService.getWindowByWebContents(y.webContents),this.scheduleUpdateMenu()}install(){const y=n.Menu.getApplicationMenu();if(y&&this.oldMenus.push(y),Object.keys(this.menubarMenus).length===0){this.doSetApplicationMenu(L.isMacintosh?new n.Menu:null);return}const k=new n.Menu;let T;if(L.isMacintosh){const C=new n.Menu;T=new n.MenuItem({label:this.productService.nameShort,submenu:C}),this.setMacApplicationMenu(C),k.append(T)}if(L.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const C=new n.Menu;C.append(new n.MenuItem({label:this.mnemonicLabel(w.localize(11280,null)),click:()=>this.windowsMainService.openEmptyWindow({context:i.OpenContext.DOCK})})),n.app.dock.setMenu(C)}if(this.shouldDrawMenu("File")){const C=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(w.localize(11281,null)),submenu:C});this.setMenuById(C,"File"),k.append(_)}if(this.shouldDrawMenu("Edit")){const C=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(w.localize(11282,null)),submenu:C});this.setMenuById(C,"Edit"),k.append(_)}if(this.shouldDrawMenu("Selection")){const C=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(w.localize(11283,null)),submenu:C});this.setMenuById(C,"Selection"),k.append(_)}if(this.shouldDrawMenu("View")){const C=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(w.localize(11284,null)),submenu:C});this.setMenuById(C,"View"),k.append(_)}if(this.shouldDrawMenu("Go")){const C=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(w.localize(11285,null)),submenu:C});this.setMenuById(C,"Go"),k.append(_)}if(this.shouldDrawMenu("Run")){const C=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(w.localize(11286,null)),submenu:C});this.setMenuById(C,"Run"),k.append(_)}if(this.shouldDrawMenu("Terminal")){const C=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(w.localize(11287,null)),submenu:C});this.setMenuById(C,"Terminal"),k.append(_)}let A;if(this.shouldDrawMenu("Window")){const C=new n.Menu;A=new n.MenuItem({label:this.mnemonicLabel(w.localize(11288,null)),submenu:C,role:"window"}),this.setMacWindowMenu(C)}if(A&&k.append(A),this.shouldDrawMenu("Help")){const C=new n.Menu,_=new n.MenuItem({label:this.mnemonicLabel(w.localize(11289,null)),submenu:C,role:"help"});this.setMenuById(C,"Help"),k.append(_)}k.items&&k.items.length>0?this.doSetApplicationMenu(k):this.doSetApplicationMenu(null),this.menuGC.schedule()}doSetApplicationMenu(y){if(n.Menu.setApplicationMenu(y),y)for(const k of this.auxiliaryWindowsMainService.getWindows())k.win?.setMenu(null)}setMacApplicationMenu(y){const k=this.createMenuItem(w.localize(11290,null,this.productService.nameLong),"workbench.action.showAboutDialog"),T=this.getUpdateMenuItems();let A;if(this.shouldDrawMenu("Preferences")){const X=new n.Menu;this.setMenuById(X,"Preferences"),A=new n.MenuItem({label:this.mnemonicLabel(w.localize(11291,null)),submenu:X})}const C=new n.Menu,_=new n.MenuItem({label:w.localize(11292,null),role:"services",submenu:C}),H=new n.MenuItem({label:w.localize(11293,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),q=new n.MenuItem({label:w.localize(11294,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new n.MenuItem({label:w.localize(11295,null),role:"unhide"}),fe=new n.MenuItem(this.likeAction("workbench.action.quit",{label:w.localize(11296,null,this.productService.nameLong),click:async(X,B,J)=>{const U=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||U?.win?.isMinimized())&&await this.confirmBeforeQuit(J)&&this.nativeHostMainService.quit(void 0)}})),$=[k];$.push(...T),A&&$.push(l(),A),$.push(l(),_,l(),H,q,K,l(),fe),$.forEach(X=>y.append(X))}async confirmBeforeQuit(y){if(this.windowsMainService.getWindowCount()===0)return!0;const k=this.configurationService.getValue("window.confirmBeforeClose");if(k==="always"||k==="keyboardOnly"&&this.isKeyboardEvent(y)){const{response:T}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[w.localize(11297,null),w.localize(11298,null)],message:w.localize(11299,null)});return T===0}return!0}shouldDrawMenu(y){if(!L.isMacintosh&&!(0,I.hasNativeTitlebar)(this.configurationService))return!1;switch(y){case"File":case"Help":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus&&!!this.menubarMenus[y];case"Window":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[y]}}setMenu(y,k){k.forEach(T=>{if((0,h.isMenubarMenuItemSeparator)(T))y.append(l());else if((0,h.isMenubarMenuItemSubmenu)(T)){const A=new n.Menu,C=new n.MenuItem({label:this.mnemonicLabel(T.label),submenu:A});this.setMenu(A,T.submenu.items),y.append(C)}else(0,h.isMenubarMenuItemRecentAction)(T)?y.append(this.createOpenRecentMenuItem(T)):(0,h.isMenubarMenuItemAction)(T)&&(T.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(y),L.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow?this.fallbackMenuHandlers[T.id]?y.append(new n.MenuItem(this.likeAction(T.id,{label:this.mnemonicLabel(T.label),click:this.fallbackMenuHandlers[T.id]}))):y.append(this.createMenuItem(T.label,T.id,!1,T.checked)):y.append(this.createMenuItem(T.label,T.id,T.enabled!==!1,!!T.checked)):y.append(this.createMenuItem(T.label,T.id,T.enabled!==!1,!!T.checked)))})}setMenuById(y,k){this.menubarMenus&&this.menubarMenus[k]&&this.setMenu(y,this.menubarMenus[k].items)}insertCheckForUpdatesItems(y){const k=this.getUpdateMenuItems();k.length&&(k.forEach(T=>y.append(T)),y.append(l()))}createOpenRecentMenuItem(y){const k=R.URI.revive(y.uri),T=y.id,A=T==="openRecentFile"?{fileUri:k}:T==="openRecentWorkspace"?{workspaceUri:k}:{folderUri:k};return new n.MenuItem(this.likeAction(T,{label:y.label,click:async(C,_,H)=>{const q=this.isOptionClick(H);(await this.windowsMainService.open({context:i.OpenContext.MENU,cli:this.environmentMainService.args,urisToOpen:[A],forceNewWindow:q,gotoLineMode:!1,remoteAuthority:y.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([k])}},!1))}isOptionClick(y){return!!(y&&(!L.isMacintosh&&(y.ctrlKey||y.shiftKey)||L.isMacintosh&&(y.metaKey||y.altKey)))}isKeyboardEvent(y){return!!(y.triggeredByAccelerator||y.altKey||y.ctrlKey||y.metaKey||y.shiftKey)}createRoleMenuItem(y,k,T){const A={label:this.mnemonicLabel(y),role:T,enabled:!0};return new n.MenuItem(this.withKeybinding(k,A))}setMacWindowMenu(y){const k=new n.MenuItem({label:w.localize(11300,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),T=new n.MenuItem({label:w.localize(11301,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),A=new n.MenuItem({label:w.localize(11302,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),C=this.createMenuItem(w.localize(11303,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(l()),_.push(this.createMenuItem(w.localize(11304,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(w.localize(11305,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(w.localize(11306,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(w.localize(11307,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(w.localize(11308,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[k,T,l(),C,..._,l(),A].forEach(H=>y.append(H))}getUpdateMenuItems(){switch(this.updateService.state.type){case D.StateType.Idle:return[new n.MenuItem({label:this.mnemonicLabel(w.localize(11309,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case D.StateType.CheckingForUpdates:return[new n.MenuItem({label:w.localize(11310,null),enabled:!1})];case D.StateType.AvailableForDownload:return[new n.MenuItem({label:this.mnemonicLabel(w.localize(11311,null)),click:()=>{this.updateService.downloadUpdate()}})];case D.StateType.Downloading:return[new n.MenuItem({label:w.localize(11312,null),enabled:!1})];case D.StateType.Downloaded:return L.isMacintosh?[]:[new n.MenuItem({label:this.mnemonicLabel(w.localize(11313,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case D.StateType.Updating:return[new n.MenuItem({label:w.localize(11314,null),enabled:!1})];case D.StateType.Ready:return[new n.MenuItem({label:this.mnemonicLabel(w.localize(11315,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(y,k,T,A){const C=this.mnemonicLabel(y),_=typeof k=="function"?k:($,X,B)=>{const J=$?$.userSettingsLabel:null;let U=k;Array.isArray(k)&&(U=this.isOptionClick(B)?k[1]:k[0]),J&&B.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:J}):this.runActionInRenderer({type:"commandId",commandId:U})},H=typeof T=="boolean"?T:this.windowsMainService.getWindowCount()>0,q=typeof A=="boolean"?A:!1,K={label:C,click:_,enabled:H};q&&(K.type="checkbox",K.checked=q);let fe;return typeof k=="string"?fe=k:Array.isArray(k)&&(fe=k[0]),L.isMacintosh&&(fe==="editor.action.clipboardCutAction"?K.role="cut":fe==="editor.action.clipboardCopyAction"?K.role="copy":fe==="editor.action.clipboardPasteAction"&&(K.role="paste"),fe==="undo"?K.click=this.makeContextAwareClickHandler(_,{inDevTools:$=>$.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):fe==="redo"?K.click=this.makeContextAwareClickHandler(_,{inDevTools:$=>$.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):fe==="editor.action.selectAll"&&(K.click=this.makeContextAwareClickHandler(_,{inDevTools:$=>$.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.withKeybinding(fe,K))}makeContextAwareClickHandler(y,k){return(T,A,C)=>{const _=n.BrowserWindow.getFocusedWindow();if(!_)return k.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return k.inDevTools(_.webContents.devToolsWebContents);y(T,A||_,C)}}runActionInRenderer(y){let k=n.BrowserWindow.getFocusedWindow();if(k){const A=this.auxiliaryWindowsMainService.getWindowByWebContents(k.webContents);A&&(k=this.windowsMainService.getWindowById(A.parentId)?.win??null)}if(!k){const A=this.windowsMainService.getLastActiveWindow();A?.win?.isMinimized()&&(k=A.win)}const T=k?this.windowsMainService.getWindowById(k.id):void 0;if(T){if(this.logService.trace("menubar#runActionInRenderer",y),L.isMacintosh&&!this.environmentMainService.isBuilt&&!T.isReady&&(y.type==="commandId"&&y.commandId==="workbench.action.toggleDevTools"||y.type!=="commandId"&&y.userSettingsLabel==="alt+cmd+i"))return!1;if(y.type==="commandId"){const A={id:y.commandId,from:"menu"};T.sendWhenReady("vscode:runAction",b.CancellationToken.None,A)}else{const A={userSettingsLabel:y.userSettingsLabel};T.sendWhenReady("vscode:runKeybinding",b.CancellationToken.None,A)}return!0}else return this.logService.trace("menubar#runActionInRenderer: no active window found",y),!1}withKeybinding(y,k){const T=typeof y=="string"?this.keybindings[y]:void 0;if(T?.label){if(T.isNative!==!1)k.accelerator=T.label,k.userSettingsLabel=T.userSettingsLabel;else if(typeof k.label=="string"){const A=k.label.indexOf("[");A>=0?k.label=`${k.label.substr(0,A)} [${T.label}]`:k.label=`${k.label} [${T.label}]`}}else k.accelerator=void 0;return k}likeAction(y,k,T=!k.accelerator){T&&(k=this.withKeybinding(y,k));const A=k.click;return k.click=(C,_,H)=>{this.reportMenuActionTelemetry(y),A?.(C,_,H)},k}openUrl(y,k){this.nativeHostMainService.openExternal(void 0,y),this.reportMenuActionTelemetry(k)}reportMenuActionTelemetry(y){this.telemetryService.publicLog2("workbenchActionExecuted",{id:y,from:r})}mnemonicLabel(y){return(0,M.mnemonicMenuLabel)(y,!this.currentEnableMenuBarMnemonics)}};e.Menubar=a,e.Menubar=a=o=Ie([re(0,D.IUpdateService),re(1,m.IConfigurationService),re(2,i.IWindowsMainService),re(3,u.IEnvironmentMainService),re(4,p.ITelemetryService),re(5,d.IWorkspacesHistoryMainService),re(6,S.IStateService),re(7,f.ILifecycleMainService),re(8,v.ILogService),re(9,g.INativeHostMainService),re(10,E.IProductService),re(11,c.IAuxiliaryWindowsMainService)],a);function l(){return new n.MenuItem({type:"separator"})}}),define(ce[276],le([0,1,6,19,5,275,2]),function(V,e,n,s,b,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,n.createDecorator)("menubarMainService");let R=class extends L.Disposable{constructor(c,m,u){super(),this.instantiationService=c,this.lifecycleMainService=m,this.logService=u,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(s.LifecycleMainPhase.AfterWindowOpen),this._register(this.instantiationService.createInstance(M.Menubar))}async updateMenubar(c,m){this.logService.trace("menubarService#updateMenubar",c),(await this.menubar).updateMenu(m,c)}};e.MenubarMainService=R,e.MenubarMainService=R=Ie([re(0,n.IInstantiationService),re(1,s.ILifecycleMainService),re(2,b.ILogService)],R)});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[277],le([0,1,26,13,106,27,21,22,39,4,32,47,2,12,9,70,3,36,18,11,7,10,69,16,53,20,14,6,19,5,72,73,74,34,51,137,29,134,268,30,103,88,59,52,76,40,58,71,84]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i,d,t,o,r,a,l,P,y,k,T,A,C,_,H,q,K,fe,$,X,B,J,U,O,N,Q,oe,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0,n=De(n),k=je(k);function ue(W){return(0,$.isWorkspaceIdentifier)(W?.workspace)}function se(W){return(0,$.isSingleFolderWorkspaceIdentifier)(W?.workspace)}let Y=class extends f.Disposable{constructor(F,Z,z,ie,G,x,te,de,me,we,Re,Ne,ke,Ee,pe,ee,ae,he,Se,Me,We){super(),this.machineId=F,this.sqmId=Z,this.devDeviceId=z,this.initialUserEnv=ie,this.logService=G,this.loggerService=x,this.stateService=te,this.policyService=de,this.environmentMainService=me,this.userDataProfilesMainService=we,this.lifecycleMainService=Re,this.backupMainService=Ne,this.configurationService=ke,this.workspacesHistoryMainService=Ee,this.workspacesManagementMainService=pe,this.instantiationService=ee,this.dialogMainService=ae,this.fileService=he,this.protocolMainService=Se,this.themeMainService=Me,this.auxiliaryWindowsMainService=We,this._onDidOpenWindow=this._register(new c.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new c.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new c.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new c.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidMaximizeWindow=this._register(new c.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new c.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new c.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new c.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.windowsStateHandler=this._register(new fe.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(F=>this._onDidSignalReadyWindow.fire(F.window))),this._register(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const Z=new f.DisposableStore;if(Z.add(c.Event.any(F.onDidClose,F.onDidDestroy)(()=>Z.dispose())),F.config.extensionDevelopmentPath)for(const z of F.config.extensionDevelopmentPath)Z.add(this.protocolMainService.addValidFileRoot(z));F.config.extensionTestsPath&&Z.add(this.protocolMainService.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,Z){const z=this.environmentMainService.args,ie=Z?.remoteAuthority||void 0,G=!0,x=Z?.forceReuseWindow,te=!x;return this.open({...F,cli:z,forceEmpty:G,forceNewWindow:te,forceReuseWindow:x,remoteAuthority:ie,forceTempProfile:Z?.forceTempProfile,forceProfile:Z?.forceProfile})}openExistingWindow(F,Z){F.focus(),this.handleWaitMarkerFile(Z,[F])}async open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const Z=[],z=[],ie=[],G=[],x=[];let te,de=0;const me=await this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",me);for(const Ee of me)se(Ee)?F.addMode?Z.push(Ee):z.push(Ee):ue(Ee)?ie.push(Ee):Ee.fileUri?(te||(te={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ee.remoteAuthority}),te.filesToOpenOrCreate.push(Ee)):Ee.backupPath?x.push({backupFolder:(0,h.basename)(Ee.backupPath),remoteAuthority:Ee.remoteAuthority}):de++;F.diffMode&&te&&te.filesToOpenOrCreate.length>=2&&(te.filesToDiff=te.filesToOpenOrCreate.slice(0,2),te.filesToOpenOrCreate=[]),F.mergeMode&&te&&te.filesToOpenOrCreate.length===4&&(te.filesToMerge=te.filesToOpenOrCreate.slice(0,4),te.filesToOpenOrCreate=[],te.filesToDiff=[]),te&&F.waitMarkerFileURI&&(te.filesToWait={paths:(0,L.coalesce)([...te.filesToDiff,te.filesToMerge[3],...te.filesToOpenOrCreate]),waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),ie.push(...G),x.push(...this.backupMainService.getEmptyWindowBackups())):x.length=0;const{windows:we,filesOpenedInWindow:Re}=await this.doOpen(F,ie,z,x,de,te,Z);if(this.logService.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${ie.length}, foldersToOpen: ${z.length}, emptyToRestore: ${x.length}, emptyToOpen: ${de})`),we.length>1)if(Re)Re.focus();else{const Ee=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let pe=!0,ee=!0;if(Ee){const ae=we.filter(he=>this.windowsStateHandler.state.lastActiveWindow&&he.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ae.length&&(ae[0].focus(),pe=!1,ee=!1)}if(pe)for(let ae=we.length-1;ae>=0;ae--){const he=we[ae];if(!(he.openedWorkspace&&G.some(Se=>he.openedWorkspace&&Se.workspace.id===he.openedWorkspace.id)||he.backupPath&&x.some(Se=>he.backupPath&&Se.backupFolder===(0,h.basename)(he.backupPath)))){he.focus(),ee=!1;break}}ee&&we[we.length-1].focus()}const Ne=te&&te.filesToDiff.length>0,ke=te&&te.filesToMerge.length>0;if(!we.some(Ee=>Ee.isExtensionDevelopmentHost)&&!Ne&&!ke&&!F.noRecentEntry){const Ee=[];for(const pe of me)ue(pe)&&!pe.transient?Ee.push({label:pe.label,workspace:pe.workspace,remoteAuthority:pe.remoteAuthority}):se(pe)?Ee.push({label:pe.label,folderUri:pe.workspace.uri,remoteAuthority:pe.remoteAuthority}):pe.fileUri&&Ee.push({label:pe.label,fileUri:pe.fileUri,remoteAuthority:pe.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Ee)}return this.handleWaitMarkerFile(F,we),we}handleWaitMarkerFile(F,Z){const z=F.waitMarkerFileURI;F.context===q.OpenContext.CLI&&z&&Z.length===1&&Z[0]&&(async()=>{await Z[0].whenClosedOrLoaded;try{await this.fileService.del(z)}catch{}})()}async doOpen(F,Z,z,ie,G,x,te){const de=[];let me;function we(ae,he){de.push(ae),he&&(me=ae,x=void 0)}let{openFolderInNewWindow:Re,openFilesInNewWindow:Ne}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&te.length>0){const ae=te[0].remoteAuthority,he=this.getLastActiveWindowForAuthority(ae);he&&we(this.doAddFoldersToExistingWindow(he,te.map(Se=>Se.workspace.uri)))}const ke=z.length+Z.length+ie.length;if(x&&ke===0){const ae=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],he=this.getWindows().filter(Me=>x&&(0,p.isEqualAuthority)(Me.remoteAuthority,x.remoteAuthority));let Se;ae?.fileUri&&!Ne&&((F.context===q.OpenContext.DESKTOP||F.context===q.OpenContext.CLI||F.context===q.OpenContext.DOCK)&&(Se=await(0,K.findWindowOnFile)(he,ae.fileUri,async Me=>Me.configPath.scheme===v.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(Me.configPath):void 0)),Se||(Se=this.doGetLastActiveWindow(he))),Se?(0,$.isWorkspaceIdentifier)(Se.openedWorkspace)?Z.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):(0,$.isSingleFolderWorkspaceIdentifier)(Se.openedWorkspace)?z.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):we(this.doOpenFilesInExistingWindow(F,Se,x),!0):we(await this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile}),!0)}const Ee=(0,L.distinct)(Z,ae=>ae.workspace.id);if(Ee.length>0){const ae=(0,L.coalesce)(Ee.map(he=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),he.workspace.configPath)));if(ae.length>0){const he=ae[0],Se=(0,p.isEqualAuthority)(x?.remoteAuthority,he.remoteAuthority)?x:void 0;we(this.doOpenFilesInExistingWindow(F,he,Se),!!Se),Re=!0}for(const he of Ee){if(ae.some(We=>We.openedWorkspace&&We.openedWorkspace.id===he.workspace.id))continue;const Se=he.remoteAuthority,Me=(0,p.isEqualAuthority)(x?.remoteAuthority,Se)?x:void 0;we(await this.doOpenFolderOrWorkspace(F,he,Re,Me),!!Me),Re=!0}}const pe=(0,L.distinct)(z,ae=>p.extUriBiasedIgnorePathCase.getComparisonKey(ae.workspace.uri));if(pe.length>0){const ae=(0,L.coalesce)(pe.map(he=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),he.workspace.uri)));if(ae.length>0){const he=ae[0],Se=(0,p.isEqualAuthority)(x?.remoteAuthority,he.remoteAuthority)?x:void 0;we(this.doOpenFilesInExistingWindow(F,he,Se),!!Se),Re=!0}for(const he of pe){if(ae.some(We=>(0,$.isSingleFolderWorkspaceIdentifier)(We.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(We.openedWorkspace.uri,he.workspace.uri)))continue;const Se=he.remoteAuthority,Me=(0,p.isEqualAuthority)(x?.remoteAuthority,Se)?x:void 0;we(await this.doOpenFolderOrWorkspace(F,he,Re,Me),!!Me),Re=!0}}const ee=(0,L.distinct)(ie,ae=>ae.backupFolder);if(ee.length>0)for(const ae of ee){const he=ae.remoteAuthority,Se=(0,p.isEqualAuthority)(x?.remoteAuthority,he)?x:void 0;we(await this.doOpenEmpty(F,!0,he,Se,ae),!!Se),Re=!0}if(de.length===0||x){x&&!G&&G++;const ae=x?x.remoteAuthority:F.remoteAuthority;for(let he=0;he<G;he++)we(await this.doOpenEmpty(F,Re,ae,x),!!x),Re=!0}return{windows:(0,L.distinct)(de),filesOpenedInWindow:me}}doOpenFilesInExistingWindow(F,Z,z){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:z}),this.focusMainOrChildWindow(Z);const ie={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToMerge:z?.filesToMerge,filesToWait:z?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return Z.sendWhenReady("vscode:openFiles",R.CancellationToken.None,ie),Z}focusMainOrChildWindow(F){let Z=F;const z=s.BrowserWindow.getFocusedWindow();if(z&&z.id!==F.id){const ie=this.auxiliaryWindowsMainService.getWindowByWebContents(z.webContents);ie&&ie.parentId===F.id&&(Z=ie)}Z.focus()}doAddFoldersToExistingWindow(F,Z){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:Z}),F.focus();const z={foldersToAdd:Z};return F.sendWhenReady("vscode:addFolders",R.CancellationToken.None,z),F}doOpenEmpty(F,Z,z,ie,G){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!G,remoteAuthority:z,filesToOpen:ie,forceNewWindow:Z});let x;return!Z&&typeof F.contextWindowId=="number"&&(x=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:z,forceNewWindow:Z,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:ie,windowToUse:x,emptyWindowBackupInfo:G,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}doOpenFolderOrWorkspace(F,Z,z,ie,G){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:Z,filesToOpen:ie}),!z&&!G&&typeof F.contextWindowId=="number"&&(G=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:Z.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:Z.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:ie,windowToUse:G,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}async getPathsToOpen(F){let Z,z=!1,ie=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(Z=await this.doExtractPathsFromAPI(F),z=!0):F.forceEmpty?Z=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(Z=await this.doExtractPathsFromCLI(F.cli),Z.length===0&&Z.push(Object.create(null)),z=!0):(Z=await this.doGetPathsFromLastSession(),Z.length===0&&Z.push(Object.create(null)),ie=!0),!F.addMode&&z){const G=Z.filter(x=>se(x));if(G.length>1){const x=G[0].remoteAuthority;if(G.every(te=>(0,p.isEqualAuthority)(te.remoteAuthority,x))){const te=await this.workspacesManagementMainService.createUntitledWorkspace(G.map(de=>({uri:de.workspace.uri})));Z.push({workspace:te,remoteAuthority:x}),Z=Z.filter(de=>!se(de))}}}if(F.initialStartup&&!ie&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const G=await this.doGetPathsFromLastSession();Z.unshift(...G.filter(x=>ue(x)||se(x)||x.backupPath))}return Z}async doExtractPathsFromAPI(F){const Z={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority},z=await Promise.all((0,L.coalesce)(F.urisToOpen||[]).map(async ie=>{const G=await this.resolveOpenable(ie,Z);if(G)return G.label=ie.label,G;const x=this.resourceFromOpenable(ie);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,i.localize)(11032,null)],message:x.scheme===v.Schemas.file?(0,i.localize)(11033,null):(0,i.localize)(11034,null),detail:x.scheme===v.Schemas.file?(0,i.localize)(11035,null,(0,u.getPathLabel)(x,{os:E.OS,tildify:this.environmentMainService})):(0,i.localize)(11036,null,x.toString(!0))},s.BrowserWindow.getFocusedWindow()??void 0)}));return(0,L.coalesce)(z)}async doExtractPathsFromCLI(F){const Z=[],z={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:F.diff&&F._.length===2||F.merge&&F._.length===4},ie=F["folder-uri"];if(ie){const te=await Promise.all(ie.map(de=>{const me=this.cliArgToUri(de);if(me)return this.resolveOpenable({folderUri:me},z)}));Z.push(...(0,L.coalesce)(te))}const G=F["file-uri"];if(G){const te=await Promise.all(G.map(de=>{const me=this.cliArgToUri(de);if(me)return this.resolveOpenable((0,$.hasWorkspaceFileExtension)(de)?{workspaceUri:me}:{fileUri:me},z)}));Z.push(...(0,L.coalesce)(te))}const x=await Promise.all(F._.map(te=>z.remoteAuthority?this.doResolveRemotePath(te,z):this.doResolveFilePath(te,z)));return Z.push(...(0,L.coalesce)(x)),Z}cliArgToUri(F){try{const Z=I.URI.parse(F);if(!Z.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return Z.path?Z:Z.with({path:"/"})}catch(Z){this.logService.error(`Invalid URI input string: ${F}, ${Z.message}`)}}async doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const Z=[];F!=="one"&&Z.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&Z.push(this.windowsStateHandler.state.lastActiveWindow);const z=await Promise.all(Z.map(async ie=>{if(ie.workspace){const G=await this.resolveOpenable({workspaceUri:ie.workspace.configPath},{remoteAuthority:ie.remoteAuthority,rejectTransientWorkspaces:!0});if(ue(G))return G}else if(ie.folderUri){const G=await this.resolveOpenable({folderUri:ie.folderUri},{remoteAuthority:ie.remoteAuthority});if(se(G))return G}else if(F!=="folders"&&ie.backupPath)return{backupPath:ie.backupPath,remoteAuthority:ie.remoteAuthority}}));return(0,L.coalesce)(z)}}}getRestoreWindowsSetting(){let F;return this.lifecycleMainService.wasRestarted?F="all":(F=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}async resolveOpenable(F,Z=Object.create(null)){const z=this.resourceFromOpenable(F);return z.scheme===v.Schemas.file?((0,_.isFileToOpen)(F)&&(Z={...Z,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(z.fsPath,Z)):this.doResolveRemoteOpenable(F,Z)}doResolveRemoteOpenable(F,Z){let z=this.resourceFromOpenable(F);const ie=(0,A.getRemoteAuthority)(z)||Z.remoteAuthority;if(z=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(z)),(0,_.isFileToOpen)(F)){if(Z.gotoLineMode){const{path:G,line:x,column:te}=(0,m.parseLineAndColumnAware)(z.path);return{fileUri:z.with({path:G}),options:{selection:x?{startLineNumber:x,startColumn:te||1}:void 0},remoteAuthority:ie}}return{fileUri:z,remoteAuthority:ie}}else if((0,_.isWorkspaceToOpen)(F))return{workspace:(0,X.getWorkspaceIdentifier)(z),remoteAuthority:ie};return{workspace:(0,X.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:ie}}resourceFromOpenable(F){return(0,_.isWorkspaceToOpen)(F)?F.workspaceUri:(0,_.isFolderToOpen)(F)?F.folderUri:F.fileUri}async doResolveFilePath(F,Z,z){let ie,G;Z.gotoLineMode&&({path:F,line:ie,column:G}=(0,m.parseLineAndColumnAware)(F)),F=(0,m.sanitizeFilePath)((0,h.normalize)(F),(0,S.cwd)());try{const x=await n.promises.stat(F);if(x.isFile()){if(!Z.forceOpenWorkspaceAsFile){const te=await this.workspacesManagementMainService.resolveLocalWorkspace(I.URI.file(F));if(te)return te.transient&&Z.rejectTransientWorkspaces?void 0:{workspace:{id:te.id,configPath:te.configPath},type:a.FileType.File,exists:!0,remoteAuthority:te.remoteAuthority,transient:te.transient}}return{fileUri:I.URI.file(F),type:a.FileType.File,exists:!0,options:{selection:ie?{startLineNumber:ie,startColumn:G||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,X.getSingleFolderWorkspaceIdentifier)(I.URI.file(F),x),type:a.FileType.Directory,exists:!0};if(!E.isWindows&&F==="/dev/null")return{fileUri:I.URI.file(F),type:a.FileType.File,exists:!0}}}catch(x){if(x.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!z)return this.onUNCHostNotAllowed(F,Z);const te=I.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([te]),Z.ignoreFileNotFound)return{fileUri:te,type:a.FileType.File,exists:!1}}}async onUNCHostNotAllowed(F,Z){const z=I.URI.file(F),{response:ie,checkboxChecked:G}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,i.localize)(11037,null),(0,i.localize)(11038,null),(0,i.localize)(11039,null)],message:(0,i.localize)(11040,null,z.authority),detail:(0,i.localize)(11041,null,(0,u.getPathLabel)(z,{os:E.OS,tildify:this.environmentMainService})),checkboxLabel:(0,i.localize)(11042,null,z.authority),cancelId:1});if(ie===0){if((0,b.addUNCHostToAllowlist)(z.authority),G){const x={channel:"vscode:configureAllowedUNCHost",args:z.authority};this.sendToFocused(x.channel,x.args),this.sendToOpeningWindow(x.channel,x.args)}return this.doResolveFilePath(F,Z,!0)}if(ie===2)return s.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(F,Z)}doResolveRemotePath(F,Z){const z=F.charCodeAt(0),ie=Z.remoteAuthority;let G,x;Z.gotoLineMode&&({path:F,line:G,column:x}=(0,m.parseLineAndColumnAware)(F)),z!==w.CharCode.Slash&&((0,m.isWindowsDriveLetter)(z)&&F.charCodeAt(F.charCodeAt(1))===w.CharCode.Colon&&(F=(0,m.toSlashes)(F)),F=`/${F}`);const te=I.URI.from({scheme:v.Schemas.vscodeRemote,authority:ie,path:F});if(F.charCodeAt(F.length-1)!==w.CharCode.Slash){if((0,$.hasWorkspaceFileExtension)(F))return Z.forceOpenWorkspaceAsFile?{fileUri:te,options:{selection:G?{startLineNumber:G,startColumn:x||1}:void 0},remoteAuthority:Z.remoteAuthority}:{workspace:(0,X.getWorkspaceIdentifier)(te),remoteAuthority:ie};if(Z.gotoLineMode||h.posix.basename(F).indexOf(".")!==-1)return{fileUri:te,options:{selection:G?{startLineNumber:G,startColumn:x||1}:void 0},remoteAuthority:ie}}return{workspace:(0,X.getSingleFolderWorkspaceIdentifier)(te),remoteAuthority:ie}}shouldOpenNewWindow(F){const Z=this.configurationService.getValue("window"),z=Z?.openFoldersInNewWindow||"default",ie=Z?.openFilesInNewWindow||"off";let G=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(z==="on"||z==="off")&&(G=z==="on");let x=!1;return F.forceNewWindow||F.forceReuseWindow?x=!!F.forceNewWindow&&!F.forceReuseWindow:(E.isMacintosh?F.context===q.OpenContext.DOCK&&(x=!0):F.context!==q.OpenContext.DIALOG&&F.context!==q.OpenContext.MENU&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!F.cli.extensionDevelopmentPath&&(ie==="on"||ie==="off")&&(x=ie==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(F,Z){const z=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(z)return this.lifecycleMainService.reload(z,Z.cli),z.focus(),[z];let ie=Z.cli["folder-uri"]||[],G=Z.cli["file-uri"]||[],x=Z.cli._;if(!x.length&&!ie.length&&!G.length&&!Z.cli.extensionTestsPath){const me=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(I.URI.isUri(we)?we.scheme===v.Schemas.file?x=[we.fsPath]:ie=[we.toString()]:we.configPath.scheme===v.Schemas.file?x=[(0,p.originalFSPath)(we.configPath)]:G=[we.configPath.toString()])}let te=Z.remoteAuthority;for(const me of F)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=I.URI.parse(me),Re=(0,A.getRemoteAuthority)(we);Re&&(te?(0,p.isEqualAuthority)(Re,te)||this.logService.error("more than one extension development path authority"):te=Re)}x=x.filter(me=>{const we=I.URI.file(me);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),we)?!1:(0,p.isEqualAuthority)((0,A.getRemoteAuthority)(we),te)}),ie=ie.filter(me=>{const we=this.cliArgToUri(me);return we&&(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),we)?!1:we?(0,p.isEqualAuthority)((0,A.getRemoteAuthority)(we),te):!1}),G=G.filter(me=>{const we=this.cliArgToUri(me);return we&&(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),we)?!1:we?(0,p.isEqualAuthority)((0,A.getRemoteAuthority)(we),te):!1}),Z.cli._=x,Z.cli["folder-uri"]=ie,Z.cli["file-uri"]=G;const de={context:Z.context,cli:Z.cli,forceNewWindow:!0,forceEmpty:!x.length&&!ie.length&&!G.length,userEnv:Z.userEnv,noRecentEntry:!0,waitMarkerFileURI:Z.waitMarkerFileURI,remoteAuthority:te,forceProfile:Z.forceProfile,forceTempProfile:Z.forceTempProfile};return this.open(de)}async openInBrowserWindow(F){const Z=this.configurationService.getValue("window"),z=this.getLastActiveWindow(),G=(Z?.newWindowProfile?this.userDataProfilesMainService.profiles.find(de=>de.name===Z.newWindowProfile):void 0)??z?.profile??this.userDataProfilesMainService.defaultProfile;let x;!F.forceNewWindow&&!F.forceNewTabbedWindow&&(x=F.windowToUse||z,x&&x.focus());const te={...this.environmentMainService.args,...F.cli,machineId:this.machineId,sqmId:this.sqmId,devDeviceId:this.devDeviceId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,h.join)(this.environmentMainService.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:G},homeDir:this.environmentMainService.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.initialUserEnv,...F.userEnv},nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToMerge:F.filesToOpen?.filesToMerge,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:v.Schemas.file}).fsPath,product:k.default,isInitialStartup:F.initialStartup,perfMarks:(0,g.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},autoDetectHighContrast:Z?.autoDetectHighContrast??!0,autoDetectColorScheme:Z?.autoDetectColorScheme??!1,accessibilitySupport:s.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(x){const de=x.config;!te.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(te.extensionDevelopmentPath=de.extensionDevelopmentPath,te.extensionDevelopmentKind=de.extensionDevelopmentKind,te["enable-proposed-api"]=de["enable-proposed-api"],te.verbose=de.verbose,te["inspect-extensions"]=de["inspect-extensions"],te["inspect-brk-extensions"]=de["inspect-brk-extensions"],te.debugId=de.debugId,te.extensionEnvironment=de.extensionEnvironment,te["extensions-dir"]=de["extensions-dir"],te["disable-extensions"]=de["disable-extensions"]),te.loggers={global:te.loggers.global,window:de?.loggers.window??te.loggers.window}}else{const de=this.windowsStateHandler.getNewWindowState(te);(0,g.mark)("code/willCreateCodeWindow");const me=x=this.instantiationService.createInstance(H.CodeWindow,{state:de,extensionDevelopmentPath:te.extensionDevelopmentPath,isExtensionTestHost:!!te.extensionTestsPath});(0,g.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.windows.set(me.id,me),this._onDidOpenWindow.fire(me),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new f.DisposableStore;we.add(me.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire(me))),we.add(c.Event.once(me.onDidClose)(()=>this.onWindowClosed(me,we))),we.add(c.Event.once(me.onDidDestroy)(()=>this.onWindowDestroyed(me))),we.add(me.onDidMaximize(()=>this._onDidMaximizeWindow.fire(me))),we.add(me.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(me))),we.add(me.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:Ne,y:ke})=>this._onDidTriggerSystemContextMenu.fire({window:me,x:Ne,y:ke})));const Re=(0,D.assertIsDefined)(me.win?.webContents);Re.removeAllListeners("devtools-reload-page"),we.add(c.Event.fromNodeEventEmitter(Re,"devtools-reload-page")(()=>this.lifecycleMainService.reload(me))),this.lifecycleMainService.registerWindow(me)}return te.windowId=x.id,x.isReady?this.lifecycleMainService.unload(x,U.UnloadReason.LOAD).then(async de=>{de||await this.doOpenInBrowserWindow(x,te,F,G)}):await this.doOpenInBrowserWindow(x,te,F,G),x}async doOpenInBrowserWindow(F,Z,z,ie){if(Z.extensionDevelopmentPath||((0,$.isWorkspaceIdentifier)(Z.workspace)?Z.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:Z.workspace,remoteAuthority:Z.remoteAuthority}):(0,$.isSingleFolderWorkspaceIdentifier)(Z.workspace)?Z.backupPath=this.backupMainService.registerFolderBackup({folderUri:Z.workspace.uri,remoteAuthority:Z.remoteAuthority}):Z.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:z.emptyWindowBackupInfo?.backupFolder??(0,X.createEmptyWorkspaceIdentifier)().id,remoteAuthority:Z.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const G=Z.workspace??(0,$.toWorkspaceIdentifier)(Z.backupPath,!1),x=this.resolveProfileForBrowserWindow(z,G,ie),te=x instanceof Promise?await x:x;Z.profiles.profile=te,Z.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(G,te)}F.load(Z)}resolveProfileForBrowserWindow(F,Z,z){return F.forceProfile?this.userDataProfilesMainService.profiles.find(ie=>ie.name===F.forceProfile)??this.userDataProfilesMainService.createNamedProfile(F.forceProfile):F.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(Z)??z}onWindowClosed(F,Z){this.windows.delete(F.id),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),Z.dispose()}onWindowDestroyed(F){this.windows.delete(F.id),this._onDidDestroyWindow.fire(F)}getFocusedWindow(){const F=s.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter(Z=>(0,p.isEqualAuthority)(Z.remoteAuthority,F)))}doGetLastActiveWindow(F){return(0,q.getLastFocused)(F)}sendToFocused(F,...Z){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(F,R.CancellationToken.None,...Z)}sendToOpeningWindow(F,...Z){this._register(c.Event.once(this.onDidSignalReadyWindow)(z=>{z.sendWhenReady(F,R.CancellationToken.None,...Z)}))}sendToAll(F,Z,z){for(const ie of this.getWindows())z&&z.indexOf(ie.id)>=0||ie.sendWhenReady(F,R.CancellationToken.None,Z)}getWindows(){return Array.from(this.windows.values())}getWindowCount(){return this.windows.size}getWindowById(F){return this.windows.get(F)}getWindowByWebContents(F){const Z=s.BrowserWindow.fromWebContents(F);if(!Z)return;const z=this.getWindowById(Z.id);return z?.matches(F)?z:void 0}};e.WindowsMainService=Y,e.WindowsMainService=Y=Ie([re(4,y.ILogService),re(5,oe.ILoggerMainService),re(6,C.IStateService),re(7,N.IPolicyService),re(8,r.IEnvironmentMainService),re(9,Q.IUserDataProfilesMainService),re(10,P.ILifecycleMainService),re(11,d.IBackupMainService),re(12,t.IConfigurationService),re(13,B.IWorkspacesHistoryMainService),re(14,J.IWorkspacesManagementMainService),re(15,l.IInstantiationService),re(16,o.IDialogMainService),re(17,a.IFileService),re(18,T.IProtocolMainService),re(19,O.IThemeMainService),re(20,j.IAuxiliaryWindowsMainService)],Y)}),define(ce[278],le([0,1,69,29,88,59]),function(V,e,n,s,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let L=class{constructor(w,c,m,u){this.workspacesManagementMainService=w,this.windowsMainService=c,this.workspacesHistoryMainService=m,this.backupMainService=u,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,c){const m=this.windowsMainService.getWindowById(w);if(m)return this.workspacesManagementMainService.enterWorkspace(m,this.windowsMainService.getWindows(),c)}createUntitledWorkspace(w,c,m){return this.workspacesManagementMainService.createUntitledWorkspace(c,m)}deleteUntitledWorkspace(w,c){return this.workspacesManagementMainService.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(w,c){return this.workspacesManagementMainService.getWorkspaceIdentifier(c)}getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(w,c){return this.workspacesHistoryMainService.addRecentlyOpened(c)}removeRecentlyOpened(w,c){return this.workspacesHistoryMainService.removeRecentlyOpened(c)}clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=L,e.WorkspacesMainService=L=Ie([re(0,M.IWorkspacesManagementMainService),re(1,s.IWindowsMainService),re(2,b.IWorkspacesHistoryMainService),re(3,n.IBackupMainService)],L)}),define(ce[279],le([0,1,13,106,35,27,17,55,15,4,283,47,2,12,9,3,11,7,33,158,44,159,118,135,10,69,253,16,260,96,136,53,97,187,20,68,100,175,263,177,178,179,14,191,99,83,6,98,186,269,270,254,261,19,5,276,64,28,74,264,101,34,243,87,128,24,220,221,57,50,233,258,271,259,272,132,235,236,237,240,267,51,29,277,242,30,102,88,278,59,40,200,58,213,49,86,133,245,262,250,8,223,244,195,71,266,239,21,75,265,231,206,65,84,274,78]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i,d,t,o,r,a,l,P,y,k,T,A,C,_,H,q,K,fe,$,X,B,J,U,O,N,Q,oe,j,ue,se,Y,W,F,Z,z,ie,G,x,te,de,me,we,Re,Ne,ke,Ee,pe,ee,ae,he,Se,Me,We,_e,Ae,xe,Ge,Je,qe,Qe,Ye,Xe,Ue,ne,ge,ve,ye,Oe,Be,Ze,lt,st,at,tt,ut,ct,ht,gt,Ct,mt,pt,Lt,Tt,Ot,vt,_t,bt,ft,Wt,Ft,wt,Nt,It,Ut,Pt){"use strict";var St;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let yt=class extends f.Disposable{static{St=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[v.Schemas.file]:"security.promptForLocalFileProtocolHandling",[v.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ce,Le,Te,be,Pe,$e,Ve,Ke,Fe,He,ze,et){super(),this.mainProcessNodeIpcServer=Ce,this.userEnv=Le,this.mainInstantiationService=Te,this.logService=be,this.loggerService=Pe,this.environmentMainService=$e,this.lifecycleMainService=Ve,this.configurationService=Ke,this.stateService=Fe,this.fileService=He,this.productService=ze,this.userDataProfilesMainService=et,this.configureSession(),this.registerListeners()}configureSession(){const Ce=Fe=>Fe?.startsWith(`${v.Schemas.vscodeWebview}://`),Le=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Fe,He,ze,et)=>Ce(et.requestingUrl)?ze(Le.has(He)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Fe,He,ze,et)=>Ce(et.requestingUrl)?Le.has(He):!1);const Te=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),be=Fe=>{for(let He=Fe;He;He=He.parent)if(He.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Pe=Fe=>Fe.resourceType==="xhr"||be(Fe.frame),$e=Fe=>{const He=Fe.frame;if(!He||!this.windowsMainService)return!1;const ze=n.BrowserWindow.getAllWindows();for(const et of ze)if(He.processId===et.webContents.mainFrame.processId)return!0;return!1},Ve=(Fe,He)=>{if(Fe.path!=="/index.html")return!0;const ze=He.frame;if(!ze||!this.windowsMainService)return!1;for(const et of this.windowsMainService.getWindows())if(et.win&&ze.processId===et.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Fe,He)=>{const ze=S.URI.parse(Fe.url);return ze.scheme===v.Schemas.vscodeWebview&&!Ve(ze,Fe)?(this.logService.error("Blocked vscode-webview request",Fe.url),He({cancel:!0})):ze.scheme===v.Schemas.vscodeFileResource&&!$e(Fe)?(this.logService.error("Blocked vscode-file request",Fe.url),He({cancel:!0})):ze.path.endsWith(".svg")&&!Te.has(ze.scheme)?He({cancel:!Pe(Fe)}):He({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,He)=>{const ze=Fe.responseHeaders,et=ze["content-type"]||ze["Content-Type"];if(et&&Array.isArray(et)){const it=S.URI.parse(Fe.url);if(it.path.endsWith(".svg")&&Te.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],He({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(v.Schemas.vscodeRemoteResource)&&et.some(ot=>ot.toLowerCase().includes("image/svg")))return He({cancel:!Pe(Fe)})}return He({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,He)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Fe.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],He({cancel:!1,responseHeaders:ze})}return He({cancel:!1})});const Ke=n.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ke.setCodeCachePath((0,h.join)(this.environmentMainService.codeCachePath,"chrome")),g.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,s.disableUNCAccessRestrictions)():(0,s.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,w.setUnexpectedErrorHandler)(Te=>this.onUnexpectedError(Te)),process.on("uncaughtException",Te=>{(0,w.isSigPipeError)(Te)||(0,w.onUnexpectedError)(Te)}),process.on("unhandledRejection",Te=>(0,w.onUnexpectedError)(Te)),c.Event.once(this.lifecycleMainService.onWillShutdown)(()=>this.dispose()),(0,D.registerContextMenuListener)(),n.app.on("accessibility-support-changed",(Te,be)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",be)}),n.app.on("activate",async(Te,be)=>{this.logService.trace("app#activate"),be||await this.windowsMainService?.openEmptyWindow({context:Xe.OpenContext.DOCK})}),n.app.on("web-contents-created",(Te,be)=>{be?.opener?.url.startsWith(`${v.Schemas.vscodeFileResource}://${v.VSCODE_AUTHORITY}/`)&&(this.logService.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.auxiliaryWindowsMainService?.registerWindow(be)),be.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),be.setWindowOpenHandler(Pe=>Pe.url==="about:blank"?(this.logService.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.auxiliaryWindowsMainService?.createWindow(Pe)}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Pe.url}}`),this.nativeHostMainService?.openExternal(void 0,Pe.url),{action:"deny"}))});let Ce=[],Le;n.app.on("open-file",(Te,be)=>{be=(0,Pt.normalizeNFC)(be),this.logService.trace("app#open-file: ",be),Te.preventDefault(),Ce.push((0,ge.hasWorkspaceFileExtension)(be)?{workspaceUri:S.URI.file(be)}:{fileUri:S.URI.file(be)}),Le!==void 0&&(clearTimeout(Le),Le=void 0),Le=setTimeout(async()=>{await this.windowsMainService?.open({context:Xe.OpenContext.DOCK,cli:this.environmentMainService.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],Le=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:Xe.OpenContext.DESKTOP})}),b.validatedIpcMain.handle("vscode:fetchShellEnv",Te=>{const be=this.windowsMainService?.getWindowByWebContents(Te.sender);let Pe,$e;return be?.config?(Pe=be.config,$e={...process.env,...be.config.userEnv}):(Pe=this.environmentMainService.args,$e=process.env),this.resolveShellEnvironment(Pe,$e,!1)}),b.validatedIpcMain.on("vscode:toggleDevTools",Te=>Te.sender.toggleDevTools()),b.validatedIpcMain.on("vscode:openDevTools",Te=>Te.sender.openDevTools()),b.validatedIpcMain.on("vscode:reloadWindow",Te=>Te.sender.reload()),b.validatedIpcMain.handle("vscode:notifyZoomLevel",async(Te,be)=>{const Pe=this.windowsMainService?.getWindowByWebContents(Te.sender);Pe&&Pe.notifyZoomLevel(be)})}onUnexpectedError(Ce){if(Ce){const Le={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.logService.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.logService.error(Ce.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ce=this.productService.win32AppUserModelId;g.isWindows&&Ce&&n.app.setAppUserModelId(Ce);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.logService.error(ze)}const Le=new i.Server;c.Event.once(this.lifecycleMainService.onWillShutdown)(ze=>{ze.reason===F.ShutdownReason.KILL&&Le.dispose()}),this.logService.trace("Resolving machine identifier...");const[Te,be,Pe]=await Promise.all([(0,pt.resolveMachineId)(this.stateService,this.logService),(0,pt.resolveSqmId)(this.stateService,this.logService),(0,pt.resolvedevDeviceId)(this.stateService,this.logService)]);this.logService.trace(`Resolved machine identifier: ${Te}`);const{sharedProcessReady:$e,sharedProcessClient:Ve}=this.setupSharedProcess(Te,be,Pe),Ke=await this.initServices(Te,be,Pe,$e);Ke.invokeFunction(ze=>ze.get(t.IProxyAuthService)),this._register(Ke.createInstance(gt.UserDataProfilesHandler)),Ke.invokeFunction(ze=>this.initChannels(ze,Le,Ve));const Fe=await Ke.invokeFunction(ze=>this.setupProtocolUrlHandlers(ze,Le));this.setupManagedRemoteResourceUrlHandler(Le),this.lifecycleMainService.phase=F.LifecycleMainPhase.Ready,await Ke.invokeFunction(ze=>this.openFirstWindow(ze,Fe)),this.lifecycleMainService.phase=F.LifecycleMainPhase.AfterWindowOpen,this.afterWindowOpen(),this._register(new mt.RunOnceScheduler(()=>{this._register((0,mt.runWhenGlobalIdle)(()=>this.lifecycleMainService.phase=F.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async setupProtocolUrlHandlers(Ce,Le){const Te=this.windowsMainService=Ce.get(Xe.IWindowsMainService),be=Ce.get(Ae.IURLService),Pe=this.nativeHostMainService=Ce.get(ie.INativeHostMainService),$e=Ce.get(T.IDialogMainService),Ve=this;be.registerHandler({async handleURL(it,ot){return Ve.handleProtocolUrl(Te,$e,be,it,ot)}});const Ke=this._register(new ne.ActiveWindowManager({onDidOpenMainWindow:Pe.onDidOpenMainWindow,onDidFocusMainWindow:Pe.onDidFocusMainWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),Fe=new I.StaticRouter(it=>Ke.getActiveClientId().then(ot=>it===ot)),He=new xe.URLHandlerRouter(Fe,this.logService),ze=Le.getChannel("urlHandler",He);be.registerHandler(new xe.URLHandlerChannelClient(ze));const et=await this.resolveInitialProtocolUrls(Te,$e);return this._register(new Je.ElectronURLListener(et?.urls,be,Te,this.environmentMainService,this.productService,this.logService)),et}setupManagedRemoteResourceUrlHandler(Ce){const Le=()=>({statusCode:404,data:"Not found"}),Te=new Nt.Lazy(()=>Ce.getChannel(wt.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new wt.NodeRemoteResourceRouter));n.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(be,Pe)=>{const $e=S.URI.parse(be.url);if(!$e.authority.startsWith("window:"))return Pe(Le());Te.value.call(wt.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[$e]).then(Ve=>Pe({...Ve,data:Buffer.from(Ve.body,"base64")}),Ve=>{this.logService.warn("error dispatching remote resource call",Ve),Pe({statusCode:500,data:String(Ve)})})})}async resolveInitialProtocolUrls(Ce,Le){const Te=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Te.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Te);const be=global.getOpenUrls()||[];if(be.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",be),Te.length+be.length===0)return;const Pe=[...Te,...be].map(Ke=>{try{return{uri:S.URI.parse(Ke),originalUrl:Ke}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),$e=[],Ve=[];for(const Ke of Pe){if(!Ke)continue;const Fe=this.getWindowOpenableFromProtocolUrl(Ke.uri);if(Fe)if(await this.shouldBlockOpenable(Fe,Ce,Le)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Fe),$e.push(Fe);else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),Ve.push(Ke)}return{urls:Ve,openables:$e}}async shouldBlockOpenable(Ce,Le,Te){let be,Pe;if((0,Ye.isWorkspaceToOpen)(Ce)?(be=Ce.workspaceUri,Pe=(0,o.localize)(12942,null,be.scheme===v.Schemas.file?(0,u.getPathLabel)(be,{os:g.OS,tildify:this.environmentMainService}):be.toString(!0),this.productService.nameShort)):(0,Ye.isFolderToOpen)(Ce)?(be=Ce.folderUri,Pe=(0,o.localize)(12943,null,be.scheme===v.Schemas.file?(0,u.getPathLabel)(be,{os:g.OS,tildify:this.environmentMainService}):be.toString(!0),this.productService.nameShort)):(be=Ce.fileUri,Pe=(0,o.localize)(12944,null,be.scheme===v.Schemas.file?(0,u.getPathLabel)(be,{os:g.OS,tildify:this.environmentMainService}):be.toString(!0),this.productService.nameShort)),be.scheme!==v.Schemas.file&&be.scheme!==v.Schemas.vscodeRemote||this.configurationService.getValue(St.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[be.scheme])===!1)return!1;const{response:Ve,checkboxChecked:Ke}=await Te.showMessageBox({type:"warning",buttons:[(0,o.localize)(12945,null),(0,o.localize)(12946,null)],message:Pe,detail:(0,o.localize)(12947,null),checkboxLabel:be.scheme===v.Schemas.file?(0,o.localize)(12948,null):(0,o.localize)(12949,null),cancelId:1});if(Ve!==0)return!0;if(Ke){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:be.scheme===v.Schemas.file?"local":"remote"};Le.sendToFocused(Fe.channel,Fe.args),Le.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}getWindowOpenableFromProtocolUrl(Ce){if(Ce.path){if(Ce.authority===v.Schemas.file){const Le=S.URI.file(Ce.fsPath);return(0,ge.hasWorkspaceFileExtension)(Le)?{workspaceUri:Le}:{fileUri:Le}}else if(Ce.authority===v.Schemas.vscodeRemote){const Le=Ce.path.indexOf(h.posix.sep,1);if(Le!==-1){const Te=Ce.path.substring(1,Le),be=Ce.path.substring(Le);let Pe=Ce.query;const $e=new URLSearchParams(Ce.query);$e.get("windowId")==="_blank"&&($e.delete("windowId"),Pe=$e.toString());const Ve=S.URI.from({scheme:v.Schemas.vscodeRemote,authority:Te,path:be,query:Pe,fragment:Ce.fragment});return(0,ge.hasWorkspaceFileExtension)(be)?{workspaceUri:Ve}:/:[\d]+$/.test(be)?{fileUri:Ve}:{folderUri:Ve}}}}}async handleProtocolUrl(Ce,Le,Te,be,Pe){this.logService.trace("app#handleProtocolUrl():",be.toString(!0),Pe),be.scheme===this.productService.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:S.URI.parse(be.query).path,query:""}));let $e=!1;const Ve=new URLSearchParams(be.query);Ve.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),Ve.delete("windowId"),be=be.with({query:Ve.toString()}),$e=!0):g.isMacintosh&&Ce.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),$e=!0);const Ke=Ve.get("continueOn");Ke!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),Ve.delete("continueOn"),be=be.with({query:Ve.toString()}),this.environmentMainService.continueOn=Ke??void 0);const Fe=this.getWindowOpenableFromProtocolUrl(be);return Fe?await this.shouldBlockOpenable(Fe,Ce,Le)?(this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0):(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,be.toString(!0)),(0,bt.firstOrDefault)(await Ce.open({context:Xe.OpenContext.API,cli:{...this.environmentMainService.args},urisToOpen:[Fe],forceNewWindow:$e,gotoLineMode:!0}))?.focus(),!0):$e?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,bt.firstOrDefault)(await Ce.open({context:Xe.OpenContext.API,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,x.getRemoteAuthority)(be)}))?.ready(),Te.open(be,Pe)):(this.logService.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Pe),!1)}setupSharedProcess(Ce,Le,Te){const be=this._register(this.mainInstantiationService.createInstance(te.SharedProcess,Ce,Le,Te));this._register(be.onDidCrash(()=>this.windowsMainService?.sendToFocused("vscode:reportSharedProcessCrash")));const Pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ve=await be.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new d.Client(Ve,"main")})();return{sharedProcessReady:(async()=>(await be.whenReady(),Pe))(),sharedProcessClient:Pe}}async initServices(Ce,Le,Te,be){const Pe=new oe.ServiceCollection;switch(process.platform){case"win32":Pe.set(ae.IUpdateService,new N.SyncDescriptor(_e.Win32UpdateService));break;case"linux":g.isLinuxSnap?Pe.set(ae.IUpdateService,new N.SyncDescriptor(We.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(ae.IUpdateService,new N.SyncDescriptor(Me.LinuxUpdateService));break;case"darwin":Pe.set(ae.IUpdateService,new N.SyncDescriptor(Se.DarwinUpdateService));break}Pe.set(Xe.IWindowsMainService,new N.SyncDescriptor(Ue.WindowsMainService,[Ce,Le,Te,this.userEnv],!1)),Pe.set(It.IAuxiliaryWindowsMainService,new N.SyncDescriptor(Ut.AuxiliaryWindowsMainService,void 0,!1));const $e=new T.DialogMainService(this.logService,this.productService);Pe.set(T.IDialogMainService,$e),Pe.set(W.ILaunchMainService,new N.SyncDescriptor(W.LaunchMainService,void 0,!1)),Pe.set(k.IDiagnosticsMainService,new N.SyncDescriptor(k.DiagnosticsMainService,void 0,!1)),Pe.set(y.IDiagnosticsService,I.ProxyChannel.toService((0,I.getDelayedChannel)(be.then(ze=>ze.getChannel("diagnostics"))))),Pe.set(j.IIssueMainService,new N.SyncDescriptor(ue.IssueMainService,[this.userEnv])),Pe.set(j.IProcessMainService,new N.SyncDescriptor(se.ProcessMainService,[this.userEnv])),Pe.set(A.IEncryptionMainService,new N.SyncDescriptor(C.EncryptionMainService)),Pe.set(Y.IKeyboardLayoutMainService,new N.SyncDescriptor(Y.KeyboardLayoutMainService)),Pe.set(ie.INativeHostMainService,new N.SyncDescriptor(ie.NativeHostMainService,void 0,!1)),Pe.set(qe.IWebviewManagerService,new N.SyncDescriptor(Qe.WebviewMainService)),Pe.set(z.IMenubarMainService,new N.SyncDescriptor(z.MenubarMainService)),Pe.set(K.IExtensionHostStarter,new N.SyncDescriptor(fe.ExtensionHostStarter)),Pe.set(Re.IStorageMainService,new N.SyncDescriptor(Re.StorageMainService)),Pe.set(Re.IApplicationStorageMainService,new N.SyncDescriptor(Re.ApplicationStorageMainService));const Ve=new Wt.ElectronPtyHostStarter({graceTime:ft.LocalReconnectConstants.GraceTime,shortGraceTime:ft.LocalReconnectConstants.ShortGraceTime,scrollback:this.configurationService.getValue(ft.TerminalSettingId.PersistentSessionScrollback)??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),Ke=new Ft.PtyHostService(Ve,this.configurationService,this.logService,this.loggerService);Pe.set(ft.ILocalPtyService,Ke),g.isWindows?Pe.set($.IExternalTerminalMainService,new N.SyncDescriptor(X.WindowsExternalTerminalService)):g.isMacintosh?Pe.set($.IExternalTerminalMainService,new N.SyncDescriptor(X.MacExternalTerminalService)):g.isLinux&&Pe.set($.IExternalTerminalMainService,new N.SyncDescriptor(X.LinuxExternalTerminalService));const Fe=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);Pe.set(r.IBackupMainService,Fe);const He=new Be.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Fe,$e);if(Pe.set(Be.IWorkspacesManagementMainService,He),Pe.set(ve.IWorkspacesService,new N.SyncDescriptor(Oe.WorkspacesMainService,void 0,!1)),Pe.set(ye.IWorkspacesHistoryMainService,new N.SyncDescriptor(ye.WorkspacesHistoryMainService,void 0,!1)),Pe.set(Ae.IURLService,new N.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,ee.supportsTelemetry)(this.productService,this.environmentMainService)){const ze=(0,ee.isInternalTelemetry)(this.productService,this.configurationService),et=(0,I.getDelayedChannel)(be.then(Et=>Et.getChannel("telemetryAppender"))),it=new Ee.TelemetryAppenderClient(et),ot=(0,Ne.resolveCommonProperties)((0,M.release)(),(0,M.hostname)(),process.arch,this.productService.commit,this.productService.version,Ce,Le,Te,ze),nt=(0,ee.getPiiPathsFromEnvironment)(this.environmentMainService),dt={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Pe.set(ke.ITelemetryService,new N.SyncDescriptor(pe.TelemetryService,[dt],!1))}else Pe.set(ke.ITelemetryService,ee.NullTelemetryService);return Pe.set(ut.IExtensionsProfileScannerService,new N.SyncDescriptor(Lt.ExtensionsProfileScannerService,void 0,!0)),Pe.set(ct.IExtensionsScannerService,new N.SyncDescriptor(ht.ExtensionsScannerService,void 0,!0)),Pe.set(vt.IUtilityProcessWorkerMainService,new N.SyncDescriptor(vt.UtilityProcessWorkerMainService,void 0,!0)),Pe.set(t.IProxyAuthService,new N.SyncDescriptor(t.ProxyAuthService)),await mt.Promises.settled([Fe.initialize(),He.initialize()]),this.mainInstantiationService.createChild(Pe)}initChannels(Ce,Le,Te){const be=this._register(new f.DisposableStore),Pe=I.ProxyChannel.fromService(Ce.get(W.ILaunchMainService),be,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Pe);const $e=I.ProxyChannel.fromService(Ce.get(k.IDiagnosticsMainService),be,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",$e);const Ve=be.add(new lt.PolicyChannel(Ce.get(Ze.IPolicyService)));Le.registerChannel("policy",Ve),Te.then(rt=>rt.registerChannel("policy",Ve));const Ke=this.fileService.getProvider(v.Schemas.file);(0,E.assertType)(Ke instanceof O.DiskFileSystemProvider);const Fe=be.add(new U.DiskFileSystemProviderChannel(Ke,this.logService,this.environmentMainService));Le.registerChannel(B.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Fe),Te.then(rt=>rt.registerChannel(B.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Fe));const He=I.ProxyChannel.fromService(Ce.get(st.IUserDataProfilesMainService),be);Le.registerChannel("userDataProfiles",He),Te.then(rt=>rt.registerChannel("userDataProfiles",He));const ze=new at.RequestChannel(Ce.get(tt.IRequestService));Te.then(rt=>rt.registerChannel("request",ze));const et=new he.UpdateChannel(Ce.get(ae.IUpdateService));Le.registerChannel("update",et);const it=I.ProxyChannel.fromService(Ce.get(j.IIssueMainService),be);Le.registerChannel("issue",it);const ot=I.ProxyChannel.fromService(Ce.get(j.IProcessMainService),be);Le.registerChannel("process",ot);const nt=I.ProxyChannel.fromService(Ce.get(A.IEncryptionMainService),be);Le.registerChannel("encryption",nt);const dt=I.ProxyChannel.fromService(Ce.get(de.ISignService),be);Le.registerChannel("sign",dt);const Et=I.ProxyChannel.fromService(Ce.get(Y.IKeyboardLayoutMainService),be);Le.registerChannel("keyboardLayout",Et),this.nativeHostMainService=Ce.get(ie.INativeHostMainService);const Dt=I.ProxyChannel.fromService(this.nativeHostMainService,be);Le.registerChannel("nativeHost",Dt),Te.then(rt=>rt.registerChannel("nativeHost",Dt));const xt=I.ProxyChannel.fromService(Ce.get(ve.IWorkspacesService),be);Le.registerChannel("workspaces",xt);const Bt=I.ProxyChannel.fromService(Ce.get(z.IMenubarMainService),be);Le.registerChannel("menubar",Bt);const zt=I.ProxyChannel.fromService(Ce.get(Ae.IURLService),be);Le.registerChannel("url",zt);const qt=I.ProxyChannel.fromService(Ce.get(qe.IWebviewManagerService),be);Le.registerChannel("webview",qt);const Rt=be.add(new we.StorageDatabaseChannel(this.logService,Ce.get(Re.IStorageMainService)));Le.registerChannel("storage",Rt),Te.then(rt=>rt.registerChannel("storage",Rt));const $t=be.add(new Ct.ProfileStorageChangesListenerChannel(Ce.get(Re.IStorageMainService),Ce.get(st.IUserDataProfilesMainService),this.logService));Te.then(rt=>rt.registerChannel("profileStorageListener",$t));const Ht=I.ProxyChannel.fromService(Ce.get(ft.ILocalPtyService),be);Le.registerChannel(ft.TerminalIpcChannels.LocalPty,Ht);const Vt=I.ProxyChannel.fromService(Ce.get($.IExternalTerminalMainService),be);Le.registerChannel("externalTerminal",Vt);const kt=new Tt.LoggerChannel(Ce.get(Ot.ILoggerMainService));Le.registerChannel("logger",kt),Te.then(rt=>rt.registerChannel("logger",kt));const jt=new P.ElectronExtensionHostDebugBroadcastChannel(Ce.get(Xe.IWindowsMainService));Le.registerChannel("extensionhostdebugservice",jt);const Gt=I.ProxyChannel.fromService(Ce.get(K.IExtensionHostStarter),be);Le.registerChannel(K.ipcExtensionHostStarterChannelName,Gt);const Kt=I.ProxyChannel.fromService(Ce.get(vt.IUtilityProcessWorkerMainService),be);Le.registerChannel(_t.ipcUtilityProcessWorkerChannelName,Kt)}async openFirstWindow(Ce,Le){const Te=this.windowsMainService=Ce.get(Xe.IWindowsMainService);this.auxiliaryWindowsMainService=Ce.get(It.IAuxiliaryWindowsMainService);const be=(0,H.isLaunchedFromCli)(process.env)?Xe.OpenContext.CLI:Xe.OpenContext.DESKTOP,Pe=this.environmentMainService.args;if(Le){if(Le.openables.length>0)return Te.open({context:be,cli:Pe,urisToOpen:Le.openables,gotoLineMode:!0,initialStartup:!0});if(Le.urls.length>0)for(const nt of Le.urls){const dt=new URLSearchParams(nt.uri.query);if(dt.get("windowId")==="_blank")return dt.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:dt.toString()}),Te.open({context:be,cli:Pe,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const $e=global.macOpenFiles,Ve=Pe._.length,Ke=!!Pe["folder-uri"],Fe=!!Pe["file-uri"],He=Pe["skip-add-to-recently-opened"]===!0,ze=Pe.wait&&Pe.waitMarkerFilePath?S.URI.file(Pe.waitMarkerFilePath):void 0,et=Pe.remote||void 0,it=Pe.profile,ot=Pe["profile-temp"];if(!Ve&&!Ke&&!Fe){if(Pe["new-window"]||it||ot)return Te.open({context:be,cli:Pe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot});if($e.length)return Te.open({context:Xe.OpenContext.DOCK,cli:Pe,urisToOpen:$e.map(nt=>(nt=(0,Pt.normalizeNFC)(nt),(0,ge.hasWorkspaceFileExtension)(nt)?{workspaceUri:S.URI.file(nt)}:{fileUri:S.URI.file(nt)})),noRecentEntry:He,waitMarkerFileURI:ze,initialStartup:!0})}return Te.open({context:be,cli:Pe,forceNewWindow:Pe["new-window"],diffMode:Pe.diff,mergeMode:Pe.merge,noRecentEntry:He,waitMarkerFileURI:ze,gotoLineMode:Pe.goto,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot})}afterWindowOpen(){this.installMutex(),n.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Ce,Le)=>{Le({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),g.isMacintosh&&n.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const Ce=this.productService.win32MutexName;if(g.isWindows&&Ce)try{const Le=await new Promise((be,Pe)=>{V(["@vscode/windows-mutex"],be,Pe)}).then(De),Te=new Le.Mutex(Ce);c.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Te.release())}catch(Le){this.logService.error(Le)}}async resolveShellEnvironment(Ce,Le,Te){try{return await(0,q.getResolvedShellEnv)(this.configurationService,this.logService,Ce,Le)}catch(be){const Pe=(0,R.toErrorMessage)(be);Te?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}async updateCrashReporterEnablement(){try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Te=(0,m.parse)(Le),Pe=(0,ee.getTelemetryLevel)(this.configurationService)>=ke.TelemetryLevel.CRASH;if(Te["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Pe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,p.generateUuid)()}"`,"}"],Ve=Le.substring(0,Le.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,L.VSBuffer.fromString(Ve))}else{const $e=Le.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Pe},`);$e!==Le&&await this.fileService.writeFile(this.environmentMainService.argvResource,L.VSBuffer.fromString($e))}}catch(Ce){this.logService.error(Ce),this.windowsMainService?.sendToFocused("vscode:showArgvParseWarning")}}};e.CodeApplication=yt,e.CodeApplication=yt=St=Ie([re(2,Q.IInstantiationService),re(3,Z.ILogService),re(4,Z.ILoggerService),re(5,_.IEnvironmentMainService),re(6,F.ILifecycleMainService),re(7,l.IConfigurationService),re(8,me.IStateService),re(9,J.IFileService),re(10,G.IProductService),re(11,st.IUserDataProfilesMainService)],yt)});var je=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[284],le([0,1,13,26,7,21,8,55,15,32,4,47,12,9,70,3,36,25,23,44,104,279,10,16,205,219,20,68,170,14,189,99,83,185,98,19,192,5,72,28,73,246,131,257,49,256,101,218,34,57,76,58,40,201,199,2,41,234,71,194,123,127,238,106,232]),function(V,e,n,s,b,M,L,R,w,c,m,u,f,v,h,g,E,S,p,D,I,i,d,t,o,r,a,l,P,y,k,T,A,C,_,H,q,K,fe,$,X,B,J,U,O,N,Q,oe,j,ue,se,Y,W,F,Z,z,ie,G,x,te,de,me,we,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),fe=je(fe);class Ne{main(){try{this.startup()}catch(pe){console.error(pe.message),n.app.exit(1)}}async startup(){(0,w.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[pe,ee,ae,he,Se,Me,We,_e]=this.createServices();try{try{await this.initServices(ae,_e,he,Se,We)}catch(Ae){throw this.handleStartupDataDirError(ae,We,Ae),Ae}await pe.invokeFunction(async Ae=>{const xe=Ae.get(K.ILogService),Ge=Ae.get(H.ILifecycleMainService),Je=Ae.get(y.IFileService),qe=Ae.get(K.ILoggerService),Qe=await this.claimInstance(xe,ae,Ge,pe,We,!0);return p.Promises.writeFile(ae.mainLockfile,String(process.pid)).catch(Ye=>{xe.warn(`app#startup(): Error writing main lockfile: ${Ye.stack}`)}),Me.logger=qe.createLogger("main",{name:(0,d.localize)(12933,null)}),m.Event.once(Ge.onWillShutdown)(Ye=>{Je.dispose(),he.dispose(),Ye.join("instanceLockfile",s.promises.unlink(ae.mainLockfile).catch(()=>{}))}),pe.createInstance(i.CodeApplication,Qe,ee).startup()})}catch(Ae){pe.invokeFunction(this.quit,Ae)}}createServices(){const pe=new _.ServiceCollection,ee=new z.DisposableStore;process.once("exit",()=>ee.dispose());const ae={_serviceBrand:void 0,...fe.default};pe.set($.IProductService,ae);const he=new a.EnvironmentMainService(this.resolveArgs(),ae),Se=this.patchEnvironment(he);pe.set(a.IEnvironmentMainService,he);const Me=new x.LoggerMainService((0,K.getLogLevel)(he),he.logsHome);pe.set(x.ILoggerMainService,Me);const We=new q.BufferLogger(Me.getLogLevel()),_e=ee.add(new te.LogService(We,[new K.ConsoleMainLogger(Me.getLogLevel())]));pe.set(K.ILogService,_e);const Ae=new k.FileService(_e);pe.set(y.IFileService,Ae);const xe=new T.DiskFileSystemProvider(_e);Ae.registerProvider(f.Schemas.file,xe);const Ge=new G.UriIdentityService(Ae);pe.set(ie.IUriIdentityService,Ge);const Je=new me.StateService(me.SaveStrategy.DELAYED,he,_e,Ae);pe.set(j.IStateReadService,Je),pe.set(j.IStateService,Je);const qe=new Y.UserDataProfilesMainService(Je,Ge,he,Ae,_e);pe.set(Y.IUserDataProfilesMainService,qe),Ae.registerProvider(f.Schemas.vscodeUserData,new we.FileUserDataProvider(f.Schemas.file,xe,f.Schemas.vscodeUserData,qe,Ge,_e));const Qe=g.isWindows&&ae.win32RegValueName?ee.add(new F.NativePolicyService(_e,ae.win32RegValueName)):he.policyFile?ee.add(new Z.FilePolicyService(he.policyFile,Ae,_e)):new W.NullPolicyService;pe.set(W.IPolicyService,Qe);const Ye=new o.ConfigurationService(qe.defaultProfile.settingsResource,Ae,Qe,_e);return pe.set(t.IConfigurationService,Ye),pe.set(H.ILifecycleMainService,new A.SyncDescriptor(H.LifecycleMainService,void 0,!1)),pe.set(O.IRequestService,new A.SyncDescriptor(N.RequestMainService,void 0,!0)),pe.set(se.IThemeMainService,new A.SyncDescriptor(se.ThemeMainService)),pe.set(Q.ISignService,new A.SyncDescriptor(oe.SignService,void 0,!1)),pe.set(J.ITunnelService,new A.SyncDescriptor(U.TunnelService)),pe.set(X.IProtocolMainService,new B.ProtocolMainService(he,qe,_e)),[new C.InstantiationService(pe,!0),Se,he,Ye,Je,We,ae,qe]}patchEnvironment(pe){const ee={VSCODE_IPC_HOOK:pe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ae=>{const he=process.env[ae];typeof he=="string"&&(ee[ae]=he)}),Object.assign(process.env,ee),ee}async initServices(pe,ee,ae,he,Se){await L.Promises.settled([Promise.all([this.allowWindowsUNCPath(pe.extensionsPath),pe.codeCachePath,pe.logsHome.with({scheme:f.Schemas.file}).fsPath,ee.defaultProfile.globalStorageHome.with({scheme:f.Schemas.file}).fsPath,pe.workspaceStorageHome.with({scheme:f.Schemas.file}).fsPath,pe.localHistoryHome.with({scheme:f.Schemas.file}).fsPath,pe.backupHome].map(Me=>Me?s.promises.mkdir(Me,{recursive:!0}):void 0)),he.init(),ae.initialize()]),ee.init()}allowWindowsUNCPath(pe){if(g.isWindows){const ee=(0,Re.getUNCHost)(pe);ee&&(0,Re.addUNCHostToAllowlist)(ee)}return pe}async claimInstance(pe,ee,ae,he,Se,Me){let We;try{(0,h.mark)("code/willStartMainServer"),We=await(0,I.serve)(ee.mainIPCHandle),(0,h.mark)("code/didStartMainServer"),m.Event.once(ae.onWillShutdown)(()=>We.dispose())}catch(_e){if(_e.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ee,Se,_e),_e;let Ae;try{Ae=await(0,I.connect)(ee.mainIPCHandle,"main")}catch(qe){if(!Me||g.isWindows||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.showStartupWarningDialog((0,d.localize)(12934,null,Se.nameShort),(0,d.localize)(12935,null),Se),qe;try{(0,s.unlinkSync)(ee.mainIPCHandle)}catch(Qe){throw pe.warn("Could not delete obsolete instance handle",Qe),Qe}return this.claimInstance(pe,ee,ae,he,Se,!1)}if(ee.extensionTestsLocationURI&&!ee.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${Se.nameShort} is running.`;throw pe.error(qe),Ae.dispose(),new Error(qe)}let xe;!ee.args.wait&&!ee.args.status&&(xe=setTimeout(()=>{this.showStartupWarningDialog((0,d.localize)(12936,null,Se.nameShort),(0,d.localize)(12937,null),Se)},1e4));const Ge=D.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),Je=D.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(ee.args.status)return he.invokeFunction(async()=>{const qe=new r.DiagnosticsService(ue.NullTelemetryService,Se),Qe=await Je.getMainDiagnostics(),Ye=await Je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Xe=await qe.getDiagnostics(Qe,Ye);throw console.log(Xe),new w.ExpectedError});throw g.isWindows&&await this.windowsAllowSetForegroundWindow(Ge,pe),pe.trace("Sending env to running instance..."),await Ge.start(ee.args,process.env),Ae.dispose(),xe&&clearTimeout(xe),new w.ExpectedError("Sent env to running instance. Terminating...")}if(ee.args.status)throw console.log((0,d.localize)(12938,null,Se.nameShort)),new w.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),We}handleStartupDataDirError(pe,ee,ae){if(ae.code==="EACCES"||ae.code==="EPERM"){const he=(0,M.coalesce)([pe.userDataPath,pe.extensionsPath,I.XDG_RUNTIME_DIR]).map(Se=>(0,u.getPathLabel)(b.URI.file(Se),{os:g.OS,tildify:pe}));this.showStartupWarningDialog((0,d.localize)(12939,null),(0,d.localize)(12940,null,(0,R.toErrorMessage)(ae),he.join(`
`)),ee)}}showStartupWarningDialog(pe,ee,ae){n.dialog.showMessageBoxSync((0,de.massageMessageBoxOptions)({type:"warning",buttons:[(0,d.localize)(12941,null)],message:pe,detail:ee},ae).options)}async windowsAllowSetForegroundWindow(pe,ee){if(g.isWindows){const ae=await pe.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",ae);try{(await new Promise((he,Se)=>{V(["windows-foreground-love"],he,Se)}).then(De)).allowSetForegroundWindow(ae)}catch(he){ee.error(he)}}}quit(pe,ee){const ae=pe.get(K.ILogService),he=pe.get(H.ILifecycleMainService);let Se=0;ee&&(ee.isExpected?ee.message&&ae.trace(ee.message):(Se=1,ee.stack?ae.error(ee.stack):ae.error(`Startup error: ${ee.toString()}`))),he.kill(Se)}resolveArgs(){const pe=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(pe.wait&&!pe.waitMarkerFilePath){const ee=(0,P.createWaitMarkerFileSync)(pe.verbose);ee&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",ee),pe.waitMarkerFilePath=ee)}return pe}validatePaths(pe){if(pe["open-url"]&&(pe._urls=pe._,pe._=[]),!pe.remote){const ee=this.doValidatePaths(pe._,pe.goto);pe._=ee}return pe}doValidatePaths(pe,ee){const ae=(0,E.cwd)(),he=pe.map(We=>{let _e=String(We),Ae;ee&&(Ae=(0,c.parseLineAndColumnAware)(_e),_e=Ae.path),_e&&(_e=this.preparePath(ae,_e));const xe=(0,c.sanitizeFilePath)(_e,ae),Ge=(0,v.basename)(xe);return Ge&&!(0,c.isValidBasename)(Ge)?null:ee&&Ae?(Ae.path=xe,this.toPath(Ae)):xe}),Se=g.isWindows||g.isMacintosh,Me=(0,M.distinct)(he,We=>We&&Se?We.toLowerCase():We||"");return(0,M.coalesce)(Me)}preparePath(pe,ee){return g.isWindows&&(ee=(0,S.rtrim)(ee,'"')),ee=(0,S.trim)((0,S.trim)(ee," "),"	"),g.isWindows&&(ee=(0,v.resolve)(pe,ee),ee=(0,S.rtrim)(ee,".")),ee}toPath(pe){const ee=[pe.path];return typeof pe.line=="number"&&ee.push(String(pe.line)),typeof pe.column=="number"&&ee.push(String(pe.column)),ee.join(":")}}new Ne().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/code/electron-main/main.js.map
