/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/keyCodes","vs/base/common/arrays","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/charCode","vs/base/browser/browser","vs/base/browser/mouseEvent","vs/base/common/scrollable","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/base","vs/base/common/path","vs/base/browser/event","vs/base/common/equals","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/browser/ui/list/list","vs/base/common/assert","vs/base/common/map","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/range","vs/base/common/buffer","vs/base/common/codiconsUtil","vs/base/common/filters","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/base/common/actions","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/browser/canIUse","vs/base/common/observable","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/hash","vs/base/common/iconLabels","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/parts/ipc/common/ipc","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/aria/aria","vs/base/browser/ui/contextview/contextview","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/lazyObservableValue","vs/base/common/observableInternal/api","vs/base/common/keybindings","vs/base/common/process","vs/base/common/mime","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/codiconsLibrary","vs/base/common/extpath","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/contextview/contextview","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],De=function(oe){for(var t=[],i=0,n=oe.length;i<n;i++)t[i]=ve[oe[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:Ut,isFrozen:ui,getPrototypeOf:ci,getOwnPropertyDescriptor:hi}=Object;let{freeze:ct,seal:bt,create:di}=Object,{apply:kt,construct:Pt}=typeof Reflect<"u"&&Reflect;kt||(kt=function(t,i,n){return t.apply(i,n)}),ct||(ct=function(t){return t}),bt||(bt=function(t){return t}),Pt||(Pt=function(t,i){return new t(...i)});const fi=mt(Array.prototype.forEach),Vt=mt(Array.prototype.pop),At=mt(Array.prototype.push),Nt=mt(String.prototype.toLowerCase),Mt=mt(String.prototype.toString),gi=mt(String.prototype.match),vt=mt(String.prototype.replace),mi=mt(String.prototype.indexOf),pi=mt(String.prototype.trim),gt=mt(RegExp.prototype.test),Tt=bi(TypeError);function mt(oe){return function(t){for(var i=arguments.length,n=new Array(i>1?i-1:0),P=1;P<i;P++)n[P-1]=arguments[P];return kt(oe,t,n)}}function bi(oe){return function(){for(var t=arguments.length,i=new Array(t),n=0;n<t;n++)i[n]=arguments[n];return Pt(oe,i)}}function Ge(oe,t,i){var n;i=(n=i)!==null&&n!==void 0?n:Nt,Ut&&Ut(oe,null);let P=t.length;for(;P--;){let F=t[P];if(typeof F=="string"){const I=i(F);I!==F&&(ui(t)||(t[P]=I),F=I)}oe[F]=!0}return oe}function wt(oe){const t=di(null);for(const[i,n]of zt(oe))t[i]=n;return t}function Ft(oe,t){for(;oe!==null;){const n=hi(oe,t);if(n){if(n.get)return mt(n.get);if(typeof n.value=="function")return mt(n.value)}oe=ci(oe)}function i(n){return console.warn("fallback value for",n),null}return i}const Kt=ct(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Bt=ct(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),xt=ct(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),vi=ct(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Wt=ct(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),Di=ct(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),$t=ct(["#text"]),qt=ct(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ht=ct(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Gt=ct(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Rt=ct(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),Ei=bt(/\{\{[\w\W]*|[\w\W]*\}\}/gm),wi=bt(/<%[\w\W]*|[\w\W]*%>/gm),yi=bt(/\${[\w\W]*}/gm),_i=bt(/^data-[\-\w.\u00B7-\uFFFF]/),Si=bt(/^aria-[\-\w]+$/),jt=bt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),Ai=bt(/^(?:\w+script|data):/i),Ti=bt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Yt=bt(/^html$/i);var Xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:Ei,ERB_EXPR:wi,TMPLIT_EXPR:yi,DATA_ATTR:_i,ARIA_ATTR:Si,IS_ALLOWED_URI:jt,IS_SCRIPT_OR_DATA:Ai,ATTR_WHITESPACE:Ti,DOCTYPE_NAME:Yt});const Li=()=>typeof window>"u"?null:window,Ii=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let n=null;const P="data-tt-policy-suffix";i&&i.hasAttribute(P)&&(n=i.getAttribute(P));const F="dompurify"+(n?"#"+n:"");try{return t.createPolicy(F,{createHTML(I){return I},createScriptURL(I){return I}})}catch{return console.warn("TrustedTypes policy "+F+" could not be created."),null}};function Zt(){let oe=arguments.length>0&&arguments[0]!==void 0?arguments[0]:Li();const t=ze=>Zt(ze);if(t.version="3.0.5",t.removed=[],!oe||!oe.document||oe.document.nodeType!==9)return t.isSupported=!1,t;const i=oe.document,n=i.currentScript;let{document:P}=oe;const{DocumentFragment:F,HTMLTemplateElement:I,Node:D,Element:w,NodeFilter:d,NamedNodeMap:v=oe.NamedNodeMap||oe.MozNamedAttrMap,HTMLFormElement:_,DOMParser:b,trustedTypes:m}=oe,e=w.prototype,s=Ft(e,"cloneNode"),r=Ft(e,"nextSibling"),c=Ft(e,"childNodes"),l=Ft(e,"parentNode");if(typeof I=="function"){const ze=P.createElement("template");ze.content&&ze.content.ownerDocument&&(P=ze.content.ownerDocument)}let E,T="";const{implementation:A,createNodeIterator:f,createDocumentFragment:h,getElementsByTagName:p}=P,{importNode:S}=i;let U={};t.isSupported=typeof zt=="function"&&typeof l=="function"&&A&&A.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:H,ERB_EXPR:x,TMPLIT_EXPR:y,DATA_ATTR:O,ARIA_ATTR:V,IS_SCRIPT_OR_DATA:R,ATTR_WHITESPACE:W}=Xt;let{IS_ALLOWED_URI:G}=Xt,Q=null;const j=Ge({},[...Kt,...Bt,...xt,...Wt,...$t]);let q=null;const J=Ge({},[...qt,...Ht,...Gt,...Rt]);let le=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),me=null,_e=null,Ne=!0,ne=!0,ee=!1,he=!0,ae=!1,Le=!1,te=!1,pe=!1,Ae=!1,Ce=!1,Re=!1,xe=!0,He=!1;const $="user-content-";let B=!0,a=!1,o={},g=null;const k=Ge({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let L=null;const u=Ge({},["audio","video","img","source","image","track"]);let N=null;const C=Ge({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),M="http://www.w3.org/1998/Math/MathML",z="http://www.w3.org/2000/svg",X="http://www.w3.org/1999/xhtml";let ie=X,re=!1,ce=null;const we=Ge({},[M,z,X],Mt);let Ee;const ye=["application/xhtml+xml","text/html"],Ie="text/html";let de,Fe=null;const qe=P.createElement("form"),Ye=function(fe){return fe instanceof RegExp||fe instanceof Function},tt=function(fe){if(!(Fe&&Fe===fe)){if((!fe||typeof fe!="object")&&(fe={}),fe=wt(fe),Ee=ye.indexOf(fe.PARSER_MEDIA_TYPE)===-1?Ee=Ie:Ee=fe.PARSER_MEDIA_TYPE,de=Ee==="application/xhtml+xml"?Mt:Nt,Q="ALLOWED_TAGS"in fe?Ge({},fe.ALLOWED_TAGS,de):j,q="ALLOWED_ATTR"in fe?Ge({},fe.ALLOWED_ATTR,de):J,ce="ALLOWED_NAMESPACES"in fe?Ge({},fe.ALLOWED_NAMESPACES,Mt):we,N="ADD_URI_SAFE_ATTR"in fe?Ge(wt(C),fe.ADD_URI_SAFE_ATTR,de):C,L="ADD_DATA_URI_TAGS"in fe?Ge(wt(u),fe.ADD_DATA_URI_TAGS,de):u,g="FORBID_CONTENTS"in fe?Ge({},fe.FORBID_CONTENTS,de):k,me="FORBID_TAGS"in fe?Ge({},fe.FORBID_TAGS,de):{},_e="FORBID_ATTR"in fe?Ge({},fe.FORBID_ATTR,de):{},o="USE_PROFILES"in fe?fe.USE_PROFILES:!1,Ne=fe.ALLOW_ARIA_ATTR!==!1,ne=fe.ALLOW_DATA_ATTR!==!1,ee=fe.ALLOW_UNKNOWN_PROTOCOLS||!1,he=fe.ALLOW_SELF_CLOSE_IN_ATTR!==!1,ae=fe.SAFE_FOR_TEMPLATES||!1,Le=fe.WHOLE_DOCUMENT||!1,Ae=fe.RETURN_DOM||!1,Ce=fe.RETURN_DOM_FRAGMENT||!1,Re=fe.RETURN_TRUSTED_TYPE||!1,pe=fe.FORCE_BODY||!1,xe=fe.SANITIZE_DOM!==!1,He=fe.SANITIZE_NAMED_PROPS||!1,B=fe.KEEP_CONTENT!==!1,a=fe.IN_PLACE||!1,G=fe.ALLOWED_URI_REGEXP||jt,ie=fe.NAMESPACE||X,le=fe.CUSTOM_ELEMENT_HANDLING||{},fe.CUSTOM_ELEMENT_HANDLING&&Ye(fe.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(le.tagNameCheck=fe.CUSTOM_ELEMENT_HANDLING.tagNameCheck),fe.CUSTOM_ELEMENT_HANDLING&&Ye(fe.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(le.attributeNameCheck=fe.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),fe.CUSTOM_ELEMENT_HANDLING&&typeof fe.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(le.allowCustomizedBuiltInElements=fe.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),ae&&(ne=!1),Ce&&(Ae=!0),o&&(Q=Ge({},[...$t]),q=[],o.html===!0&&(Ge(Q,Kt),Ge(q,qt)),o.svg===!0&&(Ge(Q,Bt),Ge(q,Ht),Ge(q,Rt)),o.svgFilters===!0&&(Ge(Q,xt),Ge(q,Ht),Ge(q,Rt)),o.mathMl===!0&&(Ge(Q,Wt),Ge(q,Gt),Ge(q,Rt))),fe.ADD_TAGS&&(Q===j&&(Q=wt(Q)),Ge(Q,fe.ADD_TAGS,de)),fe.ADD_ATTR&&(q===J&&(q=wt(q)),Ge(q,fe.ADD_ATTR,de)),fe.ADD_URI_SAFE_ATTR&&Ge(N,fe.ADD_URI_SAFE_ATTR,de),fe.FORBID_CONTENTS&&(g===k&&(g=wt(g)),Ge(g,fe.FORBID_CONTENTS,de)),B&&(Q["#text"]=!0),Le&&Ge(Q,["html","head","body"]),Q.table&&(Ge(Q,["tbody"]),delete me.tbody),fe.TRUSTED_TYPES_POLICY){if(typeof fe.TRUSTED_TYPES_POLICY.createHTML!="function")throw Tt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof fe.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw Tt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');E=fe.TRUSTED_TYPES_POLICY,T=E.createHTML("")}else E===void 0&&(E=Ii(m,n)),E!==null&&typeof T=="string"&&(T=E.createHTML(""));ct&&ct(fe),Fe=fe}},at=Ge({},["mi","mo","mn","ms","mtext"]),st=Ge({},["foreignobject","desc","title","annotation-xml"]),je=Ge({},["title","style","font","a","script"]),Ze=Ge({},Bt);Ge(Ze,xt),Ge(Ze,vi);const Z=Ge({},Wt);Ge(Z,Di);const ue=function(fe){let Oe=l(fe);(!Oe||!Oe.tagName)&&(Oe={namespaceURI:ie,tagName:"template"});const Me=Nt(fe.tagName),Xe=Nt(Oe.tagName);return ce[fe.namespaceURI]?fe.namespaceURI===z?Oe.namespaceURI===X?Me==="svg":Oe.namespaceURI===M?Me==="svg"&&(Xe==="annotation-xml"||at[Xe]):!!Ze[Me]:fe.namespaceURI===M?Oe.namespaceURI===X?Me==="math":Oe.namespaceURI===z?Me==="math"&&st[Xe]:!!Z[Me]:fe.namespaceURI===X?Oe.namespaceURI===z&&!st[Xe]||Oe.namespaceURI===M&&!at[Xe]?!1:!Z[Me]&&(je[Me]||!Ze[Me]):!!(Ee==="application/xhtml+xml"&&ce[fe.namespaceURI]):!1},be=function(fe){At(t.removed,{element:fe});try{fe.parentNode.removeChild(fe)}catch{fe.remove()}},Te=function(fe,Oe){try{At(t.removed,{attribute:Oe.getAttributeNode(fe),from:Oe})}catch{At(t.removed,{attribute:null,from:Oe})}if(Oe.removeAttribute(fe),fe==="is"&&!q[fe])if(Ae||Ce)try{be(Oe)}catch{}else try{Oe.setAttribute(fe,"")}catch{}},Pe=function(fe){let Oe,Me;if(pe)fe="<remove></remove>"+fe;else{const ut=gi(fe,/^[\r\n\t ]+/);Me=ut&&ut[0]}Ee==="application/xhtml+xml"&&ie===X&&(fe='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+fe+"</body></html>");const Xe=E?E.createHTML(fe):fe;if(ie===X)try{Oe=new b().parseFromString(Xe,Ee)}catch{}if(!Oe||!Oe.documentElement){Oe=A.createDocument(ie,"template",null);try{Oe.documentElement.innerHTML=re?T:Xe}catch{}}const ot=Oe.body||Oe.documentElement;return fe&&Me&&ot.insertBefore(P.createTextNode(Me),ot.childNodes[0]||null),ie===X?p.call(Oe,Le?"html":"body")[0]:Le?Oe.documentElement:ot},Ve=function(fe){return f.call(fe.ownerDocument||fe,fe,d.SHOW_ELEMENT|d.SHOW_COMMENT|d.SHOW_TEXT,null,!1)},Qe=function(fe){return fe instanceof _&&(typeof fe.nodeName!="string"||typeof fe.textContent!="string"||typeof fe.removeChild!="function"||!(fe.attributes instanceof v)||typeof fe.removeAttribute!="function"||typeof fe.setAttribute!="function"||typeof fe.namespaceURI!="string"||typeof fe.insertBefore!="function"||typeof fe.hasChildNodes!="function")},rt=function(fe){return typeof D=="object"?fe instanceof D:fe&&typeof fe=="object"&&typeof fe.nodeType=="number"&&typeof fe.nodeName=="string"},it=function(fe,Oe,Me){U[fe]&&fi(U[fe],Xe=>{Xe.call(t,Oe,Me,Fe)})},ht=function(fe){let Oe;if(it("beforeSanitizeElements",fe,null),Qe(fe))return be(fe),!0;const Me=de(fe.nodeName);if(it("uponSanitizeElement",fe,{tagName:Me,allowedTags:Q}),fe.hasChildNodes()&&!rt(fe.firstElementChild)&&(!rt(fe.content)||!rt(fe.content.firstElementChild))&&gt(/<[/\w]/g,fe.innerHTML)&&gt(/<[/\w]/g,fe.textContent))return be(fe),!0;if(!Q[Me]||me[Me]){if(!me[Me]&&ft(Me)&&(le.tagNameCheck instanceof RegExp&&gt(le.tagNameCheck,Me)||le.tagNameCheck instanceof Function&&le.tagNameCheck(Me)))return!1;if(B&&!g[Me]){const Xe=l(fe)||fe.parentNode,ot=c(fe)||fe.childNodes;if(ot&&Xe){const ut=ot.length;for(let Je=ut-1;Je>=0;--Je)Xe.insertBefore(s(ot[Je],!0),r(fe))}}return be(fe),!0}return fe instanceof w&&!ue(fe)||(Me==="noscript"||Me==="noembed"||Me==="noframes")&&gt(/<\/no(script|embed|frames)/i,fe.innerHTML)?(be(fe),!0):(ae&&fe.nodeType===3&&(Oe=fe.textContent,Oe=vt(Oe,H," "),Oe=vt(Oe,x," "),Oe=vt(Oe,y," "),fe.textContent!==Oe&&(At(t.removed,{element:fe.cloneNode()}),fe.textContent=Oe)),it("afterSanitizeElements",fe,null),!1)},nt=function(fe,Oe,Me){if(xe&&(Oe==="id"||Oe==="name")&&(Me in P||Me in qe))return!1;if(!(ne&&!_e[Oe]&&gt(O,Oe))){if(!(Ne&&gt(V,Oe))){if(!q[Oe]||_e[Oe]){if(!(ft(fe)&&(le.tagNameCheck instanceof RegExp&&gt(le.tagNameCheck,fe)||le.tagNameCheck instanceof Function&&le.tagNameCheck(fe))&&(le.attributeNameCheck instanceof RegExp&&gt(le.attributeNameCheck,Oe)||le.attributeNameCheck instanceof Function&&le.attributeNameCheck(Oe))||Oe==="is"&&le.allowCustomizedBuiltInElements&&(le.tagNameCheck instanceof RegExp&&gt(le.tagNameCheck,Me)||le.tagNameCheck instanceof Function&&le.tagNameCheck(Me))))return!1}else if(!N[Oe]){if(!gt(G,vt(Me,W,""))){if(!((Oe==="src"||Oe==="xlink:href"||Oe==="href")&&fe!=="script"&&mi(Me,"data:")===0&&L[fe])){if(!(ee&&!gt(R,vt(Me,W,"")))){if(Me)return!1}}}}}}return!0},ft=function(fe){return fe.indexOf("-")>0},dt=function(fe){let Oe,Me,Xe,ot;it("beforeSanitizeAttributes",fe,null);const{attributes:ut}=fe;if(!ut)return;const Je={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:q};for(ot=ut.length;ot--;){Oe=ut[ot];const{name:pt,namespaceURI:yt}=Oe;if(Me=pt==="value"?Oe.value:pi(Oe.value),Xe=de(pt),Je.attrName=Xe,Je.attrValue=Me,Je.keepAttr=!0,Je.forceKeepAttr=void 0,it("uponSanitizeAttribute",fe,Je),Me=Je.attrValue,Je.forceKeepAttr||(Te(pt,fe),!Je.keepAttr))continue;if(!he&&gt(/\/>/i,Me)){Te(pt,fe);continue}ae&&(Me=vt(Me,H," "),Me=vt(Me,x," "),Me=vt(Me,y," "));const Ct=de(fe.nodeName);if(nt(Ct,Xe,Me)){if(He&&(Xe==="id"||Xe==="name")&&(Te(pt,fe),Me=$+Me),E&&typeof m=="object"&&typeof m.getAttributeType=="function"&&!yt)switch(m.getAttributeType(Ct,Xe)){case"TrustedHTML":{Me=E.createHTML(Me);break}case"TrustedScriptURL":{Me=E.createScriptURL(Me);break}}try{yt?fe.setAttributeNS(yt,pt,Me):fe.setAttribute(pt,Me),Vt(t.removed)}catch{}}}it("afterSanitizeAttributes",fe,null)},Dt=function ze(fe){let Oe;const Me=Ve(fe);for(it("beforeSanitizeShadowDOM",fe,null);Oe=Me.nextNode();)it("uponSanitizeShadowNode",Oe,null),!ht(Oe)&&(Oe.content instanceof F&&ze(Oe.content),dt(Oe));it("afterSanitizeShadowDOM",fe,null)};return t.sanitize=function(ze){let fe=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Oe,Me,Xe,ot;if(re=!ze,re&&(ze="<!-->"),typeof ze!="string"&&!rt(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw Tt("dirty is not a string, aborting")}else throw Tt("toString is not a function");if(!t.isSupported)return ze;if(te||tt(fe),t.removed=[],typeof ze=="string"&&(a=!1),a){if(ze.nodeName){const pt=de(ze.nodeName);if(!Q[pt]||me[pt])throw Tt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof D)Oe=Pe("<!---->"),Me=Oe.ownerDocument.importNode(ze,!0),Me.nodeType===1&&Me.nodeName==="BODY"||Me.nodeName==="HTML"?Oe=Me:Oe.appendChild(Me);else{if(!Ae&&!ae&&!Le&&ze.indexOf("<")===-1)return E&&Re?E.createHTML(ze):ze;if(Oe=Pe(ze),!Oe)return Ae?null:Re?T:""}Oe&&pe&&be(Oe.firstChild);const ut=Ve(a?ze:Oe);for(;Xe=ut.nextNode();)ht(Xe)||(Xe.content instanceof F&&Dt(Xe.content),dt(Xe));if(a)return ze;if(Ae){if(Ce)for(ot=h.call(Oe.ownerDocument);Oe.firstChild;)ot.appendChild(Oe.firstChild);else ot=Oe;return(q.shadowroot||q.shadowrootmode)&&(ot=S.call(i,ot,!0)),ot}let Je=Le?Oe.outerHTML:Oe.innerHTML;return Le&&Q["!doctype"]&&Oe.ownerDocument&&Oe.ownerDocument.doctype&&Oe.ownerDocument.doctype.name&&gt(Yt,Oe.ownerDocument.doctype.name)&&(Je="<!DOCTYPE "+Oe.ownerDocument.doctype.name+`>
`+Je),ae&&(Je=vt(Je,H," "),Je=vt(Je,x," "),Je=vt(Je,y," ")),E&&Re?E.createHTML(Je):Je},t.setConfig=function(ze){tt(ze),te=!0},t.clearConfig=function(){Fe=null,te=!1},t.isValidAttribute=function(ze,fe,Oe){Fe||tt({});const Me=de(ze),Xe=de(fe);return nt(Me,Xe,Oe)},t.addHook=function(ze,fe){typeof fe=="function"&&(U[ze]=U[ze]||[],At(U[ze],fe))},t.removeHook=function(ze){if(U[ze])return Vt(U[ze])},t.removeHooks=function(ze){U[ze]&&(U[ze]=[])},t.removeAllHooks=function(){U={}},t}var Ni=Zt();define("vs/base/browser/dompurify/dompurify",function(){return Ni}),define(ve[55],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FastDomNode=void 0,t.createFastDomNode=P;class i{constructor(I){this.domNode=I,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(I){const D=n(I);this._maxWidth!==D&&(this._maxWidth=D,this.domNode.style.maxWidth=this._maxWidth)}setWidth(I){const D=n(I);this._width!==D&&(this._width=D,this.domNode.style.width=this._width)}setHeight(I){const D=n(I);this._height!==D&&(this._height=D,this.domNode.style.height=this._height)}setTop(I){const D=n(I);this._top!==D&&(this._top=D,this.domNode.style.top=this._top)}setLeft(I){const D=n(I);this._left!==D&&(this._left=D,this.domNode.style.left=this._left)}setBottom(I){const D=n(I);this._bottom!==D&&(this._bottom=D,this.domNode.style.bottom=this._bottom)}setRight(I){const D=n(I);this._right!==D&&(this._right=D,this.domNode.style.right=this._right)}setPaddingTop(I){const D=n(I);this._paddingTop!==D&&(this._paddingTop=D,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(I){const D=n(I);this._paddingLeft!==D&&(this._paddingLeft=D,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(I){const D=n(I);this._paddingBottom!==D&&(this._paddingBottom=D,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(I){const D=n(I);this._paddingRight!==D&&(this._paddingRight=D,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(I){this._fontFamily!==I&&(this._fontFamily=I,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(I){this._fontWeight!==I&&(this._fontWeight=I,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(I){const D=n(I);this._fontSize!==D&&(this._fontSize=D,this.domNode.style.fontSize=this._fontSize)}setFontStyle(I){this._fontStyle!==I&&(this._fontStyle=I,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(I){this._fontFeatureSettings!==I&&(this._fontFeatureSettings=I,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(I){this._fontVariationSettings!==I&&(this._fontVariationSettings=I,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(I){this._textDecoration!==I&&(this._textDecoration=I,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(I){const D=n(I);this._lineHeight!==D&&(this._lineHeight=D,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(I){const D=n(I);this._letterSpacing!==D&&(this._letterSpacing=D,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(I){this._className!==I&&(this._className=I,this.domNode.className=this._className)}toggleClassName(I,D){this.domNode.classList.toggle(I,D),this._className=this.domNode.className}setDisplay(I){this._display!==I&&(this._display=I,this.domNode.style.display=this._display)}setPosition(I){this._position!==I&&(this._position=I,this.domNode.style.position=this._position)}setVisibility(I){this._visibility!==I&&(this._visibility=I,this.domNode.style.visibility=this._visibility)}setColor(I){this._color!==I&&(this._color=I,this.domNode.style.color=this._color)}setBackgroundColor(I){this._backgroundColor!==I&&(this._backgroundColor=I,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(I){this._layerHint!==I&&(this._layerHint=I,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(I){this._boxShadow!==I&&(this._boxShadow=I,this.domNode.style.boxShadow=I)}setContain(I){this._contain!==I&&(this._contain=I,this.domNode.style.contain=this._contain)}setAttribute(I,D){this.domNode.setAttribute(I,D)}removeAttribute(I){this.domNode.removeAttribute(I)}appendChild(I){this.domNode.appendChild(I.domNode)}removeChild(I){this.domNode.removeChild(I.domNode)}}t.FastDomNode=i;function n(F){return typeof F=="number"?`${F}px`:F}function P(F){return new i(F)}}),define(ve[85],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0,t.parentOriginHash=F;const i=new WeakMap;function n(D){if(!D.parent||D.parent===D)return null;try{const w=D.location,d=D.parent.location;if(w.origin!=="null"&&d.origin!=="null"&&w.origin!==d.origin)return null}catch{return null}return D.parent}class P{static getSameOriginWindowChain(w){let d=i.get(w);if(!d){d=[],i.set(w,d);let v=w,_;do _=n(v),_?d.push({window:new WeakRef(v),iframeElement:v.frameElement||null}):d.push({window:new WeakRef(v),iframeElement:null}),v=_;while(v)}return d.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(w,d){if(!d||w===d)return{top:0,left:0};let v=0,_=0;const b=this.getSameOriginWindowChain(w);for(const m of b){const e=m.window.deref();if(v+=e?.scrollY??0,_+=e?.scrollX??0,e===d||!m.iframeElement)break;const s=m.iframeElement.getBoundingClientRect();v+=s.top,_+=s.left}return{top:v,left:_}}}t.IframeUtils=P;async function F(D,w){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const d=JSON.stringify({parentOrigin:D,salt:w}),_=new TextEncoder().encode(d),b=await crypto.subtle.digest("sha-256",_);return I(b)}function I(D){const d=Array.from(new Uint8Array(D)).map(v=>v.toString(16).padStart(2,"0")).join("");return BigInt(`0x${d}`).toString(32).padStart(52,"0")}}),define(ve[33],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setBaseLayerHoverDelegate=n,t.getBaseLayerHoverDelegate=P;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupManagedHover:()=>null,showManagedHover:()=>{}};function n(F){i=F}function P(){return i}}),define(ve[41],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(I){I[I.Copy=0]="Copy",I[I.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var n;(function(I){I.Over="drop-target",I.Before="drop-target-before",I.After="drop-target-after"})(n||(t.ListDragOverEffectPosition=n={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class P extends Error{constructor(D,w){super(`ListError [${D}] ${w}`)}}t.ListError=P;class F{constructor(){this.cache=new WeakMap}getHeight(D){return this.cache.get(D)??this.estimateHeight(D)}setDynamicHeight(D,w){w>0&&this.cache.set(D,w)}}t.CachedListVirtualDelegate=F}),define(ve[86],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class i{constructor(P){this.spliceables=P}splice(P,F,I){this.spliceables.forEach(D=>D.splice(P,F,I))}}t.CombinedSpliceable=i}),define(ve[56],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const i=20;class n{constructor(F,I,D,w,d,v){this._scrollbarSize=Math.round(I),this._oppositeScrollbarSize=Math.round(D),this._arrowSize=Math.round(F),this._visibleSize=w,this._scrollSize=d,this._scrollPosition=v,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new n(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(F){const I=Math.round(F);return this._visibleSize!==I?(this._visibleSize=I,this._refreshComputedValues(),!0):!1}setScrollSize(F){const I=Math.round(F);return this._scrollSize!==I?(this._scrollSize=I,this._refreshComputedValues(),!0):!1}setScrollPosition(F){const I=Math.round(F);return this._scrollPosition!==I?(this._scrollPosition=I,this._refreshComputedValues(),!0):!1}setScrollbarSize(F){this._scrollbarSize=Math.round(F)}setOppositeScrollbarSize(F){this._oppositeScrollbarSize=Math.round(F)}static _computeValues(F,I,D,w,d){const v=Math.max(0,D-F),_=Math.max(0,v-2*I),b=w>0&&w>D;if(!b)return{computedAvailableSize:Math.round(v),computedIsNeeded:b,computedSliderSize:Math.round(_),computedSliderRatio:0,computedSliderPosition:0};const m=Math.round(Math.max(i,Math.floor(D*_/w))),e=(_-m)/(w-D),s=d*e;return{computedAvailableSize:Math.round(v),computedIsNeeded:b,computedSliderSize:Math.round(m),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}_refreshComputedValues(){const F=n._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=F.computedAvailableSize,this._computedIsNeeded=F.computedIsNeeded,this._computedSliderSize=F.computedSliderSize,this._computedSliderRatio=F.computedSliderRatio,this._computedSliderPosition=F.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(F){if(!this._computedIsNeeded)return 0;const I=F-this._arrowSize-this._computedSliderSize/2;return Math.round(I/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(F){if(!this._computedIsNeeded)return 0;const I=F-this._arrowSize;let D=this._scrollPosition;return I<this._computedSliderPosition?D-=this._visibleSize:D+=this._visibleSize,D}getDesiredScrollPositionFromDelta(F){if(!this._computedIsNeeded)return 0;const I=this._computedSliderPosition+F;return Math.round(I/this._computedSliderRatio)}}t.ScrollbarState=n}),define(ve[34],De([1,0,41]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(d){d[d.Hidden=0]="Hidden",d[d.Visible=1]="Visible",d[d.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var P;(function(d){d[d.Expanded=0]="Expanded",d[d.Collapsed=1]="Collapsed",d[d.PreserveOrExpanded=2]="PreserveOrExpanded",d[d.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(P||(t.ObjectTreeElementCollapseState=P={}));var F;(function(d){d[d.Unknown=0]="Unknown",d[d.Twistie=1]="Twistie",d[d.Element=2]="Element",d[d.Filter=3]="Filter"})(F||(t.TreeMouseEventTarget=F={}));var I;(function(d){d[d.Down=0]="Down",d[d.Up=1]="Up"})(I||(t.TreeDragOverBubble=I={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:I.Up}},acceptBubbleDown(d=!1){return{accept:!0,bubble:I.Down,autoExpand:d}},acceptCopyBubbleUp(){return{accept:!0,bubble:I.Up,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over}}},acceptCopyBubbleDown(d=!1){return{accept:!0,bubble:I.Down,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over},autoExpand:d}}};class D extends Error{constructor(v,_){super(`TreeError [${v}] ${_}`)}}t.TreeError=D;class w{constructor(v){this.fn=v,this._map=new WeakMap}map(v){let _=this._map.get(v);return _||(_=this.fn(v),this._map.set(v,_)),_}}t.WeakMapper=w}),define(ve[24],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mainWindow=void 0,t.ensureCodeWindow=i,t.isAuxiliaryWindow=n;function i(P,F){const I=P;typeof I.vscodeWindowId!="number"&&Object.defineProperty(I,"vscodeWindowId",{get:()=>F})}t.mainWindow=window;function n(P){return P===t.mainWindow?!1:typeof P?.vscodeWindowId=="number"}}),define(ve[87],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=i,t.findLastIdx=n,t.findLastMonotonous=P,t.findLastIdxMonotonous=F,t.findFirstMonotonous=I,t.findFirstIdxMonotonousOrArrLen=D,t.findFirstIdxMonotonous=w,t.findFirstMax=v,t.findLastMax=_,t.findFirstMin=b,t.findMaxIdx=m,t.mapFindFirst=e;function i(s,r){const c=n(s,r);if(c!==-1)return s[c]}function n(s,r,c=s.length-1){for(let l=c;l>=0;l--){const E=s[l];if(r(E))return l}return-1}function P(s,r){const c=F(s,r);return c===-1?void 0:s[c]}function F(s,r,c=0,l=s.length){let E=c,T=l;for(;E<T;){const A=Math.floor((E+T)/2);r(s[A])?E=A+1:T=A}return E-1}function I(s,r){const c=D(s,r);return c===s.length?void 0:s[c]}function D(s,r,c=0,l=s.length){let E=c,T=l;for(;E<T;){const A=Math.floor((E+T)/2);r(s[A])?T=A:E=A+1}return E}function w(s,r,c=0,l=s.length){const E=D(s,r,c,l);return E===s.length?-1:E}class d{static{this.assertInvariants=!1}constructor(r){this._array=r,this._findLastMonotonousLastIdx=0}findLastMonotonous(r){if(d.assertInvariants){if(this._prevFindLastPredicate){for(const l of this._array)if(this._prevFindLastPredicate(l)&&!r(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=r}const c=F(this._array,r,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=c+1,c===-1?void 0:this._array[c]}}t.MonotonousArray=d;function v(s,r){if(s.length===0)return;let c=s[0];for(let l=1;l<s.length;l++){const E=s[l];r(E,c)>0&&(c=E)}return c}function _(s,r){if(s.length===0)return;let c=s[0];for(let l=1;l<s.length;l++){const E=s[l];r(E,c)>=0&&(c=E)}return c}function b(s,r){return v(s,(c,l)=>-r(c,l))}function m(s,r){if(s.length===0)return-1;let c=0;for(let l=1;l<s.length;l++){const E=s[l];r(E,s[c])>0&&(c=l)}return c}function e(s,r){for(const c of s){const l=r(c);if(l!==void 0)return l}}}),define(ve[17],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var i;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(t.CharCode=i={}))}),define(ve[57],De([1,0]),function(oe,t){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.SetWithKey=void 0,t.groupBy=n,t.diffSets=P,t.diffMaps=F,t.intersection=I;function n(w,d){const v=Object.create(null);for(const _ of w){const b=d(_);let m=v[b];m||(m=v[b]=[]),m.push(_)}return v}function P(w,d){const v=[],_=[];for(const b of w)d.has(b)||v.push(b);for(const b of d)w.has(b)||_.push(b);return{removed:v,added:_}}function F(w,d){const v=[],_=[];for(const[b,m]of w)d.has(b)||v.push(m);for(const[b,m]of d)w.has(b)||_.push(m);return{removed:v,added:_}}function I(w,d){const v=new Set;for(const _ of d)w.has(_)&&v.add(_);return v}class D{static{i=Symbol.toStringTag}constructor(d,v){this.toKey=v,this._map=new Map,this[i]="SetWithKey";for(const _ of d)this.add(_)}get size(){return this._map.size}add(d){const v=this.toKey(d);return this._map.set(v,d),this}delete(d){return this._map.delete(this.toKey(d))}has(d){return this._map.has(this.toKey(d))}*entries(){for(const d of this._map.values())yield[d,d]}keys(){return this.values()}*values(){for(const d of this._map.values())yield d}clear(){this._map.clear()}forEach(d,v){this._map.forEach(_=>d.call(v,_,_,this))}[Symbol.iterator](){return this.values()}}t.SetWithKey=D}),define(ve[88],De([1,0,17]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function n(w,d){const v=Math.pow(10,d);return Math.round(w*v)/v}class P{constructor(d,v,_,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,v))|0,this.b=Math.min(255,Math.max(0,_))|0,this.a=n(Math.max(Math.min(1,b),0),3)}static equals(d,v){return d.r===v.r&&d.g===v.g&&d.b===v.b&&d.a===v.a}}t.RGBA=P;class F{constructor(d,v,_,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,v),0),3),this.l=n(Math.max(Math.min(1,_),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(d,v){return d.h===v.h&&d.s===v.s&&d.l===v.l&&d.a===v.a}static fromRGBA(d){const v=d.r/255,_=d.g/255,b=d.b/255,m=d.a,e=Math.max(v,_,b),s=Math.min(v,_,b);let r=0,c=0;const l=(s+e)/2,E=e-s;if(E>0){switch(c=Math.min(l<=.5?E/(2*l):E/(2-2*l),1),e){case v:r=(_-b)/E+(_<b?6:0);break;case _:r=(b-v)/E+2;break;case b:r=(v-_)/E+4;break}r*=60,r=Math.round(r)}return new F(r,c,l,m)}static _hue2rgb(d,v,_){return _<0&&(_+=1),_>1&&(_-=1),_<1/6?d+(v-d)*6*_:_<1/2?v:_<2/3?d+(v-d)*(2/3-_)*6:d}static toRGBA(d){const v=d.h/360,{s:_,l:b,a:m}=d;let e,s,r;if(_===0)e=s=r=b;else{const c=b<.5?b*(1+_):b+_-b*_,l=2*b-c;e=F._hue2rgb(l,c,v+1/3),s=F._hue2rgb(l,c,v),r=F._hue2rgb(l,c,v-1/3)}return new P(Math.round(e*255),Math.round(s*255),Math.round(r*255),m)}}t.HSLA=F;class I{constructor(d,v,_,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,v),0),3),this.v=n(Math.max(Math.min(1,_),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(d,v){return d.h===v.h&&d.s===v.s&&d.v===v.v&&d.a===v.a}static fromRGBA(d){const v=d.r/255,_=d.g/255,b=d.b/255,m=Math.max(v,_,b),e=Math.min(v,_,b),s=m-e,r=m===0?0:s/m;let c;return s===0?c=0:m===v?c=((_-b)/s%6+6)%6:m===_?c=(b-v)/s+2:c=(v-_)/s+4,new I(Math.round(c*60),r,m,d.a)}static toRGBA(d){const{h:v,s:_,v:b,a:m}=d,e=b*_,s=e*(1-Math.abs(v/60%2-1)),r=b-e;let[c,l,E]=[0,0,0];return v<60?(c=e,l=s):v<120?(c=s,l=e):v<180?(l=e,E=s):v<240?(l=s,E=e):v<300?(c=s,E=e):v<=360&&(c=e,E=s),c=Math.round((c+r)*255),l=Math.round((l+r)*255),E=Math.round((E+r)*255),new P(c,l,E,m)}}t.HSVA=I;class D{static fromHex(d){return D.Format.CSS.parseHex(d)||D.red}static equals(d,v){return!d&&!v?!0:!d||!v?!1:d.equals(v)}get hsla(){return this._hsla?this._hsla:F.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:I.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof P)this.rgba=d;else if(d instanceof F)this._hsla=d,this.rgba=F.toRGBA(d);else if(d instanceof I)this._hsva=d,this.rgba=I.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&P.equals(this.rgba,d.rgba)&&F.equals(this.hsla,d.hsla)&&I.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=D._relativeLuminanceForComponent(this.rgba.r),v=D._relativeLuminanceForComponent(this.rgba.g),_=D._relativeLuminanceForComponent(this.rgba.b),b=.2126*d+.7152*v+.0722*_;return n(b,4)}static _relativeLuminanceForComponent(d){const v=d/255;return v<=.03928?v/12.92:Math.pow((v+.055)/1.055,2.4)}getContrastRatio(d){const v=this.getRelativeLuminance(),_=d.getRelativeLuminance();return v>_?(v+.05)/(_+.05):(_+.05)/(v+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const v=this.getRelativeLuminance(),_=d.getRelativeLuminance();return v>_}isDarkerThan(d){const v=this.getRelativeLuminance(),_=d.getRelativeLuminance();return v<_}lighten(d){return new D(new F(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new D(new F(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:v,g:_,b,a:m}=this.rgba;return new D(new P(v,_,b,m*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const v=d.rgba,_=this.rgba.a,b=v.a,m=_+b*(1-_);if(m<1e-6)return D.transparent;const e=this.rgba.r*_/m+v.r*b*(1-_)/m,s=this.rgba.g*_/m+v.g*b*(1-_)/m,r=this.rgba.b*_/m+v.b*b*(1-_)/m;return new D(new P(e,s,r,m))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:v,g:_,b,a:m}=this.rgba;return new D(new P(d.rgba.r-m*(d.rgba.r-v),d.rgba.g-m*(d.rgba.g-_),d.rgba.b-m*(d.rgba.b-b),1))}flatten(...d){const v=d.reduceRight((_,b)=>D._flatten(b,_));return D._flatten(this,v)}static _flatten(d,v){const _=1-d.rgba.a;return new D(new P(_*v.rgba.r+d.rgba.a*d.rgba.r,_*v.rgba.g+d.rgba.a*d.rgba.g,_*v.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(d,v,_){if(d.isLighterThan(v))return d;_=_||.5;const b=d.getRelativeLuminance(),m=v.getRelativeLuminance();return _=_*(m-b)/m,d.lighten(_)}static getDarkerColor(d,v,_){if(d.isDarkerThan(v))return d;_=_||.5;const b=d.getRelativeLuminance(),m=v.getRelativeLuminance();return _=_*(b-m)/b,d.darken(_)}static{this.white=new D(new P(255,255,255,1))}static{this.black=new D(new P(0,0,0,1))}static{this.red=new D(new P(255,0,0,1))}static{this.blue=new D(new P(0,0,255,1))}static{this.green=new D(new P(0,255,0,1))}static{this.cyan=new D(new P(0,255,255,1))}static{this.lightgrey=new D(new P(211,211,211,1))}static{this.transparent=new D(new P(0,0,0,0))}}t.Color=D,function(w){let d;(function(v){let _;(function(b){function m(h){return h.rgba.a===1?`rgb(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b})`:w.Format.CSS.formatRGBA(h)}b.formatRGB=m;function e(h){return`rgba(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b}, ${+h.rgba.a.toFixed(2)})`}b.formatRGBA=e;function s(h){return h.hsla.a===1?`hsl(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(h)}b.formatHSL=s;function r(h){return`hsla(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%, ${h.hsla.a.toFixed(2)})`}b.formatHSLA=r;function c(h){const p=h.toString(16);return p.length!==2?"0"+p:p}function l(h){return`#${c(h.rgba.r)}${c(h.rgba.g)}${c(h.rgba.b)}`}b.formatHex=l;function E(h,p=!1){return p&&h.rgba.a===1?w.Format.CSS.formatHex(h):`#${c(h.rgba.r)}${c(h.rgba.g)}${c(h.rgba.b)}${c(Math.round(h.rgba.a*255))}`}b.formatHexA=E;function T(h){return h.isOpaque()?w.Format.CSS.formatHex(h):w.Format.CSS.formatRGBA(h)}b.format=T;function A(h){const p=h.length;if(p===0||h.charCodeAt(0)!==i.CharCode.Hash)return null;if(p===7){const S=16*f(h.charCodeAt(1))+f(h.charCodeAt(2)),U=16*f(h.charCodeAt(3))+f(h.charCodeAt(4)),H=16*f(h.charCodeAt(5))+f(h.charCodeAt(6));return new w(new P(S,U,H,1))}if(p===9){const S=16*f(h.charCodeAt(1))+f(h.charCodeAt(2)),U=16*f(h.charCodeAt(3))+f(h.charCodeAt(4)),H=16*f(h.charCodeAt(5))+f(h.charCodeAt(6)),x=16*f(h.charCodeAt(7))+f(h.charCodeAt(8));return new w(new P(S,U,H,x/255))}if(p===4){const S=f(h.charCodeAt(1)),U=f(h.charCodeAt(2)),H=f(h.charCodeAt(3));return new w(new P(16*S+S,16*U+U,16*H+H))}if(p===5){const S=f(h.charCodeAt(1)),U=f(h.charCodeAt(2)),H=f(h.charCodeAt(3)),x=f(h.charCodeAt(4));return new w(new P(16*S+S,16*U+U,16*H+H,(16*x+x)/255))}return null}b.parseHex=A;function f(h){switch(h){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(_=v.CSS||(v.CSS={}))})(d=w.Format||(w.Format={}))}(D||(t.Color=D={}))}),define(ve[35],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.memoize=n,t.debounce=P,t.throttle=F;function i(I){return(D,w,d)=>{let v=null,_=null;if(typeof d.value=="function"?(v="value",_=d.value):typeof d.get=="function"&&(v="get",_=d.get),!_)throw new Error("not supported");d[v]=I(_,w)}}function n(I,D,w){let d=null,v=null;if(typeof w.value=="function"?(d="value",v=w.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(d="get",v=w.get),!v)throw new Error("not supported");const _=`$memoize$${D}`;w[d]=function(...b){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,b)}),this[_]}}function P(I,D,w){return i((d,v)=>{const _=`$debounce$${v}`,b=`$debounce$result$${v}`;return function(...m){this[b]||(this[b]=w?w():void 0),clearTimeout(this[_]),D&&(this[b]=D(this[b],...m),m=[this[b]]),this[_]=setTimeout(()=>{d.apply(this,m),this[b]=w?w():void 0},I)}})}function F(I,D,w){return i((d,v)=>{const _=`$throttle$timer$${v}`,b=`$throttle$result$${v}`,m=`$throttle$lastRun$${v}`,e=`$throttle$pending$${v}`;return function(...s){if(this[b]||(this[b]=w?w():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),D&&(this[b]=D(this[b],...s)),this[e])return;const r=this[m]+I;r<=Date.now()?(this[m]=Date.now(),d.apply(this,[this[b]]),this[b]=w?w():void 0):(this[e]=!0,this[_]=setTimeout(()=>{this[e]=!1,this[m]=Date.now(),d.apply(this,[this[b]]),this[b]=w?w():void 0},r-Date.now()))}})}}),define(ve[89],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class i{constructor(P,F,I,D){this.originalStart=P,this.originalLength=F,this.modifiedStart=I,this.modifiedLength=D}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=i}),define(ve[6],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=n,t.isSigPipeError=P,t.onUnexpectedError=F,t.onUnexpectedExternalError=I,t.transformErrorForSerialization=D,t.transformErrorFromSerialization=w,t.isCancellationError=v,t.canceled=b,t.illegalArgument=m,t.illegalState=e,t.getErrorMessage=r;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(h){setTimeout(()=>{throw h.stack?T.isErrorNoTelemetry(h)?new T(h.message+`

`+h.stack):new Error(h.message+`

`+h.stack):h},0)}}addListener(h){return this.listeners.push(h),()=>{this._removeListener(h)}}emit(h){this.listeners.forEach(p=>{p(h)})}_removeListener(h){this.listeners.splice(this.listeners.indexOf(h),1)}setUnexpectedErrorHandler(h){this.unexpectedErrorHandler=h}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(h){this.unexpectedErrorHandler(h),this.emit(h)}onUnexpectedExternalError(h){this.unexpectedErrorHandler(h)}}t.ErrorHandler=i,t.errorHandler=new i;function n(f){t.errorHandler.setUnexpectedErrorHandler(f)}function P(f){if(!f||typeof f!="object")return!1;const h=f;return h.code==="EPIPE"&&h.syscall?.toUpperCase()==="WRITE"}function F(f){v(f)||t.errorHandler.onUnexpectedError(f)}function I(f){v(f)||t.errorHandler.onUnexpectedExternalError(f)}function D(f){if(f instanceof Error){const{name:h,message:p}=f,S=f.stacktrace||f.stack;return{$isError:!0,name:h,message:p,stack:S,noTelemetry:T.isErrorNoTelemetry(f)}}return f}function w(f){let h;return f.noTelemetry?h=new T:(h=new Error,h.name=f.name),h.message=f.message,h.stack=f.stack,h}const d="Canceled";function v(f){return f instanceof _?!0:f instanceof Error&&f.name===d&&f.message===d}class _ extends Error{constructor(){super(d),this.name=this.message}}t.CancellationError=_;function b(){const f=new Error(d);return f.name=f.message,f}function m(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}function e(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}class s extends TypeError{constructor(h){super(h?`${h} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=s;function r(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}class c extends Error{constructor(h){super("NotImplemented"),h&&(this.message=h)}}t.NotImplementedError=c;class l extends Error{constructor(h){super("NotSupported"),h&&(this.message=h)}}t.NotSupportedError=l;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=E;class T extends Error{constructor(h){super(h),this.name="CodeExpectedError"}static fromError(h){if(h instanceof T)return h;const p=new T;return p.message=h.message,p.stack=h.stack,p}static isErrorNoTelemetry(h){return h.name==="CodeExpectedError"}}t.ErrorNoTelemetry=T;class A extends Error{constructor(h){super(h||"An unexpected bug occurred."),Object.setPrototypeOf(this,A.prototype)}}t.BugIndicatingError=A}),define(ve[9],De([1,0,6,87]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=P,t.tail2=F,t.equals=I,t.removeFastWithoutKeepingOrder=D,t.binarySearch=w,t.binarySearch2=d,t.quickSelect=v,t.groupBy=_,t.groupAdjacentBy=b,t.forEachAdjacent=m,t.forEachWithNeighbors=e,t.sortedDiff=s,t.delta=r,t.top=c,t.topAsync=l,t.coalesce=T,t.coalesceInPlace=A,t.move=f,t.isFalsyOrEmpty=h,t.isNonEmptyArray=p,t.distinct=S,t.uniqueFilter=U,t.firstOrDefault=H,t.lastOrDefault=x,t.commonPrefixLength=y,t.range=O,t.index=V,t.insert=R,t.remove=W,t.arrayInsert=G,t.shuffle=Q,t.pushToStart=j,t.pushToEnd=q,t.pushMany=J,t.mapArrayOrNot=le,t.asArray=me,t.getRandomElement=_e,t.insertInto=Ne,t.splice=ne,t.compareBy=ae,t.tieBreakComparators=Le,t.reverseOrder=Ae,t.findAsync=He;function P($,B=0){return $[$.length-(1+B)]}function F($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}function I($,B,a=(o,g)=>o===g){if($===B)return!0;if(!$||!B||$.length!==B.length)return!1;for(let o=0,g=$.length;o<g;o++)if(!a($[o],B[o]))return!1;return!0}function D($,B){const a=$.length-1;B<a&&($[B]=$[a]),$.pop()}function w($,B,a){return d($.length,o=>a($[o],B))}function d($,B){let a=0,o=$-1;for(;a<=o;){const g=(a+o)/2|0,k=B(g);if(k<0)a=g+1;else if(k>0)o=g-1;else return g}return-(a+1)}function v($,B,a){if($=$|0,$>=B.length)throw new TypeError("invalid index");const o=B[Math.floor(B.length*Math.random())],g=[],k=[],L=[];for(const u of B){const N=a(u,o);N<0?g.push(u):N>0?k.push(u):L.push(u)}return $<g.length?v($,g,a):$<g.length+L.length?L[0]:v($-(g.length+L.length),k,a)}function _($,B){const a=[];let o;for(const g of $.slice(0).sort(B))!o||B(o[0],g)!==0?(o=[g],a.push(o)):o.push(g);return a}function*b($,B){let a,o;for(const g of $)o!==void 0&&B(o,g)?a.push(g):(a&&(yield a),a=[g]),o=g;a&&(yield a)}function m($,B){for(let a=0;a<=$.length;a++)B(a===0?void 0:$[a-1],a===$.length?void 0:$[a])}function e($,B){for(let a=0;a<$.length;a++)B(a===0?void 0:$[a-1],$[a],a+1===$.length?void 0:$[a+1])}function s($,B,a){const o=[];function g(u,N,C){if(N===0&&C.length===0)return;const M=o[o.length-1];M&&M.start+M.deleteCount===u?(M.deleteCount+=N,M.toInsert.push(...C)):o.push({start:u,deleteCount:N,toInsert:C})}let k=0,L=0;for(;;){if(k===$.length){g(k,0,B.slice(L));break}if(L===B.length){g(k,$.length-k,[]);break}const u=$[k],N=B[L],C=a(u,N);C===0?(k+=1,L+=1):C<0?(g(k,1,[]),k+=1):C>0&&(g(k,0,[N]),L+=1)}return o}function r($,B,a){const o=s($,B,a),g=[],k=[];for(const L of o)g.push(...$.slice(L.start,L.start+L.deleteCount)),k.push(...L.toInsert);return{removed:g,added:k}}function c($,B,a){if(a===0)return[];const o=$.slice(0,a).sort(B);return E($,B,o,a,$.length),o}function l($,B,a,o,g){return a===0?Promise.resolve([]):new Promise((k,L)=>{(async()=>{const u=$.length,N=$.slice(0,a).sort(B);for(let C=a,M=Math.min(a+o,u);C<u;C=M,M=Math.min(M+o,u)){if(C>a&&await new Promise(z=>setTimeout(z)),g&&g.isCancellationRequested)throw new i.CancellationError;E($,B,N,C,M)}return N})().then(k,L)})}function E($,B,a,o,g){for(const k=a.length;o<g;o++){const L=$[o];if(B(L,a[k-1])<0){a.pop();const u=(0,n.findFirstIdxMonotonousOrArrLen)(a,N=>B(L,N)<0);a.splice(u,0,L)}}}function T($){return $.filter(B=>!!B)}function A($){let B=0;for(let a=0;a<$.length;a++)$[a]&&($[B]=$[a],B+=1);$.length=B}function f($,B,a){$.splice(a,0,$.splice(B,1)[0])}function h($){return!Array.isArray($)||$.length===0}function p($){return Array.isArray($)&&$.length>0}function S($,B=a=>a){const a=new Set;return $.filter(o=>{const g=B(o);return a.has(g)?!1:(a.add(g),!0)})}function U($){const B=new Set;return a=>{const o=$(a);return B.has(o)?!1:(B.add(o),!0)}}function H($,B){return $.length>0?$[0]:B}function x($,B){return $.length>0?$[$.length-1]:B}function y($,B,a=(o,g)=>o===g){let o=0;for(let g=0,k=Math.min($.length,B.length);g<k&&a($[g],B[g]);g++)o++;return o}function O($,B){let a=typeof B=="number"?$:0;typeof B=="number"?a=$:(a=0,B=$);const o=[];if(a<=B)for(let g=a;g<B;g++)o.push(g);else for(let g=a;g>B;g--)o.push(g);return o}function V($,B,a){return $.reduce((o,g)=>(o[B(g)]=a?a(g):g,o),Object.create(null))}function R($,B){return $.push(B),()=>W($,B)}function W($,B){const a=$.indexOf(B);if(a>-1)return $.splice(a,1),B}function G($,B,a){const o=$.slice(0,B),g=$.slice(B);return o.concat(a,g)}function Q($,B){let a;if(typeof B=="number"){let o=B;a=()=>{const g=Math.sin(o++)*179426549;return g-Math.floor(g)}}else a=Math.random;for(let o=$.length-1;o>0;o-=1){const g=Math.floor(a()*(o+1)),k=$[o];$[o]=$[g],$[g]=k}}function j($,B){const a=$.indexOf(B);a>-1&&($.splice(a,1),$.unshift(B))}function q($,B){const a=$.indexOf(B);a>-1&&($.splice(a,1),$.push(B))}function J($,B){for(const a of B)$.push(a)}function le($,B){return Array.isArray($)?$.map(B):B($)}function me($){return Array.isArray($)?$:[$]}function _e($){return $[Math.floor(Math.random()*$.length)]}function Ne($,B,a){const o=ee($,B),g=$.length,k=a.length;$.length=g+k;for(let L=g-1;L>=o;L--)$[L+k]=$[L];for(let L=0;L<k;L++)$[L+o]=a[L]}function ne($,B,a,o){const g=ee($,B);let k=$.splice(g,a);return k===void 0&&(k=[]),Ne($,g,o),k}function ee($,B){return B<0?Math.max(B+$.length,0):Math.min(B,$.length)}var he;(function($){function B(k){return k<0}$.isLessThan=B;function a(k){return k<=0}$.isLessThanOrEqual=a;function o(k){return k>0}$.isGreaterThan=o;function g(k){return k===0}$.isNeitherLessOrGreaterThan=g,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(he||(t.CompareResult=he={}));function ae($,B){return(a,o)=>B($(a),$(o))}function Le(...$){return(B,a)=>{for(const o of $){const g=o(B,a);if(!he.isNeitherLessOrGreaterThan(g))return g}return he.neitherLessOrGreaterThan}}const te=($,B)=>$-B;t.numberComparator=te;const pe=($,B)=>(0,t.numberComparator)($?1:0,B?1:0);t.booleanComparator=pe;function Ae($){return(B,a)=>-$(B,a)}class Ce{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let a=this.firstIdx;for(;a<this.items.length&&B(this.items[a]);)a++;const o=a===this.firstIdx?null:this.items.slice(this.firstIdx,a);return this.firstIdx=a,o}takeFromEndWhile(B){let a=this.lastIdx;for(;a>=0&&B(this.items[a]);)a--;const o=a===this.lastIdx?null:this.items.slice(a+1,this.lastIdx+1);return this.lastIdx=a,o}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}removeLast(){const B=this.items[this.lastIdx];return this.lastIdx--,B}takeCount(B){const a=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,a}}t.ArrayQueue=Ce;class Re{static{this.empty=new Re(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(a=>(B(a),!0))}toArray(){const B=[];return this.iterate(a=>(B.push(a),!0)),B}filter(B){return new Re(a=>this.iterate(o=>B(o)?a(o):!0))}map(B){return new Re(a=>this.iterate(o=>a(B(o))))}some(B){let a=!1;return this.iterate(o=>(a=B(o),!a)),a}findFirst(B){let a;return this.iterate(o=>B(o)?(a=o,!1):!0),a}findLast(B){let a;return this.iterate(o=>(B(o)&&(a=o),!0)),a}findLastMaxBy(B){let a,o=!0;return this.iterate(g=>((o||he.isGreaterThan(B(g,a)))&&(o=!1,a=g),!0)),a}}t.CallbackIterable=Re;class xe{constructor(B){this._indexMap=B}static createSortPermutation(B,a){const o=Array.from(B.keys()).sort((g,k)=>a(B[g],B[k]));return new xe(o)}apply(B){return B.map((a,o)=>B[this._indexMap[o]])}inverse(){const B=this._indexMap.slice();for(let a=0;a<this._indexMap.length;a++)B[this._indexMap[a]]=a;return new xe(B)}}t.Permutation=xe;async function He($,B){return(await Promise.all($.map(async(o,g)=>({element:o,ok:await B(o,g)})))).find(o=>o.ok)?.element}}),define(ve[42],De([1,0,6]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=n,t.assertNever=P,t.assert=F,t.softAssert=I,t.assertFn=D,t.checkAdjacentItems=w;function n(d,v){if(!d)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}function P(d,v="Unreachable"){throw new Error(v)}function F(d,v="unexpected state"){if(!d)throw new i.BugIndicatingError(`Assertion Failed: ${v}`)}function I(d){d||(0,i.onUnexpectedError)(new i.BugIndicatingError("Soft Assertion Failed"))}function D(d){if(!d()){debugger;d(),(0,i.onUnexpectedError)(new i.BugIndicatingError("Assertion Failed"))}}function w(d,v){let _=0;for(;_<d.length-1;){const b=d[_],m=d[_+1];if(!v(b,m))return!1;_++}return!0}});var Fi=this&&this.__createBinding||(Object.create?function(oe,t,i,n){n===void 0&&(n=i);var P=Object.getOwnPropertyDescriptor(t,i);(!P||("get"in P?!t.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return t[i]}}),Object.defineProperty(oe,n,P)}:function(oe,t,i,n){n===void 0&&(n=i),oe[n]=t[i]}),Ri=this&&this.__setModuleDefault||(Object.create?function(oe,t){Object.defineProperty(oe,"default",{enumerable:!0,value:t})}:function(oe,t){oe.default=t}),Ue=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var t={};if(oe!=null)for(var i in oe)i!=="default"&&Object.prototype.hasOwnProperty.call(oe,i)&&Fi(t,oe,i);return Ri(t,oe),t};define(ve[30],De([1,0,9]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.strictEquals=void 0,t.itemsEquals=P,t.jsonStringifyEquals=F,t.itemEquals=I,t.equalsIfDefined=D,t.structuralEquals=w,t.getStructuralKey=d,i=Ue(i);const n=(m,e)=>m===e;t.strictEquals=n;function P(m=t.strictEquals){return(e,s)=>i.equals(e,s,m)}function F(){return(m,e)=>JSON.stringify(m)===JSON.stringify(e)}function I(){return(m,e)=>m.equals(e)}function D(m,e,s){if(s!==void 0){const r=m;return r==null||e===void 0||e===null?e===r:s(r,e)}else{const r=m;return(c,l)=>c==null||l===void 0||l===null?l===c:r(c,l)}}function w(m,e){if(m===e)return!0;if(Array.isArray(m)&&Array.isArray(e)){if(m.length!==e.length)return!1;for(let s=0;s<m.length;s++)if(!w(m[s],e[s]))return!1;return!0}if(m&&typeof m=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(m)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=m,r=e,c=Object.keys(s),l=Object.keys(r),E=new Set(l);if(c.length!==l.length)return!1;for(const T of c)if(!E.has(T)||!w(s[T],r[T]))return!1;return!0}return!1}function d(m){return JSON.stringify(b(m))}let v=0;const _=new WeakMap;function b(m){if(Array.isArray(m))return m.map(b);if(m&&typeof m=="object")if(Object.getPrototypeOf(m)===Object.prototype){const e=m,s=Object.create(null);for(const r of Object.keys(e).sort())s[r]=b(e[r]);return s}else{let e=_.get(m);return e===void 0&&(e=v++,_.set(m,e)),e+"----2b76a038c20c4bcc"}return m}}),define(ve[58],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=i;function i(n,P){const F=this;let I=!1,D;return function(){if(I)return D;if(I=!0,P)try{D=n.apply(F,arguments)}finally{P()}else D=n.apply(F,arguments);return D}}}),define(ve[90],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class i{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=i,t.defaultGenerator=new i("id#")}),define(ve[36],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(n){function P(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}n.is=P;const F=Object.freeze([]);function I(){return F}n.empty=I;function*D(h){yield h}n.single=D;function w(h){return P(h)?h:D(h)}n.wrap=w;function d(h){return h||F}n.from=d;function*v(h){for(let p=h.length-1;p>=0;p--)yield h[p]}n.reverse=v;function _(h){return!h||h[Symbol.iterator]().next().done===!0}n.isEmpty=_;function b(h){return h[Symbol.iterator]().next().value}n.first=b;function m(h,p){let S=0;for(const U of h)if(p(U,S++))return!0;return!1}n.some=m;function e(h,p){for(const S of h)if(p(S))return S}n.find=e;function*s(h,p){for(const S of h)p(S)&&(yield S)}n.filter=s;function*r(h,p){let S=0;for(const U of h)yield p(U,S++)}n.map=r;function*c(h,p){let S=0;for(const U of h)yield*p(U,S++)}n.flatMap=c;function*l(...h){for(const p of h)yield*p}n.concat=l;function E(h,p,S){let U=S;for(const H of h)U=p(U,H);return U}n.reduce=E;function*T(h,p,S=h.length){for(p<0&&(p+=h.length),S<0?S+=h.length:S>h.length&&(S=h.length);p<S;p++)yield h[p]}n.slice=T;function A(h,p=Number.POSITIVE_INFINITY){const S=[];if(p===0)return[S,h];const U=h[Symbol.iterator]();for(let H=0;H<p;H++){const x=U.next();if(x.done)return[S,n.empty()];S.push(x.value)}return[S,{[Symbol.iterator](){return U}}]}n.consume=A;async function f(h){const p=[];for await(const S of h)p.push(S);return Promise.resolve(p)}n.asyncToArray=f})(i||(t.Iterable=i={}))}),define(ve[91],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCompressedContent=i;function i(F){let I=!1;const D=new Map,w=new Map;if(P(F,s=>{if(F===s)return!0;const r=JSON.stringify(s);if(r.length<30)return!0;const c=D.get(r);if(!c){const l={schemas:[s]};return D.set(r,l),w.set(s,l),!0}return c.schemas.push(s),w.set(s,c),I=!0,!1}),D.clear(),!I)return JSON.stringify(F);let v="$defs";for(;F.hasOwnProperty(v);)v+="_";const _=[];function b(s){return JSON.stringify(s,(r,c)=>{if(c!==s){const l=w.get(c);if(l&&l.schemas.length>1)return l.id||(l.id=`_${_.length}`,_.push(l.schemas[0])),{$ref:`#/${v}/${l.id}`}}return c})}const m=b(F),e=[];for(let s=0;s<_.length;s++)e.push(`"_${s}":${b(_[s])}`);return e.length?`${m.substring(0,m.length-1)},"${v}":{${e.join(",")}}}`:m}function n(F){return typeof F=="object"&&F!==null}function P(F,I){if(!F||typeof F!="object")return;const D=(...m)=>{for(const e of m)n(e)&&_.push(e)},w=(...m)=>{for(const e of m)if(n(e))for(const s in e){const r=e[s];n(r)&&_.push(r)}},d=(...m)=>{for(const e of m)if(Array.isArray(e))for(const s of e)n(s)&&_.push(s)},v=m=>{if(Array.isArray(m))for(const e of m)n(e)&&_.push(e);else n(m)&&_.push(m)},_=[F];let b=_.pop();for(;b;)I(b)&&(D(b.additionalItems,b.additionalProperties,b.not,b.contains,b.propertyNames,b.if,b.then,b.else,b.unevaluatedItems,b.unevaluatedProperties),w(b.definitions,b.$defs,b.properties,b.patternProperties,b.dependencies,b.dependentSchemas),d(b.anyOf,b.allOf,b.oneOf,b.prefixItems),v(b.items)),b=_.pop()}}),define(ve[8],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0,t.KeyChord=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(t.ScanCode=n={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,r){this._keyCodeToStr[s]=r,this._strToKeyCode[r.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||i.Unknown}}const F=new P,I=new P,D=new P;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const w=[],d=Object.create(null),v=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>v[e]||n.None,toEnum:e=>d[e]||n.None,toString:e=>w[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=n.MAX_VALUE;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=i.DependsOnKbLayout;for(let e=0;e<=i.MAX_VALUE;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=n.DependsOnKbLayout;(function(){const e="",s=[[1,n.None,"None",i.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",i.Unknown,e,0,e,e,e],[1,n.Super,"Super",i.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",i.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",i.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",i.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",i.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",i.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",i.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",i.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",i.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",i.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",i.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",i.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",i.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",i.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",i.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",i.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",i.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",i.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",i.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",i.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",i.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",i.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",i.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",i.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",i.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",i.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",i.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",i.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",i.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",i.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",i.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",i.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",i.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",i.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",i.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",i.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",i.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",i.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",i.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",i.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",i.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",i.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",i.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",i.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",i.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",i.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",i.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",i.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",i.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",i.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",i.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",i.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",i.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",i.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",i.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",i.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",i.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",i.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",i.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",i.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",i.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",i.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",i.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",i.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",i.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",i.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",i.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",i.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",i.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",i.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",i.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",i.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",i.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",i.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",i.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",i.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",i.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",i.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",i.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",i.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",i.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",i.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",i.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",i.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",i.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",i.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",i.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",i.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",i.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",i.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",i.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",i.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",i.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",i.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",i.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",i.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",i.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",i.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",i.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",i.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",i.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",i.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",i.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",i.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",i.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",i.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",i.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",i.Unknown,e,0,e,e,e],[1,n.F13,"F13",i.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",i.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",i.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",i.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",i.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",i.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",i.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",i.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",i.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",i.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",i.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",i.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",i.Unknown,e,0,e,e,e],[1,n.Help,"Help",i.Unknown,e,0,e,e,e],[1,n.Select,"Select",i.Unknown,e,0,e,e,e],[1,n.Again,"Again",i.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",i.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",i.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",i.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",i.Unknown,e,0,e,e,e],[1,n.Find,"Find",i.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",i.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",i.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",i.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",i.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",i.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",i.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",i.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",i.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",i.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",i.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",i.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",i.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",i.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",i.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",i.Unknown,e,0,e,e,e],[1,n.Props,"Props",i.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",i.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",i.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",i.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",i.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",i.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",i.Unknown,e,0,e,e,e],[1,n.None,e,i.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,i.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,i.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,i.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",i.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",i.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",i.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",i.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",i.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",i.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",i.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",i.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",i.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",i.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",i.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",i.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",i.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",i.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",i.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",i.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",i.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",i.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",i.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",i.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",i.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",i.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",i.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",i.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",i.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",i.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",i.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",i.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",i.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",i.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",i.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",i.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",i.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",i.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",i.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",i.Unknown,e,0,e,e,e],[1,n.None,e,i.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,i.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,i.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,i.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,i.Unknown,e,0,"VK_OEM_CLEAR",e,e]],r=[],c=[];for(const l of s){const[E,T,A,f,h,p,S,U,H]=l;if(c[T]||(c[T]=!0,w[T]=A,d[A]=T,v[A.toLowerCase()]=T,E&&(t.IMMUTABLE_CODE_TO_KEY_CODE[T]=f,f!==i.Unknown&&f!==i.Enter&&f!==i.Ctrl&&f!==i.Shift&&f!==i.Alt&&f!==i.Meta&&(t.IMMUTABLE_KEY_CODE_TO_CODE[f]=T))),!r[f]){if(r[f]=!0,!h)throw new Error(`String representation missing for key code ${f} around scan code ${A}`);F.define(f,h),I.define(f,U||h),D.define(f,H||U||h)}p&&(t.EVENT_KEY_CODE_MAP[p]=f),S&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[S]=f)}t.IMMUTABLE_KEY_CODE_TO_CODE[i.Enter]=n.Enter})();var _;(function(e){function s(A){return F.keyCodeToStr(A)}e.toString=s;function r(A){return F.strToKeyCode(A)}e.fromString=r;function c(A){return I.keyCodeToStr(A)}e.toUserSettingsUS=c;function l(A){return D.keyCodeToStr(A)}e.toUserSettingsGeneral=l;function E(A){return I.strToKeyCode(A)||D.strToKeyCode(A)}e.fromUserSettings=E;function T(A){if(A>=i.Numpad0&&A<=i.NumpadDivide)return null;switch(A){case i.UpArrow:return"Up";case i.DownArrow:return"Down";case i.LeftArrow:return"Left";case i.RightArrow:return"Right"}return F.keyCodeToStr(A)}e.toElectronAccelerator=T})(_||(t.KeyCodeUtils=_={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function m(e,s){const r=(s&65535)<<16>>>0;return(e|r)>>>0}}),define(ve[25],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class i{constructor(P){this.executor=P,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=i}),define(ve[14],De([1,0,25]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setHoverDelegateFactory=D,t.getDefaultHoverDelegate=w,t.createInstantHoverDelegate=d;let P=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const F=new i.Lazy(()=>P("mouse",!1)),I=new i.Lazy(()=>P("element",!1));function D(v){P=v}function w(v){return v==="element"?I.value:F.value}function d(){return P("element",!0)}}),define(ve[59],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class i{static{this.Undefined=new i(void 0)}constructor(F){this.element=F,this.next=i.Undefined,this.prev=i.Undefined}}class n{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){let F=this._first;for(;F!==i.Undefined;){const I=F.next;F.prev=i.Undefined,F.next=i.Undefined,F=I}this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(F){return this._insert(F,!1)}push(F){return this._insert(F,!0)}_insert(F,I){const D=new i(F);if(this._first===i.Undefined)this._first=D,this._last=D;else if(I){const d=this._last;this._last=D,D.prev=d,d.next=D}else{const d=this._first;this._first=D,D.next=d,d.prev=D}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(D))}}shift(){if(this._first!==i.Undefined){const F=this._first.element;return this._remove(this._first),F}}pop(){if(this._last!==i.Undefined){const F=this._last.element;return this._remove(this._last),F}}_remove(F){if(F.prev!==i.Undefined&&F.next!==i.Undefined){const I=F.prev;I.next=F.next,F.next.prev=I}else F.prev===i.Undefined&&F.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):F.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):F.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let F=this._first;for(;F!==i.Undefined;)yield F.element,F=F.next}}t.LinkedList=n}),define(ve[43],De([1,0]),function(oe,t){"use strict";var i,n,P;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.MRUCache=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=F,t.mapToString=I,t.setToString=D,t.mapsStrictEqualIgnoreOrder=T;function F(A,f,h){let p=A.get(f);return p===void 0&&(p=h,A.set(f,p)),p}function I(A){const f=[];return A.forEach((h,p)=>{f.push(`${p} => ${h}`)}),`Map(${A.size}) {${f.join(", ")}}`}function D(A){const f=[];return A.forEach(h=>{f.push(h)}),`Set(${A.size}) {${f.join(", ")}}`}class w{constructor(f,h){this.uri=f,this.value=h}}function d(A){return Array.isArray(A)}class v{static{this.defaultToKey=f=>f.toString()}constructor(f,h){if(this[i]="ResourceMap",f instanceof v)this.map=new Map(f.map),this.toKey=h??v.defaultToKey;else if(d(f)){this.map=new Map,this.toKey=h??v.defaultToKey;for(const[p,S]of f)this.set(p,S)}else this.map=new Map,this.toKey=f??v.defaultToKey}set(f,h){return this.map.set(this.toKey(f),new w(f,h)),this}get(f){return this.map.get(this.toKey(f))?.value}has(f){return this.map.has(this.toKey(f))}get size(){return this.map.size}clear(){this.map.clear()}delete(f){return this.map.delete(this.toKey(f))}forEach(f,h){typeof h<"u"&&(f=f.bind(h));for(const[p,S]of this.map)f(S.value,S.uri,this)}*values(){for(const f of this.map.values())yield f.value}*keys(){for(const f of this.map.values())yield f.uri}*entries(){for(const f of this.map.values())yield[f.uri,f.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.map)yield[f.uri,f.value]}}t.ResourceMap=v;class _{constructor(f,h){this[n]="ResourceSet",!f||typeof f=="function"?this._map=new v(f):(this._map=new v(h),f.forEach(this.add,this))}get size(){return this._map.size}add(f){return this._map.set(f,f),this}clear(){this._map.clear()}delete(f){return this._map.delete(f)}forEach(f,h){this._map.forEach((p,S)=>f.call(h,S,S,this))}has(f){return this._map.has(f)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=_;var b;(function(A){A[A.None=0]="None",A[A.AsOld=1]="AsOld",A[A.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class m{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(f){return this._map.has(f)}get(f,h=b.None){const p=this._map.get(f);if(p)return h!==b.None&&this.touch(p,h),p.value}set(f,h,p=b.None){let S=this._map.get(f);if(S)S.value=h,p!==b.None&&this.touch(S,p);else{switch(S={key:f,value:h,next:void 0,previous:void 0},p){case b.None:this.addItemLast(S);break;case b.AsOld:this.addItemFirst(S);break;case b.AsNew:this.addItemLast(S);break;default:this.addItemLast(S);break}this._map.set(f,S),this._size++}return this}delete(f){return!!this.remove(f)}remove(f){const h=this._map.get(f);if(h)return this._map.delete(f),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const f=this._head;return this._map.delete(f.key),this.removeItem(f),this._size--,f.value}forEach(f,h){const p=this._state;let S=this._head;for(;S;){if(h?f.bind(h)(S.value,S.key,this):f(S.value,S.key,this),this._state!==p)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const f=this,h=this._state;let p=this._head;const S={[Symbol.iterator](){return S},next(){if(f._state!==h)throw new Error("LinkedMap got modified during iteration.");if(p){const U={value:p.key,done:!1};return p=p.next,U}else return{value:void 0,done:!0}}};return S}values(){const f=this,h=this._state;let p=this._head;const S={[Symbol.iterator](){return S},next(){if(f._state!==h)throw new Error("LinkedMap got modified during iteration.");if(p){const U={value:p.value,done:!1};return p=p.next,U}else return{value:void 0,done:!0}}};return S}entries(){const f=this,h=this._state;let p=this._head;const S={[Symbol.iterator](){return S},next(){if(f._state!==h)throw new Error("LinkedMap got modified during iteration.");if(p){const U={value:[p.key,p.value],done:!1};return p=p.next,U}else return{value:void 0,done:!0}}};return S}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(f){if(f>=this.size)return;if(f===0){this.clear();return}let h=this._head,p=this.size;for(;h&&p>f;)this._map.delete(h.key),h=h.next,p--;this._head=h,this._size=p,h&&(h.previous=void 0),this._state++}trimNew(f){if(f>=this.size)return;if(f===0){this.clear();return}let h=this._tail,p=this.size;for(;h&&p>f;)this._map.delete(h.key),h=h.previous,p--;this._tail=h,this._size=p,h&&(h.next=void 0),this._state++}addItemFirst(f){if(!this._head&&!this._tail)this._tail=f;else if(this._head)f.next=this._head,this._head.previous=f;else throw new Error("Invalid list");this._head=f,this._state++}addItemLast(f){if(!this._head&&!this._tail)this._head=f;else if(this._tail)f.previous=this._tail,this._tail.next=f;else throw new Error("Invalid list");this._tail=f,this._state++}removeItem(f){if(f===this._head&&f===this._tail)this._head=void 0,this._tail=void 0;else if(f===this._head){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this._head=f.next}else if(f===this._tail){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this._tail=f.previous}else{const h=f.next,p=f.previous;if(!h||!p)throw new Error("Invalid list");h.previous=p,p.next=h}f.next=void 0,f.previous=void 0,this._state++}touch(f,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==b.AsOld&&h!==b.AsNew)){if(h===b.AsOld){if(f===this._head)return;const p=f.next,S=f.previous;f===this._tail?(S.next=void 0,this._tail=S):(p.previous=S,S.next=p),f.previous=void 0,f.next=this._head,this._head.previous=f,this._head=f,this._state++}else if(h===b.AsNew){if(f===this._tail)return;const p=f.next,S=f.previous;f===this._head?(p.previous=void 0,this._head=p):(p.previous=S,S.next=p),f.next=void 0,f.previous=this._tail,this._tail.next=f,this._tail=f,this._state++}}}toJSON(){const f=[];return this.forEach((h,p)=>{f.push([p,h])}),f}fromJSON(f){this.clear();for(const[h,p]of f)this.set(h,p)}}t.LinkedMap=m;class e extends m{constructor(f,h=1){super(),this._limit=f,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(f){this._limit=f,this.checkTrim()}get ratio(){return this._ratio}set ratio(f){this._ratio=Math.min(Math.max(0,f),1),this.checkTrim()}get(f,h=b.AsNew){return super.get(f,h)}peek(f){return super.get(f,b.None)}set(f,h){return super.set(f,h,b.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class s extends e{constructor(f,h=1){super(f,h)}trim(f){this.trimOld(f)}set(f,h){return super.set(f,h),this.checkTrim(),this}}t.LRUCache=s;class r extends e{constructor(f,h=1){super(f,h)}trim(f){this.trimNew(f)}set(f,h){return this._limit<=this.size&&!this.has(f)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(f,h),this}}t.MRUCache=r;class c{constructor(){this.map=new Map}add(f){return this.map.set(f,(this.map.get(f)||0)+1),this}delete(f){let h=this.map.get(f)||0;return h===0?!1:(h--,h===0?this.map.delete(f):this.map.set(f,h),!0)}has(f){return this.map.has(f)}}t.CounterSet=c;class l{constructor(f){if(this._m1=new Map,this._m2=new Map,f)for(const[h,p]of f)this.set(h,p)}clear(){this._m1.clear(),this._m2.clear()}set(f,h){this._m1.set(f,h),this._m2.set(h,f)}get(f){return this._m1.get(f)}getKey(f){return this._m2.get(f)}delete(f){const h=this._m1.get(f);return h===void 0?!1:(this._m1.delete(f),this._m2.delete(h),!0)}forEach(f,h){this._m1.forEach((p,S)=>{f.call(h,p,S,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=l;class E{constructor(){this.map=new Map}add(f,h){let p=this.map.get(f);p||(p=new Set,this.map.set(f,p)),p.add(h)}delete(f,h){const p=this.map.get(f);p&&(p.delete(h),p.size===0&&this.map.delete(f))}forEach(f,h){const p=this.map.get(f);p&&p.forEach(h)}get(f){const h=this.map.get(f);return h||new Set}}t.SetMap=E;function T(A,f){if(A===f)return!0;if(A.size!==f.size)return!1;for(const[h,p]of A)if(!f.has(h)||f.get(h)!==p)return!1;for(const[h]of f)if(!A.has(h))return!1;return!0}}),define(ve[2],De([1,0,9,57,43,58,36]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=v,t.trackDisposable=_,t.markAsDisposed=b,t.markAsSingleton=s,t.isDisposable=r,t.dispose=c,t.disposeIfDisposable=l,t.combinedDisposable=E,t.toDisposable=T,t.disposeOnReturn=O;const D=!1;let w=null;class d{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(W){let G=this.livingDisposables.get(W);return G||(G={parent:null,source:null,isSingleton:!1,value:W,idx:d.idx++},this.livingDisposables.set(W,G)),G}trackDisposable(W){const G=this.getDisposableData(W);G.source||(G.source=new Error().stack)}setParent(W,G){const Q=this.getDisposableData(W);Q.parent=G}markAsDisposed(W){this.livingDisposables.delete(W)}markAsSingleton(W){this.getDisposableData(W).isSingleton=!0}getRootParent(W,G){const Q=G.get(W);if(Q)return Q;const j=W.parent?this.getRootParent(this.getDisposableData(W.parent),G):W;return G.set(W,j),j}getTrackedDisposables(){const W=new Map;return[...this.livingDisposables.entries()].filter(([,Q])=>Q.source!==null&&!this.getRootParent(Q,W).isSingleton).flatMap(([Q])=>Q)}computeLeakingDisposables(W=10,G){let Q;if(G)Q=G;else{const me=new Map,_e=[...this.livingDisposables.values()].filter(ne=>ne.source!==null&&!this.getRootParent(ne,me).isSingleton);if(_e.length===0)return;const Ne=new Set(_e.map(ne=>ne.value));if(Q=_e.filter(ne=>!(ne.parent&&Ne.has(ne.parent))),Q.length===0)throw new Error("There are cyclic diposable chains!")}if(!Q)return;function j(me){function _e(ne,ee){for(;ne.length>0&&ee.some(he=>typeof he=="string"?he===ne[0]:ne[0].match(he));)ne.shift()}const Ne=me.source.split(`
`).map(ne=>ne.trim().replace("at ","")).filter(ne=>ne!=="");return _e(Ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Ne.reverse()}const q=new P.SetMap;for(const me of Q){const _e=j(me);for(let Ne=0;Ne<=_e.length;Ne++)q.add(_e.slice(0,Ne).join(`
`),me)}Q.sort((0,i.compareBy)(me=>me.idx,i.numberComparator));let J="",le=0;for(const me of Q.slice(0,W)){le++;const _e=j(me),Ne=[];for(let ne=0;ne<_e.length;ne++){let ee=_e[ne];ee=`(shared with ${q.get(_e.slice(0,ne+1).join(`
`)).size}/${Q.length} leaks) at ${ee}`;const ae=q.get(_e.slice(0,ne).join(`
`)),Le=(0,n.groupBy)([...ae].map(te=>j(te)[ne]),te=>te);delete Le[_e[ne]];for(const[te,pe]of Object.entries(Le))Ne.unshift(`    - stacktraces of ${pe.length} other leaks continue with ${te}`);Ne.unshift(ee)}J+=`


==================== Leaking disposable ${le}/${Q.length}: ${me.value.constructor.name} ====================
${Ne.join(`
`)}
============================================================

`}return Q.length>W&&(J+=`


... and ${Q.length-W} more leaking disposables

`),{leaks:Q,details:J}}}t.DisposableTracker=d;function v(R){w=R}if(D){const R="__is_disposable_tracked__";v(new class{trackDisposable(W){const G=new Error("Potentially leaked disposable").stack;setTimeout(()=>{W[R]||console.log(G)},3e3)}setParent(W,G){if(W&&W!==f.None)try{W[R]=!0}catch{}}markAsDisposed(W){if(W&&W!==f.None)try{W[R]=!0}catch{}}markAsSingleton(W){}})}function _(R){return w?.trackDisposable(R),R}function b(R){w?.markAsDisposed(R)}function m(R,W){w?.setParent(R,W)}function e(R,W){if(w)for(const G of R)w.setParent(G,W)}function s(R){return w?.markAsSingleton(R),R}function r(R){return typeof R=="object"&&R!==null&&typeof R.dispose=="function"&&R.dispose.length===0}function c(R){if(I.Iterable.is(R)){const W=[];for(const G of R)if(G)try{G.dispose()}catch(Q){W.push(Q)}if(W.length===1)throw W[0];if(W.length>1)throw new AggregateError(W,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function l(R){for(const W of R)r(W)&&W.dispose();return[]}function E(...R){const W=T(()=>c(R));return e(R,W),W}function T(R){const W=_({dispose:(0,F.createSingleCallFunction)(()=>{b(W),R()})});return W}class A{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{c(this._toDispose)}finally{this._toDispose.clear()}}add(W){if(!W)return W;if(W===this)throw new Error("Cannot register a disposable on itself!");return m(W,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(W),W}delete(W){if(W){if(W===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(W),W.dispose()}}deleteAndLeak(W){W&&this._toDispose.has(W)&&(this._toDispose.delete(W),m(W,null))}}t.DisposableStore=A;class f{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new A,_(this),m(this._store,this)}dispose(){b(this),this._store.dispose()}_register(W){if(W===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(W)}}t.Disposable=f;class h{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(W){this._isDisposed||W===this._value||(this._value?.dispose(),W&&m(W,this),this._value=W)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const W=this._value;return this._value=void 0,W&&m(W,null),W}}t.MutableDisposable=h;class p{constructor(W){this._disposable=new h,this._isDisposed=!1,this._disposable.value=W}get value(){return this._disposable.value}set value(W){this._isDisposed||W===this._disposable.value||(this._disposable.value=W)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=p;class S{constructor(W){this._disposable=W,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=S;class U{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(W){let G=W;return this.unset=()=>G=void 0,this.isset=()=>G!==void 0,this.dispose=()=>{G&&(G(),G=void 0,b(this))},this}}t.SafeDisposable=U;class H{constructor(){this.references=new Map}acquire(W,...G){let Q=this.references.get(W);Q||(Q={counter:0,object:this.createReferencedObject(W,...G)},this.references.set(W,Q));const{object:j}=Q,q=(0,F.createSingleCallFunction)(()=>{--Q.counter===0&&(this.destroyReferencedObject(W,Q.object),this.references.delete(W))});return Q.counter++,{object:j,dispose:q}}}t.ReferenceCollection=H;class x{constructor(W){this.referenceCollection=W}async acquire(W,...G){const Q=this.referenceCollection.acquire(W,...G);try{return{object:await Q.object,dispose:()=>Q.dispose()}}catch(j){throw Q.dispose(),j}}}t.AsyncReferenceCollection=x;class y{constructor(W){this.object=W}dispose(){}}t.ImmortalReference=y;function O(R){const W=new A;try{R(W)}finally{W.dispose()}}class V{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){b(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{c(this._store.values())}finally{this._store.clear()}}has(W){return this._store.has(W)}get size(){return this._store.size}get(W){return this._store.get(W)}set(W,G,Q=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Q||this._store.get(W)?.dispose(),this._store.set(W,G)}deleteAndDispose(W){this._store.get(W)?.dispose(),this._store.delete(W)}deleteAndLeak(W){const G=this._store.get(W);return this._store.delete(W),G}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=V}),function(oe,t){typeof define=="function"&&define.amd?define(ve[92],De([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,t(oe.marked={}))}(this,function(oe){"use strict";function t($,B){for(var a=0;a<B.length;a++){var o=B[a];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty($,o.key,o)}}function i($,B,a){return B&&t($.prototype,B),a&&t($,a),Object.defineProperty($,"prototype",{writable:!1}),$}function n($,B){if($){if(typeof $=="string")return P($,B);var a=Object.prototype.toString.call($).slice(8,-1);if(a==="Object"&&$.constructor&&(a=$.constructor.name),a==="Map"||a==="Set")return Array.from($);if(a==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(a))return P($,B)}}function P($,B){(B==null||B>$.length)&&(B=$.length);for(var a=0,o=new Array(B);a<B;a++)o[a]=$[a];return o}function F($,B){var a=typeof Symbol<"u"&&$[Symbol.iterator]||$["@@iterator"];if(a)return(a=a.call($)).next.bind(a);if(Array.isArray($)||(a=n($))||B&&$&&typeof $.length=="number"){a&&($=a);var o=0;return function(){return o>=$.length?{done:!0}:{done:!1,value:$[o++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=I();function D($){oe.defaults=$}var w=/[&<>"']/,d=/[&<>"']/g,v=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(B){return b[B]};function e($,B){if(B){if(w.test($))return $.replace(d,m)}else if(v.test($))return $.replace(_,m);return $}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r($){return $.replace(s,function(B,a){return a=a.toLowerCase(),a==="colon"?":":a.charAt(0)==="#"?a.charAt(1)==="x"?String.fromCharCode(parseInt(a.substring(2),16)):String.fromCharCode(+a.substring(1)):""})}var c=/(^|[^\[])\^/g;function l($,B){$=typeof $=="string"?$:$.source,B=B||"";var a={replace:function(g,k){return k=k.source||k,k=k.replace(c,"$1"),$=$.replace(g,k),a},getRegex:function(){return new RegExp($,B)}};return a}var E=/[^\w:]/g,T=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function A($,B,a){if($){var o;try{o=decodeURIComponent(r(a)).replace(E,"").toLowerCase()}catch{return null}if(o.indexOf("javascript:")===0||o.indexOf("vbscript:")===0||o.indexOf("data:")===0)return null}B&&!T.test(a)&&(a=U(B,a));try{a=encodeURI(a).replace(/%25/g,"%")}catch{return null}return a}var f={},h=/^[^:]+:\/*[^/]*$/,p=/^([^:]+:)[\s\S]*$/,S=/^([^:]+:\/*[^/]*)[\s\S]*$/;function U($,B){f[" "+$]||(h.test($)?f[" "+$]=$+"/":f[" "+$]=O($,"/",!0)),$=f[" "+$];var a=$.indexOf(":")===-1;return B.substring(0,2)==="//"?a?B:$.replace(p,"$1")+B:B.charAt(0)==="/"?a?B:$.replace(S,"$1")+B:$+B}var H={exec:function(){}};function x($){for(var B=1,a,o;B<arguments.length;B++){a=arguments[B];for(o in a)Object.prototype.hasOwnProperty.call(a,o)&&($[o]=a[o])}return $}function y($,B){var a=$.replace(/\|/g,function(k,L,u){for(var N=!1,C=L;--C>=0&&u[C]==="\\";)N=!N;return N?"|":" |"}),o=a.split(/ \|/),g=0;if(o[0].trim()||o.shift(),o.length>0&&!o[o.length-1].trim()&&o.pop(),o.length>B)o.splice(B);else for(;o.length<B;)o.push("");for(;g<o.length;g++)o[g]=o[g].trim().replace(/\\\|/g,"|");return o}function O($,B,a){var o=$.length;if(o===0)return"";for(var g=0;g<o;){var k=$.charAt(o-g-1);if(k===B&&!a)g++;else if(k!==B&&a)g++;else break}return $.slice(0,o-g)}function V($,B){if($.indexOf(B[1])===-1)return-1;for(var a=$.length,o=0,g=0;g<a;g++)if($[g]==="\\")g++;else if($[g]===B[0])o++;else if($[g]===B[1]&&(o--,o<0))return g;return-1}function R($){$&&$.sanitize&&!$.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W($,B){if(B<1)return"";for(var a="";B>1;)B&1&&(a+=$),B>>=1,$+=$;return a+$}function G($,B,a,o){var g=B.href,k=B.title?e(B.title):null,L=$[1].replace(/\\([\[\]])/g,"$1");if($[0].charAt(0)!=="!"){o.state.inLink=!0;var u={type:"link",raw:a,href:g,title:k,text:L,tokens:o.inlineTokens(L)};return o.state.inLink=!1,u}return{type:"image",raw:a,href:g,title:k,text:e(L)}}function Q($,B){var a=$.match(/^(\s+)(?:```)/);if(a===null)return B;var o=a[1];return B.split(`
`).map(function(g){var k=g.match(/^\s+/);if(k===null)return g;var L=k[0];return L.length>=o.length?g.slice(o.length):g}).join(`
`)}var j=function(){function $(a){this.options=a||oe.defaults}var B=$.prototype;return B.space=function(o){var g=this.rules.block.newline.exec(o);if(g&&g[0].length>0)return{type:"space",raw:g[0]}},B.code=function(o){var g=this.rules.block.code.exec(o);if(g){var k=g[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:g[0],codeBlockStyle:"indented",text:this.options.pedantic?k:O(k,`
`)}}},B.fences=function(o){var g=this.rules.block.fences.exec(o);if(g){var k=g[0],L=Q(k,g[3]||"");return{type:"code",raw:k,lang:g[2]?g[2].trim():g[2],text:L}}},B.heading=function(o){var g=this.rules.block.heading.exec(o);if(g){var k=g[2].trim();if(/#$/.test(k)){var L=O(k,"#");(this.options.pedantic||!L||/ $/.test(L))&&(k=L.trim())}return{type:"heading",raw:g[0],depth:g[1].length,text:k,tokens:this.lexer.inline(k)}}},B.hr=function(o){var g=this.rules.block.hr.exec(o);if(g)return{type:"hr",raw:g[0]}},B.blockquote=function(o){var g=this.rules.block.blockquote.exec(o);if(g){var k=g[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:g[0],tokens:this.lexer.blockTokens(k,[]),text:k}}},B.list=function(o){var g=this.rules.block.list.exec(o);if(g){var k,L,u,N,C,M,z,X,ie,re,ce,we,Ee=g[1].trim(),ye=Ee.length>1,Ie={type:"list",raw:"",ordered:ye,start:ye?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=ye?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=ye?Ee:"[*+-]");for(var de=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");o&&(we=!1,!(!(g=de.exec(o))||this.rules.block.hr.test(o)));){if(k=g[0],o=o.substring(k.length),X=g[2].split(`
`,1)[0],ie=o.split(`
`,1)[0],this.options.pedantic?(N=2,ce=X.trimLeft()):(N=g[2].search(/[^ ]/),N=N>4?1:N,ce=X.slice(N),N+=g[1].length),M=!1,!X&&/^ *$/.test(ie)&&(k+=ie+`
`,o=o.substring(ie.length+1),we=!0),!we)for(var Fe=new RegExp("^ {0,"+Math.min(3,N-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),qe=new RegExp("^ {0,"+Math.min(3,N-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ye=new RegExp("^ {0,"+Math.min(3,N-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,N-1)+"}#");o&&(re=o.split(`
`,1)[0],X=re,this.options.pedantic&&(X=X.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ye.test(X)||tt.test(X)||Fe.test(X)||qe.test(o)));){if(X.search(/[^ ]/)>=N||!X.trim())ce+=`
`+X.slice(N);else if(!M)ce+=`
`+X;else break;!M&&!X.trim()&&(M=!0),k+=re+`
`,o=o.substring(re.length+1)}Ie.loose||(z?Ie.loose=!0:/\n *\n *$/.test(k)&&(z=!0)),this.options.gfm&&(L=/^\[[ xX]\] /.exec(ce),L&&(u=L[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:k,task:!!L,checked:u,loose:!1,text:ce}),Ie.raw+=k}Ie.items[Ie.items.length-1].raw=k.trimRight(),Ie.items[Ie.items.length-1].text=ce.trimRight(),Ie.raw=Ie.raw.trimRight();var at=Ie.items.length;for(C=0;C<at;C++){this.lexer.state.top=!1,Ie.items[C].tokens=this.lexer.blockTokens(Ie.items[C].text,[]);var st=Ie.items[C].tokens.filter(function(Ze){return Ze.type==="space"}),je=st.every(function(Ze){for(var Z=Ze.raw.split(""),ue=0,be=F(Z),Te;!(Te=be()).done;){var Pe=Te.value;if(Pe===`
`&&(ue+=1),ue>1)return!0}return!1});!Ie.loose&&st.length&&je&&(Ie.loose=!0,Ie.items[C].loose=!0)}return Ie}},B.html=function(o){var g=this.rules.block.html.exec(o);if(g){var k={type:"html",raw:g[0],pre:!this.options.sanitizer&&(g[1]==="pre"||g[1]==="script"||g[1]==="style"),text:g[0]};if(this.options.sanitize){var L=this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]);k.type="paragraph",k.text=L,k.tokens=this.lexer.inline(L)}return k}},B.def=function(o){var g=this.rules.block.def.exec(o);if(g){g[3]&&(g[3]=g[3].substring(1,g[3].length-1));var k=g[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:k,raw:g[0],href:g[2],title:g[3]}}},B.table=function(o){var g=this.rules.block.table.exec(o);if(g){var k={type:"table",header:y(g[1]).map(function(z){return{text:z}}),align:g[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:g[3]&&g[3].trim()?g[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(k.header.length===k.align.length){k.raw=g[0];var L=k.align.length,u,N,C,M;for(u=0;u<L;u++)/^ *-+: *$/.test(k.align[u])?k.align[u]="right":/^ *:-+: *$/.test(k.align[u])?k.align[u]="center":/^ *:-+ *$/.test(k.align[u])?k.align[u]="left":k.align[u]=null;for(L=k.rows.length,u=0;u<L;u++)k.rows[u]=y(k.rows[u],k.header.length).map(function(z){return{text:z}});for(L=k.header.length,N=0;N<L;N++)k.header[N].tokens=this.lexer.inline(k.header[N].text);for(L=k.rows.length,N=0;N<L;N++)for(M=k.rows[N],C=0;C<M.length;C++)M[C].tokens=this.lexer.inline(M[C].text);return k}}},B.lheading=function(o){var g=this.rules.block.lheading.exec(o);if(g)return{type:"heading",raw:g[0],depth:g[2].charAt(0)==="="?1:2,text:g[1],tokens:this.lexer.inline(g[1])}},B.paragraph=function(o){var g=this.rules.block.paragraph.exec(o);if(g){var k=g[1].charAt(g[1].length-1)===`
`?g[1].slice(0,-1):g[1];return{type:"paragraph",raw:g[0],text:k,tokens:this.lexer.inline(k)}}},B.text=function(o){var g=this.rules.block.text.exec(o);if(g)return{type:"text",raw:g[0],text:g[0],tokens:this.lexer.inline(g[0])}},B.escape=function(o){var g=this.rules.inline.escape.exec(o);if(g)return{type:"escape",raw:g[0],text:e(g[1])}},B.tag=function(o){var g=this.rules.inline.tag.exec(o);if(g)return!this.lexer.state.inLink&&/^<a /i.test(g[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(g[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(g[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(g[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:g[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]):g[0]}},B.link=function(o){var g=this.rules.inline.link.exec(o);if(g){var k=g[2].trim();if(!this.options.pedantic&&/^</.test(k)){if(!/>$/.test(k))return;var L=O(k.slice(0,-1),"\\");if((k.length-L.length)%2===0)return}else{var u=V(g[2],"()");if(u>-1){var N=g[0].indexOf("!")===0?5:4,C=N+g[1].length+u;g[2]=g[2].substring(0,u),g[0]=g[0].substring(0,C).trim(),g[3]=""}}var M=g[2],z="";if(this.options.pedantic){var X=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(M);X&&(M=X[1],z=X[3])}else z=g[3]?g[3].slice(1,-1):"";return M=M.trim(),/^</.test(M)&&(this.options.pedantic&&!/>$/.test(k)?M=M.slice(1):M=M.slice(1,-1)),G(g,{href:M&&M.replace(this.rules.inline._escapes,"$1"),title:z&&z.replace(this.rules.inline._escapes,"$1")},g[0],this.lexer)}},B.reflink=function(o,g){var k;if((k=this.rules.inline.reflink.exec(o))||(k=this.rules.inline.nolink.exec(o))){var L=(k[2]||k[1]).replace(/\s+/g," ");if(L=g[L.toLowerCase()],!L||!L.href){var u=k[0].charAt(0);return{type:"text",raw:u,text:u}}return G(k,L,k[0],this.lexer)}},B.emStrong=function(o,g,k){k===void 0&&(k="");var L=this.rules.inline.emStrong.lDelim.exec(o);if(L&&!(L[3]&&k.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var u=L[1]||L[2]||"";if(!u||u&&(k===""||this.rules.inline.punctuation.exec(k))){var N=L[0].length-1,C,M,z=N,X=0,ie=L[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,g=g.slice(-1*o.length+N);(L=ie.exec(g))!=null;)if(C=L[1]||L[2]||L[3]||L[4]||L[5]||L[6],!!C){if(M=C.length,L[3]||L[4]){z+=M;continue}else if((L[5]||L[6])&&N%3&&!((N+M)%3)){X+=M;continue}if(z-=M,!(z>0)){if(M=Math.min(M,M+z+X),Math.min(N,M)%2){var re=o.slice(1,N+L.index+M);return{type:"em",raw:o.slice(0,N+L.index+M+1),text:re,tokens:this.lexer.inlineTokens(re)}}var ce=o.slice(2,N+L.index+M-1);return{type:"strong",raw:o.slice(0,N+L.index+M+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},B.codespan=function(o){var g=this.rules.inline.code.exec(o);if(g){var k=g[2].replace(/\n/g," "),L=/[^ ]/.test(k),u=/^ /.test(k)&&/ $/.test(k);return L&&u&&(k=k.substring(1,k.length-1)),k=e(k,!0),{type:"codespan",raw:g[0],text:k}}},B.br=function(o){var g=this.rules.inline.br.exec(o);if(g)return{type:"br",raw:g[0]}},B.del=function(o){var g=this.rules.inline.del.exec(o);if(g)return{type:"del",raw:g[0],text:g[2],tokens:this.lexer.inlineTokens(g[2])}},B.autolink=function(o,g){var k=this.rules.inline.autolink.exec(o);if(k){var L,u;return k[2]==="@"?(L=e(this.options.mangle?g(k[1]):k[1]),u="mailto:"+L):(L=e(k[1]),u=L),{type:"link",raw:k[0],text:L,href:u,tokens:[{type:"text",raw:L,text:L}]}}},B.url=function(o,g){var k;if(k=this.rules.inline.url.exec(o)){var L,u;if(k[2]==="@")L=e(this.options.mangle?g(k[0]):k[0]),u="mailto:"+L;else{var N;do N=k[0],k[0]=this.rules.inline._backpedal.exec(k[0])[0];while(N!==k[0]);L=e(k[0]),k[1]==="www."?u="http://"+L:u=L}return{type:"link",raw:k[0],text:L,href:u,tokens:[{type:"text",raw:L,text:L}]}}},B.inlineText=function(o,g){var k=this.rules.inline.text.exec(o);if(k){var L;return this.lexer.state.inRawBlock?L=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]):k[0]:L=e(this.options.smartypants?g(k[0]):k[0]),{type:"text",raw:k[0],text:L}}},$}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:H,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=l(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=l(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=l(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=l(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=l(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=l(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=x({},q),q.gfm=x({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=l(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=l(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=x({},q.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:H,paragraph:l(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:H,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:H,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=l(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=l(q._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=l(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=l(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=l(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=l(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=l(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=l(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=l(J.reflink).replace("label",J._label).replace("ref",q._label).getRegex(),J.nolink=l(J.nolink).replace("ref",q._label).getRegex(),J.reflinkSearch=l(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=x({},J),J.pedantic=x({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=x({},J.normal,{escape:l(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),J.gfm.url=l(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=x({},J.gfm,{br:l(J.br).replace("{2,}","*").getRegex(),text:l(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function le($){return $.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function me($){var B="",a,o,g=$.length;for(a=0;a<g;a++)o=$.charCodeAt(a),Math.random()>.5&&(o="x"+o.toString(16)),B+="&#"+o+";";return B}var _e=function(){function $(a){this.tokens=[],this.tokens.links=Object.create(null),this.options=a||oe.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var o={block:q.normal,inline:J.normal};this.options.pedantic?(o.block=q.pedantic,o.inline=J.pedantic):this.options.gfm&&(o.block=q.gfm,this.options.breaks?o.inline=J.breaks:o.inline=J.gfm),this.tokenizer.rules=o}$.lex=function(o,g){var k=new $(g);return k.lex(o)},$.lexInline=function(o,g){var k=new $(g);return k.inlineTokens(o)};var B=$.prototype;return B.lex=function(o){o=o.replace(/\r\n|\r/g,`
`),this.blockTokens(o,this.tokens);for(var g;g=this.inlineQueue.shift();)this.inlineTokens(g.src,g.tokens);return this.tokens},B.blockTokens=function(o,g){var k=this;g===void 0&&(g=[]),this.options.pedantic?o=o.replace(/\t/g,"    ").replace(/^ +$/gm,""):o=o.replace(/^( *)(\t+)/gm,function(z,X,ie){return X+"    ".repeat(ie.length)});for(var L,u,N,C;o;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(z){return(L=z.call({lexer:k},o,g))?(o=o.substring(L.raw.length),g.push(L),!0):!1}))){if(L=this.tokenizer.space(o)){o=o.substring(L.raw.length),L.raw.length===1&&g.length>0?g[g.length-1].raw+=`
`:g.push(L);continue}if(L=this.tokenizer.code(o)){o=o.substring(L.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+L.raw,u.text+=`
`+L.text,this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(L);continue}if(L=this.tokenizer.fences(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.heading(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.hr(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.blockquote(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.list(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.html(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.def(o)){o=o.substring(L.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+L.raw,u.text+=`
`+L.raw,this.inlineQueue[this.inlineQueue.length-1].src=u.text):this.tokens.links[L.tag]||(this.tokens.links[L.tag]={href:L.href,title:L.title});continue}if(L=this.tokenizer.table(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.lheading(o)){o=o.substring(L.raw.length),g.push(L);continue}if(N=o,this.options.extensions&&this.options.extensions.startBlock&&function(){var z=1/0,X=o.slice(1),ie=void 0;k.options.extensions.startBlock.forEach(function(re){ie=re.call({lexer:this},X),typeof ie=="number"&&ie>=0&&(z=Math.min(z,ie))}),z<1/0&&z>=0&&(N=o.substring(0,z+1))}(),this.state.top&&(L=this.tokenizer.paragraph(N))){u=g[g.length-1],C&&u.type==="paragraph"?(u.raw+=`
`+L.raw,u.text+=`
`+L.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(L),C=N.length!==o.length,o=o.substring(L.raw.length);continue}if(L=this.tokenizer.text(o)){o=o.substring(L.raw.length),u=g[g.length-1],u&&u.type==="text"?(u.raw+=`
`+L.raw,u.text+=`
`+L.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(L);continue}if(o){var M="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(M);break}else throw new Error(M)}}return this.state.top=!0,g},B.inline=function(o,g){return g===void 0&&(g=[]),this.inlineQueue.push({src:o,tokens:g}),g},B.inlineTokens=function(o,g){var k=this;g===void 0&&(g=[]);var L,u,N,C=o,M,z,X;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(M=this.tokenizer.rules.inline.reflinkSearch.exec(C))!=null;)ie.includes(M[0].slice(M[0].lastIndexOf("[")+1,-1))&&(C=C.slice(0,M.index)+"["+W("a",M[0].length-2)+"]"+C.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(M=this.tokenizer.rules.inline.blockSkip.exec(C))!=null;)C=C.slice(0,M.index)+"["+W("a",M[0].length-2)+"]"+C.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(M=this.tokenizer.rules.inline.escapedEmSt.exec(C))!=null;)C=C.slice(0,M.index)+"++"+C.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;o;)if(z||(X=""),z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(L=ce.call({lexer:k},o,g))?(o=o.substring(L.raw.length),g.push(L),!0):!1}))){if(L=this.tokenizer.escape(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.tag(o)){o=o.substring(L.raw.length),u=g[g.length-1],u&&L.type==="text"&&u.type==="text"?(u.raw+=L.raw,u.text+=L.text):g.push(L);continue}if(L=this.tokenizer.link(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.reflink(o,this.tokens.links)){o=o.substring(L.raw.length),u=g[g.length-1],u&&L.type==="text"&&u.type==="text"?(u.raw+=L.raw,u.text+=L.text):g.push(L);continue}if(L=this.tokenizer.emStrong(o,C,X)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.codespan(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.br(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.del(o)){o=o.substring(L.raw.length),g.push(L);continue}if(L=this.tokenizer.autolink(o,me)){o=o.substring(L.raw.length),g.push(L);continue}if(!this.state.inLink&&(L=this.tokenizer.url(o,me))){o=o.substring(L.raw.length),g.push(L);continue}if(N=o,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,we=o.slice(1),Ee=void 0;k.options.extensions.startInline.forEach(function(ye){Ee=ye.call({lexer:this},we),typeof Ee=="number"&&Ee>=0&&(ce=Math.min(ce,Ee))}),ce<1/0&&ce>=0&&(N=o.substring(0,ce+1))}(),L=this.tokenizer.inlineText(N,le)){o=o.substring(L.raw.length),L.raw.slice(-1)!=="_"&&(X=L.raw.slice(-1)),z=!0,u=g[g.length-1],u&&u.type==="text"?(u.raw+=L.raw,u.text+=L.text):g.push(L);continue}if(o){var re="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return g},i($,null,[{key:"rules",get:function(){return{block:q,inline:J}}}]),$}(),Ne=function(){function $(a){this.options=a||oe.defaults}var B=$.prototype;return B.code=function(o,g,k){var L=(g||"").match(/\S*/)[0];if(this.options.highlight){var u=this.options.highlight(o,L);u!=null&&u!==o&&(k=!0,o=u)}return o=o.replace(/\n$/,"")+`
`,L?'<pre><code class="'+this.options.langPrefix+e(L,!0)+'">'+(k?o:e(o,!0))+`</code></pre>
`:"<pre><code>"+(k?o:e(o,!0))+`</code></pre>
`},B.blockquote=function(o){return`<blockquote>
`+o+`</blockquote>
`},B.html=function(o){return o},B.heading=function(o,g,k,L){if(this.options.headerIds){var u=this.options.headerPrefix+L.slug(k);return"<h"+g+' id="'+u+'">'+o+"</h"+g+`>
`}return"<h"+g+">"+o+"</h"+g+`>
`},B.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},B.list=function(o,g,k){var L=g?"ol":"ul",u=g&&k!==1?' start="'+k+'"':"";return"<"+L+u+`>
`+o+"</"+L+`>
`},B.listitem=function(o){return"<li>"+o+`</li>
`},B.checkbox=function(o){return"<input "+(o?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},B.paragraph=function(o){return"<p>"+o+`</p>
`},B.table=function(o,g){return g&&(g="<tbody>"+g+"</tbody>"),`<table>
<thead>
`+o+`</thead>
`+g+`</table>
`},B.tablerow=function(o){return`<tr>
`+o+`</tr>
`},B.tablecell=function(o,g){var k=g.header?"th":"td",L=g.align?"<"+k+' align="'+g.align+'">':"<"+k+">";return L+o+("</"+k+`>
`)},B.strong=function(o){return"<strong>"+o+"</strong>"},B.em=function(o){return"<em>"+o+"</em>"},B.codespan=function(o){return"<code>"+o+"</code>"},B.br=function(){return this.options.xhtml?"<br/>":"<br>"},B.del=function(o){return"<del>"+o+"</del>"},B.link=function(o,g,k){if(o=A(this.options.sanitize,this.options.baseUrl,o),o===null)return k;var L='<a href="'+e(o)+'"';return g&&(L+=' title="'+g+'"'),L+=">"+k+"</a>",L},B.image=function(o,g,k){if(o=A(this.options.sanitize,this.options.baseUrl,o),o===null)return k;var L='<img src="'+o+'" alt="'+k+'"';return g&&(L+=' title="'+g+'"'),L+=this.options.xhtml?"/>":">",L},B.text=function(o){return o},$}(),ne=function(){function $(){}var B=$.prototype;return B.strong=function(o){return o},B.em=function(o){return o},B.codespan=function(o){return o},B.del=function(o){return o},B.html=function(o){return o},B.text=function(o){return o},B.link=function(o,g,k){return""+k},B.image=function(o,g,k){return""+k},B.br=function(){return""},$}(),ee=function(){function $(){this.seen={}}var B=$.prototype;return B.serialize=function(o){return o.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},B.getNextSafeSlug=function(o,g){var k=o,L=0;if(this.seen.hasOwnProperty(k)){L=this.seen[o];do L++,k=o+"-"+L;while(this.seen.hasOwnProperty(k))}return g||(this.seen[o]=L,this.seen[k]=0),k},B.slug=function(o,g){g===void 0&&(g={});var k=this.serialize(o);return this.getNextSafeSlug(k,g.dryrun)},$}(),he=function(){function $(a){this.options=a||oe.defaults,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ne,this.slugger=new ee}$.parse=function(o,g){var k=new $(g);return k.parse(o)},$.parseInline=function(o,g){var k=new $(g);return k.parseInline(o)};var B=$.prototype;return B.parse=function(o,g){g===void 0&&(g=!0);var k="",L,u,N,C,M,z,X,ie,re,ce,we,Ee,ye,Ie,de,Fe,qe,Ye,tt,at=o.length;for(L=0;L<at;L++){if(ce=o[L],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){k+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{k+=this.renderer.hr();continue}case"heading":{k+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,r(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{k+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(ie="",X="",C=ce.header.length,u=0;u<C;u++)X+=this.renderer.tablecell(this.parseInline(ce.header[u].tokens),{header:!0,align:ce.align[u]});for(ie+=this.renderer.tablerow(X),re="",C=ce.rows.length,u=0;u<C;u++){for(z=ce.rows[u],X="",M=z.length,N=0;N<M;N++)X+=this.renderer.tablecell(this.parseInline(z[N].tokens),{header:!1,align:ce.align[N]});re+=this.renderer.tablerow(X)}k+=this.renderer.table(ie,re);continue}case"blockquote":{re=this.parse(ce.tokens),k+=this.renderer.blockquote(re);continue}case"list":{for(we=ce.ordered,Ee=ce.start,ye=ce.loose,C=ce.items.length,re="",u=0;u<C;u++)de=ce.items[u],Fe=de.checked,qe=de.task,Ie="",de.task&&(Ye=this.renderer.checkbox(Fe),ye?de.tokens.length>0&&de.tokens[0].type==="paragraph"?(de.tokens[0].text=Ye+" "+de.tokens[0].text,de.tokens[0].tokens&&de.tokens[0].tokens.length>0&&de.tokens[0].tokens[0].type==="text"&&(de.tokens[0].tokens[0].text=Ye+" "+de.tokens[0].tokens[0].text)):de.tokens.unshift({type:"text",text:Ye}):Ie+=Ye),Ie+=this.parse(de.tokens,ye),re+=this.renderer.listitem(Ie,qe,Fe);k+=this.renderer.list(re,we,Ee);continue}case"html":{k+=this.renderer.html(ce.text);continue}case"paragraph":{k+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(re=ce.tokens?this.parseInline(ce.tokens):ce.text;L+1<at&&o[L+1].type==="text";)ce=o[++L],re+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);k+=g?this.renderer.paragraph(re):re;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return k},B.parseInline=function(o,g){g=g||this.renderer;var k="",L,u,N,C=o.length;for(L=0;L<C;L++){if(u=o[L],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[u.type]&&(N=this.options.extensions.renderers[u.type].call({parser:this},u),N!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(u.type))){k+=N||"";continue}switch(u.type){case"escape":{k+=g.text(u.text);break}case"html":{k+=g.html(u.text);break}case"link":{k+=g.link(u.href,u.title,this.parseInline(u.tokens,g));break}case"image":{k+=g.image(u.href,u.title,u.text);break}case"strong":{k+=g.strong(this.parseInline(u.tokens,g));break}case"em":{k+=g.em(this.parseInline(u.tokens,g));break}case"codespan":{k+=g.codespan(u.text);break}case"br":{k+=g.br();break}case"del":{k+=g.del(this.parseInline(u.tokens,g));break}case"text":{k+=g.text(u.text);break}default:{var M='Token with "'+u.type+'" type was not found.';if(this.options.silent){console.error(M);return}else throw new Error(M)}}}return k},$}();function ae($,B,a){if(typeof $>"u"||$===null)throw new Error("marked(): input parameter is undefined or null");if(typeof $!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call($)+", string expected");if(typeof B=="function"&&(a=B,B=null),B=x({},ae.defaults,B||{}),R(B),a){var o=B.highlight,g;try{g=_e.lex($,B)}catch(C){return a(C)}var k=function(M){var z;if(!M)try{B.walkTokens&&ae.walkTokens(g,B.walkTokens),z=he.parse(g,B)}catch(X){M=X}return B.highlight=o,M?a(M):a(null,z)};if(!o||o.length<3||(delete B.highlight,!g.length))return k();var L=0;ae.walkTokens(g,function(C){C.type==="code"&&(L++,setTimeout(function(){o(C.text,C.lang,function(M,z){if(M)return k(M);z!=null&&z!==C.text&&(C.text=z,C.escaped=!0),L--,L===0&&k()})},0))}),L===0&&k();return}function u(C){if(C.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+e(C.message+"",!0)+"</pre>";throw C}try{var N=_e.lex($,B);if(B.walkTokens){if(B.async)return Promise.all(ae.walkTokens(N,B.walkTokens)).then(function(){return he.parse(N,B)}).catch(u);ae.walkTokens(N,B.walkTokens)}return he.parse(N,B)}catch(C){u(C)}}ae.options=ae.setOptions=function($){return x(ae.defaults,$),D(ae.defaults),ae},ae.getDefaults=I,ae.defaults=oe.defaults,ae.use=function(){for(var $=arguments.length,B=new Array($),a=0;a<$;a++)B[a]=arguments[a];var o=x.apply(void 0,[{}].concat(B)),g=ae.defaults.extensions||{renderers:{},childTokens:{}},k;B.forEach(function(L){if(L.extensions&&(k=!0,L.extensions.forEach(function(N){if(!N.name)throw new Error("extension name required");if(N.renderer){var C=g.renderers?g.renderers[N.name]:null;C?g.renderers[N.name]=function(){for(var M=arguments.length,z=new Array(M),X=0;X<M;X++)z[X]=arguments[X];var ie=N.renderer.apply(this,z);return ie===!1&&(ie=C.apply(this,z)),ie}:g.renderers[N.name]=N.renderer}if(N.tokenizer){if(!N.level||N.level!=="block"&&N.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");g[N.level]?g[N.level].unshift(N.tokenizer):g[N.level]=[N.tokenizer],N.start&&(N.level==="block"?g.startBlock?g.startBlock.push(N.start):g.startBlock=[N.start]:N.level==="inline"&&(g.startInline?g.startInline.push(N.start):g.startInline=[N.start]))}N.childTokens&&(g.childTokens[N.name]=N.childTokens)})),L.renderer&&function(){var N=ae.defaults.renderer||new Ne,C=function(X){var ie=N[X];N[X]=function(){for(var re=arguments.length,ce=new Array(re),we=0;we<re;we++)ce[we]=arguments[we];var Ee=L.renderer[X].apply(N,ce);return Ee===!1&&(Ee=ie.apply(N,ce)),Ee}};for(var M in L.renderer)C(M);o.renderer=N}(),L.tokenizer&&function(){var N=ae.defaults.tokenizer||new j,C=function(X){var ie=N[X];N[X]=function(){for(var re=arguments.length,ce=new Array(re),we=0;we<re;we++)ce[we]=arguments[we];var Ee=L.tokenizer[X].apply(N,ce);return Ee===!1&&(Ee=ie.apply(N,ce)),Ee}};for(var M in L.tokenizer)C(M);o.tokenizer=N}(),L.walkTokens){var u=ae.defaults.walkTokens;o.walkTokens=function(N){var C=[];return C.push(L.walkTokens.call(this,N)),u&&(C=C.concat(u.call(this,N))),C}}k&&(o.extensions=g),ae.setOptions(o)})},ae.walkTokens=function($,B){for(var a=[],o=function(){var u=k.value;switch(a=a.concat(B.call(ae,u)),u.type){case"table":{for(var N=F(u.header),C;!(C=N()).done;){var M=C.value;a=a.concat(ae.walkTokens(M.tokens,B))}for(var z=F(u.rows),X;!(X=z()).done;)for(var ie=X.value,re=F(ie),ce;!(ce=re()).done;){var we=ce.value;a=a.concat(ae.walkTokens(we.tokens,B))}break}case"list":{a=a.concat(ae.walkTokens(u.items,B));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[u.type]?ae.defaults.extensions.childTokens[u.type].forEach(function(Ee){a=a.concat(ae.walkTokens(u[Ee],B))}):u.tokens&&(a=a.concat(ae.walkTokens(u.tokens,B)))}},g=F($),k;!(k=g()).done;)o();return a},ae.parseInline=function($,B){if(typeof $>"u"||$===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof $!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call($)+", string expected");B=x({},ae.defaults,B||{}),R(B);try{var a=_e.lexInline($,B);return B.walkTokens&&ae.walkTokens(a,B.walkTokens),he.parseInline(a,B)}catch(o){if(o.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+e(o.message+"",!0)+"</pre>";throw o}},ae.Parser=he,ae.parser=he.parse,ae.Renderer=Ne,ae.TextRenderer=ne,ae.Lexer=_e,ae.lexer=_e.lex,ae.Tokenizer=j,ae.Slugger=ee,ae.parse=ae;var Le=ae.options,te=ae.setOptions,pe=ae.use,Ae=ae.walkTokens,Ce=ae.parseInline,Re=ae,xe=he.parse,He=_e.lex;oe.Lexer=_e,oe.Parser=he,oe.Renderer=Ne,oe.Slugger=ee,oe.TextRenderer=ne,oe.Tokenizer=j,oe.getDefaults=I,oe.lexer=He,oe.marked=ae,oe.options=Le,oe.parse=Re,oe.parseInline=Ce,oe.parser=xe,oe.setOptions=te,oe.use=pe,oe.walkTokens=Ae,Object.defineProperty(oe,"__esModule",{value:!0})}),define(ve[60],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var i;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(t.MarshalledId=i={}))}),define(ve[93],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getKoreanAltChars=i;function i(s){const r=F(s);if(r&&r.length>0)return new Uint32Array(r)}let n=0;const P=new Uint32Array(10);function F(s){if(n=0,I(s,_,w.InitialConsonant),n>0||(I(s,b,w.Vowel),n>0)||(I(s,m,w.FinalConsonant),n>0)||(I(s,e,w.CompatibilityJamo),n))return P.subarray(0,n);if(s>=44032&&s<=55203){const r=s-44032,c=r%588,l=Math.floor(r/588),E=Math.floor(c/28),T=c%28-1;if(l<_.length?I(l,_,0):w.InitialConsonant+l-w.CompatibilityJamo<e.length&&I(w.InitialConsonant+l,e,w.CompatibilityJamo),E<b.length?I(E,b,0):w.Vowel+E-w.CompatibilityJamo<e.length&&I(w.Vowel+E-w.CompatibilityJamo,e,w.CompatibilityJamo),T>=0&&(T<m.length?I(T,m,0):w.FinalConsonant+T-w.CompatibilityJamo<e.length&&I(w.FinalConsonant+T-w.CompatibilityJamo,e,w.CompatibilityJamo)),n>0)return P.subarray(0,n)}}function I(s,r,c){s>=c&&s<c+r.length&&D(r[s-c])}function D(s){s!==d.NUL&&(P[n++]=s&255,s>>8&&(P[n++]=s>>8&255),s>>16&&(P[n++]=s>>16&255))}var w;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(w||(w={}));var d;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(d||(d={}));var v;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(v||(v={}));const _=new Uint8Array([d.r,d.R,d.s,d.e,d.E,d.f,d.a,d.q,d.Q,d.t,d.T,d.d,d.w,d.W,d.c,d.z,d.x,d.v,d.g]),b=new Uint16Array([d.k,d.o,d.i,d.O,d.j,d.p,d.u,d.P,d.h,v.hk,v.ho,v.hl,d.y,d.n,v.nj,v.np,v.nl,d.b,d.m,v.ml,d.l]),m=new Uint16Array([d.r,d.R,v.rt,d.s,v.sw,v.sg,d.e,d.f,v.fr,v.fa,v.fq,v.ft,v.fx,v.fv,v.fg,d.a,d.q,v.qt,d.t,d.T,d.d,d.w,d.c,d.z,d.x,d.v,d.g]),e=new Uint16Array([d.r,d.R,v.rt,d.s,v.sw,v.sg,d.e,d.E,d.f,v.fr,v.fa,v.fq,v.ft,v.fx,v.fv,v.fg,d.a,d.q,d.Q,v.qt,d.t,d.T,d.d,d.w,d.W,d.c,d.z,d.x,d.v,d.g,d.k,d.o,d.i,d.O,d.j,d.p,d.u,d.P,d.h,v.hk,v.ho,v.hl,d.y,d.n,v.nj,v.np,v.nl,d.b,d.m,v.ml,d.l])}),define(ve[94],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class i{constructor(P,F=0,I=P.length,D=F-1){this.items=P,this.start=F,this.end=I,this.index=D}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=i}),define(ve[95],De([1,0,57,94]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class P{constructor(D=[],w=10){this._initialize(D),this._limit=w,this._onChange()}getHistory(){return this._elements}add(D){this._history.delete(D),this._history.add(D),this._onChange()}next(){return this._navigator.next()}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()>=this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(D){return this._history.has(D)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const D=this._elements;this._navigator=new n.ArrayNavigator(D,0,D.length,D.length)}_reduceToLimit(){const D=this._elements;D.length>this._limit&&this._initialize(D.slice(D.length-this._limit))}_currentPosition(){const D=this._navigator.current();return D?this._elements.indexOf(D):-1}_initialize(D){this._history=new Set;for(const w of D)this._history.add(w)}get _elements(){const D=[];return this._history.forEach(w=>D.push(w)),D}}t.HistoryNavigator=P;class F{get size(){return this._size}constructor(D,w=10,d=v=>v){if(this.capacity=w,this.identityFn=d,D.length<1)throw new Error("not supported");this._size=1,this.head=this.tail=this.cursor={value:D[0],previous:void 0,next:void 0},this.valueSet=new i.SetWithKey([D[0]],d);for(let v=1;v<D.length;v++)this.add(D[v])}add(D){const w={value:D,previous:this.tail,next:void 0};for(this.tail.next=w,this.tail=w,this.cursor=this.tail,this._size++,this.valueSet.has(D)?this._deleteFromList(D):this.valueSet.add(D);this._size>this.capacity;)this.valueSet.delete(this.head.value),this.head=this.head.next,this.head.previous=void 0,this._size--}replaceLast(D){if(this.identityFn(this.tail.value)===this.identityFn(D))return D;const w=this.tail.value;return this.valueSet.delete(w),this.tail.value=D,this.valueSet.has(D)?this._deleteFromList(D):this.valueSet.add(D),w}prepend(D){if(this._size===this.capacity||this.valueSet.has(D))return;const w={value:D,previous:void 0,next:this.head};this.head.previous=w,this.head=w,this._size++,this.valueSet.add(D)}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(D){return this.valueSet.has(D)}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let D=this.head;for(;D;)yield D.value,D=D.next}_deleteFromList(D){let w=this.head;const d=this.identityFn(D);for(;w!==this.tail;)this.identityFn(w.value)===d&&(w===this.head?(this.head=this.head.next,this.head.previous=void 0):(w.previous.next=w.next,w.next.previous=w.previous),this._size--),w=w.next}}t.HistoryNavigator2=F}),define(ve[37],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=void 0,t.clamp=i,t.rot=n,t.isPointWithinTriangle=D;function i(w,d,v){return Math.min(Math.max(w,d),v)}function n(w,d){return(d+w%d)%d}class P{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=P;class F{constructor(){this._n=1,this._val=0}update(d){return this._val=this._val+(d-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=F;class I{constructor(d){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(d),this._values.fill(0,0,d)}update(d){const v=this._values[this._index];return this._values[this._index]=d,this._index=(this._index+1)%this._values.length,this._sum-=v,this._sum+=d,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=I;function D(w,d,v,_,b,m,e,s){const r=e-v,c=s-_,l=b-v,E=m-_,T=w-v,A=d-_,f=r*r+c*c,h=r*l+c*E,p=r*T+c*A,S=l*l+E*E,U=l*T+E*A,H=1/(f*S-h*h),x=(S*p-h*U)*H,y=(f*U-h*p)*H;return x>=0&&y>=0&&x+y<1}}),define(ve[26],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DebugNameData=void 0,t.getDebugName=F,t.getFunctionName=b;class i{constructor(e,s,r){this.owner=e,this.debugNameSource=s,this.referenceFn=r}getDebugName(e){return F(e,this)}}t.DebugNameData=i;const n=new Map,P=new WeakMap;function F(m,e){const s=P.get(m);if(s)return s;const r=I(m,e);if(r){let c=n.get(r)??0;c++,n.set(r,c);const l=c===1?r:`${r}#${c}`;return P.set(m,l),l}}function I(m,e){const s=P.get(m);if(s)return s;const r=e.owner?v(e.owner)+".":"";let c;const l=e.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(c=l(),c!==void 0)return r+c}else return r+l;const E=e.referenceFn;if(E!==void 0&&(c=b(E),c!==void 0))return r+c;if(e.owner!==void 0){const T=D(e.owner,m);if(T!==void 0)return r+T}}function D(m,e){for(const s in m)if(m[s]===e)return s}const w=new Map,d=new WeakMap;function v(m){const e=d.get(m);if(e)return e;const s=_(m);let r=w.get(s)??0;r++,w.set(s,r);const c=r===1?s:`${s}#${r}`;return d.set(m,c),c}function _(m){const e=m.constructor;return e?e.name:"Object"}function b(m){const e=m.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(r?r[1]:void 0)?.trim()}}),define(ve[31],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConsoleObservableLogger=void 0,t.setLogger=n,t.getLogger=P;let i;function n(s){i=s}function P(){return i}class F{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(r){return I([D(m("|  ",this.indentation)),r])}formatInfo(r){return r.hadValue?r.didChange?[D(" "),d(v(r.oldValue,70),{color:"red",strikeThrough:!0}),D(" "),d(v(r.newValue,60),{color:"green"})]:[D(" (unchanged)")]:[D(" "),d(v(r.newValue,60),{color:"green"}),D(" (initial)")]}handleObservableChanged(r,c){console.log(...this.textToConsoleArgs([w("observable value changed"),d(r.debugName,{color:"BlueViolet"}),...this.formatInfo(c)]))}formatChanges(r){if(r.size!==0)return d(" (changed deps: "+[...r].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const c=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(l,E)=>(this.changedObservablesSets.get(r).add(l),c.apply(r,[l,E]))}handleDerivedRecomputed(r,c){const l=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([w("derived recomputed"),d(r.debugName,{color:"BlueViolet"}),...this.formatInfo(c),this.formatChanges(l),{data:[{fn:r._debugNameData.referenceFn??r._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(r,c){console.log(...this.textToConsoleArgs([w("observable from event triggered"),d(r.debugName,{color:"BlueViolet"}),...this.formatInfo(c),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const c=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(l,E)=>(this.changedObservablesSets.get(r).add(l),c.apply(r,[l,E]))}handleAutorunTriggered(r){const c=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([w("autorun"),d(r.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:r._debugNameData.referenceFn??r._runFn}]}])),c.clear(),this.indentation++}handleAutorunFinished(r){this.indentation--}handleBeginTransaction(r){let c=r.getDebugName();c===void 0&&(c=""),console.log(...this.textToConsoleArgs([w("transaction"),d(c,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}t.ConsoleObservableLogger=F;function I(s){const r=new Array,c=[];let l="";function E(A){if("length"in A)for(const f of A)f&&E(f);else"text"in A?(l+=`%c${A.text}`,r.push(A.style),A.data&&c.push(...A.data)):"data"in A&&c.push(...A.data)}E(s);const T=[l,...r];return T.push(...c),T}function D(s){return d(s,{color:"black"})}function w(s){return d(e(`${s}: `,10),{color:"black",bold:!0})}function d(s,r={color:"black"}){function c(E){return Object.entries(E).reduce((T,[A,f])=>`${T}${A}:${f};`,"")}const l={color:r.color};return r.strikeThrough&&(l["text-decoration"]="line-through"),r.bold&&(l["font-weight"]="bold"),{text:s,style:c(l)}}function v(s,r){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=r?`"${s}"`:`"${s.substr(0,r-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?_(s,r):b(s,r);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function _(s,r){let c="[ ",l=!0;for(const E of s){if(l||(c+=", "),c.length-5>r){c+="...";break}l=!1,c+=`${v(E,r-c.length)}`}return c+=" ]",c}function b(s,r){let c="{ ",l=!0;for(const[E,T]of Object.entries(s)){if(l||(c+=", "),c.length-5>r){c+="...";break}l=!1,c+=`${E}: ${v(T,r-c.length)}`}return c+=" }",c}function m(s,r){let c="";for(let l=1;l<=r;l++)c+=s;return c}function e(s,r){for(;s.length<r;)s+=" ";return s}}),define(ve[44],De([1,0,42,2,26,31]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AutorunObserver=void 0,t.autorun=I,t.autorunOpts=D,t.autorunHandleChanges=w,t.autorunWithStoreHandleChanges=d,t.autorunWithStore=v,t.autorunDelta=_;function I(e){return new m(new P.DebugNameData(void 0,void 0,e),e,void 0,void 0)}function D(e,s){return new m(new P.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function w(e,s){return new m(new P.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function d(e,s){const r=new n.DisposableStore,c=w({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn??s,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(l,E)=>{r.clear(),s(l,E,r)});return(0,n.toDisposable)(()=>{c.dispose(),r.dispose()})}function v(e){const s=new n.DisposableStore,r=D({owner:void 0,debugName:void 0,debugReferenceFn:e},c=>{s.clear(),e(c,s)});return(0,n.toDisposable)(()=>{r.dispose(),s.dispose()})}function _(e,s){let r;return D({debugReferenceFn:s},c=>{const l=e.read(c),E=r;r=l,s({lastValue:E,newValue:l})})}var b;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(b||(b={}));class m{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(s,r,c,l){this._debugNameData=s,this._runFn=r,this.createChangeSummary=c,this._handleChange=l,this.state=b.stale,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,F.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,n.trackDisposable)(this)}dispose(){this.disposed=!0;for(const s of this.dependencies)s.removeObserver(this);this.dependencies.clear(),(0,n.markAsDisposed)(this)}_runIfNeeded(){if(this.state===b.upToDate)return;const s=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=s,this.state=b.upToDate;const r=this.disposed;try{if(!r){(0,F.getLogger)()?.handleAutorunTriggered(this);const c=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,c)}}finally{r||(0,F.getLogger)()?.handleAutorunFinished(this);for(const c of this.dependenciesToBeRemoved)c.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===b.upToDate&&(this.state=b.dependenciesMightHaveChanged),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===b.dependenciesMightHaveChanged){this.state=b.upToDate;for(const s of this.dependencies)if(s.reportChanges(),this.state===b.stale)break}this._runIfNeeded()}while(this.state!==b.upToDate);this.updateCount--,(0,i.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(s){this.state===b.upToDate&&this.dependencies.has(s)&&!this.dependenciesToBeRemoved.has(s)&&(this.state=b.dependenciesMightHaveChanged)}handleChange(s,r){this.dependencies.has(s)&&!this.dependenciesToBeRemoved.has(s)&&(!this._handleChange||this._handleChange({changedObservable:s,change:r,didChange:l=>l===s},this.changeSummary))&&(this.state=b.stale)}readObservable(s){if(this.disposed)return s.get();s.addObserver(this);const r=s.get();return this.dependencies.add(s),this.dependenciesToBeRemoved.delete(s),r}}t.AutorunObserver=m,function(e){e.Observer=m}(I||(t.autorun=I={}))}),define(ve[27],De([1,0,30,26,31]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableObservableValue=t.ObservableValue=t.TransactionImpl=t.BaseObservable=t.ConvenientObservable=void 0,t._setRecomputeInitiallyAndOnChange=I,t._setKeepObserved=w,t._setDerivedOpts=v,t.transaction=m,t.globalTransaction=s,t.asyncTransaction=r,t.subtransaction=c,t.observableValue=E,t.disposableObservableValue=A;let F;function I(h){F=h}let D;function w(h){D=h}let d;function v(h){d=h}class _{get TChange(){return null}reportChanges(){this.get()}read(p){return p?p.readObservable(this):this.get()}map(p,S){const U=S===void 0?void 0:p,H=S===void 0?p:S;return d({owner:U,debugName:()=>{const x=(0,n.getFunctionName)(H);if(x!==void 0)return x;const O=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(H.toString());if(O)return`${this.debugName}.${O[2]}`;if(!U)return`${this.debugName} (mapped)`},debugReferenceFn:H},x=>H(this.read(x),x))}flatten(){return d({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},p=>this.read(p).read(p))}recomputeInitiallyAndOnChange(p,S){return p.add(F(this,S)),this}keepObserved(p){return p.add(D(this)),this}get debugValue(){return this.get()}}t.ConvenientObservable=_;class b extends _{constructor(){super(...arguments),this.observers=new Set}addObserver(p){const S=this.observers.size;this.observers.add(p),S===0&&this.onFirstObserverAdded()}removeObserver(p){this.observers.delete(p)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}t.BaseObservable=b;function m(h,p){const S=new l(h,p);try{h(S)}finally{S.finish()}}let e;function s(h){if(e)h(e);else{const p=new l(h,void 0);e=p;try{h(p)}finally{p.finish(),e=void 0}}}async function r(h,p){const S=new l(h,p);try{await h(S)}finally{S.finish()}}function c(h,p,S){h?p(h):m(p,S)}class l{constructor(p,S){this._fn=p,this._getDebugName=S,this.updatingObservers=[],(0,P.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,n.getFunctionName)(this._fn)}updateObserver(p,S){this.updatingObservers.push({observer:p,observable:S}),p.beginUpdate(S)}finish(){const p=this.updatingObservers;for(let S=0;S<p.length;S++){const{observer:U,observable:H}=p[S];U.endUpdate(H)}this.updatingObservers=null,(0,P.getLogger)()?.handleEndTransaction()}}t.TransactionImpl=l;function E(h,p){let S;return typeof h=="string"?S=new n.DebugNameData(void 0,h,void 0):S=new n.DebugNameData(h,void 0,void 0),new T(S,p,i.strictEquals)}class T extends b{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(p,S,U){super(),this._debugNameData=p,this._equalityComparator=U,this._value=S}get(){return this._value}set(p,S,U){if(U===void 0&&this._equalityComparator(this._value,p))return;let H;S||(S=H=new l(()=>{},()=>`Setting ${this.debugName}`));try{const x=this._value;this._setValue(p),(0,P.getLogger)()?.handleObservableChanged(this,{oldValue:x,newValue:p,change:U,didChange:!0,hadValue:!0});for(const y of this.observers)S.updateObserver(y,this),y.handleChange(this,U)}finally{H&&H.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(p){this._value=p}}t.ObservableValue=T;function A(h,p){let S;return typeof h=="string"?S=new n.DebugNameData(void 0,h,void 0):S=new n.DebugNameData(h,void 0,void 0),new f(S,p,i.strictEquals)}class f extends T{_setValue(p){this._value!==p&&(this._value&&this._value.dispose(),this._value=p)}dispose(){this._value?.dispose()}}t.DisposableObservableValue=f}),define(ve[45],De([1,0,42,30,2,27,26,31]),function(oe,t,i,n,P,F,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DerivedWithSetter=t.Derived=void 0,t.derived=w,t.derivedWithSetter=d,t.derivedOpts=v,t.derivedHandleChanges=_,t.derivedWithStore=b,t.derivedDisposable=m;function w(c,l){return l!==void 0?new s(new I.DebugNameData(c,void 0,l),l,void 0,void 0,void 0,n.strictEquals):new s(new I.DebugNameData(void 0,void 0,c),c,void 0,void 0,void 0,n.strictEquals)}function d(c,l,E){return new r(new I.DebugNameData(c,void 0,l),l,void 0,void 0,void 0,n.strictEquals,E)}function v(c,l){return new s(new I.DebugNameData(c.owner,c.debugName,c.debugReferenceFn),l,void 0,void 0,c.onLastObserverRemoved,c.equalsFn??n.strictEquals)}(0,F._setDerivedOpts)(v);function _(c,l){return new s(new I.DebugNameData(c.owner,c.debugName,void 0),l,c.createEmptyChangeSummary,c.handleChange,void 0,c.equalityComparer??n.strictEquals)}function b(c,l){let E,T;l===void 0?(E=c,T=void 0):(T=c,E=l);const A=new P.DisposableStore;return new s(new I.DebugNameData(T,void 0,E),f=>(A.clear(),E(f,A)),void 0,void 0,()=>A.dispose(),n.strictEquals)}function m(c,l){let E,T;l===void 0?(E=c,T=void 0):(T=c,E=l);let A;return new s(new I.DebugNameData(T,void 0,E),f=>{A?A.clear():A=new P.DisposableStore;const h=E(f);return h&&A.add(h),h},void 0,void 0,()=>{A&&(A.dispose(),A=void 0)},n.strictEquals)}var e;(function(c){c[c.initial=0]="initial",c[c.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",c[c.stale=2]="stale",c[c.upToDate=3]="upToDate"})(e||(e={}));class s extends F.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(l,E,T,A,f=void 0,h){super(),this._debugNameData=l,this._computeFn=E,this.createChangeSummary=T,this._handleChange=A,this._handleLastObserverRemoved=f,this._equalityComparator=h,this.state=e.initial,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,D.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=e.initial,this.value=void 0;for(const l of this.dependencies)l.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const l=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),l}else{do{if(this.state===e.dependenciesMightHaveChanged){for(const l of this.dependencies)if(l.reportChanges(),this.state===e.stale)break}this.state===e.dependenciesMightHaveChanged&&(this.state=e.upToDate),this._recomputeIfNeeded()}while(this.state!==e.upToDate);return this.value}}_recomputeIfNeeded(){if(this.state===e.upToDate)return;const l=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=l;const E=this.state!==e.initial,T=this.value;this.state=e.upToDate;const A=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,A)}finally{for(const h of this.dependenciesToBeRemoved)h.removeObserver(this);this.dependenciesToBeRemoved.clear()}const f=E&&!this._equalityComparator(T,this.value);if((0,D.getLogger)()?.handleDerivedRecomputed(this,{oldValue:T,newValue:this.value,change:void 0,didChange:f,hadValue:E}),f)for(const h of this.observers)h.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(l){this.updateCount++;const E=this.updateCount===1;if(this.state===e.upToDate&&(this.state=e.dependenciesMightHaveChanged,!E))for(const T of this.observers)T.handlePossibleChange(this);if(E)for(const T of this.observers)T.beginUpdate(this)}endUpdate(l){if(this.updateCount--,this.updateCount===0){const E=[...this.observers];for(const T of E)T.endUpdate(this)}(0,i.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(l){if(this.state===e.upToDate&&this.dependencies.has(l)&&!this.dependenciesToBeRemoved.has(l)){this.state=e.dependenciesMightHaveChanged;for(const E of this.observers)E.handlePossibleChange(this)}}handleChange(l,E){if(this.dependencies.has(l)&&!this.dependenciesToBeRemoved.has(l)){const T=this._handleChange?this._handleChange({changedObservable:l,change:E,didChange:f=>f===l},this.changeSummary):!0,A=this.state===e.upToDate;if(T&&(this.state===e.dependenciesMightHaveChanged||A)&&(this.state=e.stale,A))for(const f of this.observers)f.handlePossibleChange(this)}}readObservable(l){l.addObserver(this);const E=l.get();return this.dependencies.add(l),this.dependenciesToBeRemoved.delete(l),E}addObserver(l){const E=!this.observers.has(l)&&this.updateCount>0;super.addObserver(l),E&&l.beginUpdate(this)}removeObserver(l){const E=this.observers.has(l)&&this.updateCount>0;super.removeObserver(l),E&&l.endUpdate(this)}}t.Derived=s;class r extends s{constructor(l,E,T,A,f=void 0,h,p){super(l,E,T,A,f,h),this.set=p}}t.DerivedWithSetter=r}),define(ve[96],De([1,0,27]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LazyObservableValue=void 0;class n extends i.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"LazyObservableValue"}constructor(F,I,D){super(),this._debugNameData=F,this._equalityComparator=D,this._isUpToDate=!0,this._deltas=[],this._updateCounter=0,this._value=I}get(){return this._update(),this._value}_update(){if(!this._isUpToDate)if(this._isUpToDate=!0,this._deltas.length>0){for(const F of this.observers)for(const I of this._deltas)F.handleChange(this,I);this._deltas.length=0}else for(const F of this.observers)F.handleChange(this,void 0)}_beginUpdate(){if(this._updateCounter++,this._updateCounter===1)for(const F of this.observers)F.beginUpdate(this)}_endUpdate(){if(this._updateCounter--,this._updateCounter===0){this._update();const F=[...this.observers];for(const I of F)I.endUpdate(this)}}addObserver(F){const I=!this.observers.has(F)&&this._updateCounter>0;super.addObserver(F),I&&F.beginUpdate(this)}removeObserver(F){const I=this.observers.has(F)&&this._updateCounter>0;super.removeObserver(F),I&&F.endUpdate(this)}set(F,I,D){if(D===void 0&&this._equalityComparator(this._value,F))return;let w;I||(I=w=new i.TransactionImpl(()=>{},()=>`Setting ${this.debugName}`));try{if(this._isUpToDate=!1,this._setValue(F),D!==void 0&&this._deltas.push(D),I.updateObserver({beginUpdate:()=>this._beginUpdate(),endUpdate:()=>this._endUpdate(),handleChange:(d,v)=>{},handlePossibleChange:d=>{}},this),this._updateCounter>1)for(const d of this.observers)d.handlePossibleChange(this)}finally{w&&w.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(F){this._value=F}}t.LazyObservableValue=n}),define(ve[97],De([1,0,30,27,26,96]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=I;function I(D,w){return D.lazy?new F.LazyObservableValue(new P.DebugNameData(D.owner,D.debugName,void 0),w,D.equalsFn??i.strictEquals):new n.ObservableValue(new P.DebugNameData(D.owner,D.debugName,void 0),w,D.equalsFn??i.strictEquals)}}),define(ve[5],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=f,t.isLittleEndian=x,t.isBigSurOrNewer=y,t.LANGUAGE_DEFAULT="en";let i=!1,n=!1,P=!1,F=!1,I=!1,D=!1,w=!1,d=!1,v=!1,_=!1,b,m=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT,s,r;const c=globalThis;let l;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?l=c.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const E=typeof l?.versions?.electron=="string",T=E&&l?.type==="renderer";if(typeof l=="object"){i=l.platform==="win32",n=l.platform==="darwin",P=l.platform==="linux",F=P&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,w=E,v=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=t.LANGUAGE_DEFAULT,m=t.LANGUAGE_DEFAULT;const O=l.env.VSCODE_NLS_CONFIG;if(O)try{const V=JSON.parse(O);b=V.userLocale,e=V.osLocale,m=V.resolvedLanguage||t.LANGUAGE_DEFAULT,s=V.languagePack?.translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!T?(r=navigator.userAgent,i=r.indexOf("Windows")>=0,n=r.indexOf("Macintosh")>=0,d=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=r.indexOf("Linux")>=0,_=r?.indexOf("Mobi")>=0,D=!0,m=globalThis._VSCODE_NLS_LANGUAGE||t.LANGUAGE_DEFAULT,b=navigator.language.toLowerCase(),e=b):console.error("Unable to resolve platform.");var A;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(A||(t.Platform=A={}));function f(O){switch(O){case A.Web:return"Web";case A.Mac:return"Mac";case A.Linux:return"Linux";case A.Windows:return"Windows"}}let h=A.Web;n?h=A.Mac:i?h=A.Windows:P&&(h=A.Linux),t.isWindows=i,t.isMacintosh=n,t.isLinux=P,t.isLinuxSnap=F,t.isNative=I,t.isElectron=w,t.isWeb=D,t.isWebWorker=D&&typeof c.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?c.origin:void 0,t.isIOS=d,t.isMobile=_,t.isCI=v,t.platform=h,t.userAgent=r,t.language=m;var p;(function(O){function V(){return t.language}O.value=V;function R(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}O.isDefaultVariant=R;function W(){return t.language==="en"}O.isDefault=W})(p||(t.Language=p={})),t.locale=b,t.platformLocale=e,t.translationsConfigFile=s,t.setTimeout0IsFaster=typeof c.postMessage=="function"&&!c.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const O=[];c.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let W=0,G=O.length;W<G;W++){const Q=O[W];if(Q.id===R.data.vscodeScheduleAsyncWork){O.splice(W,1),Q.callback();return}}});let V=0;return R=>{const W=++V;O.push({id:W,callback:R}),c.postMessage({vscodeScheduleAsyncWork:W},"*")}}return O=>setTimeout(O)})();var S;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(S||(t.OperatingSystem=S={})),t.OS=n||d?S.Macintosh:i?S.Windows:S.Linux;let U=!0,H=!1;function x(){if(!H){H=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,U=new Uint16Array(O.buffer)[0]===513}return U}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function y(O){return parseFloat(O)>=20}}),define(ve[98],De([1,0,6,8,5]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=void 0,t.decodeKeybinding=I,t.createSimpleKeybinding=D;var F;(function(m){m[m.CtrlCmd=2048]="CtrlCmd",m[m.Shift=1024]="Shift",m[m.Alt=512]="Alt",m[m.WinCtrl=256]="WinCtrl",m[m.KeyCode=255]="KeyCode"})(F||(F={}));function I(m,e){if(typeof m=="number"){if(m===0)return null;const s=(m&65535)>>>0,r=(m&4294901760)>>>16;return r!==0?new v([D(s,e),D(r,e)]):new v([D(s,e)])}else{const s=[];for(let r=0;r<m.length;r++)s.push(D(m[r],e));return new v(s)}}function D(m,e){const s=!!(m&F.CtrlCmd),r=!!(m&F.WinCtrl),c=e===P.OperatingSystem.Macintosh?r:s,l=!!(m&F.Shift),E=!!(m&F.Alt),T=e===P.OperatingSystem.Macintosh?s:r,A=m&F.KeyCode;return new w(c,l,E,T,A)}class w{constructor(e,s,r,c,l){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=c,this.keyCode=l}equals(e){return e instanceof w&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",r=this.altKey?"1":"0",c=this.metaKey?"1":"0";return`K${e}${s}${r}${c}${this.keyCode}`}isModifierKey(){return this.keyCode===n.KeyCode.Unknown||this.keyCode===n.KeyCode.Ctrl||this.keyCode===n.KeyCode.Meta||this.keyCode===n.KeyCode.Alt||this.keyCode===n.KeyCode.Shift}toKeybinding(){return new v([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===n.KeyCode.Ctrl||this.shiftKey&&this.keyCode===n.KeyCode.Shift||this.altKey&&this.keyCode===n.KeyCode.Alt||this.metaKey&&this.keyCode===n.KeyCode.Meta}}t.KeyCodeChord=w;class d{constructor(e,s,r,c,l){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=c,this.scanCode=l}equals(e){return e instanceof d&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",r=this.altKey?"1":"0",c=this.metaKey?"1":"0";return`S${e}${s}${r}${c}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===n.ScanCode.ControlLeft||this.scanCode===n.ScanCode.ControlRight)||this.shiftKey&&(this.scanCode===n.ScanCode.ShiftLeft||this.scanCode===n.ScanCode.ShiftRight)||this.altKey&&(this.scanCode===n.ScanCode.AltLeft||this.scanCode===n.ScanCode.AltRight)||this.metaKey&&(this.scanCode===n.ScanCode.MetaLeft||this.scanCode===n.ScanCode.MetaRight)}}t.ScanCodeChord=d;class v{constructor(e){if(e.length===0)throw(0,i.illegalArgument)("chords");this.chords=e}getHashCode(){let e="";for(let s=0,r=this.chords.length;s<r;s++)s!==0&&(e+=";"),e+=this.chords[s].getHashCode();return e}equals(e){if(e===null||this.chords.length!==e.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(e.chords[s]))return!1;return!0}}t.Keybinding=v;class _{constructor(e,s,r,c,l,E){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=c,this.keyLabel=l,this.keyAriaLabel=E}}t.ResolvedChord=_;class b{}t.ResolvedKeybinding=b}),define(ve[99],De([1,0,5]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let n;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const F=P.process;n={get platform(){return F.platform},get arch(){return F.arch},get env(){return F.env},cwd(){return F.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.platform=n.platform,t.arch=n.arch}),define(ve[28],De([1,0,99]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0,i=Ue(i);const n=65,P=97,F=90,I=122,D=46,w=47,d=92,v=58,_=63;class b extends Error{constructor(p,S,U){let H;typeof S=="string"&&S.indexOf("not ")===0?(H="must not be",S=S.replace(/^not /,"")):H="must be";const x=p.indexOf(".")!==-1?"property":"argument";let y=`The "${p}" ${x} ${H} of type ${S}`;y+=`. Received type ${typeof U}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function m(h,p){if(h===null||typeof h!="object")throw new b(p,"Object",h)}function e(h,p){if(typeof h!="string")throw new b(p,"string",h)}const s=i.platform==="win32";function r(h){return h===w||h===d}function c(h){return h===w}function l(h){return h>=n&&h<=F||h>=P&&h<=I}function E(h,p,S,U){let H="",x=0,y=-1,O=0,V=0;for(let R=0;R<=h.length;++R){if(R<h.length)V=h.charCodeAt(R);else{if(U(V))break;V=w}if(U(V)){if(!(y===R-1||O===1))if(O===2){if(H.length<2||x!==2||H.charCodeAt(H.length-1)!==D||H.charCodeAt(H.length-2)!==D){if(H.length>2){const W=H.lastIndexOf(S);W===-1?(H="",x=0):(H=H.slice(0,W),x=H.length-1-H.lastIndexOf(S)),y=R,O=0;continue}else if(H.length!==0){H="",x=0,y=R,O=0;continue}}p&&(H+=H.length>0?`${S}..`:"..",x=2)}else H.length>0?H+=`${S}${h.slice(y+1,R)}`:H=h.slice(y+1,R),x=R-y-1;y=R,O=0}else V===D&&O!==-1?++O:O=-1}return H}function T(h){return h?`${h[0]==="."?"":"."}${h}`:""}function A(h,p){m(p,"pathObject");const S=p.dir||p.root,U=p.base||`${p.name||""}${T(p.ext)}`;return S?S===p.root?`${S}${U}`:`${S}${h}${U}`:U}t.win32={resolve(...h){let p="",S="",U=!1;for(let H=h.length-1;H>=-1;H--){let x;if(H>=0){if(x=h[H],e(x,`paths[${H}]`),x.length===0)continue}else p.length===0?x=i.cwd():(x=i.env[`=${p}`]||i.cwd(),(x===void 0||x.slice(0,2).toLowerCase()!==p.toLowerCase()&&x.charCodeAt(2)===d)&&(x=`${p}\\`));const y=x.length;let O=0,V="",R=!1;const W=x.charCodeAt(0);if(y===1)r(W)&&(O=1,R=!0);else if(r(W))if(R=!0,r(x.charCodeAt(1))){let G=2,Q=G;for(;G<y&&!r(x.charCodeAt(G));)G++;if(G<y&&G!==Q){const j=x.slice(Q,G);for(Q=G;G<y&&r(x.charCodeAt(G));)G++;if(G<y&&G!==Q){for(Q=G;G<y&&!r(x.charCodeAt(G));)G++;(G===y||G!==Q)&&(V=`\\\\${j}\\${x.slice(Q,G)}`,O=G)}}}else O=1;else l(W)&&x.charCodeAt(1)===v&&(V=x.slice(0,2),O=2,y>2&&r(x.charCodeAt(2))&&(R=!0,O=3));if(V.length>0)if(p.length>0){if(V.toLowerCase()!==p.toLowerCase())continue}else p=V;if(U){if(p.length>0)break}else if(S=`${x.slice(O)}\\${S}`,U=R,R&&p.length>0)break}return S=E(S,!U,"\\",r),U?`${p}\\${S}`:`${p}${S}`||"."},normalize(h){e(h,"path");const p=h.length;if(p===0)return".";let S=0,U,H=!1;const x=h.charCodeAt(0);if(p===1)return c(x)?"\\":h;if(r(x))if(H=!0,r(h.charCodeAt(1))){let O=2,V=O;for(;O<p&&!r(h.charCodeAt(O));)O++;if(O<p&&O!==V){const R=h.slice(V,O);for(V=O;O<p&&r(h.charCodeAt(O));)O++;if(O<p&&O!==V){for(V=O;O<p&&!r(h.charCodeAt(O));)O++;if(O===p)return`\\\\${R}\\${h.slice(V)}\\`;O!==V&&(U=`\\\\${R}\\${h.slice(V,O)}`,S=O)}}}else S=1;else l(x)&&h.charCodeAt(1)===v&&(U=h.slice(0,2),S=2,p>2&&r(h.charCodeAt(2))&&(H=!0,S=3));let y=S<p?E(h.slice(S),!H,"\\",r):"";return y.length===0&&!H&&(y="."),y.length>0&&r(h.charCodeAt(p-1))&&(y+="\\"),U===void 0?H?`\\${y}`:y:H?`${U}\\${y}`:`${U}${y}`},isAbsolute(h){e(h,"path");const p=h.length;if(p===0)return!1;const S=h.charCodeAt(0);return r(S)||p>2&&l(S)&&h.charCodeAt(1)===v&&r(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let p,S;for(let x=0;x<h.length;++x){const y=h[x];e(y,"path"),y.length>0&&(p===void 0?p=S=y:p+=`\\${y}`)}if(p===void 0)return".";let U=!0,H=0;if(typeof S=="string"&&r(S.charCodeAt(0))){++H;const x=S.length;x>1&&r(S.charCodeAt(1))&&(++H,x>2&&(r(S.charCodeAt(2))?++H:U=!1))}if(U){for(;H<p.length&&r(p.charCodeAt(H));)H++;H>=2&&(p=`\\${p.slice(H)}`)}return t.win32.normalize(p)},relative(h,p){if(e(h,"from"),e(p,"to"),h===p)return"";const S=t.win32.resolve(h),U=t.win32.resolve(p);if(S===U||(h=S.toLowerCase(),p=U.toLowerCase(),h===p))return"";let H=0;for(;H<h.length&&h.charCodeAt(H)===d;)H++;let x=h.length;for(;x-1>H&&h.charCodeAt(x-1)===d;)x--;const y=x-H;let O=0;for(;O<p.length&&p.charCodeAt(O)===d;)O++;let V=p.length;for(;V-1>O&&p.charCodeAt(V-1)===d;)V--;const R=V-O,W=y<R?y:R;let G=-1,Q=0;for(;Q<W;Q++){const q=h.charCodeAt(H+Q);if(q!==p.charCodeAt(O+Q))break;q===d&&(G=Q)}if(Q!==W){if(G===-1)return U}else{if(R>W){if(p.charCodeAt(O+Q)===d)return U.slice(O+Q+1);if(Q===2)return U.slice(O+Q)}y>W&&(h.charCodeAt(H+Q)===d?G=Q:Q===2&&(G=3)),G===-1&&(G=0)}let j="";for(Q=H+G+1;Q<=x;++Q)(Q===x||h.charCodeAt(Q)===d)&&(j+=j.length===0?"..":"\\..");return O+=G,j.length>0?`${j}${U.slice(O,V)}`:(U.charCodeAt(O)===d&&++O,U.slice(O,V))},toNamespacedPath(h){if(typeof h!="string"||h.length===0)return h;const p=t.win32.resolve(h);if(p.length<=2)return h;if(p.charCodeAt(0)===d){if(p.charCodeAt(1)===d){const S=p.charCodeAt(2);if(S!==_&&S!==D)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(l(p.charCodeAt(0))&&p.charCodeAt(1)===v&&p.charCodeAt(2)===d)return`\\\\?\\${p}`;return h},dirname(h){e(h,"path");const p=h.length;if(p===0)return".";let S=-1,U=0;const H=h.charCodeAt(0);if(p===1)return r(H)?h:".";if(r(H)){if(S=U=1,r(h.charCodeAt(1))){let O=2,V=O;for(;O<p&&!r(h.charCodeAt(O));)O++;if(O<p&&O!==V){for(V=O;O<p&&r(h.charCodeAt(O));)O++;if(O<p&&O!==V){for(V=O;O<p&&!r(h.charCodeAt(O));)O++;if(O===p)return h;O!==V&&(S=U=O+1)}}}}else l(H)&&h.charCodeAt(1)===v&&(S=p>2&&r(h.charCodeAt(2))?3:2,U=S);let x=-1,y=!0;for(let O=p-1;O>=U;--O)if(r(h.charCodeAt(O))){if(!y){x=O;break}}else y=!1;if(x===-1){if(S===-1)return".";x=S}return h.slice(0,x)},basename(h,p){p!==void 0&&e(p,"suffix"),e(h,"path");let S=0,U=-1,H=!0,x;if(h.length>=2&&l(h.charCodeAt(0))&&h.charCodeAt(1)===v&&(S=2),p!==void 0&&p.length>0&&p.length<=h.length){if(p===h)return"";let y=p.length-1,O=-1;for(x=h.length-1;x>=S;--x){const V=h.charCodeAt(x);if(r(V)){if(!H){S=x+1;break}}else O===-1&&(H=!1,O=x+1),y>=0&&(V===p.charCodeAt(y)?--y===-1&&(U=x):(y=-1,U=O))}return S===U?U=O:U===-1&&(U=h.length),h.slice(S,U)}for(x=h.length-1;x>=S;--x)if(r(h.charCodeAt(x))){if(!H){S=x+1;break}}else U===-1&&(H=!1,U=x+1);return U===-1?"":h.slice(S,U)},extname(h){e(h,"path");let p=0,S=-1,U=0,H=-1,x=!0,y=0;h.length>=2&&h.charCodeAt(1)===v&&l(h.charCodeAt(0))&&(p=U=2);for(let O=h.length-1;O>=p;--O){const V=h.charCodeAt(O);if(r(V)){if(!x){U=O+1;break}continue}H===-1&&(x=!1,H=O+1),V===D?S===-1?S=O:y!==1&&(y=1):S!==-1&&(y=-1)}return S===-1||H===-1||y===0||y===1&&S===H-1&&S===U+1?"":h.slice(S,H)},format:A.bind(null,"\\"),parse(h){e(h,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return p;const S=h.length;let U=0,H=h.charCodeAt(0);if(S===1)return r(H)?(p.root=p.dir=h,p):(p.base=p.name=h,p);if(r(H)){if(U=1,r(h.charCodeAt(1))){let G=2,Q=G;for(;G<S&&!r(h.charCodeAt(G));)G++;if(G<S&&G!==Q){for(Q=G;G<S&&r(h.charCodeAt(G));)G++;if(G<S&&G!==Q){for(Q=G;G<S&&!r(h.charCodeAt(G));)G++;G===S?U=G:G!==Q&&(U=G+1)}}}}else if(l(H)&&h.charCodeAt(1)===v){if(S<=2)return p.root=p.dir=h,p;if(U=2,r(h.charCodeAt(2))){if(S===3)return p.root=p.dir=h,p;U=3}}U>0&&(p.root=h.slice(0,U));let x=-1,y=U,O=-1,V=!0,R=h.length-1,W=0;for(;R>=U;--R){if(H=h.charCodeAt(R),r(H)){if(!V){y=R+1;break}continue}O===-1&&(V=!1,O=R+1),H===D?x===-1?x=R:W!==1&&(W=1):x!==-1&&(W=-1)}return O!==-1&&(x===-1||W===0||W===1&&x===O-1&&x===y+1?p.base=p.name=h.slice(y,O):(p.name=h.slice(y,x),p.base=h.slice(y,O),p.ext=h.slice(x,O))),y>0&&y!==U?p.dir=h.slice(0,y-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(s){const h=/\\/g;return()=>{const p=i.cwd().replace(h,"/");return p.slice(p.indexOf("/"))}}return()=>i.cwd()})();t.posix={resolve(...h){let p="",S=!1;for(let U=h.length-1;U>=-1&&!S;U--){const H=U>=0?h[U]:f();e(H,`paths[${U}]`),H.length!==0&&(p=`${H}/${p}`,S=H.charCodeAt(0)===w)}return p=E(p,!S,"/",c),S?`/${p}`:p.length>0?p:"."},normalize(h){if(e(h,"path"),h.length===0)return".";const p=h.charCodeAt(0)===w,S=h.charCodeAt(h.length-1)===w;return h=E(h,!p,"/",c),h.length===0?p?"/":S?"./":".":(S&&(h+="/"),p?`/${h}`:h)},isAbsolute(h){return e(h,"path"),h.length>0&&h.charCodeAt(0)===w},join(...h){if(h.length===0)return".";let p;for(let S=0;S<h.length;++S){const U=h[S];e(U,"path"),U.length>0&&(p===void 0?p=U:p+=`/${U}`)}return p===void 0?".":t.posix.normalize(p)},relative(h,p){if(e(h,"from"),e(p,"to"),h===p||(h=t.posix.resolve(h),p=t.posix.resolve(p),h===p))return"";const S=1,U=h.length,H=U-S,x=1,y=p.length-x,O=H<y?H:y;let V=-1,R=0;for(;R<O;R++){const G=h.charCodeAt(S+R);if(G!==p.charCodeAt(x+R))break;G===w&&(V=R)}if(R===O)if(y>O){if(p.charCodeAt(x+R)===w)return p.slice(x+R+1);if(R===0)return p.slice(x+R)}else H>O&&(h.charCodeAt(S+R)===w?V=R:R===0&&(V=0));let W="";for(R=S+V+1;R<=U;++R)(R===U||h.charCodeAt(R)===w)&&(W+=W.length===0?"..":"/..");return`${W}${p.slice(x+V)}`},toNamespacedPath(h){return h},dirname(h){if(e(h,"path"),h.length===0)return".";const p=h.charCodeAt(0)===w;let S=-1,U=!0;for(let H=h.length-1;H>=1;--H)if(h.charCodeAt(H)===w){if(!U){S=H;break}}else U=!1;return S===-1?p?"/":".":p&&S===1?"//":h.slice(0,S)},basename(h,p){p!==void 0&&e(p,"ext"),e(h,"path");let S=0,U=-1,H=!0,x;if(p!==void 0&&p.length>0&&p.length<=h.length){if(p===h)return"";let y=p.length-1,O=-1;for(x=h.length-1;x>=0;--x){const V=h.charCodeAt(x);if(V===w){if(!H){S=x+1;break}}else O===-1&&(H=!1,O=x+1),y>=0&&(V===p.charCodeAt(y)?--y===-1&&(U=x):(y=-1,U=O))}return S===U?U=O:U===-1&&(U=h.length),h.slice(S,U)}for(x=h.length-1;x>=0;--x)if(h.charCodeAt(x)===w){if(!H){S=x+1;break}}else U===-1&&(H=!1,U=x+1);return U===-1?"":h.slice(S,U)},extname(h){e(h,"path");let p=-1,S=0,U=-1,H=!0,x=0;for(let y=h.length-1;y>=0;--y){const O=h.charCodeAt(y);if(O===w){if(!H){S=y+1;break}continue}U===-1&&(H=!1,U=y+1),O===D?p===-1?p=y:x!==1&&(x=1):p!==-1&&(x=-1)}return p===-1||U===-1||x===0||x===1&&p===U-1&&p===S+1?"":h.slice(p,U)},format:A.bind(null,"/"),parse(h){e(h,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return p;const S=h.charCodeAt(0)===w;let U;S?(p.root="/",U=1):U=0;let H=-1,x=0,y=-1,O=!0,V=h.length-1,R=0;for(;V>=U;--V){const W=h.charCodeAt(V);if(W===w){if(!O){x=V+1;break}continue}y===-1&&(O=!1,y=V+1),W===D?H===-1?H=V:R!==1&&(R=1):H!==-1&&(R=-1)}if(y!==-1){const W=x===0&&S?1:x;H===-1||R===0||R===1&&H===y-1&&H===x+1?p.base=p.name=h.slice(W,y):(p.name=h.slice(W,H),p.base=h.slice(W,y),p.ext=h.slice(H,y))}return x>0?p.dir=h.slice(0,x-1):S&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=s?t.win32.normalize:t.posix.normalize,t.isAbsolute=s?t.win32.isAbsolute:t.posix.isAbsolute,t.join=s?t.win32.join:t.posix.join,t.resolve=s?t.win32.resolve:t.posix.resolve,t.relative=s?t.win32.relative:t.posix.relative,t.dirname=s?t.win32.dirname:t.posix.dirname,t.basename=s?t.win32.basename:t.posix.basename,t.extname=s?t.win32.extname:t.posix.extname,t.format=s?t.win32.format:t.posix.format,t.parse=s?t.win32.parse:t.posix.parse,t.toNamespacedPath=s?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=s?t.win32.sep:t.posix.sep,t.delimiter=s?t.win32.delimiter:t.posix.delimiter}),define(ve[100],De([1,0,28]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Mimes=void 0,t.getMediaOrTextMime=F,t.getMediaMime=I,t.getExtensionForMimeType=D,t.normalizeMimeType=d,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(v){const _=(0,i.extname)(v),b=n[_.toLowerCase()];return b!==void 0?b:I(v)}function I(v){const _=(0,i.extname)(v);return P[_.toLowerCase()]}function D(v){for(const _ in P)if(P[_]===v)return _}const w=/^(.+)\/(.+?)(;.+)?$/;function d(v,_){const b=w.exec(v);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:_?void 0:v}}),define(ve[46],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(n){function P(w,d){if(w.start>=d.end||d.start>=w.end)return{start:0,end:0};const v=Math.max(w.start,d.start),_=Math.min(w.end,d.end);return _-v<=0?{start:0,end:0}:{start:v,end:_}}n.intersect=P;function F(w){return w.end-w.start<=0}n.isEmpty=F;function I(w,d){return!F(P(w,d))}n.intersects=I;function D(w,d){const v=[],_={start:w.start,end:Math.min(d.start,w.end)},b={start:Math.max(d.end,w.start),end:w.end};return F(_)||v.push(_),F(b)||v.push(b),v}n.relativeComplement=D})(i||(t.Range=i={}))}),define(ve[101],De([1,0,46]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=void 0,t.groupIntersect=n,t.shift=P,t.consolidate=F;function n(w,d){const v=[];for(const _ of d){if(w.start>=_.range.end)continue;if(w.end<_.range.start)break;const b=i.Range.intersect(w,_.range);i.Range.isEmpty(b)||v.push({range:b,size:_.size})}return v}function P({start:w,end:d},v){return{start:w+v,end:d+v}}function F(w){const d=[];let v=null;for(const _ of w){const b=_.range.start,m=_.range.end,e=_.size;if(v&&e===v.size){v.range.end=m;continue}v={range:{start:b,end:m},size:e},d.push(v)}return d}function I(...w){return F(w.reduce((d,v)=>d.concat(v),[]))}class D{get paddingTop(){return this._paddingTop}set paddingTop(d){this._size=this._size+d-this._paddingTop,this._paddingTop=d}constructor(d){this.groups=[],this._size=0,this._paddingTop=0,this._paddingTop=d??0,this._size=this._paddingTop}splice(d,v,_=[]){const b=_.length-v,m=n({start:0,end:d},this.groups),e=n({start:d+v,end:Number.POSITIVE_INFINITY},this.groups).map(r=>({range:P(r.range,b),size:r.size})),s=_.map((r,c)=>({range:{start:d+c,end:d+c+1},size:r.size}));this.groups=I(m,s,e),this._size=this._paddingTop+this.groups.reduce((r,c)=>r+c.size*(c.range.end-c.range.start),0)}get count(){const d=this.groups.length;return d?this.groups[d-1].range.end:0}get size(){return this._size}indexAt(d){if(d<0)return-1;if(d<this._paddingTop)return 0;let v=0,_=this._paddingTop;for(const b of this.groups){const m=b.range.end-b.range.start,e=_+m*b.size;if(d<e)return v+Math.floor((d-_)/b.size);v+=m,_=e}return v}indexAfter(d){return Math.min(this.indexAt(d)+1,this.count)}positionAt(d){if(d<0)return-1;let v=0,_=0;for(const b of this.groups){const m=b.range.end-b.range.start,e=_+m;if(d<e)return this._paddingTop+v+(d-_)*b.size;v+=m*b.size,_=e}return-1}}t.RangeMap=D}),define(ve[102],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(F){return new n(F)}constructor(F){this._now=i&&F===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=n}),define(ve[3],De([1,0,6,58,2,59,102]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEvent=t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.ListenerRefusalError=t.ListenerLeakError=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=m;const D=!1,w=!1,d=!1;var v;(function(j){j.None=()=>P.Disposable.None;function q(M){if(d){const{onDidAddListener:z}=M,X=s.create();let ie=0;M.onDidAddListener=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),z?.()}}}function J(M,z){return te(M,()=>{},0,void 0,!0,void 0,z)}j.defer=J;function le(M){return(z,X=null,ie)=>{let re=!1,ce;return ce=M(we=>{if(!re)return ce?ce.dispose():re=!0,z.call(X,we)},null,ie),re&&ce.dispose(),ce}}j.once=le;function me(M,z,X){return ae((ie,re=null,ce)=>M(we=>ie.call(re,z(we)),null,ce),X)}j.map=me;function _e(M,z,X){return ae((ie,re=null,ce)=>M(we=>{z(we),ie.call(re,we)},null,ce),X)}j.forEach=_e;function Ne(M,z,X){return ae((ie,re=null,ce)=>M(we=>z(we)&&ie.call(re,we),null,ce),X)}j.filter=Ne;function ne(M){return M}j.signal=ne;function ee(...M){return(z,X=null,ie)=>{const re=(0,P.combinedDisposable)(...M.map(ce=>ce(we=>z.call(X,we))));return Le(re,ie)}}j.any=ee;function he(M,z,X,ie){let re=X;return me(M,ce=>(re=z(re,ce),re),ie)}j.reduce=he;function ae(M,z){let X;const ie={onWillAddFirstListener(){X=M(re.fire,re)},onDidRemoveLastListener(){X?.dispose()}};z||q(ie);const re=new h(ie);return z?.add(re),re.event}function Le(M,z){return z instanceof Array?z.push(M):z&&z.add(M),M}function te(M,z,X=100,ie=!1,re=!1,ce,we){let Ee,ye,Ie,de=0,Fe;const qe={leakWarningThreshold:ce,onWillAddFirstListener(){Ee=M(tt=>{de++,ye=z(ye,tt),ie&&!Ie&&(Ye.fire(ye),ye=void 0),Fe=()=>{const at=ye;ye=void 0,Ie=void 0,(!ie||de>1)&&Ye.fire(at),de=0},typeof X=="number"?(clearTimeout(Ie),Ie=setTimeout(Fe,X)):Ie===void 0&&(Ie=0,queueMicrotask(Fe))})},onWillRemoveListener(){re&&de>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,Ee.dispose()}};we||q(qe);const Ye=new h(qe);return we?.add(Ye),Ye.event}j.debounce=te;function pe(M,z=0,X){return j.debounce(M,(ie,re)=>ie?(ie.push(re),ie):[re],z,void 0,!0,void 0,X)}j.accumulate=pe;function Ae(M,z=(ie,re)=>ie===re,X){let ie=!0,re;return Ne(M,ce=>{const we=ie||!z(ce,re);return ie=!1,re=ce,we},X)}j.latch=Ae;function Ce(M,z,X){return[j.filter(M,z,X),j.filter(M,ie=>!z(ie),X)]}j.split=Ce;function Re(M,z=!1,X=[],ie){let re=X.slice(),ce=M(ye=>{re?re.push(ye):Ee.fire(ye)});ie&&ie.add(ce);const we=()=>{re?.forEach(ye=>Ee.fire(ye)),re=null},Ee=new h({onWillAddFirstListener(){ce||(ce=M(ye=>Ee.fire(ye)),ie&&ie.add(ce))},onDidAddFirstListener(){re&&(z?setTimeout(we):we())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return ie&&ie.add(Ee),Ee.event}j.buffer=Re;function xe(M,z){return(ie,re,ce)=>{const we=z(new $);return M(function(Ee){const ye=we.evaluate(Ee);ye!==He&&ie.call(re,ye)},void 0,ce)}}j.chain=xe;const He=Symbol("HaltChainable");class ${constructor(){this.steps=[]}map(z){return this.steps.push(z),this}forEach(z){return this.steps.push(X=>(z(X),X)),this}filter(z){return this.steps.push(X=>z(X)?X:He),this}reduce(z,X){let ie=X;return this.steps.push(re=>(ie=z(ie,re),ie)),this}latch(z=(X,ie)=>X===ie){let X=!0,ie;return this.steps.push(re=>{const ce=X||!z(re,ie);return X=!1,ie=re,ce?re:He}),this}evaluate(z){for(const X of this.steps)if(z=X(z),z===He)break;return z}}function B(M,z,X=ie=>ie){const ie=(...Ee)=>we.fire(X(...Ee)),re=()=>M.on(z,ie),ce=()=>M.removeListener(z,ie),we=new h({onWillAddFirstListener:re,onDidRemoveLastListener:ce});return we.event}j.fromNodeEventEmitter=B;function a(M,z,X=ie=>ie){const ie=(...Ee)=>we.fire(X(...Ee)),re=()=>M.addEventListener(z,ie),ce=()=>M.removeEventListener(z,ie),we=new h({onWillAddFirstListener:re,onDidRemoveLastListener:ce});return we.event}j.fromDOMEventEmitter=a;function o(M){return new Promise(z=>le(M)(z))}j.toPromise=o;function g(M){const z=new h;return M.then(X=>{z.fire(X)},()=>{z.fire(void 0)}).finally(()=>{z.dispose()}),z.event}j.fromPromise=g;function k(M,z){return M(X=>z.fire(X))}j.forward=k;function L(M,z,X){return z(X),M(ie=>z(ie))}j.runAndSubscribe=L;class u{constructor(z,X){this._observable=z,this._counter=0,this._hasChanged=!1;const ie={onWillAddFirstListener:()=>{z.addObserver(this)},onDidRemoveLastListener:()=>{z.removeObserver(this)}};X||q(ie),this.emitter=new h(ie),X&&X.add(this.emitter)}beginUpdate(z){this._counter++}handlePossibleChange(z){}handleChange(z,X){this._hasChanged=!0}endUpdate(z){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function N(M,z){return new u(M,z).emitter.event}j.fromObservable=N;function C(M){return(z,X,ie)=>{let re=0,ce=!1;const we={beginUpdate(){re++},endUpdate(){re--,re===0&&(M.reportChanges(),ce&&(ce=!1,z.call(X)))},handlePossibleChange(){},handleChange(){ce=!0}};M.addObserver(we),M.reportChanges();const Ee={dispose(){M.removeObserver(we)}};return ie instanceof P.DisposableStore?ie.add(Ee):Array.isArray(ie)&&ie.push(Ee),Ee}}j.fromObservableLight=C})(v||(t.Event=v={}));class _{static{this.all=new Set}static{this._idPool=0}constructor(q){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${q}_${_._idPool++}`,_.all.add(this)}start(q){this._stopWatch=new I.StopWatch,this.listenerCount=q}stop(){if(this._stopWatch){const q=this._stopWatch.elapsed();this.durations.push(q),this.elapsedOverall+=q,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=_;let b=-1;function m(j){const q=b;return b=j,{dispose(){b=q}}}class e{static{this._idPool=1}constructor(q,J,le=(e._idPool++).toString(16).padStart(3,"0")){this._errorHandler=q,this.threshold=J,this.name=le,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(q,J){const le=this.threshold;if(le<=0||J<le)return;this._stacks||(this._stacks=new Map);const me=this._stacks.get(q.value)||0;if(this._stacks.set(q.value,me+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=le*.5;const[_e,Ne]=this.getMostFrequentStack(),ne=`[${this.name}] potential listener LEAK detected, having ${J} listeners already. MOST frequent listener (${Ne}):`;console.warn(ne),console.warn(_e);const ee=new r(ne,_e);this._errorHandler(ee)}return()=>{const _e=this._stacks.get(q.value)||0;this._stacks.set(q.value,_e-1)}}getMostFrequentStack(){if(!this._stacks)return;let q,J=0;for(const[le,me]of this._stacks)(!q||J<me)&&(q=[le,me],J=me);return q}}class s{static create(){const q=new Error;return new s(q.stack??"")}constructor(q){this.value=q}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class r extends Error{constructor(q,J){super(q),this.name="ListenerLeakError",this.stack=J}}t.ListenerLeakError=r;class c extends Error{constructor(q,J){super(q),this.name="ListenerRefusalError",this.stack=J}}t.ListenerRefusalError=c;let l=0;class E{constructor(q){this.value=q,this.id=l++}}const T=2,A=(j,q)=>{if(j instanceof E)q(j);else for(let J=0;J<j.length;J++){const le=j[J];le&&q(le)}};let f;if(D){const j=[];setInterval(()=>{j.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(j.join(`
`)),j.length=0)},3e3),f=new FinalizationRegistry(q=>{typeof q=="string"&&j.push(q)})}class h{constructor(q){this._size=0,this._options=q,this._leakageMon=b>0||this._options?.leakWarningThreshold?new e(q?.onListenerError??i.onUnexpectedError,this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(w){const q=this._listeners;queueMicrotask(()=>{A(q,J=>J.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(q,J,le)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const ee=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(ee);const he=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ae=new c(`${ee}. HINT: Stack shows most frequent listener (${he[1]}-times)`,he[0]);return(this._options?.onListenerError||i.onUnexpectedError)(ae),P.Disposable.None}if(this._disposed)return P.Disposable.None;J&&(q=q.bind(J));const me=new E(q);let _e,Ne;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(me.stack=s.create(),_e=this._leakageMon.check(me.stack,this._size+1)),w&&(me.stack=Ne??s.create()),this._listeners?this._listeners instanceof E?(this._deliveryQueue??=new S,this._listeners=[this._listeners,me]):this._listeners.push(me):(this._options?.onWillAddFirstListener?.(this),this._listeners=me,this._options?.onDidAddFirstListener?.(this)),this._size++;const ne=(0,P.toDisposable)(()=>{f?.unregister(ne),_e?.(),this._removeListener(me)});if(le instanceof P.DisposableStore?le.add(ne):Array.isArray(le)&&le.push(ne),f){const ee=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),he=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(ee);f.register(ne,he?.[2]??ee,ne)}return ne},this._event}_removeListener(q){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const J=this._listeners,le=J.indexOf(q);if(le===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,J[le]=void 0;const me=this._deliveryQueue.current===this;if(this._size*T<=J.length){let _e=0;for(let Ne=0;Ne<J.length;Ne++)J[Ne]?J[_e++]=J[Ne]:me&&(this._deliveryQueue.end--,_e<this._deliveryQueue.i&&this._deliveryQueue.i--);J.length=_e}}_deliver(q,J){if(!q)return;const le=this._options?.onListenerError||i.onUnexpectedError;if(!le){q.value(J);return}try{q.value(J)}catch(me){le(me)}}_deliverQueue(q){const J=q.current._listeners;for(;q.i<q.end;)this._deliver(J[q.i++],q.value);q.reset()}fire(q){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof E)this._deliver(this._listeners,q);else{const J=this._deliveryQueue;J.enqueue(this,q,this._listeners.length),this._deliverQueue(J)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=h;const p=()=>new S;t.createEventDeliveryQueue=p;class S{constructor(){this.i=-1,this.end=0}enqueue(q,J,le){this.i=0,this.end=le,this.current=q,this.value=J}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class U extends h{async fireAsync(q,J,le){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new F.LinkedList),A(this._listeners,me=>this._asyncDeliveryQueue.push([me.value,q]));this._asyncDeliveryQueue.size>0&&!J.isCancellationRequested;){const[me,_e]=this._asyncDeliveryQueue.shift(),Ne=[],ne={..._e,token:J,waitUntil:ee=>{if(Object.isFrozen(Ne))throw new Error("waitUntil can NOT be called asynchronous");le&&(ee=le(ee,me)),Ne.push(ee)}};try{me(ne)}catch(ee){(0,i.onUnexpectedError)(ee);continue}Object.freeze(Ne),await Promise.allSettled(Ne).then(ee=>{for(const he of ee)he.status==="rejected"&&(0,i.onUnexpectedError)(he.reason)})}}}t.AsyncEmitter=U;class H extends h{get isPaused(){return this._isPaused!==0}constructor(q){super(q),this._isPaused=0,this._eventQueue=new F.LinkedList,this._mergeFn=q?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const q=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(q))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(q){this._size&&(this._isPaused!==0?this._eventQueue.push(q):super.fire(q))}}t.PauseableEmitter=H;class x extends H{constructor(q){super(q),this._delay=q.delay??100}fire(q){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(q)}}t.DebounceEmitter=x;class y extends h{constructor(q){super(q),this._queuedEvents=[],this._mergeFn=q?.merge}fire(q){this.hasListeners()&&(this._queuedEvents.push(q),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(J=>super.fire(J)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=y;class O{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(q){const J={event:q,listener:null};this.events.push(J),this.hasListeners&&this.hook(J);const le=()=>{this.hasListeners&&this.unhook(J);const me=this.events.indexOf(J);this.events.splice(me,1)};return(0,P.toDisposable)((0,n.createSingleCallFunction)(le))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(q=>this.hook(q))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(q=>this.unhook(q))}hook(q){q.listener=q.event(J=>this.emitter.fire(J))}unhook(q){q.listener?.dispose(),q.listener=null}dispose(){this.emitter.dispose();for(const q of this.events)q.listener?.dispose();this.events=[]}}t.EventMultiplexer=O;class V{constructor(q,J,le,me){this._store=new P.DisposableStore;const _e=this._store.add(new O),Ne=this._store.add(new P.DisposableMap);function ne(ee){Ne.set(ee,_e.add(me(ee)))}for(const ee of q)ne(ee);this._store.add(J(ee=>{ne(ee)})),this._store.add(le(ee=>{Ne.deleteAndDispose(ee)})),this.event=_e.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=V;class R{constructor(){this.data=[]}wrapEvent(q,J,le){return(me,_e,Ne)=>q(ne=>{const ee=this.data[this.data.length-1];if(!J){ee?ee.buffers.push(()=>me.call(_e,ne)):me.call(_e,ne);return}const he=ee;if(!he){me.call(_e,J(le,ne));return}he.items??=[],he.items.push(ne),he.buffers.length===0&&ee.buffers.push(()=>{he.reducedResult??=le?he.items.reduce(J,le):he.items.reduce(J),me.call(_e,he.reducedResult)})},void 0,Ne)}bufferEvents(q){const J={buffers:new Array};this.data.push(J);const le=q();return this.data.pop(),J.buffers.forEach(me=>me()),le}}t.EventBufferer=R;class W{constructor(){this.listening=!1,this.inputEvent=v.None,this.inputEventListener=P.Disposable.None,this.emitter=new h({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(q){this.inputEvent=q,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=q(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=W;class G{static const(q){return new Q(q)}constructor(q){this._value=q,this._onDidChange=new h,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(q){q!==this._value&&(this._value=q,this._onDidChange.fire(void 0))}}t.ValueWithChangeEvent=G;class Q{constructor(q){this.value=q,this.onDidChange=v.None}}}),define(ve[18],De([1,0,24,3]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.onDidChangeZoomLevel=void 0,t.addMatchMediaChangeListener=F,t.setZoomLevel=I,t.getZoomLevel=D,t.getZoomFactor=w,t.setZoomFactor=d,t.setFullscreen=v,t.isFullscreen=_,t.isStandalone=e,t.isWCOEnabled=s,t.getWCOBoundingRect=r;class P{constructor(){this.mapWindowIdToZoomLevel=new Map,this._onDidChangeZoomLevel=new n.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event,this.mapWindowIdToZoomFactor=new Map,this._onDidChangeFullscreen=new n.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event,this.mapWindowIdToFullScreen=new Map}static{this.INSTANCE=new P}getZoomLevel(l){return this.mapWindowIdToZoomLevel.get(this.getWindowId(l))??0}setZoomLevel(l,E){if(this.getZoomLevel(E)===l)return;const T=this.getWindowId(E);this.mapWindowIdToZoomLevel.set(T,l),this._onDidChangeZoomLevel.fire(T)}getZoomFactor(l){return this.mapWindowIdToZoomFactor.get(this.getWindowId(l))??1}setZoomFactor(l,E){this.mapWindowIdToZoomFactor.set(this.getWindowId(E),l)}setFullscreen(l,E){if(this.isFullscreen(E)===l)return;const T=this.getWindowId(E);this.mapWindowIdToFullScreen.set(T,l),this._onDidChangeFullscreen.fire(T)}isFullscreen(l){return!!this.mapWindowIdToFullScreen.get(this.getWindowId(l))}getWindowId(l){return l.vscodeWindowId}}function F(c,l,E){typeof l=="string"&&(l=c.matchMedia(l)),l.addEventListener("change",E)}function I(c,l){P.INSTANCE.setZoomLevel(c,l)}function D(c){return P.INSTANCE.getZoomLevel(c)}t.onDidChangeZoomLevel=P.INSTANCE.onDidChangeZoomLevel;function w(c){return P.INSTANCE.getZoomFactor(c)}function d(c,l){P.INSTANCE.setZoomFactor(c,l)}function v(c,l){P.INSTANCE.setFullscreen(c,l)}function _(c){return P.INSTANCE.isFullscreen(c)}t.onDidChangeFullscreen=P.INSTANCE.onDidChangeFullscreen;const b=navigator.userAgent;t.isFirefox=b.indexOf("Firefox")>=0,t.isWebKit=b.indexOf("AppleWebKit")>=0,t.isChrome=b.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&b.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=b.indexOf("Electron/")>=0,t.isAndroid=b.indexOf("Android")>=0;let m=!1;if(typeof i.mainWindow.matchMedia=="function"){const c=i.mainWindow.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),l=i.mainWindow.matchMedia("(display-mode: fullscreen)");m=c.matches,F(i.mainWindow,c,({matches:E})=>{m&&l.matches||(m=E)})}function e(){return m}function s(){return navigator?.windowControlsOverlay?.visible}function r(){return navigator?.windowControlsOverlay?.getTitlebarAreaRect()}}),define(ve[61],De([1,0,18,24,5]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0,i=Ue(i),P=Ue(P);var F;(function(I){I[I.Always=0]="Always",I[I.FullScreen=1]="FullScreen",I[I.None=2]="None"})(F||(t.KeyboardSupport=F={})),t.BrowserFeatures={clipboard:{writeText:P.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:P.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:P.isNative||i.isStandalone()?F.Always:navigator.keyboard||i.isSafari?F.FullScreen:F.None,touch:"ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0,pointerEvents:n.mainWindow.PointerEvent&&("ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0)}}),define(ve[29],De([1,0,3]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class n{get event(){return this.emitter.event}constructor(F,I,D){const w=d=>this.emitter.fire(d);this.emitter=new i.Emitter({onWillAddFirstListener:()=>F.addEventListener(I,w,D),onDidRemoveLastListener:()=>F.removeEventListener(I,w,D)})}dispose(){this.emitter.dispose()}}t.DomEmitter=n}),define(ve[15],De([1,0,18,8,98,5]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=void 0,t.printKeyboardEvent=_,t.printStandardKeyboardEvent=b,i=Ue(i),F=Ue(F);function I(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(r)}const s=e.keyCode;if(s===3)return n.KeyCode.PauseBreak;if(i.isFirefox)switch(s){case 59:return n.KeyCode.Semicolon;case 60:if(F.isLinux)return n.KeyCode.IntlBackslash;break;case 61:return n.KeyCode.Equal;case 107:return n.KeyCode.NumpadAdd;case 109:return n.KeyCode.NumpadSubtract;case 173:return n.KeyCode.Minus;case 224:if(F.isMacintosh)return n.KeyCode.Meta;break}else if(i.isWebKit){if(F.isMacintosh&&s===93)return n.KeyCode.Meta;if(!F.isMacintosh&&s===92)return n.KeyCode.Meta}return n.EVENT_KEY_CODE_MAP[s]||n.KeyCode.Unknown}const D=F.isMacintosh?n.KeyMod.WinCtrl:n.KeyMod.CtrlCmd,w=n.KeyMod.Alt,d=n.KeyMod.Shift,v=F.isMacintosh?n.KeyMod.CtrlCmd:n.KeyMod.WinCtrl;function _(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function b(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${n.KeyCodeUtils.toString(e.keyCode)}')`}class m{constructor(s){this._standardKeyboardEventBrand=!0;const r=s;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState?.("AltGraph"),this.keyCode=I(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===n.KeyCode.Ctrl,this.altKey=this.altKey||this.keyCode===n.KeyCode.Alt,this.shiftKey=this.shiftKey||this.keyCode===n.KeyCode.Shift,this.metaKey=this.metaKey||this.keyCode===n.KeyCode.Meta,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(s){return this._asKeybinding===s}_computeKeybinding(){let s=n.KeyCode.Unknown;this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode);let r=0;return this.ctrlKey&&(r|=D),this.altKey&&(r|=w),this.shiftKey&&(r|=d),this.metaKey&&(r|=v),r|=s,r}_computeKeyCodeChord(){let s=n.KeyCode.Unknown;return this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode),new P.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=m}),define(ve[19],De([1,0,18,85,5]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0,i=Ue(i),P=Ue(P);class F{constructor(d,v){this.timestamp=Date.now(),this.browserEvent=v,this.leftButton=v.button===0,this.middleButton=v.button===1,this.rightButton=v.button===2,this.buttons=v.buttons,this.target=v.target,this.detail=v.detail||1,v.type==="dblclick"&&(this.detail=2),this.ctrlKey=v.ctrlKey,this.shiftKey=v.shiftKey,this.altKey=v.altKey,this.metaKey=v.metaKey,typeof v.pageX=="number"?(this.posx=v.pageX,this.posy=v.pageY):(this.posx=v.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=v.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const _=n.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(d,v.view);this.posx-=_.left,this.posy-=_.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=F;class I extends F{constructor(d,v){super(d,v),this.dataTransfer=v.dataTransfer}}t.DragMouseEvent=I;class D{constructor(d,v=0,_=0){this.browserEvent=d||null,this.target=d?d.target||d.targetNode||d.srcElement:null,this.deltaY=_,this.deltaX=v;let b=!1;if(i.isChrome){const m=navigator.userAgent.match(/Chrome\/(\d+)/);b=(m?parseInt(m[1]):123)<=122}if(d){const m=d,e=d,s=d.view?.devicePixelRatio||1;if(typeof m.wheelDeltaY<"u")b?this.deltaY=m.wheelDeltaY/(120*s):this.deltaY=m.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(d.type==="wheel"){const r=d;r.deltaMode===r.DOM_DELTA_LINE?i.isFirefox&&!P.isMacintosh?this.deltaY=-d.deltaY/3:this.deltaY=-d.deltaY:this.deltaY=-d.deltaY/40}if(typeof m.wheelDeltaX<"u")i.isSafari&&P.isWindows?this.deltaX=-(m.wheelDeltaX/120):b?this.deltaX=m.wheelDeltaX/(120*s):this.deltaX=m.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-d.detail/3;else if(d.type==="wheel"){const r=d;r.deltaMode===r.DOM_DELTA_LINE?i.isFirefox&&!P.isMacintosh?this.deltaX=-d.deltaX/3:this.deltaX=-d.deltaX:this.deltaX=-d.deltaX/40}this.deltaY===0&&this.deltaX===0&&d.wheelDelta&&(b?this.deltaY=d.wheelDelta/(120*s):this.deltaY=d.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=D}),define(ve[38],De([1,0,3]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0,t.cancelOnDispose=D;const n=Object.freeze(function(w,d){const v=setTimeout(w.bind(d),0);return{dispose(){clearTimeout(v)}}});var P;(function(w){function d(v){return v===w.None||v===w.Cancelled||v instanceof F?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}w.isCancellationToken=d,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(P||(t.CancellationToken=P={}));class F{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new F),this._token}cancel(){this._token?this._token instanceof F&&this._token.cancel():this._token=P.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof F&&this._token.dispose():this._token=P.None}}t.CancellationTokenSource=I;function D(w){const d=new I;return w.add({dispose(){d.cancel()}}),d.token}}),define(ve[103],De([1,0,38]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0,t.identity=P;class n{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new i.CancellationTokenSource,d=this.task(w.token);return this.result={promise:d,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}t.Cache=n;function P(D){return D}class F{constructor(w,d){this.lastCache=void 0,this.lastArgKey=void 0,typeof w=="function"?(this._fn=w,this._computeKey=P):(this._fn=d,this._computeKey=w.getCacheKey)}get(w){const d=this._computeKey(w);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this._fn(w)),this.lastCache}}t.LRUCachedFunction=F;class I{get cachedValues(){return this._map}constructor(w,d){this._map=new Map,this._map2=new Map,typeof w=="function"?(this._fn=w,this._computeKey=P):(this._fn=d,this._computeKey=w.getCacheKey)}get(w){const d=this._computeKey(w);if(this._map2.has(d))return this._map2.get(d);const v=this._fn(w);return this._map.set(w,v),this._map2.set(d,v),v}}t.CachedFunction=I}),define(ve[104],De([1,0,44,27,45,38,26,30,6]),function(oe,t,i,n,P,F,I,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObservableLazyPromise=t.PromiseResult=t.ObservablePromise=t.ObservableLazy=void 0,t.waitForState=m,t.derivedWithCancellationToken=e;class d{get cachedValue(){return this._value}constructor(r){this._computeValue=r,this._value=(0,n.observableValue)(this,void 0)}getValue(){let r=this._value.get();return r||(r=this._computeValue(),this._value.set(r,void 0)),r}}t.ObservableLazy=d;class v{static fromFn(r){return new v(r())}constructor(r){this._value=(0,n.observableValue)(this,void 0),this.promiseResult=this._value,this.promise=r.then(c=>((0,n.transaction)(l=>{this._value.set(new _(c,void 0),l)}),c),c=>{throw(0,n.transaction)(l=>{this._value.set(new _(void 0,c),l)}),c})}}t.ObservablePromise=v;class _{constructor(r,c){this.data=r,this.error=c}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.PromiseResult=_;class b{constructor(r){this._computePromise=r,this._lazyValue=new d(()=>new v(this._computePromise())),this.cachedPromiseResult=(0,P.derived)(this,c=>this._lazyValue.cachedValue.read(c)?.promiseResult.read(c))}getPromise(){return this._lazyValue.getValue().promise}}t.ObservableLazyPromise=b;function m(s,r,c,l){return r||(r=E=>E!=null),new Promise((E,T)=>{let A=!0,f=!1;const h=s.map(S=>({isFinished:r(S),error:c?c(S):!1,state:S})),p=(0,i.autorun)(S=>{const{isFinished:U,error:H,state:x}=h.read(S);(U||H)&&(A?f=!0:p.dispose(),H?T(H===!0?x:H):E(x))});if(l){const S=l.onCancellationRequested(()=>{p.dispose(),S.dispose(),T(new w.CancellationError)});if(l.isCancellationRequested){p.dispose(),S.dispose(),T(new w.CancellationError);return}}A=!1,f&&p.dispose()})}function e(s,r){let c,l;r===void 0?(c=s,l=void 0):(l=s,c=r);let E;return new P.Derived(new I.DebugNameData(l,void 0,c),T=>(E&&E.dispose(!0),E=new F.CancellationTokenSource,c(T,E.token)),void 0,void 0,()=>E?.dispose(),D.strictEquals)}}),define(ve[105],De([1,0,3,2,44,27,26,45,31,6,30]),function(oe,t,i,n,P,F,I,D,w,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEventFromObservable=t.KeepAliveObserver=t.FromEventObservable=void 0,t.constObservable=_,t.observableFromPromise=m,t.observableFromEvent=e,t.observableFromEventOpts=s,t.observableSignalFromEvent=c,t.observableSignal=E,t.debouncedObservable=A,t.debouncedObservable2=f,t.wasEventTriggeredRecently=h,t.keepObserved=p,t.recomputeInitiallyAndOnChange=S,t.derivedObservableWithCache=H,t.derivedObservableWithWritableCache=x,t.mapObservableArrayCached=y,t.observableFromValueWithChangeEvent=R,t.latestChangedValue=W,t.derivedConstOnceDefined=G;function _(Q){return new b(Q)}class b extends F.ConvenientObservable{constructor(j){super(),this.value=j}get debugName(){return this.toString()}get(){return this.value}addObserver(j){}removeObserver(j){}toString(){return`Const: ${this.value}`}}function m(Q){const j=(0,F.observableValue)("promiseValue",{});return Q.then(q=>{j.set({value:q},void 0)}),j}function e(...Q){let j,q,J;return Q.length===3?[j,q,J]=Q:[q,J]=Q,new r(new I.DebugNameData(j,void 0,J),q,J,()=>r.globalTransaction,v.strictEquals)}function s(Q,j,q){return new r(new I.DebugNameData(Q.owner,Q.debugName,Q.debugReferenceFn??q),j,q,()=>r.globalTransaction,Q.equalsFn??v.strictEquals)}class r extends F.BaseObservable{constructor(j,q,J,le,me){super(),this._debugNameData=j,this.event=q,this._getValue=J,this._getTransaction=le,this._equalityComparator=me,this.hasValue=!1,this.handleEvent=_e=>{const Ne=this._getValue(_e),ne=this.value,ee=!this.hasValue||!this._equalityComparator(ne,Ne);let he=!1;ee&&(this.value=Ne,this.hasValue&&(he=!0,(0,F.subtransaction)(this._getTransaction(),ae=>{(0,w.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:ne,newValue:Ne,change:void 0,didChange:ee,hadValue:this.hasValue});for(const Le of this.observers)ae.updateObserver(Le,this),Le.handleChange(this,void 0)},()=>{const ae=this.getDebugName();return"Event fired"+(ae?`: ${ae}`:"")})),this.hasValue=!0),he||(0,w.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:ne,newValue:Ne,change:void 0,didChange:ee,hadValue:this.hasValue})}}getDebugName(){return this._debugNameData.getDebugName(this)}get debugName(){const j=this.getDebugName();return"From Event"+(j?`: ${j}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}t.FromEventObservable=r,function(Q){Q.Observer=r;function j(q,J){let le=!1;r.globalTransaction===void 0&&(r.globalTransaction=q,le=!0);try{J()}finally{le&&(r.globalTransaction=void 0)}}Q.batchEventsGlobally=j}(e||(t.observableFromEvent=e={}));function c(Q,j){return new l(Q,j)}class l extends F.BaseObservable{constructor(j,q){super(),this.debugName=j,this.event=q,this.handleEvent=()=>{(0,F.transaction)(J=>{for(const le of this.observers)J.updateObserver(le,this),le.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function E(Q){return typeof Q=="string"?new T(Q):new T(void 0,Q)}class T extends F.BaseObservable{get debugName(){return new I.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"Observable Signal"}toString(){return this.debugName}constructor(j,q){super(),this._debugName=j,this._owner=q}trigger(j,q){if(!j){(0,F.transaction)(J=>{this.trigger(J,q)},()=>`Trigger signal ${this.debugName}`);return}for(const J of this.observers)j.updateObserver(J,this),J.handleChange(this,q)}get(){}}function A(Q,j,q){const J=(0,F.observableValue)("debounced",void 0);let le;return q.add((0,P.autorun)(me=>{const _e=Q.read(me);le&&clearTimeout(le),le=setTimeout(()=>{(0,F.transaction)(Ne=>{J.set(_e,Ne)})},j)})),J}function f(Q,j){let q=!1,J,le;return e(me=>{const _e=(0,P.autorun)(Ne=>{const ne=Q.read(Ne);q?(le&&clearTimeout(le),le=setTimeout(()=>{J=ne,me()},j)):(q=!0,J=ne)});return{dispose(){_e.dispose(),q=!1,J=void 0}}},()=>q?J:Q.get())}function h(Q,j,q){const J=(0,F.observableValue)("triggeredRecently",!1);let le;return q.add(Q(()=>{J.set(!0,void 0),le&&clearTimeout(le),le=setTimeout(()=>{J.set(!1,void 0)},j)})),J}function p(Q){const j=new U(!1,void 0);return Q.addObserver(j),(0,n.toDisposable)(()=>{Q.removeObserver(j)})}(0,F._setKeepObserved)(p);function S(Q,j){const q=new U(!0,j);return Q.addObserver(q),j?j(Q.get()):Q.reportChanges(),(0,n.toDisposable)(()=>{Q.removeObserver(q)})}(0,F._setRecomputeInitiallyAndOnChange)(S);class U{constructor(j,q){this._forceRecompute=j,this._handleValue=q,this._counter=0}beginUpdate(j){this._counter++}endUpdate(j){this._counter--,this._counter===0&&this._forceRecompute&&(this._handleValue?this._handleValue(j.get()):j.reportChanges())}handlePossibleChange(j){}handleChange(j,q){}}t.KeepAliveObserver=U;function H(Q,j){let q;return(0,D.derivedOpts)({owner:Q,debugReferenceFn:j},le=>(q=j(le,q),q))}function x(Q,j){let q;const J=E("derivedObservableWithWritableCache"),le=(0,D.derived)(Q,me=>(J.read(me),q=j(me,q),q));return Object.assign(le,{clearCache:me=>{q=void 0,J.trigger(me)},setCache:(me,_e)=>{q=me,J.trigger(_e)}})}function y(Q,j,q,J){let le=new O(q,J);return(0,D.derivedOpts)({debugReferenceFn:q,owner:Q,onLastObserverRemoved:()=>{le.dispose(),le=new O(q)}},_e=>(le.setItems(j.read(_e)),le.getItems()))}class O{constructor(j,q){this._map=j,this._keySelector=q,this._cache=new Map,this._items=[]}dispose(){this._cache.forEach(j=>j.store.dispose()),this._cache.clear()}setItems(j){const q=[],J=new Set(this._cache.keys());for(const le of j){const me=this._keySelector?this._keySelector(le):le;let _e=this._cache.get(me);if(_e)J.delete(me);else{const Ne=new n.DisposableStore;_e={out:this._map(le,Ne),store:Ne},this._cache.set(me,_e)}q.push(_e.out)}for(const le of J)this._cache.get(le).store.dispose(),this._cache.delete(le);this._items=q}getItems(){return this._items}}class V{constructor(j){this.observable=j}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.ValueWithChangeEventFromObservable=V;function R(Q,j){return j instanceof V?j.observable:e(Q,j.onDidChange,()=>j.value)}function W(Q,j){if(j.length===0)throw new d.BugIndicatingError;let q=!1,J;const le=e(Q,me=>{const _e=new n.DisposableStore;for(const Ne of j)_e.add((0,P.autorunOpts)({debugName:()=>(0,I.getDebugName)(le,new I.DebugNameData(Q,void 0,void 0))+".updateLastChangedValue"},ne=>{q=!0,J=Ne.read(ne),me()}));return _e.add({dispose(){q=!1,J=void 0}}),_e},()=>q?J:j[j.length-1].get());return le}function G(Q,j){return H(Q,(q,J)=>J??j(q))}}),define(ve[62],De([1,0,27,45,44,105,104,97,31]),function(oe,t,i,n,P,F,I,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.observableValue}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.disposableObservableValue}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.transaction}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.subtransaction}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return n.derived}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return n.derivedOpts}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return n.derivedHandleChanges}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return n.derivedWithStore}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return P.autorun}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return P.autorunDelta}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return P.autorunHandleChanges}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return P.autorunWithStore}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return P.autorunOpts}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return P.autorunWithStoreHandleChanges}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return F.constObservable}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return F.debouncedObservable}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return F.derivedObservableWithCache}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return F.derivedObservableWithWritableCache}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return F.keepObserved}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return F.recomputeInitiallyAndOnChange}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return F.observableFromEvent}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return F.observableFromPromise}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return F.observableSignal}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return F.observableSignalFromEvent}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return F.wasEventTriggeredRecently}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return I.ObservableLazy}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return I.ObservableLazyPromise}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return I.ObservablePromise}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return I.PromiseResult}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return I.waitForState}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return I.derivedWithCancellationToken}}),Object.defineProperty(t,"observableValueOpts",{enumerable:!0,get:function(){return D.observableValueOpts}}),!1&&(0,w.setLogger)(new w.ConsoleObservableLogger)}),define(ve[20],De([1,0,3,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var P;(function(m){m[m.Auto=1]="Auto",m[m.Hidden=2]="Hidden",m[m.Visible=3]="Visible"})(P||(t.ScrollbarVisibility=P={}));class F{constructor(e,s,r,c,l,E,T){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(s=s|0,r=r|0,c=c|0,l=l|0,E=E|0,T=T|0),this.rawScrollLeft=c,this.rawScrollTop=T,s<0&&(s=0),c+s>r&&(c=r-s),c<0&&(c=0),l<0&&(l=0),T+l>E&&(T=E-l),T<0&&(T=0),this.width=s,this.scrollWidth=r,this.scrollLeft=c,this.height=l,this.scrollHeight=E,this.scrollTop=T}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new F(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new F(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const r=this.width!==e.width,c=this.scrollWidth!==e.scrollWidth,l=this.scrollLeft!==e.scrollLeft,E=this.height!==e.height,T=this.scrollHeight!==e.scrollHeight,A=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:c,scrollLeftChanged:l,heightChanged:E,scrollHeightChanged:T,scrollTopChanged:A}}}t.ScrollState=F;class I extends n.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new i.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new F(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,s){const r=this._state.withScrollDimensions(e,s);this._setState(r,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const s=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(s,!1)}setScrollPositionSmooth(e,s){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const r=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===r.scrollLeft&&this._smoothScrolling.to.scrollTop===r.scrollTop)return;let c;s?c=new v(this._smoothScrolling.from,r,this._smoothScrolling.startTime,this._smoothScrolling.duration):c=this._smoothScrolling.combine(this._state,r,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=c}else{const r=this._state.withScrollPosition(e);this._smoothScrolling=v.start(this._state,r,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),s=this._state.withScrollPosition(e);if(this._setState(s,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,s){const r=this._state;r.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(r,s)))}}t.Scrollable=I;class D{constructor(e,s,r){this.scrollLeft=e,this.scrollTop=s,this.isDone=r}}t.SmoothScrollingUpdate=D;function w(m,e){const s=e-m;return function(r){return m+s*b(r)}}function d(m,e,s){return function(r){return r<s?m(r/s):e((r-s)/(1-s))}}class v{constructor(e,s,r,c){this.from=e,this.to=s,this.duration=c,this.startTime=r,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,s,r){if(Math.abs(e-s)>2.5*r){let l,E;return e<s?(l=e+.75*r,E=s-.75*r):(l=e-.75*r,E=s+.75*r),d(w(e,l),w(E,s),.33)}return w(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const s=(e-this.startTime)/this.duration;if(s<1){const r=this.scrollLeft(s),c=this.scrollTop(s);return new D(r,c,!1)}return new D(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,r){return v.start(e,s,r)}static start(e,s,r){r=r+10;const c=Date.now()-10;return new v(e,s,c,r)}}t.SmoothScrollingOperation=v;function _(m){return Math.pow(m,3)}function b(m){return 1-_(1-m)}}),define(ve[106],De([1,0,6,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isReadable=P,t.isReadableStream=F,t.isReadableBufferedStream=I,t.newWriteableStream=D,t.consumeReadable=d,t.peekReadable=v,t.consumeStream=_,t.listenStream=b,t.peekStream=m,t.toStream=e,t.emptyStream=s,t.toReadable=r,t.transform=c,t.prefixedReadable=l,t.prefixedStream=E;function P(T){const A=T;return A?typeof A.read=="function":!1}function F(T){const A=T;return A?[A.on,A.pause,A.resume,A.destroy].every(f=>typeof f=="function"):!1}function I(T){const A=T;return A?F(A.stream)&&Array.isArray(A.buffer)&&typeof A.ended=="boolean":!1}function D(T,A){return new w(T,A)}class w{constructor(A,f){this.reducer=A,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(A){if(!this.state.destroyed){if(this.state.flowing)this.emitData(A);else if(this.buffer.data.push(A),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(A){this.state.destroyed||(this.state.flowing?this.emitError(A):this.buffer.error.push(A))}end(A){this.state.destroyed||(typeof A<"u"&&this.write(A),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(A){this.listeners.data.slice(0).forEach(f=>f(A))}emitError(A){this.listeners.error.length===0?(0,i.onUnexpectedError)(A):this.listeners.error.slice(0).forEach(f=>f(A))}emitEnd(){this.listeners.end.slice(0).forEach(A=>A())}on(A,f){if(!this.state.destroyed)switch(A){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(A,f){if(this.state.destroyed)return;let h;switch(A){case"data":h=this.listeners.data;break;case"end":h=this.listeners.end;break;case"error":h=this.listeners.error;break}if(h){const p=h.indexOf(f);p>=0&&h.splice(p,1)}}flowData(){if(this.buffer.data.length>0){const A=this.reducer(this.buffer.data);this.emitData(A),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(h=>h())}}flowErrors(){if(this.listeners.error.length>0){for(const A of this.buffer.error)this.emitError(A);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(T,A){const f=[];let h;for(;(h=T.read())!==null;)f.push(h);return A(f)}function v(T,A,f){const h=[];let p;for(;(p=T.read())!==null&&h.length<f;)h.push(p);return p===null&&h.length>0?A(h):{read:()=>{if(h.length>0)return h.shift();if(typeof p<"u"){const S=p;return p=void 0,S}return T.read()}}}function _(T,A){return new Promise((f,h)=>{const p=[];b(T,{onData:S=>{A&&p.push(S)},onError:S=>{A?h(S):f(void 0)},onEnd:()=>{f(A?A(p):void 0)}})})}function b(T,A,f){T.on("error",h=>{f?.isCancellationRequested||A.onError(h)}),T.on("end",()=>{f?.isCancellationRequested||A.onEnd()}),T.on("data",h=>{f?.isCancellationRequested||A.onData(h)})}function m(T,A){return new Promise((f,h)=>{const p=new n.DisposableStore,S=[],U=y=>{if(S.push(y),S.length>A)return p.dispose(),T.pause(),f({stream:T,buffer:S,ended:!1})},H=y=>(p.dispose(),h(y)),x=()=>(p.dispose(),f({stream:T,buffer:S,ended:!0}));p.add((0,n.toDisposable)(()=>T.removeListener("error",H))),T.on("error",H),p.add((0,n.toDisposable)(()=>T.removeListener("end",x))),T.on("end",x),p.add((0,n.toDisposable)(()=>T.removeListener("data",U))),T.on("data",U)})}function e(T,A){const f=D(A);return f.end(T),f}function s(){const T=D(()=>{throw new Error("not supported")});return T.end(),T}function r(T){let A=!1;return{read:()=>A?null:(A=!0,T)}}function c(T,A,f){const h=D(f);return b(T,{onData:p=>h.write(A.data(p)),onError:p=>h.error(A.error?A.error(p):p),onEnd:()=>h.end()}),h}function l(T,A,f){let h=!1;return{read:()=>{const p=A.read();return h?p:(h=!0,p!==null?f([T,p]):T)}}}function E(T,A,f){let h=!1;const p=D(f);return b(A,{onData:S=>h?p.write(S):(h=!0,p.write(f([T,S]))),onError:S=>p.error(S),onEnd:()=>{h||(h=!0,p.write(T)),p.end()}}),p}}),define(ve[47],De([1,0,25,106]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VSBuffer=void 0,t.binaryIndexOf=d,t.readUInt16LE=v,t.writeUInt16LE=_,t.readUInt32BE=b,t.writeUInt32BE=m,t.readUInt32LE=e,t.writeUInt32LE=s,t.readUInt8=r,t.writeUInt8=c,t.readableToBuffer=l,t.bufferToReadable=E,t.streamToBuffer=T,t.bufferedStreamToBuffer=A,t.bufferToStream=f,t.streamToBufferReadableStream=h,t.newWriteableBufferStream=p,t.prefixedBufferReadable=S,t.prefixedBufferStream=U,t.decodeBase64=H,t.encodeBase64=O,n=Ue(n);const P=typeof Buffer<"u",F=new i.Lazy(()=>new Uint8Array(256));let I,D;class w{static alloc(R){return P?new w(Buffer.allocUnsafe(R)):new w(new Uint8Array(R))}static wrap(R){return P&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new w(R)}static fromString(R,W){return!(W?.dontUseNodeBuffer||!1)&&P?new w(Buffer.from(R)):(I||(I=new TextEncoder),new w(I.encode(R)))}static fromByteArray(R){const W=w.alloc(R.length);for(let G=0,Q=R.length;G<Q;G++)W.buffer[G]=R[G];return W}static concat(R,W){if(typeof W>"u"){W=0;for(let j=0,q=R.length;j<q;j++)W+=R[j].byteLength}const G=w.alloc(W);let Q=0;for(let j=0,q=R.length;j<q;j++){const J=R[j];G.set(J,Q),Q+=J.byteLength}return G}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=w.alloc(this.byteLength);return R.set(this),R}toString(){return P?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(R,W){return new w(this.buffer.subarray(R,W))}set(R,W){if(R instanceof w)this.buffer.set(R.buffer,W);else if(R instanceof Uint8Array)this.buffer.set(R,W);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),W);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),W);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return b(this.buffer,R)}writeUInt32BE(R,W){m(this.buffer,R,W)}readUInt32LE(R){return e(this.buffer,R)}writeUInt32LE(R,W){s(this.buffer,R,W)}readUInt8(R){return r(this.buffer,R)}writeUInt8(R,W){c(this.buffer,R,W)}indexOf(R,W=0){return d(this.buffer,R instanceof w?R.buffer:R,W)}}t.VSBuffer=w;function d(V,R,W=0){const G=R.byteLength,Q=V.byteLength;if(G===0)return 0;if(G===1)return V.indexOf(R[0]);if(G>Q-W)return-1;const j=F.value;j.fill(R.length);for(let me=0;me<R.length;me++)j[R[me]]=R.length-me-1;let q=W+R.length-1,J=q,le=-1;for(;q<Q;)if(V[q]===R[J]){if(J===0){le=q;break}q--,J--}else q+=Math.max(R.length-J,j[V[q]]),J=R.length-1;return le}function v(V,R){return V[R+0]<<0>>>0|V[R+1]<<8>>>0}function _(V,R,W){V[W+0]=R&255,R=R>>>8,V[W+1]=R&255}function b(V,R){return V[R]*2**24+V[R+1]*2**16+V[R+2]*2**8+V[R+3]}function m(V,R,W){V[W+3]=R,R=R>>>8,V[W+2]=R,R=R>>>8,V[W+1]=R,R=R>>>8,V[W]=R}function e(V,R){return V[R+0]<<0>>>0|V[R+1]<<8>>>0|V[R+2]<<16>>>0|V[R+3]<<24>>>0}function s(V,R,W){V[W+0]=R&255,R=R>>>8,V[W+1]=R&255,R=R>>>8,V[W+2]=R&255,R=R>>>8,V[W+3]=R&255}function r(V,R){return V[R]}function c(V,R,W){V[W]=R}function l(V){return n.consumeReadable(V,R=>w.concat(R))}function E(V){return n.toReadable(V)}function T(V){return n.consumeStream(V,R=>w.concat(R))}async function A(V){return V.ended?w.concat(V.buffer):w.concat([...V.buffer,await T(V.stream)])}function f(V){return n.toStream(V,R=>w.concat(R))}function h(V){return n.transform(V,{data:R=>typeof R=="string"?w.fromString(R):w.wrap(R)},R=>w.concat(R))}function p(V){return n.newWriteableStream(R=>w.concat(R),V)}function S(V,R){return n.prefixedReadable(V,R,W=>w.concat(W))}function U(V,R){return n.prefixedStream(V,R,W=>w.concat(W))}function H(V){let R=0,W=0,G=0;const Q=new Uint8Array(Math.floor(V.length/4*3)),j=J=>{switch(W){case 3:Q[G++]=R|J,W=0;break;case 2:Q[G++]=R|J>>>2,R=J<<6,W=3;break;case 1:Q[G++]=R|J>>>4,R=J<<4,W=2;break;default:R=J<<2,W=1}};for(let J=0;J<V.length;J++){const le=V.charCodeAt(J);if(le>=65&&le<=90)j(le-65);else if(le>=97&&le<=122)j(le-97+26);else if(le>=48&&le<=57)j(le-48+52);else if(le===43||le===45)j(62);else if(le===47||le===95)j(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${V[J]}`)}}const q=G;for(;W>0;)j(0);return w.wrap(Q).slice(0,q)}const x="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:V},R=!0,W=!1){const G=W?y:x;let Q="";const j=V.byteLength%3;let q=0;for(;q<V.byteLength-j;q+=3){const J=V[q+0],le=V[q+1],me=V[q+2];Q+=G[J>>>2],Q+=G[(J<<4|le>>>4)&63],Q+=G[(le<<2|me>>>6)&63],Q+=G[me&63]}if(j===1){const J=V[q+0];Q+=G[J>>>2],Q+=G[J<<4&63],R&&(Q+="==")}else if(j===2){const J=V[q+0],le=V[q+1];Q+=G[J>>>2],Q+=G[(J<<4|le>>>4)&63],Q+=G[le<<2&63],R&&(Q+="=")}return Q}}),define(ve[63],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ve[10],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=i,t.isStringArray=n,t.isObject=P,t.isTypedArray=F,t.isNumber=I,t.isIterable=D,t.isBoolean=w,t.isUndefined=d,t.isDefined=v,t.isUndefinedOrNull=_,t.assertType=b,t.assertIsDefined=m,t.assertAllDefined=e,t.isEmptyObject=r,t.isFunction=c,t.areFunctions=l,t.validateConstraints=E,t.validateConstraint=T,t.upcast=A;function i(f){return typeof f=="string"}function n(f){return Array.isArray(f)&&f.every(h=>i(h))}function P(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}function F(f){const h=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof h}function I(f){return typeof f=="number"&&!isNaN(f)}function D(f){return!!f&&typeof f[Symbol.iterator]=="function"}function w(f){return f===!0||f===!1}function d(f){return typeof f>"u"}function v(f){return!_(f)}function _(f){return d(f)||f===null}function b(f,h){if(!f)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}function m(f){if(_(f))throw new Error("Assertion Failed: argument is undefined or null");return f}function e(...f){const h=[];for(let p=0;p<f.length;p++){const S=f[p];if(_(S))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);h.push(S)}return h}const s=Object.prototype.hasOwnProperty;function r(f){if(!P(f))return!1;for(const h in f)if(s.call(f,h))return!1;return!0}function c(f){return typeof f=="function"}function l(...f){return f.length>0&&f.every(c)}function E(f,h){const p=Math.min(f.length,h.length);for(let S=0;S<p;S++)T(f[S],h[S])}function T(f,h){if(i(h)){if(typeof f!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(c(h)){try{if(f instanceof h)return}catch{}if(!_(f)&&f.constructor===h||h.length===1&&h.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function A(f){return f}}),define(ve[48],De([1,0,10]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.register=P,t.getCodiconFontCharacters=F;const n=Object.create(null);function P(I,D){if((0,i.isString)(D)){const w=n[D];if(w===void 0)throw new Error(`${I} references an unknown codicon: ${D}`);D=w}return n[I]=D,{id:I}}function F(){return n}}),define(ve[107],De([1,0,48]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.codiconsLibrary=void 0,t.codiconsLibrary={add:(0,i.register)("add",6e4),plus:(0,i.register)("plus",6e4),gistNew:(0,i.register)("gist-new",6e4),repoCreate:(0,i.register)("repo-create",6e4),lightbulb:(0,i.register)("lightbulb",60001),lightBulb:(0,i.register)("light-bulb",60001),repo:(0,i.register)("repo",60002),repoDelete:(0,i.register)("repo-delete",60002),gistFork:(0,i.register)("gist-fork",60003),repoForked:(0,i.register)("repo-forked",60003),gitPullRequest:(0,i.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.register)("git-pull-request-abandoned",60004),recordKeys:(0,i.register)("record-keys",60005),keyboard:(0,i.register)("keyboard",60005),tag:(0,i.register)("tag",60006),gitPullRequestLabel:(0,i.register)("git-pull-request-label",60006),tagAdd:(0,i.register)("tag-add",60006),tagRemove:(0,i.register)("tag-remove",60006),person:(0,i.register)("person",60007),personFollow:(0,i.register)("person-follow",60007),personOutline:(0,i.register)("person-outline",60007),personFilled:(0,i.register)("person-filled",60007),gitBranch:(0,i.register)("git-branch",60008),gitBranchCreate:(0,i.register)("git-branch-create",60008),gitBranchDelete:(0,i.register)("git-branch-delete",60008),sourceControl:(0,i.register)("source-control",60008),mirror:(0,i.register)("mirror",60009),mirrorPublic:(0,i.register)("mirror-public",60009),star:(0,i.register)("star",60010),starAdd:(0,i.register)("star-add",60010),starDelete:(0,i.register)("star-delete",60010),starEmpty:(0,i.register)("star-empty",60010),comment:(0,i.register)("comment",60011),commentAdd:(0,i.register)("comment-add",60011),alert:(0,i.register)("alert",60012),warning:(0,i.register)("warning",60012),search:(0,i.register)("search",60013),searchSave:(0,i.register)("search-save",60013),logOut:(0,i.register)("log-out",60014),signOut:(0,i.register)("sign-out",60014),logIn:(0,i.register)("log-in",60015),signIn:(0,i.register)("sign-in",60015),eye:(0,i.register)("eye",60016),eyeUnwatch:(0,i.register)("eye-unwatch",60016),eyeWatch:(0,i.register)("eye-watch",60016),circleFilled:(0,i.register)("circle-filled",60017),primitiveDot:(0,i.register)("primitive-dot",60017),closeDirty:(0,i.register)("close-dirty",60017),debugBreakpoint:(0,i.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.register)("debug-breakpoint-disabled",60017),debugHint:(0,i.register)("debug-hint",60017),terminalDecorationSuccess:(0,i.register)("terminal-decoration-success",60017),primitiveSquare:(0,i.register)("primitive-square",60018),edit:(0,i.register)("edit",60019),pencil:(0,i.register)("pencil",60019),info:(0,i.register)("info",60020),issueOpened:(0,i.register)("issue-opened",60020),gistPrivate:(0,i.register)("gist-private",60021),gitForkPrivate:(0,i.register)("git-fork-private",60021),lock:(0,i.register)("lock",60021),mirrorPrivate:(0,i.register)("mirror-private",60021),close:(0,i.register)("close",60022),removeClose:(0,i.register)("remove-close",60022),x:(0,i.register)("x",60022),repoSync:(0,i.register)("repo-sync",60023),sync:(0,i.register)("sync",60023),clone:(0,i.register)("clone",60024),desktopDownload:(0,i.register)("desktop-download",60024),beaker:(0,i.register)("beaker",60025),microscope:(0,i.register)("microscope",60025),vm:(0,i.register)("vm",60026),deviceDesktop:(0,i.register)("device-desktop",60026),file:(0,i.register)("file",60027),fileText:(0,i.register)("file-text",60027),more:(0,i.register)("more",60028),ellipsis:(0,i.register)("ellipsis",60028),kebabHorizontal:(0,i.register)("kebab-horizontal",60028),mailReply:(0,i.register)("mail-reply",60029),reply:(0,i.register)("reply",60029),organization:(0,i.register)("organization",60030),organizationFilled:(0,i.register)("organization-filled",60030),organizationOutline:(0,i.register)("organization-outline",60030),newFile:(0,i.register)("new-file",60031),fileAdd:(0,i.register)("file-add",60031),newFolder:(0,i.register)("new-folder",60032),fileDirectoryCreate:(0,i.register)("file-directory-create",60032),trash:(0,i.register)("trash",60033),trashcan:(0,i.register)("trashcan",60033),history:(0,i.register)("history",60034),clock:(0,i.register)("clock",60034),folder:(0,i.register)("folder",60035),fileDirectory:(0,i.register)("file-directory",60035),symbolFolder:(0,i.register)("symbol-folder",60035),logoGithub:(0,i.register)("logo-github",60036),markGithub:(0,i.register)("mark-github",60036),github:(0,i.register)("github",60036),terminal:(0,i.register)("terminal",60037),console:(0,i.register)("console",60037),repl:(0,i.register)("repl",60037),zap:(0,i.register)("zap",60038),symbolEvent:(0,i.register)("symbol-event",60038),error:(0,i.register)("error",60039),stop:(0,i.register)("stop",60039),variable:(0,i.register)("variable",60040),symbolVariable:(0,i.register)("symbol-variable",60040),array:(0,i.register)("array",60042),symbolArray:(0,i.register)("symbol-array",60042),symbolModule:(0,i.register)("symbol-module",60043),symbolPackage:(0,i.register)("symbol-package",60043),symbolNamespace:(0,i.register)("symbol-namespace",60043),symbolObject:(0,i.register)("symbol-object",60043),symbolMethod:(0,i.register)("symbol-method",60044),symbolFunction:(0,i.register)("symbol-function",60044),symbolConstructor:(0,i.register)("symbol-constructor",60044),symbolBoolean:(0,i.register)("symbol-boolean",60047),symbolNull:(0,i.register)("symbol-null",60047),symbolNumeric:(0,i.register)("symbol-numeric",60048),symbolNumber:(0,i.register)("symbol-number",60048),symbolStructure:(0,i.register)("symbol-structure",60049),symbolStruct:(0,i.register)("symbol-struct",60049),symbolParameter:(0,i.register)("symbol-parameter",60050),symbolTypeParameter:(0,i.register)("symbol-type-parameter",60050),symbolKey:(0,i.register)("symbol-key",60051),symbolText:(0,i.register)("symbol-text",60051),symbolReference:(0,i.register)("symbol-reference",60052),goToFile:(0,i.register)("go-to-file",60052),symbolEnum:(0,i.register)("symbol-enum",60053),symbolValue:(0,i.register)("symbol-value",60053),symbolRuler:(0,i.register)("symbol-ruler",60054),symbolUnit:(0,i.register)("symbol-unit",60054),activateBreakpoints:(0,i.register)("activate-breakpoints",60055),archive:(0,i.register)("archive",60056),arrowBoth:(0,i.register)("arrow-both",60057),arrowDown:(0,i.register)("arrow-down",60058),arrowLeft:(0,i.register)("arrow-left",60059),arrowRight:(0,i.register)("arrow-right",60060),arrowSmallDown:(0,i.register)("arrow-small-down",60061),arrowSmallLeft:(0,i.register)("arrow-small-left",60062),arrowSmallRight:(0,i.register)("arrow-small-right",60063),arrowSmallUp:(0,i.register)("arrow-small-up",60064),arrowUp:(0,i.register)("arrow-up",60065),bell:(0,i.register)("bell",60066),bold:(0,i.register)("bold",60067),book:(0,i.register)("book",60068),bookmark:(0,i.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.register)("briefcase",60076),broadcast:(0,i.register)("broadcast",60077),browser:(0,i.register)("browser",60078),bug:(0,i.register)("bug",60079),calendar:(0,i.register)("calendar",60080),caseSensitive:(0,i.register)("case-sensitive",60081),check:(0,i.register)("check",60082),checklist:(0,i.register)("checklist",60083),chevronDown:(0,i.register)("chevron-down",60084),chevronLeft:(0,i.register)("chevron-left",60085),chevronRight:(0,i.register)("chevron-right",60086),chevronUp:(0,i.register)("chevron-up",60087),chromeClose:(0,i.register)("chrome-close",60088),chromeMaximize:(0,i.register)("chrome-maximize",60089),chromeMinimize:(0,i.register)("chrome-minimize",60090),chromeRestore:(0,i.register)("chrome-restore",60091),circleOutline:(0,i.register)("circle-outline",60092),circle:(0,i.register)("circle",60092),debugBreakpointUnverified:(0,i.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.register)("terminal-decoration-incomplete",60092),circleSlash:(0,i.register)("circle-slash",60093),circuitBoard:(0,i.register)("circuit-board",60094),clearAll:(0,i.register)("clear-all",60095),clippy:(0,i.register)("clippy",60096),closeAll:(0,i.register)("close-all",60097),cloudDownload:(0,i.register)("cloud-download",60098),cloudUpload:(0,i.register)("cloud-upload",60099),code:(0,i.register)("code",60100),collapseAll:(0,i.register)("collapse-all",60101),colorMode:(0,i.register)("color-mode",60102),commentDiscussion:(0,i.register)("comment-discussion",60103),creditCard:(0,i.register)("credit-card",60105),dash:(0,i.register)("dash",60108),dashboard:(0,i.register)("dashboard",60109),database:(0,i.register)("database",60110),debugContinue:(0,i.register)("debug-continue",60111),debugDisconnect:(0,i.register)("debug-disconnect",60112),debugPause:(0,i.register)("debug-pause",60113),debugRestart:(0,i.register)("debug-restart",60114),debugStart:(0,i.register)("debug-start",60115),debugStepInto:(0,i.register)("debug-step-into",60116),debugStepOut:(0,i.register)("debug-step-out",60117),debugStepOver:(0,i.register)("debug-step-over",60118),debugStop:(0,i.register)("debug-stop",60119),debug:(0,i.register)("debug",60120),deviceCameraVideo:(0,i.register)("device-camera-video",60121),deviceCamera:(0,i.register)("device-camera",60122),deviceMobile:(0,i.register)("device-mobile",60123),diffAdded:(0,i.register)("diff-added",60124),diffIgnored:(0,i.register)("diff-ignored",60125),diffModified:(0,i.register)("diff-modified",60126),diffRemoved:(0,i.register)("diff-removed",60127),diffRenamed:(0,i.register)("diff-renamed",60128),diff:(0,i.register)("diff",60129),diffSidebyside:(0,i.register)("diff-sidebyside",60129),discard:(0,i.register)("discard",60130),editorLayout:(0,i.register)("editor-layout",60131),emptyWindow:(0,i.register)("empty-window",60132),exclude:(0,i.register)("exclude",60133),extensions:(0,i.register)("extensions",60134),eyeClosed:(0,i.register)("eye-closed",60135),fileBinary:(0,i.register)("file-binary",60136),fileCode:(0,i.register)("file-code",60137),fileMedia:(0,i.register)("file-media",60138),filePdf:(0,i.register)("file-pdf",60139),fileSubmodule:(0,i.register)("file-submodule",60140),fileSymlinkDirectory:(0,i.register)("file-symlink-directory",60141),fileSymlinkFile:(0,i.register)("file-symlink-file",60142),fileZip:(0,i.register)("file-zip",60143),files:(0,i.register)("files",60144),filter:(0,i.register)("filter",60145),flame:(0,i.register)("flame",60146),foldDown:(0,i.register)("fold-down",60147),foldUp:(0,i.register)("fold-up",60148),fold:(0,i.register)("fold",60149),folderActive:(0,i.register)("folder-active",60150),folderOpened:(0,i.register)("folder-opened",60151),gear:(0,i.register)("gear",60152),gift:(0,i.register)("gift",60153),gistSecret:(0,i.register)("gist-secret",60154),gist:(0,i.register)("gist",60155),gitCommit:(0,i.register)("git-commit",60156),gitCompare:(0,i.register)("git-compare",60157),compareChanges:(0,i.register)("compare-changes",60157),gitMerge:(0,i.register)("git-merge",60158),githubAction:(0,i.register)("github-action",60159),githubAlt:(0,i.register)("github-alt",60160),globe:(0,i.register)("globe",60161),grabber:(0,i.register)("grabber",60162),graph:(0,i.register)("graph",60163),gripper:(0,i.register)("gripper",60164),heart:(0,i.register)("heart",60165),home:(0,i.register)("home",60166),horizontalRule:(0,i.register)("horizontal-rule",60167),hubot:(0,i.register)("hubot",60168),inbox:(0,i.register)("inbox",60169),issueReopened:(0,i.register)("issue-reopened",60171),issues:(0,i.register)("issues",60172),italic:(0,i.register)("italic",60173),jersey:(0,i.register)("jersey",60174),json:(0,i.register)("json",60175),kebabVertical:(0,i.register)("kebab-vertical",60176),key:(0,i.register)("key",60177),law:(0,i.register)("law",60178),lightbulbAutofix:(0,i.register)("lightbulb-autofix",60179),linkExternal:(0,i.register)("link-external",60180),link:(0,i.register)("link",60181),listOrdered:(0,i.register)("list-ordered",60182),listUnordered:(0,i.register)("list-unordered",60183),liveShare:(0,i.register)("live-share",60184),loading:(0,i.register)("loading",60185),location:(0,i.register)("location",60186),mailRead:(0,i.register)("mail-read",60187),mail:(0,i.register)("mail",60188),markdown:(0,i.register)("markdown",60189),megaphone:(0,i.register)("megaphone",60190),mention:(0,i.register)("mention",60191),milestone:(0,i.register)("milestone",60192),gitPullRequestMilestone:(0,i.register)("git-pull-request-milestone",60192),mortarBoard:(0,i.register)("mortar-board",60193),move:(0,i.register)("move",60194),multipleWindows:(0,i.register)("multiple-windows",60195),mute:(0,i.register)("mute",60196),noNewline:(0,i.register)("no-newline",60197),note:(0,i.register)("note",60198),octoface:(0,i.register)("octoface",60199),openPreview:(0,i.register)("open-preview",60200),package:(0,i.register)("package",60201),paintcan:(0,i.register)("paintcan",60202),pin:(0,i.register)("pin",60203),play:(0,i.register)("play",60204),run:(0,i.register)("run",60204),plug:(0,i.register)("plug",60205),preserveCase:(0,i.register)("preserve-case",60206),preview:(0,i.register)("preview",60207),project:(0,i.register)("project",60208),pulse:(0,i.register)("pulse",60209),question:(0,i.register)("question",60210),quote:(0,i.register)("quote",60211),radioTower:(0,i.register)("radio-tower",60212),reactions:(0,i.register)("reactions",60213),references:(0,i.register)("references",60214),refresh:(0,i.register)("refresh",60215),regex:(0,i.register)("regex",60216),remoteExplorer:(0,i.register)("remote-explorer",60217),remote:(0,i.register)("remote",60218),remove:(0,i.register)("remove",60219),replaceAll:(0,i.register)("replace-all",60220),replace:(0,i.register)("replace",60221),repoClone:(0,i.register)("repo-clone",60222),repoForcePush:(0,i.register)("repo-force-push",60223),repoPull:(0,i.register)("repo-pull",60224),repoPush:(0,i.register)("repo-push",60225),report:(0,i.register)("report",60226),requestChanges:(0,i.register)("request-changes",60227),rocket:(0,i.register)("rocket",60228),rootFolderOpened:(0,i.register)("root-folder-opened",60229),rootFolder:(0,i.register)("root-folder",60230),rss:(0,i.register)("rss",60231),ruby:(0,i.register)("ruby",60232),saveAll:(0,i.register)("save-all",60233),saveAs:(0,i.register)("save-as",60234),save:(0,i.register)("save",60235),screenFull:(0,i.register)("screen-full",60236),screenNormal:(0,i.register)("screen-normal",60237),searchStop:(0,i.register)("search-stop",60238),server:(0,i.register)("server",60240),settingsGear:(0,i.register)("settings-gear",60241),settings:(0,i.register)("settings",60242),shield:(0,i.register)("shield",60243),smiley:(0,i.register)("smiley",60244),sortPrecedence:(0,i.register)("sort-precedence",60245),splitHorizontal:(0,i.register)("split-horizontal",60246),splitVertical:(0,i.register)("split-vertical",60247),squirrel:(0,i.register)("squirrel",60248),starFull:(0,i.register)("star-full",60249),starHalf:(0,i.register)("star-half",60250),symbolClass:(0,i.register)("symbol-class",60251),symbolColor:(0,i.register)("symbol-color",60252),symbolConstant:(0,i.register)("symbol-constant",60253),symbolEnumMember:(0,i.register)("symbol-enum-member",60254),symbolField:(0,i.register)("symbol-field",60255),symbolFile:(0,i.register)("symbol-file",60256),symbolInterface:(0,i.register)("symbol-interface",60257),symbolKeyword:(0,i.register)("symbol-keyword",60258),symbolMisc:(0,i.register)("symbol-misc",60259),symbolOperator:(0,i.register)("symbol-operator",60260),symbolProperty:(0,i.register)("symbol-property",60261),wrench:(0,i.register)("wrench",60261),wrenchSubaction:(0,i.register)("wrench-subaction",60261),symbolSnippet:(0,i.register)("symbol-snippet",60262),tasklist:(0,i.register)("tasklist",60263),telescope:(0,i.register)("telescope",60264),textSize:(0,i.register)("text-size",60265),threeBars:(0,i.register)("three-bars",60266),thumbsdown:(0,i.register)("thumbsdown",60267),thumbsup:(0,i.register)("thumbsup",60268),tools:(0,i.register)("tools",60269),triangleDown:(0,i.register)("triangle-down",60270),triangleLeft:(0,i.register)("triangle-left",60271),triangleRight:(0,i.register)("triangle-right",60272),triangleUp:(0,i.register)("triangle-up",60273),twitter:(0,i.register)("twitter",60274),unfold:(0,i.register)("unfold",60275),unlock:(0,i.register)("unlock",60276),unmute:(0,i.register)("unmute",60277),unverified:(0,i.register)("unverified",60278),verified:(0,i.register)("verified",60279),versions:(0,i.register)("versions",60280),vmActive:(0,i.register)("vm-active",60281),vmOutline:(0,i.register)("vm-outline",60282),vmRunning:(0,i.register)("vm-running",60283),watch:(0,i.register)("watch",60284),whitespace:(0,i.register)("whitespace",60285),wholeWord:(0,i.register)("whole-word",60286),window:(0,i.register)("window",60287),wordWrap:(0,i.register)("word-wrap",60288),zoomIn:(0,i.register)("zoom-in",60289),zoomOut:(0,i.register)("zoom-out",60290),listFilter:(0,i.register)("list-filter",60291),listFlat:(0,i.register)("list-flat",60292),listSelection:(0,i.register)("list-selection",60293),selection:(0,i.register)("selection",60293),listTree:(0,i.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.register)("debug-stackframe-active",60297),circleSmallFilled:(0,i.register)("circle-small-filled",60298),debugStackframeDot:(0,i.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.register)("terminal-decoration-mark",60298),debugStackframe:(0,i.register)("debug-stackframe",60299),debugStackframeFocused:(0,i.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.register)("debug-breakpoint-unsupported",60300),symbolString:(0,i.register)("symbol-string",60301),debugReverseContinue:(0,i.register)("debug-reverse-continue",60302),debugStepBack:(0,i.register)("debug-step-back",60303),debugRestartFrame:(0,i.register)("debug-restart-frame",60304),debugAlt:(0,i.register)("debug-alt",60305),callIncoming:(0,i.register)("call-incoming",60306),callOutgoing:(0,i.register)("call-outgoing",60307),menu:(0,i.register)("menu",60308),expandAll:(0,i.register)("expand-all",60309),feedback:(0,i.register)("feedback",60310),gitPullRequestReviewer:(0,i.register)("git-pull-request-reviewer",60310),groupByRefType:(0,i.register)("group-by-ref-type",60311),ungroupByRefType:(0,i.register)("ungroup-by-ref-type",60312),account:(0,i.register)("account",60313),gitPullRequestAssignee:(0,i.register)("git-pull-request-assignee",60313),bellDot:(0,i.register)("bell-dot",60314),debugConsole:(0,i.register)("debug-console",60315),library:(0,i.register)("library",60316),output:(0,i.register)("output",60317),runAll:(0,i.register)("run-all",60318),syncIgnored:(0,i.register)("sync-ignored",60319),pinned:(0,i.register)("pinned",60320),githubInverted:(0,i.register)("github-inverted",60321),serverProcess:(0,i.register)("server-process",60322),serverEnvironment:(0,i.register)("server-environment",60323),pass:(0,i.register)("pass",60324),issueClosed:(0,i.register)("issue-closed",60324),stopCircle:(0,i.register)("stop-circle",60325),playCircle:(0,i.register)("play-circle",60326),record:(0,i.register)("record",60327),debugAltSmall:(0,i.register)("debug-alt-small",60328),vmConnect:(0,i.register)("vm-connect",60329),cloud:(0,i.register)("cloud",60330),merge:(0,i.register)("merge",60331),export:(0,i.register)("export",60332),graphLeft:(0,i.register)("graph-left",60333),magnet:(0,i.register)("magnet",60334),notebook:(0,i.register)("notebook",60335),redo:(0,i.register)("redo",60336),checkAll:(0,i.register)("check-all",60337),pinnedDirty:(0,i.register)("pinned-dirty",60338),passFilled:(0,i.register)("pass-filled",60339),circleLargeFilled:(0,i.register)("circle-large-filled",60340),circleLarge:(0,i.register)("circle-large",60341),circleLargeOutline:(0,i.register)("circle-large-outline",60341),combine:(0,i.register)("combine",60342),gather:(0,i.register)("gather",60342),table:(0,i.register)("table",60343),variableGroup:(0,i.register)("variable-group",60344),typeHierarchy:(0,i.register)("type-hierarchy",60345),typeHierarchySub:(0,i.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.register)("git-pull-request-create",60348),runAbove:(0,i.register)("run-above",60349),runBelow:(0,i.register)("run-below",60350),notebookTemplate:(0,i.register)("notebook-template",60351),debugRerun:(0,i.register)("debug-rerun",60352),workspaceTrusted:(0,i.register)("workspace-trusted",60353),workspaceUntrusted:(0,i.register)("workspace-untrusted",60354),workspaceUnknown:(0,i.register)("workspace-unknown",60355),terminalCmd:(0,i.register)("terminal-cmd",60356),terminalDebian:(0,i.register)("terminal-debian",60357),terminalLinux:(0,i.register)("terminal-linux",60358),terminalPowershell:(0,i.register)("terminal-powershell",60359),terminalTmux:(0,i.register)("terminal-tmux",60360),terminalUbuntu:(0,i.register)("terminal-ubuntu",60361),terminalBash:(0,i.register)("terminal-bash",60362),arrowSwap:(0,i.register)("arrow-swap",60363),copy:(0,i.register)("copy",60364),personAdd:(0,i.register)("person-add",60365),filterFilled:(0,i.register)("filter-filled",60366),wand:(0,i.register)("wand",60367),debugLineByLine:(0,i.register)("debug-line-by-line",60368),inspect:(0,i.register)("inspect",60369),layers:(0,i.register)("layers",60370),layersDot:(0,i.register)("layers-dot",60371),layersActive:(0,i.register)("layers-active",60372),compass:(0,i.register)("compass",60373),compassDot:(0,i.register)("compass-dot",60374),compassActive:(0,i.register)("compass-active",60375),azure:(0,i.register)("azure",60376),issueDraft:(0,i.register)("issue-draft",60377),gitPullRequestClosed:(0,i.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.register)("git-pull-request-draft",60379),debugAll:(0,i.register)("debug-all",60380),debugCoverage:(0,i.register)("debug-coverage",60381),runErrors:(0,i.register)("run-errors",60382),folderLibrary:(0,i.register)("folder-library",60383),debugContinueSmall:(0,i.register)("debug-continue-small",60384),beakerStop:(0,i.register)("beaker-stop",60385),graphLine:(0,i.register)("graph-line",60386),graphScatter:(0,i.register)("graph-scatter",60387),pieChart:(0,i.register)("pie-chart",60388),bracket:(0,i.register)("bracket",60175),bracketDot:(0,i.register)("bracket-dot",60389),bracketError:(0,i.register)("bracket-error",60390),lockSmall:(0,i.register)("lock-small",60391),azureDevops:(0,i.register)("azure-devops",60392),verifiedFilled:(0,i.register)("verified-filled",60393),newline:(0,i.register)("newline",60394),layout:(0,i.register)("layout",60395),layoutActivitybarLeft:(0,i.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.register)("layout-panel-left",60398),layoutPanelCenter:(0,i.register)("layout-panel-center",60399),layoutPanelJustify:(0,i.register)("layout-panel-justify",60400),layoutPanelRight:(0,i.register)("layout-panel-right",60401),layoutPanel:(0,i.register)("layout-panel",60402),layoutSidebarLeft:(0,i.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.register)("layout-sidebar-right",60404),layoutStatusbar:(0,i.register)("layout-statusbar",60405),layoutMenubar:(0,i.register)("layout-menubar",60406),layoutCentered:(0,i.register)("layout-centered",60407),target:(0,i.register)("target",60408),indent:(0,i.register)("indent",60409),recordSmall:(0,i.register)("record-small",60410),errorSmall:(0,i.register)("error-small",60411),terminalDecorationError:(0,i.register)("terminal-decoration-error",60411),arrowCircleDown:(0,i.register)("arrow-circle-down",60412),arrowCircleLeft:(0,i.register)("arrow-circle-left",60413),arrowCircleRight:(0,i.register)("arrow-circle-right",60414),arrowCircleUp:(0,i.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.register)("layout-sidebar-left-off",60418),blank:(0,i.register)("blank",60419),heartFilled:(0,i.register)("heart-filled",60420),map:(0,i.register)("map",60421),mapHorizontal:(0,i.register)("map-horizontal",60421),foldHorizontal:(0,i.register)("fold-horizontal",60421),mapFilled:(0,i.register)("map-filled",60422),mapHorizontalFilled:(0,i.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.register)("fold-horizontal-filled",60422),circleSmall:(0,i.register)("circle-small",60423),bellSlash:(0,i.register)("bell-slash",60424),bellSlashDot:(0,i.register)("bell-slash-dot",60425),commentUnresolved:(0,i.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.register)("search-fuzzy",60429),commentDraft:(0,i.register)("comment-draft",60430),send:(0,i.register)("send",60431),sparkle:(0,i.register)("sparkle",60432),insert:(0,i.register)("insert",60433),mic:(0,i.register)("mic",60434),thumbsdownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsupFilled:(0,i.register)("thumbsup-filled",60436),coffee:(0,i.register)("coffee",60437),snake:(0,i.register)("snake",60438),game:(0,i.register)("game",60439),vr:(0,i.register)("vr",60440),chip:(0,i.register)("chip",60441),piano:(0,i.register)("piano",60442),music:(0,i.register)("music",60443),micFilled:(0,i.register)("mic-filled",60444),repoFetch:(0,i.register)("repo-fetch",60445),copilot:(0,i.register)("copilot",60446),lightbulbSparkle:(0,i.register)("lightbulb-sparkle",60447),robot:(0,i.register)("robot",60448),sparkleFilled:(0,i.register)("sparkle-filled",60449),diffSingle:(0,i.register)("diff-single",60450),diffMultiple:(0,i.register)("diff-multiple",60451),surroundWith:(0,i.register)("surround-with",60452),share:(0,i.register)("share",60453),gitStash:(0,i.register)("git-stash",60454),gitStashApply:(0,i.register)("git-stash-apply",60455),gitStashPop:(0,i.register)("git-stash-pop",60456),vscode:(0,i.register)("vscode",60457),vscodeInsiders:(0,i.register)("vscode-insiders",60458),codeOss:(0,i.register)("code-oss",60459),runCoverage:(0,i.register)("run-coverage",60460),runAllCoverage:(0,i.register)("run-all-coverage",60461),coverage:(0,i.register)("coverage",60462),githubProject:(0,i.register)("github-project",60463),mapVertical:(0,i.register)("map-vertical",60464),foldVertical:(0,i.register)("fold-vertical",60464),mapVerticalFilled:(0,i.register)("map-vertical-filled",60465),foldVerticalFilled:(0,i.register)("fold-vertical-filled",60465),goToSearch:(0,i.register)("go-to-search",60466),percentage:(0,i.register)("percentage",60467),sortPercentage:(0,i.register)("sort-percentage",60467),attach:(0,i.register)("attach",60468)}}),define(ve[21],De([1,0,48,107]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.codiconsDerived=void 0,t.getAllCodicons=P;function P(){return Object.values(t.Codicon)}t.codiconsDerived={dialogError:(0,i.register)("dialog-error","error"),dialogWarning:(0,i.register)("dialog-warning","warning"),dialogInfo:(0,i.register)("dialog-info","info"),dialogClose:(0,i.register)("dialog-close","close"),treeItemExpanded:(0,i.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.register)("tree-filter-clear","close"),treeItemLoading:(0,i.register)("tree-item-loading","loading"),menuSelection:(0,i.register)("menu-selection","check"),menuSubmenu:(0,i.register)("menu-submenu","chevron-right"),menuBarMore:(0,i.register)("menubar-more","more"),scrollbarButtonLeft:(0,i.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.register)("toolbar-more","more"),quickInputBack:(0,i.register)("quick-input-back","arrow-left"),dropDownButton:(0,i.register)("drop-down-button",60084),symbolCustomColor:(0,i.register)("symbol-customcolor",60252),exportIcon:(0,i.register)("export",60332),workspaceUnspecified:(0,i.register)("workspace-unspecified",60355),newLine:(0,i.register)("newline",60394),thumbsDownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.register)("thumbsup-filled",60436),gitFetch:(0,i.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.register)("debug-breakpoint-pending",60377)},t.Codicon={...n.codiconsLibrary,...t.codiconsDerived}}),define(ve[64],De([1,0,10]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=n,t.deepFreeze=P,t.cloneAndChange=I,t.mixin=w,t.equals=d,t.safeStringify=v,t.distinct=_,t.getCaseInsensitive=b,t.filter=m,t.getAllPropertyNames=e,t.getAllMethodNames=s,t.createProxyObject=r,t.mapValues=c;function n(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const E=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([T,A])=>{E[T]=A&&typeof A=="object"?n(A):A}),E}function P(l){if(!l||typeof l!="object")return l;const E=[l];for(;E.length>0;){const T=E.shift();Object.freeze(T);for(const A in T)if(F.call(T,A)){const f=T[A];typeof f=="object"&&!Object.isFrozen(f)&&!(0,i.isTypedArray)(f)&&E.push(f)}}return l}const F=Object.prototype.hasOwnProperty;function I(l,E){return D(l,E,new Set)}function D(l,E,T){if((0,i.isUndefinedOrNull)(l))return l;const A=E(l);if(typeof A<"u")return A;if(Array.isArray(l)){const f=[];for(const h of l)f.push(D(h,E,T));return f}if((0,i.isObject)(l)){if(T.has(l))throw new Error("Cannot clone recursive data-structure");T.add(l);const f={};for(const h in l)F.call(l,h)&&(f[h]=D(l[h],E,T));return T.delete(l),f}return l}function w(l,E,T=!0){return(0,i.isObject)(l)?((0,i.isObject)(E)&&Object.keys(E).forEach(A=>{A in l?T&&((0,i.isObject)(l[A])&&(0,i.isObject)(E[A])?w(l[A],E[A],T):l[A]=E[A]):l[A]=E[A]}),l):E}function d(l,E){if(l===E)return!0;if(l==null||E===null||E===void 0||typeof l!=typeof E||typeof l!="object"||Array.isArray(l)!==Array.isArray(E))return!1;let T,A;if(Array.isArray(l)){if(l.length!==E.length)return!1;for(T=0;T<l.length;T++)if(!d(l[T],E[T]))return!1}else{const f=[];for(A in l)f.push(A);f.sort();const h=[];for(A in E)h.push(A);if(h.sort(),!d(f,h))return!1;for(T=0;T<f.length;T++)if(!d(l[f[T]],E[f[T]]))return!1}return!0}function v(l){const E=new Set;return JSON.stringify(l,(T,A)=>{if((0,i.isObject)(A)||Array.isArray(A)){if(E.has(A))return"[Circular]";E.add(A)}return typeof A=="bigint"?`[BigInt ${A.toString()}]`:A})}function _(l,E){const T=Object.create(null);return!l||!E||Object.keys(E).forEach(f=>{const h=l[f],p=E[f];d(h,p)||(T[f]=p)}),T}function b(l,E){const T=E.toLowerCase(),A=Object.keys(l).find(f=>f.toLowerCase()===T);return A?l[A]:l[E]}function m(l,E){const T=Object.create(null);for(const[A,f]of Object.entries(l))E(A,f)&&(T[A]=f);return T}function e(l){let E=[];for(;Object.prototype!==l;)E=E.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return E}function s(l){const E=[];for(const T of e(l))typeof l[T]=="function"&&E.push(T);return E}function r(l,E){const T=f=>function(){const h=Array.prototype.slice.call(arguments,0);return E(f,h)},A={};for(const f of l)A[f]=T(f);return A}function c(l,E){const T={};for(const[A,f]of Object.entries(l))T[A]=E(f,A);return T}}),define(ve[22],De([1,0,21]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.themeColorFromId=P;var n;(function(I){function D(w){return w&&typeof w=="object"&&typeof w.id=="string"}I.isThemeColor=D})(n||(t.ThemeColor=n={}));function P(I){return{id:I}}var F;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function w(l){const E=D.exec(l.id);if(!E)return w(i.Codicon.error);const[,T,A]=E,f=["codicon","codicon-"+T];return A&&f.push("codicon-modifier-"+A.substring(1)),f}I.asClassNameArray=w;function d(l){return w(l).join(" ")}I.asClassName=d;function v(l){return"."+w(l).join(".")}I.asCSSSelector=v;function _(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||n.isThemeColor(l.color))}I.isThemeIcon=_;const b=new RegExp(`^\\$\\((${I.iconNameExpression}(?:${I.iconModifierExpression})?)\\)$`);function m(l){const E=b.exec(l);if(!E)return;const[,T]=E;return{id:T}}I.fromString=m;function e(l){return{id:l}}I.fromId=e;function s(l,E){let T=l.id;const A=T.lastIndexOf("~");return A!==-1&&(T=T.substring(0,A)),E&&(T=`${T}~${E}`),{id:T}}I.modify=s;function r(l){const E=l.id.lastIndexOf("~");if(E!==-1)return l.id.substring(E+1)}I.getModifier=r;function c(l,E){return l.id===E.id&&l.color?.id===E.color?.id}I.isEqual=c})(F||(t.ThemeIcon=F={}))}),define(ve[65],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.toUint8=n,t.toUint32=P;var i;(function(F){F[F.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",F[F.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",F[F.MAX_UINT_8=255]="MAX_UINT_8",F[F.MAX_UINT_16=65535]="MAX_UINT_16",F[F.MAX_UINT_32=4294967295]="MAX_UINT_32",F[F.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function n(F){return F<0?0:F>i.MAX_UINT_8?i.MAX_UINT_8:F|0}function P(F){return F<0?0:F>i.MAX_UINT_32?i.MAX_UINT_32:F|0}}),define(ve[11],De([1,0,103,17,25,65]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=I,t.format=w,t.format2=v,t.htmlAttributeEncodeValue=_,t.escape=b,t.escapeRegExpCharacters=m,t.count=e,t.truncate=s,t.truncateMiddle=r,t.trim=c,t.ltrim=l,t.rtrim=E,t.convertSimple2RegExpPattern=T,t.stripWildcards=A,t.createRegExp=f,t.regExpLeadsToEndlessLoop=h,t.splitLines=p,t.splitLinesIncludeSeparators=S,t.firstNonWhitespaceIndex=U,t.getLeadingWhitespace=H,t.lastNonWhitespaceIndex=x,t.replaceAsync=y,t.compare=O,t.compareSubstring=V,t.compareIgnoreCase=R,t.compareSubstringIgnoreCase=W,t.isAsciiDigit=G,t.isLowerAsciiLetter=Q,t.isUpperAsciiLetter=j,t.equalsIgnoreCase=q,t.startsWithIgnoreCase=J,t.commonPrefixLength=le,t.commonSuffixLength=me,t.isHighSurrogate=_e,t.isLowSurrogate=Ne,t.computeCodePoint=ne,t.getNextCodePoint=ee,t.nextCharLength=te,t.prevCharLength=pe,t.getCharContainingOffset=Ae,t.charCount=Ce,t.containsRTL=He,t.isBasicASCII=B,t.containsUnusualLineTerminators=a,t.isFullWidthCharacter=o,t.isEmojiImprecise=g,t.lcut=k,t.forAnsiStringParts=u,t.removeAnsiEscapeCodes=N,t.removeAnsiEscapeCodesFromPrompt=M,t.startsWithUTF8BOM=z,t.stripUTF8BOM=X,t.fuzzyContains=ie,t.containsUppercaseCharacter=re,t.uppercaseFirstLetter=ce,t.getNLines=we,t.singleLetterHash=Ee,t.getGraphemeBreakType=ye,t.getLeftDeleteOffset=Ye;function I(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}const D=/{(\d+)}/g;function w(Z,...ue){return ue.length===0?Z:Z.replace(D,function(be,Te){const Pe=parseInt(Te,10);return isNaN(Pe)||Pe<0||Pe>=ue.length?be:ue[Pe]})}const d=/{([^}]+)}/g;function v(Z,ue){return Object.keys(ue).length===0?Z:Z.replace(d,(be,Te)=>ue[Te]??be)}function _(Z){return Z.replace(/[<>"'&]/g,ue=>{switch(ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ue})}function b(Z){return Z.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}function m(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(Z,ue){let be=0,Te=Z.indexOf(ue);for(;Te!==-1;)be++,Te=Z.indexOf(ue,Te+ue.length);return be}function s(Z,ue,be="\u2026"){return Z.length<=ue?Z:`${Z.substr(0,ue)}${be}`}function r(Z,ue,be="\u2026"){if(Z.length<=ue)return Z;const Te=Math.ceil(ue/2)-be.length/2,Pe=Math.floor(ue/2)-be.length/2;return`${Z.substr(0,Te)}${be}${Z.substr(Z.length-Pe)}`}function c(Z,ue=" "){const be=l(Z,ue);return E(be,ue)}function l(Z,ue){if(!Z||!ue)return Z;const be=ue.length;if(be===0||Z.length===0)return Z;let Te=0;for(;Z.indexOf(ue,Te)===Te;)Te=Te+be;return Z.substring(Te)}function E(Z,ue){if(!Z||!ue)return Z;const be=ue.length,Te=Z.length;if(be===0||Te===0)return Z;let Pe=Te,Ve=-1;for(;Ve=Z.lastIndexOf(ue,Pe-1),!(Ve===-1||Ve+be!==Pe);){if(Ve===0)return"";Pe=Ve}return Z.substring(0,Pe)}function T(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function A(Z){return Z.replace(/\*/g,"")}function f(Z,ue,be={}){if(!Z)throw new Error("Cannot create regex from empty string");ue||(Z=m(Z)),be.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let Te="";return be.global&&(Te+="g"),be.matchCase||(Te+="i"),be.multiline&&(Te+="m"),be.unicode&&(Te+="u"),new RegExp(Z,Te)}function h(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}function p(Z){return Z.split(/\r\n|\r|\n/)}function S(Z){const ue=[],be=Z.split(/(\r\n|\r|\n)/);for(let Te=0;Te<Math.ceil(be.length/2);Te++)ue.push(be[2*Te]+(be[2*Te+1]??""));return ue}function U(Z){for(let ue=0,be=Z.length;ue<be;ue++){const Te=Z.charCodeAt(ue);if(Te!==n.CharCode.Space&&Te!==n.CharCode.Tab)return ue}return-1}function H(Z,ue=0,be=Z.length){for(let Te=ue;Te<be;Te++){const Pe=Z.charCodeAt(Te);if(Pe!==n.CharCode.Space&&Pe!==n.CharCode.Tab)return Z.substring(ue,Te)}return Z.substring(ue,be)}function x(Z,ue=Z.length-1){for(let be=ue;be>=0;be--){const Te=Z.charCodeAt(be);if(Te!==n.CharCode.Space&&Te!==n.CharCode.Tab)return be}return-1}function y(Z,ue,be){const Te=[];let Pe=0;for(const Ve of Z.matchAll(ue)){if(Te.push(Z.slice(Pe,Ve.index)),Ve.index===void 0)throw new Error("match.index should be defined");Pe=Ve.index+Ve[0].length,Te.push(be(Ve[0],...Ve.slice(1),Ve.index,Z,Ve.groups))}return Te.push(Z.slice(Pe)),Promise.all(Te).then(Ve=>Ve.join(""))}function O(Z,ue){return Z<ue?-1:Z>ue?1:0}function V(Z,ue,be=0,Te=Z.length,Pe=0,Ve=ue.length){for(;be<Te&&Pe<Ve;be++,Pe++){const it=Z.charCodeAt(be),ht=ue.charCodeAt(Pe);if(it<ht)return-1;if(it>ht)return 1}const Qe=Te-be,rt=Ve-Pe;return Qe<rt?-1:Qe>rt?1:0}function R(Z,ue){return W(Z,ue,0,Z.length,0,ue.length)}function W(Z,ue,be=0,Te=Z.length,Pe=0,Ve=ue.length){for(;be<Te&&Pe<Ve;be++,Pe++){let it=Z.charCodeAt(be),ht=ue.charCodeAt(Pe);if(it===ht)continue;if(it>=128||ht>=128)return V(Z.toLowerCase(),ue.toLowerCase(),be,Te,Pe,Ve);Q(it)&&(it-=32),Q(ht)&&(ht-=32);const nt=it-ht;if(nt!==0)return nt}const Qe=Te-be,rt=Ve-Pe;return Qe<rt?-1:Qe>rt?1:0}function G(Z){return Z>=n.CharCode.Digit0&&Z<=n.CharCode.Digit9}function Q(Z){return Z>=n.CharCode.a&&Z<=n.CharCode.z}function j(Z){return Z>=n.CharCode.A&&Z<=n.CharCode.Z}function q(Z,ue){return Z.length===ue.length&&W(Z,ue)===0}function J(Z,ue){const be=ue.length;return ue.length>Z.length?!1:W(Z,ue,0,be)===0}function le(Z,ue){const be=Math.min(Z.length,ue.length);let Te;for(Te=0;Te<be;Te++)if(Z.charCodeAt(Te)!==ue.charCodeAt(Te))return Te;return be}function me(Z,ue){const be=Math.min(Z.length,ue.length);let Te;const Pe=Z.length-1,Ve=ue.length-1;for(Te=0;Te<be;Te++)if(Z.charCodeAt(Pe-Te)!==ue.charCodeAt(Ve-Te))return Te;return be}function _e(Z){return 55296<=Z&&Z<=56319}function Ne(Z){return 56320<=Z&&Z<=57343}function ne(Z,ue){return(Z-55296<<10)+(ue-56320)+65536}function ee(Z,ue,be){const Te=Z.charCodeAt(be);if(_e(Te)&&be+1<ue){const Pe=Z.charCodeAt(be+1);if(Ne(Pe))return ne(Te,Pe)}return Te}function he(Z,ue){const be=Z.charCodeAt(ue-1);if(Ne(be)&&ue>1){const Te=Z.charCodeAt(ue-2);if(_e(Te))return ne(Te,be)}return be}class ae{get offset(){return this._offset}constructor(ue,be=0){this._str=ue,this._len=ue.length,this._offset=be}setOffset(ue){this._offset=ue}prevCodePoint(){const ue=he(this._str,this._offset);return this._offset-=ue>=F.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ue}nextCodePoint(){const ue=ee(this._str,this._len,this._offset);return this._offset+=ue>=F.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ue}eol(){return this._offset>=this._len}}t.CodePointIterator=ae;class Le{get offset(){return this._iterator.offset}constructor(ue,be=0){this._iterator=new ae(ue,be)}nextGraphemeLength(){const ue=Fe.getInstance(),be=this._iterator,Te=be.offset;let Pe=ue.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Ve=be.offset,Qe=ue.getGraphemeBreakType(be.nextCodePoint());if(Ie(Pe,Qe)){be.setOffset(Ve);break}Pe=Qe}return be.offset-Te}prevGraphemeLength(){const ue=Fe.getInstance(),be=this._iterator,Te=be.offset;let Pe=ue.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Ve=be.offset,Qe=ue.getGraphemeBreakType(be.prevCodePoint());if(Ie(Qe,Pe)){be.setOffset(Ve);break}Pe=Qe}return Te-be.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=Le;function te(Z,ue){return new Le(Z,ue).nextGraphemeLength()}function pe(Z,ue){return new Le(Z,ue).prevGraphemeLength()}function Ae(Z,ue){ue>0&&Ne(Z.charCodeAt(ue))&&ue--;const be=ue+te(Z,ue);return[be-pe(Z,be),be]}function Ce(Z){const ue=new Le(Z);let be=0;for(;!ue.eol();)be++,ue.nextGraphemeLength();return be}let Re;function xe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function He(Z){return Re||(Re=xe()),Re.test(Z)}const $=/^[\t\n\r\x20-\x7E]*$/;function B(Z){return $.test(Z)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function a(Z){return t.UNUSUAL_LINE_TERMINATORS.test(Z)}function o(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}function g(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}function k(Z,ue,be=""){const Te=Z.trimStart();if(Te.length<ue)return Te;const Pe=/\b/g;let Ve=0;for(;Pe.test(Te)&&!(Te.length-Pe.lastIndex<ue);)Ve=Pe.lastIndex,Pe.lastIndex+=1;return Ve===0?Te:be+Te.substring(Ve).trimStart()}const L=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*u(Z){let ue=0;for(const be of Z.matchAll(L))ue!==be.index&&(yield{isCode:!1,str:Z.substring(ue,be.index)}),yield{isCode:!0,str:be[0]},ue=be.index+be[0].length;ue!==Z.length&&(yield{isCode:!1,str:Z.substring(ue)})}function N(Z){return Z&&(Z=Z.replace(L,"")),Z}const C=/\\\[.*?\\\]/g;function M(Z){return N(Z).replace(C,"")}t.UTF8_BOM_CHARACTER=String.fromCharCode(n.CharCode.UTF8_BOM);function z(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===n.CharCode.UTF8_BOM)}function X(Z){return z(Z)?Z.substr(1):Z}function ie(Z,ue){if(!Z||!ue||Z.length<ue.length)return!1;const be=ue.length,Te=Z.toLowerCase();let Pe=0,Ve=-1;for(;Pe<be;){const Qe=Te.indexOf(ue[Pe],Ve+1);if(Qe<0)return!1;Ve=Qe,Pe++}return!0}function re(Z,ue=!1){return Z?(ue&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}function ce(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}function we(Z,ue=1){if(ue===0)return"";let be=-1;do be=Z.indexOf(`
`,be+1),ue--;while(ue>0&&be>=0);return be===-1?Z:(Z[be-1]==="\r"&&be--,Z.substr(0,be))}function Ee(Z){const ue=n.CharCode.Z-n.CharCode.A+1;return Z=Z%(2*ue),Z<ue?String.fromCharCode(n.CharCode.a+Z):String.fromCharCode(n.CharCode.A+Z-ue)}function ye(Z){return Fe.getInstance().getGraphemeBreakType(Z)}function Ie(Z,ue){return Z===de.Other?ue!==de.Extend&&ue!==de.SpacingMark:Z===de.CR&&ue===de.LF?!1:Z===de.Control||Z===de.CR||Z===de.LF||ue===de.Control||ue===de.CR||ue===de.LF?!0:!(Z===de.L&&(ue===de.L||ue===de.V||ue===de.LV||ue===de.LVT)||(Z===de.LV||Z===de.V)&&(ue===de.V||ue===de.T)||(Z===de.LVT||Z===de.T)&&ue===de.T||ue===de.Extend||ue===de.ZWJ||ue===de.SpacingMark||Z===de.Prepend||Z===de.ZWJ&&ue===de.Extended_Pictographic||Z===de.Regional_Indicator&&ue===de.Regional_Indicator)}var de;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(de||(t.GraphemeBreakType=de={}));class Fe{static{this._INSTANCE=null}static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}constructor(){this._data=qe()}getGraphemeBreakType(ue){if(ue<32)return ue===n.CharCode.LineFeed?de.LF:ue===n.CharCode.CarriageReturn?de.CR:de.Control;if(ue<127)return de.Other;const be=this._data,Te=be.length/3;let Pe=1;for(;Pe<=Te;)if(ue<be[3*Pe])Pe=2*Pe;else if(ue>be[3*Pe+1])Pe=2*Pe+1;else return be[3*Pe+2];return de.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(Z,ue){if(Z===0)return 0;const be=tt(Z,ue);if(be!==void 0)return be;const Te=new ae(ue,Z);return Te.prevCodePoint(),Te.offset}function tt(Z,ue){const be=new ae(ue,Z);let Te=be.prevCodePoint();for(;at(Te)||Te===st.emojiVariantSelector||Te===st.enclosingKeyCap;){if(be.offset===0)return;Te=be.prevCodePoint()}if(!g(Te))return;let Pe=be.offset;return Pe>0&&be.prevCodePoint()===st.zwj&&(Pe=be.offset),Pe}function at(Z){return 127995<=Z&&Z<=127999}var st;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),t.noBreakWhitespace="\xA0";class je{static{this.ambiguousCharacterData=new P.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new i.LRUCachedFunction({getCacheKey:JSON.stringify},ue=>{function be(nt){const ft=new Map;for(let dt=0;dt<nt.length;dt+=2)ft.set(nt[dt],nt[dt+1]);return ft}function Te(nt,ft){const dt=new Map(nt);for(const[Dt,ze]of ft)dt.set(Dt,ze);return dt}function Pe(nt,ft){if(!nt)return ft;const dt=new Map;for(const[Dt,ze]of nt)ft.has(Dt)&&dt.set(Dt,ze);return dt}const Ve=this.ambiguousCharacterData.value;let Qe=ue.filter(nt=>!nt.startsWith("_")&&nt in Ve);Qe.length===0&&(Qe=["_default"]);let rt;for(const nt of Qe){const ft=be(Ve[nt]);rt=Pe(rt,ft)}const it=be(Ve._common),ht=Te(it,rt);return new je(ht)})}static getInstance(ue){return je.cache.get(Array.from(ue))}static{this._locales=new P.Lazy(()=>Object.keys(je.ambiguousCharacterData.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return je._locales.value}constructor(ue){this.confusableDictionary=ue}isAmbiguous(ue){return this.confusableDictionary.has(ue)}containsAmbiguousCharacter(ue){for(let be=0;be<ue.length;be++){const Te=ue.codePointAt(be);if(typeof Te=="number"&&this.isAmbiguous(Te))return!0}return!1}getPrimaryConfusable(ue){return this.confusableDictionary.get(ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=je;class Ze{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ze.getRawData())),this._data}static isInvisibleCharacter(ue){return Ze.getData().has(ue)}static containsInvisibleCharacter(ue){for(let be=0;be<ue.length;be++){const Te=ue.codePointAt(be);if(typeof Te=="number"&&Ze.isInvisibleCharacter(Te))return!0}return!1}static get codePoints(){return Ze.getData()}}t.InvisibleCharacters=Ze}),define(ve[108],De([1,0,17,28,5,11,10]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPathSeparator=D,t.toSlashes=w,t.toPosixPath=d,t.getRoot=v,t.isUNC=_,t.isValidBasename=s,t.isEqual=r,t.isEqualOrParent=c,t.isWindowsDriveLetter=l,t.sanitizeFilePath=E,t.removeTrailingPathSeparator=T,t.isRootOrDriveLetter=A,t.hasDriveLetter=f,t.getDriveLetter=h,t.indexOfPath=p,t.parseLineAndColumnAware=S,t.randomPath=x;function D(y){return y===i.CharCode.Slash||y===i.CharCode.Backslash}function w(y){return y.replace(/[\\/]/g,n.posix.sep)}function d(y){return y.indexOf("/")===-1&&(y=w(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function v(y,O=n.posix.sep){if(!y)return"";const V=y.length,R=y.charCodeAt(0);if(D(R)){if(D(y.charCodeAt(1))&&!D(y.charCodeAt(2))){let G=3;const Q=G;for(;G<V&&!D(y.charCodeAt(G));G++);if(Q!==G&&!D(y.charCodeAt(G+1))){for(G+=1;G<V;G++)if(D(y.charCodeAt(G)))return y.slice(0,G+1).replace(/[\\/]/g,O)}}return O}else if(l(R)&&y.charCodeAt(1)===i.CharCode.Colon)return D(y.charCodeAt(2))?y.slice(0,2)+O:y.slice(0,2);let W=y.indexOf("://");if(W!==-1){for(W+=3;W<V;W++)if(D(y.charCodeAt(W)))return y.slice(0,W+1)}return""}function _(y){if(!P.isWindows||!y||y.length<5)return!1;let O=y.charCodeAt(0);if(O!==i.CharCode.Backslash||(O=y.charCodeAt(1),O!==i.CharCode.Backslash))return!1;let V=2;const R=V;for(;V<y.length&&(O=y.charCodeAt(V),O!==i.CharCode.Backslash);V++);return!(R===V||(O=y.charCodeAt(V+1),isNaN(O)||O===i.CharCode.Backslash))}const b=/[\\/:\*\?"<>\|]/g,m=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(y,O=P.isWindows){const V=O?b:m;return!(!y||y.length===0||/^\s+$/.test(y)||(V.lastIndex=0,V.test(y))||O&&e.test(y)||y==="."||y===".."||O&&y[y.length-1]==="."||O&&y.length!==y.trim().length||y.length>255)}function r(y,O,V){const R=y===O;return!V||R?R:!y||!O?!1:(0,F.equalsIgnoreCase)(y,O)}function c(y,O,V,R=n.sep){if(y===O)return!0;if(!y||!O||O.length>y.length)return!1;if(V){if(!(0,F.startsWithIgnoreCase)(y,O))return!1;if(O.length===y.length)return!0;let G=O.length;return O.charAt(O.length-1)===R&&G--,y.charAt(G)===R}return O.charAt(O.length-1)!==R&&(O+=R),y.indexOf(O)===0}function l(y){return y>=i.CharCode.A&&y<=i.CharCode.Z||y>=i.CharCode.a&&y<=i.CharCode.z}function E(y,O){return P.isWindows&&y.endsWith(":")&&(y+=n.sep),(0,n.isAbsolute)(y)||(y=(0,n.join)(O,y)),y=(0,n.normalize)(y),T(y)}function T(y){return P.isWindows?(y=(0,F.rtrim)(y,n.sep),y.endsWith(":")&&(y+=n.sep)):(y=(0,F.rtrim)(y,n.sep),y||(y=n.sep)),y}function A(y){const O=(0,n.normalize)(y);return P.isWindows?y.length>3?!1:f(O)&&(y.length===2||O.charCodeAt(2)===i.CharCode.Backslash):O===n.posix.sep}function f(y,O=P.isWindows){return O?l(y.charCodeAt(0))&&y.charCodeAt(1)===i.CharCode.Colon:!1}function h(y,O=P.isWindows){return f(y,O)?y[0]:void 0}function p(y,O,V){return O.length>y.length?-1:y===O?0:(V&&(y=y.toLowerCase(),O=O.toLowerCase()),y.indexOf(O))}function S(y){const O=y.split(":");let V,R,W;for(const G of O){const Q=Number(G);(0,I.isNumber)(Q)?R===void 0?R=Q:W===void 0&&(W=Q):V=V?[V,G].join(":"):G}if(!V)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:V,line:R!==void 0?R:void 0,column:W!==void 0?W:R!==void 0?1:void 0}}const U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",H="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function x(y,O,V=8){let R="";for(let G=0;G<V;G++){let Q;G===0&&P.isWindows&&!O&&(V===3||V===4)?Q=H:Q=U,R+=Q.charAt(Math.floor(Math.random()*Q.length))}let W;return O?W=`${O}-${R}`:W=R,y?(0,n.join)(y,W):W}}),define(ve[49],De([1,0,17,43,93,11]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FuzzyScoreOptions=t.FuzzyScore=t.matchesPrefix=t.matchesStrictPrefix=void 0,t.or=I,t.matchesContiguousSubString=w,t.matchesSubString=d,t.isUpper=b,t.matchesCamelCase=x,t.matchesWords=y,t.matchesFuzzy=Q,t.matchesFuzzy2=j,t.anyScore=q,t.createMatches=J,t.isPatternInWord=xe,t.fuzzyScore=a,t.fuzzyScoreGracefulAggressive=k,t.fuzzyScoreGraceful=L,F=Ue(F);function I(...C){return function(M,z){for(let X=0,ie=C.length;X<ie;X++){const re=C[X](M,z);if(re)return re}return null}}t.matchesStrictPrefix=D.bind(void 0,!1),t.matchesPrefix=D.bind(void 0,!0);function D(C,M,z){if(!z||z.length<M.length)return null;let X;return C?X=F.startsWithIgnoreCase(z,M):X=z.indexOf(M)===0,X?M.length>0?[{start:0,end:M.length}]:[]:null}function w(C,M){const z=M.toLowerCase().indexOf(C.toLowerCase());return z===-1?null:[{start:z,end:z+C.length}]}function d(C,M){return v(C.toLowerCase(),M.toLowerCase(),0,0)}function v(C,M,z,X){if(z===C.length)return[];if(X===M.length)return null;if(C[z]===M[X]){let ie=null;return(ie=v(C,M,z+1,X+1))?A({start:X,end:X+1},ie):null}return v(C,M,z,X+1)}function _(C){return i.CharCode.a<=C&&C<=i.CharCode.z}function b(C){return i.CharCode.A<=C&&C<=i.CharCode.Z}function m(C){return i.CharCode.Digit0<=C&&C<=i.CharCode.Digit9}function e(C){return C===i.CharCode.Space||C===i.CharCode.Tab||C===i.CharCode.LineFeed||C===i.CharCode.CarriageReturn}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(C=>s.add(C.charCodeAt(0)));function r(C){return e(C)||s.has(C)}function c(C,M){return C===M||r(C)&&r(M)}const l=new Map;function E(C){if(l.has(C))return l.get(C);let M;const z=(0,P.getKoreanAltChars)(C);return z&&(M=z),l.set(C,M),M}function T(C){return _(C)||b(C)||m(C)}function A(C,M){return M.length===0?M=[C]:C.end===M[0].start?M[0].start=C.start:M.unshift(C),M}function f(C,M){for(let z=M;z<C.length;z++){const X=C.charCodeAt(z);if(b(X)||m(X)||z>0&&!T(C.charCodeAt(z-1)))return z}return C.length}function h(C,M,z,X){if(z===C.length)return[];if(X===M.length)return null;if(C[z]!==M[X].toLowerCase())return null;{let ie=null,re=X+1;for(ie=h(C,M,z+1,X+1);!ie&&(re=f(M,re))<M.length;)ie=h(C,M,z+1,re),re++;return ie===null?null:A({start:X,end:X+1},ie)}}function p(C){let M=0,z=0,X=0,ie=0,re=0;for(let Ie=0;Ie<C.length;Ie++)re=C.charCodeAt(Ie),b(re)&&M++,_(re)&&z++,T(re)&&X++,m(re)&&ie++;const ce=M/C.length,we=z/C.length,Ee=X/C.length,ye=ie/C.length;return{upperPercent:ce,lowerPercent:we,alphaPercent:Ee,numericPercent:ye}}function S(C){const{upperPercent:M,lowerPercent:z}=C;return z===0&&M>.6}function U(C){const{upperPercent:M,lowerPercent:z,alphaPercent:X,numericPercent:ie}=C;return z>.2&&M<.8&&X>.6&&ie<.2}function H(C){let M=0,z=0,X=0,ie=0;for(let re=0;re<C.length;re++)X=C.charCodeAt(re),b(X)&&M++,_(X)&&z++,e(X)&&ie++;return(M===0||z===0)&&ie===0?C.length<=30:M<=5}function x(C,M){if(!M||(M=M.trim(),M.length===0)||!H(C))return null;M.length>60&&(M=M.substring(0,60));const z=p(M);if(!U(z)){if(!S(z))return null;M=M.toLowerCase()}let X=null,ie=0;for(C=C.toLowerCase();ie<M.length&&(X=h(C,M,0,ie))===null;)ie=f(M,ie+1);return X}function y(C,M,z=!1){if(!M||M.length===0)return null;let X=null,ie=0;for(C=C.toLowerCase(),M=M.toLowerCase();ie<M.length&&(X=O(C,M,0,ie,z),X===null);)ie=V(M,ie+1);return X}function O(C,M,z,X,ie){let re=0;if(z===C.length)return[];if(X===M.length)return null;if(!c(C.charCodeAt(z),M.charCodeAt(X))){const Ee=E(C.charCodeAt(z));if(!Ee)return null;for(let ye=0;ye<Ee.length;ye++)if(!c(Ee[ye],M.charCodeAt(X+ye)))return null;re+=Ee.length-1}let ce=null,we=X+re+1;if(ce=O(C,M,z+1,we,ie),!ie)for(;!ce&&(we=V(M,we))<M.length;)ce=O(C,M,z+1,we,ie),we++;if(!ce)return null;if(C.charCodeAt(z)!==M.charCodeAt(X)){const Ee=E(C.charCodeAt(z));if(!Ee)return ce;for(let ye=0;ye<Ee.length;ye++)if(Ee[ye]!==M.charCodeAt(X+ye))return ce}return A({start:X,end:X+re+1},ce)}function V(C,M){for(let z=M;z<C.length;z++)if(r(C.charCodeAt(z))||z>0&&r(C.charCodeAt(z-1)))return z;return C.length}const R=I(t.matchesPrefix,x,w),W=I(t.matchesPrefix,x,d),G=new n.LRUCache(1e4);function Q(C,M,z=!1){if(typeof C!="string"||typeof M!="string")return null;let X=G.get(C);X||(X=new RegExp(F.convertSimple2RegExpPattern(C),"i"),G.set(C,X));const ie=X.exec(M);return ie?[{start:ie.index,end:ie.index+ie[0].length}]:z?W(C,M):R(C,M)}function j(C,M){const z=a(C,C.toLowerCase(),0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?J(z):null}function q(C,M,z,X,ie,re){const ce=Math.min(13,C.length);for(;z<ce;z++){const we=a(C,M,z,X,ie,re,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,re]}function J(C){if(typeof C>"u")return[];const M=[],z=C[1];for(let X=C.length-1;X>1;X--){const ie=C[X]+z,re=M[M.length-1];re&&re.end===ie?re.end=ie+1:M.push({start:ie,end:ie+1})}return M}const le=128;function me(){const C=[],M=[];for(let z=0;z<=le;z++)M[z]=0;for(let z=0;z<=le;z++)C.push(M.slice(0));return C}function _e(C){const M=[];for(let z=0;z<=C;z++)M[z]=0;return M}const Ne=_e(2*le),ne=_e(2*le),ee=me(),he=me(),ae=me(),Le=!1;function te(C,M,z,X,ie){function re(we,Ee,ye=" "){for(;we.length<Ee;)we=ye+we;return we}let ce=` |   |${X.split("").map(we=>re(we,3)).join("|")}
`;for(let we=0;we<=z;we++)we===0?ce+=" |":ce+=`${M[we-1]}|`,ce+=C[we].slice(0,ie+1).map(Ee=>re(Ee.toString(),3)).join("|")+`
`;return ce}function pe(C,M,z,X){C=C.substr(M),z=z.substr(X),console.log(te(he,C,C.length,z,z.length)),console.log(te(ae,C,C.length,z,z.length)),console.log(te(ee,C,C.length,z,z.length))}function Ae(C,M){if(M<0||M>=C.length)return!1;const z=C.codePointAt(M);switch(z){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(z)}}function Ce(C,M){if(M<0||M>=C.length)return!1;switch(C.charCodeAt(M)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function Re(C,M,z){return M[C]!==z[C]}function xe(C,M,z,X,ie,re,ce=!1){for(;M<z&&ie<re;)C[M]===X[ie]&&(ce&&(Ne[M]=ie),M+=1),ie+=1;return M===z}var He;(function(C){C[C.Diag=1]="Diag",C[C.Left=2]="Left",C[C.LeftLeft=3]="LeftLeft"})(He||(He={}));var $;(function(C){C.Default=[-100,0];function M(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}C.isDefault=M})($||(t.FuzzyScore=$={}));class B{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(M,z){this.firstMatchCanBeWeak=M,this.boostFullMatch=z}}t.FuzzyScoreOptions=B;function a(C,M,z,X,ie,re,ce=B.default){const we=C.length>le?le:C.length,Ee=X.length>le?le:X.length;if(z>=we||re>=Ee||we-z>Ee-re||!xe(M,z,we,ie,re,Ee,!0))return;o(we,Ee,z,re,M,ie);let ye=1,Ie=1,de=z,Fe=re;const qe=[!1];for(ye=1,de=z;de<we;ye++,de++){const je=Ne[de],Ze=ne[de],Z=de+1<we?ne[de+1]:Ee;for(Ie=je-re+1,Fe=je;Fe<Z;Ie++,Fe++){let ue=Number.MIN_SAFE_INTEGER,be=!1;Fe<=Ze&&(ue=g(C,M,de,z,X,ie,Fe,Ee,re,ee[ye-1][Ie-1]===0,qe));let Te=0;ue!==Number.MAX_SAFE_INTEGER&&(be=!0,Te=ue+he[ye-1][Ie-1]);const Pe=Fe>je,Ve=Pe?he[ye][Ie-1]+(ee[ye][Ie-1]>0?-5:0):0,Qe=Fe>je+1&&ee[ye][Ie-1]>0,rt=Qe?he[ye][Ie-2]+(ee[ye][Ie-2]>0?-5:0):0;if(Qe&&(!Pe||rt>=Ve)&&(!be||rt>=Te))he[ye][Ie]=rt,ae[ye][Ie]=He.LeftLeft,ee[ye][Ie]=0;else if(Pe&&(!be||Ve>=Te))he[ye][Ie]=Ve,ae[ye][Ie]=He.Left,ee[ye][Ie]=0;else if(be)he[ye][Ie]=Te,ae[ye][Ie]=He.Diag,ee[ye][Ie]=ee[ye-1][Ie-1]+1;else throw new Error("not possible")}}if(Le&&pe(C,z,X,re),!qe[0]&&!ce.firstMatchCanBeWeak)return;ye--,Ie--;const Ye=[he[ye][Ie],re];let tt=0,at=0;for(;ye>=1;){let je=Ie;do{const Ze=ae[ye][je];if(Ze===He.LeftLeft)je=je-2;else if(Ze===He.Left)je=je-1;else break}while(je>=1);tt>1&&M[z+ye-1]===ie[re+Ie-1]&&!Re(je+re-1,X,ie)&&tt+1>ee[ye][je]&&(je=Ie),je===Ie?tt++:tt=1,at||(at=je),ye--,Ie=je-1,Ye.push(Ie)}Ee-re===we&&ce.boostFullMatch&&(Ye[0]+=2);const st=at-we;return Ye[0]-=st,Ye}function o(C,M,z,X,ie,re){let ce=C-1,we=M-1;for(;ce>=z&&we>=X;)ie[ce]===re[we]&&(ne[ce]=we,ce--),we--}function g(C,M,z,X,ie,re,ce,we,Ee,ye,Ie){if(M[z]!==re[ce])return Number.MIN_SAFE_INTEGER;let de=1,Fe=!1;return ce===z-X?de=C[z]===ie[ce]?7:5:Re(ce,ie,re)&&(ce===0||!Re(ce-1,ie,re))?(de=C[z]===ie[ce]?7:5,Fe=!0):Ae(re,ce)&&(ce===0||!Ae(re,ce-1))?de=5:(Ae(re,ce-1)||Ce(re,ce-1))&&(de=5,Fe=!0),de>1&&z===X&&(Ie[0]=!0),Fe||(Fe=Re(ce,ie,re)||Ae(re,ce-1)||Ce(re,ce-1)),z===X?ce>Ee&&(de-=Fe?3:5):ye?de+=Fe?2:0:de+=Fe?0:1,ce+1===we&&(de-=Fe?3:5),de}function k(C,M,z,X,ie,re,ce){return u(C,M,z,X,ie,re,!0,ce)}function L(C,M,z,X,ie,re,ce){return u(C,M,z,X,ie,re,!1,ce)}function u(C,M,z,X,ie,re,ce,we){let Ee=a(C,M,z,X,ie,re,we);if(Ee&&!ce)return Ee;if(C.length>=3){const ye=Math.min(7,C.length-1);for(let Ie=z+1;Ie<ye;Ie++){const de=N(C,Ie);if(de){const Fe=a(de,de.toLowerCase(),z,X,ie,re,we);Fe&&(Fe[0]-=3,(!Ee||Fe[0]>Ee[0])&&(Ee=Fe))}}}return Ee}function N(C,M){if(M+1>=C.length)return;const z=C[M],X=C[M+1];if(z!==X)return C.slice(0,M)+X+z+C.slice(M+2)}}),define(ve[66],De([1,0,11]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=n,t.doHash=P,t.numberHash=F,t.stringHash=D,t.toHexString=s,i=Ue(i);function n(c){return P(c,0)}function P(c,l){switch(typeof c){case"object":return c===null?F(349,l):Array.isArray(c)?w(c,l):d(c,l);case"string":return D(c,l);case"boolean":return I(c,l);case"number":return F(c,l);case"undefined":return F(937,l);default:return F(617,l)}}function F(c,l){return(l<<5)-l+c|0}function I(c,l){return F(c?433:863,l)}function D(c,l){l=F(149417,l);for(let E=0,T=c.length;E<T;E++)l=F(c.charCodeAt(E),l);return l}function w(c,l){return l=F(104579,l),c.reduce((E,T)=>P(T,E),l)}function d(c,l){return l=F(181387,l),Object.keys(c).sort().reduce((E,T)=>(E=D(T,E),P(c[T],E)),l)}class v{constructor(){this._value=0}get value(){return this._value}hash(l){return this._value=P(l,this._value),this._value}}t.Hasher=v;var _;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(_||(_={}));function b(c,l,E=32){const T=E-l,A=~((1<<T)-1);return(c<<l|(A&c)>>>T)>>>0}function m(c,l=0,E=c.byteLength,T=0){for(let A=0;A<E;A++)c[l+A]=T}function e(c,l,E="0"){for(;c.length<l;)c=E+c;return c}function s(c,l=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(E=>E.toString(16).padStart(2,"0")).join(""):e((c>>>0).toString(16),l/4)}class r{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(_.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(l){const E=l.length;if(E===0)return;const T=this._buff;let A=this._buffLen,f=this._leftoverHighSurrogate,h,p;for(f!==0?(h=f,p=-1,f=0):(h=l.charCodeAt(0),p=0);;){let S=h;if(i.isHighSurrogate(h))if(p+1<E){const U=l.charCodeAt(p+1);i.isLowSurrogate(U)?(p++,S=i.computeCodePoint(h,U)):S=_.UNICODE_REPLACEMENT}else{f=h;break}else i.isLowSurrogate(h)&&(S=_.UNICODE_REPLACEMENT);if(A=this._push(T,A,S),p++,p<E)h=l.charCodeAt(p);else break}this._buffLen=A,this._leftoverHighSurrogate=f}_push(l,E,T){return T<128?l[E++]=T:T<2048?(l[E++]=192|(T&1984)>>>6,l[E++]=128|(T&63)>>>0):T<65536?(l[E++]=224|(T&61440)>>>12,l[E++]=128|(T&4032)>>>6,l[E++]=128|(T&63)>>>0):(l[E++]=240|(T&1835008)>>>18,l[E++]=128|(T&258048)>>>12,l[E++]=128|(T&4032)>>>6,l[E++]=128|(T&63)>>>0),E>=_.BLOCK_SIZE&&(this._step(),E-=_.BLOCK_SIZE,this._totalLen+=_.BLOCK_SIZE,l[0]=l[_.BLOCK_SIZE+0],l[1]=l[_.BLOCK_SIZE+1],l[2]=l[_.BLOCK_SIZE+2]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,_.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const l=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(l/4294967296),!1),this._buffDV.setUint32(60,l%4294967296,!1),this._step()}_step(){const l=r._bigBlock32,E=this._buffDV;for(let x=0;x<64;x+=4)l.setUint32(x,E.getUint32(x,!1),!1);for(let x=64;x<320;x+=4)l.setUint32(x,b(l.getUint32(x-12,!1)^l.getUint32(x-32,!1)^l.getUint32(x-56,!1)^l.getUint32(x-64,!1),1),!1);let T=this._h0,A=this._h1,f=this._h2,h=this._h3,p=this._h4,S,U,H;for(let x=0;x<80;x++)x<20?(S=A&f|~A&h,U=1518500249):x<40?(S=A^f^h,U=1859775393):x<60?(S=A&f|A&h|f&h,U=2400959708):(S=A^f^h,U=3395469782),H=b(T,5)+S+p+U+l.getUint32(x*4,!1)&4294967295,p=h,h=f,f=b(A,30),A=T,T=H;this._h0=this._h0+T&4294967295,this._h1=this._h1+A&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+p&4294967295}}t.StringSHA1=r}),define(ve[109],De([1,0,89,66,65]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.StringDiffSequence=void 0,t.stringDiff=I;class F{constructor(m){this.source=m}getElements(){const m=this.source,e=new Int32Array(m.length);for(let s=0,r=m.length;s<r;s++)e[s]=m.charCodeAt(s);return e}}t.StringDiffSequence=F;function I(b,m,e){return new _(new F(b),new F(m)).ComputeDiff(e).changes}class D{static Assert(m,e){if(!m)throw new Error(e)}}class w{static Copy(m,e,s,r,c){for(let l=0;l<c;l++)s[r+l]=m[e+l]}static Copy2(m,e,s,r,c){for(let l=0;l<c;l++)s[r+l]=m[e+l]}}var d;(function(b){b[b.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(d||(d={}));class v{constructor(){this.m_changes=[],this.m_originalStart=P.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=P.Constants.MAX_SAFE_SMALL_INTEGER,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new i.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=P.Constants.MAX_SAFE_SMALL_INTEGER,this.m_modifiedStart=P.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(m,e){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_originalCount++}AddModifiedElement(m,e){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,e),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class _{constructor(m,e,s=null){this.ContinueProcessingPredicate=s,this._originalSequence=m,this._modifiedSequence=e;const[r,c,l]=_._getElements(m),[E,T,A]=_._getElements(e);this._hasStrings=l&&A,this._originalStringElements=r,this._originalElementsOrHash=c,this._modifiedStringElements=E,this._modifiedElementsOrHash=T,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(m){return m.length>0&&typeof m[0]=="string"}static _getElements(m){const e=m.getElements();if(_._isStringArray(e)){const s=new Int32Array(e.length);for(let r=0,c=e.length;r<c;r++)s[r]=(0,n.stringHash)(e[r],0);return[e,s,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}ElementsAreEqual(m,e){return this._originalElementsOrHash[m]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[m]===this._modifiedStringElements[e]:!0}ElementsAreStrictEqual(m,e){if(!this.ElementsAreEqual(m,e))return!1;const s=_._getStrictElement(this._originalSequence,m),r=_._getStrictElement(this._modifiedSequence,e);return s===r}static _getStrictElement(m,e){return typeof m.getStrictElement=="function"?m.getStrictElement(e):null}OriginalElementsAreEqual(m,e){return this._originalElementsOrHash[m]!==this._originalElementsOrHash[e]?!1:this._hasStrings?this._originalStringElements[m]===this._originalStringElements[e]:!0}ModifiedElementsAreEqual(m,e){return this._modifiedElementsOrHash[m]!==this._modifiedElementsOrHash[e]?!1:this._hasStrings?this._modifiedStringElements[m]===this._modifiedStringElements[e]:!0}ComputeDiff(m){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,m)}_ComputeDiff(m,e,s,r,c){const l=[!1];let E=this.ComputeDiffRecursive(m,e,s,r,l);return c&&(E=this.PrettifyChanges(E)),{quitEarly:l[0],changes:E}}ComputeDiffRecursive(m,e,s,r,c){for(c[0]=!1;m<=e&&s<=r&&this.ElementsAreEqual(m,s);)m++,s++;for(;e>=m&&r>=s&&this.ElementsAreEqual(e,r);)e--,r--;if(m>e||s>r){let h;return s<=r?(D.Assert(m===e+1,"originalStart should only be one more than originalEnd"),h=[new i.DiffChange(m,0,s,r-s+1)]):m<=e?(D.Assert(s===r+1,"modifiedStart should only be one more than modifiedEnd"),h=[new i.DiffChange(m,e-m+1,s,0)]):(D.Assert(m===e+1,"originalStart should only be one more than originalEnd"),D.Assert(s===r+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const l=[0],E=[0],T=this.ComputeRecursionPoint(m,e,s,r,l,E,c),A=l[0],f=E[0];if(T!==null)return T;if(!c[0]){const h=this.ComputeDiffRecursive(m,A,s,f,c);let p=[];return c[0]?p=[new i.DiffChange(A+1,e-(A+1)+1,f+1,r-(f+1)+1)]:p=this.ComputeDiffRecursive(A+1,e,f+1,r,c),this.ConcatenateChanges(h,p)}return[new i.DiffChange(m,e-m+1,s,r-s+1)]}WALKTRACE(m,e,s,r,c,l,E,T,A,f,h,p,S,U,H,x,y,O){let V=null,R=null,W=new v,G=e,Q=s,j=S[0]-x[0]-r,q=P.Constants.MIN_SAFE_SMALL_INTEGER,J=this.m_forwardHistory.length-1;do{const le=j+m;le===G||le<Q&&A[le-1]<A[le+1]?(h=A[le+1],U=h-j-r,h<q&&W.MarkNextChange(),q=h,W.AddModifiedElement(h+1,U),j=le+1-m):(h=A[le-1]+1,U=h-j-r,h<q&&W.MarkNextChange(),q=h-1,W.AddOriginalElement(h,U+1),j=le-1-m),J>=0&&(A=this.m_forwardHistory[J],m=A[0],G=1,Q=A.length-1)}while(--J>=-1);if(V=W.getReverseChanges(),O[0]){let le=S[0]+1,me=x[0]+1;if(V!==null&&V.length>0){const _e=V[V.length-1];le=Math.max(le,_e.getOriginalEnd()),me=Math.max(me,_e.getModifiedEnd())}R=[new i.DiffChange(le,p-le+1,me,H-me+1)]}else{W=new v,G=l,Q=E,j=S[0]-x[0]-T,q=P.Constants.MAX_SAFE_SMALL_INTEGER,J=y?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const le=j+c;le===G||le<Q&&f[le-1]>=f[le+1]?(h=f[le+1]-1,U=h-j-T,h>q&&W.MarkNextChange(),q=h+1,W.AddOriginalElement(h+1,U+1),j=le+1-c):(h=f[le-1],U=h-j-T,h>q&&W.MarkNextChange(),q=h,W.AddModifiedElement(h+1,U+1),j=le-1-c),J>=0&&(f=this.m_reverseHistory[J],c=f[0],G=1,Q=f.length-1)}while(--J>=-1);R=W.getChanges()}return this.ConcatenateChanges(V,R)}ComputeRecursionPoint(m,e,s,r,c,l,E){let T=0,A=0,f=0,h=0,p=0,S=0;m--,s--,c[0]=0,l[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const U=e-m+(r-s),H=U+1,x=new Int32Array(H),y=new Int32Array(H),O=r-s,V=e-m,R=m-s,W=e-r,Q=(V-O)%2===0;x[O]=m,y[V]=e,E[0]=!1;for(let j=1;j<=U/2+1;j++){let q=0,J=0;f=this.ClipDiagonalBound(O-j,j,O,H),h=this.ClipDiagonalBound(O+j,j,O,H);for(let me=f;me<=h;me+=2){me===f||me<h&&x[me-1]<x[me+1]?T=x[me+1]:T=x[me-1]+1,A=T-(me-O)-R;const _e=T;for(;T<e&&A<r&&this.ElementsAreEqual(T+1,A+1);)T++,A++;if(x[me]=T,T+A>q+J&&(q=T,J=A),!Q&&Math.abs(me-V)<=j-1&&T>=y[me])return c[0]=T,l[0]=A,_e<=y[me]&&d.MaxDifferencesHistory>0&&j<=d.MaxDifferencesHistory+1?this.WALKTRACE(O,f,h,R,V,p,S,W,x,y,T,e,c,A,r,l,Q,E):null}const le=(q-m+(J-s)-j)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(q,le))return E[0]=!0,c[0]=q,l[0]=J,le>0&&d.MaxDifferencesHistory>0&&j<=d.MaxDifferencesHistory+1?this.WALKTRACE(O,f,h,R,V,p,S,W,x,y,T,e,c,A,r,l,Q,E):(m++,s++,[new i.DiffChange(m,e-m+1,s,r-s+1)]);p=this.ClipDiagonalBound(V-j,j,V,H),S=this.ClipDiagonalBound(V+j,j,V,H);for(let me=p;me<=S;me+=2){me===p||me<S&&y[me-1]>=y[me+1]?T=y[me+1]-1:T=y[me-1],A=T-(me-V)-W;const _e=T;for(;T>m&&A>s&&this.ElementsAreEqual(T,A);)T--,A--;if(y[me]=T,Q&&Math.abs(me-O)<=j&&T<=x[me])return c[0]=T,l[0]=A,_e>=x[me]&&d.MaxDifferencesHistory>0&&j<=d.MaxDifferencesHistory+1?this.WALKTRACE(O,f,h,R,V,p,S,W,x,y,T,e,c,A,r,l,Q,E):null}if(j<=d.MaxDifferencesHistory){let me=new Int32Array(h-f+2);me[0]=O-f+1,w.Copy2(x,f,me,1,h-f+1),this.m_forwardHistory.push(me),me=new Int32Array(S-p+2),me[0]=V-p+1,w.Copy2(y,p,me,1,S-p+1),this.m_reverseHistory.push(me)}}return this.WALKTRACE(O,f,h,R,V,p,S,W,x,y,T,e,c,A,r,l,Q,E)}PrettifyChanges(m){for(let e=0;e<m.length;e++){const s=m[e],r=e<m.length-1?m[e+1].originalStart:this._originalElementsOrHash.length,c=e<m.length-1?m[e+1].modifiedStart:this._modifiedElementsOrHash.length,l=s.originalLength>0,E=s.modifiedLength>0;for(;s.originalStart+s.originalLength<r&&s.modifiedStart+s.modifiedLength<c&&(!l||this.OriginalElementsAreEqual(s.originalStart,s.originalStart+s.originalLength))&&(!E||this.ModifiedElementsAreEqual(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const A=this.ElementsAreStrictEqual(s.originalStart,s.modifiedStart);if(this.ElementsAreStrictEqual(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!A)break;s.originalStart++,s.modifiedStart++}const T=[null];if(e<m.length-1&&this.ChangesOverlap(m[e],m[e+1],T)){m[e]=T[0],m.splice(e+1,1),e--;continue}}for(let e=m.length-1;e>=0;e--){const s=m[e];let r=0,c=0;if(e>0){const h=m[e-1];r=h.originalStart+h.originalLength,c=h.modifiedStart+h.modifiedLength}const l=s.originalLength>0,E=s.modifiedLength>0;let T=0,A=this._boundaryScore(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let h=1;;h++){const p=s.originalStart-h,S=s.modifiedStart-h;if(p<r||S<c||l&&!this.OriginalElementsAreEqual(p,p+s.originalLength)||E&&!this.ModifiedElementsAreEqual(S,S+s.modifiedLength))break;const H=(p===r&&S===c?5:0)+this._boundaryScore(p,s.originalLength,S,s.modifiedLength);H>A&&(A=H,T=h)}s.originalStart-=T,s.modifiedStart-=T;const f=[null];if(e>0&&this.ChangesOverlap(m[e-1],m[e],f)){m[e-1]=f[0],m.splice(e,1),e++;continue}}if(this._hasStrings)for(let e=1,s=m.length;e<s;e++){const r=m[e-1],c=m[e],l=c.originalStart-r.originalStart-r.originalLength,E=r.originalStart,T=c.originalStart+c.originalLength,A=T-E,f=r.modifiedStart,h=c.modifiedStart+c.modifiedLength,p=h-f;if(l<5&&A<20&&p<20){const S=this._findBetterContiguousSequence(E,A,f,p,l);if(S){const[U,H]=S;(U!==r.originalStart+r.originalLength||H!==r.modifiedStart+r.modifiedLength)&&(r.originalLength=U-r.originalStart,r.modifiedLength=H-r.modifiedStart,c.originalStart=U+l,c.modifiedStart=H+l,c.originalLength=T-c.originalStart,c.modifiedLength=h-c.modifiedStart)}}}return m}_findBetterContiguousSequence(m,e,s,r,c){if(e<c||r<c)return null;const l=m+e-c+1,E=s+r-c+1;let T=0,A=0,f=0;for(let h=m;h<l;h++)for(let p=s;p<E;p++){const S=this._contiguousSequenceScore(h,p,c);S>0&&S>T&&(T=S,A=h,f=p)}return T>0?[A,f]:null}_contiguousSequenceScore(m,e,s){let r=0;for(let c=0;c<s;c++){if(!this.ElementsAreEqual(m+c,e+c))return 0;r+=this._originalStringElements[m+c].length}return r}_OriginalIsBoundary(m){return m<=0||m>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[m])}_OriginalRegionIsBoundary(m,e){if(this._OriginalIsBoundary(m)||this._OriginalIsBoundary(m-1))return!0;if(e>0){const s=m+e;if(this._OriginalIsBoundary(s-1)||this._OriginalIsBoundary(s))return!0}return!1}_ModifiedIsBoundary(m){return m<=0||m>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[m])}_ModifiedRegionIsBoundary(m,e){if(this._ModifiedIsBoundary(m)||this._ModifiedIsBoundary(m-1))return!0;if(e>0){const s=m+e;if(this._ModifiedIsBoundary(s-1)||this._ModifiedIsBoundary(s))return!0}return!1}_boundaryScore(m,e,s,r){const c=this._OriginalRegionIsBoundary(m,e)?1:0,l=this._ModifiedRegionIsBoundary(s,r)?1:0;return c+l}ConcatenateChanges(m,e){const s=[];if(m.length===0||e.length===0)return e.length>0?e:m;if(this.ChangesOverlap(m[m.length-1],e[0],s)){const r=new Array(m.length+e.length-1);return w.Copy(m,0,r,0,m.length-1),r[m.length-1]=s[0],w.Copy(e,1,r,m.length,e.length-1),r}else{const r=new Array(m.length+e.length);return w.Copy(m,0,r,0,m.length),w.Copy(e,0,r,m.length,e.length),r}}ChangesOverlap(m,e,s){if(D.Assert(m.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),D.Assert(m.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=e.originalStart||m.modifiedStart+m.modifiedLength>=e.modifiedStart){const r=m.originalStart;let c=m.originalLength;const l=m.modifiedStart;let E=m.modifiedLength;return m.originalStart+m.originalLength>=e.originalStart&&(c=e.originalStart+e.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=e.modifiedStart&&(E=e.modifiedStart+e.modifiedLength-m.modifiedStart),s[0]=new i.DiffChange(r,c,l,E),!0}else return s[0]=null,!1}ClipDiagonalBound(m,e,s,r){if(m>=0&&m<r)return m;const c=s,l=r-s-1,E=e%2===0;if(m<0){const T=c%2===0;return E===T?0:1}else{const T=l%2===0;return E===T?r-1:r-2}}}t.LcsDiff=_}),define(ve[67],De([1,0,49,11,22]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.escapeIcons=w,t.markdownEscapeEscapedIcons=v,t.stripIcons=b,t.getCodiconAriaLabel=m,t.parseLabelWithIcons=s,t.matchesFuzzyIconAware=r;const F="$(",I=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${I.source}`,"g");function w(c){return c.replace(D,(l,E)=>E?l:`\\${l}`)}const d=new RegExp(`\\\\${I.source}`,"g");function v(c){return c.replace(d,l=>`\\${l}`)}const _=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function b(c){return c.indexOf(F)===-1?c:c.replace(_,(l,E,T,A)=>T?l:E||A||"")}function m(c){return c?c.replace(/\$\((.*?)\)/g,(l,E)=>` ${E} `).trim():""}const e=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(c){e.lastIndex=0;let l="";const E=[];let T=0;for(;;){const A=e.lastIndex,f=e.exec(c),h=c.substring(A,f?.index);if(h.length>0){l+=h;for(let p=0;p<h.length;p++)E.push(T)}if(!f)break;T+=f[0].length}return{text:l,iconOffsets:E}}function r(c,l,E=!1){const{text:T,iconOffsets:A}=l;if(!A||A.length===0)return(0,i.matchesFuzzy)(c,T,E);const f=(0,n.ltrim)(T," "),h=T.length-f.length,p=(0,i.matchesFuzzy)(c,f,E);if(p)for(const S of p){const U=A[S.start+h]+h;S.start+=U,S.end+=U}return p}}),define(ve[110],De([1,0,9,17,11]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class F{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){const s=e.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}t.StringIterator=F;class I{constructor(e=!0){this._caseSensitive=e}reset(e){return this._value=e,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===n.CharCode.Period)if(e)this._from++;else break;else e=!1;return this}cmp(e){return this._caseSensitive?(0,P.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=I;class D{constructor(e=!0,s=!0){this._splitOnBackslash=e,this._caseSensitive=s}reset(e){this._from=0,this._to=0,this._value=e,this._valueLen=e.length;for(let s=e.length-1;s>=0;s--,this._valueLen--){const r=this._value.charCodeAt(s);if(!(r===n.CharCode.Slash||this._splitOnBackslash&&r===n.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let e=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===n.CharCode.Slash||this._splitOnBackslash&&s===n.CharCode.Backslash)if(e)this._from++;else break;else e=!1}return this}cmp(e){return this._caseSensitive?(0,P.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=D;var w;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(w||(w={}));class d{constructor(e,s){this._ignorePathCasing=e,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(e){return this._value=e,this._states=[],this._value.scheme&&this._states.push(w.Scheme),this._value.authority&&this._states.push(w.Authority),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(e)),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(w.Path)),this._ignoreQueryAndFragment(e)||(this._value.query&&this._states.push(w.Query),this._value.fragment&&this._states.push(w.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===w.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===w.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(this._states[this._stateIdx]===w.Scheme)return(0,P.compareIgnoreCase)(e,this._value.scheme);if(this._states[this._stateIdx]===w.Authority)return(0,P.compareIgnoreCase)(e,this._value.authority);if(this._states[this._stateIdx]===w.Path)return this._pathIterator.cmp(e);if(this._states[this._stateIdx]===w.Query)return(0,P.compare)(e,this._value.query);if(this._states[this._stateIdx]===w.Fragment)return(0,P.compare)(e,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===w.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===w.Authority)return this._value.authority;if(this._states[this._stateIdx]===w.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===w.Query)return this._value.query;if(this._states[this._stateIdx]===w.Fragment)return this._value.fragment;throw new Error}}t.UriIterator=d;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(_||(_={}));class b{static forUris(e=()=>!1,s=()=>!1){return new b(new d(e,s))}static forPaths(e=!1){return new b(new D(void 0,!e))}static forStrings(){return new b(new F)}static forConfigKeys(){return new b(new I)}constructor(e){this._iter=e}clear(){this._root=void 0}fill(e,s){if(s){const r=s.slice(0);(0,i.shuffle)(r);for(const c of r)this.set(c,e)}else{const r=e.slice(0);(0,i.shuffle)(r);for(const c of r)this.set(c[0],c[1])}}set(e,s){const r=this._iter.reset(e);let c;this._root||(this._root=new v,this._root.segment=r.value());const l=[];for(c=this._root;;){const T=r.cmp(c.segment);if(T>0)c.left||(c.left=new v,c.left.segment=r.value()),l.push([_.Left,c]),c=c.left;else if(T<0)c.right||(c.right=new v,c.right.segment=r.value()),l.push([_.Right,c]),c=c.right;else if(r.hasNext())r.next(),c.mid||(c.mid=new v,c.mid.segment=r.value()),l.push([_.Mid,c]),c=c.mid;else break}const E=c.value;c.value=s,c.key=e;for(let T=l.length-1;T>=0;T--){const A=l[T][1];A.updateHeight();const f=A.balanceFactor();if(f<-1||f>1){const h=l[T][0],p=l[T+1][0];if(h===_.Right&&p===_.Right)l[T][1]=A.rotateLeft();else if(h===_.Left&&p===_.Left)l[T][1]=A.rotateRight();else if(h===_.Right&&p===_.Left)A.right=l[T+1][1]=l[T+1][1].rotateRight(),l[T][1]=A.rotateLeft();else if(h===_.Left&&p===_.Right)A.left=l[T+1][1]=l[T+1][1].rotateLeft(),l[T][1]=A.rotateRight();else throw new Error;if(T>0)switch(l[T-1][0]){case _.Left:l[T-1][1].left=l[T][1];break;case _.Right:l[T-1][1].right=l[T][1];break;case _.Mid:l[T-1][1].mid=l[T][1];break}else this._root=l[0][1]}}return E}get(e){return this._getNode(e)?.value}_getNode(e){const s=this._iter.reset(e);let r=this._root;for(;r;){const c=s.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(e){const s=this._getNode(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this._delete(e,!1)}deleteSuperstr(e){return this._delete(e,!0)}_delete(e,s){const r=this._iter.reset(e),c=[];let l=this._root;for(;l;){const E=r.cmp(l.segment);if(E>0)c.push([_.Left,l]),l=l.left;else if(E<0)c.push([_.Right,l]),l=l.right;else if(r.hasNext())r.next(),c.push([_.Mid,l]),l=l.mid;else break}if(l){if(s?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const E=this._min(l.right);if(E.key){const{key:T,value:A,segment:f}=E;this._delete(E.key,!1),l.key=T,l.value=A,l.segment=f}}else{const E=l.left??l.right;if(c.length>0){const[T,A]=c[c.length-1];switch(T){case _.Left:A.left=E;break;case _.Mid:A.mid=E;break;case _.Right:A.right=E;break}}else this._root=E}for(let E=c.length-1;E>=0;E--){const T=c[E][1];T.updateHeight();const A=T.balanceFactor();if(A>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),c[E][1]=T.rotateLeft()):A<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),c[E][1]=T.rotateRight()),E>0)switch(c[E-1][0]){case _.Left:c[E-1][1].left=c[E][1];break;case _.Right:c[E-1][1].right=c[E][1];break;case _.Mid:c[E-1][1].mid=c[E][1];break}else this._root=c[0][1]}}}_min(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this._iter.reset(e);let r=this._root,c;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),c=r.value||c,r=r.mid;else break}return r&&r.value||c}findSuperstr(e){return this._findSuperstrOrElement(e,!1)}_findSuperstrOrElement(e,s){const r=this._iter.reset(e);let c=this._root;for(;c;){const l=r.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this._entries(c.mid):s?c.value:void 0}}hasElementOrSubtree(e){return this._findSuperstrOrElement(e,!0)!==void 0}forEach(e){for(const[s,r]of this)e(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(e){const s=[];return this._dfsEntries(e,s),s[Symbol.iterator]()}_dfsEntries(e,s){e&&(e.left&&this._dfsEntries(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this._dfsEntries(e.mid,s),e.right&&this._dfsEntries(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const r=s.balanceFactor();return r<-1||r>1?!1:e(s.left)&&e(s.right)};return e(this._root)}}t.TernarySearchTree=b}),define(ve[16],De([1,0,17,60,28,5]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.isUriComponents=r,t.uriToFsPath=f,P=Ue(P);const I=/^\w[\w\d+.-]*$/,D=/^\//,w=/^\/\//;function d(H,x){if(!H.scheme&&x)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${H.authority}", path: "${H.path}", query: "${H.query}", fragment: "${H.fragment}"}`);if(H.scheme&&!I.test(H.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(H.path){if(H.authority){if(!D.test(H.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(H.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(H,x){return!H&&!x?"file":H}function _(H,x){switch(H){case"https":case"http":case"file":x?x[0]!==m&&(x=m+x):x=m;break}return x}const b="",m="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(x){return x instanceof s?!0:x?typeof x.authority=="string"&&typeof x.fragment=="string"&&typeof x.path=="string"&&typeof x.query=="string"&&typeof x.scheme=="string"&&typeof x.fsPath=="string"&&typeof x.with=="function"&&typeof x.toString=="function":!1}constructor(x,y,O,V,R,W=!1){typeof x=="object"?(this.scheme=x.scheme||b,this.authority=x.authority||b,this.path=x.path||b,this.query=x.query||b,this.fragment=x.fragment||b):(this.scheme=v(x,W),this.authority=y||b,this.path=_(this.scheme,O||b),this.query=V||b,this.fragment=R||b,d(this,W))}get fsPath(){return f(this,!1)}with(x){if(!x)return this;let{scheme:y,authority:O,path:V,query:R,fragment:W}=x;return y===void 0?y=this.scheme:y===null&&(y=b),O===void 0?O=this.authority:O===null&&(O=b),V===void 0?V=this.path:V===null&&(V=b),R===void 0?R=this.query:R===null&&(R=b),W===void 0?W=this.fragment:W===null&&(W=b),y===this.scheme&&O===this.authority&&V===this.path&&R===this.query&&W===this.fragment?this:new l(y,O,V,R,W)}static parse(x,y=!1){const O=e.exec(x);return O?new l(O[2]||b,U(O[4]||b),U(O[5]||b),U(O[7]||b),U(O[9]||b),y):new l(b,b,b,b,b)}static file(x){let y=b;if(F.isWindows&&(x=x.replace(/\\/g,m)),x[0]===m&&x[1]===m){const O=x.indexOf(m,2);O===-1?(y=x.substring(2),x=m):(y=x.substring(2,O),x=x.substring(O)||m)}return new l("file",y,x,b,b)}static from(x,y){return new l(x.scheme,x.authority,x.path,x.query,x.fragment,y)}static joinPath(x,...y){if(!x.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let O;return F.isWindows&&x.scheme==="file"?O=s.file(P.win32.join(f(x,!0),...y)).path:O=P.posix.join(x.path,...y),x.with({path:O})}toString(x=!1){return h(this,x)}toJSON(){return this}static revive(x){if(x){if(x instanceof s)return x;{const y=new l(x);return y._formatted=x.external??null,y._fsPath=x._sep===c?x.fsPath??null:null,y}}else return x}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=s;function r(H){return!H||typeof H!="object"?!1:typeof H.scheme=="string"&&(typeof H.authority=="string"||typeof H.authority>"u")&&(typeof H.path=="string"||typeof H.path>"u")&&(typeof H.query=="string"||typeof H.query>"u")&&(typeof H.fragment=="string"||typeof H.fragment>"u")}const c=F.isWindows?1:void 0;class l extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(x=!1){return x?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const x={$mid:n.MarshalledId.Uri};return this._fsPath&&(x.fsPath=this._fsPath,x._sep=c),this._formatted&&(x.external=this._formatted),this.path&&(x.path=this.path),this.scheme&&(x.scheme=this.scheme),this.authority&&(x.authority=this.authority),this.query&&(x.query=this.query),this.fragment&&(x.fragment=this.fragment),x}}const E={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function T(H,x,y){let O,V=-1;for(let R=0;R<H.length;R++){const W=H.charCodeAt(R);if(W>=i.CharCode.a&&W<=i.CharCode.z||W>=i.CharCode.A&&W<=i.CharCode.Z||W>=i.CharCode.Digit0&&W<=i.CharCode.Digit9||W===i.CharCode.Dash||W===i.CharCode.Period||W===i.CharCode.Underline||W===i.CharCode.Tilde||x&&W===i.CharCode.Slash||y&&W===i.CharCode.OpenSquareBracket||y&&W===i.CharCode.CloseSquareBracket||y&&W===i.CharCode.Colon)V!==-1&&(O+=encodeURIComponent(H.substring(V,R)),V=-1),O!==void 0&&(O+=H.charAt(R));else{O===void 0&&(O=H.substr(0,R));const G=E[W];G!==void 0?(V!==-1&&(O+=encodeURIComponent(H.substring(V,R)),V=-1),O+=G):V===-1&&(V=R)}}return V!==-1&&(O+=encodeURIComponent(H.substring(V))),O!==void 0?O:H}function A(H){let x;for(let y=0;y<H.length;y++){const O=H.charCodeAt(y);O===i.CharCode.Hash||O===i.CharCode.QuestionMark?(x===void 0&&(x=H.substr(0,y)),x+=E[O]):x!==void 0&&(x+=H[y])}return x!==void 0?x:H}function f(H,x){let y;return H.authority&&H.path.length>1&&H.scheme==="file"?y=`//${H.authority}${H.path}`:H.path.charCodeAt(0)===i.CharCode.Slash&&(H.path.charCodeAt(1)>=i.CharCode.A&&H.path.charCodeAt(1)<=i.CharCode.Z||H.path.charCodeAt(1)>=i.CharCode.a&&H.path.charCodeAt(1)<=i.CharCode.z)&&H.path.charCodeAt(2)===i.CharCode.Colon?x?y=H.path.substr(1):y=H.path[1].toLowerCase()+H.path.substr(2):y=H.path,F.isWindows&&(y=y.replace(/\//g,"\\")),y}function h(H,x){const y=x?A:T;let O="",{scheme:V,authority:R,path:W,query:G,fragment:Q}=H;if(V&&(O+=V,O+=":"),(R||V==="file")&&(O+=m,O+=m),R){let j=R.indexOf("@");if(j!==-1){const q=R.substr(0,j);R=R.substr(j+1),j=q.lastIndexOf(":"),j===-1?O+=y(q,!1,!1):(O+=y(q.substr(0,j),!1,!1),O+=":",O+=y(q.substr(j+1),!1,!0)),O+="@"}R=R.toLowerCase(),j=R.lastIndexOf(":"),j===-1?O+=y(R,!1,!0):(O+=y(R.substr(0,j),!1,!0),O+=R.substr(j))}if(W){if(W.length>=3&&W.charCodeAt(0)===i.CharCode.Slash&&W.charCodeAt(2)===i.CharCode.Colon){const j=W.charCodeAt(1);j>=i.CharCode.A&&j<=i.CharCode.Z&&(W=`/${String.fromCharCode(j+32)}:${W.substr(3)}`)}else if(W.length>=2&&W.charCodeAt(1)===i.CharCode.Colon){const j=W.charCodeAt(0);j>=i.CharCode.A&&j<=i.CharCode.Z&&(W=`${String.fromCharCode(j+32)}:${W.substr(2)}`)}O+=y(W,!0,!1)}return G&&(O+="?",O+=y(G,!1,!1)),Q&&(O+="#",O+=x?Q:T(Q,!1,!1)),O}function p(H){try{return decodeURIComponent(H)}catch{return H.length>3?H.substr(0,3)+p(H.substr(3)):H}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function U(H){return H.match(S)?H.replace(S,x=>p(x)):H}}),define(ve[68],De([1,0,47,16,60]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stringify=F,t.parse=I,t.revive=w;function F(d){return JSON.stringify(d,D)}function I(d){let v=JSON.parse(d);return v=w(v),v}function D(d,v){return v instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:v.source,flags:v.flags}:v}function w(d,v=0){if(!d||v>200)return d;if(typeof d=="object"){switch(d.$mid){case P.MarshalledId.Uri:return n.URI.revive(d);case P.MarshalledId.Regexp:return new RegExp(d.source,d.flags);case P.MarshalledId.Date:return new Date(d.source)}if(d instanceof i.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let _=0;_<d.length;++_)d[_]=w(d[_],v+1);else for(const _ in d)Object.hasOwnProperty.call(d,_)&&(d[_]=w(d[_],v+1))}return d}}),define(ve[39],De([1,0,6,5,11,16,28]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.VSCODE_AUTHORITY=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0,t.matchesScheme=w,t.matchesSomeScheme=d,t.getServerRootPath=_,i=Ue(i),n=Ue(n),I=Ue(I);var D;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(D||(t.Schemas=D={}));function w(e,s){return F.URI.isUri(e)?(0,P.equalsIgnoreCase)(e.scheme,s):(0,P.startsWithIgnoreCase)(e,s+":")}function d(e,...s){return s.some(r=>w(e,r))}t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class v{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(s){this._preferredWebSchema=s}setDelegate(s){this._delegate=s}setServerRootPath(s,r){this._serverRootPath=_(s,r)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return I.posix.join(this._serverRootPath,D.vscodeRemoteResource)}set(s,r,c){this._hosts[s]=r,this._ports[s]=c}setConnectionToken(s,r){this._connectionTokens[s]=r}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(s){if(this._delegate)try{return this._delegate(s)}catch(A){return i.onUnexpectedError(A),s}const r=s.authority;let c=this._hosts[r];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const l=this._ports[r],E=this._connectionTokens[r];let T=`path=${encodeURIComponent(s.path)}`;return typeof E=="string"&&(T+=`&${t.connectionTokenQueryName}=${encodeURIComponent(E)}`),F.URI.from({scheme:n.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${c}:${l}`,path:this._remoteResourcesPath,query:T})}}t.RemoteAuthorities=new v;function _(e,s){return I.posix.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",t.VSCODE_AUTHORITY="vscode-app";class b{static{this.FALLBACK_AUTHORITY=t.VSCODE_AUTHORITY}asBrowserUri(s){const r=this.toUri(s,oe);return this.uriToBrowserUri(r)}uriToBrowserUri(s){return s.scheme===D.vscodeRemote?t.RemoteAuthorities.rewrite(s):s.scheme===D.file&&(n.isNative||n.webWorkerOrigin===`${D.vscodeFileResource}://${b.FALLBACK_AUTHORITY}`)?s.with({scheme:D.vscodeFileResource,authority:s.authority||b.FALLBACK_AUTHORITY,query:null,fragment:null}):s}asFileUri(s){const r=this.toUri(s,oe);return this.uriToFileUri(r)}uriToFileUri(s){return s.scheme===D.vscodeFileResource?s.with({scheme:D.file,authority:s.authority!==b.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(s,r){return F.URI.isUri(s)?s:F.URI.parse(r.toUrl(s))}}t.FileAccess=new b;var m;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const r="vscode-coi";function c(E){let T;typeof E=="string"?T=new URL(E).searchParams:E instanceof URL?T=E.searchParams:F.URI.isUri(E)&&(T=new URL(E.toString(!0)).searchParams);const A=T?.get(r);if(A)return s.get(A)}e.getHeadersFromQuery=c;function l(E,T,A){if(!globalThis.crossOriginIsolated)return;const f=T&&A?"3":A?"2":"1";E instanceof URLSearchParams?E.set(r,f):E[r]=f}e.addSearchParam=l})(m||(t.COI=m={}))}),define(ve[50],De([1,0,17,108,39,28,5,11,16]),function(oe,t,i,n,P,F,I,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=void 0,t.originalFSPath=d,t.distinctParents=_,t.toLocalResource=m,n=Ue(n),F=Ue(F);function d(e){return(0,w.uriToFsPath)(e,!0)}class v{constructor(s){this._ignorePathCasing=s}compare(s,r,c=!1){return s===r?0:(0,D.compare)(this.getComparisonKey(s,c),this.getComparisonKey(r,c))}isEqual(s,r,c=!1){return s===r?!0:!s||!r?!1:this.getComparisonKey(s,c)===this.getComparisonKey(r,c)}getComparisonKey(s,r=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,r,c=!1){if(s.scheme===r.scheme){if(s.scheme===P.Schemas.file)return n.isEqualOrParent(d(s),d(r),this._ignorePathCasing(s))&&s.query===r.query&&(c||s.fragment===r.fragment);if((0,t.isEqualAuthority)(s.authority,r.authority))return n.isEqualOrParent(s.path,r.path,this._ignorePathCasing(s),"/")&&s.query===r.query&&(c||s.fragment===r.fragment)}return!1}joinPath(s,...r){return w.URI.joinPath(s,...r)}basenameOrAuthority(s){return(0,t.basename)(s)||s.authority}basename(s){return F.posix.basename(s.path)}extname(s){return F.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let r;return s.scheme===P.Schemas.file?r=w.URI.file(F.dirname(d(s))).path:(r=F.posix.dirname(s.path),s.authority&&r.length&&r.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),r="/")),s.with({path:r})}normalizePath(s){if(!s.path.length)return s;let r;return s.scheme===P.Schemas.file?r=w.URI.file(F.normalize(d(s))).path:r=F.posix.normalize(s.path),s.with({path:r})}relativePath(s,r){if(s.scheme!==r.scheme||!(0,t.isEqualAuthority)(s.authority,r.authority))return;if(s.scheme===P.Schemas.file){const E=F.relative(d(s),d(r));return I.isWindows?n.toSlashes(E):E}let c=s.path||"/";const l=r.path||"/";if(this._ignorePathCasing(s)){let E=0;for(const T=Math.min(c.length,l.length);E<T&&!(c.charCodeAt(E)!==l.charCodeAt(E)&&c.charAt(E).toLowerCase()!==l.charAt(E).toLowerCase());E++);c=l.substr(0,E)+c.substr(E)}return F.posix.relative(c,l)}resolvePath(s,r){if(s.scheme===P.Schemas.file){const c=w.URI.file(F.resolve(d(s),r));return s.with({authority:c.authority,path:c.path})}return r=n.toPosixPath(r),s.with({path:F.posix.resolve(s.path,r)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,r){return s===r||s!==void 0&&r!==void 0&&(0,D.equalsIgnoreCase)(s,r)}hasTrailingPathSeparator(s,r=F.sep){if(s.scheme===P.Schemas.file){const c=d(s);return c.length>n.getRoot(c).length&&c[c.length-1]===r}else{const c=s.path;return c.length>1&&c.charCodeAt(c.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,r=F.sep){return(0,t.hasTrailingPathSeparator)(s,r)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,r=F.sep){let c=!1;if(s.scheme===P.Schemas.file){const l=d(s);c=l!==void 0&&l.length===n.getRoot(l).length&&l[l.length-1]===r}else{r="/";const l=s.path;c=l.length===1&&l.charCodeAt(l.length-1)===i.CharCode.Slash}return!c&&!(0,t.hasTrailingPathSeparator)(s,r)?s.with({path:s.path+"/"}):s}}t.ExtUri=v,t.extUri=new v(()=>!1),t.extUriBiasedIgnorePathCase=new v(e=>e.scheme===P.Schemas.file?!I.isLinux:!0),t.extUriIgnorePathCase=new v(e=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function _(e,s){const r=[];for(let c=0;c<e.length;c++){const l=s(e[c]);e.some((E,T)=>T===c?!1:(0,t.isEqualOrParent)(l,s(E)))||r.push(e[c])}return r}var b;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function s(r){const c=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(T=>{const[A,f]=T.split(":");A&&f&&c.set(A,f)});const E=r.path.substring(0,r.path.indexOf(";"));return E&&c.set(e.META_DATA_MIME,E),c}e.parseMetaData=s})(b||(t.DataUri=b={}));function m(e,s,r){if(s){let c=e.path;return c&&c[0]!==F.posix.sep&&(c=F.posix.sep+c),e.with({scheme:r,authority:s,path:c})}return e.with({scheme:r})}}),define(ve[12],De([1,0,38,6,3,2,50,5,63,25]),function(oe,t,i,n,P,F,I,D,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncIterableSource=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.LazyStatefulPromise=t.StatefulPromise=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.GlobalIdleValue=t.AbstractIdleValue=t._runWhenIdle=t.runWhenGlobalIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.LimitedQueue=t.Queue=t.Limiter=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=void 0,t.isThenable=v,t.createCancelablePromise=_,t.raceCancellation=b,t.raceCancellationError=m,t.raceCancellablePromises=e,t.raceTimeout=s,t.asPromise=r,t.promiseWithResolvers=c,t.timeout=H,t.disposableTimeout=x,t.sequence=y,t.first=O,t.firstParallel=V,t.retry=ee,t.createCancelableAsyncIterable=$;function v(a){return!!a&&typeof a.then=="function"}function _(a){const o=new i.CancellationTokenSource,g=a(o.token),k=new Promise((L,u)=>{const N=o.token.onCancellationRequested(()=>{N.dispose(),u(new n.CancellationError)});Promise.resolve(g).then(C=>{N.dispose(),o.dispose(),L(C)},C=>{N.dispose(),o.dispose(),u(C)})});return new class{cancel(){o.cancel(),o.dispose()}then(L,u){return k.then(L,u)}catch(L){return this.then(void 0,L)}finally(L){return k.finally(L)}}}function b(a,o,g){return new Promise((k,L)=>{const u=o.onCancellationRequested(()=>{u.dispose(),k(g)});a.then(k,L).finally(()=>u.dispose())})}function m(a,o){return new Promise((g,k)=>{const L=o.onCancellationRequested(()=>{L.dispose(),k(new n.CancellationError)});a.then(g,k).finally(()=>L.dispose())})}async function e(a){let o=-1;const g=a.map((k,L)=>k.then(u=>(o=L,u)));try{return await Promise.race(g)}finally{a.forEach((k,L)=>{L!==o&&k.cancel()})}}function s(a,o,g){let k;const L=setTimeout(()=>{k?.(void 0),g?.()},o);return Promise.race([a.finally(()=>clearTimeout(L)),new Promise(u=>k=u)])}function r(a){return new Promise((o,g)=>{const k=a();v(k)?k.then(o,g):o(k)})}function c(){let a,o;return{promise:new Promise((k,L)=>{a=k,o=L}),resolve:a,reject:o}}class l{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(o){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=o,!this.queuedPromise){const g=()=>{if(this.queuedPromise=null,this.isDisposed)return;const k=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,k};this.queuedPromise=new Promise(k=>{this.activePromise.then(g,g).then(k)})}return new Promise((g,k)=>{this.queuedPromise.then(g,k)})}return this.activePromise=o(),new Promise((g,k)=>{this.activePromise.then(L=>{this.activePromise=null,g(L)},L=>{this.activePromise=null,k(L)})})}dispose(){this.isDisposed=!0}}t.Throttler=l;class E{constructor(){this.current=Promise.resolve(null)}queue(o){return this.current=this.current.then(()=>o(),()=>o())}}t.Sequencer=E;class T{constructor(){this.promiseMap=new Map}queue(o,g){const L=(this.promiseMap.get(o)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.promiseMap.get(o)===L&&this.promiseMap.delete(o)});return this.promiseMap.set(o,L),L}}t.SequencerByKey=T;const A=(a,o)=>{let g=!0;const k=setTimeout(()=>{g=!1,o()},a);return{isTriggered:()=>g,dispose:()=>{clearTimeout(k),g=!1}}},f=a=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,a())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class h{constructor(o){this.defaultDelay=o,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(o,g=this.defaultDelay){this.task=o,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((L,u)=>{this.doResolve=L,this.doReject=u}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const L=this.task;return this.task=null,L()}}));const k=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=g===w.MicrotaskDelay?f(k):A(g,k),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=h;class p{constructor(o){this.delayer=new h(o),this.throttler=new l}trigger(o,g){return this.delayer.trigger(()=>this.throttler.queue(o),g)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}t.ThrottledDelayer=p;class S{constructor(){this._isOpen=!1,this._promise=new Promise((o,g)=>{this._completePromise=o})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=S;class U extends S{constructor(o){super(),this._timeout=setTimeout(()=>this.open(),o)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=U;function H(a,o){return o?new Promise((g,k)=>{const L=setTimeout(()=>{u.dispose(),g()},a),u=o.onCancellationRequested(()=>{clearTimeout(L),u.dispose(),k(new n.CancellationError)})}):_(g=>H(a,g))}function x(a,o=0,g){const k=setTimeout(()=>{a(),g&&L.dispose()},o),L=(0,F.toDisposable)(()=>{clearTimeout(k),g?.deleteAndLeak(L)});return g?.add(L),L}function y(a){const o=[];let g=0;const k=a.length;function L(){return g<k?a[g++]():null}function u(N){N!=null&&o.push(N);const C=L();return C?C.then(u):Promise.resolve(o)}return Promise.resolve(null).then(u)}function O(a,o=k=>!!k,g=null){let k=0;const L=a.length,u=()=>{if(k>=L)return Promise.resolve(g);const N=a[k++];return Promise.resolve(N()).then(M=>o(M)?Promise.resolve(M):u())};return u()}function V(a,o=k=>!!k,g=null){if(a.length===0)return Promise.resolve(g);let k=a.length;const L=()=>{k=-1;for(const u of a)u.cancel?.()};return new Promise((u,N)=>{for(const C of a)C.then(M=>{--k>=0&&o(M)?(L(),u(M)):k===0&&u(g)}).catch(M=>{--k>=0&&(L(),N(M))})})}class R{constructor(o){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=o,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(o){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((g,k)=>{this.outstandingPromises.push({factory:o,c:g,e:k}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const o=this.outstandingPromises.shift();this.runningPromises++;const g=o.factory();g.then(o.c,o.e),g.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}t.Limiter=R;class W extends R{constructor(){super(1)}}t.Queue=W;class G{constructor(){this.sequentializer=new he,this.tasks=0}queue(o){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,o())):this.sequentializer.run(this.tasks++,o())}}t.LimitedQueue=G;class Q{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const o=new te;return this.drainers.add(o),o.p}isDrained(){for(const[,o]of this.queues)if(o.size>0)return!1;return!0}queueSize(o,g=I.extUri){const k=g.getComparisonKey(o);return this.queues.get(k)?.size??0}queueFor(o,g,k=I.extUri){const L=k.getComparisonKey(o);let u=this.queues.get(L);if(!u){u=new W;const N=this.drainListenerCount++,C=P.Event.once(u.onDrained)(()=>{u?.dispose(),this.queues.delete(L),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(N),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new F.DisposableMap),this.drainListeners.set(N,C),this.queues.set(L,u)}return u.queue(g)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const o of this.drainers)o.complete();this.drainers.clear()}dispose(){for(const[,o]of this.queues)o.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}t.ResourceQueue=Q;class j{constructor(o,g){this._isDisposed=!1,this._token=-1,typeof o=="function"&&typeof g=="number"&&this.setIfNotSet(o,g)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(o,g){if(this._isDisposed)throw new n.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,o()},g)}setIfNotSet(o,g){if(this._isDisposed)throw new n.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,o()},g))}}t.TimeoutTimer=j;class q{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(o,g,k=globalThis){if(this.isDisposed)throw new n.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const L=k.setInterval(()=>{o()},g);this.disposable=(0,F.toDisposable)(()=>{k.clearInterval(L),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}t.IntervalTimer=q;class J{constructor(o,g){this.timeoutToken=-1,this.runner=o,this.timeout=g,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(o=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,o)}get delay(){return this.timeout}set delay(o){this.timeout=o}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=J;class le{constructor(o,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.runner=o,this.timeout=g,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(o=this.timeout){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(o/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=le;class me extends J{constructor(o,g){super(o,g),this.units=[]}work(o){this.units.push(o),this.isScheduled()||this.schedule()}doRun(){const o=this.units;this.units=[],this.runner?.(o)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=me;class _e extends F.Disposable{constructor(o,g){super(),this.options=o,this.handler=g,this.pendingWork=[],this.throttler=this._register(new F.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(o){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+o.length>this.options.maxBufferedWork)return!1}else if(this.pending+o.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const g of o)this.pendingWork.push(g);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new J(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=_e,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t._runWhenIdle=(a,o)=>{(0,D.setTimeout0)(()=>{if(g)return;const k=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,k-Date.now())}}))});let g=!1;return{dispose(){g||(g=!0)}}}:t._runWhenIdle=(a,o,g)=>{const k=a.requestIdleCallback(o,typeof g=="number"?{timeout:g}:void 0);let L=!1;return{dispose(){L||(L=!0,a.cancelIdleCallback(k))}}},t.runWhenGlobalIdle=a=>(0,t._runWhenIdle)(globalThis,a)}();class Ne{constructor(o,g){this._didRun=!1,this._executor=()=>{try{this._value=g()}catch(k){this._error=k}finally{this._didRun=!0}},this._handle=(0,t._runWhenIdle)(o,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.AbstractIdleValue=Ne;class ne extends Ne{constructor(o){super(globalThis,o)}}t.GlobalIdleValue=ne;async function ee(a,o,g){let k;for(let L=0;L<g;L++)try{return await a()}catch(u){k=u,await H(o)}throw k}class he{isRunning(o){return typeof o=="number"?this._running?.taskId===o:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(o,g,k){return this._running={taskId:o,cancel:()=>k?.(),promise:g},g.then(()=>this.doneRunning(o),()=>this.doneRunning(o)),g}doneRunning(o){this._running&&o===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const o=this._queued;this._queued=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this._queued)this._queued.run=o;else{const{promise:g,resolve:k,reject:L}=c();this._queued={run:o,promise:g,promiseResolve:k,promiseReject:L}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}t.TaskSequentializer=he;class ae{constructor(o,g=()=>Date.now()){this.interval=o,this.nowFn=g,this.lastIncrementTime=0,this.value=0}increment(){const o=this.nowFn();return o-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=o,this.value=0),this.value++,this.value}}t.IntervalCounter=ae;var Le;(function(a){a[a.Resolved=0]="Resolved",a[a.Rejected=1]="Rejected"})(Le||(Le={}));class te{get isRejected(){return this.outcome?.outcome===Le.Rejected}get isResolved(){return this.outcome?.outcome===Le.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===Le.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((o,g)=>{this.completeCallback=o,this.errorCallback=g})}complete(o){return new Promise(g=>{this.completeCallback(o),this.outcome={outcome:Le.Resolved,value:o},g()})}error(o){return new Promise(g=>{this.errorCallback(o),this.outcome={outcome:Le.Rejected,value:o},g()})}cancel(){return this.error(new n.CancellationError)}}t.DeferredPromise=te;var pe;(function(a){async function o(k){let L;const u=await Promise.all(k.map(N=>N.then(C=>C,C=>{L||(L=C)})));if(typeof L<"u")throw L;return u}a.settled=o;function g(k){return new Promise(async(L,u)=>{try{await k(L,u)}catch(N){u(N)}})}a.withAsyncBody=g})(pe||(t.Promises=pe={}));class Ae{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(o){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=o.then(g=>(this._value=g,this._isResolved=!0,g),g=>{throw this._error=g,this._isResolved=!0,g})}requireValue(){if(!this._isResolved)throw new n.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}t.StatefulPromise=Ae;class Ce{constructor(o){this._compute=o,this._promise=new d.Lazy(()=>new Ae(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}t.LazyStatefulPromise=Ce;var Re;(function(a){a[a.Initial=0]="Initial",a[a.DoneOK=1]="DoneOK",a[a.DoneError=2]="DoneError"})(Re||(Re={}));class xe{static fromArray(o){return new xe(g=>{g.emitMany(o)})}static fromPromise(o){return new xe(async g=>{g.emitMany(await o)})}static fromPromises(o){return new xe(async g=>{await Promise.all(o.map(async k=>g.emitOne(await k)))})}static merge(o){return new xe(async g=>{await Promise.all(o.map(async k=>{for await(const L of k)g.emitOne(L)}))})}static{this.EMPTY=xe.fromArray([])}constructor(o,g){this._state=Re.Initial,this._results=[],this._error=null,this._onReturn=g,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const k={emitOne:L=>this.emitOne(L),emitMany:L=>this.emitMany(L),reject:L=>this.reject(L)};try{await Promise.resolve(o(k)),this.resolve()}catch(L){this.reject(L)}finally{k.emitOne=void 0,k.emitMany=void 0,k.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this._state===Re.DoneError)throw this._error;if(o<this._results.length)return{done:!1,value:this._results[o++]};if(this._state===Re.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(o,g){return new xe(async k=>{for await(const L of o)k.emitOne(g(L))})}map(o){return xe.map(this,o)}static filter(o,g){return new xe(async k=>{for await(const L of o)g(L)&&k.emitOne(L)})}filter(o){return xe.filter(this,o)}static coalesce(o){return xe.filter(o,g=>!!g)}coalesce(){return xe.coalesce(this)}static async toPromise(o){const g=[];for await(const k of o)g.push(k);return g}toPromise(){return xe.toPromise(this)}emitOne(o){this._state===Re.Initial&&(this._results.push(o),this._onStateChanged.fire())}emitMany(o){this._state===Re.Initial&&(this._results=this._results.concat(o),this._onStateChanged.fire())}resolve(){this._state===Re.Initial&&(this._state=Re.DoneOK,this._onStateChanged.fire())}reject(o){this._state===Re.Initial&&(this._state=Re.DoneError,this._error=o,this._onStateChanged.fire())}}t.AsyncIterableObject=xe;class He extends xe{constructor(o,g){super(g),this._source=o}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=He;function $(a){const o=new i.CancellationTokenSource,g=a(o.token);return new He(o,async k=>{const L=o.token.onCancellationRequested(()=>{L.dispose(),o.dispose(),k.reject(new n.CancellationError)});try{for await(const u of g){if(o.token.isCancellationRequested)return;k.emitOne(u)}L.dispose(),o.dispose()}catch(u){L.dispose(),o.dispose(),k.reject(u)}})}class B{constructor(o){this._deferred=new te,this._asyncIterable=new xe(L=>{if(g){L.reject(g);return}return k&&L.emitMany(k),this._errorFn=u=>L.reject(u),this._emitFn=u=>L.emitOne(u),this._deferred.p},o);let g,k;this._emitFn=L=>{k||(k=[]),k.push(L)},this._errorFn=L=>{g||(g=L)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(o){this._errorFn(o),this._deferred.complete()}emitOne(o){this._emitFn(o)}}t.AsyncIterableSource=B}),define(ve[4],De([1,0,18,61,15,19,12,6,3,111,8,2,39,5,16,66,24,37]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b,m,e,s,r,c){"use strict";var l;Object.defineProperty(t,"__esModule",{value:!0}),t.SafeTriangle=t.DragAndDropObserver=t.ModifierKeyEmitter=t.basicMarkupHtmlTags=t.DetectedFullscreenMode=t.Namespace=t.EventHelper=t.EventType=t.sharedMutationObserver=t.Dimension=t.WindowIntervalTimer=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.WindowIdleValue=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.clearNode=E,t.addDisposableListener=A,t.addDisposableGenericMouseDownListener=H,t.addDisposableGenericMouseMoveListener=x,t.addDisposableGenericMouseUpListener=y,t.runWhenWindowIdle=O,t.disposableWindowInterval=R,t.measure=Q,t.modify=j,t.addDisposableThrottledListener=me,t.getComputedStyle=_e,t.getClientArea=Ne,t.getTopLeftOffset=he,t.size=ae,t.position=Le,t.getDomNodePagePosition=te,t.getDomNodeZoomLevel=pe,t.getTotalWidth=Ae,t.getContentWidth=Ce,t.getTotalScrollWidth=Re,t.getContentHeight=xe,t.getTotalHeight=He,t.getLargestChildWidth=B,t.isAncestor=a,t.setParentFlowTo=g,t.isAncestorUsingFlowTo=L,t.findParentWithClass=u,t.hasParentWithClass=N,t.isShadowRoot=C,t.isInShadowDOM=M,t.getShadowRoot=z,t.getActiveElement=X,t.isActiveElement=ie,t.isAncestorOfActiveElement=re,t.isActiveDocument=ce,t.getActiveDocument=we,t.getActiveWindow=Ee,t.isGlobalStylesheet=Ie,t.createStyleSheet2=de,t.createStyleSheet=qe,t.cloneGlobalStylesheets=Ye,t.createMetaElement=at,t.createLinkElement=st,t.createCSSRule=be,t.removeCSSRulesContainingSelector=Te,t.isHTMLElement=Ve,t.isHTMLAnchorElement=Qe,t.isHTMLSpanElement=rt,t.isHTMLTextAreaElement=it,t.isHTMLInputElement=ht,t.isHTMLButtonElement=nt,t.isHTMLDivElement=ft,t.isSVGElement=dt,t.isMouseEvent=Dt,t.isKeyboardEvent=ze,t.isPointerEvent=fe,t.isDragEvent=Oe,t.isEventLike=Me,t.saveParentsScrollTop=Xe,t.restoreParentsScrollTop=ot,t.trackFocus=Je,t.after=pt,t.append=yt,t.prepend=Ct,t.reset=Qt,t.$=ei,t.join=ki,t.setVisibility=Pi,t.show=ti,t.hide=ii,t.removeTabIndexAndUpdateFocus=Bi,t.finalHandler=xi,t.domContentLoaded=Wi,t.computeScreenAwareSize=Hi,t.windowOpenNoOpener=zi,t.windowOpenPopup=Ui,t.windowOpenWithSuccess=Vi,t.animate=Ki,t.asCSSUrl=$i,t.asCSSPropertyValue=qi,t.asCssValueWithDefault=ri,t.triggerDownload=Gi,t.triggerUpload=ji,t.detectFullscreen=Yi,t.hookDomPurifyHrefAndSrcSanitizer=oi,t.safeInnerHtml=Qi,t.multibyteAwareBtoa=en,t.getCookieValue=tn,t.h=sn,t.svgElem=rn,t.copyAttributes=li,t.trackAttributes=an,i=Ue(i),w=Ue(w),d=Ue(d),m=Ue(m),l=function(){const K=new Map;(0,r.ensureCodeWindow)(r.mainWindow,1);const Y={window:r.mainWindow,disposables:new _.DisposableStore};K.set(r.mainWindow.vscodeWindowId,Y);const se=new w.Emitter,ge=new w.Emitter,Se=new w.Emitter;function Be(ke,$e){return(typeof ke=="number"?K.get(ke):void 0)??($e?Y:void 0)}return{onDidRegisterWindow:se.event,onWillUnregisterWindow:Se.event,onDidUnregisterWindow:ge.event,registerWindow(ke){if(K.has(ke.vscodeWindowId))return _.Disposable.None;const $e=new _.DisposableStore,Ke={window:ke,disposables:$e.add(new _.DisposableStore)};return K.set(ke.vscodeWindowId,Ke),$e.add((0,_.toDisposable)(()=>{K.delete(ke.vscodeWindowId),ge.fire(ke)})),$e.add(A(ke,t.EventType.BEFORE_UNLOAD,()=>{Se.fire(ke)})),se.fire(Ke),$e},getWindows(){return K.values()},getWindowsCount(){return K.size},getWindowId(ke){return ke.vscodeWindowId},hasWindow(ke){return K.has(ke)},getWindowById:Be,getWindow(ke){const $e=ke;if($e?.ownerDocument?.defaultView)return $e.ownerDocument.defaultView.window;const Ke=ke;return Ke?.view?Ke.view.window:r.mainWindow},getDocument(ke){const $e=ke;return(0,t.getWindow)($e).document}}}(),t.registerWindow=l.registerWindow,t.getWindow=l.getWindow,t.getDocument=l.getDocument,t.getWindows=l.getWindows,t.getWindowsCount=l.getWindowsCount,t.getWindowId=l.getWindowId,t.getWindowById=l.getWindowById,t.hasWindow=l.hasWindow,t.onDidRegisterWindow=l.onDidRegisterWindow,t.onWillUnregisterWindow=l.onWillUnregisterWindow,t.onDidUnregisterWindow=l.onDidUnregisterWindow;function E(K){for(;K.firstChild;)K.firstChild.remove()}class T{constructor(Y,se,ge,Se){this._node=Y,this._type=se,this._handler=ge,this._options=Se||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function A(K,Y,se,ge){return new T(K,Y,se,ge)}function f(K,Y){return function(se){return Y(new F.StandardMouseEvent(K,se))}}function h(K){return function(Y){return K(new P.StandardKeyboardEvent(Y))}}const p=function(Y,se,ge,Se){let Be=ge;return se==="click"||se==="mousedown"||se==="contextmenu"?Be=f((0,t.getWindow)(Y),ge):(se==="keydown"||se==="keypress"||se==="keyup")&&(Be=h(ge)),A(Y,se,Be,Se)};t.addStandardDisposableListener=p;const S=function(Y,se,ge){const Se=f((0,t.getWindow)(Y),se);return H(Y,Se,ge)};t.addStandardDisposableGenericMouseDownListener=S;const U=function(Y,se,ge){const Se=f((0,t.getWindow)(Y),se);return y(Y,Se,ge)};t.addStandardDisposableGenericMouseUpListener=U;function H(K,Y,se){return A(K,m.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,Y,se)}function x(K,Y,se){return A(K,m.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,Y,se)}function y(K,Y,se){return A(K,m.isIOS&&n.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,Y,se)}function O(K,Y,se){return(0,I._runWhenIdle)(K,Y,se)}class V extends I.AbstractIdleValue{constructor(Y,se){super(Y,se)}}t.WindowIdleValue=V;function R(K,Y,se,ge){let Se=0;const Be=K.setInterval(()=>{Se++,(typeof ge=="number"&&Se>=ge||Y()===!0)&&ke.dispose()},se),ke=(0,_.toDisposable)(()=>{K.clearInterval(Be)});return ke}class W extends I.IntervalTimer{constructor(Y){super(),this.defaultTarget=Y&&(0,t.getWindow)(Y)}cancelAndSet(Y,se,ge){return super.cancelAndSet(Y,se,ge??this.defaultTarget)}}t.WindowIntervalTimer=W;class G{constructor(Y,se=0){this._runner=Y,this.priority=se,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(Y){(0,D.onUnexpectedError)(Y)}}static sort(Y,se){return se.priority-Y.priority}}(function(){const K=new Map,Y=new Map,se=new Map,ge=new Map,Se=Be=>{se.set(Be,!1);const ke=K.get(Be)??[];for(Y.set(Be,ke),K.set(Be,[]),ge.set(Be,!0);ke.length>0;)ke.sort(G.sort),ke.shift().execute();ge.set(Be,!1)};t.scheduleAtNextAnimationFrame=(Be,ke,$e=0)=>{const Ke=(0,t.getWindowId)(Be),We=new G(ke,$e);let lt=K.get(Ke);return lt||(lt=[],K.set(Ke,lt)),lt.push(We),se.get(Ke)||(se.set(Ke,!0),Be.requestAnimationFrame(()=>Se(Ke))),We},t.runAtThisOrScheduleAtNextAnimationFrame=(Be,ke,$e)=>{const Ke=(0,t.getWindowId)(Be);if(ge.get(Ke)){const We=new G(ke,$e);let lt=Y.get(Ke);return lt||(lt=[],Y.set(Ke,lt)),lt.push(We),We}else return(0,t.scheduleAtNextAnimationFrame)(Be,ke,$e)}})();function Q(K,Y){return(0,t.scheduleAtNextAnimationFrame)(K,Y,1e4)}function j(K,Y){return(0,t.scheduleAtNextAnimationFrame)(K,Y,-1e4)}const q=8,J=function(K,Y){return Y};class le extends _.Disposable{constructor(Y,se,ge,Se=J,Be=q){super();let ke=null,$e=0;const Ke=this._register(new I.TimeoutTimer),We=()=>{$e=new Date().getTime(),ge(ke),ke=null};this._register(A(Y,se,lt=>{ke=Se(ke,lt);const St=new Date().getTime()-$e;St>=Be?(Ke.cancel(),We()):Ke.setIfNotSet(We,Be-St)}))}}function me(K,Y,se,ge,Se){return new le(K,Y,se,ge,Se)}function _e(K){return(0,t.getWindow)(K).getComputedStyle(K,null)}function Ne(K,Y){const se=(0,t.getWindow)(K),ge=se.document;if(K!==ge.body)return new ee(K.clientWidth,K.clientHeight);if(m.isIOS&&se?.visualViewport)return new ee(se.visualViewport.width,se.visualViewport.height);if(se?.innerWidth&&se.innerHeight)return new ee(se.innerWidth,se.innerHeight);if(ge.body&&ge.body.clientWidth&&ge.body.clientHeight)return new ee(ge.body.clientWidth,ge.body.clientHeight);if(ge.documentElement&&ge.documentElement.clientWidth&&ge.documentElement.clientHeight)return new ee(ge.documentElement.clientWidth,ge.documentElement.clientHeight);if(Y)return Ne(Y);throw new Error("Unable to figure out browser width and height")}class ne{static convertToPixels(Y,se){return parseFloat(se)||0}static getDimension(Y,se,ge){const Se=_e(Y),Be=Se?Se.getPropertyValue(se):"0";return ne.convertToPixels(Y,Be)}static getBorderLeftWidth(Y){return ne.getDimension(Y,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Y){return ne.getDimension(Y,"border-right-width","borderRightWidth")}static getBorderTopWidth(Y){return ne.getDimension(Y,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Y){return ne.getDimension(Y,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Y){return ne.getDimension(Y,"padding-left","paddingLeft")}static getPaddingRight(Y){return ne.getDimension(Y,"padding-right","paddingRight")}static getPaddingTop(Y){return ne.getDimension(Y,"padding-top","paddingTop")}static getPaddingBottom(Y){return ne.getDimension(Y,"padding-bottom","paddingBottom")}static getMarginLeft(Y){return ne.getDimension(Y,"margin-left","marginLeft")}static getMarginTop(Y){return ne.getDimension(Y,"margin-top","marginTop")}static getMarginRight(Y){return ne.getDimension(Y,"margin-right","marginRight")}static getMarginBottom(Y){return ne.getDimension(Y,"margin-bottom","marginBottom")}}class ee{static{this.None=new ee(0,0)}constructor(Y,se){this.width=Y,this.height=se}with(Y=this.width,se=this.height){return Y!==this.width||se!==this.height?new ee(Y,se):this}static is(Y){return typeof Y=="object"&&typeof Y.height=="number"&&typeof Y.width=="number"}static lift(Y){return Y instanceof ee?Y:new ee(Y.width,Y.height)}static equals(Y,se){return Y===se?!0:!Y||!se?!1:Y.width===se.width&&Y.height===se.height}}t.Dimension=ee;function he(K){let Y=K.offsetParent,se=K.offsetTop,ge=K.offsetLeft;for(;(K=K.parentNode)!==null&&K!==K.ownerDocument.body&&K!==K.ownerDocument.documentElement;){se-=K.scrollTop;const Se=C(K)?null:_e(K);Se&&(ge-=Se.direction!=="rtl"?K.scrollLeft:-K.scrollLeft),K===Y&&(ge+=ne.getBorderLeftWidth(K),se+=ne.getBorderTopWidth(K),se+=K.offsetTop,ge+=K.offsetLeft,Y=K.offsetParent)}return{left:ge,top:se}}function ae(K,Y,se){typeof Y=="number"&&(K.style.width=`${Y}px`),typeof se=="number"&&(K.style.height=`${se}px`)}function Le(K,Y,se,ge,Se,Be="absolute"){typeof Y=="number"&&(K.style.top=`${Y}px`),typeof se=="number"&&(K.style.right=`${se}px`),typeof ge=="number"&&(K.style.bottom=`${ge}px`),typeof Se=="number"&&(K.style.left=`${Se}px`),K.style.position=Be}function te(K){const Y=K.getBoundingClientRect(),se=(0,t.getWindow)(K);return{left:Y.left+se.scrollX,top:Y.top+se.scrollY,width:Y.width,height:Y.height}}function pe(K){let Y=K,se=1;do{const ge=_e(Y).zoom;ge!=null&&ge!=="1"&&(se*=ge),Y=Y.parentElement}while(Y!==null&&Y!==Y.ownerDocument.documentElement);return se}function Ae(K){const Y=ne.getMarginLeft(K)+ne.getMarginRight(K);return K.offsetWidth+Y}function Ce(K){const Y=ne.getBorderLeftWidth(K)+ne.getBorderRightWidth(K),se=ne.getPaddingLeft(K)+ne.getPaddingRight(K);return K.offsetWidth-Y-se}function Re(K){const Y=ne.getMarginLeft(K)+ne.getMarginRight(K);return K.scrollWidth+Y}function xe(K){const Y=ne.getBorderTopWidth(K)+ne.getBorderBottomWidth(K),se=ne.getPaddingTop(K)+ne.getPaddingBottom(K);return K.offsetHeight-Y-se}function He(K){const Y=ne.getMarginTop(K)+ne.getMarginBottom(K);return K.offsetHeight+Y}function $(K,Y){if(K===null)return 0;const se=he(K),ge=he(Y);return se.left-ge.left}function B(K,Y){const se=Y.map(Se=>Math.max(Re(Se),Ae(Se))+$(Se,K)||0);return Math.max(...se)}function a(K,Y){return!!Y?.contains(K)}const o="parentFlowToElementId";function g(K,Y){K.dataset[o]=Y.id}function k(K){const Y=K.dataset[o];return typeof Y=="string"?K.ownerDocument.getElementById(Y):null}function L(K,Y){let se=K;for(;se;){if(se===Y)return!0;if(Ve(se)){const ge=k(se);if(ge){se=ge;continue}}se=se.parentNode}return!1}function u(K,Y,se){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K.classList.contains(Y))return K;if(se){if(typeof se=="string"){if(K.classList.contains(se))return null}else if(K===se)return null}K=K.parentNode}return null}function N(K,Y,se){return!!u(K,Y,se)}function C(K){return K&&!!K.host&&!!K.mode}function M(K){return!!z(K)}function z(K){for(;K.parentNode;){if(K===K.ownerDocument?.body)return null;K=K.parentNode}return C(K)?K:null}function X(){let K=we().activeElement;for(;K?.shadowRoot;)K=K.shadowRoot.activeElement;return K}function ie(K){return X()===K}function re(K){return a(X(),K)}function ce(K){return K.ownerDocument===we()}function we(){return(0,t.getWindowsCount)()<=1?r.mainWindow.document:Array.from((0,t.getWindows)()).map(({window:Y})=>Y.document).find(Y=>Y.hasFocus())??r.mainWindow.document}function Ee(){return we().defaultView?.window??r.mainWindow}const ye=new Map;function Ie(K){return ye.has(K)}function de(){return new Fe}class Fe{constructor(){this._currentCssStyle="",this._styleSheet=void 0}setStyle(Y){Y!==this._currentCssStyle&&(this._currentCssStyle=Y,this._styleSheet?this._styleSheet.innerText=Y:this._styleSheet=qe(r.mainWindow.document.head,se=>se.innerText=Y))}dispose(){this._styleSheet&&(this._styleSheet.remove(),this._styleSheet=void 0)}}function qe(K=r.mainWindow.document.head,Y,se){const ge=document.createElement("style");if(ge.type="text/css",ge.media="screen",Y?.(ge),K.appendChild(ge),se&&se.add((0,_.toDisposable)(()=>ge.remove())),K===r.mainWindow.document.head){const Se=new Set;ye.set(ge,Se);for(const{window:Be,disposables:ke}of(0,t.getWindows)()){if(Be===r.mainWindow)continue;const $e=ke.add(tt(ge,Se,Be));se?.add($e)}}return ge}function Ye(K){const Y=new _.DisposableStore;for(const[se,ge]of ye)Y.add(tt(se,ge,K));return Y}function tt(K,Y,se){const ge=new _.DisposableStore,Se=K.cloneNode(!0);se.document.head.appendChild(Se),ge.add((0,_.toDisposable)(()=>Se.remove()));for(const Be of ue(K))Se.sheet?.insertRule(Be.cssText,Se.sheet?.cssRules.length);return ge.add(t.sharedMutationObserver.observe(K,ge,{childList:!0})(()=>{Se.textContent=K.textContent})),Y.add(Se),ge.add((0,_.toDisposable)(()=>Y.delete(Se))),ge}t.sharedMutationObserver=new class{constructor(){this.mutationObservers=new Map}observe(K,Y,se){let ge=this.mutationObservers.get(K);ge||(ge=new Map,this.mutationObservers.set(K,ge));const Se=(0,s.hash)(se);let Be=ge.get(Se);if(Be)Be.users+=1;else{const ke=new w.Emitter,$e=new MutationObserver(We=>ke.fire(We));$e.observe(K,se);const Ke=Be={users:1,observer:$e,onDidMutate:ke.event};Y.add((0,_.toDisposable)(()=>{Ke.users-=1,Ke.users===0&&(ke.dispose(),$e.disconnect(),ge?.delete(Se),ge?.size===0&&this.mutationObservers.delete(K))})),ge.set(Se,Be)}return Be.onDidMutate}};function at(K=r.mainWindow.document.head){return je("meta",K)}function st(K=r.mainWindow.document.head){return je("link",K)}function je(K,Y=r.mainWindow.document.head){const se=document.createElement(K);return Y.appendChild(se),se}let Ze=null;function Z(){return Ze||(Ze=qe()),Ze}function ue(K){return K?.sheet?.rules?K.sheet.rules:K?.sheet?.cssRules?K.sheet.cssRules:[]}function be(K,Y,se=Z()){if(!(!se||!Y)){se.sheet?.insertRule(`${K} {${Y}}`,0);for(const ge of ye.get(se)??[])be(K,Y,ge)}}function Te(K,Y=Z()){if(!Y)return;const se=ue(Y),ge=[];for(let Se=0;Se<se.length;Se++){const Be=se[Se];Pe(Be)&&Be.selectorText.indexOf(K)!==-1&&ge.push(Se)}for(let Se=ge.length-1;Se>=0;Se--)Y.sheet?.deleteRule(ge[Se]);for(const Se of ye.get(Y)??[])Te(K,Se)}function Pe(K){return typeof K.selectorText=="string"}function Ve(K){return K instanceof HTMLElement||K instanceof(0,t.getWindow)(K).HTMLElement}function Qe(K){return K instanceof HTMLAnchorElement||K instanceof(0,t.getWindow)(K).HTMLAnchorElement}function rt(K){return K instanceof HTMLSpanElement||K instanceof(0,t.getWindow)(K).HTMLSpanElement}function it(K){return K instanceof HTMLTextAreaElement||K instanceof(0,t.getWindow)(K).HTMLTextAreaElement}function ht(K){return K instanceof HTMLInputElement||K instanceof(0,t.getWindow)(K).HTMLInputElement}function nt(K){return K instanceof HTMLButtonElement||K instanceof(0,t.getWindow)(K).HTMLButtonElement}function ft(K){return K instanceof HTMLDivElement||K instanceof(0,t.getWindow)(K).HTMLDivElement}function dt(K){return K instanceof SVGElement||K instanceof(0,t.getWindow)(K).SVGElement}function Dt(K){return K instanceof MouseEvent||K instanceof(0,t.getWindow)(K).MouseEvent}function ze(K){return K instanceof KeyboardEvent||K instanceof(0,t.getWindow)(K).KeyboardEvent}function fe(K){return K instanceof PointerEvent||K instanceof(0,t.getWindow)(K).PointerEvent}function Oe(K){return K instanceof DragEvent||K instanceof(0,t.getWindow)(K).DragEvent}t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:i.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.isWebKit?"webkitAnimationIteration":"animationiteration"};function Me(K){const Y=K;return!!(Y&&typeof Y.preventDefault=="function"&&typeof Y.stopPropagation=="function")}t.EventHelper={stop:(K,Y)=>(K.preventDefault(),Y&&K.stopPropagation(),K)};function Xe(K){const Y=[];for(let se=0;K&&K.nodeType===K.ELEMENT_NODE;se++)Y[se]=K.scrollTop,K=K.parentNode;return Y}function ot(K,Y){for(let se=0;K&&K.nodeType===K.ELEMENT_NODE;se++)K.scrollTop!==Y[se]&&(K.scrollTop=Y[se]),K=K.parentNode}class ut extends _.Disposable{static hasFocusWithin(Y){if(Ve(Y)){const se=z(Y),ge=se?se.activeElement:Y.ownerDocument.activeElement;return a(ge,Y)}else{const se=Y;return a(se.document.activeElement,se.document)}}constructor(Y){super(),this._onDidFocus=this._register(new w.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new w.Emitter),this.onDidBlur=this._onDidBlur.event;let se=ut.hasFocusWithin(Y),ge=!1;const Se=()=>{ge=!1,se||(se=!0,this._onDidFocus.fire())},Be=()=>{se&&(ge=!0,(Ve(Y)?(0,t.getWindow)(Y):Y).setTimeout(()=>{ge&&(ge=!1,se=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{ut.hasFocusWithin(Y)!==se&&(se?Be():Se())},this._register(A(Y,t.EventType.FOCUS,Se,!0)),this._register(A(Y,t.EventType.BLUR,Be,!0)),Ve(Y)&&(this._register(A(Y,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(A(Y,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler())))}refreshState(){this._refreshStateHandler()}}function Je(K){return new ut(K)}function pt(K,Y){return K.after(Y),Y}function yt(K,...Y){if(K.append(...Y),Y.length===1&&typeof Y[0]!="string")return Y[0]}function Ct(K,Y){return K.insertBefore(Y,K.firstChild),Y}function Qt(K,...Y){K.innerText="",yt(K,...Y)}const Oi=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Lt;(function(K){K.HTML="http://www.w3.org/1999/xhtml",K.SVG="http://www.w3.org/2000/svg"})(Lt||(t.Namespace=Lt={}));function Jt(K,Y,se,...ge){const Se=Oi.exec(Y);if(!Se)throw new Error("Bad use of emmet");const Be=Se[1]||"div";let ke;return K!==Lt.HTML?ke=document.createElementNS(K,Be):ke=document.createElement(Be),Se[3]&&(ke.id=Se[3]),Se[4]&&(ke.className=Se[4].replace(/\./g," ").trim()),se&&Object.entries(se).forEach(([$e,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test($e)?ke[$e]=Ke:$e==="selected"?Ke&&ke.setAttribute($e,"true"):ke.setAttribute($e,Ke))}),ke.append(...ge),ke}function ei(K,Y,...se){return Jt(Lt.HTML,K,Y,...se)}ei.SVG=function(K,Y,...se){return Jt(Lt.SVG,K,Y,...se)};function ki(K,Y){const se=[];return K.forEach((ge,Se)=>{Se>0&&(Y instanceof Node?se.push(Y.cloneNode()):se.push(document.createTextNode(Y))),se.push(ge)}),se}function Pi(K,...Y){K?ti(...Y):ii(...Y)}function ti(...K){for(const Y of K)Y.style.display="",Y.removeAttribute("aria-hidden")}function ii(...K){for(const Y of K)Y.style.display="none",Y.setAttribute("aria-hidden","true")}function Mi(K,Y){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(Ve(K)&&K.hasAttribute(Y))return K;K=K.parentNode}return null}function Bi(K){!K||!K.hasAttribute("tabIndex")||(K.ownerDocument.activeElement===K&&Mi(K.parentElement,"tabIndex")?.focus(),K.removeAttribute("tabindex"))}function xi(K){return Y=>{Y.preventDefault(),Y.stopPropagation(),K(Y)}}function Wi(K){return new Promise(Y=>{if(K.document.readyState==="complete"||K.document&&K.document.body!==null)Y(void 0);else{const ge=()=>{K.window.removeEventListener("DOMContentLoaded",ge,!1),Y()};K.window.addEventListener("DOMContentLoaded",ge,!1)}})}function Hi(K,Y){const se=K.devicePixelRatio*Y;return Math.max(1,Math.floor(se))/K.devicePixelRatio}function zi(K){r.mainWindow.open(K,"_blank","noopener")}const ni=780,si=640;function Ui(K){const Y=Math.floor(r.mainWindow.screenLeft+r.mainWindow.innerWidth/2-ni/2),se=Math.floor(r.mainWindow.screenTop+r.mainWindow.innerHeight/2-si/2);r.mainWindow.open(K,"_blank",`width=${ni},height=${si},top=${se},left=${Y}`)}function Vi(K,Y=!0){const se=r.mainWindow.open();return se?(Y&&(se.opener=null),se.location.href=K,!0):!1}function Ki(K,Y){const se=()=>{Y(),ge=(0,t.scheduleAtNextAnimationFrame)(K,se)};let ge=(0,t.scheduleAtNextAnimationFrame)(K,se);return(0,_.toDisposable)(()=>ge.dispose())}b.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(r.mainWindow.location.href)?"https":"http");function $i(K){return K?`url('${b.FileAccess.uriToBrowserUri(K).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function qi(K){return`'${K.replace(/'/g,"%27")}'`}function ri(K,Y){if(K!==void 0){const se=K.match(/^\s*var\((.+)\)$/);if(se){const ge=se[1].split(",",2);return ge.length===2&&(Y=ri(ge[1].trim(),Y)),`var(${ge[0]}, ${Y})`}return K}return Y}function Gi(K,Y){let se;if(e.URI.isUri(K))se=K.toString(!0);else{const Be=new Blob([K]);se=URL.createObjectURL(Be),setTimeout(()=>URL.revokeObjectURL(se))}const ge=Ee(),Se=document.createElement("a");ge.document.body.appendChild(Se),Se.download=Y,Se.href=se,Se.click(),setTimeout(()=>Se.remove())}function ji(){return new Promise(K=>{const Y=Ee(),se=document.createElement("input");Y.document.body.appendChild(se),se.type="file",se.multiple=!0,w.Event.once(w.Event.fromDOMEventEmitter(se,"input"))(()=>{K(se.files??void 0)}),se.click(),setTimeout(()=>se.remove())})}var It;(function(K){K[K.DOCUMENT=1]="DOCUMENT",K[K.BROWSER=2]="BROWSER"})(It||(t.DetectedFullscreenMode=It={}));function Yi(K){return K.document.fullscreenElement||K.document.webkitFullscreenElement||K.document.webkitIsFullScreen?{mode:It.DOCUMENT,guess:!1}:K.innerHeight===K.screen.height?{mode:It.BROWSER,guess:!1}:(m.isMacintosh||m.isLinux)&&K.outerHeight===K.screen.height&&K.outerWidth===K.screen.width?{mode:It.BROWSER,guess:!0}:null}function oi(K,Y=!1){const se=document.createElement("a");return d.addHook("afterSanitizeAttributes",ge=>{for(const Se of["href","src"])if(ge.hasAttribute(Se)){const Be=ge.getAttribute(Se);if(Se==="href"&&Be.startsWith("#"))continue;if(se.href=Be,!K.includes(se.protocol.replace(/:$/,""))){if(Y&&Se==="src"&&se.href.startsWith("data:"))continue;ge.removeAttribute(Se)}}}),(0,_.toDisposable)(()=>{d.removeHook("afterSanitizeAttributes")})}const Xi=[b.Schemas.http,b.Schemas.https,b.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Zi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Qi(K,Y){const se=oi(Xi);try{const ge=d.sanitize(Y,Zi);K.innerHTML=ge}finally{se.dispose()}}function Ji(K){const Y=new Uint16Array(K.length);for(let Se=0;Se<Y.length;Se++)Y[Se]=K.charCodeAt(Se);let se="";const ge=new Uint8Array(Y.buffer);for(let Se=0;Se<ge.length;Se++)se+=String.fromCharCode(ge[Se]);return se}function en(K){return btoa(Ji(K))}class _t extends w.Emitter{constructor(){super(),this._subscriptions=new _.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(w.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Y,disposables:se})=>this.registerListeners(Y,se),{window:r.mainWindow,disposables:this._subscriptions}))}registerListeners(Y,se){se.add(A(Y,"keydown",ge=>{if(ge.defaultPrevented)return;const Se=new P.StandardKeyboardEvent(ge);if(!(Se.keyCode===v.KeyCode.Alt&&ge.repeat)){if(ge.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(ge.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(ge.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(ge.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(Se.keyCode!==v.KeyCode.Alt)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=ge.altKey,this._keyStatus.ctrlKey=ge.ctrlKey,this._keyStatus.metaKey=ge.metaKey,this._keyStatus.shiftKey=ge.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=ge,this.fire(this._keyStatus))}},!0)),se.add(A(Y,"keyup",ge=>{ge.defaultPrevented||(!ge.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!ge.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!ge.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!ge.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=ge.altKey,this._keyStatus.ctrlKey=ge.ctrlKey,this._keyStatus.metaKey=ge.metaKey,this._keyStatus.shiftKey=ge.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=ge,this.fire(this._keyStatus)))},!0)),se.add(A(Y.document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),se.add(A(Y.document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),se.add(A(Y.document.body,"mousemove",ge=>{ge.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),se.add(A(Y,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return _t.instance||(_t.instance=new _t),_t.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=_t;function tn(K){const Y=document.cookie.match("(^|[^;]+)\\s*"+K+"\\s*=\\s*([^;]+)");return Y?Y.pop():void 0}class nn extends _.Disposable{constructor(Y,se){super(),this.element=Y,this.callbacks=se,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this.callbacks.onDragStart&&this._register(A(this.element,t.EventType.DRAG_START,Y=>{this.callbacks.onDragStart?.(Y)})),this.callbacks.onDrag&&this._register(A(this.element,t.EventType.DRAG,Y=>{this.callbacks.onDrag?.(Y)})),this._register(A(this.element,t.EventType.DRAG_ENTER,Y=>{this.counter++,this.dragStartTime=Y.timeStamp,this.callbacks.onDragEnter?.(Y)})),this._register(A(this.element,t.EventType.DRAG_OVER,Y=>{Y.preventDefault(),this.callbacks.onDragOver?.(Y,Y.timeStamp-this.dragStartTime)})),this._register(A(this.element,t.EventType.DRAG_LEAVE,Y=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave?.(Y))})),this._register(A(this.element,t.EventType.DRAG_END,Y=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd?.(Y)})),this._register(A(this.element,t.EventType.DROP,Y=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop?.(Y)}))}}t.DragAndDropObserver=nn;const ai=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function sn(K,...Y){let se,ge;Array.isArray(Y[0])?(se={},ge=Y[0]):(se=Y[0]||{},ge=Y[1]);const Se=ai.exec(K);if(!Se||!Se.groups)throw new Error("Bad use of h");const Be=Se.groups.tag||"div",ke=document.createElement(Be);Se.groups.id&&(ke.id=Se.groups.id);const $e=[];if(Se.groups.class)for(const We of Se.groups.class.split("."))We!==""&&$e.push(We);if(se.className!==void 0)for(const We of se.className.split("."))We!==""&&$e.push(We);$e.length>0&&(ke.className=$e.join(" "));const Ke={};if(Se.groups.name&&(Ke[Se.groups.name]=ke),ge)for(const We of ge)Ve(We)?ke.appendChild(We):typeof We=="string"?ke.append(We):"root"in We&&(Object.assign(Ke,We),ke.appendChild(We.root));for(const[We,lt]of Object.entries(se))if(We!=="className")if(We==="style")for(const[St,Et]of Object.entries(lt))ke.style.setProperty(Ot(St),typeof Et=="number"?Et+"px":""+Et);else We==="tabIndex"?ke.tabIndex=lt:ke.setAttribute(Ot(We),lt.toString());return Ke.root=ke,Ke}function rn(K,...Y){let se,ge;Array.isArray(Y[0])?(se={},ge=Y[0]):(se=Y[0]||{},ge=Y[1]);const Se=ai.exec(K);if(!Se||!Se.groups)throw new Error("Bad use of h");const Be=Se.groups.tag||"div",ke=document.createElementNS("http://www.w3.org/2000/svg",Be);Se.groups.id&&(ke.id=Se.groups.id);const $e=[];if(Se.groups.class)for(const We of Se.groups.class.split("."))We!==""&&$e.push(We);if(se.className!==void 0)for(const We of se.className.split("."))We!==""&&$e.push(We);$e.length>0&&(ke.className=$e.join(" "));const Ke={};if(Se.groups.name&&(Ke[Se.groups.name]=ke),ge)for(const We of ge)Ve(We)?ke.appendChild(We):typeof We=="string"?ke.append(We):"root"in We&&(Object.assign(Ke,We),ke.appendChild(We.root));for(const[We,lt]of Object.entries(se))if(We!=="className")if(We==="style")for(const[St,Et]of Object.entries(lt))ke.style.setProperty(Ot(St),typeof Et=="number"?Et+"px":""+Et);else We==="tabIndex"?ke.tabIndex=lt:ke.setAttribute(Ot(We),lt.toString());return Ke.root=ke,Ke}function Ot(K){return K.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function li(K,Y,se){for(const{name:ge,value:Se}of K.attributes)(!se||se.includes(ge))&&Y.setAttribute(ge,Se)}function on(K,Y,se){const ge=K.getAttribute(se);ge?Y.setAttribute(se,ge):Y.removeAttribute(se)}function an(K,Y,se){li(K,Y,se);const ge=new _.DisposableStore;return ge.add(t.sharedMutationObserver.observe(K,ge,{attributes:!0,attributeFilter:se})(Se=>{for(const Be of Se)Be.type==="attributes"&&Be.attributeName&&on(K,Y,Be.attributeName)})),ge}class ln{constructor(Y,se,ge){this.originX=Y,this.originY=se,this.triangles=[];const{top:Se,left:Be,right:ke,bottom:$e}=ge.getBoundingClientRect(),Ke=this.triangles;let We=0;Ke[We++]=Be,Ke[We++]=Se,Ke[We++]=ke,Ke[We++]=Se,Ke[We++]=Be,Ke[We++]=Se,Ke[We++]=Be,Ke[We++]=$e,Ke[We++]=ke,Ke[We++]=Se,Ke[We++]=ke,Ke[We++]=$e,Ke[We++]=Be,Ke[We++]=$e,Ke[We++]=ke,Ke[We++]=$e}contains(Y,se){const{triangles:ge,originX:Se,originY:Be}=this;for(let ke=0;ke<4;ke++)if((0,c.isPointWithinTriangle)(Y,se,Se,Be,ge[2*ke],ge[2*ke+1],ge[2*ke+2],ge[2*ke+3]))return!0;return!1}}t.SafeTriangle=ln}),define(ve[69],De([1,0,4,2,100]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTransfers=t.DelayedDragHandler=void 0,t.applyDragImage=I;class F extends n.Disposable{constructor(w,d){super(),this._register((0,i.addDisposableListener)(w,"dragover",v=>{v.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{d(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(v=>{this._register((0,i.addDisposableListener)(w,v,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=F,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:P.Mimes.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function I(D,w,d,v,_){const b=document.createElement("div");b.className=d,b.textContent=w,_&&(b.style.color=_),v&&(b.style.background=v),D.dataTransfer&&((0,i.getWindow)(D).document.body.appendChild(b),D.dataTransfer.setDragImage(b,-10,-10),setTimeout(()=>b.remove(),0))}}),define(ve[70],De([1,0,4]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderText=n,t.renderFormattedText=P,t.createElement=F,i=Ue(i);function n(b,m={}){const e=F(m);return e.textContent=b,e}function P(b,m={}){const e=F(m);return w(e,d(b,!!m.renderCodeSegments),m.actionHandler,m.renderCodeSegments),e}function F(b){const m=b.inline?"span":"div",e=document.createElement(m);return b.className&&(e.className=b.className),e}class I{constructor(m){this.source=m,this.index=0}eos(){return this.index>=this.source.length}next(){const m=this.peek();return this.advance(),m}peek(){return this.source[this.index]}advance(){this.index++}}var D;(function(b){b[b.Invalid=0]="Invalid",b[b.Root=1]="Root",b[b.Text=2]="Text",b[b.Bold=3]="Bold",b[b.Italics=4]="Italics",b[b.Action=5]="Action",b[b.ActionClose=6]="ActionClose",b[b.Code=7]="Code",b[b.NewLine=8]="NewLine"})(D||(D={}));function w(b,m,e,s){let r;if(m.type===D.Text)r=document.createTextNode(m.content||"");else if(m.type===D.Bold)r=document.createElement("b");else if(m.type===D.Italics)r=document.createElement("i");else if(m.type===D.Code&&s)r=document.createElement("code");else if(m.type===D.Action&&e){const c=document.createElement("a");e.disposables.add(i.addStandardDisposableListener(c,"click",l=>{e.callback(String(m.index),l)})),r=c}else m.type===D.NewLine?r=document.createElement("br"):m.type===D.Root&&(r=b);r&&b!==r&&b.appendChild(r),r&&Array.isArray(m.children)&&m.children.forEach(c=>{w(r,c,e,s)})}function d(b,m){const e={type:D.Root,children:[]};let s=0,r=e;const c=[],l=new I(b);for(;!l.eos();){let E=l.next();const T=E==="\\"&&_(l.peek(),m)!==D.Invalid;if(T&&(E=l.next()),!T&&v(E,m)&&E===l.peek()){l.advance(),r.type===D.Text&&(r=c.pop());const A=_(E,m);if(r.type===A||r.type===D.Action&&A===D.ActionClose)r=c.pop();else{const f={type:A,children:[]};A===D.Action&&(f.index=s,s++),r.children.push(f),c.push(r),r=f}}else if(E===`
`)r.type===D.Text&&(r=c.pop()),r.children.push({type:D.NewLine});else if(r.type!==D.Text){const A={type:D.Text,content:E};r.children.push(A),c.push(r),r=A}else r.content+=E}return r.type===D.Text&&(r=c.pop()),c.length,e}function v(b,m){return _(b,m)!==D.Invalid}function _(b,m){switch(b){case"*":return D.Bold;case"_":return D.Italics;case"[":return D.Action;case"]":return D.ActionClose;case"`":return m?D.Code:D.Invalid;default:return D.Invalid}}}),define(ve[71],De([1,0,4,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0,i=Ue(i);class P{constructor(){this._hooks=new n.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(I,D){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const w=this._onStopCallback;this._onStopCallback=null,I&&w&&w(D)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(I,D,w,d,v){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=d,this._onStopCallback=v;let _=I;try{I.setPointerCapture(D),this._hooks.add((0,n.toDisposable)(()=>{try{I.releasePointerCapture(D)}catch{}}))}catch{_=i.getWindow(I)}this._hooks.add(i.addDisposableListener(_,i.EventType.POINTER_MOVE,b=>{if(b.buttons!==w){this.stopMonitoring(!0);return}b.preventDefault(),this._pointerMoveCallback(b)})),this._hooks.add(i.addDisposableListener(_,i.EventType.POINTER_UP,b=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=P});var et=this&&this.__decorate||function(oe,t,i,n){var P=arguments.length,F=P<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,i):n,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(oe,t,i,n);else for(var D=oe.length-1;D>=0;D--)(I=oe[D])&&(F=(P<3?I(F):P>3?I(t,i,F):I(t,i))||F);return P>3&&F&&Object.defineProperty(t,i,F),F};define(ve[32],De([1,0,4,24,9,35,3,2,59]),function(oe,t,i,n,P,F,I,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0,i=Ue(i),P=Ue(P);var d;(function(_){_.Tap="-monaco-gesturetap",_.Change="-monaco-gesturechange",_.Start="-monaco-gesturestart",_.End="-monaco-gesturesend",_.Contextmenu="-monaco-gesturecontextmenu"})(d||(t.EventType=d={}));class v extends D.Disposable{static{this.SCROLL_FRICTION=-.005}static{this.HOLD_DELAY=700}static{this.CLEAR_TAP_COUNT_TIME=400}constructor(){super(),this.dispatched=!1,this.targets=new w.LinkedList,this.ignoreTargets=new w.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(I.Event.runAndSubscribe(i.onDidRegisterWindow,({window:b,disposables:m})=>{m.add(i.addDisposableListener(b.document,"touchstart",e=>this.onTouchStart(e),{passive:!1})),m.add(i.addDisposableListener(b.document,"touchend",e=>this.onTouchEnd(b,e))),m.add(i.addDisposableListener(b.document,"touchmove",e=>this.onTouchMove(e),{passive:!1}))},{window:n.mainWindow,disposables:this._store}))}static addTarget(b){if(!v.isTouchDevice())return D.Disposable.None;v.INSTANCE||(v.INSTANCE=(0,D.markAsSingleton)(new v));const m=v.INSTANCE.targets.push(b);return(0,D.toDisposable)(m)}static ignoreTarget(b){if(!v.isTouchDevice())return D.Disposable.None;v.INSTANCE||(v.INSTANCE=(0,D.markAsSingleton)(new v));const m=v.INSTANCE.ignoreTargets.push(b);return(0,D.toDisposable)(m)}static isTouchDevice(){return"ontouchstart"in n.mainWindow||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(b){const m=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let e=0,s=b.targetTouches.length;e<s;e++){const r=b.targetTouches.item(e);this.activeTouches[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:m,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[m],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const c=this.newGestureEvent(d.Start,r.target);c.pageX=r.pageX,c.pageY=r.pageY,this.dispatchEvent(c)}this.dispatched&&(b.preventDefault(),b.stopPropagation(),this.dispatched=!1)}onTouchEnd(b,m){const e=Date.now(),s=Object.keys(this.activeTouches).length;for(let r=0,c=m.changedTouches.length;r<c;r++){const l=m.changedTouches.item(r);if(!this.activeTouches.hasOwnProperty(String(l.identifier))){console.warn("move of an UNKNOWN touch",l);continue}const E=this.activeTouches[l.identifier],T=Date.now()-E.initialTimeStamp;if(T<v.HOLD_DELAY&&Math.abs(E.initialPageX-P.tail(E.rollingPageX))<30&&Math.abs(E.initialPageY-P.tail(E.rollingPageY))<30){const A=this.newGestureEvent(d.Tap,E.initialTarget);A.pageX=P.tail(E.rollingPageX),A.pageY=P.tail(E.rollingPageY),this.dispatchEvent(A)}else if(T>=v.HOLD_DELAY&&Math.abs(E.initialPageX-P.tail(E.rollingPageX))<30&&Math.abs(E.initialPageY-P.tail(E.rollingPageY))<30){const A=this.newGestureEvent(d.Contextmenu,E.initialTarget);A.pageX=P.tail(E.rollingPageX),A.pageY=P.tail(E.rollingPageY),this.dispatchEvent(A)}else if(s===1){const A=P.tail(E.rollingPageX),f=P.tail(E.rollingPageY),h=P.tail(E.rollingTimestamps)-E.rollingTimestamps[0],p=A-E.rollingPageX[0],S=f-E.rollingPageY[0],U=[...this.targets].filter(H=>E.initialTarget instanceof Node&&H.contains(E.initialTarget));this.inertia(b,U,e,Math.abs(p)/h,p>0?1:-1,A,Math.abs(S)/h,S>0?1:-1,f)}this.dispatchEvent(this.newGestureEvent(d.End,E.initialTarget)),delete this.activeTouches[l.identifier]}this.dispatched&&(m.preventDefault(),m.stopPropagation(),this.dispatched=!1)}newGestureEvent(b,m){const e=document.createEvent("CustomEvent");return e.initEvent(b,!1,!0),e.initialTarget=m,e.tapCount=0,e}dispatchEvent(b){if(b.type===d.Tap){const m=new Date().getTime();let e=0;m-this._lastSetTapCountTime>v.CLEAR_TAP_COUNT_TIME?e=1:e=2,this._lastSetTapCountTime=m,b.tapCount=e}else(b.type===d.Change||b.type===d.Contextmenu)&&(this._lastSetTapCountTime=0);if(b.initialTarget instanceof Node){for(const e of this.ignoreTargets)if(e.contains(b.initialTarget))return;const m=[];for(const e of this.targets)if(e.contains(b.initialTarget)){let s=0,r=b.initialTarget;for(;r&&r!==e;)s++,r=r.parentElement;m.push([s,e])}m.sort((e,s)=>e[0]-s[0]);for(const[e,s]of m)s.dispatchEvent(b),this.dispatched=!0}}inertia(b,m,e,s,r,c,l,E,T){this.handle=i.scheduleAtNextAnimationFrame(b,()=>{const A=Date.now(),f=A-e;let h=0,p=0,S=!0;s+=v.SCROLL_FRICTION*f,l+=v.SCROLL_FRICTION*f,s>0&&(S=!1,h=r*s*f),l>0&&(S=!1,p=E*l*f);const U=this.newGestureEvent(d.Change);U.translationX=h,U.translationY=p,m.forEach(H=>H.dispatchEvent(U)),S||this.inertia(b,m,A,s,r,c+h,l,E,T+p)})}onTouchMove(b){const m=Date.now();for(let e=0,s=b.changedTouches.length;e<s;e++){const r=b.changedTouches.item(e);if(!this.activeTouches.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const c=this.activeTouches[r.identifier],l=this.newGestureEvent(d.Change,c.initialTarget);l.translationX=r.pageX-P.tail(c.rollingPageX),l.translationY=r.pageY-P.tail(c.rollingPageY),l.pageX=r.pageX,l.pageY=r.pageY,this.dispatchEvent(l),c.rollingPageX.length>3&&(c.rollingPageX.shift(),c.rollingPageY.shift(),c.rollingTimestamps.shift()),c.rollingPageX.push(r.pageX),c.rollingPageY.push(r.pageY),c.rollingTimestamps.push(m)}this.dispatched&&(b.preventDefault(),b.stopPropagation(),this.dispatched=!1)}}t.Gesture=v,et([F.memoize],v,"isTouchDevice",null)}),define(ve[112],De([1,0,4,22]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderLabelWithIcons=F,t.renderIcon=I,i=Ue(i);const P=new RegExp(`(\\\\)?\\$\\((${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?)\\)`,"g");function F(D){const w=new Array;let d,v=0,_=0;for(;(d=P.exec(D))!==null;){_=d.index||0,v<_&&w.push(D.substring(v,_)),v=(d.index||0)+d[0].length;const[,b,m]=d;w.push(b?`$(${m})`:I({id:m}))}return v<D.length&&w.push(D.substring(v)),w}function I(D){const w=i.$("span");return w.classList.add(...n.ThemeIcon.asClassNameArray(D)),w}}),define(ve[113],De([1,0,4]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;class n{constructor(F){this.renderers=F,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(F){let I=this.getTemplateCache(F).pop(),D=!1;if(I)D=this.transactionNodesPendingRemoval.has(I.domNode),D&&this.transactionNodesPendingRemoval.delete(I.domNode);else{const w=(0,i.$)(".monaco-list-row"),v=this.getRenderer(F).renderTemplate(w);I={domNode:w,templateId:F,templateData:v}}return{row:I,isReusingConnectedDomNode:D}}release(F){F&&this.releaseRow(F)}transact(F){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{F()}finally{for(const I of this.transactionNodesPendingRemoval)this.doRemoveNode(I);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(F){const{domNode:I,templateId:D}=F;I&&(this.inTransaction?this.transactionNodesPendingRemoval.add(I):this.doRemoveNode(I)),this.getTemplateCache(D).push(F)}doRemoveNode(F){F.classList.remove("scrolling"),F.remove()}getTemplateCache(F){let I=this.cache.get(F);return I||(I=[],this.cache.set(F,I)),I}dispose(){this.cache.forEach((F,I)=>{for(const D of F)this.getRenderer(I).disposeTemplate(D.templateData),D.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(F){const I=this.renderers.get(F);if(!I)throw new Error(`No renderer found for ${F}`);return I}}t.RowCache=n}),define(ve[114],De([1,0,12,2,20]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class F extends n.Disposable{constructor(D,w,d){super(),this._visibility=D,this._visibleClassName=w,this._invisibleClassName=d,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new i.TimeoutTimer)}setVisibility(D){this._visibility!==D&&(this._visibility=D,this._updateShouldBeVisible())}setShouldBeVisible(D){this._rawShouldBeVisible=D,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===P.ScrollbarVisibility.Hidden?!1:this._visibility===P.ScrollbarVisibility.Visible?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const D=this._applyVisibilitySetting();this._shouldBeVisible!==D&&(this._shouldBeVisible=D,this.ensureVisibility())}setIsNeeded(D){this._isNeeded!==D&&(this._isNeeded=D,this.ensureVisibility())}setDomNode(D){this._domNode=D,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(D){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(D?" fade":"")))}}t.ScrollbarVisibilityController=F}),define(ve[115],De([1,0,4,32,9,3,8,2,5]),function(oe,t,i,n,P,F,I,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0,i=Ue(i),P=Ue(P);class d extends D.Disposable{constructor(_,b,m,e){super(),this.selected=0,this.selectBoxOptions=e||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new F.Emitter),this.styles=m,this.registerListeners(),this.setOptions(_,b)}registerListeners(){this._register(n.Gesture.addTarget(this.selectElement)),[n.EventType.Tap].forEach(_=>{this._register(i.addDisposableListener(this.selectElement,_,b=>{this.selectElement.focus()}))}),this._register(i.addStandardDisposableListener(this.selectElement,"click",_=>{i.EventHelper.stop(_,!0)})),this._register(i.addStandardDisposableListener(this.selectElement,"change",_=>{this.selectElement.title=_.target.value,this._onDidSelect.fire({index:_.target.selectedIndex,selected:_.target.value})})),this._register(i.addStandardDisposableListener(this.selectElement,"keydown",_=>{let b=!1;w.isMacintosh?(_.keyCode===I.KeyCode.DownArrow||_.keyCode===I.KeyCode.UpArrow||_.keyCode===I.KeyCode.Space)&&(b=!0):(_.keyCode===I.KeyCode.DownArrow&&_.altKey||_.keyCode===I.KeyCode.Space||_.keyCode===I.KeyCode.Enter)&&(b=!0),b&&_.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(_,b){(!this.options||!P.equals(this.options,_))&&(this.options=_,this.selectElement.options.length=0,this.options.forEach((m,e)=>{this.selectElement.add(this.createOption(m.text,e,m.isDisabled))})),b!==void 0&&this.select(b)}select(_){this.options.length===0?this.selected=0:_>=0&&_<this.options.length?this.selected=_:_>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(_){this.selectBoxOptions.ariaLabel=_,this.selectElement.setAttribute("aria-label",_)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setEnabled(_){this.selectElement.disabled=!_}setFocusable(_){this.selectElement.tabIndex=_?0:-1}render(_){_.classList.add("select-container"),_.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(_){this.styles=_,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(_,b,m){const e=document.createElement("option");return e.value=_,e.text=_,e.disabled=!!m,e}}t.SelectBoxNative=d}),define(ve[72],De([1,0,34,9,12,63,109,3,36]),function(oe,t,i,n,P,F,I,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=void 0,t.isFilterResult=d,t.getVisibleState=v;function d(m){return typeof m=="object"&&"visibility"in m&&"data"in m}function v(m){switch(m){case!0:return i.TreeVisibility.Visible;case!1:return i.TreeVisibility.Hidden;default:return m}}function _(m){return typeof m.collapsible=="boolean"}class b{constructor(e,s,r,c={}){this.user=e,this.list=s,this.rootRef=[],this.eventBufferer=new D.EventBufferer,this._onDidChangeCollapseState=new D.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new D.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new D.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new P.Delayer(F.MicrotaskDelay),this.collapseByDefault=typeof c.collapseByDefault>"u"?!1:c.collapseByDefault,this.allowNonCollapsibleParents=c.allowNonCollapsibleParents??!1,this.filter=c.filter,this.autoExpandSingleChildren=typeof c.autoExpandSingleChildren>"u"?!1:c.autoExpandSingleChildren,this.root={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0}}splice(e,s,r=w.Iterable.empty(),c={}){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");c.diffIdentityProvider?this.spliceSmart(c.diffIdentityProvider,e,s,r,c):this.spliceSimple(e,s,r,c)}spliceSmart(e,s,r,c=w.Iterable.empty(),l,E=l.diffDepth??0){const{parentNode:T}=this.getParentNodeWithListIndex(s);if(!T.lastDiffIds)return this.spliceSimple(s,r,c,l);const A=[...c],f=s[s.length-1],h=new I.LcsDiff({getElements:()=>T.lastDiffIds},{getElements:()=>[...T.children.slice(0,f),...A,...T.children.slice(f+r)].map(x=>e.getId(x.element).toString())}).ComputeDiff(!1);if(h.quitEarly)return T.lastDiffIds=void 0,this.spliceSimple(s,r,A,l);const p=s.slice(0,-1),S=(x,y,O)=>{if(E>0)for(let V=0;V<O;V++)x--,y--,this.spliceSmart(e,[...p,x,0],Number.MAX_SAFE_INTEGER,A[y].children,l,E-1)};let U=Math.min(T.children.length,f+r),H=A.length;for(const x of h.changes.sort((y,O)=>O.originalStart-y.originalStart))S(U,H,U-(x.originalStart+x.originalLength)),U=x.originalStart,H=x.modifiedStart-f,this.spliceSimple([...p,U],x.originalLength,w.Iterable.slice(A,H,H+x.modifiedLength),l);S(U,H,U)}spliceSimple(e,s,r=w.Iterable.empty(),{onDidCreateNode:c,onDidDeleteNode:l,diffIdentityProvider:E}){const{parentNode:T,listIndex:A,revealed:f,visible:h}=this.getParentNodeWithListIndex(e),p=[],S=w.Iterable.map(r,G=>this.createTreeNode(G,T,T.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,f,p,c)),U=e[e.length-1];let H=0;for(let G=U;G>=0&&G<T.children.length;G--){const Q=T.children[G];if(Q.visible){H=Q.visibleChildIndex;break}}const x=[];let y=0,O=0;for(const G of S)x.push(G),O+=G.renderNodeCount,G.visible&&(G.visibleChildIndex=H+y++);const V=(0,n.splice)(T.children,U,s,x);E?T.lastDiffIds?(0,n.splice)(T.lastDiffIds,U,s,x.map(G=>E.getId(G.element).toString())):T.lastDiffIds=T.children.map(G=>E.getId(G.element).toString()):T.lastDiffIds=void 0;let R=0;for(const G of V)G.visible&&R++;if(R!==0)for(let G=U+x.length;G<T.children.length;G++){const Q=T.children[G];Q.visible&&(Q.visibleChildIndex-=R)}if(T.visibleChildrenCount+=y-R,f&&h){const G=V.reduce((Q,j)=>Q+(j.visible?j.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(T,O-G),this.list.splice(A,G,p)}if(V.length>0&&l){const G=Q=>{l(Q),Q.children.forEach(G)};V.forEach(G)}this._onDidSplice.fire({insertedNodes:x,deletedNodes:V});let W=T;for(;W;){if(W.visibility===i.TreeVisibility.Recurse){this.refilterDelayer.trigger(()=>this.refilter());break}W=W.parent}}rerender(e){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");const{node:s,listIndex:r,revealed:c}=this.getTreeNodeWithListIndex(e);s.visible&&c&&this.list.splice(r,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");const{listIndex:r}=this.getTreeNodeWithListIndex(e);this.list.updateElementHeight(r,s)}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:s,visible:r,revealed:c}=this.getTreeNodeWithListIndex(e);return r&&c?s:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,s){const r=this.getTreeNode(e);typeof s>"u"&&(s=!r.collapsible);const c={collapsible:s};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,c))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,s,r){const c=this.getTreeNode(e);typeof s>"u"&&(s=!c.collapsed);const l={collapsed:s,recursive:r||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,l))}_setCollapseState(e,s){const{node:r,listIndex:c,revealed:l}=this.getTreeNodeWithListIndex(e),E=this._setListNodeCollapseState(r,c,l,s);if(r!==this.root&&this.autoExpandSingleChildren&&E&&!_(s)&&r.collapsible&&!r.collapsed&&!s.recursive){let T=-1;for(let A=0;A<r.children.length;A++)if(r.children[A].visible)if(T>-1){T=-1;break}else T=A;T>-1&&this._setCollapseState([...e,T],s)}return E}_setListNodeCollapseState(e,s,r,c){const l=this._setNodeCollapseState(e,c,!1);if(!r||!e.visible||!l)return l;const E=e.renderNodeCount,T=this.updateNodeAfterCollapseChange(e),A=E-(s===-1?0:1);return this.list.splice(s+1,A,T.slice(1)),l}_setNodeCollapseState(e,s,r){let c;if(e===this.root?c=!1:(_(s)?(c=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(c=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):c=!1,c&&this._onDidChangeCollapseState.fire({node:e,deep:r})),!_(s)&&s.recursive)for(const l of e.children)c=this._setNodeCollapseState(l,s,!0)||c;return c}expandTo(e){this.eventBufferer.bufferEvents(()=>{let s=this.getTreeNode(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.root.renderNodeCount,s=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,s),this.refilterDelayer.cancel()}createTreeNode(e,s,r,c,l,E){const T={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0},A=this._filterNode(T,r);T.visibility=A,c&&l.push(T);const f=e.children||w.Iterable.empty(),h=c&&A!==i.TreeVisibility.Hidden&&!T.collapsed;let p=0,S=1;for(const U of f){const H=this.createTreeNode(U,T,A,h,l,E);T.children.push(H),S+=H.renderNodeCount,H.visible&&(H.visibleChildIndex=p++)}return this.allowNonCollapsibleParents||(T.collapsible=T.collapsible||T.children.length>0),T.visibleChildrenCount=p,T.visible=A===i.TreeVisibility.Recurse?p>0:A===i.TreeVisibility.Visible,T.visible?T.collapsed||(T.renderNodeCount=S):(T.renderNodeCount=0,c&&l.pop()),E?.(T),T}updateNodeAfterCollapseChange(e){const s=e.renderNodeCount,r=[];return this._updateNodeAfterCollapseChange(e,r),this._updateAncestorsRenderNodeCount(e.parent,r.length-s),r}_updateNodeAfterCollapseChange(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(r,s);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const s=e.renderNodeCount,r=[];return this._updateNodeAfterFilterChange(e,e.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,r),this._updateAncestorsRenderNodeCount(e.parent,r.length-s),r}_updateNodeAfterFilterChange(e,s,r,c=!0){let l;if(e!==this.root){if(l=this._filterNode(e,s),l===i.TreeVisibility.Hidden)return e.visible=!1,e.renderNodeCount=0,!1;c&&r.push(e)}const E=r.length;e.renderNodeCount=e===this.root?0:1;let T=!1;if(!e.collapsed||l!==i.TreeVisibility.Hidden){let A=0;for(const f of e.children)T=this._updateNodeAfterFilterChange(f,l,r,c&&!e.collapsed)||T,f.visible&&(f.visibleChildIndex=A++);e.visibleChildrenCount=A}else e.visibleChildrenCount=0;return e!==this.root&&(e.visible=l===i.TreeVisibility.Recurse?T:l===i.TreeVisibility.Visible,e.visibility=l),e.visible?e.collapsed||(e.renderNodeCount+=r.length-E):(e.renderNodeCount=0,c&&r.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,s){const r=this.filter?this.filter.filter(e.element,s):i.TreeVisibility.Visible;return typeof r=="boolean"?(e.filterData=void 0,r?i.TreeVisibility.Visible:i.TreeVisibility.Hidden):d(r)?(e.filterData=r.data,v(r.visibility)):(e.filterData=void 0,v(r))}hasTreeNode(e,s=this.root){if(!e||e.length===0)return!0;const[r,...c]=e;return r<0||r>s.children.length?!1:this.hasTreeNode(c,s.children[r])}getTreeNode(e,s=this.root){if(!e||e.length===0)return s;const[r,...c]=e;if(r<0||r>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");return this.getTreeNode(c,s.children[r])}getTreeNodeWithListIndex(e){if(e.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:r,revealed:c,visible:l}=this.getParentNodeWithListIndex(e),E=e[e.length-1];if(E<0||E>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");const T=s.children[E];return{node:T,listIndex:r,revealed:c,visible:l&&T.visible}}getParentNodeWithListIndex(e,s=this.root,r=0,c=!0,l=!0){const[E,...T]=e;if(E<0||E>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");for(let A=0;A<E;A++)r+=s.children[A].renderNodeCount;return c=c&&!s.collapsed,l=l&&s.visible,T.length===0?{parentNode:s,listIndex:r,revealed:c,visible:l}:this.getParentNodeWithListIndex(T,s.children[E],r+1,c,l)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const s=[];let r=e;for(;r.parent;)s.push(r.parent.children.indexOf(r)),r=r.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,n.tail2)(e)[0]}getFirstElementChild(e){const s=this.getTreeNode(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.getTreeNode(e);if(s.children.length!==0)return this._getLastElementAncestor(s)}_getLastElementAncestor(e){return e.children.length===0?e.element:this._getLastElementAncestor(e.children[e.children.length-1])}}t.IndexTreeModel=b}),define(ve[116],De([1,0,72,34,36]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class F{get size(){return this.nodes.size}constructor(D,w,d={}){this.user=D,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new i.IndexTreeModel(D,w,null,d),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,d.sorter&&(this.sorter={compare(v,_){return d.sorter.compare(v.element,_.element)}}),this.identityProvider=d.identityProvider}setChildren(D,w=P.Iterable.empty(),d={}){const v=this.getElementLocation(D);this._setChildren(v,this.preserveCollapseState(w),d)}_setChildren(D,w=P.Iterable.empty(),d){const v=new Set,_=new Set,b=e=>{if(e.element===null)return;const s=e;if(v.add(s.element),this.nodes.set(s.element,s),this.identityProvider){const r=this.identityProvider.getId(s.element).toString();_.add(r),this.nodesByIdentity.set(r,s)}d.onDidCreateNode?.(s)},m=e=>{if(e.element===null)return;const s=e;if(v.has(s.element)||this.nodes.delete(s.element),this.identityProvider){const r=this.identityProvider.getId(s.element).toString();_.has(r)||this.nodesByIdentity.delete(r)}d.onDidDeleteNode?.(s)};this.model.splice([...D,0],Number.MAX_VALUE,w,{...d,onDidCreateNode:b,onDidDeleteNode:m})}preserveCollapseState(D=P.Iterable.empty()){return this.sorter&&(D=[...D].sort(this.sorter.compare.bind(this.sorter))),P.Iterable.map(D,w=>{let d=this.nodes.get(w.element);if(!d&&this.identityProvider){const b=this.identityProvider.getId(w.element).toString();d=this.nodesByIdentity.get(b)}if(!d){let b;return typeof w.collapsed>"u"?b=void 0:w.collapsed===n.ObjectTreeElementCollapseState.Collapsed||w.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed?b=!0:w.collapsed===n.ObjectTreeElementCollapseState.Expanded||w.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?b=!1:b=!!w.collapsed,{...w,children:this.preserveCollapseState(w.children),collapsed:b}}const v=typeof w.collapsible=="boolean"?w.collapsible:d.collapsible;let _;return typeof w.collapsed>"u"||w.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed||w.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?_=d.collapsed:w.collapsed===n.ObjectTreeElementCollapseState.Collapsed?_=!0:w.collapsed===n.ObjectTreeElementCollapseState.Expanded?_=!1:_=!!w.collapsed,{...w,collapsible:v,collapsed:_,children:this.preserveCollapseState(w.children)}})}rerender(D){const w=this.getElementLocation(D);this.model.rerender(w)}updateElementHeight(D,w){const d=this.getElementLocation(D);this.model.updateElementHeight(d,w)}resort(D=null,w=!0){if(!this.sorter)return;const d=this.getElementLocation(D),v=this.model.getNode(d);this._setChildren(d,this.resortChildren(v,w),{})}resortChildren(D,w,d=!0){let v=[...D.children];return(w||d)&&(v=v.sort(this.sorter.compare.bind(this.sorter))),P.Iterable.map(v,_=>({element:_.element,collapsible:_.collapsible,collapsed:_.collapsed,children:this.resortChildren(_,w,!1)}))}getFirstElementChild(D=null){const w=this.getElementLocation(D);return this.model.getFirstElementChild(w)}getLastElementAncestor(D=null){const w=this.getElementLocation(D);return this.model.getLastElementAncestor(w)}has(D){return this.nodes.has(D)}getListIndex(D){const w=this.getElementLocation(D);return this.model.getListIndex(w)}getListRenderCount(D){const w=this.getElementLocation(D);return this.model.getListRenderCount(w)}isCollapsible(D){const w=this.getElementLocation(D);return this.model.isCollapsible(w)}setCollapsible(D,w){const d=this.getElementLocation(D);return this.model.setCollapsible(d,w)}isCollapsed(D){const w=this.getElementLocation(D);return this.model.isCollapsed(w)}setCollapsed(D,w,d){const v=this.getElementLocation(D);return this.model.setCollapsed(v,w,d)}expandTo(D){const w=this.getElementLocation(D);this.model.expandTo(w)}refilter(){this.model.refilter()}getNode(D=null){if(D===null)return this.model.getNode(this.model.rootRef);const w=this.nodes.get(D);if(!w)throw new n.TreeError(this.user,`Tree element not found: ${D}`);return w}getNodeLocation(D){return D.element}getParentNodeLocation(D){if(D===null)throw new n.TreeError(this.user,"Invalid getParentNodeLocation call");const w=this.nodes.get(D);if(!w)throw new n.TreeError(this.user,`Tree element not found: ${D}`);const d=this.model.getNodeLocation(w),v=this.model.getParentNodeLocation(d);return this.model.getNode(v).element}getElementLocation(D){if(D===null)return[];const w=this.nodes.get(D);if(!w)throw new n.TreeError(this.user,`Tree element not found: ${D}`);return this.model.getNodeLocation(w)}}t.ObjectTreeModel=F}),define(ve[23],De([1,0,4,15,19,32,2]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0,i=Ue(i);class D extends I.Disposable{onclick(d,v){this._register(i.addDisposableListener(d,i.EventType.CLICK,_=>v(new P.StandardMouseEvent(i.getWindow(d),_))))}onmousedown(d,v){this._register(i.addDisposableListener(d,i.EventType.MOUSE_DOWN,_=>v(new P.StandardMouseEvent(i.getWindow(d),_))))}onmouseover(d,v){this._register(i.addDisposableListener(d,i.EventType.MOUSE_OVER,_=>v(new P.StandardMouseEvent(i.getWindow(d),_))))}onmouseleave(d,v){this._register(i.addDisposableListener(d,i.EventType.MOUSE_LEAVE,_=>v(new P.StandardMouseEvent(i.getWindow(d),_))))}onkeydown(d,v){this._register(i.addDisposableListener(d,i.EventType.KEY_DOWN,_=>v(new n.StandardKeyboardEvent(_))))}onkeyup(d,v){this._register(i.addDisposableListener(d,i.EventType.KEY_UP,_=>v(new n.StandardKeyboardEvent(_))))}oninput(d,v){this._register(i.addDisposableListener(d,i.EventType.INPUT,v))}onblur(d,v){this._register(i.addDisposableListener(d,i.EventType.BLUR,v))}onfocus(d,v){this._register(i.addDisposableListener(d,i.EventType.FOCUS,v))}onchange(d,v){this._register(i.addDisposableListener(d,i.EventType.CHANGE,v))}ignoreGesture(d){return F.Gesture.ignoreTarget(d)}}t.Widget=D}),define(ve[51],De([1,0,71,23,12,22,4]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,I=Ue(I),t.ARROW_IMG_SIZE=11;class D extends n.Widget{constructor(d){super(),this._onActivate=d.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=d.bgWidth+"px",this.bgDomNode.style.height=d.bgHeight+"px",typeof d.top<"u"&&(this.bgDomNode.style.top="0px"),typeof d.left<"u"&&(this.bgDomNode.style.left="0px"),typeof d.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof d.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=d.className,this.domNode.classList.add(...F.ThemeIcon.asClassNameArray(d.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof d.top<"u"&&(this.domNode.style.top=d.top+"px"),typeof d.left<"u"&&(this.domNode.style.left=d.left+"px"),typeof d.bottom<"u"&&(this.domNode.style.bottom=d.bottom+"px"),typeof d.right<"u"&&(this.domNode.style.right=d.right+"px"),this._pointerMoveMonitor=this._register(new i.GlobalPointerMoveMonitor),this._register(I.addStandardDisposableListener(this.bgDomNode,I.EventType.POINTER_DOWN,v=>this._arrowPointerDown(v))),this._register(I.addStandardDisposableListener(this.domNode,I.EventType.POINTER_DOWN,v=>this._arrowPointerDown(v))),this._pointerdownRepeatTimer=this._register(new I.WindowIntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new P.TimeoutTimer)}_arrowPointerDown(d){if(!d.target||!(d.target instanceof Element))return;const v=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24,I.getWindow(d))};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(v,200),this._pointerMoveMonitor.startMonitoring(d.target,d.pointerId,d.buttons,_=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),d.preventDefault()}}t.ScrollbarArrow=D}),define(ve[73],De([1,0,4,55,71,51,114,23,5]),function(oe,t,i,n,P,F,I,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0,i=Ue(i),w=Ue(w);const d=140;class v extends D.Widget{constructor(b){super(),this._lazyRender=b.lazyRender,this._host=b.host,this._scrollable=b.scrollable,this._scrollByPage=b.scrollByPage,this._scrollbarState=b.scrollbarState,this._visibilityController=this._register(new I.ScrollbarVisibilityController(b.visibility,"visible scrollbar "+b.extraScrollbarClassName,"invisible scrollbar "+b.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new P.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,n.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(i.addDisposableListener(this.domNode.domNode,i.EventType.POINTER_DOWN,m=>this._domNodePointerDown(m)))}_createArrow(b){const m=this._register(new F.ScrollbarArrow(b));this.domNode.domNode.appendChild(m.bgDomNode),this.domNode.domNode.appendChild(m.domNode)}_createSlider(b,m,e,s){this.slider=(0,n.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(b),this.slider.setLeft(m),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(i.addDisposableListener(this.slider.domNode,i.EventType.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this._sliderPointerDown(r))})),this.onclick(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}_onElementSize(b){return this._scrollbarState.setVisibleSize(b)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(b){return this._scrollbarState.setScrollSize(b)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(b){return this._scrollbarState.setScrollPosition(b)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(b){b.target===this.domNode.domNode&&this._onPointerDown(b)}delegatePointerDown(b){const m=this.domNode.domNode.getClientRects()[0].top,e=m+this._scrollbarState.getSliderPosition(),s=m+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),r=this._sliderPointerPosition(b);e<=r&&r<=s?b.button===0&&(b.preventDefault(),this._sliderPointerDown(b)):this._onPointerDown(b)}_onPointerDown(b){let m,e;if(b.target===this.domNode.domNode&&typeof b.offsetX=="number"&&typeof b.offsetY=="number")m=b.offsetX,e=b.offsetY;else{const r=i.getDomNodePagePosition(this.domNode.domNode);m=b.pageX-r.left,e=b.pageY-r.top}const s=this._pointerDownRelativePosition(m,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(s):this._scrollbarState.getDesiredScrollPositionFromOffset(s)),b.button===0&&(b.preventDefault(),this._sliderPointerDown(b))}_sliderPointerDown(b){if(!b.target||!(b.target instanceof Element))return;const m=this._sliderPointerPosition(b),e=this._sliderOrthogonalPointerPosition(b),s=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(b.target,b.pointerId,b.buttons,r=>{const c=this._sliderOrthogonalPointerPosition(r),l=Math.abs(c-e);if(w.isWindows&&l>d){this._setDesiredScrollPositionNow(s.getScrollPosition());return}const T=this._sliderPointerPosition(r)-m;this._setDesiredScrollPositionNow(s.getDesiredScrollPositionFromDelta(T))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(b){const m={};this.writeScrollPosition(m,b),this._scrollable.setScrollPositionNow(m)}updateScrollbarSize(b){this._updateScrollbarSize(b),this._scrollbarState.setScrollbarSize(b),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=v}),define(ve[117],De([1,0,19,73,51,56,21,20]),function(oe,t,i,n,P,F,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends n.AbstractScrollbar{constructor(v,_,b){const m=v.getScrollDimensions(),e=v.getCurrentScrollPosition();if(super({lazyRender:_.lazyRender,host:b,scrollbarState:new F.ScrollbarState(_.horizontalHasArrows?_.arrowSize:0,_.horizontal===D.ScrollbarVisibility.Hidden?0:_.horizontalScrollbarSize,_.vertical===D.ScrollbarVisibility.Hidden?0:_.verticalScrollbarSize,m.width,m.scrollWidth,e.scrollLeft),visibility:_.horizontal,extraScrollbarClassName:"horizontal",scrollable:v,scrollByPage:_.scrollByPage}),_.horizontalHasArrows){const s=(_.arrowSize-P.ARROW_IMG_SIZE)/2,r=(_.horizontalScrollbarSize-P.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:I.Codicon.scrollbarButtonLeft,top:r,left:s,bottom:void 0,right:void 0,bgWidth:_.arrowSize,bgHeight:_.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:I.Codicon.scrollbarButtonRight,top:r,left:void 0,bottom:void 0,right:s,bgWidth:_.arrowSize,bgHeight:_.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((_.horizontalScrollbarSize-_.horizontalSliderSize)/2),0,void 0,_.horizontalSliderSize)}_updateSlider(v,_){this.slider.setWidth(v),this.slider.setLeft(_)}_renderDomNode(v,_){this.domNode.setWidth(v),this.domNode.setHeight(_),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(v){return this._shouldRender=this._onElementScrollSize(v.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(v.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(v.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(v,_){return v}_sliderPointerPosition(v){return v.pageX}_sliderOrthogonalPointerPosition(v){return v.pageY}_updateScrollbarSize(v){this.slider.setHeight(v)}writeScrollPosition(v,_){v.scrollLeft=_}updateOptions(v){this.updateScrollbarSize(v.horizontal===D.ScrollbarVisibility.Hidden?0:v.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(v.vertical===D.ScrollbarVisibility.Hidden?0:v.verticalScrollbarSize),this._visibilityController.setVisibility(v.horizontal),this._scrollByPage=v.scrollByPage}}t.HorizontalScrollbar=w}),define(ve[118],De([1,0,19,73,51,56,21,20]),function(oe,t,i,n,P,F,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends n.AbstractScrollbar{constructor(v,_,b){const m=v.getScrollDimensions(),e=v.getCurrentScrollPosition();if(super({lazyRender:_.lazyRender,host:b,scrollbarState:new F.ScrollbarState(_.verticalHasArrows?_.arrowSize:0,_.vertical===D.ScrollbarVisibility.Hidden?0:_.verticalScrollbarSize,0,m.height,m.scrollHeight,e.scrollTop),visibility:_.vertical,extraScrollbarClassName:"vertical",scrollable:v,scrollByPage:_.scrollByPage}),_.verticalHasArrows){const s=(_.arrowSize-P.ARROW_IMG_SIZE)/2,r=(_.verticalScrollbarSize-P.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:I.Codicon.scrollbarButtonUp,top:s,left:r,bottom:void 0,right:void 0,bgWidth:_.verticalScrollbarSize,bgHeight:_.arrowSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:I.Codicon.scrollbarButtonDown,top:void 0,left:r,bottom:s,right:void 0,bgWidth:_.verticalScrollbarSize,bgHeight:_.arrowSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((_.verticalScrollbarSize-_.verticalSliderSize)/2),_.verticalSliderSize,void 0)}_updateSlider(v,_){this.slider.setHeight(v),this.slider.setTop(_)}_renderDomNode(v,_){this.domNode.setWidth(_),this.domNode.setHeight(v),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(v){return this._shouldRender=this._onElementScrollSize(v.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(v.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(v.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(v,_){return _}_sliderPointerPosition(v){return v.pageY}_sliderOrthogonalPointerPosition(v){return v.pageX}_updateScrollbarSize(v){this.slider.setWidth(v)}writeScrollPosition(v,_){v.scrollTop=_}updateOptions(v){this.updateScrollbarSize(v.vertical===D.ScrollbarVisibility.Hidden?0:v.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(v.vertical),this._scrollByPage=v.scrollByPage}}t.VerticalScrollbar=w}),define(ve[119],De([1,0,6,67,50,11,16]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0,t.isEmptyMarkdownString=d,t.isMarkdownString=v,t.markdownStringEqual=_,t.escapeMarkdownSyntaxTokens=b,t.appendEscapedMarkdownCodeBlockFence=m,t.escapeDoubleQuotes=e,t.removeMarkdownEscapes=s,t.parseHrefAndDimensions=r;var D;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(D||(t.MarkdownStringTextNewlineStyle=D={}));class w{constructor(l="",E=!1){if(this.value=l,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=E.isTrusted??void 0,this.supportThemeIcons=E.supportThemeIcons??!1,this.supportHtml=E.supportHtml??!1)}appendText(l,E=D.Paragraph){return this.value+=b(this.supportThemeIcons?(0,n.escapeIcons)(l):l).replace(/([ \t]+)/g,(T,A)=>"&nbsp;".repeat(A.length)).replace(/\>/gm,"\\>").replace(/\n/g,E===D.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,E){return this.value+=`
${m(E,l)}
`,this}appendLink(l,E,T){return this.value+="[",this.value+=this._escape(E,"]"),this.value+="](",this.value+=this._escape(String(l),")"),T&&(this.value+=` "${this._escape(this._escape(T,'"'),")")}"`),this.value+=")",this}_escape(l,E){const T=new RegExp((0,F.escapeRegExpCharacters)(E),"g");return l.replace(T,(A,f)=>l.charAt(f-1)!=="\\"?`\\${A}`:A)}}t.MarkdownString=w;function d(c){return v(c)?!c.value:Array.isArray(c)?c.every(d):!0}function v(c){return c instanceof w?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function _(c,l){return c===l?!0:!c||!l?!1:c.value===l.value&&c.isTrusted===l.isTrusted&&c.supportThemeIcons===l.supportThemeIcons&&c.supportHtml===l.supportHtml&&(c.baseUri===l.baseUri||!!c.baseUri&&!!l.baseUri&&(0,P.isEqual)(I.URI.from(c.baseUri),I.URI.from(l.baseUri)))}function b(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(c,l){const E=c.match(/^`+/gm)?.reduce((A,f)=>A.length>f.length?A:f).length??0,T=E>=3?E+1:3;return[`${"`".repeat(T)}${l}`,c,`${"`".repeat(T)}`].join(`
`)}function e(c){return c.replace(/"/g,"&quot;")}function s(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(c){const l=[],E=c.split("|").map(A=>A.trim());c=E[0];const T=E[1];if(T){const A=/height=(\d+)/.exec(T),f=/width=(\d+)/.exec(T),h=A?A[1]:"",p=f?f[1]:"",S=isFinite(parseInt(p)),U=isFinite(parseInt(h));S&&l.push(`width="${p}"`),U&&l.push(`height="${h}"`)}return{href:c,dimensions:l}}}),define(ve[120],De([1,0,4,111,29,70,15,19,112,6,3,119,67,90,8,25,2,92,68,39,64,50,11,16]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b,m,e,s,r,c,l,E,T,A,f,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.allowedMarkdownAttr=void 0,t.renderMarkdown=S,t.renderStringAsPlaintext=V,t.renderMarkdownAsPlaintext=R,t.fillInIncompleteTokens=ne,i=Ue(i),n=Ue(n);const p=Object.freeze({image:(a,o,g)=>{let k=[],L=[];return a&&({href:a,dimensions:k}=(0,_.parseHrefAndDimensions)(a),L.push(`src="${(0,_.escapeDoubleQuotes)(a)}"`)),g&&L.push(`alt="${(0,_.escapeDoubleQuotes)(g)}"`),o&&L.push(`title="${(0,_.escapeDoubleQuotes)(o)}"`),k.length&&(L=L.concat(k)),"<img "+L.join(" ")+">"},paragraph:a=>`<p>${a}</p>`,link:(a,o,g)=>typeof a!="string"?"":(a===g&&(g=(0,_.removeMarkdownEscapes)(g)),o=typeof o=="string"?(0,_.escapeDoubleQuotes)((0,_.removeMarkdownEscapes)(o)):"",a=(0,_.removeMarkdownEscapes)(a),a=a.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${a}" title="${o||a}" draggable="false">${g}</a>`)});function S(a,o={},g={}){const k=new r.DisposableStore;let L=!1;const u=(0,F.createElement)(o),N=function(Ee){let ye;try{ye=(0,l.parse)(decodeURIComponent(Ee))}catch{}return ye?(ye=(0,T.cloneAndChange)(ye,Ie=>{if(a.uris&&a.uris[Ie])return h.URI.revive(a.uris[Ie])}),encodeURIComponent(JSON.stringify(ye))):Ee},C=function(Ee,ye){const Ie=a.uris&&a.uris[Ee];let de=h.URI.revive(Ie);return ye?Ee.startsWith(E.Schemas.data+":")?Ee:(de||(de=h.URI.parse(Ee)),E.FileAccess.uriToBrowserUri(de).toString(!0)):!de||h.URI.parse(Ee).toString()===de.toString()?Ee:(de.query&&(de=de.with({query:N(de.query)})),de.toString())},M=new c.marked.Renderer;M.image=p.image,M.link=p.link,M.paragraph=p.paragraph;const z=[],X=[];if(o.codeBlockRendererSync?M.code=(Ee,ye)=>{const Ie=m.defaultGenerator.nextId(),de=o.codeBlockRendererSync(U(ye),Ee);return X.push([Ie,de]),`<div class="code" data-code="${Ie}">${(0,f.escape)(Ee)}</div>`}:o.codeBlockRenderer&&(M.code=(Ee,ye)=>{const Ie=m.defaultGenerator.nextId(),de=o.codeBlockRenderer(U(ye),Ee);return z.push(de.then(Fe=>[Ie,Fe])),`<div class="code" data-code="${Ie}">${(0,f.escape)(Ee)}</div>`}),o.actionHandler){const Ee=function(de){let Fe=de.target;if(!(Fe.tagName!=="A"&&(Fe=Fe.parentElement,!Fe||Fe.tagName!=="A")))try{let qe=Fe.dataset.href;qe&&(a.baseUri&&(qe=H(h.URI.from(a.baseUri),qe)),o.actionHandler.callback(qe,de))}catch(qe){(0,d.onUnexpectedError)(qe)}finally{de.preventDefault()}},ye=o.actionHandler.disposables.add(new P.DomEmitter(u,"click")),Ie=o.actionHandler.disposables.add(new P.DomEmitter(u,"auxclick"));o.actionHandler.disposables.add(v.Event.any(ye.event,Ie.event)(de=>{const Fe=new D.StandardMouseEvent(i.getWindow(u),de);!Fe.leftButton&&!Fe.middleButton||Ee(Fe)})),o.actionHandler.disposables.add(i.addDisposableListener(u,"keydown",de=>{const Fe=new I.StandardKeyboardEvent(de);!Fe.equals(e.KeyCode.Space)&&!Fe.equals(e.KeyCode.Enter)||Ee(Fe)}))}a.supportHtml||(g.sanitizer=Ee=>o.sanitizerOptions?.replaceWithPlaintext?(0,f.escape)(Ee):(a.isTrusted?Ee.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?Ee:"",g.sanitize=!0,g.silent=!0),g.renderer=M;let ie=a.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`),a.supportThemeIcons&&(ie=(0,b.markdownEscapeEscapedIcons)(ie));let re;if(o.fillInIncompleteTokens){const Ee={...c.marked.defaults,...g},ye=c.marked.lexer(ie,Ee),Ie=ne(ye);re=c.marked.parser(Ie,Ee)}else re=c.marked.parse(ie,g);a.supportThemeIcons&&(re=(0,w.renderLabelWithIcons)(re).map(ye=>typeof ye=="string"?ye:ye.outerHTML).join(""));const we=new DOMParser().parseFromString(y({isTrusted:a.isTrusted,...o.sanitizerOptions},re),"text/html");if(we.body.querySelectorAll("img, audio, video, source").forEach(Ee=>{const ye=Ee.getAttribute("src");if(ye){let Ie=ye;try{a.baseUri&&(Ie=H(h.URI.from(a.baseUri),Ie))}catch{}if(Ee.setAttribute("src",C(Ie,!0)),o.remoteImageIsAllowed){const de=h.URI.parse(Ie);de.scheme!==E.Schemas.file&&de.scheme!==E.Schemas.data&&!o.remoteImageIsAllowed(de)&&Ee.replaceWith(i.$("",void 0,Ee.outerHTML))}}}),we.body.querySelectorAll("a").forEach(Ee=>{const ye=Ee.getAttribute("href");if(Ee.setAttribute("href",""),!ye||/^data:|javascript:/i.test(ye)||/^command:/i.test(ye)&&!a.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(ye))Ee.replaceWith(...Ee.childNodes);else{let Ie=C(ye,!1);a.baseUri&&(Ie=H(h.URI.from(a.baseUri),ye)),Ee.dataset.href=Ie}}),u.innerHTML=y({isTrusted:a.isTrusted,...o.sanitizerOptions},we.body.innerHTML),z.length>0)Promise.all(z).then(Ee=>{if(L)return;const ye=new Map(Ee),Ie=u.querySelectorAll("div[data-code]");for(const de of Ie){const Fe=ye.get(de.dataset.code??"");Fe&&i.reset(de,Fe)}o.asyncRenderCallback?.()});else if(X.length>0){const Ee=new Map(X),ye=u.querySelectorAll("div[data-code]");for(const Ie of ye){const de=Ee.get(Ie.dataset.code??"");de&&i.reset(Ie,de)}}if(o.asyncRenderCallback)for(const Ee of u.getElementsByTagName("img")){const ye=k.add(i.addDisposableListener(Ee,"load",()=>{ye.dispose(),o.asyncRenderCallback()}))}return{element:u,dispose:()=>{L=!0,k.dispose()}}}function U(a){if(!a)return"";const o=a.split(/[\s+|:|,|\{|\?]/,1);return o.length?o[0]:a}function H(a,o){return/^\w[\w\d+.-]*:/.test(o)?o:a.path.endsWith("/")?(0,A.resolvePath)(a,o).toString():(0,A.resolvePath)((0,A.dirname)(a),o).toString()}const x=["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"];function y(a,o){const{config:g,allowedSchemes:k}=O(a),L=new r.DisposableStore;L.add(B("uponSanitizeAttribute",(u,N)=>{if(N.attrName==="style"||N.attrName==="class"){if(u.tagName==="SPAN"){if(N.attrName==="style"){N.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(border-radius:[0-9]+px;)?$/.test(N.attrValue);return}else if(N.attrName==="class"){N.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(N.attrValue);return}}N.keepAttr=!1;return}else if(u.tagName==="INPUT"&&u.attributes.getNamedItem("type")?.value==="checkbox"){if(N.attrName==="type"&&N.attrValue==="checkbox"||N.attrName==="disabled"||N.attrName==="checked"){N.keepAttr=!0;return}N.keepAttr=!1}})),L.add(B("uponSanitizeElement",(u,N)=>{if(N.tagName==="input"&&(u.attributes.getNamedItem("type")?.value==="checkbox"?u.setAttribute("disabled",""):a.replaceWithPlaintext||u.remove()),a.replaceWithPlaintext&&!N.allowedTags[N.tagName]&&N.tagName!=="body"&&u.parentElement){let C,M;if(N.tagName==="#comment")C=`<!--${u.textContent}-->`;else{const re=x.includes(N.tagName),ce=u.attributes.length?" "+Array.from(u.attributes).map(we=>`${we.name}="${we.value}"`).join(" "):"";C=`<${N.tagName}${ce}>`,re||(M=`</${N.tagName}>`)}const z=document.createDocumentFragment(),X=u.parentElement.ownerDocument.createTextNode(C);z.appendChild(X);const ie=M?u.parentElement.ownerDocument.createTextNode(M):void 0;for(;u.firstChild;)z.appendChild(u.firstChild);ie&&z.appendChild(ie),u.parentElement.replaceChild(z,u)}})),L.add(i.hookDomPurifyHrefAndSrcSanitizer(k));try{return n.sanitize(o,{...g,RETURN_TRUSTED_TYPE:!0})}finally{L.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","checked","class","colspan","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","rowspan","src","style","target","title","type","width","start"];function O(a){const o=[E.Schemas.http,E.Schemas.https,E.Schemas.mailto,E.Schemas.data,E.Schemas.file,E.Schemas.vscodeFileResource,E.Schemas.vscodeRemote,E.Schemas.vscodeRemoteResource];return a.isTrusted&&o.push(E.Schemas.command),{config:{ALLOWED_TAGS:a.allowedTags??[...i.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:o}}function V(a){return typeof a=="string"?a:R(a)}function R(a,o){let g=a.value??"";g.length>1e5&&(g=`${g.substr(0,1e5)}\u2026`);const k=c.marked.parse(g,{renderer:o?j.value:Q.value}).replace(/&(#\d+|[a-zA-Z]+);/g,L=>W.get(L)??L);return y({isTrusted:!1},k).toString()}const W=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]);function G(){const a=new c.marked.Renderer;return a.code=o=>o,a.blockquote=o=>o,a.html=o=>"",a.heading=(o,g,k)=>o+`
`,a.hr=()=>"",a.list=(o,g)=>o,a.listitem=o=>o+`
`,a.paragraph=o=>o+`
`,a.table=(o,g)=>o+g+`
`,a.tablerow=o=>o,a.tablecell=(o,g)=>o+" ",a.strong=o=>o,a.em=o=>o,a.codespan=o=>o,a.br=()=>`
`,a.del=o=>o,a.image=(o,g,k)=>"",a.text=o=>o,a.link=(o,g,k)=>k,a}const Q=new s.Lazy(a=>G()),j=new s.Lazy(()=>{const a=G();return a.code=o=>`
\`\`\`
${o}
\`\`\`
`,a});function q(a){let o="";return a.forEach(g=>{o+=g.raw}),o}function J(a){if(a.tokens)for(let o=a.tokens.length-1;o>=0;o--){const g=a.tokens[o];if(g.type==="text"){const k=g.raw.split(`
`),L=k[k.length-1];if(L.includes("`"))return ae(a);if(L.includes("**"))return Re(a);if(L.match(/\*\w/))return Le(a);if(L.match(/(^|\s)__\w/))return xe(a);if(L.match(/(^|\s)_\w/))return te(a);if(le(L)||me(L)&&a.tokens.slice(0,o).some(u=>u.type==="text"&&u.raw.match(/\[[^\]]*$/))){const u=a.tokens.slice(o+1);return u[0]?.type==="link"&&u[1]?.type==="text"&&u[1].raw.match(/^ *"[^"]*$/)||L.match(/^[^"]* +"[^"]*$/)?Ae(a):pe(a)}else if(L.match(/(^|\s)\[\w*/))return Ce(a)}}}function le(a){return!!a.match(/(^|\s)\[.*\]\(\w*/)}function me(a){return!!a.match(/^[^\[]*\]\([^\)]*$/)}function _e(a){const o=a.items[a.items.length-1],g=o.tokens?o.tokens[o.tokens.length-1]:void 0;let k;if(g?.type==="text"&&!("inRawBlock"in o)&&(k=J(g)),!k||k.type!=="paragraph")return;const L=q(a.items.slice(0,-1)),u=o.raw.match(/^(\s*(-|\d+\.|\*) +)/)?.[0];if(!u)return;const N=u+q(o.tokens.slice(0,-1))+k.raw,C=c.marked.lexer(L+N)[0];if(C.type==="list")return C}const Ne=3;function ne(a){for(let o=0;o<Ne;o++){const g=ee(a);if(g)a=g;else break}return a}function ee(a){let o,g;for(o=0;o<a.length;o++){const k=a[o];let L;if(k.type==="paragraph"&&(L=k.raw.match(/(\n|^)(````*)/))){const u=L[2];g=he(a.slice(o),u);break}if(k.type==="paragraph"&&k.raw.match(/(\n|^)\|/)){g=$(a.slice(o));break}if(o===a.length-1&&k.type==="list"){const u=_e(k);if(u){g=[u];break}}if(o===a.length-1&&k.type==="paragraph"){const u=J(k);if(u){g=[u];break}}}if(g){const k=[...a.slice(0,o),...g];return k.links=a.links,k}return null}function he(a,o){const g=q(a);return c.marked.lexer(g+`
${o}`)}function ae(a){return He(a,"`")}function Le(a){return He(a,"*")}function te(a){return He(a,"_")}function pe(a){return He(a,")")}function Ae(a){return He(a,'")')}function Ce(a){return He(a,"](https://microsoft.com)")}function Re(a){return He(a,"**")}function xe(a){return He(a,"__")}function He(a,o){const g=q(Array.isArray(a)?a:[a]);return c.marked.lexer(g+o)[0]}function $(a){const o=q(a),g=o.split(`
`);let k,L=!1;for(let u=0;u<g.length;u++){const N=g[u].trim();if(typeof k>"u"&&N.match(/^\s*\|/)){const C=N.match(/(\|[^\|]+)(?=\||$)/g);C&&(k=C.length)}else if(typeof k=="number")if(N.match(/^\s*\|/)){if(u!==g.length-1)return;L=!0}else return}if(typeof k=="number"&&k>0){const u=L?g.slice(0,-1).join(`
`):o,N=!!u.match(/\|\s*$/),C=u+(N?"":"|")+`
|${" --- |".repeat(k)}`;return c.marked.lexer(C)}}function B(a,o){return n.addHook(a,o),(0,r.toDisposable)(()=>n.removeHook(a))}}),define(ve[121],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ve[74],De([1,0,9,12,47,38,35,6,3,2,68,11,10]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.BufferWriter=t.BufferReader=void 0,t.serialize=H,t.deserialize=x,t.getDelayedChannel=G,t.getNextTickChannel=Q,_=Ue(_);var m;(function(ne){ne[ne.Promise=100]="Promise",ne[ne.PromiseCancel=101]="PromiseCancel",ne[ne.EventListen=102]="EventListen",ne[ne.EventDispose=103]="EventDispose"})(m||(m={}));function e(ne){switch(ne){case m.Promise:return"req";case m.PromiseCancel:return"cancel";case m.EventListen:return"subscribe";case m.EventDispose:return"unsubscribe"}}var s;(function(ne){ne[ne.Initialize=200]="Initialize",ne[ne.PromiseSuccess=201]="PromiseSuccess",ne[ne.PromiseError=202]="PromiseError",ne[ne.PromiseErrorObj=203]="PromiseErrorObj",ne[ne.EventFire=204]="EventFire"})(s||(s={}));function r(ne){switch(ne){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var c;(function(ne){ne[ne.Uninitialized=0]="Uninitialized",ne[ne.Idle=1]="Idle"})(c||(c={}));function l(ne){let ee=0;for(let he=0;;he+=7){const ae=ne.read(1);if(ee|=(ae.buffer[0]&127)<<he,!(ae.buffer[0]&128))return ee}}const E=p(0);function T(ne,ee){if(ee===0){ne.write(E);return}let he=0;for(let Le=ee;Le!==0;Le=Le>>>7)he++;const ae=P.VSBuffer.alloc(he);for(let Le=0;ee!==0;Le++)ae.buffer[Le]=ee&127,ee=ee>>>7,ee>0&&(ae.buffer[Le]|=128);ne.write(ae)}class A{constructor(ee){this.buffer=ee,this.pos=0}read(ee){const he=this.buffer.slice(this.pos,this.pos+ee);return this.pos+=he.byteLength,he}}t.BufferReader=A;class f{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(ee){this.buffers.push(ee)}}t.BufferWriter=f;var h;(function(ne){ne[ne.Undefined=0]="Undefined",ne[ne.String=1]="String",ne[ne.Buffer=2]="Buffer",ne[ne.VSBuffer=3]="VSBuffer",ne[ne.Array=4]="Array",ne[ne.Object=5]="Object",ne[ne.Int=6]="Int"})(h||(h={}));function p(ne){const ee=P.VSBuffer.alloc(1);return ee.writeUInt8(ne,0),ee}const S={Undefined:p(h.Undefined),String:p(h.String),Buffer:p(h.Buffer),VSBuffer:p(h.VSBuffer),Array:p(h.Array),Object:p(h.Object),Uint:p(h.Int)},U=typeof Buffer<"u";function H(ne,ee){if(typeof ee>"u")ne.write(S.Undefined);else if(typeof ee=="string"){const he=P.VSBuffer.fromString(ee);ne.write(S.String),T(ne,he.byteLength),ne.write(he)}else if(U&&Buffer.isBuffer(ee)){const he=P.VSBuffer.wrap(ee);ne.write(S.Buffer),T(ne,he.byteLength),ne.write(he)}else if(ee instanceof P.VSBuffer)ne.write(S.VSBuffer),T(ne,ee.byteLength),ne.write(ee);else if(Array.isArray(ee)){ne.write(S.Array),T(ne,ee.length);for(const he of ee)H(ne,he)}else if(typeof ee=="number"&&(ee|0)===ee)ne.write(S.Uint),T(ne,ee);else{const he=P.VSBuffer.fromString(JSON.stringify(ee));ne.write(S.Object),T(ne,he.byteLength),ne.write(he)}}function x(ne){switch(ne.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return ne.read(l(ne)).toString();case h.Buffer:return ne.read(l(ne)).buffer;case h.VSBuffer:return ne.read(l(ne));case h.Array:{const he=l(ne),ae=[];for(let Le=0;Le<he;Le++)ae.push(x(ne));return ae}case h.Object:return JSON.parse(ne.read(l(ne)).toString());case h.Int:return l(ne)}}class y{constructor(ee,he,ae=null,Le=1e3){this.protocol=ee,this.ctx=he,this.logger=ae,this.timeoutDelay=Le,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(te=>this.onRawMessage(te)),this.sendResponse({type:s.Initialize})}registerChannel(ee,he){this.channels.set(ee,he),setTimeout(()=>this.flushPendingRequests(ee),0)}sendResponse(ee){switch(ee.type){case s.Initialize:{const he=this.send([ee.type]);this.logger?.logOutgoing(he,0,O.OtherSide,r(ee.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const he=this.send([ee.type,ee.id],ee.data);this.logger?.logOutgoing(he,ee.id,O.OtherSide,r(ee.type),ee.data);return}}}send(ee,he=void 0){const ae=new f;return H(ae,ee),H(ae,he),this.sendBuffer(ae.buffer)}sendBuffer(ee){try{return this.protocol.send(ee),ee.byteLength}catch{return 0}}onRawMessage(ee){const he=new A(ee),ae=x(he),Le=x(he),te=ae[0];switch(te){case m.Promise:return this.logger?.logIncoming(ee.byteLength,ae[1],O.OtherSide,`${e(te)}: ${ae[2]}.${ae[3]}`,Le),this.onPromise({type:te,id:ae[1],channelName:ae[2],name:ae[3],arg:Le});case m.EventListen:return this.logger?.logIncoming(ee.byteLength,ae[1],O.OtherSide,`${e(te)}: ${ae[2]}.${ae[3]}`,Le),this.onEventListen({type:te,id:ae[1],channelName:ae[2],name:ae[3],arg:Le});case m.PromiseCancel:return this.logger?.logIncoming(ee.byteLength,ae[1],O.OtherSide,`${e(te)}`),this.disposeActiveRequest({type:te,id:ae[1]});case m.EventDispose:return this.logger?.logIncoming(ee.byteLength,ae[1],O.OtherSide,`${e(te)}`),this.disposeActiveRequest({type:te,id:ae[1]})}}onPromise(ee){const he=this.channels.get(ee.channelName);if(!he){this.collectPendingRequest(ee);return}const ae=new F.CancellationTokenSource;let Le;try{Le=he.call(this.ctx,ee.name,ee.arg,ae.token)}catch(Ae){Le=Promise.reject(Ae)}const te=ee.id;Le.then(Ae=>{this.sendResponse({id:te,data:Ae,type:s.PromiseSuccess})},Ae=>{Ae instanceof Error?this.sendResponse({id:te,data:{message:Ae.message,name:Ae.name,stack:Ae.stack?Ae.stack.split(`
`):void 0},type:s.PromiseError}):this.sendResponse({id:te,data:Ae,type:s.PromiseErrorObj})}).finally(()=>{pe.dispose(),this.activeRequests.delete(ee.id)});const pe=(0,d.toDisposable)(()=>ae.cancel());this.activeRequests.set(ee.id,pe)}onEventListen(ee){const he=this.channels.get(ee.channelName);if(!he){this.collectPendingRequest(ee);return}const ae=ee.id,te=he.listen(this.ctx,ee.name,ee.arg)(pe=>this.sendResponse({id:ae,data:pe,type:s.EventFire}));this.activeRequests.set(ee.id,te)}disposeActiveRequest(ee){const he=this.activeRequests.get(ee.id);he&&(he.dispose(),this.activeRequests.delete(ee.id))}collectPendingRequest(ee){let he=this.pendingRequests.get(ee.channelName);he||(he=[],this.pendingRequests.set(ee.channelName,he));const ae=setTimeout(()=>{console.error(`Unknown channel: ${ee.channelName}`),ee.type===m.Promise&&this.sendResponse({id:ee.id,data:{name:"Unknown channel",message:`Channel name '${ee.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:s.PromiseError})},this.timeoutDelay);he.push({request:ee,timeoutTimer:ae})}flushPendingRequests(ee){const he=this.pendingRequests.get(ee);if(he){for(const ae of he)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case m.Promise:this.onPromise(ae.request);break;case m.EventListen:this.onEventListen(ae.request);break}this.pendingRequests.delete(ee)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=y;var O;(function(ne){ne[ne.LocalSide=0]="LocalSide",ne[ne.OtherSide=1]="OtherSide"})(O||(t.RequestInitiator=O={}));class V{constructor(ee,he=null){this.protocol=ee,this.isDisposed=!1,this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ae=>this.onBuffer(ae)),this.logger=he}getChannel(ee){const he=this;return{call(ae,Le,te){return he.isDisposed?Promise.reject(new D.CancellationError):he.requestPromise(ee,ae,Le,te)},listen(ae,Le){return he.isDisposed?w.Event.None:he.requestEvent(ee,ae,Le)}}}requestPromise(ee,he,ae,Le=F.CancellationToken.None){const te=this.lastRequestId++,pe=m.Promise,Ae={id:te,type:pe,channelName:ee,name:he,arg:ae};if(Le.isCancellationRequested)return Promise.reject(new D.CancellationError);let Ce;return new Promise((xe,He)=>{if(Le.isCancellationRequested)return He(new D.CancellationError);const $=()=>{const g=k=>{switch(k.type){case s.PromiseSuccess:this.handlers.delete(te),xe(k.data);break;case s.PromiseError:{this.handlers.delete(te);const L=new Error(k.data.message);L.stack=Array.isArray(k.data.stack)?k.data.stack.join(`
`):k.data.stack,L.name=k.data.name,He(L);break}case s.PromiseErrorObj:this.handlers.delete(te),He(k.data);break}};this.handlers.set(te,g),this.sendRequest(Ae)};let B=null;this.state===c.Idle?$():(B=(0,n.createCancelablePromise)(g=>this.whenInitialized()),B.then(()=>{B=null,$()}));const a=()=>{B?(B.cancel(),B=null):this.sendRequest({id:te,type:m.PromiseCancel}),He(new D.CancellationError)},o=Le.onCancellationRequested(a);Ce=(0,d.combinedDisposable)((0,d.toDisposable)(a),o),this.activeRequests.add(Ce)}).finally(()=>{Ce.dispose(),this.activeRequests.delete(Ce)})}requestEvent(ee,he,ae){const Le=this.lastRequestId++,te=m.EventListen,pe={id:Le,type:te,channelName:ee,name:he,arg:ae};let Ae=null;const Ce=new w.Emitter({onWillAddFirstListener:()=>{Ae=(0,n.createCancelablePromise)(xe=>this.whenInitialized()),Ae.then(()=>{Ae=null,this.activeRequests.add(Ce),this.sendRequest(pe)})},onDidRemoveLastListener:()=>{Ae?(Ae.cancel(),Ae=null):(this.activeRequests.delete(Ce),this.sendRequest({id:Le,type:m.EventDispose}))}}),Re=xe=>Ce.fire(xe.data);return this.handlers.set(Le,Re),Ce.event}sendRequest(ee){switch(ee.type){case m.Promise:case m.EventListen:{const he=this.send([ee.type,ee.id,ee.channelName,ee.name],ee.arg);this.logger?.logOutgoing(he,ee.id,O.LocalSide,`${e(ee.type)}: ${ee.channelName}.${ee.name}`,ee.arg);return}case m.PromiseCancel:case m.EventDispose:{const he=this.send([ee.type,ee.id]);this.logger?.logOutgoing(he,ee.id,O.LocalSide,e(ee.type));return}}}send(ee,he=void 0){const ae=new f;return H(ae,ee),H(ae,he),this.sendBuffer(ae.buffer)}sendBuffer(ee){try{return this.protocol.send(ee),ee.byteLength}catch{return 0}}onBuffer(ee){const he=new A(ee),ae=x(he),Le=x(he),te=ae[0];switch(te){case s.Initialize:return this.logger?.logIncoming(ee.byteLength,0,O.LocalSide,r(te)),this.onResponse({type:ae[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.logger?.logIncoming(ee.byteLength,ae[1],O.LocalSide,r(te),Le),this.onResponse({type:ae[0],id:ae[1],data:Le})}}onResponse(ee){if(ee.type===s.Initialize){this.state=c.Idle,this._onDidInitialize.fire();return}this.handlers.get(ee.id)?.(ee)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=V,et([I.memoize],V.prototype,"onDidInitializePromise",null);class R{get connections(){const ee=[];return this._connections.forEach(he=>ee.push(he)),ee}constructor(ee,he,ae){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new d.DisposableStore,this.disposables.add(ee(({protocol:Le,onDidClientDisconnect:te})=>{const pe=w.Event.once(Le.onMessage);this.disposables.add(pe(Ae=>{const Ce=new A(Ae),Re=x(Ce),xe=new y(Le,Re,he,ae),He=new V(Le,he);this.channels.forEach((B,a)=>xe.registerChannel(a,B));const $={channelServer:xe,channelClient:He,ctx:Re};this._connections.add($),this._onDidAddConnection.fire($),this.disposables.add(te(()=>{xe.dispose(),He.dispose(),this._connections.delete($),this._onDidRemoveConnection.fire($)}))}))}))}getChannel(ee,he){const ae=this;return{call(Le,te,pe){let Ae;if((0,b.isFunction)(he)){const Re=(0,i.getRandomElement)(ae.connections.filter(he));Ae=Re?Promise.resolve(Re):w.Event.toPromise(w.Event.filter(ae.onDidAddConnection,he))}else Ae=he.routeCall(ae,Le,te);const Ce=Ae.then(Re=>Re.channelClient.getChannel(ee));return G(Ce).call(Le,te,pe)},listen(Le,te){if((0,b.isFunction)(he))return ae.getMulticastEvent(ee,he,Le,te);const pe=he.routeEvent(ae,Le,te).then(Ae=>Ae.channelClient.getChannel(ee));return G(pe).listen(Le,te)}}}getMulticastEvent(ee,he,ae,Le){const te=this;let pe;const Ae=new w.Emitter({onWillAddFirstListener:()=>{pe=new d.DisposableStore;const Ce=new w.EventMultiplexer,Re=new Map,xe=$=>{const a=$.channelClient.getChannel(ee).listen(ae,Le),o=Ce.add(a);Re.set($,o)},He=$=>{const B=Re.get($);B&&(B.dispose(),Re.delete($))};te.connections.filter(he).forEach(xe),w.Event.filter(te.onDidAddConnection,he)(xe,void 0,pe),te.onDidRemoveConnection(He,void 0,pe),Ce.event(Ae.fire,Ae,pe),pe.add(Ce)},onDidRemoveLastListener:()=>{pe?.dispose(),pe=void 0}});return Ae.event}registerChannel(ee,he){this.channels.set(ee,he);for(const ae of this._connections)ae.channelServer.registerChannel(ee,he)}dispose(){this.disposables.dispose();for(const ee of this._connections)ee.channelClient.dispose(),ee.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=R;class W{constructor(ee,he,ae=null){const Le=new f;H(Le,he),ee.send(Le.buffer),this.channelClient=new V(ee,ae),this.channelServer=new y(ee,he,ae)}getChannel(ee){return this.channelClient.getChannel(ee)}registerChannel(ee,he){this.channelServer.registerChannel(ee,he)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=W;function G(ne){return{call(ee,he,ae){return ne.then(Le=>Le.call(ee,he,ae))},listen(ee,he){const ae=new w.Relay;return ne.then(Le=>ae.input=Le.listen(ee,he)),ae.event}}}function Q(ne){let ee=!1;return{call(he,ae,Le){return ee?ne.call(he,ae,Le):(0,n.timeout)(0).then(()=>ee=!0).then(()=>ne.call(he,ae,Le))},listen(he,ae){if(ee)return ne.listen(he,ae);const Le=new w.Relay;return(0,n.timeout)(0).then(()=>ee=!0).then(()=>Le.input=ne.listen(he,ae)),Le.event}}}class j{constructor(ee){this.fn=ee}routeCall(ee){return this.route(ee)}routeEvent(ee){return this.route(ee)}async route(ee){for(const he of ee.connections)if(await Promise.resolve(this.fn(he.ctx)))return Promise.resolve(he);return await w.Event.toPromise(ee.onDidAddConnection),await this.route(ee)}}t.StaticRouter=j;var q;(function(ne){function ee(te,pe,Ae){const Ce=te,Re=Ae&&Ae.disableMarshalling,xe=new Map;for(const He in Ce)ae(He)&&xe.set(He,w.Event.buffer(Ce[He],!0,void 0,pe));return new class{listen(He,$,B){const a=xe.get($);if(a)return a;const o=Ce[$];if(typeof o=="function"){if(Le($))return o.call(Ce,B);if(ae($))return xe.set($,w.Event.buffer(Ce[$],!0,void 0,pe)),xe.get($)}throw new D.ErrorNoTelemetry(`Event not found: ${$}`)}call(He,$,B){const a=Ce[$];if(typeof a=="function"){if(!Re&&Array.isArray(B))for(let g=0;g<B.length;g++)B[g]=(0,v.revive)(B[g]);let o=a.apply(Ce,B);return o instanceof Promise||(o=Promise.resolve(o)),o}throw new D.ErrorNoTelemetry(`Method not found: ${$}`)}}}ne.fromService=ee;function he(te,pe){const Ae=pe&&pe.disableMarshalling;return new Proxy({},{get(Ce,Re){if(typeof Re=="string")return pe?.properties?.has(Re)?pe.properties.get(Re):Le(Re)?function(xe){return te.listen(Re,xe)}:ae(Re)?te.listen(Re):async function(...xe){let He;pe&&!(0,b.isUndefinedOrNull)(pe.context)?He=[pe.context,...xe]:He=xe;const $=await te.call(Re,He);return Ae?$:(0,v.revive)($)};throw new D.ErrorNoTelemetry(`Property not found: ${String(Re)}`)}})}ne.toService=he;function ae(te){return te[0]==="o"&&te[1]==="n"&&_.isUpperAsciiLetter(te.charCodeAt(2))}function Le(te){return/^onDynamic/.test(te)&&_.isUpperAsciiLetter(te.charCodeAt(9))}})(q||(t.ProxyChannel=q={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(ne){if(Array.isArray(ne))return ne;if(ne&&typeof ne=="object"&&typeof ne.toString=="function"){const ee=ne.toString();if(ee!=="[object Object]")return ee}return ne}function me(ne){return Array.isArray(ne)?ne.map(le):le(ne)}function _e(ne,ee,he,ae,Le,te,pe){pe=me(pe);const Ae=J[Le],Ce=Ae[ae%Ae.length];let Re=[`%c[${ne}]%c[${String(ee).padStart(7," ")}]%c[len: ${String(he).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(te)?(Re=Re.concat(pe),Re.push(")")):Re.push(pe),console.log.apply(console,Re)}class Ne{constructor(ee,he){this._outgoingPrefix=ee,this._incomingPrefix=he,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(ee,he,ae,Le,te){this._totalOutgoing+=ee,_e(this._outgoingPrefix,this._totalOutgoing,ee,he,ae,Le,te)}logIncoming(ee,he,ae,Le,te){this._totalIncoming+=ee,_e(this._incomingPrefix,this._totalIncoming,ee,he,ae,Le,te)}}t.IPCLogger=Ne}),define(ve[122],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class i{constructor(P,F){this.sender=P,this.onMessage=F}send(P){try{this.sender.send("vscode:message",P.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=i}),define(ve[40],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.webUtils=t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0;const i=globalThis.vscode;t.ipcRenderer=i.ipcRenderer,t.ipcMessagePort=i.ipcMessagePort,t.webFrame=i.webFrame,t.process=i.process,t.context=i.context,t.webUtils=i.webUtils}),define(ve[123],De([1,0,121,40]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=F;let P=0;function F(D,w,d){const v=[],_=P++,b=`vscode:onContextMenu${_}`,m=(e,s,r)=>{v[s].click?.(r)};n.ipcRenderer.once(b,m),n.ipcRenderer.once(i.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===_&&(n.ipcRenderer.removeListener(b,m),d?.())}),n.ipcRenderer.send(i.CONTEXT_MENU_CHANNEL,_,D.map(e=>I(e,v)),b,w)}function I(D,w){const d={id:w.length,label:D.label,type:D.type,accelerator:D.accelerator,checked:D.checked,enabled:typeof D.enabled=="boolean"?D.enabled:!0,visible:typeof D.visible=="boolean"?D.visible:!0};return w.push(D),Array.isArray(D.submenu)&&(d.submenu=D.submenu.map(v=>I(v,w))),d}}),define(ve[124],De([1,0,47,3,74,122,40]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class D extends P.IPCClient{static createProtocol(){const d=n.Event.fromNodeEventEmitter(I.ipcRenderer,"vscode:message",(v,_)=>i.VSBuffer.wrap(_));return I.ipcRenderer.send("vscode:hello"),new F.Protocol(I.ipcRenderer,d)}constructor(d){const v=D.createProtocol();super(v,d),this.protocol=v}dispose(){this.protocol.disconnect(),super.dispose()}}t.Client=D}),define(ve[75],De([7]),{}),define(ve[125],De([7]),{}),define(ve[76],De([1,0,4,125]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setARIAContainer=d,t.alert=v,t.status=_,i=Ue(i);const n=2e4;let P,F,I,D,w;function d(m){P=document.createElement("div"),P.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),P.appendChild(r),r};F=e(),I=e();const s=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),P.appendChild(r),r};D=s(),w=s(),m.appendChild(P)}function v(m){P&&(F.textContent!==m?(i.clearNode(I),b(F,m)):(i.clearNode(F),b(I,m)))}function _(m){P&&(D.textContent!==m?(i.clearNode(w),b(D,m)):(i.clearNode(D),b(w,m)))}function b(m,e){i.clearNode(m),e.length>n&&(e=e.substr(0,n)),m.textContent=e,m.style.visibility="hidden",m.style.visibility="visible"}}),define(ve[126],De([7]),{}),define(ve[127],De([7]),{}),define(ve[128],De([1,0,126,127]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ve[129],De([7]),{}),define(ve[77],De([1,0,61,4,2,5,46,129]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ContextView=t.LayoutAnchorMode=t.LayoutAnchorPosition=t.AnchorAxisAlignment=t.AnchorPosition=t.AnchorAlignment=t.ContextViewDOMPosition=void 0,t.isAnchor=w,t.layout=e,n=Ue(n),F=Ue(F);var D;(function(c){c[c.ABSOLUTE=1]="ABSOLUTE",c[c.FIXED=2]="FIXED",c[c.FIXED_SHADOW=3]="FIXED_SHADOW"})(D||(t.ContextViewDOMPosition=D={}));function w(c){const l=c;return!!l&&typeof l.x=="number"&&typeof l.y=="number"}var d;(function(c){c[c.LEFT=0]="LEFT",c[c.RIGHT=1]="RIGHT"})(d||(t.AnchorAlignment=d={}));var v;(function(c){c[c.BELOW=0]="BELOW",c[c.ABOVE=1]="ABOVE"})(v||(t.AnchorPosition=v={}));var _;(function(c){c[c.VERTICAL=0]="VERTICAL",c[c.HORIZONTAL=1]="HORIZONTAL"})(_||(t.AnchorAxisAlignment=_={}));var b;(function(c){c[c.Before=0]="Before",c[c.After=1]="After"})(b||(t.LayoutAnchorPosition=b={}));var m;(function(c){c[c.AVOID=0]="AVOID",c[c.ALIGN=1]="ALIGN"})(m||(t.LayoutAnchorMode=m={}));function e(c,l,E){const T=E.mode===m.ALIGN?E.offset:E.offset+E.size,A=E.mode===m.ALIGN?E.offset+E.size:E.offset;return E.position===b.Before?l<=c-T?T:l<=A?A-l:Math.max(c-l,0):l<=A?A-l:l<=c-T?T:0}class s extends P.Disposable{static{this.BUBBLE_UP_EVENTS=["click","keydown","focus","blur"]}static{this.BUBBLE_DOWN_EVENTS=["click"]}constructor(l,E){super(),this.container=null,this.useFixedPosition=!1,this.useShadowDOM=!1,this.delegate=null,this.toDisposeOnClean=P.Disposable.None,this.toDisposeOnSetContainer=P.Disposable.None,this.shadowRoot=null,this.shadowRootHostElement=null,this.view=n.$(".context-view"),n.hide(this.view),this.setContainer(l,E),this._register((0,P.toDisposable)(()=>this.setContainer(null,D.ABSOLUTE)))}setContainer(l,E){this.useFixedPosition=E!==D.ABSOLUTE;const T=this.useShadowDOM;if(this.useShadowDOM=E===D.FIXED_SHADOW,!(l===this.container&&T===this.useShadowDOM)&&(this.container&&(this.toDisposeOnSetContainer.dispose(),this.view.remove(),this.shadowRoot&&(this.shadowRoot=null,this.shadowRootHostElement?.remove(),this.shadowRootHostElement=null),this.container=null),l)){if(this.container=l,this.useShadowDOM){this.shadowRootHostElement=n.$(".shadow-root-host"),this.container.appendChild(this.shadowRootHostElement),this.shadowRoot=this.shadowRootHostElement.attachShadow({mode:"open"});const f=document.createElement("style");f.textContent=r,this.shadowRoot.appendChild(f),this.shadowRoot.appendChild(this.view),this.shadowRoot.appendChild(n.$("slot"))}else this.container.appendChild(this.view);const A=new P.DisposableStore;s.BUBBLE_UP_EVENTS.forEach(f=>{A.add(n.addStandardDisposableListener(this.container,f,h=>{this.onDOMEvent(h,!1)}))}),s.BUBBLE_DOWN_EVENTS.forEach(f=>{A.add(n.addStandardDisposableListener(this.container,f,h=>{this.onDOMEvent(h,!0)},!0))}),this.toDisposeOnSetContainer=A}}show(l){this.isVisible()&&this.hide(),n.clearNode(this.view),this.view.className="context-view monaco-component",this.view.style.top="0px",this.view.style.left="0px",this.view.style.zIndex=`${2575+(l.layer??0)}`,this.view.style.position=this.useFixedPosition?"fixed":"absolute",n.show(this.view),this.toDisposeOnClean=l.render(this.view)||P.Disposable.None,this.delegate=l,this.doLayout(),this.delegate.focus?.()}getViewElement(){return this.view}layout(){if(this.isVisible()){if(this.delegate.canRelayout===!1&&!(F.isIOS&&i.BrowserFeatures.pointerEvents)){this.hide();return}this.delegate?.layout?.(),this.doLayout()}}doLayout(){if(!this.isVisible())return;const l=this.delegate.getAnchor();let E;if(n.isHTMLElement(l)){const y=n.getDomNodePagePosition(l),O=n.getDomNodeZoomLevel(l);E={top:y.top*O,left:y.left*O,width:y.width*O,height:y.height*O}}else w(l)?E={top:l.y,left:l.x,width:l.width||1,height:l.height||2}:E={top:l.posy,left:l.posx,width:2,height:2};const T=n.getTotalWidth(this.view),A=n.getTotalHeight(this.view),f=this.delegate.anchorPosition||v.BELOW,h=this.delegate.anchorAlignment||d.LEFT,p=this.delegate.anchorAxisAlignment||_.VERTICAL;let S,U;const H=n.getActiveWindow();if(p===_.VERTICAL){const y={offset:E.top-H.pageYOffset,size:E.height,position:f===v.BELOW?b.Before:b.After},O={offset:E.left,size:E.width,position:h===d.LEFT?b.Before:b.After,mode:m.ALIGN};S=e(H.innerHeight,A,y)+H.pageYOffset,I.Range.intersects({start:S,end:S+A},{start:y.offset,end:y.offset+y.size})&&(O.mode=m.AVOID),U=e(H.innerWidth,T,O)}else{const y={offset:E.left,size:E.width,position:h===d.LEFT?b.Before:b.After},O={offset:E.top,size:E.height,position:f===v.BELOW?b.Before:b.After,mode:m.ALIGN};U=e(H.innerWidth,T,y),I.Range.intersects({start:U,end:U+T},{start:y.offset,end:y.offset+y.size})&&(O.mode=m.AVOID),S=e(H.innerHeight,A,O)+H.pageYOffset}this.view.classList.remove("top","bottom","left","right"),this.view.classList.add(f===v.BELOW?"bottom":"top"),this.view.classList.add(h===d.LEFT?"left":"right"),this.view.classList.toggle("fixed",this.useFixedPosition);const x=n.getDomNodePagePosition(this.container);this.view.style.top=`${S-(this.useFixedPosition?n.getDomNodePagePosition(this.view).top:x.top)}px`,this.view.style.left=`${U-(this.useFixedPosition?n.getDomNodePagePosition(this.view).left:x.left)}px`,this.view.style.width="initial"}hide(l){const E=this.delegate;this.delegate=null,E?.onHide&&E.onHide(l),this.toDisposeOnClean.dispose(),n.hide(this.view)}isVisible(){return!!this.delegate}onDOMEvent(l,E){this.delegate&&(this.delegate.onDOMEvent?this.delegate.onDOMEvent(l,n.getWindow(l).document.activeElement):E&&!n.isAncestor(l.target,this.container)&&this.hide())}dispose(){this.hide(),super.dispose()}}t.ContextView=s;const r=`
	:host {
		all: initial; /* 1st rule so subsequent properties are reset. */
	}

	.codicon[class*='codicon-'] {
		font: normal normal normal 16px/1 codicon;
		display: inline-block;
		text-decoration: none;
		text-rendering: auto;
		text-align: center;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		user-select: none;
		-webkit-user-select: none;
		-ms-user-select: none;
	}

	:host {
		font-family: -apple-system, BlinkMacSystemFont, "Segoe WPC", "Segoe UI", "HelveticaNeue-Light", system-ui, "Ubuntu", "Droid Sans", sans-serif;
	}

	:host-context(.mac) { font-family: -apple-system, BlinkMacSystemFont, sans-serif; }
	:host-context(.mac:lang(zh-Hans)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang SC", "Hiragino Sans GB", sans-serif; }
	:host-context(.mac:lang(zh-Hant)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang TC", sans-serif; }
	:host-context(.mac:lang(ja)) { font-family: -apple-system, BlinkMacSystemFont, "Hiragino Kaku Gothic Pro", sans-serif; }
	:host-context(.mac:lang(ko)) { font-family: -apple-system, BlinkMacSystemFont, "Nanum Gothic", "Apple SD Gothic Neo", "AppleGothic", sans-serif; }

	:host-context(.windows) { font-family: "Segoe WPC", "Segoe UI", sans-serif; }
	:host-context(.windows:lang(zh-Hans)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft YaHei", sans-serif; }
	:host-context(.windows:lang(zh-Hant)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft Jhenghei", sans-serif; }
	:host-context(.windows:lang(ja)) { font-family: "Segoe WPC", "Segoe UI", "Yu Gothic UI", "Meiryo UI", sans-serif; }
	:host-context(.windows:lang(ko)) { font-family: "Segoe WPC", "Segoe UI", "Malgun Gothic", "Dotom", sans-serif; }

	:host-context(.linux) { font-family: system-ui, "Ubuntu", "Droid Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hans)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans SC", "Source Han Sans CN", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hant)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans TC", "Source Han Sans TW", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ja)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans J", "Source Han Sans JP", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ko)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans K", "Source Han Sans JR", "Source Han Sans", "UnDotum", "FBaekmuk Gulim", sans-serif; }
`}),define(ve[130],De([7]),{}),define(ve[131],De([7]),{}),define(ve[132],De([7]),{}),define(ve[133],De([7]),{}),define(ve[78],De([1,0,18,4,55,19,117,118,23,12,3,2,5,20,133]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0,n=Ue(n),b=Ue(b);const e=500,s=50,r=!0;class c{constructor(S,U,H){this.timestamp=S,this.deltaX=U,this.deltaY=H,this.score=0}}class l{static{this.INSTANCE=new l}constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let S=1,U=0,H=1,x=this._rear;do{const y=x===this._front?S:Math.pow(2,-H);if(S-=y,U+=this._memory[x].score*y,x===this._front)break;x=(this._capacity+x-1)%this._capacity,H++}while(!0);return U<=.5}acceptStandardWheelEvent(S){if(i.isChrome){const U=n.getWindow(S.browserEvent),H=(0,i.getZoomFactor)(U);this.accept(Date.now(),S.deltaX*H,S.deltaY*H)}else this.accept(Date.now(),S.deltaX,S.deltaY)}accept(S,U,H){let x=null;const y=new c(S,U,H);this._front===-1&&this._rear===-1?(this._memory[0]=y,this._front=0,this._rear=0):(x=this._memory[this._rear],this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=y),y.score=this._computeScore(y,x)}_computeScore(S,U){if(Math.abs(S.deltaX)>0&&Math.abs(S.deltaY)>0)return 1;let H=.5;if((!this._isAlmostInt(S.deltaX)||!this._isAlmostInt(S.deltaY))&&(H+=.25),U){const x=Math.abs(S.deltaX),y=Math.abs(S.deltaY),O=Math.abs(U.deltaX),V=Math.abs(U.deltaY),R=Math.max(Math.min(x,O),1),W=Math.max(Math.min(y,V),1),G=Math.max(x,O),Q=Math.max(y,V);G%R===0&&Q%W===0&&(H-=.5)}return Math.min(Math.max(H,0),1)}_isAlmostInt(S){return Math.abs(Math.round(S)-S)<.01}}t.MouseWheelClassifier=l;class E extends w.Widget{get options(){return this._options}constructor(S,U,H){super(),this._onScroll=this._register(new v.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new v.Emitter),this.onWillScroll=this._onWillScroll.event,S.style.overflow="hidden",this._options=h(U),this._scrollable=H,this._register(this._scrollable.onScroll(y=>{this._onWillScroll.fire(y),this._onDidScroll(y),this._onScroll.fire(y)}));const x={onMouseWheel:y=>this._onMouseWheel(y),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new D.VerticalScrollbar(this._scrollable,this._options,x)),this._horizontalScrollbar=this._register(new I.HorizontalScrollbar(this._scrollable,this._options,x)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(S),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,y=>this._onMouseOver(y)),this.onmouseleave(this._listenOnDomNode,y=>this._onMouseLeave(y)),this._hideTimeout=this._register(new d.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,_.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(S){this._verticalScrollbar.delegatePointerDown(S)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(S){this._scrollable.setScrollDimensions(S,!1)}updateClassName(S){this._options.className=S,b.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(S){typeof S.handleMouseWheel<"u"&&(this._options.handleMouseWheel=S.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof S.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=S.mouseWheelScrollSensitivity),typeof S.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=S.fastScrollSensitivity),typeof S.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=S.scrollPredominantAxis),typeof S.horizontal<"u"&&(this._options.horizontal=S.horizontal),typeof S.vertical<"u"&&(this._options.vertical=S.vertical),typeof S.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=S.horizontalScrollbarSize),typeof S.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=S.verticalScrollbarSize),typeof S.scrollByPage<"u"&&(this._options.scrollByPage=S.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(S){this._revealOnScroll=S}delegateScrollFromMouseWheelEvent(S){this._onMouseWheel(new F.StandardWheelEvent(S))}_setListeningToMouseWheel(S){if(this._mouseWheelToDispose.length>0!==S&&(this._mouseWheelToDispose=(0,_.dispose)(this._mouseWheelToDispose),S)){const H=x=>{this._onMouseWheel(new F.StandardWheelEvent(x))};this._mouseWheelToDispose.push(n.addDisposableListener(this._listenOnDomNode,n.EventType.MOUSE_WHEEL,H,{passive:!1}))}}_onMouseWheel(S){if(S.browserEvent?.defaultPrevented)return;const U=l.INSTANCE;r&&U.acceptStandardWheelEvent(S);let H=!1;if(S.deltaY||S.deltaX){let y=S.deltaY*this._options.mouseWheelScrollSensitivity,O=S.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(this._options.scrollYToX&&O+y===0?O=y=0:Math.abs(y)>=Math.abs(O)?O=0:y=0),this._options.flipAxes&&([y,O]=[O,y]);const V=!b.isMacintosh&&S.browserEvent&&S.browserEvent.shiftKey;(this._options.scrollYToX||V)&&!O&&(O=y,y=0),S.browserEvent&&S.browserEvent.altKey&&(O=O*this._options.fastScrollSensitivity,y=y*this._options.fastScrollSensitivity);const R=this._scrollable.getFutureScrollPosition();let W={};if(y){const G=s*y,Q=R.scrollTop-(G<0?Math.floor(G):Math.ceil(G));this._verticalScrollbar.writeScrollPosition(W,Q)}if(O){const G=s*O,Q=R.scrollLeft-(G<0?Math.floor(G):Math.ceil(G));this._horizontalScrollbar.writeScrollPosition(W,Q)}W=this._scrollable.validateScrollPosition(W),(R.scrollLeft!==W.scrollLeft||R.scrollTop!==W.scrollTop)&&(r&&this._options.mouseWheelSmoothScroll&&U.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(W):this._scrollable.setScrollPositionNow(W),H=!0)}let x=H;!x&&this._options.alwaysConsumeMouseWheel&&(x=!0),!x&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(x=!0),x&&(S.preventDefault(),S.stopPropagation())}_onDidScroll(S){this._shouldRender=this._horizontalScrollbar.onDidScroll(S)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(S)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const S=this._scrollable.getCurrentScrollPosition(),U=S.scrollTop>0,H=S.scrollLeft>0,x=H?" left":"",y=U?" top":"",O=H||U?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${x}`),this._topShadowDomNode.setClassName(`shadow${y}`),this._topLeftShadowDomNode.setClassName(`shadow${O}${y}${x}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(S){this._mouseIsOver=!1,this._hide()}_onMouseOver(S){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=E;class T extends E{constructor(S,U){U=U||{},U.mouseWheelSmoothScroll=!1;const H=new m.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:x=>n.scheduleAtNextAnimationFrame(n.getWindow(S),x)});super(S,U,H),this._register(H)}setScrollPosition(S){this._scrollable.setScrollPositionNow(S)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=T;class A extends E{constructor(S,U,H){super(S,U,H)}setScrollPosition(S){S.reuseAnimation?this._scrollable.setScrollPositionSmooth(S,S.reuseAnimation):this._scrollable.setScrollPositionNow(S)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=A;class f extends E{constructor(S,U){U=U||{},U.mouseWheelSmoothScroll=!1;const H=new m.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:x=>n.scheduleAtNextAnimationFrame(n.getWindow(S),x)});super(S,U,H),this._register(H),this._element=S,this._register(this.onScroll(x=>{x.scrollTopChanged&&(this._element.scrollTop=x.scrollTop),x.scrollLeftChanged&&(this._element.scrollLeft=x.scrollLeft)})),this.scanDomNode()}setScrollPosition(S){this._scrollable.setScrollPositionNow(S)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=f;function h(p){const S={lazyRender:typeof p.lazyRender<"u"?p.lazyRender:!1,className:typeof p.className<"u"?p.className:"",useShadows:typeof p.useShadows<"u"?p.useShadows:!0,handleMouseWheel:typeof p.handleMouseWheel<"u"?p.handleMouseWheel:!0,flipAxes:typeof p.flipAxes<"u"?p.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof p.consumeMouseWheelIfScrollbarIsNeeded<"u"?p.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof p.alwaysConsumeMouseWheel<"u"?p.alwaysConsumeMouseWheel:!1,scrollYToX:typeof p.scrollYToX<"u"?p.scrollYToX:!1,mouseWheelScrollSensitivity:typeof p.mouseWheelScrollSensitivity<"u"?p.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof p.fastScrollSensitivity<"u"?p.fastScrollSensitivity:5,scrollPredominantAxis:typeof p.scrollPredominantAxis<"u"?p.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof p.mouseWheelSmoothScroll<"u"?p.mouseWheelSmoothScroll:!0,arrowSize:typeof p.arrowSize<"u"?p.arrowSize:11,listenOnDomNode:typeof p.listenOnDomNode<"u"?p.listenOnDomNode:null,horizontal:typeof p.horizontal<"u"?p.horizontal:m.ScrollbarVisibility.Auto,horizontalScrollbarSize:typeof p.horizontalScrollbarSize<"u"?p.horizontalScrollbarSize:10,horizontalSliderSize:typeof p.horizontalSliderSize<"u"?p.horizontalSliderSize:0,horizontalHasArrows:typeof p.horizontalHasArrows<"u"?p.horizontalHasArrows:!1,vertical:typeof p.vertical<"u"?p.vertical:m.ScrollbarVisibility.Auto,verticalScrollbarSize:typeof p.verticalScrollbarSize<"u"?p.verticalScrollbarSize:10,verticalHasArrows:typeof p.verticalHasArrows<"u"?p.verticalHasArrows:!1,verticalSliderSize:typeof p.verticalSliderSize<"u"?p.verticalSliderSize:0,scrollByPage:typeof p.scrollByPage<"u"?p.scrollByPage:!1};return S.horizontalSliderSize=typeof p.horizontalSliderSize<"u"?p.horizontalSliderSize:S.horizontalScrollbarSize,S.verticalSliderSize=typeof p.verticalSliderSize<"u"?p.verticalSliderSize:S.verticalScrollbarSize,b.isMacintosh&&(S.className+=" mac"),S}}),define(ve[79],De([1,0,69,4,29,32,78,9,12,35,3,2,46,20,41,101,113,6,37]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b,m,e,s,r,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=t.ListViewTargetSector=void 0;const E={CurrentDragAndDropData:void 0};var T;(function(x){x[x.TOP=0]="TOP",x[x.CENTER_TOP=1]="CENTER_TOP",x[x.CENTER_BOTTOM=2]="CENTER_BOTTOM",x[x.BOTTOM=3]="BOTTOM"})(T||(t.ListViewTargetSector=T={}));const A={useShadows:!0,verticalScrollMode:m.ScrollbarVisibility.Auto,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(x){return[x]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class f{get context(){return this._context}set context(y){this._context=y}constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=f;class h{constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=h;class p{constructor(){this.types=[],this.files=[]}update(y){if(y.types&&this.types.splice(0,this.types.length,...y.types),y.files){this.files.splice(0,this.files.length);for(let O=0;O<y.files.length;O++){const V=y.files.item(O);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=p;function S(x,y){return Array.isArray(x)&&Array.isArray(y)?(0,D.equals)(x,y):x===y}class U{constructor(y){y?.getSetSize?this.getSetSize=y.getSetSize.bind(y):this.getSetSize=(O,V,R)=>R,y?.getPosInSet?this.getPosInSet=y.getPosInSet.bind(y):this.getPosInSet=(O,V)=>V+1,y?.getRole?this.getRole=y.getRole.bind(y):this.getRole=O=>"listitem",y?.isChecked?this.isChecked=y.isChecked.bind(y):this.isChecked=O=>{}}}class H{static{this.InstanceCount=0}get contentHeight(){return this.rangeMap.size}get contentWidth(){return this.scrollWidth??0}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(y){if(y!==this._horizontalScrolling){if(y&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=y,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const O of this.items)this.measureItemWidth(O);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,n.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(y,O,V,R=A){if(this.virtualDelegate=O,this.domId=`list_id_${++H.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new w.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=_.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=_.Disposable.None,this.onDragLeaveTimeout=_.Disposable.None,this.disposables=new _.DisposableStore,this._onDidChangeContentHeight=new v.Emitter,this._onDidChangeContentWidth=new v.Emitter,this.onDidChangeContentHeight=v.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this.onDidChangeContentWidth=v.Event.latch(this._onDidChangeContentWidth.event,void 0,this.disposables),this._horizontalScrolling=!1,R.horizontalScrolling&&R.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=this.createRangeMap(R.paddingTop??0);for(const G of V)this.renderers.set(G.templateId,G);this.cache=this.disposables.add(new r.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof R.mouseSupport=="boolean"?R.mouseSupport:!0),this._horizontalScrolling=R.horizontalScrolling??A.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.paddingBottom=typeof R.paddingBottom>"u"?0:R.paddingBottom,this.accessibilityProvider=new U(R.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(R.transformOptimization??A.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(F.Gesture.addTarget(this.rowsContainer)),this.scrollable=this.disposables.add(new m.Scrollable({forceIntegerValues:!0,smoothScrollDuration:R.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:G=>(0,n.scheduleAtNextAnimationFrame)((0,n.getWindow)(this.domNode),G)})),this.scrollableElement=this.disposables.add(new I.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:R.alwaysConsumeMouseWheel??A.alwaysConsumeMouseWheel,horizontal:m.ScrollbarVisibility.Auto,vertical:R.verticalScrollMode??A.verticalScrollMode,useShadows:R.useShadows??A.useShadows,mouseWheelScrollSensitivity:R.mouseWheelScrollSensitivity,fastScrollSensitivity:R.fastScrollSensitivity,scrollByPage:R.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),y.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,n.addDisposableListener)(this.rowsContainer,F.EventType.Change,G=>this.onTouchChange(G))),this.disposables.add((0,n.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",G=>G.target.scrollTop=0)),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragover",G=>this.onDragOver(this.toDragEvent(G)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"drop",G=>this.onDrop(this.toDragEvent(G)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragleave",G=>this.onDragLeave(this.toDragEvent(G)))),this.disposables.add((0,n.addDisposableListener)(this.domNode,"dragend",G=>this.onDragEnd(G))),this.setRowLineHeight=R.setRowLineHeight??A.setRowLineHeight,this.setRowHeight=R.setRowHeight??A.setRowHeight,this.supportDynamicHeights=R.supportDynamicHeights??A.supportDynamicHeights,this.dnd=R.dnd??this.disposables.add(A.dnd),this.layout(R.initialSize?.height,R.initialSize?.width)}updateOptions(y){y.paddingBottom!==void 0&&(this.paddingBottom=y.paddingBottom,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),y.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(y.smoothScrolling?125:0),y.horizontalScrolling!==void 0&&(this.horizontalScrolling=y.horizontalScrolling);let O;if(y.scrollByPage!==void 0&&(O={...O??{},scrollByPage:y.scrollByPage}),y.mouseWheelScrollSensitivity!==void 0&&(O={...O??{},mouseWheelScrollSensitivity:y.mouseWheelScrollSensitivity}),y.fastScrollSensitivity!==void 0&&(O={...O??{},fastScrollSensitivity:y.fastScrollSensitivity}),O&&this.scrollableElement.updateOptions(O),y.paddingTop!==void 0&&y.paddingTop!==this.rangeMap.paddingTop){const V=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),R=y.paddingTop-this.rangeMap.paddingTop;this.rangeMap.paddingTop=y.paddingTop,this.render(V,Math.max(0,this.lastRenderTop+R),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}}delegateScrollFromMouseWheelEvent(y){this.scrollableElement.delegateScrollFromMouseWheelEvent(y)}delegateVerticalScrollbarPointerDown(y){this.scrollableElement.delegateVerticalScrollbarPointerDown(y)}updateElementHeight(y,O,V){if(y<0||y>=this.items.length)return;const R=this.items[y].size;if(typeof O>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[y].lastDynamicHeightWidth=void 0,O=R+this.probeDynamicHeight(y)}if(R===O)return;const W=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let G=0;y<W.start||V!==null&&V>y&&V<W.end?G=O-R:G=0,this.rangeMap.splice(y,1,[{size:O}]),this.items[y].size=O,this.render(W,Math.max(0,this.lastRenderTop+G),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}createRangeMap(y){return new s.RangeMap(y)}splice(y,O,V=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(y,O,V)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(y,O,V=[]){const R=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),W={start:y,end:y+O},G=b.Range.intersect(R,W),Q=new Map;for(let pe=G.end-1;pe>=G.start;pe--){const Ae=this.items[pe];if(Ae.dragStartDisposable.dispose(),Ae.checkedDisposable.dispose(),Ae.row){let Ce=Q.get(Ae.templateId);Ce||(Ce=[],Q.set(Ae.templateId,Ce));const Re=this.renderers.get(Ae.templateId);Re&&Re.disposeElement&&Re.disposeElement(Ae.element,pe,Ae.row.templateData,Ae.size),Ce.unshift(Ae.row)}Ae.row=null,Ae.stale=!0}const j={start:y+O,end:this.items.length},q=b.Range.intersect(j,R),J=b.Range.relativeComplement(j,R),le=V.map(pe=>({id:String(this.itemId++),element:pe,templateId:this.virtualDelegate.getTemplateId(pe),size:this.virtualDelegate.getHeight(pe),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(pe),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:_.Disposable.None,checkedDisposable:_.Disposable.None,stale:!1}));let me;y===0&&O>=this.items.length?(this.rangeMap=this.createRangeMap(this.rangeMap.paddingTop),this.rangeMap.splice(0,0,le),me=this.items,this.items=le):(this.rangeMap.splice(y,O,le),me=this.items.splice(y,O,...le));const _e=V.length-O,Ne=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),ne=(0,s.shift)(q,_e),ee=b.Range.intersect(Ne,ne);for(let pe=ee.start;pe<ee.end;pe++)this.updateItemInDOM(this.items[pe],pe);const he=b.Range.relativeComplement(ne,Ne);for(const pe of he)for(let Ae=pe.start;Ae<pe.end;Ae++)this.removeItemFromDOM(Ae);const ae=J.map(pe=>(0,s.shift)(pe,_e)),te=[{start:y,end:y+V.length},...ae].map(pe=>b.Range.intersect(Ne,pe)).reverse();for(const pe of te)for(let Ae=pe.end-1;Ae>=pe.start;Ae--){const Ce=this.items[Ae],xe=Q.get(Ce.templateId)?.pop();this.insertItemInDOM(Ae,xe)}for(const pe of Q.values())for(const Ae of pe)this.cache.release(Ae);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),me.map(pe=>pe.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,n.scheduleAtNextAnimationFrame)((0,n.getWindow)(this.domNode),()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let y=0;for(const O of this.items)typeof O.width<"u"&&(y=Math.max(y,O.width));this.scrollWidth=y,this.scrollableElement.setScrollDimensions({scrollWidth:y===0?0:y+10}),this._onDidChangeContentWidth.fire(this.scrollWidth)}updateWidth(y){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const O=this.items[y];this.measureItemWidth(O),typeof O.width<"u"&&O.width>this.scrollWidth&&(this.scrollWidth=O.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}),this._onDidChangeContentWidth.fire(this.scrollWidth))}rerender(){if(this.supportDynamicHeights){for(const y of this.items)y.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).start}get firstMostlyVisibleIndex(){const y=this.firstVisibleIndex,O=this.rangeMap.positionAt(y),V=this.rangeMap.positionAt(y+1);return V!==-1&&(V-O)/2+O<this.scrollTop?y+1:y}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(y){return this.items[y].element}indexOf(y){return this.items.findIndex(O=>O.element===y)}domElement(y){const O=this.items[y].row;return O&&O.domNode}elementHeight(y){return this.items[y].size}elementTop(y){return this.rangeMap.positionAt(y)}indexAt(y){return this.rangeMap.indexAt(y)}indexAfter(y){return this.rangeMap.indexAfter(y)}layout(y,O){const V={height:typeof y=="number"?y:(0,n.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,V.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(V),typeof O<"u"&&(this.renderWidth=O,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof O=="number"?O:(0,n.getContentWidth)(this.domNode)})}render(y,O,V,R,W,G=!1){const Q=this.getRenderRange(O,V),j=b.Range.relativeComplement(Q,y).reverse(),q=b.Range.relativeComplement(y,Q);if(G){const J=b.Range.intersect(y,Q);for(let le=J.start;le<J.end;le++)this.updateItemInDOM(this.items[le],le)}this.cache.transact(()=>{for(const J of q)for(let le=J.start;le<J.end;le++)this.removeItemFromDOM(le);for(const J of j)for(let le=J.end-1;le>=J.start;le--)this.insertItemInDOM(le)}),R!==void 0&&(this.rowsContainer.style.left=`-${R}px`),this.rowsContainer.style.top=`-${O}px`,this.horizontalScrolling&&W!==void 0&&(this.rowsContainer.style.width=`${Math.max(W,this.renderWidth)}px`),this.lastRenderTop=O,this.lastRenderHeight=V}insertItemInDOM(y,O){const V=this.items[y];if(!V.row)if(O)V.row=O,V.stale=!0;else{const j=this.cache.alloc(V.templateId);V.row=j.row,V.stale||=j.isReusingConnectedDomNode}const R=this.accessibilityProvider.getRole(V.element)||"listitem";V.row.domNode.setAttribute("role",R);const W=this.accessibilityProvider.isChecked(V.element);if(typeof W=="boolean")V.row.domNode.setAttribute("aria-checked",String(!!W));else if(W){const j=q=>V.row.domNode.setAttribute("aria-checked",String(!!q));j(W.value),V.checkedDisposable=W.onDidChange(()=>j(W.value))}if(V.stale||!V.row.domNode.parentElement){const j=this.items.at(y+1)?.row?.domNode??null;(V.row.domNode.parentElement!==this.rowsContainer||V.row.domNode.nextElementSibling!==j)&&this.rowsContainer.insertBefore(V.row.domNode,j),V.stale=!1}this.updateItemInDOM(V,y);const G=this.renderers.get(V.templateId);if(!G)throw new Error(`No renderer found for template id ${V.templateId}`);G?.renderElement(V.element,y,V.row.templateData,V.size);const Q=this.dnd.getDragURI(V.element);V.dragStartDisposable.dispose(),V.row.domNode.draggable=!!Q,Q&&(V.dragStartDisposable=(0,n.addDisposableListener)(V.row.domNode,"dragstart",j=>this.onDragStart(V.element,Q,j))),this.horizontalScrolling&&(this.measureItemWidth(V),this.eventuallyUpdateScrollWidth())}measureItemWidth(y){if(!y.row||!y.row.domNode)return;y.row.domNode.style.width="fit-content",y.width=(0,n.getContentWidth)(y.row.domNode);const O=(0,n.getWindow)(y.row.domNode).getComputedStyle(y.row.domNode);O.paddingLeft&&(y.width+=parseFloat(O.paddingLeft)),O.paddingRight&&(y.width+=parseFloat(O.paddingRight)),y.row.domNode.style.width=""}updateItemInDOM(y,O){y.row.domNode.style.top=`${this.elementTop(O)}px`,this.setRowHeight&&(y.row.domNode.style.height=`${y.size}px`),this.setRowLineHeight&&(y.row.domNode.style.lineHeight=`${y.size}px`),y.row.domNode.setAttribute("data-index",`${O}`),y.row.domNode.setAttribute("data-last-element",O===this.length-1?"true":"false"),y.row.domNode.setAttribute("data-parity",O%2===0?"even":"odd"),y.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(y.element,O,this.length))),y.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(y.element,O))),y.row.domNode.setAttribute("id",this.getElementDomId(O)),y.row.domNode.classList.toggle("drop-target",y.dropTarget)}removeItemFromDOM(y){const O=this.items[y];if(O.dragStartDisposable.dispose(),O.checkedDisposable.dispose(),O.row){const V=this.renderers.get(O.templateId);V&&V.disposeElement&&V.disposeElement(O.element,y,O.row.templateData,O.size),this.cache.release(O.row),O.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(y,O){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:y,reuseAnimation:O})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(y){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:y})}get scrollTop(){return this.getScrollTop()}set scrollTop(y){this.setScrollTop(y)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.paddingBottom}get onMouseClick(){return v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"click")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseDblClick(){return v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"dblclick")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseMiddleClick(){return v.Event.filter(v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"auxclick")).event,y=>this.toMouseEvent(y),this.disposables),y=>y.browserEvent.button===1,this.disposables)}get onMouseUp(){return v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"mouseup")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseDown(){return v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"mousedown")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseOver(){return v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"mouseover")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseMove(){return v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"mousemove")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseOut(){return v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"mouseout")).event,y=>this.toMouseEvent(y),this.disposables)}get onContextMenu(){return v.Event.any(v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"contextmenu")).event,y=>this.toMouseEvent(y),this.disposables),v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,F.EventType.Contextmenu)).event,y=>this.toGestureEvent(y),this.disposables))}get onTouchStart(){return v.Event.map(this.disposables.add(new P.DomEmitter(this.domNode,"touchstart")).event,y=>this.toTouchEvent(y),this.disposables)}get onTap(){return v.Event.map(this.disposables.add(new P.DomEmitter(this.rowsContainer,F.EventType.Tap)).event,y=>this.toGestureEvent(y),this.disposables)}toMouseEvent(y){const O=this.getItemIndexFromEventTarget(y.target||null),V=typeof O>"u"?void 0:this.items[O],R=V&&V.element;return{browserEvent:y,index:O,element:R}}toTouchEvent(y){const O=this.getItemIndexFromEventTarget(y.target||null),V=typeof O>"u"?void 0:this.items[O],R=V&&V.element;return{browserEvent:y,index:O,element:R}}toGestureEvent(y){const O=this.getItemIndexFromEventTarget(y.initialTarget||null),V=typeof O>"u"?void 0:this.items[O],R=V&&V.element;return{browserEvent:y,index:O,element:R}}toDragEvent(y){const O=this.getItemIndexFromEventTarget(y.target||null),V=typeof O>"u"?void 0:this.items[O],R=V&&V.element,W=this.getTargetSector(y,O);return{browserEvent:y,index:O,element:R,sector:W}}onScroll(y){try{const O=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(O,y.scrollTop,y.height,y.scrollLeft,y.scrollWidth),this.supportDynamicHeights&&this._rerender(y.scrollTop,y.height,y.inSmoothScrolling)}catch(O){throw console.error("Got bad scroll event:",y),O}}onTouchChange(y){y.preventDefault(),y.stopPropagation(),this.scrollTop-=y.translationY}onDragStart(y,O,V){if(!V.dataTransfer)return;const R=this.dnd.getDragElements(y);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(i.DataTransfers.TEXT,O),V.dataTransfer.setDragImage){let W;this.dnd.getDragLabel&&(W=this.dnd.getDragLabel(R,V)),typeof W>"u"&&(W=String(R.length));const G=(0,n.$)(".monaco-drag-image");G.textContent=W,(q=>{for(;q&&!q.classList.contains("monaco-workbench");)q=q.parentElement;return q||this.domNode.ownerDocument})(this.domNode).appendChild(G),V.dataTransfer.setDragImage(G,-10,-10),setTimeout(()=>G.remove(),0)}this.domNode.classList.add("dragging"),this.currentDragData=new f(R),E.CurrentDragAndDropData=new h(R),this.dnd.onDragStart?.(this.currentDragData,V)}onDragOver(y){if(y.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),E.CurrentDragAndDropData&&E.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(y.browserEvent),!y.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(E.CurrentDragAndDropData)this.currentDragData=E.CurrentDragAndDropData;else{if(!y.browserEvent.dataTransfer.types)return!1;this.currentDragData=new p}const O=this.dnd.onDragOver(this.currentDragData,y.element,y.index,y.sector,y.browserEvent);if(this.canDrop=typeof O=="boolean"?O:O.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;y.browserEvent.dataTransfer.dropEffect=typeof O!="boolean"&&O.effect?.type===e.ListDragOverEffectType.Copy?"copy":"move";let V;typeof O!="boolean"&&O.feedback?V=O.feedback:typeof y.index>"u"?V=[-1]:V=[y.index],V=(0,D.distinct)(V).filter(W=>W>=-1&&W<this.length).sort((W,G)=>W-G),V=V[0]===-1?[-1]:V;let R=typeof O!="boolean"&&O.effect&&O.effect.position?O.effect.position:e.ListDragOverEffectPosition.Over;if(S(this.currentDragFeedback,V)&&this.currentDragFeedbackPosition===R)return!0;if(this.currentDragFeedback=V,this.currentDragFeedbackPosition=R,this.currentDragFeedbackDisposable.dispose(),V[0]===-1)this.domNode.classList.add(R),this.rowsContainer.classList.add(R),this.currentDragFeedbackDisposable=(0,_.toDisposable)(()=>{this.domNode.classList.remove(R),this.rowsContainer.classList.remove(R)});else{if(V.length>1&&R!==e.ListDragOverEffectPosition.Over)throw new Error("Can't use multiple feedbacks with position different than 'over'");R===e.ListDragOverEffectPosition.After&&V[0]<this.length-1&&(V[0]+=1,R=e.ListDragOverEffectPosition.Before);for(const W of V){const G=this.items[W];G.dropTarget=!0,G.row?.domNode.classList.add(R)}this.currentDragFeedbackDisposable=(0,_.toDisposable)(()=>{for(const W of V){const G=this.items[W];G.dropTarget=!1,G.row?.domNode.classList.remove(R)}})}return!0}onDragLeave(y){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,w.disposableTimeout)(()=>this.clearDragOverFeedback(),100,this.disposables),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,y.element,y.index,y.browserEvent)}onDrop(y){if(!this.canDrop)return;const O=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,E.CurrentDragAndDropData=void 0,!(!O||!y.browserEvent.dataTransfer)&&(y.browserEvent.preventDefault(),O.update(y.browserEvent.dataTransfer),this.dnd.drop(O,y.element,y.index,y.sector,y.browserEvent))}onDragEnd(y){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,E.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(y)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackPosition=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=_.Disposable.None}setupDragAndDropScrollTopAnimation(y){if(!this.dragOverAnimationDisposable){const O=(0,n.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,n.animate)((0,n.getWindow)(this.domNode),this.animateDragAndDropScrollTop.bind(this,O))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,w.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3,this.disposables),this.dragOverMouseY=y.pageY}animateDragAndDropScrollTop(y){if(this.dragOverMouseY===void 0)return;const O=this.dragOverMouseY-y,V=this.renderHeight-35;O<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(O-35))):O>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(O-V))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getTargetSector(y,O){if(O===void 0)return;const V=y.offsetY/this.items[O].size,R=Math.floor(V/.25);return(0,l.clamp)(R,0,3)}getItemIndexFromEventTarget(y){const O=this.scrollableElement.getDomNode();let V=y;for(;((0,n.isHTMLElement)(V)||(0,n.isSVGElement)(V))&&V!==this.rowsContainer&&O.contains(V);){const R=V.getAttribute("data-index");if(R){const W=Number(R);if(!isNaN(W))return W}V=V.parentElement}}getRenderRange(y,O){return{start:this.rangeMap.indexAt(y),end:this.rangeMap.indexAfter(y+O-1)}}_rerender(y,O,V){const R=this.getRenderRange(y,O);let W,G;y===this.elementTop(R.start)?(W=R.start,G=0):R.end-R.start>1&&(W=R.start+1,G=this.elementTop(W)-y);let Q=0;for(;;){const j=this.getRenderRange(y,O);let q=!1;for(let J=j.start;J<j.end;J++){const le=this.probeDynamicHeight(J);le!==0&&this.rangeMap.splice(J,1,[this.items[J]]),Q+=le,q=q||le!==0}if(!q){Q!==0&&this.eventuallyUpdateScrollDimensions();const J=b.Range.relativeComplement(R,j);for(const me of J)for(let _e=me.start;_e<me.end;_e++)this.items[_e].row&&this.removeItemFromDOM(_e);const le=b.Range.relativeComplement(j,R).reverse();for(const me of le)for(let _e=me.end-1;_e>=me.start;_e--)this.insertItemInDOM(_e);for(let me=j.start;me<j.end;me++)this.items[me].row&&this.updateItemInDOM(this.items[me],me);if(typeof W=="number"){const me=this.scrollable.getFutureScrollPosition().scrollTop-y,_e=this.elementTop(W)-G+me;this.setScrollTop(_e,V)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(y){const O=this.items[y];if(this.virtualDelegate.getDynamicHeight){const G=this.virtualDelegate.getDynamicHeight(O.element);if(G!==null){const Q=O.size;return O.size=G,O.lastDynamicHeightWidth=this.renderWidth,G-Q}}if(!O.hasDynamicHeight||O.lastDynamicHeightWidth===this.renderWidth||this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(O.element))return 0;const V=O.size;if(O.row)return O.row.domNode.style.height="",O.size=O.row.domNode.offsetHeight,O.size===0&&!(0,n.isAncestor)(O.row.domNode,(0,n.getWindow)(O.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),O.lastDynamicHeightWidth=this.renderWidth,O.size-V;const{row:R}=this.cache.alloc(O.templateId);R.domNode.style.height="",this.rowsContainer.appendChild(R.domNode);const W=this.renderers.get(O.templateId);if(!W)throw new c.BugIndicatingError("Missing renderer for templateId: "+O.templateId);return W.renderElement(O.element,y,R.templateData,void 0),O.size=R.domNode.offsetHeight,W.disposeElement?.(O.element,y,R.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(O.element,O.size),O.lastDynamicHeightWidth=this.renderWidth,R.domNode.remove(),this.cache.release(R),O.size-V}getElementDomId(y){return`${this.domId}_${y}`}dispose(){for(const y of this.items)if(y.dragStartDisposable.dispose(),y.checkedDisposable.dispose(),y.row){const O=this.renderers.get(y.row.templateId);O&&(O.disposeElement?.(y.element,-1,y.row.templateData,void 0),O.disposeTemplate(y.row.templateData))}this.items=[],this.domNode?.remove(),this.dragOverAnimationDisposable?.dispose(),this.disposables.dispose()}}t.ListView=H,et([d.memoize],H.prototype,"onMouseClick",null),et([d.memoize],H.prototype,"onMouseDblClick",null),et([d.memoize],H.prototype,"onMouseMiddleClick",null),et([d.memoize],H.prototype,"onMouseUp",null),et([d.memoize],H.prototype,"onMouseDown",null),et([d.memoize],H.prototype,"onMouseOver",null),et([d.memoize],H.prototype,"onMouseMove",null),et([d.memoize],H.prototype,"onMouseOut",null),et([d.memoize],H.prototype,"onContextMenu",null),et([d.memoize],H.prototype,"onTouchStart",null),et([d.memoize],H.prototype,"onTap",null)}),define(ve[52],De([1,0,4,29,15,32,76,86,9,12,88,35,3,49,8,2,37,5,10,41,79,19,62,132]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b,m,e,s,r,c,l,E,T,A,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=void 0,t.isInputElement=H,t.isMonacoEditor=y,t.isMonacoCustomToggle=O,t.isActionItem=V,t.isMonacoTwistie=R,t.isStickyScrollElement=W,t.isStickyScrollContainer=G,t.isButton=Q,t.isSelectionSingleChangeEvent=_e,t.isSelectionRangeChangeEvent=Ne,c=Ue(c);class h{constructor(a){this.trait=a,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(a){return a}renderElement(a,o,g){const k=this.renderedElements.findIndex(L=>L.templateData===g);if(k>=0){const L=this.renderedElements[k];this.trait.unrender(g),L.index=o}else{const L={index:o,templateData:g};this.renderedElements.push(L)}this.trait.renderIndex(o,g)}splice(a,o,g){const k=[];for(const L of this.renderedElements)L.index<a?k.push(L):L.index>=a+o&&k.push({index:L.index+g-o,templateData:L.templateData});this.renderedElements=k}renderIndexes(a){for(const{index:o,templateData:g}of this.renderedElements)a.indexOf(o)>-1&&this.trait.renderIndex(o,g)}disposeTemplate(a){const o=this.renderedElements.findIndex(g=>g.templateData===a);o<0||this.renderedElements.splice(o,1)}}class p{get name(){return this._trait}get renderer(){return new h(this)}constructor(a){this._trait=a,this.indexes=[],this.sortedIndexes=[],this._onChange=new b.Emitter,this.onChange=this._onChange.event}splice(a,o,g){const k=g.length-o,L=a+o,u=[];let N=0;for(;N<this.sortedIndexes.length&&this.sortedIndexes[N]<a;)u.push(this.sortedIndexes[N++]);for(let C=0;C<g.length;C++)g[C]&&u.push(C+a);for(;N<this.sortedIndexes.length&&this.sortedIndexes[N]>=L;)u.push(this.sortedIndexes[N++]+k);this.renderer.splice(a,o,g.length),this._set(u,u)}renderIndex(a,o){o.classList.toggle(this._trait,this.contains(a))}unrender(a){a.classList.remove(this._trait)}set(a,o){return this._set(a,[...a].sort(Ce),o)}_set(a,o,g){const k=this.indexes,L=this.sortedIndexes;this.indexes=a,this.sortedIndexes=o;const u=pe(L,a);return this.renderer.renderIndexes(u),this._onChange.fire({indexes:a,browserEvent:g}),k}get(){return this.indexes}contains(a){return(0,w.binarySearch)(this.sortedIndexes,a,Ce)>=0}dispose(){(0,s.dispose)(this._onChange)}}et([_.memoize],p.prototype,"renderer",null);class S extends p{constructor(a){super("selected"),this.setAriaSelected=a}renderIndex(a,o){super.renderIndex(a,o),this.setAriaSelected&&(this.contains(a)?o.setAttribute("aria-selected","true"):o.setAttribute("aria-selected","false"))}}class U{constructor(a,o,g){this.trait=a,this.view=o,this.identityProvider=g}splice(a,o,g){if(!this.identityProvider)return this.trait.splice(a,o,new Array(g.length).fill(!1));const k=this.trait.get().map(N=>this.identityProvider.getId(this.view.element(N)).toString());if(k.length===0)return this.trait.splice(a,o,new Array(g.length).fill(!1));const L=new Set(k),u=g.map(N=>L.has(this.identityProvider.getId(N).toString()));this.trait.splice(a,o,u)}}function H(B){return B.tagName==="INPUT"||B.tagName==="TEXTAREA"}function x(B,a){return B.classList.contains(a)?!0:B.classList.contains("monaco-list")||!B.parentElement?!1:x(B.parentElement,a)}function y(B){return x(B,"monaco-editor")}function O(B){return x(B,"monaco-custom-toggle")}function V(B){return x(B,"action-item")}function R(B){return x(B,"monaco-tl-twistie")}function W(B){return x(B,"monaco-tree-sticky-row")}function G(B){return B.classList.contains("monaco-tree-sticky-container")}function Q(B){return B.tagName==="A"&&B.classList.contains("monaco-button")||B.tagName==="DIV"&&B.classList.contains("monaco-button-dropdown")?!0:B.classList.contains("monaco-list")||!B.parentElement?!1:Q(B.parentElement)}class j{get onKeyDown(){return b.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,a=>a.filter(o=>!H(o.target)).map(o=>new P.StandardKeyboardEvent(o)))}constructor(a,o,g){this.list=a,this.view=o,this.disposables=new s.DisposableStore,this.multipleSelectionDisposables=new s.DisposableStore,this.multipleSelectionSupport=g.multipleSelectionSupport,this.disposables.add(this.onKeyDown(k=>{switch(k.keyCode){case e.KeyCode.Enter:return this.onEnter(k);case e.KeyCode.UpArrow:return this.onUpArrow(k);case e.KeyCode.DownArrow:return this.onDownArrow(k);case e.KeyCode.PageUp:return this.onPageUpArrow(k);case e.KeyCode.PageDown:return this.onPageDownArrow(k);case e.KeyCode.Escape:return this.onEscape(k);case e.KeyCode.KeyA:this.multipleSelectionSupport&&(c.isMacintosh?k.metaKey:k.ctrlKey)&&this.onCtrlA(k)}}))}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.multipleSelectionSupport=a.multipleSelectionSupport)}onEnter(a){a.preventDefault(),a.stopPropagation(),this.list.setSelection(this.list.getFocus(),a.browserEvent)}onUpArrow(a){a.preventDefault(),a.stopPropagation(),this.list.focusPrevious(1,!1,a.browserEvent);const o=this.list.getFocus()[0];this.list.setAnchor(o),this.list.reveal(o),this.view.domNode.focus()}onDownArrow(a){a.preventDefault(),a.stopPropagation(),this.list.focusNext(1,!1,a.browserEvent);const o=this.list.getFocus()[0];this.list.setAnchor(o),this.list.reveal(o),this.view.domNode.focus()}onPageUpArrow(a){a.preventDefault(),a.stopPropagation(),this.list.focusPreviousPage(a.browserEvent);const o=this.list.getFocus()[0];this.list.setAnchor(o),this.list.reveal(o),this.view.domNode.focus()}onPageDownArrow(a){a.preventDefault(),a.stopPropagation(),this.list.focusNextPage(a.browserEvent);const o=this.list.getFocus()[0];this.list.setAnchor(o),this.list.reveal(o),this.view.domNode.focus()}onCtrlA(a){a.preventDefault(),a.stopPropagation(),this.list.setSelection((0,w.range)(this.list.length),a.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(a){this.list.getSelection().length&&(a.preventDefault(),a.stopPropagation(),this.list.setSelection([],a.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}et([_.memoize],j.prototype,"onKeyDown",null);var q;(function(B){B[B.Automatic=0]="Automatic",B[B.Trigger=1]="Trigger"})(q||(t.TypeNavigationMode=q={}));var J;(function(B){B[B.Idle=0]="Idle",B[B.Typing=1]="Typing"})(J||(J={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(B){return B.ctrlKey||B.metaKey||B.altKey?!1:B.keyCode>=e.KeyCode.KeyA&&B.keyCode<=e.KeyCode.KeyZ||B.keyCode>=e.KeyCode.Digit0&&B.keyCode<=e.KeyCode.Digit9||B.keyCode>=e.KeyCode.Numpad0&&B.keyCode<=e.KeyCode.Numpad9||B.keyCode>=e.KeyCode.Semicolon&&B.keyCode<=e.KeyCode.Quote}};class le{constructor(a,o,g,k,L){this.list=a,this.view=o,this.keyboardNavigationLabelProvider=g,this.keyboardNavigationEventFilter=k,this.delegate=L,this.enabled=!1,this.state=J.Idle,this.mode=q.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new s.DisposableStore,this.disposables=new s.DisposableStore,this.updateOptions(a.options)}updateOptions(a){a.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=a.typeNavigationMode??q.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let a=!1;const o=b.Event.chain(this.enabledDisposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,L=>L.filter(u=>!H(u.target)).filter(()=>this.mode===q.Automatic||this.triggered).map(u=>new P.StandardKeyboardEvent(u)).filter(u=>a||this.keyboardNavigationEventFilter(u)).filter(u=>this.delegate.mightProducePrintableCharacter(u)).forEach(u=>i.EventHelper.stop(u,!0)).map(u=>u.browserEvent.key)),g=b.Event.debounce(o,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);b.Event.reduce(b.Event.any(o,g),(L,u)=>u===null?null:(L||"")+u,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),g(this.onClear,this,this.enabledDisposables),o(()=>a=!0,void 0,this.enabledDisposables),g(()=>a=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const a=this.list.getFocus();if(a.length>0&&a[0]===this.previouslyFocused){const o=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(a[0]));typeof o=="string"?(0,I.alert)(o):o&&(0,I.alert)(o.get())}this.previouslyFocused=-1}onInput(a){if(!a){this.state=J.Idle,this.triggered=!1;return}const o=this.list.getFocus(),g=o.length>0?o[0]:0,k=this.state===J.Idle?1:0;this.state=J.Typing;for(let L=0;L<this.list.length;L++){const u=(g+L+k)%this.list.length,N=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(u)),C=N&&N.toString();if(this.list.options.typeNavigationEnabled){if(typeof C<"u"){if((0,m.matchesPrefix)(a,C)){this.previouslyFocused=g,this.list.setFocus([u]),this.list.reveal(u);return}const M=(0,m.matchesFuzzy2)(a,C);if(M&&M[0].end-M[0].start>1&&M.length===1){this.previouslyFocused=g,this.list.setFocus([u]),this.list.reveal(u);return}}}else if(typeof C>"u"||(0,m.matchesPrefix)(a,C)){this.previouslyFocused=g,this.list.setFocus([u]),this.list.reveal(u);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class me{constructor(a,o){this.list=a,this.view=o,this.disposables=new s.DisposableStore;const g=b.Event.chain(this.disposables.add(new n.DomEmitter(o.domNode,"keydown")).event,L=>L.filter(u=>!H(u.target)).map(u=>new P.StandardKeyboardEvent(u)));b.Event.chain(g,L=>L.filter(u=>u.keyCode===e.KeyCode.Tab&&!u.ctrlKey&&!u.metaKey&&!u.shiftKey&&!u.altKey))(this.onTab,this,this.disposables)}onTab(a){if(a.target!==this.view.domNode)return;const o=this.list.getFocus();if(o.length===0)return;const g=this.view.domElement(o[0]);if(!g)return;const k=g.querySelector("[tabIndex]");if(!k||!(0,i.isHTMLElement)(k)||k.tabIndex===-1)return;const L=(0,i.getWindow)(k).getComputedStyle(k);L.visibility==="hidden"||L.display==="none"||(a.preventDefault(),a.stopPropagation(),k.focus())}dispose(){this.disposables.dispose()}}function _e(B){return c.isMacintosh?B.browserEvent.metaKey:B.browserEvent.ctrlKey}function Ne(B){return B.browserEvent.shiftKey}function ne(B){return(0,i.isMouseEvent)(B)&&B.button===2}const ee={isSelectionSingleChangeEvent:_e,isSelectionRangeChangeEvent:Ne};class he{constructor(a){this.list=a,this.disposables=new s.DisposableStore,this._onPointer=new b.Emitter,this.onPointer=this._onPointer.event,a.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ee),this.mouseSupport=typeof a.options.mouseSupport>"u"||!!a.options.mouseSupport,this.mouseSupport&&(a.onMouseDown(this.onMouseDown,this,this.disposables),a.onContextMenu(this.onContextMenu,this,this.disposables),a.onMouseDblClick(this.onDoubleClick,this,this.disposables),a.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(F.Gesture.addTarget(a.getHTMLElement()))),b.Event.any(a.onMouseClick,a.onMouseMiddleClick,a.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,a.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ee))}isSelectionSingleChangeEvent(a){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(a):!1}isSelectionRangeChangeEvent(a){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(a):!1}isSelectionChangeEvent(a){return this.isSelectionSingleChangeEvent(a)||this.isSelectionRangeChangeEvent(a)}onMouseDown(a){y(a.browserEvent.target)||(0,i.getActiveElement)()!==a.browserEvent.target&&this.list.domFocus()}onContextMenu(a){if(H(a.browserEvent.target)||y(a.browserEvent.target))return;const o=typeof a.index>"u"?[]:[a.index];this.list.setFocus(o,a.browserEvent)}onViewPointer(a){if(!this.mouseSupport||H(a.browserEvent.target)||y(a.browserEvent.target)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const o=a.index;if(typeof o>"u"){this.list.setFocus([],a.browserEvent),this.list.setSelection([],a.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionChangeEvent(a))return this.changeSelection(a);this.list.setFocus([o],a.browserEvent),this.list.setAnchor(o),ne(a.browserEvent)||this.list.setSelection([o],a.browserEvent),this._onPointer.fire(a)}onDoubleClick(a){if(H(a.browserEvent.target)||y(a.browserEvent.target)||this.isSelectionChangeEvent(a)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const o=this.list.getFocus();this.list.setSelection(o,a.browserEvent)}changeSelection(a){const o=a.index;let g=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(a)){typeof g>"u"&&(g=this.list.getFocus()[0]??o,this.list.setAnchor(g));const k=Math.min(g,o),L=Math.max(g,o),u=(0,w.range)(k,L+1),N=this.list.getSelection(),C=te(pe(N,[g]),g);if(C.length===0)return;const M=pe(u,Ae(N,C));this.list.setSelection(M,a.browserEvent),this.list.setFocus([o],a.browserEvent)}else if(this.isSelectionSingleChangeEvent(a)){const k=this.list.getSelection(),L=k.filter(u=>u!==o);this.list.setFocus([o]),this.list.setAnchor(o),k.length===L.length?this.list.setSelection([...L,o],a.browserEvent):this.list.setSelection(L,a.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=he;class ae{constructor(a,o){this.styleElement=a,this.selectorSuffix=o}style(a){const o=this.selectorSuffix&&`.${this.selectorSuffix}`,g=[];a.listBackground&&g.push(`.monaco-list${o} .monaco-list-rows { background: ${a.listBackground}; }`),a.listFocusBackground&&(g.push(`.monaco-list${o}:focus .monaco-list-row.focused { background-color: ${a.listFocusBackground}; }`),g.push(`.monaco-list${o}:focus .monaco-list-row.focused:hover { background-color: ${a.listFocusBackground}; }`)),a.listFocusForeground&&g.push(`.monaco-list${o}:focus .monaco-list-row.focused { color: ${a.listFocusForeground}; }`),a.listActiveSelectionBackground&&(g.push(`.monaco-list${o}:focus .monaco-list-row.selected { background-color: ${a.listActiveSelectionBackground}; }`),g.push(`.monaco-list${o}:focus .monaco-list-row.selected:hover { background-color: ${a.listActiveSelectionBackground}; }`)),a.listActiveSelectionForeground&&g.push(`.monaco-list${o}:focus .monaco-list-row.selected { color: ${a.listActiveSelectionForeground}; }`),a.listActiveSelectionIconForeground&&g.push(`.monaco-list${o}:focus .monaco-list-row.selected .codicon { color: ${a.listActiveSelectionIconForeground}; }`),a.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.selected.focused { background-color: ${a.listFocusAndSelectionBackground}; }
			`),a.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.selected.focused { color: ${a.listFocusAndSelectionForeground}; }
			`),a.listInactiveFocusForeground&&(g.push(`.monaco-list${o} .monaco-list-row.focused { color:  ${a.listInactiveFocusForeground}; }`),g.push(`.monaco-list${o} .monaco-list-row.focused:hover { color:  ${a.listInactiveFocusForeground}; }`)),a.listInactiveSelectionIconForeground&&g.push(`.monaco-list${o} .monaco-list-row.focused .codicon { color:  ${a.listInactiveSelectionIconForeground}; }`),a.listInactiveFocusBackground&&(g.push(`.monaco-list${o} .monaco-list-row.focused { background-color:  ${a.listInactiveFocusBackground}; }`),g.push(`.monaco-list${o} .monaco-list-row.focused:hover { background-color:  ${a.listInactiveFocusBackground}; }`)),a.listInactiveSelectionBackground&&(g.push(`.monaco-list${o} .monaco-list-row.selected { background-color:  ${a.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${o} .monaco-list-row.selected:hover { background-color:  ${a.listInactiveSelectionBackground}; }`)),a.listInactiveSelectionForeground&&g.push(`.monaco-list${o} .monaco-list-row.selected { color: ${a.listInactiveSelectionForeground}; }`),a.listHoverBackground&&g.push(`.monaco-list${o}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${a.listHoverBackground}; }`),a.listHoverForeground&&g.push(`.monaco-list${o}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${a.listHoverForeground}; }`);const k=(0,i.asCssValueWithDefault)(a.listFocusAndSelectionOutline,(0,i.asCssValueWithDefault)(a.listSelectionOutline,a.listFocusOutline??""));k&&g.push(`.monaco-list${o}:focus .monaco-list-row.focused.selected { outline: 1px solid ${k}; outline-offset: -1px;}`),a.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
			`);const L=(0,i.asCssValueWithDefault)(a.listSelectionOutline,a.listInactiveFocusOutline??"");L&&g.push(`.monaco-list${o} .monaco-list-row.focused.selected { outline: 1px dotted ${L}; outline-offset: -1px; }`),a.listSelectionOutline&&g.push(`.monaco-list${o} .monaco-list-row.selected { outline: 1px dotted ${a.listSelectionOutline}; outline-offset: -1px; }`),a.listInactiveFocusOutline&&g.push(`.monaco-list${o} .monaco-list-row.focused { outline: 1px dotted ${a.listInactiveFocusOutline}; outline-offset: -1px; }`),a.listHoverOutline&&g.push(`.monaco-list${o} .monaco-list-row:hover { outline: 1px dashed ${a.listHoverOutline}; outline-offset: -1px; }`),a.listDropOverBackground&&g.push(`
				.monaco-list${o}.drop-target,
				.monaco-list${o} .monaco-list-rows.drop-target,
				.monaco-list${o} .monaco-list-row.drop-target { background-color: ${a.listDropOverBackground} !important; color: inherit !important; }
			`),a.listDropBetweenBackground&&(g.push(`
			.monaco-list${o} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${o} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`),g.push(`
			.monaco-list${o} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${o} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`)),a.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${a.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),a.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${a.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=g.join(`
`)}}t.DefaultStyleController=ae,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:v.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:v.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:v.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const Le={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function te(B,a){const o=B.indexOf(a);if(o===-1)return[];const g=[];let k=o-1;for(;k>=0&&B[k]===a-(o-k);)g.push(B[k--]);for(g.reverse(),k=o;k<B.length&&B[k]===a+(k-o);)g.push(B[k++]);return g}function pe(B,a){const o=[];let g=0,k=0;for(;g<B.length||k<a.length;)if(g>=B.length)o.push(a[k++]);else if(k>=a.length)o.push(B[g++]);else if(B[g]===a[k]){o.push(B[g]),g++,k++;continue}else B[g]<a[k]?o.push(B[g++]):o.push(a[k++]);return o}function Ae(B,a){const o=[];let g=0,k=0;for(;g<B.length||k<a.length;)if(g>=B.length)o.push(a[k++]);else if(k>=a.length)o.push(B[g++]);else if(B[g]===a[k]){g++,k++;continue}else B[g]<a[k]?o.push(B[g++]):k++;return o}const Ce=(B,a)=>B-a;class Re{constructor(a,o){this._templateId=a,this.renderers=o}get templateId(){return this._templateId}renderTemplate(a){return this.renderers.map(o=>o.renderTemplate(a))}renderElement(a,o,g,k){let L=0;for(const u of this.renderers)u.renderElement(a,o,g[L++],k)}disposeElement(a,o,g,k){let L=0;for(const u of this.renderers)u.disposeElement?.(a,o,g[L],k),L+=1}disposeTemplate(a){let o=0;for(const g of this.renderers)g.disposeTemplate(a[o++])}}class xe{constructor(a){this.accessibilityProvider=a,this.templateId="a18n"}renderTemplate(a){return{container:a,disposables:new s.DisposableStore}}renderElement(a,o,g){const k=this.accessibilityProvider.getAriaLabel(a),L=k&&typeof k!="string"?k:(0,f.constObservable)(k);g.disposables.add((0,f.autorun)(N=>{this.setAriaLabel(N.readObservable(L),g.container)}));const u=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(a);typeof u=="number"?g.container.setAttribute("aria-level",`${u}`):g.container.removeAttribute("aria-level")}setAriaLabel(a,o){a?o.setAttribute("aria-label",a):o.removeAttribute("aria-label")}disposeElement(a,o,g,k){g.disposables.clear()}disposeTemplate(a){a.disposables.dispose()}}class He{constructor(a,o){this.list=a,this.dnd=o}getDragElements(a){const o=this.list.getSelectedElements();return o.indexOf(a)>-1?o:[a]}getDragURI(a){return this.dnd.getDragURI(a)}getDragLabel(a,o){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(a,o)}onDragStart(a,o){this.dnd.onDragStart?.(a,o)}onDragOver(a,o,g,k,L){return this.dnd.onDragOver(a,o,g,k,L)}onDragLeave(a,o,g,k){this.dnd.onDragLeave?.(a,o,g,k)}onDragEnd(a){this.dnd.onDragEnd?.(a)}drop(a,o,g,k,L){this.dnd.drop(a,o,g,k,L)}dispose(){this.dnd.dispose()}}class ${get onDidChangeFocus(){return b.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),a=>this.toListEvent(a),this.disposables)}get onDidChangeSelection(){return b.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),a=>this.toListEvent(a),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let a=!1;const o=b.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event,L=>L.map(u=>new P.StandardKeyboardEvent(u)).filter(u=>a=u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.EventHelper.stop(u,!0)).filter(()=>!1)),g=b.Event.chain(this.disposables.add(new n.DomEmitter(this.view.domNode,"keyup")).event,L=>L.forEach(()=>a=!1).map(u=>new P.StandardKeyboardEvent(u)).filter(u=>u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.EventHelper.stop(u,!0)).map(({browserEvent:u})=>{const N=this.getFocus(),C=N.length?N[0]:void 0,M=typeof C<"u"?this.view.element(C):void 0,z=typeof C<"u"?this.view.domElement(C):this.view.domNode;return{index:C,element:M,anchor:z,browserEvent:u}})),k=b.Event.chain(this.view.onContextMenu,L=>L.filter(u=>!a).map(({element:u,index:N,browserEvent:C})=>({element:u,index:N,anchor:new A.StandardMouseEvent((0,i.getWindow)(this.view.domNode),C),browserEvent:C})));return b.Event.any(o,g,k)}get onKeyDown(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new n.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return b.Event.signal(this.disposables.add(new n.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return b.Event.signal(this.disposables.add(new n.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(a,o,g,k,L=Le){this.user=a,this._options=L,this.focus=new p("focused"),this.anchor=new p("anchor"),this.eventBufferer=new b.EventBufferer,this._ariaLabel="",this.disposables=new s.DisposableStore,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event;const u=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new S(u!=="listbox");const N=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=L.accessibilityProvider,this.accessibilityProvider&&(N.push(new xe(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),k=k.map(M=>new Re(M.templateId,[...N,M]));const C={...L,dnd:L.dnd&&new He(this,L.dnd)};if(this.view=this.createListView(o,g,k,C),this.view.domNode.setAttribute("role",u),L.styleController)this.styleController=L.styleController(this.view.domId);else{const M=(0,i.createStyleSheet)(this.view.domNode);this.styleController=new ae(M,this.view.domId)}if(this.spliceable=new D.CombinedSpliceable([new U(this.focus,this.view,L.identityProvider),new U(this.selection,this.view,L.identityProvider),new U(this.anchor,this.view,L.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new me(this,this.view)),(typeof L.keyboardSupport!="boolean"||L.keyboardSupport)&&(this.keyboardController=new j(this,this.view,L),this.disposables.add(this.keyboardController)),L.keyboardNavigationLabelProvider){const M=L.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new le(this,this.view,L.keyboardNavigationLabelProvider,L.keyboardNavigationEventFilter??(()=>!0),M),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(L),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(a,o,g,k){return new T.ListView(a,o,g,k)}createMouseController(a){return new he(this)}updateOptions(a={}){this._options={...this._options,...a},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(a),this.keyboardController?.updateOptions(a),this.view.updateOptions(a)}get options(){return this._options}splice(a,o,g=[]){if(a<0||a>this.view.length)throw new E.ListError(this.user,`Invalid start index: ${a}`);if(o<0)throw new E.ListError(this.user,`Invalid delete count: ${o}`);o===0&&g.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(a,o,g))}updateWidth(a){this.view.updateWidth(a)}updateElementHeight(a,o){this.view.updateElementHeight(a,o,null)}rerender(){this.view.rerender()}element(a){return this.view.element(a)}indexOf(a){return this.view.indexOf(a)}indexAt(a){return this.view.indexAt(a)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.getScrollTop()}set scrollTop(a){this.view.setScrollTop(a)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(a){this.view.setScrollLeft(a)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.view.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(a){this._ariaLabel=a,this.view.domNode.setAttribute("aria-label",a)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(a,o){this.view.layout(a,o)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(a,o){for(const g of a)if(g<0||g>=this.length)throw new E.ListError(this.user,`Invalid index ${g}`);this.selection.set(a,o)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(a=>this.view.element(a))}setAnchor(a){if(typeof a>"u"){this.anchor.set([]);return}if(a<0||a>=this.length)throw new E.ListError(this.user,`Invalid index ${a}`);this.anchor.set([a])}getAnchor(){return(0,w.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const a=this.getAnchor();return typeof a>"u"?void 0:this.element(a)}setFocus(a,o){for(const g of a)if(g<0||g>=this.length)throw new E.ListError(this.user,`Invalid index ${g}`);this.focus.set(a,o)}focusNext(a=1,o=!1,g,k){if(this.length===0)return;const L=this.focus.get(),u=this.findNextIndex(L.length>0?L[0]+a:0,o,k);u>-1&&this.setFocus([u],g)}focusPrevious(a=1,o=!1,g,k){if(this.length===0)return;const L=this.focus.get(),u=this.findPreviousIndex(L.length>0?L[0]-a:0,o,k);u>-1&&this.setFocus([u],g)}async focusNextPage(a,o){let g=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);g=g===0?0:g-1;const k=this.getFocus()[0];if(k!==g&&(k===void 0||g>k)){const L=this.findPreviousIndex(g,!1,o);L>-1&&k!==L?this.setFocus([L],a):this.setFocus([g],a)}else{const L=this.view.getScrollTop();let u=L+this.view.renderHeight;g>k&&(u-=this.view.elementHeight(g)),this.view.setScrollTop(u),this.view.getScrollTop()!==L&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusNextPage(a,o))}}async focusPreviousPage(a,o,g=()=>0){let k;const L=g(),u=this.view.getScrollTop()+L;u===0?k=this.view.indexAt(u):k=this.view.indexAfter(u-1);const N=this.getFocus()[0];if(N!==k&&(N===void 0||N>=k)){const C=this.findNextIndex(k,!1,o);C>-1&&N!==C?this.setFocus([C],a):this.setFocus([k],a)}else{const C=u;this.view.setScrollTop(u-this.view.renderHeight-L),this.view.getScrollTop()+g()!==C&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusPreviousPage(a,o,g))}}focusLast(a,o){if(this.length===0)return;const g=this.findPreviousIndex(this.length-1,!1,o);g>-1&&this.setFocus([g],a)}focusFirst(a,o){this.focusNth(0,a,o)}focusNth(a,o,g){if(this.length===0)return;const k=this.findNextIndex(a,!1,g);k>-1&&this.setFocus([k],o)}findNextIndex(a,o=!1,g){for(let k=0;k<this.length;k++){if(a>=this.length&&!o)return-1;if(a=a%this.length,!g||g(this.element(a)))return a;a++}return-1}findPreviousIndex(a,o=!1,g){for(let k=0;k<this.length;k++){if(a<0&&!o)return-1;if(a=(this.length+a%this.length)%this.length,!g||g(this.element(a)))return a;a--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(a=>this.view.element(a))}reveal(a,o,g=0){if(a<0||a>=this.length)throw new E.ListError(this.user,`Invalid index ${a}`);const k=this.view.getScrollTop(),L=this.view.elementTop(a),u=this.view.elementHeight(a);if((0,l.isNumber)(o)){const N=u-this.view.renderHeight+g;this.view.setScrollTop(N*(0,r.clamp)(o,0,1)+L-g)}else{const N=L+u,C=k+this.view.renderHeight;L<k+g&&N>=C||(L<k+g||N>=C&&u>=this.view.renderHeight?this.view.setScrollTop(L-g):N>=C&&this.view.setScrollTop(N-this.view.renderHeight))}}getRelativeTop(a,o=0){if(a<0||a>=this.length)throw new E.ListError(this.user,`Invalid index ${a}`);const g=this.view.getScrollTop(),k=this.view.elementTop(a),L=this.view.elementHeight(a);if(k<g+o||k+L>g+this.view.renderHeight)return null;const u=L-this.view.renderHeight+o;return Math.abs((g+o-k)/u)}isDOMFocused(){return(0,i.isActiveElement)(this.view.domNode)}getHTMLElement(){return this.view.domNode}getScrollableElement(){return this.view.scrollableElementDomNode}getElementID(a){return this.view.getElementDomId(a)}getElementTop(a){return this.view.elementTop(a)}style(a){this.styleController.style(a)}toListEvent({indexes:a,browserEvent:o}){return{indexes:a,elements:a.map(g=>this.view.element(g)),browserEvent:o}}_onFocusChange(){const a=this.focus.get();this.view.domNode.classList.toggle("element-focused",a.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const a=this.focus.get();if(a.length>0){let o;this.accessibilityProvider?.getActiveDescendantId&&(o=this.accessibilityProvider.getActiveDescendantId(this.view.element(a[0]))),this.view.domNode.setAttribute("aria-activedescendant",o||this.view.getElementDomId(a[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const a=this.selection.get();this.view.domNode.classList.toggle("selection-none",a.length===0),this.view.domNode.classList.toggle("selection-single",a.length===1),this.view.domNode.classList.toggle("selection-multiple",a.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}t.List=$,et([_.memoize],$.prototype,"onDidChangeFocus",null),et([_.memoize],$.prototype,"onDidChangeSelection",null),et([_.memoize],$.prototype,"onContextMenu",null),et([_.memoize],$.prototype,"onKeyDown",null),et([_.memoize],$.prototype,"onKeyUp",null),et([_.memoize],$.prototype,"onKeyPress",null),et([_.memoize],$.prototype,"onDidFocus",null),et([_.memoize],$.prototype,"onDidBlur",null)}),define(ve[134],De([7]),{}),define(ve[135],De([7]),{}),define(ve[136],De([7]),{}),define(ve[137],De([7]),{}),define(ve[138],De([7]),{}),define(ve[13],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=P,t.localize2=I;const i=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function n(D,w){let d;return w.length===0?d=D:d=D.replace(/\{(\d+)\}/g,(v,_)=>{const b=_[0],m=w[b];let e=v;return typeof m=="string"?e=m:(typeof m=="number"||typeof m=="boolean"||m===void 0||m===null)&&(e=String(m)),e}),i&&(d="\uFF3B"+d.replace(/[aouei]/g,"$&$&")+"\uFF3D"),d}function P(D,w,...d){return n(typeof D=="number"?F(D,w):w,d)}function F(D,w){const d=globalThis._VSCODE_NLS_MESSAGES?.[D];if(typeof d!="string"){if(typeof w=="string")return w;throw new Error(`!!! NLS MISSING: ${D} !!!`)}return d}function I(D,w,...d){let v;typeof D=="number"?v=F(D,w):v=w;const _=n(v,d);return{value:_,original:w===v?_:n(w,d)}}}),define(ve[139],De([1,0,4,29,15,120,77,33,14,52,9,3,8,2,5,20,13,135]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b,m,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0,i=Ue(i),v=Ue(v);const c=i.$,l="selectOption.entry.template";class E{get templateId(){return l}renderTemplate(f){const h=Object.create(null);return h.root=f,h.text=i.append(f,c(".option-text")),h.detail=i.append(f,c(".option-detail")),h.decoratorRight=i.append(f,c(".option-decorator-right")),h}renderElement(f,h,p){const S=p,U=f.text,H=f.detail,x=f.decoratorRight,y=f.isDisabled;S.text.textContent=U,S.detail.textContent=H||"",S.decoratorRight.innerText=x||"",y?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(f){}}class T extends m.Disposable{static{this.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32}static{this.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2}static{this.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}constructor(f,h,p,S,U){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=S,this.selectBoxOptions=U||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=T.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new _.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(p),this.selected=h||0,f&&this.setOptions(f,h),this.initStyleSheet()}setTitle(f){!this._hover&&f?this._hover=this._register((0,D.getBaseLayerHoverDelegate)().setupManagedHover((0,w.getDefaultHoverDelegate)("mouse"),this.selectElement,f)):this._hover&&this._hover.update(f)}getHeight(){return 22}getTemplateId(){return l}constructSelectDropDown(f){this.contextViewProvider=f,this.selectDropDownContainer=i.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=i.append(this.selectDropDownContainer,c(".select-box-details-pane"));const h=i.append(this.selectDropDownContainer,c(".select-box-dropdown-container-width-control")),p=i.append(h,c(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",i.append(p,this.widthControlElement),this._dropDownPosition=I.AnchorPosition.BELOW,this.styleElement=i.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(i.addDisposableListener(this.selectDropDownContainer,i.EventType.DRAG_START,S=>{i.EventHelper.stop(S,!0)}))}registerListeners(){this._register(i.addStandardDisposableListener(this.selectElement,"change",h=>{this.selected=h.target.selectedIndex,this._onDidSelect.fire({index:h.target.selectedIndex,selected:h.target.value}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)})),this._register(i.addDisposableListener(this.selectElement,i.EventType.CLICK,h=>{i.EventHelper.stop(h),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(i.addDisposableListener(this.selectElement,i.EventType.MOUSE_DOWN,h=>{i.EventHelper.stop(h)}));let f;this._register(i.addDisposableListener(this.selectElement,"touchstart",h=>{f=this._isVisible})),this._register(i.addDisposableListener(this.selectElement,"touchend",h=>{i.EventHelper.stop(h),f?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(i.addDisposableListener(this.selectElement,i.EventType.KEY_DOWN,h=>{const p=new P.StandardKeyboardEvent(h);let S=!1;e.isMacintosh?(p.keyCode===b.KeyCode.DownArrow||p.keyCode===b.KeyCode.UpArrow||p.keyCode===b.KeyCode.Space||p.keyCode===b.KeyCode.Enter)&&(S=!0):(p.keyCode===b.KeyCode.DownArrow&&p.altKey||p.keyCode===b.KeyCode.UpArrow&&p.altKey||p.keyCode===b.KeyCode.Space||p.keyCode===b.KeyCode.Enter)&&(S=!0),S&&(this.showSelectDropDown(),i.EventHelper.stop(h,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(f,h){v.equals(this.options,f)||(this.options=f,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((p,S)=>{this.selectElement.add(this.createOption(p.text,S,p.isDisabled)),typeof p.description=="string"&&(this._hasDetails=!0)})),h!==void 0&&(this.select(h),this._currentSelection=this.selected)}setEnabled(f){this.selectElement.disabled=!f}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(f){f>=0&&f<this.options.length?this.selected=f:f>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)}setAriaLabel(f){this.selectBoxOptions.ariaLabel=f,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(f){this.selectElement.tabIndex=f?0:-1}render(f){this.container=f,f.classList.add("select-container"),f.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const f=[];this.styles.listFocusBackground&&f.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&f.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&f.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(f.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),f.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),f.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(f.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),f.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&f.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&f.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&f.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&f.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),f.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),f.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=f.join(`
`)}styleSelectElement(){const f=this.styles.selectBackground??"",h=this.styles.selectForeground??"",p=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=f,this.selectElement.style.color=h,this.selectElement.style.borderColor=p}styleList(){const f=this.styles.selectBackground??"",h=i.asCssValueWithDefault(this.styles.selectListBackground,f);this.selectDropDownListContainer.style.backgroundColor=h,this.selectionDetailsPane.style.backgroundColor=h;const p=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=p,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(f,h,p){const S=document.createElement("option");return S.value=f,S.text=f,S.disabled=!!p,S}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:f=>this.renderSelectDropDown(f,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:f=>this.renderSelectDropDown(f),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(f){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),f&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(f,h){return f.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(h),{dispose:()=>{this.selectDropDownContainer.remove()}}}measureMaxDetailsHeight(){let f=0;return this.options.forEach((h,p)=>{this.updateDetail(p),this.selectionDetailsPane.offsetHeight>f&&(f=this.selectionDetailsPane.offsetHeight)}),f}layoutSelectDropDown(f){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const h=i.getWindow(this.selectElement),p=i.getDomNodePagePosition(this.selectElement),S=i.getWindow(this.selectElement).getComputedStyle(this.selectElement),U=parseFloat(S.getPropertyValue("--dropdown-padding-top"))+parseFloat(S.getPropertyValue("--dropdown-padding-bottom")),H=h.innerHeight-p.top-p.height-(this.selectBoxOptions.minBottomMargin||0),x=p.top-T.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,y=this.selectElement.offsetWidth,O=this.setWidthControlElement(this.widthControlElement),V=Math.max(O,Math.round(y)).toString()+"px";this.selectDropDownContainer.style.width=V,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let R=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const W=this._hasDetails?this._cachedMaxDetailsHeight:0,G=R+U+W,Q=Math.floor((H-U-W)/this.getHeight()),j=Math.floor((x-U-W)/this.getHeight());if(f)return p.top+p.height>h.innerHeight-22||p.top<T.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||Q<1&&j<1?!1:(Q<T.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&j>Q&&this.options.length>Q?(this._dropDownPosition=I.AnchorPosition.ABOVE,this.selectDropDownListContainer.remove(),this.selectionDetailsPane.remove(),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=I.AnchorPosition.BELOW,this.selectDropDownListContainer.remove(),this.selectionDetailsPane.remove(),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(p.top+p.height>h.innerHeight-22||p.top<T.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===I.AnchorPosition.BELOW&&Q<1||this._dropDownPosition===I.AnchorPosition.ABOVE&&j<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===I.AnchorPosition.BELOW){if(this._isVisible&&Q+j<1)return this.hideSelectDropDown(!0),!1;G>H&&(R=Q*this.getHeight())}else G>x&&(R=j*this.getHeight());return this.selectList.layout(R),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=R+U+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=R+U+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=V,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(f){let h=0;if(f){let p=0,S=0;this.options.forEach((U,H)=>{const x=U.detail?U.detail.length:0,y=U.decoratorRight?U.decoratorRight.length:0,O=U.text.length+x+y;O>S&&(p=H,S=O)}),f.textContent=this.options[p].text+(this.options[p].decoratorRight?this.options[p].decoratorRight+" ":""),h=i.getTotalWidth(f)}return h}createSelectList(f){if(this.selectList)return;this.selectDropDownListContainer=i.append(f,c(".select-box-dropdown-list-container")),this.listRenderer=new E,this.selectList=this._register(new d.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:s.ScrollbarVisibility.Visible,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let U=S.text;return S.detail&&(U+=`. ${S.detail}`),S.decoratorRight&&(U+=`. ${S.decoratorRight}`),S.description&&(U+=`. ${S.description}`),U},getWidgetAriaLabel:()=>(0,r.localize)(10459,null),getRole:()=>e.isMacintosh?"":"option",getWidgetRole:()=>"listbox"}})),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const h=this._register(new n.DomEmitter(this.selectDropDownListContainer,"keydown")),p=_.Event.chain(h.event,S=>S.filter(()=>this.selectList.length>0).map(U=>new P.StandardKeyboardEvent(U)));this._register(_.Event.chain(p,S=>S.filter(U=>U.keyCode===b.KeyCode.Enter))(this.onEnter,this)),this._register(_.Event.chain(p,S=>S.filter(U=>U.keyCode===b.KeyCode.Tab))(this.onEnter,this)),this._register(_.Event.chain(p,S=>S.filter(U=>U.keyCode===b.KeyCode.Escape))(this.onEscape,this)),this._register(_.Event.chain(p,S=>S.filter(U=>U.keyCode===b.KeyCode.UpArrow))(this.onUpArrow,this)),this._register(_.Event.chain(p,S=>S.filter(U=>U.keyCode===b.KeyCode.DownArrow))(this.onDownArrow,this)),this._register(_.Event.chain(p,S=>S.filter(U=>U.keyCode===b.KeyCode.PageDown))(this.onPageDown,this)),this._register(_.Event.chain(p,S=>S.filter(U=>U.keyCode===b.KeyCode.PageUp))(this.onPageUp,this)),this._register(_.Event.chain(p,S=>S.filter(U=>U.keyCode===b.KeyCode.Home))(this.onHome,this)),this._register(_.Event.chain(p,S=>S.filter(U=>U.keyCode===b.KeyCode.End))(this.onEnd,this)),this._register(_.Event.chain(p,S=>S.filter(U=>U.keyCode>=b.KeyCode.Digit0&&U.keyCode<=b.KeyCode.KeyZ||U.keyCode>=b.KeyCode.Semicolon&&U.keyCode<=b.KeyCode.NumpadDivide))(this.onCharacter,this)),this._register(i.addDisposableListener(this.selectList.getHTMLElement(),i.EventType.POINTER_UP,S=>this.onPointerUp(S))),this._register(this.selectList.onMouseOver(S=>typeof S.index<"u"&&this.selectList.setFocus([S.index]))),this._register(this.selectList.onDidChangeFocus(S=>this.onListFocus(S))),this._register(i.addDisposableListener(this.selectDropDownContainer,i.EventType.FOCUS_OUT,S=>{!this._isVisible||i.isAncestor(S.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(f){if(!this.selectList.length)return;i.EventHelper.stop(f);const h=f.target;if(!h||h.classList.contains("slider"))return;const p=h.closest(".monaco-list-row");if(!p)return;const S=Number(p.getAttribute("data-index")),U=p.classList.contains("option-disabled");S>=0&&S<this.options.length&&!U&&(this.selected=S,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(f,h){const p=U=>{for(let H=0;H<U.childNodes.length;H++){const x=U.childNodes.item(H);(x.tagName&&x.tagName.toLowerCase())==="img"?x.remove():p(x)}},S=(0,F.renderMarkdown)({value:f,supportThemeIcons:!0},{actionHandler:h});return S.element.classList.add("select-box-description-markdown"),p(S.element),S.element}onListFocus(f){!this._isVisible||!this._hasDetails||this.updateDetail(f.indexes[0])}updateDetail(f){this.selectionDetailsPane.innerText="";const h=this.options[f],p=h?.description??"",S=h?.descriptionIsMarkdown??!1;if(p){if(S){const U=h.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(p,U))}else this.selectionDetailsPane.innerText=p;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(f){i.EventHelper.stop(f),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(f){i.EventHelper.stop(f),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(f){if(this.selected<this.options.length-1){i.EventHelper.stop(f,!0);const h=this.options[this.selected+1].isDisabled;if(h&&this.options.length>this.selected+2)this.selected+=2;else{if(h)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(f){this.selected>0&&(i.EventHelper.stop(f,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(f){i.EventHelper.stop(f),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(f){i.EventHelper.stop(f),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(f){i.EventHelper.stop(f),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(f){i.EventHelper.stop(f),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(f){const h=b.KeyCodeUtils.toString(f.keyCode);let p=-1;for(let S=0;S<this.options.length-1;S++)if(p=(S+this.selected+1)%this.options.length,this.options[p].text.charAt(0).toUpperCase()===h&&!this.options[p].isDisabled){this.select(p),this.selectList.setFocus([p]),this.selectList.reveal(this.selectList.getFocus()[0]),i.EventHelper.stop(f);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=T}),define(ve[140],De([1,0,52,139,115,23,5,134]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...i.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class D extends F.Widget{constructor(d,v,_,b,m){super(),I.isMacintosh&&!m?.useCustomDrawn?this.selectBoxDelegate=new P.SelectBoxNative(d,v,b,m):this.selectBoxDelegate=new n.SelectBoxList(d,v,_,b,m),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(d,v){this.selectBoxDelegate.setOptions(d,v)}select(d){this.selectBoxDelegate.select(d)}setAriaLabel(d){this.selectBoxDelegate.setAriaLabel(d)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(d){this.selectBoxDelegate.setFocusable(d)}setEnabled(d){this.selectBoxDelegate.setEnabled(d)}render(d){this.selectBoxDelegate.render(d)}}t.SelectBox=D}),define(ve[53],De([1,0,3,2,13]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0,t.toAction=v,P=Ue(P);class F extends n.Disposable{constructor(b,m="",e="",s=!0,r){super(),this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=b,this._label=m,this._cssClass=e,this._enabled=s,this._actionCallback=r}get id(){return this._id}get label(){return this._label}set label(b){this._setLabel(b)}_setLabel(b){this._label!==b&&(this._label=b,this._onDidChange.fire({label:b}))}get tooltip(){return this._tooltip||""}set tooltip(b){this._setTooltip(b)}_setTooltip(b){this._tooltip!==b&&(this._tooltip=b,this._onDidChange.fire({tooltip:b}))}get class(){return this._cssClass}set class(b){this._setClass(b)}_setClass(b){this._cssClass!==b&&(this._cssClass=b,this._onDidChange.fire({class:b}))}get enabled(){return this._enabled}set enabled(b){this._setEnabled(b)}_setEnabled(b){this._enabled!==b&&(this._enabled=b,this._onDidChange.fire({enabled:b}))}get checked(){return this._checked}set checked(b){this._setChecked(b)}_setChecked(b){this._checked!==b&&(this._checked=b,this._onDidChange.fire({checked:b}))}async run(b,m){this._actionCallback&&await this._actionCallback(b)}}t.Action=F;class I extends n.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new i.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new i.Emitter),this.onDidRun=this._onDidRun.event}async run(b,m){if(!b.enabled)return;this._onWillRun.fire({action:b});let e;try{await this.runAction(b,m)}catch(s){e=s}this._onDidRun.fire({action:b,error:e})}async runAction(b,m){await b.run(m)}}t.ActionRunner=I;class D{constructor(){this.id=D.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let m=[];for(const e of b)e.length&&(m.length?m=[...m,new D,...e]:m=e);return m}static{this.ID="vs.actions.separator"}async run(){}}t.Separator=D;class w{get actions(){return this._actions}constructor(b,m,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=m,this.class=s,this._actions=e}async run(){}}t.SubmenuAction=w;class d extends F{static{this.ID="vs.actions.empty"}constructor(){super(d.ID,P.localize(13048,null),void 0,!1)}}t.EmptySubmenuAction=d;function v(_){return{id:_.id,label:_.label,tooltip:_.tooltip??_.label,class:_.class,enabled:_.enabled??!0,checked:_.checked,run:async(...b)=>_.run(...b)}}}),define(ve[80],De([1,0,18,69,4,32,14,140,53,2,5,10,13,33,75]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0,v=Ue(v),_=Ue(_),b=Ue(b);class e extends d.Disposable{get action(){return this._action}constructor(l,E,T={}){super(),this.options=T,this._context=l||this,this._action=E,E instanceof w.Action&&this._register(E.onDidChange(A=>{this.element&&this.handleActionChangeEvent(A)}))}handleActionChangeEvent(l){l.enabled!==void 0&&this.updateEnabled(),l.checked!==void 0&&this.updateChecked(),l.class!==void 0&&this.updateClass(),l.label!==void 0&&(this.updateLabel(),this.updateTooltip()),l.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new w.ActionRunner)),this._actionRunner}set actionRunner(l){this._actionRunner=l}isEnabled(){return this._action.enabled}setActionContext(l){this._context=l}render(l){const E=this.element=l;this._register(F.Gesture.addTarget(l));const T=this.options&&this.options.draggable;T&&(l.draggable=!0,i.isFirefox&&this._register((0,P.addDisposableListener)(l,P.EventType.DRAG_START,A=>A.dataTransfer?.setData(n.DataTransfers.TEXT,this._action.label)))),this._register((0,P.addDisposableListener)(E,F.EventType.Tap,A=>this.onClick(A,!0))),this._register((0,P.addDisposableListener)(E,P.EventType.MOUSE_DOWN,A=>{T||P.EventHelper.stop(A,!0),this._action.enabled&&A.button===0&&E.classList.add("active")})),v.isMacintosh&&this._register((0,P.addDisposableListener)(E,P.EventType.CONTEXT_MENU,A=>{A.button===0&&A.ctrlKey===!0&&this.onClick(A)})),this._register((0,P.addDisposableListener)(E,P.EventType.CLICK,A=>{P.EventHelper.stop(A,!0),this.options&&this.options.isMenu||this.onClick(A)})),this._register((0,P.addDisposableListener)(E,P.EventType.DBLCLICK,A=>{P.EventHelper.stop(A,!0)})),[P.EventType.MOUSE_UP,P.EventType.MOUSE_OUT].forEach(A=>{this._register((0,P.addDisposableListener)(E,A,f=>{P.EventHelper.stop(f),E.classList.remove("active")}))})}onClick(l,E=!1){P.EventHelper.stop(l,!0);const T=_.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?l:{preserveFocus:E}:this._context;this.actionRunner.run(this._action,T)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(l){this.element&&(this.element.tabIndex=l?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getClass(){return this.action.class}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const l=this.getTooltip()??"";if(this.updateAriaLabel(),this.options.hoverDelegate?.showNativeHover)this.element.title=l;else if(!this.customHover&&l!==""){const E=this.options.hoverDelegate??(0,I.getDefaultHoverDelegate)("element");this.customHover=this._store.add((0,m.getBaseLayerHoverDelegate)().setupManagedHover(E,this.element,l))}else this.customHover&&this.customHover.update(l)}updateAriaLabel(){if(this.element){const l=this.getTooltip()??"";this.element.setAttribute("aria-label",l)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=e;class s extends e{constructor(l,E,T){super(l,E,T),this.options=T,this.options.icon=T.icon!==void 0?T.icon:!1,this.options.label=T.label!==void 0?T.label:!0,this.cssClass=""}render(l){super.render(l),_.assertType(this.element);const E=document.createElement("a");if(E.classList.add("action-label"),E.setAttribute("role",this.getDefaultAriaRole()),this.label=E,this.element.appendChild(E),this.options.label&&this.options.keybinding){const T=document.createElement("span");T.classList.add("keybinding"),T.textContent=this.options.keybinding,this.element.appendChild(T)}this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}getDefaultAriaRole(){return this._action.id===w.Separator.ID?"presentation":this.options.isMenu?"menuitem":this.options.isTabList?"tab":"button"}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(l){this.label&&(this.label.tabIndex=l?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let l=null;return this.action.tooltip?l=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(l=this.action.label,this.options.keybinding&&(l=b.localize(10487,null,l,this.options.keybinding))),l??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.getClass(),this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const l=this.getTooltip()??"";this.label.setAttribute("aria-label",l)}}updateChecked(){this.label&&(this.action.checked!==void 0?(this.label.classList.toggle("checked",this.action.checked),this.options.isTabList?this.label.setAttribute("aria-selected",this.action.checked?"true":"false"):(this.label.setAttribute("aria-checked",this.action.checked?"true":"false"),this.label.setAttribute("role","checkbox"))):(this.label.classList.remove("checked"),this.label.removeAttribute(this.options.isTabList?"aria-selected":"aria-checked"),this.label.setAttribute("role",this.getDefaultAriaRole())))}}t.ActionViewItem=s;class r extends e{constructor(l,E,T,A,f,h,p){super(l,E),this.selectBox=new D.SelectBox(T,A,f,h,p),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(l,E){this.selectBox.setOptions(l,E)}select(l){this.selectBox.select(l)}registerListeners(){this._register(this.selectBox.onDidSelect(l=>this.runAction(l.selected,l.index)))}runAction(l,E){this.actionRunner.run(this._action,this.getActionContext(l,E))}getActionContext(l,E){return l}setFocusable(l){this.selectBox.setFocusable(l)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(l){this.selectBox.render(l)}}t.SelectActionViewItem=r}),define(ve[81],De([1,0,4,15,80,14,53,3,8,2,10,75]),function(oe,t,i,n,P,F,I,D,w,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ActionBar=t.ActionsOrientation=void 0,t.prepareActions=m,i=Ue(i),v=Ue(v);var _;(function(e){e[e.HORIZONTAL=0]="HORIZONTAL",e[e.VERTICAL=1]="VERTICAL"})(_||(t.ActionsOrientation=_={}));class b extends d.Disposable{constructor(s,r={}){super(),this._actionRunnerDisposables=this._register(new d.DisposableStore),this.viewItemDisposables=this._register(new d.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new D.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new D.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new D.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new D.Emitter),this.onWillRun=this._onWillRun.event,this.options=r,this._context=r.context??null,this._orientation=this.options.orientation??_.HORIZONTAL,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[w.KeyCode.Enter,w.KeyCode.Space]},this._hoverDelegate=r.hoverDelegate??this._register((0,F.createInstantHoverDelegate)()),this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new I.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(E=>this._onDidRun.fire(E))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(E=>this._onWillRun.fire(E))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let c,l;switch(this._orientation){case _.HORIZONTAL:c=[w.KeyCode.LeftArrow],l=[w.KeyCode.RightArrow];break;case _.VERTICAL:c=[w.KeyCode.UpArrow],l=[w.KeyCode.DownArrow],this.domNode.className+=" vertical";break}this._register(i.addDisposableListener(this.domNode,i.EventType.KEY_DOWN,E=>{const T=new n.StandardKeyboardEvent(E);let A=!0;const f=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;c&&(T.equals(c[0])||T.equals(c[1]))?A=this.focusPrevious():l&&(T.equals(l[0])||T.equals(l[1]))?A=this.focusNext():T.equals(w.KeyCode.Escape)&&this.cancelHasListener?this._onDidCancel.fire():T.equals(w.KeyCode.Home)?A=this.focusFirst():T.equals(w.KeyCode.End)?A=this.focusLast():T.equals(w.KeyCode.Tab)&&f instanceof P.BaseActionViewItem&&f.trapsArrowNavigation?A=this.focusNext():this.isTriggerKeyEvent(T)?this._triggerKeys.keyDown?this.doTrigger(T):this.triggerKeyDown=!0:A=!1,A&&(T.preventDefault(),T.stopPropagation())})),this._register(i.addDisposableListener(this.domNode,i.EventType.KEY_UP,E=>{const T=new n.StandardKeyboardEvent(E);this.isTriggerKeyEvent(T)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(T)),T.preventDefault(),T.stopPropagation()):(T.equals(w.KeyCode.Tab)||T.equals(w.KeyMod.Shift|w.KeyCode.Tab)||T.equals(w.KeyCode.UpArrow)||T.equals(w.KeyCode.DownArrow)||T.equals(w.KeyCode.LeftArrow)||T.equals(w.KeyCode.RightArrow))&&this.updateFocusedItem()})),this.focusTracker=this._register(i.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(i.getActiveElement()===this.domNode||!i.isAncestor(i.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.previouslyFocusedItem=this.focusedItem,this.focusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.options.highlightToggledItems&&this.actionsList.classList.add("highlight-toggled"),this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),s.appendChild(this.domNode)}refreshRole(){this.length()>=1?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(s){s?this.actionsList.setAttribute("aria-label",s):this.actionsList.removeAttribute("aria-label")}setFocusable(s){if(this.focusable=s,this.focusable){const r=this.viewItems.find(c=>c instanceof P.BaseActionViewItem&&c.isEnabled());r instanceof P.BaseActionViewItem&&r.setFocusable(!0)}else this.viewItems.forEach(r=>{r instanceof P.BaseActionViewItem&&r.setFocusable(!1)})}isTriggerKeyEvent(s){let r=!1;return this._triggerKeys.keys.forEach(c=>{r=r||s.equals(c)}),r}updateFocusedItem(){for(let s=0;s<this.actionsList.children.length;s++){const r=this.actionsList.children[s];if(i.isAncestor(i.getActiveElement(),r)){this.focusedItem=s,this.viewItems[this.focusedItem]?.showHover?.();break}}}get context(){return this._context}set context(s){this._context=s,this.viewItems.forEach(r=>r.setActionContext(s))}get actionRunner(){return this._actionRunner}set actionRunner(s){this._actionRunner=s,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(r=>this._onDidRun.fire(r))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(r=>this._onWillRun.fire(r))),this.viewItems.forEach(r=>r.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(r=>r.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(i.isHTMLElement(s)){for(;s.parentElement!==this.actionsList;){if(!s.parentElement)return;s=s.parentElement}for(let r=0;r<this.actionsList.childNodes.length;r++)if(this.actionsList.childNodes[r]===s)return this.viewItems[r].action}}push(s,r={}){const c=Array.isArray(s)?s:[s];let l=v.isNumber(r.index)?r.index:null;c.forEach(E=>{const T=document.createElement("li");T.className="action-item",T.setAttribute("role","presentation");let A;const f={hoverDelegate:this._hoverDelegate,...r,isTabList:this.options.ariaRole==="tablist"};this.options.actionViewItemProvider&&(A=this.options.actionViewItemProvider(E,f)),A||(A=new P.ActionViewItem(this.context,E,f)),this.options.allowContextMenu||this.viewItemDisposables.set(A,i.addDisposableListener(T,i.EventType.CONTEXT_MENU,h=>{i.EventHelper.stop(h,!0)})),A.actionRunner=this._actionRunner,A.setActionContext(this.context),A.render(T),this.focusable&&A instanceof P.BaseActionViewItem&&this.viewItems.length===0&&A.setFocusable(!0),l===null||l<0||l>=this.actionsList.children.length?(this.actionsList.appendChild(T),this.viewItems.push(A)):(this.actionsList.insertBefore(T,this.actionsList.children[l]),this.viewItems.splice(l,0,A),l++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(s){if(s>=0&&s<this.actionsList.children.length){const r=this.actionsList.children.item(s);if(r)return r.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.actionsList.children.length){const r=this.actionsList.children.item(s);if(r)return r.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.actionsList.childNodes[s].remove(),this.viewItemDisposables.deleteAndDispose(this.viewItems[s]),(0,d.dispose)(this.viewItems.splice(s,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,d.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),i.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let r=!1,c;if(s===void 0?r=!0:typeof s=="number"?c=s:typeof s=="boolean"&&(r=s),r&&typeof this.focusedItem>"u"){const l=this.viewItems.findIndex(E=>E.isEnabled());this.focusedItem=l===-1?void 0:l,this.updateFocus(void 0,void 0,!0)}else c!==void 0&&(this.focusedItem=c),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(s){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const r=this.focusedItem;let c;do{if(!s&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=r,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,c=this.viewItems[this.focusedItem]}while(this.focusedItem!==r&&(this.options.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===I.Separator.ID));return this.updateFocus(),!0}focusPrevious(s){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const r=this.focusedItem;let c;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!s&&this.options.preventLoopNavigation)return this.focusedItem=r,!1;this.focusedItem=this.viewItems.length-1}c=this.viewItems[this.focusedItem]}while(this.focusedItem!==r&&(this.options.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===I.Separator.ID));return this.updateFocus(!0),!0}updateFocus(s,r,c=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:r}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const l=this.focusedItem!==void 0?this.viewItems[this.focusedItem]:void 0;if(l){let E=!0;v.isFunction(l.focus)||(E=!1),this.options.focusOnlyEnabledItems&&v.isFunction(l.isEnabled)&&!l.isEnabled()&&(E=!1),l.action.id===I.Separator.ID&&(E=!1),E?(c||this.previouslyFocusedItem!==this.focusedItem)&&(l.focus(s),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:r}),this.previouslyFocusedItem=void 0),E&&l.showHover?.()}}doTrigger(s){if(typeof this.focusedItem>"u")return;const r=this.viewItems[this.focusedItem];if(r instanceof P.BaseActionViewItem){const c=r._context===null||r._context===void 0?s:r._context;this.run(r._action,c)}}async run(s,r){await this._actionRunner.run(s,r)}dispose(){this._context=void 0,this.viewItems=(0,d.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=b;function m(e){if(!e.length)return e;let s=-1;for(let c=0;c<e.length;c++)if(e[c].id!==I.Separator.ID){s=c;break}if(s===-1)return[];e=e.slice(s);for(let c=e.length-1;c>=0&&e[c].id===I.Separator.ID;c--)e.splice(c,1);let r=!1;for(let c=e.length-1;c>=0;c--){const l=e[c].id===I.Separator.ID;l&&!r?e.splice(c,1):l?l&&(r=!1):r=!0}return e}}),define(ve[82],De([1,0,4,29,70,81,76,77,33,14,78,23,3,95,64,20,13,131]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b,m,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0,i=Ue(i),I=Ue(I),r=Ue(r);const c=i.$;var l;(function(A){A[A.INFO=1]="INFO",A[A.WARNING=2]="WARNING",A[A.ERROR=3]="ERROR"})(l||(t.MessageType=l={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class E extends _.Widget{constructor(f,h,p){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new b.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=h,this.options=p,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=i.append(f,c(".monaco-inputbox.idle"));const S=this.options.flexibleHeight?"textarea":"input",U=i.append(this.element,c(".ibwrapper"));if(this.input=i.append(U,c(S+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=i.append(U,c("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new v.ScrollableElement(this.element,{vertical:s.ScrollbarVisibility.Auto}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),i.append(f,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(y=>this.input.scrollTop=y.scrollTop));const H=this._register(new n.DomEmitter(f.ownerDocument,"selectionchange")),x=b.Event.filter(H.event,()=>f.ownerDocument.getSelection()?.anchorNode===U);this._register(x(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new F.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(f){this.placeholder=f,this.input.setAttribute("placeholder",f)}setTooltip(f){this.tooltip=f,this.hover?this.hover.update(f):this.hover=this._register((0,w.getBaseLayerHoverDelegate)().setupManagedHover((0,d.getDefaultHoverDelegate)("mouse"),this.input,f))}setAriaLabel(f){this.ariaLabel=f,f?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(f){this.input.value!==f&&(this.input.value=f,this.onValueChange())}get step(){return this.input.step}set step(f){this.input.step=f}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:i.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return i.isActiveElement(this.input)}select(f=null){this.input.select(),f&&(this.input.setSelectionRange(f.start,f.end),f.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}getSelection(){const f=this.input.selectionStart;if(f===null)return null;const h=this.input.selectionEnd??f;return{start:f,end:h}}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(f){f?this.enable():this.disable()}get width(){return i.getTotalWidth(this.input)}set width(f){if(this.options.flexibleHeight&&this.options.flexibleWidth){let h=0;if(this.mirror){const p=parseFloat(this.mirror.style.paddingLeft||"")||0,S=parseFloat(this.mirror.style.paddingRight||"")||0;h=p+S}this.input.style.width=f-h+"px"}else this.input.style.width=f+"px";this.mirror&&(this.mirror.style.width=f+"px")}set paddingRight(f){this.input.style.width=`calc(100% - ${f}px)`,this.mirror&&(this.mirror.style.paddingRight=f+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const f=this.cachedContentHeight,h=this.cachedHeight,p=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:f,height:h}),this.scrollableElement.setScrollPosition({scrollTop:p})}showMessage(f,h){if(this.state==="open"&&(0,e.equals)(this.message,f))return;this.message=f,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(f.type));const p=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${i.asCssValueWithDefault(p.border,"transparent")}`,this.message.content&&(this.hasFocus()||h)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let f=null;return this.validation&&(f=this.validation(this.value),f?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(f)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),f?.type}stylesForType(f){const h=this.options.inputBoxStyles;switch(f){case l.INFO:return{border:h.inputValidationInfoBorder,background:h.inputValidationInfoBackground,foreground:h.inputValidationInfoForeground};case l.WARNING:return{border:h.inputValidationWarningBorder,background:h.inputValidationWarningBackground,foreground:h.inputValidationWarningForeground};default:return{border:h.inputValidationErrorBorder,background:h.inputValidationErrorBackground,foreground:h.inputValidationErrorForeground}}}classForType(f){switch(f){case l.INFO:return"info";case l.WARNING:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let f;const h=()=>f.style.width=i.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:D.AnchorAlignment.RIGHT,render:S=>{if(!this.message)return null;f=i.append(S,c(".monaco-inputbox-container")),h();const U={inline:!0,className:"monaco-inputbox-message"},H=this.message.formatContent?(0,P.renderFormattedText)(this.message.content,U):(0,P.renderText)(this.message.content,U);H.classList.add(this.classForType(this.message.type));const x=this.stylesForType(this.message.type);return H.style.backgroundColor=x.background??"",H.style.color=x.foreground??"",H.style.border=x.border?`1px solid ${x.border}`:"",i.append(f,H),null},onHide:()=>{this.state="closed"},layout:h});let p;this.message.type===l.ERROR?p=r.localize(10463,null,this.message.content):this.message.type===l.WARNING?p=r.localize(10464,null,this.message.content):p=r.localize(10465,null,this.message.content),I.alert(p),this.state="open"}_hideMessage(){this.contextViewProvider&&(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const f=this.value,p=f.charCodeAt(f.length-1)===10?" ":"";(f+p).replace(/\u000c/g,"")?this.mirror.textContent=f+p:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const f=this.options.inputBoxStyles,h=f.inputBackground??"",p=f.inputForeground??"",S=f.inputBorder??"";this.element.style.backgroundColor=h,this.element.style.color=p,this.input.style.backgroundColor="inherit",this.input.style.color=p,this.element.style.border=`1px solid ${i.asCssValueWithDefault(S,"transparent")}`}layout(){if(!this.mirror)return;const f=this.cachedContentHeight;this.cachedContentHeight=i.getTotalHeight(this.mirror),f!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(f){const h=this.inputElement,p=h.selectionStart,S=h.selectionEnd,U=h.value;p!==null&&S!==null&&(this.value=U.substr(0,p)+f+U.substr(S),h.setSelectionRange(p+1,p+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=E;class T extends E{constructor(f,h,p){const S=r.localize(10466,null,"\u21C5"),U=r.localize(10467,null,"\u21C5");super(f,h,p),this._onDidFocus=this._register(new b.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new b.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new m.HistoryNavigator(p.history,100);const H=()=>{if(p.showHistoryHint&&p.showHistoryHint()&&!this.placeholder.endsWith(S)&&!this.placeholder.endsWith(U)&&this.history.getHistory().length){const x=this.placeholder.endsWith(")")?S:U,y=this.placeholder+x;p.showPlaceholderOnFocus&&!i.isActiveElement(this.input)?this.placeholder=y:this.setPlaceHolder(y)}};this.observer=new MutationObserver((x,y)=>{x.forEach(O=>{O.target.textContent||H()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>H()),this.onblur(this.input,()=>{const x=y=>{if(this.placeholder.endsWith(y)){const O=this.placeholder.slice(0,this.placeholder.length-y.length);return p.showPlaceholderOnFocus?this.placeholder=O:this.setPlaceHolder(O),!0}else return!1};x(U)||x(S)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(f){this.value&&(f||this.value!==this.getCurrentValue())&&this.history.add(this.value)}prependHistory(f){const h=this.getHistory();this.clearHistory(),f.forEach(p=>{this.history.add(p)}),h.forEach(p=>{this.history.add(p)})}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let f=this.getNextValue();f&&(f=f===this.value?this.getNextValue():f),this.value=f??"",I.status(this.value?this.value:r.localize(10468,null))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let f=this.getPreviousValue();f&&(f=f===this.value?this.getPreviousValue():f),f&&(this.value=f,I.status(this.value))}clearHistory(){this.history.clear()}setPlaceHolder(f){super.setPlaceHolder(f),this.setTooltip(f)}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let f=this.history.current();return f||(f=this.history.last(),this.history.next()),f}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()}}t.HistoryInputBox=T}),define(ve[83],De([1,0,80,23,21,22,3,8,4,14,33,136]),function(oe,t,i,n,P,F,I,D,w,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CheckboxActionViewItem=t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class _ extends i.BaseActionViewItem{constructor(r,c,l){super(r,c,l),this.toggle=this._register(new b({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground,hoverDelegate:l.hoverDelegate})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(r){this.element=r,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(r){this.toggle.domNode.tabIndex=r?0:-1}}t.ToggleActionViewItem=_;class b extends n.Widget{constructor(r){super(),this._onChange=this._register(new I.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new I.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=r,this._checked=this._opts.isChecked;const c=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,c.push(...F.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&c.push(...this._opts.actionClassName.split(" ")),this._checked&&c.push("checked"),this.domNode=document.createElement("div"),this._hover=this._register((0,v.getBaseLayerHoverDelegate)().setupManagedHover(r.hoverDelegate??(0,d.getDefaultHoverDelegate)("mouse"),this.domNode,this._opts.title)),this.domNode.classList.add(...c),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,l=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),l.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,l=>{if(l.keyCode===D.KeyCode.Space||l.keyCode===D.KeyCode.Enter){this.checked=!this._checked,this._onChange.fire(!0),l.preventDefault(),l.stopPropagation();return}this._onKeyDown.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(r){this._checked=r,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(r){this._icon&&this.domNode.classList.remove(...F.ThemeIcon.asClassNameArray(this._icon)),this._icon=r,this._icon&&this.domNode.classList.add(...F.ThemeIcon.asClassNameArray(this._icon))}width(){return 22}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(r){this._hover.update(r),this.domNode.setAttribute("aria-label",r)}set visible(r){this.domNode.style.display=r?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.Toggle=b;class m extends n.Widget{static{this.CLASS_NAME="monaco-checkbox"}constructor(r,c,l){super(),this.title=r,this.isChecked=c,this._onChange=this._register(new I.Emitter),this.onChange=this._onChange.event,this.checkbox=this._register(new b({title:this.title,isChecked:this.isChecked,icon:P.Codicon.check,actionClassName:m.CLASS_NAME,...t.unthemedToggleStyles})),this.domNode=this.checkbox.domNode,this.styles=l,this.applyStyles(),this._register(this.checkbox.onChange(E=>{this.applyStyles(),this._onChange.fire(E)}))}get checked(){return this.checkbox.checked}set checked(r){this.checkbox.checked=r,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return(0,w.isActiveElement)(this.domNode)}enable(){this.checkbox.enable()}disable(){this.checkbox.disable()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}t.Checkbox=m;class e extends i.BaseActionViewItem{constructor(r,c,l){super(r,c,l),this.toggle=this._register(new m(this._action.label,!!this._action.checked,l.checkboxStyles)),this._register(this.toggle.onChange(()=>this.onChange()))}render(r){if(this.element=r,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.toggle.domNode),this.options.label&&this._action.label){const c=this.element.appendChild((0,w.$)("span.checkbox-label",void 0,this._action.label));this._register((0,w.addDisposableListener)(c,w.EventType.CLICK,l=>{this.toggle.checked=!this.toggle.checked,l.stopPropagation(),l.preventDefault(),this.onChange()}))}this.updateEnabled(),this.updateClass(),this.updateChecked()}onChange(){this._action.checked=!!this.toggle&&this.toggle.checked,this.actionRunner.run(this._action,this._context)}updateEnabled(){this.isEnabled()?this.toggle.enable():this.toggle.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}updateChecked(){this.toggle.checked=!!this._action.checked}updateClass(){this.cssClass&&this.toggle.domNode.classList.remove(...this.cssClass.split(" ")),this.cssClass=this.getClass(),this.cssClass&&this.toggle.domNode.classList.add(...this.cssClass.split(" "))}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(r){this.toggle.domNode.tabIndex=r?0:-1}}t.CheckboxActionViewItem=e}),define(ve[141],De([1,0,14,83,21,13]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0,F=Ue(F);const I=F.localize(10475,null),D=F.localize(10476,null),w=F.localize(10477,null);class d extends n.Toggle{constructor(m){super({icon:P.Codicon.caseSensitive,title:I+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.CaseSensitiveToggle=d;class v extends n.Toggle{constructor(m){super({icon:P.Codicon.wholeWord,title:D+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.WholeWordsToggle=v;class _ extends n.Toggle{constructor(m){super({icon:P.Codicon.regex,title:w+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.RegexToggle=_}),define(ve[142],De([1,0,4,141,82,23,3,8,13,2,14,130]),function(oe,t,i,n,P,F,I,D,w,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0,i=Ue(i),w=Ue(w);const _=w.localize(10478,null);class b extends F.Widget{static{this.OPTION_CHANGE="optionChange"}constructor(e,s,r){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=this._register(new d.MutableDisposable),this.additionalToggles=[],this._onDidOptionChange=this._register(new I.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new I.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new I.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new I.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new I.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new I.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new I.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=r.placeholder||"",this.validation=r.validation,this.label=r.label||_,this.showCommonFindToggles=!!r.showCommonFindToggles;const c=r.appendCaseSensitiveLabel||"",l=r.appendWholeWordsLabel||"",E=r.appendRegexLabel||"",T=r.history||[],A=!!r.flexibleHeight,f=!!r.flexibleWidth,h=r.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new P.HistoryInputBox(this.domNode,s,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:T,showHistoryHint:r.showHistoryHint,flexibleHeight:A,flexibleWidth:f,flexibleMaxHeight:h,inputBoxStyles:r.inputBoxStyles}));const p=this._register((0,v.createInstantHoverDelegate)());if(this.showCommonFindToggles){this.regex=this._register(new n.RegexToggle({appendTitle:E,isChecked:!1,hoverDelegate:p,...r.toggleStyles})),this._register(this.regex.onChange(U=>{this._onDidOptionChange.fire(U),!U&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(U=>{this._onRegexKeyDown.fire(U)})),this.wholeWords=this._register(new n.WholeWordsToggle({appendTitle:l,isChecked:!1,hoverDelegate:p,...r.toggleStyles})),this._register(this.wholeWords.onChange(U=>{this._onDidOptionChange.fire(U),!U&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new n.CaseSensitiveToggle({appendTitle:c,isChecked:!1,hoverDelegate:p,...r.toggleStyles})),this._register(this.caseSensitive.onChange(U=>{this._onDidOptionChange.fire(U),!U&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(U=>{this._onCaseSensitiveKeyDown.fire(U)}));const S=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,U=>{if(U.equals(D.KeyCode.LeftArrow)||U.equals(D.KeyCode.RightArrow)||U.equals(D.KeyCode.Escape)){const H=S.indexOf(this.domNode.ownerDocument.activeElement);if(H>=0){let x=-1;U.equals(D.KeyCode.RightArrow)?x=(H+1)%S.length:U.equals(D.KeyCode.LeftArrow)&&(H===0?x=S.length-1:x=H-1),U.equals(D.KeyCode.Escape)?(S[H].blur(),this.inputBox.focus()):x>=0&&S[x].focus(),i.EventHelper.stop(U,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(r?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),e?.appendChild(this.domNode),this._register(i.addDisposableListener(this.inputBox.inputElement,"compositionstart",S=>{this.imeSessionInProgress=!0})),this._register(i.addDisposableListener(this.inputBox.inputElement,"compositionend",S=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,S=>this._onKeyDown.fire(S)),this.onkeyup(this.inputBox.inputElement,S=>this._onKeyUp.fire(S)),this.oninput(this.inputBox.inputElement,S=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,S=>this._onMouseDown.fire(S))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(e){this.inputBox.layout(),this.updateInputBoxPadding(e.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const e of this.additionalToggles)e.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const e of this.additionalToggles)e.disable()}setFocusInputOnOptionClick(e){this.fixFocusOnOptionClickEnabled=e}setEnabled(e){e?this.enable():this.disable()}setAdditionalToggles(e){for(const s of this.additionalToggles)s.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.value=new d.DisposableStore;for(const s of e??[])this.additionalTogglesDisposables.value.add(s),this.controls.appendChild(s.domNode),this.additionalTogglesDisposables.value.add(s.onChange(r=>{this._onDidOptionChange.fire(r),!r&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(s);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(e=!1){e?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((s,r)=>s+r.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(e){this.inputBox.value!==e&&(this.inputBox.value=e)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(e){this.caseSensitive&&(this.caseSensitive.checked=e)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(e){this.wholeWords&&(this.wholeWords.checked=e)}getRegex(){return this.regex?.checked??!1}setRegex(e){this.regex&&(this.regex.checked=e,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(e){this.inputBox.showMessage(e)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=b}),define(ve[143],De([1,0,4,29,15,81,142,82,79,52,83,72,34,53,9,12,21,22,43,3,49,8,2,37,10,13,14,62,137]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b,m,e,s,r,c,l,E,T,A,f,h,p,S,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.TreeRenderer=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class x extends w.ElementsDragAndDropData{set context(u){this.data.context=u}get context(){return this.data.context}constructor(u){super(u.elements.map(N=>N.element)),this.data=u}}function y(L){return L instanceof w.ElementsDragAndDropData?new x(L):L}class O{constructor(u,N){this.modelProvider=u,this.dnd=N,this.autoExpandDisposable=f.Disposable.None,this.disposables=new f.DisposableStore}getDragURI(u){return this.dnd.getDragURI(u.element)}getDragLabel(u,N){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(u.map(C=>C.element),N)}onDragStart(u,N){this.dnd.onDragStart?.(y(u),N)}onDragOver(u,N,C,M,z,X=!0){const ie=this.dnd.onDragOver(y(u),N&&N.element,C,M,z),re=this.autoExpandNode!==N;if(re&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=N),typeof N>"u")return ie;if(re&&typeof ie!="boolean"&&ie.autoExpand&&(this.autoExpandDisposable=(0,s.disposableTimeout)(()=>{const Ie=this.modelProvider(),de=Ie.getNodeLocation(N);Ie.isCollapsed(de)&&Ie.setCollapsed(de,!1),this.autoExpandNode=void 0},500,this.disposables)),typeof ie=="boolean"||!ie.accept||typeof ie.bubble>"u"||ie.feedback){if(!X){const Ie=typeof ie=="boolean"?ie:ie.accept,de=typeof ie=="boolean"?void 0:ie.effect;return{accept:Ie,effect:de,feedback:[C]}}return ie}if(ie.bubble===b.TreeDragOverBubble.Up){const Ie=this.modelProvider(),de=Ie.getNodeLocation(N),Fe=Ie.getParentNodeLocation(de),qe=Ie.getNode(Fe),Ye=Fe&&Ie.getListIndex(Fe);return this.onDragOver(u,qe,Ye,M,z,!1)}const ce=this.modelProvider(),we=ce.getNodeLocation(N),Ee=ce.getListIndex(we),ye=ce.getListRenderCount(we);return{...ie,feedback:(0,e.range)(Ee,Ee+ye)}}drop(u,N,C,M,z){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(y(u),N&&N.element,C,M,z)}onDragEnd(u){this.dnd.onDragEnd?.(u)}dispose(){this.disposables.dispose(),this.dnd.dispose()}}function V(L,u){return u&&{...u,identityProvider:u.identityProvider&&{getId(N){return u.identityProvider.getId(N.element)}},dnd:u.dnd&&new O(L,u.dnd),multipleSelectionController:u.multipleSelectionController&&{isSelectionSingleChangeEvent(N){return u.multipleSelectionController.isSelectionSingleChangeEvent({...N,element:N.element})},isSelectionRangeChangeEvent(N){return u.multipleSelectionController.isSelectionRangeChangeEvent({...N,element:N.element})}},accessibilityProvider:u.accessibilityProvider&&{...u.accessibilityProvider,getSetSize(N){const C=L(),M=C.getNodeLocation(N),z=C.getParentNodeLocation(M);return C.getNode(z).visibleChildrenCount},getPosInSet(N){return N.visibleChildIndex+1},isChecked:u.accessibilityProvider&&u.accessibilityProvider.isChecked?N=>u.accessibilityProvider.isChecked(N.element):void 0,getRole:u.accessibilityProvider&&u.accessibilityProvider.getRole?N=>u.accessibilityProvider.getRole(N.element):()=>"treeitem",getAriaLabel(N){return u.accessibilityProvider.getAriaLabel(N.element)},getWidgetAriaLabel(){return u.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:u.accessibilityProvider&&u.accessibilityProvider.getWidgetRole?()=>u.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:u.accessibilityProvider&&u.accessibilityProvider.getAriaLevel?N=>u.accessibilityProvider.getAriaLevel(N.element):N=>N.depth,getActiveDescendantId:u.accessibilityProvider.getActiveDescendantId&&(N=>u.accessibilityProvider.getActiveDescendantId(N.element))},keyboardNavigationLabelProvider:u.keyboardNavigationLabelProvider&&{...u.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(N){return u.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(N.element)}}}}class R{constructor(u){this.delegate=u}getHeight(u){return this.delegate.getHeight(u.element)}getTemplateId(u){return this.delegate.getTemplateId(u.element)}hasDynamicHeight(u){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(u.element)}setDynamicHeight(u,N){this.delegate.setDynamicHeight?.(u.element,N)}}t.ComposedTreeDelegate=R;class W{static lift(u){return u instanceof W?u:new W(u)}static empty(u=0){return new W({focus:[],selection:[],expanded:Object.create(null),scrollTop:u})}constructor(u){if(this.focus=new Set(u.focus),this.selection=new Set(u.selection),u.expanded instanceof Array){this.expanded=Object.create(null);for(const N of u.expanded)this.expanded[N]=1}else this.expanded=u.expanded;this.expanded=u.expanded,this.scrollTop=u.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=W;var G;(function(L){L.None="none",L.OnHover="onHover",L.Always="always"})(G||(t.RenderIndentGuides=G={}));class Q{get elements(){return this._elements}constructor(u,N=[]){this._elements=N,this.disposables=new f.DisposableStore,this.onDidChange=E.Event.forEach(u,C=>this._elements=C,this.disposables)}dispose(){this.disposables.dispose()}}class j{static{this.DefaultIndent=8}constructor(u,N,C,M,z,X={}){this.renderer=u,this.modelProvider=N,this.activeNodes=M,this.renderedIndentGuides=z,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=j.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=f.Disposable.None,this.disposables=new f.DisposableStore,this.templateId=u.templateId,this.updateOptions(X),E.Event.map(C,ie=>ie.node)(this.onDidChangeNodeTwistieState,this,this.disposables),u.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(u={}){if(typeof u.indent<"u"){const N=(0,h.clamp)(u.indent,0,40);if(N!==this.indent){this.indent=N;for(const[C,M]of this.renderedNodes)this.renderTreeElement(C,M)}}if(typeof u.renderIndentGuides<"u"){const N=u.renderIndentGuides!==G.None;if(N!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=N;for(const[C,M]of this.renderedNodes)this._renderIndentGuides(C,M);if(this.indentGuidesDisposable.dispose(),N){const C=new f.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,C),this.indentGuidesDisposable=C,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof u.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=u.hideTwistiesOfChildlessElements)}renderTemplate(u){const N=(0,i.append)(u,(0,i.$)(".monaco-tl-row")),C=(0,i.append)(N,(0,i.$)(".monaco-tl-indent")),M=(0,i.append)(N,(0,i.$)(".monaco-tl-twistie")),z=(0,i.append)(N,(0,i.$)(".monaco-tl-contents")),X=this.renderer.renderTemplate(z);return{container:u,indent:C,twistie:M,indentGuidesDisposable:f.Disposable.None,templateData:X}}renderElement(u,N,C,M){this.renderedNodes.set(u,C),this.renderedElements.set(u.element,u),this.renderTreeElement(u,C),this.renderer.renderElement(u,N,C.templateData,M)}disposeElement(u,N,C,M){C.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(u,N,C.templateData,M),typeof M=="number"&&(this.renderedNodes.delete(u),this.renderedElements.delete(u.element))}disposeTemplate(u){this.renderer.disposeTemplate(u.templateData)}onDidChangeTwistieState(u){const N=this.renderedElements.get(u);N&&this.onDidChangeNodeTwistieState(N)}onDidChangeNodeTwistieState(u){const N=this.renderedNodes.get(u);N&&(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(u,N))}renderTreeElement(u,N){const C=j.DefaultIndent+(u.depth-1)*this.indent;N.twistie.style.paddingLeft=`${C}px`,N.indent.style.width=`${C+this.indent-16}px`,u.collapsible?N.container.setAttribute("aria-expanded",String(!u.collapsed)):N.container.removeAttribute("aria-expanded"),N.twistie.classList.remove(...c.ThemeIcon.asClassNameArray(r.Codicon.treeItemExpanded));let M=!1;this.renderer.renderTwistie&&(M=this.renderer.renderTwistie(u.element,N.twistie)),u.collapsible&&(!this.hideTwistiesOfChildlessElements||u.visibleChildrenCount>0)?(M||N.twistie.classList.add(...c.ThemeIcon.asClassNameArray(r.Codicon.treeItemExpanded)),N.twistie.classList.add("collapsible"),N.twistie.classList.toggle("collapsed",u.collapsed)):N.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(u,N)}_renderIndentGuides(u,N){if((0,i.clearNode)(N.indent),N.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const C=new f.DisposableStore,M=this.modelProvider();for(;;){const z=M.getNodeLocation(u),X=M.getParentNodeLocation(z);if(!X)break;const ie=M.getNode(X),re=(0,i.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(ie)&&re.classList.add("active"),N.indent.childElementCount===0?N.indent.appendChild(re):N.indent.insertBefore(re,N.indent.firstElementChild),this.renderedIndentGuides.add(ie,re),C.add((0,f.toDisposable)(()=>this.renderedIndentGuides.delete(ie,re))),u=ie}N.indentGuidesDisposable=C}_onDidChangeActiveNodes(u){if(!this.shouldRenderIndentGuides)return;const N=new Set,C=this.modelProvider();u.forEach(M=>{const z=C.getNodeLocation(M);try{const X=C.getParentNodeLocation(z);M.collapsible&&M.children.length>0&&!M.collapsed?N.add(M):X&&N.add(C.getNode(X))}catch{}}),this.activeIndentNodes.forEach(M=>{N.has(M)||this.renderedIndentGuides.forEach(M,z=>z.classList.remove("active"))}),N.forEach(M=>{this.activeIndentNodes.has(M)||this.renderedIndentGuides.forEach(M,z=>z.classList.add("active"))}),this.activeIndentNodes=N}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,f.dispose)(this.disposables)}}t.TreeRenderer=j;class q{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(u){this._pattern=u,this._lowercasePattern=u.toLowerCase()}constructor(u,N,C){this.tree=u,this.keyboardNavigationLabelProvider=N,this._filter=C,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new f.DisposableStore,u.onWillRefilter(this.reset,this,this.disposables)}filter(u,N){let C=b.TreeVisibility.Visible;if(this._filter){const X=this._filter.filter(u,N);if(typeof X=="boolean"?C=X?b.TreeVisibility.Visible:b.TreeVisibility.Hidden:(0,_.isFilterResult)(X)?C=(0,_.getVisibleState)(X.visibility):C=X,C===b.TreeVisibility.Hidden)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:T.FuzzyScore.Default,visibility:C};const M=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(u),z=Array.isArray(M)?M:[M];for(const X of z){const ie=X&&X.toString();if(typeof ie>"u")return{data:T.FuzzyScore.Default,visibility:C};let re;if(this.tree.findMatchType===Ne.Contiguous){const ce=ie.toLowerCase().indexOf(this._lowercasePattern);if(ce>-1){re=[Number.MAX_SAFE_INTEGER,0];for(let we=this._lowercasePattern.length;we>0;we--)re.push(ce+we-1)}}else re=(0,T.fuzzyScore)(this._pattern,this._lowercasePattern,0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return this._matchCount++,z.length===1?{data:re,visibility:C}:{data:{label:ie,score:re},visibility:C}}return this.tree.findMode===_e.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(u):b.TreeVisibility.Recurse:{data:T.FuzzyScore.Default,visibility:C}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,f.dispose)(this.disposables)}}class J extends v.Toggle{constructor(u){super({icon:r.Codicon.listFilter,title:(0,S.localize)(10450,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,U.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.ModeToggle=J;class le extends v.Toggle{constructor(u){super({icon:r.Codicon.searchFuzzy,title:(0,S.localize)(10451,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,U.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.FuzzyToggle=le;const me={inputBoxStyles:D.unthemedInboxStyles,toggleStyles:v.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var _e;(function(L){L[L.Highlight=0]="Highlight",L[L.Filter=1]="Filter"})(_e||(t.TreeFindMode=_e={}));var Ne;(function(L){L[L.Fuzzy=0]="Fuzzy",L[L.Contiguous=1]="Contiguous"})(Ne||(t.TreeFindMatchType=Ne={}));class ne extends f.Disposable{set mode(u){this.modeToggle.checked=u===_e.Filter,this.findInput.inputBox.setPlaceHolder(u===_e.Filter?(0,S.localize)(10452,null):(0,S.localize)(10453,null))}set matchType(u){this.matchTypeToggle.checked=u===Ne.Fuzzy}get value(){return this.findInput.inputBox.value}set value(u){this.findInput.inputBox.value=u}constructor(u,N,C,M,z,X){super(),this.tree=N,this.elements=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new E.Emitter,this.onDidDisable=this._onDidDisable.event,u.appendChild(this.elements.root),this._register((0,f.toDisposable)(()=>this.elements.root.remove()));const ie=X?.styles??me;ie.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=ie.listFilterWidgetBackground),ie.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${ie.listFilterWidgetShadow}`);const re=this._register((0,U.createInstantHoverDelegate)());this.modeToggle=this._register(new J({...ie.toggleStyles,isChecked:M===_e.Filter,hoverDelegate:re})),this.matchTypeToggle=this._register(new le({...ie.toggleStyles,isChecked:z===Ne.Fuzzy,hoverDelegate:re})),this.onDidChangeMode=E.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?_e.Filter:_e.Highlight,this._store),this.onDidChangeMatchType=E.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?Ne.Fuzzy:Ne.Contiguous,this._store),this.findInput=this._register(new I.FindInput(this.elements.findInput,C,{label:(0,S.localize)(10454,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:ie.inputBoxStyles,toggleStyles:ie.toggleStyles,history:X?.history})),this.actionbar=this._register(new F.ActionBar(this.elements.actionbar)),this.mode=M;const ce=this._register(new n.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),we=E.Event.chain(ce.event,de=>de.map(Fe=>new P.StandardKeyboardEvent(Fe)));this._register(we(de=>{if(de.equals(A.KeyCode.Enter)){de.preventDefault(),de.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(de.equals(A.KeyCode.DownArrow)){de.preventDefault(),de.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(de.equals(A.KeyCode.UpArrow)){de.preventDefault(),de.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const Ee=this._register(new m.Action("close",(0,S.localize)(10455,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(Ee,{icon:!0,label:!1});const ye=this._register(new n.DomEmitter(this.elements.grab,"mousedown"));this._register(ye.event(de=>{const Fe=new f.DisposableStore,qe=Fe.add(new n.DomEmitter((0,i.getWindow)(de),"mousemove")),Ye=Fe.add(new n.DomEmitter((0,i.getWindow)(de),"mouseup")),tt=this.right,at=de.pageX,st=this.top,je=de.pageY;this.elements.grab.classList.add("grabbing");const Ze=this.elements.root.style.transition;this.elements.root.style.transition="unset";const Z=ue=>{const be=ue.pageX-at;this.right=tt-be;const Te=ue.pageY-je;this.top=st+Te,this.layout()};Fe.add(qe.event(Z)),Fe.add(Ye.event(ue=>{Z(ue),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=Ze,Fe.dispose()}))}));const Ie=E.Event.chain(this._register(new n.DomEmitter(this.elements.grab,"keydown")).event,de=>de.map(Fe=>new P.StandardKeyboardEvent(Fe)));this._register(Ie(de=>{let Fe,qe;if(de.keyCode===A.KeyCode.LeftArrow?Fe=Number.POSITIVE_INFINITY:de.keyCode===A.KeyCode.RightArrow?Fe=0:de.keyCode===A.KeyCode.Space&&(Fe=this.right===0?Number.POSITIVE_INFINITY:0),de.keyCode===A.KeyCode.UpArrow?qe=0:de.keyCode===A.KeyCode.DownArrow&&(qe=Number.POSITIVE_INFINITY),Fe!==void 0&&(de.preventDefault(),de.stopPropagation(),this.right=Fe,this.layout()),qe!==void 0){de.preventDefault(),de.stopPropagation(),this.top=qe;const Ye=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=Ye},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(u=this.width){this.width=u,this.right=(0,h.clamp)(this.right,0,Math.max(0,u-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,h.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(u){this.findInput.showMessage(u)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class ee{get pattern(){return this._pattern}get mode(){return this._mode}set mode(u){u!==this._mode&&(this._mode=u,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(u))}get matchType(){return this._matchType}set matchType(u){u!==this._matchType&&(this._matchType=u,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(u))}constructor(u,N,C,M,z,X={}){this.tree=u,this.view=C,this.filter=M,this.contextViewProvider=z,this.options=X,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new E.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new E.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new E.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new E.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new f.DisposableStore,this.disposables=new f.DisposableStore,this._mode=u.options.defaultFindMode??_e.Highlight,this._matchType=u.options.defaultFindMatchType??Ne.Fuzzy,N.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(u={}){u.defaultFindMode!==void 0&&(this.mode=u.defaultFindMode),u.defaultFindMatchType!==void 0&&(this.matchType=u.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new ne(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(u=>this.mode=u,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(u=>this.matchType=u,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){this.widget&&(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.clear(),this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(u){this._pattern=u,this._onDidChangePattern.fire(u),this.filter.pattern=u,this.tree.refilter(),u&&this.tree.focusNext(0,!0,void 0,C=>!T.FuzzyScore.isDefault(C.filterData));const N=this.tree.getFocus();if(N.length>0){const C=N[0];this.tree.getRelativeTop(C)===null&&this.tree.reveal(C,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const u=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&u?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:D.MessageType.WARNING,content:(0,S.localize)(10456,null)}):this.widget?.showMessage({type:D.MessageType.WARNING}):this.widget?.clearMessage()}shouldAllowFocus(u){return!this.widget||!this.pattern||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!T.FuzzyScore.isDefault(u.filterData)}layout(u){this.width=u,this.widget?.layout(u)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function he(L,u){return L.position===u.position&&ae(L,u)}function ae(L,u){return L.node.element===u.node.element&&L.startIndex===u.startIndex&&L.height===u.height&&L.endIndex===u.endIndex}class Le{constructor(u=[]){this.stickyNodes=u}get count(){return this.stickyNodes.length}equal(u){return(0,e.equals)(this.stickyNodes,u.stickyNodes,he)}lastNodePartiallyVisible(){if(this.count===0)return!1;const u=this.stickyNodes[this.count-1];if(this.count===1)return u.position!==0;const N=this.stickyNodes[this.count-2];return N.position+N.height!==u.position}animationStateChanged(u){if(!(0,e.equals)(this.stickyNodes,u.stickyNodes,ae)||this.count===0)return!1;const N=this.stickyNodes[this.count-1],C=u.stickyNodes[u.count-1];return N.position!==C.position}}class te{constrainStickyScrollNodes(u,N,C){for(let M=0;M<u.length;M++){const z=u[M];if(z.position+z.height>C||M>=N)return u.slice(0,M)}return u}}class pe extends f.Disposable{constructor(u,N,C,M,z,X={}){super(),this.tree=u,this.model=N,this.view=C,this.treeDelegate=z,this.maxWidgetViewRatio=.4;const ie=this.validateStickySettings(X);this.stickyScrollMaxItemCount=ie.stickyScrollMaxItemCount,this.stickyScrollDelegate=X.stickyScrollDelegate??new te,this._widget=this._register(new Ae(C.getScrollableElement(),C,u,M,z,X.accessibilityProvider)),this.onDidChangeHasFocus=this._widget.onDidChangeHasFocus,this.onContextMenu=this._widget.onContextMenu,this._register(C.onDidScroll(()=>this.update())),this._register(C.onDidChangeContentHeight(()=>this.update())),this._register(u.onDidChangeCollapseState(()=>this.update())),this.update()}get height(){return this._widget.height}get count(){return this._widget.count}getNode(u){return this._widget.getNode(u)}getNodeAtHeight(u){let N;if(u===0?N=this.view.firstVisibleIndex:N=this.view.indexAt(u+this.view.scrollTop),!(N<0||N>=this.view.length))return this.view.element(N)}update(){const u=this.getNodeAtHeight(0);if(!u||this.tree.scrollTop===0){this._widget.setState(void 0);return}const N=this.findStickyState(u);this._widget.setState(N)}findStickyState(u){const N=[];let C=u,M=0,z=this.getNextStickyNode(C,void 0,M);for(;z&&(N.push(z),M+=z.height,!(N.length<=this.stickyScrollMaxItemCount&&(C=this.getNextVisibleNode(z),!C)));)z=this.getNextStickyNode(C,z.node,M);const X=this.constrainStickyNodes(N);return X.length?new Le(X):void 0}getNextVisibleNode(u){return this.getNodeAtHeight(u.position+u.height)}getNextStickyNode(u,N,C){const M=this.getAncestorUnderPrevious(u,N);if(M&&!(M===u&&(!this.nodeIsUncollapsedParent(u)||this.nodeTopAlignsWithStickyNodesBottom(u,C))))return this.createStickyScrollNode(M,C)}nodeTopAlignsWithStickyNodesBottom(u,N){const C=this.getNodeIndex(u),M=this.view.getElementTop(C),z=N;return this.view.scrollTop===M-z}createStickyScrollNode(u,N){const C=this.treeDelegate.getHeight(u),{startIndex:M,endIndex:z}=this.getNodeRange(u),X=this.calculateStickyNodePosition(z,N,C);return{node:u,position:X,height:C,startIndex:M,endIndex:z}}getAncestorUnderPrevious(u,N=void 0){let C=u,M=this.getParentNode(C);for(;M;){if(M===N)return C;C=M,M=this.getParentNode(C)}if(N===void 0)return C}calculateStickyNodePosition(u,N,C){let M=this.view.getRelativeTop(u);if(M===null&&this.view.firstVisibleIndex===u&&u+1<this.view.length){const ce=this.treeDelegate.getHeight(this.view.element(u)),we=this.view.getRelativeTop(u+1);M=we?we-ce/this.view.renderHeight:null}if(M===null)return N;const z=this.view.element(u),X=this.treeDelegate.getHeight(z),re=M*this.view.renderHeight+X;return N+C>re&&N<=re?re-C:N}constrainStickyNodes(u){if(u.length===0)return[];const N=this.view.renderHeight*this.maxWidgetViewRatio,C=u[u.length-1];if(u.length<=this.stickyScrollMaxItemCount&&C.position+C.height<=N)return u;const M=this.stickyScrollDelegate.constrainStickyScrollNodes(u,this.stickyScrollMaxItemCount,N);if(!M.length)return[];const z=M[M.length-1];if(M.length>this.stickyScrollMaxItemCount||z.position+z.height>N)throw new Error("stickyScrollDelegate violates constraints");return M}getParentNode(u){const N=this.model.getNodeLocation(u),C=this.model.getParentNodeLocation(N);return C?this.model.getNode(C):void 0}nodeIsUncollapsedParent(u){const N=this.model.getNodeLocation(u);return this.model.getListRenderCount(N)>1}getNodeIndex(u){const N=this.model.getNodeLocation(u);return this.model.getListIndex(N)}getNodeRange(u){const N=this.model.getNodeLocation(u),C=this.model.getListIndex(N);if(C<0)throw new Error("Node not found in tree");const M=this.model.getListRenderCount(N),z=C+M-1;return{startIndex:C,endIndex:z}}nodePositionTopBelowWidget(u){const N=[];let C=this.getParentNode(u);for(;C;)N.push(C),C=this.getParentNode(C);let M=0;for(let z=0;z<N.length&&z<this.stickyScrollMaxItemCount;z++)M+=this.treeDelegate.getHeight(N[z]);return M}getFocus(){return this._widget.getFocus()}domFocus(){this._widget.domFocus()}focusedLast(){return this._widget.focusedLast()}updateOptions(u={}){if(!u.stickyScrollMaxItemCount)return;const N=this.validateStickySettings(u);this.stickyScrollMaxItemCount!==N.stickyScrollMaxItemCount&&(this.stickyScrollMaxItemCount=N.stickyScrollMaxItemCount,this.update())}validateStickySettings(u){let N=7;return typeof u.stickyScrollMaxItemCount=="number"&&(N=Math.max(u.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:N}}}class Ae{constructor(u,N,C,M,z,X){this.view=N,this.tree=C,this.treeRenderers=M,this.treeDelegate=z,this.accessibilityProvider=X,this._previousElements=[],this._previousStateDisposables=new f.DisposableStore,this._rootDomNode=(0,i.$)(".monaco-tree-sticky-container.empty"),u.appendChild(this._rootDomNode);const ie=(0,i.$)(".monaco-tree-sticky-container-shadow");this._rootDomNode.appendChild(ie),this.stickyScrollFocus=new Ce(this._rootDomNode,N),this.onDidChangeHasFocus=this.stickyScrollFocus.onDidChangeHasFocus,this.onContextMenu=this.stickyScrollFocus.onContextMenu}get height(){if(!this._previousState)return 0;const u=this._previousState.stickyNodes[this._previousState.count-1];return u.position+u.height}get count(){return this._previousState?.count??0}getNode(u){return this._previousState?.stickyNodes.find(N=>N.node===u)}setState(u){const N=!!this._previousState&&this._previousState.count>0,C=!!u&&u.count>0;if(!N&&!C||N&&C&&this._previousState.equal(u))return;if(N!==C&&this.setVisible(C),!C){this._previousState=void 0,this._previousElements=[],this._previousStateDisposables.clear();return}const M=u.stickyNodes[u.count-1];if(this._previousState&&u.animationStateChanged(this._previousState))this._previousElements[this._previousState.count-1].style.top=`${M.position}px`;else{this._previousStateDisposables.clear();const z=Array(u.count);for(let X=u.count-1;X>=0;X--){const ie=u.stickyNodes[X],{element:re,disposable:ce}=this.createElement(ie,X,u.count);z[X]=re,this._rootDomNode.appendChild(re),this._previousStateDisposables.add(ce)}this.stickyScrollFocus.updateElements(z,u),this._previousElements=z}this._previousState=u,this._rootDomNode.style.height=`${M.position+M.height}px`}createElement(u,N,C){const M=u.startIndex,z=document.createElement("div");z.style.top=`${u.position}px`,this.tree.options.setRowHeight!==!1&&(z.style.height=`${u.height}px`),this.tree.options.setRowLineHeight!==!1&&(z.style.lineHeight=`${u.height}px`),z.classList.add("monaco-tree-sticky-row"),z.classList.add("monaco-list-row"),z.setAttribute("data-index",`${M}`),z.setAttribute("data-parity",M%2===0?"even":"odd"),z.setAttribute("id",this.view.getElementID(M));const X=this.setAccessibilityAttributes(z,u.node.element,N,C),ie=this.treeDelegate.getTemplateId(u.node),re=this.treeRenderers.find(ye=>ye.templateId===ie);if(!re)throw new Error(`No renderer found for template id ${ie}`);let ce=u.node;ce===this.tree.getNode(this.tree.getNodeLocation(u.node))&&(ce=new Proxy(u.node,{}));const we=re.renderTemplate(z);re.renderElement(ce,u.startIndex,we,u.height);const Ee=(0,f.toDisposable)(()=>{X.dispose(),re.disposeElement(ce,u.startIndex,we,u.height),re.disposeTemplate(we),z.remove()});return{element:z,disposable:Ee}}setAccessibilityAttributes(u,N,C,M){if(!this.accessibilityProvider)return f.Disposable.None;this.accessibilityProvider.getSetSize&&u.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(N,C,M))),this.accessibilityProvider.getPosInSet&&u.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(N,C))),this.accessibilityProvider.getRole&&u.setAttribute("role",this.accessibilityProvider.getRole(N)??"treeitem");const z=this.accessibilityProvider.getAriaLabel(N),X=z&&typeof z!="string"?z:(0,H.constObservable)(z),ie=(0,H.autorun)(ce=>{const we=ce.readObservable(X);we?u.setAttribute("aria-label",we):u.removeAttribute("aria-label")});typeof z=="string"||z&&u.setAttribute("aria-label",z.get());const re=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(N);return typeof re=="number"&&u.setAttribute("aria-level",`${re}`),u.setAttribute("aria-selected",String(!1)),ie}setVisible(u){this._rootDomNode.classList.toggle("empty",!u),u||this.stickyScrollFocus.updateElements([],void 0)}getFocus(){return this.stickyScrollFocus.getFocus()}domFocus(){this.stickyScrollFocus.domFocus()}focusedLast(){return this.stickyScrollFocus.focusedLast()}dispose(){this.stickyScrollFocus.dispose(),this._previousStateDisposables.dispose(),this._rootDomNode.remove()}}class Ce extends f.Disposable{get domHasFocus(){return this._domHasFocus}set domHasFocus(u){u!==this._domHasFocus&&(this._onDidChangeHasFocus.fire(u),this._domHasFocus=u)}constructor(u,N){super(),this.container=u,this.view=N,this.focusedIndex=-1,this.elements=[],this._onDidChangeHasFocus=new E.Emitter,this.onDidChangeHasFocus=this._onDidChangeHasFocus.event,this._onContextMenu=new E.Emitter,this.onContextMenu=this._onContextMenu.event,this._domHasFocus=!1,this._register((0,i.addDisposableListener)(this.container,"focus",()=>this.onFocus())),this._register((0,i.addDisposableListener)(this.container,"blur",()=>this.onBlur())),this._register(this.view.onDidFocus(()=>this.toggleStickyScrollFocused(!1))),this._register(this.view.onKeyDown(C=>this.onKeyDown(C))),this._register(this.view.onMouseDown(C=>this.onMouseDown(C))),this._register(this.view.onContextMenu(C=>this.handleContextMenu(C)))}handleContextMenu(u){const N=u.browserEvent.target;if(!(0,d.isStickyScrollContainer)(N)&&!(0,d.isStickyScrollElement)(N)){this.focusedLast()&&this.view.domFocus();return}if(!(0,i.isKeyboardEvent)(u.browserEvent)){if(!this.state)throw new Error("Context menu should not be triggered when state is undefined");const X=this.state.stickyNodes.findIndex(ie=>ie.node.element===u.element?.element);if(X===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.container.focus(),this.setFocus(X);return}if(!this.state||this.focusedIndex<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const M=this.state.stickyNodes[this.focusedIndex].node.element,z=this.elements[this.focusedIndex];this._onContextMenu.fire({element:M,anchor:z,browserEvent:u.browserEvent,isStickyScroll:!0})}onKeyDown(u){if(this.domHasFocus&&this.state){if(u.key==="ArrowUp")this.setFocusedElement(Math.max(0,this.focusedIndex-1)),u.preventDefault(),u.stopPropagation();else if(u.key==="ArrowDown"||u.key==="ArrowRight"){if(this.focusedIndex>=this.state.count-1){const N=this.state.stickyNodes[this.state.count-1].startIndex+1;this.view.domFocus(),this.view.setFocus([N]),this.scrollNodeUnderWidget(N,this.state)}else this.setFocusedElement(this.focusedIndex+1);u.preventDefault(),u.stopPropagation()}}}onMouseDown(u){const N=u.browserEvent.target;!(0,d.isStickyScrollContainer)(N)&&!(0,d.isStickyScrollElement)(N)||(u.browserEvent.preventDefault(),u.browserEvent.stopPropagation())}updateElements(u,N){if(N&&N.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(N&&N.count!==u.length)throw new Error("Sticky scroll focus received illigel state");const C=this.focusedIndex;if(this.removeFocus(),this.elements=u,this.state=N,N){const M=(0,h.clamp)(C,0,N.count-1);this.setFocus(M)}else this.domHasFocus&&this.view.domFocus();this.container.tabIndex=N?0:-1}setFocusedElement(u){const N=this.state;if(!N)throw new Error("Cannot set focus when state is undefined");if(this.setFocus(u),!(u<N.count-1)&&N.lastNodePartiallyVisible()){const C=N.stickyNodes[u];this.scrollNodeUnderWidget(C.endIndex+1,N)}}scrollNodeUnderWidget(u,N){const C=N.stickyNodes[N.count-1],M=N.count>1?N.stickyNodes[N.count-2]:void 0,z=this.view.getElementTop(u),X=M?M.position+M.height+C.height:C.height;this.view.scrollTop=z-X}getFocus(){if(!(!this.state||this.focusedIndex===-1))return this.state.stickyNodes[this.focusedIndex].node.element}domFocus(){if(!this.state)throw new Error("Cannot focus when state is undefined");this.container.focus()}focusedLast(){return this.state?this.view.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}removeFocus(){this.focusedIndex!==-1&&(this.toggleElementFocus(this.elements[this.focusedIndex],!1),this.focusedIndex=-1)}setFocus(u){if(0>u)throw new Error("addFocus() can not remove focus");if(!this.state&&u>=0)throw new Error("Cannot set focus index when state is undefined");if(this.state&&u>=this.state.count)throw new Error("Cannot set focus index to an index that does not exist");const N=this.focusedIndex;N>=0&&this.toggleElementFocus(this.elements[N],!1),u>=0&&this.toggleElementFocus(this.elements[u],!0),this.focusedIndex=u}toggleElementFocus(u,N){this.toggleElementActiveFocus(u,N&&this.domHasFocus),this.toggleElementPassiveFocus(u,N)}toggleCurrentElementActiveFocus(u){this.focusedIndex!==-1&&this.toggleElementActiveFocus(this.elements[this.focusedIndex],u)}toggleElementActiveFocus(u,N){u.classList.toggle("focused",N)}toggleElementPassiveFocus(u,N){u.classList.toggle("passive-focused",N)}toggleStickyScrollFocused(u){this.view.getHTMLElement().classList.toggle("sticky-scroll-focused",u)}onFocus(){if(!this.state||this.elements.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.domHasFocus=!0,this.toggleStickyScrollFocused(!0),this.toggleCurrentElementActiveFocus(!0),this.focusedIndex===-1&&this.setFocus(0)}onBlur(){this.domHasFocus=!1,this.toggleCurrentElementActiveFocus(!1)}dispose(){this.toggleStickyScrollFocused(!1),this._onDidChangeHasFocus.fire(!1),super.dispose()}}function Re(L){let u=b.TreeMouseEventTarget.Unknown;return(0,i.hasParentWithClass)(L.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?u=b.TreeMouseEventTarget.Twistie:(0,i.hasParentWithClass)(L.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?u=b.TreeMouseEventTarget.Element:(0,i.hasParentWithClass)(L.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(u=b.TreeMouseEventTarget.Filter),{browserEvent:L.browserEvent,element:L.element?L.element.element:null,target:u}}function xe(L){const u=(0,d.isStickyScrollContainer)(L.browserEvent.target);return{element:L.element?L.element.element:null,browserEvent:L.browserEvent,anchor:L.anchor,isStickyScroll:u}}function He(L,u){u(L),L.children.forEach(N=>He(N,u))}class ${get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(u,N){this.getFirstViewElementWithTrait=u,this.identityProvider=N,this.nodes=[],this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event}set(u,N){!N?.__forceEvent&&(0,e.equals)(this.nodes,u)||this._set(u,!1,N)}_set(u,N,C){if(this.nodes=[...u],this.elements=void 0,this._nodeSet=void 0,!N){const M=this;this._onDidChange.fire({get elements(){return M.get()},browserEvent:C})}}get(){return this.elements||(this.elements=this.nodes.map(u=>u.element)),[...this.elements]}getNodes(){return this.nodes}has(u){return this.nodeSet.has(u)}onDidModelSplice({insertedNodes:u,deletedNodes:N}){if(!this.identityProvider){const re=this.createNodeSet(),ce=we=>re.delete(we);N.forEach(we=>He(we,ce)),this.set([...re.values()]);return}const C=new Set,M=re=>C.add(this.identityProvider.getId(re.element).toString());N.forEach(re=>He(re,M));const z=new Map,X=re=>z.set(this.identityProvider.getId(re.element).toString(),re);u.forEach(re=>He(re,X));const ie=[];for(const re of this.nodes){const ce=this.identityProvider.getId(re.element).toString();if(!C.has(ce))ie.push(re);else{const Ee=z.get(ce);Ee&&Ee.visible&&ie.push(Ee)}}if(this.nodes.length>0&&ie.length===0){const re=this.getFirstViewElementWithTrait();re&&ie.push(re)}this._set(ie,!0)}createNodeSet(){const u=new Set;for(const N of this.nodes)u.add(N);return u}}class B extends d.MouseController{constructor(u,N,C){super(u),this.tree=N,this.stickyScrollProvider=C}onViewPointer(u){if((0,d.isButton)(u.browserEvent.target)||(0,d.isInputElement)(u.browserEvent.target)||(0,d.isMonacoEditor)(u.browserEvent.target)||u.browserEvent.isHandledByList)return;const N=u.element;if(!N)return super.onViewPointer(u);if(this.isSelectionRangeChangeEvent(u)||this.isSelectionSingleChangeEvent(u))return super.onViewPointer(u);const C=u.browserEvent.target,M=C.classList.contains("monaco-tl-twistie")||C.classList.contains("monaco-icon-label")&&C.classList.contains("folder-icon")&&u.browserEvent.offsetX<16,z=(0,d.isStickyScrollElement)(u.browserEvent.target);let X=!1;if(z?X=!0:typeof this.tree.expandOnlyOnTwistieClick=="function"?X=this.tree.expandOnlyOnTwistieClick(N.element):X=!!this.tree.expandOnlyOnTwistieClick,z)this.handleStickyScrollMouseEvent(u,N);else{if(X&&!M&&u.browserEvent.detail!==2)return super.onViewPointer(u);if(!this.tree.expandOnDoubleClick&&u.browserEvent.detail===2)return super.onViewPointer(u)}if(N.collapsible&&(!z||M)){const ie=this.tree.getNodeLocation(N),re=u.browserEvent.altKey;if(this.tree.setFocus([ie]),this.tree.toggleCollapsed(ie,re),M){u.browserEvent.isHandledByList=!0;return}}z||super.onViewPointer(u)}handleStickyScrollMouseEvent(u,N){if((0,d.isMonacoCustomToggle)(u.browserEvent.target)||(0,d.isActionItem)(u.browserEvent.target))return;const C=this.stickyScrollProvider();if(!C)throw new Error("Sticky scroll controller not found");const M=this.list.indexOf(N),z=this.list.getElementTop(M),X=C.nodePositionTopBelowWidget(N);this.tree.scrollTop=z-X,this.list.domFocus(),this.list.setFocus([M]),this.list.setSelection([M])}onDoubleClick(u){u.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||u.browserEvent.isHandledByList||super.onDoubleClick(u)}onMouseDown(u){const N=u.browserEvent.target;if(!(0,d.isStickyScrollContainer)(N)&&!(0,d.isStickyScrollElement)(N)){super.onMouseDown(u);return}}onContextMenu(u){const N=u.browserEvent.target;if(!(0,d.isStickyScrollContainer)(N)&&!(0,d.isStickyScrollElement)(N)){super.onContextMenu(u);return}}}class a extends d.List{constructor(u,N,C,M,z,X,ie,re){super(u,N,C,M,re),this.focusTrait=z,this.selectionTrait=X,this.anchorTrait=ie}createMouseController(u){return new B(this,u.tree,u.stickyScrollProvider)}splice(u,N,C=[]){if(super.splice(u,N,C),C.length===0)return;const M=[],z=[];let X;C.forEach((ie,re)=>{this.focusTrait.has(ie)&&M.push(u+re),this.selectionTrait.has(ie)&&z.push(u+re),this.anchorTrait.has(ie)&&(X=u+re)}),M.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...M])),z.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...z])),typeof X=="number"&&super.setAnchor(X)}setFocus(u,N,C=!1){super.setFocus(u,N),C||this.focusTrait.set(u.map(M=>this.element(M)),N)}setSelection(u,N,C=!1){super.setSelection(u,N),C||this.selectionTrait.set(u.map(M=>this.element(M)),N)}setAnchor(u,N=!1){super.setAnchor(u),N||(typeof u>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(u)]))}}var o;(function(L){L[L.Tree=0]="Tree",L[L.StickyScroll=1]="StickyScroll"})(o||(t.AbstractTreePart=o={}));class g{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return E.Event.map(this.view.onMouseClick,Re)}get onMouseDblClick(){return E.Event.filter(E.Event.map(this.view.onMouseDblClick,Re),u=>u.target!==b.TreeMouseEventTarget.Filter)}get onMouseOver(){return E.Event.map(this.view.onMouseOver,Re)}get onMouseOut(){return E.Event.map(this.view.onMouseOut,Re)}get onContextMenu(){return E.Event.any(E.Event.filter(E.Event.map(this.view.onContextMenu,xe),u=>!u.isStickyScroll),this.stickyScrollController?.onContextMenu??E.Event.None)}get onTap(){return E.Event.map(this.view.onTap,Re)}get onPointer(){return E.Event.map(this.view.onPointer,Re)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return E.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??_e.Highlight}set findMode(u){this.findController&&(this.findController.mode=u)}get findMatchType(){return this.findController?.matchType??Ne.Fuzzy}set findMatchType(u){this.findController&&(this.findController.matchType=u)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:E.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(u,N,C,M,z={}){this._user=u,this._options=z,this.eventBufferer=new E.EventBufferer,this.onDidChangeFindOpenState=E.Event.None,this.onDidChangeStickyScrollFocused=E.Event.None,this.disposables=new f.DisposableStore,this._onWillRefilter=new E.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new E.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event,this.treeDelegate=new R(C);const X=new E.Relay,ie=new E.Relay,re=this.disposables.add(new Q(ie.event)),ce=new l.SetMap;this.renderers=M.map(de=>new j(de,()=>this.model,X.event,re,ce,z));for(const de of this.renderers)this.disposables.add(de);let we;z.keyboardNavigationLabelProvider&&(we=new q(this,z.keyboardNavigationLabelProvider,z.filter),z={...z,filter:we},this.disposables.add(we)),this.focus=new $(()=>this.view.getFocusedElements()[0],z.identityProvider),this.selection=new $(()=>this.view.getSelectedElements()[0],z.identityProvider),this.anchor=new $(()=>this.view.getAnchorElement(),z.identityProvider),this.view=new a(u,N,this.treeDelegate,this.renderers,this.focus,this.selection,this.anchor,{...V(()=>this.model,z),tree:this,stickyScrollProvider:()=>this.stickyScrollController}),this.model=this.createModel(u,this.view,z),X.input=this.model.onDidChangeCollapseState;const Ee=E.Event.forEach(this.model.onDidSplice,de=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(de),this.selection.onDidModelSplice(de)})},this.disposables);Ee(()=>null,null,this.disposables);const ye=this.disposables.add(new E.Emitter),Ie=this.disposables.add(new s.Delayer(0));if(this.disposables.add(E.Event.any(Ee,this.focus.onDidChange,this.selection.onDidChange)(()=>{Ie.trigger(()=>{const de=new Set;for(const Fe of this.focus.getNodes())de.add(Fe);for(const Fe of this.selection.getNodes())de.add(Fe);ye.fire([...de.values()])})})),ie.input=ye.event,z.keyboardSupport!==!1){const de=E.Event.chain(this.view.onKeyDown,Fe=>Fe.filter(qe=>!(0,d.isInputElement)(qe.target)).map(qe=>new P.StandardKeyboardEvent(qe)));E.Event.chain(de,Fe=>Fe.filter(qe=>qe.keyCode===A.KeyCode.LeftArrow))(this.onLeftArrow,this,this.disposables),E.Event.chain(de,Fe=>Fe.filter(qe=>qe.keyCode===A.KeyCode.RightArrow))(this.onRightArrow,this,this.disposables),E.Event.chain(de,Fe=>Fe.filter(qe=>qe.keyCode===A.KeyCode.Space))(this.onSpace,this,this.disposables)}if((z.findWidgetEnabled??!0)&&z.keyboardNavigationLabelProvider&&z.contextViewProvider){const de=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new ee(this,this.model,this.view,we,z.contextViewProvider,de),this.focusNavigationFilter=Fe=>this.findController.shouldAllowFocus(Fe),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=E.Event.None,this.onDidChangeFindMatchType=E.Event.None;z.enableStickyScroll&&(this.stickyScrollController=new pe(this,this.model,this.view,this.renderers,this.treeDelegate,z),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus),this.styleElement=(0,i.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===G.Always)}updateOptions(u={}){this._options={...this._options,...u};for(const N of this.renderers)N.updateOptions(u);this.view.updateOptions(this._options),this.findController?.updateOptions(u),this.updateStickyScroll(u),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===G.Always)}get options(){return this._options}updateStickyScroll(u){!this.stickyScrollController&&this._options.enableStickyScroll?(this.stickyScrollController=new pe(this,this.model,this.view,this.renderers,this.treeDelegate,this._options),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus):this.stickyScrollController&&!this._options.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=E.Event.None,this.stickyScrollController.dispose(),this.stickyScrollController=void 0),this.stickyScrollController?.updateOptions(u)}updateWidth(u){const N=this.model.getListIndex(u);N!==-1&&this.view.updateWidth(N)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.scrollTop}set scrollTop(u){this.view.scrollTop=u}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(u){this.view.scrollLeft=u}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){let u=this.view.firstVisibleIndex;return this.stickyScrollController&&(u+=this.stickyScrollController.count),u<0||u>=this.view.length?void 0:this.view.element(u).element}get lastVisibleElement(){const u=this.view.lastVisibleIndex;return this.view.element(u).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(u){this.view.ariaLabel=u}get selectionSize(){return this.selection.getNodes().length}domFocus(){this.stickyScrollController?.focusedLast()?this.stickyScrollController.domFocus():this.view.domFocus()}isDOMFocused(){return(0,i.isActiveElement)(this.getHTMLElement())}layout(u,N){this.view.layout(u,N),(0,p.isNumber)(N)&&this.findController?.layout(N)}style(u){const N=`.${this.view.domId}`,C=[];u.treeIndentGuidesStroke&&(C.push(`.monaco-list${N}:hover .monaco-tl-indent > .indent-guide, .monaco-list${N}.always .monaco-tl-indent > .indent-guide  { border-color: ${u.treeInactiveIndentGuidesStroke}; }`),C.push(`.monaco-list${N} .monaco-tl-indent > .indent-guide.active { border-color: ${u.treeIndentGuidesStroke}; }`));const M=u.treeStickyScrollBackground??u.listBackground;M&&(C.push(`.monaco-list${N} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${M}; }`),C.push(`.monaco-list${N} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${M}; }`)),u.treeStickyScrollBorder&&C.push(`.monaco-list${N} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${u.treeStickyScrollBorder}; }`),u.treeStickyScrollShadow&&C.push(`.monaco-list${N} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${u.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),u.listFocusForeground&&(C.push(`.monaco-list${N}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),C.push(`.monaco-list${N}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const z=(0,i.asCssValueWithDefault)(u.listFocusAndSelectionOutline,(0,i.asCssValueWithDefault)(u.listSelectionOutline,u.listFocusOutline??""));z&&(C.push(`.monaco-list${N}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${z}; outline-offset: -1px;}`),C.push(`.monaco-list${N}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),u.listFocusOutline&&(C.push(`.monaco-list${N}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),C.push(`.monaco-list${N}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),C.push(`.monaco-workbench.context-menu-visible .monaco-list${N}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),C.push(`.monaco-workbench.context-menu-visible .monaco-list${N}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),C.push(`.monaco-workbench.context-menu-visible .monaco-list${N}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.styleElement.textContent=C.join(`
`),this.view.style(u)}getParentElement(u){const N=this.model.getParentNodeLocation(u);return this.model.getNode(N).element}getFirstElementChild(u){return this.model.getFirstElementChild(u)}getNode(u){return this.model.getNode(u)}getNodeLocation(u){return this.model.getNodeLocation(u)}collapse(u,N=!1){return this.model.setCollapsed(u,!0,N)}expand(u,N=!1){return this.model.setCollapsed(u,!1,N)}toggleCollapsed(u,N=!1){return this.model.setCollapsed(u,void 0,N)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(u){return this.model.isCollapsible(u)}setCollapsible(u,N){return this.model.setCollapsible(u,N)}isCollapsed(u){return this.model.isCollapsed(u)}expandTo(u){this.model.expandTo(u)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(u){if(typeof u>"u")return this.view.setAnchor(void 0);this.eventBufferer.bufferEvents(()=>{const N=this.model.getNode(u);this.anchor.set([N]);const C=this.model.getListIndex(u);C>-1&&this.view.setAnchor(C,!0)})}getAnchor(){return(0,e.firstOrDefault)(this.anchor.get(),void 0)}setSelection(u,N){this.eventBufferer.bufferEvents(()=>{const C=u.map(z=>this.model.getNode(z));this.selection.set(C,N);const M=u.map(z=>this.model.getListIndex(z)).filter(z=>z>-1);this.view.setSelection(M,N,!0)})}getSelection(){return this.selection.get()}setFocus(u,N){this.eventBufferer.bufferEvents(()=>{const C=u.map(z=>this.model.getNode(z));this.focus.set(C,N);const M=u.map(z=>this.model.getListIndex(z)).filter(z=>z>-1);this.view.setFocus(M,N,!0)})}focusNext(u=1,N=!1,C,M=(0,i.isKeyboardEvent)(C)&&C.altKey?void 0:this.focusNavigationFilter){this.view.focusNext(u,N,C,M)}focusPrevious(u=1,N=!1,C,M=(0,i.isKeyboardEvent)(C)&&C.altKey?void 0:this.focusNavigationFilter){this.view.focusPrevious(u,N,C,M)}focusNextPage(u,N=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){return this.view.focusNextPage(u,N)}focusPreviousPage(u,N=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){return this.view.focusPreviousPage(u,N,()=>this.stickyScrollController?.height??0)}focusLast(u,N=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){this.view.focusLast(u,N)}focusFirst(u,N=(0,i.isKeyboardEvent)(u)&&u.altKey?void 0:this.focusNavigationFilter){this.view.focusFirst(u,N)}getFocus(){return this.focus.get()}getStickyScrollFocus(){const u=this.stickyScrollController?.getFocus();return u!==void 0?[u]:[]}getFocusedPart(){return this.stickyScrollController?.focusedLast()?o.StickyScroll:o.Tree}reveal(u,N){this.model.expandTo(u);const C=this.model.getListIndex(u);if(C!==-1)if(!this.stickyScrollController)this.view.reveal(C,N);else{const M=this.stickyScrollController.nodePositionTopBelowWidget(this.getNode(u));this.view.reveal(C,N,M)}}getRelativeTop(u){const N=this.model.getListIndex(u);if(N===-1)return null;const C=this.stickyScrollController?.getNode(this.getNode(u));return this.view.getRelativeTop(N,C?.position??this.stickyScrollController?.height)}getViewState(u=this.options.identityProvider){if(!u)throw new b.TreeError(this._user,"Can't get tree view state without an identity provider");const N=X=>u.getId(X).toString(),C=W.empty(this.scrollTop);for(const X of this.getFocus())C.focus.add(N(X));for(const X of this.getSelection())C.selection.add(N(X));const M=this.model.getNode(),z=[M];for(;z.length>0;){const X=z.shift();X!==M&&X.collapsible&&(C.expanded[N(X.element)]=X.collapsed?0:1),z.push(...X.children)}return C}onLeftArrow(u){u.preventDefault(),u.stopPropagation();const N=this.view.getFocusedElements();if(N.length===0)return;const C=N[0],M=this.model.getNodeLocation(C);if(!this.model.setCollapsed(M,!0)){const X=this.model.getParentNodeLocation(M);if(!X)return;const ie=this.model.getListIndex(X);this.view.reveal(ie),this.view.setFocus([ie])}}onRightArrow(u){u.preventDefault(),u.stopPropagation();const N=this.view.getFocusedElements();if(N.length===0)return;const C=N[0],M=this.model.getNodeLocation(C);if(!this.model.setCollapsed(M,!1)){if(!C.children.some(re=>re.visible))return;const[X]=this.view.getFocus(),ie=X+1;this.view.reveal(ie),this.view.setFocus([ie])}}onSpace(u){u.preventDefault(),u.stopPropagation();const N=this.view.getFocusedElements();if(N.length===0)return;const C=N[0],M=this.model.getNodeLocation(C),z=u.browserEvent.altKey;this.model.setCollapsed(M,void 0,z)}navigate(u){return new k(this.view,this.model,u)}dispose(){(0,f.dispose)(this.disposables),this.stickyScrollController?.dispose(),this.view.dispose()}}t.AbstractTree=g;class k{constructor(u,N,C){this.view=u,this.model=N,C?this.index=this.model.getListIndex(C):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(ve[144],De([1,0,143,116,34,36]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class I extends i.AbstractTree{constructor(w,d,v,_,b,m={}){super(w,d,v,_,m),this.user=w,this.dataSource=b,this.nodesByIdentity=new Map,this.identityProvider=m.identityProvider}getInput(){return this.input}setInput(w,d){if(d&&!this.identityProvider)throw new P.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=w,!w){this.nodesByIdentity.clear(),this.model.setChildren(null,F.Iterable.empty());return}if(!d){this._refresh(w);return}const v=[],_=[],b=e=>{const s=this.identityProvider.getId(e).toString();return!d.expanded[s]},m=e=>{const s=this.identityProvider.getId(e.element).toString();d.focus.has(s)&&v.push(e.element),d.selection.has(s)&&_.push(e.element)};this._refresh(w,b,m),this.setFocus(v),this.setSelection(_),d&&typeof d.scrollTop=="number"&&(this.scrollTop=d.scrollTop)}updateChildren(w=this.input){if(typeof this.input>"u")throw new P.TreeError(this.user,"Tree input not set");let d;this.identityProvider&&(d=v=>{const _=this.identityProvider.getId(v).toString(),b=this.nodesByIdentity.get(_);if(b)return b.collapsed}),this._refresh(w,d)}resort(w=this.input,d=!0){this.model.resort(w===this.input?null:w,d)}refresh(w){if(w===void 0){this.view.rerender();return}this.model.rerender(w)}_refresh(w,d,v){let _;if(this.identityProvider){const b=new Set,m=v;v=e=>{const s=this.identityProvider.getId(e.element).toString();b.add(s),this.nodesByIdentity.set(s,e),m?.(e)},_=e=>{const s=this.identityProvider.getId(e.element).toString();b.has(s)||this.nodesByIdentity.delete(s)}}this.model.setChildren(w===this.input?null:w,this.iterate(w,d).elements,{onDidCreateNode:v,onDidDeleteNode:_})}iterate(w,d){const v=[...this.dataSource.getChildren(w)];return{elements:F.Iterable.map(v,b=>{const{elements:m,size:e}=this.iterate(b,d),s=this.dataSource.hasChildren?this.dataSource.hasChildren(b):void 0,r=e===0?void 0:d&&d(b);return{element:b,children:m,collapsible:s,collapsed:r}}),size:v.length}}createModel(w,d,v){return new n.ObjectTreeModel(w,d,v)}}t.DataTree=I}),define(ve[54],De([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IInstantiationService=t._util=void 0,t.createDecorator=P,t.refineServiceDecorator=F;var i;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function D(w){return w[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=D})(i||(t._util=i={})),t.IInstantiationService=P("instantiationService");function n(I,D,w){D[i.DI_TARGET]===D?D[i.DI_DEPENDENCIES].push({id:I,index:w}):(D[i.DI_DEPENDENCIES]=[{id:I,index:w}],D[i.DI_TARGET]=D)}function P(I){if(i.serviceIds.has(I))return i.serviceIds.get(I);const D=function(w,d,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(D,w,v)};return D.toString=()=>I,i.serviceIds.set(I,D),D}function F(I){return I}}),define(ve[145],De([1,0,54]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.IDiagnosticsService=t.ID=void 0,t.isRemoteDiagnosticError=n,t.ID="diagnosticsService",t.IDiagnosticsService=(0,i.createDecorator)(t.ID);function n(F){return!!F.hostName&&!!F.errorMessage}class P{async getPerformanceInfo(I,D){return{}}async getSystemInfo(I,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,D){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}t.NullDiagnosticsService=P}),define(ve[146],De([1,0,110,28,11,10,16,13,54,5,39,25]),function(oe,t,i,n,P,F,I,D,w,d,v,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ByteSize=t.ETAG_DISABLED=t.FileKind=t.FILES_READONLY_FROM_PERMISSIONS_CONFIG=t.FILES_READONLY_EXCLUDE_CONFIG=t.FILES_READONLY_INCLUDE_CONFIG=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.IFileService=void 0,t.isFileOpenForWriteOptions=b,t.isFileSystemWatcher=r,t.hasReadWriteCapability=l,t.hasFileFolderCopyCapability=E,t.hasFileCloneCapability=T,t.hasOpenReadWriteCloseCapability=A,t.hasFileReadStreamCapability=f,t.hasFileAtomicReadCapability=h,t.hasFileAtomicWriteCapability=p,t.hasFileAtomicDeleteCapability=S,t.hasReadonlyCapability=U,t.createFileSystemProviderError=y,t.ensureFileSystemProviderError=O,t.markAsFileSystemProviderError=V,t.toFileSystemProviderErrorCode=R,t.toFileOperationResult=W,t.isParent=J,t.etag=ee,t.whenProviderRegistered=he,t.getLargeFileConfirmationLimit=Le,t.IFileService=(0,w.createDecorator)("fileService");function b(te){return te.create===!0}var m;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(m||(t.FileType=m={}));var e;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function r(te){const pe=te;return!!pe&&typeof pe.onDidChange=="function"}var c;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(c||(t.FileSystemProviderCapabilities=c={}));function l(te){return!!(te.capabilities&c.FileReadWrite)}function E(te){return!!(te.capabilities&c.FileFolderCopy)}function T(te){return!!(te.capabilities&c.FileClone)}function A(te){return!!(te.capabilities&c.FileOpenReadWriteClose)}function f(te){return!!(te.capabilities&c.FileReadStream)}function h(te){return l(te)?!!(te.capabilities&c.FileAtomicRead):!1}function p(te){return l(te)?!!(te.capabilities&c.FileAtomicWrite):!1}function S(te){return!!(te.capabilities&c.FileAtomicDelete)}function U(te){return!!(te.capabilities&c.Readonly)}var H;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(H||(t.FileSystemProviderErrorCode=H={}));class x extends Error{static create(pe,Ae){const Ce=new x(pe.toString(),Ae);return V(Ce,Ae),Ce}constructor(pe,Ae){super(pe),this.code=Ae}}t.FileSystemProviderError=x;function y(te,pe){return x.create(te,pe)}function O(te){return te||y((0,D.localize)(11386,null),H.Unknown)}function V(te,pe){return te.name=pe?`${pe} (FileSystemError)`:"FileSystemError",te}function R(te){if(!te)return H.Unknown;if(te instanceof x)return te.code;const pe=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!pe)return H.Unknown;switch(pe[1]){case H.FileExists:return H.FileExists;case H.FileIsADirectory:return H.FileIsADirectory;case H.FileNotADirectory:return H.FileNotADirectory;case H.FileNotFound:return H.FileNotFound;case H.FileTooLarge:return H.FileTooLarge;case H.FileWriteLocked:return H.FileWriteLocked;case H.NoPermissions:return H.NoPermissions;case H.Unavailable:return H.Unavailable}return H.Unknown}function W(te){if(te instanceof le)return te.fileOperationResult;switch(R(te)){case H.FileNotFound:return Ne.FILE_NOT_FOUND;case H.FileIsADirectory:return Ne.FILE_IS_DIRECTORY;case H.FileNotADirectory:return Ne.FILE_NOT_DIRECTORY;case H.FileWriteLocked:return Ne.FILE_WRITE_LOCKED;case H.NoPermissions:return Ne.FILE_PERMISSION_DENIED;case H.FileExists:return Ne.FILE_MOVE_CONFLICT;case H.FileTooLarge:return Ne.FILE_TOO_LARGE;default:return Ne.FILE_OTHER_ERROR}}var G;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(G||(t.FileOperation=G={}));class Q{constructor(pe,Ae,Ce){this.resource=pe,this.operation=Ae,this.target=Ce}isOperation(pe){return this.operation===pe}}t.FileOperationEvent=Q;var j;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(j||(t.FileChangeType=j={}));class q{static{this.MIXED_CORRELATION=null}constructor(pe,Ae){this.ignorePathCasing=Ae,this.correlationId=void 0,this.added=new _.Lazy(()=>{const Ce=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Ce.fill(this.rawAdded.map(Re=>[Re,!0])),Ce}),this.updated=new _.Lazy(()=>{const Ce=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Ce.fill(this.rawUpdated.map(Re=>[Re,!0])),Ce}),this.deleted=new _.Lazy(()=>{const Ce=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Ce.fill(this.rawDeleted.map(Re=>[Re,!0])),Ce}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Ce of pe){switch(Ce.type){case j.ADDED:this.rawAdded.push(Ce.resource);break;case j.UPDATED:this.rawUpdated.push(Ce.resource);break;case j.DELETED:this.rawDeleted.push(Ce.resource);break}this.correlationId!==q.MIXED_CORRELATION&&(typeof Ce.cId=="number"?this.correlationId===void 0?this.correlationId=Ce.cId:this.correlationId!==Ce.cId&&(this.correlationId=q.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=q.MIXED_CORRELATION))}}contains(pe,...Ae){return this.doContains(pe,{includeChildren:!1},...Ae)}affects(pe,...Ae){return this.doContains(pe,{includeChildren:!0},...Ae)}doContains(pe,Ae,...Ce){if(!pe)return!1;const Re=Ce.length>0;return!!((!Re||Ce.includes(j.ADDED))&&(this.added.value.get(pe)||Ae.includeChildren&&this.added.value.findSuperstr(pe))||(!Re||Ce.includes(j.UPDATED))&&(this.updated.value.get(pe)||Ae.includeChildren&&this.updated.value.findSuperstr(pe))||(!Re||Ce.includes(j.DELETED))&&(this.deleted.value.findSubstr(pe)||Ae.includeChildren&&this.deleted.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.correlationId===pe}hasCorrelation(){return typeof this.correlationId=="number"}}t.FileChangesEvent=q;function J(te,pe,Ae){return!te||!pe||te===pe||pe.length>te.length?!1:(pe.charAt(pe.length-1)!==n.sep&&(pe+=n.sep),Ae?(0,P.startsWithIgnoreCase)(te,pe):te.indexOf(pe)===0)}class le extends Error{constructor(pe,Ae,Ce){super(pe),this.fileOperationResult=Ae,this.options=Ce}}t.FileOperationError=le;class me extends le{constructor(pe,Ae,Ce,Re){super(pe,Ae,Re),this.fileOperationResult=Ae,this.size=Ce}}t.TooLargeFileOperationError=me;class _e extends le{constructor(pe,Ae,Ce){super(pe,Ne.FILE_NOT_MODIFIED_SINCE,Ce),this.stat=Ae}}t.NotModifiedSinceFileOperationError=_e;var Ne;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ne||(t.FileOperationResult=Ne={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",t.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",t.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",t.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ne;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(t.FileKind=ne={})),t.ETAG_DISABLED="";function ee(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function he(te,pe){if(!pe.hasProvider(I.URI.from({scheme:te.scheme})))return new Promise(Ae=>{const Ce=pe.onDidChangeFileSystemProviderRegistrations(Re=>{Re.scheme===te.scheme&&Re.added&&(Ce.dispose(),Ae())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(pe){return(0,F.isNumber)(pe)||(pe=0),pe<ae.KB?(0,D.localize)(11387,null,pe.toFixed(0)):pe<ae.MB?(0,D.localize)(11388,null,(pe/ae.KB).toFixed(2)):pe<ae.GB?(0,D.localize)(11389,null,(pe/ae.MB).toFixed(2)):pe<ae.TB?(0,D.localize)(11390,null,(pe/ae.GB).toFixed(2)):(0,D.localize)(11391,null,(pe/ae.TB).toFixed(2))}}t.ByteSize=ae;function Le(te){const pe=typeof te=="string"||te?.scheme===v.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===v.Schemas.file?1024*ae.MB:pe?10*ae.MB:d.isWeb?50*ae.MB:1024*ae.MB}}),define(ve[147],De([1,0,54]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,i.createDecorator)("mainProcessService");class n{constructor(F,I){this.server=F,this.router=I}getChannel(F){return this.server.getChannel(F,this.router)}registerChannel(F,I){this.server.registerChannel(F,I)}}t.MainProcessService=n}),define(ve[148],De([1,0,2,124]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class P extends i.Disposable{constructor(I){super(),this.mainProcessConnection=this._register(new n.Client(`window:${I}`))}getChannel(I){return this.mainProcessConnection.getChannel(I)}registerChannel(I,D){this.mainProcessConnection.registerChannel(I,D)}}t.ElectronIPCMainProcessService=P});var Ci=this&&this.__param||function(oe,t){return function(i,n){t(i,n,oe)}};define(ve[149],De([1,0,74,147]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let P=class{constructor(I,D){return this.windowId=I,i.ProxyChannel.toService(D.getChannel("nativeHost"),{context:I,properties:(()=>{const w=new Map;return w.set("windowId",I),w})()})}};t.NativeHostService=P,t.NativeHostService=P=et([Ci(1,n.IMainProcessService)],P)}),define(ve[84],De([1,0,42,10]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0,i=Ue(i),n=Ue(n);class P{constructor(){this.data=new Map}add(I,D){i.ok(n.isString(I)),i.ok(n.isObject(D)),i.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,D)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}t.Registry=new P}),define(ve[150],De([1,0,3,91,84]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,P=Ue(P),t.Extensions={JSONContribution:"base.contributions.json"};function F(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class I{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,v){this.schemasById[F(d)]=v,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(d){const v=this.schemasById[d];return v?(0,n.getCompressedContent)(v):void 0}hasSchemaContent(d){return!!this.schemasById[d]}}const D=new I;P.Registry.add(t.Extensions.JSONContribution,D)}),define(ve[151],De([1,0,12,21,48,22,3,10,16,13,150,84]),function(oe,t,i,n,P,F,I,D,w,d,v,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.registerIcon=r,t.getIconRegistry=c,_=Ue(_),t.Extensions={IconContribution:"base.contributions.icons"};var b;(function(A){function f(h,p){let S=h.defaults;for(;F.ThemeIcon.isThemeIcon(S);){const U=s.getIcon(S.id);if(!U)return;S=U.defaults}return S}A.getDefinition=f})(b||(t.IconContribution=b={}));var m;(function(A){function f(p){return{weight:p.weight,style:p.style,src:p.src.map(S=>({format:S.format,location:S.location.toString()}))}}A.toJSONObject=f;function h(p){const S=U=>(0,D.isString)(U)?U:void 0;if(p&&Array.isArray(p.src)&&p.src.every(U=>(0,D.isString)(U.format)&&(0,D.isString)(U.location)))return{weight:S(p.weight),style:S(p.style),src:p.src.map(U=>({format:U.format,location:w.URI.parse(U.location)}))}}A.fromJSONObject=h})(m||(t.IconFontDefinition=m={}));class e{constructor(){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,d.localize)(11152,null)},fontCharacter:{type:"string",description:(0,d.localize)(11153,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${F.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(f,h,p,S){const U=this.iconsById[f];if(U){if(p&&!U.description){U.description=p,this.iconSchema.properties[f].markdownDescription=`${p} $(${f})`;const y=this.iconReferenceSchema.enum.indexOf(f);y!==-1&&(this.iconReferenceSchema.enumDescriptions[y]=p),this._onDidChange.fire()}return U}const H={id:f,description:p,defaults:h,deprecationMessage:S};this.iconsById[f]=H;const x={$ref:"#/definitions/icons"};return S&&(x.deprecationMessage=S),p&&(x.markdownDescription=`${p}: $(${f})`),this.iconSchema.properties[f]=x,this.iconReferenceSchema.enum.push(f),this.iconReferenceSchema.enumDescriptions.push(p||""),this._onDidChange.fire(),{id:f}}deregisterIcon(f){delete this.iconsById[f],delete this.iconSchema.properties[f];const h=this.iconReferenceSchema.enum.indexOf(f);h!==-1&&(this.iconReferenceSchema.enum.splice(h,1),this.iconReferenceSchema.enumDescriptions.splice(h,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(f=>this.iconsById[f])}getIcon(f){return this.iconsById[f]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(f,h){const p=this.iconFontsById[f];return p||(this.iconFontsById[f]=h,this._onDidChange.fire(),h)}deregisterIconFont(f){delete this.iconFontsById[f]}getIconFont(f){return this.iconFontsById[f]}toString(){const f=(U,H)=>U.id.localeCompare(H.id),h=U=>{for(;F.ThemeIcon.isThemeIcon(U.defaults);)U=this.iconsById[U.defaults.id];return`codicon codicon-${U?U.id:""}`},p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const S=Object.keys(this.iconsById).map(U=>this.iconsById[U]);for(const U of S.filter(H=>!!H.description).sort(f))p.push(`|<i class="${h(U)}"></i>|${U.id}|${F.ThemeIcon.isThemeIcon(U.defaults)?U.defaults.id:U.id}|${U.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const U of S.filter(H=>!F.ThemeIcon.isThemeIcon(H.defaults)).sort(f))p.push(`|<i class="${h(U)}"></i>|${U.id}|`);return p.join(`
`)}}const s=new e;_.Registry.add(t.Extensions.IconContribution,s);function r(A,f,h,p){return s.registerIcon(A,f,h,p)}function c(){return s}function l(){const A=(0,P.getCodiconFontCharacters)();for(const f in A){const h="\\"+A[f].toString(16);s.registerIcon(f,{fontCharacter:h})}}l(),t.iconsSchemaId="vscode://schemas/icons";const E=_.Registry.as(v.Extensions.JSONContribution);E.registerSchema(t.iconsSchemaId,s.getIconSchema());const T=new i.RunOnceScheduler(()=>E.notifySchemaChanged(t.iconsSchemaId),200);s.onDidChange(()=>{T.isScheduled()||T.schedule()}),t.widgetClose=r("widget-close",n.Codicon.close,(0,d.localize)(11154,null)),t.gotoPreviousLocation=r("goto-previous-location",n.Codicon.arrowUp,(0,d.localize)(11155,null)),t.gotoNextLocation=r("goto-next-location",n.Codicon.arrowDown,(0,d.localize)(11156,null)),t.syncing=F.ThemeIcon.modify(n.Codicon.sync,"spin"),t.spinningLoading=F.ThemeIcon.modify(n.Codicon.loading,"spin")}),define(ve[152],De([1,0,4,3,2,22,151]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=void 0,t.getIconsStyleSheet=D;function D(d){const v=new P.DisposableStore,_=v.add(new n.Emitter),b=(0,I.getIconRegistry)();return v.add(b.onDidChange(()=>_.fire())),d&&v.add(d.onDidProductIconThemeChange(()=>_.fire())),{dispose:()=>v.dispose(),onDidChange:_.event,getCSS(){const m=d?d.getProductIconTheme():new w,e={},s=[],r=[];for(const c of b.getIcons()){const l=m.getIcon(c);if(!l)continue;const E=l.font,T=`--vscode-icon-${c.id}-font-family`,A=`--vscode-icon-${c.id}-content`;E?(e[E.id]=E.definition,r.push(`${T}: ${(0,i.asCSSPropertyValue)(E.id)};`,`${A}: '${l.fontCharacter}';`),s.push(`.codicon-${c.id}:before { content: '${l.fontCharacter}'; font-family: ${(0,i.asCSSPropertyValue)(E.id)}; }`)):(r.push(`${A}: '${l.fontCharacter}'; ${T}: 'codicon';`),s.push(`.codicon-${c.id}:before { content: '${l.fontCharacter}'; }`))}for(const c in e){const l=e[c],E=l.weight?`font-weight: ${l.weight};`:"",T=l.style?`font-style: ${l.style};`:"",A=l.src.map(f=>`${(0,i.asCSSUrl)(f.location)} format('${f.format}')`).join(", ");s.push(`@font-face { src: ${A}; font-family: ${(0,i.asCSSPropertyValue)(c)};${E}${T} font-display: block; }`)}return s.push(`:root { ${r.join(" ")} }`),s.join(`
`)}}}class w{getIcon(v){const _=(0,I.getIconRegistry)();let b=v.defaults;for(;F.ThemeIcon.isThemeIcon(b);){const m=_.getIcon(b.id);if(!m)return;b=m.defaults}return b}}t.UnthemedProductIconTheme=w}),define(ve[153],De([1,0,5]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.WindowMinimumSize=void 0,t.isOpenedAuxiliaryWindow=n,t.isWorkspaceToOpen=P,t.isFolderToOpen=F,t.isFileToOpen=I,t.getMenuBarVisibility=D,t.hasCustomTitlebar=_,t.hasNativeTitlebar=b,t.getTitleBarStyle=m,t.useWindowControlsOverlay=e,t.useNativeFullScreen=s,t.zoomLevelToZoomFactor=r,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(c){return typeof c.parentId=="number"}function P(c){return!!c.workspaceUri}function F(c){return!!c.folderUri}function I(c){return!!c.fileUri}function D(c){const l=b(c),E=c.getValue("window.menuBarVisibility");return E==="default"||l&&E==="compact"||i.isMacintosh&&i.isNative?"classic":E}var w;(function(c){c.TITLE_BAR_STYLE="window.titleBarStyle",c.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(w||(t.TitleBarSetting=w={}));var d;(function(c){c.NATIVE="native",c.CUSTOM="custom"})(d||(t.TitlebarStyle=d={}));var v;(function(c){c.AUTO="auto",c.WINDOWED="windowed",c.NEVER="never"})(v||(t.CustomTitleBarVisibility=v={}));function _(c,l){return!0}function b(c,l){return l||(l=m(c)),l===d.NATIVE}function m(c){if(i.isWeb)return d.CUSTOM;const l=c.getValue("window");if(l){if(i.isMacintosh&&l.nativeTabs===!0||i.isMacintosh&&l.nativeFullScreen===!1)return d.NATIVE;const A=l.titleBarStyle;if(A===d.NATIVE||A===d.CUSTOM)return A}return i.isLinux?d.NATIVE:d.CUSTOM}t.DEFAULT_CUSTOM_TITLEBAR_HEIGHT=35;function e(c){return!(!i.isWindows||i.isWeb||b(c))}function s(c){const l=c.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}function r(c=0){return Math.pow(1.2,c)}}),define(ve[154],De([1,0,18,4,24,40,153]),function(oe,t,i,n,P,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MIN_ZOOM_LEVEL=t.MAX_ZOOM_LEVEL=t.ApplyZoomTarget=void 0,t.applyZoom=w,t.zoomIn=v,t.zoomOut=_;var D;(function(b){b[b.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",b[b.ALL_WINDOWS=2]="ALL_WINDOWS"})(D||(t.ApplyZoomTarget=D={})),t.MAX_ZOOM_LEVEL=8,t.MIN_ZOOM_LEVEL=-8;function w(b,m){b=Math.min(Math.max(b,t.MIN_ZOOM_LEVEL),t.MAX_ZOOM_LEVEL);const e=[];m===D.ACTIVE_WINDOW?e.push((0,n.getActiveWindow)()):m===D.ALL_WINDOWS?e.push(...Array.from((0,n.getWindows)()).map(({window:s})=>s)):e.push(m);for(const s of e)d(s)?.webFrame?.setZoomLevel(b),(0,i.setZoomFactor)((0,I.zoomLevelToZoomFactor)(b),s),(0,i.setZoomLevel)(b,s)}function d(b){if(b===P.mainWindow)return{ipcRenderer:F.ipcRenderer,webFrame:F.webFrame};{const m=b;if(m?.vscode?.ipcRenderer&&m?.vscode?.webFrame)return m.vscode}}function v(b){w((0,i.getZoomLevel)(typeof b=="number"?(0,n.getActiveWindow)():b)+1,b)}function _(b){w((0,i.getZoomLevel)(typeof b=="number"?(0,n.getActiveWindow)():b)-1,b)}}),define(ve[155],De([1,0,13,4,144,12,123,40,145,146,148,149,152,154,15,8,24,138,128]),function(oe,t,i,n,P,F,I,D,w,d,v,_,b,m,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=O;const c=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class E{getHeight(R){return 22}getTemplateId(R){return H(R)?"process":S(R)?"machine":(0,w.isRemoteDiagnosticError)(R)?"error":U(R)?"header":""}}class T{hasChildren(R){return(0,w.isRemoteDiagnosticError)(R)?!1:H(R)?!!R.children?.length:!0}getChildren(R){return H(R)?R.children?R.children:[]:(0,w.isRemoteDiagnosticError)(R)?[]:U(R)?R.processRoots.length>1?R.processRoots:[R.processRoots[0].rootProcess]:S(R)?[R.rootProcess]:[R.processes]}}class A{constructor(){this.templateId="header"}renderTemplate(R){const W=(0,n.append)(R,(0,n.$)(".row")),G=(0,n.append)(W,(0,n.$)(".nameLabel")),Q=(0,n.append)(W,(0,n.$)(".cpu")),j=(0,n.append)(W,(0,n.$)(".memory")),q=(0,n.append)(W,(0,n.$)(".pid"));return{name:G,CPU:Q,memory:j,PID:q}}renderElement(R,W,G,Q){G.name.textContent=(0,i.localize)(12199,null),G.CPU.textContent=(0,i.localize)(12200,null),G.PID.textContent=(0,i.localize)(12201,null),G.memory.textContent=(0,i.localize)(12202,null)}disposeTemplate(R){}}class f{constructor(){this.templateId="machine"}renderTemplate(R){const W=Object.create(null),G=(0,n.append)(R,(0,n.$)(".row"));return W.name=(0,n.append)(G,(0,n.$)(".nameLabel")),W}renderElement(R,W,G,Q){G.name.textContent=R.element.name}disposeTemplate(R){}}class h{constructor(){this.templateId="error"}renderTemplate(R){const W=Object.create(null),G=(0,n.append)(R,(0,n.$)(".row"));return W.name=(0,n.append)(G,(0,n.$)(".nameLabel")),W}renderElement(R,W,G,Q){G.name.textContent=R.element.errorMessage}disposeTemplate(R){}}class p{constructor(R,W,G){this.platform=R,this.totalMem=W,this.mapPidToName=G,this.templateId="process"}renderTemplate(R){const W=(0,n.append)(R,(0,n.$)(".row")),G=(0,n.append)(W,(0,n.$)(".nameLabel")),Q=(0,n.append)(W,(0,n.$)(".cpu")),j=(0,n.append)(W,(0,n.$)(".memory")),q=(0,n.append)(W,(0,n.$)(".pid"));return{name:G,CPU:Q,PID:q,memory:j}}renderElement(R,W,G,Q){const{element:j}=R,q=j.pid.toFixed(0);let J=j.name;this.mapPidToName.has(j.pid)&&(J=this.mapPidToName.get(j.pid)),G.name.textContent=J,G.name.title=j.cmd,G.CPU.textContent=j.load.toFixed(0),G.PID.textContent=q,G.PID.parentElement.id=`pid-${q}`;const le=this.platform==="win32"?j.mem:this.totalMem*(j.mem/100);G.memory.textContent=(le/d.ByteSize.MB).toFixed(0)}disposeTemplate(R){}}function S(V){return!!V.name&&!!V.rootProcess}function U(V){return!!V.processRoots}function H(V){return!!V.pid}class x{constructor(R,W){this.data=W,this.mapPidToName=new Map;const G=new v.ElectronIPCMainProcessService(R);this.nativeHostService=new _.NativeHostService(R,G),this.applyStyles(W.styles),this.setEventHandlers(W),D.ipcRenderer.on("vscode:pidToNameResponse",(Q,j)=>{this.mapPidToName.clear();for(const[q,J]of j)this.mapPidToName.set(q,J)}),D.ipcRenderer.on("vscode:listProcessesResponse",async(Q,j)=>{j.forEach((q,J)=>{H(q.rootProcess)&&(q.rootProcess.name=J===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:j}}),this.tree.layout(r.mainWindow.innerHeight,r.mainWindow.innerWidth)):await this.createProcessTree(j),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),D.ipcRenderer.send("vscode:pidToNameRequest"),D.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(R){r.mainWindow.document.onkeydown=W=>{const G=R.platform==="darwin"?W.metaKey:W.ctrlKey;G&&W.keyCode===87&&(W.stopPropagation(),W.preventDefault(),D.ipcRenderer.send("vscode:closeProcessExplorer")),G&&W.keyCode===187&&(0,m.zoomIn)(r.mainWindow),G&&W.keyCode===189&&(0,m.zoomOut)(r.mainWindow)}}async createProcessTree(R){const W=r.mainWindow.document.getElementById("process-list");if(!W)return;const{totalmem:G}=await this.nativeHostService.getOSStatistics(),Q=[new p(this.data.platform,G,this.mapPidToName),new A,new f,new h];this.tree=new P.DataTree("processExplorer",W,new E,Q,new T,{identityProvider:{getId:j=>H(j)?j.pid.toString():(0,w.isRemoteDiagnosticError)(j)?j.hostName:U(j)?"processes":S(j)?j.name:"header"}}),this.tree.setInput({processes:{processRoots:R}}),this.tree.layout(r.mainWindow.innerHeight,r.mainWindow.innerWidth),this.tree.onKeyDown(j=>{const q=new e.StandardKeyboardEvent(j);if(q.keyCode===s.KeyCode.KeyE&&q.altKey){const J=this.getSelectedPids();Promise.all(J.map(le=>this.nativeHostService.killProcess(le,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(j=>{H(j.element)&&this.showContextMenu(j.element,!0)}),W.style.height=`${r.mainWindow.innerHeight}px`,r.mainWindow.addEventListener("resize",()=>{W.style.height=`${r.mainWindow.innerHeight}px`,this.tree?.layout(r.mainWindow.innerHeight,r.mainWindow.innerWidth)})}isDebuggable(R){const W=c.exec(R);return W&&W.groups.port!=="0"||R.indexOf("node ")>=0||R.indexOf("node.exe")>=0}attachTo(R){const W={type:"node",request:"attach",name:`process ${R.pid}`};let G=c.exec(R.cmd);G?W.port=Number(G.groups.port):W.processId=String(R.pid),G=l.exec(R.cmd),G&&(W.port=Number(G.groups.port)),D.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[W]})}applyStyles(R){const W=(0,n.createStyleSheet)(),G=[];R.listFocusBackground&&(G.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${R.listFocusBackground}; }`),G.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${R.listFocusBackground}; }`)),R.listFocusForeground&&G.push(`.monaco-list:focus .monaco-list-row.focused { color: ${R.listFocusForeground}; }`),R.listActiveSelectionBackground&&(G.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${R.listActiveSelectionBackground}; }`),G.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${R.listActiveSelectionBackground}; }`)),R.listActiveSelectionForeground&&G.push(`.monaco-list:focus .monaco-list-row.selected { color: ${R.listActiveSelectionForeground}; }`),R.listHoverBackground&&G.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${R.listHoverBackground}; }`),R.listHoverForeground&&G.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${R.listHoverForeground}; }`),R.listFocusOutline&&G.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${R.listFocusOutline}; outline-offset: -1px; }`),R.listHoverOutline&&G.push(`.monaco-list-row:hover { outline: 1px dashed ${R.listHoverOutline}; outline-offset: -1px; }`),R.scrollbarShadowColor&&G.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${R.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),R.scrollbarSliderBackgroundColor&&G.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${R.scrollbarSliderBackgroundColor};
				}
			`),R.scrollbarSliderHoverBackgroundColor&&G.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${R.scrollbarSliderHoverBackgroundColor};
				}
			`),R.scrollbarSliderActiveBackgroundColor&&G.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${R.scrollbarSliderActiveBackgroundColor};
				}
			`),W.textContent=G.join(`
`),R.color&&(r.mainWindow.document.body.style.color=R.color)}showContextMenu(R,W){const G=[],Q=Number(R.pid);W&&(G.push({accelerator:"Alt+E",label:(0,i.localize)(12203,null),click:()=>{this.nativeHostService.killProcess(Q,"SIGTERM")}}),G.push({label:(0,i.localize)(12204,null),click:()=>{this.nativeHostService.killProcess(Q,"SIGKILL")}}),G.push({type:"separator"})),G.push({label:(0,i.localize)(12205,null),click:()=>{const j=this.getSelectedPids();j?.includes(Q)||(j.length=0,j.push(Q));const q=j?.map(J=>r.mainWindow.document.getElementById(`pid-${J}`)).filter(J=>!!J);if(q){const J=q.map(le=>le.innerText).filter(le=>!!le);this.nativeHostService.writeClipboardText(J.join(`
`))}}}),G.push({label:(0,i.localize)(12206,null),click:()=>{const j=r.mainWindow.document.getElementById("process-list");j&&this.nativeHostService.writeClipboardText(j.innerText)}}),R&&W&&this.isDebuggable(R.cmd)&&(G.push({type:"separator"}),G.push({label:(0,i.localize)(12207,null),click:()=>{this.attachTo(R)}})),(0,I.popup)(G)}requestProcessList(R){setTimeout(()=>{const W=Date.now(),G=R+W-this.lastRequestTime;this.lastRequestTime=W,G>1e3?(D.ipcRenderer.send("vscode:pidToNameRequest"),D.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(G)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(R=>{if(!(!R||!("pid"in R)))return R.pid}).filter(R=>!!R)}}function y(){const V=(0,n.createStyleSheet)();V.id="codiconStyles";const R=(0,b.getIconsStyleSheet)(void 0);function W(){V.textContent=R.getCSS()}const G=new F.RunOnceScheduler(W,0);R.onDidChange(()=>G.schedule()),G.schedule()}function O(V){const R=V.data.platform==="win32"?"windows":V.data.platform==="linux"?"linux":"mac";r.mainWindow.document.body.classList.add(R),y(),(0,m.applyZoom)(V.data.zoomLevel,r.mainWindow),new x(V.windowId,V.data)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
