/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/strings","vs/base/common/extpath","vs/base/common/uri","vs/base/common/charCode","vs/base/common/async","fs","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/cancellation","vs/base/common/arrays","vs/base/common/lazy","vs/base/common/map","vs/base/common/process","vs/base/common/event","vs/base/common/network","vs/base/common/resources","vs/base/node/pfs","os","vs/nls","vs/base/common/functional","vs/base/common/normalization","vs/base/common/types","vs/platform/environment/node/argv","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/ports","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/terminalEncoding","child_process","vs/platform/environment/node/argvHelper","vs/platform/environment/node/stdin","vs/platform/environment/node/wait","vs/platform/files/common/watcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/product/common/product","vs/platform/profiling/common/profiling","util","net","minimist","assert","vs/code/node/cli","vs/base/node/unc"],be=function(oe){for(var e=[],f=0,t=oe.length;f<t;f++)e[f]=pe[oe[f]];return e};define(pe[29],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=f,e.findLastIdx=t,e.findLastMonotonous=I,e.findLastIdxMonotonous=U,e.findFirstMonotonous=Y,e.findFirstIdxMonotonousOrArrLen=O,e.findFirstIdxMonotonous=R,e.findFirstMax=q,e.findLastMax=$,e.findFirstMin=T,e.findMaxIdx=C,e.mapFindFirst=c;function f(r,u){const _=t(r,u);if(_!==-1)return r[_]}function t(r,u,_=r.length-1){for(let A=_;A>=0;A--){const v=r[A];if(u(v))return A}return-1}function I(r,u){const _=U(r,u);return _===-1?void 0:r[_]}function U(r,u,_=0,A=r.length){let v=_,k=A;for(;v<k;){const w=Math.floor((v+k)/2);u(r[w])?v=w+1:k=w}return v-1}function Y(r,u){const _=O(r,u);return _===r.length?void 0:r[_]}function O(r,u,_=0,A=r.length){let v=_,k=A;for(;v<k;){const w=Math.floor((v+k)/2);u(r[w])?k=w:v=w+1}return v}function R(r,u,_=0,A=r.length){const v=O(r,u,_,A);return v===r.length?-1:v}class D{static{this.assertInvariants=!1}constructor(u){this._array=u,this._findLastMonotonousLastIdx=0}findLastMonotonous(u){if(D.assertInvariants){if(this._prevFindLastPredicate){for(const A of this._array)if(this._prevFindLastPredicate(A)&&!u(A))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=u}const _=U(this._array,u,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=_+1,_===-1?void 0:this._array[_]}}e.MonotonousArray=D;function q(r,u){if(r.length===0)return;let _=r[0];for(let A=1;A<r.length;A++){const v=r[A];u(v,_)>0&&(_=v)}return _}function $(r,u){if(r.length===0)return;let _=r[0];for(let A=1;A<r.length;A++){const v=r[A];u(v,_)>=0&&(_=v)}return _}function T(r,u){return q(r,(_,A)=>-u(_,A))}function C(r,u){if(r.length===0)return-1;let _=0;for(let A=1;A<r.length;A++){const v=r[A];u(v,r[_])>0&&(_=A)}return _}function c(r,u){for(const _ of r){const A=u(_);if(A!==void 0)return A}}}),define(pe[7],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var f;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(f||(e.CharCode=f={}))}),define(pe[30],be([0,1]),function(oe,e){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=t,e.diffSets=I,e.diffMaps=U,e.intersection=Y;function t(R,D){const q=Object.create(null);for(const $ of R){const T=D($);let C=q[T];C||(C=q[T]=[]),C.push($)}return q}function I(R,D){const q=[],$=[];for(const T of R)D.has(T)||q.push(T);for(const T of D)R.has(T)||$.push(T);return{removed:q,added:$}}function U(R,D){const q=[],$=[];for(const[T,C]of R)D.has(T)||q.push(C);for(const[T,C]of D)R.has(T)||$.push(C);return{removed:q,added:$}}function Y(R,D){const q=new Set;for(const $ of D)R.has($)&&q.add($);return q}class O{static{f=Symbol.toStringTag}constructor(D,q){this.toKey=q,this._map=new Map,this[f]="SetWithKey";for(const $ of D)this.add($)}get size(){return this._map.size}add(D){const q=this.toKey(D);return this._map.set(q,D),this}delete(D){return this._map.delete(this.toKey(D))}has(D){return this._map.has(this.toKey(D))}*entries(){for(const D of this._map.values())yield[D,D]}keys(){return this.values()}*values(){for(const D of this._map.values())yield D}clear(){this._map.clear()}forEach(D,q){this._map.forEach($=>D.call(q,$,$,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=O}),define(pe[10],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=t,e.isSigPipeError=I,e.onUnexpectedError=U,e.onUnexpectedExternalError=Y,e.transformErrorForSerialization=O,e.transformErrorFromSerialization=R,e.isCancellationError=q,e.canceled=T,e.illegalArgument=C,e.illegalState=c,e.getErrorMessage=u;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?k.isErrorNoTelemetry(i)?new k(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=f,e.errorHandler=new f;function t(n){e.errorHandler.setUnexpectedErrorHandler(n)}function I(n){if(!n||typeof n!="object")return!1;const i=n;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function U(n){q(n)||e.errorHandler.onUnexpectedError(n)}function Y(n){q(n)||e.errorHandler.onUnexpectedExternalError(n)}function O(n){if(n instanceof Error){const{name:i,message:s}=n,g=n.stacktrace||n.stack;return{$isError:!0,name:i,message:s,stack:g,noTelemetry:k.isErrorNoTelemetry(n)}}return n}function R(n){let i;return n.noTelemetry?i=new k:(i=new Error,i.name=n.name),i.message=n.message,i.stack=n.stack,i}const D="Canceled";function q(n){return n instanceof $?!0:n instanceof Error&&n.name===D&&n.message===D}class $ extends Error{constructor(){super(D),this.name=this.message}}e.CancellationError=$;function T(){const n=new Error(D);return n.name=n.message,n}function C(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function c(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class r extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=r;function u(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class _ extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=_;class A extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=A;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class k extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof k)return i;const s=new k;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=k;class w extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.BugIndicatingError=w}),define(pe[13],be([0,1,10,29]),function(oe,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=I,e.tail2=U,e.equals=Y,e.removeFastWithoutKeepingOrder=O,e.binarySearch=R,e.binarySearch2=D,e.quickSelect=q,e.groupBy=$,e.groupAdjacentBy=T,e.forEachAdjacent=C,e.forEachWithNeighbors=c,e.sortedDiff=r,e.delta=u,e.top=_,e.topAsync=A,e.coalesce=k,e.coalesceInPlace=w,e.move=n,e.isFalsyOrEmpty=i,e.isNonEmptyArray=s,e.distinct=g,e.uniqueFilter=N,e.firstOrDefault=h,e.lastOrDefault=m,e.commonPrefixLength=a,e.range=o,e.index=S,e.insert=L,e.remove=p,e.arrayInsert=z,e.shuffle=x,e.pushToStart=J,e.pushToEnd=j,e.pushMany=le,e.mapArrayOrNot=M,e.asArray=K,e.getRandomElement=Z,e.insertInto=ee,e.splice=W,e.compareBy=te,e.tieBreakComparators=ue,e.reverseOrder=se,e.findAsync=Le;function I(F,B=0){return F[F.length-(1+B)]}function U(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}function Y(F,B,E=(l,y)=>l===y){if(F===B)return!0;if(!F||!B||F.length!==B.length)return!1;for(let l=0,y=F.length;l<y;l++)if(!E(F[l],B[l]))return!1;return!0}function O(F,B){const E=F.length-1;B<E&&(F[B]=F[E]),F.pop()}function R(F,B,E){return D(F.length,l=>E(F[l],B))}function D(F,B){let E=0,l=F-1;for(;E<=l;){const y=(E+l)/2|0,V=B(y);if(V<0)E=y+1;else if(V>0)l=y-1;else return y}return-(E+1)}function q(F,B,E){if(F=F|0,F>=B.length)throw new TypeError("invalid index");const l=B[Math.floor(B.length*Math.random())],y=[],V=[],X=[];for(const _e of B){const ve=E(_e,l);ve<0?y.push(_e):ve>0?V.push(_e):X.push(_e)}return F<y.length?q(F,y,E):F<y.length+X.length?X[0]:q(F-(y.length+X.length),V,E)}function $(F,B){const E=[];let l;for(const y of F.slice(0).sort(B))!l||B(l[0],y)!==0?(l=[y],E.push(l)):l.push(y);return E}function*T(F,B){let E,l;for(const y of F)l!==void 0&&B(l,y)?E.push(y):(E&&(yield E),E=[y]),l=y;E&&(yield E)}function C(F,B){for(let E=0;E<=F.length;E++)B(E===0?void 0:F[E-1],E===F.length?void 0:F[E])}function c(F,B){for(let E=0;E<F.length;E++)B(E===0?void 0:F[E-1],F[E],E+1===F.length?void 0:F[E+1])}function r(F,B,E){const l=[];function y(_e,ve,De){if(ve===0&&De.length===0)return;const ce=l[l.length-1];ce&&ce.start+ce.deleteCount===_e?(ce.deleteCount+=ve,ce.toInsert.push(...De)):l.push({start:_e,deleteCount:ve,toInsert:De})}let V=0,X=0;for(;;){if(V===F.length){y(V,0,B.slice(X));break}if(X===B.length){y(V,F.length-V,[]);break}const _e=F[V],ve=B[X],De=E(_e,ve);De===0?(V+=1,X+=1):De<0?(y(V,1,[]),V+=1):De>0&&(y(V,0,[ve]),X+=1)}return l}function u(F,B,E){const l=r(F,B,E),y=[],V=[];for(const X of l)y.push(...F.slice(X.start,X.start+X.deleteCount)),V.push(...X.toInsert);return{removed:y,added:V}}function _(F,B,E){if(E===0)return[];const l=F.slice(0,E).sort(B);return v(F,B,l,E,F.length),l}function A(F,B,E,l,y){return E===0?Promise.resolve([]):new Promise((V,X)=>{(async()=>{const _e=F.length,ve=F.slice(0,E).sort(B);for(let De=E,ce=Math.min(E+l,_e);De<_e;De=ce,ce=Math.min(ce+l,_e)){if(De>E&&await new Promise(ae=>setTimeout(ae)),y&&y.isCancellationRequested)throw new f.CancellationError;v(F,B,ve,De,ce)}return ve})().then(V,X)})}function v(F,B,E,l,y){for(const V=E.length;l<y;l++){const X=F[l];if(B(X,E[V-1])<0){E.pop();const _e=(0,t.findFirstIdxMonotonousOrArrLen)(E,ve=>B(X,ve)<0);E.splice(_e,0,X)}}}function k(F){return F.filter(B=>!!B)}function w(F){let B=0;for(let E=0;E<F.length;E++)F[E]&&(F[B]=F[E],B+=1);F.length=B}function n(F,B,E){F.splice(E,0,F.splice(B,1)[0])}function i(F){return!Array.isArray(F)||F.length===0}function s(F){return Array.isArray(F)&&F.length>0}function g(F,B=E=>E){const E=new Set;return F.filter(l=>{const y=B(l);return E.has(y)?!1:(E.add(y),!0)})}function N(F){const B=new Set;return E=>{const l=F(E);return B.has(l)?!1:(B.add(l),!0)}}function h(F,B){return F.length>0?F[0]:B}function m(F,B){return F.length>0?F[F.length-1]:B}function a(F,B,E=(l,y)=>l===y){let l=0;for(let y=0,V=Math.min(F.length,B.length);y<V&&E(F[y],B[y]);y++)l++;return l}function o(F,B){let E=typeof B=="number"?F:0;typeof B=="number"?E=F:(E=0,B=F);const l=[];if(E<=B)for(let y=E;y<B;y++)l.push(y);else for(let y=E;y>B;y--)l.push(y);return l}function S(F,B,E){return F.reduce((l,y)=>(l[B(y)]=E?E(y):y,l),Object.create(null))}function L(F,B){return F.push(B),()=>p(F,B)}function p(F,B){const E=F.indexOf(B);if(E>-1)return F.splice(E,1),B}function z(F,B,E){const l=F.slice(0,B),y=F.slice(B);return l.concat(E,y)}function x(F,B){let E;if(typeof B=="number"){let l=B;E=()=>{const y=Math.sin(l++)*179426549;return y-Math.floor(y)}}else E=Math.random;for(let l=F.length-1;l>0;l-=1){const y=Math.floor(E()*(l+1)),V=F[l];F[l]=F[y],F[y]=V}}function J(F,B){const E=F.indexOf(B);E>-1&&(F.splice(E,1),F.unshift(B))}function j(F,B){const E=F.indexOf(B);E>-1&&(F.splice(E,1),F.push(B))}function le(F,B){for(const E of B)F.push(E)}function M(F,B){return Array.isArray(F)?F.map(B):B(F)}function K(F){return Array.isArray(F)?F:[F]}function Z(F){return F[Math.floor(Math.random()*F.length)]}function ee(F,B,E){const l=G(F,B),y=F.length,V=E.length;F.length=y+V;for(let X=y-1;X>=l;X--)F[X+V]=F[X];for(let X=0;X<V;X++)F[X+l]=E[X]}function W(F,B,E,l){const y=G(F,B);let V=F.splice(y,E);return V===void 0&&(V=[]),ee(F,y,l),V}function G(F,B){return B<0?Math.max(B+F.length,0):Math.min(B,F.length)}var H;(function(F){function B(V){return V<0}F.isLessThan=B;function E(V){return V<=0}F.isLessThanOrEqual=E;function l(V){return V>0}F.isGreaterThan=l;function y(V){return V===0}F.isNeitherLessOrGreaterThan=y,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function te(F,B){return(E,l)=>B(F(E),F(l))}function ue(...F){return(B,E)=>{for(const l of F){const y=l(B,E);if(!H.isNeitherLessOrGreaterThan(y))return y}return H.neitherLessOrGreaterThan}}const b=(F,B)=>F-B;e.numberComparator=b;const ie=(F,B)=>(0,e.numberComparator)(F?1:0,B?1:0);e.booleanComparator=ie;function se(F){return(B,E)=>-F(B,E)}class re{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let E=this.firstIdx;for(;E<this.items.length&&B(this.items[E]);)E++;const l=E===this.firstIdx?null:this.items.slice(this.firstIdx,E);return this.firstIdx=E,l}takeFromEndWhile(B){let E=this.lastIdx;for(;E>=0&&B(this.items[E]);)E--;const l=E===this.lastIdx?null:this.items.slice(E+1,this.lastIdx+1);return this.lastIdx=E,l}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}removeLast(){const B=this.items[this.lastIdx];return this.lastIdx--,B}takeCount(B){const E=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,E}}e.ArrayQueue=re;class fe{static{this.empty=new fe(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(E=>(B(E),!0))}toArray(){const B=[];return this.iterate(E=>(B.push(E),!0)),B}filter(B){return new fe(E=>this.iterate(l=>B(l)?E(l):!0))}map(B){return new fe(E=>this.iterate(l=>E(B(l))))}some(B){let E=!1;return this.iterate(l=>(E=B(l),!E)),E}findFirst(B){let E;return this.iterate(l=>B(l)?(E=l,!1):!0),E}findLast(B){let E;return this.iterate(l=>(B(l)&&(E=l),!0)),E}findLastMaxBy(B){let E,l=!0;return this.iterate(y=>((l||H.isGreaterThan(B(y,E)))&&(l=!1,E=y),!0)),E}}e.CallbackIterable=fe;class de{constructor(B){this._indexMap=B}static createSortPermutation(B,E){const l=Array.from(B.keys()).sort((y,V)=>E(B[y],B[V]));return new de(l)}apply(B){return B.map((E,l)=>B[this._indexMap[l]])}inverse(){const B=this._indexMap.slice();for(let E=0;E<this._indexMap.length;E++)B[this._indexMap[E]]=E;return new de(B)}}e.Permutation=de;async function Le(F,B){return(await Promise.all(F.map(async(l,y)=>({element:l,ok:await B(l,y)})))).find(l=>l.ok)?.element}}),define(pe[23],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=f;function f(t,I){const U=this;let Y=!1,O;return function(){if(Y)return O;if(Y=!0,I)try{O=t.apply(U,arguments)}finally{I()}else O=t.apply(U,arguments);return O}}}),define(pe[31],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(t){function I(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=I;const U=Object.freeze([]);function Y(){return U}t.empty=Y;function*O(i){yield i}t.single=O;function R(i){return I(i)?i:O(i)}t.wrap=R;function D(i){return i||U}t.from=D;function*q(i){for(let s=i.length-1;s>=0;s--)yield i[s]}t.reverse=q;function $(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=$;function T(i){return i[Symbol.iterator]().next().value}t.first=T;function C(i,s){let g=0;for(const N of i)if(s(N,g++))return!0;return!1}t.some=C;function c(i,s){for(const g of i)if(s(g))return g}t.find=c;function*r(i,s){for(const g of i)s(g)&&(yield g)}t.filter=r;function*u(i,s){let g=0;for(const N of i)yield s(N,g++)}t.map=u;function*_(i,s){let g=0;for(const N of i)yield*s(N,g++)}t.flatMap=_;function*A(...i){for(const s of i)yield*s}t.concat=A;function v(i,s,g){let N=g;for(const h of i)N=s(N,h);return N}t.reduce=v;function*k(i,s,g=i.length){for(s<0&&(s+=i.length),g<0?g+=i.length:g>i.length&&(g=i.length);s<g;s++)yield i[s]}t.slice=k;function w(i,s=Number.POSITIVE_INFINITY){const g=[];if(s===0)return[g,i];const N=i[Symbol.iterator]();for(let h=0;h<s;h++){const m=N.next();if(m.done)return[g,t.empty()];g.push(m.value)}return[g,{[Symbol.iterator](){return N}}]}t.consume=w;async function n(i){const s=[];for await(const g of i)s.push(g);return Promise.resolve(s)}t.asyncToArray=n})(f||(e.Iterable=f={}))}),define(pe[14],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(I){this.executor=I,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=f}),define(pe[32],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{static{this.Undefined=new f(void 0)}constructor(U){this.element=U,this.next=f.Undefined,this.prev=f.Undefined}}class t{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let U=this._first;for(;U!==f.Undefined;){const Y=U.next;U.prev=f.Undefined,U.next=f.Undefined,U=Y}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(U){return this._insert(U,!1)}push(U){return this._insert(U,!0)}_insert(U,Y){const O=new f(U);if(this._first===f.Undefined)this._first=O,this._last=O;else if(Y){const D=this._last;this._last=O,O.prev=D,D.next=O}else{const D=this._first;this._first=O,O.next=D,D.prev=O}this._size+=1;let R=!1;return()=>{R||(R=!0,this._remove(O))}}shift(){if(this._first!==f.Undefined){const U=this._first.element;return this._remove(this._first),U}}pop(){if(this._last!==f.Undefined){const U=this._last.element;return this._remove(this._last),U}}_remove(U){if(U.prev!==f.Undefined&&U.next!==f.Undefined){const Y=U.prev;Y.next=U.next,U.next.prev=Y}else U.prev===f.Undefined&&U.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):U.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):U.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let U=this._first;for(;U!==f.Undefined;)yield U.element,U=U.next}}e.LinkedList=t}),define(pe[15],be([0,1]),function(oe,e){"use strict";var f,t,I;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=U,e.mapToString=Y,e.setToString=O,e.mapsStrictEqualIgnoreOrder=k;function U(w,n,i){let s=w.get(n);return s===void 0&&(s=i,w.set(n,s)),s}function Y(w){const n=[];return w.forEach((i,s)=>{n.push(`${s} => ${i}`)}),`Map(${w.size}) {${n.join(", ")}}`}function O(w){const n=[];return w.forEach(i=>{n.push(i)}),`Set(${w.size}) {${n.join(", ")}}`}class R{constructor(n,i){this.uri=n,this.value=i}}function D(w){return Array.isArray(w)}class q{static{this.defaultToKey=n=>n.toString()}constructor(n,i){if(this[f]="ResourceMap",n instanceof q)this.map=new Map(n.map),this.toKey=i??q.defaultToKey;else if(D(n)){this.map=new Map,this.toKey=i??q.defaultToKey;for(const[s,g]of n)this.set(s,g)}else this.map=new Map,this.toKey=n??q.defaultToKey}set(n,i){return this.map.set(this.toKey(n),new R(n,i)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[s,g]of this.map)n(g.value,g.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(f=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=q;class ${constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this._map=new q(n):(this._map=new q(i),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,i){this._map.forEach((s,g)=>n.call(i,g,g,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=$;var T;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(T||(e.Touch=T={}));class C{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,i=T.None){const s=this._map.get(n);if(s)return i!==T.None&&this.touch(s,i),s.value}set(n,i,s=T.None){let g=this._map.get(n);if(g)g.value=i,s!==T.None&&this.touch(g,s);else{switch(g={key:n,value:i,next:void 0,previous:void 0},s){case T.None:this.addItemLast(g);break;case T.AsOld:this.addItemFirst(g);break;case T.AsNew:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(n,g),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this._map.get(n);if(i)return this._map.delete(n),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,i){const s=this._state;let g=this._head;for(;g;){if(i?n.bind(i)(g.value,g.key,this):n(g.value,g.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const n=this,i=this._state;let s=this._head;const g={[Symbol.iterator](){return g},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const N={value:s.key,done:!1};return s=s.next,N}else return{value:void 0,done:!0}}};return g}values(){const n=this,i=this._state;let s=this._head;const g={[Symbol.iterator](){return g},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const N={value:s.value,done:!1};return s=s.next,N}else return{value:void 0,done:!0}}};return g}entries(){const n=this,i=this._state;let s=this._head;const g={[Symbol.iterator](){return g},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const N={value:[s.key,s.value],done:!1};return s=s.next,N}else return{value:void 0,done:!0}}};return g}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>n;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}trimNew(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._tail,s=this.size;for(;i&&s>n;)this._map.delete(i.key),i=i.previous,s--;this._tail=i,this._size=s,i&&(i.next=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const i=n.next,s=n.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}n.next=void 0,n.previous=void 0,this._state++}touch(n,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==T.AsOld&&i!==T.AsNew)){if(i===T.AsOld){if(n===this._head)return;const s=n.next,g=n.previous;n===this._tail?(g.next=void 0,this._tail=g):(s.previous=g,g.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(i===T.AsNew){if(n===this._tail)return;const s=n.next,g=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=g,g.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((i,s)=>{n.push([s,i])}),n}fromJSON(n){this.clear();for(const[i,s]of n)this.set(i,s)}}e.LinkedMap=C;class c extends C{constructor(n,i=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,i=T.AsNew){return super.get(n,i)}peek(n){return super.get(n,T.None)}set(n,i){return super.set(n,i,T.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class r extends c{constructor(n,i=1){super(n,i)}trim(n){this.trimOld(n)}set(n,i){return super.set(n,i),this.checkTrim(),this}}e.LRUCache=r;class u extends c{constructor(n,i=1){super(n,i)}trim(n){this.trimNew(n)}set(n,i){return this._limit<=this.size&&!this.has(n)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(n,i),this}}e.MRUCache=u;class _{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let i=this.map.get(n)||0;return i===0?!1:(i--,i===0?this.map.delete(n):this.map.set(n,i),!0)}has(n){return this.map.has(n)}}e.CounterSet=_;class A{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[i,s]of n)this.set(i,s)}clear(){this._m1.clear(),this._m2.clear()}set(n,i){this._m1.set(n,i),this._m2.set(i,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const i=this._m1.get(n);return i===void 0?!1:(this._m1.delete(n),this._m2.delete(i),!0)}forEach(n,i){this._m1.forEach((s,g)=>{n.call(i,s,g,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=A;class v{constructor(){this.map=new Map}add(n,i){let s=this.map.get(n);s||(s=new Set,this.map.set(n,s)),s.add(i)}delete(n,i){const s=this.map.get(n);s&&(s.delete(i),s.size===0&&this.map.delete(n))}forEach(n,i){const s=this.map.get(n);s&&s.forEach(i)}get(n){const i=this.map.get(n);return i||new Set}}e.SetMap=v;function k(w,n){if(w===n)return!0;if(w.size!==n.size)return!1;for(const[i,s]of w)if(!n.has(i)||n.get(i)!==s)return!1;for(const[i]of n)if(!w.has(i))return!1;return!0}}),define(pe[11],be([0,1,13,30,15,23,31]),function(oe,e,f,t,I,U,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=q,e.trackDisposable=$,e.markAsDisposed=T,e.markAsSingleton=r,e.isDisposable=u,e.dispose=_,e.disposeIfDisposable=A,e.combinedDisposable=v,e.toDisposable=k,e.disposeOnReturn=o;const O=!1;let R=null;class D{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(p){let z=this.livingDisposables.get(p);return z||(z={parent:null,source:null,isSingleton:!1,value:p,idx:D.idx++},this.livingDisposables.set(p,z)),z}trackDisposable(p){const z=this.getDisposableData(p);z.source||(z.source=new Error().stack)}setParent(p,z){const x=this.getDisposableData(p);x.parent=z}markAsDisposed(p){this.livingDisposables.delete(p)}markAsSingleton(p){this.getDisposableData(p).isSingleton=!0}getRootParent(p,z){const x=z.get(p);if(x)return x;const J=p.parent?this.getRootParent(this.getDisposableData(p.parent),z):p;return z.set(p,J),J}getTrackedDisposables(){const p=new Map;return[...this.livingDisposables.entries()].filter(([,x])=>x.source!==null&&!this.getRootParent(x,p).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(p=10,z){let x;if(z)x=z;else{const K=new Map,Z=[...this.livingDisposables.values()].filter(W=>W.source!==null&&!this.getRootParent(W,K).isSingleton);if(Z.length===0)return;const ee=new Set(Z.map(W=>W.value));if(x=Z.filter(W=>!(W.parent&&ee.has(W.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function J(K){function Z(W,G){for(;W.length>0&&G.some(H=>typeof H=="string"?H===W[0]:W[0].match(H));)W.shift()}const ee=K.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return Z(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const j=new I.SetMap;for(const K of x){const Z=J(K);for(let ee=0;ee<=Z.length;ee++)j.add(Z.slice(0,ee).join(`
`),K)}x.sort((0,f.compareBy)(K=>K.idx,f.numberComparator));let le="",M=0;for(const K of x.slice(0,p)){M++;const Z=J(K),ee=[];for(let W=0;W<Z.length;W++){let G=Z[W];G=`(shared with ${j.get(Z.slice(0,W+1).join(`
`)).size}/${x.length} leaks) at ${G}`;const te=j.get(Z.slice(0,W).join(`
`)),ue=(0,t.groupBy)([...te].map(b=>J(b)[W]),b=>b);delete ue[Z[W]];for(const[b,ie]of Object.entries(ue))ee.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${b}`);ee.unshift(G)}le+=`


==================== Leaking disposable ${M}/${x.length}: ${K.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return x.length>p&&(le+=`


... and ${x.length-p} more leaking disposables

`),{leaks:x,details:le}}}e.DisposableTracker=D;function q(L){R=L}if(O){const L="__is_disposable_tracked__";q(new class{trackDisposable(p){const z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[L]||console.log(z)},3e3)}setParent(p,z){if(p&&p!==n.None)try{p[L]=!0}catch{}}markAsDisposed(p){if(p&&p!==n.None)try{p[L]=!0}catch{}}markAsSingleton(p){}})}function $(L){return R?.trackDisposable(L),L}function T(L){R?.markAsDisposed(L)}function C(L,p){R?.setParent(L,p)}function c(L,p){if(R)for(const z of L)R.setParent(z,p)}function r(L){return R?.markAsSingleton(L),L}function u(L){return typeof L=="object"&&L!==null&&typeof L.dispose=="function"&&L.dispose.length===0}function _(L){if(Y.Iterable.is(L)){const p=[];for(const z of L)if(z)try{z.dispose()}catch(x){p.push(x)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}function A(L){for(const p of L)u(p)&&p.dispose();return[]}function v(...L){const p=k(()=>_(L));return c(L,p),p}function k(L){const p=$({dispose:(0,U.createSingleCallFunction)(()=>{T(p),L()})});return p}class w{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,$(this)}dispose(){this._isDisposed||(T(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{_(this._toDispose)}finally{this._toDispose.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return C(p,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(p),p}delete(p){if(p){if(p===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(p),p.dispose()}}deleteAndLeak(p){p&&this._toDispose.has(p)&&(this._toDispose.delete(p),C(p,null))}}e.DisposableStore=w;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new w,$(this),C(this._store,this)}dispose(){T(this),this._store.dispose()}_register(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(p)}}e.Disposable=n;class i{constructor(){this._isDisposed=!1,$(this)}get value(){return this._isDisposed?void 0:this._value}set value(p){this._isDisposed||p===this._value||(this._value?.dispose(),p&&C(p,this),this._value=p)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,T(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const p=this._value;return this._value=void 0,p&&C(p,null),p}}e.MutableDisposable=i;class s{constructor(p){this._disposable=new i,this._isDisposed=!1,this._disposable.value=p}get value(){return this._disposable.value}set value(p){this._isDisposed||p===this._disposable.value||(this._disposable.value=p)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class g{constructor(p){this._disposable=p,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class N{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(p){let z=p;return this.unset=()=>z=void 0,this.isset=()=>z!==void 0,this.dispose=()=>{z&&(z(),z=void 0,T(this))},this}}e.SafeDisposable=N;class h{constructor(){this.references=new Map}acquire(p,...z){let x=this.references.get(p);x||(x={counter:0,object:this.createReferencedObject(p,...z)},this.references.set(p,x));const{object:J}=x,j=(0,U.createSingleCallFunction)(()=>{--x.counter===0&&(this.destroyReferencedObject(p,x.object),this.references.delete(p))});return x.counter++,{object:J,dispose:j}}}e.ReferenceCollection=h;class m{constructor(p){this.referenceCollection=p}async acquire(p,...z){const x=this.referenceCollection.acquire(p,...z);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(J){throw x.dispose(),J}}}e.AsyncReferenceCollection=m;class a{constructor(p){this.object=p}dispose(){}}e.ImmortalReference=a;function o(L){const p=new w;try{L(p)}finally{p.dispose()}}class S{constructor(){this._store=new Map,this._isDisposed=!1,$(this)}dispose(){T(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{_(this._store.values())}finally{this._store.clear()}}has(p){return this._store.has(p)}get size(){return this._store.size}get(p){return this._store.get(p)}set(p,z,x=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this._store.get(p)?.dispose(),this._store.set(p,z)}deleteAndDispose(p){this._store.get(p)?.dispose(),this._store.delete(p)}deleteAndLeak(p){const z=this._store.get(p);return this._store.delete(p),z}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=S}),define(pe[33],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var f;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(f||(e.MarshalledId=f={}))}),define(pe[24],be([0,1,15]),function(oe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=I,e.normalizeNFD=Y;const t=new f.LRUCache(1e4);function I(D){return R(D,"NFC",t)}const U=new f.LRUCache(1e4);function Y(D){return R(D,"NFD",U)}const O=/[^\u0000-\u0080]/;function R(D,q,$){if(!D)return D;const T=$.get(D);if(T)return T;let C;return O.test(D)?C=D.normalize(q):C=D,$.set(D,C),C}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(q){return Y(q).replace(D,"")}}()}),define(pe[2],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=n,e.isLittleEndian=m,e.isBigSurOrNewer=a,e.LANGUAGE_DEFAULT="en";let f=!1,t=!1,I=!1,U=!1,Y=!1,O=!1,R=!1,D=!1,q=!1,$=!1,T,C=e.LANGUAGE_DEFAULT,c=e.LANGUAGE_DEFAULT,r,u;const _=globalThis;let A;typeof _.vscode<"u"&&typeof _.vscode.process<"u"?A=_.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(A=process);const v=typeof A?.versions?.electron=="string",k=v&&A?.type==="renderer";if(typeof A=="object"){f=A.platform==="win32",t=A.platform==="darwin",I=A.platform==="linux",U=I&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,R=v,q=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT;const o=A.env.VSCODE_NLS_CONFIG;if(o)try{const S=JSON.parse(o);T=S.userLocale,c=S.osLocale,C=S.resolvedLanguage||e.LANGUAGE_DEFAULT,r=S.languagePack?.translationsConfigFile}catch{}Y=!0}else typeof navigator=="object"&&!k?(u=navigator.userAgent,f=u.indexOf("Windows")>=0,t=u.indexOf("Macintosh")>=0,D=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=u.indexOf("Linux")>=0,$=u?.indexOf("Mobi")>=0,O=!0,C=globalThis._VSCODE_NLS_LANGUAGE||e.LANGUAGE_DEFAULT,T=navigator.language.toLowerCase(),c=T):console.error("Unable to resolve platform.");var w;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(w||(e.Platform=w={}));function n(o){switch(o){case w.Web:return"Web";case w.Mac:return"Mac";case w.Linux:return"Linux";case w.Windows:return"Windows"}}let i=w.Web;t?i=w.Mac:f?i=w.Windows:I&&(i=w.Linux),e.isWindows=f,e.isMacintosh=t,e.isLinux=I,e.isLinuxSnap=U,e.isNative=Y,e.isElectron=R,e.isWeb=O,e.isWebWorker=O&&typeof _.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?_.origin:void 0,e.isIOS=D,e.isMobile=$,e.isCI=q,e.platform=i,e.userAgent=u,e.language=C;var s;(function(o){function S(){return e.language}o.value=S;function L(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=L;function p(){return e.language==="en"}o.isDefault=p})(s||(e.Language=s={})),e.locale=T,e.platformLocale=c,e.translationsConfigFile=r,e.setTimeout0IsFaster=typeof _.postMessage=="function"&&!_.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];_.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let p=0,z=o.length;p<z;p++){const x=o[p];if(x.id===L.data.vscodeScheduleAsyncWork){o.splice(p,1),x.callback();return}}});let S=0;return L=>{const p=++S;o.push({id:p,callback:L}),_.postMessage({vscodeScheduleAsyncWork:p},"*")}}return o=>setTimeout(o)})();var g;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(g||(e.OperatingSystem=g={})),e.OS=t||D?g.Macintosh:f?g.Windows:g.Linux;let N=!0,h=!1;function m(){if(!h){h=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,N=new Uint16Array(o.buffer)[0]===513}return N}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function a(o){return parseFloat(o)>=20}}),define(pe[34],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPort=f;function f(){return 1025+Math.floor(64510*Math.random())}}),define(pe[16],be([0,1,2]),function(oe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.process<"u"){const U=I.process;t={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch});var Ye=this&&this.__createBinding||(Object.create?function(oe,e,f,t){t===void 0&&(t=f);var I=Object.getOwnPropertyDescriptor(e,f);(!I||("get"in I?!e.__esModule:I.writable||I.configurable))&&(I={enumerable:!0,get:function(){return e[f]}}),Object.defineProperty(oe,t,I)}:function(oe,e,f,t){t===void 0&&(t=f),oe[t]=e[f]}),Xe=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),Ue=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var f in oe)f!=="default"&&Object.prototype.hasOwnProperty.call(oe,f)&&Ye(e,oe,f);return Xe(e,oe),e};define(pe[3],be([0,1,16]),function(oe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,f=Ue(f);const t=65,I=97,U=90,Y=122,O=46,R=47,D=92,q=58,$=63;class T extends Error{constructor(s,g,N){let h;typeof g=="string"&&g.indexOf("not ")===0?(h="must not be",g=g.replace(/^not /,"")):h="must be";const m=s.indexOf(".")!==-1?"property":"argument";let a=`The "${s}" ${m} ${h} of type ${g}`;a+=`. Received type ${typeof N}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function C(i,s){if(i===null||typeof i!="object")throw new T(s,"Object",i)}function c(i,s){if(typeof i!="string")throw new T(s,"string",i)}const r=f.platform==="win32";function u(i){return i===R||i===D}function _(i){return i===R}function A(i){return i>=t&&i<=U||i>=I&&i<=Y}function v(i,s,g,N){let h="",m=0,a=-1,o=0,S=0;for(let L=0;L<=i.length;++L){if(L<i.length)S=i.charCodeAt(L);else{if(N(S))break;S=R}if(N(S)){if(!(a===L-1||o===1))if(o===2){if(h.length<2||m!==2||h.charCodeAt(h.length-1)!==O||h.charCodeAt(h.length-2)!==O){if(h.length>2){const p=h.lastIndexOf(g);p===-1?(h="",m=0):(h=h.slice(0,p),m=h.length-1-h.lastIndexOf(g)),a=L,o=0;continue}else if(h.length!==0){h="",m=0,a=L,o=0;continue}}s&&(h+=h.length>0?`${g}..`:"..",m=2)}else h.length>0?h+=`${g}${i.slice(a+1,L)}`:h=i.slice(a+1,L),m=L-a-1;a=L,o=0}else S===O&&o!==-1?++o:o=-1}return h}function k(i){return i?`${i[0]==="."?"":"."}${i}`:""}function w(i,s){C(s,"pathObject");const g=s.dir||s.root,N=s.base||`${s.name||""}${k(s.ext)}`;return g?g===s.root?`${g}${N}`:`${g}${i}${N}`:N}e.win32={resolve(...i){let s="",g="",N=!1;for(let h=i.length-1;h>=-1;h--){let m;if(h>=0){if(m=i[h],c(m,`paths[${h}]`),m.length===0)continue}else s.length===0?m=f.cwd():(m=f.env[`=${s}`]||f.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==s.toLowerCase()&&m.charCodeAt(2)===D)&&(m=`${s}\\`));const a=m.length;let o=0,S="",L=!1;const p=m.charCodeAt(0);if(a===1)u(p)&&(o=1,L=!0);else if(u(p))if(L=!0,u(m.charCodeAt(1))){let z=2,x=z;for(;z<a&&!u(m.charCodeAt(z));)z++;if(z<a&&z!==x){const J=m.slice(x,z);for(x=z;z<a&&u(m.charCodeAt(z));)z++;if(z<a&&z!==x){for(x=z;z<a&&!u(m.charCodeAt(z));)z++;(z===a||z!==x)&&(S=`\\\\${J}\\${m.slice(x,z)}`,o=z)}}}else o=1;else A(p)&&m.charCodeAt(1)===q&&(S=m.slice(0,2),o=2,a>2&&u(m.charCodeAt(2))&&(L=!0,o=3));if(S.length>0)if(s.length>0){if(S.toLowerCase()!==s.toLowerCase())continue}else s=S;if(N){if(s.length>0)break}else if(g=`${m.slice(o)}\\${g}`,N=L,L&&s.length>0)break}return g=v(g,!N,"\\",u),N?`${s}\\${g}`:`${s}${g}`||"."},normalize(i){c(i,"path");const s=i.length;if(s===0)return".";let g=0,N,h=!1;const m=i.charCodeAt(0);if(s===1)return _(m)?"\\":i;if(u(m))if(h=!0,u(i.charCodeAt(1))){let o=2,S=o;for(;o<s&&!u(i.charCodeAt(o));)o++;if(o<s&&o!==S){const L=i.slice(S,o);for(S=o;o<s&&u(i.charCodeAt(o));)o++;if(o<s&&o!==S){for(S=o;o<s&&!u(i.charCodeAt(o));)o++;if(o===s)return`\\\\${L}\\${i.slice(S)}\\`;o!==S&&(N=`\\\\${L}\\${i.slice(S,o)}`,g=o)}}}else g=1;else A(m)&&i.charCodeAt(1)===q&&(N=i.slice(0,2),g=2,s>2&&u(i.charCodeAt(2))&&(h=!0,g=3));let a=g<s?v(i.slice(g),!h,"\\",u):"";return a.length===0&&!h&&(a="."),a.length>0&&u(i.charCodeAt(s-1))&&(a+="\\"),N===void 0?h?`\\${a}`:a:h?`${N}\\${a}`:`${N}${a}`},isAbsolute(i){c(i,"path");const s=i.length;if(s===0)return!1;const g=i.charCodeAt(0);return u(g)||s>2&&A(g)&&i.charCodeAt(1)===q&&u(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,g;for(let m=0;m<i.length;++m){const a=i[m];c(a,"path"),a.length>0&&(s===void 0?s=g=a:s+=`\\${a}`)}if(s===void 0)return".";let N=!0,h=0;if(typeof g=="string"&&u(g.charCodeAt(0))){++h;const m=g.length;m>1&&u(g.charCodeAt(1))&&(++h,m>2&&(u(g.charCodeAt(2))?++h:N=!1))}if(N){for(;h<s.length&&u(s.charCodeAt(h));)h++;h>=2&&(s=`\\${s.slice(h)}`)}return e.win32.normalize(s)},relative(i,s){if(c(i,"from"),c(s,"to"),i===s)return"";const g=e.win32.resolve(i),N=e.win32.resolve(s);if(g===N||(i=g.toLowerCase(),s=N.toLowerCase(),i===s))return"";let h=0;for(;h<i.length&&i.charCodeAt(h)===D;)h++;let m=i.length;for(;m-1>h&&i.charCodeAt(m-1)===D;)m--;const a=m-h;let o=0;for(;o<s.length&&s.charCodeAt(o)===D;)o++;let S=s.length;for(;S-1>o&&s.charCodeAt(S-1)===D;)S--;const L=S-o,p=a<L?a:L;let z=-1,x=0;for(;x<p;x++){const j=i.charCodeAt(h+x);if(j!==s.charCodeAt(o+x))break;j===D&&(z=x)}if(x!==p){if(z===-1)return N}else{if(L>p){if(s.charCodeAt(o+x)===D)return N.slice(o+x+1);if(x===2)return N.slice(o+x)}a>p&&(i.charCodeAt(h+x)===D?z=x:x===2&&(z=3)),z===-1&&(z=0)}let J="";for(x=h+z+1;x<=m;++x)(x===m||i.charCodeAt(x)===D)&&(J+=J.length===0?"..":"\\..");return o+=z,J.length>0?`${J}${N.slice(o,S)}`:(N.charCodeAt(o)===D&&++o,N.slice(o,S))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===D){if(s.charCodeAt(1)===D){const g=s.charCodeAt(2);if(g!==$&&g!==O)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(A(s.charCodeAt(0))&&s.charCodeAt(1)===q&&s.charCodeAt(2)===D)return`\\\\?\\${s}`;return i},dirname(i){c(i,"path");const s=i.length;if(s===0)return".";let g=-1,N=0;const h=i.charCodeAt(0);if(s===1)return u(h)?i:".";if(u(h)){if(g=N=1,u(i.charCodeAt(1))){let o=2,S=o;for(;o<s&&!u(i.charCodeAt(o));)o++;if(o<s&&o!==S){for(S=o;o<s&&u(i.charCodeAt(o));)o++;if(o<s&&o!==S){for(S=o;o<s&&!u(i.charCodeAt(o));)o++;if(o===s)return i;o!==S&&(g=N=o+1)}}}}else A(h)&&i.charCodeAt(1)===q&&(g=s>2&&u(i.charCodeAt(2))?3:2,N=g);let m=-1,a=!0;for(let o=s-1;o>=N;--o)if(u(i.charCodeAt(o))){if(!a){m=o;break}}else a=!1;if(m===-1){if(g===-1)return".";m=g}return i.slice(0,m)},basename(i,s){s!==void 0&&c(s,"suffix"),c(i,"path");let g=0,N=-1,h=!0,m;if(i.length>=2&&A(i.charCodeAt(0))&&i.charCodeAt(1)===q&&(g=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let a=s.length-1,o=-1;for(m=i.length-1;m>=g;--m){const S=i.charCodeAt(m);if(u(S)){if(!h){g=m+1;break}}else o===-1&&(h=!1,o=m+1),a>=0&&(S===s.charCodeAt(a)?--a===-1&&(N=m):(a=-1,N=o))}return g===N?N=o:N===-1&&(N=i.length),i.slice(g,N)}for(m=i.length-1;m>=g;--m)if(u(i.charCodeAt(m))){if(!h){g=m+1;break}}else N===-1&&(h=!1,N=m+1);return N===-1?"":i.slice(g,N)},extname(i){c(i,"path");let s=0,g=-1,N=0,h=-1,m=!0,a=0;i.length>=2&&i.charCodeAt(1)===q&&A(i.charCodeAt(0))&&(s=N=2);for(let o=i.length-1;o>=s;--o){const S=i.charCodeAt(o);if(u(S)){if(!m){N=o+1;break}continue}h===-1&&(m=!1,h=o+1),S===O?g===-1?g=o:a!==1&&(a=1):g!==-1&&(a=-1)}return g===-1||h===-1||a===0||a===1&&g===h-1&&g===N+1?"":i.slice(g,h)},format:w.bind(null,"\\"),parse(i){c(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const g=i.length;let N=0,h=i.charCodeAt(0);if(g===1)return u(h)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(u(h)){if(N=1,u(i.charCodeAt(1))){let z=2,x=z;for(;z<g&&!u(i.charCodeAt(z));)z++;if(z<g&&z!==x){for(x=z;z<g&&u(i.charCodeAt(z));)z++;if(z<g&&z!==x){for(x=z;z<g&&!u(i.charCodeAt(z));)z++;z===g?N=z:z!==x&&(N=z+1)}}}}else if(A(h)&&i.charCodeAt(1)===q){if(g<=2)return s.root=s.dir=i,s;if(N=2,u(i.charCodeAt(2))){if(g===3)return s.root=s.dir=i,s;N=3}}N>0&&(s.root=i.slice(0,N));let m=-1,a=N,o=-1,S=!0,L=i.length-1,p=0;for(;L>=N;--L){if(h=i.charCodeAt(L),u(h)){if(!S){a=L+1;break}continue}o===-1&&(S=!1,o=L+1),h===O?m===-1?m=L:p!==1&&(p=1):m!==-1&&(p=-1)}return o!==-1&&(m===-1||p===0||p===1&&m===o-1&&m===a+1?s.base=s.name=i.slice(a,o):(s.name=i.slice(a,m),s.base=i.slice(a,o),s.ext=i.slice(m,o))),a>0&&a!==N?s.dir=i.slice(0,a-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const n=(()=>{if(r){const i=/\\/g;return()=>{const s=f.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>f.cwd()})();e.posix={resolve(...i){let s="",g=!1;for(let N=i.length-1;N>=-1&&!g;N--){const h=N>=0?i[N]:n();c(h,`paths[${N}]`),h.length!==0&&(s=`${h}/${s}`,g=h.charCodeAt(0)===R)}return s=v(s,!g,"/",_),g?`/${s}`:s.length>0?s:"."},normalize(i){if(c(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===R,g=i.charCodeAt(i.length-1)===R;return i=v(i,!s,"/",_),i.length===0?s?"/":g?"./":".":(g&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return c(i,"path"),i.length>0&&i.charCodeAt(0)===R},join(...i){if(i.length===0)return".";let s;for(let g=0;g<i.length;++g){const N=i[g];c(N,"path"),N.length>0&&(s===void 0?s=N:s+=`/${N}`)}return s===void 0?".":e.posix.normalize(s)},relative(i,s){if(c(i,"from"),c(s,"to"),i===s||(i=e.posix.resolve(i),s=e.posix.resolve(s),i===s))return"";const g=1,N=i.length,h=N-g,m=1,a=s.length-m,o=h<a?h:a;let S=-1,L=0;for(;L<o;L++){const z=i.charCodeAt(g+L);if(z!==s.charCodeAt(m+L))break;z===R&&(S=L)}if(L===o)if(a>o){if(s.charCodeAt(m+L)===R)return s.slice(m+L+1);if(L===0)return s.slice(m+L)}else h>o&&(i.charCodeAt(g+L)===R?S=L:L===0&&(S=0));let p="";for(L=g+S+1;L<=N;++L)(L===N||i.charCodeAt(L)===R)&&(p+=p.length===0?"..":"/..");return`${p}${s.slice(m+S)}`},toNamespacedPath(i){return i},dirname(i){if(c(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===R;let g=-1,N=!0;for(let h=i.length-1;h>=1;--h)if(i.charCodeAt(h)===R){if(!N){g=h;break}}else N=!1;return g===-1?s?"/":".":s&&g===1?"//":i.slice(0,g)},basename(i,s){s!==void 0&&c(s,"ext"),c(i,"path");let g=0,N=-1,h=!0,m;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let a=s.length-1,o=-1;for(m=i.length-1;m>=0;--m){const S=i.charCodeAt(m);if(S===R){if(!h){g=m+1;break}}else o===-1&&(h=!1,o=m+1),a>=0&&(S===s.charCodeAt(a)?--a===-1&&(N=m):(a=-1,N=o))}return g===N?N=o:N===-1&&(N=i.length),i.slice(g,N)}for(m=i.length-1;m>=0;--m)if(i.charCodeAt(m)===R){if(!h){g=m+1;break}}else N===-1&&(h=!1,N=m+1);return N===-1?"":i.slice(g,N)},extname(i){c(i,"path");let s=-1,g=0,N=-1,h=!0,m=0;for(let a=i.length-1;a>=0;--a){const o=i.charCodeAt(a);if(o===R){if(!h){g=a+1;break}continue}N===-1&&(h=!1,N=a+1),o===O?s===-1?s=a:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||N===-1||m===0||m===1&&s===N-1&&s===g+1?"":i.slice(s,N)},format:w.bind(null,"/"),parse(i){c(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const g=i.charCodeAt(0)===R;let N;g?(s.root="/",N=1):N=0;let h=-1,m=0,a=-1,o=!0,S=i.length-1,L=0;for(;S>=N;--S){const p=i.charCodeAt(S);if(p===R){if(!o){m=S+1;break}continue}a===-1&&(o=!1,a=S+1),p===O?h===-1?h=S:L!==1&&(L=1):h!==-1&&(L=-1)}if(a!==-1){const p=m===0&&g?1:m;h===-1||L===0||L===1&&h===a-1&&h===m+1?s.base=s.name=i.slice(p,a):(s.name=i.slice(p,h),s.base=i.slice(p,a),s.ext=i.slice(h,a))}return m>0?s.dir=i.slice(0,m-1):g&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=r?e.win32.normalize:e.posix.normalize,e.isAbsolute=r?e.win32.isAbsolute:e.posix.isAbsolute,e.join=r?e.win32.join:e.posix.join,e.resolve=r?e.win32.resolve:e.posix.resolve,e.relative=r?e.win32.relative:e.posix.relative,e.dirname=r?e.win32.dirname:e.posix.dirname,e.basename=r?e.win32.basename:e.posix.basename,e.extname=r?e.win32.extname:e.posix.extname,e.format=r?e.win32.format:e.posix.format,e.parse=r?e.win32.parse:e.posix.parse,e.toNamespacedPath=r?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=r?e.win32.sep:e.posix.sep,e.delimiter=r?e.win32.delimiter:e.posix.delimiter}),define(pe[35],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const f=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(U){return new t(U)}constructor(U){this._now=f&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=t}),define(pe[17],be([0,1,10,23,11,32,35]),function(oe,e,f,t,I,U,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=C;const O=!1,R=!1,D=!1;var q;(function(J){J.None=()=>I.Disposable.None;function j(ce){if(D){const{onDidAddListener:ae}=ce,me=r.create();let he=0;ce.onDidAddListener=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),ae?.()}}}function le(ce,ae){return b(ce,()=>{},0,void 0,!0,void 0,ae)}J.defer=le;function M(ce){return(ae,me=null,he)=>{let Ee=!1,Ae;return Ae=ce(Re=>{if(!Ee)return Ae?Ae.dispose():Ee=!0,ae.call(me,Re)},null,he),Ee&&Ae.dispose(),Ae}}J.once=M;function K(ce,ae,me){return te((he,Ee=null,Ae)=>ce(Re=>he.call(Ee,ae(Re)),null,Ae),me)}J.map=K;function Z(ce,ae,me){return te((he,Ee=null,Ae)=>ce(Re=>{ae(Re),he.call(Ee,Re)},null,Ae),me)}J.forEach=Z;function ee(ce,ae,me){return te((he,Ee=null,Ae)=>ce(Re=>ae(Re)&&he.call(Ee,Re),null,Ae),me)}J.filter=ee;function W(ce){return ce}J.signal=W;function G(...ce){return(ae,me=null,he)=>{const Ee=(0,I.combinedDisposable)(...ce.map(Ae=>Ae(Re=>ae.call(me,Re))));return ue(Ee,he)}}J.any=G;function H(ce,ae,me,he){let Ee=me;return K(ce,Ae=>(Ee=ae(Ee,Ae),Ee),he)}J.reduce=H;function te(ce,ae){let me;const he={onWillAddFirstListener(){me=ce(Ee.fire,Ee)},onDidRemoveLastListener(){me?.dispose()}};ae||j(he);const Ee=new i(he);return ae?.add(Ee),Ee.event}function ue(ce,ae){return ae instanceof Array?ae.push(ce):ae&&ae.add(ce),ce}function b(ce,ae,me=100,he=!1,Ee=!1,Ae,Re){let Ie,Te,ke,we=0,Pe;const je={leakWarningThreshold:Ae,onWillAddFirstListener(){Ie=ce(Ve=>{we++,Te=ae(Te,Ve),he&&!ke&&(qe.fire(Te),Te=void 0),Pe=()=>{const Ke=Te;Te=void 0,ke=void 0,(!he||we>1)&&qe.fire(Ke),we=0},typeof me=="number"?(clearTimeout(ke),ke=setTimeout(Pe,me)):ke===void 0&&(ke=0,queueMicrotask(Pe))})},onWillRemoveListener(){Ee&&we>0&&Pe?.()},onDidRemoveLastListener(){Pe=void 0,Ie.dispose()}};Re||j(je);const qe=new i(je);return Re?.add(qe),qe.event}J.debounce=b;function ie(ce,ae=0,me){return J.debounce(ce,(he,Ee)=>he?(he.push(Ee),he):[Ee],ae,void 0,!0,void 0,me)}J.accumulate=ie;function se(ce,ae=(he,Ee)=>he===Ee,me){let he=!0,Ee;return ee(ce,Ae=>{const Re=he||!ae(Ae,Ee);return he=!1,Ee=Ae,Re},me)}J.latch=se;function re(ce,ae,me){return[J.filter(ce,ae,me),J.filter(ce,he=>!ae(he),me)]}J.split=re;function fe(ce,ae=!1,me=[],he){let Ee=me.slice(),Ae=ce(Te=>{Ee?Ee.push(Te):Ie.fire(Te)});he&&he.add(Ae);const Re=()=>{Ee?.forEach(Te=>Ie.fire(Te)),Ee=null},Ie=new i({onWillAddFirstListener(){Ae||(Ae=ce(Te=>Ie.fire(Te)),he&&he.add(Ae))},onDidAddFirstListener(){Ee&&(ae?setTimeout(Re):Re())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return he&&he.add(Ie),Ie.event}J.buffer=fe;function de(ce,ae){return(he,Ee,Ae)=>{const Re=ae(new F);return ce(function(Ie){const Te=Re.evaluate(Ie);Te!==Le&&he.call(Ee,Te)},void 0,Ae)}}J.chain=de;const Le=Symbol("HaltChainable");class F{constructor(){this.steps=[]}map(ae){return this.steps.push(ae),this}forEach(ae){return this.steps.push(me=>(ae(me),me)),this}filter(ae){return this.steps.push(me=>ae(me)?me:Le),this}reduce(ae,me){let he=me;return this.steps.push(Ee=>(he=ae(he,Ee),he)),this}latch(ae=(me,he)=>me===he){let me=!0,he;return this.steps.push(Ee=>{const Ae=me||!ae(Ee,he);return me=!1,he=Ee,Ae?Ee:Le}),this}evaluate(ae){for(const me of this.steps)if(ae=me(ae),ae===Le)break;return ae}}function B(ce,ae,me=he=>he){const he=(...Ie)=>Re.fire(me(...Ie)),Ee=()=>ce.on(ae,he),Ae=()=>ce.removeListener(ae,he),Re=new i({onWillAddFirstListener:Ee,onDidRemoveLastListener:Ae});return Re.event}J.fromNodeEventEmitter=B;function E(ce,ae,me=he=>he){const he=(...Ie)=>Re.fire(me(...Ie)),Ee=()=>ce.addEventListener(ae,he),Ae=()=>ce.removeEventListener(ae,he),Re=new i({onWillAddFirstListener:Ee,onDidRemoveLastListener:Ae});return Re.event}J.fromDOMEventEmitter=E;function l(ce){return new Promise(ae=>M(ce)(ae))}J.toPromise=l;function y(ce){const ae=new i;return ce.then(me=>{ae.fire(me)},()=>{ae.fire(void 0)}).finally(()=>{ae.dispose()}),ae.event}J.fromPromise=y;function V(ce,ae){return ce(me=>ae.fire(me))}J.forward=V;function X(ce,ae,me){return ae(me),ce(he=>ae(he))}J.runAndSubscribe=X;class _e{constructor(ae,me){this._observable=ae,this._counter=0,this._hasChanged=!1;const he={onWillAddFirstListener:()=>{ae.addObserver(this)},onDidRemoveLastListener:()=>{ae.removeObserver(this)}};me||j(he),this.emitter=new i(he),me&&me.add(this.emitter)}beginUpdate(ae){this._counter++}handlePossibleChange(ae){}handleChange(ae,me){this._hasChanged=!0}endUpdate(ae){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ve(ce,ae){return new _e(ce,ae).emitter.event}J.fromObservable=ve;function De(ce){return(ae,me,he)=>{let Ee=0,Ae=!1;const Re={beginUpdate(){Ee++},endUpdate(){Ee--,Ee===0&&(ce.reportChanges(),Ae&&(Ae=!1,ae.call(me)))},handlePossibleChange(){},handleChange(){Ae=!0}};ce.addObserver(Re),ce.reportChanges();const Ie={dispose(){ce.removeObserver(Re)}};return he instanceof I.DisposableStore?he.add(Ie):Array.isArray(he)&&he.push(Ie),Ie}}J.fromObservableLight=De})(q||(e.Event=q={}));class ${static{this.all=new Set}static{this._idPool=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${$._idPool++}`,$.all.add(this)}start(j){this._stopWatch=new Y.StopWatch,this.listenerCount=j}stop(){if(this._stopWatch){const j=this._stopWatch.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=$;let T=-1;function C(J){const j=T;return T=J,{dispose(){T=j}}}class c{static{this._idPool=1}constructor(j,le,M=(c._idPool++).toString(16).padStart(3,"0")){this._errorHandler=j,this.threshold=le,this.name=M,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(j,le){const M=this.threshold;if(M<=0||le<M)return;this._stacks||(this._stacks=new Map);const K=this._stacks.get(j.value)||0;if(this._stacks.set(j.value,K+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;const[Z,ee]=this.getMostFrequentStack(),W=`[${this.name}] potential listener LEAK detected, having ${le} listeners already. MOST frequent listener (${ee}):`;console.warn(W),console.warn(Z);const G=new u(W,Z);this._errorHandler(G)}return()=>{const Z=this._stacks.get(j.value)||0;this._stacks.set(j.value,Z-1)}}getMostFrequentStack(){if(!this._stacks)return;let j,le=0;for(const[M,K]of this._stacks)(!j||le<K)&&(j=[M,K],le=K);return j}}class r{static create(){const j=new Error;return new r(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u extends Error{constructor(j,le){super(j),this.name="ListenerLeakError",this.stack=le}}e.ListenerLeakError=u;class _ extends Error{constructor(j,le){super(j),this.name="ListenerRefusalError",this.stack=le}}e.ListenerRefusalError=_;let A=0;class v{constructor(j){this.value=j,this.id=A++}}const k=2,w=(J,j)=>{if(J instanceof v)j(J);else for(let le=0;le<J.length;le++){const M=J[le];M&&j(M)}};let n;if(O){const J=[];setInterval(()=>{J.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(J.join(`
`)),J.length=0)},3e3),n=new FinalizationRegistry(j=>{typeof j=="string"&&J.push(j)})}class i{constructor(j){this._size=0,this._options=j,this._leakageMon=T>0||this._options?.leakWarningThreshold?new c(j?.onListenerError??f.onUnexpectedError,this._options?.leakWarningThreshold??T):void 0,this._perfMon=this._options?._profName?new $(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(R){const j=this._listeners;queueMicrotask(()=>{w(j,le=>le.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(j,le,M)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const G=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(G);const H=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],te=new _(`${G}. HINT: Stack shows most frequent listener (${H[1]}-times)`,H[0]);return(this._options?.onListenerError||f.onUnexpectedError)(te),I.Disposable.None}if(this._disposed)return I.Disposable.None;le&&(j=j.bind(le));const K=new v(j);let Z,ee;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(K.stack=r.create(),Z=this._leakageMon.check(K.stack,this._size+1)),R&&(K.stack=ee??r.create()),this._listeners?this._listeners instanceof v?(this._deliveryQueue??=new g,this._listeners=[this._listeners,K]):this._listeners.push(K):(this._options?.onWillAddFirstListener?.(this),this._listeners=K,this._options?.onDidAddFirstListener?.(this)),this._size++;const W=(0,I.toDisposable)(()=>{n?.unregister(W),Z?.(),this._removeListener(K)});if(M instanceof I.DisposableStore?M.add(W):Array.isArray(M)&&M.push(W),n){const G=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),H=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(G);n.register(W,H?.[2]??G,W)}return W},this._event}_removeListener(j){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const le=this._listeners,M=le.indexOf(j);if(M===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,le[M]=void 0;const K=this._deliveryQueue.current===this;if(this._size*k<=le.length){let Z=0;for(let ee=0;ee<le.length;ee++)le[ee]?le[Z++]=le[ee]:K&&(this._deliveryQueue.end--,Z<this._deliveryQueue.i&&this._deliveryQueue.i--);le.length=Z}}_deliver(j,le){if(!j)return;const M=this._options?.onListenerError||f.onUnexpectedError;if(!M){j.value(le);return}try{j.value(le)}catch(K){M(K)}}_deliverQueue(j){const le=j.current._listeners;for(;j.i<j.end;)this._deliver(le[j.i++],j.value);j.reset()}fire(j){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof v)this._deliver(this._listeners,j);else{const le=this._deliveryQueue;le.enqueue(this,j,this._listeners.length),this._deliverQueue(le)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const s=()=>new g;e.createEventDeliveryQueue=s;class g{constructor(){this.i=-1,this.end=0}enqueue(j,le,M){this.i=0,this.end=M,this.current=j,this.value=le}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class N extends i{async fireAsync(j,le,M){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList),w(this._listeners,K=>this._asyncDeliveryQueue.push([K.value,j]));this._asyncDeliveryQueue.size>0&&!le.isCancellationRequested;){const[K,Z]=this._asyncDeliveryQueue.shift(),ee=[],W={...Z,token:le,waitUntil:G=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");M&&(G=M(G,K)),ee.push(G)}};try{K(W)}catch(G){(0,f.onUnexpectedError)(G);continue}Object.freeze(ee),await Promise.allSettled(ee).then(G=>{for(const H of G)H.status==="rejected"&&(0,f.onUnexpectedError)(H.reason)})}}}e.AsyncEmitter=N;class h extends i{get isPaused(){return this._isPaused!==0}constructor(j){super(j),this._isPaused=0,this._eventQueue=new U.LinkedList,this._mergeFn=j?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const j=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(j))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(j){this._size&&(this._isPaused!==0?this._eventQueue.push(j):super.fire(j))}}e.PauseableEmitter=h;class m extends h{constructor(j){super(j),this._delay=j.delay??100}fire(j){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(j)}}e.DebounceEmitter=m;class a extends i{constructor(j){super(j),this._queuedEvents=[],this._mergeFn=j?.merge}fire(j){this.hasListeners()&&(this._queuedEvents.push(j),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(le=>super.fire(le)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=a;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(j){const le={event:j,listener:null};this.events.push(le),this.hasListeners&&this.hook(le);const M=()=>{this.hasListeners&&this.unhook(le);const K=this.events.indexOf(le);this.events.splice(K,1)};return(0,I.toDisposable)((0,t.createSingleCallFunction)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(j=>this.hook(j))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(j=>this.unhook(j))}hook(j){j.listener=j.event(le=>this.emitter.fire(le))}unhook(j){j.listener?.dispose(),j.listener=null}dispose(){this.emitter.dispose();for(const j of this.events)j.listener?.dispose();this.events=[]}}e.EventMultiplexer=o;class S{constructor(j,le,M,K){this._store=new I.DisposableStore;const Z=this._store.add(new o),ee=this._store.add(new I.DisposableMap);function W(G){ee.set(G,Z.add(K(G)))}for(const G of j)W(G);this._store.add(le(G=>{W(G)})),this._store.add(M(G=>{ee.deleteAndDispose(G)})),this.event=Z.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=S;class L{constructor(){this.data=[]}wrapEvent(j,le,M){return(K,Z,ee)=>j(W=>{const G=this.data[this.data.length-1];if(!le){G?G.buffers.push(()=>K.call(Z,W)):K.call(Z,W);return}const H=G;if(!H){K.call(Z,le(M,W));return}H.items??=[],H.items.push(W),H.buffers.length===0&&G.buffers.push(()=>{H.reducedResult??=M?H.items.reduce(le,M):H.items.reduce(le),K.call(Z,H.reducedResult)})},void 0,ee)}bufferEvents(j){const le={buffers:new Array};this.data.push(le);const M=j();return this.data.pop(),le.buffers.forEach(K=>K()),M}}e.EventBufferer=L;class p{constructor(){this.listening=!1,this.inputEvent=q.None,this.inputEventListener=I.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(j){this.inputEvent=j,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=j(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p;class z{static const(j){return new x(j)}constructor(j){this._value=j,this._onDidChange=new i,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(j){j!==this._value&&(this._value=j,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=z;class x{constructor(j){this.value=j,this.onDidChange=q.None}}}),define(pe[12],be([0,1,17]),function(oe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=O;const t=Object.freeze(function(R,D){const q=setTimeout(R.bind(D),0);return{dispose(){clearTimeout(q)}}});var I;(function(R){function D(q){return q===R.None||q===R.Cancelled||q instanceof U?!0:!q||typeof q!="object"?!1:typeof q.isCancellationRequested=="boolean"&&typeof q.onCancellationRequested=="function"}R.isCancellationToken=D,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I||(e.CancellationToken=I={}));class U{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class Y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new U),this._token}cancel(){this._token?this._token instanceof U&&this._token.cancel():this._token=I.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof U&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=Y;function O(R){const D=new Y;return R.add({dispose(){D.cancel()}}),D.token}}),define(pe[36],be([0,1,12]),function(oe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=I;class t{constructor(R){this.task=R,this.result=null}get(){if(this.result)return this.result;const R=new f.CancellationTokenSource,D=this.task(R.token);return this.result={promise:D,dispose:()=>{this.result=null,R.cancel(),R.dispose()}},this.result}}e.Cache=t;function I(O){return O}class U{constructor(R,D){this.lastCache=void 0,this.lastArgKey=void 0,typeof R=="function"?(this._fn=R,this._computeKey=I):(this._fn=D,this._computeKey=R.getCacheKey)}get(R){const D=this._computeKey(R);return this.lastArgKey!==D&&(this.lastArgKey=D,this.lastCache=this._fn(R)),this.lastCache}}e.LRUCachedFunction=U;class Y{get cachedValues(){return this._map}constructor(R,D){this._map=new Map,this._map2=new Map,typeof R=="function"?(this._fn=R,this._computeKey=I):(this._fn=D,this._computeKey=R.getCacheKey)}get(R){const D=this._computeKey(R);if(this._map2.has(D))return this._map2.get(D);const q=this._fn(R);return this._map.set(R,q),this._map2.set(D,q),q}}e.CachedFunction=Y}),define(pe[37],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(pe[25],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=f,e.isStringArray=t,e.isObject=I,e.isTypedArray=U,e.isNumber=Y,e.isIterable=O,e.isBoolean=R,e.isUndefined=D,e.isDefined=q,e.isUndefinedOrNull=$,e.assertType=T,e.assertIsDefined=C,e.assertAllDefined=c,e.isEmptyObject=u,e.isFunction=_,e.areFunctions=A,e.validateConstraints=v,e.validateConstraint=k,e.upcast=w;function f(n){return typeof n=="string"}function t(n){return Array.isArray(n)&&n.every(i=>f(i))}function I(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}function U(n){const i=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof i}function Y(n){return typeof n=="number"&&!isNaN(n)}function O(n){return!!n&&typeof n[Symbol.iterator]=="function"}function R(n){return n===!0||n===!1}function D(n){return typeof n>"u"}function q(n){return!$(n)}function $(n){return D(n)||n===null}function T(n,i){if(!n)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function C(n){if($(n))throw new Error("Assertion Failed: argument is undefined or null");return n}function c(...n){const i=[];for(let s=0;s<n.length;s++){const g=n[s];if($(g))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(g)}return i}const r=Object.prototype.hasOwnProperty;function u(n){if(!I(n))return!1;for(const i in n)if(r.call(n,i))return!1;return!0}function _(n){return typeof n=="function"}function A(...n){return n.length>0&&n.every(_)}function v(n,i){const s=Math.min(n.length,i.length);for(let g=0;g<s;g++)k(n[g],i[g])}function k(n,i){if(f(i)){if(typeof n!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(_(i)){try{if(n instanceof i)return}catch{}if(!$(n)&&n.constructor===i||i.length===1&&i.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function w(n){return n}}),define(pe[38],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=t,e.toUint32=I;var f;(function(U){U[U.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",U[U.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",U[U.MAX_UINT_8=255]="MAX_UINT_8",U[U.MAX_UINT_16=65535]="MAX_UINT_16",U[U.MAX_UINT_32=4294967295]="MAX_UINT_32",U[U.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f||(e.Constants=f={}));function t(U){return U<0?0:U>f.MAX_UINT_8?f.MAX_UINT_8:U|0}function I(U){return U<0?0:U>f.MAX_UINT_32?f.MAX_UINT_32:U|0}}),define(pe[4],be([0,1,36,7,14,38]),function(oe,e,f,t,I,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=Y,e.format=R,e.format2=q,e.htmlAttributeEncodeValue=$,e.escape=T,e.escapeRegExpCharacters=C,e.count=c,e.truncate=r,e.truncateMiddle=u,e.trim=_,e.ltrim=A,e.rtrim=v,e.convertSimple2RegExpPattern=k,e.stripWildcards=w,e.createRegExp=n,e.regExpLeadsToEndlessLoop=i,e.splitLines=s,e.splitLinesIncludeSeparators=g,e.firstNonWhitespaceIndex=N,e.getLeadingWhitespace=h,e.lastNonWhitespaceIndex=m,e.replaceAsync=a,e.compare=o,e.compareSubstring=S,e.compareIgnoreCase=L,e.compareSubstringIgnoreCase=p,e.isAsciiDigit=z,e.isLowerAsciiLetter=x,e.isUpperAsciiLetter=J,e.equalsIgnoreCase=j,e.startsWithIgnoreCase=le,e.commonPrefixLength=M,e.commonSuffixLength=K,e.isHighSurrogate=Z,e.isLowSurrogate=ee,e.computeCodePoint=W,e.getNextCodePoint=G,e.nextCharLength=b,e.prevCharLength=ie,e.getCharContainingOffset=se,e.charCount=re,e.containsRTL=Le,e.isBasicASCII=B,e.containsUnusualLineTerminators=E,e.isFullWidthCharacter=l,e.isEmojiImprecise=y,e.lcut=V,e.forAnsiStringParts=_e,e.removeAnsiEscapeCodes=ve,e.removeAnsiEscapeCodesFromPrompt=ce,e.startsWithUTF8BOM=ae,e.stripUTF8BOM=me,e.fuzzyContains=he,e.containsUppercaseCharacter=Ee,e.uppercaseFirstLetter=Ae,e.getNLines=Re,e.singleLetterHash=Ie,e.getGraphemeBreakType=Te,e.getLeftDeleteOffset=qe;function Y(d){return!d||typeof d!="string"?!0:d.trim().length===0}const O=/{(\d+)}/g;function R(d,...P){return P.length===0?d:d.replace(O,function(Q,ne){const ge=parseInt(ne,10);return isNaN(ge)||ge<0||ge>=P.length?Q:P[ge]})}const D=/{([^}]+)}/g;function q(d,P){return Object.keys(P).length===0?d:d.replace(D,(Q,ne)=>P[ne]??Q)}function $(d){return d.replace(/[<>"'&]/g,P=>{switch(P){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return P})}function T(d){return d.replace(/[<>&]/g,function(P){switch(P){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return P}})}function C(d){return d.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(d,P){let Q=0,ne=d.indexOf(P);for(;ne!==-1;)Q++,ne=d.indexOf(P,ne+P.length);return Q}function r(d,P,Q="\u2026"){return d.length<=P?d:`${d.substr(0,P)}${Q}`}function u(d,P,Q="\u2026"){if(d.length<=P)return d;const ne=Math.ceil(P/2)-Q.length/2,ge=Math.floor(P/2)-Q.length/2;return`${d.substr(0,ne)}${Q}${d.substr(d.length-ge)}`}function _(d,P=" "){const Q=A(d,P);return v(Q,P)}function A(d,P){if(!d||!P)return d;const Q=P.length;if(Q===0||d.length===0)return d;let ne=0;for(;d.indexOf(P,ne)===ne;)ne=ne+Q;return d.substring(ne)}function v(d,P){if(!d||!P)return d;const Q=P.length,ne=d.length;if(Q===0||ne===0)return d;let ge=ne,ye=-1;for(;ye=d.lastIndexOf(P,ge-1),!(ye===-1||ye+Q!==ge);){if(ye===0)return"";ge=ye}return d.substring(0,ge)}function k(d){return d.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function w(d){return d.replace(/\*/g,"")}function n(d,P,Q={}){if(!d)throw new Error("Cannot create regex from empty string");P||(d=C(d)),Q.wholeWord&&(/\B/.test(d.charAt(0))||(d="\\b"+d),/\B/.test(d.charAt(d.length-1))||(d=d+"\\b"));let ne="";return Q.global&&(ne+="g"),Q.matchCase||(ne+="i"),Q.multiline&&(ne+="m"),Q.unicode&&(ne+="u"),new RegExp(d,ne)}function i(d){return d.source==="^"||d.source==="^$"||d.source==="$"||d.source==="^\\s*$"?!1:!!(d.exec("")&&d.lastIndex===0)}function s(d){return d.split(/\r\n|\r|\n/)}function g(d){const P=[],Q=d.split(/(\r\n|\r|\n)/);for(let ne=0;ne<Math.ceil(Q.length/2);ne++)P.push(Q[2*ne]+(Q[2*ne+1]??""));return P}function N(d){for(let P=0,Q=d.length;P<Q;P++){const ne=d.charCodeAt(P);if(ne!==t.CharCode.Space&&ne!==t.CharCode.Tab)return P}return-1}function h(d,P=0,Q=d.length){for(let ne=P;ne<Q;ne++){const ge=d.charCodeAt(ne);if(ge!==t.CharCode.Space&&ge!==t.CharCode.Tab)return d.substring(P,ne)}return d.substring(P,Q)}function m(d,P=d.length-1){for(let Q=P;Q>=0;Q--){const ne=d.charCodeAt(Q);if(ne!==t.CharCode.Space&&ne!==t.CharCode.Tab)return Q}return-1}function a(d,P,Q){const ne=[];let ge=0;for(const ye of d.matchAll(P)){if(ne.push(d.slice(ge,ye.index)),ye.index===void 0)throw new Error("match.index should be defined");ge=ye.index+ye[0].length,ne.push(Q(ye[0],...ye.slice(1),ye.index,d,ye.groups))}return ne.push(d.slice(ge)),Promise.all(ne).then(ye=>ye.join(""))}function o(d,P){return d<P?-1:d>P?1:0}function S(d,P,Q=0,ne=d.length,ge=0,ye=P.length){for(;Q<ne&&ge<ye;Q++,ge++){const Fe=d.charCodeAt(Q),Ne=P.charCodeAt(ge);if(Fe<Ne)return-1;if(Fe>Ne)return 1}const Oe=ne-Q,We=ye-ge;return Oe<We?-1:Oe>We?1:0}function L(d,P){return p(d,P,0,d.length,0,P.length)}function p(d,P,Q=0,ne=d.length,ge=0,ye=P.length){for(;Q<ne&&ge<ye;Q++,ge++){let Fe=d.charCodeAt(Q),Ne=P.charCodeAt(ge);if(Fe===Ne)continue;if(Fe>=128||Ne>=128)return S(d.toLowerCase(),P.toLowerCase(),Q,ne,ge,ye);x(Fe)&&(Fe-=32),x(Ne)&&(Ne-=32);const Se=Fe-Ne;if(Se!==0)return Se}const Oe=ne-Q,We=ye-ge;return Oe<We?-1:Oe>We?1:0}function z(d){return d>=t.CharCode.Digit0&&d<=t.CharCode.Digit9}function x(d){return d>=t.CharCode.a&&d<=t.CharCode.z}function J(d){return d>=t.CharCode.A&&d<=t.CharCode.Z}function j(d,P){return d.length===P.length&&p(d,P)===0}function le(d,P){const Q=P.length;return P.length>d.length?!1:p(d,P,0,Q)===0}function M(d,P){const Q=Math.min(d.length,P.length);let ne;for(ne=0;ne<Q;ne++)if(d.charCodeAt(ne)!==P.charCodeAt(ne))return ne;return Q}function K(d,P){const Q=Math.min(d.length,P.length);let ne;const ge=d.length-1,ye=P.length-1;for(ne=0;ne<Q;ne++)if(d.charCodeAt(ge-ne)!==P.charCodeAt(ye-ne))return ne;return Q}function Z(d){return 55296<=d&&d<=56319}function ee(d){return 56320<=d&&d<=57343}function W(d,P){return(d-55296<<10)+(P-56320)+65536}function G(d,P,Q){const ne=d.charCodeAt(Q);if(Z(ne)&&Q+1<P){const ge=d.charCodeAt(Q+1);if(ee(ge))return W(ne,ge)}return ne}function H(d,P){const Q=d.charCodeAt(P-1);if(ee(Q)&&P>1){const ne=d.charCodeAt(P-2);if(Z(ne))return W(ne,Q)}return Q}class te{get offset(){return this._offset}constructor(P,Q=0){this._str=P,this._len=P.length,this._offset=Q}setOffset(P){this._offset=P}prevCodePoint(){const P=H(this._str,this._offset);return this._offset-=P>=U.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,P}nextCodePoint(){const P=G(this._str,this._len,this._offset);return this._offset+=P>=U.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,P}eol(){return this._offset>=this._len}}e.CodePointIterator=te;class ue{get offset(){return this._iterator.offset}constructor(P,Q=0){this._iterator=new te(P,Q)}nextGraphemeLength(){const P=Pe.getInstance(),Q=this._iterator,ne=Q.offset;let ge=P.getGraphemeBreakType(Q.nextCodePoint());for(;!Q.eol();){const ye=Q.offset,Oe=P.getGraphemeBreakType(Q.nextCodePoint());if(ke(ge,Oe)){Q.setOffset(ye);break}ge=Oe}return Q.offset-ne}prevGraphemeLength(){const P=Pe.getInstance(),Q=this._iterator,ne=Q.offset;let ge=P.getGraphemeBreakType(Q.prevCodePoint());for(;Q.offset>0;){const ye=Q.offset,Oe=P.getGraphemeBreakType(Q.prevCodePoint());if(ke(Oe,ge)){Q.setOffset(ye);break}ge=Oe}return ne-Q.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ue;function b(d,P){return new ue(d,P).nextGraphemeLength()}function ie(d,P){return new ue(d,P).prevGraphemeLength()}function se(d,P){P>0&&ee(d.charCodeAt(P))&&P--;const Q=P+b(d,P);return[Q-ie(d,Q),Q]}function re(d){const P=new ue(d);let Q=0;for(;!P.eol();)Q++,P.nextGraphemeLength();return Q}let fe;function de(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Le(d){return fe||(fe=de()),fe.test(d)}const F=/^[\t\n\r\x20-\x7E]*$/;function B(d){return F.test(d)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function E(d){return e.UNUSUAL_LINE_TERMINATORS.test(d)}function l(d){return d>=11904&&d<=55215||d>=63744&&d<=64255||d>=65281&&d<=65374}function y(d){return d>=127462&&d<=127487||d===8986||d===8987||d===9200||d===9203||d>=9728&&d<=10175||d===11088||d===11093||d>=127744&&d<=128591||d>=128640&&d<=128764||d>=128992&&d<=129008||d>=129280&&d<=129535||d>=129648&&d<=129782}function V(d,P,Q=""){const ne=d.trimStart();if(ne.length<P)return ne;const ge=/\b/g;let ye=0;for(;ge.test(ne)&&!(ne.length-ge.lastIndex<P);)ye=ge.lastIndex,ge.lastIndex+=1;return ye===0?ne:Q+ne.substring(ye).trimStart()}const X=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*_e(d){let P=0;for(const Q of d.matchAll(X))P!==Q.index&&(yield{isCode:!1,str:d.substring(P,Q.index)}),yield{isCode:!0,str:Q[0]},P=Q.index+Q[0].length;P!==d.length&&(yield{isCode:!1,str:d.substring(P)})}function ve(d){return d&&(d=d.replace(X,"")),d}const De=/\\\[.*?\\\]/g;function ce(d){return ve(d).replace(De,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(t.CharCode.UTF8_BOM);function ae(d){return!!(d&&d.length>0&&d.charCodeAt(0)===t.CharCode.UTF8_BOM)}function me(d){return ae(d)?d.substr(1):d}function he(d,P){if(!d||!P||d.length<P.length)return!1;const Q=P.length,ne=d.toLowerCase();let ge=0,ye=-1;for(;ge<Q;){const Oe=ne.indexOf(P[ge],ye+1);if(Oe<0)return!1;ye=Oe,ge++}return!0}function Ee(d,P=!1){return d?(P&&(d=d.replace(/\\./g,"")),d.toLowerCase()!==d):!1}function Ae(d){return d.charAt(0).toUpperCase()+d.slice(1)}function Re(d,P=1){if(P===0)return"";let Q=-1;do Q=d.indexOf(`
`,Q+1),P--;while(P>0&&Q>=0);return Q===-1?d:(d[Q-1]==="\r"&&Q--,d.substr(0,Q))}function Ie(d){const P=t.CharCode.Z-t.CharCode.A+1;return d=d%(2*P),d<P?String.fromCharCode(t.CharCode.a+d):String.fromCharCode(t.CharCode.A+d-P)}function Te(d){return Pe.getInstance().getGraphemeBreakType(d)}function ke(d,P){return d===we.Other?P!==we.Extend&&P!==we.SpacingMark:d===we.CR&&P===we.LF?!1:d===we.Control||d===we.CR||d===we.LF||P===we.Control||P===we.CR||P===we.LF?!0:!(d===we.L&&(P===we.L||P===we.V||P===we.LV||P===we.LVT)||(d===we.LV||d===we.V)&&(P===we.V||P===we.T)||(d===we.LVT||d===we.T)&&P===we.T||P===we.Extend||P===we.ZWJ||P===we.SpacingMark||d===we.Prepend||d===we.ZWJ&&P===we.Extended_Pictographic||d===we.Regional_Indicator&&P===we.Regional_Indicator)}var we;(function(d){d[d.Other=0]="Other",d[d.Prepend=1]="Prepend",d[d.CR=2]="CR",d[d.LF=3]="LF",d[d.Control=4]="Control",d[d.Extend=5]="Extend",d[d.Regional_Indicator=6]="Regional_Indicator",d[d.SpacingMark=7]="SpacingMark",d[d.L=8]="L",d[d.V=9]="V",d[d.T=10]="T",d[d.LV=11]="LV",d[d.LVT=12]="LVT",d[d.ZWJ=13]="ZWJ",d[d.Extended_Pictographic=14]="Extended_Pictographic"})(we||(e.GraphemeBreakType=we={}));class Pe{static{this._INSTANCE=null}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}constructor(){this._data=je()}getGraphemeBreakType(P){if(P<32)return P===t.CharCode.LineFeed?we.LF:P===t.CharCode.CarriageReturn?we.CR:we.Control;if(P<127)return we.Other;const Q=this._data,ne=Q.length/3;let ge=1;for(;ge<=ne;)if(P<Q[3*ge])ge=2*ge;else if(P>Q[3*ge+1])ge=2*ge+1;else return Q[3*ge+2];return we.Other}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(d,P){if(d===0)return 0;const Q=Ve(d,P);if(Q!==void 0)return Q;const ne=new te(P,d);return ne.prevCodePoint(),ne.offset}function Ve(d,P){const Q=new te(P,d);let ne=Q.prevCodePoint();for(;Ke(ne)||ne===ze.emojiVariantSelector||ne===ze.enclosingKeyCap;){if(Q.offset===0)return;ne=Q.prevCodePoint()}if(!y(ne))return;let ge=Q.offset;return ge>0&&Q.prevCodePoint()===ze.zwj&&(ge=Q.offset),ge}function Ke(d){return 127995<=d&&d<=127999}var ze;(function(d){d[d.zwj=8205]="zwj",d[d.emojiVariantSelector=65039]="emojiVariantSelector",d[d.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class $e{static{this.ambiguousCharacterData=new I.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new f.LRUCachedFunction({getCacheKey:JSON.stringify},P=>{function Q(Se){const Be=new Map;for(let Me=0;Me<Se.length;Me+=2)Be.set(Se[Me],Se[Me+1]);return Be}function ne(Se,Be){const Me=new Map(Se);for(const[He,Qe]of Be)Me.set(He,Qe);return Me}function ge(Se,Be){if(!Se)return Be;const Me=new Map;for(const[He,Qe]of Se)Be.has(He)&&Me.set(He,Qe);return Me}const ye=this.ambiguousCharacterData.value;let Oe=P.filter(Se=>!Se.startsWith("_")&&Se in ye);Oe.length===0&&(Oe=["_default"]);let We;for(const Se of Oe){const Be=Q(ye[Se]);We=ge(We,Be)}const Fe=Q(ye._common),Ne=ne(Fe,We);return new $e(Ne)})}static getInstance(P){return $e.cache.get(Array.from(P))}static{this._locales=new I.Lazy(()=>Object.keys($e.ambiguousCharacterData.value).filter(P=>!P.startsWith("_")))}static getLocales(){return $e._locales.value}constructor(P){this.confusableDictionary=P}isAmbiguous(P){return this.confusableDictionary.has(P)}containsAmbiguousCharacter(P){for(let Q=0;Q<P.length;Q++){const ne=P.codePointAt(Q);if(typeof ne=="number"&&this.isAmbiguous(ne))return!0}return!1}getPrimaryConfusable(P){return this.confusableDictionary.get(P)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=$e;class Ce{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ce.getRawData())),this._data}static isInvisibleCharacter(P){return Ce.getData().has(P)}static containsInvisibleCharacter(P){for(let Q=0;Q<P.length;Q++){const ne=P.codePointAt(Q);if(typeof ne=="number"&&Ce.isInvisibleCharacter(ne))return!0}return!1}static get codePoints(){return Ce.getData()}}e.InvisibleCharacters=Ce}),define(pe[5],be([0,1,7,3,2,4,25]),function(oe,e,f,t,I,U,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=O,e.toSlashes=R,e.toPosixPath=D,e.getRoot=q,e.isUNC=$,e.isValidBasename=r,e.isEqual=u,e.isEqualOrParent=_,e.isWindowsDriveLetter=A,e.sanitizeFilePath=v,e.removeTrailingPathSeparator=k,e.isRootOrDriveLetter=w,e.hasDriveLetter=n,e.getDriveLetter=i,e.indexOfPath=s,e.parseLineAndColumnAware=g,e.randomPath=m;function O(a){return a===f.CharCode.Slash||a===f.CharCode.Backslash}function R(a){return a.replace(/[\\/]/g,t.posix.sep)}function D(a){return a.indexOf("/")===-1&&(a=R(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}function q(a,o=t.posix.sep){if(!a)return"";const S=a.length,L=a.charCodeAt(0);if(O(L)){if(O(a.charCodeAt(1))&&!O(a.charCodeAt(2))){let z=3;const x=z;for(;z<S&&!O(a.charCodeAt(z));z++);if(x!==z&&!O(a.charCodeAt(z+1))){for(z+=1;z<S;z++)if(O(a.charCodeAt(z)))return a.slice(0,z+1).replace(/[\\/]/g,o)}}return o}else if(A(L)&&a.charCodeAt(1)===f.CharCode.Colon)return O(a.charCodeAt(2))?a.slice(0,2)+o:a.slice(0,2);let p=a.indexOf("://");if(p!==-1){for(p+=3;p<S;p++)if(O(a.charCodeAt(p)))return a.slice(0,p+1)}return""}function $(a){if(!I.isWindows||!a||a.length<5)return!1;let o=a.charCodeAt(0);if(o!==f.CharCode.Backslash||(o=a.charCodeAt(1),o!==f.CharCode.Backslash))return!1;let S=2;const L=S;for(;S<a.length&&(o=a.charCodeAt(S),o!==f.CharCode.Backslash);S++);return!(L===S||(o=a.charCodeAt(S+1),isNaN(o)||o===f.CharCode.Backslash))}const T=/[\\/:\*\?"<>\|]/g,C=/[/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(a,o=I.isWindows){const S=o?T:C;return!(!a||a.length===0||/^\s+$/.test(a)||(S.lastIndex=0,S.test(a))||o&&c.test(a)||a==="."||a===".."||o&&a[a.length-1]==="."||o&&a.length!==a.trim().length||a.length>255)}function u(a,o,S){const L=a===o;return!S||L?L:!a||!o?!1:(0,U.equalsIgnoreCase)(a,o)}function _(a,o,S,L=t.sep){if(a===o)return!0;if(!a||!o||o.length>a.length)return!1;if(S){if(!(0,U.startsWithIgnoreCase)(a,o))return!1;if(o.length===a.length)return!0;let z=o.length;return o.charAt(o.length-1)===L&&z--,a.charAt(z)===L}return o.charAt(o.length-1)!==L&&(o+=L),a.indexOf(o)===0}function A(a){return a>=f.CharCode.A&&a<=f.CharCode.Z||a>=f.CharCode.a&&a<=f.CharCode.z}function v(a,o){return I.isWindows&&a.endsWith(":")&&(a+=t.sep),(0,t.isAbsolute)(a)||(a=(0,t.join)(o,a)),a=(0,t.normalize)(a),k(a)}function k(a){return I.isWindows?(a=(0,U.rtrim)(a,t.sep),a.endsWith(":")&&(a+=t.sep)):(a=(0,U.rtrim)(a,t.sep),a||(a=t.sep)),a}function w(a){const o=(0,t.normalize)(a);return I.isWindows?a.length>3?!1:n(o)&&(a.length===2||o.charCodeAt(2)===f.CharCode.Backslash):o===t.posix.sep}function n(a,o=I.isWindows){return o?A(a.charCodeAt(0))&&a.charCodeAt(1)===f.CharCode.Colon:!1}function i(a,o=I.isWindows){return n(a,o)?a[0]:void 0}function s(a,o,S){return o.length>a.length?-1:a===o?0:(S&&(a=a.toLowerCase(),o=o.toLowerCase()),a.indexOf(o))}function g(a){const o=a.split(":");let S,L,p;for(const z of o){const x=Number(z);(0,Y.isNumber)(x)?L===void 0?L=x:p===void 0&&(p=x):S=S?[S,z].join(":"):z}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:L!==void 0?L:void 0,column:p!==void 0?p:L!==void 0?1:void 0}}const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(a,o,S=8){let L="";for(let z=0;z<S;z++){let x;z===0&&I.isWindows&&!o&&(S===3||S===4)?x=h:x=N,L+=x.charAt(Math.floor(Math.random()*x.length))}let p;return o?p=`${o}-${L}`:p=L,a?(0,t.join)(a,p):p}}),define(pe[39],be([0,1,13,7,4]),function(oe,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class U{constructor(){this._value="",this._pos=0}reset(c){return this._value=c,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(c){const r=c.charCodeAt(0),u=this._value.charCodeAt(this._pos);return r-u}value(){return this._value[this._pos]}}e.StringIterator=U;class Y{constructor(c=!0){this._caseSensitive=c}reset(c){return this._value=c,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let c=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===t.CharCode.Period)if(c)this._from++;else break;else c=!1;return this}cmp(c){return this._caseSensitive?(0,I.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=Y;class O{constructor(c=!0,r=!0){this._splitOnBackslash=c,this._caseSensitive=r}reset(c){this._from=0,this._to=0,this._value=c,this._valueLen=c.length;for(let r=c.length-1;r>=0;r--,this._valueLen--){const u=this._value.charCodeAt(r);if(!(u===t.CharCode.Slash||this._splitOnBackslash&&u===t.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let c=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===t.CharCode.Slash||this._splitOnBackslash&&r===t.CharCode.Backslash)if(c)this._from++;else break;else c=!1}return this}cmp(c){return this._caseSensitive?(0,I.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=O;var R;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(R||(R={}));class D{constructor(c,r){this._ignorePathCasing=c,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(c){return this._value=c,this._states=[],this._value.scheme&&this._states.push(R.Scheme),this._value.authority&&this._states.push(R.Authority),this._value.path&&(this._pathIterator=new O(!1,!this._ignorePathCasing(c)),this._pathIterator.reset(c.path),this._pathIterator.value()&&this._states.push(R.Path)),this._ignoreQueryAndFragment(c)||(this._value.query&&this._states.push(R.Query),this._value.fragment&&this._states.push(R.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===R.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===R.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(c){if(this._states[this._stateIdx]===R.Scheme)return(0,I.compareIgnoreCase)(c,this._value.scheme);if(this._states[this._stateIdx]===R.Authority)return(0,I.compareIgnoreCase)(c,this._value.authority);if(this._states[this._stateIdx]===R.Path)return this._pathIterator.cmp(c);if(this._states[this._stateIdx]===R.Query)return(0,I.compare)(c,this._value.query);if(this._states[this._stateIdx]===R.Fragment)return(0,I.compare)(c,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===R.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===R.Authority)return this._value.authority;if(this._states[this._stateIdx]===R.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===R.Query)return this._value.query;if(this._states[this._stateIdx]===R.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=D;class q{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})($||($={}));class T{static forUris(c=()=>!1,r=()=>!1){return new T(new D(c,r))}static forPaths(c=!1){return new T(new O(void 0,!c))}static forStrings(){return new T(new U)}static forConfigKeys(){return new T(new Y)}constructor(c){this._iter=c}clear(){this._root=void 0}fill(c,r){if(r){const u=r.slice(0);(0,f.shuffle)(u);for(const _ of u)this.set(_,c)}else{const u=c.slice(0);(0,f.shuffle)(u);for(const _ of u)this.set(_[0],_[1])}}set(c,r){const u=this._iter.reset(c);let _;this._root||(this._root=new q,this._root.segment=u.value());const A=[];for(_=this._root;;){const k=u.cmp(_.segment);if(k>0)_.left||(_.left=new q,_.left.segment=u.value()),A.push([$.Left,_]),_=_.left;else if(k<0)_.right||(_.right=new q,_.right.segment=u.value()),A.push([$.Right,_]),_=_.right;else if(u.hasNext())u.next(),_.mid||(_.mid=new q,_.mid.segment=u.value()),A.push([$.Mid,_]),_=_.mid;else break}const v=_.value;_.value=r,_.key=c;for(let k=A.length-1;k>=0;k--){const w=A[k][1];w.updateHeight();const n=w.balanceFactor();if(n<-1||n>1){const i=A[k][0],s=A[k+1][0];if(i===$.Right&&s===$.Right)A[k][1]=w.rotateLeft();else if(i===$.Left&&s===$.Left)A[k][1]=w.rotateRight();else if(i===$.Right&&s===$.Left)w.right=A[k+1][1]=A[k+1][1].rotateRight(),A[k][1]=w.rotateLeft();else if(i===$.Left&&s===$.Right)w.left=A[k+1][1]=A[k+1][1].rotateLeft(),A[k][1]=w.rotateRight();else throw new Error;if(k>0)switch(A[k-1][0]){case $.Left:A[k-1][1].left=A[k][1];break;case $.Right:A[k-1][1].right=A[k][1];break;case $.Mid:A[k-1][1].mid=A[k][1];break}else this._root=A[0][1]}}return v}get(c){return this._getNode(c)?.value}_getNode(c){const r=this._iter.reset(c);let u=this._root;for(;u;){const _=r.cmp(u.segment);if(_>0)u=u.left;else if(_<0)u=u.right;else if(r.hasNext())r.next(),u=u.mid;else break}return u}has(c){const r=this._getNode(c);return!(r?.value===void 0&&r?.mid===void 0)}delete(c){return this._delete(c,!1)}deleteSuperstr(c){return this._delete(c,!0)}_delete(c,r){const u=this._iter.reset(c),_=[];let A=this._root;for(;A;){const v=u.cmp(A.segment);if(v>0)_.push([$.Left,A]),A=A.left;else if(v<0)_.push([$.Right,A]),A=A.right;else if(u.hasNext())u.next(),_.push([$.Mid,A]),A=A.mid;else break}if(A){if(r?(A.left=void 0,A.mid=void 0,A.right=void 0,A.height=1):(A.key=void 0,A.value=void 0),!A.mid&&!A.value)if(A.left&&A.right){const v=this._min(A.right);if(v.key){const{key:k,value:w,segment:n}=v;this._delete(v.key,!1),A.key=k,A.value=w,A.segment=n}}else{const v=A.left??A.right;if(_.length>0){const[k,w]=_[_.length-1];switch(k){case $.Left:w.left=v;break;case $.Mid:w.mid=v;break;case $.Right:w.right=v;break}}else this._root=v}for(let v=_.length-1;v>=0;v--){const k=_[v][1];k.updateHeight();const w=k.balanceFactor();if(w>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),_[v][1]=k.rotateLeft()):w<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),_[v][1]=k.rotateRight()),v>0)switch(_[v-1][0]){case $.Left:_[v-1][1].left=_[v][1];break;case $.Right:_[v-1][1].right=_[v][1];break;case $.Mid:_[v-1][1].mid=_[v][1];break}else this._root=_[0][1]}}}_min(c){for(;c.left;)c=c.left;return c}findSubstr(c){const r=this._iter.reset(c);let u=this._root,_;for(;u;){const A=r.cmp(u.segment);if(A>0)u=u.left;else if(A<0)u=u.right;else if(r.hasNext())r.next(),_=u.value||_,u=u.mid;else break}return u&&u.value||_}findSuperstr(c){return this._findSuperstrOrElement(c,!1)}_findSuperstrOrElement(c,r){const u=this._iter.reset(c);let _=this._root;for(;_;){const A=u.cmp(_.segment);if(A>0)_=_.left;else if(A<0)_=_.right;else if(u.hasNext())u.next(),_=_.mid;else return _.mid?this._entries(_.mid):r?_.value:void 0}}hasElementOrSubtree(c){return this._findSuperstrOrElement(c,!0)!==void 0}forEach(c){for(const[r,u]of this)c(u,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(c){const r=[];return this._dfsEntries(c,r),r[Symbol.iterator]()}_dfsEntries(c,r){c&&(c.left&&this._dfsEntries(c.left,r),c.value&&r.push([c.key,c.value]),c.mid&&this._dfsEntries(c.mid,r),c.right&&this._dfsEntries(c.right,r))}_isBalanced(){const c=r=>{if(!r)return!0;const u=r.balanceFactor();return u<-1||u>1?!1:c(r.left)&&c(r.right)};return c(this._root)}}e.TernarySearchTree=T}),define(pe[6],be([0,1,7,33,3,2]),function(oe,e,f,t,I,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=u,e.uriToFsPath=n,I=Ue(I);const Y=/^\w[\w\d+.-]*$/,O=/^\//,R=/^\/\//;function D(h,m){if(!h.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!Y.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!O.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function q(h,m){return!h&&!m?"file":h}function $(h,m){switch(h){case"https":case"http":case"file":m?m[0]!==C&&(m=C+m):m=C;break}return m}const T="",C="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(m){return m instanceof r?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,a,o,S,L,p=!1){typeof m=="object"?(this.scheme=m.scheme||T,this.authority=m.authority||T,this.path=m.path||T,this.query=m.query||T,this.fragment=m.fragment||T):(this.scheme=q(m,p),this.authority=a||T,this.path=$(this.scheme,o||T),this.query=S||T,this.fragment=L||T,D(this,p))}get fsPath(){return n(this,!1)}with(m){if(!m)return this;let{scheme:a,authority:o,path:S,query:L,fragment:p}=m;return a===void 0?a=this.scheme:a===null&&(a=T),o===void 0?o=this.authority:o===null&&(o=T),S===void 0?S=this.path:S===null&&(S=T),L===void 0?L=this.query:L===null&&(L=T),p===void 0?p=this.fragment:p===null&&(p=T),a===this.scheme&&o===this.authority&&S===this.path&&L===this.query&&p===this.fragment?this:new A(a,o,S,L,p)}static parse(m,a=!1){const o=c.exec(m);return o?new A(o[2]||T,N(o[4]||T),N(o[5]||T),N(o[7]||T),N(o[9]||T),a):new A(T,T,T,T,T)}static file(m){let a=T;if(U.isWindows&&(m=m.replace(/\\/g,C)),m[0]===C&&m[1]===C){const o=m.indexOf(C,2);o===-1?(a=m.substring(2),m=C):(a=m.substring(2,o),m=m.substring(o)||C)}return new A("file",a,m,T,T)}static from(m,a){return new A(m.scheme,m.authority,m.path,m.query,m.fragment,a)}static joinPath(m,...a){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return U.isWindows&&m.scheme==="file"?o=r.file(I.win32.join(n(m,!0),...a)).path:o=I.posix.join(m.path,...a),m.with({path:o})}toString(m=!1){return i(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof r)return m;{const a=new A(m);return a._formatted=m.external??null,a._fsPath=m._sep===_?m.fsPath??null:null,a}}else return m}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=r;function u(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const _=U.isWindows?1:void 0;class A extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(m=!1){return m?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const m={$mid:t.MarshalledId.Uri};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=_),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const v={[f.CharCode.Colon]:"%3A",[f.CharCode.Slash]:"%2F",[f.CharCode.QuestionMark]:"%3F",[f.CharCode.Hash]:"%23",[f.CharCode.OpenSquareBracket]:"%5B",[f.CharCode.CloseSquareBracket]:"%5D",[f.CharCode.AtSign]:"%40",[f.CharCode.ExclamationMark]:"%21",[f.CharCode.DollarSign]:"%24",[f.CharCode.Ampersand]:"%26",[f.CharCode.SingleQuote]:"%27",[f.CharCode.OpenParen]:"%28",[f.CharCode.CloseParen]:"%29",[f.CharCode.Asterisk]:"%2A",[f.CharCode.Plus]:"%2B",[f.CharCode.Comma]:"%2C",[f.CharCode.Semicolon]:"%3B",[f.CharCode.Equals]:"%3D",[f.CharCode.Space]:"%20"};function k(h,m,a){let o,S=-1;for(let L=0;L<h.length;L++){const p=h.charCodeAt(L);if(p>=f.CharCode.a&&p<=f.CharCode.z||p>=f.CharCode.A&&p<=f.CharCode.Z||p>=f.CharCode.Digit0&&p<=f.CharCode.Digit9||p===f.CharCode.Dash||p===f.CharCode.Period||p===f.CharCode.Underline||p===f.CharCode.Tilde||m&&p===f.CharCode.Slash||a&&p===f.CharCode.OpenSquareBracket||a&&p===f.CharCode.CloseSquareBracket||a&&p===f.CharCode.Colon)S!==-1&&(o+=encodeURIComponent(h.substring(S,L)),S=-1),o!==void 0&&(o+=h.charAt(L));else{o===void 0&&(o=h.substr(0,L));const z=v[p];z!==void 0?(S!==-1&&(o+=encodeURIComponent(h.substring(S,L)),S=-1),o+=z):S===-1&&(S=L)}}return S!==-1&&(o+=encodeURIComponent(h.substring(S))),o!==void 0?o:h}function w(h){let m;for(let a=0;a<h.length;a++){const o=h.charCodeAt(a);o===f.CharCode.Hash||o===f.CharCode.QuestionMark?(m===void 0&&(m=h.substr(0,a)),m+=v[o]):m!==void 0&&(m+=h[a])}return m!==void 0?m:h}function n(h,m){let a;return h.authority&&h.path.length>1&&h.scheme==="file"?a=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===f.CharCode.Slash&&(h.path.charCodeAt(1)>=f.CharCode.A&&h.path.charCodeAt(1)<=f.CharCode.Z||h.path.charCodeAt(1)>=f.CharCode.a&&h.path.charCodeAt(1)<=f.CharCode.z)&&h.path.charCodeAt(2)===f.CharCode.Colon?m?a=h.path.substr(1):a=h.path[1].toLowerCase()+h.path.substr(2):a=h.path,U.isWindows&&(a=a.replace(/\//g,"\\")),a}function i(h,m){const a=m?w:k;let o="",{scheme:S,authority:L,path:p,query:z,fragment:x}=h;if(S&&(o+=S,o+=":"),(L||S==="file")&&(o+=C,o+=C),L){let J=L.indexOf("@");if(J!==-1){const j=L.substr(0,J);L=L.substr(J+1),J=j.lastIndexOf(":"),J===-1?o+=a(j,!1,!1):(o+=a(j.substr(0,J),!1,!1),o+=":",o+=a(j.substr(J+1),!1,!0)),o+="@"}L=L.toLowerCase(),J=L.lastIndexOf(":"),J===-1?o+=a(L,!1,!0):(o+=a(L.substr(0,J),!1,!0),o+=L.substr(J))}if(p){if(p.length>=3&&p.charCodeAt(0)===f.CharCode.Slash&&p.charCodeAt(2)===f.CharCode.Colon){const J=p.charCodeAt(1);J>=f.CharCode.A&&J<=f.CharCode.Z&&(p=`/${String.fromCharCode(J+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===f.CharCode.Colon){const J=p.charCodeAt(0);J>=f.CharCode.A&&J<=f.CharCode.Z&&(p=`${String.fromCharCode(J+32)}:${p.substr(2)}`)}o+=a(p,!0,!1)}return z&&(o+="?",o+=a(z,!1,!1)),x&&(o+="#",o+=m?x:k(x,!1,!1)),o}function s(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+s(h.substr(3)):h}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(h){return h.match(g)?h.replace(g,m=>s(m)):h}}),define(pe[18],be([0,1,10,2,4,6,3]),function(oe,e,f,t,I,U,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=R,e.matchesSomeScheme=D,e.getServerRootPath=$,f=Ue(f),t=Ue(t),Y=Ue(Y);var O;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(O||(e.Schemas=O={}));function R(c,r){return U.URI.isUri(c)?(0,I.equalsIgnoreCase)(c.scheme,r):(0,I.startsWithIgnoreCase)(c,r+":")}function D(c,...r){return r.some(u=>R(c,u))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class q{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r,u){this._serverRootPath=$(r,u)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return Y.posix.join(this._serverRootPath,O.vscodeRemoteResource)}set(r,u,_){this._hosts[r]=u,this._ports[r]=_}setConnectionToken(r,u){this._connectionTokens[r]=u}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(w){return f.onUnexpectedError(w),r}const u=r.authority;let _=this._hosts[u];_&&_.indexOf(":")!==-1&&_.indexOf("[")===-1&&(_=`[${_}]`);const A=this._ports[u],v=this._connectionTokens[u];let k=`path=${encodeURIComponent(r.path)}`;return typeof v=="string"&&(k+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),U.URI.from({scheme:t.isWeb?this._preferredWebSchema:O.vscodeRemoteResource,authority:`${_}:${A}`,path:this._remoteResourcesPath,query:k})}}e.RemoteAuthorities=new q;function $(c,r){return Y.posix.join(r??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class T{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(r){const u=this.toUri(r,oe);return this.uriToBrowserUri(u)}uriToBrowserUri(r){return r.scheme===O.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===O.file&&(t.isNative||t.webWorkerOrigin===`${O.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?r.with({scheme:O.vscodeFileResource,authority:r.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const u=this.toUri(r,oe);return this.uriToFileUri(u)}uriToFileUri(r){return r.scheme===O.vscodeFileResource?r.with({scheme:O.file,authority:r.authority!==T.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,u){return U.URI.isUri(r)?r:U.URI.parse(u.toUrl(r))}}e.FileAccess=new T;var C;(function(c){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(r.get("3"));const u="vscode-coi";function _(v){let k;typeof v=="string"?k=new URL(v).searchParams:v instanceof URL?k=v.searchParams:U.URI.isUri(v)&&(k=new URL(v.toString(!0)).searchParams);const w=k?.get(u);if(w)return r.get(w)}c.getHeadersFromQuery=_;function A(v,k,w){if(!globalThis.crossOriginIsolated)return;const n=k&&w?"3":w?"2":"1";v instanceof URLSearchParams?v.set(u,n):v[u]=n}c.addSearchParam=A})(C||(e.COI=C={}))}),define(pe[19],be([0,1,7,5,18,3,2,4,6]),function(oe,e,f,t,I,U,Y,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=D,e.distinctParents=$,e.toLocalResource=C,t=Ue(t),U=Ue(U);function D(c){return(0,R.uriToFsPath)(c,!0)}class q{constructor(r){this._ignorePathCasing=r}compare(r,u,_=!1){return r===u?0:(0,O.compare)(this.getComparisonKey(r,_),this.getComparisonKey(u,_))}isEqual(r,u,_=!1){return r===u?!0:!r||!u?!1:this.getComparisonKey(r,_)===this.getComparisonKey(u,_)}getComparisonKey(r,u=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,u,_=!1){if(r.scheme===u.scheme){if(r.scheme===I.Schemas.file)return t.isEqualOrParent(D(r),D(u),this._ignorePathCasing(r))&&r.query===u.query&&(_||r.fragment===u.fragment);if((0,e.isEqualAuthority)(r.authority,u.authority))return t.isEqualOrParent(r.path,u.path,this._ignorePathCasing(r),"/")&&r.query===u.query&&(_||r.fragment===u.fragment)}return!1}joinPath(r,...u){return R.URI.joinPath(r,...u)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return U.posix.basename(r.path)}extname(r){return U.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let u;return r.scheme===I.Schemas.file?u=R.URI.file(U.dirname(D(r))).path:(u=U.posix.dirname(r.path),r.authority&&u.length&&u.charCodeAt(0)!==f.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),u="/")),r.with({path:u})}normalizePath(r){if(!r.path.length)return r;let u;return r.scheme===I.Schemas.file?u=R.URI.file(U.normalize(D(r))).path:u=U.posix.normalize(r.path),r.with({path:u})}relativePath(r,u){if(r.scheme!==u.scheme||!(0,e.isEqualAuthority)(r.authority,u.authority))return;if(r.scheme===I.Schemas.file){const v=U.relative(D(r),D(u));return Y.isWindows?t.toSlashes(v):v}let _=r.path||"/";const A=u.path||"/";if(this._ignorePathCasing(r)){let v=0;for(const k=Math.min(_.length,A.length);v<k&&!(_.charCodeAt(v)!==A.charCodeAt(v)&&_.charAt(v).toLowerCase()!==A.charAt(v).toLowerCase());v++);_=A.substr(0,v)+_.substr(v)}return U.posix.relative(_,A)}resolvePath(r,u){if(r.scheme===I.Schemas.file){const _=R.URI.file(U.resolve(D(r),u));return r.with({authority:_.authority,path:_.path})}return u=t.toPosixPath(u),r.with({path:U.posix.resolve(r.path,u)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,u){return r===u||r!==void 0&&u!==void 0&&(0,O.equalsIgnoreCase)(r,u)}hasTrailingPathSeparator(r,u=U.sep){if(r.scheme===I.Schemas.file){const _=D(r);return _.length>t.getRoot(_).length&&_[_.length-1]===u}else{const _=r.path;return _.length>1&&_.charCodeAt(_.length-1)===f.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,u=U.sep){return(0,e.hasTrailingPathSeparator)(r,u)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,u=U.sep){let _=!1;if(r.scheme===I.Schemas.file){const A=D(r);_=A!==void 0&&A.length===t.getRoot(A).length&&A[A.length-1]===u}else{u="/";const A=r.path;_=A.length===1&&A.charCodeAt(A.length-1)===f.CharCode.Slash}return!_&&!(0,e.hasTrailingPathSeparator)(r,u)?r.with({path:r.path+"/"}):r}}e.ExtUri=q,e.extUri=new q(()=>!1),e.extUriBiasedIgnorePathCase=new q(c=>c.scheme===I.Schemas.file?!Y.isLinux:!0),e.extUriIgnorePathCase=new q(c=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function $(c,r){const u=[];for(let _=0;_<c.length;_++){const A=r(c[_]);c.some((v,k)=>k===_?!1:(0,e.isEqualOrParent)(A,r(v)))||u.push(c[_])}return u}var T;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function r(u){const _=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(k=>{const[w,n]=k.split(":");w&&n&&_.set(w,n)});const v=u.path.substring(0,u.path.indexOf(";"));return v&&_.set(c.META_DATA_MIME,v),_}c.parseMetaData=r})(T||(e.DataUri=T={}));function C(c,r,u){if(r){let _=c.path;return _&&_[0]!==U.posix.sep&&(_=U.posix.sep+_),c.with({scheme:u,authority:r,path:_})}return c.with({scheme:u})}}),define(pe[8],be([0,1,12,10,17,11,19,2,37,14]),function(oe,e,f,t,I,U,Y,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=q,e.createCancelablePromise=$,e.raceCancellation=T,e.raceCancellationError=C,e.raceCancellablePromises=c,e.raceTimeout=r,e.asPromise=u,e.promiseWithResolvers=_,e.timeout=h,e.disposableTimeout=m,e.sequence=a,e.first=o,e.firstParallel=S,e.retry=G,e.createCancelableAsyncIterable=F;function q(E){return!!E&&typeof E.then=="function"}function $(E){const l=new f.CancellationTokenSource,y=E(l.token),V=new Promise((X,_e)=>{const ve=l.token.onCancellationRequested(()=>{ve.dispose(),_e(new t.CancellationError)});Promise.resolve(y).then(De=>{ve.dispose(),l.dispose(),X(De)},De=>{ve.dispose(),l.dispose(),_e(De)})});return new class{cancel(){l.cancel(),l.dispose()}then(X,_e){return V.then(X,_e)}catch(X){return this.then(void 0,X)}finally(X){return V.finally(X)}}}function T(E,l,y){return new Promise((V,X)=>{const _e=l.onCancellationRequested(()=>{_e.dispose(),V(y)});E.then(V,X).finally(()=>_e.dispose())})}function C(E,l){return new Promise((y,V)=>{const X=l.onCancellationRequested(()=>{X.dispose(),V(new t.CancellationError)});E.then(y,V).finally(()=>X.dispose())})}async function c(E){let l=-1;const y=E.map((V,X)=>V.then(_e=>(l=X,_e)));try{return await Promise.race(y)}finally{E.forEach((V,X)=>{X!==l&&V.cancel()})}}function r(E,l,y){let V;const X=setTimeout(()=>{V?.(void 0),y?.()},l);return Promise.race([E.finally(()=>clearTimeout(X)),new Promise(_e=>V=_e)])}function u(E){return new Promise((l,y)=>{const V=E();q(V)?V.then(l,y):l(V)})}function _(){let E,l;return{promise:new Promise((V,X)=>{E=V,l=X}),resolve:E,reject:l}}class A{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(l){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=l,!this.queuedPromise){const y=()=>{if(this.queuedPromise=null,this.isDisposed)return;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(y,y).then(V)})}return new Promise((y,V)=>{this.queuedPromise.then(y,V)})}return this.activePromise=l(),new Promise((y,V)=>{this.activePromise.then(X=>{this.activePromise=null,y(X)},X=>{this.activePromise=null,V(X)})})}dispose(){this.isDisposed=!0}}e.Throttler=A;class v{constructor(){this.current=Promise.resolve(null)}queue(l){return this.current=this.current.then(()=>l(),()=>l())}}e.Sequencer=v;class k{constructor(){this.promiseMap=new Map}queue(l,y){const X=(this.promiseMap.get(l)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.promiseMap.get(l)===X&&this.promiseMap.delete(l)});return this.promiseMap.set(l,X),X}}e.SequencerByKey=k;const w=(E,l)=>{let y=!0;const V=setTimeout(()=>{y=!1,l()},E);return{isTriggered:()=>y,dispose:()=>{clearTimeout(V),y=!1}}},n=E=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,E())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class i{constructor(l){this.defaultDelay=l,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(l,y=this.defaultDelay){this.task=l,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((X,_e)=>{this.doResolve=X,this.doReject=_e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const X=this.task;return this.task=null,X()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=y===R.MicrotaskDelay?n(V):w(y,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class s{constructor(l){this.delayer=new i(l),this.throttler=new A}trigger(l,y){return this.delayer.trigger(()=>this.throttler.queue(l),y)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=s;class g{constructor(){this._isOpen=!1,this._promise=new Promise((l,y)=>{this._completePromise=l})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class N extends g{constructor(l){super(),this._timeout=setTimeout(()=>this.open(),l)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=N;function h(E,l){return l?new Promise((y,V)=>{const X=setTimeout(()=>{_e.dispose(),y()},E),_e=l.onCancellationRequested(()=>{clearTimeout(X),_e.dispose(),V(new t.CancellationError)})}):$(y=>h(E,y))}function m(E,l=0,y){const V=setTimeout(()=>{E(),y&&X.dispose()},l),X=(0,U.toDisposable)(()=>{clearTimeout(V),y?.deleteAndLeak(X)});return y?.add(X),X}function a(E){const l=[];let y=0;const V=E.length;function X(){return y<V?E[y++]():null}function _e(ve){ve!=null&&l.push(ve);const De=X();return De?De.then(_e):Promise.resolve(l)}return Promise.resolve(null).then(_e)}function o(E,l=V=>!!V,y=null){let V=0;const X=E.length,_e=()=>{if(V>=X)return Promise.resolve(y);const ve=E[V++];return Promise.resolve(ve()).then(ce=>l(ce)?Promise.resolve(ce):_e())};return _e()}function S(E,l=V=>!!V,y=null){if(E.length===0)return Promise.resolve(y);let V=E.length;const X=()=>{V=-1;for(const _e of E)_e.cancel?.()};return new Promise((_e,ve)=>{for(const De of E)De.then(ce=>{--V>=0&&l(ce)?(X(),_e(ce)):V===0&&_e(y)}).catch(ce=>{--V>=0&&(X(),ve(ce))})})}class L{constructor(l){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=l,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(l){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((y,V)=>{this.outstandingPromises.push({factory:l,c:y,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const l=this.outstandingPromises.shift();this.runningPromises++;const y=l.factory();y.then(l.c,l.e),y.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=L;class p extends L{constructor(){super(1)}}e.Queue=p;class z{constructor(){this.sequentializer=new H,this.tasks=0}queue(l){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,l())):this.sequentializer.run(this.tasks++,l())}}e.LimitedQueue=z;class x{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const l=new b;return this.drainers.add(l),l.p}isDrained(){for(const[,l]of this.queues)if(l.size>0)return!1;return!0}queueSize(l,y=Y.extUri){const V=y.getComparisonKey(l);return this.queues.get(V)?.size??0}queueFor(l,y,V=Y.extUri){const X=V.getComparisonKey(l);let _e=this.queues.get(X);if(!_e){_e=new p;const ve=this.drainListenerCount++,De=I.Event.once(_e.onDrained)(()=>{_e?.dispose(),this.queues.delete(X),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ve),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new U.DisposableMap),this.drainListeners.set(ve,De),this.queues.set(X,_e)}return _e.queue(y)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const l of this.drainers)l.complete();this.drainers.clear()}dispose(){for(const[,l]of this.queues)l.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=x;class J{constructor(l,y){this._isDisposed=!1,this._token=-1,typeof l=="function"&&typeof y=="number"&&this.setIfNotSet(l,y)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(l,y){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,l()},y)}setIfNotSet(l,y){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,l()},y))}}e.TimeoutTimer=J;class j{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(l,y,V=globalThis){if(this.isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const X=V.setInterval(()=>{l()},y);this.disposable=(0,U.toDisposable)(()=>{V.clearInterval(X),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=j;class le{constructor(l,y){this.timeoutToken=-1,this.runner=l,this.timeout=y,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(l=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,l)}get delay(){return this.timeout}set delay(l){this.timeout=l}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=le;class M{constructor(l,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.runner=l,this.timeout=y,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(l=this.timeout){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(l/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=M;class K extends le{constructor(l,y){super(l,y),this.units=[]}work(l){this.units.push(l),this.isScheduled()||this.schedule()}doRun(){const l=this.units;this.units=[],this.runner?.(l)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=K;class Z extends U.Disposable{constructor(l,y){super(),this.options=l,this.handler=y,this.pendingWork=[],this.throttler=this._register(new U.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(l){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+l.length>this.options.maxBufferedWork)return!1}else if(this.pending+l.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const y of l)this.pendingWork.push(y);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new le(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(E,l)=>{(0,O.setTimeout0)(()=>{if(y)return;const V=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let y=!1;return{dispose(){y||(y=!0)}}}:e._runWhenIdle=(E,l,y)=>{const V=E.requestIdleCallback(l,typeof y=="number"?{timeout:y}:void 0);let X=!1;return{dispose(){X||(X=!0,E.cancelIdleCallback(V))}}},e.runWhenGlobalIdle=E=>(0,e._runWhenIdle)(globalThis,E)}();class ee{constructor(l,y){this._didRun=!1,this._executor=()=>{try{this._value=y()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(l,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ee;class W extends ee{constructor(l){super(globalThis,l)}}e.GlobalIdleValue=W;async function G(E,l,y){let V;for(let X=0;X<y;X++)try{return await E()}catch(_e){V=_e,await h(l)}throw V}class H{isRunning(l){return typeof l=="number"?this._running?.taskId===l:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(l,y,V){return this._running={taskId:l,cancel:()=>V?.(),promise:y},y.then(()=>this.doneRunning(l),()=>this.doneRunning(l)),y}doneRunning(l){this._running&&l===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const l=this._queued;this._queued=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this._queued)this._queued.run=l;else{const{promise:y,resolve:V,reject:X}=_();this._queued={run:l,promise:y,promiseResolve:V,promiseReject:X}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=H;class te{constructor(l,y=()=>Date.now()){this.interval=l,this.nowFn=y,this.lastIncrementTime=0,this.value=0}increment(){const l=this.nowFn();return l-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=l,this.value=0),this.value++,this.value}}e.IntervalCounter=te;var ue;(function(E){E[E.Resolved=0]="Resolved",E[E.Rejected=1]="Rejected"})(ue||(ue={}));class b{get isRejected(){return this.outcome?.outcome===ue.Rejected}get isResolved(){return this.outcome?.outcome===ue.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ue.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((l,y)=>{this.completeCallback=l,this.errorCallback=y})}complete(l){return new Promise(y=>{this.completeCallback(l),this.outcome={outcome:ue.Resolved,value:l},y()})}error(l){return new Promise(y=>{this.errorCallback(l),this.outcome={outcome:ue.Rejected,value:l},y()})}cancel(){return this.error(new t.CancellationError)}}e.DeferredPromise=b;var ie;(function(E){async function l(V){let X;const _e=await Promise.all(V.map(ve=>ve.then(De=>De,De=>{X||(X=De)})));if(typeof X<"u")throw X;return _e}E.settled=l;function y(V){return new Promise(async(X,_e)=>{try{await V(X,_e)}catch(ve){_e(ve)}})}E.withAsyncBody=y})(ie||(e.Promises=ie={}));class se{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(l){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=l.then(y=>(this._value=y,this._isResolved=!0,y),y=>{throw this._error=y,this._isResolved=!0,y})}requireValue(){if(!this._isResolved)throw new t.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=se;class re{constructor(l){this._compute=l,this._promise=new D.Lazy(()=>new se(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=re;var fe;(function(E){E[E.Initial=0]="Initial",E[E.DoneOK=1]="DoneOK",E[E.DoneError=2]="DoneError"})(fe||(fe={}));class de{static fromArray(l){return new de(y=>{y.emitMany(l)})}static fromPromise(l){return new de(async y=>{y.emitMany(await l)})}static fromPromises(l){return new de(async y=>{await Promise.all(l.map(async V=>y.emitOne(await V)))})}static merge(l){return new de(async y=>{await Promise.all(l.map(async V=>{for await(const X of V)y.emitOne(X)}))})}static{this.EMPTY=de.fromArray([])}constructor(l,y){this._state=fe.Initial,this._results=[],this._error=null,this._onReturn=y,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const V={emitOne:X=>this.emitOne(X),emitMany:X=>this.emitMany(X),reject:X=>this.reject(X)};try{await Promise.resolve(l(V)),this.resolve()}catch(X){this.reject(X)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this._state===fe.DoneError)throw this._error;if(l<this._results.length)return{done:!1,value:this._results[l++]};if(this._state===fe.DoneOK)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(l,y){return new de(async V=>{for await(const X of l)V.emitOne(y(X))})}map(l){return de.map(this,l)}static filter(l,y){return new de(async V=>{for await(const X of l)y(X)&&V.emitOne(X)})}filter(l){return de.filter(this,l)}static coalesce(l){return de.filter(l,y=>!!y)}coalesce(){return de.coalesce(this)}static async toPromise(l){const y=[];for await(const V of l)y.push(V);return y}toPromise(){return de.toPromise(this)}emitOne(l){this._state===fe.Initial&&(this._results.push(l),this._onStateChanged.fire())}emitMany(l){this._state===fe.Initial&&(this._results=this._results.concat(l),this._onStateChanged.fire())}resolve(){this._state===fe.Initial&&(this._state=fe.DoneOK,this._onStateChanged.fire())}reject(l){this._state===fe.Initial&&(this._state=fe.DoneError,this._error=l,this._onStateChanged.fire())}}e.AsyncIterableObject=de;class Le extends de{constructor(l,y){super(y),this._source=l}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Le;function F(E){const l=new f.CancellationTokenSource,y=E(l.token);return new Le(l,async V=>{const X=l.token.onCancellationRequested(()=>{X.dispose(),l.dispose(),V.reject(new t.CancellationError)});try{for await(const _e of y){if(l.token.isCancellationRequested)return;V.emitOne(_e)}X.dispose(),l.dispose()}catch(_e){X.dispose(),l.dispose(),V.reject(_e)}})}class B{constructor(l){this._deferred=new b,this._asyncIterable=new de(X=>{if(y){X.reject(y);return}return V&&X.emitMany(V),this._errorFn=_e=>X.reject(_e),this._emitFn=_e=>X.emitOne(_e),this._deferred.p},l);let y,V;this._emitFn=X=>{V||(V=[]),V.push(X)},this._errorFn=X=>{y||(y=X)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(l){this._errorFn(l),this._deferred.complete()}emitOne(l){this._emitFn(l)}}e.AsyncIterableSource=B}),define(pe[40],be([0,1,13,8,7,5,15,3,2,4]),function(oe,e,f,t,I,U,Y,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=q,e.splitGlobAware=r,e.match=z,e.parse=x,e.isRelativePattern=J,e.getBasenameTerms=j,e.getPathTerms=le,e.patternsEquals=ee;function q(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const $="[/\\\\]",T="[^/\\\\]",C=/\//g;function c(W,G){switch(W){case 0:return"";case 1:return`${T}*?`;default:return`(?:${$}|${T}+${$}${G?`|${$}${T}+`:""})*?`}}function r(W,G){if(!W)return[];const H=[];let te=!1,ue=!1,b="";for(const ie of W){switch(ie){case G:if(!te&&!ue){H.push(b),b="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}b+=ie}return b&&H.push(b),H}function u(W){if(!W)return"";let G="";const H=r(W,e.GLOB_SPLIT);if(H.every(te=>te===e.GLOBSTAR))G=".*";else{let te=!1;H.forEach((ue,b)=>{if(ue===e.GLOBSTAR){if(te)return;G+=c(2,b===H.length-1)}else{let ie=!1,se="",re=!1,fe="";for(const de of ue){if(de!=="}"&&ie){se+=de;continue}if(re&&(de!=="]"||!fe)){let Le;de==="-"?Le=de:(de==="^"||de==="!")&&!fe?Le="^":de===e.GLOB_SPLIT?Le="":Le=(0,D.escapeRegExpCharacters)(de),fe+=Le;continue}switch(de){case"{":ie=!0;continue;case"[":re=!0;continue;case"}":{const F=`(?:${r(se,",").map(B=>u(B)).join("|")})`;G+=F,ie=!1,se="";break}case"]":{G+="["+fe+"]",re=!1,fe="";break}case"?":G+=T;continue;case"*":G+=c(1);continue;default:G+=(0,D.escapeRegExpCharacters)(de)}}b<H.length-1&&(H[b+1]!==e.GLOBSTAR||b+2<H.length)&&(G+=$)}te=ue===e.GLOBSTAR})}return G}const _=/^\*\*\/\*\.[\w\.-]+$/,A=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new Y.LRUCache(1e4),s=function(){return!1},g=function(){return null};function N(W,G){if(!W)return g;let H;typeof W!="string"?H=W.pattern:H=W,H=H.trim();const te=`${H}_${!!G.trimForExclusions}`;let ue=i.get(te);if(ue)return h(ue,W);let b;return _.test(H)?ue=a(H.substr(4),H):(b=A.exec(m(H,G)))?ue=o(b[1],H):(G.trimForExclusions?k:v).test(H)?ue=S(H,G):(b=w.exec(m(H,G)))?ue=L(b[1].substr(1),H,!0):(b=n.exec(m(H,G)))?ue=L(b[1],H,!1):ue=p(H),i.set(te,ue),h(ue,W)}function h(W,G){if(typeof G=="string")return W;const H=function(te,ue){return(0,U.isEqualOrParent)(te,G.base,!R.isLinux)?W((0,D.ltrim)(te.substr(G.base.length),O.sep),ue):null};return H.allBasenames=W.allBasenames,H.allPaths=W.allPaths,H.basenames=W.basenames,H.patterns=W.patterns,H}function m(W,G){return G.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function a(W,G){return function(H,te){return typeof H=="string"&&H.endsWith(W)?G:null}}function o(W,G){const H=`/${W}`,te=`\\${W}`,ue=function(ie,se){return typeof ie!="string"?null:se?se===W?G:null:ie===W||ie.endsWith(H)||ie.endsWith(te)?G:null},b=[W];return ue.basenames=b,ue.patterns=[G],ue.allBasenames=b,ue}function S(W,G){const H=Z(W.slice(1,-1).split(",").map(se=>N(se,G)).filter(se=>se!==g),W),te=H.length;if(!te)return g;if(te===1)return H[0];const ue=function(se,re){for(let fe=0,de=H.length;fe<de;fe++)if(H[fe](se,re))return W;return null},b=H.find(se=>!!se.allBasenames);b&&(ue.allBasenames=b.allBasenames);const ie=H.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ie.length&&(ue.allPaths=ie),ue}function L(W,G,H){const te=O.sep===O.posix.sep,ue=te?W:W.replace(C,O.sep),b=O.sep+ue,ie=O.posix.sep+W;let se;return H?se=function(re,fe){return typeof re=="string"&&(re===ue||re.endsWith(b)||!te&&(re===W||re.endsWith(ie)))?G:null}:se=function(re,fe){return typeof re=="string"&&(re===ue||!te&&re===W)?G:null},se.allPaths=[(H?"*/":"./")+W],se}function p(W){try{const G=new RegExp(`^${u(W)}$`);return function(H){return G.lastIndex=0,typeof H=="string"&&G.test(H)?W:null}}catch{return g}}function z(W,G,H){return!W||typeof G!="string"?!1:x(W)(G,void 0,H)}function x(W,G={}){if(!W)return s;if(typeof W=="string"||J(W)){const H=N(W,G);if(H===g)return s;const te=function(ue,b){return!!H(ue,b)};return H.allBasenames&&(te.allBasenames=H.allBasenames),H.allPaths&&(te.allPaths=H.allPaths),te}return M(W,G)}function J(W){const G=W;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}function j(W){return W.allBasenames||[]}function le(W){return W.allPaths||[]}function M(W,G){const H=Z(Object.getOwnPropertyNames(W).map(se=>K(se,W[se],G)).filter(se=>se!==g)),te=H.length;if(!te)return g;if(!H.some(se=>!!se.requiresSiblings)){if(te===1)return H[0];const se=function(de,Le){let F;for(let B=0,E=H.length;B<E;B++){const l=H[B](de,Le);if(typeof l=="string")return l;(0,t.isThenable)(l)&&(F||(F=[]),F.push(l))}return F?(async()=>{for(const B of F){const E=await B;if(typeof E=="string")return E}return null})():null},re=H.find(de=>!!de.allBasenames);re&&(se.allBasenames=re.allBasenames);const fe=H.reduce((de,Le)=>Le.allPaths?de.concat(Le.allPaths):de,[]);return fe.length&&(se.allPaths=fe),se}const ue=function(se,re,fe){let de,Le;for(let F=0,B=H.length;F<B;F++){const E=H[F];E.requiresSiblings&&fe&&(re||(re=(0,O.basename)(se)),de||(de=re.substr(0,re.length-(0,O.extname)(se).length)));const l=E(se,re,de,fe);if(typeof l=="string")return l;(0,t.isThenable)(l)&&(Le||(Le=[]),Le.push(l))}return Le?(async()=>{for(const F of Le){const B=await F;if(typeof B=="string")return B}return null})():null},b=H.find(se=>!!se.allBasenames);b&&(ue.allBasenames=b.allBasenames);const ie=H.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ie.length&&(ue.allPaths=ie),ue}function K(W,G,H){if(G===!1)return g;const te=N(W,H);if(te===g)return g;if(typeof G=="boolean")return te;if(G){const ue=G.when;if(typeof ue=="string"){const b=(ie,se,re,fe)=>{if(!fe||!te(ie,se))return null;const de=ue.replace("$(basename)",()=>re),Le=fe(de);return(0,t.isThenable)(Le)?Le.then(F=>F?W:null):Le?W:null};return b.requiresSiblings=!0,b}}return te}function Z(W,G){const H=W.filter(se=>!!se.basenames);if(H.length<2)return W;const te=H.reduce((se,re)=>{const fe=re.basenames;return fe?se.concat(fe):se},[]);let ue;if(G){ue=[];for(let se=0,re=te.length;se<re;se++)ue.push(G)}else ue=H.reduce((se,re)=>{const fe=re.patterns;return fe?se.concat(fe):se},[]);const b=function(se,re){if(typeof se!="string")return null;if(!re){let de;for(de=se.length;de>0;de--){const Le=se.charCodeAt(de-1);if(Le===I.CharCode.Slash||Le===I.CharCode.Backslash)break}re=se.substr(de)}const fe=te.indexOf(re);return fe!==-1?ue[fe]:null};b.basenames=te,b.patterns=ue,b.allBasenames=te;const ie=W.filter(se=>!se.basenames);return ie.push(b),ie}function ee(W,G){return(0,f.equals)(W,G,(H,te)=>typeof H=="string"&&typeof te=="string"?H===te:typeof H!="string"&&typeof te!="string"?H.base===te.base&&H.pattern===te.pattern:!1)}}),define(pe[20],be([0,1,9,21,52,8,5,24,3,2,19,6]),function(oe,e,f,t,I,U,Y,O,R,D,q,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=u,e.readdirSync=v,e.whenDeleted=n,e.configureFlushOnWrite=h,e.writeFileSync=a,f=Ue(f);var T;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(T||(e.RimRafMode=T={}));async function C(M,K=T.UNLINK,Z){if((0,Y.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return K===T.UNLINK?r(M):c(M,Z)}async function c(M,K=(0,Y.randomPath)((0,t.tmpdir)())){try{try{await f.promises.rename(M,K)}catch(Z){return Z.code==="ENOENT"?void 0:r(M)}r(K).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function r(M){return f.promises.rm(M,{recursive:!0,force:!0,maxRetries:3})}function u(M){if((0,Y.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");f.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function _(M,K){return k(await(K?A(M):f.promises.readdir(M)))}async function A(M){try{return await f.promises.readdir(M,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const K=[],Z=await _(M);for(const ee of Z){let W=!1,G=!1,H=!1;try{const te=await f.promises.lstat((0,R.join)(M,ee));W=te.isFile(),G=te.isDirectory(),H=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}K.push({name:ee,isFile:()=>W,isDirectory:()=>G,isSymbolicLink:()=>H})}return K}function v(M){return k(f.readdirSync(M))}function k(M){return M.map(K=>typeof K=="string"?D.isMacintosh?(0,O.normalizeNFC)(K):K:(K.name=D.isMacintosh?(0,O.normalizeNFC)(K.name):K.name,K))}async function w(M){const K=await _(M),Z=[];for(const ee of K)await i.existsDirectory((0,R.join)(M,ee))&&Z.push(ee);return Z}function n(M,K=1e3){return new Promise(Z=>{let ee=!1;const W=setInterval(()=>{ee||(ee=!0,f.access(M,G=>{ee=!1,G&&(clearInterval(W),Z(void 0))}))},K)})}var i;(function(M){async function K(W){let G;try{if(G=await f.promises.lstat(W),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await f.promises.stat(W),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(D.isWindows&&H.code==="EACCES")try{return{stat:await f.promises.stat(await f.promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw te}throw H}}M.stat=K;async function Z(W){try{const{stat:G,symbolicLink:H}=await M.stat(W);return G.isFile()&&H?.dangling!==!0}catch{}return!1}M.existsFile=Z;async function ee(W){try{const{stat:G,symbolicLink:H}=await M.stat(W);return G.isDirectory()&&H?.dangling!==!0}catch{}return!1}M.existsDirectory=ee})(i||(e.SymlinkSupport=i={}));const s=new U.ResourceQueue;function g(M,K,Z){return s.queueFor($.URI.file(M),()=>{const ee=o(Z);return new Promise((W,G)=>m(M,K,ee,H=>H?G(H):W()))},q.extUriBiasedIgnorePathCase)}let N=!0;function h(M){N=M}function m(M,K,Z,ee){if(!N)return f.writeFile(M,K,{mode:Z.mode,flag:Z.flag},ee);f.open(M,Z.flag,Z.mode,(W,G)=>{if(W)return ee(W);f.writeFile(G,K,H=>{if(H)return f.close(G,()=>ee(H));f.fdatasync(G,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),h(!1)),f.close(G,ue=>ee(ue))))})})}function a(M,K,Z){const ee=o(Z);if(!N)return f.writeFileSync(M,K,{mode:ee.mode,flag:ee.flag});const W=f.openSync(M,ee.flag,ee.mode);try{f.writeFileSync(W,K);try{f.fdatasyncSync(W)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),h(!1)}}finally{f.closeSync(W)}}function o(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function S(M,K,Z=6e4){if(M!==K)try{D.isWindows&&typeof Z=="number"?await L(M,K,Date.now(),Z):await f.promises.rename(M,K)}catch(ee){if(M.toLowerCase()!==K.toLowerCase()&&ee.code==="EXDEV"||M.endsWith("."))await p(M,K,{preserveSymlinks:!1}),await C(M,T.MOVE);else throw ee}}async function L(M,K,Z,ee,W=0){try{return await f.promises.rename(M,K)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-Z>=ee)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${G}`),G;if(W===0){let H=!1;try{const{stat:te}=await i.stat(K);te.isFile()||(H=!0)}catch{}if(H)throw G}return await(0,U.timeout)(Math.min(100,W*10)),L(M,K,Z,ee,W+1)}}async function p(M,K,Z){return x(M,K,{root:{source:M,target:K},options:Z,handledSourcePaths:new Set})}const z=511;async function x(M,K,Z){if(Z.handledSourcePaths.has(M))return;Z.handledSourcePaths.add(M);const{stat:ee,symbolicLink:W}=await i.stat(M);if(W){if(Z.options.preserveSymlinks)try{return await le(M,K,Z)}catch{}if(W.dangling)return}return ee.isDirectory()?J(M,K,ee.mode&z,Z):j(M,K,ee.mode&z)}async function J(M,K,Z,ee){await f.promises.mkdir(K,{recursive:!0,mode:Z});const W=await _(M);for(const G of W)await x((0,R.join)(M,G),(0,R.join)(K,G),ee)}async function j(M,K,Z){await f.promises.copyFile(M,K),await f.promises.chmod(K,Z)}async function le(M,K,Z){let ee=await f.promises.readlink(M);(0,Y.isEqualOrParent)(ee,Z.root.source,!D.isLinux)&&(ee=(0,R.join)(Z.root.target,ee.substr(Z.root.source.length+1))),await f.promises.symlink(ee,K)}e.Promises=new class{get read(){return(M,K,Z,ee,W)=>new Promise((G,H)=>{f.read(M,K,Z,ee,W,(te,ue,b)=>te?H(te):G({bytesRead:ue,buffer:b}))})}get write(){return(M,K,Z,ee,W)=>new Promise((G,H)=>{f.write(M,K,Z,ee,W,(te,ue,b)=>te?H(te):G({bytesWritten:ue,buffer:b}))})}get fdatasync(){return(0,I.promisify)(f.fdatasync)}get open(){return(0,I.promisify)(f.open)}get close(){return(0,I.promisify)(f.close)}get realpath(){return(0,I.promisify)(f.realpath)}async exists(M){try{return await f.promises.access(M),!0}catch{return!1}}get readdir(){return _}get readDirsInDir(){return w}get writeFile(){return g}get rm(){return C}get rename(){return S}get copy(){return p}}}),define(pe[41],be([0,1,9,3,2,4,20]),function(oe,e,f,t,I,U,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=O,e.realcase=R,e.realpath=D,e.realpathSync=q,f=Ue(f);function O(T){if(I.isLinux)return T;const C=(0,t.dirname)(T);if(T===C)return T;const c=((0,t.basename)(T)||T).toLowerCase();try{const u=(0,Y.readdirSync)(C).filter(_=>_.toLowerCase()===c);if(u.length===1){const _=O(C);if(_)return(0,t.join)(_,u[0])}else if(u.length>1){const _=u.indexOf(c);if(_>=0){const A=O(C);if(A)return(0,t.join)(A,u[_])}}}catch{}return null}async function R(T,C){if(I.isLinux)return T;const c=(0,t.dirname)(T);if(T===c)return T;const r=((0,t.basename)(T)||T).toLowerCase();try{if(C?.isCancellationRequested)return null;const _=(await Y.Promises.readdir(c)).filter(A=>A.toLowerCase()===r);if(_.length===1){const A=await R(c,C);if(A)return(0,t.join)(A,_[0])}else if(_.length>1){const A=_.indexOf(r);if(A>=0){const v=await R(c,C);if(v)return(0,t.join)(v,_[A])}}}catch{}return null}async function D(T){try{return await Y.Promises.realpath(T)}catch{const c=$(T);return await f.promises.access(c,f.constants.R_OK),c}}function q(T){try{return f.realpathSync(T)}catch{const c=$(T);return f.accessSync(c,f.constants.R_OK),c}}function $(T){return(0,U.rtrim)((0,t.normalize)(T),t.sep)}}),define(pe[42],be([0,1,53]),function(oe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=t,e.findFreePortFaster=U,f=Ue(f);function t(O,R,D,q=1){let $=!1;return new Promise(T=>{const C=setTimeout(()=>{if(!$)return $=!0,T(0)},D);I(O,R,q,c=>{if(!$)return $=!0,clearTimeout(C),T(c)})})}function I(O,R,D,q){if(R===0)return q(0);const $=new f.Socket;$.once("connect",()=>(Y($),I(O+D,R-1,D,q))),$.once("data",()=>{}),$.once("error",T=>(Y($),T.code!=="ECONNREFUSED"?I(O+D,R-1,D,q):q(O))),$.connect(O,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function U(O,R,D,q="127.0.0.1"){let $=!1,T,C=1;const c=f.createServer({pauseOnConnect:!0});function r(u,_){$||($=!0,c.removeAllListeners(),c.close(),T&&clearTimeout(T),_(u))}return new Promise(u=>{T=setTimeout(()=>{r(0,u)},D),c.on("listening",()=>{r(O,u)}),c.on("error",_=>{_&&(_.code==="EADDRINUSE"||_.code==="EACCES")&&C<R?(O++,C++,c.listen(O,q)):r(0,u)}),c.on("close",()=>{r(0,u)}),c.listen(O,q)})}function Y(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch(R){console.error(R)}}}),define(pe[43],be([0,1,44,2]),function(oe,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveTerminalEncoding=R;const I={437:"cp437",850:"cp850",852:"cp852",855:"cp855",857:"cp857",860:"cp860",861:"cp861",863:"cp863",865:"cp865",866:"cp866",869:"cp869",936:"cp936",1252:"cp1252"};function U(D){const q=D.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return Y[q]||q}const Y={ibm866:"cp866",big5:"cp950"},O="utf8";async function R(D){let q;const $=process.env.VSCODE_CLI_ENCODING;$?(D&&console.log(`Found VSCODE_CLI_ENCODING variable: ${$}`),q=Promise.resolve($)):t.isWindows?q=new Promise(C=>{D&&console.log('Running "chcp" to detect terminal encoding...'),(0,f.exec)("chcp",(c,r,u)=>{if(r){D&&console.log(`Output from "chcp" command is: ${r}`);const _=Object.keys(I);for(const A of _)if(r.indexOf(A)>=0)return C(I[A])}return C(void 0)})}):q=new Promise(C=>{D&&console.log('Running "locale charmap" to detect terminal encoding...'),(0,f.exec)("locale charmap",(c,r,u)=>C(r))});const T=await q;return D&&console.log(`Detected raw terminal encoding: ${T}`),!T||T.toLowerCase()==="utf-8"||T.toLowerCase()===O?O:U(T)}}),function(){function oe(){function e(){return process.uncHostAllowlist}function f(R){const D=new Set;if(Array.isArray(R))for(const q of R)typeof q=="string"&&D.add(q);return Array.from(D)}function t(){const R=e();return R?Array.from(R):[]}function I(R){if(process.platform!=="win32")return;const D=e();if(D)if(typeof R=="string")D.add(R.toLowerCase());else for(const q of f(R))I(q)}function U(R){if(typeof R!="string")return;const D=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let q;for(const $ of D){if(R.indexOf($)!==0)continue;const C=R.indexOf("\\",$.length);if(C===-1)continue;const c=R.substring($.length,C);if(c){q=c;break}}return q}function Y(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function O(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:t,addUNCHostToAllowlist:I,getUNCHost:U,disableUNCAccessRestrictions:Y,isUNCAccessRestrictionsDisabled:O}}typeof define=="function"?define("vs/base/node/unc",[],function(){return oe()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=oe():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(pe[22],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=I,e.localize2=Y;const f=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function t(O,R){let D;return R.length===0?D=O:D=O.replace(/\{(\d+)\}/g,(q,$)=>{const T=$[0],C=R[T];let c=q;return typeof C=="string"?c=C:(typeof C=="number"||typeof C=="boolean"||C===void 0||C===null)&&(c=String(C)),c}),f&&(D="\uFF3B"+D.replace(/[aouei]/g,"$&$&")+"\uFF3D"),D}function I(O,R,...D){return t(typeof O=="number"?U(O,R):R,D)}function U(O,R){const D=globalThis._VSCODE_NLS_MESSAGES?.[O];if(typeof D!="string"){if(typeof R=="string")return R;throw new Error(`!!! NLS MISSING: ${O} !!!`)}return D}function Y(O,R,...D){let q;typeof O=="number"?q=U(O,R):q=R;const $=t(q,D);return{value:$,original:R===q?$:t(R,D)}}});var Ge=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(pe[26],be([0,1,54,2,22]),function(oe,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=O,e.formatOptions=D,e.buildHelpMessage=C,e.buildVersionMessage=c,f=Ge(f);const U={o:(0,I.localize)(11523,null),e:(0,I.localize)(11524,null),t:(0,I.localize)(11525,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(11526,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(11527,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,I.localize)(11528,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,I.localize)(11529,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,I.localize)(11530,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,I.localize)(11531,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,I.localize)(11532,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,I.localize)(11533,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,I.localize)(11534,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,I.localize)(11535,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,I.localize)(11536,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,I.localize)(11537,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,I.localize)(11538,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,I.localize)(11539,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(11540,null)},"show-versions":{type:"boolean",cat:"e",description:(0,I.localize)(11541,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,I.localize)(11542,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,I.localize)(11543,null)},"pre-release":{type:"boolean",cat:"e",description:(0,I.localize)(11544,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,I.localize)(11545,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(11546,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,I.localize)(11547,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,I.localize)(11548,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,I.localize)(11549,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,I.localize)(11550,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,I.localize)(11551,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,I.localize)(11552,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,I.localize)(11553,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,I.localize)(11554,null)},sync:{type:"string",cat:"t",description:(0,I.localize)(11555,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,I.localize)(11556,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,I.localize)(11557,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,I.localize)(11558,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,I.localize)(11559,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,I.localize)(11560,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,I.localize)(11561,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const Y={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function O(r,u,_=Y){const A=r.find(h=>h.length>0&&h[0]!=="-"),v={},k=["_"],w=[],n={};let i;for(const h in u){const m=u[h];m.type==="subcommand"?h===A&&(i=m):(m.alias&&(v[h]=m.alias),m.type==="string"||m.type==="string[]"?(k.push(h),m.deprecates&&k.push(...m.deprecates)):m.type==="boolean"&&(w.push(h),m.deprecates&&w.push(...m.deprecates)),m.global&&(n[h]=m))}if(i&&A){const h=n;for(const S in i.options)h[S]=i.options[S];const m=r.filter(S=>S!==A),a=_.getSubcommandReporter?_.getSubcommandReporter(A):void 0,o=O(m,h,a);return{[A]:o,_:[]}}const s=(0,f.default)(r,{string:k,boolean:w,alias:v}),g={},N=s;g._=s._.map(h=>String(h)).filter(h=>h.length>0),delete N._;for(const h in u){const m=u[h];if(m.type==="subcommand")continue;m.alias&&delete N[m.alias];let a=N[h];if(m.deprecates)for(const o of m.deprecates)N.hasOwnProperty(o)&&(a||(a=N[o],a&&_.onDeprecatedOption(o,m.deprecationMessage||(0,I.localize)(11562,null,h))),delete N[o]);if(typeof a<"u"){if(m.type==="string[]"){if(Array.isArray(a)||(a=[a]),!m.allowEmptyValue){const o=a.filter(S=>S.length>0);o.length!==a.length&&(_.onEmptyValue(h),a=o.length>0?o:void 0)}}else m.type==="string"&&(Array.isArray(a)?(a=a.pop(),_.onMultipleValues(h,a)):!a&&!m.allowEmptyValue&&(_.onEmptyValue(h),a=void 0));g[h]=a,m.deprecationMessage&&_.onDeprecatedOption(h,m.deprecationMessage)}delete N[h]}for(const h in N)_.onUnknownOption(h);return g}function R(r,u){let _="";return u.args&&(Array.isArray(u.args)?_=` <${u.args.join("> <")}>`:_=` <${u.args}>`),u.alias?`-${u.alias} --${r}${_}`:`--${r}${_}`}function D(r,u){const _=[];for(const A in r){const v=r[A],k=R(A,v);_.push([k,v.description])}return q(_,u)}function q(r,u){const A=r.reduce((w,n)=>Math.max(w,n[0].length),12)+2+1;if(u-A<25)return r.reduce((w,n)=>w.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const v=u-A-1,k=[];for(const w of r){const n=w[0],i=T(w[1],v),s=$(A-n.length-2);k.push("  "+n+s+i[0]);for(let g=1;g<i.length;g++)k.push($(A)+i[g])}return k}function $(r){return" ".repeat(r)}function T(r,u){const _=[];for(;r.length;){const A=r.length<u?r.length:r.lastIndexOf(" ",u),v=r.slice(0,A).trim();r=r.slice(A),_.push(v)}return _}function C(r,u,_,A,v){const k=process.stdout.isTTY&&process.stdout.columns||80,w=v?.noInputFiles!==!0?`[${(0,I.localize)(11563,null)}...]`:"",n=[`${r} ${_}`];n.push(""),n.push(`${(0,I.localize)(11564,null)}: ${u} [${(0,I.localize)(11565,null)}]${w}`),n.push(""),v?.noPipe!==!0&&(t.isWindows?n.push((0,I.localize)(11566,null,u)):n.push((0,I.localize)(11567,null,u)),n.push(""));const i={},s=[];for(const g in A){const N=A[g];if(N.type==="subcommand")N.description&&s.push({command:g,description:N.description});else if(N.description&&N.cat){let h=i[N.cat];h||(i[N.cat]=h={}),h[g]=N}}for(const g in i){const N=g,h=i[N];h&&(n.push(U[N]),n.push(...D(h,k)),n.push(""))}return s.length&&(n.push((0,I.localize)(11568,null)),n.push(...q(s.map(g=>[g.command,g.description]),k)),n.push("")),n.join(`
`)}function c(r,u){return`${r||(0,I.localize)(11569,null)}
${u||(0,I.localize)(11570,null)}
${process.arch}`}});var Ge=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(pe[45],be([0,1,55,22,26]),function(oe,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMainProcessArgv=O,e.parseCLIProcessArgv=R,e.addArg=D,e.isLaunchedFromCli=q,f=Ge(f);function U($,T){const C=(v,k)=>{console.warn((0,t.localize)(11517,null,v,k))},c=v=>{console.warn((0,t.localize)(11518,null,v))},r=(v,k)=>{console.warn((0,t.localize)(11519,null,v,k))},u=v=>({onUnknownOption:k=>{I.NATIVE_CLI_COMMANDS.includes(v)||console.warn((0,t.localize)(11520,null,k,v))},onMultipleValues:C,onEmptyValue:c,onDeprecatedOption:r,getSubcommandReporter:I.NATIVE_CLI_COMMANDS.includes(v)?u:void 0}),_={onUnknownOption:v=>{console.warn((0,t.localize)(11521,null,v))},onMultipleValues:C,onEmptyValue:c,onDeprecatedOption:r,getSubcommandReporter:u},A=(0,I.parseArgs)($,I.OPTIONS,T?_:void 0);return A.goto&&A._.forEach(v=>(0,f.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(v),(0,t.localize)(11522,null))),A}function Y($){const T=$.findIndex(C=>!/^-/.test(C));if(T>-1)return[...$.slice(0,T),...$.slice(T+1)]}function O($){let[,...T]=$;process.env.VSCODE_DEV&&(T=Y(T)||[]);const C=!q(process.env);return U(T,C)}function R($){let[,,...T]=$;return process.env.VSCODE_DEV&&(T=Y(T)||[]),U(T,!0)}function D($,...T){const C=$.indexOf("--");return C===-1?$.push(...T):$.splice(C,0,...T),$}function q($){return $.VSCODE_CLI==="1"}}),define(pe[46],be([0,1,9,21,8,5,43]),function(oe,e,f,t,I,U,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasStdinWithoutTty=O,e.stdinDataListener=R,e.getStdinFilePath=D,e.readFromStdin=q,f=Ue(f);function O(){try{return!process.stdin.isTTY}catch{}return!1}function R($){return new Promise(T=>{const C=()=>T(!0);setTimeout(()=>{process.stdin.removeListener("data",C),T(!1)},$),process.stdin.once("data",C)})}function D(){return(0,U.randomPath)((0,t.tmpdir)(),"code-stdin",3)}async function q($,T,C){let[c,r]=await Promise.all([(0,Y.resolveTerminalEncoding)(T),new Promise((A,v)=>{oe(["@vscode/iconv-lite-umd"],A,v)}).then(Ue),f.promises.appendFile($,"")]);r.encodingExists(c)||(console.log(`Unsupported terminal encoding: ${c}, falling back to UTF-8.`),c="utf8");const u=new I.Queue,_=r.getDecoder(c);process.stdin.on("data",A=>{const v=_.write(A);u.queue(()=>f.promises.appendFile($,v))}),process.stdin.on("end",()=>{const A=_.end();u.queue(async()=>{try{typeof A=="string"&&await f.promises.appendFile($,A)}finally{C?.()}})})}}),define(pe[47],be([0,1,9,21,5]),function(oe,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=U;function U(Y){const O=(0,I.randomPath)((0,t.tmpdir)());try{return(0,f.writeFileSync)(O,""),Y&&console.log(`Marker file for --wait created: ${O}`),O}catch(R){Y&&console.error(`Failed to create marker file for --wait: ${R}`);return}}}),define(pe[27],be([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=I,e.refineServiceDecorator=U;var f;(function(Y){Y.serviceIds=new Map,Y.DI_TARGET="$di$target",Y.DI_DEPENDENCIES="$di$dependencies";function O(R){return R[Y.DI_DEPENDENCIES]||[]}Y.getServiceDependencies=O})(f||(e._util=f={})),e.IInstantiationService=I("instantiationService");function t(Y,O,R){O[f.DI_TARGET]===O?O[f.DI_DEPENDENCIES].push({id:Y,index:R}):(O[f.DI_DEPENDENCIES]=[{id:Y,index:R}],O[f.DI_TARGET]=O)}function I(Y){if(f.serviceIds.has(Y))return f.serviceIds.get(Y);const O=function(R,D,q){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(O,R,q)};return O.toString=()=>Y,f.serviceIds.set(Y,O),O}function U(Y){return Y}}),define(pe[28],be([0,1,39,3,4,25,6,22,27,2,18,14]),function(oe,e,f,t,I,U,Y,O,R,D,q,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=T,e.isFileSystemWatcher=u,e.hasReadWriteCapability=A,e.hasFileFolderCopyCapability=v,e.hasFileCloneCapability=k,e.hasOpenReadWriteCloseCapability=w,e.hasFileReadStreamCapability=n,e.hasFileAtomicReadCapability=i,e.hasFileAtomicWriteCapability=s,e.hasFileAtomicDeleteCapability=g,e.hasReadonlyCapability=N,e.createFileSystemProviderError=a,e.ensureFileSystemProviderError=o,e.markAsFileSystemProviderError=S,e.toFileSystemProviderErrorCode=L,e.toFileOperationResult=p,e.isParent=le,e.etag=G,e.whenProviderRegistered=H,e.getLargeFileConfirmationLimit=ue,e.IFileService=(0,R.createDecorator)("fileService");function T(b){return b.create===!0}var C;(function(b){b[b.Unknown=0]="Unknown",b[b.File=1]="File",b[b.Directory=2]="Directory",b[b.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var c;(function(b){b[b.Readonly=1]="Readonly",b[b.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var r;(function(b){b[b.UPDATED=2]="UPDATED",b[b.ADDED=4]="ADDED",b[b.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function u(b){const ie=b;return!!ie&&typeof ie.onDidChange=="function"}var _;(function(b){b[b.None=0]="None",b[b.FileReadWrite=2]="FileReadWrite",b[b.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",b[b.FileReadStream=16]="FileReadStream",b[b.FileFolderCopy=8]="FileFolderCopy",b[b.PathCaseSensitive=1024]="PathCaseSensitive",b[b.Readonly=2048]="Readonly",b[b.Trash=4096]="Trash",b[b.FileWriteUnlock=8192]="FileWriteUnlock",b[b.FileAtomicRead=16384]="FileAtomicRead",b[b.FileAtomicWrite=32768]="FileAtomicWrite",b[b.FileAtomicDelete=65536]="FileAtomicDelete",b[b.FileClone=131072]="FileClone"})(_||(e.FileSystemProviderCapabilities=_={}));function A(b){return!!(b.capabilities&_.FileReadWrite)}function v(b){return!!(b.capabilities&_.FileFolderCopy)}function k(b){return!!(b.capabilities&_.FileClone)}function w(b){return!!(b.capabilities&_.FileOpenReadWriteClose)}function n(b){return!!(b.capabilities&_.FileReadStream)}function i(b){return A(b)?!!(b.capabilities&_.FileAtomicRead):!1}function s(b){return A(b)?!!(b.capabilities&_.FileAtomicWrite):!1}function g(b){return!!(b.capabilities&_.FileAtomicDelete)}function N(b){return!!(b.capabilities&_.Readonly)}var h;(function(b){b.FileExists="EntryExists",b.FileNotFound="EntryNotFound",b.FileNotADirectory="EntryNotADirectory",b.FileIsADirectory="EntryIsADirectory",b.FileExceedsStorageQuota="EntryExceedsStorageQuota",b.FileTooLarge="EntryTooLarge",b.FileWriteLocked="EntryWriteLocked",b.NoPermissions="NoPermissions",b.Unavailable="Unavailable",b.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class m extends Error{static create(ie,se){const re=new m(ie.toString(),se);return S(re,se),re}constructor(ie,se){super(ie),this.code=se}}e.FileSystemProviderError=m;function a(b,ie){return m.create(b,ie)}function o(b){return b||a((0,O.localize)(11386,null),h.Unknown)}function S(b,ie){return b.name=ie?`${ie} (FileSystemError)`:"FileSystemError",b}function L(b){if(!b)return h.Unknown;if(b instanceof m)return b.code;const ie=/^(.+) \(FileSystemError\)$/.exec(b.name);if(!ie)return h.Unknown;switch(ie[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function p(b){if(b instanceof M)return b.fileOperationResult;switch(L(b)){case h.FileNotFound:return ee.FILE_NOT_FOUND;case h.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case h.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case h.NoPermissions:return ee.FILE_PERMISSION_DENIED;case h.FileExists:return ee.FILE_MOVE_CONFLICT;case h.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var z;(function(b){b[b.CREATE=0]="CREATE",b[b.DELETE=1]="DELETE",b[b.MOVE=2]="MOVE",b[b.COPY=3]="COPY",b[b.WRITE=4]="WRITE"})(z||(e.FileOperation=z={}));class x{constructor(ie,se,re){this.resource=ie,this.operation=se,this.target=re}isOperation(ie){return this.operation===ie}}e.FileOperationEvent=x;var J;(function(b){b[b.UPDATED=0]="UPDATED",b[b.ADDED=1]="ADDED",b[b.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class j{static{this.MIXED_CORRELATION=null}constructor(ie,se){this.ignorePathCasing=se,this.correlationId=void 0,this.added=new $.Lazy(()=>{const re=f.TernarySearchTree.forUris(()=>this.ignorePathCasing);return re.fill(this.rawAdded.map(fe=>[fe,!0])),re}),this.updated=new $.Lazy(()=>{const re=f.TernarySearchTree.forUris(()=>this.ignorePathCasing);return re.fill(this.rawUpdated.map(fe=>[fe,!0])),re}),this.deleted=new $.Lazy(()=>{const re=f.TernarySearchTree.forUris(()=>this.ignorePathCasing);return re.fill(this.rawDeleted.map(fe=>[fe,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of ie){switch(re.type){case J.ADDED:this.rawAdded.push(re.resource);break;case J.UPDATED:this.rawUpdated.push(re.resource);break;case J.DELETED:this.rawDeleted.push(re.resource);break}this.correlationId!==j.MIXED_CORRELATION&&(typeof re.cId=="number"?this.correlationId===void 0?this.correlationId=re.cId:this.correlationId!==re.cId&&(this.correlationId=j.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=j.MIXED_CORRELATION))}}contains(ie,...se){return this.doContains(ie,{includeChildren:!1},...se)}affects(ie,...se){return this.doContains(ie,{includeChildren:!0},...se)}doContains(ie,se,...re){if(!ie)return!1;const fe=re.length>0;return!!((!fe||re.includes(J.ADDED))&&(this.added.value.get(ie)||se.includeChildren&&this.added.value.findSuperstr(ie))||(!fe||re.includes(J.UPDATED))&&(this.updated.value.get(ie)||se.includeChildren&&this.updated.value.findSuperstr(ie))||(!fe||re.includes(J.DELETED))&&(this.deleted.value.findSubstr(ie)||se.includeChildren&&this.deleted.value.findSuperstr(ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ie){return this.correlationId===ie}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=j;function le(b,ie,se){return!b||!ie||b===ie||ie.length>b.length?!1:(ie.charAt(ie.length-1)!==t.sep&&(ie+=t.sep),se?(0,I.startsWithIgnoreCase)(b,ie):b.indexOf(ie)===0)}class M extends Error{constructor(ie,se,re){super(ie),this.fileOperationResult=se,this.options=re}}e.FileOperationError=M;class K extends M{constructor(ie,se,re,fe){super(ie,se,fe),this.fileOperationResult=se,this.size=re}}e.TooLargeFileOperationError=K;class Z extends M{constructor(ie,se,re){super(ie,ee.FILE_NOT_MODIFIED_SINCE,re),this.stat=se}}e.NotModifiedSinceFileOperationError=Z;var ee;(function(b){b[b.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",b[b.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",b[b.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",b[b.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",b[b.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",b[b.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",b[b.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",b[b.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",b[b.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",b[b.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",b[b.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var W;(function(b){b[b.FILE=0]="FILE",b[b.FOLDER=1]="FOLDER",b[b.ROOT_FOLDER=2]="ROOT_FOLDER"})(W||(e.FileKind=W={})),e.ETAG_DISABLED="";function G(b){if(!(typeof b.size!="number"||typeof b.mtime!="number"))return b.mtime.toString(29)+b.size.toString(31)}async function H(b,ie){if(!ie.hasProvider(Y.URI.from({scheme:b.scheme})))return new Promise(se=>{const re=ie.onDidChangeFileSystemProviderRegistrations(fe=>{fe.scheme===b.scheme&&fe.added&&(re.dispose(),se())})})}class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(ie){return(0,U.isNumber)(ie)||(ie=0),ie<te.KB?(0,O.localize)(11387,null,ie.toFixed(0)):ie<te.MB?(0,O.localize)(11388,null,(ie/te.KB).toFixed(2)):ie<te.GB?(0,O.localize)(11389,null,(ie/te.MB).toFixed(2)):ie<te.TB?(0,O.localize)(11390,null,(ie/te.GB).toFixed(2)):(0,O.localize)(11391,null,(ie/te.TB).toFixed(2))}}e.ByteSize=te;function ue(b){const ie=typeof b=="string"||b?.scheme===q.Schemas.vscodeRemote;return typeof b!="string"&&b?.scheme===q.Schemas.file?1024*te.MB:ie?10*te.MB:D.isWeb?50*te.MB:1024*te.MB}}),define(pe[48],be([0,1,40,11,3,2,6,28]),function(oe,e,f,t,I,U,Y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=R,e.isRecursiveWatchRequest=D,e.reviveFileChanges=C,e.coalesceEvents=c,e.normalizeWatcherPattern=r,e.parseWatcherPatterns=u,e.isFiltered=A,e.requestFilterToString=v;function R(k){return typeof k.correlationId=="number"}function D(k){return k.recursive===!0}class q extends t.Disposable{static{this.MAX_RESTARTS=5}constructor(w,n,i,s){super(),this.onFileChanges=w,this.onLogMessage=n,this.verboseLogging=i,this.options=s,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const w=new t.DisposableStore;this.watcherDisposables.value=w,this.watcher=this.createWatcher(w),this.watcher.setVerboseLogging(this.verboseLogging),w.add(this.watcher.onDidChangeFile(n=>this.onFileChanges(n))),w.add(this.watcher.onDidLogMessage(n=>this.onLogMessage(n))),w.add(this.watcher.onDidError(n=>this.onError(n.error,n.request)))}onError(w,n){this.canRestart(w,n)?this.restartCounter<q.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${w}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${w}`):this.error(w)}canRestart(w,n){return!(!this.options.restartOnError||n||w.indexOf("No space left on device")!==-1||w.indexOf("EMFILE")!==-1)}restart(w){this.restartCounter++,this.init(),this.watch(w)}async watch(w){this.requests=w,await this.watcher?.watch(w)}async setVerboseLogging(w){this.verboseLogging=w,await this.watcher?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${w}`})}trace(w){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${w}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=q;class $ extends q{constructor(w,n,i){super(w,n,i,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=$;class T extends q{constructor(w,n,i){super(w,n,i,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=T;function C(k){return k.map(w=>({type:w.type,resource:Y.URI.revive(w.resource),cId:w.cId}))}function c(k){const w=new _;for(const n of k)w.processEvent(n);return w.coalesce()}function r(k,w){return typeof w=="string"&&!w.startsWith(f.GLOBSTAR)&&!(0,I.isAbsolute)(w)?{base:k,pattern:w}:w}function u(k,w){const n=[];for(const i of w)n.push((0,f.parse)(r(k,i)));return n}class _{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(w){return U.isLinux?w.resource.fsPath:w.resource.fsPath.toLowerCase()}processEvent(w){const n=this.mapPathToChange.get(this.toKey(w));let i=!1;if(n){const s=n.type,g=w.type;n.resource.fsPath!==w.resource.fsPath&&(w.type===O.FileChangeType.DELETED||w.type===O.FileChangeType.ADDED)?i=!0:s===O.FileChangeType.ADDED&&g===O.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(w)),this.coalesced.delete(n)):s===O.FileChangeType.DELETED&&g===O.FileChangeType.ADDED?n.type=O.FileChangeType.UPDATED:s===O.FileChangeType.ADDED&&g===O.FileChangeType.UPDATED||(n.type=g)}else i=!0;i&&(this.coalesced.add(w),this.mapPathToChange.set(this.toKey(w),w))}coalesce(){const w=[],n=[];return Array.from(this.coalesced).filter(i=>i.type!==O.FileChangeType.DELETED?(w.push(i),!1):!0).sort((i,s)=>i.resource.fsPath.length-s.resource.fsPath.length).filter(i=>n.some(s=>(0,O.isParent)(i.resource.fsPath,s,!U.isLinux))?!1:(n.push(i.resource.fsPath),!0)).concat(w)}}function A(k,w){if(typeof w=="number")switch(k.type){case O.FileChangeType.ADDED:return(w&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(w&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(w&O.FileChangeFilter.UPDATED)===0}return!1}function v(k){if(typeof k=="number"){const w=[];return k&O.FileChangeFilter.ADDED&&w.push("Added"),k&O.FileChangeFilter.DELETED&&w.push("Deleted"),k&O.FileChangeFilter.UPDATED&&w.push("Updated"),w.length===0?"<all>":`[${w.join(", ")}]`}return"<none>"}}),define(pe[49],be([0,1,9,8,12,5,11,24,3,2,19,6,41,20,28,48]),function(oe,e,f,t,I,U,Y,O,R,D,q,$,T,C,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=_;class u extends Y.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(v,k,w,n,i,s){super(),this.request=v,this.recursiveWatcher=k,this.onDidFilesChange=w,this.onDidWatchFail=n,this.onLogMessage=i,this.verboseLogging=s,this.throttledFileChangesEmitter=this._register(new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g))),this.fileChangesAggregator=this._register(new t.RunOnceWorker(g=>this.handleFileChanges(g),u.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,r.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,r.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,r.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new I.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const k=await f.promises.stat(v);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(v,k.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${v})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(v){let k=v.path;try{k=await C.Promises.realpath(v.path),v.path===k&&(k=await(0,T.realcase)(v.path,this.cts.token)??v.path),v.path!==k&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${k})`)}catch{}return k}async doWatch(v,k){const w=new Y.DisposableStore;return this.doWatchWithExistingWatcher(v,k,w)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(v,k,w)),w}doWatchWithExistingWatcher(v,k,w){if(k)return!1;const n=$.URI.file(this.request.path),i=this.recursiveWatcher?.subscribe(this.request.path,async(s,g)=>{if(!w.isDisposed)if(s){const N=await this.doWatch(v,k);w.isDisposed?N.dispose():w.add(N)}else g&&(typeof g.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:n,type:g.type,cId:this.request.correlationId},!0)});return i?(w.add(i),!0):!1}async doWatchWithNodeJS(v,k,w){if(D.isMacintosh&&(0,U.isEqualOrParent)(v,"/Volumes/",!0)){this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const n=new I.CancellationTokenSource(this.cts.token);w.add((0,Y.toDisposable)(()=>n.dispose(!0)));const i=new Y.DisposableStore;w.add(i);try{const s=$.URI.file(this.request.path),g=(0,R.basename)(v),N=(0,f.watch)(v);i.add((0,Y.toDisposable)(()=>{N.removeAllListeners(),N.close()})),this.trace(`Started watching: '${v}'`);const h=new Set;if(k)try{for(const a of await C.Promises.readdir(v))h.add(a)}catch(a){this.error(a)}if(n.token.isCancellationRequested)return;const m=new Map;i.add((0,Y.toDisposable)(()=>{for(const[,a]of m)a.dispose();m.clear()})),N.on("error",(a,o)=>{n.token.isCancellationRequested||(this.error(`Failed to watch ${v} for changes using fs.watch() (${a}, ${o})`),this.notifyWatchFailed())}),N.on("change",(a,o)=>{if(n.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${a}"] ${o}`);let S="";if(o&&(S=o.toString(),D.isMacintosh&&(S=(0,O.normalizeNFC)(S))),!(!S||a!=="change"&&a!=="rename"))if(k)if(a==="rename"){m.get(S)?.dispose();const L=setTimeout(async()=>{if(m.delete(S),S===g&&!await C.Promises.exists(v)){this.onWatchedPathDeleted(s);return}if(n.token.isCancellationRequested)return;const p=await this.existsChildStrictCase((0,R.join)(v,S));if(n.token.isCancellationRequested)return;let z;p?h.has(S)?z=c.FileChangeType.UPDATED:(z=c.FileChangeType.ADDED,h.add(S)):(h.delete(S),z=c.FileChangeType.DELETED),this.onFileChange({resource:(0,q.joinPath)(s,S),type:z,cId:this.request.correlationId})},u.FILE_DELETE_HANDLER_DELAY);m.set(S,(0,Y.toDisposable)(()=>clearTimeout(L)))}else{let L;h.has(S)?L=c.FileChangeType.UPDATED:(L=c.FileChangeType.ADDED,h.add(S)),this.onFileChange({resource:(0,q.joinPath)(s,S),type:L,cId:this.request.correlationId})}else if(a==="rename"||S!==g){const L=setTimeout(async()=>{const p=await C.Promises.exists(v);n.token.isCancellationRequested||(p?(this.onFileChange({resource:s,type:c.FileChangeType.UPDATED,cId:this.request.correlationId},!0),i.add(await this.doWatch(v,!1))):this.onWatchedPathDeleted(s))},u.FILE_DELETE_HANDLER_DELAY);i.clear(),i.add((0,Y.toDisposable)(()=>clearTimeout(L)))}else this.onFileChange({resource:s,type:c.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(s){n.token.isCancellationRequested||this.error(`Failed to watch ${v} for changes using fs.watch() (${s.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(v){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:v,type:c.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(v,k=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${v.type===c.FileChangeType.ADDED?"[ADDED]":v.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`),!k&&this.excludes.some(w=>w(v.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${v.resource.fsPath}`):!k&&this.includes&&this.includes.length>0&&!this.includes.some(w=>w(v.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${v.resource.fsPath}`):this.fileChangesAggregator.work(v))}handleFileChanges(v){const k=(0,r.coalesceEvents)(v),w=[];for(const i of k){if((0,r.isFiltered)(i,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${i.resource.fsPath}`);continue}w.push(i)}if(w.length===0)return;if(this.verboseLogging)for(const i of w)this.traceWithCorrelation(` >> normalized ${i.type===c.FileChangeType.ADDED?"[ADDED]":i.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.throttledFileChangesEmitter.work(w)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${w[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${w.length}, most recent change: ${w[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(v){if(D.isLinux)return C.Promises.exists(v);try{const k=(0,R.basename)(v);return(await C.Promises.readdir((0,R.dirname)(v))).some(n=>n===k)}catch(k){return this.trace(k),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}traceWithCorrelation(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${v}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u;async function _(A,v,k,w,n=512){const i=await C.Promises.open(A,"r"),s=Buffer.allocUnsafe(n),g=new I.CancellationTokenSource(w);let N,h=!1;const m={path:A,excludes:[],recursive:!1},a=new u(m,void 0,o=>{(async()=>{for(const{type:S}of o)if(S===c.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!g.token.isCancellationRequested;){const{bytesRead:L}=await C.Promises.read(i,s,0,n,null);if(!L||g.token.isCancellationRequested)break;v(s.slice(0,L))}}catch(L){N=new Error(L),g.dispose(!0)}finally{h=!1}}})()});return await a.ready,k(),new Promise((o,S)=>{g.token.onCancellationRequested(async()=>{a.dispose();try{await C.Promises.close(i)}catch(L){N=new Error(L)}N?S(N):o()})})}}),define(pe[50],be([0,1,16]),function(oe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let t;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.context<"u"){const U=I.context.configuration();if(U)t=U.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){t=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:U,searchUrl:Y,itemUrl:O,controlUrl:R}=t.extensionsGallery||{};Object.assign(t,{extensionsGallery:{serviceUrl:f.env.VSCODE_GALLERY_SERVICE_URL||U,searchUrl:f.env.VSCODE_GALLERY_SEARCH_URL||Y,itemUrl:f.env.VSCODE_GALLERY_ITEM_URL||O,controlUrl:f.env.VSCODE_GALLERY_CONTROL_URL||R}});try{const D=(...$)=>$.reduce((T,C)=>(Object.keys(C).forEach(c=>{Array.isArray(T[c])&&Array.isArray(C[c])?T[c]=C[c]:typeof T[c]=="object"&&typeof C[c]=="object"?T[c]=D(T[c],C[c]):T[c]=C[c]}),T),{}),q=globalThis._VSCODE_USER_PRODUCT_JSON||{};t=D(t,q)}catch{}if(f.env.VSCODE_DEV&&Object.assign(t,{nameShort:`${t.nameShort} Dev`,nameLong:`${t.nameLong} Dev`,dataFolderName:`${t.dataFolderName}-dev`,serverDataFolderName:t.serverDataFolderName?`${t.serverDataFolderName}-dev`:void 0}),!t.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(t,{version:D.version,release:D.release})}}else t={},Object.keys(t).length===0&&Object.assign(t,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=t}),define(pe[51],be([0,1,3,27]),function(oe,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var I;(function(U){function Y(R){return!!(R.samples&&R.timeDeltas)}U.isValidProfile=Y;function O(R,D="noAbsolutePaths"){for(const q of R.nodes)q.callFrame&&q.callFrame.url&&((0,f.isAbsolute)(q.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(q.callFrame.url))&&(q.callFrame.url=(0,f.join)(D,(0,f.basename)(q.callFrame.url)));return R}U.rewriteAbsolutePaths=O})(I||(e.Utils=I={}))});var Ge=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(pe[56],be([0,1,44,9,21,17,3,2,34,20,42,49,26,45,46,47,50,12,5,51,18,16,57,6,8]),function(oe,e,f,t,I,U,Y,O,R,D,q,$,T,C,c,r,u,_,A,v,k,w,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=N,u=Ge(u);function g(a){return!!a["install-source"]||!!a["list-extensions"]||!!a["install-extension"]||!!a["uninstall-extension"]||!!a["update-extensions"]||!!a["locate-extension"]||!!a.telemetry}async function N(a){let o;try{o=(0,C.parseCLIProcessArgv)(a)}catch(S){console.error(S.message);return}for(const S of T.NATIVE_CLI_COMMANDS)if(o[S]){if(!u.default.tunnelApplicationName){console.error(`'${S}' command not supported in ${u.default.applicationName}`);return}const L={...process.env};delete L.ELECTRON_RUN_AS_NODE;const p=a.slice(a.indexOf(S)+1);return new Promise((z,x)=>{let J;const j=["ignore","pipe","pipe"];if(process.env.VSCODE_DEV)J=(0,f.spawn)("cargo",["run","--",S,...p],{cwd:(0,Y.join)(h(),"cli"),stdio:j,env:L});else{const le=process.platform==="darwin"?(0,Y.join)((0,Y.dirname)((0,Y.dirname)(process.execPath)),"Resources","app"):(0,Y.dirname)(process.execPath),M=(0,Y.join)(le,"bin",`${u.default.tunnelApplicationName}${O.isWindows?".exe":""}`);J=(0,f.spawn)(M,[S,...p],{cwd:(0,w.cwd)(),stdio:j,env:L})}J.stdout.pipe(process.stdout),J.stderr.pipe(process.stderr),J.on("exit",z),J.on("error",x)})}if(o.help){const S=`${u.default.applicationName}${O.isWindows?".exe":""}`;console.log((0,T.buildHelpMessage)(u.default.nameLong,S,u.default.version,T.OPTIONS))}else if(o.version)console.log((0,T.buildVersionMessage)(u.default.version,u.default.commit));else if(o["locate-shell-integration-path"]){let S;switch(o["locate-shell-integration-path"]){case"bash":S="shellIntegration-bash.sh";break;case"pwsh":S="shellIntegration.ps1";break;case"zsh":S="shellIntegration-rc.zsh";break;case"fish":S="fish_xdg_data/fish/vendor_conf.d/shellIntegration.fish";break;default:throw new Error("Error using --locate-shell-integration-path: Invalid shell type")}console.log((0,Y.join)(h(),"out","vs","workbench","contrib","terminal","browser","media",S))}else if(g(o)){await(await new Promise((L,p)=>{oe(["vs/code/node/cliProcessMain"],L,p)}).then(Ue)).main(o);return}else if(o["file-write"]){const S=o._[0],L=o._[1];if(O.isWindows)for(const p of[S,L])(0,A.isUNC)(p)&&(0,n.addUNCHostToAllowlist)(i.URI.file(p).authority);if(!S||!L||S===L||!(0,Y.isAbsolute)(S)||!(0,Y.isAbsolute)(L)||!(0,t.existsSync)(S)||!(0,t.statSync)(S).isFile()||!(0,t.existsSync)(L)||!(0,t.statSync)(L).isFile())throw new Error("Using --file-write with invalid arguments.");try{let p=0,z=!1;o["file-chmod"]&&(p=(0,t.statSync)(L).mode,p&128||((0,t.chmodSync)(L,p|128),z=!0));const x=(0,t.readFileSync)(S);O.isWindows?((0,t.truncateSync)(L,0),(0,D.writeFileSync)(L,x,{flag:"r+"})):(0,D.writeFileSync)(L,x),z&&(0,t.chmodSync)(L,p)}catch(p){throw p.message=`Error using --file-write: ${p.message}`,p}}else{const S={...process.env,ELECTRON_NO_ATTACH_CONSOLE:"1"};delete S.ELECTRON_RUN_AS_NODE;const L=[];o.verbose&&(S.ELECTRON_ENABLE_LOGGING="1"),(o.verbose||o.status)&&L.push(async M=>{M.stdout?.on("data",K=>console.log(K.toString("utf8").trim())),M.stderr?.on("data",K=>console.log(K.toString("utf8").trim())),await U.Event.toPromise(U.Event.fromNodeEventEmitter(M,"exit"))});const p=o._.some(M=>M==="-");p&&(o._=o._.filter(M=>M!=="-"),a=a.filter(M=>M!=="-"));let z;if((0,c.hasStdinWithoutTty)())if(p){z=(0,c.getStdinFilePath)();try{const M=new s.DeferredPromise;await(0,c.readFromStdin)(z,!!o.verbose,()=>M.complete()),o.wait||L.push(()=>M.p),(0,C.addArg)(a,z),(0,C.addArg)(a,"--skip-add-to-recently-opened"),console.log(`Reading from stdin via: ${z}`)}catch(M){console.log(`Failed to create file to read via stdin: ${M.toString()}`),z=void 0}}else L.push(M=>(0,c.stdinDataListener)(1e3).then(K=>{K&&(O.isWindows?console.log(`Run with '${u.default.applicationName} -' to read output from another program (e.g. 'echo Hello World | ${u.default.applicationName} -').`):console.log(`Run with '${u.default.applicationName} -' to read from stdin (e.g. 'ps aux | grep code | ${u.default.applicationName} -').`))}));const x=O.isMacintosh&&(0,I.release)()>"20.0.0";let J;if(o.wait&&(J=(0,r.createWaitMarkerFileSync)(o.verbose),J&&(0,C.addArg)(a,"--waitMarkerFilePath",J),L.push(async M=>{let K;x?K=new Promise(Z=>{M.on("exit",(ee,W)=>{(ee!==0||W)&&Z()})}):K=U.Event.toPromise(U.Event.fromNodeEventEmitter(M,"exit"));try{await Promise.race([(0,D.whenDeleted)(J),U.Event.toPromise(U.Event.fromNodeEventEmitter(M,"error")),K])}finally{z&&(0,t.unlinkSync)(z)}})),o["prof-startup"]){const M="127.0.0.1",K=await(0,q.findFreePort)((0,R.randomPort)(),10,3e3),Z=await(0,q.findFreePort)(K+1,10,3e3),ee=await(0,q.findFreePort)(Z+1,10,3e3);if(K*Z*ee===0)throw new Error("Failed to find free ports for profiler. Make sure to shutdown all instances of the editor first.");const W=(0,A.randomPath)((0,I.homedir)(),"prof");(0,C.addArg)(a,`--inspect-brk=${M}:${K}`),(0,C.addArg)(a,`--remote-debugging-port=${M}:${Z}`),(0,C.addArg)(a,`--inspect-brk-extensions=${M}:${ee}`),(0,C.addArg)(a,"--prof-startup-prefix",W),(0,C.addArg)(a,"--no-cached-data"),(0,D.writeFileSync)(W,a.slice(-6).join("|")),L.push(async G=>{class H{static async start(ue,b,ie){const se=await new Promise((fe,de)=>{oe(["v8-inspect-profiler"],fe,de)}).then(Ue);let re;try{re=await se.startProfiling({...ie,host:M})}catch{console.error(`FAILED to start profiling for '${ue}' on port '${ie.port}'`)}return{async stop(){if(!re)return;let fe="";const de=await re.stop();process.env.VSCODE_DEV||(de.profile=v.Utils.rewriteAbsolutePaths(de.profile,"piiRemoved"),fe=".txt"),(0,D.writeFileSync)(`${b}.${ue}.cpuprofile${fe}`,JSON.stringify(de.profile,void 0,4))}}}}try{const te=H.start("main",W,{port:K}),ue=H.start("extHost",W,{port:ee,tries:300}),b=H.start("renderer",W,{port:Z,tries:200,target:function(fe){return fe.filter(de=>de.webSocketDebuggerUrl?de.type==="page"?de.url.indexOf("workbench/workbench.html")>0||de.url.indexOf("workbench/workbench-dev.html")>0:!0:!1)[0]}}),ie=await te,se=await ue,re=await b;await(0,D.whenDeleted)(W),await ie.stop(),await re.stop(),await se.stop(),(0,D.writeFileSync)(W,"")}catch{console.error("Failed to profile startup. Make sure to quit Code first.")}})}const j={detached:!0,env:S};o.verbose||(j.stdio="ignore");let le;if(!x)!o.verbose&&o.status&&(j.stdio=["ignore","pipe","ignore"]),le=(0,f.spawn)(process.execPath,a.slice(2),j);else{const M=["-n","-g"];if(M.push("-a",process.execPath),o.verbose||o.status){M.push("--wait-apps");for(const K of o.verbose?["stdout","stderr"]:["stdout"]){const Z=(0,A.randomPath)((0,I.tmpdir)(),`code-${K}`);(0,D.writeFileSync)(Z,""),M.push(`--${K}`,Z),L.push(async ee=>{try{const W=K==="stdout"?process.stdout:process.stderr,G=new _.CancellationTokenSource;ee.on("close",()=>{setTimeout(()=>G.dispose(!0),200)}),await(0,$.watchFileContents)(Z,H=>W.write(H),()=>{},G.token)}finally{(0,t.unlinkSync)(Z)}})}}for(const K in S)K!=="_"&&(M.push("--env"),M.push(`${K}=${S[K]}`));if(M.push("--args",...a.slice(2)),S.VSCODE_DEV){const K=".",Z=M.indexOf(K);Z!==-1&&(M[Z]=(0,Y.resolve)(K))}le=(0,f.spawn)("open",M,{...j,env:{}})}return Promise.all(L.map(M=>M(le)))}}function h(){return(0,Y.dirname)(k.FileAccess.asFileUri("").fsPath)}function m(a){setTimeout(()=>process.exit(a),0)}N(process.argv).then(()=>m(0)).then(null,a=>{console.error(a.message||a.stack||a),m(1)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/code/node/cli.js.map
