/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ue=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/processes","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],de=function(J){for(var e=[],I=0,b=J.length;I<b;I++)e[I]=ue[J[I]];return e};define(ue[74],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.isESM=void 0,e.isESM=!1;var I;(function(E){E[E.LoaderAvailable=1]="LoaderAvailable",E[E.BeginLoadingScript=10]="BeginLoadingScript",E[E.EndLoadingScriptOK=11]="EndLoadingScriptOK",E[E.EndLoadingScriptError=12]="EndLoadingScriptError",E[E.BeginInvokeFactory=21]="BeginInvokeFactory",E[E.EndInvokeFactory=22]="EndInvokeFactory",E[E.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",E[E.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",E[E.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",E[E.NodeEndNativeRequire=34]="NodeEndNativeRequire",E[E.CachedDataFound=60]="CachedDataFound",E[E.CachedDataMissed=61]="CachedDataMissed",E[E.CachedDataRejected=62]="CachedDataRejected",E[E.CachedDataCreated=63]="CachedDataCreated"})(I||(e.LoaderEventType=I={}));class b{static get(){const R=new Map,A=new Map,D=new Map,v=new Map;function a(g,C){g.has(C.detail)||g.set(C.detail,-C.timestamp)}function h(g,C){const w=g.get(C.detail);w&&(w>=0||g.set(C.detail,w+C.timestamp))}let c=[];typeof J=="function"&&typeof J.getStats=="function"&&(c=J.getStats().slice(0).sort((g,C)=>g.timestamp-C.timestamp));for(const g of c)switch(g.type){case I.BeginLoadingScript:a(R,g);break;case I.EndLoadingScriptOK:case I.EndLoadingScriptError:h(R,g);break;case I.BeginInvokeFactory:a(A,g);break;case I.EndInvokeFactory:h(A,g);break;case I.NodeBeginNativeRequire:a(D,g);break;case I.NodeEndNativeRequire:h(D,g);break;case I.NodeBeginEvaluatingScript:a(v,g);break;case I.NodeEndEvaluatingScript:h(v,g);break}let p=0;D.forEach(g=>p+=g);function f(g){const C=[];return g.forEach((w,d)=>C.push([d,w])),C}return{amdLoad:f(R),amdInvoke:f(A),nodeRequire:f(D),nodeEval:f(v),nodeRequireTotal:p}}static toMarkdownTable(R,A){let D="";const v=[];return R.forEach((a,h)=>{v[h]=a.length}),A.forEach(a=>{a.forEach((h,c)=>{typeof h>"u"&&(h=a[c]="-");const p=h.toString().length;v[c]=Math.max(p,v[c])})}),R.forEach((a,h)=>{D+=`| ${a+" ".repeat(v[h]-a.toString().length)} `}),D+=`|
`,R.forEach((a,h)=>{D+=`| ${"-".repeat(v[h])} `}),D+=`|
`,A.forEach(a=>{a.forEach((h,c)=>{typeof h<"u"&&(D+=`| ${h+" ".repeat(v[c]-h.toString().length)} `)}),D+=`|
`}),D}}e.LoaderStats=b}),define(ue[55],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=b,e.debounce=E,e.throttle=R;function I(A){return(D,v,a)=>{let h=null,c=null;if(typeof a.value=="function"?(h="value",c=a.value):typeof a.get=="function"&&(h="get",c=a.get),!c)throw new Error("not supported");a[h]=A(c,v)}}function b(A,D,v){let a=null,h=null;if(typeof v.value=="function"?(a="value",h=v.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(a="get",h=v.get),!h)throw new Error("not supported");const c=`$memoize$${D}`;v[a]=function(...p){return this.hasOwnProperty(c)||Object.defineProperty(this,c,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,p)}),this[c]}}function E(A,D,v){return I((a,h)=>{const c=`$debounce$${h}`,p=`$debounce$result$${h}`;return function(...f){this[p]||(this[p]=v?v():void 0),clearTimeout(this[c]),D&&(this[p]=D(this[p],...f),f=[this[p]]),this[c]=setTimeout(()=>{a.apply(this,f),this[p]=v?v():void 0},A)}})}function R(A,D,v){return I((a,h)=>{const c=`$throttle$timer$${h}`,p=`$throttle$result$${h}`,f=`$throttle$lastRun$${h}`,g=`$throttle$pending$${h}`;return function(...C){if(this[p]||(this[p]=v?v():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),D&&(this[p]=D(this[p],...C)),this[g])return;const w=this[f]+A;w<=Date.now()?(this[f]=Date.now(),a.apply(this,[this[p]]),this[p]=v?v():void 0):(this[g]=!0,this[c]=setTimeout(()=>{this[g]=!1,this[f]=Date.now(),a.apply(this,[this[p]]),this[p]=v?v():void 0},w-Date.now()))}})}}),define(ue[75],de([0,1,7]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=b,e.assertNever=E,e.assert=R,e.softAssert=A,e.assertFn=D,e.checkAdjacentItems=v;function b(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function E(a,h="Unreachable"){throw new Error(h)}function R(a,h="unexpected state"){if(!a)throw new I.BugIndicatingError(`Assertion Failed: ${h}`)}function A(a){a||(0,I.onUnexpectedError)(new I.BugIndicatingError("Soft Assertion Failed"))}function D(a){if(!a()){debugger;a(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}function v(a,h){let c=0;for(;c<a.length-1;){const p=a[c],f=a[c+1];if(!h(p,f))return!1;c++}return!0}}),define(ue[34],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=A,e.getLocation=c,e.parse=p,e.parseTree=f,e.findNodeAtLocation=g,e.getNodePath=C,e.getNodeValue=w,e.contains=d,e.findNodeAtOffset=m,e.visit=O,e.getNodeType=y;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var b;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(b||(e.SyntaxKind=b={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function A(i,l=!1){let r=0;const n=i.length;let t="",s=0,o=b.Unknown,u=I.None;function S(Y){let te=0,ae=0;for(;te<Y;){const ce=i.charCodeAt(r);if(ce>=h._0&&ce<=h._9)ae=ae*16+ce-h._0;else if(ce>=h.A&&ce<=h.F)ae=ae*16+ce-h.A+10;else if(ce>=h.a&&ce<=h.f)ae=ae*16+ce-h.a+10;else break;r++,te++}return te<Y&&(ae=-1),ae}function T(Y){r=Y,t="",s=0,o=b.Unknown,u=I.None}function N(){const Y=r;if(i.charCodeAt(r)===h._0)r++;else for(r++;r<i.length&&a(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===h.dot)if(r++,r<i.length&&a(i.charCodeAt(r)))for(r++;r<i.length&&a(i.charCodeAt(r));)r++;else return u=I.UnexpectedEndOfNumber,i.substring(Y,r);let te=r;if(r<i.length&&(i.charCodeAt(r)===h.E||i.charCodeAt(r)===h.e))if(r++,(r<i.length&&i.charCodeAt(r)===h.plus||i.charCodeAt(r)===h.minus)&&r++,r<i.length&&a(i.charCodeAt(r))){for(r++;r<i.length&&a(i.charCodeAt(r));)r++;te=r}else u=I.UnexpectedEndOfNumber;return i.substring(Y,te)}function L(){let Y="",te=r;for(;;){if(r>=n){Y+=i.substring(te,r),u=I.UnexpectedEndOfString;break}const ae=i.charCodeAt(r);if(ae===h.doubleQuote){Y+=i.substring(te,r),r++;break}if(ae===h.backslash){if(Y+=i.substring(te,r),r++,r>=n){u=I.UnexpectedEndOfString;break}switch(i.charCodeAt(r++)){case h.doubleQuote:Y+='"';break;case h.backslash:Y+="\\";break;case h.slash:Y+="/";break;case h.b:Y+="\b";break;case h.f:Y+="\f";break;case h.n:Y+=`
`;break;case h.r:Y+="\r";break;case h.t:Y+="	";break;case h.u:{const fe=S(4);fe>=0?Y+=String.fromCharCode(fe):u=I.InvalidUnicode;break}default:u=I.InvalidEscapeCharacter}te=r;continue}if(ae>=0&&ae<=31)if(v(ae)){Y+=i.substring(te,r),u=I.UnexpectedEndOfString;break}else u=I.InvalidCharacter;r++}return Y}function k(){if(t="",u=I.None,s=r,r>=n)return s=n,o=b.EOF;let Y=i.charCodeAt(r);if(D(Y)){do r++,t+=String.fromCharCode(Y),Y=i.charCodeAt(r);while(D(Y));return o=b.Trivia}if(v(Y))return r++,t+=String.fromCharCode(Y),Y===h.carriageReturn&&i.charCodeAt(r)===h.lineFeed&&(r++,t+=`
`),o=b.LineBreakTrivia;switch(Y){case h.openBrace:return r++,o=b.OpenBraceToken;case h.closeBrace:return r++,o=b.CloseBraceToken;case h.openBracket:return r++,o=b.OpenBracketToken;case h.closeBracket:return r++,o=b.CloseBracketToken;case h.colon:return r++,o=b.ColonToken;case h.comma:return r++,o=b.CommaToken;case h.doubleQuote:return r++,t=L(),o=b.StringLiteral;case h.slash:{const te=r-1;if(i.charCodeAt(r+1)===h.slash){for(r+=2;r<n&&!v(i.charCodeAt(r));)r++;return t=i.substring(te,r),o=b.LineCommentTrivia}if(i.charCodeAt(r+1)===h.asterisk){r+=2;const ae=n-1;let ce=!1;for(;r<ae;){if(i.charCodeAt(r)===h.asterisk&&i.charCodeAt(r+1)===h.slash){r+=2,ce=!0;break}r++}return ce||(r++,u=I.UnexpectedEndOfComment),t=i.substring(te,r),o=b.BlockCommentTrivia}return t+=String.fromCharCode(Y),r++,o=b.Unknown}case h.minus:if(t+=String.fromCharCode(Y),r++,r===n||!a(i.charCodeAt(r)))return o=b.Unknown;case h._0:case h._1:case h._2:case h._3:case h._4:case h._5:case h._6:case h._7:case h._8:case h._9:return t+=N(),o=b.NumericLiteral;default:for(;r<n&&U(Y);)r++,Y=i.charCodeAt(r);if(s!==r){switch(t=i.substring(s,r),t){case"true":return o=b.TrueKeyword;case"false":return o=b.FalseKeyword;case"null":return o=b.NullKeyword}return o=b.Unknown}return t+=String.fromCharCode(Y),r++,o=b.Unknown}}function U(Y){if(D(Y)||v(Y))return!1;switch(Y){case h.closeBrace:case h.closeBracket:case h.openBrace:case h.openBracket:case h.doubleQuote:case h.colon:case h.comma:case h.slash:return!1}return!0}function G(){let Y;do Y=k();while(Y>=b.LineCommentTrivia&&Y<=b.Trivia);return Y}return{setPosition:T,getPosition:()=>r,scan:l?G:k,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>r-s,getTokenError:()=>u}}function D(i){return i===h.space||i===h.tab||i===h.verticalTab||i===h.formFeed||i===h.nonBreakingSpace||i===h.ogham||i>=h.enQuad&&i<=h.zeroWidthSpace||i===h.narrowNoBreakSpace||i===h.mathematicalSpace||i===h.ideographicSpace||i===h.byteOrderMark}function v(i){return i===h.lineFeed||i===h.carriageReturn||i===h.lineSeparator||i===h.paragraphSeparator}function a(i){return i>=h._0&&i<=h._9}var h;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(h||(h={}));function c(i,l){const r=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u(S,T,N,L){s.value=S,s.offset=T,s.length=N,s.type=L,s.colonOffset=void 0,t=s}try{O(i,{onObjectBegin:(S,T)=>{if(l<=S)throw n;t=void 0,o=l>S,r.push("")},onObjectProperty:(S,T,N)=>{if(l<T||(u(S,T,N,"property"),r[r.length-1]=S,l<=T+N))throw n},onObjectEnd:(S,T)=>{if(l<=S)throw n;t=void 0,r.pop()},onArrayBegin:(S,T)=>{if(l<=S)throw n;t=void 0,r.push(0)},onArrayEnd:(S,T)=>{if(l<=S)throw n;t=void 0,r.pop()},onLiteralValue:(S,T,N)=>{if(l<T||(u(S,T,N,y(S)),l<=T+N))throw n},onSeparator:(S,T,N)=>{if(l<=T)throw n;if(S===":"&&t&&t.type==="property")t.colonOffset=T,o=!1,t=void 0;else if(S===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(o=!0,r[r.length-1]=""),t=void 0}}})}catch(S){if(S!==n)throw S}return{path:r,previousNode:t,isAtPropertyKey:o,matches:S=>{let T=0;for(let N=0;T<S.length&&N<r.length;N++)if(S[T]===r[N]||S[T]==="*")T++;else if(S[T]!=="**")return!1;return T===S.length}}}function p(i,l=[],r=R.DEFAULT){let n=null,t=[];const s=[];function o(S){Array.isArray(t)?t.push(S):n!==null&&(t[n]=S)}return O(i,{onObjectBegin:()=>{const S={};o(S),s.push(t),t=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const S=[];o(S),s.push(t),t=S,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:o,onError:(S,T,N)=>{l.push({error:S,offset:T,length:N})}},r),t[0]}function f(i,l=[],r=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function s(S){return n.children.push(S),S}O(i,{onObjectBegin:S=>{n=s({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,T,N)=>{n=s({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:T,length:N,parent:n})},onObjectEnd:(S,T)=>{n.length=S+T-n.offset,n=n.parent,t(S+T)},onArrayBegin:(S,T)=>{n=s({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,T)=>{n.length=S+T-n.offset,n=n.parent,t(S+T)},onLiteralValue:(S,T,N)=>{s({type:y(S),offset:T,length:N,parent:n,value:S}),t(T+N)},onSeparator:(S,T,N)=>{n.type==="property"&&(S===":"?n.colonOffset=T:S===","&&t(T))},onError:(S,T,N)=>{l.push({error:S,offset:T,length:N})}},r);const u=n.children[0];return u&&delete u.parent,u}function g(i,l){if(!i)return;let r=i;for(const n of l)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let t=!1;for(const s of r.children)if(Array.isArray(s.children)&&s.children[0].value===n){r=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(r.type!=="array"||t<0||!Array.isArray(r.children)||t>=r.children.length)return;r=r.children[t]}return r}function C(i){if(!i.parent||!i.parent.children)return[];const l=C(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;l.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&l.push(r)}return l}function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const l=Object.create(null);for(const r of i.children){const n=r.children[1];n&&(l[r.children[0].value]=w(n))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function d(i,l,r=!1){return l>=i.offset&&l<i.offset+i.length||r&&l===i.offset+i.length}function m(i,l,r=!1){if(d(i,l,r)){const n=i.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=l;t++){const s=m(n[t],l,r);if(s)return s}return i}}function O(i,l,r=R.DEFAULT){const n=A(i,!1);function t(H){return H?()=>H(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(H){return H?ie=>H(ie,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=t(l.onObjectBegin),u=s(l.onObjectProperty),S=t(l.onObjectEnd),T=t(l.onArrayBegin),N=t(l.onArrayEnd),L=s(l.onLiteralValue),k=s(l.onSeparator),U=t(l.onComment),G=s(l.onError),Y=r&&r.disallowComments,te=r&&r.allowTrailingComma;function ae(){for(;;){const H=n.scan();switch(n.getTokenError()){case I.InvalidUnicode:ce(E.InvalidUnicode);break;case I.InvalidEscapeCharacter:ce(E.InvalidEscapeCharacter);break;case I.UnexpectedEndOfNumber:ce(E.UnexpectedEndOfNumber);break;case I.UnexpectedEndOfComment:Y||ce(E.UnexpectedEndOfComment);break;case I.UnexpectedEndOfString:ce(E.UnexpectedEndOfString);break;case I.InvalidCharacter:ce(E.InvalidCharacter);break}switch(H){case b.LineCommentTrivia:case b.BlockCommentTrivia:Y?ce(E.InvalidCommentToken):U();break;case b.Unknown:ce(E.InvalidSymbol);break;case b.Trivia:case b.LineBreakTrivia:break;default:return H}}}function ce(H,ie=[],ne=[]){if(G(H),ie.length+ne.length>0){let F=n.getToken();for(;F!==b.EOF;){if(ie.indexOf(F)!==-1){ae();break}else if(ne.indexOf(F)!==-1)break;F=ae()}}}function fe(H){const ie=n.getTokenValue();return H?L(ie):u(ie),ae(),!0}function q(){switch(n.getToken()){case b.NumericLiteral:{let H=0;try{H=JSON.parse(n.getTokenValue()),typeof H!="number"&&(ce(E.InvalidNumberFormat),H=0)}catch{ce(E.InvalidNumberFormat)}L(H);break}case b.NullKeyword:L(null);break;case b.TrueKeyword:L(!0);break;case b.FalseKeyword:L(!1);break;default:return!1}return ae(),!0}function Q(){return n.getToken()!==b.StringLiteral?(ce(E.PropertyNameExpected,[],[b.CloseBraceToken,b.CommaToken]),!1):(fe(!1),n.getToken()===b.ColonToken?(k(":"),ae(),K()||ce(E.ValueExpected,[],[b.CloseBraceToken,b.CommaToken])):ce(E.ColonExpected,[],[b.CloseBraceToken,b.CommaToken]),!0)}function z(){o(),ae();let H=!1;for(;n.getToken()!==b.CloseBraceToken&&n.getToken()!==b.EOF;){if(n.getToken()===b.CommaToken){if(H||ce(E.ValueExpected,[],[]),k(","),ae(),n.getToken()===b.CloseBraceToken&&te)break}else H&&ce(E.CommaExpected,[],[]);Q()||ce(E.ValueExpected,[],[b.CloseBraceToken,b.CommaToken]),H=!0}return S(),n.getToken()!==b.CloseBraceToken?ce(E.CloseBraceExpected,[b.CloseBraceToken],[]):ae(),!0}function V(){T(),ae();let H=!1;for(;n.getToken()!==b.CloseBracketToken&&n.getToken()!==b.EOF;){if(n.getToken()===b.CommaToken){if(H||ce(E.ValueExpected,[],[]),k(","),ae(),n.getToken()===b.CloseBracketToken&&te)break}else H&&ce(E.CommaExpected,[],[]);K()||ce(E.ValueExpected,[],[b.CloseBracketToken,b.CommaToken]),H=!0}return N(),n.getToken()!==b.CloseBracketToken?ce(E.CloseBracketExpected,[b.CloseBracketToken],[]):ae(),!0}function K(){switch(n.getToken()){case b.OpenBracketToken:return V();case b.OpenBraceToken:return z();case b.StringLiteral:return fe(!0);default:return q()}}return ae(),n.getToken()===b.EOF?r.allowEmptyContent?!0:(ce(E.ValueExpected,[],[]),!1):K()?(n.getToken()!==b.EOF&&ce(E.EndOfFileExpected,[],[]),!0):(ce(E.ValueExpected,[],[]),!1)}function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ue[76],de([0,1,34]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=b,e.toFormattedString=E,e.getEOL=D,e.isEOL=v;function b(a,h,c){let p,f,g,C,w;if(h){for(C=h.offset,w=C+h.length,g=C;g>0&&!v(a,g-1);)g--;let u=w;for(;u<a.length&&!v(a,u);)u++;f=a.substring(g,u),p=A(f,c)}else f=a,p=0,g=0,C=0,w=a.length;const d=D(c,a);let m=!1,O=0,y;c.insertSpaces?y=R(" ",c.tabSize||4):y="	";const i=(0,I.createScanner)(f,!1);let l=!1;function r(){return d+R(y,p+O)}function n(){let u=i.scan();for(m=!1;u===I.SyntaxKind.Trivia||u===I.SyntaxKind.LineBreakTrivia;)m=m||u===I.SyntaxKind.LineBreakTrivia,u=i.scan();return l=u===I.SyntaxKind.Unknown||i.getTokenError()!==I.ScanError.None,u}const t=[];function s(u,S,T){!l&&S<w&&T>C&&a.substring(S,T)!==u&&t.push({offset:S,length:T-S,content:u})}let o=n();if(o!==I.SyntaxKind.EOF){const u=i.getTokenOffset()+g,S=R(y,p);s(S,g,u)}for(;o!==I.SyntaxKind.EOF;){let u=i.getTokenOffset()+i.getTokenLength()+g,S=n(),T="";for(;!m&&(S===I.SyntaxKind.LineCommentTrivia||S===I.SyntaxKind.BlockCommentTrivia);){const L=i.getTokenOffset()+g;s(" ",u,L),u=i.getTokenOffset()+i.getTokenLength()+g,T=S===I.SyntaxKind.LineCommentTrivia?r():"",S=n()}if(S===I.SyntaxKind.CloseBraceToken)o!==I.SyntaxKind.OpenBraceToken&&(O--,T=r());else if(S===I.SyntaxKind.CloseBracketToken)o!==I.SyntaxKind.OpenBracketToken&&(O--,T=r());else{switch(o){case I.SyntaxKind.OpenBracketToken:case I.SyntaxKind.OpenBraceToken:O++,T=r();break;case I.SyntaxKind.CommaToken:case I.SyntaxKind.LineCommentTrivia:T=r();break;case I.SyntaxKind.BlockCommentTrivia:m?T=r():T=" ";break;case I.SyntaxKind.ColonToken:T=" ";break;case I.SyntaxKind.StringLiteral:if(S===I.SyntaxKind.ColonToken){T="";break}case I.SyntaxKind.NullKeyword:case I.SyntaxKind.TrueKeyword:case I.SyntaxKind.FalseKeyword:case I.SyntaxKind.NumericLiteral:case I.SyntaxKind.CloseBraceToken:case I.SyntaxKind.CloseBracketToken:S===I.SyntaxKind.LineCommentTrivia||S===I.SyntaxKind.BlockCommentTrivia?T=" ":S!==I.SyntaxKind.CommaToken&&S!==I.SyntaxKind.EOF&&(l=!0);break;case I.SyntaxKind.Unknown:l=!0;break}m&&(S===I.SyntaxKind.LineCommentTrivia||S===I.SyntaxKind.BlockCommentTrivia)&&(T=r())}const N=i.getTokenOffset()+g;s(T,u,N),o=S}return t}function E(a,h){const c=JSON.stringify(a,void 0,h.insertSpaces?h.tabSize||4:"	");return h.eol!==void 0?c.replace(/\r\n|\r|\n/g,h.eol):c}function R(a,h){let c="";for(let p=0;p<h;p++)c+=a;return c}function A(a,h){let c=0,p=0;const f=h.tabSize||4;for(;c<a.length;){const g=a.charAt(c);if(g===" ")p++;else if(g==="	")p+=f;else break;c++}return Math.floor(p/f)}function D(a,h){for(let c=0;c<h.length;c++){const p=h.charAt(c);if(p==="\r")return c+1<h.length&&h.charAt(c+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return a&&a.eol||`
`}function v(a,h){return`\r
`.indexOf(a.charAt(h))!==-1}}),define(ue[77],de([0,1,34,76]),function(J,e,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=E,e.setProperty=R,e.withFormatting=A,e.applyEdit=D,e.applyEdits=v;function E(a,h,c){return R(a,h,void 0,c)}function R(a,h,c,p,f){const g=h.slice(),C=[],w=(0,I.parseTree)(a,C);let d,m;for(;g.length>0&&(m=g.pop(),d=(0,I.findNodeAtLocation)(w,g),d===void 0&&c!==void 0);)typeof m=="string"?c={[m]:c}:c=[c];if(d)if(d.type==="object"&&typeof m=="string"&&Array.isArray(d.children)){const O=(0,I.findNodeAtLocation)(d,[m]);if(O!==void 0)if(c===void 0){if(!O.parent)throw new Error("Malformed AST");const y=d.children.indexOf(O.parent);let i,l=O.parent.offset+O.parent.length;if(y>0){const r=d.children[y-1];i=r.offset+r.length}else i=d.offset+1,d.children.length>1&&(l=d.children[1].offset);return A(a,{offset:i,length:l-i,content:""},p)}else return A(a,{offset:O.offset,length:O.length,content:JSON.stringify(c)},p);else{if(c===void 0)return[];const y=`${JSON.stringify(m)}: ${JSON.stringify(c)}`,i=f?f(d.children.map(r=>r.children[0].value)):d.children.length;let l;if(i>0){const r=d.children[i-1];l={offset:r.offset+r.length,length:0,content:","+y}}else d.children.length===0?l={offset:d.offset+1,length:0,content:y}:l={offset:d.offset+1,length:0,content:y+","};return A(a,l,p)}}else if(d.type==="array"&&typeof m=="number"&&Array.isArray(d.children))if(c!==void 0){const O=`${JSON.stringify(c)}`;let y;if(d.children.length===0||m===0)y={offset:d.offset+1,length:0,content:d.children.length===0?O:O+","};else{const i=m===-1||m>d.children.length?d.children.length:m,l=d.children[i-1];y={offset:l.offset+l.length,length:0,content:","+O}}return A(a,y,p)}else{const O=m,y=d.children[O];let i;if(d.children.length===1)i={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===O){const l=d.children[O-1],r=l.offset+l.length,n=d.offset+d.length;i={offset:r,length:n-2-r,content:""}}else i={offset:y.offset,length:d.children[O+1].offset-y.offset,content:""};return A(a,i,p)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${d.type}`);else return c===void 0?[]:A(a,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(c)},p)}function A(a,h,c){let p=D(a,h),f=h.offset,g=h.offset+h.content.length;if(h.length===0||h.content.length===0){for(;f>0&&!(0,b.isEOL)(p,f-1);)f--;for(;g<p.length&&!(0,b.isEOL)(p,g);)g++}const C=(0,b.format)(p,{offset:f,length:g-f},c);for(let d=C.length-1;d>=0;d--){const m=C[d];p=D(p,m),f=Math.min(f,m.offset),g=Math.max(g,m.offset+m.length),g+=m.content.length-m.length}const w=a.length-(p.length-g)-f;return[{offset:f,length:w,content:p.substring(f,g)}]}function D(a,h){return a.substring(0,h.offset)+h.content+a.substring(h.offset+h.length)}function v(a,h){const c=h.slice(0).sort((f,g)=>{const C=f.offset-g.offset;return C===0?f.length-g.length:C});let p=a.length;for(let f=c.length-1;f>=0;f--){const g=c[f];if(g.offset+g.length<=p)a=D(a,g);else throw new Error("Overlapping edit");p=g.offset}return a}}),define(ue[78],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCompressedContent=I;function I(R){let A=!1;const D=new Map,v=new Map;if(E(R,C=>{if(R===C)return!0;const w=JSON.stringify(C);if(w.length<30)return!0;const d=D.get(w);if(!d){const m={schemas:[C]};return D.set(w,m),v.set(C,m),!0}return d.schemas.push(C),v.set(C,d),A=!0,!1}),D.clear(),!A)return JSON.stringify(R);let h="$defs";for(;R.hasOwnProperty(h);)h+="_";const c=[];function p(C){return JSON.stringify(C,(w,d)=>{if(d!==C){const m=v.get(d);if(m&&m.schemas.length>1)return m.id||(m.id=`_${c.length}`,c.push(m.schemas[0])),{$ref:`#/${h}/${m.id}`}}return d})}const f=p(R),g=[];for(let C=0;C<c.length;C++)g.push(`"_${C}":${p(c[C])}`);return g.length?`${f.substring(0,f.length-1)},"${h}":{${g.join(",")}}}`:f}function b(R){return typeof R=="object"&&R!==null}function E(R,A){if(!R||typeof R!="object")return;const D=(...f)=>{for(const g of f)b(g)&&c.push(g)},v=(...f)=>{for(const g of f)if(b(g))for(const C in g){const w=g[C];b(w)&&c.push(w)}},a=(...f)=>{for(const g of f)if(Array.isArray(g))for(const C of g)b(C)&&c.push(C)},h=f=>{if(Array.isArray(f))for(const g of f)b(g)&&c.push(g);else b(f)&&c.push(f)},c=[R];let p=c.pop();for(;p;)A(p)&&(D(p.additionalItems,p.additionalProperties,p.not,p.contains,p.propertyNames,p.if,p.then,p.else,p.unevaluatedItems,p.unevaluatedProperties),v(p.definitions,p.$defs,p.properties,p.patternProperties,p.dependencies,p.dependentSchemas),a(p.anyOf,p.allOf,p.oneOf,p.prefixItems),h(p.items)),p=c.pop()}}),define(ue[79],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=I,e.rot=b,e.isPointWithinTriangle=D;function I(v,a,h){return Math.min(Math.max(v,a),h)}function b(v,a){return(a+v%a)%a}class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class R{constructor(){this._n=1,this._val=0}update(a){return this._val=this._val+(a-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=R;class A{constructor(a){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(a),this._values.fill(0,0,a)}update(a){const h=this._values[this._index];return this._values[this._index]=a,this._index=(this._index+1)%this._values.length,this._sum-=h,this._sum+=a,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A;function D(v,a,h,c,p,f,g,C){const w=g-h,d=C-c,m=p-h,O=f-c,y=v-h,i=a-c,l=w*w+d*d,r=w*m+d*O,n=w*y+d*i,t=m*m+O*O,s=m*y+O*i,o=1/(l*t-r*r),u=(t*n-r*s)*o,S=(l*s-r*n)*o;return u>=0&&S>=0&&u+S<1}}),function(){function J(E){const R=[];typeof E=="number"&&R.push("code/timeOrigin",E);function A(v){R.push(v,Date.now())}function D(){const v=[];for(let a=0;a<R.length;a+=2)v.push({name:R[a],startTime:R[a+1]});return v}return{mark:A,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(E+A.startTime)});return R}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function I(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var b;typeof global=="object"?b=global:typeof self=="object"?b=self:b={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(b)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(b):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),b.perf=I(b))}(),define(ue[56],de([0,1,12]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=R,e.removeDangerousEnvVariables=A;var b;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(b||(e.Source=b={}));var E;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function R(D,...v){const a=v.reduce((p,f)=>(p[f]=!0,p),{}),h=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(p=>!a[p]).forEach(p=>{for(let f=0;f<h.length;f++)if(p.search(h[f])!==-1){delete D[p];break}})}function A(D){D&&(delete D.DEBUG,I.isLinux&&delete D.LD_PRELOAD)}}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var b in I)(typeof exports=="object"?exports:J)[b]=I[b]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function I(b){if(e[b])return e[b].exports;var E=e[b]={i:b,l:!1,exports:{}};return J[b].call(E.exports,E,E.exports,I),E.l=!0,E.exports}return I.m=J,I.c=e,I.d=function(b,E,R){I.o(b,E)||Object.defineProperty(b,E,{enumerable:!0,get:R})},I.r=function(b){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(b,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(b,"__esModule",{value:!0})},I.t=function(b,E){if(1&E&&(b=I(b)),8&E||4&E&&typeof b=="object"&&b&&b.__esModule)return b;var R=Object.create(null);if(I.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:b}),2&E&&typeof b!="string")for(var A in b)I.d(R,A,function(D){return b[D]}.bind(null,A));return R},I.n=function(b){var E=b&&b.__esModule?function(){return b.default}:function(){return b};return I.d(E,"a",E),E},I.o=function(b,E){return Object.prototype.hasOwnProperty.call(b,E)},I.p="",I(I.s=0)}([function(J,e,I){(function(b){var E;e=J.exports=F,E=typeof b=="object"&&b.env&&b.env.NODE_DEBUG&&/\bsemver\b/i.test(b.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],v=e.src=[],a=0,h=a++;v[h]="0|[1-9]\\d*";var c=a++;v[c]="[0-9]+";var p=a++;v[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=a++;v[f]="("+v[h]+")\\.("+v[h]+")\\.("+v[h]+")";var g=a++;v[g]="("+v[c]+")\\.("+v[c]+")\\.("+v[c]+")";var C=a++;v[C]="(?:"+v[h]+"|"+v[p]+")";var w=a++;v[w]="(?:"+v[c]+"|"+v[p]+")";var d=a++;v[d]="(?:-("+v[C]+"(?:\\."+v[C]+")*))";var m=a++;v[m]="(?:-?("+v[w]+"(?:\\."+v[w]+")*))";var O=a++;v[O]="[0-9A-Za-z-]+";var y=a++;v[y]="(?:\\+("+v[O]+"(?:\\."+v[O]+")*))";var i=a++,l="v?"+v[f]+v[d]+"?"+v[y]+"?";v[i]="^"+l+"$";var r="[v=\\s]*"+v[g]+v[m]+"?"+v[y]+"?",n=a++;v[n]="^"+r+"$";var t=a++;v[t]="((?:<|>)?=?)";var s=a++;v[s]=v[c]+"|x|X|\\*";var o=a++;v[o]=v[h]+"|x|X|\\*";var u=a++;v[u]="[v=\\s]*("+v[o]+")(?:\\.("+v[o]+")(?:\\.("+v[o]+")(?:"+v[d]+")?"+v[y]+"?)?)?";var S=a++;v[S]="[v=\\s]*("+v[s]+")(?:\\.("+v[s]+")(?:\\.("+v[s]+")(?:"+v[m]+")?"+v[y]+"?)?)?";var T=a++;v[T]="^"+v[t]+"\\s*"+v[u]+"$";var N=a++;v[N]="^"+v[t]+"\\s*"+v[S]+"$";var L=a++;v[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var k=a++;v[k]="(?:~>?)";var U=a++;v[U]="(\\s*)"+v[k]+"\\s+",D[U]=new RegExp(v[U],"g");var G=a++;v[G]="^"+v[k]+v[u]+"$";var Y=a++;v[Y]="^"+v[k]+v[S]+"$";var te=a++;v[te]="(?:\\^)";var ae=a++;v[ae]="(\\s*)"+v[te]+"\\s+",D[ae]=new RegExp(v[ae],"g");var ce=a++;v[ce]="^"+v[te]+v[u]+"$";var fe=a++;v[fe]="^"+v[te]+v[S]+"$";var q=a++;v[q]="^"+v[t]+"\\s*("+r+")$|^$";var Q=a++;v[Q]="^"+v[t]+"\\s*("+l+")$|^$";var z=a++;v[z]="(\\s*)"+v[t]+"\\s*("+r+"|"+v[u]+")",D[z]=new RegExp(v[z],"g");var V=a++;v[V]="^\\s*("+v[u]+")\\s+-\\s+("+v[u]+")\\s*$";var K=a++;v[K]="^\\s*("+v[S]+")\\s+-\\s+("+v[S]+")\\s*$";var H=a++;v[H]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)E(ie,v[ie]),D[ie]||(D[ie]=new RegExp(v[ie]));function ne(j,Z){if(j instanceof F)return j;if(typeof j!="string"||j.length>R||!(Z?D[n]:D[i]).test(j))return null;try{return new F(j,Z)}catch{return null}}function F(j,Z){if(j instanceof F){if(j.loose===Z)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof F))return new F(j,Z);E("SemVer",j,Z),this.loose=Z;var ee=j.trim().match(Z?D[n]:D[i]);if(!ee)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ie=+Se;if(Ie>=0&&Ie<A)return Ie}return Se}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=ne,e.valid=function(j,Z){var ee=ne(j,Z);return ee?ee.version:null},e.clean=function(j,Z){var ee=ne(j.trim().replace(/^[=v]+/,""),Z);return ee?ee.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(j){return E("SemVer.compare",this.version,this.loose,j),j instanceof F||(j=new F(j,this.loose)),this.compareMain(j)||this.comparePre(j)},F.prototype.compareMain=function(j){return j instanceof F||(j=new F(j,this.loose)),_(this.major,j.major)||_(this.minor,j.minor)||_(this.patch,j.patch)},F.prototype.comparePre=function(j){if(j instanceof F||(j=new F(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var Z=0;do{var ee=this.prerelease[Z],Se=j.prerelease[Z];if(E("prerelease compare",Z,ee,Se),ee===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(ee===void 0)return-1;if(ee!==Se)return _(ee,Se)}while(++Z)},F.prototype.inc=function(j,Z){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,Z,ee,Se){typeof ee=="string"&&(Se=ee,ee=void 0);try{return new F(j,ee).inc(Z,Se).version}catch{return null}},e.diff=function(j,Z){if(x(j,Z))return null;var ee=ne(j),Se=ne(Z);if(ee.prerelease.length||Se.prerelease.length){for(var Ie in ee)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ee[Ie]!==Se[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ee)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ee[Ie]!==Se[Ie])return Ie},e.compareIdentifiers=_;var $=/^[0-9]+$/;function _(j,Z){var ee=$.test(j),Se=$.test(Z);return ee&&Se&&(j=+j,Z=+Z),ee&&!Se?-1:Se&&!ee?1:j<Z?-1:j>Z?1:0}function P(j,Z,ee){return new F(j,ee).compare(new F(Z,ee))}function M(j,Z,ee){return P(j,Z,ee)>0}function X(j,Z,ee){return P(j,Z,ee)<0}function x(j,Z,ee){return P(j,Z,ee)===0}function W(j,Z,ee){return P(j,Z,ee)!==0}function B(j,Z,ee){return P(j,Z,ee)>=0}function re(j,Z,ee){return P(j,Z,ee)<=0}function oe(j,Z,ee,Se){var Ie;switch(Z){case"===":typeof j=="object"&&(j=j.version),typeof ee=="object"&&(ee=ee.version),Ie=j===ee;break;case"!==":typeof j=="object"&&(j=j.version),typeof ee=="object"&&(ee=ee.version),Ie=j!==ee;break;case"":case"=":case"==":Ie=x(j,ee,Se);break;case"!=":Ie=W(j,ee,Se);break;case">":Ie=M(j,ee,Se);break;case">=":Ie=B(j,ee,Se);break;case"<":Ie=X(j,ee,Se);break;case"<=":Ie=re(j,ee,Se);break;default:throw new TypeError("Invalid operator: "+Z)}return Ie}function le(j,Z){if(j instanceof le){if(j.loose===Z)return j;j=j.value}if(!(this instanceof le))return new le(j,Z);E("comparator",j,Z),this.loose=Z,this.parse(j),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(j,Z){return _(Z,j)},e.major=function(j,Z){return new F(j,Z).major},e.minor=function(j,Z){return new F(j,Z).minor},e.patch=function(j,Z){return new F(j,Z).patch},e.compare=P,e.compareLoose=function(j,Z){return P(j,Z,!0)},e.rcompare=function(j,Z,ee){return P(Z,j,ee)},e.sort=function(j,Z){return j.sort(function(ee,Se){return e.compare(ee,Se,Z)})},e.rsort=function(j,Z){return j.sort(function(ee,Se){return e.rcompare(ee,Se,Z)})},e.gt=M,e.lt=X,e.eq=x,e.neq=W,e.gte=B,e.lte=re,e.cmp=oe,e.Comparator=le;var ye={};function he(j,Z){if(j instanceof he)return j.loose===Z?j:new he(j.raw,Z);if(j instanceof le)return new he(j.value,Z);if(!(this instanceof he))return new he(j,Z);if(this.loose=Z,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function ve(j){return!j||j.toLowerCase()==="x"||j==="*"}function ge(j,Z,ee,Se,Ie,ke,Re,Ne,Oe,Ae,We,Le,Fe){return((Z=ve(ee)?"":ve(Se)?">="+ee+".0.0":ve(Ie)?">="+ee+"."+Se+".0":">="+Z)+" "+(Ne=ve(Oe)?"":ve(Ae)?"<"+(+Oe+1)+".0.0":ve(We)?"<"+Oe+"."+(+Ae+1)+".0":Le?"<="+Oe+"."+Ae+"."+We+"-"+Le:"<="+Ne)).trim()}function pe(j,Z){for(var ee=0;ee<j.length;ee++)if(!j[ee].test(Z))return!1;if(Z.prerelease.length){for(ee=0;ee<j.length;ee++)if(E(j[ee].semver),j[ee].semver!==ye&&j[ee].semver.prerelease.length>0){var Se=j[ee].semver;if(Se.major===Z.major&&Se.minor===Z.minor&&Se.patch===Z.patch)return!0}return!1}return!0}function me(j,Z,ee){try{Z=new he(Z,ee)}catch{return!1}return Z.test(j)}function Pe(j,Z,ee,Se){var Ie,ke,Re,Ne,Oe;switch(j=new F(j,Se),Z=new he(Z,Se),ee){case">":Ie=M,ke=re,Re=X,Ne=">",Oe=">=";break;case"<":Ie=X,ke=B,Re=M,Ne="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(j,Z,Se))return!1;for(var Ae=0;Ae<Z.set.length;++Ae){var We=Z.set[Ae],Le=null,Fe=null;if(We.forEach(function(xe){xe.semver===ye&&(xe=new le(">=0.0.0")),Le=Le||xe,Fe=Fe||xe,Ie(xe.semver,Le.semver,Se)?Le=xe:Re(xe.semver,Fe.semver,Se)&&(Fe=xe)}),Le.operator===Ne||Le.operator===Oe||(!Fe.operator||Fe.operator===Ne)&&ke(j,Fe.semver)||Fe.operator===Oe&&Re(j,Fe.semver))return!1}return!0}le.prototype.parse=function(j){var Z=this.loose?D[q]:D[Q],ee=j.match(Z);if(!ee)throw new TypeError("Invalid comparator: "+j);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new F(ee[2],this.loose):this.semver=ye},le.prototype.toString=function(){return this.value},le.prototype.test=function(j){return E("Comparator.test",j,this.loose),this.semver===ye||(typeof j=="string"&&(j=new F(j,this.loose)),oe(j,this.operator,this.semver,this.loose))},le.prototype.intersects=function(j,Z){if(!(j instanceof le))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new he(j.value,Z),me(this.value,ee,Z);if(j.operator==="")return ee=new he(this.value,Z),me(j.semver,ee,Z);var Se=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),ke=this.semver.version===j.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ne=oe(this.semver,"<",j.semver,Z)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),Oe=oe(this.semver,">",j.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return Se||Ie||ke&&Re||Ne||Oe},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(j){var Z=this.loose;j=j.trim(),E("range",j,Z);var ee=Z?D[K]:D[V];j=j.replace(ee,ge),E("hyphen replace",j),j=j.replace(D[z],"$1$2$3"),E("comparator trim",j,D[z]),j=(j=(j=j.replace(D[U],"$1~")).replace(D[ae],"$1^")).split(/\s+/).join(" ");var Se=Z?D[q]:D[Q],Ie=j.split(" ").map(function(ke){return function(Re,Ne){return E("comp",Re),Re=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(We){return function(Le,Fe){E("caret",Le,Fe);var xe=Fe?D[fe]:D[ce];return Le.replace(xe,function(Ue,be,Ce,De,Te){var Me;return E("caret",Le,Ue,be,Ce,De,Te),ve(be)?Me="":ve(Ce)?Me=">="+be+".0.0 <"+(+be+1)+".0.0":ve(De)?Me=be==="0"?">="+be+"."+Ce+".0 <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+".0 <"+(+be+1)+".0.0":Te?(E("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Me=be==="0"?Ce==="0"?">="+be+"."+Ce+"."+De+Te+" <"+be+"."+Ce+"."+(+De+1):">="+be+"."+Ce+"."+De+Te+" <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+"."+De+Te+" <"+(+be+1)+".0.0"):(E("no pr"),Me=be==="0"?Ce==="0"?">="+be+"."+Ce+"."+De+" <"+be+"."+Ce+"."+(+De+1):">="+be+"."+Ce+"."+De+" <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+"."+De+" <"+(+be+1)+".0.0"),E("caret return",Me),Me})}(We,Ae)}).join(" ")}(Re,Ne),E("caret",Re),Re=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(We){return function(Le,Fe){var xe=Fe?D[Y]:D[G];return Le.replace(xe,function(Ue,be,Ce,De,Te){var Me;return E("tilde",Le,Ue,be,Ce,De,Te),ve(be)?Me="":ve(Ce)?Me=">="+be+".0.0 <"+(+be+1)+".0.0":ve(De)?Me=">="+be+"."+Ce+".0 <"+be+"."+(+Ce+1)+".0":Te?(E("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Me=">="+be+"."+Ce+"."+De+Te+" <"+be+"."+(+Ce+1)+".0"):Me=">="+be+"."+Ce+"."+De+" <"+be+"."+(+Ce+1)+".0",E("tilde return",Me),Me})}(We,Ae)}).join(" ")}(Re,Ne),E("tildes",Re),Re=function(Oe,Ae){return E("replaceXRanges",Oe,Ae),Oe.split(/\s+/).map(function(We){return function(Le,Fe){Le=Le.trim();var xe=Fe?D[N]:D[T];return Le.replace(xe,function(Ue,be,Ce,De,Te,Me){E("xRange",Le,Ue,be,Ce,De,Te,Me);var je=ve(Ce),_e=je||ve(De),ze=_e||ve(Te);return be==="="&&ze&&(be=""),je?Ue=be===">"||be==="<"?"<0.0.0":"*":be&&ze?(_e&&(De=0),ze&&(Te=0),be===">"?(be=">=",_e?(Ce=+Ce+1,De=0,Te=0):ze&&(De=+De+1,Te=0)):be==="<="&&(be="<",_e?Ce=+Ce+1:De=+De+1),Ue=be+Ce+"."+De+"."+Te):_e?Ue=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":ze&&(Ue=">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0"),E("xRange return",Ue),Ue})}(We,Ae)}).join(" ")}(Re,Ne),E("xrange",Re),Re=function(Oe,Ae){return E("replaceStars",Oe,Ae),Oe.trim().replace(D[H],"")}(Re,Ne),E("stars",Re),Re}(ke,Z)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(ke){return!!ke.match(Se)})),Ie=Ie.map(function(ke){return new le(ke,Z)})},he.prototype.intersects=function(j,Z){if(!(j instanceof he))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(Se){return j.set.some(function(Ie){return Ie.every(function(ke){return Se.intersects(ke,Z)})})})})},e.toComparators=function(j,Z){return new he(j,Z).set.map(function(ee){return ee.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},he.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new F(j,this.loose));for(var Z=0;Z<this.set.length;Z++)if(pe(this.set[Z],j))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(j,Z,ee){var Se=null,Ie=null;try{var ke=new he(Z,ee)}catch{return null}return j.forEach(function(Re){ke.test(Re)&&(Se&&Ie.compare(Re)!==-1||(Ie=new F(Se=Re,ee)))}),Se},e.minSatisfying=function(j,Z,ee){var Se=null,Ie=null;try{var ke=new he(Z,ee)}catch{return null}return j.forEach(function(Re){ke.test(Re)&&(Se&&Ie.compare(Re)!==1||(Ie=new F(Se=Re,ee)))}),Se},e.validRange=function(j,Z){try{return new he(j,Z).range||"*"}catch{return null}},e.ltr=function(j,Z,ee){return Pe(j,Z,"<",ee)},e.gtr=function(j,Z,ee){return Pe(j,Z,">",ee)},e.outside=Pe,e.prerelease=function(j,Z){var ee=ne(j,Z);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(j,Z,ee){return j=new he(j,ee),Z=new he(Z,ee),j.intersects(Z)},e.coerce=function(j){if(j instanceof F)return j;if(typeof j!="string")return null;var Z=j.match(D[L]);return Z==null?null:ne((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,I(1))},function(J,e){var I,b,E=J.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function D(w){if(I===setTimeout)return setTimeout(w,0);if((I===R||!I)&&setTimeout)return I=setTimeout,setTimeout(w,0);try{return I(w,0)}catch{try{return I.call(null,w,0)}catch{return I.call(this,w,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:R}catch{I=R}try{b=typeof clearTimeout=="function"?clearTimeout:A}catch{b=A}})();var v,a=[],h=!1,c=-1;function p(){h&&v&&(h=!1,v.length?a=v.concat(a):c=-1,a.length&&f())}function f(){if(!h){var w=D(p);h=!0;for(var d=a.length;d;){for(v=a,a=[];++c<d;)v&&v[c].run();c=-1,d=a.length}v=null,h=!1,function(m){if(b===clearTimeout)return clearTimeout(m);if((b===A||!b)&&clearTimeout)return b=clearTimeout,clearTimeout(m);try{b(m)}catch{try{return b.call(null,m)}catch{return b.call(this,m)}}}(w)}}function g(w,d){this.fun=w,this.array=d}function C(){}E.nextTick=function(w){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];a.push(new g(w,d)),a.length!==1||h||D(f)},g.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=C,E.addListener=C,E.once=C,E.off=C,E.removeListener=C,E.removeAllListeners=C,E.emit=C,E.prependListener=C,E.prependOnceListener=C,E.listeners=function(w){return[]},E.binding=function(w){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(w){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(ue[80],de([0,1]),function(J,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class b{constructor(D,v,a){this.level=D,this.key=v,this.value=a,this.forward=[]}}const E=void 0;class R{constructor(D,v=2**16){this.comparator=D,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(v)|0),this._header=new b(this._maxLevel,E,E)}get size(){return this._size}clear(){this._header=new b(this._maxLevel,E,E),this._size=0}has(D){return!!R._search(this,D,this.comparator)}get(D){return R._search(this,D,this.comparator)?.value}set(D,v){return R._insert(this,D,v,this.comparator)&&(this._size+=1),this}delete(D){const v=R._delete(this,D,this.comparator);return v&&(this._size-=1),v}forEach(D,v){let a=this._header.forward[0];for(;a;)D.call(v,a.value,a.key,this),a=a.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",v=this._header.forward[0];for(;v;)D+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return D}static _search(D,v,a){let h=D._header;for(let c=D._level-1;c>=0;c--)for(;h.forward[c]&&a(h.forward[c].key,v)<0;)h=h.forward[c];if(h=h.forward[0],h&&a(h.key,v)===0)return h}static _insert(D,v,a,h){const c=[];let p=D._header;for(let f=D._level-1;f>=0;f--){for(;p.forward[f]&&h(p.forward[f].key,v)<0;)p=p.forward[f];c[f]=p}if(p=p.forward[0],p&&h(p.key,v)===0)return p.value=a,!1;{const f=R._randomLevel(D);if(f>D._level){for(let g=D._level;g<f;g++)c[g]=D._header;D._level=f}p=new b(f,v,a);for(let g=0;g<f;g++)p.forward[g]=c[g].forward[g],c[g].forward[g]=p;return!0}}static _randomLevel(D,v=.5){let a=1;for(;Math.random()<v&&a<D._maxLevel;)a+=1;return a}static _delete(D,v,a){const h=[];let c=D._header;for(let p=D._level-1;p>=0;p--){for(;c.forward[p]&&a(c.forward[p].key,v)<0;)c=c.forward[p];h[p]=c}if(c=c.forward[0],!c||a(c.key,v)!==0)return!1;for(let p=0;p<D._level&&h[p].forward[p]===c;p++)h[p].forward[p]=c.forward[p];for(;D._level>0&&D._header.forward[D._level-1]===E;)D._level-=1;return!0}}e.SkipList=R}),define(ue[47],de([0,1,7,2]),function(J,e,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=E,e.isReadableStream=R,e.isReadableBufferedStream=A,e.newWriteableStream=D,e.consumeReadable=a,e.peekReadable=h,e.consumeStream=c,e.listenStream=p,e.peekStream=f,e.toStream=g,e.emptyStream=C,e.toReadable=w,e.transform=d,e.prefixedReadable=m,e.prefixedStream=O;function E(y){const i=y;return i?typeof i.read=="function":!1}function R(y){const i=y;return i?[i.on,i.pause,i.resume,i.destroy].every(l=>typeof l=="function"):!1}function A(y){const i=y;return i?R(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function D(y,i){return new v(y,i)}class v{constructor(i,l){this.reducer=i,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(i){if(!this.state.destroyed){if(this.state.flowing)this.emitData(i);else if(this.buffer.data.push(i),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(i){this.state.destroyed||(this.state.flowing?this.emitError(i):this.buffer.error.push(i))}end(i){this.state.destroyed||(typeof i<"u"&&this.write(i),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(i){this.listeners.data.slice(0).forEach(l=>l(i))}emitError(i){this.listeners.error.length===0?(0,I.onUnexpectedError)(i):this.listeners.error.slice(0).forEach(l=>l(i))}emitEnd(){this.listeners.end.slice(0).forEach(i=>i())}on(i,l){if(!this.state.destroyed)switch(i){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(i,l){if(this.state.destroyed)return;let r;switch(i){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const n=r.indexOf(l);n>=0&&r.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const i=this.reducer(this.buffer.data);this.emitData(i),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const i of this.buffer.error)this.emitError(i);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(y,i){const l=[];let r;for(;(r=y.read())!==null;)l.push(r);return i(l)}function h(y,i,l){const r=[];let n;for(;(n=y.read())!==null&&r.length<l;)r.push(n);return n===null&&r.length>0?i(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return y.read()}}}function c(y,i){return new Promise((l,r)=>{const n=[];p(y,{onData:t=>{i&&n.push(t)},onError:t=>{i?r(t):l(void 0)},onEnd:()=>{l(i?i(n):void 0)}})})}function p(y,i,l){y.on("error",r=>{l?.isCancellationRequested||i.onError(r)}),y.on("end",()=>{l?.isCancellationRequested||i.onEnd()}),y.on("data",r=>{l?.isCancellationRequested||i.onData(r)})}function f(y,i){return new Promise((l,r)=>{const n=new b.DisposableStore,t=[],s=S=>{if(t.push(S),t.length>i)return n.dispose(),y.pause(),l({stream:y,buffer:t,ended:!1})},o=S=>(n.dispose(),r(S)),u=()=>(n.dispose(),l({stream:y,buffer:t,ended:!0}));n.add((0,b.toDisposable)(()=>y.removeListener("error",o))),y.on("error",o),n.add((0,b.toDisposable)(()=>y.removeListener("end",u))),y.on("end",u),n.add((0,b.toDisposable)(()=>y.removeListener("data",s))),y.on("data",s)})}function g(y,i){const l=D(i);return l.end(y),l}function C(){const y=D(()=>{throw new Error("not supported")});return y.end(),y}function w(y){let i=!1;return{read:()=>i?null:(i=!0,y)}}function d(y,i,l){const r=D(l);return p(y,{onData:n=>r.write(i.data(n)),onError:n=>r.error(i.error?i.error(n):n),onEnd:()=>r.end()}),r}function m(y,i,l){let r=!1;return{read:()=>{const n=i.read();return r?n:(r=!0,n!==null?l([y,n]):y)}}}function O(y,i,l){let r=!1;const n=D(l);return p(i,{onData:t=>r?n.write(t):(r=!0,n.write(l([y,t]))),onError:t=>n.error(t),onEnd:()=>{r||(r=!0,n.write(y)),n.end()}}),n}});var $e=this&&this.__createBinding||(Object.create?function(J,e,I,b){b===void 0&&(b=I);var E=Object.getOwnPropertyDescriptor(e,I);(!E||("get"in E?!e.__esModule:E.writable||E.configurable))&&(E={enumerable:!0,get:function(){return e[I]}}),Object.defineProperty(J,b,E)}:function(J,e,I,b){b===void 0&&(b=I),J[b]=e[I]}),Be=this&&this.__setModuleDefault||(Object.create?function(J,e){Object.defineProperty(J,"default",{enumerable:!0,value:e})}:function(J,e){J.default=e}),Ee=this&&this.__importStar||function(J){if(J&&J.__esModule)return J;var e={};if(J!=null)for(var I in J)I!=="default"&&Object.prototype.hasOwnProperty.call(J,I)&&$e(e,J,I);return Be(e,J),e};define(ue[13],de([0,1,146,47]),function(J,e,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=a,e.readUInt16LE=h,e.writeUInt16LE=c,e.readUInt32BE=p,e.writeUInt32BE=f,e.readUInt32LE=g,e.writeUInt32LE=C,e.readUInt8=w,e.writeUInt8=d,e.readableToBuffer=m,e.bufferToReadable=O,e.streamToBuffer=y,e.bufferedStreamToBuffer=i,e.bufferToStream=l,e.streamToBufferReadableStream=r,e.newWriteableBufferStream=n,e.prefixedBufferReadable=t,e.prefixedBufferStream=s,e.decodeBase64=o,e.encodeBase64=T,b=Ee(b);const E=typeof Buffer<"u",R=new I.Lazy(()=>new Uint8Array(256));let A,D;class v{static alloc(L){return E?new v(Buffer.allocUnsafe(L)):new v(new Uint8Array(L))}static wrap(L){return E&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new v(L)}static fromString(L,k){return!(k?.dontUseNodeBuffer||!1)&&E?new v(Buffer.from(L)):(A||(A=new TextEncoder),new v(A.encode(L)))}static fromByteArray(L){const k=v.alloc(L.length);for(let U=0,G=L.length;U<G;U++)k.buffer[U]=L[U];return k}static concat(L,k){if(typeof k>"u"){k=0;for(let Y=0,te=L.length;Y<te;Y++)k+=L[Y].byteLength}const U=v.alloc(k);let G=0;for(let Y=0,te=L.length;Y<te;Y++){const ae=L[Y];U.set(ae,G),G+=ae.byteLength}return U}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=v.alloc(this.byteLength);return L.set(this),L}toString(){return E?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(L,k){return new v(this.buffer.subarray(L,k))}set(L,k){if(L instanceof v)this.buffer.set(L.buffer,k);else if(L instanceof Uint8Array)this.buffer.set(L,k);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),k);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return p(this.buffer,L)}writeUInt32BE(L,k){f(this.buffer,L,k)}readUInt32LE(L){return g(this.buffer,L)}writeUInt32LE(L,k){C(this.buffer,L,k)}readUInt8(L){return w(this.buffer,L)}writeUInt8(L,k){d(this.buffer,L,k)}indexOf(L,k=0){return a(this.buffer,L instanceof v?L.buffer:L,k)}}e.VSBuffer=v;function a(N,L,k=0){const U=L.byteLength,G=N.byteLength;if(U===0)return 0;if(U===1)return N.indexOf(L[0]);if(U>G-k)return-1;const Y=R.value;Y.fill(L.length);for(let fe=0;fe<L.length;fe++)Y[L[fe]]=L.length-fe-1;let te=k+L.length-1,ae=te,ce=-1;for(;te<G;)if(N[te]===L[ae]){if(ae===0){ce=te;break}te--,ae--}else te+=Math.max(L.length-ae,Y[N[te]]),ae=L.length-1;return ce}function h(N,L){return N[L+0]<<0>>>0|N[L+1]<<8>>>0}function c(N,L,k){N[k+0]=L&255,L=L>>>8,N[k+1]=L&255}function p(N,L){return N[L]*2**24+N[L+1]*2**16+N[L+2]*2**8+N[L+3]}function f(N,L,k){N[k+3]=L,L=L>>>8,N[k+2]=L,L=L>>>8,N[k+1]=L,L=L>>>8,N[k]=L}function g(N,L){return N[L+0]<<0>>>0|N[L+1]<<8>>>0|N[L+2]<<16>>>0|N[L+3]<<24>>>0}function C(N,L,k){N[k+0]=L&255,L=L>>>8,N[k+1]=L&255,L=L>>>8,N[k+2]=L&255,L=L>>>8,N[k+3]=L&255}function w(N,L){return N[L]}function d(N,L,k){N[k]=L}function m(N){return b.consumeReadable(N,L=>v.concat(L))}function O(N){return b.toReadable(N)}function y(N){return b.consumeStream(N,L=>v.concat(L))}async function i(N){return N.ended?v.concat(N.buffer):v.concat([...N.buffer,await y(N.stream)])}function l(N){return b.toStream(N,L=>v.concat(L))}function r(N){return b.transform(N,{data:L=>typeof L=="string"?v.fromString(L):v.wrap(L)},L=>v.concat(L))}function n(N){return b.newWriteableStream(L=>v.concat(L),N)}function t(N,L){return b.prefixedReadable(N,L,k=>v.concat(k))}function s(N,L){return b.prefixedStream(N,L,k=>v.concat(k))}function o(N){let L=0,k=0,U=0;const G=new Uint8Array(Math.floor(N.length/4*3)),Y=ae=>{switch(k){case 3:G[U++]=L|ae,k=0;break;case 2:G[U++]=L|ae>>>2,L=ae<<6,k=3;break;case 1:G[U++]=L|ae>>>4,L=ae<<4,k=2;break;default:L=ae<<2,k=1}};for(let ae=0;ae<N.length;ae++){const ce=N.charCodeAt(ae);if(ce>=65&&ce<=90)Y(ce-65);else if(ce>=97&&ce<=122)Y(ce-97+26);else if(ce>=48&&ce<=57)Y(ce-48+52);else if(ce===43||ce===45)Y(62);else if(ce===47||ce===95)Y(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${N[ae]}`)}}const te=U;for(;k>0;)Y(0);return v.wrap(G).slice(0,te)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function T({buffer:N},L=!0,k=!1){const U=k?S:u;let G="";const Y=N.byteLength%3;let te=0;for(;te<N.byteLength-Y;te+=3){const ae=N[te+0],ce=N[te+1],fe=N[te+2];G+=U[ae>>>2],G+=U[(ae<<4|ce>>>4)&63],G+=U[(ce<<2|fe>>>6)&63],G+=U[fe&63]}if(Y===1){const ae=N[te+0];G+=U[ae>>>2],G+=U[ae<<4&63],L&&(G+="==")}else if(Y===2){const ae=N[te+0],ce=N[te+1];G+=U[ae>>>2],G+=U[(ae<<4|ce>>>4)&63],G+=U[ce<<2&63],L&&(G+="=")}return G}}),define(ue[27],de([0,1,3]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=b,e.deepFreeze=E,e.cloneAndChange=A,e.mixin=v,e.equals=a,e.safeStringify=h,e.distinct=c,e.getCaseInsensitive=p,e.filter=f,e.getAllPropertyNames=g,e.getAllMethodNames=C,e.createProxyObject=w,e.mapValues=d;function b(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const O=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([y,i])=>{O[y]=i&&typeof i=="object"?b(i):i}),O}function E(m){if(!m||typeof m!="object")return m;const O=[m];for(;O.length>0;){const y=O.shift();Object.freeze(y);for(const i in y)if(R.call(y,i)){const l=y[i];typeof l=="object"&&!Object.isFrozen(l)&&!(0,I.isTypedArray)(l)&&O.push(l)}}return m}const R=Object.prototype.hasOwnProperty;function A(m,O){return D(m,O,new Set)}function D(m,O,y){if((0,I.isUndefinedOrNull)(m))return m;const i=O(m);if(typeof i<"u")return i;if(Array.isArray(m)){const l=[];for(const r of m)l.push(D(r,O,y));return l}if((0,I.isObject)(m)){if(y.has(m))throw new Error("Cannot clone recursive data-structure");y.add(m);const l={};for(const r in m)R.call(m,r)&&(l[r]=D(m[r],O,y));return y.delete(m),l}return m}function v(m,O,y=!0){return(0,I.isObject)(m)?((0,I.isObject)(O)&&Object.keys(O).forEach(i=>{i in m?y&&((0,I.isObject)(m[i])&&(0,I.isObject)(O[i])?v(m[i],O[i],y):m[i]=O[i]):m[i]=O[i]}),m):O}function a(m,O){if(m===O)return!0;if(m==null||O===null||O===void 0||typeof m!=typeof O||typeof m!="object"||Array.isArray(m)!==Array.isArray(O))return!1;let y,i;if(Array.isArray(m)){if(m.length!==O.length)return!1;for(y=0;y<m.length;y++)if(!a(m[y],O[y]))return!1}else{const l=[];for(i in m)l.push(i);l.sort();const r=[];for(i in O)r.push(i);if(r.sort(),!a(l,r))return!1;for(y=0;y<l.length;y++)if(!a(m[l[y]],O[l[y]]))return!1}return!0}function h(m){const O=new Set;return JSON.stringify(m,(y,i)=>{if((0,I.isObject)(i)||Array.isArray(i)){if(O.has(i))return"[Circular]";O.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function c(m,O){const y=Object.create(null);return!m||!O||Object.keys(O).forEach(l=>{const r=m[l],n=O[l];a(r,n)||(y[l]=n)}),y}function p(m,O){const y=O.toLowerCase(),i=Object.keys(m).find(l=>l.toLowerCase()===y);return i?m[i]:m[O]}function f(m,O){const y=Object.create(null);for(const[i,l]of Object.entries(m))O(i,l)&&(y[i]=l);return y}function g(m){let O=[];for(;Object.prototype!==m;)O=O.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return O}function C(m){const O=[];for(const y of g(m))typeof m[y]=="function"&&O.push(y);return O}function w(m,O){const y=l=>function(){const r=Array.prototype.slice.call(arguments,0);return O(l,r)},i={};for(const l of m)i[l]=y(l);return i}function d(m,O){const y={};for(const[i,l]of Object.entries(m))y[i]=O(l,i);return y}}),define(ue[43],de([0,1,31]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=b,e.doHash=E,e.numberHash=R,e.stringHash=D,e.toHexString=C,I=Ee(I);function b(d){return E(d,0)}function E(d,m){switch(typeof d){case"object":return d===null?R(349,m):Array.isArray(d)?v(d,m):a(d,m);case"string":return D(d,m);case"boolean":return A(d,m);case"number":return R(d,m);case"undefined":return R(937,m);default:return R(617,m)}}function R(d,m){return(m<<5)-m+d|0}function A(d,m){return R(d?433:863,m)}function D(d,m){m=R(149417,m);for(let O=0,y=d.length;O<y;O++)m=R(d.charCodeAt(O),m);return m}function v(d,m){return m=R(104579,m),d.reduce((O,y)=>E(y,O),m)}function a(d,m){return m=R(181387,m),Object.keys(d).sort().reduce((O,y)=>(O=D(y,O),E(d[y],O)),m)}class h{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=E(m,this._value),this._value}}e.Hasher=h;var c;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(c||(c={}));function p(d,m,O=32){const y=O-m,i=~((1<<y)-1);return(d<<m|(i&d)>>>y)>>>0}function f(d,m=0,O=d.byteLength,y=0){for(let i=0;i<O;i++)d[m+i]=y}function g(d,m,O="0"){for(;d.length<m;)d=O+d;return d}function C(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(O=>O.toString(16).padStart(2,"0")).join(""):g((d>>>0).toString(16),m/4)}class w{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(c.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const O=m.length;if(O===0)return;const y=this._buff;let i=this._buffLen,l=this._leftoverHighSurrogate,r,n;for(l!==0?(r=l,n=-1,l=0):(r=m.charCodeAt(0),n=0);;){let t=r;if(I.isHighSurrogate(r))if(n+1<O){const s=m.charCodeAt(n+1);I.isLowSurrogate(s)?(n++,t=I.computeCodePoint(r,s)):t=c.UNICODE_REPLACEMENT}else{l=r;break}else I.isLowSurrogate(r)&&(t=c.UNICODE_REPLACEMENT);if(i=this._push(y,i,t),n++,n<O)r=m.charCodeAt(n);else break}this._buffLen=i,this._leftoverHighSurrogate=l}_push(m,O,y){return y<128?m[O++]=y:y<2048?(m[O++]=192|(y&1984)>>>6,m[O++]=128|(y&63)>>>0):y<65536?(m[O++]=224|(y&61440)>>>12,m[O++]=128|(y&4032)>>>6,m[O++]=128|(y&63)>>>0):(m[O++]=240|(y&1835008)>>>18,m[O++]=128|(y&258048)>>>12,m[O++]=128|(y&4032)>>>6,m[O++]=128|(y&63)>>>0),O>=c.BLOCK_SIZE&&(this._step(),O-=c.BLOCK_SIZE,this._totalLen+=c.BLOCK_SIZE,m[0]=m[c.BLOCK_SIZE+0],m[1]=m[c.BLOCK_SIZE+1],m[2]=m[c.BLOCK_SIZE+2]),O}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,c.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),C(this._h0)+C(this._h1)+C(this._h2)+C(this._h3)+C(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=w._bigBlock32,O=this._buffDV;for(let u=0;u<64;u+=4)m.setUint32(u,O.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)m.setUint32(u,p(m.getUint32(u-12,!1)^m.getUint32(u-32,!1)^m.getUint32(u-56,!1)^m.getUint32(u-64,!1),1),!1);let y=this._h0,i=this._h1,l=this._h2,r=this._h3,n=this._h4,t,s,o;for(let u=0;u<80;u++)u<20?(t=i&l|~i&r,s=1518500249):u<40?(t=i^l^r,s=1859775393):u<60?(t=i&l|i&r|l&r,s=2400959708):(t=i^l^r,s=3395469782),o=p(y,5)+t+n+s+m.getUint32(u*4,!1)&4294967295,n=r,r=l,l=p(i,30),i=y,y=o;this._h0=this._h0+y&4294967295,this._h1=this._h1+i&4294967295,this._h2=this._h2+l&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=w}),define(ue[57],de([0,1,31]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),I=Ee(I);var b;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(b||(b={})),function(E){const R="error",A="warning",D="warn",v="info",a="ignore";function h(p){return p?I.equalsIgnoreCase(R,p)?E.Error:I.equalsIgnoreCase(A,p)||I.equalsIgnoreCase(D,p)?E.Warning:I.equalsIgnoreCase(v,p)?E.Info:E.Ignore:E.Ignore}E.fromValue=h;function c(p){switch(p){case E.Error:return R;case E.Warning:return A;case E.Info:return v;default:return a}}E.toString=c}(b||(b={})),e.default=b}),define(ue[81],de([0,1,11]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=b,e.parse=E,e.getFirstFrame=R,e.log=D;function b(a){const h=a;return h&&typeof h.type=="string"&&typeof h.severity=="string"}function E(a){const h=[];let c;try{const p=JSON.parse(a.arguments),f=p[p.length-1];f&&f.__$stack&&(p.pop(),c=f.__$stack),h.push(...p)}catch{h.push("Unable to log remote console arguments",a.arguments)}return{args:h,stack:c}}function R(a){if(typeof a!="string")return R(E(a).stack);const h=a;if(h){const c=A(h),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(c||"");if(p&&p.length===4)return{uri:I.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function A(a){if(!a)return a;const h=a.indexOf(`
`);return h===-1?a:a.substring(0,h)}function D(a,h){const{args:c,stack:p}=E(a),f=typeof c[0]=="string"&&c.length===1;let g=A(p);g&&(g=`(${g.trim()})`);let C=[];if(typeof c[0]=="string"?g&&f?C=[`%c[${h}] %c${c[0]} %c${g}`,v("blue"),v(""),v("grey")]:C=[`%c[${h}] %c${c[0]}`,v("blue"),v(""),...c.slice(1)]:C=[`%c[${h}]%`,v("blue"),...c],g&&!f&&C.push(g),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,C)}function v(a){return`color: ${a}`}}),define(ue[48],de([0,1,13,11,147]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=R,e.parse=A,e.revive=v;function R(a){return JSON.stringify(a,D)}function A(a){let h=JSON.parse(a);return h=v(h),h}function D(a,h){return h instanceof RegExp?{$mid:E.MarshalledId.Regexp,source:h.source,flags:h.flags}:h}function v(a,h=0){if(!a||h>200)return a;if(typeof a=="object"){switch(a.$mid){case E.MarshalledId.Uri:return b.URI.revive(a);case E.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case E.MarshalledId.Date:return new Date(a.source)}if(a instanceof I.VSBuffer||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let c=0;c<a.length;++c)a[c]=v(a[c],h+1);else for(const c in a)Object.hasOwnProperty.call(a,c)&&(a[c]=v(a[c],h+1))}return a}}),define(ue[82],de([0,1,74,14,12,3,11]),function(J,e,I,b,E,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=c,e.resolveAmdNodeModulePath=p,E=Ee(E);class D{constructor(g,C,w){this.id=g,this.dependencies=C,this.callback=w}}class v{static{this.INSTANCE=new v}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(g,C,w)=>{typeof g!="string"&&(w=C,C=g,g=null),(typeof C!="object"||!Array.isArray(C))&&(w=C,C=null),this._defineCalls.push(new D(g,C,w))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this._initialize();const C=await(this._isWebWorker?this._workerLoadScript(g):this._isRenderer?this._rendererLoadScript(g):this._nodeJSLoadScript(g));if(!C)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(C.dependencies)&&C.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${C.dependencies.join(", ")}`);return typeof C.callback=="function"?C.callback([]):C.callback}_rendererLoadScript(g){return new Promise((C,w)=>{const d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript");const m=()=>{d.removeEventListener("load",O),d.removeEventListener("error",y)},O=i=>{m(),C(this._defineCalls.pop())},y=i=>{m(),w(i)};d.addEventListener("load",O),d.addEventListener("error",y),this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),d.setAttribute("src",g),window.document.getElementsByTagName("head")[0].appendChild(d)})}_workerLoadScript(g){return new Promise((C,w)=>{try{this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),importScripts(g),C(this._defineCalls.pop())}catch(d){w(d)}})}async _nodeJSLoadScript(g){try{const C=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,d=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(g).fsPath,O=C.readFileSync(m).toString(),y=d.wrap(O.replace(/^#!.*/,""));return new w.Script(y).runInThisContext().apply(),this._defineCalls.pop()}catch(C){throw C}}}const a=new Map;let h={};typeof globalThis.require=="object"&&(h=globalThis.require.paths??{});async function c(f,g,C){if(I.isESM){C===void 0&&(C=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),h[f]&&(f=h[f]);const w=g?`${f}/${g}`:f;if(a.has(w))return a.get(w);let d;if(/^\w[\w\d+.-]*:\/\//.test(w))d=w;else{const i=`${C&&!E.isWeb?b.nodeModulesAsarPath:b.nodeModulesPath}/${w}`;d=b.FileAccess.asBrowserUri(i).toString(!0)}const m=v.INSTANCE.load(d);return a.set(w,m),m}else return await new Promise((w,d)=>{J([f],w,d)}).then(Ee)}function p(f,g){(0,R.assertType)(I.isESM);const d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!E.isWeb,m=`${f}/${g}`,y=`${d?b.nodeModulesAsarPath:b.nodeModulesPath}/${m}`;return b.FileAccess.asBrowserUri(y).toString(!0)}}),define(ue[28],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=b;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function b(E){return I.test(E)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(D){for(let v=0;v<D.length;v++)D[v]=Math.floor(Math.random()*256);return D};const R=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));return function(){E(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let v=0,a="";return a+=A[R[v++]],a+=A[R[v++]],a+=A[R[v++]],a+=A[R[v++]],a+="-",a+=A[R[v++]],a+=A[R[v++]],a+="-",a+=A[R[v++]],a+=A[R[v++]],a+="-",a+=A[R[v++]],a+=A[R[v++]],a+="-",a+=A[R[v++]],a+=A[R[v++]],a+=A[R[v++]],a+=A[R[v++]],a+=A[R[v++]],a+=A[R[v++]],a}}()}),define(ue[83],de([0,1,35]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=R;const b=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(A){const D=A.replace(/\-/g,":").toLowerCase();return!b.has(D)}function R(){const A=(0,I.networkInterfaces)();for(const D in A){const v=A[D];if(v){for(const{mac:a}of v)if(E(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ue[84],de([0,1,35,49,28,83,12]),function(J,e,I,b,E,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=v,e.getSqmMachineId=c,e.getdevDeviceId=p,E=Ee(E),e.virtualMachineHint=new class{_isVirtualMachineMacAddress(f){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(f)}value(){if(this._value===void 0){let f=0,g=0;const C=(0,I.networkInterfaces)();for(const w in C){const d=C[w];if(d)for(const{mac:m,internal:O}of d)O||(g+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(f+=1))}this._value=g>0?f/g:0}return this._value}};let D;async function v(f){return D||(D=(async()=>await a(f)||E.generateUuid())()),D}async function a(f){try{const g=await new Promise((w,d)=>{J(["crypto"],w,d)}).then(Ee),C=(0,R.getMac)();return g.createHash("sha256").update(C,"utf8").digest("hex")}catch(g){f(g);return}}const h="Software\\Microsoft\\SQMClient";async function c(f){if(A.isWindows){const g=await new Promise((C,w)=>{J(["@vscode/windows-registry"],C,w)}).then(Ee);try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",h,"MachineId")||""}catch(C){return f(C),""}}return""}async function p(f){try{return await(await new Promise((w,d)=>{J(["@vscode/deviceid"],w,d)}).then(Ee)).getDeviceId()}catch(g){return f(g),""}}}),define(ue[85],de([0,1,35,15,29]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=m,e.getFirstAvailablePowerShellInstallation=O,I=Ee(I),b=Ee(b),E=Ee(E);const R=/^\d+$/,A=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var v;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(v||(v={}));let a;switch(process.arch){case"ia32":a=v.x86;break;case"arm":case"arm64":a=v.ARM;break;default:a=v.x64;break}let h;process.env.PROCESSOR_ARCHITEW6432?h=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?v.ARM:v.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?h=v.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?h=v.x86:h=v.x64;class c{constructor(i,l,r){this.exePath=i,this.displayName=l,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await E.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:y=!1}={}){return y?a===v.x64?process.env["ProgramFiles(x86)"]||null:h===v.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:y=!1,findPreview:i=!1}={}){const l=p({useAlternateBitness:y});if(!l)return null;const r=b.join(l,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(r))return null;let n=-1,t=null;for(const u of await E.Promises.readdir(r)){let S=-1;if(i){const N=u.indexOf("-");if(N<0)continue;const L=u.substring(0,N);if(!R.test(L)||u.substring(N+1)!=="preview")continue;S=parseInt(L,10)}else{if(!R.test(u))continue;S=parseInt(u,10)}if(S<=n)continue;const T=b.join(r,u,"pwsh.exe");await E.SymlinkSupport.existsFile(T)&&(t=T,n=S)}if(!t)return null;const s=l.includes("x86")?" (x86)":"",o=i?" Preview":"";return new c(t,`PowerShell${o}${s}`,!0)}async function g({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const i=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:l,pwshMsixName:r}=y?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const n of await E.Promises.readdir(i))if(l.test(n)){const t=b.join(i,n,"pwsh.exe");return new c(t,r)}return null}function C(){const y=b.join(I.homedir(),".dotnet","tools","pwsh.exe");return new c(y,".NET Core PowerShell Global Tool")}function w(){const y=b.join(process.env.windir,a===v.x86&&h!==v.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new c(y,"Windows PowerShell",!0)}async function*d(){let y=await f();y&&(yield y),y=await f({useAlternateBitness:!0}),y&&(yield y),y=await g(),y&&(yield y),y=C(),y&&(yield y),y=await f({findPreview:!0}),y&&(yield y),y=await g({findPreview:!0}),y&&(yield y),y=await f({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=w(),y&&(yield y)}async function*m(){for await(const y of d())await y.exists()&&(yield y)}async function O(){for await(const y of m())return y;return null}}),define(ue[58],de([0,1,32,15,12,36,56,3,29]),function(J,e,I,b,E,R,A,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=a,e.createQueuedSender=h,b=Ee(b),E=Ee(E),R=Ee(R),D=Ee(D),v=Ee(v),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function a(p=R.env){return p.comspec||"cmd.exe"}function h(p){let f=[],g=!1;const C=function(w){if(g){f.push(w);return}(!p.send(w,m=>{if(m&&console.error(m),g=!1,f.length>0){const O=f.slice(0);f=[],O.forEach(y=>C(y))}})||E.isWindows)&&(g=!0)};return{send:C}}var c;(function(p){async function f(g,C,w){if(b.isAbsolute(g))return g;if(C===void 0&&(C=R.cwd()),b.dirname(g)!=="."||(w===void 0&&D.isString(R.env.PATH)&&(w=R.env.PATH.split(b.delimiter)),w===void 0||w.length===0))return b.join(C,g);async function m(O){if(await v.Promises.exists(O)){let y;try{y=await I.promises.stat(O)}catch(i){i.message.startsWith("EACCES")&&(y=await I.promises.lstat(O))}return y?!y.isDirectory():!1}return!1}for(const O of w){let y;if(b.isAbsolute(O)?y=b.join(O,g):y=b.join(C,O,g),await m(y))return y;let i=y+".com";if(await m(i)||(i=y+".exe",await m(i)))return i}return b.join(C,g)}p.findExecutable=f})(c||(e.win32=c={}))}),define(ue[86],de([0,1,35,12,85,58]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=A,b=Ee(b),R=Ee(R);async function A(c,p){return c===b.OperatingSystem.Windows?b.isWindows?h():R.getWindowsShell(p):v(c,p)}let D=null;function v(c,p){if(b.isLinux&&c===b.OperatingSystem.Macintosh||b.isMacintosh&&c===b.OperatingSystem.Linux)return"/bin/bash";if(!D){let f;if(b.isWindows)f="/bin/bash";else{if(f=p.SHELL,!f)try{f=(0,I.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}D=f}return D}let a=null;async function h(){return a||(a=(await(0,E.getFirstAvailablePowerShellInstallation)()).exePath),a}});var we=this&&this.__decorate||function(J,e,I,b){var E=arguments.length,R=E<3?e:b===null?b=Object.getOwnPropertyDescriptor(e,I):b,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(J,e,I,b);else for(var D=J.length-1;D>=0;D--)(A=J[D])&&(R=(E<3?A(R):E>3?A(e,I,R):A(e,I))||R);return E>3&&R&&Object.defineProperty(e,I,R),R};define(ue[59],de([0,1,19,8,13,21,55,7,4,2,48,31,3]),function(J,e,I,b,E,R,A,D,v,a,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=o,e.deserialize=u,e.getDelayedChannel=U,e.getNextTickChannel=G,c=Ee(c);var f;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(f||(f={}));function g(z){switch(z){case f.Promise:return"req";case f.PromiseCancel:return"cancel";case f.EventListen:return"subscribe";case f.EventDispose:return"unsubscribe"}}var C;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(C||(C={}));function w(z){switch(z){case C.Initialize:return"init";case C.PromiseSuccess:return"reply:";case C.PromiseError:case C.PromiseErrorObj:return"replyErr:";case C.EventFire:return"event:"}}var d;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(d||(d={}));function m(z){let V=0;for(let K=0;;K+=7){const H=z.read(1);if(V|=(H.buffer[0]&127)<<K,!(H.buffer[0]&128))return V}}const O=n(0);function y(z,V){if(V===0){z.write(O);return}let K=0;for(let ie=V;ie!==0;ie=ie>>>7)K++;const H=E.VSBuffer.alloc(K);for(let ie=0;V!==0;ie++)H.buffer[ie]=V&127,V=V>>>7,V>0&&(H.buffer[ie]|=128);z.write(H)}class i{constructor(V){this.buffer=V,this.pos=0}read(V){const K=this.buffer.slice(this.pos,this.pos+V);return this.pos+=K.byteLength,K}}e.BufferReader=i;class l{constructor(){this.buffers=[]}get buffer(){return E.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}e.BufferWriter=l;var r;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(r||(r={}));function n(z){const V=E.VSBuffer.alloc(1);return V.writeUInt8(z,0),V}const t={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},s=typeof Buffer<"u";function o(z,V){if(typeof V>"u")z.write(t.Undefined);else if(typeof V=="string"){const K=E.VSBuffer.fromString(V);z.write(t.String),y(z,K.byteLength),z.write(K)}else if(s&&Buffer.isBuffer(V)){const K=E.VSBuffer.wrap(V);z.write(t.Buffer),y(z,K.byteLength),z.write(K)}else if(V instanceof E.VSBuffer)z.write(t.VSBuffer),y(z,V.byteLength),z.write(V);else if(Array.isArray(V)){z.write(t.Array),y(z,V.length);for(const K of V)o(z,K)}else if(typeof V=="number"&&(V|0)===V)z.write(t.Uint),y(z,V);else{const K=E.VSBuffer.fromString(JSON.stringify(V));z.write(t.Object),y(z,K.byteLength),z.write(K)}}function u(z){switch(z.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return z.read(m(z)).toString();case r.Buffer:return z.read(m(z)).buffer;case r.VSBuffer:return z.read(m(z));case r.Array:{const K=m(z),H=[];for(let ie=0;ie<K;ie++)H.push(u(z));return H}case r.Object:return JSON.parse(z.read(m(z)).toString());case r.Int:return m(z)}}class S{constructor(V,K,H=null,ie=1e3){this.protocol=V,this.ctx=K,this.logger=H,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ne=>this.onRawMessage(ne)),this.sendResponse({type:C.Initialize})}registerChannel(V,K){this.channels.set(V,K),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case C.Initialize:{const K=this.send([V.type]);this.logger?.logOutgoing(K,0,T.OtherSide,w(V.type));return}case C.PromiseSuccess:case C.PromiseError:case C.EventFire:case C.PromiseErrorObj:{const K=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(K,V.id,T.OtherSide,w(V.type),V.data);return}}}send(V,K=void 0){const H=new l;return o(H,V),o(H,K),this.sendBuffer(H.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const K=new i(V),H=u(K),ie=u(K),ne=H[0];switch(ne){case f.Promise:return this.logger?.logIncoming(V.byteLength,H[1],T.OtherSide,`${g(ne)}: ${H[2]}.${H[3]}`,ie),this.onPromise({type:ne,id:H[1],channelName:H[2],name:H[3],arg:ie});case f.EventListen:return this.logger?.logIncoming(V.byteLength,H[1],T.OtherSide,`${g(ne)}: ${H[2]}.${H[3]}`,ie),this.onEventListen({type:ne,id:H[1],channelName:H[2],name:H[3],arg:ie});case f.PromiseCancel:return this.logger?.logIncoming(V.byteLength,H[1],T.OtherSide,`${g(ne)}`),this.disposeActiveRequest({type:ne,id:H[1]});case f.EventDispose:return this.logger?.logIncoming(V.byteLength,H[1],T.OtherSide,`${g(ne)}`),this.disposeActiveRequest({type:ne,id:H[1]})}}onPromise(V){const K=this.channels.get(V.channelName);if(!K){this.collectPendingRequest(V);return}const H=new R.CancellationTokenSource;let ie;try{ie=K.call(this.ctx,V.name,V.arg,H.token)}catch($){ie=Promise.reject($)}const ne=V.id;ie.then($=>{this.sendResponse({id:ne,data:$,type:C.PromiseSuccess})},$=>{$ instanceof Error?this.sendResponse({id:ne,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split(`
`):void 0},type:C.PromiseError}):this.sendResponse({id:ne,data:$,type:C.PromiseErrorObj})}).finally(()=>{F.dispose(),this.activeRequests.delete(V.id)});const F=(0,a.toDisposable)(()=>H.cancel());this.activeRequests.set(V.id,F)}onEventListen(V){const K=this.channels.get(V.channelName);if(!K){this.collectPendingRequest(V);return}const H=V.id,ne=K.listen(this.ctx,V.name,V.arg)(F=>this.sendResponse({id:H,data:F,type:C.EventFire}));this.activeRequests.set(V.id,ne)}disposeActiveRequest(V){const K=this.activeRequests.get(V.id);K&&(K.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let K=this.pendingRequests.get(V.channelName);K||(K=[],this.pendingRequests.set(V.channelName,K));const H=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===f.Promise&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:C.PromiseError})},this.timeoutDelay);K.push({request:V,timeoutTimer:H})}flushPendingRequests(V){const K=this.pendingRequests.get(V);if(K){for(const H of K)switch(clearTimeout(H.timeoutTimer),H.request.type){case f.Promise:this.onPromise(H.request);break;case f.EventListen:this.onEventListen(H.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=S;var T;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(T||(e.RequestInitiator=T={}));class N{constructor(V,K=null){this.protocol=V,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=K}getChannel(V){const K=this;return{call(H,ie,ne){return K.isDisposed?Promise.reject(new D.CancellationError):K.requestPromise(V,H,ie,ne)},listen(H,ie){return K.isDisposed?v.Event.None:K.requestEvent(V,H,ie)}}}requestPromise(V,K,H,ie=R.CancellationToken.None){const ne=this.lastRequestId++,F=f.Promise,$={id:ne,type:F,channelName:V,name:K,arg:H};if(ie.isCancellationRequested)return Promise.reject(new D.CancellationError);let _;return new Promise((M,X)=>{if(ie.isCancellationRequested)return X(new D.CancellationError);const x=()=>{const oe=le=>{switch(le.type){case C.PromiseSuccess:this.handlers.delete(ne),M(le.data);break;case C.PromiseError:{this.handlers.delete(ne);const ye=new Error(le.data.message);ye.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,ye.name=le.data.name,X(ye);break}case C.PromiseErrorObj:this.handlers.delete(ne),X(le.data);break}};this.handlers.set(ne,oe),this.sendRequest($)};let W=null;this.state===d.Idle?x():(W=(0,b.createCancelablePromise)(oe=>this.whenInitialized()),W.then(()=>{W=null,x()}));const B=()=>{W?(W.cancel(),W=null):this.sendRequest({id:ne,type:f.PromiseCancel}),X(new D.CancellationError)},re=ie.onCancellationRequested(B);_=(0,a.combinedDisposable)((0,a.toDisposable)(B),re),this.activeRequests.add(_)}).finally(()=>{_.dispose(),this.activeRequests.delete(_)})}requestEvent(V,K,H){const ie=this.lastRequestId++,ne=f.EventListen,F={id:ie,type:ne,channelName:V,name:K,arg:H};let $=null;const _=new v.Emitter({onWillAddFirstListener:()=>{$=(0,b.createCancelablePromise)(M=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(_),this.sendRequest(F)})},onDidRemoveLastListener:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(_),this.sendRequest({id:ie,type:f.EventDispose}))}}),P=M=>_.fire(M.data);return this.handlers.set(ie,P),_.event}sendRequest(V){switch(V.type){case f.Promise:case f.EventListen:{const K=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger?.logOutgoing(K,V.id,T.LocalSide,`${g(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case f.PromiseCancel:case f.EventDispose:{const K=this.send([V.type,V.id]);this.logger?.logOutgoing(K,V.id,T.LocalSide,g(V.type));return}}}send(V,K=void 0){const H=new l;return o(H,V),o(H,K),this.sendBuffer(H.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const K=new i(V),H=u(K),ie=u(K),ne=H[0];switch(ne){case C.Initialize:return this.logger?.logIncoming(V.byteLength,0,T.LocalSide,w(ne)),this.onResponse({type:H[0]});case C.PromiseSuccess:case C.PromiseError:case C.EventFire:case C.PromiseErrorObj:return this.logger?.logIncoming(V.byteLength,H[1],T.LocalSide,w(ne),ie),this.onResponse({type:H[0],id:H[1],data:ie})}}onResponse(V){if(V.type===C.Initialize){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(V.id)?.(V)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=N,we([A.memoize],N.prototype,"onDidInitializePromise",null);class L{get connections(){const V=[];return this._connections.forEach(K=>V.push(K)),V}constructor(V,K,H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new a.DisposableStore,this.disposables.add(V(({protocol:ie,onDidClientDisconnect:ne})=>{const F=v.Event.once(ie.onMessage);this.disposables.add(F($=>{const _=new i($),P=u(_),M=new S(ie,P,K,H),X=new N(ie,K);this.channels.forEach((W,B)=>M.registerChannel(B,W));const x={channelServer:M,channelClient:X,ctx:P};this._connections.add(x),this._onDidAddConnection.fire(x),this.disposables.add(ne(()=>{M.dispose(),X.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)}))}))}))}getChannel(V,K){const H=this;return{call(ie,ne,F){let $;if((0,p.isFunction)(K)){const P=(0,I.getRandomElement)(H.connections.filter(K));$=P?Promise.resolve(P):v.Event.toPromise(v.Event.filter(H.onDidAddConnection,K))}else $=K.routeCall(H,ie,ne);const _=$.then(P=>P.channelClient.getChannel(V));return U(_).call(ie,ne,F)},listen(ie,ne){if((0,p.isFunction)(K))return H.getMulticastEvent(V,K,ie,ne);const F=K.routeEvent(H,ie,ne).then($=>$.channelClient.getChannel(V));return U(F).listen(ie,ne)}}}getMulticastEvent(V,K,H,ie){const ne=this;let F;const $=new v.Emitter({onWillAddFirstListener:()=>{F=new a.DisposableStore;const _=new v.EventMultiplexer,P=new Map,M=x=>{const B=x.channelClient.getChannel(V).listen(H,ie),re=_.add(B);P.set(x,re)},X=x=>{const W=P.get(x);W&&(W.dispose(),P.delete(x))};ne.connections.filter(K).forEach(M),v.Event.filter(ne.onDidAddConnection,K)(M,void 0,F),ne.onDidRemoveConnection(X,void 0,F),_.event($.fire,$,F),F.add(_)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return $.event}registerChannel(V,K){this.channels.set(V,K);for(const H of this._connections)H.channelServer.registerChannel(V,K)}dispose(){this.disposables.dispose();for(const V of this._connections)V.channelClient.dispose(),V.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class k{constructor(V,K,H=null){const ie=new l;o(ie,K),V.send(ie.buffer),this.channelClient=new N(V,H),this.channelServer=new S(V,K,H)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,K){this.channelServer.registerChannel(V,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function U(z){return{call(V,K,H){return z.then(ie=>ie.call(V,K,H))},listen(V,K){const H=new v.Relay;return z.then(ie=>H.input=ie.listen(V,K)),H.event}}}function G(z){let V=!1;return{call(K,H,ie){return V?z.call(K,H,ie):(0,b.timeout)(0).then(()=>V=!0).then(()=>z.call(K,H,ie))},listen(K,H){if(V)return z.listen(K,H);const ie=new v.Relay;return(0,b.timeout)(0).then(()=>V=!0).then(()=>ie.input=z.listen(K,H)),ie.event}}}class Y{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const K of V.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await v.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=Y;var te;(function(z){function V(ne,F,$){const _=ne,P=$&&$.disableMarshalling,M=new Map;for(const X in _)H(X)&&M.set(X,v.Event.buffer(_[X],!0,void 0,F));return new class{listen(X,x,W){const B=M.get(x);if(B)return B;const re=_[x];if(typeof re=="function"){if(ie(x))return re.call(_,W);if(H(x))return M.set(x,v.Event.buffer(_[x],!0,void 0,F)),M.get(x)}throw new D.ErrorNoTelemetry(`Event not found: ${x}`)}call(X,x,W){const B=_[x];if(typeof B=="function"){if(!P&&Array.isArray(W))for(let oe=0;oe<W.length;oe++)W[oe]=(0,h.revive)(W[oe]);let re=B.apply(_,W);return re instanceof Promise||(re=Promise.resolve(re)),re}throw new D.ErrorNoTelemetry(`Method not found: ${x}`)}}}z.fromService=V;function K(ne,F){const $=F&&F.disableMarshalling;return new Proxy({},{get(_,P){if(typeof P=="string")return F?.properties?.has(P)?F.properties.get(P):ie(P)?function(M){return ne.listen(P,M)}:H(P)?ne.listen(P):async function(...M){let X;F&&!(0,p.isUndefinedOrNull)(F.context)?X=[F.context,...M]:X=M;const x=await ne.call(P,X);return $?x:(0,h.revive)(x)};throw new D.ErrorNoTelemetry(`Property not found: ${String(P)}`)}})}z.toService=K;function H(ne){return ne[0]==="o"&&ne[1]==="n"&&c.isUpperAsciiLetter(ne.charCodeAt(2))}function ie(ne){return/^onDynamic/.test(ne)&&c.isUpperAsciiLetter(ne.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const V=z.toString();if(V!=="[object Object]")return V}return z}function fe(z){return Array.isArray(z)?z.map(ce):ce(z)}function q(z,V,K,H,ie,ne,F){F=fe(F);const $=ae[ie],_=$[H%$.length];let P=[`%c[${z}]%c[${String(V).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(ne)?(P=P.concat(F),P.push(")")):P.push(F),console.log.apply(console,P)}class Q{constructor(V,K){this._outgoingPrefix=V,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,K,H,ie,ne){this._totalOutgoing+=V,q(this._outgoingPrefix,this._totalOutgoing,V,K,H,ie,ne)}logIncoming(V,K,H,ie,ne){this._totalIncoming+=V,q(this._incomingPrefix,this._totalIncoming,V,K,H,ie,ne)}}e.IPCLogger=Q}),define(ue[87],de([0,1,60,8,13,21,81,7,4,2,27,58,56,59]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,D=Ee(D);class g extends f.ChannelServer{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",m=>E.VSBuffer.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=g;class C{constructor(d,m){this.modulePath=d,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const O=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new b.Delayer(O),this.child=null,this._client=null}getChannel(d){const m=this;return{call(O,y,i){return m.requestPromise(d,O,y,i)},listen(O,y){return m.requestEvent(d,O,y)}}}requestPromise(d,m,O,y=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(d),l=(0,b.createCancelablePromise)(t=>i.call(m,O,t)),r=y.onCancellationRequested(()=>l.cancel()),n=(0,a.toDisposable)(()=>l.cancel());return this.activeRequests.add(n),l.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(d,m,O){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let y;const i=new v.Emitter({onWillAddFirstListener:()=>{y=this.getCachedChannel(d).listen(m,O)(i.fire,i),this.activeRequests.add(y)},onDidRemoveLastListener:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,h.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,p.removeDangerousEnvVariables)(m.env),this.child=(0,I.fork)(this.modulePath,d,m);const O=new v.Emitter,i=v.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,A.isRemoteConsoleLog)(o)){(0,A.log)(o,`IPC Library: ${this.options.serverName}`);return}O.fire(E.VSBuffer.wrap(Buffer.from(o,"base64")))}),l=this.options.useQueue?(0,c.createQueuedSender)(this.child):this.child,r=o=>this.child&&this.child.connected&&l.send(o.buffer.toString("base64")),n=O.event,t={send:r,onMessage:n};this._client=new f.ChannelClient(t);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,u)=>{process.removeListener("exit",s),i.dispose(),this.activeRequests.forEach(S=>(0,a.dispose)(S)),this.activeRequests.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:u})})}return this._client}getCachedChannel(d){let m=this.channels.get(d);return m||(m=this.client.getChannel(d),this.channels.set(d,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(ue[88],de([0,1,8,4,2,48,3]),function(J,e,I,b,E,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=v;var D;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D||(e.StorageHint=D={}));function v(p){const f=p;return f?.changed instanceof Map||f?.deleted instanceof Set}var a;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(a||(e.StorageState=a={}));class h extends E.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(f,g=Object.create(null)){super(),this.database=f,this.options=g,this._onDidChangeStorage=this._register(new b.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new I.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){this._onDidChangeStorage.pause();try{f.changed?.forEach((g,C)=>this.acceptExternal(C,g)),f.deleted?.forEach(g=>this.acceptExternal(g,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(f,g){if(this.state===a.Closed)return;let C=!1;(0,A.isUndefinedOrNull)(g)?C=this.cache.delete(f):this.cache.get(f)!==g&&(this.cache.set(f,g),C=!0),C&&this._onDidChangeStorage.fire({key:f,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,g){const C=this.cache.get(f);return(0,A.isUndefinedOrNull)(C)?g:C}getBoolean(f,g){const C=this.get(f);return(0,A.isUndefinedOrNull)(C)?g:C==="true"}getNumber(f,g){const C=this.get(f);return(0,A.isUndefinedOrNull)(C)?g:parseInt(C,10)}getObject(f,g){const C=this.get(f);return(0,A.isUndefinedOrNull)(C)?g:(0,R.parse)(C)}async set(f,g,C=!1){if(this.state===a.Closed)return;if((0,A.isUndefinedOrNull)(g))return this.delete(f,C);const w=(0,A.isObject)(g)||Array.isArray(g)?(0,R.stringify)(g):String(g);if(this.cache.get(f)!==w)return this.cache.set(f,w),this.pendingInserts.set(f,w),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire({key:f,external:C}),this.doFlush()}async delete(f,g=!1){if(!(this.state===a.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire({key:f,external:g}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!(this.state===a.Closed||this.pendingClose))return this.doFlush(f)}async doFlush(f){return this.options.hint===D.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}isInMemory(){return this.options.hint===D.STORAGE_IN_MEMORY}}e.Storage=h;class c{constructor(){this.onDidChangeItemsExternal=b.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert?.forEach((g,C)=>this.items.set(C,g)),f.delete?.forEach(g=>this.items.delete(g))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=c}),define(ue[89],de([0,1,5]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=a,e.getDurationString=h,e.toLocalISOString=c;const b=60,E=b*60,R=E*24,A=R*7,D=R*30,v=R*365;function a(p,f,g,C){typeof p!="number"&&(p=p.getTime());const w=Math.round((new Date().getTime()-p)/1e3);if(w<-30)return(0,I.localize)(12985,null,a(new Date().getTime()+w*1e3,!1));if(!C&&w<30)return(0,I.localize)(12986,null);let d;return w<b?(d=w,f?d===1?g?(0,I.localize)(12987,null,d):(0,I.localize)(12988,null,d):g?(0,I.localize)(12989,null,d):(0,I.localize)(12990,null,d):d===1?g?(0,I.localize)(12991,null,d):(0,I.localize)(12992,null,d):g?(0,I.localize)(12993,null,d):(0,I.localize)(12994,null,d)):w<E?(d=Math.floor(w/b),f?d===1?g?(0,I.localize)(12995,null,d):(0,I.localize)(12996,null,d):g?(0,I.localize)(12997,null,d):(0,I.localize)(12998,null,d):d===1?g?(0,I.localize)(12999,null,d):(0,I.localize)(13e3,null,d):g?(0,I.localize)(13001,null,d):(0,I.localize)(13002,null,d)):w<R?(d=Math.floor(w/E),f?d===1?g?(0,I.localize)(13003,null,d):(0,I.localize)(13004,null,d):g?(0,I.localize)(13005,null,d):(0,I.localize)(13006,null,d):d===1?g?(0,I.localize)(13007,null,d):(0,I.localize)(13008,null,d):g?(0,I.localize)(13009,null,d):(0,I.localize)(13010,null,d)):w<A?(d=Math.floor(w/R),f?d===1?(0,I.localize)(13011,null,d):(0,I.localize)(13012,null,d):d===1?(0,I.localize)(13013,null,d):(0,I.localize)(13014,null,d)):w<D?(d=Math.floor(w/A),f?d===1?g?(0,I.localize)(13015,null,d):(0,I.localize)(13016,null,d):g?(0,I.localize)(13017,null,d):(0,I.localize)(13018,null,d):d===1?g?(0,I.localize)(13019,null,d):(0,I.localize)(13020,null,d):g?(0,I.localize)(13021,null,d):(0,I.localize)(13022,null,d)):w<v?(d=Math.floor(w/D),f?d===1?g?(0,I.localize)(13023,null,d):(0,I.localize)(13024,null,d):g?(0,I.localize)(13025,null,d):(0,I.localize)(13026,null,d):d===1?g?(0,I.localize)(13027,null,d):(0,I.localize)(13028,null,d):g?(0,I.localize)(13029,null,d):(0,I.localize)(13030,null,d)):(d=Math.floor(w/v),f?d===1?g?(0,I.localize)(13031,null,d):(0,I.localize)(13032,null,d):g?(0,I.localize)(13033,null,d):(0,I.localize)(13034,null,d):d===1?g?(0,I.localize)(13035,null,d):(0,I.localize)(13036,null,d):g?(0,I.localize)(13037,null,d):(0,I.localize)(13038,null,d))}function h(p,f){const g=Math.abs(p/1e3);return g<1?f?(0,I.localize)(13039,null,p):(0,I.localize)(13040,null,p):g<b?f?(0,I.localize)(13041,null,Math.round(p)/1e3):(0,I.localize)(13042,null,Math.round(p)/1e3):g<E?f?(0,I.localize)(13043,null,Math.round(p/(1e3*b))):(0,I.localize)(13044,null,Math.round(p/(1e3*b))):g<R?f?(0,I.localize)(13045,null,Math.round(p/(1e3*E))):(0,I.localize)(13046,null,Math.round(p/(1e3*E))):(0,I.localize)(13047,null,Math.round(p/(1e3*R)))}function c(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ue[38],de([0,1,19,3,5]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=v,e.isErrorWithActions=a,e.createErrorWithActions=h,I=Ee(I),b=Ee(b),E=Ee(E);function R(c,p){return p&&(c.stack||c.stacktrace)?E.localize(12979,null,D(c),A(c.stack)||A(c.stacktrace)):D(c)}function A(c){return Array.isArray(c)?c.join(`
`):c}function D(c){return c.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?E.localize(12980,null,c.message):c.message||E.localize(12981,null)}function v(c=null,p=!1){if(!c)return E.localize(12982,null);if(Array.isArray(c)){const f=I.coalesce(c),g=v(f[0],p);return f.length>1?E.localize(12983,null,g,f.length):g}if(b.isString(c))return c;if(c.detail){const f=c.detail;if(f.error)return R(f.error,p);if(f.exception)return R(f.exception,p)}return c.stack?R(c,p):c.message?c.message:E.localize(12984,null)}function a(c){const p=c;return p instanceof Error&&Array.isArray(p.actions)}function h(c,p){let f;return typeof c=="string"?f=new Error(c):f=c,f.actions=p,f}}),define(ue[90],de([0,1,5,34]),function(J,e,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=E;function E(R){switch(R){case b.ParseErrorCode.InvalidSymbol:return(0,I.localize)(12970,null);case b.ParseErrorCode.InvalidNumberFormat:return(0,I.localize)(12971,null);case b.ParseErrorCode.PropertyNameExpected:return(0,I.localize)(12972,null);case b.ParseErrorCode.ValueExpected:return(0,I.localize)(12973,null);case b.ParseErrorCode.ColonExpected:return(0,I.localize)(12974,null);case b.ParseErrorCode.CommaExpected:return(0,I.localize)(12975,null);case b.ParseErrorCode.CloseBraceExpected:return(0,I.localize)(12976,null);case b.ParseErrorCode.CloseBracketExpected:return(0,I.localize)(12977,null);case b.ParseErrorCode.EndOfFileExpected:return(0,I.localize)(12978,null);default:return""}}}),define(ue[50],de([0,1,32,8,15,3,29,5]),function(J,e,I,b,E,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=w,e.extract=d,e.buffer=O,E=Ee(E),D=Ee(D),e.CorruptZipMessage="end of central directory record signature not found";const v=new RegExp(e.CorruptZipMessage);class a extends Error{constructor(i,l){let r=l.message;switch(i){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=i,this.cause=l}}e.ExtractError=a;function h(y){const i=y.externalFileAttributes>>16||33188;return[448,56,7].map(l=>i&l).reduce((l,r)=>l+r,i&61440)}function c(y){if(y instanceof a)return y;let i;return v.test(y.message)&&(i="CorruptZip"),new a(i,y)}function p(y,i,l,r,n,t){const s=E.dirname(i),o=E.join(r,s);if(!o.startsWith(r))return Promise.reject(new Error(D.localize(13049,null,i)));const u=E.join(r,i);let S;return t.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(I.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((T,N)=>{if(!t.isCancellationRequested)try{S=(0,I.createWriteStream)(u,{mode:l}),S.once("close",()=>T()),S.once("error",N),y.once("error",N),y.pipe(S)}catch(L){N(L)}}))}function f(y,i,l,r){let n=(0,b.createCancelablePromise)(()=>Promise.resolve()),t=0;const s=r.onCancellationRequested(()=>{n.cancel(),y.close()});return new Promise((o,u)=>{const S=new b.Sequencer,T=N=>{N.isCancellationRequested||(t++,y.readEntry())};y.once("error",u),y.once("close",()=>n.then(()=>{r.isCancellationRequested||y.entryCount===t?o():u(new a("Incomplete",new Error(D.localize(13050,null,t,y.entryCount))))},u)),y.readEntry(),y.on("entry",N=>{if(r.isCancellationRequested)return;if(!l.sourcePathRegex.test(N.fileName)){T(r);return}const L=N.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(L)){const G=E.join(i,L);n=(0,b.createCancelablePromise)(Y=>I.promises.mkdir(G,{recursive:!0}).then(()=>T(Y)).then(void 0,u));return}const k=C(y,N),U=h(N);n=(0,b.createCancelablePromise)(G=>S.queue(()=>k.then(Y=>p(Y,L,U,i,l,G).then(()=>T(G)))).then(null,u))})}).finally(()=>s.dispose())}async function g(y,i=!1){const{open:l}=await new Promise((r,n)=>{J(["yauzl"],r,n)}).then(Ee);return new Promise((r,n)=>{l(y,i?{lazyEntries:!0}:void 0,(t,s)=>{t?n(c(t)):r((0,R.assertIsDefined)(s))})})}function C(y,i){return new Promise((l,r)=>{y.openReadStream(i,(n,t)=>{n?r(c(n)):l((0,R.assertIsDefined)(t))})})}async function w(y,i){const{ZipFile:l}=await new Promise((r,n)=>{J(["yazl"],r,n)}).then(Ee);return new Promise((r,n)=>{const t=new l;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,I.createWriteStream)(y);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>r(y))})}function d(y,i,l={},r){const n=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let t=g(y,!0);return l.overwrite&&(t=t.then(s=>A.Promises.rm(i).then(()=>s))),t.then(s=>f(s,i,{sourcePathRegex:n},r))}function m(y,i){return g(y).then(l=>new Promise((r,n)=>{l.on("entry",t=>{t.fileName===i&&C(l,t).then(s=>r(s),s=>n(s))}),l.once("close",()=>n(new Error(D.localize(13051,null,i))))}))}function O(y,i){return m(y,i).then(l=>new Promise((r,n)=>{const t=[];l.once("error",n),l.on("data",s=>t.push(s)),l.on("end",()=>r(Buffer.concat(t)))}))}}),define(ue[91],de([0,1,92,7,5]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var R;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...h){switch(h.length){case 1:return(0,E.localize)(11586,null,h[0]);case 2:return(0,E.localize)(11587,null,h[0],h[1]);case 3:return(0,E.localize)(11588,null,h[0],h[1],h[2]);default:return}}const D=(0,E.localize)(11589,null),v=(0,E.localize)(11590,null);class a{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(c){switch(c.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return c.isTripleEq?"===":"==";case R.NotEq:return c.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return c.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return c.lexeme;case R.QuotedStr:return c.lexeme;case R.Error:return c.lexeme;case R.EOF:return"EOF";default:throw(0,b.illegalState)(`unhandled token type: ${JSON.stringify(c)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0)))}static{this._keywords=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this._errors}reset(c){return this._input=c,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case I.CharCode.OpenParen:this._addToken(R.LParen);break;case I.CharCode.CloseParen:this._addToken(R.RParen);break;case I.CharCode.ExclamationMark:if(this._match(I.CharCode.Equals)){const p=this._match(I.CharCode.Equals);this._tokens.push({type:R.NotEq,offset:this._start,isTripleEq:p})}else this._addToken(R.Neg);break;case I.CharCode.SingleQuote:this._quotedString();break;case I.CharCode.Slash:this._regex();break;case I.CharCode.Equals:if(this._match(I.CharCode.Equals)){const p=this._match(I.CharCode.Equals);this._tokens.push({type:R.Eq,offset:this._start,isTripleEq:p})}else this._match(I.CharCode.Tilde)?this._addToken(R.RegexOp):this._error(A("==","=~"));break;case I.CharCode.LessThan:this._addToken(this._match(I.CharCode.Equals)?R.LtEq:R.Lt);break;case I.CharCode.GreaterThan:this._addToken(this._match(I.CharCode.Equals)?R.GtEq:R.Gt);break;case I.CharCode.Ampersand:this._match(I.CharCode.Ampersand)?this._addToken(R.And):this._error(A("&&"));break;case I.CharCode.Pipe:this._match(I.CharCode.Pipe)?this._addToken(R.Or):this._error(A("||"));break;case I.CharCode.Space:case I.CharCode.CarriageReturn:case I.CharCode.Tab:case I.CharCode.LineFeed:case I.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(R.EOF),Array.from(this._tokens)}_match(c){return this._isAtEnd()||this._input.charCodeAt(this._current)!==c?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?I.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(c){this._tokens.push({type:c,offset:this._start})}_error(c){const p=this._start,f=this._input.substring(this._start,this._current),g={type:R.Error,offset:this._start,lexeme:f};this._errors.push({offset:p,lexeme:f,additionalInfo:c}),this._tokens.push(g)}_string(){this.stringRe.lastIndex=this._start;const c=this.stringRe.exec(this._input);if(c){this._current=this._start+c[0].length;const p=this._input.substring(this._start,this._current),f=a._keywords.get(p);f?this._addToken(f):this._tokens.push({type:R.Str,lexeme:p,offset:this._start})}}_quotedString(){for(;this._peek()!==I.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(D);return}this._advance(),this._tokens.push({type:R.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let c=this._current,p=!1,f=!1;for(;;){if(c>=this._input.length){this._current=c,this._error(v);return}const C=this._input.charCodeAt(c);if(p)p=!1;else if(C===I.CharCode.Slash&&!f){c++;break}else C===I.CharCode.OpenSquareBracket?f=!0:C===I.CharCode.Backslash?p=!0:C===I.CharCode.CloseSquareBracket&&(f=!1);c++}for(;c<this._input.length&&a._regexFlags.has(this._input.charCodeAt(c));)c++;this._current=c;const g=this._input.substring(this._start,this._current);this._tokens.push({type:R.RegexStr,lexeme:g,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=a}),define(ue[93],de([0,1,89,55,14,15,36,16,11]),function(J,e,I,b,E,R,A,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=h,e.parseDebugParams=c,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,R.dirname)(E.FileAccess.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return v.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.paths.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,D.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",f)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(v.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?v.URI.file((0,R.join)(f,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,R.resolve)(f):(0,R.normalize)((0,R.join)(E.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?v.URI.file((0,R.resolve)(f)):v.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,R.resolve)(f);const g=A.env.VSCODE_EXTENSIONS;if(g)return g;const C=A.env.VSCODE_PORTABLE;return C?(0,R.join)(C,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(g=>/^[^:/?#]+?:\/\//.test(g)?v.URI.parse(g):v.URI.file((0,R.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?v.URI.parse(f):v.URI.file((0,R.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return h(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const g of this.args.log||[]){const C=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);C&&C[1]&&C[2]&&f.push([C[1],C[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,D.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?v.URI.file((0,R.join)(f,"policy.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this._args}constructor(f,g,C){this._args=f,this.paths=g,this.productService=C,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=a,we([b.memoize],a.prototype,"appRoot",null),we([b.memoize],a.prototype,"userHome",null),we([b.memoize],a.prototype,"userDataPath",null),we([b.memoize],a.prototype,"appSettingsHome",null),we([b.memoize],a.prototype,"tmpDir",null),we([b.memoize],a.prototype,"cacheHome",null),we([b.memoize],a.prototype,"stateResource",null),we([b.memoize],a.prototype,"userRoamingDataHome",null),we([b.memoize],a.prototype,"userDataSyncHome",null),we([b.memoize],a.prototype,"sync",null),we([b.memoize],a.prototype,"machineSettingsResource",null),we([b.memoize],a.prototype,"workspaceStorageHome",null),we([b.memoize],a.prototype,"localHistoryHome",null),we([b.memoize],a.prototype,"keyboardLayoutResource",null),we([b.memoize],a.prototype,"argvResource",null),we([b.memoize],a.prototype,"isExtensionDevelopment",null),we([b.memoize],a.prototype,"untitledWorkspacesHome",null),we([b.memoize],a.prototype,"builtinExtensionsPath",null),we([b.memoize],a.prototype,"extensionsPath",null),we([b.memoize],a.prototype,"extensionDevelopmentLocationURI",null),we([b.memoize],a.prototype,"extensionDevelopmentKind",null),we([b.memoize],a.prototype,"extensionTestsLocationURI",null),we([b.memoize],a.prototype,"debugExtensionHost",null),we([b.memoize],a.prototype,"logLevel",null),we([b.memoize],a.prototype,"extensionLogLevel",null),we([b.memoize],a.prototype,"serviceMachineIdResource",null),we([b.memoize],a.prototype,"disableTelemetry",null),we([b.memoize],a.prototype,"disableWorkspaceTrust",null),we([b.memoize],a.prototype,"useInMemorySecretStorage",null),we([b.memoize],a.prototype,"policyFile",null);function h(p,f){return c(p["inspect-extensions"],p["inspect-brk-extensions"],5870,f,p.debugId,p.extensionEnvironment)}function c(p,f,g,C,w,d){const O=Number(f||p)||(C?null:g),y=O?!!f:!1;let i;if(d)try{i=JSON.parse(d)}catch{}return{port:O,break:y,debugId:w,env:i}}}),function(){function J(e,I,b){function E(A,D){const v=R(A,D),a=[v];return e.isAbsolute(v)||a.unshift(b),e.resolve(...a)}function R(A,D){process.env.VSCODE_DEV&&(D="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,D);const h=A["user-data-dir"];if(h)return h;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const c=process.env.USERPROFILE;if(typeof c!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(c,"AppData","Roaming")}break;case"darwin":a=e.join(I.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,D)}return{getUserDataPath:E}}if(typeof define=="function")define(ue[94],de([148,35,36]),function(e,I,b){return J(e,I,b.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=J(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ue[95],de([0,1,35,93,94]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=A,e.parseSharedProcessDebugPort=D;class R extends b.AbstractNativeEnvironmentService{constructor(a,h){super(a,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,E.getUserDataPath)(a,h.nameShort)},h)}}e.NativeEnvironmentService=R;function A(v,a){return(0,b.parseDebugParams)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,a,v.extensionEnvironment)}function D(v,a){return(0,b.parseDebugParams)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,a,v.extensionEnvironment)}}),define(ue[96],de([0,1,3,5]),function(J,e,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=E;function E(A,D,v,a){try{R(A,D,v,a)}catch(h){A.error(h?.message??h)}return D}function R(A,D,v,a){const h=(c,p,f)=>{const g=c[p];if((0,I.isString)(g)){const C=g,w=C.length;if(w>1&&C[0]==="%"&&C[w-1]==="%"){const d=C.substr(1,w-2);let m=v[d];m===void 0&&a&&(m=a[d]);const O=typeof m=="string"?m:m?.message,y=a?.[d],i=typeof y=="string"?y:y?.message;if(!O){i||A.warn(`[${D.name}]: ${(0,b.localize)(11469,null,d)}`);return}if(f&&(p==="title"||p==="category")&&i&&i!==O){const l={value:O,original:i};c[p]=l}else c[p]=O}}else if((0,I.isObject)(g))for(const C in g)g.hasOwnProperty(C)&&(C==="commands"?h(g,C,!0):h(g,C,f));else if(Array.isArray(g))for(let C=0;C<g.length;C++)h(g,C,f)};for(const c in D)D.hasOwnProperty(c)&&h(D,c)}}),define(ue[97],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const I={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(I)}),define(ue[51],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(E,R=[],A=!1){this.ctor=E,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=I}),define(ue[98],de([0,1,51]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=R,e.getSingletonServiceDescriptors=A;const b=[];var E;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function R(D,v,a){v instanceof I.SyncDescriptor||(v=new I.SyncDescriptor(v,[],!!a)),b.push([D,v])}function A(){return b}}),define(ue[99],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class b{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const A of this._nodes.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const D=this.lookupOrInsertNode(R),v=this.lookupOrInsertNode(A);D.outgoing.set(v.key,v),v.incoming.set(D.key,D)}removeNode(R){const A=this._hashFn(R);this._nodes.delete(A);for(const D of this._nodes.values())D.outgoing.delete(A),D.incoming.delete(A)}lookupOrInsertNode(R){const A=this._hashFn(R);let D=this._nodes.get(A);return D||(D=new I(A,R),this._nodes.set(A,D)),D}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[A,D]of this._nodes)R.push(`${A}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this._nodes){const D=new Set([R]),v=this._findCycle(A,D);if(v)return v}}_findCycle(R,A){for(const[D,v]of R.outgoing){if(A.has(D))return[...A,D].join(" -> ");A.add(D);const a=this._findCycle(v,A);if(a)return a;A.delete(D)}}}e.Graph=b}),define(ue[30],de([0,1,3,11,10]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=R,e.isConfigurationUpdateOverrides=A,e.ConfigurationTargetToString=v,e.isConfigured=a,e.toValuesTree=h,e.addToValueTree=c,e.removeFromValueTree=p,e.getConfigurationValue=g,e.merge=C,e.getLanguageTagSettingPlainKey=w,I=Ee(I),e.IConfigurationService=(0,E.createDecorator)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof b.URI)}function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof b.URI)}var D;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(D||(e.ConfigurationTarget=D={}));function v(d){switch(d){case D.APPLICATION:return"APPLICATION";case D.USER:return"USER";case D.USER_LOCAL:return"USER_LOCAL";case D.USER_REMOTE:return"USER_REMOTE";case D.WORKSPACE:return"WORKSPACE";case D.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case D.DEFAULT:return"DEFAULT";case D.MEMORY:return"MEMORY"}}function a(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function h(d,m){const O=Object.create(null);for(const y in d)c(O,y,d[y],m);return O}function c(d,m,O,y){const i=m.split("."),l=i.pop();let r=d;for(let n=0;n<i.length;n++){const t=i[n];let s=r[t];switch(typeof s){case"undefined":s=r[t]=Object.create(null);break;case"object":if(s===null){y(`Ignoring ${m} as ${i.slice(0,n+1).join(".")} is null`);return}break;default:y(`Ignoring ${m} as ${i.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[l]=O}catch{y(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(r)}`)}else y(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(r)}`)}function p(d,m){const O=m.split(".");f(d,O)}function f(d,m){const O=m.shift();if(m.length===0){delete d[O];return}if(Object.keys(d).indexOf(O)!==-1){const y=d[O];typeof y=="object"&&!Array.isArray(y)&&(f(y,m),Object.keys(y).length===0&&delete d[O])}}function g(d,m,O){function y(r,n){let t=r;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const i=m.split("."),l=y(d,i);return typeof l>"u"?O:l}function C(d,m,O){Object.keys(m).forEach(y=>{y!=="__proto__"&&(y in d?I.isObject(d[y])&&I.isObject(m[y])?C(d[y],m[y],O):O&&(d[y]=m[y]):d[y]=m[y])})}function w(d){return d.replace(/[\[\]]/g,"")}}),define(ue[100],de([0,1,92,12,31,91,10,5,7]),function(J,e,I,b,E,R,A,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=h,e.validateWhenClauses=n,e.expressionsAreEqualWithConstantSubstitution=t,e.implies=ne;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",b.isMacintosh),a.set("isLinux",b.isLinux),a.set("isWindows",b.isWindows),a.set("isWeb",b.isWeb),a.set("isMacNative",b.isMacintosh&&!b.isWeb),a.set("isEdge",b.isEdge),a.set("isFirefox",b.isFirefox),a.set("isChrome",b.isChrome),a.set("isSafari",b.isSafari);function h(_,P){if(a.get(_)!==void 0)throw(0,v.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(_,P)}const c=Object.prototype.hasOwnProperty;var p;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const f={regexParsingWithErrorRecovery:!0},g=(0,D.localize)(11600,null),C=(0,D.localize)(11601,null),w=(0,D.localize)(11602,null),d=(0,D.localize)(11603,null),m=(0,D.localize)(11604,null),O=(0,D.localize)(11605,null),y=(0,D.localize)(11606,null),i=(0,D.localize)(11607,null);class l{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(P=f){this._config=P,this._scanner=new R.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(P){if(P===""){this._parsingErrors.push({message:g,offset:0,lexeme:"",additionalInfo:C});return}this._tokens=this._scanner.reset(P).scan(),this._current=0,this._parsingErrors=[];try{const M=this._expr();if(!this._isAtEnd()){const X=this._peek(),x=X.type===R.TokenType.Str?O:void 0;throw this._parsingErrors.push({message:m,offset:X.offset,lexeme:R.Scanner.getLexeme(X),additionalInfo:x}),l._parseError}return M}catch(M){if(M!==l._parseError)throw M;return}}_expr(){return this._or()}_or(){const P=[this._and()];for(;this._matchOne(R.TokenType.Or);){const M=this._and();P.push(M)}return P.length===1?P[0]:r.or(...P)}_and(){const P=[this._term()];for(;this._matchOne(R.TokenType.And);){const M=this._term();P.push(M)}return P.length===1?P[0]:r.and(...P)}_term(){if(this._matchOne(R.TokenType.Neg)){const P=this._peek();switch(P.type){case R.TokenType.True:return this._advance(),o.INSTANCE;case R.TokenType.False:return this._advance(),u.INSTANCE;case R.TokenType.LParen:{this._advance();const M=this._expr();return this._consume(R.TokenType.RParen,d),M?.negate()}case R.TokenType.Str:return this._advance(),U.create(P.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",P)}}return this._primary()}_primary(){const P=this._peek();switch(P.type){case R.TokenType.True:return this._advance(),r.true();case R.TokenType.False:return this._advance(),r.false();case R.TokenType.LParen:{this._advance();const M=this._expr();return this._consume(R.TokenType.RParen,d),M}case R.TokenType.Str:{const M=P.lexeme;if(this._advance(),this._matchOne(R.TokenType.RegexOp)){const x=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),x.type!==R.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",x);const W=x.lexeme,B=W.lastIndexOf("/"),re=B===W.length-1?void 0:this._removeFlagsGY(W.substring(B+1));let oe;try{oe=new RegExp(W.substring(1,B),re)}catch{throw this._errExpectedButGot("REGEX",x)}return fe.create(M,oe)}switch(x.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const W=[x.lexeme];this._advance();let B=this._peek(),re=0;for(let ve=0;ve<x.lexeme.length;ve++)x.lexeme.charCodeAt(ve)===I.CharCode.OpenParen?re++:x.lexeme.charCodeAt(ve)===I.CharCode.CloseParen&&re--;for(;!this._isAtEnd()&&B.type!==R.TokenType.And&&B.type!==R.TokenType.Or;){switch(B.type){case R.TokenType.LParen:re++;break;case R.TokenType.RParen:re--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let ve=0;ve<B.lexeme.length;ve++)B.lexeme.charCodeAt(ve)===I.CharCode.OpenParen?re++:x.lexeme.charCodeAt(ve)===I.CharCode.CloseParen&&re--}if(re<0)break;W.push(R.Scanner.getLexeme(B)),this._advance(),B=this._peek()}const oe=W.join(""),le=oe.lastIndexOf("/"),ye=le===oe.length-1?void 0:this._removeFlagsGY(oe.substring(le+1));let he;try{he=new RegExp(oe.substring(1,le),ye)}catch{throw this._errExpectedButGot("REGEX",x)}return r.regex(M,he)}case R.TokenType.QuotedStr:{const W=x.lexeme;this._advance();let B=null;if(!(0,E.isFalsyOrWhitespace)(W)){const re=W.indexOf("/"),oe=W.lastIndexOf("/");if(re!==oe&&re>=0){const le=W.slice(re+1,oe),ye=W[oe+1]==="i"?"i":"";try{B=new RegExp(le,ye)}catch{throw this._errExpectedButGot("REGEX",x)}}}if(B===null)throw this._errExpectedButGot("REGEX",x);return fe.create(M,B)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(R.TokenType.Not)){this._consume(R.TokenType.In,w);const x=this._value();return r.notIn(M,x)}switch(this._peek().type){case R.TokenType.Eq:{this._advance();const x=this._value();if(this._previous().type===R.TokenType.QuotedStr)return r.equals(M,x);switch(x){case"true":return r.has(M);case"false":return r.not(M);default:return r.equals(M,x)}}case R.TokenType.NotEq:{this._advance();const x=this._value();if(this._previous().type===R.TokenType.QuotedStr)return r.notEquals(M,x);switch(x){case"true":return r.not(M);case"false":return r.has(M);default:return r.notEquals(M,x)}}case R.TokenType.Lt:return this._advance(),ae.create(M,this._value());case R.TokenType.LtEq:return this._advance(),ce.create(M,this._value());case R.TokenType.Gt:return this._advance(),Y.create(M,this._value());case R.TokenType.GtEq:return this._advance(),te.create(M,this._value());case R.TokenType.In:return this._advance(),r.in(M,this._value());default:return r.has(M)}}case R.TokenType.EOF:throw this._parsingErrors.push({message:y,offset:P.offset,lexeme:"",additionalInfo:i}),l._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const P=this._peek();switch(P.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this._advance(),P.lexeme;case R.TokenType.True:return this._advance(),"true";case R.TokenType.False:return this._advance(),"false";case R.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(P){return P.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(P){return this._check(P)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(P,M){if(this._check(P))return this._advance();throw this._errExpectedButGot(M,this._peek())}_errExpectedButGot(P,M,X){const x=(0,D.localize)(11608,null,P,R.Scanner.getLexeme(M)),W=M.offset,B=R.Scanner.getLexeme(M);return this._parsingErrors.push({message:x,offset:W,lexeme:B,additionalInfo:X}),l._parseError}_check(P){return this._peek().type===P}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===R.TokenType.EOF}}e.Parser=l;class r{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(P){return S.create(P)}static equals(P,M){return T.create(P,M)}static notEquals(P,M){return k.create(P,M)}static regex(P,M){return fe.create(P,M)}static in(P,M){return N.create(P,M)}static notIn(P,M){return L.create(P,M)}static not(P){return U.create(P)}static and(...P){return z.create(P,null,!0)}static or(...P){return V.create(P,null,!0)}static greater(P,M){return Y.create(P,M)}static greaterEquals(P,M){return te.create(P,M)}static smaller(P,M){return ae.create(P,M)}static smallerEquals(P,M){return ce.create(P,M)}static{this._parser=new l({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this._parser.parse(P)}}e.ContextKeyExpr=r;function n(_){const P=new l({regexParsingWithErrorRecovery:!1});return _.map(M=>(P.parse(M),P.lexingErrors.length>0?P.lexingErrors.map(X=>({errorMessage:X.additionalInfo?(0,D.localize)(11609,null,X.additionalInfo):(0,D.localize)(11610,null),offset:X.offset,length:X.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(X=>({errorMessage:X.additionalInfo?`${X.message}. ${X.additionalInfo}`:X.message,offset:X.offset,length:X.lexeme.length})):[]))}function t(_,P){const M=_?_.substituteConstants():void 0,X=P?P.substituteConstants():void 0;return!M&&!X?!0:!M||!X?!1:M.equals(X)}function s(_,P){return _.cmp(P)}class o{static{this.INSTANCE=new o}constructor(){this.type=p.False}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=o;class u{static{this.INSTANCE=new u}constructor(){this.type=p.True}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return o.INSTANCE}}e.ContextKeyTrueExpr=u;class S{static create(P,M=null){const X=a.get(P);return typeof X=="boolean"?X?u.INSTANCE:o.INSTANCE:new S(P,M)}constructor(P,M){this.key=P,this.negated=M,this.type=p.Defined}cmp(P){return P.type!==this.type?this.type-P.type:H(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=a.get(this.key);return typeof P=="boolean"?P?u.INSTANCE:o.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=U.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class T{static create(P,M,X=null){if(typeof M=="boolean")return M?S.create(P,X):U.create(P,X);const x=a.get(P);return typeof x=="boolean"?M===(x?"true":"false")?u.INSTANCE:o.INSTANCE:new T(P,M,X)}constructor(P,M,X){this.key=P,this.value=M,this.negated=X,this.type=p.Equals}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=a.get(this.key);if(typeof P=="boolean"){const M=P?"true":"false";return this.value===M?u.INSTANCE:o.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=T;class N{static create(P,M){return new N(P,M)}constructor(P,M){this.key=P,this.valueKey=M,this.type=p.In,this.negated=null}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.valueKey),X=P.getValue(this.key);return Array.isArray(M)?M.includes(X):typeof X=="string"&&typeof M=="object"&&M!==null?c.call(M,X):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=L.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=N;class L{static create(P,M){return new L(P,M)}constructor(P,M){this.key=P,this.valueKey=M,this.type=p.NotIn,this._negated=N.create(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:this._negated.cmp(P._negated)}equals(P){return P.type===this.type?this._negated.equals(P._negated):!1}substituteConstants(){return this}evaluate(P){return!this._negated.evaluate(P)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(P){return P.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=L;class k{static create(P,M,X=null){if(typeof M=="boolean")return M?U.create(P,X):S.create(P,X);const x=a.get(P);return typeof x=="boolean"?M===(x?"true":"false")?o.INSTANCE:u.INSTANCE:new k(P,M,X)}constructor(P,M,X){this.key=P,this.value=M,this.negated=X,this.type=p.NotEquals}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=a.get(this.key);if(typeof P=="boolean"){const M=P?"true":"false";return this.value===M?o.INSTANCE:u.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=k;class U{static create(P,M=null){const X=a.get(P);return typeof X=="boolean"?X?o.INSTANCE:u.INSTANCE:new U(P,M)}constructor(P,M){this.key=P,this.negated=M,this.type=p.Not}cmp(P){return P.type!==this.type?this.type-P.type:H(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=a.get(this.key);return typeof P=="boolean"?P?o.INSTANCE:u.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=U;function G(_,P){if(typeof _=="string"){const M=parseFloat(_);isNaN(M)||(_=M)}return typeof _=="string"||typeof _=="number"?P(_):o.INSTANCE}class Y{static create(P,M,X=null){return G(M,x=>new Y(P,x,X))}constructor(P,M,X){this.key=P,this.value=M,this.negated=X,this.type=p.Greater}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ce.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=Y;class te{static create(P,M,X=null){return G(M,x=>new te(P,x,X))}constructor(P,M,X){this.key=P,this.value=M,this.negated=X,this.type=p.GreaterEquals}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ae.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=te;class ae{static create(P,M,X=null){return G(M,x=>new ae(P,x,X))}constructor(P,M,X){this.key=P,this.value=M,this.negated=X,this.type=p.Smaller}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=te.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=ae;class ce{static create(P,M,X=null){return G(M,x=>new ce(P,x,X))}constructor(P,M,X){this.key=P,this.value=M,this.negated=X,this.type=p.SmallerEquals}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ce;class fe{static create(P,M){return new fe(P,M)}constructor(P,M){this.key=P,this.regexp=M,this.type=p.Regex,this.negated=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const M=this.regexp?this.regexp.source:"",X=P.regexp?P.regexp.source:"";return M<X?-1:M>X?1:0}equals(P){if(P.type===this.type){const M=this.regexp?this.regexp.source:"",X=P.regexp?P.regexp.source:"";return this.key===P.key&&M===X}return!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=q.create(this)),this.negated}}e.ContextKeyRegexExpr=fe;class q{static create(P){return new q(P)}constructor(P){this._actual=P,this.type=p.NotRegex}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(P){return new q(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=q;function Q(_){let P=null;for(let M=0,X=_.length;M<X;M++){const x=_[M].substituteConstants();if(_[M]!==x&&P===null){P=[];for(let W=0;W<M;W++)P[W]=_[W]}P!==null&&(P[M]=x)}return P===null?_:P}class z{static create(P,M,X){return z._normalizeArr(P,M,X)}constructor(P,M){this.expr=P,this.negated=M,this.type=p.And}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,X=this.expr.length;M<X;M++){const x=s(this.expr[M],P.expr[M]);if(x!==0)return x}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,X=this.expr.length;M<X;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=Q(this.expr);return P===this.expr?this:z.create(P,this.negated,!1)}evaluate(P){for(let M=0,X=this.expr.length;M<X;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static _normalizeArr(P,M,X){const x=[];let W=!1;for(const B of P)if(B){if(B.type===p.True){W=!0;continue}if(B.type===p.False)return o.INSTANCE;if(B.type===p.And){x.push(...B.expr);continue}x.push(B)}if(x.length===0&&W)return u.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(s);for(let B=1;B<x.length;B++)x[B-1].equals(x[B])&&(x.splice(B,1),B--);if(x.length===1)return x[0];for(;x.length>1;){const B=x[x.length-1];if(B.type!==p.Or)break;x.pop();const re=x.pop(),oe=x.length===0,le=V.create(B.expr.map(ye=>z.create([ye,re],null,X)),null,oe);le&&(x.push(le),x.sort(s))}if(x.length===1)return x[0];if(X){for(let B=0;B<x.length;B++)for(let re=B+1;re<x.length;re++)if(x[B].negate().equals(x[re]))return o.INSTANCE;if(x.length===1)return x[0]}return new z(x,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new z(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.negated){const P=[];for(const M of this.expr)P.push(M.negate());this.negated=V.create(P,this,!0)}return this.negated}}e.ContextKeyAndExpr=z;class V{static create(P,M,X){return V._normalizeArr(P,M,X)}constructor(P,M){this.expr=P,this.negated=M,this.type=p.Or}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,X=this.expr.length;M<X;M++){const x=s(this.expr[M],P.expr[M]);if(x!==0)return x}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,X=this.expr.length;M<X;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=Q(this.expr);return P===this.expr?this:V.create(P,this.negated,!1)}evaluate(P){for(let M=0,X=this.expr.length;M<X;M++)if(this.expr[M].evaluate(P))return!0;return!1}static _normalizeArr(P,M,X){let x=[],W=!1;if(P){for(let B=0,re=P.length;B<re;B++){const oe=P[B];if(oe){if(oe.type===p.False){W=!0;continue}if(oe.type===p.True)return u.INSTANCE;if(oe.type===p.Or){x=x.concat(oe.expr);continue}x.push(oe)}}if(x.length===0&&W)return o.INSTANCE;x.sort(s)}if(x.length!==0){if(x.length===1)return x[0];for(let B=1;B<x.length;B++)x[B-1].equals(x[B])&&(x.splice(B,1),B--);if(x.length===1)return x[0];if(X){for(let B=0;B<x.length;B++)for(let re=B+1;re<x.length;re++)if(x[B].negate().equals(x[re]))return u.INSTANCE;if(x.length===1)return x[0]}return new V(x,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new V(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.negated){const P=[];for(const M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),X=P.shift(),x=[];for(const W of $(M))for(const B of $(X))x.push(z.create([W,B],null,!1));P.unshift(V.create(x,null,!1))}this.negated=V.create(P,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class K extends S{static{this._info=[]}static all(){return K._info.values()}constructor(P,M,X){super(P,null),this._defaultValue=M,typeof X=="object"?K._info.push({...X,key:P}):X!==!0&&K._info.push({key:P,description:X,type:M!=null?typeof M:void 0})}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return T.create(this.key,P)}notEqualsTo(P){return k.create(this.key,P)}}e.RawContextKey=K,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function H(_,P){return _<P?-1:_>P?1:0}function ie(_,P,M,X){return _<M?-1:_>M?1:P<X?-1:P>X?1:0}function ne(_,P){if(_.type===p.False||P.type===p.True)return!0;if(_.type===p.Or)return P.type===p.Or?F(_.expr,P.expr):!1;if(P.type===p.Or){for(const M of P.expr)if(ne(_,M))return!0;return!1}if(_.type===p.And){if(P.type===p.And)return F(P.expr,_.expr);for(const M of _.expr)if(ne(M,P))return!0;return!1}return _.equals(P)}function F(_,P){let M=0,X=0;for(;M<_.length&&X<P.length;){const x=_[M].cmp(P[X]);if(x<0)return!1;x===0&&M++,X++}return M===_.length}function $(_){return _.type===p.Or?_.expr:[_]}}),define(ue[61],de([0,1,10]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,I.createDecorator)("downloadService")}),define(ue[17],de([0,1,10]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ue[62],de([0,1,13,7,5,9]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=A;async function A(h,c,p,f,g,C){let w;try{await D(h,c,p,f,g,C)}catch(d){w=d}finally{w&&g.errorTransformer&&(w=g.errorTransformer(w)),typeof w<"u"&&p.error(w),p.end()}}async function D(h,c,p,f,g,C){v(C);const w=await h.open(c,{create:!1});try{v(C);let d=0,m=0,O=g&&typeof g.length=="number"?g.length:void 0,y=I.VSBuffer.alloc(Math.min(g.bufferSize,typeof O=="number"?O:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,l=0;do m=await h.read(w,i,y.buffer,l,y.byteLength-l),i+=m,l+=m,d+=m,typeof O=="number"&&(O-=m),l===y.byteLength&&(await p.write(f(y)),y=I.VSBuffer.alloc(Math.min(g.bufferSize,typeof O=="number"?O:g.bufferSize)),l=0);while(m>0&&(typeof O!="number"||O>0)&&v(C)&&a(d,g));if(l>0){let r=l;typeof O=="number"&&(r=Math.min(l,O)),p.write(f(y.slice(0,r)))}}catch(d){throw(0,R.ensureFileSystemProviderError)(d)}finally{await h.close(w)}}function v(h){if(h.isCancellationRequested)throw(0,b.canceled)();return!0}function a(h,c){if(typeof c?.limits?.size=="number"&&h>c.limits.size)throw(0,R.createFileSystemProviderError)((0,E.localize)(11385,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ue[101],de([0,1,32,2,52,4,9,11,8]),function(J,e,I,b,E,R,A,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class a extends b.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new R.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new b.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new v.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new v.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(c=>this.handleDidWatchFail(c)))}handleDidWatchFail(c){this.isCorrelated(c)&&this.suspendWatchRequest(c)}isCorrelated(c){return(0,E.isWatchRequestWithCorrelation)(c)}async watch(c){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new v.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const p of c)this.isCorrelated(p)?this.allCorrelatedWatchRequests.set(p.correlationId,p):this.allNonCorrelatedWatchRequests.add(p);for(const[p]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(p)||(this.suspendedWatchRequests.deleteAndDispose(p),this.suspendedWatchRequestsWithPolling.delete(p));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(c){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(p=>!this.suspendedWatchRequests.has(p.correlationId))]),c?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(c){return typeof c.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(c.correlationId)?"polling":this.suspendedWatchRequests.has(c.correlationId)}async suspendWatchRequest(c){if(this.suspendedWatchRequests.has(c.correlationId))return;const p=new b.DisposableStore;this.suspendedWatchRequests.set(c.correlationId,p),await this.joinWatch.p,!p.isDisposed&&(this.monitorSuspendedWatchRequest(c,p),this.updateWatchers(!0))}resumeWatchRequest(c){this.suspendedWatchRequests.deleteAndDispose(c.correlationId),this.suspendedWatchRequestsWithPolling.delete(c.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(c,p){this.doMonitorWithExistingWatcher(c,p)?(this.trace(`reusing an existing recursive watcher to monitor ${c.path}`),this.suspendedWatchRequestsWithPolling.delete(c.correlationId)):(this.doMonitorWithNodeJS(c,p),this.suspendedWatchRequestsWithPolling.add(c.correlationId))}doMonitorWithExistingWatcher(c,p){const f=this.recursiveWatcher?.subscribe(c.path,(g,C)=>{p.isDisposed||(g?this.monitorSuspendedWatchRequest(c,p):C?.type===A.FileChangeType.ADDED&&this.onMonitoredPathAdded(c))});return f?(p.add(f),!0):!1}doMonitorWithNodeJS(c,p){let f=!1;const g=(C,w)=>{if(p.isDisposed)return;const d=this.isPathNotFound(C),m=this.isPathNotFound(w),O=f;f=d,!d&&(m||O)&&this.onMonitoredPathAdded(c)};this.trace(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,I.watchFile)(c.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},g)}catch(C){this.warn(`fs.watchFile() failed with error ${C} on path ${c.path} (correlationId: ${c.correlationId})`)}p.add((0,b.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,I.unwatchFile)(c.path,g)}catch(C){this.warn(`fs.unwatchFile() failed with error ${C} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}onMonitoredPathAdded(c){this.trace(`detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const p={resource:D.URI.file(c.path),type:A.FileChangeType.ADDED,cId:c.correlationId};this._onDidChangeFile.fire([p]),this.traceEvent(p,c),this.resumeWatchRequest(c)}isPathNotFound(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(c,p){if(this.verboseLogging){const f=` >> normalized ${c.type===A.FileChangeType.ADDED?"[ADDED]":c.type===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.traceWithCorrelation(f,p)}}traceWithCorrelation(c,p){this.verboseLogging&&this.trace(`${c}${typeof p.correlationId=="number"?` <${p.correlationId}> `:""}`)}requestToString(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,E.requestFilterToString)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}async setVerboseLogging(c){this.verboseLogging=c}}e.BaseWatcher=a}),define(ue[102],de([0,1,4,149,101,12,150,63]),function(J,e,I,b,E,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class v extends E.BaseWatcher{constructor(h){super(),this.recursiveWatcher=h,this.onDidError=I.Event.None,this.watchers=new Set}async doWatch(h){h=this.removeDuplicateRequests(h);const c=[],p=new Set(Array.from(this.watchers));for(const f of h){const g=this.findWatcher(f);g&&(0,b.patternsEquals)(g.request.excludes,f.excludes)&&(0,b.patternsEquals)(g.request.includes,f.includes)?p.delete(g):c.push(f)}c.length&&this.trace(`Request to start watching: ${c.map(f=>this.requestToString(f)).join(",")}`),p.size&&this.trace(`Request to stop watching: ${Array.from(p).map(f=>this.requestToString(f.request)).join(",")}`);for(const f of p)this.stopWatching(f);for(const f of c)this.startWatching(f)}findWatcher(h){for(const c of this.watchers)if(typeof h.correlationId=="number"||typeof c.request.correlationId=="number"){if(c.request.correlationId===h.correlationId)return c}else if((0,D.isEqual)(c.request.path,h.path,!R.isLinux))return c}startWatching(h){const c=new A.NodeJSFileWatcherLibrary(h,this.recursiveWatcher,f=>this._onDidChangeFile.fire(f),()=>this._onDidWatchFail.fire(h),f=>this._onDidLogMessage.fire(f),this.verboseLogging),p={request:h,instance:c};this.watchers.add(p)}async stop(){await super.stop();for(const h of this.watchers)this.stopWatching(h)}stopWatching(h){this.trace("stopping file watcher",h),this.watchers.delete(h),h.instance.dispose()}removeDuplicateRequests(h){const c=new Map;for(const p of h){const f=R.isLinux?p.path:p.path.toLowerCase();let g=c.get(p.correlationId);g||(g=new Map,c.set(p.correlationId,g)),g.has(f)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(p)}`),g.set(f,p)}return Array.from(c.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(h){super.setVerboseLogging(h);for(const c of this.watchers)c.instance.setVerboseLogging(h)}trace(h,c){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(h,c)})}warn(h){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(h)})}toMessage(h,c){return c?`[File Watcher (node.js)] ${h} (${this.requestToString(c.request)})`:`[File Watcher (node.js)] ${h}`}}e.NodeJSWatcher=v}),define(ue[103],de([0,1,52,102]),function(J,e,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class E extends I.AbstractNonRecursiveWatcherClient{constructor(A,D,v){super(A,D,v),this.init()}createWatcher(A){return A.add(new b.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=E}),define(ue[104],de([0,1,14,59,87,52]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends R.AbstractUniversalWatcherClient{constructor(v,a,h){super(v,a,h),this.init()}createWatcher(v){const a=v.add(new E.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(a.onDidProcessExit(({code:h,signal:c})=>this.onError(`terminated by itself with code ${h}, signal: ${c} (ETERM)`))),b.ProxyChannel.toService((0,b.getNextTickChannel)(a.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ue[64],de([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...E){this._entries=new Map;for(const[R,A]of E)this.set(R,A)}set(E,R){const A=this._entries.get(E);return this._entries.set(E,R),A}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=I}),define(ue[105],de([0,1,8,7,2,51,99,10,64,151]),function(J,e,I,b,E,R,A,D,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const h=!1;class c extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class p{constructor(w=new v.ServiceCollection,d=!1,m,O=h){this._services=w,this._strict=d,this._parent=m,this._enableTracing=O,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(D.IInstantiationService,this),this._globalGraph=O?m?._globalGraph??new A.Graph(y=>y):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,E.dispose)(this._children),this._children.clear();for(const w of this._servicesToMaybeDispose)(0,E.isDisposable)(w)&&w.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(w,d){this._throwIfDisposed();const m=this,O=new class extends p{dispose(){m._children.delete(O),super.dispose()}}(w,this._strict,this,this._enableTracing);return this._children.add(O),d?.add(O),O}invokeFunction(w,...d){this._throwIfDisposed();const m=g.traceInvocation(this._enableTracing,w);let O=!1;try{return w({get:i=>{if(O)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(i,m);if(!l)throw new Error(`[invokeFunction] unknown service '${i}'`);return l}},...d)}finally{O=!0,m.stop()}}createInstance(w,...d){this._throwIfDisposed();let m,O;return w instanceof R.SyncDescriptor?(m=g.traceCreation(this._enableTracing,w.ctor),O=this._createInstance(w.ctor,w.staticArguments.concat(d),m)):(m=g.traceCreation(this._enableTracing,w),O=this._createInstance(w,d,m)),m.stop(),O}_createInstance(w,d=[],m){const O=D._util.getServiceDependencies(w).sort((l,r)=>l.index-r.index),y=[];for(const l of O){const r=this._getOrCreateServiceInstance(l.id,m);r||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${l.id}.`,!1),y.push(r)}const i=O.length>0?O[0].index:d.length;if(d.length!==i){console.trace(`[createInstance] First service dependency of ${w.name} at position ${i+1} conflicts with ${d.length} static arguments`);const l=i-d.length;l>0?d=d.concat(new Array(l)):d=d.slice(0,i)}return Reflect.construct(w,d.concat(y))}_setCreatedServiceInstance(w,d){if(this._services.get(w)instanceof R.SyncDescriptor)this._services.set(w,d);else if(this._parent)this._parent._setCreatedServiceInstance(w,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const d=this._services.get(w);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):d}_getOrCreateServiceInstance(w,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(w));const m=this._getServiceInstanceOrDescriptor(w);return m instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,m,d.branch(w,!0)):(d.branch(w,!1),m)}_safeCreateAndCacheServiceInstance(w,d,m){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,d,m)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,d,m){const O=new A.Graph(r=>r.id.toString());let y=0;const i=[{id:w,desc:d,_trace:m}],l=new Set;for(;i.length;){const r=i.pop();if(!l.has(String(r.id))){if(l.add(String(r.id)),O.lookupOrInsertNode(r),y++>1e3)throw new c(O);for(const n of D._util.getServiceDependencies(r.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(n.id);if(t||this._throwIfStrict(`[createInstance] ${w} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(n.id)),t instanceof R.SyncDescriptor){const s={id:n.id,desc:t,_trace:r._trace.branch(n.id,!0)};O.insertEdge(r,s),i.push(s)}}}}for(;;){const r=O.roots();if(r.length===0){if(!O.isEmpty())throw new c(O);break}for(const{data:n}of r){if(this._getServiceInstanceOrDescriptor(n.id)instanceof R.SyncDescriptor){const s=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setCreatedServiceInstance(n.id,s)}O.removeNode(n)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,d,m=[],O,y){if(this._services.get(w)instanceof R.SyncDescriptor)return this._createServiceInstance(w,d,m,O,y,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,d,m,O,y);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(w,d,m=[],O,y,i){if(O){const l=new p(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(w);const r=new Map,n=new I.GlobalIdleValue(()=>{const t=l._createInstance(d,m,y);for(const[s,o]of r){const u=t[s];if(typeof u=="function")for(const S of o)S.disposable=u.apply(t,S.listener)}return r.clear(),i.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let S=r.get(s);return S||(S=new a.LinkedList,r.set(s,S)),(N,L,k)=>{if(n.isInitialized)return n.value[s](N,L,k);{const U={listener:[N,L,k],disposable:void 0},G=S.push(U);return(0,E.toDisposable)(()=>{G(),U.disposable?.dispose()})}}}if(s in t)return t[s];const o=n.value;let u=o[s];return typeof u!="function"||(u=u.bind(o),t[s]=u),u},set(t,s,o){return n.value[s]=o,!0},getPrototypeOf(t){return d.prototype}})}else{const l=this._createInstance(d,m,y);return i.add(l),l}}_throwIfStrict(w,d){if(d&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=p;var f;(function(C){C[C.None=0]="None",C[C.Creation=1]="Creation",C[C.Invocation=2]="Invocation",C[C.Branch=3]="Branch"})(f||(f={}));class g{static{this.all=new Set}static{this._None=new class extends g{constructor(){super(f.None,null)}stop(){}branch(){return this}}}static traceInvocation(w,d){return w?new g(f.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(w,d){return w?new g(f.Creation,d.name):g._None}static{this._totals=0}constructor(w,d){this.type=w,this.name=d,this._start=Date.now(),this._dep=[]}branch(w,d){const m=new g(f.Branch,w.toString());return this._dep.push([w,d,m]),m}stop(){const w=Date.now()-this._start;g._totals+=w;let d=!1;function m(y,i){const l=[],r=new Array(y+1).join("	");for(const[n,t,s]of i._dep)if(t&&s){d=!0,l.push(`${r}CREATES -> ${n}`);const o=m(y+1,s);o&&l.push(o)}else l.push(`${r}uses -> ${n}`);return l.join(`
`)}const O=[`${this.type===f.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(w>2||d)&&g.all.add(O.join(`
`))}}e.Trace=g}),define(ue[6],de([0,1,5,38,4,43,2,25,12,16,3,11,100,10]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=C,e.log=d,e.getLogLevel=u,e.LogLevelToString=S,e.LogLevelToLocalizedString=T,e.parseLogLevel=N,I=Ee(I),e.ILogService=(0,f.createDecorator)("logService"),e.ILoggerService=(0,f.createDecorator)("loggerService");function g(){return new Date().toISOString()}function C(L){return(0,h.isNumber)(L)}var w;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function d(L,k,U){switch(k){case w.Trace:L.trace(U);break;case w.Debug:L.debug(U);break;case w.Info:L.info(U);break;case w.Warning:L.warn(U);break;case w.Error:L.error(U);break;case w.Off:break;default:throw new Error(`Invalid log level ${k}`)}}function m(L,k=!1){let U="";for(let G=0;G<L.length;G++){let Y=L[G];if(Y instanceof Error&&(Y=(0,b.toErrorMessage)(Y,k)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}U+=(G>0?" ":"")+Y}return U}class O extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(k){this.level!==k&&(this.level=k,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(k){return this.level!==w.Off&&this.level<=k}}e.AbstractLogger=O;class y extends O{constructor(k){super(),this.logAlways=k}checkLogLevel(k){return this.logAlways||super.checkLogLevel(k)}trace(k,...U){this.checkLogLevel(w.Trace)&&this.log(w.Trace,m([k,...U],!0))}debug(k,...U){this.checkLogLevel(w.Debug)&&this.log(w.Debug,m([k,...U]))}info(k,...U){this.checkLogLevel(w.Info)&&this.log(w.Info,m([k,...U]))}warn(k,...U){this.checkLogLevel(w.Warning)&&this.log(w.Warning,m([k,...U]))}error(k,...U){if(this.checkLogLevel(w.Error))if(k instanceof Error){const G=Array.prototype.slice.call(arguments);G[0]=k.stack,this.log(w.Error,m(G))}else this.log(w.Error,m([k,...U]))}flush(){}}e.AbstractMessageLogger=y;class i extends O{constructor(k=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(k),this.useColors=!v.isWindows}trace(k,...U){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,k,...U):console.log(`[main ${g()}]`,k,...U))}debug(k,...U){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,k,...U):console.log(`[main ${g()}]`,k,...U))}info(k,...U){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,k,...U):console.log(`[main ${g()}]`,k,...U))}warn(k,...U){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,k,...U):console.warn(`[main ${g()}]`,k,...U))}error(k,...U){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,k,...U):console.error(`[main ${g()}]`,k,...U))}flush(){}}e.ConsoleMainLogger=i;class l extends O{constructor(k=e.DEFAULT_LOG_LEVEL,U=!0){super(),this.useColors=U,this.setLevel(k)}trace(k,...U){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",k,...U):console.log(k,...U))}debug(k,...U){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",k,...U):console.log(k,...U))}info(k,...U){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",k,...U):console.log(k,...U))}warn(k,...U){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",k,...U):console.log(k,...U))}error(k,...U){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",k,...U):console.error(k,...U))}flush(){}}e.ConsoleLogger=l;class r extends O{constructor(k,U=e.DEFAULT_LOG_LEVEL){super(),this.adapter=k,this.setLevel(U)}trace(k,...U){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(k),...U])}debug(k,...U){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(k),...U])}info(k,...U){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(k),...U])}warn(k,...U){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(k),...U])}error(k,...U){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(k),...U])}extractMessage(k){return typeof k=="string"?k:(0,b.toErrorMessage)(k,this.checkLogLevel(w.Trace))}flush(){}}e.AdapterLogger=r;class n extends O{constructor(k){super(),this.loggers=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const U of this.loggers)U.setLevel(k);super.setLevel(k)}trace(k,...U){for(const G of this.loggers)G.trace(k,...U)}debug(k,...U){for(const G of this.loggers)G.debug(k,...U)}info(k,...U){for(const G of this.loggers)G.info(k,...U)}warn(k,...U){for(const G of this.loggers)G.warn(k,...U)}error(k,...U){for(const G of this.loggers)G.error(k,...U)}flush(){for(const k of this.loggers)k.flush()}dispose(){for(const k of this.loggers)k.dispose();super.dispose()}}e.MultiplexLogger=n;class t extends A.Disposable{constructor(k,U,G){if(super(),this.logLevel=k,this.logsHome=U,this._loggers=new D.ResourceMap,this._onDidChangeLoggers=this._register(new E.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new E.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,G)for(const Y of G)this._loggers.set(Y.resource,{logger:void 0,info:Y})}getLoggerEntry(k){return(0,h.isString)(k)?[...this._loggers.values()].find(U=>U.info.id===k):this._loggers.get(k)}getLogger(k){return this.getLoggerEntry(k)?.logger}createLogger(k,U){const G=this.toResource(k),Y=(0,h.isString)(k)?k:U?.id??(0,R.hash)(G.toString()).toString(16);let te=this._loggers.get(G)?.logger;const ae=U?.logLevel==="always"?w.Trace:U?.logLevel;te||(te=this.doCreateLogger(G,ae??this.getLogLevel(G)??this.logLevel,{...U,id:Y}));const ce={logger:te,info:{resource:G,id:Y,logLevel:ae,name:U?.name,hidden:U?.hidden,extensionId:U?.extensionId,when:U?.when}};return this.registerLogger(ce.info),this._loggers.set(G,ce),te}toResource(k){return(0,h.isString)(k)?(0,a.joinPath)(this.logsHome,`${k}.log`):k}setLogLevel(k,U){if(c.URI.isUri(k)){const G=k,Y=U,te=this._loggers.get(G);te&&Y!==te.info.logLevel&&(te.info.logLevel=Y===this.logLevel?void 0:Y,te.logger?.setLevel(Y),this._loggers.set(te.info.resource,te),this._onDidChangeLogLevel.fire([G,Y]))}else{this.logLevel=k;for(const[G,Y]of this._loggers.entries())this._loggers.get(G)?.info.logLevel===void 0&&Y.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(k,U){const G=this.getLoggerEntry(k);G&&U!==!G.info.hidden&&(G.info.hidden=!U,this._loggers.set(G.info.resource,G),this._onDidChangeVisibility.fire([G.info.resource,U]))}getLogLevel(k){let U;return k&&(U=this._loggers.get(k)?.info.logLevel),U??this.logLevel}registerLogger(k){const U=this._loggers.get(k.resource);U?U.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this._loggers.set(k.resource,{info:k,logger:void 0}),this._onDidChangeLoggers.fire({added:[k],removed:[]}))}deregisterLogger(k){const U=this._loggers.get(k);U&&(U.logger&&U.logger.dispose(),this._loggers.delete(k),this._onDidChangeLoggers.fire({added:[],removed:[U.info]}))}*getRegisteredLoggers(){for(const k of this._loggers.values())yield k.info}getRegisteredLogger(k){return this._loggers.get(k)?.info}dispose(){this._loggers.forEach(k=>k.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=t;class s{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(k){}getLevel(){return w.Info}trace(k,...U){}debug(k,...U){}info(k,...U){}warn(k,...U){}error(k,...U){}critical(k,...U){}dispose(){}flush(){}}e.NullLogger=s;class o extends s{}e.NullLogService=o;function u(L){if(L.verbose)return w.Trace;if(typeof L.logLevel=="string"){const k=N(L.logLevel.toLowerCase());if(k!==void 0)return k}return e.DEFAULT_LOG_LEVEL}function S(L){switch(L){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function T(L){switch(L){case w.Trace:return{original:"Trace",value:I.localize(11319,null)};case w.Debug:return{original:"Debug",value:I.localize(11320,null)};case w.Info:return{original:"Info",value:I.localize(11321,null)};case w.Warning:return{original:"Warning",value:I.localize(11322,null)};case w.Error:return{original:"Error",value:I.localize(11323,null)};case w.Off:return{original:"Off",value:I.localize(11324,null)}}}function N(L){switch(L){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.CONTEXT_LOG_LEVEL=new p.RawContextKey("logLevel",S(w.Info))}),define(ue[106],de([0,1,19,8,7,4,63,2,15,52,6]),function(J,e,I,b,E,R,A,D,v,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class c extends D.Disposable{constructor(f,g){super(),this.logService=f,this.options=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new b.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}watch(f,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,g):this.watchNonRecursive(f,g)}watchUniversal(f,g){const C={path:this.toWatchPath(f),excludes:g.excludes,includes:g.includes,recursive:g.recursive,filter:g.filter,correlationId:g.correlationId},w=(0,I.insert)(this.universalWatchRequests,C);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,E.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,a.reviveFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const g of this.universalWatchRequests)(0,a.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const g of this.universalWatchRequests)(0,a.isRecursiveWatchRequest)(g)&&f.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(f,g){const C={path:this.toWatchPath(f),excludes:g.excludes,includes:g.includes,recursive:!1,filter:g.filter,correlationId:g.correlationId},w=(0,I.insert)(this.nonRecursiveWatchRequests,C);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,E.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,a.reviveFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logWatcherMessage(f)}logWatcherMessage(f){this.logService[f.type](f.message)}toFilePath(f){return(0,v.normalize)(f.fsPath)}toWatchPath(f){const g=this.toFilePath(f);return(0,A.removeTrailingPathSeparator)(g)}}e.AbstractDiskFileSystemProvider=c});var se=this&&this.__param||function(J,e){return function(I,b){e(I,b,J)}};define(ue[107],de([0,1,19,8,13,21,4,43,65,2,49,14,108,16,47,5,9,62,6,7]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d,m,O){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let i=class extends a.Disposable{static{y=this}constructor(r){super(),this.logService=r,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new A.Emitter),this._onDidUncorrelatedFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(r,n){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${r}`);const t=new a.DisposableStore;return this.provider.set(r,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:n}),t.add(n.onDidChangeFile(s=>{const o=new w.FileChangesEvent(s,!this.isPathCaseSensitive(n));this.internalOnDidFilesChange.fire(o),o.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(o)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:r}))),(0,a.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:n}),this.provider.delete(r),(0,a.dispose)(t)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(t){n.push(t)}}),!this.provider.has(r)&&await b.Promises.settled(n)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.provider.has(r.scheme)}hasCapability(r,n){const t=this.provider.get(r.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return v.Iterable.map(this.provider,([r,n])=>({scheme:r,capabilities:n.capabilities}))}async withProvider(r){if(!(0,f.isAbsolutePath)(r))throw new w.FileOperationError((0,C.localize)(11392,null,this.resourceForError(r)),w.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(r.scheme);const n=this.provider.get(r.scheme);if(!n){const t=new O.ErrorNoTelemetry;throw t.message=(0,C.localize)(11393,null,r.toString()),t}return n}async withReadProvider(r){const n=await this.withProvider(r);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)||(0,w.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const n=await this.withProvider(r);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,n){try{return await this.doResolveFile(r,n)}catch(t){throw(0,w.toFileSystemProviderErrorCode)(t)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,C.localize)(11394,null,this.resourceForError(r)),w.FileOperationResult.FILE_NOT_FOUND):(0,w.ensureFileSystemProviderError)(t)}}async doResolveFile(r,n){const t=await this.withProvider(r),s=this.isPathCaseSensitive(t),o=n?.resolveTo,u=n?.resolveSingleChildDescendants,S=n?.resolveMetadata,T=await t.stat(r);let N;return this.toFileStat(t,r,T,void 0,!!S,(L,k)=>(N||(N=h.TernarySearchTree.forUris(()=>!s),N.set(r,!0),o&&N.fill(!0,o)),N.get(L.resource)||N.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&u?k===1:!1))}async toFileStat(r,n,t,s,o,u){const{providerExtUri:S}=this.getExtUri(r),T={resource:n,name:S.basename(n),isFile:(t.type&w.FileType.File)!==0,isDirectory:(t.type&w.FileType.Directory)!==0,isSymbolicLink:(t.type&w.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&w.FilePermission.Readonly)||!!(r.capabilities&w.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&w.FilePermission.Locked),etag:(0,w.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(T.isDirectory&&u(T,s)){try{const N=await r.readdir(n),L=await b.Promises.settled(N.map(async([k,U])=>{try{const G=S.joinPath(n,k),Y=o?await r.stat(G):{type:U};return await this.toFileStat(r,G,Y,N.length,o,u)}catch(G){return this.logService.trace(G),null}}));T.children=(0,I.coalesce)(L)}catch(N){this.logService.trace(N),T.children=[]}return T}return T}async resolveAll(r){return b.Promises.settled(r.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async stat(r){const n=await this.withProvider(r),t=await n.stat(r);return this.toFileStat(n,r,t,void 0,!0,()=>!1)}async exists(r){const n=await this.withProvider(r);try{return!!await n.stat(r)}catch{return!1}}async canCreateFile(r,n){try{await this.doValidateCreateFile(r,n)}catch(t){return t}return!0}async doValidateCreateFile(r,n){if(!n?.overwrite&&await this.exists(r))throw new w.FileOperationError((0,C.localize)(11395,null,this.resourceForError(r)),w.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(r,n=E.VSBuffer.fromString(""),t){await this.doValidateCreateFile(r,t);const s=await this.writeFile(r,n);return this._onDidRunOperation.fire(new w.FileOperationEvent(r,w.FileOperation.CREATE,s)),s}async writeFile(r,n,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:o}=this.getExtUri(s);let u=t;if((0,w.hasFileAtomicWriteCapability)(s)&&!u?.atomic){const S=s.enforceAtomicWriteFile?.(r);S&&(u={...t,atomic:S})}try{await this.validateWriteFile(s,r,u)||await this.mkdirp(s,o.dirname(r));let T;if((0,w.hasReadWriteCapability)(s)&&!(n instanceof E.VSBuffer))if((0,g.isReadableStream)(n)){const N=await(0,g.peekStream)(n,3);N.ended?T=E.VSBuffer.concat(N.buffer):T=N}else T=(0,g.peekReadable)(n,N=>E.VSBuffer.concat(N),3);else T=n;!(0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasReadWriteCapability)(s)&&T instanceof E.VSBuffer||(0,w.hasReadWriteCapability)(s)&&(0,w.hasFileAtomicWriteCapability)(s)&&u?.atomic?await this.doWriteUnbuffered(s,r,u,T):await this.doWriteBuffered(s,r,u,T instanceof E.VSBuffer?(0,E.bufferToReadable)(T):T),this._onDidRunOperation.fire(new w.FileOperationEvent(r,w.FileOperation.WRITE))}catch(S){throw new w.FileOperationError((0,C.localize)(11396,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(S).toString()),(0,w.toFileOperationResult)(S),u)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,n,t){const s=!!t?.unlock;if(s&&!(r.capabilities&w.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,C.localize)(11397,null,this.resourceForError(n)));if(!!t?.atomic){if(!(r.capabilities&w.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,C.localize)(11398,null,this.resourceForError(n)));if(!(r.capabilities&w.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,C.localize)(11399,null,this.resourceForError(n)));if(s)throw new Error((0,C.localize)(11400,null,this.resourceForError(n)))}let u;try{u=await r.stat(n)}catch{return}if(u.type&w.FileType.Directory)throw new w.FileOperationError((0,C.localize)(11401,null,this.resourceForError(n)),w.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.throwIfFileIsReadonly(n,u),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==w.ETAG_DISABLED&&typeof u.mtime=="number"&&typeof u.size=="number"&&t.mtime<u.mtime&&t.etag!==(0,w.etag)({mtime:t.mtime,size:u.size}))throw new w.FileOperationError((0,C.localize)(11402,null),w.FileOperationResult.FILE_MODIFIED_SINCE,t);return u}async readFile(r,n,t){const s=await this.withReadProvider(r);return n?.atomic?this.doReadFileAtomic(s,r,n,t):this.doReadFile(s,r,n,t)}async doReadFileAtomic(r,n,t,s){return new Promise((o,u)=>{this.writeQueue.queueFor(n,async()=>{try{const S=await this.doReadFile(r,n,t,s);o(S)}catch(S){u(S)}},this.getExtUri(r).providerExtUri)})}async doReadFile(r,n,t,s){const o=await this.doReadFileStream(r,n,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,E.streamToBuffer)(o.value)}}async readFileStream(r,n,t){const s=await this.withReadProvider(r);return this.doReadFileStream(s,r,n,t)}async doReadFileStream(r,n,t,s){const o=new R.CancellationTokenSource(s);let u=t;(0,w.hasFileAtomicReadCapability)(r)&&r.enforceAtomicReadFile?.(n)&&(u={...t,atomic:!0});const S=this.validateReadFile(n,u).then(N=>N,N=>{throw o.dispose(!0),N});let T;try{return typeof u?.etag=="string"&&u.etag!==w.ETAG_DISABLED&&await S,u?.atomic&&(0,w.hasFileAtomicReadCapability)(r)||!((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasFileReadStreamCapability)(r))||(0,w.hasReadWriteCapability)(r)&&u?.preferUnbuffered?T=this.readFileUnbuffered(r,n,u):(0,w.hasFileReadStreamCapability)(r)?T=this.readFileStreamed(r,n,o.token,u):T=this.readFileBuffered(r,n,o.token,u),T.on("end",()=>o.dispose()),T.on("error",()=>o.dispose()),{...await S,value:T}}catch(N){throw T&&await(0,g.consumeStream)(T),this.restoreReadError(N,n,u)}}restoreReadError(r,n,t){const s=(0,C.localize)(11403,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(r).toString());return r instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(s,r.stat,t):r instanceof w.TooLargeFileOperationError?new w.TooLargeFileOperationError(s,r.fileOperationResult,r.size,r.options):new w.FileOperationError(s,(0,w.toFileOperationResult)(r),t)}readFileStreamed(r,n,t,s=Object.create(null)){const o=r.readFileStream(n,s,t);return(0,g.transform)(o,{data:u=>u instanceof E.VSBuffer?u:E.VSBuffer.wrap(u),error:u=>this.restoreReadError(u,n,s)},u=>E.VSBuffer.concat(u))}readFileBuffered(r,n,t,s=Object.create(null)){const o=(0,E.newWriteableBufferStream)();return(0,d.readFileIntoStream)(r,n,o,u=>u,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:u=>this.restoreReadError(u,n,s)},t),o}readFileUnbuffered(r,n,t){const s=(0,g.newWriteableStream)(o=>E.VSBuffer.concat(o));return(async()=>{try{let o;t?.atomic&&(0,w.hasFileAtomicReadCapability)(r)?o=await r.readFile(n,{atomic:!0}):o=await r.readFile(n),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.validateReadFileLimits(n,o.byteLength,t),s.end(E.VSBuffer.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async validateReadFile(r,n){const t=await this.resolve(r,{resolveMetadata:!0});if(t.isDirectory)throw new w.FileOperationError((0,C.localize)(11404,null,this.resourceForError(r)),w.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&n.etag===t.etag)throw new w.NotModifiedSinceFileOperationError((0,C.localize)(11405,null),t,n);return this.validateReadFileLimits(r,t.size,n),t}validateReadFileLimits(r,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new w.TooLargeFileOperationError((0,C.localize)(11406,null,this.resourceForError(r)),w.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(r,n,t){return this.doCanMoveCopy(r,n,"move",t)}async canCopy(r,n,t){return this.doCanMoveCopy(r,n,"copy",t)}async doCanMoveCopy(r,n,t,s){if(r.toString()!==n.toString())try{const o=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(o,r,u,n,t,s)}catch(o){return o}return!0}async move(r,n,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),u=await this.doMoveCopy(s,r,o,n,"move",!!t),S=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(r,u==="move"?w.FileOperation.MOVE:w.FileOperation.COPY,S)),S}async copy(r,n,t){const s=await this.withReadProvider(r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),u=await this.doMoveCopy(s,r,o,n,"copy",!!t),S=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(r,u==="copy"?w.FileOperation.COPY:w.FileOperation.MOVE,S)),S}async doMoveCopy(r,n,t,s,o,u){if(n.toString()===s.toString())return o;const{exists:S,isSameResourceWithDifferentPathCase:T}=await this.doValidateMoveCopy(r,n,t,s,o,u);if(S&&!T&&u&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),o==="copy"){if(r===t&&(0,w.hasFileFolderCopyCapability)(r))await r.copy(n,s,{overwrite:u});else{const N=await this.resolve(n);N.isDirectory?await this.doCopyFolder(r,N,t,s):await this.doCopyFile(r,n,t,s)}return o}else return r===t?(await r.rename(n,s,{overwrite:u}),o):(await this.doMoveCopy(r,n,t,s,"copy",u),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(r,n,t,s){if((0,w.hasOpenReadWriteCloseCapability)(r)&&(0,w.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(r,n,t,s);if((0,w.hasOpenReadWriteCloseCapability)(r)&&(0,w.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(r,n,t,s);if((0,w.hasReadWriteCapability)(r)&&(0,w.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(r,n,t,s);if((0,w.hasReadWriteCapability)(r)&&(0,w.hasReadWriteCapability)(t))return this.doPipeUnbuffered(r,n,t,s)}async doCopyFolder(r,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await b.Promises.settled(n.children.map(async o=>{const u=this.getExtUri(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.doCopyFolder(r,await this.resolve(o.resource),t,u):this.doCopyFile(r,o.resource,t,u)}))}async doValidateMoveCopy(r,n,t,s,o,u){let S=!1;if(r===t){const{providerExtUri:N,isPathCaseSensitive:L}=this.getExtUri(r);if(L||(S=N.isEqual(n,s)),S&&o==="copy")throw new Error((0,C.localize)(11407,null,this.resourceForError(n),this.resourceForError(s)));if(!S&&N.isEqualOrParent(s,n))throw new Error((0,C.localize)(11408,null,this.resourceForError(n),this.resourceForError(s)))}const T=await this.exists(s);if(T&&!S){if(!u)throw new w.FileOperationError((0,C.localize)(11409,null,this.resourceForError(n),this.resourceForError(s)),w.FileOperationResult.FILE_MOVE_CONFLICT);if(r===t){const{providerExtUri:N}=this.getExtUri(r);if(N.isEqualOrParent(n,s))throw new Error((0,C.localize)(11410,null,this.resourceForError(n),this.resourceForError(s)))}}return{exists:T,isSameResourceWithDifferentPathCase:S}}getExtUri(r){const n=this.isPathCaseSensitive(r);return{providerExtUri:n?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(r){return!!(r.capabilities&w.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(r){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(n,r);const t=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(r,w.FileOperation.CREATE,t)),t}async mkdirp(r,n){const t=[],{providerExtUri:s}=this.getExtUri(r);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await r.stat(n)).type&w.FileType.Directory))throw new Error((0,C.localize)(11411,null,this.resourceForError(n)));break}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(n)),n=s.dirname(n)}for(let o=t.length-1;o>=0;o--){n=s.joinPath(n,t[o]);try{await r.mkdir(n)}catch(u){if((0,w.toFileSystemProviderErrorCode)(u)!==w.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(r,n){try{await this.doValidateDelete(r,n)}catch(t){return t}return!0}async doValidateDelete(r,n){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r),s=!!n?.useTrash;if(s&&!(t.capabilities&w.FileSystemProviderCapabilities.Trash))throw new Error((0,C.localize)(11412,null,this.resourceForError(r)));const o=n?.atomic;if(o&&!(t.capabilities&w.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,C.localize)(11413,null,this.resourceForError(r)));if(s&&o)throw new Error((0,C.localize)(11414,null,this.resourceForError(r)));let u;try{u=await t.stat(r)}catch{}if(u)this.throwIfFileIsReadonly(r,u);else throw new w.FileOperationError((0,C.localize)(11415,null,this.resourceForError(r)),w.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const T=await this.resolve(r);if(T.isDirectory&&Array.isArray(T.children)&&T.children.length>0)throw new Error((0,C.localize)(11416,null,this.resourceForError(r)))}return t}async del(r,n){const t=await this.doValidateDelete(r,n);let s=n;if((0,w.hasFileAtomicDeleteCapability)(t)&&!s?.atomic){const T=t.enforceAtomicDelete?.(r);T&&(s={...n,atomic:T})}const o=!!s?.useTrash,u=!!s?.recursive,S=s?.atomic??!1;await t.delete(r,{recursive:u,useTrash:o,atomic:S}),this._onDidRunOperation.fire(new w.FileOperationEvent(r,w.FileOperation.DELETE))}async cloneFile(r,n){const t=await this.withProvider(r),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(!(t===s&&this.getExtUri(t).providerExtUri.isEqual(r,n)))return t===s&&(0,w.hasFileCloneCapability)(t)?t.cloneFile(r,n):(await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(n)),t===s&&(0,w.hasFileFolderCopyCapability)(t)?this.writeQueue.queueFor(r,()=>t.copy(r,n,{overwrite:!0}),this.getExtUri(t).providerExtUri):this.writeQueue.queueFor(r,()=>this.doCopyFile(t,r,s,n),this.getExtUri(t).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(r,n){return this.watch(r,{...n,correlationId:y.WATCHER_CORRELATION_IDS++})}watch(r,n={recursive:!1,excludes:[]}){const t=new a.DisposableStore;let s=!1,o=()=>{s=!0};t.add((0,a.toDisposable)(()=>o())),(async()=>{try{const S=await this.doWatch(r,n);s?(0,a.dispose)(S):o=()=>(0,a.dispose)(S)}catch(S){this.logService.error(S)}})();const u=n.correlationId;if(typeof u=="number"){const S=t.add(new A.Emitter);return t.add(this.internalOnDidFilesChange.event(N=>{N.correlates(u)&&S.fire(N)})),{onDidChange:S.event,dispose:()=>t.dispose()}}return t}async doWatch(r,n){const t=await this.withProvider(r),s=(0,D.hash)([this.getExtUri(t).providerExtUri.getComparisonKey(r),n]);let o=this.activeWatchers.get(s);return o||(o={count:0,disposable:t.watch(r,n)},this.activeWatchers.set(s,o)),o.count+=1,(0,a.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,a.dispose)(o.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.activeWatchers)(0,a.dispose)(r.disposable);this.activeWatchers.clear()}async doWriteBuffered(r,n,t,s){return this.writeQueue.queueFor(n,async()=>{const o=await r.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,g.isReadableStream)(s)||(0,g.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(r,o,s):await this.doWriteReadableBufferedQueued(r,o,s)}catch(u){throw(0,w.ensureFileSystemProviderError)(u)}finally{await r.close(o)}},this.getExtUri(r).providerExtUri)}async doWriteStreamBufferedQueued(r,n,t){let s=0,o;if((0,g.isReadableBufferedStream)(t)){if(t.buffer.length>0){const u=E.VSBuffer.concat(t.buffer);await this.doWriteBuffer(r,n,u,u.byteLength,s,0),s+=u.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((u,S)=>{(0,g.listenStream)(o,{onData:async T=>{o.pause();try{await this.doWriteBuffer(r,n,T,T.byteLength,s,0)}catch(N){return S(N)}s+=T.byteLength,setTimeout(()=>o.resume())},onError:T=>S(T),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(r,n,t){let s=0,o;for(;(o=t.read())!==null;)await this.doWriteBuffer(r,n,o,o.byteLength,s,0),s+=o.byteLength}async doWriteBuffer(r,n,t,s,o,u){let S=0;for(;S<s;){const T=await r.write(n,o+S,t.buffer,u+S,s-S);S+=T}}async doWriteUnbuffered(r,n,t,s){return this.writeQueue.queueFor(n,()=>this.doWriteUnbufferedQueued(r,n,t,s),this.getExtUri(r).providerExtUri)}async doWriteUnbufferedQueued(r,n,t,s){let o;s instanceof E.VSBuffer?o=s:(0,g.isReadableStream)(s)?o=await(0,E.streamToBuffer)(s):(0,g.isReadableBufferedStream)(s)?o=await(0,E.bufferedStreamToBuffer)(s):o=(0,E.readableToBuffer)(s),await r.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async doPipeBuffered(r,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeBufferedQueued(r,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeBufferedQueued(r,n,t,s){let o,u;try{o=await r.open(n,{create:!1}),u=await t.open(s,{create:!0,unlock:!1});const S=E.VSBuffer.alloc(this.BUFFER_SIZE);let T=0,N=0,L=0;do L=await r.read(o,T,S.buffer,N,S.byteLength-N),await this.doWriteBuffer(t,u,S,L,T,N),T+=L,N+=L,N===S.byteLength&&(N=0);while(L>0)}catch(S){throw(0,w.ensureFileSystemProviderError)(S)}finally{await b.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async doPipeUnbuffered(r,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeUnbufferedQueued(r,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeUnbufferedQueued(r,n,t,s){return t.writeFile(s,await r.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(r,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeUnbufferedToBufferedQueued(r,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeUnbufferedToBufferedQueued(r,n,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const u=await r.readFile(n);await this.doWriteBuffer(t,o,E.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,w.ensureFileSystemProviderError)(u)}finally{await t.close(o)}}async doPipeBufferedToUnbuffered(r,n,t,s){const o=await(0,E.streamToBuffer)(this.readFileBuffered(r,n,R.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,o)}throwIfFileSystemIsReadonly(r,n){if(r.capabilities&w.FileSystemProviderCapabilities.Readonly)throw new w.FileOperationError((0,C.localize)(11417,null,this.resourceForError(n)),w.FileOperationResult.FILE_PERMISSION_DENIED);return r}throwIfFileIsReadonly(r,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,C.localize)(11418,null,this.resourceForError(r)),w.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(r){return r.scheme===c.Schemas.file?r.fsPath:r.toString(!0)}};e.FileService=i,e.FileService=i=y=we([se(0,m.ILogService)],i)}),define(ue[109],de([0,1,32,8,25,13,4,63,2,15,12,16,47,29,5,9,62,106,104,103]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class y extends d.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(l,r){super(l,r),this.onDidChangeCapabilities=A.Event.None,this.resourceLocks=new E.ResourceMap(n=>c.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=C.FileSystemProviderCapabilities.FileReadWrite|C.FileSystemProviderCapabilities.FileOpenReadWriteClose|C.FileSystemProviderCapabilities.FileReadStream|C.FileSystemProviderCapabilities.FileFolderCopy|C.FileSystemProviderCapabilities.FileWriteUnlock|C.FileSystemProviderCapabilities.FileAtomicRead|C.FileSystemProviderCapabilities.FileAtomicWrite|C.FileSystemProviderCapabilities.FileAtomicDelete|C.FileSystemProviderCapabilities.FileClone,h.isLinux&&(this._capabilities|=C.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(l){try{const{stat:r,symbolicLink:n}=await f.SymlinkSupport.stat(this.toFilePath(l));return{type:this.toType(r,n),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:C.FilePermission.Locked}}catch(r){throw this.toFileSystemProviderError(r)}}async statIgnoreError(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const r=await f.Promises.readdir(this.toFilePath(l),{withFileTypes:!0}),n=[];return await Promise.all(r.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,c.joinPath)(l,t.name))).type:s=this.toType(t),n.push([t.name,s])}catch(s){this.logService.trace(s)}})),n}catch(r){throw this.toFileSystemProviderError(r)}}toType(l,r){let n;return r?.dangling?n=C.FileType.Unknown:l.isFile()?n=C.FileType.File:l.isDirectory()?n=C.FileType.Directory:n=C.FileType.Unknown,r&&(n|=C.FileType.SymbolicLink),n}async createResourceLock(l){const r=this.toFilePath(l);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let n;for(;n=this.resourceLocks.get(l);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await n.wait();const t=new b.Barrier;return this.resourceLocks.set(l,t),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,v.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(l)===t&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(l)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),t.open()})}async readFile(l,r){let n;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(l)})`),n=await this.createResourceLock(l));const t=this.toFilePath(l);return await I.promises.readFile(t)}catch(t){throw this.toFileSystemProviderError(t)}finally{n?.dispose()}}traceLock(l){y.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(l)}readFileStream(l,r,n){const t=(0,p.newWriteableStream)(s=>R.VSBuffer.concat(s.map(o=>R.VSBuffer.wrap(o))).buffer);return(0,w.readFileIntoStream)(this,l,t,s=>s.buffer,{...r,bufferSize:256*1024},n),t}async writeFile(l,r,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(l)?this.doWriteFileAtomic(l,(0,c.joinPath)((0,c.dirname)(l),`${(0,c.basename)(l)}${n.atomic.postfix}`),r,n):this.doWriteFile(l,r,n)}async canWriteFileAtomic(l){try{const r=this.toFilePath(l),{symbolicLink:n}=await f.SymlinkSupport.stat(r);if(n)return!1}catch{}return!0}async doWriteFileAtomic(l,r,n,t){const s=new v.DisposableStore;try{s.add(await this.createResourceLock(l)),s.add(await this.createResourceLock(r)),await this.doWriteFile(r,n,t,!0);try{await this.rename(r,l,{overwrite:!0})}catch(o){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{s.dispose()}}async doWriteFile(l,r,n,t){let s;try{const o=this.toFilePath(l);if(!n.create||!n.overwrite){if(await f.Promises.exists(o)){if(!n.overwrite)throw(0,C.createFileSystemProviderError)((0,g.localize)(11376,null),C.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,C.createFileSystemProviderError)((0,g.localize)(11377,null),C.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(l,{create:!0,unlock:n.unlock},t),await this.write(s,0,r,0,r.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(l,o)}finally{typeof s=="number"&&await this.close(s)}}static{this.canFlush=!0}static configureFlushOnWrite(l){y.canFlush=l}async open(l,r,n){const t=this.toFilePath(l);let s;(0,C.isFileOpenForWriteOptions)(r)&&!n&&(s=await this.createResourceLock(l));let o;try{if((0,C.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:S}=await f.SymlinkSupport.stat(t);S.mode&128||await I.promises.chmod(t,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}let u;if((0,C.isFileOpenForWriteOptions)(r)){if(h.isWindows)try{await I.promises.truncate(t,0),u="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}u||(u="w")}else u="r";o=await f.Promises.open(t,u)}catch(u){throw s?.dispose(),(0,C.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(l,u):this.toFileSystemProviderError(u)}if(this.mapHandleToPos.set(o,0),(0,C.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(o,l),s){const u=this.mapHandleToLock.get(o);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.mapHandleToLock.set(o,s),u&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),u.dispose())}return o}async close(l){const r=this.mapHandleToLock.get(l);try{if(this.mapHandleToPos.delete(l),this.writeHandles.delete(l)&&y.canFlush)try{await f.Promises.fdatasync(l)}catch(n){y.configureFlushOnWrite(!1),this.logService.error(n)}return await f.Promises.close(l)}catch(n){throw this.toFileSystemProviderError(n)}finally{r&&(this.mapHandleToLock.get(l)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.mapHandleToLock.delete(l)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),r.dispose())}}async read(l,r,n,t,s){const o=this.normalizePos(l,r);let u=null;try{u=(await f.Promises.read(l,n,t,s,o)).bytesRead}catch(S){throw this.toFileSystemProviderError(S)}finally{this.updatePos(l,o,u)}return u}normalizePos(l,r){return r===this.mapHandleToPos.get(l)?null:r}updatePos(l,r,n){const t=this.mapHandleToPos.get(l);typeof t=="number"&&(typeof r=="number"||(typeof n=="number"?this.mapHandleToPos.set(l,t+n):this.mapHandleToPos.delete(l)))}async write(l,r,n,t,s){return(0,b.retry)(()=>this.doWrite(l,r,n,t,s),100,3)}async doWrite(l,r,n,t,s){const o=this.normalizePos(l,r);let u=null;try{u=(await f.Promises.write(l,n,t,s,o)).bytesWritten}catch(S){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(l),S)}finally{this.updatePos(l,o,u)}return u}async mkdir(l){try{await I.promises.mkdir(this.toFilePath(l))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(l,r){try{const n=this.toFilePath(l);if(r.recursive){let t;r?.atomic!==!1&&r.atomic.postfix&&(t=(0,a.join)((0,a.dirname)(n),`${(0,a.basename)(n)}${r.atomic.postfix}`)),await f.Promises.rm(n,f.RimRafMode.MOVE,t)}else try{await I.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:o,symbolicLink:u}=await f.SymlinkSupport.stat(n);s=o.isDirectory()&&!u}catch{}if(s)await I.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(l,r,n){const t=this.toFilePath(l),s=this.toFilePath(r);if(t!==s)try{await this.validateMoveCopy(l,r,"move",n.overwrite),await f.Promises.rename(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,g.localize)(11378,null,(0,a.basename)(t),(0,a.basename)((0,a.dirname)(s)),o.toString()))),this.toFileSystemProviderError(o)}}async copy(l,r,n){const t=this.toFilePath(l),s=this.toFilePath(r);if(t!==s)try{await this.validateMoveCopy(l,r,"copy",n.overwrite),await f.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,g.localize)(11379,null,(0,a.basename)(t),(0,a.basename)((0,a.dirname)(s)),o.toString()))),this.toFileSystemProviderError(o)}}async validateMoveCopy(l,r,n,t){const s=this.toFilePath(l),o=this.toFilePath(r);let u=!1;if(!!(this.capabilities&C.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,D.isEqual)(s,o,!0)),u){if(n==="copy")throw(0,C.createFileSystemProviderError)((0,g.localize)(11380,null),C.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const T=await this.statIgnoreError(l);if(!T)throw(0,C.createFileSystemProviderError)((0,g.localize)(11381,null),C.FileSystemProviderErrorCode.FileNotFound);const N=await this.statIgnoreError(r);if(N){if(!t)throw(0,C.createFileSystemProviderError)((0,g.localize)(11382,null),C.FileSystemProviderErrorCode.FileExists);T.type&C.FileType.File&&N.type&C.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,r){return this.doCloneFile(l,r,!1)}async doCloneFile(l,r,n){const t=this.toFilePath(l),s=this.toFilePath(r),o=!!(this.capabilities&C.FileSystemProviderCapabilities.PathCaseSensitive);if((0,D.isEqual)(t,s,!o))return;const u=new v.DisposableStore;try{u.add(await this.createResourceLock(l)),u.add(await this.createResourceLock(r)),n&&await I.promises.mkdir((0,a.dirname)(s),{recursive:!0}),await I.promises.copyFile(t,s)}catch(S){if(S.code==="ENOENT"&&!n)return this.doCloneFile(l,r,!0);throw this.toFileSystemProviderError(S)}finally{u.dispose()}}createUniversalWatcher(l,r,n){return new m.UniversalWatcherClient(t=>l(t),t=>r(t),n)}createNonRecursiveWatcher(l,r,n){return new O.NodeJSWatcherClient(t=>l(t),t=>r(t),n)}toFileSystemProviderError(l){if(l instanceof C.FileSystemProviderError)return l;let r=l,n;switch(l.code){case"ENOENT":n=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=C.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=C.FileSystemProviderErrorCode.Unknown;break;default:n=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(r,n)}async toFileSystemProviderWriteError(l,r){let n=this.toFileSystemProviderError(r);if(l&&n.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await f.SymlinkSupport.stat(this.toFilePath(l));t.mode&128||(n=(0,C.createFileSystemProviderError)(r,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.logService.trace(t)}return n}}e.DiskFileSystemProvider=y}),define(ue[110],de([0,1,2,6]),function(J,e,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class E extends I.Disposable{constructor(A,D=[]){super(),this.logger=new b.MultiplexLogger([A,...D]),this._register(A.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...D){this.logger.trace(A,...D)}debug(A,...D){this.logger.debug(A,...D)}info(A,...D){this.logger.info(A,...D)}warn(A,...D){this.logger.warn(A,...D)}error(A,...D){this.logger.error(A,...D)}flush(){this.logger.flush()}}e.LogService=E}),define(ue[111],de([0,1,9,6]),function(J,e,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var E;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(E||(E={}));async function R(a,h,c,p,f){try{const g=await new Promise((w,d)=>{J(["@vscode/spdlog"],w,d)}).then(Ee);g.setFlushOn(E.Trace);const C=await g.createAsyncRotatingLogger(a,h,c,p);return f?C.clearFormatters():C.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),C}catch(g){console.error(g)}return null}function A(a,h,c){switch(h){case b.LogLevel.Trace:a.trace(c);break;case b.LogLevel.Debug:a.debug(c);break;case b.LogLevel.Info:a.info(c);break;case b.LogLevel.Warning:a.warn(c);break;case b.LogLevel.Error:a.error(c);break;case b.LogLevel.Off:break;default:throw new Error(`Invalid log level ${h}`)}}function D(a,h){switch(h){case b.LogLevel.Trace:a.setLevel(E.Trace);break;case b.LogLevel.Debug:a.setLevel(E.Debug);break;case b.LogLevel.Info:a.setLevel(E.Info);break;case b.LogLevel.Warning:a.setLevel(E.Warning);break;case b.LogLevel.Error:a.setLevel(E.Error);break;case b.LogLevel.Off:a.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${h}`)}}class v extends b.AbstractMessageLogger{constructor(h,c,p,f,g){super(),this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(h,c,p,f),this._register(this.onDidChangeLogLevel(C=>{this._logger&&D(this._logger,C)}))}async _createSpdLogLogger(h,c,p,f){const g=p?6:1,C=30/g*I.ByteSize.MB,w=await R(h,c,C,g,f);if(w){this._logger=w,D(this._logger,this.getLevel());for(const{level:d,message:m}of this.buffer)A(this._logger,d,m);this.buffer=[]}}log(h,c){this._logger?A(this._logger,h,c):this.getLevel()<=h&&this.buffer.push({level:h,message:c})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=v}),define(ue[112],de([0,1,28,6,111]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class R extends b.AbstractLoggerService{doCreateLogger(D,v,a){return new E.SpdLogLogger((0,I.generateUuid)(),D.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,v)}}e.LoggerService=R}),define(ue[39],de([0,1,4,65,2,10]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class A extends E.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(a){const h=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...a,...this.policyDefinitions},h!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(a),b.Iterable.reduce(this.policies.entries(),(c,[p,f])=>({...c,[p]:f}),{})}getPolicyValue(a){return this.policies.get(a)}serialize(){return b.Iterable.reduce(Object.entries(this.policyDefinitions),(a,[h,c])=>({...a,[h]:{definition:c,value:this.policies.get(h)}}),{})}}e.AbstractPolicyService=A;class D{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=D}),define(ue[113],de([0,1,8,4,65,3,9,6,39]),function(J,e,I,b,E,R,A,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function a(c,p){const f=[];for(const g of new Set(E.Iterable.concat(c.keys(),p.keys())))c.get(g)!==p.get(g)&&f.push(g);return f}let h=class extends v.AbstractPolicyService{constructor(p,f,g){super(),this.file=p,this.fileService=f,this.logService=g,this.throttledDelayer=this._register(new I.ThrottledDelayer(500));const C=b.Event.filter(f.onDidFilesChange,w=>w.affects(p));this._register(f.watch(p)),this._register(C(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const p=new Map;try{const f=await this.fileService.readFile(this.file),g=JSON.parse(f.value.toString());if(!(0,R.isObject)(g))throw new Error("Policy file isn't a JSON object");for(const C of Object.keys(g))this.policyDefinitions[C]&&p.set(C,g[C])}catch(f){f.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.logService.error("[FilePolicyService] Failed to read policies",f)}return p}async refresh(){const p=await this.read(),f=a(this.policies,p);this.policies=p,f.length>0&&this._onDidChange.fire(f)}};e.FilePolicyService=h,e.FilePolicyService=h=we([se(1,A.IFileService),se(2,D.ILogService)],h)}),define(ue[114],de([0,1,39,8,2,6]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let A=class extends I.AbstractPolicyService{constructor(v,a){super(),this.logService=v,this.productName=a,this.throttler=new b.Throttler,this.watcher=this._register(new E.MutableDisposable)}async _updatePolicyDefinitions(v){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(v).length} policy definitions`);const{createWatcher:a}=await new Promise((h,c)=>{J(["@vscode/policy-watcher"],h,c)}).then(Ee);await this.throttler.queue(()=>new Promise((h,c)=>{try{this.watcher.value=a(this.productName,v,p=>{this._onDidPolicyChange(p),h()})}catch(p){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),c(p)}}))}_onDidPolicyChange(v){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(v)}`);for(const a in v){const h=v[a];h===void 0?this.policies.delete(a):this.policies.set(a,h)}this._onDidChange.fire(Object.keys(v))}};e.NativePolicyService=A,e.NativePolicyService=A=we([se(0,R.ILogService)],A)}),define(ue[33],de([0,1,10]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ue[37],de([0,1,75,3]),function(J,e,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,I=Ee(I),b=Ee(b);class E{constructor(){this.data=new Map}add(A,D){I.ok(b.isString(A)),I.ok(b.isObject(D)),I.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,D)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new E}),define(ue[115],de([0,1,4,78,37]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,E=Ee(E),e.Extensions={JSONContribution:"base.contributions.json"};function R(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class A{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(a,h){this.schemasById[R(a)]=h,this._onDidChangeSchema.fire(a)}notifySchemaChanged(a){this._onDidChangeSchema.fire(a)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(a){const h=this.schemasById[a];return h?(0,b.getCompressedContent)(h):void 0}hasSchemaContent(a){return!!this.schemasById[a]}}const D=new A;E.Registry.add(e.Extensions.JSONContribution,D)}),define(ue[40],de([0,1,19,4,3,5,30,115,37]),function(J,e,I,b,E,R,A,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=C,e.keyFromOverrideIdentifiers=w,e.getDefaultValue=d,e.validateProperty=O,e.getScopes=y,e.getAllConfigurationProperties=i,e.parseScope=l,E=Ee(E),R=Ee(R);var a;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var h;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(h||(e.ConfigurationScope=h={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const c=v.Registry.as(D.Extensions.JSONContribution);class p{constructor(){this.registeredConfigurationDefaults=[],this.overrideIdentifiers=new Set,this._onDidSchemaChange=new b.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new b.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(11612,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},c.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.doRegisterConfigurations(n,t,s),c.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.doDeregisterConfigurations(n,t),c.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.doDeregisterConfigurations(t,s),this.doRegisterConfigurations(n,!1,s),c.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.doRegisterDefaultConfigurations(n,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,t){this.registeredConfigurationDefaults.push(...n);const s=[];for(const{overrides:o,source:u}of n)for(const S in o){t.add(S);const T=this.configurationDefaultsOverrides.get(S)??this.configurationDefaultsOverrides.set(S,{configurationDefaultOverrides:[]}).get(S),N=o[S];if(T.configurationDefaultOverrides.push({value:N,source:u}),e.OVERRIDE_PROPERTY_REGEX.test(S)){const L=this.mergeDefaultConfigurationsForOverrideIdentifier(S,N,u,T.configurationDefaultOverrideValue);if(!L)continue;T.configurationDefaultOverrideValue=L,this.updateDefaultOverrideProperty(S,L,u),s.push(...C(S))}else{const L=this.mergeDefaultConfigurationsForConfigurationProperty(S,N,u,T.configurationDefaultOverrideValue);if(!L)continue;T.configurationDefaultOverrideValue=L;const k=this.configurationProperties[S];k&&(this.updatePropertyDefaultValue(S,k),this.updateSchema(S,k))}}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(n){const t=new Set;this.doDeregisterDefaultConfigurations(n,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,t){for(const s of n){const o=this.registeredConfigurationDefaults.indexOf(s);o!==-1&&this.registeredConfigurationDefaults.splice(o,1)}for(const{overrides:s,source:o}of n)for(const u in s){const S=this.configurationDefaultsOverrides.get(u);if(!S)continue;const T=S.configurationDefaultOverrides.findIndex(N=>o?N.source?.id===o.id:N.value===s[u]);if(T!==-1){if(S.configurationDefaultOverrides.splice(T,1),S.configurationDefaultOverrides.length===0&&this.configurationDefaultsOverrides.delete(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){let N;for(const L of S.configurationDefaultOverrides)N=this.mergeDefaultConfigurationsForOverrideIdentifier(u,L.value,L.source,N);N&&!E.isEmptyObject(N.value)?(S.configurationDefaultOverrideValue=N,this.updateDefaultOverrideProperty(u,N,o)):(this.configurationDefaultsOverrides.delete(u),delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u])}else{let N;for(const k of S.configurationDefaultOverrides)N=this.mergeDefaultConfigurationsForConfigurationProperty(u,k.value,k.source,N);S.configurationDefaultOverrideValue=N;const L=this.configurationProperties[u];L&&(this.updatePropertyDefaultValue(u,L),this.updateSchema(u,L))}t.add(u)}}this.updateOverridePropertyPatternKey()}updateDefaultOverrideProperty(n,t,s){const o={type:"object",default:t.value,description:R.localize(11613,null,(0,A.getLanguageTagSettingPlainKey)(n)),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.configurationProperties[n]=o,this.defaultLanguageConfigurationOverridesNode.properties[n]=o}mergeDefaultConfigurationsForOverrideIdentifier(n,t,s,o){const u=o?.value||{},S=o?.source??new Map;if(!(S instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const T of Object.keys(t)){const N=t[T];if(E.isObject(N)&&(E.isUndefined(u[T])||E.isObject(u[T]))){if(u[T]={...u[T]??{},...N},s)for(const k in N)S.set(`${T}.${k}`,s)}else u[T]=N,s?S.set(T,s):S.delete(T)}return{value:u,source:S}}mergeDefaultConfigurationsForConfigurationProperty(n,t,s,o){const u=this.configurationProperties[n],S=o?.value??u?.defaultDefaultValue;let T=s;if(E.isObject(t)&&(u!==void 0&&u.type==="object"||u===void 0&&(E.isUndefined(S)||E.isObject(S)))){if(T=o?.source??new Map,!(T instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const L in t)s&&T.set(`${n}.${L}`,s);t={...E.isObject(S)?S:{},...t}}return{value:t,source:T}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,s),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const t of n)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,t,s){n.forEach(o=>{this.validateAndRegisterProperties(o,t,o.extensionInfo,o.restrictedProperties,void 0,s),this.configurationContributors.push(o),this.registerJSONConfiguration(o)})}doDeregisterConfigurations(n,t){const s=o=>{if(o.properties)for(const u in o.properties){t.add(u);const S=this.configurationProperties[u];S?.policy?.name&&this.policyConfigurations.delete(S.policy.name),delete this.configurationProperties[u],this.removeFromSchema(u,o.properties[u])}o.allOf?.forEach(u=>s(u))};for(const o of n){s(o);const u=this.configurationContributors.indexOf(o);u!==-1&&this.configurationContributors.splice(u,1)}}validateAndRegisterProperties(n,t=!0,s,o,u=h.WINDOW,S){u=E.isUndefinedOrNull(n.scope)?u:n.scope;const T=n.properties;if(T)for(const L in T){const k=T[L];if(t&&O(L,k)){delete T[L];continue}if(k.source=s,k.defaultDefaultValue=T[L].default,this.updatePropertyDefaultValue(L,k),e.OVERRIDE_PROPERTY_REGEX.test(L)?k.scope=void 0:(k.scope=E.isUndefinedOrNull(k.scope)?u:k.scope,k.restricted=E.isUndefinedOrNull(k.restricted)?!!o?.includes(L):k.restricted),T[L].hasOwnProperty("included")&&!T[L].included){this.excludedConfigurationProperties[L]=T[L],delete T[L];continue}else this.configurationProperties[L]=T[L],T[L].policy?.name&&this.policyConfigurations.set(T[L].policy.name,L);!T[L].deprecationMessage&&T[L].markdownDeprecationMessage&&(T[L].deprecationMessage=T[L].markdownDeprecationMessage),S.add(L)}const N=n.allOf;if(N)for(const L of N)this.validateAndRegisterProperties(L,t,s,o,u,S)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getRegisteredDefaultConfigurations(){return[...this.registeredConfigurationDefaults]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.configurationDefaultsOverrides)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}registerJSONConfiguration(n){const t=s=>{const o=s.properties;if(o)for(const S in o)this.updateSchema(S,o[S]);s.allOf?.forEach(t)};t(n)}updateSchema(n,t){switch(e.allSettings.properties[n]=t,t.scope){case h.APPLICATION:e.applicationSettings.properties[n]=t;break;case h.MACHINE:e.machineSettings.properties[n]=t;break;case h.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[n]=t;break;case h.WINDOW:e.windowSettings.properties[n]=t;break;case h.RESOURCE:e.resourceSettings.properties[n]=t;break;case h.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[n]=t,this.resourceLanguageSettingsSchema.properties[n]=t;break}}removeFromSchema(n,t){switch(delete e.allSettings.properties[n],t.scope){case h.APPLICATION:delete e.applicationSettings.properties[n];break;case h.MACHINE:delete e.machineSettings.properties[n];break;case h.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[n];break;case h.WINDOW:delete e.windowSettings.properties[n];break;case h.RESOURCE:case h.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const t=`[${n}]`,s={type:"object",description:R.localize(11614,null),errorMessage:R.localize(11615,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,s),e.allSettings.properties[t]=s,e.applicationSettings.properties[t]=s,e.machineSettings.properties[t]=s,e.machineOverridableSettings.properties[t]=s,e.windowSettings.properties[t]=s,e.resourceSettings.properties[t]=s}}registerOverridePropertyPatternKey(){const n={type:"object",description:R.localize(11616,null),errorMessage:R.localize(11617,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,t){const s=this.configurationDefaultsOverrides.get(n)?.configurationDefaultOverrideValue;let o,u;s&&(!t.disallowConfigurationDefault||!s.source)&&(o=s.value,u=s.source),E.isUndefined(o)&&(o=t.defaultDefaultValue,u=void 0),E.isUndefined(o)&&(o=d(t.type)),t.default=o,t.defaultValueSource=u}}const f="\\[([^\\]]+)\\]",g=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function C(r){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let t=g.exec(r);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=g.exec(r)}}return(0,I.distinct)(n)}function w(r){return r.reduce((n,t)=>`${n}[${t}]`,"")}function d(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new p;v.Registry.add(e.Extensions.Configuration,m);function O(r,n){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?R.localize(11619,null,r):m.getConfigurationProperties()[r]!==void 0?R.localize(11620,null,r):n.policy?.name&&m.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(11621,null,r,n.policy?.name,m.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(11618,null)}function y(){const r=[],n=m.getConfigurationProperties();for(const t of Object.keys(n))r.push([t,n[t].scope]);return r.push(["launch",h.RESOURCE]),r.push(["task",h.RESOURCE]),r}function i(r){const n={};for(const t of r){const s=t.properties;if(E.isObject(s))for(const o in s)n[o]=s[o];t.allOf&&Object.assign(n,i(t.allOf))}return n}function l(r){switch(r){case"application":return h.APPLICATION;case"machine":return h.MACHINE;case"resource":return h.RESOURCE;case"machine-overridable":return h.MACHINE_OVERRIDABLE;case"language-overridable":return h.LANGUAGE_OVERRIDABLE;default:return h.WINDOW}}}),define(ue[66],de([0,1,19,4,34,2,25,27,3,11,30,40,9,37]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=y,I=Ee(I),E=Ee(E),D=Ee(D),v=Ee(v);function g(n){return Object.isFrozen(n)?n:D.deepFreeze(n)}class C{static createEmptyModel(t){return new C({},[],[],void 0,t)}constructor(t,s,o,u,S){this._contents=t,this._keys=s,this._overrides=o,this.raw=u,this.logService=S,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof C)return s;const o=new w("",this.logService);return o.parseRaw(s),o.configurationModel});this._rawConfiguration=t.reduce((s,o)=>o===s?o:s.merge(o),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,h.getConfigurationValue)(this.contents,t):this.contents}inspect(t,s){const o=this;return{get value(){return g(o.rawConfiguration.getValue(t))},get override(){return s?g(o.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return g(s?o.rawConfiguration.override(s).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const u=[];for(const{contents:S,identifiers:T,keys:N}of o.rawConfiguration.overrides){const L=new C(S,N,[],void 0,o.logService).getValue(t);L!==void 0&&u.push({identifiers:T,value:L})}return u.length?g(u):void 0}}}getOverrideValue(t,s){const o=this.getContentsForOverrideIdentifer(s);return o?t?(0,h.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const o of this.overrides)o.identifiers.includes(t)&&s.push(...o.keys);return I.distinct(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return I.distinct(t)}override(t){let s=this.overrideConfigurations.get(t);return s||(s=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,s)),s}merge(...t){const s=D.deepClone(this.contents),o=D.deepClone(this.overrides),u=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const T of t)if(S.push(...T.raw?.length?T.raw:[T]),!T.isEmpty()){this.mergeContents(s,T.contents);for(const N of T.overrides){const[L]=o.filter(k=>I.equals(k.identifiers,N.identifiers));L?(this.mergeContents(L.contents,N.contents),L.keys.push(...N.keys),L.keys=I.distinct(L.keys)):o.push(D.deepClone(N))}for(const N of T.keys)u.indexOf(N)===-1&&u.push(N)}return new C(s,u,o,S.every(T=>T instanceof C)?void 0:S,this.logService)}createOverrideConfigurationModel(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const u of I.distinct([...Object.keys(this.contents),...Object.keys(s)])){let S=this.contents[u];const T=s[u];T&&(typeof S=="object"&&typeof T=="object"?(S=D.deepClone(S),this.mergeContents(S,T)):S=T),o[u]=S}return new C(o,this.keys,this.overrides,void 0,this.logService)}mergeContents(t,s){for(const o of Object.keys(s)){if(o in t&&v.isObject(t[o])&&v.isObject(s[o])){this.mergeContents(t[o],s[o]);continue}t[o]=D.deepClone(s[o])}}getContentsForOverrideIdentifer(t){let s=null,o=null;const u=S=>{S&&(o?this.mergeContents(o,S):o=D.deepClone(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===t?s=S.contents:S.identifiers.includes(t)&&u(S.contents);return u(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.updateValue(t,s,!0)}setValue(t,s){this.updateValue(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,h.removeFromValueTree)(this.contents,t),c.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>I.equals(o.identifiers,(0,c.overrideIdentifiersFromKey)(t))),1))}updateValue(t,s,o){if((0,h.addToValueTree)(this.contents,t,s,u=>this.logService.error(u)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),c.OVERRIDE_PROPERTY_REGEX.test(t)){const u=(0,c.overrideIdentifiersFromKey)(t),S={identifiers:u,keys:Object.keys(this.contents[t]),contents:(0,h.toValuesTree)(this.contents[t],N=>this.logService.error(N))},T=this.overrides.findIndex(N=>I.equals(N.identifiers,u));T!==-1?this.overrides[T]=S:this.overrides.push(S)}}}e.ConfigurationModel=C;class w{constructor(t,s){this._name=t,this.logService=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||C.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!v.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:o,keys:u,overrides:S,restricted:T,hasExcludedProperties:N}=this.doParseRaw(t,s);this._configurationModel=new C(o,u,S,N?[t]:void 0,this.logService),this._restrictedConfigurations=T||[]}doParseContent(t){let s={},o=null,u=[];const S=[],T=[];function N(k){Array.isArray(u)?u.push(k):o!==null&&(u[o]=k)}const L={onObjectBegin:()=>{const k={};N(k),S.push(u),u=k,o=null},onObjectProperty:k=>{o=k},onObjectEnd:()=>{u=S.pop()},onArrayBegin:()=>{const k=[];N(k),S.push(u),u=k,o=null},onArrayEnd:()=>{u=S.pop()},onLiteralValue:N,onError:(k,U,G)=>{T.push({error:k,offset:U,length:G})}};if(t)try{E.visit(t,L),s=u[0]||{}}catch(k){this.logService.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return s}doParseRaw(t,s){const o=f.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),u=this.filter(t,o,!0,s);t=u.raw;const S=(0,h.toValuesTree)(t,L=>this.logService.error(`Conflict in settings file ${this._name}: ${L}`)),T=Object.keys(t),N=this.toOverrides(t,L=>this.logService.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:S,keys:T,overrides:N,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}filter(t,s,o,u){let S=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:S};const T={},N=[];for(const L in t)if(c.OVERRIDE_PROPERTY_REGEX.test(L)&&o){const k=this.filter(t[L],s,!1,u);T[L]=k.raw,S=S||k.hasExcludedProperties,N.push(...k.restricted)}else{const k=s[L],U=k?typeof k.scope<"u"?k.scope:c.ConfigurationScope.WINDOW:void 0;k?.restricted&&N.push(L),!u.exclude?.includes(L)&&(u.include?.includes(L)||(U===void 0||u.scopes===void 0||u.scopes.includes(U))&&!(u.skipRestricted&&k?.restricted))?T[L]=t[L]:S=!0}return{raw:T,restricted:N,hasExcludedProperties:S}}toOverrides(t,s){const o=[];for(const u of Object.keys(t))if(c.OVERRIDE_PROPERTY_REGEX.test(u)){const S={};for(const T in t[u])S[T]=t[u][T];o.push({identifiers:(0,c.overrideIdentifiersFromKey)(u),keys:Object.keys(S),contents:(0,h.toValuesTree)(S,s)})}return o}}e.ConfigurationModelParser=w;class d extends R.Disposable{constructor(t,s,o,u,S){super(),this.userSettingsResource=t,this.parseOptions=s,this.fileService=u,this.logService=S,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString(),S),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.any(b.Event.filter(this.fileService.onDidFilesChange,T=>T.contains(this.userSettingsResource)),b.Event.filter(this.fileService.onDidRunOperation,T=>(T.isOperation(p.FileOperation.CREATE)||T.isOperation(p.FileOperation.COPY)||T.isOperation(p.FileOperation.DELETE)||T.isOperation(p.FileOperation.WRITE))&&o.isEqual(T.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return C.createEmptyModel(this.logService)}}reparse(t){return t&&(this.parseOptions=t),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class m{constructor(t,s,o,u,S,T,N,L,k,U,G,Y,te){this.key=t,this.overrides=s,this._value=o,this.overrideIdentifiers=u,this.defaultConfiguration=S,this.policyConfiguration=T,this.applicationConfiguration=N,this.userConfiguration=L,this.localUserConfiguration=k,this.remoteUserConfiguration=U,this.workspaceConfiguration=G,this.folderConfigurationModel=Y,this.memoryConfigurationModel=te}get value(){return g(this._value)}toInspectValue(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class O{constructor(t,s,o,u,S,T,N,L,k,U){this._defaultConfiguration=t,this._policyConfiguration=s,this._applicationConfiguration=o,this._localUserConfiguration=u,this._remoteUserConfiguration=S,this._workspaceConfiguration=T,this._folderConfigurations=N,this._memoryConfiguration=L,this._memoryConfigurationByResource=k,this.logService=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,s,o){return this.getConsolidatedConfigurationModel(t,s,o).getValue(t)}updateValue(t,s,o={}){let u;o.resource?(u=this._memoryConfigurationByResource.get(o.resource),u||(u=C.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(o.resource,u))):u=this._memoryConfiguration,s===void 0?u.removeValue(t):u.setValue(t,s),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,o){const u=this.getConsolidatedConfigurationModel(t,s,o),S=this.getFolderConfigurationModelForResource(s.resource,o),T=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,N=new Set;for(const L of u.overrides)for(const k of L.identifiers)u.getOverrideValue(t,k)!==void 0&&N.add(k);return new m(t,s,u.getValue(t),N.size?[...N]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this._workspaceConfiguration:void 0,S||void 0,T)}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=[];if(!s){const{added:u,updated:S,removed:T}=l(this._defaultConfiguration,t);s=[...u,...S,...T]}for(const u of s)for(const S of(0,c.overrideIdentifiersFromKey)(u)){const T=this._defaultConfiguration.getKeysForOverrideIdentifier(S),N=t.getKeysForOverrideIdentifier(S),L=[...N.filter(k=>T.indexOf(k)===-1),...T.filter(k=>N.indexOf(k)===-1),...T.filter(k=>!D.equals(this._defaultConfiguration.override(S).getValue(k),t.override(S).getValue(k)))];o.push([S,L])}return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:o,removed:u}=l(this._policyConfiguration,t),S=[...s,...o,...u];return S.length&&this.updatePolicyConfiguration(t),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:o,removed:u,overrides:S}=l(this.applicationConfiguration,t),T=[...s,...o,...u];return T.length&&this.updateApplicationConfiguration(t),{keys:T,overrides:S}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:u,overrides:S}=l(this.localUserConfiguration,t),T=[...s,...o,...u];return T.length&&this.updateLocalUserConfiguration(t),{keys:T,overrides:S}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:u,overrides:S}=l(this.remoteUserConfiguration,t),T=[...s,...o,...u];return T.length&&this.updateRemoteUserConfiguration(t),{keys:T,overrides:S}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:u,overrides:S}=l(this.workspaceConfiguration,t),T=[...s,...o,...u];return T.length&&this.updateWorkspaceConfiguration(t),{keys:T,overrides:S}}compareAndUpdateFolderConfiguration(t,s){const o=this.folderConfigurations.get(t),{added:u,updated:S,removed:T,overrides:N}=l(o,s),L=[...u,...S,...T];return(L.length||!o)&&this.updateFolderConfiguration(t,s),{keys:L,overrides:N}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:u,removed:S,overrides:T}=l(s,void 0);return{keys:[...o,...u,...S],overrides:T}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,s,o){let u=this.getConsolidatedConfigurationModelForResource(s,o);return s.overrideIdentifier&&(u=u.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(u=u.merge(this._policyConfiguration)),u}getConsolidatedConfigurationModelForResource({resource:t},s){let o=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const u=s.getFolder(t);u&&(o=this.getFolderConsolidatedConfiguration(u.uri)||o);const S=this._memoryConfigurationByResource.get(t);S&&(o=o.merge(S))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const o=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(t);u?(s=o.merge(u),this._foldersConsolidatedConfigurations.set(t,s)):s=o}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:o,overrides:u,keys:S}=this._folderConfigurations.get(s);return t.push([s,{contents:o,overrides:u,keys:S}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this._workspaceConfiguration.keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(o=>t.add(o))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(u=>s.add(u))),[...s.values()]}static parse(t,s){const o=this.parseConfigurationModel(t.defaults,s),u=this.parseConfigurationModel(t.policy,s),S=this.parseConfigurationModel(t.application,s),T=this.parseConfigurationModel(t.user,s),N=this.parseConfigurationModel(t.workspace,s),L=t.folders.reduce((k,U)=>(k.set(a.URI.revive(U[0]),this.parseConfigurationModel(U[1],s)),k),new A.ResourceMap);return new O(o,u,S,T,C.createEmptyModel(s),N,L,C.createEmptyModel(s),new A.ResourceMap,s)}static parseConfigurationModel(t,s){return new C(t.contents,t.keys,t.overrides,void 0,s)}}e.Configuration=O;function y(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const u of n)u.keys.forEach(S=>t.add(S)),u.overrides.forEach(([S,T])=>{const N=(0,A.getOrSet)(s,S,new Set);T.forEach(L=>N.add(L))});const o=[];return s.forEach((u,S)=>o.push([S,[...u.values()]])),{keys:[...t.values()],overrides:o}}class i{constructor(t,s,o,u,S){this.change=t,this.previous=s,this.currentConfiguraiton=o,this.currentWorkspace=u,this.logService=S,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const T of t.keys)this.affectedKeys.add(T);for(const[,T]of t.overrides)for(const N of T)this.affectedKeys.add(N);this._affectsConfigStr=this._marker;for(const T of this.affectedKeys)this._affectsConfigStr+=T+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=O.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(t,s){const o=this._marker+t,u=this._affectsConfigStr.indexOf(o);if(u<0)return!1;const S=u+o.length;if(S>=this._affectsConfigStr.length)return!1;const T=this._affectsConfigStr.charCodeAt(S);if(T!==this._markerCode1&&T!==this._markerCode2)return!1;if(s){const N=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,L=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!D.equals(N,L)}return!0}}e.ConfigurationChangeEvent=i;function l(n,t){const{added:s,removed:o,updated:u}=r(t?.rawConfiguration,n?.rawConfiguration),S=[],T=n?.getAllOverrideIdentifiers()||[],N=t?.getAllOverrideIdentifiers()||[];if(t){const L=N.filter(k=>!T.includes(k));for(const k of L)S.push([k,t.getKeysForOverrideIdentifier(k)])}if(n){const L=T.filter(k=>!N.includes(k));for(const k of L)S.push([k,n.getKeysForOverrideIdentifier(k)])}if(t&&n){for(const L of T)if(N.includes(L)){const k=r({contents:n.getOverrideValue(void 0,L)||{},keys:n.getKeysForOverrideIdentifier(L)},{contents:t.getOverrideValue(void 0,L)||{},keys:t.getKeysForOverrideIdentifier(L)});S.push([L,[...k.added,...k.removed,...k.updated]])}}return{added:s,removed:o,updated:u,overrides:S}}function r(n,t){const s=n?t?n.keys.filter(S=>t.keys.indexOf(S)===-1):[...n.keys]:[],o=t?n?t.keys.filter(S=>n.keys.indexOf(S)===-1):[...t.keys]:[],u=[];if(n&&t){for(const S of t.keys)if(n.keys.indexOf(S)!==-1){const T=(0,h.getConfigurationValue)(t.contents,S),N=(0,h.getConfigurationValue)(n.contents,S);D.equals(T,N)||u.push(S)}}return{added:s,removed:o,updated:u}}}),define(ue[116],de([0,1,19,4,2,27,3,66,40,6,39,37]),function(J,e,I,b,E,R,A,D,v,a,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class p extends E.Disposable{get configurationModel(){return this._configurationModel}constructor(w){super(),this.logService=w,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=D.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(c.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:d})=>this.onDidUpdateConfiguration(Array.from(w),d))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(w,d){this.updateConfigurationModel(w,c.Registry.as(v.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:w})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=D.ConfigurationModel.createEmptyModel(this.logService);const w=c.Registry.as(v.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(w),w)}updateConfigurationModel(w,d){const m=this.getConfigurationDefaultOverrides();for(const O of w){const y=m[O],i=d[O];y!==void 0?this._configurationModel.setValue(O,y):i?this._configurationModel.setValue(O,i.default):this._configurationModel.removeValue(O)}}}e.DefaultConfiguration=p;class f{constructor(){this.onDidChangeConfiguration=b.Event.None,this.configurationModel=D.ConfigurationModel.createEmptyModel(new a.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let g=class extends E.Disposable{get configurationModel(){return this._configurationModel}constructor(w,d,m){super(),this.defaultConfiguration=w,this.policyService=d,this.logService=m,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=D.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(w=>this.onDidChangePolicies(w))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:w})=>this.update(await this.updatePolicyDefinitions(w),!0))),this._configurationModel}async updatePolicyDefinitions(w){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",w);const d={},m=[],O=c.Registry.as(v.Extensions.Configuration).getConfigurationProperties();for(const y of w){const i=O[y];if(!i){m.push(y);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.logService.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}m.push(y),d[i.policy.name]={type:i.type}}}return(0,A.isEmptyObject)(d)||await this.policyService.updatePolicyDefinitions(d),m}onDidChangePolicies(w){this.logService.trace("PolicyConfiguration#onDidChangePolicies",w);const d=c.Registry.as(v.Extensions.Configuration).getPolicyConfigurations(),m=(0,I.coalesce)(w.map(O=>d.get(O)));this.update(m,!0)}update(w,d){this.logService.trace("PolicyConfiguration#update",w);const m=c.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),O=[],y=this._configurationModel.isEmpty();for(const i of w){const l=m[i]?.policy?.name;if(l){const r=this.policyService.getPolicyValue(l);(y?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(i),r))&&O.push([i,r])}else this._configurationModel.getValue(i)!==void 0&&O.push([i,void 0])}if(O.length){this.logService.trace("PolicyConfiguration#changed",O);const i=this._configurationModel;this._configurationModel=D.ConfigurationModel.createEmptyModel(this.logService);for(const l of i.keys)this._configurationModel.setValue(l,i.getValue(l));for(const[l,r]of O)r===void 0?this._configurationModel.removeValue(l):this._configurationModel.setValue(l,r);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=g,e.PolicyConfiguration=g=we([se(1,h.IPolicyService),se(2,a.ILogService)],g)}),define(ue[117],de([0,1,19,8,13,4,34,77,2,25,27,12,16,30,66,40,116,9,39]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class O extends v.Disposable{constructor(l,r,n,t){super(),this.settingsResource=l,this.logService=t,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new w.DefaultConfiguration(t)),this.policyConfiguration=n instanceof m.NullPolicyService?new w.NullPolicyConfiguration:this._register(new w.PolicyConfiguration(this.defaultConfiguration,n,t)),this.userConfiguration=this._register(new g.UserSettings(this.settingsResource,{},p.extUriBiasedIgnorePathCase,r,t)),this.configuration=new g.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,g.ConfigurationModel.createEmptyModel(t),g.ConfigurationModel.createEmptyModel(t),g.ConfigurationModel.createEmptyModel(t),g.ConfigurationModel.createEmptyModel(t),new a.ResourceMap,g.ConfigurationModel.createEmptyModel(t),new a.ResourceMap,t),this.configurationEditing=new y(l,r,this),this.reloadConfigurationScheduler=this._register(new b.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:o})=>this.onDidDefaultConfigurationChange(s,o))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[l,r,n]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new g.Configuration(l,r,g.ConfigurationModel.createEmptyModel(this.logService),n,g.ConfigurationModel.createEmptyModel(this.logService),g.ConfigurationModel.createEmptyModel(this.logService),new a.ResourceMap,g.ConfigurationModel.createEmptyModel(this.logService),new a.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(l,r){const n=typeof l=="string"?l:void 0,t=(0,f.isConfigurationOverrides)(l)?l:(0,f.isConfigurationOverrides)(r)?r:{};return this.configuration.getValue(n,t,void 0)}async updateValue(l,r,n,t,s){const o=(0,f.isConfigurationUpdateOverrides)(n)?n:(0,f.isConfigurationOverrides)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,u=o?t:n;if(u!==void 0&&u!==f.ConfigurationTarget.USER_LOCAL&&u!==f.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${u}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,I.distinct)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const S=this.inspect(l,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(S.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,h.equals)(r,S.defaultValue)&&(r=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const N=o.overrideIdentifiers.sort(),L=this.configuration.localUserConfiguration.overrides.find(k=>(0,I.equals)([...k.identifiers].sort(),N));L&&(o.overrideIdentifiers=L.identifiers)}const T=o?.overrideIdentifiers?.length?[(0,C.keyFromOverrideIdentifiers)(o.overrideIdentifiers),l]:[l];await this.configurationEditing.write(T,r),await this.reloadConfiguration()}inspect(l,r={}){return this.configuration.inspect(l,r,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const l=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(l)}onDidChangeUserConfiguration(l){const r=this.configuration.toData(),n=this.configuration.compareAndUpdateLocalUserConfiguration(l);this.trigger(n,r,f.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(l,r){const n=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(l,r);this.trigger(t,n,f.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(l){const r=this.configuration.toData(),n=this.configuration.compareAndUpdatePolicyConfiguration(l);this.trigger(n,r,f.ConfigurationTarget.DEFAULT)}trigger(l,r,n){const t=new g.ConfigurationChangeEvent(l,{data:r},this.configuration,void 0,this.logService);t.source=n,this._onDidChangeConfiguration.fire(t)}}e.ConfigurationService=O;class y{constructor(l,r,n){this.settingsResource=l,this.fileService=r,this.configurationService=n,this.queue=new b.Queue}write(l,r){return this.queue.queue(()=>this.doWriteConfiguration(l,r))}async doWriteConfiguration(l,r){let n;try{n=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(o){if(o.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw o}const t=[];if((0,A.parse)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.getEdits(n,l,r);n=(0,D.applyEdits)(n,s),await this.fileService.writeFile(this.settingsResource,E.VSBuffer.fromString(n))}getEdits(l,r,n){const{tabSize:t,insertSpaces:s,eol:o}=this.formattingOptions;if(!r.length){const u=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:u,length:u.length,offset:0}]}return(0,D.setProperty)(l,r,n,{tabSize:t,insertSpaces:s,eol:o})}get formattingOptions(){if(!this._formattingOptions){let l=c.OS===c.OperatingSystem.Linux||c.OS===c.OperatingSystem.Macintosh?`
`:`\r
`;const r=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});r&&typeof r=="string"&&r!=="auto"&&(l=r),this._formattingOptions={eol:l,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ue[67],de([0,1,14]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=b,e.getRemoteName=E,e.parseAuthorityWithPort=R,e.parseAuthorityWithOptionalPort=A;function b(v){return v.scheme===I.Schemas.vscodeRemote?v.authority:void 0}function E(v){if(!v)return;const a=v.indexOf("+");return a<0?v:v.substr(0,a)}function R(v){const{host:a,port:h}=D(v);if(typeof h>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:h}}function A(v,a){let{host:h,port:c}=D(v);return typeof c>"u"&&(c=a),{host:h,port:c}}function D(v){const a=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const h=v.match(/^(\[[0-9a-z:]+\])$/);if(h)return{host:h[1],port:void 0};const c=v.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:v,port:void 0}}}),define(ue[22],de([0,1,31,10,67]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=R,e.isApplicationScopedExtension=c,e.isLanguagePackExtension=p,e.isAuthenticationProviderExtension=f,e.isResolverExtension=g,e.parseApiProposals=C,e.parseEnabledApiProposalNames=w,I=Ee(I),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(A||(e.ExtensionType=A={}));var D;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.LINUX_PPC64LE="linux-ppc64le",d.LINUX_RISCV64="linux-riscv64",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(D||(e.TargetPlatform=D={}));class v{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,O){if(typeof m>"u"||m===null)return typeof O>"u"||O===null;if(typeof O>"u"||O===null)return!1;if(typeof m=="string"||typeof O=="string"){const y=typeof m=="string"?m:m.value,i=typeof O=="string"?O:O.value;return I.equalsIgnoreCase(y,i)}return m._lower===O._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=v;class a{get size(){return this._set.size}constructor(m){if(this._set=new Set,m)for(const O of m)this.add(O)}add(m){this._set.add(v.toKey(m))}delete(m){return this._set.delete(v.toKey(m))}has(m){return this._set.has(v.toKey(m))}}e.ExtensionIdentifierSet=a;class h{constructor(){this._map=new Map}clear(){this._map.clear()}delete(m){this._map.delete(v.toKey(m))}get(m){return this._map.get(v.toKey(m))}has(m){return this._map.has(v.toKey(m))}set(m,O){this._map.set(v.toKey(m),O)}values(){return this._map.values()}forEach(m){this._map.forEach(m)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=h;function c(d){return p(d)}function p(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function f(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function g(d,m){if(m){const O=`onResolveRemoteAuthority:${(0,E.getRemoteName)(m)}`;return!!d.activationEvents?.includes(O)}return!1}function C(d){return d.map(m=>{const[O,y]=m.split("@");return{proposalName:O,version:y?parseInt(y):void 0}})}function w(d){return d.map(m=>m.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,b.createDecorator)("IBuiltinExtensionsScannerService")}),define(ue[20],de([0,1,12,5,22,10]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=D,e.toTargetPlatform=v,e.getTargetPlatform=a,e.isNotWebExtensionInWebTargetPlatform=h,e.isTargetPlatformCompatible=c,e.isIExtensionIdentifier=p,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var A;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function D(i){switch(i){case E.TargetPlatform.WIN32_X64:return"Windows 64 bit";case E.TargetPlatform.WIN32_ARM64:return"Windows ARM";case E.TargetPlatform.LINUX_X64:return"Linux 64 bit";case E.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case E.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case E.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case E.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case E.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case E.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case E.TargetPlatform.DARWIN_X64:return"Mac";case E.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case E.TargetPlatform.WEB:return"Web";case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;case E.TargetPlatform.UNKNOWN:return E.TargetPlatform.UNKNOWN;case E.TargetPlatform.UNDEFINED:return E.TargetPlatform.UNDEFINED}}function v(i){switch(i){case E.TargetPlatform.WIN32_X64:return E.TargetPlatform.WIN32_X64;case E.TargetPlatform.WIN32_ARM64:return E.TargetPlatform.WIN32_ARM64;case E.TargetPlatform.LINUX_X64:return E.TargetPlatform.LINUX_X64;case E.TargetPlatform.LINUX_ARM64:return E.TargetPlatform.LINUX_ARM64;case E.TargetPlatform.LINUX_ARMHF:return E.TargetPlatform.LINUX_ARMHF;case E.TargetPlatform.LINUX_PPC64LE:return E.TargetPlatform.LINUX_PPC64LE;case E.TargetPlatform.LINUX_RISCV64:return E.TargetPlatform.LINUX_RISCV64;case E.TargetPlatform.ALPINE_X64:return E.TargetPlatform.ALPINE_X64;case E.TargetPlatform.ALPINE_ARM64:return E.TargetPlatform.ALPINE_ARM64;case E.TargetPlatform.DARWIN_X64:return E.TargetPlatform.DARWIN_X64;case E.TargetPlatform.DARWIN_ARM64:return E.TargetPlatform.DARWIN_ARM64;case E.TargetPlatform.WEB:return E.TargetPlatform.WEB;case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;default:return E.TargetPlatform.UNKNOWN}}function a(i,l){switch(i){case I.Platform.Windows:return l==="x64"?E.TargetPlatform.WIN32_X64:l==="arm64"?E.TargetPlatform.WIN32_ARM64:E.TargetPlatform.UNKNOWN;case I.Platform.Linux:return l==="x64"?E.TargetPlatform.LINUX_X64:l==="arm64"?E.TargetPlatform.LINUX_ARM64:l==="arm"?E.TargetPlatform.LINUX_ARMHF:l==="ppc64le"?E.TargetPlatform.LINUX_PPC64LE:l==="riscv64"?E.TargetPlatform.LINUX_RISCV64:E.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?E.TargetPlatform.ALPINE_X64:l==="arm64"?E.TargetPlatform.ALPINE_ARM64:E.TargetPlatform.UNKNOWN;case I.Platform.Mac:return l==="x64"?E.TargetPlatform.DARWIN_X64:l==="arm64"?E.TargetPlatform.DARWIN_ARM64:E.TargetPlatform.UNKNOWN;case I.Platform.Web:return E.TargetPlatform.WEB}}function h(i,l){return l===E.TargetPlatform.WEB&&!i.includes(E.TargetPlatform.WEB)}function c(i,l,r){return h(l,r)?!1:i===E.TargetPlatform.UNDEFINED||i===E.TargetPlatform.UNIVERSAL?!0:i===E.TargetPlatform.UNKNOWN?!1:i===r}function p(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var f;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var g;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var C;(function(i){i.Install="install",i.Uninstall="uninstall"})(C||(e.StatisticType=C={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var d;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(d||(e.ExtensionGalleryErrorCode=d={}));class m extends Error{constructor(l,r){super(l),this.code=r,this.name=r}}e.ExtensionGalleryError=m;var O;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(O||(e.ExtensionManagementErrorCode=O={}));class y extends Error{constructor(l,r){super(l),this.code=r,this.name=r}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,b.localize2)(11502,"Extensions"),e.PreferencesLocalizedLabel=(0,b.localize2)(11503,"Preferences")}),define(ue[118],de([0,1,2,22,9]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class R extends I.Disposable{constructor(D,v,a,h,c){super(),this.userDataProfilesService=D,this.fileService=v,this.uriIdentityService=a,this.logService=c,this._register(h.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(h.onDidUninstallExtension(p=>this.onDidUnInstallExtension(p)))}onDidInstallExtensions(D){for(const v of D)v.local&&this.invalidate(v.profileLocation)}onDidUnInstallExtension(D){D.error||this.invalidate(D.profileLocation)}async invalidate(D){if(D)for(const v of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(v.extensionsResource,D)&&await this.deleteUserCacheFile(v);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(D){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(D.cacheHome,b.USER_MANIFEST_CACHE_FILE))}catch(v){(0,E.toFileOperationResult)(v)!==E.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(v)}}}e.ExtensionsManifestCache=R});var Ve=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(ue[44],de([0,1,16,57,5,45,22,97]),function(J,e,I,b,E,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=h,e.parseVersion=c,e.normalizeVersion=p,e.isValidVersion=f,e.validateExtensionManifest=g,e.isValidExtensionVersion=C,e.isEngineValid=w,e.areApiProposalsCompatible=d,b=Ve(b),E=Ee(E),R=Ee(R);const v=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function h(y){return y=y.trim(),y==="*"||v.test(y)}function c(y){if(!h(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=y.match(v);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function p(y){if(!y)return null;const i=y.majorBase,l=y.majorMustEqual,r=y.minorBase;let n=y.minorMustEqual;const t=y.patchBase;let s=y.patchMustEqual;y.hasCaret&&(i===0||(n=!1),s=!1);let o=0;if(y.preRelease){const u=a.exec(y.preRelease);if(u){const[,S,T,N]=u;o=Date.UTC(Number(S),Number(T)-1,Number(N))}}return{majorBase:i,majorMustEqual:l,minorBase:r,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:y.hasGreaterEquals,notBefore:o}}function f(y,i,l){let r;typeof y=="string"?r=p(c(y)):r=y;let n;i instanceof Date?n=i.getTime():typeof i=="string"&&(n=new Date(i).getTime());let t;if(typeof l=="string"?t=p(c(l)):t=l,!r||!t)return!1;const s=r.majorBase,o=r.minorBase,u=r.patchBase;let S=t.majorBase,T=t.minorBase,N=t.patchBase;const L=t.notBefore;let k=t.majorMustEqual,U=t.minorMustEqual,G=t.patchMustEqual;return t.isMinimum?s>S?!0:s<S?!1:o>T?!0:o<T||n&&n<L?!1:u>=N:(s===1&&S===0&&(!k||!U||!G)&&(S=1,T=0,N=0,k=!0,U=!1,G=!1),s<S?!1:s>S?!k:o<T?!1:o>T?!U:u<N?!1:u>N?!G:!(n&&n<L))}function g(y,i,l,r,n,t){const s=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return s.push([b.default.Error,E.localize(11433,null)]),s;if(typeof r.name!="string")return s.push([b.default.Error,E.localize(11434,null,"name")]),s;if(typeof r.version!="string")return s.push([b.default.Error,E.localize(11435,null,"version")]),s;if(!r.engines)return s.push([b.default.Error,E.localize(11436,null,"engines")]),s;if(typeof r.engines.vscode!="string")return s.push([b.default.Error,E.localize(11437,null,"engines.vscode")]),s;if(typeof r.extensionDependencies<"u"&&!O(r.extensionDependencies))return s.push([b.default.Error,E.localize(11438,null,"extensionDependencies")]),s;if(typeof r.activationEvents<"u"){if(!O(r.activationEvents))return s.push([b.default.Error,E.localize(11439,null,"activationEvents")]),s;if(typeof r.main>"u"&&typeof r.browser>"u")return s.push([b.default.Error,E.localize(11440,null,"activationEvents","main","browser")]),s}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&s.push([b.default.Warning,E.localize(11441,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return s.push([b.default.Error,E.localize(11442,null,"main")]),s;{const S=(0,I.joinPath)(l,r.main);(0,I.isEqualOrParent)(S,l)||s.push([b.default.Warning,E.localize(11443,null,S.path,l.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return s.push([b.default.Error,E.localize(11444,null,"browser")]),s;{const S=(0,I.joinPath)(l,r.browser);(0,I.isEqualOrParent)(S,l)||s.push([b.default.Warning,E.localize(11445,null,S.path,l.path)])}}if(!R.valid(r.version))return s.push([b.default.Error,E.localize(11446,null)]),s;const o=[];if(!C(y,i,r,n,o))for(const S of o)s.push([b.default.Error,S]);if(t&&r.enabledApiProposals?.length){const S=[];if(!d([...r.enabledApiProposals],S))for(const T of S)s.push([b.default.Error,T])}return s}function C(y,i,l,r,n){return r||typeof l.main>"u"&&typeof l.browser>"u"?!0:m(y,i,l.engines.vscode,n)}function w(y,i,l){return y==="*"||m(i,l,y)}function d(y,i){if(y.length===0)return!0;const l=Array.isArray(i)?i:void 0,r=(l?void 0:i)??D.allApiProposals,n=[],t=(0,A.parseApiProposals)(y);for(const{proposalName:s,version:o}of t){const u=r[s];u&&o&&u.version!==o&&n.push(E.localize(11447,null,s))}return l?.push(...n),n.length===0}function m(y,i,l,r=[]){const n=p(c(l));if(!n)return r.push(E.localize(11448,null,l)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return r.push(E.localize(11449,null,l)),!1}else if(!n.majorMustEqual)return r.push(E.localize(11450,null,l)),!1;return f(y,i,n)?!0:(r.push(E.localize(11451,null,y,l)),!1)}function O(y){if(!Array.isArray(y))return!1;for(let i=0,l=y.length;i<l;i++)if(typeof y[i]!="string")return!1;return!0}}),define(ue[68],de([0,1,21,2,12,5,20,10]),function(J,e,I,b,E,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=v;function v(h){return h.tags.find(c=>c.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,D.createDecorator)("languagePackService");let a=class extends b.Disposable{constructor(c){super(),this.extensionGalleryService=c}async getAvailableLanguages(){const c=new I.CancellationTokenSource;setTimeout(()=>c.cancel(),1e3);let p;try{p=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},c.token)}catch{return[]}const g=p.firstPage.filter(C=>C.properties.localizedLanguages?.length&&C.tags.some(w=>w.startsWith("lp-"))).map(C=>{const w=C.properties.localizedLanguages?.[0],d=v(C);return{...this.createQuickPickItem(d,w,C),extensionId:C.identifier.id,galleryExtension:C}});return g.push(this.createQuickPickItem("en","English")),g}createQuickPickItem(c,p,f){const g=p??c;let C;if(g!==c&&(C=`(${c})`),c.toLowerCase()===E.language.toLowerCase()&&(C??="",C+=(0,R.localize)(11355,null)),f?.installCount){C??="";const w=f.installCount;let d;w>1e6?d=`${Math.floor(w/1e5)/10}M`:w>1e3?d=`${Math.floor(w/1e3)}K`:d=String(w),C+=` $(cloud-download) ${d}`}return{id:c,label:g,description:C}}};e.LanguagePackBaseService=a,e.LanguagePackBaseService=a=we([se(0,A.IExtensionGalleryService)],a)}),define(ue[46],de([0,1,13,7,2,5,40,10,6,37]),function(J,e,I,b,E,R,A,D,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=p,e.hasNoContent=f,e.asText=g,e.asTextOrError=C,e.asJson=w,e.updateProxyConfigurationsScope=d,e.IRequestService=(0,D.createDecorator)("requestService");class h{constructor(i){this.original=i}toJSON(){if(!this.headers){const i=Object.create(null);for(const l in this.original)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?i[l]="*****":i[l]=this.original[l];this.headers=i}return this.headers}}class c extends E.Disposable{constructor(i){super(),this.counter=0,this.logger=i.createLogger("network",{name:(0,R.localize)(11220,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async logAndRequest(i,l,r){const n=`${i} #${++this.counter}: ${l.url}`;this.logger.trace(`${n} - begin`,l.type,new h(l.headers??{}));try{const t=await r();return this.logger.trace(`${n} - end`,l.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.logger.error(`${n} - error`,l.type,(0,b.getErrorMessage)(t)),t}}}e.AbstractRequestService=c;function p(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}function f(y){return y.res.statusCode===204}async function g(y){return f(y)?null:(await(0,I.streamToBuffer)(y.stream)).toString()}async function C(y){if(!p(y))throw new Error("Server returned "+y.res.statusCode);return g(y)}async function w(y){if(!p(y))throw new Error("Server returned "+y.res.statusCode);if(f(y))return null;const l=(await(0,I.streamToBuffer)(y.stream)).toString();try{return JSON.parse(l)}catch(r){throw r.message+=`:
`+l,r}}function d(y){O(y)}let m;function O(y){const i=a.Registry.as(A.Extensions.Configuration),l=m;m={id:"http",order:15,title:(0,R.localize)(11221,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(11222,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(11223,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(11224,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(11225,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(11226,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(11227,null),(0,R.localize)(11228,null),(0,R.localize)(11229,null),(0,R.localize)(11230,null)],default:"override",description:(0,R.localize)(11231,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11232,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(11233,null),restricted:!0}}},i.updateConfigurations({add:[m],remove:l?[l]:[]})}O(A.ConfigurationScope.APPLICATION)}),define(ue[119],de([0,1,21,14,9,46]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(v,a){this.requestService=v,this.fileService=a}async download(v,a,h=I.CancellationToken.None){if(v.scheme===b.Schemas.file||v.scheme===b.Schemas.vscodeRemote){await this.fileService.copy(v,a);return}const c={type:"GET",url:v.toString(!0)},p=await this.requestService.request(c,h);if(p.res.statusCode===200)await this.fileService.writeFile(a,p.stream);else{const f=await(0,R.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${f}`)}}};e.DownloadService=A,e.DownloadService=A=we([se(0,R.IRequestService),se(1,E.IFileService)],A)}),define(ue[120],de([0,1,121,3]),function(J,e,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=R;function E(A,D){return A.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:A.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function R(A,D,v={}){const a=(0,I.parse)(A),h=v.proxyUrl||E(a,D);if(!h)return null;const c=(0,I.parse)(h);if(!/^https?:$/.test(c.protocol||""))return null;const p={host:c.hostname||"",port:(c.port?+c.port:0)||(c.protocol==="https"?443:80),auth:c.auth,rejectUnauthorized:(0,b.isBoolean)(v.strictSSL)?v.strictSSL:!0};if(a.protocol==="http:"){const f=await new Promise((g,C)=>{J(["http-proxy-agent"],g,C)}).then(Ee);return new f.HttpProxyAgent(h,p)}else{const f=await new Promise((g,C)=>{J(["https-proxy-agent"],g,C)}).then(Ee);return new f.HttpsProxyAgent(h,p)}}}),define(ue[122],de([0,1,60,15,5,21,38,7,12,28,86,152,8,79]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=C;let g;async function C(d,m,O,y){return O["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,c.isLaunchedFromCli)(y)&&!O["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,c.isLaunchedFromCli)(y)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=p.Promises.withAsyncBody(async(i,l)=>{const r=new R.CancellationTokenSource;let n=1e4;const t=d.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(n=(0,f.clamp)(t,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),l(new Error((0,E.localize)(11217,null)))},n);try{i(await w(m,r.token))}catch(o){!(0,D.isCancellationError)(o)&&!r.token.isCancellationRequested?l(new Error((0,E.localize)(11218,null,(0,A.toErrorMessage)(o)))):i({})}finally{clearTimeout(s),r.dispose()}})),g)}async function w(d,m){const O=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",O);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",y);const i=(0,a.generateUuid)().replace(/-/g,"").substr(0,12),l=new RegExp(i+"({.*})"+i),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",r);const n=await(0,h.getSystemShell)(v.OS,r);return d.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(m.isCancellationRequested)return s(new D.CancellationError);const o=(0,b.basename)(n);let u,S;const T="";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${T} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,S=["-Login","-Command"]):o==="nu"?(u=`^'${process.execPath}' ${T} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,S=["-i","-l","-c"]):o==="xonsh"?(u=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,S=["-i","-l","-c"]):(u=`'${process.execPath}' ${T} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?S=["-ic"]:S=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),u);const N=(0,I.spawn)(n,[...S,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(N.kill(),s(new D.CancellationError))),N.on("error",U=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(U)),s(U)});const L=[];N.stdout.on("data",U=>L.push(U));const k=[];N.stderr.on("data",U=>k.push(U)),N.on("close",(U,G)=>{const Y=Buffer.concat(L).toString("utf8");d.trace("getUnixShellEnvironment#raw",Y);const te=Buffer.concat(k).toString("utf8");if(te.trim()&&d.trace("getUnixShellEnvironment#stderr",te),U||G)return s(new Error((0,E.localize)(11219,null,U,G)));const ae=l.exec(Y),ce=ae?ae[1]:"{}";try{const fe=JSON.parse(ce);O?fe.ELECTRON_RUN_AS_NODE=O:delete fe.ELECTRON_RUN_AS_NODE,y?fe.ELECTRON_NO_ATTACH_CONSOLE=y:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",fe),t(fe)}catch(fe){d.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(fe)),s(fe)}})})}}),define(ue[123],de([0,1,10]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,I.createDecorator)("stateReadService"),e.IStateService=(0,I.createDecorator)("stateService")}),define(ue[69],de([0,1,8,13,2,3,17,9,6]),function(J,e,I,b,E,R,A,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var a;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class h extends E.Disposable{constructor(g,C,w,d){super(),this.storagePath=g,this.saveStrategy=C,this.logService=w,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new I.ThrottledDelayer(this.saveStrategy===a.IMMEDIATE?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(g){g.fileOperationResult!==D.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(g)}}getItem(g,C){const w=this.storage[g];return(0,R.isUndefinedOrNull)(w)?C:w}setItem(g,C){this.setItems([{key:g,data:C}])}setItems(g){let C=!1;for(const{key:w,data:d}of g)this.storage[w]!==d&&((0,R.isUndefinedOrNull)(d)?(0,R.isUndefined)(this.storage[w])||(this.storage[w]=void 0,C=!0):(this.storage[w]=d,C=!0));C&&this.save()}removeItem(g){(0,R.isUndefined)(this.storage[g])||(this.storage[g]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const g=JSON.stringify(this.storage,null,4);if(g!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,b.VSBuffer.fromString(g),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=g}catch(C){this.logService.error(C)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=h;let c=class extends E.Disposable{constructor(g,C,w,d){super(),this.fileStorage=this._register(new h(C.stateResource,g,w,d))}async init(){await this.fileStorage.init()}getItem(g,C){return this.fileStorage.getItem(g,C)}};e.StateReadonlyService=c,e.StateReadonlyService=c=we([se(1,A.IEnvironmentService),se(2,v.ILogService),se(3,D.IFileService)],c);class p extends c{setItem(g,C){this.fileStorage.setItem(g,C)}setItems(g){this.fileStorage.setItems(g)}removeItem(g){this.fileStorage.removeItem(g)}close(){return this.fileStorage.close()}}e.StateService=p}),define(ue[70],de([0,1,12,36,28]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=A,e.verifyMicrosoftInternalDomain=D;function R(v){if(I.platform===I.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function A(v,a,h,c,p,f,g,C,w,d){const m=Object.create(null);m["common.machineId"]=f,m["common.sqmId"]=g,m["common.devDeviceId"]=C,m.sessionID=(0,E.generateUuid)()+Date.now(),m.commitHash=c,m.version=p,m["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,I.PlatformToString)(I.platform),m["common.nodePlatform"]=b.platform,m["common.nodeArch"]=h,m["common.product"]=d||"desktop",w&&(m["common.msftInternal"]=w);let O=0;const y=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>O++,enumerable:!0}}),I.isLinuxSnap&&(m["common.snap"]="true");const i=R(a);return i&&(m["common.platformDetail"]=i),m}function D(v){const a=b.env.USERDNSDOMAIN;if(!a)return!1;const h=a.toLowerCase();return v.some(c=>h===c)}}),define(ue[18],de([0,1,10]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var b;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(b||(e.TelemetryLevel=b={}));var E;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(ue[71],de([0,1,7,10,6,18]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.ExtensionSignatureVerificationError=e.ExtensionSignatureVerificationCode=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,b.createDecorator)("IExtensionSignatureVerificationService");var A;(function(a){a.Success="Success",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(e.ExtensionSignatureVerificationCode=A={}));class D extends Error{constructor(h){super(h),this.code=h}}e.ExtensionSignatureVerificationError=D;let v=class{constructor(h,c){this.logService=h,this.telemetryService=c}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((h,c)=>J(["@vscode/vsce-sign"],async p=>h(p),c))),this.moduleLoadingPromise}async verify(h,c,p,f){let g;const C=h.identifier.id;try{g=await this.vsceSign()}catch(O){return this.logService.error("Could not load vsce-sign module",(0,I.getErrorMessage)(O)),this.logService.info(`Extension signature verification is not done: ${C}`),!1}const w=new Date().getTime();let d;try{this.logService.trace(`Verifying extension signature for ${C}...`),d=await g.verify(c,p,this.logService.getLevel()===E.LogLevel.Trace)}catch(O){d={code:A.UnknownError,didExecute:!1,output:(0,I.getErrorMessage)(O)}}const m=new Date().getTime()-w;if(this.logService.info(`Extension signature verification result for ${C}: ${d.code}. Executed: ${d.didExecute}. Duration: ${m}ms.`),this.logService.trace(`Extension signature verification output for ${C}:
${d.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:C,extensionVersion:h.version,code:d.code,internalCode:d.internalCode,duration:m,didExecute:d.didExecute,clientTargetPlatform:f}),d.code===A.Success)return!0;throw new D(d.code)}};e.ExtensionSignatureVerificationService=v,e.ExtensionSignatureVerificationService=v=we([se(0,E.ILogService),se(1,R.ITelemetryService)],v)}),define(ue[41],de([0,1,27,3,67,70,18]),function(J,e,I,b,E,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=h,e.isLoggingOnly=c,e.getTelemetryLevel=p,e.validateTelemetryData=f,e.cleanRemoteAuthority=C,e.isInternalTelemetry=d,e.getPiiPathsFromEnvironment=m,e.cleanData=i;class D{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=D;class v{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class a{async publicLog(r,n,t){}async publicLogError(r,n,t){}}e.NullEndpointTelemetryService=a,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(l,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!l.enableTelemetry)}function c(l,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function p(l){const r=l.getValue(A.TELEMETRY_SETTING_ID),n=l.getValue(A.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return A.TelemetryLevel.NONE;switch(r??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function f(l){const r={},n={},t={};w(l,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const o=t[s];typeof o=="number"?n[s]=o:typeof o=="boolean"?n[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:n}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function C(l){if(!l)return"none";const r=(0,E.getRemoteName)(l);return g.has(r)?r:"other"}function w(l,r,n=0,t){if(l)for(const s of Object.getOwnPropertyNames(l)){const o=l[s],u=t?t+s:s;Array.isArray(o)?r[u]=(0,I.safeStringify)(o):o instanceof Date?r[u]=o.toISOString():(0,b.isObject)(o)?n<2?w(o,r,n+1,u+"."):r[u]=(0,I.safeStringify)(o):r[u]=o}}function d(l,r){const n=l.msftInternalDomains||[],t=r.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(n)||t}function m(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function O(l,r){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let n=l;const t=[];for(const S of r)for(;;){const T=S.exec(l);if(!T)break;t.push([T.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(n="";;){const S=o.exec(l);if(!S)break;const T=t.some(([N,L])=>S.index<L&&N<o.lastIndex);!s.test(S[0])&&!T&&(n+=l.substring(u,S.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<l.length&&(n+=l.substr(u)),n}function y(l){if(!l)return l;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of r)if(n.regex.test(l))return`<REDACTED: ${n.label}>`;return l}function i(l,r){return(0,I.cloneAndChange)(l,n=>{if(n instanceof D||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=O(t,r);for(const s of r)t=t.replace(s,"");return t=y(t),t}})}}),define(ue[26],de([0,1,31,20,22,12,11,7,36,41]),function(J,e,I,b,E,R,A,D,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=h,e.getIdAndVersion=g,e.getExtensionId=C,e.adoptToGalleryExtensionId=w,e.getGalleryExtensionId=d,e.groupByExtension=m,e.getLocalExtensionTelemetryData=O,e.getGalleryExtensionTelemetryData=y,e.getExtensionDependencies=i,e.computeTargetPlatform=r;function h(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,I.compareIgnoreCase)(n.id,t.id)===0}const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new p(t.identifier,s,o)}static parse(t){const s=c.exec(t);return s&&s[1]&&s[2]?new p({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o=E.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==E.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof p?h(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=p;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const t=f.exec(n);return t&&t[1]?[w(t[1]),t[2]]:[w(n),void 0]}function C(n,t){return`${n}.${t}`}function w(n){return n.toLowerCase()}function d(n,t){return w(C(n??E.UNDEFINED_PUBLISHER,t))}function m(n,t){const s=[],o=u=>{for(const S of s)if(S.some(T=>h(t(T),t(u))))return S;return null};for(const u of n){const S=o(u);S?S.push(u):s.push([u])}return s}function O(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function y(n){return{id:new a.TelemetryTrustedValue(n.identifier.id),name:new a.TelemetryTrustedValue(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.BetterMergeId=new E.ExtensionIdentifier("pprice.better-merge");function i(n,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&s.every(S=>!h(S.identifier,{id:u}))){const S=n.filter(T=>h(T.identifier,{id:u}));S.length===1&&(s.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function l(n,t){if(!R.isLinux)return!1;let s;try{s=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(u))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(n,t){const s=await l(n,t),o=(0,b.getTargetPlatform)(s?"alpine":R.platform,v.arch);return t.debug("ComputeTargetPlatform:",o),o}}),define(ue[124],de([0,1,21,7,14,16,45,11,5,20,26,22]),function(J,e,I,b,E,R,A,D,v,a,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const p=C=>(0,v.localize)(11470,null,C),f=(0,v.localize)(11471,null,"ms-dotnettools.csharp");let g=class{constructor(w,d,m){this.logger=w,this.extensionManagementService=d,this.extensionGalleryService=m}get location(){}async listExtensions(w,d,m){let O=await this.extensionManagementService.getInstalled(c.ExtensionType.User,m);const y=c.EXTENSION_CATEGORIES.map(l=>l.toLowerCase());if(d&&d!==""){if(y.indexOf(d.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}O=O.filter(l=>l.manifest.categories?l.manifest.categories.map(n=>n.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.logger.info("Possible Categories: "),y.forEach(l=>{this.logger.info(l)});return}this.location&&this.logger.info((0,v.localize)(11472,null,this.location)),O=O.sort((l,r)=>l.identifier.id.localeCompare(r.identifier.id));let i;for(const l of O)i!==l.identifier.id&&(i=l.identifier.id,this.logger.info(w?`${i}@${l.manifest.version}`:i))}async installExtensions(w,d,m,O){const y=[];try{w.length&&this.logger.info(this.location?(0,v.localize)(11473,null,this.location):(0,v.localize)(11474,null));const i=[],l=[],r=(t,s,o)=>{l.push({id:t,version:s!=="prerelease"?s:void 0,installOptions:{...m,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||m.installPreReleaseVersion}})};for(const t of w)if(t instanceof D.URI)i.push({vsix:t,installOptions:m});else{const[s,o]=(0,h.getIdAndVersion)(t);r(s,o,!1)}for(const t of d)if(t instanceof D.URI)i.push({vsix:t,installOptions:{...m,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,h.getIdAndVersion)(t);r(s,o,!0)}const n=await this.extensionManagementService.getInstalled(void 0,m.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:t,installOptions:s})=>{try{await this.installVSIX(t,s,O,n)}catch(o){this.logger.error(o),y.push(t.toString())}})),l.length){const t=await this.installGalleryExtensions(l,n,O);y.push(...t)}}catch(i){throw this.logger.error((0,v.localize)(11475,null,(0,b.getErrorMessage)(i))),i}if(y.length)throw new Error((0,v.localize)(11476,null,y.join(", ")))}async updateExtensions(w){const d=await this.extensionManagementService.getInstalled(c.ExtensionType.User,w),m=[];for(const l of d)l.identifier.uuid&&m.push({...l.identifier,preRelease:l.preRelease});this.logger.trace((0,v.localize)(11477,null,m.length));const O=await this.extensionGalleryService.getExtensions(m,{compatible:!0},I.CancellationToken.None),y=[];for(const l of O)for(const r of d)(0,h.areSameExtensions)(r.identifier,l.identifier)&&(0,A.gt)(l.version,r.manifest.version)&&y.push({extension:l,options:{operation:a.InstallOperation.Update,installPreReleaseVersion:r.preRelease,profileLocation:w,isApplicationScoped:r.isApplicationScoped}});if(!y.length){this.logger.info((0,v.localize)(11478,null));return}this.logger.info((0,v.localize)(11479,null,y.map(l=>l.extension.identifier.id).join(", ")));const i=await this.extensionManagementService.installGalleryExtensions(y);for(const l of i)l.error?this.logger.error((0,v.localize)(11480,null,l.identifier.id,(0,b.getErrorMessage)(l.error))):this.logger.info((0,v.localize)(11481,null,l.identifier.id,l.local?.manifest.version))}async installGalleryExtensions(w,d,m){if(w=w.filter(({id:l,version:r})=>{const n=d.find(t=>(0,h.areSameExtensions)(t.identifier,{id:l}));if(n){if(!m&&(!r||r==="prerelease"&&n.preRelease))return this.logger.info((0,v.localize)(11482,null,l,n.manifest.version,l)),!1;if(r&&n.manifest.version===r)return this.logger.info((0,v.localize)(11483,null,`${l}@${r}`)),!1}return!0}),!w.length)return[];const O=[],y=[],i=await this.getGalleryExtensions(w);if(await Promise.all(w.map(async({id:l,version:r,installOptions:n})=>{const t=i.get(l.toLowerCase());if(!t){this.logger.error(`${p(r?`${l}@${r}`:l)}
${f}`),O.push(l);return}try{const o=await this.extensionGalleryService.getManifest(t,I.CancellationToken.None);if(o&&!this.validateExtensionKind(o))return}catch(o){this.logger.error(o.message||o.stack||o),O.push(l);return}const s=d.find(o=>(0,h.areSameExtensions)(o.identifier,t.identifier));if(s){if(t.version===s.manifest.version){this.logger.info((0,v.localize)(11484,null,r?`${l}@${r}`:l));return}this.logger.info((0,v.localize)(11485,null,l,t.version))}n.isBuiltin?this.logger.info(r?(0,v.localize)(11486,null,l,r):(0,v.localize)(11487,null,l)):this.logger.info(r?(0,v.localize)(11488,null,l,r):(0,v.localize)(11489,null,l)),y.push({extension:t,options:{...n,installGivenVersion:!!r,isApplicationScoped:n.isApplicationScoped||s?.isApplicationScoped}})})),y.length){const l=await this.extensionManagementService.installGalleryExtensions(y);for(const r of l)r.error?(this.logger.error((0,v.localize)(11490,null,r.identifier.id,(0,b.getErrorMessage)(r.error))),O.push(r.identifier.id)):this.logger.info((0,v.localize)(11491,null,r.identifier.id,r.local?.manifest.version))}return O}async installVSIX(w,d,m,O){const y=await this.extensionManagementService.getManifest(w);if(!y)throw new Error("Invalid vsix");if(await this.validateVSIX(y,m,d.profileLocation,O))try{await this.extensionManagementService.install(w,{...d,installGivenVersion:!0}),this.logger.info((0,v.localize)(11492,null,(0,R.basename)(w)))}catch(l){if((0,b.isCancellationError)(l))this.logger.info((0,v.localize)(11493,null,(0,R.basename)(w)));else throw l}}async getGalleryExtensions(w){const d=new Map,m=w.some(i=>i.installOptions.installPreReleaseVersion),O=await this.extensionManagementService.getTargetPlatform(),y=[];for(const i of w)a.EXTENSION_IDENTIFIER_REGEX.test(i.id)&&y.push({...i,preRelease:m});if(y.length){const i=await this.extensionGalleryService.getExtensions(y,{targetPlatform:O},I.CancellationToken.None);for(const l of i)d.set(l.identifier.id.toLowerCase(),l)}return d}validateExtensionKind(w){return!0}async validateVSIX(w,d,m,O){if(!d){const y={id:(0,h.getGalleryExtensionId)(w.publisher,w.name)},i=O.find(l=>(0,h.areSameExtensions)(y,l.identifier)&&(0,A.gt)(l.manifest.version,w.version));if(i)return this.logger.info((0,v.localize)(11494,null,i.identifier.id,i.manifest.version,w.version)),!1}return this.validateExtensionKind(w)}async uninstallExtensions(w,d,m){const O=async i=>{if(i instanceof D.URI){const l=await this.extensionManagementService.getManifest(i);return(0,h.getExtensionId)(l.publisher,l.name)}return i},y=[];for(const i of w){const l=await O(i),n=(await this.extensionManagementService.getInstalled(void 0,m)).filter(t=>(0,h.areSameExtensions)(t.identifier,{id:l}));if(!n.length)throw new Error(`${this.notInstalled(l)}
${f}`);if(n.some(t=>t.type===c.ExtensionType.System)){this.logger.info((0,v.localize)(11495,null,l));return}if(!d&&n.some(t=>t.isBuiltin)){this.logger.info((0,v.localize)(11496,null,l));return}this.logger.info((0,v.localize)(11497,null,l));for(const t of n)await this.extensionManagementService.uninstall(t,{profileLocation:m}),y.push(t);this.location?this.logger.info((0,v.localize)(11498,null,l,this.location)):this.logger.info((0,v.localize)(11499,null,l))}}async locateExtension(w){const d=await this.extensionManagementService.getInstalled();w.forEach(m=>{d.forEach(O=>{if(O.identifier.id===m&&O.location.scheme===E.Schemas.file){this.logger.info(O.location.fsPath);return}})})}notInstalled(w){return this.location?(0,v.localize)(11500,null,w,this.location):(0,v.localize)(11501,null,w)}};e.ExtensionManagementCLI=g,e.ExtensionManagementCLI=g=we([se(1,a.IExtensionManagementService),se(2,a.IExtensionGalleryService)],g)}),define(ue[125],de([0,1,7,4,2,25,26,22,9]),function(J,e,I,b,E,R,A,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class a extends E.Disposable{constructor(c,p,f,g,C,w,d){super(),this.extensionManagementService=c,this.extensionsScannerService=p,this.userDataProfilesService=f,this.extensionsProfileScannerService=g,this.uriIdentityService=C,this.fileService=w,this.logService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new b.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new E.DisposableMap),this.initialize().then(null,m=>d.error("Error while initializing Extensions Watcher",(0,I.getErrorMessage)(m)))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(c=>this.onDidChangeProfiles(c.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(c=>this.onAddExtensions(c))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(c=>this.onDidAddExtensions(c))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(c=>this.onRemoveExtensions(c))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(c=>this.onDidRemoveExtensions(c))),this._register(this.fileService.onDidFilesChange(c=>this.onDidFilesChange(c)))}async onDidChangeProfiles(c){try{c.length&&await Promise.all(c.map(p=>(this.extensionsProfileWatchDisposables.set(p.id,(0,E.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(p.extensionsResource)),this.fileService.watch(p.extensionsResource))),this.populateExtensionsFromProfile(p.extensionsResource))))}catch(p){throw this.logService.error(p),p}}async onAddExtensions(c){for(const p of c.extensions)this.addExtensionWithKey(this.getKey(p.identifier,p.version),c.profileLocation)}async onDidAddExtensions(c){for(const p of c.extensions){const f=this.getKey(p.identifier,p.version);c.error?this.removeExtensionWithKey(f,c.profileLocation):this.addExtensionWithKey(f,c.profileLocation)}}async onRemoveExtensions(c){for(const p of c.extensions)this.removeExtensionWithKey(this.getKey(p.identifier,p.version),c.profileLocation)}async onDidRemoveExtensions(c){const p=[],f=[];for(const g of c.extensions){const C=this.getKey(g.identifier,g.version);c.error?this.addExtensionWithKey(C,c.profileLocation):(this.removeExtensionWithKey(C,c.profileLocation),this.allExtensions.has(C)||(this.logService.debug("Extension is removed from all profiles",g.identifier.id,g.version),f.push(this.extensionManagementService.scanInstalledExtensionAtLocation(g.location).then(w=>{w?p.push(w):this.logService.info("Extension not found at the location",g.location.toString())},w=>this.logService.error(w)))))}try{await Promise.all(f),p.length&&await this.uninstallExtensionsNotInProfiles(p)}catch(g){this.logService.error(g)}}onDidFilesChange(c){for(const p of this.userDataProfilesService.profiles)c.contains(p.extensionsResource,v.FileChangeType.UPDATED,v.FileChangeType.ADDED)&&this.onDidExtensionsProfileChange(p.extensionsResource)}async onDidExtensionsProfileChange(c){const p=[],f=[],g=await this.extensionsProfileScannerService.scanProfileExtensions(c),C=new Set,w=new Set;for(const[d,m]of this.allExtensions)m.has(c)&&w.add(d);for(const d of g){const m=this.getKey(d.identifier,d.version);C.add(m),w.has(m)||(p.push(d.identifier),this.addExtensionWithKey(m,c))}for(const d of w)if(!C.has(d)){const m=this.fromKey(d);m&&(f.push(m.identifier),this.removeExtensionWithKey(d,c))}(p.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p.length?{extensions:p,profileLocation:c}:void 0,removed:f.length?{extensions:f,profileLocation:c}:void 0})}async populateExtensionsFromProfile(c){const p=await this.extensionsProfileScannerService.scanProfileExtensions(c);for(const f of p)this.addExtensionWithKey(this.getKey(f.identifier,f.version),c)}async uninstallExtensionsNotInProfiles(c){c||(c=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(f=>!this.allExtensions.has(this.getKey(f.identifier,f.manifest.version)))),c.length&&await this.extensionManagementService.markAsUninstalled(...c)}addExtensionWithKey(c,p){let f=this.allExtensions.get(c);f||this.allExtensions.set(c,f=new R.ResourceSet(g=>this.uriIdentityService.extUri.getComparisonKey(g))),f.add(p)}removeExtensionWithKey(c,p){const f=this.allExtensions.get(c);f&&f.delete(p),f?.size||this.allExtensions.delete(c)}getKey(c,p){return`${D.ExtensionIdentifier.toKey(c.id)}@${p}`}fromKey(c){const[p,f]=(0,A.getIdAndVersion)(c);return f?{identifier:{id:p},version:f}:void 0}}e.ExtensionsWatcher=a}),define(ue[126],de([0,1,32,153,19,8,2,14,15,29,17,20,26,6,68,11]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0,I=Ee(I);let w=class extends g.LanguagePackBaseService{constructor(y,i,l,r){super(l),this.extensionManagementService=y,this.logService=r,this.cache=this._register(new d(i,r)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getBuiltInExtensionTranslationsUri(y,i){const r=(await this.cache.getLanguagePacks())[i];if(!r){this.logService.warn(`No language pack found for ${i}`);return}const n=r.translations[y];return n?C.URI.file(n):void 0}async getInstalledLanguages(){const y=await this.cache.getLanguagePacks(),i=Object.keys(y).map(l=>{const r=y[l];return{...this.createQuickPickItem(l,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return i.push(this.createQuickPickItem("en","English")),i.sort((l,r)=>l.label.localeCompare(r.label)),i}async postInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",y.identifier.id),await this.update())}async postUninstallExtension(y){const i=await this.cache.getLanguagePacks();Object.keys(i).some(l=>i[l]&&i[l].extensions.some(r=>(0,p.areSameExtensions)(r.extensionIdentifier,y.identifier)))&&(this.logService.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,i]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(i);return!(0,E.equals)(Object.keys(y),Object.keys(l))}};e.NativeLanguagePackService=w,e.NativeLanguagePackService=w=we([se(0,c.IExtensionManagementService),se(1,h.INativeEnvironmentService),se(2,c.IExtensionGalleryService),se(3,f.ILogService)],w);let d=class extends A.Disposable{constructor(y,i){super(),this.logService=i,this.languagePacks={},this.languagePacksFilePath=(0,v.join)(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(i=>{Object.keys(i).forEach(l=>delete i[l]),this.createLanguagePacksFromExtensions(i,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...i){for(const l of i)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,l);Object.keys(y).forEach(l=>this.updateHash(y[l]))}createLanguagePacksFromExtension(y,i){const l=i.identifier,r=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const n of r)if(i.location.scheme===D.Schemas.file&&m(n)){let t=y[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},y[n.languageId]=t);const s=t.extensions.filter(o=>(0,p.areSameExtensions)(o.extensionIdentifier,l))[0];s?s.version=i.manifest.version:t.extensions.push({extensionIdentifier:l,version:i.manifest.version});for(const o of n.translations)t.translations[o.id]=(0,v.join)(i.location.fsPath,o.path)}}updateHash(y){if(y){const i=(0,b.createHash)("md5");for(const l of y.extensions)i.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);y.hash=i.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let i=null;return I.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(i=y(l),l)).then(l=>{for(const n of Object.keys(l))l[n]||delete l[n];this.languagePacks=l,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),a.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>i,l=>this.logService.error(l))})}};d=we([se(0,h.INativeEnvironmentService),se(1,f.ILogService)],d);function m(O){if(typeof O.languageId!="string"||!Array.isArray(O.translations)||O.translations.length===0)return!1;for(const y of O.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(O.languageName&&typeof O.languageName!="string"||O.localizedLanguageName&&typeof O.localizedLanguageName!="string")}}),define(ue[127],de([0,1,82,7,27,41]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://0.0.0.0/OneCollector/1.0",D="https://0.0.0.0/ping";async function v(h,c,p){const f=await(0,I.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,I.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),C=new f.AppInsightsCore,w=new g.PostChannel,d={instrumentationKey:h,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(p){d.extensionConfig={};const m={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:p};d.extensionConfig[w.identifier]=m}return C.initialize(d,[]),C.addTelemetryInitializer(m=>{m.ext=m.ext??{},m.ext.web=m.ext.web??{},m.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',c&&(m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),C}class a{constructor(c,p,f,g,C){this._isInternalTelemetry=c,this._eventPrefix=p,this._defaultData=f,this._xhrOverride=C,this.endPointUrl=A,this.endPointHealthUrl=D,this._defaultData||(this._defaultData={}),typeof g=="function"?this._aiCoreOrKey=g():this._aiCoreOrKey=g,this._asyncAiCore=null}_withAIClient(c){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){c(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=v(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(p=>{c(p)},p=>{(0,b.onUnexpectedError)(p),console.error(p)})}}log(c,p){if(!this._aiCoreOrKey)return;p=(0,E.mixin)(p,this._defaultData),p=(0,R.validateTelemetryData)(p);const f=this._eventPrefix+"/"+c;try{this._withAIClient(g=>{g.pluginVersionString=p?.properties.version??"Unknown",g.track({name:f,baseData:{name:f,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(c=>{this._withAIClient(p=>{p.unload(!0,()=>{this._aiCoreOrKey=void 0,c(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=a});var Ve=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(ue[128],de([0,1,2,27,12,31,5,30,40,129,33,37,18,41]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0,a=Ve(a);let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,m,O){this._configurationService=m,this._productService=O,this._experimentProperties={},this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=d.piiPaths||[],this._telemetryLevel=p.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(y),"gi")),y.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(y.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(y=>{(y.affectsConfiguration(p.TELEMETRY_SETTING_ID)||y.affectsConfiguration(p.TELEMETRY_OLD_SETTING_ID)||y.affectsConfiguration(p.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(d,m){this._experimentProperties[d]=m}_updateTelemetryLevel(){let d=(0,f.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const O=m.usage?p.TelemetryLevel.USAGE:m.error?p.TelemetryLevel.ERROR:p.TelemetryLevel.NONE;d=Math.min(d,O)}this._telemetryLevel=d}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(d,m,O){this._telemetryLevel<m||(O=(0,b.mixin)(O,this._experimentProperties),O=(0,f.cleanData)(O,this._cleanupPatterns),O=(0,b.mixin)(O,this._commonProperties),this._appenders.forEach(y=>y.log(d,O)))}publicLog(d,m){this._log(d,p.TelemetryLevel.USAGE,m)}publicLog2(d,m){this.publicLog(d,m)}publicLogError(d,m){this._sendErrorTelemetry&&this._log(d,p.TelemetryLevel.ERROR,m)}publicLogError2(d,m){this.publicLogError(d,m)}};e.TelemetryService=g,e.TelemetryService=g=we([se(1,D.IConfigurationService),se(2,h.IProductService)],g);function C(){const w=(0,A.localize)(11198,null,a.default.nameLong),d=a.default.privacyStatementUrl?(0,A.localize)(11200,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(11199,null,"https://aka.ms/vscode-telemetry"),m=E.isWeb?"":(0,A.localize)(11201,null),O=(0,A.localize)(11202,null),y=(0,A.localize)(11203,null),i=(0,A.localize)(11204,null),l=(0,A.localize)(11205,null),r=`
|       | ${O} | ${y} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,A.localize)(11206,null);return`
${w} ${d} ${m}

&nbsp;

${l}
${r}

&nbsp;

${n}
`}c.Registry.as(v.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,A.localize)(11207,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:[p.TelemetryConfiguration.ON,p.TelemetryConfiguration.ERROR,p.TelemetryConfiguration.CRASH,p.TelemetryConfiguration.OFF],enumDescriptions:[(0,A.localize)(11208,null),(0,A.localize)(11209,null),(0,A.localize)(11210,null),(0,A.localize)(11211,null)],markdownDescription:C(),default:p.TelemetryConfiguration.OFF,restricted:!0,scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),c.Registry.as(v.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(11212,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(11214,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(11213,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(11215,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ue[130],de([0,1,13,21,154,127]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0,E=Ee(E);async function A(h,c){const p=await c.request(h,b.CancellationToken.None),f=(await(0,I.streamToBuffer)(p.stream)).toString(),g=p.res.statusCode??200;return{headers:p.res.headers,statusCode:g,responseData:f}}async function D(h){const c={method:h.type,headers:h.headers};return new Promise((f,g)=>{const C=E.request(h.url??"",c,w=>{w.on("data",function(d){f({headers:w.headers,statusCode:w.statusCode??200,responseData:d.toString()})}),w.on("error",function(d){g(d)})});C.write(h.data,w=>{w&&g(w)}),C.end()})}async function v(h,c,p){const f=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),g={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:f};try{const C=h?await A(g,h):await D(g);p(C.statusCode,C.headers,C.responseData)}catch{p(0,{})}}class a extends R.AbstractOneDataSystemAppender{constructor(c,p,f,g,C){const w={sendPOST:(d,m)=>{v(c,d,m)}};super(p,f,g,C,w)}}e.OneDataSystemAppender=a}),define(ue[131],de([0,1,32,15,29]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=R,I=Ee(I);async function R(A,D){const v=Object.create(null),a=(c,p)=>{const f=JSON.parse(c);v[p]=f};if(D){const c=[],p=await E.Promises.readdir(D);for(const g of p)try{(await I.promises.stat((0,b.join)(D,g))).isDirectory()&&c.push(g)}catch{}const f=[];for(const g of c)(await E.Promises.readdir((0,b.join)(D,g))).filter(w=>w==="telemetry.json").length===1&&f.push(g);for(const g of f){const C=(await I.promises.readFile((0,b.join)(D,g,"telemetry.json"))).toString();a(C,g)}}let h=(await I.promises.readFile((0,b.join)(A,"telemetry-core.json"))).toString();return a(h,"vscode-core"),h=(await I.promises.readFile((0,b.join)(A,"telemetry-extensions.json"))).toString(),a(h,"vscode-extensions"),JSON.stringify(v,null,4)}}),define(ue[132],de([0,1,12,84,18]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=R,e.resolveSqmId=A,e.resolvedevDeviceId=D;async function R(v,a){let h=v.getItem(E.machineIdKey);return(typeof h!="string"||I.isMacintosh&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,b.getMachineId)(a.error.bind(a))),h}async function A(v,a){let h=v.getItem(E.sqmIdKey);return typeof h!="string"&&(h=await(0,b.getSqmMachineId)(a.error.bind(a))),h}async function D(v,a){let h=v.getItem(E.devDeviceIdKey);return typeof h!="string"&&(h=await(0,b.getdevDeviceId)(a.error.bind(a))),h}}),define(ue[23],de([0,1,10]),function(J,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ue[133],de([0,1,23,98,9,16,80,4,2]),function(J,e,I,b,E,R,A,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class a{static{this._clock=0}constructor(p){this.uri=p,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let h=class{constructor(p){this._fileService=p,this._dispooables=new v.DisposableStore,this._limit=2**16;const f=new Map,g=C=>{let w=f.get(C.scheme);return w===void 0&&(w=p.hasProvider(C)&&!this._fileService.hasCapability(C,E.FileSystemProviderCapabilities.PathCaseSensitive),f.set(C.scheme,w)),w};this._dispooables.add(D.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(C=>{f.delete(C.scheme)})),this.extUri=new R.ExtUri(g),this._canonicalUris=new A.SkipList((C,w)=>this.extUri.compare(C,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,R.normalizePath)(p));const f=this._canonicalUris.get(p);return f?f.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new a(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((g,C)=>g[1].time<C[1].time?1:g[1].time>C[1].time?-1:0);a._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let g=0;g<f;g++)this._canonicalUris.set(p[g][0],p[g][1].touch())}};e.UriIdentityService=h,e.UriIdentityService=h=we([se(0,E.IFileService)],h),(0,b.registerSingleton)(I.IUriIdentityService,h,b.InstantiationType.Delayed)}),define(ue[134],de([0,1,4,2,9,49,25]),function(J,e,I,b,E,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class D extends b.Disposable{constructor(a,h,c,p,f,g){super(),this.fileSystemScheme=a,this.fileSystemProvider=h,this.userDataScheme=c,this.userDataProfilesService=p,this.uriIdentityService=f,this.logService=g,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=R.TernarySearchTree.forUris(()=>!(this.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new A.ResourceSet(C=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(C))),this.updateAtomicReadWritesResources(),this._register(p.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(C=>this.handleFileChanges(C)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const a of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(a.settingsResource),this.atomicReadWriteResources.add(a.keybindingsResource),this.atomicReadWriteResources.add(a.tasksResource),this.atomicReadWriteResources.add(a.extensionsResource)}open(a,h){return this.fileSystemProvider.open(this.toFileSystemResource(a),h)}close(a){return this.fileSystemProvider.close(a)}read(a,h,c,p,f){return this.fileSystemProvider.read(a,h,c,p,f)}write(a,h,c,p,f){return this.fileSystemProvider.write(a,h,c,p,f)}watch(a,h){this.watchResources.set(a,a);const c=this.fileSystemProvider.watch(this.toFileSystemResource(a),h);return(0,b.toDisposable)(()=>{this.watchResources.delete(a),c.dispose()})}stat(a){return this.fileSystemProvider.stat(this.toFileSystemResource(a))}mkdir(a){return this.fileSystemProvider.mkdir(this.toFileSystemResource(a))}rename(a,h,c){return this.fileSystemProvider.rename(this.toFileSystemResource(a),this.toFileSystemResource(h),c)}readFile(a,h){return this.fileSystemProvider.readFile(this.toFileSystemResource(a),h)}readFileStream(a,h,c){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(a),h,c)}readdir(a){return this.fileSystemProvider.readdir(this.toFileSystemResource(a))}enforceAtomicReadFile(a){return this.atomicReadWriteResources.has(a)}writeFile(a,h,c){return this.fileSystemProvider.writeFile(this.toFileSystemResource(a),h,c)}enforceAtomicWriteFile(a){return this.atomicReadWriteResources.has(a)?{postfix:".vsctmp"}:!1}delete(a,h){return this.fileSystemProvider.delete(this.toFileSystemResource(a),h)}copy(a,h,c){if((0,E.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(a),this.toFileSystemResource(h),c);throw new Error("copy not supported")}cloneFile(a,h){if((0,E.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(a),this.toFileSystemResource(h));throw new Error("clone not supported")}handleFileChanges(a){const h=[];for(const c of a){if(c.resource.scheme!==this.fileSystemScheme)continue;const p=this.toUserDataResource(c.resource);this.watchResources.findSubstr(p)&&h.push({resource:p,type:c.type,cId:c.cId})}h.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(h))}toFileSystemResource(a){return a.with({scheme:this.fileSystemScheme})}toUserDataResource(a){return a.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=D}),define(ue[135],de([0,1,5,15,49,16,11,10,14]),function(J,e,I,b,E,R,A,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=a,e.isEmptyWorkspaceIdentifier=h,e.toWorkspaceIdentifier=c,e.isWorkspaceIdentifier=p,e.reviveIdentifier=f,e.isWorkspace=C,e.isWorkspaceFolder=w,e.toWorkspaceFolder=O,e.isUntitledWorkspace=y,e.isTemporaryWorkspace=i,e.isStandaloneEditorWorkspace=l,e.isSavedWorkspace=r,e.hasWorkspaceFileExtension=n,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function a(t){const s=t;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}function h(t){return typeof t?.id=="string"&&!a(t)&&!p(t)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function c(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,b.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function p(t){const s=t;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}function f(t){const s=t;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var g;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function C(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function w(t){const s=t;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class d{constructor(s,o,u,S,T){this._id=s,this._transient=u,this._configuration=S,this._ignorePathCasing=T,this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class m{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function O(t){return new m({uri:t,index:0,name:(0,R.basenameOrAuthority)(t)},{uri:t.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(11031,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(t,s){return R.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}function i(t){let s;return A.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===v.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function r(t,s){return!y(t,s)&&!i(t)}function n(t){return(typeof t=="string"?(0,b.extname)(t):(0,R.extname)(t))===e.WORKSPACE_SUFFIX}}),define(ue[24],de([0,1,43,4,2,16,11,5,17,9,10,6,135,25,23,8,28,31,3]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=y,e.reviveProfile=i,e.toUserDataProfile=l;var O;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(O||(e.ProfileResourceType=O={}));function y(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.IUserDataProfilesService=(0,h.createDecorator)("IUserDataProfilesService");function i(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:A.URI.revive(t.location).with({scheme:s}),globalStorageHome:A.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function l(t,s,o,u,S,T){return{id:t,name:s,location:o,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:T&&S?.useDefaultFlags?.globalState?T.globalStorageHome:(0,R.joinPath)(o,"globalStorage"),settingsResource:T&&S?.useDefaultFlags?.settings?T.settingsResource:(0,R.joinPath)(o,"settings.json"),keybindingsResource:T&&S?.useDefaultFlags?.keybindings?T.keybindingsResource:(0,R.joinPath)(o,"keybindings.json"),tasksResource:T&&S?.useDefaultFlags?.tasks?T.tasksResource:(0,R.joinPath)(o,"tasks.json"),snippetsHome:T&&S?.useDefaultFlags?.snippets?T.snippetsHome:(0,R.joinPath)(o,"snippets"),extensionsResource:T&&S?.useDefaultFlags?.extensions?T.extensionsResource:(0,R.joinPath)(o,"extensions.json"),cacheHome:(0,R.joinPath)(u,t),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let r=class extends E.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(s,o,u,S){super(),this.environmentService=s,this.fileService=o,this.uriIdentityService=u,this.logService=S,this.enabled=!0,this._onDidChangeProfiles=this._register(new b.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new b.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new b.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new b.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new f.ResourceMap,workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,R.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(s){this.enabled!==s&&(this._profilesObject=void 0,this.enabled=s)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const s=this.createDefaultProfile(),o=[s];if(this.enabled)try{for(const T of this.getStoredProfiles()){if(!T.name||!(0,m.isString)(T.name)||!T.location){this.logService.warn("Skipping the invalid stored profile",T.location||T.name);continue}o.push(l((0,R.basename)(T.location),T.name,T.location,this.profilesCacheHome,{shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags},s))}}catch(T){this.logService.error(T)}const u=new f.ResourceMap,S=new Map;if(o.length)try{const T=this.getStoredProfileAssociations();if(T.workspaces)for(const[N,L]of Object.entries(T.workspaces)){const k=A.URI.parse(N),U=o.find(G=>G.id===L);U&&u.set(k,U)}if(T.emptyWindows)for(const[N,L]of Object.entries(T.emptyWindows)){const k=o.find(U=>U.id===L);k&&S.set(N,k)}}catch(T){this.logService.error(T)}this._profilesObject={profiles:o,workspaces:u,emptyWindows:S}}return this._profilesObject}createDefaultProfile(){const s=l("__default__profile__",(0,D.localize)(11078,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...s,extensionsResource:this.getDefaultProfileExtensionsLocation()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",u=new RegExp(`${(0,d.escapeRegExpCharacters)(o)}\\s(\\d+)`);let S=0;for(const N of this.profiles){const L=u.exec(N.name),k=L?parseInt(L[1]):0;S=k>S?k:S}const T=`${o} ${S+1}`;return this.createProfile((0,I.hash)((0,w.generateUuid)()).toString(16),T,{transient:!0},s)}async createNamedProfile(s,o,u){return this.createProfile((0,I.hash)((0,w.generateUuid)()).toString(16),s,o,u)}async createProfile(s,o,u,S){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const T=await this.doCreateProfile(s,o,u);return S&&await this.setProfileForWorkspace(S,T),T}async doCreateProfile(s,o,u){if(!(0,m.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.profileCreationPromises.get(o);return S||(S=(async()=>{try{if(this.profiles.find(k=>k.name===o||k.id===s))throw new Error(`Profile with ${o} name already exists`);const N=l(s,o,(0,R.joinPath)(this.profilesHome,s),this.profilesCacheHome,u,this.defaultProfile);await this.fileService.createFolder(N.location);const L=[];return this._onWillCreateProfile.fire({profile:N,join(k){L.push(k)}}),await C.Promises.settled(L),this.updateProfiles([N],[],[]),N}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,S)),S}async updateProfile(s,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(S=>S.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);return u=l(u.id,o.name??u.name,u.location,this.profilesCacheHome,{shortName:o.shortName??u.shortName,icon:o.icon===null?void 0:o.icon??u.icon,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[u]),u}async removeProfile(s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(S=>S.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const u=[];this._onWillRemoveProfile.fire({profile:o,join(S){u.push(S)}});try{await Promise.allSettled(u)}catch(S){this.logService.error(S)}for(const S of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(S)?.id&&this.profilesObject.emptyWindows.delete(S);for(const S of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(S)?.id&&this.profilesObject.workspaces.delete(S);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(S){(0,a.toFileOperationResult)(S)!==a.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(S)}}async setProfileForWorkspace(s,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(S=>S.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(s,u)}unsetWorkspace(s,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(s,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const s=await this.fileService.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.uriIdentityService.extUri.isEqual(u.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const s=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.getWorkspace(s),u=A.URI.isUri(o)?this.profilesObject.workspaces.get(o):this.profilesObject.emptyWindows.get(o);return u||((0,p.isSingleFolderWorkspaceIdentifier)(s)?this.transientProfilesObject.folders.get(s.uri):(0,p.isWorkspaceIdentifier)(s)?this.transientProfilesObject.workspaces.get(s.configPath):this.transientProfilesObject.emptyWindows.get(s.id))}getWorkspace(s){return(0,p.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,p.isWorkspaceIdentifier)(s)?s.configPath:s.id}isProfileAssociatedToWorkspace(s){return!!([...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,s.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,s.location))||[...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,s.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,s.location))||[...this.transientProfilesObject.folders.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,s.location)))}updateProfiles(s,o,u){const S=[...this.profiles,...s],T=[],N=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let L of S){if(L.isDefault||o.some(U=>L.id===U.id))continue;L=u.find(U=>L.id===U.id)??L;const k=N.find(U=>L.id===U.id);if(L.isTransient)this.transientProfilesObject.profiles.push(L);else{if(k){for(const[U,G]of this.transientProfilesObject.emptyWindows.entries())if(L.id===G.id){this.updateWorkspaceAssociation({id:U},L);break}for(const[U,G]of this.transientProfilesObject.workspaces.entries())if(L.id===G.id){this.updateWorkspaceAssociation({id:"",configPath:U},L);break}for(const[U,G]of this.transientProfilesObject.folders.entries())if(L.id===G.id){this.updateWorkspaceAssociation({id:"",uri:U},L);break}}T.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags})}}this.saveStoredProfiles(T),this._profilesObject=void 0,this.triggerProfilesChanges(s,o,u)}triggerProfilesChanges(s,o,u){this._onDidChangeProfiles.fire({added:s,removed:o,updated:u,all:this.profiles})}updateWorkspaceAssociation(s,o,u){if(u=o?.isTransient?!0:u,u)(0,p.isSingleFolderWorkspaceIdentifier)(s)?(this.transientProfilesObject.folders.delete(s.uri),o&&this.transientProfilesObject.folders.set(s.uri,o)):(0,p.isWorkspaceIdentifier)(s)?(this.transientProfilesObject.workspaces.delete(s.configPath),o&&this.transientProfilesObject.workspaces.set(s.configPath,o)):(this.transientProfilesObject.emptyWindows.delete(s.id),o&&this.transientProfilesObject.emptyWindows.set(s.id,o));else{this.updateWorkspaceAssociation(s,void 0,!0);const S=this.getWorkspace(s);A.URI.isUri(S)?(this.profilesObject.workspaces.delete(S),o&&this.profilesObject.workspaces.set(S,o)):(this.profilesObject.emptyWindows.delete(S),o&&this.profilesObject.emptyWindows.set(S,o)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const s={};for(const[u,S]of this.profilesObject.workspaces.entries())s[u.toString()]=S.id;const o={};for(const[u,S]of this.profilesObject.emptyWindows.entries())o[u.toString()]=S.id;this.saveStoredProfileAssociations({workspaces:s,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(s){const o={},u=this.createDefaultProfile();if(s.workspaces)for(const[T,N]of Object.entries(s.workspaces)){const L=A.URI.parse(N);o[T]=this.uriIdentityService.extUri.isEqual(L,u.location)?u.id:this.uriIdentityService.extUri.basename(L)}const S={};if(s.emptyWindows)for(const[T,N]of Object.entries(s.emptyWindows)){const L=A.URI.parse(N);S[T]=this.uriIdentityService.extUri.isEqual(L,u.location)?u.id:this.uriIdentityService.extUri.basename(L)}return{workspaces:o,emptyWindows:S}}getStoredProfiles(){return[]}saveStoredProfiles(s){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(s){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=r,e.UserDataProfilesService=r=we([se(0,v.IEnvironmentService),se(1,a.IFileService),se(2,g.IUriIdentityService),se(3,c.ILogService)],r);class n extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(s){this.storedProfiles=s}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(s){this.storedProfileAssociations=s}}e.InMemoryUserDataProfilesService=n}),define(ue[53],de([0,1,19,8,21,7,4,2,25,12,3,11,5,20,26,22,44,6,33,18,23,24]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d,m,O,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.toExtensionManagementError=r,p=Ee(p);let l=class extends D.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(o,u,S,T,N,L){super(),this.galleryService=o,this.telemetryService=u,this.uriIdentityService=S,this.logService=T,this.productService=N,this.userDataProfilesService=L,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this._onDidInstallExtensions=this._register(new A.Emitter),this._onUninstallExtension=this._register(new A.Emitter),this._onDidUninstallExtension=this._register(new A.Emitter),this._onDidUpdateExtensionMetadata=this._register(new A.Emitter),this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(({task:k})=>k.cancel()),this.uninstallingExtensions.forEach(k=>k.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const u=await this.getTargetPlatform();return o.allTargetPlatforms.some(S=>(0,f.isTargetPlatformCompatible)(S,o.allTargetPlatforms,u))}async installFromGallery(o,u={}){try{const T=(await this.installGalleryExtensions([{extension:o,options:u}])).find(({identifier:N})=>(0,g.areSameExtensions)(N,o.identifier));if(T?.local)return T?.local;throw T?.error?T.error:new f.ExtensionManagementError(`Unknown error while installing extension ${o.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(S){throw r(S)}}async installGalleryExtensions(o){if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(p.localize(11504,null),f.ExtensionManagementErrorCode.NotAllowed);const u=[],S=[];return await Promise.allSettled(o.map(async({extension:T,options:N})=>{try{const L=await this.checkAndGetCompatibleVersion(T,!!N?.installGivenVersion,!!N?.installPreReleaseVersion,N.productVersion??{version:this.productService.version,date:this.productService.date});S.push({...L,options:N})}catch(L){u.push({identifier:T.identifier,operation:f.InstallOperation.Install,source:T,error:L,profileLocation:N.profileLocation??this.getCurrentExtensionsManifestLocation()})}})),S.length&&u.push(...await this.installExtensions(S)),u}async uninstall(o,u){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.uninstallExtensions([{extension:o,options:u}])}async toggleAppliationScope(o,u){if((0,C.isApplicationScopedExtension)(o.manifest)||o.isBuiltin)return o;if(o.isApplicationScoped){let S=await this.updateMetadata(o,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(u,this.userDataProfilesService.defaultProfile.extensionsResource)||(S=await this.copyExtension(o,this.userDataProfilesService.defaultProfile.extensionsResource,u));for(const T of this.userDataProfilesService.profiles){const N=(await this.getInstalled(C.ExtensionType.User,T.extensionsResource)).find(L=>(0,g.areSameExtensions)(L.identifier,o.identifier));N?this._onDidUpdateExtensionMetadata.fire({local:N,profileLocation:T.extensionsResource}):this._onDidUninstallExtension.fire({identifier:o.identifier,profileLocation:T.extensionsResource})}return S}else{const S=this.uriIdentityService.extUri.isEqual(u,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(o,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(o,u,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:S.identifier,operation:f.InstallOperation.Install,local:S,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),S}}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.extensionsControlManifest||o-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=o),this.extensionsControlManifest}registerParticipant(o){this.participants.push(o)}async resetPinnedStateForAllUserExtensions(o){try{await this.joinAllSettled(this.userDataProfilesService.profiles.map(async u=>{const S=await this.getInstalled(C.ExtensionType.User,u.extensionsResource);await this.joinAllSettled(S.map(async T=>{T.pinned!==o&&await this.updateMetadata(T,{pinned:o},u.extensionsResource)}))}))}catch(u){throw this.logService.error("Error while resetting pinned state for all user extensions",(0,R.getErrorMessage)(u)),u}}async installExtensions(o){const u=new Map,S=new Map,T=[],N=(k,U)=>`${g.ExtensionKey.create(k).toString()}-${U.toString()}`,L=(k,U,G,Y)=>{const te=this.createInstallExtensionTask(k,U,G),ae=`${(0,g.getGalleryExtensionId)(k.publisher,k.name)}-${G.profileLocation.toString()}`;S.set(ae,{task:te,root:Y}),this._onInstallExtension.fire({identifier:te.identifier,source:U,profileLocation:G.profileLocation}),this.logService.info("Installing extension:",te.identifier.id,G),c.URI.isUri(U)||this.installingExtensions.set(N(U,G.profileLocation),{task:te,waitingTasks:[]})};try{for(const{manifest:k,extension:U,options:G}of o){const Y=G.isApplicationScoped||G.isBuiltin||(0,C.isApplicationScopedExtension)(k),te={...G,installOnlyNewlyAddedFromExtensionPack:G.installOnlyNewlyAddedFromExtensionPack??!c.URI.isUri(U),isApplicationScoped:Y,profileLocation:Y?this.userDataProfilesService.defaultProfile.extensionsResource:G.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:G.productVersion??{version:this.productService.version,date:this.productService.date}},ae=c.URI.isUri(U)?void 0:this.installingExtensions.get(N(U,te.profileLocation));ae?(this.logService.info("Extension is already requested to install",ae.task.identifier.id,te.profileLocation.toString()),T.push(ae.task.waitUntilTaskIsFinished())):L(k,U,te,void 0)}return await Promise.all([...S.values()].map(async({task:k})=>{if(k.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",k.identifier.id);else try{const U=await this.getAllDepsAndPackExtensions(k.identifier,k.manifest,!!k.options.installOnlyNewlyAddedFromExtensionPack,!!k.options.installPreReleaseVersion,k.options.profileLocation,k.options.productVersion),G=await this.getInstalled(void 0,k.options.profileLocation,k.options.productVersion),Y={...k.options,context:{...k.options.context,[f.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:te,manifest:ae}of(0,I.distinct)(U,({gallery:ce})=>ce.identifier.id)){if(S.has(`${te.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`))continue;const ce=this.installingExtensions.get(N(te,Y.profileLocation));if(ce){if(this.canWaitForTask(k,ce.task)){const fe=ce.task.identifier;this.logService.info("Waiting for already requested installing extension",fe.id,k.identifier.id,Y.profileLocation.toString()),ce.waitingTasks.push(k),T.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,q=>q.some(Q=>(0,g.areSameExtensions)(Q.identifier,fe)))).then(q=>{if(this.logService.info("Finished waiting for already requested installing extension",fe.id,k.identifier.id,Y.profileLocation.toString()),!q.find(z=>(0,g.areSameExtensions)(z.identifier,fe))?.local)throw new Error(`Extension ${fe.id} is not installed`)}))}}else G.some(({identifier:fe})=>(0,g.areSameExtensions)(fe,te.identifier))||L(ae,te,Y,k)}}catch(U){if(c.URI.isUri(k.source))(0,I.isNonEmptyArray)(k.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",k.identifier.id,U.message),(0,I.isNonEmptyArray)(k.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",k.identifier.id,U.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",k.identifier.id),U}})),await this.joinAllSettled([...S.entries()].map(async([k,{task:U}])=>{const G=new Date().getTime();let Y;try{Y=await U.run(),await this.joinAllSettled(this.participants.map(te=>te.postInstall(Y,U.source,U.options,E.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(te){const ae=r(te);throw c.URI.isUri(U.source)||n(this.telemetryService,U.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(U.source),error:ae,source:U.options.context?.[f.EXTENSION_INSTALL_SOURCE_CONTEXT]}),u.set(k,{error:ae,identifier:U.identifier,operation:U.operation,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,applicationScoped:U.options.isApplicationScoped}),this.logService.error("Error while installing the extension",U.identifier.id,(0,R.getErrorMessage)(ae),U.options.profileLocation.toString()),ae}if(!c.URI.isUri(U.source)){const te=U.operation===f.InstallOperation.Update,ae=te?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(n(this.telemetryService,te?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(U.source),verificationStatus:U.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:ae,source:U.options.context?.[f.EXTENSION_INSTALL_SOURCE_CONTEXT]}),a.isWeb&&U.operation!==f.InstallOperation.Update)try{await this.galleryService.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,f.StatisticType.Install)}catch{}}u.set(k,{local:Y,identifier:U.identifier,operation:U.operation,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,applicationScoped:Y.isApplicationScoped})})),T.length&&await this.joinAllSettled(T),[...u.values()]}catch(k){const U=(te,ae,ce)=>{const fe=[];te.manifest.extensionDependencies?.length&&fe.push(...te.manifest.extensionDependencies),te.manifest.extensionPack?.length&&fe.push(...te.manifest.extensionPack);for(const q of fe){if(ce.includes(q.toLowerCase()))continue;ce.push(q.toLowerCase());const Q=u.get(`${q.toLowerCase()}-${ae.toString()}`);Q?.local&&(ce=U(Q.local,ae,ce))}return ce},G=te=>({identifier:te.identifier,operation:f.InstallOperation.Install,source:te.source,context:te.options.context,profileLocation:te.options.profileLocation,error:k}),Y=[];for(const[te,{task:ae,root:ce}]of S){const fe=u.get(te);fe?fe.local&&ce&&!u.get(`${ce.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(Y.push(this.createUninstallExtensionTask(fe.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),u.set(te,G(ae))):(ae.cancel(),u.set(te,G(ae)))}for(const[te,{task:ae}]of S){const ce=u.get(te);if(!ce?.local||ae.options.donotIncludePackAndDependencies)continue;U(ce.local,ae.options.profileLocation,[ce.local.identifier.id.toLowerCase()]).slice(1).some(q=>S.has(`${q.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!u.get(`${q.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(Y.push(this.createUninstallExtensionTask(ce.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),u.set(te,G(ae)))}throw Y.length&&await Promise.allSettled(Y.map(async te=>{try{await te.run(),this.logService.info("Rollback: Uninstalled extension",te.extension.identifier.id)}catch(ae){this.logService.warn("Rollback: Error while uninstalling extension",te.extension.identifier.id,(0,R.getErrorMessage)(ae))}})),k}finally{for(const{task:k}of S.values())k.source&&!c.URI.isUri(k.source)&&this.installingExtensions.delete(N(k.source,k.options.profileLocation));if(u.size){const k=[...u.values()];for(const U of k)U.local&&this.logService.info("Extension installed successfully:",U.identifier.id,U.profileLocation.toString());this._onDidInstallExtensions.fire(k)}}}canWaitForTask(o,u){for(const[,{task:S,waitingTasks:T}]of this.installingExtensions.entries())if(S===o&&(T.includes(u)||T.some(N=>this.canWaitForTask(N,u)))||S===u&&T[0]&&!this.canWaitForTask(o,T[0]))return!1;return!0}async joinAllSettled(o,u){const S=[],T=[],N=await Promise.allSettled(o);for(const k of N)k.status==="fulfilled"?S.push(k.value):T.push(r(k.reason,u));if(!T.length)return S;if(T.length===1)throw T[0];let L=new f.ExtensionManagementError("",f.ExtensionManagementErrorCode.Unknown);for(const k of T)L=new f.ExtensionManagementError(L.message?`${L.message}, ${k.message}`:k.message,k.code!==f.ExtensionManagementErrorCode.Unknown&&k.code!==f.ExtensionManagementErrorCode.Internal?k.code:L.code);throw L}async getAllDepsAndPackExtensions(o,u,S,T,N,L){if(!this.galleryService.isEnabled())return[];const k=await this.getInstalled(void 0,N,L),U=[],G=[],Y=async(te,ae)=>{U.push(te);const ce=ae.extensionDependencies||[],fe=[...ce];if(ae.extensionPack){const q=S?k.find(Q=>(0,g.areSameExtensions)(Q.identifier,te)):void 0;for(const Q of ae.extensionPack)q&&q.manifest.extensionPack&&q.manifest.extensionPack.some(z=>(0,g.areSameExtensions)({id:z},{id:Q}))||fe.every(z=>!(0,g.areSameExtensions)({id:z},{id:Q}))&&fe.push(Q)}if(fe.length){const q=fe.filter(Q=>U.every(z=>!(0,g.areSameExtensions)(z,{id:Q})));if(q.length){const Q=await this.galleryService.getExtensions(q.map(z=>({id:z,preRelease:T})),E.CancellationToken.None);for(const z of Q){if(U.find(H=>(0,g.areSameExtensions)(H,z.identifier)))continue;const V=ce.some(H=>(0,g.areSameExtensions)({id:H},z.identifier));let K;try{K=await this.checkAndGetCompatibleVersion(z,!1,T,L)}catch(H){if(V)throw H;this.logService.info("Skipping the packed extension as it cannot be installed",z.identifier.id,(0,R.getErrorMessage)(H));continue}G.push({gallery:K.extension,manifest:K.manifest}),await Y(K.extension.identifier,K.manifest)}}}};return await Y(o,u),G}async checkAndGetCompatibleVersion(o,u,S,T){let N;const L=await this.getExtensionsControlManifest();if(L.malicious.some(G=>(0,g.areSameExtensions)(o.identifier,G)))throw new f.ExtensionManagementError(p.localize(11505,null,o.identifier.id),f.ExtensionManagementErrorCode.Malicious);const k=L.deprecated[o.identifier.id.toLowerCase()];if(k?.extension?.autoMigrate){if(this.logService.info(`The '${o.identifier.id}' extension is deprecated, fetching the compatible '${k.extension.id}' extension instead.`),N=(await this.galleryService.getExtensions([{id:k.extension.id,preRelease:k.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:T},E.CancellationToken.None))[0],!N)throw new f.ExtensionManagementError(p.localize(11506,null,o.identifier.id,k.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(o)){const G=await this.getTargetPlatform();throw new f.ExtensionManagementError(p.localize(11507,null,o.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(G)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(N=await this.getCompatibleVersion(o,u,S,T),!N){const G=[];throw(0,w.areApiProposalsCompatible)(o.properties.enabledApiProposals??[],G)?!S&&o.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([o.identifier],E.CancellationToken.None))[0]?new f.ExtensionManagementError(p.localize(11509,null,o.displayName??o.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(p.localize(11510,null,o.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible):new f.ExtensionManagementError(p.localize(11508,null,o.displayName??o.identifier.id,G[0]),f.ExtensionManagementErrorCode.IncompatibleApi)}}this.logService.info("Getting Manifest...",N.identifier.id);const U=await this.galleryService.getManifest(N,E.CancellationToken.None);if(U===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${N.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(U.version!==N.version)throw new f.ExtensionManagementError(`Cannot install '${N.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:N,manifest:U}}async getCompatibleVersion(o,u,S,T){const N=await this.getTargetPlatform();let L=null;return!u&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==S&&(L=(await this.galleryService.getExtensions([{...o.identifier,preRelease:S}],{targetPlatform:N,compatible:!0,productVersion:T},E.CancellationToken.None))[0]||null),!L&&await this.galleryService.isExtensionCompatible(o,S,N,T)&&(L=o),L||(u?L=(await this.galleryService.getExtensions([{...o.identifier,version:o.version}],{targetPlatform:N,compatible:!0,productVersion:T},E.CancellationToken.None))[0]||null:L=await this.galleryService.getCompatibleExtension(o,S,N,T)),L}async uninstallExtensions(o){const u=(G,Y)=>`${G.identifier.id.toLowerCase()}${Y.versionOnly?`-${G.manifest.version}`:""}@${Y.profileLocation.toString()}`,S=(G,Y)=>{const te=this.createUninstallExtensionTask(G,Y);return this.uninstallingExtensions.set(u(te.extension,Y),te),this.logService.info("Uninstalling extension from the profile:",`${G.identifier.id}@${G.manifest.version}`,Y.profileLocation.toString()),this._onUninstallExtension.fire({identifier:G.identifier,profileLocation:Y.profileLocation,applicationScoped:G.isApplicationScoped}),te},T=(G,Y,te)=>{te?this.logService.error("Failed to uninstall extension from the profile:",`${G.identifier.id}@${G.manifest.version}`,Y.profileLocation.toString(),te.message):this.logService.info("Successfully uninstalled extension from the profile",`${G.identifier.id}@${G.manifest.version}`,Y.profileLocation.toString()),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(G),error:te}),this._onDidUninstallExtension.fire({identifier:G.identifier,error:te?.code,profileLocation:Y.profileLocation,applicationScoped:G.isApplicationScoped})},N=[],L=[],k=[],U=new v.ResourceMap;for(const{extension:G,options:Y}of o){const te={...Y,profileLocation:G.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:Y?.profileLocation??this.getCurrentExtensionsManifestLocation()},ae=this.uninstallingExtensions.get(u(G,te));ae?(this.logService.info("Extensions is already requested to uninstall",G.identifier.id),k.push(ae.waitUntilTaskIsFinished())):N.push(S(G,te))}try{for(const G of N.slice(0)){let Y=U.get(G.options.profileLocation);if(Y||U.set(G.options.profileLocation,Y=await this.getInstalled(C.ExtensionType.User,G.options.profileLocation)),G.options.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${G.extension.identifier.id}@${G.extension.manifest.version}`);else{const te=this.getAllPackExtensionsToUninstall(G.extension,Y);for(const ae of te)this.uninstallingExtensions.has(u(ae,G.options))?this.logService.info("Extensions is already requested to uninstall",ae.identifier.id):N.push(S(ae,G.options))}G.options.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${G.extension.identifier.id}@${G.extension.manifest.version}`):this.checkForDependents(N.map(te=>te.extension),Y,G.extension)}await this.joinAllSettled(N.map(async G=>{try{if(await G.run(),await this.joinAllSettled(this.participants.map(Y=>Y.postUninstall(G.extension,G.options,E.CancellationToken.None))),G.extension.identifier.uuid)try{await this.galleryService.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,f.StatisticType.Uninstall)}catch{}}catch(Y){const te=r(Y);throw T(G.extension,G.options,te),te}finally{L.push(G)}})),k.length&&await this.joinAllSettled(k);for(const G of N)T(G.extension,G.options)}catch(G){const Y=r(G);for(const te of N){try{te.cancel()}catch{}L.includes(te)||T(te.extension,te.options,Y)}throw Y}finally{for(const G of N)this.uninstallingExtensions.delete(u(G.extension,G.options))||this.logService.warn("Uninstallation task is not found in the cache",G.extension.identifier.id)}}checkForDependents(o,u,S){for(const T of o){const N=this.getDependents(T,u);if(N.length){const L=N.filter(k=>!o.some(U=>(0,g.areSameExtensions)(U.identifier,k.identifier)));if(L.length)throw new Error(this.getDependentsErrorMessage(T,L,S))}}}getDependentsErrorMessage(o,u,S){return S===o?u.length===1?p.localize(11511,null,S.manifest.displayName||S.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?p.localize(11512,null,S.manifest.displayName||S.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):p.localize(11513,null,S.manifest.displayName||S.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):u.length===1?p.localize(11514,null,S.manifest.displayName||S.manifest.name,o.manifest.displayName||o.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?p.localize(11515,null,S.manifest.displayName||S.manifest.name,o.manifest.displayName||o.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):p.localize(11516,null,S.manifest.displayName||S.manifest.name,o.manifest.displayName||o.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name)}getAllPackExtensionsToUninstall(o,u,S=[]){if(S.indexOf(o)!==-1)return[];S.push(o);const T=o.manifest.extensionPack?o.manifest.extensionPack:[];if(T.length){const N=u.filter(k=>!k.isBuiltin&&T.some(U=>(0,g.areSameExtensions)({id:U},k.identifier))),L=[];for(const k of N)L.push(...this.getAllPackExtensionsToUninstall(k,u,S));return[...N,...L]}return[]}getDependents(o,u){return u.filter(S=>S.manifest.extensionDependencies&&S.manifest.extensionDependencies.some(T=>(0,g.areSameExtensions)({id:T},o.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(o){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,R.getErrorMessage)(o)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=l,e.AbstractExtensionManagementService=l=we([se(0,f.IExtensionGalleryService),se(1,O.ITelemetryService),se(2,y.IUriIdentityService),se(3,d.ILogService),se(4,m.IProductService),se(5,i.IUserDataProfilesService)],l);function r(s,o){if(s instanceof f.ExtensionManagementError)return s;let u;return s instanceof f.ExtensionGalleryError?u=new f.ExtensionManagementError(s.message,s.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):u=new f.ExtensionManagementError(s.message,(0,R.isCancellationError)(s)?f.ExtensionManagementErrorCode.Cancelled:o??f.ExtensionManagementErrorCode.Internal),u.stack=s.stack,u}function n(s,o,{extensionData:u,verificationStatus:S,duration:T,error:N,source:L,durationSinceUpdate:k}){let U,G;(0,h.isDefined)(S)&&(S===!0?S="Verified":(S===!1||(U=f.ExtensionManagementErrorCode.Signature,G=S),S="Unverified")),N&&(U=N.code,N.code===f.ExtensionManagementErrorCode.Signature&&(G=N.message)),s.publicLog(o,{...u,verificationStatus:S,success:!N,duration:T,errorcode:U,errorcodeDetail:G,durationSinceUpdate:k,source:L})}class t{constructor(){this.barrier=new b.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(o=>new Promise((u,S)=>{const T=o.onCancellationRequested(()=>{T.dispose(),S(new R.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(ue[42],de([0,1,8,13,2,4,25,11,20,26,9,10,6,24,23,3,7,18]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(e.ExtensionsProfileScanningErrorCode=m={}));class O extends Error{constructor(n,t){super(n),this.code=t}}e.ExtensionsProfileScanningError=O,e.IExtensionsProfileScannerService=(0,c.createDecorator)("IExtensionsProfileScannerService");let y=class extends E.Disposable{constructor(n,t,s,o,u,S){super(),this.extensionsLocation=n,this.fileService=t,this.userDataProfilesService=s,this.uriIdentityService=o,this.telemetryService=u,this.logService=S,this._onAddExtensions=this._register(new R.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new R.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new R.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new R.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new A.ResourceMap}scanProfileExtensions(n,t){return this.withProfileExtensions(n,void 0,t)}async addExtensionsToProfile(n,t,s){const o=[],u=[];try{return await this.withProfileExtensions(t,S=>{const T=[];if(s)T.push(...S);else for(const N of S)n.some(([L])=>(0,a.areSameExtensions)(L.identifier,N.identifier)&&L.manifest.version!==N.version)?o.push(N):T.push(N);for(const[N,L]of n){const k=T.findIndex(G=>(0,a.areSameExtensions)(G.identifier,N.identifier)&&G.version===N.manifest.version),U={identifier:N.identifier,version:N.manifest.version,location:N.location,metadata:L};k===-1?(u.push(U),T.push(U)):T.splice(k,1,U)}return u.length&&this._onAddExtensions.fire({extensions:u,profileLocation:t}),o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:t}),T}),u.length&&this._onDidAddExtensions.fire({extensions:u,profileLocation:t}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:t}),u}catch(S){throw u.length&&this._onDidAddExtensions.fire({extensions:u,error:S,profileLocation:t}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:S,profileLocation:t}),S}}async updateMetadata(n,t){const s=[];return await this.withProfileExtensions(t,o=>{const u=[];for(const S of o){const T=n.find(([N])=>(0,a.areSameExtensions)(N.identifier,S.identifier)&&N.manifest.version===S.version);T&&(S.metadata={...S.metadata,...T[1]},s.push(S)),u.push(S)}return u}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.withProfileExtensions(t,o=>{const u=[];for(const S of o)(0,a.areSameExtensions)(S.identifier,n.identifier)?s.push(S):u.push(S);return s.length&&this._onRemoveExtensions.fire({extensions:s,profileLocation:t}),u}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this._onDidRemoveExtensions.fire({extensions:s,error:o,profileLocation:t}),o}}async withProfileExtensions(n,t,s){return this.getResourceAccessQueue(n).queue(async()=>{let o=[],u;try{const S=await this.fileService.readFile(n);u=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,h.toFileOperationResult)(S)!==h.FileOperationResult.FILE_NOT_FOUND)throw S;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(u=await this.migrateFromOldDefaultProfileExtensionsLocation()),!u&&s?.bailOutWhenFileNotFound)throw new O((0,w.getErrorMessage)(S),m.ERROR_PROFILE_NOT_FOUND)}if(u){Array.isArray(u)||this.reportAndThrowInvalidConentError(n);let S=!1;for(const T of u){i(T)||this.reportAndThrowInvalidConentError(n);let N;if((0,C.isString)(T.relativeLocation)&&T.relativeLocation)N=this.resolveExtensionLocation(T.relativeLocation);else if((0,C.isString)(T.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${T.location}`);continue}else{N=D.URI.revive(T.location);const L=this.toRelativePath(N);L&&(S=!0,T.relativeLocation=L)}(0,C.isUndefined)(T.metadata?.hasPreReleaseVersion)&&T.metadata?.preRelease&&(S=!0,T.metadata.hasPreReleaseVersion=!0),o.push({identifier:T.identifier,location:N,version:T.version,metadata:T.metadata})}S&&await this.fileService.writeFile(n,b.VSBuffer.fromString(JSON.stringify(u)))}if(t){o=t(o);const S=o.map(T=>({identifier:T.identifier,version:T.version,location:T.location.toJSON(),relativeLocation:this.toRelativePath(T.location),metadata:T.metadata}));await this.fileService.writeFile(n,b.VSBuffer.fromString(JSON.stringify(S)))}return o})}reportAndThrowInvalidConentError(n){const t=new O(`Invalid extensions content in ${n.toString()}`,m.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),t=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let s;try{s=(await this.fileService.readFile(n)).value.toString()}catch(u){if((0,h.toFileOperationResult)(u)===h.FileOperationResult.FILE_NOT_FOUND)return;throw u}this.logService.info("Migrating extensions from old default profile location",n.toString());let o;try{const u=JSON.parse(s);Array.isArray(u)&&u.every(S=>i(S))?o=u:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.logService.error(u)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,b.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(u){if((0,h.toFileOperationResult)(u)===h.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw u}try{await this.fileService.del(n)}catch(u){(0,h.toFileOperationResult)(u)!==h.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(u)}try{await this.fileService.del(t)}catch(u){(0,h.toFileOperationResult)(u)!==h.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(u)}return o})()),this._migrationPromise}getResourceAccessQueue(n){let t=this.resourcesAccessQueueMap.get(n);return t||(t=new I.Queue,this.resourcesAccessQueueMap.set(n,t)),t}};e.AbstractExtensionsProfileScannerService=y,e.AbstractExtensionsProfileScannerService=y=we([se(1,h.IFileService),se(2,f.IUserDataProfilesService),se(3,g.IUriIdentityService),se(4,d.ITelemetryService),se(5,p.ILogService)],y);function i(r){return(0,C.isObject)(r)&&(0,v.isIExtensionIdentifier)(r.identifier)&&(l(r.location)||(0,C.isString)(r.location)&&r.location)&&((0,C.isUndefined)(r.relativeLocation)||(0,C.isString)(r.relativeLocation))&&r.version&&(0,C.isString)(r.version)}function l(r){return r?(0,C.isString)(r.path)&&(0,C.isString)(r.scheme):!1}});var Ve=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(ue[54],de([0,1,19,8,27,13,7,34,90,2,14,15,12,16,45,57,3,11,5,17,26,22,44,9,10,6,33,4,48,42,24,23,96]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d,m,O,y,i,l,r,n,t,s,o,u,S,T,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=ae,E=Ee(E),c=Ee(c),p=Ee(p),g=Ee(g),C=Ve(C);var k;(function(fe){function q(Q,z){if(Q===z)return!0;const V=Object.keys(Q),K=new Set;for(const H of Object.keys(z))K.add(H);if(V.length!==K.size)return!1;for(const H of V){if(Q[H]!==z[H])return!1;K.delete(H)}return K.size===0}fe.equals=q})(k||(e.Translations=k={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let U=class extends a.Disposable{constructor(q,Q,z,V,K,H,ie,ne,F,$,_,P){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=Q,this.extensionsControlLocation=z,this.currentProfile=V,this.userDataProfilesService=K,this.extensionsProfileScannerService=H,this.fileService=ie,this.logService=ne,this.environmentService=F,this.productService=$,this.uriIdentityService=_,this.instantiationService=P,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(te,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(te,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(Y,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(i.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(i.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,y.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(q,Q,z){const[V,K]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(Q)]),H=z?await this.scanExtensionsUnderDevelopment(q,[...V,...K]):[];return this.dedupExtensions(V,K,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const Q=[];Q.push(this.scanDefaultSystemExtensions(!!q.useCache,q.language)),Q.push(this.scanDevSystemExtensions(q.language,!!q.checkControlFile));const[z,V]=await Promise.all(Q);return this.applyScanOptions([...z,...V],i.ExtensionType.System,q,!1)}async scanUserExtensions(q){const Q=q.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Q);const z=this.uriIdentityService.extUri.isEqual(q.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.createExtensionScannerInput(Q,!!q.profileLocation,i.ExtensionType.User,!q.includeUninstalled,q.language,!0,z,q.productVersion??this.getProductVersion()),K=q.useCache&&!V.devMode&&V.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let H;try{H=await K.scanExtensions(V)}catch(ie){if(ie instanceof S.ExtensionsProfileScanningError&&ie.code===S.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),H=await K.scanExtensions(V);else throw ie}return H=await this.applyScanOptions(H,i.ExtensionType.User,q,!0),this.logService.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(q,Q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(V=>V.scheme===h.Schemas.file).map(async V=>{const K=await this.createExtensionScannerInput(V,!1,i.ExtensionType.User,!0,q.language,!1,void 0,q.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(K)).map(ie=>(ie.type=Q.find(ne=>(0,y.areSameExtensions)(ne.identifier,ie.identifier))?.type??ie.type,this.extensionsScanner.validate(ie,K)))}))).flat();return this.applyScanOptions(z,"development",q,!0)}return[]}async scanExistingExtension(q,Q,z){const V=await this.createExtensionScannerInput(q,!1,Q,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),K=await this.extensionsScanner.scanExtension(V);return!K||!z.includeInvalid&&!K.isValid?null:K}async scanOneOrMultipleExtensions(q,Q,z){const V=await this.createExtensionScannerInput(q,!1,Q,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),K=await this.extensionsScanner.scanOneOrMultipleExtensions(V);return this.applyScanOptions(K,Q,z,!0)}async scanMultipleExtensions(q,Q,z){const V=[];return await Promise.all(q.map(async K=>{const H=await this.scanOneOrMultipleExtensions(K,Q,z);V.push(...H)})),this.applyScanOptions(V,Q,z,!0)}async scanMetadata(q){const Q=(0,f.joinPath)(q,"package.json"),z=(await this.fileService.readFile(Q)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(q,Q){const z=(0,f.joinPath)(q,"package.json"),V=(await this.fileService.readFile(z)).value.toString(),K=JSON.parse(V);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,K.__metadata={...K.__metadata,...Q},await this.fileService.writeFile((0,f.joinPath)(q,"package.json"),R.VSBuffer.fromString(JSON.stringify(K,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof S.ExtensionsProfileScanningError&&q.code===S.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw q}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.extensionsProfileScannerService.addExtensionsToProfile(q.map(Q=>[Q,Q.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(Q){(0,r.toFileOperationResult)(Q)!==r.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(Q))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.logService.error(q)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(q,Q,z,V){return z.includeAllVersions||(q=this.dedupExtensions(Q===i.ExtensionType.System?q:void 0,Q===i.ExtensionType.User?q:void 0,Q==="development"?q:void 0,await this.getTargetPlatform(),V)),z.includeInvalid||(q=q.filter(K=>K.isValid)),q.sort((K,H)=>{const ie=c.basename(K.location.fsPath),ne=c.basename(H.location.fsPath);return ie<ne?-1:ie>ne?1:0})}dedupExtensions(q,Q,z,V,K){const H=(ne,F,$)=>{if(ne.isValid&&!F.isValid)return!1;if(ne.isValid===F.isValid){if(K&&g.gt(ne.manifest.version,F.manifest.version))return this.logService.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${ne.location.path} with version ${ne.manifest.version}`),!1;if(g.eq(ne.manifest.version,F.manifest.version)){if(ne.type===i.ExtensionType.System)return this.logService.debug(`Skipping extension ${F.location.path} in favour of system extension ${ne.location.path} with same version`),!1;if(ne.targetPlatform===V)return this.logService.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return $?this.logService.warn(`Overwriting user extension ${ne.location.path} with ${F.location.path}.`):this.logService.debug(`Overwriting user extension ${ne.location.path} with ${F.location.path}.`),!0},ie=new i.ExtensionIdentifierMap;return q?.forEach(ne=>{const F=ie.get(ne.identifier.id);(!F||H(F,ne,!1))&&ie.set(ne.identifier.id,ne)}),Q?.forEach(ne=>{const F=ie.get(ne.identifier.id);if(!F&&q&&ne.type===i.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${ne.location.path}.`);return}(!F||H(F,ne,!1))&&ie.set(ne.identifier.id,ne)}),z?.forEach(ne=>{const F=ie.get(ne.identifier.id);(!F||H(F,ne,!0))&&ie.set(ne.identifier.id,ne),ie.set(ne.identifier.id,ne)}),[...ie.values()]}async scanDefaultSystemExtensions(q,Q){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,Q,!0,void 0,this.getProductVersion()),K=await(q&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",K.length),K}async scanDevSystemExtensions(q,Q){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const V=Q?await this.getBuiltInExtensionControl():{},K=[],H=d.URI.file(c.normalize(c.join(h.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ne of z){const F=V[ne.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":K.push((0,f.joinPath)(H,ne.name));break;default:K.push(d.URI.file(F));break}}const ie=await Promise.all(K.map(async ne=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ne,!1,i.ExtensionType.System,!0,q,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",ie.length),(0,I.coalesce)(ie)}async getBuiltInExtensionControl(){try{const q=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(q.value.toString())}catch{return{}}}async createExtensionScannerInput(q,Q,z,V,K,H,ie,ne){const F=await this.getTranslations(K??p.language),$=await this.getMtime(q),_=Q&&!this.uriIdentityService.extUri.isEqual(q,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,P=_?await this.getMtime(_):void 0;return new G(q,$,_,P,Q,ie,z,V,H,ne.version,ne.date,this.productService.commit,!this.environmentService.isBuilt,K,F)}async getMtime(q){try{const Q=await this.fileService.stat(q);if(typeof Q.mtime=="number")return Q.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=U,e.AbstractExtensionsScannerService=U=we([se(4,T.IUserDataProfilesService),se(5,S.IExtensionsProfileScannerService),se(6,r.IFileService),se(7,t.ILogService),se(8,O.IEnvironmentService),se(9,s.IProductService),se(10,N.IUriIdentityService),se(11,n.IInstantiationService)],U);class G{constructor(q,Q,z,V,K,H,ie,ne,F,$,_,P,M,X,x){this.location=q,this.mtime=Q,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=V,this.profile=K,this.profileScanOptions=H,this.type=ie,this.excludeObsolete=ne,this.validate=F,this.productVersion=$,this.productDate=_,this.productCommit=P,this.devMode=M,this.language=X,this.translations=x}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,Q){return(0,f.isEqual)(q.location,Q.location)&&q.mtime===Q.mtime&&(0,f.isEqual)(q.applicationExtensionslocation,Q.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&q.profile===Q.profile&&E.equals(q.profileScanOptions,Q.profileScanOptions)&&q.type===Q.type&&q.excludeObsolete===Q.excludeObsolete&&q.validate===Q.validate&&q.productVersion===Q.productVersion&&q.productDate===Q.productDate&&q.productCommit===Q.productCommit&&q.devMode===Q.devMode&&q.language===Q.language&&k.equals(q.translations,Q.translations)}}e.ExtensionScannerInput=G;let Y=class extends a.Disposable{constructor(q,Q,z,V,K,H,ie){super(),this.obsoleteFile=q,this.extensionsProfileScannerService=Q,this.uriIdentityService=z,this.fileService=V,this.environmentService=H,this.logService=ie,this.extensionsEnabledWithApiProposalVersion=K.extensionsEnabledWithApiProposalVersion?.map(ne=>ne.toLowerCase())??[]}async scanExtensions(q){const Q=q.profile?await this.scanExtensionsFromProfile(q):await this.scanExtensionsFromLocation(q);let z={};if(q.excludeObsolete&&q.type===i.ExtensionType.User)try{const V=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(V)}catch{}return(0,w.isEmptyObject)(z)?Q:Q.filter(V=>!z[y.ExtensionKey.create(V).toString()])}async scanExtensionsFromLocation(q){const Q=await this.fileService.resolve(q.location);if(!Q.children?.length)return[];const z=await Promise.all(Q.children.map(async V=>{if(!V.isDirectory||q.type===i.ExtensionType.User&&(0,f.basename)(V.resource).indexOf(".")===0)return null;const K=new G(V.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(K)}));return(0,I.coalesce)(z).sort((V,K)=>V.location.path<K.location.path?-1:1)}async scanExtensionsFromProfile(q){let Q=await this.scanExtensionsFromProfileResource(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(q.location,q.applicationExtensionslocation)){Q=Q.filter(V=>!V.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(q.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,q);Q.push(...z)}return Q}async scanExtensionsFromProfileResource(q,Q,z){const V=await this.extensionsProfileScannerService.scanProfileExtensions(q,z.profileScanOptions);if(!V.length)return[];const K=await Promise.all(V.map(async H=>{if(Q(H)){const ie=new G(H.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(ie,H.metadata)}return null}));return(0,I.coalesce)(K)}async scanOneOrMultipleExtensions(q){try{if(await this.fileService.exists((0,f.joinPath)(q.location,"package.json"))){const Q=await this.scanExtension(q);return Q?[Q]:[]}else return await this.scanExtensions(q)}catch(Q){return this.logService.error(`Error scanning extensions at ${q.location.path}:`,(0,A.getErrorMessage)(Q)),[]}}async scanExtension(q,Q){try{let z=await this.scanExtensionManifest(q.location);if(z){z.publisher||(z.publisher=i.UNDEFINED_PUBLISHER),Q=Q??z.__metadata,delete z.__metadata;const V=(0,y.getGalleryExtensionId)(z.publisher,z.name),K=Q?.id?{id:V,uuid:Q.id}:{id:V},H=Q?.isSystem?i.ExtensionType.System:q.type,ie=H===i.ExtensionType.System||!!Q?.isBuiltin;z=await this.translateManifest(q.location,z,G.createNlsConfiguration(q));let ne={type:H,identifier:K,manifest:z,location:q.location,isBuiltin:ie,targetPlatform:Q?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:Q?.publisherDisplayName,metadata:Q,isValid:!0,validations:[]};return q.validate&&(ne=this.validate(ne,q)),z.enabledApiProposals&&(!this.environmentService.isBuilt||this.extensionsEnabledWithApiProposalVersion.includes(V.toLowerCase()))&&(z.originalEnabledApiProposals=z.enabledApiProposals,z.enabledApiProposals=(0,i.parseEnabledApiProposalNames)([...z.enabledApiProposals])),ne}}catch(z){q.type!==i.ExtensionType.System&&this.logService.error(z)}return null}validate(q,Q){let z=!0;const V=this.environmentService.isBuilt&&this.extensionsEnabledWithApiProposalVersion.includes(q.identifier.id.toLowerCase()),K=(0,l.validateExtensionManifest)(Q.productVersion,Q.productDate,Q.location,q.manifest,q.isBuiltin,V);for(const[H,ie]of K)H===C.default.Error&&(z=!1,this.logService.error(this.formatMessage(Q.location,ie)));return q.isValid=z,q.validations=K,q}async scanExtensionManifest(q){const Q=(0,f.joinPath)(q,"package.json");let z;try{z=(await this.fileService.readFile(Q)).value.toString()}catch(K){return(0,r.toFileOperationResult)(K)!==r.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(q,(0,m.localize)(11462,null,Q.path,K.message))),null}let V;try{V=JSON.parse(z)}catch{const H=[];(0,D.parse)(z,H);for(const ie of H)this.logService.error(this.formatMessage(q,(0,m.localize)(11463,null,Q.path,ie.offset,ie.length,(0,v.getParseErrorMessage)(ie.error))));return null}return(0,D.getNodeType)(V)!=="object"?(this.logService.error(this.formatMessage(q,(0,m.localize)(11464,null,Q.path))),null):V}async translateManifest(q,Q,z){const V=await this.getLocalizedMessages(q,Q,z);if(V)try{const K=[],H=await this.resolveOriginalMessageBundle(V.default,K);if(K.length>0)return K.forEach(ne=>{this.logService.error(this.formatMessage(q,(0,m.localize)(11465,null,V.default?.path,(0,v.getParseErrorMessage)(ne.error))))}),Q;if((0,D.getNodeType)(V)!=="object")return this.logService.error(this.formatMessage(q,(0,m.localize)(11466,null,V.default?.path))),Q;const ie=V.values||Object.create(null);return(0,L.localizeManifest)(this.logService,Q,ie,H)}catch{}return Q}async getLocalizedMessages(q,Q,z){const V=(0,f.joinPath)(q,"package.nls.json"),K=(F,$)=>{$.forEach(_=>{this.logService.error(this.formatMessage(q,(0,m.localize)(11467,null,F?.path,(0,v.getParseErrorMessage)(_.error))))})},H=F=>{this.logService.error(this.formatMessage(q,(0,m.localize)(11468,null,F?.path)))},ie=`${Q.publisher}.${Q.name}`,ne=z.translations[ie];if(ne)try{const F=d.URI.file(ne),$=(await this.fileService.readFile(F)).value.toString(),_=[],P=(0,D.parse)($,_);return _.length>0?(K(F,_),{values:void 0,default:V}):(0,D.getNodeType)(P)!=="object"?(H(F),{values:void 0,default:V}):{values:P.contents?P.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.fileService.exists(V))return;let $;try{$=await this.findMessageBundles(q,z)}catch{return}if(!$.localized)return{values:void 0,default:$.original};try{const _=(await this.fileService.readFile($.localized)).value.toString(),P=[],M=(0,D.parse)(_,P);return P.length>0?(K($.localized,P),{values:void 0,default:$.original}):(0,D.getNodeType)(M)!=="object"?(H($.localized),{values:void 0,default:$.original}):{values:M,default:$.original}}catch{return{values:void 0,default:$.original}}}}async resolveOriginalMessageBundle(q,Q){if(q)try{const z=(await this.fileService.readFile(q)).value.toString();return(0,D.parse)(z,Q)}catch{}}findMessageBundles(q,Q){return new Promise((z,V)=>{const K=H=>{const ie=(0,f.joinPath)(q,`package.nls.${H}.json`);this.fileService.exists(ie).then(ne=>{ne&&z({localized:ie,original:(0,f.joinPath)(q,"package.nls.json")});const F=H.lastIndexOf("-");F===-1?z({localized:(0,f.joinPath)(q,"package.nls.json"),original:null}):(H=H.substring(0,F),K(H))})};if(Q.devMode||Q.pseudo||!Q.language)return z({localized:(0,f.joinPath)(q,"package.nls.json"),original:null});K(Q.language)})}formatMessage(q,Q){return`[${q.path}]: ${Q}`}};Y=we([se(1,S.IExtensionsProfileScannerService),se(2,N.IUriIdentityService),se(3,r.IFileService),se(4,s.IProductService),se(5,O.IEnvironmentService),se(6,t.ILogService)],Y);let te=class extends Y{constructor(q,Q,z,V,K,H,ie,ne,F){super(Q,V,K,H,ie,ne,F),this.currentProfile=q,this.userDataProfilesService=z,this.cacheValidatorThrottler=this._register(new b.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(q){const Q=this.getCacheFile(q),z=await this.readExtensionCache(Q);if(this.input=q,z&&z.input&&G.equals(z.input,this.input))return this.logService.debug("Using cached extensions scan result",q.type===i.ExtensionType.System?"system":"user",q.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(K=>(K.location=d.URI.revive(K.location),K));const V=await super.scanExtensions(q);return await this.writeExtensionCache(Q,{input:q,result:V}),V}async readExtensionCache(q){try{const Q=await this.fileService.readFile(q),z=JSON.parse(Q.value.toString());return{result:z.result,input:(0,u.revive)(z.input)}}catch(Q){this.logService.debug("Error while reading the extension cache file:",q.path,(0,A.getErrorMessage)(Q))}return null}async writeExtensionCache(q,Q){try{await this.fileService.writeFile(q,R.VSBuffer.fromString(JSON.stringify(Q)))}catch(z){this.logService.debug("Error while writing the extension cache file:",q.path,(0,A.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const q=this.getCacheFile(this.input),Q=await this.readExtensionCache(q);if(!Q)return;const z=Q.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!E.equals(V,z))try{this.logService.info("Invalidating Cache",z,V),await this.fileService.del(q),this._onDidChangeCache.fire()}catch(K){this.logService.error(K)}}getCacheFile(q){const Q=this.getProfile(q);return this.uriIdentityService.extUri.joinPath(Q.cacheHome,q.type===i.ExtensionType.System?i.BUILTIN_MANIFEST_CACHE_FILE:i.USER_MANIFEST_CACHE_FILE)}getProfile(q){return q.type===i.ExtensionType.System?this.userDataProfilesService.defaultProfile:q.profile?this.uriIdentityService.extUri.isEqual(q.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Q=>this.uriIdentityService.extUri.isEqual(q.location,Q.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};te=we([se(2,T.IUserDataProfilesService),se(3,S.IExtensionsProfileScannerService),se(4,N.IUriIdentityService),se(5,r.IFileService),se(6,s.IProductService),se(7,O.IEnvironmentService),se(8,t.ILogService)],te);function ae(fe,q){const Q=(0,y.getExtensionId)(fe.manifest.publisher,fe.manifest.name);return{id:Q,identifier:new i.ExtensionIdentifier(Q),isBuiltin:fe.type===i.ExtensionType.System,isUserBuiltin:fe.type===i.ExtensionType.User&&fe.isBuiltin,isUnderDevelopment:q,extensionLocation:fe.location,uuid:fe.identifier.uuid,targetPlatform:fe.targetPlatform,publisherDisplayName:fe.publisherDisplayName,...fe.manifest}}class ce extends U{constructor(q,Q,z,V,K,H,ie,ne,F,$,_,P){super(q,Q,(0,f.joinPath)(z,".vscode-oss-dev","extensions","control.json"),V,K,H,ie,ne,F,$,_,P),this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const M=await this.fileService.readFile(d.URI.file(p.translationsConfigFile));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}getTranslations(q){return this.translationsPromise}}e.NativeExtensionsScannerService=ce}),define(ue[136],de([0,1,60,8,38,4,2,14,15,29,6,24]),function(J,e,I,b,E,R,A,D,v,a,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends A.Disposable{constructor(g,C){super(),this.userDataProfilesService=g,this.logService=C,this.processesLimiter=new b.Limiter(5)}async postUninstall(g){const C=this.parseScript(g,"uninstall");C&&(this.logService.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(C.script,"uninstall",C.args,!0,g),this.logService.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(w){this.logService.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.logService.error(w)}}));try{await a.Promises.rm(this.getExtensionStoragePath(g))}catch(w){this.logService.error("Error while removing extension storage path",g.identifier.id),this.logService.error(w)}}parseScript(g,C){const w=`vscode:${C}`;if(g.location.scheme===D.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[w]=="string"){const d=g.manifest.scripts[w].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(g.identifier.id,g.manifest.version,`${w} should be a node script`),null):{script:(0,v.join)(g.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(g,C,w,d,m){return new Promise((O,y)=>{const i=this.start(g,C,w,m);let l;const r=n=>{l&&(clearTimeout(l),l=null),n?y(n):O(void 0)};i.on("error",n=>{r((0,E.toErrorMessage)(n)||"Unknown")}),i.on("exit",(n,t)=>{r(n?`post-${C} process exited with code ${n}`:void 0)}),d&&(l=setTimeout(()=>{l=null,i.kill(),y("timed out")},5e3))})}start(g,C,w,d){const m={silent:!0,execArgv:void 0},O=(0,I.fork)(g,[`--type=extension-post-${C}`,...w],m);O.stdout.setEncoding("utf8"),O.stderr.setEncoding("utf8");const y=R.Event.fromNodeEventEmitter(O.stdout,"data"),i=R.Event.fromNodeEventEmitter(O.stderr,"data");this._register(y(n=>this.logService.info(d.identifier.id,d.manifest.version,`post-${C}`,n))),this._register(i(n=>this.logService.error(d.identifier.id,d.manifest.version,`post-${C}`,n)));const l=R.Event.any(R.Event.map(y,n=>({data:`%c${n}`,format:[""]}),this._store),R.Event.map(i,n=>({data:`%c${n}`,format:["color: red"]}),this._store));return R.Event.debounce(l,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this._store)(n=>{console.group(d.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),O}getExtensionStoragePath(g){return(0,v.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=p,e.ExtensionsLifecycle=p=we([se(0,c.IUserDataProfilesService),se(1,h.ILogService)],p)}),define(ue[72],de([0,1,50,5,53,20]),function(J,e,I,b,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromExtractError=A,e.getManifest=D;function A(v){let a=R.ExtensionManagementErrorCode.Extract;return v instanceof I.ExtractError&&(v.type==="CorruptZip"?a=R.ExtensionManagementErrorCode.CorruptZip:v.type==="Incomplete"&&(a=R.ExtensionManagementErrorCode.IncompleteZip)),(0,E.toExtensionManagementError)(v,a)}async function D(v){let a;try{a=await(0,I.buffer)(v,"extension/package.json")}catch(h){throw A(h)}try{return JSON.parse(a.toString("utf8"))}catch{throw new R.ExtensionManagementError((0,b.localize)(11452,null),R.ExtensionManagementErrorCode.Invalid)}}}),define(ue[137],de([0,1,8,7,2,14,16,45,28,29,50,30,17,53,20,26,72,71,9,6,18]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d,m,O,y){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0,D=Ee(D);let l=class extends E.Disposable{static{i=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(n,t,s,o,u,S,T){super(),this.fileService=t,this.extensionGalleryService=s,this.configurationService=o,this.extensionSignatureVerificationService=u,this.telemetryService=S,this.logService=T,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(n,t,s,o){await this.cleanUpPromise;const u=await this.downloadVSIX(n,t);let S=!1;if(s&&this.shouldVerifySignature(n)){let T;try{T=await this.downloadSignatureArchive(n)}catch(N){try{await this.delete(u)}catch(L){this.logService.error(L)}throw N}try{S=await this.extensionSignatureVerificationService.verify(n,u.fsPath,T.fsPath,o)}catch(N){if(S=N.code,S===d.ExtensionSignatureVerificationCode.PackageIsInvalidZip||S===d.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(u)}catch(L){this.logService.error(L)}throw new g.ExtensionManagementError(h.CorruptZipMessage,g.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(N){this.logService.error(N)}}}return{location:u,verificationStatus:S}}shouldVerifySignature(n){return n.isSigned||this.logService.info(`Extension is not signed: ${n.identifier.id}`),!1}async downloadVSIX(n,t){try{const s=(0,A.joinPath)(this.extensionsDownloadDir,this.getName(n)),o=await this.doDownload(n,"vsix",async()=>{await this.downloadFile(n,s,u=>this.extensionGalleryService.download(n,u,t));try{await this.validate(s.fsPath,"extension/package.json")}catch(u){try{await this.fileService.del(s)}catch(S){this.logService.warn(`Error while deleting: ${s.path}`,(0,b.getErrorMessage)(S))}throw u}},2);return o>1&&this.telemetryService.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:n.identifier.id,attempts:o}),s}catch(s){throw(0,f.toExtensionManagementError)(s,g.ExtensionManagementErrorCode.Download)}}async downloadSignatureArchive(n){try{const t=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`),s=await this.doDownload(n,"sigzip",async()=>{await this.extensionGalleryService.downloadSignatureArchive(n,t);try{await this.validate(t.fsPath,".signature.p7s")}catch(o){try{await this.fileService.del(t)}catch(u){this.logService.warn(`Error while deleting: ${t.path}`,(0,b.getErrorMessage)(u))}throw o}},2);return s>1&&this.telemetryService.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:n.identifier.id,attempts:s}),t}catch(t){throw(0,f.toExtensionManagementError)(t,g.ExtensionManagementErrorCode.DownloadSignature)}}async downloadFile(n,t,s){if(await this.fileService.exists(t))return;if(t.scheme!==R.Schemas.file){await s(t);return}const o=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);try{await s(o)}catch(u){try{await this.fileService.del(o)}catch{}throw u}try{await a.Promises.rename(o.fsPath,t.fsPath,2*60*1e3)}catch(u){try{await this.fileService.del(o)}catch{}let S=!1;try{S=await this.fileService.exists(t)}catch{}if(S)this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,t.path);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(u)}. Deleted the file from downloaded location`,o.path),u}}async doDownload(n,t,s,o){let u=1;for(;;)try{return await s(),u}catch(S){if(u++>o)throw S;this.logService.warn(`Failed downloading ${t}. ${(0,b.getErrorMessage)(S)}. Retry again...`,n.identifier.id)}}async validate(n,t){try{await(0,h.buffer)(n,t)}catch(s){throw(0,w.fromExtractError)(s)}}async delete(n){await this.cleanUpPromise,await this.fileService.del(n)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const t=[],s=[],o=[];for(const T of n.children)if(T.name.endsWith(i.SignatureArchiveExtension))o.push(T.resource);else{const N=C.ExtensionKey.parse(T.name);N&&s.push([N,T])}const u=(0,C.groupByExtension)(s,([T])=>T),S=[];for(const T of u)T.sort((N,L)=>D.rcompare(N[0].version,L[0].version)),t.push(...T.slice(1).map(N=>N[1].resource)),S.push(T[0][1]);S.sort((T,N)=>T.mtime-N.mtime),t.push(...S.slice(0,Math.max(0,S.length-this.cache)).map(T=>T.resource)),t.push(...o),await I.Promises.settled(t.map(T=>(this.logService.trace("Deleting from cache",T.path),this.fileService.del(T))))}}catch(n){this.logService.error(n)}}getName(n){return this.cache?C.ExtensionKey.create(n).toString().toLowerCase():(0,v.generateUuid)()}};e.ExtensionsDownloader=l,e.ExtensionsDownloader=l=i=we([se(0,p.INativeEnvironmentService),se(1,m.IFileService),se(2,g.IExtensionGalleryService),se(3,c.IConfigurationService),se(4,d.IExtensionSignatureVerificationService),se(5,y.ITelemetryService),se(6,O.ILogService)],l)}),define(ue[138],de([0,1,32,8,13,21,38,7,4,43,2,25,14,15,16,45,3,11,28,29,50,5,61,17,53,20,26,42,54,137,136,72,118,125,22,44,9,10,6,33,18,23,24]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d,m,O,y,i,l,r,n,t,s,o,u,S,T,N,L,k,U,G,Y,te,ae,ce,fe,q,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,I=Ee(I),f=Ee(f),C=Ee(C),O=Ee(O),i=Ee(i),e.INativeServerExtensionManagementService=(0,te.refineServiceDecorator)(t.IExtensionManagementService);const z=".vsctmp";let V=class extends n.AbstractExtensionManagementService{constructor(F,$,_,P,M,X,x,W,B,re,oe,le){super(F,$,oe,_,re,le),this.extensionsScannerService=M,this.extensionsProfileScannerService=X,this.downloadService=x,this.instantiationService=W,this.fileService=B,this.extractingGalleryExtensions=new Map,this.knownDirectories=new c.ResourceSet;const ye=this._register(W.createInstance(T.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(K,ve=>ye.postUninstall(ve))),this.manifestCache=this._register(new L.ExtensionsManifestCache(le,B,oe,this,this.logService)),this.extensionsDownloader=this._register(W.createInstance(S.ExtensionsDownloader));const he=this._register(new k.ExtensionsWatcher(this,this.extensionsScannerService,le,X,oe,B,_));this._register(he.onDidChangeExtensionsByAnotherSource(ve=>this.onDidChangeExtensionsFromAnotherSource(ve))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const $=await this.collectFiles(F),_=await(0,y.zip)((0,g.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,m.generateUuid)()).fsPath,$);return d.URI.file(_)}async getManifest(F){const{location:$,cleanup:_}=await this.downloadVsix(F),P=f.resolve($.fsPath);try{return await(0,N.getManifest)(P)}finally{await _()}}getInstalled(F,$=this.userDataProfilesService.defaultProfile.extensionsResource,_={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(F??null,$,_)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.extensionsScanner.scanUserExtensionAtLocation(F)}async install(F,$={}){this.logService.trace("ExtensionManagementService#install",F.toString());const{location:_,cleanup:P}=await this.downloadVsix(F);try{const M=await(0,N.getManifest)(f.resolve(_.fsPath)),X=(0,s.getGalleryExtensionId)(M.publisher,M.name);if(M.engines&&M.engines.vscode&&!(0,G.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(i.localize(11453,null,X,this.productService.version));const W=(await this.installExtensions([{manifest:M,extension:_,options:$}])).find(({identifier:B})=>(0,s.areSameExtensions)(B,{id:X}));if(W?.local)return W.local;throw W?.error?W.error:(0,n.toExtensionManagementError)(new Error(`Unknown error while installing extension ${X}`))}finally{await P()}}async installFromLocation(F,$){this.logService.trace("ExtensionManagementService#installFromLocation",F.toString());const _=await this.extensionsScanner.scanUserExtensionAtLocation(F);if(!_||!_.manifest.name||!_.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.addExtensionsToProfile([[_,{source:"resource"}]],$),this.logService.info("Successfully installed extension",_.identifier.id,$.toString()),_}async installExtensionsFromProfile(F,$,_){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",F,$.toString(),_.toString());const P=(await this.getInstalled(U.ExtensionType.User,$)).filter(M=>F.some(X=>(0,s.areSameExtensions)(X,M.identifier)));if(P.length){const M=await Promise.all(P.map(X=>this.extensionsScanner.scanMetadata(X,$)));await this.addExtensionsToProfile(P.map((X,x)=>[X,M[x]]),_),this.logService.info("Successfully installed extensions",P.map(X=>X.identifier.id),_.toString())}return P}async updateMetadata(F,$,_){return this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id),$.isPreReleaseVersion&&($.preRelease=!0,$.hasPreReleaseVersion=!0),$.isMachineScoped===!1&&($.isMachineScoped=void 0),$.isBuiltin===!1&&($.isBuiltin=void 0),$.pinned===!1&&($.pinned=void 0),F=await this.extensionsScanner.updateMetadata(F,$,_),this.manifestCache.invalidate(_),this._onDidUpdateExtensionMetadata.fire({local:F,profileLocation:_}),F}async reinstallFromGallery(F){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(11454,null));const $=await this.getTargetPlatform(),[_]=await this.galleryService.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:$,compatible:!0},R.CancellationToken.None);if(!_)throw new Error(i.localize(11455,null));await this.extensionsScanner.setUninstalled(F);try{await this.extensionsScanner.removeUninstalledExtension(F)}catch(P){throw new Error(i.localize(11456,null,(0,A.toErrorMessage)(P)))}return this.installFromGallery(_)}copyExtension(F,$,_,P){return this.extensionsScanner.copyExtension(F,$,_,P)}copyExtensions(F,$){return this.extensionsScanner.copyExtensions(F,$,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...F){return this.extensionsScanner.setUninstalled(...F)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(F){this.logService.error(F)}}async download(F,$,_){const{location:P}=await this.extensionsDownloader.download(F,$,!_);return P}async downloadVsix(F){if(F.scheme===p.Schemas.file)return{location:F,async cleanup(){}};this.logService.trace("Downloading extension from",F.toString());const $=(0,g.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,m.generateUuid)());return await this.downloadService.download(F,$),this.logService.info("Downloaded extension to",$.toString()),{location:$,cleanup:async()=>{try{await this.fileService.del($)}catch(P){this.logService.error(P)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(F,$,_){const P=$ instanceof d.URI?new s.ExtensionKey({id:(0,s.getGalleryExtensionId)(F.publisher,F.name)},F.version):s.ExtensionKey.create($);return this.instantiationService.createInstance(H,P,F,$,_,(M,X)=>{if($ instanceof d.URI)return this.extractVSIX(P,$,_,X);let x=this.extractingGalleryExtensions.get(P.toString());return x||(this.extractingGalleryExtensions.set(P.toString(),x=this.downloadAndExtractGalleryExtension(P,$,M,_,X)),x.finally(()=>this.extractingGalleryExtensions.delete(P.toString()))),x},this.extensionsScanner)}createUninstallExtensionTask(F,$){return new ie(F,$,this.extensionsProfileScannerService)}async downloadAndExtractGalleryExtension(F,$,_,P,M){const{verificationStatus:X,location:x}=await this.extensionsDownloader.download($,_,!P.donotVerifySignature,P.context?.[t.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT]);try{if(M.isCancellationRequested)throw new D.CancellationError;const W=await(0,N.getManifest)(x.fsPath);if(!new s.ExtensionKey($.identifier,$.version).equals(new s.ExtensionKey({id:(0,s.getGalleryExtensionId)(W.publisher,W.name)},W.version)))throw new t.ExtensionManagementError(i.localize(11457,null,$.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.extensionsScanner.extractUserExtension(F,x.fsPath,{id:$.identifier.uuid,publisherId:$.publisherId,publisherDisplayName:$.publisherDisplayName,targetPlatform:$.properties.targetPlatform,isApplicationScoped:P.isApplicationScoped,isMachineScoped:P.isMachineScoped,isBuiltin:P.isBuiltin,isPreReleaseVersion:$.properties.isPreReleaseVersion,hasPreReleaseVersion:$.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:P.installGivenVersion?!0:!!P.pinned,preRelease:(0,w.isBoolean)(P.preRelease)?P.preRelease:P.installPreReleaseVersion||$.properties.isPreReleaseVersion,source:"gallery"},!1,M),verificationStatus:X}}catch(W){try{await this.extensionsDownloader.delete(x)}catch(B){this.logService.warn("Error while deleting the downloaded file",x.toString(),(0,D.getErrorMessage)(B))}throw(0,n.toExtensionManagementError)(W)}}async extractVSIX(F,$,_,P){return{local:await this.extensionsScanner.extractUserExtension(F,f.resolve($.fsPath),{isApplicationScoped:_.isApplicationScoped,isMachineScoped:_.isMachineScoped,isBuiltin:_.isBuiltin,installedTimestamp:Date.now(),pinned:_.installGivenVersion?!0:!!_.pinned,source:"vsix"},_.keepExisting??!0,P)}}async collectFiles(F){const $=async P=>{let M=await O.Promises.readdir(P);M=M.map(W=>f.join(P,W));const X=await Promise.all(M.map(W=>I.promises.stat(W)));let x=Promise.resolve([]);return X.forEach((W,B)=>{const re=M[B];W.isFile()&&(x=x.then(oe=>[...oe,re])),W.isDirectory()&&(x=x.then(oe=>$(re).then(le=>[...oe,...le])))}),x};return(await $(F.location.fsPath)).map(P=>({path:`extension/${f.relative(F.location.fsPath,P)}`,localPath:P}))}async onDidChangeExtensionsFromAnotherSource({added:F,removed:$}){if($){const _=F&&this.uriIdentityService.extUri.isEqual($.profileLocation,F.profileLocation)?$.extensions.filter(P=>F.extensions.every(M=>!(0,s.areSameExtensions)(M,P))):$.extensions;for(const P of _)this.logService.info("Extensions removed from another source",P.id,$.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:P,profileLocation:$.profileLocation})}if(F){const P=(await this.getInstalled(U.ExtensionType.User,F.profileLocation)).filter(M=>F.extensions.some(X=>(0,s.areSameExtensions)(X,M.identifier)));this._onDidInstallExtensions.fire(P.map(M=>(this.logService.info("Extensions added from another source",M.identifier.id,F.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:F.profileLocation,operation:t.InstallOperation.None})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract($=>this.knownDirectories.add($)));const F=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const $ of F.children??[])$.isDirectory&&this.knownDirectories.add($.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange($=>this.onDidFilesChange($)))}async onDidFilesChange(F){if(!F.affects(this.extensionsScannerService.userExtensionsLocation,Y.FileChangeType.ADDED))return;const $=[];for(const _ of F.rawAdded){if(this.knownDirectories.has(_)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(_),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(_,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(_).startsWith(".")||!(await this.fileService.stat(_)).isDirectory)continue;const P=await this.extensionsScanner.scanUserExtensionAtLocation(_);P&&P.installedTimestamp===void 0&&(this.knownDirectories.add(_),$.push(P))}$.length&&(await this.addExtensionsToProfile($.map(_=>[_,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",$.map(_=>_.identifier.id)))}async addExtensionsToProfile(F,$){const _=F.map(P=>P[0]);await this.setInstalled(_),await this.extensionsProfileScannerService.addExtensionsToProfile(F,$),this._onDidInstallExtensions.fire(_.map(P=>({local:P,identifier:P.identifier,operation:t.InstallOperation.None,profileLocation:$})))}async setInstalled(F){const $=await this.extensionsScanner.getUninstalledExtensions();for(const _ of F){const P=s.ExtensionKey.create(_);$[P.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",P.id),await this.extensionsScanner.setInstalled(P),this.logService.info("Removed the extension from uninstalled list:",P.id))}}};e.ExtensionManagementService=V,e.ExtensionManagementService=V=we([se(0,t.IExtensionGalleryService),se(1,fe.ITelemetryService),se(2,ae.ILogService),se(3,r.INativeEnvironmentService),se(4,u.IExtensionsScannerService),se(5,o.IExtensionsProfileScannerService),se(6,l.IDownloadService),se(7,te.IInstantiationService),se(8,Y.IFileService),se(9,ce.IProductService),se(10,q.IUriIdentityService),se(11,Q.IUserDataProfilesService)],V);let K=class extends h.Disposable{constructor(F,$,_,P,M,X,x){super(),this.beforeRemovingExtension=F,this.fileService=$,this.extensionsScannerService=_,this.extensionsProfileScannerService=P,this.uriIdentityService=M,this.telemetryService=X,this.logService=x,this._onExtract=this._register(new v.Emitter),this.onExtract=this._onExtract.event,this.scanAllExtensionPromise=new c.ResourceMap,this.scanUserExtensionsPromise=new c.ResourceMap,this.uninstalledResource=(0,g.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new b.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(F,$,_){try{const P={includeInvalid:!0,profileLocation:$,productVersion:_};let M=[];if(F===null||F===U.ExtensionType.System){let X=this.scanAllExtensionPromise.get($);X||(X=this.extensionsScannerService.scanAllExtensions({includeInvalid:!0,useCache:!0},P,!1).finally(()=>this.scanAllExtensionPromise.delete($)),this.scanAllExtensionPromise.set($,X)),M.push(...await X)}else if(F===U.ExtensionType.User){let X=this.scanUserExtensionsPromise.get($);X||(X=this.extensionsScannerService.scanUserExtensions(P).finally(()=>this.scanUserExtensionsPromise.delete($)),this.scanUserExtensionsPromise.set($,X)),M.push(...await X)}return M=F!==null?M.filter(X=>X.type===F):M,await Promise.all(M.map(X=>this.toLocalExtension(X)))}catch(P){throw(0,n.toExtensionManagementError)(P,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(F){try{const $=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all($.map(_=>this.toLocalExtension(_)))}catch($){throw(0,n.toExtensionManagementError)($,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(F){try{const $=await this.extensionsScannerService.scanExistingExtension(F,U.ExtensionType.User,{includeInvalid:!0});if($)return await this.toLocalExtension($)}catch($){this.logService.error($)}return null}async extractUserExtension(F,$,_,P,M){const X=F.toString(),x=d.URI.file(f.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,m.generateUuid)()}`)),W=d.URI.file(f.join(this.extensionsScannerService.userExtensionsLocation.fsPath,X));if(await this.fileService.exists(W)){if(!P)try{return await this.scanLocalExtension(W,U.ExtensionType.User)}catch(B){this.logService.warn(`Error while scanning the existing extension at ${W.path}. Deleting the existing extension and extracting it.`,(0,D.getErrorMessage)(B))}try{await this.deleteExtensionFromLocation(F.id,W,"removeExisting")}catch{throw new t.ExtensionManagementError(i.localize(11458,null,W.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}}try{if(M.isCancellationRequested)throw new D.CancellationError;try{this.logService.trace(`Started extracting the extension from ${$} to ${W.fsPath}`),await(0,y.extract)($,x.fsPath,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${W}:`,F.id)}catch(B){throw(0,N.fromExtractError)(B)}try{await this.extensionsScannerService.updateMetadata(x,_)}catch(B){throw this.telemetryService.publicLog2("extension:extract",{extensionId:F.id,code:`${(0,Y.toFileOperationResult)(B)}`}),(0,n.toExtensionManagementError)(B,t.ExtensionManagementErrorCode.UpdateMetadata)}if(M.isCancellationRequested)throw new D.CancellationError;try{this.logService.trace(`Started renaming the extension from ${x.fsPath} to ${W.fsPath}`),await this.rename(x.fsPath,W.fsPath),this.logService.info("Renamed to",W.fsPath)}catch(B){if(B.code==="ENOTEMPTY"){this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);try{await this.fileService.del(x,{recursive:!0})}catch{}}else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(B)}. Deleted from extracted location`,x),B}this._onExtract.fire(W)}catch(B){try{await this.fileService.del(x,{recursive:!0})}catch{}throw B}return this.scanLocalExtension(W,U.ExtensionType.User)}async scanMetadata(F,$){return $?(await this.getScannedExtension(F,$))?.metadata:this.extensionsScannerService.scanMetadata(F.location)}async getScannedExtension(F,$){return(await this.extensionsProfileScannerService.scanProfileExtensions($)).find(P=>(0,s.areSameExtensions)(P.identifier,F.identifier))}async updateMetadata(F,$,_){try{_?await this.extensionsProfileScannerService.updateMetadata([[F,$]],_):await this.extensionsScannerService.updateMetadata(F.location,$)}catch(P){throw this.telemetryService.publicLog2("extension:extract",{extensionId:F.identifier.id,code:`${(0,Y.toFileOperationResult)(P)}`,isProfile:!!_}),(0,n.toExtensionManagementError)(P,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(F.location,F.type,_)}async getUninstalledExtensions(){try{return await this.withUninstalledExtensions()}catch(F){throw(0,n.toExtensionManagementError)(F,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...F){const $=F.map(_=>s.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>$.forEach(P=>{_[P.toString()]=!0,this.logService.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(F){try{await this.withUninstalledExtensions($=>delete $[F.toString()])}catch($){throw(0,n.toExtensionManagementError)($,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(F,$){if(this.uriIdentityService.extUri.isEqualOrParent(F.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(F.identifier.id,F.location,$)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions($=>delete $[s.ExtensionKey.create(F).toString()])}async copyExtension(F,$,_,P){const M=await this.getScannedExtension(F,$),X=await this.getScannedExtension(F,_);if(P={...M?.metadata,...P},X)if(this.uriIdentityService.extUri.isEqual(X.location,F.location))await this.extensionsProfileScannerService.updateMetadata([[F,{...X.metadata,...P}]],_);else{const x=await this.scanLocalExtension(X.location,F.type,_);await this.extensionsProfileScannerService.removeExtensionFromProfile(x,_),await this.extensionsProfileScannerService.addExtensionsToProfile([[F,{...X.metadata,...P}]],_)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[F,P]],_);return this.scanLocalExtension(F.location,F.type,_)}async copyExtensions(F,$,_){const P=await this.scanExtensions(U.ExtensionType.User,F,_),M=await Promise.all(P.filter(X=>!X.isApplicationScoped).map(async X=>[X,await this.scanMetadata(X,F)]));await this.extensionsProfileScannerService.addExtensionsToProfile(M,$)}async deleteExtensionFromLocation(F,$,_){this.logService.trace(`Deleting ${_} extension from disk`,F,$.fsPath);const P=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname($),`${this.uriIdentityService.extUri.basename($)}.${(0,a.hash)((0,m.generateUuid)()).toString(16)}${z}`);await this.rename($.fsPath,P.fsPath),await this.fileService.del(P,{recursive:!0}),this.logService.info(`Deleted ${_} extension from disk`,F,$.fsPath)}withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let $;try{$=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(P){if((0,Y.toFileOperationResult)(P)!==Y.FileOperationResult.FILE_NOT_FOUND)throw P}let _={};if($)try{_=JSON.parse($)}catch{}return F&&(F(_),Object.keys(_).length?await this.fileService.writeFile(this.uninstalledResource,E.VSBuffer.fromString(JSON.stringify(_))):await this.fileService.del(this.uninstalledResource)),_})}async rename(F,$){try{await O.Promises.rename(F,$,2*60*1e3)}catch(_){throw(0,n.toExtensionManagementError)(_,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,$,_){try{if(_){const M=(await this.extensionsScannerService.scanUserExtensions({profileLocation:_})).find(X=>this.uriIdentityService.extUri.isEqual(X.location,F));if(M)return await this.toLocalExtension(M)}else{const P=await this.extensionsScannerService.scanExistingExtension(F,$,{includeInvalid:!0});if(P)return await this.toLocalExtension(P)}throw new t.ExtensionManagementError(i.localize(11459,null,F.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(P){throw(0,n.toExtensionManagementError)(P,t.ExtensionManagementErrorCode.ScanningExtension)}}async toLocalExtension(F){const $=await this.fileService.resolve(F.location);let _,P;return $.children&&(_=$.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,P=$.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:_,changelogUrl:P,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(F));const $=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const M of $)F[s.ExtensionKey.create(M).toString()]||_.add(M.identifier.id.toLowerCase());try{const M=(0,s.groupByExtension)($,X=>X.identifier);await b.Promises.settled(M.map(async X=>{const x=X.sort((W,B)=>C.rcompare(W.manifest.version,B.manifest.version))[0];_.has(x.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(x))}))}catch(M){this.logService.error(M)}const P=$.filter(M=>M.metadata&&F[s.ExtensionKey.create(M).toString()]);await Promise.allSettled(P.map(M=>this.removeUninstalledExtension(M)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch($){(0,Y.toFileOperationResult)($)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.logService.error($);return}if(F?.children)try{await Promise.allSettled(F.children.map(async $=>{if(!(!$.isDirectory||!$.name.endsWith(z))){this.logService.trace("Deleting the temporarily deleted folder",$.resource.toString());try{await this.fileService.del($.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",$.resource.toString())}catch(_){(0,Y.toFileOperationResult)(_)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(_)}}}))}catch{}}};e.ExtensionsScanner=K,e.ExtensionsScanner=K=we([se(1,Y.IFileService),se(2,u.IExtensionsScannerService),se(3,o.IExtensionsProfileScannerService),se(4,q.IUriIdentityService),se(5,fe.ITelemetryService),se(6,ae.ILogService)],K);let H=class extends n.AbstractExtensionTask{get operation(){return this.options.operation??this._operation}get verificationStatus(){return this._verificationStatus}constructor(F,$,_,P,M,X,x,W,B,re,oe,le){super(),this.extensionKey=F,this.manifest=$,this.source=_,this.options=P,this.extractExtensionFn=M,this.extensionsScanner=X,this.uriIdentityService=x,this.galleryService=W,this.userDataProfilesService=B,this.extensionsScannerService=re,this.extensionsProfileScannerService=oe,this.logService=le,this._operation=t.InstallOperation.Install,this.identifier=this.extensionKey.identifier}async doRun(F){const _=(await this.extensionsScanner.scanExtensions(U.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(x=>(0,s.areSameExtensions)(x.identifier,this.identifier));_&&(this._operation=t.InstallOperation.Update);const P={isApplicationScoped:this.options.isApplicationScoped||_?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===U.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??_?.pinned,source:this.source instanceof d.URI?"vsix":"gallery"};let M;if(this.source instanceof d.URI){if(_&&this.extensionKey.equals(new s.ExtensionKey(_.identifier,_.manifest.version)))try{await this.extensionsScanner.removeExtension(_,"existing")}catch{throw new Error(i.localize(11460,null,this.manifest.displayName||this.manifest.name))}const x=await this.unsetIfUninstalled(this.extensionKey);if(x)try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(i.localize(11461,null,this.manifest.displayName||this.manifest.name))}}else{if(P.id=this.source.identifier.uuid,P.publisherId=this.source.publisherId,P.publisherDisplayName=this.source.publisherDisplayName,P.targetPlatform=this.source.properties.targetPlatform,P.updated=!!_,P.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,P.hasPreReleaseVersion=_?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,P.preRelease=(0,w.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||_?.preRelease,_&&_.type!==U.ExtensionType.System&&_.manifest.version===this.source.version)return this.extensionsScanner.updateMetadata(_,P,this.options.profileLocation);M=await this.unsetIfUninstalled(this.extensionKey)}if(F.isCancellationRequested)throw(0,n.toExtensionManagementError)(new D.CancellationError);if(!M){const x=await this.extractExtensionFn(this.operation,F);M=x.local,this._verificationStatus=x.verificationStatus}if(this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.extensionsScannerService.initializeDefaultProfileExtensions()}catch(x){throw(0,n.toExtensionManagementError)(x,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(F.isCancellationRequested)throw(0,n.toExtensionManagementError)(new D.CancellationError);try{await this.extensionsProfileScannerService.addExtensionsToProfile([[M,P]],this.options.profileLocation,!M.isValid)}catch(x){throw(0,n.toExtensionManagementError)(x,t.ExtensionManagementErrorCode.AddToProfile)}const X=await this.extensionsScanner.scanLocalExtension(M.location,U.ExtensionType.User,this.options.profileLocation);if(!X)throw new t.ExtensionManagementError("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof d.URI&&this.updateMetadata(M,F),X}async unsetIfUninstalled(F){return(await this.extensionsScanner.getUninstalledExtensions())[F.toString()]?(this.logService.trace("Removing the extension from uninstalled list:",F.id),await this.extensionsScanner.setInstalled(F),this.logService.info("Removed the extension from uninstalled list:",F.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(P=>s.ExtensionKey.create(P).equals(F))):void 0}async updateMetadata(F,$){try{let[_]=await this.galleryService.getExtensions([{id:F.identifier.id,version:F.manifest.version}],$);if(_||([_]=await this.galleryService.getExtensions([{id:F.identifier.id}],$)),_){const P={id:_.identifier.uuid,publisherDisplayName:_.publisherDisplayName,publisherId:_.publisherId,isPreReleaseVersion:_.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||_.properties.isPreReleaseVersion,preRelease:_.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(F,P,this.options.profileLocation)}}catch{}}};H=we([se(6,q.IUriIdentityService),se(7,t.IExtensionGalleryService),se(8,Q.IUserDataProfilesService),se(9,u.IExtensionsScannerService),se(10,o.IExtensionsProfileScannerService),se(11,ae.ILogService)],H);class ie extends n.AbstractExtensionTask{constructor(F,$,_){super(),this.extension=F,this.options=$,this.extensionsProfileScannerService=_}async doRun(F){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(ue[139],de([0,1,6,24,23,18,42,9,17,11]),function(J,e,I,b,E,R,A,D,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let h=class extends A.AbstractExtensionsProfileScannerService{constructor(p,f,g,C,w,d){super(a.URI.file(p.extensionsPath),f,g,C,w,d)}};e.ExtensionsProfileScannerService=h,e.ExtensionsProfileScannerService=h=we([se(0,v.INativeEnvironmentService),se(1,D.IFileService),se(2,b.IUserDataProfilesService),se(3,E.IUriIdentityService),se(4,R.ITelemetryService),se(5,I.ILogService)],h)}),define(ue[140],de([0,1,11,17,42,54,9,10,6,33,23,24]),function(J,e,I,b,E,R,A,D,v,a,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends R.NativeExtensionsScannerService{constructor(g,C,w,d,m,O,y,i){super(I.URI.file(m.builtinExtensionsPath),I.URI.file(m.extensionsPath),m.userHome,g.defaultProfile,g,C,w,d,m,O,y,i)}};e.ExtensionsScannerService=p,e.ExtensionsScannerService=p=we([se(0,c.IUserDataProfilesService),se(1,E.IExtensionsProfileScannerService),se(2,A.IFileService),se(3,v.ILogService),se(4,b.INativeEnvironmentService),se(5,a.IProductService),se(6,h.IUriIdentityService),se(7,D.IInstantiationService)],p)}),define(ue[73],de([0,1,8,4,2,108,3,88,10,24]),function(J,e,I,b,E,R,A,D,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=f,e.isProfileUsingDefaultStorage=C,e.logStorage=d,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var h;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(h||(e.WillSaveStateReason=h={}));var c;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(c||(e.StorageScope=c={}));var p;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function f(m){const O=m.get(e.TARGET_KEY);if(O)try{return JSON.parse(O)}catch{}return Object.create(null)}class g extends E.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(O={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super(),this.options=O,this._onDidChangeValue=this._register(new b.PauseableEmitter),this._onDidChangeTarget=this._register(new b.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new b.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new E.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(O,y,i){return b.Event.filter(this._onDidChangeValue.event,l=>l.scope===O&&(y===void 0||l.key===y),i)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,E.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(O,y){const{key:i,external:l}=y;if(i===e.TARGET_KEY){switch(O){case c.APPLICATION:this._applicationKeyTargets=void 0;break;case c.PROFILE:this._profileKeyTargets=void 0;break;case c.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:O})}else this._onDidChangeValue.fire({scope:O,key:i,target:this.getKeyTargets(O)[i],external:l})}emitWillSaveState(O){this._onWillSaveState.fire({reason:O})}get(O,y,i){return this.getStorage(y)?.get(O,i)}getBoolean(O,y,i){return this.getStorage(y)?.getBoolean(O,i)}getNumber(O,y,i){return this.getStorage(y)?.getNumber(O,i)}getObject(O,y,i){return this.getStorage(y)?.getObject(O,i)}storeAll(O,y){this.withPausedEmitters(()=>{for(const i of O)this.store(i.key,i.value,i.scope,i.target,y)})}store(O,y,i,l,r=!1){if((0,A.isUndefinedOrNull)(y)){this.remove(O,i,r);return}this.withPausedEmitters(()=>{this.updateKeyTarget(O,i,l),this.getStorage(i)?.set(O,y,r)})}remove(O,y,i=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(O,y,void 0),this.getStorage(y)?.delete(O,i)})}withPausedEmitters(O){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{O()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(O,y){const i=[],l=this.getKeyTargets(O);for(const r of Object.keys(l))l[r]===y&&i.push(r);return i}updateKeyTarget(O,y,i,l=!1){const r=this.getKeyTargets(y);typeof i=="number"?r[O]!==i&&(r[O]=i,this.getStorage(y)?.set(e.TARGET_KEY,JSON.stringify(r),l)):typeof r[O]=="number"&&(delete r[O],this.getStorage(y)?.set(e.TARGET_KEY,JSON.stringify(r),l))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(c.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(c.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(c.APPLICATION)),this._applicationKeyTargets}getKeyTargets(O){switch(O){case c.APPLICATION:return this.applicationKeyTargets;case c.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(O){const y=this.getStorage(O);return y?f(y):Object.create(null)}isNew(O){return this.getBoolean(e.IS_NEW_KEY,O)===!0}async flush(O=h.NONE){this._onWillSaveState.fire({reason:O});const y=this.getStorage(c.APPLICATION),i=this.getStorage(c.PROFILE),l=this.getStorage(c.WORKSPACE);switch(O){case h.NONE:await I.Promises.settled([y?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case h.SHUTDOWN:await I.Promises.settled([y?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const O=this.getStorage(c.APPLICATION)?.items??new Map,y=this.getStorage(c.PROFILE)?.items??new Map,i=this.getStorage(c.WORKSPACE)?.items??new Map;return d(O,y,i,this.getLogDetails(c.APPLICATION)??"",this.getLogDetails(c.PROFILE)??"",this.getLogDetails(c.WORKSPACE)??"")}async optimize(O){return await this.flush(),this.getStorage(O)?.optimize()}async switch(O,y){return this.emitWillSaveState(h.NONE),(0,a.isUserDataProfile)(O)?this.switchToProfile(O,y):this.switchToWorkspace(O,y)}canSwitchProfile(O,y){return!(O.id===y.id||C(y)&&C(O))}switchData(O,y,i){this.withPausedEmitters(()=>{const l=new Set;for(const[r,n]of O)l.add(r),y.get(r)!==n&&this.emitDidChangeValue(i,{key:r,external:!0});for(const[r]of y.items)l.has(r)||this.emitDidChangeValue(i,{key:r,external:!0})})}}e.AbstractStorageService=g;function C(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class w extends g{constructor(){super(),this.applicationStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(O=>this.emitDidChangeValue(c.WORKSPACE,O))),this._register(this.profileStorage.onDidChangeStorage(O=>this.emitDidChangeValue(c.PROFILE,O))),this._register(this.applicationStorage.onDidChangeStorage(O=>this.emitDidChangeValue(c.APPLICATION,O)))}getStorage(O){switch(O){case c.APPLICATION:return this.applicationStorage;case c.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(O){switch(O){case c.APPLICATION:return"inMemory (application)";case c.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(O){return!1}}e.InMemoryStorageService=w;async function d(m,O,y,i,l,r){const n=k=>{try{return JSON.parse(k)}catch{return k}},t=new Map,s=new Map;m.forEach((k,U)=>{t.set(U,k),s.set(U,n(k))});const o=new Map,u=new Map;O.forEach((k,U)=>{o.set(U,k),u.set(U,n(k))});const S=new Map,T=new Map;y.forEach((k,U)=>{S.set(U,k),T.set(U,n(k))}),console.group(i!==l?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const N=[];if(t.forEach((k,U)=>{N.push({key:U,value:k})}),console.table(N),console.groupEnd(),console.log(s),i!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const k=[];o.forEach((U,G)=>{k.push({key:G,value:U})}),console.table(k),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${r})`);const L=[];S.forEach((k,U)=>{L.push({key:U,value:k})}),console.table(L),console.groupEnd(),console.log(T)}}),define(ue[141],de([0,1,13,28,73]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=R;async function R(A,D,v){let a=v&&v.get("storage.serviceMachineId",E.StorageScope.APPLICATION)||null;if(a)return a;try{const c=(await D.readFile(A.serviceMachineIdResource)).value.toString();a=(0,b.isUUID)(c)?c:null}catch{a=null}if(!a){a=(0,b.generateUuid)();try{await D.writeFile(A.serviceMachineIdResource,I.VSBuffer.fromString(a))}catch{}}return v?.store("storage.serviceMachineId",a,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),a}}),define(ue[142],de([0,1,141,18,41]),function(J,e,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=R;async function R(A,D,v,a,h,c,p){const f={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${D.nameShort})`};if((0,E.supportsTelemetry)(D,v)&&(0,E.getTelemetryLevel)(a)===b.TelemetryLevel.USAGE){const g=await(0,I.getServiceMachineId)(v,h,c);f["X-Market-User-Id"]=g,f["VSCode-SessionId"]=p.machineId||g}return f}}),define(ue[143],de([0,1,19,21,7,12,36,3,11,30,17,20,26,22,44,9,6,33,46,142,73,18,155]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d,m,O,y,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=F;const r=R.isWeb?f.TargetPlatform.WEB:(0,c.getTargetPlatform)(R.platform,A.arch),n="X-Market-Search-Activity-Id";var t;(function(x){x[x.None=0]="None",x[x.IncludeVersions=1]="IncludeVersions",x[x.IncludeFiles=2]="IncludeFiles",x[x.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",x[x.IncludeSharedAccounts=8]="IncludeSharedAccounts",x[x.IncludeVersionProperties=16]="IncludeVersionProperties",x[x.ExcludeNonValidated=32]="ExcludeNonValidated",x[x.IncludeInstallationTargets=64]="IncludeInstallationTargets",x[x.IncludeAssetUri=128]="IncludeAssetUri",x[x.IncludeStatistics=256]="IncludeStatistics",x[x.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",x[x.Unpublished=4096]="Unpublished",x[x.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function s(...x){return String(x.reduce((W,B)=>W|B,0))}var o;(function(x){x[x.Tag=1]="Tag",x[x.ExtensionId=4]="ExtensionId",x[x.Category=5]="Category",x[x.ExtensionName=7]="ExtensionName",x[x.Target=8]="Target",x[x.Featured=9]="Featured",x[x.SearchText=10]="SearchText",x[x.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},S={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},N={pageNumber:1,pageSize:10,sortBy:c.SortBy.NoneOrRelevance,sortOrder:c.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class L{constructor(W=N){this.state=W}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(W,B=this.state.pageSize){return new L({...this.state,pageNumber:W,pageSize:B})}withFilter(W,...B){const re=[...this.state.criteria,...B.length?B.map(oe=>({filterType:W,value:oe})):[{filterType:W}]];return new L({...this.state,criteria:re})}withSortBy(W){return new L({...this.state,sortBy:W})}withSortOrder(W){return new L({...this.state,sortOrder:W})}withFlags(...W){return new L({...this.state,flags:W.reduce((B,re)=>B|re,0)})}withAssetTypes(...W){return new L({...this.state,assetTypes:W})}withSource(W){return new L({...this.state,source:W})}get raw(){const{criteria:W,pageNumber:B,pageSize:re,sortBy:oe,sortOrder:le,flags:ye,assetTypes:he}=this.state;return{filters:[{criteria:W,pageNumber:B,pageSize:re,sortBy:oe,sortOrder:le}],assetTypes:he,flags:ye}}get searchText(){const W=this.state.criteria.filter(B=>B.filterType===o.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(W=>String(W.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function k(x,W){const B=(x||[]).filter(re=>re.statisticName===W)[0];return B?B.value:0}function U(x){const W="Microsoft.VisualStudio.Code.Translation.";return x.files.filter(re=>re.assetType.indexOf(W)===0).reduce((re,oe)=>{const le=te(x,oe.assetType);return le&&re.push([oe.assetType.substring(W.length),le]),re},[])}function G(x){if(x.properties){const W=x.properties.filter(oe=>oe.key===u.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=W.filter(oe=>B.test(oe.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return te(x,u.Repository)}function Y(x){return{uri:`${x.fallbackAssetUri}/${u.VSIX}?redirect=true${x.targetPlatform?`&targetPlatform=${x.targetPlatform}`:""}`,fallbackUri:`${x.fallbackAssetUri}/${u.VSIX}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`}}function te(x,W){return x.files.filter(re=>re.assetType===W)[0]?{uri:`${x.assetUri}/${W}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`,fallbackUri:`${x.fallbackAssetUri}/${W}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`}:null}function ae(x,W){const B=x.properties?x.properties.filter(oe=>oe.key===W):[],re=B.length>0&&B[0].value;return re?re.split(",").map(oe=>(0,p.adoptToGalleryExtensionId)(oe)):[]}function ce(x){const W=x.properties?x.properties.filter(B=>B.key===S.Engine):[];return W.length>0&&W[0].value||""}function fe(x){const W=x.properties?x.properties.filter(B=>B.key===S.PreRelease):[];return W.length>0&&W[0].value==="true"}function q(x){const W=x.properties?x.properties.filter(B=>B.key===S.ExecutesCode):[];return W.length>0?W[0].value==="true":void 0}function Q(x){const W=x.properties?x.properties.filter(re=>re.key===S.EnabledApiProposals):[],B=W.length>0&&W[0].value||"";return B?B.split(","):[]}function z(x){const W=x.properties?x.properties.filter(re=>re.key===S.LocalizedLanguages):[],B=W.length>0&&W[0].value||"";return B?B.split(","):[]}function V(x){return x.properties?.find(W=>W.key===S.SponsorLink)?.value}function K(x){return x.properties?.find(W=>W.key===S.SupportLink)?.value}function H(x){return x.indexOf("preview")!==-1}function ie(x){return x.targetPlatform?(0,c.toTargetPlatform)(x.targetPlatform):f.TargetPlatform.UNDEFINED}function ne(x){const W=(0,I.distinct)(x.versions.map(ie)),B=!!x.tags?.includes(c.WEB_EXTENSION_TAG),re=W.indexOf(f.TargetPlatform.WEB);return B?re===-1&&W.push(f.TargetPlatform.WEB):re!==-1&&W.splice(re,1),W}function F(x,W){for(let B=0;B<x.length;B++){const re=x[B];if(re.version===x[B-1]?.version){let oe=B;if(ie(re)===W)for(;oe>0&&x[oe-1].version===re.version;)oe--;oe!==B&&(x.splice(B,1),x.splice(oe,0,re))}}return x}function $(x,W,B){x.telemetryData={index:W,querySource:B,queryActivityId:x.queryContext?.[n]}}function _(x,W,B,re){const oe=x.versions[0],le={manifest:te(W,u.Manifest),readme:te(W,u.Details),changelog:te(W,u.Changelog),license:te(W,u.License),repository:G(W),download:Y(W),icon:te(W,u.Icon),signature:te(W,u.Signature),coreTranslations:U(W)};return{type:"gallery",identifier:{id:(0,p.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},name:x.extensionName,version:W.version,displayName:x.displayName,publisherId:x.publisher.publisherId,publisher:x.publisher.publisherName,publisherDisplayName:x.publisher.displayName,publisherDomain:x.publisher.domain?{link:x.publisher.domain,verified:!!x.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(oe),description:x.shortDescription??"",installCount:k(x.statistics,"install"),rating:k(x.statistics,"averagerating"),ratingCount:k(x.statistics,"ratingcount"),categories:x.categories||[],tags:x.tags||[],releaseDate:Date.parse(x.releaseDate),lastUpdated:Date.parse(x.lastUpdated),allTargetPlatforms:B,assets:le,properties:{dependencies:ae(W,S.Dependency),extensionPack:ae(W,S.ExtensionPack),engine:ce(W),enabledApiProposals:Q(W),localizedLanguages:z(W),targetPlatform:ie(W),isPreReleaseVersion:fe(W),executesCode:q(W)},hasPreReleaseVersion:fe(oe),hasReleaseVersion:!0,preview:H(x.flags),isSigned:!!le.signature,queryContext:re,supportLink:K(oe)}}let P=class{constructor(W,B,re,oe,le,ye,he,ve){this.requestService=B,this.logService=re,this.environmentService=oe,this.telemetryService=le,this.fileService=ye,this.productService=he,this.configurationService=ve;const ge=he.extensionsGallery,pe=ge?.servicePPEUrl&&ve.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=pe?ge.servicePPEUrl:ge?.serviceUrl,this.extensionsGallerySearchUrl=pe?void 0:ge?.searchUrl,this.extensionsControlUrl=ge?.controlUrl,this.extensionsEnabledWithApiProposalVersion=he.extensionsEnabledWithApiProposalVersion?.map(me=>me.toLowerCase())??[],this.commonHeadersPromise=(0,O.resolveMarketplaceHeaders)(he.version,he,this.environmentService,this.configurationService,this.fileService,W,this.telemetryService)}api(W=""){return`${this.extensionsGalleryUrl}${W}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(W,B,re){const oe=b.CancellationToken.isCancellationToken(B)?{}:B,le=b.CancellationToken.isCancellationToken(B)?B:re,ye=[],he=[],ve=[],ge=[];let pe=!0;for(const j of W){j.uuid?he.push(j.uuid):ye.push(j.id);const Z=!!(j.version||j.preRelease);ve.push({id:j.id,uuid:j.uuid,includePreRelease:Z}),j.version&&ge.push({id:j.id,uuid:j.uuid,version:j.version}),pe=pe&&!!j.hasPreRelease&&!Z}if(!he.length&&!ye.length)return[];let me=new L().withPage(1,W.length);he.length&&(me=me.withFilter(o.ExtensionId,...he)),ye.length&&(me=me.withFilter(o.ExtensionName,...ye)),(oe.queryAllVersions||pe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),oe.source&&(me=me.withSource(oe.source));const{extensions:Pe}=await this.queryGalleryExtensions(me,{targetPlatform:oe.targetPlatform??r,includePreRelease:ve,versions:ge,compatible:!!oe.compatible,productVersion:oe.productVersion??{version:this.productService.version,date:this.productService.date}},le);return oe.source&&Pe.forEach((j,Z)=>$(j,Z,oe.source)),Pe}async getCompatibleExtension(W,B,re,oe={version:this.productService.version,date:this.productService.date}){if((0,c.isNotWebExtensionInWebTargetPlatform)(W.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(W,B,re))return W;const le=new L().withFlags(t.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,W.identifier.uuid),{extensions:ye}=await this.queryGalleryExtensions(le,{targetPlatform:re,compatible:!0,includePreRelease:B,productVersion:oe},b.CancellationToken.None);return ye[0]||null}async isExtensionCompatible(W,B,re,oe={version:this.productService.version,date:this.productService.date}){if(!(0,c.isTargetPlatformCompatible)(W.properties.targetPlatform,W.allTargetPlatforms,re)||!B&&W.properties.isPreReleaseVersion)return!1;let le=W.properties.engine;if(!le){const ye=await this.getManifest(W,b.CancellationToken.None);if(!ye)throw new Error("Manifest was not found");le=ye.engines.vscode}return!(!(0,g.isEngineValid)(le,oe.version,oe.date)||!this.areApiProposalsCompatible(W.identifier,W.properties.enabledApiProposals))}areApiProposalsCompatible(W,B){return!B||!this.extensionsEnabledWithApiProposalVersion.includes(W.id.toLowerCase())?!0:(0,g.areApiProposalsCompatible)(B)}async isValidVersion(W,B,re,oe,le,ye,he={version:this.productService.version,date:this.productService.date}){if(!(0,c.isTargetPlatformCompatible)(ie(B),le,ye)||re!=="any"&&fe(B)!==(re==="prerelease"))return!1;if(oe)try{const ve=await this.getEngine(W,B);if(!(0,g.isEngineValid)(ve,he.version,he.date))return!1}catch(ve){return this.logService.error(`Error while getting the engine for the version ${B.version}.`,(0,E.getErrorMessage)(ve)),!1}return!0}async query(W,B){let re=W.text||"";const oe=W.pageSize??50;let le=new L().withPage(1,oe);re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,me,Pe)=>(le=le.withFilter(o.Category,Pe||me),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,me,Pe)=>(le=le.withFilter(o.Tag,Pe||me),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(le=le.withFilter(o.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),le=le.withFilter(o.SearchText,re)),le=le.withSortBy(c.SortBy.NoneOrRelevance)):W.ids?le=le.withFilter(o.ExtensionId,...W.ids):W.names?le=le.withFilter(o.ExtensionName,...W.names):le=le.withSortBy(c.SortBy.InstallCount),typeof W.sortBy=="number"&&(le=le.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(le=le.withSortOrder(W.sortOrder)),W.source&&(le=le.withSource(W.source));const ye=async(pe,me)=>{const{extensions:Pe,total:j}=await this.queryGalleryExtensions(pe,{targetPlatform:r,compatible:!1,includePreRelease:!!W.includePreRelease,productVersion:W.productVersion??{version:this.productService.version,date:this.productService.date}},me);return Pe.forEach((Z,ee)=>$(Z,(pe.pageNumber-1)*pe.pageSize+ee,W.source)),{extensions:Pe,total:j}},{extensions:he,total:ve}=await ye(le,B),ge=async(pe,me)=>{if(me.isCancellationRequested)throw new E.CancellationError;const{extensions:Pe}=await ye(le.withPage(pe+1),me);return Pe};return{firstPage:he,total:ve,pageSize:le.pageSize,getPage:ge}}async queryGalleryExtensions(W,B,re){const oe=W.flags;W.flags&t.IncludeLatestVersionOnly&&W.flags&t.IncludeVersions&&(W=W.withFlags(W.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(W.flags&t.IncludeLatestVersionOnly)&&!(W.flags&t.IncludeVersions)&&(W=W.withFlags(W.flags,t.IncludeLatestVersionOnly)),B.versions?.length&&(W=W.withFlags(W.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),W=W.withFlags(W.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:le,total:ye,context:he}=await this.queryRawGalleryExtensions(W,re);if(!(W.flags&t.IncludeLatestVersionOnly)){const me=[];for(const Pe of le){const j=await this.toGalleryExtensionWithCriteria(Pe,B,he);j&&me.push(j)}return{extensions:me,total:ye}}const ge=[],pe=new Map;for(let me=0;me<le.length;me++){const Pe=le[me],j={id:(0,p.getGalleryExtensionId)(Pe.publisher.publisherName,Pe.extensionName),uuid:Pe.extensionId},Z=(0,D.isBoolean)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(Se=>(0,p.areSameExtensions)(Se,j))?.includePreRelease;if(B.compatible&&(0,c.isNotWebExtensionInWebTargetPlatform)(ne(Pe),B.targetPlatform))continue;const ee=await this.toGalleryExtensionWithCriteria(Pe,B,he);!ee||ee.properties.isPreReleaseVersion&&(!Z||!ee.hasReleaseVersion)||!ee.properties.isPreReleaseVersion&&ee.properties.targetPlatform!==B.targetPlatform&&ee.hasPreReleaseVersion?pe.set(Pe.extensionId,me):ge.push([me,ee])}if(pe.size){const me=new l.StopWatch,Pe=new L().withFlags(oe&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,pe.size).withFilter(o.ExtensionId,...pe.keys()),{extensions:j}=await this.queryGalleryExtensions(Pe,B,re);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:pe.size});for(const Z of j){const ee=pe.get(Z.identifier.uuid);ge.push([ee,Z])}}return{extensions:ge.sort((me,Pe)=>me[0]-Pe[0]).map(([,me])=>me),total:ye}}async toGalleryExtensionWithCriteria(W,B,re){const oe={id:(0,p.getGalleryExtensionId)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},le=B.versions?.find(ge=>(0,p.areSameExtensions)(ge,oe))?.version,ye=(0,D.isBoolean)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(ge=>(0,p.areSameExtensions)(ge,oe))?.includePreRelease,he=ne(W),ve=F(W.versions,B.targetPlatform);if(B.compatible&&(0,c.isNotWebExtensionInWebTargetPlatform)(he,B.targetPlatform))return null;for(let ge=0;ge<ve.length;ge++){const pe=ve[ge];if(!(le&&pe.version!==le)){if(await this.isValidVersion(oe.id,pe,ye?"any":"release",B.compatible,he,B.targetPlatform,B.productVersion))return B.compatible&&!this.areApiProposalsCompatible(oe,Q(pe))?null:_(W,pe,he,re);if(le&&pe.version===le)return null}}return le||B.compatible?null:_(W,W.versions[0],he)}async queryRawGalleryExtensions(W,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,t.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,s(t.Unpublished));const re=await this.commonHeadersPromise,oe=JSON.stringify(W.raw),le={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(oe.length)},ye=new l.StopWatch;let he,ve,ge=0;try{if(he=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&W.criteria.some(me=>me.filterType===o.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:oe,headers:le},B),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:ge};const pe=await(0,m.asJson)(he);if(pe){const me=pe.results[0],Pe=me.extensions,j=me.resultMetadata&&me.resultMetadata.filter(Z=>Z.metadataType==="ResultCount")[0];return ge=j&&j.metadataItems.filter(Z=>Z.name==="TotalCount")[0].count||0,{galleryExtensions:Pe,total:ge,context:he.res.headers.activityid?{[n]:he.res.headers.activityid}:{}}}return{galleryExtensions:[],total:ge}}catch(pe){if((0,E.isCancellationError)(pe))throw ve=c.ExtensionGalleryErrorCode.Cancelled,pe;{const me=(0,E.getErrorMessage)(pe);throw ve=me.startsWith("XHR timeout")?c.ExtensionGalleryErrorCode.Timeout:c.ExtensionGalleryErrorCode.Failed,new c.ExtensionGalleryError(me,ve)}}finally{this.telemetryService.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(oe.length),duration:ye.elapsed(),success:!!he&&(0,m.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:ve,count:String(ge)})}}async reportStatistic(W,B,re,oe){if(!this.isEnabled())return;const le=R.isWeb?this.api(`/itemName/${W}.${B}/version/${re}/statType/${oe===c.StatisticType.Install?"1":"3"}/vscodewebextension`):this.api(`/publishers/${W}/extensions/${B}/${re}/stats?statType=${oe}`),ye=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ve={...await this.commonHeadersPromise,Accept:ye};try{await this.requestService.request({type:"POST",url:le,headers:ve},b.CancellationToken.None)}catch{}}async download(W,B,re){this.logService.trace("ExtensionGalleryService#download",W.identifier.id);const oe=(0,p.getGalleryExtensionTelemetryData)(W),le=new Date().getTime(),ye=re===c.InstallOperation.Install?"install":re===c.InstallOperation.Update?"update":"",he=ye?{uri:`${W.assets.download.uri}${v.URI.parse(W.assets.download.uri).query?"&":"?"}${ye}=true`,fallbackUri:`${W.assets.download.fallbackUri}${v.URI.parse(W.assets.download.fallbackUri).query?"&":"?"}${ye}=true`}:W.assets.download,ve=W.queryContext?.[n]?{[n]:W.queryContext[n]}:void 0,ge=await this.getAsset(W.identifier.id,he,u.VSIX,ve?{headers:ve}:void 0);try{await this.fileService.writeFile(B,ge.stream)}catch(pe){try{await this.fileService.del(B)}catch(me){this.logService.warn(`Error while deleting the file ${B.toString()}`,(0,E.getErrorMessage)(me))}throw new c.ExtensionGalleryError((0,E.getErrorMessage)(pe),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.telemetryService.publicLog("galleryService:downloadVSIX",{...oe,duration:new Date().getTime()-le})}async downloadSignatureArchive(W,B){if(!W.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",W.identifier.id);const re=await this.getAsset(W.identifier.id,W.assets.signature,u.Signature);try{await this.fileService.writeFile(B,re.stream)}catch(oe){try{await this.fileService.del(B)}catch(le){this.logService.warn(`Error while deleting the file ${B.toString()}`,(0,E.getErrorMessage)(le))}throw new c.ExtensionGalleryError((0,E.getErrorMessage)(oe),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(W,B){if(W.assets.readme){const re=await this.getAsset(W.identifier.id,W.assets.readme,u.Details,{},B);return await(0,m.asTextOrError)(re)||""}return""}async getManifest(W,B){if(W.assets.manifest){const re=await this.getAsset(W.identifier.id,W.assets.manifest,u.Manifest,{},B),oe=await(0,m.asTextOrError)(re);return oe?JSON.parse(oe):null}return null}async getManifestFromRawExtensionVersion(W,B,re){const oe=te(B,u.Manifest);if(!oe)throw new Error("Manifest was not found");const le={"Accept-Encoding":"gzip"},ye=await this.getAsset(W,oe,u.Manifest,{headers:le});return await(0,m.asJson)(ye)}async getCoreTranslation(W,B){const re=W.assets.coreTranslations.filter(oe=>oe[0]===B.toUpperCase())[0];if(re){const oe=await this.getAsset(W.identifier.id,re[1],re[0]),le=await(0,m.asTextOrError)(oe);return le?JSON.parse(le):null}return null}async getChangelog(W,B){if(W.assets.changelog){const re=await this.getAsset(W.identifier.id,W.assets.changelog,u.Changelog,{},B);return await(0,m.asTextOrError)(re)||""}return""}async getAllCompatibleVersions(W,B,re){let oe=new L().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);W.uuid?oe=oe.withFilter(o.ExtensionId,W.uuid):oe=oe.withFilter(o.ExtensionName,W.id);const{galleryExtensions:le}=await this.queryRawGalleryExtensions(oe,b.CancellationToken.None);if(!le.length)return[];const ye=ne(le[0]);if((0,c.isNotWebExtensionInWebTargetPlatform)(ye,re))return[];const he=[];await Promise.all(le[0].versions.map(async pe=>{try{await this.isValidVersion(W.id,pe,B?"any":"release",!0,ye,re)&&this.areApiProposalsCompatible(W,Q(pe))&&he.push(pe)}catch{}}));const ve=[],ge=new Set;for(const pe of F(he,re))ge.has(pe.version)||(ge.add(pe.version),ve.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:fe(pe)}));return ve}async getAsset(W,B,re,oe={},le=b.CancellationToken.None){const ye=await this.commonHeadersPromise,he={type:"GET"},ve={...ye,...oe.headers||{}};oe={...oe,...he,headers:ve};const ge=B.uri,pe=B.fallbackUri,me={...oe,url:ge};try{const Pe=await this.requestService.request(me,le);if(Pe.res.statusCode===200)return Pe;const j=await(0,m.asTextOrError)(Pe);throw new Error(`Expected 200, got back ${Pe.res.statusCode} instead.

${j}`)}catch(Pe){if((0,E.isCancellationError)(Pe))throw Pe;const j=(0,E.getErrorMessage)(Pe);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:W,assetType:re,message:j});const Z={...oe,url:pe};return this.requestService.request(Z,le)}}async getEngine(W,B){let re=ce(B);if(!re){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:W,version:B.version});const oe=await this.getManifestFromRawExtensionVersion(W,B,b.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");re=oe.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const W=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},b.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,m.asJson)(W),re=[],oe={},le=[],ye=[];if(B){for(const he of B.malicious)re.push({id:he});if(B.migrateToPreRelease)for(const[he,ve]of Object.entries(B.migrateToPreRelease))(!ve.engine||(0,g.isEngineValid)(ve.engine,this.productService.version,this.productService.date))&&(oe[he.toLowerCase()]={disallowInstall:!0,extension:{id:ve.id,displayName:ve.displayName,autoMigrate:{storage:!!ve.migrateStorage},preRelease:!0}});if(B.deprecated)for(const[he,ve]of Object.entries(B.deprecated))ve&&(oe[he.toLowerCase()]=(0,D.isBoolean)(ve)?{}:ve);if(B.search)for(const he of B.search)le.push(he);if(Array.isArray(B.extensionsEnabledWithPreRelease))for(const he of B.extensionsEnabledWithPreRelease)ye.push(he.toLowerCase())}return{malicious:re,deprecated:oe,search:le,extensionsEnabledWithPreRelease:ye}}};P=we([se(1,m.IRequestService),se(2,w.ILogService),se(3,h.IEnvironmentService),se(4,i.ITelemetryService),se(5,C.IFileService),se(6,d.IProductService),se(7,a.IConfigurationService)],P);let M=class extends P{constructor(W,B,re,oe,le,ye,he,ve){super(W,B,re,oe,le,ye,he,ve)}};e.ExtensionGalleryService=M,e.ExtensionGalleryService=M=we([se(0,y.IStorageService),se(1,m.IRequestService),se(2,w.ILogService),se(3,h.IEnvironmentService),se(4,i.ITelemetryService),se(5,C.IFileService),se(6,d.IProductService),se(7,a.IConfigurationService)],M);let X=class extends P{constructor(W,B,re,oe,le,ye,he){super(void 0,W,B,re,oe,le,ye,he)}};e.ExtensionGalleryServiceWithNoStorageService=X,e.ExtensionGalleryServiceWithNoStorageService=X=we([se(0,m.IRequestService),se(1,w.ILogService),se(2,h.IEnvironmentService),se(3,i.ITelemetryService),se(4,C.IFileService),se(5,d.IProductService),se(6,a.IConfigurationService)],X)}),define(ue[144],de([0,1,11,17,9,6,123,23,24,3,69]),function(J,e,I,b,E,R,A,D,v,a,h){"use strict";var c,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let f=class extends v.UserDataProfilesService{static{c=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(d,m,O,y,i){super(O,y,m,i),this.stateReadonlyService=d,this.nativeEnvironmentService=O}getStoredProfiles(){return this.stateReadonlyService.getItem(c.PROFILES_KEY,[]).map(m=>({...m,location:(0,a.isString)(m.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,m.location):I.URI.revive(m.location)}))}getStoredProfileAssociations(){const d=this.stateReadonlyService.getItem(c.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(c.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?d:this.migrateStoredProfileAssociations(d)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(I.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=f,e.UserDataProfilesReadonlyService=f=c=we([se(0,A.IStateReadService),se(1,D.IUriIdentityService),se(2,b.INativeEnvironmentService),se(3,E.IFileService),se(4,R.ILogService)],f);let g=p=class extends f{constructor(d,m,O,y,i){super(d,m,O,y,i),this.stateService=d}saveStoredProfiles(d){d.length?this.stateService.setItem(p.PROFILES_KEY,d.map(m=>({...m,location:this.uriIdentityService.extUri.basename(m.location)}))):this.stateService.removeItem(p.PROFILES_KEY)}getStoredProfiles(){const d=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(d),this.stateService.setItem("userDataProfilesMigration",!0)),d}saveStoredProfileAssociations(d){d.emptyWindows||d.workspaces?this.stateService.setItem(p.PROFILE_ASSOCIATIONS_KEY,d):this.stateService.removeItem(p.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const d="workspaceAndProfileInfo",m=this.stateService.getItem(d,void 0);if(m){this.stateService.removeItem(d);const y=m.reduce((i,{workspace:l,profile:r})=>(i[I.URI.revive(l).toString()]=I.URI.revive(r).toString(),i),{});this.stateService.setItem(p.PROFILE_ASSOCIATIONS_KEY,{workspaces:y})}const O=super.getStoredProfileAssociations();return this.stateService.getItem(p.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(O),this.stateService.setItem(p.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),O}};e.UserDataProfilesService=g,e.UserDataProfilesService=g=p=we([se(0,A.IStateService),se(1,D.IUriIdentityService),se(2,b.INativeEnvironmentService),se(3,E.IFileService),se(4,R.ILogService)],g);let C=class extends g{constructor(d,m,O,y){super(new h.StateService(h.SaveStrategy.IMMEDIATE,m,y,O),d,m,O,y)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=C,e.ServerUserDataProfilesService=C=we([se(0,D.IUriIdentityService),se(1,b.INativeEnvironmentService),se(2,E.IFileService),se(3,R.ILogService)],C)}),define(ue[145],de([0,1,121,8,13,7,3,30,17,122,6,46,120,156]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=w;let g=class extends c.AbstractRequestService{constructor(m,O,y,i){super(i),this.configurationService=m,this.environmentService=O,this.logService=y,this.configure(),this._register(m.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.configure()}))}configure(){const m=this.configurationService.getValue("http");this.proxyUrl=m?.proxy,this.strictSSL=!!m?.proxyStrictSSL,this.authorization=m?.proxyAuthorization}async request(m,O){const{proxyUrl:y,strictSSL:i}=this;let l;try{l=await(0,a.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(t){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,R.getErrorMessage)(t)))}const r={...process.env,...l},n=m.agent?m.agent:await(0,p.getProxyAgent)(m.url||"",r,{proxyUrl:y,strictSSL:i});return m.agent=n,m.strictSSL=i,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(m.isChromiumNetwork?"electron":"node",m,()=>w(m,O))}async resolveProxy(m){}async lookupAuthorization(m){}async lookupKerberosAuthorization(m){try{const O=await new Promise((n,t)=>{J(["kerberos"],n,t)}).then(Ee),y=new URL(m),i=this.configurationService.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${y.hostname}`:`HTTP@${y.hostname}`);return this.logService.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${y}`,`spn:${i}`),"Negotiate "+await(await O.initializeClient(i)).step("")}catch(O){this.logService.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",O);return}}async loadCertificates(){return(await new Promise((O,y)=>{J(["@vscode/proxy-agent"],O,y)}).then(Ee)).loadSystemCertificates({log:this.logService})}};e.RequestService=g,e.RequestService=g=we([se(0,D.IConfigurationService),se(1,v.INativeEnvironmentService),se(2,h.ILogService),se(3,h.ILoggerService)],g);async function C(d){return((0,I.parse)(d.url).protocol==="https:"?await new Promise((y,i)=>{J(["https"],y,i)}).then(Ee):await new Promise((y,i)=>{J(["http"],y,i)}).then(Ee)).request}async function w(d,m){return b.Promises.withAsyncBody(async(O,y)=>{const i=(0,I.parse)(d.url),l=d.getRawRequest?d.getRawRequest(d):await C(d),r={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,A.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(r.auth=d.user+":"+d.password);const n=l(r,t=>{const s=(0,A.isNumber)(d.followRedirects)?d.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&s>0&&t.headers.location)w({...d,url:t.headers.location,followRedirects:s-1},m).then(O,y);else{let o=t;!d.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,f.createGunzip)())),O({res:t,stream:(0,E.streamToBufferReadableStream)(o)})}});n.on("error",y),d.timeout&&n.setTimeout(d.timeout),d.isChromiumNetwork&&n.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&n.write(d.data),n.end(),m.onCancellationRequested(()=>{n.abort(),y(new R.CancellationError)})})}});var Ve=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(ue[157],de([0,1,32,35,8,38,7,2,14,15,12,36,11,30,117,61,119,17,95,143,20,71,124,42,54,138,140,9,107,109,51,105,64,68,126,6,113,39,114,129,33,46,145,69,70,18,128,41,130,131,23,133,24,144,132,139,110,112,5,134,158]),function(J,e,I,b,E,R,A,D,v,a,h,c,p,f,g,C,w,d,m,O,y,i,l,r,n,t,s,o,u,S,T,N,L,k,U,G,Y,te,ae,ce,fe,q,Q,z,V,K,H,ie,ne,F,$,_,P,M,X,x,W,B,re,oe,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=he,I=Ee(I),ce=Ve(ce);class ye extends D.Disposable{constructor(ge){super(),this.argv=ge,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ge,pe]=await this.initServices();return ge.invokeFunction(async me=>{const Pe=me.get(G.ILogService),j=me.get(o.IFileService),Z=me.get(d.INativeEnvironmentService),ee=me.get(P.IUserDataProfilesService);Pe.info("CLI main",this.argv),this.registerErrorHandler(Pe),await this.doRun(Z,j,ee,ge),await Promise.all(pe.map(Se=>{(0,E.raceTimeout)(Se.flush(),1e3)}))})}async initServices(){const ge=new L.ServiceCollection,pe={_serviceBrand:void 0,...ce.default};ge.set(fe.IProductService,pe);const me=new m.NativeEnvironmentService(this.argv,pe);ge.set(d.INativeEnvironmentService,me),await Promise.all([this.allowWindowsUNCPath(me.appSettingsHome.with({scheme:v.Schemas.file}).fsPath),this.allowWindowsUNCPath(me.extensionsPath)].map(Ce=>Ce?I.promises.mkdir(Ce,{recursive:!0}):void 0));const Pe=new B.LoggerService((0,G.getLogLevel)(me),me.logsHome);ge.set(G.ILoggerService,Pe);const j=this._register(Pe.createLogger("cli",{name:(0,re.localize)(12932,null)})),Z=[];Pe.getLogLevel()===G.LogLevel.Trace&&Z.push(new G.ConsoleLogger(Pe.getLogLevel()));const ee=this._register(new W.LogService(j,Z));ge.set(G.ILogService,ee);const Se=this._register(new u.FileService(ee));ge.set(o.IFileService,Se);const Ie=this._register(new S.DiskFileSystemProvider(ee));Se.registerProvider(v.Schemas.file,Ie);const ke=new _.UriIdentityService(Se);ge.set($.IUriIdentityService,ke);const Re=new z.StateReadonlyService(z.SaveStrategy.DELAYED,me,ee,Se),Ne=new M.UserDataProfilesReadonlyService(Re,ke,me,Se,ee);ge.set(P.IUserDataProfilesService,Ne),Se.registerProvider(v.Schemas.vscodeUserData,new oe.FileUserDataProvider(v.Schemas.file,Ie,v.Schemas.vscodeUserData,Ne,ke,ee));const Oe=h.isWindows&&pe.win32RegValueName?this._register(new ae.NativePolicyService(ee,pe.win32RegValueName)):me.policyFile?this._register(new Y.FilePolicyService(me.policyFile,Se,ee)):new te.NullPolicyService;ge.set(te.IPolicyService,Oe);const Ae=this._register(new g.ConfigurationService(Ne.defaultProfile.settingsResource,Se,Oe,ee));ge.set(f.IConfigurationService,Ae),await Promise.all([Re.init(),Ae.initialize()]);let We;try{We=await(0,X.resolveMachineId)(Re,ee)}catch(Ce){Ce.code!=="ENOENT"&&ee.error(Ce)}const Le=await(0,X.resolveSqmId)(Re,ee),Fe=await(0,X.resolvedevDeviceId)(Re,ee);Ne.init(),ge.set($.IUriIdentityService,new _.UriIdentityService(Se));const xe=new Q.RequestService(Ae,me,ee,Pe);ge.set(q.IRequestService,xe),ge.set(C.IDownloadService,new T.SyncDescriptor(w.DownloadService,void 0,!0)),ge.set(r.IExtensionsProfileScannerService,new T.SyncDescriptor(x.ExtensionsProfileScannerService,void 0,!0)),ge.set(n.IExtensionsScannerService,new T.SyncDescriptor(s.ExtensionsScannerService,void 0,!0)),ge.set(i.IExtensionSignatureVerificationService,new T.SyncDescriptor(i.ExtensionSignatureVerificationService,void 0,!0)),ge.set(t.INativeServerExtensionManagementService,new T.SyncDescriptor(t.ExtensionManagementService,void 0,!0)),ge.set(y.IExtensionGalleryService,new T.SyncDescriptor(O.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),ge.set(k.ILanguagePackService,new T.SyncDescriptor(U.NativeLanguagePackService,void 0,!1));const Ue=[],be=(0,ie.isInternalTelemetry)(pe,Ae);if((0,ie.supportsTelemetry)(pe,me)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ue.push(new ne.OneDataSystemAppender(xe,be,"monacoworkbench",null,pe.aiConfig.ariaKey));const Ce={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,V.resolveCommonProperties)((0,b.release)(),(0,b.hostname)(),process.arch,pe.commit,pe.version,We,Le,Fe,be),piiPaths:(0,ie.getPiiPathsFromEnvironment)(me)};ge.set(K.ITelemetryService,new T.SyncDescriptor(H.TelemetryService,[Ce],!1))}else ge.set(K.ITelemetryService,ie.NullTelemetryService);return[new N.InstantiationService(ge),Ue]}allowWindowsUNCPath(ge){if(h.isWindows){const pe=(0,le.getUNCHost)(ge);pe&&(0,le.addUNCHostToAllowlist)(pe)}return ge}registerErrorHandler(ge){(0,A.setUnexpectedErrorHandler)(pe=>{const me=(0,R.toErrorMessage)(pe,!0);me&&ge.error(`[uncaught exception in CLI]: ${me}`)}),process.on("uncaughtException",pe=>{(0,A.isSigPipeError)(pe)||(0,A.onUnexpectedError)(pe)}),process.on("unhandledRejection",pe=>(0,A.onUnexpectedError)(pe))}async doRun(ge,pe,me,Pe){let j;if(ge.args.profile&&(j=me.profiles.find(ee=>ee.name===ge.args.profile),!j))throw new Error(`Profile '${ge.args.profile}' not found.`);const Z=(j??me.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return Pe.createInstance(l.ExtensionManagementCLI,new G.ConsoleLogger(G.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,Z);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ee={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:Z};return Pe.createInstance(l.ExtensionManagementCLI,new G.ConsoleLogger(G.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),ee,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return Pe.createInstance(l.ExtensionManagementCLI,new G.ConsoleLogger(G.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,Z);if(this.argv["update-extensions"])return Pe.createInstance(l.ExtensionManagementCLI,new G.ConsoleLogger(G.LogLevel.Info,!1)).updateExtensions(Z);if(this.argv["locate-extension"])return Pe.createInstance(l.ExtensionManagementCLI,new G.ConsoleLogger(G.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,F.buildTelemetryMessage)(ge.appRoot,ge.extensionsPath))}}asExtensionIdOrVSIX(ge){return ge.map(pe=>/\.vsix$/i.test(pe)?p.URI.file((0,a.isAbsolute)(pe)?pe:(0,a.join)((0,c.cwd)(),pe)):pe)}}async function he(ve){const ge=new ye(ve);try{await ge.run()}finally{ge.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/code/node/cliProcessMain.js.map
