/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ue=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/map","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","vs/base/common/marshalling","net","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/jsonSchema","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/node/processes","vs/base/node/ps","vs/base/parts/sandbox/node/electronTypes","vs/base/parts/ipc/node/ipc.mp","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(ae){for(var e=[],P=0,a=ae.length;P<a;P++)e[P]=ue[ae[P]];return e};define(ue[128],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.isESM=void 0,e.isESM=!1;var P;(function(_){_[_.LoaderAvailable=1]="LoaderAvailable",_[_.BeginLoadingScript=10]="BeginLoadingScript",_[_.EndLoadingScriptOK=11]="EndLoadingScriptOK",_[_.EndLoadingScriptError=12]="EndLoadingScriptError",_[_.BeginInvokeFactory=21]="BeginInvokeFactory",_[_.EndInvokeFactory=22]="EndInvokeFactory",_[_.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",_[_.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",_[_.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",_[_.NodeEndNativeRequire=34]="NodeEndNativeRequire",_[_.CachedDataFound=60]="CachedDataFound",_[_.CachedDataMissed=61]="CachedDataMissed",_[_.CachedDataRejected=62]="CachedDataRejected",_[_.CachedDataCreated=63]="CachedDataCreated"})(P||(e.LoaderEventType=P={}));class a{static get(){const L=new Map,k=new Map,T=new Map,D=new Map;function E(l,p){l.has(p.detail)||l.set(p.detail,-p.timestamp)}function R(l,p){const I=l.get(p.detail);I&&(I>=0||l.set(p.detail,I+p.timestamp))}let m=[];typeof ae=="function"&&typeof ae.getStats=="function"&&(m=ae.getStats().slice(0).sort((l,p)=>l.timestamp-p.timestamp));for(const l of m)switch(l.type){case P.BeginLoadingScript:E(L,l);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:R(L,l);break;case P.BeginInvokeFactory:E(k,l);break;case P.EndInvokeFactory:R(k,l);break;case P.NodeBeginNativeRequire:E(T,l);break;case P.NodeEndNativeRequire:R(T,l);break;case P.NodeBeginEvaluatingScript:E(D,l);break;case P.NodeEndEvaluatingScript:R(D,l);break}let d=0;T.forEach(l=>d+=l);function f(l){const p=[];return l.forEach((I,g)=>p.push([g,I])),p}return{amdLoad:f(L),amdInvoke:f(k),nodeRequire:f(T),nodeEval:f(D),nodeRequireTotal:d}}static toMarkdownTable(L,k){let T="";const D=[];return L.forEach((E,R)=>{D[R]=E.length}),k.forEach(E=>{E.forEach((R,m)=>{typeof R>"u"&&(R=E[m]="-");const d=R.toString().length;D[m]=Math.max(d,D[m])})}),L.forEach((E,R)=>{T+=`| ${E+" ".repeat(D[R]-E.toString().length)} `}),T+=`|
`,L.forEach((E,R)=>{T+=`| ${"-".repeat(D[R])} `}),T+=`|
`,k.forEach(E=>{E.forEach((R,m)=>{typeof R<"u"&&(T+=`| ${R+" ".repeat(D[m]-R.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=a}),define(ue[129],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=P,e.findLastIdx=a,e.findLastMonotonous=_,e.findLastIdxMonotonous=L,e.findFirstMonotonous=k,e.findFirstIdxMonotonousOrArrLen=T,e.findFirstIdxMonotonous=D,e.findFirstMax=R,e.findLastMax=m,e.findFirstMin=d,e.findMaxIdx=f,e.mapFindFirst=l;function P(p,I){const g=a(p,I);if(g!==-1)return p[g]}function a(p,I,g=p.length-1){for(let v=g;v>=0;v--){const C=p[v];if(I(C))return v}return-1}function _(p,I){const g=L(p,I);return g===-1?void 0:p[g]}function L(p,I,g=0,v=p.length){let C=g,S=v;for(;C<S;){const c=Math.floor((C+S)/2);I(p[c])?C=c+1:S=c}return C-1}function k(p,I){const g=T(p,I);return g===p.length?void 0:p[g]}function T(p,I,g=0,v=p.length){let C=g,S=v;for(;C<S;){const c=Math.floor((C+S)/2);I(p[c])?S=c:C=c+1}return C}function D(p,I,g=0,v=p.length){const C=T(p,I,g,v);return C===p.length?-1:C}class E{static{this.assertInvariants=!1}constructor(I){this._array=I,this._findLastMonotonousLastIdx=0}findLastMonotonous(I){if(E.assertInvariants){if(this._prevFindLastPredicate){for(const v of this._array)if(this._prevFindLastPredicate(v)&&!I(v))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=I}const g=L(this._array,I,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=g+1,g===-1?void 0:this._array[g]}}e.MonotonousArray=E;function R(p,I){if(p.length===0)return;let g=p[0];for(let v=1;v<p.length;v++){const C=p[v];I(C,g)>0&&(g=C)}return g}function m(p,I){if(p.length===0)return;let g=p[0];for(let v=1;v<p.length;v++){const C=p[v];I(C,g)>=0&&(g=C)}return g}function d(p,I){return R(p,(g,v)=>-I(g,v))}function f(p,I){if(p.length===0)return-1;let g=0;for(let v=1;v<p.length;v++){const C=p[v];I(C,p[g])>0&&(g=v)}return g}function l(p,I){for(const g of p){const v=I(g);if(v!==void 0)return v}}}),define(ue[39],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(P||(e.CharCode=P={}))}),define(ue[130],he([0,1]),function(ae,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=a,e.diffSets=_,e.diffMaps=L,e.intersection=k;function a(D,E){const R=Object.create(null);for(const m of D){const d=E(m);let f=R[d];f||(f=R[d]=[]),f.push(m)}return R}function _(D,E){const R=[],m=[];for(const d of D)E.has(d)||R.push(d);for(const d of E)D.has(d)||m.push(d);return{removed:R,added:m}}function L(D,E){const R=[],m=[];for(const[d,f]of D)E.has(d)||R.push(f);for(const[d,f]of E)D.has(d)||m.push(f);return{removed:R,added:m}}function k(D,E){const R=new Set;for(const m of E)D.has(m)&&R.add(m);return R}class T{static{P=Symbol.toStringTag}constructor(E,R){this.toKey=R,this._map=new Map,this[P]="SetWithKey";for(const m of E)this.add(m)}get size(){return this._map.size}add(E){const R=this.toKey(E);return this._map.set(R,E),this}delete(E){return this._map.delete(this.toKey(E))}has(E){return this._map.has(this.toKey(E))}*entries(){for(const E of this._map.values())yield[E,E]}keys(){return this.values()}*values(){for(const E of this._map.values())yield E}clear(){this._map.clear()}forEach(E,R){this._map.forEach(m=>E.call(R,m,m,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=T}),define(ue[87],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=a,e.debounce=_,e.throttle=L;function P(k){return(T,D,E)=>{let R=null,m=null;if(typeof E.value=="function"?(R="value",m=E.value):typeof E.get=="function"&&(R="get",m=E.get),!m)throw new Error("not supported");E[R]=k(m,D)}}function a(k,T,D){let E=null,R=null;if(typeof D.value=="function"?(E="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(E="get",R=D.get),!R)throw new Error("not supported");const m=`$memoize$${T}`;D[E]=function(...d){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,d)}),this[m]}}function _(k,T,D){return P((E,R)=>{const m=`$debounce$${R}`,d=`$debounce$result$${R}`;return function(...f){this[d]||(this[d]=D?D():void 0),clearTimeout(this[m]),T&&(this[d]=T(this[d],...f),f=[this[d]]),this[m]=setTimeout(()=>{E.apply(this,f),this[d]=D?D():void 0},k)}})}function L(k,T,D){return P((E,R)=>{const m=`$throttle$timer$${R}`,d=`$throttle$result$${R}`,f=`$throttle$lastRun$${R}`,l=`$throttle$pending$${R}`;return function(...p){if(this[d]||(this[d]=D?D():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),T&&(this[d]=T(this[d],...p)),this[l])return;const I=this[f]+k;I<=Date.now()?(this[f]=Date.now(),E.apply(this,[this[d]]),this[d]=D?D():void 0):(this[l]=!0,this[m]=setTimeout(()=>{this[l]=!1,this[f]=Date.now(),E.apply(this,[this[d]]),this[d]=D?D():void 0},I-Date.now()))}})}}),define(ue[8],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=a,e.isSigPipeError=_,e.onUnexpectedError=L,e.onUnexpectedExternalError=k,e.transformErrorForSerialization=T,e.transformErrorFromSerialization=D,e.isCancellationError=R,e.canceled=d,e.illegalArgument=f,e.illegalState=l,e.getErrorMessage=I;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?S.isErrorNoTelemetry(i)?new S(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(n=>{n(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=P,e.errorHandler=new P;function a(u){e.errorHandler.setUnexpectedErrorHandler(u)}function _(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function L(u){R(u)||e.errorHandler.onUnexpectedError(u)}function k(u){R(u)||e.errorHandler.onUnexpectedExternalError(u)}function T(u){if(u instanceof Error){const{name:i,message:n}=u,t=u.stacktrace||u.stack;return{$isError:!0,name:i,message:n,stack:t,noTelemetry:S.isErrorNoTelemetry(u)}}return u}function D(u){let i;return u.noTelemetry?i=new S:(i=new Error,i.name=u.name),i.message=u.message,i.stack=u.stack,i}const E="Canceled";function R(u){return u instanceof m?!0:u instanceof Error&&u.name===E&&u.message===E}class m extends Error{constructor(){super(E),this.name=this.message}}e.CancellationError=m;function d(){const u=new Error(E);return u.name=u.message,u}function f(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function l(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class p extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=p;function I(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class g extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=g;class v extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=v;class C extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=C;class S extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof S)return i;const n=new S;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.BugIndicatingError=c}),define(ue[17],he([0,1,8,129]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=_,e.tail2=L,e.equals=k,e.removeFastWithoutKeepingOrder=T,e.binarySearch=D,e.binarySearch2=E,e.quickSelect=R,e.groupBy=m,e.groupAdjacentBy=d,e.forEachAdjacent=f,e.forEachWithNeighbors=l,e.sortedDiff=p,e.delta=I,e.top=g,e.topAsync=v,e.coalesce=S,e.coalesceInPlace=c,e.move=u,e.isFalsyOrEmpty=i,e.isNonEmptyArray=n,e.distinct=t,e.uniqueFilter=s,e.firstOrDefault=r,e.lastOrDefault=o,e.commonPrefixLength=h,e.range=y,e.index=A,e.insert=b,e.remove=w,e.arrayInsert=O,e.shuffle=N,e.pushToStart=F,e.pushToEnd=M,e.pushMany=H,e.mapArrayOrNot=z,e.asArray=J,e.getRandomElement=V,e.insertInto=te,e.splice=$,e.compareBy=ne,e.tieBreakComparators=le,e.reverseOrder=K,e.findAsync=oe;function _(x,B=0){return x[x.length-(1+B)]}function L(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function k(x,B,j=(G,ie)=>G===ie){if(x===B)return!0;if(!x||!B||x.length!==B.length)return!1;for(let G=0,ie=x.length;G<ie;G++)if(!j(x[G],B[G]))return!1;return!0}function T(x,B){const j=x.length-1;B<j&&(x[B]=x[j]),x.pop()}function D(x,B,j){return E(x.length,G=>j(x[G],B))}function E(x,B){let j=0,G=x-1;for(;j<=G;){const ie=(j+G)/2|0,ce=B(ie);if(ce<0)j=ie+1;else if(ce>0)G=ie-1;else return ie}return-(j+1)}function R(x,B,j){if(x=x|0,x>=B.length)throw new TypeError("invalid index");const G=B[Math.floor(B.length*Math.random())],ie=[],ce=[],ge=[];for(const Se of B){const Ie=j(Se,G);Ie<0?ie.push(Se):Ie>0?ce.push(Se):ge.push(Se)}return x<ie.length?R(x,ie,j):x<ie.length+ge.length?ge[0]:R(x-(ie.length+ge.length),ce,j)}function m(x,B){const j=[];let G;for(const ie of x.slice(0).sort(B))!G||B(G[0],ie)!==0?(G=[ie],j.push(G)):G.push(ie);return j}function*d(x,B){let j,G;for(const ie of x)G!==void 0&&B(G,ie)?j.push(ie):(j&&(yield j),j=[ie]),G=ie;j&&(yield j)}function f(x,B){for(let j=0;j<=x.length;j++)B(j===0?void 0:x[j-1],j===x.length?void 0:x[j])}function l(x,B){for(let j=0;j<x.length;j++)B(j===0?void 0:x[j-1],x[j],j+1===x.length?void 0:x[j+1])}function p(x,B,j){const G=[];function ie(Se,Ie,Ce){if(Ie===0&&Ce.length===0)return;const Ee=G[G.length-1];Ee&&Ee.start+Ee.deleteCount===Se?(Ee.deleteCount+=Ie,Ee.toInsert.push(...Ce)):G.push({start:Se,deleteCount:Ie,toInsert:Ce})}let ce=0,ge=0;for(;;){if(ce===x.length){ie(ce,0,B.slice(ge));break}if(ge===B.length){ie(ce,x.length-ce,[]);break}const Se=x[ce],Ie=B[ge],Ce=j(Se,Ie);Ce===0?(ce+=1,ge+=1):Ce<0?(ie(ce,1,[]),ce+=1):Ce>0&&(ie(ce,0,[Ie]),ge+=1)}return G}function I(x,B,j){const G=p(x,B,j),ie=[],ce=[];for(const ge of G)ie.push(...x.slice(ge.start,ge.start+ge.deleteCount)),ce.push(...ge.toInsert);return{removed:ie,added:ce}}function g(x,B,j){if(j===0)return[];const G=x.slice(0,j).sort(B);return C(x,B,G,j,x.length),G}function v(x,B,j,G,ie){return j===0?Promise.resolve([]):new Promise((ce,ge)=>{(async()=>{const Se=x.length,Ie=x.slice(0,j).sort(B);for(let Ce=j,Ee=Math.min(j+G,Se);Ce<Se;Ce=Ee,Ee=Math.min(Ee+G,Se)){if(Ce>j&&await new Promise(ve=>setTimeout(ve)),ie&&ie.isCancellationRequested)throw new P.CancellationError;C(x,B,Ie,Ce,Ee)}return Ie})().then(ce,ge)})}function C(x,B,j,G,ie){for(const ce=j.length;G<ie;G++){const ge=x[G];if(B(ge,j[ce-1])<0){j.pop();const Se=(0,a.findFirstIdxMonotonousOrArrLen)(j,Ie=>B(ge,Ie)<0);j.splice(Se,0,ge)}}}function S(x){return x.filter(B=>!!B)}function c(x){let B=0;for(let j=0;j<x.length;j++)x[j]&&(x[B]=x[j],B+=1);x.length=B}function u(x,B,j){x.splice(j,0,x.splice(B,1)[0])}function i(x){return!Array.isArray(x)||x.length===0}function n(x){return Array.isArray(x)&&x.length>0}function t(x,B=j=>j){const j=new Set;return x.filter(G=>{const ie=B(G);return j.has(ie)?!1:(j.add(ie),!0)})}function s(x){const B=new Set;return j=>{const G=x(j);return B.has(G)?!1:(B.add(G),!0)}}function r(x,B){return x.length>0?x[0]:B}function o(x,B){return x.length>0?x[x.length-1]:B}function h(x,B,j=(G,ie)=>G===ie){let G=0;for(let ie=0,ce=Math.min(x.length,B.length);ie<ce&&j(x[ie],B[ie]);ie++)G++;return G}function y(x,B){let j=typeof B=="number"?x:0;typeof B=="number"?j=x:(j=0,B=x);const G=[];if(j<=B)for(let ie=j;ie<B;ie++)G.push(ie);else for(let ie=j;ie>B;ie--)G.push(ie);return G}function A(x,B,j){return x.reduce((G,ie)=>(G[B(ie)]=j?j(ie):ie,G),Object.create(null))}function b(x,B){return x.push(B),()=>w(x,B)}function w(x,B){const j=x.indexOf(B);if(j>-1)return x.splice(j,1),B}function O(x,B,j){const G=x.slice(0,B),ie=x.slice(B);return G.concat(j,ie)}function N(x,B){let j;if(typeof B=="number"){let G=B;j=()=>{const ie=Math.sin(G++)*179426549;return ie-Math.floor(ie)}}else j=Math.random;for(let G=x.length-1;G>0;G-=1){const ie=Math.floor(j()*(G+1)),ce=x[G];x[G]=x[ie],x[ie]=ce}}function F(x,B){const j=x.indexOf(B);j>-1&&(x.splice(j,1),x.unshift(B))}function M(x,B){const j=x.indexOf(B);j>-1&&(x.splice(j,1),x.push(B))}function H(x,B){for(const j of B)x.push(j)}function z(x,B){return Array.isArray(x)?x.map(B):B(x)}function J(x){return Array.isArray(x)?x:[x]}function V(x){return x[Math.floor(Math.random()*x.length)]}function te(x,B,j){const G=q(x,B),ie=x.length,ce=j.length;x.length=ie+ce;for(let ge=ie-1;ge>=G;ge--)x[ge+ce]=x[ge];for(let ge=0;ge<ce;ge++)x[ge+G]=j[ge]}function $(x,B,j,G){const ie=q(x,B);let ce=x.splice(ie,j);return ce===void 0&&(ce=[]),te(x,ie,G),ce}function q(x,B){return B<0?Math.max(B+x.length,0):Math.min(B,x.length)}var Z;(function(x){function B(ce){return ce<0}x.isLessThan=B;function j(ce){return ce<=0}x.isLessThanOrEqual=j;function G(ce){return ce>0}x.isGreaterThan=G;function ie(ce){return ce===0}x.isNeitherLessOrGreaterThan=ie,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(Z||(e.CompareResult=Z={}));function ne(x,B){return(j,G)=>B(x(j),x(G))}function le(...x){return(B,j)=>{for(const G of x){const ie=G(B,j);if(!Z.isNeitherLessOrGreaterThan(ie))return ie}return Z.neitherLessOrGreaterThan}}const ee=(x,B)=>x-B;e.numberComparator=ee;const X=(x,B)=>(0,e.numberComparator)(x?1:0,B?1:0);e.booleanComparator=X;function K(x){return(B,j)=>-x(B,j)}class W{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let j=this.firstIdx;for(;j<this.items.length&&B(this.items[j]);)j++;const G=j===this.firstIdx?null:this.items.slice(this.firstIdx,j);return this.firstIdx=j,G}takeFromEndWhile(B){let j=this.lastIdx;for(;j>=0&&B(this.items[j]);)j--;const G=j===this.lastIdx?null:this.items.slice(j+1,this.lastIdx+1);return this.lastIdx=j,G}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}removeLast(){const B=this.items[this.lastIdx];return this.lastIdx--,B}takeCount(B){const j=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,j}}e.ArrayQueue=W;class U{static{this.empty=new U(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(j=>(B(j),!0))}toArray(){const B=[];return this.iterate(j=>(B.push(j),!0)),B}filter(B){return new U(j=>this.iterate(G=>B(G)?j(G):!0))}map(B){return new U(j=>this.iterate(G=>j(B(G))))}some(B){let j=!1;return this.iterate(G=>(j=B(G),!j)),j}findFirst(B){let j;return this.iterate(G=>B(G)?(j=G,!1):!0),j}findLast(B){let j;return this.iterate(G=>(B(G)&&(j=G),!0)),j}findLastMaxBy(B){let j,G=!0;return this.iterate(ie=>((G||Z.isGreaterThan(B(ie,j)))&&(G=!1,j=ie),!0)),j}}e.CallbackIterable=U;class Y{constructor(B){this._indexMap=B}static createSortPermutation(B,j){const G=Array.from(B.keys()).sort((ie,ce)=>j(B[ie],B[ce]));return new Y(G)}apply(B){return B.map((j,G)=>B[this._indexMap[G]])}inverse(){const B=this._indexMap.slice();for(let j=0;j<this._indexMap.length;j++)B[this._indexMap[j]]=j;return new Y(B)}}e.Permutation=Y;async function oe(x,B){return(await Promise.all(x.map(async(G,ie)=>({element:G,ok:await B(G,ie)})))).find(G=>G.ok)?.element}}),define(ue[131],he([0,1,8]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.assertNever=_,e.assert=L,e.softAssert=k,e.assertFn=T,e.checkAdjacentItems=D;function a(E,R){if(!E)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}function _(E,R="Unreachable"){throw new Error(R)}function L(E,R="unexpected state"){if(!E)throw new P.BugIndicatingError(`Assertion Failed: ${R}`)}function k(E){E||(0,P.onUnexpectedError)(new P.BugIndicatingError("Soft Assertion Failed"))}function T(E){if(!E()){debugger;E(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}function D(E,R){let m=0;for(;m<E.length-1;){const d=E[m],f=E[m+1];if(!R(d,f))return!1;m++}return!0}}),define(ue[88],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=P;function P(a,_){const L=this;let k=!1,T;return function(){if(k)return T;if(k=!0,_)try{T=a.apply(L,arguments)}finally{_()}else T=a.apply(L,arguments);return T}}}),define(ue[63],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(a){function _(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}a.is=_;const L=Object.freeze([]);function k(){return L}a.empty=k;function*T(i){yield i}a.single=T;function D(i){return _(i)?i:T(i)}a.wrap=D;function E(i){return i||L}a.from=E;function*R(i){for(let n=i.length-1;n>=0;n--)yield i[n]}a.reverse=R;function m(i){return!i||i[Symbol.iterator]().next().done===!0}a.isEmpty=m;function d(i){return i[Symbol.iterator]().next().value}a.first=d;function f(i,n){let t=0;for(const s of i)if(n(s,t++))return!0;return!1}a.some=f;function l(i,n){for(const t of i)if(n(t))return t}a.find=l;function*p(i,n){for(const t of i)n(t)&&(yield t)}a.filter=p;function*I(i,n){let t=0;for(const s of i)yield n(s,t++)}a.map=I;function*g(i,n){let t=0;for(const s of i)yield*n(s,t++)}a.flatMap=g;function*v(...i){for(const n of i)yield*n}a.concat=v;function C(i,n,t){let s=t;for(const r of i)s=n(s,r);return s}a.reduce=C;function*S(i,n,t=i.length){for(n<0&&(n+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);n<t;n++)yield i[n]}a.slice=S;function c(i,n=Number.POSITIVE_INFINITY){const t=[];if(n===0)return[t,i];const s=i[Symbol.iterator]();for(let r=0;r<n;r++){const o=s.next();if(o.done)return[t,a.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return s}}]}a.consume=c;async function u(i){const n=[];for await(const t of i)n.push(t);return Promise.resolve(n)}a.asyncToArray=u})(P||(e.Iterable=P={}))}),define(ue[36],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=k,e.getLocation=m,e.parse=d,e.parseTree=f,e.findNodeAtLocation=l,e.getNodePath=p,e.getNodeValue=I,e.contains=g,e.findNodeAtOffset=v,e.visit=C,e.getNodeType=S;var P;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var a;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var _;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(_||(e.ParseErrorCode=_={}));var L;(function(c){c.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function k(c,u=!1){let i=0;const n=c.length;let t="",s=0,r=a.Unknown,o=P.None;function h(F){let M=0,H=0;for(;M<F;){const z=c.charCodeAt(i);if(z>=R._0&&z<=R._9)H=H*16+z-R._0;else if(z>=R.A&&z<=R.F)H=H*16+z-R.A+10;else if(z>=R.a&&z<=R.f)H=H*16+z-R.a+10;else break;i++,M++}return M<F&&(H=-1),H}function y(F){i=F,t="",s=0,r=a.Unknown,o=P.None}function A(){const F=i;if(c.charCodeAt(i)===R._0)i++;else for(i++;i<c.length&&E(c.charCodeAt(i));)i++;if(i<c.length&&c.charCodeAt(i)===R.dot)if(i++,i<c.length&&E(c.charCodeAt(i)))for(i++;i<c.length&&E(c.charCodeAt(i));)i++;else return o=P.UnexpectedEndOfNumber,c.substring(F,i);let M=i;if(i<c.length&&(c.charCodeAt(i)===R.E||c.charCodeAt(i)===R.e))if(i++,(i<c.length&&c.charCodeAt(i)===R.plus||c.charCodeAt(i)===R.minus)&&i++,i<c.length&&E(c.charCodeAt(i))){for(i++;i<c.length&&E(c.charCodeAt(i));)i++;M=i}else o=P.UnexpectedEndOfNumber;return c.substring(F,M)}function b(){let F="",M=i;for(;;){if(i>=n){F+=c.substring(M,i),o=P.UnexpectedEndOfString;break}const H=c.charCodeAt(i);if(H===R.doubleQuote){F+=c.substring(M,i),i++;break}if(H===R.backslash){if(F+=c.substring(M,i),i++,i>=n){o=P.UnexpectedEndOfString;break}switch(c.charCodeAt(i++)){case R.doubleQuote:F+='"';break;case R.backslash:F+="\\";break;case R.slash:F+="/";break;case R.b:F+="\b";break;case R.f:F+="\f";break;case R.n:F+=`
`;break;case R.r:F+="\r";break;case R.t:F+="	";break;case R.u:{const J=h(4);J>=0?F+=String.fromCharCode(J):o=P.InvalidUnicode;break}default:o=P.InvalidEscapeCharacter}M=i;continue}if(H>=0&&H<=31)if(D(H)){F+=c.substring(M,i),o=P.UnexpectedEndOfString;break}else o=P.InvalidCharacter;i++}return F}function w(){if(t="",o=P.None,s=i,i>=n)return s=n,r=a.EOF;let F=c.charCodeAt(i);if(T(F)){do i++,t+=String.fromCharCode(F),F=c.charCodeAt(i);while(T(F));return r=a.Trivia}if(D(F))return i++,t+=String.fromCharCode(F),F===R.carriageReturn&&c.charCodeAt(i)===R.lineFeed&&(i++,t+=`
`),r=a.LineBreakTrivia;switch(F){case R.openBrace:return i++,r=a.OpenBraceToken;case R.closeBrace:return i++,r=a.CloseBraceToken;case R.openBracket:return i++,r=a.OpenBracketToken;case R.closeBracket:return i++,r=a.CloseBracketToken;case R.colon:return i++,r=a.ColonToken;case R.comma:return i++,r=a.CommaToken;case R.doubleQuote:return i++,t=b(),r=a.StringLiteral;case R.slash:{const M=i-1;if(c.charCodeAt(i+1)===R.slash){for(i+=2;i<n&&!D(c.charCodeAt(i));)i++;return t=c.substring(M,i),r=a.LineCommentTrivia}if(c.charCodeAt(i+1)===R.asterisk){i+=2;const H=n-1;let z=!1;for(;i<H;){if(c.charCodeAt(i)===R.asterisk&&c.charCodeAt(i+1)===R.slash){i+=2,z=!0;break}i++}return z||(i++,o=P.UnexpectedEndOfComment),t=c.substring(M,i),r=a.BlockCommentTrivia}return t+=String.fromCharCode(F),i++,r=a.Unknown}case R.minus:if(t+=String.fromCharCode(F),i++,i===n||!E(c.charCodeAt(i)))return r=a.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return t+=A(),r=a.NumericLiteral;default:for(;i<n&&O(F);)i++,F=c.charCodeAt(i);if(s!==i){switch(t=c.substring(s,i),t){case"true":return r=a.TrueKeyword;case"false":return r=a.FalseKeyword;case"null":return r=a.NullKeyword}return r=a.Unknown}return t+=String.fromCharCode(F),i++,r=a.Unknown}}function O(F){if(T(F)||D(F))return!1;switch(F){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function N(){let F;do F=w();while(F>=a.LineCommentTrivia&&F<=a.Trivia);return F}return{setPosition:y,getPosition:()=>i,scan:u?N:w,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>o}}function T(c){return c===R.space||c===R.tab||c===R.verticalTab||c===R.formFeed||c===R.nonBreakingSpace||c===R.ogham||c>=R.enQuad&&c<=R.zeroWidthSpace||c===R.narrowNoBreakSpace||c===R.mathematicalSpace||c===R.ideographicSpace||c===R.byteOrderMark}function D(c){return c===R.lineFeed||c===R.carriageReturn||c===R.lineSeparator||c===R.paragraphSeparator}function E(c){return c>=R._0&&c<=R._9}var R;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(R||(R={}));function m(c,u){const i=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function o(h,y,A,b){s.value=h,s.offset=y,s.length=A,s.type=b,s.colonOffset=void 0,t=s}try{C(c,{onObjectBegin:(h,y)=>{if(u<=h)throw n;t=void 0,r=u>h,i.push("")},onObjectProperty:(h,y,A)=>{if(u<y||(o(h,y,A,"property"),i[i.length-1]=h,u<=y+A))throw n},onObjectEnd:(h,y)=>{if(u<=h)throw n;t=void 0,i.pop()},onArrayBegin:(h,y)=>{if(u<=h)throw n;t=void 0,i.push(0)},onArrayEnd:(h,y)=>{if(u<=h)throw n;t=void 0,i.pop()},onLiteralValue:(h,y,A)=>{if(u<y||(o(h,y,A,S(h)),u<=y+A))throw n},onSeparator:(h,y,A)=>{if(u<=y)throw n;if(h===":"&&t&&t.type==="property")t.colonOffset=y,r=!1,t=void 0;else if(h===","){const b=i[i.length-1];typeof b=="number"?i[i.length-1]=b+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(h){if(h!==n)throw h}return{path:i,previousNode:t,isAtPropertyKey:r,matches:h=>{let y=0;for(let A=0;y<h.length&&A<i.length;A++)if(h[y]===i[A]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}function d(c,u=[],i=L.DEFAULT){let n=null,t=[];const s=[];function r(h){Array.isArray(t)?t.push(h):n!==null&&(t[n]=h)}return C(c,{onObjectBegin:()=>{const h={};r(h),s.push(t),t=h,n=null},onObjectProperty:h=>{n=h},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const h=[];r(h),s.push(t),t=h,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:r,onError:(h,y,A)=>{u.push({error:h,offset:y,length:A})}},i),t[0]}function f(c,u=[],i=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(h){n.type==="property"&&(n.length=h-n.offset,n=n.parent)}function s(h){return n.children.push(h),h}C(c,{onObjectBegin:h=>{n=s({type:"object",offset:h,length:-1,parent:n,children:[]})},onObjectProperty:(h,y,A)=>{n=s({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:h,offset:y,length:A,parent:n})},onObjectEnd:(h,y)=>{n.length=h+y-n.offset,n=n.parent,t(h+y)},onArrayBegin:(h,y)=>{n=s({type:"array",offset:h,length:-1,parent:n,children:[]})},onArrayEnd:(h,y)=>{n.length=h+y-n.offset,n=n.parent,t(h+y)},onLiteralValue:(h,y,A)=>{s({type:S(h),offset:y,length:A,parent:n,value:h}),t(y+A)},onSeparator:(h,y,A)=>{n.type==="property"&&(h===":"?n.colonOffset=y:h===","&&t(y))},onError:(h,y,A)=>{u.push({error:h,offset:y,length:A})}},i);const o=n.children[0];return o&&delete o.parent,o}function l(c,u){if(!c)return;let i=c;for(const n of u)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function p(c){if(!c.parent||!c.parent.children)return[];const u=p(c.parent);if(c.parent.type==="property"){const i=c.parent.children[0].value;u.push(i)}else if(c.parent.type==="array"){const i=c.parent.children.indexOf(c);i!==-1&&u.push(i)}return u}function I(c){switch(c.type){case"array":return c.children.map(I);case"object":{const u=Object.create(null);for(const i of c.children){const n=i.children[1];n&&(u[i.children[0].value]=I(n))}return u}case"null":case"string":case"number":case"boolean":return c.value;default:return}}function g(c,u,i=!1){return u>=c.offset&&u<c.offset+c.length||i&&u===c.offset+c.length}function v(c,u,i=!1){if(g(c,u,i)){const n=c.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=u;t++){const s=v(n[t],u,i);if(s)return s}return c}}function C(c,u,i=L.DEFAULT){const n=k(c,!1);function t(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(ne){return ne?le=>ne(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=t(u.onObjectBegin),o=s(u.onObjectProperty),h=t(u.onObjectEnd),y=t(u.onArrayBegin),A=t(u.onArrayEnd),b=s(u.onLiteralValue),w=s(u.onSeparator),O=t(u.onComment),N=s(u.onError),F=i&&i.disallowComments,M=i&&i.allowTrailingComma;function H(){for(;;){const ne=n.scan();switch(n.getTokenError()){case P.InvalidUnicode:z(_.InvalidUnicode);break;case P.InvalidEscapeCharacter:z(_.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:z(_.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:F||z(_.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:z(_.UnexpectedEndOfString);break;case P.InvalidCharacter:z(_.InvalidCharacter);break}switch(ne){case a.LineCommentTrivia:case a.BlockCommentTrivia:F?z(_.InvalidCommentToken):O();break;case a.Unknown:z(_.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ne}}}function z(ne,le=[],ee=[]){if(N(ne),le.length+ee.length>0){let X=n.getToken();for(;X!==a.EOF;){if(le.indexOf(X)!==-1){H();break}else if(ee.indexOf(X)!==-1)break;X=H()}}}function J(ne){const le=n.getTokenValue();return ne?b(le):o(le),H(),!0}function V(){switch(n.getToken()){case a.NumericLiteral:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(z(_.InvalidNumberFormat),ne=0)}catch{z(_.InvalidNumberFormat)}b(ne);break}case a.NullKeyword:b(null);break;case a.TrueKeyword:b(!0);break;case a.FalseKeyword:b(!1);break;default:return!1}return H(),!0}function te(){return n.getToken()!==a.StringLiteral?(z(_.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(J(!1),n.getToken()===a.ColonToken?(w(":"),H(),Z()||z(_.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):z(_.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function $(){r(),H();let ne=!1;for(;n.getToken()!==a.CloseBraceToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||z(_.ValueExpected,[],[]),w(","),H(),n.getToken()===a.CloseBraceToken&&M)break}else ne&&z(_.CommaExpected,[],[]);te()||z(_.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ne=!0}return h(),n.getToken()!==a.CloseBraceToken?z(_.CloseBraceExpected,[a.CloseBraceToken],[]):H(),!0}function q(){y(),H();let ne=!1;for(;n.getToken()!==a.CloseBracketToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||z(_.ValueExpected,[],[]),w(","),H(),n.getToken()===a.CloseBracketToken&&M)break}else ne&&z(_.CommaExpected,[],[]);Z()||z(_.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ne=!0}return A(),n.getToken()!==a.CloseBracketToken?z(_.CloseBracketExpected,[a.CloseBracketToken],[]):H(),!0}function Z(){switch(n.getToken()){case a.OpenBracketToken:return q();case a.OpenBraceToken:return $();case a.StringLiteral:return J(!0);default:return V()}}return H(),n.getToken()===a.EOF?i.allowEmptyContent?!0:(z(_.ValueExpected,[],[]),!1):Z()?(n.getToken()!==a.EOF&&z(_.EndOfFileExpected,[],[]),!0):(z(_.ValueExpected,[],[]),!1)}function S(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}}),define(ue[45],he([0,1,36]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=a,e.toFormattedString=_,e.getEOL=T,e.isEOL=D;function a(E,R,m){let d,f,l,p,I;if(R){for(p=R.offset,I=p+R.length,l=p;l>0&&!D(E,l-1);)l--;let o=I;for(;o<E.length&&!D(E,o);)o++;f=E.substring(l,o),d=k(f,m)}else f=E,d=0,l=0,p=0,I=E.length;const g=T(m,E);let v=!1,C=0,S;m.insertSpaces?S=L(" ",m.tabSize||4):S="	";const c=(0,P.createScanner)(f,!1);let u=!1;function i(){return g+L(S,d+C)}function n(){let o=c.scan();for(v=!1;o===P.SyntaxKind.Trivia||o===P.SyntaxKind.LineBreakTrivia;)v=v||o===P.SyntaxKind.LineBreakTrivia,o=c.scan();return u=o===P.SyntaxKind.Unknown||c.getTokenError()!==P.ScanError.None,o}const t=[];function s(o,h,y){!u&&h<I&&y>p&&E.substring(h,y)!==o&&t.push({offset:h,length:y-h,content:o})}let r=n();if(r!==P.SyntaxKind.EOF){const o=c.getTokenOffset()+l,h=L(S,d);s(h,l,o)}for(;r!==P.SyntaxKind.EOF;){let o=c.getTokenOffset()+c.getTokenLength()+l,h=n(),y="";for(;!v&&(h===P.SyntaxKind.LineCommentTrivia||h===P.SyntaxKind.BlockCommentTrivia);){const b=c.getTokenOffset()+l;s(" ",o,b),o=c.getTokenOffset()+c.getTokenLength()+l,y=h===P.SyntaxKind.LineCommentTrivia?i():"",h=n()}if(h===P.SyntaxKind.CloseBraceToken)r!==P.SyntaxKind.OpenBraceToken&&(C--,y=i());else if(h===P.SyntaxKind.CloseBracketToken)r!==P.SyntaxKind.OpenBracketToken&&(C--,y=i());else{switch(r){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:C++,y=i();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:y=i();break;case P.SyntaxKind.BlockCommentTrivia:v?y=i():y=" ";break;case P.SyntaxKind.ColonToken:y=" ";break;case P.SyntaxKind.StringLiteral:if(h===P.SyntaxKind.ColonToken){y="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:h===P.SyntaxKind.LineCommentTrivia||h===P.SyntaxKind.BlockCommentTrivia?y=" ":h!==P.SyntaxKind.CommaToken&&h!==P.SyntaxKind.EOF&&(u=!0);break;case P.SyntaxKind.Unknown:u=!0;break}v&&(h===P.SyntaxKind.LineCommentTrivia||h===P.SyntaxKind.BlockCommentTrivia)&&(y=i())}const A=c.getTokenOffset()+l;s(y,o,A),r=h}return t}function _(E,R){const m=JSON.stringify(E,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?m.replace(/\r\n|\r|\n/g,R.eol):m}function L(E,R){let m="";for(let d=0;d<R;d++)m+=E;return m}function k(E,R){let m=0,d=0;const f=R.tabSize||4;for(;m<E.length;){const l=E.charAt(m);if(l===" ")d++;else if(l==="	")d+=f;else break;m++}return Math.floor(d/f)}function T(E,R){for(let m=0;m<R.length;m++){const d=R.charAt(m);if(d==="\r")return m+1<R.length&&R.charAt(m+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return E&&E.eol||`
`}function D(E,R){return`\r
`.indexOf(E.charAt(R))!==-1}}),define(ue[64],he([0,1,36,45]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=_,e.setProperty=L,e.withFormatting=k,e.applyEdit=T,e.applyEdits=D;function _(E,R,m){return L(E,R,void 0,m)}function L(E,R,m,d,f){const l=R.slice(),p=[],I=(0,P.parseTree)(E,p);let g,v;for(;l.length>0&&(v=l.pop(),g=(0,P.findNodeAtLocation)(I,l),g===void 0&&m!==void 0);)typeof v=="string"?m={[v]:m}:m=[m];if(g)if(g.type==="object"&&typeof v=="string"&&Array.isArray(g.children)){const C=(0,P.findNodeAtLocation)(g,[v]);if(C!==void 0)if(m===void 0){if(!C.parent)throw new Error("Malformed AST");const S=g.children.indexOf(C.parent);let c,u=C.parent.offset+C.parent.length;if(S>0){const i=g.children[S-1];c=i.offset+i.length}else c=g.offset+1,g.children.length>1&&(u=g.children[1].offset);return k(E,{offset:c,length:u-c,content:""},d)}else return k(E,{offset:C.offset,length:C.length,content:JSON.stringify(m)},d);else{if(m===void 0)return[];const S=`${JSON.stringify(v)}: ${JSON.stringify(m)}`,c=f?f(g.children.map(i=>i.children[0].value)):g.children.length;let u;if(c>0){const i=g.children[c-1];u={offset:i.offset+i.length,length:0,content:","+S}}else g.children.length===0?u={offset:g.offset+1,length:0,content:S}:u={offset:g.offset+1,length:0,content:S+","};return k(E,u,d)}}else if(g.type==="array"&&typeof v=="number"&&Array.isArray(g.children))if(m!==void 0){const C=`${JSON.stringify(m)}`;let S;if(g.children.length===0||v===0)S={offset:g.offset+1,length:0,content:g.children.length===0?C:C+","};else{const c=v===-1||v>g.children.length?g.children.length:v,u=g.children[c-1];S={offset:u.offset+u.length,length:0,content:","+C}}return k(E,S,d)}else{const C=v,S=g.children[C];let c;if(g.children.length===1)c={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===C){const u=g.children[C-1],i=u.offset+u.length,n=g.offset+g.length;c={offset:i,length:n-2-i,content:""}}else c={offset:S.offset,length:g.children[C+1].offset-S.offset,content:""};return k(E,c,d)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${g.type}`);else return m===void 0?[]:k(E,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(m)},d)}function k(E,R,m){let d=T(E,R),f=R.offset,l=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;f>0&&!(0,a.isEOL)(d,f-1);)f--;for(;l<d.length&&!(0,a.isEOL)(d,l);)l++}const p=(0,a.format)(d,{offset:f,length:l-f},m);for(let g=p.length-1;g>=0;g--){const v=p[g];d=T(d,v),f=Math.min(f,v.offset),l=Math.max(l,v.offset+v.length),l+=v.content.length-v.length}const I=E.length-(d.length-l)-f;return[{offset:f,length:I,content:d.substring(f,l)}]}function T(E,R){return E.substring(0,R.offset)+R.content+E.substring(R.offset+R.length)}function D(E,R){const m=R.slice(0).sort((f,l)=>{const p=f.offset-l.offset;return p===0?f.length-l.length:p});let d=E.length;for(let f=m.length-1;f>=0;f--){const l=m[f];if(l.offset+l.length<=d)E=T(E,l);else throw new Error("Overlapping edit");d=l.offset}return E}}),define(ue[132],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCompressedContent=P;function P(L){let k=!1;const T=new Map,D=new Map;if(_(L,p=>{if(L===p)return!0;const I=JSON.stringify(p);if(I.length<30)return!0;const g=T.get(I);if(!g){const v={schemas:[p]};return T.set(I,v),D.set(p,v),!0}return g.schemas.push(p),D.set(p,g),k=!0,!1}),T.clear(),!k)return JSON.stringify(L);let R="$defs";for(;L.hasOwnProperty(R);)R+="_";const m=[];function d(p){return JSON.stringify(p,(I,g)=>{if(g!==p){const v=D.get(g);if(v&&v.schemas.length>1)return v.id||(v.id=`_${m.length}`,m.push(v.schemas[0])),{$ref:`#/${R}/${v.id}`}}return g})}const f=d(L),l=[];for(let p=0;p<m.length;p++)l.push(`"_${p}":${d(m[p])}`);return l.length?`${f.substring(0,f.length-1)},"${R}":{${l.join(",")}}}`:f}function a(L){return typeof L=="object"&&L!==null}function _(L,k){if(!L||typeof L!="object")return;const T=(...f)=>{for(const l of f)a(l)&&m.push(l)},D=(...f)=>{for(const l of f)if(a(l))for(const p in l){const I=l[p];a(I)&&m.push(I)}},E=(...f)=>{for(const l of f)if(Array.isArray(l))for(const p of l)a(p)&&m.push(p)},R=f=>{if(Array.isArray(f))for(const l of f)a(l)&&m.push(l);else a(f)&&m.push(f)},m=[L];let d=m.pop();for(;d;)k(d)&&(T(d.additionalItems,d.additionalProperties,d.not,d.contains,d.propertyNames,d.if,d.then,d.else,d.unevaluatedItems,d.unevaluatedProperties),D(d.definitions,d.$defs,d.properties,d.patternProperties,d.dependencies,d.dependentSchemas),E(d.anyOf,d.allOf,d.oneOf,d.prefixItems),R(d.items)),d=m.pop()}}),define(ue[53],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class P{constructor(_){this.executor=_,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(_){this._error=_}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=P}),define(ue[89],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class P{static{this.Undefined=new P(void 0)}constructor(L){this.element=L,this.next=P.Undefined,this.prev=P.Undefined}}class a{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let L=this._first;for(;L!==P.Undefined;){const k=L.next;L.prev=P.Undefined,L.next=P.Undefined,L=k}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,k){const T=new P(L);if(this._first===P.Undefined)this._first=T,this._last=T;else if(k){const E=this._last;this._last=T,T.prev=E,E.next=T}else{const E=this._first;this._first=T,T.next=E,E.prev=T}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(T))}}shift(){if(this._first!==P.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==P.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==P.Undefined&&L.next!==P.Undefined){const k=L.prev;k.next=L.next,L.next.prev=k}else L.prev===P.Undefined&&L.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):L.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):L.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==P.Undefined;)yield L.element,L=L.next}}e.LinkedList=a}),define(ue[31],he([0,1]),function(ae,e){"use strict";var P,a,_;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=L,e.mapToString=k,e.setToString=T,e.mapsStrictEqualIgnoreOrder=S;function L(c,u,i){let n=c.get(u);return n===void 0&&(n=i,c.set(u,n)),n}function k(c){const u=[];return c.forEach((i,n)=>{u.push(`${n} => ${i}`)}),`Map(${c.size}) {${u.join(", ")}}`}function T(c){const u=[];return c.forEach(i=>{u.push(i)}),`Set(${c.size}) {${u.join(", ")}}`}class D{constructor(u,i){this.uri=u,this.value=i}}function E(c){return Array.isArray(c)}class R{static{this.defaultToKey=u=>u.toString()}constructor(u,i){if(this[P]="ResourceMap",u instanceof R)this.map=new Map(u.map),this.toKey=i??R.defaultToKey;else if(E(u)){this.map=new Map,this.toKey=i??R.defaultToKey;for(const[n,t]of u)this.set(n,t)}else this.map=new Map,this.toKey=u??R.defaultToKey}set(u,i){return this.map.set(this.toKey(u),new D(u,i)),this}get(u){return this.map.get(this.toKey(u))?.value}has(u){return this.map.has(this.toKey(u))}get size(){return this.map.size}clear(){this.map.clear()}delete(u){return this.map.delete(this.toKey(u))}forEach(u,i){typeof i<"u"&&(u=u.bind(i));for(const[n,t]of this.map)u(t.value,t.uri,this)}*values(){for(const u of this.map.values())yield u.value}*keys(){for(const u of this.map.values())yield u.uri}*entries(){for(const u of this.map.values())yield[u.uri,u.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.map)yield[u.uri,u.value]}}e.ResourceMap=R;class m{constructor(u,i){this[a]="ResourceSet",!u||typeof u=="function"?this._map=new R(u):(this._map=new R(i),u.forEach(this.add,this))}get size(){return this._map.size}add(u){return this._map.set(u,u),this}clear(){this._map.clear()}delete(u){return this._map.delete(u)}forEach(u,i){this._map.forEach((n,t)=>u.call(i,t,t,this))}has(u){return this._map.has(u)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var d;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class f{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(u){return this._map.has(u)}get(u,i=d.None){const n=this._map.get(u);if(n)return i!==d.None&&this.touch(n,i),n.value}set(u,i,n=d.None){let t=this._map.get(u);if(t)t.value=i,n!==d.None&&this.touch(t,n);else{switch(t={key:u,value:i,next:void 0,previous:void 0},n){case d.None:this.addItemLast(t);break;case d.AsOld:this.addItemFirst(t);break;case d.AsNew:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(u,t),this._size++}return this}delete(u){return!!this.remove(u)}remove(u){const i=this._map.get(u);if(i)return this._map.delete(u),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const u=this._head;return this._map.delete(u.key),this.removeItem(u),this._size--,u.value}forEach(u,i){const n=this._state;let t=this._head;for(;t;){if(i?u.bind(i)(t.value,t.key,this):u(t.value,t.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const u=this,i=this._state;let n=this._head;const t={[Symbol.iterator](){return t},next(){if(u._state!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.key,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}values(){const u=this,i=this._state;let n=this._head;const t={[Symbol.iterator](){return t},next(){if(u._state!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.value,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}entries(){const u=this,i=this._state;let n=this._head;const t={[Symbol.iterator](){return t},next(){if(u._state!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:[n.key,n.value],done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this._head,n=this.size;for(;i&&n>u;)this._map.delete(i.key),i=i.next,n--;this._head=i,this._size=n,i&&(i.previous=void 0),this._state++}trimNew(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this._tail,n=this.size;for(;i&&n>u;)this._map.delete(i.key),i=i.previous,n--;this._tail=i,this._size=n,i&&(i.next=void 0),this._state++}addItemFirst(u){if(!this._head&&!this._tail)this._tail=u;else if(this._head)u.next=this._head,this._head.previous=u;else throw new Error("Invalid list");this._head=u,this._state++}addItemLast(u){if(!this._head&&!this._tail)this._head=u;else if(this._tail)u.previous=this._tail,this._tail.next=u;else throw new Error("Invalid list");this._tail=u,this._state++}removeItem(u){if(u===this._head&&u===this._tail)this._head=void 0,this._tail=void 0;else if(u===this._head){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this._head=u.next}else if(u===this._tail){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this._tail=u.previous}else{const i=u.next,n=u.previous;if(!i||!n)throw new Error("Invalid list");i.previous=n,n.next=i}u.next=void 0,u.previous=void 0,this._state++}touch(u,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==d.AsOld&&i!==d.AsNew)){if(i===d.AsOld){if(u===this._head)return;const n=u.next,t=u.previous;u===this._tail?(t.next=void 0,this._tail=t):(n.previous=t,t.next=n),u.previous=void 0,u.next=this._head,this._head.previous=u,this._head=u,this._state++}else if(i===d.AsNew){if(u===this._tail)return;const n=u.next,t=u.previous;u===this._head?(n.previous=void 0,this._head=n):(n.previous=t,t.next=n),u.next=void 0,u.previous=this._tail,this._tail.next=u,this._tail=u,this._state++}}}toJSON(){const u=[];return this.forEach((i,n)=>{u.push([n,i])}),u}fromJSON(u){this.clear();for(const[i,n]of u)this.set(i,n)}}e.LinkedMap=f;class l extends f{constructor(u,i=1){super(),this._limit=u,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(u){this._limit=u,this.checkTrim()}get ratio(){return this._ratio}set ratio(u){this._ratio=Math.min(Math.max(0,u),1),this.checkTrim()}get(u,i=d.AsNew){return super.get(u,i)}peek(u){return super.get(u,d.None)}set(u,i){return super.set(u,i,d.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class p extends l{constructor(u,i=1){super(u,i)}trim(u){this.trimOld(u)}set(u,i){return super.set(u,i),this.checkTrim(),this}}e.LRUCache=p;class I extends l{constructor(u,i=1){super(u,i)}trim(u){this.trimNew(u)}set(u,i){return this._limit<=this.size&&!this.has(u)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(u,i),this}}e.MRUCache=I;class g{constructor(){this.map=new Map}add(u){return this.map.set(u,(this.map.get(u)||0)+1),this}delete(u){let i=this.map.get(u)||0;return i===0?!1:(i--,i===0?this.map.delete(u):this.map.set(u,i),!0)}has(u){return this.map.has(u)}}e.CounterSet=g;class v{constructor(u){if(this._m1=new Map,this._m2=new Map,u)for(const[i,n]of u)this.set(i,n)}clear(){this._m1.clear(),this._m2.clear()}set(u,i){this._m1.set(u,i),this._m2.set(i,u)}get(u){return this._m1.get(u)}getKey(u){return this._m2.get(u)}delete(u){const i=this._m1.get(u);return i===void 0?!1:(this._m1.delete(u),this._m2.delete(i),!0)}forEach(u,i){this._m1.forEach((n,t)=>{u.call(i,n,t,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=v;class C{constructor(){this.map=new Map}add(u,i){let n=this.map.get(u);n||(n=new Set,this.map.set(u,n)),n.add(i)}delete(u,i){const n=this.map.get(u);n&&(n.delete(i),n.size===0&&this.map.delete(u))}forEach(u,i){const n=this.map.get(u);n&&n.forEach(i)}get(u){const i=this.map.get(u);return i||new Set}}e.SetMap=C;function S(c,u){if(c===u)return!0;if(c.size!==u.size)return!1;for(const[i,n]of c)if(!u.has(i)||u.get(i)!==n)return!1;for(const[i]of u)if(!c.has(i))return!1;return!0}}),define(ue[2],he([0,1,17,130,31,88,63]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=R,e.trackDisposable=m,e.markAsDisposed=d,e.markAsSingleton=p,e.isDisposable=I,e.dispose=g,e.disposeIfDisposable=v,e.combinedDisposable=C,e.toDisposable=S,e.disposeOnReturn=y;const T=!1;let D=null;class E{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(w){let O=this.livingDisposables.get(w);return O||(O={parent:null,source:null,isSingleton:!1,value:w,idx:E.idx++},this.livingDisposables.set(w,O)),O}trackDisposable(w){const O=this.getDisposableData(w);O.source||(O.source=new Error().stack)}setParent(w,O){const N=this.getDisposableData(w);N.parent=O}markAsDisposed(w){this.livingDisposables.delete(w)}markAsSingleton(w){this.getDisposableData(w).isSingleton=!0}getRootParent(w,O){const N=O.get(w);if(N)return N;const F=w.parent?this.getRootParent(this.getDisposableData(w.parent),O):w;return O.set(w,F),F}getTrackedDisposables(){const w=new Map;return[...this.livingDisposables.entries()].filter(([,N])=>N.source!==null&&!this.getRootParent(N,w).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(w=10,O){let N;if(O)N=O;else{const J=new Map,V=[...this.livingDisposables.values()].filter($=>$.source!==null&&!this.getRootParent($,J).isSingleton);if(V.length===0)return;const te=new Set(V.map($=>$.value));if(N=V.filter($=>!($.parent&&te.has($.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function F(J){function V($,q){for(;$.length>0&&q.some(Z=>typeof Z=="string"?Z===$[0]:$[0].match(Z));)$.shift()}const te=J.source.split(`
`).map($=>$.trim().replace("at ","")).filter($=>$!=="");return V(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const M=new _.SetMap;for(const J of N){const V=F(J);for(let te=0;te<=V.length;te++)M.add(V.slice(0,te).join(`
`),J)}N.sort((0,P.compareBy)(J=>J.idx,P.numberComparator));let H="",z=0;for(const J of N.slice(0,w)){z++;const V=F(J),te=[];for(let $=0;$<V.length;$++){let q=V[$];q=`(shared with ${M.get(V.slice(0,$+1).join(`
`)).size}/${N.length} leaks) at ${q}`;const ne=M.get(V.slice(0,$).join(`
`)),le=(0,a.groupBy)([...ne].map(ee=>F(ee)[$]),ee=>ee);delete le[V[$]];for(const[ee,X]of Object.entries(le))te.unshift(`    - stacktraces of ${X.length} other leaks continue with ${ee}`);te.unshift(q)}H+=`


==================== Leaking disposable ${z}/${N.length}: ${J.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return N.length>w&&(H+=`


... and ${N.length-w} more leaking disposables

`),{leaks:N,details:H}}}e.DisposableTracker=E;function R(b){D=b}if(T){const b="__is_disposable_tracked__";R(new class{trackDisposable(w){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{w[b]||console.log(O)},3e3)}setParent(w,O){if(w&&w!==u.None)try{w[b]=!0}catch{}}markAsDisposed(w){if(w&&w!==u.None)try{w[b]=!0}catch{}}markAsSingleton(w){}})}function m(b){return D?.trackDisposable(b),b}function d(b){D?.markAsDisposed(b)}function f(b,w){D?.setParent(b,w)}function l(b,w){if(D)for(const O of b)D.setParent(O,w)}function p(b){return D?.markAsSingleton(b),b}function I(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function g(b){if(k.Iterable.is(b)){const w=[];for(const O of b)if(O)try{O.dispose()}catch(N){w.push(N)}if(w.length===1)throw w[0];if(w.length>1)throw new AggregateError(w,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function v(b){for(const w of b)I(w)&&w.dispose();return[]}function C(...b){const w=S(()=>g(b));return l(b,w),w}function S(b){const w=m({dispose:(0,L.createSingleCallFunction)(()=>{d(w),b()})});return w}class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,m(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{g(this._toDispose)}finally{this._toDispose.clear()}}add(w){if(!w)return w;if(w===this)throw new Error("Cannot register a disposable on itself!");return f(w,this),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(w),w}delete(w){if(w){if(w===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(w),w.dispose()}}deleteAndLeak(w){w&&this._toDispose.has(w)&&(this._toDispose.delete(w),f(w,null))}}e.DisposableStore=c;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new c,m(this),f(this._store,this)}dispose(){d(this),this._store.dispose()}_register(w){if(w===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(w)}}e.Disposable=u;class i{constructor(){this._isDisposed=!1,m(this)}get value(){return this._isDisposed?void 0:this._value}set value(w){this._isDisposed||w===this._value||(this._value?.dispose(),w&&f(w,this),this._value=w)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const w=this._value;return this._value=void 0,w&&f(w,null),w}}e.MutableDisposable=i;class n{constructor(w){this._disposable=new i,this._isDisposed=!1,this._disposable.value=w}get value(){return this._disposable.value}set value(w){this._isDisposed||w===this._disposable.value||(this._disposable.value=w)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=n;class t{constructor(w){this._disposable=w,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=t;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(w){let O=w;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,d(this))},this}}e.SafeDisposable=s;class r{constructor(){this.references=new Map}acquire(w,...O){let N=this.references.get(w);N||(N={counter:0,object:this.createReferencedObject(w,...O)},this.references.set(w,N));const{object:F}=N,M=(0,L.createSingleCallFunction)(()=>{--N.counter===0&&(this.destroyReferencedObject(w,N.object),this.references.delete(w))});return N.counter++,{object:F,dispose:M}}}e.ReferenceCollection=r;class o{constructor(w){this.referenceCollection=w}async acquire(w,...O){const N=this.referenceCollection.acquire(w,...O);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(F){throw N.dispose(),F}}}e.AsyncReferenceCollection=o;class h{constructor(w){this.object=w}dispose(){}}e.ImmortalReference=h;function y(b){const w=new c;try{b(w)}finally{w.dispose()}}class A{constructor(){this._store=new Map,this._isDisposed=!1,m(this)}dispose(){d(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{g(this._store.values())}finally{this._store.clear()}}has(w){return this._store.has(w)}get size(){return this._store.size}get(w){return this._store.get(w)}set(w,O,N=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this._store.get(w)?.dispose(),this._store.set(w,O)}deleteAndDispose(w){this._store.get(w)?.dispose(),this._store.delete(w)}deleteAndLeak(w){const O=this._store.get(w);return this._store.delete(w),O}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=A}),define(ue[65],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var P;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(P||(e.MarshalledId=P={}))}),define(ue[90],he([0,1,31]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=_,e.normalizeNFD=k;const a=new P.LRUCache(1e4);function _(E){return D(E,"NFC",a)}const L=new P.LRUCache(1e4);function k(E){return D(E,"NFD",L)}const T=/[^\u0000-\u0080]/;function D(E,R,m){if(!E)return E;const d=m.get(E);if(d)return d;let f;return T.test(E)?f=E.normalize(R):f=E,m.set(E,f),f}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(R){return k(R).replace(E,"")}}()}),function(){function ae(_){const L=[];typeof _=="number"&&L.push("code/timeOrigin",_);function k(D){L.push(D,Date.now())}function T(){const D=[];for(let E=0;E<L.length;E+=2)D.push({name:L[E],startTime:L[E+1]});return D}return{mark:k,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const k of performance.getEntriesByType("mark"))L.push({name:k.name,startTime:Math.round(_+k.startTime)});return L}};if(typeof process=="object"){const _=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function P(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=P(a))}(),define(ue[5],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=u,e.isLittleEndian=o,e.isBigSurOrNewer=h,e.LANGUAGE_DEFAULT="en";let P=!1,a=!1,_=!1,L=!1,k=!1,T=!1,D=!1,E=!1,R=!1,m=!1,d,f=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT,p,I;const g=globalThis;let v;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?v=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const C=typeof v?.versions?.electron=="string",S=C&&v?.type==="renderer";if(typeof v=="object"){P=v.platform==="win32",a=v.platform==="darwin",_=v.platform==="linux",L=_&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,D=C,R=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const y=v.env.VSCODE_NLS_CONFIG;if(y)try{const A=JSON.parse(y);d=A.userLocale,l=A.osLocale,f=A.resolvedLanguage||e.LANGUAGE_DEFAULT,p=A.languagePack?.translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!S?(I=navigator.userAgent,P=I.indexOf("Windows")>=0,a=I.indexOf("Macintosh")>=0,E=(I.indexOf("Macintosh")>=0||I.indexOf("iPad")>=0||I.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=I.indexOf("Linux")>=0,m=I?.indexOf("Mobi")>=0,T=!0,f=globalThis._VSCODE_NLS_LANGUAGE||e.LANGUAGE_DEFAULT,d=navigator.language.toLowerCase(),l=d):console.error("Unable to resolve platform.");var c;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(c||(e.Platform=c={}));function u(y){switch(y){case c.Web:return"Web";case c.Mac:return"Mac";case c.Linux:return"Linux";case c.Windows:return"Windows"}}let i=c.Web;a?i=c.Mac:P?i=c.Windows:_&&(i=c.Linux),e.isWindows=P,e.isMacintosh=a,e.isLinux=_,e.isLinuxSnap=L,e.isNative=k,e.isElectron=D,e.isWeb=T,e.isWebWorker=T&&typeof g.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?g.origin:void 0,e.isIOS=E,e.isMobile=m,e.isCI=R,e.platform=i,e.userAgent=I,e.language=f;var n;(function(y){function A(){return e.language}y.value=A;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}y.isDefaultVariant=b;function w(){return e.language==="en"}y.isDefault=w})(n||(e.Language=n={})),e.locale=d,e.platformLocale=l,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof g.postMessage=="function"&&!g.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const y=[];g.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let w=0,O=y.length;w<O;w++){const N=y[w];if(N.id===b.data.vscodeScheduleAsyncWork){y.splice(w,1),N.callback();return}}});let A=0;return b=>{const w=++A;y.push({id:w,callback:b}),g.postMessage({vscodeScheduleAsyncWork:w},"*")}}return y=>setTimeout(y)})();var t;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=a||E?t.Macintosh:P?t.Windows:t.Linux;let s=!0,r=!1;function o(){if(!r){r=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,s=new Uint16Array(y.buffer)[0]===513}return s}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function h(y){return parseFloat(y)>=20}}),define(ue[37],he([0,1,5]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let a;const _=globalThis.vscode;if(typeof _<"u"&&typeof _.process<"u"){const L=_.process;a={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.platform=a.platform,e.arch=a.arch}),define(ue[133],he([0,1,37]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDesktopEnvironment=k;var a;(function(T){T.UNKNOWN="UNKNOWN",T.CINNAMON="CINNAMON",T.DEEPIN="DEEPIN",T.GNOME="GNOME",T.KDE3="KDE3",T.KDE4="KDE4",T.KDE5="KDE5",T.KDE6="KDE6",T.PANTHEON="PANTHEON",T.UNITY="UNITY",T.XFCE="XFCE",T.UKUI="UKUI",T.LXQT="LXQT"})(a||(a={}));const _="XDG_CURRENT_DESKTOP",L="KDE_SESSION_VERSION";function k(){const T=P.env[_];if(T){const E=T.split(":").map(R=>R.trim()).filter(R=>R.length>0);for(const R of E)switch(R){case"Unity":{const m=P.env.DESKTOP_SESSION;return m&&m.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const m=P.env[L];return m==="5"?a.KDE5:m==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const D=P.env.DESKTOP_SESSION;if(D)switch(D){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return L in P.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in P.env?a.GNOME:"KDE_FULL_SESSION"in P.env?L in P.env?a.KDE4:a.KDE3:a.UNKNOWN}});var Tt=this&&this.__createBinding||(Object.create?function(ae,e,P,a){a===void 0&&(a=P);var _=Object.getOwnPropertyDescriptor(e,P);(!_||("get"in _?!e.__esModule:_.writable||_.configurable))&&(_={enumerable:!0,get:function(){return e[P]}}),Object.defineProperty(ae,a,_)}:function(ae,e,P,a){a===void 0&&(a=P),ae[a]=e[P]}),Lt=this&&this.__setModuleDefault||(Object.create?function(ae,e){Object.defineProperty(ae,"default",{enumerable:!0,value:e})}:function(ae,e){ae.default=e}),De=this&&this.__importStar||function(ae){if(ae&&ae.__esModule)return ae;var e={};if(ae!=null)for(var P in ae)P!=="default"&&Object.prototype.hasOwnProperty.call(ae,P)&&Tt(e,ae,P);return Lt(e,ae),e};define(ue[13],he([0,1,37]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,P=De(P);const a=65,_=97,L=90,k=122,T=46,D=47,E=92,R=58,m=63;class d extends Error{constructor(n,t,s){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const o=n.indexOf(".")!==-1?"property":"argument";let h=`The "${n}" ${o} ${r} of type ${t}`;h+=`. Received type ${typeof s}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,n){if(i===null||typeof i!="object")throw new d(n,"Object",i)}function l(i,n){if(typeof i!="string")throw new d(n,"string",i)}const p=P.platform==="win32";function I(i){return i===D||i===E}function g(i){return i===D}function v(i){return i>=a&&i<=L||i>=_&&i<=k}function C(i,n,t,s){let r="",o=0,h=-1,y=0,A=0;for(let b=0;b<=i.length;++b){if(b<i.length)A=i.charCodeAt(b);else{if(s(A))break;A=D}if(s(A)){if(!(h===b-1||y===1))if(y===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==T||r.charCodeAt(r.length-2)!==T){if(r.length>2){const w=r.lastIndexOf(t);w===-1?(r="",o=0):(r=r.slice(0,w),o=r.length-1-r.lastIndexOf(t)),h=b,y=0;continue}else if(r.length!==0){r="",o=0,h=b,y=0;continue}}n&&(r+=r.length>0?`${t}..`:"..",o=2)}else r.length>0?r+=`${t}${i.slice(h+1,b)}`:r=i.slice(h+1,b),o=b-h-1;h=b,y=0}else A===T&&y!==-1?++y:y=-1}return r}function S(i){return i?`${i[0]==="."?"":"."}${i}`:""}function c(i,n){f(n,"pathObject");const t=n.dir||n.root,s=n.base||`${n.name||""}${S(n.ext)}`;return t?t===n.root?`${t}${s}`:`${t}${i}${s}`:s}e.win32={resolve(...i){let n="",t="",s=!1;for(let r=i.length-1;r>=-1;r--){let o;if(r>=0){if(o=i[r],l(o,`paths[${r}]`),o.length===0)continue}else n.length===0?o=P.cwd():(o=P.env[`=${n}`]||P.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==n.toLowerCase()&&o.charCodeAt(2)===E)&&(o=`${n}\\`));const h=o.length;let y=0,A="",b=!1;const w=o.charCodeAt(0);if(h===1)I(w)&&(y=1,b=!0);else if(I(w))if(b=!0,I(o.charCodeAt(1))){let O=2,N=O;for(;O<h&&!I(o.charCodeAt(O));)O++;if(O<h&&O!==N){const F=o.slice(N,O);for(N=O;O<h&&I(o.charCodeAt(O));)O++;if(O<h&&O!==N){for(N=O;O<h&&!I(o.charCodeAt(O));)O++;(O===h||O!==N)&&(A=`\\\\${F}\\${o.slice(N,O)}`,y=O)}}}else y=1;else v(w)&&o.charCodeAt(1)===R&&(A=o.slice(0,2),y=2,h>2&&I(o.charCodeAt(2))&&(b=!0,y=3));if(A.length>0)if(n.length>0){if(A.toLowerCase()!==n.toLowerCase())continue}else n=A;if(s){if(n.length>0)break}else if(t=`${o.slice(y)}\\${t}`,s=b,b&&n.length>0)break}return t=C(t,!s,"\\",I),s?`${n}\\${t}`:`${n}${t}`||"."},normalize(i){l(i,"path");const n=i.length;if(n===0)return".";let t=0,s,r=!1;const o=i.charCodeAt(0);if(n===1)return g(o)?"\\":i;if(I(o))if(r=!0,I(i.charCodeAt(1))){let y=2,A=y;for(;y<n&&!I(i.charCodeAt(y));)y++;if(y<n&&y!==A){const b=i.slice(A,y);for(A=y;y<n&&I(i.charCodeAt(y));)y++;if(y<n&&y!==A){for(A=y;y<n&&!I(i.charCodeAt(y));)y++;if(y===n)return`\\\\${b}\\${i.slice(A)}\\`;y!==A&&(s=`\\\\${b}\\${i.slice(A,y)}`,t=y)}}}else t=1;else v(o)&&i.charCodeAt(1)===R&&(s=i.slice(0,2),t=2,n>2&&I(i.charCodeAt(2))&&(r=!0,t=3));let h=t<n?C(i.slice(t),!r,"\\",I):"";return h.length===0&&!r&&(h="."),h.length>0&&I(i.charCodeAt(n-1))&&(h+="\\"),s===void 0?r?`\\${h}`:h:r?`${s}\\${h}`:`${s}${h}`},isAbsolute(i){l(i,"path");const n=i.length;if(n===0)return!1;const t=i.charCodeAt(0);return I(t)||n>2&&v(t)&&i.charCodeAt(1)===R&&I(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,t;for(let o=0;o<i.length;++o){const h=i[o];l(h,"path"),h.length>0&&(n===void 0?n=t=h:n+=`\\${h}`)}if(n===void 0)return".";let s=!0,r=0;if(typeof t=="string"&&I(t.charCodeAt(0))){++r;const o=t.length;o>1&&I(t.charCodeAt(1))&&(++r,o>2&&(I(t.charCodeAt(2))?++r:s=!1))}if(s){for(;r<n.length&&I(n.charCodeAt(r));)r++;r>=2&&(n=`\\${n.slice(r)}`)}return e.win32.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n)return"";const t=e.win32.resolve(i),s=e.win32.resolve(n);if(t===s||(i=t.toLowerCase(),n=s.toLowerCase(),i===n))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===E;)r++;let o=i.length;for(;o-1>r&&i.charCodeAt(o-1)===E;)o--;const h=o-r;let y=0;for(;y<n.length&&n.charCodeAt(y)===E;)y++;let A=n.length;for(;A-1>y&&n.charCodeAt(A-1)===E;)A--;const b=A-y,w=h<b?h:b;let O=-1,N=0;for(;N<w;N++){const M=i.charCodeAt(r+N);if(M!==n.charCodeAt(y+N))break;M===E&&(O=N)}if(N!==w){if(O===-1)return s}else{if(b>w){if(n.charCodeAt(y+N)===E)return s.slice(y+N+1);if(N===2)return s.slice(y+N)}h>w&&(i.charCodeAt(r+N)===E?O=N:N===2&&(O=3)),O===-1&&(O=0)}let F="";for(N=r+O+1;N<=o;++N)(N===o||i.charCodeAt(N)===E)&&(F+=F.length===0?"..":"\\..");return y+=O,F.length>0?`${F}${s.slice(y,A)}`:(s.charCodeAt(y)===E&&++y,s.slice(y,A))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.win32.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===E){if(n.charCodeAt(1)===E){const t=n.charCodeAt(2);if(t!==m&&t!==T)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(v(n.charCodeAt(0))&&n.charCodeAt(1)===R&&n.charCodeAt(2)===E)return`\\\\?\\${n}`;return i},dirname(i){l(i,"path");const n=i.length;if(n===0)return".";let t=-1,s=0;const r=i.charCodeAt(0);if(n===1)return I(r)?i:".";if(I(r)){if(t=s=1,I(i.charCodeAt(1))){let y=2,A=y;for(;y<n&&!I(i.charCodeAt(y));)y++;if(y<n&&y!==A){for(A=y;y<n&&I(i.charCodeAt(y));)y++;if(y<n&&y!==A){for(A=y;y<n&&!I(i.charCodeAt(y));)y++;if(y===n)return i;y!==A&&(t=s=y+1)}}}}else v(r)&&i.charCodeAt(1)===R&&(t=n>2&&I(i.charCodeAt(2))?3:2,s=t);let o=-1,h=!0;for(let y=n-1;y>=s;--y)if(I(i.charCodeAt(y))){if(!h){o=y;break}}else h=!1;if(o===-1){if(t===-1)return".";o=t}return i.slice(0,o)},basename(i,n){n!==void 0&&l(n,"suffix"),l(i,"path");let t=0,s=-1,r=!0,o;if(i.length>=2&&v(i.charCodeAt(0))&&i.charCodeAt(1)===R&&(t=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let h=n.length-1,y=-1;for(o=i.length-1;o>=t;--o){const A=i.charCodeAt(o);if(I(A)){if(!r){t=o+1;break}}else y===-1&&(r=!1,y=o+1),h>=0&&(A===n.charCodeAt(h)?--h===-1&&(s=o):(h=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=t;--o)if(I(i.charCodeAt(o))){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=0,t=-1,s=0,r=-1,o=!0,h=0;i.length>=2&&i.charCodeAt(1)===R&&v(i.charCodeAt(0))&&(n=s=2);for(let y=i.length-1;y>=n;--y){const A=i.charCodeAt(y);if(I(A)){if(!o){s=y+1;break}continue}r===-1&&(o=!1,r=y+1),A===T?t===-1?t=y:h!==1&&(h=1):t!==-1&&(h=-1)}return t===-1||r===-1||h===0||h===1&&t===r-1&&t===s+1?"":i.slice(t,r)},format:c.bind(null,"\\"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.length;let s=0,r=i.charCodeAt(0);if(t===1)return I(r)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(I(r)){if(s=1,I(i.charCodeAt(1))){let O=2,N=O;for(;O<t&&!I(i.charCodeAt(O));)O++;if(O<t&&O!==N){for(N=O;O<t&&I(i.charCodeAt(O));)O++;if(O<t&&O!==N){for(N=O;O<t&&!I(i.charCodeAt(O));)O++;O===t?s=O:O!==N&&(s=O+1)}}}}else if(v(r)&&i.charCodeAt(1)===R){if(t<=2)return n.root=n.dir=i,n;if(s=2,I(i.charCodeAt(2))){if(t===3)return n.root=n.dir=i,n;s=3}}s>0&&(n.root=i.slice(0,s));let o=-1,h=s,y=-1,A=!0,b=i.length-1,w=0;for(;b>=s;--b){if(r=i.charCodeAt(b),I(r)){if(!A){h=b+1;break}continue}y===-1&&(A=!1,y=b+1),r===T?o===-1?o=b:w!==1&&(w=1):o!==-1&&(w=-1)}return y!==-1&&(o===-1||w===0||w===1&&o===y-1&&o===h+1?n.base=n.name=i.slice(h,y):(n.name=i.slice(h,o),n.base=i.slice(h,y),n.ext=i.slice(o,y))),h>0&&h!==s?n.dir=i.slice(0,h-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(p){const i=/\\/g;return()=>{const n=P.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>P.cwd()})();e.posix={resolve(...i){let n="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const r=s>=0?i[s]:u();l(r,`paths[${s}]`),r.length!==0&&(n=`${r}/${n}`,t=r.charCodeAt(0)===D)}return n=C(n,!t,"/",g),t?`/${n}`:n.length>0?n:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===D,t=i.charCodeAt(i.length-1)===D;return i=C(i,!n,"/",g),i.length===0?n?"/":t?"./":".":(t&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===D},join(...i){if(i.length===0)return".";let n;for(let t=0;t<i.length;++t){const s=i[t];l(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.posix.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n||(i=e.posix.resolve(i),n=e.posix.resolve(n),i===n))return"";const t=1,s=i.length,r=s-t,o=1,h=n.length-o,y=r<h?r:h;let A=-1,b=0;for(;b<y;b++){const O=i.charCodeAt(t+b);if(O!==n.charCodeAt(o+b))break;O===D&&(A=b)}if(b===y)if(h>y){if(n.charCodeAt(o+b)===D)return n.slice(o+b+1);if(b===0)return n.slice(o+b)}else r>y&&(i.charCodeAt(t+b)===D?A=b:b===0&&(A=0));let w="";for(b=t+A+1;b<=s;++b)(b===s||i.charCodeAt(b)===D)&&(w+=w.length===0?"..":"/..");return`${w}${n.slice(o+A)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===D;let t=-1,s=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===D){if(!s){t=r;break}}else s=!1;return t===-1?n?"/":".":n&&t===1?"//":i.slice(0,t)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let t=0,s=-1,r=!0,o;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let h=n.length-1,y=-1;for(o=i.length-1;o>=0;--o){const A=i.charCodeAt(o);if(A===D){if(!r){t=o+1;break}}else y===-1&&(r=!1,y=o+1),h>=0&&(A===n.charCodeAt(h)?--h===-1&&(s=o):(h=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=0;--o)if(i.charCodeAt(o)===D){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=-1,t=0,s=-1,r=!0,o=0;for(let h=i.length-1;h>=0;--h){const y=i.charCodeAt(h);if(y===D){if(!r){t=h+1;break}continue}s===-1&&(r=!1,s=h+1),y===T?n===-1?n=h:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||s===-1||o===0||o===1&&n===s-1&&n===t+1?"":i.slice(n,s)},format:c.bind(null,"/"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.charCodeAt(0)===D;let s;t?(n.root="/",s=1):s=0;let r=-1,o=0,h=-1,y=!0,A=i.length-1,b=0;for(;A>=s;--A){const w=i.charCodeAt(A);if(w===D){if(!y){o=A+1;break}continue}h===-1&&(y=!1,h=A+1),w===T?r===-1?r=A:b!==1&&(b=1):r!==-1&&(b=-1)}if(h!==-1){const w=o===0&&t?1:o;r===-1||b===0||b===1&&r===h-1&&r===o+1?n.base=n.name=i.slice(w,h):(n.name=i.slice(w,r),n.base=i.slice(w,h),n.ext=i.slice(r,h))}return o>0?n.dir=i.slice(0,o-1):t&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(ue[134],he([0,1,13]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=L,e.getMediaMime=k,e.getExtensionForMimeType=T,e.normalizeMimeType=E,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},_={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const m=(0,P.extname)(R),d=a[m.toLowerCase()];return d!==void 0?d:k(R)}function k(R){const m=(0,P.extname)(R);return _[m.toLowerCase()]}function T(R){for(const m in _)if(_[m]===R)return m}const D=/^(.+)\/(.+?)(;.+)?$/;function E(R,m){const d=D.exec(R);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:m?void 0:R}}),define(ue[91],he([0,1,5]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=L,e.removeDangerousEnvVariables=k;var a;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(a||(e.Source=a={}));var _;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(_||(e.TerminateResponseCode=_={}));function L(T,...D){const E=D.reduce((d,f)=>(d[f]=!0,d),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(d=>!E[d]).forEach(d=>{for(let f=0;f<R.length;f++)if(d.search(R[f])!==-1){delete T[d];break}})}function k(T){T&&(delete T.DEBUG,P.isLinux&&delete T.LD_PRELOAD)}}),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var a in P)(typeof exports=="object"?exports:ae)[a]=P[a]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function P(a){if(e[a])return e[a].exports;var _=e[a]={i:a,l:!1,exports:{}};return ae[a].call(_.exports,_,_.exports,P),_.l=!0,_.exports}return P.m=ae,P.c=e,P.d=function(a,_,L){P.o(a,_)||Object.defineProperty(a,_,{enumerable:!0,get:L})},P.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},P.t=function(a,_){if(1&_&&(a=P(a)),8&_||4&_&&typeof a=="object"&&a&&a.__esModule)return a;var L=Object.create(null);if(P.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:a}),2&_&&typeof a!="string")for(var k in a)P.d(L,k,function(T){return a[T]}.bind(null,k));return L},P.n=function(a){var _=a&&a.__esModule?function(){return a.default}:function(){return a};return P.d(_,"a",_),_},P.o=function(a,_){return Object.prototype.hasOwnProperty.call(a,_)},P.p="",P(P.s=0)}([function(ae,e,P){(function(a){var _;e=ae.exports=X,_=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],D=e.src=[],E=0,R=E++;D[R]="0|[1-9]\\d*";var m=E++;D[m]="[0-9]+";var d=E++;D[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=E++;D[f]="("+D[R]+")\\.("+D[R]+")\\.("+D[R]+")";var l=E++;D[l]="("+D[m]+")\\.("+D[m]+")\\.("+D[m]+")";var p=E++;D[p]="(?:"+D[R]+"|"+D[d]+")";var I=E++;D[I]="(?:"+D[m]+"|"+D[d]+")";var g=E++;D[g]="(?:-("+D[p]+"(?:\\."+D[p]+")*))";var v=E++;D[v]="(?:-?("+D[I]+"(?:\\."+D[I]+")*))";var C=E++;D[C]="[0-9A-Za-z-]+";var S=E++;D[S]="(?:\\+("+D[C]+"(?:\\."+D[C]+")*))";var c=E++,u="v?"+D[f]+D[g]+"?"+D[S]+"?";D[c]="^"+u+"$";var i="[v=\\s]*"+D[l]+D[v]+"?"+D[S]+"?",n=E++;D[n]="^"+i+"$";var t=E++;D[t]="((?:<|>)?=?)";var s=E++;D[s]=D[m]+"|x|X|\\*";var r=E++;D[r]=D[R]+"|x|X|\\*";var o=E++;D[o]="[v=\\s]*("+D[r]+")(?:\\.("+D[r]+")(?:\\.("+D[r]+")(?:"+D[g]+")?"+D[S]+"?)?)?";var h=E++;D[h]="[v=\\s]*("+D[s]+")(?:\\.("+D[s]+")(?:\\.("+D[s]+")(?:"+D[v]+")?"+D[S]+"?)?)?";var y=E++;D[y]="^"+D[t]+"\\s*"+D[o]+"$";var A=E++;D[A]="^"+D[t]+"\\s*"+D[h]+"$";var b=E++;D[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=E++;D[w]="(?:~>?)";var O=E++;D[O]="(\\s*)"+D[w]+"\\s+",T[O]=new RegExp(D[O],"g");var N=E++;D[N]="^"+D[w]+D[o]+"$";var F=E++;D[F]="^"+D[w]+D[h]+"$";var M=E++;D[M]="(?:\\^)";var H=E++;D[H]="(\\s*)"+D[M]+"\\s+",T[H]=new RegExp(D[H],"g");var z=E++;D[z]="^"+D[M]+D[o]+"$";var J=E++;D[J]="^"+D[M]+D[h]+"$";var V=E++;D[V]="^"+D[t]+"\\s*("+i+")$|^$";var te=E++;D[te]="^"+D[t]+"\\s*("+u+")$|^$";var $=E++;D[$]="(\\s*)"+D[t]+"\\s*("+i+"|"+D[o]+")",T[$]=new RegExp(D[$],"g");var q=E++;D[q]="^\\s*("+D[o]+")\\s+-\\s+("+D[o]+")\\s*$";var Z=E++;D[Z]="^\\s*("+D[h]+")\\s+-\\s+("+D[h]+")\\s*$";var ne=E++;D[ne]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)_(le,D[le]),T[le]||(T[le]=new RegExp(D[le]));function ee(re,fe){if(re instanceof X)return re;if(typeof re!="string"||re.length>L||!(fe?T[n]:T[c]).test(re))return null;try{return new X(re,fe)}catch{return null}}function X(re,fe){if(re instanceof X){if(re.loose===fe)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof X))return new X(re,fe);_("SemVer",re,fe),this.loose=fe;var me=re.trim().match(fe?T[n]:T[c]);if(!me)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Te=+Pe;if(Te>=0&&Te<k)return Te}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=ee,e.valid=function(re,fe){var me=ee(re,fe);return me?me.version:null},e.clean=function(re,fe){var me=ee(re.trim().replace(/^[=v]+/,""),fe);return me?me.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(re){return _("SemVer.compare",this.version,this.loose,re),re instanceof X||(re=new X(re,this.loose)),this.compareMain(re)||this.comparePre(re)},X.prototype.compareMain=function(re){return re instanceof X||(re=new X(re,this.loose)),W(this.major,re.major)||W(this.minor,re.minor)||W(this.patch,re.patch)},X.prototype.comparePre=function(re){if(re instanceof X||(re=new X(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var fe=0;do{var me=this.prerelease[fe],Pe=re.prerelease[fe];if(_("prerelease compare",fe,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return W(me,Pe)}while(++fe)},X.prototype.inc=function(re,fe){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,fe,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new X(re,me).inc(fe,Pe).version}catch{return null}},e.diff=function(re,fe){if(x(re,fe))return null;var me=ee(re),Pe=ee(fe);if(me.prerelease.length||Pe.prerelease.length){for(var Te in me)if((Te==="major"||Te==="minor"||Te==="patch")&&me[Te]!==Pe[Te])return"pre"+Te;return"prerelease"}for(var Te in me)if((Te==="major"||Te==="minor"||Te==="patch")&&me[Te]!==Pe[Te])return Te},e.compareIdentifiers=W;var K=/^[0-9]+$/;function W(re,fe){var me=K.test(re),Pe=K.test(fe);return me&&Pe&&(re=+re,fe=+fe),me&&!Pe?-1:Pe&&!me?1:re<fe?-1:re>fe?1:0}function U(re,fe,me){return new X(re,me).compare(new X(fe,me))}function Y(re,fe,me){return U(re,fe,me)>0}function oe(re,fe,me){return U(re,fe,me)<0}function x(re,fe,me){return U(re,fe,me)===0}function B(re,fe,me){return U(re,fe,me)!==0}function j(re,fe,me){return U(re,fe,me)>=0}function G(re,fe,me){return U(re,fe,me)<=0}function ie(re,fe,me,Pe){var Te;switch(fe){case"===":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),Te=re===me;break;case"!==":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),Te=re!==me;break;case"":case"=":case"==":Te=x(re,me,Pe);break;case"!=":Te=B(re,me,Pe);break;case">":Te=Y(re,me,Pe);break;case">=":Te=j(re,me,Pe);break;case"<":Te=oe(re,me,Pe);break;case"<=":Te=G(re,me,Pe);break;default:throw new TypeError("Invalid operator: "+fe)}return Te}function ce(re,fe){if(re instanceof ce){if(re.loose===fe)return re;re=re.value}if(!(this instanceof ce))return new ce(re,fe);_("comparator",re,fe),this.loose=fe,this.parse(re),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,_("comp",this)}e.rcompareIdentifiers=function(re,fe){return W(fe,re)},e.major=function(re,fe){return new X(re,fe).major},e.minor=function(re,fe){return new X(re,fe).minor},e.patch=function(re,fe){return new X(re,fe).patch},e.compare=U,e.compareLoose=function(re,fe){return U(re,fe,!0)},e.rcompare=function(re,fe,me){return U(fe,re,me)},e.sort=function(re,fe){return re.sort(function(me,Pe){return e.compare(me,Pe,fe)})},e.rsort=function(re,fe){return re.sort(function(me,Pe){return e.rcompare(me,Pe,fe)})},e.gt=Y,e.lt=oe,e.eq=x,e.neq=B,e.gte=j,e.lte=G,e.cmp=ie,e.Comparator=ce;var ge={};function Se(re,fe){if(re instanceof Se)return re.loose===fe?re:new Se(re.raw,fe);if(re instanceof ce)return new Se(re.value,fe);if(!(this instanceof Se))return new Se(re,fe);if(this.loose=fe,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function Ie(re){return!re||re.toLowerCase()==="x"||re==="*"}function Ce(re,fe,me,Pe,Te,Ue,ke,_e,Ne,$e,ze,Me,We){return((fe=Ie(me)?"":Ie(Pe)?">="+me+".0.0":Ie(Te)?">="+me+"."+Pe+".0":">="+fe)+" "+(_e=Ie(Ne)?"":Ie($e)?"<"+(+Ne+1)+".0.0":Ie(ze)?"<"+Ne+"."+(+$e+1)+".0":Me?"<="+Ne+"."+$e+"."+ze+"-"+Me:"<="+_e)).trim()}function Ee(re,fe){for(var me=0;me<re.length;me++)if(!re[me].test(fe))return!1;if(fe.prerelease.length){for(me=0;me<re.length;me++)if(_(re[me].semver),re[me].semver!==ge&&re[me].semver.prerelease.length>0){var Pe=re[me].semver;if(Pe.major===fe.major&&Pe.minor===fe.minor&&Pe.patch===fe.patch)return!0}return!1}return!0}function ve(re,fe,me){try{fe=new Se(fe,me)}catch{return!1}return fe.test(re)}function be(re,fe,me,Pe){var Te,Ue,ke,_e,Ne;switch(re=new X(re,Pe),fe=new Se(fe,Pe),me){case">":Te=Y,Ue=G,ke=oe,_e=">",Ne=">=";break;case"<":Te=oe,Ue=j,ke=Y,_e="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(re,fe,Pe))return!1;for(var $e=0;$e<fe.set.length;++$e){var ze=fe.set[$e],Me=null,We=null;if(ze.forEach(function(qe){qe.semver===ge&&(qe=new ce(">=0.0.0")),Me=Me||qe,We=We||qe,Te(qe.semver,Me.semver,Pe)?Me=qe:ke(qe.semver,We.semver,Pe)&&(We=qe)}),Me.operator===_e||Me.operator===Ne||(!We.operator||We.operator===_e)&&Ue(re,We.semver)||We.operator===Ne&&ke(re,We.semver))return!1}return!0}ce.prototype.parse=function(re){var fe=this.loose?T[V]:T[te],me=re.match(fe);if(!me)throw new TypeError("Invalid comparator: "+re);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new X(me[2],this.loose):this.semver=ge},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(re){return _("Comparator.test",re,this.loose),this.semver===ge||(typeof re=="string"&&(re=new X(re,this.loose)),ie(re,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(re,fe){if(!(re instanceof ce))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new Se(re.value,fe),ve(this.value,me,fe);if(re.operator==="")return me=new Se(this.value,fe),ve(re.semver,me,fe);var Pe=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Ue=this.semver.version===re.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),_e=ie(this.semver,"<",re.semver,fe)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),Ne=ie(this.semver,">",re.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return Pe||Te||Ue&&ke||_e||Ne},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(re){var fe=this.loose;re=re.trim(),_("range",re,fe);var me=fe?T[Z]:T[q];re=re.replace(me,Ce),_("hyphen replace",re),re=re.replace(T[$],"$1$2$3"),_("comparator trim",re,T[$]),re=(re=(re=re.replace(T[O],"$1~")).replace(T[H],"$1^")).split(/\s+/).join(" ");var Pe=fe?T[V]:T[te],Te=re.split(" ").map(function(Ue){return function(ke,_e){return _("comp",ke),ke=function(Ne,$e){return Ne.trim().split(/\s+/).map(function(ze){return function(Me,We){_("caret",Me,We);var qe=We?T[J]:T[z];return Me.replace(qe,function(Be,Ae,se,de,pe){var ye;return _("caret",Me,Be,Ae,se,de,pe),Ie(Ae)?ye="":Ie(se)?ye=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Ie(de)?ye=Ae==="0"?">="+Ae+"."+se+".0 <"+Ae+"."+(+se+1)+".0":">="+Ae+"."+se+".0 <"+(+Ae+1)+".0.0":pe?(_("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=Ae==="0"?se==="0"?">="+Ae+"."+se+"."+de+pe+" <"+Ae+"."+se+"."+(+de+1):">="+Ae+"."+se+"."+de+pe+" <"+Ae+"."+(+se+1)+".0":">="+Ae+"."+se+"."+de+pe+" <"+(+Ae+1)+".0.0"):(_("no pr"),ye=Ae==="0"?se==="0"?">="+Ae+"."+se+"."+de+" <"+Ae+"."+se+"."+(+de+1):">="+Ae+"."+se+"."+de+" <"+Ae+"."+(+se+1)+".0":">="+Ae+"."+se+"."+de+" <"+(+Ae+1)+".0.0"),_("caret return",ye),ye})}(ze,$e)}).join(" ")}(ke,_e),_("caret",ke),ke=function(Ne,$e){return Ne.trim().split(/\s+/).map(function(ze){return function(Me,We){var qe=We?T[F]:T[N];return Me.replace(qe,function(Be,Ae,se,de,pe){var ye;return _("tilde",Me,Be,Ae,se,de,pe),Ie(Ae)?ye="":Ie(se)?ye=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Ie(de)?ye=">="+Ae+"."+se+".0 <"+Ae+"."+(+se+1)+".0":pe?(_("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+Ae+"."+se+"."+de+pe+" <"+Ae+"."+(+se+1)+".0"):ye=">="+Ae+"."+se+"."+de+" <"+Ae+"."+(+se+1)+".0",_("tilde return",ye),ye})}(ze,$e)}).join(" ")}(ke,_e),_("tildes",ke),ke=function(Ne,$e){return _("replaceXRanges",Ne,$e),Ne.split(/\s+/).map(function(ze){return function(Me,We){Me=Me.trim();var qe=We?T[A]:T[y];return Me.replace(qe,function(Be,Ae,se,de,pe,ye){_("xRange",Me,Be,Ae,se,de,pe,ye);var Le=Ie(se),Oe=Le||Ie(de),xe=Oe||Ie(pe);return Ae==="="&&xe&&(Ae=""),Le?Be=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&xe?(Oe&&(de=0),xe&&(pe=0),Ae===">"?(Ae=">=",Oe?(se=+se+1,de=0,pe=0):xe&&(de=+de+1,pe=0)):Ae==="<="&&(Ae="<",Oe?se=+se+1:de=+de+1),Be=Ae+se+"."+de+"."+pe):Oe?Be=">="+se+".0.0 <"+(+se+1)+".0.0":xe&&(Be=">="+se+"."+de+".0 <"+se+"."+(+de+1)+".0"),_("xRange return",Be),Be})}(ze,$e)}).join(" ")}(ke,_e),_("xrange",ke),ke=function(Ne,$e){return _("replaceStars",Ne,$e),Ne.trim().replace(T[ne],"")}(ke,_e),_("stars",ke),ke}(Ue,fe)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(Ue){return!!Ue.match(Pe)})),Te=Te.map(function(Ue){return new ce(Ue,fe)})},Se.prototype.intersects=function(re,fe){if(!(re instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return re.set.some(function(Te){return Te.every(function(Ue){return Pe.intersects(Ue,fe)})})})})},e.toComparators=function(re,fe){return new Se(re,fe).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new X(re,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Ee(this.set[fe],re))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(re,fe,me){var Pe=null,Te=null;try{var Ue=new Se(fe,me)}catch{return null}return re.forEach(function(ke){Ue.test(ke)&&(Pe&&Te.compare(ke)!==-1||(Te=new X(Pe=ke,me)))}),Pe},e.minSatisfying=function(re,fe,me){var Pe=null,Te=null;try{var Ue=new Se(fe,me)}catch{return null}return re.forEach(function(ke){Ue.test(ke)&&(Pe&&Te.compare(ke)!==1||(Te=new X(Pe=ke,me)))}),Pe},e.validRange=function(re,fe){try{return new Se(re,fe).range||"*"}catch{return null}},e.ltr=function(re,fe,me){return be(re,fe,"<",me)},e.gtr=function(re,fe,me){return be(re,fe,">",me)},e.outside=be,e.prerelease=function(re,fe){var me=ee(re,fe);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(re,fe,me){return re=new Se(re,me),fe=new Se(fe,me),re.intersects(fe)},e.coerce=function(re){if(re instanceof X)return re;if(typeof re!="string")return null;var fe=re.match(T[b]);return fe==null?null:ee((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,P(1))},function(ae,e){var P,a,_=ae.exports={};function L(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function T(I){if(P===setTimeout)return setTimeout(I,0);if((P===L||!P)&&setTimeout)return P=setTimeout,setTimeout(I,0);try{return P(I,0)}catch{try{return P.call(null,I,0)}catch{return P.call(this,I,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:L}catch{P=L}try{a=typeof clearTimeout=="function"?clearTimeout:k}catch{a=k}})();var D,E=[],R=!1,m=-1;function d(){R&&D&&(R=!1,D.length?E=D.concat(E):m=-1,E.length&&f())}function f(){if(!R){var I=T(d);R=!0;for(var g=E.length;g;){for(D=E,E=[];++m<g;)D&&D[m].run();m=-1,g=E.length}D=null,R=!1,function(v){if(a===clearTimeout)return clearTimeout(v);if((a===k||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(v);try{a(v)}catch{try{return a.call(null,v)}catch{return a.call(this,v)}}}(I)}}function l(I,g){this.fun=I,this.array=g}function p(){}_.nextTick=function(I){var g=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)g[v-1]=arguments[v];E.push(new l(I,g)),E.length!==1||R||T(f)},l.prototype.run=function(){this.fun.apply(null,this.array)},_.title="browser",_.browser=!0,_.env={},_.argv=[],_.version="",_.versions={},_.on=p,_.addListener=p,_.once=p,_.off=p,_.removeListener=p,_.removeAllListeners=p,_.emit=p,_.prependListener=p,_.prependOnceListener=p,_.listeners=function(I){return[]},_.binding=function(I){throw new Error("process.binding is not supported")},_.cwd=function(){return"/"},_.chdir=function(I){throw new Error("process.chdir is not supported")},_.umask=function(){return 0}}])}),define(ue[135],he([0,1]),function(ae,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class a{constructor(T,D,E){this.level=T,this.key=D,this.value=E,this.forward=[]}}const _=void 0;class L{constructor(T,D=2**16){this.comparator=T,this[P]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(D)|0),this._header=new a(this._maxLevel,_,_)}get size(){return this._size}clear(){this._header=new a(this._maxLevel,_,_),this._size=0}has(T){return!!L._search(this,T,this.comparator)}get(T){return L._search(this,T,this.comparator)?.value}set(T,D){return L._insert(this,T,D,this.comparator)&&(this._size+=1),this}delete(T){const D=L._delete(this,T,this.comparator);return D&&(this._size-=1),D}forEach(T,D){let E=this._header.forward[0];for(;E;)T.call(D,E.value,E.key,this),E=E.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let T=this._header.forward[0];for(;T;)yield[T.key,T.value],T=T.forward[0]}*keys(){let T=this._header.forward[0];for(;T;)yield T.key,T=T.forward[0]}*values(){let T=this._header.forward[0];for(;T;)yield T.value,T=T.forward[0]}toString(){let T="[SkipList]:",D=this._header.forward[0];for(;D;)T+=`node(${D.key}, ${D.value}, lvl:${D.level})`,D=D.forward[0];return T}static _search(T,D,E){let R=T._header;for(let m=T._level-1;m>=0;m--)for(;R.forward[m]&&E(R.forward[m].key,D)<0;)R=R.forward[m];if(R=R.forward[0],R&&E(R.key,D)===0)return R}static _insert(T,D,E,R){const m=[];let d=T._header;for(let f=T._level-1;f>=0;f--){for(;d.forward[f]&&R(d.forward[f].key,D)<0;)d=d.forward[f];m[f]=d}if(d=d.forward[0],d&&R(d.key,D)===0)return d.value=E,!1;{const f=L._randomLevel(T);if(f>T._level){for(let l=T._level;l<f;l++)m[l]=T._header;T._level=f}d=new a(f,D,E);for(let l=0;l<f;l++)d.forward[l]=m[l].forward[l],m[l].forward[l]=d;return!0}}static _randomLevel(T,D=.5){let E=1;for(;Math.random()<D&&E<T._maxLevel;)E+=1;return E}static _delete(T,D,E){const R=[];let m=T._header;for(let d=T._level-1;d>=0;d--){for(;m.forward[d]&&E(m.forward[d].key,D)<0;)m=m.forward[d];R[d]=m}if(m=m.forward[0],!m||E(m.key,D)!==0)return!1;for(let d=0;d<T._level&&R[d].forward[d]===m;d++)R[d].forward[d]=m.forward[d];for(;T._level>0&&T._header.forward[T._level-1]===_;)T._level-=1;return!0}}e.SkipList=L}),define(ue[54],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(L){return new a(L)}constructor(L){this._now=P&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=a}),define(ue[3],he([0,1,8,88,2,89,54]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=f;const T=!1,D=!1,E=!1;var R;(function(F){F.None=()=>_.Disposable.None;function M(Ee){if(E){const{onDidAddListener:ve}=Ee,be=p.create();let re=0;Ee.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),ve?.()}}}function H(Ee,ve){return ee(Ee,()=>{},0,void 0,!0,void 0,ve)}F.defer=H;function z(Ee){return(ve,be=null,re)=>{let fe=!1,me;return me=Ee(Pe=>{if(!fe)return me?me.dispose():fe=!0,ve.call(be,Pe)},null,re),fe&&me.dispose(),me}}F.once=z;function J(Ee,ve,be){return ne((re,fe=null,me)=>Ee(Pe=>re.call(fe,ve(Pe)),null,me),be)}F.map=J;function V(Ee,ve,be){return ne((re,fe=null,me)=>Ee(Pe=>{ve(Pe),re.call(fe,Pe)},null,me),be)}F.forEach=V;function te(Ee,ve,be){return ne((re,fe=null,me)=>Ee(Pe=>ve(Pe)&&re.call(fe,Pe),null,me),be)}F.filter=te;function $(Ee){return Ee}F.signal=$;function q(...Ee){return(ve,be=null,re)=>{const fe=(0,_.combinedDisposable)(...Ee.map(me=>me(Pe=>ve.call(be,Pe))));return le(fe,re)}}F.any=q;function Z(Ee,ve,be,re){let fe=be;return J(Ee,me=>(fe=ve(fe,me),fe),re)}F.reduce=Z;function ne(Ee,ve){let be;const re={onWillAddFirstListener(){be=Ee(fe.fire,fe)},onDidRemoveLastListener(){be?.dispose()}};ve||M(re);const fe=new i(re);return ve?.add(fe),fe.event}function le(Ee,ve){return ve instanceof Array?ve.push(Ee):ve&&ve.add(Ee),Ee}function ee(Ee,ve,be=100,re=!1,fe=!1,me,Pe){let Te,Ue,ke,_e=0,Ne;const $e={leakWarningThreshold:me,onWillAddFirstListener(){Te=Ee(Me=>{_e++,Ue=ve(Ue,Me),re&&!ke&&(ze.fire(Ue),Ue=void 0),Ne=()=>{const We=Ue;Ue=void 0,ke=void 0,(!re||_e>1)&&ze.fire(We),_e=0},typeof be=="number"?(clearTimeout(ke),ke=setTimeout(Ne,be)):ke===void 0&&(ke=0,queueMicrotask(Ne))})},onWillRemoveListener(){fe&&_e>0&&Ne?.()},onDidRemoveLastListener(){Ne=void 0,Te.dispose()}};Pe||M($e);const ze=new i($e);return Pe?.add(ze),ze.event}F.debounce=ee;function X(Ee,ve=0,be){return F.debounce(Ee,(re,fe)=>re?(re.push(fe),re):[fe],ve,void 0,!0,void 0,be)}F.accumulate=X;function K(Ee,ve=(re,fe)=>re===fe,be){let re=!0,fe;return te(Ee,me=>{const Pe=re||!ve(me,fe);return re=!1,fe=me,Pe},be)}F.latch=K;function W(Ee,ve,be){return[F.filter(Ee,ve,be),F.filter(Ee,re=>!ve(re),be)]}F.split=W;function U(Ee,ve=!1,be=[],re){let fe=be.slice(),me=Ee(Ue=>{fe?fe.push(Ue):Te.fire(Ue)});re&&re.add(me);const Pe=()=>{fe?.forEach(Ue=>Te.fire(Ue)),fe=null},Te=new i({onWillAddFirstListener(){me||(me=Ee(Ue=>Te.fire(Ue)),re&&re.add(me))},onDidAddFirstListener(){fe&&(ve?setTimeout(Pe):Pe())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return re&&re.add(Te),Te.event}F.buffer=U;function Y(Ee,ve){return(re,fe,me)=>{const Pe=ve(new x);return Ee(function(Te){const Ue=Pe.evaluate(Te);Ue!==oe&&re.call(fe,Ue)},void 0,me)}}F.chain=Y;const oe=Symbol("HaltChainable");class x{constructor(){this.steps=[]}map(ve){return this.steps.push(ve),this}forEach(ve){return this.steps.push(be=>(ve(be),be)),this}filter(ve){return this.steps.push(be=>ve(be)?be:oe),this}reduce(ve,be){let re=be;return this.steps.push(fe=>(re=ve(re,fe),re)),this}latch(ve=(be,re)=>be===re){let be=!0,re;return this.steps.push(fe=>{const me=be||!ve(fe,re);return be=!1,re=fe,me?fe:oe}),this}evaluate(ve){for(const be of this.steps)if(ve=be(ve),ve===oe)break;return ve}}function B(Ee,ve,be=re=>re){const re=(...Te)=>Pe.fire(be(...Te)),fe=()=>Ee.on(ve,re),me=()=>Ee.removeListener(ve,re),Pe=new i({onWillAddFirstListener:fe,onDidRemoveLastListener:me});return Pe.event}F.fromNodeEventEmitter=B;function j(Ee,ve,be=re=>re){const re=(...Te)=>Pe.fire(be(...Te)),fe=()=>Ee.addEventListener(ve,re),me=()=>Ee.removeEventListener(ve,re),Pe=new i({onWillAddFirstListener:fe,onDidRemoveLastListener:me});return Pe.event}F.fromDOMEventEmitter=j;function G(Ee){return new Promise(ve=>z(Ee)(ve))}F.toPromise=G;function ie(Ee){const ve=new i;return Ee.then(be=>{ve.fire(be)},()=>{ve.fire(void 0)}).finally(()=>{ve.dispose()}),ve.event}F.fromPromise=ie;function ce(Ee,ve){return Ee(be=>ve.fire(be))}F.forward=ce;function ge(Ee,ve,be){return ve(be),Ee(re=>ve(re))}F.runAndSubscribe=ge;class Se{constructor(ve,be){this._observable=ve,this._counter=0,this._hasChanged=!1;const re={onWillAddFirstListener:()=>{ve.addObserver(this)},onDidRemoveLastListener:()=>{ve.removeObserver(this)}};be||M(re),this.emitter=new i(re),be&&be.add(this.emitter)}beginUpdate(ve){this._counter++}handlePossibleChange(ve){}handleChange(ve,be){this._hasChanged=!0}endUpdate(ve){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Ie(Ee,ve){return new Se(Ee,ve).emitter.event}F.fromObservable=Ie;function Ce(Ee){return(ve,be,re)=>{let fe=0,me=!1;const Pe={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(Ee.reportChanges(),me&&(me=!1,ve.call(be)))},handlePossibleChange(){},handleChange(){me=!0}};Ee.addObserver(Pe),Ee.reportChanges();const Te={dispose(){Ee.removeObserver(Pe)}};return re instanceof _.DisposableStore?re.add(Te):Array.isArray(re)&&re.push(Te),Te}}F.fromObservableLight=Ce})(R||(e.Event=R={}));class m{static{this.all=new Set}static{this._idPool=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${m._idPool++}`,m.all.add(this)}start(M){this._stopWatch=new k.StopWatch,this.listenerCount=M}stop(){if(this._stopWatch){const M=this._stopWatch.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=m;let d=-1;function f(F){const M=d;return d=F,{dispose(){d=M}}}class l{static{this._idPool=1}constructor(M,H,z=(l._idPool++).toString(16).padStart(3,"0")){this._errorHandler=M,this.threshold=H,this.name=z,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(M,H){const z=this.threshold;if(z<=0||H<z)return;this._stacks||(this._stacks=new Map);const J=this._stacks.get(M.value)||0;if(this._stacks.set(M.value,J+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=z*.5;const[V,te]=this.getMostFrequentStack(),$=`[${this.name}] potential listener LEAK detected, having ${H} listeners already. MOST frequent listener (${te}):`;console.warn($),console.warn(V);const q=new I($,V);this._errorHandler(q)}return()=>{const V=this._stacks.get(M.value)||0;this._stacks.set(M.value,V-1)}}getMostFrequentStack(){if(!this._stacks)return;let M,H=0;for(const[z,J]of this._stacks)(!M||H<J)&&(M=[z,J],H=J);return M}}class p{static create(){const M=new Error;return new p(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class I extends Error{constructor(M,H){super(M),this.name="ListenerLeakError",this.stack=H}}e.ListenerLeakError=I;class g extends Error{constructor(M,H){super(M),this.name="ListenerRefusalError",this.stack=H}}e.ListenerRefusalError=g;let v=0;class C{constructor(M){this.value=M,this.id=v++}}const S=2,c=(F,M)=>{if(F instanceof C)M(F);else for(let H=0;H<F.length;H++){const z=F[H];z&&M(z)}};let u;if(T){const F=[];setInterval(()=>{F.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(F.join(`
`)),F.length=0)},3e3),u=new FinalizationRegistry(M=>{typeof M=="string"&&F.push(M)})}class i{constructor(M){this._size=0,this._options=M,this._leakageMon=d>0||this._options?.leakWarningThreshold?new l(M?.onListenerError??P.onUnexpectedError,this._options?.leakWarningThreshold??d):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(D){const M=this._listeners;queueMicrotask(()=>{c(M,H=>H.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(M,H,z)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const q=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(q);const Z=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new g(`${q}. HINT: Stack shows most frequent listener (${Z[1]}-times)`,Z[0]);return(this._options?.onListenerError||P.onUnexpectedError)(ne),_.Disposable.None}if(this._disposed)return _.Disposable.None;H&&(M=M.bind(H));const J=new C(M);let V,te;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(J.stack=p.create(),V=this._leakageMon.check(J.stack,this._size+1)),D&&(J.stack=te??p.create()),this._listeners?this._listeners instanceof C?(this._deliveryQueue??=new t,this._listeners=[this._listeners,J]):this._listeners.push(J):(this._options?.onWillAddFirstListener?.(this),this._listeners=J,this._options?.onDidAddFirstListener?.(this)),this._size++;const $=(0,_.toDisposable)(()=>{u?.unregister($),V?.(),this._removeListener(J)});if(z instanceof _.DisposableStore?z.add($):Array.isArray(z)&&z.push($),u){const q=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Z=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(q);u.register($,Z?.[2]??q,$)}return $},this._event}_removeListener(M){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const H=this._listeners,z=H.indexOf(M);if(z===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,H[z]=void 0;const J=this._deliveryQueue.current===this;if(this._size*S<=H.length){let V=0;for(let te=0;te<H.length;te++)H[te]?H[V++]=H[te]:J&&(this._deliveryQueue.end--,V<this._deliveryQueue.i&&this._deliveryQueue.i--);H.length=V}}_deliver(M,H){if(!M)return;const z=this._options?.onListenerError||P.onUnexpectedError;if(!z){M.value(H);return}try{M.value(H)}catch(J){z(J)}}_deliverQueue(M){const H=M.current._listeners;for(;M.i<M.end;)this._deliver(H[M.i++],M.value);M.reset()}fire(M){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof C)this._deliver(this._listeners,M);else{const H=this._deliveryQueue;H.enqueue(this,M,this._listeners.length),this._deliverQueue(H)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const n=()=>new t;e.createEventDeliveryQueue=n;class t{constructor(){this.i=-1,this.end=0}enqueue(M,H,z){this.i=0,this.end=z,this.current=M,this.value=H}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends i{async fireAsync(M,H,z){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList),c(this._listeners,J=>this._asyncDeliveryQueue.push([J.value,M]));this._asyncDeliveryQueue.size>0&&!H.isCancellationRequested;){const[J,V]=this._asyncDeliveryQueue.shift(),te=[],$={...V,token:H,waitUntil:q=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");z&&(q=z(q,J)),te.push(q)}};try{J($)}catch(q){(0,P.onUnexpectedError)(q);continue}Object.freeze(te),await Promise.allSettled(te).then(q=>{for(const Z of q)Z.status==="rejected"&&(0,P.onUnexpectedError)(Z.reason)})}}}e.AsyncEmitter=s;class r extends i{get isPaused(){return this._isPaused!==0}constructor(M){super(M),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=M?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const M=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(M))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(M){this._size&&(this._isPaused!==0?this._eventQueue.push(M):super.fire(M))}}e.PauseableEmitter=r;class o extends r{constructor(M){super(M),this._delay=M.delay??100}fire(M){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(M)}}e.DebounceEmitter=o;class h extends i{constructor(M){super(M),this._queuedEvents=[],this._mergeFn=M?.merge}fire(M){this.hasListeners()&&(this._queuedEvents.push(M),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(H=>super.fire(H)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=h;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(M){const H={event:M,listener:null};this.events.push(H),this.hasListeners&&this.hook(H);const z=()=>{this.hasListeners&&this.unhook(H);const J=this.events.indexOf(H);this.events.splice(J,1)};return(0,_.toDisposable)((0,a.createSingleCallFunction)(z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(M=>this.hook(M))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(M=>this.unhook(M))}hook(M){M.listener=M.event(H=>this.emitter.fire(H))}unhook(M){M.listener?.dispose(),M.listener=null}dispose(){this.emitter.dispose();for(const M of this.events)M.listener?.dispose();this.events=[]}}e.EventMultiplexer=y;class A{constructor(M,H,z,J){this._store=new _.DisposableStore;const V=this._store.add(new y),te=this._store.add(new _.DisposableMap);function $(q){te.set(q,V.add(J(q)))}for(const q of M)$(q);this._store.add(H(q=>{$(q)})),this._store.add(z(q=>{te.deleteAndDispose(q)})),this.event=V.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=A;class b{constructor(){this.data=[]}wrapEvent(M,H,z){return(J,V,te)=>M($=>{const q=this.data[this.data.length-1];if(!H){q?q.buffers.push(()=>J.call(V,$)):J.call(V,$);return}const Z=q;if(!Z){J.call(V,H(z,$));return}Z.items??=[],Z.items.push($),Z.buffers.length===0&&q.buffers.push(()=>{Z.reducedResult??=z?Z.items.reduce(H,z):Z.items.reduce(H),J.call(V,Z.reducedResult)})},void 0,te)}bufferEvents(M){const H={buffers:new Array};this.data.push(H);const z=M();return this.data.pop(),H.buffers.forEach(J=>J()),z}}e.EventBufferer=b;class w{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=_.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(M){this.inputEvent=M,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=M(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w;class O{static const(M){return new N(M)}constructor(M){this._value=M,this._onDidChange=new i,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(M){M!==this._value&&(this._value=M,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=O;class N{constructor(M){this.value=M,this.onDidChange=R.None}}}),define(ue[25],he([0,1,3]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=T;const a=Object.freeze(function(D,E){const R=setTimeout(D.bind(E),0);return{dispose(){clearTimeout(R)}}});var _;(function(D){function E(R){return R===D.None||R===D.Cancelled||R instanceof L?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}D.isCancellationToken=E,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(_||(e.CancellationToken=_={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?a:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=_.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=_.None}}e.CancellationTokenSource=k;function T(D){const E=new k;return D.add({dispose(){E.cancel()}}),E.token}}),define(ue[136],he([0,1,25]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=_;class a{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new P.CancellationTokenSource,E=this.task(D.token);return this.result={promise:E,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=a;function _(T){return T}class L{constructor(D,E){this.lastCache=void 0,this.lastArgKey=void 0,typeof D=="function"?(this._fn=D,this._computeKey=_):(this._fn=E,this._computeKey=D.getCacheKey)}get(D){const E=this._computeKey(D);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this._fn(D)),this.lastCache}}e.LRUCachedFunction=L;class k{get cachedValues(){return this._map}constructor(D,E){this._map=new Map,this._map2=new Map,typeof D=="function"?(this._fn=D,this._computeKey=_):(this._fn=E,this._computeKey=D.getCacheKey)}get(D){const E=this._computeKey(D);if(this._map2.has(E))return this._map2.get(E);const R=this._fn(D);return this._map.set(D,R),this._map2.set(E,R),R}}e.CachedFunction=k}),define(ue[50],he([0,1,8,2]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=_,e.isReadableStream=L,e.isReadableBufferedStream=k,e.newWriteableStream=T,e.consumeReadable=E,e.peekReadable=R,e.consumeStream=m,e.listenStream=d,e.peekStream=f,e.toStream=l,e.emptyStream=p,e.toReadable=I,e.transform=g,e.prefixedReadable=v,e.prefixedStream=C;function _(S){const c=S;return c?typeof c.read=="function":!1}function L(S){const c=S;return c?[c.on,c.pause,c.resume,c.destroy].every(u=>typeof u=="function"):!1}function k(S){const c=S;return c?L(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}function T(S,c){return new D(S,c)}class D{constructor(c,u){this.reducer=c,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(u=>u(c))}emitError(c){this.listeners.error.length===0?(0,P.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(u=>u(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,u){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(c,u){if(this.state.destroyed)return;let i;switch(c){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const n=i.indexOf(u);n>=0&&i.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(S,c){const u=[];let i;for(;(i=S.read())!==null;)u.push(i);return c(u)}function R(S,c,u){const i=[];let n;for(;(n=S.read())!==null&&i.length<u;)i.push(n);return n===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return S.read()}}}function m(S,c){return new Promise((u,i)=>{const n=[];d(S,{onData:t=>{c&&n.push(t)},onError:t=>{c?i(t):u(void 0)},onEnd:()=>{u(c?c(n):void 0)}})})}function d(S,c,u){S.on("error",i=>{u?.isCancellationRequested||c.onError(i)}),S.on("end",()=>{u?.isCancellationRequested||c.onEnd()}),S.on("data",i=>{u?.isCancellationRequested||c.onData(i)})}function f(S,c){return new Promise((u,i)=>{const n=new a.DisposableStore,t=[],s=h=>{if(t.push(h),t.length>c)return n.dispose(),S.pause(),u({stream:S,buffer:t,ended:!1})},r=h=>(n.dispose(),i(h)),o=()=>(n.dispose(),u({stream:S,buffer:t,ended:!0}));n.add((0,a.toDisposable)(()=>S.removeListener("error",r))),S.on("error",r),n.add((0,a.toDisposable)(()=>S.removeListener("end",o))),S.on("end",o),n.add((0,a.toDisposable)(()=>S.removeListener("data",s))),S.on("data",s)})}function l(S,c){const u=T(c);return u.end(S),u}function p(){const S=T(()=>{throw new Error("not supported")});return S.end(),S}function I(S){let c=!1;return{read:()=>c?null:(c=!0,S)}}function g(S,c,u){const i=T(u);return d(S,{onData:n=>i.write(c.data(n)),onError:n=>i.error(c.error?c.error(n):n),onEnd:()=>i.end()}),i}function v(S,c,u){let i=!1;return{read:()=>{const n=c.read();return i?n:(i=!0,n!==null?u([S,n]):S)}}}function C(S,c,u){let i=!1;const n=T(u);return d(c,{onData:t=>i?n.write(t):(i=!0,n.write(u([S,t]))),onError:t=>n.error(t),onEnd:()=>{i||(i=!0,n.write(S)),n.end()}}),n}}),define(ue[14],he([0,1,53,50]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=E,e.readUInt16LE=R,e.writeUInt16LE=m,e.readUInt32BE=d,e.writeUInt32BE=f,e.readUInt32LE=l,e.writeUInt32LE=p,e.readUInt8=I,e.writeUInt8=g,e.readableToBuffer=v,e.bufferToReadable=C,e.streamToBuffer=S,e.bufferedStreamToBuffer=c,e.bufferToStream=u,e.streamToBufferReadableStream=i,e.newWriteableBufferStream=n,e.prefixedBufferReadable=t,e.prefixedBufferStream=s,e.decodeBase64=r,e.encodeBase64=y,a=De(a);const _=typeof Buffer<"u",L=new P.Lazy(()=>new Uint8Array(256));let k,T;class D{static alloc(b){return _?new D(Buffer.allocUnsafe(b)):new D(new Uint8Array(b))}static wrap(b){return _&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new D(b)}static fromString(b,w){return!(w?.dontUseNodeBuffer||!1)&&_?new D(Buffer.from(b)):(k||(k=new TextEncoder),new D(k.encode(b)))}static fromByteArray(b){const w=D.alloc(b.length);for(let O=0,N=b.length;O<N;O++)w.buffer[O]=b[O];return w}static concat(b,w){if(typeof w>"u"){w=0;for(let F=0,M=b.length;F<M;F++)w+=b[F].byteLength}const O=D.alloc(w);let N=0;for(let F=0,M=b.length;F<M;F++){const H=b[F];O.set(H,N),N+=H.byteLength}return O}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=D.alloc(this.byteLength);return b.set(this),b}toString(){return _?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(b,w){return new D(this.buffer.subarray(b,w))}set(b,w){if(b instanceof D)this.buffer.set(b.buffer,w);else if(b instanceof Uint8Array)this.buffer.set(b,w);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),w);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return d(this.buffer,b)}writeUInt32BE(b,w){f(this.buffer,b,w)}readUInt32LE(b){return l(this.buffer,b)}writeUInt32LE(b,w){p(this.buffer,b,w)}readUInt8(b){return I(this.buffer,b)}writeUInt8(b,w){g(this.buffer,b,w)}indexOf(b,w=0){return E(this.buffer,b instanceof D?b.buffer:b,w)}}e.VSBuffer=D;function E(A,b,w=0){const O=b.byteLength,N=A.byteLength;if(O===0)return 0;if(O===1)return A.indexOf(b[0]);if(O>N-w)return-1;const F=L.value;F.fill(b.length);for(let J=0;J<b.length;J++)F[b[J]]=b.length-J-1;let M=w+b.length-1,H=M,z=-1;for(;M<N;)if(A[M]===b[H]){if(H===0){z=M;break}M--,H--}else M+=Math.max(b.length-H,F[A[M]]),H=b.length-1;return z}function R(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0}function m(A,b,w){A[w+0]=b&255,b=b>>>8,A[w+1]=b&255}function d(A,b){return A[b]*2**24+A[b+1]*2**16+A[b+2]*2**8+A[b+3]}function f(A,b,w){A[w+3]=b,b=b>>>8,A[w+2]=b,b=b>>>8,A[w+1]=b,b=b>>>8,A[w]=b}function l(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0|A[b+2]<<16>>>0|A[b+3]<<24>>>0}function p(A,b,w){A[w+0]=b&255,b=b>>>8,A[w+1]=b&255,b=b>>>8,A[w+2]=b&255,b=b>>>8,A[w+3]=b&255}function I(A,b){return A[b]}function g(A,b,w){A[w]=b}function v(A){return a.consumeReadable(A,b=>D.concat(b))}function C(A){return a.toReadable(A)}function S(A){return a.consumeStream(A,b=>D.concat(b))}async function c(A){return A.ended?D.concat(A.buffer):D.concat([...A.buffer,await S(A.stream)])}function u(A){return a.toStream(A,b=>D.concat(b))}function i(A){return a.transform(A,{data:b=>typeof b=="string"?D.fromString(b):D.wrap(b)},b=>D.concat(b))}function n(A){return a.newWriteableStream(b=>D.concat(b),A)}function t(A,b){return a.prefixedReadable(A,b,w=>D.concat(w))}function s(A,b){return a.prefixedStream(A,b,w=>D.concat(w))}function r(A){let b=0,w=0,O=0;const N=new Uint8Array(Math.floor(A.length/4*3)),F=H=>{switch(w){case 3:N[O++]=b|H,w=0;break;case 2:N[O++]=b|H>>>2,b=H<<6,w=3;break;case 1:N[O++]=b|H>>>4,b=H<<4,w=2;break;default:b=H<<2,w=1}};for(let H=0;H<A.length;H++){const z=A.charCodeAt(H);if(z>=65&&z<=90)F(z-65);else if(z>=97&&z<=122)F(z-97+26);else if(z>=48&&z<=57)F(z-48+52);else if(z===43||z===45)F(62);else if(z===47||z===95)F(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${A[H]}`)}}const M=O;for(;w>0;)F(0);return D.wrap(N).slice(0,M)}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:A},b=!0,w=!1){const O=w?h:o;let N="";const F=A.byteLength%3;let M=0;for(;M<A.byteLength-F;M+=3){const H=A[M+0],z=A[M+1],J=A[M+2];N+=O[H>>>2],N+=O[(H<<4|z>>>4)&63],N+=O[(z<<2|J>>>6)&63],N+=O[J&63]}if(F===1){const H=A[M+0];N+=O[H>>>2],N+=O[H<<4&63],b&&(N+="==")}else if(F===2){const H=A[M+0],z=A[M+1];N+=O[H>>>2],N+=O[(H<<4|z>>>4)&63],N+=O[z<<2&63],b&&(N+="=")}return N}}),define(ue[137],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ue[12],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=P,e.isStringArray=a,e.isObject=_,e.isTypedArray=L,e.isNumber=k,e.isIterable=T,e.isBoolean=D,e.isUndefined=E,e.isDefined=R,e.isUndefinedOrNull=m,e.assertType=d,e.assertIsDefined=f,e.assertAllDefined=l,e.isEmptyObject=I,e.isFunction=g,e.areFunctions=v,e.validateConstraints=C,e.validateConstraint=S,e.upcast=c;function P(u){return typeof u=="string"}function a(u){return Array.isArray(u)&&u.every(i=>P(i))}function _(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}function L(u){const i=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof i}function k(u){return typeof u=="number"&&!isNaN(u)}function T(u){return!!u&&typeof u[Symbol.iterator]=="function"}function D(u){return u===!0||u===!1}function E(u){return typeof u>"u"}function R(u){return!m(u)}function m(u){return E(u)||u===null}function d(u,i){if(!u)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function f(u){if(m(u))throw new Error("Assertion Failed: argument is undefined or null");return u}function l(...u){const i=[];for(let n=0;n<u.length;n++){const t=u[n];if(m(t))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(t)}return i}const p=Object.prototype.hasOwnProperty;function I(u){if(!_(u))return!1;for(const i in u)if(p.call(u,i))return!1;return!0}function g(u){return typeof u=="function"}function v(...u){return u.length>0&&u.every(g)}function C(u,i){const n=Math.min(u.length,i.length);for(let t=0;t<n;t++)S(u[t],i[t])}function S(u,i){if(P(i)){if(typeof u!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(u instanceof i)return}catch{}if(!m(u)&&u.constructor===i||i.length===1&&i.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function c(u){return u}}),define(ue[29],he([0,1,12]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=a,e.deepFreeze=_,e.cloneAndChange=k,e.mixin=D,e.equals=E,e.safeStringify=R,e.distinct=m,e.getCaseInsensitive=d,e.filter=f,e.getAllPropertyNames=l,e.getAllMethodNames=p,e.createProxyObject=I,e.mapValues=g;function a(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const C=Array.isArray(v)?[]:{};return Object.entries(v).forEach(([S,c])=>{C[S]=c&&typeof c=="object"?a(c):c}),C}function _(v){if(!v||typeof v!="object")return v;const C=[v];for(;C.length>0;){const S=C.shift();Object.freeze(S);for(const c in S)if(L.call(S,c)){const u=S[c];typeof u=="object"&&!Object.isFrozen(u)&&!(0,P.isTypedArray)(u)&&C.push(u)}}return v}const L=Object.prototype.hasOwnProperty;function k(v,C){return T(v,C,new Set)}function T(v,C,S){if((0,P.isUndefinedOrNull)(v))return v;const c=C(v);if(typeof c<"u")return c;if(Array.isArray(v)){const u=[];for(const i of v)u.push(T(i,C,S));return u}if((0,P.isObject)(v)){if(S.has(v))throw new Error("Cannot clone recursive data-structure");S.add(v);const u={};for(const i in v)L.call(v,i)&&(u[i]=T(v[i],C,S));return S.delete(v),u}return v}function D(v,C,S=!0){return(0,P.isObject)(v)?((0,P.isObject)(C)&&Object.keys(C).forEach(c=>{c in v?S&&((0,P.isObject)(v[c])&&(0,P.isObject)(C[c])?D(v[c],C[c],S):v[c]=C[c]):v[c]=C[c]}),v):C}function E(v,C){if(v===C)return!0;if(v==null||C===null||C===void 0||typeof v!=typeof C||typeof v!="object"||Array.isArray(v)!==Array.isArray(C))return!1;let S,c;if(Array.isArray(v)){if(v.length!==C.length)return!1;for(S=0;S<v.length;S++)if(!E(v[S],C[S]))return!1}else{const u=[];for(c in v)u.push(c);u.sort();const i=[];for(c in C)i.push(c);if(i.sort(),!E(u,i))return!1;for(S=0;S<u.length;S++)if(!E(v[u[S]],C[u[S]]))return!1}return!0}function R(v){const C=new Set;return JSON.stringify(v,(S,c)=>{if((0,P.isObject)(c)||Array.isArray(c)){if(C.has(c))return"[Circular]";C.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function m(v,C){const S=Object.create(null);return!v||!C||Object.keys(C).forEach(u=>{const i=v[u],n=C[u];E(i,n)||(S[u]=n)}),S}function d(v,C){const S=C.toLowerCase(),c=Object.keys(v).find(u=>u.toLowerCase()===S);return c?v[c]:v[C]}function f(v,C){const S=Object.create(null);for(const[c,u]of Object.entries(v))C(c,u)&&(S[c]=u);return S}function l(v){let C=[];for(;Object.prototype!==v;)C=C.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return C}function p(v){const C=[];for(const S of l(v))typeof v[S]=="function"&&C.push(S);return C}function I(v,C){const S=u=>function(){const i=Array.prototype.slice.call(arguments,0);return C(u,i)},c={};for(const u of v)c[u]=S(u);return c}function g(v,C){const S={};for(const[c,u]of Object.entries(v))S[c]=C(u,c);return S}}),define(ue[138],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=a,e.toUint32=_;var P;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(e.Constants=P={}));function a(L){return L<0?0:L>P.MAX_UINT_8?P.MAX_UINT_8:L|0}function _(L){return L<0?0:L>P.MAX_UINT_32?P.MAX_UINT_32:L|0}}),define(ue[26],he([0,1,136,39,53,138]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=k,e.format=D,e.format2=R,e.htmlAttributeEncodeValue=m,e.escape=d,e.escapeRegExpCharacters=f,e.count=l,e.truncate=p,e.truncateMiddle=I,e.trim=g,e.ltrim=v,e.rtrim=C,e.convertSimple2RegExpPattern=S,e.stripWildcards=c,e.createRegExp=u,e.regExpLeadsToEndlessLoop=i,e.splitLines=n,e.splitLinesIncludeSeparators=t,e.firstNonWhitespaceIndex=s,e.getLeadingWhitespace=r,e.lastNonWhitespaceIndex=o,e.replaceAsync=h,e.compare=y,e.compareSubstring=A,e.compareIgnoreCase=b,e.compareSubstringIgnoreCase=w,e.isAsciiDigit=O,e.isLowerAsciiLetter=N,e.isUpperAsciiLetter=F,e.equalsIgnoreCase=M,e.startsWithIgnoreCase=H,e.commonPrefixLength=z,e.commonSuffixLength=J,e.isHighSurrogate=V,e.isLowSurrogate=te,e.computeCodePoint=$,e.getNextCodePoint=q,e.nextCharLength=ee,e.prevCharLength=X,e.getCharContainingOffset=K,e.charCount=W,e.containsRTL=oe,e.isBasicASCII=B,e.containsUnusualLineTerminators=j,e.isFullWidthCharacter=G,e.isEmojiImprecise=ie,e.lcut=ce,e.forAnsiStringParts=Se,e.removeAnsiEscapeCodes=Ie,e.removeAnsiEscapeCodesFromPrompt=Ee,e.startsWithUTF8BOM=ve,e.stripUTF8BOM=be,e.fuzzyContains=re,e.containsUppercaseCharacter=fe,e.uppercaseFirstLetter=me,e.getNLines=Pe,e.singleLetterHash=Te,e.getGraphemeBreakType=Ue,e.getLeftDeleteOffset=ze;function k(se){return!se||typeof se!="string"?!0:se.trim().length===0}const T=/{(\d+)}/g;function D(se,...de){return de.length===0?se:se.replace(T,function(pe,ye){const Le=parseInt(ye,10);return isNaN(Le)||Le<0||Le>=de.length?pe:de[Le]})}const E=/{([^}]+)}/g;function R(se,de){return Object.keys(de).length===0?se:se.replace(E,(pe,ye)=>de[ye]??pe)}function m(se){return se.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function d(se){return se.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function f(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(se,de){let pe=0,ye=se.indexOf(de);for(;ye!==-1;)pe++,ye=se.indexOf(de,ye+de.length);return pe}function p(se,de,pe="\u2026"){return se.length<=de?se:`${se.substr(0,de)}${pe}`}function I(se,de,pe="\u2026"){if(se.length<=de)return se;const ye=Math.ceil(de/2)-pe.length/2,Le=Math.floor(de/2)-pe.length/2;return`${se.substr(0,ye)}${pe}${se.substr(se.length-Le)}`}function g(se,de=" "){const pe=v(se,de);return C(pe,de)}function v(se,de){if(!se||!de)return se;const pe=de.length;if(pe===0||se.length===0)return se;let ye=0;for(;se.indexOf(de,ye)===ye;)ye=ye+pe;return se.substring(ye)}function C(se,de){if(!se||!de)return se;const pe=de.length,ye=se.length;if(pe===0||ye===0)return se;let Le=ye,Oe=-1;for(;Oe=se.lastIndexOf(de,Le-1),!(Oe===-1||Oe+pe!==Le);){if(Oe===0)return"";Le=Oe}return se.substring(0,Le)}function S(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(se){return se.replace(/\*/g,"")}function u(se,de,pe={}){if(!se)throw new Error("Cannot create regex from empty string");de||(se=f(se)),pe.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(se,ye)}function i(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function n(se){return se.split(/\r\n|\r|\n/)}function t(se){const de=[],pe=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)de.push(pe[2*ye]+(pe[2*ye+1]??""));return de}function s(se){for(let de=0,pe=se.length;de<pe;de++){const ye=se.charCodeAt(de);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return de}return-1}function r(se,de=0,pe=se.length){for(let ye=de;ye<pe;ye++){const Le=se.charCodeAt(ye);if(Le!==a.CharCode.Space&&Le!==a.CharCode.Tab)return se.substring(de,ye)}return se.substring(de,pe)}function o(se,de=se.length-1){for(let pe=de;pe>=0;pe--){const ye=se.charCodeAt(pe);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return pe}return-1}function h(se,de,pe){const ye=[];let Le=0;for(const Oe of se.matchAll(de)){if(ye.push(se.slice(Le,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Le=Oe.index+Oe[0].length,ye.push(pe(Oe[0],...Oe.slice(1),Oe.index,se,Oe.groups))}return ye.push(se.slice(Le)),Promise.all(ye).then(Oe=>Oe.join(""))}function y(se,de){return se<de?-1:se>de?1:0}function A(se,de,pe=0,ye=se.length,Le=0,Oe=de.length){for(;pe<ye&&Le<Oe;pe++,Le++){const Ge=se.charCodeAt(pe),Ye=de.charCodeAt(Le);if(Ge<Ye)return-1;if(Ge>Ye)return 1}const xe=ye-pe,Je=Oe-Le;return xe<Je?-1:xe>Je?1:0}function b(se,de){return w(se,de,0,se.length,0,de.length)}function w(se,de,pe=0,ye=se.length,Le=0,Oe=de.length){for(;pe<ye&&Le<Oe;pe++,Le++){let Ge=se.charCodeAt(pe),Ye=de.charCodeAt(Le);if(Ge===Ye)continue;if(Ge>=128||Ye>=128)return A(se.toLowerCase(),de.toLowerCase(),pe,ye,Le,Oe);N(Ge)&&(Ge-=32),N(Ye)&&(Ye-=32);const je=Ge-Ye;if(je!==0)return je}const xe=ye-pe,Je=Oe-Le;return xe<Je?-1:xe>Je?1:0}function O(se){return se>=a.CharCode.Digit0&&se<=a.CharCode.Digit9}function N(se){return se>=a.CharCode.a&&se<=a.CharCode.z}function F(se){return se>=a.CharCode.A&&se<=a.CharCode.Z}function M(se,de){return se.length===de.length&&w(se,de)===0}function H(se,de){const pe=de.length;return de.length>se.length?!1:w(se,de,0,pe)===0}function z(se,de){const pe=Math.min(se.length,de.length);let ye;for(ye=0;ye<pe;ye++)if(se.charCodeAt(ye)!==de.charCodeAt(ye))return ye;return pe}function J(se,de){const pe=Math.min(se.length,de.length);let ye;const Le=se.length-1,Oe=de.length-1;for(ye=0;ye<pe;ye++)if(se.charCodeAt(Le-ye)!==de.charCodeAt(Oe-ye))return ye;return pe}function V(se){return 55296<=se&&se<=56319}function te(se){return 56320<=se&&se<=57343}function $(se,de){return(se-55296<<10)+(de-56320)+65536}function q(se,de,pe){const ye=se.charCodeAt(pe);if(V(ye)&&pe+1<de){const Le=se.charCodeAt(pe+1);if(te(Le))return $(ye,Le)}return ye}function Z(se,de){const pe=se.charCodeAt(de-1);if(te(pe)&&de>1){const ye=se.charCodeAt(de-2);if(V(ye))return $(ye,pe)}return pe}class ne{get offset(){return this._offset}constructor(de,pe=0){this._str=de,this._len=de.length,this._offset=pe}setOffset(de){this._offset=de}prevCodePoint(){const de=Z(this._str,this._offset);return this._offset-=de>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,de}nextCodePoint(){const de=q(this._str,this._len,this._offset);return this._offset+=de>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,de}eol(){return this._offset>=this._len}}e.CodePointIterator=ne;class le{get offset(){return this._iterator.offset}constructor(de,pe=0){this._iterator=new ne(de,pe)}nextGraphemeLength(){const de=Ne.getInstance(),pe=this._iterator,ye=pe.offset;let Le=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Oe=pe.offset,xe=de.getGraphemeBreakType(pe.nextCodePoint());if(ke(Le,xe)){pe.setOffset(Oe);break}Le=xe}return pe.offset-ye}prevGraphemeLength(){const de=Ne.getInstance(),pe=this._iterator,ye=pe.offset;let Le=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Oe=pe.offset,xe=de.getGraphemeBreakType(pe.prevCodePoint());if(ke(xe,Le)){pe.setOffset(Oe);break}Le=xe}return ye-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=le;function ee(se,de){return new le(se,de).nextGraphemeLength()}function X(se,de){return new le(se,de).prevGraphemeLength()}function K(se,de){de>0&&te(se.charCodeAt(de))&&de--;const pe=de+ee(se,de);return[pe-X(se,pe),pe]}function W(se){const de=new le(se);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}let U;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(se){return U||(U=Y()),U.test(se)}const x=/^[\t\n\r\x20-\x7E]*$/;function B(se){return x.test(se)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(se){return e.UNUSUAL_LINE_TERMINATORS.test(se)}function G(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ie(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ce(se,de,pe=""){const ye=se.trimStart();if(ye.length<de)return ye;const Le=/\b/g;let Oe=0;for(;Le.test(ye)&&!(ye.length-Le.lastIndex<de);)Oe=Le.lastIndex,Le.lastIndex+=1;return Oe===0?ye:pe+ye.substring(Oe).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Se(se){let de=0;for(const pe of se.matchAll(ge))de!==pe.index&&(yield{isCode:!1,str:se.substring(de,pe.index)}),yield{isCode:!0,str:pe[0]},de=pe.index+pe[0].length;de!==se.length&&(yield{isCode:!1,str:se.substring(de)})}function Ie(se){return se&&(se=se.replace(ge,"")),se}const Ce=/\\\[.*?\\\]/g;function Ee(se){return Ie(se).replace(Ce,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(a.CharCode.UTF8_BOM);function ve(se){return!!(se&&se.length>0&&se.charCodeAt(0)===a.CharCode.UTF8_BOM)}function be(se){return ve(se)?se.substr(1):se}function re(se,de){if(!se||!de||se.length<de.length)return!1;const pe=de.length,ye=se.toLowerCase();let Le=0,Oe=-1;for(;Le<pe;){const xe=ye.indexOf(de[Le],Oe+1);if(xe<0)return!1;Oe=xe,Le++}return!0}function fe(se,de=!1){return se?(de&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Pe(se,de=1){if(de===0)return"";let pe=-1;do pe=se.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?se:(se[pe-1]==="\r"&&pe--,se.substr(0,pe))}function Te(se){const de=a.CharCode.Z-a.CharCode.A+1;return se=se%(2*de),se<de?String.fromCharCode(a.CharCode.a+se):String.fromCharCode(a.CharCode.A+se-de)}function Ue(se){return Ne.getInstance().getGraphemeBreakType(se)}function ke(se,de){return se===_e.Other?de!==_e.Extend&&de!==_e.SpacingMark:se===_e.CR&&de===_e.LF?!1:se===_e.Control||se===_e.CR||se===_e.LF||de===_e.Control||de===_e.CR||de===_e.LF?!0:!(se===_e.L&&(de===_e.L||de===_e.V||de===_e.LV||de===_e.LVT)||(se===_e.LV||se===_e.V)&&(de===_e.V||de===_e.T)||(se===_e.LVT||se===_e.T)&&de===_e.T||de===_e.Extend||de===_e.ZWJ||de===_e.SpacingMark||se===_e.Prepend||se===_e.ZWJ&&de===_e.Extended_Pictographic||se===_e.Regional_Indicator&&de===_e.Regional_Indicator)}var _e;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(_e||(e.GraphemeBreakType=_e={}));class Ne{static{this._INSTANCE=null}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}constructor(){this._data=$e()}getGraphemeBreakType(de){if(de<32)return de===a.CharCode.LineFeed?_e.LF:de===a.CharCode.CarriageReturn?_e.CR:_e.Control;if(de<127)return _e.Other;const pe=this._data,ye=pe.length/3;let Le=1;for(;Le<=ye;)if(de<pe[3*Le])Le=2*Le;else if(de>pe[3*Le+1])Le=2*Le+1;else return pe[3*Le+2];return _e.Other}}function $e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(se,de){if(se===0)return 0;const pe=Me(se,de);if(pe!==void 0)return pe;const ye=new ne(de,se);return ye.prevCodePoint(),ye.offset}function Me(se,de){const pe=new ne(de,se);let ye=pe.prevCodePoint();for(;We(ye)||ye===qe.emojiVariantSelector||ye===qe.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!ie(ye))return;let Le=pe.offset;return Le>0&&pe.prevCodePoint()===qe.zwj&&(Le=pe.offset),Le}function We(se){return 127995<=se&&se<=127999}var qe;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.noBreakWhitespace="\xA0";class Be{static{this.ambiguousCharacterData=new _.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new P.LRUCachedFunction({getCacheKey:JSON.stringify},de=>{function pe(je){const Ze=new Map;for(let Xe=0;Xe<je.length;Xe+=2)Ze.set(je[Xe],je[Xe+1]);return Ze}function ye(je,Ze){const Xe=new Map(je);for(const[nt,at]of Ze)Xe.set(nt,at);return Xe}function Le(je,Ze){if(!je)return Ze;const Xe=new Map;for(const[nt,at]of je)Ze.has(nt)&&Xe.set(nt,at);return Xe}const Oe=this.ambiguousCharacterData.value;let xe=de.filter(je=>!je.startsWith("_")&&je in Oe);xe.length===0&&(xe=["_default"]);let Je;for(const je of xe){const Ze=pe(Oe[je]);Je=Le(Je,Ze)}const Ge=pe(Oe._common),Ye=ye(Ge,Je);return new Be(Ye)})}static getInstance(de){return Be.cache.get(Array.from(de))}static{this._locales=new _.Lazy(()=>Object.keys(Be.ambiguousCharacterData.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Be._locales.value}constructor(de){this.confusableDictionary=de}isAmbiguous(de){return this.confusableDictionary.has(de)}containsAmbiguousCharacter(de){for(let pe=0;pe<de.length;pe++){const ye=de.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(de){return this.confusableDictionary.get(de)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be;class Ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ae.getRawData())),this._data}static isInvisibleCharacter(de){return Ae.getData().has(de)}static containsInvisibleCharacter(de){for(let pe=0;pe<de.length;pe++){const ye=de.codePointAt(pe);if(typeof ye=="number"&&Ae.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ae.getData()}}e.InvisibleCharacters=Ae}),define(ue[41],he([0,1,39,13,5,26,12]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=T,e.toSlashes=D,e.toPosixPath=E,e.getRoot=R,e.isUNC=m,e.isValidBasename=p,e.isEqual=I,e.isEqualOrParent=g,e.isWindowsDriveLetter=v,e.sanitizeFilePath=C,e.removeTrailingPathSeparator=S,e.isRootOrDriveLetter=c,e.hasDriveLetter=u,e.getDriveLetter=i,e.indexOfPath=n,e.parseLineAndColumnAware=t,e.randomPath=o;function T(h){return h===P.CharCode.Slash||h===P.CharCode.Backslash}function D(h){return h.replace(/[\\/]/g,a.posix.sep)}function E(h){return h.indexOf("/")===-1&&(h=D(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function R(h,y=a.posix.sep){if(!h)return"";const A=h.length,b=h.charCodeAt(0);if(T(b)){if(T(h.charCodeAt(1))&&!T(h.charCodeAt(2))){let O=3;const N=O;for(;O<A&&!T(h.charCodeAt(O));O++);if(N!==O&&!T(h.charCodeAt(O+1))){for(O+=1;O<A;O++)if(T(h.charCodeAt(O)))return h.slice(0,O+1).replace(/[\\/]/g,y)}}return y}else if(v(b)&&h.charCodeAt(1)===P.CharCode.Colon)return T(h.charCodeAt(2))?h.slice(0,2)+y:h.slice(0,2);let w=h.indexOf("://");if(w!==-1){for(w+=3;w<A;w++)if(T(h.charCodeAt(w)))return h.slice(0,w+1)}return""}function m(h){if(!_.isWindows||!h||h.length<5)return!1;let y=h.charCodeAt(0);if(y!==P.CharCode.Backslash||(y=h.charCodeAt(1),y!==P.CharCode.Backslash))return!1;let A=2;const b=A;for(;A<h.length&&(y=h.charCodeAt(A),y!==P.CharCode.Backslash);A++);return!(b===A||(y=h.charCodeAt(A+1),isNaN(y)||y===P.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,f=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(h,y=_.isWindows){const A=y?d:f;return!(!h||h.length===0||/^\s+$/.test(h)||(A.lastIndex=0,A.test(h))||y&&l.test(h)||h==="."||h===".."||y&&h[h.length-1]==="."||y&&h.length!==h.trim().length||h.length>255)}function I(h,y,A){const b=h===y;return!A||b?b:!h||!y?!1:(0,L.equalsIgnoreCase)(h,y)}function g(h,y,A,b=a.sep){if(h===y)return!0;if(!h||!y||y.length>h.length)return!1;if(A){if(!(0,L.startsWithIgnoreCase)(h,y))return!1;if(y.length===h.length)return!0;let O=y.length;return y.charAt(y.length-1)===b&&O--,h.charAt(O)===b}return y.charAt(y.length-1)!==b&&(y+=b),h.indexOf(y)===0}function v(h){return h>=P.CharCode.A&&h<=P.CharCode.Z||h>=P.CharCode.a&&h<=P.CharCode.z}function C(h,y){return _.isWindows&&h.endsWith(":")&&(h+=a.sep),(0,a.isAbsolute)(h)||(h=(0,a.join)(y,h)),h=(0,a.normalize)(h),S(h)}function S(h){return _.isWindows?(h=(0,L.rtrim)(h,a.sep),h.endsWith(":")&&(h+=a.sep)):(h=(0,L.rtrim)(h,a.sep),h||(h=a.sep)),h}function c(h){const y=(0,a.normalize)(h);return _.isWindows?h.length>3?!1:u(y)&&(h.length===2||y.charCodeAt(2)===P.CharCode.Backslash):y===a.posix.sep}function u(h,y=_.isWindows){return y?v(h.charCodeAt(0))&&h.charCodeAt(1)===P.CharCode.Colon:!1}function i(h,y=_.isWindows){return u(h,y)?h[0]:void 0}function n(h,y,A){return y.length>h.length?-1:h===y?0:(A&&(h=h.toLowerCase(),y=y.toLowerCase()),h.indexOf(y))}function t(h){const y=h.split(":");let A,b,w;for(const O of y){const N=Number(O);(0,k.isNumber)(N)?b===void 0?b=N:w===void 0&&(w=N):A=A?[A,O].join(":"):O}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:b!==void 0?b:void 0,column:w!==void 0?w:b!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(h,y,A=8){let b="";for(let O=0;O<A;O++){let N;O===0&&_.isWindows&&!y&&(A===3||A===4)?N=r:N=s,b+=N.charAt(Math.floor(Math.random()*N.length))}let w;return y?w=`${y}-${b}`:w=b,h?(0,a.join)(h,w):w}}),define(ue[55],he([0,1,26]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=a,e.doHash=_,e.numberHash=L,e.stringHash=T,e.toHexString=p,P=De(P);function a(g){return _(g,0)}function _(g,v){switch(typeof g){case"object":return g===null?L(349,v):Array.isArray(g)?D(g,v):E(g,v);case"string":return T(g,v);case"boolean":return k(g,v);case"number":return L(g,v);case"undefined":return L(937,v);default:return L(617,v)}}function L(g,v){return(v<<5)-v+g|0}function k(g,v){return L(g?433:863,v)}function T(g,v){v=L(149417,v);for(let C=0,S=g.length;C<S;C++)v=L(g.charCodeAt(C),v);return v}function D(g,v){return v=L(104579,v),g.reduce((C,S)=>_(S,C),v)}function E(g,v){return v=L(181387,v),Object.keys(g).sort().reduce((C,S)=>(C=T(S,C),_(g[S],C)),v)}class R{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=_(v,this._value),this._value}}e.Hasher=R;var m;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function d(g,v,C=32){const S=C-v,c=~((1<<S)-1);return(g<<v|(c&g)>>>S)>>>0}function f(g,v=0,C=g.byteLength,S=0){for(let c=0;c<C;c++)g[v+c]=S}function l(g,v,C="0"){for(;g.length<v;)g=C+g;return g}function p(g,v=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(C=>C.toString(16).padStart(2,"0")).join(""):l((g>>>0).toString(16),v/4)}class I{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(m.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const C=v.length;if(C===0)return;const S=this._buff;let c=this._buffLen,u=this._leftoverHighSurrogate,i,n;for(u!==0?(i=u,n=-1,u=0):(i=v.charCodeAt(0),n=0);;){let t=i;if(P.isHighSurrogate(i))if(n+1<C){const s=v.charCodeAt(n+1);P.isLowSurrogate(s)?(n++,t=P.computeCodePoint(i,s)):t=m.UNICODE_REPLACEMENT}else{u=i;break}else P.isLowSurrogate(i)&&(t=m.UNICODE_REPLACEMENT);if(c=this._push(S,c,t),n++,n<C)i=v.charCodeAt(n);else break}this._buffLen=c,this._leftoverHighSurrogate=u}_push(v,C,S){return S<128?v[C++]=S:S<2048?(v[C++]=192|(S&1984)>>>6,v[C++]=128|(S&63)>>>0):S<65536?(v[C++]=224|(S&61440)>>>12,v[C++]=128|(S&4032)>>>6,v[C++]=128|(S&63)>>>0):(v[C++]=240|(S&1835008)>>>18,v[C++]=128|(S&258048)>>>12,v[C++]=128|(S&4032)>>>6,v[C++]=128|(S&63)>>>0),C>=m.BLOCK_SIZE&&(this._step(),C-=m.BLOCK_SIZE,this._totalLen+=m.BLOCK_SIZE,v[0]=v[m.BLOCK_SIZE+0],v[1]=v[m.BLOCK_SIZE+1],v[2]=v[m.BLOCK_SIZE+2]),C}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,m.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=I._bigBlock32,C=this._buffDV;for(let o=0;o<64;o+=4)v.setUint32(o,C.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,d(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let S=this._h0,c=this._h1,u=this._h2,i=this._h3,n=this._h4,t,s,r;for(let o=0;o<80;o++)o<20?(t=c&u|~c&i,s=1518500249):o<40?(t=c^u^i,s=1859775393):o<60?(t=c&u|c&i|u&i,s=2400959708):(t=c^u^i,s=3395469782),r=d(S,5)+t+n+s+v.getUint32(o*4,!1)&4294967295,n=i,i=u,u=d(c,30),c=S,S=r;this._h0=this._h0+S&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+u&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=I}),define(ue[92],he([0,1,26]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),P=De(P);var a;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(a||(a={})),function(_){const L="error",k="warning",T="warn",D="info",E="ignore";function R(d){return d?P.equalsIgnoreCase(L,d)?_.Error:P.equalsIgnoreCase(k,d)||P.equalsIgnoreCase(T,d)?_.Warning:P.equalsIgnoreCase(D,d)?_.Info:_.Ignore:_.Ignore}_.fromValue=R;function m(d){switch(d){case _.Error:return L;case _.Warning:return k;case _.Info:return D;default:return E}}_.toString=m}(a||(a={})),e.default=a}),define(ue[51],he([0,1,17,39,26]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class L{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const p=l.charCodeAt(0),I=this._value.charCodeAt(this._pos);return p-I}value(){return this._value[this._pos]}}e.StringIterator=L;class k{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===a.CharCode.Period)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,_.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class T{constructor(l=!0,p=!0){this._splitOnBackslash=l,this._caseSensitive=p}reset(l){this._from=0,this._to=0,this._value=l,this._valueLen=l.length;for(let p=l.length-1;p>=0;p--,this._valueLen--){const I=this._value.charCodeAt(p);if(!(I===a.CharCode.Slash||this._splitOnBackslash&&I===a.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let l=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===a.CharCode.Slash||this._splitOnBackslash&&p===a.CharCode.Backslash)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,_.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var D;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(D||(D={}));class E{constructor(l,p){this._ignorePathCasing=l,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(D.Scheme),this._value.authority&&this._states.push(D.Authority),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(D.Path)),this._ignoreQueryAndFragment(l)||(this._value.query&&this._states.push(D.Query),this._value.fragment&&this._states.push(D.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===D.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===D.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===D.Scheme)return(0,_.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===D.Authority)return(0,_.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===D.Path)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===D.Query)return(0,_.compare)(l,this._value.query);if(this._states[this._stateIdx]===D.Fragment)return(0,_.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===D.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===D.Authority)return this._value.authority;if(this._states[this._stateIdx]===D.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===D.Query)return this._value.query;if(this._states[this._stateIdx]===D.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=E;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(m||(m={}));class d{static forUris(l=()=>!1,p=()=>!1){return new d(new E(l,p))}static forPaths(l=!1){return new d(new T(void 0,!l))}static forStrings(){return new d(new L)}static forConfigKeys(){return new d(new k)}constructor(l){this._iter=l}clear(){this._root=void 0}fill(l,p){if(p){const I=p.slice(0);(0,P.shuffle)(I);for(const g of I)this.set(g,l)}else{const I=l.slice(0);(0,P.shuffle)(I);for(const g of I)this.set(g[0],g[1])}}set(l,p){const I=this._iter.reset(l);let g;this._root||(this._root=new R,this._root.segment=I.value());const v=[];for(g=this._root;;){const S=I.cmp(g.segment);if(S>0)g.left||(g.left=new R,g.left.segment=I.value()),v.push([m.Left,g]),g=g.left;else if(S<0)g.right||(g.right=new R,g.right.segment=I.value()),v.push([m.Right,g]),g=g.right;else if(I.hasNext())I.next(),g.mid||(g.mid=new R,g.mid.segment=I.value()),v.push([m.Mid,g]),g=g.mid;else break}const C=g.value;g.value=p,g.key=l;for(let S=v.length-1;S>=0;S--){const c=v[S][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const i=v[S][0],n=v[S+1][0];if(i===m.Right&&n===m.Right)v[S][1]=c.rotateLeft();else if(i===m.Left&&n===m.Left)v[S][1]=c.rotateRight();else if(i===m.Right&&n===m.Left)c.right=v[S+1][1]=v[S+1][1].rotateRight(),v[S][1]=c.rotateLeft();else if(i===m.Left&&n===m.Right)c.left=v[S+1][1]=v[S+1][1].rotateLeft(),v[S][1]=c.rotateRight();else throw new Error;if(S>0)switch(v[S-1][0]){case m.Left:v[S-1][1].left=v[S][1];break;case m.Right:v[S-1][1].right=v[S][1];break;case m.Mid:v[S-1][1].mid=v[S][1];break}else this._root=v[0][1]}}return C}get(l){return this._getNode(l)?.value}_getNode(l){const p=this._iter.reset(l);let I=this._root;for(;I;){const g=p.cmp(I.segment);if(g>0)I=I.left;else if(g<0)I=I.right;else if(p.hasNext())p.next(),I=I.mid;else break}return I}has(l){const p=this._getNode(l);return!(p?.value===void 0&&p?.mid===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,p){const I=this._iter.reset(l),g=[];let v=this._root;for(;v;){const C=I.cmp(v.segment);if(C>0)g.push([m.Left,v]),v=v.left;else if(C<0)g.push([m.Right,v]),v=v.right;else if(I.hasNext())I.next(),g.push([m.Mid,v]),v=v.mid;else break}if(v){if(p?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const C=this._min(v.right);if(C.key){const{key:S,value:c,segment:u}=C;this._delete(C.key,!1),v.key=S,v.value=c,v.segment=u}}else{const C=v.left??v.right;if(g.length>0){const[S,c]=g[g.length-1];switch(S){case m.Left:c.left=C;break;case m.Mid:c.mid=C;break;case m.Right:c.right=C;break}}else this._root=C}for(let C=g.length-1;C>=0;C--){const S=g[C][1];S.updateHeight();const c=S.balanceFactor();if(c>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),g[C][1]=S.rotateLeft()):c<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),g[C][1]=S.rotateRight()),C>0)switch(g[C-1][0]){case m.Left:g[C-1][1].left=g[C][1];break;case m.Right:g[C-1][1].right=g[C][1];break;case m.Mid:g[C-1][1].mid=g[C][1];break}else this._root=g[0][1]}}}_min(l){for(;l.left;)l=l.left;return l}findSubstr(l){const p=this._iter.reset(l);let I=this._root,g;for(;I;){const v=p.cmp(I.segment);if(v>0)I=I.left;else if(v<0)I=I.right;else if(p.hasNext())p.next(),g=I.value||g,I=I.mid;else break}return I&&I.value||g}findSuperstr(l){return this._findSuperstrOrElement(l,!1)}_findSuperstrOrElement(l,p){const I=this._iter.reset(l);let g=this._root;for(;g;){const v=I.cmp(g.segment);if(v>0)g=g.left;else if(v<0)g=g.right;else if(I.hasNext())I.next(),g=g.mid;else return g.mid?this._entries(g.mid):p?g.value:void 0}}hasElementOrSubtree(l){return this._findSuperstrOrElement(l,!0)!==void 0}forEach(l){for(const[p,I]of this)l(I,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(l){const p=[];return this._dfsEntries(l,p),p[Symbol.iterator]()}_dfsEntries(l,p){l&&(l.left&&this._dfsEntries(l.left,p),l.value&&p.push([l.key,l.value]),l.mid&&this._dfsEntries(l.mid,p),l.right&&this._dfsEntries(l.right,p))}_isBalanced(){const l=p=>{if(!p)return!0;const I=p.balanceFactor();return I<-1||I>1?!1:l(p.left)&&l(p.right)};return l(this._root)}}e.TernarySearchTree=d}),define(ue[9],he([0,1,39,65,13,5]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=I,e.uriToFsPath=u,_=De(_);const k=/^\w[\w\d+.-]*$/,T=/^\//,D=/^\/\//;function E(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!T.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function R(r,o){return!r&&!o?"file":r}function m(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==f&&(o=f+o):o=f;break}return o}const d="",f="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(o){return o instanceof p?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,h,y,A,b,w=!1){typeof o=="object"?(this.scheme=o.scheme||d,this.authority=o.authority||d,this.path=o.path||d,this.query=o.query||d,this.fragment=o.fragment||d):(this.scheme=R(o,w),this.authority=h||d,this.path=m(this.scheme,y||d),this.query=A||d,this.fragment=b||d,E(this,w))}get fsPath(){return u(this,!1)}with(o){if(!o)return this;let{scheme:h,authority:y,path:A,query:b,fragment:w}=o;return h===void 0?h=this.scheme:h===null&&(h=d),y===void 0?y=this.authority:y===null&&(y=d),A===void 0?A=this.path:A===null&&(A=d),b===void 0?b=this.query:b===null&&(b=d),w===void 0?w=this.fragment:w===null&&(w=d),h===this.scheme&&y===this.authority&&A===this.path&&b===this.query&&w===this.fragment?this:new v(h,y,A,b,w)}static parse(o,h=!1){const y=l.exec(o);return y?new v(y[2]||d,s(y[4]||d),s(y[5]||d),s(y[7]||d),s(y[9]||d),h):new v(d,d,d,d,d)}static file(o){let h=d;if(L.isWindows&&(o=o.replace(/\\/g,f)),o[0]===f&&o[1]===f){const y=o.indexOf(f,2);y===-1?(h=o.substring(2),o=f):(h=o.substring(2,y),o=o.substring(y)||f)}return new v("file",h,o,d,d)}static from(o,h){return new v(o.scheme,o.authority,o.path,o.query,o.fragment,h)}static joinPath(o,...h){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return L.isWindows&&o.scheme==="file"?y=p.file(_.win32.join(u(o,!0),...h)).path:y=_.posix.join(o.path,...h),o.with({path:y})}toString(o=!1){return i(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof p)return o;{const h=new v(o);return h._formatted=o.external??null,h._fsPath=o._sep===g?o.fsPath??null:null,h}}else return o}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=p;function I(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const g=L.isWindows?1:void 0;class v extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(o=!1){return o?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const o={$mid:a.MarshalledId.Uri};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=g),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const C={[P.CharCode.Colon]:"%3A",[P.CharCode.Slash]:"%2F",[P.CharCode.QuestionMark]:"%3F",[P.CharCode.Hash]:"%23",[P.CharCode.OpenSquareBracket]:"%5B",[P.CharCode.CloseSquareBracket]:"%5D",[P.CharCode.AtSign]:"%40",[P.CharCode.ExclamationMark]:"%21",[P.CharCode.DollarSign]:"%24",[P.CharCode.Ampersand]:"%26",[P.CharCode.SingleQuote]:"%27",[P.CharCode.OpenParen]:"%28",[P.CharCode.CloseParen]:"%29",[P.CharCode.Asterisk]:"%2A",[P.CharCode.Plus]:"%2B",[P.CharCode.Comma]:"%2C",[P.CharCode.Semicolon]:"%3B",[P.CharCode.Equals]:"%3D",[P.CharCode.Space]:"%20"};function S(r,o,h){let y,A=-1;for(let b=0;b<r.length;b++){const w=r.charCodeAt(b);if(w>=P.CharCode.a&&w<=P.CharCode.z||w>=P.CharCode.A&&w<=P.CharCode.Z||w>=P.CharCode.Digit0&&w<=P.CharCode.Digit9||w===P.CharCode.Dash||w===P.CharCode.Period||w===P.CharCode.Underline||w===P.CharCode.Tilde||o&&w===P.CharCode.Slash||h&&w===P.CharCode.OpenSquareBracket||h&&w===P.CharCode.CloseSquareBracket||h&&w===P.CharCode.Colon)A!==-1&&(y+=encodeURIComponent(r.substring(A,b)),A=-1),y!==void 0&&(y+=r.charAt(b));else{y===void 0&&(y=r.substr(0,b));const O=C[w];O!==void 0?(A!==-1&&(y+=encodeURIComponent(r.substring(A,b)),A=-1),y+=O):A===-1&&(A=b)}}return A!==-1&&(y+=encodeURIComponent(r.substring(A))),y!==void 0?y:r}function c(r){let o;for(let h=0;h<r.length;h++){const y=r.charCodeAt(h);y===P.CharCode.Hash||y===P.CharCode.QuestionMark?(o===void 0&&(o=r.substr(0,h)),o+=C[y]):o!==void 0&&(o+=r[h])}return o!==void 0?o:r}function u(r,o){let h;return r.authority&&r.path.length>1&&r.scheme==="file"?h=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===P.CharCode.Slash&&(r.path.charCodeAt(1)>=P.CharCode.A&&r.path.charCodeAt(1)<=P.CharCode.Z||r.path.charCodeAt(1)>=P.CharCode.a&&r.path.charCodeAt(1)<=P.CharCode.z)&&r.path.charCodeAt(2)===P.CharCode.Colon?o?h=r.path.substr(1):h=r.path[1].toLowerCase()+r.path.substr(2):h=r.path,L.isWindows&&(h=h.replace(/\//g,"\\")),h}function i(r,o){const h=o?c:S;let y="",{scheme:A,authority:b,path:w,query:O,fragment:N}=r;if(A&&(y+=A,y+=":"),(b||A==="file")&&(y+=f,y+=f),b){let F=b.indexOf("@");if(F!==-1){const M=b.substr(0,F);b=b.substr(F+1),F=M.lastIndexOf(":"),F===-1?y+=h(M,!1,!1):(y+=h(M.substr(0,F),!1,!1),y+=":",y+=h(M.substr(F+1),!1,!0)),y+="@"}b=b.toLowerCase(),F=b.lastIndexOf(":"),F===-1?y+=h(b,!1,!0):(y+=h(b.substr(0,F),!1,!0),y+=b.substr(F))}if(w){if(w.length>=3&&w.charCodeAt(0)===P.CharCode.Slash&&w.charCodeAt(2)===P.CharCode.Colon){const F=w.charCodeAt(1);F>=P.CharCode.A&&F<=P.CharCode.Z&&(w=`/${String.fromCharCode(F+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===P.CharCode.Colon){const F=w.charCodeAt(0);F>=P.CharCode.A&&F<=P.CharCode.Z&&(w=`${String.fromCharCode(F+32)}:${w.substr(2)}`)}y+=h(w,!0,!1)}return O&&(y+="?",y+=h(O,!1,!1)),N&&(y+="#",y+=o?N:S(N,!1,!1)),y}function n(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+n(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,o=>n(o)):r}}),define(ue[139],he([0,1,9]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=a,e.parse=_,e.getFirstFrame=L,e.log=T;function a(E){const R=E;return R&&typeof R.type=="string"&&typeof R.severity=="string"}function _(E){const R=[];let m;try{const d=JSON.parse(E.arguments),f=d[d.length-1];f&&f.__$stack&&(d.pop(),m=f.__$stack),R.push(...d)}catch{R.push("Unable to log remote console arguments",E.arguments)}return{args:R,stack:m}}function L(E){if(typeof E!="string")return L(_(E).stack);const R=E;if(R){const m=k(R),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(d&&d.length===4)return{uri:P.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function k(E){if(!E)return E;const R=E.indexOf(`
`);return R===-1?E:E.substring(0,R)}function T(E,R){const{args:m,stack:d}=_(E),f=typeof m[0]=="string"&&m.length===1;let l=k(d);l&&(l=`(${l.trim()})`);let p=[];if(typeof m[0]=="string"?l&&f?p=[`%c[${R}] %c${m[0]} %c${l}`,D("blue"),D(""),D("grey")]:p=[`%c[${R}] %c${m[0]}`,D("blue"),D(""),...m.slice(1)]:p=[`%c[${R}]%`,D("blue"),...m],l&&!f&&p.push(l),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,p)}function D(E){return`color: ${E}`}}),define(ue[66],he([0,1,14,9,65]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=L,e.parse=k,e.revive=D;function L(E){return JSON.stringify(E,T)}function k(E){let R=JSON.parse(E);return R=D(R),R}function T(E,R){return R instanceof RegExp?{$mid:_.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function D(E,R=0){if(!E||R>200)return E;if(typeof E=="object"){switch(E.$mid){case _.MarshalledId.Uri:return a.URI.revive(E);case _.MarshalledId.Regexp:return new RegExp(E.source,E.flags);case _.MarshalledId.Date:return new Date(E.source)}if(E instanceof P.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let m=0;m<E.length;++m)E[m]=D(E[m],R+1);else for(const m in E)Object.hasOwnProperty.call(E,m)&&(E[m]=D(E[m],R+1))}return E}}),define(ue[22],he([0,1,8,5,26,9,13]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=D,e.matchesSomeScheme=E,e.getServerRootPath=m,P=De(P),a=De(a),k=De(k);var T;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(T||(e.Schemas=T={}));function D(l,p){return L.URI.isUri(l)?(0,_.equalsIgnoreCase)(l.scheme,p):(0,_.startsWithIgnoreCase)(l,p+":")}function E(l,...p){return p.some(I=>D(l,I))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p,I){this._serverRootPath=m(p,I)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return k.posix.join(this._serverRootPath,T.vscodeRemoteResource)}set(p,I,g){this._hosts[p]=I,this._ports[p]=g}setConnectionToken(p,I){this._connectionTokens[p]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)try{return this._delegate(p)}catch(c){return P.onUnexpectedError(c),p}const I=p.authority;let g=this._hosts[I];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const v=this._ports[I],C=this._connectionTokens[I];let S=`path=${encodeURIComponent(p.path)}`;return typeof C=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),L.URI.from({scheme:a.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${g}:${v}`,path:this._remoteResourcesPath,query:S})}}e.RemoteAuthorities=new R;function m(l,p){return k.posix.join(p??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class d{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(p){const I=this.toUri(p,ae);return this.uriToBrowserUri(I)}uriToBrowserUri(p){return p.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===T.file&&(a.isNative||a.webWorkerOrigin===`${T.vscodeFileResource}://${d.FALLBACK_AUTHORITY}`)?p.with({scheme:T.vscodeFileResource,authority:p.authority||d.FALLBACK_AUTHORITY,query:null,fragment:null}):p}asFileUri(p){const I=this.toUri(p,ae);return this.uriToFileUri(I)}uriToFileUri(p){return p.scheme===T.vscodeFileResource?p.with({scheme:T.file,authority:p.authority!==d.FALLBACK_AUTHORITY?p.authority:null,query:null,fragment:null}):p}toUri(p,I){return L.URI.isUri(p)?p:L.URI.parse(I.toUrl(p))}}e.FileAccess=new d;var f;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const I="vscode-coi";function g(C){let S;typeof C=="string"?S=new URL(C).searchParams:C instanceof URL?S=C.searchParams:L.URI.isUri(C)&&(S=new URL(C.toString(!0)).searchParams);const c=S?.get(I);if(c)return p.get(c)}l.getHeadersFromQuery=g;function v(C,S,c){if(!globalThis.crossOriginIsolated)return;const u=S&&c?"3":c?"2":"1";C instanceof URLSearchParams?C.set(I,u):C[I]=u}l.addSearchParam=v})(f||(e.COI=f={}))}),define(ue[140],he([0,1,128,22,5,12,9]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=m,e.resolveAmdNodeModulePath=d,_=De(_);class T{constructor(l,p,I){this.id=l,this.dependencies=p,this.callback=I}}class D{static{this.INSTANCE=new D}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(l,p,I)=>{typeof l!="string"&&(I=p,p=l,l=null),(typeof p!="object"||!Array.isArray(p))&&(I=p,p=null),this._defineCalls.push(new T(l,p,I))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith("vscode-file://vscode-app"))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}})))}async load(l){this._initialize();const p=await(this._isWebWorker?this._workerLoadScript(l):this._isRenderer?this._rendererLoadScript(l):this._nodeJSLoadScript(l));if(!p)throw new Error(`Did not receive a define call from script ${l}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}_rendererLoadScript(l){return new Promise((p,I)=>{const g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript");const v=()=>{g.removeEventListener("load",C),g.removeEventListener("error",S)},C=c=>{v(),p(this._defineCalls.pop())},S=c=>{v(),I(c)};g.addEventListener("load",C),g.addEventListener("error",S),this._amdPolicy&&(l=this._amdPolicy.createScriptURL(l)),g.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(g)})}_workerLoadScript(l){return new Promise((p,I)=>{try{this._amdPolicy&&(l=this._amdPolicy.createScriptURL(l)),importScripts(l),p(this._defineCalls.pop())}catch(g){I(g)}})}async _nodeJSLoadScript(l){try{const p=globalThis._VSCODE_NODE_MODULES.fs,I=globalThis._VSCODE_NODE_MODULES.vm,g=globalThis._VSCODE_NODE_MODULES.module,v=k.URI.parse(l).fsPath,C=p.readFileSync(v).toString(),S=g.wrap(C.replace(/^#!.*/,""));return new I.Script(S).runInThisContext().apply(),this._defineCalls.pop()}catch(p){throw p}}}const E=new Map;let R={};typeof globalThis.require=="object"&&(R=globalThis.require.paths??{});async function m(f,l,p){if(P.isESM){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),R[f]&&(f=R[f]);const I=l?`${f}/${l}`:f;if(E.has(I))return E.get(I);let g;if(/^\w[\w\d+.-]*:\/\//.test(I))g=I;else{const c=`${p&&!_.isWeb?a.nodeModulesAsarPath:a.nodeModulesPath}/${I}`;g=a.FileAccess.asBrowserUri(c).toString(!0)}const v=D.INSTANCE.load(g);return E.set(I,v),v}else return await new Promise((I,g)=>{ae([f],I,g)}).then(De)}function d(f,l){(0,L.assertType)(P.isESM);const g=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!_.isWeb,v=`${f}/${l}`,S=`${g?a.nodeModulesAsarPath:a.nodeModulesPath}/${v}`;return a.FileAccess.asBrowserUri(S).toString(!0)}}),define(ue[20],he([0,1,39,41,22,13,5,26,9]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=E,e.distinctParents=m,e.toLocalResource=f,a=De(a),L=De(L);function E(l){return(0,D.uriToFsPath)(l,!0)}class R{constructor(p){this._ignorePathCasing=p}compare(p,I,g=!1){return p===I?0:(0,T.compare)(this.getComparisonKey(p,g),this.getComparisonKey(I,g))}isEqual(p,I,g=!1){return p===I?!0:!p||!I?!1:this.getComparisonKey(p,g)===this.getComparisonKey(I,g)}getComparisonKey(p,I=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:I?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,I,g=!1){if(p.scheme===I.scheme){if(p.scheme===_.Schemas.file)return a.isEqualOrParent(E(p),E(I),this._ignorePathCasing(p))&&p.query===I.query&&(g||p.fragment===I.fragment);if((0,e.isEqualAuthority)(p.authority,I.authority))return a.isEqualOrParent(p.path,I.path,this._ignorePathCasing(p),"/")&&p.query===I.query&&(g||p.fragment===I.fragment)}return!1}joinPath(p,...I){return D.URI.joinPath(p,...I)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return L.posix.basename(p.path)}extname(p){return L.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let I;return p.scheme===_.Schemas.file?I=D.URI.file(L.dirname(E(p))).path:(I=L.posix.dirname(p.path),p.authority&&I.length&&I.charCodeAt(0)!==P.CharCode.Slash&&(console.error(`dirname("${p.toString})) resulted in a relative path`),I="/")),p.with({path:I})}normalizePath(p){if(!p.path.length)return p;let I;return p.scheme===_.Schemas.file?I=D.URI.file(L.normalize(E(p))).path:I=L.posix.normalize(p.path),p.with({path:I})}relativePath(p,I){if(p.scheme!==I.scheme||!(0,e.isEqualAuthority)(p.authority,I.authority))return;if(p.scheme===_.Schemas.file){const C=L.relative(E(p),E(I));return k.isWindows?a.toSlashes(C):C}let g=p.path||"/";const v=I.path||"/";if(this._ignorePathCasing(p)){let C=0;for(const S=Math.min(g.length,v.length);C<S&&!(g.charCodeAt(C)!==v.charCodeAt(C)&&g.charAt(C).toLowerCase()!==v.charAt(C).toLowerCase());C++);g=v.substr(0,C)+g.substr(C)}return L.posix.relative(g,v)}resolvePath(p,I){if(p.scheme===_.Schemas.file){const g=D.URI.file(L.resolve(E(p),I));return p.with({authority:g.authority,path:g.path})}return I=a.toPosixPath(I),p.with({path:L.posix.resolve(p.path,I)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,I){return p===I||p!==void 0&&I!==void 0&&(0,T.equalsIgnoreCase)(p,I)}hasTrailingPathSeparator(p,I=L.sep){if(p.scheme===_.Schemas.file){const g=E(p);return g.length>a.getRoot(g).length&&g[g.length-1]===I}else{const g=p.path;return g.length>1&&g.charCodeAt(g.length-1)===P.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,I=L.sep){return(0,e.hasTrailingPathSeparator)(p,I)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,I=L.sep){let g=!1;if(p.scheme===_.Schemas.file){const v=E(p);g=v!==void 0&&v.length===a.getRoot(v).length&&v[v.length-1]===I}else{I="/";const v=p.path;g=v.length===1&&v.charCodeAt(v.length-1)===P.CharCode.Slash}return!g&&!(0,e.hasTrailingPathSeparator)(p,I)?p.with({path:p.path+"/"}):p}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(l=>l.scheme===_.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new R(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function m(l,p){const I=[];for(let g=0;g<l.length;g++){const v=p(l[g]);l.some((C,S)=>S===g?!1:(0,e.isEqualOrParent)(v,p(C)))||I.push(l[g])}return I}var d;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function p(I){const g=new Map;I.path.substring(I.path.indexOf(";")+1,I.path.lastIndexOf(";")).split(";").forEach(S=>{const[c,u]=S.split(":");c&&u&&g.set(c,u)});const C=I.path.substring(0,I.path.indexOf(";"));return C&&g.set(l.META_DATA_MIME,C),g}l.parseMetaData=p})(d||(e.DataUri=d={}));function f(l,p,I){if(p){let g=l.path;return g&&g[0]!==L.posix.sep&&(g=L.posix.sep+g),l.with({scheme:I,authority:p,path:g})}return l.with({scheme:I})}}),define(ue[6],he([0,1,25,8,3,2,20,5,137,53]),function(ae,e,P,a,_,L,k,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=R,e.createCancelablePromise=m,e.raceCancellation=d,e.raceCancellationError=f,e.raceCancellablePromises=l,e.raceTimeout=p,e.asPromise=I,e.promiseWithResolvers=g,e.timeout=r,e.disposableTimeout=o,e.sequence=h,e.first=y,e.firstParallel=A,e.retry=q,e.createCancelableAsyncIterable=x;function R(j){return!!j&&typeof j.then=="function"}function m(j){const G=new P.CancellationTokenSource,ie=j(G.token),ce=new Promise((ge,Se)=>{const Ie=G.token.onCancellationRequested(()=>{Ie.dispose(),Se(new a.CancellationError)});Promise.resolve(ie).then(Ce=>{Ie.dispose(),G.dispose(),ge(Ce)},Ce=>{Ie.dispose(),G.dispose(),Se(Ce)})});return new class{cancel(){G.cancel(),G.dispose()}then(ge,Se){return ce.then(ge,Se)}catch(ge){return this.then(void 0,ge)}finally(ge){return ce.finally(ge)}}}function d(j,G,ie){return new Promise((ce,ge)=>{const Se=G.onCancellationRequested(()=>{Se.dispose(),ce(ie)});j.then(ce,ge).finally(()=>Se.dispose())})}function f(j,G){return new Promise((ie,ce)=>{const ge=G.onCancellationRequested(()=>{ge.dispose(),ce(new a.CancellationError)});j.then(ie,ce).finally(()=>ge.dispose())})}async function l(j){let G=-1;const ie=j.map((ce,ge)=>ce.then(Se=>(G=ge,Se)));try{return await Promise.race(ie)}finally{j.forEach((ce,ge)=>{ge!==G&&ce.cancel()})}}function p(j,G,ie){let ce;const ge=setTimeout(()=>{ce?.(void 0),ie?.()},G);return Promise.race([j.finally(()=>clearTimeout(ge)),new Promise(Se=>ce=Se)])}function I(j){return new Promise((G,ie)=>{const ce=j();R(ce)?ce.then(G,ie):G(ce)})}function g(){let j,G;return{promise:new Promise((ce,ge)=>{j=ce,G=ge}),resolve:j,reject:G}}class v{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(G){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=G,!this.queuedPromise){const ie=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ce=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ce};this.queuedPromise=new Promise(ce=>{this.activePromise.then(ie,ie).then(ce)})}return new Promise((ie,ce)=>{this.queuedPromise.then(ie,ce)})}return this.activePromise=G(),new Promise((ie,ce)=>{this.activePromise.then(ge=>{this.activePromise=null,ie(ge)},ge=>{this.activePromise=null,ce(ge)})})}dispose(){this.isDisposed=!0}}e.Throttler=v;class C{constructor(){this.current=Promise.resolve(null)}queue(G){return this.current=this.current.then(()=>G(),()=>G())}}e.Sequencer=C;class S{constructor(){this.promiseMap=new Map}queue(G,ie){const ge=(this.promiseMap.get(G)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(G)===ge&&this.promiseMap.delete(G)});return this.promiseMap.set(G,ge),ge}}e.SequencerByKey=S;const c=(j,G)=>{let ie=!0;const ce=setTimeout(()=>{ie=!1,G()},j);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ce),ie=!1}}},u=j=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,j())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class i{constructor(G){this.defaultDelay=G,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(G,ie=this.defaultDelay){this.task=G,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,Se)=>{this.doResolve=ge,this.doReject=Se}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const ce=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ie===D.MicrotaskDelay?u(ce):c(ie,ce),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new a.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class n{constructor(G){this.delayer=new i(G),this.throttler=new v}trigger(G,ie){return this.delayer.trigger(()=>this.throttler.queue(G),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=n;class t{constructor(){this._isOpen=!1,this._promise=new Promise((G,ie)=>{this._completePromise=G})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class s extends t{constructor(G){super(),this._timeout=setTimeout(()=>this.open(),G)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function r(j,G){return G?new Promise((ie,ce)=>{const ge=setTimeout(()=>{Se.dispose(),ie()},j),Se=G.onCancellationRequested(()=>{clearTimeout(ge),Se.dispose(),ce(new a.CancellationError)})}):m(ie=>r(j,ie))}function o(j,G=0,ie){const ce=setTimeout(()=>{j(),ie&&ge.dispose()},G),ge=(0,L.toDisposable)(()=>{clearTimeout(ce),ie?.deleteAndLeak(ge)});return ie?.add(ge),ge}function h(j){const G=[];let ie=0;const ce=j.length;function ge(){return ie<ce?j[ie++]():null}function Se(Ie){Ie!=null&&G.push(Ie);const Ce=ge();return Ce?Ce.then(Se):Promise.resolve(G)}return Promise.resolve(null).then(Se)}function y(j,G=ce=>!!ce,ie=null){let ce=0;const ge=j.length,Se=()=>{if(ce>=ge)return Promise.resolve(ie);const Ie=j[ce++];return Promise.resolve(Ie()).then(Ee=>G(Ee)?Promise.resolve(Ee):Se())};return Se()}function A(j,G=ce=>!!ce,ie=null){if(j.length===0)return Promise.resolve(ie);let ce=j.length;const ge=()=>{ce=-1;for(const Se of j)Se.cancel?.()};return new Promise((Se,Ie)=>{for(const Ce of j)Ce.then(Ee=>{--ce>=0&&G(Ee)?(ge(),Se(Ee)):ce===0&&Se(ie)}).catch(Ee=>{--ce>=0&&(ge(),Ie(Ee))})})}class b{constructor(G){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=G,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new _.Emitter}whenIdle(){return this.size>0?_.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(G){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((ie,ce)=>{this.outstandingPromises.push({factory:G,c:ie,e:ce}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const G=this.outstandingPromises.shift();this.runningPromises++;const ie=G.factory();ie.then(G.c,G.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=b;class w extends b{constructor(){super(1)}}e.Queue=w;class O{constructor(){this.sequentializer=new Z,this.tasks=0}queue(G){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,G())):this.sequentializer.run(this.tasks++,G())}}e.LimitedQueue=O;class N{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const G=new ee;return this.drainers.add(G),G.p}isDrained(){for(const[,G]of this.queues)if(G.size>0)return!1;return!0}queueSize(G,ie=k.extUri){const ce=ie.getComparisonKey(G);return this.queues.get(ce)?.size??0}queueFor(G,ie,ce=k.extUri){const ge=ce.getComparisonKey(G);let Se=this.queues.get(ge);if(!Se){Se=new w;const Ie=this.drainListenerCount++,Ce=_.Event.once(Se.onDrained)(()=>{Se?.dispose(),this.queues.delete(ge),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Ie),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new L.DisposableMap),this.drainListeners.set(Ie,Ce),this.queues.set(ge,Se)}return Se.queue(ie)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const G of this.drainers)G.complete();this.drainers.clear()}dispose(){for(const[,G]of this.queues)G.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=N;class F{constructor(G,ie){this._isDisposed=!1,this._token=-1,typeof G=="function"&&typeof ie=="number"&&this.setIfNotSet(G,ie)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(G,ie){if(this._isDisposed)throw new a.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,G()},ie)}setIfNotSet(G,ie){if(this._isDisposed)throw new a.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,G()},ie))}}e.TimeoutTimer=F;class M{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(G,ie,ce=globalThis){if(this.isDisposed)throw new a.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=ce.setInterval(()=>{G()},ie);this.disposable=(0,L.toDisposable)(()=>{ce.clearInterval(ge),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=M;class H{constructor(G,ie){this.timeoutToken=-1,this.runner=G,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(G=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,G)}get delay(){return this.timeout}set delay(G){this.timeout=G}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=H;class z{constructor(G,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=G,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(G=this.timeout){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(G/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=z;class J extends H{constructor(G,ie){super(G,ie),this.units=[]}work(G){this.units.push(G),this.isScheduled()||this.schedule()}doRun(){const G=this.units;this.units=[],this.runner?.(G)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=J;class V extends L.Disposable{constructor(G,ie){super(),this.options=G,this.handler=ie,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(G){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+G.length>this.options.maxBufferedWork)return!1}else if(this.pending+G.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ie of G)this.pendingWork.push(ie);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new H(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(j,G)=>{(0,T.setTimeout0)(()=>{if(ie)return;const ce=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e._runWhenIdle=(j,G,ie)=>{const ce=j.requestIdleCallback(G,typeof ie=="number"?{timeout:ie}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,j.cancelIdleCallback(ce))}}},e.runWhenGlobalIdle=j=>(0,e._runWhenIdle)(globalThis,j)}();class te{constructor(G,ie){this._didRun=!1,this._executor=()=>{try{this._value=ie()}catch(ce){this._error=ce}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(G,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=te;class $ extends te{constructor(G){super(globalThis,G)}}e.GlobalIdleValue=$;async function q(j,G,ie){let ce;for(let ge=0;ge<ie;ge++)try{return await j()}catch(Se){ce=Se,await r(G)}throw ce}class Z{isRunning(G){return typeof G=="number"?this._running?.taskId===G:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(G,ie,ce){return this._running={taskId:G,cancel:()=>ce?.(),promise:ie},ie.then(()=>this.doneRunning(G),()=>this.doneRunning(G)),ie}doneRunning(G){this._running&&G===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const G=this._queued;this._queued=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this._queued)this._queued.run=G;else{const{promise:ie,resolve:ce,reject:ge}=g();this._queued={run:G,promise:ie,promiseResolve:ce,promiseReject:ge}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Z;class ne{constructor(G,ie=()=>Date.now()){this.interval=G,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const G=this.nowFn();return G-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=G,this.value=0),this.value++,this.value}}e.IntervalCounter=ne;var le;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(le||(le={}));class ee{get isRejected(){return this.outcome?.outcome===le.Rejected}get isResolved(){return this.outcome?.outcome===le.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===le.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((G,ie)=>{this.completeCallback=G,this.errorCallback=ie})}complete(G){return new Promise(ie=>{this.completeCallback(G),this.outcome={outcome:le.Resolved,value:G},ie()})}error(G){return new Promise(ie=>{this.errorCallback(G),this.outcome={outcome:le.Rejected,value:G},ie()})}cancel(){return this.error(new a.CancellationError)}}e.DeferredPromise=ee;var X;(function(j){async function G(ce){let ge;const Se=await Promise.all(ce.map(Ie=>Ie.then(Ce=>Ce,Ce=>{ge||(ge=Ce)})));if(typeof ge<"u")throw ge;return Se}j.settled=G;function ie(ce){return new Promise(async(ge,Se)=>{try{await ce(ge,Se)}catch(Ie){Se(Ie)}})}j.withAsyncBody=ie})(X||(e.Promises=X={}));class K{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(G){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=G.then(ie=>(this._value=ie,this._isResolved=!0,ie),ie=>{throw this._error=ie,this._isResolved=!0,ie})}requireValue(){if(!this._isResolved)throw new a.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=K;class W{constructor(G){this._compute=G,this._promise=new E.Lazy(()=>new K(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=W;var U;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(U||(U={}));class Y{static fromArray(G){return new Y(ie=>{ie.emitMany(G)})}static fromPromise(G){return new Y(async ie=>{ie.emitMany(await G)})}static fromPromises(G){return new Y(async ie=>{await Promise.all(G.map(async ce=>ie.emitOne(await ce)))})}static merge(G){return new Y(async ie=>{await Promise.all(G.map(async ce=>{for await(const ge of ce)ie.emitOne(ge)}))})}static{this.EMPTY=Y.fromArray([])}constructor(G,ie){this._state=U.Initial,this._results=[],this._error=null,this._onReturn=ie,this._onStateChanged=new _.Emitter,queueMicrotask(async()=>{const ce={emitOne:ge=>this.emitOne(ge),emitMany:ge=>this.emitMany(ge),reject:ge=>this.reject(ge)};try{await Promise.resolve(G(ce)),this.resolve()}catch(ge){this.reject(ge)}finally{ce.emitOne=void 0,ce.emitMany=void 0,ce.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this._state===U.DoneError)throw this._error;if(G<this._results.length)return{done:!1,value:this._results[G++]};if(this._state===U.DoneOK)return{done:!0,value:void 0};await _.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(G,ie){return new Y(async ce=>{for await(const ge of G)ce.emitOne(ie(ge))})}map(G){return Y.map(this,G)}static filter(G,ie){return new Y(async ce=>{for await(const ge of G)ie(ge)&&ce.emitOne(ge)})}filter(G){return Y.filter(this,G)}static coalesce(G){return Y.filter(G,ie=>!!ie)}coalesce(){return Y.coalesce(this)}static async toPromise(G){const ie=[];for await(const ce of G)ie.push(ce);return ie}toPromise(){return Y.toPromise(this)}emitOne(G){this._state===U.Initial&&(this._results.push(G),this._onStateChanged.fire())}emitMany(G){this._state===U.Initial&&(this._results=this._results.concat(G),this._onStateChanged.fire())}resolve(){this._state===U.Initial&&(this._state=U.DoneOK,this._onStateChanged.fire())}reject(G){this._state===U.Initial&&(this._state=U.DoneError,this._error=G,this._onStateChanged.fire())}}e.AsyncIterableObject=Y;class oe extends Y{constructor(G,ie){super(ie),this._source=G}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function x(j){const G=new P.CancellationTokenSource,ie=j(G.token);return new oe(G,async ce=>{const ge=G.token.onCancellationRequested(()=>{ge.dispose(),G.dispose(),ce.reject(new a.CancellationError)});try{for await(const Se of ie){if(G.token.isCancellationRequested)return;ce.emitOne(Se)}ge.dispose(),G.dispose()}catch(Se){ge.dispose(),G.dispose(),ce.reject(Se)}})}class B{constructor(G){this._deferred=new ee,this._asyncIterable=new Y(ge=>{if(ie){ge.reject(ie);return}return ce&&ge.emitMany(ce),this._errorFn=Se=>ge.reject(Se),this._emitFn=Se=>ge.emitOne(Se),this._deferred.p},G);let ie,ce;this._emitFn=ge=>{ce||(ce=[]),ce.push(ge)},this._errorFn=ge=>{ie||(ie=ge)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(G){this._errorFn(G),this._deferred.complete()}emitOne(G){this._emitFn(G)}}e.AsyncIterableSource=B}),define(ue[93],he([0,1,17,6,39,41,31,13,5,26]),function(ae,e,P,a,_,L,k,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=R,e.splitGlobAware=p,e.match=O,e.parse=N,e.isRelativePattern=F,e.getBasenameTerms=M,e.getPathTerms=H,e.patternsEquals=te;function R(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const m="[/\\\\]",d="[^/\\\\]",f=/\//g;function l($,q){switch($){case 0:return"";case 1:return`${d}*?`;default:return`(?:${m}|${d}+${m}${q?`|${m}${d}+`:""})*?`}}function p($,q){if(!$)return[];const Z=[];let ne=!1,le=!1,ee="";for(const X of $){switch(X){case q:if(!ne&&!le){Z.push(ee),ee="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":le=!0;break;case"]":le=!1;break}ee+=X}return ee&&Z.push(ee),Z}function I($){if(!$)return"";let q="";const Z=p($,e.GLOB_SPLIT);if(Z.every(ne=>ne===e.GLOBSTAR))q=".*";else{let ne=!1;Z.forEach((le,ee)=>{if(le===e.GLOBSTAR){if(ne)return;q+=l(2,ee===Z.length-1)}else{let X=!1,K="",W=!1,U="";for(const Y of le){if(Y!=="}"&&X){K+=Y;continue}if(W&&(Y!=="]"||!U)){let oe;Y==="-"?oe=Y:(Y==="^"||Y==="!")&&!U?oe="^":Y===e.GLOB_SPLIT?oe="":oe=(0,E.escapeRegExpCharacters)(Y),U+=oe;continue}switch(Y){case"{":X=!0;continue;case"[":W=!0;continue;case"}":{const x=`(?:${p(K,",").map(B=>I(B)).join("|")})`;q+=x,X=!1,K="";break}case"]":{q+="["+U+"]",W=!1,U="";break}case"?":q+=d;continue;case"*":q+=l(1);continue;default:q+=(0,E.escapeRegExpCharacters)(Y)}}ee<Z.length-1&&(Z[ee+1]!==e.GLOBSTAR||ee+2<Z.length)&&(q+=m)}ne=le===e.GLOBSTAR})}return q}const g=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),n=function(){return!1},t=function(){return null};function s($,q){if(!$)return t;let Z;typeof $!="string"?Z=$.pattern:Z=$,Z=Z.trim();const ne=`${Z}_${!!q.trimForExclusions}`;let le=i.get(ne);if(le)return r(le,$);let ee;return g.test(Z)?le=h(Z.substr(4),Z):(ee=v.exec(o(Z,q)))?le=y(ee[1],Z):(q.trimForExclusions?S:C).test(Z)?le=A(Z,q):(ee=c.exec(o(Z,q)))?le=b(ee[1].substr(1),Z,!0):(ee=u.exec(o(Z,q)))?le=b(ee[1],Z,!1):le=w(Z),i.set(ne,le),r(le,$)}function r($,q){if(typeof q=="string")return $;const Z=function(ne,le){return(0,L.isEqualOrParent)(ne,q.base,!D.isLinux)?$((0,E.ltrim)(ne.substr(q.base.length),T.sep),le):null};return Z.allBasenames=$.allBasenames,Z.allPaths=$.allPaths,Z.basenames=$.basenames,Z.patterns=$.patterns,Z}function o($,q){return q.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function h($,q){return function(Z,ne){return typeof Z=="string"&&Z.endsWith($)?q:null}}function y($,q){const Z=`/${$}`,ne=`\\${$}`,le=function(X,K){return typeof X!="string"?null:K?K===$?q:null:X===$||X.endsWith(Z)||X.endsWith(ne)?q:null},ee=[$];return le.basenames=ee,le.patterns=[q],le.allBasenames=ee,le}function A($,q){const Z=V($.slice(1,-1).split(",").map(K=>s(K,q)).filter(K=>K!==t),$),ne=Z.length;if(!ne)return t;if(ne===1)return Z[0];const le=function(K,W){for(let U=0,Y=Z.length;U<Y;U++)if(Z[U](K,W))return $;return null},ee=Z.find(K=>!!K.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const X=Z.reduce((K,W)=>W.allPaths?K.concat(W.allPaths):K,[]);return X.length&&(le.allPaths=X),le}function b($,q,Z){const ne=T.sep===T.posix.sep,le=ne?$:$.replace(f,T.sep),ee=T.sep+le,X=T.posix.sep+$;let K;return Z?K=function(W,U){return typeof W=="string"&&(W===le||W.endsWith(ee)||!ne&&(W===$||W.endsWith(X)))?q:null}:K=function(W,U){return typeof W=="string"&&(W===le||!ne&&W===$)?q:null},K.allPaths=[(Z?"*/":"./")+$],K}function w($){try{const q=new RegExp(`^${I($)}$`);return function(Z){return q.lastIndex=0,typeof Z=="string"&&q.test(Z)?$:null}}catch{return t}}function O($,q,Z){return!$||typeof q!="string"?!1:N($)(q,void 0,Z)}function N($,q={}){if(!$)return n;if(typeof $=="string"||F($)){const Z=s($,q);if(Z===t)return n;const ne=function(le,ee){return!!Z(le,ee)};return Z.allBasenames&&(ne.allBasenames=Z.allBasenames),Z.allPaths&&(ne.allPaths=Z.allPaths),ne}return z($,q)}function F($){const q=$;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function M($){return $.allBasenames||[]}function H($){return $.allPaths||[]}function z($,q){const Z=V(Object.getOwnPropertyNames($).map(K=>J(K,$[K],q)).filter(K=>K!==t)),ne=Z.length;if(!ne)return t;if(!Z.some(K=>!!K.requiresSiblings)){if(ne===1)return Z[0];const K=function(Y,oe){let x;for(let B=0,j=Z.length;B<j;B++){const G=Z[B](Y,oe);if(typeof G=="string")return G;(0,a.isThenable)(G)&&(x||(x=[]),x.push(G))}return x?(async()=>{for(const B of x){const j=await B;if(typeof j=="string")return j}return null})():null},W=Z.find(Y=>!!Y.allBasenames);W&&(K.allBasenames=W.allBasenames);const U=Z.reduce((Y,oe)=>oe.allPaths?Y.concat(oe.allPaths):Y,[]);return U.length&&(K.allPaths=U),K}const le=function(K,W,U){let Y,oe;for(let x=0,B=Z.length;x<B;x++){const j=Z[x];j.requiresSiblings&&U&&(W||(W=(0,T.basename)(K)),Y||(Y=W.substr(0,W.length-(0,T.extname)(K).length)));const G=j(K,W,Y,U);if(typeof G=="string")return G;(0,a.isThenable)(G)&&(oe||(oe=[]),oe.push(G))}return oe?(async()=>{for(const x of oe){const B=await x;if(typeof B=="string")return B}return null})():null},ee=Z.find(K=>!!K.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const X=Z.reduce((K,W)=>W.allPaths?K.concat(W.allPaths):K,[]);return X.length&&(le.allPaths=X),le}function J($,q,Z){if(q===!1)return t;const ne=s($,Z);if(ne===t)return t;if(typeof q=="boolean")return ne;if(q){const le=q.when;if(typeof le=="string"){const ee=(X,K,W,U)=>{if(!U||!ne(X,K))return null;const Y=le.replace("$(basename)",()=>W),oe=U(Y);return(0,a.isThenable)(oe)?oe.then(x=>x?$:null):oe?$:null};return ee.requiresSiblings=!0,ee}}return ne}function V($,q){const Z=$.filter(K=>!!K.basenames);if(Z.length<2)return $;const ne=Z.reduce((K,W)=>{const U=W.basenames;return U?K.concat(U):K},[]);let le;if(q){le=[];for(let K=0,W=ne.length;K<W;K++)le.push(q)}else le=Z.reduce((K,W)=>{const U=W.patterns;return U?K.concat(U):K},[]);const ee=function(K,W){if(typeof K!="string")return null;if(!W){let Y;for(Y=K.length;Y>0;Y--){const oe=K.charCodeAt(Y-1);if(oe===_.CharCode.Slash||oe===_.CharCode.Backslash)break}W=K.substr(Y)}const U=ne.indexOf(W);return U!==-1?le[U]:null};ee.basenames=ne,ee.patterns=le,ee.allBasenames=ne;const X=$.filter(K=>!K.basenames);return X.push(ee),X}function te($,q){return(0,P.equals)($,q,(Z,ne)=>typeof Z=="string"&&typeof ne=="string"?Z===ne:typeof Z!="string"&&typeof ne!="string"?Z.base===ne.base&&Z.pattern===ne.pattern:!1)}}),define(ue[94],he([0,1,14,65,9]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=D,e.transformIncomingURIs=R,e.transformAndReviveIncomingURIs=m;function L(d){return d.toJSON()}class k{constructor(f){this._uriTransformer=f}transformIncoming(f){const l=this._uriTransformer.transformIncoming(f);return l===f?f:L(_.URI.from(l))}transformOutgoing(f){const l=this._uriTransformer.transformOutgoing(f);return l===f?f:L(_.URI.from(l))}transformOutgoingURI(f){const l=this._uriTransformer.transformOutgoing(f);return l===f?f:_.URI.from(l)}transformOutgoingScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function T(d,f,l){if(!d||l>200)return null;if(typeof d=="object"){if(d instanceof _.URI)return f.transformOutgoing(d);for(const p in d)if(Object.hasOwnProperty.call(d,p)){const I=T(d[p],f,l+1);I!==null&&(d[p]=I)}}return null}function D(d,f){const l=T(d,f,0);return l===null?d:l}function E(d,f,l,p){if(!d||p>200)return null;if(typeof d=="object"){if(d.$mid===a.MarshalledId.Uri)return l?_.URI.revive(f.transformIncoming(d)):f.transformIncoming(d);if(d instanceof P.VSBuffer)return null;for(const I in d)if(Object.hasOwnProperty.call(d,I)){const g=E(d[I],f,l,p+1);g!==null&&(d[I]=g)}}return null}function R(d,f){const l=E(d,f,!1,0);return l===null?d:l}function m(d,f){const l=E(d,f,!0,0);return l===null?d:l}}),define(ue[32],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=a;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(_){return P.test(_)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let _;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?_=crypto.getRandomValues.bind(crypto):_=function(T){for(let D=0;D<T.length;D++)T[D]=Math.floor(Math.random()*256);return T};const L=new Uint8Array(16),k=[];for(let T=0;T<256;T++)k.push(T.toString(16).padStart(2,"0"));return function(){_(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let D=0,E="";return E+=k[L[D++]],E+=k[L[D++]],E+=k[L[D++]],E+=k[L[D++]],E+="-",E+=k[L[D++]],E+=k[L[D++]],E+="-",E+=k[L[D++]],E+=k[L[D++]],E+="-",E+=k[L[D++]],E+=k[L[D++]],E+="-",E+=k[L[D++]],E+=k[L[D++]],E+=k[L[D++]],E+=k[L[D++]],E+=k[L[D++]],E+=k[L[D++]],E}}()}),define(ue[141],he([0,1,38]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=L;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function _(k){const T=k.replace(/\-/g,":").toLowerCase();return!a.has(T)}function L(){const k=(0,P.networkInterfaces)();for(const T in k){const D=k[T];if(D){for(const{mac:E}of D)if(_(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ue[142],he([0,1,38,51,32,141,5]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=D,e.getSqmMachineId=m,e.getdevDeviceId=d,_=De(_),e.virtualMachineHint=new class{_isVirtualMachineMacAddress(f){return this._virtualMachineOUIs||(this._virtualMachineOUIs=a.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(f)}value(){if(this._value===void 0){let f=0,l=0;const p=(0,P.networkInterfaces)();for(const I in p){const g=p[I];if(g)for(const{mac:v,internal:C}of g)C||(l+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(f+=1))}this._value=l>0?f/l:0}return this._value}};let T;async function D(f){return T||(T=(async()=>await E(f)||_.generateUuid())()),T}async function E(f){try{const l=await new Promise((I,g)=>{ae(["crypto"],I,g)}).then(De),p=(0,L.getMac)();return l.createHash("sha256").update(p,"utf8").digest("hex")}catch(l){f(l);return}}const R="Software\\Microsoft\\SQMClient";async function m(f){if(k.isWindows){const l=await new Promise((p,I)=>{ae(["@vscode/windows-registry"],p,I)}).then(De);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",R,"MachineId")||""}catch(p){return f(p),""}}return""}async function d(f){try{return await(await new Promise((I,g)=>{ae(["@vscode/deviceid"],I,g)}).then(De)).getDeviceId()}catch(l){return f(l),""}}}),define(ue[143],he([0,1,240,14]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class _ extends P.Transform{constructor(k){if(super(),typeof k=="number")this.splitter=k,this.spitterLen=1;else{const T=Buffer.isBuffer(k)?k:Buffer.from(k);this.splitter=T.length===1?T[0]:T,this.spitterLen=T.length}}_transform(k,T,D){this.buffer?this.buffer=Buffer.concat([this.buffer,k]):this.buffer=k;let E=0;for(;E<this.buffer.length;){const R=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,E):(0,a.binaryIndexOf)(this.buffer,this.splitter,E);if(R===-1)break;this.push(this.buffer.slice(E,R+this.spitterLen)),E=R+this.spitterLen}this.buffer=E===this.buffer.length?void 0:this.buffer.slice(E),D()}_flush(k){this.buffer&&this.push(this.buffer),k()}}e.StreamSplitter=_}),define(ue[144],he([0,1,33,13,37]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDisplayProtocol=E,e.getCodeDisplayProtocol=R;const L="XDG_SESSION_TYPE",k="WAYLAND_DISPLAY",T="XDG_RUNTIME_DIR";var D;(function(m){m.Wayland="wayland",m.XWayland="xwayland",m.X11="x11",m.Unknown="unknown"})(D||(D={}));async function E(m){const d=_.env[L];if(d)return d===D.Wayland||d===D.X11?d:D.Unknown;if(_.env[k]){const l=_.env[T];if(l){const p=(0,a.join)(l,"wayland-0");try{return await P.promises.access(p,P.constants.R_OK),D.Wayland}catch(I){return m(I),D.Unknown}}else return D.Unknown}else return D.X11}function R(m,d){if(d)switch(d){case"auto":return m;case"x11":return m===D.Wayland?D.XWayland:D.X11;case"wayland":return D.Wayland;default:return D.Unknown}else return m===D.Wayland?D.XWayland:D.X11}}),define(ue[145],he([0,1,33,241,5]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOSReleaseInfo=L,_=De(_);async function L(k){if(_.isMacintosh||_.isWindows)return;let T;for(const D of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{T=await P.promises.open(D,P.constants.R_OK);break}catch{}if(!T){k("Unable to retrieve release information from known identifier paths.");return}try{const D=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const R of(0,a.createInterface)({input:T.createReadStream(),crlfDelay:1/0})){if(!R.includes("="))continue;const m=R.split("=")[0].toUpperCase().trim();if(D.has(m)){const d=R.split("=")[1].replace(/"/g,"").toLowerCase().trim();m==="ID"||m==="DISTRIB_ID"?E.id=d:m==="ID_LIKE"?E.id_like=d:(m==="VERSION_ID"||m==="DISTRIB_RELEASE")&&(E.version_id=d)}}return E}catch(D){k(D)}}}),define(ue[30],he([0,1,33,38,242,6,41,90,13,5,20,9]),function(ae,e,P,a,_,L,k,T,D,E,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=I,e.readdirSync=C,e.whenDeleted=u,e.configureFlushOnWrite=r,e.writeFileSync=h,P=De(P);var d;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function f(z,J=d.UNLINK,V){if((0,k.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return J===d.UNLINK?p(z):l(z,V)}async function l(z,J=(0,k.randomPath)((0,a.tmpdir)())){try{try{await P.promises.rename(z,J)}catch(V){return V.code==="ENOENT"?void 0:p(z)}p(J).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function p(z){return P.promises.rm(z,{recursive:!0,force:!0,maxRetries:3})}function I(z){if((0,k.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}async function g(z,J){return S(await(J?v(z):P.promises.readdir(z)))}async function v(z){try{return await P.promises.readdir(z,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const J=[],V=await g(z);for(const te of V){let $=!1,q=!1,Z=!1;try{const ne=await P.promises.lstat((0,D.join)(z,te));$=ne.isFile(),q=ne.isDirectory(),Z=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}J.push({name:te,isFile:()=>$,isDirectory:()=>q,isSymbolicLink:()=>Z})}return J}function C(z){return S(P.readdirSync(z))}function S(z){return z.map(J=>typeof J=="string"?E.isMacintosh?(0,T.normalizeNFC)(J):J:(J.name=E.isMacintosh?(0,T.normalizeNFC)(J.name):J.name,J))}async function c(z){const J=await g(z),V=[];for(const te of J)await i.existsDirectory((0,D.join)(z,te))&&V.push(te);return V}function u(z,J=1e3){return new Promise(V=>{let te=!1;const $=setInterval(()=>{te||(te=!0,P.access(z,q=>{te=!1,q&&(clearInterval($),V(void 0))}))},J)})}var i;(function(z){async function J($){let q;try{if(q=await P.promises.lstat($),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await P.promises.stat($),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(E.isWindows&&Z.code==="EACCES")try{return{stat:await P.promises.stat(await P.promises.readlink($)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw ne}throw Z}}z.stat=J;async function V($){try{const{stat:q,symbolicLink:Z}=await z.stat($);return q.isFile()&&Z?.dangling!==!0}catch{}return!1}z.existsFile=V;async function te($){try{const{stat:q,symbolicLink:Z}=await z.stat($);return q.isDirectory()&&Z?.dangling!==!0}catch{}return!1}z.existsDirectory=te})(i||(e.SymlinkSupport=i={}));const n=new L.ResourceQueue;function t(z,J,V){return n.queueFor(m.URI.file(z),()=>{const te=y(V);return new Promise(($,q)=>o(z,J,te,Z=>Z?q(Z):$()))},R.extUriBiasedIgnorePathCase)}let s=!0;function r(z){s=z}function o(z,J,V,te){if(!s)return P.writeFile(z,J,{mode:V.mode,flag:V.flag},te);P.open(z,V.flag,V.mode,($,q)=>{if($)return te($);P.writeFile(q,J,Z=>{if(Z)return P.close(q,()=>te(Z));P.fdatasync(q,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),P.close(q,le=>te(le))))})})}function h(z,J,V){const te=y(V);if(!s)return P.writeFileSync(z,J,{mode:te.mode,flag:te.flag});const $=P.openSync(z,te.flag,te.mode);try{P.writeFileSync($,J);try{P.fdatasyncSync($)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r(!1)}}finally{P.closeSync($)}}function y(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function A(z,J,V=6e4){if(z!==J)try{E.isWindows&&typeof V=="number"?await b(z,J,Date.now(),V):await P.promises.rename(z,J)}catch(te){if(z.toLowerCase()!==J.toLowerCase()&&te.code==="EXDEV"||z.endsWith("."))await w(z,J,{preserveSymlinks:!1}),await f(z,d.MOVE);else throw te}}async function b(z,J,V,te,$=0){try{return await P.promises.rename(z,J)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-V>=te)throw console.error(`[node.js fs] rename failed after ${$} retries with error: ${q}`),q;if($===0){let Z=!1;try{const{stat:ne}=await i.stat(J);ne.isFile()||(Z=!0)}catch{}if(Z)throw q}return await(0,L.timeout)(Math.min(100,$*10)),b(z,J,V,te,$+1)}}async function w(z,J,V){return N(z,J,{root:{source:z,target:J},options:V,handledSourcePaths:new Set})}const O=511;async function N(z,J,V){if(V.handledSourcePaths.has(z))return;V.handledSourcePaths.add(z);const{stat:te,symbolicLink:$}=await i.stat(z);if($){if(V.options.preserveSymlinks)try{return await H(z,J,V)}catch{}if($.dangling)return}return te.isDirectory()?F(z,J,te.mode&O,V):M(z,J,te.mode&O)}async function F(z,J,V,te){await P.promises.mkdir(J,{recursive:!0,mode:V});const $=await g(z);for(const q of $)await N((0,D.join)(z,q),(0,D.join)(J,q),te)}async function M(z,J,V){await P.promises.copyFile(z,J),await P.promises.chmod(J,V)}async function H(z,J,V){let te=await P.promises.readlink(z);(0,k.isEqualOrParent)(te,V.root.source,!E.isLinux)&&(te=(0,D.join)(V.root.target,te.substr(V.root.source.length+1))),await P.promises.symlink(te,J)}e.Promises=new class{get read(){return(z,J,V,te,$)=>new Promise((q,Z)=>{P.read(z,J,V,te,$,(ne,le,ee)=>ne?Z(ne):q({bytesRead:le,buffer:ee}))})}get write(){return(z,J,V,te,$)=>new Promise((q,Z)=>{P.write(z,J,V,te,$,(ne,le,ee)=>ne?Z(ne):q({bytesWritten:le,buffer:ee}))})}get fdatasync(){return(0,_.promisify)(P.fdatasync)}get open(){return(0,_.promisify)(P.open)}get close(){return(0,_.promisify)(P.close)}get realpath(){return(0,_.promisify)(P.realpath)}async exists(z){try{return await P.promises.access(z),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return f}get rename(){return A}get copy(){return w}}}),define(ue[146],he([0,1,33,13,5,26,30]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=T,e.realcase=D,e.realpath=E,e.realpathSync=R,P=De(P);function T(d){if(_.isLinux)return d;const f=(0,a.dirname)(d);if(d===f)return d;const l=((0,a.basename)(d)||d).toLowerCase();try{const I=(0,k.readdirSync)(f).filter(g=>g.toLowerCase()===l);if(I.length===1){const g=T(f);if(g)return(0,a.join)(g,I[0])}else if(I.length>1){const g=I.indexOf(l);if(g>=0){const v=T(f);if(v)return(0,a.join)(v,I[g])}}}catch{}return null}async function D(d,f){if(_.isLinux)return d;const l=(0,a.dirname)(d);if(d===l)return d;const p=((0,a.basename)(d)||d).toLowerCase();try{if(f?.isCancellationRequested)return null;const g=(await k.Promises.readdir(l)).filter(v=>v.toLowerCase()===p);if(g.length===1){const v=await D(l,f);if(v)return(0,a.join)(v,g[0])}else if(g.length>1){const v=g.indexOf(p);if(v>=0){const C=await D(l,f);if(C)return(0,a.join)(C,g[v])}}}catch{}return null}async function E(d){try{return await k.Promises.realpath(d)}catch{const l=m(d);return await P.promises.access(l,P.constants.R_OK),l}}function R(d){try{return P.realpathSync(d)}catch{const l=m(d);return P.accessSync(l,P.constants.R_OK),l}}function m(d){return(0,L.rtrim)((0,a.normalize)(d),a.sep)}}),define(ue[147],he([0,1,67]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=a,e.findFreePortFaster=L,P=De(P);function a(T,D,E,R=1){let m=!1;return new Promise(d=>{const f=setTimeout(()=>{if(!m)return m=!0,d(0)},E);_(T,D,R,l=>{if(!m)return m=!0,clearTimeout(f),d(l)})})}function _(T,D,E,R){if(D===0)return R(0);const m=new P.Socket;m.once("connect",()=>(k(m),_(T+E,D-1,E,R))),m.once("data",()=>{}),m.once("error",d=>(k(m),d.code!=="ECONNREFUSED"?_(T+E,D-1,E,R):R(T))),m.connect(T,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(T,D,E,R="127.0.0.1"){let m=!1,d,f=1;const l=P.createServer({pauseOnConnect:!0});function p(I,g){m||(m=!0,l.removeAllListeners(),l.close(),d&&clearTimeout(d),g(I))}return new Promise(I=>{d=setTimeout(()=>{p(0,I)},E),l.on("listening",()=>{p(T,I)}),l.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&f<D?(T++,f++,l.listen(T,R)):p(0,I)}),l.on("close",()=>{p(0,I)}),l.listen(T,R)})}function k(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch(D){console.error(D)}}}),define(ue[148],he([0,1,33,13,5,37,91,12,30]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=E,e.createQueuedSender=R,a=De(a),_=De(_),L=De(L),T=De(T),D=De(D),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function E(d=L.env){return d.comspec||"cmd.exe"}function R(d){let f=[],l=!1;const p=function(I){if(l){f.push(I);return}(!d.send(I,v=>{if(v&&console.error(v),l=!1,f.length>0){const C=f.slice(0);f=[],C.forEach(S=>p(S))}})||_.isWindows)&&(l=!0)};return{send:p}}var m;(function(d){async function f(l,p,I){if(a.isAbsolute(l))return l;if(p===void 0&&(p=L.cwd()),a.dirname(l)!=="."||(I===void 0&&T.isString(L.env.PATH)&&(I=L.env.PATH.split(a.delimiter)),I===void 0||I.length===0))return a.join(p,l);async function v(C){if(await D.Promises.exists(C)){let S;try{S=await P.promises.stat(C)}catch(c){c.message.startsWith("EACCES")&&(S=await P.promises.lstat(C))}return S?!S.isDirectory():!1}return!1}for(const C of I){let S;if(a.isAbsolute(C)?S=a.join(C,l):S=a.join(p,C,l),await v(S))return S;let c=S+".com";if(await v(c)||(c=S+".exe",await v(c)))return c}return a.join(p,l)}d.findExecutable=f})(m||(e.win32=m={}))}),define(ue[149],he([0,1,68,22]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=_;function _(k){return new Promise((T,D)=>{let E;const R=new Map;function m(f,l,p,I,g){const v=R.get(l);if(f===k||v){const C={name:d(p),cmd:p,pid:f,ppid:l,load:I,mem:g};R.set(f,C),f===k&&(E=C),v&&(v.children||(v.children=[]),v.children.push(C),v.children.length>1&&(v.children=v.children.sort((S,c)=>S.pid-c.pid)))}}function d(f){const l=/--utility-sub-type=network/i,p=/--crashes-directory/i,I=/\\pipe\\winpty-control/i,g=/conhost\.exe.+--headless/i,v=/--type=([a-zA-Z-]+)/;if(p.exec(f))return"electron-crash-reporter";if(I.exec(f))return"winpty-agent";if(g.exec(f))return"conpty-agent";let C=v.exec(f);if(C&&C.length===2)return C[1]==="renderer"?"window":C[1]==="utility"?l.exec(f)?"utility-network-service":"utility-process":C[1]==="extensionHost"?"extension-host":C[1];const S=/[a-zA-Z-]+\.js/g;let c="";do C=S.exec(f),C&&(c+=C+" ");while(C);return c&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${c})`:f}if(process.platform==="win32"){const f=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,p)=>{ae(["@vscode/windows-process-tree"],l,p)}).then(De).then(l=>{l.getProcessList(k,p=>{if(!p){D(new Error(`Root process ${k} not found`));return}l.getProcessCpuUsage(p,I=>{const g=new Map;I.forEach(v=>{const C=f(v.commandLine||"");g.set(v.pid,{name:d(C),cmd:C,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),E=g.get(k),E?(g.forEach(v=>{const C=g.get(v.ppid);C&&(C.children||(C.children=[]),C.children.push(v))}),g.forEach(v=>{v.children&&(v.children=v.children.sort((C,S)=>C.pid-S.pid))}),T(E)):D(new Error(`Root process ${k} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let f=function(){let l=[E];const p=[];for(;l.length;){const g=l.shift();g&&(p.push(g.pid),g.children&&(l=l.concat(g.children)))}let I=JSON.stringify(a.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);I+=" "+p.join(" "),(0,P.exec)(I,{},(g,v,C)=>{if(g||C)D(g||new Error(C.toString()));else{const S=v.toString().split(`
`);for(let c=0;c<p.length;c++){const u=R.get(p[c]);u.load=parseFloat(S[c])}if(!E){D(new Error(`Root process ${k} not found`));return}T(E)}})};(0,P.exec)("which ps",{},(l,p,I)=>{if(l||I)if(process.platform!=="linux")D(l||new Error(I.toString()));else{const g=JSON.stringify(a.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(g,{},(v,C,S)=>{v||S?D(v||new Error(S.toString())):(L(C,m),f())})}else{const g=p.toString().trim();(0,P.exec)(`${g} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(C,S,c)=>{C||c&&!c.includes("screen size is bogus")?D(C||new Error(c.toString())):(L(S,m),process.platform==="linux"?f():E?T(E):D(new Error(`Root process ${k} not found`)))})}})}})}function L(k,T){const D=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=k.toString().split(`
`);for(const R of E){const m=D.exec(R.trim());m&&m.length===6&&T(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}});var we=this&&this.__decorate||function(ae,e,P,a){var _=arguments.length,L=_<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,P):a,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ae,e,P,a);else for(var T=ae.length-1;T>=0;T--)(k=ae[T])&&(L=(_<3?k(L):_>3?k(e,P,L):k(e,P))||L);return _>3&&L&&Object.defineProperty(e,P,L),L};define(ue[42],he([0,1,17,6,14,25,87,8,3,2,66,26,12]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=r,e.deserialize=o,e.getDelayedChannel=O,e.getNextTickChannel=N,m=De(m);var f;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(f||(f={}));function l($){switch($){case f.Promise:return"req";case f.PromiseCancel:return"cancel";case f.EventListen:return"subscribe";case f.EventDispose:return"unsubscribe"}}var p;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(p||(p={}));function I($){switch($){case p.Initialize:return"init";case p.PromiseSuccess:return"reply:";case p.PromiseError:case p.PromiseErrorObj:return"replyErr:";case p.EventFire:return"event:"}}var g;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(g||(g={}));function v($){let q=0;for(let Z=0;;Z+=7){const ne=$.read(1);if(q|=(ne.buffer[0]&127)<<Z,!(ne.buffer[0]&128))return q}}const C=n(0);function S($,q){if(q===0){$.write(C);return}let Z=0;for(let le=q;le!==0;le=le>>>7)Z++;const ne=_.VSBuffer.alloc(Z);for(let le=0;q!==0;le++)ne.buffer[le]=q&127,q=q>>>7,q>0&&(ne.buffer[le]|=128);$.write(ne)}class c{constructor(q){this.buffer=q,this.pos=0}read(q){const Z=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Z.byteLength,Z}}e.BufferReader=c;class u{constructor(){this.buffers=[]}get buffer(){return _.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=u;var i;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object",$[$.Int=6]="Int"})(i||(i={}));function n($){const q=_.VSBuffer.alloc(1);return q.writeUInt8($,0),q}const t={Undefined:n(i.Undefined),String:n(i.String),Buffer:n(i.Buffer),VSBuffer:n(i.VSBuffer),Array:n(i.Array),Object:n(i.Object),Uint:n(i.Int)},s=typeof Buffer<"u";function r($,q){if(typeof q>"u")$.write(t.Undefined);else if(typeof q=="string"){const Z=_.VSBuffer.fromString(q);$.write(t.String),S($,Z.byteLength),$.write(Z)}else if(s&&Buffer.isBuffer(q)){const Z=_.VSBuffer.wrap(q);$.write(t.Buffer),S($,Z.byteLength),$.write(Z)}else if(q instanceof _.VSBuffer)$.write(t.VSBuffer),S($,q.byteLength),$.write(q);else if(Array.isArray(q)){$.write(t.Array),S($,q.length);for(const Z of q)r($,Z)}else if(typeof q=="number"&&(q|0)===q)$.write(t.Uint),S($,q);else{const Z=_.VSBuffer.fromString(JSON.stringify(q));$.write(t.Object),S($,Z.byteLength),$.write(Z)}}function o($){switch($.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return $.read(v($)).toString();case i.Buffer:return $.read(v($)).buffer;case i.VSBuffer:return $.read(v($));case i.Array:{const Z=v($),ne=[];for(let le=0;le<Z;le++)ne.push(o($));return ne}case i.Object:return JSON.parse($.read(v($)).toString());case i.Int:return v($)}}class h{constructor(q,Z,ne=null,le=1e3){this.protocol=q,this.ctx=Z,this.logger=ne,this.timeoutDelay=le,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:p.Initialize})}registerChannel(q,Z){this.channels.set(q,Z),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case p.Initialize:{const Z=this.send([q.type]);this.logger?.logOutgoing(Z,0,y.OtherSide,I(q.type));return}case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:{const Z=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(Z,q.id,y.OtherSide,I(q.type),q.data);return}}}send(q,Z=void 0){const ne=new u;return r(ne,q),r(ne,Z),this.sendBuffer(ne.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Z=new c(q),ne=o(Z),le=o(Z),ee=ne[0];switch(ee){case f.Promise:return this.logger?.logIncoming(q.byteLength,ne[1],y.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.onPromise({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case f.EventListen:return this.logger?.logIncoming(q.byteLength,ne[1],y.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.onEventListen({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case f.PromiseCancel:return this.logger?.logIncoming(q.byteLength,ne[1],y.OtherSide,`${l(ee)}`),this.disposeActiveRequest({type:ee,id:ne[1]});case f.EventDispose:return this.logger?.logIncoming(q.byteLength,ne[1],y.OtherSide,`${l(ee)}`),this.disposeActiveRequest({type:ee,id:ne[1]})}}onPromise(q){const Z=this.channels.get(q.channelName);if(!Z){this.collectPendingRequest(q);return}const ne=new L.CancellationTokenSource;let le;try{le=Z.call(this.ctx,q.name,q.arg,ne.token)}catch(K){le=Promise.reject(K)}const ee=q.id;le.then(K=>{this.sendResponse({id:ee,data:K,type:p.PromiseSuccess})},K=>{K instanceof Error?this.sendResponse({id:ee,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split(`
`):void 0},type:p.PromiseError}):this.sendResponse({id:ee,data:K,type:p.PromiseErrorObj})}).finally(()=>{X.dispose(),this.activeRequests.delete(q.id)});const X=(0,E.toDisposable)(()=>ne.cancel());this.activeRequests.set(q.id,X)}onEventListen(q){const Z=this.channels.get(q.channelName);if(!Z){this.collectPendingRequest(q);return}const ne=q.id,ee=Z.listen(this.ctx,q.name,q.arg)(X=>this.sendResponse({id:ne,data:X,type:p.EventFire}));this.activeRequests.set(q.id,ee)}disposeActiveRequest(q){const Z=this.activeRequests.get(q.id);Z&&(Z.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Z=this.pendingRequests.get(q.channelName);Z||(Z=[],this.pendingRequests.set(q.channelName,Z));const ne=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===f.Promise&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:p.PromiseError})},this.timeoutDelay);Z.push({request:q,timeoutTimer:ne})}flushPendingRequests(q){const Z=this.pendingRequests.get(q);if(Z){for(const ne of Z)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case f.Promise:this.onPromise(ne.request);break;case f.EventListen:this.onEventListen(ne.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=h;var y;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class A{constructor(q,Z=null){this.protocol=q,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new D.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=Z}getChannel(q){const Z=this;return{call(ne,le,ee){return Z.isDisposed?Promise.reject(new T.CancellationError):Z.requestPromise(q,ne,le,ee)},listen(ne,le){return Z.isDisposed?D.Event.None:Z.requestEvent(q,ne,le)}}}requestPromise(q,Z,ne,le=L.CancellationToken.None){const ee=this.lastRequestId++,X=f.Promise,K={id:ee,type:X,channelName:q,name:Z,arg:ne};if(le.isCancellationRequested)return Promise.reject(new T.CancellationError);let W;return new Promise((Y,oe)=>{if(le.isCancellationRequested)return oe(new T.CancellationError);const x=()=>{const ie=ce=>{switch(ce.type){case p.PromiseSuccess:this.handlers.delete(ee),Y(ce.data);break;case p.PromiseError:{this.handlers.delete(ee);const ge=new Error(ce.data.message);ge.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,ge.name=ce.data.name,oe(ge);break}case p.PromiseErrorObj:this.handlers.delete(ee),oe(ce.data);break}};this.handlers.set(ee,ie),this.sendRequest(K)};let B=null;this.state===g.Idle?x():(B=(0,a.createCancelablePromise)(ie=>this.whenInitialized()),B.then(()=>{B=null,x()}));const j=()=>{B?(B.cancel(),B=null):this.sendRequest({id:ee,type:f.PromiseCancel}),oe(new T.CancellationError)},G=le.onCancellationRequested(j);W=(0,E.combinedDisposable)((0,E.toDisposable)(j),G),this.activeRequests.add(W)}).finally(()=>{W.dispose(),this.activeRequests.delete(W)})}requestEvent(q,Z,ne){const le=this.lastRequestId++,ee=f.EventListen,X={id:le,type:ee,channelName:q,name:Z,arg:ne};let K=null;const W=new D.Emitter({onWillAddFirstListener:()=>{K=(0,a.createCancelablePromise)(Y=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(W),this.sendRequest(X)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(W),this.sendRequest({id:le,type:f.EventDispose}))}}),U=Y=>W.fire(Y.data);return this.handlers.set(le,U),W.event}sendRequest(q){switch(q.type){case f.Promise:case f.EventListen:{const Z=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(Z,q.id,y.LocalSide,`${l(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case f.PromiseCancel:case f.EventDispose:{const Z=this.send([q.type,q.id]);this.logger?.logOutgoing(Z,q.id,y.LocalSide,l(q.type));return}}}send(q,Z=void 0){const ne=new u;return r(ne,q),r(ne,Z),this.sendBuffer(ne.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Z=new c(q),ne=o(Z),le=o(Z),ee=ne[0];switch(ee){case p.Initialize:return this.logger?.logIncoming(q.byteLength,0,y.LocalSide,I(ee)),this.onResponse({type:ne[0]});case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:return this.logger?.logIncoming(q.byteLength,ne[1],y.LocalSide,I(ee),le),this.onResponse({type:ne[0],id:ne[1],data:le})}}onResponse(q){if(q.type===p.Initialize){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=A,we([k.memoize],A.prototype,"onDidInitializePromise",null);class b{get connections(){const q=[];return this._connections.forEach(Z=>q.push(Z)),q}constructor(q,Z,ne){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new D.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new D.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new E.DisposableStore,this.disposables.add(q(({protocol:le,onDidClientDisconnect:ee})=>{const X=D.Event.once(le.onMessage);this.disposables.add(X(K=>{const W=new c(K),U=o(W),Y=new h(le,U,Z,ne),oe=new A(le,Z);this.channels.forEach((B,j)=>Y.registerChannel(j,B));const x={channelServer:Y,channelClient:oe,ctx:U};this._connections.add(x),this._onDidAddConnection.fire(x),this.disposables.add(ee(()=>{Y.dispose(),oe.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)}))}))}))}getChannel(q,Z){const ne=this;return{call(le,ee,X){let K;if((0,d.isFunction)(Z)){const U=(0,P.getRandomElement)(ne.connections.filter(Z));K=U?Promise.resolve(U):D.Event.toPromise(D.Event.filter(ne.onDidAddConnection,Z))}else K=Z.routeCall(ne,le,ee);const W=K.then(U=>U.channelClient.getChannel(q));return O(W).call(le,ee,X)},listen(le,ee){if((0,d.isFunction)(Z))return ne.getMulticastEvent(q,Z,le,ee);const X=Z.routeEvent(ne,le,ee).then(K=>K.channelClient.getChannel(q));return O(X).listen(le,ee)}}}getMulticastEvent(q,Z,ne,le){const ee=this;let X;const K=new D.Emitter({onWillAddFirstListener:()=>{X=new E.DisposableStore;const W=new D.EventMultiplexer,U=new Map,Y=x=>{const j=x.channelClient.getChannel(q).listen(ne,le),G=W.add(j);U.set(x,G)},oe=x=>{const B=U.get(x);B&&(B.dispose(),U.delete(x))};ee.connections.filter(Z).forEach(Y),D.Event.filter(ee.onDidAddConnection,Z)(Y,void 0,X),ee.onDidRemoveConnection(oe,void 0,X),W.event(K.fire,K,X),X.add(W)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return K.event}registerChannel(q,Z){this.channels.set(q,Z);for(const ne of this._connections)ne.channelServer.registerChannel(q,Z)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class w{constructor(q,Z,ne=null){const le=new u;r(le,Z),q.send(le.buffer),this.channelClient=new A(q,ne),this.channelServer=new h(q,Z,ne)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Z){this.channelServer.registerChannel(q,Z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=w;function O($){return{call(q,Z,ne){return $.then(le=>le.call(q,Z,ne))},listen(q,Z){const ne=new D.Relay;return $.then(le=>ne.input=le.listen(q,Z)),ne.event}}}function N($){let q=!1;return{call(Z,ne,le){return q?$.call(Z,ne,le):(0,a.timeout)(0).then(()=>q=!0).then(()=>$.call(Z,ne,le))},listen(Z,ne){if(q)return $.listen(Z,ne);const le=new D.Relay;return(0,a.timeout)(0).then(()=>q=!0).then(()=>le.input=$.listen(Z,ne)),le.event}}}class F{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Z of q.connections)if(await Promise.resolve(this.fn(Z.ctx)))return Promise.resolve(Z);return await D.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=F;var M;(function($){function q(ee,X,K){const W=ee,U=K&&K.disableMarshalling,Y=new Map;for(const oe in W)ne(oe)&&Y.set(oe,D.Event.buffer(W[oe],!0,void 0,X));return new class{listen(oe,x,B){const j=Y.get(x);if(j)return j;const G=W[x];if(typeof G=="function"){if(le(x))return G.call(W,B);if(ne(x))return Y.set(x,D.Event.buffer(W[x],!0,void 0,X)),Y.get(x)}throw new T.ErrorNoTelemetry(`Event not found: ${x}`)}call(oe,x,B){const j=W[x];if(typeof j=="function"){if(!U&&Array.isArray(B))for(let ie=0;ie<B.length;ie++)B[ie]=(0,R.revive)(B[ie]);let G=j.apply(W,B);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new T.ErrorNoTelemetry(`Method not found: ${x}`)}}}$.fromService=q;function Z(ee,X){const K=X&&X.disableMarshalling;return new Proxy({},{get(W,U){if(typeof U=="string")return X?.properties?.has(U)?X.properties.get(U):le(U)?function(Y){return ee.listen(U,Y)}:ne(U)?ee.listen(U):async function(...Y){let oe;X&&!(0,d.isUndefinedOrNull)(X.context)?oe=[X.context,...Y]:oe=Y;const x=await ee.call(U,oe);return K?x:(0,R.revive)(x)};throw new T.ErrorNoTelemetry(`Property not found: ${String(U)}`)}})}$.toService=Z;function ne(ee){return ee[0]==="o"&&ee[1]==="n"&&m.isUpperAsciiLetter(ee.charCodeAt(2))}function le(ee){return/^onDynamic/.test(ee)&&m.isUpperAsciiLetter(ee.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){const q=$.toString();if(q!=="[object Object]")return q}return $}function J($){return Array.isArray($)?$.map(z):z($)}function V($,q,Z,ne,le,ee,X){X=J(X);const K=H[le],W=K[ne%K.length];let U=[`%c[${$}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(ee)?(U=U.concat(X),U.push(")")):U.push(X),console.log.apply(console,U)}class te{constructor(q,Z){this._outgoingPrefix=q,this._incomingPrefix=Z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Z,ne,le,ee){this._totalOutgoing+=q,V(this._outgoingPrefix,this._totalOutgoing,q,Z,ne,le,ee)}logIncoming(q,Z,ne,le,ee){this._totalIncoming+=q,V(this._incomingPrefix,this._totalIncoming,q,Z,ne,le,ee)}}e.IPCLogger=te}),define(ue[69],he([0,1,14,3,2,42]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var T;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let r=0;function o(y,A){if(!s.has(y)){const b=String(++r);s.set(y,b)}return s.get(y)}function h(y,A,b,w){if(!t.enableDiagnostics)return;const O=o(y,A);if(w instanceof P.VSBuffer||w instanceof Uint8Array||w instanceof ArrayBuffer||ArrayBuffer.isView(w)){const N=P.VSBuffer.alloc(w.byteLength);N.set(w),t.records.push({timestamp:Date.now(),id:O,label:A,type:b,buff:N})}else t.records.push({timestamp:Date.now(),id:O,label:A,type:b,data:w})}t.traceSocketEvent=h})(T||(e.SocketDiagnostics=T={}));var D;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D||(e.SocketCloseEventType=D={}));let E=null;function R(){return E||(E=P.VSBuffer.alloc(0)),E}class m{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,r){if(s===0)return R();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return r&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}const o=P.VSBuffer.alloc(s);let h=0,y=0;for(;s>0;){const A=this._chunks[y];if(A.byteLength>s){const b=A.slice(0,s);o.set(b,h),h+=s,r&&(this._chunks[y]=A.slice(s),this._totalLength-=s),s-=s}else o.set(A,h),h+=A.byteLength,r?(this._chunks.shift(),this._totalLength-=A.byteLength):y++,s-=A.byteLength}return o}}e.ChunkStream=m;var d;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(d||(d={}));function f(t){switch(t){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class p{constructor(s,r,o,h){this.type=s,this.id=r,this.ack=o,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class I extends _.Disposable{constructor(s){super(),this._onMessage=this._register(new a.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:l.HeaderLength,messageType:d.None,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new m,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent(k.ProtocolHeaderRead,{messageType:f(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,h=this._state.id,y=this._state.ack;if(this._state.readHead=!0,this._state.readLen=l.HeaderLength,this._state.messageType=d.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(k.ProtocolMessageRead,r),this._onMessage.fire(new p(o,h,y,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=P.VSBuffer.alloc(l.HeaderLength);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent(k.ProtocolHeaderWrite,{messageType:f(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent(k.ProtocolMessageWrite,s.data),this._writeSoon(r,s.data)}_bufferAdd(s,r){const o=this._totalLength===0;return this._data.push(s,r),this._totalLength+=s.byteLength+r.byteLength,o}_bufferTake(){const s=P.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,r){this._bufferAdd(s,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent(k.ProtocolWrite,{byteLength:s.byteLength}),this._socket.write(s)}}class v extends _.Disposable{constructor(s){super(),this._onMessage=new a.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new a.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new I(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===d.Regular&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(d.Regular,0,0,s))}}e.Protocol=v;class C extends L.IPCClient{static fromSocket(s,r){return new C(new v(s),r)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,r,o=null){super(s,r,o),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=C;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new a.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class c{constructor(s){this.data=s,this.next=null}}class u{constructor(){this._first=null,this._last=null}length(){let s=0,r=this._first;for(;r;)r=r.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let r=0,o=this._first;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const r=new c(s);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class i{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let r=0;r<i._HISTORY_LENGTH;r++)this.lastRuns[r]=s-1e3*r;setInterval(()=>{for(let r=i._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),r=(1+i._HISTORY_LENGTH)*1e3;let o=0;for(let h=0;h<i._HISTORY_LENGTH;h++)s-this.lastRuns[h]<=r&&o++;return 1-o/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s){this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s.loadEstimator??i.getInstance(),this._shouldSendKeepAlive=s.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new _.DisposableStore,this._socket=s.socket,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new I(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.add(this._socket.onClose(r=>this._onSocketClose.fire(r))),s.initialChunk&&this._socketReader.acceptChunk(s.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},l.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){if(!this._didSendDisconnect){this._didSendDisconnect=!0;const s=new p(d.Disconnect,0,0,R());this._socketWriter.write(s),this._socketWriter.flush()}}sendPause(){const s=new p(d.Pause,0,0,R());this._socketWriter.write(s)}sendResume(){const s=new p(d.Resume,0,0,R());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,r){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new _.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new I(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.add(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new p(d.Ack,0,this._incomingAckId,R());this._socketWriter.write(s);const r=this._outgoingUnackMsg.toArray();for(let o=0,h=r.length;o<h;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case d.None:break;case d.Regular:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new p(d.ReplayRequest,0,0,R())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case d.Control:{this._onControlMessage.fire(s.data);break}case d.Ack:break;case d.Disconnect:{this._onDidDispose.fire();break}case d.ReplayRequest:{const r=this._outgoingUnackMsg.toArray();for(let o=0,h=r.length;o<h;o++)this._socketWriter.write(r[o]);this._recvAckCheck();break}case d.Pause:{this._socketWriter.pause();break}case d.Resume:{this._socketWriter.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new p(d.Regular,r,this._incomingAckId,s);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(s){const r=new p(d.Control,0,0,s);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=l.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},l.AcknowledgeTime-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),r=Date.now()-s.writtenTime,o=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(r>=l.TimeoutTime&&o>=l.TimeoutTime&&h>=l.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const y=Math.max(l.TimeoutTime-r,l.TimeoutTime-o,l.TimeoutTime-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},y)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new p(d.Ack,0,this._incomingAckId,R());this._socketWriter.write(s)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const s=new p(d.KeepAlive,0,this._incomingAckId,R());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(ue[95],he([0,1,68,6,14,25,139,8,3,2,29,148,91,42]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,T=De(T);class l extends f.ChannelServer{constructor(g){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:D.Event.fromNodeEventEmitter(process,"message",v=>_.VSBuffer.wrap(Buffer.from(v,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=l;class p{constructor(g,v){this.modulePath=g,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new D.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const C=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new a.Delayer(C),this.child=null,this._client=null}getChannel(g){const v=this;return{call(C,S,c){return v.requestPromise(g,C,S,c)},listen(C,S){return v.requestEvent(g,C,S)}}}requestPromise(g,v,C,S=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(T.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(g),u=(0,a.createCancelablePromise)(t=>c.call(v,C,t)),i=S.onCancellationRequested(()=>u.cancel()),n=(0,E.toDisposable)(()=>u.cancel());return this.activeRequests.add(n),u.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(g,v,C){if(!this.disposeDelayer)return D.Event.None;this.disposeDelayer.cancel();let S;const c=new D.Emitter({onWillAddFirstListener:()=>{S=this.getCachedChannel(g).listen(v,C)(c.fire,c),this.activeRequests.add(S)},onDidRemoveLastListener:()=>{this.activeRequests.delete(S),S.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,d.removeDangerousEnvVariables)(v.env),this.child=(0,P.fork)(this.modulePath,g,v);const C=new D.Emitter,c=D.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,k.isRemoteConsoleLog)(r)){(0,k.log)(r,`IPC Library: ${this.options.serverName}`);return}C.fire(_.VSBuffer.wrap(Buffer.from(r,"base64")))}),u=this.options.useQueue?(0,m.createQueuedSender)(this.child):this.child,i=r=>this.child&&this.child.connected&&u.send(r.buffer.toString("base64")),n=C.event,t={send:i,onMessage:n};this._client=new f.ChannelClient(t);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,o)=>{process.removeListener("exit",s),c.dispose(),this.activeRequests.forEach(h=>(0,E.dispose)(h)),this.activeRequests.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:o})})}return this._client}getCachedChannel(g){let v=this.channels.get(g);return v||(v=this.client.getChannel(g),this.channels.set(g,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(ue[150],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=P;function P(a){return!!a.parentPort}}),define(ue[151],he([0,1,150,14,42,3,12,17]),function(ae,e,P,a,_,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=R;class D{constructor(d){this.port=d,this.onMessage=L.Event.fromNodeEventEmitter(this.port,"message",f=>f.data?a.VSBuffer.wrap(f.data):a.VSBuffer.alloc(0)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}class E extends _.IPCServer{static getOnDidClientConnect(d){(0,k.assertType)((0,P.isUtilityProcess)(process),"Electron Utility Process");const f=new L.Emitter;return process.parentPort.on("message",l=>{if(d?.handledClientConnection(l))return;const p=(0,T.firstOrDefault)(l.ports);p&&f.fire(p)}),L.Event.map(f.event,l=>({protocol:new D(l),onDidClientDisconnect:L.Event.fromNodeEventEmitter(l,"close")}))}constructor(d){super(E.getOnDidClientConnect(d))}}e.Server=E;function R(m,d,f){const l=p=>{p.data===d&&(m.removeListener("message",l),f())};m.on("message",l)}}),define(ue[70],he([0,1,6,3,2,66,12]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=D;var T;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function D(d){const f=d;return f?.changed instanceof Map||f?.deleted instanceof Set}var E;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(E||(e.StorageState=E={}));class R extends _.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(f,l=Object.create(null)){super(),this.database=f,this.options=l,this._onDidChangeStorage=this._register(new a.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=this._register(new P.ThrottledDelayer(R.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){this._onDidChangeStorage.pause();try{f.changed?.forEach((l,p)=>this.acceptExternal(p,l)),f.deleted?.forEach(l=>this.acceptExternal(l,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(f,l){if(this.state===E.Closed)return;let p=!1;(0,k.isUndefinedOrNull)(l)?p=this.cache.delete(f):this.cache.get(f)!==l&&(this.cache.set(f,l),p=!0),p&&this._onDidChangeStorage.fire({key:f,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,l){const p=this.cache.get(f);return(0,k.isUndefinedOrNull)(p)?l:p}getBoolean(f,l){const p=this.get(f);return(0,k.isUndefinedOrNull)(p)?l:p==="true"}getNumber(f,l){const p=this.get(f);return(0,k.isUndefinedOrNull)(p)?l:parseInt(p,10)}getObject(f,l){const p=this.get(f);return(0,k.isUndefinedOrNull)(p)?l:(0,L.parse)(p)}async set(f,l,p=!1){if(this.state===E.Closed)return;if((0,k.isUndefinedOrNull)(l))return this.delete(f,p);const I=(0,k.isObject)(l)||Array.isArray(l)?(0,L.stringify)(l):String(l);if(this.cache.get(f)!==I)return this.cache.set(f,I),this.pendingInserts.set(f,I),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire({key:f,external:p}),this.doFlush()}async delete(f,l=!1){if(!(this.state===E.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire({key:f,external:l}),this.doFlush()}async optimize(){if(this.state!==E.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!(this.state===E.Closed||this.pendingClose))return this.doFlush(f)}async doFlush(f){return this.options.hint===T.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}isInMemory(){return this.options.hint===T.STORAGE_IN_MEMORY}}e.Storage=R;class m{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert?.forEach((l,p)=>this.items.set(p,l)),f.delete?.forEach(l=>this.items.delete(l))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=m}),define(ue[11],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=_,e.localize2=k;const P=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function a(T,D){let E;return D.length===0?E=T:E=T.replace(/\{(\d+)\}/g,(R,m)=>{const d=m[0],f=D[d];let l=R;return typeof f=="string"?l=f:(typeof f=="number"||typeof f=="boolean"||f===void 0||f===null)&&(l=String(f)),l}),P&&(E="\uFF3B"+E.replace(/[aouei]/g,"$&$&")+"\uFF3D"),E}function _(T,D,...E){return a(typeof T=="number"?L(T,D):D,E)}function L(T,D){const E=globalThis._VSCODE_NLS_MESSAGES?.[T];if(typeof E!="string"){if(typeof D=="string")return D;throw new Error(`!!! NLS MISSING: ${T} !!!`)}return E}function k(T,D,...E){let R;typeof T=="number"?R=L(T,D):R=D;const m=a(R,E);return{value:m,original:D===R?m:a(D,E)}}}),define(ue[71],he([0,1,11]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=E,e.getDurationString=R,e.toLocalISOString=m;const a=60,_=a*60,L=_*24,k=L*7,T=L*30,D=L*365;function E(d,f,l,p){typeof d!="number"&&(d=d.getTime());const I=Math.round((new Date().getTime()-d)/1e3);if(I<-30)return(0,P.localize)(12985,null,E(new Date().getTime()+I*1e3,!1));if(!p&&I<30)return(0,P.localize)(12986,null);let g;return I<a?(g=I,f?g===1?l?(0,P.localize)(12987,null,g):(0,P.localize)(12988,null,g):l?(0,P.localize)(12989,null,g):(0,P.localize)(12990,null,g):g===1?l?(0,P.localize)(12991,null,g):(0,P.localize)(12992,null,g):l?(0,P.localize)(12993,null,g):(0,P.localize)(12994,null,g)):I<_?(g=Math.floor(I/a),f?g===1?l?(0,P.localize)(12995,null,g):(0,P.localize)(12996,null,g):l?(0,P.localize)(12997,null,g):(0,P.localize)(12998,null,g):g===1?l?(0,P.localize)(12999,null,g):(0,P.localize)(13e3,null,g):l?(0,P.localize)(13001,null,g):(0,P.localize)(13002,null,g)):I<L?(g=Math.floor(I/_),f?g===1?l?(0,P.localize)(13003,null,g):(0,P.localize)(13004,null,g):l?(0,P.localize)(13005,null,g):(0,P.localize)(13006,null,g):g===1?l?(0,P.localize)(13007,null,g):(0,P.localize)(13008,null,g):l?(0,P.localize)(13009,null,g):(0,P.localize)(13010,null,g)):I<k?(g=Math.floor(I/L),f?g===1?(0,P.localize)(13011,null,g):(0,P.localize)(13012,null,g):g===1?(0,P.localize)(13013,null,g):(0,P.localize)(13014,null,g)):I<T?(g=Math.floor(I/k),f?g===1?l?(0,P.localize)(13015,null,g):(0,P.localize)(13016,null,g):l?(0,P.localize)(13017,null,g):(0,P.localize)(13018,null,g):g===1?l?(0,P.localize)(13019,null,g):(0,P.localize)(13020,null,g):l?(0,P.localize)(13021,null,g):(0,P.localize)(13022,null,g)):I<D?(g=Math.floor(I/T),f?g===1?l?(0,P.localize)(13023,null,g):(0,P.localize)(13024,null,g):l?(0,P.localize)(13025,null,g):(0,P.localize)(13026,null,g):g===1?l?(0,P.localize)(13027,null,g):(0,P.localize)(13028,null,g):l?(0,P.localize)(13029,null,g):(0,P.localize)(13030,null,g)):(g=Math.floor(I/D),f?g===1?l?(0,P.localize)(13031,null,g):(0,P.localize)(13032,null,g):l?(0,P.localize)(13033,null,g):(0,P.localize)(13034,null,g):g===1?l?(0,P.localize)(13035,null,g):(0,P.localize)(13036,null,g):l?(0,P.localize)(13037,null,g):(0,P.localize)(13038,null,g))}function R(d,f){const l=Math.abs(d/1e3);return l<1?f?(0,P.localize)(13039,null,d):(0,P.localize)(13040,null,d):l<a?f?(0,P.localize)(13041,null,Math.round(d)/1e3):(0,P.localize)(13042,null,Math.round(d)/1e3):l<_?f?(0,P.localize)(13043,null,Math.round(d/(1e3*a))):(0,P.localize)(13044,null,Math.round(d/(1e3*a))):l<L?f?(0,P.localize)(13045,null,Math.round(d/(1e3*_))):(0,P.localize)(13046,null,Math.round(d/(1e3*_))):(0,P.localize)(13047,null,Math.round(d/(1e3*L)))}function m(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ue[43],he([0,1,17,12,11]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=D,e.isErrorWithActions=E,e.createErrorWithActions=R,P=De(P),a=De(a),_=De(_);function L(m,d){return d&&(m.stack||m.stacktrace)?_.localize(12979,null,T(m),k(m.stack)||k(m.stacktrace)):T(m)}function k(m){return Array.isArray(m)?m.join(`
`):m}function T(m){return m.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${m.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?_.localize(12980,null,m.message):m.message||_.localize(12981,null)}function D(m=null,d=!1){if(!m)return _.localize(12982,null);if(Array.isArray(m)){const f=P.coalesce(m),l=D(f[0],d);return f.length>1?_.localize(12983,null,l,f.length):l}if(a.isString(m))return m;if(m.detail){const f=m.detail;if(f.error)return L(f.error,d);if(f.exception)return L(f.exception,d)}return m.stack?L(m,d):m.message?m.message:_.localize(12984,null)}function E(m){const d=m;return d instanceof Error&&Array.isArray(d.actions)}function R(m,d){let f;return typeof m=="string"?f=new Error(m):f=m,f.actions=d,f}}),define(ue[152],he([0,1,11,36]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=_;function _(L){switch(L){case a.ParseErrorCode.InvalidSymbol:return(0,P.localize)(12970,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(12971,null);case a.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(12972,null);case a.ParseErrorCode.ValueExpected:return(0,P.localize)(12973,null);case a.ParseErrorCode.ColonExpected:return(0,P.localize)(12974,null);case a.ParseErrorCode.CommaExpected:return(0,P.localize)(12975,null);case a.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(12976,null);case a.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(12977,null);case a.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(12978,null);default:return""}}}),define(ue[72],he([0,1,33,6,13,12,30,11]),function(ae,e,P,a,_,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=I,e.extract=g,e.buffer=C,_=De(_),T=De(T),e.CorruptZipMessage="end of central directory record signature not found";const D=new RegExp(e.CorruptZipMessage);class E extends Error{constructor(c,u){let i=u.message;switch(c){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=c,this.cause=u}}e.ExtractError=E;function R(S){const c=S.externalFileAttributes>>16||33188;return[448,56,7].map(u=>c&u).reduce((u,i)=>u+i,c&61440)}function m(S){if(S instanceof E)return S;let c;return D.test(S.message)&&(c="CorruptZip"),new E(c,S)}function d(S,c,u,i,n,t){const s=_.dirname(c),r=_.join(i,s);if(!r.startsWith(i))return Promise.reject(new Error(T.localize(13049,null,c)));const o=_.join(i,c);let h;return t.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(P.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,A)=>{if(!t.isCancellationRequested)try{h=(0,P.createWriteStream)(o,{mode:u}),h.once("close",()=>y()),h.once("error",A),S.once("error",A),S.pipe(h)}catch(b){A(b)}}))}function f(S,c,u,i){let n=(0,a.createCancelablePromise)(()=>Promise.resolve()),t=0;const s=i.onCancellationRequested(()=>{n.cancel(),S.close()});return new Promise((r,o)=>{const h=new a.Sequencer,y=A=>{A.isCancellationRequested||(t++,S.readEntry())};S.once("error",o),S.once("close",()=>n.then(()=>{i.isCancellationRequested||S.entryCount===t?r():o(new E("Incomplete",new Error(T.localize(13050,null,t,S.entryCount))))},o)),S.readEntry(),S.on("entry",A=>{if(i.isCancellationRequested)return;if(!u.sourcePathRegex.test(A.fileName)){y(i);return}const b=A.fileName.replace(u.sourcePathRegex,"");if(/\/$/.test(b)){const N=_.join(c,b);n=(0,a.createCancelablePromise)(F=>P.promises.mkdir(N,{recursive:!0}).then(()=>y(F)).then(void 0,o));return}const w=p(S,A),O=R(A);n=(0,a.createCancelablePromise)(N=>h.queue(()=>w.then(F=>d(F,b,O,c,u,N).then(()=>y(N)))).then(null,o))})}).finally(()=>s.dispose())}async function l(S,c=!1){const{open:u}=await new Promise((i,n)=>{ae(["yauzl"],i,n)}).then(De);return new Promise((i,n)=>{u(S,c?{lazyEntries:!0}:void 0,(t,s)=>{t?n(m(t)):i((0,L.assertIsDefined)(s))})})}function p(S,c){return new Promise((u,i)=>{S.openReadStream(c,(n,t)=>{n?i(m(n)):u((0,L.assertIsDefined)(t))})})}async function I(S,c){const{ZipFile:u}=await new Promise((i,n)=>{ae(["yazl"],i,n)}).then(De);return new Promise((i,n)=>{const t=new u;c.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const s=(0,P.createWriteStream)(S);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>i(S))})}function g(S,c,u={},i){const n=new RegExp(u.sourcePath?`^${u.sourcePath}`:"");let t=l(S,!0);return u.overwrite&&(t=t.then(s=>k.Promises.rm(c).then(()=>s))),t.then(s=>f(s,c,{sourcePathRegex:n},i))}function v(S,c){return l(S).then(u=>new Promise((i,n)=>{u.on("entry",t=>{t.fileName===c&&p(u,t).then(s=>i(s),s=>n(s))}),u.once("close",()=>n(new Error(T.localize(13051,null,c))))}))}function C(S,c){return v(S,c).then(u=>new Promise((i,n)=>{const t=[];u.once("error",n),u.on("data",s=>t.push(s)),u.on("end",()=>i(Buffer.concat(t)))}))}}),define(ue[153],he([0,1,39,8,11]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var L;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(L||(e.TokenType=L={}));function k(...R){switch(R.length){case 1:return(0,_.localize)(11586,null,R[0]);case 2:return(0,_.localize)(11587,null,R[0],R[1]);case 3:return(0,_.localize)(11588,null,R[0],R[1],R[2]);default:return}}const T=(0,_.localize)(11589,null),D=(0,_.localize)(11590,null);class E{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case L.LParen:return"(";case L.RParen:return")";case L.Neg:return"!";case L.Eq:return m.isTripleEq?"===":"==";case L.NotEq:return m.isTripleEq?"!==":"!=";case L.Lt:return"<";case L.LtEq:return"<=";case L.Gt:return">=";case L.GtEq:return">=";case L.RegexOp:return"=~";case L.RegexStr:return m.lexeme;case L.True:return"true";case L.False:return"false";case L.In:return"in";case L.Not:return"not";case L.And:return"&&";case L.Or:return"||";case L.Str:return m.lexeme;case L.QuotedStr:return m.lexeme;case L.Error:return m.lexeme;case L.EOF:return"EOF";default:throw(0,a.illegalState)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this._keywords=new Map([["not",L.Not],["in",L.In],["false",L.False],["true",L.True]])}get errors(){return this._errors}reset(m){return this._input=m,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case P.CharCode.OpenParen:this._addToken(L.LParen);break;case P.CharCode.CloseParen:this._addToken(L.RParen);break;case P.CharCode.ExclamationMark:if(this._match(P.CharCode.Equals)){const d=this._match(P.CharCode.Equals);this._tokens.push({type:L.NotEq,offset:this._start,isTripleEq:d})}else this._addToken(L.Neg);break;case P.CharCode.SingleQuote:this._quotedString();break;case P.CharCode.Slash:this._regex();break;case P.CharCode.Equals:if(this._match(P.CharCode.Equals)){const d=this._match(P.CharCode.Equals);this._tokens.push({type:L.Eq,offset:this._start,isTripleEq:d})}else this._match(P.CharCode.Tilde)?this._addToken(L.RegexOp):this._error(k("==","=~"));break;case P.CharCode.LessThan:this._addToken(this._match(P.CharCode.Equals)?L.LtEq:L.Lt);break;case P.CharCode.GreaterThan:this._addToken(this._match(P.CharCode.Equals)?L.GtEq:L.Gt);break;case P.CharCode.Ampersand:this._match(P.CharCode.Ampersand)?this._addToken(L.And):this._error(k("&&"));break;case P.CharCode.Pipe:this._match(P.CharCode.Pipe)?this._addToken(L.Or):this._error(k("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(L.EOF),Array.from(this._tokens)}_match(m){return this._isAtEnd()||this._input.charCodeAt(this._current)!==m?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?P.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(m){this._tokens.push({type:m,offset:this._start})}_error(m){const d=this._start,f=this._input.substring(this._start,this._current),l={type:L.Error,offset:this._start,lexeme:f};this._errors.push({offset:d,lexeme:f,additionalInfo:m}),this._tokens.push(l)}_string(){this.stringRe.lastIndex=this._start;const m=this.stringRe.exec(this._input);if(m){this._current=this._start+m[0].length;const d=this._input.substring(this._start,this._current),f=E._keywords.get(d);f?this._addToken(f):this._tokens.push({type:L.Str,lexeme:d,offset:this._start})}}_quotedString(){for(;this._peek()!==P.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:L.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let m=this._current,d=!1,f=!1;for(;;){if(m>=this._input.length){this._current=m,this._error(D);return}const p=this._input.charCodeAt(m);if(d)d=!1;else if(p===P.CharCode.Slash&&!f){m++;break}else p===P.CharCode.OpenSquareBracket?f=!0:p===P.CharCode.Backslash?d=!0:p===P.CharCode.CloseSquareBracket&&(f=!1);m++}for(;m<this._input.length&&E._regexFlags.has(this._input.charCodeAt(m));)m++;this._current=m;const l=this._input.substring(this._start,this._current);this._tokens.push({type:L.RegexStr,lexeme:l,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=E}),define(ue[154],he([0,1,71,87,22,13,37,20,9]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=R,e.parseDebugParams=m,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class E{get appRoot(){return(0,L.dirname)(_.FileAccess.asFileUri("").fsPath)}get userHome(){return D.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return D.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return D.URI.file(this.paths.tmpDir)}get cacheHome(){return D.URI.file(this.userDataPath)}get stateResource(){return(0,T.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:_.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,T.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",f)}return D.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(D.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,T.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,T.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=k.env.VSCODE_PORTABLE;return f?D.URI.file((0,L.join)(f,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return D.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,L.resolve)(f):(0,L.normalize)((0,L.join)(_.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?D.URI.file((0,L.resolve)(f)):D.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,L.resolve)(f);const l=k.env.VSCODE_EXTENSIONS;if(l)return l;const p=k.env.VSCODE_PORTABLE;return p?(0,L.join)(p,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(l=>/^[^:/?#]+?:\/\//.test(l)?D.URI.parse(l):D.URI.file((0,L.normalize)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?D.URI.parse(f):D.URI.file((0,L.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const l of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(l);p&&p[1]&&p[2]&&f.push([p[1],p[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,T.joinPath)(D.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=k.env.VSCODE_PORTABLE;return f?D.URI.file((0,L.join)(f,"policy.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this._args}constructor(f,l,p){this._args=f,this.paths=l,this.productService=p,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=E,we([a.memoize],E.prototype,"appRoot",null),we([a.memoize],E.prototype,"userHome",null),we([a.memoize],E.prototype,"userDataPath",null),we([a.memoize],E.prototype,"appSettingsHome",null),we([a.memoize],E.prototype,"tmpDir",null),we([a.memoize],E.prototype,"cacheHome",null),we([a.memoize],E.prototype,"stateResource",null),we([a.memoize],E.prototype,"userRoamingDataHome",null),we([a.memoize],E.prototype,"userDataSyncHome",null),we([a.memoize],E.prototype,"sync",null),we([a.memoize],E.prototype,"machineSettingsResource",null),we([a.memoize],E.prototype,"workspaceStorageHome",null),we([a.memoize],E.prototype,"localHistoryHome",null),we([a.memoize],E.prototype,"keyboardLayoutResource",null),we([a.memoize],E.prototype,"argvResource",null),we([a.memoize],E.prototype,"isExtensionDevelopment",null),we([a.memoize],E.prototype,"untitledWorkspacesHome",null),we([a.memoize],E.prototype,"builtinExtensionsPath",null),we([a.memoize],E.prototype,"extensionsPath",null),we([a.memoize],E.prototype,"extensionDevelopmentLocationURI",null),we([a.memoize],E.prototype,"extensionDevelopmentKind",null),we([a.memoize],E.prototype,"extensionTestsLocationURI",null),we([a.memoize],E.prototype,"debugExtensionHost",null),we([a.memoize],E.prototype,"logLevel",null),we([a.memoize],E.prototype,"extensionLogLevel",null),we([a.memoize],E.prototype,"serviceMachineIdResource",null),we([a.memoize],E.prototype,"disableTelemetry",null),we([a.memoize],E.prototype,"disableWorkspaceTrust",null),we([a.memoize],E.prototype,"useInMemorySecretStorage",null),we([a.memoize],E.prototype,"policyFile",null);function R(d,f){return m(d["inspect-extensions"],d["inspect-brk-extensions"],5870,f,d.debugId,d.extensionEnvironment)}function m(d,f,l,p,I,g){const C=Number(f||d)||(p?null:l),S=C?!!f:!1;let c;if(g)try{c=JSON.parse(g)}catch{}return{port:C,break:S,debugId:I,env:c}}}),function(){function ae(e,P,a){function _(k,T){const D=L(k,T),E=[D];return e.isAbsolute(D)||E.unshift(a),e.resolve(...E)}function L(k,T){process.env.VSCODE_DEV&&(T="code-oss-dev");const D=process.env.VSCODE_PORTABLE;if(D)return e.join(D,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,T);const R=k["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(m,"AppData","Roaming")}break;case"darwin":E=e.join(P.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,T)}return{getUserDataPath:_}}if(typeof define=="function")define(ue[155],he([243,38,37]),function(e,P,a){return ae(e,P,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=ae(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ue[156],he([0,1,38,154,155]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=k,e.parseSharedProcessDebugPort=T;class L extends a.AbstractNativeEnvironmentService{constructor(E,R){super(E,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,_.getUserDataPath)(E,R.nameShort)},R)}}e.NativeEnvironmentService=L;function k(D,E){return(0,a.parseDebugParams)(D["inspect-ptyhost"],D["inspect-brk-ptyhost"],5877,E,D.extensionEnvironment)}function T(D,E){return(0,a.parseDebugParams)(D["inspect-sharedprocess"],D["inspect-brk-sharedprocess"],5879,E,D.extensionEnvironment)}}),define(ue[157],he([0,1,12,11]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=_;function _(k,T,D,E){try{L(k,T,D,E)}catch(R){k.error(R?.message??R)}return T}function L(k,T,D,E){const R=(m,d,f)=>{const l=m[d];if((0,P.isString)(l)){const p=l,I=p.length;if(I>1&&p[0]==="%"&&p[I-1]==="%"){const g=p.substr(1,I-2);let v=D[g];v===void 0&&E&&(v=E[g]);const C=typeof v=="string"?v:v?.message,S=E?.[g],c=typeof S=="string"?S:S?.message;if(!C){c||k.warn(`[${T.name}]: ${(0,a.localize)(11469,null,g)}`);return}if(f&&(d==="title"||d==="category")&&c&&c!==C){const u={value:C,original:c};m[d]=u}else m[d]=C}}else if((0,P.isObject)(l))for(const p in l)l.hasOwnProperty(p)&&(p==="commands"?R(l,p,!0):R(l,p,f));else if(Array.isArray(l))for(let p=0;p<l.length;p++)R(l,p,f)};for(const m in T)T.hasOwnProperty(m)&&R(T,m)}}),define(ue[158],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class P{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.channel.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=P;class a{constructor(L){this.service=L}listen(L,k){throw new Error(`Event not found: ${k}`)}call(L,k,T){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(T[0])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=a}),define(ue[159],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const P={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(P)}),define(ue[73],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class P{constructor(_,L=[],k=!1){this.ctor=_,this.staticArguments=L,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=P}),define(ue[160],he([0,1,73]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=L,e.getSingletonServiceDescriptors=k;const a=[];var _;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(_||(e.InstantiationType=_={}));function L(T,D,E){D instanceof P.SyncDescriptor||(D=new P.SyncDescriptor(D,[],!!E)),a.push([T,D])}function k(){return a}}),define(ue[161],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class P{constructor(L,k){this.key=L,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=P;class a{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const k of this._nodes.values())k.outgoing.size===0&&L.push(k);return L}insertEdge(L,k){const T=this.lookupOrInsertNode(L),D=this.lookupOrInsertNode(k);T.outgoing.set(D.key,D),D.incoming.set(T.key,T)}removeNode(L){const k=this._hashFn(L);this._nodes.delete(k);for(const T of this._nodes.values())T.outgoing.delete(k),T.incoming.delete(k)}lookupOrInsertNode(L){const k=this._hashFn(L);let T=this._nodes.get(k);return T||(T=new P(k,L),this._nodes.set(k,T)),T}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[k,T]of this._nodes)L.push(`${k}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,k]of this._nodes){const T=new Set([L]),D=this._findCycle(k,T);if(D)return D}}_findCycle(L,k){for(const[T,D]of L.outgoing){if(k.has(T))return[...k,T].join(" -> ");k.add(T);const E=this._findCycle(D,k);if(E)return E;k.delete(T)}}}e.Graph=a}),define(ue[4],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=_,e.refineServiceDecorator=L;var P;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function T(D){return D[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=T})(P||(e._util=P={})),e.IInstantiationService=_("instantiationService");function a(k,T,D){T[P.DI_TARGET]===T?T[P.DI_DEPENDENCIES].push({id:k,index:D}):(T[P.DI_DEPENDENCIES]=[{id:k,index:D}],T[P.DI_TARGET]=T)}function _(k){if(P.serviceIds.has(k))return P.serviceIds.get(k);const T=function(D,E,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(T,D,R)};return T.toString=()=>k,P.serviceIds.set(k,T),T}function L(k){return k}}),define(ue[162],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,P.createDecorator)("checksumService")}),define(ue[21],he([0,1,12,9,4]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=L,e.isConfigurationUpdateOverrides=k,e.ConfigurationTargetToString=D,e.isConfigured=E,e.toValuesTree=R,e.addToValueTree=m,e.removeFromValueTree=d,e.getConfigurationValue=l,e.merge=p,e.getLanguageTagSettingPlainKey=I,P=De(P),e.IConfigurationService=(0,_.createDecorator)("configurationService");function L(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof a.URI)}function k(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof a.URI)}var T;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function D(g){switch(g){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function E(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}function R(g,v){const C=Object.create(null);for(const S in g)m(C,S,g[S],v);return C}function m(g,v,C,S){const c=v.split("."),u=c.pop();let i=g;for(let n=0;n<c.length;n++){const t=c[n];let s=i[t];switch(typeof s){case"undefined":s=i[t]=Object.create(null);break;case"object":if(s===null){S(`Ignoring ${v} as ${c.slice(0,n+1).join(".")} is null`);return}break;default:S(`Ignoring ${v} as ${c.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[u]=C}catch{S(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(i)}`)}else S(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(i)}`)}function d(g,v){const C=v.split(".");f(g,C)}function f(g,v){const C=v.shift();if(v.length===0){delete g[C];return}if(Object.keys(g).indexOf(C)!==-1){const S=g[C];typeof S=="object"&&!Array.isArray(S)&&(f(S,v),Object.keys(S).length===0&&delete g[C])}}function l(g,v,C){function S(i,n){let t=i;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const c=v.split("."),u=S(g,c);return typeof u>"u"?C:u}function p(g,v,C){Object.keys(v).forEach(S=>{S!=="__proto__"&&(S in g?P.isObject(g[S])&&P.isObject(v[S])?p(g[S],v[S],C):C&&(g[S]=v[S]):g[S]=v[S])})}function I(g){return g.replace(/[\[\]]/g,"")}}),define(ue[96],he([0,1,39,5,26,153,4,11,8]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=R,e.validateWhenClauses=n,e.expressionsAreEqualWithConstantSubstitution=t,e.implies=ee;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",a.isMacintosh),E.set("isLinux",a.isLinux),E.set("isWindows",a.isWindows),E.set("isWeb",a.isWeb),E.set("isMacNative",a.isMacintosh&&!a.isWeb),E.set("isEdge",a.isEdge),E.set("isFirefox",a.isFirefox),E.set("isChrome",a.isChrome),E.set("isSafari",a.isSafari);function R(W,U){if(E.get(W)!==void 0)throw(0,D.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(W,U)}const m=Object.prototype.hasOwnProperty;var d;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const f={regexParsingWithErrorRecovery:!0},l=(0,T.localize)(11600,null),p=(0,T.localize)(11601,null),I=(0,T.localize)(11602,null),g=(0,T.localize)(11603,null),v=(0,T.localize)(11604,null),C=(0,T.localize)(11605,null),S=(0,T.localize)(11606,null),c=(0,T.localize)(11607,null);class u{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(U=f){this._config=U,this._scanner=new L.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(U){if(U===""){this._parsingErrors.push({message:l,offset:0,lexeme:"",additionalInfo:p});return}this._tokens=this._scanner.reset(U).scan(),this._current=0,this._parsingErrors=[];try{const Y=this._expr();if(!this._isAtEnd()){const oe=this._peek(),x=oe.type===L.TokenType.Str?C:void 0;throw this._parsingErrors.push({message:v,offset:oe.offset,lexeme:L.Scanner.getLexeme(oe),additionalInfo:x}),u._parseError}return Y}catch(Y){if(Y!==u._parseError)throw Y;return}}_expr(){return this._or()}_or(){const U=[this._and()];for(;this._matchOne(L.TokenType.Or);){const Y=this._and();U.push(Y)}return U.length===1?U[0]:i.or(...U)}_and(){const U=[this._term()];for(;this._matchOne(L.TokenType.And);){const Y=this._term();U.push(Y)}return U.length===1?U[0]:i.and(...U)}_term(){if(this._matchOne(L.TokenType.Neg)){const U=this._peek();switch(U.type){case L.TokenType.True:return this._advance(),r.INSTANCE;case L.TokenType.False:return this._advance(),o.INSTANCE;case L.TokenType.LParen:{this._advance();const Y=this._expr();return this._consume(L.TokenType.RParen,g),Y?.negate()}case L.TokenType.Str:return this._advance(),O.create(U.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",U)}}return this._primary()}_primary(){const U=this._peek();switch(U.type){case L.TokenType.True:return this._advance(),i.true();case L.TokenType.False:return this._advance(),i.false();case L.TokenType.LParen:{this._advance();const Y=this._expr();return this._consume(L.TokenType.RParen,g),Y}case L.TokenType.Str:{const Y=U.lexeme;if(this._advance(),this._matchOne(L.TokenType.RegexOp)){const x=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),x.type!==L.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",x);const B=x.lexeme,j=B.lastIndexOf("/"),G=j===B.length-1?void 0:this._removeFlagsGY(B.substring(j+1));let ie;try{ie=new RegExp(B.substring(1,j),G)}catch{throw this._errExpectedButGot("REGEX",x)}return J.create(Y,ie)}switch(x.type){case L.TokenType.RegexStr:case L.TokenType.Error:{const B=[x.lexeme];this._advance();let j=this._peek(),G=0;for(let Ie=0;Ie<x.lexeme.length;Ie++)x.lexeme.charCodeAt(Ie)===P.CharCode.OpenParen?G++:x.lexeme.charCodeAt(Ie)===P.CharCode.CloseParen&&G--;for(;!this._isAtEnd()&&j.type!==L.TokenType.And&&j.type!==L.TokenType.Or;){switch(j.type){case L.TokenType.LParen:G++;break;case L.TokenType.RParen:G--;break;case L.TokenType.RegexStr:case L.TokenType.QuotedStr:for(let Ie=0;Ie<j.lexeme.length;Ie++)j.lexeme.charCodeAt(Ie)===P.CharCode.OpenParen?G++:x.lexeme.charCodeAt(Ie)===P.CharCode.CloseParen&&G--}if(G<0)break;B.push(L.Scanner.getLexeme(j)),this._advance(),j=this._peek()}const ie=B.join(""),ce=ie.lastIndexOf("/"),ge=ce===ie.length-1?void 0:this._removeFlagsGY(ie.substring(ce+1));let Se;try{Se=new RegExp(ie.substring(1,ce),ge)}catch{throw this._errExpectedButGot("REGEX",x)}return i.regex(Y,Se)}case L.TokenType.QuotedStr:{const B=x.lexeme;this._advance();let j=null;if(!(0,_.isFalsyOrWhitespace)(B)){const G=B.indexOf("/"),ie=B.lastIndexOf("/");if(G!==ie&&G>=0){const ce=B.slice(G+1,ie),ge=B[ie+1]==="i"?"i":"";try{j=new RegExp(ce,ge)}catch{throw this._errExpectedButGot("REGEX",x)}}}if(j===null)throw this._errExpectedButGot("REGEX",x);return J.create(Y,j)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(L.TokenType.Not)){this._consume(L.TokenType.In,I);const x=this._value();return i.notIn(Y,x)}switch(this._peek().type){case L.TokenType.Eq:{this._advance();const x=this._value();if(this._previous().type===L.TokenType.QuotedStr)return i.equals(Y,x);switch(x){case"true":return i.has(Y);case"false":return i.not(Y);default:return i.equals(Y,x)}}case L.TokenType.NotEq:{this._advance();const x=this._value();if(this._previous().type===L.TokenType.QuotedStr)return i.notEquals(Y,x);switch(x){case"true":return i.not(Y);case"false":return i.has(Y);default:return i.notEquals(Y,x)}}case L.TokenType.Lt:return this._advance(),H.create(Y,this._value());case L.TokenType.LtEq:return this._advance(),z.create(Y,this._value());case L.TokenType.Gt:return this._advance(),F.create(Y,this._value());case L.TokenType.GtEq:return this._advance(),M.create(Y,this._value());case L.TokenType.In:return this._advance(),i.in(Y,this._value());default:return i.has(Y)}}case L.TokenType.EOF:throw this._parsingErrors.push({message:S,offset:U.offset,lexeme:"",additionalInfo:c}),u._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const U=this._peek();switch(U.type){case L.TokenType.Str:case L.TokenType.QuotedStr:return this._advance(),U.lexeme;case L.TokenType.True:return this._advance(),"true";case L.TokenType.False:return this._advance(),"false";case L.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(U){return U.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(U){return this._check(U)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(U,Y){if(this._check(U))return this._advance();throw this._errExpectedButGot(Y,this._peek())}_errExpectedButGot(U,Y,oe){const x=(0,T.localize)(11608,null,U,L.Scanner.getLexeme(Y)),B=Y.offset,j=L.Scanner.getLexeme(Y);return this._parsingErrors.push({message:x,offset:B,lexeme:j,additionalInfo:oe}),u._parseError}_check(U){return this._peek().type===U}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===L.TokenType.EOF}}e.Parser=u;class i{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(U){return h.create(U)}static equals(U,Y){return y.create(U,Y)}static notEquals(U,Y){return w.create(U,Y)}static regex(U,Y){return J.create(U,Y)}static in(U,Y){return A.create(U,Y)}static notIn(U,Y){return b.create(U,Y)}static not(U){return O.create(U)}static and(...U){return $.create(U,null,!0)}static or(...U){return q.create(U,null,!0)}static greater(U,Y){return F.create(U,Y)}static greaterEquals(U,Y){return M.create(U,Y)}static smaller(U,Y){return H.create(U,Y)}static smallerEquals(U,Y){return z.create(U,Y)}static{this._parser=new u({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this._parser.parse(U)}}e.ContextKeyExpr=i;function n(W){const U=new u({regexParsingWithErrorRecovery:!1});return W.map(Y=>(U.parse(Y),U.lexingErrors.length>0?U.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,T.localize)(11609,null,oe.additionalInfo):(0,T.localize)(11610,null),offset:oe.offset,length:oe.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function t(W,U){const Y=W?W.substituteConstants():void 0,oe=U?U.substituteConstants():void 0;return!Y&&!oe?!0:!Y||!oe?!1:Y.equals(oe)}function s(W,U){return W.cmp(U)}class r{static{this.INSTANCE=new r}constructor(){this.type=d.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=r;class o{static{this.INSTANCE=new o}constructor(){this.type=d.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=o;class h{static create(U,Y=null){const oe=E.get(U);return typeof oe=="boolean"?oe?o.INSTANCE:r.INSTANCE:new h(U,Y)}constructor(U,Y){this.key=U,this.negated=Y,this.type=d.Defined}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?o.INSTANCE:r.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class y{static create(U,Y,oe=null){if(typeof Y=="boolean")return Y?h.create(U,oe):O.create(U,oe);const x=E.get(U);return typeof x=="boolean"?Y===(x?"true":"false")?o.INSTANCE:r.INSTANCE:new y(U,Y,oe)}constructor(U,Y,oe){this.key=U,this.value=Y,this.negated=oe,this.type=d.Equals}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){const U=E.get(this.key);if(typeof U=="boolean"){const Y=U?"true":"false";return this.value===Y?o.INSTANCE:r.INSTANCE}return this}evaluate(U){return U.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(U){return U.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class A{static create(U,Y){return new A(U,Y)}constructor(U,Y){this.key=U,this.valueKey=Y,this.type=d.In,this.negated=null}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.valueKey,U.key,U.valueKey)}equals(U){return U.type===this.type?this.key===U.key&&this.valueKey===U.valueKey:!1}substituteConstants(){return this}evaluate(U){const Y=U.getValue(this.valueKey),oe=U.getValue(this.key);return Array.isArray(Y)?Y.includes(oe):typeof oe=="string"&&typeof Y=="object"&&Y!==null?m.call(Y,oe):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(U){return U.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=A;class b{static create(U,Y){return new b(U,Y)}constructor(U,Y){this.key=U,this.valueKey=Y,this.type=d.NotIn,this._negated=A.create(U,Y)}cmp(U){return U.type!==this.type?this.type-U.type:this._negated.cmp(U._negated)}equals(U){return U.type===this.type?this._negated.equals(U._negated):!1}substituteConstants(){return this}evaluate(U){return!this._negated.evaluate(U)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(U){return U.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class w{static create(U,Y,oe=null){if(typeof Y=="boolean")return Y?O.create(U,oe):h.create(U,oe);const x=E.get(U);return typeof x=="boolean"?Y===(x?"true":"false")?r.INSTANCE:o.INSTANCE:new w(U,Y,oe)}constructor(U,Y,oe){this.key=U,this.value=Y,this.negated=oe,this.type=d.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){const U=E.get(this.key);if(typeof U=="boolean"){const Y=U?"true":"false";return this.value===Y?r.INSTANCE:o.INSTANCE}return this}evaluate(U){return U.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(U){return U.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class O{static create(U,Y=null){const oe=E.get(U);return typeof oe=="boolean"?oe?r.INSTANCE:o.INSTANCE:new O(U,Y)}constructor(U,Y){this.key=U,this.negated=Y,this.type=d.Not}cmp(U){return U.type!==this.type?this.type-U.type:ne(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?r.INSTANCE:o.INSTANCE:this}evaluate(U){return!U.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(U){return U.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function N(W,U){if(typeof W=="string"){const Y=parseFloat(W);isNaN(Y)||(W=Y)}return typeof W=="string"||typeof W=="number"?U(W):r.INSTANCE}class F{static create(U,Y,oe=null){return N(Y,x=>new F(U,x,oe))}constructor(U,Y,oe){this.key=U,this.value=Y,this.negated=oe,this.type=d.Greater}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(U){return U.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=F;class M{static create(U,Y,oe=null){return N(Y,x=>new M(U,x,oe))}constructor(U,Y,oe){this.key=U,this.value=Y,this.negated=oe,this.type=d.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(U){return U.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=M;class H{static create(U,Y,oe=null){return N(Y,x=>new H(U,x,oe))}constructor(U,Y,oe){this.key=U,this.value=Y,this.negated=oe,this.type=d.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(U){return U.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=H;class z{static create(U,Y,oe=null){return N(Y,x=>new z(U,x,oe))}constructor(U,Y,oe){this.key=U,this.value=Y,this.negated=oe,this.type=d.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:le(this.key,this.value,U.key,U.value)}equals(U){return U.type===this.type?this.key===U.key&&this.value===U.value:!1}substituteConstants(){return this}evaluate(U){return typeof this.value=="string"?!1:parseFloat(U.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(U){return U.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=z;class J{static create(U,Y){return new J(U,Y)}constructor(U,Y){this.key=U,this.regexp=Y,this.type=d.Regex,this.negated=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.key<U.key)return-1;if(this.key>U.key)return 1;const Y=this.regexp?this.regexp.source:"",oe=U.regexp?U.regexp.source:"";return Y<oe?-1:Y>oe?1:0}equals(U){if(U.type===this.type){const Y=this.regexp?this.regexp.source:"",oe=U.regexp?U.regexp.source:"";return this.key===U.key&&Y===oe}return!1}substituteConstants(){return this}evaluate(U){const Y=U.getValue(this.key);return this.regexp?this.regexp.test(Y):!1}serialize(){const U=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${U}`}keys(){return[this.key]}map(U){return U.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=V.create(this)),this.negated}}e.ContextKeyRegexExpr=J;class V{static create(U){return new V(U)}constructor(U){this._actual=U,this.type=d.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this._actual.cmp(U._actual)}equals(U){return U.type===this.type?this._actual.equals(U._actual):!1}substituteConstants(){return this}evaluate(U){return!this._actual.evaluate(U)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(U){return new V(this._actual.map(U))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=V;function te(W){let U=null;for(let Y=0,oe=W.length;Y<oe;Y++){const x=W[Y].substituteConstants();if(W[Y]!==x&&U===null){U=[];for(let B=0;B<Y;B++)U[B]=W[B]}U!==null&&(U[Y]=x)}return U===null?W:U}class ${static create(U,Y,oe){return $._normalizeArr(U,Y,oe)}constructor(U,Y){this.expr=U,this.negated=Y,this.type=d.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let Y=0,oe=this.expr.length;Y<oe;Y++){const x=s(this.expr[Y],U.expr[Y]);if(x!==0)return x}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let Y=0,oe=this.expr.length;Y<oe;Y++)if(!this.expr[Y].equals(U.expr[Y]))return!1;return!0}return!1}substituteConstants(){const U=te(this.expr);return U===this.expr?this:$.create(U,this.negated,!1)}evaluate(U){for(let Y=0,oe=this.expr.length;Y<oe;Y++)if(!this.expr[Y].evaluate(U))return!1;return!0}static _normalizeArr(U,Y,oe){const x=[];let B=!1;for(const j of U)if(j){if(j.type===d.True){B=!0;continue}if(j.type===d.False)return r.INSTANCE;if(j.type===d.And){x.push(...j.expr);continue}x.push(j)}if(x.length===0&&B)return o.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(s);for(let j=1;j<x.length;j++)x[j-1].equals(x[j])&&(x.splice(j,1),j--);if(x.length===1)return x[0];for(;x.length>1;){const j=x[x.length-1];if(j.type!==d.Or)break;x.pop();const G=x.pop(),ie=x.length===0,ce=q.create(j.expr.map(ge=>$.create([ge,G],null,oe)),null,ie);ce&&(x.push(ce),x.sort(s))}if(x.length===1)return x[0];if(oe){for(let j=0;j<x.length;j++)for(let G=j+1;G<x.length;G++)if(x[j].negate().equals(x[G]))return r.INSTANCE;if(x.length===1)return x[0]}return new $(x,Y)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const Y of this.expr)U.push(...Y.keys());return U}map(U){return new $(this.expr.map(Y=>Y.map(U)),null)}negate(){if(!this.negated){const U=[];for(const Y of this.expr)U.push(Y.negate());this.negated=q.create(U,this,!0)}return this.negated}}e.ContextKeyAndExpr=$;class q{static create(U,Y,oe){return q._normalizeArr(U,Y,oe)}constructor(U,Y){this.expr=U,this.negated=Y,this.type=d.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let Y=0,oe=this.expr.length;Y<oe;Y++){const x=s(this.expr[Y],U.expr[Y]);if(x!==0)return x}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let Y=0,oe=this.expr.length;Y<oe;Y++)if(!this.expr[Y].equals(U.expr[Y]))return!1;return!0}return!1}substituteConstants(){const U=te(this.expr);return U===this.expr?this:q.create(U,this.negated,!1)}evaluate(U){for(let Y=0,oe=this.expr.length;Y<oe;Y++)if(this.expr[Y].evaluate(U))return!0;return!1}static _normalizeArr(U,Y,oe){let x=[],B=!1;if(U){for(let j=0,G=U.length;j<G;j++){const ie=U[j];if(ie){if(ie.type===d.False){B=!0;continue}if(ie.type===d.True)return o.INSTANCE;if(ie.type===d.Or){x=x.concat(ie.expr);continue}x.push(ie)}}if(x.length===0&&B)return r.INSTANCE;x.sort(s)}if(x.length!==0){if(x.length===1)return x[0];for(let j=1;j<x.length;j++)x[j-1].equals(x[j])&&(x.splice(j,1),j--);if(x.length===1)return x[0];if(oe){for(let j=0;j<x.length;j++)for(let G=j+1;G<x.length;G++)if(x[j].negate().equals(x[G]))return o.INSTANCE;if(x.length===1)return x[0]}return new q(x,Y)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const Y of this.expr)U.push(...Y.keys());return U}map(U){return new q(this.expr.map(Y=>Y.map(U)),null)}negate(){if(!this.negated){const U=[];for(const Y of this.expr)U.push(Y.negate());for(;U.length>1;){const Y=U.shift(),oe=U.shift(),x=[];for(const B of K(Y))for(const j of K(oe))x.push($.create([B,j],null,!1));U.unshift(q.create(x,null,!1))}this.negated=q.create(U,this,!0)}return this.negated}}e.ContextKeyOrExpr=q;class Z extends h{static{this._info=[]}static all(){return Z._info.values()}constructor(U,Y,oe){super(U,null),this._defaultValue=Y,typeof oe=="object"?Z._info.push({...oe,key:U}):oe!==!0&&Z._info.push({key:U,description:oe,type:Y!=null?typeof Y:void 0})}bindTo(U){return U.createKey(this.key,this._defaultValue)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return y.create(this.key,U)}notEqualsTo(U){return w.create(this.key,U)}}e.RawContextKey=Z,e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function ne(W,U){return W<U?-1:W>U?1:0}function le(W,U,Y,oe){return W<Y?-1:W>Y?1:U<oe?-1:U>oe?1:0}function ee(W,U){if(W.type===d.False||U.type===d.True)return!0;if(W.type===d.Or)return U.type===d.Or?X(W.expr,U.expr):!1;if(U.type===d.Or){for(const Y of U.expr)if(ee(W,Y))return!0;return!1}if(W.type===d.And){if(U.type===d.And)return X(U.expr,W.expr);for(const Y of W.expr)if(ee(Y,U))return!0;return!1}return W.equals(U)}function X(W,U){let Y=0,oe=0;for(;Y<W.length&&oe<U.length;){const x=W[Y].cmp(U[oe]);if(x<0)return!1;x===0&&Y++,oe++}return Y===W.length}function K(W){return W.type===d.Or?W.expr:[W]}}),define(ue[97],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=a,e.ID="diagnosticsService",e.IDiagnosticsService=(0,P.createDecorator)(e.ID);function a(L){return!!L.hostName&&!!L.errorMessage}class _{async getPerformanceInfo(k,T){return{}}async getSystemInfo(k,T){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,T){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=_}),define(ue[98],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,P.createDecorator)("downloadService")}),define(ue[15],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,P.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,P.refineServiceDecorator)(e.IEnvironmentService)}),define(ue[74],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.RecommendationSourceToString=_;var a;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function _(k){switch(k){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var L;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.IExtensionRecommendationNotificationService=(0,P.createDecorator)("IExtensionRecommendationNotificationService")}),define(ue[7],he([0,1,51,13,26,12,9,11,4,5,22,53]),function(ae,e,P,a,_,L,k,T,D,E,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=d,e.isFileSystemWatcher=I,e.hasReadWriteCapability=v,e.hasFileFolderCopyCapability=C,e.hasFileCloneCapability=S,e.hasOpenReadWriteCloseCapability=c,e.hasFileReadStreamCapability=u,e.hasFileAtomicReadCapability=i,e.hasFileAtomicWriteCapability=n,e.hasFileAtomicDeleteCapability=t,e.hasReadonlyCapability=s,e.createFileSystemProviderError=h,e.ensureFileSystemProviderError=y,e.markAsFileSystemProviderError=A,e.toFileSystemProviderErrorCode=b,e.toFileOperationResult=w,e.isParent=H,e.etag=q,e.whenProviderRegistered=Z,e.getLargeFileConfirmationLimit=le,e.IFileService=(0,D.createDecorator)("fileService");function d(ee){return ee.create===!0}var f;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var l;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var p;(function(ee){ee[ee.UPDATED=2]="UPDATED",ee[ee.ADDED=4]="ADDED",ee[ee.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function I(ee){const X=ee;return!!X&&typeof X.onDidChange=="function"}var g;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function v(ee){return!!(ee.capabilities&g.FileReadWrite)}function C(ee){return!!(ee.capabilities&g.FileFolderCopy)}function S(ee){return!!(ee.capabilities&g.FileClone)}function c(ee){return!!(ee.capabilities&g.FileOpenReadWriteClose)}function u(ee){return!!(ee.capabilities&g.FileReadStream)}function i(ee){return v(ee)?!!(ee.capabilities&g.FileAtomicRead):!1}function n(ee){return v(ee)?!!(ee.capabilities&g.FileAtomicWrite):!1}function t(ee){return!!(ee.capabilities&g.FileAtomicDelete)}function s(ee){return!!(ee.capabilities&g.Readonly)}var r;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class o extends Error{static create(X,K){const W=new o(X.toString(),K);return A(W,K),W}constructor(X,K){super(X),this.code=K}}e.FileSystemProviderError=o;function h(ee,X){return o.create(ee,X)}function y(ee){return ee||h((0,T.localize)(11386,null),r.Unknown)}function A(ee,X){return ee.name=X?`${X} (FileSystemError)`:"FileSystemError",ee}function b(ee){if(!ee)return r.Unknown;if(ee instanceof o)return ee.code;const X=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!X)return r.Unknown;switch(X[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function w(ee){if(ee instanceof z)return ee.fileOperationResult;switch(b(ee)){case r.FileNotFound:return te.FILE_NOT_FOUND;case r.FileIsADirectory:return te.FILE_IS_DIRECTORY;case r.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return te.FILE_WRITE_LOCKED;case r.NoPermissions:return te.FILE_PERMISSION_DENIED;case r.FileExists:return te.FILE_MOVE_CONFLICT;case r.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var O;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class N{constructor(X,K,W){this.resource=X,this.operation=K,this.target=W}isOperation(X){return this.operation===X}}e.FileOperationEvent=N;var F;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.MIXED_CORRELATION=null}constructor(X,K){this.ignorePathCasing=K,this.correlationId=void 0,this.added=new m.Lazy(()=>{const W=P.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawAdded.map(U=>[U,!0])),W}),this.updated=new m.Lazy(()=>{const W=P.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawUpdated.map(U=>[U,!0])),W}),this.deleted=new m.Lazy(()=>{const W=P.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawDeleted.map(U=>[U,!0])),W}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const W of X){switch(W.type){case F.ADDED:this.rawAdded.push(W.resource);break;case F.UPDATED:this.rawUpdated.push(W.resource);break;case F.DELETED:this.rawDeleted.push(W.resource);break}this.correlationId!==M.MIXED_CORRELATION&&(typeof W.cId=="number"?this.correlationId===void 0?this.correlationId=W.cId:this.correlationId!==W.cId&&(this.correlationId=M.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=M.MIXED_CORRELATION))}}contains(X,...K){return this.doContains(X,{includeChildren:!1},...K)}affects(X,...K){return this.doContains(X,{includeChildren:!0},...K)}doContains(X,K,...W){if(!X)return!1;const U=W.length>0;return!!((!U||W.includes(F.ADDED))&&(this.added.value.get(X)||K.includeChildren&&this.added.value.findSuperstr(X))||(!U||W.includes(F.UPDATED))&&(this.updated.value.get(X)||K.includeChildren&&this.updated.value.findSuperstr(X))||(!U||W.includes(F.DELETED))&&(this.deleted.value.findSubstr(X)||K.includeChildren&&this.deleted.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.correlationId===X}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=M;function H(ee,X,K){return!ee||!X||ee===X||X.length>ee.length?!1:(X.charAt(X.length-1)!==a.sep&&(X+=a.sep),K?(0,_.startsWithIgnoreCase)(ee,X):ee.indexOf(X)===0)}class z extends Error{constructor(X,K,W){super(X),this.fileOperationResult=K,this.options=W}}e.FileOperationError=z;class J extends z{constructor(X,K,W,U){super(X,K,U),this.fileOperationResult=K,this.size=W}}e.TooLargeFileOperationError=J;class V extends z{constructor(X,K,W){super(X,te.FILE_NOT_MODIFIED_SINCE,W),this.stat=K}}e.NotModifiedSinceFileOperationError=V;var te;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var $;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})($||(e.FileKind=$={})),e.ETAG_DISABLED="";function q(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function Z(ee,X){if(!X.hasProvider(k.URI.from({scheme:ee.scheme})))return new Promise(K=>{const W=X.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ee.scheme&&U.added&&(W.dispose(),K())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(X){return(0,L.isNumber)(X)||(X=0),X<ne.KB?(0,T.localize)(11387,null,X.toFixed(0)):X<ne.MB?(0,T.localize)(11388,null,(X/ne.KB).toFixed(2)):X<ne.GB?(0,T.localize)(11389,null,(X/ne.MB).toFixed(2)):X<ne.TB?(0,T.localize)(11390,null,(X/ne.GB).toFixed(2)):(0,T.localize)(11391,null,(X/ne.TB).toFixed(2))}}e.ByteSize=ne;function le(ee){const X=typeof ee=="string"||ee?.scheme===R.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===R.Schemas.file?1024*ne.MB:X?10*ne.MB:E.isWeb?50*ne.MB:1024*ne.MB}});var Q=this&&this.__param||function(ae,e){return function(P,a){e(P,a,ae)}};define(ue[163],he([0,1,75,50,7]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(T){this.fileService=T}async checksum(T){const D=(await this.fileService.readFileStream(T)).value;return new Promise((E,R)=>{const m=(0,P.createHash)("sha256");(0,a.listenStream)(D,{onData:d=>m.update(d.buffer),onError:d=>R(d),onEnd:()=>E(m.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=L,e.ChecksumService=L=we([Q(0,_.IFileService)],L)}),define(ue[99],he([0,1,14,8,11,7]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=k;async function k(R,m,d,f,l,p){let I;try{await T(R,m,d,f,l,p)}catch(g){I=g}finally{I&&l.errorTransformer&&(I=l.errorTransformer(I)),typeof I<"u"&&d.error(I),d.end()}}async function T(R,m,d,f,l,p){D(p);const I=await R.open(m,{create:!1});try{D(p);let g=0,v=0,C=l&&typeof l.length=="number"?l.length:void 0,S=P.VSBuffer.alloc(Math.min(l.bufferSize,typeof C=="number"?C:l.bufferSize)),c=l&&typeof l.position=="number"?l.position:0,u=0;do v=await R.read(I,c,S.buffer,u,S.byteLength-u),c+=v,u+=v,g+=v,typeof C=="number"&&(C-=v),u===S.byteLength&&(await d.write(f(S)),S=P.VSBuffer.alloc(Math.min(l.bufferSize,typeof C=="number"?C:l.bufferSize)),u=0);while(v>0&&(typeof C!="number"||C>0)&&D(p)&&E(g,l));if(u>0){let i=u;typeof C=="number"&&(i=Math.min(u,C)),d.write(f(S.slice(0,i)))}}catch(g){throw(0,L.ensureFileSystemProviderError)(g)}finally{await R.close(I)}}function D(R){if(R.isCancellationRequested)throw(0,a.canceled)();return!0}function E(R,m){if(typeof m?.limits?.size=="number"&&R>m.limits.size)throw(0,L.createFileSystemProviderError)((0,_.localize)(11385,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ue[46],he([0,1,93,2,13,5,9,7]),function(ae,e,P,a,_,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=D,e.isRecursiveWatchRequest=E,e.reviveFileChanges=f,e.coalesceEvents=l,e.normalizeWatcherPattern=p,e.parseWatcherPatterns=I,e.isFiltered=v,e.requestFilterToString=C;function D(S){return typeof S.correlationId=="number"}function E(S){return S.recursive===!0}class R extends a.Disposable{static{this.MAX_RESTARTS=5}constructor(c,u,i,n){super(),this.onFileChanges=c,this.onLogMessage=u,this.verboseLogging=i,this.options=n,this.watcherDisposables=this._register(new a.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new a.DisposableStore;this.watcherDisposables.value=c,this.watcher=this.createWatcher(c),this.watcher.setVerboseLogging(this.verboseLogging),c.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),c.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),c.add(this.watcher.onDidError(u=>this.onError(u.error,u.request)))}onError(c,u){this.canRestart(c,u)?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${c}`):this.error(c)}canRestart(c,u){return!(!this.options.restartOnError||u||c.indexOf("No space left on device")!==-1||c.indexOf("EMFILE")!==-1)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.watcher?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.watcher?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${c}`})}trace(c){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${c}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R;class m extends R{constructor(c,u,i){super(c,u,i,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=m;class d extends R{constructor(c,u,i){super(c,u,i,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=d;function f(S){return S.map(c=>({type:c.type,resource:k.URI.revive(c.resource),cId:c.cId}))}function l(S){const c=new g;for(const u of S)c.processEvent(u);return c.coalesce()}function p(S,c){return typeof c=="string"&&!c.startsWith(P.GLOBSTAR)&&!(0,_.isAbsolute)(c)?{base:S,pattern:c}:c}function I(S,c){const u=[];for(const i of c)u.push((0,P.parse)(p(S,i)));return u}class g{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return L.isLinux?c.resource.fsPath:c.resource.fsPath.toLowerCase()}processEvent(c){const u=this.mapPathToChange.get(this.toKey(c));let i=!1;if(u){const n=u.type,t=c.type;u.resource.fsPath!==c.resource.fsPath&&(c.type===T.FileChangeType.DELETED||c.type===T.FileChangeType.ADDED)?i=!0:n===T.FileChangeType.ADDED&&t===T.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(u)):n===T.FileChangeType.DELETED&&t===T.FileChangeType.ADDED?u.type=T.FileChangeType.UPDATED:n===T.FileChangeType.ADDED&&t===T.FileChangeType.UPDATED||(u.type=t)}else i=!0;i&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],u=[];return Array.from(this.coalesced).filter(i=>i.type!==T.FileChangeType.DELETED?(c.push(i),!1):!0).sort((i,n)=>i.resource.fsPath.length-n.resource.fsPath.length).filter(i=>u.some(n=>(0,T.isParent)(i.resource.fsPath,n,!L.isLinux))?!1:(u.push(i.resource.fsPath),!0)).concat(c)}}function v(S,c){if(typeof c=="number")switch(S.type){case T.FileChangeType.ADDED:return(c&T.FileChangeFilter.ADDED)===0;case T.FileChangeType.DELETED:return(c&T.FileChangeFilter.DELETED)===0;case T.FileChangeType.UPDATED:return(c&T.FileChangeFilter.UPDATED)===0}return!1}function C(S){if(typeof S=="number"){const c=[];return S&T.FileChangeFilter.ADDED&&c.push("Added"),S&T.FileChangeFilter.DELETED&&c.push("Deleted"),S&T.FileChangeFilter.UPDATED&&c.push("Updated"),c.length===0?"<all>":`[${c.join(", ")}]`}return"<none>"}}),define(ue[164],he([0,1,14,43,8,3,2,50,32,7,46]),function(ae,e,P,a,_,L,k,T,D,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class m extends k.Disposable{constructor(f,l){super(),this.channel=f,this.extraCapabilities=l,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,D.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=E.FileSystemProviderCapabilities.FileReadWrite|E.FileSystemProviderCapabilities.FileOpenReadWriteClose|E.FileSystemProviderCapabilities.FileReadStream|E.FileSystemProviderCapabilities.FileFolderCopy|E.FileSystemProviderCapabilities.FileWriteUnlock|E.FileSystemProviderCapabilities.FileAtomicRead|E.FileSystemProviderCapabilities.FileAtomicWrite|E.FileSystemProviderCapabilities.FileAtomicDelete|E.FileSystemProviderCapabilities.FileClone,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=E.FileSystemProviderCapabilities.PathCaseSensitive),this.extraCapabilities.trash&&(this._capabilities|=E.FileSystemProviderCapabilities.Trash)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,l){const{buffer:p}=await this.channel.call("readFile",[f,l]);return p}readFileStream(f,l,p){const I=(0,T.newWriteableStream)(v=>P.VSBuffer.concat(v.map(C=>P.VSBuffer.wrap(C))).buffer),g=new k.DisposableStore;return g.add(this.channel.listen("readFileStream",[f,l])(v=>{if(v instanceof P.VSBuffer)I.write(v.buffer);else{if(v==="end")I.end();else{let C;if(v instanceof Error)C=v;else{const S=v;C=(0,E.createFileSystemProviderError)(S.message??(0,a.toErrorMessage)(S),S.code??E.FileSystemProviderErrorCode.Unknown)}I.error(C),I.end()}g.dispose()}})),g.add(p.onCancellationRequested(()=>{I.error((0,_.canceled)()),I.end(),g.dispose()})),I}writeFile(f,l,p){return this.channel.call("writeFile",[f,P.VSBuffer.wrap(l),p])}open(f,l){return this.channel.call("open",[f,l])}close(f){return this.channel.call("close",[f])}async read(f,l,p,I,g){const[v,C]=await this.channel.call("read",[f,l,g]);return p.set(v.buffer.slice(0,C),I),C}write(f,l,p,I,g){return this.channel.call("write",[f,l,P.VSBuffer.wrap(p),I,g])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,l){return this.channel.call("delete",[f,l])}rename(f,l,p){return this.channel.call("rename",[f,l,p])}copy(f,l,p){return this.channel.call("copy",[f,l,p])}cloneFile(f,l){return this.channel.call("cloneFile",[f,l])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const l=f;this._onDidChange.fire((0,R.reviveFileChanges)(l))}else{const l=f;this._onDidWatchError.fire(l)}}))}watch(f,l){const p=(0,D.generateUuid)();return this.channel.call("watch",[this.sessionId,p,f,l]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=m}),define(ue[165],he([0,1,33,2,46,3,7,9,6]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class E extends a.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new L.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new L.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new a.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new D.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new D.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(m=>this.handleDidWatchFail(m)))}handleDidWatchFail(m){this.isCorrelated(m)&&this.suspendWatchRequest(m)}isCorrelated(m){return(0,_.isWatchRequestWithCorrelation)(m)}async watch(m){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new D.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const d of m)this.isCorrelated(d)?this.allCorrelatedWatchRequests.set(d.correlationId,d):this.allNonCorrelatedWatchRequests.add(d);for(const[d]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(d)||(this.suspendedWatchRequests.deleteAndDispose(d),this.suspendedWatchRequestsWithPolling.delete(d));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(m){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(d=>!this.suspendedWatchRequests.has(d.correlationId))]),m?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(m){return typeof m.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(m.correlationId)?"polling":this.suspendedWatchRequests.has(m.correlationId)}async suspendWatchRequest(m){if(this.suspendedWatchRequests.has(m.correlationId))return;const d=new a.DisposableStore;this.suspendedWatchRequests.set(m.correlationId,d),await this.joinWatch.p,!d.isDisposed&&(this.monitorSuspendedWatchRequest(m,d),this.updateWatchers(!0))}resumeWatchRequest(m){this.suspendedWatchRequests.deleteAndDispose(m.correlationId),this.suspendedWatchRequestsWithPolling.delete(m.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(m,d){this.doMonitorWithExistingWatcher(m,d)?(this.trace(`reusing an existing recursive watcher to monitor ${m.path}`),this.suspendedWatchRequestsWithPolling.delete(m.correlationId)):(this.doMonitorWithNodeJS(m,d),this.suspendedWatchRequestsWithPolling.add(m.correlationId))}doMonitorWithExistingWatcher(m,d){const f=this.recursiveWatcher?.subscribe(m.path,(l,p)=>{d.isDisposed||(l?this.monitorSuspendedWatchRequest(m,d):p?.type===k.FileChangeType.ADDED&&this.onMonitoredPathAdded(m))});return f?(d.add(f),!0):!1}doMonitorWithNodeJS(m,d){let f=!1;const l=(p,I)=>{if(d.isDisposed)return;const g=this.isPathNotFound(p),v=this.isPathNotFound(I),C=f;f=g,!g&&(v||C)&&this.onMonitoredPathAdded(m)};this.trace(`starting fs.watchFile() on ${m.path} (correlationId: ${m.correlationId})`);try{(0,P.watchFile)(m.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},l)}catch(p){this.warn(`fs.watchFile() failed with error ${p} on path ${m.path} (correlationId: ${m.correlationId})`)}d.add((0,a.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${m.path} (correlationId: ${m.correlationId})`);try{(0,P.unwatchFile)(m.path,l)}catch(p){this.warn(`fs.unwatchFile() failed with error ${p} on path ${m.path} (correlationId: ${m.correlationId})`)}}))}onMonitoredPathAdded(m){this.trace(`detected ${m.path} exists again, resuming watcher (correlationId: ${m.correlationId})`);const d={resource:T.URI.file(m.path),type:k.FileChangeType.ADDED,cId:m.correlationId};this._onDidChangeFile.fire([d]),this.traceEvent(d,m),this.resumeWatchRequest(m)}isPathNotFound(m){return m.ctimeMs===0&&m.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(m,d){if(this.verboseLogging){const f=` >> normalized ${m.type===k.FileChangeType.ADDED?"[ADDED]":m.type===k.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`;this.traceWithCorrelation(f,d)}}traceWithCorrelation(m,d){this.verboseLogging&&this.trace(`${m}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}requestToString(m){return`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"}, filter: ${(0,_.requestFilterToString)(m.filter)}, correlationId: ${typeof m.correlationId=="number"?m.correlationId:"<none>"})`}async setVerboseLogging(m){this.verboseLogging=m}}e.BaseWatcher=E}),define(ue[166],he([0,1,33,6,25,41,2,90,13,5,20,9,146,30,7,46]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=g;class I extends k.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(C,S,c,u,i,n){super(),this.request=C,this.recursiveWatcher=S,this.onDidFilesChange=c,this.onDidWatchFail=u,this.onLogMessage=i,this.verboseLogging=n,this.throttledFileChangesEmitter=this._register(new a.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.onDidFilesChange(t))),this.fileChangesAggregator=this._register(new a.RunOnceWorker(t=>this.handleFileChanges(t),I.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,p.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new _.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const S=await P.promises.stat(C);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(C,S.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${C})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(C){let S=C.path;try{S=await f.Promises.realpath(C.path),C.path===S&&(S=await(0,d.realcase)(C.path,this.cts.token)??C.path),C.path!==S&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${S})`)}catch{}return S}async doWatch(C,S){const c=new k.DisposableStore;return this.doWatchWithExistingWatcher(C,S,c)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(C,S,c)),c}doWatchWithExistingWatcher(C,S,c){if(S)return!1;const u=m.URI.file(this.request.path),i=this.recursiveWatcher?.subscribe(this.request.path,async(n,t)=>{if(!c.isDisposed)if(n){const s=await this.doWatch(C,S);c.isDisposed?s.dispose():c.add(s)}else t&&(typeof t.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:u,type:t.type,cId:this.request.correlationId},!0)});return i?(c.add(i),!0):!1}async doWatchWithNodeJS(C,S,c){if(E.isMacintosh&&(0,L.isEqualOrParent)(C,"/Volumes/",!0)){this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const u=new _.CancellationTokenSource(this.cts.token);c.add((0,k.toDisposable)(()=>u.dispose(!0)));const i=new k.DisposableStore;c.add(i);try{const n=m.URI.file(this.request.path),t=(0,D.basename)(C),s=(0,P.watch)(C);i.add((0,k.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${C}'`);const r=new Set;if(S)try{for(const h of await f.Promises.readdir(C))r.add(h)}catch(h){this.error(h)}if(u.token.isCancellationRequested)return;const o=new Map;i.add((0,k.toDisposable)(()=>{for(const[,h]of o)h.dispose();o.clear()})),s.on("error",(h,y)=>{u.token.isCancellationRequested||(this.error(`Failed to watch ${C} for changes using fs.watch() (${h}, ${y})`),this.notifyWatchFailed())}),s.on("change",(h,y)=>{if(u.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${h}"] ${y}`);let A="";if(y&&(A=y.toString(),E.isMacintosh&&(A=(0,T.normalizeNFC)(A))),!(!A||h!=="change"&&h!=="rename"))if(S)if(h==="rename"){o.get(A)?.dispose();const b=setTimeout(async()=>{if(o.delete(A),A===t&&!await f.Promises.exists(C)){this.onWatchedPathDeleted(n);return}if(u.token.isCancellationRequested)return;const w=await this.existsChildStrictCase((0,D.join)(C,A));if(u.token.isCancellationRequested)return;let O;w?r.has(A)?O=l.FileChangeType.UPDATED:(O=l.FileChangeType.ADDED,r.add(A)):(r.delete(A),O=l.FileChangeType.DELETED),this.onFileChange({resource:(0,R.joinPath)(n,A),type:O,cId:this.request.correlationId})},I.FILE_DELETE_HANDLER_DELAY);o.set(A,(0,k.toDisposable)(()=>clearTimeout(b)))}else{let b;r.has(A)?b=l.FileChangeType.UPDATED:(b=l.FileChangeType.ADDED,r.add(A)),this.onFileChange({resource:(0,R.joinPath)(n,A),type:b,cId:this.request.correlationId})}else if(h==="rename"||A!==t){const b=setTimeout(async()=>{const w=await f.Promises.exists(C);u.token.isCancellationRequested||(w?(this.onFileChange({resource:n,type:l.FileChangeType.UPDATED,cId:this.request.correlationId},!0),i.add(await this.doWatch(C,!1))):this.onWatchedPathDeleted(n))},I.FILE_DELETE_HANDLER_DELAY);i.clear(),i.add((0,k.toDisposable)(()=>clearTimeout(b)))}else this.onFileChange({resource:n,type:l.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(n){u.token.isCancellationRequested||this.error(`Failed to watch ${C} for changes using fs.watch() (${n.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(C){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:C,type:l.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(C,S=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${C.type===l.FileChangeType.ADDED?"[ADDED]":C.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${C.resource.fsPath}`),!S&&this.excludes.some(c=>c(C.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${C.resource.fsPath}`):!S&&this.includes&&this.includes.length>0&&!this.includes.some(c=>c(C.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${C.resource.fsPath}`):this.fileChangesAggregator.work(C))}handleFileChanges(C){const S=(0,p.coalesceEvents)(C),c=[];for(const i of S){if((0,p.isFiltered)(i,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${i.resource.fsPath}`);continue}c.push(i)}if(c.length===0)return;if(this.verboseLogging)for(const i of c)this.traceWithCorrelation(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.throttledFileChangesEmitter.work(c)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(C){if(E.isLinux)return f.Promises.exists(C);try{const S=(0,D.basename)(C);return(await f.Promises.readdir((0,D.dirname)(C))).some(u=>u===S)}catch(S){return this.trace(S),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}traceWithCorrelation(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${C}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=I;async function g(v,C,S,c,u=512){const i=await f.Promises.open(v,"r"),n=Buffer.allocUnsafe(u),t=new _.CancellationTokenSource(c);let s,r=!1;const o={path:v,excludes:[],recursive:!1},h=new I(o,void 0,y=>{(async()=>{for(const{type:A}of y)if(A===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:b}=await f.Promises.read(i,n,0,u,null);if(!b||t.token.isCancellationRequested)break;C(n.slice(0,b))}}catch(b){s=new Error(b),t.dispose(!0)}finally{r=!1}}})()});return await h.ready,S(),new Promise((y,A)=>{t.token.onCancellationRequested(async()=>{h.dispose();try{await f.Promises.close(i)}catch(b){s=new Error(b)}s?A(s):y()})})}}),define(ue[167],he([0,1,3,93,165,5,166,41]),function(ae,e,P,a,_,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends _.BaseWatcher{constructor(R){super(),this.recursiveWatcher=R,this.onDidError=P.Event.None,this.watchers=new Set}async doWatch(R){R=this.removeDuplicateRequests(R);const m=[],d=new Set(Array.from(this.watchers));for(const f of R){const l=this.findWatcher(f);l&&(0,a.patternsEquals)(l.request.excludes,f.excludes)&&(0,a.patternsEquals)(l.request.includes,f.includes)?d.delete(l):m.push(f)}m.length&&this.trace(`Request to start watching: ${m.map(f=>this.requestToString(f)).join(",")}`),d.size&&this.trace(`Request to stop watching: ${Array.from(d).map(f=>this.requestToString(f.request)).join(",")}`);for(const f of d)this.stopWatching(f);for(const f of m)this.startWatching(f)}findWatcher(R){for(const m of this.watchers)if(typeof R.correlationId=="number"||typeof m.request.correlationId=="number"){if(m.request.correlationId===R.correlationId)return m}else if((0,T.isEqual)(m.request.path,R.path,!L.isLinux))return m}startWatching(R){const m=new k.NodeJSFileWatcherLibrary(R,this.recursiveWatcher,f=>this._onDidChangeFile.fire(f),()=>this._onDidWatchFail.fire(R),f=>this._onDidLogMessage.fire(f),this.verboseLogging),d={request:R,instance:m};this.watchers.add(d)}async stop(){await super.stop();for(const R of this.watchers)this.stopWatching(R)}stopWatching(R){this.trace("stopping file watcher",R),this.watchers.delete(R),R.instance.dispose()}removeDuplicateRequests(R){const m=new Map;for(const d of R){const f=L.isLinux?d.path:d.path.toLowerCase();let l=m.get(d.correlationId);l||(l=new Map,m.set(d.correlationId,l)),l.has(f)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(d)}`),l.set(f,d)}return Array.from(m.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(R){super.setVerboseLogging(R);for(const m of this.watchers)m.instance.setVerboseLogging(R)}trace(R,m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(R,m)})}warn(R){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(R)})}toMessage(R,m){return m?`[File Watcher (node.js)] ${R} (${this.requestToString(m.request)})`:`[File Watcher (node.js)] ${R}`}}e.NodeJSWatcher=D}),define(ue[168],he([0,1,46,167]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class _ extends P.AbstractNonRecursiveWatcherClient{constructor(k,T,D){super(k,T,D),this.init()}createWatcher(k){return k.add(new a.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=_}),define(ue[169],he([0,1,22,42,95,46]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends L.AbstractUniversalWatcherClient{constructor(D,E,R){super(D,E,R),this.init()}createWatcher(D){const E=D.add(new _.Client(P.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return D.add(E.onDidProcessExit(({code:R,signal:m})=>this.onError(`terminated by itself with code ${R}, signal: ${m} (ETERM)`))),a.ProxyChannel.toService((0,a.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(ue[76],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class P{constructor(..._){this._entries=new Map;for(const[L,k]of _)this.set(L,k)}set(_,L){const k=this._entries.get(_);return this._entries.set(_,L),k}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=P}),define(ue[170],he([0,1,6,8,2,73,161,4,76,89]),function(ae,e,P,a,_,L,k,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class m extends Error{constructor(I){super("cyclic dependency between services"),this.message=I.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${I.toString()}`}}class d{constructor(I=new D.ServiceCollection,g=!1,v,C=R){this._services=I,this._strict=g,this._parent=v,this._enableTracing=C,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=C?v?._globalGraph??new k.Graph(S=>S):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,_.dispose)(this._children),this._children.clear();for(const I of this._servicesToMaybeDispose)(0,_.isDisposable)(I)&&I.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(I,g){this._throwIfDisposed();const v=this,C=new class extends d{dispose(){v._children.delete(C),super.dispose()}}(I,this._strict,this,this._enableTracing);return this._children.add(C),g?.add(C),C}invokeFunction(I,...g){this._throwIfDisposed();const v=l.traceInvocation(this._enableTracing,I);let C=!1;try{return I({get:c=>{if(C)throw(0,a.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(c,v);if(!u)throw new Error(`[invokeFunction] unknown service '${c}'`);return u}},...g)}finally{C=!0,v.stop()}}createInstance(I,...g){this._throwIfDisposed();let v,C;return I instanceof L.SyncDescriptor?(v=l.traceCreation(this._enableTracing,I.ctor),C=this._createInstance(I.ctor,I.staticArguments.concat(g),v)):(v=l.traceCreation(this._enableTracing,I),C=this._createInstance(I,g,v)),v.stop(),C}_createInstance(I,g=[],v){const C=T._util.getServiceDependencies(I).sort((u,i)=>u.index-i.index),S=[];for(const u of C){const i=this._getOrCreateServiceInstance(u.id,v);i||this._throwIfStrict(`[createInstance] ${I.name} depends on UNKNOWN service ${u.id}.`,!1),S.push(i)}const c=C.length>0?C[0].index:g.length;if(g.length!==c){console.trace(`[createInstance] First service dependency of ${I.name} at position ${c+1} conflicts with ${g.length} static arguments`);const u=c-g.length;u>0?g=g.concat(new Array(u)):g=g.slice(0,c)}return Reflect.construct(I,g.concat(S))}_setCreatedServiceInstance(I,g){if(this._services.get(I)instanceof L.SyncDescriptor)this._services.set(I,g);else if(this._parent)this._parent._setCreatedServiceInstance(I,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(I){const g=this._services.get(I);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(I):g}_getOrCreateServiceInstance(I,g){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(I));const v=this._getServiceInstanceOrDescriptor(I);return v instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(I,v,g.branch(I,!0)):(g.branch(I,!1),v)}_safeCreateAndCacheServiceInstance(I,g,v){if(this._activeInstantiations.has(I))throw new Error(`illegal state - RECURSIVELY instantiating service '${I}'`);this._activeInstantiations.add(I);try{return this._createAndCacheServiceInstance(I,g,v)}finally{this._activeInstantiations.delete(I)}}_createAndCacheServiceInstance(I,g,v){const C=new k.Graph(i=>i.id.toString());let S=0;const c=[{id:I,desc:g,_trace:v}],u=new Set;for(;c.length;){const i=c.pop();if(!u.has(String(i.id))){if(u.add(String(i.id)),C.lookupOrInsertNode(i),S++>1e3)throw new m(C);for(const n of T._util.getServiceDependencies(i.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(n.id);if(t||this._throwIfStrict(`[createInstance] ${I} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof L.SyncDescriptor){const s={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};C.insertEdge(i,s),c.push(s)}}}}for(;;){const i=C.roots();if(i.length===0){if(!C.isEmpty())throw new m(C);break}for(const{data:n}of i){if(this._getServiceInstanceOrDescriptor(n.id)instanceof L.SyncDescriptor){const s=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setCreatedServiceInstance(n.id,s)}C.removeNode(n)}}return this._getServiceInstanceOrDescriptor(I)}_createServiceInstanceWithOwner(I,g,v=[],C,S){if(this._services.get(I)instanceof L.SyncDescriptor)return this._createServiceInstance(I,g,v,C,S,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(I,g,v,C,S);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(I,g,v=[],C,S,c){if(C){const u=new d(void 0,this._strict,this,this._enableTracing);u._globalGraphImplicitDependency=String(I);const i=new Map,n=new P.GlobalIdleValue(()=>{const t=u._createInstance(g,v,S);for(const[s,r]of i){const o=t[s];if(typeof o=="function")for(const h of r)h.disposable=o.apply(t,h.listener)}return i.clear(),c.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let h=i.get(s);return h||(h=new E.LinkedList,i.set(s,h)),(A,b,w)=>{if(n.isInitialized)return n.value[s](A,b,w);{const O={listener:[A,b,w],disposable:void 0},N=h.push(O);return(0,_.toDisposable)(()=>{N(),O.disposable?.dispose()})}}}if(s in t)return t[s];const r=n.value;let o=r[s];return typeof o!="function"||(o=o.bind(r),t[s]=o),o},set(t,s,r){return n.value[s]=r,!0},getPrototypeOf(t){return g.prototype}})}else{const u=this._createInstance(g,v,S);return c.add(u),u}}_throwIfStrict(I,g){if(g&&console.warn(I),this._strict)throw new Error(I)}}e.InstantiationService=d;var f;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(f||(f={}));class l{static{this.all=new Set}static{this._None=new class extends l{constructor(){super(f.None,null)}stop(){}branch(){return this}}}static traceInvocation(I,g){return I?new l(f.Invocation,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l._None}static traceCreation(I,g){return I?new l(f.Creation,g.name):l._None}static{this._totals=0}constructor(I,g){this.type=I,this.name=g,this._start=Date.now(),this._dep=[]}branch(I,g){const v=new l(f.Branch,I.toString());return this._dep.push([I,g,v]),v}stop(){const I=Date.now()-this._start;l._totals+=I;let g=!1;function v(S,c){const u=[],i=new Array(S+1).join("	");for(const[n,t,s]of c._dep)if(t&&s){g=!0,u.push(`${i}CREATES -> ${n}`);const r=v(S+1,s);r&&u.push(r)}else u.push(`${i}uses -> ${n}`);return u.join(`
`)}const C=[`${this.type===f.Creation?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${I.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(I>2||g)&&l.all.add(C.join(`
`))}}e.Trace=l}),define(ue[56],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,P.createDecorator)("mainProcessService");class a{constructor(L,k){this.server=L,this.router=k}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,k){this.server.registerChannel(L,k)}}e.MainProcessService=a}),define(ue[10],he([0,1,11,43,3,55,2,31,5,20,12,9,96,4]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=p,e.log=g,e.getLogLevel=o,e.LogLevelToString=h,e.LogLevelToLocalizedString=y,e.parseLogLevel=A,P=De(P),e.ILogService=(0,f.createDecorator)("logService"),e.ILoggerService=(0,f.createDecorator)("loggerService");function l(){return new Date().toISOString()}function p(b){return(0,R.isNumber)(b)}var I;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(I||(e.LogLevel=I={})),e.DEFAULT_LOG_LEVEL=I.Info;function g(b,w,O){switch(w){case I.Trace:b.trace(O);break;case I.Debug:b.debug(O);break;case I.Info:b.info(O);break;case I.Warning:b.warn(O);break;case I.Error:b.error(O);break;case I.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function v(b,w=!1){let O="";for(let N=0;N<b.length;N++){let F=b[N];if(F instanceof Error&&(F=(0,a.toErrorMessage)(F,w)),typeof F=="object")try{F=JSON.stringify(F)}catch{}O+=(N>0?" ":"")+F}return O}class C extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(w){this.level!==w&&(this.level=w,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(w){return this.level!==I.Off&&this.level<=w}}e.AbstractLogger=C;class S extends C{constructor(w){super(),this.logAlways=w}checkLogLevel(w){return this.logAlways||super.checkLogLevel(w)}trace(w,...O){this.checkLogLevel(I.Trace)&&this.log(I.Trace,v([w,...O],!0))}debug(w,...O){this.checkLogLevel(I.Debug)&&this.log(I.Debug,v([w,...O]))}info(w,...O){this.checkLogLevel(I.Info)&&this.log(I.Info,v([w,...O]))}warn(w,...O){this.checkLogLevel(I.Warning)&&this.log(I.Warning,v([w,...O]))}error(w,...O){if(this.checkLogLevel(I.Error))if(w instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=w.stack,this.log(I.Error,v(N))}else this.log(I.Error,v([w,...O]))}flush(){}}e.AbstractMessageLogger=S;class c extends C{constructor(w=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(w),this.useColors=!D.isWindows}trace(w,...O){this.checkLogLevel(I.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,w,...O):console.log(`[main ${l()}]`,w,...O))}debug(w,...O){this.checkLogLevel(I.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,w,...O):console.log(`[main ${l()}]`,w,...O))}info(w,...O){this.checkLogLevel(I.Info)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,w,...O):console.log(`[main ${l()}]`,w,...O))}warn(w,...O){this.checkLogLevel(I.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,w,...O):console.warn(`[main ${l()}]`,w,...O))}error(w,...O){this.checkLogLevel(I.Error)&&(this.useColors?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,w,...O):console.error(`[main ${l()}]`,w,...O))}flush(){}}e.ConsoleMainLogger=c;class u extends C{constructor(w=e.DEFAULT_LOG_LEVEL,O=!0){super(),this.useColors=O,this.setLevel(w)}trace(w,...O){this.checkLogLevel(I.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",w,...O):console.log(w,...O))}debug(w,...O){this.checkLogLevel(I.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",w,...O):console.log(w,...O))}info(w,...O){this.checkLogLevel(I.Info)&&(this.useColors?console.log("%c INFO","color: #33f",w,...O):console.log(w,...O))}warn(w,...O){this.checkLogLevel(I.Warning)&&(this.useColors?console.log("%c WARN","color: #993",w,...O):console.log(w,...O))}error(w,...O){this.checkLogLevel(I.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",w,...O):console.error(w,...O))}flush(){}}e.ConsoleLogger=u;class i extends C{constructor(w,O=e.DEFAULT_LOG_LEVEL){super(),this.adapter=w,this.setLevel(O)}trace(w,...O){this.checkLogLevel(I.Trace)&&this.adapter.log(I.Trace,[this.extractMessage(w),...O])}debug(w,...O){this.checkLogLevel(I.Debug)&&this.adapter.log(I.Debug,[this.extractMessage(w),...O])}info(w,...O){this.checkLogLevel(I.Info)&&this.adapter.log(I.Info,[this.extractMessage(w),...O])}warn(w,...O){this.checkLogLevel(I.Warning)&&this.adapter.log(I.Warning,[this.extractMessage(w),...O])}error(w,...O){this.checkLogLevel(I.Error)&&this.adapter.log(I.Error,[this.extractMessage(w),...O])}extractMessage(w){return typeof w=="string"?w:(0,a.toErrorMessage)(w,this.checkLogLevel(I.Trace))}flush(){}}e.AdapterLogger=i;class n extends C{constructor(w){super(),this.loggers=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const O of this.loggers)O.setLevel(w);super.setLevel(w)}trace(w,...O){for(const N of this.loggers)N.trace(w,...O)}debug(w,...O){for(const N of this.loggers)N.debug(w,...O)}info(w,...O){for(const N of this.loggers)N.info(w,...O)}warn(w,...O){for(const N of this.loggers)N.warn(w,...O)}error(w,...O){for(const N of this.loggers)N.error(w,...O)}flush(){for(const w of this.loggers)w.flush()}dispose(){for(const w of this.loggers)w.dispose();super.dispose()}}e.MultiplexLogger=n;class t extends k.Disposable{constructor(w,O,N){if(super(),this.logLevel=w,this.logsHome=O,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new _.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,N)for(const F of N)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(w){return(0,R.isString)(w)?[...this._loggers.values()].find(O=>O.info.id===w):this._loggers.get(w)}getLogger(w){return this.getLoggerEntry(w)?.logger}createLogger(w,O){const N=this.toResource(w),F=(0,R.isString)(w)?w:O?.id??(0,L.hash)(N.toString()).toString(16);let M=this._loggers.get(N)?.logger;const H=O?.logLevel==="always"?I.Trace:O?.logLevel;M||(M=this.doCreateLogger(N,H??this.getLogLevel(N)??this.logLevel,{...O,id:F}));const z={logger:M,info:{resource:N,id:F,logLevel:H,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(z.info),this._loggers.set(N,z),M}toResource(w){return(0,R.isString)(w)?(0,E.joinPath)(this.logsHome,`${w}.log`):w}setLogLevel(w,O){if(m.URI.isUri(w)){const N=w,F=O,M=this._loggers.get(N);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.logLevel?void 0:F,M.logger?.setLevel(F),this._loggers.set(M.info.resource,M),this._onDidChangeLogLevel.fire([N,F]))}else{this.logLevel=w;for(const[N,F]of this._loggers.entries())this._loggers.get(N)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(w,O){const N=this.getLoggerEntry(w);N&&O!==!N.info.hidden&&(N.info.hidden=!O,this._loggers.set(N.info.resource,N),this._onDidChangeVisibility.fire([N.info.resource,O]))}getLogLevel(w){let O;return w&&(O=this._loggers.get(w)?.info.logLevel),O??this.logLevel}registerLogger(w){const O=this._loggers.get(w.resource);O?O.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this._loggers.set(w.resource,{info:w,logger:void 0}),this._onDidChangeLoggers.fire({added:[w],removed:[]}))}deregisterLogger(w){const O=this._loggers.get(w);O&&(O.logger&&O.logger.dispose(),this._loggers.delete(w),this._onDidChangeLoggers.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const w of this._loggers.values())yield w.info}getRegisteredLogger(w){return this._loggers.get(w)?.info}dispose(){this._loggers.forEach(w=>w.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=t;class s{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(w){}getLevel(){return I.Info}trace(w,...O){}debug(w,...O){}info(w,...O){}warn(w,...O){}error(w,...O){}critical(w,...O){}dispose(){}flush(){}}e.NullLogger=s;class r extends s{}e.NullLogService=r;function o(b){if(b.verbose)return I.Trace;if(typeof b.logLevel=="string"){const w=A(b.logLevel.toLowerCase());if(w!==void 0)return w}return e.DEFAULT_LOG_LEVEL}function h(b){switch(b){case I.Trace:return"trace";case I.Debug:return"debug";case I.Info:return"info";case I.Warning:return"warn";case I.Error:return"error";case I.Off:return"off"}}function y(b){switch(b){case I.Trace:return{original:"Trace",value:P.localize(11319,null)};case I.Debug:return{original:"Debug",value:P.localize(11320,null)};case I.Info:return{original:"Info",value:P.localize(11321,null)};case I.Warning:return{original:"Warning",value:P.localize(11322,null)};case I.Error:return{original:"Error",value:P.localize(11323,null)};case I.Off:return{original:"Off",value:P.localize(11324,null)}}}function A(b){switch(b){case"trace":return I.Trace;case"debug":return I.Debug;case"info":return I.Info;case"warn":return I.Warning;case"error":return I.Error;case"critical":return I.Error;case"off":return I.Off}}e.CONTEXT_LOG_LEVEL=new d.RawContextKey("logLevel",h(I.Info))}),define(ue[171],he([0,1,6,8,2,22,13,20,30,15,10]),function(ae,e,P,a,_,L,k,T,D,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let m=class extends _.Disposable{constructor(f,l){super(),this.environmentService=f,this.logService=l,this._register(new P.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const f=(0,T.basename)(this.environmentService.logsHome),l=(0,T.dirname)(this.environmentService.logsHome.with({scheme:L.Schemas.file})).fsPath,g=(await D.Promises.readdir(l)).filter(C=>/^\d{8}T\d{6}$/.test(C)).sort().filter(C=>C!==f),v=g.slice(0,Math.max(0,g.length-9));v.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(C=>D.Promises.rm((0,k.join)(l,C)))))}catch(f){(0,a.onUnexpectedError)(f)}}};e.LogsDataCleaner=m,e.LogsDataCleaner=m=we([Q(0,E.IEnvironmentService),Q(1,R.ILogService)],m)}),define(ue[172],he([0,1,17,6,8,3,41,2,13,46,10]),function(ae,e,P,a,_,L,k,T,D,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends T.Disposable{constructor(f,l){super(),this.logService=f,this.options=l,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new a.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new a.ThrottledDelayer(0))}watch(f,l){return l.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,l):this.watchNonRecursive(f,l)}watchUniversal(f,l){const p={path:this.toWatchPath(f),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},I=(0,P.insert)(this.universalWatchRequests,p);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{I(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,_.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(l=>this._onDidChangeFile.fire((0,E.reviveFileChanges)(l)),l=>this.onWatcherLogMessage(l),this.logService.getLevel()===R.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===R.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const l of this.universalWatchRequests)(0,E.isRecursiveWatchRequest)(l)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const l of this.universalWatchRequests)(0,E.isRecursiveWatchRequest)(l)&&f.includes(l.path)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(f,l){const p={path:this.toWatchPath(f),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},I=(0,P.insert)(this.nonRecursiveWatchRequests,p);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{I(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,_.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,E.reviveFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===R.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===R.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logWatcherMessage(f)}logWatcherMessage(f){this.logService[f.type](f.message)}toFilePath(f){return(0,D.normalize)(f.fsPath)}toWatchPath(f){const l=this.toFilePath(f);return(0,k.removeTrailingPathSeparator)(l)}}e.AbstractDiskFileSystemProvider=m}),define(ue[173],he([0,1,17,6,14,25,3,55,63,2,51,22,100,20,50,11,7,99,10,8]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends E.Disposable{static{S=this}constructor(i){super(),this.logService=i,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new k.Emitter),this._onDidUncorrelatedFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new a.ResourceQueue)}registerProvider(i,n){if(this.provider.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${i}`);const t=new E.DisposableStore;return this.provider.set(i,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:i,provider:n}),t.add(n.onDidChangeFile(s=>{const r=new I.FileChangesEvent(s,!this.isPathCaseSensitive(n));this.internalOnDidFilesChange.fire(r),r.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(r)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:i}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:i,provider:n}),this.provider.delete(i),(0,E.dispose)(t)})}getProvider(i){return this.provider.get(i)}async activateProvider(i){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:i,join(t){n.push(t)}}),!this.provider.has(i)&&await a.Promises.settled(n)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.provider.has(i.scheme)}hasCapability(i,n){const t=this.provider.get(i.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return D.Iterable.map(this.provider,([i,n])=>({scheme:i,capabilities:n.capabilities}))}async withProvider(i){if(!(0,f.isAbsolutePath)(i))throw new I.FileOperationError((0,p.localize)(11392,null,this.resourceForError(i)),I.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const n=this.provider.get(i.scheme);if(!n){const t=new C.ErrorNoTelemetry;throw t.message=(0,p.localize)(11393,null,i.toString()),t}return n}async withReadProvider(i){const n=await this.withProvider(i);if((0,I.hasOpenReadWriteCloseCapability)(n)||(0,I.hasReadWriteCapability)(n)||(0,I.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(i){const n=await this.withProvider(i);if((0,I.hasOpenReadWriteCloseCapability)(n)||(0,I.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,n){try{return await this.doResolveFile(i,n)}catch(t){throw(0,I.toFileSystemProviderErrorCode)(t)===I.FileSystemProviderErrorCode.FileNotFound?new I.FileOperationError((0,p.localize)(11394,null,this.resourceForError(i)),I.FileOperationResult.FILE_NOT_FOUND):(0,I.ensureFileSystemProviderError)(t)}}async doResolveFile(i,n){const t=await this.withProvider(i),s=this.isPathCaseSensitive(t),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,h=n?.resolveMetadata,y=await t.stat(i);let A;return this.toFileStat(t,i,y,void 0,!!h,(b,w)=>(A||(A=R.TernarySearchTree.forUris(()=>!s),A.set(i,!0),r&&A.fill(!0,r)),A.get(b.resource)||A.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&o?w===1:!1))}async toFileStat(i,n,t,s,r,o){const{providerExtUri:h}=this.getExtUri(i),y={resource:n,name:h.basename(n),isFile:(t.type&I.FileType.File)!==0,isDirectory:(t.type&I.FileType.Directory)!==0,isSymbolicLink:(t.type&I.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&I.FilePermission.Readonly)||!!(i.capabilities&I.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&I.FilePermission.Locked),etag:(0,I.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(y.isDirectory&&o(y,s)){try{const A=await i.readdir(n),b=await a.Promises.settled(A.map(async([w,O])=>{try{const N=h.joinPath(n,w),F=r?await i.stat(N):{type:O};return await this.toFileStat(i,N,F,A.length,r,o)}catch(N){return this.logService.trace(N),null}}));y.children=(0,P.coalesce)(b)}catch(A){this.logService.trace(A),y.children=[]}return y}return y}async resolveAll(i){return a.Promises.settled(i.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const n=await this.withProvider(i),t=await n.stat(i);return this.toFileStat(n,i,t,void 0,!0,()=>!1)}async exists(i){const n=await this.withProvider(i);try{return!!await n.stat(i)}catch{return!1}}async canCreateFile(i,n){try{await this.doValidateCreateFile(i,n)}catch(t){return t}return!0}async doValidateCreateFile(i,n){if(!n?.overwrite&&await this.exists(i))throw new I.FileOperationError((0,p.localize)(11395,null,this.resourceForError(i)),I.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(i,n=_.VSBuffer.fromString(""),t){await this.doValidateCreateFile(i,t);const s=await this.writeFile(i,n);return this._onDidRunOperation.fire(new I.FileOperationEvent(i,I.FileOperation.CREATE,s)),s}async writeFile(i,n,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),{providerExtUri:r}=this.getExtUri(s);let o=t;if((0,I.hasFileAtomicWriteCapability)(s)&&!o?.atomic){const h=s.enforceAtomicWriteFile?.(i);h&&(o={...t,atomic:h})}try{await this.validateWriteFile(s,i,o)||await this.mkdirp(s,r.dirname(i));let y;if((0,I.hasReadWriteCapability)(s)&&!(n instanceof _.VSBuffer))if((0,l.isReadableStream)(n)){const A=await(0,l.peekStream)(n,3);A.ended?y=_.VSBuffer.concat(A.buffer):y=A}else y=(0,l.peekReadable)(n,A=>_.VSBuffer.concat(A),3);else y=n;!(0,I.hasOpenReadWriteCloseCapability)(s)||(0,I.hasReadWriteCapability)(s)&&y instanceof _.VSBuffer||(0,I.hasReadWriteCapability)(s)&&(0,I.hasFileAtomicWriteCapability)(s)&&o?.atomic?await this.doWriteUnbuffered(s,i,o,y):await this.doWriteBuffered(s,i,o,y instanceof _.VSBuffer?(0,_.bufferToReadable)(y):y),this._onDidRunOperation.fire(new I.FileOperationEvent(i,I.FileOperation.WRITE))}catch(h){throw new I.FileOperationError((0,p.localize)(11396,null,this.resourceForError(i),(0,I.ensureFileSystemProviderError)(h).toString()),(0,I.toFileOperationResult)(h),o)}return this.resolve(i,{resolveMetadata:!0})}async validateWriteFile(i,n,t){const s=!!t?.unlock;if(s&&!(i.capabilities&I.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,p.localize)(11397,null,this.resourceForError(n)));if(!!t?.atomic){if(!(i.capabilities&I.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,p.localize)(11398,null,this.resourceForError(n)));if(!(i.capabilities&I.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,p.localize)(11399,null,this.resourceForError(n)));if(s)throw new Error((0,p.localize)(11400,null,this.resourceForError(n)))}let o;try{o=await i.stat(n)}catch{return}if(o.type&I.FileType.Directory)throw new I.FileOperationError((0,p.localize)(11401,null,this.resourceForError(n)),I.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.throwIfFileIsReadonly(n,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==I.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,I.etag)({mtime:t.mtime,size:o.size}))throw new I.FileOperationError((0,p.localize)(11402,null),I.FileOperationResult.FILE_MODIFIED_SINCE,t);return o}async readFile(i,n,t){const s=await this.withReadProvider(i);return n?.atomic?this.doReadFileAtomic(s,i,n,t):this.doReadFile(s,i,n,t)}async doReadFileAtomic(i,n,t,s){return new Promise((r,o)=>{this.writeQueue.queueFor(n,async()=>{try{const h=await this.doReadFile(i,n,t,s);r(h)}catch(h){o(h)}},this.getExtUri(i).providerExtUri)})}async doReadFile(i,n,t,s){const r=await this.doReadFileStream(i,n,{...t,preferUnbuffered:!0},s);return{...r,value:await(0,_.streamToBuffer)(r.value)}}async readFileStream(i,n,t){const s=await this.withReadProvider(i);return this.doReadFileStream(s,i,n,t)}async doReadFileStream(i,n,t,s){const r=new L.CancellationTokenSource(s);let o=t;(0,I.hasFileAtomicReadCapability)(i)&&i.enforceAtomicReadFile?.(n)&&(o={...t,atomic:!0});const h=this.validateReadFile(n,o).then(A=>A,A=>{throw r.dispose(!0),A});let y;try{return typeof o?.etag=="string"&&o.etag!==I.ETAG_DISABLED&&await h,o?.atomic&&(0,I.hasFileAtomicReadCapability)(i)||!((0,I.hasOpenReadWriteCloseCapability)(i)||(0,I.hasFileReadStreamCapability)(i))||(0,I.hasReadWriteCapability)(i)&&o?.preferUnbuffered?y=this.readFileUnbuffered(i,n,o):(0,I.hasFileReadStreamCapability)(i)?y=this.readFileStreamed(i,n,r.token,o):y=this.readFileBuffered(i,n,r.token,o),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await h,value:y}}catch(A){throw y&&await(0,l.consumeStream)(y),this.restoreReadError(A,n,o)}}restoreReadError(i,n,t){const s=(0,p.localize)(11403,null,this.resourceForError(n),(0,I.ensureFileSystemProviderError)(i).toString());return i instanceof I.NotModifiedSinceFileOperationError?new I.NotModifiedSinceFileOperationError(s,i.stat,t):i instanceof I.TooLargeFileOperationError?new I.TooLargeFileOperationError(s,i.fileOperationResult,i.size,i.options):new I.FileOperationError(s,(0,I.toFileOperationResult)(i),t)}readFileStreamed(i,n,t,s=Object.create(null)){const r=i.readFileStream(n,s,t);return(0,l.transform)(r,{data:o=>o instanceof _.VSBuffer?o:_.VSBuffer.wrap(o),error:o=>this.restoreReadError(o,n,s)},o=>_.VSBuffer.concat(o))}readFileBuffered(i,n,t,s=Object.create(null)){const r=(0,_.newWriteableBufferStream)();return(0,g.readFileIntoStream)(i,n,r,o=>o,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>this.restoreReadError(o,n,s)},t),r}readFileUnbuffered(i,n,t){const s=(0,l.newWriteableStream)(r=>_.VSBuffer.concat(r));return(async()=>{try{let r;t?.atomic&&(0,I.hasFileAtomicReadCapability)(i)?r=await i.readFile(n,{atomic:!0}):r=await i.readFile(n),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(n,r.byteLength,t),s.end(_.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(i,n){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new I.FileOperationError((0,p.localize)(11404,null,this.resourceForError(i)),I.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==I.ETAG_DISABLED&&n.etag===t.etag)throw new I.NotModifiedSinceFileOperationError((0,p.localize)(11405,null),t,n);return this.validateReadFileLimits(i,t.size,n),t}validateReadFileLimits(i,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new I.TooLargeFileOperationError((0,p.localize)(11406,null,this.resourceForError(i)),I.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(i,n,t){return this.doCanMoveCopy(i,n,"move",t)}async canCopy(i,n,t){return this.doCanMoveCopy(i,n,"copy",t)}async doCanMoveCopy(i,n,t,s){if(i.toString()!==n.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i):await this.withReadProvider(i),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,i,o,n,t,s)}catch(r){return r}return!0}async move(i,n,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),o=await this.doMoveCopy(s,i,r,n,"move",!!t),h=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(i,o==="move"?I.FileOperation.MOVE:I.FileOperation.COPY,h)),h}async copy(i,n,t){const s=await this.withReadProvider(i),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),o=await this.doMoveCopy(s,i,r,n,"copy",!!t),h=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(i,o==="copy"?I.FileOperation.COPY:I.FileOperation.MOVE,h)),h}async doMoveCopy(i,n,t,s,r,o){if(n.toString()===s.toString())return r;const{exists:h,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(i,n,t,s,r,o);if(h&&!y&&o&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),r==="copy"){if(i===t&&(0,I.hasFileFolderCopyCapability)(i))await i.copy(n,s,{overwrite:o});else{const A=await this.resolve(n);A.isDirectory?await this.doCopyFolder(i,A,t,s):await this.doCopyFile(i,n,t,s)}return r}else return i===t?(await i.rename(n,s,{overwrite:o}),r):(await this.doMoveCopy(i,n,t,s,"copy",o),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(i,n,t,s){if((0,I.hasOpenReadWriteCloseCapability)(i)&&(0,I.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(i,n,t,s);if((0,I.hasOpenReadWriteCloseCapability)(i)&&(0,I.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(i,n,t,s);if((0,I.hasReadWriteCapability)(i)&&(0,I.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(i,n,t,s);if((0,I.hasReadWriteCapability)(i)&&(0,I.hasReadWriteCapability)(t))return this.doPipeUnbuffered(i,n,t,s)}async doCopyFolder(i,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await a.Promises.settled(n.children.map(async r=>{const o=this.getExtUri(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(i,await this.resolve(r.resource),t,o):this.doCopyFile(i,r.resource,t,o)}))}async doValidateMoveCopy(i,n,t,s,r,o){let h=!1;if(i===t){const{providerExtUri:A,isPathCaseSensitive:b}=this.getExtUri(i);if(b||(h=A.isEqual(n,s)),h&&r==="copy")throw new Error((0,p.localize)(11407,null,this.resourceForError(n),this.resourceForError(s)));if(!h&&A.isEqualOrParent(s,n))throw new Error((0,p.localize)(11408,null,this.resourceForError(n),this.resourceForError(s)))}const y=await this.exists(s);if(y&&!h){if(!o)throw new I.FileOperationError((0,p.localize)(11409,null,this.resourceForError(n),this.resourceForError(s)),I.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:A}=this.getExtUri(i);if(A.isEqualOrParent(n,s))throw new Error((0,p.localize)(11410,null,this.resourceForError(n),this.resourceForError(s)))}}return{exists:y,isSameResourceWithDifferentPathCase:h}}getExtUri(i){const n=this.isPathCaseSensitive(i);return{providerExtUri:n?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(i){return!!(i.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i);await this.mkdirp(n,i);const t=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(i,I.FileOperation.CREATE,t)),t}async mkdirp(i,n){const t=[],{providerExtUri:s}=this.getExtUri(i);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await i.stat(n)).type&I.FileType.Directory))throw new Error((0,p.localize)(11411,null,this.resourceForError(n)));break}catch(r){if((0,I.toFileSystemProviderErrorCode)(r)!==I.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(n)),n=s.dirname(n)}for(let r=t.length-1;r>=0;r--){n=s.joinPath(n,t[r]);try{await i.mkdir(n)}catch(o){if((0,I.toFileSystemProviderErrorCode)(o)!==I.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(i,n){try{await this.doValidateDelete(i,n)}catch(t){return t}return!0}async doValidateDelete(i,n){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i),s=!!n?.useTrash;if(s&&!(t.capabilities&I.FileSystemProviderCapabilities.Trash))throw new Error((0,p.localize)(11412,null,this.resourceForError(i)));const r=n?.atomic;if(r&&!(t.capabilities&I.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,p.localize)(11413,null,this.resourceForError(i)));if(s&&r)throw new Error((0,p.localize)(11414,null,this.resourceForError(i)));let o;try{o=await t.stat(i)}catch{}if(o)this.throwIfFileIsReadonly(i,o);else throw new I.FileOperationError((0,p.localize)(11415,null,this.resourceForError(i)),I.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const y=await this.resolve(i);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,p.localize)(11416,null,this.resourceForError(i)))}return t}async del(i,n){const t=await this.doValidateDelete(i,n);let s=n;if((0,I.hasFileAtomicDeleteCapability)(t)&&!s?.atomic){const y=t.enforceAtomicDelete?.(i);y&&(s={...n,atomic:y})}const r=!!s?.useTrash,o=!!s?.recursive,h=s?.atomic??!1;await t.delete(i,{recursive:o,useTrash:r,atomic:h}),this._onDidRunOperation.fire(new I.FileOperationEvent(i,I.FileOperation.DELETE))}async cloneFile(i,n){const t=await this.withProvider(i),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(!(t===s&&this.getExtUri(t).providerExtUri.isEqual(i,n)))return t===s&&(0,I.hasFileCloneCapability)(t)?t.cloneFile(i,n):(await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(n)),t===s&&(0,I.hasFileFolderCopyCapability)(t)?this.writeQueue.queueFor(i,()=>t.copy(i,n,{overwrite:!0}),this.getExtUri(t).providerExtUri):this.writeQueue.queueFor(i,()=>this.doCopyFile(t,i,s,n),this.getExtUri(t).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(i,n){return this.watch(i,{...n,correlationId:S.WATCHER_CORRELATION_IDS++})}watch(i,n={recursive:!1,excludes:[]}){const t=new E.DisposableStore;let s=!1,r=()=>{s=!0};t.add((0,E.toDisposable)(()=>r())),(async()=>{try{const h=await this.doWatch(i,n);s?(0,E.dispose)(h):r=()=>(0,E.dispose)(h)}catch(h){this.logService.error(h)}})();const o=n.correlationId;if(typeof o=="number"){const h=t.add(new k.Emitter);return t.add(this.internalOnDidFilesChange.event(A=>{A.correlates(o)&&h.fire(A)})),{onDidChange:h.event,dispose:()=>t.dispose()}}return t}async doWatch(i,n){const t=await this.withProvider(i),s=(0,T.hash)([this.getExtUri(t).providerExtUri.getComparisonKey(i),n]);let r=this.activeWatchers.get(s);return r||(r={count:0,disposable:t.watch(i,n)},this.activeWatchers.set(s,r)),r.count+=1,(0,E.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,E.dispose)(r.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.activeWatchers)(0,E.dispose)(i.disposable);this.activeWatchers.clear()}async doWriteBuffered(i,n,t,s){return this.writeQueue.queueFor(n,async()=>{const r=await i.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,l.isReadableStream)(s)||(0,l.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(i,r,s):await this.doWriteReadableBufferedQueued(i,r,s)}catch(o){throw(0,I.ensureFileSystemProviderError)(o)}finally{await i.close(r)}},this.getExtUri(i).providerExtUri)}async doWriteStreamBufferedQueued(i,n,t){let s=0,r;if((0,l.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=_.VSBuffer.concat(t.buffer);await this.doWriteBuffer(i,n,o,o.byteLength,s,0),s+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((o,h)=>{(0,l.listenStream)(r,{onData:async y=>{r.pause();try{await this.doWriteBuffer(i,n,y,y.byteLength,s,0)}catch(A){return h(A)}s+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>h(y),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(i,n,t){let s=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(i,n,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(i,n,t,s,r,o){let h=0;for(;h<s;){const y=await i.write(n,r+h,t.buffer,o+h,s-h);h+=y}}async doWriteUnbuffered(i,n,t,s){return this.writeQueue.queueFor(n,()=>this.doWriteUnbufferedQueued(i,n,t,s),this.getExtUri(i).providerExtUri)}async doWriteUnbufferedQueued(i,n,t,s){let r;s instanceof _.VSBuffer?r=s:(0,l.isReadableStream)(s)?r=await(0,_.streamToBuffer)(s):(0,l.isReadableBufferedStream)(s)?r=await(0,_.bufferedStreamToBuffer)(s):r=(0,_.readableToBuffer)(s),await i.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async doPipeBuffered(i,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeBufferedQueued(i,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeBufferedQueued(i,n,t,s){let r,o;try{r=await i.open(n,{create:!1}),o=await t.open(s,{create:!0,unlock:!1});const h=_.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,A=0,b=0;do b=await i.read(r,y,h.buffer,A,h.byteLength-A),await this.doWriteBuffer(t,o,h,b,y,A),y+=b,A+=b,A===h.byteLength&&(A=0);while(b>0)}catch(h){throw(0,I.ensureFileSystemProviderError)(h)}finally{await a.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(i,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeUnbufferedQueued(i,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeUnbufferedQueued(i,n,t,s){return t.writeFile(s,await i.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(i,n,t,s){return this.writeQueue.queueFor(s,()=>this.doPipeUnbufferedToBufferedQueued(i,n,t,s),this.getExtUri(t).providerExtUri)}async doPipeUnbufferedToBufferedQueued(i,n,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const o=await i.readFile(n);await this.doWriteBuffer(t,r,_.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,I.ensureFileSystemProviderError)(o)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(i,n,t,s){const r=await(0,_.streamToBuffer)(this.readFileBuffered(i,n,L.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,r)}throwIfFileSystemIsReadonly(i,n){if(i.capabilities&I.FileSystemProviderCapabilities.Readonly)throw new I.FileOperationError((0,p.localize)(11417,null,this.resourceForError(n)),I.FileOperationResult.FILE_PERMISSION_DENIED);return i}throwIfFileIsReadonly(i,n){if((n.permissions??0)&I.FilePermission.Readonly)throw new I.FileOperationError((0,p.localize)(11418,null,this.resourceForError(i)),I.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(i){return i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}};e.FileService=c,e.FileService=c=S=we([Q(0,v.ILogService)],c)}),define(ue[174],he([0,1,33,6,31,14,3,41,2,13,5,20,50,30,11,7,99,172,169,168]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class S extends g.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(u,i){super(u,i),this.onDidChangeCapabilities=k.Event.None,this.resourceLocks=new _.ResourceMap(n=>m.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,R.isLinux&&(this._capabilities|=p.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(u){try{const{stat:i,symbolicLink:n}=await f.SymlinkSupport.stat(this.toFilePath(u));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const i=await f.Promises.readdir(this.toFilePath(u),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,m.joinPath)(u,t.name))).type:s=this.toType(t),n.push([t.name,s])}catch(s){this.logService.trace(s)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(u,i){let n;return i?.dangling?n=p.FileType.Unknown:u.isFile()?n=p.FileType.File:u.isDirectory()?n=p.FileType.Directory:n=p.FileType.Unknown,i&&(n|=p.FileType.SymbolicLink),n}async createResourceLock(u){const i=this.toFilePath(u);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.resourceLocks.get(u);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const t=new a.Barrier;return this.resourceLocks.set(u,t),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,D.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(u)===t&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(u)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(u,i){let n;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(u)})`),n=await this.createResourceLock(u));const t=this.toFilePath(u);return await P.promises.readFile(t)}catch(t){throw this.toFileSystemProviderError(t)}finally{n?.dispose()}}traceLock(u){S.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(u)}readFileStream(u,i,n){const t=(0,d.newWriteableStream)(s=>L.VSBuffer.concat(s.map(r=>L.VSBuffer.wrap(r))).buffer);return(0,I.readFileIntoStream)(this,u,t,s=>s.buffer,{...i,bufferSize:256*1024},n),t}async writeFile(u,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(u)?this.doWriteFileAtomic(u,(0,m.joinPath)((0,m.dirname)(u),`${(0,m.basename)(u)}${n.atomic.postfix}`),i,n):this.doWriteFile(u,i,n)}async canWriteFileAtomic(u){try{const i=this.toFilePath(u),{symbolicLink:n}=await f.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async doWriteFileAtomic(u,i,n,t){const s=new D.DisposableStore;try{s.add(await this.createResourceLock(u)),s.add(await this.createResourceLock(i)),await this.doWriteFile(i,n,t,!0);try{await this.rename(i,u,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{s.dispose()}}async doWriteFile(u,i,n,t){let s;try{const r=this.toFilePath(u);if(!n.create||!n.overwrite){if(await f.Promises.exists(r)){if(!n.overwrite)throw(0,p.createFileSystemProviderError)((0,l.localize)(11376,null),p.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,p.createFileSystemProviderError)((0,l.localize)(11377,null),p.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(u,{create:!0,unlock:n.unlock},t),await this.write(s,0,i,0,i.byteLength)}catch(r){throw await this.toFileSystemProviderWriteError(u,r)}finally{typeof s=="number"&&await this.close(s)}}static{this.canFlush=!0}static configureFlushOnWrite(u){S.canFlush=u}async open(u,i,n){const t=this.toFilePath(u);let s;(0,p.isFileOpenForWriteOptions)(i)&&!n&&(s=await this.createResourceLock(u));let r;try{if((0,p.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:h}=await f.SymlinkSupport.stat(t);h.mode&128||await P.promises.chmod(t,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}let o;if((0,p.isFileOpenForWriteOptions)(i)){if(R.isWindows)try{await P.promises.truncate(t,0),o="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}o||(o="w")}else o="r";r=await f.Promises.open(t,o)}catch(o){throw s?.dispose(),(0,p.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(u,o):this.toFileSystemProviderError(o)}if(this.mapHandleToPos.set(r,0),(0,p.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(r,u),s){const o=this.mapHandleToLock.get(r);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.mapHandleToLock.set(r,s),o&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),o.dispose())}return r}async close(u){const i=this.mapHandleToLock.get(u);try{if(this.mapHandleToPos.delete(u),this.writeHandles.delete(u)&&S.canFlush)try{await f.Promises.fdatasync(u)}catch(n){S.configureFlushOnWrite(!1),this.logService.error(n)}return await f.Promises.close(u)}catch(n){throw this.toFileSystemProviderError(n)}finally{i&&(this.mapHandleToLock.get(u)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.mapHandleToLock.delete(u)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),i.dispose())}}async read(u,i,n,t,s){const r=this.normalizePos(u,i);let o=null;try{o=(await f.Promises.read(u,n,t,s,r)).bytesRead}catch(h){throw this.toFileSystemProviderError(h)}finally{this.updatePos(u,r,o)}return o}normalizePos(u,i){return i===this.mapHandleToPos.get(u)?null:i}updatePos(u,i,n){const t=this.mapHandleToPos.get(u);typeof t=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(u,t+n):this.mapHandleToPos.delete(u)))}async write(u,i,n,t,s){return(0,a.retry)(()=>this.doWrite(u,i,n,t,s),100,3)}async doWrite(u,i,n,t,s){const r=this.normalizePos(u,i);let o=null;try{o=(await f.Promises.write(u,n,t,s,r)).bytesWritten}catch(h){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(u),h)}finally{this.updatePos(u,r,o)}return o}async mkdir(u){try{await P.promises.mkdir(this.toFilePath(u))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(u,i){try{const n=this.toFilePath(u);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,E.join)((0,E.dirname)(n),`${(0,E.basename)(n)}${i.atomic.postfix}`)),await f.Promises.rm(n,f.RimRafMode.MOVE,t)}else try{await P.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:r,symbolicLink:o}=await f.SymlinkSupport.stat(n);s=r.isDirectory()&&!o}catch{}if(s)await P.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(u,i,n){const t=this.toFilePath(u),s=this.toFilePath(i);if(t!==s)try{await this.validateMoveCopy(u,i,"move",n.overwrite),await f.Promises.rename(t,s)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11378,null,(0,E.basename)(t),(0,E.basename)((0,E.dirname)(s)),r.toString()))),this.toFileSystemProviderError(r)}}async copy(u,i,n){const t=this.toFilePath(u),s=this.toFilePath(i);if(t!==s)try{await this.validateMoveCopy(u,i,"copy",n.overwrite),await f.Promises.copy(t,s,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11379,null,(0,E.basename)(t),(0,E.basename)((0,E.dirname)(s)),r.toString()))),this.toFileSystemProviderError(r)}}async validateMoveCopy(u,i,n,t){const s=this.toFilePath(u),r=this.toFilePath(i);let o=!1;if(!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,T.isEqual)(s,r,!0)),o){if(n==="copy")throw(0,p.createFileSystemProviderError)((0,l.localize)(11380,null),p.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const y=await this.statIgnoreError(u);if(!y)throw(0,p.createFileSystemProviderError)((0,l.localize)(11381,null),p.FileSystemProviderErrorCode.FileNotFound);const A=await this.statIgnoreError(i);if(A){if(!t)throw(0,p.createFileSystemProviderError)((0,l.localize)(11382,null),p.FileSystemProviderErrorCode.FileExists);y.type&p.FileType.File&&A.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,i){return this.doCloneFile(u,i,!1)}async doCloneFile(u,i,n){const t=this.toFilePath(u),s=this.toFilePath(i),r=!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.isEqual)(t,s,!r))return;const o=new D.DisposableStore;try{o.add(await this.createResourceLock(u)),o.add(await this.createResourceLock(i)),n&&await P.promises.mkdir((0,E.dirname)(s),{recursive:!0}),await P.promises.copyFile(t,s)}catch(h){if(h.code==="ENOENT"&&!n)return this.doCloneFile(u,i,!0);throw this.toFileSystemProviderError(h)}finally{o.dispose()}}createUniversalWatcher(u,i,n){return new v.UniversalWatcherClient(t=>u(t),t=>i(t),n)}createNonRecursiveWatcher(u,i,n){return new C.NodeJSWatcherClient(t=>u(t),t=>i(t),n)}toFileSystemProviderError(u){if(u instanceof p.FileSystemProviderError)return u;let i=u,n;switch(u.code){case"ENOENT":n=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=p.FileSystemProviderErrorCode.Unknown;break;default:n=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(u,i){let n=this.toFileSystemProviderError(i);if(u&&n.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await f.SymlinkSupport.stat(this.toFilePath(u));t.mode&128||(n=(0,p.createFileSystemProviderError)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.logService.trace(t)}return n}}e.DiskFileSystemProvider=S}),define(ue[101],he([0,1,3,2,4,10]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,_.createDecorator)("sharedProcessLifecycleService");let k=class extends a.Disposable{constructor(D){super(),this.logService=D,this._onWillShutdown=this._register(new P.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=k,e.SharedProcessLifecycleService=k=we([Q(0,L.ILogService)],k)}),define(ue[175],he([0,1,9,3,10,2]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class k extends _.AbstractLoggerService{constructor(m,d,f,l,p){super(d,f,l),this.windowId=m,this.channel=p,this._register(p.listen("onDidChangeLogLevel",m)(I=>{(0,_.isLogLevel)(I)?super.setLogLevel(I):super.setLogLevel(P.URI.revive(I[0]),I[1])})),this._register(p.listen("onDidChangeVisibility",m)(([I,g])=>super.setVisibility(P.URI.revive(I),g))),this._register(p.listen("onDidChangeLoggers",m)(({added:I,removed:g})=>{for(const v of I)super.registerLogger({...v,resource:P.URI.revive(v.resource)});for(const v of g)super.deregisterLogger(v.resource)}))}createConsoleMainLogger(){return new _.AdapterLogger({log:(m,d)=>{this.channel.call("consoleLog",[m,d])}})}registerLogger(m){super.registerLogger(m),this.channel.call("registerLogger",[m,this.windowId])}deregisterLogger(m){super.deregisterLogger(m),this.channel.call("deregisterLogger",[m,this.windowId])}setLogLevel(m,d){super.setLogLevel(m,d),this.channel.call("setLogLevel",[m,d])}setVisibility(m,d){super.setVisibility(m,d),this.channel.call("setVisibility",[this.toResource(m),d])}doCreateLogger(m,d,f){return new T(this.channel,m,d,f,this.windowId)}static setLogLevel(m,d,f){return m.call("setLogLevel",[d,f])}}e.LoggerChannelClient=k;class T extends _.AbstractMessageLogger{constructor(m,d,f,l,p){super(l?.logLevel==="always"),this.channel=m,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[d,l,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,d){const f=[[m,d]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(m){this.channel.call("log",[this.file,m])}}class D{constructor(m,d){this.loggerService=m,this.getUriTransformer=d}listen(m,d){const f=this.getUriTransformer(m);switch(d){case"onDidChangeLoggers":return a.Event.map(this.loggerService.onDidChangeLoggers,l=>({added:[...l.added].map(p=>this.transformLogger(p,f)),removed:[...l.removed].map(p=>this.transformLogger(p,f))}));case"onDidChangeVisibility":return a.Event.map(this.loggerService.onDidChangeVisibility,l=>[f.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return a.Event.map(this.loggerService.onDidChangeLogLevel,l=>(0,_.isLogLevel)(l)?l:[f.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${d}`)}async call(m,d,f){const l=this.getUriTransformer(m);switch(d){case"setLogLevel":return(0,_.isLogLevel)(f[0])?this.loggerService.setLogLevel(f[0]):this.loggerService.setLogLevel(P.URI.revive(l.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(p=>this.transformLogger(p,l)))}throw new Error(`Call not found: ${d}`)}transformLogger(m,d){return{...m,resource:d.transformOutgoingURI(m.resource)}}}e.LoggerChannel=D;class E extends L.Disposable{constructor(m,d){super(),d.call("setLogLevel",[m.getLogLevel()]),this._register(m.onDidChangeLogLevel(f=>d.call("setLogLevel",[f]))),d.call("getRegisteredLoggers").then(f=>{for(const l of f)m.registerLogger({...l,resource:P.URI.revive(l.resource)})}),this._register(d.listen("onDidChangeVisibility")(([f,l])=>m.setVisibility(P.URI.revive(f),l))),this._register(d.listen("onDidChangeLoggers")(({added:f,removed:l})=>{for(const p of f)m.registerLogger({...p,resource:P.URI.revive(p.resource)});for(const p of l)m.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=E}),define(ue[176],he([0,1,2,10]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class _ extends P.Disposable{constructor(k,T=[]){super(),this.logger=new a.MultiplexLogger([k,...T]),this._register(k.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,...T){this.logger.trace(k,...T)}debug(k,...T){this.logger.debug(k,...T)}info(k,...T){this.logger.info(k,...T)}warn(k,...T){this.logger.warn(k,...T)}error(k,...T){this.logger.error(k,...T)}flush(){this.logger.flush()}}e.LogService=_}),define(ue[57],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,P.createDecorator)("nativeHostService")}),define(ue[177],he([0,1,42,56]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostService=void 0;let _=class{constructor(k,T){return this.windowId=k,P.ProxyChannel.toService(T.getChannel("nativeHost"),{context:k,properties:(()=>{const D=new Map;return D.set("windowId",k),D})()})}};e.NativeHostService=_,e.NativeHostService=_=we([Q(1,a.IMainProcessService)],_)}),define(ue[58],he([0,1,3,63,2,4]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class k extends _.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(E){const R=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...E,...this.policyDefinitions},R!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(E),a.Iterable.reduce(this.policies.entries(),(m,[d,f])=>({...m,[d]:f}),{})}getPolicyValue(E){return this.policies.get(E)}serialize(){return a.Iterable.reduce(Object.entries(this.policyDefinitions),(E,[R,m])=>({...E,[R]:{definition:m,value:this.policies.get(R)}}),{})}}e.AbstractPolicyService=k;class T{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=T}),define(ue[178],he([0,1,3,2,58]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(D){this.service=D,this.disposables=new a.DisposableStore}listen(D,E){switch(E){case"onDidChange":return P.Event.map(this.service.onDidChange,R=>R.reduce((m,d)=>({...m,[d]:this.service.getPolicyValue(d)??null}),{}),this.disposables)}throw new Error(`Event not found: ${E}`)}call(D,E,R){switch(E){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(R)}throw new Error(`Call not found: ${E}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class k extends _.AbstractPolicyService{constructor(D,E){super(),this.channel=E;for(const R in D){const{definition:m,value:d}=D[R];this.policyDefinitions[R]=m,d!==void 0&&this.policies.set(R,d)}this.channel.listen("onDidChange")(R=>{for(const m in R){const d=R[m];d===null?this.policies.delete(m):this.policies.set(m,d)}this._onDidChange.fire(Object.keys(R))})}async _updatePolicyDefinitions(D){const E=await this.channel.call("updatePolicyDefinitions",D);for(const R in E)this.policies.set(R,E[R])}}e.PolicyChannelClient=k}),define(ue[102],he([0,1,37]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const _=globalThis.vscode;if(typeof _<"u"&&typeof _.context<"u"){const L=_.context.configuration();if(L)a=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){a=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:L,searchUrl:k,itemUrl:T,controlUrl:D}=a.extensionsGallery||{};Object.assign(a,{extensionsGallery:{serviceUrl:P.env.VSCODE_GALLERY_SERVICE_URL||L,searchUrl:P.env.VSCODE_GALLERY_SEARCH_URL||k,itemUrl:P.env.VSCODE_GALLERY_ITEM_URL||T,controlUrl:P.env.VSCODE_GALLERY_CONTROL_URL||D}});try{const E=(...m)=>m.reduce((d,f)=>(Object.keys(f).forEach(l=>{Array.isArray(d[l])&&Array.isArray(f[l])?d[l]=f[l]:typeof d[l]=="object"&&typeof f[l]=="object"?d[l]=E(d[l],f[l]):d[l]=f[l]}),d),{}),R=globalThis._VSCODE_USER_PRODUCT_JSON||{};a=E(a,R)}catch{}if(P.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const E=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:E.version,release:E.release})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(ue[23],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,P.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ue[179],he([0,1,33,6,8,2,13,30,10,23]),function(ae,e,P,a,_,L,k,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0,P=De(P);let R=class extends L.Disposable{constructor(d,f,l){super(),this.productService=f,this.logService=l,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,d&&this._register(new a.RunOnceScheduler(()=>{this.cleanUpCodeCaches(d)},3e4)).schedule()}async cleanUpCodeCaches(d){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),l=(0,k.dirname)(d),p=(0,k.basename)(d),I=await T.Promises.readdir(l);await Promise.all(I.map(async g=>{if(g===p)return;const v=(0,k.join)(l,g),C=await P.promises.stat(v);if(C.isDirectory()&&f-C.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),T.Promises.rm(v)}))}catch(f){(0,_.onUnexpectedError)(f)}}};e.CodeCacheCleaner=R,e.CodeCacheCleaner=R=we([Q(1,E.IProductService),Q(2,D.ILogService)],R)}),define(ue[180],he([0,1,33,6,8,2,13,30,15,10,23]),function(ae,e,P,a,_,L,k,T,D,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0,P=De(P);let m=class extends L.Disposable{constructor(f,l,p){super(),this.environmentService=f,this.logService=l,this.productService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new a.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),l=JSON.parse(await P.promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const C of Object.keys(l)){const S=l[C];f[`${S.hash}.${C}`]=!0}const p=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(p))return;const g=await T.Promises.readdir(p);for(const C of g){if(f[C]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${C}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${C}`),await T.Promises.rm((0,k.join)(p,C))}const v=Date.now();for(const C of Object.keys(f)){const S=(0,k.join)(p,C),c=await T.Promises.readdir(S);for(const u of c){if(u==="tcf.json")continue;const i=(0,k.join)(S,u),n=await P.promises.stat(i);n.isDirectory()&&v-n.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(C,u)}`),await T.Promises.rm(i))}}}catch(f){(0,_.onUnexpectedError)(f)}}};e.LanguagePackCachedDataCleaner=m,e.LanguagePackCachedDataCleaner=m=we([Q(0,D.INativeEnvironmentService),Q(1,E.ILogService),Q(2,R.IProductService)],m)}),define(ue[181],he([0,1,13,4]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,a.createDecorator)("IV8InspectProfilingService");var _;(function(L){function k(D){return!!(D.samples&&D.timeDeltas)}L.isValidProfile=k;function T(D,E="noAbsolutePaths"){for(const R of D.nodes)R.callFrame&&R.callFrame.url&&((0,P.isAbsolute)(R.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(R.callFrame.url))&&(R.callFrame.url=(0,P.join)(E,(0,P.basename)(R.callFrame.url)));return D}L.rewriteAbsolutePaths=T})(_||(e.Utils=_={}))}),define(ue[182],he([0,1,32]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class a{constructor(){this._sessions=new Map}async startProfiling(L){const T=await(await new Promise((E,R)=>{ae(["v8-inspect-profiler"],E,R)}).then(De)).startProfiling({host:L.host,port:L.port,checkForPaused:!0}),D=(0,P.generateUuid)();return this._sessions.set(D,T),D}async stopProfiling(L){const k=this._sessions.get(L);if(!k)throw new Error(`UNKNOWN session '${L}'`);const T=await k.stop();return this._sessions.delete(L),T.profile}}e.InspectProfilingService=a}),define(ue[44],he([0,1,131,12]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,P=De(P),a=De(a);class _{constructor(){this.data=new Map}add(k,T){P.ok(a.isString(k)),P.ok(a.isObject(T)),P.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,T)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new _}),define(ue[103],he([0,1,3,132,44]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,_=De(_),e.Extensions={JSONContribution:"base.contributions.json"};function L(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class k{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,R){this.schemasById[L(E)]=R,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(E){const R=this.schemasById[E];return R?(0,a.getCompressedContent)(R):void 0}hasSchemaContent(E){return!!this.schemasById[E]}}const T=new k;_.Registry.add(e.Extensions.JSONContribution,T)}),define(ue[47],he([0,1,17,3,12,11,21,103,44]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=p,e.keyFromOverrideIdentifiers=I,e.getDefaultValue=g,e.validateProperty=C,e.getScopes=S,e.getAllConfigurationProperties=c,e.parseScope=u,_=De(_),L=De(L);var E;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const m=D.Registry.as(T.Extensions.JSONContribution);class d{constructor(){this.registeredConfigurationDefaults=[],this.overrideIdentifiers=new Set,this._onDidSchemaChange=new a.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new a.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(11612,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.doRegisterConfigurations(n,t,s),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.doDeregisterConfigurations(n,t),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.doDeregisterConfigurations(t,s),this.doRegisterConfigurations(n,!1,s),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.doRegisterDefaultConfigurations(n,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,t){this.registeredConfigurationDefaults.push(...n);const s=[];for(const{overrides:r,source:o}of n)for(const h in r){t.add(h);const y=this.configurationDefaultsOverrides.get(h)??this.configurationDefaultsOverrides.set(h,{configurationDefaultOverrides:[]}).get(h),A=r[h];if(y.configurationDefaultOverrides.push({value:A,source:o}),e.OVERRIDE_PROPERTY_REGEX.test(h)){const b=this.mergeDefaultConfigurationsForOverrideIdentifier(h,A,o,y.configurationDefaultOverrideValue);if(!b)continue;y.configurationDefaultOverrideValue=b,this.updateDefaultOverrideProperty(h,b,o),s.push(...p(h))}else{const b=this.mergeDefaultConfigurationsForConfigurationProperty(h,A,o,y.configurationDefaultOverrideValue);if(!b)continue;y.configurationDefaultOverrideValue=b;const w=this.configurationProperties[h];w&&(this.updatePropertyDefaultValue(h,w),this.updateSchema(h,w))}}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(n){const t=new Set;this.doDeregisterDefaultConfigurations(n,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,t){for(const s of n){const r=this.registeredConfigurationDefaults.indexOf(s);r!==-1&&this.registeredConfigurationDefaults.splice(r,1)}for(const{overrides:s,source:r}of n)for(const o in s){const h=this.configurationDefaultsOverrides.get(o);if(!h)continue;const y=h.configurationDefaultOverrides.findIndex(A=>r?A.source?.id===r.id:A.value===s[o]);if(y!==-1){if(h.configurationDefaultOverrides.splice(y,1),h.configurationDefaultOverrides.length===0&&this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){let A;for(const b of h.configurationDefaultOverrides)A=this.mergeDefaultConfigurationsForOverrideIdentifier(o,b.value,b.source,A);A&&!_.isEmptyObject(A.value)?(h.configurationDefaultOverrideValue=A,this.updateDefaultOverrideProperty(o,A,r)):(this.configurationDefaultsOverrides.delete(o),delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o])}else{let A;for(const w of h.configurationDefaultOverrides)A=this.mergeDefaultConfigurationsForConfigurationProperty(o,w.value,w.source,A);h.configurationDefaultOverrideValue=A;const b=this.configurationProperties[o];b&&(this.updatePropertyDefaultValue(o,b),this.updateSchema(o,b))}t.add(o)}}this.updateOverridePropertyPatternKey()}updateDefaultOverrideProperty(n,t,s){const r={type:"object",default:t.value,description:L.localize(11613,null,(0,k.getLanguageTagSettingPlainKey)(n)),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.configurationProperties[n]=r,this.defaultLanguageConfigurationOverridesNode.properties[n]=r}mergeDefaultConfigurationsForOverrideIdentifier(n,t,s,r){const o=r?.value||{},h=r?.source??new Map;if(!(h instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const y of Object.keys(t)){const A=t[y];if(_.isObject(A)&&(_.isUndefined(o[y])||_.isObject(o[y]))){if(o[y]={...o[y]??{},...A},s)for(const w in A)h.set(`${y}.${w}`,s)}else o[y]=A,s?h.set(y,s):h.delete(y)}return{value:o,source:h}}mergeDefaultConfigurationsForConfigurationProperty(n,t,s,r){const o=this.configurationProperties[n],h=r?.value??o?.defaultDefaultValue;let y=s;if(_.isObject(t)&&(o!==void 0&&o.type==="object"||o===void 0&&(_.isUndefined(h)||_.isObject(h)))){if(y=r?.source??new Map,!(y instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const b in t)s&&y.set(`${n}.${b}`,s);t={..._.isObject(h)?h:{},...t}}return{value:t,source:y}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,s),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const t of n)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,t,s){n.forEach(r=>{this.validateAndRegisterProperties(r,t,r.extensionInfo,r.restrictedProperties,void 0,s),this.configurationContributors.push(r),this.registerJSONConfiguration(r)})}doDeregisterConfigurations(n,t){const s=r=>{if(r.properties)for(const o in r.properties){t.add(o);const h=this.configurationProperties[o];h?.policy?.name&&this.policyConfigurations.delete(h.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>s(o))};for(const r of n){s(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}}validateAndRegisterProperties(n,t=!0,s,r,o=R.WINDOW,h){o=_.isUndefinedOrNull(n.scope)?o:n.scope;const y=n.properties;if(y)for(const b in y){const w=y[b];if(t&&C(b,w)){delete y[b];continue}if(w.source=s,w.defaultDefaultValue=y[b].default,this.updatePropertyDefaultValue(b,w),e.OVERRIDE_PROPERTY_REGEX.test(b)?w.scope=void 0:(w.scope=_.isUndefinedOrNull(w.scope)?o:w.scope,w.restricted=_.isUndefinedOrNull(w.restricted)?!!r?.includes(b):w.restricted),y[b].hasOwnProperty("included")&&!y[b].included){this.excludedConfigurationProperties[b]=y[b],delete y[b];continue}else this.configurationProperties[b]=y[b],y[b].policy?.name&&this.policyConfigurations.set(y[b].policy.name,b);!y[b].deprecationMessage&&y[b].markdownDeprecationMessage&&(y[b].deprecationMessage=y[b].markdownDeprecationMessage),h.add(b)}const A=n.allOf;if(A)for(const b of A)this.validateAndRegisterProperties(b,t,s,r,o,h)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getRegisteredDefaultConfigurations(){return[...this.registeredConfigurationDefaults]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.configurationDefaultsOverrides)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}registerJSONConfiguration(n){const t=s=>{const r=s.properties;if(r)for(const h in r)this.updateSchema(h,r[h]);s.allOf?.forEach(t)};t(n)}updateSchema(n,t){switch(e.allSettings.properties[n]=t,t.scope){case R.APPLICATION:e.applicationSettings.properties[n]=t;break;case R.MACHINE:e.machineSettings.properties[n]=t;break;case R.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[n]=t;break;case R.WINDOW:e.windowSettings.properties[n]=t;break;case R.RESOURCE:e.resourceSettings.properties[n]=t;break;case R.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[n]=t,this.resourceLanguageSettingsSchema.properties[n]=t;break}}removeFromSchema(n,t){switch(delete e.allSettings.properties[n],t.scope){case R.APPLICATION:delete e.applicationSettings.properties[n];break;case R.MACHINE:delete e.machineSettings.properties[n];break;case R.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[n];break;case R.WINDOW:delete e.windowSettings.properties[n];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const t=`[${n}]`,s={type:"object",description:L.localize(11614,null),errorMessage:L.localize(11615,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,s),e.allSettings.properties[t]=s,e.applicationSettings.properties[t]=s,e.machineSettings.properties[t]=s,e.machineOverridableSettings.properties[t]=s,e.windowSettings.properties[t]=s,e.resourceSettings.properties[t]=s}}registerOverridePropertyPatternKey(){const n={type:"object",description:L.localize(11616,null),errorMessage:L.localize(11617,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,t){const s=this.configurationDefaultsOverrides.get(n)?.configurationDefaultOverrideValue;let r,o;s&&(!t.disallowConfigurationDefault||!s.source)&&(r=s.value,o=s.source),_.isUndefined(r)&&(r=t.defaultDefaultValue,o=void 0),_.isUndefined(r)&&(r=g(t.type)),t.default=r,t.defaultValueSource=o}}const f="\\[([^\\]]+)\\]",l=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(i){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(i)){let t=l.exec(i);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=l.exec(i)}}return(0,P.distinct)(n)}function I(i){return i.reduce((n,t)=>`${n}[${t}]`,"")}function g(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const v=new d;D.Registry.add(e.Extensions.Configuration,v);function C(i,n){return i.trim()?e.OVERRIDE_PROPERTY_REGEX.test(i)?L.localize(11619,null,i):v.getConfigurationProperties()[i]!==void 0?L.localize(11620,null,i):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(11621,null,i,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(11618,null)}function S(){const i=[],n=v.getConfigurationProperties();for(const t of Object.keys(n))i.push([t,n[t].scope]);return i.push(["launch",R.RESOURCE]),i.push(["task",R.RESOURCE]),i}function c(i){const n={};for(const t of i){const s=t.properties;if(_.isObject(s))for(const r in s)n[r]=s[r];t.allOf&&Object.assign(n,c(t.allOf))}return n}function u(i){switch(i){case"application":return R.APPLICATION;case"machine":return R.MACHINE;case"resource":return R.RESOURCE;case"machine-overridable":return R.MACHINE_OVERRIDABLE;case"language-overridable":return R.LANGUAGE_OVERRIDABLE;default:return R.WINDOW}}}),define(ue[77],he([0,1,17,3,36,2,31,29,12,9,21,47,7,44]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=S,P=De(P),_=De(_),T=De(T),D=De(D);function l(n){return Object.isFrozen(n)?n:T.deepFreeze(n)}class p{static createEmptyModel(t){return new p({},[],[],void 0,t)}constructor(t,s,r,o,h){this._contents=t,this._keys=s,this._overrides=r,this.raw=o,this.logService=h,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof p)return s;const r=new I("",this.logService);return r.parseRaw(s),r.configurationModel});this._rawConfiguration=t.reduce((s,r)=>r===s?r:s.merge(r),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,R.getConfigurationValue)(this.contents,t):this.contents}inspect(t,s){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return s?l(r.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return l(s?r.rawConfiguration.override(s).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:h,identifiers:y,keys:A}of r.rawConfiguration.overrides){const b=new p(h,A,[],void 0,r.logService).getValue(t);b!==void 0&&o.push({identifiers:y,value:b})}return o.length?l(o):void 0}}}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,R.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const r of this.overrides)r.identifiers.includes(t)&&s.push(...r.keys);return P.distinct(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return P.distinct(t)}override(t){let s=this.overrideConfigurations.get(t);return s||(s=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,s)),s}merge(...t){const s=T.deepClone(this.contents),r=T.deepClone(this.overrides),o=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const y of t)if(h.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.mergeContents(s,y.contents);for(const A of y.overrides){const[b]=r.filter(w=>P.equals(w.identifiers,A.identifiers));b?(this.mergeContents(b.contents,A.contents),b.keys.push(...A.keys),b.keys=P.distinct(b.keys)):r.push(T.deepClone(A))}for(const A of y.keys)o.indexOf(A)===-1&&o.push(A)}return new p(s,o,r,h.every(y=>y instanceof p)?void 0:h,this.logService)}createOverrideConfigurationModel(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const r={};for(const o of P.distinct([...Object.keys(this.contents),...Object.keys(s)])){let h=this.contents[o];const y=s[o];y&&(typeof h=="object"&&typeof y=="object"?(h=T.deepClone(h),this.mergeContents(h,y)):h=y),r[o]=h}return new p(r,this.keys,this.overrides,void 0,this.logService)}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&D.isObject(t[r])&&D.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=T.deepClone(s[r])}}getContentsForOverrideIdentifer(t){let s=null,r=null;const o=h=>{h&&(r?this.mergeContents(r,h):r=T.deepClone(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===t?s=h.contents:h.identifiers.includes(t)&&o(h.contents);return o(s),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.updateValue(t,s,!0)}setValue(t,s){this.updateValue(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,R.removeFromValueTree)(this.contents,t),m.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>P.equals(r.identifiers,(0,m.overrideIdentifiersFromKey)(t))),1))}updateValue(t,s,r){if((0,R.addToValueTree)(this.contents,t,s,o=>this.logService.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),m.OVERRIDE_PROPERTY_REGEX.test(t)){const o=(0,m.overrideIdentifiersFromKey)(t),h={identifiers:o,keys:Object.keys(this.contents[t]),contents:(0,R.toValuesTree)(this.contents[t],A=>this.logService.error(A))},y=this.overrides.findIndex(A=>P.equals(A.identifiers,o));y!==-1?this.overrides[y]=h:this.overrides.push(h)}}}e.ConfigurationModel=p;class I{constructor(t,s){this._name=t,this.logService=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||p.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!D.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:o,overrides:h,restricted:y,hasExcludedProperties:A}=this.doParseRaw(t,s);this._configurationModel=new p(r,o,h,A?[t]:void 0,this.logService),this._restrictedConfigurations=y||[]}doParseContent(t){let s={},r=null,o=[];const h=[],y=[];function A(w){Array.isArray(o)?o.push(w):r!==null&&(o[r]=w)}const b={onObjectBegin:()=>{const w={};A(w),h.push(o),o=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const w=[];A(w),h.push(o),o=w,r=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:A,onError:(w,O,N)=>{y.push({error:w,offset:O,length:N})}};if(t)try{_.visit(t,b),s=o[0]||{}}catch(w){this.logService.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return s}doParseRaw(t,s){const r=f.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,r,!0,s);t=o.raw;const h=(0,R.toValuesTree)(t,b=>this.logService.error(`Conflict in settings file ${this._name}: ${b}`)),y=Object.keys(t),A=this.toOverrides(t,b=>this.logService.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:h,keys:y,overrides:A,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(t,s,r,o){let h=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:h};const y={},A=[];for(const b in t)if(m.OVERRIDE_PROPERTY_REGEX.test(b)&&r){const w=this.filter(t[b],s,!1,o);y[b]=w.raw,h=h||w.hasExcludedProperties,A.push(...w.restricted)}else{const w=s[b],O=w?typeof w.scope<"u"?w.scope:m.ConfigurationScope.WINDOW:void 0;w?.restricted&&A.push(b),!o.exclude?.includes(b)&&(o.include?.includes(b)||(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&!(o.skipRestricted&&w?.restricted))?y[b]=t[b]:h=!0}return{raw:y,restricted:A,hasExcludedProperties:h}}toOverrides(t,s){const r=[];for(const o of Object.keys(t))if(m.OVERRIDE_PROPERTY_REGEX.test(o)){const h={};for(const y in t[o])h[y]=t[o][y];r.push({identifiers:(0,m.overrideIdentifiersFromKey)(o),keys:Object.keys(h),contents:(0,R.toValuesTree)(h,s)})}return r}}e.ConfigurationModelParser=I;class g extends L.Disposable{constructor(t,s,r,o,h){super(),this.userSettingsResource=t,this.parseOptions=s,this.fileService=o,this.logService=h,this._onDidChange=this._register(new a.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new I(this.userSettingsResource.toString(),h),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(a.Event.any(a.Event.filter(this.fileService.onDidFilesChange,y=>y.contains(this.userSettingsResource)),a.Event.filter(this.fileService.onDidRunOperation,y=>(y.isOperation(d.FileOperation.CREATE)||y.isOperation(d.FileOperation.COPY)||y.isOperation(d.FileOperation.DELETE)||y.isOperation(d.FileOperation.WRITE))&&r.isEqual(y.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return p.createEmptyModel(this.logService)}}reparse(t){return t&&(this.parseOptions=t),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class v{constructor(t,s,r,o,h,y,A,b,w,O,N,F,M){this.key=t,this.overrides=s,this._value=r,this.overrideIdentifiers=o,this.defaultConfiguration=h,this.policyConfiguration=y,this.applicationConfiguration=A,this.userConfiguration=b,this.localUserConfiguration=w,this.remoteUserConfiguration=O,this.workspaceConfiguration=N,this.folderConfigurationModel=F,this.memoryConfigurationModel=M}get value(){return l(this._value)}toInspectValue(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class C{constructor(t,s,r,o,h,y,A,b,w,O){this._defaultConfiguration=t,this._policyConfiguration=s,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=h,this._workspaceConfiguration=y,this._folderConfigurations=A,this._memoryConfiguration=b,this._memoryConfigurationByResource=w,this.logService=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidatedConfigurationModel(t,s,r).getValue(t)}updateValue(t,s,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=p.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,s===void 0?o.removeValue(t):o.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const o=this.getConsolidatedConfigurationModel(t,s,r),h=this.getFolderConfigurationModelForResource(s.resource,r),y=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,A=new Set;for(const b of o.overrides)for(const w of b.identifiers)o.getOverrideValue(t,w)!==void 0&&A.add(w);return new v(t,s,o.getValue(t),A.size?[...A]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,h||void 0,y)}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=[];if(!s){const{added:o,updated:h,removed:y}=u(this._defaultConfiguration,t);s=[...o,...h,...y]}for(const o of s)for(const h of(0,m.overrideIdentifiersFromKey)(o)){const y=this._defaultConfiguration.getKeysForOverrideIdentifier(h),A=t.getKeysForOverrideIdentifier(h),b=[...A.filter(w=>y.indexOf(w)===-1),...y.filter(w=>A.indexOf(w)===-1),...y.filter(w=>!T.equals(this._defaultConfiguration.override(h).getValue(w),t.override(h).getValue(w)))];r.push([h,b])}return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:r,removed:o}=u(this._policyConfiguration,t),h=[...s,...r,...o];return h.length&&this.updatePolicyConfiguration(t),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:r,removed:o,overrides:h}=u(this.applicationConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateApplicationConfiguration(t),{keys:y,overrides:h}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:h}=u(this.localUserConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:h}=u(this.remoteUserConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:o,overrides:h}=u(this.workspaceConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:h}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:o,updated:h,removed:y,overrides:A}=u(r,s),b=[...o,...h,...y];return(b.length||!r)&&this.updateFolderConfiguration(t,s),{keys:b,overrides:A}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:h,overrides:y}=u(s,void 0);return{keys:[...r,...o,...h],overrides:y}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,s,r){let o=this.getConsolidatedConfigurationModelForResource(s,r);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const o=s.getFolder(t);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const h=this._memoryConfigurationByResource.get(t);h&&(r=r.merge(h))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(s=r.merge(o),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:o,keys:h}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:o,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this._workspaceConfiguration.keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(r=>t.add(r))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o))),[...s.values()]}static parse(t,s){const r=this.parseConfigurationModel(t.defaults,s),o=this.parseConfigurationModel(t.policy,s),h=this.parseConfigurationModel(t.application,s),y=this.parseConfigurationModel(t.user,s),A=this.parseConfigurationModel(t.workspace,s),b=t.folders.reduce((w,O)=>(w.set(E.URI.revive(O[0]),this.parseConfigurationModel(O[1],s)),w),new k.ResourceMap);return new C(r,o,h,y,p.createEmptyModel(s),A,b,p.createEmptyModel(s),new k.ResourceMap,s)}static parseConfigurationModel(t,s){return new p(t.contents,t.keys,t.overrides,void 0,s)}}e.Configuration=C;function S(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const o of n)o.keys.forEach(h=>t.add(h)),o.overrides.forEach(([h,y])=>{const A=(0,k.getOrSet)(s,h,new Set);y.forEach(b=>A.add(b))});const r=[];return s.forEach((o,h)=>r.push([h,[...o.values()]])),{keys:[...t.values()],overrides:r}}class c{constructor(t,s,r,o,h){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=o,this.logService=h,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const y of t.keys)this.affectedKeys.add(y);for(const[,y]of t.overrides)for(const A of y)this.affectedKeys.add(A);this._affectsConfigStr=this._marker;for(const y of this.affectedKeys)this._affectsConfigStr+=y+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(t,s){const r=this._marker+t,o=this._affectsConfigStr.indexOf(r);if(o<0)return!1;const h=o+r.length;if(h>=this._affectsConfigStr.length)return!1;const y=this._affectsConfigStr.charCodeAt(h);if(y!==this._markerCode1&&y!==this._markerCode2)return!1;if(s){const A=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,b=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!T.equals(A,b)}return!0}}e.ConfigurationChangeEvent=c;function u(n,t){const{added:s,removed:r,updated:o}=i(t?.rawConfiguration,n?.rawConfiguration),h=[],y=n?.getAllOverrideIdentifiers()||[],A=t?.getAllOverrideIdentifiers()||[];if(t){const b=A.filter(w=>!y.includes(w));for(const w of b)h.push([w,t.getKeysForOverrideIdentifier(w)])}if(n){const b=y.filter(w=>!A.includes(w));for(const w of b)h.push([w,n.getKeysForOverrideIdentifier(w)])}if(t&&n){for(const b of y)if(A.includes(b)){const w=i({contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)},{contents:t.getOverrideValue(void 0,b)||{},keys:t.getKeysForOverrideIdentifier(b)});h.push([b,[...w.added,...w.removed,...w.updated]])}}return{added:s,removed:r,updated:o,overrides:h}}function i(n,t){const s=n?t?n.keys.filter(h=>t.keys.indexOf(h)===-1):[...n.keys]:[],r=t?n?t.keys.filter(h=>n.keys.indexOf(h)===-1):[...t.keys]:[],o=[];if(n&&t){for(const h of t.keys)if(n.keys.indexOf(h)!==-1){const y=(0,R.getConfigurationValue)(t.contents,h),A=(0,R.getConfigurationValue)(n.contents,h);T.equals(y,A)||o.push(h)}}return{added:s,removed:r,updated:o}}}),define(ue[183],he([0,1,17,3,2,29,12,77,47,10,58,44]),function(ae,e,P,a,_,L,k,T,D,E,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends _.Disposable{get configurationModel(){return this._configurationModel}constructor(I){super(),this.logService=I,this._onDidChangeConfiguration=this._register(new a.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=T.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(m.Registry.as(D.Extensions.Configuration).onDidUpdateConfiguration(({properties:I,defaultsOverrides:g})=>this.onDidUpdateConfiguration(Array.from(I),g))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(I,g){this.updateConfigurationModel(I,m.Registry.as(D.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:I})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=T.ConfigurationModel.createEmptyModel(this.logService);const I=m.Registry.as(D.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(I),I)}updateConfigurationModel(I,g){const v=this.getConfigurationDefaultOverrides();for(const C of I){const S=v[C],c=g[C];S!==void 0?this._configurationModel.setValue(C,S):c?this._configurationModel.setValue(C,c.default):this._configurationModel.removeValue(C)}}}e.DefaultConfiguration=d;class f{constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=T.ConfigurationModel.createEmptyModel(new E.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let l=class extends _.Disposable{get configurationModel(){return this._configurationModel}constructor(I,g,v){super(),this.defaultConfiguration=I,this.policyService=g,this.logService=v,this._onDidChangeConfiguration=this._register(new a.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=T.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(I=>this.onDidChangePolicies(I))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:I})=>this.update(await this.updatePolicyDefinitions(I),!0))),this._configurationModel}async updatePolicyDefinitions(I){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",I);const g={},v=[],C=m.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(const S of I){const c=C[S];if(!c){v.push(S);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.logService.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}v.push(S),g[c.policy.name]={type:c.type}}}return(0,k.isEmptyObject)(g)||await this.policyService.updatePolicyDefinitions(g),v}onDidChangePolicies(I){this.logService.trace("PolicyConfiguration#onDidChangePolicies",I);const g=m.Registry.as(D.Extensions.Configuration).getPolicyConfigurations(),v=(0,P.coalesce)(I.map(C=>g.get(C)));this.update(v,!0)}update(I,g){this.logService.trace("PolicyConfiguration#update",I);const v=m.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),C=[],S=this._configurationModel.isEmpty();for(const c of I){const u=v[c]?.policy?.name;if(u){const i=this.policyService.getPolicyValue(u);(S?i!==void 0:!(0,L.equals)(this._configurationModel.getValue(c),i))&&C.push([c,i])}else this._configurationModel.getValue(c)!==void 0&&C.push([c,void 0])}if(C.length){this.logService.trace("PolicyConfiguration#changed",C);const c=this._configurationModel;this._configurationModel=T.ConfigurationModel.createEmptyModel(this.logService);for(const u of c.keys)this._configurationModel.setValue(u,c.getValue(u));for(const[u,i]of C)i===void 0?this._configurationModel.removeValue(u):this._configurationModel.setValue(u,i);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=l,e.PolicyConfiguration=l=we([Q(1,R.IPolicyService),Q(2,E.ILogService)],l)}),define(ue[184],he([0,1,17,6,14,3,36,64,2,31,29,5,20,21,77,47,183,7,58]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(u,i,n,t){super(),this.settingsResource=u,this.logService=t,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration(t)),this.policyConfiguration=n instanceof v.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,n,t)),this.userConfiguration=this._register(new l.UserSettings(this.settingsResource,{},d.extUriBiasedIgnorePathCase,i,t)),this.configuration=new l.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,l.ConfigurationModel.createEmptyModel(t),l.ConfigurationModel.createEmptyModel(t),l.ConfigurationModel.createEmptyModel(t),l.ConfigurationModel.createEmptyModel(t),new E.ResourceMap,l.ConfigurationModel.createEmptyModel(t),new E.ResourceMap,t),this.configurationEditing=new S(u,i,this),this.reloadConfigurationScheduler=this._register(new a.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:r})=>this.onDidDefaultConfigurationChange(s,r))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[u,i,n]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new l.Configuration(u,i,l.ConfigurationModel.createEmptyModel(this.logService),n,l.ConfigurationModel.createEmptyModel(this.logService),l.ConfigurationModel.createEmptyModel(this.logService),new E.ResourceMap,l.ConfigurationModel.createEmptyModel(this.logService),new E.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(u,i){const n=typeof u=="string"?u:void 0,t=(0,f.isConfigurationOverrides)(u)?u:(0,f.isConfigurationOverrides)(i)?i:{};return this.configuration.getValue(n,t,void 0)}async updateValue(u,i,n,t,s){const r=(0,f.isConfigurationUpdateOverrides)(n)?n:(0,f.isConfigurationOverrides)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,o=r?t:n;if(o!==void 0&&o!==f.ConfigurationTarget.USER_LOCAL&&o!==f.ConfigurationTarget.USER)throw new Error(`Unable to write ${u} to target ${o}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,P.distinct)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const h=this.inspect(u,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(h.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,R.equals)(i,h.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const A=r.overrideIdentifiers.sort(),b=this.configuration.localUserConfiguration.overrides.find(w=>(0,P.equals)([...w.identifiers].sort(),A));b&&(r.overrideIdentifiers=b.identifiers)}const y=r?.overrideIdentifiers?.length?[(0,p.keyFromOverrideIdentifiers)(r.overrideIdentifiers),u]:[u];await this.configurationEditing.write(y,i),await this.reloadConfiguration()}inspect(u,i={}){return this.configuration.inspect(u,i,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const u=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(u)}onDidChangeUserConfiguration(u){const i=this.configuration.toData(),n=this.configuration.compareAndUpdateLocalUserConfiguration(u);this.trigger(n,i,f.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(u,i){const n=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(u,i);this.trigger(t,n,f.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(u){const i=this.configuration.toData(),n=this.configuration.compareAndUpdatePolicyConfiguration(u);this.trigger(n,i,f.ConfigurationTarget.DEFAULT)}trigger(u,i,n){const t=new l.ConfigurationChangeEvent(u,{data:i},this.configuration,void 0,this.logService);t.source=n,this._onDidChangeConfiguration.fire(t)}}e.ConfigurationService=C;class S{constructor(u,i,n){this.settingsResource=u,this.fileService=i,this.configurationService=n,this.queue=new a.Queue}write(u,i){return this.queue.queue(()=>this.doWriteConfiguration(u,i))}async doWriteConfiguration(u,i){let n;try{n=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(r){if(r.fileOperationResult===g.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw r}const t=[];if((0,k.parse)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.getEdits(n,u,i);n=(0,T.applyEdits)(n,s),await this.fileService.writeFile(this.settingsResource,_.VSBuffer.fromString(n))}getEdits(u,i,n){const{tabSize:t,insertSpaces:s,eol:r}=this.formattingOptions;if(!i.length){const o=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,T.setProperty)(u,i,n,{tabSize:t,insertSpaces:s,eol:r})}get formattingOptions(){if(!this._formattingOptions){let u=m.OS===m.OperatingSystem.Linux||m.OS===m.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(u=i),this._formattingOptions={eol:u,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ue[185],he([0,1,14,3,2,69]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=T;const k=(E,R,m)=>{const d=new Uint8Array(16);for(let p=0;p<16;p++)d[p]=Math.round(Math.random()*256);const f=(0,P.encodeBase64)(P.VSBuffer.wrap(d));return[`GET ws://localhost${E}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=k,e.socketRawEndHeaderSequence=P.VSBuffer.fromString(`\r
\r
`);async function T(E,R,m,d,f){E.write(P.VSBuffer.fromString((0,e.makeRawSocketHeaders)(R,m,d)));const l=new _.DisposableStore;try{return await new Promise((p,I)=>{let g;l.add(E.onData(v=>{g?g=P.VSBuffer.concat([g,v],g.byteLength+v.byteLength):g=v;const C=g.indexOf(e.socketRawEndHeaderSequence);if(C===-1)return;p(E),E.pauseData();const S=g.slice(C+e.socketRawEndHeaderSequence.byteLength);S.byteLength&&f.onData.fire(S)})),l.add(E.onClose(v=>I(v??new Error("socket closed")))),l.add(E.onEnd(()=>I(new Error("socket ended"))))})}catch(p){throw E.dispose(),p}finally{l.dispose()}}class D extends _.Disposable{constructor(R,m){super(),this.debugLabel=R,this.pausableDataEmitter=this._register(new a.PauseableEmitter),this.onData=(...d)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...d)),this.didDisposeEmitter=this._register(new a.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(m.onData),this._register(m.onData.event(d=>this.pausableDataEmitter.fire(d))),this.onClose=this._register(m.onClose).event,this.onEnd=this._register(m.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(R,m){L.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,R,m)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=D}),define(ue[104],he([0,1,8,4]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=E,e.IRemoteAuthorityResolverService=(0,a.createDecorator)("remoteAuthorityResolverService");var _;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(_||(e.RemoteConnectionType=_={}));class L{constructor(m){this.id=m,this.type=_.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=L;class k{constructor(m,d){this.host=m,this.port=d,this.type=_.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=k;var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class D extends P.ErrorNoTelemetry{static isNotAvailable(m){return m instanceof D&&m._code===T.NotAvailable}static isTemporarilyNotAvailable(m){return m instanceof D&&m._code===T.TemporarilyNotAvailable}static isNoResolverFound(m){return m instanceof D&&m._code===T.NoResolverFound}static isInvalidAuthority(m){return m instanceof D&&m._code===T.InvalidAuthority}static isHandled(m){return m instanceof D&&m.isHandled}constructor(m,d=T.Unknown,f){super(m),this._message=m,this._code=d,this._detail=f,this.isHandled=d===T.NotAvailable&&f===!0,Object.setPrototypeOf(this,D.prototype)}}e.RemoteAuthorityResolverError=D;function E(R){const m=R.indexOf("+");return m===-1?R:R.substring(0,m)}}),define(ue[186],he([0,1,6,14,25,8,3,2,22,100,54,32,69,104]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=h,e.connectRemoteAgentExtensionHost=y,e.connectRemoteAgentTunnel=b,E=De(E);const l=30*1e3;var p;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function I(K){switch(K){case p.Management:return"Management";case p.ExtensionHost:return"ExtensionHost";case p.Tunnel:return"Tunnel"}}function g(K){const W=new _.CancellationTokenSource;return setTimeout(()=>W.cancel(),K),W.token}function v(K,W){if(K.isCancellationRequested||W.isCancellationRequested)return _.CancellationToken.Cancelled;const U=new _.CancellationTokenSource;return K.onCancellationRequested(()=>U.cancel()),W.onCancellationRequested(()=>U.cancel()),U.token}class C{get didTimeout(){return this._state==="timedout"}constructor(W){this._state="pending",this._disposables=new T.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,P.promiseWithResolvers)(),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function S(K,W){const U=new C(W);return U.registerDisposable(K.onControlMessage(Y=>{const oe=JSON.parse(Y.toString()),x=q(oe);x?U.reject(x):U.resolve(oe)})),U.promise}function c(K,W,U,Y,oe,x,B,j){const G=new C(j),ie=R.StopWatch.create(!1);return K.info(`Creating a socket (${B})...`),E.mark(`code/willCreateSocket/${x}`),W.connect(U,Y,oe,B).then(ce=>{G.didTimeout?(E.mark(`code/didCreateSocketError/${x}`),K.info(`Creating a socket (${B}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(E.mark(`code/didCreateSocketOK/${x}`),K.info(`Creating a socket (${B}) was successful after ${ie.elapsed()} ms.`),G.resolve(ce))},ce=>{E.mark(`code/didCreateSocketError/${x}`),K.info(`Creating a socket (${B}) returned an error after ${ie.elapsed()} ms.`),K.error(ce),G.reject(ce)}),G.promise}function u(K,W){const U=new C(W);return K.then(Y=>{U.didTimeout||U.resolve(Y)},Y=>{U.didTimeout||U.reject(Y)}),U.promise}async function i(K,W,U,Y){const oe=ee(K,W);K.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let x;try{x=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,D.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,I(W),`renderer-${I(W)}-${K.reconnectionToken}`,Y)}catch(ce){throw K.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ce),ce}K.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let B,j;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(x,null),B=K.reconnectionProtocol,j=!1):(B=new d.PersistentProtocol({socket:x}),j=!0),K.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const G=await u(K.signService.createNewMessage((0,m.generateUuid)()),Y),ie={type:"auth",auth:K.connectionToken||"00000000000000000000",data:G.data};B.sendControl(a.VSBuffer.fromString(JSON.stringify(ie)));try{const ce=await S(B,v(Y,g(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(K.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await u(K.signService.validate(G,ce.signedData),Y)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const Se=await u(K.signService.sign(ce.data),Y),Ie={type:"connectionType",commit:K.commit,signedData:Se,desiredConnectionType:W};return U&&(Ie.args=U),K.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(a.VSBuffer.fromString(JSON.stringify(Ie))),{protocol:B,ownsProtocol:j}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(K.logService.error(`${oe} the handshake timed out. Error:`),K.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${oe} received error control message when negotiating connection. Error:`),K.logService.error(ce)),j&&$(B),ce}}async function n(K,W,U,Y){const oe=Date.now(),x=ee(K,W),{protocol:B,ownsProtocol:j}=await i(K,W,U,Y),G=new C(Y);return G.registerDisposable(B.onControlMessage(ie=>{const ce=JSON.parse(ie.toString()),ge=q(ce);ge?(K.logService.error(`${x} received error control message when negotiating connection. Error:`),K.logService.error(ge),j&&$(B),G.reject(ge)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${X(oe)}!`),G.resolve({protocol:B,firstMessage:ce}))})),G.promise}async function t(K,W){const{protocol:U}=await n(K,p.Management,void 0,W);return{protocol:U}}async function s(K,W,U){const{protocol:Y,firstMessage:oe}=await n(K,p.ExtensionHost,W,U),x=oe&&oe.debugPort;return{protocol:Y,debugPort:x}}async function r(K,W,U){const Y=Date.now(),oe=ee(K,p.Tunnel),{protocol:x}=await i(K,p.Tunnel,W,U);return K.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${X(Y)}!`),x}async function o(K,W,U){const{connectTo:Y,connectionToken:oe}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:Y,connectionToken:oe,reconnectionToken:W,reconnectionProtocol:U,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function h(K,W,U){return A(K,async Y=>{const{protocol:oe}=await t(Y,_.CancellationToken.None);return new V(K,W,U,Y.reconnectionToken,oe)})}async function y(K,W){return A(K,async U=>{const{protocol:Y,debugPort:oe}=await s(U,W,_.CancellationToken.None);return new te(K,W,U.reconnectionToken,Y,oe)})}async function A(K,W){for(let Y=1;;Y++)try{const oe=(0,m.generateUuid)(),x=await o(K,oe,null);return await W(x)}catch(oe){if(Y<5)K.logService.error(`[remote-connection][attempt ${Y}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(oe);else throw K.logService.error(`[remote-connection][attempt ${Y}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(oe),J.triggerPermanentFailure(0,0,f.RemoteAuthorityResolverError.isHandled(oe)),oe}}async function b(K,W,U){const Y=await o(K,(0,m.generateUuid)(),null);return await r(Y,{host:W,port:U},_.CancellationToken.None)}function w(K){return(0,P.createCancelablePromise)(W=>new Promise((U,Y)=>{const oe=setTimeout(U,K*1e3);W.onCancellationRequested(()=>{clearTimeout(oe),U()})}))}var O;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class N{constructor(W,U){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.type=O.ConnectionLost}}e.ConnectionLostEvent=N;class F{constructor(W,U,Y,oe){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.durationSeconds=Y,this.cancellableTimer=oe,this.type=O.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class M{constructor(W,U,Y){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=Y,this.type=O.ReconnectionRunning}}e.ReconnectionRunningEvent=M;class H{constructor(W,U,Y){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=Y,this.type=O.ConnectionGain}}e.ConnectionGainEvent=H;class z{constructor(W,U,Y,oe){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=Y,this.handled=oe,this.type=O.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=z;class J extends T.Disposable{static triggerPermanentFailure(W,U,Y){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=U,this._permanentFailureHandled=Y,this._instances.forEach(oe=>oe._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(W=>W._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(W=>W._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||J._permanentFailure}constructor(W,U,Y,oe,x){super(),this._connectionType=W,this._options=U,this.reconnectionToken=Y,this.protocol=oe,this._reconnectionFailureIsFatal=x,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new H(this.reconnectionToken,0,0)),this._register(oe.onSocketClose(B=>{const j=le(this._connectionType,this.reconnectionToken,!0);B?B.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${j} received socket close event (hadError: ${B.hadError}).`),B.error&&this._options.logService.error(B.error)):(this._options.logService.info(`${j} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this._options.logService.error(B.event)):this._options.logService.info(`${j} received socket close event.`),this._beginReconnecting()})),this._register(oe.onSocketTimeout(B=>{const j=le(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} received socket timeout event (unacknowledgedMsgCount: ${B.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${B.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${B.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),J._instances.push(this),this._register((0,T.toDisposable)(()=>{const B=J._instances.indexOf(this);B>=0&&J._instances.splice(B,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(J._permanentFailureMillisSinceLastIncomingData,J._permanentFailureAttempt,J._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const W=le(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let Y=-1;do{Y++;const oe=Y<U.length?U[Y]:U[U.length-1];try{if(oe>0){const B=w(oe);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,B)),this._options.logService.info(`${W} waiting for ${oe} seconds before reconnecting...`);try{await B}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1)),this._options.logService.info(`${W} resolving connection...`);const x=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${x.connectTo}...`),await this._reconnect(x,g(l)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(Y>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(f.RemoteAuthorityResolverError.isTemporarilyNotAvailable(x)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((0,L.isCancellationError)(x)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if(x instanceof f.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,f.RemoteAuthorityResolverError.isHandled(x));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(W,U,Y){this._reconnectionFailureIsFatal?J.triggerPermanentFailure(W,U,Y):this._gotoPermanentFailure(W,U,Y)}_gotoPermanentFailure(W,U,Y){this._onDidStateChange.fire(new z(this.reconnectionToken,W,U,Y)),$(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=J;class V extends J{constructor(W,U,Y,oe,x){super(p.Management,W,oe,x,!0),this.client=this._register(new d.Client(x,{remoteAuthority:U,clientId:Y},W.ipcLogger))}async _reconnect(W,U){await t(W,U)}}e.ManagementPersistentConnection=V;class te extends J{constructor(W,U,Y,oe,x){super(p.ExtensionHost,W,Y,oe,!1),this._startArguments=U,this.debugPort=x}async _reconnect(W,U){await s(W,this._startArguments,U)}}e.ExtensionHostPersistentConnection=te;function $(K){try{K.acceptDisconnect();const W=K.getSocket();K.dispose(),W.dispose()}catch(W){(0,L.onUnexpectedError)(W)}}function q(K){if(K&&K.type==="error"){const W=new Error(`Connection error: ${K.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Z(K,W){for(;K.length<W;)K+=" ";return K}function ne(K,W){return`[remote-connection][${Z(I(K),13)}][${W.substr(0,5)}\u2026]`}function le(K,W,U){return`${ne(K,W)}[${U?"reconnect":"initial"}]`}function ee(K,W){return`${le(W,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function X(K){return`${Date.now()-K} ms`}}),define(ue[105],he([0,1,22]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=a,e.getRemoteName=_,e.parseAuthorityWithPort=L,e.parseAuthorityWithOptionalPort=k;function a(D){return D.scheme===P.Schemas.vscodeRemote?D.authority:void 0}function _(D){if(!D)return;const E=D.indexOf("+");return E<0?D:D.substr(0,E)}function L(D){const{host:E,port:R}=T(D);if(typeof R>"u")throw new Error(`Invalid remote authority: ${D}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:R}}function k(D,E){let{host:R,port:m}=T(D);return typeof m>"u"&&(m=E),{host:R,port:m}}function T(D){const E=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const R=D.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const m=D.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:D,port:void 0}}}),define(ue[34],he([0,1,26,4,105]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=L,e.isApplicationScopedExtension=m,e.isLanguagePackExtension=d,e.isAuthenticationProviderExtension=f,e.isResolverExtension=l,e.parseApiProposals=p,e.parseEnabledApiProposalNames=I,P=De(P),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(k||(e.ExtensionType=k={}));var T;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.LINUX_PPC64LE="linux-ppc64le",g.LINUX_RISCV64="linux-riscv64",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class D{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,C){if(typeof v>"u"||v===null)return typeof C>"u"||C===null;if(typeof C>"u"||C===null)return!1;if(typeof v=="string"||typeof C=="string"){const S=typeof v=="string"?v:v.value,c=typeof C=="string"?C:C.value;return P.equalsIgnoreCase(S,c)}return v._lower===C._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=D;class E{get size(){return this._set.size}constructor(v){if(this._set=new Set,v)for(const C of v)this.add(C)}add(v){this._set.add(D.toKey(v))}delete(v){return this._set.delete(D.toKey(v))}has(v){return this._set.has(D.toKey(v))}}e.ExtensionIdentifierSet=E;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(v){this._map.delete(D.toKey(v))}get(v){return this._map.get(D.toKey(v))}has(v){return this._map.has(D.toKey(v))}set(v,C){this._map.set(D.toKey(v),C)}values(){return this._map.values()}forEach(v){this._map.forEach(v)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function m(g){return d(g)}function d(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}function f(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}function l(g,v){if(v){const C=`onResolveRemoteAuthority:${(0,_.getRemoteName)(v)}`;return!!g.activationEvents?.includes(C)}return!1}function p(g){return g.map(v=>{const[C,S]=v.split("@");return{proposalName:C,version:S?parseInt(S):void 0}})}function I(g){return g.map(v=>v.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,a.createDecorator)("IBuiltinExtensionsScannerService")}),define(ue[27],he([0,1,5,11,34,4]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=T,e.toTargetPlatform=D,e.getTargetPlatform=E,e.isNotWebExtensionInWebTargetPlatform=R,e.isTargetPlatformCompatible=m,e.isIExtensionIdentifier=d,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var k;(function(c){c.COMMAND="command",c.SETTINGS_SYNC="settingsSync"})(k||(e.ExtensionInstallSource=k={}));function T(c){switch(c){case _.TargetPlatform.WIN32_X64:return"Windows 64 bit";case _.TargetPlatform.WIN32_ARM64:return"Windows ARM";case _.TargetPlatform.LINUX_X64:return"Linux 64 bit";case _.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case _.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case _.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case _.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case _.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case _.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case _.TargetPlatform.DARWIN_X64:return"Mac";case _.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case _.TargetPlatform.WEB:return"Web";case _.TargetPlatform.UNIVERSAL:return _.TargetPlatform.UNIVERSAL;case _.TargetPlatform.UNKNOWN:return _.TargetPlatform.UNKNOWN;case _.TargetPlatform.UNDEFINED:return _.TargetPlatform.UNDEFINED}}function D(c){switch(c){case _.TargetPlatform.WIN32_X64:return _.TargetPlatform.WIN32_X64;case _.TargetPlatform.WIN32_ARM64:return _.TargetPlatform.WIN32_ARM64;case _.TargetPlatform.LINUX_X64:return _.TargetPlatform.LINUX_X64;case _.TargetPlatform.LINUX_ARM64:return _.TargetPlatform.LINUX_ARM64;case _.TargetPlatform.LINUX_ARMHF:return _.TargetPlatform.LINUX_ARMHF;case _.TargetPlatform.LINUX_PPC64LE:return _.TargetPlatform.LINUX_PPC64LE;case _.TargetPlatform.LINUX_RISCV64:return _.TargetPlatform.LINUX_RISCV64;case _.TargetPlatform.ALPINE_X64:return _.TargetPlatform.ALPINE_X64;case _.TargetPlatform.ALPINE_ARM64:return _.TargetPlatform.ALPINE_ARM64;case _.TargetPlatform.DARWIN_X64:return _.TargetPlatform.DARWIN_X64;case _.TargetPlatform.DARWIN_ARM64:return _.TargetPlatform.DARWIN_ARM64;case _.TargetPlatform.WEB:return _.TargetPlatform.WEB;case _.TargetPlatform.UNIVERSAL:return _.TargetPlatform.UNIVERSAL;default:return _.TargetPlatform.UNKNOWN}}function E(c,u){switch(c){case P.Platform.Windows:return u==="x64"?_.TargetPlatform.WIN32_X64:u==="arm64"?_.TargetPlatform.WIN32_ARM64:_.TargetPlatform.UNKNOWN;case P.Platform.Linux:return u==="x64"?_.TargetPlatform.LINUX_X64:u==="arm64"?_.TargetPlatform.LINUX_ARM64:u==="arm"?_.TargetPlatform.LINUX_ARMHF:u==="ppc64le"?_.TargetPlatform.LINUX_PPC64LE:u==="riscv64"?_.TargetPlatform.LINUX_RISCV64:_.TargetPlatform.UNKNOWN;case"alpine":return u==="x64"?_.TargetPlatform.ALPINE_X64:u==="arm64"?_.TargetPlatform.ALPINE_ARM64:_.TargetPlatform.UNKNOWN;case P.Platform.Mac:return u==="x64"?_.TargetPlatform.DARWIN_X64:u==="arm64"?_.TargetPlatform.DARWIN_ARM64:_.TargetPlatform.UNKNOWN;case P.Platform.Web:return _.TargetPlatform.WEB}}function R(c,u){return u===_.TargetPlatform.WEB&&!c.includes(_.TargetPlatform.WEB)}function m(c,u,i){return R(u,i)?!1:c===_.TargetPlatform.UNDEFINED||c===_.TargetPlatform.UNIVERSAL?!0:c===_.TargetPlatform.UNKNOWN?!1:c===i}function d(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var f;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var l;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var p;(function(c){c.Install="install",c.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var I;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(I||(e.InstallOperation=I={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var g;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed",c.DownloadFailedWriting="DownloadFailedWriting"})(g||(e.ExtensionGalleryErrorCode=g={}));class v extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.ExtensionGalleryError=v;var C;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleApi="IncompatibleApi",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.DownloadFailedWriting="DownloadFailedWriting",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.ScanningExtension="ScanningExtension",c.ReadUninstalled="ReadUninstalled",c.UnsetUninstalled="UnsetUninstalled",c.Delete="Delete",c.Rename="Rename",c.IntializeDefaultProfile="IntializeDefaultProfile",c.AddToProfile="AddToProfile",c.InstalledExtensionNotFound="InstalledExtensionNotFound",c.PostInstall="PostInstall",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(C||(e.ExtensionManagementErrorCode=C={}));class S extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,a.localize2)(11502,"Extensions"),e.PreferencesLocalizedLabel=(0,a.localize2)(11503,"Preferences")}),define(ue[187],he([0,1,3,2,29,9,94,27]),function(ae,e,P,a,_,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function D(I,g){return I?L.URI.revive(g?g.transformIncoming(I):I):void 0}function E(I,g){return g?g.transformOutgoingURI(I):I}function R(I,g){g=g||k.DefaultURITransformer;const v=I.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...I,manifest:void 0},g),manifest:v}}function m(I,g){return I?.profileLocation?(0,k.transformAndReviveIncomingURIs)(I,g??k.DefaultURITransformer):I}function d(I,g){return g?(0,_.cloneAndChange)(I,v=>v instanceof L.URI?g.transformOutgoingURI(v):void 0):I}class f{constructor(g,v){this.service=g,this.getUriTransformer=v,this.onInstallExtension=P.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=P.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=P.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=P.Event.buffer(g.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=P.Event.buffer(g.onDidUpdateExtensionMetadata,!0)}listen(g,v){const C=this.getUriTransformer(g);switch(v){case"onInstallExtension":return P.Event.map(this.onInstallExtension,S=>({...S,profileLocation:S.profileLocation?E(S.profileLocation,C):S.profileLocation}));case"onDidInstallExtensions":return P.Event.map(this.onDidInstallExtensions,S=>S.map(c=>({...c,local:c.local?d(c.local,C):c.local,profileLocation:c.profileLocation?E(c.profileLocation,C):c.profileLocation})));case"onUninstallExtension":return P.Event.map(this.onUninstallExtension,S=>({...S,profileLocation:S.profileLocation?E(S.profileLocation,C):S.profileLocation}));case"onDidUninstallExtension":return P.Event.map(this.onDidUninstallExtension,S=>({...S,profileLocation:S.profileLocation?E(S.profileLocation,C):S.profileLocation}));case"onDidUpdateExtensionMetadata":return P.Event.map(this.onDidUpdateExtensionMetadata,S=>({local:d(S.local,C),profileLocation:E(S.profileLocation,C)}))}throw new Error("Invalid listen")}async call(g,v,C){const S=this.getUriTransformer(g);switch(v){case"zip":{const c=R(C[0],S),u=await this.service.zip(c);return E(u,S)}case"install":return this.service.install(D(C[0],S),m(C[1],S));case"installFromLocation":return this.service.installFromLocation(D(C[0],S),D(C[1],S));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(C[0],D(C[1],S),D(C[2],S));case"getManifest":return this.service.getManifest(D(C[0],S));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(C[0]);case"installFromGallery":return this.service.installFromGallery(C[0],m(C[1],S));case"installGalleryExtensions":{const c=C[0];return this.service.installGalleryExtensions(c.map(({extension:u,options:i})=>({extension:u,options:m(i,S)??{}})))}case"uninstall":return this.service.uninstall(R(C[0],S),m(C[1],S));case"uninstallExtensions":{const c=C[0];return this.service.uninstallExtensions(c.map(({extension:u,options:i})=>({extension:R(u,S),options:m(i,S)})))}case"reinstallFromGallery":return this.service.reinstallFromGallery(R(C[0],S));case"getInstalled":return(await this.service.getInstalled(C[0],D(C[1],S),C[2])).map(u=>d(u,S));case"toggleAppliationScope":{const c=await this.service.toggleAppliationScope(R(C[0],S),D(C[1],S));return d(c,S)}case"copyExtensions":return this.service.copyExtensions(D(C[0],S),D(C[1],S));case"updateMetadata":{const c=await this.service.updateMetadata(R(C[0],S),C[1],D(C[2],S));return d(c,S)}case"resetPinnedStateForAllUserExtensions":return this.service.resetPinnedStateForAllUserExtensions(C[0]);case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(C[0],C[1],C[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class l extends a.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(g){super(),this.channel=g,this._onInstallExtension=this._register(new P.Emitter),this._onDidInstallExtensions=this._register(new P.Emitter),this._onUninstallExtension=this._register(new P.Emitter),this._onDidUninstallExtension=this._register(new P.Emitter),this._onDidUpdateExtensionMetadata=this._register(new P.Emitter),this._register(this.channel.listen("onInstallExtension")(v=>this.fireEvent(this._onInstallExtension,{...v,source:this.isUriComponents(v.source)?L.URI.revive(v.source):v.source,profileLocation:L.URI.revive(v.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(v=>this.fireEvent(this._onDidInstallExtensions,v.map(C=>({...C,local:C.local?R(C.local,null):C.local,source:this.isUriComponents(C.source)?L.URI.revive(C.source):C.source,profileLocation:L.URI.revive(C.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(v=>this.fireEvent(this._onUninstallExtension,{...v,profileLocation:L.URI.revive(v.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(v=>this.fireEvent(this._onDidUninstallExtension,{...v,profileLocation:L.URI.revive(v.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(v=>this.fireEvent(this._onDidUpdateExtensionMetadata,{profileLocation:L.URI.revive(v.profileLocation),local:R(v.local,null)})))}fireEvent(g,v){g.fire(v)}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const v=await this.getTargetPlatform();return g.allTargetPlatforms.some(C=>(0,T.isTargetPlatformCompatible)(C,g.allTargetPlatforms,v))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(v=>L.URI.revive(v)))}install(g,v){return Promise.resolve(this.channel.call("install",[g,v])).then(C=>R(C,null))}installFromLocation(g,v){return Promise.resolve(this.channel.call("installFromLocation",[g,v])).then(C=>R(C,null))}async installExtensionsFromProfile(g,v,C){return(await this.channel.call("installExtensionsFromProfile",[g,v,C])).map(c=>R(c,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,v){return Promise.resolve(this.channel.call("installFromGallery",[g,v])).then(C=>R(C,null))}async installGalleryExtensions(g){return(await this.channel.call("installGalleryExtensions",[g])).map(C=>({...C,local:C.local?R(C.local,null):C.local,source:this.isUriComponents(C.source)?L.URI.revive(C.source):C.source,profileLocation:L.URI.revive(C.profileLocation)}))}uninstall(g,v){if(g.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.channel.call("uninstall",[g,v]))}uninstallExtensions(g){if(g.some(v=>v.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.channel.call("uninstallExtensions",[g]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g])).then(v=>R(v,null))}getInstalled(g=null,v,C){return Promise.resolve(this.channel.call("getInstalled",[g,v,C])).then(S=>S.map(c=>R(c,null)))}updateMetadata(g,v,C){return Promise.resolve(this.channel.call("updateMetadata",[g,v,C])).then(S=>R(S,null))}resetPinnedStateForAllUserExtensions(g){return this.channel.call("resetPinnedStateForAllUserExtensions",[g])}toggleAppliationScope(g,v){return this.channel.call("toggleAppliationScope",[g,v]).then(C=>R(C,null))}copyExtensions(g,v){return this.channel.call("copyExtensions",[g,v])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(g,v,C){const S=await this.channel.call("download",[g,v,C]);return L.URI.revive(S)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=l;class p{constructor(g){this.service=g}listen(g,v){throw new Error("Invalid listen")}call(g,v,C){switch(v){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(C[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(ue[188],he([0,1,2,34,7]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends P.Disposable{constructor(T,D,E,R,m){super(),this.userDataProfilesService=T,this.fileService=D,this.uriIdentityService=E,this.logService=m,this._register(R.onDidInstallExtensions(d=>this.onDidInstallExtensions(d))),this._register(R.onDidUninstallExtension(d=>this.onDidUnInstallExtension(d)))}onDidInstallExtensions(T){for(const D of T)D.local&&this.invalidate(D.profileLocation)}onDidUnInstallExtension(T){T.error||this.invalidate(T.profileLocation)}async invalidate(T){if(T)for(const D of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(D.extensionsResource,T)&&await this.deleteUserCacheFile(D);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(T){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(T.cacheHome,a.USER_MANIFEST_CACHE_FILE))}catch(D){(0,_.toFileOperationResult)(D)!==_.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(D)}}}e.ExtensionsManifestCache=L});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ue[59],he([0,1,20,92,11,60,34,159]),function(ae,e,P,a,_,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=R,e.parseVersion=m,e.normalizeVersion=d,e.isValidVersion=f,e.validateExtensionManifest=l,e.isValidExtensionVersion=p,e.isEngineValid=I,e.areApiProposalsCompatible=g,a=it(a),_=De(_),L=De(L);const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function R(S){return S=S.trim(),S==="*"||D.test(S)}function m(S){if(!R(S))return null;if(S=S.trim(),S==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=S.match(D);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function d(S){if(!S)return null;const c=S.majorBase,u=S.majorMustEqual,i=S.minorBase;let n=S.minorMustEqual;const t=S.patchBase;let s=S.patchMustEqual;S.hasCaret&&(c===0||(n=!1),s=!1);let r=0;if(S.preRelease){const o=E.exec(S.preRelease);if(o){const[,h,y,A]=o;r=Date.UTC(Number(h),Number(y)-1,Number(A))}}return{majorBase:c,majorMustEqual:u,minorBase:i,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:S.hasGreaterEquals,notBefore:r}}function f(S,c,u){let i;typeof S=="string"?i=d(m(S)):i=S;let n;c instanceof Date?n=c.getTime():typeof c=="string"&&(n=new Date(c).getTime());let t;if(typeof u=="string"?t=d(m(u)):t=u,!i||!t)return!1;const s=i.majorBase,r=i.minorBase,o=i.patchBase;let h=t.majorBase,y=t.minorBase,A=t.patchBase;const b=t.notBefore;let w=t.majorMustEqual,O=t.minorMustEqual,N=t.patchMustEqual;return t.isMinimum?s>h?!0:s<h?!1:r>y?!0:r<y||n&&n<b?!1:o>=A:(s===1&&h===0&&(!w||!O||!N)&&(h=1,y=0,A=0,w=!0,O=!1,N=!1),s<h?!1:s>h?!w:r<y?!1:r>y?!O:o<A?!1:o>A?!N:!(n&&n<b))}function l(S,c,u,i,n,t){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([a.default.Error,_.localize(11433,null)]),s;if(typeof i.name!="string")return s.push([a.default.Error,_.localize(11434,null,"name")]),s;if(typeof i.version!="string")return s.push([a.default.Error,_.localize(11435,null,"version")]),s;if(!i.engines)return s.push([a.default.Error,_.localize(11436,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([a.default.Error,_.localize(11437,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!C(i.extensionDependencies))return s.push([a.default.Error,_.localize(11438,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!C(i.activationEvents))return s.push([a.default.Error,_.localize(11439,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([a.default.Error,_.localize(11440,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([a.default.Warning,_.localize(11441,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([a.default.Error,_.localize(11442,null,"main")]),s;{const h=(0,P.joinPath)(u,i.main);(0,P.isEqualOrParent)(h,u)||s.push([a.default.Warning,_.localize(11443,null,h.path,u.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([a.default.Error,_.localize(11444,null,"browser")]),s;{const h=(0,P.joinPath)(u,i.browser);(0,P.isEqualOrParent)(h,u)||s.push([a.default.Warning,_.localize(11445,null,h.path,u.path)])}}if(!L.valid(i.version))return s.push([a.default.Error,_.localize(11446,null)]),s;const r=[];if(!p(S,c,i,n,r))for(const h of r)s.push([a.default.Error,h]);if(t&&i.enabledApiProposals?.length){const h=[];if(!g([...i.enabledApiProposals],h))for(const y of h)s.push([a.default.Error,y])}return s}function p(S,c,u,i,n){return i||typeof u.main>"u"&&typeof u.browser>"u"?!0:v(S,c,u.engines.vscode,n)}function I(S,c,u){return S==="*"||v(c,u,S)}function g(S,c){if(S.length===0)return!0;const u=Array.isArray(c)?c:void 0,i=(u?void 0:c)??T.allApiProposals,n=[],t=(0,k.parseApiProposals)(S);for(const{proposalName:s,version:r}of t){const o=i[s];o&&r&&o.version!==r&&n.push(_.localize(11447,null,s))}return u?.push(...n),n.length===0}function v(S,c,u,i=[]){const n=d(m(u));if(!n)return i.push(_.localize(11448,null,u)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return i.push(_.localize(11449,null,u)),!1}else if(!n.majorMustEqual)return i.push(_.localize(11450,null,u)),!1;return f(S,c,n)?!0:(i.push(_.localize(11451,null,S,u)),!1)}function C(S){if(!Array.isArray(S))return!1;for(let c=0,u=S.length;c<u;c++)if(typeof S[c]!="string")return!1;return!0}}),define(ue[78],he([0,1,25,2,5,11,27,4]),function(ae,e,P,a,_,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=D;function D(R){return R.tags.find(m=>m.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,T.createDecorator)("languagePackService");let E=class extends a.Disposable{constructor(m){super(),this.extensionGalleryService=m}async getAvailableLanguages(){const m=new P.CancellationTokenSource;setTimeout(()=>m.cancel(),1e3);let d;try{d=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},m.token)}catch{return[]}const l=d.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(I=>I.startsWith("lp-"))).map(p=>{const I=p.properties.localizedLanguages?.[0],g=D(p);return{...this.createQuickPickItem(g,I,p),extensionId:p.identifier.id,galleryExtension:p}});return l.push(this.createQuickPickItem("en","English")),l}createQuickPickItem(m,d,f){const l=d??m;let p;if(l!==m&&(p=`(${m})`),m.toLowerCase()===_.language.toLowerCase()&&(p??="",p+=(0,L.localize)(11355,null)),f?.installCount){p??="";const I=f.installCount;let g;I>1e6?g=`${Math.floor(I/1e5)/10}M`:I>1e3?g=`${Math.floor(I/1e3)}K`:g=String(I),p+=` $(cloud-download) ${g}`}return{id:m,label:l,description:p}}};e.LanguagePackBaseService=E,e.LanguagePackBaseService=E=we([Q(0,k.IExtensionGalleryService)],E)}),define(ue[189],he([0,1,2,78]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let _=class extends P.Disposable{constructor(k){super(),this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=_,e.LocalizationsUpdater=_=we([Q(0,a.ILanguagePackService)],_)}),define(ue[106],he([0,1,2,4]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,a.createDecorator)("remoteSocketFactoryService");class _{constructor(){this.factories={}}register(k,T){return this.factories[k]??=[],this.factories[k].push(T),(0,P.toDisposable)(()=>{const D=this.factories[k]?.indexOf(T);typeof D=="number"&&D>=0&&this.factories[k]?.splice(D,1)})}getSocketFactory(k){return(this.factories[k.type]||[]).find(D=>D.supports(k))}connect(k,T,D,E){const R=this.getSocketFactory(k);if(!R)throw new Error(`No socket factory found for ${k}`);return R.connect(k,T,D,E)}}e.RemoteSocketFactoryService=_}),define(ue[190],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,P.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ue[107],he([0,1,4,11]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,P.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var _;(function(L){L.disconnected=k=>({type:"disconnected",onTokenFailed:k}),L.connected=(k,T)=>({type:"connected",info:k,serviceInstallFailed:T}),L.connecting=k=>({type:"connecting",progress:k}),L.uninitialized={type:"uninitialized"}})(_||(e.TunnelStates=_={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,a.localize)(11239,null)}),define(ue[61],he([0,1,14,8,2,11,47,4,10,44]),function(ae,e,P,a,_,L,k,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=d,e.hasNoContent=f,e.asText=l,e.asTextOrError=p,e.asJson=I,e.updateProxyConfigurationsScope=g,e.IRequestService=(0,T.createDecorator)("requestService");class R{constructor(c){this.original=c}toJSON(){if(!this.headers){const c=Object.create(null);for(const u in this.original)u.toLowerCase()==="authorization"||u.toLowerCase()==="proxy-authorization"?c[u]="*****":c[u]=this.original[u];this.headers=c}return this.headers}}class m extends _.Disposable{constructor(c){super(),this.counter=0,this.logger=c.createLogger("network",{name:(0,L.localize)(11220,null),when:D.CONTEXT_LOG_LEVEL.isEqualTo((0,D.LogLevelToString)(D.LogLevel.Trace)).serialize()})}async logAndRequest(c,u,i){const n=`${c} #${++this.counter}: ${u.url}`;this.logger.trace(`${n} - begin`,u.type,new R(u.headers??{}));try{const t=await i();return this.logger.trace(`${n} - end`,u.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.logger.error(`${n} - error`,u.type,(0,a.getErrorMessage)(t)),t}}}e.AbstractRequestService=m;function d(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}function f(S){return S.res.statusCode===204}async function l(S){return f(S)?null:(await(0,P.streamToBuffer)(S.stream)).toString()}async function p(S){if(!d(S))throw new Error("Server returned "+S.res.statusCode);return l(S)}async function I(S){if(!d(S))throw new Error("Server returned "+S.res.statusCode);if(f(S))return null;const u=(await(0,P.streamToBuffer)(S.stream)).toString();try{return JSON.parse(u)}catch(i){throw i.message+=`:
`+u,i}}function g(S){C(S)}let v;function C(S){const c=E.Registry.as(k.Extensions.Configuration),u=v;v={id:"http",order:15,title:(0,L.localize)(11221,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(11222,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(11223,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(11224,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,L.localize)(11225,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(11226,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(11227,null),(0,L.localize)(11228,null),(0,L.localize)(11229,null),(0,L.localize)(11230,null)],default:"override",description:(0,L.localize)(11231,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11232,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(11233,null),restricted:!0}}},c.updateConfigurations({add:[v],remove:u?[u]:[]})}C(k.ConfigurationScope.APPLICATION)}),define(ue[191],he([0,1,25,22,7,61]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(D,E){this.requestService=D,this.fileService=E}async download(D,E,R=P.CancellationToken.None){if(D.scheme===a.Schemas.file||D.scheme===a.Schemas.vscodeRemote){await this.fileService.copy(D,E);return}const m={type:"GET",url:D.toString(!0)},d=await this.requestService.request(m,R);if(d.res.statusCode===200)await this.fileService.writeFile(E,d.stream);else{const f=await(0,L.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${f}`)}}};e.DownloadService=k,e.DownloadService=k=we([Q(0,L.IRequestService),Q(1,_.IFileService)],k)}),define(ue[192],he([0,1,14,25]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class _{constructor(T){this.service=T}listen(T,D){throw new Error("Invalid listen")}call(T,D,E,R=a.CancellationToken.None){switch(D){case"request":return this.service.request(E[0],R).then(async({res:m,stream:d})=>{const f=await(0,P.streamToBuffer)(d);return[{statusCode:m.statusCode,headers:m.headers},f]});case"resolveProxy":return this.service.resolveProxy(E[0]);case"lookupAuthorization":return this.service.lookupAuthorization(E[0]);case"lookupKerberosAuthorization":return this.service.lookupKerberosAuthorization(E[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=_;class L{constructor(T){this.channel=T}async request(T,D){const[E,R]=await this.channel.call("request",[T],D);return{res:E,stream:(0,P.bufferToStream)(R)}}async resolveProxy(T){return this.channel.call("resolveProxy",[T])}async lookupAuthorization(T){return this.channel.call("lookupAuthorization",[T])}async lookupKerberosAuthorization(T){return this.channel.call("lookupKerberosAuthorization",[T])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=L}),define(ue[193],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ue[194],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class P{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(_){try{const L=await this.getValidator();if(L){const k=String(P._nextId++);return this.validators.set(k,L),{id:k,data:L.createNewMessage(_)}}}catch{}return{id:"",data:_}}async validate(_,L){if(!_.id)return!0;const k=this.validators.get(_.id);if(!k)return!1;this.validators.delete(_.id);try{return k.validate(L)==="ok"}catch{return!1}finally{k.dispose?.()}}async sign(_){try{return await this.signValue(_)}catch{}return _}}e.AbstractSignService=P}),define(ue[108],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,P.createDecorator)(e.SIGN_SERVICE_ID)}),define(ue[195],he([0,1,194]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a extends P.AbstractSignService{getValidator(){return this.vsda().then(L=>new L.validator)}signValue(L){return this.vsda().then(k=>new k.signer().sign(L))}vsda(){return new Promise((L,k)=>ae(["vsda"],L,k))}}e.SignService=a}),define(ue[79],he([0,1,3,2]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class _ extends a.Disposable{constructor(m,d,f){super(),this.channel=m,this.profile=d,this.workspace=f}async getItems(){const m={profile:this.profile,workspace:this.workspace},d=await this.channel.call("getItems",m);return new Map(d)}updateItems(m){const d={profile:this.profile,workspace:this.workspace};return m.insert&&(d.insert=Array.from(m.insert.entries())),m.delete&&(d.delete=Array.from(m.delete.values())),this.channel.call("updateItems",d)}optimize(){const m={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",m)}}class L extends _{constructor(m,d){super(m,d,void 0),this._onDidChangeItemsExternal=this._register(new P.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(m=>this.onDidChangeStorage(m)))}onDidChangeStorage(m){(Array.isArray(m.changed)||Array.isArray(m.deleted))&&this._onDidChangeItemsExternal.fire({changed:m.changed?new Map(m.changed):void 0,deleted:m.deleted?new Set(m.deleted):void 0})}}class k extends L{constructor(m){super(m,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=k;class T extends L{constructor(m,d){super(m,d)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=T;class D extends _{constructor(m,d){super(m,void 0,d),this.onDidChangeItemsExternal=P.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=D;class E{constructor(m){this.channel=m}isUsed(m){const d={payload:m,profile:void 0,workspace:void 0};return this.channel.call("isUsed",d)}}e.StorageClient=E}),define(ue[109],he([0,1,5,37,32]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=k,e.verifyMicrosoftInternalDomain=T;function L(D){if(P.platform===P.Platform.Linux&&/^penguin(\.|$)/i.test(D))return"chromebook"}function k(D,E,R,m,d,f,l,p,I,g){const v=Object.create(null);v["common.machineId"]=f,v["common.sqmId"]=l,v["common.devDeviceId"]=p,v.sessionID=(0,_.generateUuid)()+Date.now(),v.commitHash=m,v.version=d,v["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,P.PlatformToString)(P.platform),v["common.nodePlatform"]=a.platform,v["common.nodeArch"]=R,v["common.product"]=g||"desktop",I&&(v["common.msftInternal"]=I);let C=0;const S=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-S,enumerable:!0},"common.sequence":{get:()=>C++,enumerable:!0}}),P.isLinuxSnap&&(v["common.snap"]="true");const c=L(E);return c&&(v["common.platformDetail"]=c),v}function T(D){const E=a.env.USERDNSDOMAIN;if(!E)return!1;const R=E.toLowerCase();return D.some(m=>R===m)}}),define(ue[18],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,P.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,P.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var a;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var _;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(_||(e.TelemetryConfiguration=_={}))}),define(ue[196],he([0,1,33,38,6,36,22,13,5,54,9,142,30,149,97,7,23,18]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=C,e.getMachineInfo=c,e.collectLaunchConfigs=u,P=De(P),a=De(a);const v=new Map;async function C(n,t){const s=`${n}::${t.join(":")}`,r=v.get(s);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],h=new Map,y=new Map,A=2e4;function b(O,N,F,M){const H=N.substring(O.length+1);return _.Promises.withAsyncBody(async z=>{let J;M.readdirCount++;try{J=await d.Promises.readdir(N,{withFileTypes:!0})}catch{z();return}if(M.count>=A){M.count+=J.length,M.maxReached=!0,z();return}let V=J.length;if(V===0){z();return}let te=J;M.count+J.length>A&&(M.maxReached=!0,V=A-M.count,te=J.slice(0,V)),M.count+=J.length;for(const $ of te)if($.isDirectory()){if(F.includes($.name)||await b(O,(0,T.join)(N,$.name),F,M),--V===0){z();return}}else{const q=$.name.lastIndexOf(".");if(q>=0){const Z=$.name.substring(q+1);Z&&h.set(Z,(h.get(Z)??0)+1)}for(const Z of o)Z.relativePathPattern?.test(H)!==!1&&Z.filePattern.test($.name)&&y.set(Z.tag,(y.get(Z.tag)??0)+1);if(--V===0){z();return}}})}const w=_.Promises.withAsyncBody(async O=>{const N={count:0,maxReached:!1,readdirCount:0},F=new E.StopWatch(!0);await b(n,n,t,N);const M=await u(n);O({configFiles:S(y),fileTypes:S(h),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:M,totalScanTime:F.elapsed(),totalReaddirCount:N.readdirCount})});return v.set(s,w),w}function S(n){return Array.from(n.entries(),([t,s])=>({name:t,count:s})).sort((t,s)=>s.count-t.count)}function c(){const n={os:`${a.type()} ${a.arch()} ${a.release()}`,memory:`${(a.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(a.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},t=a.cpus();return t&&t.length>0&&(n.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),n}async function u(n){try{const t=new Map,s=(0,T.join)(n,".vscode","launch.json"),r=await P.promises.readFile(s),o=[],h=(0,L.parse)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,L.getNodeType)(h)==="object"&&h.configurations)for(const y of h.configurations){const A=y.type;A&&(t.has(A)?t.set(A,t.get(A)+1):t.set(A,1))}return S(t)}catch{return[]}}let i=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${a.type()} ${a.arch()} ${a.release()}`);const r=a.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(a.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(a.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||s.push(`Load (avg):       ${a.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,f.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async r=>{let[o,h]=r,y=this.formatProcessList(t,o);return s.forEach(A=>{if((0,l.isRemoteDiagnosticError)(A))y+=`
${A.errorMessage}`,h+=`
${A.errorMessage}`;else if(y+=`

Remote: ${A.hostName}`,A.processes&&(y+=`
${this.formatProcessList(t,A.processes)}`),A.workspaceMetadata){h+=`
|  Remote: ${A.hostName}`;for(const b of Object.keys(A.workspaceMetadata)){const w=A.workspaceMetadata[b];let O=`${w.fileCount} files`;w.maxFilesReached&&(O=`more than ${O}`),h+=`|    Folder (${b}): ${O}`,h+=this.formatWorkspaceStats(w)}}}),{processInfo:y,workspaceInfo:h}})}async getSystemInfo(t,s){const{memory:r,vmHint:o,os:h,cpus:y}=c(),A={os:h,memory:r,cpus:y,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return D.isWindows||(A.load=`${a.loadavg().map(b=>Math.round(b)).join(", ")}`),D.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(t,s){const r=[];return(0,f.listProcesses)(t.mainPID).then(async o=>(r.push(""),r.push(this.formatEnvironment(t)),r.push(""),r.push(this.formatProcessList(t,o)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(t))),s.forEach(h=>{if((0,l.isRemoteDiagnosticError)(h))r.push(`
${h.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${h.hostName}`),r.push(this.formatMachineInfo(h.machineInfo)),h.processes&&r.push(this.formatProcessList(t,h.processes)),h.workspaceMetadata)for(const y of Object.keys(h.workspaceMetadata)){const A=h.workspaceMetadata[y];let b=`${A.fileCount} files`;A.maxFilesReached&&(b=`more than ${b}`),r.push(`Folder (${y}): ${b}`),r.push(this.formatWorkspaceStats(A))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(t){const s=[];let o=0;const h=(w,O)=>{const N=` ${w}(${O})`;o+N.length>60?(s.push(y),y="|                 ",o=y.length):o+=N.length,y+=N};let y="|      File types:";const A=10,b=t.fileTypes.length>A?A:t.fileTypes.length;for(let w=0;w<b;w++){const O=t.fileTypes[w];h(O.name,O.count)}if(s.push(y),t.configFiles.length>=0&&(y="|      Conf files:",o=0,t.configFiles.forEach(w=>{h(w.name,w.count)}),s.push(y)),t.launchConfigFiles.length>0){let w="|      Launch Configs:";t.launchConfigFiles.forEach(O=>{const N=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;w+=N}),s.push(w)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],r=[];return t.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const y=R.URI.revive(h);if(y.scheme===k.Schemas.file){const A=y.fsPath;r.push(C(A,["node_modules",".git"]).then(b=>{let w=`${b.fileCount} files`;b.maxFilesReached&&(w=`more than ${w}`),s.push(`|    Folder (${(0,T.basename)(A)}): ${w}`),s.push(this.formatWorkspaceStats(b))}).catch(b=>{s.push(`|      Error: Unable to collect workspace stats for folder ${A} (${b.toString()})`)}))}else s.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(t,s){const r=new Map;t.windows.forEach(h=>r.set(h.pid,`window [${h.id}] (${h.title})`)),t.pidToNames.forEach(({pid:h,name:y})=>r.set(h,y));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,r,o,s,0),o.join(`
`)}formatProcessItem(t,s,r,o,h){const y=h===0;let A;y?A=o.pid===t?`${this.productService.applicationName} main`:"remote agent":s.has(o.pid)?A=s.get(o.pid):A=`${"  ".repeat(h)} ${o.name}`;const b=process.platform==="win32"?o.mem:a.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(b/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(o.children)&&o.children.forEach(w=>this.formatProcessItem(t,s,r,w,h+1))}async getWorkspaceFileExtensions(t){const s=new Set;for(const{uri:r}of t.folders){const o=R.URI.revive(r);if(o.scheme!==k.Schemas.file)continue;const h=o.fsPath;try{(await C(h,["node_modules",".git"])).fileTypes.forEach(A=>s.add(A.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=R.URI.revive(s);if(r.scheme!==k.Schemas.file)continue;const o=r.fsPath;try{const h=await C(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),h.launchConfigFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),h.configFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),this.telemetryService.publicLog2("workspace.stats.metadata",{duration:h.totalScanTime,reachedLimit:h.maxFilesReached,fileCount:h.fileCount,readdirCount:h.totalReaddirCount})}catch{}}}};e.DiagnosticsService=i,e.DiagnosticsService=i=we([Q(0,g.ITelemetryService),Q(1,I.IProductService)],i)}),define(ue[110],he([0,1,8,4,10,18]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.ExtensionSignatureVerificationError=e.ExtensionSignatureVerificationCode=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,a.createDecorator)("IExtensionSignatureVerificationService");var k;(function(E){E.Success="Success",E.RequiredArgumentMissing="RequiredArgumentMissing",E.InvalidArgument="InvalidArgument",E.PackageIsUnreadable="PackageIsUnreadable",E.UnhandledException="UnhandledException",E.SignatureManifestIsMissing="SignatureManifestIsMissing",E.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",E.SignatureIsMissing="SignatureIsMissing",E.SignatureIsUnreadable="SignatureIsUnreadable",E.CertificateIsUnreadable="CertificateIsUnreadable",E.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",E.FileAlreadyExists="FileAlreadyExists",E.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",E.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",E.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",E.SignatureIsInvalid="SignatureIsInvalid",E.SignatureManifestIsInvalid="SignatureManifestIsInvalid",E.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",E.EntryIsMissing="EntryIsMissing",E.EntryIsTampered="EntryIsTampered",E.Untrusted="Untrusted",E.CertificateRevoked="CertificateRevoked",E.SignatureIsNotValid="SignatureIsNotValid",E.UnknownError="UnknownError",E.PackageIsInvalidZip="PackageIsInvalidZip",E.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(k||(e.ExtensionSignatureVerificationCode=k={}));class T extends Error{constructor(R){super(R),this.code=R}}e.ExtensionSignatureVerificationError=T;let D=class{constructor(R,m){this.logService=R,this.telemetryService=m}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((R,m)=>ae(["@vscode/vsce-sign"],async d=>R(d),m))),this.moduleLoadingPromise}async verify(R,m,d,f){let l;const p=R.identifier.id;try{l=await this.vsceSign()}catch(C){return this.logService.error("Could not load vsce-sign module",(0,P.getErrorMessage)(C)),this.logService.info(`Extension signature verification is not done: ${p}`),!1}const I=new Date().getTime();let g;try{this.logService.trace(`Verifying extension signature for ${p}...`),g=await l.verify(m,d,this.logService.getLevel()===_.LogLevel.Trace)}catch(C){g={code:k.UnknownError,didExecute:!1,output:(0,P.getErrorMessage)(C)}}const v=new Date().getTime()-I;if(this.logService.info(`Extension signature verification result for ${p}: ${g.code}. Executed: ${g.didExecute}. Duration: ${v}ms.`),this.logService.trace(`Extension signature verification output for ${p}:
${g.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:p,extensionVersion:R.version,code:g.code,internalCode:g.internalCode,duration:v,didExecute:g.didExecute,clientTargetPlatform:f}),g.code===k.Success)return!0;throw new T(g.code)}};e.ExtensionSignatureVerificationService=D,e.ExtensionSignatureVerificationService=D=we([Q(0,_.ILogService),Q(1,L.ITelemetryService)],D)}),define(ue[111],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class P{constructor(L){this.appenders=L}listen(L,k){throw new Error(`Event not found: ${k}`)}call(L,k,{eventName:T,data:D}){return this.appenders.forEach(E=>E.log(T,D)),Promise.resolve(null)}}e.TelemetryAppenderChannel=P;class a{constructor(L){this.channel=L}log(L,k){return this.channel.call("log",{eventName:L,data:k}).then(void 0,T=>`Failed to log telemetry: ${console.warn(T)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=a}),define(ue[48],he([0,1,29,12,105,109,18]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=R,e.isLoggingOnly=m,e.getTelemetryLevel=d,e.validateTelemetryData=f,e.cleanRemoteAuthority=p,e.isInternalTelemetry=g,e.getPiiPathsFromEnvironment=v,e.cleanData=c;class T{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=T;class D{constructor(){this.telemetryLevel=k.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class E{async publicLog(i,n,t){}async publicLogError(i,n,t){}}e.NullEndpointTelemetryService=E,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(u,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!u.enableTelemetry)}function m(u,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}function d(u){const i=u.getValue(k.TELEMETRY_SETTING_ID),n=u.getValue(k.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return k.TelemetryLevel.NONE;switch(i??k.TelemetryConfiguration.ON){case k.TelemetryConfiguration.ON:return k.TelemetryLevel.USAGE;case k.TelemetryConfiguration.ERROR:return k.TelemetryLevel.ERROR;case k.TelemetryConfiguration.CRASH:return k.TelemetryLevel.CRASH;case k.TelemetryConfiguration.OFF:return k.TelemetryLevel.NONE}}function f(u){const i={},n={},t={};I(u,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const r=t[s];typeof r=="number"?n[s]=r:typeof r=="boolean"?n[s]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${r.length}`),i[s]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[s]=r)}return{properties:i,measurements:n}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(u){if(!u)return"none";const i=(0,_.getRemoteName)(u);return l.has(i)?i:"other"}function I(u,i,n=0,t){if(u)for(const s of Object.getOwnPropertyNames(u)){const r=u[s],o=t?t+s:s;Array.isArray(r)?i[o]=(0,P.safeStringify)(r):r instanceof Date?i[o]=r.toISOString():(0,a.isObject)(r)?n<2?I(r,i,n+1,o+"."):i[o]=(0,P.safeStringify)(r):i[o]=r}}function g(u,i){const n=u.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(n)||t}function v(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}function C(u,i){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let n=u;const t=[];for(const h of i)for(;;){const y=h.exec(u);if(!y)break;t.push([y.index,h.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(n="";;){const h=r.exec(u);if(!h)break;const y=t.some(([A,b])=>h.index<b&&A<r.lastIndex);!s.test(h[0])&&!y&&(n+=u.substring(o,h.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<u.length&&(n+=u.substr(o)),n}function S(u){if(!u)return u;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of i)if(n.regex.test(u))return`<REDACTED: ${n.label}>`;return u}function c(u,i){return(0,P.cloneAndChange)(u,n=>{if(n instanceof T||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=C(t,i);for(const s of i)t=t.replace(s,"");return t=S(t),t}})}}),define(ue[35],he([0,1,26,27,34,5,9,8,37,48]),function(ae,e,P,a,_,L,k,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=R,e.getIdAndVersion=l,e.getExtensionId=p,e.adoptToGalleryExtensionId=I,e.getGalleryExtensionId=g,e.groupByExtension=v,e.getLocalExtensionTelemetryData=C,e.getGalleryExtensionTelemetryData=S,e.getExtensionDependencies=c,e.computeTargetPlatform=i;function R(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,P.compareIgnoreCase)(n.id,t.id)===0}const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new d(t.identifier,s,r)}static parse(t){const s=m.exec(t);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r=_.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==_.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof d?R(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=d;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(n){const t=f.exec(n);return t&&t[1]?[I(t[1]),t[2]]:[I(n),void 0]}function p(n,t){return`${n}.${t}`}function I(n){return n.toLowerCase()}function g(n,t){return I(p(n??_.UNDEFINED_PUBLISHER,t))}function v(n,t){const s=[],r=o=>{for(const h of s)if(h.some(y=>R(t(y),t(o))))return h;return null};for(const o of n){const h=r(o);h?h.push(o):s.push([o])}return s}function C(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function S(n){return{id:new E.TelemetryTrustedValue(n.identifier.id),name:new E.TelemetryTrustedValue(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.BetterMergeId=new _.ExtensionIdentifier("pprice.better-merge");function c(n,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&s.every(h=>!R(h.identifier,{id:o}))){const h=n.filter(y=>R(y.identifier,{id:o}));h.length===1&&(s.push(h[0]),r.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function u(n,t){if(!L.isLinux)return!1;let s;try{s=(await n.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){t.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(n,t){const s=await u(n,t),r=(0,a.getTargetPlatform)(s?"alpine":L.platform,D.arch);return t.debug("ComputeTargetPlatform:",r),r}}),define(ue[197],he([0,1,25,27,35,34]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=k;async function k(T,D,E,R,m){try{const d=await T.getExtensionsControlManifest();if(!d.deprecated)return;const f=await T.getInstalled(L.ExtensionType.User);for(const[l,p]of Object.entries(d.deprecated)){if(!p?.extension)continue;const{id:I,autoMigrate:g,preRelease:v}=p.extension;if(!g)continue;const C=f.find(c=>(0,_.areSameExtensions)(c.identifier,{id:l}));if(!C)continue;const S=(await D.getExtensions([{id:I,preRelease:v}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},P.CancellationToken.None))[0];if(!S){m.info(`Skipping migrating '${C.identifier.id}' extension because, the comaptible target '${I}' extension is not found`);continue}try{m.info(`Migrating '${C.identifier.id}' extension to '${I}' extension...`);const c=!R.getDisabledExtensions().some(i=>(0,_.areSameExtensions)(i,C.identifier));await T.uninstall(C),m.info(`Uninstalled the unsupported extension '${C.identifier.id}'`);let u=f.find(i=>(0,_.areSameExtensions)(i.identifier,{id:I}));(!u||!u.isPreReleaseVersion&&c)&&(u=await T.installFromGallery(S,{installPreReleaseVersion:!0,isMachineScoped:C.isMachineScoped,operation:a.InstallOperation.Migrate}),m.info(`Installed the pre-release extension '${u.identifier.id}'`),c||(await R.disableExtension(u.identifier),m.info(`Disabled the pre-release extension '${u.identifier.id}' because the unsupported extension '${C.identifier.id}' is disabled`)),g.storage&&(E.addToMigrationList((0,_.getExtensionId)(C.manifest.publisher,C.manifest.name),(0,_.getExtensionId)(u.manifest.publisher,u.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${C.identifier.id}' extension to '${I}' extension.`)}catch(c){m.error(c)}}}catch(d){m.error(d)}}}),define(ue[198],he([0,1,8,3,2,31,35,34,7]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class E extends _.Disposable{constructor(m,d,f,l,p,I,g){super(),this.extensionManagementService=m,this.extensionsScannerService=d,this.userDataProfilesService=f,this.extensionsProfileScannerService=l,this.uriIdentityService=p,this.fileService=I,this.logService=g,this._onDidChangeExtensionsByAnotherSource=this._register(new a.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new _.DisposableMap),this.initialize().then(null,v=>g.error("Error while initializing Extensions Watcher",(0,P.getErrorMessage)(v)))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(m=>this.onDidChangeProfiles(m.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(m=>this.onAddExtensions(m))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(m=>this.onDidAddExtensions(m))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(m=>this.onRemoveExtensions(m))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(m=>this.onDidRemoveExtensions(m))),this._register(this.fileService.onDidFilesChange(m=>this.onDidFilesChange(m)))}async onDidChangeProfiles(m){try{m.length&&await Promise.all(m.map(d=>(this.extensionsProfileWatchDisposables.set(d.id,(0,_.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(d.extensionsResource)),this.fileService.watch(d.extensionsResource))),this.populateExtensionsFromProfile(d.extensionsResource))))}catch(d){throw this.logService.error(d),d}}async onAddExtensions(m){for(const d of m.extensions)this.addExtensionWithKey(this.getKey(d.identifier,d.version),m.profileLocation)}async onDidAddExtensions(m){for(const d of m.extensions){const f=this.getKey(d.identifier,d.version);m.error?this.removeExtensionWithKey(f,m.profileLocation):this.addExtensionWithKey(f,m.profileLocation)}}async onRemoveExtensions(m){for(const d of m.extensions)this.removeExtensionWithKey(this.getKey(d.identifier,d.version),m.profileLocation)}async onDidRemoveExtensions(m){const d=[],f=[];for(const l of m.extensions){const p=this.getKey(l.identifier,l.version);m.error?this.addExtensionWithKey(p,m.profileLocation):(this.removeExtensionWithKey(p,m.profileLocation),this.allExtensions.has(p)||(this.logService.debug("Extension is removed from all profiles",l.identifier.id,l.version),f.push(this.extensionManagementService.scanInstalledExtensionAtLocation(l.location).then(I=>{I?d.push(I):this.logService.info("Extension not found at the location",l.location.toString())},I=>this.logService.error(I)))))}try{await Promise.all(f),d.length&&await this.uninstallExtensionsNotInProfiles(d)}catch(l){this.logService.error(l)}}onDidFilesChange(m){for(const d of this.userDataProfilesService.profiles)m.contains(d.extensionsResource,D.FileChangeType.UPDATED,D.FileChangeType.ADDED)&&this.onDidExtensionsProfileChange(d.extensionsResource)}async onDidExtensionsProfileChange(m){const d=[],f=[],l=await this.extensionsProfileScannerService.scanProfileExtensions(m),p=new Set,I=new Set;for(const[g,v]of this.allExtensions)v.has(m)&&I.add(g);for(const g of l){const v=this.getKey(g.identifier,g.version);p.add(v),I.has(v)||(d.push(g.identifier),this.addExtensionWithKey(v,m))}for(const g of I)if(!p.has(g)){const v=this.fromKey(g);v&&(f.push(v.identifier),this.removeExtensionWithKey(g,m))}(d.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:d.length?{extensions:d,profileLocation:m}:void 0,removed:f.length?{extensions:f,profileLocation:m}:void 0})}async populateExtensionsFromProfile(m){const d=await this.extensionsProfileScannerService.scanProfileExtensions(m);for(const f of d)this.addExtensionWithKey(this.getKey(f.identifier,f.version),m)}async uninstallExtensionsNotInProfiles(m){m||(m=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(f=>!this.allExtensions.has(this.getKey(f.identifier,f.manifest.version)))),m.length&&await this.extensionManagementService.markAsUninstalled(...m)}addExtensionWithKey(m,d){let f=this.allExtensions.get(m);f||this.allExtensions.set(m,f=new L.ResourceSet(l=>this.uriIdentityService.extUri.getComparisonKey(l))),f.add(d)}removeExtensionWithKey(m,d){const f=this.allExtensions.get(m);f&&f.delete(d),f?.size||this.allExtensions.delete(m)}getKey(m,d){return`${T.ExtensionIdentifier.toKey(m.id)}@${d}`}fromKey(m){const[d,f]=(0,k.getIdAndVersion)(m);return f?{identifier:{id:d},version:f}:void 0}}e.ExtensionsWatcher=E}),define(ue[199],he([0,1,33,75,17,6,2,22,13,30,15,27,35,10,78,9]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0,P=De(P);let I=class extends l.LanguagePackBaseService{constructor(S,c,u,i){super(u),this.extensionManagementService=S,this.logService=i,this.cache=this._register(new g(c,i)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getBuiltInExtensionTranslationsUri(S,c){const i=(await this.cache.getLanguagePacks())[c];if(!i){this.logService.warn(`No language pack found for ${c}`);return}const n=i.translations[S];return n?p.URI.file(n):void 0}async getInstalledLanguages(){const S=await this.cache.getLanguagePacks(),c=Object.keys(S).map(u=>{const i=S[u];return{...this.createQuickPickItem(u,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.createQuickPickItem("en","English")),c.sort((u,i)=>u.label.localeCompare(i.label)),c}async postInstallExtension(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",S.identifier.id),await this.update())}async postUninstallExtension(S){const c=await this.cache.getLanguagePacks();Object.keys(c).some(u=>c[u]&&c[u].extensions.some(i=>(0,d.areSameExtensions)(i.extensionIdentifier,S.identifier)))&&(this.logService.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,c]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),u=await this.cache.update(c);return!(0,_.equals)(Object.keys(S),Object.keys(u))}};e.NativeLanguagePackService=I,e.NativeLanguagePackService=I=we([Q(0,m.IExtensionManagementService),Q(1,R.INativeEnvironmentService),Q(2,m.IExtensionGalleryService),Q(3,f.ILogService)],I);let g=class extends k.Disposable{constructor(S,c){super(),this.logService=c,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(S.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(S){return this.withLanguagePacks(c=>{Object.keys(c).forEach(u=>delete c[u]),this.createLanguagePacksFromExtensions(c,...S)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(S,...c){for(const u of c)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(S,u);Object.keys(S).forEach(u=>this.updateHash(S[u]))}createLanguagePacksFromExtension(S,c){const u=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const n of i)if(c.location.scheme===T.Schemas.file&&v(n)){let t=S[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},S[n.languageId]=t);const s=t.extensions.filter(r=>(0,d.areSameExtensions)(r.extensionIdentifier,u))[0];s?s.version=c.manifest.version:t.extensions.push({extensionIdentifier:u,version:c.manifest.version});for(const r of n.translations)t.translations[r.id]=(0,D.join)(c.location.fsPath,r.path)}}updateHash(S){if(S){const c=(0,a.createHash)("md5");for(const u of S.extensions)c.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);S.hash=c.digest("hex")}}withLanguagePacks(S=()=>null){return this.languagePacksFileLimiter.queue(()=>{let c=null;return P.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(c=S(u),u)).then(u=>{for(const n of Object.keys(u))u[n]||delete u[n];this.languagePacks=u,this.initializedCache=!0;const i=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",i),E.Promises.writeFile(this.languagePacksFilePath,i)}).then(()=>c,u=>this.logService.error(u))})}};g=we([Q(0,R.INativeEnvironmentService),Q(1,f.ILogService)],g);function v(C){if(typeof C.languageId!="string"||!Array.isArray(C.translations)||C.translations.length===0)return!1;for(const S of C.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(C.languageName&&typeof C.languageName!="string"||C.localizedLanguageName&&typeof C.localizedLanguageName!="string")}}),define(ue[200],he([0,1,140,8,29,48]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://0.0.0.0/OneCollector/1.0",T="https://0.0.0.0/ping";async function D(R,m,d){const f=await(0,P.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,P.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new f.AppInsightsCore,I=new l.PostChannel,g={instrumentationKey:R,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[I]]};if(d){g.extensionConfig={};const v={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};g.extensionConfig[I.identifier]=v}return p.initialize(g,[]),p.addTelemetryInitializer(v=>{v.ext=v.ext??{},v.ext.web=v.ext.web??{},v.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',m&&(v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),p}class E{constructor(m,d,f,l,p){this._isInternalTelemetry=m,this._eventPrefix=d,this._defaultData=f,this._xhrOverride=p,this.endPointUrl=k,this.endPointHealthUrl=T,this._defaultData||(this._defaultData={}),typeof l=="function"?this._aiCoreOrKey=l():this._aiCoreOrKey=l,this._asyncAiCore=null}_withAIClient(m){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){m(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=D(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(d=>{m(d)},d=>{(0,a.onUnexpectedError)(d),console.error(d)})}}log(m,d){if(!this._aiCoreOrKey)return;d=(0,_.mixin)(d,this._defaultData),d=(0,L.validateTelemetryData)(d);const f=this._eventPrefix+"/"+m;try{this._withAIClient(l=>{l.pluginVersionString=d?.properties.version??"Unknown",l.track({name:f,baseData:{name:f,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(m=>{this._withAIClient(d=>{d.unload(!0,()=>{this._aiCoreOrKey=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=E}),define(ue[112],he([0,1,2,11,15,10,23,48]),function(ae,e,P,a,_,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let D=class extends P.Disposable{constructor(R,m,d,f,l=""){super(),this.prefix=l;const p=m.getLogger(T.telemetryLogId);if(p)this.logger=this._register(p);else{const g=(0,T.isLoggingOnly)(f,d)?" (Not Sent)":"",v=()=>(0,T.supportsTelemetry)(f,d)&&R.getLevel()===L.LogLevel.Trace;this.logger=this._register(m.createLogger(T.telemetryLogId,{name:(0,a.localize)(11216,null,g),hidden:!v()})),this._register(R.onDidChangeLogLevel(()=>m.setVisibility(T.telemetryLogId,v()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(R,m){this.logger.trace(`${this.prefix}telemetry/${R}`,(0,T.validateTelemetryData)(m))}};e.TelemetryLogAppender=D,e.TelemetryLogAppender=D=we([Q(0,L.ILogService),Q(1,L.ILoggerService),Q(2,_.IEnvironmentService),Q(3,k.IProductService)],D)});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ue[113],he([0,1,2,29,5,26,11,21,47,102,23,44,18,48]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0,E=it(E);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,v,C){this._configurationService=v,this._productService=C,this._experimentProperties={},this._disposables=new P.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=g.piiPaths||[],this._telemetryLevel=d.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(S=>{(S.affectsConfiguration(d.TELEMETRY_SETTING_ID)||S.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(g,v){this._experimentProperties[g]=v}_updateTelemetryLevel(){let g=(0,f.getTelemetryLevel)(this._configurationService);const v=this._productService.enabledTelemetryLevels;if(v){this._sendErrorTelemetry=this.sendErrorTelemetry?v.error:!1;const C=v.usage?d.TelemetryLevel.USAGE:v.error?d.TelemetryLevel.ERROR:d.TelemetryLevel.NONE;g=Math.min(g,C)}this._telemetryLevel=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(g,v,C){this._telemetryLevel<v||(C=(0,a.mixin)(C,this._experimentProperties),C=(0,f.cleanData)(C,this._cleanupPatterns),C=(0,a.mixin)(C,this._commonProperties),this._appenders.forEach(S=>S.log(g,C)))}publicLog(g,v){this._log(g,d.TelemetryLevel.USAGE,v)}publicLog2(g,v){this.publicLog(g,v)}publicLogError(g,v){this._sendErrorTelemetry&&this._log(g,d.TelemetryLevel.ERROR,v)}publicLogError2(g,v){this.publicLogError(g,v)}};e.TelemetryService=l,e.TelemetryService=l=we([Q(1,T.IConfigurationService),Q(2,R.IProductService)],l);function p(){const I=(0,k.localize)(11198,null,E.default.nameLong),g=E.default.privacyStatementUrl?(0,k.localize)(11200,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,k.localize)(11199,null,"https://aka.ms/vscode-telemetry"),v=_.isWeb?"":(0,k.localize)(11201,null),C=(0,k.localize)(11202,null),S=(0,k.localize)(11203,null),c=(0,k.localize)(11204,null),u=(0,k.localize)(11205,null),i=`
|       | ${C} | ${S} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,k.localize)(11206,null);return`
${I} ${g} ${v}

&nbsp;

${u}
${i}

&nbsp;

${n}
`}m.Registry.as(D.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(11207,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:[d.TelemetryConfiguration.ON,d.TelemetryConfiguration.ERROR,d.TelemetryConfiguration.CRASH,d.TelemetryConfiguration.OFF],enumDescriptions:[(0,k.localize)(11208,null),(0,k.localize)(11209,null),(0,k.localize)(11210,null),(0,k.localize)(11211,null)],markdownDescription:p(),default:d.TelemetryConfiguration.OFF,restricted:!0,scope:D.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(D.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(11212,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,k.localize)(11214,null,E.default.nameLong,E.default.privacyStatementUrl):(0,k.localize)(11213,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(11215,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:D.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ue[201],he([0,1,14,25,244,200]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0,_=De(_);async function k(R,m){const d=await m.request(R,a.CancellationToken.None),f=(await(0,P.streamToBuffer)(d.stream)).toString(),l=d.res.statusCode??200;return{headers:d.res.headers,statusCode:l,responseData:f}}async function T(R){const m={method:R.type,headers:R.headers};return new Promise((f,l)=>{const p=_.request(R.url??"",m,I=>{I.on("data",function(g){f({headers:I.headers,statusCode:I.statusCode??200,responseData:g.toString()})}),I.on("error",function(g){l(g)})});p.write(R.data,I=>{I&&l(I)}),p.end()})}async function D(R,m,d){const f=typeof m.data=="string"?m.data:new TextDecoder().decode(m.data),l={type:"POST",headers:{...m.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(m.data).toString()},url:m.urlString,data:f};try{const p=R?await k(l,R):await T(l);d(p.statusCode,p.headers,p.responseData)}catch{d(0,{})}}class E extends L.AbstractOneDataSystemAppender{constructor(m,d,f,l,p){const I={sendPOST:(g,v)=>{D(m,g,v)}};super(d,f,l,p,I)}}e.OneDataSystemAppender=E}),define(ue[202],he([0,1,22,95,21,15,10,23,18,111,112,113]),function(ae,e,P,a,_,L,k,T,D,E,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let d=class{constructor(l,p,I,g,v,C){this.configurationService=l,this.telemetryService=p,this.logService=I,this.loggerService=g,this.environmentService=v,this.productService=C,this.customTelemetryServices=new Map}getCustomTelemetryService(l){if(!this.customTelemetryServices.has(l.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.telemetryService.machineId,p["common.vscodesessionid"]=this.telemetryService.sessionId;const I=[l.id,JSON.stringify(p),l.aiKey],v=new a.Client(P.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:I,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),C=[new E.TelemetryAppenderClient(v),new R.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${l.id}] `)];this.customTelemetryServices.set(l.id,new m.TelemetryService({appenders:C,sendErrorTelemetry:l.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(l.id)}publicLog(l,p,I){this.getCustomTelemetryService(l).publicLog(p,I)}publicLogError(l,p,I){this.getCustomTelemetryService(l).publicLogError(p,I)}};e.CustomEndpointTelemetryService=d,e.CustomEndpointTelemetryService=d=we([Q(0,_.IConfigurationService),Q(1,D.ITelemetryService),Q(2,k.ILogService),Q(3,k.ILoggerService),Q(4,L.IEnvironmentService),Q(5,T.IProductService)],d)}),define(ue[80],he([0,1,3,2,5,9,21,4,10]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=m,e.extractLocalHostUriMetaDataForPortMapping=f,e.extractQueryLocalHostUriMetaDataForPortMapping=l,e.isLocalhost=p,e.isAllInterfaces=I,e.isPortPrivileged=g,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var E;(function(S){S.Http="http",S.Https="https"})(E||(e.TunnelProtocol=E={}));var R;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(R||(e.TunnelPrivacyId=R={}));function m(S){return!!S.forwardPort}var d;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function f(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(c)return{address:c[1],port:+c[2]}}function l(S){if(S.scheme!=="http"&&S.scheme!=="https"||!S.query)return;const c=S.query.split("&");for(const u of c){const i=u.split("=")[1];if(/^https?:/.exec(i)){const n=f(L.URI.parse(i));if(n)return n}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}function g(S,c,u,i){if(u===_.OperatingSystem.Windows)return!1;if(u===_.OperatingSystem.Macintosh&&I(c)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(n?.length===4&&parseInt(n[1])>=18)return!1}return S<1024}class v{constructor(c,u,i){this.remoteAddress=c,this.localAddress=u,this._dispose=i,this._onDispose=new P.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let C=class extends a.Disposable{constructor(c,u){super(),this.logService=c,this.configurationService=u,this._onTunnelOpened=new P.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new P.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new P.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this._tunnelProvider=c,c?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this._canElevate=c.elevation,this._privacyOptions=c.privacyOptions,this._canChangeProtocol=c.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],u=Array.from(this._tunnels.values());for(const i of u){const n=Array.from(i.values());for(const t of n){const s=await t.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){super.dispose();for(const c of this._tunnels.values()){for(const{value:u}of c.values())await u.then(i=>typeof i!="string"?i?.dispose():void 0);c.clear()}this._tunnels.clear()}setEnvironmentTunnel(c,u,i,n,t){this.addTunnelToMap(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:i,privacy:n,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(I(c)||p(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const i=this.getTunnelFromMap(c,u);if(i)return++i.refcount,i.value}openTunnel(c,u,i,n,t,s=!1,r,o){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${i} on local port ${t}.`);const h=this._tunnelProvider??c;if(!h)return;if(u||(u="localhost"),n||(n=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(i)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.retainOrCreateTunnel(h,u,i,n,t,s,r,o);return y?y.then(A=>{if(A){if(typeof A=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(u,i),A}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(u,i);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.makeTunnel(A);return(A.tunnelRemoteHost!==u||A.tunnelRemotePort!==i)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&A.privacy!==r&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(b),b}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this._tunnels.get(c.tunnelRemoteHost);if(u){const i=u.get(c.tunnelRemotePort);i&&(i.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,i))}}}}async tryDisposeTunnel(c,u,i){if(i.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const n=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this._onTunnelClosed.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(u),n}}async closeTunnel(c,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const i=this._tunnels.get(c);if(i&&i.has(u)){const n=i.get(u);n.refcount=0,await this.tryDisposeTunnel(c,u,n)}}addTunnelToMap(c,u,i){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(u,{refcount:1,value:i})}async removeEmptyOrErrorTunnelFromMap(c,u){const i=this._tunnels.get(c);if(i){const n=i.get(u),t=n?await n.value:void 0;(!t||typeof t=="string")&&i.delete(u),i.size===0&&this._tunnels.delete(c)}}getTunnelFromMap(c,u){const i=[c];p(c)?(i.push(...e.LOCALHOST_ADDRESSES),i.push(...e.ALL_INTERFACES_ADDRESSES)):I(c)&&i.push(...e.ALL_INTERFACES_ADDRESSES);const n=i.map(t=>this._tunnels.get(t));for(const t of n){const s=t?.get(u);if(s)return s}}canTunnel(c){return!!f(c)}createWithProvider(c,u,i,n,t,s,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${i} on local port ${n}.`);const o=i;this._factoryInProgress.add(o);const h=n===void 0?i:n,y={elevationRequired:t?this.isPortPrivileged(h):!1},A={remoteAddress:{host:u,port:i},localAddressPort:n,privacy:s,public:s?s!==R.Private:void 0,protocol:r},b=c.forwardPort(A,y);return b?(this.addTunnelToMap(u,i,b),b.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),b}};e.AbstractTunnelService=C,e.AbstractTunnelService=C=we([Q(0,D.ILogService),Q(1,k.IConfigurationService)],C)}),define(ue[203],he([0,1,10,80,2,8,6]),function(ae,e,P,a,_,L,k){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class D extends _.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(m){this._address=m,this._addressPromise&&(this._addressPromise.complete(m),this._addressPromise=null)}setTunnel(m){this._register(m)}}let E=class extends _.Disposable{static{T=this}static{this._lastId=0}constructor(m,d){super(),this._tunnelService=m,this._logService=d,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(m=>m.dispose())}async createTunnel(){return{id:String(++T._lastId)}}async startTunnel(m,d,f,l,p,I,g){const v=new D,C=await Promise.resolve(this._tunnelService.openTunnel(m,v,f,l,p,I,g));if(!C||typeof C=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${l} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(d))throw this._disposedTunnels.delete(d),v.dispose(),await C.dispose(),(0,L.canceled)();return v.setTunnel(C),this._tunnels.set(d,v),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${d}: ${C.localAddress} (local) to ${f}:${l} (remote).`),{tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress}}async setAddress(m,d){const f=this._tunnels.get(m);f&&f.setAddress(d)}async destroyTunnel(m){const d=this._tunnels.get(m);if(d){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${m}.`),this._tunnels.delete(m),await d.dispose();return}this._disposedTunnels.add(m)}};e.SharedProcessTunnelService=E,e.SharedProcessTunnelService=E=T=we([Q(0,a.ISharedTunnelsService),Q(1,P.ILogService)],E)}),define(ue[28],he([0,1,4]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,P.createDecorator)("IUriIdentityService")}),define(ue[204],he([0,1,28,160,7,20,135,3,2]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{static{this._clock=0}constructor(d){this.uri=d,this.time=E._clock++}touch(){return this.time=E._clock++,this}}let R=class{constructor(d){this._fileService=d,this._dispooables=new D.DisposableStore,this._limit=2**16;const f=new Map,l=p=>{let I=f.get(p.scheme);return I===void 0&&(I=d.hasProvider(p)&&!this._fileService.hasCapability(p,_.FileSystemProviderCapabilities.PathCaseSensitive),f.set(p.scheme,I)),I};this._dispooables.add(T.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(p=>{f.delete(p.scheme)})),this.extUri=new L.ExtUri(l),this._canonicalUris=new k.SkipList((p,I)=>this.extUri.compare(p,I,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,L.normalizePath)(d));const f=this._canonicalUris.get(d);return f?f.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new E(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((l,p)=>l[1].time<p[1].time?1:l[1].time>p[1].time?-1:0);E._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let l=0;l<f;l++)this._canonicalUris.set(d[l][0],d[l][1].touch())}};e.UriIdentityService=R,e.UriIdentityService=R=we([Q(0,_.IFileService)],R),(0,a.registerSingleton)(P.IUriIdentityService,R,a.InstantiationType.Delayed)}),define(ue[205],he([0,1,3,2,7,51,31]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class T extends a.Disposable{constructor(E,R,m,d,f,l){super(),this.fileSystemScheme=E,this.fileSystemProvider=R,this.userDataScheme=m,this.userDataProfilesService=d,this.uriIdentityService=f,this.logService=l,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=L.TernarySearchTree.forUris(()=>!(this.capabilities&_.FileSystemProviderCapabilities.PathCaseSensitive)),this.atomicReadWriteResources=new k.ResourceSet(p=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(p))),this.updateAtomicReadWritesResources(),this._register(d.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const E of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(E.settingsResource),this.atomicReadWriteResources.add(E.keybindingsResource),this.atomicReadWriteResources.add(E.tasksResource),this.atomicReadWriteResources.add(E.extensionsResource)}open(E,R){return this.fileSystemProvider.open(this.toFileSystemResource(E),R)}close(E){return this.fileSystemProvider.close(E)}read(E,R,m,d,f){return this.fileSystemProvider.read(E,R,m,d,f)}write(E,R,m,d,f){return this.fileSystemProvider.write(E,R,m,d,f)}watch(E,R){this.watchResources.set(E,E);const m=this.fileSystemProvider.watch(this.toFileSystemResource(E),R);return(0,a.toDisposable)(()=>{this.watchResources.delete(E),m.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,R,m){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(R),m)}readFile(E,R){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),R)}readFileStream(E,R,m){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(E),R,m)}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}enforceAtomicReadFile(E){return this.atomicReadWriteResources.has(E)}writeFile(E,R,m){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),R,m)}enforceAtomicWriteFile(E){return this.atomicReadWriteResources.has(E)?{postfix:".vsctmp"}:!1}delete(E,R){return this.fileSystemProvider.delete(this.toFileSystemResource(E),R)}copy(E,R,m){if((0,_.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(E),this.toFileSystemResource(R),m);throw new Error("copy not supported")}cloneFile(E,R){if((0,_.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(E),this.toFileSystemResource(R));throw new Error("clone not supported")}handleFileChanges(E){const R=[];for(const m of E){if(m.resource.scheme!==this.fileSystemScheme)continue;const d=this.toUserDataResource(m.resource);this.watchResources.findSubstr(d)&&R.push({resource:d,type:m.type,cId:m.cId})}R.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(R))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=T}),define(ue[81],he([0,1,64]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.getLineStartOffset=_,e.getLineEndOffset=L;function a(k,T,D,E){const R=(0,P.setProperty)(k,T,D,E)[0];return R&&(k=k.substring(0,R.offset)+R.content+k.substring(R.offset+R.length)),k}function _(k,T,D){let E=D;for(;E>=0;){if(k.charAt(E)===T.charAt(T.length-1)&&T.length===1)return E+1;if(E--,T.length===2&&E>=0&&k.charAt(E)===T.charAt(0))return E+2}return 0}function L(k,T,D){let E=D;for(;E>=0;)if(k.charAt(E)===T.charAt(T.length-1)&&T.length===1||(E++,T.length===2&&E>=0&&k.charAt(E)===T.charAt(1)))return E;return k.length-1}}),define(ue[206],he([0,1,29,60,12]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=L,a=De(a);function L(f,l,p,I,g,v){const C=[],S=[],c=[];if(!l){const M=f.filter(({identifier:H})=>g.every(z=>z.toLowerCase()!==H.id.toLowerCase()));return{local:{added:C,removed:S,updated:c},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}f=f.map(m),l=l.map(m),p=p?p.map(m):null;const u=new Map,i=M=>{M.uuid&&u.set(M.id.toLowerCase(),M.uuid)};f.forEach(({identifier:M})=>i(M)),l.forEach(({identifier:M})=>i(M)),p?.forEach(({identifier:M})=>i(M)),I?.forEach(({identifier:M})=>i(M)),v?.forEach(M=>i(M));const n=M=>{const H=M.identifier.uuid||u.get(M.identifier.id.toLowerCase());return H?`uuid:${H}`:`id:${M.identifier.id.toLowerCase()}`},t=(M,H)=>(M.set(n(H),H),M),s=f.reduce(t,new Map),r=l.reduce(t,new Map),o=l.reduce((M,H)=>t(M,(0,P.deepClone)(H)),new Map),h=p?p.reduce(t,new Map):null,y=I.reduce(t,new Map),A=g.reduce((M,H)=>{const z=u.get(H.toLowerCase());return M.add(z?`uuid:${z}`:`id:${H.toLowerCase()}`)},new Set),b=v?v.reduce((M,{id:H,uuid:z})=>(z=z??u.get(H.toLowerCase()),M.add(z?`uuid:${z}`:`id:${H.toLowerCase()}`)),new Set):null,w=k(s,r,A,!1);if(w.added.size>0||w.removed.size>0||w.updated.size>0){const M=k(h,s,A,!1),H=k(h,r,A,!0),z=(J,V,te,$)=>{let q,Z,ne;return V.installed?(q=$.pinned,ne=$.preRelease,q&&(Z=$.version)):(q=te.pinned,ne=te.preRelease,q&&(Z=te.version)),q===void 0&&(q=V.pinned,q&&(Z=V.version)),ne===void 0&&(ne=V.preRelease),{...$,installed:V.installed||te.installed,pinned:q,preRelease:ne,version:Z??(te.version&&(!V.installed||a.gt(te.version,V.version))?te.version:V.version),state:D(V,te,h?.get(J))}};for(const J of H.removed.values()){const V=s.get(J);if(!V)continue;const te=(0,_.assertIsDefined)(h?.get(J)),$=b&&!b.has(J)&&te.installed;V.installed&&$?S.push(V.identifier):o.set(J,V)}for(const J of H.added.values()){const V=(0,_.assertIsDefined)(r.get(J)),te=s.get(J);if(te){if(w.updated.has(J)){const $=z(J,te,V,V);T(te,V,!1,!1)||c.push(d($,J)),o.set(J,$)}}else V.installed&&C.push(d(V,J))}for(const J of H.updated.values()){const V=(0,_.assertIsDefined)(r.get(J)),te=(0,_.assertIsDefined)(h?.get(J)),$=s.get(J);if($)if(b&&!b.has(J)&&te.installed&&$.installed&&!V.installed)S.push($.identifier);else{const Z=z(J,$,V,V);c.push(d(Z,J)),o.set(J,Z)}else V.installed&&C.push(d(V,J))}for(const J of M.added.values())H.added.has(J)||o.set(J,(0,_.assertIsDefined)(s.get(J)));for(const J of M.updated.values()){if(H.removed.has(J)||H.updated.has(J))continue;const V=(0,_.assertIsDefined)(s.get(J)),te=(0,_.assertIsDefined)(r.get(J));o.set(J,z(J,V,te,V))}for(const J of M.removed.values())H.updated.has(J)||H.removed.has(J)||y.has(J)||(0,_.assertIsDefined)(r.get(J)).installed&&b&&(b.has(J)||!(0,_.assertIsDefined)(h?.get(J)).installed||o.delete(J))}const O=[],N=k(r,o,new Set,!0),F=N.added.size>0||N.updated.size>0||N.removed.size>0;return F&&o.forEach((M,H)=>O.push(d(M,H))),{local:{added:C,removed:S,updated:c},remote:F?{added:[...N.added].map(M=>o.get(M)),updated:[...N.updated].map(M=>o.get(M)),removed:[...N.removed].map(M=>r.get(M)),all:O}:null}}function k(f,l,p,I){const g=f?[...f.keys()].filter(u=>!p.has(u)):[],v=[...l.keys()].filter(u=>!p.has(u)),C=v.filter(u=>!g.includes(u)).reduce((u,i)=>(u.add(i),u),new Set),S=g.filter(u=>!v.includes(u)).reduce((u,i)=>(u.add(i),u),new Set),c=new Set;for(const u of g){if(S.has(u))continue;const i=f.get(u),n=l.get(u);(!n||!T(i,n,I,!0))&&c.add(u)}return{added:C,removed:S,updated:c}}function T(f,l,p,I){return!(f.disabled!==l.disabled||!!f.isApplicationScoped!=!!l.isApplicationScoped||I&&f.installed!==l.installed||f.installed&&l.installed&&(f.preRelease!==l.preRelease||f.pinned!==l.pinned||l.pinned&&f.version!==l.version)||!R(f.state,l.state)||p&&f.version!==l.version)}function D(f,l,p){const I=f.state,g=l.state,v=p?.state;if(!l.version||I&&a.gt(f.version,l.version))return I;if(g&&a.gt(l.version,f.version)||!I)return g;if(!g)return I;const C=(0,P.deepClone)(I),S=v?E(v,g):{added:Object.keys(g).reduce((u,i)=>(u.add(i),u),new Set),removed:new Set,updated:new Set},c=v?E(v,I):{added:Object.keys(I).reduce((u,i)=>(u.add(i),u),new Set),removed:new Set,updated:new Set};for(const u of[...S.added.values(),...S.updated.values()])C[u]=g[u];for(const u of S.removed.values())c.updated.has(u)||delete C[u];return C}function E(f,l){const p=Object.keys(f),I=Object.keys(l),g=I.filter(S=>!p.includes(S)).reduce((S,c)=>(S.add(c),S),new Set),v=p.filter(S=>!I.includes(S)).reduce((S,c)=>(S.add(c),S),new Set),C=new Set;for(const S of p){if(v.has(S))continue;const c=f[S],u=l[S];(0,P.equals)(c,u)||C.add(S)}return{added:g,removed:v,updated:C}}function R(f={},l={}){const{added:p,removed:I,updated:g}=E(f,l);return p.size===0&&I.size===0&&g.size===0}function m(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function d(f,l){const p={...f,identifier:{id:f.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled||delete p.disabled,f.installed||delete p.installed,f.state||delete p.state,f.isApplicationScoped||delete p.isApplicationScoped,p}}),define(ue[114],he([0,1,17,21,4]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,_.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(T){this.configurationService=T}hasToNeverSyncExtension(T){return this.getConfiguredIgnoredExtensions().includes(T.toLowerCase())}hasToAlwaysSyncExtension(T){return this.getConfiguredIgnoredExtensions().includes(`-${T.toLowerCase()}`)}updateIgnoredExtensions(T,D){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return E=E.filter(R=>R!==T&&R!==`-${T}`),D&&E.push(T.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(T,D){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return E=E.filter(R=>R!==T&&R!==`-${T}`),D&&E.push(`-${T.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(T){const D=T.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),R=[],m=[];if(Array.isArray(E))for(const d of E)d.startsWith("-")?m.push(d.substring(1)):R.push(d);return(0,P.distinct)([...D,...R].filter(d=>!m.includes(d)))}getConfiguredIgnoredExtensions(){let T=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return T!==void 0||(T=this.configurationService.inspect("sync.ignoredExtensions").userValue,T!==void 0)?T:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(D=>D.toLowerCase())}};e.IgnoredExtensionsManagementService=L,e.IgnoredExtensionsManagementService=L=we([Q(0,a.IConfigurationService)],L)}),define(ue[207],he([0,1,17,36,29,96,81]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=D,_=De(_),k=De(k);function T(S){return(0,a.parse)(S)||[]}async function D(S,c,u,i,n){const t=T(S),s=T(c),r=u?T(u):null,o=[...t,...s,...r||[]].map(z=>z.key),h=await n.resolveUserBindings(o),y=R(t,s,r,h);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:S,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};const A=d(t),b=d(s),w=r?d(r):null,O=l(A,b,h),N=w?l(w,A,h):{added:[...A.keys()].reduce((z,J)=>(z.add(J),z),new Set),removed:new Set,updated:new Set},F=w?l(w,b,h):{added:[...b.keys()].reduce((z,J)=>(z.add(J),z),new Set),removed:new Set,updated:new Set},M=E(O,N,F);let H=S;for(const z of M.removed.values())M.conflicts.has(z)||(H=v(H,z,i));for(const z of M.added.values()){if(M.conflicts.has(z))continue;const J=b.get(z);if(J.some(V=>V.command!==`-${z}`&&y.conflicts.has(h[V.key]))){M.conflicts.add(z);continue}H=g(H,J,i)}for(const z of M.updated.values()){if(M.conflicts.has(z))continue;const J=b.get(z);if(J.some(V=>V.command!==`-${z}`&&y.conflicts.has(h[V.key]))){M.conflicts.add(z);continue}H=C(H,z,J,i)}return{mergeContent:H,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function E(S,c,u){const i=new Set,n=new Set,t=new Set,s=new Set;for(const r of c.removed.values())u.updated.has(r)&&s.add(r);for(const r of u.removed.values())s.has(r)||(c.updated.has(r)?s.add(r):n.add(r));for(const r of c.added.values())s.has(r)||u.added.has(r)&&S.updated.has(r)&&s.add(r);for(const r of u.added.values())s.has(r)||(c.added.has(r)?S.updated.has(r)&&s.add(r):i.add(r));for(const r of c.updated.values())s.has(r)||u.updated.has(r)&&S.updated.has(r)&&s.add(r);for(const r of u.updated.values())s.has(r)||(c.updated.has(r)?S.updated.has(r)&&s.add(r):t.add(r));return{added:i,removed:n,updated:t,conflicts:s}}function R(S,c,u,i){const n=new Set,t=m(S,i),s=m(c,i),r=u?m(u,i):null,o=f(t,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const h=r?f(r,t):{added:[...t.keys()].reduce((N,F)=>(N.add(F),N),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?f(r,s):{added:[...s.keys()].reduce((N,F)=>(N.add(F),N),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:A,removed:b,updated:w,conflicts:O}=E(o,h,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:b,updated:w,conflicts:O}}function m(S,c){const u=new Map;for(const i of S){const n=c[i.key];let t=u.get(n);t||(t=[],u.set(n,t)),t.push(i)}return u}function d(S){const c=new Map;for(const u of S){const i=u.command[0]==="-"?u.command.substring(1):u.command;let n=c.get(i);n||(n=[],c.set(i,n)),n.push(u)}return c}function f(S,c){const u=[...S.keys()],i=[...c.keys()],n=i.filter(r=>!u.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=u.filter(r=>!i.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),s=new Set;for(const r of u){if(t.has(r))continue;const o=S.get(r).map(y=>({...y,key:r})),h=c.get(r).map(y=>({...y,key:r}));(0,P.equals)(o,h,(y,A)=>I(y,A))||s.add(r)}return{added:n,removed:t,updated:s}}function l(S,c,u){const i=[...S.keys()],n=[...c.keys()],t=n.filter(o=>!i.includes(o)).reduce((o,h)=>(o.add(h),o),new Set),s=i.filter(o=>!n.includes(o)).reduce((o,h)=>(o.add(h),o),new Set),r=new Set;for(const o of i){if(s.has(o))continue;const h=S.get(o).map(A=>({...A,key:u[A.key]})),y=c.get(o).map(A=>({...A,key:u[A.key]}));p(h,y)||r.add(o)}return{added:t,removed:s,updated:r}}function p(S,c){return!(!(0,P.equals)(S.filter(({command:u})=>u[0]!=="-"),c.filter(({command:u})=>u[0]!=="-"),(u,i)=>I(u,i))||!(0,P.equals)(S.filter(({command:u})=>u[0]==="-"),c.filter(({command:u})=>u[0]==="-"),(u,i)=>I(u,i)))}function I(S,c){if(S.command!==c.command||S.key!==c.key)return!1;const u=L.ContextKeyExpr.deserialize(S.when),i=L.ContextKeyExpr.deserialize(c.when);return!(u&&!i||!u&&i||u&&i&&!u.equals(i)||!_.equals(S.args,c.args))}function g(S,c,u){for(const i of c)S=k.edit(S,[-1],i,u);return S}function v(S,c,u){const i=T(S);for(let n=i.length-1;n>=0;n--)(i[n].command===c||i[n].command===`-${c}`)&&(S=k.edit(S,[n],void 0,u));return S}function C(S,c,u,i){const n=T(S),t=n.findIndex(s=>s.command===c||s.command===`-${c}`);for(let s=n.length-1;s>=0;s--)(n[s].command===c||n[s].command===`-${c}`)&&(S=k.edit(S,[s],void 0,i));for(let s=u.length-1;s>=0;s--)S=k.edit(S,[t],u[s],i);return S}}),define(ue[208],he([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=P,e.areSame=_;function P(L,k,T){const D={},E={},R=new Set;if(!k)return{local:{added:D,updated:E,removed:[...R.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const m=a(L,k);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{local:{added:D,updated:E,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=a(T,L),f=a(T,k),l={},p={},I=new Set,g=new Set;for(const v of d.removed.values())f.updated.has(v)?D[v]=k[v]:I.add(v);for(const v of f.removed.values())g.has(v)||(d.updated.has(v)?g.add(v):R.add(v));for(const v of d.updated.values())g.has(v)||(f.updated.has(v)?m.updated.has(v)&&g.add(v):p[v]=L[v]);for(const v of f.updated.values())g.has(v)||(d.updated.has(v)?m.updated.has(v)&&g.add(v):L[v]!==void 0&&(E[v]=k[v]));for(const v of d.added.values())g.has(v)||(f.added.has(v)?m.updated.has(v)&&g.add(v):l[v]=L[v]);for(const v of f.added.values())g.has(v)||(d.added.has(v)?m.updated.has(v)&&g.add(v):D[v]=k[v]);return{local:{added:D,removed:[...R.values()],updated:E},remote:{added:l,removed:[...I.values()],updated:p},conflicts:[...g.values()]}}function a(L,k){const T=L?Object.keys(L):[],D=k?Object.keys(k):[],E=D.filter(d=>!T.includes(d)).reduce((d,f)=>(d.add(f),d),new Set),R=T.filter(d=>!D.includes(d)).reduce((d,f)=>(d.add(f),d),new Set),m=new Set;for(const d of T){if(R.has(d))continue;const f=L[d],l=k[d];f!==l&&m.add(d)}return{added:E,removed:R,updated:m}}function _(L,k){const{added:T,removed:D,updated:E}=a(L,k);return T.size===0&&D.size===0&&E.size===0}}),define(ue[209],he([0,1,29]),function(ae,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=a;function a(L,k,T,D){const E={added:[],removed:[],updated:[]};let R={added:[],removed:[],updated:[]};if(!k){const d=L.filter(({id:f})=>!D.includes(f));return d.length?R.added=d:R=null,{local:E,remote:R}}const m=_(L,k,D);if(m.added.length>0||m.removed.length>0||m.updated.length>0){const d=_(T,L,D),f=_(T,k,D);for(const l of f.removed){const p=L.find(I=>I.id===l);p&&E.removed.push(p)}for(const l of f.added){const p=k.find(I=>I.id===l);d.added.includes(l)?m.updated.includes(l)&&E.updated.push(p):E.added.push(p)}for(const l of f.updated)E.updated.push(k.find(p=>p.id===l));for(const l of d.added)f.added.includes(l)||R.added.push(L.find(p=>p.id===l));for(const l of d.updated)f.removed.includes(l)||f.updated.includes(l)||R.updated.push(L.find(p=>p.id===l));for(const l of d.removed){const p=k.find(I=>I.id===l);p&&R.removed.push(p)}}return R.added.length===0&&R.removed.length===0&&R.updated.length===0&&(R=null),{local:E,remote:R}}function _(L,k,T){L=L?L.filter(({id:f})=>!T.includes(f)):[],k=k.filter(({id:f})=>!T.includes(f));const D=L.map(({id:f})=>f),E=k.map(({id:f})=>f),R=E.filter(f=>!D.includes(f)),m=D.filter(f=>!E.includes(f)),d=[];for(const{id:f,name:l,shortName:p,icon:I,useDefaultFlags:g}of L){if(m.includes(f))continue;const v=k.find(C=>C.id===f);(!v||v.name!==l||v.shortName!==p||v.icon!==I||!(0,P.equals)(v.useDefaultFlags,g))&&d.push(f)}return{added:R,removed:m,updated:d}}}),define(ue[24],he([0,1,17,12,11,47,27,4,103,44]),function(ae,e,P,a,_,L,k,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=void 0,e.getDisallowedIgnoredSettings=R,e.getDefaultIgnoredSettings=m,e.getIgnoredSettingsForExtension=d,e.registerConfiguration=l,e.isAuthenticationProvider=p,e.getPathSegments=g,e.getLastSyncResourceUri=v,e.createSyncHeaders=C,e.getEnablementKey=r;function R(){const o=E.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(h=>!!o[h].disallowSyncIgnore)}function m(o=!1){const h=E.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),y=f(h,o),A=R();return(0,P.distinct)([...y,...A])}function d(o){if(!o.contributes?.configuration)return[];const h=Array.isArray(o.contributes.configuration)?o.contributes.configuration:[o.contributes.configuration];if(!h.length)return[];const y=(0,L.getAllConfigurationProperties)(h);return f(y,!1)}function f(o,h){const y=new Set;for(const A in o){if(h&&o[A].source)continue;const b=(0,a.isString)(o[A].scope)?(0,L.parseScope)(o[A].scope):o[A].scope;(o[A].ignoreSync||b===L.ConfigurationScope.MACHINE||b===L.ConfigurationScope.MACHINE_OVERRIDABLE)&&y.add(A)}return[...y.values()]}e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function l(){const o="vscode://schemas/ignoredSettings",h=E.Registry.as(L.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,_.localize)(11061,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,_.localize)(11062,null),default:!0,scope:L.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,_.localize)(11063,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,_.localize)(11064,null)}],default:[],scope:L.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,_.localize)(11065,null),default:[],scope:L.ConfigurationScope.APPLICATION,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=E.Registry.as(D.Extensions.JSONContribution),A=()=>{const b=R(),w=m(),O=Object.keys(L.allSettings.properties).filter(M=>!w.includes(M)),N=w.filter(M=>!b.includes(M)),F={items:{type:"string",enum:[...O,...N.map(M=>`-${M}`)]}};y.registerSchema(o,F)};return h.onDidUpdateConfiguration(()=>A())}function p(o){return o&&(0,a.isObject)(o)&&(0,a.isString)(o.id)&&Array.isArray(o.scopes)}var I;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles",o.WorkspaceState="workspaceState"})(I||(e.SyncResource=I={})),e.ALL_SYNC_RESOURCES=[I.Settings,I.Keybindings,I.Snippets,I.Tasks,I.Extensions,I.GlobalState,I.Profiles];function g(o,...h){return o?[o,...h]:h}function v(o,h,y,A){return A.joinPath(y.userDataSyncHome,...g(o,h,`lastSync${h}.json`))}e.IUserDataSyncStoreManagementService=(0,T.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,T.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,T.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function C(o){const h={};return h[e.HEADER_EXECUTION_ID]=o,h}var S;(function(o){o.Unauthorized="Unauthorized",o.Forbidden="Forbidden",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})(S||(e.UserDataSyncErrorCode=S={}));class c extends Error{constructor(h,y,A,b){super(h),this.code=y,this.resource=A,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=c;class u extends c{constructor(h,y,A,b,w){super(h,A,void 0,w),this.url=y,this.serverCode=b}}e.UserDataSyncStoreError=u;class i extends c{constructor(h,y){super(h,y)}}e.UserDataAutoSyncError=i,function(o){function h(y){if(y instanceof o)return y;const A=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(A&&A[1]){const b=A[2]==="unknown"?void 0:A[2],w=A[3]==="unknown"?void 0:A[3];return new o(y.message,A[1],b,w)}return new o(y.message,S.Unknown)}o.toUserDataSyncError=h}(c||(e.UserDataSyncError=c={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var t;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(t||(e.Change=t={}));var s;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(s||(e.MergeState=s={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(o){return`sync.enable.${o}`}e.IUserDataSyncEnablementService=(0,T.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,T.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,T.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,T.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,T.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,T.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ue[210],he([0,1,29,24]),function(ae,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=_,P=De(P);function _(k,T,D,E,R){if(!T)return{remote:{added:Object.keys(k),removed:[],updated:[],all:Object.keys(k).length>0?k:null},local:{added:{},removed:[],updated:{}}};const m=L(k,T);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const d=D?L(D,T):{added:Object.keys(T).reduce((v,C)=>(v.add(C),v),new Set),removed:new Set,updated:new Set},f=D?L(D,k):{added:Object.keys(k).reduce((v,C)=>(v.add(C),v),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},p=P.deepClone(T),I=!D;for(const v of f.added.values())v!==a.SYNC_SERVICE_URL_TYPE&&I&&d.added.has(v)||(p[v]=k[v]);for(const v of f.updated.values())p[v]=k[v];for(const v of f.removed.values())E.unregistered.includes(v)||delete p[v];for(const v of d.added.values()){const C=T[v];if(E.machine.includes(v)){R.info(`GlobalState: Skipped adding ${v} in local storage because it is declared as machine scoped.`);continue}if(D&&f.added.has(v))continue;const S=k[v];S&&S.value===C.value||v===a.SYNC_SERVICE_URL_TYPE&&I&&f.added.has(v)||(S?l.updated[v]=C:l.added[v]=C)}for(const v of d.updated.values()){const C=T[v];if(E.machine.includes(v)){R.info(`GlobalState: Skipped updating ${v} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(v)||f.removed.has(v))continue;const S=k[v];S&&S.value===C.value||(l.updated[v]=C)}for(const v of d.removed.values()){if(E.machine.includes(v)){R.trace(`GlobalState: Skipped removing ${v} in local storage because it is declared as machine scoped.`);continue}f.updated.has(v)||f.removed.has(v)||l.removed.push(v)}const g=L(T,p);return{local:l,remote:{added:[...g.added],updated:[...g.updated],removed:[...g.removed],all:g.added.size===0&&g.removed.size===0&&g.updated.size===0?null:p}}}function L(k,T){const D=Object.keys(k),E=Object.keys(T),R=E.filter(f=>!D.includes(f)).reduce((f,l)=>(f.add(l),f),new Set),m=D.filter(f=>!E.includes(f)).reduce((f,l)=>(f.add(l),f),new Set),d=new Set;for(const f of D){if(m.has(f))continue;const l=k[f],p=T[f];P.equals(l,p)||d.add(f)}return{added:R,removed:m,updated:d}}}),define(ue[211],he([0,1,17,36,64,45,29,81,24]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getIgnoredSettings=E,e.removeComments=d,e.updateIgnoredSettings=f,e.merge=l,e.isEmpty=I,e.addSetting=v,k=De(k),T=De(T);function E(o,h,y){let A=[];y?A=m(y):A=R(h);const b=[],w=[...(0,D.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const O of A)O.startsWith("-")?w.push(O.substring(1)):b.push(O);return(0,P.distinct)([...o,...b].filter(O=>!w.includes(O)))}function R(o){let h=o.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=o.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:o.getValue("settingsSync.ignoredSettings")||[]}function m(o){const h=(0,a.parse)(o);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function d(o,h){const y=(0,a.parse)(o)||{};let A="{}";for(const b of Object.keys(y)){const w=(0,_.setProperty)(A,[b],y[b],h);A=(0,_.applyEdits)(A,w)}return A}function f(o,h,y,A){if(y.length){const b=r(h),w=(0,a.parse)(h)||{},O=(0,a.parse)(o);if(!O)return o;const N=[];for(const F of y){const M=w[F],H=O[F];M===void 0?o=T.edit(o,[F],void 0,A):H!==void 0?o=T.edit(o,[F],M,A):N.push(u(F,b))}N.sort((F,M)=>F.startOffset-M.startOffset),N.forEach(F=>o=v(F.setting.key,h,o,A))}return o}function l(o,h,y,A,b,w){const O=f(o,h,A,w),N=y!==O,F=y!==h;if(!N&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!F)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(F&&!N)return{conflictsSettings:[],localContent:f(h,o,A,w),remoteContent:null,hasConflicts:!1};if(y===null&&I(o)){const U=p(o,h,A)?null:f(h,o,A,w);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let M=o,H=h;const z=(0,a.parse)(o),J=(0,a.parse)(h),V=y?(0,a.parse)(y):null,te=A.reduce((U,Y)=>(U.add(Y),U),new Set),$=g(z,J,te),q=g(V,z,te),Z=g(V,J,te),ne=new Map,le=new Set,ee=U=>{le.add(U);const Y=b.filter(({key:oe})=>oe===U)[0];Y?(M=T.edit(M,[U],Y.value,w),H=T.edit(H,[U],Y.value,w)):ne.set(U,{key:U,localValue:z[U],remoteValue:J[U]})};for(const U of q.removed.values())Z.updated.has(U)?ee(U):H=T.edit(H,[U],void 0,w);for(const U of Z.removed.values())le.has(U)||(q.updated.has(U)?ee(U):M=T.edit(M,[U],void 0,w));for(const U of q.updated.values())le.has(U)||(Z.updated.has(U)?$.updated.has(U)&&ee(U):H=T.edit(H,[U],z[U],w));for(const U of Z.updated.values())le.has(U)||(q.updated.has(U)?$.updated.has(U)&&ee(U):M=T.edit(M,[U],J[U],w));for(const U of q.added.values())le.has(U)||(Z.added.has(U)?$.updated.has(U)&&ee(U):H=v(U,M,H,w));for(const U of Z.added.values())le.has(U)||(q.added.has(U)?$.updated.has(U)&&ee(U):M=v(U,H,M,w));const X=ne.size>0||!p(M,H,A),K=X||!p(M,o,[]),W=X||!p(H,h,[]);return{localContent:K?M:null,remoteContent:W?H:null,conflictsSettings:[...ne.values()],hasConflicts:X}}function p(o,h,y){if(o===h)return!0;const A=(0,a.parse)(o),b=(0,a.parse)(h),w=y.reduce((F,M)=>(F.add(M),F),new Set),O=r(o).filter(F=>!(F.setting&&w.has(F.setting.key))),N=r(h).filter(F=>!(F.setting&&w.has(F.setting.key)));if(O.length!==N.length)return!1;for(let F=0;F<O.length;F++){const M=O[F],H=N[F];if(M.setting&&H.setting){if(M.setting.key!==H.setting.key||!k.equals(A[M.setting.key],b[M.setting.key]))return!1}else if(!M.setting&&!H.setting){if(M.value!==H.value)return!1}else return!1}return!0}function I(o){return o?r(o).length===0:!0}function g(o,h,y){const A=o?Object.keys(o).filter(F=>!y.has(F)):[],b=Object.keys(h).filter(F=>!y.has(F)),w=b.filter(F=>!A.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),O=A.filter(F=>!b.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),N=new Set;if(o)for(const F of A){if(O.has(F))continue;const M=o[F],H=h[F];k.equals(M,H)||N.add(F)}return{added:w,removed:O,updated:N}}function v(o,h,y,A){const b=(0,a.parse)(h),w=r(h),O=r(y),N=C(o,w,O);return S(y,o,b[o],N,O,A)}function C(o,h,y){const A=h.findIndex(w=>w.setting?.key===o),b=h[A-1];if(b){if(b.setting){const O=u(b.setting.key,y);if(O)return{index:y.indexOf(O),insertAfter:!0}}else{const O=i(A,h);if(O){const N=u(O.setting.key,y);if(N){const F=n(y.indexOf(N),y),M=t(h,O,h[A]);if(F){const H=t(y,N,F),z=s(M,H);return z?{index:y.indexOf(z),insertAfter:!0}:{index:y.indexOf(F),insertAfter:!1}}else{const H=t(y,N,y[y.length-1]),z=s(M,H);return z?{index:y.indexOf(z),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const w=h[A+1];if(w)if(w.setting){const O=u(w.setting.key,y);if(O)return{index:y.indexOf(O),insertAfter:!1}}else{const O=n(A,h);if(O){const N=u(O.setting.key,y);if(N){const F=i(y.indexOf(N),y),M=t(h,h[A],O);if(F){const H=t(y,F,N),z=s(M.reverse(),H.reverse());return z?{index:y.indexOf(z),insertAfter:!1}:{index:y.indexOf(F),insertAfter:!0}}else{const H=t(y,y[0],N),z=s(M.reverse(),H.reverse());return z?{index:y.indexOf(z),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function S(o,h,y,A,b,w){let O;return A.index===-1?O=(0,_.setProperty)(o,[h],y,w):O=c(o,h,y,A,b,w).map(N=>(0,_.withFormatting)(o,N,w)[0]),(0,_.applyEdits)(o,O)}function c(o,h,y,A,b,w){const O=`${JSON.stringify(h)}: ${JSON.stringify(y)}`,N=(0,L.getEOL)(w,o),F=b[A.index];if(A.insertAfter){const M=[];if(F.setting)M.push({offset:F.endOffset,length:0,content:","+O});else{const H=n(A.index,b),z=i(A.index,b),J=z?.setting?.commaOffset;z&&J===void 0&&M.push({offset:z.endOffset,length:0,content:","});const V=J!==void 0&&J>F.endOffset;M.push({offset:V?J+1:F.endOffset,length:0,content:H?N+O+",":N+O})}return M}else{if(F.setting)return[{offset:F.startOffset,length:0,content:O+","}];const M=(b[A.index-1]&&!b[A.index-1].setting?N:"")+O+(n(A.index,b)?",":"")+N;return[{offset:F.startOffset,length:0,content:M}]}}function u(o,h){return h.filter(y=>y.setting?.key===o)[0]}function i(o,h){for(let y=o-1;y>=0;y--)if(h[y].setting)return h[y]}function n(o,h){for(let y=o+1;y<h.length;y++)if(h[y].setting)return h[y]}function t(o,h,y){const A=o.indexOf(h),b=o.indexOf(y);return o.filter((w,O)=>A<O&&O<b)}function s(o,h){if(o.length&&h.length){let y=0;for(;y<h.length&&y<o.length;y++)if(o[y].value!==h[y].value)return h[y-1];return h[y-1]}}function r(o){const h=[];let y=-1,A,b;const w={onObjectBegin:O=>{y++},onObjectProperty:(O,N,F)=>{y===0&&(A=N,b=O)},onObjectEnd:(O,N)=>{y--,y===0&&h.push({startOffset:A,endOffset:O+N,value:o.substring(A,O+N),setting:{key:b,commaOffset:void 0}})},onArrayBegin:(O,N)=>{y++},onArrayEnd:(O,N)=>{y--,y===0&&h.push({startOffset:A,endOffset:O+N,value:o.substring(A,O+N),setting:{key:b,commaOffset:void 0}})},onLiteralValue:(O,N,F)=>{y===0&&h.push({startOffset:A,endOffset:N+F,value:o.substring(A,N+F),setting:{key:b,commaOffset:void 0}})},onSeparator:(O,N,F)=>{if(y===0&&O===","){let M=h.length-1;for(;M>=0&&!h[M].setting;M--);const H=h[M];H&&h.splice(M,1,{startOffset:H.startOffset,endOffset:H.endOffset,value:H.value,setting:{key:H.setting.key,commaOffset:N}})}},onComment:(O,N)=>{y===0&&h.push({startOffset:O,endOffset:O+N,value:o.substring(O,O+N)})}};return(0,a.visit)(o,w),h}}),define(ue[82],he([0,1,3,2,4,24]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,_.createDecorator)("IUserDataSyncAccountService");let k=class extends a.Disposable{get account(){return this._account}constructor(D,E){super(),this.userDataSyncStoreService=D,this.logService=E,this._onDidChangeAccount=this._register(new P.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new P.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(D.onTokenFailed(R=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,R),this.updateAccount(void 0),R===L.UserDataSyncErrorCode.Forbidden?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(D.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(D){(D&&this._account?D.token!==this._account.token||D.authenticationProviderId!==this._account.authenticationProviderId:D!==this._account)&&(this._account=D,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(D))}};e.UserDataSyncAccountService=k,e.UserDataSyncAccountService=k=we([Q(0,L.IUserDataSyncStoreService),Q(1,L.IUserDataSyncLogService)],k)}),define(ue[212],he([0,1,20,11,15,10,24]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let T=class extends L.AbstractLogger{constructor(E,R){super(),this.logger=this._register(E.createLogger((0,P.joinPath)(R.logsHome,`${k.USER_DATA_SYNC_LOG_ID}.log`),{id:k.USER_DATA_SYNC_LOG_ID,name:(0,a.localize)(11060,null)}))}trace(E,...R){this.logger.trace(E,...R)}debug(E,...R){this.logger.debug(E,...R)}info(E,...R){this.logger.info(E,...R)}warn(E,...R){this.logger.warn(E,...R)}error(E,...R){this.logger.error(E,...R)}flush(){this.logger.flush()}};e.UserDataSyncLogService=T,e.UserDataSyncLogService=T=we([Q(0,L.ILoggerService),Q(1,_.IEnvironmentService)],T)}),define(ue[213],he([0,1,6,3,2]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends _.Disposable{constructor({onDidOpenMainWindow:T,onDidFocusMainWindow:D,getActiveWindowId:E}){super(),this.disposables=this._register(new _.DisposableStore),a.Event.latch(a.Event.any(T,D))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,P.createCancelablePromise)(()=>E()),(async()=>{try{const m=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:m}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(T){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=T}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ue[115],he([0,1,11,13,51,20,9,4,22]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=E,e.isEmptyWorkspaceIdentifier=R,e.toWorkspaceIdentifier=m,e.isWorkspaceIdentifier=d,e.reviveIdentifier=f,e.isWorkspace=p,e.isWorkspaceFolder=I,e.toWorkspaceFolder=C,e.isUntitledWorkspace=S,e.isTemporaryWorkspace=c,e.isStandaloneEditorWorkspace=u,e.isSavedWorkspace=i,e.hasWorkspaceFileExtension=n,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function E(t){const s=t;return typeof s?.id=="string"&&k.URI.isUri(s.uri)}function R(t){return typeof t?.id=="string"&&!E(t)&&!d(t)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function m(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,a.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function d(t){const s=t;return typeof s?.id=="string"&&k.URI.isUri(s.configPath)}function f(t){const s=t;if(s?.uri)return{id:s.id,uri:k.URI.revive(s.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:k.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function p(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function I(t){const s=t;return!!(s&&typeof s=="object"&&k.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class g{constructor(s,r,o,h,y){this._id=s,this._transient=o,this._configuration=h,this._ignorePathCasing=y,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class v{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function C(t){return new v({uri:t,index:0,name:(0,L.basenameOrAuthority)(t)},{uri:t.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,P.localize)(11031,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(t,s){return L.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}function c(t){let s;return k.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===D.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function u(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function i(t,s){return!S(t,s)&&!c(t)}function n(t){return(typeof t=="string"?(0,a.extname)(t):(0,L.extname)(t))===e.WORKSPACE_SUFFIX}}),define(ue[19],he([0,1,55,3,2,20,9,11,15,7,4,10,115,31,28,6,32,26,12]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=S,e.reviveProfile=c,e.toUserDataProfile=u;var C;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(C||(e.ProfileResourceType=C={}));function S(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&k.URI.isUri(s.location)&&k.URI.isUri(s.globalStorageHome)&&k.URI.isUri(s.settingsResource)&&k.URI.isUri(s.keybindingsResource)&&k.URI.isUri(s.tasksResource)&&k.URI.isUri(s.snippetsHome)&&k.URI.isUri(s.extensionsResource))}e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function c(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:k.URI.revive(t.location).with({scheme:s}),globalStorageHome:k.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:k.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:k.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:k.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:k.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:k.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:k.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function u(t,s,r,o,h,y){return{id:t,name:s,location:r,isDefault:!1,shortName:h?.shortName,icon:h?.icon,globalStorageHome:y&&h?.useDefaultFlags?.globalState?y.globalStorageHome:(0,L.joinPath)(r,"globalStorage"),settingsResource:y&&h?.useDefaultFlags?.settings?y.settingsResource:(0,L.joinPath)(r,"settings.json"),keybindingsResource:y&&h?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,L.joinPath)(r,"keybindings.json"),tasksResource:y&&h?.useDefaultFlags?.tasks?y.tasksResource:(0,L.joinPath)(r,"tasks.json"),snippetsHome:y&&h?.useDefaultFlags?.snippets?y.snippetsHome:(0,L.joinPath)(r,"snippets"),extensionsResource:y&&h?.useDefaultFlags?.extensions?y.extensionsResource:(0,L.joinPath)(r,"extensions.json"),cacheHome:(0,L.joinPath)(o,t),useDefaultFlags:h?.useDefaultFlags,isTransient:h?.transient}}let i=class extends _.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(s,r,o,h){super(),this.environmentService=s,this.fileService=r,this.uriIdentityService=o,this.logService=h,this.enabled=!0,this._onDidChangeProfiles=this._register(new a.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new a.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new a.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new a.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new f.ResourceMap,workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,L.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(s){this.enabled!==s&&(this._profilesObject=void 0,this.enabled=s)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const s=this.createDefaultProfile(),r=[s];if(this.enabled)try{for(const y of this.getStoredProfiles()){if(!y.name||!(0,v.isString)(y.name)||!y.location){this.logService.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(u((0,L.basename)(y.location),y.name,y.location,this.profilesCacheHome,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},s))}}catch(y){this.logService.error(y)}const o=new f.ResourceMap,h=new Map;if(r.length)try{const y=this.getStoredProfileAssociations();if(y.workspaces)for(const[A,b]of Object.entries(y.workspaces)){const w=k.URI.parse(A),O=r.find(N=>N.id===b);O&&o.set(w,O)}if(y.emptyWindows)for(const[A,b]of Object.entries(y.emptyWindows)){const w=r.find(O=>O.id===b);w&&h.set(A,w)}}catch(y){this.logService.error(y)}this._profilesObject={profiles:r,workspaces:o,emptyWindows:h}}return this._profilesObject}createDefaultProfile(){const s=u("__default__profile__",(0,T.localize)(11078,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...s,extensionsResource:this.getDefaultProfileExtensionsLocation()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",o=new RegExp(`${(0,g.escapeRegExpCharacters)(r)}\\s(\\d+)`);let h=0;for(const A of this.profiles){const b=o.exec(A.name),w=b?parseInt(b[1]):0;h=w>h?w:h}const y=`${r} ${h+1}`;return this.createProfile((0,P.hash)((0,I.generateUuid)()).toString(16),y,{transient:!0},s)}async createNamedProfile(s,r,o){return this.createProfile((0,P.hash)((0,I.generateUuid)()).toString(16),s,r,o)}async createProfile(s,r,o,h){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const y=await this.doCreateProfile(s,r,o);return h&&await this.setProfileForWorkspace(h,y),y}async doCreateProfile(s,r,o){if(!(0,v.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let h=this.profileCreationPromises.get(r);return h||(h=(async()=>{try{if(this.profiles.find(w=>w.name===r||w.id===s))throw new Error(`Profile with ${r} name already exists`);const A=u(s,r,(0,L.joinPath)(this.profilesHome,s),this.profilesCacheHome,o,this.defaultProfile);await this.fileService.createFolder(A.location);const b=[];return this._onWillCreateProfile.fire({profile:A,join(w){b.push(w)}}),await p.Promises.settled(b),this.updateProfiles([A],[],[]),A}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,h)),h}async updateProfile(s,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(h=>h.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);return o=u(o.id,r.name??o.name,o.location,this.profilesCacheHome,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[o]),o}async removeProfile(s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(h=>h.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(h){o.push(h)}});try{await Promise.allSettled(o)}catch(h){this.logService.error(h)}for(const h of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(h)?.id&&this.profilesObject.emptyWindows.delete(h);for(const h of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(h)?.id&&this.profilesObject.workspaces.delete(h);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(h){(0,E.toFileOperationResult)(h)!==E.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(h)}}async setProfileForWorkspace(s,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(h=>h.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(s,o)}unsetWorkspace(s,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(s,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const s=await this.fileService.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const s=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.getWorkspace(s),o=k.URI.isUri(r)?this.profilesObject.workspaces.get(r):this.profilesObject.emptyWindows.get(r);return o||((0,d.isSingleFolderWorkspaceIdentifier)(s)?this.transientProfilesObject.folders.get(s.uri):(0,d.isWorkspaceIdentifier)(s)?this.transientProfilesObject.workspaces.get(s.configPath):this.transientProfilesObject.emptyWindows.get(s.id))}getWorkspace(s){return(0,d.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,d.isWorkspaceIdentifier)(s)?s.configPath:s.id}isProfileAssociatedToWorkspace(s){return!!([...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,s.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,s.location))||[...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,s.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,s.location))||[...this.transientProfilesObject.folders.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,s.location)))}updateProfiles(s,r,o){const h=[...this.profiles,...s],y=[],A=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let b of h){if(b.isDefault||r.some(O=>b.id===O.id))continue;b=o.find(O=>b.id===O.id)??b;const w=A.find(O=>b.id===O.id);if(b.isTransient)this.transientProfilesObject.profiles.push(b);else{if(w){for(const[O,N]of this.transientProfilesObject.emptyWindows.entries())if(b.id===N.id){this.updateWorkspaceAssociation({id:O},b);break}for(const[O,N]of this.transientProfilesObject.workspaces.entries())if(b.id===N.id){this.updateWorkspaceAssociation({id:"",configPath:O},b);break}for(const[O,N]of this.transientProfilesObject.folders.entries())if(b.id===N.id){this.updateWorkspaceAssociation({id:"",uri:O},b);break}}y.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags})}}this.saveStoredProfiles(y),this._profilesObject=void 0,this.triggerProfilesChanges(s,r,o)}triggerProfilesChanges(s,r,o){this._onDidChangeProfiles.fire({added:s,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(s,r,o){if(o=r?.isTransient?!0:o,o)(0,d.isSingleFolderWorkspaceIdentifier)(s)?(this.transientProfilesObject.folders.delete(s.uri),r&&this.transientProfilesObject.folders.set(s.uri,r)):(0,d.isWorkspaceIdentifier)(s)?(this.transientProfilesObject.workspaces.delete(s.configPath),r&&this.transientProfilesObject.workspaces.set(s.configPath,r)):(this.transientProfilesObject.emptyWindows.delete(s.id),r&&this.transientProfilesObject.emptyWindows.set(s.id,r));else{this.updateWorkspaceAssociation(s,void 0,!0);const h=this.getWorkspace(s);k.URI.isUri(h)?(this.profilesObject.workspaces.delete(h),r&&this.profilesObject.workspaces.set(h,r)):(this.profilesObject.emptyWindows.delete(h),r&&this.profilesObject.emptyWindows.set(h,r)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const s={};for(const[o,h]of this.profilesObject.workspaces.entries())s[o.toString()]=h.id;const r={};for(const[o,h]of this.profilesObject.emptyWindows.entries())r[o.toString()]=h.id;this.saveStoredProfileAssociations({workspaces:s,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(s){const r={},o=this.createDefaultProfile();if(s.workspaces)for(const[y,A]of Object.entries(s.workspaces)){const b=k.URI.parse(A);r[y]=this.uriIdentityService.extUri.isEqual(b,o.location)?o.id:this.uriIdentityService.extUri.basename(b)}const h={};if(s.emptyWindows)for(const[y,A]of Object.entries(s.emptyWindows)){const b=k.URI.parse(A);h[y]=this.uriIdentityService.extUri.isEqual(b,o.location)?o.id:this.uriIdentityService.extUri.basename(b)}return{workspaces:r,emptyWindows:h}}getStoredProfiles(){return[]}saveStoredProfiles(s){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(s){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=i,e.UserDataProfilesService=i=we([Q(0,D.IEnvironmentService),Q(1,E.IFileService),Q(2,l.IUriIdentityService),Q(3,m.ILogService)],i);class n extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(s){this.storedProfiles=s}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(s){this.storedProfileAssociations=s}}e.InMemoryUserDataProfilesService=n}),define(ue[214],he([0,1,6,2,19]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let L=class extends a.Disposable{constructor(T){super(),this._register(new P.RunOnceScheduler(()=>{T.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=L,e.UserDataProfilesCleaner=L=we([Q(0,_.IUserDataProfilesService)],L)}),define(ue[83],he([0,1,17,6,25,8,3,2,31,5,12,9,11,27,35,34,59,10,23,18,28,19]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.toExtensionManagementError=i,d=De(d);let u=class extends T.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(r,o,h,y,A,b){super(),this.galleryService=r,this.telemetryService=o,this.uriIdentityService=h,this.logService=y,this.productService=A,this.userDataProfilesService=b,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(({task:w})=>w.cancel()),this.uninstallingExtensions.forEach(w=>w.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(h=>(0,f.isTargetPlatformCompatible)(h,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{const y=(await this.installGalleryExtensions([{extension:r,options:o}])).find(({identifier:A})=>(0,l.areSameExtensions)(A,r.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new f.ExtensionManagementError(`Unknown error while installing extension ${r.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(h){throw i(h)}}async installGalleryExtensions(r){if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(d.localize(11504,null),f.ExtensionManagementErrorCode.NotAllowed);const o=[],h=[];return await Promise.allSettled(r.map(async({extension:y,options:A})=>{try{const b=await this.checkAndGetCompatibleVersion(y,!!A?.installGivenVersion,!!A?.installPreReleaseVersion,A.productVersion??{version:this.productService.version,date:this.productService.date});h.push({...b,options:A})}catch(b){o.push({identifier:y.identifier,operation:f.InstallOperation.Install,source:y,error:b,profileLocation:A.profileLocation??this.getCurrentExtensionsManifestLocation()})}})),h.length&&o.push(...await this.installExtensions(h)),o}async uninstall(r,o){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtensions([{extension:r,options:o}])}async toggleAppliationScope(r,o){if((0,p.isApplicationScopedExtension)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let h=await this.updateMetadata(r,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)||(h=await this.copyExtension(r,this.userDataProfilesService.defaultProfile.extensionsResource,o));for(const y of this.userDataProfilesService.profiles){const A=(await this.getInstalled(p.ExtensionType.User,y.extensionsResource)).find(b=>(0,l.areSameExtensions)(b.identifier,r.identifier));A?this._onDidUpdateExtensionMetadata.fire({local:A,profileLocation:y.extensionsResource}):this._onDidUninstallExtension.fire({identifier:r.identifier,profileLocation:y.extensionsResource})}return h}else{const h=this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(r,o,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:h.identifier,operation:f.InstallOperation.Install,local:h,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),h}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async resetPinnedStateForAllUserExtensions(r){try{await this.joinAllSettled(this.userDataProfilesService.profiles.map(async o=>{const h=await this.getInstalled(p.ExtensionType.User,o.extensionsResource);await this.joinAllSettled(h.map(async y=>{y.pinned!==r&&await this.updateMetadata(y,{pinned:r},o.extensionsResource)}))}))}catch(o){throw this.logService.error("Error while resetting pinned state for all user extensions",(0,L.getErrorMessage)(o)),o}}async installExtensions(r){const o=new Map,h=new Map,y=[],A=(w,O)=>`${l.ExtensionKey.create(w).toString()}-${O.toString()}`,b=(w,O,N,F)=>{const M=this.createInstallExtensionTask(w,O,N),H=`${(0,l.getGalleryExtensionId)(w.publisher,w.name)}-${N.profileLocation.toString()}`;h.set(H,{task:M,root:F}),this._onInstallExtension.fire({identifier:M.identifier,source:O,profileLocation:N.profileLocation}),this.logService.info("Installing extension:",M.identifier.id,N),m.URI.isUri(O)||this.installingExtensions.set(A(O,N.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:w,extension:O,options:N}of r){const F=N.isApplicationScoped||N.isBuiltin||(0,p.isApplicationScopedExtension)(w),M={...N,installOnlyNewlyAddedFromExtensionPack:N.installOnlyNewlyAddedFromExtensionPack??!m.URI.isUri(O),isApplicationScoped:F,profileLocation:F?this.userDataProfilesService.defaultProfile.extensionsResource:N.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:N.productVersion??{version:this.productService.version,date:this.productService.date}},H=m.URI.isUri(O)?void 0:this.installingExtensions.get(A(O,M.profileLocation));H?(this.logService.info("Extension is already requested to install",H.task.identifier.id,M.profileLocation.toString()),y.push(H.task.waitUntilTaskIsFinished())):b(w,O,M,void 0)}return await Promise.all([...h.values()].map(async({task:w})=>{if(w.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",w.identifier.id);else try{const O=await this.getAllDepsAndPackExtensions(w.identifier,w.manifest,!!w.options.installOnlyNewlyAddedFromExtensionPack,!!w.options.installPreReleaseVersion,w.options.profileLocation,w.options.productVersion),N=await this.getInstalled(void 0,w.options.profileLocation,w.options.productVersion),F={...w.options,context:{...w.options.context,[f.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:M,manifest:H}of(0,P.distinct)(O,({gallery:z})=>z.identifier.id)){if(h.has(`${M.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`))continue;const z=this.installingExtensions.get(A(M,F.profileLocation));if(z){if(this.canWaitForTask(w,z.task)){const J=z.task.identifier;this.logService.info("Waiting for already requested installing extension",J.id,w.identifier.id,F.profileLocation.toString()),z.waitingTasks.push(w),y.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,V=>V.some(te=>(0,l.areSameExtensions)(te.identifier,J)))).then(V=>{if(this.logService.info("Finished waiting for already requested installing extension",J.id,w.identifier.id,F.profileLocation.toString()),!V.find($=>(0,l.areSameExtensions)($.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else N.some(({identifier:J})=>(0,l.areSameExtensions)(J,M.identifier))||b(H,M,F,w)}}catch(O){if(m.URI.isUri(w.source))(0,P.isNonEmptyArray)(w.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",w.identifier.id,O.message),(0,P.isNonEmptyArray)(w.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",w.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",w.identifier.id),O}})),await this.joinAllSettled([...h.entries()].map(async([w,{task:O}])=>{const N=new Date().getTime();let F;try{F=await O.run(),await this.joinAllSettled(this.participants.map(M=>M.postInstall(F,O.source,O.options,_.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(M){const H=i(M);throw m.URI.isUri(O.source)||n(this.telemetryService,O.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.getGalleryExtensionTelemetryData)(O.source),error:H,source:O.options.context?.[f.EXTENSION_INSTALL_SOURCE_CONTEXT]}),o.set(w,{error:H,identifier:O.identifier,operation:O.operation,source:O.source,context:O.options.context,profileLocation:O.options.profileLocation,applicationScoped:O.options.isApplicationScoped}),this.logService.error("Error while installing the extension",O.identifier.id,(0,L.getErrorMessage)(H),O.options.profileLocation.toString()),H}if(!m.URI.isUri(O.source)){const M=O.operation===f.InstallOperation.Update,H=M?void 0:(new Date().getTime()-O.source.lastUpdated)/1e3;if(n(this.telemetryService,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.getGalleryExtensionTelemetryData)(O.source),verificationStatus:O.verificationStatus,duration:new Date().getTime()-N,durationSinceUpdate:H,source:O.options.context?.[f.EXTENSION_INSTALL_SOURCE_CONTEXT]}),E.isWeb&&O.operation!==f.InstallOperation.Update)try{await this.galleryService.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,f.StatisticType.Install)}catch{}}o.set(w,{local:F,identifier:O.identifier,operation:O.operation,source:O.source,context:O.options.context,profileLocation:O.options.profileLocation,applicationScoped:F.isApplicationScoped})})),y.length&&await this.joinAllSettled(y),[...o.values()]}catch(w){const O=(M,H,z)=>{const J=[];M.manifest.extensionDependencies?.length&&J.push(...M.manifest.extensionDependencies),M.manifest.extensionPack?.length&&J.push(...M.manifest.extensionPack);for(const V of J){if(z.includes(V.toLowerCase()))continue;z.push(V.toLowerCase());const te=o.get(`${V.toLowerCase()}-${H.toString()}`);te?.local&&(z=O(te.local,H,z))}return z},N=M=>({identifier:M.identifier,operation:f.InstallOperation.Install,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,error:w}),F=[];for(const[M,{task:H,root:z}]of h){const J=o.get(M);J?J.local&&z&&!o.get(`${z.identifier.id.toLowerCase()}-${H.options.profileLocation.toString()}`)?.local&&(F.push(this.createUninstallExtensionTask(J.local,{versionOnly:!0,profileLocation:H.options.profileLocation})),o.set(M,N(H))):(H.cancel(),o.set(M,N(H)))}for(const[M,{task:H}]of h){const z=o.get(M);if(!z?.local||H.options.donotIncludePackAndDependencies)continue;O(z.local,H.options.profileLocation,[z.local.identifier.id.toLowerCase()]).slice(1).some(V=>h.has(`${V.toLowerCase()}-${H.options.profileLocation.toString()}`)&&!o.get(`${V.toLowerCase()}-${H.options.profileLocation.toString()}`)?.local)&&(F.push(this.createUninstallExtensionTask(z.local,{versionOnly:!0,profileLocation:H.options.profileLocation})),o.set(M,N(H)))}throw F.length&&await Promise.allSettled(F.map(async M=>{try{await M.run(),this.logService.info("Rollback: Uninstalled extension",M.extension.identifier.id)}catch(H){this.logService.warn("Rollback: Error while uninstalling extension",M.extension.identifier.id,(0,L.getErrorMessage)(H))}})),w}finally{for(const{task:w}of h.values())w.source&&!m.URI.isUri(w.source)&&this.installingExtensions.delete(A(w.source,w.options.profileLocation));if(o.size){const w=[...o.values()];for(const O of w)O.local&&this.logService.info("Extension installed successfully:",O.identifier.id,O.profileLocation.toString());this._onDidInstallExtensions.fire(w)}}}canWaitForTask(r,o){for(const[,{task:h,waitingTasks:y}]of this.installingExtensions.entries())if(h===r&&(y.includes(o)||y.some(A=>this.canWaitForTask(A,o)))||h===o&&y[0]&&!this.canWaitForTask(r,y[0]))return!1;return!0}async joinAllSettled(r,o){const h=[],y=[],A=await Promise.allSettled(r);for(const w of A)w.status==="fulfilled"?h.push(w.value):y.push(i(w.reason,o));if(!y.length)return h;if(y.length===1)throw y[0];let b=new f.ExtensionManagementError("",f.ExtensionManagementErrorCode.Unknown);for(const w of y)b=new f.ExtensionManagementError(b.message?`${b.message}, ${w.message}`:w.message,w.code!==f.ExtensionManagementErrorCode.Unknown&&w.code!==f.ExtensionManagementErrorCode.Internal?w.code:b.code);throw b}async getAllDepsAndPackExtensions(r,o,h,y,A,b){if(!this.galleryService.isEnabled())return[];const w=await this.getInstalled(void 0,A,b),O=[],N=[],F=async(M,H)=>{O.push(M);const z=H.extensionDependencies||[],J=[...z];if(H.extensionPack){const V=h?w.find(te=>(0,l.areSameExtensions)(te.identifier,M)):void 0;for(const te of H.extensionPack)V&&V.manifest.extensionPack&&V.manifest.extensionPack.some($=>(0,l.areSameExtensions)({id:$},{id:te}))||J.every($=>!(0,l.areSameExtensions)({id:$},{id:te}))&&J.push(te)}if(J.length){const V=J.filter(te=>O.every($=>!(0,l.areSameExtensions)($,{id:te})));if(V.length){const te=await this.galleryService.getExtensions(V.map($=>({id:$,preRelease:y})),_.CancellationToken.None);for(const $ of te){if(O.find(ne=>(0,l.areSameExtensions)(ne,$.identifier)))continue;const q=z.some(ne=>(0,l.areSameExtensions)({id:ne},$.identifier));let Z;try{Z=await this.checkAndGetCompatibleVersion($,!1,y,b)}catch(ne){if(q)throw ne;this.logService.info("Skipping the packed extension as it cannot be installed",$.identifier.id,(0,L.getErrorMessage)(ne));continue}N.push({gallery:Z.extension,manifest:Z.manifest}),await F(Z.extension.identifier,Z.manifest)}}}};return await F(r,o),N}async checkAndGetCompatibleVersion(r,o,h,y){let A;const b=await this.getExtensionsControlManifest();if(b.malicious.some(N=>(0,l.areSameExtensions)(r.identifier,N)))throw new f.ExtensionManagementError(d.localize(11505,null,r.identifier.id),f.ExtensionManagementErrorCode.Malicious);const w=b.deprecated[r.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.logService.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),A=(await this.galleryService.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},_.CancellationToken.None))[0],!A)throw new f.ExtensionManagementError(d.localize(11506,null,r.identifier.id,w.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const N=await this.getTargetPlatform();throw new f.ExtensionManagementError(d.localize(11507,null,r.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(N)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(A=await this.getCompatibleVersion(r,o,h,y),!A){const N=[];throw(0,I.areApiProposalsCompatible)(r.properties.enabledApiProposals??[],N)?!h&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],_.CancellationToken.None))[0]?new f.ExtensionManagementError(d.localize(11509,null,r.displayName??r.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(d.localize(11510,null,r.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible):new f.ExtensionManagementError(d.localize(11508,null,r.displayName??r.identifier.id,N[0]),f.ExtensionManagementErrorCode.IncompatibleApi)}}this.logService.info("Getting Manifest...",A.identifier.id);const O=await this.galleryService.getManifest(A,_.CancellationToken.None);if(O===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${A.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(O.version!==A.version)throw new f.ExtensionManagementError(`Cannot install '${A.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:A,manifest:O}}async getCompatibleVersion(r,o,h,y){const A=await this.getTargetPlatform();let b=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==h&&(b=(await this.galleryService.getExtensions([{...r.identifier,preRelease:h}],{targetPlatform:A,compatible:!0,productVersion:y},_.CancellationToken.None))[0]||null),!b&&await this.galleryService.isExtensionCompatible(r,h,A,y)&&(b=r),b||(o?b=(await this.galleryService.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:A,compatible:!0,productVersion:y},_.CancellationToken.None))[0]||null:b=await this.galleryService.getCompatibleExtension(r,h,A,y)),b}async uninstallExtensions(r){const o=(N,F)=>`${N.identifier.id.toLowerCase()}${F.versionOnly?`-${N.manifest.version}`:""}@${F.profileLocation.toString()}`,h=(N,F)=>{const M=this.createUninstallExtensionTask(N,F);return this.uninstallingExtensions.set(o(M.extension,F),M),this.logService.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,F.profileLocation.toString()),this._onUninstallExtension.fire({identifier:N.identifier,profileLocation:F.profileLocation,applicationScoped:N.isApplicationScoped}),M},y=(N,F,M)=>{M?this.logService.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,F.profileLocation.toString(),M.message):this.logService.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,F.profileLocation.toString()),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,l.getLocalExtensionTelemetryData)(N),error:M}),this._onDidUninstallExtension.fire({identifier:N.identifier,error:M?.code,profileLocation:F.profileLocation,applicationScoped:N.isApplicationScoped})},A=[],b=[],w=[],O=new D.ResourceMap;for(const{extension:N,options:F}of r){const M={...F,profileLocation:N.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:F?.profileLocation??this.getCurrentExtensionsManifestLocation()},H=this.uninstallingExtensions.get(o(N,M));H?(this.logService.info("Extensions is already requested to uninstall",N.identifier.id),w.push(H.waitUntilTaskIsFinished())):A.push(h(N,M))}try{for(const N of A.slice(0)){let F=O.get(N.options.profileLocation);if(F||O.set(N.options.profileLocation,F=await this.getInstalled(p.ExtensionType.User,N.options.profileLocation)),N.options.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${N.extension.identifier.id}@${N.extension.manifest.version}`);else{const M=this.getAllPackExtensionsToUninstall(N.extension,F);for(const H of M)this.uninstallingExtensions.has(o(H,N.options))?this.logService.info("Extensions is already requested to uninstall",H.identifier.id):A.push(h(H,N.options))}N.options.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${N.extension.identifier.id}@${N.extension.manifest.version}`):this.checkForDependents(A.map(M=>M.extension),F,N.extension)}await this.joinAllSettled(A.map(async N=>{try{if(await N.run(),await this.joinAllSettled(this.participants.map(F=>F.postUninstall(N.extension,N.options,_.CancellationToken.None))),N.extension.identifier.uuid)try{await this.galleryService.reportStatistic(N.extension.manifest.publisher,N.extension.manifest.name,N.extension.manifest.version,f.StatisticType.Uninstall)}catch{}}catch(F){const M=i(F);throw y(N.extension,N.options,M),M}finally{b.push(N)}})),w.length&&await this.joinAllSettled(w);for(const N of A)y(N.extension,N.options)}catch(N){const F=i(N);for(const M of A){try{M.cancel()}catch{}b.includes(M)||y(M.extension,M.options,F)}throw F}finally{for(const N of A)this.uninstallingExtensions.delete(o(N.extension,N.options))||this.logService.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}checkForDependents(r,o,h){for(const y of r){const A=this.getDependents(y,o);if(A.length){const b=A.filter(w=>!r.some(O=>(0,l.areSameExtensions)(O.identifier,w.identifier)));if(b.length)throw new Error(this.getDependentsErrorMessage(y,b,h))}}}getDependentsErrorMessage(r,o,h){return h===r?o.length===1?d.localize(11511,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?d.localize(11512,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):d.localize(11513,null,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?d.localize(11514,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?d.localize(11515,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):d.localize(11516,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(r,o,h=[]){if(h.indexOf(r)!==-1)return[];h.push(r);const y=r.manifest.extensionPack?r.manifest.extensionPack:[];if(y.length){const A=o.filter(w=>!w.isBuiltin&&y.some(O=>(0,l.areSameExtensions)({id:O},w.identifier))),b=[];for(const w of A)b.push(...this.getAllPackExtensionsToUninstall(w,o,h));return[...A,...b]}return[]}getDependents(r,o){return o.filter(h=>h.manifest.extensionDependencies&&h.manifest.extensionDependencies.some(y=>(0,l.areSameExtensions)({id:y},r.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(r){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.getErrorMessage)(r)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=u,e.AbstractExtensionManagementService=u=we([Q(0,f.IExtensionGalleryService),Q(1,C.ITelemetryService),Q(2,S.IUriIdentityService),Q(3,g.ILogService),Q(4,v.IProductService),Q(5,c.IUserDataProfilesService)],u);function i(s,r){if(s instanceof f.ExtensionManagementError)return s;let o;return s instanceof f.ExtensionGalleryError?o=new f.ExtensionManagementError(s.message,s.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):o=new f.ExtensionManagementError(s.message,(0,L.isCancellationError)(s)?f.ExtensionManagementErrorCode.Cancelled:r??f.ExtensionManagementErrorCode.Internal),o.stack=s.stack,o}function n(s,r,{extensionData:o,verificationStatus:h,duration:y,error:A,source:b,durationSinceUpdate:w}){let O,N;(0,R.isDefined)(h)&&(h===!0?h="Verified":(h===!1||(O=f.ExtensionManagementErrorCode.Signature,N=h),h="Unverified")),A&&(O=A.code,A.code===f.ExtensionManagementErrorCode.Signature&&(N=A.message)),s.publicLog(r,{...o,verificationStatus:h,success:!A,duration:y,errorcode:O,errorcodeDetail:N,durationSinceUpdate:w,source:b})}class t{constructor(){this.barrier=new a.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,a.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,a.createCancelablePromise)(r=>new Promise((o,h)=>{const y=r.onCancellationRequested(()=>{y.dispose(),h(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(ue[52],he([0,1,6,14,2,3,31,9,27,35,7,4,10,19,28,12,8,18]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var v;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(v||(e.ExtensionsProfileScanningErrorCode=v={}));class C extends Error{constructor(n,t){super(n),this.code=t}}e.ExtensionsProfileScanningError=C,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let S=class extends _.Disposable{constructor(n,t,s,r,o,h){super(),this.extensionsLocation=n,this.fileService=t,this.userDataProfilesService=s,this.uriIdentityService=r,this.telemetryService=o,this.logService=h,this._onAddExtensions=this._register(new L.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new L.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new L.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new L.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(n,t){return this.withProfileExtensions(n,void 0,t)}async addExtensionsToProfile(n,t,s){const r=[],o=[];try{return await this.withProfileExtensions(t,h=>{const y=[];if(s)y.push(...h);else for(const A of h)n.some(([b])=>(0,E.areSameExtensions)(b.identifier,A.identifier)&&b.manifest.version!==A.version)?r.push(A):y.push(A);for(const[A,b]of n){const w=y.findIndex(N=>(0,E.areSameExtensions)(N.identifier,A.identifier)&&N.version===A.manifest.version),O={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:b};w===-1?(o.push(O),y.push(O)):y.splice(w,1,O)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:t}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:t}),y}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:t}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:t}),o}catch(h){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:h,profileLocation:t}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:h,profileLocation:t}),h}}async updateMetadata(n,t){const s=[];return await this.withProfileExtensions(t,r=>{const o=[];for(const h of r){const y=n.find(([A])=>(0,E.areSameExtensions)(A.identifier,h.identifier)&&A.manifest.version===h.version);y&&(h.metadata={...h.metadata,...y[1]},s.push(h)),o.push(h)}return o}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.withProfileExtensions(t,r=>{const o=[];for(const h of r)(0,E.areSameExtensions)(h.identifier,n.identifier)?s.push(h):o.push(h);return s.length&&this._onRemoveExtensions.fire({extensions:s,profileLocation:t}),o}),s.length&&this._onDidRemoveExtensions.fire({extensions:s,profileLocation:t})}catch(r){throw s.length&&this._onDidRemoveExtensions.fire({extensions:s,error:r,profileLocation:t}),r}}async withProfileExtensions(n,t,s){return this.getResourceAccessQueue(n).queue(async()=>{let r=[],o;try{const h=await this.fileService.readFile(n);o=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,R.toFileOperationResult)(h)!==R.FileOperationResult.FILE_NOT_FOUND)throw h;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(o=await this.migrateFromOldDefaultProfileExtensionsLocation()),!o&&s?.bailOutWhenFileNotFound)throw new C((0,I.getErrorMessage)(h),v.ERROR_PROFILE_NOT_FOUND)}if(o){Array.isArray(o)||this.reportAndThrowInvalidConentError(n);let h=!1;for(const y of o){c(y)||this.reportAndThrowInvalidConentError(n);let A;if((0,p.isString)(y.relativeLocation)&&y.relativeLocation)A=this.resolveExtensionLocation(y.relativeLocation);else if((0,p.isString)(y.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${y.location}`);continue}else{A=T.URI.revive(y.location);const b=this.toRelativePath(A);b&&(h=!0,y.relativeLocation=b)}(0,p.isUndefined)(y.metadata?.hasPreReleaseVersion)&&y.metadata?.preRelease&&(h=!0,y.metadata.hasPreReleaseVersion=!0),r.push({identifier:y.identifier,location:A,version:y.version,metadata:y.metadata})}h&&await this.fileService.writeFile(n,a.VSBuffer.fromString(JSON.stringify(o)))}if(t){r=t(r);const h=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.toRelativePath(y.location),metadata:y.metadata}));await this.fileService.writeFile(n,a.VSBuffer.fromString(JSON.stringify(h)))}return r})}reportAndThrowInvalidConentError(n){const t=new C(`Invalid extensions content in ${n.toString()}`,v.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),t=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let s;try{s=(await this.fileService.readFile(n)).value.toString()}catch(o){if((0,R.toFileOperationResult)(o)===R.FileOperationResult.FILE_NOT_FOUND)return;throw o}this.logService.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(s);Array.isArray(o)&&o.every(h=>c(h))?r=o:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.logService.error(o)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,a.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(o){if((0,R.toFileOperationResult)(o)===R.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw o}try{await this.fileService.del(n)}catch(o){(0,R.toFileOperationResult)(o)!==R.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(o)}try{await this.fileService.del(t)}catch(o){(0,R.toFileOperationResult)(o)!==R.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(o)}return r})()),this._migrationPromise}getResourceAccessQueue(n){let t=this.resourcesAccessQueueMap.get(n);return t||(t=new P.Queue,this.resourcesAccessQueueMap.set(n,t)),t}};e.AbstractExtensionsProfileScannerService=S,e.AbstractExtensionsProfileScannerService=S=we([Q(1,R.IFileService),Q(2,f.IUserDataProfilesService),Q(3,l.IUriIdentityService),Q(4,g.ITelemetryService),Q(5,d.ILogService)],S);function c(i){return(0,p.isObject)(i)&&(0,D.isIExtensionIdentifier)(i.identifier)&&(u(i.location)||(0,p.isString)(i.location)&&i.location)&&((0,p.isUndefined)(i.relativeLocation)||(0,p.isString)(i.relativeLocation))&&i.version&&(0,p.isString)(i.version)}function u(i){return i?(0,p.isString)(i.path)&&(0,p.isString)(i.scheme):!1}});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ue[84],he([0,1,17,6,29,14,8,36,152,2,22,13,5,20,60,92,12,9,11,15,35,34,59,7,4,10,23,3,66,52,19,28,157]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S,c,u,i,n,t,s,r,o,h,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=H,_=De(_),m=De(m),d=De(d),l=De(l),p=it(p);var w;(function(J){function V(te,$){if(te===$)return!0;const q=Object.keys(te),Z=new Set;for(const ne of Object.keys($))Z.add(ne);if(q.length!==Z.size)return!1;for(const ne of q){if(te[ne]!==$[ne])return!1;Z.delete(ne)}return Z.size===0}J.equals=V})(w||(e.Translations=w={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let O=class extends E.Disposable{constructor(V,te,$,q,Z,ne,le,ee,X,K,W,U){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=te,this.extensionsControlLocation=$,this.currentProfile=q,this.userDataProfilesService=Z,this.extensionsProfileScannerService=ne,this.fileService=le,this.logService=ee,this.environmentService=X,this.productService=K,this.uriIdentityService=W,this.instantiationService=U,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(M,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(M,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(F,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(c.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(c.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,S.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,te,$){const[q,Z]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(te)]),ne=$?await this.scanExtensionsUnderDevelopment(V,[...q,...Z]):[];return this.dedupExtensions(q,Z,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const te=[];te.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),te.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[$,q]=await Promise.all(te);return this.applyScanOptions([...$,...q],c.ExtensionType.System,V,!1)}async scanUserExtensions(V){const te=V.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",te);const $=this.uriIdentityService.extUri.isEqual(V.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.createExtensionScannerInput(te,!!V.profileLocation,c.ExtensionType.User,!V.includeUninstalled,V.language,!0,$,V.productVersion??this.getProductVersion()),Z=V.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ne;try{ne=await Z.scanExtensions(q)}catch(le){if(le instanceof h.ExtensionsProfileScanningError&&le.code===h.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),ne=await Z.scanExtensions(q);else throw le}return ne=await this.applyScanOptions(ne,c.ExtensionType.User,V,!0),this.logService.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(V,te){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const $=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(q=>q.scheme===R.Schemas.file).map(async q=>{const Z=await this.createExtensionScannerInput(q,!1,c.ExtensionType.User,!0,V.language,!1,void 0,V.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(Z)).map(le=>(le.type=te.find(ee=>(0,S.areSameExtensions)(ee.identifier,le.identifier))?.type??le.type,this.extensionsScanner.validate(le,Z)))}))).flat();return this.applyScanOptions($,"development",V,!0)}return[]}async scanExistingExtension(V,te,$){const q=await this.createExtensionScannerInput(V,!1,te,!0,$.language,!0,void 0,$.productVersion??this.getProductVersion()),Z=await this.extensionsScanner.scanExtension(q);return!Z||!$.includeInvalid&&!Z.isValid?null:Z}async scanOneOrMultipleExtensions(V,te,$){const q=await this.createExtensionScannerInput(V,!1,te,!0,$.language,!0,void 0,$.productVersion??this.getProductVersion()),Z=await this.extensionsScanner.scanOneOrMultipleExtensions(q);return this.applyScanOptions(Z,te,$,!0)}async scanMultipleExtensions(V,te,$){const q=[];return await Promise.all(V.map(async Z=>{const ne=await this.scanOneOrMultipleExtensions(Z,te,$);q.push(...ne)})),this.applyScanOptions(q,te,$,!0)}async scanMetadata(V){const te=(0,f.joinPath)(V,"package.json"),$=(await this.fileService.readFile(te)).value.toString();return JSON.parse($).__metadata}async updateMetadata(V,te){const $=(0,f.joinPath)(V,"package.json"),q=(await this.fileService.readFile($)).value.toString(),Z=JSON.parse(q);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,Z.__metadata={...Z.__metadata,...te},await this.fileService.writeFile((0,f.joinPath)(V,"package.json"),L.VSBuffer.fromString(JSON.stringify(Z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof h.ExtensionsProfileScanningError&&V.code===h.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw V}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.extensionsProfileScannerService.addExtensionsToProfile(V.map(te=>[te,te.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify([])))}catch(te){(0,i.toFileOperationResult)(te)!==i.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(te))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.logService.error(V)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(V,te,$,q){return $.includeAllVersions||(V=this.dedupExtensions(te===c.ExtensionType.System?V:void 0,te===c.ExtensionType.User?V:void 0,te==="development"?V:void 0,await this.getTargetPlatform(),q)),$.includeInvalid||(V=V.filter(Z=>Z.isValid)),V.sort((Z,ne)=>{const le=m.basename(Z.location.fsPath),ee=m.basename(ne.location.fsPath);return le<ee?-1:le>ee?1:0})}dedupExtensions(V,te,$,q,Z){const ne=(ee,X,K)=>{if(ee.isValid&&!X.isValid)return!1;if(ee.isValid===X.isValid){if(Z&&l.gt(ee.manifest.version,X.manifest.version))return this.logService.debug(`Skipping extension ${X.location.path} with lower version ${X.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(l.eq(ee.manifest.version,X.manifest.version)){if(ee.type===c.ExtensionType.System)return this.logService.debug(`Skipping extension ${X.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===q)return this.logService.debug(`Skipping extension ${X.location.path} from different target platform ${X.targetPlatform}`),!1}}return K?this.logService.warn(`Overwriting user extension ${ee.location.path} with ${X.location.path}.`):this.logService.debug(`Overwriting user extension ${ee.location.path} with ${X.location.path}.`),!0},le=new c.ExtensionIdentifierMap;return V?.forEach(ee=>{const X=le.get(ee.identifier.id);(!X||ne(X,ee,!1))&&le.set(ee.identifier.id,ee)}),te?.forEach(ee=>{const X=le.get(ee.identifier.id);if(!X&&V&&ee.type===c.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!X||ne(X,ee,!1))&&le.set(ee.identifier.id,ee)}),$?.forEach(ee=>{const X=le.get(ee.identifier.id);(!X||ne(X,ee,!0))&&le.set(ee.identifier.id,ee),le.set(ee.identifier.id,ee)}),[...le.values()]}async scanDefaultSystemExtensions(V,te){this.logService.trace("Started scanning system extensions");const $=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,c.ExtensionType.System,!0,te,!0,void 0,this.getProductVersion()),Z=await(V&&!$.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions($);return this.logService.trace("Scanned system extensions:",Z.length),Z}async scanDevSystemExtensions(V,te){const $=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!$?.length)return[];this.logService.trace("Started scanning dev system extensions");const q=te?await this.getBuiltInExtensionControl():{},Z=[],ne=g.URI.file(m.normalize(m.join(R.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of $){const X=q[ee.name]||"marketplace";switch(X){case"disabled":break;case"marketplace":Z.push((0,f.joinPath)(ne,ee.name));break;default:Z.push(g.URI.file(X));break}}const le=await Promise.all(Z.map(async ee=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ee,!1,c.ExtensionType.System,!0,V,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",le.length),(0,P.coalesce)(le)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,te,$,q,Z,ne,le,ee){const X=await this.getTranslations(Z??d.language),K=await this.getMtime(V),W=te&&!this.uriIdentityService.extUri.isEqual(V,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,U=W?await this.getMtime(W):void 0;return new N(V,K,W,U,te,le,$,q,ne,ee.version,ee.date,this.productService.commit,!this.environmentService.isBuilt,Z,X)}async getMtime(V){try{const te=await this.fileService.stat(V);if(typeof te.mtime=="number")return te.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=O,e.AbstractExtensionsScannerService=O=we([Q(4,y.IUserDataProfilesService),Q(5,h.IExtensionsProfileScannerService),Q(6,i.IFileService),Q(7,t.ILogService),Q(8,C.IEnvironmentService),Q(9,s.IProductService),Q(10,A.IUriIdentityService),Q(11,n.IInstantiationService)],O);class N{constructor(V,te,$,q,Z,ne,le,ee,X,K,W,U,Y,oe,x){this.location=V,this.mtime=te,this.applicationExtensionslocation=$,this.applicationExtensionslocationMtime=q,this.profile=Z,this.profileScanOptions=ne,this.type=le,this.excludeObsolete=ee,this.validate=X,this.productVersion=K,this.productDate=W,this.productCommit=U,this.devMode=Y,this.language=oe,this.translations=x}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,te){return(0,f.isEqual)(V.location,te.location)&&V.mtime===te.mtime&&(0,f.isEqual)(V.applicationExtensionslocation,te.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&V.profile===te.profile&&_.equals(V.profileScanOptions,te.profileScanOptions)&&V.type===te.type&&V.excludeObsolete===te.excludeObsolete&&V.validate===te.validate&&V.productVersion===te.productVersion&&V.productDate===te.productDate&&V.productCommit===te.productCommit&&V.devMode===te.devMode&&V.language===te.language&&w.equals(V.translations,te.translations)}}e.ExtensionScannerInput=N;let F=class extends E.Disposable{constructor(V,te,$,q,Z,ne,le){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=te,this.uriIdentityService=$,this.fileService=q,this.environmentService=ne,this.logService=le,this.extensionsEnabledWithApiProposalVersion=Z.extensionsEnabledWithApiProposalVersion?.map(ee=>ee.toLowerCase())??[]}async scanExtensions(V){const te=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let $={};if(V.excludeObsolete&&V.type===c.ExtensionType.User)try{const q=(await this.fileService.readFile(this.obsoleteFile)).value.toString();$=JSON.parse(q)}catch{}return(0,I.isEmptyObject)($)?te:te.filter(q=>!$[S.ExtensionKey.create(q).toString()])}async scanExtensionsFromLocation(V){const te=await this.fileService.resolve(V.location);if(!te.children?.length)return[];const $=await Promise.all(te.children.map(async q=>{if(!q.isDirectory||V.type===c.ExtensionType.User&&(0,f.basename)(q.resource).indexOf(".")===0)return null;const Z=new N(q.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(Z)}));return(0,P.coalesce)($).sort((q,Z)=>q.location.path<Z.location.path?-1:1)}async scanExtensionsFromProfile(V){let te=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){te=te.filter(q=>!q.metadata?.isApplicationScoped);const $=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,V);te.push(...$)}return te}async scanExtensionsFromProfileResource(V,te,$){const q=await this.extensionsProfileScannerService.scanProfileExtensions(V,$.profileScanOptions);if(!q.length)return[];const Z=await Promise.all(q.map(async ne=>{if(te(ne)){const le=new N(ne.location,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.profileScanOptions,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(le,ne.metadata)}return null}));return(0,P.coalesce)(Z)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,f.joinPath)(V.location,"package.json"))){const te=await this.scanExtension(V);return te?[te]:[]}else return await this.scanExtensions(V)}catch(te){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,k.getErrorMessage)(te)),[]}}async scanExtension(V,te){try{let $=await this.scanExtensionManifest(V.location);if($){$.publisher||($.publisher=c.UNDEFINED_PUBLISHER),te=te??$.__metadata,delete $.__metadata;const q=(0,S.getGalleryExtensionId)($.publisher,$.name),Z=te?.id?{id:q,uuid:te.id}:{id:q},ne=te?.isSystem?c.ExtensionType.System:V.type,le=ne===c.ExtensionType.System||!!te?.isBuiltin;$=await this.translateManifest(V.location,$,N.createNlsConfiguration(V));let ee={type:ne,identifier:Z,manifest:$,location:V.location,isBuiltin:le,targetPlatform:te?.targetPlatform??c.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return V.validate&&(ee=this.validate(ee,V)),$.enabledApiProposals&&(!this.environmentService.isBuilt||this.extensionsEnabledWithApiProposalVersion.includes(q.toLowerCase()))&&($.originalEnabledApiProposals=$.enabledApiProposals,$.enabledApiProposals=(0,c.parseEnabledApiProposalNames)([...$.enabledApiProposals])),ee}}catch($){V.type!==c.ExtensionType.System&&this.logService.error($)}return null}validate(V,te){let $=!0;const q=this.environmentService.isBuilt&&this.extensionsEnabledWithApiProposalVersion.includes(V.identifier.id.toLowerCase()),Z=(0,u.validateExtensionManifest)(te.productVersion,te.productDate,te.location,V.manifest,V.isBuiltin,q);for(const[ne,le]of Z)ne===p.default.Error&&($=!1,this.logService.error(this.formatMessage(te.location,le)));return V.isValid=$,V.validations=Z,V}async scanExtensionManifest(V){const te=(0,f.joinPath)(V,"package.json");let $;try{$=(await this.fileService.readFile(te)).value.toString()}catch(Z){return(0,i.toFileOperationResult)(Z)!==i.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(V,(0,v.localize)(11462,null,te.path,Z.message))),null}let q;try{q=JSON.parse($)}catch{const ne=[];(0,T.parse)($,ne);for(const le of ne)this.logService.error(this.formatMessage(V,(0,v.localize)(11463,null,te.path,le.offset,le.length,(0,D.getParseErrorMessage)(le.error))));return null}return(0,T.getNodeType)(q)!=="object"?(this.logService.error(this.formatMessage(V,(0,v.localize)(11464,null,te.path))),null):q}async translateManifest(V,te,$){const q=await this.getLocalizedMessages(V,te,$);if(q)try{const Z=[],ne=await this.resolveOriginalMessageBundle(q.default,Z);if(Z.length>0)return Z.forEach(ee=>{this.logService.error(this.formatMessage(V,(0,v.localize)(11465,null,q.default?.path,(0,D.getParseErrorMessage)(ee.error))))}),te;if((0,T.getNodeType)(q)!=="object")return this.logService.error(this.formatMessage(V,(0,v.localize)(11466,null,q.default?.path))),te;const le=q.values||Object.create(null);return(0,b.localizeManifest)(this.logService,te,le,ne)}catch{}return te}async getLocalizedMessages(V,te,$){const q=(0,f.joinPath)(V,"package.nls.json"),Z=(X,K)=>{K.forEach(W=>{this.logService.error(this.formatMessage(V,(0,v.localize)(11467,null,X?.path,(0,D.getParseErrorMessage)(W.error))))})},ne=X=>{this.logService.error(this.formatMessage(V,(0,v.localize)(11468,null,X?.path)))},le=`${te.publisher}.${te.name}`,ee=$.translations[le];if(ee)try{const X=g.URI.file(ee),K=(await this.fileService.readFile(X)).value.toString(),W=[],U=(0,T.parse)(K,W);return W.length>0?(Z(X,W),{values:void 0,default:q}):(0,T.getNodeType)(U)!=="object"?(ne(X),{values:void 0,default:q}):{values:U.contents?U.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.fileService.exists(q))return;let K;try{K=await this.findMessageBundles(V,$)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const W=(await this.fileService.readFile(K.localized)).value.toString(),U=[],Y=(0,T.parse)(W,U);return U.length>0?(Z(K.localized,U),{values:void 0,default:K.original}):(0,T.getNodeType)(Y)!=="object"?(ne(K.localized),{values:void 0,default:K.original}):{values:Y,default:K.original}}catch{return{values:void 0,default:K.original}}}}async resolveOriginalMessageBundle(V,te){if(V)try{const $=(await this.fileService.readFile(V)).value.toString();return(0,T.parse)($,te)}catch{}}findMessageBundles(V,te){return new Promise(($,q)=>{const Z=ne=>{const le=(0,f.joinPath)(V,`package.nls.${ne}.json`);this.fileService.exists(le).then(ee=>{ee&&$({localized:le,original:(0,f.joinPath)(V,"package.nls.json")});const X=ne.lastIndexOf("-");X===-1?$({localized:(0,f.joinPath)(V,"package.nls.json"),original:null}):(ne=ne.substring(0,X),Z(ne))})};if(te.devMode||te.pseudo||!te.language)return $({localized:(0,f.joinPath)(V,"package.nls.json"),original:null});Z(te.language)})}formatMessage(V,te){return`[${V.path}]: ${te}`}};F=we([Q(1,h.IExtensionsProfileScannerService),Q(2,A.IUriIdentityService),Q(3,i.IFileService),Q(4,s.IProductService),Q(5,C.IEnvironmentService),Q(6,t.ILogService)],F);let M=class extends F{constructor(V,te,$,q,Z,ne,le,ee,X){super(te,q,Z,ne,le,ee,X),this.currentProfile=V,this.userDataProfilesService=$,this.cacheValidatorThrottler=this._register(new a.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const te=this.getCacheFile(V),$=await this.readExtensionCache(te);if(this.input=V,$&&$.input&&N.equals($.input,this.input))return this.logService.debug("Using cached extensions scan result",V.type===c.ExtensionType.System?"system":"user",V.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),$.result.map(Z=>(Z.location=g.URI.revive(Z.location),Z));const q=await super.scanExtensions(V);return await this.writeExtensionCache(te,{input:V,result:q}),q}async readExtensionCache(V){try{const te=await this.fileService.readFile(V),$=JSON.parse(te.value.toString());return{result:$.result,input:(0,o.revive)($.input)}}catch(te){this.logService.debug("Error while reading the extension cache file:",V.path,(0,k.getErrorMessage)(te))}return null}async writeExtensionCache(V,te){try{await this.fileService.writeFile(V,L.VSBuffer.fromString(JSON.stringify(te)))}catch($){this.logService.debug("Error while writing the extension cache file:",V.path,(0,k.getErrorMessage)($))}}async validateCache(){if(!this.input)return;const V=this.getCacheFile(this.input),te=await this.readExtensionCache(V);if(!te)return;const $=te.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!_.equals(q,$))try{this.logService.info("Invalidating Cache",$,q),await this.fileService.del(V),this._onDidChangeCache.fire()}catch(Z){this.logService.error(Z)}}getCacheFile(V){const te=this.getProfile(V);return this.uriIdentityService.extUri.joinPath(te.cacheHome,V.type===c.ExtensionType.System?c.BUILTIN_MANIFEST_CACHE_FILE:c.USER_MANIFEST_CACHE_FILE)}getProfile(V){return V.type===c.ExtensionType.System?this.userDataProfilesService.defaultProfile:V.profile?this.uriIdentityService.extUri.isEqual(V.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(te=>this.uriIdentityService.extUri.isEqual(V.location,te.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};M=we([Q(2,y.IUserDataProfilesService),Q(3,h.IExtensionsProfileScannerService),Q(4,A.IUriIdentityService),Q(5,i.IFileService),Q(6,s.IProductService),Q(7,C.IEnvironmentService),Q(8,t.ILogService)],M);function H(J,V){const te=(0,S.getExtensionId)(J.manifest.publisher,J.manifest.name);return{id:te,identifier:new c.ExtensionIdentifier(te),isBuiltin:J.type===c.ExtensionType.System,isUserBuiltin:J.type===c.ExtensionType.User&&J.isBuiltin,isUnderDevelopment:V,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,publisherDisplayName:J.publisherDisplayName,...J.manifest}}class z extends O{constructor(V,te,$,q,Z,ne,le,ee,X,K,W,U){super(V,te,(0,f.joinPath)($,".vscode-oss-dev","extensions","control.json"),q,Z,ne,le,ee,X,K,W,U),this.translationsPromise=(async()=>{if(d.translationsConfigFile)try{const Y=await this.fileService.readFile(g.URI.file(d.translationsConfigFile));return JSON.parse(Y.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}e.NativeExtensionsScannerService=z}),define(ue[215],he([0,1,68,6,43,3,2,22,13,30,10,19]),function(ae,e,P,a,_,L,k,T,D,E,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends k.Disposable{constructor(l,p){super(),this.userDataProfilesService=l,this.logService=p,this.processesLimiter=new a.Limiter(5)}async postUninstall(l){const p=this.parseScript(l,"uninstall");p&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(p.script,"uninstall",p.args,!0,l),this.logService.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(I){this.logService.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.logService.error(I)}}));try{await E.Promises.rm(this.getExtensionStoragePath(l))}catch(I){this.logService.error("Error while removing extension storage path",l.identifier.id),this.logService.error(I)}}parseScript(l,p){const I=`vscode:${p}`;if(l.location.scheme===T.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[I]=="string"){const g=l.manifest.scripts[I].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${I} should be a node script`),null):{script:(0,D.join)(l.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(l,p,I,g,v){return new Promise((C,S)=>{const c=this.start(l,p,I,v);let u;const i=n=>{u&&(clearTimeout(u),u=null),n?S(n):C(void 0)};c.on("error",n=>{i((0,_.toErrorMessage)(n)||"Unknown")}),c.on("exit",(n,t)=>{i(n?`post-${p} process exited with code ${n}`:void 0)}),g&&(u=setTimeout(()=>{u=null,c.kill(),S("timed out")},5e3))})}start(l,p,I,g){const v={silent:!0,execArgv:void 0},C=(0,P.fork)(l,[`--type=extension-post-${p}`,...I],v);C.stdout.setEncoding("utf8"),C.stderr.setEncoding("utf8");const S=L.Event.fromNodeEventEmitter(C.stdout,"data"),c=L.Event.fromNodeEventEmitter(C.stderr,"data");this._register(S(n=>this.logService.info(g.identifier.id,g.manifest.version,`post-${p}`,n))),this._register(c(n=>this.logService.error(g.identifier.id,g.manifest.version,`post-${p}`,n)));const u=L.Event.any(L.Event.map(S,n=>({data:`%c${n}`,format:[""]}),this._store),L.Event.map(c,n=>({data:`%c${n}`,format:["color: red"]}),this._store));return L.Event.debounce(u,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this._store)(n=>{console.group(g.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),C}getExtensionStoragePath(l){return(0,D.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=d,e.ExtensionsLifecycle=d=we([Q(0,m.IUserDataProfilesService),Q(1,R.ILogService)],d)}),define(ue[116],he([0,1,72,11,83,27]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromExtractError=k,e.getManifest=T;function k(D){let E=L.ExtensionManagementErrorCode.Extract;return D instanceof P.ExtractError&&(D.type==="CorruptZip"?E=L.ExtensionManagementErrorCode.CorruptZip:D.type==="Incomplete"&&(E=L.ExtensionManagementErrorCode.IncompleteZip)),(0,_.toExtensionManagementError)(D,E)}async function T(D){let E;try{E=await(0,P.buffer)(D,"extension/package.json")}catch(R){throw k(R)}try{return JSON.parse(E.toString("utf8"))}catch{throw new L.ExtensionManagementError((0,a.localize)(11452,null),L.ExtensionManagementErrorCode.Invalid)}}}),define(ue[216],he([0,1,6,8,2,22,20,60,32,30,72,21,15,83,27,35,116,110,7,10,18]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0,T=De(T);let u=class extends _.Disposable{static{c=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(n,t,s,r,o,h,y){super(),this.fileService=t,this.extensionGalleryService=s,this.configurationService=r,this.extensionSignatureVerificationService=o,this.telemetryService=h,this.logService=y,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(n,t,s,r){await this.cleanUpPromise;const o=await this.downloadVSIX(n,t);let h=!1;if(s&&this.shouldVerifySignature(n)){let y;try{y=await this.downloadSignatureArchive(n)}catch(A){try{await this.delete(o)}catch(b){this.logService.error(b)}throw A}try{h=await this.extensionSignatureVerificationService.verify(n,o.fsPath,y.fsPath,r)}catch(A){if(h=A.code,h===g.ExtensionSignatureVerificationCode.PackageIsInvalidZip||h===g.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(o)}catch(b){this.logService.error(b)}throw new l.ExtensionManagementError(R.CorruptZipMessage,l.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(y)}catch(A){this.logService.error(A)}}}return{location:o,verificationStatus:h}}shouldVerifySignature(n){return n.isSigned||this.logService.info(`Extension is not signed: ${n.identifier.id}`),!1}async downloadVSIX(n,t){try{const s=(0,k.joinPath)(this.extensionsDownloadDir,this.getName(n)),r=await this.doDownload(n,"vsix",async()=>{await this.downloadFile(n,s,o=>this.extensionGalleryService.download(n,o,t));try{await this.validate(s.fsPath,"extension/package.json")}catch(o){try{await this.fileService.del(s)}catch(h){this.logService.warn(`Error while deleting: ${s.path}`,(0,a.getErrorMessage)(h))}throw o}},2);return r>1&&this.telemetryService.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:n.identifier.id,attempts:r}),s}catch(s){throw(0,f.toExtensionManagementError)(s,l.ExtensionManagementErrorCode.Download)}}async downloadSignatureArchive(n){try{const t=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,D.generateUuid)()}`),s=await this.doDownload(n,"sigzip",async()=>{await this.extensionGalleryService.downloadSignatureArchive(n,t);try{await this.validate(t.fsPath,".signature.p7s")}catch(r){try{await this.fileService.del(t)}catch(o){this.logService.warn(`Error while deleting: ${t.path}`,(0,a.getErrorMessage)(o))}throw r}},2);return s>1&&this.telemetryService.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:n.identifier.id,attempts:s}),t}catch(t){throw(0,f.toExtensionManagementError)(t,l.ExtensionManagementErrorCode.DownloadSignature)}}async downloadFile(n,t,s){if(await this.fileService.exists(t))return;if(t.scheme!==L.Schemas.file){await s(t);return}const r=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,D.generateUuid)()}`);try{await s(r)}catch(o){try{await this.fileService.del(r)}catch{}throw o}try{await E.Promises.rename(r.fsPath,t.fsPath,2*60*1e3)}catch(o){try{await this.fileService.del(r)}catch{}let h=!1;try{h=await this.fileService.exists(t)}catch{}if(h)this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,t.path);else throw this.logService.info(`Rename failed because of ${(0,a.getErrorMessage)(o)}. Deleted the file from downloaded location`,r.path),o}}async doDownload(n,t,s,r){let o=1;for(;;)try{return await s(),o}catch(h){if(o++>r)throw h;this.logService.warn(`Failed downloading ${t}. ${(0,a.getErrorMessage)(h)}. Retry again...`,n.identifier.id)}}async validate(n,t){try{await(0,R.buffer)(n,t)}catch(s){throw(0,I.fromExtractError)(s)}}async delete(n){await this.cleanUpPromise,await this.fileService.del(n)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const t=[],s=[],r=[];for(const y of n.children)if(y.name.endsWith(c.SignatureArchiveExtension))r.push(y.resource);else{const A=p.ExtensionKey.parse(y.name);A&&s.push([A,y])}const o=(0,p.groupByExtension)(s,([y])=>y),h=[];for(const y of o)y.sort((A,b)=>T.rcompare(A[0].version,b[0].version)),t.push(...y.slice(1).map(A=>A[1].resource)),h.push(y[0][1]);h.sort((y,A)=>y.mtime-A.mtime),t.push(...h.slice(0,Math.max(0,h.length-this.cache)).map(y=>y.resource)),t.push(...r),await P.Promises.settled(t.map(y=>(this.logService.trace("Deleting from cache",y.path),this.fileService.del(y))))}}catch(n){this.logService.error(n)}}getName(n){return this.cache?p.ExtensionKey.create(n).toString().toLowerCase():(0,D.generateUuid)()}};e.ExtensionsDownloader=u,e.ExtensionsDownloader=u=c=we([Q(0,d.INativeEnvironmentService),Q(1,v.IFileService),Q(2,l.IExtensionGalleryService),Q(3,m.IConfigurationService),Q(4,g.IExtensionSignatureVerificationService),Q(5,S.ITelemetryService),Q(6,C.ILogService)],u)}),define(ue[117],he([0,1,33,6,14,25,43,8,3,55,2,31,22,13,20,60,12,9,32,30,72,11,98,15,83,27,35,52,84,216,215,116,188,198,34,59,7,4,10,23,18,28,19]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S,c,u,i,n,t,s,r,o,h,y,A,b,w,O,N,F,M,H,z,J,V,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,P=De(P),f=De(f),p=De(p),C=De(C),c=De(c),e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(t.IExtensionManagementService);const $=".vsctmp";let q=class extends n.AbstractExtensionManagementService{constructor(X,K,W,U,Y,oe,x,B,j,G,ie,ce){super(X,K,ie,W,G,ce),this.extensionsScannerService=Y,this.extensionsProfileScannerService=oe,this.downloadService=x,this.instantiationService=B,this.fileService=j,this.extractingGalleryExtensions=new Map,this.knownDirectories=new m.ResourceSet;const ge=this._register(B.createInstance(y.ExtensionsLifecycle));this.extensionsScanner=this._register(B.createInstance(Z,Ie=>ge.postUninstall(Ie))),this.manifestCache=this._register(new b.ExtensionsManifestCache(ce,j,ie,this,this.logService)),this.extensionsDownloader=this._register(B.createInstance(h.ExtensionsDownloader));const Se=this._register(new w.ExtensionsWatcher(this,this.extensionsScannerService,ce,oe,ie,j,W));this._register(Se.onDidChangeExtensionsByAnotherSource(Ie=>this.onDidChangeExtensionsFromAnotherSource(Ie))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(X){this.logService.trace("ExtensionManagementService#zip",X.identifier.id);const K=await this.collectFiles(X),W=await(0,S.zip)((0,l.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,K);return g.URI.file(W)}async getManifest(X){const{location:K,cleanup:W}=await this.downloadVsix(X),U=f.resolve(K.fsPath);try{return await(0,A.getManifest)(U)}finally{await W()}}getInstalled(X,K=this.userDataProfilesService.defaultProfile.extensionsResource,W={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(X??null,K,W)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.extensionsScanner.scanUserExtensionAtLocation(X)}async install(X,K={}){this.logService.trace("ExtensionManagementService#install",X.toString());const{location:W,cleanup:U}=await this.downloadVsix(X);try{const Y=await(0,A.getManifest)(f.resolve(W.fsPath)),oe=(0,s.getGalleryExtensionId)(Y.publisher,Y.name);if(Y.engines&&Y.engines.vscode&&!(0,N.isEngineValid)(Y.engines.vscode,this.productService.version,this.productService.date))throw new Error(c.localize(11453,null,oe,this.productService.version));const B=(await this.installExtensions([{manifest:Y,extension:W,options:K}])).find(({identifier:j})=>(0,s.areSameExtensions)(j,{id:oe}));if(B?.local)return B.local;throw B?.error?B.error:(0,n.toExtensionManagementError)(new Error(`Unknown error while installing extension ${oe}`))}finally{await U()}}async installFromLocation(X,K){this.logService.trace("ExtensionManagementService#installFromLocation",X.toString());const W=await this.extensionsScanner.scanUserExtensionAtLocation(X);if(!W||!W.manifest.name||!W.manifest.version)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.addExtensionsToProfile([[W,{source:"resource"}]],K),this.logService.info("Successfully installed extension",W.identifier.id,K.toString()),W}async installExtensionsFromProfile(X,K,W){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",X,K.toString(),W.toString());const U=(await this.getInstalled(O.ExtensionType.User,K)).filter(Y=>X.some(oe=>(0,s.areSameExtensions)(oe,Y.identifier)));if(U.length){const Y=await Promise.all(U.map(oe=>this.extensionsScanner.scanMetadata(oe,K)));await this.addExtensionsToProfile(U.map((oe,x)=>[oe,Y[x]]),W),this.logService.info("Successfully installed extensions",U.map(oe=>oe.identifier.id),W.toString())}return U}async updateMetadata(X,K,W){return this.logService.trace("ExtensionManagementService#updateMetadata",X.identifier.id),K.isPreReleaseVersion&&(K.preRelease=!0,K.hasPreReleaseVersion=!0),K.isMachineScoped===!1&&(K.isMachineScoped=void 0),K.isBuiltin===!1&&(K.isBuiltin=void 0),K.pinned===!1&&(K.pinned=void 0),X=await this.extensionsScanner.updateMetadata(X,K,W),this.manifestCache.invalidate(W),this._onDidUpdateExtensionMetadata.fire({local:X,profileLocation:W}),X}async reinstallFromGallery(X){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.galleryService.isEnabled())throw new Error(c.localize(11454,null));const K=await this.getTargetPlatform(),[W]=await this.galleryService.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:K,compatible:!0},L.CancellationToken.None);if(!W)throw new Error(c.localize(11455,null));await this.extensionsScanner.setUninstalled(X);try{await this.extensionsScanner.removeUninstalledExtension(X)}catch(U){throw new Error(c.localize(11456,null,(0,k.toErrorMessage)(U)))}return this.installFromGallery(W)}copyExtension(X,K,W,U){return this.extensionsScanner.copyExtension(X,K,W,U)}copyExtensions(X,K){return this.extensionsScanner.copyExtensions(X,K,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...X){return this.extensionsScanner.setUninstalled(...X)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(X){this.logService.error(X)}}async download(X,K,W){const{location:U}=await this.extensionsDownloader.download(X,K,!W);return U}async downloadVsix(X){if(X.scheme===d.Schemas.file)return{location:X,async cleanup(){}};this.logService.trace("Downloading extension from",X.toString());const K=(0,l.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(X,K),this.logService.info("Downloaded extension to",K.toString()),{location:K,cleanup:async()=>{try{await this.fileService.del(K)}catch(U){this.logService.error(U)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(X,K,W){const U=K instanceof g.URI?new s.ExtensionKey({id:(0,s.getGalleryExtensionId)(X.publisher,X.name)},X.version):s.ExtensionKey.create(K);return this.instantiationService.createInstance(ne,U,X,K,W,(Y,oe)=>{if(K instanceof g.URI)return this.extractVSIX(U,K,W,oe);let x=this.extractingGalleryExtensions.get(U.toString());return x||(this.extractingGalleryExtensions.set(U.toString(),x=this.downloadAndExtractGalleryExtension(U,K,Y,W,oe)),x.finally(()=>this.extractingGalleryExtensions.delete(U.toString()))),x},this.extensionsScanner)}createUninstallExtensionTask(X,K){return new le(X,K,this.extensionsProfileScannerService)}async downloadAndExtractGalleryExtension(X,K,W,U,Y){const{verificationStatus:oe,location:x}=await this.extensionsDownloader.download(K,W,!U.donotVerifySignature,U.context?.[t.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT]);try{if(Y.isCancellationRequested)throw new T.CancellationError;const B=await(0,A.getManifest)(x.fsPath);if(!new s.ExtensionKey(K.identifier,K.version).equals(new s.ExtensionKey({id:(0,s.getGalleryExtensionId)(B.publisher,B.name)},B.version)))throw new t.ExtensionManagementError(c.localize(11457,null,K.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.extensionsScanner.extractUserExtension(X,x.fsPath,{id:K.identifier.uuid,publisherId:K.publisherId,publisherDisplayName:K.publisherDisplayName,targetPlatform:K.properties.targetPlatform,isApplicationScoped:U.isApplicationScoped,isMachineScoped:U.isMachineScoped,isBuiltin:U.isBuiltin,isPreReleaseVersion:K.properties.isPreReleaseVersion,hasPreReleaseVersion:K.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:U.installGivenVersion?!0:!!U.pinned,preRelease:(0,I.isBoolean)(U.preRelease)?U.preRelease:U.installPreReleaseVersion||K.properties.isPreReleaseVersion,source:"gallery"},!1,Y),verificationStatus:oe}}catch(B){try{await this.extensionsDownloader.delete(x)}catch(j){this.logService.warn("Error while deleting the downloaded file",x.toString(),(0,T.getErrorMessage)(j))}throw(0,n.toExtensionManagementError)(B)}}async extractVSIX(X,K,W,U){return{local:await this.extensionsScanner.extractUserExtension(X,f.resolve(K.fsPath),{isApplicationScoped:W.isApplicationScoped,isMachineScoped:W.isMachineScoped,isBuiltin:W.isBuiltin,installedTimestamp:Date.now(),pinned:W.installGivenVersion?!0:!!W.pinned,source:"vsix"},W.keepExisting??!0,U)}}async collectFiles(X){const K=async U=>{let Y=await C.Promises.readdir(U);Y=Y.map(B=>f.join(U,B));const oe=await Promise.all(Y.map(B=>P.promises.stat(B)));let x=Promise.resolve([]);return oe.forEach((B,j)=>{const G=Y[j];B.isFile()&&(x=x.then(ie=>[...ie,G])),B.isDirectory()&&(x=x.then(ie=>K(G).then(ce=>[...ie,...ce])))}),x};return(await K(X.location.fsPath)).map(U=>({path:`extension/${f.relative(X.location.fsPath,U)}`,localPath:U}))}async onDidChangeExtensionsFromAnotherSource({added:X,removed:K}){if(K){const W=X&&this.uriIdentityService.extUri.isEqual(K.profileLocation,X.profileLocation)?K.extensions.filter(U=>X.extensions.every(Y=>!(0,s.areSameExtensions)(Y,U))):K.extensions;for(const U of W)this.logService.info("Extensions removed from another source",U.id,K.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:U,profileLocation:K.profileLocation})}if(X){const U=(await this.getInstalled(O.ExtensionType.User,X.profileLocation)).filter(Y=>X.extensions.some(oe=>(0,s.areSameExtensions)(oe,Y.identifier)));this._onDidInstallExtensions.fire(U.map(Y=>(this.logService.info("Extensions added from another source",Y.identifier.id,X.profileLocation.toString()),{identifier:Y.identifier,local:Y,profileLocation:X.profileLocation,operation:t.InstallOperation.None})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(K=>this.knownDirectories.add(K)));const X=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const K of X.children??[])K.isDirectory&&this.knownDirectories.add(K.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(K=>this.onDidFilesChange(K)))}async onDidFilesChange(X){if(!X.affects(this.extensionsScannerService.userExtensionsLocation,F.FileChangeType.ADDED))return;const K=[];for(const W of X.rawAdded){if(this.knownDirectories.has(W)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(W),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(W,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(W).startsWith(".")||!(await this.fileService.stat(W)).isDirectory)continue;const U=await this.extensionsScanner.scanUserExtensionAtLocation(W);U&&U.installedTimestamp===void 0&&(this.knownDirectories.add(W),K.push(U))}K.length&&(await this.addExtensionsToProfile(K.map(W=>[W,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",K.map(W=>W.identifier.id)))}async addExtensionsToProfile(X,K){const W=X.map(U=>U[0]);await this.setInstalled(W),await this.extensionsProfileScannerService.addExtensionsToProfile(X,K),this._onDidInstallExtensions.fire(W.map(U=>({local:U,identifier:U.identifier,operation:t.InstallOperation.None,profileLocation:K})))}async setInstalled(X){const K=await this.extensionsScanner.getUninstalledExtensions();for(const W of X){const U=s.ExtensionKey.create(W);K[U.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",U.id),await this.extensionsScanner.setInstalled(U),this.logService.info("Removed the extension from uninstalled list:",U.id))}}};e.ExtensionManagementService=q,e.ExtensionManagementService=q=we([Q(0,t.IExtensionGalleryService),Q(1,J.ITelemetryService),Q(2,H.ILogService),Q(3,i.INativeEnvironmentService),Q(4,o.IExtensionsScannerService),Q(5,r.IExtensionsProfileScannerService),Q(6,u.IDownloadService),Q(7,M.IInstantiationService),Q(8,F.IFileService),Q(9,z.IProductService),Q(10,V.IUriIdentityService),Q(11,te.IUserDataProfilesService)],q);let Z=class extends R.Disposable{constructor(X,K,W,U,Y,oe,x){super(),this.beforeRemovingExtension=X,this.fileService=K,this.extensionsScannerService=W,this.extensionsProfileScannerService=U,this.uriIdentityService=Y,this.telemetryService=oe,this.logService=x,this._onExtract=this._register(new D.Emitter),this.onExtract=this._onExtract.event,this.scanAllExtensionPromise=new m.ResourceMap,this.scanUserExtensionsPromise=new m.ResourceMap,this.uninstalledResource=(0,l.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new a.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(X,K,W){try{const U={includeInvalid:!0,profileLocation:K,productVersion:W};let Y=[];if(X===null||X===O.ExtensionType.System){let oe=this.scanAllExtensionPromise.get(K);oe||(oe=this.extensionsScannerService.scanAllExtensions({includeInvalid:!0,useCache:!0},U,!1).finally(()=>this.scanAllExtensionPromise.delete(K)),this.scanAllExtensionPromise.set(K,oe)),Y.push(...await oe)}else if(X===O.ExtensionType.User){let oe=this.scanUserExtensionsPromise.get(K);oe||(oe=this.extensionsScannerService.scanUserExtensions(U).finally(()=>this.scanUserExtensionsPromise.delete(K)),this.scanUserExtensionsPromise.set(K,oe)),Y.push(...await oe)}return Y=X!==null?Y.filter(oe=>oe.type===X):Y,await Promise.all(Y.map(oe=>this.toLocalExtension(oe)))}catch(U){throw(0,n.toExtensionManagementError)(U,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(X){try{const K=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return await Promise.all(K.map(W=>this.toLocalExtension(W)))}catch(K){throw(0,n.toExtensionManagementError)(K,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(X){try{const K=await this.extensionsScannerService.scanExistingExtension(X,O.ExtensionType.User,{includeInvalid:!0});if(K)return await this.toLocalExtension(K)}catch(K){this.logService.error(K)}return null}async extractUserExtension(X,K,W,U,Y){const oe=X.toString(),x=g.URI.file(f.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`)),B=g.URI.file(f.join(this.extensionsScannerService.userExtensionsLocation.fsPath,oe));if(await this.fileService.exists(B)){if(!U)try{return await this.scanLocalExtension(B,O.ExtensionType.User)}catch(j){this.logService.warn(`Error while scanning the existing extension at ${B.path}. Deleting the existing extension and extracting it.`,(0,T.getErrorMessage)(j))}try{await this.deleteExtensionFromLocation(X.id,B,"removeExisting")}catch{throw new t.ExtensionManagementError(c.localize(11458,null,B.fsPath,X.id),t.ExtensionManagementErrorCode.Delete)}}try{if(Y.isCancellationRequested)throw new T.CancellationError;try{this.logService.trace(`Started extracting the extension from ${K} to ${B.fsPath}`),await(0,S.extract)(K,x.fsPath,{sourcePath:"extension",overwrite:!0},Y),this.logService.info(`Extracted extension to ${B}:`,X.id)}catch(j){throw(0,A.fromExtractError)(j)}try{await this.extensionsScannerService.updateMetadata(x,W)}catch(j){throw this.telemetryService.publicLog2("extension:extract",{extensionId:X.id,code:`${(0,F.toFileOperationResult)(j)}`}),(0,n.toExtensionManagementError)(j,t.ExtensionManagementErrorCode.UpdateMetadata)}if(Y.isCancellationRequested)throw new T.CancellationError;try{this.logService.trace(`Started renaming the extension from ${x.fsPath} to ${B.fsPath}`),await this.rename(x.fsPath,B.fsPath),this.logService.info("Renamed to",B.fsPath)}catch(j){if(j.code==="ENOTEMPTY"){this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);try{await this.fileService.del(x,{recursive:!0})}catch{}}else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(j)}. Deleted from extracted location`,x),j}this._onExtract.fire(B)}catch(j){try{await this.fileService.del(x,{recursive:!0})}catch{}throw j}return this.scanLocalExtension(B,O.ExtensionType.User)}async scanMetadata(X,K){return K?(await this.getScannedExtension(X,K))?.metadata:this.extensionsScannerService.scanMetadata(X.location)}async getScannedExtension(X,K){return(await this.extensionsProfileScannerService.scanProfileExtensions(K)).find(U=>(0,s.areSameExtensions)(U.identifier,X.identifier))}async updateMetadata(X,K,W){try{W?await this.extensionsProfileScannerService.updateMetadata([[X,K]],W):await this.extensionsScannerService.updateMetadata(X.location,K)}catch(U){throw this.telemetryService.publicLog2("extension:extract",{extensionId:X.identifier.id,code:`${(0,F.toFileOperationResult)(U)}`,isProfile:!!W}),(0,n.toExtensionManagementError)(U,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(X.location,X.type,W)}async getUninstalledExtensions(){try{return await this.withUninstalledExtensions()}catch(X){throw(0,n.toExtensionManagementError)(X,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...X){const K=X.map(W=>s.ExtensionKey.create(W));await this.withUninstalledExtensions(W=>K.forEach(U=>{W[U.toString()]=!0,this.logService.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(X){try{await this.withUninstalledExtensions(K=>delete K[X.toString()])}catch(K){throw(0,n.toExtensionManagementError)(K,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(X,K){if(this.uriIdentityService.extUri.isEqualOrParent(X.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(X.identifier.id,X.location,K)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.withUninstalledExtensions(K=>delete K[s.ExtensionKey.create(X).toString()])}async copyExtension(X,K,W,U){const Y=await this.getScannedExtension(X,K),oe=await this.getScannedExtension(X,W);if(U={...Y?.metadata,...U},oe)if(this.uriIdentityService.extUri.isEqual(oe.location,X.location))await this.extensionsProfileScannerService.updateMetadata([[X,{...oe.metadata,...U}]],W);else{const x=await this.scanLocalExtension(oe.location,X.type,W);await this.extensionsProfileScannerService.removeExtensionFromProfile(x,W),await this.extensionsProfileScannerService.addExtensionsToProfile([[X,{...oe.metadata,...U}]],W)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[X,U]],W);return this.scanLocalExtension(X.location,X.type,W)}async copyExtensions(X,K,W){const U=await this.scanExtensions(O.ExtensionType.User,X,W),Y=await Promise.all(U.filter(oe=>!oe.isApplicationScoped).map(async oe=>[oe,await this.scanMetadata(oe,X)]));await this.extensionsProfileScannerService.addExtensionsToProfile(Y,K)}async deleteExtensionFromLocation(X,K,W){this.logService.trace(`Deleting ${W} extension from disk`,X,K.fsPath);const U=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(K),`${this.uriIdentityService.extUri.basename(K)}.${(0,E.hash)((0,v.generateUuid)()).toString(16)}${$}`);await this.rename(K.fsPath,U.fsPath),await this.fileService.del(U,{recursive:!0}),this.logService.info(`Deleted ${W} extension from disk`,X,K.fsPath)}withUninstalledExtensions(X){return this.uninstalledFileLimiter.queue(async()=>{let K;try{K=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(U){if((0,F.toFileOperationResult)(U)!==F.FileOperationResult.FILE_NOT_FOUND)throw U}let W={};if(K)try{W=JSON.parse(K)}catch{}return X&&(X(W),Object.keys(W).length?await this.fileService.writeFile(this.uninstalledResource,_.VSBuffer.fromString(JSON.stringify(W))):await this.fileService.del(this.uninstalledResource)),W})}async rename(X,K){try{await C.Promises.rename(X,K,2*60*1e3)}catch(W){throw(0,n.toExtensionManagementError)(W,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(X,K,W){try{if(W){const Y=(await this.extensionsScannerService.scanUserExtensions({profileLocation:W})).find(oe=>this.uriIdentityService.extUri.isEqual(oe.location,X));if(Y)return await this.toLocalExtension(Y)}else{const U=await this.extensionsScannerService.scanExistingExtension(X,K,{includeInvalid:!0});if(U)return await this.toLocalExtension(U)}throw new t.ExtensionManagementError(c.localize(11459,null,X.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(U){throw(0,n.toExtensionManagementError)(U,t.ExtensionManagementErrorCode.ScanningExtension)}}async toLocalExtension(X){const K=await this.fileService.resolve(X.location);let W,U;return K.children&&(W=K.children.find(({name:Y})=>/^readme(\.txt|\.md|)$/i.test(Y))?.resource,U=K.children.find(({name:Y})=>/^changelog(\.txt|\.md|)$/i.test(Y))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:W,changelogUrl:U,publisherDisplayName:X.metadata?.publisherDisplayName,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!X.metadata?.hasPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned,isWorkspaceScoped:!1,source:X.metadata?.source??(X.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(X));const K=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=new Set;for(const Y of K)X[s.ExtensionKey.create(Y).toString()]||W.add(Y.identifier.id.toLowerCase());try{const Y=(0,s.groupByExtension)(K,oe=>oe.identifier);await a.Promises.settled(Y.map(async oe=>{const x=oe.sort((B,j)=>p.rcompare(B.manifest.version,j.manifest.version))[0];W.has(x.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(x))}))}catch(Y){this.logService.error(Y)}const U=K.filter(Y=>Y.metadata&&X[s.ExtensionKey.create(Y).toString()]);await Promise.allSettled(U.map(Y=>this.removeUninstalledExtension(Y)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let X;try{X=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(K){(0,F.toFileOperationResult)(K)!==F.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(K);return}if(X?.children)try{await Promise.allSettled(X.children.map(async K=>{if(!(!K.isDirectory||!K.name.endsWith($))){this.logService.trace("Deleting the temporarily deleted folder",K.resource.toString());try{await this.fileService.del(K.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",K.resource.toString())}catch(W){(0,F.toFileOperationResult)(W)!==F.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(W)}}}))}catch{}}};e.ExtensionsScanner=Z,e.ExtensionsScanner=Z=we([Q(1,F.IFileService),Q(2,o.IExtensionsScannerService),Q(3,r.IExtensionsProfileScannerService),Q(4,V.IUriIdentityService),Q(5,J.ITelemetryService),Q(6,H.ILogService)],Z);let ne=class extends n.AbstractExtensionTask{get operation(){return this.options.operation??this._operation}get verificationStatus(){return this._verificationStatus}constructor(X,K,W,U,Y,oe,x,B,j,G,ie,ce){super(),this.extensionKey=X,this.manifest=K,this.source=W,this.options=U,this.extractExtensionFn=Y,this.extensionsScanner=oe,this.uriIdentityService=x,this.galleryService=B,this.userDataProfilesService=j,this.extensionsScannerService=G,this.extensionsProfileScannerService=ie,this.logService=ce,this._operation=t.InstallOperation.Install,this.identifier=this.extensionKey.identifier}async doRun(X){const W=(await this.extensionsScanner.scanExtensions(O.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(x=>(0,s.areSameExtensions)(x.identifier,this.identifier));W&&(this._operation=t.InstallOperation.Update);const U={isApplicationScoped:this.options.isApplicationScoped||W?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||W?.isMachineScoped,isBuiltin:this.options.isBuiltin||W?.isBuiltin,isSystem:W?.type===O.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??W?.pinned,source:this.source instanceof g.URI?"vsix":"gallery"};let Y;if(this.source instanceof g.URI){if(W&&this.extensionKey.equals(new s.ExtensionKey(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(c.localize(11460,null,this.manifest.displayName||this.manifest.name))}const x=await this.unsetIfUninstalled(this.extensionKey);if(x)try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(c.localize(11461,null,this.manifest.displayName||this.manifest.name))}}else{if(U.id=this.source.identifier.uuid,U.publisherId=this.source.publisherId,U.publisherDisplayName=this.source.publisherDisplayName,U.targetPlatform=this.source.properties.targetPlatform,U.updated=!!W,U.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,U.hasPreReleaseVersion=W?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,U.preRelease=(0,I.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||W?.preRelease,W&&W.type!==O.ExtensionType.System&&W.manifest.version===this.source.version)return this.extensionsScanner.updateMetadata(W,U,this.options.profileLocation);Y=await this.unsetIfUninstalled(this.extensionKey)}if(X.isCancellationRequested)throw(0,n.toExtensionManagementError)(new T.CancellationError);if(!Y){const x=await this.extractExtensionFn(this.operation,X);Y=x.local,this._verificationStatus=x.verificationStatus}if(this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.extensionsScannerService.initializeDefaultProfileExtensions()}catch(x){throw(0,n.toExtensionManagementError)(x,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(X.isCancellationRequested)throw(0,n.toExtensionManagementError)(new T.CancellationError);try{await this.extensionsProfileScannerService.addExtensionsToProfile([[Y,U]],this.options.profileLocation,!Y.isValid)}catch(x){throw(0,n.toExtensionManagementError)(x,t.ExtensionManagementErrorCode.AddToProfile)}const oe=await this.extensionsScanner.scanLocalExtension(Y.location,O.ExtensionType.User,this.options.profileLocation);if(!oe)throw new t.ExtensionManagementError("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof g.URI&&this.updateMetadata(Y,X),oe}async unsetIfUninstalled(X){return(await this.extensionsScanner.getUninstalledExtensions())[X.toString()]?(this.logService.trace("Removing the extension from uninstalled list:",X.id),await this.extensionsScanner.setInstalled(X),this.logService.info("Removed the extension from uninstalled list:",X.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(U=>s.ExtensionKey.create(U).equals(X))):void 0}async updateMetadata(X,K){try{let[W]=await this.galleryService.getExtensions([{id:X.identifier.id,version:X.manifest.version}],K);if(W||([W]=await this.galleryService.getExtensions([{id:X.identifier.id}],K)),W){const U={id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId,isPreReleaseVersion:W.properties.isPreReleaseVersion,hasPreReleaseVersion:X.hasPreReleaseVersion||W.properties.isPreReleaseVersion,preRelease:W.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(X,U,this.options.profileLocation)}}catch{}}};ne=we([Q(6,V.IUriIdentityService),Q(7,t.IExtensionGalleryService),Q(8,te.IUserDataProfilesService),Q(9,o.IExtensionsScannerService),Q(10,r.IExtensionsProfileScannerService),Q(11,H.ILogService)],ne);class le extends n.AbstractExtensionTask{constructor(X,K,W){super(),this.extension=X,this.options=K,this.extensionsProfileScannerService=W}async doRun(X){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(ue[217],he([0,1,10,19,28,18,52,7,15,9]),function(ae,e,P,a,_,L,k,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let R=class extends k.AbstractExtensionsProfileScannerService{constructor(d,f,l,p,I,g){super(E.URI.file(d.extensionsPath),f,l,p,I,g)}};e.ExtensionsProfileScannerService=R,e.ExtensionsProfileScannerService=R=we([Q(0,D.INativeEnvironmentService),Q(1,T.IFileService),Q(2,a.IUserDataProfilesService),Q(3,_.IUriIdentityService),Q(4,L.ITelemetryService),Q(5,P.ILogService)],R)}),define(ue[218],he([0,1,9,15,52,84,7,4,10,23,28,19]),function(ae,e,P,a,_,L,k,T,D,E,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends L.NativeExtensionsScannerService{constructor(l,p,I,g,v,C,S,c){super(P.URI.file(v.builtinExtensionsPath),P.URI.file(v.extensionsPath),v.userHome,l.defaultProfile,l,p,I,g,v,C,S,c)}};e.ExtensionsScannerService=d,e.ExtensionsScannerService=d=we([Q(0,m.IUserDataProfilesService),Q(1,_.IExtensionsProfileScannerService),Q(2,k.IFileService),Q(3,D.ILogService),Q(4,a.INativeEnvironmentService),Q(5,E.IProductService),Q(6,R.IUriIdentityService),Q(7,T.IInstantiationService)],d)}),define(ue[16],he([0,1,6,3,2,100,12,70,4,19]),function(ae,e,P,a,_,L,k,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=f,e.isProfileUsingDefaultStorage=p,e.logStorage=g,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,D.createDecorator)("storageService");var R;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var m;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(m||(e.StorageScope=m={}));var d;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function f(v){const C=v.get(e.TARGET_KEY);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}class l extends _.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(C={flushInterval:l.DEFAULT_FLUSH_INTERVAL}){super(),this.options=C,this._onDidChangeValue=this._register(new a.PauseableEmitter),this._onDidChangeTarget=this._register(new a.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new a.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new _.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(C,S,c){return a.Event.filter(this._onDidChangeValue.event,u=>u.scope===C&&(S===void 0||u.key===S),c)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,P.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,_.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(C,S){const{key:c,external:u}=S;if(c===e.TARGET_KEY){switch(C){case m.APPLICATION:this._applicationKeyTargets=void 0;break;case m.PROFILE:this._profileKeyTargets=void 0;break;case m.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:C})}else this._onDidChangeValue.fire({scope:C,key:c,target:this.getKeyTargets(C)[c],external:u})}emitWillSaveState(C){this._onWillSaveState.fire({reason:C})}get(C,S,c){return this.getStorage(S)?.get(C,c)}getBoolean(C,S,c){return this.getStorage(S)?.getBoolean(C,c)}getNumber(C,S,c){return this.getStorage(S)?.getNumber(C,c)}getObject(C,S,c){return this.getStorage(S)?.getObject(C,c)}storeAll(C,S){this.withPausedEmitters(()=>{for(const c of C)this.store(c.key,c.value,c.scope,c.target,S)})}store(C,S,c,u,i=!1){if((0,k.isUndefinedOrNull)(S)){this.remove(C,c,i);return}this.withPausedEmitters(()=>{this.updateKeyTarget(C,c,u),this.getStorage(c)?.set(C,S,i)})}remove(C,S,c=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(C,S,void 0),this.getStorage(S)?.delete(C,c)})}withPausedEmitters(C){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{C()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(C,S){const c=[],u=this.getKeyTargets(C);for(const i of Object.keys(u))u[i]===S&&c.push(i);return c}updateKeyTarget(C,S,c,u=!1){const i=this.getKeyTargets(S);typeof c=="number"?i[C]!==c&&(i[C]=c,this.getStorage(S)?.set(e.TARGET_KEY,JSON.stringify(i),u)):typeof i[C]=="number"&&(delete i[C],this.getStorage(S)?.set(e.TARGET_KEY,JSON.stringify(i),u))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(m.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(m.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(m.APPLICATION)),this._applicationKeyTargets}getKeyTargets(C){switch(C){case m.APPLICATION:return this.applicationKeyTargets;case m.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(C){const S=this.getStorage(C);return S?f(S):Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(C=R.NONE){this._onWillSaveState.fire({reason:C});const S=this.getStorage(m.APPLICATION),c=this.getStorage(m.PROFILE),u=this.getStorage(m.WORKSPACE);switch(C){case R.NONE:await P.Promises.settled([S?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await P.Promises.settled([S?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async log(){const C=this.getStorage(m.APPLICATION)?.items??new Map,S=this.getStorage(m.PROFILE)?.items??new Map,c=this.getStorage(m.WORKSPACE)?.items??new Map;return g(C,S,c,this.getLogDetails(m.APPLICATION)??"",this.getLogDetails(m.PROFILE)??"",this.getLogDetails(m.WORKSPACE)??"")}async optimize(C){return await this.flush(),this.getStorage(C)?.optimize()}async switch(C,S){return this.emitWillSaveState(R.NONE),(0,E.isUserDataProfile)(C)?this.switchToProfile(C,S):this.switchToWorkspace(C,S)}canSwitchProfile(C,S){return!(C.id===S.id||p(S)&&p(C))}switchData(C,S,c){this.withPausedEmitters(()=>{const u=new Set;for(const[i,n]of C)u.add(i),S.get(i)!==n&&this.emitDidChangeValue(c,{key:i,external:!0});for(const[i]of S.items)u.has(i)||this.emitDidChangeValue(c,{key:i,external:!0})})}}e.AbstractStorageService=l;function p(v){return v.isDefault||!!v.useDefaultFlags?.globalState}class I extends l{constructor(){super(),this.applicationStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(C=>this.emitDidChangeValue(m.WORKSPACE,C))),this._register(this.profileStorage.onDidChangeStorage(C=>this.emitDidChangeValue(m.PROFILE,C))),this._register(this.applicationStorage.onDidChangeStorage(C=>this.emitDidChangeValue(m.APPLICATION,C)))}getStorage(C){switch(C){case m.APPLICATION:return this.applicationStorage;case m.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(C){switch(C){case m.APPLICATION:return"inMemory (application)";case m.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(C){return!1}}e.InMemoryStorageService=I;async function g(v,C,S,c,u,i){const n=w=>{try{return JSON.parse(w)}catch{return w}},t=new Map,s=new Map;v.forEach((w,O)=>{t.set(O,w),s.set(O,n(w))});const r=new Map,o=new Map;C.forEach((w,O)=>{r.set(O,w),o.set(O,n(w))});const h=new Map,y=new Map;S.forEach((w,O)=>{h.set(O,w),y.set(O,n(w))}),console.group(c!==u?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const A=[];if(t.forEach((w,O)=>{A.push({key:O,value:w})}),console.table(A),console.groupEnd(),console.log(s),c!==u){console.group(`Storage: Profile (path: ${u}, profile specific)`);const w=[];r.forEach((O,N)=>{w.push({key:N,value:O})}),console.table(w),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${i})`);const b=[];h.forEach((w,O)=>{b.push({key:O,value:w})}),console.table(b),console.groupEnd(),console.log(y)}}),define(ue[118],he([0,1,3,2,12,27,35,16]),function(ae,e,P,a,_,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let D=class extends a.Disposable{constructor(m,d){super(),this._onDidChangeEnablement=new P.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(m)),this._register(this.storageManger.onDidChange(f=>this._onDidChangeEnablement.fire({extensions:f,source:"storage"}))),this._register(d.onDidInstallExtensions(f=>f.forEach(({local:l,operation:p})=>{l&&p===L.InstallOperation.Migrate&&this._removeFromDisabledExtensions(l.identifier)})))}async enableExtension(m,d){return this._removeFromDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:d}),!0):!1}async disableExtension(m,d){return this._addToDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(m){const d=this.getDisabledExtensions();return d.every(f=>!(0,k.areSameExtensions)(f,m))?(d.push(m),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(m){const d=this.getDisabledExtensions();for(let f=0;f<d.length;f++){const l=d[f];if((0,k.areSameExtensions)(l,m))return d.splice(f,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(m){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,m)}_getExtensions(m){return this.storageManger.get(m,T.StorageScope.PROFILE)}_setExtensions(m,d){this.storageManger.set(m,d,T.StorageScope.PROFILE)}};e.GlobalExtensionEnablementService=D,e.GlobalExtensionEnablementService=D=we([Q(0,T.IStorageService),Q(1,L.IExtensionManagementService)],D);class E extends a.Disposable{constructor(m){super(),this.storageService=m,this.storage=Object.create(null),this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this._register(m.onDidChangeValue(T.StorageScope.PROFILE,void 0,this._register(new a.DisposableStore))(d=>this.onDidStorageChange(d)))}get(m,d){let f;return d===T.StorageScope.PROFILE?((0,_.isUndefinedOrNull)(this.storage[m])&&(this.storage[m]=this._get(m,d)),f=this.storage[m]):f=this._get(m,d),JSON.parse(f)}set(m,d,f){const l=JSON.stringify(d.map(({id:I,uuid:g})=>({id:I,uuid:g})));this._get(m,f)!==l&&(f===T.StorageScope.PROFILE&&(d.length?this.storage[m]=l:delete this.storage[m]),this._set(m,d.length?l:void 0,f))}onDidStorageChange(m){if(!(0,_.isUndefinedOrNull)(this.storage[m.key])&&this._get(m.key,m.scope)!==this.storage[m.key]){const f=this.get(m.key,m.scope);delete this.storage[m.key];const l=this.get(m.key,m.scope),p=f.filter(g=>!l.some(v=>(0,k.areSameExtensions)(g,v))),I=l.filter(g=>!f.some(v=>(0,k.areSameExtensions)(v,g)));(p.length||I.length)&&this._onDidChange.fire([...p,...I])}}_get(m,d){return this.storageService.get(m,d,"[]")}_set(m,d,f){d?this.storageService.store(m,d,f,T.StorageTarget.MACHINE):this.storageService.remove(m,f)}}e.StorageManager=E}),define(ue[85],he([0,1,4,3,2,16,35,23,17,10,12]),function(ae,e,P,a,_,L,k,T,D,E,R){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,P.createDecorator)("IExtensionStorageService");const d=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class extends _.Disposable{static{m=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(p){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(p.id)}@${p.version}`}static fromKey(p){const I=d.exec(p);if(I&&I[1])return{id:I[1],version:I[2]}}static async removeOutdatedExtensionVersions(p,I){const g=await p.getInstalled(),v=[];for(const[C,S]of m.readAllExtensionsWithKeysForSync(I)){const c=g.find(u=>(0,k.areSameExtensions)(u.identifier,{id:C}))?.manifest.version;for(const u of S)c!==u&&v.push(m.toKey({id:C,version:u}))}for(const C of v)I.remove(C,L.StorageScope.PROFILE)}static readAllExtensionsWithKeysForSync(p){const I=new Map,g=p.keys(L.StorageScope.PROFILE,L.StorageTarget.MACHINE);for(const v of g){const C=m.fromKey(v);if(C){let S=I.get(C.id.toLowerCase());S||I.set(C.id.toLowerCase(),S=[]),S.push(C.version)}}return I}constructor(p,I,g){super(),this.storageService=p,this.productService=I,this.logService=g,this._onDidChangeExtensionStorageToSync=this._register(new a.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=m.readAllExtensionsWithKeysForSync(p),this._register(this.storageService.onDidChangeValue(L.StorageScope.PROFILE,void 0,this._register(new _.DisposableStore))(v=>this.onDidChangeStorageValue(v)))}onDidChangeStorageValue(p){if(this.extensionsWithKeysForSync.has(p.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const I=m.fromKey(p.key);if(I){if(this.storageService.get(p.key,L.StorageScope.PROFILE)===void 0)this.extensionsWithKeysForSync.delete(I.id.toLowerCase());else{let g=this.extensionsWithKeysForSync.get(I.id.toLowerCase());g||this.extensionsWithKeysForSync.set(I.id.toLowerCase(),g=[]),g.push(I.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(p){if((0,R.isString)(p))return p;const I=p.manifest?p.manifest.publisher:p.publisher,g=p.manifest?p.manifest.name:p.name;return(0,k.getExtensionId)(I,g)}getExtensionState(p,I){const g=this.getExtensionId(p),v=this.getExtensionStateRaw(p,I);if(v)try{return JSON.parse(v)}catch(C){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${I}): ${C}`)}}getExtensionStateRaw(p,I){const g=this.getExtensionId(p),v=this.storageService.get(g,I?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE);return v&&v?.length>m.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${g}, global: ${I}): ${v.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),v}setExtensionState(p,I,g){const v=this.getExtensionId(p);I===void 0?this.storageService.remove(v,g?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE):this.storageService.store(v,JSON.stringify(I),g?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE,L.StorageTarget.MACHINE)}setKeysForSync(p,I){this.storageService.store(m.toKey(p),JSON.stringify(I),L.StorageScope.PROFILE,L.StorageTarget.MACHINE)}getKeysForSync(p){const I=this.productService.extensionSyncedKeys?.[p.id.toLowerCase()],g=this.storageService.get(m.toKey(p),L.StorageScope.PROFILE),v=g?JSON.parse(g):void 0;return v&&I?(0,D.distinct)([...v,...I]):v||I}addToMigrationList(p,I){if(p!==I){const g=this.migrationList.filter(v=>!v.includes(p)&&!v.includes(I));g.push([p,I]),this.migrationList=g}}getSourceExtensionToMigrate(p){const I=this.migrationList.find(([,g])=>p===g);return I?I[0]:void 0}get migrationList(){const p=this.storageService.get("extensionStorage.migrationList",L.StorageScope.APPLICATION,"[]");try{const I=JSON.parse(p);if(Array.isArray(I))return I}catch{}return[]}set migrationList(p){p.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(p),L.StorageScope.APPLICATION,L.StorageTarget.MACHINE):this.storageService.remove("extensionStorage.migrationList",L.StorageScope.APPLICATION)}};e.ExtensionStorageService=f,e.ExtensionStorageService=f=m=we([Q(0,L.IStorageService),Q(1,T.IProductService),Q(2,E.ILogService)],f)}),define(ue[219],he([0,1,2,27,85,197,117,10,16]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let E=class extends P.Disposable{constructor(m,d,f,l,p,I){super(),m.cleanUp(),(0,L.migrateUnsupportedExtensions)(m,d,f,l,I),_.ExtensionStorageService.removeOutdatedExtensionVersions(m,p)}};e.ExtensionsContributions=E,e.ExtensionsContributions=E=we([Q(0,k.INativeServerExtensionManagementService),Q(1,a.IExtensionGalleryService),Q(2,_.IExtensionStorageService),Q(3,a.IGlobalExtensionEnablementService),Q(4,D.IStorageService),Q(5,T.ILogService)],E)}),define(ue[220],he([0,1,17,2,20,9,7,23,6,3,13,5,37,35,74,34,16]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let g=class extends a.Disposable{constructor(u,i){super(),this.fileService=u,this.productService=i,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,n])=>this.allConfigBasedTips.set(n.configPath,n))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const i=[];for(const[n,t]of this.allConfigBasedTips)if(!(t.configScheme&&t.configScheme!==u.scheme))try{const s=(await this.fileService.readFile((0,_.joinPath)(u,n))).value.toString();for(const[r,o]of Object.entries(t.recommendations))(!o.contentPattern||new RegExp(o.contentPattern,"mig").test(s))&&i.push({extensionId:r,extensionName:o.name,configName:t.configName,important:!!o.important,isExtensionPack:!!o.isExtensionPack,whenNotInstalled:o.whenNotInstalled})}catch{}return i}};e.ExtensionTipsService=g,e.ExtensionTipsService=g=we([Q(0,k.IFileService),Q(1,T.IProductService)],g);const v="extensionTips/promptedExecutableTips",C="extensionTips/lastPromptedMediumImpExeTime";class S extends g{constructor(u,i,n,t,s,r,o,h){super(o,h),this.userHome=u,this.windowEvents=i,this.telemetryService=n,this.extensionManagementService=t,this.storageService=s,this.extensionRecommendationNotificationService=r,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,h.exeBasedExtensionTips&&Object.entries(h.exeBasedExtensionTips).forEach(([y,A])=>{const b=[],w=[],O=[];Object.entries(A.recommendations).forEach(([N,F])=>{F.important?A.important?b.push({extensionId:N,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):w.push({extensionId:N,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):O.push({extensionId:N,extensionName:F.name,isExtensionPack:!!F.isExtensionPack})}),b.length&&this.highImportanceExecutableTips.set(y,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:b}),w.length&&this.mediumImportanceExecutableTips.set(y,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:w}),O.length&&this.allOtherExecutableTips.set(y,{exeFriendlyName:A.friendlyName,windowsPath:A.windowsPath,recommendations:O})}),(0,D.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),i=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...i]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),i=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),n=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,n),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(i,n)}groupImportantTipsByExe(u,i){const n=new Map;u.forEach(h=>n.set(h.extensionId.toLowerCase(),h));const{installed:t,uninstalled:s}=this.groupByInstalled([...n.keys()],i);for(const h of t){const y=n.get(h);y&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:h,exeName:y.exeName})}for(const h of s){const y=n.get(h);y&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:h,exeName:y.exeName})}const r=this.getPromptedExecutableTips(),o=new Map;for(const h of s){const y=n.get(h);if(y&&(!r[y.exeName]||!r[y.exeName].includes(y.extensionId))){let A=o.get(y.exeName);A||(A=[],o.set(y.exeName,A)),A.push(y)}}return o}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,i]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(i).then(n=>{switch(n){case l.RecommendationsNotificationResult.Accepted:this.addToRecommendedExecutables(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.highImportanceTipsByExe.delete(u);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=E.Event.once(E.Event.latch(E.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(t(()=>this.promptHighImportanceExeBasedTip()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this._register(new a.MutableDisposable);t.value=(0,D.disposableTimeout)(()=>{t.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),i=Date.now()-u,n=7*24*60*60*1e3;if(i<n){const r=this._register(new a.MutableDisposable);r.value=(0,D.disposableTimeout)(()=>{r.dispose(),this.promptMediumImportanceExeBasedTip()},n-i);return}const[t,s]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(t),this.addToRecommendedExecutables(s[0].exeName,s);const o=this._register(new a.MutableDisposable);o.value=(0,D.disposableTimeout)(()=>{o.dispose(),this.promptMediumImportanceExeBasedTip()},n);break}case l.RecommendationsNotificationResult.Ignored:this.mediumImportanceTipsByExe.delete(t),this.promptMediumImportanceExeBasedTip();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const o=E.Event.once(E.Event.latch(E.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(o(()=>this.promptMediumImportanceExeBasedTip()));break}case l.RecommendationsNotificationResult.TooMany:{const o=this._register(new a.MutableDisposable);o.value=(0,D.disposableTimeout)(()=>{o.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(u){const i=await this.extensionManagementService.getInstalled(p.ExtensionType.User),n=u.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(s=>i.every(r=>!(0,f.areSameExtensions)(r.identifier,{id:s})))).map(({extensionId:t})=>t.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:n,source:l.RecommendationSource.EXE,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(C,I.StorageScope.APPLICATION);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(C,u,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(v,I.StorageScope.APPLICATION,"{}"))}addToRecommendedExecutables(u,i){const n=this.getPromptedExecutableTips();n[u]=i.map(({extensionId:t})=>t.toLowerCase()),this.storageService.store(v,JSON.stringify(n),I.StorageScope.APPLICATION,I.StorageTarget.USER)}groupByInstalled(u,i){const n=[],t=[],s=i.reduce((r,o)=>(r.add(o.identifier.id.toLowerCase()),r),new Set);return u.forEach(r=>{s.has(r.toLowerCase())?n.push(r):t.push(r)}),{installed:n,uninstalled:t}}async getValidExecutableBasedExtensionTips(u){const i=[],n=new Map;for(const t of u.keys()){const s=u.get(t);if(!s||!(0,P.isNonEmptyArray)(s.recommendations))continue;const r=[];m.isWindows?s.windowsPath&&r.push(s.windowsPath.replace("%USERPROFILE%",()=>d.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>d.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>d.env.ProgramFiles).replace("%APPDATA%",()=>d.env.APPDATA).replace("%WINDIR%",()=>d.env.WINDIR)):(r.push((0,R.join)("/usr/local/bin",t)),r.push((0,R.join)("/usr/bin",t)),r.push((0,R.join)(this.userHome.fsPath,t)));for(const o of r){let h=n.get(o);if(h===void 0&&(h=await this.fileService.exists(L.URI.file(o)),n.set(o,h)),h)for(const{extensionId:y,extensionName:A,isExtensionPack:b,whenNotInstalled:w}of s.recommendations)i.push({extensionId:y,extensionName:A,isExtensionPack:b,exeName:t,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:w})}}return i}}e.AbstractNativeExtensionTipsService=S}),define(ue[221],he([0,1,27,7,23,15,74,57,16,18,220]),function(ae,e,P,a,_,L,k,T,D,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends R.AbstractNativeExtensionTipsService{constructor(f,l,p,I,g,v,C,S){super(f.userHome,g,l,p,I,v,C,S)}};e.ExtensionTipsService=m,e.ExtensionTipsService=m=we([Q(0,L.INativeEnvironmentService),Q(1,E.ITelemetryService),Q(2,P.IExtensionManagementService),Q(3,D.IStorageService),Q(4,T.INativeHostService),Q(5,k.IExtensionRecommendationNotificationService),Q(6,a.IFileService),Q(7,_.IProductService)],m)}),define(ue[49],he([0,1,14,32,16]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=L;async function L(k,T,D){let E=D&&D.get("storage.serviceMachineId",_.StorageScope.APPLICATION)||null;if(E)return E;try{const m=(await T.readFile(k.serviceMachineIdResource)).value.toString();E=(0,a.isUUID)(m)?m:null}catch{E=null}if(!E){E=(0,a.generateUuid)();try{await T.writeFile(k.serviceMachineIdResource,P.VSBuffer.fromString(E))}catch{}}return D?.store("storage.serviceMachineId",E,_.StorageScope.APPLICATION,_.StorageTarget.MACHINE),E}}),define(ue[222],he([0,1,49,18,48]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=L;async function L(k,T,D,E,R,m,d){const f={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${T.nameShort})`};if((0,_.supportsTelemetry)(T,D)&&(0,_.getTelemetryLevel)(E)===a.TelemetryLevel.USAGE){const l=await(0,P.getServiceMachineId)(D,R,m);f["X-Market-User-Id"]=l,f["VSCode-SessionId"]=d.machineId||l}return f}}),define(ue[223],he([0,1,17,25,8,5,37,12,9,21,15,27,35,34,59,7,10,23,61,222,16,18,54]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=X;const i=L.isWeb?f.TargetPlatform.WEB:(0,m.getTargetPlatform)(L.platform,k.arch),n="X-Market-Search-Activity-Id";var t;(function(x){x[x.None=0]="None",x[x.IncludeVersions=1]="IncludeVersions",x[x.IncludeFiles=2]="IncludeFiles",x[x.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",x[x.IncludeSharedAccounts=8]="IncludeSharedAccounts",x[x.IncludeVersionProperties=16]="IncludeVersionProperties",x[x.ExcludeNonValidated=32]="ExcludeNonValidated",x[x.IncludeInstallationTargets=64]="IncludeInstallationTargets",x[x.IncludeAssetUri=128]="IncludeAssetUri",x[x.IncludeStatistics=256]="IncludeStatistics",x[x.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",x[x.Unpublished=4096]="Unpublished",x[x.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function s(...x){return String(x.reduce((B,j)=>B|j,0))}var r;(function(x){x[x.Tag=1]="Tag",x[x.ExtensionId=4]="ExtensionId",x[x.Category=5]="Category",x[x.ExtensionName=7]="ExtensionName",x[x.Target=8]="Target",x[x.Featured=9]="Featured",x[x.SearchText=10]="SearchText",x[x.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},A={pageNumber:1,pageSize:10,sortBy:m.SortBy.NoneOrRelevance,sortOrder:m.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class b{constructor(B=A){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(B,j=this.state.pageSize){return new b({...this.state,pageNumber:B,pageSize:j})}withFilter(B,...j){const G=[...this.state.criteria,...j.length?j.map(ie=>({filterType:B,value:ie})):[{filterType:B}]];return new b({...this.state,criteria:G})}withSortBy(B){return new b({...this.state,sortBy:B})}withSortOrder(B){return new b({...this.state,sortOrder:B})}withFlags(...B){return new b({...this.state,flags:B.reduce((j,G)=>j|G,0)})}withAssetTypes(...B){return new b({...this.state,assetTypes:B})}withSource(B){return new b({...this.state,source:B})}get raw(){const{criteria:B,pageNumber:j,pageSize:G,sortBy:ie,sortOrder:ce,flags:ge,assetTypes:Se}=this.state;return{filters:[{criteria:B,pageNumber:j,pageSize:G,sortBy:ie,sortOrder:ce}],assetTypes:Se,flags:ge}}get searchText(){const B=this.state.criteria.filter(j=>j.filterType===r.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function w(x,B){const j=(x||[]).filter(G=>G.statisticName===B)[0];return j?j.value:0}function O(x){const B="Microsoft.VisualStudio.Code.Translation.";return x.files.filter(G=>G.assetType.indexOf(B)===0).reduce((G,ie)=>{const ce=M(x,ie.assetType);return ce&&G.push([ie.assetType.substring(B.length),ce]),G},[])}function N(x){if(x.properties){const B=x.properties.filter(ie=>ie.key===o.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=B.filter(ie=>j.test(ie.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return M(x,o.Repository)}function F(x){return{uri:`${x.fallbackAssetUri}/${o.VSIX}?redirect=true${x.targetPlatform?`&targetPlatform=${x.targetPlatform}`:""}`,fallbackUri:`${x.fallbackAssetUri}/${o.VSIX}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`}}function M(x,B){return x.files.filter(G=>G.assetType===B)[0]?{uri:`${x.assetUri}/${B}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`,fallbackUri:`${x.fallbackAssetUri}/${B}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`}:null}function H(x,B){const j=x.properties?x.properties.filter(ie=>ie.key===B):[],G=j.length>0&&j[0].value;return G?G.split(",").map(ie=>(0,d.adoptToGalleryExtensionId)(ie)):[]}function z(x){const B=x.properties?x.properties.filter(j=>j.key===h.Engine):[];return B.length>0&&B[0].value||""}function J(x){const B=x.properties?x.properties.filter(j=>j.key===h.PreRelease):[];return B.length>0&&B[0].value==="true"}function V(x){const B=x.properties?x.properties.filter(j=>j.key===h.ExecutesCode):[];return B.length>0?B[0].value==="true":void 0}function te(x){const B=x.properties?x.properties.filter(G=>G.key===h.EnabledApiProposals):[],j=B.length>0&&B[0].value||"";return j?j.split(","):[]}function $(x){const B=x.properties?x.properties.filter(G=>G.key===h.LocalizedLanguages):[],j=B.length>0&&B[0].value||"";return j?j.split(","):[]}function q(x){return x.properties?.find(B=>B.key===h.SponsorLink)?.value}function Z(x){return x.properties?.find(B=>B.key===h.SupportLink)?.value}function ne(x){return x.indexOf("preview")!==-1}function le(x){return x.targetPlatform?(0,m.toTargetPlatform)(x.targetPlatform):f.TargetPlatform.UNDEFINED}function ee(x){const B=(0,P.distinct)(x.versions.map(le)),j=!!x.tags?.includes(m.WEB_EXTENSION_TAG),G=B.indexOf(f.TargetPlatform.WEB);return j?G===-1&&B.push(f.TargetPlatform.WEB):G!==-1&&B.splice(G,1),B}function X(x,B){for(let j=0;j<x.length;j++){const G=x[j];if(G.version===x[j-1]?.version){let ie=j;if(le(G)===B)for(;ie>0&&x[ie-1].version===G.version;)ie--;ie!==j&&(x.splice(j,1),x.splice(ie,0,G))}}return x}function K(x,B,j){x.telemetryData={index:B,querySource:j,queryActivityId:x.queryContext?.[n]}}function W(x,B,j,G){const ie=x.versions[0],ce={manifest:M(B,o.Manifest),readme:M(B,o.Details),changelog:M(B,o.Changelog),license:M(B,o.License),repository:N(B),download:F(B),icon:M(B,o.Icon),signature:M(B,o.Signature),coreTranslations:O(B)};return{type:"gallery",identifier:{id:(0,d.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},name:x.extensionName,version:B.version,displayName:x.displayName,publisherId:x.publisher.publisherId,publisher:x.publisher.publisherName,publisherDisplayName:x.publisher.displayName,publisherDomain:x.publisher.domain?{link:x.publisher.domain,verified:!!x.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(ie),description:x.shortDescription??"",installCount:w(x.statistics,"install"),rating:w(x.statistics,"averagerating"),ratingCount:w(x.statistics,"ratingcount"),categories:x.categories||[],tags:x.tags||[],releaseDate:Date.parse(x.releaseDate),lastUpdated:Date.parse(x.lastUpdated),allTargetPlatforms:j,assets:ce,properties:{dependencies:H(B,h.Dependency),extensionPack:H(B,h.ExtensionPack),engine:z(B),enabledApiProposals:te(B),localizedLanguages:$(B),targetPlatform:le(B),isPreReleaseVersion:J(B),executesCode:V(B)},hasPreReleaseVersion:J(ie),hasReleaseVersion:!0,preview:ne(x.flags),isSigned:!!ce.signature,queryContext:G,supportLink:Z(ie)}}let U=class{constructor(B,j,G,ie,ce,ge,Se,Ie){this.requestService=j,this.logService=G,this.environmentService=ie,this.telemetryService=ce,this.fileService=ge,this.productService=Se,this.configurationService=Ie;const Ce=Se.extensionsGallery,Ee=Ce?.servicePPEUrl&&Ie.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=Ee?Ce.servicePPEUrl:Ce?.serviceUrl,this.extensionsGallerySearchUrl=Ee?void 0:Ce?.searchUrl,this.extensionsControlUrl=Ce?.controlUrl,this.extensionsEnabledWithApiProposalVersion=Se.extensionsEnabledWithApiProposalVersion?.map(ve=>ve.toLowerCase())??[],this.commonHeadersPromise=(0,C.resolveMarketplaceHeaders)(Se.version,Se,this.environmentService,this.configurationService,this.fileService,B,this.telemetryService)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,j,G){const ie=a.CancellationToken.isCancellationToken(j)?{}:j,ce=a.CancellationToken.isCancellationToken(j)?j:G,ge=[],Se=[],Ie=[],Ce=[];let Ee=!0;for(const re of B){re.uuid?Se.push(re.uuid):ge.push(re.id);const fe=!!(re.version||re.preRelease);Ie.push({id:re.id,uuid:re.uuid,includePreRelease:fe}),re.version&&Ce.push({id:re.id,uuid:re.uuid,version:re.version}),Ee=Ee&&!!re.hasPreRelease&&!fe}if(!Se.length&&!ge.length)return[];let ve=new b().withPage(1,B.length);Se.length&&(ve=ve.withFilter(r.ExtensionId,...Se)),ge.length&&(ve=ve.withFilter(r.ExtensionName,...ge)),(ie.queryAllVersions||Ee)&&(ve=ve.withFlags(ve.flags,t.IncludeVersions)),ie.source&&(ve=ve.withSource(ie.source));const{extensions:be}=await this.queryGalleryExtensions(ve,{targetPlatform:ie.targetPlatform??i,includePreRelease:Ie,versions:Ce,compatible:!!ie.compatible,productVersion:ie.productVersion??{version:this.productService.version,date:this.productService.date}},ce);return ie.source&&be.forEach((re,fe)=>K(re,fe,ie.source)),be}async getCompatibleExtension(B,j,G,ie={version:this.productService.version,date:this.productService.date}){if((0,m.isNotWebExtensionInWebTargetPlatform)(B.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(B,j,G))return B;const ce=new b().withFlags(t.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,B.identifier.uuid),{extensions:ge}=await this.queryGalleryExtensions(ce,{targetPlatform:G,compatible:!0,includePreRelease:j,productVersion:ie},a.CancellationToken.None);return ge[0]||null}async isExtensionCompatible(B,j,G,ie={version:this.productService.version,date:this.productService.date}){if(!(0,m.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,G)||!j&&B.properties.isPreReleaseVersion)return!1;let ce=B.properties.engine;if(!ce){const ge=await this.getManifest(B,a.CancellationToken.None);if(!ge)throw new Error("Manifest was not found");ce=ge.engines.vscode}return!(!(0,l.isEngineValid)(ce,ie.version,ie.date)||!this.areApiProposalsCompatible(B.identifier,B.properties.enabledApiProposals))}areApiProposalsCompatible(B,j){return!j||!this.extensionsEnabledWithApiProposalVersion.includes(B.id.toLowerCase())?!0:(0,l.areApiProposalsCompatible)(j)}async isValidVersion(B,j,G,ie,ce,ge,Se={version:this.productService.version,date:this.productService.date}){if(!(0,m.isTargetPlatformCompatible)(le(j),ce,ge)||G!=="any"&&J(j)!==(G==="prerelease"))return!1;if(ie)try{const Ie=await this.getEngine(B,j);if(!(0,l.isEngineValid)(Ie,Se.version,Se.date))return!1}catch(Ie){return this.logService.error(`Error while getting the engine for the version ${j.version}.`,(0,_.getErrorMessage)(Ie)),!1}return!0}async query(B,j){let G=B.text||"";const ie=B.pageSize??50;let ce=new b().withPage(1,ie);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,ve,be)=>(ce=ce.withFilter(r.Category,be||ve),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,ve,be)=>(ce=ce.withFilter(r.Tag,be||ve),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(ce=ce.withFilter(r.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),ce=ce.withFilter(r.SearchText,G)),ce=ce.withSortBy(m.SortBy.NoneOrRelevance)):B.ids?ce=ce.withFilter(r.ExtensionId,...B.ids):B.names?ce=ce.withFilter(r.ExtensionName,...B.names):ce=ce.withSortBy(m.SortBy.InstallCount),typeof B.sortBy=="number"&&(ce=ce.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(ce=ce.withSortOrder(B.sortOrder)),B.source&&(ce=ce.withSource(B.source));const ge=async(Ee,ve)=>{const{extensions:be,total:re}=await this.queryGalleryExtensions(Ee,{targetPlatform:i,compatible:!1,includePreRelease:!!B.includePreRelease,productVersion:B.productVersion??{version:this.productService.version,date:this.productService.date}},ve);return be.forEach((fe,me)=>K(fe,(Ee.pageNumber-1)*Ee.pageSize+me,B.source)),{extensions:be,total:re}},{extensions:Se,total:Ie}=await ge(ce,j),Ce=async(Ee,ve)=>{if(ve.isCancellationRequested)throw new _.CancellationError;const{extensions:be}=await ge(ce.withPage(Ee+1),ve);return be};return{firstPage:Se,total:Ie,pageSize:ce.pageSize,getPage:Ce}}async queryGalleryExtensions(B,j,G){const ie=B.flags;B.flags&t.IncludeLatestVersionOnly&&B.flags&t.IncludeVersions&&(B=B.withFlags(B.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(B.flags&t.IncludeLatestVersionOnly)&&!(B.flags&t.IncludeVersions)&&(B=B.withFlags(B.flags,t.IncludeLatestVersionOnly)),j.versions?.length&&(B=B.withFlags(B.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),B=B.withFlags(B.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ce,total:ge,context:Se}=await this.queryRawGalleryExtensions(B,G);if(!(B.flags&t.IncludeLatestVersionOnly)){const ve=[];for(const be of ce){const re=await this.toGalleryExtensionWithCriteria(be,j,Se);re&&ve.push(re)}return{extensions:ve,total:ge}}const Ce=[],Ee=new Map;for(let ve=0;ve<ce.length;ve++){const be=ce[ve],re={id:(0,d.getGalleryExtensionId)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},fe=(0,T.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(Pe=>(0,d.areSameExtensions)(Pe,re))?.includePreRelease;if(j.compatible&&(0,m.isNotWebExtensionInWebTargetPlatform)(ee(be),j.targetPlatform))continue;const me=await this.toGalleryExtensionWithCriteria(be,j,Se);!me||me.properties.isPreReleaseVersion&&(!fe||!me.hasReleaseVersion)||!me.properties.isPreReleaseVersion&&me.properties.targetPlatform!==j.targetPlatform&&me.hasPreReleaseVersion?Ee.set(be.extensionId,ve):Ce.push([ve,me])}if(Ee.size){const ve=new u.StopWatch,be=new b().withFlags(ie&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,Ee.size).withFilter(r.ExtensionId,...Ee.keys()),{extensions:re}=await this.queryGalleryExtensions(be,j,G);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:ve.elapsed(),count:Ee.size});for(const fe of re){const me=Ee.get(fe.identifier.uuid);Ce.push([me,fe])}}return{extensions:Ce.sort((ve,be)=>ve[0]-be[0]).map(([,ve])=>ve),total:ge}}async toGalleryExtensionWithCriteria(B,j,G){const ie={id:(0,d.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},ce=j.versions?.find(Ce=>(0,d.areSameExtensions)(Ce,ie))?.version,ge=(0,T.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(Ce=>(0,d.areSameExtensions)(Ce,ie))?.includePreRelease,Se=ee(B),Ie=X(B.versions,j.targetPlatform);if(j.compatible&&(0,m.isNotWebExtensionInWebTargetPlatform)(Se,j.targetPlatform))return null;for(let Ce=0;Ce<Ie.length;Ce++){const Ee=Ie[Ce];if(!(ce&&Ee.version!==ce)){if(await this.isValidVersion(ie.id,Ee,ge?"any":"release",j.compatible,Se,j.targetPlatform,j.productVersion))return j.compatible&&!this.areApiProposalsCompatible(ie,te(Ee))?null:W(B,Ee,Se,G);if(ce&&Ee.version===ce)return null}}return ce||j.compatible?null:W(B,B.versions[0],Se)}async queryRawGalleryExtensions(B,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,t.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,s(t.Unpublished));const G=await this.commonHeadersPromise,ie=JSON.stringify(B.raw),ce={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ie.length)},ge=new u.StopWatch;let Se,Ie,Ce=0;try{if(Se=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&B.criteria.some(ve=>ve.filterType===r.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ie,headers:ce},j),Se.res.statusCode&&Se.res.statusCode>=400&&Se.res.statusCode<500)return{galleryExtensions:[],total:Ce};const Ee=await(0,v.asJson)(Se);if(Ee){const ve=Ee.results[0],be=ve.extensions,re=ve.resultMetadata&&ve.resultMetadata.filter(fe=>fe.metadataType==="ResultCount")[0];return Ce=re&&re.metadataItems.filter(fe=>fe.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:Ce,context:Se.res.headers.activityid?{[n]:Se.res.headers.activityid}:{}}}return{galleryExtensions:[],total:Ce}}catch(Ee){if((0,_.isCancellationError)(Ee))throw Ie=m.ExtensionGalleryErrorCode.Cancelled,Ee;{const ve=(0,_.getErrorMessage)(Ee);throw Ie=ve.startsWith("XHR timeout")?m.ExtensionGalleryErrorCode.Timeout:m.ExtensionGalleryErrorCode.Failed,new m.ExtensionGalleryError(ve,Ie)}}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(ie.length),duration:ge.elapsed(),success:!!Se&&(0,v.isSuccess)(Se),responseBodySize:Se?.res.headers["Content-Length"],statusCode:Se?String(Se.res.statusCode):void 0,errorCode:Ie,count:String(Ce)})}}async reportStatistic(B,j,G,ie){if(!this.isEnabled())return;const ce=L.isWeb?this.api(`/itemName/${B}.${j}/version/${G}/statType/${ie===m.StatisticType.Install?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${j}/${G}/stats?statType=${ie}`),ge=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:ge};try{await this.requestService.request({type:"POST",url:ce,headers:Ie},a.CancellationToken.None)}catch{}}async download(B,j,G){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const ie=(0,d.getGalleryExtensionTelemetryData)(B),ce=new Date().getTime(),ge=G===m.InstallOperation.Install?"install":G===m.InstallOperation.Update?"update":"",Se=ge?{uri:`${B.assets.download.uri}${D.URI.parse(B.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${B.assets.download.fallbackUri}${D.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:B.assets.download,Ie=B.queryContext?.[n]?{[n]:B.queryContext[n]}:void 0,Ce=await this.getAsset(B.identifier.id,Se,o.VSIX,Ie?{headers:Ie}:void 0);try{await this.fileService.writeFile(j,Ce.stream)}catch(Ee){try{await this.fileService.del(j)}catch(ve){this.logService.warn(`Error while deleting the file ${j.toString()}`,(0,_.getErrorMessage)(ve))}throw new m.ExtensionGalleryError((0,_.getErrorMessage)(Ee),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.telemetryService.publicLog("galleryService:downloadVSIX",{...ie,duration:new Date().getTime()-ce})}async downloadSignatureArchive(B,j){if(!B.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const G=await this.getAsset(B.identifier.id,B.assets.signature,o.Signature);try{await this.fileService.writeFile(j,G.stream)}catch(ie){try{await this.fileService.del(j)}catch(ce){this.logService.warn(`Error while deleting the file ${j.toString()}`,(0,_.getErrorMessage)(ce))}throw new m.ExtensionGalleryError((0,_.getErrorMessage)(ie),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(B,j){if(B.assets.readme){const G=await this.getAsset(B.identifier.id,B.assets.readme,o.Details,{},j);return await(0,v.asTextOrError)(G)||""}return""}async getManifest(B,j){if(B.assets.manifest){const G=await this.getAsset(B.identifier.id,B.assets.manifest,o.Manifest,{},j),ie=await(0,v.asTextOrError)(G);return ie?JSON.parse(ie):null}return null}async getManifestFromRawExtensionVersion(B,j,G){const ie=M(j,o.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},ge=await this.getAsset(B,ie,o.Manifest,{headers:ce});return await(0,v.asJson)(ge)}async getCoreTranslation(B,j){const G=B.assets.coreTranslations.filter(ie=>ie[0]===j.toUpperCase())[0];if(G){const ie=await this.getAsset(B.identifier.id,G[1],G[0]),ce=await(0,v.asTextOrError)(ie);return ce?JSON.parse(ce):null}return null}async getChangelog(B,j){if(B.assets.changelog){const G=await this.getAsset(B.identifier.id,B.assets.changelog,o.Changelog,{},j);return await(0,v.asTextOrError)(G)||""}return""}async getAllCompatibleVersions(B,j,G){let ie=new b().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);B.uuid?ie=ie.withFilter(r.ExtensionId,B.uuid):ie=ie.withFilter(r.ExtensionName,B.id);const{galleryExtensions:ce}=await this.queryRawGalleryExtensions(ie,a.CancellationToken.None);if(!ce.length)return[];const ge=ee(ce[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(ge,G))return[];const Se=[];await Promise.all(ce[0].versions.map(async Ee=>{try{await this.isValidVersion(B.id,Ee,j?"any":"release",!0,ge,G)&&this.areApiProposalsCompatible(B,te(Ee))&&Se.push(Ee)}catch{}}));const Ie=[],Ce=new Set;for(const Ee of X(Se,G))Ce.has(Ee.version)||(Ce.add(Ee.version),Ie.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:J(Ee)}));return Ie}async getAsset(B,j,G,ie={},ce=a.CancellationToken.None){const ge=await this.commonHeadersPromise,Se={type:"GET"},Ie={...ge,...ie.headers||{}};ie={...ie,...Se,headers:Ie};const Ce=j.uri,Ee=j.fallbackUri,ve={...ie,url:Ce};try{const be=await this.requestService.request(ve,ce);if(be.res.statusCode===200)return be;const re=await(0,v.asTextOrError)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${re}`)}catch(be){if((0,_.isCancellationError)(be))throw be;const re=(0,_.getErrorMessage)(be);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:B,assetType:G,message:re});const fe={...ie,url:Ee};return this.requestService.request(fe,ce)}}async getEngine(B,j){let G=z(j);if(!G){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:B,version:j.version});const ie=await this.getManifestFromRawExtensionVersion(B,j,a.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");G=ie.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},a.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,v.asJson)(B),G=[],ie={},ce=[],ge=[];if(j){for(const Se of j.malicious)G.push({id:Se});if(j.migrateToPreRelease)for(const[Se,Ie]of Object.entries(j.migrateToPreRelease))(!Ie.engine||(0,l.isEngineValid)(Ie.engine,this.productService.version,this.productService.date))&&(ie[Se.toLowerCase()]={disallowInstall:!0,extension:{id:Ie.id,displayName:Ie.displayName,autoMigrate:{storage:!!Ie.migrateStorage},preRelease:!0}});if(j.deprecated)for(const[Se,Ie]of Object.entries(j.deprecated))Ie&&(ie[Se.toLowerCase()]=(0,T.isBoolean)(Ie)?{}:Ie);if(j.search)for(const Se of j.search)ce.push(Se);if(Array.isArray(j.extensionsEnabledWithPreRelease))for(const Se of j.extensionsEnabledWithPreRelease)ge.push(Se.toLowerCase())}return{malicious:G,deprecated:ie,search:ce,extensionsEnabledWithPreRelease:ge}}};U=we([Q(1,v.IRequestService),Q(2,I.ILogService),Q(3,R.IEnvironmentService),Q(4,c.ITelemetryService),Q(5,p.IFileService),Q(6,g.IProductService),Q(7,E.IConfigurationService)],U);let Y=class extends U{constructor(B,j,G,ie,ce,ge,Se,Ie){super(B,j,G,ie,ce,ge,Se,Ie)}};e.ExtensionGalleryService=Y,e.ExtensionGalleryService=Y=we([Q(0,S.IStorageService),Q(1,v.IRequestService),Q(2,I.ILogService),Q(3,R.IEnvironmentService),Q(4,c.ITelemetryService),Q(5,p.IFileService),Q(6,g.IProductService),Q(7,E.IConfigurationService)],Y);let oe=class extends U{constructor(B,j,G,ie,ce,ge,Se){super(void 0,B,j,G,ie,ce,ge,Se)}};e.ExtensionGalleryServiceWithNoStorageService=oe,e.ExtensionGalleryServiceWithNoStorageService=oe=we([Q(0,v.IRequestService),Q(1,I.ILogService),Q(2,R.IEnvironmentService),Q(3,c.ITelemetryService),Q(4,p.IFileService),Q(5,g.IProductService),Q(6,E.IConfigurationService)],oe)}),define(ue[224],he([0,1,107,3,18,15,2,10,13,68,23,5,6,101,21,11,38,16,12,143,20]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const c=[P.CONFIGURATION_KEY_HOST_NAME,P.CONFIGURATION_KEY_PREVENT_SLEEP],u="remoteTunnelSession",i="remoteTunnelIsService";let n=class extends k.Disposable{constructor(o,h,y,A,b,w,O){super(),this.telemetryService=o,this.productService=h,this.environmentService=y,this.configurationService=w,this.storageService=O,this._onDidTokenFailedEmitter=new a.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new a.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new a.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=P.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(N,F)=>{F?this._logger.error(N):this._logger.info(N)},this._logger=this._register(A.createLogger((0,S.joinPath)(y.logsHome,`${P.LOG_ID}.log`),{id:P.LOG_ID,name:P.LOGGER_NAME})),this._startTunnelProcessDelayer=new d.Delayer(100),this._register(this._logger.onDidChangeLogLevel(N=>this._logger.info("Log level changed to "+(0,T.LogLevelToString)(N)))),this._register(b.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(w.onDidChangeConfiguration(N=>{c.some(F=>N.affectsConfiguration(F))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=P.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(o){this._tunnelStatus=o,this._onDidChangeTunnelStatusEmitter.fire(o)}setMode(o){s(this._mode,o)||(this._mode=o,this._storeMode(o),this._onDidChangeModeEmitter.fire(this._mode),o.active?(this._logger.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this._logger.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(o){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(o);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(h){this._logger.error(h)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let o;m.isMacintosh?o=this.environmentService.appRoot:o=(0,D.dirname)((0,D.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,D.join)(o,"bin",`${this.productService.tunnelApplicationName}${m.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(o){if(s(this._mode,o)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(o);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(h){this._logger.error(h)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this._mode.active){const o=this._mode.asService;this.setMode(P.INACTIVE_TUNNEL_MODE);try{o&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(h){this._logger.error(h)}}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(o){this._logger.error(o)}this.setTunnelStatus(P.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let o="",h=!1;const y=(F,M)=>{M?this._logger.error(F):o+=F,!this.environmentService.isBuilt&&F.startsWith("   Compiling")&&this.setTunnelStatus(P.TunnelStates.connecting((0,p.localize)(11234,null)))},A=this.runCodeTunnelCommand("status",["status"],y);this._tunnelProcess=A;try{if(await A,this._tunnelProcess!==A)return;let F;try{F=JSON.parse(o.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this._logger.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.setTunnelStatus(P.TunnelStates.disconnected());return}if(h=F.service_installed,this._logger.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this._mode.active){this.setTunnelStatus(P.TunnelStates.disconnected());return}}catch(F){this._logger.error(F),this.setTunnelStatus(P.TunnelStates.disconnected());return}finally{this._tunnelProcess===A&&(this._tunnelProcess=void 0)}const b=this._mode.active?this._mode.session:void 0;if(b&&b.token){const F=b.token;this.setTunnelStatus(P.TunnelStates.connecting((0,p.localize)(11235,null,b.accountLabel,b.providerId)));const M=(z,J)=>{z=z.replaceAll(F,"*".repeat(4)),y(z,J)},H=this.runCodeTunnelCommand("login",["user","login","--provider",b.providerId,"--log",(0,T.LogLevelToString)(this._logger.getLevel())],M,{VSCODE_CLI_ACCESS_TOKEN:F});this._tunnelProcess=H;try{if(await H,this._tunnelProcess!==H)return}catch(z){this._logger.error(z),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(b),this.setTunnelStatus(P.TunnelStates.disconnected(b));return}}const w=this._getTunnelName();w?this.setTunnelStatus(P.TunnelStates.connecting((0,p.localize)(11236,null,w))):this.setTunnelStatus(P.TunnelStates.connecting((0,p.localize)(11237,null)));const O=["--accept-server-license-terms","--log",(0,T.LogLevelToString)(this._logger.getLevel())];w?O.push("--name",w):O.push("--random-name");let N=!1;return this._mode.active&&this._mode.asService&&!h&&(N=await this.installTunnelService(O)===!1),this.serverOrAttachTunnel(b,O,N)}async installTunnelService(o){let h;try{h=await this.runCodeTunnelCommand("serviceInstall",["service","install",...o])}catch(y){this._logger.error(y),h=1}if(h!==0){const y=(0,p.localize)(11238,null);return this._logger.warn(y),this.setTunnelStatus(P.TunnelStates.connecting(y)),!1}return!0}async serverOrAttachTunnel(o,h,y){h.push("--parent-process-id",String(process.pid)),this._preventSleep()&&h.push("--no-sleep");let A=!1;const b=this.runCodeTunnelCommand("tunnel",h,(w,O)=>{O?this._logger.error(w):this._logger.info(w),w.includes("Connected to an existing tunnel process")&&(A=!0);const N=w.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(N){const F={link:N[1],domain:N[2],tunnelName:N[4],isAttached:A};this.setTunnelStatus(P.TunnelStates.connected(F,y))}else w.match(/error refreshing token/)&&(b.cancel(),this._onDidTokenFailedEmitter.fire(o),this.setTunnelStatus(P.TunnelStates.disconnected(o)))});this._tunnelProcess=b,b.finally(()=>{b===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=P.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(P.TunnelStates.disconnected()))})}runCodeTunnelCommand(o,h,y=this.defaultOnOutput,A){return(0,d.createCancelablePromise)(b=>new Promise((w,O)=>{b.isCancellationRequested&&w(-1);let N;const F=["ignore","pipe","pipe"];if(b.onCancellationRequested(()=>{N&&(this._logger.info(`${o} terminating(${N.pid})`),N.kill())}),!this.environmentService.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${o} Spawning: cargo run -- tunnel ${h.join(" ")}
`,!1),N=(0,E.spawn)("cargo",["run","--","tunnel",...h],{cwd:(0,D.join)(this.environmentService.appRoot,"cli"),stdio:F,env:{...process.env,RUST_BACKTRACE:"1",...A}});else{y(`Running tunnel CLI
`,!1);const M=this.getTunnelCommandLocation();y(`${o} Spawning: ${M} tunnel ${h.join(" ")}
`,!1),N=(0,E.spawn)(M,["tunnel",...h],{cwd:(0,I.homedir)(),stdio:F,env:{...process.env,...A}})}N.stdout.pipe(new C.StreamSplitter(`
`)).on("data",M=>{if(N){const H=M.toString();y(H,!1)}}),N.stderr.pipe(new C.StreamSplitter(`
`)).on("data",M=>{if(N){const H=M.toString();y(H,!0)}}),N.on("exit",M=>{N&&(y(`${o} exit(${N.pid}): + ${M} `,!1),N=void 0,w(M||0))}),N.on("error",M=>{N&&(y(`${o} error(${N.pid}): + ${M} `,!0),N=void 0,O())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(P.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let o=this.configurationService.getValue(P.CONFIGURATION_KEY_HOST_NAME)||(0,I.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}_restoreMode(){try{const o=this.storageService.get(u,g.StorageScope.APPLICATION),h=this.storageService.getBoolean(i,g.StorageScope.APPLICATION,!1);if(o){const y=JSON.parse(o);if(y&&(0,v.isString)(y.accountLabel)&&(0,v.isString)(y.sessionId)&&(0,v.isString)(y.providerId))return{active:!0,session:y,asService:h};this._logger.error("Problems restoring session from storage, invalid format",y)}}catch(o){this._logger.error("Problems restoring session from storage",o)}return P.INACTIVE_TUNNEL_MODE}_storeMode(o){if(o.active){const h={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.storageService.store(u,JSON.stringify(h),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),this.storageService.store(i,o.asService,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE)}else this.storageService.remove(u,g.StorageScope.APPLICATION),this.storageService.remove(i,g.StorageScope.APPLICATION)}};e.RemoteTunnelService=n,e.RemoteTunnelService=n=we([Q(0,_.ITelemetryService),Q(1,R.IProductService),Q(2,L.INativeEnvironmentService),Q(3,T.ILoggerService),Q(4,f.ISharedProcessLifecycleService),Q(5,l.IConfigurationService),Q(6,g.IStorageService)],n);function t(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const s=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&t(r.session,o.session):!0}),define(ue[225],he([0,1,6,2,22,20,70,16,79,19]),function(ae,e,P,a,_,L,k,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class R extends T.AbstractStorageService{constructor(d,f,l,p){super(),this.initialWorkspace=d,this.initialProfiles=f,this.remoteService=l,this.environmentService=p,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new a.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new a.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const d=this._register(new D.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),f=this._register(new k.Storage(d));return this._register(f.onDidChangeStorage(l=>this.emitDidChangeValue(T.StorageScope.APPLICATION,l))),f}createProfileStorage(d){this.profileStorageDisposables.clear(),this.profileStorageProfile=d;let f;if((0,T.isProfileUsingDefaultStorage)(d))f=this.applicationStorage;else{const l=this.profileStorageDisposables.add(new D.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),d));f=this.profileStorageDisposables.add(new k.Storage(l))}return this.profileStorageDisposables.add(f.onDidChangeStorage(l=>this.emitDidChangeValue(T.StorageScope.PROFILE,l))),f}createWorkspaceStorage(d){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=d?.id;let f;if(d){const l=this.workspaceStorageDisposables.add(new D.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),d));f=this.workspaceStorageDisposables.add(new k.Storage(l)),this.workspaceStorageDisposables.add(f.onDidChangeStorage(p=>this.emitDidChangeValue(T.StorageScope.WORKSPACE,p)))}return f}async doInitialize(){await P.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(d){switch(d){case T.StorageScope.APPLICATION:return this.applicationStorage;case T.StorageScope.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(d){switch(d){case T.StorageScope.APPLICATION:return this.applicationStorageProfile.globalStorageHome.with({scheme:_.Schemas.file}).fsPath;case T.StorageScope.PROFILE:return this.profileStorageProfile?.globalStorageHome.with({scheme:_.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:_.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await P.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(d){if(!this.canSwitchProfile(this.profileStorageProfile,d))return;const f=this.profileStorage,l=f.items;f!==this.applicationStorage&&await f.close(),this.profileStorage=this.createProfileStorage(d),await this.profileStorage.init(),this.switchData(l,this.profileStorage,T.StorageScope.PROFILE)}async switchToWorkspace(d,f){const l=this.workspaceStorage,p=l?.items??new Map;await l?.close(),this.workspaceStorage=this.createWorkspaceStorage(d),await this.workspaceStorage.init(),this.switchData(p,this.workspaceStorage,T.StorageScope.WORKSPACE)}hasScope(d){return(0,E.isUserDataProfile)(d)?this.profileStorageProfile.id===d.id:this.workspaceStorageId===d.id}}e.RemoteStorageService=R}),define(ue[226],he([0,1,3,2,19,94]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class k{constructor(E,R){this.service=E,this.getUriTransformer=R}listen(E,R){const m=this.getUriTransformer(E);switch(R){case"onDidChangeProfiles":return P.Event.map(this.service.onDidChangeProfiles,d=>({all:d.all.map(f=>(0,L.transformOutgoingURIs)({...f},m)),added:d.added.map(f=>(0,L.transformOutgoingURIs)({...f},m)),removed:d.removed.map(f=>(0,L.transformOutgoingURIs)({...f},m)),updated:d.updated.map(f=>(0,L.transformOutgoingURIs)({...f},m))}))}throw new Error(`Invalid listen ${R}`)}async call(E,R,m){const d=this.getUriTransformer(E);switch(R){case"createProfile":{const f=await this.service.createProfile(m[0],m[1],m[2]);return(0,L.transformOutgoingURIs)({...f},d)}case"updateProfile":{let f=(0,_.reviveProfile)((0,L.transformIncomingURIs)(m[0],d),this.service.profilesHome.scheme);return f=await this.service.updateProfile(f,m[1]),(0,L.transformOutgoingURIs)({...f},d)}case"removeProfile":{const f=(0,_.reviveProfile)((0,L.transformIncomingURIs)(m[0],d),this.service.profilesHome.scheme);return this.service.removeProfile(f)}}throw new Error(`Invalid call ${R}`)}}e.RemoteUserDataProfilesServiceChannel=k;class T extends a.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(E,R,m){super(),this.profilesHome=R,this.channel=m,this._profiles=[],this._onDidChangeProfiles=this._register(new P.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=E.map(d=>(0,_.reviveProfile)(d,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(d=>{const f=d.added.map(I=>(0,_.reviveProfile)(I,this.profilesHome.scheme)),l=d.removed.map(I=>(0,_.reviveProfile)(I,this.profilesHome.scheme)),p=d.updated.map(I=>(0,_.reviveProfile)(I,this.profilesHome.scheme));this._profiles=d.all.map(I=>(0,_.reviveProfile)(I,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:f,removed:l,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(E){this.enabled=E}isEnabled(){return this.enabled}async createNamedProfile(E,R,m){const d=await this.channel.call("createNamedProfile",[E,R,m]);return(0,_.reviveProfile)(d,this.profilesHome.scheme)}async createProfile(E,R,m,d){const f=await this.channel.call("createProfile",[E,R,m,d]);return(0,_.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(E){const R=await this.channel.call("createTransientProfile",[E]);return(0,_.reviveProfile)(R,this.profilesHome.scheme)}async setProfileForWorkspace(E,R){await this.channel.call("setProfileForWorkspace",[E,R])}removeProfile(E){return this.channel.call("removeProfile",[E])}async updateProfile(E,R){const m=await this.channel.call("updateProfile",[E,R]);return(0,_.reviveProfile)(m,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=T}),define(ue[62],he([0,1,2,70,4,16,3,79,19]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,_.createDecorator)("IUserDataProfileStorageService");let E=class extends P.Disposable{constructor(f,l){super(),this.storageService=l,f&&(this.storageServicesMap=this._register(new P.DisposableMap))}async readStorageData(f){return this.withProfileScopedStorageService(f,async l=>this.getItems(l))}async updateStorageData(f,l,p){return this.withProfileScopedStorageService(f,async I=>this.writeItems(I,l,p))}async withProfileScopedStorageService(f,l){if(this.storageService.hasScope(f))return l(this.storageService);let p=this.storageServicesMap?.get(f.id);if(!p){p=new m(this.createStorageDatabase(f)),this.storageServicesMap?.set(f.id,p);try{await p.initialize()}catch(I){throw this.storageServicesMap?.has(f.id)?this.storageServicesMap.deleteAndDispose(f.id):p.dispose(),I}}try{const I=await l(p);return await p.flush(),I}finally{this.storageServicesMap?.has(f.id)||p.dispose()}}getItems(f){const l=new Map,p=I=>{for(const g of f.keys(L.StorageScope.PROFILE,I))l.set(g,{value:f.get(g,L.StorageScope.PROFILE),target:I})};return p(L.StorageTarget.USER),p(L.StorageTarget.MACHINE),l}writeItems(f,l,p){f.storeAll(Array.from(l.entries()).map(([I,g])=>({key:I,value:g,scope:L.StorageScope.PROFILE,target:p})),!0)}};e.AbstractUserDataProfileStorageService=E,e.AbstractUserDataProfileStorageService=E=we([Q(1,L.IStorageService)],E);class R extends E{constructor(f,l,p,I,g){super(f,I),this.remoteService=l;const v=l.getChannel("profileStorageListener"),C=this._register(new P.MutableDisposable);this._onDidChange=this._register(new k.Emitter({onWillAddFirstListener:()=>{C.value=v.listen("onDidChange")(S=>{g.trace("profile storage changes",S),this._onDidChange.fire({targetChanges:S.targetChanges.map(c=>(0,D.reviveProfile)(c,p.profilesHome.scheme)),valueChanges:S.valueChanges.map(c=>({...c,profile:(0,D.reviveProfile)(c.profile,p.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>C.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(f){const l=this.remoteService.getChannel("storage");return(0,L.isProfileUsingDefaultStorage)(f)?new T.ApplicationStorageDatabaseClient(l):new T.ProfileStorageDatabaseClient(l,f)}}e.RemoteUserDataProfileStorageService=R;class m extends L.AbstractStorageService{constructor(f){super({flushInterval:100}),this.profileStorageDatabase=f}async doInitialize(){const f=await this.profileStorageDatabase,l=new a.Storage(f);return this._register(l.onDidChangeStorage(p=>{this.emitDidChangeValue(L.StorageScope.PROFILE,p)})),this._register((0,P.toDisposable)(()=>{l.close(),l.dispose(),(0,P.isDisposable)(f)&&f.dispose()})),this.profileStorage=l,this.profileStorage.init()}getStorage(f){return f===L.StorageScope.PROFILE?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ue[227],he([0,1,16,10,19,56,62]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessUserDataProfileStorageService=void 0;let T=class extends k.RemoteUserDataProfileStorageService{constructor(E,R,m,d){super(!0,E,R,m,d)}};e.SharedProcessUserDataProfileStorageService=T,e.SharedProcessUserDataProfileStorageService=T=we([Q(0,L.IMainProcessService),Q(1,_.IUserDataProfilesService),Q(2,P.IStorageService),Q(3,a.ILogService)],T)}),define(ue[40],he([0,1,17,6,14,25,3,36,2,26,12,11,21,15,7,10,49,16,18,28,24,19]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=void 0,e.isRemoteUserData=u,e.isSyncData=i,e.getSyncResourceLogLabel=n;function u(h){return!!(h&&h.ref!==void 0&&typeof h.ref=="string"&&h.ref!==""&&h.syncData!==void 0&&(h.syncData===null||i(h.syncData)))}function i(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}function n(h,y){return`${(0,E.uppercaseFirstLetter)(h)}${y.isDefault?"":` (${y.name})`}`}let t=class extends D.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(y,A,b,w,O,N,F,M,H,z,J,V){super(),this.syncResource=y,this.collection=A,this.fileService=b,this.environmentService=w,this.storageService=O,this.userDataSyncStoreService=N,this.userDataSyncLocalStoreService=F,this.userDataSyncEnablementService=M,this.telemetryService=H,this.logService=z,this.configurationService=J,this.syncPreviewPromise=null,this._status=S.SyncStatus.Idle,this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new a.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(y.syncResource,y.profile),this.extUri=V.extUri,this.syncFolder=this.extUri.joinPath(w.userDataSyncHome,...(0,S.getPathSegments)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,S.PREVIEW_DIR_NAME),this.lastSyncResource=(0,S.getLastSyncResourceUri)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,w,this.extUri),this.currentMachineIdPromise=(0,I.getServiceMachineId)(w,b,O)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status===S.SyncStatus.HasConflicts){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const y=await this.syncPreviewPromise;this.syncPreviewPromise=null;const A=await this.performSync(y.remoteUserData,y.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(A)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.hasRemoteChanged(y):!0)&&this._onDidChangeLocal.fire()}}setStatus(y){this._status!==y&&(this._status=y,this._onDidChangStatus.fire(y))}async sync(y,A={}){await this._sync(y,!0,this.getUserDataSyncConfiguration(),A)}async preview(y,A,b={}){return this._sync(y,!1,A,b)}async apply(y,A={}){try{this.syncHeaders={...A};const b=await this.doApply(y);return this.setStatus(b),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(y,A,b,w){try{if(this.syncHeaders={...w},this.status===S.SyncStatus.HasConflicts)return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status===S.SyncStatus.Syncing)return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus(S.SyncStatus.Syncing);let O=S.SyncStatus.Idle;try{const N=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(y,N);return O=await this.performSync(F,N,A,b),O===S.SyncStatus.HasConflicts?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O===S.SyncStatus.Idle&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(y){const A=this.parseSyncData(y);if(!A)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus(S.SyncStatus.Syncing);const b=await this.getLastSyncUserData(),w=await this.getLatestRemoteUserData(null,b),O=await this.isRemoteDataFromCurrentMachine(w),N=await this.generateSyncPreview({ref:w.ref,syncData:A},b,O,this.getUserDataSyncConfiguration(),L.CancellationToken.None),F=[];for(const M of N){const H=await this.getAcceptResult(M,M.remoteResource,void 0,L.CancellationToken.None),{remoteChange:z}=await this.getAcceptResult(M,M.previewResource,M.remoteContent,L.CancellationToken.None);F.push([M,{...H,remoteChange:z!==S.Change.None?z:S.Change.Modified}])}await this.applyResult(w,b,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus(S.SyncStatus.Idle)}return!0}async isRemoteDataFromCurrentMachine(y){const A=await this.currentMachineIdPromise;return!!y.syncData?.machineId&&y.syncData.machineId===A}async getLatestRemoteUserData(y,A){if(A){const b=y?y[this.resource]:void 0;if(A.ref===b||b===void 0&&A.syncData===null)return A}return this.getRemoteUserData(A)}async performSync(y,A,b,w){if(y.syncData&&y.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new S.UserDataSyncError((0,m.localize)(11076,null,this.resource,this.version,y.syncData.version),S.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(y,A,b,w)}catch(O){if(O instanceof S.UserDataSyncError)switch(O.code){case S.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(y,A,b,w);case S.UserDataSyncErrorCode.Conflict:case S.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),A=await this.getLastSyncUserData(),this.performSync(y,A,b,w)}throw O}}async doSync(y,A,b,w){try{const O=await this.isRemoteDataFromCurrentMachine(y),N=!O&&A===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,F=b&&!N;this.syncPreviewPromise||(this.syncPreviewPromise=(0,a.createCancelablePromise)(H=>this.doGenerateSyncResourcePreview(y,A,O,F,w,H)));let M=await this.syncPreviewPromise;if(b&&N){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const H of M.resourcePreviews)M=await this.accept(H.remoteResource)||M}return this.updateConflicts(M.resourcePreviews),M.resourcePreviews.some(({mergeState:H})=>H===S.MergeState.Conflict)?S.SyncStatus.HasConflicts:b?await this.doApply(!1):S.SyncStatus.Syncing}catch(O){throw this.syncPreviewPromise=null,O}}async merge(y){return await this.updateSyncResourcePreview(y,async A=>{const b=await this.getMergeResult(A,L.CancellationToken.None);await this.fileService.writeFile(A.previewResource,_.VSBuffer.fromString(b?.content||""));const w=b&&!b.hasConflicts?await this.getAcceptResult(A,A.previewResource,void 0,L.CancellationToken.None):void 0;return A.acceptResult=w,A.mergeState=b.hasConflicts?S.MergeState.Conflict:w?S.MergeState.Accepted:S.MergeState.Preview,A.localChange=w?w.localChange:b.localChange,A.remoteChange=w?w.remoteChange:b.remoteChange,A}),this.syncPreviewPromise}async accept(y,A){return await this.updateSyncResourcePreview(y,async b=>{const w=await this.getAcceptResult(b,y,A,L.CancellationToken.None);return b.acceptResult=w,b.mergeState=S.MergeState.Accepted,b.localChange=w.localChange,b.remoteChange=w.remoteChange,b}),this.syncPreviewPromise}async discard(y){return await this.updateSyncResourcePreview(y,async A=>{const b=await this.getMergeResult(A,L.CancellationToken.None);return await this.fileService.writeFile(A.previewResource,_.VSBuffer.fromString(b.content||"")),A.acceptResult=void 0,A.mergeState=S.MergeState.Preview,A.localChange=b.localChange,A.remoteChange=b.remoteChange,A}),this.syncPreviewPromise}async updateSyncResourcePreview(y,A){if(!this.syncPreviewPromise)return;let b=await this.syncPreviewPromise;const w=b.resourcePreviews.findIndex(({localResource:O,remoteResource:N,previewResource:F})=>this.extUri.isEqual(O,y)||this.extUri.isEqual(N,y)||this.extUri.isEqual(F,y));w!==-1&&(this.syncPreviewPromise=(0,a.createCancelablePromise)(async O=>{const N=[...b.resourcePreviews];return N[w]=await A(N[w]),{...b,resourcePreviews:N}}),b=await this.syncPreviewPromise,this.updateConflicts(b.resourcePreviews),b.resourcePreviews.some(({mergeState:O})=>O===S.MergeState.Conflict)?this.setStatus(S.SyncStatus.HasConflicts):this.setStatus(S.SyncStatus.Syncing))}async doApply(y){if(!this.syncPreviewPromise)return S.SyncStatus.Idle;const A=await this.syncPreviewPromise;return A.resourcePreviews.some(({mergeState:b})=>b===S.MergeState.Conflict)?S.SyncStatus.HasConflicts:A.resourcePreviews.some(({mergeState:b})=>b!==S.MergeState.Accepted)?S.SyncStatus.Syncing:(await this.applyResult(A.remoteUserData,A.lastSyncUserData,A.resourcePreviews.map(b=>[b,b.acceptResult]),y),this.syncPreviewPromise=null,await this.clearPreviewFolder(),S.SyncStatus.Idle)}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(y){const A=y.filter(({mergeState:b})=>b===S.MergeState.Conflict);(0,P.equals)(this._conflicts,A,(b,w)=>this.extUri.isEqual(b.previewResource,w.previewResource))||(this._conflicts=A,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async resolvePreviewContent(y){const A=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(A)for(const b of A.resourcePreviews){if(this.extUri.isEqual(b.acceptedResource,y))return b.acceptResult?b.acceptResult.content:null;if(this.extUri.isEqual(b.remoteResource,y))return b.remoteContent;if(this.extUri.isEqual(b.localResource,y))return b.localContent;if(this.extUri.isEqual(b.baseResource,y))return b.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,g.StorageScope.APPLICATION);try{await this.fileService.del(this.lastSyncResource)}catch(y){(0,l.toFileOperationResult)(y)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(y)}}async doGenerateSyncResourcePreview(y,A,b,w,O,N){const F=await this.generateSyncPreview(y,A,b,O,N),M=[];for(const H of F){const z=H.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(H.localChange===S.Change.None&&H.remoteChange===S.Change.None)M.push({...H,acceptedResource:z,acceptResult:{content:null,localChange:S.Change.None,remoteChange:S.Change.None},mergeState:S.MergeState.Accepted});else{const J=w?await this.getMergeResult(H,N):void 0;if(N.isCancellationRequested)break;await this.fileService.writeFile(H.previewResource,_.VSBuffer.fromString(J?.content||""));const V=J&&!J.hasConflicts?await this.getAcceptResult(H,H.previewResource,void 0,N):void 0;M.push({...H,acceptResult:V,mergeState:J?.hasConflicts?S.MergeState.Conflict:V?S.MergeState.Accepted:S.MergeState.Preview,localChange:V?V.localChange:J?J.localChange:H.localChange,remoteChange:V?V.remoteChange:J?J.remoteChange:H.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:A,resourcePreviews:M,isLastSyncFromCurrentMachine:b}}async getLastSyncUserData(){let y=this.getStoredLastSyncUserDataStateContent();if(y||(y=await this.migrateLastSyncUserData()),!y)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const A=JSON.parse(y),b=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!A.version&&!!b&&A.version!==b,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${A.version} is not compatible with current sync state version ${b}.`),await this.resetLocal(),null;let w,O=1;for(;w===void 0&&O++<6;)try{const N=await this.readLastSyncStoredRemoteUserData();N&&(N.ref===A.ref?w=N.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(N){if(N instanceof l.FileOperationError&&N.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(N instanceof S.UserDataSyncError)throw N;this.logService.error(N,O)}}if(w===void 0)try{const N=await this.userDataSyncStoreService.resolveResourceContent(this.resource,A.ref,this.collection,this.syncHeaders);w=N===null?null:this.parseSyncData(N),await this.writeLastSyncStoredRemoteUserData({ref:A.ref,syncData:w})}catch(N){if(N instanceof S.UserDataSyncError&&N.code===S.UserDataSyncErrorCode.NotFound)this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw N}return w===void 0?null:{...A,syncData:w}}async updateLastSyncUserData(y,A={}){if(A.ref||A.version)throw new Error("Cannot have core properties as additional");const b=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),w={ref:y.ref,version:b,...A};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(w),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await this.writeLastSyncStoredRemoteUserData(y)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,g.StorageScope.APPLICATION)}async readLastSyncStoredRemoteUserData(){const y=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const A=y?JSON.parse(y):void 0;if(u(A))return A}catch(A){this.logService.error(A)}}async writeLastSyncStoredRemoteUserData(y){await this.fileService.writeFile(this.lastSyncResource,_.VSBuffer.fromString(JSON.stringify(y)))}async migrateLastSyncUserData(){try{const y=await this.fileService.readFile(this.lastSyncResource),A=JSON.parse(y.value.toString());await this.fileService.del(this.lastSyncResource),A.ref&&A.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...A,content:void 0}),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await this.writeLastSyncStoredRemoteUserData({ref:A.ref,syncData:A.content===null?null:JSON.parse(A.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,A)}catch(y){y instanceof l.FileOperationError&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(y)}return this.storageService.get(this.lastSyncUserDataStateKey,g.StorageScope.APPLICATION)}async getRemoteUserData(y){const{ref:A,content:b}=await this.getUserData(y);let w=null;return b!==null&&(w=this.parseSyncData(b)),{ref:A,syncData:w}}parseSyncData(y){try{const A=JSON.parse(y);if(i(A))return A}catch(A){this.logService.error(A)}throw new S.UserDataSyncError((0,m.localize)(11077,null),S.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(y){const A=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,A,this.collection,this.syncHeaders)}async updateRemoteUserData(y,A){const b=await this.currentMachineIdPromise,w={version:this.version,machineId:b,content:y};try{return A=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(w),A,this.collection,this.syncHeaders),{ref:A,syncData:w}}catch(O){throw O instanceof S.UserDataSyncError&&O.code===S.UserDataSyncErrorCode.TooLarge&&(O=new S.UserDataSyncError(O.message,O.code,this.resource)),O}}async backupLocal(y){const A={version:this.version,content:y};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(A),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==S.SyncStatus.Idle&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus(S.SyncStatus.Idle),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(S.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=t,e.AbstractSynchroniser=t=we([Q(2,l.IFileService),Q(3,f.IEnvironmentService),Q(4,g.IStorageService),Q(5,S.IUserDataSyncStoreService),Q(6,S.IUserDataSyncLocalStoreService),Q(7,S.IUserDataSyncEnablementService),Q(8,v.ITelemetryService),Q(9,S.IUserDataSyncLogService),Q(10,d.IConfigurationService),Q(11,C.IUriIdentityService)],t);let s=class extends t{constructor(y,A,b,w,O,N,F,M,H,z,J,V,te){super(A,b,w,O,N,F,M,H,z,J,V,te),this.file=y,this._register(this.fileService.watch(this.extUri.dirname(y))),this._register(this.fileService.onDidFilesChange($=>this.onFileChanges($)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(y,A,b){try{A?await this.fileService.writeFile(this.file,_.VSBuffer.fromString(y),b?void 0:A):await this.fileService.createFile(this.file,_.VSBuffer.fromString(y),{overwrite:b})}catch(w){throw w instanceof l.FileOperationError&&w.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||w instanceof l.FileOperationError&&w.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new S.UserDataSyncError(w.message,S.UserDataSyncErrorCode.LocalPreconditionFailed):w}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(y){if(!(y instanceof l.FileOperationError&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw y}}onFileChanges(y){y.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=s,e.AbstractFileSynchroniser=s=we([Q(3,l.IFileService),Q(4,f.IEnvironmentService),Q(5,g.IStorageService),Q(6,S.IUserDataSyncStoreService),Q(7,S.IUserDataSyncLocalStoreService),Q(8,S.IUserDataSyncEnablementService),Q(9,v.ITelemetryService),Q(10,S.IUserDataSyncLogService),Q(11,d.IConfigurationService),Q(12,C.IUriIdentityService)],s);let r=class extends s{constructor(y,A,b,w,O,N,F,M,H,z,J,V,te,$){super(y,A,b,w,O,N,F,M,H,z,J,te,$),this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(y,A){const b=[],w=(0,T.parse)(y,b,{allowEmptyContent:!0,allowTrailingComma:!0});return b.length>0||!(0,R.isUndefined)(w)&&A!==Array.isArray(w)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=r,e.AbstractJsonFileSynchroniser=r=we([Q(3,l.IFileService),Q(4,f.IEnvironmentService),Q(5,g.IStorageService),Q(6,S.IUserDataSyncStoreService),Q(7,S.IUserDataSyncLocalStoreService),Q(8,S.IUserDataSyncEnablementService),Q(9,v.ITelemetryService),Q(10,S.IUserDataSyncLogService),Q(11,S.IUserDataSyncUtilService),Q(12,d.IConfigurationService),Q(13,C.IUriIdentityService)],r);let o=class{constructor(y,A,b,w,O,N,F){this.resource=y,this.userDataProfilesService=A,this.environmentService=b,this.logService=w,this.fileService=O,this.storageService=N,this.extUri=F.extUri,this.lastSyncResource=(0,S.getLastSyncResourceUri)(void 0,this.resource,b,this.extUri)}async initialize({ref:y,content:A}){if(!A){this.logService.info("Remote content does not exist.",this.resource);return}const b=this.parseSyncData(A);if(b)try{await this.doInitialize({ref:y,syncData:b})}catch(w){this.logService.error(w)}}parseSyncData(y){try{const A=JSON.parse(y);if(i(A))return A}catch(A){this.logService.error(A)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(y,A={}){if(A.ref||A.version)throw new Error("Cannot have core properties as additional");const b={ref:y.ref,version:void 0,...A};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(b),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await this.fileService.writeFile(this.lastSyncResource,_.VSBuffer.fromString(JSON.stringify(y)))}};e.AbstractInitializer=o,e.AbstractInitializer=o=we([Q(1,c.IUserDataProfilesService),Q(2,f.IEnvironmentService),Q(3,p.ILogService),Q(4,l.IFileService),Q(5,g.IStorageService),Q(6,C.IUriIdentityService)],o)}),define(ue[119],he([0,1,6,25,8,3,45,2,26,21,15,118,27,35,85,34,7,4,76,10,16,18,28,19,40,206,114,24,62]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S,c,u,i,n,t,s,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=void 0,e.parseExtensions=y,e.stringify=A;async function h(N,F){const M=JSON.parse(N.content);if(N.version===1||N.version===2){const H=(await F.getInstalled(p.ExtensionType.System)).filter(z=>z.isBuiltin);for(const z of M)N.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),N.version===2&&H.every(J=>!(0,f.areSameExtensions)(J.identifier,z.identifier))&&(z.installed=!0)}return M}function y(N){return JSON.parse(N.content)}function A(N,F){return N.sort((M,H)=>!M.identifier.uuid&&H.identifier.uuid?-1:M.identifier.uuid&&!H.identifier.uuid?1:(0,D.compare)(M.identifier.id,H.identifier.id)),F?(0,k.toFormattedString)(N,{}):JSON.stringify(N)}let b=class extends n.AbstractSynchroniser{constructor(F,M,H,z,J,V,te,$,q,Z,ne,le,ee,X,K,W,U){super({syncResource:r.SyncResource.Extensions,profile:F},M,z,H,J,V,te,le,ee,Z,ne,K),this.extensionManagementService=$,this.ignoredExtensionsManagementService=q,this.instantiationService=U,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(w),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,Y=>Y.some(({local:oe})=>!!oe)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,Y=>!Y.error),L.Event.filter(W.onDidChange,Y=>Y.valueChanges.some(({profile:oe,changes:x})=>this.syncResource.profile.id===oe.id&&x.some(B=>B.key===d.DISABLED_EXTENSIONS_STORAGE_PATH))),X.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(F,M){const H=F.syncData?await h(F.syncData,this.extensionManagementService):null,z=M?.skippedExtensions??[],J=M?.builtinExtensions??null,V=M?.syncData?await h(M.syncData,this.extensionManagementService):null,{localExtensions:te,ignoredExtensions:$}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);H?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:Z}=(0,t.merge)(te,H,V,z,$,J),ne={local:q,remote:Z,content:this.getPreviewContent(te,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:Z!==null?r.Change.Modified:r.Change.None},le=this.stringify(te,!1);return[{skippedExtensions:z,builtinExtensions:J,baseResource:this.baseResource,baseContent:V?this.stringify(V,!1):le,localResource:this.localResource,localContent:le,localExtensions:te,remoteResource:this.remoteResource,remoteExtensions:H,remoteContent:H?this.stringify(H,!1):null,previewResource:this.previewResource,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(F){const M=F.syncData?await h(F.syncData,this.extensionManagementService):null,{localExtensions:H,ignoredExtensions:z}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:J}=(0,t.merge)(H,M,M,F.skippedExtensions||[],z,F.builtinExtensions||[]);return J!==null}getPreviewContent(F,M,H,z){const J=[...M,...H],V=new Set,te=$=>{V.add($.id.toLowerCase()),$.uuid&&V.add($.uuid)};J.forEach(({identifier:$})=>te($)),z.forEach(te);for(const $ of F)V.has($.identifier.id.toLowerCase())||$.identifier.uuid&&V.has($.identifier.uuid)||J.push($);return this.stringify(J,!1)}async getMergeResult(F,M){return{...F.previewResult,hasConflicts:!1}}async getAcceptResult(F,M,H,z){if(this.extUri.isEqual(M,this.localResource))return this.acceptLocal(F);if(this.extUri.isEqual(M,this.remoteResource))return this.acceptRemote(F);if(this.extUri.isEqual(M,this.previewResource))return F.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async acceptLocal(F){const M=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),H=this.ignoredExtensionsManagementService.getIgnoredExtensions(M),z=(0,t.merge)(F.localExtensions,null,null,F.skippedExtensions,H,F.builtinExtensions),{local:J,remote:V}=z;return{content:F.localContent,local:J,remote:V,localChange:J.added.length>0||J.removed.length>0||J.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:V!==null?r.Change.Modified:r.Change.None}}async acceptRemote(F){const M=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),H=this.ignoredExtensionsManagementService.getIgnoredExtensions(M),z=F.remoteContent?JSON.parse(F.remoteContent):null;if(z!==null){const J=(0,t.merge)(F.localExtensions,z,F.localExtensions,[],H,F.builtinExtensions),{local:V,remote:te}=J;return{content:F.remoteContent,local:V,remote:te,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:te!==null?r.Change.Modified:r.Change.None}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async applyResult(F,M,H,z){let{skippedExtensions:J,builtinExtensions:V,localExtensions:te}=H[0][0];const{local:$,remote:q,localChange:Z,remoteChange:ne}=H[0][1];if(Z===r.Change.None&&ne===r.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),Z!==r.Change.None&&(await this.backupLocal(JSON.stringify(te)),J=await this.localExtensionsProvider.updateLocalExtensions($.added,$.removed,$.updated,J,this.syncResource.profile)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const le=JSON.stringify(q.all);F=await this.updateRemoteUserData(le,z?null:F.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(ee=>ee.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(ee=>ee.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(ee=>ee.identifier.id))}.`:""}`)}M?.ref!==F.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),V=this.computeBuiltinExtensions(te,V),await this.updateLastSyncUserData(F,{skippedExtensions:J,builtinExtensions:V}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${J.length?` Skipped: ${JSON.stringify(J.map(le=>le.identifier.id))}.`:""}`))}computeBuiltinExtensions(F,M){const H=new Set,z=[];for(const J of F)H.add(J.identifier.id.toLowerCase()),J.installed||z.push(J.identifier);if(M)for(const J of M)H.has(J.id.toLowerCase())||z.push(J);return z}async resolveContent(F){if(this.extUri.isEqual(this.remoteResource,F)||this.extUri.isEqual(this.baseResource,F)||this.extUri.isEqual(this.localResource,F)||this.extUri.isEqual(this.acceptedResource,F)){const M=await this.resolvePreviewContent(F);return M&&this.stringify(JSON.parse(M),!0)}return null}stringify(F,M){return A(F,M)}async hasLocalData(){try{const{localExtensions:F}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(F.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=b,e.ExtensionsSynchroniser=b=we([Q(2,R.IEnvironmentService),Q(3,I.IFileService),Q(4,S.IStorageService),Q(5,r.IUserDataSyncStoreService),Q(6,r.IUserDataSyncLocalStoreService),Q(7,d.IExtensionManagementService),Q(8,s.IIgnoredExtensionsManagementService),Q(9,r.IUserDataSyncLogService),Q(10,E.IConfigurationService),Q(11,r.IUserDataSyncEnablementService),Q(12,c.ITelemetryService),Q(13,l.IExtensionStorageService),Q(14,u.IUriIdentityService),Q(15,o.IUserDataProfileStorageService),Q(16,g.IInstantiationService)],b);let w=class{constructor(F,M,H,z,J,V){this.extensionManagementService=F,this.userDataProfileStorageService=M,this.extensionGalleryService=H,this.ignoredExtensionsManagementService=z,this.instantiationService=J,this.logService=V}async getLocalExtensions(F){const M=await this.extensionManagementService.getInstalled(void 0,F.extensionsResource),H=this.ignoredExtensionsManagementService.getIgnoredExtensions(M);return{localExtensions:await this.withProfileScopedServices(F,async(J,V)=>{const te=J.getDisabledExtensions();return M.map($=>{const{identifier:q,isBuiltin:Z,manifest:ne,preRelease:le,pinned:ee,isApplicationScoped:X}=$,K={identifier:q,preRelease:le,version:ne.version,pinned:!!ee};X&&!(0,p.isApplicationScopedExtension)(ne)&&(K.isApplicationScoped=X),te.some(W=>(0,f.areSameExtensions)(W,q))&&(K.disabled=!0),Z||(K.installed=!0);try{const W=V.getKeysForSync({id:q.id,version:ne.version});if(W){const U=V.getExtensionState($,!0)||{};K.state=Object.keys(U).reduce((Y,oe)=>(W.includes(oe)&&(Y[oe]=U[oe]),Y),{})}}catch(W){this.logService.info(`${(0,n.getSyncResourceLogLabel)(r.SyncResource.Extensions,F)}: Error while parsing extension state`,(0,_.getErrorMessage)(W))}return K})}),ignoredExtensions:H}}async updateLocalExtensions(F,M,H,z,J){const V=(0,n.getSyncResourceLogLabel)(r.SyncResource.Extensions,J),te=[],$=new Map,q=[],Z=[],ne=await this.extensionManagementService.getInstalled(void 0,J.extensionsResource);if((F.length||H.length)&&await this.withProfileScopedServices(J,async(X,K)=>{await P.Promises.settled([...F,...H].map(async W=>{const U=ne.find(x=>(0,f.areSameExtensions)(x.identifier,W.identifier));if(U&&U.isBuiltin){W.state&&U.manifest.version===W.version&&this.updateExtensionState(W.state,U,U.manifest.version,K),X.getDisabledExtensions().some(B=>(0,f.areSameExtensions)(B,W.identifier))!==!!W.disabled&&(W.disabled?(this.logService.trace(`${V}: Disabling extension...`,W.identifier.id),await X.disableExtension(W.identifier),this.logService.info(`${V}: Disabled extension`,W.identifier.id)):(this.logService.trace(`${V}: Enabling extension...`,W.identifier.id),await X.enableExtension(W.identifier),this.logService.info(`${V}: Enabled extension`,W.identifier.id))),q.push(W.identifier);return}const Y=W.pinned?W.version:void 0,oe=(await this.extensionGalleryService.getExtensions([{...W.identifier,version:Y,preRelease:Y?void 0:W.preRelease}],a.CancellationToken.None))[0];if(W.state&&(U?U.manifest.version===W.version:oe)&&this.updateExtensionState(W.state,U||oe,U?.manifest.version,K),oe)try{X.getDisabledExtensions().some(B=>(0,f.areSameExtensions)(B,W.identifier))!==!!W.disabled&&(W.disabled?(this.logService.trace(`${V}: Disabling extension...`,W.identifier.id,oe.version),await X.disableExtension(oe.identifier),this.logService.info(`${V}: Disabled extension`,W.identifier.id,oe.version)):(this.logService.trace(`${V}: Enabling extension...`,W.identifier.id,oe.version),await X.enableExtension(oe.identifier),this.logService.info(`${V}: Enabled extension`,W.identifier.id,oe.version))),(!U||U.preRelease!==W.preRelease||U.pinned!==W.pinned||Y&&U.manifest.version!==Y)&&(await this.extensionManagementService.canInstall(oe)?(te.push({extension:oe,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:W.pinned&&!!W.version,pinned:W.pinned,installPreReleaseVersion:W.preRelease,profileLocation:J.extensionsResource,isApplicationScoped:W.isApplicationScoped,context:{[d.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[d.EXTENSION_INSTALL_SOURCE_CONTEXT]:d.ExtensionInstallSource.SETTINGS_SYNC}}}),$.set(oe.identifier.id.toLowerCase(),W)):(this.logService.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,oe.displayName||oe.identifier.id),Z.push(W)))}catch(x){Z.push(W),this.logService.error(x),this.logService.info(`${V}: Skipped synchronizing extension`,oe.displayName||oe.identifier.id)}else Z.push(W),this.logService.info(`${V}: Skipped synchronizing extension because the extension is not found.`,W.identifier.id)}))}),M.length){const X=ne.filter(({identifier:K,isBuiltin:W})=>!W&&M.some(U=>(0,f.areSameExtensions)(K,U)));await P.Promises.settled(X.map(async K=>{this.logService.trace(`${V}: Uninstalling local extension...`,K.identifier.id),await this.extensionManagementService.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:J.extensionsResource}),this.logService.info(`${V}: Uninstalled local extension.`,K.identifier.id),q.push(K.identifier)}))}const le=await this.extensionManagementService.installGalleryExtensions(te);for(const{identifier:X,local:K,error:W,source:U}of le){const Y=U;if(K)this.logService.info(`${V}: Installed extension.`,X.id,Y.version),q.push(X);else{const oe=$.get(X.id.toLowerCase());oe&&(Z.push(oe),this.logService.info(`${V}: Skipped synchronizing extension`,Y.displayName||Y.identifier.id)),W instanceof d.ExtensionManagementError&&[d.ExtensionManagementErrorCode.Incompatible,d.ExtensionManagementErrorCode.IncompatibleApi,d.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(W.code)?this.logService.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,Y.displayName||Y.identifier.id):W&&this.logService.error(W)}}const ee=[];for(const X of z)q.some(K=>(0,f.areSameExtensions)(K,X.identifier))||ee.push(X);for(const X of Z)ee.some(K=>(0,f.areSameExtensions)(K.identifier,X.identifier))||ee.push(X);return ee}updateExtensionState(F,M,H,z){const J=z.getExtensionState(M,!0)||{},V=H?z.getKeysForSync({id:M.identifier.id,version:H}):void 0;V?V.forEach(te=>{J[te]=F[te]}):Object.keys(F).forEach(te=>J[te]=F[te]),z.setExtensionState(M,J,!0)}async withProfileScopedServices(F,M){return this.userDataProfileStorageService.withProfileScopedStorageService(F,async H=>{const z=new T.DisposableStore,J=z.add(this.instantiationService.createChild(new v.ServiceCollection([S.IStorageService,H]))),V=z.add(J.createInstance(m.GlobalExtensionEnablementService)),te=z.add(J.createInstance(l.ExtensionStorageService));try{return await M(V,te)}finally{z.dispose()}})}};e.LocalExtensionsProvider=w,e.LocalExtensionsProvider=w=we([Q(0,d.IExtensionManagementService),Q(1,o.IUserDataProfileStorageService),Q(2,d.IExtensionGalleryService),Q(3,s.IIgnoredExtensionsManagementService),Q(4,g.IInstantiationService),Q(5,r.IUserDataSyncLogService)],w);let O=class extends n.AbstractInitializer{constructor(F,M,H,z,J,V,te,$){super(r.SyncResource.Extensions,z,J,V,H,te,$),this.extensionManagementService=F,this.ignoredExtensionsManagementService=M}async parseExtensions(F){return F.syncData?await h(F.syncData,this.extensionManagementService):null}generatePreview(F,M){const H=[],z=[],J=[];for(const V of F){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(V.identifier.id))continue;const te=M.find($=>(0,f.areSameExtensions)($.identifier,V.identifier));te?(H.push(te),V.disabled&&J.push(V.identifier)):V.installed&&(z.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&J.push(V.identifier))}return{installedExtensions:H,newExtensions:z,disabledExtensions:J,remoteExtensions:F}}};e.AbstractExtensionsInitializer=O,e.AbstractExtensionsInitializer=O=we([Q(0,d.IExtensionManagementService),Q(1,s.IIgnoredExtensionsManagementService),Q(2,I.IFileService),Q(3,i.IUserDataProfilesService),Q(4,R.IEnvironmentService),Q(5,C.ILogService),Q(6,S.IStorageService),Q(7,u.IUriIdentityService)],O)}),define(ue[120],he([0,1,14,8,3,36,45,5,32,21,15,7,10,49,16,18,28,40,81,210,24,19,62,4]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S,c,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=void 0,e.stringify=s;const n="globalState.argv.",t=["locale"];function s(b,w){const O=b.storage?Object.keys(b.storage).sort():[],N={};return O.forEach(F=>N[F]=b.storage[F]),b.storage=N,w?(0,k.toFormattedString)(b,{}):JSON.stringify(b)}const r=1;let o=class extends g.AbstractSynchroniser{constructor(w,O,N,F,M,H,z,J,V,te,$,q,Z,ne){super({syncResource:S.SyncResource.GlobalState,profile:w},O,F,J,q,M,H,V,te,z,$,Z),this.userDataProfileStorageService=N,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ne.createInstance(h),this._register(F.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(_.Event.any(_.Event.filter(F.onDidFilesChange,le=>le.contains(this.environmentService.argvResource)),_.Event.filter(N.onDidChange,le=>!!(le.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||le.valueChanges.some(({profile:ee,changes:X})=>this.syncResource.profile.id===ee.id&&X.some(K=>K.target===l.StorageTarget.USER)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(w,O,N){const F=w.syncData?JSON.parse(w.syncData.content):null;O=O===null&&N?w:O;const M=O&&O.syncData?JSON.parse(O.syncData.content):null,H=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const z=await this.getStorageKeys(M),{local:J,remote:V}=(0,C.merge)(H.storage,F?F.storage:null,M?M.storage:null,z,this.logService),te={content:null,local:J,remote:V,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?S.Change.Modified:S.Change.None,remoteChange:V.all!==null?S.Change.Modified:S.Change.None},$=s(H,!1);return[{baseResource:this.baseResource,baseContent:M?s(M,!1):$,localResource:this.localResource,localContent:$,localUserData:H,remoteResource:this.remoteResource,remoteContent:F?s(F,!1):null,previewResource:this.previewResource,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.acceptedResource,storageKeys:z}]}async hasRemoteChanged(w){const O=w.syncData?JSON.parse(w.syncData.content):null;if(O===null)return!0;const N=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),F=await this.getStorageKeys(O),{remote:M}=(0,C.merge)(N.storage,O.storage,O.storage,F,this.logService);return M.all!==null}async getMergeResult(w,O){return{...w.previewResult,hasConflicts:!1}}async getAcceptResult(w,O,N,F){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(w);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(w);if(this.extUri.isEqual(O,this.previewResource))return w.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(w){return{content:w.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(w.localUserData.storage),removed:[],updated:[],all:w.localUserData.storage},localChange:S.Change.None,remoteChange:S.Change.Modified}}async acceptRemote(w){if(w.remoteContent!==null){const O=JSON.parse(w.remoteContent),{local:N,remote:F}=(0,C.merge)(w.localUserData.storage,O.storage,null,w.storageKeys,this.logService);return{content:w.remoteContent,local:N,remote:F,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?S.Change.Modified:S.Change.None,remoteChange:F!==null?S.Change.Modified:S.Change.None}}else return{content:w.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:S.Change.None,remoteChange:S.Change.None}}async applyResult(w,O,N,F){const{localUserData:M}=N[0][0],{local:H,remote:z,localChange:J,remoteChange:V}=N[0][1];if(J===S.Change.None&&V===S.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==S.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(M)),await this.localGlobalStateProvider.writeLocalGlobalState(H,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==S.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const te=JSON.stringify({storage:z.all});w=await this.updateRemoteUserData(te,F?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${z.added.length?` Added: ${z.added}.`:""}${z.updated.length?` Updated: ${z.updated}.`:""}${z.removed.length?` Removed: ${z.removed}.`:""}`)}O?.ref!==w.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(w),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(w){if(this.extUri.isEqual(this.remoteResource,w)||this.extUri.isEqual(this.baseResource,w)||this.extUri.isEqual(this.localResource,w)||this.extUri.isEqual(this.acceptedResource,w)){const O=await this.resolvePreviewContent(w);return O&&s(JSON.parse(O),!0)}return null}async hasLocalData(){try{const{storage:w}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(w).length>1||w[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(w){const O=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),N=[],F=[];for(const[z,J]of O)J.target===l.StorageTarget.USER?N.push(z):J.target===l.StorageTarget.MACHINE&&F.push(z);const M=[...N,...F],H=w?.storage?Object.keys(w.storage).filter(z=>!z.startsWith(n)&&!M.includes(z)&&O.get(z)!==void 0):[];if(!T.isWeb){const z=[...S.ALL_SYNC_RESOURCES.map(J=>(0,S.getEnablementKey)(J)),S.SYNC_SERVICE_URL_TYPE];H.push(...z),F.push(...z)}return{user:N,machine:F,unregistered:H}}};e.GlobalStateSynchroniser=o,e.GlobalStateSynchroniser=o=we([Q(2,u.IUserDataProfileStorageService),Q(3,m.IFileService),Q(4,S.IUserDataSyncStoreService),Q(5,S.IUserDataSyncLocalStoreService),Q(6,S.IUserDataSyncLogService),Q(7,R.IEnvironmentService),Q(8,S.IUserDataSyncEnablementService),Q(9,p.ITelemetryService),Q(10,E.IConfigurationService),Q(11,l.IStorageService),Q(12,I.IUriIdentityService),Q(13,i.IInstantiationService)],o);let h=class{constructor(w,O,N,F){this.fileService=w,this.environmentService=O,this.userDataProfileStorageService=N,this.logService=F}async getLocalGlobalState(w){const O={};if(w.isDefault){const F=await this.getLocalArgvContent(),M=(0,L.parse)(F);for(const H of t)M[H]!==void 0&&(O[`${n}${H}`]={version:1,value:M[H]})}const N=await this.userDataProfileStorageService.readStorageData(w);for(const[F,M]of N)M.value&&M.target===l.StorageTarget.USER&&(O[F]={version:1,value:M.value});return{storage:O}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const w=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),w.value.toString()}catch(w){this.logService.debug((0,a.getErrorMessage)(w))}return"{}"}async writeLocalGlobalState({added:w,removed:O,updated:N},F){const M=(0,g.getSyncResourceLogLabel)(S.SyncResource.GlobalState,F),H={},z=new Map,J=await this.userDataProfileStorageService.readStorageData(F),V=(te,$)=>{for(const q of te){if(q.startsWith(n)){H[q.substring(n.length)]=$?$[q].value:void 0;continue}if($){const Z=$[q];Z.value!==J.get(q)?.value&&z.set(q,Z.value)}else J.get(q)!==void 0&&z.set(q,void 0)}};if(V(Object.keys(w),w),V(Object.keys(N),N),V(O),Object.keys(H).length){this.logService.trace(`${M}: Updating locale...`);const te=await this.getLocalArgvContent();let $=te;for(const q of Object.keys(H))$=(0,v.edit)($,[q],H[q],{});te!==$&&(this.logService.trace(`${M}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,P.VSBuffer.fromString($)),this.logService.info(`${M}: Updated locale.`)),this.logService.info(`${M}: Updated locale`)}z.size&&(this.logService.trace(`${M}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(F,z,l.StorageTarget.USER),this.logService.info(`${M}: Updated global state`,[...z.keys()]))}};e.LocalGlobalStateProvider=h,e.LocalGlobalStateProvider=h=we([Q(0,m.IFileService),Q(1,R.IEnvironmentService),Q(2,u.IUserDataProfileStorageService),Q(3,S.IUserDataSyncLogService)],h);let y=class extends g.AbstractInitializer{constructor(w,O,N,F,M,H){super(S.SyncResource.GlobalState,N,F,M,O,w,H)}async doInitialize(w){const O=w.syncData?JSON.parse(w.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const N={},F={};for(const M of Object.keys(O.storage))M.startsWith(n)?N[M.substring(n.length)]=O.storage[M].value:this.storageService.get(M,l.StorageScope.PROFILE)===void 0&&(F[M]=O.storage[M].value);if(Object.keys(N).length){let M="{}";try{M=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const H of Object.keys(N))M=(0,v.edit)(M,[H],N[H],{});await this.fileService.writeFile(this.environmentService.argvResource,P.VSBuffer.fromString(M))}if(Object.keys(F).length){const M=[];for(const H of Object.keys(F))M.push({key:H,value:F[H],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.storageService.storeAll(M,!0)}}};e.GlobalStateInitializer=y,e.GlobalStateInitializer=y=we([Q(0,l.IStorageService),Q(1,m.IFileService),Q(2,c.IUserDataProfilesService),Q(3,R.IEnvironmentService),Q(4,S.IUserDataSyncLogService),Q(5,I.IUriIdentityService)],y);let A=class{constructor(w,O,N,F,M){this.userDataSyncStoreClient=w,this.storageService=O,this.environmentService=N,this.fileService=F,this.logService=M}getSyncStoreType(w){return this.parseGlobalState(w)?.storage[S.SYNC_SERVICE_URL_TYPE]?.value}async sync(w){const O=(0,S.createSyncHeaders)((0,D.generateUuid)());try{return await this.doSync(w,O)}catch(N){if(N instanceof S.UserDataSyncError)switch(N.code){case S.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(w,O)}throw N}}async doSync(w,O){const N=await this.userDataSyncStoreClient.readResource(S.SyncResource.GlobalState,null,void 0,O),F=this.parseGlobalState(N)||{storage:{}};F.storage[S.SYNC_SERVICE_URL_TYPE]={value:w,version:r};const M=await(0,f.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),H={version:r,machineId:M,content:s(F,!1)};await this.userDataSyncStoreClient.writeResource(S.SyncResource.GlobalState,JSON.stringify(H),N.ref,void 0,O)}parseGlobalState({content:w}){if(!w)return null;const O=JSON.parse(w);if((0,g.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=A,e.UserDataSyncStoreTypeSynchronizer=A=we([Q(1,l.IStorageService),Q(2,R.IEnvironmentService),Q(3,m.IFileService),Q(4,d.ILogService)],A)}),define(ue[121],he([0,1,17,14,3,36,5,12,11,21,15,7,16,18,28,19,40,207,24]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=void 0,e.getKeybindingsContentFromSyncContent=C;function C(u,i,n){try{const t=JSON.parse(u);if(!i)return(0,T.isUndefined)(t.all)?null:t.all;switch(k.OS){case k.OperatingSystem.Macintosh:return(0,T.isUndefined)(t.mac)?null:t.mac;case k.OperatingSystem.Linux:return(0,T.isUndefined)(t.linux)?null:t.linux;case k.OperatingSystem.Windows:return(0,T.isUndefined)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}let S=class extends I.AbstractJsonFileSynchroniser{constructor(i,n,t,s,r,o,h,y,A,b,w,O,N){super(i.keybindingsResource,{syncResource:v.SyncResource.Keybindings,profile:i},n,y,A,b,t,s,h,O,r,w,o,N),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(_.Event.filter(o.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,n,t,s){const r=i.syncData?C(i.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&t?i:n;const o=n?this.getKeybindingsContentFromLastSyncUserData(n):null,h=await this.getLocalFileContent(),y=await this.getFormattingOptions();let A=null,b=!1,w=!1,O=!1;if(r){let M=h?h.value.toString():"[]";if(M=M||"[]",this.hasErrors(M,!0))throw new v.UserDataSyncError((0,D.localize)(11074,null),v.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==M||o!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const H=await(0,g.merge)(M,r,o,y,this.userDataSyncUtilService);H.hasChanges&&(A=H.mergeContent,O=H.hasConflicts,b=O||H.mergeContent!==M,w=O||H.mergeContent!==r)}}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=h.value.toString(),w=!0);const N={content:O?o:A,localChange:b?h?v.Change.Modified:v.Change.Added:v.Change.None,remoteChange:w?v.Change.Modified:v.Change.None,hasConflicts:O},F=h?h.value.toString():null;return[{fileContent:h,baseResource:this.baseResource,baseContent:o,localResource:this.localResource,localContent:F,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const n=this.getKeybindingsContentFromLastSyncUserData(i);if(n===null)return!0;const t=await this.getLocalFileContent(),s=t?t.value.toString():"",r=await this.getFormattingOptions(),o=await(0,g.merge)(s||"[]",n,n,r,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==n}async getMergeResult(i,n){return i.previewResult}async getAcceptResult(i,n,t,s){if(this.extUri.isEqual(n,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:v.Change.None,remoteChange:v.Change.Modified};if(this.extUri.isEqual(n,this.remoteResource))return{content:i.remoteContent,localChange:v.Change.Modified,remoteChange:v.Change.None};if(this.extUri.isEqual(n,this.previewResource))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:v.Change.Modified,remoteChange:v.Change.Modified};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(i,n,t,s){const{fileContent:r}=t[0][0];let{content:o,localChange:h,remoteChange:y}=t[0][1];if(h===v.Change.None&&y===v.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o,!0)))throw new v.UserDataSyncError((0,D.localize)(11075,null),v.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(h!==v.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(o||"[]",r,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),y!==v.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(o||"[]",i.syncData?.content);i=await this.updateRemoteUserData(A,s?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const n=(0,L.parse)(i.value.toString());if((0,P.isNonEmptyArray)(n))return!0}}catch(i){if(i.fileOperationResult!==m.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.baseResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i)?this.resolvePreviewContent(i):null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:C(i.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(i,n){let t={};try{t=JSON.parse(n||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete t.all:t.all=i,k.OS){case k.OperatingSystem.Macintosh:t.mac=i;break;case k.OperatingSystem.Linux:t.linux=i;break;case k.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(v.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=S,e.KeybindingsSynchroniser=S=we([Q(2,v.IUserDataSyncStoreService),Q(3,v.IUserDataSyncLocalStoreService),Q(4,v.IUserDataSyncLogService),Q(5,E.IConfigurationService),Q(6,v.IUserDataSyncEnablementService),Q(7,m.IFileService),Q(8,R.IEnvironmentService),Q(9,d.IStorageService),Q(10,v.IUserDataSyncUtilService),Q(11,f.ITelemetryService),Q(12,l.IUriIdentityService)],S);let c=class extends I.AbstractInitializer{constructor(i,n,t,s,r,o){super(v.SyncResource.Keybindings,n,t,s,i,r,o)}async doInitialize(i){const n=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,a.VSBuffer.fromString(n)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,L.parse)(i.value.toString());return!(0,P.isNonEmptyArray)(n)}catch(i){return i.fileOperationResult===m.FileOperationResult.FILE_NOT_FOUND}}getKeybindingsContentFromSyncContent(i){try{return C(i,!0,this.logService)}catch(n){return this.logService.error(n),null}}};e.KeybindingsInitializer=c,e.KeybindingsInitializer=c=we([Q(0,m.IFileService),Q(1,p.IUserDataProfilesService),Q(2,R.IEnvironmentService),Q(3,v.IUserDataSyncLogService),Q(4,d.IStorageService),Q(5,l.IUriIdentityService)],c)}),define(ue[122],he([0,1,17,14,3,11,21,77,15,27,34,7,16,18,28,19,40,211,24]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=void 0,e.parseSettingsSyncContent=S;function C(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function S(i){const n=JSON.parse(i);return C(n)?n:{settings:i}}let c=class extends I.AbstractJsonFileSynchroniser{constructor(n,t,s,r,o,h,y,A,b,w,O,N,F,M){super(n.settingsResource,{syncResource:v.SyncResource.Settings,profile:n},t,s,r,o,h,y,O,N,A,b,w,M),this.profile=n,this.extensionManagementService=F,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.coreIgnoredSettings=void 0,this.systemExtensionsIgnoredSettings=void 0,this.userExtensionsIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(n){const t=await this.getLastSyncUserData(),s=await this.getLatestRemoteUserData(n,t),r=this.getSettingsSyncContent(s),o=new T.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE,this.logService);return r?.settings&&o.parse(r.settings),o.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(n,t,s){const r=await this.getLocalFileContent(),o=await this.getFormattingOptions(),h=this.getSettingsSyncContent(n);t=t===null&&s?n:t;const y=t?this.getSettingsSyncContent(t):null,A=await this.getIgnoredSettings();let b=null,w=!1,O=!1,N=!1;if(h){let z=r?r.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const J=(0,g.merge)(z,h.settings,y?y.settings:null,A,[],o);b=J.localContent||J.remoteContent,w=J.localContent!==null,O=J.remoteContent!==null,N=J.hasConflicts}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),b=r.value.toString().trim()||"{}",this.validateContent(b),O=!0);const F=r?r.value.toString():null,M=y?.settings??null,H={content:N?M:b,localChange:w?v.Change.Modified:v.Change.None,remoteChange:O?v.Change.Modified:v.Change.None,hasConflicts:N};return[{fileContent:r,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:F,localChange:H.localChange,remoteResource:this.remoteResource,remoteContent:h?h.settings:null,remoteChange:H.remoteChange,previewResource:this.previewResource,previewResult:H,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(n){const t=this.getSettingsSyncContent(n);if(t===null)return!0;const s=await this.getLocalFileContent(),r=s?s.value.toString().trim():"",o=await this.getIgnoredSettings(),h=await this.getFormattingOptions();return(0,g.merge)(r||"{}",t.settings,t.settings,o,[],h).remoteContent!==null}async getMergeResult(n,t){const s=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...n.previewResult,content:n.previewResult.content?(0,g.updateIgnoredSettings)(n.previewResult.content,"{}",r,s):null}}async getAcceptResult(n,t,s,r){const o=await this.getFormattingOptions(),h=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:n.fileContent?(0,g.updateIgnoredSettings)(n.fileContent.value.toString(),"{}",h,o):null,localChange:v.Change.None,remoteChange:v.Change.Modified};if(this.extUri.isEqual(t,this.remoteResource))return{content:n.remoteContent!==null?(0,g.updateIgnoredSettings)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",h,o):null,localChange:v.Change.Modified,remoteChange:v.Change.None};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,g.updateIgnoredSettings)(s,n.fileContent?n.fileContent.value.toString():"{}",h,o):null,localChange:v.Change.Modified,remoteChange:v.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(n,t,s,r){const{fileContent:o}=s[0][0];let{content:h,localChange:y,remoteChange:A}=s[0][1];if(y===v.Change.None&&A===v.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),h=h?h.trim():"{}",h=h||"{}",this.validateContent(h),y!==v.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(h,o,r),await this.configurationService.reloadConfiguration(k.ConfigurationTarget.USER_LOCAL),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),A!==v.Change.None){const b=await this.getFormattingOptions(),w=this.getSettingsSyncContent(n),O=await this.getIgnoredSettings(h);h=(0,g.updateIgnoredSettings)(h,w?w.settings:"{}",O,b),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),n=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(h)),r?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(n),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n)return!(0,g.isEmpty)(n.value.toString())}catch(n){if(n.fileOperationResult!==m.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(n){return this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n)||this.extUri.isEqual(this.baseResource,n)?this.resolvePreviewContent(n):null}async resolvePreviewContent(n){let t=await super.resolvePreviewContent(n);if(t){const s=await this.getFormattingOptions(),r=await this.getIgnoredSettings();t=(0,g.updateIgnoredSettings)(t,"{}",r,s)}return t}getSettingsSyncContent(n){return n.syncData?this.parseSettingsSyncContent(n.syncData.content):null}parseSettingsSyncContent(n){try{return S(n)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(n){return{settings:n}}async getIgnoredSettings(n){if(this.coreIgnoredSettings||(this.coreIgnoredSettings=this.userDataSyncUtilService.resolveDefaultCoreIgnoredSettings()),this.systemExtensionsIgnoredSettings||(this.systemExtensionsIgnoredSettings=this.getIgnoredSettingForSystemExtensions()),!this.userExtensionsIgnoredSettings){this.userExtensionsIgnoredSettings=this.getIgnoredSettingForUserExtensions();const s=this._register(_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:o})=>!!o)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{s.dispose(),this.userExtensionsIgnoredSettings=void 0}))}const t=(await Promise.all([this.coreIgnoredSettings,this.systemExtensionsIgnoredSettings,this.userExtensionsIgnoredSettings])).flat();return(0,g.getIgnoredSettings)(t,this.configurationService,n)}async getIgnoredSettingForSystemExtensions(){const n=await this.extensionManagementService.getInstalled(R.ExtensionType.System);return(0,P.distinct)(n.map(t=>(0,v.getIgnoredSettingsForExtension)(t.manifest)).flat())}async getIgnoredSettingForUserExtensions(){const n=await this.extensionManagementService.getInstalled(R.ExtensionType.User,this.profile.extensionsResource);return(0,P.distinct)(n.map(t=>(0,v.getIgnoredSettingsForExtension)(t.manifest)).flat())}validateContent(n){if(this.hasErrors(n,!1))throw new v.UserDataSyncError((0,L.localize)(11073,null),v.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.SettingsSynchroniser=c,e.SettingsSynchroniser=c=we([Q(2,m.IFileService),Q(3,D.IEnvironmentService),Q(4,d.IStorageService),Q(5,v.IUserDataSyncStoreService),Q(6,v.IUserDataSyncLocalStoreService),Q(7,v.IUserDataSyncLogService),Q(8,v.IUserDataSyncUtilService),Q(9,k.IConfigurationService),Q(10,v.IUserDataSyncEnablementService),Q(11,f.ITelemetryService),Q(12,E.IExtensionManagementService),Q(13,l.IUriIdentityService)],c);let u=class extends I.AbstractInitializer{constructor(n,t,s,r,o,h){super(v.SyncResource.Settings,t,s,r,n,o,h)}async doInitialize(n){const t=n.syncData?this.parseSettingsSyncContent(n.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,a.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,g.isEmpty)(n.value.toString().trim())}catch(n){return n.fileOperationResult===m.FileOperationResult.FILE_NOT_FOUND}}parseSettingsSyncContent(n){try{return S(n)}catch(t){this.logService.error(t)}return null}};e.SettingsInitializer=u,e.SettingsInitializer=u=we([Q(0,m.IFileService),Q(1,p.IUserDataProfilesService),Q(2,D.IEnvironmentService),Q(3,v.IUserDataSyncLogService),Q(4,d.IStorageService),Q(5,l.IUriIdentityService)],u)}),define(ue[123],he([0,1,14,3,29,21,15,7,16,18,28,19,40,208,24]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0,e.parseSnippets=p;function p(v){return JSON.parse(v.content)}let I=class extends d.AbstractSynchroniser{constructor(C,S,c,u,i,n,t,s,r,o,h,y){super({syncResource:l.SyncResource.Snippets,profile:C},S,u,c,i,n,t,o,h,s,r,y),this.version=1,this.snippetsFolder=C.snippetsHome,this._register(this.fileService.watch(c.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(a.Event.filter(this.fileService.onDidFilesChange,A=>A.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(C,S,c){const u=await this.getSnippetsFileContents(),i=this.toSnippetsContents(u),n=C.syncData?this.parseSnippets(C.syncData):null;S=S===null&&c?C:S;const t=S&&S.syncData?this.parseSnippets(S.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,f.merge)(i,n,t);return this.getResourcePreviews(s,u,n||{},t||{})}async hasRemoteChanged(C){const S=C.syncData?this.parseSnippets(C.syncData):null;if(S===null)return!0;const c=await this.getSnippetsFileContents(),u=this.toSnippetsContents(c),i=(0,f.merge)(u,S,S);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async getMergeResult(C,S){return C.previewResult}async getAcceptResult(C,S,c,u){if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:C.fileContent?C.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:C.fileContent?C.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:C.remoteContent,localChange:C.remoteContent!==null?C.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder))return c===void 0?{content:C.previewResult.content,localChange:C.previewResult.localChange,remoteChange:C.previewResult.remoteChange}:{content:c,localChange:c===null?C.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:c===null?C.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${S.toString()}`)}async applyResult(C,S,c,u){const i=c.map(([n,t])=>({...n,acceptResult:t}));i.every(({localChange:n,remoteChange:t})=>n===l.Change.None&&t===l.Change.None)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),i.some(({localChange:n})=>n!==l.Change.None)&&(await this.updateLocalBackup(i),await this.updateLocalSnippets(i,u)),i.some(({remoteChange:n})=>n!==l.Change.None)&&(C=await this.updateRemoteSnippets(i,C,u)),S?.ref!==C.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(C),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of i)try{await this.fileService.del(n)}catch{}}getResourcePreviews(C,S,c,u){const i=new Map;for(const n of Object.keys(C.local.added)){const t={content:C.local.added[n],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(C.local.updated)){const t={content:C.local.updated[n],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},s=S[n]?S[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of C.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},s=S[n]?S[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(C.remote.added)){const t={content:C.remote.added[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},s=S[n]?S[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(C.remote.updated)){const t={content:C.remote.updated[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},s=S[n]?S[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of C.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of C.conflicts){const t={content:u[n]??null,hasConflicts:!0,localChange:S[n]?l.Change.Modified:l.Change.Added,remoteChange:c[n]?l.Change.Modified:l.Change.Added},s=S[n]?S[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[n]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(S))if(!i.has(n)){const t={content:S[n]?S[n].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},s=S[n]?S[n].value.toString():null;i.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[n]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...i.values()]}async resolveContent(C){return this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(C):null}async hasLocalData(){try{const C=await this.getSnippetsFileContents();if(Object.keys(C).length)return!0}catch{}return!1}async updateLocalBackup(C){const S={};for(const c of C)c.fileContent&&(S[this.extUri.basename(c.localResource)]=c.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(S)))}async updateLocalSnippets(C,S){for(const{fileContent:c,acceptResult:u,localResource:i,remoteResource:n,localChange:t}of C)if(t!==l.Change.None){const s=n?this.extUri.basename(n):this.extUri.basename(i),r=this.extUri.joinPath(this.snippetsFolder,s);t===l.Change.Deleted?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===l.Change.Added?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,P.VSBuffer.fromString(u.content),{overwrite:S}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,P.VSBuffer.fromString(u.content),S?void 0:c),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(C,S,c){const u=S.syncData?this.parseSnippets(S.syncData):{},i=(0,_.deepClone)(u);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:r}of C)if(r!==l.Change.None){const o=t?this.extUri.basename(t):this.extUri.basename(s);r===l.Change.Deleted?delete i[o]:i[o]=n.content}return(0,f.areSame)(u,i)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),S=await this.updateRemoteUserData(JSON.stringify(i),c?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),S}parseSnippets(C){return p(C)}toSnippetsContents(C){const S={};for(const c of Object.keys(C))S[c]=C[c].value.toString();return S}async getSnippetsFileContents(){const C={};let S;try{S=await this.fileService.resolve(this.snippetsFolder)}catch(c){if(c instanceof T.FileOperationError&&c.fileOperationResult===T.FileOperationResult.FILE_NOT_FOUND)return C;throw c}for(const c of S.children||[]){const u=c.resource,i=this.extUri.extname(u);if(i===".json"||i===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,u),t=await this.fileService.readFile(u);C[n]=t}}return C}};e.SnippetsSynchroniser=I,e.SnippetsSynchroniser=I=we([Q(2,k.IEnvironmentService),Q(3,T.IFileService),Q(4,D.IStorageService),Q(5,l.IUserDataSyncStoreService),Q(6,l.IUserDataSyncLocalStoreService),Q(7,l.IUserDataSyncLogService),Q(8,L.IConfigurationService),Q(9,l.IUserDataSyncEnablementService),Q(10,E.ITelemetryService),Q(11,R.IUriIdentityService)],I);let g=class extends d.AbstractInitializer{constructor(C,S,c,u,i,n){super(l.SyncResource.Snippets,S,c,u,C,i,n)}async doInitialize(C){const S=C.syncData?JSON.parse(C.syncData.content):null;if(!S){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const u of Object.keys(S)){const i=S[u];if(i){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,u);await this.fileService.createFile(n,P.VSBuffer.fromString(i)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(C)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(C){return C.fileOperationResult===T.FileOperationResult.FILE_NOT_FOUND}}};e.SnippetsInitializer=g,e.SnippetsInitializer=g=we([Q(0,T.IFileService),Q(1,m.IUserDataProfilesService),Q(2,k.IEnvironmentService),Q(3,l.IUserDataSyncLogService),Q(4,D.IStorageService),Q(5,R.IUriIdentityService)],g)}),define(ue[124],he([0,1,14,21,15,7,16,18,28,19,40,24]),function(ae,e,P,a,_,L,k,T,D,E,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=void 0,e.getTasksContentFromSyncContent=d;function d(I,g){try{return JSON.parse(I).tasks??null}catch(v){return g.error(v),null}}let f=class extends R.AbstractFileSynchroniser{constructor(g,v,C,S,c,u,i,n,t,s,r,o){super(g.tasksResource,{syncResource:m.SyncResource.Tasks,profile:g},v,n,t,s,C,S,i,r,c,u,o),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(g,v,C,S){const c=g.syncData?d(g.syncData.content,this.logService):null;v=v===null&&C?g:v;const u=v?.syncData?d(v.syncData.content,this.logService):null,i=await this.getLocalFileContent();let n=null,t=!1,s=!1,r=!1;if(g.syncData){const y=i?i.value.toString():null;if(!u||u!==y||u!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=p(y,c,u);n=A.content,r=A.hasConflicts,t=A.hasLocalChanged,s=A.hasRemoteChanged}}else i&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=i.value.toString(),s=!0);const o={content:r?u:n,localChange:t?i?m.Change.Modified:m.Change.Added:m.Change.None,remoteChange:s?m.Change.Modified:m.Change.None,hasConflicts:r},h=i?i.value.toString():null;return[{fileContent:i,baseResource:this.baseResource,baseContent:u,localResource:this.localResource,localContent:h,localChange:o.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:o.remoteChange,previewResource:this.previewResource,previewResult:o,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(g){const v=g?.syncData?d(g.syncData.content,this.logService):null;if(v===null)return!0;const C=await this.getLocalFileContent(),S=C?C.value.toString():null,c=p(S,v,v);return c.hasLocalChanged||c.hasRemoteChanged}async getMergeResult(g,v){return g.previewResult}async getAcceptResult(g,v,C,S){if(this.extUri.isEqual(v,this.localResource))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:m.Change.None,remoteChange:m.Change.Modified};if(this.extUri.isEqual(v,this.remoteResource))return{content:g.remoteContent,localChange:m.Change.Modified,remoteChange:m.Change.None};if(this.extUri.isEqual(v,this.previewResource))return C===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:C,localChange:m.Change.Modified,remoteChange:m.Change.Modified};throw new Error(`Invalid Resource: ${v.toString()}`)}async applyResult(g,v,C,S){const{fileContent:c}=C[0][0],{content:u,localChange:i,remoteChange:n}=C[0][1];if(i===m.Change.None&&n===m.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),i!==m.Change.None&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),c&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(c.value.toString()))),u?await this.updateLocalFileContent(u,c,S):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==m.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const t=JSON.stringify(this.toTasksSyncContent(u));g=await this.updateRemoteUserData(t,S?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}v?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(g){return this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.baseResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g)?this.resolvePreviewContent(g):null}toTasksSyncContent(g){return g?{tasks:g}:{}}};e.TasksSynchroniser=f,e.TasksSynchroniser=f=we([Q(2,m.IUserDataSyncStoreService),Q(3,m.IUserDataSyncLocalStoreService),Q(4,m.IUserDataSyncLogService),Q(5,a.IConfigurationService),Q(6,m.IUserDataSyncEnablementService),Q(7,L.IFileService),Q(8,_.IEnvironmentService),Q(9,k.IStorageService),Q(10,T.ITelemetryService),Q(11,D.IUriIdentityService)],f);let l=class extends R.AbstractInitializer{constructor(g,v,C,S,c,u){super(m.SyncResource.Tasks,v,C,S,g,c,u),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(g){const v=g.syncData?d(g.syncData.content,this.logService):null;if(!v){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,P.VSBuffer.fromString(v)),await this.updateLastSyncUserData(g)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=l,e.TasksInitializer=l=we([Q(0,L.IFileService),Q(1,E.IUserDataProfilesService),Q(2,_.IEnvironmentService),Q(3,m.IUserDataSyncLogService),Q(4,k.IStorageService),Q(5,D.IUriIdentityService)],l);function p(I,g,v){if(I===null&&g===null&&v===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(I===g)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const C=v!==I,S=v!==g;return!C&&!S?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:C&&!S?{content:I,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:S&&!C?{content:g,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:I,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ue[125],he([0,1,45,21,15,7,16,18,28,19,40,209,24]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0,e.stringifyLocalProfiles=l,e.parseUserDataProfilesManifest=p;let f=class extends R.AbstractSynchroniser{constructor(g,v,C,S,c,u,i,n,t,s,r,o,h){super({syncResource:d.SyncResource.Profiles,profile:g},v,S,c,u,i,n,r,o,t,s,h),this.userDataProfilesService=C,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(C.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const g=await this.getLastSyncUserData();return g?.syncData?p(g.syncData):null}async getRemoteSyncedProfiles(g){const v=await this.getLastSyncUserData(),C=await this.getLatestRemoteUserData(g,v);return C?.syncData?p(C.syncData):null}async generateSyncPreview(g,v,C){if(!this.userDataProfilesService.isEnabled())throw new d.UserDataSyncError("Cannot sync profiles because they are disabled",d.UserDataSyncErrorCode.LocalError);const S=g.syncData?p(g.syncData):null,c=v?.syncData?p(v.syncData):null,u=this.getLocalUserDataProfiles(),{local:i,remote:n}=(0,m.merge)(u,S,c,[]),t={local:i,remote:n,content:c?this.stringifyRemoteProfiles(c):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:n!==null?d.Change.Modified:d.Change.None},s=l(u,!1);return[{baseResource:this.baseResource,baseContent:c?this.stringifyRemoteProfiles(c):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:S?this.stringifyRemoteProfiles(S):null,remoteProfiles:S,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(g){const v=g?.syncData?p(g.syncData):null,C=this.getLocalUserDataProfiles(),{remote:S}=(0,m.merge)(C,v,v,[]);return!!S?.added.length||!!S?.removed.length||!!S?.updated.length}async getMergeResult(g,v){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,v,C,S){if(this.extUri.isEqual(v,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(v,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(v,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${v.toString()}`)}async acceptLocal(g){const v=this.getLocalUserDataProfiles(),C=(0,m.merge)(v,null,null,[]),{local:S,remote:c}=C;return{content:g.localContent,local:S,remote:c,localChange:S.added.length>0||S.removed.length>0||S.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:c!==null?d.Change.Modified:d.Change.None}}async acceptRemote(g){const v=g.remoteContent?JSON.parse(g.remoteContent):null,C=[],S=[];for(const c of this.getLocalUserDataProfiles()){const u=v?.find(i=>i.id===c.id);u&&(C.push({id:c.id,name:c.name,collection:u.collection}),S.push(c))}if(v!==null){const c=(0,m.merge)(S,v,C,[]),{local:u,remote:i}=c;return{content:g.remoteContent,local:u,remote:i,localChange:u.added.length>0||u.removed.length>0||u.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:i!==null?d.Change.Modified:d.Change.None}}else return{content:g.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:d.Change.None,remoteChange:d.Change.None}}async applyResult(g,v,C,S){const{local:c,remote:u,localChange:i,remoteChange:n}=C[0][1];i===d.Change.None&&n===d.Change.None&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const t=C[0][0].remoteProfiles||[];if(t.length+(u?.added.length??0)-(u?.removed.length??0)>20)throw new d.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.",d.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==d.Change.None&&(await this.backupLocal(l(this.getLocalUserDataProfiles(),!1)),await Promise.all(c.removed.map(async s=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${s.name}' profile...`),await this.userDataProfilesService.removeProfile(s),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${s.name}'.`)})),await Promise.all(c.added.map(async s=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${s.name}' profile...`),await this.userDataProfilesService.createProfile(s.id,s.name,{shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${s.name}'.`)})),await Promise.all(c.updated.map(async s=>{const r=this.userDataProfilesService.profiles.find(o=>o.id===s.id);r?(this.logService.trace(`${this.syncResourceLogLabel}: Updating '${s.name}' profile...`),await this.userDataProfilesService.updateProfile(r,{name:s.name,shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${s.name}'.`)):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${s.id}' to update.`)}))),n!==d.Change.None){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const s=[],r=t.length+(u?.added.length??0)<=20;if(r)for(const o of u?.added||[]){const h=await this.userDataSyncStoreService.createCollection(this.syncHeaders);s.push(h),t.push({id:o.id,name:o.name,collection:h,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const o of u?.removed||[])t.splice(t.findIndex(({id:h})=>o.id===h),1);for(const o of u?.updated||[]){const h=t.find(({id:y})=>o.id===y);h&&t.splice(t.indexOf(h),1,{...h,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{g=await this.updateRemoteProfiles(t,S?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${r&&u?.added.length?` Added: ${JSON.stringify(u.added.map(o=>o.name))}.`:""}${u?.updated.length?` Updated: ${JSON.stringify(u.updated.map(o=>o.name))}.`:""}${u?.removed.length?` Removed: ${JSON.stringify(u.removed.map(o=>o.name))}.`:""}`)}catch(o){if(s.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const h of s)await this.userDataSyncStoreService.deleteCollection(h,this.syncHeaders)}throw o}for(const o of u?.removed||[])await this.userDataSyncStoreService.deleteCollection(o.collection,this.syncHeaders)}v?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(g,v){return this.updateRemoteUserData(this.stringifyRemoteProfiles(g),v)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(g){if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.baseResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g)){const v=await this.resolvePreviewContent(g);return v&&(0,P.toFormattedString)(JSON.parse(v),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(g=>!g.isDefault&&!g.isTransient)}stringifyRemoteProfiles(g){return JSON.stringify([...g].sort((v,C)=>v.name.localeCompare(C.name)))}};e.UserDataProfilesManifestSynchroniser=f,e.UserDataProfilesManifestSynchroniser=f=we([Q(2,E.IUserDataProfilesService),Q(3,L.IFileService),Q(4,_.IEnvironmentService),Q(5,k.IStorageService),Q(6,d.IUserDataSyncStoreService),Q(7,d.IUserDataSyncLocalStoreService),Q(8,d.IUserDataSyncLogService),Q(9,a.IConfigurationService),Q(10,d.IUserDataSyncEnablementService),Q(11,T.ITelemetryService),Q(12,D.IUriIdentityService)],f);function l(I,g){const v=[...I].sort((C,S)=>C.name.localeCompare(S.name)).map(C=>({id:C.id,name:C.name}));return g?(0,P.toFormattedString)(v,{}):JSON.stringify(v)}function p(I){return JSON.parse(I.content)}}),define(ue[228],he([0,1,3,2,5,15,16,18,24]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let R=class extends a.Disposable{constructor(d,f,l,p){super(),this.storageService=d,this.telemetryService=f,this.environmentService=l,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new P.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new P.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(d.onDidChangeValue(k.StorageScope.APPLICATION,void 0,this._register(new a.DisposableStore))(I=>this.onDidStorageChange(I)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,k.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:d}),this.storageService.store(E,d,k.StorageScope.APPLICATION,k.StorageTarget.MACHINE))}isResourceEnabled(d){return this.storageService.getBoolean((0,D.getEnablementKey)(d),k.StorageScope.APPLICATION,!0)}setResourceEnablement(d,f){if(this.isResourceEnabled(d)!==f){const l=(0,D.getEnablementKey)(d);this.storeResourceEnablement(l,f)}}getResourceSyncStateVersion(d){}storeResourceEnablement(d,f){this.storageService.store(d,f,k.StorageScope.APPLICATION,_.isWeb?k.StorageTarget.USER:k.StorageTarget.MACHINE)}onDidStorageChange(d){if(E===d.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const f=D.ALL_SYNC_RESOURCES.filter(l=>(0,D.getEnablementKey)(l)===d.key)[0];if(f){this._onDidChangeResourceEnablement.fire([f,this.isResourceEnabled(f)]);return}}};e.UserDataSyncEnablementService=R,e.UserDataSyncEnablementService=R=we([Q(0,k.IStorageService),Q(1,T.ITelemetryService),Q(2,L.IEnvironmentService),Q(3,D.IUserDataSyncStoreManagementService)],R)}),define(ue[229],he([0,1,6,14,71,2,20,21,15,7,19,24]),function(ae,e,P,a,_,L,k,T,D,E,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let d=class extends L.Disposable{constructor(l,p,I,g,v){super(),this.environmentService=l,this.fileService=p,this.configurationService=I,this.logService=g,this.userDataProfilesService=v,this.cleanUp()}async cleanUp(){for(const p of this.userDataProfilesService.profiles)for(const I of m.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(I,p.isDefault?void 0:p.id))}catch(g){this.logService.error(g)}let l;try{l=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(p){(0,E.toFileOperationResult)(p)!==E.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(p);return}if(l.children){for(const p of l.children)if(p.isDirectory&&!m.ALL_SYNC_RESOURCES.includes(p.name)&&!this.userDataProfilesService.profiles.some(I=>I.id===p.name))try{this.logService.info("Deleting non existing profile from backup",p.resource.path),await this.fileService.del(p.resource,{recursive:!0})}catch(I){this.logService.error(I)}}}async getAllResourceRefs(l,p,I){const g=this.getResourceBackupHome(l,p,I);try{const v=await this.fileService.resolve(g);if(v.children)return v.children.filter(S=>S.isFile&&!S.name.startsWith("lastSync")).sort().reverse().map(S=>({ref:S.name,created:this.getCreationTime(S)}))}catch(v){if((0,E.toFileOperationResult)(v)!==E.FileOperationResult.FILE_NOT_FOUND)throw v}return[]}async resolveResourceContent(l,p,I,g){const v=this.getResourceBackupHome(l,I,g),C=(0,k.joinPath)(v,p);try{return(await this.fileService.readFile(C)).value.toString()}catch(S){return this.logService.error(S),null}}async writeResource(l,p,I,g,v){const C=this.getResourceBackupHome(l,g,v),S=(0,k.joinPath)(C,`${(0,_.toLocalISOString)(I).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(S,a.VSBuffer.fromString(p))}catch(c){this.logService.error(c)}}getResourceBackupHome(l,p,I=this.environmentService.userDataSyncHome){return(0,k.joinPath)(I,...p?[p,l]:[l])}async cleanUpBackup(l){try{try{if(!await this.fileService.exists(l))return}catch{return}const p=await this.fileService.resolve(l);if(p.children){const I=p.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let v=I.filter(S=>Date.now()-this.getCreationTime(S)>g);const C=I.length-v.length;C<10&&(v=v.slice(10-C)),await P.Promises.settled(v.map(async S=>{this.logService.info("Deleting from backup",S.resource.path),await this.fileService.del(S.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=d,e.UserDataSyncLocalStoreService=d=we([Q(0,D.IEnvironmentService),Q(1,E.IFileService),Q(2,T.IConfigurationService),Q(3,m.IUserDataSyncLogService),Q(4,R.IUserDataProfilesService)],d)}),define(ue[86],he([0,1,3,2,5,26,11,15,7,4,23,49,16,24]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.isWebPlatform=c,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const p="sync.currentMachineName",I="Safari",g="Chrome",v="Edge",C="Firefox",S="Android";function c(n){switch(n){case I:case g:case v:case C:case S:case(0,_.PlatformToString)(_.Platform.Web):return!0}return!1}function u(){return _.isSafari?I:_.isChrome?g:_.isEdge?v:_.isFirefox?C:_.isAndroid?S:(0,_.PlatformToString)(_.isWeb?_.Platform.Web:_.platform)}let i=class extends a.Disposable{static{l=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(t,s,r,o,h,y){super(),this.storageService=r,this.userDataSyncStoreService=o,this.logService=h,this.productService=y,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,m.getServiceMachineId)(t,s,r)}async getMachines(t){const s=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(o=>({...o,isCurrent:o.id===s}))}async addCurrentMachine(t){const s=await this.currentMachineIdPromise,r=await this.readMachinesData(t);r.machines.some(({id:o})=>o===s)||(r.machines.push({id:s,name:this.computeCurrentMachineName(r.machines),platform:u()}),await this.writeMachinesData(r))}async removeCurrentMachine(t){const s=await this.currentMachineIdPromise,r=await this.readMachinesData(t),o=r.machines.filter(({id:h})=>h!==s);o.length!==r.machines.length&&(r.machines=o,await this.writeMachinesData(r))}async renameMachine(t,s,r){const o=await this.readMachinesData(r),h=o.machines.find(({id:y})=>y===t);if(h){h.name=s,await this.writeMachinesData(o);const y=await this.currentMachineIdPromise;t===y&&this.storageService.store(p,s,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}}async setEnablements(t){const s=await this.readMachinesData();for(const[r,o]of t){const h=s.machines.find(y=>y.id===r);h&&(h.disabled=o?void 0:!0)}await this.writeMachinesData(s)}computeCurrentMachineName(t){const s=this.storageService.get(p,d.StorageScope.APPLICATION);if(s)return s;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${u()} (${this.productService.nameShort})`,o=new RegExp(`${(0,L.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let h=0;for(const y of t){const A=o.exec(y.name),b=A?parseInt(A[1]):0;h=b>h?b:h}return`${r} #${h+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const s=this.parse(this.userData);if(s.version!==l.VERSION)throw new Error((0,k.localize)(11059,null,this.productService.nameLong));return s}async writeMachinesData(t){const s=JSON.stringify(t),r=await this.userDataSyncStoreService.writeResource(l.RESOURCE,s,this.userData?.ref||null);this.userData={ref:r,content:s},this._onDidChange.fire()}async readUserData(t){if(this.userData){const s=t&&t.latest?t.latest[l.RESOURCE]:void 0;if(this.userData.ref===s)return this.userData;if(s===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(l.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.logService.error(s)}return{version:l.VERSION,machines:[]}}};e.UserDataSyncMachinesService=i,e.UserDataSyncMachinesService=i=l=we([Q(0,T.IEnvironmentService),Q(1,D.IFileService),Q(2,d.IStorageService),Q(3,f.IUserDataSyncStoreService),Q(4,f.IUserDataSyncLogService),Q(5,R.IProductService)],i)}),define(ue[230],he([0,1,6,71,43,8,3,2,5,20,9,11,23,16,18,24,82,86]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const v="sync.disableMachineEventually",C="sync.sessionId",S="sync.storeUrl",c="sync.productQuality";let u=class extends T.Disposable{get syncUrl(){const t=this.storageService.get(S,f.StorageScope.APPLICATION);return t?R.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(S,t.toString(),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE):this.storageService.remove(S,f.StorageScope.APPLICATION)}get productQuality(){return this.storageService.get(c,f.StorageScope.APPLICATION)}set productQuality(t){t?this.storageService.store(c,t,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE):this.storageService.remove(c,f.StorageScope.APPLICATION)}constructor(t,s,r,o,h,y,A,b,w,O){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=o,this.userDataSyncService=h,this.logService=y,this.userDataSyncAccountService=A,this.telemetryService=b,this.userDataSyncMachinesService=w,this.storageService=O,this.autoSync=this._register(new T.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new P.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(h.onDidChangeLocal(N=>this.triggerSync([N],!1,!1))),this._register(k.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,N])=>N)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new i(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(C,f.StorageScope.APPLICATION),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(o){if(this.logService.error(o),s)this.updateEnablement(!1);else throw o}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=p.UserDataSyncError.toUserDataSyncError(t);s instanceof p.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code===p.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code===p.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code===p.UserDataSyncErrorCode.LocalTooManyRequests?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code===p.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code===p.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code===p.UserDataSyncErrorCode.UpgradeRequired||s.code===p.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code===p.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code===p.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code===p.UserDataSyncErrorCode.ServiceChanged||s.code===p.UserDataSyncErrorCode.DefaultServiceChanged?D.isWeb&&s.code===p.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(v,!0,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await(0,P.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(v,f.StorageScope.APPLICATION,!1)}stopDisableMachineEventually(){this.storageService.remove(v,f.StorageScope.APPLICATION)}async triggerSync(t,s,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const o=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:o}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=u,e.UserDataAutoSyncService=u=we([Q(0,d.IProductService),Q(1,p.IUserDataSyncStoreManagementService),Q(2,p.IUserDataSyncStoreService),Q(3,p.IUserDataSyncEnablementService),Q(4,p.IUserDataSyncService),Q(5,p.IUserDataSyncLogService),Q(6,I.IUserDataSyncAccountService),Q(7,l.ITelemetryService),Q(8,g.IUserDataSyncMachinesService),Q(9,f.IStorageService)],u);class i extends T.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(t,s,r,o,h,y,A,b,w){super(),this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=o,this.userDataSyncService=h,this.userDataSyncMachinesService=y,this.logService=A,this.telemetryService=b,this.storageService=w,this.intervalHandler=this._register(new T.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,T.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(i.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,P.disposableTimeout)(()=>{this.sync(i.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(t,s){const r=(0,P.createCancelablePromise)(async o=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,L.isCancellationError)(h))return}return this.doSync(t,s,o)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,E.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,E.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,r){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let o;try{await this.createAndRunSyncTask(s,r)}catch(h){if(this.logService.error(h),o=h,p.UserDataSyncError.toUserDataSyncError(h).code===p.UserDataSyncErrorCode.MethodNotFound)try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(s,r),o=void 0}catch(y){this.logService.error(y),o=y}}this._onDidFinishSync.fire(o)}async createAndRunSyncTask(t,s){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,t),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,m.localize)(11066,null),p.UserDataSyncErrorCode.DefaultServiceChanged):new p.UserDataAutoSyncError((0,m.localize)(11067,null),p.UserDataSyncErrorCode.ServiceChanged):new p.UserDataAutoSyncError((0,m.localize)(11068,null),p.UserDataSyncErrorCode.TurnedOff);const r=this.storageService.get(C,f.StorageScope.APPLICATION);if(r&&this.manifest&&r!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,m.localize)(11069,null),p.UserDataSyncErrorCode.DefaultServiceChanged):new p.UserDataAutoSyncError((0,m.localize)(11070,null),p.UserDataSyncErrorCode.ServiceChanged):new p.UserDataAutoSyncError((0,m.localize)(11071,null),p.UserDataSyncErrorCode.SessionExpired);const o=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const h=o.find(A=>A.isCurrent);if(h?.disabled)throw new p.UserDataAutoSyncError((0,m.localize)(11072,null),p.UserDataSyncErrorCode.TurnedOff);const y=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(A){throw new p.UserDataAutoSyncError((0,_.toErrorMessage)(A),A instanceof p.UserDataSyncError?A.code:p.UserDataSyncErrorCode.Unknown)}this.manifest&&this.manifest.session!==r&&this.storageService.store(C,this.manifest.session,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),!s.isCancellationRequested&&(h||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(t){return super._register(t)}}}),define(ue[231],he([0,1,9,11,15,7,49,16,28,24,19,40,123,122,121,21,124,119,120,4,125,45,26]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S,c,u){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class{static{i=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(s,r,o,h,y,A,b,w,O,N){this.userDataSyncStoreService=s,this.userDataSyncLocalStoreService=r,this.logService=o,this.environmentService=y,this.storageService=A,this.fileService=b,this.userDataProfilesService=w,this.configurationService=O,this.instantiationService=N,this.extUri=h.extUri}async getRemoteSyncedProfiles(){const s=await this.userDataSyncStoreService.readResource(E.SyncResource.Profiles,null,void 0);if(s.content){const r=this.parseSyncData(s.content,E.SyncResource.Profiles);return(0,S.parseUserDataProfilesManifest)(r)}return[]}async getLocalSyncedProfiles(s){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs(E.SyncResource.Profiles,void 0,s);if(r.length){const o=await this.userDataSyncLocalStoreService.resolveResourceContent(E.SyncResource.Profiles,r[0].ref,void 0,s);if(o){const h=this.parseSyncData(o,E.SyncResource.Profiles);return(0,S.parseUserDataProfilesManifest)(h)}}return[]}async getLocalSyncedMachines(s){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,s);if(r.length){const o=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",r[0].ref,void 0,s);if(o)return JSON.parse(o).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(s,r){return(await this.userDataSyncStoreService.getAllResourceRefs(s,r?.collection)).map(({created:h,ref:y})=>({created:h,uri:this.toUri({remote:!0,syncResource:s,profile:r?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(s,r,o){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(s,r?.collection,o)).map(({created:y,ref:A})=>({created:y,uri:this.toUri({remote:!1,syncResource:s,profile:r?.id??this.userDataProfilesService.defaultProfile.id,collection:r?.collection,ref:A,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:s}){const r=this.resolveUri(s),o=r?this.userDataProfilesService.profiles.find(h=>h.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:s}){const r=this.resolveUri(s);if(!r)return[];const o=this.userDataProfilesService.profiles.find(h=>h.id===r.profile);switch(r.syncResource){case E.SyncResource.Settings:return this.getSettingsAssociatedResources(s,o);case E.SyncResource.Keybindings:return this.getKeybindingsAssociatedResources(s,o);case E.SyncResource.Tasks:return this.getTasksAssociatedResources(s,o);case E.SyncResource.Snippets:return this.getSnippetsAssociatedResources(s,o);case E.SyncResource.GlobalState:return this.getGlobalStateAssociatedResources(s,o);case E.SyncResource.Extensions:return this.getExtensionsAssociatedResources(s,o);case E.SyncResource.Profiles:return this.getProfilesAssociatedResources(s,o);case E.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:s}){const r=this.resolveUri(s);if(r){if(r.remote){if(r.ref){const{content:o}=await this.getUserData(r.syncResource,r.ref,r.collection);if(o)return this.parseSyncData(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.userDataSyncLocalStoreService.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.parseSyncData(o,r.syncResource)?.machineId}return}return(0,k.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(s){const r=this.resolveUri(s);if(!r||r.node===i.NOT_EXISTING_RESOURCE)return null;if(r.ref){const o=await this.getContentFromStore(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.resolveNodeContent(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.resolveLatestContent(r.syncResource,r.profile):null}async getContentFromStore(s,r,o,h,y){if(s){const{content:A}=await this.getUserData(r,h,o);return A}return this.userDataSyncLocalStoreService.resolveResourceContent(r,h,o,y)}resolveNodeContent(s,r,o){const h=this.parseSyncData(r,s);switch(s){case E.SyncResource.Settings:return this.resolveSettingsNodeContent(h,o);case E.SyncResource.Keybindings:return this.resolveKeybindingsNodeContent(h,o);case E.SyncResource.Tasks:return this.resolveTasksNodeContent(h,o);case E.SyncResource.Snippets:return this.resolveSnippetsNodeContent(h,o);case E.SyncResource.GlobalState:return this.resolveGlobalStateNodeContent(h,o);case E.SyncResource.Extensions:return this.resolveExtensionsNodeContent(h,o);case E.SyncResource.Profiles:return this.resolveProfileNodeContent(h,o);case E.SyncResource.WorkspaceState:return null}}async resolveLatestContent(s,r){const o=this.userDataProfilesService.profiles.find(h=>h.id===r);if(!o)return null;switch(s){case E.SyncResource.GlobalState:return this.resolveLatestGlobalStateContent(o);case E.SyncResource.Extensions:return this.resolveLatestExtensionsContent(o);case E.SyncResource.Profiles:return this.resolveLatestProfilesContent(o);case E.SyncResource.Settings:return null;case E.SyncResource.Keybindings:return null;case E.SyncResource.Tasks:return null;case E.SyncResource.Snippets:return null;case E.SyncResource.WorkspaceState:return null}}getSettingsAssociatedResources(s,r){const o=this.extUri.joinPath(s,"settings.json"),h=r?r.settingsResource:this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:h}]}resolveSettingsNodeContent(s,r){switch(r){case"settings.json":return(0,f.parseSettingsSyncContent)(s.content).settings}return null}getKeybindingsAssociatedResources(s,r){const o=this.extUri.joinPath(s,"keybindings.json"),h=r?r.keybindingsResource:this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:h}]}resolveKeybindingsNodeContent(s,r){switch(r){case"keybindings.json":return(0,l.getKeybindingsContentFromSyncContent)(s.content,!!this.configurationService.getValue(E.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(s,r){const o=this.extUri.joinPath(s,"tasks.json"),h=r?r.tasksResource:this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:h}]}resolveTasksNodeContent(s,r){switch(r){case"tasks.json":return(0,I.getTasksContentFromSyncContent)(s.content,this.logService)}return null}async getSnippetsAssociatedResources(s,r){const o=await this.resolveContent(s);if(o){const h=this.parseSyncData(o,E.SyncResource.Snippets);if(h){const y=(0,d.parseSnippets)(h),A=[];for(const b of Object.keys(y)){const w=this.extUri.joinPath(s,b),O=r?this.extUri.joinPath(r.snippetsHome,b):this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);A.push({resource:w,comparableResource:O})}return A}}return[]}resolveSnippetsNodeContent(s,r){return(0,d.parseSnippets)(s)[r]||null}getExtensionsAssociatedResources(s,r){const o=this.extUri.joinPath(s,"extensions.json"),h=r?this.toUri({remote:!1,syncResource:E.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:h}]}resolveExtensionsNodeContent(s,r){switch(r){case"extensions.json":return(0,g.stringify)((0,g.parseExtensions)(s),!0)}return null}async resolveLatestExtensionsContent(s){const{localExtensions:r}=await this.instantiationService.createInstance(g.LocalExtensionsProvider).getLocalExtensions(s);return(0,g.stringify)(r,!0)}getGlobalStateAssociatedResources(s,r){const o=this.extUri.joinPath(s,"globalState.json"),h=r?this.toUri({remote:!1,syncResource:E.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(s,i.NOT_EXISTING_RESOURCE);return[{resource:o,comparableResource:h}]}resolveGlobalStateNodeContent(s,r){switch(r){case"globalState.json":return(0,v.stringify)(JSON.parse(s.content),!0)}return null}async resolveLatestGlobalStateContent(s){const r=await this.instantiationService.createInstance(v.LocalGlobalStateProvider).getLocalGlobalState(s);return(0,v.stringify)(r,!0)}getProfilesAssociatedResources(s,r){const o=this.extUri.joinPath(s,"profiles.json"),h=this.toUri({remote:!1,syncResource:E.SyncResource.Profiles,profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:h}]}resolveProfileNodeContent(s,r){switch(r){case"profiles.json":return(0,c.toFormattedString)(JSON.parse(s.content),{})}return null}async resolveLatestProfilesContent(s){return(0,S.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}toUri(s){const r=s.remote?i.REMOTE_BACKUP_AUTHORITY:i.LOCAL_BACKUP_AUTHORITY,o=[];return s.location&&(o.push(`scheme:${s.location.scheme}`),o.push(`authority:${s.location.authority}`),o.push((0,u.trim)(s.location.path,"/"))),o.push(`syncResource:${s.syncResource}`),o.push(`profile:${s.profile}`),s.collection&&o.push(`collection:${s.collection}`),s.ref&&o.push(`ref:${s.ref}`),s.node&&o.push(s.node),this.extUri.joinPath(P.URI.from({scheme:E.USER_DATA_SYNC_SCHEME,authority:r,path:"/",query:s.location?.query,fragment:s.location?.fragment}),...o)}resolveUri(s){if(s.scheme!==E.USER_DATA_SYNC_SCHEME)return;const r=[];for(;s.path!=="/";)r.unshift(this.extUri.basename(s)),s=this.extUri.dirname(s);if(r.length<2)return;const o=s.authority===i.REMOTE_BACKUP_AUTHORITY;let h,y;const A=[];let b,w,O,N,F;for(;r.length;){const M=r.shift();M.startsWith("scheme:")?h=M.substring(7):M.startsWith("authority:")?y=M.substring(10):M.startsWith("syncResource:")?b=M.substring(13):M.startsWith("profile:")?w=M.substring(8):M.startsWith("collection:")?O=M.substring(11):M.startsWith("ref:")?N=M.substring(4):b?F=M:A.push(M)}return{remote:o,syncResource:b,profile:w,collection:O,ref:N,node:F,location:h&&y!==void 0?this.extUri.joinPath(P.URI.from({scheme:h,authority:y,query:s.query,fragment:s.fragment,path:"/"}),...A):void 0}}parseSyncData(s,r){try{const o=JSON.parse(s);if((0,m.isSyncData)(o))return o}catch(o){this.logService.error(o)}throw new E.UserDataSyncError((0,a.localize)(11058,null),E.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async getUserData(s,r,o){const h=await this.userDataSyncStoreService.resolveResourceContent(s,r,o);return{ref:r,content:h}}};e.UserDataSyncResourceProviderService=n,e.UserDataSyncResourceProviderService=n=i=we([Q(0,E.IUserDataSyncStoreService),Q(1,E.IUserDataSyncLocalStoreService),Q(2,E.IUserDataSyncLogService),Q(3,D.IUriIdentityService),Q(4,_.IEnvironmentService),Q(5,T.IStorageService),Q(6,L.IFileService),Q(7,R.IUserDataProfilesService),Q(8,p.IConfigurationService),Q(9,C.IInstantiationService)],n)}),define(ue[232],he([0,1,17,6,25,43,3,2,20,12,32,21,27,7,4,16,18,19,119,120,121,122,123,124,125,24]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S,c,u,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let r=class extends T.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(b,w,O,N,F,M,H,z,J,V,te){super(),this.fileService=b,this.userDataSyncStoreService=w,this.userDataSyncStoreManagementService=O,this.instantiationService=N,this.logService=F,this.telemetryService=M,this.storageService=H,this.userDataSyncEnablementService=z,this.userDataProfilesService=J,this.userDataSyncResourceProviderService=V,this.userDataSyncLocalStoreService=te,this._status=t.SyncStatus.Uninitialized,this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=O.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this._lastSyncTime=this.storageService.getNumber(s,p.StorageScope.APPLICATION,void 0),this._register((0,T.toDisposable)(()=>this.clearActiveProfileSynchronizers())),this._register(new a.RunOnceScheduler(()=>this.cleanUpStaleStorageData(),5*1e3)).schedule()}async createSyncTask(b,w){this.checkEnablement(),this.logService.info("Sync started.");const O=new Date().getTime(),N=(0,R.generateUuid)();try{const z=(0,t.createSyncHeaders)(N);w&&(z["Cache-Control"]="no-cache"),b=await this.userDataSyncStoreService.manifest(b,z)}catch(z){const J=t.UserDataSyncError.toUserDataSyncError(z);throw y(J,N,this.userDataSyncStoreManagementService,this.telemetryService),J}const F=!1,M=this;let H;return{manifest:b,async run(){if(F)throw new Error("Can run a task only once");H=(0,a.createCancelablePromise)(z=>M.sync(b,!1,N,z)),await H.finally(()=>H=void 0),M.logService.info(`Sync done. Took ${new Date().getTime()-O}ms`),M.updateLastSyncTime()},stop(){return H?.cancel(),M.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.logService.info("Sync started.");const b=new Date().getTime(),w=(0,R.generateUuid)(),O=(0,t.createSyncHeaders)(w);let N;try{N=await this.userDataSyncStoreService.manifest(null,O)}catch(H){const z=t.UserDataSyncError.toUserDataSyncError(H);throw y(z,w,this.userDataSyncStoreManagementService,this.telemetryService),z}await this.resetLocal();const F=this,M=new _.CancellationTokenSource;return{id:w,async merge(){return F.sync(N,!0,w,M.token)},async apply(){try{try{await F.applyManualSync(N,w,M.token)}catch(H){if(t.UserDataSyncError.toUserDataSyncError(H).code===t.UserDataSyncErrorCode.MethodNotFound)F.logService.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.logService.info("Applying manual sync again..."),await F.applyManualSync(N,w,M.token);else throw H}}catch(H){throw F.logService.error(H),H}F.logService.info(`Sync done. Took ${new Date().getTime()-b}ms`),F.updateLastSyncTime()},async stop(){M.cancel(),await F.stop(),await F.resetLocal()}}}async sync(b,w,O,N){this._syncErrors=[];try{this.status!==t.SyncStatus.HasConflicts&&this.setStatus(t.SyncStatus.Syncing);const F=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(F,b,w,O,N));const M=F.enabled.find(H=>H.resource===t.SyncResource.Profiles);if(M){const H=await M.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(H,b,w,O,N)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.setStatus(t.SyncStatus.Idle),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(b,w,O,N,F){for(const M of b){if(F.isCancellationRequested)return;const H=this.userDataProfilesService.profiles.find(J=>J.id===M.id);if(!H){this.logService.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",M.name);const z=this.getOrCreateActiveProfileSynchronizer(H,M);this._syncErrors.push(...await this.syncProfile(z,w,O,N,F))}for(const[M,H]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(z=>z.id===H[0].profile.id)||(await H[0].resetLocal(),H[1].dispose(),this.activeProfileSynchronizers.delete(M))}async applyManualSync(b,w,O){const N=this.getActiveProfileSynchronizers();for(const J of N){if(O.isCancellationRequested)return;await J.apply(w,O)}const F=N.find(J=>J.profile.isDefault);if(!F)return;const M=F.enabled.find(J=>J.resource===t.SyncResource.Profiles);if(!M)return;const z=(await M.getRemoteSyncedProfiles(b?.latest??null)||[]).filter(J=>N.every(V=>V.profile.id!==J.id));z.length&&await this.syncRemoteProfiles(z,b,!1,w,O)}async syncProfile(b,w,O,N,F){return(await b.sync(w,O,N,F)).map(([H,z])=>({profile:b.profile,syncResource:H,error:z}))}async stop(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(b=>b.stop()))}async resolveContent(b){const w=await this.userDataSyncResourceProviderService.resolveContent(b);if(w)return w;for(const O of this.getActiveProfileSynchronizers())for(const N of O.enabled){const F=await N.resolveContent(b);if(F)return F}return null}async replace(b){this.checkEnablement();const w=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(b);if(!w)return;const O=await this.resolveContent(b.uri);O&&await this.performAction(w.profile,async N=>{if(w.syncResource===N.resource)return await N.replace(O),!0})}async accept(b,w,O,N){this.checkEnablement(),await this.performAction(b.profile,async F=>{if(b.syncResource===F.resource)return await F.accept(w,O),N&&await F.apply((0,E.isBoolean)(N)?!1:N.force,(0,t.createSyncHeaders)((0,R.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async w=>{if(w.resource!==t.SyncResource.GlobalState&&await w.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async w=>{if(await w.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(b){this.logService.error(b)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(s,p.StorageScope.APPLICATION);for(const[b]of this.activeProfileSynchronizers.values())try{await b.resetLocal()}catch(w){this.logService.error(w)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpStaleStorageData(){const b=this.storageService.keys(p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),w=[];for(const N of b){if(!N.endsWith(".lastSyncUserData"))continue;const F=N.split(".");F.length===3&&w.push([N,F[0]])}if(!w.length)return;const O=new T.DisposableStore;try{let N=this.activeProfileSynchronizers.get(this.userDataProfilesService.defaultProfile.id)?.[0];N||(N=O.add(this.instantiationService.createInstance(o,this.userDataProfilesService.defaultProfile,void 0)));const F=N.enabled.find(z=>z.resource===t.SyncResource.Profiles);if(!F)return;const H=(await F.getLastSyncedProfiles())?.map(z=>z.collection)??[];for(const[z,J]of w)H.includes(J)||(this.logService.info(`Removing last sync state for stale profile: ${J}`),this.storageService.remove(z,p.StorageScope.APPLICATION))}finally{O.dispose()}}async cleanUpRemoteData(){const b=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),w=b.map(M=>M.collection),O=await this.userDataSyncStoreService.getAllCollections(),N=O.filter(M=>!w.includes(M));N.length&&(this.logService.info(`Deleting ${N.length} redundant collections on server`),await Promise.allSettled(N.map(M=>this.userDataSyncStoreService.deleteCollection(M))),this.logService.info("Deleted redundant collections on server"));const F=b.filter(M=>O.includes(M.collection));if(F.length!==b.length){const M=this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(F,null),this.logService.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(b){this.checkEnablement();const w=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(b,w)}async extractActivityData(b,w){const O=(await this.fileService.readFile(b)).value.toString(),N=JSON.parse(O);if(N.resources)for(const F in N.resources)for(const M of N.resources[F])await this.userDataSyncLocalStoreService.writeResource(F,M.content,new Date(M.created*1e3),void 0,w);if(N.collections)for(const F in N.collections)for(const M in N.collections[F].resources)for(const H of N.collections[F].resources?.[M]??[])await this.userDataSyncLocalStoreService.writeResource(M,H.content,new Date(H.created*1e3),F,w)}async performAction(b,w){const O=new T.DisposableStore;try{const N=this.activeProfileSynchronizers.get(b.id);if(N){const J=await this.performActionWithProfileSynchronizer(N[0],w,O);return(0,E.isUndefined)(J)?null:J}if(b.isDefault){const J=O.add(this.instantiationService.createInstance(o,b,void 0)),V=await this.performActionWithProfileSynchronizer(J,w,O);return(0,E.isUndefined)(V)?null:V}if(this.userDataProfilesService.isEnabled())return null;const F=O.add(this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,b,void 0)),M=await this.userDataSyncStoreService.manifest(null),z=(await F.getRemoteSyncedProfiles(M?.latest??null)||[]).find(J=>J.id===b.id);if(z){const J=O.add(this.instantiationService.createInstance(o,b,z.collection)),V=await this.performActionWithProfileSynchronizer(J,w,O);return(0,E.isUndefined)(V)?null:V}return null}finally{O.dispose()}}async performActionWithProfileSynchronizer(b,w,O){const N=[...b.enabled,...b.disabled.reduce((F,M)=>(M!==t.SyncResource.WorkspaceState&&F.push(O.add(b.createSynchronizer(M))),F),[])];for(const F of N){const M=await w(F);if(!(0,E.isUndefined)(M))return M}}setStatus(b){const w=this._status;this._status!==b&&(this._status=b,this._onDidChangeStatus.fire(b),w===t.SyncStatus.HasConflicts&&this.updateLastSyncTime())}updateConflicts(){const b=this.getActiveProfileSynchronizers().map(w=>w.conflicts).flat();(0,P.equals)(this._conflicts,b,(w,O)=>w.profile.id===O.profile.id&&w.syncResource===O.syncResource&&(0,P.equals)(w.conflicts,O.conflicts,(N,F)=>(0,D.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=b,this._onDidChangeConflicts.fire(b))}updateLastSyncTime(){this.status===t.SyncStatus.Idle&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(s,this._lastSyncTime,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(b,w){let O=this.activeProfileSynchronizers.get(b.id);if(O&&O[0].collection!==w?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),O[1].dispose(),O=void 0,this.activeProfileSynchronizers.delete(b.id)),!O){const N=new T.DisposableStore,F=N.add(this.instantiationService.createInstance(o,b,w?.collection));N.add(F.onDidChangeStatus(M=>this.setStatus(M))),N.add(F.onDidChangeConflicts(M=>this.updateConflicts())),N.add(F.onDidChangeLocal(M=>this._onDidChangeLocal.fire(M))),this.activeProfileSynchronizers.set(b.id,O=[F,N])}return O[0]}getActiveProfileSynchronizers(){const b=[];for(const[w]of this.activeProfileSynchronizers.values())b.push(w);return b}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,b])=>b.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=r,e.UserDataSyncService=r=we([Q(0,f.IFileService),Q(1,t.IUserDataSyncStoreService),Q(2,t.IUserDataSyncStoreManagementService),Q(3,l.IInstantiationService),Q(4,t.IUserDataSyncLogService),Q(5,I.ITelemetryService),Q(6,p.IStorageService),Q(7,t.IUserDataSyncEnablementService),Q(8,g.IUserDataProfilesService),Q(9,t.IUserDataSyncResourceProviderService),Q(10,t.IUserDataSyncLocalStoreService)],r);let o=class extends T.Disposable{get enabled(){return this._enabled.sort((b,w)=>b[1]-w[1]).map(([b])=>b)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(b=>!this.userDataSyncEnablementService.isResourceEnabled(b))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(b,w,O,N,F,M,H,z,J,V){super(),this.profile=b,this.collection=w,this.userDataSyncEnablementService=O,this.instantiationService=N,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=M,this.telemetryService=H,this.logService=z,this.userDataProfilesService=J,this.configurationService=V,this._enabled=[],this._status=t.SyncStatus.Idle,this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(O.onDidChangeResourceEnablement(([te,$])=>this.onDidChangeResourceEnablement(te,$))),this._register((0,T.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,te])=>te.dispose())));for(const te of t.ALL_SYNC_RESOURCES)O.isResourceEnabled(te)&&this.registerSynchronizer(te)}onDidChangeResourceEnablement(b,w){w?this.registerSynchronizer(b):this.deRegisterSynchronizer(b)}registerSynchronizer(b){if(this._enabled.some(([F])=>F.resource===b))return;if(b===t.SyncResource.Extensions&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(b===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||b===t.SyncResource.WorkspaceState)return;if(b!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[b]){this.logService.debug(`Skipping syncing ${b} in ${this.profile.name} because it is already synced by default profile`);return}const w=new T.DisposableStore,O=w.add(this.createSynchronizer(b));w.add(O.onDidChangeStatus(()=>this.updateStatus())),w.add(O.onDidChangeConflicts(()=>this.updateConflicts())),w.add(O.onDidChangeLocal(()=>this._onDidChangeLocal.fire(b)));const N=this.getOrder(b);this._enabled.push([O,N,w])}deRegisterSynchronizer(b){const w=this._enabled.findIndex(([O])=>O.resource===b);if(w!==-1){const[[O,,N]]=this._enabled.splice(w,1);N.dispose(),this.updateStatus(),O.stop().then(null,F=>this.logService.error(F))}}createSynchronizer(b){switch(b){case t.SyncResource.Settings:return this.instantiationService.createInstance(c.SettingsSynchroniser,this.profile,this.collection);case t.SyncResource.Keybindings:return this.instantiationService.createInstance(S.KeybindingsSynchroniser,this.profile,this.collection);case t.SyncResource.Snippets:return this.instantiationService.createInstance(u.SnippetsSynchroniser,this.profile,this.collection);case t.SyncResource.Tasks:return this.instantiationService.createInstance(i.TasksSynchroniser,this.profile,this.collection);case t.SyncResource.GlobalState:return this.instantiationService.createInstance(C.GlobalStateSynchroniser,this.profile,this.collection);case t.SyncResource.Extensions:return this.instantiationService.createInstance(v.ExtensionsSynchroniser,this.profile,this.collection);case t.SyncResource.Profiles:return this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(b,w,O,N){if(N.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const M=[],H=(0,t.createSyncHeaders)(O),z=(this.collection?b?.collections?.[this.collection]?.latest:b?.latest)??null,J=w?await this.getUserDataSyncConfiguration(z):{};for(const V of F){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(V.resource))return[];try{if(w){const te=await V.preview(z,J,H);if(te)for(const $ of te.resourcePreviews)($.localChange!==t.Change.None||$.remoteChange!==t.Change.None)&&$.mergeState===t.MergeState.Preview&&await V.merge($.previewResource)}else await V.sync(z,H)}catch(te){const $=t.UserDataSyncError.toUserDataSyncError(te);if(y($,O,this.userDataSyncStoreManagementService,this.telemetryService),h(te))throw $;this.logService.error(te),this.logService.error(`${V.resource}: ${(0,L.toErrorMessage)(te)}`),M.push([V.resource,$])}}return M}finally{this.updateStatus()}}async apply(b,w){const O=(0,t.createSyncHeaders)(b);for(const N of this.enabled){if(w.isCancellationRequested)return;try{await N.apply(!1,O)}catch(F){const M=t.UserDataSyncError.toUserDataSyncError(F);if(y(M,b,this.userDataSyncStoreManagementService,this.telemetryService),h(F))throw M;this.logService.error(F),this.logService.error(`${N.resource}: ${(0,L.toErrorMessage)(F)}`)}}}async stop(){for(const b of this.enabled)try{b.status!==t.SyncStatus.Idle&&await b.stop()}catch(w){this.logService.error(w)}}async resetLocal(){for(const b of this.enabled)try{await b.resetLocal()}catch(w){this.logService.error(`${b.resource}: ${(0,L.toErrorMessage)(w)}`),this.logService.error(w)}}async getUserDataSyncConfiguration(b){if(!this.profile.isDefault)return{};const w=this.configurationService.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),O=this.enabled.find(N=>N instanceof c.SettingsSynchroniser);if(O){const N=await O.getRemoteUserDataSyncConfiguration(b);return{...w,...N}}return w}setStatus(b){this._status!==b&&(this._status=b,this._onDidChangeStatus.fire(b))}updateStatus(){return this.updateConflicts(),this.enabled.some(b=>b.status===t.SyncStatus.HasConflicts)?this.setStatus(t.SyncStatus.HasConflicts):this.enabled.some(b=>b.status===t.SyncStatus.Syncing)?this.setStatus(t.SyncStatus.Syncing):this.setStatus(t.SyncStatus.Idle)}updateConflicts(){const b=this.enabled.filter(w=>w.status===t.SyncStatus.HasConflicts).filter(w=>w.conflicts.conflicts.length>0).map(w=>w.conflicts);(0,P.equals)(this._conflicts,b,(w,O)=>w.syncResource===O.syncResource&&(0,P.equals)(w.conflicts,O.conflicts,(N,F)=>(0,D.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=b,this._onDidChangeConflicts.fire(b))}getOrder(b){switch(b){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};o=we([Q(2,t.IUserDataSyncEnablementService),Q(3,l.IInstantiationService),Q(4,d.IExtensionGalleryService),Q(5,t.IUserDataSyncStoreManagementService),Q(6,I.ITelemetryService),Q(7,t.IUserDataSyncLogService),Q(8,g.IUserDataProfilesService),Q(9,m.IConfigurationService)],o);function h(A){if(A instanceof t.UserDataSyncError)switch(A.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function y(A,b,w,O){O.publicLog2("sync/error",{code:A.code,serverCode:A instanceof t.UserDataSyncStoreError?String(A.serverCode):void 0,url:A instanceof t.UserDataSyncStoreError?A.url:void 0,resource:A.resource,executionId:b,service:w.userDataSyncStore.url.toString()})}}),define(ue[233],he([0,1,3,2,9,19,24]),function(ae,e,P,a,_,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncServiceChannelClient=e.UserDataSyncServiceChannel=void 0;function T(d,f){return{...d,profile:(0,L.reviveProfile)(d.profile,f.profilesHome.scheme)}}function D(d){return{created:d.created,uri:_.URI.revive(d.uri)}}class E{constructor(f,l,p){this.service=f,this.userDataProfilesService=l,this.logService=p,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new P.Emitter}listen(f,l){switch(l){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(f,l,p){try{return await this._call(f,l,p)}catch(I){throw this.logService.error(I),I}}async _call(f,l,p){switch(l){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(_.URI.revive(p[0]));case"accept":return this.service.accept(T(p[0],this.userDataProfilesService),_.URI.revive(p[1]),p[2],p[3]);case"replace":return this.service.replace(D(p[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(_.URI.revive(p[0]));case"extractActivityData":return this.service.extractActivityData(_.URI.revive(p[0]),_.URI.revive(p[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(l.startsWith("manualSync/")){const I=l.substring(11),g=p[0],v=this.getManualSyncTask(g);switch(p=p.slice(1),I){case"merge":return v.merge();case"apply":return v.apply().then(()=>this.manualSyncTasks.delete(this.createKey(v.id)));case"stop":return v.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(v.id)))}}throw new Error("Invalid call")}getManualSyncTask(f){const l=this.manualSyncTasks.get(this.createKey(f));if(!l)throw new Error(`Manual sync taks not found: ${f}`);return l}async createManualSyncTask(){const f=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(f.id),f),f.id}createKey(f){return`manualSyncTask-${f}`}}e.UserDataSyncServiceChannel=E;let R=class extends a.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(f,l){super(),this.userDataProfilesService=l,this._status=k.SyncStatus.Uninitialized,this._onDidChangeStatus=this._register(new P.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new P.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new P.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new P.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(p,I,g){return f.call(p,I,g).then(null,v=>{throw k.UserDataSyncError.toUserDataSyncError(v)})},listen(p,I){return f.listen(p,I)}},this.channel.call("_getInitialData").then(([p,I,g])=>{this.updateStatus(p),this.updateConflicts(I),g&&this.updateLastSyncTime(g),this._register(this.channel.listen("onDidChangeStatus")(v=>this.updateStatus(v))),this._register(this.channel.listen("onDidChangeLastSyncTime")(v=>this.updateLastSyncTime(v)))}),this._register(this.channel.listen("onDidChangeConflicts")(p=>this.updateConflicts(p))),this._register(this.channel.listen("onSyncErrors")(p=>this._onSyncErrors.fire(p.map(I=>({...I,error:k.UserDataSyncError.toUserDataSyncError(I.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.channel.call("createManualSyncTask"),l=this;return new m(f,{async call(I,g,v){return l.channel.call(`manualSync/${I}`,[f,...Array.isArray(g)?g:[g]],v)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(f,l,p,I){return this.channel.call("accept",[f,l,p,I])}resolveContent(f){return this.channel.call("resolveContent",[f])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(f){return this.channel.call("replace",[f])}saveRemoteActivityData(f){return this.channel.call("getRemoteActivityData",[f])}extractActivityData(f,l){return this.channel.call("extractActivityData",[f,l])}async updateStatus(f){this._status=f,this._onDidChangeStatus.fire(f)}async updateConflicts(f){this._conflicts=f.map(l=>({syncResource:l.syncResource,profile:(0,L.reviveProfile)(l.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:l.conflicts.map(p=>({...p,baseResource:_.URI.revive(p.baseResource),localResource:_.URI.revive(p.localResource),remoteResource:_.URI.revive(p.remoteResource),previewResource:_.URI.revive(p.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(f){this._lastSyncTime!==f&&(this._lastSyncTime=f,this._onDidChangeLastSyncTime.fire(f))}};e.UserDataSyncServiceChannelClient=R,e.UserDataSyncServiceChannelClient=R=we([Q(1,L.IUserDataProfilesService)],R);class m extends a.Disposable{constructor(f,l){super(),this.id=f,this.channel=l}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose"),super.dispose()}}}),define(ue[126],he([0,1,6,25,8,3,2,134,5,20,12,9,32,21,15,7,23,61,49,16,24]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="configurationSync.store",u="sync.previous.store",i="sync.donot-make-requests-until",n="sync.user-session-id",t="sync.machine-session-id",s=100,r=1e3*60*5;let o=class extends k.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(S.SYNC_SERVICE_URL_TYPE,C.StorageScope.APPLICATION)}set userDataSyncStoreType(O){this.storageService.store(S.SYNC_SERVICE_URL_TYPE,O,C.StorageScope.APPLICATION,D.isWeb?C.StorageTarget.USER:C.StorageTarget.MACHINE)}constructor(O,N,F){super(),this.productService=O,this.configurationService=N,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const M=this._register(new k.DisposableStore);this._register(L.Event.filter(F.onDidChangeValue(C.StorageScope.APPLICATION,S.SYNC_SERVICE_URL_TYPE,M),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,M)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O){if(O&&(O=D.isWeb&&O.web?{...O,...O.web}:O,(0,R.isString)(O.url)&&(0,R.isObject)(O.authenticationProviders)&&Object.keys(O.authenticationProviders).every(N=>Array.isArray(O.authenticationProviders[N].scopes)))){const N=O,F=!!N.canSwitch,M=N.url===N.insidersUrl?"insiders":"stable",H=(F?this.userDataSyncStoreType:void 0)||M,z=H==="insiders"?N.insidersUrl:H==="stable"?N.stableUrl:N.url;return{url:m.URI.parse(z),type:H,defaultType:M,defaultUrl:m.URI.parse(N.url),stableUrl:m.URI.parse(N.stableUrl),insidersUrl:m.URI.parse(N.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(N.authenticationProviders).reduce((J,V)=>(J.push({id:V,scopes:N.authenticationProviders[V].scopes}),J),[])}}}};e.AbstractUserDataSyncStoreManagementService=o,e.AbstractUserDataSyncStoreManagementService=o=we([Q(0,I.IProductService),Q(1,f.IConfigurationService),Q(2,C.IStorageService)],o);let h=class extends o{constructor(O,N,F){super(O,N,F);const M=this.storageService.get(u,C.StorageScope.APPLICATION);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const H=this.productService[c];H?this.storageService.store(u,JSON.stringify(H),C.StorageScope.APPLICATION,C.StorageTarget.MACHINE):this.storageService.remove(u,C.StorageScope.APPLICATION)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=h,e.UserDataSyncStoreManagementService=h=we([Q(0,I.IProductService),Q(1,f.IConfigurationService),Q(2,C.IStorageService)],h);let y=class extends k.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(O,N,F,M,H,z,J){super(),this.requestService=F,this.logService=M,this.storageService=J,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,v.getServiceMachineId)(H,z,J).then(V=>{const te={"X-Client-Name":`${N.applicationName}${D.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(te["X-Client-Commit"]=N.commit),te}),this.session=new b(s,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(O,N){this.authToken={token:O,type:N}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(i,C.StorageScope.APPLICATION);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),C.StorageScope.APPLICATION,C.StorageTarget.MACHINE),this.resetDonotMakeRequestsUntilPromise=(0,P.createCancelablePromise)(N=>(0,P.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(i,C.StorageScope.APPLICATION),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},O["Content-Type"]="application/json";const F=await this.request(N,{type:"GET",headers:O},[],a.CancellationToken.None);return(await(0,g.asJson)(F))?.map(({id:M})=>M)||[]}async createCollection(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},O["Content-Type"]=T.Mimes.text;const F=await this.request(N,{type:"POST",headers:O},[],a.CancellationToken.None),M=await(0,g.asTextOrError)(F);if(!M)throw new S.UserDataSyncStoreError("Server did not return the collection id",N,S.UserDataSyncErrorCode.NoCollection,F.res.statusCode,F.res.headers[S.HEADER_OPERATION_ID]);return M}async deleteCollection(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=O?(0,E.joinPath)(this.userDataSyncStoreUrl,"collection",O).toString():(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},await this.request(F,{type:"DELETE",headers:N},[],a.CancellationToken.None)}async getAllResourceRefs(O,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=this.getResourceUrl(this.userDataSyncStoreUrl,N,O),M={},H=await this.request(F.toString(),{type:"GET",headers:M},[],a.CancellationToken.None);return(await(0,g.asJson)(H)||[]).map(({url:J,created:V})=>({ref:(0,E.relativePath)(F,F.with({path:J})),created:V*1e3}))}async resolveResourceContent(O,N,F,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,O),N).toString();M={...M},M["Cache-Control"]="no-cache";const z=await this.request(H,{type:"GET",headers:M},[],a.CancellationToken.None);return await(0,g.asTextOrError)(z)}async deleteResource(O,N,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=N!==null?(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,O),N).toString():this.getResourceUrl(this.userDataSyncStoreUrl,F,O).toString(),H={};await this.request(M,{type:"DELETE",headers:H},[],a.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":T.Mimes.text};await this.request(O,{type:"DELETE",headers:N},[],a.CancellationToken.None)}async readResource(O,N,F,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,O),"latest").toString();M={...M},M["Cache-Control"]="no-cache",N&&(M["If-None-Match"]=N.ref);const z=await this.request(H,{type:"GET",headers:M},[304],a.CancellationToken.None);let J=null;if(z.res.statusCode===304&&(J=N),J===null){const V=z.res.headers.etag;if(!V)throw new S.UserDataSyncStoreError("Server did not return the ref",H,S.UserDataSyncErrorCode.NoRef,z.res.statusCode,z.res.headers[S.HEADER_OPERATION_ID]);const te=await(0,g.asTextOrError)(z);if(!te&&z.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",H,S.UserDataSyncErrorCode.EmptyResponse,z.res.statusCode,z.res.headers[S.HEADER_OPERATION_ID]);J={ref:V,content:te}}return J}async writeResource(O,N,F,M,H={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=this.getResourceUrl(this.userDataSyncStoreUrl,M,O).toString();H={...H},H["Content-Type"]=T.Mimes.text,F&&(H["If-Match"]=F);const J=await this.request(z,{type:"POST",data:N,headers:H},[],a.CancellationToken.None),V=J.res.headers.etag;if(!V)throw new S.UserDataSyncStoreError("Server did not return the ref",z,S.UserDataSyncErrorCode.NoRef,J.res.statusCode,J.res.headers[S.HEADER_OPERATION_ID]);return V}async manifest(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",O&&(N["If-None-Match"]=O.ref);const M=await this.request(F,{type:"GET",headers:N},[304],a.CancellationToken.None);let H=null;if(M.res.statusCode===304&&(H=O),!H){const J=M.res.headers.etag;if(!J)throw new S.UserDataSyncStoreError("Server did not return the ref",F,S.UserDataSyncErrorCode.NoRef,M.res.statusCode,M.res.headers[S.HEADER_OPERATION_ID]);const V=await(0,g.asTextOrError)(M);if(!V&&M.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",F,S.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[S.HEADER_OPERATION_ID]);V&&(H={...JSON.parse(V),ref:J})}const z=this.storageService.get(n,C.StorageScope.APPLICATION);return z&&H&&z!==H.session&&this.clearSession(),H===null&&z&&this.clearSession(),H&&this.storageService.store(n,H.session,C.StorageScope.APPLICATION,C.StorageTarget.MACHINE),H}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"download").toString(),N={},F=await this.request(O,{type:"GET",headers:N},[],a.CancellationToken.None);if(!(0,g.isSuccess)(F))throw new S.UserDataSyncStoreError("Server returned "+F.res.statusCode,O,S.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[S.HEADER_OPERATION_ID]);if((0,g.hasNoContent)(F))throw new S.UserDataSyncStoreError("Empty response",O,S.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[S.HEADER_OPERATION_ID]);return F.stream}getResourceUrl(O,N,F){return N?(0,E.joinPath)(O,"collection",N,"resource",F):(0,E.joinPath)(O,"resource",F)}clearSession(){this.storageService.remove(n,C.StorageScope.APPLICATION),this.storageService.remove(t,C.StorageScope.APPLICATION)}async request(O,N,F,M){if(!this.authToken)throw new S.UserDataSyncStoreError("No Auth Token Available",O,S.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,S.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const H=await this.commonHeadersPromise;N.headers={...N.headers||{},...H,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:O,type:N.type,headers:{...N.headers,authorization:void 0}});let z;try{z=await this.session.request(O,N,M)}catch(q){if(!(q instanceof S.UserDataSyncStoreError)){let Z=S.UserDataSyncErrorCode.RequestFailed;const ne=(0,_.getErrorMessage)(q).toLowerCase();ne.includes("xhr timeout")?Z=S.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?Z=S.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?Z=S.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?Z=S.UserDataSyncErrorCode.RequestHeadersNotObject:(0,_.isCancellationError)(q)&&(Z=S.UserDataSyncErrorCode.RequestCanceled),q=new S.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,Z,void 0,void 0)}throw this.logService.info("Request failed",O),q}const J=z.res.headers[S.HEADER_OPERATION_ID],V={url:O,status:z.res.statusCode,"execution-id":N.headers[S.HEADER_EXECUTION_ID],"operation-id":J},te=(0,g.isSuccess)(z)||z.res.statusCode&&F.includes(z.res.statusCode);let $="";if(te?this.logService.trace("Request succeeded",V):($=await(0,g.asText)(z)||"",this.logService.info("Request failed",V,$)),z.res.statusCode===401||z.res.statusCode===403){if(this.authToken=void 0,z.res.statusCode===401)throw this._onTokenFailed.fire(S.UserDataSyncErrorCode.Unauthorized),new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Unauthorized (401).`,O,S.UserDataSyncErrorCode.Unauthorized,z.res.statusCode,J);if(z.res.statusCode===403)throw this._onTokenFailed.fire(S.UserDataSyncErrorCode.Forbidden),new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because the access is forbidden (403).`,O,S.UserDataSyncErrorCode.Forbidden,z.res.statusCode,J)}if(this._onTokenSucceed.fire(),z.res.statusCode===404)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not found (404).`,O,S.UserDataSyncErrorCode.NotFound,z.res.statusCode,J);if(z.res.statusCode===405)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested endpoint is not found (405). ${$}`,O,S.UserDataSyncErrorCode.MethodNotFound,z.res.statusCode,J);if(z.res.statusCode===409)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,S.UserDataSyncErrorCode.Conflict,z.res.statusCode,J);if(z.res.statusCode===410)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not longer available (410).`,O,S.UserDataSyncErrorCode.Gone,z.res.statusCode,J);if(z.res.statusCode===412)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,S.UserDataSyncErrorCode.PreconditionFailed,z.res.statusCode,J);if(z.res.statusCode===413)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too large payload (413).`,O,S.UserDataSyncErrorCode.TooLarge,z.res.statusCode,J);if(z.res.statusCode===426)throw new S.UserDataSyncStoreError(`${N.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,S.UserDataSyncErrorCode.UpgradeRequired,z.res.statusCode,J);if(z.res.statusCode===429){const q=z.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,S.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,z.res.statusCode,J)):new S.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,S.UserDataSyncErrorCode.TooManyRequests,z.res.statusCode,J)}if(!te)throw new S.UserDataSyncStoreError("Server returned "+z.res.statusCode,O,S.UserDataSyncErrorCode.Unknown,z.res.statusCode,J);return z}addSessionHeaders(O){let N=this.storageService.get(t,C.StorageScope.APPLICATION);N===void 0&&(N=(0,d.generateUuid)(),this.storageService.store(t,N,C.StorageScope.APPLICATION,C.StorageTarget.MACHINE)),O["X-Machine-Session-Id"]=N;const F=this.storageService.get(n,C.StorageScope.APPLICATION);F!==void 0&&(O["X-User-Session-Id"]=F)}};e.UserDataSyncStoreClient=y,e.UserDataSyncStoreClient=y=we([Q(1,I.IProductService),Q(2,g.IRequestService),Q(3,S.IUserDataSyncLogService),Q(4,l.IEnvironmentService),Q(5,p.IFileService),Q(6,C.IStorageService)],y);let A=class extends y{constructor(O,N,F,M,H,z,J){super(O.userDataSyncStore?.url,N,F,M,H,z,J),this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=A,e.UserDataSyncStoreService=A=we([Q(0,S.IUserDataSyncStoreManagementService),Q(1,I.IProductService),Q(2,g.IRequestService),Q(3,S.IUserDataSyncLogService),Q(4,l.IEnvironmentService),Q(5,p.IFileService),Q(6,C.IStorageService)],A);class b{constructor(O,N,F,M){this.limit=O,this.interval=N,this.requestService=F,this.logService=M,this.requests=[],this.startTime=void 0}request(O,N,F){if(this.isExpired()&&this.reset(),N.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new S.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,S.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(N,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=b}),define(ue[234],he([0,1,3,2,9,21,23,16,126]),function(ae,e,P,a,_,L,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannelClient=e.UserDataSyncAccountServiceChannel=void 0;class E{constructor(l){this.service=l}listen(l,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${p}`)}call(l,p,I){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(I)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class R extends a.Disposable{get account(){return this._account}get onTokenFailed(){return this.channel.listen("onTokenFailed")}constructor(l){super(),this.channel=l,this._onDidChangeAccount=this._register(new P.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this.channel.call("_getInitialData").then(p=>{this._account=p,this._register(this.channel.listen("onDidChangeAccount")(I=>{this._account=I,this._onDidChangeAccount.fire(I)}))})}updateAccount(l){return this.channel.call("updateAccount",l)}}e.UserDataSyncAccountServiceChannelClient=R;class m{constructor(l){this.service=l}listen(l,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${p}`)}call(l,p,I){switch(p){case"switch":return this.service.switch(I[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=m;let d=class extends D.AbstractUserDataSyncStoreManagementService{constructor(l,p,I,g){super(p,I,g),this.channel=l,this._register(this.channel.listen("onDidChangeUserDataSyncStore")(()=>this.updateUserDataSyncStore()))}async switch(l){return this.channel.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(l)}revive(l){return{url:_.URI.revive(l.url),type:l.type,defaultUrl:_.URI.revive(l.defaultUrl),insidersUrl:_.URI.revive(l.insidersUrl),stableUrl:_.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.UserDataSyncStoreManagementServiceChannelClient=d,e.UserDataSyncStoreManagementServiceChannelClient=d=we([Q(1,k.IProductService),Q(2,L.IConfigurationService),Q(3,T.IStorageService)],d)}),define(ue[235],he([0,1,3,57,23,16,18,230,24,82,86]),function(ae,e,P,a,_,L,k,T,D,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let m=class extends T.UserDataAutoSyncService{constructor(f,l,p,I,g,v,C,S,c,u,i){super(f,l,p,I,g,C,S,c,u,i),this._register(P.Event.debounce(P.Event.any(P.Event.map(v.onDidFocusMainWindow,()=>"windowFocus"),P.Event.map(v.onDidOpenMainWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=m,e.UserDataAutoSyncService=m=we([Q(0,_.IProductService),Q(1,D.IUserDataSyncStoreManagementService),Q(2,D.IUserDataSyncStoreService),Q(3,D.IUserDataSyncEnablementService),Q(4,D.IUserDataSyncService),Q(5,a.INativeHostService),Q(6,D.IUserDataSyncLogService),Q(7,E.IUserDataSyncAccountService),Q(8,k.ITelemetryService),Q(9,R.IUserDataSyncMachinesService),Q(10,L.IStorageService)],m)}),define(ue[236],he([0,1,75,22,5,20]),function(ae,e,P,a,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=k,e.getSingleFolderWorkspaceIdentifier=T,e.createEmptyWorkspaceIdentifier=D,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function k(E){function R(){let m=E.scheme===a.Schemas.file?(0,L.originalFSPath)(E):E.toString();return _.isLinux||(m=m.toLowerCase()),(0,P.createHash)("md5").update(m).digest("hex")}return{id:R(),configPath:E}}function T(E,R){function m(){if(E.scheme!==a.Schemas.file)return(0,P.createHash)("md5").update(E.toString()).digest("hex");if(!R)return;let f;return _.isLinux?f=R.ino:_.isMacintosh?f=R.birthtime.getTime():_.isWindows&&(typeof R.birthtimeMs=="number"?f=Math.floor(R.birthtimeMs):f=R.birthtime.getTime()),(0,P.createHash)("md5").update(E.fsPath).update(f?String(f):"").digest("hex")}const d=m();if(typeof d=="string")return{id:d,uri:E}}function D(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ue[237],he([0,1,6,8,2,13,30,15,10,79,115,236,57,56,22]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let p=class extends _.Disposable{constructor(g,v,C,S){super(),this.environmentService=g,this.logService=v,this.nativeHostService=C,this.mainProcessService=S,this._register(new P.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const g=this.environmentService.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,v=await k.Promises.readdir(g),C=new E.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(v.map(async S=>{const c=(0,L.join)(g,S);S.length===m.NON_EMPTY_WORKSPACE_ID_LENGTH||S===R.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===S)||await C.isUsed(c)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S} as it seems to be an unused empty workspace.`),await k.Promises.rm(c))}))}catch(g){(0,a.onUnexpectedError)(g)}}};e.UnusedWorkspaceStorageDataCleaner=p,e.UnusedWorkspaceStorageDataCleaner=p=we([Q(0,T.INativeEnvironmentService),Q(1,D.ILogService),Q(2,d.INativeHostService),Q(3,f.IMainProcessService)],p)}),define(ue[127],he([0,1,75,67,38,245,14,8,3,2,13,5,32,42,69]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=t,e.createStaticIPCHandle=s,e.serve=h,e.connect=y;const p=3e4;class I{traceSocketEvent(b,w){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,w)}constructor(b,w=""){this._canWrite=!0,this.debugLabel=w,this.socket=b,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=N=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,T.onUnexpectedError)(N)}},this.socket.on("error",this._errorListener);let O;this._closeListener=N=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:N}),this._canWrite=!1,O&&clearTimeout(O)},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1,O=setTimeout(()=>b.destroy(),p)},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(b){const w=O=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,O),b(k.VSBuffer.wrap(O))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(b){const w=O=>{b({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:O,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(b){const w=()=>{b()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(b){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,b),this.socket.write(b.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((b,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),b();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),b()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=I;var g;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var v;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(v||(v={}));class C extends E.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,w){this.socket.traceSocketEvent(b,w)}constructor(b,w,O,N){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:v.PeekHeader,readLen:g.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:O?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new S(this,w,O,N,this._onData,(F,M)=>this._write(F,M))),this._register(this._flowManager.onError(F=>{console.error(F),(0,T.onUnexpectedError)(F),this._onClose.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:F})})),this._incomingData=new l.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(async F=>{this._flowManager.isProcessingReadQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(F)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let w=0;for(;w<b.byteLength;)this._flowManager.writeMessage(b.slice(w,Math.min(w+g.MaxWebSocketMessageLength,b.byteLength)),{compressed:!0,opcode:2}),w+=g.MaxWebSocketMessageLength}_write(b,{compressed:w,opcode:O}){if(this._isEnded)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,b);let N=g.MinHeaderByteSize;b.byteLength<126?N+=0:b.byteLength<2**16?N+=2:N+=8;const F=k.VSBuffer.alloc(N),M=w?64:0,H=O&15;if(F.writeUInt8(128|M|H,0),b.byteLength<126)F.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){F.writeUInt8(126,1);let z=1;F.writeUInt8(b.byteLength>>>8&255,++z),F.writeUInt8(b.byteLength>>>0&255,++z)}else{F.writeUInt8(127,1);let z=1;F.writeUInt8(0,++z),F.writeUInt8(0,++z),F.writeUInt8(0,++z),F.writeUInt8(0,++z),F.writeUInt8(b.byteLength>>>24&255,++z),F.writeUInt8(b.byteLength>>>16&255,++z),F.writeUInt8(b.byteLength>>>8&255,++z),F.writeUInt8(b.byteLength>>>0&255,++z)}this.socket.write(k.VSBuffer.concat([F,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===v.PeekHeader){const w=this._incomingData.peek(this._state.readLen),O=w.readUInt8(0),N=(O&128)>>>7,F=(O&64)>>>6,M=O&15,H=w.readUInt8(1),z=(H&128)>>>7,J=H&127;this._state.state=v.ReadHeader,this._state.readLen=g.MinHeaderByteSize+(z?4:0)+(J===126?2:0)+(J===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!F),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this._state.opcode=M,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===v.ReadHeader){const w=this._incomingData.read(this._state.readLen),O=w.readUInt8(1),N=(O&128)>>>7;let F=O&127,M=1;F===126?F=w.readUInt8(++M)*2**8+w.readUInt8(++M):F===127&&(F=w.readUInt8(++M)*0+w.readUInt8(++M)*0+w.readUInt8(++M)*0+w.readUInt8(++M)*0+w.readUInt8(++M)*2**24+w.readUInt8(++M)*2**16+w.readUInt8(++M)*2**8+w.readUInt8(++M));let H=0;N&&(H=w.readUInt8(++M)*2**24+w.readUInt8(++M)*2**16+w.readUInt8(++M)*2**8+w.readUInt8(++M)),this._state.state=v.ReadBody,this._state.readLen=F,this._state.mask=H,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===v.ReadBody){const w=this._incomingData.read(this._state.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,w),i(w,this._state.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,w),this._state.state=v.PeekHeader,this._state.readLen=g.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(w,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(w,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=C;class S extends E.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(b,w,O,N,F,M){super(),this._tracer=b,this._onData=F,this._writeFn=M,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new D.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,w?(this._zlibInflateStream=this._register(new c(this._tracer,N,O,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(H=>this._onError.fire(H))),this._register(this._zlibDeflateStream.onError(H=>this._onError.fire(H)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(b,w){this._writeQueue.push({data:b,options:w}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:b,options:w}=this._writeQueue.shift();if(this._zlibDeflateStream&&w.compressed){const O=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(O,w)}else this._writeFn(b,{...w,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,w){return new Promise((O,N)=>{b.write(w),b.flush(F=>O(F))})}acceptFrame(b,w,O){this._readQueue.push({data:b,isCompressed:w,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const w=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(w)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(b,w,O){return new Promise((N,F)=>{b.write(w),O&&b.write(k.VSBuffer.fromByteArray([0,0,255,255])),b.flush(M=>N(M))})}}class c extends E.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.concat(this._recordedInflateBytes):k.VSBuffer.alloc(0)}constructor(b,w,O,N){super(),this._tracer=b,this._recordInflateBytes=w,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,L.createInflateRaw)(N),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,F),this._pendingInflateData.push(k.VSBuffer.wrap(F))}),O&&(this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const w=k.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(w)})}}class u extends E.Disposable{constructor(b,w){super(),this._tracer=b,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,L.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,O),this._pendingDeflateData.push(k.VSBuffer.wrap(O))})}write(b){this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let w=k.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.byteLength-4),b(w)})}}function i(A,b){if(b===0)return;const w=A.byteLength>>>2;for(let z=0;z<w;z++){const J=A.readUInt32BE(z*4);A.writeUInt32BE(J^b,z*4)}const O=w*4,N=A.byteLength-O,F=b>>>24&255,M=b>>>16&255,H=b>>>8&255;N>=1&&A.writeUInt8(A.readUInt8(O)^F,O),N>=2&&A.writeUInt8(A.readUInt8(O+1)^M,O+1),N>=3&&A.writeUInt8(A.readUInt8(O+2)^H,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const n={[m.Platform.Linux]:107,[m.Platform.Mac]:103};function t(){const A=(0,d.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const b=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,_.tmpdir)(),w=(0,R.join)(b,`vscode-ipc-${A}.sock`);return r(w),w}function s(A,b,w){const N=(0,P.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${w}-${b}-sock`;const F=w.substr(0,4),M=b.substr(0,6);let H;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?H=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${F}-${M}.sock`):H=(0,R.join)(A,`${F}-${M}.sock`),r(H),H}function r(A){const b=n[m.platform];typeof b=="number"&&A.length>=b&&console.warn(`WARNING: IPC handle "${A}" is longer than ${b} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{static toClientConnectionEvent(b){const w=D.Event.fromNodeEventEmitter(b,"connection");return D.Event.map(w,O=>({protocol:new l.Protocol(new I(O,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(O,"close"))}))}constructor(b){super(o.toClientConnectionEvent(b)),this.server=b}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function h(A){return new Promise((b,w)=>{const O=(0,a.createServer)();O.on("error",w),O.listen(A,()=>{O.removeListener("error",w),b(new o(O))})})}function y(A,b){return new Promise((w,O)=>{const N=(0,a.createConnection)(A,()=>{N.removeListener("error",O),w(l.Client.fromSocket(new I(N,`ipc-client${b}`),b))});N.once("error",O)})}}),define(ue[238],he([0,1,67,127,185]),function(ae,e,P,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,P=De(P),e.nodeSocketFactory=new class{supports(L){return!0}connect({host:L,port:k},T,D,E){return new Promise((R,m)=>{const d=P.createConnection({host:L,port:k},()=>{d.removeListener("error",m),d.write((0,_.makeRawSocketHeaders)(T,D,E));const f=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(d.off("data",f),R(new a.NodeSocket(d,E)))};d.on("data",f)});d.setNoDelay(!0),d.once("error",m)})}}}),define(ue[239],he([0,1,67,38,147,127,6,2,5,21,10,23,186,106,108,80,14]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0,P=De(P),a=De(a);async function g(u,i,n,t,s){let r;for(let o=3;o&&(r?.dispose(),r=await new v(u,i,n,t,s).waitForReady(),!(s&&_.BROWSER_RESTRICTED_PORTS[s]||!_.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));o--);return r}class v extends T.Disposable{constructor(i,n,t,s,r){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=r,this.privacy=p.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=i,this._server=P.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=o=>this._onConnection(o),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const i=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,p.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let t=await(0,_.findFreePortFaster)(i,2,1e3,n),s=null;return this._server.listen(t,this.defaultTunnelHost),await this._barrier.wait(),s=this._server.address(),s||(t=0,this._server.listen(t,this.defaultTunnelHost),await this._barrier.wait(),s=this._server.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async _onConnection(i){i.pause();const n=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,d.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),s=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this._socketsDispose.delete(i.localAddress),s.end()}),i.on("close",()=>s.end()),i.on("error",()=>{i.localAddress&&this._socketsDispose.delete(i.localAddress),s instanceof L.NodeSocket?s.socket.destroy():s.end()}),s instanceof L.NodeSocket?this._mirrorNodeSocket(i,s):this._mirrorGenericSocket(i,s),i.localAddress&&this._socketsDispose.set(i.localAddress,()=>{i.end(),s.end()})}_mirrorGenericSocket(i,n){n.onClose(()=>i.destroy()),n.onEnd(()=>i.end()),n.onData(t=>i.write(t.buffer)),i.on("data",t=>n.write(I.VSBuffer.wrap(t))),i.resume()}_mirrorNodeSocket(i,n){const t=n.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.NodeRemoteTunnel=v;let C=class extends p.AbstractTunnelService{constructor(i,n,t,s,r){super(n,r),this.remoteSocketFactoryService=i,this.signService=t,this.productService=s}isPortPrivileged(i){return(0,p.isPortPrivileged)(i,this.defaultTunnelHost,D.OS,a.release())}retainOrCreateTunnel(i,n,t,s,r,o,h,y){const A=this.getTunnelFromMap(n,t);if(A)return++A.refcount,A.value;if((0,p.isTunnelProvider)(i))return this.createWithProvider(i,n,t,r,o,h,y);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${t} on local port ${r}.`);const b={commit:this.productService.commit,quality:this.productService.quality,addressProvider:i,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},w=g(b,s,n,t,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,t,w),w}}};e.BaseTunnelService=C,e.BaseTunnelService=C=we([Q(0,f.IRemoteSocketFactoryService),Q(1,R.ILogService),Q(2,l.ISignService),Q(3,m.IProductService),Q(4,E.IConfigurationService)],C);let S=class extends C{constructor(i,n,t,s,r){super(i,n,t,s,r)}};e.TunnelService=S,e.TunnelService=S=we([Q(0,f.IRemoteSocketFactoryService),Q(1,R.ILogService),Q(2,l.ISignService),Q(3,m.IProductService),Q(4,E.IConfigurationService)],S);let c=class extends T.Disposable{constructor(i,n,t,s,r){super(),this.remoteSocketFactoryService=i,this.logService=n,this.productService=t,this.signService=s,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(i,n,t,s,r,o,h,y,A){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${s} on local port ${o}.`),!this._tunnelServices.has(i)){const b=new S(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(b),this._tunnelServices.set(i,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this._tunnelServices.delete(i))})}return this._tunnelServices.get(i).openTunnel(n,t,s,r,o,h,y,A)}};e.SharedTunnelsService=c,e.SharedTunnelsService=c=we([Q(0,f.IRemoteSocketFactoryService),Q(1,R.ILogService),Q(2,m.IProductService),Q(3,l.ISignService),Q(4,E.IConfigurationService)],c)});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(ue[246],he([0,1,38,43,8,2,22,9,17,3,42,151,179,180,189,171,237,162,163,21,184,97,196,98,191,15,118,223,27,110,187,117,74,7,173,174,73,4,170,76,78,199,10,175,102,23,61,16,109,18,111,112,113,48,202,85,114,24,82,229,234,212,86,228,232,233,126,62,227,213,108,195,80,239,190,203,28,204,5,205,164,182,181,84,218,19,52,178,58,226,201,214,107,231,219,11,176,101,224,217,192,158,57,177,235,221,56,225,106,104,238,156,193,145,133,144]),function(ae,e,P,a,_,L,k,T,D,E,R,m,d,f,l,p,I,g,v,C,S,c,u,i,n,t,s,r,o,h,y,A,b,w,O,N,F,M,H,z,J,V,te,$,q,Z,ne,le,ee,X,K,W,U,Y,oe,x,B,j,G,ie,ce,ge,Se,Ie,Ce,Ee,ve,be,re,fe,me,Pe,Te,Ue,ke,_e,Ne,$e,ze,Me,We,qe,Be,Ae,se,de,pe,ye,Le,Oe,xe,Je,Ge,Ye,je,Ze,Xe,nt,at,_t,At,Ot,kt,Ut,Nt,Ft,yt,Mt,wt,xt,Wt,$t,ut,qt,Bt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=bt,q=it(q);class zt extends L.Disposable{constructor(Re){super(),this.configuration=Re,this.server=this._register(new m.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new E.Emitter),this.registerListeners()}registerListeners(){let Re=!1;const Fe=()=>{Re||(Re=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Fe),(0,m.once)(process.parentPort,ut.SharedProcessLifecycle.exit,Fe)}async init(){const Re=await this.initServices();(0,j.registerConfiguration)(),Re.invokeFunction(Fe=>{const He=Fe.get(te.ILogService),Ve=Fe.get(X.ITelemetryService),et=Fe.get(de.IUserDataProfilesService);He.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Fe),this.registerErrorHandler(He),this.reportProfilesInfo(Ve,et),this._register(et.onDidChangeProfiles(()=>this.reportProfilesInfo(Ve,et))),this.reportClientOSInfo(Ve,He)}),this._register((0,L.combinedDisposable)(Re.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),Re.createInstance(f.LanguagePackCachedDataCleaner),Re.createInstance(I.UnusedWorkspaceStorageDataCleaner),Re.createInstance(p.LogsDataCleaner),Re.createInstance(l.LocalizationsUpdater),Re.createInstance(je.ExtensionsContributions),Re.createInstance(Je.UserDataProfilesCleaner)))}async initServices(){const Re=new z.ServiceCollection,Fe={_serviceBrand:void 0,...q.default};Re.set(Z.IProductService,Fe);const He=new R.StaticRouter(Qe=>Qe==="main"),Ve=new yt.MainProcessService(this.server,He);Re.set(yt.IMainProcessService,Ve);const et=this.configuration.policiesData?new ye.PolicyChannelClient(this.configuration.policiesData,Ve.getChannel("policy")):new Le.NullPolicyService;Re.set(Le.IPolicyService,et);const Ke=new $t.NativeEnvironmentService(this.configuration.args,Fe);Re.set(t.INativeEnvironmentService,Ke);const ot=new $.LoggerChannelClient(void 0,this.configuration.logLevel,Ke.logsHome,this.configuration.loggers.map(Qe=>({...Qe,resource:T.URI.revive(Qe.resource)})),Ve.getChannel("logger"));Re.set(te.ILoggerService,ot);const dt=this._register(ot.createLogger("sharedprocess",{name:(0,Ze.localize)(12198,null)})),pt=this._register(new te.ConsoleLogger(dt.getLevel())),tt=this._register(new Xe.LogService(dt,[pt]));Re.set(te.ILogService,tt),this.lifecycleService=this._register(new nt.SharedProcessLifecycleService(tt)),Re.set(nt.ISharedProcessLifecycleService,this.lifecycleService);const st=this._register(new O.FileService(tt));Re.set(w.IFileService,st);const St=this._register(new N.DiskFileSystemProvider(tt));st.registerProvider(k.Schemas.file,St);const ft=new $e.UriIdentityService(st);Re.set(Ne.IUriIdentityService,ft);const rt=this._register(new Oe.UserDataProfilesService(this.configuration.profiles.all,T.URI.revive(this.configuration.profiles.home).with({scheme:Ke.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Re.set(de.IUserDataProfilesService,rt);const vt=this._register(new Me.FileUserDataProvider(k.Schemas.file,this._register(new We.DiskFileSystemProviderClient(Ve.getChannel(We.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ze.isLinux})),k.Schemas.vscodeUserData,rt,ft,tt));st.registerProvider(k.Schemas.vscodeUserData,vt);const ct=this._register(new S.ConfigurationService(rt.defaultProfile.settingsResource,st,et,tt));Re.set(C.IConfigurationService,ct);const Et=new Mt.RemoteStorageService(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ve,Ke);Re.set(le.IStorageService,Et),this._register((0,L.toDisposable)(()=>Et.flush())),await Promise.all([ct.initialize(),Et.initialize()]);const Pt=new At.RequestChannelClient(Ve.getChannel("request"));Re.set(ne.IRequestService,Pt),Re.set(g.IChecksumService,new F.SyncDescriptor(v.ChecksumService,void 0,!1)),Re.set(Be.IV8InspectProfilingService,new F.SyncDescriptor(qe.InspectProfilingService,void 0,!1));const Rt=new Ut.NativeHostService(-1,Ve);Re.set(kt.INativeHostService,Rt),Re.set(i.IDownloadService,new F.SyncDescriptor(n.DownloadService,void 0,!0));const Vt=this._register(new fe.ActiveWindowManager(Rt)),Ht=new R.StaticRouter(Qe=>Vt.getActiveClientId().then(mt=>Qe===mt));Re.set(b.IExtensionRecommendationNotificationService,new Ot.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ht)));let gt;const lt=[],Ct=(0,Y.isInternalTelemetry)(Fe,ct);if((0,Y.supportsTelemetry)(Fe,Ke)){const Qe=new W.TelemetryLogAppender(tt,ot,Ke,Fe);if(lt.push(Qe),!(0,Y.isLoggingOnly)(Fe,Ke)&&Fe.aiConfig?.ariaKey){const mt=new xe.OneDataSystemAppender(Pt,Ct,"monacoworkbench",null,Fe.aiConfig.ariaKey);this._register((0,L.toDisposable)(()=>mt.flush())),lt.push(mt)}gt=new U.TelemetryService({appenders:lt,commonProperties:(0,ee.resolveCommonProperties)((0,P.release)(),(0,P.hostname)(),process.arch,Fe.commit,Fe.version,this.configuration.machineId,this.configuration.sqmId,this.configuration.devDeviceId,Ct),sendErrorTelemetry:!0,piiPaths:(0,Y.getPiiPathsFromEnvironment)(Ke)},ct,Fe)}else{gt=Y.NullTelemetryService;const Qe=Y.NullAppender;lt.push(Qe)}this.server.registerChannel("telemetryAppender",new K.TelemetryAppenderChannel(lt)),Re.set(X.ITelemetryService,gt);const Gt=new oe.CustomEndpointTelemetryService(ct,gt,tt,ot,Ke,Fe);Re.set(X.ICustomEndpointTelemetryService,Gt),Re.set(pe.IExtensionsProfileScannerService,new F.SyncDescriptor(_t.ExtensionsProfileScannerService,void 0,!0)),Re.set(Ae.IExtensionsScannerService,new F.SyncDescriptor(se.ExtensionsScannerService,void 0,!0)),Re.set(h.IExtensionSignatureVerificationService,new F.SyncDescriptor(h.ExtensionSignatureVerificationService,void 0,!0)),Re.set(A.INativeServerExtensionManagementService,new F.SyncDescriptor(A.ExtensionManagementService,void 0,!0)),Re.set(o.IExtensionGalleryService,new F.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),Re.set(o.IExtensionTipsService,new F.SyncDescriptor(Ft.ExtensionTipsService,void 0,!1)),Re.set(J.ILanguagePackService,new F.SyncDescriptor(V.NativeLanguagePackService,void 0,!1)),Re.set(c.IDiagnosticsService,new F.SyncDescriptor(u.DiagnosticsService,void 0,!1)),Re.set(G.IUserDataSyncAccountService,new F.SyncDescriptor(G.UserDataSyncAccountService,void 0,!0)),Re.set(j.IUserDataSyncLogService,new F.SyncDescriptor(ge.UserDataSyncLogService,void 0,!0)),Re.set(j.IUserDataSyncUtilService,R.ProxyChannel.toService(this.server.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Re.set(o.IGlobalExtensionEnablementService,new F.SyncDescriptor(s.GlobalExtensionEnablementService,void 0,!1)),Re.set(B.IIgnoredExtensionsManagementService,new F.SyncDescriptor(B.IgnoredExtensionsManagementService,void 0,!0)),Re.set(x.IExtensionStorageService,new F.SyncDescriptor(x.ExtensionStorageService)),Re.set(j.IUserDataSyncStoreManagementService,new F.SyncDescriptor(ve.UserDataSyncStoreManagementService,void 0,!0)),Re.set(j.IUserDataSyncStoreService,new F.SyncDescriptor(ve.UserDataSyncStoreService,void 0,!0)),Re.set(Se.IUserDataSyncMachinesService,new F.SyncDescriptor(Se.UserDataSyncMachinesService,void 0,!0)),Re.set(j.IUserDataSyncLocalStoreService,new F.SyncDescriptor(ie.UserDataSyncLocalStoreService,void 0,!1)),Re.set(j.IUserDataSyncEnablementService,new F.SyncDescriptor(Ie.UserDataSyncEnablementService,void 0,!0)),Re.set(j.IUserDataSyncService,new F.SyncDescriptor(Ce.UserDataSyncService,void 0,!1)),Re.set(be.IUserDataProfileStorageService,new F.SyncDescriptor(re.SharedProcessUserDataProfileStorageService,void 0,!0)),Re.set(j.IUserDataSyncResourceProviderService,new F.SyncDescriptor(Ye.UserDataSyncResourceProviderService,void 0,!0)),Re.set(me.ISignService,new F.SyncDescriptor(Pe.SignService,void 0,!1));const Dt=new wt.RemoteSocketFactoryService;return Re.set(wt.IRemoteSocketFactoryService,Dt),Dt.register(xt.RemoteConnectionType.WebSocket,Wt.nodeSocketFactory),Re.set(Te.ISharedTunnelsService,new F.SyncDescriptor(Ue.SharedTunnelsService)),Re.set(ke.ISharedProcessTunnelService,new F.SyncDescriptor(_e.SharedProcessTunnelService)),Re.set(Ge.IRemoteTunnelService,new F.SyncDescriptor(at.RemoteTunnelService)),new H.InstantiationService(Re)}initChannels(Re){const Fe=new y.ExtensionManagementChannel(Re.get(o.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Fe);const He=R.ProxyChannel.fromService(Re.get(J.ILanguagePackService),this._store);this.server.registerChannel("languagePacks",He);const Ve=R.ProxyChannel.fromService(Re.get(c.IDiagnosticsService),this._store);this.server.registerChannel("diagnostics",Ve);const et=new y.ExtensionTipsChannel(Re.get(o.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Ke=R.ProxyChannel.fromService(Re.get(g.IChecksumService),this._store);this.server.registerChannel("checksum",Ke);const ot=R.ProxyChannel.fromService(Re.get(Be.IV8InspectProfilingService),this._store);this.server.registerChannel("v8InspectProfiling",ot);const dt=R.ProxyChannel.fromService(Re.get(Se.IUserDataSyncMachinesService),this._store);this.server.registerChannel("userDataSyncMachines",dt);const pt=R.ProxyChannel.fromService(Re.get(X.ICustomEndpointTelemetryService),this._store);this.server.registerChannel("customEndpointTelemetry",pt);const tt=new ce.UserDataSyncAccountServiceChannel(Re.get(G.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",tt);const st=new ce.UserDataSyncStoreManagementServiceChannel(Re.get(j.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",st);const St=new Ee.UserDataSyncServiceChannel(Re.get(j.IUserDataSyncService),Re.get(de.IUserDataProfilesService),Re.get(te.ILogService));this.server.registerChannel("userDataSync",St);const ft=this._register(Re.get(M.IInstantiationService).createInstance(Nt.UserDataAutoSyncService));this.server.registerChannel("userDataAutoSync",R.ProxyChannel.fromService(ft,this._store)),this.server.registerChannel("IUserDataSyncResourceProviderService",R.ProxyChannel.fromService(Re.get(j.IUserDataSyncResourceProviderService),this._store));const rt=R.ProxyChannel.fromService(Re.get(ke.ISharedProcessTunnelService),this._store);this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,rt);const vt=R.ProxyChannel.fromService(Re.get(Ge.IRemoteTunnelService),this._store);this.server.registerChannel("remoteTunnel",vt)}registerErrorHandler(Re){process.on("uncaughtException",Fe=>(0,_.onUnexpectedError)(Fe)),process.on("unhandledRejection",Fe=>(0,_.onUnexpectedError)(Fe)),(0,_.setUnexpectedErrorHandler)(Fe=>{const He=(0,a.toErrorMessage)(Fe,!0);He&&Re.error(`[uncaught exception in sharedProcess]: ${He}`)})}reportProfilesInfo(Re,Fe){Re.publicLog2("profilesInfo",{count:Fe.profiles.length})}async reportClientOSInfo(Re,Fe){if(ze.isLinux){const[He,Ve]=await Promise.all([(0,qt.getOSReleaseInfo)(Fe.error.bind(Fe)),(0,It.getDisplayProtocol)(Fe.error.bind(Fe))]),et=(0,Bt.getDesktopEnvironment)(),Ke=(0,It.getCodeDisplayProtocol)(Ve,this.configuration.args["ozone-platform"]);He&&Re.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:et,displayProtocol:Ve,codeDisplayProtocol:Ke})}}handledClientConnection(Re){if(Re.data!==ut.SharedProcessRawConnection.response)return!1;const Fe=(0,D.firstOrDefault)(Re.ports);return Fe?(this.onDidWindowConnectRaw.fire(Fe),!0):!1}}async function bt(ht){try{const Re=new zt(ht);process.parentPort.postMessage(ut.SharedProcessLifecycle.ipcReady),await Re.init(),process.parentPort.postMessage(ut.SharedProcessLifecycle.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const jt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ht=>{clearTimeout(jt),bt(ht.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
