/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/event","vs/base/common/strings","vs/base/common/async","vs/base/common/errors","vs/base/common/types","vs/base/common/charCode","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/extpath","fs","vs/base/common/lazy","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/files/common/watcher","vs/base/common/map","vs/base/common/normalization","vs/base/common/resources","vs/base/common/glob","vs/base/node/pfs","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/processes","vs/base/common/ternarySearchTree","vs/base/common/network","vs/base/node/extpath","vs/base/parts/sandbox/node/electronTypes","vs/nls","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/console","vs/base/common/marshalling","os","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/base/common/errorMessage","vs/platform/instantiation/common/instantiation","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcher","vs/platform/files/node/watcher/watcherStats","vs/platform/files/node/watcher/watcher","util","child_process","@parcel/watcher","vs/platform/files/node/watcher/watcherMain"],pe=function(ce){for(var e=[],p=0,t=ce.length;p<t;p++)e[p]=Ee[ce[p]];return e};define(Ee[37],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=p,e.findLastIdx=t,e.findLastMonotonous=$,e.findLastIdxMonotonous=q,e.findFirstMonotonous=V,e.findFirstIdxMonotonousOrArrLen=N,e.findFirstIdxMonotonous=L,e.findFirstMax=M,e.findLastMax=w,e.findFirstMin=D,e.findMaxIdx=k,e.mapFindFirst=a;function p(r,f){const b=t(r,f);if(b!==-1)return r[b]}function t(r,f,b=r.length-1){for(let u=b;u>=0;u--){const y=r[u];if(f(y))return u}return-1}function $(r,f){const b=q(r,f);return b===-1?void 0:r[b]}function q(r,f,b=0,u=r.length){let y=b,v=u;for(;y<v;){const l=Math.floor((y+v)/2);f(r[l])?y=l+1:v=l}return y-1}function V(r,f){const b=N(r,f);return b===r.length?void 0:r[b]}function N(r,f,b=0,u=r.length){let y=b,v=u;for(;y<v;){const l=Math.floor((y+v)/2);f(r[l])?v=l:y=l+1}return y}function L(r,f,b=0,u=r.length){const y=N(r,f,b,u);return y===r.length?-1:y}class T{static{this.assertInvariants=!1}constructor(f){this._array=f,this._findLastMonotonousLastIdx=0}findLastMonotonous(f){if(T.assertInvariants){if(this._prevFindLastPredicate){for(const u of this._array)if(this._prevFindLastPredicate(u)&&!f(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=f}const b=q(this._array,f,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=b+1,b===-1?void 0:this._array[b]}}e.MonotonousArray=T;function M(r,f){if(r.length===0)return;let b=r[0];for(let u=1;u<r.length;u++){const y=r[u];f(y,b)>0&&(b=y)}return b}function w(r,f){if(r.length===0)return;let b=r[0];for(let u=1;u<r.length;u++){const y=r[u];f(y,b)>=0&&(b=y)}return b}function D(r,f){return M(r,(b,u)=>-f(b,u))}function k(r,f){if(r.length===0)return-1;let b=0;for(let u=1;u<r.length;u++){const y=r[u];f(y,r[b])>0&&(b=u)}return b}function a(r,f){for(const b of r){const u=f(b);if(u!==void 0)return u}}}),define(Ee[11],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var p;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(p||(e.CharCode=p={}))}),define(Ee[38],pe([0,1]),function(ce,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=t,e.diffSets=$,e.diffMaps=q,e.intersection=V;function t(L,T){const M=Object.create(null);for(const w of L){const D=T(w);let k=M[D];k||(k=M[D]=[]),k.push(w)}return M}function $(L,T){const M=[],w=[];for(const D of L)T.has(D)||M.push(D);for(const D of T)L.has(D)||w.push(D);return{removed:M,added:w}}function q(L,T){const M=[],w=[];for(const[D,k]of L)T.has(D)||M.push(k);for(const[D,k]of T)L.has(D)||w.push(k);return{removed:M,added:w}}function V(L,T){const M=new Set;for(const w of T)L.has(w)&&M.add(w);return M}class N{static{p=Symbol.toStringTag}constructor(T,M){this.toKey=M,this._map=new Map,this[p]="SetWithKey";for(const w of T)this.add(w)}get size(){return this._map.size}add(T){const M=this.toKey(T);return this._map.set(M,T),this}delete(T){return this._map.delete(this.toKey(T))}has(T){return this._map.has(this.toKey(T))}*entries(){for(const T of this._map.values())yield[T,T]}keys(){return this.values()}*values(){for(const T of this._map.values())yield T}clear(){this._map.clear()}forEach(T,M){this._map.forEach(w=>T.call(M,w,w,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=N}),define(Ee[39],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=t,e.debounce=$,e.throttle=q;function p(V){return(N,L,T)=>{let M=null,w=null;if(typeof T.value=="function"?(M="value",w=T.value):typeof T.get=="function"&&(M="get",w=T.get),!w)throw new Error("not supported");T[M]=V(w,L)}}function t(V,N,L){let T=null,M=null;if(typeof L.value=="function"?(T="value",M=L.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof L.get=="function"&&(T="get",M=L.get),!M)throw new Error("not supported");const w=`$memoize$${N}`;L[T]=function(...D){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,D)}),this[w]}}function $(V,N,L){return p((T,M)=>{const w=`$debounce$${M}`,D=`$debounce$result$${M}`;return function(...k){this[D]||(this[D]=L?L():void 0),clearTimeout(this[w]),N&&(this[D]=N(this[D],...k),k=[this[D]]),this[w]=setTimeout(()=>{T.apply(this,k),this[D]=L?L():void 0},V)}})}function q(V,N,L){return p((T,M)=>{const w=`$throttle$timer$${M}`,D=`$throttle$result$${M}`,k=`$throttle$lastRun$${M}`,a=`$throttle$pending$${M}`;return function(...r){if(this[D]||(this[D]=L?L():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),N&&(this[D]=N(this[D],...r)),this[a])return;const f=this[k]+V;f<=Date.now()?(this[k]=Date.now(),T.apply(this,[this[D]]),this[D]=L?L():void 0):(this[a]=!0,this[w]=setTimeout(()=>{this[a]=!1,this[k]=Date.now(),T.apply(this,[this[D]]),this[D]=L?L():void 0},f-Date.now()))}})}}),define(Ee[9],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=t,e.isSigPipeError=$,e.onUnexpectedError=q,e.onUnexpectedExternalError=V,e.transformErrorForSerialization=N,e.transformErrorFromSerialization=L,e.isCancellationError=M,e.canceled=D,e.illegalArgument=k,e.illegalState=a,e.getErrorMessage=f;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?v.isErrorNoTelemetry(i)?new v(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=p,e.errorHandler=new p;function t(n){e.errorHandler.setUnexpectedErrorHandler(n)}function $(n){if(!n||typeof n!="object")return!1;const i=n;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function q(n){M(n)||e.errorHandler.onUnexpectedError(n)}function V(n){M(n)||e.errorHandler.onUnexpectedExternalError(n)}function N(n){if(n instanceof Error){const{name:i,message:s}=n,o=n.stacktrace||n.stack;return{$isError:!0,name:i,message:s,stack:o,noTelemetry:v.isErrorNoTelemetry(n)}}return n}function L(n){let i;return n.noTelemetry?i=new v:(i=new Error,i.name=n.name),i.message=n.message,i.stack=n.stack,i}const T="Canceled";function M(n){return n instanceof w?!0:n instanceof Error&&n.name===T&&n.message===T}class w extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=w;function D(){const n=new Error(T);return n.name=n.message,n}function k(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function a(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class r extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=r;function f(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=b;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=u;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=y;class v extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof v)return i;const s=new v;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=v;class l extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}e.BugIndicatingError=l}),define(Ee[12],pe([0,1,9,37]),function(ce,e,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=$,e.tail2=q,e.equals=V,e.removeFastWithoutKeepingOrder=N,e.binarySearch=L,e.binarySearch2=T,e.quickSelect=M,e.groupBy=w,e.groupAdjacentBy=D,e.forEachAdjacent=k,e.forEachWithNeighbors=a,e.sortedDiff=r,e.delta=f,e.top=b,e.topAsync=u,e.coalesce=v,e.coalesceInPlace=l,e.move=n,e.isFalsyOrEmpty=i,e.isNonEmptyArray=s,e.distinct=o,e.uniqueFilter=U,e.firstOrDefault=m,e.lastOrDefault=E,e.commonPrefixLength=h,e.range=d,e.index=F,e.insert=c,e.remove=A,e.arrayInsert=j,e.shuffle=Z,e.pushToStart=x,e.pushToEnd=H,e.pushMany=se,e.mapArrayOrNot=K,e.asArray=ie,e.getRandomElement=oe,e.insertInto=re,e.splice=I,e.compareBy=C,e.tieBreakComparators=Y,e.reverseOrder=ee,e.findAsync=we;function $(B,z=0){return B[B.length-(1+z)]}function q(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function V(B,z,P=(g,W)=>g===W){if(B===z)return!0;if(!B||!z||B.length!==z.length)return!1;for(let g=0,W=B.length;g<W;g++)if(!P(B[g],z[g]))return!1;return!0}function N(B,z){const P=B.length-1;z<P&&(B[z]=B[P]),B.pop()}function L(B,z,P){return T(B.length,g=>P(B[g],z))}function T(B,z){let P=0,g=B-1;for(;P<=g;){const W=(P+g)/2|0,Q=z(W);if(Q<0)P=W+1;else if(Q>0)g=W-1;else return W}return-(P+1)}function M(B,z,P){if(B=B|0,B>=z.length)throw new TypeError("invalid index");const g=z[Math.floor(z.length*Math.random())],W=[],Q=[],te=[];for(const ge of z){const ye=P(ge,g);ye<0?W.push(ge):ye>0?Q.push(ge):te.push(ge)}return B<W.length?M(B,W,P):B<W.length+te.length?te[0]:M(B-(W.length+te.length),Q,P)}function w(B,z){const P=[];let g;for(const W of B.slice(0).sort(z))!g||z(g[0],W)!==0?(g=[W],P.push(g)):g.push(W);return P}function*D(B,z){let P,g;for(const W of B)g!==void 0&&z(g,W)?P.push(W):(P&&(yield P),P=[W]),g=W;P&&(yield P)}function k(B,z){for(let P=0;P<=B.length;P++)z(P===0?void 0:B[P-1],P===B.length?void 0:B[P])}function a(B,z){for(let P=0;P<B.length;P++)z(P===0?void 0:B[P-1],B[P],P+1===B.length?void 0:B[P+1])}function r(B,z,P){const g=[];function W(ge,ye,Re){if(ye===0&&Re.length===0)return;const fe=g[g.length-1];fe&&fe.start+fe.deleteCount===ge?(fe.deleteCount+=ye,fe.toInsert.push(...Re)):g.push({start:ge,deleteCount:ye,toInsert:Re})}let Q=0,te=0;for(;;){if(Q===B.length){W(Q,0,z.slice(te));break}if(te===z.length){W(Q,B.length-Q,[]);break}const ge=B[Q],ye=z[te],Re=P(ge,ye);Re===0?(Q+=1,te+=1):Re<0?(W(Q,1,[]),Q+=1):Re>0&&(W(Q,0,[ye]),te+=1)}return g}function f(B,z,P){const g=r(B,z,P),W=[],Q=[];for(const te of g)W.push(...B.slice(te.start,te.start+te.deleteCount)),Q.push(...te.toInsert);return{removed:W,added:Q}}function b(B,z,P){if(P===0)return[];const g=B.slice(0,P).sort(z);return y(B,z,g,P,B.length),g}function u(B,z,P,g,W){return P===0?Promise.resolve([]):new Promise((Q,te)=>{(async()=>{const ge=B.length,ye=B.slice(0,P).sort(z);for(let Re=P,fe=Math.min(P+g,ge);Re<ge;Re=fe,fe=Math.min(fe+g,ge)){if(Re>P&&await new Promise(ue=>setTimeout(ue)),W&&W.isCancellationRequested)throw new p.CancellationError;y(B,z,ye,Re,fe)}return ye})().then(Q,te)})}function y(B,z,P,g,W){for(const Q=P.length;g<W;g++){const te=B[g];if(z(te,P[Q-1])<0){P.pop();const ge=(0,t.findFirstIdxMonotonousOrArrLen)(P,ye=>z(te,ye)<0);P.splice(ge,0,te)}}}function v(B){return B.filter(z=>!!z)}function l(B){let z=0;for(let P=0;P<B.length;P++)B[P]&&(B[z]=B[P],z+=1);B.length=z}function n(B,z,P){B.splice(P,0,B.splice(z,1)[0])}function i(B){return!Array.isArray(B)||B.length===0}function s(B){return Array.isArray(B)&&B.length>0}function o(B,z=P=>P){const P=new Set;return B.filter(g=>{const W=z(g);return P.has(W)?!1:(P.add(W),!0)})}function U(B){const z=new Set;return P=>{const g=B(P);return z.has(g)?!1:(z.add(g),!0)}}function m(B,z){return B.length>0?B[0]:z}function E(B,z){return B.length>0?B[B.length-1]:z}function h(B,z,P=(g,W)=>g===W){let g=0;for(let W=0,Q=Math.min(B.length,z.length);W<Q&&P(B[W],z[W]);W++)g++;return g}function d(B,z){let P=typeof z=="number"?B:0;typeof z=="number"?P=B:(P=0,z=B);const g=[];if(P<=z)for(let W=P;W<z;W++)g.push(W);else for(let W=P;W>z;W--)g.push(W);return g}function F(B,z,P){return B.reduce((g,W)=>(g[z(W)]=P?P(W):W,g),Object.create(null))}function c(B,z){return B.push(z),()=>A(B,z)}function A(B,z){const P=B.indexOf(z);if(P>-1)return B.splice(P,1),z}function j(B,z,P){const g=B.slice(0,z),W=B.slice(z);return g.concat(P,W)}function Z(B,z){let P;if(typeof z=="number"){let g=z;P=()=>{const W=Math.sin(g++)*179426549;return W-Math.floor(W)}}else P=Math.random;for(let g=B.length-1;g>0;g-=1){const W=Math.floor(P()*(g+1)),Q=B[g];B[g]=B[W],B[W]=Q}}function x(B,z){const P=B.indexOf(z);P>-1&&(B.splice(P,1),B.unshift(z))}function H(B,z){const P=B.indexOf(z);P>-1&&(B.splice(P,1),B.push(z))}function se(B,z){for(const P of z)B.push(P)}function K(B,z){return Array.isArray(B)?B.map(z):z(B)}function ie(B){return Array.isArray(B)?B:[B]}function oe(B){return B[Math.floor(Math.random()*B.length)]}function re(B,z,P){const g=_(B,z),W=B.length,Q=P.length;B.length=W+Q;for(let te=W-1;te>=g;te--)B[te+Q]=B[te];for(let te=0;te<Q;te++)B[te+g]=P[te]}function I(B,z,P,g){const W=_(B,z);let Q=B.splice(W,P);return Q===void 0&&(Q=[]),re(B,W,g),Q}function _(B,z){return z<0?Math.max(z+B.length,0):Math.min(z,B.length)}var O;(function(B){function z(Q){return Q<0}B.isLessThan=z;function P(Q){return Q<=0}B.isLessThanOrEqual=P;function g(Q){return Q>0}B.isGreaterThan=g;function W(Q){return Q===0}B.isNeitherLessOrGreaterThan=W,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(O||(e.CompareResult=O={}));function C(B,z){return(P,g)=>z(B(P),B(g))}function Y(...B){return(z,P)=>{for(const g of B){const W=g(z,P);if(!O.isNeitherLessOrGreaterThan(W))return W}return O.neitherLessOrGreaterThan}}const R=(B,z)=>B-z;e.numberComparator=R;const X=(B,z)=>(0,e.numberComparator)(B?1:0,z?1:0);e.booleanComparator=X;function ee(B){return(z,P)=>-B(z,P)}class ne{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let P=this.firstIdx;for(;P<this.items.length&&z(this.items[P]);)P++;const g=P===this.firstIdx?null:this.items.slice(this.firstIdx,P);return this.firstIdx=P,g}takeFromEndWhile(z){let P=this.lastIdx;for(;P>=0&&z(this.items[P]);)P--;const g=P===this.lastIdx?null:this.items.slice(P+1,this.lastIdx+1);return this.lastIdx=P,g}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const P=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,P}}e.ArrayQueue=ne;class le{static{this.empty=new le(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(P=>(z(P),!0))}toArray(){const z=[];return this.iterate(P=>(z.push(P),!0)),z}filter(z){return new le(P=>this.iterate(g=>z(g)?P(g):!0))}map(z){return new le(P=>this.iterate(g=>P(z(g))))}some(z){let P=!1;return this.iterate(g=>(P=z(g),!P)),P}findFirst(z){let P;return this.iterate(g=>z(g)?(P=g,!1):!0),P}findLast(z){let P;return this.iterate(g=>(z(g)&&(P=g),!0)),P}findLastMaxBy(z){let P,g=!0;return this.iterate(W=>((g||O.isGreaterThan(z(W,P)))&&(g=!1,P=W),!0)),P}}e.CallbackIterable=le;class he{constructor(z){this._indexMap=z}static createSortPermutation(z,P){const g=Array.from(z.keys()).sort((W,Q)=>P(z[W],z[Q]));return new he(g)}apply(z){return z.map((P,g)=>z[this._indexMap[g]])}inverse(){const z=this._indexMap.slice();for(let P=0;P<this._indexMap.length;P++)z[this._indexMap[P]]=P;return new he(z)}}e.Permutation=he;async function we(B,z){return(await Promise.all(B.map(async(g,W)=>({element:g,ok:await z(g,W)})))).find(g=>g.ok)?.element}}),define(Ee[26],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=p;function p(t,$){const q=this;let V=!1,N;return function(){if(V)return N;if(V=!0,$)try{N=t.apply(q,arguments)}finally{$()}else N=t.apply(q,arguments);return N}}}),define(Ee[40],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(t){function $(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=$;const q=Object.freeze([]);function V(){return q}t.empty=V;function*N(i){yield i}t.single=N;function L(i){return $(i)?i:N(i)}t.wrap=L;function T(i){return i||q}t.from=T;function*M(i){for(let s=i.length-1;s>=0;s--)yield i[s]}t.reverse=M;function w(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=w;function D(i){return i[Symbol.iterator]().next().value}t.first=D;function k(i,s){let o=0;for(const U of i)if(s(U,o++))return!0;return!1}t.some=k;function a(i,s){for(const o of i)if(s(o))return o}t.find=a;function*r(i,s){for(const o of i)s(o)&&(yield o)}t.filter=r;function*f(i,s){let o=0;for(const U of i)yield s(U,o++)}t.map=f;function*b(i,s){let o=0;for(const U of i)yield*s(U,o++)}t.flatMap=b;function*u(...i){for(const s of i)yield*s}t.concat=u;function y(i,s,o){let U=o;for(const m of i)U=s(U,m);return U}t.reduce=y;function*v(i,s,o=i.length){for(s<0&&(s+=i.length),o<0?o+=i.length:o>i.length&&(o=i.length);s<o;s++)yield i[s]}t.slice=v;function l(i,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,i];const U=i[Symbol.iterator]();for(let m=0;m<s;m++){const E=U.next();if(E.done)return[o,t.empty()];o.push(E.value)}return[o,{[Symbol.iterator](){return U}}]}t.consume=l;async function n(i){const s=[];for await(const o of i)s.push(o);return Promise.resolve(s)}t.asyncToArray=n})(p||(e.Iterable=p={}))}),define(Ee[16],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor($){this.executor=$,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch($){this._error=$}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=p}),define(Ee[41],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{static{this.Undefined=new p(void 0)}constructor(q){this.element=q,this.next=p.Undefined,this.prev=p.Undefined}}class t{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let q=this._first;for(;q!==p.Undefined;){const V=q.next;q.prev=p.Undefined,q.next=p.Undefined,q=V}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(q){return this._insert(q,!1)}push(q){return this._insert(q,!0)}_insert(q,V){const N=new p(q);if(this._first===p.Undefined)this._first=N,this._last=N;else if(V){const T=this._last;this._last=N,N.prev=T,T.next=N}else{const T=this._first;this._first=N,N.next=T,T.prev=N}this._size+=1;let L=!1;return()=>{L||(L=!0,this._remove(N))}}shift(){if(this._first!==p.Undefined){const q=this._first.element;return this._remove(this._first),q}}pop(){if(this._last!==p.Undefined){const q=this._last.element;return this._remove(this._last),q}}_remove(q){if(q.prev!==p.Undefined&&q.next!==p.Undefined){const V=q.prev;V.next=q.next,q.next.prev=V}else q.prev===p.Undefined&&q.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):q.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):q.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let q=this._first;for(;q!==p.Undefined;)yield q.element,q=q.next}}e.LinkedList=t}),define(Ee[20],pe([0,1]),function(ce,e){"use strict";var p,t,$;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=q,e.mapToString=V,e.setToString=N,e.mapsStrictEqualIgnoreOrder=v;function q(l,n,i){let s=l.get(n);return s===void 0&&(s=i,l.set(n,s)),s}function V(l){const n=[];return l.forEach((i,s)=>{n.push(`${s} => ${i}`)}),`Map(${l.size}) {${n.join(", ")}}`}function N(l){const n=[];return l.forEach(i=>{n.push(i)}),`Set(${l.size}) {${n.join(", ")}}`}class L{constructor(n,i){this.uri=n,this.value=i}}function T(l){return Array.isArray(l)}class M{static{this.defaultToKey=n=>n.toString()}constructor(n,i){if(this[p]="ResourceMap",n instanceof M)this.map=new Map(n.map),this.toKey=i??M.defaultToKey;else if(T(n)){this.map=new Map,this.toKey=i??M.defaultToKey;for(const[s,o]of n)this.set(s,o)}else this.map=new Map,this.toKey=n??M.defaultToKey}set(n,i){return this.map.set(this.toKey(n),new L(n,i)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[s,o]of this.map)n(o.value,o.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(p=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=M;class w{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this._map=new M(n):(this._map=new M(i),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,i){this._map.forEach((s,o)=>n.call(i,o,o,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=w;var D;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(D||(e.Touch=D={}));class k{constructor(){this[$]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,i=D.None){const s=this._map.get(n);if(s)return i!==D.None&&this.touch(s,i),s.value}set(n,i,s=D.None){let o=this._map.get(n);if(o)o.value=i,s!==D.None&&this.touch(o,s);else{switch(o={key:n,value:i,next:void 0,previous:void 0},s){case D.None:this.addItemLast(o);break;case D.AsOld:this.addItemFirst(o);break;case D.AsNew:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this._map.get(n);if(i)return this._map.delete(n),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,i){const s=this._state;let o=this._head;for(;o;){if(i?n.bind(i)(o.value,o.key,this):n(o.value,o.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,i=this._state;let s=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const U={value:s.key,done:!1};return s=s.next,U}else return{value:void 0,done:!0}}};return o}values(){const n=this,i=this._state;let s=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const U={value:s.value,done:!1};return s=s.next,U}else return{value:void 0,done:!0}}};return o}entries(){const n=this,i=this._state;let s=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const U={value:[s.key,s.value],done:!1};return s=s.next,U}else return{value:void 0,done:!0}}};return o}[($=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>n;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}trimNew(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._tail,s=this.size;for(;i&&s>n;)this._map.delete(i.key),i=i.previous,s--;this._tail=i,this._size=s,i&&(i.next=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const i=n.next,s=n.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}n.next=void 0,n.previous=void 0,this._state++}touch(n,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==D.AsOld&&i!==D.AsNew)){if(i===D.AsOld){if(n===this._head)return;const s=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(s.previous=o,o.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(i===D.AsNew){if(n===this._tail)return;const s=n.next,o=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=o,o.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((i,s)=>{n.push([s,i])}),n}fromJSON(n){this.clear();for(const[i,s]of n)this.set(i,s)}}e.LinkedMap=k;class a extends k{constructor(n,i=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,i=D.AsNew){return super.get(n,i)}peek(n){return super.get(n,D.None)}set(n,i){return super.set(n,i,D.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class r extends a{constructor(n,i=1){super(n,i)}trim(n){this.trimOld(n)}set(n,i){return super.set(n,i),this.checkTrim(),this}}e.LRUCache=r;class f extends a{constructor(n,i=1){super(n,i)}trim(n){this.trimNew(n)}set(n,i){return this._limit<=this.size&&!this.has(n)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(n,i),this}}e.MRUCache=f;class b{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let i=this.map.get(n)||0;return i===0?!1:(i--,i===0?this.map.delete(n):this.map.set(n,i),!0)}has(n){return this.map.has(n)}}e.CounterSet=b;class u{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[i,s]of n)this.set(i,s)}clear(){this._m1.clear(),this._m2.clear()}set(n,i){this._m1.set(n,i),this._m2.set(i,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const i=this._m1.get(n);return i===void 0?!1:(this._m1.delete(n),this._m2.delete(i),!0)}forEach(n,i){this._m1.forEach((s,o)=>{n.call(i,s,o,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=u;class y{constructor(){this.map=new Map}add(n,i){let s=this.map.get(n);s||(s=new Set,this.map.set(n,s)),s.add(i)}delete(n,i){const s=this.map.get(n);s&&(s.delete(i),s.size===0&&this.map.delete(n))}forEach(n,i){const s=this.map.get(n);s&&s.forEach(i)}get(n){const i=this.map.get(n);return i||new Set}}e.SetMap=y;function v(l,n){if(l===n)return!0;if(l.size!==n.size)return!1;for(const[i,s]of l)if(!n.has(i)||n.get(i)!==s)return!1;for(const[i]of n)if(!l.has(i))return!1;return!0}}),define(Ee[4],pe([0,1,12,38,20,26,40]),function(ce,e,p,t,$,q,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=M,e.trackDisposable=w,e.markAsDisposed=D,e.markAsSingleton=r,e.isDisposable=f,e.dispose=b,e.disposeIfDisposable=u,e.combinedDisposable=y,e.toDisposable=v,e.disposeOnReturn=d;const N=!1;let L=null;class T{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(A){let j=this.livingDisposables.get(A);return j||(j={parent:null,source:null,isSingleton:!1,value:A,idx:T.idx++},this.livingDisposables.set(A,j)),j}trackDisposable(A){const j=this.getDisposableData(A);j.source||(j.source=new Error().stack)}setParent(A,j){const Z=this.getDisposableData(A);Z.parent=j}markAsDisposed(A){this.livingDisposables.delete(A)}markAsSingleton(A){this.getDisposableData(A).isSingleton=!0}getRootParent(A,j){const Z=j.get(A);if(Z)return Z;const x=A.parent?this.getRootParent(this.getDisposableData(A.parent),j):A;return j.set(A,x),x}getTrackedDisposables(){const A=new Map;return[...this.livingDisposables.entries()].filter(([,Z])=>Z.source!==null&&!this.getRootParent(Z,A).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(A=10,j){let Z;if(j)Z=j;else{const ie=new Map,oe=[...this.livingDisposables.values()].filter(I=>I.source!==null&&!this.getRootParent(I,ie).isSingleton);if(oe.length===0)return;const re=new Set(oe.map(I=>I.value));if(Z=oe.filter(I=>!(I.parent&&re.has(I.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function x(ie){function oe(I,_){for(;I.length>0&&_.some(O=>typeof O=="string"?O===I[0]:I[0].match(O));)I.shift()}const re=ie.source.split(`
`).map(I=>I.trim().replace("at ","")).filter(I=>I!=="");return oe(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const H=new $.SetMap;for(const ie of Z){const oe=x(ie);for(let re=0;re<=oe.length;re++)H.add(oe.slice(0,re).join(`
`),ie)}Z.sort((0,p.compareBy)(ie=>ie.idx,p.numberComparator));let se="",K=0;for(const ie of Z.slice(0,A)){K++;const oe=x(ie),re=[];for(let I=0;I<oe.length;I++){let _=oe[I];_=`(shared with ${H.get(oe.slice(0,I+1).join(`
`)).size}/${Z.length} leaks) at ${_}`;const C=H.get(oe.slice(0,I).join(`
`)),Y=(0,t.groupBy)([...C].map(R=>x(R)[I]),R=>R);delete Y[oe[I]];for(const[R,X]of Object.entries(Y))re.unshift(`    - stacktraces of ${X.length} other leaks continue with ${R}`);re.unshift(_)}se+=`


==================== Leaking disposable ${K}/${Z.length}: ${ie.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return Z.length>A&&(se+=`


... and ${Z.length-A} more leaking disposables

`),{leaks:Z,details:se}}}e.DisposableTracker=T;function M(c){L=c}if(N){const c="__is_disposable_tracked__";M(new class{trackDisposable(A){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[c]||console.log(j)},3e3)}setParent(A,j){if(A&&A!==n.None)try{A[c]=!0}catch{}}markAsDisposed(A){if(A&&A!==n.None)try{A[c]=!0}catch{}}markAsSingleton(A){}})}function w(c){return L?.trackDisposable(c),c}function D(c){L?.markAsDisposed(c)}function k(c,A){L?.setParent(c,A)}function a(c,A){if(L)for(const j of c)L.setParent(j,A)}function r(c){return L?.markAsSingleton(c),c}function f(c){return typeof c=="object"&&c!==null&&typeof c.dispose=="function"&&c.dispose.length===0}function b(c){if(V.Iterable.is(c)){const A=[];for(const j of c)if(j)try{j.dispose()}catch(Z){A.push(Z)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}function u(c){for(const A of c)f(A)&&A.dispose();return[]}function y(...c){const A=v(()=>b(c));return a(c,A),A}function v(c){const A=w({dispose:(0,q.createSingleCallFunction)(()=>{D(A),c()})});return A}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{b(this._toDispose)}finally{this._toDispose.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return k(A,this),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(A),A.dispose()}}deleteAndLeak(A){A&&this._toDispose.has(A)&&(this._toDispose.delete(A),k(A,null))}}e.DisposableStore=l;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new l,w(this),k(this._store,this)}dispose(){D(this),this._store.dispose()}_register(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(A)}}e.Disposable=n;class i{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(A){this._isDisposed||A===this._value||(this._value?.dispose(),A&&k(A,this),this._value=A)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const A=this._value;return this._value=void 0,A&&k(A,null),A}}e.MutableDisposable=i;class s{constructor(A){this._disposable=new i,this._isDisposed=!1,this._disposable.value=A}get value(){return this._disposable.value}set value(A){this._isDisposed||A===this._disposable.value||(this._disposable.value=A)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class o{constructor(A){this._disposable=A,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class U{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(A){let j=A;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,D(this))},this}}e.SafeDisposable=U;class m{constructor(){this.references=new Map}acquire(A,...j){let Z=this.references.get(A);Z||(Z={counter:0,object:this.createReferencedObject(A,...j)},this.references.set(A,Z));const{object:x}=Z,H=(0,q.createSingleCallFunction)(()=>{--Z.counter===0&&(this.destroyReferencedObject(A,Z.object),this.references.delete(A))});return Z.counter++,{object:x,dispose:H}}}e.ReferenceCollection=m;class E{constructor(A){this.referenceCollection=A}async acquire(A,...j){const Z=this.referenceCollection.acquire(A,...j);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(x){throw Z.dispose(),x}}}e.AsyncReferenceCollection=E;class h{constructor(A){this.object=A}dispose(){}}e.ImmortalReference=h;function d(c){const A=new l;try{c(A)}finally{A.dispose()}}class F{constructor(){this._store=new Map,this._isDisposed=!1,w(this)}dispose(){D(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{b(this._store.values())}finally{this._store.clear()}}has(A){return this._store.has(A)}get size(){return this._store.size}get(A){return this._store.get(A)}set(A,j,Z=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this._store.get(A)?.dispose(),this._store.set(A,j)}deleteAndDispose(A){this._store.get(A)?.dispose(),this._store.delete(A)}deleteAndLeak(A){const j=this._store.get(A);return this._store.delete(A),j}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=F}),define(Ee[27],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var p;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(p||(e.MarshalledId=p={}))}),define(Ee[21],pe([0,1,20]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=$,e.normalizeNFD=V;const t=new p.LRUCache(1e4);function $(T){return L(T,"NFC",t)}const q=new p.LRUCache(1e4);function V(T){return L(T,"NFD",q)}const N=/[^\u0000-\u0080]/;function L(T,M,w){if(!T)return T;const D=w.get(T);if(D)return D;let k;return N.test(T)?k=T.normalize(M):k=T,w.set(T,k),k}e.removeAccents=function(){const T=/[\u0300-\u036f]/g;return function(M){return V(M).replace(T,"")}}()}),define(Ee[2],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=n,e.isLittleEndian=E,e.isBigSurOrNewer=h,e.LANGUAGE_DEFAULT="en";let p=!1,t=!1,$=!1,q=!1,V=!1,N=!1,L=!1,T=!1,M=!1,w=!1,D,k=e.LANGUAGE_DEFAULT,a=e.LANGUAGE_DEFAULT,r,f;const b=globalThis;let u;typeof b.vscode<"u"&&typeof b.vscode.process<"u"?u=b.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(u=process);const y=typeof u?.versions?.electron=="string",v=y&&u?.type==="renderer";if(typeof u=="object"){p=u.platform==="win32",t=u.platform==="darwin",$=u.platform==="linux",q=$&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,L=y,M=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,D=e.LANGUAGE_DEFAULT,k=e.LANGUAGE_DEFAULT;const d=u.env.VSCODE_NLS_CONFIG;if(d)try{const F=JSON.parse(d);D=F.userLocale,a=F.osLocale,k=F.resolvedLanguage||e.LANGUAGE_DEFAULT,r=F.languagePack?.translationsConfigFile}catch{}V=!0}else typeof navigator=="object"&&!v?(f=navigator.userAgent,p=f.indexOf("Windows")>=0,t=f.indexOf("Macintosh")>=0,T=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,$=f.indexOf("Linux")>=0,w=f?.indexOf("Mobi")>=0,N=!0,k=globalThis._VSCODE_NLS_LANGUAGE||e.LANGUAGE_DEFAULT,D=navigator.language.toLowerCase(),a=D):console.error("Unable to resolve platform.");var l;(function(d){d[d.Web=0]="Web",d[d.Mac=1]="Mac",d[d.Linux=2]="Linux",d[d.Windows=3]="Windows"})(l||(e.Platform=l={}));function n(d){switch(d){case l.Web:return"Web";case l.Mac:return"Mac";case l.Linux:return"Linux";case l.Windows:return"Windows"}}let i=l.Web;t?i=l.Mac:p?i=l.Windows:$&&(i=l.Linux),e.isWindows=p,e.isMacintosh=t,e.isLinux=$,e.isLinuxSnap=q,e.isNative=V,e.isElectron=L,e.isWeb=N,e.isWebWorker=N&&typeof b.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?b.origin:void 0,e.isIOS=T,e.isMobile=w,e.isCI=M,e.platform=i,e.userAgent=f,e.language=k;var s;(function(d){function F(){return e.language}d.value=F;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}d.isDefaultVariant=c;function A(){return e.language==="en"}d.isDefault=A})(s||(e.Language=s={})),e.locale=D,e.platformLocale=a,e.translationsConfigFile=r,e.setTimeout0IsFaster=typeof b.postMessage=="function"&&!b.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const d=[];b.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let A=0,j=d.length;A<j;A++){const Z=d[A];if(Z.id===c.data.vscodeScheduleAsyncWork){d.splice(A,1),Z.callback();return}}});let F=0;return c=>{const A=++F;d.push({id:A,callback:c}),b.postMessage({vscodeScheduleAsyncWork:A},"*")}}return d=>setTimeout(d)})();var o;(function(d){d[d.Windows=1]="Windows",d[d.Macintosh=2]="Macintosh",d[d.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=t||T?o.Macintosh:p?o.Windows:o.Linux;let U=!0,m=!1;function E(){if(!m){m=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,U=new Uint16Array(d.buffer)[0]===513}return U}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function h(d){return parseFloat(d)>=20}}),define(Ee[28],pe([0,1,2]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;const $=globalThis.vscode;if(typeof $<"u"&&typeof $.process<"u"){const q=$.process;t={get platform(){return q.platform},get arch(){return q.arch},get env(){return q.env},cwd(){return q.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch});var Qe=this&&this.__createBinding||(Object.create?function(ce,e,p,t){t===void 0&&(t=p);var $=Object.getOwnPropertyDescriptor(e,p);(!$||("get"in $?!e.__esModule:$.writable||$.configurable))&&($={enumerable:!0,get:function(){return e[p]}}),Object.defineProperty(ce,t,$)}:function(ce,e,p,t){t===void 0&&(t=p),ce[t]=e[p]}),Ye=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),Ie=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var p in ce)p!=="default"&&Object.prototype.hasOwnProperty.call(ce,p)&&Qe(e,ce,p);return Ye(e,ce),e};define(Ee[3],pe([0,1,28]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,p=Ie(p);const t=65,$=97,q=90,V=122,N=46,L=47,T=92,M=58,w=63;class D extends Error{constructor(s,o,U){let m;typeof o=="string"&&o.indexOf("not ")===0?(m="must not be",o=o.replace(/^not /,"")):m="must be";const E=s.indexOf(".")!==-1?"property":"argument";let h=`The "${s}" ${E} ${m} of type ${o}`;h+=`. Received type ${typeof U}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function k(i,s){if(i===null||typeof i!="object")throw new D(s,"Object",i)}function a(i,s){if(typeof i!="string")throw new D(s,"string",i)}const r=p.platform==="win32";function f(i){return i===L||i===T}function b(i){return i===L}function u(i){return i>=t&&i<=q||i>=$&&i<=V}function y(i,s,o,U){let m="",E=0,h=-1,d=0,F=0;for(let c=0;c<=i.length;++c){if(c<i.length)F=i.charCodeAt(c);else{if(U(F))break;F=L}if(U(F)){if(!(h===c-1||d===1))if(d===2){if(m.length<2||E!==2||m.charCodeAt(m.length-1)!==N||m.charCodeAt(m.length-2)!==N){if(m.length>2){const A=m.lastIndexOf(o);A===-1?(m="",E=0):(m=m.slice(0,A),E=m.length-1-m.lastIndexOf(o)),h=c,d=0;continue}else if(m.length!==0){m="",E=0,h=c,d=0;continue}}s&&(m+=m.length>0?`${o}..`:"..",E=2)}else m.length>0?m+=`${o}${i.slice(h+1,c)}`:m=i.slice(h+1,c),E=c-h-1;h=c,d=0}else F===N&&d!==-1?++d:d=-1}return m}function v(i){return i?`${i[0]==="."?"":"."}${i}`:""}function l(i,s){k(s,"pathObject");const o=s.dir||s.root,U=s.base||`${s.name||""}${v(s.ext)}`;return o?o===s.root?`${o}${U}`:`${o}${i}${U}`:U}e.win32={resolve(...i){let s="",o="",U=!1;for(let m=i.length-1;m>=-1;m--){let E;if(m>=0){if(E=i[m],a(E,`paths[${m}]`),E.length===0)continue}else s.length===0?E=p.cwd():(E=p.env[`=${s}`]||p.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==s.toLowerCase()&&E.charCodeAt(2)===T)&&(E=`${s}\\`));const h=E.length;let d=0,F="",c=!1;const A=E.charCodeAt(0);if(h===1)f(A)&&(d=1,c=!0);else if(f(A))if(c=!0,f(E.charCodeAt(1))){let j=2,Z=j;for(;j<h&&!f(E.charCodeAt(j));)j++;if(j<h&&j!==Z){const x=E.slice(Z,j);for(Z=j;j<h&&f(E.charCodeAt(j));)j++;if(j<h&&j!==Z){for(Z=j;j<h&&!f(E.charCodeAt(j));)j++;(j===h||j!==Z)&&(F=`\\\\${x}\\${E.slice(Z,j)}`,d=j)}}}else d=1;else u(A)&&E.charCodeAt(1)===M&&(F=E.slice(0,2),d=2,h>2&&f(E.charCodeAt(2))&&(c=!0,d=3));if(F.length>0)if(s.length>0){if(F.toLowerCase()!==s.toLowerCase())continue}else s=F;if(U){if(s.length>0)break}else if(o=`${E.slice(d)}\\${o}`,U=c,c&&s.length>0)break}return o=y(o,!U,"\\",f),U?`${s}\\${o}`:`${s}${o}`||"."},normalize(i){a(i,"path");const s=i.length;if(s===0)return".";let o=0,U,m=!1;const E=i.charCodeAt(0);if(s===1)return b(E)?"\\":i;if(f(E))if(m=!0,f(i.charCodeAt(1))){let d=2,F=d;for(;d<s&&!f(i.charCodeAt(d));)d++;if(d<s&&d!==F){const c=i.slice(F,d);for(F=d;d<s&&f(i.charCodeAt(d));)d++;if(d<s&&d!==F){for(F=d;d<s&&!f(i.charCodeAt(d));)d++;if(d===s)return`\\\\${c}\\${i.slice(F)}\\`;d!==F&&(U=`\\\\${c}\\${i.slice(F,d)}`,o=d)}}}else o=1;else u(E)&&i.charCodeAt(1)===M&&(U=i.slice(0,2),o=2,s>2&&f(i.charCodeAt(2))&&(m=!0,o=3));let h=o<s?y(i.slice(o),!m,"\\",f):"";return h.length===0&&!m&&(h="."),h.length>0&&f(i.charCodeAt(s-1))&&(h+="\\"),U===void 0?m?`\\${h}`:h:m?`${U}\\${h}`:`${U}${h}`},isAbsolute(i){a(i,"path");const s=i.length;if(s===0)return!1;const o=i.charCodeAt(0);return f(o)||s>2&&u(o)&&i.charCodeAt(1)===M&&f(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,o;for(let E=0;E<i.length;++E){const h=i[E];a(h,"path"),h.length>0&&(s===void 0?s=o=h:s+=`\\${h}`)}if(s===void 0)return".";let U=!0,m=0;if(typeof o=="string"&&f(o.charCodeAt(0))){++m;const E=o.length;E>1&&f(o.charCodeAt(1))&&(++m,E>2&&(f(o.charCodeAt(2))?++m:U=!1))}if(U){for(;m<s.length&&f(s.charCodeAt(m));)m++;m>=2&&(s=`\\${s.slice(m)}`)}return e.win32.normalize(s)},relative(i,s){if(a(i,"from"),a(s,"to"),i===s)return"";const o=e.win32.resolve(i),U=e.win32.resolve(s);if(o===U||(i=o.toLowerCase(),s=U.toLowerCase(),i===s))return"";let m=0;for(;m<i.length&&i.charCodeAt(m)===T;)m++;let E=i.length;for(;E-1>m&&i.charCodeAt(E-1)===T;)E--;const h=E-m;let d=0;for(;d<s.length&&s.charCodeAt(d)===T;)d++;let F=s.length;for(;F-1>d&&s.charCodeAt(F-1)===T;)F--;const c=F-d,A=h<c?h:c;let j=-1,Z=0;for(;Z<A;Z++){const H=i.charCodeAt(m+Z);if(H!==s.charCodeAt(d+Z))break;H===T&&(j=Z)}if(Z!==A){if(j===-1)return U}else{if(c>A){if(s.charCodeAt(d+Z)===T)return U.slice(d+Z+1);if(Z===2)return U.slice(d+Z)}h>A&&(i.charCodeAt(m+Z)===T?j=Z:Z===2&&(j=3)),j===-1&&(j=0)}let x="";for(Z=m+j+1;Z<=E;++Z)(Z===E||i.charCodeAt(Z)===T)&&(x+=x.length===0?"..":"\\..");return d+=j,x.length>0?`${x}${U.slice(d,F)}`:(U.charCodeAt(d)===T&&++d,U.slice(d,F))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===T){if(s.charCodeAt(1)===T){const o=s.charCodeAt(2);if(o!==w&&o!==N)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(u(s.charCodeAt(0))&&s.charCodeAt(1)===M&&s.charCodeAt(2)===T)return`\\\\?\\${s}`;return i},dirname(i){a(i,"path");const s=i.length;if(s===0)return".";let o=-1,U=0;const m=i.charCodeAt(0);if(s===1)return f(m)?i:".";if(f(m)){if(o=U=1,f(i.charCodeAt(1))){let d=2,F=d;for(;d<s&&!f(i.charCodeAt(d));)d++;if(d<s&&d!==F){for(F=d;d<s&&f(i.charCodeAt(d));)d++;if(d<s&&d!==F){for(F=d;d<s&&!f(i.charCodeAt(d));)d++;if(d===s)return i;d!==F&&(o=U=d+1)}}}}else u(m)&&i.charCodeAt(1)===M&&(o=s>2&&f(i.charCodeAt(2))?3:2,U=o);let E=-1,h=!0;for(let d=s-1;d>=U;--d)if(f(i.charCodeAt(d))){if(!h){E=d;break}}else h=!1;if(E===-1){if(o===-1)return".";E=o}return i.slice(0,E)},basename(i,s){s!==void 0&&a(s,"suffix"),a(i,"path");let o=0,U=-1,m=!0,E;if(i.length>=2&&u(i.charCodeAt(0))&&i.charCodeAt(1)===M&&(o=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let h=s.length-1,d=-1;for(E=i.length-1;E>=o;--E){const F=i.charCodeAt(E);if(f(F)){if(!m){o=E+1;break}}else d===-1&&(m=!1,d=E+1),h>=0&&(F===s.charCodeAt(h)?--h===-1&&(U=E):(h=-1,U=d))}return o===U?U=d:U===-1&&(U=i.length),i.slice(o,U)}for(E=i.length-1;E>=o;--E)if(f(i.charCodeAt(E))){if(!m){o=E+1;break}}else U===-1&&(m=!1,U=E+1);return U===-1?"":i.slice(o,U)},extname(i){a(i,"path");let s=0,o=-1,U=0,m=-1,E=!0,h=0;i.length>=2&&i.charCodeAt(1)===M&&u(i.charCodeAt(0))&&(s=U=2);for(let d=i.length-1;d>=s;--d){const F=i.charCodeAt(d);if(f(F)){if(!E){U=d+1;break}continue}m===-1&&(E=!1,m=d+1),F===N?o===-1?o=d:h!==1&&(h=1):o!==-1&&(h=-1)}return o===-1||m===-1||h===0||h===1&&o===m-1&&o===U+1?"":i.slice(o,m)},format:l.bind(null,"\\"),parse(i){a(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const o=i.length;let U=0,m=i.charCodeAt(0);if(o===1)return f(m)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(f(m)){if(U=1,f(i.charCodeAt(1))){let j=2,Z=j;for(;j<o&&!f(i.charCodeAt(j));)j++;if(j<o&&j!==Z){for(Z=j;j<o&&f(i.charCodeAt(j));)j++;if(j<o&&j!==Z){for(Z=j;j<o&&!f(i.charCodeAt(j));)j++;j===o?U=j:j!==Z&&(U=j+1)}}}}else if(u(m)&&i.charCodeAt(1)===M){if(o<=2)return s.root=s.dir=i,s;if(U=2,f(i.charCodeAt(2))){if(o===3)return s.root=s.dir=i,s;U=3}}U>0&&(s.root=i.slice(0,U));let E=-1,h=U,d=-1,F=!0,c=i.length-1,A=0;for(;c>=U;--c){if(m=i.charCodeAt(c),f(m)){if(!F){h=c+1;break}continue}d===-1&&(F=!1,d=c+1),m===N?E===-1?E=c:A!==1&&(A=1):E!==-1&&(A=-1)}return d!==-1&&(E===-1||A===0||A===1&&E===d-1&&E===h+1?s.base=s.name=i.slice(h,d):(s.name=i.slice(h,E),s.base=i.slice(h,d),s.ext=i.slice(E,d))),h>0&&h!==U?s.dir=i.slice(0,h-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const n=(()=>{if(r){const i=/\\/g;return()=>{const s=p.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>p.cwd()})();e.posix={resolve(...i){let s="",o=!1;for(let U=i.length-1;U>=-1&&!o;U--){const m=U>=0?i[U]:n();a(m,`paths[${U}]`),m.length!==0&&(s=`${m}/${s}`,o=m.charCodeAt(0)===L)}return s=y(s,!o,"/",b),o?`/${s}`:s.length>0?s:"."},normalize(i){if(a(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===L,o=i.charCodeAt(i.length-1)===L;return i=y(i,!s,"/",b),i.length===0?s?"/":o?"./":".":(o&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return a(i,"path"),i.length>0&&i.charCodeAt(0)===L},join(...i){if(i.length===0)return".";let s;for(let o=0;o<i.length;++o){const U=i[o];a(U,"path"),U.length>0&&(s===void 0?s=U:s+=`/${U}`)}return s===void 0?".":e.posix.normalize(s)},relative(i,s){if(a(i,"from"),a(s,"to"),i===s||(i=e.posix.resolve(i),s=e.posix.resolve(s),i===s))return"";const o=1,U=i.length,m=U-o,E=1,h=s.length-E,d=m<h?m:h;let F=-1,c=0;for(;c<d;c++){const j=i.charCodeAt(o+c);if(j!==s.charCodeAt(E+c))break;j===L&&(F=c)}if(c===d)if(h>d){if(s.charCodeAt(E+c)===L)return s.slice(E+c+1);if(c===0)return s.slice(E+c)}else m>d&&(i.charCodeAt(o+c)===L?F=c:c===0&&(F=0));let A="";for(c=o+F+1;c<=U;++c)(c===U||i.charCodeAt(c)===L)&&(A+=A.length===0?"..":"/..");return`${A}${s.slice(E+F)}`},toNamespacedPath(i){return i},dirname(i){if(a(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===L;let o=-1,U=!0;for(let m=i.length-1;m>=1;--m)if(i.charCodeAt(m)===L){if(!U){o=m;break}}else U=!1;return o===-1?s?"/":".":s&&o===1?"//":i.slice(0,o)},basename(i,s){s!==void 0&&a(s,"ext"),a(i,"path");let o=0,U=-1,m=!0,E;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let h=s.length-1,d=-1;for(E=i.length-1;E>=0;--E){const F=i.charCodeAt(E);if(F===L){if(!m){o=E+1;break}}else d===-1&&(m=!1,d=E+1),h>=0&&(F===s.charCodeAt(h)?--h===-1&&(U=E):(h=-1,U=d))}return o===U?U=d:U===-1&&(U=i.length),i.slice(o,U)}for(E=i.length-1;E>=0;--E)if(i.charCodeAt(E)===L){if(!m){o=E+1;break}}else U===-1&&(m=!1,U=E+1);return U===-1?"":i.slice(o,U)},extname(i){a(i,"path");let s=-1,o=0,U=-1,m=!0,E=0;for(let h=i.length-1;h>=0;--h){const d=i.charCodeAt(h);if(d===L){if(!m){o=h+1;break}continue}U===-1&&(m=!1,U=h+1),d===N?s===-1?s=h:E!==1&&(E=1):s!==-1&&(E=-1)}return s===-1||U===-1||E===0||E===1&&s===U-1&&s===o+1?"":i.slice(s,U)},format:l.bind(null,"/"),parse(i){a(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const o=i.charCodeAt(0)===L;let U;o?(s.root="/",U=1):U=0;let m=-1,E=0,h=-1,d=!0,F=i.length-1,c=0;for(;F>=U;--F){const A=i.charCodeAt(F);if(A===L){if(!d){E=F+1;break}continue}h===-1&&(d=!1,h=F+1),A===N?m===-1?m=F:c!==1&&(c=1):m!==-1&&(c=-1)}if(h!==-1){const A=E===0&&o?1:E;m===-1||c===0||c===1&&m===h-1&&m===E+1?s.base=s.name=i.slice(A,h):(s.name=i.slice(A,m),s.base=i.slice(A,h),s.ext=i.slice(m,h))}return E>0?s.dir=i.slice(0,E-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=r?e.win32.normalize:e.posix.normalize,e.isAbsolute=r?e.win32.isAbsolute:e.posix.isAbsolute,e.join=r?e.win32.join:e.posix.join,e.resolve=r?e.win32.resolve:e.posix.resolve,e.relative=r?e.win32.relative:e.posix.relative,e.dirname=r?e.win32.dirname:e.posix.dirname,e.basename=r?e.win32.basename:e.posix.basename,e.extname=r?e.win32.extname:e.posix.extname,e.format=r?e.win32.format:e.posix.format,e.parse=r?e.win32.parse:e.posix.parse,e.toNamespacedPath=r?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=r?e.win32.sep:e.posix.sep,e.delimiter=r?e.win32.delimiter:e.posix.delimiter}),define(Ee[29],pe([0,1,2]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=q,e.removeDangerousEnvVariables=V;var t;(function(N){N[N.stdout=0]="stdout",N[N.stderr=1]="stderr"})(t||(e.Source=t={}));var $;(function(N){N[N.Success=0]="Success",N[N.Unknown=1]="Unknown",N[N.AccessDenied=2]="AccessDenied",N[N.ProcessNotFound=3]="ProcessNotFound"})($||(e.TerminateResponseCode=$={}));function q(N,...L){const T=L.reduce((D,k)=>(D[k]=!0,D),{}),M=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(N).filter(D=>!T[D]).forEach(D=>{for(let k=0;k<M.length;k++)if(D.search(M[k])!==-1){delete N[D];break}})}function V(N){N&&(delete N.DEBUG,p.isLinux&&delete N.LD_PRELOAD)}}),define(Ee[42],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const p=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(q){return new t(q)}constructor(q){this._now=p&&q===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=t}),define(Ee[6],pe([0,1,9,26,4,41,42]),function(ce,e,p,t,$,q,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=k;const N=!1,L=!1,T=!1;var M;(function(x){x.None=()=>$.Disposable.None;function H(fe){if(T){const{onDidAddListener:ue}=fe,_e=r.create();let de=0;fe.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_e.print()),ue?.()}}}function se(fe,ue){return R(fe,()=>{},0,void 0,!0,void 0,ue)}x.defer=se;function K(fe){return(ue,_e=null,de)=>{let be=!1,Ae;return Ae=fe(Le=>{if(!be)return Ae?Ae.dispose():be=!0,ue.call(_e,Le)},null,de),be&&Ae.dispose(),Ae}}x.once=K;function ie(fe,ue,_e){return C((de,be=null,Ae)=>fe(Le=>de.call(be,ue(Le)),null,Ae),_e)}x.map=ie;function oe(fe,ue,_e){return C((de,be=null,Ae)=>fe(Le=>{ue(Le),de.call(be,Le)},null,Ae),_e)}x.forEach=oe;function re(fe,ue,_e){return C((de,be=null,Ae)=>fe(Le=>ue(Le)&&de.call(be,Le),null,Ae),_e)}x.filter=re;function I(fe){return fe}x.signal=I;function _(...fe){return(ue,_e=null,de)=>{const be=(0,$.combinedDisposable)(...fe.map(Ae=>Ae(Le=>ue.call(_e,Le))));return Y(be,de)}}x.any=_;function O(fe,ue,_e,de){let be=_e;return ie(fe,Ae=>(be=ue(be,Ae),be),de)}x.reduce=O;function C(fe,ue){let _e;const de={onWillAddFirstListener(){_e=fe(be.fire,be)},onDidRemoveLastListener(){_e?.dispose()}};ue||H(de);const be=new i(de);return ue?.add(be),be.event}function Y(fe,ue){return ue instanceof Array?ue.push(fe):ue&&ue.add(fe),fe}function R(fe,ue,_e=100,de=!1,be=!1,Ae,Le){let Se,Te,ke,ve=0,Ue;const ze={leakWarningThreshold:Ae,onWillAddFirstListener(){Se=fe(He=>{ve++,Te=ue(Te,He),de&&!ke&&(Be.fire(Te),Te=void 0),Ue=()=>{const Ke=Te;Te=void 0,ke=void 0,(!de||ve>1)&&Be.fire(Ke),ve=0},typeof _e=="number"?(clearTimeout(ke),ke=setTimeout(Ue,_e)):ke===void 0&&(ke=0,queueMicrotask(Ue))})},onWillRemoveListener(){be&&ve>0&&Ue?.()},onDidRemoveLastListener(){Ue=void 0,Se.dispose()}};Le||H(ze);const Be=new i(ze);return Le?.add(Be),Be.event}x.debounce=R;function X(fe,ue=0,_e){return x.debounce(fe,(de,be)=>de?(de.push(be),de):[be],ue,void 0,!0,void 0,_e)}x.accumulate=X;function ee(fe,ue=(de,be)=>de===be,_e){let de=!0,be;return re(fe,Ae=>{const Le=de||!ue(Ae,be);return de=!1,be=Ae,Le},_e)}x.latch=ee;function ne(fe,ue,_e){return[x.filter(fe,ue,_e),x.filter(fe,de=>!ue(de),_e)]}x.split=ne;function le(fe,ue=!1,_e=[],de){let be=_e.slice(),Ae=fe(Te=>{be?be.push(Te):Se.fire(Te)});de&&de.add(Ae);const Le=()=>{be?.forEach(Te=>Se.fire(Te)),be=null},Se=new i({onWillAddFirstListener(){Ae||(Ae=fe(Te=>Se.fire(Te)),de&&de.add(Ae))},onDidAddFirstListener(){be&&(ue?setTimeout(Le):Le())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return de&&de.add(Se),Se.event}x.buffer=le;function he(fe,ue){return(de,be,Ae)=>{const Le=ue(new B);return fe(function(Se){const Te=Le.evaluate(Se);Te!==we&&de.call(be,Te)},void 0,Ae)}}x.chain=he;const we=Symbol("HaltChainable");class B{constructor(){this.steps=[]}map(ue){return this.steps.push(ue),this}forEach(ue){return this.steps.push(_e=>(ue(_e),_e)),this}filter(ue){return this.steps.push(_e=>ue(_e)?_e:we),this}reduce(ue,_e){let de=_e;return this.steps.push(be=>(de=ue(de,be),de)),this}latch(ue=(_e,de)=>_e===de){let _e=!0,de;return this.steps.push(be=>{const Ae=_e||!ue(be,de);return _e=!1,de=be,Ae?be:we}),this}evaluate(ue){for(const _e of this.steps)if(ue=_e(ue),ue===we)break;return ue}}function z(fe,ue,_e=de=>de){const de=(...Se)=>Le.fire(_e(...Se)),be=()=>fe.on(ue,de),Ae=()=>fe.removeListener(ue,de),Le=new i({onWillAddFirstListener:be,onDidRemoveLastListener:Ae});return Le.event}x.fromNodeEventEmitter=z;function P(fe,ue,_e=de=>de){const de=(...Se)=>Le.fire(_e(...Se)),be=()=>fe.addEventListener(ue,de),Ae=()=>fe.removeEventListener(ue,de),Le=new i({onWillAddFirstListener:be,onDidRemoveLastListener:Ae});return Le.event}x.fromDOMEventEmitter=P;function g(fe){return new Promise(ue=>K(fe)(ue))}x.toPromise=g;function W(fe){const ue=new i;return fe.then(_e=>{ue.fire(_e)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}x.fromPromise=W;function Q(fe,ue){return fe(_e=>ue.fire(_e))}x.forward=Q;function te(fe,ue,_e){return ue(_e),fe(de=>ue(de))}x.runAndSubscribe=te;class ge{constructor(ue,_e){this._observable=ue,this._counter=0,this._hasChanged=!1;const de={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};_e||H(de),this.emitter=new i(de),_e&&_e.add(this.emitter)}beginUpdate(ue){this._counter++}handlePossibleChange(ue){}handleChange(ue,_e){this._hasChanged=!0}endUpdate(ue){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ye(fe,ue){return new ge(fe,ue).emitter.event}x.fromObservable=ye;function Re(fe){return(ue,_e,de)=>{let be=0,Ae=!1;const Le={beginUpdate(){be++},endUpdate(){be--,be===0&&(fe.reportChanges(),Ae&&(Ae=!1,ue.call(_e)))},handlePossibleChange(){},handleChange(){Ae=!0}};fe.addObserver(Le),fe.reportChanges();const Se={dispose(){fe.removeObserver(Le)}};return de instanceof $.DisposableStore?de.add(Se):Array.isArray(de)&&de.push(Se),Se}}x.fromObservableLight=Re})(M||(e.Event=M={}));class w{static{this.all=new Set}static{this._idPool=0}constructor(H){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${H}_${w._idPool++}`,w.all.add(this)}start(H){this._stopWatch=new V.StopWatch,this.listenerCount=H}stop(){if(this._stopWatch){const H=this._stopWatch.elapsed();this.durations.push(H),this.elapsedOverall+=H,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=w;let D=-1;function k(x){const H=D;return D=x,{dispose(){D=H}}}class a{static{this._idPool=1}constructor(H,se,K=(a._idPool++).toString(16).padStart(3,"0")){this._errorHandler=H,this.threshold=se,this.name=K,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(H,se){const K=this.threshold;if(K<=0||se<K)return;this._stacks||(this._stacks=new Map);const ie=this._stacks.get(H.value)||0;if(this._stacks.set(H.value,ie+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=K*.5;const[oe,re]=this.getMostFrequentStack(),I=`[${this.name}] potential listener LEAK detected, having ${se} listeners already. MOST frequent listener (${re}):`;console.warn(I),console.warn(oe);const _=new f(I,oe);this._errorHandler(_)}return()=>{const oe=this._stacks.get(H.value)||0;this._stacks.set(H.value,oe-1)}}getMostFrequentStack(){if(!this._stacks)return;let H,se=0;for(const[K,ie]of this._stacks)(!H||se<ie)&&(H=[K,ie],se=ie);return H}}class r{static create(){const H=new Error;return new r(H.stack??"")}constructor(H){this.value=H}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f extends Error{constructor(H,se){super(H),this.name="ListenerLeakError",this.stack=se}}e.ListenerLeakError=f;class b extends Error{constructor(H,se){super(H),this.name="ListenerRefusalError",this.stack=se}}e.ListenerRefusalError=b;let u=0;class y{constructor(H){this.value=H,this.id=u++}}const v=2,l=(x,H)=>{if(x instanceof y)H(x);else for(let se=0;se<x.length;se++){const K=x[se];K&&H(K)}};let n;if(N){const x=[];setInterval(()=>{x.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(x.join(`
`)),x.length=0)},3e3),n=new FinalizationRegistry(H=>{typeof H=="string"&&x.push(H)})}class i{constructor(H){this._size=0,this._options=H,this._leakageMon=D>0||this._options?.leakWarningThreshold?new a(H?.onListenerError??p.onUnexpectedError,this._options?.leakWarningThreshold??D):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(L){const H=this._listeners;queueMicrotask(()=>{l(H,se=>se.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(H,se,K)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const _=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(_);const O=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],C=new b(`${_}. HINT: Stack shows most frequent listener (${O[1]}-times)`,O[0]);return(this._options?.onListenerError||p.onUnexpectedError)(C),$.Disposable.None}if(this._disposed)return $.Disposable.None;se&&(H=H.bind(se));const ie=new y(H);let oe,re;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ie.stack=r.create(),oe=this._leakageMon.check(ie.stack,this._size+1)),L&&(ie.stack=re??r.create()),this._listeners?this._listeners instanceof y?(this._deliveryQueue??=new o,this._listeners=[this._listeners,ie]):this._listeners.push(ie):(this._options?.onWillAddFirstListener?.(this),this._listeners=ie,this._options?.onDidAddFirstListener?.(this)),this._size++;const I=(0,$.toDisposable)(()=>{n?.unregister(I),oe?.(),this._removeListener(ie)});if(K instanceof $.DisposableStore?K.add(I):Array.isArray(K)&&K.push(I),n){const _=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),O=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(_);n.register(I,O?.[2]??_,I)}return I},this._event}_removeListener(H){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const se=this._listeners,K=se.indexOf(H);if(K===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,se[K]=void 0;const ie=this._deliveryQueue.current===this;if(this._size*v<=se.length){let oe=0;for(let re=0;re<se.length;re++)se[re]?se[oe++]=se[re]:ie&&(this._deliveryQueue.end--,oe<this._deliveryQueue.i&&this._deliveryQueue.i--);se.length=oe}}_deliver(H,se){if(!H)return;const K=this._options?.onListenerError||p.onUnexpectedError;if(!K){H.value(se);return}try{H.value(se)}catch(ie){K(ie)}}_deliverQueue(H){const se=H.current._listeners;for(;H.i<H.end;)this._deliver(se[H.i++],H.value);H.reset()}fire(H){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof y)this._deliver(this._listeners,H);else{const se=this._deliveryQueue;se.enqueue(this,H,this._listeners.length),this._deliverQueue(se)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const s=()=>new o;e.createEventDeliveryQueue=s;class o{constructor(){this.i=-1,this.end=0}enqueue(H,se,K){this.i=0,this.end=K,this.current=H,this.value=se}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class U extends i{async fireAsync(H,se,K){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new q.LinkedList),l(this._listeners,ie=>this._asyncDeliveryQueue.push([ie.value,H]));this._asyncDeliveryQueue.size>0&&!se.isCancellationRequested;){const[ie,oe]=this._asyncDeliveryQueue.shift(),re=[],I={...oe,token:se,waitUntil:_=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");K&&(_=K(_,ie)),re.push(_)}};try{ie(I)}catch(_){(0,p.onUnexpectedError)(_);continue}Object.freeze(re),await Promise.allSettled(re).then(_=>{for(const O of _)O.status==="rejected"&&(0,p.onUnexpectedError)(O.reason)})}}}e.AsyncEmitter=U;class m extends i{get isPaused(){return this._isPaused!==0}constructor(H){super(H),this._isPaused=0,this._eventQueue=new q.LinkedList,this._mergeFn=H?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const H=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(H))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(H){this._size&&(this._isPaused!==0?this._eventQueue.push(H):super.fire(H))}}e.PauseableEmitter=m;class E extends m{constructor(H){super(H),this._delay=H.delay??100}fire(H){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(H)}}e.DebounceEmitter=E;class h extends i{constructor(H){super(H),this._queuedEvents=[],this._mergeFn=H?.merge}fire(H){this.hasListeners()&&(this._queuedEvents.push(H),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(se=>super.fire(se)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=h;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(H){const se={event:H,listener:null};this.events.push(se),this.hasListeners&&this.hook(se);const K=()=>{this.hasListeners&&this.unhook(se);const ie=this.events.indexOf(se);this.events.splice(ie,1)};return(0,$.toDisposable)((0,t.createSingleCallFunction)(K))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(H=>this.hook(H))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(H=>this.unhook(H))}hook(H){H.listener=H.event(se=>this.emitter.fire(se))}unhook(H){H.listener?.dispose(),H.listener=null}dispose(){this.emitter.dispose();for(const H of this.events)H.listener?.dispose();this.events=[]}}e.EventMultiplexer=d;class F{constructor(H,se,K,ie){this._store=new $.DisposableStore;const oe=this._store.add(new d),re=this._store.add(new $.DisposableMap);function I(_){re.set(_,oe.add(ie(_)))}for(const _ of H)I(_);this._store.add(se(_=>{I(_)})),this._store.add(K(_=>{re.deleteAndDispose(_)})),this.event=oe.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=F;class c{constructor(){this.data=[]}wrapEvent(H,se,K){return(ie,oe,re)=>H(I=>{const _=this.data[this.data.length-1];if(!se){_?_.buffers.push(()=>ie.call(oe,I)):ie.call(oe,I);return}const O=_;if(!O){ie.call(oe,se(K,I));return}O.items??=[],O.items.push(I),O.buffers.length===0&&_.buffers.push(()=>{O.reducedResult??=K?O.items.reduce(se,K):O.items.reduce(se),ie.call(oe,O.reducedResult)})},void 0,re)}bufferEvents(H){const se={buffers:new Array};this.data.push(se);const K=H();return this.data.pop(),se.buffers.forEach(ie=>ie()),K}}e.EventBufferer=c;class A{constructor(){this.listening=!1,this.inputEvent=M.None,this.inputEventListener=$.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(H){this.inputEvent=H,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=H(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=A;class j{static const(H){return new Z(H)}constructor(H){this._value=H,this._onDidChange=new i,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(H){H!==this._value&&(this._value=H,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=j;class Z{constructor(H){this.value=H,this.onDidChange=M.None}}}),define(Ee[13],pe([0,1,6]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=N;const t=Object.freeze(function(L,T){const M=setTimeout(L.bind(T),0);return{dispose(){clearTimeout(M)}}});var $;(function(L){function T(M){return M===L.None||M===L.Cancelled||M instanceof q?!0:!M||typeof M!="object"?!1:typeof M.isCancellationRequested=="boolean"&&typeof M.onCancellationRequested=="function"}L.isCancellationToken=T,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})($||(e.CancellationToken=$={}));class q{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class V{constructor(T){this._token=void 0,this._parentListener=void 0,this._parentListener=T&&T.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new q),this._token}cancel(){this._token?this._token instanceof q&&this._token.cancel():this._token=$.Cancelled}dispose(T=!1){T&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof q&&this._token.dispose():this._token=$.None}}e.CancellationTokenSource=V;function N(L){const T=new V;return L.add({dispose(){T.cancel()}}),T.token}}),define(Ee[43],pe([0,1,13]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=$;class t{constructor(L){this.task=L,this.result=null}get(){if(this.result)return this.result;const L=new p.CancellationTokenSource,T=this.task(L.token);return this.result={promise:T,dispose:()=>{this.result=null,L.cancel(),L.dispose()}},this.result}}e.Cache=t;function $(N){return N}class q{constructor(L,T){this.lastCache=void 0,this.lastArgKey=void 0,typeof L=="function"?(this._fn=L,this._computeKey=$):(this._fn=T,this._computeKey=L.getCacheKey)}get(L){const T=this._computeKey(L);return this.lastArgKey!==T&&(this.lastArgKey=T,this.lastCache=this._fn(L)),this.lastCache}}e.LRUCachedFunction=q;class V{get cachedValues(){return this._map}constructor(L,T){this._map=new Map,this._map2=new Map,typeof L=="function"?(this._fn=L,this._computeKey=$):(this._fn=T,this._computeKey=L.getCacheKey)}get(L){const T=this._computeKey(L);if(this._map2.has(T))return this._map2.get(T);const M=this._fn(L);return this._map.set(L,M),this._map2.set(T,M),M}}e.CachedFunction=V}),define(Ee[44],pe([0,1,9,4]),function(ce,e,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=$,e.isReadableStream=q,e.isReadableBufferedStream=V,e.newWriteableStream=N,e.consumeReadable=T,e.peekReadable=M,e.consumeStream=w,e.listenStream=D,e.peekStream=k,e.toStream=a,e.emptyStream=r,e.toReadable=f,e.transform=b,e.prefixedReadable=u,e.prefixedStream=y;function $(v){const l=v;return l?typeof l.read=="function":!1}function q(v){const l=v;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}function V(v){const l=v;return l?q(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}function N(v,l){return new L(v,l)}class L{constructor(l,n){this.reducer=l,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(n=>n(l))}emitError(l){this.listeners.error.length===0?(0,p.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(n=>n(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,n){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(l,n){if(this.state.destroyed)return;let i;switch(l){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(n);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function T(v,l){const n=[];let i;for(;(i=v.read())!==null;)n.push(i);return l(n)}function M(v,l,n){const i=[];let s;for(;(s=v.read())!==null&&i.length<n;)i.push(s);return s===null&&i.length>0?l(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return v.read()}}}function w(v,l){return new Promise((n,i)=>{const s=[];D(v,{onData:o=>{l&&s.push(o)},onError:o=>{l?i(o):n(void 0)},onEnd:()=>{n(l?l(s):void 0)}})})}function D(v,l,n){v.on("error",i=>{n?.isCancellationRequested||l.onError(i)}),v.on("end",()=>{n?.isCancellationRequested||l.onEnd()}),v.on("data",i=>{n?.isCancellationRequested||l.onData(i)})}function k(v,l){return new Promise((n,i)=>{const s=new t.DisposableStore,o=[],U=h=>{if(o.push(h),o.length>l)return s.dispose(),v.pause(),n({stream:v,buffer:o,ended:!1})},m=h=>(s.dispose(),i(h)),E=()=>(s.dispose(),n({stream:v,buffer:o,ended:!0}));s.add((0,t.toDisposable)(()=>v.removeListener("error",m))),v.on("error",m),s.add((0,t.toDisposable)(()=>v.removeListener("end",E))),v.on("end",E),s.add((0,t.toDisposable)(()=>v.removeListener("data",U))),v.on("data",U)})}function a(v,l){const n=N(l);return n.end(v),n}function r(){const v=N(()=>{throw new Error("not supported")});return v.end(),v}function f(v){let l=!1;return{read:()=>l?null:(l=!0,v)}}function b(v,l,n){const i=N(n);return D(v,{onData:s=>i.write(l.data(s)),onError:s=>i.error(l.error?l.error(s):s),onEnd:()=>i.end()}),i}function u(v,l,n){let i=!1;return{read:()=>{const s=l.read();return i?s:(i=!0,s!==null?n([v,s]):v)}}}function y(v,l,n){let i=!1;const s=N(n);return D(l,{onData:o=>i?s.write(o):(i=!0,s.write(n([v,o]))),onError:o=>s.error(o),onEnd:()=>{i||(i=!0,s.write(v)),s.end()}}),s}}),define(Ee[17],pe([0,1,16,44]),function(ce,e,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=T,e.readUInt16LE=M,e.writeUInt16LE=w,e.readUInt32BE=D,e.writeUInt32BE=k,e.readUInt32LE=a,e.writeUInt32LE=r,e.readUInt8=f,e.writeUInt8=b,e.readableToBuffer=u,e.bufferToReadable=y,e.streamToBuffer=v,e.bufferedStreamToBuffer=l,e.bufferToStream=n,e.streamToBufferReadableStream=i,e.newWriteableBufferStream=s,e.prefixedBufferReadable=o,e.prefixedBufferStream=U,e.decodeBase64=m,e.encodeBase64=d,t=Ie(t);const $=typeof Buffer<"u",q=new p.Lazy(()=>new Uint8Array(256));let V,N;class L{static alloc(c){return $?new L(Buffer.allocUnsafe(c)):new L(new Uint8Array(c))}static wrap(c){return $&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new L(c)}static fromString(c,A){return!(A?.dontUseNodeBuffer||!1)&&$?new L(Buffer.from(c)):(V||(V=new TextEncoder),new L(V.encode(c)))}static fromByteArray(c){const A=L.alloc(c.length);for(let j=0,Z=c.length;j<Z;j++)A.buffer[j]=c[j];return A}static concat(c,A){if(typeof A>"u"){A=0;for(let x=0,H=c.length;x<H;x++)A+=c[x].byteLength}const j=L.alloc(A);let Z=0;for(let x=0,H=c.length;x<H;x++){const se=c[x];j.set(se,Z),Z+=se.byteLength}return j}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=L.alloc(this.byteLength);return c.set(this),c}toString(){return $?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(c,A){return new L(this.buffer.subarray(c,A))}set(c,A){if(c instanceof L)this.buffer.set(c.buffer,A);else if(c instanceof Uint8Array)this.buffer.set(c,A);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),A);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return D(this.buffer,c)}writeUInt32BE(c,A){k(this.buffer,c,A)}readUInt32LE(c){return a(this.buffer,c)}writeUInt32LE(c,A){r(this.buffer,c,A)}readUInt8(c){return f(this.buffer,c)}writeUInt8(c,A){b(this.buffer,c,A)}indexOf(c,A=0){return T(this.buffer,c instanceof L?c.buffer:c,A)}}e.VSBuffer=L;function T(F,c,A=0){const j=c.byteLength,Z=F.byteLength;if(j===0)return 0;if(j===1)return F.indexOf(c[0]);if(j>Z-A)return-1;const x=q.value;x.fill(c.length);for(let ie=0;ie<c.length;ie++)x[c[ie]]=c.length-ie-1;let H=A+c.length-1,se=H,K=-1;for(;H<Z;)if(F[H]===c[se]){if(se===0){K=H;break}H--,se--}else H+=Math.max(c.length-se,x[F[H]]),se=c.length-1;return K}function M(F,c){return F[c+0]<<0>>>0|F[c+1]<<8>>>0}function w(F,c,A){F[A+0]=c&255,c=c>>>8,F[A+1]=c&255}function D(F,c){return F[c]*2**24+F[c+1]*2**16+F[c+2]*2**8+F[c+3]}function k(F,c,A){F[A+3]=c,c=c>>>8,F[A+2]=c,c=c>>>8,F[A+1]=c,c=c>>>8,F[A]=c}function a(F,c){return F[c+0]<<0>>>0|F[c+1]<<8>>>0|F[c+2]<<16>>>0|F[c+3]<<24>>>0}function r(F,c,A){F[A+0]=c&255,c=c>>>8,F[A+1]=c&255,c=c>>>8,F[A+2]=c&255,c=c>>>8,F[A+3]=c&255}function f(F,c){return F[c]}function b(F,c,A){F[A]=c}function u(F){return t.consumeReadable(F,c=>L.concat(c))}function y(F){return t.toReadable(F)}function v(F){return t.consumeStream(F,c=>L.concat(c))}async function l(F){return F.ended?L.concat(F.buffer):L.concat([...F.buffer,await v(F.stream)])}function n(F){return t.toStream(F,c=>L.concat(c))}function i(F){return t.transform(F,{data:c=>typeof c=="string"?L.fromString(c):L.wrap(c)},c=>L.concat(c))}function s(F){return t.newWriteableStream(c=>L.concat(c),F)}function o(F,c){return t.prefixedReadable(F,c,A=>L.concat(A))}function U(F,c){return t.prefixedStream(F,c,A=>L.concat(A))}function m(F){let c=0,A=0,j=0;const Z=new Uint8Array(Math.floor(F.length/4*3)),x=se=>{switch(A){case 3:Z[j++]=c|se,A=0;break;case 2:Z[j++]=c|se>>>2,c=se<<6,A=3;break;case 1:Z[j++]=c|se>>>4,c=se<<4,A=2;break;default:c=se<<2,A=1}};for(let se=0;se<F.length;se++){const K=F.charCodeAt(se);if(K>=65&&K<=90)x(K-65);else if(K>=97&&K<=122)x(K-97+26);else if(K>=48&&K<=57)x(K-48+52);else if(K===43||K===45)x(62);else if(K===47||K===95)x(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${F[se]}`)}}const H=j;for(;A>0;)x(0);return L.wrap(Z).slice(0,H)}const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:F},c=!0,A=!1){const j=A?h:E;let Z="";const x=F.byteLength%3;let H=0;for(;H<F.byteLength-x;H+=3){const se=F[H+0],K=F[H+1],ie=F[H+2];Z+=j[se>>>2],Z+=j[(se<<4|K>>>4)&63],Z+=j[(K<<2|ie>>>6)&63],Z+=j[ie&63]}if(x===1){const se=F[H+0];Z+=j[se>>>2],Z+=j[se<<4&63],c&&(Z+="==")}else if(x===2){const se=F[H+0],K=F[H+1];Z+=j[se>>>2],Z+=j[(se<<4|K>>>4)&63],Z+=j[K<<2&63],c&&(Z+="=")}return Z}}),define(Ee[45],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ee[10],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=p,e.isStringArray=t,e.isObject=$,e.isTypedArray=q,e.isNumber=V,e.isIterable=N,e.isBoolean=L,e.isUndefined=T,e.isDefined=M,e.isUndefinedOrNull=w,e.assertType=D,e.assertIsDefined=k,e.assertAllDefined=a,e.isEmptyObject=f,e.isFunction=b,e.areFunctions=u,e.validateConstraints=y,e.validateConstraint=v,e.upcast=l;function p(n){return typeof n=="string"}function t(n){return Array.isArray(n)&&n.every(i=>p(i))}function $(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}function q(n){const i=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof i}function V(n){return typeof n=="number"&&!isNaN(n)}function N(n){return!!n&&typeof n[Symbol.iterator]=="function"}function L(n){return n===!0||n===!1}function T(n){return typeof n>"u"}function M(n){return!w(n)}function w(n){return T(n)||n===null}function D(n,i){if(!n)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function k(n){if(w(n))throw new Error("Assertion Failed: argument is undefined or null");return n}function a(...n){const i=[];for(let s=0;s<n.length;s++){const o=n[s];if(w(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(o)}return i}const r=Object.prototype.hasOwnProperty;function f(n){if(!$(n))return!1;for(const i in n)if(r.call(n,i))return!1;return!0}function b(n){return typeof n=="function"}function u(...n){return n.length>0&&n.every(b)}function y(n,i){const s=Math.min(n.length,i.length);for(let o=0;o<s;o++)v(n[o],i[o])}function v(n,i){if(p(i)){if(typeof n!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(b(i)){try{if(n instanceof i)return}catch{}if(!w(n)&&n.constructor===i||i.length===1&&i.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function l(n){return n}}),define(Ee[46],pe([0,1,10]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=t,e.deepFreeze=$,e.cloneAndChange=V,e.mixin=L,e.equals=T,e.safeStringify=M,e.distinct=w,e.getCaseInsensitive=D,e.filter=k,e.getAllPropertyNames=a,e.getAllMethodNames=r,e.createProxyObject=f,e.mapValues=b;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const y=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([v,l])=>{y[v]=l&&typeof l=="object"?t(l):l}),y}function $(u){if(!u||typeof u!="object")return u;const y=[u];for(;y.length>0;){const v=y.shift();Object.freeze(v);for(const l in v)if(q.call(v,l)){const n=v[l];typeof n=="object"&&!Object.isFrozen(n)&&!(0,p.isTypedArray)(n)&&y.push(n)}}return u}const q=Object.prototype.hasOwnProperty;function V(u,y){return N(u,y,new Set)}function N(u,y,v){if((0,p.isUndefinedOrNull)(u))return u;const l=y(u);if(typeof l<"u")return l;if(Array.isArray(u)){const n=[];for(const i of u)n.push(N(i,y,v));return n}if((0,p.isObject)(u)){if(v.has(u))throw new Error("Cannot clone recursive data-structure");v.add(u);const n={};for(const i in u)q.call(u,i)&&(n[i]=N(u[i],y,v));return v.delete(u),n}return u}function L(u,y,v=!0){return(0,p.isObject)(u)?((0,p.isObject)(y)&&Object.keys(y).forEach(l=>{l in u?v&&((0,p.isObject)(u[l])&&(0,p.isObject)(y[l])?L(u[l],y[l],v):u[l]=y[l]):u[l]=y[l]}),u):y}function T(u,y){if(u===y)return!0;if(u==null||y===null||y===void 0||typeof u!=typeof y||typeof u!="object"||Array.isArray(u)!==Array.isArray(y))return!1;let v,l;if(Array.isArray(u)){if(u.length!==y.length)return!1;for(v=0;v<u.length;v++)if(!T(u[v],y[v]))return!1}else{const n=[];for(l in u)n.push(l);n.sort();const i=[];for(l in y)i.push(l);if(i.sort(),!T(n,i))return!1;for(v=0;v<n.length;v++)if(!T(u[n[v]],y[n[v]]))return!1}return!0}function M(u){const y=new Set;return JSON.stringify(u,(v,l)=>{if((0,p.isObject)(l)||Array.isArray(l)){if(y.has(l))return"[Circular]";y.add(l)}return typeof l=="bigint"?`[BigInt ${l.toString()}]`:l})}function w(u,y){const v=Object.create(null);return!u||!y||Object.keys(y).forEach(n=>{const i=u[n],s=y[n];T(i,s)||(v[n]=s)}),v}function D(u,y){const v=y.toLowerCase(),l=Object.keys(u).find(n=>n.toLowerCase()===v);return l?u[l]:u[y]}function k(u,y){const v=Object.create(null);for(const[l,n]of Object.entries(u))y(l,n)&&(v[l]=n);return v}function a(u){let y=[];for(;Object.prototype!==u;)y=y.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return y}function r(u){const y=[];for(const v of a(u))typeof u[v]=="function"&&y.push(v);return y}function f(u,y){const v=n=>function(){const i=Array.prototype.slice.call(arguments,0);return y(n,i)},l={};for(const n of u)l[n]=v(n);return l}function b(u,y){const v={};for(const[l,n]of Object.entries(u))v[l]=y(n,l);return v}}),define(Ee[47],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=t,e.toUint32=$;var p;(function(q){q[q.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",q[q.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",q[q.MAX_UINT_8=255]="MAX_UINT_8",q[q.MAX_UINT_16=65535]="MAX_UINT_16",q[q.MAX_UINT_32=4294967295]="MAX_UINT_32",q[q.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p||(e.Constants=p={}));function t(q){return q<0?0:q>p.MAX_UINT_8?p.MAX_UINT_8:q|0}function $(q){return q<0?0:q>p.MAX_UINT_32?p.MAX_UINT_32:q|0}}),define(Ee[7],pe([0,1,43,11,16,47]),function(ce,e,p,t,$,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=V,e.format=L,e.format2=M,e.htmlAttributeEncodeValue=w,e.escape=D,e.escapeRegExpCharacters=k,e.count=a,e.truncate=r,e.truncateMiddle=f,e.trim=b,e.ltrim=u,e.rtrim=y,e.convertSimple2RegExpPattern=v,e.stripWildcards=l,e.createRegExp=n,e.regExpLeadsToEndlessLoop=i,e.splitLines=s,e.splitLinesIncludeSeparators=o,e.firstNonWhitespaceIndex=U,e.getLeadingWhitespace=m,e.lastNonWhitespaceIndex=E,e.replaceAsync=h,e.compare=d,e.compareSubstring=F,e.compareIgnoreCase=c,e.compareSubstringIgnoreCase=A,e.isAsciiDigit=j,e.isLowerAsciiLetter=Z,e.isUpperAsciiLetter=x,e.equalsIgnoreCase=H,e.startsWithIgnoreCase=se,e.commonPrefixLength=K,e.commonSuffixLength=ie,e.isHighSurrogate=oe,e.isLowSurrogate=re,e.computeCodePoint=I,e.getNextCodePoint=_,e.nextCharLength=R,e.prevCharLength=X,e.getCharContainingOffset=ee,e.charCount=ne,e.containsRTL=we,e.isBasicASCII=z,e.containsUnusualLineTerminators=P,e.isFullWidthCharacter=g,e.isEmojiImprecise=W,e.lcut=Q,e.forAnsiStringParts=ge,e.removeAnsiEscapeCodes=ye,e.removeAnsiEscapeCodesFromPrompt=fe,e.startsWithUTF8BOM=ue,e.stripUTF8BOM=_e,e.fuzzyContains=de,e.containsUppercaseCharacter=be,e.uppercaseFirstLetter=Ae,e.getNLines=Le,e.singleLetterHash=Se,e.getGraphemeBreakType=Te,e.getLeftDeleteOffset=Be;function V(S){return!S||typeof S!="string"?!0:S.trim().length===0}const N=/{(\d+)}/g;function L(S,...G){return G.length===0?S:S.replace(N,function(J,ae){const me=parseInt(ae,10);return isNaN(me)||me<0||me>=G.length?J:G[me]})}const T=/{([^}]+)}/g;function M(S,G){return Object.keys(G).length===0?S:S.replace(T,(J,ae)=>G[ae]??J)}function w(S){return S.replace(/[<>"'&]/g,G=>{switch(G){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return G})}function D(S){return S.replace(/[<>&]/g,function(G){switch(G){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return G}})}function k(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a(S,G){let J=0,ae=S.indexOf(G);for(;ae!==-1;)J++,ae=S.indexOf(G,ae+G.length);return J}function r(S,G,J="\u2026"){return S.length<=G?S:`${S.substr(0,G)}${J}`}function f(S,G,J="\u2026"){if(S.length<=G)return S;const ae=Math.ceil(G/2)-J.length/2,me=Math.floor(G/2)-J.length/2;return`${S.substr(0,ae)}${J}${S.substr(S.length-me)}`}function b(S,G=" "){const J=u(S,G);return y(J,G)}function u(S,G){if(!S||!G)return S;const J=G.length;if(J===0||S.length===0)return S;let ae=0;for(;S.indexOf(G,ae)===ae;)ae=ae+J;return S.substring(ae)}function y(S,G){if(!S||!G)return S;const J=G.length,ae=S.length;if(J===0||ae===0)return S;let me=ae,De=-1;for(;De=S.lastIndexOf(G,me-1),!(De===-1||De+J!==me);){if(De===0)return"";me=De}return S.substring(0,me)}function v(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(S){return S.replace(/\*/g,"")}function n(S,G,J={}){if(!S)throw new Error("Cannot create regex from empty string");G||(S=k(S)),J.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let ae="";return J.global&&(ae+="g"),J.matchCase||(ae+="i"),J.multiline&&(ae+="m"),J.unicode&&(ae+="u"),new RegExp(S,ae)}function i(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}function s(S){return S.split(/\r\n|\r|\n/)}function o(S){const G=[],J=S.split(/(\r\n|\r|\n)/);for(let ae=0;ae<Math.ceil(J.length/2);ae++)G.push(J[2*ae]+(J[2*ae+1]??""));return G}function U(S){for(let G=0,J=S.length;G<J;G++){const ae=S.charCodeAt(G);if(ae!==t.CharCode.Space&&ae!==t.CharCode.Tab)return G}return-1}function m(S,G=0,J=S.length){for(let ae=G;ae<J;ae++){const me=S.charCodeAt(ae);if(me!==t.CharCode.Space&&me!==t.CharCode.Tab)return S.substring(G,ae)}return S.substring(G,J)}function E(S,G=S.length-1){for(let J=G;J>=0;J--){const ae=S.charCodeAt(J);if(ae!==t.CharCode.Space&&ae!==t.CharCode.Tab)return J}return-1}function h(S,G,J){const ae=[];let me=0;for(const De of S.matchAll(G)){if(ae.push(S.slice(me,De.index)),De.index===void 0)throw new Error("match.index should be defined");me=De.index+De[0].length,ae.push(J(De[0],...De.slice(1),De.index,S,De.groups))}return ae.push(S.slice(me)),Promise.all(ae).then(De=>De.join(""))}function d(S,G){return S<G?-1:S>G?1:0}function F(S,G,J=0,ae=S.length,me=0,De=G.length){for(;J<ae&&me<De;J++,me++){const Fe=S.charCodeAt(J),Ne=G.charCodeAt(me);if(Fe<Ne)return-1;if(Fe>Ne)return 1}const Pe=ae-J,We=De-me;return Pe<We?-1:Pe>We?1:0}function c(S,G){return A(S,G,0,S.length,0,G.length)}function A(S,G,J=0,ae=S.length,me=0,De=G.length){for(;J<ae&&me<De;J++,me++){let Fe=S.charCodeAt(J),Ne=G.charCodeAt(me);if(Fe===Ne)continue;if(Fe>=128||Ne>=128)return F(S.toLowerCase(),G.toLowerCase(),J,ae,me,De);Z(Fe)&&(Fe-=32),Z(Ne)&&(Ne-=32);const Oe=Fe-Ne;if(Oe!==0)return Oe}const Pe=ae-J,We=De-me;return Pe<We?-1:Pe>We?1:0}function j(S){return S>=t.CharCode.Digit0&&S<=t.CharCode.Digit9}function Z(S){return S>=t.CharCode.a&&S<=t.CharCode.z}function x(S){return S>=t.CharCode.A&&S<=t.CharCode.Z}function H(S,G){return S.length===G.length&&A(S,G)===0}function se(S,G){const J=G.length;return G.length>S.length?!1:A(S,G,0,J)===0}function K(S,G){const J=Math.min(S.length,G.length);let ae;for(ae=0;ae<J;ae++)if(S.charCodeAt(ae)!==G.charCodeAt(ae))return ae;return J}function ie(S,G){const J=Math.min(S.length,G.length);let ae;const me=S.length-1,De=G.length-1;for(ae=0;ae<J;ae++)if(S.charCodeAt(me-ae)!==G.charCodeAt(De-ae))return ae;return J}function oe(S){return 55296<=S&&S<=56319}function re(S){return 56320<=S&&S<=57343}function I(S,G){return(S-55296<<10)+(G-56320)+65536}function _(S,G,J){const ae=S.charCodeAt(J);if(oe(ae)&&J+1<G){const me=S.charCodeAt(J+1);if(re(me))return I(ae,me)}return ae}function O(S,G){const J=S.charCodeAt(G-1);if(re(J)&&G>1){const ae=S.charCodeAt(G-2);if(oe(ae))return I(ae,J)}return J}class C{get offset(){return this._offset}constructor(G,J=0){this._str=G,this._len=G.length,this._offset=J}setOffset(G){this._offset=G}prevCodePoint(){const G=O(this._str,this._offset);return this._offset-=G>=q.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,G}nextCodePoint(){const G=_(this._str,this._len,this._offset);return this._offset+=G>=q.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,G}eol(){return this._offset>=this._len}}e.CodePointIterator=C;class Y{get offset(){return this._iterator.offset}constructor(G,J=0){this._iterator=new C(G,J)}nextGraphemeLength(){const G=Ue.getInstance(),J=this._iterator,ae=J.offset;let me=G.getGraphemeBreakType(J.nextCodePoint());for(;!J.eol();){const De=J.offset,Pe=G.getGraphemeBreakType(J.nextCodePoint());if(ke(me,Pe)){J.setOffset(De);break}me=Pe}return J.offset-ae}prevGraphemeLength(){const G=Ue.getInstance(),J=this._iterator,ae=J.offset;let me=G.getGraphemeBreakType(J.prevCodePoint());for(;J.offset>0;){const De=J.offset,Pe=G.getGraphemeBreakType(J.prevCodePoint());if(ke(Pe,me)){J.setOffset(De);break}me=Pe}return ae-J.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function R(S,G){return new Y(S,G).nextGraphemeLength()}function X(S,G){return new Y(S,G).prevGraphemeLength()}function ee(S,G){G>0&&re(S.charCodeAt(G))&&G--;const J=G+R(S,G);return[J-X(S,J),J]}function ne(S){const G=new Y(S);let J=0;for(;!G.eol();)J++,G.nextGraphemeLength();return J}let le;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(S){return le||(le=he()),le.test(S)}const B=/^[\t\n\r\x20-\x7E]*$/;function z(S){return B.test(S)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function P(S){return e.UNUSUAL_LINE_TERMINATORS.test(S)}function g(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}function W(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}function Q(S,G,J=""){const ae=S.trimStart();if(ae.length<G)return ae;const me=/\b/g;let De=0;for(;me.test(ae)&&!(ae.length-me.lastIndex<G);)De=me.lastIndex,me.lastIndex+=1;return De===0?ae:J+ae.substring(De).trimStart()}const te=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ge(S){let G=0;for(const J of S.matchAll(te))G!==J.index&&(yield{isCode:!1,str:S.substring(G,J.index)}),yield{isCode:!0,str:J[0]},G=J.index+J[0].length;G!==S.length&&(yield{isCode:!1,str:S.substring(G)})}function ye(S){return S&&(S=S.replace(te,"")),S}const Re=/\\\[.*?\\\]/g;function fe(S){return ye(S).replace(Re,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(t.CharCode.UTF8_BOM);function ue(S){return!!(S&&S.length>0&&S.charCodeAt(0)===t.CharCode.UTF8_BOM)}function _e(S){return ue(S)?S.substr(1):S}function de(S,G){if(!S||!G||S.length<G.length)return!1;const J=G.length,ae=S.toLowerCase();let me=0,De=-1;for(;me<J;){const Pe=ae.indexOf(G[me],De+1);if(Pe<0)return!1;De=Pe,me++}return!0}function be(S,G=!1){return S?(G&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}function Ae(S){return S.charAt(0).toUpperCase()+S.slice(1)}function Le(S,G=1){if(G===0)return"";let J=-1;do J=S.indexOf(`
`,J+1),G--;while(G>0&&J>=0);return J===-1?S:(S[J-1]==="\r"&&J--,S.substr(0,J))}function Se(S){const G=t.CharCode.Z-t.CharCode.A+1;return S=S%(2*G),S<G?String.fromCharCode(t.CharCode.a+S):String.fromCharCode(t.CharCode.A+S-G)}function Te(S){return Ue.getInstance().getGraphemeBreakType(S)}function ke(S,G){return S===ve.Other?G!==ve.Extend&&G!==ve.SpacingMark:S===ve.CR&&G===ve.LF?!1:S===ve.Control||S===ve.CR||S===ve.LF||G===ve.Control||G===ve.CR||G===ve.LF?!0:!(S===ve.L&&(G===ve.L||G===ve.V||G===ve.LV||G===ve.LVT)||(S===ve.LV||S===ve.V)&&(G===ve.V||G===ve.T)||(S===ve.LVT||S===ve.T)&&G===ve.T||G===ve.Extend||G===ve.ZWJ||G===ve.SpacingMark||S===ve.Prepend||S===ve.ZWJ&&G===ve.Extended_Pictographic||S===ve.Regional_Indicator&&G===ve.Regional_Indicator)}var ve;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(ve||(e.GraphemeBreakType=ve={}));class Ue{static{this._INSTANCE=null}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(G){if(G<32)return G===t.CharCode.LineFeed?ve.LF:G===t.CharCode.CarriageReturn?ve.CR:ve.Control;if(G<127)return ve.Other;const J=this._data,ae=J.length/3;let me=1;for(;me<=ae;)if(G<J[3*me])me=2*me;else if(G>J[3*me+1])me=2*me+1;else return J[3*me+2];return ve.Other}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be(S,G){if(S===0)return 0;const J=He(S,G);if(J!==void 0)return J;const ae=new C(G,S);return ae.prevCodePoint(),ae.offset}function He(S,G){const J=new C(G,S);let ae=J.prevCodePoint();for(;Ke(ae)||ae===je.emojiVariantSelector||ae===je.enclosingKeyCap;){if(J.offset===0)return;ae=J.prevCodePoint()}if(!W(ae))return;let me=J.offset;return me>0&&J.prevCodePoint()===je.zwj&&(me=J.offset),me}function Ke(S){return 127995<=S&&S<=127999}var je;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class Ce{static{this.ambiguousCharacterData=new $.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new p.LRUCachedFunction({getCacheKey:JSON.stringify},G=>{function J(Oe){const qe=new Map;for(let Me=0;Me<Oe.length;Me+=2)qe.set(Oe[Me],Oe[Me+1]);return qe}function ae(Oe,qe){const Me=new Map(Oe);for(const[Ge,Ve]of qe)Me.set(Ge,Ve);return Me}function me(Oe,qe){if(!Oe)return qe;const Me=new Map;for(const[Ge,Ve]of Oe)qe.has(Ge)&&Me.set(Ge,Ve);return Me}const De=this.ambiguousCharacterData.value;let Pe=G.filter(Oe=>!Oe.startsWith("_")&&Oe in De);Pe.length===0&&(Pe=["_default"]);let We;for(const Oe of Pe){const qe=J(De[Oe]);We=me(We,qe)}const Fe=J(De._common),Ne=ae(Fe,We);return new Ce(Ne)})}static getInstance(G){return Ce.cache.get(Array.from(G))}static{this._locales=new $.Lazy(()=>Object.keys(Ce.ambiguousCharacterData.value).filter(G=>!G.startsWith("_")))}static getLocales(){return Ce._locales.value}constructor(G){this.confusableDictionary=G}isAmbiguous(G){return this.confusableDictionary.has(G)}containsAmbiguousCharacter(G){for(let J=0;J<G.length;J++){const ae=G.codePointAt(J);if(typeof ae=="number"&&this.isAmbiguous(ae))return!0}return!1}getPrimaryConfusable(G){return this.confusableDictionary.get(G)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ce;class $e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set($e.getRawData())),this._data}static isInvisibleCharacter(G){return $e.getData().has(G)}static containsInvisibleCharacter(G){for(let J=0;J<G.length;J++){const ae=G.codePointAt(J);if(typeof ae=="number"&&$e.isInvisibleCharacter(ae))return!0}return!1}static get codePoints(){return $e.getData()}}e.InvisibleCharacters=$e}),define(Ee[14],pe([0,1,11,3,2,7,10]),function(ce,e,p,t,$,q,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=N,e.toSlashes=L,e.toPosixPath=T,e.getRoot=M,e.isUNC=w,e.isValidBasename=r,e.isEqual=f,e.isEqualOrParent=b,e.isWindowsDriveLetter=u,e.sanitizeFilePath=y,e.removeTrailingPathSeparator=v,e.isRootOrDriveLetter=l,e.hasDriveLetter=n,e.getDriveLetter=i,e.indexOfPath=s,e.parseLineAndColumnAware=o,e.randomPath=E;function N(h){return h===p.CharCode.Slash||h===p.CharCode.Backslash}function L(h){return h.replace(/[\\/]/g,t.posix.sep)}function T(h){return h.indexOf("/")===-1&&(h=L(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function M(h,d=t.posix.sep){if(!h)return"";const F=h.length,c=h.charCodeAt(0);if(N(c)){if(N(h.charCodeAt(1))&&!N(h.charCodeAt(2))){let j=3;const Z=j;for(;j<F&&!N(h.charCodeAt(j));j++);if(Z!==j&&!N(h.charCodeAt(j+1))){for(j+=1;j<F;j++)if(N(h.charCodeAt(j)))return h.slice(0,j+1).replace(/[\\/]/g,d)}}return d}else if(u(c)&&h.charCodeAt(1)===p.CharCode.Colon)return N(h.charCodeAt(2))?h.slice(0,2)+d:h.slice(0,2);let A=h.indexOf("://");if(A!==-1){for(A+=3;A<F;A++)if(N(h.charCodeAt(A)))return h.slice(0,A+1)}return""}function w(h){if(!$.isWindows||!h||h.length<5)return!1;let d=h.charCodeAt(0);if(d!==p.CharCode.Backslash||(d=h.charCodeAt(1),d!==p.CharCode.Backslash))return!1;let F=2;const c=F;for(;F<h.length&&(d=h.charCodeAt(F),d!==p.CharCode.Backslash);F++);return!(c===F||(d=h.charCodeAt(F+1),isNaN(d)||d===p.CharCode.Backslash))}const D=/[\\/:\*\?"<>\|]/g,k=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(h,d=$.isWindows){const F=d?D:k;return!(!h||h.length===0||/^\s+$/.test(h)||(F.lastIndex=0,F.test(h))||d&&a.test(h)||h==="."||h===".."||d&&h[h.length-1]==="."||d&&h.length!==h.trim().length||h.length>255)}function f(h,d,F){const c=h===d;return!F||c?c:!h||!d?!1:(0,q.equalsIgnoreCase)(h,d)}function b(h,d,F,c=t.sep){if(h===d)return!0;if(!h||!d||d.length>h.length)return!1;if(F){if(!(0,q.startsWithIgnoreCase)(h,d))return!1;if(d.length===h.length)return!0;let j=d.length;return d.charAt(d.length-1)===c&&j--,h.charAt(j)===c}return d.charAt(d.length-1)!==c&&(d+=c),h.indexOf(d)===0}function u(h){return h>=p.CharCode.A&&h<=p.CharCode.Z||h>=p.CharCode.a&&h<=p.CharCode.z}function y(h,d){return $.isWindows&&h.endsWith(":")&&(h+=t.sep),(0,t.isAbsolute)(h)||(h=(0,t.join)(d,h)),h=(0,t.normalize)(h),v(h)}function v(h){return $.isWindows?(h=(0,q.rtrim)(h,t.sep),h.endsWith(":")&&(h+=t.sep)):(h=(0,q.rtrim)(h,t.sep),h||(h=t.sep)),h}function l(h){const d=(0,t.normalize)(h);return $.isWindows?h.length>3?!1:n(d)&&(h.length===2||d.charCodeAt(2)===p.CharCode.Backslash):d===t.posix.sep}function n(h,d=$.isWindows){return d?u(h.charCodeAt(0))&&h.charCodeAt(1)===p.CharCode.Colon:!1}function i(h,d=$.isWindows){return n(h,d)?h[0]:void 0}function s(h,d,F){return d.length>h.length?-1:h===d?0:(F&&(h=h.toLowerCase(),d=d.toLowerCase()),h.indexOf(d))}function o(h){const d=h.split(":");let F,c,A;for(const j of d){const Z=Number(j);(0,V.isNumber)(Z)?c===void 0?c=Z:A===void 0&&(A=Z):F=F?[F,j].join(":"):j}if(!F)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:F,line:c!==void 0?c:void 0,column:A!==void 0?A:c!==void 0?1:void 0}}const U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",m="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(h,d,F=8){let c="";for(let j=0;j<F;j++){let Z;j===0&&$.isWindows&&!d&&(F===3||F===4)?Z=m:Z=U,c+=Z.charAt(Math.floor(Math.random()*Z.length))}let A;return d?A=`${d}-${c}`:A=c,h?(0,t.join)(h,A):A}}),define(Ee[30],pe([0,1,12,11,7]),function(ce,e,p,t,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class q{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const r=a.charCodeAt(0),f=this._value.charCodeAt(this._pos);return r-f}value(){return this._value[this._pos]}}e.StringIterator=q;class V{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===t.CharCode.Period)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,$.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,$.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=V;class N{constructor(a=!0,r=!0){this._splitOnBackslash=a,this._caseSensitive=r}reset(a){this._from=0,this._to=0,this._value=a,this._valueLen=a.length;for(let r=a.length-1;r>=0;r--,this._valueLen--){const f=this._value.charCodeAt(r);if(!(f===t.CharCode.Slash||this._splitOnBackslash&&f===t.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let a=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===t.CharCode.Slash||this._splitOnBackslash&&r===t.CharCode.Backslash)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,$.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,$.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=N;var L;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(L||(L={}));class T{constructor(a,r){this._ignorePathCasing=a,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(L.Scheme),this._value.authority&&this._states.push(L.Authority),this._value.path&&(this._pathIterator=new N(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(L.Path)),this._ignoreQueryAndFragment(a)||(this._value.query&&this._states.push(L.Query),this._value.fragment&&this._states.push(L.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===L.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===L.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===L.Scheme)return(0,$.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===L.Authority)return(0,$.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===L.Path)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===L.Query)return(0,$.compare)(a,this._value.query);if(this._states[this._stateIdx]===L.Fragment)return(0,$.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===L.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===L.Authority)return this._value.authority;if(this._states[this._stateIdx]===L.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===L.Query)return this._value.query;if(this._states[this._stateIdx]===L.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=T;class M{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(w||(w={}));class D{static forUris(a=()=>!1,r=()=>!1){return new D(new T(a,r))}static forPaths(a=!1){return new D(new N(void 0,!a))}static forStrings(){return new D(new q)}static forConfigKeys(){return new D(new V)}constructor(a){this._iter=a}clear(){this._root=void 0}fill(a,r){if(r){const f=r.slice(0);(0,p.shuffle)(f);for(const b of f)this.set(b,a)}else{const f=a.slice(0);(0,p.shuffle)(f);for(const b of f)this.set(b[0],b[1])}}set(a,r){const f=this._iter.reset(a);let b;this._root||(this._root=new M,this._root.segment=f.value());const u=[];for(b=this._root;;){const v=f.cmp(b.segment);if(v>0)b.left||(b.left=new M,b.left.segment=f.value()),u.push([w.Left,b]),b=b.left;else if(v<0)b.right||(b.right=new M,b.right.segment=f.value()),u.push([w.Right,b]),b=b.right;else if(f.hasNext())f.next(),b.mid||(b.mid=new M,b.mid.segment=f.value()),u.push([w.Mid,b]),b=b.mid;else break}const y=b.value;b.value=r,b.key=a;for(let v=u.length-1;v>=0;v--){const l=u[v][1];l.updateHeight();const n=l.balanceFactor();if(n<-1||n>1){const i=u[v][0],s=u[v+1][0];if(i===w.Right&&s===w.Right)u[v][1]=l.rotateLeft();else if(i===w.Left&&s===w.Left)u[v][1]=l.rotateRight();else if(i===w.Right&&s===w.Left)l.right=u[v+1][1]=u[v+1][1].rotateRight(),u[v][1]=l.rotateLeft();else if(i===w.Left&&s===w.Right)l.left=u[v+1][1]=u[v+1][1].rotateLeft(),u[v][1]=l.rotateRight();else throw new Error;if(v>0)switch(u[v-1][0]){case w.Left:u[v-1][1].left=u[v][1];break;case w.Right:u[v-1][1].right=u[v][1];break;case w.Mid:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}return y}get(a){return this._getNode(a)?.value}_getNode(a){const r=this._iter.reset(a);let f=this._root;for(;f;){const b=r.cmp(f.segment);if(b>0)f=f.left;else if(b<0)f=f.right;else if(r.hasNext())r.next(),f=f.mid;else break}return f}has(a){const r=this._getNode(a);return!(r?.value===void 0&&r?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,r){const f=this._iter.reset(a),b=[];let u=this._root;for(;u;){const y=f.cmp(u.segment);if(y>0)b.push([w.Left,u]),u=u.left;else if(y<0)b.push([w.Right,u]),u=u.right;else if(f.hasNext())f.next(),b.push([w.Mid,u]),u=u.mid;else break}if(u){if(r?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const y=this._min(u.right);if(y.key){const{key:v,value:l,segment:n}=y;this._delete(y.key,!1),u.key=v,u.value=l,u.segment=n}}else{const y=u.left??u.right;if(b.length>0){const[v,l]=b[b.length-1];switch(v){case w.Left:l.left=y;break;case w.Mid:l.mid=y;break;case w.Right:l.right=y;break}}else this._root=y}for(let y=b.length-1;y>=0;y--){const v=b[y][1];v.updateHeight();const l=v.balanceFactor();if(l>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),b[y][1]=v.rotateLeft()):l<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),b[y][1]=v.rotateRight()),y>0)switch(b[y-1][0]){case w.Left:b[y-1][1].left=b[y][1];break;case w.Right:b[y-1][1].right=b[y][1];break;case w.Mid:b[y-1][1].mid=b[y][1];break}else this._root=b[0][1]}}}_min(a){for(;a.left;)a=a.left;return a}findSubstr(a){const r=this._iter.reset(a);let f=this._root,b;for(;f;){const u=r.cmp(f.segment);if(u>0)f=f.left;else if(u<0)f=f.right;else if(r.hasNext())r.next(),b=f.value||b,f=f.mid;else break}return f&&f.value||b}findSuperstr(a){return this._findSuperstrOrElement(a,!1)}_findSuperstrOrElement(a,r){const f=this._iter.reset(a);let b=this._root;for(;b;){const u=f.cmp(b.segment);if(u>0)b=b.left;else if(u<0)b=b.right;else if(f.hasNext())f.next(),b=b.mid;else return b.mid?this._entries(b.mid):r?b.value:void 0}}hasElementOrSubtree(a){return this._findSuperstrOrElement(a,!0)!==void 0}forEach(a){for(const[r,f]of this)a(f,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(a){const r=[];return this._dfsEntries(a,r),r[Symbol.iterator]()}_dfsEntries(a,r){a&&(a.left&&this._dfsEntries(a.left,r),a.value&&r.push([a.key,a.value]),a.mid&&this._dfsEntries(a.mid,r),a.right&&this._dfsEntries(a.right,r))}_isBalanced(){const a=r=>{if(!r)return!0;const f=r.balanceFactor();return f<-1||f>1?!1:a(r.left)&&a(r.right)};return a(this._root)}}e.TernarySearchTree=D}),define(Ee[5],pe([0,1,11,27,3,2]),function(ce,e,p,t,$,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=f,e.uriToFsPath=n,$=Ie($);const V=/^\w[\w\d+.-]*$/,N=/^\//,L=/^\/\//;function T(m,E){if(!m.scheme&&E)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!V.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!N.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function M(m,E){return!m&&!E?"file":m}function w(m,E){switch(m){case"https":case"http":case"file":E?E[0]!==k&&(E=k+E):E=k;break}return E}const D="",k="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(E){return E instanceof r?!0:E?typeof E.authority=="string"&&typeof E.fragment=="string"&&typeof E.path=="string"&&typeof E.query=="string"&&typeof E.scheme=="string"&&typeof E.fsPath=="string"&&typeof E.with=="function"&&typeof E.toString=="function":!1}constructor(E,h,d,F,c,A=!1){typeof E=="object"?(this.scheme=E.scheme||D,this.authority=E.authority||D,this.path=E.path||D,this.query=E.query||D,this.fragment=E.fragment||D):(this.scheme=M(E,A),this.authority=h||D,this.path=w(this.scheme,d||D),this.query=F||D,this.fragment=c||D,T(this,A))}get fsPath(){return n(this,!1)}with(E){if(!E)return this;let{scheme:h,authority:d,path:F,query:c,fragment:A}=E;return h===void 0?h=this.scheme:h===null&&(h=D),d===void 0?d=this.authority:d===null&&(d=D),F===void 0?F=this.path:F===null&&(F=D),c===void 0?c=this.query:c===null&&(c=D),A===void 0?A=this.fragment:A===null&&(A=D),h===this.scheme&&d===this.authority&&F===this.path&&c===this.query&&A===this.fragment?this:new u(h,d,F,c,A)}static parse(E,h=!1){const d=a.exec(E);return d?new u(d[2]||D,U(d[4]||D),U(d[5]||D),U(d[7]||D),U(d[9]||D),h):new u(D,D,D,D,D)}static file(E){let h=D;if(q.isWindows&&(E=E.replace(/\\/g,k)),E[0]===k&&E[1]===k){const d=E.indexOf(k,2);d===-1?(h=E.substring(2),E=k):(h=E.substring(2,d),E=E.substring(d)||k)}return new u("file",h,E,D,D)}static from(E,h){return new u(E.scheme,E.authority,E.path,E.query,E.fragment,h)}static joinPath(E,...h){if(!E.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return q.isWindows&&E.scheme==="file"?d=r.file($.win32.join(n(E,!0),...h)).path:d=$.posix.join(E.path,...h),E.with({path:d})}toString(E=!1){return i(this,E)}toJSON(){return this}static revive(E){if(E){if(E instanceof r)return E;{const h=new u(E);return h._formatted=E.external??null,h._fsPath=E._sep===b?E.fsPath??null:null,h}}else return E}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=r;function f(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}const b=q.isWindows?1:void 0;class u extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(E=!1){return E?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const E={$mid:t.MarshalledId.Uri};return this._fsPath&&(E.fsPath=this._fsPath,E._sep=b),this._formatted&&(E.external=this._formatted),this.path&&(E.path=this.path),this.scheme&&(E.scheme=this.scheme),this.authority&&(E.authority=this.authority),this.query&&(E.query=this.query),this.fragment&&(E.fragment=this.fragment),E}}const y={[p.CharCode.Colon]:"%3A",[p.CharCode.Slash]:"%2F",[p.CharCode.QuestionMark]:"%3F",[p.CharCode.Hash]:"%23",[p.CharCode.OpenSquareBracket]:"%5B",[p.CharCode.CloseSquareBracket]:"%5D",[p.CharCode.AtSign]:"%40",[p.CharCode.ExclamationMark]:"%21",[p.CharCode.DollarSign]:"%24",[p.CharCode.Ampersand]:"%26",[p.CharCode.SingleQuote]:"%27",[p.CharCode.OpenParen]:"%28",[p.CharCode.CloseParen]:"%29",[p.CharCode.Asterisk]:"%2A",[p.CharCode.Plus]:"%2B",[p.CharCode.Comma]:"%2C",[p.CharCode.Semicolon]:"%3B",[p.CharCode.Equals]:"%3D",[p.CharCode.Space]:"%20"};function v(m,E,h){let d,F=-1;for(let c=0;c<m.length;c++){const A=m.charCodeAt(c);if(A>=p.CharCode.a&&A<=p.CharCode.z||A>=p.CharCode.A&&A<=p.CharCode.Z||A>=p.CharCode.Digit0&&A<=p.CharCode.Digit9||A===p.CharCode.Dash||A===p.CharCode.Period||A===p.CharCode.Underline||A===p.CharCode.Tilde||E&&A===p.CharCode.Slash||h&&A===p.CharCode.OpenSquareBracket||h&&A===p.CharCode.CloseSquareBracket||h&&A===p.CharCode.Colon)F!==-1&&(d+=encodeURIComponent(m.substring(F,c)),F=-1),d!==void 0&&(d+=m.charAt(c));else{d===void 0&&(d=m.substr(0,c));const j=y[A];j!==void 0?(F!==-1&&(d+=encodeURIComponent(m.substring(F,c)),F=-1),d+=j):F===-1&&(F=c)}}return F!==-1&&(d+=encodeURIComponent(m.substring(F))),d!==void 0?d:m}function l(m){let E;for(let h=0;h<m.length;h++){const d=m.charCodeAt(h);d===p.CharCode.Hash||d===p.CharCode.QuestionMark?(E===void 0&&(E=m.substr(0,h)),E+=y[d]):E!==void 0&&(E+=m[h])}return E!==void 0?E:m}function n(m,E){let h;return m.authority&&m.path.length>1&&m.scheme==="file"?h=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===p.CharCode.Slash&&(m.path.charCodeAt(1)>=p.CharCode.A&&m.path.charCodeAt(1)<=p.CharCode.Z||m.path.charCodeAt(1)>=p.CharCode.a&&m.path.charCodeAt(1)<=p.CharCode.z)&&m.path.charCodeAt(2)===p.CharCode.Colon?E?h=m.path.substr(1):h=m.path[1].toLowerCase()+m.path.substr(2):h=m.path,q.isWindows&&(h=h.replace(/\//g,"\\")),h}function i(m,E){const h=E?l:v;let d="",{scheme:F,authority:c,path:A,query:j,fragment:Z}=m;if(F&&(d+=F,d+=":"),(c||F==="file")&&(d+=k,d+=k),c){let x=c.indexOf("@");if(x!==-1){const H=c.substr(0,x);c=c.substr(x+1),x=H.lastIndexOf(":"),x===-1?d+=h(H,!1,!1):(d+=h(H.substr(0,x),!1,!1),d+=":",d+=h(H.substr(x+1),!1,!0)),d+="@"}c=c.toLowerCase(),x=c.lastIndexOf(":"),x===-1?d+=h(c,!1,!0):(d+=h(c.substr(0,x),!1,!0),d+=c.substr(x))}if(A){if(A.length>=3&&A.charCodeAt(0)===p.CharCode.Slash&&A.charCodeAt(2)===p.CharCode.Colon){const x=A.charCodeAt(1);x>=p.CharCode.A&&x<=p.CharCode.Z&&(A=`/${String.fromCharCode(x+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===p.CharCode.Colon){const x=A.charCodeAt(0);x>=p.CharCode.A&&x<=p.CharCode.Z&&(A=`${String.fromCharCode(x+32)}:${A.substr(2)}`)}d+=h(A,!0,!1)}return j&&(d+="?",d+=h(j,!1,!1)),Z&&(d+="#",d+=E?Z:v(Z,!1,!1)),d}function s(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+s(m.substr(3)):m}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function U(m){return m.match(o)?m.replace(o,E=>s(E)):m}}),define(Ee[48],pe([0,1,5]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=t,e.parse=$,e.getFirstFrame=q,e.log=N;function t(T){const M=T;return M&&typeof M.type=="string"&&typeof M.severity=="string"}function $(T){const M=[];let w;try{const D=JSON.parse(T.arguments),k=D[D.length-1];k&&k.__$stack&&(D.pop(),w=k.__$stack),M.push(...D)}catch{M.push("Unable to log remote console arguments",T.arguments)}return{args:M,stack:w}}function q(T){if(typeof T!="string")return q($(T).stack);const M=T;if(M){const w=V(M),D=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(D&&D.length===4)return{uri:p.URI.file(D[1]),line:Number(D[2]),column:Number(D[3])}}}function V(T){if(!T)return T;const M=T.indexOf(`
`);return M===-1?T:T.substring(0,M)}function N(T,M){const{args:w,stack:D}=$(T),k=typeof w[0]=="string"&&w.length===1;let a=V(D);a&&(a=`(${a.trim()})`);let r=[];if(typeof w[0]=="string"?a&&k?r=[`%c[${M}] %c${w[0]} %c${a}`,L("blue"),L(""),L("grey")]:r=[`%c[${M}] %c${w[0]}`,L("blue"),L(""),...w.slice(1)]:r=[`%c[${M}]%`,L("blue"),...w],a&&!k&&r.push(a),typeof console[T.severity]!="function")throw new Error("Unknown console method");console[T.severity].apply(console,r)}function L(T){return`color: ${T}`}}),define(Ee[49],pe([0,1,17,5,27]),function(ce,e,p,t,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=q,e.parse=V,e.revive=L;function q(T){return JSON.stringify(T,N)}function V(T){let M=JSON.parse(T);return M=L(M),M}function N(T,M){return M instanceof RegExp?{$mid:$.MarshalledId.Regexp,source:M.source,flags:M.flags}:M}function L(T,M=0){if(!T||M>200)return T;if(typeof T=="object"){switch(T.$mid){case $.MarshalledId.Uri:return t.URI.revive(T);case $.MarshalledId.Regexp:return new RegExp(T.source,T.flags);case $.MarshalledId.Date:return new Date(T.source)}if(T instanceof p.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let w=0;w<T.length;++w)T[w]=L(T[w],M+1);else for(const w in T)Object.hasOwnProperty.call(T,w)&&(T[w]=L(T[w],M+1))}return T}}),define(Ee[31],pe([0,1,9,2,7,5,3]),function(ce,e,p,t,$,q,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=L,e.matchesSomeScheme=T,e.getServerRootPath=w,p=Ie(p),t=Ie(t),V=Ie(V);var N;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(N||(e.Schemas=N={}));function L(a,r){return q.URI.isUri(a)?(0,$.equalsIgnoreCase)(a.scheme,r):(0,$.startsWithIgnoreCase)(a,r+":")}function T(a,...r){return r.some(f=>L(a,f))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r,f){this._serverRootPath=w(r,f)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return V.posix.join(this._serverRootPath,N.vscodeRemoteResource)}set(r,f,b){this._hosts[r]=f,this._ports[r]=b}setConnectionToken(r,f){this._connectionTokens[r]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(l){return p.onUnexpectedError(l),r}const f=r.authority;let b=this._hosts[f];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const u=this._ports[f],y=this._connectionTokens[f];let v=`path=${encodeURIComponent(r.path)}`;return typeof y=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),q.URI.from({scheme:t.isWeb?this._preferredWebSchema:N.vscodeRemoteResource,authority:`${b}:${u}`,path:this._remoteResourcesPath,query:v})}}e.RemoteAuthorities=new M;function w(a,r){return V.posix.join(r??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class D{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(r){const f=this.toUri(r,ce);return this.uriToBrowserUri(f)}uriToBrowserUri(r){return r.scheme===N.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===N.file&&(t.isNative||t.webWorkerOrigin===`${N.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?r.with({scheme:N.vscodeFileResource,authority:r.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const f=this.toUri(r,ce);return this.uriToFileUri(f)}uriToFileUri(r){return r.scheme===N.vscodeFileResource?r.with({scheme:N.file,authority:r.authority!==D.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,f){return q.URI.isUri(r)?r:q.URI.parse(f.toUrl(r))}}e.FileAccess=new D;var k;(function(a){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(r.get("3"));const f="vscode-coi";function b(y){let v;typeof y=="string"?v=new URL(y).searchParams:y instanceof URL?v=y.searchParams:q.URI.isUri(y)&&(v=new URL(y.toString(!0)).searchParams);const l=v?.get(f);if(l)return r.get(l)}a.getHeadersFromQuery=b;function u(y,v,l){if(!globalThis.crossOriginIsolated)return;const n=v&&l?"3":l?"2":"1";y instanceof URLSearchParams?y.set(f,n):y[f]=n}a.addSearchParam=u})(k||(e.COI=k={}))}),define(Ee[22],pe([0,1,11,14,31,3,2,7,5]),function(ce,e,p,t,$,q,V,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=T,e.distinctParents=w,e.toLocalResource=k,t=Ie(t),q=Ie(q);function T(a){return(0,L.uriToFsPath)(a,!0)}class M{constructor(r){this._ignorePathCasing=r}compare(r,f,b=!1){return r===f?0:(0,N.compare)(this.getComparisonKey(r,b),this.getComparisonKey(f,b))}isEqual(r,f,b=!1){return r===f?!0:!r||!f?!1:this.getComparisonKey(r,b)===this.getComparisonKey(f,b)}getComparisonKey(r,f=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,f,b=!1){if(r.scheme===f.scheme){if(r.scheme===$.Schemas.file)return t.isEqualOrParent(T(r),T(f),this._ignorePathCasing(r))&&r.query===f.query&&(b||r.fragment===f.fragment);if((0,e.isEqualAuthority)(r.authority,f.authority))return t.isEqualOrParent(r.path,f.path,this._ignorePathCasing(r),"/")&&r.query===f.query&&(b||r.fragment===f.fragment)}return!1}joinPath(r,...f){return L.URI.joinPath(r,...f)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return q.posix.basename(r.path)}extname(r){return q.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let f;return r.scheme===$.Schemas.file?f=L.URI.file(q.dirname(T(r))).path:(f=q.posix.dirname(r.path),r.authority&&f.length&&f.charCodeAt(0)!==p.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),f="/")),r.with({path:f})}normalizePath(r){if(!r.path.length)return r;let f;return r.scheme===$.Schemas.file?f=L.URI.file(q.normalize(T(r))).path:f=q.posix.normalize(r.path),r.with({path:f})}relativePath(r,f){if(r.scheme!==f.scheme||!(0,e.isEqualAuthority)(r.authority,f.authority))return;if(r.scheme===$.Schemas.file){const y=q.relative(T(r),T(f));return V.isWindows?t.toSlashes(y):y}let b=r.path||"/";const u=f.path||"/";if(this._ignorePathCasing(r)){let y=0;for(const v=Math.min(b.length,u.length);y<v&&!(b.charCodeAt(y)!==u.charCodeAt(y)&&b.charAt(y).toLowerCase()!==u.charAt(y).toLowerCase());y++);b=u.substr(0,y)+b.substr(y)}return q.posix.relative(b,u)}resolvePath(r,f){if(r.scheme===$.Schemas.file){const b=L.URI.file(q.resolve(T(r),f));return r.with({authority:b.authority,path:b.path})}return f=t.toPosixPath(f),r.with({path:q.posix.resolve(r.path,f)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,f){return r===f||r!==void 0&&f!==void 0&&(0,N.equalsIgnoreCase)(r,f)}hasTrailingPathSeparator(r,f=q.sep){if(r.scheme===$.Schemas.file){const b=T(r);return b.length>t.getRoot(b).length&&b[b.length-1]===f}else{const b=r.path;return b.length>1&&b.charCodeAt(b.length-1)===p.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,f=q.sep){return(0,e.hasTrailingPathSeparator)(r,f)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,f=q.sep){let b=!1;if(r.scheme===$.Schemas.file){const u=T(r);b=u!==void 0&&u.length===t.getRoot(u).length&&u[u.length-1]===f}else{f="/";const u=r.path;b=u.length===1&&u.charCodeAt(u.length-1)===p.CharCode.Slash}return!b&&!(0,e.hasTrailingPathSeparator)(r,f)?r.with({path:r.path+"/"}):r}}e.ExtUri=M,e.extUri=new M(()=>!1),e.extUriBiasedIgnorePathCase=new M(a=>a.scheme===$.Schemas.file?!V.isLinux:!0),e.extUriIgnorePathCase=new M(a=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function w(a,r){const f=[];for(let b=0;b<a.length;b++){const u=r(a[b]);a.some((y,v)=>v===b?!1:(0,e.isEqualOrParent)(u,r(y)))||f.push(a[b])}return f}var D;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function r(f){const b=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(v=>{const[l,n]=v.split(":");l&&n&&b.set(l,n)});const y=f.path.substring(0,f.path.indexOf(";"));return y&&b.set(a.META_DATA_MIME,y),b}a.parseMetaData=r})(D||(e.DataUri=D={}));function k(a,r,f){if(r){let b=a.path;return b&&b[0]!==q.posix.sep&&(b=q.posix.sep+b),a.with({scheme:f,authority:r,path:b})}return a.with({scheme:f})}}),define(Ee[8],pe([0,1,13,9,6,4,22,2,45,16]),function(ce,e,p,t,$,q,V,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=M,e.createCancelablePromise=w,e.raceCancellation=D,e.raceCancellationError=k,e.raceCancellablePromises=a,e.raceTimeout=r,e.asPromise=f,e.promiseWithResolvers=b,e.timeout=m,e.disposableTimeout=E,e.sequence=h,e.first=d,e.firstParallel=F,e.retry=_,e.createCancelableAsyncIterable=B;function M(P){return!!P&&typeof P.then=="function"}function w(P){const g=new p.CancellationTokenSource,W=P(g.token),Q=new Promise((te,ge)=>{const ye=g.token.onCancellationRequested(()=>{ye.dispose(),ge(new t.CancellationError)});Promise.resolve(W).then(Re=>{ye.dispose(),g.dispose(),te(Re)},Re=>{ye.dispose(),g.dispose(),ge(Re)})});return new class{cancel(){g.cancel(),g.dispose()}then(te,ge){return Q.then(te,ge)}catch(te){return this.then(void 0,te)}finally(te){return Q.finally(te)}}}function D(P,g,W){return new Promise((Q,te)=>{const ge=g.onCancellationRequested(()=>{ge.dispose(),Q(W)});P.then(Q,te).finally(()=>ge.dispose())})}function k(P,g){return new Promise((W,Q)=>{const te=g.onCancellationRequested(()=>{te.dispose(),Q(new t.CancellationError)});P.then(W,Q).finally(()=>te.dispose())})}async function a(P){let g=-1;const W=P.map((Q,te)=>Q.then(ge=>(g=te,ge)));try{return await Promise.race(W)}finally{P.forEach((Q,te)=>{te!==g&&Q.cancel()})}}function r(P,g,W){let Q;const te=setTimeout(()=>{Q?.(void 0),W?.()},g);return Promise.race([P.finally(()=>clearTimeout(te)),new Promise(ge=>Q=ge)])}function f(P){return new Promise((g,W)=>{const Q=P();M(Q)?Q.then(g,W):g(Q)})}function b(){let P,g;return{promise:new Promise((Q,te)=>{P=Q,g=te}),resolve:P,reject:g}}class u{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(g){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=g,!this.queuedPromise){const W=()=>{if(this.queuedPromise=null,this.isDisposed)return;const Q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Q};this.queuedPromise=new Promise(Q=>{this.activePromise.then(W,W).then(Q)})}return new Promise((W,Q)=>{this.queuedPromise.then(W,Q)})}return this.activePromise=g(),new Promise((W,Q)=>{this.activePromise.then(te=>{this.activePromise=null,W(te)},te=>{this.activePromise=null,Q(te)})})}dispose(){this.isDisposed=!0}}e.Throttler=u;class y{constructor(){this.current=Promise.resolve(null)}queue(g){return this.current=this.current.then(()=>g(),()=>g())}}e.Sequencer=y;class v{constructor(){this.promiseMap=new Map}queue(g,W){const te=(this.promiseMap.get(g)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(g)===te&&this.promiseMap.delete(g)});return this.promiseMap.set(g,te),te}}e.SequencerByKey=v;const l=(P,g)=>{let W=!0;const Q=setTimeout(()=>{W=!1,g()},P);return{isTriggered:()=>W,dispose:()=>{clearTimeout(Q),W=!1}}},n=P=>{let g=!0;return queueMicrotask(()=>{g&&(g=!1,P())}),{isTriggered:()=>g,dispose:()=>{g=!1}}};class i{constructor(g){this.defaultDelay=g,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(g,W=this.defaultDelay){this.task=g,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((te,ge)=>{this.doResolve=te,this.doReject=ge}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const te=this.task;return this.task=null,te()}}));const Q=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=W===L.MicrotaskDelay?n(Q):l(W,Q),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class s{constructor(g){this.delayer=new i(g),this.throttler=new u}trigger(g,W){return this.delayer.trigger(()=>this.throttler.queue(g),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=s;class o{constructor(){this._isOpen=!1,this._promise=new Promise((g,W)=>{this._completePromise=g})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class U extends o{constructor(g){super(),this._timeout=setTimeout(()=>this.open(),g)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=U;function m(P,g){return g?new Promise((W,Q)=>{const te=setTimeout(()=>{ge.dispose(),W()},P),ge=g.onCancellationRequested(()=>{clearTimeout(te),ge.dispose(),Q(new t.CancellationError)})}):w(W=>m(P,W))}function E(P,g=0,W){const Q=setTimeout(()=>{P(),W&&te.dispose()},g),te=(0,q.toDisposable)(()=>{clearTimeout(Q),W?.deleteAndLeak(te)});return W?.add(te),te}function h(P){const g=[];let W=0;const Q=P.length;function te(){return W<Q?P[W++]():null}function ge(ye){ye!=null&&g.push(ye);const Re=te();return Re?Re.then(ge):Promise.resolve(g)}return Promise.resolve(null).then(ge)}function d(P,g=Q=>!!Q,W=null){let Q=0;const te=P.length,ge=()=>{if(Q>=te)return Promise.resolve(W);const ye=P[Q++];return Promise.resolve(ye()).then(fe=>g(fe)?Promise.resolve(fe):ge())};return ge()}function F(P,g=Q=>!!Q,W=null){if(P.length===0)return Promise.resolve(W);let Q=P.length;const te=()=>{Q=-1;for(const ge of P)ge.cancel?.()};return new Promise((ge,ye)=>{for(const Re of P)Re.then(fe=>{--Q>=0&&g(fe)?(te(),ge(fe)):Q===0&&ge(W)}).catch(fe=>{--Q>=0&&(te(),ye(fe))})})}class c{constructor(g){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=g,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new $.Emitter}whenIdle(){return this.size>0?$.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(g){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((W,Q)=>{this.outstandingPromises.push({factory:g,c:W,e:Q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const g=this.outstandingPromises.shift();this.runningPromises++;const W=g.factory();W.then(g.c,g.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=c;class A extends c{constructor(){super(1)}}e.Queue=A;class j{constructor(){this.sequentializer=new O,this.tasks=0}queue(g){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,g())):this.sequentializer.run(this.tasks++,g())}}e.LimitedQueue=j;class Z{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const g=new R;return this.drainers.add(g),g.p}isDrained(){for(const[,g]of this.queues)if(g.size>0)return!1;return!0}queueSize(g,W=V.extUri){const Q=W.getComparisonKey(g);return this.queues.get(Q)?.size??0}queueFor(g,W,Q=V.extUri){const te=Q.getComparisonKey(g);let ge=this.queues.get(te);if(!ge){ge=new A;const ye=this.drainListenerCount++,Re=$.Event.once(ge.onDrained)(()=>{ge?.dispose(),this.queues.delete(te),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ye),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new q.DisposableMap),this.drainListeners.set(ye,Re),this.queues.set(te,ge)}return ge.queue(W)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const g of this.drainers)g.complete();this.drainers.clear()}dispose(){for(const[,g]of this.queues)g.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=Z;class x{constructor(g,W){this._isDisposed=!1,this._token=-1,typeof g=="function"&&typeof W=="number"&&this.setIfNotSet(g,W)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(g,W){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,g()},W)}setIfNotSet(g,W){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,g()},W))}}e.TimeoutTimer=x;class H{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(g,W,Q=globalThis){if(this.isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const te=Q.setInterval(()=>{g()},W);this.disposable=(0,q.toDisposable)(()=>{Q.clearInterval(te),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=H;class se{constructor(g,W){this.timeoutToken=-1,this.runner=g,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(g=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,g)}get delay(){return this.timeout}set delay(g){this.timeout=g}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=se;class K{constructor(g,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=g,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(g=this.timeout){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(g/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=K;class ie extends se{constructor(g,W){super(g,W),this.units=[]}work(g){this.units.push(g),this.isScheduled()||this.schedule()}doRun(){const g=this.units;this.units=[],this.runner?.(g)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ie;class oe extends q.Disposable{constructor(g,W){super(),this.options=g,this.handler=W,this.pendingWork=[],this.throttler=this._register(new q.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(g){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+g.length>this.options.maxBufferedWork)return!1}else if(this.pending+g.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const W of g)this.pendingWork.push(W);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new se(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=oe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(P,g)=>{(0,N.setTimeout0)(()=>{if(W)return;const Q=Date.now()+15;g(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e._runWhenIdle=(P,g,W)=>{const Q=P.requestIdleCallback(g,typeof W=="number"?{timeout:W}:void 0);let te=!1;return{dispose(){te||(te=!0,P.cancelIdleCallback(Q))}}},e.runWhenGlobalIdle=P=>(0,e._runWhenIdle)(globalThis,P)}();class re{constructor(g,W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(Q){this._error=Q}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(g,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=re;class I extends re{constructor(g){super(globalThis,g)}}e.GlobalIdleValue=I;async function _(P,g,W){let Q;for(let te=0;te<W;te++)try{return await P()}catch(ge){Q=ge,await m(g)}throw Q}class O{isRunning(g){return typeof g=="number"?this._running?.taskId===g:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(g,W,Q){return this._running={taskId:g,cancel:()=>Q?.(),promise:W},W.then(()=>this.doneRunning(g),()=>this.doneRunning(g)),W}doneRunning(g){this._running&&g===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const g=this._queued;this._queued=void 0,g.run().then(g.promiseResolve,g.promiseReject)}}queue(g){if(this._queued)this._queued.run=g;else{const{promise:W,resolve:Q,reject:te}=b();this._queued={run:g,promise:W,promiseResolve:Q,promiseReject:te}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=O;class C{constructor(g,W=()=>Date.now()){this.interval=g,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const g=this.nowFn();return g-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=g,this.value=0),this.value++,this.value}}e.IntervalCounter=C;var Y;(function(P){P[P.Resolved=0]="Resolved",P[P.Rejected=1]="Rejected"})(Y||(Y={}));class R{get isRejected(){return this.outcome?.outcome===Y.Rejected}get isResolved(){return this.outcome?.outcome===Y.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===Y.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((g,W)=>{this.completeCallback=g,this.errorCallback=W})}complete(g){return new Promise(W=>{this.completeCallback(g),this.outcome={outcome:Y.Resolved,value:g},W()})}error(g){return new Promise(W=>{this.errorCallback(g),this.outcome={outcome:Y.Rejected,value:g},W()})}cancel(){return this.error(new t.CancellationError)}}e.DeferredPromise=R;var X;(function(P){async function g(Q){let te;const ge=await Promise.all(Q.map(ye=>ye.then(Re=>Re,Re=>{te||(te=Re)})));if(typeof te<"u")throw te;return ge}P.settled=g;function W(Q){return new Promise(async(te,ge)=>{try{await Q(te,ge)}catch(ye){ge(ye)}})}P.withAsyncBody=W})(X||(e.Promises=X={}));class ee{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(g){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=g.then(W=>(this._value=W,this._isResolved=!0,W),W=>{throw this._error=W,this._isResolved=!0,W})}requireValue(){if(!this._isResolved)throw new t.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=ee;class ne{constructor(g){this._compute=g,this._promise=new T.Lazy(()=>new ee(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=ne;var le;(function(P){P[P.Initial=0]="Initial",P[P.DoneOK=1]="DoneOK",P[P.DoneError=2]="DoneError"})(le||(le={}));class he{static fromArray(g){return new he(W=>{W.emitMany(g)})}static fromPromise(g){return new he(async W=>{W.emitMany(await g)})}static fromPromises(g){return new he(async W=>{await Promise.all(g.map(async Q=>W.emitOne(await Q)))})}static merge(g){return new he(async W=>{await Promise.all(g.map(async Q=>{for await(const te of Q)W.emitOne(te)}))})}static{this.EMPTY=he.fromArray([])}constructor(g,W){this._state=le.Initial,this._results=[],this._error=null,this._onReturn=W,this._onStateChanged=new $.Emitter,queueMicrotask(async()=>{const Q={emitOne:te=>this.emitOne(te),emitMany:te=>this.emitMany(te),reject:te=>this.reject(te)};try{await Promise.resolve(g(Q)),this.resolve()}catch(te){this.reject(te)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let g=0;return{next:async()=>{do{if(this._state===le.DoneError)throw this._error;if(g<this._results.length)return{done:!1,value:this._results[g++]};if(this._state===le.DoneOK)return{done:!0,value:void 0};await $.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(g,W){return new he(async Q=>{for await(const te of g)Q.emitOne(W(te))})}map(g){return he.map(this,g)}static filter(g,W){return new he(async Q=>{for await(const te of g)W(te)&&Q.emitOne(te)})}filter(g){return he.filter(this,g)}static coalesce(g){return he.filter(g,W=>!!W)}coalesce(){return he.coalesce(this)}static async toPromise(g){const W=[];for await(const Q of g)W.push(Q);return W}toPromise(){return he.toPromise(this)}emitOne(g){this._state===le.Initial&&(this._results.push(g),this._onStateChanged.fire())}emitMany(g){this._state===le.Initial&&(this._results=this._results.concat(g),this._onStateChanged.fire())}resolve(){this._state===le.Initial&&(this._state=le.DoneOK,this._onStateChanged.fire())}reject(g){this._state===le.Initial&&(this._state=le.DoneError,this._error=g,this._onStateChanged.fire())}}e.AsyncIterableObject=he;class we extends he{constructor(g,W){super(W),this._source=g}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=we;function B(P){const g=new p.CancellationTokenSource,W=P(g.token);return new we(g,async Q=>{const te=g.token.onCancellationRequested(()=>{te.dispose(),g.dispose(),Q.reject(new t.CancellationError)});try{for await(const ge of W){if(g.token.isCancellationRequested)return;Q.emitOne(ge)}te.dispose(),g.dispose()}catch(ge){te.dispose(),g.dispose(),Q.reject(ge)}})}class z{constructor(g){this._deferred=new R,this._asyncIterable=new he(te=>{if(W){te.reject(W);return}return Q&&te.emitMany(Q),this._errorFn=ge=>te.reject(ge),this._emitFn=ge=>te.emitOne(ge),this._deferred.p},g);let W,Q;this._emitFn=te=>{Q||(Q=[]),Q.push(te)},this._errorFn=te=>{W||(W=te)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(g){this._errorFn(g),this._deferred.complete()}emitOne(g){this._emitFn(g)}}e.AsyncIterableSource=z}),define(Ee[23],pe([0,1,12,8,11,14,20,3,2,7]),function(ce,e,p,t,$,q,V,N,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=M,e.splitGlobAware=r,e.match=j,e.parse=Z,e.isRelativePattern=x,e.getBasenameTerms=H,e.getPathTerms=se,e.patternsEquals=re;function M(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const w="[/\\\\]",D="[^/\\\\]",k=/\//g;function a(I,_){switch(I){case 0:return"";case 1:return`${D}*?`;default:return`(?:${w}|${D}+${w}${_?`|${w}${D}+`:""})*?`}}function r(I,_){if(!I)return[];const O=[];let C=!1,Y=!1,R="";for(const X of I){switch(X){case _:if(!C&&!Y){O.push(R),R="";continue}break;case"{":C=!0;break;case"}":C=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}R+=X}return R&&O.push(R),O}function f(I){if(!I)return"";let _="";const O=r(I,e.GLOB_SPLIT);if(O.every(C=>C===e.GLOBSTAR))_=".*";else{let C=!1;O.forEach((Y,R)=>{if(Y===e.GLOBSTAR){if(C)return;_+=a(2,R===O.length-1)}else{let X=!1,ee="",ne=!1,le="";for(const he of Y){if(he!=="}"&&X){ee+=he;continue}if(ne&&(he!=="]"||!le)){let we;he==="-"?we=he:(he==="^"||he==="!")&&!le?we="^":he===e.GLOB_SPLIT?we="":we=(0,T.escapeRegExpCharacters)(he),le+=we;continue}switch(he){case"{":X=!0;continue;case"[":ne=!0;continue;case"}":{const B=`(?:${r(ee,",").map(z=>f(z)).join("|")})`;_+=B,X=!1,ee="";break}case"]":{_+="["+le+"]",ne=!1,le="";break}case"?":_+=D;continue;case"*":_+=a(1);continue;default:_+=(0,T.escapeRegExpCharacters)(he)}}R<O.length-1&&(O[R+1]!==e.GLOBSTAR||R+2<O.length)&&(_+=w)}C=Y===e.GLOBSTAR})}return _}const b=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new V.LRUCache(1e4),s=function(){return!1},o=function(){return null};function U(I,_){if(!I)return o;let O;typeof I!="string"?O=I.pattern:O=I,O=O.trim();const C=`${O}_${!!_.trimForExclusions}`;let Y=i.get(C);if(Y)return m(Y,I);let R;return b.test(O)?Y=h(O.substr(4),O):(R=u.exec(E(O,_)))?Y=d(R[1],O):(_.trimForExclusions?v:y).test(O)?Y=F(O,_):(R=l.exec(E(O,_)))?Y=c(R[1].substr(1),O,!0):(R=n.exec(E(O,_)))?Y=c(R[1],O,!1):Y=A(O),i.set(C,Y),m(Y,I)}function m(I,_){if(typeof _=="string")return I;const O=function(C,Y){return(0,q.isEqualOrParent)(C,_.base,!L.isLinux)?I((0,T.ltrim)(C.substr(_.base.length),N.sep),Y):null};return O.allBasenames=I.allBasenames,O.allPaths=I.allPaths,O.basenames=I.basenames,O.patterns=I.patterns,O}function E(I,_){return _.trimForExclusions&&I.endsWith("/**")?I.substr(0,I.length-2):I}function h(I,_){return function(O,C){return typeof O=="string"&&O.endsWith(I)?_:null}}function d(I,_){const O=`/${I}`,C=`\\${I}`,Y=function(X,ee){return typeof X!="string"?null:ee?ee===I?_:null:X===I||X.endsWith(O)||X.endsWith(C)?_:null},R=[I];return Y.basenames=R,Y.patterns=[_],Y.allBasenames=R,Y}function F(I,_){const O=oe(I.slice(1,-1).split(",").map(ee=>U(ee,_)).filter(ee=>ee!==o),I),C=O.length;if(!C)return o;if(C===1)return O[0];const Y=function(ee,ne){for(let le=0,he=O.length;le<he;le++)if(O[le](ee,ne))return I;return null},R=O.find(ee=>!!ee.allBasenames);R&&(Y.allBasenames=R.allBasenames);const X=O.reduce((ee,ne)=>ne.allPaths?ee.concat(ne.allPaths):ee,[]);return X.length&&(Y.allPaths=X),Y}function c(I,_,O){const C=N.sep===N.posix.sep,Y=C?I:I.replace(k,N.sep),R=N.sep+Y,X=N.posix.sep+I;let ee;return O?ee=function(ne,le){return typeof ne=="string"&&(ne===Y||ne.endsWith(R)||!C&&(ne===I||ne.endsWith(X)))?_:null}:ee=function(ne,le){return typeof ne=="string"&&(ne===Y||!C&&ne===I)?_:null},ee.allPaths=[(O?"*/":"./")+I],ee}function A(I){try{const _=new RegExp(`^${f(I)}$`);return function(O){return _.lastIndex=0,typeof O=="string"&&_.test(O)?I:null}}catch{return o}}function j(I,_,O){return!I||typeof _!="string"?!1:Z(I)(_,void 0,O)}function Z(I,_={}){if(!I)return s;if(typeof I=="string"||x(I)){const O=U(I,_);if(O===o)return s;const C=function(Y,R){return!!O(Y,R)};return O.allBasenames&&(C.allBasenames=O.allBasenames),O.allPaths&&(C.allPaths=O.allPaths),C}return K(I,_)}function x(I){const _=I;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}function H(I){return I.allBasenames||[]}function se(I){return I.allPaths||[]}function K(I,_){const O=oe(Object.getOwnPropertyNames(I).map(ee=>ie(ee,I[ee],_)).filter(ee=>ee!==o)),C=O.length;if(!C)return o;if(!O.some(ee=>!!ee.requiresSiblings)){if(C===1)return O[0];const ee=function(he,we){let B;for(let z=0,P=O.length;z<P;z++){const g=O[z](he,we);if(typeof g=="string")return g;(0,t.isThenable)(g)&&(B||(B=[]),B.push(g))}return B?(async()=>{for(const z of B){const P=await z;if(typeof P=="string")return P}return null})():null},ne=O.find(he=>!!he.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const le=O.reduce((he,we)=>we.allPaths?he.concat(we.allPaths):he,[]);return le.length&&(ee.allPaths=le),ee}const Y=function(ee,ne,le){let he,we;for(let B=0,z=O.length;B<z;B++){const P=O[B];P.requiresSiblings&&le&&(ne||(ne=(0,N.basename)(ee)),he||(he=ne.substr(0,ne.length-(0,N.extname)(ee).length)));const g=P(ee,ne,he,le);if(typeof g=="string")return g;(0,t.isThenable)(g)&&(we||(we=[]),we.push(g))}return we?(async()=>{for(const B of we){const z=await B;if(typeof z=="string")return z}return null})():null},R=O.find(ee=>!!ee.allBasenames);R&&(Y.allBasenames=R.allBasenames);const X=O.reduce((ee,ne)=>ne.allPaths?ee.concat(ne.allPaths):ee,[]);return X.length&&(Y.allPaths=X),Y}function ie(I,_,O){if(_===!1)return o;const C=U(I,O);if(C===o)return o;if(typeof _=="boolean")return C;if(_){const Y=_.when;if(typeof Y=="string"){const R=(X,ee,ne,le)=>{if(!le||!C(X,ee))return null;const he=Y.replace("$(basename)",()=>ne),we=le(he);return(0,t.isThenable)(we)?we.then(B=>B?I:null):we?I:null};return R.requiresSiblings=!0,R}}return C}function oe(I,_){const O=I.filter(ee=>!!ee.basenames);if(O.length<2)return I;const C=O.reduce((ee,ne)=>{const le=ne.basenames;return le?ee.concat(le):ee},[]);let Y;if(_){Y=[];for(let ee=0,ne=C.length;ee<ne;ee++)Y.push(_)}else Y=O.reduce((ee,ne)=>{const le=ne.patterns;return le?ee.concat(le):ee},[]);const R=function(ee,ne){if(typeof ee!="string")return null;if(!ne){let he;for(he=ee.length;he>0;he--){const we=ee.charCodeAt(he-1);if(we===$.CharCode.Slash||we===$.CharCode.Backslash)break}ne=ee.substr(he)}const le=C.indexOf(ne);return le!==-1?Y[le]:null};R.basenames=C,R.patterns=Y,R.allBasenames=C;const X=I.filter(ee=>!ee.basenames);return X.push(R),X}function re(I,_){return(0,p.equals)(I,_,(O,C)=>typeof O=="string"&&typeof C=="string"?O===C:typeof O!="string"&&typeof C!="string"?O.base===C.base&&O.pattern===C.pattern:!1)}}),define(Ee[24],pe([0,1,15,50,60,8,14,21,3,2,22,5]),function(ce,e,p,t,$,q,V,N,L,T,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=y,e.whenDeleted=n,e.configureFlushOnWrite=m,e.writeFileSync=h,p=Ie(p);var D;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(D||(e.RimRafMode=D={}));async function k(K,ie=D.UNLINK,oe){if((0,V.isRootOrDriveLetter)(K))throw new Error("rimraf - will refuse to recursively delete root");return ie===D.UNLINK?r(K):a(K,oe)}async function a(K,ie=(0,V.randomPath)((0,t.tmpdir)())){try{try{await p.promises.rename(K,ie)}catch(oe){return oe.code==="ENOENT"?void 0:r(K)}r(ie).catch(oe=>{})}catch(oe){if(oe.code!=="ENOENT")throw oe}}async function r(K){return p.promises.rm(K,{recursive:!0,force:!0,maxRetries:3})}function f(K){if((0,V.isRootOrDriveLetter)(K))throw new Error("rimraf - will refuse to recursively delete root");p.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}async function b(K,ie){return v(await(ie?u(K):p.promises.readdir(K)))}async function u(K){try{return await p.promises.readdir(K,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const ie=[],oe=await b(K);for(const re of oe){let I=!1,_=!1,O=!1;try{const C=await p.promises.lstat((0,L.join)(K,re));I=C.isFile(),_=C.isDirectory(),O=C.isSymbolicLink()}catch(C){console.warn("[node.js fs] unexpected error from lstat after readdir: ",C)}ie.push({name:re,isFile:()=>I,isDirectory:()=>_,isSymbolicLink:()=>O})}return ie}function y(K){return v(p.readdirSync(K))}function v(K){return K.map(ie=>typeof ie=="string"?T.isMacintosh?(0,N.normalizeNFC)(ie):ie:(ie.name=T.isMacintosh?(0,N.normalizeNFC)(ie.name):ie.name,ie))}async function l(K){const ie=await b(K),oe=[];for(const re of ie)await i.existsDirectory((0,L.join)(K,re))&&oe.push(re);return oe}function n(K,ie=1e3){return new Promise(oe=>{let re=!1;const I=setInterval(()=>{re||(re=!0,p.access(K,_=>{re=!1,_&&(clearInterval(I),oe(void 0))}))},ie)})}var i;(function(K){async function ie(I){let _;try{if(_=await p.promises.lstat(I),!_.isSymbolicLink())return{stat:_}}catch{}try{return{stat:await p.promises.stat(I),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(T.isWindows&&O.code==="EACCES")try{return{stat:await p.promises.stat(await p.promises.readlink(I)),symbolicLink:{dangling:!1}}}catch(C){if(C.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw C}throw O}}K.stat=ie;async function oe(I){try{const{stat:_,symbolicLink:O}=await K.stat(I);return _.isFile()&&O?.dangling!==!0}catch{}return!1}K.existsFile=oe;async function re(I){try{const{stat:_,symbolicLink:O}=await K.stat(I);return _.isDirectory()&&O?.dangling!==!0}catch{}return!1}K.existsDirectory=re})(i||(e.SymlinkSupport=i={}));const s=new q.ResourceQueue;function o(K,ie,oe){return s.queueFor(w.URI.file(K),()=>{const re=d(oe);return new Promise((I,_)=>E(K,ie,re,O=>O?_(O):I()))},M.extUriBiasedIgnorePathCase)}let U=!0;function m(K){U=K}function E(K,ie,oe,re){if(!U)return p.writeFile(K,ie,{mode:oe.mode,flag:oe.flag},re);p.open(K,oe.flag,oe.mode,(I,_)=>{if(I)return re(I);p.writeFile(_,ie,O=>{if(O)return p.close(_,()=>re(O));p.fdatasync(_,C=>(C&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",C),m(!1)),p.close(_,Y=>re(Y))))})})}function h(K,ie,oe){const re=d(oe);if(!U)return p.writeFileSync(K,ie,{mode:re.mode,flag:re.flag});const I=p.openSync(K,re.flag,re.mode);try{p.writeFileSync(I,ie);try{p.fdatasyncSync(I)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),m(!1)}}finally{p.closeSync(I)}}function d(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function F(K,ie,oe=6e4){if(K!==ie)try{T.isWindows&&typeof oe=="number"?await c(K,ie,Date.now(),oe):await p.promises.rename(K,ie)}catch(re){if(K.toLowerCase()!==ie.toLowerCase()&&re.code==="EXDEV"||K.endsWith("."))await A(K,ie,{preserveSymlinks:!1}),await k(K,D.MOVE);else throw re}}async function c(K,ie,oe,re,I=0){try{return await p.promises.rename(K,ie)}catch(_){if(_.code!=="EACCES"&&_.code!=="EPERM"&&_.code!=="EBUSY")throw _;if(Date.now()-oe>=re)throw console.error(`[node.js fs] rename failed after ${I} retries with error: ${_}`),_;if(I===0){let O=!1;try{const{stat:C}=await i.stat(ie);C.isFile()||(O=!0)}catch{}if(O)throw _}return await(0,q.timeout)(Math.min(100,I*10)),c(K,ie,oe,re,I+1)}}async function A(K,ie,oe){return Z(K,ie,{root:{source:K,target:ie},options:oe,handledSourcePaths:new Set})}const j=511;async function Z(K,ie,oe){if(oe.handledSourcePaths.has(K))return;oe.handledSourcePaths.add(K);const{stat:re,symbolicLink:I}=await i.stat(K);if(I){if(oe.options.preserveSymlinks)try{return await se(K,ie,oe)}catch{}if(I.dangling)return}return re.isDirectory()?x(K,ie,re.mode&j,oe):H(K,ie,re.mode&j)}async function x(K,ie,oe,re){await p.promises.mkdir(ie,{recursive:!0,mode:oe});const I=await b(K);for(const _ of I)await Z((0,L.join)(K,_),(0,L.join)(ie,_),re)}async function H(K,ie,oe){await p.promises.copyFile(K,ie),await p.promises.chmod(ie,oe)}async function se(K,ie,oe){let re=await p.promises.readlink(K);(0,V.isEqualOrParent)(re,oe.root.source,!T.isLinux)&&(re=(0,L.join)(oe.root.target,re.substr(oe.root.source.length+1))),await p.promises.symlink(re,ie)}e.Promises=new class{get read(){return(K,ie,oe,re,I)=>new Promise((_,O)=>{p.read(K,ie,oe,re,I,(C,Y,R)=>C?O(C):_({bytesRead:Y,buffer:R}))})}get write(){return(K,ie,oe,re,I)=>new Promise((_,O)=>{p.write(K,ie,oe,re,I,(C,Y,R)=>C?O(C):_({bytesWritten:Y,buffer:R}))})}get fdatasync(){return(0,$.promisify)(p.fdatasync)}get open(){return(0,$.promisify)(p.open)}get close(){return(0,$.promisify)(p.close)}get realpath(){return(0,$.promisify)(p.realpath)}async exists(K){try{return await p.promises.access(K),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return l}get writeFile(){return o}get rm(){return k}get rename(){return F}get copy(){return A}}}),define(Ee[32],pe([0,1,15,3,2,7,24]),function(ce,e,p,t,$,q,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=N,e.realcase=L,e.realpath=T,e.realpathSync=M,p=Ie(p);function N(D){if($.isLinux)return D;const k=(0,t.dirname)(D);if(D===k)return D;const a=((0,t.basename)(D)||D).toLowerCase();try{const f=(0,V.readdirSync)(k).filter(b=>b.toLowerCase()===a);if(f.length===1){const b=N(k);if(b)return(0,t.join)(b,f[0])}else if(f.length>1){const b=f.indexOf(a);if(b>=0){const u=N(k);if(u)return(0,t.join)(u,f[b])}}}catch{}return null}async function L(D,k){if($.isLinux)return D;const a=(0,t.dirname)(D);if(D===a)return D;const r=((0,t.basename)(D)||D).toLowerCase();try{if(k?.isCancellationRequested)return null;const b=(await V.Promises.readdir(a)).filter(u=>u.toLowerCase()===r);if(b.length===1){const u=await L(a,k);if(u)return(0,t.join)(u,b[0])}else if(b.length>1){const u=b.indexOf(r);if(u>=0){const y=await L(a,k);if(y)return(0,t.join)(y,b[u])}}}catch{}return null}async function T(D){try{return await V.Promises.realpath(D)}catch{const a=w(D);return await p.promises.access(a,p.constants.R_OK),a}}function M(D){try{return p.realpathSync(D)}catch{const a=w(D);return p.accessSync(a,p.constants.R_OK),a}}function w(D){return(0,q.rtrim)((0,t.normalize)(D),t.sep)}}),define(Ee[51],pe([0,1,15,3,2,28,29,10,24]),function(ce,e,p,t,$,q,V,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=T,e.createQueuedSender=M,t=Ie(t),$=Ie($),q=Ie(q),N=Ie(N),L=Ie(L),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return V.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return V.TerminateResponseCode}});function T(D=q.env){return D.comspec||"cmd.exe"}function M(D){let k=[],a=!1;const r=function(f){if(a){k.push(f);return}(!D.send(f,u=>{if(u&&console.error(u),a=!1,k.length>0){const y=k.slice(0);k=[],y.forEach(v=>r(v))}})||$.isWindows)&&(a=!0)};return{send:r}}var w;(function(D){async function k(a,r,f){if(t.isAbsolute(a))return a;if(r===void 0&&(r=q.cwd()),t.dirname(a)!=="."||(f===void 0&&N.isString(q.env.PATH)&&(f=q.env.PATH.split(t.delimiter)),f===void 0||f.length===0))return t.join(r,a);async function u(y){if(await L.Promises.exists(y)){let v;try{v=await p.promises.stat(y)}catch(l){l.message.startsWith("EACCES")&&(v=await p.promises.lstat(y))}return v?!v.isDirectory():!1}return!1}for(const y of f){let v;if(t.isAbsolute(y)?v=t.join(y,a):v=t.join(r,y,a),await u(v))return v;let l=v+".com";if(await u(l)||(l=v+".exe",await u(l)))return l}return t.join(r,a)}D.findExecutable=k})(w||(e.win32=w={}))});var Xe=this&&this.__decorate||function(ce,e,p,t){var $=arguments.length,q=$<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,p):t,V;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")q=Reflect.decorate(ce,e,p,t);else for(var N=ce.length-1;N>=0;N--)(V=ce[N])&&(q=($<3?V(q):$>3?V(e,p,q):V(e,p))||q);return $>3&&q&&Object.defineProperty(e,p,q),q};define(Ee[25],pe([0,1,12,8,17,13,39,9,6,4,49,7,10]),function(ce,e,p,t,$,q,V,N,L,T,M,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=m,e.deserialize=E,e.getDelayedChannel=j,e.getNextTickChannel=Z,w=Ie(w);var k;(function(I){I[I.Promise=100]="Promise",I[I.PromiseCancel=101]="PromiseCancel",I[I.EventListen=102]="EventListen",I[I.EventDispose=103]="EventDispose"})(k||(k={}));function a(I){switch(I){case k.Promise:return"req";case k.PromiseCancel:return"cancel";case k.EventListen:return"subscribe";case k.EventDispose:return"unsubscribe"}}var r;(function(I){I[I.Initialize=200]="Initialize",I[I.PromiseSuccess=201]="PromiseSuccess",I[I.PromiseError=202]="PromiseError",I[I.PromiseErrorObj=203]="PromiseErrorObj",I[I.EventFire=204]="EventFire"})(r||(r={}));function f(I){switch(I){case r.Initialize:return"init";case r.PromiseSuccess:return"reply:";case r.PromiseError:case r.PromiseErrorObj:return"replyErr:";case r.EventFire:return"event:"}}var b;(function(I){I[I.Uninitialized=0]="Uninitialized",I[I.Idle=1]="Idle"})(b||(b={}));function u(I){let _=0;for(let O=0;;O+=7){const C=I.read(1);if(_|=(C.buffer[0]&127)<<O,!(C.buffer[0]&128))return _}}const y=s(0);function v(I,_){if(_===0){I.write(y);return}let O=0;for(let Y=_;Y!==0;Y=Y>>>7)O++;const C=$.VSBuffer.alloc(O);for(let Y=0;_!==0;Y++)C.buffer[Y]=_&127,_=_>>>7,_>0&&(C.buffer[Y]|=128);I.write(C)}class l{constructor(_){this.buffer=_,this.pos=0}read(_){const O=this.buffer.slice(this.pos,this.pos+_);return this.pos+=O.byteLength,O}}e.BufferReader=l;class n{constructor(){this.buffers=[]}get buffer(){return $.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}e.BufferWriter=n;var i;(function(I){I[I.Undefined=0]="Undefined",I[I.String=1]="String",I[I.Buffer=2]="Buffer",I[I.VSBuffer=3]="VSBuffer",I[I.Array=4]="Array",I[I.Object=5]="Object",I[I.Int=6]="Int"})(i||(i={}));function s(I){const _=$.VSBuffer.alloc(1);return _.writeUInt8(I,0),_}const o={Undefined:s(i.Undefined),String:s(i.String),Buffer:s(i.Buffer),VSBuffer:s(i.VSBuffer),Array:s(i.Array),Object:s(i.Object),Uint:s(i.Int)},U=typeof Buffer<"u";function m(I,_){if(typeof _>"u")I.write(o.Undefined);else if(typeof _=="string"){const O=$.VSBuffer.fromString(_);I.write(o.String),v(I,O.byteLength),I.write(O)}else if(U&&Buffer.isBuffer(_)){const O=$.VSBuffer.wrap(_);I.write(o.Buffer),v(I,O.byteLength),I.write(O)}else if(_ instanceof $.VSBuffer)I.write(o.VSBuffer),v(I,_.byteLength),I.write(_);else if(Array.isArray(_)){I.write(o.Array),v(I,_.length);for(const O of _)m(I,O)}else if(typeof _=="number"&&(_|0)===_)I.write(o.Uint),v(I,_);else{const O=$.VSBuffer.fromString(JSON.stringify(_));I.write(o.Object),v(I,O.byteLength),I.write(O)}}function E(I){switch(I.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return I.read(u(I)).toString();case i.Buffer:return I.read(u(I)).buffer;case i.VSBuffer:return I.read(u(I));case i.Array:{const O=u(I),C=[];for(let Y=0;Y<O;Y++)C.push(E(I));return C}case i.Object:return JSON.parse(I.read(u(I)).toString());case i.Int:return u(I)}}class h{constructor(_,O,C=null,Y=1e3){this.protocol=_,this.ctx=O,this.logger=C,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(R=>this.onRawMessage(R)),this.sendResponse({type:r.Initialize})}registerChannel(_,O){this.channels.set(_,O),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case r.Initialize:{const O=this.send([_.type]);this.logger?.logOutgoing(O,0,d.OtherSide,f(_.type));return}case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:{const O=this.send([_.type,_.id],_.data);this.logger?.logOutgoing(O,_.id,d.OtherSide,f(_.type),_.data);return}}}send(_,O=void 0){const C=new n;return m(C,_),m(C,O),this.sendBuffer(C.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onRawMessage(_){const O=new l(_),C=E(O),Y=E(O),R=C[0];switch(R){case k.Promise:return this.logger?.logIncoming(_.byteLength,C[1],d.OtherSide,`${a(R)}: ${C[2]}.${C[3]}`,Y),this.onPromise({type:R,id:C[1],channelName:C[2],name:C[3],arg:Y});case k.EventListen:return this.logger?.logIncoming(_.byteLength,C[1],d.OtherSide,`${a(R)}: ${C[2]}.${C[3]}`,Y),this.onEventListen({type:R,id:C[1],channelName:C[2],name:C[3],arg:Y});case k.PromiseCancel:return this.logger?.logIncoming(_.byteLength,C[1],d.OtherSide,`${a(R)}`),this.disposeActiveRequest({type:R,id:C[1]});case k.EventDispose:return this.logger?.logIncoming(_.byteLength,C[1],d.OtherSide,`${a(R)}`),this.disposeActiveRequest({type:R,id:C[1]})}}onPromise(_){const O=this.channels.get(_.channelName);if(!O){this.collectPendingRequest(_);return}const C=new q.CancellationTokenSource;let Y;try{Y=O.call(this.ctx,_.name,_.arg,C.token)}catch(ee){Y=Promise.reject(ee)}const R=_.id;Y.then(ee=>{this.sendResponse({id:R,data:ee,type:r.PromiseSuccess})},ee=>{ee instanceof Error?this.sendResponse({id:R,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split(`
`):void 0},type:r.PromiseError}):this.sendResponse({id:R,data:ee,type:r.PromiseErrorObj})}).finally(()=>{X.dispose(),this.activeRequests.delete(_.id)});const X=(0,T.toDisposable)(()=>C.cancel());this.activeRequests.set(_.id,X)}onEventListen(_){const O=this.channels.get(_.channelName);if(!O){this.collectPendingRequest(_);return}const C=_.id,R=O.listen(this.ctx,_.name,_.arg)(X=>this.sendResponse({id:C,data:X,type:r.EventFire}));this.activeRequests.set(_.id,R)}disposeActiveRequest(_){const O=this.activeRequests.get(_.id);O&&(O.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let O=this.pendingRequests.get(_.channelName);O||(O=[],this.pendingRequests.set(_.channelName,O));const C=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===k.Promise&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:r.PromiseError})},this.timeoutDelay);O.push({request:_,timeoutTimer:C})}flushPendingRequests(_){const O=this.pendingRequests.get(_);if(O){for(const C of O)switch(clearTimeout(C.timeoutTimer),C.request.type){case k.Promise:this.onPromise(C.request);break;case k.EventListen:this.onEventListen(C.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,T.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=h;var d;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(d||(e.RequestInitiator=d={}));class F{constructor(_,O=null){this.protocol=_,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new L.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(C=>this.onBuffer(C)),this.logger=O}getChannel(_){const O=this;return{call(C,Y,R){return O.isDisposed?Promise.reject(new N.CancellationError):O.requestPromise(_,C,Y,R)},listen(C,Y){return O.isDisposed?L.Event.None:O.requestEvent(_,C,Y)}}}requestPromise(_,O,C,Y=q.CancellationToken.None){const R=this.lastRequestId++,X=k.Promise,ee={id:R,type:X,channelName:_,name:O,arg:C};if(Y.isCancellationRequested)return Promise.reject(new N.CancellationError);let ne;return new Promise((he,we)=>{if(Y.isCancellationRequested)return we(new N.CancellationError);const B=()=>{const W=Q=>{switch(Q.type){case r.PromiseSuccess:this.handlers.delete(R),he(Q.data);break;case r.PromiseError:{this.handlers.delete(R);const te=new Error(Q.data.message);te.stack=Array.isArray(Q.data.stack)?Q.data.stack.join(`
`):Q.data.stack,te.name=Q.data.name,we(te);break}case r.PromiseErrorObj:this.handlers.delete(R),we(Q.data);break}};this.handlers.set(R,W),this.sendRequest(ee)};let z=null;this.state===b.Idle?B():(z=(0,t.createCancelablePromise)(W=>this.whenInitialized()),z.then(()=>{z=null,B()}));const P=()=>{z?(z.cancel(),z=null):this.sendRequest({id:R,type:k.PromiseCancel}),we(new N.CancellationError)},g=Y.onCancellationRequested(P);ne=(0,T.combinedDisposable)((0,T.toDisposable)(P),g),this.activeRequests.add(ne)}).finally(()=>{ne.dispose(),this.activeRequests.delete(ne)})}requestEvent(_,O,C){const Y=this.lastRequestId++,R=k.EventListen,X={id:Y,type:R,channelName:_,name:O,arg:C};let ee=null;const ne=new L.Emitter({onWillAddFirstListener:()=>{ee=(0,t.createCancelablePromise)(he=>this.whenInitialized()),ee.then(()=>{ee=null,this.activeRequests.add(ne),this.sendRequest(X)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.activeRequests.delete(ne),this.sendRequest({id:Y,type:k.EventDispose}))}}),le=he=>ne.fire(he.data);return this.handlers.set(Y,le),ne.event}sendRequest(_){switch(_.type){case k.Promise:case k.EventListen:{const O=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger?.logOutgoing(O,_.id,d.LocalSide,`${a(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case k.PromiseCancel:case k.EventDispose:{const O=this.send([_.type,_.id]);this.logger?.logOutgoing(O,_.id,d.LocalSide,a(_.type));return}}}send(_,O=void 0){const C=new n;return m(C,_),m(C,O),this.sendBuffer(C.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onBuffer(_){const O=new l(_),C=E(O),Y=E(O),R=C[0];switch(R){case r.Initialize:return this.logger?.logIncoming(_.byteLength,0,d.LocalSide,f(R)),this.onResponse({type:C[0]});case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:return this.logger?.logIncoming(_.byteLength,C[1],d.LocalSide,f(R),Y),this.onResponse({type:C[0],id:C[1],data:Y})}}onResponse(_){if(_.type===r.Initialize){this.state=b.Idle,this._onDidInitialize.fire();return}this.handlers.get(_.id)?.(_)}get onDidInitializePromise(){return L.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,T.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=F,Xe([V.memoize],F.prototype,"onDidInitializePromise",null);class c{get connections(){const _=[];return this._connections.forEach(O=>_.push(O)),_}constructor(_,O,C){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new L.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new L.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new T.DisposableStore,this.disposables.add(_(({protocol:Y,onDidClientDisconnect:R})=>{const X=L.Event.once(Y.onMessage);this.disposables.add(X(ee=>{const ne=new l(ee),le=E(ne),he=new h(Y,le,O,C),we=new F(Y,O);this.channels.forEach((z,P)=>he.registerChannel(P,z));const B={channelServer:he,channelClient:we,ctx:le};this._connections.add(B),this._onDidAddConnection.fire(B),this.disposables.add(R(()=>{he.dispose(),we.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)}))}))}))}getChannel(_,O){const C=this;return{call(Y,R,X){let ee;if((0,D.isFunction)(O)){const le=(0,p.getRandomElement)(C.connections.filter(O));ee=le?Promise.resolve(le):L.Event.toPromise(L.Event.filter(C.onDidAddConnection,O))}else ee=O.routeCall(C,Y,R);const ne=ee.then(le=>le.channelClient.getChannel(_));return j(ne).call(Y,R,X)},listen(Y,R){if((0,D.isFunction)(O))return C.getMulticastEvent(_,O,Y,R);const X=O.routeEvent(C,Y,R).then(ee=>ee.channelClient.getChannel(_));return j(X).listen(Y,R)}}}getMulticastEvent(_,O,C,Y){const R=this;let X;const ee=new L.Emitter({onWillAddFirstListener:()=>{X=new T.DisposableStore;const ne=new L.EventMultiplexer,le=new Map,he=B=>{const P=B.channelClient.getChannel(_).listen(C,Y),g=ne.add(P);le.set(B,g)},we=B=>{const z=le.get(B);z&&(z.dispose(),le.delete(B))};R.connections.filter(O).forEach(he),L.Event.filter(R.onDidAddConnection,O)(he,void 0,X),R.onDidRemoveConnection(we,void 0,X),ne.event(ee.fire,ee,X),X.add(ne)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return ee.event}registerChannel(_,O){this.channels.set(_,O);for(const C of this._connections)C.channelServer.registerChannel(_,O)}dispose(){this.disposables.dispose();for(const _ of this._connections)_.channelClient.dispose(),_.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=c;class A{constructor(_,O,C=null){const Y=new n;m(Y,O),_.send(Y.buffer),this.channelClient=new F(_,C),this.channelServer=new h(_,O,C)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,O){this.channelServer.registerChannel(_,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function j(I){return{call(_,O,C){return I.then(Y=>Y.call(_,O,C))},listen(_,O){const C=new L.Relay;return I.then(Y=>C.input=Y.listen(_,O)),C.event}}}function Z(I){let _=!1;return{call(O,C,Y){return _?I.call(O,C,Y):(0,t.timeout)(0).then(()=>_=!0).then(()=>I.call(O,C,Y))},listen(O,C){if(_)return I.listen(O,C);const Y=new L.Relay;return(0,t.timeout)(0).then(()=>_=!0).then(()=>Y.input=I.listen(O,C)),Y.event}}}class x{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const O of _.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await L.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=x;var H;(function(I){function _(R,X,ee){const ne=R,le=ee&&ee.disableMarshalling,he=new Map;for(const we in ne)C(we)&&he.set(we,L.Event.buffer(ne[we],!0,void 0,X));return new class{listen(we,B,z){const P=he.get(B);if(P)return P;const g=ne[B];if(typeof g=="function"){if(Y(B))return g.call(ne,z);if(C(B))return he.set(B,L.Event.buffer(ne[B],!0,void 0,X)),he.get(B)}throw new N.ErrorNoTelemetry(`Event not found: ${B}`)}call(we,B,z){const P=ne[B];if(typeof P=="function"){if(!le&&Array.isArray(z))for(let W=0;W<z.length;W++)z[W]=(0,M.revive)(z[W]);let g=P.apply(ne,z);return g instanceof Promise||(g=Promise.resolve(g)),g}throw new N.ErrorNoTelemetry(`Method not found: ${B}`)}}}I.fromService=_;function O(R,X){const ee=X&&X.disableMarshalling;return new Proxy({},{get(ne,le){if(typeof le=="string")return X?.properties?.has(le)?X.properties.get(le):Y(le)?function(he){return R.listen(le,he)}:C(le)?R.listen(le):async function(...he){let we;X&&!(0,D.isUndefinedOrNull)(X.context)?we=[X.context,...he]:we=he;const B=await R.call(le,we);return ee?B:(0,M.revive)(B)};throw new N.ErrorNoTelemetry(`Property not found: ${String(le)}`)}})}I.toService=O;function C(R){return R[0]==="o"&&R[1]==="n"&&w.isUpperAsciiLetter(R.charCodeAt(2))}function Y(R){return/^onDynamic/.test(R)&&w.isUpperAsciiLetter(R.charCodeAt(9))}})(H||(e.ProxyChannel=H={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(I){if(Array.isArray(I))return I;if(I&&typeof I=="object"&&typeof I.toString=="function"){const _=I.toString();if(_!=="[object Object]")return _}return I}function ie(I){return Array.isArray(I)?I.map(K):K(I)}function oe(I,_,O,C,Y,R,X){X=ie(X);const ee=se[Y],ne=ee[C%ee.length];let le=[`%c[${I}]%c[${String(_).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(C).padStart(5," ")} - ${R}`,"color: darkgreen","color: grey","color: grey",`color: ${ne}`];/\($/.test(R)?(le=le.concat(X),le.push(")")):le.push(X),console.log.apply(console,le)}class re{constructor(_,O){this._outgoingPrefix=_,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,O,C,Y,R){this._totalOutgoing+=_,oe(this._outgoingPrefix,this._totalOutgoing,_,O,C,Y,R)}logIncoming(_,O,C,Y,R){this._totalIncoming+=_,oe(this._incomingPrefix,this._totalIncoming,_,O,C,Y,R)}}e.IPCLogger=re}),define(Ee[52],pe([0,1,61,8,17,13,48,9,6,4,46,51,29,25]),function(ce,e,p,t,$,q,V,N,L,T,M,w,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,N=Ie(N);class a extends k.ChannelServer{constructor(b){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:L.Event.fromNodeEventEmitter(process,"message",u=>$.VSBuffer.wrap(Buffer.from(u,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.Server=a;class r{constructor(b,u){this.modulePath=b,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new L.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new t.Delayer(y),this.child=null,this._client=null}getChannel(b){const u=this;return{call(y,v,l){return u.requestPromise(b,y,v,l)},listen(y,v){return u.requestEvent(b,y,v)}}}requestPromise(b,u,y,v=q.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(N.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(b),n=(0,t.createCancelablePromise)(o=>l.call(u,y,o)),i=v.onCancellationRequested(()=>n.cancel()),s=(0,T.toDisposable)(()=>n.cancel());return this.activeRequests.add(s),n.finally(()=>{i.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(b,u,y){if(!this.disposeDelayer)return L.Event.None;this.disposeDelayer.cancel();let v;const l=new L.Emitter({onWillAddFirstListener:()=>{v=this.getCachedChannel(b).listen(u,y)(l.fire,l),this.activeRequests.add(v)},onDidRemoveLastListener:()=>{this.activeRequests.delete(v),v.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,M.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(m=>!/^--inspect(-brk)?=/.test(m)).filter(m=>!m.startsWith("--vscode-"))),(0,D.removeDangerousEnvVariables)(u.env),this.child=(0,p.fork)(this.modulePath,b,u);const y=new L.Emitter,l=L.Event.fromNodeEventEmitter(this.child,"message",m=>m)(m=>{if((0,V.isRemoteConsoleLog)(m)){(0,V.log)(m,`IPC Library: ${this.options.serverName}`);return}y.fire($.VSBuffer.wrap(Buffer.from(m,"base64")))}),n=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,i=m=>this.child&&this.child.connected&&n.send(m.buffer.toString("base64")),s=y.event,o={send:i,onMessage:s};this._client=new k.ChannelClient(o);const U=()=>this.disposeClient();process.once("exit",U),this.child.on("error",m=>console.warn('IPC "'+this.options.serverName+'" errored with '+m)),this.child.on("exit",(m,E)=>{process.removeListener("exit",U),l.dispose(),this.activeRequests.forEach(h=>(0,T.dispose)(h)),this.activeRequests.clear(),m!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+m+" and signal "+E),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:m,signal:E})})}return this._client}getCachedChannel(b){let u=this.channels.get(b);return u||(u=this.client.getChannel(b),this.channels.set(b,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=r}),define(Ee[33],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=p;function p(t){return!!t.parentPort}}),define(Ee[53],pe([0,1,33,17,25,6,10,12]),function(ce,e,p,t,$,q,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=M;class L{constructor(D){this.port=D,this.onMessage=q.Event.fromNodeEventEmitter(this.port,"message",k=>k.data?t.VSBuffer.wrap(k.data):t.VSBuffer.alloc(0)),D.start()}send(D){this.port.postMessage(D.buffer)}disconnect(){this.port.close()}}class T extends $.IPCServer{static getOnDidClientConnect(D){(0,V.assertType)((0,p.isUtilityProcess)(process),"Electron Utility Process");const k=new q.Emitter;return process.parentPort.on("message",a=>{if(D?.handledClientConnection(a))return;const r=(0,N.firstOrDefault)(a.ports);r&&k.fire(r)}),q.Event.map(k.event,a=>({protocol:new L(a),onDidClientDisconnect:q.Event.fromNodeEventEmitter(a,"close")}))}constructor(D){super(T.getOnDidClientConnect(D))}}e.Server=T;function M(w,D,k){const a=r=>{r.data===D&&(w.removeListener("message",a),k())};w.on("message",a)}}),define(Ee[34],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=$,e.localize2=V;const p=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function t(N,L){let T;return L.length===0?T=N:T=N.replace(/\{(\d+)\}/g,(M,w)=>{const D=w[0],k=L[D];let a=M;return typeof k=="string"?a=k:(typeof k=="number"||typeof k=="boolean"||k===void 0||k===null)&&(a=String(k)),a}),p&&(T="\uFF3B"+T.replace(/[aouei]/g,"$&$&")+"\uFF3D"),T}function $(N,L,...T){return t(typeof N=="number"?q(N,L):L,T)}function q(N,L){const T=globalThis._VSCODE_NLS_MESSAGES?.[N];if(typeof T!="string"){if(typeof L=="string")return L;throw new Error(`!!! NLS MISSING: ${N} !!!`)}return T}function V(N,L,...T){let M;typeof N=="number"?M=q(N,L):M=L;const w=t(M,T);return{value:w,original:L===M?w:t(L,T)}}}),define(Ee[54],pe([0,1,12,10,34]),function(ce,e,p,t,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=L,e.isErrorWithActions=T,e.createErrorWithActions=M,p=Ie(p),t=Ie(t),$=Ie($);function q(w,D){return D&&(w.stack||w.stacktrace)?$.localize(12979,null,N(w),V(w.stack)||V(w.stacktrace)):N(w)}function V(w){return Array.isArray(w)?w.join(`
`):w}function N(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?$.localize(12980,null,w.message):w.message||$.localize(12981,null)}function L(w=null,D=!1){if(!w)return $.localize(12982,null);if(Array.isArray(w)){const k=p.coalesce(w),a=L(k[0],D);return k.length>1?$.localize(12983,null,a,k.length):a}if(t.isString(w))return w;if(w.detail){const k=w.detail;if(k.error)return q(k.error,D);if(k.exception)return q(k.exception,D)}return w.stack?q(w,D):w.message?w.message:$.localize(12984,null)}function T(w){const D=w;return D instanceof Error&&Array.isArray(D.actions)}function M(w,D){let k;return typeof w=="string"?k=new Error(w):k=w,k.actions=D,k}}),define(Ee[55],pe([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=$,e.refineServiceDecorator=q;var p;(function(V){V.serviceIds=new Map,V.DI_TARGET="$di$target",V.DI_DEPENDENCIES="$di$dependencies";function N(L){return L[V.DI_DEPENDENCIES]||[]}V.getServiceDependencies=N})(p||(e._util=p={})),e.IInstantiationService=$("instantiationService");function t(V,N,L){N[p.DI_TARGET]===N?N[p.DI_DEPENDENCIES].push({id:V,index:L}):(N[p.DI_DEPENDENCIES]=[{id:V,index:L}],N[p.DI_TARGET]=N)}function $(V){if(p.serviceIds.has(V))return p.serviceIds.get(V);const N=function(L,T,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(N,L,M)};return N.toString=()=>V,p.serviceIds.set(V,N),N}function q(V){return V}}),define(Ee[18],pe([0,1,30,3,7,10,5,34,55,2,31,16]),function(ce,e,p,t,$,q,V,N,L,T,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=D,e.isFileSystemWatcher=f,e.hasReadWriteCapability=u,e.hasFileFolderCopyCapability=y,e.hasFileCloneCapability=v,e.hasOpenReadWriteCloseCapability=l,e.hasFileReadStreamCapability=n,e.hasFileAtomicReadCapability=i,e.hasFileAtomicWriteCapability=s,e.hasFileAtomicDeleteCapability=o,e.hasReadonlyCapability=U,e.createFileSystemProviderError=h,e.ensureFileSystemProviderError=d,e.markAsFileSystemProviderError=F,e.toFileSystemProviderErrorCode=c,e.toFileOperationResult=A,e.isParent=se,e.etag=_,e.whenProviderRegistered=O,e.getLargeFileConfirmationLimit=Y,e.IFileService=(0,L.createDecorator)("fileService");function D(R){return R.create===!0}var k;(function(R){R[R.Unknown=0]="Unknown",R[R.File=1]="File",R[R.Directory=2]="Directory",R[R.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var a;(function(R){R[R.Readonly=1]="Readonly",R[R.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var r;(function(R){R[R.UPDATED=2]="UPDATED",R[R.ADDED=4]="ADDED",R[R.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function f(R){const X=R;return!!X&&typeof X.onDidChange=="function"}var b;(function(R){R[R.None=0]="None",R[R.FileReadWrite=2]="FileReadWrite",R[R.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",R[R.FileReadStream=16]="FileReadStream",R[R.FileFolderCopy=8]="FileFolderCopy",R[R.PathCaseSensitive=1024]="PathCaseSensitive",R[R.Readonly=2048]="Readonly",R[R.Trash=4096]="Trash",R[R.FileWriteUnlock=8192]="FileWriteUnlock",R[R.FileAtomicRead=16384]="FileAtomicRead",R[R.FileAtomicWrite=32768]="FileAtomicWrite",R[R.FileAtomicDelete=65536]="FileAtomicDelete",R[R.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function u(R){return!!(R.capabilities&b.FileReadWrite)}function y(R){return!!(R.capabilities&b.FileFolderCopy)}function v(R){return!!(R.capabilities&b.FileClone)}function l(R){return!!(R.capabilities&b.FileOpenReadWriteClose)}function n(R){return!!(R.capabilities&b.FileReadStream)}function i(R){return u(R)?!!(R.capabilities&b.FileAtomicRead):!1}function s(R){return u(R)?!!(R.capabilities&b.FileAtomicWrite):!1}function o(R){return!!(R.capabilities&b.FileAtomicDelete)}function U(R){return!!(R.capabilities&b.Readonly)}var m;(function(R){R.FileExists="EntryExists",R.FileNotFound="EntryNotFound",R.FileNotADirectory="EntryNotADirectory",R.FileIsADirectory="EntryIsADirectory",R.FileExceedsStorageQuota="EntryExceedsStorageQuota",R.FileTooLarge="EntryTooLarge",R.FileWriteLocked="EntryWriteLocked",R.NoPermissions="NoPermissions",R.Unavailable="Unavailable",R.Unknown="Unknown"})(m||(e.FileSystemProviderErrorCode=m={}));class E extends Error{static create(X,ee){const ne=new E(X.toString(),ee);return F(ne,ee),ne}constructor(X,ee){super(X),this.code=ee}}e.FileSystemProviderError=E;function h(R,X){return E.create(R,X)}function d(R){return R||h((0,N.localize)(11386,null),m.Unknown)}function F(R,X){return R.name=X?`${X} (FileSystemError)`:"FileSystemError",R}function c(R){if(!R)return m.Unknown;if(R instanceof E)return R.code;const X=/^(.+) \(FileSystemError\)$/.exec(R.name);if(!X)return m.Unknown;switch(X[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}function A(R){if(R instanceof K)return R.fileOperationResult;switch(c(R)){case m.FileNotFound:return re.FILE_NOT_FOUND;case m.FileIsADirectory:return re.FILE_IS_DIRECTORY;case m.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case m.FileWriteLocked:return re.FILE_WRITE_LOCKED;case m.NoPermissions:return re.FILE_PERMISSION_DENIED;case m.FileExists:return re.FILE_MOVE_CONFLICT;case m.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var j;(function(R){R[R.CREATE=0]="CREATE",R[R.DELETE=1]="DELETE",R[R.MOVE=2]="MOVE",R[R.COPY=3]="COPY",R[R.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class Z{constructor(X,ee,ne){this.resource=X,this.operation=ee,this.target=ne}isOperation(X){return this.operation===X}}e.FileOperationEvent=Z;var x;(function(R){R[R.UPDATED=0]="UPDATED",R[R.ADDED=1]="ADDED",R[R.DELETED=2]="DELETED"})(x||(e.FileChangeType=x={}));class H{static{this.MIXED_CORRELATION=null}constructor(X,ee){this.ignorePathCasing=ee,this.correlationId=void 0,this.added=new w.Lazy(()=>{const ne=p.TernarySearchTree.forUris(()=>this.ignorePathCasing);return ne.fill(this.rawAdded.map(le=>[le,!0])),ne}),this.updated=new w.Lazy(()=>{const ne=p.TernarySearchTree.forUris(()=>this.ignorePathCasing);return ne.fill(this.rawUpdated.map(le=>[le,!0])),ne}),this.deleted=new w.Lazy(()=>{const ne=p.TernarySearchTree.forUris(()=>this.ignorePathCasing);return ne.fill(this.rawDeleted.map(le=>[le,!0])),ne}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ne of X){switch(ne.type){case x.ADDED:this.rawAdded.push(ne.resource);break;case x.UPDATED:this.rawUpdated.push(ne.resource);break;case x.DELETED:this.rawDeleted.push(ne.resource);break}this.correlationId!==H.MIXED_CORRELATION&&(typeof ne.cId=="number"?this.correlationId===void 0?this.correlationId=ne.cId:this.correlationId!==ne.cId&&(this.correlationId=H.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=H.MIXED_CORRELATION))}}contains(X,...ee){return this.doContains(X,{includeChildren:!1},...ee)}affects(X,...ee){return this.doContains(X,{includeChildren:!0},...ee)}doContains(X,ee,...ne){if(!X)return!1;const le=ne.length>0;return!!((!le||ne.includes(x.ADDED))&&(this.added.value.get(X)||ee.includeChildren&&this.added.value.findSuperstr(X))||(!le||ne.includes(x.UPDATED))&&(this.updated.value.get(X)||ee.includeChildren&&this.updated.value.findSuperstr(X))||(!le||ne.includes(x.DELETED))&&(this.deleted.value.findSubstr(X)||ee.includeChildren&&this.deleted.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.correlationId===X}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=H;function se(R,X,ee){return!R||!X||R===X||X.length>R.length?!1:(X.charAt(X.length-1)!==t.sep&&(X+=t.sep),ee?(0,$.startsWithIgnoreCase)(R,X):R.indexOf(X)===0)}class K extends Error{constructor(X,ee,ne){super(X),this.fileOperationResult=ee,this.options=ne}}e.FileOperationError=K;class ie extends K{constructor(X,ee,ne,le){super(X,ee,le),this.fileOperationResult=ee,this.size=ne}}e.TooLargeFileOperationError=ie;class oe extends K{constructor(X,ee,ne){super(X,re.FILE_NOT_MODIFIED_SINCE,ne),this.stat=ee}}e.NotModifiedSinceFileOperationError=oe;var re;(function(R){R[R.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",R[R.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",R[R.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",R[R.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",R[R.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",R[R.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",R[R.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",R[R.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",R[R.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",R[R.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",R[R.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var I;(function(R){R[R.FILE=0]="FILE",R[R.FOLDER=1]="FOLDER",R[R.ROOT_FOLDER=2]="ROOT_FOLDER"})(I||(e.FileKind=I={})),e.ETAG_DISABLED="";function _(R){if(!(typeof R.size!="number"||typeof R.mtime!="number"))return R.mtime.toString(29)+R.size.toString(31)}async function O(R,X){if(!X.hasProvider(V.URI.from({scheme:R.scheme})))return new Promise(ee=>{const ne=X.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===R.scheme&&le.added&&(ne.dispose(),ee())})})}class C{static{this.KB=1024}static{this.MB=C.KB*C.KB}static{this.GB=C.MB*C.KB}static{this.TB=C.GB*C.KB}static formatSize(X){return(0,q.isNumber)(X)||(X=0),X<C.KB?(0,N.localize)(11387,null,X.toFixed(0)):X<C.MB?(0,N.localize)(11388,null,(X/C.KB).toFixed(2)):X<C.GB?(0,N.localize)(11389,null,(X/C.MB).toFixed(2)):X<C.TB?(0,N.localize)(11390,null,(X/C.GB).toFixed(2)):(0,N.localize)(11391,null,(X/C.TB).toFixed(2))}}e.ByteSize=C;function Y(R){const X=typeof R=="string"||R?.scheme===M.Schemas.vscodeRemote;return typeof R!="string"&&R?.scheme===M.Schemas.file?1024*C.MB:X?10*C.MB:T.isWeb?50*C.MB:1024*C.MB}}),define(Ee[19],pe([0,1,23,4,3,2,5,18]),function(ce,e,p,t,$,q,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=L,e.isRecursiveWatchRequest=T,e.reviveFileChanges=k,e.coalesceEvents=a,e.normalizeWatcherPattern=r,e.parseWatcherPatterns=f,e.isFiltered=u,e.requestFilterToString=y;function L(v){return typeof v.correlationId=="number"}function T(v){return v.recursive===!0}class M extends t.Disposable{static{this.MAX_RESTARTS=5}constructor(l,n,i,s){super(),this.onFileChanges=l,this.onLogMessage=n,this.verboseLogging=i,this.options=s,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const l=new t.DisposableStore;this.watcherDisposables.value=l,this.watcher=this.createWatcher(l),this.watcher.setVerboseLogging(this.verboseLogging),l.add(this.watcher.onDidChangeFile(n=>this.onFileChanges(n))),l.add(this.watcher.onDidLogMessage(n=>this.onLogMessage(n))),l.add(this.watcher.onDidError(n=>this.onError(n.error,n.request)))}onError(l,n){this.canRestart(l,n)?this.restartCounter<M.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${l}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${l}`):this.error(l)}canRestart(l,n){return!(!this.options.restartOnError||n||l.indexOf("No space left on device")!==-1||l.indexOf("EMFILE")!==-1)}restart(l){this.restartCounter++,this.init(),this.watch(l)}async watch(l){this.requests=l,await this.watcher?.watch(l)}async setVerboseLogging(l){this.verboseLogging=l,await this.watcher?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${l}`})}trace(l){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${l}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=M;class w extends M{constructor(l,n,i){super(l,n,i,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=w;class D extends M{constructor(l,n,i){super(l,n,i,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=D;function k(v){return v.map(l=>({type:l.type,resource:V.URI.revive(l.resource),cId:l.cId}))}function a(v){const l=new b;for(const n of v)l.processEvent(n);return l.coalesce()}function r(v,l){return typeof l=="string"&&!l.startsWith(p.GLOBSTAR)&&!(0,$.isAbsolute)(l)?{base:v,pattern:l}:l}function f(v,l){const n=[];for(const i of l)n.push((0,p.parse)(r(v,i)));return n}class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(l){return q.isLinux?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const n=this.mapPathToChange.get(this.toKey(l));let i=!1;if(n){const s=n.type,o=l.type;n.resource.fsPath!==l.resource.fsPath&&(l.type===N.FileChangeType.DELETED||l.type===N.FileChangeType.ADDED)?i=!0:s===N.FileChangeType.ADDED&&o===N.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(l)),this.coalesced.delete(n)):s===N.FileChangeType.DELETED&&o===N.FileChangeType.ADDED?n.type=N.FileChangeType.UPDATED:s===N.FileChangeType.ADDED&&o===N.FileChangeType.UPDATED||(n.type=o)}else i=!0;i&&(this.coalesced.add(l),this.mapPathToChange.set(this.toKey(l),l))}coalesce(){const l=[],n=[];return Array.from(this.coalesced).filter(i=>i.type!==N.FileChangeType.DELETED?(l.push(i),!1):!0).sort((i,s)=>i.resource.fsPath.length-s.resource.fsPath.length).filter(i=>n.some(s=>(0,N.isParent)(i.resource.fsPath,s,!q.isLinux))?!1:(n.push(i.resource.fsPath),!0)).concat(l)}}function u(v,l){if(typeof l=="number")switch(v.type){case N.FileChangeType.ADDED:return(l&N.FileChangeFilter.ADDED)===0;case N.FileChangeType.DELETED:return(l&N.FileChangeFilter.DELETED)===0;case N.FileChangeType.UPDATED:return(l&N.FileChangeFilter.UPDATED)===0}return!1}function y(v){if(typeof v=="number"){const l=[];return v&N.FileChangeFilter.ADDED&&l.push("Added"),v&N.FileChangeFilter.DELETED&&l.push("Deleted"),v&N.FileChangeFilter.UPDATED&&l.push("Updated"),l.length===0?"<all>":`[${l.join(", ")}]`}return"<none>"}}),define(Ee[35],pe([0,1,15,4,19,6,18,5,8]),function(ce,e,p,t,$,q,V,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class T extends t.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new q.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new q.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new q.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new t.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new L.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new L.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(w=>this.handleDidWatchFail(w)))}handleDidWatchFail(w){this.isCorrelated(w)&&this.suspendWatchRequest(w)}isCorrelated(w){return(0,$.isWatchRequestWithCorrelation)(w)}async watch(w){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new L.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const D of w)this.isCorrelated(D)?this.allCorrelatedWatchRequests.set(D.correlationId,D):this.allNonCorrelatedWatchRequests.add(D);for(const[D]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(D)||(this.suspendedWatchRequests.deleteAndDispose(D),this.suspendedWatchRequestsWithPolling.delete(D));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(w){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(D=>!this.suspendedWatchRequests.has(D.correlationId))]),w?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(w){return typeof w.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(w.correlationId)?"polling":this.suspendedWatchRequests.has(w.correlationId)}async suspendWatchRequest(w){if(this.suspendedWatchRequests.has(w.correlationId))return;const D=new t.DisposableStore;this.suspendedWatchRequests.set(w.correlationId,D),await this.joinWatch.p,!D.isDisposed&&(this.monitorSuspendedWatchRequest(w,D),this.updateWatchers(!0))}resumeWatchRequest(w){this.suspendedWatchRequests.deleteAndDispose(w.correlationId),this.suspendedWatchRequestsWithPolling.delete(w.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(w,D){this.doMonitorWithExistingWatcher(w,D)?(this.trace(`reusing an existing recursive watcher to monitor ${w.path}`),this.suspendedWatchRequestsWithPolling.delete(w.correlationId)):(this.doMonitorWithNodeJS(w,D),this.suspendedWatchRequestsWithPolling.add(w.correlationId))}doMonitorWithExistingWatcher(w,D){const k=this.recursiveWatcher?.subscribe(w.path,(a,r)=>{D.isDisposed||(a?this.monitorSuspendedWatchRequest(w,D):r?.type===V.FileChangeType.ADDED&&this.onMonitoredPathAdded(w))});return k?(D.add(k),!0):!1}doMonitorWithNodeJS(w,D){let k=!1;const a=(r,f)=>{if(D.isDisposed)return;const b=this.isPathNotFound(r),u=this.isPathNotFound(f),y=k;k=b,!b&&(u||y)&&this.onMonitoredPathAdded(w)};this.trace(`starting fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,p.watchFile)(w.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},a)}catch(r){this.warn(`fs.watchFile() failed with error ${r} on path ${w.path} (correlationId: ${w.correlationId})`)}D.add((0,t.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,p.unwatchFile)(w.path,a)}catch(r){this.warn(`fs.unwatchFile() failed with error ${r} on path ${w.path} (correlationId: ${w.correlationId})`)}}))}onMonitoredPathAdded(w){this.trace(`detected ${w.path} exists again, resuming watcher (correlationId: ${w.correlationId})`);const D={resource:N.URI.file(w.path),type:V.FileChangeType.ADDED,cId:w.correlationId};this._onDidChangeFile.fire([D]),this.traceEvent(D,w),this.resumeWatchRequest(w)}isPathNotFound(w){return w.ctimeMs===0&&w.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(w,D){if(this.verboseLogging){const k=` >> normalized ${w.type===V.FileChangeType.ADDED?"[ADDED]":w.type===V.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${w.resource.fsPath}`;this.traceWithCorrelation(k,D)}}traceWithCorrelation(w,D){this.verboseLogging&&this.trace(`${w}${typeof D.correlationId=="number"?` <${D.correlationId}> `:""}`)}requestToString(w){return`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"}, filter: ${(0,$.requestFilterToString)(w.filter)}, correlationId: ${typeof w.correlationId=="number"?w.correlationId:"<none>"})`}async setVerboseLogging(w){this.verboseLogging=w}}e.BaseWatcher=T}),define(Ee[36],pe([0,1,15,8,13,14,4,21,3,2,22,5,32,24,18,19]),function(ce,e,p,t,$,q,V,N,L,T,M,w,D,k,a,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=b;class f extends V.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(y,v,l,n,i,s){super(),this.request=y,this.recursiveWatcher=v,this.onDidFilesChange=l,this.onDidWatchFail=n,this.onLogMessage=i,this.verboseLogging=s,this.throttledFileChangesEmitter=this._register(new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.onDidFilesChange(o))),this.fileChangesAggregator=this._register(new t.RunOnceWorker(o=>this.handleFileChanges(o),f.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,r.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,r.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,r.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new $.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const v=await p.promises.stat(y);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(y,v.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${y})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(y){let v=y.path;try{v=await k.Promises.realpath(y.path),y.path===v&&(v=await(0,D.realcase)(y.path,this.cts.token)??y.path),y.path!==v&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${v})`)}catch{}return v}async doWatch(y,v){const l=new V.DisposableStore;return this.doWatchWithExistingWatcher(y,v,l)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(y,v,l)),l}doWatchWithExistingWatcher(y,v,l){if(v)return!1;const n=w.URI.file(this.request.path),i=this.recursiveWatcher?.subscribe(this.request.path,async(s,o)=>{if(!l.isDisposed)if(s){const U=await this.doWatch(y,v);l.isDisposed?U.dispose():l.add(U)}else o&&(typeof o.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:n,type:o.type,cId:this.request.correlationId},!0)});return i?(l.add(i),!0):!1}async doWatchWithNodeJS(y,v,l){if(T.isMacintosh&&(0,q.isEqualOrParent)(y,"/Volumes/",!0)){this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const n=new $.CancellationTokenSource(this.cts.token);l.add((0,V.toDisposable)(()=>n.dispose(!0)));const i=new V.DisposableStore;l.add(i);try{const s=w.URI.file(this.request.path),o=(0,L.basename)(y),U=(0,p.watch)(y);i.add((0,V.toDisposable)(()=>{U.removeAllListeners(),U.close()})),this.trace(`Started watching: '${y}'`);const m=new Set;if(v)try{for(const h of await k.Promises.readdir(y))m.add(h)}catch(h){this.error(h)}if(n.token.isCancellationRequested)return;const E=new Map;i.add((0,V.toDisposable)(()=>{for(const[,h]of E)h.dispose();E.clear()})),U.on("error",(h,d)=>{n.token.isCancellationRequested||(this.error(`Failed to watch ${y} for changes using fs.watch() (${h}, ${d})`),this.notifyWatchFailed())}),U.on("change",(h,d)=>{if(n.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${h}"] ${d}`);let F="";if(d&&(F=d.toString(),T.isMacintosh&&(F=(0,N.normalizeNFC)(F))),!(!F||h!=="change"&&h!=="rename"))if(v)if(h==="rename"){E.get(F)?.dispose();const c=setTimeout(async()=>{if(E.delete(F),F===o&&!await k.Promises.exists(y)){this.onWatchedPathDeleted(s);return}if(n.token.isCancellationRequested)return;const A=await this.existsChildStrictCase((0,L.join)(y,F));if(n.token.isCancellationRequested)return;let j;A?m.has(F)?j=a.FileChangeType.UPDATED:(j=a.FileChangeType.ADDED,m.add(F)):(m.delete(F),j=a.FileChangeType.DELETED),this.onFileChange({resource:(0,M.joinPath)(s,F),type:j,cId:this.request.correlationId})},f.FILE_DELETE_HANDLER_DELAY);E.set(F,(0,V.toDisposable)(()=>clearTimeout(c)))}else{let c;m.has(F)?c=a.FileChangeType.UPDATED:(c=a.FileChangeType.ADDED,m.add(F)),this.onFileChange({resource:(0,M.joinPath)(s,F),type:c,cId:this.request.correlationId})}else if(h==="rename"||F!==o){const c=setTimeout(async()=>{const A=await k.Promises.exists(y);n.token.isCancellationRequested||(A?(this.onFileChange({resource:s,type:a.FileChangeType.UPDATED,cId:this.request.correlationId},!0),i.add(await this.doWatch(y,!1))):this.onWatchedPathDeleted(s))},f.FILE_DELETE_HANDLER_DELAY);i.clear(),i.add((0,V.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({resource:s,type:a.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(s){n.token.isCancellationRequested||this.error(`Failed to watch ${y} for changes using fs.watch() (${s.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(y){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:y,type:a.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(y,v=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${y.type===a.FileChangeType.ADDED?"[ADDED]":y.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`),!v&&this.excludes.some(l=>l(y.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${y.resource.fsPath}`):!v&&this.includes&&this.includes.length>0&&!this.includes.some(l=>l(y.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${y.resource.fsPath}`):this.fileChangesAggregator.work(y))}handleFileChanges(y){const v=(0,r.coalesceEvents)(y),l=[];for(const i of v){if((0,r.isFiltered)(i,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${i.resource.fsPath}`);continue}l.push(i)}if(l.length===0)return;if(this.verboseLogging)for(const i of l)this.traceWithCorrelation(` >> normalized ${i.type===a.FileChangeType.ADDED?"[ADDED]":i.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.throttledFileChangesEmitter.work(l)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(y){if(T.isLinux)return k.Promises.exists(y);try{const v=(0,L.basename)(y);return(await k.Promises.readdir((0,L.dirname)(y))).some(n=>n===v)}catch(v){return this.trace(v),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}traceWithCorrelation(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${y}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f;async function b(u,y,v,l,n=512){const i=await k.Promises.open(u,"r"),s=Buffer.allocUnsafe(n),o=new $.CancellationTokenSource(l);let U,m=!1;const E={path:u,excludes:[],recursive:!1},h=new f(E,void 0,d=>{(async()=>{for(const{type:F}of d)if(F===a.FileChangeType.UPDATED){if(m)return;m=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:c}=await k.Promises.read(i,s,0,n,null);if(!c||o.token.isCancellationRequested)break;y(s.slice(0,c))}}catch(c){U=new Error(c),o.dispose(!0)}finally{m=!1}}})()});return await h.ready,v(),new Promise((d,F)=>{o.token.onCancellationRequested(async()=>{h.dispose();try{await k.Promises.close(i)}catch(c){U=new Error(c)}U?F(U):d()})})}}),define(Ee[56],pe([0,1,6,23,35,2,36,14]),function(ce,e,p,t,$,q,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class L extends $.BaseWatcher{constructor(M){super(),this.recursiveWatcher=M,this.onDidError=p.Event.None,this.watchers=new Set}async doWatch(M){M=this.removeDuplicateRequests(M);const w=[],D=new Set(Array.from(this.watchers));for(const k of M){const a=this.findWatcher(k);a&&(0,t.patternsEquals)(a.request.excludes,k.excludes)&&(0,t.patternsEquals)(a.request.includes,k.includes)?D.delete(a):w.push(k)}w.length&&this.trace(`Request to start watching: ${w.map(k=>this.requestToString(k)).join(",")}`),D.size&&this.trace(`Request to stop watching: ${Array.from(D).map(k=>this.requestToString(k.request)).join(",")}`);for(const k of D)this.stopWatching(k);for(const k of w)this.startWatching(k)}findWatcher(M){for(const w of this.watchers)if(typeof M.correlationId=="number"||typeof w.request.correlationId=="number"){if(w.request.correlationId===M.correlationId)return w}else if((0,N.isEqual)(w.request.path,M.path,!q.isLinux))return w}startWatching(M){const w=new V.NodeJSFileWatcherLibrary(M,this.recursiveWatcher,k=>this._onDidChangeFile.fire(k),()=>this._onDidWatchFail.fire(M),k=>this._onDidLogMessage.fire(k),this.verboseLogging),D={request:M,instance:w};this.watchers.add(D)}async stop(){await super.stop();for(const M of this.watchers)this.stopWatching(M)}stopWatching(M){this.trace("stopping file watcher",M),this.watchers.delete(M),M.instance.dispose()}removeDuplicateRequests(M){const w=new Map;for(const D of M){const k=q.isLinux?D.path:D.path.toLowerCase();let a=w.get(D.correlationId);a||(a=new Map,w.set(D.correlationId,a)),a.has(k)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(D)}`),a.set(k,D)}return Array.from(w.values()).map(D=>Array.from(D.values())).flat()}async setVerboseLogging(M){super.setVerboseLogging(M);for(const w of this.watchers)w.instance.setVerboseLogging(M)}trace(M,w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(M,w)})}warn(M){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(M)})}toMessage(M,w){return w?`[File Watcher (node.js)] ${M} (${this.requestToString(w.request)})`:`[File Watcher (node.js)] ${M}`}}e.NodeJSWatcher=L}),define(Ee[57],pe([0,1,62,15,50,5,8,13,54,6,14,23,35,30,21,3,2,32,36,18,19,4]),function(ce,e,p,t,$,q,V,N,L,T,M,w,D,k,a,r,f,b,u,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcher=e.ParcelWatcherInstance=void 0,p=Ie(p);class n extends l.Disposable{get failed(){return this.didFail}get stopped(){return this.didStop}constructor(o,U,m,E,h,d){super(),this.ready=o,this.request=U,this.restarts=m,this.token=E,this.worker=h,this.stopFn=d,this._onDidStop=this._register(new T.Emitter),this.onDidStop=this._onDidStop.event,this._onDidFail=this._register(new T.Emitter),this.onDidFail=this._onDidFail.event,this.didFail=!1,this.didStop=!1,this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.excludes=this.request.excludes?(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes):void 0,this.subscriptions=new Map,this._register((0,l.toDisposable)(()=>this.subscriptions.clear()))}subscribe(o,U){o=q.URI.file(o).fsPath;let m=this.subscriptions.get(o);return m||(m=new Set,this.subscriptions.set(o,m)),m.add(U),(0,l.toDisposable)(()=>{const E=this.subscriptions.get(o);E&&(E.delete(U),E.size===0&&this.subscriptions.delete(o))})}get subscriptionsCount(){return this.subscriptions.size}notifyFileChange(o,U){const m=this.subscriptions.get(o);if(m)for(const E of m)E(U)}notifyWatchFailed(){this.didFail=!0,this._onDidFail.fire()}include(o){return!this.includes||this.includes.length===0?!0:this.includes.some(U=>U(o))}exclude(o){return!!this.excludes?.some(U=>U(o))}async stop(o){this.didStop=!0;try{await this.stopFn()}finally{this._onDidStop.fire({joinRestart:o}),this.dispose()}}}e.ParcelWatcherInstance=n;class i extends D.BaseWatcher{static{this.MAP_PARCEL_WATCHER_ACTION_TO_FILE_CHANGE=new Map([["create",y.FileChangeType.ADDED],["update",y.FileChangeType.UPDATED],["delete",y.FileChangeType.DELETED]])}static{this.PARCEL_WATCHER_BACKEND=f.isWindows?"windows":f.isLinux?"inotify":"fs-events"}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(){super(),this._onDidError=this._register(new T.Emitter),this.onDidError=this._onDidError.event,this.watchers=new Set,this.throttledFileChangesEmitter=this._register(new V.ThrottledWorker({maxWorkChunkSize:500,throttleDelay:200,maxBufferedWork:3e4},o=>this._onDidChangeFile.fire(o))),this.enospcErrorLogged=!1,this.registerListeners()}registerListeners(){process.on("uncaughtException",o=>this.onUnexpectedError(o)),process.on("unhandledRejection",o=>this.onUnexpectedError(o))}async doWatch(o){o=this.removeDuplicateRequests(o);const U=[],m=new Set(Array.from(this.watchers));for(const E of o){const h=this.findWatcher(E);h&&(0,w.patternsEquals)(h.request.excludes,E.excludes)&&(0,w.patternsEquals)(h.request.includes,E.includes)&&h.request.pollingInterval===E.pollingInterval?m.delete(h):U.push(E)}U.length&&this.trace(`Request to start watching: ${U.map(E=>this.requestToString(E)).join(",")}`),m.size&&this.trace(`Request to stop watching: ${Array.from(m).map(E=>this.requestToString(E.request)).join(",")}`);for(const E of m)await this.stopWatching(E);for(const E of U)E.pollingInterval?this.startPolling(E,E.pollingInterval):await this.startWatching(E)}findWatcher(o){for(const U of this.watchers)if(this.isCorrelated(o)||this.isCorrelated(U.request)){if(U.request.correlationId===o.correlationId)return U}else if((0,M.isEqual)(U.request.path,o.path,!f.isLinux))return U}startPolling(o,U,m=0){const E=new N.CancellationTokenSource,h=new V.DeferredPromise,d=(0,M.randomPath)((0,$.tmpdir)(),"vscode-watcher-snapshot"),F=new n(h.p,o,m,E.token,new V.RunOnceWorker(H=>this.handleParcelEvents(H,F),i.FILE_CHANGES_HANDLER_DELAY),async()=>{E.dispose(!0),F.worker.flush(),F.worker.dispose(),x.dispose(),(0,t.unlinkSync)(d)});this.watchers.add(F);const{realPath:c,realPathDiffers:A,realPathLength:j}=this.normalizePath(o);this.trace(`Started watching: '${c}' with polling interval '${U}'`);let Z=0;const x=new V.RunOnceScheduler(async()=>{if(Z++,!E.token.isCancellationRequested){if(Z>1){const H=await p.getEventsSince(c,d,{ignore:o.excludes,backend:i.PARCEL_WATCHER_BACKEND});if(E.token.isCancellationRequested)return;this.onParcelEvents(H,F,A,j)}await p.writeSnapshot(c,d,{ignore:o.excludes,backend:i.PARCEL_WATCHER_BACKEND}),Z===1&&h.complete(),!E.token.isCancellationRequested&&x.schedule()}},U);x.schedule(0)}async startWatching(o,U=0){const m=new N.CancellationTokenSource,E=new V.DeferredPromise,h=new n(E.p,o,U,m.token,new V.RunOnceWorker(A=>this.handleParcelEvents(A,h),i.FILE_CHANGES_HANDLER_DELAY),async()=>{m.dispose(!0),h.worker.flush(),h.worker.dispose(),await(await E.p)?.unsubscribe()});this.watchers.add(h);const{realPath:d,realPathDiffers:F,realPathLength:c}=this.normalizePath(o);try{const A=await p.subscribe(d,(j,Z)=>{h.token.isCancellationRequested||(j&&this.onUnexpectedError(j,o),this.onParcelEvents(Z,h,F,c))},{backend:i.PARCEL_WATCHER_BACKEND,ignore:h.request.excludes});this.trace(`Started watching: '${d}' with backend '${i.PARCEL_WATCHER_BACKEND}'`),E.complete(A)}catch(A){this.onUnexpectedError(A,o),E.complete(void 0),h.notifyWatchFailed(),this._onDidWatchFail.fire(o)}}onParcelEvents(o,U,m,E){if(o.length===0)return;this.normalizeEvents(o,U.request,m,E);const h=this.handleIncludes(U,o);for(const d of h)U.worker.work(d)}handleIncludes(o,U){const m=[];for(const{path:E,type:h}of U){const d=i.MAP_PARCEL_WATCHER_ACTION_TO_FILE_CHANGE.get(h);this.verboseLogging&&this.traceWithCorrelation(`${d===y.FileChangeType.ADDED?"[ADDED]":d===y.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E}`,o.request),o.include(E)?m.push({type:d,resource:q.URI.file(E),cId:o.request.correlationId}):this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${E}`,o.request)}return m}handleParcelEvents(o,U){const m=(0,v.coalesceEvents)(o),{events:E,rootDeleted:h}=this.filterEvents(m,U);this.emitEvents(E,U),h&&this.onWatchedPathDeleted(U)}emitEvents(o,U){if(o.length===0)return;this.throttledFileChangesEmitter.work(o)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`,U):this.warn(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}normalizePath(o){let U=o.path,m=!1,E=o.path.length;try{U=(0,b.realpathSync)(o.path),o.path===U&&(U=(0,b.realcaseSync)(o.path)??o.path),o.path!==U&&(E=U.length,m=!0,this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${U})`))}catch{}return{realPath:U,realPathDiffers:m,realPathLength:E}}normalizeEvents(o,U,m,E){for(const h of o)f.isMacintosh&&(h.path=(0,a.normalizeNFC)(h.path)),f.isWindows&&U.path.length<=3&&(h.path=(0,r.normalize)(h.path)),m&&(h.path=U.path+h.path.substr(E))}filterEvents(o,U){const m=[];let E=!1;const h=this.isCorrelated(U.request)?U.request.filter:void 0;for(const d of o){if(U.subscriptionsCount>0&&U.notifyFileChange(d.resource.fsPath,d),E=d.type===y.FileChangeType.DELETED&&(0,M.isEqual)(d.resource.fsPath,U.request.path,!f.isLinux),(0,v.isFiltered)(d,h)||E&&!this.isCorrelated(U.request)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${d.resource.fsPath}`,U.request);continue}this.traceEvent(d,U.request),m.push(d)}return{events:m,rootDeleted:E}}onWatchedPathDeleted(o){this.warn("Watcher shutdown because watched path got deleted",o);let U=!1;this.isCorrelated(o.request)||(U=this.legacyMonitorRequest(o)),U||(o.notifyWatchFailed(),this._onDidWatchFail.fire(o.request))}legacyMonitorRequest(o){const U=(0,r.dirname)(o.request.path);if((0,t.existsSync)(U)){this.trace("Trying to watch on the parent path to restart the watcher...",o);const m=new u.NodeJSFileWatcherLibrary({path:U,excludes:[],recursive:!1,correlationId:o.request.correlationId},void 0,E=>{if(!o.token.isCancellationRequested){for(const{resource:h,type:d}of E)if((0,M.isEqual)(h.fsPath,o.request.path,!f.isLinux)&&(d===y.FileChangeType.ADDED||d===y.FileChangeType.UPDATED)&&this.isPathValid(o.request.path)){this.warn("Watcher restarts because watched path got created again",o),m.dispose(),this.restartWatching(o);break}}},void 0,E=>this._onDidLogMessage.fire(E),this.verboseLogging);return o.token.onCancellationRequested(()=>m.dispose()),!0}return!1}onUnexpectedError(o,U){const m=(0,L.toErrorMessage)(o);m.indexOf("No space left on device")!==-1?this.enospcErrorLogged||(this.error("Inotify limit reached (ENOSPC)",U),this.enospcErrorLogged=!0):(this.error(`Unexpected error: ${m} (EUNKNOWN)`,U),this._onDidError.fire({request:U,error:m}))}async stop(){await super.stop();for(const o of this.watchers)await this.stopWatching(o)}restartWatching(o,U=800){const m=new V.RunOnceScheduler(async()=>{if(o.token.isCancellationRequested)return;const E=new V.DeferredPromise;try{await this.stopWatching(o,E.p),o.request.pollingInterval?this.startPolling(o.request,o.request.pollingInterval,o.restarts+1):await this.startWatching(o.request,o.restarts+1)}finally{E.complete()}},U);m.schedule(),o.token.onCancellationRequested(()=>m.dispose())}async stopWatching(o,U){this.trace("stopping file watcher",o),this.watchers.delete(o);try{await o.stop(U)}catch(m){this.error(`Unexpected error stopping watcher: ${(0,L.toErrorMessage)(m)}`,o.request)}}removeDuplicateRequests(o,U=!0){o.sort((h,d)=>h.path.length-d.path.length);const m=new Map;for(const h of o){if(h.excludes.includes(w.GLOBSTAR))continue;const d=f.isLinux?h.path:h.path.toLowerCase();let F=m.get(h.correlationId);F||(F=new Map,m.set(h.correlationId,F)),F.has(d)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(h)}`),F.set(d,h)}const E=[];for(const h of m.values()){const d=k.TernarySearchTree.forPaths(!f.isLinux);for(const F of h.values()){if(d.findSubstr(F.path))try{if((0,b.realpathSync)(F.path)===F.path){this.trace(`ignoring a request for watching who's parent is already watched: ${this.requestToString(F)}`);continue}}catch(c){this.trace(`ignoring a request for watching who's realpath failed to resolve: ${this.requestToString(F)} (error: ${c})`),this._onDidWatchFail.fire(F);continue}if(U&&!this.isPathValid(F.path)){this._onDidWatchFail.fire(F);continue}d.set(F.path,F)}E.push(...Array.from(d).map(([,F])=>F))}return E}isPathValid(o){try{if(!(0,t.statSync)(o).isDirectory())return this.trace(`ignoring a path for watching that is a file and not a folder: ${o}`),!1}catch(U){return this.trace(`ignoring a path for watching who's stat info failed to resolve: ${o} (error: ${U})`),!1}return!0}subscribe(o,U){for(const m of this.watchers){if(m.failed||!(0,M.isEqualOrParent)(o,m.request.path,!f.isLinux)||m.exclude(o)||!m.include(o))continue;const E=new l.DisposableStore;return E.add(T.Event.once(m.onDidStop)(async h=>{await h.joinRestart,!E.isDisposed&&U(!0)})),E.add(T.Event.once(m.onDidFail)(()=>U(!0))),E.add(m.subscribe(o,h=>U(null,h))),E}}trace(o,U){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(o,U?.request)})}warn(o,U){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(o,U?.request)})}error(o,U){this._onDidLogMessage.fire({type:"error",message:this.toMessage(o,U)})}toMessage(o,U){return U?`[File Watcher (parcel)] ${o} (path: ${U.path})`:`[File Watcher (parcel)] ${o}`}get recursiveWatcher(){return this}}e.ParcelWatcher=i}),define(Ee[58],pe([0,1,19]),function(ce,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeStats=t;function t(a,r,f){const b=[],u=L(a.filter(j=>j.recursive)),y=u.filter(j=>r.isSuspended(j)===!1),v=u.filter(j=>r.isSuspended(j)==="polling"),l=u.filter(j=>r.isSuspended(j)===!0),n=q(u,r),i=V(r),s=L(a.filter(j=>!j.recursive)),o=s.filter(j=>f.isSuspended(j)===!1),U=s.filter(j=>f.isSuspended(j)==="polling"),m=s.filter(j=>f.isSuspended(j)===!0),E=q(s,f),h=N(f);b.push("[Summary]"),b.push(`- Recursive Requests:     total: ${u.length}, suspended: ${n.suspended}, polling: ${n.polling}`),b.push(`- Non-Recursive Requests: total: ${s.length}, suspended: ${E.suspended}, polling: ${E.polling}`),b.push(`- Recursive Watchers:     total: ${r.watchers.size}, active: ${i.active}, failed: ${i.failed}, stopped: ${i.stopped}`),b.push(`- Non-Recursive Watchers: total: ${f.watchers.size}, active: ${h.active}, failed: ${h.failed}, reusing: ${h.reusing}`),b.push(`- I/O Handles Impact:     total: ${n.polling+E.polling+i.active+h.active}`),b.push(`
[Recursive Requests (${u.length}, suspended: ${n.suspended}, polling: ${n.polling})]:`);const d=[];for(const j of[y,v,l].flat())M(d,j,r);b.push(...$(d));const F=[];D(F,r),b.push(...$(F)),b.push(`
[Non-Recursive Requests (${s.length}, suspended: ${E.suspended}, polling: ${E.polling})]:`);const c=[];for(const j of[o,U,m].flat())M(c,j,f);b.push(...$(c));const A=[];return k(A,f),b.push(...$(A)),`

[File Watcher] request stats:

${b.join(`
`)}

`}function $(a){let r=0;for(const f of a)r=Math.max(r,f.split("	")[0].length);for(let f=0;f<a.length;f++){const u=a[f].split("	");if(u.length===2){const y=" ".repeat(r-u[0].length);a[f]=`${u[0]}${y}	${u[1]}`}}return a}function q(a,r){let f=0,b=0;for(const u of a){const y=r.isSuspended(u);y!==!1&&(b++,y==="polling"&&f++)}return{suspended:b,polling:f}}function V(a){let r=0,f=0,b=0;for(const u of a.watchers.values())!u.failed&&!u.stopped&&r++,u.failed&&f++,u.stopped&&b++;return{active:r,failed:f,stopped:b}}function N(a){let r=0,f=0,b=0;for(const u of a.watchers)!u.instance.failed&&!u.instance.isReusingRecursiveWatcher&&r++,u.instance.failed&&f++,u.instance.isReusingRecursiveWatcher&&b++;return{active:r,failed:f,reusing:b}}function L(a){return a.sort((r,f)=>{const b=T(r)?r.path:r.request.path,u=T(f)?f.path:f.request.path,y=Math.min(b.length,u.length);for(let v=0;v<y;v++)if(b[v]!==u[v])return b[v]<u[v]?-1:1;return b.length-u.length}),a}function T(a){return typeof a?.path=="string"}function M(a,r,f){const b=[],u=f.isSuspended(r);u!==!1&&(u==="polling"?b.push("[SUSPENDED <polling>]"):b.push("[SUSPENDED <non-polling>]")),a.push(` ${r.path}	${b.length>0?b.join(" ")+" ":""}(${w(r)})`)}function w(a){return`excludes: ${a.excludes.length>0?a.excludes:"<none>"}, includes: ${a.includes&&a.includes.length>0?JSON.stringify(a.includes):"<all>"}, filter: ${(0,p.requestFilterToString)(a.filter)}, correlationId: ${typeof a.correlationId=="number"?a.correlationId:"<none>"}`}function D(a,r){const f=L(Array.from(r.watchers.values())),{active:b,failed:u,stopped:y}=V(r);a.push(`
[Recursive Watchers (${f.length}, active: ${b}, failed: ${u}, stopped: ${y})]:`);for(const v of f){const l=[];v.failed&&l.push("[FAILED]"),v.stopped&&l.push("[STOPPED]"),v.subscriptionsCount>0&&l.push(`[SUBSCRIBED:${v.subscriptionsCount}]`),v.restarts>0&&l.push(`[RESTARTED:${v.restarts}]`),a.push(` ${v.request.path}	${l.length>0?l.join(" ")+" ":""}(${w(v.request)})`)}}function k(a,r){const f=L(Array.from(r.watchers.values())),b=f.filter(i=>!i.instance.failed&&!i.instance.isReusingRecursiveWatcher),u=f.filter(i=>i.instance.failed),y=f.filter(i=>i.instance.isReusingRecursiveWatcher),{active:v,failed:l,reusing:n}=N(r);a.push(`
[Non-Recursive Watchers (${f.length}, active: ${v}, failed: ${l}, reusing: ${n})]:`);for(const i of[b,u,y].flat()){const s=[];i.instance.failed&&s.push("[FAILED]"),i.instance.isReusingRecursiveWatcher&&s.push("[REUSING]"),a.push(` ${i.request.path}	${s.length>0?s.join(" ")+" ":""}(${w(i.request)})`)}}}),define(Ee[59],pe([0,1,4,6,57,56,8,58]),function(ce,e,p,t,$,q,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcher=void 0;class L extends p.Disposable{constructor(){super(...arguments),this.recursiveWatcher=this._register(new $.ParcelWatcher),this.nonRecursiveWatcher=this._register(new q.NodeJSWatcher(this.recursiveWatcher)),this.onDidChangeFile=t.Event.any(this.recursiveWatcher.onDidChangeFile,this.nonRecursiveWatcher.onDidChangeFile),this.onDidError=t.Event.any(this.recursiveWatcher.onDidError,this.nonRecursiveWatcher.onDidError),this._onDidLogMessage=this._register(new t.Emitter),this.onDidLogMessage=t.Event.any(this._onDidLogMessage.event,this.recursiveWatcher.onDidLogMessage,this.nonRecursiveWatcher.onDidLogMessage),this.requests=[]}async watch(M){this.requests=M;let w;try{await this.recursiveWatcher.watch(M.filter(D=>D.recursive))}catch(D){w=D}try{await this.nonRecursiveWatcher.watch(M.filter(D=>!D.recursive))}catch(D){w||(w=D)}if(w)throw w}async setVerboseLogging(M){M&&this.requests.length>0&&this._onDidLogMessage.fire({type:"trace",message:(0,N.computeStats)(this.requests,this.recursiveWatcher,this.nonRecursiveWatcher)}),await V.Promises.settled([this.recursiveWatcher.setVerboseLogging(M),this.nonRecursiveWatcher.setVerboseLogging(M)])}async stop(){await V.Promises.settled([this.recursiveWatcher.stop(),this.nonRecursiveWatcher.stop()])}}e.UniversalWatcher=L}),define(Ee[63],pe([0,1,4,25,52,53,33,59]),function(ce,e,p,t,$,q,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;(0,V.isUtilityProcess)(process)?L=new q.Server:L=new $.Server("watcher");const T=new N.UniversalWatcher;L.registerChannel("watcher",t.ProxyChannel.fromService(T,new p.DisposableStore))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/platform/files/node/watcher/watcherMain.js.map
