/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls","vs/base/common/charCode","vs/base/common/decorators","vs/base/common/process","vs/platform/terminal/common/terminal","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/platform/terminal/common/capabilities/capabilities","vs/base/common/lazy","vs/base/common/resources","vs/base/common/map","vs/base/common/marshallingIds","vs/base/node/pfs","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/processes","vs/base/common/objects","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/sandbox/node/electronTypes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uint","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/uuid","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/base/common/date","vs/base/common/errorMessage","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","util","minimist","node-pty","vs/base/common/performance","@xterm/headless","vs/platform/terminal/node/ptyHostMain"],fe=function(ie){for(var e=[],a=0,t=ie.length;a<t;a++)e[a]=he[ie[a]];return e};define(he[43],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=a,e.findLastIdx=t,e.findLastMonotonous=D,e.findLastIdxMonotonous=y,e.findFirstMonotonous=W,e.findFirstIdxMonotonousOrArrLen=P,e.findFirstIdxMonotonous=g,e.findFirstMax=w,e.findLastMax=p,e.findFirstMin=f,e.findMaxIdx=c,e.mapFindFirst=l;function a(h,d){const u=t(h,d);if(u!==-1)return h[u]}function t(h,d,u=h.length-1){for(let n=u;n>=0;n--){const v=h[n];if(d(v))return n}return-1}function D(h,d){const u=y(h,d);return u===-1?void 0:h[u]}function y(h,d,u=0,n=h.length){let v=u,b=n;for(;v<b;){const o=Math.floor((v+b)/2);d(h[o])?v=o+1:b=o}return v-1}function W(h,d){const u=P(h,d);return u===h.length?void 0:h[u]}function P(h,d,u=0,n=h.length){let v=u,b=n;for(;v<b;){const o=Math.floor((v+b)/2);d(h[o])?b=o:v=o+1}return v}function g(h,d,u=0,n=h.length){const v=P(h,d,u,n);return v===h.length?-1:v}class r{static{this.assertInvariants=!1}constructor(d){this._array=d,this._findLastMonotonousLastIdx=0}findLastMonotonous(d){if(r.assertInvariants){if(this._prevFindLastPredicate){for(const n of this._array)if(this._prevFindLastPredicate(n)&&!d(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=d}const u=y(this._array,d,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=u+1,u===-1?void 0:this._array[u]}}e.MonotonousArray=r;function w(h,d){if(h.length===0)return;let u=h[0];for(let n=1;n<h.length;n++){const v=h[n];d(v,u)>0&&(u=v)}return u}function p(h,d){if(h.length===0)return;let u=h[0];for(let n=1;n<h.length;n++){const v=h[n];d(v,u)>=0&&(u=v)}return u}function f(h,d){return w(h,(u,n)=>-d(u,n))}function c(h,d){if(h.length===0)return-1;let u=0;for(let n=1;n<h.length;n++){const v=h[n];d(v,h[u])>0&&(u=n)}return u}function l(h,d){for(const u of h){const n=d(u);if(n!==void 0)return n}}}),define(he[13],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var a;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(a||(e.CharCode=a={}))}),define(he[44],fe([0,1]),function(ie,e){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=t,e.diffSets=D,e.diffMaps=y,e.intersection=W;function t(g,r){const w=Object.create(null);for(const p of g){const f=r(p);let c=w[f];c||(c=w[f]=[]),c.push(p)}return w}function D(g,r){const w=[],p=[];for(const f of g)r.has(f)||w.push(f);for(const f of r)g.has(f)||p.push(f);return{removed:w,added:p}}function y(g,r){const w=[],p=[];for(const[f,c]of g)r.has(f)||w.push(c);for(const[f,c]of r)g.has(f)||p.push(c);return{removed:w,added:p}}function W(g,r){const w=new Set;for(const p of r)g.has(p)&&w.add(p);return w}class P{static{a=Symbol.toStringTag}constructor(r,w){this.toKey=w,this._map=new Map,this[a]="SetWithKey";for(const p of r)this.add(p)}get size(){return this._map.size}add(r){const w=this.toKey(r);return this._map.set(w,r),this}delete(r){return this._map.delete(this.toKey(r))}has(r){return this._map.has(this.toKey(r))}*entries(){for(const r of this._map.values())yield[r,r]}keys(){return this.values()}*values(){for(const r of this._map.values())yield r}clear(){this._map.clear()}forEach(r,w){this._map.forEach(p=>r.call(w,p,p,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=P}),define(he[14],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=t,e.debounce=D,e.throttle=y;function a(W){return(P,g,r)=>{let w=null,p=null;if(typeof r.value=="function"?(w="value",p=r.value):typeof r.get=="function"&&(w="get",p=r.get),!p)throw new Error("not supported");r[w]=W(p,g)}}function t(W,P,g){let r=null,w=null;if(typeof g.value=="function"?(r="value",w=g.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(r="get",w=g.get),!w)throw new Error("not supported");const p=`$memoize$${P}`;g[r]=function(...f){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,f)}),this[p]}}function D(W,P,g){return a((r,w)=>{const p=`$debounce$${w}`,f=`$debounce$result$${w}`;return function(...c){this[f]||(this[f]=g?g():void 0),clearTimeout(this[p]),P&&(this[f]=P(this[f],...c),c=[this[f]]),this[p]=setTimeout(()=>{r.apply(this,c),this[f]=g?g():void 0},W)}})}function y(W,P,g){return a((r,w)=>{const p=`$throttle$timer$${w}`,f=`$throttle$result$${w}`,c=`$throttle$lastRun$${w}`,l=`$throttle$pending$${w}`;return function(...h){if(this[f]||(this[f]=g?g():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...h)),this[l])return;const d=this[c]+W;d<=Date.now()?(this[c]=Date.now(),r.apply(this,[this[f]]),this[f]=g?g():void 0):(this[l]=!0,this[p]=setTimeout(()=>{this[l]=!1,this[c]=Date.now(),r.apply(this,[this[f]]),this[f]=g?g():void 0},d-Date.now()))}})}}),define(he[7],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=t,e.isSigPipeError=D,e.onUnexpectedError=y,e.onUnexpectedExternalError=W,e.transformErrorForSerialization=P,e.transformErrorFromSerialization=g,e.isCancellationError=w,e.canceled=f,e.illegalArgument=c,e.illegalState=l,e.getErrorMessage=d;class a{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?b.isErrorNoTelemetry(i)?new b(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(_=>{_(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=a,e.errorHandler=new a;function t(s){e.errorHandler.setUnexpectedErrorHandler(s)}function D(s){if(!s||typeof s!="object")return!1;const i=s;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function y(s){w(s)||e.errorHandler.onUnexpectedError(s)}function W(s){w(s)||e.errorHandler.onUnexpectedExternalError(s)}function P(s){if(s instanceof Error){const{name:i,message:_}=s,A=s.stacktrace||s.stack;return{$isError:!0,name:i,message:_,stack:A,noTelemetry:b.isErrorNoTelemetry(s)}}return s}function g(s){let i;return s.noTelemetry?i=new b:(i=new Error,i.name=s.name),i.message=s.message,i.stack=s.stack,i}const r="Canceled";function w(s){return s instanceof p?!0:s instanceof Error&&s.name===r&&s.message===r}class p extends Error{constructor(){super(r),this.name=this.message}}e.CancellationError=p;function f(){const s=new Error(r);return s.name=s.message,s}function c(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function l(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class h extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=h;function d(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class u extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=u;class n extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=n;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class b extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof b)return i;const _=new b;return _.message=i.message,_.stack=i.stack,_}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.BugIndicatingError=o}),define(he[17],fe([0,1,7,43]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=D,e.tail2=y,e.equals=W,e.removeFastWithoutKeepingOrder=P,e.binarySearch=g,e.binarySearch2=r,e.quickSelect=w,e.groupBy=p,e.groupAdjacentBy=f,e.forEachAdjacent=c,e.forEachWithNeighbors=l,e.sortedDiff=h,e.delta=d,e.top=u,e.topAsync=n,e.coalesce=b,e.coalesceInPlace=o,e.move=s,e.isFalsyOrEmpty=i,e.isNonEmptyArray=_,e.distinct=A,e.uniqueFilter=F,e.firstOrDefault=S,e.lastOrDefault=L,e.commonPrefixLength=k,e.range=O,e.index=x,e.insert=R,e.remove=E,e.arrayInsert=U,e.shuffle=I,e.pushToStart=C,e.pushToEnd=B,e.pushMany=Y,e.mapArrayOrNot=G,e.asArray=Z,e.getRandomElement=se,e.insertInto=le,e.splice=V,e.compareBy=ee,e.tieBreakComparators=ue,e.reverseOrder=me,e.findAsync=oe;function D(N,K=0){return N[N.length-(1+K)]}function y(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function W(N,K,M=(T,H)=>T===H){if(N===K)return!0;if(!N||!K||N.length!==K.length)return!1;for(let T=0,H=N.length;T<H;T++)if(!M(N[T],K[T]))return!1;return!0}function P(N,K){const M=N.length-1;K<M&&(N[K]=N[M]),N.pop()}function g(N,K,M){return r(N.length,T=>M(N[T],K))}function r(N,K){let M=0,T=N-1;for(;M<=T;){const H=(M+T)/2|0,J=K(H);if(J<0)M=H+1;else if(J>0)T=H-1;else return H}return-(M+1)}function w(N,K,M){if(N=N|0,N>=K.length)throw new TypeError("invalid index");const T=K[Math.floor(K.length*Math.random())],H=[],J=[],ne=[];for(const pe of K){const we=M(pe,T);we<0?H.push(pe):we>0?J.push(pe):ne.push(pe)}return N<H.length?w(N,H,M):N<H.length+ne.length?ne[0]:w(N-(H.length+ne.length),J,M)}function p(N,K){const M=[];let T;for(const H of N.slice(0).sort(K))!T||K(T[0],H)!==0?(T=[H],M.push(T)):T.push(H);return M}function*f(N,K){let M,T;for(const H of N)T!==void 0&&K(T,H)?M.push(H):(M&&(yield M),M=[H]),T=H;M&&(yield M)}function c(N,K){for(let M=0;M<=N.length;M++)K(M===0?void 0:N[M-1],M===N.length?void 0:N[M])}function l(N,K){for(let M=0;M<N.length;M++)K(M===0?void 0:N[M-1],N[M],M+1===N.length?void 0:N[M+1])}function h(N,K,M){const T=[];function H(pe,we,Ie){if(we===0&&Ie.length===0)return;const ge=T[T.length-1];ge&&ge.start+ge.deleteCount===pe?(ge.deleteCount+=we,ge.toInsert.push(...Ie)):T.push({start:pe,deleteCount:we,toInsert:Ie})}let J=0,ne=0;for(;;){if(J===N.length){H(J,0,K.slice(ne));break}if(ne===K.length){H(J,N.length-J,[]);break}const pe=N[J],we=K[ne],Ie=M(pe,we);Ie===0?(J+=1,ne+=1):Ie<0?(H(J,1,[]),J+=1):Ie>0&&(H(J,0,[we]),ne+=1)}return T}function d(N,K,M){const T=h(N,K,M),H=[],J=[];for(const ne of T)H.push(...N.slice(ne.start,ne.start+ne.deleteCount)),J.push(...ne.toInsert);return{removed:H,added:J}}function u(N,K,M){if(M===0)return[];const T=N.slice(0,M).sort(K);return v(N,K,T,M,N.length),T}function n(N,K,M,T,H){return M===0?Promise.resolve([]):new Promise((J,ne)=>{(async()=>{const pe=N.length,we=N.slice(0,M).sort(K);for(let Ie=M,ge=Math.min(M+T,pe);Ie<pe;Ie=ge,ge=Math.min(ge+T,pe)){if(Ie>M&&await new Promise(de=>setTimeout(de)),H&&H.isCancellationRequested)throw new a.CancellationError;v(N,K,we,Ie,ge)}return we})().then(J,ne)})}function v(N,K,M,T,H){for(const J=M.length;T<H;T++){const ne=N[T];if(K(ne,M[J-1])<0){M.pop();const pe=(0,t.findFirstIdxMonotonousOrArrLen)(M,we=>K(ne,we)<0);M.splice(pe,0,ne)}}}function b(N){return N.filter(K=>!!K)}function o(N){let K=0;for(let M=0;M<N.length;M++)N[M]&&(N[K]=N[M],K+=1);N.length=K}function s(N,K,M){N.splice(M,0,N.splice(K,1)[0])}function i(N){return!Array.isArray(N)||N.length===0}function _(N){return Array.isArray(N)&&N.length>0}function A(N,K=M=>M){const M=new Set;return N.filter(T=>{const H=K(T);return M.has(H)?!1:(M.add(H),!0)})}function F(N){const K=new Set;return M=>{const T=N(M);return K.has(T)?!1:(K.add(T),!0)}}function S(N,K){return N.length>0?N[0]:K}function L(N,K){return N.length>0?N[N.length-1]:K}function k(N,K,M=(T,H)=>T===H){let T=0;for(let H=0,J=Math.min(N.length,K.length);H<J&&M(N[H],K[H]);H++)T++;return T}function O(N,K){let M=typeof K=="number"?N:0;typeof K=="number"?M=N:(M=0,K=N);const T=[];if(M<=K)for(let H=M;H<K;H++)T.push(H);else for(let H=M;H>K;H--)T.push(H);return T}function x(N,K,M){return N.reduce((T,H)=>(T[K(H)]=M?M(H):H,T),Object.create(null))}function R(N,K){return N.push(K),()=>E(N,K)}function E(N,K){const M=N.indexOf(K);if(M>-1)return N.splice(M,1),K}function U(N,K,M){const T=N.slice(0,K),H=N.slice(K);return T.concat(M,H)}function I(N,K){let M;if(typeof K=="number"){let T=K;M=()=>{const H=Math.sin(T++)*179426549;return H-Math.floor(H)}}else M=Math.random;for(let T=N.length-1;T>0;T-=1){const H=Math.floor(M()*(T+1)),J=N[T];N[T]=N[H],N[H]=J}}function C(N,K){const M=N.indexOf(K);M>-1&&(N.splice(M,1),N.unshift(K))}function B(N,K){const M=N.indexOf(K);M>-1&&(N.splice(M,1),N.push(K))}function Y(N,K){for(const M of K)N.push(M)}function G(N,K){return Array.isArray(N)?N.map(K):K(N)}function Z(N){return Array.isArray(N)?N:[N]}function se(N){return N[Math.floor(Math.random()*N.length)]}function le(N,K,M){const T=z(N,K),H=N.length,J=M.length;N.length=H+J;for(let ne=H-1;ne>=T;ne--)N[ne+J]=N[ne];for(let ne=0;ne<J;ne++)N[ne+T]=M[ne]}function V(N,K,M,T){const H=z(N,K);let J=N.splice(H,M);return J===void 0&&(J=[]),le(N,H,T),J}function z(N,K){return K<0?Math.max(K+N.length,0):Math.min(K,N.length)}var Q;(function(N){function K(J){return J<0}N.isLessThan=K;function M(J){return J<=0}N.isLessThanOrEqual=M;function T(J){return J>0}N.isGreaterThan=T;function H(J){return J===0}N.isNeitherLessOrGreaterThan=H,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function ee(N,K){return(M,T)=>K(N(M),N(T))}function ue(...N){return(K,M)=>{for(const T of N){const H=T(K,M);if(!Q.isNeitherLessOrGreaterThan(H))return H}return Q.neitherLessOrGreaterThan}}const $=(N,K)=>N-K;e.numberComparator=$;const ae=(N,K)=>(0,e.numberComparator)(N?1:0,K?1:0);e.booleanComparator=ae;function me(N){return(K,M)=>-N(K,M)}class te{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let M=this.firstIdx;for(;M<this.items.length&&K(this.items[M]);)M++;const T=M===this.firstIdx?null:this.items.slice(this.firstIdx,M);return this.firstIdx=M,T}takeFromEndWhile(K){let M=this.lastIdx;for(;M>=0&&K(this.items[M]);)M--;const T=M===this.lastIdx?null:this.items.slice(M+1,this.lastIdx+1);return this.lastIdx=M,T}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const K=this.items[this.firstIdx];return this.firstIdx++,K}removeLast(){const K=this.items[this.lastIdx];return this.lastIdx--,K}takeCount(K){const M=this.items.slice(this.firstIdx,this.firstIdx+K);return this.firstIdx+=K,M}}e.ArrayQueue=te;class m{static{this.empty=new m(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(M=>(K(M),!0))}toArray(){const K=[];return this.iterate(M=>(K.push(M),!0)),K}filter(K){return new m(M=>this.iterate(T=>K(T)?M(T):!0))}map(K){return new m(M=>this.iterate(T=>M(K(T))))}some(K){let M=!1;return this.iterate(T=>(M=K(T),!M)),M}findFirst(K){let M;return this.iterate(T=>K(T)?(M=T,!1):!0),M}findLast(K){let M;return this.iterate(T=>(K(T)&&(M=T),!0)),M}findLastMaxBy(K){let M,T=!0;return this.iterate(H=>((T||Q.isGreaterThan(K(H,M)))&&(T=!1,M=H),!0)),M}}e.CallbackIterable=m;class j{constructor(K){this._indexMap=K}static createSortPermutation(K,M){const T=Array.from(K.keys()).sort((H,J)=>M(K[H],K[J]));return new j(T)}apply(K){return K.map((M,T)=>K[this._indexMap[T]])}inverse(){const K=this._indexMap.slice();for(let M=0;M<this._indexMap.length;M++)K[this._indexMap[M]]=M;return new j(K)}}e.Permutation=j;async function oe(N,K){return(await Promise.all(N.map(async(T,H)=>({element:T,ok:await K(T,H)})))).find(T=>T.ok)?.element}}),define(he[45],fe([0,1,7]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=t,e.assertNever=D,e.assert=y,e.softAssert=W,e.assertFn=P,e.checkAdjacentItems=g;function t(r,w){if(!r)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function D(r,w="Unreachable"){throw new Error(w)}function y(r,w="unexpected state"){if(!r)throw new a.BugIndicatingError(`Assertion Failed: ${w}`)}function W(r){r||(0,a.onUnexpectedError)(new a.BugIndicatingError("Soft Assertion Failed"))}function P(r){if(!r()){debugger;r(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}function g(r,w){let p=0;for(;p<r.length-1;){const f=r[p],c=r[p+1];if(!w(f,c))return!1;p++}return!0}}),define(he[31],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=a;function a(t,D){const y=this;let W=!1,P;return function(){if(W)return P;if(W=!0,D)try{P=t.apply(y,arguments)}finally{D()}else P=t.apply(y,arguments);return P}}}),define(he[46],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function D(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=D;const y=Object.freeze([]);function W(){return y}t.empty=W;function*P(i){yield i}t.single=P;function g(i){return D(i)?i:P(i)}t.wrap=g;function r(i){return i||y}t.from=r;function*w(i){for(let _=i.length-1;_>=0;_--)yield i[_]}t.reverse=w;function p(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=p;function f(i){return i[Symbol.iterator]().next().value}t.first=f;function c(i,_){let A=0;for(const F of i)if(_(F,A++))return!0;return!1}t.some=c;function l(i,_){for(const A of i)if(_(A))return A}t.find=l;function*h(i,_){for(const A of i)_(A)&&(yield A)}t.filter=h;function*d(i,_){let A=0;for(const F of i)yield _(F,A++)}t.map=d;function*u(i,_){let A=0;for(const F of i)yield*_(F,A++)}t.flatMap=u;function*n(...i){for(const _ of i)yield*_}t.concat=n;function v(i,_,A){let F=A;for(const S of i)F=_(F,S);return F}t.reduce=v;function*b(i,_,A=i.length){for(_<0&&(_+=i.length),A<0?A+=i.length:A>i.length&&(A=i.length);_<A;_++)yield i[_]}t.slice=b;function o(i,_=Number.POSITIVE_INFINITY){const A=[];if(_===0)return[A,i];const F=i[Symbol.iterator]();for(let S=0;S<_;S++){const L=F.next();if(L.done)return[A,t.empty()];A.push(L.value)}return[A,{[Symbol.iterator](){return F}}]}t.consume=o;async function s(i){const _=[];for await(const A of i)_.push(A);return Promise.resolve(_)}t.asyncToArray=s})(a||(e.Iterable=a={}))}),define(he[24],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(D){this.executor=D,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=a}),define(he[47],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{static{this.Undefined=new a(void 0)}constructor(y){this.element=y,this.next=a.Undefined,this.prev=a.Undefined}}class t{constructor(){this._first=a.Undefined,this._last=a.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===a.Undefined}clear(){let y=this._first;for(;y!==a.Undefined;){const W=y.next;y.prev=a.Undefined,y.next=a.Undefined,y=W}this._first=a.Undefined,this._last=a.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,W){const P=new a(y);if(this._first===a.Undefined)this._first=P,this._last=P;else if(W){const r=this._last;this._last=P,P.prev=r,r.next=P}else{const r=this._first;this._first=P,P.next=r,r.prev=P}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(P))}}shift(){if(this._first!==a.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==a.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==a.Undefined&&y.next!==a.Undefined){const W=y.prev;W.next=y.next,y.next.prev=W}else y.prev===a.Undefined&&y.next===a.Undefined?(this._first=a.Undefined,this._last=a.Undefined):y.next===a.Undefined?(this._last=this._last.prev,this._last.next=a.Undefined):y.prev===a.Undefined&&(this._first=this._first.next,this._first.prev=a.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==a.Undefined;)yield y.element,y=y.next}}e.LinkedList=t}),define(he[26],fe([0,1]),function(ie,e){"use strict";var a,t,D;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=y,e.mapToString=W,e.setToString=P,e.mapsStrictEqualIgnoreOrder=b;function y(o,s,i){let _=o.get(s);return _===void 0&&(_=i,o.set(s,_)),_}function W(o){const s=[];return o.forEach((i,_)=>{s.push(`${_} => ${i}`)}),`Map(${o.size}) {${s.join(", ")}}`}function P(o){const s=[];return o.forEach(i=>{s.push(i)}),`Set(${o.size}) {${s.join(", ")}}`}class g{constructor(s,i){this.uri=s,this.value=i}}function r(o){return Array.isArray(o)}class w{static{this.defaultToKey=s=>s.toString()}constructor(s,i){if(this[a]="ResourceMap",s instanceof w)this.map=new Map(s.map),this.toKey=i??w.defaultToKey;else if(r(s)){this.map=new Map,this.toKey=i??w.defaultToKey;for(const[_,A]of s)this.set(_,A)}else this.map=new Map,this.toKey=s??w.defaultToKey}set(s,i){return this.map.set(this.toKey(s),new g(s,i)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,i){typeof i<"u"&&(s=s.bind(i));for(const[_,A]of this.map)s(A.value,A.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=w;class p{constructor(s,i){this[t]="ResourceSet",!s||typeof s=="function"?this._map=new w(s):(this._map=new w(i),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,i){this._map.forEach((_,A)=>s.call(i,A,A,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var f;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class c{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,i=f.None){const _=this._map.get(s);if(_)return i!==f.None&&this.touch(_,i),_.value}set(s,i,_=f.None){let A=this._map.get(s);if(A)A.value=i,_!==f.None&&this.touch(A,_);else{switch(A={key:s,value:i,next:void 0,previous:void 0},_){case f.None:this.addItemLast(A);break;case f.AsOld:this.addItemFirst(A);break;case f.AsNew:this.addItemLast(A);break;default:this.addItemLast(A);break}this._map.set(s,A),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const i=this._map.get(s);if(i)return this._map.delete(s),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,i){const _=this._state;let A=this._head;for(;A;){if(i?s.bind(i)(A.value,A.key,this):s(A.value,A.key,this),this._state!==_)throw new Error("LinkedMap got modified during iteration.");A=A.next}}keys(){const s=this,i=this._state;let _=this._head;const A={[Symbol.iterator](){return A},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(_){const F={value:_.key,done:!1};return _=_.next,F}else return{value:void 0,done:!0}}};return A}values(){const s=this,i=this._state;let _=this._head;const A={[Symbol.iterator](){return A},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(_){const F={value:_.value,done:!1};return _=_.next,F}else return{value:void 0,done:!0}}};return A}entries(){const s=this,i=this._state;let _=this._head;const A={[Symbol.iterator](){return A},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(_){const F={value:[_.key,_.value],done:!1};return _=_.next,F}else return{value:void 0,done:!0}}};return A}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let i=this._head,_=this.size;for(;i&&_>s;)this._map.delete(i.key),i=i.next,_--;this._head=i,this._size=_,i&&(i.previous=void 0),this._state++}trimNew(s){if(s>=this.size)return;if(s===0){this.clear();return}let i=this._tail,_=this.size;for(;i&&_>s;)this._map.delete(i.key),i=i.previous,_--;this._tail=i,this._size=_,i&&(i.next=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const i=s.next,_=s.previous;if(!i||!_)throw new Error("Invalid list");i.previous=_,_.next=i}s.next=void 0,s.previous=void 0,this._state++}touch(s,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==f.AsOld&&i!==f.AsNew)){if(i===f.AsOld){if(s===this._head)return;const _=s.next,A=s.previous;s===this._tail?(A.next=void 0,this._tail=A):(_.previous=A,A.next=_),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(i===f.AsNew){if(s===this._tail)return;const _=s.next,A=s.previous;s===this._head?(_.previous=void 0,this._head=_):(_.previous=A,A.next=_),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((i,_)=>{s.push([_,i])}),s}fromJSON(s){this.clear();for(const[i,_]of s)this.set(i,_)}}e.LinkedMap=c;class l extends c{constructor(s,i=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,i=f.AsNew){return super.get(s,i)}peek(s){return super.get(s,f.None)}set(s,i){return super.set(s,i,f.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class h extends l{constructor(s,i=1){super(s,i)}trim(s){this.trimOld(s)}set(s,i){return super.set(s,i),this.checkTrim(),this}}e.LRUCache=h;class d extends l{constructor(s,i=1){super(s,i)}trim(s){this.trimNew(s)}set(s,i){return this._limit<=this.size&&!this.has(s)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(s,i),this}}e.MRUCache=d;class u{constructor(){this.map=new Map}add(s){return this.map.set(s,(this.map.get(s)||0)+1),this}delete(s){let i=this.map.get(s)||0;return i===0?!1:(i--,i===0?this.map.delete(s):this.map.set(s,i),!0)}has(s){return this.map.has(s)}}e.CounterSet=u;class n{constructor(s){if(this._m1=new Map,this._m2=new Map,s)for(const[i,_]of s)this.set(i,_)}clear(){this._m1.clear(),this._m2.clear()}set(s,i){this._m1.set(s,i),this._m2.set(i,s)}get(s){return this._m1.get(s)}getKey(s){return this._m2.get(s)}delete(s){const i=this._m1.get(s);return i===void 0?!1:(this._m1.delete(s),this._m2.delete(i),!0)}forEach(s,i){this._m1.forEach((_,A)=>{s.call(i,_,A,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=n;class v{constructor(){this.map=new Map}add(s,i){let _=this.map.get(s);_||(_=new Set,this.map.set(s,_)),_.add(i)}delete(s,i){const _=this.map.get(s);_&&(_.delete(i),_.size===0&&this.map.delete(s))}forEach(s,i){const _=this.map.get(s);_&&_.forEach(i)}get(s){const i=this.map.get(s);return i||new Set}}e.SetMap=v;function b(o,s){if(o===s)return!0;if(o.size!==s.size)return!1;for(const[i,_]of o)if(!s.has(i)||s.get(i)!==_)return!1;for(const[i]of s)if(!o.has(i))return!1;return!0}}),define(he[2],fe([0,1,17,44,26,31,46]),function(ie,e,a,t,D,y,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=w,e.trackDisposable=p,e.markAsDisposed=f,e.markAsSingleton=h,e.isDisposable=d,e.dispose=u,e.disposeIfDisposable=n,e.combinedDisposable=v,e.toDisposable=b,e.disposeOnReturn=O;const P=!1;let g=null;class r{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(E){let U=this.livingDisposables.get(E);return U||(U={parent:null,source:null,isSingleton:!1,value:E,idx:r.idx++},this.livingDisposables.set(E,U)),U}trackDisposable(E){const U=this.getDisposableData(E);U.source||(U.source=new Error().stack)}setParent(E,U){const I=this.getDisposableData(E);I.parent=U}markAsDisposed(E){this.livingDisposables.delete(E)}markAsSingleton(E){this.getDisposableData(E).isSingleton=!0}getRootParent(E,U){const I=U.get(E);if(I)return I;const C=E.parent?this.getRootParent(this.getDisposableData(E.parent),U):E;return U.set(E,C),C}getTrackedDisposables(){const E=new Map;return[...this.livingDisposables.entries()].filter(([,I])=>I.source!==null&&!this.getRootParent(I,E).isSingleton).flatMap(([I])=>I)}computeLeakingDisposables(E=10,U){let I;if(U)I=U;else{const Z=new Map,se=[...this.livingDisposables.values()].filter(V=>V.source!==null&&!this.getRootParent(V,Z).isSingleton);if(se.length===0)return;const le=new Set(se.map(V=>V.value));if(I=se.filter(V=>!(V.parent&&le.has(V.parent))),I.length===0)throw new Error("There are cyclic diposable chains!")}if(!I)return;function C(Z){function se(V,z){for(;V.length>0&&z.some(Q=>typeof Q=="string"?Q===V[0]:V[0].match(Q));)V.shift()}const le=Z.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return se(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const B=new D.SetMap;for(const Z of I){const se=C(Z);for(let le=0;le<=se.length;le++)B.add(se.slice(0,le).join(`
`),Z)}I.sort((0,a.compareBy)(Z=>Z.idx,a.numberComparator));let Y="",G=0;for(const Z of I.slice(0,E)){G++;const se=C(Z),le=[];for(let V=0;V<se.length;V++){let z=se[V];z=`(shared with ${B.get(se.slice(0,V+1).join(`
`)).size}/${I.length} leaks) at ${z}`;const ee=B.get(se.slice(0,V).join(`
`)),ue=(0,t.groupBy)([...ee].map($=>C($)[V]),$=>$);delete ue[se[V]];for(const[$,ae]of Object.entries(ue))le.unshift(`    - stacktraces of ${ae.length} other leaks continue with ${$}`);le.unshift(z)}Y+=`


==================== Leaking disposable ${G}/${I.length}: ${Z.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return I.length>E&&(Y+=`


... and ${I.length-E} more leaking disposables

`),{leaks:I,details:Y}}}e.DisposableTracker=r;function w(R){g=R}if(P){const R="__is_disposable_tracked__";w(new class{trackDisposable(E){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[R]||console.log(U)},3e3)}setParent(E,U){if(E&&E!==s.None)try{E[R]=!0}catch{}}markAsDisposed(E){if(E&&E!==s.None)try{E[R]=!0}catch{}}markAsSingleton(E){}})}function p(R){return g?.trackDisposable(R),R}function f(R){g?.markAsDisposed(R)}function c(R,E){g?.setParent(R,E)}function l(R,E){if(g)for(const U of R)g.setParent(U,E)}function h(R){return g?.markAsSingleton(R),R}function d(R){return typeof R=="object"&&R!==null&&typeof R.dispose=="function"&&R.dispose.length===0}function u(R){if(W.Iterable.is(R)){const E=[];for(const U of R)if(U)try{U.dispose()}catch(I){E.push(I)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function n(R){for(const E of R)d(E)&&E.dispose();return[]}function v(...R){const E=b(()=>u(R));return l(R,E),E}function b(R){const E=p({dispose:(0,y.createSingleCallFunction)(()=>{f(E),R()})});return E}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,p(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return c(E,this),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(E),E.dispose()}}deleteAndLeak(E){E&&this._toDispose.has(E)&&(this._toDispose.delete(E),c(E,null))}}e.DisposableStore=o;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new o,p(this),c(this._store,this)}dispose(){f(this),this._store.dispose()}_register(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(E)}}e.Disposable=s;class i{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(E){this._isDisposed||E===this._value||(this._value?.dispose(),E&&c(E,this),this._value=E)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const E=this._value;return this._value=void 0,E&&c(E,null),E}}e.MutableDisposable=i;class _{constructor(E){this._disposable=new i,this._isDisposed=!1,this._disposable.value=E}get value(){return this._disposable.value}set value(E){this._isDisposed||E===this._disposable.value||(this._disposable.value=E)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=_;class A{constructor(E){this._disposable=E,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=A;class F{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(E){let U=E;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,f(this))},this}}e.SafeDisposable=F;class S{constructor(){this.references=new Map}acquire(E,...U){let I=this.references.get(E);I||(I={counter:0,object:this.createReferencedObject(E,...U)},this.references.set(E,I));const{object:C}=I,B=(0,y.createSingleCallFunction)(()=>{--I.counter===0&&(this.destroyReferencedObject(E,I.object),this.references.delete(E))});return I.counter++,{object:C,dispose:B}}}e.ReferenceCollection=S;class L{constructor(E){this.referenceCollection=E}async acquire(E,...U){const I=this.referenceCollection.acquire(E,...U);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(C){throw I.dispose(),C}}}e.AsyncReferenceCollection=L;class k{constructor(E){this.object=E}dispose(){}}e.ImmortalReference=k;function O(R){const E=new o;try{R(E)}finally{E.dispose()}}class x{constructor(){this._store=new Map,this._isDisposed=!1,p(this)}dispose(){f(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(E){return this._store.has(E)}get size(){return this._store.size}get(E){return this._store.get(E)}set(E,U,I=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this._store.get(E)?.dispose(),this._store.set(E,U)}deleteAndDispose(E){this._store.get(E)?.dispose(),this._store.delete(E)}deleteAndLeak(E){const U=this._store.get(E);return this._store.delete(E),U}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=x}),define(he[27],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var a;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(a||(e.MarshalledId=a={}))}),define(he[48],fe([0,1,26]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=D,e.normalizeNFD=W;const t=new a.LRUCache(1e4);function D(r){return g(r,"NFC",t)}const y=new a.LRUCache(1e4);function W(r){return g(r,"NFD",y)}const P=/[^\u0000-\u0080]/;function g(r,w,p){if(!r)return r;const f=p.get(r);if(f)return f;let c;return P.test(r)?c=r.normalize(w):c=r,p.set(r,c),c}e.removeAccents=function(){const r=/[\u0300-\u036f]/g;return function(w){return W(w).replace(r,"")}}()}),function(){function ie(D){const y=[];typeof D=="number"&&y.push("code/timeOrigin",D);function W(g){y.push(g,Date.now())}function P(){const g=[];for(let r=0;r<y.length;r+=2)g.push({name:y[r],startTime:y[r+1]});return g}return{mark:W,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const W of performance.getEntriesByType("mark"))y.push({name:W.name,startTime:Math.round(D+W.startTime)});return y}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function a(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),define(he[3],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=s,e.isLittleEndian=L,e.isBigSurOrNewer=k,e.LANGUAGE_DEFAULT="en";let a=!1,t=!1,D=!1,y=!1,W=!1,P=!1,g=!1,r=!1,w=!1,p=!1,f,c=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT,h,d;const u=globalThis;let n;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?n=u.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const v=typeof n?.versions?.electron=="string",b=v&&n?.type==="renderer";if(typeof n=="object"){a=n.platform==="win32",t=n.platform==="darwin",D=n.platform==="linux",y=D&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,g=v,w=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,c=e.LANGUAGE_DEFAULT;const O=n.env.VSCODE_NLS_CONFIG;if(O)try{const x=JSON.parse(O);f=x.userLocale,l=x.osLocale,c=x.resolvedLanguage||e.LANGUAGE_DEFAULT,h=x.languagePack?.translationsConfigFile}catch{}W=!0}else typeof navigator=="object"&&!b?(d=navigator.userAgent,a=d.indexOf("Windows")>=0,t=d.indexOf("Macintosh")>=0,r=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=d.indexOf("Linux")>=0,p=d?.indexOf("Mobi")>=0,P=!0,c=globalThis._VSCODE_NLS_LANGUAGE||e.LANGUAGE_DEFAULT,f=navigator.language.toLowerCase(),l=f):console.error("Unable to resolve platform.");var o;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(o||(e.Platform=o={}));function s(O){switch(O){case o.Web:return"Web";case o.Mac:return"Mac";case o.Linux:return"Linux";case o.Windows:return"Windows"}}let i=o.Web;t?i=o.Mac:a?i=o.Windows:D&&(i=o.Linux),e.isWindows=a,e.isMacintosh=t,e.isLinux=D,e.isLinuxSnap=y,e.isNative=W,e.isElectron=g,e.isWeb=P,e.isWebWorker=P&&typeof u.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?u.origin:void 0,e.isIOS=r,e.isMobile=p,e.isCI=w,e.platform=i,e.userAgent=d,e.language=c;var _;(function(O){function x(){return e.language}O.value=x;function R(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}O.isDefaultVariant=R;function E(){return e.language==="en"}O.isDefault=E})(_||(e.Language=_={})),e.locale=f,e.platformLocale=l,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof u.postMessage=="function"&&!u.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const O=[];u.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let E=0,U=O.length;E<U;E++){const I=O[E];if(I.id===R.data.vscodeScheduleAsyncWork){O.splice(E,1),I.callback();return}}});let x=0;return R=>{const E=++x;O.push({id:E,callback:R}),u.postMessage({vscodeScheduleAsyncWork:E},"*")}}return O=>setTimeout(O)})();var A;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(A||(e.OperatingSystem=A={})),e.OS=t||r?A.Macintosh:a?A.Windows:A.Linux;let F=!0,S=!1;function L(){if(!S){S=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,F=new Uint16Array(O.buffer)[0]===513}return F}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function k(O){return parseFloat(O)>=20}}),define(he[15],fe([0,1,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.process<"u"){const y=D.process;t={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch});var Ye=this&&this.__createBinding||(Object.create?function(ie,e,a,t){t===void 0&&(t=a);var D=Object.getOwnPropertyDescriptor(e,a);(!D||("get"in D?!e.__esModule:D.writable||D.configurable))&&(D={enumerable:!0,get:function(){return e[a]}}),Object.defineProperty(ie,t,D)}:function(ie,e,a,t){t===void 0&&(t=a),ie[t]=e[a]}),Ze=this&&this.__setModuleDefault||(Object.create?function(ie,e){Object.defineProperty(ie,"default",{enumerable:!0,value:e})}:function(ie,e){ie.default=e}),De=this&&this.__importStar||function(ie){if(ie&&ie.__esModule)return ie;var e={};if(ie!=null)for(var a in ie)a!=="default"&&Object.prototype.hasOwnProperty.call(ie,a)&&Ye(e,ie,a);return Ze(e,ie),e};define(he[5],fe([0,1,15]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,a=De(a);const t=65,D=97,y=90,W=122,P=46,g=47,r=92,w=58,p=63;class f extends Error{constructor(_,A,F){let S;typeof A=="string"&&A.indexOf("not ")===0?(S="must not be",A=A.replace(/^not /,"")):S="must be";const L=_.indexOf(".")!==-1?"property":"argument";let k=`The "${_}" ${L} ${S} of type ${A}`;k+=`. Received type ${typeof F}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function c(i,_){if(i===null||typeof i!="object")throw new f(_,"Object",i)}function l(i,_){if(typeof i!="string")throw new f(_,"string",i)}const h=a.platform==="win32";function d(i){return i===g||i===r}function u(i){return i===g}function n(i){return i>=t&&i<=y||i>=D&&i<=W}function v(i,_,A,F){let S="",L=0,k=-1,O=0,x=0;for(let R=0;R<=i.length;++R){if(R<i.length)x=i.charCodeAt(R);else{if(F(x))break;x=g}if(F(x)){if(!(k===R-1||O===1))if(O===2){if(S.length<2||L!==2||S.charCodeAt(S.length-1)!==P||S.charCodeAt(S.length-2)!==P){if(S.length>2){const E=S.lastIndexOf(A);E===-1?(S="",L=0):(S=S.slice(0,E),L=S.length-1-S.lastIndexOf(A)),k=R,O=0;continue}else if(S.length!==0){S="",L=0,k=R,O=0;continue}}_&&(S+=S.length>0?`${A}..`:"..",L=2)}else S.length>0?S+=`${A}${i.slice(k+1,R)}`:S=i.slice(k+1,R),L=R-k-1;k=R,O=0}else x===P&&O!==-1?++O:O=-1}return S}function b(i){return i?`${i[0]==="."?"":"."}${i}`:""}function o(i,_){c(_,"pathObject");const A=_.dir||_.root,F=_.base||`${_.name||""}${b(_.ext)}`;return A?A===_.root?`${A}${F}`:`${A}${i}${F}`:F}e.win32={resolve(...i){let _="",A="",F=!1;for(let S=i.length-1;S>=-1;S--){let L;if(S>=0){if(L=i[S],l(L,`paths[${S}]`),L.length===0)continue}else _.length===0?L=a.cwd():(L=a.env[`=${_}`]||a.cwd(),(L===void 0||L.slice(0,2).toLowerCase()!==_.toLowerCase()&&L.charCodeAt(2)===r)&&(L=`${_}\\`));const k=L.length;let O=0,x="",R=!1;const E=L.charCodeAt(0);if(k===1)d(E)&&(O=1,R=!0);else if(d(E))if(R=!0,d(L.charCodeAt(1))){let U=2,I=U;for(;U<k&&!d(L.charCodeAt(U));)U++;if(U<k&&U!==I){const C=L.slice(I,U);for(I=U;U<k&&d(L.charCodeAt(U));)U++;if(U<k&&U!==I){for(I=U;U<k&&!d(L.charCodeAt(U));)U++;(U===k||U!==I)&&(x=`\\\\${C}\\${L.slice(I,U)}`,O=U)}}}else O=1;else n(E)&&L.charCodeAt(1)===w&&(x=L.slice(0,2),O=2,k>2&&d(L.charCodeAt(2))&&(R=!0,O=3));if(x.length>0)if(_.length>0){if(x.toLowerCase()!==_.toLowerCase())continue}else _=x;if(F){if(_.length>0)break}else if(A=`${L.slice(O)}\\${A}`,F=R,R&&_.length>0)break}return A=v(A,!F,"\\",d),F?`${_}\\${A}`:`${_}${A}`||"."},normalize(i){l(i,"path");const _=i.length;if(_===0)return".";let A=0,F,S=!1;const L=i.charCodeAt(0);if(_===1)return u(L)?"\\":i;if(d(L))if(S=!0,d(i.charCodeAt(1))){let O=2,x=O;for(;O<_&&!d(i.charCodeAt(O));)O++;if(O<_&&O!==x){const R=i.slice(x,O);for(x=O;O<_&&d(i.charCodeAt(O));)O++;if(O<_&&O!==x){for(x=O;O<_&&!d(i.charCodeAt(O));)O++;if(O===_)return`\\\\${R}\\${i.slice(x)}\\`;O!==x&&(F=`\\\\${R}\\${i.slice(x,O)}`,A=O)}}}else A=1;else n(L)&&i.charCodeAt(1)===w&&(F=i.slice(0,2),A=2,_>2&&d(i.charCodeAt(2))&&(S=!0,A=3));let k=A<_?v(i.slice(A),!S,"\\",d):"";return k.length===0&&!S&&(k="."),k.length>0&&d(i.charCodeAt(_-1))&&(k+="\\"),F===void 0?S?`\\${k}`:k:S?`${F}\\${k}`:`${F}${k}`},isAbsolute(i){l(i,"path");const _=i.length;if(_===0)return!1;const A=i.charCodeAt(0);return d(A)||_>2&&n(A)&&i.charCodeAt(1)===w&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let _,A;for(let L=0;L<i.length;++L){const k=i[L];l(k,"path"),k.length>0&&(_===void 0?_=A=k:_+=`\\${k}`)}if(_===void 0)return".";let F=!0,S=0;if(typeof A=="string"&&d(A.charCodeAt(0))){++S;const L=A.length;L>1&&d(A.charCodeAt(1))&&(++S,L>2&&(d(A.charCodeAt(2))?++S:F=!1))}if(F){for(;S<_.length&&d(_.charCodeAt(S));)S++;S>=2&&(_=`\\${_.slice(S)}`)}return e.win32.normalize(_)},relative(i,_){if(l(i,"from"),l(_,"to"),i===_)return"";const A=e.win32.resolve(i),F=e.win32.resolve(_);if(A===F||(i=A.toLowerCase(),_=F.toLowerCase(),i===_))return"";let S=0;for(;S<i.length&&i.charCodeAt(S)===r;)S++;let L=i.length;for(;L-1>S&&i.charCodeAt(L-1)===r;)L--;const k=L-S;let O=0;for(;O<_.length&&_.charCodeAt(O)===r;)O++;let x=_.length;for(;x-1>O&&_.charCodeAt(x-1)===r;)x--;const R=x-O,E=k<R?k:R;let U=-1,I=0;for(;I<E;I++){const B=i.charCodeAt(S+I);if(B!==_.charCodeAt(O+I))break;B===r&&(U=I)}if(I!==E){if(U===-1)return F}else{if(R>E){if(_.charCodeAt(O+I)===r)return F.slice(O+I+1);if(I===2)return F.slice(O+I)}k>E&&(i.charCodeAt(S+I)===r?U=I:I===2&&(U=3)),U===-1&&(U=0)}let C="";for(I=S+U+1;I<=L;++I)(I===L||i.charCodeAt(I)===r)&&(C+=C.length===0?"..":"\\..");return O+=U,C.length>0?`${C}${F.slice(O,x)}`:(F.charCodeAt(O)===r&&++O,F.slice(O,x))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const _=e.win32.resolve(i);if(_.length<=2)return i;if(_.charCodeAt(0)===r){if(_.charCodeAt(1)===r){const A=_.charCodeAt(2);if(A!==p&&A!==P)return`\\\\?\\UNC\\${_.slice(2)}`}}else if(n(_.charCodeAt(0))&&_.charCodeAt(1)===w&&_.charCodeAt(2)===r)return`\\\\?\\${_}`;return i},dirname(i){l(i,"path");const _=i.length;if(_===0)return".";let A=-1,F=0;const S=i.charCodeAt(0);if(_===1)return d(S)?i:".";if(d(S)){if(A=F=1,d(i.charCodeAt(1))){let O=2,x=O;for(;O<_&&!d(i.charCodeAt(O));)O++;if(O<_&&O!==x){for(x=O;O<_&&d(i.charCodeAt(O));)O++;if(O<_&&O!==x){for(x=O;O<_&&!d(i.charCodeAt(O));)O++;if(O===_)return i;O!==x&&(A=F=O+1)}}}}else n(S)&&i.charCodeAt(1)===w&&(A=_>2&&d(i.charCodeAt(2))?3:2,F=A);let L=-1,k=!0;for(let O=_-1;O>=F;--O)if(d(i.charCodeAt(O))){if(!k){L=O;break}}else k=!1;if(L===-1){if(A===-1)return".";L=A}return i.slice(0,L)},basename(i,_){_!==void 0&&l(_,"suffix"),l(i,"path");let A=0,F=-1,S=!0,L;if(i.length>=2&&n(i.charCodeAt(0))&&i.charCodeAt(1)===w&&(A=2),_!==void 0&&_.length>0&&_.length<=i.length){if(_===i)return"";let k=_.length-1,O=-1;for(L=i.length-1;L>=A;--L){const x=i.charCodeAt(L);if(d(x)){if(!S){A=L+1;break}}else O===-1&&(S=!1,O=L+1),k>=0&&(x===_.charCodeAt(k)?--k===-1&&(F=L):(k=-1,F=O))}return A===F?F=O:F===-1&&(F=i.length),i.slice(A,F)}for(L=i.length-1;L>=A;--L)if(d(i.charCodeAt(L))){if(!S){A=L+1;break}}else F===-1&&(S=!1,F=L+1);return F===-1?"":i.slice(A,F)},extname(i){l(i,"path");let _=0,A=-1,F=0,S=-1,L=!0,k=0;i.length>=2&&i.charCodeAt(1)===w&&n(i.charCodeAt(0))&&(_=F=2);for(let O=i.length-1;O>=_;--O){const x=i.charCodeAt(O);if(d(x)){if(!L){F=O+1;break}continue}S===-1&&(L=!1,S=O+1),x===P?A===-1?A=O:k!==1&&(k=1):A!==-1&&(k=-1)}return A===-1||S===-1||k===0||k===1&&A===S-1&&A===F+1?"":i.slice(A,S)},format:o.bind(null,"\\"),parse(i){l(i,"path");const _={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return _;const A=i.length;let F=0,S=i.charCodeAt(0);if(A===1)return d(S)?(_.root=_.dir=i,_):(_.base=_.name=i,_);if(d(S)){if(F=1,d(i.charCodeAt(1))){let U=2,I=U;for(;U<A&&!d(i.charCodeAt(U));)U++;if(U<A&&U!==I){for(I=U;U<A&&d(i.charCodeAt(U));)U++;if(U<A&&U!==I){for(I=U;U<A&&!d(i.charCodeAt(U));)U++;U===A?F=U:U!==I&&(F=U+1)}}}}else if(n(S)&&i.charCodeAt(1)===w){if(A<=2)return _.root=_.dir=i,_;if(F=2,d(i.charCodeAt(2))){if(A===3)return _.root=_.dir=i,_;F=3}}F>0&&(_.root=i.slice(0,F));let L=-1,k=F,O=-1,x=!0,R=i.length-1,E=0;for(;R>=F;--R){if(S=i.charCodeAt(R),d(S)){if(!x){k=R+1;break}continue}O===-1&&(x=!1,O=R+1),S===P?L===-1?L=R:E!==1&&(E=1):L!==-1&&(E=-1)}return O!==-1&&(L===-1||E===0||E===1&&L===O-1&&L===k+1?_.base=_.name=i.slice(k,O):(_.name=i.slice(k,L),_.base=i.slice(k,O),_.ext=i.slice(L,O))),k>0&&k!==F?_.dir=i.slice(0,k-1):_.dir=_.root,_},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(h){const i=/\\/g;return()=>{const _=a.cwd().replace(i,"/");return _.slice(_.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...i){let _="",A=!1;for(let F=i.length-1;F>=-1&&!A;F--){const S=F>=0?i[F]:s();l(S,`paths[${F}]`),S.length!==0&&(_=`${S}/${_}`,A=S.charCodeAt(0)===g)}return _=v(_,!A,"/",u),A?`/${_}`:_.length>0?_:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const _=i.charCodeAt(0)===g,A=i.charCodeAt(i.length-1)===g;return i=v(i,!_,"/",u),i.length===0?_?"/":A?"./":".":(A&&(i+="/"),_?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===g},join(...i){if(i.length===0)return".";let _;for(let A=0;A<i.length;++A){const F=i[A];l(F,"path"),F.length>0&&(_===void 0?_=F:_+=`/${F}`)}return _===void 0?".":e.posix.normalize(_)},relative(i,_){if(l(i,"from"),l(_,"to"),i===_||(i=e.posix.resolve(i),_=e.posix.resolve(_),i===_))return"";const A=1,F=i.length,S=F-A,L=1,k=_.length-L,O=S<k?S:k;let x=-1,R=0;for(;R<O;R++){const U=i.charCodeAt(A+R);if(U!==_.charCodeAt(L+R))break;U===g&&(x=R)}if(R===O)if(k>O){if(_.charCodeAt(L+R)===g)return _.slice(L+R+1);if(R===0)return _.slice(L+R)}else S>O&&(i.charCodeAt(A+R)===g?x=R:R===0&&(x=0));let E="";for(R=A+x+1;R<=F;++R)(R===F||i.charCodeAt(R)===g)&&(E+=E.length===0?"..":"/..");return`${E}${_.slice(L+x)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const _=i.charCodeAt(0)===g;let A=-1,F=!0;for(let S=i.length-1;S>=1;--S)if(i.charCodeAt(S)===g){if(!F){A=S;break}}else F=!1;return A===-1?_?"/":".":_&&A===1?"//":i.slice(0,A)},basename(i,_){_!==void 0&&l(_,"ext"),l(i,"path");let A=0,F=-1,S=!0,L;if(_!==void 0&&_.length>0&&_.length<=i.length){if(_===i)return"";let k=_.length-1,O=-1;for(L=i.length-1;L>=0;--L){const x=i.charCodeAt(L);if(x===g){if(!S){A=L+1;break}}else O===-1&&(S=!1,O=L+1),k>=0&&(x===_.charCodeAt(k)?--k===-1&&(F=L):(k=-1,F=O))}return A===F?F=O:F===-1&&(F=i.length),i.slice(A,F)}for(L=i.length-1;L>=0;--L)if(i.charCodeAt(L)===g){if(!S){A=L+1;break}}else F===-1&&(S=!1,F=L+1);return F===-1?"":i.slice(A,F)},extname(i){l(i,"path");let _=-1,A=0,F=-1,S=!0,L=0;for(let k=i.length-1;k>=0;--k){const O=i.charCodeAt(k);if(O===g){if(!S){A=k+1;break}continue}F===-1&&(S=!1,F=k+1),O===P?_===-1?_=k:L!==1&&(L=1):_!==-1&&(L=-1)}return _===-1||F===-1||L===0||L===1&&_===F-1&&_===A+1?"":i.slice(_,F)},format:o.bind(null,"/"),parse(i){l(i,"path");const _={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return _;const A=i.charCodeAt(0)===g;let F;A?(_.root="/",F=1):F=0;let S=-1,L=0,k=-1,O=!0,x=i.length-1,R=0;for(;x>=F;--x){const E=i.charCodeAt(x);if(E===g){if(!O){L=x+1;break}continue}k===-1&&(O=!1,k=x+1),E===P?S===-1?S=x:R!==1&&(R=1):S!==-1&&(R=-1)}if(k!==-1){const E=L===0&&A?1:L;S===-1||R===0||R===1&&S===k-1&&S===L+1?_.base=_.name=i.slice(E,k):(_.name=i.slice(E,S),_.base=i.slice(E,k),_.ext=i.slice(S,k))}return L>0?_.dir=i.slice(0,L-1):A&&(_.dir="/"),_},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h?e.win32.normalize:e.posix.normalize,e.isAbsolute=h?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h?e.win32.join:e.posix.join,e.resolve=h?e.win32.resolve:e.posix.resolve,e.relative=h?e.win32.relative:e.posix.relative,e.dirname=h?e.win32.dirname:e.posix.dirname,e.basename=h?e.win32.basename:e.posix.basename,e.extname=h?e.win32.extname:e.posix.extname,e.format=h?e.win32.format:e.posix.format,e.parse=h?e.win32.parse:e.posix.parse,e.toNamespacedPath=h?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h?e.win32.sep:e.posix.sep,e.delimiter=h?e.win32.delimiter:e.posix.delimiter}),define(he[32],fe([0,1,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=y,e.removeDangerousEnvVariables=W;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t||(e.Source=t={}));var D;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function y(P,...g){const r=g.reduce((f,c)=>(f[c]=!0,f),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(f=>!r[f]).forEach(f=>{for(let c=0;c<w.length;c++)if(f.search(w[c])!==-1){delete P[f];break}})}function W(P){P&&(delete P.DEBUG,a.isLinux&&delete P.LD_PRELOAD)}}),define(he[49],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const a=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(y){return new t(y)}constructor(y){this._now=a&&y===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=t}),define(he[4],fe([0,1,7,31,2,47,49]),function(ie,e,a,t,D,y,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=c;const P=!1,g=!1,r=!1;var w;(function(C){C.None=()=>D.Disposable.None;function B(ge){if(r){const{onDidAddListener:de}=ge,ve=h.create();let ye=0;ge.onDidAddListener=()=>{++ye===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),de?.()}}}function Y(ge,de){return $(ge,()=>{},0,void 0,!0,void 0,de)}C.defer=Y;function G(ge){return(de,ve=null,ye)=>{let be=!1,Le;return Le=ge(Ce=>{if(!be)return Le?Le.dispose():be=!0,de.call(ve,Ce)},null,ye),be&&Le.dispose(),Le}}C.once=G;function Z(ge,de,ve){return ee((ye,be=null,Le)=>ge(Ce=>ye.call(be,de(Ce)),null,Le),ve)}C.map=Z;function se(ge,de,ve){return ee((ye,be=null,Le)=>ge(Ce=>{de(Ce),ye.call(be,Ce)},null,Le),ve)}C.forEach=se;function le(ge,de,ve){return ee((ye,be=null,Le)=>ge(Ce=>de(Ce)&&ye.call(be,Ce),null,Le),ve)}C.filter=le;function V(ge){return ge}C.signal=V;function z(...ge){return(de,ve=null,ye)=>{const be=(0,D.combinedDisposable)(...ge.map(Le=>Le(Ce=>de.call(ve,Ce))));return ue(be,ye)}}C.any=z;function Q(ge,de,ve,ye){let be=ve;return Z(ge,Le=>(be=de(be,Le),be),ye)}C.reduce=Q;function ee(ge,de){let ve;const ye={onWillAddFirstListener(){ve=ge(be.fire,be)},onDidRemoveLastListener(){ve?.dispose()}};de||B(ye);const be=new i(ye);return de?.add(be),be.event}function ue(ge,de){return de instanceof Array?de.push(ge):de&&de.add(ge),ge}function $(ge,de,ve=100,ye=!1,be=!1,Le,Ce){let Ae,Re,Fe,Se=0,Oe;const He={leakWarningThreshold:Le,onWillAddFirstListener(){Ae=ge(Ke=>{Se++,Re=de(Re,Ke),ye&&!Fe&&(qe.fire(Re),Re=void 0),Oe=()=>{const Xe=Re;Re=void 0,Fe=void 0,(!ye||Se>1)&&qe.fire(Xe),Se=0},typeof ve=="number"?(clearTimeout(Fe),Fe=setTimeout(Oe,ve)):Fe===void 0&&(Fe=0,queueMicrotask(Oe))})},onWillRemoveListener(){be&&Se>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,Ae.dispose()}};Ce||B(He);const qe=new i(He);return Ce?.add(qe),qe.event}C.debounce=$;function ae(ge,de=0,ve){return C.debounce(ge,(ye,be)=>ye?(ye.push(be),ye):[be],de,void 0,!0,void 0,ve)}C.accumulate=ae;function me(ge,de=(ye,be)=>ye===be,ve){let ye=!0,be;return le(ge,Le=>{const Ce=ye||!de(Le,be);return ye=!1,be=Le,Ce},ve)}C.latch=me;function te(ge,de,ve){return[C.filter(ge,de,ve),C.filter(ge,ye=>!de(ye),ve)]}C.split=te;function m(ge,de=!1,ve=[],ye){let be=ve.slice(),Le=ge(Re=>{be?be.push(Re):Ae.fire(Re)});ye&&ye.add(Le);const Ce=()=>{be?.forEach(Re=>Ae.fire(Re)),be=null},Ae=new i({onWillAddFirstListener(){Le||(Le=ge(Re=>Ae.fire(Re)),ye&&ye.add(Le))},onDidAddFirstListener(){be&&(de?setTimeout(Ce):Ce())},onDidRemoveLastListener(){Le&&Le.dispose(),Le=null}});return ye&&ye.add(Ae),Ae.event}C.buffer=m;function j(ge,de){return(ye,be,Le)=>{const Ce=de(new N);return ge(function(Ae){const Re=Ce.evaluate(Ae);Re!==oe&&ye.call(be,Re)},void 0,Le)}}C.chain=j;const oe=Symbol("HaltChainable");class N{constructor(){this.steps=[]}map(de){return this.steps.push(de),this}forEach(de){return this.steps.push(ve=>(de(ve),ve)),this}filter(de){return this.steps.push(ve=>de(ve)?ve:oe),this}reduce(de,ve){let ye=ve;return this.steps.push(be=>(ye=de(ye,be),ye)),this}latch(de=(ve,ye)=>ve===ye){let ve=!0,ye;return this.steps.push(be=>{const Le=ve||!de(be,ye);return ve=!1,ye=be,Le?be:oe}),this}evaluate(de){for(const ve of this.steps)if(de=ve(de),de===oe)break;return de}}function K(ge,de,ve=ye=>ye){const ye=(...Ae)=>Ce.fire(ve(...Ae)),be=()=>ge.on(de,ye),Le=()=>ge.removeListener(de,ye),Ce=new i({onWillAddFirstListener:be,onDidRemoveLastListener:Le});return Ce.event}C.fromNodeEventEmitter=K;function M(ge,de,ve=ye=>ye){const ye=(...Ae)=>Ce.fire(ve(...Ae)),be=()=>ge.addEventListener(de,ye),Le=()=>ge.removeEventListener(de,ye),Ce=new i({onWillAddFirstListener:be,onDidRemoveLastListener:Le});return Ce.event}C.fromDOMEventEmitter=M;function T(ge){return new Promise(de=>G(ge)(de))}C.toPromise=T;function H(ge){const de=new i;return ge.then(ve=>{de.fire(ve)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}C.fromPromise=H;function J(ge,de){return ge(ve=>de.fire(ve))}C.forward=J;function ne(ge,de,ve){return de(ve),ge(ye=>de(ye))}C.runAndSubscribe=ne;class pe{constructor(de,ve){this._observable=de,this._counter=0,this._hasChanged=!1;const ye={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};ve||B(ye),this.emitter=new i(ye),ve&&ve.add(this.emitter)}beginUpdate(de){this._counter++}handlePossibleChange(de){}handleChange(de,ve){this._hasChanged=!0}endUpdate(de){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function we(ge,de){return new pe(ge,de).emitter.event}C.fromObservable=we;function Ie(ge){return(de,ve,ye)=>{let be=0,Le=!1;const Ce={beginUpdate(){be++},endUpdate(){be--,be===0&&(ge.reportChanges(),Le&&(Le=!1,de.call(ve)))},handlePossibleChange(){},handleChange(){Le=!0}};ge.addObserver(Ce),ge.reportChanges();const Ae={dispose(){ge.removeObserver(Ce)}};return ye instanceof D.DisposableStore?ye.add(Ae):Array.isArray(ye)&&ye.push(Ae),Ae}}C.fromObservableLight=Ie})(w||(e.Event=w={}));class p{static{this.all=new Set}static{this._idPool=0}constructor(B){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${B}_${p._idPool++}`,p.all.add(this)}start(B){this._stopWatch=new W.StopWatch,this.listenerCount=B}stop(){if(this._stopWatch){const B=this._stopWatch.elapsed();this.durations.push(B),this.elapsedOverall+=B,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=p;let f=-1;function c(C){const B=f;return f=C,{dispose(){f=B}}}class l{static{this._idPool=1}constructor(B,Y,G=(l._idPool++).toString(16).padStart(3,"0")){this._errorHandler=B,this.threshold=Y,this.name=G,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(B,Y){const G=this.threshold;if(G<=0||Y<G)return;this._stacks||(this._stacks=new Map);const Z=this._stacks.get(B.value)||0;if(this._stacks.set(B.value,Z+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=G*.5;const[se,le]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${Y} listeners already. MOST frequent listener (${le}):`;console.warn(V),console.warn(se);const z=new d(V,se);this._errorHandler(z)}return()=>{const se=this._stacks.get(B.value)||0;this._stacks.set(B.value,se-1)}}getMostFrequentStack(){if(!this._stacks)return;let B,Y=0;for(const[G,Z]of this._stacks)(!B||Y<Z)&&(B=[G,Z],Y=Z);return B}}class h{static create(){const B=new Error;return new h(B.stack??"")}constructor(B){this.value=B}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(B,Y){super(B),this.name="ListenerLeakError",this.stack=Y}}e.ListenerLeakError=d;class u extends Error{constructor(B,Y){super(B),this.name="ListenerRefusalError",this.stack=Y}}e.ListenerRefusalError=u;let n=0;class v{constructor(B){this.value=B,this.id=n++}}const b=2,o=(C,B)=>{if(C instanceof v)B(C);else for(let Y=0;Y<C.length;Y++){const G=C[Y];G&&B(G)}};let s;if(P){const C=[];setInterval(()=>{C.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(C.join(`
`)),C.length=0)},3e3),s=new FinalizationRegistry(B=>{typeof B=="string"&&C.push(B)})}class i{constructor(B){this._size=0,this._options=B,this._leakageMon=f>0||this._options?.leakWarningThreshold?new l(B?.onListenerError??a.onUnexpectedError,this._options?.leakWarningThreshold??f):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(g){const B=this._listeners;queueMicrotask(()=>{o(B,Y=>Y.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(B,Y,G)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const z=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(z);const Q=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new u(`${z}. HINT: Stack shows most frequent listener (${Q[1]}-times)`,Q[0]);return(this._options?.onListenerError||a.onUnexpectedError)(ee),D.Disposable.None}if(this._disposed)return D.Disposable.None;Y&&(B=B.bind(Y));const Z=new v(B);let se,le;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(Z.stack=h.create(),se=this._leakageMon.check(Z.stack,this._size+1)),g&&(Z.stack=le??h.create()),this._listeners?this._listeners instanceof v?(this._deliveryQueue??=new A,this._listeners=[this._listeners,Z]):this._listeners.push(Z):(this._options?.onWillAddFirstListener?.(this),this._listeners=Z,this._options?.onDidAddFirstListener?.(this)),this._size++;const V=(0,D.toDisposable)(()=>{s?.unregister(V),se?.(),this._removeListener(Z)});if(G instanceof D.DisposableStore?G.add(V):Array.isArray(G)&&G.push(V),s){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Q=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);s.register(V,Q?.[2]??z,V)}return V},this._event}_removeListener(B){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const Y=this._listeners,G=Y.indexOf(B);if(G===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,Y[G]=void 0;const Z=this._deliveryQueue.current===this;if(this._size*b<=Y.length){let se=0;for(let le=0;le<Y.length;le++)Y[le]?Y[se++]=Y[le]:Z&&(this._deliveryQueue.end--,se<this._deliveryQueue.i&&this._deliveryQueue.i--);Y.length=se}}_deliver(B,Y){if(!B)return;const G=this._options?.onListenerError||a.onUnexpectedError;if(!G){B.value(Y);return}try{B.value(Y)}catch(Z){G(Z)}}_deliverQueue(B){const Y=B.current._listeners;for(;B.i<B.end;)this._deliver(Y[B.i++],B.value);B.reset()}fire(B){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof v)this._deliver(this._listeners,B);else{const Y=this._deliveryQueue;Y.enqueue(this,B,this._listeners.length),this._deliverQueue(Y)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const _=()=>new A;e.createEventDeliveryQueue=_;class A{constructor(){this.i=-1,this.end=0}enqueue(B,Y,G){this.i=0,this.end=G,this.current=B,this.value=Y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class F extends i{async fireAsync(B,Y,G){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList),o(this._listeners,Z=>this._asyncDeliveryQueue.push([Z.value,B]));this._asyncDeliveryQueue.size>0&&!Y.isCancellationRequested;){const[Z,se]=this._asyncDeliveryQueue.shift(),le=[],V={...se,token:Y,waitUntil:z=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");G&&(z=G(z,Z)),le.push(z)}};try{Z(V)}catch(z){(0,a.onUnexpectedError)(z);continue}Object.freeze(le),await Promise.allSettled(le).then(z=>{for(const Q of z)Q.status==="rejected"&&(0,a.onUnexpectedError)(Q.reason)})}}}e.AsyncEmitter=F;class S extends i{get isPaused(){return this._isPaused!==0}constructor(B){super(B),this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=B?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const B=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(B))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(B){this._size&&(this._isPaused!==0?this._eventQueue.push(B):super.fire(B))}}e.PauseableEmitter=S;class L extends S{constructor(B){super(B),this._delay=B.delay??100}fire(B){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(B)}}e.DebounceEmitter=L;class k extends i{constructor(B){super(B),this._queuedEvents=[],this._mergeFn=B?.merge}fire(B){this.hasListeners()&&(this._queuedEvents.push(B),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(Y=>super.fire(Y)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=k;class O{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(B){const Y={event:B,listener:null};this.events.push(Y),this.hasListeners&&this.hook(Y);const G=()=>{this.hasListeners&&this.unhook(Y);const Z=this.events.indexOf(Y);this.events.splice(Z,1)};return(0,D.toDisposable)((0,t.createSingleCallFunction)(G))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(B=>this.hook(B))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(B=>this.unhook(B))}hook(B){B.listener=B.event(Y=>this.emitter.fire(Y))}unhook(B){B.listener?.dispose(),B.listener=null}dispose(){this.emitter.dispose();for(const B of this.events)B.listener?.dispose();this.events=[]}}e.EventMultiplexer=O;class x{constructor(B,Y,G,Z){this._store=new D.DisposableStore;const se=this._store.add(new O),le=this._store.add(new D.DisposableMap);function V(z){le.set(z,se.add(Z(z)))}for(const z of B)V(z);this._store.add(Y(z=>{V(z)})),this._store.add(G(z=>{le.deleteAndDispose(z)})),this.event=se.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=x;class R{constructor(){this.data=[]}wrapEvent(B,Y,G){return(Z,se,le)=>B(V=>{const z=this.data[this.data.length-1];if(!Y){z?z.buffers.push(()=>Z.call(se,V)):Z.call(se,V);return}const Q=z;if(!Q){Z.call(se,Y(G,V));return}Q.items??=[],Q.items.push(V),Q.buffers.length===0&&z.buffers.push(()=>{Q.reducedResult??=G?Q.items.reduce(Y,G):Q.items.reduce(Y),Z.call(se,Q.reducedResult)})},void 0,le)}bufferEvents(B){const Y={buffers:new Array};this.data.push(Y);const G=B();return this.data.pop(),Y.buffers.forEach(Z=>Z()),G}}e.EventBufferer=R;class E{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=D.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(B){this.inputEvent=B,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=B(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E;class U{static const(B){return new I(B)}constructor(B){this._value=B,this._onDidChange=new i,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(B){B!==this._value&&(this._value=B,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=U;class I{constructor(B){this.value=B,this.onDidChange=w.None}}}),define(he[18],fe([0,1,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=P;const t=Object.freeze(function(g,r){const w=setTimeout(g.bind(r),0);return{dispose(){clearTimeout(w)}}});var D;(function(g){function r(w){return w===g.None||w===g.Cancelled||w instanceof y?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}g.isCancellationToken=r,g.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),g.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D||(e.CancellationToken=D={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new a.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class W{constructor(r){this._token=void 0,this._parentListener=void 0,this._parentListener=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=D.Cancelled}dispose(r=!1){r&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=W;function P(g){const r=new W;return g.add({dispose(){r.cancel()}}),r.token}}),define(he[50],fe([0,1,18]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=D;class t{constructor(g){this.task=g,this.result=null}get(){if(this.result)return this.result;const g=new a.CancellationTokenSource,r=this.task(g.token);return this.result={promise:r,dispose:()=>{this.result=null,g.cancel(),g.dispose()}},this.result}}e.Cache=t;function D(P){return P}class y{constructor(g,r){this.lastCache=void 0,this.lastArgKey=void 0,typeof g=="function"?(this._fn=g,this._computeKey=D):(this._fn=r,this._computeKey=g.getCacheKey)}get(g){const r=this._computeKey(g);return this.lastArgKey!==r&&(this.lastArgKey=r,this.lastCache=this._fn(g)),this.lastCache}}e.LRUCachedFunction=y;class W{get cachedValues(){return this._map}constructor(g,r){this._map=new Map,this._map2=new Map,typeof g=="function"?(this._fn=g,this._computeKey=D):(this._fn=r,this._computeKey=g.getCacheKey)}get(g){const r=this._computeKey(g);if(this._map2.has(r))return this._map2.get(r);const w=this._fn(g);return this._map.set(g,w),this._map2.set(r,w),w}}e.CachedFunction=W}),define(he[51],fe([0,1,7,2]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=D,e.isReadableStream=y,e.isReadableBufferedStream=W,e.newWriteableStream=P,e.consumeReadable=r,e.peekReadable=w,e.consumeStream=p,e.listenStream=f,e.peekStream=c,e.toStream=l,e.emptyStream=h,e.toReadable=d,e.transform=u,e.prefixedReadable=n,e.prefixedStream=v;function D(b){const o=b;return o?typeof o.read=="function":!1}function y(b){const o=b;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}function W(b){const o=b;return o?y(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function P(b,o){return new g(b,o)}class g{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o<"u"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,a.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let i;switch(o){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const _=i.indexOf(s);_>=0&&i.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function r(b,o){const s=[];let i;for(;(i=b.read())!==null;)s.push(i);return o(s)}function w(b,o,s){const i=[];let _;for(;(_=b.read())!==null&&i.length<s;)i.push(_);return _===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof _<"u"){const A=_;return _=void 0,A}return b.read()}}}function p(b,o){return new Promise((s,i)=>{const _=[];f(b,{onData:A=>{o&&_.push(A)},onError:A=>{o?i(A):s(void 0)},onEnd:()=>{s(o?o(_):void 0)}})})}function f(b,o,s){b.on("error",i=>{s?.isCancellationRequested||o.onError(i)}),b.on("end",()=>{s?.isCancellationRequested||o.onEnd()}),b.on("data",i=>{s?.isCancellationRequested||o.onData(i)})}function c(b,o){return new Promise((s,i)=>{const _=new t.DisposableStore,A=[],F=k=>{if(A.push(k),A.length>o)return _.dispose(),b.pause(),s({stream:b,buffer:A,ended:!1})},S=k=>(_.dispose(),i(k)),L=()=>(_.dispose(),s({stream:b,buffer:A,ended:!0}));_.add((0,t.toDisposable)(()=>b.removeListener("error",S))),b.on("error",S),_.add((0,t.toDisposable)(()=>b.removeListener("end",L))),b.on("end",L),_.add((0,t.toDisposable)(()=>b.removeListener("data",F))),b.on("data",F)})}function l(b,o){const s=P(o);return s.end(b),s}function h(){const b=P(()=>{throw new Error("not supported")});return b.end(),b}function d(b){let o=!1;return{read:()=>o?null:(o=!0,b)}}function u(b,o,s){const i=P(s);return f(b,{onData:_=>i.write(o.data(_)),onError:_=>i.error(o.error?o.error(_):_),onEnd:()=>i.end()}),i}function n(b,o,s){let i=!1;return{read:()=>{const _=o.read();return i?_:(i=!0,_!==null?s([b,_]):b)}}}function v(b,o,s){let i=!1;const _=P(s);return f(o,{onData:A=>i?_.write(A):(i=!0,_.write(s([b,A]))),onError:A=>_.error(A),onEnd:()=>{i||(i=!0,_.write(b)),_.end()}}),_}}),define(he[19],fe([0,1,24,51]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=r,e.readUInt16LE=w,e.writeUInt16LE=p,e.readUInt32BE=f,e.writeUInt32BE=c,e.readUInt32LE=l,e.writeUInt32LE=h,e.readUInt8=d,e.writeUInt8=u,e.readableToBuffer=n,e.bufferToReadable=v,e.streamToBuffer=b,e.bufferedStreamToBuffer=o,e.bufferToStream=s,e.streamToBufferReadableStream=i,e.newWriteableBufferStream=_,e.prefixedBufferReadable=A,e.prefixedBufferStream=F,e.decodeBase64=S,e.encodeBase64=O,t=De(t);const D=typeof Buffer<"u",y=new a.Lazy(()=>new Uint8Array(256));let W,P;class g{static alloc(R){return D?new g(Buffer.allocUnsafe(R)):new g(new Uint8Array(R))}static wrap(R){return D&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new g(R)}static fromString(R,E){return!(E?.dontUseNodeBuffer||!1)&&D?new g(Buffer.from(R)):(W||(W=new TextEncoder),new g(W.encode(R)))}static fromByteArray(R){const E=g.alloc(R.length);for(let U=0,I=R.length;U<I;U++)E.buffer[U]=R[U];return E}static concat(R,E){if(typeof E>"u"){E=0;for(let C=0,B=R.length;C<B;C++)E+=R[C].byteLength}const U=g.alloc(E);let I=0;for(let C=0,B=R.length;C<B;C++){const Y=R[C];U.set(Y,I),I+=Y.byteLength}return U}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=g.alloc(this.byteLength);return R.set(this),R}toString(){return D?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(R,E){return new g(this.buffer.subarray(R,E))}set(R,E){if(R instanceof g)this.buffer.set(R.buffer,E);else if(R instanceof Uint8Array)this.buffer.set(R,E);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),E);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return f(this.buffer,R)}writeUInt32BE(R,E){c(this.buffer,R,E)}readUInt32LE(R){return l(this.buffer,R)}writeUInt32LE(R,E){h(this.buffer,R,E)}readUInt8(R){return d(this.buffer,R)}writeUInt8(R,E){u(this.buffer,R,E)}indexOf(R,E=0){return r(this.buffer,R instanceof g?R.buffer:R,E)}}e.VSBuffer=g;function r(x,R,E=0){const U=R.byteLength,I=x.byteLength;if(U===0)return 0;if(U===1)return x.indexOf(R[0]);if(U>I-E)return-1;const C=y.value;C.fill(R.length);for(let Z=0;Z<R.length;Z++)C[R[Z]]=R.length-Z-1;let B=E+R.length-1,Y=B,G=-1;for(;B<I;)if(x[B]===R[Y]){if(Y===0){G=B;break}B--,Y--}else B+=Math.max(R.length-Y,C[x[B]]),Y=R.length-1;return G}function w(x,R){return x[R+0]<<0>>>0|x[R+1]<<8>>>0}function p(x,R,E){x[E+0]=R&255,R=R>>>8,x[E+1]=R&255}function f(x,R){return x[R]*2**24+x[R+1]*2**16+x[R+2]*2**8+x[R+3]}function c(x,R,E){x[E+3]=R,R=R>>>8,x[E+2]=R,R=R>>>8,x[E+1]=R,R=R>>>8,x[E]=R}function l(x,R){return x[R+0]<<0>>>0|x[R+1]<<8>>>0|x[R+2]<<16>>>0|x[R+3]<<24>>>0}function h(x,R,E){x[E+0]=R&255,R=R>>>8,x[E+1]=R&255,R=R>>>8,x[E+2]=R&255,R=R>>>8,x[E+3]=R&255}function d(x,R){return x[R]}function u(x,R,E){x[E]=R}function n(x){return t.consumeReadable(x,R=>g.concat(R))}function v(x){return t.toReadable(x)}function b(x){return t.consumeStream(x,R=>g.concat(R))}async function o(x){return x.ended?g.concat(x.buffer):g.concat([...x.buffer,await b(x.stream)])}function s(x){return t.toStream(x,R=>g.concat(R))}function i(x){return t.transform(x,{data:R=>typeof R=="string"?g.fromString(R):g.wrap(R)},R=>g.concat(R))}function _(x){return t.newWriteableStream(R=>g.concat(R),x)}function A(x,R){return t.prefixedReadable(x,R,E=>g.concat(E))}function F(x,R){return t.prefixedStream(x,R,E=>g.concat(E))}function S(x){let R=0,E=0,U=0;const I=new Uint8Array(Math.floor(x.length/4*3)),C=Y=>{switch(E){case 3:I[U++]=R|Y,E=0;break;case 2:I[U++]=R|Y>>>2,R=Y<<6,E=3;break;case 1:I[U++]=R|Y>>>4,R=Y<<4,E=2;break;default:R=Y<<2,E=1}};for(let Y=0;Y<x.length;Y++){const G=x.charCodeAt(Y);if(G>=65&&G<=90)C(G-65);else if(G>=97&&G<=122)C(G-97+26);else if(G>=48&&G<=57)C(G-48+52);else if(G===43||G===45)C(62);else if(G===47||G===95)C(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${x[Y]}`)}}const B=U;for(;E>0;)C(0);return g.wrap(I).slice(0,B)}const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:x},R=!0,E=!1){const U=E?k:L;let I="";const C=x.byteLength%3;let B=0;for(;B<x.byteLength-C;B+=3){const Y=x[B+0],G=x[B+1],Z=x[B+2];I+=U[Y>>>2],I+=U[(Y<<4|G>>>4)&63],I+=U[(G<<2|Z>>>6)&63],I+=U[Z&63]}if(C===1){const Y=x[B+0];I+=U[Y>>>2],I+=U[Y<<4&63],R&&(I+="==")}else if(C===2){const Y=x[B+0],G=x[B+1];I+=U[Y>>>2],I+=U[(Y<<4|G>>>4)&63],I+=U[G<<2&63],R&&(I+="=")}return I}}),define(he[52],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(he[9],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=a,e.isStringArray=t,e.isObject=D,e.isTypedArray=y,e.isNumber=W,e.isIterable=P,e.isBoolean=g,e.isUndefined=r,e.isDefined=w,e.isUndefinedOrNull=p,e.assertType=f,e.assertIsDefined=c,e.assertAllDefined=l,e.isEmptyObject=d,e.isFunction=u,e.areFunctions=n,e.validateConstraints=v,e.validateConstraint=b,e.upcast=o;function a(s){return typeof s=="string"}function t(s){return Array.isArray(s)&&s.every(i=>a(i))}function D(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function y(s){const i=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof i}function W(s){return typeof s=="number"&&!isNaN(s)}function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}function g(s){return s===!0||s===!1}function r(s){return typeof s>"u"}function w(s){return!p(s)}function p(s){return r(s)||s===null}function f(s,i){if(!s)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function c(s){if(p(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function l(...s){const i=[];for(let _=0;_<s.length;_++){const A=s[_];if(p(A))throw new Error(`Assertion Failed: argument at index ${_} is undefined or null`);i.push(A)}return i}const h=Object.prototype.hasOwnProperty;function d(s){if(!D(s))return!1;for(const i in s)if(h.call(s,i))return!1;return!0}function u(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(u)}function v(s,i){const _=Math.min(s.length,i.length);for(let A=0;A<_;A++)b(s[A],i[A])}function b(s,i){if(a(i)){if(typeof s!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(s instanceof i)return}catch{}if(!p(s)&&s.constructor===i||i.length===1&&i.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function o(s){return s}}),define(he[33],fe([0,1,9]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=t,e.deepFreeze=D,e.cloneAndChange=W,e.mixin=g,e.equals=r,e.safeStringify=w,e.distinct=p,e.getCaseInsensitive=f,e.filter=c,e.getAllPropertyNames=l,e.getAllMethodNames=h,e.createProxyObject=d,e.mapValues=u;function t(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const v=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([b,o])=>{v[b]=o&&typeof o=="object"?t(o):o}),v}function D(n){if(!n||typeof n!="object")return n;const v=[n];for(;v.length>0;){const b=v.shift();Object.freeze(b);for(const o in b)if(y.call(b,o)){const s=b[o];typeof s=="object"&&!Object.isFrozen(s)&&!(0,a.isTypedArray)(s)&&v.push(s)}}return n}const y=Object.prototype.hasOwnProperty;function W(n,v){return P(n,v,new Set)}function P(n,v,b){if((0,a.isUndefinedOrNull)(n))return n;const o=v(n);if(typeof o<"u")return o;if(Array.isArray(n)){const s=[];for(const i of n)s.push(P(i,v,b));return s}if((0,a.isObject)(n)){if(b.has(n))throw new Error("Cannot clone recursive data-structure");b.add(n);const s={};for(const i in n)y.call(n,i)&&(s[i]=P(n[i],v,b));return b.delete(n),s}return n}function g(n,v,b=!0){return(0,a.isObject)(n)?((0,a.isObject)(v)&&Object.keys(v).forEach(o=>{o in n?b&&((0,a.isObject)(n[o])&&(0,a.isObject)(v[o])?g(n[o],v[o],b):n[o]=v[o]):n[o]=v[o]}),n):v}function r(n,v){if(n===v)return!0;if(n==null||v===null||v===void 0||typeof n!=typeof v||typeof n!="object"||Array.isArray(n)!==Array.isArray(v))return!1;let b,o;if(Array.isArray(n)){if(n.length!==v.length)return!1;for(b=0;b<n.length;b++)if(!r(n[b],v[b]))return!1}else{const s=[];for(o in n)s.push(o);s.sort();const i=[];for(o in v)i.push(o);if(i.sort(),!r(s,i))return!1;for(b=0;b<s.length;b++)if(!r(n[s[b]],v[s[b]]))return!1}return!0}function w(n){const v=new Set;return JSON.stringify(n,(b,o)=>{if((0,a.isObject)(o)||Array.isArray(o)){if(v.has(o))return"[Circular]";v.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function p(n,v){const b=Object.create(null);return!n||!v||Object.keys(v).forEach(s=>{const i=n[s],_=v[s];r(i,_)||(b[s]=_)}),b}function f(n,v){const b=v.toLowerCase(),o=Object.keys(n).find(s=>s.toLowerCase()===b);return o?n[o]:n[v]}function c(n,v){const b=Object.create(null);for(const[o,s]of Object.entries(n))v(o,s)&&(b[o]=s);return b}function l(n){let v=[];for(;Object.prototype!==n;)v=v.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return v}function h(n){const v=[];for(const b of l(n))typeof n[b]=="function"&&v.push(b);return v}function d(n,v){const b=s=>function(){const i=Array.prototype.slice.call(arguments,0);return v(s,i)},o={};for(const s of n)o[s]=b(s);return o}function u(n,v){const b={};for(const[o,s]of Object.entries(n))b[o]=v(s,o);return b}}),define(he[53],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=t,e.toUint32=D;var a;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a||(e.Constants=a={}));function t(y){return y<0?0:y>a.MAX_UINT_8?a.MAX_UINT_8:y|0}function D(y){return y<0?0:y>a.MAX_UINT_32?a.MAX_UINT_32:y|0}}),define(he[10],fe([0,1,50,13,24,53]),function(ie,e,a,t,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=W,e.format=g,e.format2=w,e.htmlAttributeEncodeValue=p,e.escape=f,e.escapeRegExpCharacters=c,e.count=l,e.truncate=h,e.truncateMiddle=d,e.trim=u,e.ltrim=n,e.rtrim=v,e.convertSimple2RegExpPattern=b,e.stripWildcards=o,e.createRegExp=s,e.regExpLeadsToEndlessLoop=i,e.splitLines=_,e.splitLinesIncludeSeparators=A,e.firstNonWhitespaceIndex=F,e.getLeadingWhitespace=S,e.lastNonWhitespaceIndex=L,e.replaceAsync=k,e.compare=O,e.compareSubstring=x,e.compareIgnoreCase=R,e.compareSubstringIgnoreCase=E,e.isAsciiDigit=U,e.isLowerAsciiLetter=I,e.isUpperAsciiLetter=C,e.equalsIgnoreCase=B,e.startsWithIgnoreCase=Y,e.commonPrefixLength=G,e.commonSuffixLength=Z,e.isHighSurrogate=se,e.isLowSurrogate=le,e.computeCodePoint=V,e.getNextCodePoint=z,e.nextCharLength=$,e.prevCharLength=ae,e.getCharContainingOffset=me,e.charCount=te,e.containsRTL=oe,e.isBasicASCII=K,e.containsUnusualLineTerminators=M,e.isFullWidthCharacter=T,e.isEmojiImprecise=H,e.lcut=J,e.forAnsiStringParts=pe,e.removeAnsiEscapeCodes=we,e.removeAnsiEscapeCodesFromPrompt=ge,e.startsWithUTF8BOM=de,e.stripUTF8BOM=ve,e.fuzzyContains=ye,e.containsUppercaseCharacter=be,e.uppercaseFirstLetter=Le,e.getNLines=Ce,e.singleLetterHash=Ae,e.getGraphemeBreakType=Re,e.getLeftDeleteOffset=qe;function W(q){return!q||typeof q!="string"?!0:q.trim().length===0}const P=/{(\d+)}/g;function g(q,...X){return X.length===0?q:q.replace(P,function(re,ce){const Ee=parseInt(ce,10);return isNaN(Ee)||Ee<0||Ee>=X.length?re:X[Ee]})}const r=/{([^}]+)}/g;function w(q,X){return Object.keys(X).length===0?q:q.replace(r,(re,ce)=>X[ce]??re)}function p(q){return q.replace(/[<>"'&]/g,X=>{switch(X){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return X})}function f(q){return q.replace(/[<>&]/g,function(X){switch(X){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return X}})}function c(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(q,X){let re=0,ce=q.indexOf(X);for(;ce!==-1;)re++,ce=q.indexOf(X,ce+X.length);return re}function h(q,X,re="\u2026"){return q.length<=X?q:`${q.substr(0,X)}${re}`}function d(q,X,re="\u2026"){if(q.length<=X)return q;const ce=Math.ceil(X/2)-re.length/2,Ee=Math.floor(X/2)-re.length/2;return`${q.substr(0,ce)}${re}${q.substr(q.length-Ee)}`}function u(q,X=" "){const re=n(q,X);return v(re,X)}function n(q,X){if(!q||!X)return q;const re=X.length;if(re===0||q.length===0)return q;let ce=0;for(;q.indexOf(X,ce)===ce;)ce=ce+re;return q.substring(ce)}function v(q,X){if(!q||!X)return q;const re=X.length,ce=q.length;if(re===0||ce===0)return q;let Ee=ce,Pe=-1;for(;Pe=q.lastIndexOf(X,Ee-1),!(Pe===-1||Pe+re!==Ee);){if(Pe===0)return"";Ee=Pe}return q.substring(0,Ee)}function b(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(q){return q.replace(/\*/g,"")}function s(q,X,re={}){if(!q)throw new Error("Cannot create regex from empty string");X||(q=c(q)),re.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ce="";return re.global&&(ce+="g"),re.matchCase||(ce+="i"),re.multiline&&(ce+="m"),re.unicode&&(ce+="u"),new RegExp(q,ce)}function i(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}function _(q){return q.split(/\r\n|\r|\n/)}function A(q){const X=[],re=q.split(/(\r\n|\r|\n)/);for(let ce=0;ce<Math.ceil(re.length/2);ce++)X.push(re[2*ce]+(re[2*ce+1]??""));return X}function F(q){for(let X=0,re=q.length;X<re;X++){const ce=q.charCodeAt(X);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return X}return-1}function S(q,X=0,re=q.length){for(let ce=X;ce<re;ce++){const Ee=q.charCodeAt(ce);if(Ee!==t.CharCode.Space&&Ee!==t.CharCode.Tab)return q.substring(X,ce)}return q.substring(X,re)}function L(q,X=q.length-1){for(let re=X;re>=0;re--){const ce=q.charCodeAt(re);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return re}return-1}function k(q,X,re){const ce=[];let Ee=0;for(const Pe of q.matchAll(X)){if(ce.push(q.slice(Ee,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Ee=Pe.index+Pe[0].length,ce.push(re(Pe[0],...Pe.slice(1),Pe.index,q,Pe.groups))}return ce.push(q.slice(Ee)),Promise.all(ce).then(Pe=>Pe.join(""))}function O(q,X){return q<X?-1:q>X?1:0}function x(q,X,re=0,ce=q.length,Ee=0,Pe=X.length){for(;re<ce&&Ee<Pe;re++,Ee++){const Me=q.charCodeAt(re),Ue=X.charCodeAt(Ee);if(Me<Ue)return-1;if(Me>Ue)return 1}const ke=ce-re,Be=Pe-Ee;return ke<Be?-1:ke>Be?1:0}function R(q,X){return E(q,X,0,q.length,0,X.length)}function E(q,X,re=0,ce=q.length,Ee=0,Pe=X.length){for(;re<ce&&Ee<Pe;re++,Ee++){let Me=q.charCodeAt(re),Ue=X.charCodeAt(Ee);if(Me===Ue)continue;if(Me>=128||Ue>=128)return x(q.toLowerCase(),X.toLowerCase(),re,ce,Ee,Pe);I(Me)&&(Me-=32),I(Ue)&&(Ue-=32);const Te=Me-Ue;if(Te!==0)return Te}const ke=ce-re,Be=Pe-Ee;return ke<Be?-1:ke>Be?1:0}function U(q){return q>=t.CharCode.Digit0&&q<=t.CharCode.Digit9}function I(q){return q>=t.CharCode.a&&q<=t.CharCode.z}function C(q){return q>=t.CharCode.A&&q<=t.CharCode.Z}function B(q,X){return q.length===X.length&&E(q,X)===0}function Y(q,X){const re=X.length;return X.length>q.length?!1:E(q,X,0,re)===0}function G(q,X){const re=Math.min(q.length,X.length);let ce;for(ce=0;ce<re;ce++)if(q.charCodeAt(ce)!==X.charCodeAt(ce))return ce;return re}function Z(q,X){const re=Math.min(q.length,X.length);let ce;const Ee=q.length-1,Pe=X.length-1;for(ce=0;ce<re;ce++)if(q.charCodeAt(Ee-ce)!==X.charCodeAt(Pe-ce))return ce;return re}function se(q){return 55296<=q&&q<=56319}function le(q){return 56320<=q&&q<=57343}function V(q,X){return(q-55296<<10)+(X-56320)+65536}function z(q,X,re){const ce=q.charCodeAt(re);if(se(ce)&&re+1<X){const Ee=q.charCodeAt(re+1);if(le(Ee))return V(ce,Ee)}return ce}function Q(q,X){const re=q.charCodeAt(X-1);if(le(re)&&X>1){const ce=q.charCodeAt(X-2);if(se(ce))return V(ce,re)}return re}class ee{get offset(){return this._offset}constructor(X,re=0){this._str=X,this._len=X.length,this._offset=re}setOffset(X){this._offset=X}prevCodePoint(){const X=Q(this._str,this._offset);return this._offset-=X>=y.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,X}nextCodePoint(){const X=z(this._str,this._len,this._offset);return this._offset+=X>=y.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,X}eol(){return this._offset>=this._len}}e.CodePointIterator=ee;class ue{get offset(){return this._iterator.offset}constructor(X,re=0){this._iterator=new ee(X,re)}nextGraphemeLength(){const X=Oe.getInstance(),re=this._iterator,ce=re.offset;let Ee=X.getGraphemeBreakType(re.nextCodePoint());for(;!re.eol();){const Pe=re.offset,ke=X.getGraphemeBreakType(re.nextCodePoint());if(Fe(Ee,ke)){re.setOffset(Pe);break}Ee=ke}return re.offset-ce}prevGraphemeLength(){const X=Oe.getInstance(),re=this._iterator,ce=re.offset;let Ee=X.getGraphemeBreakType(re.prevCodePoint());for(;re.offset>0;){const Pe=re.offset,ke=X.getGraphemeBreakType(re.prevCodePoint());if(Fe(ke,Ee)){re.setOffset(Pe);break}Ee=ke}return ce-re.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ue;function $(q,X){return new ue(q,X).nextGraphemeLength()}function ae(q,X){return new ue(q,X).prevGraphemeLength()}function me(q,X){X>0&&le(q.charCodeAt(X))&&X--;const re=X+$(q,X);return[re-ae(q,re),re]}function te(q){const X=new ue(q);let re=0;for(;!X.eol();)re++,X.nextGraphemeLength();return re}let m;function j(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(q){return m||(m=j()),m.test(q)}const N=/^[\t\n\r\x20-\x7E]*$/;function K(q){return N.test(q)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function M(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}function T(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}function H(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}function J(q,X,re=""){const ce=q.trimStart();if(ce.length<X)return ce;const Ee=/\b/g;let Pe=0;for(;Ee.test(ce)&&!(ce.length-Ee.lastIndex<X);)Pe=Ee.lastIndex,Ee.lastIndex+=1;return Pe===0?ce:re+ce.substring(Pe).trimStart()}const ne=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(q){let X=0;for(const re of q.matchAll(ne))X!==re.index&&(yield{isCode:!1,str:q.substring(X,re.index)}),yield{isCode:!0,str:re[0]},X=re.index+re[0].length;X!==q.length&&(yield{isCode:!1,str:q.substring(X)})}function we(q){return q&&(q=q.replace(ne,"")),q}const Ie=/\\\[.*?\\\]/g;function ge(q){return we(q).replace(Ie,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(t.CharCode.UTF8_BOM);function de(q){return!!(q&&q.length>0&&q.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ve(q){return de(q)?q.substr(1):q}function ye(q,X){if(!q||!X||q.length<X.length)return!1;const re=X.length,ce=q.toLowerCase();let Ee=0,Pe=-1;for(;Ee<re;){const ke=ce.indexOf(X[Ee],Pe+1);if(ke<0)return!1;Pe=ke,Ee++}return!0}function be(q,X=!1){return q?(X&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}function Le(q){return q.charAt(0).toUpperCase()+q.slice(1)}function Ce(q,X=1){if(X===0)return"";let re=-1;do re=q.indexOf(`
`,re+1),X--;while(X>0&&re>=0);return re===-1?q:(q[re-1]==="\r"&&re--,q.substr(0,re))}function Ae(q){const X=t.CharCode.Z-t.CharCode.A+1;return q=q%(2*X),q<X?String.fromCharCode(t.CharCode.a+q):String.fromCharCode(t.CharCode.A+q-X)}function Re(q){return Oe.getInstance().getGraphemeBreakType(q)}function Fe(q,X){return q===Se.Other?X!==Se.Extend&&X!==Se.SpacingMark:q===Se.CR&&X===Se.LF?!1:q===Se.Control||q===Se.CR||q===Se.LF||X===Se.Control||X===Se.CR||X===Se.LF?!0:!(q===Se.L&&(X===Se.L||X===Se.V||X===Se.LV||X===Se.LVT)||(q===Se.LV||q===Se.V)&&(X===Se.V||X===Se.T)||(q===Se.LVT||q===Se.T)&&X===Se.T||X===Se.Extend||X===Se.ZWJ||X===Se.SpacingMark||q===Se.Prepend||q===Se.ZWJ&&X===Se.Extended_Pictographic||q===Se.Regional_Indicator&&X===Se.Regional_Indicator)}var Se;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Se||(e.GraphemeBreakType=Se={}));class Oe{static{this._INSTANCE=null}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}constructor(){this._data=He()}getGraphemeBreakType(X){if(X<32)return X===t.CharCode.LineFeed?Se.LF:X===t.CharCode.CarriageReturn?Se.CR:Se.Control;if(X<127)return Se.Other;const re=this._data,ce=re.length/3;let Ee=1;for(;Ee<=ce;)if(X<re[3*Ee])Ee=2*Ee;else if(X>re[3*Ee+1])Ee=2*Ee+1;else return re[3*Ee+2];return Se.Other}}function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(q,X){if(q===0)return 0;const re=Ke(q,X);if(re!==void 0)return re;const ce=new ee(X,q);return ce.prevCodePoint(),ce.offset}function Ke(q,X){const re=new ee(X,q);let ce=re.prevCodePoint();for(;Xe(ce)||ce===je.emojiVariantSelector||ce===je.enclosingKeyCap;){if(re.offset===0)return;ce=re.prevCodePoint()}if(!H(ce))return;let Ee=re.offset;return Ee>0&&re.prevCodePoint()===je.zwj&&(Ee=re.offset),Ee}function Xe(q){return 127995<=q&&q<=127999}var je;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class $e{static{this.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new a.LRUCachedFunction({getCacheKey:JSON.stringify},X=>{function re(Te){const ze=new Map;for(let Ne=0;Ne<Te.length;Ne+=2)ze.set(Te[Ne],Te[Ne+1]);return ze}function ce(Te,ze){const Ne=new Map(Te);for(const[Ge,Qe]of ze)Ne.set(Ge,Qe);return Ne}function Ee(Te,ze){if(!Te)return ze;const Ne=new Map;for(const[Ge,Qe]of Te)ze.has(Ge)&&Ne.set(Ge,Qe);return Ne}const Pe=this.ambiguousCharacterData.value;let ke=X.filter(Te=>!Te.startsWith("_")&&Te in Pe);ke.length===0&&(ke=["_default"]);let Be;for(const Te of ke){const ze=re(Pe[Te]);Be=Ee(Be,ze)}const Me=re(Pe._common),Ue=ce(Me,Be);return new $e(Ue)})}static getInstance(X){return $e.cache.get(Array.from(X))}static{this._locales=new D.Lazy(()=>Object.keys($e.ambiguousCharacterData.value).filter(X=>!X.startsWith("_")))}static getLocales(){return $e._locales.value}constructor(X){this.confusableDictionary=X}isAmbiguous(X){return this.confusableDictionary.has(X)}containsAmbiguousCharacter(X){for(let re=0;re<X.length;re++){const ce=X.codePointAt(re);if(typeof ce=="number"&&this.isAmbiguous(ce))return!0}return!1}getPrimaryConfusable(X){return this.confusableDictionary.get(X)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=$e;class xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(xe.getRawData())),this._data}static isInvisibleCharacter(X){return xe.getData().has(X)}static containsInvisibleCharacter(X){for(let re=0;re<X.length;re++){const ce=X.codePointAt(re);if(typeof ce=="number"&&xe.isInvisibleCharacter(ce))return!0}return!1}static get codePoints(){return xe.getData()}}e.InvisibleCharacters=xe}),define(he[34],fe([0,1,13,5,3,10,9]),function(ie,e,a,t,D,y,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=P,e.toSlashes=g,e.toPosixPath=r,e.getRoot=w,e.isUNC=p,e.isValidBasename=h,e.isEqual=d,e.isEqualOrParent=u,e.isWindowsDriveLetter=n,e.sanitizeFilePath=v,e.removeTrailingPathSeparator=b,e.isRootOrDriveLetter=o,e.hasDriveLetter=s,e.getDriveLetter=i,e.indexOfPath=_,e.parseLineAndColumnAware=A,e.randomPath=L;function P(k){return k===a.CharCode.Slash||k===a.CharCode.Backslash}function g(k){return k.replace(/[\\/]/g,t.posix.sep)}function r(k){return k.indexOf("/")===-1&&(k=g(k)),/^[a-zA-Z]:(\/|$)/.test(k)&&(k="/"+k),k}function w(k,O=t.posix.sep){if(!k)return"";const x=k.length,R=k.charCodeAt(0);if(P(R)){if(P(k.charCodeAt(1))&&!P(k.charCodeAt(2))){let U=3;const I=U;for(;U<x&&!P(k.charCodeAt(U));U++);if(I!==U&&!P(k.charCodeAt(U+1))){for(U+=1;U<x;U++)if(P(k.charCodeAt(U)))return k.slice(0,U+1).replace(/[\\/]/g,O)}}return O}else if(n(R)&&k.charCodeAt(1)===a.CharCode.Colon)return P(k.charCodeAt(2))?k.slice(0,2)+O:k.slice(0,2);let E=k.indexOf("://");if(E!==-1){for(E+=3;E<x;E++)if(P(k.charCodeAt(E)))return k.slice(0,E+1)}return""}function p(k){if(!D.isWindows||!k||k.length<5)return!1;let O=k.charCodeAt(0);if(O!==a.CharCode.Backslash||(O=k.charCodeAt(1),O!==a.CharCode.Backslash))return!1;let x=2;const R=x;for(;x<k.length&&(O=k.charCodeAt(x),O!==a.CharCode.Backslash);x++);return!(R===x||(O=k.charCodeAt(x+1),isNaN(O)||O===a.CharCode.Backslash))}const f=/[\\/:\*\?"<>\|]/g,c=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(k,O=D.isWindows){const x=O?f:c;return!(!k||k.length===0||/^\s+$/.test(k)||(x.lastIndex=0,x.test(k))||O&&l.test(k)||k==="."||k===".."||O&&k[k.length-1]==="."||O&&k.length!==k.trim().length||k.length>255)}function d(k,O,x){const R=k===O;return!x||R?R:!k||!O?!1:(0,y.equalsIgnoreCase)(k,O)}function u(k,O,x,R=t.sep){if(k===O)return!0;if(!k||!O||O.length>k.length)return!1;if(x){if(!(0,y.startsWithIgnoreCase)(k,O))return!1;if(O.length===k.length)return!0;let U=O.length;return O.charAt(O.length-1)===R&&U--,k.charAt(U)===R}return O.charAt(O.length-1)!==R&&(O+=R),k.indexOf(O)===0}function n(k){return k>=a.CharCode.A&&k<=a.CharCode.Z||k>=a.CharCode.a&&k<=a.CharCode.z}function v(k,O){return D.isWindows&&k.endsWith(":")&&(k+=t.sep),(0,t.isAbsolute)(k)||(k=(0,t.join)(O,k)),k=(0,t.normalize)(k),b(k)}function b(k){return D.isWindows?(k=(0,y.rtrim)(k,t.sep),k.endsWith(":")&&(k+=t.sep)):(k=(0,y.rtrim)(k,t.sep),k||(k=t.sep)),k}function o(k){const O=(0,t.normalize)(k);return D.isWindows?k.length>3?!1:s(O)&&(k.length===2||O.charCodeAt(2)===a.CharCode.Backslash):O===t.posix.sep}function s(k,O=D.isWindows){return O?n(k.charCodeAt(0))&&k.charCodeAt(1)===a.CharCode.Colon:!1}function i(k,O=D.isWindows){return s(k,O)?k[0]:void 0}function _(k,O,x){return O.length>k.length?-1:k===O?0:(x&&(k=k.toLowerCase(),O=O.toLowerCase()),k.indexOf(O))}function A(k){const O=k.split(":");let x,R,E;for(const U of O){const I=Number(U);(0,W.isNumber)(I)?R===void 0?R=I:E===void 0&&(E=I):x=x?[x,U].join(":"):U}if(!x)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:x,line:R!==void 0?R:void 0,column:E!==void 0?E:R!==void 0?1:void 0}}const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",S="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function L(k,O,x=8){let R="";for(let U=0;U<x;U++){let I;U===0&&D.isWindows&&!O&&(x===3||x===4)?I=S:I=F,R+=I.charAt(Math.floor(Math.random()*I.length))}let E;return O?E=`${O}-${R}`:E=R,k?(0,t.join)(k,E):E}}),define(he[54],fe([0,1,10]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=t,e.doHash=D,e.numberHash=y,e.stringHash=P,e.toHexString=h,a=De(a);function t(u){return D(u,0)}function D(u,n){switch(typeof u){case"object":return u===null?y(349,n):Array.isArray(u)?g(u,n):r(u,n);case"string":return P(u,n);case"boolean":return W(u,n);case"number":return y(u,n);case"undefined":return y(937,n);default:return y(617,n)}}function y(u,n){return(n<<5)-n+u|0}function W(u,n){return y(u?433:863,n)}function P(u,n){n=y(149417,n);for(let v=0,b=u.length;v<b;v++)n=y(u.charCodeAt(v),n);return n}function g(u,n){return n=y(104579,n),u.reduce((v,b)=>D(b,v),n)}function r(u,n){return n=y(181387,n),Object.keys(u).sort().reduce((v,b)=>(v=P(b,v),D(u[b],v)),n)}class w{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=D(n,this._value),this._value}}e.Hasher=w;var p;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function f(u,n,v=32){const b=v-n,o=~((1<<b)-1);return(u<<n|(o&u)>>>b)>>>0}function c(u,n=0,v=u.byteLength,b=0){for(let o=0;o<v;o++)u[n+o]=b}function l(u,n,v="0"){for(;u.length<n;)u=v+u;return u}function h(u,n=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(v=>v.toString(16).padStart(2,"0")).join(""):l((u>>>0).toString(16),n/4)}class d{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(p.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const v=n.length;if(v===0)return;const b=this._buff;let o=this._buffLen,s=this._leftoverHighSurrogate,i,_;for(s!==0?(i=s,_=-1,s=0):(i=n.charCodeAt(0),_=0);;){let A=i;if(a.isHighSurrogate(i))if(_+1<v){const F=n.charCodeAt(_+1);a.isLowSurrogate(F)?(_++,A=a.computeCodePoint(i,F)):A=p.UNICODE_REPLACEMENT}else{s=i;break}else a.isLowSurrogate(i)&&(A=p.UNICODE_REPLACEMENT);if(o=this._push(b,o,A),_++,_<v)i=n.charCodeAt(_);else break}this._buffLen=o,this._leftoverHighSurrogate=s}_push(n,v,b){return b<128?n[v++]=b:b<2048?(n[v++]=192|(b&1984)>>>6,n[v++]=128|(b&63)>>>0):b<65536?(n[v++]=224|(b&61440)>>>12,n[v++]=128|(b&4032)>>>6,n[v++]=128|(b&63)>>>0):(n[v++]=240|(b&1835008)>>>18,n[v++]=128|(b&258048)>>>12,n[v++]=128|(b&4032)>>>6,n[v++]=128|(b&63)>>>0),v>=p.BLOCK_SIZE&&(this._step(),v-=p.BLOCK_SIZE,this._totalLen+=p.BLOCK_SIZE,n[0]=n[p.BLOCK_SIZE+0],n[1]=n[p.BLOCK_SIZE+1],n[2]=n[p.BLOCK_SIZE+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,p.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=d._bigBlock32,v=this._buffDV;for(let L=0;L<64;L+=4)n.setUint32(L,v.getUint32(L,!1),!1);for(let L=64;L<320;L+=4)n.setUint32(L,f(n.getUint32(L-12,!1)^n.getUint32(L-32,!1)^n.getUint32(L-56,!1)^n.getUint32(L-64,!1),1),!1);let b=this._h0,o=this._h1,s=this._h2,i=this._h3,_=this._h4,A,F,S;for(let L=0;L<80;L++)L<20?(A=o&s|~o&i,F=1518500249):L<40?(A=o^s^i,F=1859775393):L<60?(A=o&s|o&i|s&i,F=2400959708):(A=o^s^i,F=3395469782),S=f(b,5)+A+_+F+n.getUint32(L*4,!1)&4294967295,_=i,i=s,s=f(o,30),o=b,b=S;this._h0=this._h0+b&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+_&4294967295}}e.StringSHA1=d}),define(he[55],fe([0,1,17,13,10]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const h=l.charCodeAt(0),d=this._value.charCodeAt(this._pos);return h-d}value(){return this._value[this._pos]}}e.StringIterator=y;class W{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===t.CharCode.Period)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,D.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=W;class P{constructor(l=!0,h=!0){this._splitOnBackslash=l,this._caseSensitive=h}reset(l){this._from=0,this._to=0,this._value=l,this._valueLen=l.length;for(let h=l.length-1;h>=0;h--,this._valueLen--){const d=this._value.charCodeAt(h);if(!(d===t.CharCode.Slash||this._splitOnBackslash&&d===t.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let l=!0;for(;this._to<this._valueLen;this._to++){const h=this._value.charCodeAt(this._to);if(h===t.CharCode.Slash||this._splitOnBackslash&&h===t.CharCode.Backslash)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,D.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=P;var g;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(g||(g={}));class r{constructor(l,h){this._ignorePathCasing=l,this._ignoreQueryAndFragment=h,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(g.Scheme),this._value.authority&&this._states.push(g.Authority),this._value.path&&(this._pathIterator=new P(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(g.Path)),this._ignoreQueryAndFragment(l)||(this._value.query&&this._states.push(g.Query),this._value.fragment&&this._states.push(g.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===g.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===g.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===g.Scheme)return(0,D.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===g.Authority)return(0,D.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===g.Path)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===g.Query)return(0,D.compare)(l,this._value.query);if(this._states[this._stateIdx]===g.Fragment)return(0,D.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===g.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===g.Authority)return this._value.authority;if(this._states[this._stateIdx]===g.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===g.Query)return this._value.query;if(this._states[this._stateIdx]===g.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=r;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(p||(p={}));class f{static forUris(l=()=>!1,h=()=>!1){return new f(new r(l,h))}static forPaths(l=!1){return new f(new P(void 0,!l))}static forStrings(){return new f(new y)}static forConfigKeys(){return new f(new W)}constructor(l){this._iter=l}clear(){this._root=void 0}fill(l,h){if(h){const d=h.slice(0);(0,a.shuffle)(d);for(const u of d)this.set(u,l)}else{const d=l.slice(0);(0,a.shuffle)(d);for(const u of d)this.set(u[0],u[1])}}set(l,h){const d=this._iter.reset(l);let u;this._root||(this._root=new w,this._root.segment=d.value());const n=[];for(u=this._root;;){const b=d.cmp(u.segment);if(b>0)u.left||(u.left=new w,u.left.segment=d.value()),n.push([p.Left,u]),u=u.left;else if(b<0)u.right||(u.right=new w,u.right.segment=d.value()),n.push([p.Right,u]),u=u.right;else if(d.hasNext())d.next(),u.mid||(u.mid=new w,u.mid.segment=d.value()),n.push([p.Mid,u]),u=u.mid;else break}const v=u.value;u.value=h,u.key=l;for(let b=n.length-1;b>=0;b--){const o=n[b][1];o.updateHeight();const s=o.balanceFactor();if(s<-1||s>1){const i=n[b][0],_=n[b+1][0];if(i===p.Right&&_===p.Right)n[b][1]=o.rotateLeft();else if(i===p.Left&&_===p.Left)n[b][1]=o.rotateRight();else if(i===p.Right&&_===p.Left)o.right=n[b+1][1]=n[b+1][1].rotateRight(),n[b][1]=o.rotateLeft();else if(i===p.Left&&_===p.Right)o.left=n[b+1][1]=n[b+1][1].rotateLeft(),n[b][1]=o.rotateRight();else throw new Error;if(b>0)switch(n[b-1][0]){case p.Left:n[b-1][1].left=n[b][1];break;case p.Right:n[b-1][1].right=n[b][1];break;case p.Mid:n[b-1][1].mid=n[b][1];break}else this._root=n[0][1]}}return v}get(l){return this._getNode(l)?.value}_getNode(l){const h=this._iter.reset(l);let d=this._root;for(;d;){const u=h.cmp(d.segment);if(u>0)d=d.left;else if(u<0)d=d.right;else if(h.hasNext())h.next(),d=d.mid;else break}return d}has(l){const h=this._getNode(l);return!(h?.value===void 0&&h?.mid===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,h){const d=this._iter.reset(l),u=[];let n=this._root;for(;n;){const v=d.cmp(n.segment);if(v>0)u.push([p.Left,n]),n=n.left;else if(v<0)u.push([p.Right,n]),n=n.right;else if(d.hasNext())d.next(),u.push([p.Mid,n]),n=n.mid;else break}if(n){if(h?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const v=this._min(n.right);if(v.key){const{key:b,value:o,segment:s}=v;this._delete(v.key,!1),n.key=b,n.value=o,n.segment=s}}else{const v=n.left??n.right;if(u.length>0){const[b,o]=u[u.length-1];switch(b){case p.Left:o.left=v;break;case p.Mid:o.mid=v;break;case p.Right:o.right=v;break}}else this._root=v}for(let v=u.length-1;v>=0;v--){const b=u[v][1];b.updateHeight();const o=b.balanceFactor();if(o>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),u[v][1]=b.rotateLeft()):o<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),u[v][1]=b.rotateRight()),v>0)switch(u[v-1][0]){case p.Left:u[v-1][1].left=u[v][1];break;case p.Right:u[v-1][1].right=u[v][1];break;case p.Mid:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}}_min(l){for(;l.left;)l=l.left;return l}findSubstr(l){const h=this._iter.reset(l);let d=this._root,u;for(;d;){const n=h.cmp(d.segment);if(n>0)d=d.left;else if(n<0)d=d.right;else if(h.hasNext())h.next(),u=d.value||u,d=d.mid;else break}return d&&d.value||u}findSuperstr(l){return this._findSuperstrOrElement(l,!1)}_findSuperstrOrElement(l,h){const d=this._iter.reset(l);let u=this._root;for(;u;){const n=d.cmp(u.segment);if(n>0)u=u.left;else if(n<0)u=u.right;else if(d.hasNext())d.next(),u=u.mid;else return u.mid?this._entries(u.mid):h?u.value:void 0}}hasElementOrSubtree(l){return this._findSuperstrOrElement(l,!0)!==void 0}forEach(l){for(const[h,d]of this)l(d,h)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(l){const h=[];return this._dfsEntries(l,h),h[Symbol.iterator]()}_dfsEntries(l,h){l&&(l.left&&this._dfsEntries(l.left,h),l.value&&h.push([l.key,l.value]),l.mid&&this._dfsEntries(l.mid,h),l.right&&this._dfsEntries(l.right,h))}_isBalanced(){const l=h=>{if(!h)return!0;const d=h.balanceFactor();return d<-1||d>1?!1:l(h.left)&&l(h.right)};return l(this._root)}}e.TernarySearchTree=f}),define(he[6],fe([0,1,13,27,5,3]),function(ie,e,a,t,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=d,e.uriToFsPath=s,D=De(D);const W=/^\w[\w\d+.-]*$/,P=/^\//,g=/^\/\//;function r(S,L){if(!S.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${S.authority}", path: "${S.path}", query: "${S.query}", fragment: "${S.fragment}"}`);if(S.scheme&&!W.test(S.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(S.path){if(S.authority){if(!P.test(S.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(g.test(S.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(S,L){return!S&&!L?"file":S}function p(S,L){switch(S){case"https":case"http":case"file":L?L[0]!==c&&(L=c+L):L=c;break}return L}const f="",c="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(L){return L instanceof h?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,k,O,x,R,E=!1){typeof L=="object"?(this.scheme=L.scheme||f,this.authority=L.authority||f,this.path=L.path||f,this.query=L.query||f,this.fragment=L.fragment||f):(this.scheme=w(L,E),this.authority=k||f,this.path=p(this.scheme,O||f),this.query=x||f,this.fragment=R||f,r(this,E))}get fsPath(){return s(this,!1)}with(L){if(!L)return this;let{scheme:k,authority:O,path:x,query:R,fragment:E}=L;return k===void 0?k=this.scheme:k===null&&(k=f),O===void 0?O=this.authority:O===null&&(O=f),x===void 0?x=this.path:x===null&&(x=f),R===void 0?R=this.query:R===null&&(R=f),E===void 0?E=this.fragment:E===null&&(E=f),k===this.scheme&&O===this.authority&&x===this.path&&R===this.query&&E===this.fragment?this:new n(k,O,x,R,E)}static parse(L,k=!1){const O=l.exec(L);return O?new n(O[2]||f,F(O[4]||f),F(O[5]||f),F(O[7]||f),F(O[9]||f),k):new n(f,f,f,f,f)}static file(L){let k=f;if(y.isWindows&&(L=L.replace(/\\/g,c)),L[0]===c&&L[1]===c){const O=L.indexOf(c,2);O===-1?(k=L.substring(2),L=c):(k=L.substring(2,O),L=L.substring(O)||c)}return new n("file",k,L,f,f)}static from(L,k){return new n(L.scheme,L.authority,L.path,L.query,L.fragment,k)}static joinPath(L,...k){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let O;return y.isWindows&&L.scheme==="file"?O=h.file(D.win32.join(s(L,!0),...k)).path:O=D.posix.join(L.path,...k),L.with({path:O})}toString(L=!1){return i(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof h)return L;{const k=new n(L);return k._formatted=L.external??null,k._fsPath=L._sep===u?L.fsPath??null:null,k}}else return L}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=h;function d(S){return!S||typeof S!="object"?!1:typeof S.scheme=="string"&&(typeof S.authority=="string"||typeof S.authority>"u")&&(typeof S.path=="string"||typeof S.path>"u")&&(typeof S.query=="string"||typeof S.query>"u")&&(typeof S.fragment=="string"||typeof S.fragment>"u")}const u=y.isWindows?1:void 0;class n extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(L=!1){return L?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const L={$mid:t.MarshalledId.Uri};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=u),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const v={[a.CharCode.Colon]:"%3A",[a.CharCode.Slash]:"%2F",[a.CharCode.QuestionMark]:"%3F",[a.CharCode.Hash]:"%23",[a.CharCode.OpenSquareBracket]:"%5B",[a.CharCode.CloseSquareBracket]:"%5D",[a.CharCode.AtSign]:"%40",[a.CharCode.ExclamationMark]:"%21",[a.CharCode.DollarSign]:"%24",[a.CharCode.Ampersand]:"%26",[a.CharCode.SingleQuote]:"%27",[a.CharCode.OpenParen]:"%28",[a.CharCode.CloseParen]:"%29",[a.CharCode.Asterisk]:"%2A",[a.CharCode.Plus]:"%2B",[a.CharCode.Comma]:"%2C",[a.CharCode.Semicolon]:"%3B",[a.CharCode.Equals]:"%3D",[a.CharCode.Space]:"%20"};function b(S,L,k){let O,x=-1;for(let R=0;R<S.length;R++){const E=S.charCodeAt(R);if(E>=a.CharCode.a&&E<=a.CharCode.z||E>=a.CharCode.A&&E<=a.CharCode.Z||E>=a.CharCode.Digit0&&E<=a.CharCode.Digit9||E===a.CharCode.Dash||E===a.CharCode.Period||E===a.CharCode.Underline||E===a.CharCode.Tilde||L&&E===a.CharCode.Slash||k&&E===a.CharCode.OpenSquareBracket||k&&E===a.CharCode.CloseSquareBracket||k&&E===a.CharCode.Colon)x!==-1&&(O+=encodeURIComponent(S.substring(x,R)),x=-1),O!==void 0&&(O+=S.charAt(R));else{O===void 0&&(O=S.substr(0,R));const U=v[E];U!==void 0?(x!==-1&&(O+=encodeURIComponent(S.substring(x,R)),x=-1),O+=U):x===-1&&(x=R)}}return x!==-1&&(O+=encodeURIComponent(S.substring(x))),O!==void 0?O:S}function o(S){let L;for(let k=0;k<S.length;k++){const O=S.charCodeAt(k);O===a.CharCode.Hash||O===a.CharCode.QuestionMark?(L===void 0&&(L=S.substr(0,k)),L+=v[O]):L!==void 0&&(L+=S[k])}return L!==void 0?L:S}function s(S,L){let k;return S.authority&&S.path.length>1&&S.scheme==="file"?k=`//${S.authority}${S.path}`:S.path.charCodeAt(0)===a.CharCode.Slash&&(S.path.charCodeAt(1)>=a.CharCode.A&&S.path.charCodeAt(1)<=a.CharCode.Z||S.path.charCodeAt(1)>=a.CharCode.a&&S.path.charCodeAt(1)<=a.CharCode.z)&&S.path.charCodeAt(2)===a.CharCode.Colon?L?k=S.path.substr(1):k=S.path[1].toLowerCase()+S.path.substr(2):k=S.path,y.isWindows&&(k=k.replace(/\//g,"\\")),k}function i(S,L){const k=L?o:b;let O="",{scheme:x,authority:R,path:E,query:U,fragment:I}=S;if(x&&(O+=x,O+=":"),(R||x==="file")&&(O+=c,O+=c),R){let C=R.indexOf("@");if(C!==-1){const B=R.substr(0,C);R=R.substr(C+1),C=B.lastIndexOf(":"),C===-1?O+=k(B,!1,!1):(O+=k(B.substr(0,C),!1,!1),O+=":",O+=k(B.substr(C+1),!1,!0)),O+="@"}R=R.toLowerCase(),C=R.lastIndexOf(":"),C===-1?O+=k(R,!1,!0):(O+=k(R.substr(0,C),!1,!0),O+=R.substr(C))}if(E){if(E.length>=3&&E.charCodeAt(0)===a.CharCode.Slash&&E.charCodeAt(2)===a.CharCode.Colon){const C=E.charCodeAt(1);C>=a.CharCode.A&&C<=a.CharCode.Z&&(E=`/${String.fromCharCode(C+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===a.CharCode.Colon){const C=E.charCodeAt(0);C>=a.CharCode.A&&C<=a.CharCode.Z&&(E=`${String.fromCharCode(C+32)}:${E.substr(2)}`)}O+=k(E,!0,!1)}return U&&(O+="?",O+=k(U,!1,!1)),I&&(O+="#",O+=L?I:b(I,!1,!1)),O}function _(S){try{return decodeURIComponent(S)}catch{return S.length>3?S.substr(0,3)+_(S.substr(3)):S}}const A=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function F(S){return S.match(A)?S.replace(A,L=>_(L)):S}}),define(he[56],fe([0,1,6]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=t,e.parse=D,e.getFirstFrame=y,e.log=P;function t(r){const w=r;return w&&typeof w.type=="string"&&typeof w.severity=="string"}function D(r){const w=[];let p;try{const f=JSON.parse(r.arguments),c=f[f.length-1];c&&c.__$stack&&(f.pop(),p=c.__$stack),w.push(...f)}catch{w.push("Unable to log remote console arguments",r.arguments)}return{args:w,stack:p}}function y(r){if(typeof r!="string")return y(D(r).stack);const w=r;if(w){const p=W(w),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(f&&f.length===4)return{uri:a.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function W(r){if(!r)return r;const w=r.indexOf(`
`);return w===-1?r:r.substring(0,w)}function P(r,w){const{args:p,stack:f}=D(r),c=typeof p[0]=="string"&&p.length===1;let l=W(f);l&&(l=`(${l.trim()})`);let h=[];if(typeof p[0]=="string"?l&&c?h=[`%c[${w}] %c${p[0]} %c${l}`,g("blue"),g(""),g("grey")]:h=[`%c[${w}] %c${p[0]}`,g("blue"),g(""),...p.slice(1)]:h=[`%c[${w}]%`,g("blue"),...p],l&&!c&&h.push(l),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,h)}function g(r){return`color: ${r}`}}),define(he[57],fe([0,1,19,6,27]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=y,e.parse=W,e.revive=g;function y(r){return JSON.stringify(r,P)}function W(r){let w=JSON.parse(r);return w=g(w),w}function P(r,w){return w instanceof RegExp?{$mid:D.MarshalledId.Regexp,source:w.source,flags:w.flags}:w}function g(r,w=0){if(!r||w>200)return r;if(typeof r=="object"){switch(r.$mid){case D.MarshalledId.Uri:return t.URI.revive(r);case D.MarshalledId.Regexp:return new RegExp(r.source,r.flags);case D.MarshalledId.Date:return new Date(r.source)}if(r instanceof a.VSBuffer||r instanceof Uint8Array)return r;if(Array.isArray(r))for(let p=0;p<r.length;++p)r[p]=g(r[p],w+1);else for(const p in r)Object.hasOwnProperty.call(r,p)&&(r[p]=g(r[p],w+1))}return r}}),define(he[20],fe([0,1,7,3,10,6,5]),function(ie,e,a,t,D,y,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=g,e.matchesSomeScheme=r,e.getServerRootPath=p,a=De(a),t=De(t),W=De(W);var P;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(P||(e.Schemas=P={}));function g(l,h){return y.URI.isUri(l)?(0,D.equalsIgnoreCase)(l.scheme,h):(0,D.startsWithIgnoreCase)(l,h+":")}function r(l,...h){return h.some(d=>g(l,d))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class w{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h,d){this._serverRootPath=p(h,d)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return W.posix.join(this._serverRootPath,P.vscodeRemoteResource)}set(h,d,u){this._hosts[h]=d,this._ports[h]=u}setConnectionToken(h,d){this._connectionTokens[h]=d}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)try{return this._delegate(h)}catch(o){return a.onUnexpectedError(o),h}const d=h.authority;let u=this._hosts[d];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const n=this._ports[d],v=this._connectionTokens[d];let b=`path=${encodeURIComponent(h.path)}`;return typeof v=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),y.URI.from({scheme:t.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${u}:${n}`,path:this._remoteResourcesPath,query:b})}}e.RemoteAuthorities=new w;function p(l,h){return W.posix.join(h??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class f{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(h){const d=this.toUri(h,ie);return this.uriToBrowserUri(d)}uriToBrowserUri(h){return h.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(h):h.scheme===P.file&&(t.isNative||t.webWorkerOrigin===`${P.vscodeFileResource}://${f.FALLBACK_AUTHORITY}`)?h.with({scheme:P.vscodeFileResource,authority:h.authority||f.FALLBACK_AUTHORITY,query:null,fragment:null}):h}asFileUri(h){const d=this.toUri(h,ie);return this.uriToFileUri(d)}uriToFileUri(h){return h.scheme===P.vscodeFileResource?h.with({scheme:P.file,authority:h.authority!==f.FALLBACK_AUTHORITY?h.authority:null,query:null,fragment:null}):h}toUri(h,d){return y.URI.isUri(h)?h:y.URI.parse(d.toUrl(h))}}e.FileAccess=new f;var c;(function(l){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(h.get("3"));const d="vscode-coi";function u(v){let b;typeof v=="string"?b=new URL(v).searchParams:v instanceof URL?b=v.searchParams:y.URI.isUri(v)&&(b=new URL(v.toString(!0)).searchParams);const o=b?.get(d);if(o)return h.get(o)}l.getHeadersFromQuery=u;function n(v,b,o){if(!globalThis.crossOriginIsolated)return;const s=b&&o?"3":o?"2":"1";v instanceof URLSearchParams?v.set(d,s):v[d]=s}l.addSearchParam=n})(c||(e.COI=c={}))}),define(he[25],fe([0,1,13,34,20,5,3,10,6]),function(ie,e,a,t,D,y,W,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=r,e.distinctParents=p,e.toLocalResource=c,t=De(t),y=De(y);function r(l){return(0,g.uriToFsPath)(l,!0)}class w{constructor(h){this._ignorePathCasing=h}compare(h,d,u=!1){return h===d?0:(0,P.compare)(this.getComparisonKey(h,u),this.getComparisonKey(d,u))}isEqual(h,d,u=!1){return h===d?!0:!h||!d?!1:this.getComparisonKey(h,u)===this.getComparisonKey(d,u)}getComparisonKey(h,d=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,d,u=!1){if(h.scheme===d.scheme){if(h.scheme===D.Schemas.file)return t.isEqualOrParent(r(h),r(d),this._ignorePathCasing(h))&&h.query===d.query&&(u||h.fragment===d.fragment);if((0,e.isEqualAuthority)(h.authority,d.authority))return t.isEqualOrParent(h.path,d.path,this._ignorePathCasing(h),"/")&&h.query===d.query&&(u||h.fragment===d.fragment)}return!1}joinPath(h,...d){return g.URI.joinPath(h,...d)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let d;return h.scheme===D.Schemas.file?d=g.URI.file(y.dirname(r(h))).path:(d=y.posix.dirname(h.path),h.authority&&d.length&&d.charCodeAt(0)!==a.CharCode.Slash&&(console.error(`dirname("${h.toString})) resulted in a relative path`),d="/")),h.with({path:d})}normalizePath(h){if(!h.path.length)return h;let d;return h.scheme===D.Schemas.file?d=g.URI.file(y.normalize(r(h))).path:d=y.posix.normalize(h.path),h.with({path:d})}relativePath(h,d){if(h.scheme!==d.scheme||!(0,e.isEqualAuthority)(h.authority,d.authority))return;if(h.scheme===D.Schemas.file){const v=y.relative(r(h),r(d));return W.isWindows?t.toSlashes(v):v}let u=h.path||"/";const n=d.path||"/";if(this._ignorePathCasing(h)){let v=0;for(const b=Math.min(u.length,n.length);v<b&&!(u.charCodeAt(v)!==n.charCodeAt(v)&&u.charAt(v).toLowerCase()!==n.charAt(v).toLowerCase());v++);u=n.substr(0,v)+u.substr(v)}return y.posix.relative(u,n)}resolvePath(h,d){if(h.scheme===D.Schemas.file){const u=g.URI.file(y.resolve(r(h),d));return h.with({authority:u.authority,path:u.path})}return d=t.toPosixPath(d),h.with({path:y.posix.resolve(h.path,d)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,d){return h===d||h!==void 0&&d!==void 0&&(0,P.equalsIgnoreCase)(h,d)}hasTrailingPathSeparator(h,d=y.sep){if(h.scheme===D.Schemas.file){const u=r(h);return u.length>t.getRoot(u).length&&u[u.length-1]===d}else{const u=h.path;return u.length>1&&u.charCodeAt(u.length-1)===a.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,d=y.sep){return(0,e.hasTrailingPathSeparator)(h,d)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,d=y.sep){let u=!1;if(h.scheme===D.Schemas.file){const n=r(h);u=n!==void 0&&n.length===t.getRoot(n).length&&n[n.length-1]===d}else{d="/";const n=h.path;u=n.length===1&&n.charCodeAt(n.length-1)===a.CharCode.Slash}return!u&&!(0,e.hasTrailingPathSeparator)(h,d)?h.with({path:h.path+"/"}):h}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(l=>l.scheme===D.Schemas.file?!W.isLinux:!0),e.extUriIgnorePathCase=new w(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function p(l,h){const d=[];for(let u=0;u<l.length;u++){const n=h(l[u]);l.some((v,b)=>b===u?!1:(0,e.isEqualOrParent)(n,h(v)))||d.push(l[u])}return d}var f;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function h(d){const u=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(b=>{const[o,s]=b.split(":");o&&s&&u.set(o,s)});const v=d.path.substring(0,d.path.indexOf(";"));return v&&u.set(l.META_DATA_MIME,v),u}l.parseMetaData=h})(f||(e.DataUri=f={}));function c(l,h,d){if(h){let u=l.path;return u&&u[0]!==y.posix.sep&&(u=y.posix.sep+u),l.with({scheme:d,authority:h,path:u})}return l.with({scheme:d})}}),define(he[11],fe([0,1,18,7,4,2,25,3,52,24]),function(ie,e,a,t,D,y,W,P,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=w,e.createCancelablePromise=p,e.raceCancellation=f,e.raceCancellationError=c,e.raceCancellablePromises=l,e.raceTimeout=h,e.asPromise=d,e.promiseWithResolvers=u,e.timeout=S,e.disposableTimeout=L,e.sequence=k,e.first=O,e.firstParallel=x,e.retry=z,e.createCancelableAsyncIterable=N;function w(M){return!!M&&typeof M.then=="function"}function p(M){const T=new a.CancellationTokenSource,H=M(T.token),J=new Promise((ne,pe)=>{const we=T.token.onCancellationRequested(()=>{we.dispose(),pe(new t.CancellationError)});Promise.resolve(H).then(Ie=>{we.dispose(),T.dispose(),ne(Ie)},Ie=>{we.dispose(),T.dispose(),pe(Ie)})});return new class{cancel(){T.cancel(),T.dispose()}then(ne,pe){return J.then(ne,pe)}catch(ne){return this.then(void 0,ne)}finally(ne){return J.finally(ne)}}}function f(M,T,H){return new Promise((J,ne)=>{const pe=T.onCancellationRequested(()=>{pe.dispose(),J(H)});M.then(J,ne).finally(()=>pe.dispose())})}function c(M,T){return new Promise((H,J)=>{const ne=T.onCancellationRequested(()=>{ne.dispose(),J(new t.CancellationError)});M.then(H,J).finally(()=>ne.dispose())})}async function l(M){let T=-1;const H=M.map((J,ne)=>J.then(pe=>(T=ne,pe)));try{return await Promise.race(H)}finally{M.forEach((J,ne)=>{ne!==T&&J.cancel()})}}function h(M,T,H){let J;const ne=setTimeout(()=>{J?.(void 0),H?.()},T);return Promise.race([M.finally(()=>clearTimeout(ne)),new Promise(pe=>J=pe)])}function d(M){return new Promise((T,H)=>{const J=M();w(J)?J.then(T,H):T(J)})}function u(){let M,T;return{promise:new Promise((J,ne)=>{M=J,T=ne}),resolve:M,reject:T}}class n{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const H=()=>{if(this.queuedPromise=null,this.isDisposed)return;const J=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,J};this.queuedPromise=new Promise(J=>{this.activePromise.then(H,H).then(J)})}return new Promise((H,J)=>{this.queuedPromise.then(H,J)})}return this.activePromise=T(),new Promise((H,J)=>{this.activePromise.then(ne=>{this.activePromise=null,H(ne)},ne=>{this.activePromise=null,J(ne)})})}dispose(){this.isDisposed=!0}}e.Throttler=n;class v{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=v;class b{constructor(){this.promiseMap=new Map}queue(T,H){const ne=(this.promiseMap.get(T)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(T)===ne&&this.promiseMap.delete(T)});return this.promiseMap.set(T,ne),ne}}e.SequencerByKey=b;const o=(M,T)=>{let H=!0;const J=setTimeout(()=>{H=!1,T()},M);return{isTriggered:()=>H,dispose:()=>{clearTimeout(J),H=!1}}},s=M=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,M())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class i{constructor(T){this.defaultDelay=T,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,H=this.defaultDelay){this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ne,pe)=>{this.doResolve=ne,this.doReject=pe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ne=this.task;return this.task=null,ne()}}));const J=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=H===g.MicrotaskDelay?s(J):o(H,J),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class _{constructor(T){this.delayer=new i(T),this.throttler=new n}trigger(T,H){return this.delayer.trigger(()=>this.throttler.queue(T),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=_;class A{constructor(){this._isOpen=!1,this._promise=new Promise((T,H)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=A;class F extends A{constructor(T){super(),this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=F;function S(M,T){return T?new Promise((H,J)=>{const ne=setTimeout(()=>{pe.dispose(),H()},M),pe=T.onCancellationRequested(()=>{clearTimeout(ne),pe.dispose(),J(new t.CancellationError)})}):p(H=>S(M,H))}function L(M,T=0,H){const J=setTimeout(()=>{M(),H&&ne.dispose()},T),ne=(0,y.toDisposable)(()=>{clearTimeout(J),H?.deleteAndLeak(ne)});return H?.add(ne),ne}function k(M){const T=[];let H=0;const J=M.length;function ne(){return H<J?M[H++]():null}function pe(we){we!=null&&T.push(we);const Ie=ne();return Ie?Ie.then(pe):Promise.resolve(T)}return Promise.resolve(null).then(pe)}function O(M,T=J=>!!J,H=null){let J=0;const ne=M.length,pe=()=>{if(J>=ne)return Promise.resolve(H);const we=M[J++];return Promise.resolve(we()).then(ge=>T(ge)?Promise.resolve(ge):pe())};return pe()}function x(M,T=J=>!!J,H=null){if(M.length===0)return Promise.resolve(H);let J=M.length;const ne=()=>{J=-1;for(const pe of M)pe.cancel?.()};return new Promise((pe,we)=>{for(const Ie of M)Ie.then(ge=>{--J>=0&&T(ge)?(ne(),pe(ge)):J===0&&pe(H)}).catch(ge=>{--J>=0&&(ne(),we(ge))})})}class R{constructor(T){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}whenIdle(){return this.size>0?D.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(T){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((H,J)=>{this.outstandingPromises.push({factory:T,c:H,e:J}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const H=T.factory();H.then(T.c,T.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=R;class E extends R{constructor(){super(1)}}e.Queue=E;class U{constructor(){this.sequentializer=new Q,this.tasks=0}queue(T){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,T())):this.sequentializer.run(this.tasks++,T())}}e.LimitedQueue=U;class I{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const T=new $;return this.drainers.add(T),T.p}isDrained(){for(const[,T]of this.queues)if(T.size>0)return!1;return!0}queueSize(T,H=W.extUri){const J=H.getComparisonKey(T);return this.queues.get(J)?.size??0}queueFor(T,H,J=W.extUri){const ne=J.getComparisonKey(T);let pe=this.queues.get(ne);if(!pe){pe=new E;const we=this.drainListenerCount++,Ie=D.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.queues.delete(ne),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(we),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new y.DisposableMap),this.drainListeners.set(we,Ie),this.queues.set(ne,pe)}return pe.queue(H)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const T of this.drainers)T.complete();this.drainers.clear()}dispose(){for(const[,T]of this.queues)T.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=I;class C{constructor(T,H){this._isDisposed=!1,this._token=-1,typeof T=="function"&&typeof H=="number"&&this.setIfNotSet(T,H)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,H){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},H)}setIfNotSet(T,H){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},H))}}e.TimeoutTimer=C;class B{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(T,H,J=globalThis){if(this.isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ne=J.setInterval(()=>{T()},H);this.disposable=(0,y.toDisposable)(()=>{J.clearInterval(ne),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=B;class Y{constructor(T,H){this.timeoutToken=-1,this.runner=T,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Y;class G{constructor(T,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=T,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(T=this.timeout){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(T/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=G;class Z extends Y{constructor(T,H){super(T,H),this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner?.(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Z;class se extends y.Disposable{constructor(T,H){super(),this.options=T,this.handler=H,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(T){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+T.length>this.options.maxBufferedWork)return!1}else if(this.pending+T.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const H of T)this.pendingWork.push(H);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Y(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(M,T)=>{(0,P.setTimeout0)(()=>{if(H)return;const J=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,J-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e._runWhenIdle=(M,T,H)=>{const J=M.requestIdleCallback(T,typeof H=="number"?{timeout:H}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,M.cancelIdleCallback(J))}}},e.runWhenGlobalIdle=M=>(0,e._runWhenIdle)(globalThis,M)}();class le{constructor(T,H){this._didRun=!1,this._executor=()=>{try{this._value=H()}catch(J){this._error=J}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(T,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=le;class V extends le{constructor(T){super(globalThis,T)}}e.GlobalIdleValue=V;async function z(M,T,H){let J;for(let ne=0;ne<H;ne++)try{return await M()}catch(pe){J=pe,await S(T)}throw J}class Q{isRunning(T){return typeof T=="number"?this._running?.taskId===T:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(T,H,J){return this._running={taskId:T,cancel:()=>J?.(),promise:H},H.then(()=>this.doneRunning(T),()=>this.doneRunning(T)),H}doneRunning(T){this._running&&T===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const T=this._queued;this._queued=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this._queued)this._queued.run=T;else{const{promise:H,resolve:J,reject:ne}=u();this._queued={run:T,promise:H,promiseResolve:J,promiseReject:ne}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Q;class ee{constructor(T,H=()=>Date.now()){this.interval=T,this.nowFn=H,this.lastIncrementTime=0,this.value=0}increment(){const T=this.nowFn();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;var ue;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ue||(ue={}));class ${get isRejected(){return this.outcome?.outcome===ue.Rejected}get isResolved(){return this.outcome?.outcome===ue.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ue.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((T,H)=>{this.completeCallback=T,this.errorCallback=H})}complete(T){return new Promise(H=>{this.completeCallback(T),this.outcome={outcome:ue.Resolved,value:T},H()})}error(T){return new Promise(H=>{this.errorCallback(T),this.outcome={outcome:ue.Rejected,value:T},H()})}cancel(){return this.error(new t.CancellationError)}}e.DeferredPromise=$;var ae;(function(M){async function T(J){let ne;const pe=await Promise.all(J.map(we=>we.then(Ie=>Ie,Ie=>{ne||(ne=Ie)})));if(typeof ne<"u")throw ne;return pe}M.settled=T;function H(J){return new Promise(async(ne,pe)=>{try{await J(ne,pe)}catch(we){pe(we)}})}M.withAsyncBody=H})(ae||(e.Promises=ae={}));class me{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(T){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=T.then(H=>(this._value=H,this._isResolved=!0,H),H=>{throw this._error=H,this._isResolved=!0,H})}requireValue(){if(!this._isResolved)throw new t.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=me;class te{constructor(T){this._compute=T,this._promise=new r.Lazy(()=>new me(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=te;var m;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(m||(m={}));class j{static fromArray(T){return new j(H=>{H.emitMany(T)})}static fromPromise(T){return new j(async H=>{H.emitMany(await T)})}static fromPromises(T){return new j(async H=>{await Promise.all(T.map(async J=>H.emitOne(await J)))})}static merge(T){return new j(async H=>{await Promise.all(T.map(async J=>{for await(const ne of J)H.emitOne(ne)}))})}static{this.EMPTY=j.fromArray([])}constructor(T,H){this._state=m.Initial,this._results=[],this._error=null,this._onReturn=H,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const J={emitOne:ne=>this.emitOne(ne),emitMany:ne=>this.emitMany(ne),reject:ne=>this.reject(ne)};try{await Promise.resolve(T(J)),this.resolve()}catch(ne){this.reject(ne)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this._state===m.DoneError)throw this._error;if(T<this._results.length)return{done:!1,value:this._results[T++]};if(this._state===m.DoneOK)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(T,H){return new j(async J=>{for await(const ne of T)J.emitOne(H(ne))})}map(T){return j.map(this,T)}static filter(T,H){return new j(async J=>{for await(const ne of T)H(ne)&&J.emitOne(ne)})}filter(T){return j.filter(this,T)}static coalesce(T){return j.filter(T,H=>!!H)}coalesce(){return j.coalesce(this)}static async toPromise(T){const H=[];for await(const J of T)H.push(J);return H}toPromise(){return j.toPromise(this)}emitOne(T){this._state===m.Initial&&(this._results.push(T),this._onStateChanged.fire())}emitMany(T){this._state===m.Initial&&(this._results=this._results.concat(T),this._onStateChanged.fire())}resolve(){this._state===m.Initial&&(this._state=m.DoneOK,this._onStateChanged.fire())}reject(T){this._state===m.Initial&&(this._state=m.DoneError,this._error=T,this._onStateChanged.fire())}}e.AsyncIterableObject=j;class oe extends j{constructor(T,H){super(H),this._source=T}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function N(M){const T=new a.CancellationTokenSource,H=M(T.token);return new oe(T,async J=>{const ne=T.token.onCancellationRequested(()=>{ne.dispose(),T.dispose(),J.reject(new t.CancellationError)});try{for await(const pe of H){if(T.token.isCancellationRequested)return;J.emitOne(pe)}ne.dispose(),T.dispose()}catch(pe){ne.dispose(),T.dispose(),J.reject(pe)}})}class K{constructor(T){this._deferred=new $,this._asyncIterable=new j(ne=>{if(H){ne.reject(H);return}return J&&ne.emitMany(J),this._errorFn=pe=>ne.reject(pe),this._emitFn=pe=>ne.emitOne(pe),this._deferred.p},T);let H,J;this._emitFn=ne=>{J||(J=[]),J.push(ne)},this._errorFn=ne=>{H||(H=ne)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(T){this._errorFn(T),this._deferred.complete()}emitOne(T){this._emitFn(T)}}e.AsyncIterableSource=K}),define(he[58],fe([0,1,19,27,6]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=g,e.transformIncomingURIs=w,e.transformAndReviveIncomingURIs=p;function y(f){return f.toJSON()}class W{constructor(c){this._uriTransformer=c}transformIncoming(c){const l=this._uriTransformer.transformIncoming(c);return l===c?c:y(D.URI.from(l))}transformOutgoing(c){const l=this._uriTransformer.transformOutgoing(c);return l===c?c:y(D.URI.from(l))}transformOutgoingURI(c){const l=this._uriTransformer.transformOutgoing(c);return l===c?c:D.URI.from(l)}transformOutgoingScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}}e.URITransformer=W,e.DefaultURITransformer=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function P(f,c,l){if(!f||l>200)return null;if(typeof f=="object"){if(f instanceof D.URI)return c.transformOutgoing(f);for(const h in f)if(Object.hasOwnProperty.call(f,h)){const d=P(f[h],c,l+1);d!==null&&(f[h]=d)}}return null}function g(f,c){const l=P(f,c,0);return l===null?f:l}function r(f,c,l,h){if(!f||h>200)return null;if(typeof f=="object"){if(f.$mid===t.MarshalledId.Uri)return l?D.URI.revive(c.transformIncoming(f)):c.transformIncoming(f);if(f instanceof a.VSBuffer)return null;for(const d in f)if(Object.hasOwnProperty.call(f,d)){const u=r(f[d],c,l,h+1);u!==null&&(f[d]=u)}}return null}function w(f,c){const l=r(f,c,!1,0);return l===null?f:l}function p(f,c){const l=r(f,c,!0,0);return l===null?f:l}}),define(he[59],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=t;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return a.test(D)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let g=0;g<P.length;g++)P[g]=Math.floor(Math.random()*256);return P};const y=new Uint8Array(16),W=[];for(let P=0;P<256;P++)W.push(P.toString(16).padStart(2,"0"));return function(){D(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let g=0,r="";return r+=W[y[g++]],r+=W[y[g++]],r+=W[y[g++]],r+=W[y[g++]],r+="-",r+=W[y[g++]],r+=W[y[g++]],r+="-",r+=W[y[g++]],r+=W[y[g++]],r+="-",r+=W[y[g++]],r+=W[y[g++]],r+="-",r+=W[y[g++]],r+=W[y[g++]],r+=W[y[g++]],r+=W[y[g++]],r+=W[y[g++]],r+=W[y[g++]],r}}()}),define(he[28],fe([0,1,35,21,100,11,34,48,5,3,25,6]),function(ie,e,a,t,D,y,W,P,g,r,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=v,e.whenDeleted=s,e.configureFlushOnWrite=S,e.writeFileSync=k,a=De(a);var f;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function c(G,Z=f.UNLINK,se){if((0,W.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");return Z===f.UNLINK?h(G):l(G,se)}async function l(G,Z=(0,W.randomPath)((0,t.tmpdir)())){try{try{await a.promises.rename(G,Z)}catch(se){return se.code==="ENOENT"?void 0:h(G)}h(Z).catch(se=>{})}catch(se){if(se.code!=="ENOENT")throw se}}async function h(G){return a.promises.rm(G,{recursive:!0,force:!0,maxRetries:3})}function d(G){if((0,W.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function u(G,Z){return b(await(Z?n(G):a.promises.readdir(G)))}async function n(G){try{return await a.promises.readdir(G,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const Z=[],se=await u(G);for(const le of se){let V=!1,z=!1,Q=!1;try{const ee=await a.promises.lstat((0,g.join)(G,le));V=ee.isFile(),z=ee.isDirectory(),Q=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Z.push({name:le,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>Q})}return Z}function v(G){return b(a.readdirSync(G))}function b(G){return G.map(Z=>typeof Z=="string"?r.isMacintosh?(0,P.normalizeNFC)(Z):Z:(Z.name=r.isMacintosh?(0,P.normalizeNFC)(Z.name):Z.name,Z))}async function o(G){const Z=await u(G),se=[];for(const le of Z)await i.existsDirectory((0,g.join)(G,le))&&se.push(le);return se}function s(G,Z=1e3){return new Promise(se=>{let le=!1;const V=setInterval(()=>{le||(le=!0,a.access(G,z=>{le=!1,z&&(clearInterval(V),se(void 0))}))},Z)})}var i;(function(G){async function Z(V){let z;try{if(z=await a.promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await a.promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(r.isWindows&&Q.code==="EACCES")try{return{stat:await a.promises.stat(await a.promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ee}throw Q}}G.stat=Z;async function se(V){try{const{stat:z,symbolicLink:Q}=await G.stat(V);return z.isFile()&&Q?.dangling!==!0}catch{}return!1}G.existsFile=se;async function le(V){try{const{stat:z,symbolicLink:Q}=await G.stat(V);return z.isDirectory()&&Q?.dangling!==!0}catch{}return!1}G.existsDirectory=le})(i||(e.SymlinkSupport=i={}));const _=new y.ResourceQueue;function A(G,Z,se){return _.queueFor(p.URI.file(G),()=>{const le=O(se);return new Promise((V,z)=>L(G,Z,le,Q=>Q?z(Q):V()))},w.extUriBiasedIgnorePathCase)}let F=!0;function S(G){F=G}function L(G,Z,se,le){if(!F)return a.writeFile(G,Z,{mode:se.mode,flag:se.flag},le);a.open(G,se.flag,se.mode,(V,z)=>{if(V)return le(V);a.writeFile(z,Z,Q=>{if(Q)return a.close(z,()=>le(Q));a.fdatasync(z,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),S(!1)),a.close(z,ue=>le(ue))))})})}function k(G,Z,se){const le=O(se);if(!F)return a.writeFileSync(G,Z,{mode:le.mode,flag:le.flag});const V=a.openSync(G,le.flag,le.mode);try{a.writeFileSync(V,Z);try{a.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),S(!1)}}finally{a.closeSync(V)}}function O(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function x(G,Z,se=6e4){if(G!==Z)try{r.isWindows&&typeof se=="number"?await R(G,Z,Date.now(),se):await a.promises.rename(G,Z)}catch(le){if(G.toLowerCase()!==Z.toLowerCase()&&le.code==="EXDEV"||G.endsWith("."))await E(G,Z,{preserveSymlinks:!1}),await c(G,f.MOVE);else throw le}}async function R(G,Z,se,le,V=0){try{return await a.promises.rename(G,Z)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-se>=le)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let Q=!1;try{const{stat:ee}=await i.stat(Z);ee.isFile()||(Q=!0)}catch{}if(Q)throw z}return await(0,y.timeout)(Math.min(100,V*10)),R(G,Z,se,le,V+1)}}async function E(G,Z,se){return I(G,Z,{root:{source:G,target:Z},options:se,handledSourcePaths:new Set})}const U=511;async function I(G,Z,se){if(se.handledSourcePaths.has(G))return;se.handledSourcePaths.add(G);const{stat:le,symbolicLink:V}=await i.stat(G);if(V){if(se.options.preserveSymlinks)try{return await Y(G,Z,se)}catch{}if(V.dangling)return}return le.isDirectory()?C(G,Z,le.mode&U,se):B(G,Z,le.mode&U)}async function C(G,Z,se,le){await a.promises.mkdir(Z,{recursive:!0,mode:se});const V=await u(G);for(const z of V)await I((0,g.join)(G,z),(0,g.join)(Z,z),le)}async function B(G,Z,se){await a.promises.copyFile(G,Z),await a.promises.chmod(Z,se)}async function Y(G,Z,se){let le=await a.promises.readlink(G);(0,W.isEqualOrParent)(le,se.root.source,!r.isLinux)&&(le=(0,g.join)(se.root.target,le.substr(se.root.source.length+1))),await a.promises.symlink(le,Z)}e.Promises=new class{get read(){return(G,Z,se,le,V)=>new Promise((z,Q)=>{a.read(G,Z,se,le,V,(ee,ue,$)=>ee?Q(ee):z({bytesRead:ue,buffer:$}))})}get write(){return(G,Z,se,le,V)=>new Promise((z,Q)=>{a.write(G,Z,se,le,V,(ee,ue,$)=>ee?Q(ee):z({bytesWritten:ue,buffer:$}))})}get fdatasync(){return(0,D.promisify)(a.fdatasync)}get open(){return(0,D.promisify)(a.open)}get close(){return(0,D.promisify)(a.close)}get realpath(){return(0,D.promisify)(a.realpath)}async exists(G){try{return await a.promises.access(G),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return o}get writeFile(){return A}get rm(){return c}get rename(){return x}get copy(){return E}}}),define(he[60],fe([0,1,21,5,28]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=n,e.getFirstAvailablePowerShellInstallation=v,a=De(a),t=De(t),D=De(D);const y=/^\d+$/,W=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var g;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(g||(g={}));let r;switch(process.arch){case"ia32":r=g.x86;break;case"arm":case"arm64":r=g.ARM;break;default:r=g.x64;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?g.ARM:g.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=g.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=g.x86:w=g.x64;class p{constructor(o,s,i){this.exePath=o,this.displayName=s,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:b=!1}={}){return b?r===g.x64?process.env["ProgramFiles(x86)"]||null:w===g.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function c({useAlternateBitness:b=!1,findPreview:o=!1}={}){const s=f({useAlternateBitness:b});if(!s)return null;const i=t.join(s,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(i))return null;let _=-1,A=null;for(const L of await D.Promises.readdir(i)){let k=-1;if(o){const x=L.indexOf("-");if(x<0)continue;const R=L.substring(0,x);if(!y.test(R)||L.substring(x+1)!=="preview")continue;k=parseInt(R,10)}else{if(!y.test(L))continue;k=parseInt(L,10)}if(k<=_)continue;const O=t.join(i,L,"pwsh.exe");await D.SymlinkSupport.existsFile(O)&&(A=O,_=k)}if(!A)return null;const F=s.includes("x86")?" (x86)":"",S=o?" Preview":"";return new p(A,`PowerShell${S}${F}`,!0)}async function l({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const o=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:s,pwshMsixName:i}=b?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:W,pwshMsixName:"PowerShell (Store)"};for(const _ of await D.Promises.readdir(o))if(s.test(_)){const A=t.join(o,_,"pwsh.exe");return new p(A,i)}return null}function h(){const b=t.join(a.homedir(),".dotnet","tools","pwsh.exe");return new p(b,".NET Core PowerShell Global Tool")}function d(){const b=t.join(process.env.windir,r===g.x86&&w!==g.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(b,"Windows PowerShell",!0)}async function*u(){let b=await c();b&&(yield b),b=await c({useAlternateBitness:!0}),b&&(yield b),b=await l(),b&&(yield b),b=h(),b&&(yield b),b=await c({findPreview:!0}),b&&(yield b),b=await l({findPreview:!0}),b&&(yield b),b=await c({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=d(),b&&(yield b)}async function*n(){for await(const b of u())await b.exists()&&(yield b)}async function v(){for await(const b of n())return b;return null}}),define(he[36],fe([0,1,35,5,3,15,32,9,28]),function(ie,e,a,t,D,y,W,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=r,e.createQueuedSender=w,t=De(t),D=De(D),y=De(y),P=De(P),g=De(g),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return W.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return W.TerminateResponseCode}});function r(f=y.env){return f.comspec||"cmd.exe"}function w(f){let c=[],l=!1;const h=function(d){if(l){c.push(d);return}(!f.send(d,n=>{if(n&&console.error(n),l=!1,c.length>0){const v=c.slice(0);c=[],v.forEach(b=>h(b))}})||D.isWindows)&&(l=!0)};return{send:h}}var p;(function(f){async function c(l,h,d){if(t.isAbsolute(l))return l;if(h===void 0&&(h=y.cwd()),t.dirname(l)!=="."||(d===void 0&&P.isString(y.env.PATH)&&(d=y.env.PATH.split(t.delimiter)),d===void 0||d.length===0))return t.join(h,l);async function n(v){if(await g.Promises.exists(v)){let b;try{b=await a.promises.stat(v)}catch(o){o.message.startsWith("EACCES")&&(b=await a.promises.lstat(v))}return b?!b.isDirectory():!1}return!1}for(const v of d){let b;if(t.isAbsolute(v)?b=t.join(v,l):b=t.join(h,v,l),await n(b))return b;let o=b+".com";if(await n(o)||(o=b+".exe",await n(o)))return o}return t.join(h,l)}f.findExecutable=c})(p||(e.win32=p={}))}),define(he[61],fe([0,1,29,20]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=D;function D(W){return new Promise((P,g)=>{let r;const w=new Map;function p(c,l,h,d,u){const n=w.get(l);if(c===W||n){const v={name:f(h),cmd:h,pid:c,ppid:l,load:d,mem:u};w.set(c,v),c===W&&(r=v),n&&(n.children||(n.children=[]),n.children.push(v),n.children.length>1&&(n.children=n.children.sort((b,o)=>b.pid-o.pid)))}}function f(c){const l=/--utility-sub-type=network/i,h=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,n=/--type=([a-zA-Z-]+)/;if(h.exec(c))return"electron-crash-reporter";if(d.exec(c))return"winpty-agent";if(u.exec(c))return"conpty-agent";let v=n.exec(c);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?l.exec(c)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const b=/[a-zA-Z-]+\.js/g;let o="";do v=b.exec(c),v&&(o+=v+" ");while(v);return o&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${o})`:c}if(process.platform==="win32"){const c=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,h)=>{ie(["@vscode/windows-process-tree"],l,h)}).then(De).then(l=>{l.getProcessList(W,h=>{if(!h){g(new Error(`Root process ${W} not found`));return}l.getProcessCpuUsage(h,d=>{const u=new Map;d.forEach(n=>{const v=c(n.commandLine||"");u.set(n.pid,{name:f(v),cmd:v,pid:n.pid,ppid:n.ppid,load:n.cpu||0,mem:n.memory||0})}),r=u.get(W),r?(u.forEach(n=>{const v=u.get(n.ppid);v&&(v.children||(v.children=[]),v.children.push(n))}),u.forEach(n=>{n.children&&(n.children=n.children.sort((v,b)=>v.pid-b.pid))}),P(r)):g(new Error(`Root process ${W} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let c=function(){let l=[r];const h=[];for(;l.length;){const u=l.shift();u&&(h.push(u.pid),u.children&&(l=l.concat(u.children)))}let d=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+h.join(" "),(0,a.exec)(d,{},(u,n,v)=>{if(u||v)g(u||new Error(v.toString()));else{const b=n.toString().split(`
`);for(let o=0;o<h.length;o++){const s=w.get(h[o]);s.load=parseFloat(b[o])}if(!r){g(new Error(`Root process ${W} not found`));return}P(r)}})};(0,a.exec)("which ps",{},(l,h,d)=>{if(l||d)if(process.platform!=="linux")g(l||new Error(d.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,a.exec)(u,{},(n,v,b)=>{n||b?g(n||new Error(b.toString())):(y(v,p),c())})}else{const u=h.toString().trim();(0,a.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,b,o)=>{v||o&&!o.includes("screen size is bogus")?g(v||new Error(o.toString())):(y(b,p),process.platform==="linux"?c():r?P(r):g(new Error(`Root process ${W} not found`)))})}})}})}function y(W,P){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=W.toString().split(`
`);for(const w of r){const p=g.exec(w.trim());p&&p.length===6&&P(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(he[62],fe([0,1,21,3,60,36]),function(ie,e,a,t,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=W,t=De(t),y=De(y);async function W(p,f){return p===t.OperatingSystem.Windows?t.isWindows?w():y.getWindowsShell(f):g(p,f)}let P=null;function g(p,f){if(t.isLinux&&p===t.OperatingSystem.Macintosh||t.isMacintosh&&p===t.OperatingSystem.Linux)return"/bin/bash";if(!P){let c;if(t.isWindows)c="/bin/bash";else{if(c=f.SHELL,!c)try{c=(0,a.userInfo)().shell}catch{}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}P=c}return P}let r=null;async function w(){return r||(r=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),r}});var _e=this&&this.__decorate||function(ie,e,a,t){var D=arguments.length,y=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,W;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(ie,e,a,t);else for(var P=ie.length-1;P>=0;P--)(W=ie[P])&&(y=(D<3?W(y):D>3?W(e,a,y):W(e,a))||y);return D>3&&y&&Object.defineProperty(e,a,y),y};define(he[30],fe([0,1,17,11,19,18,14,7,4,2,57,10,9]),function(ie,e,a,t,D,y,W,P,g,r,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=S,e.deserialize=L,e.getDelayedChannel=U,e.getNextTickChannel=I,p=De(p);var c;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(c||(c={}));function l(V){switch(V){case c.Promise:return"req";case c.PromiseCancel:return"cancel";case c.EventListen:return"subscribe";case c.EventDispose:return"unsubscribe"}}var h;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(h||(h={}));function d(V){switch(V){case h.Initialize:return"init";case h.PromiseSuccess:return"reply:";case h.PromiseError:case h.PromiseErrorObj:return"replyErr:";case h.EventFire:return"event:"}}var u;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(u||(u={}));function n(V){let z=0;for(let Q=0;;Q+=7){const ee=V.read(1);if(z|=(ee.buffer[0]&127)<<Q,!(ee.buffer[0]&128))return z}}const v=_(0);function b(V,z){if(z===0){V.write(v);return}let Q=0;for(let ue=z;ue!==0;ue=ue>>>7)Q++;const ee=D.VSBuffer.alloc(Q);for(let ue=0;z!==0;ue++)ee.buffer[ue]=z&127,z=z>>>7,z>0&&(ee.buffer[ue]|=128);V.write(ee)}class o{constructor(z){this.buffer=z,this.pos=0}read(z){const Q=this.buffer.slice(this.pos,this.pos+z);return this.pos+=Q.byteLength,Q}}e.BufferReader=o;class s{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}e.BufferWriter=s;var i;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(i||(i={}));function _(V){const z=D.VSBuffer.alloc(1);return z.writeUInt8(V,0),z}const A={Undefined:_(i.Undefined),String:_(i.String),Buffer:_(i.Buffer),VSBuffer:_(i.VSBuffer),Array:_(i.Array),Object:_(i.Object),Uint:_(i.Int)},F=typeof Buffer<"u";function S(V,z){if(typeof z>"u")V.write(A.Undefined);else if(typeof z=="string"){const Q=D.VSBuffer.fromString(z);V.write(A.String),b(V,Q.byteLength),V.write(Q)}else if(F&&Buffer.isBuffer(z)){const Q=D.VSBuffer.wrap(z);V.write(A.Buffer),b(V,Q.byteLength),V.write(Q)}else if(z instanceof D.VSBuffer)V.write(A.VSBuffer),b(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(A.Array),b(V,z.length);for(const Q of z)S(V,Q)}else if(typeof z=="number"&&(z|0)===z)V.write(A.Uint),b(V,z);else{const Q=D.VSBuffer.fromString(JSON.stringify(z));V.write(A.Object),b(V,Q.byteLength),V.write(Q)}}function L(V){switch(V.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return V.read(n(V)).toString();case i.Buffer:return V.read(n(V)).buffer;case i.VSBuffer:return V.read(n(V));case i.Array:{const Q=n(V),ee=[];for(let ue=0;ue<Q;ue++)ee.push(L(V));return ee}case i.Object:return JSON.parse(V.read(n(V)).toString());case i.Int:return n(V)}}class k{constructor(z,Q,ee=null,ue=1e3){this.protocol=z,this.ctx=Q,this.logger=ee,this.timeoutDelay=ue,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:h.Initialize})}registerChannel(z,Q){this.channels.set(z,Q),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case h.Initialize:{const Q=this.send([z.type]);this.logger?.logOutgoing(Q,0,O.OtherSide,d(z.type));return}case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:{const Q=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(Q,z.id,O.OtherSide,d(z.type),z.data);return}}}send(z,Q=void 0){const ee=new s;return S(ee,z),S(ee,Q),this.sendBuffer(ee.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const Q=new o(z),ee=L(Q),ue=L(Q),$=ee[0];switch($){case c.Promise:return this.logger?.logIncoming(z.byteLength,ee[1],O.OtherSide,`${l($)}: ${ee[2]}.${ee[3]}`,ue),this.onPromise({type:$,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case c.EventListen:return this.logger?.logIncoming(z.byteLength,ee[1],O.OtherSide,`${l($)}: ${ee[2]}.${ee[3]}`,ue),this.onEventListen({type:$,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case c.PromiseCancel:return this.logger?.logIncoming(z.byteLength,ee[1],O.OtherSide,`${l($)}`),this.disposeActiveRequest({type:$,id:ee[1]});case c.EventDispose:return this.logger?.logIncoming(z.byteLength,ee[1],O.OtherSide,`${l($)}`),this.disposeActiveRequest({type:$,id:ee[1]})}}onPromise(z){const Q=this.channels.get(z.channelName);if(!Q){this.collectPendingRequest(z);return}const ee=new y.CancellationTokenSource;let ue;try{ue=Q.call(this.ctx,z.name,z.arg,ee.token)}catch(me){ue=Promise.reject(me)}const $=z.id;ue.then(me=>{this.sendResponse({id:$,data:me,type:h.PromiseSuccess})},me=>{me instanceof Error?this.sendResponse({id:$,data:{message:me.message,name:me.name,stack:me.stack?me.stack.split(`
`):void 0},type:h.PromiseError}):this.sendResponse({id:$,data:me,type:h.PromiseErrorObj})}).finally(()=>{ae.dispose(),this.activeRequests.delete(z.id)});const ae=(0,r.toDisposable)(()=>ee.cancel());this.activeRequests.set(z.id,ae)}onEventListen(z){const Q=this.channels.get(z.channelName);if(!Q){this.collectPendingRequest(z);return}const ee=z.id,$=Q.listen(this.ctx,z.name,z.arg)(ae=>this.sendResponse({id:ee,data:ae,type:h.EventFire}));this.activeRequests.set(z.id,$)}disposeActiveRequest(z){const Q=this.activeRequests.get(z.id);Q&&(Q.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let Q=this.pendingRequests.get(z.channelName);Q||(Q=[],this.pendingRequests.set(z.channelName,Q));const ee=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===c.Promise&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:h.PromiseError})},this.timeoutDelay);Q.push({request:z,timeoutTimer:ee})}flushPendingRequests(z){const Q=this.pendingRequests.get(z);if(Q){for(const ee of Q)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case c.Promise:this.onPromise(ee.request);break;case c.EventListen:this.onEventListen(ee.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,r.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=k;var O;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(O||(e.RequestInitiator=O={}));class x{constructor(z,Q=null){this.protocol=z,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=Q}getChannel(z){const Q=this;return{call(ee,ue,$){return Q.isDisposed?Promise.reject(new P.CancellationError):Q.requestPromise(z,ee,ue,$)},listen(ee,ue){return Q.isDisposed?g.Event.None:Q.requestEvent(z,ee,ue)}}}requestPromise(z,Q,ee,ue=y.CancellationToken.None){const $=this.lastRequestId++,ae=c.Promise,me={id:$,type:ae,channelName:z,name:Q,arg:ee};if(ue.isCancellationRequested)return Promise.reject(new P.CancellationError);let te;return new Promise((j,oe)=>{if(ue.isCancellationRequested)return oe(new P.CancellationError);const N=()=>{const H=J=>{switch(J.type){case h.PromiseSuccess:this.handlers.delete($),j(J.data);break;case h.PromiseError:{this.handlers.delete($);const ne=new Error(J.data.message);ne.stack=Array.isArray(J.data.stack)?J.data.stack.join(`
`):J.data.stack,ne.name=J.data.name,oe(ne);break}case h.PromiseErrorObj:this.handlers.delete($),oe(J.data);break}};this.handlers.set($,H),this.sendRequest(me)};let K=null;this.state===u.Idle?N():(K=(0,t.createCancelablePromise)(H=>this.whenInitialized()),K.then(()=>{K=null,N()}));const M=()=>{K?(K.cancel(),K=null):this.sendRequest({id:$,type:c.PromiseCancel}),oe(new P.CancellationError)},T=ue.onCancellationRequested(M);te=(0,r.combinedDisposable)((0,r.toDisposable)(M),T),this.activeRequests.add(te)}).finally(()=>{te.dispose(),this.activeRequests.delete(te)})}requestEvent(z,Q,ee){const ue=this.lastRequestId++,$=c.EventListen,ae={id:ue,type:$,channelName:z,name:Q,arg:ee};let me=null;const te=new g.Emitter({onWillAddFirstListener:()=>{me=(0,t.createCancelablePromise)(j=>this.whenInitialized()),me.then(()=>{me=null,this.activeRequests.add(te),this.sendRequest(ae)})},onDidRemoveLastListener:()=>{me?(me.cancel(),me=null):(this.activeRequests.delete(te),this.sendRequest({id:ue,type:c.EventDispose}))}}),m=j=>te.fire(j.data);return this.handlers.set(ue,m),te.event}sendRequest(z){switch(z.type){case c.Promise:case c.EventListen:{const Q=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger?.logOutgoing(Q,z.id,O.LocalSide,`${l(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case c.PromiseCancel:case c.EventDispose:{const Q=this.send([z.type,z.id]);this.logger?.logOutgoing(Q,z.id,O.LocalSide,l(z.type));return}}}send(z,Q=void 0){const ee=new s;return S(ee,z),S(ee,Q),this.sendBuffer(ee.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const Q=new o(z),ee=L(Q),ue=L(Q),$=ee[0];switch($){case h.Initialize:return this.logger?.logIncoming(z.byteLength,0,O.LocalSide,d($)),this.onResponse({type:ee[0]});case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:return this.logger?.logIncoming(z.byteLength,ee[1],O.LocalSide,d($),ue),this.onResponse({type:ee[0],id:ee[1],data:ue})}}onResponse(z){if(z.type===h.Initialize){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(z.id)?.(z)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,r.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=x,_e([W.memoize],x.prototype,"onDidInitializePromise",null);class R{get connections(){const z=[];return this._connections.forEach(Q=>z.push(Q)),z}constructor(z,Q,ee){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new r.DisposableStore,this.disposables.add(z(({protocol:ue,onDidClientDisconnect:$})=>{const ae=g.Event.once(ue.onMessage);this.disposables.add(ae(me=>{const te=new o(me),m=L(te),j=new k(ue,m,Q,ee),oe=new x(ue,Q);this.channels.forEach((K,M)=>j.registerChannel(M,K));const N={channelServer:j,channelClient:oe,ctx:m};this._connections.add(N),this._onDidAddConnection.fire(N),this.disposables.add($(()=>{j.dispose(),oe.dispose(),this._connections.delete(N),this._onDidRemoveConnection.fire(N)}))}))}))}getChannel(z,Q){const ee=this;return{call(ue,$,ae){let me;if((0,f.isFunction)(Q)){const m=(0,a.getRandomElement)(ee.connections.filter(Q));me=m?Promise.resolve(m):g.Event.toPromise(g.Event.filter(ee.onDidAddConnection,Q))}else me=Q.routeCall(ee,ue,$);const te=me.then(m=>m.channelClient.getChannel(z));return U(te).call(ue,$,ae)},listen(ue,$){if((0,f.isFunction)(Q))return ee.getMulticastEvent(z,Q,ue,$);const ae=Q.routeEvent(ee,ue,$).then(me=>me.channelClient.getChannel(z));return U(ae).listen(ue,$)}}}getMulticastEvent(z,Q,ee,ue){const $=this;let ae;const me=new g.Emitter({onWillAddFirstListener:()=>{ae=new r.DisposableStore;const te=new g.EventMultiplexer,m=new Map,j=N=>{const M=N.channelClient.getChannel(z).listen(ee,ue),T=te.add(M);m.set(N,T)},oe=N=>{const K=m.get(N);K&&(K.dispose(),m.delete(N))};$.connections.filter(Q).forEach(j),g.Event.filter($.onDidAddConnection,Q)(j,void 0,ae),$.onDidRemoveConnection(oe,void 0,ae),te.event(me.fire,me,ae),ae.add(te)},onDidRemoveLastListener:()=>{ae?.dispose(),ae=void 0}});return me.event}registerChannel(z,Q){this.channels.set(z,Q);for(const ee of this._connections)ee.channelServer.registerChannel(z,Q)}dispose(){this.disposables.dispose();for(const z of this._connections)z.channelClient.dispose(),z.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class E{constructor(z,Q,ee=null){const ue=new s;S(ue,Q),z.send(ue.buffer),this.channelClient=new x(z,ee),this.channelServer=new k(z,Q,ee)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,Q){this.channelServer.registerChannel(z,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=E;function U(V){return{call(z,Q,ee){return V.then(ue=>ue.call(z,Q,ee))},listen(z,Q){const ee=new g.Relay;return V.then(ue=>ee.input=ue.listen(z,Q)),ee.event}}}function I(V){let z=!1;return{call(Q,ee,ue){return z?V.call(Q,ee,ue):(0,t.timeout)(0).then(()=>z=!0).then(()=>V.call(Q,ee,ue))},listen(Q,ee){if(z)return V.listen(Q,ee);const ue=new g.Relay;return(0,t.timeout)(0).then(()=>z=!0).then(()=>ue.input=V.listen(Q,ee)),ue.event}}}class C{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const Q of z.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await g.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=C;var B;(function(V){function z($,ae,me){const te=$,m=me&&me.disableMarshalling,j=new Map;for(const oe in te)ee(oe)&&j.set(oe,g.Event.buffer(te[oe],!0,void 0,ae));return new class{listen(oe,N,K){const M=j.get(N);if(M)return M;const T=te[N];if(typeof T=="function"){if(ue(N))return T.call(te,K);if(ee(N))return j.set(N,g.Event.buffer(te[N],!0,void 0,ae)),j.get(N)}throw new P.ErrorNoTelemetry(`Event not found: ${N}`)}call(oe,N,K){const M=te[N];if(typeof M=="function"){if(!m&&Array.isArray(K))for(let H=0;H<K.length;H++)K[H]=(0,w.revive)(K[H]);let T=M.apply(te,K);return T instanceof Promise||(T=Promise.resolve(T)),T}throw new P.ErrorNoTelemetry(`Method not found: ${N}`)}}}V.fromService=z;function Q($,ae){const me=ae&&ae.disableMarshalling;return new Proxy({},{get(te,m){if(typeof m=="string")return ae?.properties?.has(m)?ae.properties.get(m):ue(m)?function(j){return $.listen(m,j)}:ee(m)?$.listen(m):async function(...j){let oe;ae&&!(0,f.isUndefinedOrNull)(ae.context)?oe=[ae.context,...j]:oe=j;const N=await $.call(m,oe);return me?N:(0,w.revive)(N)};throw new P.ErrorNoTelemetry(`Property not found: ${String(m)}`)}})}V.toService=Q;function ee($){return $[0]==="o"&&$[1]==="n"&&p.isUpperAsciiLetter($.charCodeAt(2))}function ue($){return/^onDynamic/.test($)&&p.isUpperAsciiLetter($.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function Z(V){return Array.isArray(V)?V.map(G):G(V)}function se(V,z,Q,ee,ue,$,ae){ae=Z(ae);const me=Y[ue],te=me[ee%me.length];let m=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${te}`];/\($/.test($)?(m=m.concat(ae),m.push(")")):m.push(ae),console.log.apply(console,m)}class le{constructor(z,Q){this._outgoingPrefix=z,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,Q,ee,ue,$){this._totalOutgoing+=z,se(this._outgoingPrefix,this._totalOutgoing,z,Q,ee,ue,$)}logIncoming(z,Q,ee,ue,$){this._totalIncoming+=z,se(this._incomingPrefix,this._totalIncoming,z,Q,ee,ue,$)}}e.IPCLogger=le}),define(he[63],fe([0,1,29,11,19,18,56,7,4,2,33,36,32,30]),function(ie,e,a,t,D,y,W,P,g,r,w,p,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,P=De(P);class l extends c.ChannelServer{constructor(u){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",n=>D.VSBuffer.wrap(Buffer.from(n,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=l;class h{constructor(u,n){this.modulePath=u,this.options=n,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=n&&n.timeout?n.timeout:6e4;this.disposeDelayer=new t.Delayer(v),this.child=null,this._client=null}getChannel(u){const n=this;return{call(v,b,o){return n.requestPromise(u,v,b,o)},listen(v,b){return n.requestEvent(u,v,b)}}}requestPromise(u,n,v,b=y.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(u),s=(0,t.createCancelablePromise)(A=>o.call(n,v,A)),i=b.onCancellationRequested(()=>s.cancel()),_=(0,r.toDisposable)(()=>s.cancel());return this.activeRequests.add(_),s.finally(()=>{i.dispose(),this.activeRequests.delete(_),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(u,n,v){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let b;const o=new g.Emitter({onWillAddFirstListener:()=>{b=this.getCachedChannel(u).listen(n,v)(o.fire,o),this.activeRequests.add(b)},onDidRemoveLastListener:()=>{this.activeRequests.delete(b),b.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],n=Object.create(null);n.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(n.env={...n.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(n.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(S=>!/^--inspect(-brk)?=/.test(S)).filter(S=>!S.startsWith("--vscode-"))),(0,f.removeDangerousEnvVariables)(n.env),this.child=(0,a.fork)(this.modulePath,u,n);const v=new g.Emitter,o=g.Event.fromNodeEventEmitter(this.child,"message",S=>S)(S=>{if((0,W.isRemoteConsoleLog)(S)){(0,W.log)(S,`IPC Library: ${this.options.serverName}`);return}v.fire(D.VSBuffer.wrap(Buffer.from(S,"base64")))}),s=this.options.useQueue?(0,p.createQueuedSender)(this.child):this.child,i=S=>this.child&&this.child.connected&&s.send(S.buffer.toString("base64")),_=v.event,A={send:i,onMessage:_};this._client=new c.ChannelClient(A);const F=()=>this.disposeClient();process.once("exit",F),this.child.on("error",S=>console.warn('IPC "'+this.options.serverName+'" errored with '+S)),this.child.on("exit",(S,L)=>{process.removeListener("exit",F),o.dispose(),this.activeRequests.forEach(k=>(0,r.dispose)(k)),this.activeRequests.clear(),S!==0&&L!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+S+" and signal "+L),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:S,signal:L})})}return this._client}getCachedChannel(u){let n=this.channels.get(u);return n||(n=this.client.getChannel(u),this.channels.set(u,n)),n}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(he[37],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=a;function a(t){return!!t.parentPort}}),define(he[64],fe([0,1,37,19,30,4,9,17]),function(ie,e,a,t,D,y,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=w;class g{constructor(f){this.port=f,this.onMessage=y.Event.fromNodeEventEmitter(this.port,"message",c=>c.data?t.VSBuffer.wrap(c.data):t.VSBuffer.alloc(0)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}class r extends D.IPCServer{static getOnDidClientConnect(f){(0,W.assertType)((0,a.isUtilityProcess)(process),"Electron Utility Process");const c=new y.Emitter;return process.parentPort.on("message",l=>{if(f?.handledClientConnection(l))return;const h=(0,P.firstOrDefault)(l.ports);h&&c.fire(h)}),y.Event.map(c.event,l=>({protocol:new g(l),onDidClientDisconnect:y.Event.fromNodeEventEmitter(l,"close")}))}constructor(f){super(r.getOnDidClientConnect(f))}}e.Server=r;function w(p,f,c){const l=h=>{h.data===f&&(p.removeListener("message",l),c())};p.on("message",l)}}),define(he[12],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=D,e.localize2=W;const a=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function t(P,g){let r;return g.length===0?r=P:r=P.replace(/\{(\d+)\}/g,(w,p)=>{const f=p[0],c=g[f];let l=w;return typeof c=="string"?l=c:(typeof c=="number"||typeof c=="boolean"||c===void 0||c===null)&&(l=String(c)),l}),a&&(r="\uFF3B"+r.replace(/[aouei]/g,"$&$&")+"\uFF3D"),r}function D(P,g,...r){return t(typeof P=="number"?y(P,g):g,r)}function y(P,g){const r=globalThis._VSCODE_NLS_MESSAGES?.[P];if(typeof r!="string"){if(typeof g=="string")return g;throw new Error(`!!! NLS MISSING: ${P} !!!`)}return r}function W(P,g,...r){let w;typeof P=="number"?w=y(P,g):w=g;const p=t(w,r);return{value:p,original:g===w?p:t(g,r)}}}),define(he[65],fe([0,1,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=r,e.getDurationString=w,e.toLocalISOString=p;const t=60,D=t*60,y=D*24,W=y*7,P=y*30,g=y*365;function r(f,c,l,h){typeof f!="number"&&(f=f.getTime());const d=Math.round((new Date().getTime()-f)/1e3);if(d<-30)return(0,a.localize)(12985,null,r(new Date().getTime()+d*1e3,!1));if(!h&&d<30)return(0,a.localize)(12986,null);let u;return d<t?(u=d,c?u===1?l?(0,a.localize)(12987,null,u):(0,a.localize)(12988,null,u):l?(0,a.localize)(12989,null,u):(0,a.localize)(12990,null,u):u===1?l?(0,a.localize)(12991,null,u):(0,a.localize)(12992,null,u):l?(0,a.localize)(12993,null,u):(0,a.localize)(12994,null,u)):d<D?(u=Math.floor(d/t),c?u===1?l?(0,a.localize)(12995,null,u):(0,a.localize)(12996,null,u):l?(0,a.localize)(12997,null,u):(0,a.localize)(12998,null,u):u===1?l?(0,a.localize)(12999,null,u):(0,a.localize)(13e3,null,u):l?(0,a.localize)(13001,null,u):(0,a.localize)(13002,null,u)):d<y?(u=Math.floor(d/D),c?u===1?l?(0,a.localize)(13003,null,u):(0,a.localize)(13004,null,u):l?(0,a.localize)(13005,null,u):(0,a.localize)(13006,null,u):u===1?l?(0,a.localize)(13007,null,u):(0,a.localize)(13008,null,u):l?(0,a.localize)(13009,null,u):(0,a.localize)(13010,null,u)):d<W?(u=Math.floor(d/y),c?u===1?(0,a.localize)(13011,null,u):(0,a.localize)(13012,null,u):u===1?(0,a.localize)(13013,null,u):(0,a.localize)(13014,null,u)):d<P?(u=Math.floor(d/W),c?u===1?l?(0,a.localize)(13015,null,u):(0,a.localize)(13016,null,u):l?(0,a.localize)(13017,null,u):(0,a.localize)(13018,null,u):u===1?l?(0,a.localize)(13019,null,u):(0,a.localize)(13020,null,u):l?(0,a.localize)(13021,null,u):(0,a.localize)(13022,null,u)):d<g?(u=Math.floor(d/P),c?u===1?l?(0,a.localize)(13023,null,u):(0,a.localize)(13024,null,u):l?(0,a.localize)(13025,null,u):(0,a.localize)(13026,null,u):u===1?l?(0,a.localize)(13027,null,u):(0,a.localize)(13028,null,u):l?(0,a.localize)(13029,null,u):(0,a.localize)(13030,null,u)):(u=Math.floor(d/g),c?u===1?l?(0,a.localize)(13031,null,u):(0,a.localize)(13032,null,u):l?(0,a.localize)(13033,null,u):(0,a.localize)(13034,null,u):u===1?l?(0,a.localize)(13035,null,u):(0,a.localize)(13036,null,u):l?(0,a.localize)(13037,null,u):(0,a.localize)(13038,null,u))}function w(f,c){const l=Math.abs(f/1e3);return l<1?c?(0,a.localize)(13039,null,f):(0,a.localize)(13040,null,f):l<t?c?(0,a.localize)(13041,null,Math.round(f)/1e3):(0,a.localize)(13042,null,Math.round(f)/1e3):l<D?c?(0,a.localize)(13043,null,Math.round(f/(1e3*t))):(0,a.localize)(13044,null,Math.round(f/(1e3*t))):l<y?c?(0,a.localize)(13045,null,Math.round(f/(1e3*D))):(0,a.localize)(13046,null,Math.round(f/(1e3*D))):(0,a.localize)(13047,null,Math.round(f/(1e3*y)))}function p(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[66],fe([0,1,17,9,12]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=g,e.isErrorWithActions=r,e.createErrorWithActions=w,a=De(a),t=De(t),D=De(D);function y(p,f){return f&&(p.stack||p.stacktrace)?D.localize(12979,null,P(p),W(p.stack)||W(p.stacktrace)):P(p)}function W(p){return Array.isArray(p)?p.join(`
`):p}function P(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?D.localize(12980,null,p.message):p.message||D.localize(12981,null)}function g(p=null,f=!1){if(!p)return D.localize(12982,null);if(Array.isArray(p)){const c=a.coalesce(p),l=g(c[0],f);return c.length>1?D.localize(12983,null,l,c.length):l}if(t.isString(p))return p;if(p.detail){const c=p.detail;if(c.error)return y(c.error,f);if(c.exception)return y(c.exception,f)}return p.stack?y(p,f):p.message?p.message:D.localize(12984,null)}function r(p){const f=p;return f instanceof Error&&Array.isArray(f.actions)}function w(p,f){let c;return typeof p=="string"?c=new Error(p):c=p,c.actions=f,c}}),define(he[67],fe([0,1,13,7,12]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var y;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(y||(e.TokenType=y={}));function W(...w){switch(w.length){case 1:return(0,D.localize)(11586,null,w[0]);case 2:return(0,D.localize)(11587,null,w[0],w[1]);case 3:return(0,D.localize)(11588,null,w[0],w[1],w[2]);default:return}}const P=(0,D.localize)(11589,null),g=(0,D.localize)(11590,null);class r{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case y.LParen:return"(";case y.RParen:return")";case y.Neg:return"!";case y.Eq:return p.isTripleEq?"===":"==";case y.NotEq:return p.isTripleEq?"!==":"!=";case y.Lt:return"<";case y.LtEq:return"<=";case y.Gt:return">=";case y.GtEq:return">=";case y.RegexOp:return"=~";case y.RegexStr:return p.lexeme;case y.True:return"true";case y.False:return"false";case y.In:return"in";case y.Not:return"not";case y.And:return"&&";case y.Or:return"||";case y.Str:return p.lexeme;case y.QuotedStr:return p.lexeme;case y.Error:return p.lexeme;case y.EOF:return"EOF";default:throw(0,t.illegalState)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this._keywords=new Map([["not",y.Not],["in",y.In],["false",y.False],["true",y.True]])}get errors(){return this._errors}reset(p){return this._input=p,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case a.CharCode.OpenParen:this._addToken(y.LParen);break;case a.CharCode.CloseParen:this._addToken(y.RParen);break;case a.CharCode.ExclamationMark:if(this._match(a.CharCode.Equals)){const f=this._match(a.CharCode.Equals);this._tokens.push({type:y.NotEq,offset:this._start,isTripleEq:f})}else this._addToken(y.Neg);break;case a.CharCode.SingleQuote:this._quotedString();break;case a.CharCode.Slash:this._regex();break;case a.CharCode.Equals:if(this._match(a.CharCode.Equals)){const f=this._match(a.CharCode.Equals);this._tokens.push({type:y.Eq,offset:this._start,isTripleEq:f})}else this._match(a.CharCode.Tilde)?this._addToken(y.RegexOp):this._error(W("==","=~"));break;case a.CharCode.LessThan:this._addToken(this._match(a.CharCode.Equals)?y.LtEq:y.Lt);break;case a.CharCode.GreaterThan:this._addToken(this._match(a.CharCode.Equals)?y.GtEq:y.Gt);break;case a.CharCode.Ampersand:this._match(a.CharCode.Ampersand)?this._addToken(y.And):this._error(W("&&"));break;case a.CharCode.Pipe:this._match(a.CharCode.Pipe)?this._addToken(y.Or):this._error(W("||"));break;case a.CharCode.Space:case a.CharCode.CarriageReturn:case a.CharCode.Tab:case a.CharCode.LineFeed:case a.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(y.EOF),Array.from(this._tokens)}_match(p){return this._isAtEnd()||this._input.charCodeAt(this._current)!==p?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?a.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(p){this._tokens.push({type:p,offset:this._start})}_error(p){const f=this._start,c=this._input.substring(this._start,this._current),l={type:y.Error,offset:this._start,lexeme:c};this._errors.push({offset:f,lexeme:c,additionalInfo:p}),this._tokens.push(l)}_string(){this.stringRe.lastIndex=this._start;const p=this.stringRe.exec(this._input);if(p){this._current=this._start+p[0].length;const f=this._input.substring(this._start,this._current),c=r._keywords.get(f);c?this._addToken(c):this._tokens.push({type:y.Str,lexeme:f,offset:this._start})}}_quotedString(){for(;this._peek()!==a.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(P);return}this._advance(),this._tokens.push({type:y.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let p=this._current,f=!1,c=!1;for(;;){if(p>=this._input.length){this._current=p,this._error(g);return}const h=this._input.charCodeAt(p);if(f)f=!1;else if(h===a.CharCode.Slash&&!c){p++;break}else h===a.CharCode.OpenSquareBracket?c=!0:h===a.CharCode.Backslash?f=!0:h===a.CharCode.CloseSquareBracket&&(c=!1);p++}for(;p<this._input.length&&r._regexFlags.has(this._input.charCodeAt(p));)p++;this._current=p;const l=this._input.substring(this._start,this._current);this._tokens.push({type:y.RegexStr,lexeme:l,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=r}),define(he[68],fe([0,1,65,14,20,5,15,25,6]),function(ie,e,a,t,D,y,W,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=w,e.parseDebugParams=p,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,y.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,y.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,a.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,y.join)(this.userDataPath,"logs",c)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(g.URI.file((0,y.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=W.env.VSCODE_PORTABLE;return c?g.URI.file((0,y.join)(c,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,y.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,y.resolve)(c):(0,y.normalize)((0,y.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?g.URI.file((0,y.resolve)(c)):g.URI.file((0,y.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,y.resolve)(c);const l=W.env.VSCODE_EXTENSIONS;if(l)return l;const h=W.env.VSCODE_PORTABLE;return h?(0,y.join)(h,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(l=>/^[^:/?#]+?:\/\//.test(l)?g.URI.parse(l):g.URI.file((0,y.normalize)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?g.URI.parse(c):g.URI.file((0,y.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!W.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(c))}get extensionLogLevel(){const c=[];for(const l of this.args.log||[]){const h=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(l);h&&h[1]&&h[2]&&c.push([h[1],h[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=W.env.VSCODE_PORTABLE;return c?g.URI.file((0,y.join)(c,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this._args}constructor(c,l,h){this._args=c,this.paths=l,this.productService=h,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=r,_e([t.memoize],r.prototype,"appRoot",null),_e([t.memoize],r.prototype,"userHome",null),_e([t.memoize],r.prototype,"userDataPath",null),_e([t.memoize],r.prototype,"appSettingsHome",null),_e([t.memoize],r.prototype,"tmpDir",null),_e([t.memoize],r.prototype,"cacheHome",null),_e([t.memoize],r.prototype,"stateResource",null),_e([t.memoize],r.prototype,"userRoamingDataHome",null),_e([t.memoize],r.prototype,"userDataSyncHome",null),_e([t.memoize],r.prototype,"sync",null),_e([t.memoize],r.prototype,"machineSettingsResource",null),_e([t.memoize],r.prototype,"workspaceStorageHome",null),_e([t.memoize],r.prototype,"localHistoryHome",null),_e([t.memoize],r.prototype,"keyboardLayoutResource",null),_e([t.memoize],r.prototype,"argvResource",null),_e([t.memoize],r.prototype,"isExtensionDevelopment",null),_e([t.memoize],r.prototype,"untitledWorkspacesHome",null),_e([t.memoize],r.prototype,"builtinExtensionsPath",null),_e([t.memoize],r.prototype,"extensionsPath",null),_e([t.memoize],r.prototype,"extensionDevelopmentLocationURI",null),_e([t.memoize],r.prototype,"extensionDevelopmentKind",null),_e([t.memoize],r.prototype,"extensionTestsLocationURI",null),_e([t.memoize],r.prototype,"debugExtensionHost",null),_e([t.memoize],r.prototype,"logLevel",null),_e([t.memoize],r.prototype,"extensionLogLevel",null),_e([t.memoize],r.prototype,"serviceMachineIdResource",null),_e([t.memoize],r.prototype,"disableTelemetry",null),_e([t.memoize],r.prototype,"disableWorkspaceTrust",null),_e([t.memoize],r.prototype,"useInMemorySecretStorage",null),_e([t.memoize],r.prototype,"policyFile",null);function w(f,c){return p(f["inspect-extensions"],f["inspect-brk-extensions"],5870,c,f.debugId,f.extensionEnvironment)}function p(f,c,l,h,d,u){const v=Number(c||f)||(h?null:l),b=v?!!c:!1;let o;if(u)try{o=JSON.parse(u)}catch{}return{port:v,break:b,debugId:d,env:o}}});var Ve=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[69],fe([0,1,101,3,12]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=P,e.formatOptions=r,e.buildHelpMessage=c,e.buildVersionMessage=l,a=Ve(a);const y={o:(0,D.localize)(11523,null),e:(0,D.localize)(11524,null),t:(0,D.localize)(11525,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(11526,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(11527,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(11528,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(11529,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(11530,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(11531,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(11532,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(11533,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(11534,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11535,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11536,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(11537,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11538,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(11539,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(11540,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(11541,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,D.localize)(11542,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(11543,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(11544,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(11545,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(11546,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(11547,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(11548,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(11549,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(11550,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(11551,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(11552,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(11553,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(11554,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(11555,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(11556,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(11557,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,D.localize)(11558,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(11559,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,D.localize)(11560,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(11561,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const W={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(h,d,u=W){const n=h.find(S=>S.length>0&&S[0]!=="-"),v={},b=["_"],o=[],s={};let i;for(const S in d){const L=d[S];L.type==="subcommand"?S===n&&(i=L):(L.alias&&(v[S]=L.alias),L.type==="string"||L.type==="string[]"?(b.push(S),L.deprecates&&b.push(...L.deprecates)):L.type==="boolean"&&(o.push(S),L.deprecates&&o.push(...L.deprecates)),L.global&&(s[S]=L))}if(i&&n){const S=s;for(const x in i.options)S[x]=i.options[x];const L=h.filter(x=>x!==n),k=u.getSubcommandReporter?u.getSubcommandReporter(n):void 0,O=P(L,S,k);return{[n]:O,_:[]}}const _=(0,a.default)(h,{string:b,boolean:o,alias:v}),A={},F=_;A._=_._.map(S=>String(S)).filter(S=>S.length>0),delete F._;for(const S in d){const L=d[S];if(L.type==="subcommand")continue;L.alias&&delete F[L.alias];let k=F[S];if(L.deprecates)for(const O of L.deprecates)F.hasOwnProperty(O)&&(k||(k=F[O],k&&u.onDeprecatedOption(O,L.deprecationMessage||(0,D.localize)(11562,null,S))),delete F[O]);if(typeof k<"u"){if(L.type==="string[]"){if(Array.isArray(k)||(k=[k]),!L.allowEmptyValue){const O=k.filter(x=>x.length>0);O.length!==k.length&&(u.onEmptyValue(S),k=O.length>0?O:void 0)}}else L.type==="string"&&(Array.isArray(k)?(k=k.pop(),u.onMultipleValues(S,k)):!k&&!L.allowEmptyValue&&(u.onEmptyValue(S),k=void 0));A[S]=k,L.deprecationMessage&&u.onDeprecatedOption(S,L.deprecationMessage)}delete F[S]}for(const S in F)u.onUnknownOption(S);return A}function g(h,d){let u="";return d.args&&(Array.isArray(d.args)?u=` <${d.args.join("> <")}>`:u=` <${d.args}>`),d.alias?`-${d.alias} --${h}${u}`:`--${h}${u}`}function r(h,d){const u=[];for(const n in h){const v=h[n],b=g(n,v);u.push([b,v.description])}return w(u,d)}function w(h,d){const n=h.reduce((o,s)=>Math.max(o,s[0].length),12)+2+1;if(d-n<25)return h.reduce((o,s)=>o.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const v=d-n-1,b=[];for(const o of h){const s=o[0],i=f(o[1],v),_=p(n-s.length-2);b.push("  "+s+_+i[0]);for(let A=1;A<i.length;A++)b.push(p(n)+i[A])}return b}function p(h){return" ".repeat(h)}function f(h,d){const u=[];for(;h.length;){const n=h.length<d?h.length:h.lastIndexOf(" ",d),v=h.slice(0,n).trim();h=h.slice(n),u.push(v)}return u}function c(h,d,u,n,v){const b=process.stdout.isTTY&&process.stdout.columns||80,o=v?.noInputFiles!==!0?`[${(0,D.localize)(11563,null)}...]`:"",s=[`${h} ${u}`];s.push(""),s.push(`${(0,D.localize)(11564,null)}: ${d} [${(0,D.localize)(11565,null)}]${o}`),s.push(""),v?.noPipe!==!0&&(t.isWindows?s.push((0,D.localize)(11566,null,d)):s.push((0,D.localize)(11567,null,d)),s.push(""));const i={},_=[];for(const A in n){const F=n[A];if(F.type==="subcommand")F.description&&_.push({command:A,description:F.description});else if(F.description&&F.cat){let S=i[F.cat];S||(i[F.cat]=S={}),S[A]=F}}for(const A in i){const F=A,S=i[F];S&&(s.push(y[F]),s.push(...r(S,b)),s.push(""))}return _.length&&(s.push((0,D.localize)(11568,null)),s.push(...w(_.map(A=>[A.command,A.description]),b)),s.push("")),s.join(`
`)}function l(h,d){return`${h||(0,D.localize)(11569,null)}
${d||(0,D.localize)(11570,null)}
${process.arch}`}}),function(){function ie(e,a,t){function D(W,P){const g=y(W,P),r=[g];return e.isAbsolute(g)||r.unshift(t),e.resolve(...r)}function y(W,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,P);const w=W["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(p,"AppData","Roaming")}break;case"darwin":r=e.join(a.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(a.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,P)}return{getUserDataPath:D}}if(typeof define=="function")define(he[70],fe([71,21,15]),function(e,a,t){return ie(e,a,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),a=require("os");module.exports=ie(e,a,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[72],fe([0,1,21,68,70]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=W,e.parseSharedProcessDebugPort=P;class y extends t.AbstractNativeEnvironmentService{constructor(r,w){super(r,{homeDir:(0,a.homedir)(),tmpDir:(0,a.tmpdir)(),userDataDir:(0,D.getUserDataPath)(r,w.nameShort)},w)}}e.NativeEnvironmentService=y;function W(g,r){return(0,t.parseDebugParams)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,r,g.extensionEnvironment)}function P(g,r){return(0,t.parseDebugParams)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,r,g.extensionEnvironment)}}),define(he[22],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=D,e.refineServiceDecorator=y;var a;(function(W){W.serviceIds=new Map,W.DI_TARGET="$di$target",W.DI_DEPENDENCIES="$di$dependencies";function P(g){return g[W.DI_DEPENDENCIES]||[]}W.getServiceDependencies=P})(a||(e._util=a={})),e.IInstantiationService=D("instantiationService");function t(W,P,g){P[a.DI_TARGET]===P?P[a.DI_DEPENDENCIES].push({id:W,index:g}):(P[a.DI_DEPENDENCIES]=[{id:W,index:g}],P[a.DI_TARGET]=P)}function D(W){if(a.serviceIds.has(W))return a.serviceIds.get(W);const P=function(g,r,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,g,w)};return P.toString=()=>W,a.serviceIds.set(W,P),P}function y(W){return W}}),define(he[38],fe([0,1,13,3,10,67,22,12,7]),function(ie,e,a,t,D,y,W,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=w,e.validateWhenClauses=_,e.expressionsAreEqualWithConstantSubstitution=A,e.implies=$;const r=new Map;r.set("false",!1),r.set("true",!0),r.set("isMac",t.isMacintosh),r.set("isLinux",t.isLinux),r.set("isWindows",t.isWindows),r.set("isWeb",t.isWeb),r.set("isMacNative",t.isMacintosh&&!t.isWeb),r.set("isEdge",t.isEdge),r.set("isFirefox",t.isFirefox),r.set("isChrome",t.isChrome),r.set("isSafari",t.isSafari);function w(te,m){if(r.get(te)!==void 0)throw(0,g.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");r.set(te,m)}const p=Object.prototype.hasOwnProperty;var f;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const c={regexParsingWithErrorRecovery:!0},l=(0,P.localize)(11600,null),h=(0,P.localize)(11601,null),d=(0,P.localize)(11602,null),u=(0,P.localize)(11603,null),n=(0,P.localize)(11604,null),v=(0,P.localize)(11605,null),b=(0,P.localize)(11606,null),o=(0,P.localize)(11607,null);class s{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(m=c){this._config=m,this._scanner=new y.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(m){if(m===""){this._parsingErrors.push({message:l,offset:0,lexeme:"",additionalInfo:h});return}this._tokens=this._scanner.reset(m).scan(),this._current=0,this._parsingErrors=[];try{const j=this._expr();if(!this._isAtEnd()){const oe=this._peek(),N=oe.type===y.TokenType.Str?v:void 0;throw this._parsingErrors.push({message:n,offset:oe.offset,lexeme:y.Scanner.getLexeme(oe),additionalInfo:N}),s._parseError}return j}catch(j){if(j!==s._parseError)throw j;return}}_expr(){return this._or()}_or(){const m=[this._and()];for(;this._matchOne(y.TokenType.Or);){const j=this._and();m.push(j)}return m.length===1?m[0]:i.or(...m)}_and(){const m=[this._term()];for(;this._matchOne(y.TokenType.And);){const j=this._term();m.push(j)}return m.length===1?m[0]:i.and(...m)}_term(){if(this._matchOne(y.TokenType.Neg)){const m=this._peek();switch(m.type){case y.TokenType.True:return this._advance(),S.INSTANCE;case y.TokenType.False:return this._advance(),L.INSTANCE;case y.TokenType.LParen:{this._advance();const j=this._expr();return this._consume(y.TokenType.RParen,u),j?.negate()}case y.TokenType.Str:return this._advance(),U.create(m.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",m)}}return this._primary()}_primary(){const m=this._peek();switch(m.type){case y.TokenType.True:return this._advance(),i.true();case y.TokenType.False:return this._advance(),i.false();case y.TokenType.LParen:{this._advance();const j=this._expr();return this._consume(y.TokenType.RParen,u),j}case y.TokenType.Str:{const j=m.lexeme;if(this._advance(),this._matchOne(y.TokenType.RegexOp)){const N=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),N.type!==y.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",N);const K=N.lexeme,M=K.lastIndexOf("/"),T=M===K.length-1?void 0:this._removeFlagsGY(K.substring(M+1));let H;try{H=new RegExp(K.substring(1,M),T)}catch{throw this._errExpectedButGot("REGEX",N)}return Z.create(j,H)}switch(N.type){case y.TokenType.RegexStr:case y.TokenType.Error:{const K=[N.lexeme];this._advance();let M=this._peek(),T=0;for(let we=0;we<N.lexeme.length;we++)N.lexeme.charCodeAt(we)===a.CharCode.OpenParen?T++:N.lexeme.charCodeAt(we)===a.CharCode.CloseParen&&T--;for(;!this._isAtEnd()&&M.type!==y.TokenType.And&&M.type!==y.TokenType.Or;){switch(M.type){case y.TokenType.LParen:T++;break;case y.TokenType.RParen:T--;break;case y.TokenType.RegexStr:case y.TokenType.QuotedStr:for(let we=0;we<M.lexeme.length;we++)M.lexeme.charCodeAt(we)===a.CharCode.OpenParen?T++:N.lexeme.charCodeAt(we)===a.CharCode.CloseParen&&T--}if(T<0)break;K.push(y.Scanner.getLexeme(M)),this._advance(),M=this._peek()}const H=K.join(""),J=H.lastIndexOf("/"),ne=J===H.length-1?void 0:this._removeFlagsGY(H.substring(J+1));let pe;try{pe=new RegExp(H.substring(1,J),ne)}catch{throw this._errExpectedButGot("REGEX",N)}return i.regex(j,pe)}case y.TokenType.QuotedStr:{const K=N.lexeme;this._advance();let M=null;if(!(0,D.isFalsyOrWhitespace)(K)){const T=K.indexOf("/"),H=K.lastIndexOf("/");if(T!==H&&T>=0){const J=K.slice(T+1,H),ne=K[H+1]==="i"?"i":"";try{M=new RegExp(J,ne)}catch{throw this._errExpectedButGot("REGEX",N)}}}if(M===null)throw this._errExpectedButGot("REGEX",N);return Z.create(j,M)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(y.TokenType.Not)){this._consume(y.TokenType.In,d);const N=this._value();return i.notIn(j,N)}switch(this._peek().type){case y.TokenType.Eq:{this._advance();const N=this._value();if(this._previous().type===y.TokenType.QuotedStr)return i.equals(j,N);switch(N){case"true":return i.has(j);case"false":return i.not(j);default:return i.equals(j,N)}}case y.TokenType.NotEq:{this._advance();const N=this._value();if(this._previous().type===y.TokenType.QuotedStr)return i.notEquals(j,N);switch(N){case"true":return i.not(j);case"false":return i.has(j);default:return i.notEquals(j,N)}}case y.TokenType.Lt:return this._advance(),Y.create(j,this._value());case y.TokenType.LtEq:return this._advance(),G.create(j,this._value());case y.TokenType.Gt:return this._advance(),C.create(j,this._value());case y.TokenType.GtEq:return this._advance(),B.create(j,this._value());case y.TokenType.In:return this._advance(),i.in(j,this._value());default:return i.has(j)}}case y.TokenType.EOF:throw this._parsingErrors.push({message:b,offset:m.offset,lexeme:"",additionalInfo:o}),s._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const m=this._peek();switch(m.type){case y.TokenType.Str:case y.TokenType.QuotedStr:return this._advance(),m.lexeme;case y.TokenType.True:return this._advance(),"true";case y.TokenType.False:return this._advance(),"false";case y.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(m){return m.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(m){return this._check(m)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(m,j){if(this._check(m))return this._advance();throw this._errExpectedButGot(j,this._peek())}_errExpectedButGot(m,j,oe){const N=(0,P.localize)(11608,null,m,y.Scanner.getLexeme(j)),K=j.offset,M=y.Scanner.getLexeme(j);return this._parsingErrors.push({message:N,offset:K,lexeme:M,additionalInfo:oe}),s._parseError}_check(m){return this._peek().type===m}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===y.TokenType.EOF}}e.Parser=s;class i{static false(){return S.INSTANCE}static true(){return L.INSTANCE}static has(m){return k.create(m)}static equals(m,j){return O.create(m,j)}static notEquals(m,j){return E.create(m,j)}static regex(m,j){return Z.create(m,j)}static in(m,j){return x.create(m,j)}static notIn(m,j){return R.create(m,j)}static not(m){return U.create(m)}static and(...m){return V.create(m,null,!0)}static or(...m){return z.create(m,null,!0)}static greater(m,j){return C.create(m,j)}static greaterEquals(m,j){return B.create(m,j)}static smaller(m,j){return Y.create(m,j)}static smallerEquals(m,j){return G.create(m,j)}static{this._parser=new s({regexParsingWithErrorRecovery:!1})}static deserialize(m){return m==null?void 0:this._parser.parse(m)}}e.ContextKeyExpr=i;function _(te){const m=new s({regexParsingWithErrorRecovery:!1});return te.map(j=>(m.parse(j),m.lexingErrors.length>0?m.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,P.localize)(11609,null,oe.additionalInfo):(0,P.localize)(11610,null),offset:oe.offset,length:oe.lexeme.length})):m.parsingErrors.length>0?m.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function A(te,m){const j=te?te.substituteConstants():void 0,oe=m?m.substituteConstants():void 0;return!j&&!oe?!0:!j||!oe?!1:j.equals(oe)}function F(te,m){return te.cmp(m)}class S{static{this.INSTANCE=new S}constructor(){this.type=f.False}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return L.INSTANCE}}e.ContextKeyFalseExpr=S;class L{static{this.INSTANCE=new L}constructor(){this.type=f.True}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=L;class k{static create(m,j=null){const oe=r.get(m);return typeof oe=="boolean"?oe?L.INSTANCE:S.INSTANCE:new k(m,j)}constructor(m,j){this.key=m,this.negated=j,this.type=f.Defined}cmp(m){return m.type!==this.type?this.type-m.type:ee(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=r.get(this.key);return typeof m=="boolean"?m?L.INSTANCE:S.INSTANCE:this}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return this.negated||(this.negated=U.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=k;class O{static create(m,j,oe=null){if(typeof j=="boolean")return j?k.create(m,oe):U.create(m,oe);const N=r.get(m);return typeof N=="boolean"?j===(N?"true":"false")?L.INSTANCE:S.INSTANCE:new O(m,j,oe)}constructor(m,j,oe){this.key=m,this.value=j,this.negated=oe,this.type=f.Equals}cmp(m){return m.type!==this.type?this.type-m.type:ue(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){const m=r.get(this.key);if(typeof m=="boolean"){const j=m?"true":"false";return this.value===j?L.INSTANCE:S.INSTANCE}return this}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=O;class x{static create(m,j){return new x(m,j)}constructor(m,j){this.key=m,this.valueKey=j,this.type=f.In,this.negated=null}cmp(m){return m.type!==this.type?this.type-m.type:ue(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}substituteConstants(){return this}evaluate(m){const j=m.getValue(this.valueKey),oe=m.getValue(this.key);return Array.isArray(j)?j.includes(oe):typeof oe=="string"&&typeof j=="object"&&j!==null?p.call(j,oe):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=R.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=x;class R{static create(m,j){return new R(m,j)}constructor(m,j){this.key=m,this.valueKey=j,this.type=f.NotIn,this._negated=x.create(m,j)}cmp(m){return m.type!==this.type?this.type-m.type:this._negated.cmp(m._negated)}equals(m){return m.type===this.type?this._negated.equals(m._negated):!1}substituteConstants(){return this}evaluate(m){return!this._negated.evaluate(m)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(m){return m.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=R;class E{static create(m,j,oe=null){if(typeof j=="boolean")return j?U.create(m,oe):k.create(m,oe);const N=r.get(m);return typeof N=="boolean"?j===(N?"true":"false")?S.INSTANCE:L.INSTANCE:new E(m,j,oe)}constructor(m,j,oe){this.key=m,this.value=j,this.negated=oe,this.type=f.NotEquals}cmp(m){return m.type!==this.type?this.type-m.type:ue(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){const m=r.get(this.key);if(typeof m=="boolean"){const j=m?"true":"false";return this.value===j?S.INSTANCE:L.INSTANCE}return this}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=O.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class U{static create(m,j=null){const oe=r.get(m);return typeof oe=="boolean"?oe?S.INSTANCE:L.INSTANCE:new U(m,j)}constructor(m,j){this.key=m,this.negated=j,this.type=f.Not}cmp(m){return m.type!==this.type?this.type-m.type:ee(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=r.get(this.key);return typeof m=="boolean"?m?S.INSTANCE:L.INSTANCE:this}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=U;function I(te,m){if(typeof te=="string"){const j=parseFloat(te);isNaN(j)||(te=j)}return typeof te=="string"||typeof te=="number"?m(te):S.INSTANCE}class C{static create(m,j,oe=null){return I(j,N=>new C(m,N,oe))}constructor(m,j,oe){this.key=m,this.value=j,this.negated=oe,this.type=f.Greater}cmp(m){return m.type!==this.type?this.type-m.type:ue(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=G.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=C;class B{static create(m,j,oe=null){return I(j,N=>new B(m,N,oe))}constructor(m,j,oe){this.key=m,this.value=j,this.negated=oe,this.type=f.GreaterEquals}cmp(m){return m.type!==this.type?this.type-m.type:ue(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Y.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=B;class Y{static create(m,j,oe=null){return I(j,N=>new Y(m,N,oe))}constructor(m,j,oe){this.key=m,this.value=j,this.negated=oe,this.type=f.Smaller}cmp(m){return m.type!==this.type?this.type-m.type:ue(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=Y;class G{static create(m,j,oe=null){return I(j,N=>new G(m,N,oe))}constructor(m,j,oe){this.key=m,this.value=j,this.negated=oe,this.type=f.SmallerEquals}cmp(m){return m.type!==this.type?this.type-m.type:ue(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}substituteConstants(){return this}evaluate(m){return typeof this.value=="string"?!1:parseFloat(m.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=G;class Z{static create(m,j){return new Z(m,j)}constructor(m,j){this.key=m,this.regexp=j,this.type=f.Regex,this.negated=null}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const j=this.regexp?this.regexp.source:"",oe=m.regexp?m.regexp.source:"";return j<oe?-1:j>oe?1:0}equals(m){if(m.type===this.type){const j=this.regexp?this.regexp.source:"",oe=m.regexp?m.regexp.source:"";return this.key===m.key&&j===oe}return!1}substituteConstants(){return this}evaluate(m){const j=m.getValue(this.key);return this.regexp?this.regexp.test(j):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=se.create(this)),this.negated}}e.ContextKeyRegexExpr=Z;class se{static create(m){return new se(m)}constructor(m){this._actual=m,this.type=f.NotRegex}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}substituteConstants(){return this}evaluate(m){return!this._actual.evaluate(m)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(m){return new se(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=se;function le(te){let m=null;for(let j=0,oe=te.length;j<oe;j++){const N=te[j].substituteConstants();if(te[j]!==N&&m===null){m=[];for(let K=0;K<j;K++)m[K]=te[K]}m!==null&&(m[j]=N)}return m===null?te:m}class V{static create(m,j,oe){return V._normalizeArr(m,j,oe)}constructor(m,j){this.expr=m,this.negated=j,this.type=f.And}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let j=0,oe=this.expr.length;j<oe;j++){const N=F(this.expr[j],m.expr[j]);if(N!==0)return N}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let j=0,oe=this.expr.length;j<oe;j++)if(!this.expr[j].equals(m.expr[j]))return!1;return!0}return!1}substituteConstants(){const m=le(this.expr);return m===this.expr?this:V.create(m,this.negated,!1)}evaluate(m){for(let j=0,oe=this.expr.length;j<oe;j++)if(!this.expr[j].evaluate(m))return!1;return!0}static _normalizeArr(m,j,oe){const N=[];let K=!1;for(const M of m)if(M){if(M.type===f.True){K=!0;continue}if(M.type===f.False)return S.INSTANCE;if(M.type===f.And){N.push(...M.expr);continue}N.push(M)}if(N.length===0&&K)return L.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(F);for(let M=1;M<N.length;M++)N[M-1].equals(N[M])&&(N.splice(M,1),M--);if(N.length===1)return N[0];for(;N.length>1;){const M=N[N.length-1];if(M.type!==f.Or)break;N.pop();const T=N.pop(),H=N.length===0,J=z.create(M.expr.map(ne=>V.create([ne,T],null,oe)),null,H);J&&(N.push(J),N.sort(F))}if(N.length===1)return N[0];if(oe){for(let M=0;M<N.length;M++)for(let T=M+1;T<N.length;T++)if(N[M].negate().equals(N[T]))return S.INSTANCE;if(N.length===1)return N[0]}return new V(N,j)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(const j of this.expr)m.push(...j.keys());return m}map(m){return new V(this.expr.map(j=>j.map(m)),null)}negate(){if(!this.negated){const m=[];for(const j of this.expr)m.push(j.negate());this.negated=z.create(m,this,!0)}return this.negated}}e.ContextKeyAndExpr=V;class z{static create(m,j,oe){return z._normalizeArr(m,j,oe)}constructor(m,j){this.expr=m,this.negated=j,this.type=f.Or}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let j=0,oe=this.expr.length;j<oe;j++){const N=F(this.expr[j],m.expr[j]);if(N!==0)return N}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let j=0,oe=this.expr.length;j<oe;j++)if(!this.expr[j].equals(m.expr[j]))return!1;return!0}return!1}substituteConstants(){const m=le(this.expr);return m===this.expr?this:z.create(m,this.negated,!1)}evaluate(m){for(let j=0,oe=this.expr.length;j<oe;j++)if(this.expr[j].evaluate(m))return!0;return!1}static _normalizeArr(m,j,oe){let N=[],K=!1;if(m){for(let M=0,T=m.length;M<T;M++){const H=m[M];if(H){if(H.type===f.False){K=!0;continue}if(H.type===f.True)return L.INSTANCE;if(H.type===f.Or){N=N.concat(H.expr);continue}N.push(H)}}if(N.length===0&&K)return S.INSTANCE;N.sort(F)}if(N.length!==0){if(N.length===1)return N[0];for(let M=1;M<N.length;M++)N[M-1].equals(N[M])&&(N.splice(M,1),M--);if(N.length===1)return N[0];if(oe){for(let M=0;M<N.length;M++)for(let T=M+1;T<N.length;T++)if(N[M].negate().equals(N[T]))return L.INSTANCE;if(N.length===1)return N[0]}return new z(N,j)}}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(const j of this.expr)m.push(...j.keys());return m}map(m){return new z(this.expr.map(j=>j.map(m)),null)}negate(){if(!this.negated){const m=[];for(const j of this.expr)m.push(j.negate());for(;m.length>1;){const j=m.shift(),oe=m.shift(),N=[];for(const K of me(j))for(const M of me(oe))N.push(V.create([K,M],null,!1));m.unshift(z.create(N,null,!1))}this.negated=z.create(m,this,!0)}return this.negated}}e.ContextKeyOrExpr=z;class Q extends k{static{this._info=[]}static all(){return Q._info.values()}constructor(m,j,oe){super(m,null),this._defaultValue=j,typeof oe=="object"?Q._info.push({...oe,key:m}):oe!==!0&&Q._info.push({key:m,description:oe,type:j!=null?typeof j:void 0})}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(m){return O.create(this.key,m)}notEqualsTo(m){return E.create(this.key,m)}}e.RawContextKey=Q,e.IContextKeyService=(0,W.createDecorator)("contextKeyService");function ee(te,m){return te<m?-1:te>m?1:0}function ue(te,m,j,oe){return te<j?-1:te>j?1:m<oe?-1:m>oe?1:0}function $(te,m){if(te.type===f.False||m.type===f.True)return!0;if(te.type===f.Or)return m.type===f.Or?ae(te.expr,m.expr):!1;if(m.type===f.Or){for(const j of m.expr)if($(te,j))return!0;return!1}if(te.type===f.And){if(m.type===f.And)return ae(m.expr,te.expr);for(const j of te.expr)if($(j,m))return!0;return!1}return te.equals(m)}function ae(te,m){let j=0,oe=0;for(;j<te.length&&oe<m.length;){const N=te[j].cmp(m[oe]);if(N<0)return!1;N===0&&j++,oe++}return j===te.length}function me(te){return te.type===f.Or?te.expr:[te]}}),define(he[73],fe([0,1,55,5,10,9,6,12,22,3,20,24]),function(ie,e,a,t,D,y,W,P,g,r,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=f,e.isFileSystemWatcher=d,e.hasReadWriteCapability=n,e.hasFileFolderCopyCapability=v,e.hasFileCloneCapability=b,e.hasOpenReadWriteCloseCapability=o,e.hasFileReadStreamCapability=s,e.hasFileAtomicReadCapability=i,e.hasFileAtomicWriteCapability=_,e.hasFileAtomicDeleteCapability=A,e.hasReadonlyCapability=F,e.createFileSystemProviderError=k,e.ensureFileSystemProviderError=O,e.markAsFileSystemProviderError=x,e.toFileSystemProviderErrorCode=R,e.toFileOperationResult=E,e.isParent=Y,e.etag=z,e.whenProviderRegistered=Q,e.getLargeFileConfirmationLimit=ue,e.IFileService=(0,g.createDecorator)("fileService");function f($){return $.create===!0}var c;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var l;(function($){$[$.Readonly=1]="Readonly",$[$.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var h;(function($){$[$.UPDATED=2]="UPDATED",$[$.ADDED=4]="ADDED",$[$.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function d($){const ae=$;return!!ae&&typeof ae.onDidChange=="function"}var u;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileAtomicWrite=32768]="FileAtomicWrite",$[$.FileAtomicDelete=65536]="FileAtomicDelete",$[$.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function n($){return!!($.capabilities&u.FileReadWrite)}function v($){return!!($.capabilities&u.FileFolderCopy)}function b($){return!!($.capabilities&u.FileClone)}function o($){return!!($.capabilities&u.FileOpenReadWriteClose)}function s($){return!!($.capabilities&u.FileReadStream)}function i($){return n($)?!!($.capabilities&u.FileAtomicRead):!1}function _($){return n($)?!!($.capabilities&u.FileAtomicWrite):!1}function A($){return!!($.capabilities&u.FileAtomicDelete)}function F($){return!!($.capabilities&u.Readonly)}var S;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsStorageQuota="EntryExceedsStorageQuota",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class L extends Error{static create(ae,me){const te=new L(ae.toString(),me);return x(te,me),te}constructor(ae,me){super(ae),this.code=me}}e.FileSystemProviderError=L;function k($,ae){return L.create($,ae)}function O($){return $||k((0,P.localize)(11386,null),S.Unknown)}function x($,ae){return $.name=ae?`${ae} (FileSystemError)`:"FileSystemError",$}function R($){if(!$)return S.Unknown;if($ instanceof L)return $.code;const ae=/^(.+) \(FileSystemError\)$/.exec($.name);if(!ae)return S.Unknown;switch(ae[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function E($){if($ instanceof G)return $.fileOperationResult;switch(R($)){case S.FileNotFound:return le.FILE_NOT_FOUND;case S.FileIsADirectory:return le.FILE_IS_DIRECTORY;case S.FileNotADirectory:return le.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return le.FILE_WRITE_LOCKED;case S.NoPermissions:return le.FILE_PERMISSION_DENIED;case S.FileExists:return le.FILE_MOVE_CONFLICT;case S.FileTooLarge:return le.FILE_TOO_LARGE;default:return le.FILE_OTHER_ERROR}}var U;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(U||(e.FileOperation=U={}));class I{constructor(ae,me,te){this.resource=ae,this.operation=me,this.target=te}isOperation(ae){return this.operation===ae}}e.FileOperationEvent=I;var C;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(C||(e.FileChangeType=C={}));class B{static{this.MIXED_CORRELATION=null}constructor(ae,me){this.ignorePathCasing=me,this.correlationId=void 0,this.added=new p.Lazy(()=>{const te=a.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawAdded.map(m=>[m,!0])),te}),this.updated=new p.Lazy(()=>{const te=a.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawUpdated.map(m=>[m,!0])),te}),this.deleted=new p.Lazy(()=>{const te=a.TernarySearchTree.forUris(()=>this.ignorePathCasing);return te.fill(this.rawDeleted.map(m=>[m,!0])),te}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const te of ae){switch(te.type){case C.ADDED:this.rawAdded.push(te.resource);break;case C.UPDATED:this.rawUpdated.push(te.resource);break;case C.DELETED:this.rawDeleted.push(te.resource);break}this.correlationId!==B.MIXED_CORRELATION&&(typeof te.cId=="number"?this.correlationId===void 0?this.correlationId=te.cId:this.correlationId!==te.cId&&(this.correlationId=B.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=B.MIXED_CORRELATION))}}contains(ae,...me){return this.doContains(ae,{includeChildren:!1},...me)}affects(ae,...me){return this.doContains(ae,{includeChildren:!0},...me)}doContains(ae,me,...te){if(!ae)return!1;const m=te.length>0;return!!((!m||te.includes(C.ADDED))&&(this.added.value.get(ae)||me.includeChildren&&this.added.value.findSuperstr(ae))||(!m||te.includes(C.UPDATED))&&(this.updated.value.get(ae)||me.includeChildren&&this.updated.value.findSuperstr(ae))||(!m||te.includes(C.DELETED))&&(this.deleted.value.findSubstr(ae)||me.includeChildren&&this.deleted.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.correlationId===ae}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=B;function Y($,ae,me){return!$||!ae||$===ae||ae.length>$.length?!1:(ae.charAt(ae.length-1)!==t.sep&&(ae+=t.sep),me?(0,D.startsWithIgnoreCase)($,ae):$.indexOf(ae)===0)}class G extends Error{constructor(ae,me,te){super(ae),this.fileOperationResult=me,this.options=te}}e.FileOperationError=G;class Z extends G{constructor(ae,me,te,m){super(ae,me,m),this.fileOperationResult=me,this.size=te}}e.TooLargeFileOperationError=Z;class se extends G{constructor(ae,me,te){super(ae,le.FILE_NOT_MODIFIED_SINCE,te),this.stat=me}}e.NotModifiedSinceFileOperationError=se;var le;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(le||(e.FileOperationResult=le={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var V;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.ETAG_DISABLED="";function z($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}async function Q($,ae){if(!ae.hasProvider(W.URI.from({scheme:$.scheme})))return new Promise(me=>{const te=ae.onDidChangeFileSystemProviderRegistrations(m=>{m.scheme===$.scheme&&m.added&&(te.dispose(),me())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ae){return(0,y.isNumber)(ae)||(ae=0),ae<ee.KB?(0,P.localize)(11387,null,ae.toFixed(0)):ae<ee.MB?(0,P.localize)(11388,null,(ae/ee.KB).toFixed(2)):ae<ee.GB?(0,P.localize)(11389,null,(ae/ee.MB).toFixed(2)):ae<ee.TB?(0,P.localize)(11390,null,(ae/ee.GB).toFixed(2)):(0,P.localize)(11391,null,(ae/ee.TB).toFixed(2))}}e.ByteSize=ee;function ue($){const ae=typeof $=="string"||$?.scheme===w.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===w.Schemas.file?1024*ee.MB:ae?10*ee.MB:r.isWeb?50*ee.MB:1024*ee.MB}}),define(he[8],fe([0,1,12,66,4,54,2,26,3,25,9,6,38,22]),function(ie,e,a,t,D,y,W,P,g,r,w,p,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=h,e.log=u,e.getLogLevel=L,e.LogLevelToString=k,e.LogLevelToLocalizedString=O,e.parseLogLevel=x,a=De(a),e.ILogService=(0,c.createDecorator)("logService"),e.ILoggerService=(0,c.createDecorator)("loggerService");function l(){return new Date().toISOString()}function h(R){return(0,w.isNumber)(R)}var d;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(d||(e.LogLevel=d={})),e.DEFAULT_LOG_LEVEL=d.Info;function u(R,E,U){switch(E){case d.Trace:R.trace(U);break;case d.Debug:R.debug(U);break;case d.Info:R.info(U);break;case d.Warning:R.warn(U);break;case d.Error:R.error(U);break;case d.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function n(R,E=!1){let U="";for(let I=0;I<R.length;I++){let C=R[I];if(C instanceof Error&&(C=(0,t.toErrorMessage)(C,E)),typeof C=="object")try{C=JSON.stringify(C)}catch{}U+=(I>0?" ":"")+C}return U}class v extends W.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(E){this.level!==E&&(this.level=E,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(E){return this.level!==d.Off&&this.level<=E}}e.AbstractLogger=v;class b extends v{constructor(E){super(),this.logAlways=E}checkLogLevel(E){return this.logAlways||super.checkLogLevel(E)}trace(E,...U){this.checkLogLevel(d.Trace)&&this.log(d.Trace,n([E,...U],!0))}debug(E,...U){this.checkLogLevel(d.Debug)&&this.log(d.Debug,n([E,...U]))}info(E,...U){this.checkLogLevel(d.Info)&&this.log(d.Info,n([E,...U]))}warn(E,...U){this.checkLogLevel(d.Warning)&&this.log(d.Warning,n([E,...U]))}error(E,...U){if(this.checkLogLevel(d.Error))if(E instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=E.stack,this.log(d.Error,n(I))}else this.log(d.Error,n([E,...U]))}flush(){}}e.AbstractMessageLogger=b;class o extends v{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.useColors=!g.isWindows}trace(E,...U){this.checkLogLevel(d.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...U):console.log(`[main ${l()}]`,E,...U))}debug(E,...U){this.checkLogLevel(d.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...U):console.log(`[main ${l()}]`,E,...U))}info(E,...U){this.checkLogLevel(d.Info)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...U):console.log(`[main ${l()}]`,E,...U))}warn(E,...U){this.checkLogLevel(d.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,E,...U):console.warn(`[main ${l()}]`,E,...U))}error(E,...U){this.checkLogLevel(d.Error)&&(this.useColors?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,E,...U):console.error(`[main ${l()}]`,E,...U))}flush(){}}e.ConsoleMainLogger=o;class s extends v{constructor(E=e.DEFAULT_LOG_LEVEL,U=!0){super(),this.useColors=U,this.setLevel(E)}trace(E,...U){this.checkLogLevel(d.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",E,...U):console.log(E,...U))}debug(E,...U){this.checkLogLevel(d.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",E,...U):console.log(E,...U))}info(E,...U){this.checkLogLevel(d.Info)&&(this.useColors?console.log("%c INFO","color: #33f",E,...U):console.log(E,...U))}warn(E,...U){this.checkLogLevel(d.Warning)&&(this.useColors?console.log("%c WARN","color: #993",E,...U):console.log(E,...U))}error(E,...U){this.checkLogLevel(d.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",E,...U):console.error(E,...U))}flush(){}}e.ConsoleLogger=s;class i extends v{constructor(E,U=e.DEFAULT_LOG_LEVEL){super(),this.adapter=E,this.setLevel(U)}trace(E,...U){this.checkLogLevel(d.Trace)&&this.adapter.log(d.Trace,[this.extractMessage(E),...U])}debug(E,...U){this.checkLogLevel(d.Debug)&&this.adapter.log(d.Debug,[this.extractMessage(E),...U])}info(E,...U){this.checkLogLevel(d.Info)&&this.adapter.log(d.Info,[this.extractMessage(E),...U])}warn(E,...U){this.checkLogLevel(d.Warning)&&this.adapter.log(d.Warning,[this.extractMessage(E),...U])}error(E,...U){this.checkLogLevel(d.Error)&&this.adapter.log(d.Error,[this.extractMessage(E),...U])}extractMessage(E){return typeof E=="string"?E:(0,t.toErrorMessage)(E,this.checkLogLevel(d.Trace))}flush(){}}e.AdapterLogger=i;class _ extends v{constructor(E){super(),this.loggers=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const U of this.loggers)U.setLevel(E);super.setLevel(E)}trace(E,...U){for(const I of this.loggers)I.trace(E,...U)}debug(E,...U){for(const I of this.loggers)I.debug(E,...U)}info(E,...U){for(const I of this.loggers)I.info(E,...U)}warn(E,...U){for(const I of this.loggers)I.warn(E,...U)}error(E,...U){for(const I of this.loggers)I.error(E,...U)}flush(){for(const E of this.loggers)E.flush()}dispose(){for(const E of this.loggers)E.dispose();super.dispose()}}e.MultiplexLogger=_;class A extends W.Disposable{constructor(E,U,I){if(super(),this.logLevel=E,this.logsHome=U,this._loggers=new P.ResourceMap,this._onDidChangeLoggers=this._register(new D.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,I)for(const C of I)this._loggers.set(C.resource,{logger:void 0,info:C})}getLoggerEntry(E){return(0,w.isString)(E)?[...this._loggers.values()].find(U=>U.info.id===E):this._loggers.get(E)}getLogger(E){return this.getLoggerEntry(E)?.logger}createLogger(E,U){const I=this.toResource(E),C=(0,w.isString)(E)?E:U?.id??(0,y.hash)(I.toString()).toString(16);let B=this._loggers.get(I)?.logger;const Y=U?.logLevel==="always"?d.Trace:U?.logLevel;B||(B=this.doCreateLogger(I,Y??this.getLogLevel(I)??this.logLevel,{...U,id:C}));const G={logger:B,info:{resource:I,id:C,logLevel:Y,name:U?.name,hidden:U?.hidden,extensionId:U?.extensionId,when:U?.when}};return this.registerLogger(G.info),this._loggers.set(I,G),B}toResource(E){return(0,w.isString)(E)?(0,r.joinPath)(this.logsHome,`${E}.log`):E}setLogLevel(E,U){if(p.URI.isUri(E)){const I=E,C=U,B=this._loggers.get(I);B&&C!==B.info.logLevel&&(B.info.logLevel=C===this.logLevel?void 0:C,B.logger?.setLevel(C),this._loggers.set(B.info.resource,B),this._onDidChangeLogLevel.fire([I,C]))}else{this.logLevel=E;for(const[I,C]of this._loggers.entries())this._loggers.get(I)?.info.logLevel===void 0&&C.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(E,U){const I=this.getLoggerEntry(E);I&&U!==!I.info.hidden&&(I.info.hidden=!U,this._loggers.set(I.info.resource,I),this._onDidChangeVisibility.fire([I.info.resource,U]))}getLogLevel(E){let U;return E&&(U=this._loggers.get(E)?.info.logLevel),U??this.logLevel}registerLogger(E){const U=this._loggers.get(E.resource);U?U.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this._loggers.set(E.resource,{info:E,logger:void 0}),this._onDidChangeLoggers.fire({added:[E],removed:[]}))}deregisterLogger(E){const U=this._loggers.get(E);U&&(U.logger&&U.logger.dispose(),this._loggers.delete(E),this._onDidChangeLoggers.fire({added:[],removed:[U.info]}))}*getRegisteredLoggers(){for(const E of this._loggers.values())yield E.info}getRegisteredLogger(E){return this._loggers.get(E)?.info}dispose(){this._loggers.forEach(E=>E.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=A;class F{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(E){}getLevel(){return d.Info}trace(E,...U){}debug(E,...U){}info(E,...U){}warn(E,...U){}error(E,...U){}critical(E,...U){}dispose(){}flush(){}}e.NullLogger=F;class S extends F{}e.NullLogService=S;function L(R){if(R.verbose)return d.Trace;if(typeof R.logLevel=="string"){const E=x(R.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}function k(R){switch(R){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function O(R){switch(R){case d.Trace:return{original:"Trace",value:a.localize(11319,null)};case d.Debug:return{original:"Debug",value:a.localize(11320,null)};case d.Info:return{original:"Info",value:a.localize(11321,null)};case d.Warning:return{original:"Warning",value:a.localize(11322,null)};case d.Error:return{original:"Error",value:a.localize(11323,null)};case d.Off:return{original:"Off",value:a.localize(11324,null)}}}function x(R){switch(R){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.CONTEXT_LOG_LEVEL=new f.RawContextKey("logLevel",k(d.Info))}),define(he[74],fe([0,1,6,4,8,2]),function(ie,e,a,t,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class W extends D.AbstractLoggerService{constructor(p,f,c,l,h){super(f,c,l),this.windowId=p,this.channel=h,this._register(h.listen("onDidChangeLogLevel",p)(d=>{(0,D.isLogLevel)(d)?super.setLogLevel(d):super.setLogLevel(a.URI.revive(d[0]),d[1])})),this._register(h.listen("onDidChangeVisibility",p)(([d,u])=>super.setVisibility(a.URI.revive(d),u))),this._register(h.listen("onDidChangeLoggers",p)(({added:d,removed:u})=>{for(const n of d)super.registerLogger({...n,resource:a.URI.revive(n.resource)});for(const n of u)super.deregisterLogger(n.resource)}))}createConsoleMainLogger(){return new D.AdapterLogger({log:(p,f)=>{this.channel.call("consoleLog",[p,f])}})}registerLogger(p){super.registerLogger(p),this.channel.call("registerLogger",[p,this.windowId])}deregisterLogger(p){super.deregisterLogger(p),this.channel.call("deregisterLogger",[p,this.windowId])}setLogLevel(p,f){super.setLogLevel(p,f),this.channel.call("setLogLevel",[p,f])}setVisibility(p,f){super.setVisibility(p,f),this.channel.call("setVisibility",[this.toResource(p),f])}doCreateLogger(p,f,c){return new P(this.channel,p,f,c,this.windowId)}static setLogLevel(p,f,c){return p.call("setLogLevel",[f,c])}}e.LoggerChannelClient=W;class P extends D.AbstractMessageLogger{constructor(p,f,c,l,h){super(l?.logLevel==="always"),this.channel=p,this.file=f,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[f,l,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,f){const c=[[p,f]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(p){this.channel.call("log",[this.file,p])}}class g{constructor(p,f){this.loggerService=p,this.getUriTransformer=f}listen(p,f){const c=this.getUriTransformer(p);switch(f){case"onDidChangeLoggers":return t.Event.map(this.loggerService.onDidChangeLoggers,l=>({added:[...l.added].map(h=>this.transformLogger(h,c)),removed:[...l.removed].map(h=>this.transformLogger(h,c))}));case"onDidChangeVisibility":return t.Event.map(this.loggerService.onDidChangeVisibility,l=>[c.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return t.Event.map(this.loggerService.onDidChangeLogLevel,l=>(0,D.isLogLevel)(l)?l:[c.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${f}`)}async call(p,f,c){const l=this.getUriTransformer(p);switch(f){case"setLogLevel":return(0,D.isLogLevel)(c[0])?this.loggerService.setLogLevel(c[0]):this.loggerService.setLogLevel(a.URI.revive(l.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(h=>this.transformLogger(h,l)))}throw new Error(`Call not found: ${f}`)}transformLogger(p,f){return{...p,resource:f.transformOutgoingURI(p.resource)}}}e.LoggerChannel=g;class r extends y.Disposable{constructor(p,f){super(),f.call("setLogLevel",[p.getLogLevel()]),this._register(p.onDidChangeLogLevel(c=>f.call("setLogLevel",[c]))),f.call("getRegisteredLoggers").then(c=>{for(const l of c)p.registerLogger({...l,resource:a.URI.revive(l.resource)})}),this._register(f.listen("onDidChangeVisibility")(([c,l])=>p.setVisibility(a.URI.revive(c),l))),this._register(f.listen("onDidChangeLoggers")(({added:c,removed:l})=>{for(const h of c)p.registerLogger({...h,resource:a.URI.revive(h.resource)});for(const h of l)p.deregisterLogger(h.resource)}))}}e.RemoteLoggerChannelClient=r}),define(he[75],fe([0,1,2,8]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends a.Disposable{constructor(W,P=[]){super(),this.logger=new t.MultiplexLogger([W,...P]),this._register(W.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(W){this.logger.setLevel(W)}getLevel(){return this.logger.getLevel()}trace(W,...P){this.logger.trace(W,...P)}debug(W,...P){this.logger.debug(W,...P)}info(W,...P){this.logger.info(W,...P)}warn(W,...P){this.logger.warn(W,...P)}error(W,...P){this.logger.error(W,...P)}flush(){this.logger.flush()}}e.LogService=D}),define(he[76],fe([0,1,73,8]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var D;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(D||(D={}));async function y(r,w,p,f,c){try{const l=await new Promise((d,u)=>{ie(["@vscode/spdlog"],d,u)}).then(De);l.setFlushOn(D.Trace);const h=await l.createAsyncRotatingLogger(r,w,p,f);return c?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(l){console.error(l)}return null}function W(r,w,p){switch(w){case t.LogLevel.Trace:r.trace(p);break;case t.LogLevel.Debug:r.debug(p);break;case t.LogLevel.Info:r.info(p);break;case t.LogLevel.Warning:r.warn(p);break;case t.LogLevel.Error:r.error(p);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function P(r,w){switch(w){case t.LogLevel.Trace:r.setLevel(D.Trace);break;case t.LogLevel.Debug:r.setLevel(D.Debug);break;case t.LogLevel.Info:r.setLevel(D.Info);break;case t.LogLevel.Warning:r.setLevel(D.Warning);break;case t.LogLevel.Error:r.setLevel(D.Error);break;case t.LogLevel.Off:r.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class g extends t.AbstractMessageLogger{constructor(w,p,f,c,l){super(),this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(w,p,f,c),this._register(this.onDidChangeLogLevel(h=>{this._logger&&P(this._logger,h)}))}async _createSpdLogLogger(w,p,f,c){const l=f?6:1,h=30/l*a.ByteSize.MB,d=await y(w,p,h,l,c);if(d){this._logger=d,P(this._logger,this.getLevel());for(const{level:u,message:n}of this.buffer)W(this._logger,u,n);this.buffer=[]}}log(w,p){this._logger?W(this._logger,w,p):this.getLevel()<=w&&this.buffer.push({level:w,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=g}),define(he[77],fe([0,1,59,8,76]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class y extends t.AbstractLoggerService{doCreateLogger(P,g,r){return new D.SpdLogLogger((0,a.generateUuid)(),P.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,g)}}e.LoggerService=y}),define(he[78],fe([0,1,15]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let t;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.context<"u"){const y=D.context.configuration();if(y)t=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){t=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:y,searchUrl:W,itemUrl:P,controlUrl:g}=t.extensionsGallery||{};Object.assign(t,{extensionsGallery:{serviceUrl:a.env.VSCODE_GALLERY_SERVICE_URL||y,searchUrl:a.env.VSCODE_GALLERY_SEARCH_URL||W,itemUrl:a.env.VSCODE_GALLERY_ITEM_URL||P,controlUrl:a.env.VSCODE_GALLERY_CONTROL_URL||g}});try{const r=(...p)=>p.reduce((f,c)=>(Object.keys(c).forEach(l=>{Array.isArray(f[l])&&Array.isArray(c[l])?f[l]=c[l]:typeof f[l]=="object"&&typeof c[l]=="object"?f[l]=r(f[l],c[l]):f[l]=c[l]}),f),{}),w=globalThis._VSCODE_USER_PRODUCT_JSON||{};t=r(t,w)}catch{}if(a.env.VSCODE_DEV&&Object.assign(t,{nameShort:`${t.nameShort} Dev`,nameLong:`${t.nameLong} Dev`,dataFolderName:`${t.dataFolderName}-dev`,serverDataFolderName:t.serverDataFolderName?`${t.serverDataFolderName}-dev`:void 0}),!t.version){const r=globalThis._VSCODE_PACKAGE_JSON;Object.assign(t,{version:r.version,release:r.release})}}else t={},Object.keys(t).length===0&&Object.assign(t,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=t}),define(he[79],fe([0,1,22]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(he[80],fe([0,1,45,9]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,a=De(a),t=De(t);class D{constructor(){this.data=new Map}add(W,P){a.ok(t.isString(W)),a.ok(t.isObject(P)),a.ok(!this.data.has(W),"There is already an extension with this id"),this.data.set(W,P)}knows(W){return this.data.has(W)}as(W){return this.data.get(W)||null}}e.Registry=new D}),define(he[23],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandInvalidationReason=e.TerminalCapability=void 0;var a;(function(D){D[D.CwdDetection=0]="CwdDetection",D[D.NaiveCwdDetection=1]="NaiveCwdDetection",D[D.CommandDetection=2]="CommandDetection",D[D.PartialCommandDetection=3]="PartialCommandDetection",D[D.BufferMarkDetection=4]="BufferMarkDetection"})(a||(e.TerminalCapability=a={}));var t;(function(D){D.Windows="windows",D.NoProblemsReported="noProblemsReported"})(t||(e.CommandInvalidationReason=t={}))}),define(he[81],fe([0,1,4,2,23]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferMarkCapability=void 0;class y extends t.Disposable{constructor(P){super(),this._terminal=P,this.type=D.TerminalCapability.BufferMarkDetection,this._idToMarkerMap=new Map,this._anonymousMarkers=new Map,this._onMarkAdded=this._register(new a.Emitter),this.onMarkAdded=this._onMarkAdded.event}*markers(){for(const P of this._idToMarkerMap.values())yield P;for(const P of this._anonymousMarkers.values())yield P}addMark(P){const g=P?.marker||this._terminal.registerMarker(),r=P?.id;g&&(r?(this._idToMarkerMap.set(r,g),g.onDispose(()=>this._idToMarkerMap.delete(r))):(this._anonymousMarkers.set(g.id,g),g.onDispose(()=>this._anonymousMarkers.delete(g.id))),this._onMarkAdded.fire({marker:g,id:r,hidden:P?.hidden,hoverMessage:P?.hoverMessage}))}getMark(P){return this._idToMarkerMap.get(P)}}e.BufferMarkCapability=y});var We=this&&this.__param||function(ie,e){return function(a,t){e(a,t,ie)}};define(he[82],fe([0,1,4,2,8,14]),function(ie,e,a,t,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PromptInputModel=void 0;var W;(function(g){g[g.Unknown=0]="Unknown",g[g.Input=1]="Input",g[g.Execute=2]="Execute"})(W||(W={}));let P=class extends t.Disposable{get value(){return this._value}get cursorIndex(){return this._cursorIndex}get ghostTextIndex(){return this._ghostTextIndex}constructor(r,w,p,f){super(),this._xterm=r,this._logService=f,this._state=W.Unknown,this._commandStartX=0,this._lastUserInput="",this._value="",this._cursorIndex=0,this._ghostTextIndex=-1,this._onDidStartInput=this._register(new a.Emitter),this.onDidStartInput=this._onDidStartInput.event,this._onDidChangeInput=this._register(new a.Emitter),this.onDidChangeInput=this._onDidChangeInput.event,this._onDidFinishInput=this._register(new a.Emitter),this.onDidFinishInput=this._onDidFinishInput.event,this._onDidInterrupt=this._register(new a.Emitter),this.onDidInterrupt=this._onDidInterrupt.event,this._register(a.Event.any(this._xterm.onCursorMove,this._xterm.onData,this._xterm.onWriteParsed)(()=>this._sync())),this._register(this._xterm.onData(c=>this._handleUserInput(c))),this._register(w(c=>this._handleCommandStart(c))),this._register(p(()=>this._handleCommandExecuted())),this._register(this.onDidStartInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidStartInput"))),this._register(this.onDidChangeInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidChangeInput"))),this._register(this.onDidFinishInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidFinishInput"))),this._register(this.onDidInterrupt(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidInterrupt")))}_logCombinedStringIfTrace(r){this._logService.getLevel()===D.LogLevel.Trace&&this._logService.trace(r,this.getCombinedString())}setContinuationPrompt(r){this._continuationPrompt=r,this._sync()}setLastPromptLine(r){this._lastPromptLine=r,this._sync()}setConfidentCommandLine(r){this._value!==r&&(this._value=r,this._cursorIndex=-1,this._ghostTextIndex=-1,this._onDidChangeInput.fire(this._createStateObject()))}getCombinedString(){const r=this._value.replaceAll(`
`,"\u23CE");if(this._cursorIndex===-1)return r;let w=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(w+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,w+=`${r.substring(this.ghostTextIndex)}]`):w+=r.substring(this.cursorIndex),w}serialize(){return{modelState:this._createStateObject(),commandStartX:this._commandStartX,lastPromptLine:this._lastPromptLine,continuationPrompt:this._continuationPrompt,lastUserInput:this._lastUserInput}}deserialize(r){this._value=r.modelState.value,this._cursorIndex=r.modelState.cursorIndex,this._ghostTextIndex=r.modelState.ghostTextIndex,this._commandStartX=r.commandStartX,this._lastPromptLine=r.lastPromptLine,this._continuationPrompt=r.continuationPrompt,this._lastUserInput=r.lastUserInput}_handleCommandStart(r){this._state!==W.Input&&(this._state=W.Input,this._commandStartMarker=r.marker,this._commandStartX=this._xterm.buffer.active.cursorX,this._value="",this._cursorIndex=0,this._onDidStartInput.fire(this._createStateObject()),this._onDidChangeInput.fire(this._createStateObject()),this._lastPromptLine&&this._commandStartX!==this._lastPromptLine.length&&this._xterm.buffer.active.getLine(this._commandStartMarker.line)?.translateToString(!0).startsWith(this._lastPromptLine)&&(this._commandStartX=this._lastPromptLine.length,this._sync()))}_handleCommandExecuted(){if(this._state===W.Execute)return;this._cursorIndex=-1,this._ghostTextIndex!==-1&&(this._value=this._value.substring(0,this._ghostTextIndex),this._ghostTextIndex=-1);const r=this._createStateObject();this._lastUserInput===""&&(this._lastUserInput="",this._onDidInterrupt.fire(r)),this._state=W.Execute,this._onDidFinishInput.fire(r),this._onDidChangeInput.fire(r)}_sync(){try{this._doSync()}catch(r){this._logService.error("Error while syncing prompt input model",r)}}_doSync(){if(this._state!==W.Input)return;const r=this._commandStartMarker?.line;if(r===void 0)return;const w=this._xterm.buffer.active;let p=w.getLine(r);const f=p?.translateToString(!0,this._commandStartX);if(!p||f===void 0){this._logService.trace("PromptInputModel#_sync: no line");return}const c=w.baseY+w.cursorY;let l=f,h=-1,d;c===r?d=this._getRelativeCursorIndex(this._commandStartX,w,p):d=f.trimEnd().length,c===r&&w.cursorX>1&&(h=this._scanForGhostText(w,p,d));for(let u=r+1;u<=c;u++){p=w.getLine(u);const n=p?.translateToString(!0);if(n&&p)if(p.isWrapped){l+=n;const v=this._getRelativeCursorIndex(0,w,p);c===u?d+=v:d+=n.length}else if(this._continuationPrompt===void 0||this._lineContainsContinuationPrompt(n)){const v=this._trimContinuationPrompt(n);if(l+=`
${v}`,c===u){const b=this._getContinuationPromptCellWidth(p,n),o=this._getRelativeCursorIndex(b,w,p);d+=o+1}else d+=v.length+1}else break}for(let u=c+1;u<w.baseY+this._xterm.rows;u++){p=w.getLine(u);const n=p?.translateToString(!0);if(n&&p)if(this._continuationPrompt===void 0||this._lineContainsContinuationPrompt(n))l+=`
${this._trimContinuationPrompt(n)}`;else break;else break}this._logService.getLevel()===D.LogLevel.Trace&&this._logService.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`);{let u=this._value.length-this._value.trimEnd().length;this._lastUserInput==="\x7F"&&(this._lastUserInput="",d===this._cursorIndex-1&&(this._value.trimEnd().length>l.trimEnd().length&&l.trimEnd().length<=d?u=Math.max(this._value.length-1-l.trimEnd().length,0):u=Math.max(u-1,0))),this._lastUserInput==="\x1B[3~"&&(this._lastUserInput="",d===this._cursorIndex&&(u=Math.max(u-1,0)));const n=l.split(`
`),v=n.length>1,b=l.trimEnd();if(!v){b.length<l.length&&(this._lastUserInput===" "&&(this._lastUserInput="",d>b.length&&d>this._cursorIndex&&u++),u=Math.max(d-b.length,u,0));const o=d===0?"":l[d-1];u>0&&d===this._cursorIndex+1&&this._lastUserInput!==""&&o!==" "&&(u=this._value.length-this._cursorIndex)}if(v){n[n.length-1]=n.at(-1)?.trimEnd()??"";const o=(n.length-1)*(this._continuationPrompt?.length??0);u=Math.max(0,d-l.length-o)}l=n.map(o=>o.trimEnd()).join(`
`)+" ".repeat(u)}(this._value!==l||this._cursorIndex!==d||this._ghostTextIndex!==h)&&(this._value=l,this._cursorIndex=d,this._ghostTextIndex=h,this._onDidChangeInput.fire(this._createStateObject()))}_handleUserInput(r){this._lastUserInput=r}_scanForGhostText(r,w,p){let f=-1,c=!1,l=r.cursorX;for(;l>0;){const h=w.getCell(--l);if(!h)break;if(h.getChars().trim().length>0){c=!this._isCellStyledLikeGhostText(h);break}}if(c){let h=0,d=r.cursorX;for(;d<w.length;){const u=w.getCell(d++);if(!u||u.getCode()===0)break;if(this._isCellStyledLikeGhostText(u)){f=p+h;break}h+=u.getChars().length}}return f}_trimContinuationPrompt(r){return this._lineContainsContinuationPrompt(r)&&(r=r.substring(this._continuationPrompt.length)),r}_lineContainsContinuationPrompt(r){return!!(this._continuationPrompt&&r.startsWith(this._continuationPrompt))}_getContinuationPromptCellWidth(r,w){if(!this._continuationPrompt||!w.startsWith(this._continuationPrompt))return 0;let p="",f=0;for(;p!==this._continuationPrompt;)p+=r.getCell(f++).getChars();return f}_getRelativeCursorIndex(r,w,p){return p?.translateToString(!0,r,w.cursorX).length??0}_isCellStyledLikeGhostText(r){return!!(r.isItalic()||r.isDim())}_createStateObject(){return Object.freeze({value:this._value,cursorIndex:this._cursorIndex,ghostTextIndex:this._ghostTextIndex})}};e.PromptInputModel=P,_e([(0,y.throttle)(0)],P.prototype,"_sync",null),e.PromptInputModel=P=_e([We(3,D.ILogService)],P)}),define(he[83],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialTerminalCommand=e.TerminalCommand=void 0;class a{get command(){return this._properties.command}get commandLineConfidence(){return this._properties.commandLineConfidence}get isTrusted(){return this._properties.isTrusted}get timestamp(){return this._properties.timestamp}get duration(){return this._properties.duration}get promptStartMarker(){return this._properties.promptStartMarker}get marker(){return this._properties.marker}get endMarker(){return this._properties.endMarker}set endMarker(w){this._properties.endMarker=w}get executedMarker(){return this._properties.executedMarker}get aliases(){return this._properties.aliases}get wasReplayed(){return this._properties.wasReplayed}get cwd(){return this._properties.cwd}get exitCode(){return this._properties.exitCode}get commandStartLineContent(){return this._properties.commandStartLineContent}get markProperties(){return this._properties.markProperties}get executedX(){return this._properties.executedX}get startX(){return this._properties.startX}constructor(w,p){this._xterm=w,this._properties=p}static deserialize(w,p,f){const c=w.buffer.normal,l=p.startLine!==void 0?w.registerMarker(p.startLine-(c.baseY+c.cursorY)):void 0;if(!l)return;const h=p.promptStartLine!==void 0?w.registerMarker(p.promptStartLine-(c.baseY+c.cursorY)):void 0,d=p.endLine!==void 0?w.registerMarker(p.endLine-(c.baseY+c.cursorY)):void 0,u=p.executedLine!==void 0?w.registerMarker(p.executedLine-(c.baseY+c.cursorY)):void 0;return new a(w,{command:f?"":p.command,commandLineConfidence:p.commandLineConfidence??"low",isTrusted:p.isTrusted,promptStartMarker:h,marker:l,startX:p.startX,endMarker:d,executedMarker:u,executedX:p.executedX,timestamp:p.timestamp,duration:p.duration,cwd:p.cwd,commandStartLineContent:p.commandStartLineContent,exitCode:p.exitCode,markProperties:p.markProperties,aliases:void 0,wasReplayed:!0})}serialize(w){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:w?"":this.command,commandLineConfidence:w?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return D(this._xterm.buffer.active,this._xterm.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const w=this.executedMarker.line,p=this.endMarker.line;if(w===p)return;let f="",c;for(let l=w;l<p;l++)c=this._xterm.buffer.active.getLine(l),c&&(f+=c.translateToString(!c.isWrapped)+(c.isWrapped?"":`
`));return f===""?void 0:f}getOutputMatch(w){if(!this.executedMarker||!this.endMarker)return;const p=this.endMarker.line;if(p===-1)return;const f=this._xterm.buffer.active,c=Math.max(this.executedMarker.line,0),l=w.lineMatcher,h=typeof l=="string"?1:w.length||W(l),d=[];let u;if(w.anchor==="bottom")for(let n=p-(w.offset||0);n>=c;n--){let v=n;const b=n;for(;v>=c&&f.getLine(v)?.isWrapped;)v--;if(n=v,d.unshift(y(f,v,b,this._xterm.cols)),u||(u=d[0].match(l)),d.length>=h)break}else for(let n=c+(w.offset||0);n<p;n++){const v=n;let b=n;for(;b+1<p&&f.getLine(b+1)?.isWrapped;)b++;if(n=b,d.push(y(f,v,b,this._xterm.cols)),u||(u=d[d.length-1].match(l)),d.length>=h)break}return u?{regexMatch:u,outputLines:d}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return P(this,this._xterm.buffer.active)}getCommandRowCount(){return g(this)}}e.TerminalCommand=a;class t{constructor(w){this._xterm=w}serialize(w){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:w,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(w,p,f,c){if(p===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||f)return new a(this._xterm,{command:f?"":this.command||"",commandLineConfidence:f?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.commandDuration||0,cwd:w,exitCode:p,commandStartLineContent:this.commandStartLineContent,markProperties:c})}markExecutedTime(){this.commandExecutedTimestamp===void 0&&(this.commandExecutedTimestamp=Date.now())}markFinishedTime(){this.commandDuration===void 0&&this.commandExecutedTimestamp!==void 0&&(this.commandDuration=Date.now()-this.commandExecutedTimestamp)}extractCommandLine(){return D(this._xterm.buffer.active,this._xterm.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return P(this,this._xterm.buffer.active)}getCommandRowCount(){return g(this)}}e.PartialTerminalCommand=t;function D(r,w,p,f,c,l){if(!p||!c||f===void 0||l===void 0)return"";let h="";for(let d=p.line;d<=c.line;d++){const u=r.getLine(d);u&&(h+=u.translateToString(!0,d===p.line?f:0,d===c.line?l:w))}return h}function y(r,w,p,f){const c=Math.max(2048/f*2);p=Math.min(p,w+c);let l="";for(let h=w;h<=p;h++){const d=r.getLine(h);d&&(l+=d.translateToString(!0,0,f))}return l}function W(r){if(!r.multiline)return 1;const w=r.source;let p=1,f=w.indexOf("\\n");for(;f!==-1;)p++,f=w.indexOf("\\n",f+1);return p}function P(r,w){const p="hasOutput"in r?r.marker:r.commandStartMarker;if(!p||!r.promptStartMarker)return 1;let f=1,c=r.promptStartMarker.line;for(;c<p.line&&(w.getLine(c)?.translateToString(!0)??"").length===0;)c++;return f=p.line-c+1,f}function g(r){const w="hasOutput"in r?r.marker:r.commandStartMarker,p="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!w||!p)return 1;let c=Math.max(p.line,w.line)-w.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&c--,c}}),define(he[84],fe([0,1,11,14,4,2,8,23,83,82]),function(ie,e,a,t,D,y,W,P,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandDetectionCapability=void 0,e.getLinesForCommand=l;let w=class extends y.Disposable{get promptInputModel(){return this._promptInputModel}get commands(){return this._commands}get executingCommand(){return this._currentCommand.command}get executingCommandObject(){if(this._currentCommand.commandStartMarker)return{marker:this._currentCommand.commandStartMarker}}get currentCommand(){return this._currentCommand}get cwd(){return this._cwd}get promptTerminator(){return this._promptTerminator}constructor(n,v){super(),this._terminal=n,this._logService=v,this.type=P.TerminalCapability.CommandDetection,this._commands=[],this._currentCommand=new g.PartialTerminalCommand(this._terminal),this._commandMarkers=[],this.__isCommandStorageDisabled=!1,this._onCommandStarted=this._register(new D.Emitter),this.onCommandStarted=this._onCommandStarted.event,this._onBeforeCommandFinished=this._register(new D.Emitter),this.onBeforeCommandFinished=this._onBeforeCommandFinished.event,this._onCommandFinished=this._register(new D.Emitter),this.onCommandFinished=this._onCommandFinished.event,this._onCommandExecuted=this._register(new D.Emitter),this.onCommandExecuted=this._onCommandExecuted.event,this._onCommandInvalidated=this._register(new D.Emitter),this.onCommandInvalidated=this._onCommandInvalidated.event,this._onCurrentCommandInvalidated=this._register(new D.Emitter),this.onCurrentCommandInvalidated=this._onCurrentCommandInvalidated.event,this._promptInputModel=this._register(new r.PromptInputModel(this._terminal,this.onCommandStarted,this.onCommandExecuted,this._logService)),this._register(this.onCommandExecuted(o=>{if(o.commandLineConfidence!=="high"){const s=o;o.command=s.extractCommandLine(),o.commandLineConfidence="low","getOutput"in s?s.promptStartMarker&&s.marker&&s.executedMarker&&o.command.indexOf(`
`)===-1&&s.startX!==void 0&&s.startX>0&&(o.commandLineConfidence="medium"):s.promptStartMarker&&s.commandStartMarker&&s.commandExecutedMarker&&o.command.indexOf(`
`)===-1&&s.commandStartX!==void 0&&s.commandStartX>0&&(o.commandLineConfidence="medium")}}));const b=this;this._ptyHeuristicsHooks=new class{get onCurrentCommandInvalidatedEmitter(){return b._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return b._onCommandStarted}get onCommandExecutedEmitter(){return b._onCommandExecuted}get dimensions(){return b._dimensions}get isCommandStorageDisabled(){return b.__isCommandStorageDisabled}get commandMarkers(){return b._commandMarkers}set commandMarkers(o){b._commandMarkers=o}get clearCommandsInViewport(){return b._clearCommandsInViewport.bind(b)}commitCommandFinished(){b._commitCommandFinished?.flush(),b._commitCommandFinished=void 0}},this._ptyHeuristics=this._register(new y.MandatoryMutableDisposable(new p(this._terminal,this,this._ptyHeuristicsHooks,this._logService))),this._dimensions={cols:this._terminal.cols,rows:this._terminal.rows},this._register(this._terminal.onResize(o=>this._handleResize(o))),this._register(this._terminal.onCursorMove(()=>this._handleCursorMove()))}_handleResize(n){this._ptyHeuristics.value.preHandleResize?.(n),this._dimensions.cols=n.cols,this._dimensions.rows=n.rows}_handleCursorMove(){this._store.isDisposed||this._terminal.buffer.active===this._terminal.buffer.normal&&this._currentCommand.commandStartMarker&&this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY<this._currentCommand.commandStartMarker.line&&(this._clearCommandsInViewport(),this._currentCommand.isInvalid=!0,this._onCurrentCommandInvalidated.fire({reason:P.CommandInvalidationReason.Windows}))}_clearCommandsInViewport(){let n=0;for(let v=this._commands.length-1;v>=0;v--){const b=this._commands[v].marker?.line;if(b&&b<this._terminal.buffer.active.baseY)break;n++}n>0&&this._onCommandInvalidated.fire(this._commands.splice(this._commands.length-n,n))}setContinuationPrompt(n){this._promptInputModel.setContinuationPrompt(n)}setPromptTerminator(n,v){this._logService.debug("CommandDetectionCapability#setPromptTerminator",n),this._promptTerminator=n,this._promptInputModel.setLastPromptLine(v)}setCwd(n){this._cwd=n}setIsWindowsPty(n){if(n&&!(this._ptyHeuristics.value instanceof c)){const v=this;this._ptyHeuristics.value=new c(this._terminal,this,new class{get onCurrentCommandInvalidatedEmitter(){return v._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return v._onCommandStarted}get onCommandExecutedEmitter(){return v._onCommandExecuted}get dimensions(){return v._dimensions}get isCommandStorageDisabled(){return v.__isCommandStorageDisabled}get commandMarkers(){return v._commandMarkers}set commandMarkers(b){v._commandMarkers=b}get clearCommandsInViewport(){return v._clearCommandsInViewport.bind(v)}commitCommandFinished(){v._commitCommandFinished?.flush(),v._commitCommandFinished=void 0}},this._logService)}else!n&&!(this._ptyHeuristics.value instanceof p)&&(this._ptyHeuristics.value=new p(this._terminal,this,this._ptyHeuristicsHooks,this._logService))}setIsCommandStorageDisabled(){this.__isCommandStorageDisabled=!0}getCommandForLine(n){if(this._currentCommand.promptStartMarker&&n>=this._currentCommand.promptStartMarker?.line)return this._currentCommand;if(this._commands.length!==0&&!((this._commands[0].promptStartMarker??this._commands[0].marker).line>n)){for(let v=this.commands.length-1;v>=0;v--)if((this.commands[v].promptStartMarker??this.commands[v].marker).line<=n)return this.commands[v]}}getCwdForLine(n){if(this._currentCommand.promptStartMarker&&n>=this._currentCommand.promptStartMarker?.line)return this._cwd;const v=this.getCommandForLine(n);if(v&&"cwd"in v)return v.cwd}handlePromptStart(n){const v=this.commands.at(-1);v?.endMarker&&v?.executedMarker&&v.endMarker.line===v.executedMarker.line&&(this._logService.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${v.endMarker.line} -> ${v.executedMarker.line+1}`),v.endMarker=d(this._terminal,v.executedMarker,1)),this._currentCommand.promptStartMarker=n?.marker||(v?.endMarker?d(this._terminal,v.endMarker):this._terminal.registerMarker(0)),this._logService.debug("CommandDetectionCapability#handlePromptStart",this._terminal.buffer.active.cursorX,this._currentCommand.promptStartMarker?.line)}handleContinuationStart(){this._currentCommand.currentContinuationMarker=this._terminal.registerMarker(0),this._logService.debug("CommandDetectionCapability#handleContinuationStart",this._currentCommand.currentContinuationMarker)}handleContinuationEnd(){if(!this._currentCommand.currentContinuationMarker){this._logService.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this._currentCommand.continuations||(this._currentCommand.continuations=[]),this._currentCommand.continuations.push({marker:this._currentCommand.currentContinuationMarker,end:this._terminal.buffer.active.cursorX}),this._currentCommand.currentContinuationMarker=void 0,this._logService.debug("CommandDetectionCapability#handleContinuationEnd",this._currentCommand.continuations[this._currentCommand.continuations.length-1])}handleRightPromptStart(){this._currentCommand.commandRightPromptStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptStart",this._currentCommand.commandRightPromptStartX)}handleRightPromptEnd(){this._currentCommand.commandRightPromptEndX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptEnd",this._currentCommand.commandRightPromptEndX)}handleCommandStart(n){if(this._handleCommandStartOptions=n,this._currentCommand.cwd=this._cwd,this._currentCommand.commandStartMarker=n?.marker||this._currentCommand.commandStartMarker,this._currentCommand.commandStartMarker?.line===this._terminal.buffer.active.cursorY){this._currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandStart",this._currentCommand.commandStartX,this._currentCommand.commandStartMarker?.line);return}this._ptyHeuristics.value.handleCommandStart(n)}handleGenericCommand(n){n?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(n),this.handleCommandStart(n),this.handleCommandExecuted(n),this.handleCommandFinished(void 0,n)}handleCommandExecuted(n){this._ptyHeuristics.value.handleCommandExecuted(n),this._currentCommand.markExecutedTime()}handleCommandFinished(n,v){if(this._currentCommand.markFinishedTime(),this._ptyHeuristics.value.preHandleCommandFinished?.(),this._logService.debug("CommandDetectionCapability#handleCommandFinished",this._terminal.buffer.active.cursorX,v?.marker?.line,this._currentCommand.command,this._currentCommand),n===void 0){const o=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this._currentCommand.command&&this._currentCommand.command.length>0&&o?.command===this._currentCommand.command&&(n=o.exitCode)}if(this._currentCommand.commandStartMarker===void 0||!this._terminal.buffer.active)return;this._currentCommand.commandFinishedMarker=v?.marker||this._terminal.registerMarker(0),this._ptyHeuristics.value.postHandleCommandFinished?.();const b=this._currentCommand.promoteToFullCommand(this._cwd,n,this._handleCommandStartOptions?.ignoreCommandLine??!1,v?.markProperties);b&&(this._commands.push(b),this._commitCommandFinished=new a.RunOnceScheduler(()=>{this._onBeforeCommandFinished.fire(b),this._currentCommand.isInvalid||(this._logService.debug("CommandDetectionCapability#onCommandFinished",b),this._onCommandFinished.fire(b))},50),this._commitCommandFinished.schedule()),this._currentCommand=new g.PartialTerminalCommand(this._terminal),this._handleCommandStartOptions=void 0}setCommandLine(n,v){this._logService.debug("CommandDetectionCapability#setCommandLine",n,v),this._currentCommand.command=n,this._currentCommand.commandLineConfidence="high",this._currentCommand.isTrusted=v,v&&this._promptInputModel.setConfidentCommandLine(n)}serialize(){const n=this.commands.map(b=>b.serialize(this.__isCommandStorageDisabled)),v=this._currentCommand.serialize(this._cwd);return v&&n.push(v),{isWindowsPty:this._ptyHeuristics.value instanceof c,commands:n,promptInputModel:this._promptInputModel.serialize()}}deserialize(n){n.isWindowsPty&&this.setIsWindowsPty(n.isWindowsPty);const v=this._terminal.buffer.normal;for(const b of n.commands){if(!b.endLine){const s=b.startLine!==void 0?this._terminal.registerMarker(b.startLine-(v.baseY+v.cursorY)):void 0;if(!s)continue;this._currentCommand.commandStartMarker=b.startLine!==void 0?this._terminal.registerMarker(b.startLine-(v.baseY+v.cursorY)):void 0,this._currentCommand.commandStartX=b.startX,this._currentCommand.promptStartMarker=b.promptStartLine!==void 0?this._terminal.registerMarker(b.promptStartLine-(v.baseY+v.cursorY)):void 0,this._cwd=b.cwd,this._onCommandStarted.fire({marker:s});continue}const o=g.TerminalCommand.deserialize(this._terminal,b,this.__isCommandStorageDisabled);o&&(this._commands.push(o),this._logService.debug("CommandDetectionCapability#onCommandFinished",o),this._onCommandFinished.fire(o))}n.promptInputModel&&this._promptInputModel.deserialize(n.promptInputModel)}};e.CommandDetectionCapability=w,_e([(0,t.debounce)(500)],w.prototype,"_handleCursorMove",null),e.CommandDetectionCapability=w=_e([We(1,W.ILogService)],w);class p extends y.Disposable{constructor(n,v,b,o){super(),this._terminal=n,this._capability=v,this._hooks=b,this._logService=o,this._register(n.parser.registerCsiHandler({final:"J"},s=>(s.length>=1&&(s[0]===2||s[0]===3)&&b.clearCommandsInViewport(),!1)))}handleCommandStart(n){this._hooks.commitCommandFinished();const v=this._capability.currentCommand;v.commandStartX=this._terminal.buffer.active.cursorX,v.commandStartMarker=n?.marker||this._terminal.registerMarker(0),v.commandExecutedMarker?.dispose(),v.commandExecutedMarker=void 0,v.commandExecutedX=void 0;for(const b of this._hooks.commandMarkers)b.dispose();this._hooks.commandMarkers.length=0,this._hooks.onCommandStartedEmitter.fire({marker:n?.marker||v.commandStartMarker,markProperties:n?.markProperties}),this._logService.debug("CommandDetectionCapability#handleCommandStart",v.commandStartX,v.commandStartMarker?.line)}handleCommandExecuted(n){const v=this._capability.currentCommand;if(v.commandExecutedMarker=n?.marker||this._terminal.registerMarker(0),v.commandExecutedX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandExecuted",v.commandExecutedX,v.commandExecutedMarker?.line),!v.commandStartMarker||!v.commandExecutedMarker||v.commandStartX===void 0)return;v.command=this._hooks.isCommandStorageDisabled?"":this._terminal.buffer.active.getLine(v.commandStartMarker.line)?.translateToString(!0,v.commandStartX,v.commandRightPromptStartX).trim();let b=v.commandStartMarker.line+1;const o=v.commandExecutedMarker.line;for(;b<o;b++){const s=this._terminal.buffer.active.getLine(b);if(s){const i=v.continuations?.find(A=>A.marker.line===b);i&&(v.command+=`
`);const _=i?.end??0;v.command+=s.translateToString(!0,_)}}b===o&&(v.command+=this._terminal.buffer.active.getLine(o)?.translateToString(!0,void 0,v.commandExecutedX)||""),this._hooks.onCommandExecutedEmitter.fire(v)}}var f;(function(u){u[u.MaxCheckLineCount=10]="MaxCheckLineCount",u[u.Interval=20]="Interval",u[u.MaximumPollCount=10]="MaximumPollCount"})(f||(f={}));let c=class extends y.Disposable{constructor(n,v,b,o){super(),this._terminal=n,this._capability=v,this._hooks=b,this._logService=o,this._onCursorMoveListener=this._register(new y.MutableDisposable),this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._register(n.parser.registerCsiHandler({final:"J"},s=>(s.length>=1&&(s[0]===2||s[0]===3)&&this._hooks.clearCommandsInViewport(),!1))),this._register(this._capability.onBeforeCommandFinished(s=>{(s.command.trim().toLowerCase()==="clear"||s.command.trim().toLowerCase()==="cls")&&(this._tryAdjustCommandStartMarkerScheduler?.cancel(),this._tryAdjustCommandStartMarkerScheduler=void 0,this._hooks.clearCommandsInViewport(),this._capability.currentCommand.isInvalid=!0,this._hooks.onCurrentCommandInvalidatedEmitter.fire({reason:P.CommandInvalidationReason.Windows}))}))}preHandleResize(n){const v=this._terminal.buffer.active.baseY,b=n.rows-this._hooks.dimensions.rows;b>0&&this._waitForCursorMove().then(()=>{const o=Math.min(b,v);for(let s=this._capability.commands.length-1;s>=0;s--){const i=this._capability.commands[s];if(!i.marker||i.marker.line<v||i.commandStartLineContent===void 0)break;const _=this._terminal.buffer.active.getLine(i.marker.line);if(!_||_.translateToString(!0)===i.commandStartLineContent)continue;const A=i.marker.line-o;this._terminal.buffer.active.getLine(A)?.translateToString(!0)===i.commandStartLineContent&&this._terminal._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this._terminal.buffer.active.baseY,amount:o})}})}handleCommandStart(){this._capability.currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._hooks.commandMarkers.length=0;const n=this._capability.currentCommand.commandStartMarker=this._capability.currentCommand.promptStartMarker?d(this._terminal,this._capability.currentCommand.promptStartMarker):this._terminal.registerMarker(0);this._capability.currentCommand.commandStartX=0,this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._tryAdjustCommandStartMarkerScheduler=new a.RunOnceScheduler(()=>this._tryAdjustCommandStartMarker(n),f.Interval),this._tryAdjustCommandStartMarkerScheduler.schedule()}_tryAdjustCommandStartMarker(n){if(this._store.isDisposed)return;const v=this._terminal.buffer.active;let b=this._tryAdjustCommandStartMarkerScannedLineCount;for(;b<f.MaxCheckLineCount&&n.line+b<v.baseY+this._terminal.rows;){if(this._cursorOnNextLine()){const o=this._getWindowsPrompt(n.line+b);if(o){const s=typeof o=="string"?o:o.prompt;if(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0),typeof o=="object"&&o.likelySingleLine){this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this._capability.currentCommand.promptStartMarker?.line} -> ${this._capability.currentCommand.commandStartMarker.line}`),this._capability.currentCommand.promptStartMarker?.dispose(),this._capability.currentCommand.promptStartMarker=d(this._terminal,this._capability.currentCommand.commandStartMarker);const i=this._capability.commands.at(-1);i&&this._capability.currentCommand.commandStartMarker.line!==i.endMarker?.line&&(i.endMarker?.dispose(),i.endMarker=d(this._terminal,this._capability.currentCommand.commandStartMarker))}this._capability.currentCommand.commandStartX=s.length,this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${n.line} -> ${this._capability.currentCommand.commandStartMarker.line}:${this._capability.currentCommand.commandStartX}`),this._flushPendingHandleCommandStartTask();return}}b++}b<f.MaxCheckLineCount?(this._tryAdjustCommandStartMarkerScannedLineCount=b,++this._tryAdjustCommandStartMarkerPollCount<f.MaximumPollCount?this._tryAdjustCommandStartMarkerScheduler?.schedule():this._flushPendingHandleCommandStartTask()):this._flushPendingHandleCommandStartTask()}_flushPendingHandleCommandStartTask(){if(this._tryAdjustCommandStartMarkerScheduler&&(this._tryAdjustCommandStartMarkerPollCount=f.MaximumPollCount,this._tryAdjustCommandStartMarkerScheduler.flush(),this._tryAdjustCommandStartMarkerScheduler=void 0),this._hooks.commitCommandFinished(),this._capability.currentCommand.commandExecutedMarker||(this._onCursorMoveListener.value=this._terminal.onCursorMove(()=>{if(this._hooks.commandMarkers.length===0||this._hooks.commandMarkers[this._hooks.commandMarkers.length-1].line!==this._terminal.buffer.active.cursorY){const n=this._terminal.registerMarker(0);n&&this._hooks.commandMarkers.push(n)}})),this._capability.currentCommand.commandStartMarker){const n=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);n&&(this._capability.currentCommand.commandStartLineContent=n.translateToString(!0))}this._hooks.onCommandStartedEmitter.fire({marker:this._capability.currentCommand.commandStartMarker}),this._logService.debug("CommandDetectionCapability#_handleCommandStartWindows",this._capability.currentCommand.commandStartX,this._capability.currentCommand.commandStartMarker?.line)}handleCommandExecuted(n){this._tryAdjustCommandStartMarkerScheduler&&this._flushPendingHandleCommandStartTask(),this._onCursorMoveListener.clear(),this._evaluateCommandMarkers(),this._capability.currentCommand.commandExecutedX=this._terminal.buffer.active.cursorX,this._hooks.onCommandExecutedEmitter.fire(this._capability.currentCommand),this._logService.debug("CommandDetectionCapability#handleCommandExecuted",this._capability.currentCommand.commandExecutedX,this._capability.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this._capability.currentCommand.commandExecutedMarker||(this._hooks.commandMarkers.length===0&&(this._capability.currentCommand.commandStartMarker||(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0)),this._capability.currentCommand.commandStartMarker&&this._hooks.commandMarkers.push(this._capability.currentCommand.commandStartMarker)),this._evaluateCommandMarkers())}postHandleCommandFinished(){const n=this._capability.currentCommand,v=n.command,b=n.commandStartMarker?.line,o=n.commandExecutedMarker?.line;if(!v||v.length===0||b===void 0||b===-1||o===void 0||o===-1)return;let s=0,i=!1;for(let _=b;_<=o;_++){const A=this._terminal.buffer.active.getLine(_);if(!A)break;const F=A.translateToString(!0);for(let S=0;S<F.length;S++){for(;v.length<s&&v[s]===" ";)s++;if(F[S]===v[s]&&s++,s===v.length){const L=S>=this._terminal.cols-1;n.commandExecutedMarker=this._terminal.registerMarker(_-(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY)+(L?1:0)),n.commandExecutedX=L?0:S+1,i=!0;break}}if(i)break}}_evaluateCommandMarkers(){if(this._hooks.commandMarkers.length!==0){if(this._hooks.commandMarkers=this._hooks.commandMarkers.sort((n,v)=>n.line-v.line),this._capability.currentCommand.commandStartMarker=this._hooks.commandMarkers[0],this._capability.currentCommand.commandStartMarker){const n=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);n&&(this._capability.currentCommand.commandStartLineContent=n.translateToString(!0))}this._capability.currentCommand.commandExecutedMarker=this._hooks.commandMarkers[this._hooks.commandMarkers.length-1],this._hooks.onCommandExecutedEmitter.fire(this._capability.currentCommand)}}_cursorOnNextLine(){const n=this._capability.commands.at(-1);if(!n)return!0;const v=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY,b=(n.endMarker?n.endMarker.line:n.marker?.line)??-1;return v>b}_waitForCursorMove(){const n=this._terminal.buffer.active.cursorX,v=this._terminal.buffer.active.cursorY;let b=0;return new Promise((o,s)=>{const i=setInterval(()=>{if(n!==this._terminal.buffer.active.cursorX||v!==this._terminal.buffer.active.cursorY){o(),clearInterval(i);return}b+=10,b>1e3&&(clearInterval(i),o())},10)})}_getWindowsPrompt(n=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY){const v=this._terminal.buffer.active.getLine(n);if(!v)return;const b=v.translateToString(!0);if(!b)return;const o=b.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(o){const F=this._adjustPrompt(o,b,">");if(F)return{prompt:F,likelySingleLine:!0}}const s=b.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(s){const F=this._adjustPrompt(s,b,"\u276F");if(F)return F}const i=b.match(/^(?<prompt>\$)/)?.groups?.prompt;if(i){const F=this._adjustPrompt(i,b,"$");if(F)return F}const _=b.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(_)return{prompt:_,likelySingleLine:!0};if(this._capability.promptTerminator&&b.trim().endsWith(this._capability.promptTerminator)){const F=this._adjustPrompt(b,b,this._capability.promptTerminator);if(F)return F}const A=b.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return A?.groups?.prompt?{prompt:A.groups.prompt,likelySingleLine:!0}:void 0}_adjustPrompt(n,v,b){if(n)return v===n&&n.endsWith(b)&&(n+=" "),n}};c=_e([We(3,W.ILogService)],c);function l(u,n,v,b){if(!b)return;const o=n.executedMarker,s=n.endMarker;if(!o||!s)return;const i=o.line,_=s.line,A=b.length,F=[];if(b.anchor==="bottom")for(let S=_-(b.offset||0);S>=i;S--){let L=S;const k=S;for(;L>=i&&u.getLine(L)?.isWrapped;)L--;S=L,F.unshift(h(u,L,k,v)),F.length>A&&F.pop()}else for(let S=i+(b.offset||0);S<_;S++){const L=S;let k=S;for(;k+1<_&&u.getLine(k+1)?.isWrapped;)k++;S=k,F.push(h(u,L,k,v)),F.length===A&&F.shift()}return F}function h(u,n,v,b){const o=Math.max(2048/b*2);v=Math.min(v,n+o);let s="";for(let i=n;i<=v;i++){const _=u.getLine(i);_&&(s+=_.translateToString(!0,0,b))}return s}function d(u,n,v=0){return u.registerMarker(n.line-(u.buffer.active.baseY+u.buffer.active.cursorY)+v)}}),define(he[85],fe([0,1,4,2,23]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CwdDetectionCapability=void 0;class y extends t.Disposable{constructor(){super(...arguments),this.type=D.TerminalCapability.CwdDetection,this._cwd="",this._cwds=new Map,this._onDidChangeCwd=this._register(new a.Emitter),this.onDidChangeCwd=this._onDidChangeCwd.event}get cwds(){return Array.from(this._cwds.keys())}getCwd(){return this._cwd}updateCwd(P){const g=this._cwd!==P;this._cwd=P;const r=this._cwds.get(this._cwd)||0;this._cwds.delete(this._cwd),this._cwds.set(this._cwd,r+1),g&&this._onDidChangeCwd.fire(P)}}e.CwdDetectionCapability=y}),define(he[86],fe([0,1,4,2,23]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialCommandDetectionCapability=void 0;var y;(function(P){P[P.MinimumPromptLength=2]="MinimumPromptLength"})(y||(y={}));class W extends t.DisposableStore{get commands(){return this._commands}constructor(g){super(),this._terminal=g,this.type=D.TerminalCapability.PartialCommandDetection,this._commands=[],this._onCommandFinished=this.add(new a.Emitter),this.onCommandFinished=this._onCommandFinished.event,this.add(this._terminal.onData(r=>this._onData(r))),this.add(this._terminal.parser.registerCsiHandler({final:"J"},r=>(r.length>=1&&(r[0]===2||r[0]===3)&&this._clearCommandsInViewport(),!1)))}_onData(g){g==="\r"&&this._onEnter()}_onEnter(){if(this._terminal&&this._terminal.buffer.active.cursorX>=y.MinimumPromptLength){const g=this._terminal.registerMarker(0);g&&(this._commands.push(g),this._onCommandFinished.fire(g))}}_clearCommandsInViewport(){let g=0;for(let r=this._commands.length-1;r>=0&&!(this._commands[r].line<this._terminal.buffer.active.baseY);r--)g++;this._commands.splice(this._commands.length-g,g)}}e.PartialCommandDetectionCapability=W}),define(he[87],fe([0,1,4,2]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalCapabilityStoreMultiplexer=e.TerminalCapabilityStore=void 0;class D extends t.Disposable{constructor(){super(...arguments),this._map=new Map,this._onDidRemoveCapabilityType=this._register(new a.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new a.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new a.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new a.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._map.keys()}add(P,g){this._map.set(P,g),this._onDidAddCapabilityType.fire(P),this._onDidAddCapability.fire({id:P,capability:g})}get(P){return this._map.get(P)}remove(P){const g=this._map.get(P);g&&(this._map.delete(P),this._onDidRemoveCapabilityType.fire(P),this._onDidAddCapability.fire({id:P,capability:g}))}has(P){return this._map.has(P)}}e.TerminalCapabilityStore=D;class y extends t.Disposable{constructor(){super(...arguments),this._stores=[],this._onDidRemoveCapabilityType=this._register(new a.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new a.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new a.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new a.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._items()}*_items(){for(const P of this._stores)for(const g of P.items)yield g}has(P){for(const g of this._stores)for(const r of g.items)if(r===P)return!0;return!1}get(P){for(const g of this._stores){const r=g.get(P);if(r)return r}}add(P){this._stores.push(P);for(const g of P.items)this._onDidAddCapabilityType.fire(g),this._onDidAddCapability.fire({id:g,capability:P.get(g)});this._register(P.onDidAddCapabilityType(g=>this._onDidAddCapabilityType.fire(g))),this._register(P.onDidAddCapability(g=>this._onDidAddCapability.fire(g))),this._register(P.onDidRemoveCapabilityType(g=>this._onDidRemoveCapabilityType.fire(g))),this._register(P.onDidRemoveCapability(g=>this._onDidRemoveCapability.fire(g)))}}e.TerminalCapabilityStoreMultiplexer=y}),define(he[39],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var a;(function(t){t[t.Replace=1]="Replace",t[t.Append=2]="Append",t[t.Prepend=3]="Prepend"})(a||(e.EnvironmentVariableMutatorType=a={}))}),define(he[88],fe([0,1,3,39]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const D=new Map([[t.EnvironmentVariableMutatorType.Append,"APPEND"],[t.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[t.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class y{constructor(w){this.collections=w,this.map=new Map,this.descriptionMap=new Map,w.forEach((p,f)=>{this.populateDescriptionMap(p,f);const c=p.map.entries();let l=c.next();for(;!l.done;){const h=l.value[1],d=l.value[0];let u=this.map.get(d);if(u||(u=[],this.map.set(d,u)),u.length>0&&u[0].type===t.EnvironmentVariableMutatorType.Replace){l=c.next();continue}const n={extensionIdentifier:f,value:h.value,type:h.type,scope:h.scope,variable:h.variable,options:h.options};n.scope||delete n.scope,u.unshift(n),l=c.next()}})}async applyToProcessEnvironment(w,p,f){let c;a.isWindows&&(c={},Object.keys(w).forEach(l=>c[l.toLowerCase()]=l));for(const[l,h]of this.getVariableMap(p)){const d=a.isWindows&&c[l.toLowerCase()]||l;for(const u of h){const n=f?await f(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case t.EnvironmentVariableMutatorType.Append:w[d]=(w[d]||"")+n;break;case t.EnvironmentVariableMutatorType.Prepend:w[d]=n+(w[d]||"");break;case t.EnvironmentVariableMutatorType.Replace:w[d]=n;break}if(u.options?.applyAtShellIntegration??!1){const v=`VSCODE_ENV_${D.get(u.type)}`;w[v]=(w[v]?w[v]+":":"")+l+"="+this._encodeColons(n)}}}}_encodeColons(w){return w.replaceAll(":","\\x3a")}diff(w,p){const f=new Map,c=new Map,l=new Map;if(w.getVariableMap(p).forEach((h,d)=>{const u=this.getVariableMap(p).get(d),n=P(h,u);n&&f.set(d,n)}),this.getVariableMap(p).forEach((h,d)=>{const u=w.getVariableMap(p).get(d),n=P(h,u);n&&l.set(d,n)}),this.getVariableMap(p).forEach((h,d)=>{const u=w.getVariableMap(p).get(d),n=g(h,u);n&&c.set(d,n)}),!(f.size===0&&c.size===0&&l.size===0))return{added:f,changed:c,removed:l}}getVariableMap(w){const p=new Map;for(const f of this.map.values()){const c=f.filter(l=>W(l,w));c.length>0&&p.set(c[0].variable,c)}return p}getDescriptionMap(w){const p=new Map;for(const f of this.descriptionMap.values()){const c=f.filter(l=>W(l,w,!0));for(const l of c)p.set(l.extensionIdentifier,l.description)}return p}populateDescriptionMap(w,p){if(!w.descriptionMap)return;const f=w.descriptionMap.entries();let c=f.next();for(;!c.done;){const l=c.value[1],h=c.value[0];let d=this.descriptionMap.get(h);d||(d=[],this.descriptionMap.set(h,d));const u={extensionIdentifier:p,scope:l.scope,description:l.description};u.scope||delete u.scope,d.push(u),c=f.next()}}}e.MergedEnvironmentVariableCollection=y;function W(r,w,p=!1){return r.scope?!!(r.scope.workspaceFolder&&w?.workspaceFolder&&r.scope.workspaceFolder.index===w.workspaceFolder.index):p?w===r.scope:!0}function P(r,w){if(!w)return r;const p=new Set;w.forEach(c=>p.add(c.extensionIdentifier));const f=[];return r.forEach(c=>{p.has(c.extensionIdentifier)||f.push(c)}),f.length===0?void 0:f}function g(r,w){if(!w)return;const p=new Map;w.forEach(c=>p.set(c.extensionIdentifier,c));const f=[];return r.forEach(c=>{const l=p.get(c.extensionIdentifier);l&&(c.type!==l.type||c.value!==l.value||c.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index)&&f.push(l)}),f.length===0?void 0:f}}),define(he[89],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=a,e.serializeEnvironmentDescriptionMap=t,e.deserializeEnvironmentVariableCollection=D,e.deserializeEnvironmentDescriptionMap=y,e.serializeEnvironmentVariableCollections=W,e.deserializeEnvironmentVariableCollections=P;function a(g){return[...g.entries()]}function t(g){return g?[...g.entries()]:[]}function D(g){return new Map(g)}function y(g){return new Map(g??[])}function W(g){return Array.from(g.entries()).map(r=>[r[0],a(r[1].map),t(r[1].descriptionMap)])}function P(g){return new Map(g.map(r=>[r[0],{map:D(r[1]),descriptionMap:y(r[2])}]))}}),define(he[90],fe([0,1,11,18,4,2,8]),function(ie,e,a,t,D,y,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends y.Disposable{constructor(r,w){super(),this._logService=w,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=r===void 0?15e3:r,this._register((0,y.toDisposable)(()=>{for(const p of this._pendingRequestDisposables.values())(0,y.dispose)(p)}))}createRequest(r){return new Promise((w,p)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,w),this._onCreateRequest.fire({requestId:f,...r});const c=new t.CancellationTokenSource;(0,a.timeout)(this._timeout,c.token).then(()=>p(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,y.toDisposable)(()=>c.cancel())])})}acceptReply(r,w){const p=this._pendingRequests.get(r);p?(this._pendingRequests.delete(r),(0,y.dispose)(this._pendingRequestDisposables.get(r)||[]),this._pendingRequestDisposables.delete(r),p(w)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.RequestStore=P,e.RequestStore=P=_e([We(1,W.ILogService)],P)}),define(he[16],fe([0,1,22,38,80]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new t.RawContextKey("terminalTabFocusMode",!1,!0);var y;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(y||(e.TerminalSettingPrefix=y={}));var W;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(W||(e.TerminalSettingId=W={}));var P;(function(o){o.PowerShell="pwsh",o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh",o.Python="python"})(P||(e.PosixShellType=P={}));var g;(function(o){o.CommandPrompt="cmd",o.PowerShell="pwsh",o.Wsl="wsl",o.GitBash="gitbash",o.Python="python"})(g||(e.WindowsShellType=g={}));var r;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(r||(e.TitleEventSource=r={}));var w;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(w||(e.TerminalIpcChannels=w={}));var p;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.IPtyService=(0,a.createDecorator)("ptyService");var f;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(f||(e.HeartbeatConstants=f={}));var c;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(c||(e.TerminalLocation=c={}));var l;(function(o){o.TerminalView="view",o.Editor="editor"})(l||(e.TerminalLocationString=l={}));var h;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(h||(e.LocalReconnectConstants=h={}));var d;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var u;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var n;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(n||(e.ShellIntegrationStatus=n={}));var v;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(v||(e.TerminalExitReason=v={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class b{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(s){const i=this._sanitizeRemoteAuthority(s.remoteAuthority);if(this._backends.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this._backends.set(i,s)}getTerminalBackend(s){return this._backends.get(this._sanitizeRemoteAuthority(s))}_sanitizeRemoteAuthority(s){return s?.toLowerCase()??""}}D.Registry.add(e.TerminalExtensions.Backend,new b),e.ILocalPtyService=(0,a.createDecorator)("localPtyService"),e.ITerminalLogService=(0,a.createDecorator)("terminalLogService")}),define(he[91],fe([0,1,11,2,3]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalAutoResponder=void 0;class y extends t.Disposable{constructor(P,g,r,w){super(),this._pointer=0,this._paused=!1,this._throttled=!1,this._register(P.onProcessData(p=>{if(this._paused||this._throttled)return;const f=typeof p=="string"?p:p.data;for(let c=0;c<f.length;c++)f[c]===g[this._pointer]?this._pointer++:this._reset(),this._pointer===g.length&&(w.debug(`Auto reply match: "${g}", response: "${r}"`),P.input(r),this._throttled=!0,(0,a.timeout)(1e3).then(()=>this._throttled=!1),this._reset())}))}_reset(){this._pointer=0}handleResize(){D.isWindows&&(this._paused=!0)}handleInput(){this._paused=!1}}e.TerminalAutoResponder=y}),define(he[92],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,y,W=5){const P=y(g=>{const r=typeof g=="string"?g:g.data;let w=this._terminalBufferMap.get(D);if(w){w.data.push(r);return}const p=setTimeout(()=>this.flushBuffer(D),W);w={data:[r],timeoutId:p,dispose:()=>{clearTimeout(p),this.flushBuffer(D),P.dispose()}},this._terminalBufferMap.set(D,w)});return P}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const y=this._terminalBufferMap.get(D);y&&(this._terminalBufferMap.delete(D),this._callback(D,y.data.join("")))}}e.TerminalDataBufferer=a}),define(he[40],fe([0,1,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeNonWindowsPath=t,e.collapseTildePath=D,e.sanitizeCwd=y,e.shouldUseEnvironmentVariableCollection=W;function t(P){let g=P;g.includes("\\")&&(g=g.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return g=g.replace(r,""),`'${g}'`}function D(P,g,r){if(!P)return"";if(!g)return P;g.match(/[\/\\]$/)&&(g=g.slice(0,g.length-1));const w=P.replace(/\\/g,"/").toLowerCase(),p=g.replace(/\\/g,"/").toLowerCase();return w.includes(p)?`~${r}${P.slice(g.length+1)}`:P}function y(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),a.OS===a.OperatingSystem.Windows&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}function W(P){return!P.strictEnv}}),define(he[93],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.chunkInput=t;var a;(function(D){D[D.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(a||(a={}));function t(D){const y=[];let W=0;for(let P=0;P<D.length-1;P++)(P-W+1>=a.WriteMaxChunkSize||D[P+1]==="\x1B")&&(y.push(D.substring(W,P+1)),W=P+1,P++);return W!==D.length&&y.push(D.substring(W)),y}}),define(he[94],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.formatMessageForTerminal=a;function a(t,D={}){let y="";return D.excludeLeadingNewLine||(y+=`\r
`),y+="\x1B[0m\x1B[7m * ",D.loudFormatting?y+="\x1B[0;104m":y+="\x1B[0m",y+=` ${t} \x1B[0m
\r`,y}}),define(he[95],fe([0,1,16,2,87,84,85,23,86,4,81,6,40,10]),function(ie,e,a,t,D,y,W,P,g,r,w,p,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ShellIntegrationAddon=e.ShellIntegrationOscPs=void 0,e.deserializeMessage=v,e.parseKeyValueAssignment=b,e.parseMarkSequence=o;var l;(function(s){s[s.FinalTerm=133]="FinalTerm",s[s.VSCode=633]="VSCode",s[s.ITerm=1337]="ITerm",s[s.SetCwd=7]="SetCwd",s[s.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(l||(e.ShellIntegrationOscPs=l={}));var h;(function(s){s.PromptStart="A",s.CommandStart="B",s.CommandExecuted="C",s.CommandFinished="D"})(h||(h={}));var d;(function(s){s.PromptStart="A",s.CommandStart="B",s.CommandExecuted="C",s.CommandFinished="D",s.CommandLine="E",s.ContinuationStart="F",s.ContinuationEnd="G",s.RightPromptStart="H",s.RightPromptEnd="I",s.Property="P",s.SetMark="SetMark"})(d||(d={}));var u;(function(s){s.SetMark="SetMark",s.CurrentDir="CurrentDir"})(u||(u={}));class n extends t.Disposable{get status(){return this._status}constructor(i,_,A,F){super(),this._nonce=i,this._disableTelemetry=_,this._telemetryService=A,this._logService=F,this.capabilities=this._register(new D.TerminalCapabilityStore),this._hasUpdatedTelemetry=!1,this._commonProtocolDisposables=[],this._status=a.ShellIntegrationStatus.Off,this._onDidChangeStatus=new r.Emitter,this.onDidChangeStatus=this._onDidChangeStatus.event,this._register((0,t.toDisposable)(()=>{this._clearActivationTimeout(),this._disposeCommonProtocol()}))}_disposeCommonProtocol(){(0,t.dispose)(this._commonProtocolDisposables),this._commonProtocolDisposables.length=0}activate(i){this._terminal=i,this.capabilities.add(P.TerminalCapability.PartialCommandDetection,this._register(new g.PartialCommandDetectionCapability(this._terminal))),this._register(i.parser.registerOscHandler(l.VSCode,_=>this._handleVSCodeSequence(_))),this._register(i.parser.registerOscHandler(l.ITerm,_=>this._doHandleITermSequence(_))),this._commonProtocolDisposables.push(i.parser.registerOscHandler(l.FinalTerm,_=>this._handleFinalTermSequence(_))),this._register(i.parser.registerOscHandler(l.SetCwd,_=>this._doHandleSetCwd(_))),this._register(i.parser.registerOscHandler(l.SetWindowsFriendlyCwd,_=>this._doHandleSetWindowsFriendlyCwd(_))),this._ensureCapabilitiesOrAddFailureTelemetry()}getMarkerId(i,_){this._createOrGetBufferMarkDetection(i).getMark(_)}_handleFinalTermSequence(i){const _=this._doHandleFinalTermSequence(i);return this._status===a.ShellIntegrationStatus.Off&&(this._status=a.ShellIntegrationStatus.FinalTerm,this._onDidChangeStatus.fire(this._status)),_}_doHandleFinalTermSequence(i){if(!this._terminal)return!1;const[_,...A]=i.split(";");switch(_){case h.PromptStart:return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case h.CommandStart:return this._createOrGetCommandDetection(this._terminal).handleCommandStart({ignoreCommandLine:!0}),!0;case h.CommandExecuted:return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case h.CommandFinished:{const F=A.length===1?parseInt(A[0]):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(F),!0}}return!1}_handleVSCodeSequence(i){const _=this._doHandleVSCodeSequence(i);return!this._hasUpdatedTelemetry&&_&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this._hasUpdatedTelemetry=!0,this._clearActivationTimeout()),this._status!==a.ShellIntegrationStatus.VSCode&&(this._status=a.ShellIntegrationStatus.VSCode,this._onDidChangeStatus.fire(this._status)),_}async _ensureCapabilitiesOrAddFailureTelemetry(){!this._telemetryService||this._disableTelemetry||(this._activationTimeout=setTimeout(()=>{!this.capabilities.get(P.TerminalCapability.CommandDetection)&&!this.capabilities.get(P.TerminalCapability.CwdDetection)&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationTimeout"),this._logService.warn("Shell integration failed to add capabilities within 10 seconds")),this._hasUpdatedTelemetry=!0},1e4))}_clearActivationTimeout(){this._activationTimeout!==void 0&&(clearTimeout(this._activationTimeout),this._activationTimeout=void 0)}_doHandleVSCodeSequence(i){if(!this._terminal)return!1;const _=i.indexOf(";"),A=_===-1?i:i.substring(0,_),F=_===-1?[]:i.substring(_+1).split(";");switch(A){case d.PromptStart:return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case d.CommandStart:return this._createOrGetCommandDetection(this._terminal).handleCommandStart(),!0;case d.CommandExecuted:return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case d.CommandFinished:{const S=F[0],L=S!==void 0?parseInt(S):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(L),!0}case d.CommandLine:{const S=F[0],L=F[1];let k;return S!==void 0?k=v(S):k="",this._createOrGetCommandDetection(this._terminal).setCommandLine(k,L===this._nonce),!0}case d.ContinuationStart:return this._createOrGetCommandDetection(this._terminal).handleContinuationStart(),!0;case d.ContinuationEnd:return this._createOrGetCommandDetection(this._terminal).handleContinuationEnd(),!0;case d.RightPromptStart:return this._createOrGetCommandDetection(this._terminal).handleRightPromptStart(),!0;case d.RightPromptEnd:return this._createOrGetCommandDetection(this._terminal).handleRightPromptEnd(),!0;case d.Property:{const S=F[0],L=S!==void 0?v(S):"",{key:k,value:O}=b(L);if(O===void 0)return!0;switch(k){case"ContinuationPrompt":return this._updateContinuationPrompt((0,c.removeAnsiEscapeCodesFromPrompt)(O)),!0;case"Cwd":return this._updateCwd(O),!0;case"IsWindows":return this._createOrGetCommandDetection(this._terminal).setIsWindowsPty(O==="True"),!0;case"Prompt":{const x=O.replace(/\x1b\[[0-9;]*m/g,"");return this._updatePromptTerminator(x),!0}case"Task":return this._createOrGetBufferMarkDetection(this._terminal),this.capabilities.get(P.TerminalCapability.CommandDetection)?.setIsCommandStorageDisabled(),!0}}case d.SetMark:return this._createOrGetBufferMarkDetection(this._terminal).addMark(o(F)),!0}return!1}_updateContinuationPrompt(i){this._terminal&&this._createOrGetCommandDetection(this._terminal).setContinuationPrompt(i)}_updatePromptTerminator(i){if(!this._terminal)return;const _=i.substring(i.lastIndexOf(`
`)+1),A=_.substring(_.lastIndexOf(" "));A&&this._createOrGetCommandDetection(this._terminal).setPromptTerminator(A,_)}_updateCwd(i){i=(0,f.sanitizeCwd)(i),this._createOrGetCwdDetection().updateCwd(i),this.capabilities.get(P.TerminalCapability.CommandDetection)?.setCwd(i)}_doHandleITermSequence(i){if(!this._terminal)return!1;const[_]=i.split(";");switch(_){case u.SetMark:this._createOrGetBufferMarkDetection(this._terminal).addMark();default:{const{key:A,value:F}=b(_);if(F===void 0)return!0;switch(A){case u.CurrentDir:return this._updateCwd(F),!0}}}return!1}_doHandleSetWindowsFriendlyCwd(i){if(!this._terminal)return!1;const[_,...A]=i.split(";");switch(_){case"9":return A.length&&this._updateCwd(A[0]),!0}return!1}_doHandleSetCwd(i){if(!this._terminal)return!1;const[_]=i.split(";");if(_.match(/^file:\/\/.*\//)){const A=p.URI.parse(_);if(A.path&&A.path.length>0)return this._updateCwd(A.path),!0}return!1}serialize(){return!this._terminal||!this.capabilities.has(P.TerminalCapability.CommandDetection)?{isWindowsPty:!1,commands:[],promptInputModel:void 0}:this._createOrGetCommandDetection(this._terminal).serialize()}deserialize(i){if(!this._terminal)throw new Error("Cannot restore commands before addon is activated");this._createOrGetCommandDetection(this._terminal).deserialize(i)}_createOrGetCwdDetection(){let i=this.capabilities.get(P.TerminalCapability.CwdDetection);return i||(i=this._register(new W.CwdDetectionCapability),this.capabilities.add(P.TerminalCapability.CwdDetection,i)),i}_createOrGetCommandDetection(i){let _=this.capabilities.get(P.TerminalCapability.CommandDetection);return _||(_=this._register(new y.CommandDetectionCapability(i,this._logService)),this.capabilities.add(P.TerminalCapability.CommandDetection,_)),_}_createOrGetBufferMarkDetection(i){let _=this.capabilities.get(P.TerminalCapability.BufferMarkDetection);return _||(_=this._register(new w.BufferMarkCapability(i)),this.capabilities.add(P.TerminalCapability.BufferMarkDetection,_)),_}}e.ShellIntegrationAddon=n;function v(s){return s.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(i,_,A)=>A?String.fromCharCode(parseInt(A,16)):_)}function b(s){const i=s.indexOf("=");return i===-1?{key:s,value:void 0}:{key:s.substring(0,i),value:s.substring(1+i)}}function o(s){let i,_=!1;for(const A of s)A!==void 0&&(A==="Hidden"&&(_=!0),A.startsWith("Id=")&&(i=A.substring(3)));return{id:i,hidden:_}}}),define(he[41],fe([0,1,5,14,4,2,61,8]),function(ie,e,a,t,D,y,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChildProcessMonitor=e.ignoreProcessNames=void 0;var g;(function(w){w[w.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",w[w.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(g||(g={})),e.ignoreProcessNames=[];let r=class extends y.Disposable{set hasChildProcesses(p){this._hasChildProcesses!==p&&(this._hasChildProcesses=p,this._logService.debug("ChildProcessMonitor: Has child processes changed",p),this._onDidChangeHasChildProcesses.fire(p))}get hasChildProcesses(){return this._hasChildProcesses}constructor(p,f){super(),this._pid=p,this._logService=f,this._hasChildProcesses=!1,this._onDidChangeHasChildProcesses=this._register(new D.Emitter),this.onDidChangeHasChildProcesses=this._onDidChangeHasChildProcesses.event}handleInput(){this._refreshActive()}handleOutput(){this._refreshInactive()}async _refreshActive(){if(!this._store.isDisposed)try{const p=await(0,W.listProcesses)(this._pid);this.hasChildProcesses=this._processContainsChildren(p)}catch(p){this._logService.debug("ChildProcessMonitor: Fetching process tree failed",p)}}_refreshInactive(){this._refreshActive()}_processContainsChildren(p){if(!p.children)return!1;if(p.children.length===1){const f=p.children[0];let c;if(f.cmd.startsWith('"'))c=f.cmd.substring(1,f.cmd.indexOf('"',1));else{const l=f.cmd.indexOf(" ");l===-1?c=f.cmd:c=f.cmd.substring(0,l)}return e.ignoreProcessNames.indexOf((0,a.parse)(c).name)===-1}return p.children.length>0}};e.ChildProcessMonitor=r,_e([(0,t.debounce)(g.ActiveDebounceDuration)],r.prototype,"_refreshActive",null),_e([(0,t.throttle)(g.InactiveThrottleDuration)],r.prototype,"_refreshInactive",null),e.ChildProcessMonitor=r=_e([We(1,P.ILogService)],r)}),define(he[96],fe([0,1,4,2,16]),function(ie,e,a,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HeartbeatService=void 0;class y extends t.Disposable{constructor(){super(),this._onBeat=this._register(new a.Emitter),this.onBeat=this._onBeat.event;const P=setInterval(()=>{this._onBeat.fire()},D.HeartbeatConstants.BeatInterval);this._register((0,t.toDisposable)(()=>clearInterval(P)))}}e.HeartbeatService=y}),define(he[42],fe([0,1,21,20,33,5,3,15,10,9,28,39,89,88]),function(ie,e,a,t,D,y,W,P,g,r,w,p,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=l,e.findExecutable=h,e.getShellIntegrationInjection=d,a=De(a),y=De(y),P=De(P),w=De(w);function l(){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(a.release());let L=0;return S&&S.length===4&&(L=parseInt(S[3])),L}async function h(S,L,k,O=P.env,x=w.Promises.exists){if(y.isAbsolute(S))return await x(S)?S:void 0;if(L===void 0&&(L=P.cwd()),y.dirname(S)!=="."){const I=y.join(L,S);return await x(I)?I:void 0}const E=(0,D.getCaseInsensitive)(O,"PATH");if(k===void 0&&(0,r.isString)(E)&&(k=E.split(y.delimiter)),k===void 0||k.length===0){const I=y.join(L,S);return await x(I)?I:void 0}for(const I of k){let C;if(y.isAbsolute(I)?C=y.join(I,S):C=y.join(L,I,S),await x(C))return C;if(W.isWindows){let B=C+".com";if(await x(B)||(B=C+".exe",await x(B)))return B}}const U=y.join(L,S);return await x(U)?U:void 0}function d(S,L,k,O,x){const R=W.isWindows&&(!L.windowsEnableConpty||l()<18309);if(!L.shellIntegration.enabled||!S.executable||S.isFeatureTerminal&&!S.forceShellIntegration||S.ignoreShellIntegration||R)return;const E=S.args,U=P.platform==="win32"?y.basename(S.executable).toLowerCase():y.basename(S.executable),I=y.dirname(t.FileAccess.asFileUri("").fsPath);let C;const B={VSCODE_INJECTION:"1"};if(L.shellIntegration.nonce&&(B.VSCODE_NONCE=L.shellIntegration.nonce),W.isWindows){if(U==="pwsh.exe"||U==="powershell.exe")return!E||A(E)?C=v.get(n.WindowsPwsh):_(E)&&(C=v.get(n.WindowsPwshLogin)),C?(C=[...C],C[C.length-1]=(0,g.format)(C[C.length-1],I,""),B.VSCODE_STABLE=x.quality==="stable"?"1":"0",L.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),{newArgs:C,envMixin:B}):void 0;if(U==="bash.exe")return!E||E.length===0?C=v.get(n.Bash):F(E)&&(B.VSCODE_SHELL_LOGIN="1",u(L,B),C=v.get(n.Bash)),C?(C=[...C],C[C.length-1]=(0,g.format)(C[C.length-1],I),B.VSCODE_STABLE=x.quality==="stable"?"1":"0",{newArgs:C,envMixin:B}):void 0;O.warn(`Shell integration cannot be enabled for executable "${S.executable}" and args`,S.args);return}switch(U){case"bash":return!E||E.length===0?C=v.get(n.Bash):F(E)&&(B.VSCODE_SHELL_LOGIN="1",u(L,B),C=v.get(n.Bash)),C?(C=[...C],C[C.length-1]=(0,g.format)(C[C.length-1],I),B.VSCODE_STABLE=x.quality==="stable"?"1":"0",{newArgs:C,envMixin:B}):void 0;case"fish":{const Y=k?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",G=y.join(I,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${Y}:${G}`,u(L,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!E||A(E)?C=v.get(n.Pwsh):_(E)&&(C=v.get(n.PwshLogin)),C?(L.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),C=[...C],C[C.length-1]=(0,g.format)(C[C.length-1],I,""),B.VSCODE_STABLE=x.quality==="stable"?"1":"0",{newArgs:C,envMixin:B}):void 0;case"zsh":{if(!E||E.length===0?C=v.get(n.Zsh):F(E)?(C=v.get(n.ZshLogin),u(L,B)):(E===v.get(n.Zsh)||E===v.get(n.ZshLogin))&&(C=E),!C)return;C=[...C],C[C.length-1]=(0,g.format)(C[C.length-1],I);let Y;try{Y=a.userInfo().username}catch{Y="unknown"}const G=y.join(a.tmpdir(),`${Y}-${x.applicationName}-zsh`);B.ZDOTDIR=G;const Z=k?.ZDOTDIR??a.homedir()??"~";B.USER_ZDOTDIR=Z;const se=[];return se.push({source:y.join(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:y.join(G,".zshrc")}),se.push({source:y.join(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:y.join(G,".zprofile")}),se.push({source:y.join(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:y.join(G,".zshenv")}),se.push({source:y.join(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:y.join(G,".zlogin")}),{newArgs:C,envMixin:B,filesToCopy:se}}}O.warn(`Shell integration cannot be enabled for executable "${S.executable}" and args`,S.args)}function u(S,L){if(W.isMacintosh&&S.environmentVariableCollections){const k=(0,f.deserializeEnvironmentVariableCollections)(S.environmentVariableCollections),x=new c.MergedEnvironmentVariableCollection(k).getVariableMap({workspaceFolder:S.workspaceFolder}).get("PATH"),R=[];if(x)for(const E of x)E.type===p.EnvironmentVariableMutatorType.Prepend&&R.push(E.value);R.length>0&&(L.VSCODE_PATH_PREFIX=R.join(""))}}var n;(function(S){S.WindowsPwsh="windows-pwsh",S.WindowsPwshLogin="windows-pwsh-login",S.Pwsh="pwsh",S.PwshLogin="pwsh-login",S.Zsh="zsh",S.ZshLogin="zsh-login",S.Bash="bash"})(n||(n={}));const v=new Map;v.set(n.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(n.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(n.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(n.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(n.Zsh,["-i"]),v.set(n.ZshLogin,["-il"]),v.set(n.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],o=["--login","-l"],s=["-i","--interactive"],i=["-nol","-nologo"];function _(S){return typeof S=="string"?b.includes(S.toLowerCase()):S.length===1&&b.includes(S[0].toLowerCase())||S.length===2&&(b.includes(S[0].toLowerCase())||b.includes(S[1].toLowerCase()))&&(i.includes(S[0].toLowerCase())||i.includes(S[1].toLowerCase()))}function A(S){return typeof S=="string"?i.includes(S.toLowerCase()):S.length===0||S?.length===1&&i.includes(S[0].toLowerCase())}function F(S){return typeof S!="string"&&(S=S.filter(L=>!s.includes(L.toLowerCase()))),S==="string"&&o.includes(S.toLowerCase())||typeof S!="string"&&S.length===1&&o.includes(S[0].toLowerCase())}}),define(he[97],fe([0,1,11,14,4,2,3,16]),function(ie,e,a,t,D,y,W,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsShellHelper=void 0;const g=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let r;class w extends y.Disposable{get shellType(){return this._shellType}get shellTitle(){return this._shellTitle}get onShellNameChanged(){return this._onShellNameChanged.event}get onShellTypeChanged(){return this._onShellTypeChanged.event}constructor(f){if(super(),this._rootProcessId=f,this._shellTitle="",this._onShellNameChanged=new D.Emitter,this._onShellTypeChanged=new D.Emitter,!W.isWindows)throw new Error(`WindowsShellHelper cannot be instantiated on ${W.platform}`);this._startMonitoringShell()}async _startMonitoringShell(){this._store.isDisposed||this.checkShell()}async checkShell(){W.isWindows&&(await(0,a.timeout)(300),this.getShellName().then(f=>{const c=this.getShellType(f);c!==this._shellType&&(this._onShellTypeChanged.fire(c),this._onShellNameChanged.fire(f),this._shellType=c,this._shellTitle=f)}))}traverseTree(f){if(!f)return"";if(g.indexOf(f.name)===-1||!f.children||f.children.length===0)return f.name;let c=0;for(;c<f.children.length;c++){const l=f.children[c];if(!l.children||l.children.length===0||l.children[0].name!=="conhost.exe")break}return c>=f.children.length?f.name:this.traverseTree(f.children[c])}async getShellName(){return this._store.isDisposed?Promise.resolve(""):this._currentRequest?this._currentRequest:(r||(r=await new Promise((f,c)=>{ie(["@vscode/windows-process-tree"],f,c)}).then(De)),this._currentRequest=new Promise(f=>{r.getProcessTree(this._rootProcessId,c=>{const l=this.traverseTree(c);this._currentRequest=void 0,f(l)})}),this._currentRequest)}getShellType(f){switch(f.toLowerCase()){case"cmd.exe":return P.WindowsShellType.CommandPrompt;case"powershell.exe":case"pwsh.exe":return P.WindowsShellType.PowerShell;case"bash.exe":case"git-cmd.exe":return P.WindowsShellType.GitBash;case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return P.WindowsShellType.Wsl;default:return f.match(/python(\d(\.\d{0,2})?)?\.exe/)?P.WindowsShellType.Python:void 0}}}e.WindowsShellHelper=w,_e([(0,t.debounce)(500)],w.prototype,"checkShell",null)}),define(he[98],fe([0,1,35,29,11,4,2,5,3,6,12,8,79,16,41,42,97,102,93]),function(ie,e,a,t,D,y,W,P,g,r,w,p,f,c,l,h,d,u,n){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0,a=De(a),P=De(P);var b;(function(A){A[A.DataFlushTimeout=250]="DataFlushTimeout",A[A.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(b||(b={}));var o;(function(A){A[A.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",A[A.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",A[A.WriteInterval=5]="WriteInterval"})(o||(o={}));const s=new Map([["bash",c.PosixShellType.Bash],["csh",c.PosixShellType.Csh],["fish",c.PosixShellType.Fish],["ksh",c.PosixShellType.Ksh],["sh",c.PosixShellType.Sh],["pwsh",c.PosixShellType.PowerShell],["python",c.PosixShellType.Python],["zsh",c.PosixShellType.Zsh]]);let i=class extends W.Disposable{static{v=this}static{this._lastKillOrStart=0}get exitMessage(){return this._exitMessage}get currentTitle(){return this._windowsShellHelper?.shellTitle||this._currentTitle}get shellType(){return g.isWindows?this._windowsShellHelper?.shellType:s.get(this._currentTitle)}get hasChildProcesses(){return this._childProcessMonitor?.hasChildProcesses||!1}constructor(F,S,L,k,O,x,R,E,U){super(),this.shellLaunchConfig=F,this._executableEnv=x,this._options=R,this._logService=E,this._productService=U,this.id=0,this.shouldPersist=!1,this._properties={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this._currentTitle="",this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new y.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new y.Emitter),this.onProcessReady=this._onProcessReady.event,this._onDidChangeProperty=this._register(new y.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new y.Emitter),this.onProcessExit=this._onProcessExit.event;let I;g.isWindows?I=P.basename(this.shellLaunchConfig.executable||""):I="xterm-256color",this._initialCwd=S,this._properties[c.ProcessPropertyType.InitialCwd]=this._initialCwd,this._properties[c.ProcessPropertyType.Cwd]=this._initialCwd;const C=this._options.windowsEnableConpty&&process.platform==="win32"&&(0,h.getWindowsBuildNumber)()>=18309;this._ptyOptions={name:I,cwd:S,env:O,cols:L,rows:k,useConpty:C,conptyInheritCursor:C&&!!F.initialText},g.isWindows&&(C&&L===0&&k===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this._delayedResizer=new _,this._register(this._delayedResizer.onTrigger(B=>{this._delayedResizer?.dispose(),this._delayedResizer=void 0,B.cols&&B.rows&&this.resize(B.cols,B.rows)}))),this.onProcessReady(B=>{this._windowsShellHelper=this._register(new d.WindowsShellHelper(B.pid)),this._register(this._windowsShellHelper.onShellTypeChanged(Y=>this._onDidChangeProperty.fire({type:c.ProcessPropertyType.ShellType,value:Y}))),this._register(this._windowsShellHelper.onShellNameChanged(Y=>this._onDidChangeProperty.fire({type:c.ProcessPropertyType.Title,value:Y})))})),this._register((0,W.toDisposable)(()=>{this._titleInterval&&(clearInterval(this._titleInterval),this._titleInterval=null)}))}async start(){const S=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(k=>k!==void 0);if(S)return S;let L;if(this._options.shellIntegration.enabled)if(L=(0,h.getShellIntegrationInjection)(this.shellLaunchConfig,this._options,this._ptyOptions.env,this._logService,this._productService),L){if(this._onDidChangeProperty.fire({type:c.ProcessPropertyType.UsedShellIntegrationInjection,value:!0}),L.envMixin)for(const[k,O]of Object.entries(L.envMixin))this._ptyOptions.env||={},this._ptyOptions.env[k]=O;if(L.filesToCopy)for(const k of L.filesToCopy){await a.promises.mkdir(P.dirname(k.dest),{recursive:!0});try{await a.promises.copyFile(k.source,k.dest)}catch{}}}else this._onDidChangeProperty.fire({type:c.ProcessPropertyType.FailedShellIntegrationActivation,value:!0});try{return await this.setupPtyProcess(this.shellLaunchConfig,this._ptyOptions,L),L?.newArgs?{injectedArgs:L.newArgs}:void 0}catch(k){return this._logService.trace("node-pty.node-pty.IPty#spawn native exception",k),{message:`A native exception occurred during launch (${k.message})`}}}async _validateCwd(){try{if(!(await a.promises.stat(this._initialCwd)).isDirectory())return{message:(0,w.localize)(11159,null,this._initialCwd.toString())}}catch(F){if(F?.code==="ENOENT")return{message:(0,w.localize)(11160,null,this._initialCwd.toString())}}this._onDidChangeProperty.fire({type:c.ProcessPropertyType.InitialCwd,value:this._initialCwd})}async _validateExecutable(){const F=this.shellLaunchConfig;if(!F.executable)throw new Error("IShellLaunchConfig.executable not set");const S=F.cwd instanceof r.URI?F.cwd.path:F.cwd,L=F.env&&F.env.PATH?F.env.PATH.split(P.delimiter):void 0,k=await(0,h.findExecutable)(F.executable,S,L,this._executableEnv);if(!k)return{message:(0,w.localize)(11161,null,F.executable)};try{const O=await a.promises.stat(k);if(!O.isFile()&&!O.isSymbolicLink())return{message:(0,w.localize)(11162,null,F.executable)};F.executable=k}catch(O){if(O?.code!=="EACCES")throw O}}async setupPtyProcess(F,S,L){const k=L?.newArgs||F.args||[];await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#spawn",F.executable,k,S);const O=(0,u.spawn)(F.executable,k,S);this._ptyProcess=O,this._childProcessMonitor=this._register(new l.ChildProcessMonitor(O.pid,this._logService)),this._childProcessMonitor.onDidChangeHasChildProcesses(x=>this._onDidChangeProperty.fire({type:c.ProcessPropertyType.HasChildProcesses,value:x})),this._processStartupComplete=new Promise(x=>{this.onProcessReady(()=>x())}),O.onData(x=>{this._unacknowledgedCharCount+=x.length,!this._isPtyPaused&&this._unacknowledgedCharCount>c.FlowControlConstants.HighWatermarkChars&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > ${c.FlowControlConstants.HighWatermarkChars})`),this._isPtyPaused=!0,O.pause()),this._logService.trace("node-pty.IPty#onData",x),this._onProcessData.fire(x),this._closeTimeout&&this._queueProcessExit(),this._windowsShellHelper?.checkShell(),this._childProcessMonitor?.handleOutput()}),O.onExit(x=>{this._exitCode=x.exitCode,this._queueProcessExit()}),this._sendProcessId(O.pid),this._setupTitlePolling(O)}_setupTitlePolling(F){setTimeout(()=>this._sendProcessTitle(F)),g.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==F.process&&this._sendProcessTitle(F)},200))}_queueProcessExit(){this._logService.getLevel()===p.LogLevel.Trace&&this._logService.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>{this._closeTimeout=void 0,this._kill()},b.DataFlushTimeout)}async _kill(){if(await this._processStartupComplete,!this._store.isDisposed){try{this._ptyProcess&&(await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#kill"),this._ptyProcess.kill())}catch{}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}async _throttleKillSpawn(){if(!(!g.isWindows||!("useConpty"in this._ptyOptions)||!this._ptyOptions.useConpty)){for(;Date.now()-v._lastKillOrStart<o.KillSpawnThrottleInterval;)this._logService.trace("Throttling kill/spawn call"),await(0,D.timeout)(o.KillSpawnThrottleInterval-(Date.now()-v._lastKillOrStart)+o.KillSpawnSpacingDuration);v._lastKillOrStart=Date.now()}}_sendProcessId(F){this._onProcessReady.fire({pid:F,cwd:this._initialCwd,windowsPty:this.getWindowsPty()})}_sendProcessTitle(F){if(this._store.isDisposed)return;this._currentTitle=F.process??"",this._onDidChangeProperty.fire({type:c.ProcessPropertyType.Title,value:this._currentTitle});const S=this.currentTitle.replace(/ \(figterm\)$/g,"");S.toLowerCase().startsWith("python")?this._onDidChangeProperty.fire({type:c.ProcessPropertyType.ShellType,value:c.PosixShellType.Python}):this._onDidChangeProperty.fire({type:c.ProcessPropertyType.ShellType,value:s.get(S)})}shutdown(F){this._logService.getLevel()===p.LogLevel.Trace&&this._logService.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),F&&!g.isWindows?this._kill():!this._closeTimeout&&!this._store.isDisposed&&(this._queueProcessExit(),setTimeout(()=>{this._closeTimeout&&!this._store.isDisposed&&(this._closeTimeout=void 0,this._kill())},b.MaximumShutdownTime))}input(F,S=!1){this._store.isDisposed||!this._ptyProcess||(this._writeQueue.push(...(0,n.chunkInput)(F).map(L=>({isBinary:S,data:L}))),this._startWrite())}async processBinary(F){this.input(F,!0)}async refreshProperty(F){switch(F){case c.ProcessPropertyType.Cwd:{const S=await this.getCwd();return S!==this._properties.cwd&&(this._properties.cwd=S,this._onDidChangeProperty.fire({type:c.ProcessPropertyType.Cwd,value:this._properties.cwd})),S}case c.ProcessPropertyType.InitialCwd:{const S=await this.getInitialCwd();return S!==this._properties.initialCwd&&(this._properties.initialCwd=S,this._onDidChangeProperty.fire({type:c.ProcessPropertyType.InitialCwd,value:this._properties.initialCwd})),S}case c.ProcessPropertyType.Title:return this.currentTitle;default:return this.shellType}}async updateProperty(F,S){F===c.ProcessPropertyType.FixedDimensions&&(this._properties.fixedDimensions=S)}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},o.WriteInterval)}}_doWrite(){const F=this._writeQueue.shift();this._logService.trace("node-pty.IPty#write",F.data),F.isBinary?this._ptyProcess.write(Buffer.from(F.data,"binary")):this._ptyProcess.write(F.data),this._childProcessMonitor?.handleInput()}resize(F,S){if(!this._store.isDisposed&&!(typeof F!="number"||typeof S!="number"||isNaN(F)||isNaN(S))&&this._ptyProcess){if(F=Math.max(F,1),S=Math.max(S,1),this._delayedResizer){this._delayedResizer.cols=F,this._delayedResizer.rows=S;return}this._logService.trace("node-pty.IPty#resize",F,S);try{this._ptyProcess.resize(F,S)}catch(L){if(this._logService.trace("node-pty.IPty#resize exception "+L.message),this._exitCode!==void 0&&L.message!=="ioctl(2) failed, EBADF"&&L.message!=="Cannot resize a pty that has already exited")throw L}}}clearBuffer(){this._ptyProcess?.clear()}acknowledgeDataEvent(F){this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-F,0),this._logService.trace(`Flow control: Ack ${F} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<c.FlowControlConstants.LowWatermarkChars&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < ${c.FlowControlConstants.LowWatermarkChars})`),this._ptyProcess?.resume(),this._isPtyPaused=!1)}clearUnacknowledgedChars(){this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&(this._ptyProcess?.resume(),this._isPtyPaused=!1)}async setUnicodeVersion(F){}getInitialCwd(){return Promise.resolve(this._initialCwd)}async getCwd(){if(g.isMacintosh)return new Promise(F=>{if(!this._ptyProcess){F(this._initialCwd);return}this._logService.trace("node-pty.IPty#pid"),(0,t.exec)("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(S,L,k)=>{!S&&L!==""?F(L.substring(L.indexOf("/"),L.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",S,L,k),F(this._initialCwd))})});if(g.isLinux){if(!this._ptyProcess)return this._initialCwd;this._logService.trace("node-pty.IPty#pid");try{return await a.promises.readlink(`/proc/${this._ptyProcess.pid}/cwd`)}catch{return this._initialCwd}}return this._initialCwd}getWindowsPty(){return g.isWindows?{backend:"useConpty"in this._ptyOptions&&this._ptyOptions.useConpty?"conpty":"winpty",buildNumber:(0,h.getWindowsBuildNumber)()}:void 0}};e.TerminalProcess=i,e.TerminalProcess=i=v=_e([We(7,p.ILogService),We(8,f.IProductService)],i);class _ extends W.Disposable{get onTrigger(){return this._onTrigger.event}constructor(){super(),this._onTrigger=this._register(new y.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register((0,W.toDisposable)(()=>clearTimeout(this._timeout)))}}}),define(he[99],fe([0,1,29,11,4,2,3,62,8,90,16,92,40,42,98,12,41,91,7,95,94,71,14,103,104]),function(ie,e,a,t,D,y,W,P,g,r,w,p,f,c,l,h,d,u,n,v,b,o,s,i,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyService=void 0,e.traceRpc=A,i=De(i);function A(U,I,C){if(typeof C.value!="function")throw new Error("not supported");const B="value",Y=C.value;C[B]=async function(...G){this.traceRpcArgs.logService.getLevel()===g.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${Y.name}(${G.map(se=>JSON.stringify(se)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,t.timeout)(this.traceRpcArgs.simulatedLatency);let Z;try{Z=await Y.apply(this,G)}catch(se){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${Y.name}`,se),se}return this.traceRpcArgs.logService.getLevel()===g.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${Y.name}`,Z),Z}}let F,S;class L extends y.Disposable{_traceEvent(I,C){return C(B=>{this._logService.getLevel()===g.LogLevel.Trace&&this._logService.trace(`[RPC Event] PtyService#${I}.fire(${JSON.stringify(B)})`)}),C}get traceRpcArgs(){return{logService:this._logService,simulatedLatency:this._simulatedLatency}}constructor(I,C,B,Y){super(),this._logService=I,this._productService=C,this._reconnectConstants=B,this._simulatedLatency=Y,this._ptys=new Map,this._workspaceLayoutInfos=new Map,this._revivedPtyIdMap=new Map,this._autoReplies=new Map,this._lastPtyId=0,this._onHeartbeat=this._register(new D.Emitter),this.onHeartbeat=this._traceEvent("_onHeartbeat",this._onHeartbeat.event),this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._traceEvent("_onProcessData",this._onProcessData.event),this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._traceEvent("_onProcessReplay",this._onProcessReplay.event),this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._traceEvent("_onProcessReady",this._onProcessReady.event),this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._traceEvent("_onProcessExit",this._onProcessExit.event),this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._traceEvent("_onProcessOrphanQuestion",this._onProcessOrphanQuestion.event),this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._traceEvent("_onDidRequestDetach",this._onDidRequestDetach.event),this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._traceEvent("_onDidChangeProperty",this._onDidChangeProperty.event),this._register((0,y.toDisposable)(()=>{for(const G of this._ptys.values())G.shutdown(!0);this._ptys.clear()})),this._detachInstanceRequestStore=this._register(new r.RequestStore(void 0,this._logService)),this._detachInstanceRequestStore.onCreateRequest(this._onDidRequestDetach.fire,this._onDidRequestDetach)}async refreshIgnoreProcessNames(I){d.ignoreProcessNames.length=0,d.ignoreProcessNames.push(...I)}async requestDetachInstance(I,C){return this._detachInstanceRequestStore.createRequest({workspaceId:I,instanceId:C})}async acceptDetachInstanceReply(I,C){let B;const Y=this._ptys.get(C);Y&&(B=await this._buildProcessDetails(C,Y)),this._detachInstanceRequestStore.acceptReply(I,B)}async freePortKillProcess(I){const B=(await new Promise((Y,G)=>{(0,a.exec)(W.isWindows?`netstat -ano | findstr "${I}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${I}`,{},(Z,se)=>{if(Z)return G("Problem occurred when listing active processes");Y(se)})})).split(/\r?\n/).filter(Y=>!!Y.trim());if(B.length>=1){const Y=/\s+(\d+)(?:\s+|$)/,G=B[0].match(Y)?.[1];if(G)try{process.kill(Number.parseInt(G))}catch{}else throw new Error(`Processes for port ${I} were not found`);return{port:I,processId:G}}throw new Error(`Could not kill process with port ${I}`)}async serializeTerminalState(I){const C=[];for(const[Y,G]of this._ptys.entries())G.hasWrittenData&&I.indexOf(Y)!==-1&&C.push(t.Promises.withAsyncBody(async Z=>{Z({id:Y,shellLaunchConfig:G.shellLaunchConfig,processDetails:await this._buildProcessDetails(Y,G),processLaunchConfig:G.processLaunchOptions,unicodeVersion:G.unicodeVersion,replayEvent:await G.serializeNormalBuffer(),timestamp:Date.now()})}));const B={version:1,state:await Promise.all(C)};return JSON.stringify(B)}async reviveTerminalProcesses(I,C,B){const Y=[];for(const G of C)Y.push(this._reviveTerminalProcess(I,G));await Promise.all(Y)}async _reviveTerminalProcess(I,C){const B=(0,h.localize)(11163,null),Y=await this.createProcess({...C.shellLaunchConfig,cwd:C.processDetails.cwd,color:C.processDetails.color,icon:C.processDetails.icon,name:C.processDetails.titleSource===w.TitleEventSource.Api?C.processDetails.title:void 0,initialText:C.replayEvent.events[0].data+(0,b.formatMessageForTerminal)(B,{loudFormatting:!0})},C.processDetails.cwd,C.replayEvent.events[0].cols,C.replayEvent.events[0].rows,C.unicodeVersion,C.processLaunchConfig.env,C.processLaunchConfig.executableEnv,C.processLaunchConfig.options,!0,C.processDetails.workspaceId,C.processDetails.workspaceName,!0,C.replayEvent.events[0].data),G=this._getRevivingProcessId(I,C.id);this._revivedPtyIdMap.set(G,{newId:Y,state:C}),this._logService.info(`Revived process, old id ${G} -> new id ${Y}`)}async shutdownAll(){this.dispose()}async createProcess(I,C,B,Y,G,Z,se,le,V,z,Q,ee,ue){if(I.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const $=++this._lastPtyId,ae=new l.TerminalProcess(I,C,B,Y,Z,se,le,this._logService,this._productService),me={env:Z,executableEnv:se,options:le},te=new O($,ae,z,Q,V,B,Y,me,G,this._reconnectConstants,this._logService,ee&&typeof I.initialText=="string"?I.initialText:void 0,ue,I.icon,I.color,I.name,I.fixedDimensions);return ae.onProcessExit(m=>{te.dispose(),this._ptys.delete($),this._onProcessExit.fire({id:$,event:m})}),te.onProcessData(m=>this._onProcessData.fire({id:$,event:m})),te.onProcessReplay(m=>this._onProcessReplay.fire({id:$,event:m})),te.onProcessReady(m=>this._onProcessReady.fire({id:$,event:m})),te.onProcessOrphanQuestion(()=>this._onProcessOrphanQuestion.fire({id:$})),te.onDidChangeProperty(m=>this._onDidChangeProperty.fire({id:$,property:m})),te.onPersistentProcessReady(()=>{for(const m of this._autoReplies.entries())te.installAutoReply(m[0],m[1])}),this._ptys.set($,te),$}async attachToProcess(I){try{await this._throwIfNoPty(I).attach(),this._logService.info(`Persistent process reconnection "${I}"`)}catch(C){throw this._logService.warn(`Persistent process reconnection "${I}" failed`,C.message),C}}async updateTitle(I,C,B){this._throwIfNoPty(I).setTitle(C,B)}async updateIcon(I,C,B,Y){this._throwIfNoPty(I).setIcon(C,B,Y)}async clearBuffer(I){this._throwIfNoPty(I).clearBuffer()}async refreshProperty(I,C){return this._throwIfNoPty(I).refreshProperty(C)}async updateProperty(I,C,B){return this._throwIfNoPty(I).updateProperty(C,B)}async detachFromProcess(I,C){return this._throwIfNoPty(I).detach(C)}async reduceConnectionGraceTime(){for(const I of this._ptys.values())I.reduceGraceTime()}async listProcesses(){const I=Array.from(this._ptys.entries()).filter(([Y,G])=>G.shouldPersistTerminal);this._logService.info(`Listing ${I.length} persistent terminals, ${this._ptys.size} total terminals`);const C=I.map(async([Y,G])=>this._buildProcessDetails(Y,G));return(await Promise.all(C)).filter(Y=>Y.isOrphan)}async getPerformanceMarks(){return i.getMarks()}async start(I){const C=this._ptys.get(I);return C?C.start():{message:`Could not find pty with id "${I}"`}}async shutdown(I,C){return this._ptys.get(I)?.shutdown(C)}async input(I,C){return this._throwIfNoPty(I).input(C)}async processBinary(I,C){return this._throwIfNoPty(I).writeBinary(C)}async resize(I,C,B){return this._throwIfNoPty(I).resize(C,B)}async getInitialCwd(I){return this._throwIfNoPty(I).getInitialCwd()}async getCwd(I){return this._throwIfNoPty(I).getCwd()}async acknowledgeDataEvent(I,C){return this._throwIfNoPty(I).acknowledgeDataEvent(C)}async setUnicodeVersion(I,C){return this._throwIfNoPty(I).setUnicodeVersion(C)}async getLatency(){return[]}async orphanQuestionReply(I){return this._throwIfNoPty(I).orphanQuestionReply()}async installAutoReply(I,C){this._autoReplies.set(I,C);for(const B of this._ptys.values())B.installAutoReply(I,C)}async uninstallAllAutoReplies(){for(const I of this._autoReplies.keys())for(const C of this._ptys.values())C.uninstallAutoReply(I)}async uninstallAutoReply(I){for(const C of this._ptys.values())C.uninstallAutoReply(I)}async getDefaultSystemShell(I=W.OS){return(0,P.getSystemShell)(I,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(I,C){if(C==="win-to-unix"){if(!W.isWindows)return I;if((0,c.getWindowsBuildNumber)()<17063)return I.replace(/\\/g,"/");const B=this._getWSLExecutablePath();return B?new Promise(Y=>{(0,a.execFile)(B,["-e","wslpath",I],{},(Z,se,le)=>{Y(Z?I:(0,f.escapeNonWindowsPath)(se.trim()))}).stdin.end()}):I}if(C==="unix-to-win"&&W.isWindows){if((0,c.getWindowsBuildNumber)()<17063)return I;const B=this._getWSLExecutablePath();return B?new Promise(Y=>{(0,a.execFile)(B,["-e","wslpath","-w",I],{},(Z,se,le)=>{Y(Z?I:se.trim())}).stdin.end()}):I}return I}_getWSLExecutablePath(){const I=(0,c.getWindowsBuildNumber)()>=16299,C=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),B=process.env.SystemRoot;if(B)return(0,o.join)(B,C?"Sysnative":"System32",I?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(I,C){try{return this._revivedPtyIdMap.get(this._getRevivingProcessId(I,C))?.newId}catch(B){this._logService.warn(`Couldn't find terminal ID ${I}-${C}`,B.message)}}async setTerminalLayoutInfo(I){this._workspaceLayoutInfos.set(I.workspaceId,I)}async getTerminalLayoutInfo(I){i.mark("code/willGetTerminalLayoutInfo");const C=this._workspaceLayoutInfos.get(I.workspaceId);if(C){const B=new Set,G=(await Promise.all(C.tabs.map(async Z=>this._expandTerminalTab(I.workspaceId,Z,B)))).filter(Z=>Z.terminals.length>0);return i.mark("code/didGetTerminalLayoutInfo"),{tabs:G}}i.mark("code/didGetTerminalLayoutInfo")}async _expandTerminalTab(I,C,B){const G=(await Promise.all(C.terminals.map(Z=>this._expandTerminalInstance(I,Z,B)))).filter(Z=>Z.terminal!==null);return{isActive:C.isActive,activePersistentProcessId:C.activePersistentProcessId,terminals:G}}async _expandTerminalInstance(I,C,B){try{const Y=this._getRevivingProcessId(I,C.terminal),G=this._revivedPtyIdMap.get(Y)?.newId;this._logService.info(`Expanding terminal instance, old id ${Y} -> new id ${G}`),this._revivedPtyIdMap.delete(Y);const Z=G??C.terminal;if(B.has(Z))throw new Error(`Terminal ${Z} has already been expanded`);B.add(Z);const se=this._throwIfNoPty(Z);return{terminal:{...se&&await this._buildProcessDetails(C.terminal,se,G!==void 0),id:Z},relativeSize:C.relativeSize}}catch(Y){return this._logService.warn("Couldn't get layout info, a terminal was probably disconnected",Y.message),this._logService.debug("Reattach to wrong terminal debug info - layout info by id",C),this._logService.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this._revivedPtyIdMap.values())),this._logService.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this._ptys.keys())),{terminal:null,relativeSize:C.relativeSize}}}_getRevivingProcessId(I,C){return`${I}-${C}`}async _buildProcessDetails(I,C,B=!1){i.mark(`code/willBuildProcessDetails/${I}`);const[Y,G]=await Promise.all([C.getCwd(),B?!0:C.isOrphaned()]),Z={id:I,title:C.title,titleSource:C.titleSource,pid:C.pid,workspaceId:C.workspaceId,workspaceName:C.workspaceName,cwd:Y,isOrphan:G,icon:C.icon,color:C.color,fixedDimensions:C.fixedDimensions,environmentVariableCollections:C.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:C.shellLaunchConfig.reconnectionProperties,waitOnExit:C.shellLaunchConfig.waitOnExit,hideFromUser:C.shellLaunchConfig.hideFromUser,isFeatureTerminal:C.shellLaunchConfig.isFeatureTerminal,type:C.shellLaunchConfig.type,hasChildProcesses:C.hasChildProcesses,shellIntegrationNonce:C.processLaunchOptions.options.shellIntegration.nonce};return i.mark(`code/didBuildProcessDetails/${I}`),Z}_throwIfNoPty(I){const C=this._ptys.get(I);if(!C)throw new n.ErrorNoTelemetry("Could not find pty on pty host");return C}}e.PtyService=L,_e([s.memoize],L.prototype,"traceRpcArgs",null),_e([A],L.prototype,"refreshIgnoreProcessNames",null),_e([A],L.prototype,"requestDetachInstance",null),_e([A],L.prototype,"acceptDetachInstanceReply",null),_e([A],L.prototype,"freePortKillProcess",null),_e([A],L.prototype,"serializeTerminalState",null),_e([A],L.prototype,"reviveTerminalProcesses",null),_e([A],L.prototype,"shutdownAll",null),_e([A],L.prototype,"createProcess",null),_e([A],L.prototype,"attachToProcess",null),_e([A],L.prototype,"updateTitle",null),_e([A],L.prototype,"updateIcon",null),_e([A],L.prototype,"clearBuffer",null),_e([A],L.prototype,"refreshProperty",null),_e([A],L.prototype,"updateProperty",null),_e([A],L.prototype,"detachFromProcess",null),_e([A],L.prototype,"reduceConnectionGraceTime",null),_e([A],L.prototype,"listProcesses",null),_e([A],L.prototype,"getPerformanceMarks",null),_e([A],L.prototype,"start",null),_e([A],L.prototype,"shutdown",null),_e([A],L.prototype,"input",null),_e([A],L.prototype,"processBinary",null),_e([A],L.prototype,"resize",null),_e([A],L.prototype,"getInitialCwd",null),_e([A],L.prototype,"getCwd",null),_e([A],L.prototype,"acknowledgeDataEvent",null),_e([A],L.prototype,"setUnicodeVersion",null),_e([A],L.prototype,"getLatency",null),_e([A],L.prototype,"orphanQuestionReply",null),_e([A],L.prototype,"installAutoReply",null),_e([A],L.prototype,"uninstallAllAutoReplies",null),_e([A],L.prototype,"uninstallAutoReply",null),_e([A],L.prototype,"getDefaultSystemShell",null),_e([A],L.prototype,"getEnvironment",null),_e([A],L.prototype,"getWslPath",null),_e([A],L.prototype,"getRevivedPtyNewId",null),_e([A],L.prototype,"setTerminalLayoutInfo",null),_e([A],L.prototype,"getTerminalLayoutInfo",null);var k;(function(U){U.None="None",U.ReplayOnly="ReplayOnly",U.Session="Session"})(k||(k={}));class O extends y.Disposable{get pid(){return this._pid}get shellLaunchConfig(){return this._terminalProcess.shellLaunchConfig}get hasWrittenData(){return this._interactionState.value!==k.None}get title(){return this._title||this._terminalProcess.currentTitle}get titleSource(){return this._titleSource}get icon(){return this._icon}get color(){return this._color}get fixedDimensions(){return this._fixedDimensions}get hasChildProcesses(){return this._terminalProcess.hasChildProcesses}setTitle(I,C){C===w.TitleEventSource.Api&&(this._interactionState.setValue(k.Session,"setTitle"),this._serializer.freeRawReviveBuffer()),this._title=I,this._titleSource=C}setIcon(I,C,B){(!this._icon||"id"in C&&"id"in this._icon&&C.id!==this._icon.id||!this.color||B!==this._color)&&(this._serializer.freeRawReviveBuffer(),I&&this._interactionState.setValue(k.Session,"setIcon")),this._icon=C,this._color=B}_setFixedDimensions(I){this._fixedDimensions=I}constructor(I,C,B,Y,G,Z,se,le,V,z,Q,ee,ue,$,ae,me,te){super(),this._persistentProcessId=I,this._terminalProcess=C,this.workspaceId=B,this.workspaceName=Y,this.shouldPersistTerminal=G,this.processLaunchOptions=le,this.unicodeVersion=V,this._logService=Q,this._icon=$,this._color=ae,this._autoReplies=new Map,this._pendingCommands=new Map,this._isStarted=!1,this._orphanRequestQueue=new t.Queue,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onPersistentProcessReady=this._register(new D.Emitter),this.onPersistentProcessReady=this._onPersistentProcessReady.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._inReplay=!1,this._pid=-1,this._cwd="",this._titleSource=w.TitleEventSource.Process,this._interactionState=new x(`Persistent process "${this._persistentProcessId}" interaction state`,k.None,this._logService),this._wasRevived=ee!==void 0,this._serializer=new R(Z,se,z.scrollback,V,ee,le.options.shellIntegration.nonce,G?ue:void 0,this._logService),me&&this.setTitle(me,w.TitleEventSource.Api),this._fixedDimensions=te,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new t.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The reconnection grace time of ${E(z.graceTime)} has expired, shutting down pid "${this._pid}"`),this.shutdown(!0)},z.graceTime)),this._disconnectRunner2=this._register(new t.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The short reconnection grace time of ${E(z.shortGraceTime)} has expired, shutting down pid ${this._pid}`),this.shutdown(!0)},z.shortGraceTime)),this._register(this._terminalProcess.onProcessExit(()=>this._bufferer.stopBuffering(this._persistentProcessId))),this._register(this._terminalProcess.onProcessReady(m=>{this._pid=m.pid,this._cwd=m.cwd,this._onProcessReady.fire(m)})),this._register(this._terminalProcess.onDidChangeProperty(m=>{this._onDidChangeProperty.fire(m)})),this._bufferer=new p.TerminalDataBufferer((m,j)=>this._onProcessData.fire(j)),this._register(this._bufferer.startBuffering(this._persistentProcessId,this._terminalProcess.onProcessData)),this._register(this.onProcessData(m=>this._serializer.handleData(m))),this._register((0,y.toDisposable)(()=>{for(const m of this._autoReplies.values())m.dispose();this._autoReplies.clear()}))}async attach(){!this._disconnectRunner1.isScheduled()&&!this._disconnectRunner2.isScheduled()&&this._logService.warn(`Persistent process "${this._persistentProcessId}": Process had no disconnect runners but was an orphan`),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel()}async detach(I){this.shouldPersistTerminal&&(this._interactionState.value!==k.None||I)?this._disconnectRunner1.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this._serializer.generateReplayEvent(!0,this._interactionState.value!==k.Session)}async refreshProperty(I){return this._terminalProcess.refreshProperty(I)}async updateProperty(I,C){if(I===w.ProcessPropertyType.FixedDimensions)return this._setFixedDimensions(C)}async start(){if(!this._isStarted){const I=await this._terminalProcess.start();return I&&"message"in I||(this._isStarted=!0,this._wasRevived?this.triggerReplay():this._onPersistentProcessReady.fire()),I}this._onProcessReady.fire({pid:this._pid,cwd:this._cwd,windowsPty:this._terminalProcess.getWindowsPty()}),this._onDidChangeProperty.fire({type:w.ProcessPropertyType.Title,value:this._terminalProcess.currentTitle}),this._onDidChangeProperty.fire({type:w.ProcessPropertyType.ShellType,value:this._terminalProcess.shellType}),this.triggerReplay()}shutdown(I){return this._terminalProcess.shutdown(I)}input(I){if(this._interactionState.setValue(k.Session,"input"),this._serializer.freeRawReviveBuffer(),!this._inReplay){for(const C of this._autoReplies.values())C.handleInput();return this._terminalProcess.input(I)}}writeBinary(I){return this._terminalProcess.processBinary(I)}resize(I,C){if(!this._inReplay){this._serializer.handleResize(I,C),this._bufferer.flushBuffer(this._persistentProcessId);for(const B of this._autoReplies.values())B.handleResize();return this._terminalProcess.resize(I,C)}}async clearBuffer(){this._serializer.clearBuffer(),this._terminalProcess.clearBuffer()}setUnicodeVersion(I){this.unicodeVersion=I,this._serializer.setUnicodeVersion?.(I)}acknowledgeDataEvent(I){if(!this._inReplay)return this._terminalProcess.acknowledgeDataEvent(I)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}async triggerReplay(){this._interactionState.value===k.None&&this._interactionState.setValue(k.ReplayOnly,"triggerReplay");const I=await this._serializer.generateReplayEvent();let C=0;for(const B of I.events)C+=B.data.length;this._logService.info(`Persistent process "${this._persistentProcessId}": Replaying ${C} chars and ${I.events.length} size events`),this._onProcessReplay.fire(I),this._terminalProcess.clearUnacknowledgedChars(),this._onPersistentProcessReady.fire()}installAutoReply(I,C){this._autoReplies.get(I)?.dispose(),this._autoReplies.set(I,new u.TerminalAutoResponder(this._terminalProcess,I,C,this._logService))}uninstallAutoReply(I){this._autoReplies.get(I)?.dispose(),this._autoReplies.delete(I)}sendCommandResult(I,C,B){this._pendingCommands.get(I)&&this._pendingCommands.delete(I)}orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const I=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,I.open()}}reduceGraceTime(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){return this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled()?!0:(this._orphanQuestionBarrier||(this._orphanQuestionBarrier=new t.AutoOpenBarrier(4e3),this._orphanQuestionReplyTime=0,this._onProcessOrphanQuestion.fire()),await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500)}}class x{get value(){return this._value}setValue(I,C){this._value!==I&&(this._value=I,this._log(C))}constructor(I,C,B){this._name=I,this._value=C,this._logService=B,this._log("initialized")}_log(I){this._logService.debug(`MutationLogger "${this._name}" set to "${this._value}", reason: ${I}`)}}class R{constructor(I,C,B,Y,G,Z,se,le){this._rawReviveBuffer=se,this._xterm=new _.Terminal({cols:I,rows:C,scrollback:B,allowProposedApi:!0}),G&&this._xterm.writeln(G),this.setUnicodeVersion(Y),this._shellIntegrationAddon=new v.ShellIntegrationAddon(Z,!0,void 0,le),this._xterm.loadAddon(this._shellIntegrationAddon)}freeRawReviveBuffer(){this._rawReviveBuffer=void 0}handleData(I){this._xterm.write(I)}handleResize(I,C){this._xterm.resize(I,C)}clearBuffer(){this._xterm.clear()}async generateReplayEvent(I,C){const B=new(await this._getSerializeConstructor());this._xterm.loadAddon(B);const Y={scrollback:this._xterm.options.scrollback};I&&(Y.excludeAltBuffer=!0,Y.excludeModes=!0);let G;return C&&this._rawReviveBuffer?G=this._rawReviveBuffer:G=B.serialize(Y),{events:[{cols:this._xterm.cols,rows:this._xterm.rows,data:G}],commands:this._shellIntegrationAddon.serialize()}}async setUnicodeVersion(I){this._xterm.unicode.activeVersion!==I&&(I==="11"?(this._unicodeAddon=new(await this._getUnicode11Constructor()),this._xterm.loadAddon(this._unicodeAddon)):(this._unicodeAddon?.dispose(),this._unicodeAddon=void 0),this._xterm.unicode.activeVersion=I)}async _getUnicode11Constructor(){return S||(S=(await new Promise((I,C)=>{ie(["@xterm/addon-unicode11"],I,C)}).then(De)).Unicode11Addon),S}async _getSerializeConstructor(){return F||(F=(await new Promise((I,C)=>{ie(["@xterm/addon-serialize"],I,C)}).then(De)).SerializeAddon),F}}function E(U){let I=0,C=0,B=0;U>=1e3&&(B=Math.floor(U/1e3),U-=B*1e3),B>=60&&(C=Math.floor(B/60),B-=C*60),C>=60&&(I=Math.floor(C/60),C-=I*60);const Y=I?`${I}h`:"",G=C?`${C}m`:"",Z=B?`${B}s`:"",se=U?`${U}ms`:"";return`${Y}${G}${Z}${se}`}});var Ve=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[105],fe([0,1,58,30,63,64,12,69,72,8,74,75,77,78,16,96,99,37,11,2]),function(ie,e,a,t,D,y,W,P,g,r,w,p,f,c,l,h,d,u,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),c=Ve(c),b();async function b(){const o=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),s=parseInt(process.env.VSCODE_LATENCY??"0"),i={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,o&&await(0,n.timeout)(o);const _=(0,u.isUtilityProcess)(process);let A;_?A=new y.Server:A=new D.Server(l.TerminalIpcChannels.PtyHost);const F={_serviceBrand:void 0,...c.default},S=new g.NativeEnvironmentService((0,P.parseArgs)(process.argv,P.OPTIONS),F),L=new f.LoggerService((0,r.getLogLevel)(S),S.logsHome);A.registerChannel(l.TerminalIpcChannels.Logger,new w.LoggerChannel(L,()=>a.DefaultURITransformer));const k=L.createLogger("ptyhost",{name:(0,W.localize)(11164,null)}),O=new p.LogService(k);o&&O.warn(`Pty Host startup is delayed ${o}ms`),s&&O.warn(`Pty host is simulating ${s}ms latency`);const x=new v.DisposableStore,R=new h.HeartbeatService;A.registerChannel(l.TerminalIpcChannels.Heartbeat,t.ProxyChannel.fromService(R,x));const E=new d.PtyService(O,F,i,s),U=t.ProxyChannel.fromService(E,x);A.registerChannel(l.TerminalIpcChannels.PtyHost,U),_&&A.registerChannel(l.TerminalIpcChannels.PtyHostWindow,U),process.once("exit",()=>{O.trace("Pty host exiting"),O.dispose(),R.dispose(),E.dispose()})}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/platform/terminal/node/ptyHostMain.js.map
