/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/nls","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(pe){for(var e=[],r=0,d=pe.length;r<d;r++)e[r]=Ce[pe[r]];return e};define(Ce[174],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.isESM=void 0,e.isESM=!1;var r;(function(P){P[P.LoaderAvailable=1]="LoaderAvailable",P[P.BeginLoadingScript=10]="BeginLoadingScript",P[P.EndLoadingScriptOK=11]="EndLoadingScriptOK",P[P.EndLoadingScriptError=12]="EndLoadingScriptError",P[P.BeginInvokeFactory=21]="BeginInvokeFactory",P[P.EndInvokeFactory=22]="EndInvokeFactory",P[P.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",P[P.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",P[P.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",P[P.NodeEndNativeRequire=34]="NodeEndNativeRequire",P[P.CachedDataFound=60]="CachedDataFound",P[P.CachedDataMissed=61]="CachedDataMissed",P[P.CachedDataRejected=62]="CachedDataRejected",P[P.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class d{static get(){const k=new Map,L=new Map,R=new Map,v=new Map;function l(b,a){b.has(a.detail)||b.set(a.detail,-a.timestamp)}function I(b,a){const m=b.get(a.detail);m&&(m>=0||b.set(a.detail,m+a.timestamp))}let y=[];typeof pe=="function"&&typeof pe.getStats=="function"&&(y=pe.getStats().slice(0).sort((b,a)=>b.timestamp-a.timestamp));for(const b of y)switch(b.type){case r.BeginLoadingScript:l(k,b);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(k,b);break;case r.BeginInvokeFactory:l(L,b);break;case r.EndInvokeFactory:I(L,b);break;case r.NodeBeginNativeRequire:l(R,b);break;case r.NodeEndNativeRequire:I(R,b);break;case r.NodeBeginEvaluatingScript:l(v,b);break;case r.NodeEndEvaluatingScript:I(v,b);break}let u=0;R.forEach(b=>u+=b);function T(b){const a=[];return b.forEach((m,p)=>a.push([p,m])),a}return{amdLoad:T(k),amdInvoke:T(L),nodeRequire:T(R),nodeEval:T(v),nodeRequireTotal:u}}static toMarkdownTable(k,L){let R="";const v=[];return k.forEach((l,I)=>{v[I]=l.length}),L.forEach(l=>{l.forEach((I,y)=>{typeof I>"u"&&(I=l[y]="-");const u=I.toString().length;v[y]=Math.max(u,v[y])})}),k.forEach((l,I)=>{R+=`| ${l+" ".repeat(v[I]-l.toString().length)} `}),R+=`|
`,k.forEach((l,I)=>{R+=`| ${"-".repeat(v[I])} `}),R+=`|
`,L.forEach(l=>{l.forEach((I,y)=>{typeof I<"u"&&(R+=`| ${I+" ".repeat(v[y]-I.toString().length)} `)}),R+=`|
`}),R}}e.LoaderStats=d}),define(Ce[131],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=r,e.findLastIdx=d,e.findLastMonotonous=P,e.findLastIdxMonotonous=k,e.findFirstMonotonous=L,e.findFirstIdxMonotonousOrArrLen=R,e.findFirstIdxMonotonous=v,e.findFirstMax=I,e.findLastMax=y,e.findFirstMin=u,e.findMaxIdx=T,e.mapFindFirst=b;function r(a,m){const p=d(a,m);if(p!==-1)return a[p]}function d(a,m,p=a.length-1){for(let f=p;f>=0;f--){const i=a[f];if(m(i))return f}return-1}function P(a,m){const p=k(a,m);return p===-1?void 0:a[p]}function k(a,m,p=0,f=a.length){let i=p,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?i=t+1:s=t}return i-1}function L(a,m){const p=R(a,m);return p===a.length?void 0:a[p]}function R(a,m,p=0,f=a.length){let i=p,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?s=t:i=t+1}return i}function v(a,m,p=0,f=a.length){const i=R(a,m,p,f);return i===a.length?-1:i}class l{static{this.assertInvariants=!1}constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const f of this._array)if(this._prevFindLastPredicate(f)&&!m(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const p=k(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=p+1,p===-1?void 0:this._array[p]}}e.MonotonousArray=l;function I(a,m){if(a.length===0)return;let p=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,p)>0&&(p=i)}return p}function y(a,m){if(a.length===0)return;let p=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,p)>=0&&(p=i)}return p}function u(a,m){return I(a,(p,f)=>-m(p,f))}function T(a,m){if(a.length===0)return-1;let p=0;for(let f=1;f<a.length;f++){const i=a[f];m(i,a[p])>0&&(p=f)}return p}function b(a,m){for(const p of a){const f=m(p);if(f!==void 0)return f}}}),define(Ce[26],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(d){d[d.Null=0]="Null",d[d.Backspace=8]="Backspace",d[d.Tab=9]="Tab",d[d.LineFeed=10]="LineFeed",d[d.CarriageReturn=13]="CarriageReturn",d[d.Space=32]="Space",d[d.ExclamationMark=33]="ExclamationMark",d[d.DoubleQuote=34]="DoubleQuote",d[d.Hash=35]="Hash",d[d.DollarSign=36]="DollarSign",d[d.PercentSign=37]="PercentSign",d[d.Ampersand=38]="Ampersand",d[d.SingleQuote=39]="SingleQuote",d[d.OpenParen=40]="OpenParen",d[d.CloseParen=41]="CloseParen",d[d.Asterisk=42]="Asterisk",d[d.Plus=43]="Plus",d[d.Comma=44]="Comma",d[d.Dash=45]="Dash",d[d.Period=46]="Period",d[d.Slash=47]="Slash",d[d.Digit0=48]="Digit0",d[d.Digit1=49]="Digit1",d[d.Digit2=50]="Digit2",d[d.Digit3=51]="Digit3",d[d.Digit4=52]="Digit4",d[d.Digit5=53]="Digit5",d[d.Digit6=54]="Digit6",d[d.Digit7=55]="Digit7",d[d.Digit8=56]="Digit8",d[d.Digit9=57]="Digit9",d[d.Colon=58]="Colon",d[d.Semicolon=59]="Semicolon",d[d.LessThan=60]="LessThan",d[d.Equals=61]="Equals",d[d.GreaterThan=62]="GreaterThan",d[d.QuestionMark=63]="QuestionMark",d[d.AtSign=64]="AtSign",d[d.A=65]="A",d[d.B=66]="B",d[d.C=67]="C",d[d.D=68]="D",d[d.E=69]="E",d[d.F=70]="F",d[d.G=71]="G",d[d.H=72]="H",d[d.I=73]="I",d[d.J=74]="J",d[d.K=75]="K",d[d.L=76]="L",d[d.M=77]="M",d[d.N=78]="N",d[d.O=79]="O",d[d.P=80]="P",d[d.Q=81]="Q",d[d.R=82]="R",d[d.S=83]="S",d[d.T=84]="T",d[d.U=85]="U",d[d.V=86]="V",d[d.W=87]="W",d[d.X=88]="X",d[d.Y=89]="Y",d[d.Z=90]="Z",d[d.OpenSquareBracket=91]="OpenSquareBracket",d[d.Backslash=92]="Backslash",d[d.CloseSquareBracket=93]="CloseSquareBracket",d[d.Caret=94]="Caret",d[d.Underline=95]="Underline",d[d.BackTick=96]="BackTick",d[d.a=97]="a",d[d.b=98]="b",d[d.c=99]="c",d[d.d=100]="d",d[d.e=101]="e",d[d.f=102]="f",d[d.g=103]="g",d[d.h=104]="h",d[d.i=105]="i",d[d.j=106]="j",d[d.k=107]="k",d[d.l=108]="l",d[d.m=109]="m",d[d.n=110]="n",d[d.o=111]="o",d[d.p=112]="p",d[d.q=113]="q",d[d.r=114]="r",d[d.s=115]="s",d[d.t=116]="t",d[d.u=117]="u",d[d.v=118]="v",d[d.w=119]="w",d[d.x=120]="x",d[d.y=121]="y",d[d.z=122]="z",d[d.OpenCurlyBrace=123]="OpenCurlyBrace",d[d.Pipe=124]="Pipe",d[d.CloseCurlyBrace=125]="CloseCurlyBrace",d[d.Tilde=126]="Tilde",d[d.NoBreakSpace=160]="NoBreakSpace",d[d.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",d[d.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",d[d.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",d[d.U_Combining_Tilde=771]="U_Combining_Tilde",d[d.U_Combining_Macron=772]="U_Combining_Macron",d[d.U_Combining_Overline=773]="U_Combining_Overline",d[d.U_Combining_Breve=774]="U_Combining_Breve",d[d.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",d[d.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",d[d.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",d[d.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",d[d.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",d[d.U_Combining_Caron=780]="U_Combining_Caron",d[d.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",d[d.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",d[d.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",d[d.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",d[d.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",d[d.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",d[d.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",d[d.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",d[d.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",d[d.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",d[d.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",d[d.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",d[d.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",d[d.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",d[d.U_Combining_Horn=795]="U_Combining_Horn",d[d.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",d[d.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",d[d.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",d[d.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",d[d.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",d[d.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",d[d.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",d[d.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",d[d.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",d[d.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",d[d.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",d[d.U_Combining_Cedilla=807]="U_Combining_Cedilla",d[d.U_Combining_Ogonek=808]="U_Combining_Ogonek",d[d.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",d[d.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",d[d.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",d[d.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",d[d.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",d[d.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",d[d.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",d[d.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",d[d.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",d[d.U_Combining_Low_Line=818]="U_Combining_Low_Line",d[d.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",d[d.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",d[d.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",d[d.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",d[d.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",d[d.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",d[d.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",d[d.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",d[d.U_Combining_Square_Below=827]="U_Combining_Square_Below",d[d.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",d[d.U_Combining_X_Above=829]="U_Combining_X_Above",d[d.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",d[d.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",d[d.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",d[d.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",d[d.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",d[d.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",d[d.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",d[d.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",d[d.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",d[d.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",d[d.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",d[d.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",d[d.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",d[d.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",d[d.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",d[d.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",d[d.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",d[d.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",d[d.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",d[d.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",d[d.U_Combining_Fermata=850]="U_Combining_Fermata",d[d.U_Combining_X_Below=851]="U_Combining_X_Below",d[d.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",d[d.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",d[d.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",d[d.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",d[d.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",d[d.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",d[d.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",d[d.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",d[d.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",d[d.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",d[d.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",d[d.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",d[d.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",d[d.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",d[d.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",d[d.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",d[d.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",d[d.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",d[d.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",d[d.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",d[d.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",d[d.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",d[d.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",d[d.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",d[d.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",d[d.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",d[d.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",d[d.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",d[d.LINE_SEPARATOR=8232]="LINE_SEPARATOR",d[d.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",d[d.NEXT_LINE=133]="NEXT_LINE",d[d.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",d[d.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",d[d.U_DIAERESIS=168]="U_DIAERESIS",d[d.U_MACRON=175]="U_MACRON",d[d.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",d[d.U_CEDILLA=184]="U_CEDILLA",d[d.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",d[d.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",d[d.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",d[d.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",d[d.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",d[d.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",d[d.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",d[d.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",d[d.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",d[d.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",d[d.U_BREVE=728]="U_BREVE",d[d.U_DOT_ABOVE=729]="U_DOT_ABOVE",d[d.U_RING_ABOVE=730]="U_RING_ABOVE",d[d.U_OGONEK=731]="U_OGONEK",d[d.U_SMALL_TILDE=732]="U_SMALL_TILDE",d[d.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",d[d.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",d[d.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",d[d.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",d[d.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",d[d.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",d[d.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",d[d.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",d[d.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",d[d.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",d[d.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",d[d.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",d[d.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",d[d.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",d[d.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",d[d.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",d[d.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",d[d.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",d[d.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",d[d.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",d[d.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",d[d.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",d[d.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",d[d.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",d[d.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",d[d.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",d[d.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",d[d.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",d[d.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",d[d.U_GREEK_TONOS=900]="U_GREEK_TONOS",d[d.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",d[d.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",d[d.U_GREEK_PSILI=8127]="U_GREEK_PSILI",d[d.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",d[d.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",d[d.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",d[d.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",d[d.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",d[d.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",d[d.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",d[d.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",d[d.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",d[d.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",d[d.U_GREEK_VARIA=8175]="U_GREEK_VARIA",d[d.U_GREEK_OXIA=8189]="U_GREEK_OXIA",d[d.U_GREEK_DASIA=8190]="U_GREEK_DASIA",d[d.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",d[d.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",d[d.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",d[d.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",d[d.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",d[d.U_OVERLINE=8254]="U_OVERLINE",d[d.UTF8_BOM=65279]="UTF8_BOM",d[d.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",d[d.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(Ce[78],Ie([1,0]),function(pe,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=d,e.diffSets=P,e.diffMaps=k,e.intersection=L;function d(v,l){const I=Object.create(null);for(const y of v){const u=l(y);let T=I[u];T||(T=I[u]=[]),T.push(y)}return I}function P(v,l){const I=[],y=[];for(const u of v)l.has(u)||I.push(u);for(const u of l)v.has(u)||y.push(u);return{removed:I,added:y}}function k(v,l){const I=[],y=[];for(const[u,T]of v)l.has(u)||I.push(T);for(const[u,T]of l)v.has(u)||y.push(T);return{removed:I,added:y}}function L(v,l){const I=new Set;for(const y of l)v.has(y)&&I.add(y);return I}class R{static{r=Symbol.toStringTag}constructor(l,I){this.toKey=I,this._map=new Map,this[r]="SetWithKey";for(const y of l)this.add(y)}get size(){return this._map.size}add(l){const I=this.toKey(l);return this._map.set(I,l),this}delete(l){return this._map.delete(this.toKey(l))}has(l){return this._map.has(this.toKey(l))}*entries(){for(const l of this._map.values())yield[l,l]}keys(){return this.values()}*values(){for(const l of this._map.values())yield l}clear(){this._map.clear()}forEach(l,I){this._map.forEach(y=>l.call(I,y,y,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=R}),define(Ce[59],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=d,e.debounce=P,e.throttle=k;function r(L){return(R,v,l)=>{let I=null,y=null;if(typeof l.value=="function"?(I="value",y=l.value):typeof l.get=="function"&&(I="get",y=l.get),!y)throw new Error("not supported");l[I]=L(y,v)}}function d(L,R,v){let l=null,I=null;if(typeof v.value=="function"?(l="value",I=v.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(l="get",I=v.get),!I)throw new Error("not supported");const y=`$memoize$${R}`;v[l]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[y]}}function P(L,R,v){return r((l,I)=>{const y=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...T){this[u]||(this[u]=v?v():void 0),clearTimeout(this[y]),R&&(this[u]=R(this[u],...T),T=[this[u]]),this[y]=setTimeout(()=>{l.apply(this,T),this[u]=v?v():void 0},L)}})}function k(L,R,v){return r((l,I)=>{const y=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,T=`$throttle$lastRun$${I}`,b=`$throttle$pending$${I}`;return function(...a){if(this[u]||(this[u]=v?v():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),R&&(this[u]=R(this[u],...a)),this[b])return;const m=this[T]+L;m<=Date.now()?(this[T]=Date.now(),l.apply(this,[this[u]]),this[u]=v?v():void 0):(this[b]=!0,this[y]=setTimeout(()=>{this[b]=!1,this[T]=Date.now(),l.apply(this,[this[u]]),this[u]=v?v():void 0},m-Date.now()))}})}}),define(Ce[13],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=d,e.isSigPipeError=P,e.onUnexpectedError=k,e.onUnexpectedExternalError=L,e.transformErrorForSerialization=R,e.transformErrorFromSerialization=v,e.isCancellationError=I,e.canceled=u,e.illegalArgument=T,e.illegalState=b,e.getErrorMessage=m;class r{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?s.isErrorNoTelemetry(n)?new s(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(h=>{h(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=r,e.errorHandler=new r;function d(o){e.errorHandler.setUnexpectedErrorHandler(o)}function P(o){if(!o||typeof o!="object")return!1;const n=o;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function k(o){I(o)||e.errorHandler.onUnexpectedError(o)}function L(o){I(o)||e.errorHandler.onUnexpectedExternalError(o)}function R(o){if(o instanceof Error){const{name:n,message:h}=o,c=o.stacktrace||o.stack;return{$isError:!0,name:n,message:h,stack:c,noTelemetry:s.isErrorNoTelemetry(o)}}return o}function v(o){let n;return o.noTelemetry?n=new s:(n=new Error,n.name=o.name),n.message=o.message,n.stack=o.stack,n}const l="Canceled";function I(o){return o instanceof y?!0:o instanceof Error&&o.name===l&&o.message===l}class y extends Error{constructor(){super(l),this.name=this.message}}e.CancellationError=y;function u(){const o=new Error(l);return o.name=o.message,o}function T(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function b(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class a extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=a;function m(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class p extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=p;class f extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=f;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=i;class s extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof s)return n;const h=new s;return h.message=n.message,h.stack=n.stack,h}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=s;class t extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.BugIndicatingError=t}),define(Ce[18],Ie([1,0,13,131]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=P,e.tail2=k,e.equals=L,e.removeFastWithoutKeepingOrder=R,e.binarySearch=v,e.binarySearch2=l,e.quickSelect=I,e.groupBy=y,e.groupAdjacentBy=u,e.forEachAdjacent=T,e.forEachWithNeighbors=b,e.sortedDiff=a,e.delta=m,e.top=p,e.topAsync=f,e.coalesce=s,e.coalesceInPlace=t,e.move=o,e.isFalsyOrEmpty=n,e.isNonEmptyArray=h,e.distinct=c,e.uniqueFilter=g,e.firstOrDefault=w,e.lastOrDefault=D,e.commonPrefixLength=_,e.range=C,e.index=A,e.insert=E,e.remove=S,e.arrayInsert=F,e.shuffle=N,e.pushToStart=O,e.pushToEnd=M,e.pushMany=U,e.mapArrayOrNot=x,e.asArray=z,e.getRandomElement=B,e.insertInto=ee,e.splice=V,e.compareBy=Z,e.tieBreakComparators=le,e.reverseOrder=ge,e.findAsync=Se;function P(te,ae=0){return te[te.length-(1+ae)]}function k(te){if(te.length===0)throw new Error("Invalid tail call");return[te.slice(0,te.length-1),te[te.length-1]]}function L(te,ae,se=(Q,re)=>Q===re){if(te===ae)return!0;if(!te||!ae||te.length!==ae.length)return!1;for(let Q=0,re=te.length;Q<re;Q++)if(!se(te[Q],ae[Q]))return!1;return!0}function R(te,ae){const se=te.length-1;ae<se&&(te[ae]=te[se]),te.pop()}function v(te,ae,se){return l(te.length,Q=>se(te[Q],ae))}function l(te,ae){let se=0,Q=te-1;for(;se<=Q;){const re=(se+Q)/2|0,ve=ae(re);if(ve<0)se=re+1;else if(ve>0)Q=re-1;else return re}return-(se+1)}function I(te,ae,se){if(te=te|0,te>=ae.length)throw new TypeError("invalid index");const Q=ae[Math.floor(ae.length*Math.random())],re=[],ve=[],be=[];for(const Fe of ae){const Be=se(Fe,Q);Be<0?re.push(Fe):Be>0?ve.push(Fe):be.push(Fe)}return te<re.length?I(te,re,se):te<re.length+be.length?be[0]:I(te-(re.length+be.length),ve,se)}function y(te,ae){const se=[];let Q;for(const re of te.slice(0).sort(ae))!Q||ae(Q[0],re)!==0?(Q=[re],se.push(Q)):Q.push(re);return se}function*u(te,ae){let se,Q;for(const re of te)Q!==void 0&&ae(Q,re)?se.push(re):(se&&(yield se),se=[re]),Q=re;se&&(yield se)}function T(te,ae){for(let se=0;se<=te.length;se++)ae(se===0?void 0:te[se-1],se===te.length?void 0:te[se])}function b(te,ae){for(let se=0;se<te.length;se++)ae(se===0?void 0:te[se-1],te[se],se+1===te.length?void 0:te[se+1])}function a(te,ae,se){const Q=[];function re(Fe,Be,ke){if(Be===0&&ke.length===0)return;const De=Q[Q.length-1];De&&De.start+De.deleteCount===Fe?(De.deleteCount+=Be,De.toInsert.push(...ke)):Q.push({start:Fe,deleteCount:Be,toInsert:ke})}let ve=0,be=0;for(;;){if(ve===te.length){re(ve,0,ae.slice(be));break}if(be===ae.length){re(ve,te.length-ve,[]);break}const Fe=te[ve],Be=ae[be],ke=se(Fe,Be);ke===0?(ve+=1,be+=1):ke<0?(re(ve,1,[]),ve+=1):ke>0&&(re(ve,0,[Be]),be+=1)}return Q}function m(te,ae,se){const Q=a(te,ae,se),re=[],ve=[];for(const be of Q)re.push(...te.slice(be.start,be.start+be.deleteCount)),ve.push(...be.toInsert);return{removed:re,added:ve}}function p(te,ae,se){if(se===0)return[];const Q=te.slice(0,se).sort(ae);return i(te,ae,Q,se,te.length),Q}function f(te,ae,se,Q,re){return se===0?Promise.resolve([]):new Promise((ve,be)=>{(async()=>{const Fe=te.length,Be=te.slice(0,se).sort(ae);for(let ke=se,De=Math.min(se+Q,Fe);ke<Fe;ke=De,De=Math.min(De+Q,Fe)){if(ke>se&&await new Promise(Pe=>setTimeout(Pe)),re&&re.isCancellationRequested)throw new r.CancellationError;i(te,ae,Be,ke,De)}return Be})().then(ve,be)})}function i(te,ae,se,Q,re){for(const ve=se.length;Q<re;Q++){const be=te[Q];if(ae(be,se[ve-1])<0){se.pop();const Fe=(0,d.findFirstIdxMonotonousOrArrLen)(se,Be=>ae(be,Be)<0);se.splice(Fe,0,be)}}}function s(te){return te.filter(ae=>!!ae)}function t(te){let ae=0;for(let se=0;se<te.length;se++)te[se]&&(te[ae]=te[se],ae+=1);te.length=ae}function o(te,ae,se){te.splice(se,0,te.splice(ae,1)[0])}function n(te){return!Array.isArray(te)||te.length===0}function h(te){return Array.isArray(te)&&te.length>0}function c(te,ae=se=>se){const se=new Set;return te.filter(Q=>{const re=ae(Q);return se.has(re)?!1:(se.add(re),!0)})}function g(te){const ae=new Set;return se=>{const Q=te(se);return ae.has(Q)?!1:(ae.add(Q),!0)}}function w(te,ae){return te.length>0?te[0]:ae}function D(te,ae){return te.length>0?te[te.length-1]:ae}function _(te,ae,se=(Q,re)=>Q===re){let Q=0;for(let re=0,ve=Math.min(te.length,ae.length);re<ve&&se(te[re],ae[re]);re++)Q++;return Q}function C(te,ae){let se=typeof ae=="number"?te:0;typeof ae=="number"?se=te:(se=0,ae=te);const Q=[];if(se<=ae)for(let re=se;re<ae;re++)Q.push(re);else for(let re=se;re>ae;re--)Q.push(re);return Q}function A(te,ae,se){return te.reduce((Q,re)=>(Q[ae(re)]=se?se(re):re,Q),Object.create(null))}function E(te,ae){return te.push(ae),()=>S(te,ae)}function S(te,ae){const se=te.indexOf(ae);if(se>-1)return te.splice(se,1),ae}function F(te,ae,se){const Q=te.slice(0,ae),re=te.slice(ae);return Q.concat(se,re)}function N(te,ae){let se;if(typeof ae=="number"){let Q=ae;se=()=>{const re=Math.sin(Q++)*179426549;return re-Math.floor(re)}}else se=Math.random;for(let Q=te.length-1;Q>0;Q-=1){const re=Math.floor(se()*(Q+1)),ve=te[Q];te[Q]=te[re],te[re]=ve}}function O(te,ae){const se=te.indexOf(ae);se>-1&&(te.splice(se,1),te.unshift(ae))}function M(te,ae){const se=te.indexOf(ae);se>-1&&(te.splice(se,1),te.push(ae))}function U(te,ae){for(const se of ae)te.push(se)}function x(te,ae){return Array.isArray(te)?te.map(ae):ae(te)}function z(te){return Array.isArray(te)?te:[te]}function B(te){return te[Math.floor(Math.random()*te.length)]}function ee(te,ae,se){const Q=$(te,ae),re=te.length,ve=se.length;te.length=re+ve;for(let be=re-1;be>=Q;be--)te[be+ve]=te[be];for(let be=0;be<ve;be++)te[be+Q]=se[be]}function V(te,ae,se,Q){const re=$(te,ae);let ve=te.splice(re,se);return ve===void 0&&(ve=[]),ee(te,re,Q),ve}function $(te,ae){return ae<0?Math.max(ae+te.length,0):Math.min(ae,te.length)}var G;(function(te){function ae(ve){return ve<0}te.isLessThan=ae;function se(ve){return ve<=0}te.isLessThanOrEqual=se;function Q(ve){return ve>0}te.isGreaterThan=Q;function re(ve){return ve===0}te.isNeitherLessOrGreaterThan=re,te.greaterThan=1,te.lessThan=-1,te.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function Z(te,ae){return(se,Q)=>ae(te(se),te(Q))}function le(...te){return(ae,se)=>{for(const Q of te){const re=Q(ae,se);if(!G.isNeitherLessOrGreaterThan(re))return re}return G.neitherLessOrGreaterThan}}const ne=(te,ae)=>te-ae;e.numberComparator=ne;const _e=(te,ae)=>(0,e.numberComparator)(te?1:0,ae?1:0);e.booleanComparator=_e;function ge(te){return(ae,se)=>-te(ae,se)}class Y{constructor(ae){this.items=ae,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ae){let se=this.firstIdx;for(;se<this.items.length&&ae(this.items[se]);)se++;const Q=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,Q}takeFromEndWhile(ae){let se=this.lastIdx;for(;se>=0&&ae(this.items[se]);)se--;const Q=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,Q}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ae=this.items[this.firstIdx];return this.firstIdx++,ae}removeLast(){const ae=this.items[this.lastIdx];return this.lastIdx--,ae}takeCount(ae){const se=this.items.slice(this.firstIdx,this.firstIdx+ae);return this.firstIdx+=ae,se}}e.ArrayQueue=Y;class W{static{this.empty=new W(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(se=>(ae(se),!0))}toArray(){const ae=[];return this.iterate(se=>(ae.push(se),!0)),ae}filter(ae){return new W(se=>this.iterate(Q=>ae(Q)?se(Q):!0))}map(ae){return new W(se=>this.iterate(Q=>se(ae(Q))))}some(ae){let se=!1;return this.iterate(Q=>(se=ae(Q),!se)),se}findFirst(ae){let se;return this.iterate(Q=>ae(Q)?(se=Q,!1):!0),se}findLast(ae){let se;return this.iterate(Q=>(ae(Q)&&(se=Q),!0)),se}findLastMaxBy(ae){let se,Q=!0;return this.iterate(re=>((Q||G.isGreaterThan(ae(re,se)))&&(Q=!1,se=re),!0)),se}}e.CallbackIterable=W;class oe{constructor(ae){this._indexMap=ae}static createSortPermutation(ae,se){const Q=Array.from(ae.keys()).sort((re,ve)=>se(ae[re],ae[ve]));return new oe(Q)}apply(ae){return ae.map((se,Q)=>ae[this._indexMap[Q]])}inverse(){const ae=this._indexMap.slice();for(let se=0;se<this._indexMap.length;se++)ae[this._indexMap[se]]=se;return new oe(ae)}}e.Permutation=oe;async function Se(te,ae){return(await Promise.all(te.map(async(Q,re)=>({element:Q,ok:await ae(Q,re)})))).find(Q=>Q.ok)?.element}}),define(Ce[65],Ie([1,0,13]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=d,e.assertNever=P,e.assert=k,e.softAssert=L,e.assertFn=R,e.checkAdjacentItems=v;function d(l,I){if(!l)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function P(l,I="Unreachable"){throw new Error(I)}function k(l,I="unexpected state"){if(!l)throw new r.BugIndicatingError(`Assertion Failed: ${I}`)}function L(l){l||(0,r.onUnexpectedError)(new r.BugIndicatingError("Soft Assertion Failed"))}function R(l){if(!l()){debugger;l(),(0,r.onUnexpectedError)(new r.BugIndicatingError("Assertion Failed"))}}function v(l,I){let y=0;for(;y<l.length-1;){const u=l[y],T=l[y+1];if(!I(u,T))return!1;y++}return!0}});var jn=this&&this.__createBinding||(Object.create?function(pe,e,r,d){d===void 0&&(d=r);var P=Object.getOwnPropertyDescriptor(e,r);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(pe,d,P)}:function(pe,e,r,d){d===void 0&&(d=r),pe[d]=e[r]}),Kn=this&&this.__setModuleDefault||(Object.create?function(pe,e){Object.defineProperty(pe,"default",{enumerable:!0,value:e})}:function(pe,e){pe.default=e}),$e=this&&this.__importStar||function(pe){if(pe&&pe.__esModule)return pe;var e={};if(pe!=null)for(var r in pe)r!=="default"&&Object.prototype.hasOwnProperty.call(pe,r)&&jn(e,pe,r);return Kn(e,pe),e};define(Ce[175],Ie([1,0,18]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=P,e.jsonStringifyEquals=k,e.itemEquals=L,e.equalsIfDefined=R,e.structuralEquals=v,e.getStructuralKey=l,r=$e(r);const d=(T,b)=>T===b;e.strictEquals=d;function P(T=e.strictEquals){return(b,a)=>r.equals(b,a,T)}function k(){return(T,b)=>JSON.stringify(T)===JSON.stringify(b)}function L(){return(T,b)=>T.equals(b)}function R(T,b,a){if(a!==void 0){const m=T;return m==null||b===void 0||b===null?b===m:a(m,b)}else{const m=T;return(p,f)=>p==null||f===void 0||f===null?f===p:m(p,f)}}function v(T,b){if(T===b)return!0;if(Array.isArray(T)&&Array.isArray(b)){if(T.length!==b.length)return!1;for(let a=0;a<T.length;a++)if(!v(T[a],b[a]))return!1;return!0}if(T&&typeof T=="object"&&b&&typeof b=="object"&&Object.getPrototypeOf(T)===Object.prototype&&Object.getPrototypeOf(b)===Object.prototype){const a=T,m=b,p=Object.keys(a),f=Object.keys(m),i=new Set(f);if(p.length!==f.length)return!1;for(const s of p)if(!i.has(s)||!v(a[s],m[s]))return!1;return!0}return!1}function l(T){return JSON.stringify(u(T))}let I=0;const y=new WeakMap;function u(T){if(Array.isArray(T))return T.map(u);if(T&&typeof T=="object")if(Object.getPrototypeOf(T)===Object.prototype){const b=T,a=Object.create(null);for(const m of Object.keys(b).sort())a[m]=u(b[m]);return a}else{let b=y.get(T);return b===void 0&&(b=I++,y.set(T,b)),b+"----2b76a038c20c4bcc"}return T}}),define(Ce[79],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=r;function r(d,P){const k=this;let L=!1,R;return function(){if(L)return R;if(L=!0,P)try{R=d.apply(k,arguments)}finally{P()}else R=d.apply(k,arguments);return R}}}),define(Ce[132],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ce[39],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(d){function P(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}d.is=P;const k=Object.freeze([]);function L(){return k}d.empty=L;function*R(n){yield n}d.single=R;function v(n){return P(n)?n:R(n)}d.wrap=v;function l(n){return n||k}d.from=l;function*I(n){for(let h=n.length-1;h>=0;h--)yield n[h]}d.reverse=I;function y(n){return!n||n[Symbol.iterator]().next().done===!0}d.isEmpty=y;function u(n){return n[Symbol.iterator]().next().value}d.first=u;function T(n,h){let c=0;for(const g of n)if(h(g,c++))return!0;return!1}d.some=T;function b(n,h){for(const c of n)if(h(c))return c}d.find=b;function*a(n,h){for(const c of n)h(c)&&(yield c)}d.filter=a;function*m(n,h){let c=0;for(const g of n)yield h(g,c++)}d.map=m;function*p(n,h){let c=0;for(const g of n)yield*h(g,c++)}d.flatMap=p;function*f(...n){for(const h of n)yield*h}d.concat=f;function i(n,h,c){let g=c;for(const w of n)g=h(g,w);return g}d.reduce=i;function*s(n,h,c=n.length){for(h<0&&(h+=n.length),c<0?c+=n.length:c>n.length&&(c=n.length);h<c;h++)yield n[h]}d.slice=s;function t(n,h=Number.POSITIVE_INFINITY){const c=[];if(h===0)return[c,n];const g=n[Symbol.iterator]();for(let w=0;w<h;w++){const D=g.next();if(D.done)return[c,d.empty()];c.push(D.value)}return[c,{[Symbol.iterator](){return g}}]}d.consume=t;async function o(n){const h=[];for await(const c of n)h.push(c);return Promise.resolve(h)}d.asyncToArray=o})(r||(e.Iterable=r={}))}),define(Ce[176],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=L,e.getLocation=y,e.parse=u,e.parseTree=T,e.findNodeAtLocation=b,e.getNodePath=a,e.getNodeValue=m,e.contains=p,e.findNodeAtOffset=f,e.visit=i,e.getNodeType=s;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var d;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(d||(e.SyntaxKind=d={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function L(t,o=!1){let n=0;const h=t.length;let c="",g=0,w=d.Unknown,D=r.None;function _(O){let M=0,U=0;for(;M<O;){const x=t.charCodeAt(n);if(x>=I._0&&x<=I._9)U=U*16+x-I._0;else if(x>=I.A&&x<=I.F)U=U*16+x-I.A+10;else if(x>=I.a&&x<=I.f)U=U*16+x-I.a+10;else break;n++,M++}return M<O&&(U=-1),U}function C(O){n=O,c="",g=0,w=d.Unknown,D=r.None}function A(){const O=n;if(t.charCodeAt(n)===I._0)n++;else for(n++;n<t.length&&l(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===I.dot)if(n++,n<t.length&&l(t.charCodeAt(n)))for(n++;n<t.length&&l(t.charCodeAt(n));)n++;else return D=r.UnexpectedEndOfNumber,t.substring(O,n);let M=n;if(n<t.length&&(t.charCodeAt(n)===I.E||t.charCodeAt(n)===I.e))if(n++,(n<t.length&&t.charCodeAt(n)===I.plus||t.charCodeAt(n)===I.minus)&&n++,n<t.length&&l(t.charCodeAt(n))){for(n++;n<t.length&&l(t.charCodeAt(n));)n++;M=n}else D=r.UnexpectedEndOfNumber;return t.substring(O,M)}function E(){let O="",M=n;for(;;){if(n>=h){O+=t.substring(M,n),D=r.UnexpectedEndOfString;break}const U=t.charCodeAt(n);if(U===I.doubleQuote){O+=t.substring(M,n),n++;break}if(U===I.backslash){if(O+=t.substring(M,n),n++,n>=h){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(n++)){case I.doubleQuote:O+='"';break;case I.backslash:O+="\\";break;case I.slash:O+="/";break;case I.b:O+="\b";break;case I.f:O+="\f";break;case I.n:O+=`
`;break;case I.r:O+="\r";break;case I.t:O+="	";break;case I.u:{const z=_(4);z>=0?O+=String.fromCharCode(z):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}M=n;continue}if(U>=0&&U<=31)if(v(U)){O+=t.substring(M,n),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;n++}return O}function S(){if(c="",D=r.None,g=n,n>=h)return g=h,w=d.EOF;let O=t.charCodeAt(n);if(R(O)){do n++,c+=String.fromCharCode(O),O=t.charCodeAt(n);while(R(O));return w=d.Trivia}if(v(O))return n++,c+=String.fromCharCode(O),O===I.carriageReturn&&t.charCodeAt(n)===I.lineFeed&&(n++,c+=`
`),w=d.LineBreakTrivia;switch(O){case I.openBrace:return n++,w=d.OpenBraceToken;case I.closeBrace:return n++,w=d.CloseBraceToken;case I.openBracket:return n++,w=d.OpenBracketToken;case I.closeBracket:return n++,w=d.CloseBracketToken;case I.colon:return n++,w=d.ColonToken;case I.comma:return n++,w=d.CommaToken;case I.doubleQuote:return n++,c=E(),w=d.StringLiteral;case I.slash:{const M=n-1;if(t.charCodeAt(n+1)===I.slash){for(n+=2;n<h&&!v(t.charCodeAt(n));)n++;return c=t.substring(M,n),w=d.LineCommentTrivia}if(t.charCodeAt(n+1)===I.asterisk){n+=2;const U=h-1;let x=!1;for(;n<U;){if(t.charCodeAt(n)===I.asterisk&&t.charCodeAt(n+1)===I.slash){n+=2,x=!0;break}n++}return x||(n++,D=r.UnexpectedEndOfComment),c=t.substring(M,n),w=d.BlockCommentTrivia}return c+=String.fromCharCode(O),n++,w=d.Unknown}case I.minus:if(c+=String.fromCharCode(O),n++,n===h||!l(t.charCodeAt(n)))return w=d.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return c+=A(),w=d.NumericLiteral;default:for(;n<h&&F(O);)n++,O=t.charCodeAt(n);if(g!==n){switch(c=t.substring(g,n),c){case"true":return w=d.TrueKeyword;case"false":return w=d.FalseKeyword;case"null":return w=d.NullKeyword}return w=d.Unknown}return c+=String.fromCharCode(O),n++,w=d.Unknown}}function F(O){if(R(O)||v(O))return!1;switch(O){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function N(){let O;do O=S();while(O>=d.LineCommentTrivia&&O<=d.Trivia);return O}return{setPosition:C,getPosition:()=>n,scan:o?N:S,getToken:()=>w,getTokenValue:()=>c,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>D}}function R(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function v(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function l(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function y(t,o){const n=[],h=new Object;let c;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function D(_,C,A,E){g.value=_,g.offset=C,g.length=A,g.type=E,g.colonOffset=void 0,c=g}try{i(t,{onObjectBegin:(_,C)=>{if(o<=_)throw h;c=void 0,w=o>_,n.push("")},onObjectProperty:(_,C,A)=>{if(o<C||(D(_,C,A,"property"),n[n.length-1]=_,o<=C+A))throw h},onObjectEnd:(_,C)=>{if(o<=_)throw h;c=void 0,n.pop()},onArrayBegin:(_,C)=>{if(o<=_)throw h;c=void 0,n.push(0)},onArrayEnd:(_,C)=>{if(o<=_)throw h;c=void 0,n.pop()},onLiteralValue:(_,C,A)=>{if(o<C||(D(_,C,A,s(_)),o<=C+A))throw h},onSeparator:(_,C,A)=>{if(o<=C)throw h;if(_===":"&&c&&c.type==="property")c.colonOffset=C,w=!1,c=void 0;else if(_===","){const E=n[n.length-1];typeof E=="number"?n[n.length-1]=E+1:(w=!0,n[n.length-1]=""),c=void 0}}})}catch(_){if(_!==h)throw _}return{path:n,previousNode:c,isAtPropertyKey:w,matches:_=>{let C=0;for(let A=0;C<_.length&&A<n.length;A++)if(_[C]===n[A]||_[C]==="*")C++;else if(_[C]!=="**")return!1;return C===_.length}}}function u(t,o=[],n=k.DEFAULT){let h=null,c=[];const g=[];function w(_){Array.isArray(c)?c.push(_):h!==null&&(c[h]=_)}return i(t,{onObjectBegin:()=>{const _={};w(_),g.push(c),c=_,h=null},onObjectProperty:_=>{h=_},onObjectEnd:()=>{c=g.pop()},onArrayBegin:()=>{const _=[];w(_),g.push(c),c=_,h=null},onArrayEnd:()=>{c=g.pop()},onLiteralValue:w,onError:(_,C,A)=>{o.push({error:_,offset:C,length:A})}},n),c[0]}function T(t,o=[],n=k.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(_){h.type==="property"&&(h.length=_-h.offset,h=h.parent)}function g(_){return h.children.push(_),_}i(t,{onObjectBegin:_=>{h=g({type:"object",offset:_,length:-1,parent:h,children:[]})},onObjectProperty:(_,C,A)=>{h=g({type:"property",offset:C,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:_,offset:C,length:A,parent:h})},onObjectEnd:(_,C)=>{h.length=_+C-h.offset,h=h.parent,c(_+C)},onArrayBegin:(_,C)=>{h=g({type:"array",offset:_,length:-1,parent:h,children:[]})},onArrayEnd:(_,C)=>{h.length=_+C-h.offset,h=h.parent,c(_+C)},onLiteralValue:(_,C,A)=>{g({type:s(_),offset:C,length:A,parent:h,value:_}),c(C+A)},onSeparator:(_,C,A)=>{h.type==="property"&&(_===":"?h.colonOffset=C:_===","&&c(C))},onError:(_,C,A)=>{o.push({error:_,offset:C,length:A})}},n);const D=h.children[0];return D&&delete D.parent,D}function b(t,o){if(!t)return;let n=t;for(const h of o)if(typeof h=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let c=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===h){n=g.children[1],c=!0;break}if(!c)return}else{const c=h;if(n.type!=="array"||c<0||!Array.isArray(n.children)||c>=n.children.length)return;n=n.children[c]}return n}function a(t){if(!t.parent||!t.parent.children)return[];const o=a(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const o=Object.create(null);for(const n of t.children){const h=n.children[1];h&&(o[n.children[0].value]=m(h))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function p(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}function f(t,o,n=!1){if(p(t,o,n)){const h=t.children;if(Array.isArray(h))for(let c=0;c<h.length&&h[c].offset<=o;c++){const g=f(h[c],o,n);if(g)return g}return t}}function i(t,o,n=k.DEFAULT){const h=L(t,!1);function c(Z){return Z?()=>Z(h.getTokenOffset(),h.getTokenLength()):()=>!0}function g(Z){return Z?le=>Z(le,h.getTokenOffset(),h.getTokenLength()):()=>!0}const w=c(o.onObjectBegin),D=g(o.onObjectProperty),_=c(o.onObjectEnd),C=c(o.onArrayBegin),A=c(o.onArrayEnd),E=g(o.onLiteralValue),S=g(o.onSeparator),F=c(o.onComment),N=g(o.onError),O=n&&n.disallowComments,M=n&&n.allowTrailingComma;function U(){for(;;){const Z=h.scan();switch(h.getTokenError()){case r.InvalidUnicode:x(P.InvalidUnicode);break;case r.InvalidEscapeCharacter:x(P.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:x(P.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:O||x(P.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:x(P.UnexpectedEndOfString);break;case r.InvalidCharacter:x(P.InvalidCharacter);break}switch(Z){case d.LineCommentTrivia:case d.BlockCommentTrivia:O?x(P.InvalidCommentToken):F();break;case d.Unknown:x(P.InvalidSymbol);break;case d.Trivia:case d.LineBreakTrivia:break;default:return Z}}}function x(Z,le=[],ne=[]){if(N(Z),le.length+ne.length>0){let _e=h.getToken();for(;_e!==d.EOF;){if(le.indexOf(_e)!==-1){U();break}else if(ne.indexOf(_e)!==-1)break;_e=U()}}}function z(Z){const le=h.getTokenValue();return Z?E(le):D(le),U(),!0}function B(){switch(h.getToken()){case d.NumericLiteral:{let Z=0;try{Z=JSON.parse(h.getTokenValue()),typeof Z!="number"&&(x(P.InvalidNumberFormat),Z=0)}catch{x(P.InvalidNumberFormat)}E(Z);break}case d.NullKeyword:E(null);break;case d.TrueKeyword:E(!0);break;case d.FalseKeyword:E(!1);break;default:return!1}return U(),!0}function ee(){return h.getToken()!==d.StringLiteral?(x(P.PropertyNameExpected,[],[d.CloseBraceToken,d.CommaToken]),!1):(z(!1),h.getToken()===d.ColonToken?(S(":"),U(),G()||x(P.ValueExpected,[],[d.CloseBraceToken,d.CommaToken])):x(P.ColonExpected,[],[d.CloseBraceToken,d.CommaToken]),!0)}function V(){w(),U();let Z=!1;for(;h.getToken()!==d.CloseBraceToken&&h.getToken()!==d.EOF;){if(h.getToken()===d.CommaToken){if(Z||x(P.ValueExpected,[],[]),S(","),U(),h.getToken()===d.CloseBraceToken&&M)break}else Z&&x(P.CommaExpected,[],[]);ee()||x(P.ValueExpected,[],[d.CloseBraceToken,d.CommaToken]),Z=!0}return _(),h.getToken()!==d.CloseBraceToken?x(P.CloseBraceExpected,[d.CloseBraceToken],[]):U(),!0}function $(){C(),U();let Z=!1;for(;h.getToken()!==d.CloseBracketToken&&h.getToken()!==d.EOF;){if(h.getToken()===d.CommaToken){if(Z||x(P.ValueExpected,[],[]),S(","),U(),h.getToken()===d.CloseBracketToken&&M)break}else Z&&x(P.CommaExpected,[],[]);G()||x(P.ValueExpected,[],[d.CloseBracketToken,d.CommaToken]),Z=!0}return A(),h.getToken()!==d.CloseBracketToken?x(P.CloseBracketExpected,[d.CloseBracketToken],[]):U(),!0}function G(){switch(h.getToken()){case d.OpenBracketToken:return $();case d.OpenBraceToken:return V();case d.StringLiteral:return z(!0);default:return B()}}return U(),h.getToken()===d.EOF?n.allowEmptyContent?!0:(x(P.ValueExpected,[],[]),!1):G()?(h.getToken()!==d.EOF&&x(P.EndOfFileExpected,[],[]),!0):(x(P.ValueExpected,[],[]),!1)}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ce[177],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCompressedContent=r;function r(k){let L=!1;const R=new Map,v=new Map;if(P(k,a=>{if(k===a)return!0;const m=JSON.stringify(a);if(m.length<30)return!0;const p=R.get(m);if(!p){const f={schemas:[a]};return R.set(m,f),v.set(a,f),!0}return p.schemas.push(a),v.set(a,p),L=!0,!1}),R.clear(),!L)return JSON.stringify(k);let I="$defs";for(;k.hasOwnProperty(I);)I+="_";const y=[];function u(a){return JSON.stringify(a,(m,p)=>{if(p!==a){const f=v.get(p);if(f&&f.schemas.length>1)return f.id||(f.id=`_${y.length}`,y.push(f.schemas[0])),{$ref:`#/${I}/${f.id}`}}return p})}const T=u(k),b=[];for(let a=0;a<y.length;a++)b.push(`"_${a}":${u(y[a])}`);return b.length?`${T.substring(0,T.length-1)},"${I}":{${b.join(",")}}}`:T}function d(k){return typeof k=="object"&&k!==null}function P(k,L){if(!k||typeof k!="object")return;const R=(...T)=>{for(const b of T)d(b)&&y.push(b)},v=(...T)=>{for(const b of T)if(d(b))for(const a in b){const m=b[a];d(m)&&y.push(m)}},l=(...T)=>{for(const b of T)if(Array.isArray(b))for(const a of b)d(a)&&y.push(a)},I=T=>{if(Array.isArray(T))for(const b of T)d(b)&&y.push(b);else d(T)&&y.push(T)},y=[k];let u=y.pop();for(;u;)L(u)&&(R(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),v(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),l(u.anyOf,u.allOf,u.oneOf,u.prefixItems),I(u.items)),u=y.pop()}}),define(Ce[50],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class r{constructor(P){this.executor=P,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=r}),define(Ce[80],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class r{static{this.Undefined=new r(void 0)}constructor(k){this.element=k,this.next=r.Undefined,this.prev=r.Undefined}}class d{constructor(){this._first=r.Undefined,this._last=r.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===r.Undefined}clear(){let k=this._first;for(;k!==r.Undefined;){const L=k.next;k.prev=r.Undefined,k.next=r.Undefined,k=L}this._first=r.Undefined,this._last=r.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,L){const R=new r(k);if(this._first===r.Undefined)this._first=R,this._last=R;else if(L){const l=this._last;this._last=R,R.prev=l,l.next=R}else{const l=this._first;this._first=R,R.next=l,l.prev=R}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(R))}}shift(){if(this._first!==r.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==r.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==r.Undefined&&k.next!==r.Undefined){const L=k.prev;L.next=k.next,k.next.prev=L}else k.prev===r.Undefined&&k.next===r.Undefined?(this._first=r.Undefined,this._last=r.Undefined):k.next===r.Undefined?(this._last=this._last.prev,this._last.next=r.Undefined):k.prev===r.Undefined&&(this._first=this._first.next,this._first.prev=r.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==r.Undefined;)yield k.element,k=k.next}}e.LinkedList=d}),define(Ce[28],Ie([1,0]),function(pe,e){"use strict";var r,d,P;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=k,e.mapToString=L,e.setToString=R,e.mapsStrictEqualIgnoreOrder=s;function k(t,o,n){let h=t.get(o);return h===void 0&&(h=n,t.set(o,h)),h}function L(t){const o=[];return t.forEach((n,h)=>{o.push(`${h} => ${n}`)}),`Map(${t.size}) {${o.join(", ")}}`}function R(t){const o=[];return t.forEach(n=>{o.push(n)}),`Set(${t.size}) {${o.join(", ")}}`}class v{constructor(o,n){this.uri=o,this.value=n}}function l(t){return Array.isArray(t)}class I{static{this.defaultToKey=o=>o.toString()}constructor(o,n){if(this[r]="ResourceMap",o instanceof I)this.map=new Map(o.map),this.toKey=n??I.defaultToKey;else if(l(o)){this.map=new Map,this.toKey=n??I.defaultToKey;for(const[h,c]of o)this.set(h,c)}else this.map=new Map,this.toKey=o??I.defaultToKey}set(o,n){return this.map.set(this.toKey(o),new v(o,n)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,n){typeof n<"u"&&(o=o.bind(n));for(const[h,c]of this.map)o(c.value,c.uri,this)}*values(){for(const o of this.map.values())yield o.value}*keys(){for(const o of this.map.values())yield o.uri}*entries(){for(const o of this.map.values())yield[o.uri,o.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.map)yield[o.uri,o.value]}}e.ResourceMap=I;class y{constructor(o,n){this[d]="ResourceSet",!o||typeof o=="function"?this._map=new I(o):(this._map=new I(n),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,n){this._map.forEach((h,c)=>o.call(n,c,c,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var u;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class T{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,n=u.None){const h=this._map.get(o);if(h)return n!==u.None&&this.touch(h,n),h.value}set(o,n,h=u.None){let c=this._map.get(o);if(c)c.value=n,h!==u.None&&this.touch(c,h);else{switch(c={key:o,value:n,next:void 0,previous:void 0},h){case u.None:this.addItemLast(c);break;case u.AsOld:this.addItemFirst(c);break;case u.AsNew:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(o,c),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const n=this._map.get(o);if(n)return this._map.delete(o),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,n){const h=this._state;let c=this._head;for(;c;){if(n?o.bind(n)(c.value,c.key,this):o(c.value,c.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const o=this,n=this._state;let h=this._head;const c={[Symbol.iterator](){return c},next(){if(o._state!==n)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:h.key,done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return c}values(){const o=this,n=this._state;let h=this._head;const c={[Symbol.iterator](){return c},next(){if(o._state!==n)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:h.value,done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return c}entries(){const o=this,n=this._state;let h=this._head;const c={[Symbol.iterator](){return c},next(){if(o._state!==n)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:[h.key,h.value],done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return c}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this._head,h=this.size;for(;n&&h>o;)this._map.delete(n.key),n=n.next,h--;this._head=n,this._size=h,n&&(n.previous=void 0),this._state++}trimNew(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this._tail,h=this.size;for(;n&&h>o;)this._map.delete(n.key),n=n.previous,h--;this._tail=n,this._size=h,n&&(n.next=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const n=o.next,h=o.previous;if(!n||!h)throw new Error("Invalid list");n.previous=h,h.next=n}o.next=void 0,o.previous=void 0,this._state++}touch(o,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==u.AsOld&&n!==u.AsNew)){if(n===u.AsOld){if(o===this._head)return;const h=o.next,c=o.previous;o===this._tail?(c.next=void 0,this._tail=c):(h.previous=c,c.next=h),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(n===u.AsNew){if(o===this._tail)return;const h=o.next,c=o.previous;o===this._head?(h.previous=void 0,this._head=h):(h.previous=c,c.next=h),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((n,h)=>{o.push([h,n])}),o}fromJSON(o){this.clear();for(const[n,h]of o)this.set(n,h)}}e.LinkedMap=T;class b extends T{constructor(o,n=1){super(),this._limit=o,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,n=u.AsNew){return super.get(o,n)}peek(o){return super.get(o,u.None)}set(o,n){return super.set(o,n,u.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class a extends b{constructor(o,n=1){super(o,n)}trim(o){this.trimOld(o)}set(o,n){return super.set(o,n),this.checkTrim(),this}}e.LRUCache=a;class m extends b{constructor(o,n=1){super(o,n)}trim(o){this.trimNew(o)}set(o,n){return this._limit<=this.size&&!this.has(o)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(o,n),this}}e.MRUCache=m;class p{constructor(){this.map=new Map}add(o){return this.map.set(o,(this.map.get(o)||0)+1),this}delete(o){let n=this.map.get(o)||0;return n===0?!1:(n--,n===0?this.map.delete(o):this.map.set(o,n),!0)}has(o){return this.map.has(o)}}e.CounterSet=p;class f{constructor(o){if(this._m1=new Map,this._m2=new Map,o)for(const[n,h]of o)this.set(n,h)}clear(){this._m1.clear(),this._m2.clear()}set(o,n){this._m1.set(o,n),this._m2.set(n,o)}get(o){return this._m1.get(o)}getKey(o){return this._m2.get(o)}delete(o){const n=this._m1.get(o);return n===void 0?!1:(this._m1.delete(o),this._m2.delete(n),!0)}forEach(o,n){this._m1.forEach((h,c)=>{o.call(n,h,c,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=f;class i{constructor(){this.map=new Map}add(o,n){let h=this.map.get(o);h||(h=new Set,this.map.set(o,h)),h.add(n)}delete(o,n){const h=this.map.get(o);h&&(h.delete(n),h.size===0&&this.map.delete(o))}forEach(o,n){const h=this.map.get(o);h&&h.forEach(n)}get(o){const n=this.map.get(o);return n||new Set}}e.SetMap=i;function s(t,o){if(t===o)return!0;if(t.size!==o.size)return!1;for(const[n,h]of t)if(!o.has(n)||o.get(n)!==h)return!1;for(const[n]of o)if(!t.has(n))return!1;return!0}}),define(Ce[3],Ie([1,0,18,78,28,79,39]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=I,e.trackDisposable=y,e.markAsDisposed=u,e.markAsSingleton=a,e.isDisposable=m,e.dispose=p,e.disposeIfDisposable=f,e.combinedDisposable=i,e.toDisposable=s,e.disposeOnReturn=C;const R=!1;let v=null;class l{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(S){let F=this.livingDisposables.get(S);return F||(F={parent:null,source:null,isSingleton:!1,value:S,idx:l.idx++},this.livingDisposables.set(S,F)),F}trackDisposable(S){const F=this.getDisposableData(S);F.source||(F.source=new Error().stack)}setParent(S,F){const N=this.getDisposableData(S);N.parent=F}markAsDisposed(S){this.livingDisposables.delete(S)}markAsSingleton(S){this.getDisposableData(S).isSingleton=!0}getRootParent(S,F){const N=F.get(S);if(N)return N;const O=S.parent?this.getRootParent(this.getDisposableData(S.parent),F):S;return F.set(S,O),O}getTrackedDisposables(){const S=new Map;return[...this.livingDisposables.entries()].filter(([,N])=>N.source!==null&&!this.getRootParent(N,S).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(S=10,F){let N;if(F)N=F;else{const z=new Map,B=[...this.livingDisposables.values()].filter(V=>V.source!==null&&!this.getRootParent(V,z).isSingleton);if(B.length===0)return;const ee=new Set(B.map(V=>V.value));if(N=B.filter(V=>!(V.parent&&ee.has(V.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function O(z){function B(V,$){for(;V.length>0&&$.some(G=>typeof G=="string"?G===V[0]:V[0].match(G));)V.shift()}const ee=z.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return B(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const M=new P.SetMap;for(const z of N){const B=O(z);for(let ee=0;ee<=B.length;ee++)M.add(B.slice(0,ee).join(`
`),z)}N.sort((0,r.compareBy)(z=>z.idx,r.numberComparator));let U="",x=0;for(const z of N.slice(0,S)){x++;const B=O(z),ee=[];for(let V=0;V<B.length;V++){let $=B[V];$=`(shared with ${M.get(B.slice(0,V+1).join(`
`)).size}/${N.length} leaks) at ${$}`;const Z=M.get(B.slice(0,V).join(`
`)),le=(0,d.groupBy)([...Z].map(ne=>O(ne)[V]),ne=>ne);delete le[B[V]];for(const[ne,_e]of Object.entries(le))ee.unshift(`    - stacktraces of ${_e.length} other leaks continue with ${ne}`);ee.unshift($)}U+=`


==================== Leaking disposable ${x}/${N.length}: ${z.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return N.length>S&&(U+=`


... and ${N.length-S} more leaking disposables

`),{leaks:N,details:U}}}e.DisposableTracker=l;function I(E){v=E}if(R){const E="__is_disposable_tracked__";I(new class{trackDisposable(S){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{S[E]||console.log(F)},3e3)}setParent(S,F){if(S&&S!==o.None)try{S[E]=!0}catch{}}markAsDisposed(S){if(S&&S!==o.None)try{S[E]=!0}catch{}}markAsSingleton(S){}})}function y(E){return v?.trackDisposable(E),E}function u(E){v?.markAsDisposed(E)}function T(E,S){v?.setParent(E,S)}function b(E,S){if(v)for(const F of E)v.setParent(F,S)}function a(E){return v?.markAsSingleton(E),E}function m(E){return typeof E=="object"&&E!==null&&typeof E.dispose=="function"&&E.dispose.length===0}function p(E){if(L.Iterable.is(E)){const S=[];for(const F of E)if(F)try{F.dispose()}catch(N){S.push(N)}if(S.length===1)throw S[0];if(S.length>1)throw new AggregateError(S,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}function f(E){for(const S of E)m(S)&&S.dispose();return[]}function i(...E){const S=s(()=>p(E));return b(E,S),S}function s(E){const S=y({dispose:(0,k.createSingleCallFunction)(()=>{u(S),E()})});return S}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{p(this._toDispose)}finally{this._toDispose.clear()}}add(S){if(!S)return S;if(S===this)throw new Error("Cannot register a disposable on itself!");return T(S,this),this._isDisposed?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(S),S}delete(S){if(S){if(S===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(S),S.dispose()}}deleteAndLeak(S){S&&this._toDispose.has(S)&&(this._toDispose.delete(S),T(S,null))}}e.DisposableStore=t;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new t,y(this),T(this._store,this)}dispose(){u(this),this._store.dispose()}_register(S){if(S===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(S)}}e.Disposable=o;class n{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(S){this._isDisposed||S===this._value||(this._value?.dispose(),S&&T(S,this),this._value=S)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const S=this._value;return this._value=void 0,S&&T(S,null),S}}e.MutableDisposable=n;class h{constructor(S){this._disposable=new n,this._isDisposed=!1,this._disposable.value=S}get value(){return this._disposable.value}set value(S){this._isDisposed||S===this._disposable.value||(this._disposable.value=S)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=h;class c{constructor(S){this._disposable=S,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(S){let F=S;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,u(this))},this}}e.SafeDisposable=g;class w{constructor(){this.references=new Map}acquire(S,...F){let N=this.references.get(S);N||(N={counter:0,object:this.createReferencedObject(S,...F)},this.references.set(S,N));const{object:O}=N,M=(0,k.createSingleCallFunction)(()=>{--N.counter===0&&(this.destroyReferencedObject(S,N.object),this.references.delete(S))});return N.counter++,{object:O,dispose:M}}}e.ReferenceCollection=w;class D{constructor(S){this.referenceCollection=S}async acquire(S,...F){const N=this.referenceCollection.acquire(S,...F);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(O){throw N.dispose(),O}}}e.AsyncReferenceCollection=D;class _{constructor(S){this.object=S}dispose(){}}e.ImmortalReference=_;function C(E){const S=new t;try{E(S)}finally{S.dispose()}}class A{constructor(){this._store=new Map,this._isDisposed=!1,y(this)}dispose(){u(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{p(this._store.values())}finally{this._store.clear()}}has(S){return this._store.has(S)}get size(){return this._store.size}get(S){return this._store.get(S)}set(S,F,N=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this._store.get(S)?.dispose(),this._store.set(S,F)}deleteAndDispose(S){this._store.get(S)?.dispose(),this._store.delete(S)}deleteAndLeak(S){const F=this._store.get(S);return this._store.delete(S),F}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=A}),function(pe,e){typeof define=="function"&&define.amd?define(Ce[178],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(te,ae){for(var se=0;se<ae.length;se++){var Q=ae[se];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(te,Q.key,Q)}}function r(te,ae,se){return ae&&e(te.prototype,ae),se&&e(te,se),Object.defineProperty(te,"prototype",{writable:!1}),te}function d(te,ae){if(te){if(typeof te=="string")return P(te,ae);var se=Object.prototype.toString.call(te).slice(8,-1);if(se==="Object"&&te.constructor&&(se=te.constructor.name),se==="Map"||se==="Set")return Array.from(te);if(se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(se))return P(te,ae)}}function P(te,ae){(ae==null||ae>te.length)&&(ae=te.length);for(var se=0,Q=new Array(ae);se<ae;se++)Q[se]=te[se];return Q}function k(te,ae){var se=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(se)return(se=se.call(te)).next.bind(se);if(Array.isArray(te)||(se=d(te))||ae&&te&&typeof te.length=="number"){se&&(te=se);var Q=0;return function(){return Q>=te.length?{done:!0}:{done:!1,value:te[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=L();function R(te){pe.defaults=te}var v=/[&<>"']/,l=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(ae){return u[ae]};function b(te,ae){if(ae){if(v.test(te))return te.replace(l,T)}else if(I.test(te))return te.replace(y,T);return te}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(te){return te.replace(a,function(ae,se){return se=se.toLowerCase(),se==="colon"?":":se.charAt(0)==="#"?se.charAt(1)==="x"?String.fromCharCode(parseInt(se.substring(2),16)):String.fromCharCode(+se.substring(1)):""})}var p=/(^|[^\[])\^/g;function f(te,ae){te=typeof te=="string"?te:te.source,ae=ae||"";var se={replace:function(re,ve){return ve=ve.source||ve,ve=ve.replace(p,"$1"),te=te.replace(re,ve),se},getRegex:function(){return new RegExp(te,ae)}};return se}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(te,ae,se){if(te){var Q;try{Q=decodeURIComponent(m(se)).replace(i,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}ae&&!s.test(se)&&(se=g(ae,se));try{se=encodeURI(se).replace(/%25/g,"%")}catch{return null}return se}var o={},n=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(te,ae){o[" "+te]||(n.test(te)?o[" "+te]=te+"/":o[" "+te]=C(te,"/",!0)),te=o[" "+te];var se=te.indexOf(":")===-1;return ae.substring(0,2)==="//"?se?ae:te.replace(h,"$1")+ae:ae.charAt(0)==="/"?se?ae:te.replace(c,"$1")+ae:te+ae}var w={exec:function(){}};function D(te){for(var ae=1,se,Q;ae<arguments.length;ae++){se=arguments[ae];for(Q in se)Object.prototype.hasOwnProperty.call(se,Q)&&(te[Q]=se[Q])}return te}function _(te,ae){var se=te.replace(/\|/g,function(ve,be,Fe){for(var Be=!1,ke=be;--ke>=0&&Fe[ke]==="\\";)Be=!Be;return Be?"|":" |"}),Q=se.split(/ \|/),re=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>ae)Q.splice(ae);else for(;Q.length<ae;)Q.push("");for(;re<Q.length;re++)Q[re]=Q[re].trim().replace(/\\\|/g,"|");return Q}function C(te,ae,se){var Q=te.length;if(Q===0)return"";for(var re=0;re<Q;){var ve=te.charAt(Q-re-1);if(ve===ae&&!se)re++;else if(ve!==ae&&se)re++;else break}return te.slice(0,Q-re)}function A(te,ae){if(te.indexOf(ae[1])===-1)return-1;for(var se=te.length,Q=0,re=0;re<se;re++)if(te[re]==="\\")re++;else if(te[re]===ae[0])Q++;else if(te[re]===ae[1]&&(Q--,Q<0))return re;return-1}function E(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function S(te,ae){if(ae<1)return"";for(var se="";ae>1;)ae&1&&(se+=te),ae>>=1,te+=te;return se+te}function F(te,ae,se,Q){var re=ae.href,ve=ae.title?b(ae.title):null,be=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){Q.state.inLink=!0;var Fe={type:"link",raw:se,href:re,title:ve,text:be,tokens:Q.inlineTokens(be)};return Q.state.inLink=!1,Fe}return{type:"image",raw:se,href:re,title:ve,text:b(be)}}function N(te,ae){var se=te.match(/^(\s+)(?:```)/);if(se===null)return ae;var Q=se[1];return ae.split(`
`).map(function(re){var ve=re.match(/^\s+/);if(ve===null)return re;var be=ve[0];return be.length>=Q.length?re.slice(Q.length):re}).join(`
`)}var O=function(){function te(se){this.options=se||pe.defaults}var ae=te.prototype;return ae.space=function(Q){var re=this.rules.block.newline.exec(Q);if(re&&re[0].length>0)return{type:"space",raw:re[0]}},ae.code=function(Q){var re=this.rules.block.code.exec(Q);if(re){var ve=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?ve:C(ve,`
`)}}},ae.fences=function(Q){var re=this.rules.block.fences.exec(Q);if(re){var ve=re[0],be=N(ve,re[3]||"");return{type:"code",raw:ve,lang:re[2]?re[2].trim():re[2],text:be}}},ae.heading=function(Q){var re=this.rules.block.heading.exec(Q);if(re){var ve=re[2].trim();if(/#$/.test(ve)){var be=C(ve,"#");(this.options.pedantic||!be||/ $/.test(be))&&(ve=be.trim())}return{type:"heading",raw:re[0],depth:re[1].length,text:ve,tokens:this.lexer.inline(ve)}}},ae.hr=function(Q){var re=this.rules.block.hr.exec(Q);if(re)return{type:"hr",raw:re[0]}},ae.blockquote=function(Q){var re=this.rules.block.blockquote.exec(Q);if(re){var ve=re[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:re[0],tokens:this.lexer.blockTokens(ve,[]),text:ve}}},ae.list=function(Q){var re=this.rules.block.list.exec(Q);if(re){var ve,be,Fe,Be,ke,De,Pe,H,q,X,J,he,we=re[1].trim(),Oe=we.length>1,Ve={type:"list",raw:"",ordered:Oe,start:Oe?+we.slice(0,-1):"",loose:!1,items:[]};we=Oe?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Oe?we:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(he=!1,!(!(re=Ke.exec(Q))||this.rules.block.hr.test(Q)));){if(ve=re[0],Q=Q.substring(ve.length),H=re[2].split(`
`,1)[0],q=Q.split(`
`,1)[0],this.options.pedantic?(Be=2,J=H.trimLeft()):(Be=re[2].search(/[^ ]/),Be=Be>4?1:Be,J=H.slice(Be),Be+=re[1].length),De=!1,!H&&/^ *$/.test(q)&&(ve+=q+`
`,Q=Q.substring(q.length+1),he=!0),!he)for(var et=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),st=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}#");Q&&(X=Q.split(`
`,1)[0],H=X,this.options.pedantic&&(H=H.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(st.test(H)||rt.test(H)||et.test(H)||nt.test(Q)));){if(H.search(/[^ ]/)>=Be||!H.trim())J+=`
`+H.slice(Be);else if(!De)J+=`
`+H;else break;!De&&!H.trim()&&(De=!0),ve+=X+`
`,Q=Q.substring(X.length+1)}Ve.loose||(Pe?Ve.loose=!0:/\n *\n *$/.test(ve)&&(Pe=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(J),be&&(Fe=be[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:ve,task:!!be,checked:Fe,loose:!1,text:J}),Ve.raw+=ve}Ve.items[Ve.items.length-1].raw=ve.trimRight(),Ve.items[Ve.items.length-1].text=J.trimRight(),Ve.raw=Ve.raw.trimRight();var at=Ve.items.length;for(ke=0;ke<at;ke++){this.lexer.state.top=!1,Ve.items[ke].tokens=this.lexer.blockTokens(Ve.items[ke].text,[]);var gt=Ve.items[ke].tokens.filter(function(lt){return lt.type==="space"}),ht=gt.every(function(lt){for(var Te=lt.raw.split(""),Ue=0,je=k(Te),Ne;!(Ne=je()).done;){var xe=Ne.value;if(xe===`
`&&(Ue+=1),Ue>1)return!0}return!1});!Ve.loose&&gt.length&&ht&&(Ve.loose=!0,Ve.items[ke].loose=!0)}return Ve}},ae.html=function(Q){var re=this.rules.block.html.exec(Q);if(re){var ve={type:"html",raw:re[0],pre:!this.options.sanitizer&&(re[1]==="pre"||re[1]==="script"||re[1]==="style"),text:re[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(re[0]):b(re[0]);ve.type="paragraph",ve.text=be,ve.tokens=this.lexer.inline(be)}return ve}},ae.def=function(Q){var re=this.rules.block.def.exec(Q);if(re){re[3]&&(re[3]=re[3].substring(1,re[3].length-1));var ve=re[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ve,raw:re[0],href:re[2],title:re[3]}}},ae.table=function(Q){var re=this.rules.block.table.exec(Q);if(re){var ve={type:"table",header:_(re[1]).map(function(Pe){return{text:Pe}}),align:re[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ve.header.length===ve.align.length){ve.raw=re[0];var be=ve.align.length,Fe,Be,ke,De;for(Fe=0;Fe<be;Fe++)/^ *-+: *$/.test(ve.align[Fe])?ve.align[Fe]="right":/^ *:-+: *$/.test(ve.align[Fe])?ve.align[Fe]="center":/^ *:-+ *$/.test(ve.align[Fe])?ve.align[Fe]="left":ve.align[Fe]=null;for(be=ve.rows.length,Fe=0;Fe<be;Fe++)ve.rows[Fe]=_(ve.rows[Fe],ve.header.length).map(function(Pe){return{text:Pe}});for(be=ve.header.length,Be=0;Be<be;Be++)ve.header[Be].tokens=this.lexer.inline(ve.header[Be].text);for(be=ve.rows.length,Be=0;Be<be;Be++)for(De=ve.rows[Be],ke=0;ke<De.length;ke++)De[ke].tokens=this.lexer.inline(De[ke].text);return ve}}},ae.lheading=function(Q){var re=this.rules.block.lheading.exec(Q);if(re)return{type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:this.lexer.inline(re[1])}},ae.paragraph=function(Q){var re=this.rules.block.paragraph.exec(Q);if(re){var ve=re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1];return{type:"paragraph",raw:re[0],text:ve,tokens:this.lexer.inline(ve)}}},ae.text=function(Q){var re=this.rules.block.text.exec(Q);if(re)return{type:"text",raw:re[0],text:re[0],tokens:this.lexer.inline(re[0])}},ae.escape=function(Q){var re=this.rules.inline.escape.exec(Q);if(re)return{type:"escape",raw:re[0],text:b(re[1])}},ae.tag=function(Q){var re=this.rules.inline.tag.exec(Q);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):b(re[0]):re[0]}},ae.link=function(Q){var re=this.rules.inline.link.exec(Q);if(re){var ve=re[2].trim();if(!this.options.pedantic&&/^</.test(ve)){if(!/>$/.test(ve))return;var be=C(ve.slice(0,-1),"\\");if((ve.length-be.length)%2===0)return}else{var Fe=A(re[2],"()");if(Fe>-1){var Be=re[0].indexOf("!")===0?5:4,ke=Be+re[1].length+Fe;re[2]=re[2].substring(0,Fe),re[0]=re[0].substring(0,ke).trim(),re[3]=""}}var De=re[2],Pe="";if(this.options.pedantic){var H=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(De);H&&(De=H[1],Pe=H[3])}else Pe=re[3]?re[3].slice(1,-1):"";return De=De.trim(),/^</.test(De)&&(this.options.pedantic&&!/>$/.test(ve)?De=De.slice(1):De=De.slice(1,-1)),F(re,{href:De&&De.replace(this.rules.inline._escapes,"$1"),title:Pe&&Pe.replace(this.rules.inline._escapes,"$1")},re[0],this.lexer)}},ae.reflink=function(Q,re){var ve;if((ve=this.rules.inline.reflink.exec(Q))||(ve=this.rules.inline.nolink.exec(Q))){var be=(ve[2]||ve[1]).replace(/\s+/g," ");if(be=re[be.toLowerCase()],!be||!be.href){var Fe=ve[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return F(ve,be,ve[0],this.lexer)}},ae.emStrong=function(Q,re,ve){ve===void 0&&(ve="");var be=this.rules.inline.emStrong.lDelim.exec(Q);if(be&&!(be[3]&&ve.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=be[1]||be[2]||"";if(!Fe||Fe&&(ve===""||this.rules.inline.punctuation.exec(ve))){var Be=be[0].length-1,ke,De,Pe=Be,H=0,q=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,re=re.slice(-1*Q.length+Be);(be=q.exec(re))!=null;)if(ke=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!ke){if(De=ke.length,be[3]||be[4]){Pe+=De;continue}else if((be[5]||be[6])&&Be%3&&!((Be+De)%3)){H+=De;continue}if(Pe-=De,!(Pe>0)){if(De=Math.min(De,De+Pe+H),Math.min(Be,De)%2){var X=Q.slice(1,Be+be.index+De);return{type:"em",raw:Q.slice(0,Be+be.index+De+1),text:X,tokens:this.lexer.inlineTokens(X)}}var J=Q.slice(2,Be+be.index+De-1);return{type:"strong",raw:Q.slice(0,Be+be.index+De+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ae.codespan=function(Q){var re=this.rules.inline.code.exec(Q);if(re){var ve=re[2].replace(/\n/g," "),be=/[^ ]/.test(ve),Fe=/^ /.test(ve)&&/ $/.test(ve);return be&&Fe&&(ve=ve.substring(1,ve.length-1)),ve=b(ve,!0),{type:"codespan",raw:re[0],text:ve}}},ae.br=function(Q){var re=this.rules.inline.br.exec(Q);if(re)return{type:"br",raw:re[0]}},ae.del=function(Q){var re=this.rules.inline.del.exec(Q);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2])}},ae.autolink=function(Q,re){var ve=this.rules.inline.autolink.exec(Q);if(ve){var be,Fe;return ve[2]==="@"?(be=b(this.options.mangle?re(ve[1]):ve[1]),Fe="mailto:"+be):(be=b(ve[1]),Fe=be),{type:"link",raw:ve[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},ae.url=function(Q,re){var ve;if(ve=this.rules.inline.url.exec(Q)){var be,Fe;if(ve[2]==="@")be=b(this.options.mangle?re(ve[0]):ve[0]),Fe="mailto:"+be;else{var Be;do Be=ve[0],ve[0]=this.rules.inline._backpedal.exec(ve[0])[0];while(Be!==ve[0]);be=b(ve[0]),ve[1]==="www."?Fe="http://"+be:Fe=be}return{type:"link",raw:ve[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},ae.inlineText=function(Q,re){var ve=this.rules.inline.text.exec(Q);if(ve){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):b(ve[0]):ve[0]:be=b(this.options.smartypants?re(ve[0]):ve[0]),{type:"text",raw:ve[0],text:be}}},te}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:w,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=f(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=f(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=f(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=f(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=f(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=f(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=D({},M),M.gfm=D({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=f(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=f(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=D({},M.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:w,paragraph:f(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:w,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:w,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=f(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=f(M._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=f(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=f(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=f(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=f(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=f(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=f(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=f(U.reflink).replace("label",U._label).replace("ref",M._label).getRegex(),U.nolink=f(U.nolink).replace("ref",M._label).getRegex(),U.reflinkSearch=f(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=D({},U),U.pedantic=D({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=D({},U.normal,{escape:f(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=f(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=D({},U.gfm,{br:f(U.br).replace("{2,}","*").getRegex(),text:f(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(te){var ae="",se,Q,re=te.length;for(se=0;se<re;se++)Q=te.charCodeAt(se),Math.random()>.5&&(Q="x"+Q.toString(16)),ae+="&#"+Q+";";return ae}var B=function(){function te(se){this.tokens=[],this.tokens.links=Object.create(null),this.options=se||pe.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:M.normal,inline:U.normal};this.options.pedantic?(Q.block=M.pedantic,Q.inline=U.pedantic):this.options.gfm&&(Q.block=M.gfm,this.options.breaks?Q.inline=U.breaks:Q.inline=U.gfm),this.tokenizer.rules=Q}te.lex=function(Q,re){var ve=new te(re);return ve.lex(Q)},te.lexInline=function(Q,re){var ve=new te(re);return ve.inlineTokens(Q)};var ae=te.prototype;return ae.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var re;re=this.inlineQueue.shift();)this.inlineTokens(re.src,re.tokens);return this.tokens},ae.blockTokens=function(Q,re){var ve=this;re===void 0&&(re=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(Pe,H,q){return H+"    ".repeat(q.length)});for(var be,Fe,Be,ke;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Pe){return(be=Pe.call({lexer:ve},Q,re))?(Q=Q.substring(be.raw.length),re.push(be),!0):!1}))){if(be=this.tokenizer.space(Q)){Q=Q.substring(be.raw.length),be.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(be);continue}if(be=this.tokenizer.code(Q)){Q=Q.substring(be.raw.length),Fe=re[re.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):re.push(be);continue}if(be=this.tokenizer.fences(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.heading(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.hr(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.blockquote(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.list(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.html(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.def(Q)){Q=Q.substring(be.raw.length),Fe=re[re.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.lheading(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(Be=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var Pe=1/0,H=Q.slice(1),q=void 0;ve.options.extensions.startBlock.forEach(function(X){q=X.call({lexer:this},H),typeof q=="number"&&q>=0&&(Pe=Math.min(Pe,q))}),Pe<1/0&&Pe>=0&&(Be=Q.substring(0,Pe+1))}(),this.state.top&&(be=this.tokenizer.paragraph(Be))){Fe=re[re.length-1],ke&&Fe.type==="paragraph"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):re.push(be),ke=Be.length!==Q.length,Q=Q.substring(be.raw.length);continue}if(be=this.tokenizer.text(Q)){Q=Q.substring(be.raw.length),Fe=re[re.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):re.push(be);continue}if(Q){var De="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return this.state.top=!0,re},ae.inline=function(Q,re){return re===void 0&&(re=[]),this.inlineQueue.push({src:Q,tokens:re}),re},ae.inlineTokens=function(Q,re){var ve=this;re===void 0&&(re=[]);var be,Fe,Be,ke=Q,De,Pe,H;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(De=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)q.includes(De[0].slice(De[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,De.index)+"["+S("a",De[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(De=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,De.index)+"["+S("a",De[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(De=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,De.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(Pe||(H=""),Pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(be=J.call({lexer:ve},Q,re))?(Q=Q.substring(be.raw.length),re.push(be),!0):!1}))){if(be=this.tokenizer.escape(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.tag(Q)){Q=Q.substring(be.raw.length),Fe=re[re.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):re.push(be);continue}if(be=this.tokenizer.link(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(be.raw.length),Fe=re[re.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):re.push(be);continue}if(be=this.tokenizer.emStrong(Q,ke,H)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.codespan(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.br(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.del(Q)){Q=Q.substring(be.raw.length),re.push(be);continue}if(be=this.tokenizer.autolink(Q,z)){Q=Q.substring(be.raw.length),re.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(Q,z))){Q=Q.substring(be.raw.length),re.push(be);continue}if(Be=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,he=Q.slice(1),we=void 0;ve.options.extensions.startInline.forEach(function(Oe){we=Oe.call({lexer:this},he),typeof we=="number"&&we>=0&&(J=Math.min(J,we))}),J<1/0&&J>=0&&(Be=Q.substring(0,J+1))}(),be=this.tokenizer.inlineText(Be,x)){Q=Q.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(H=be.raw.slice(-1)),Pe=!0,Fe=re[re.length-1],Fe&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):re.push(be);continue}if(Q){var X="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return re},r(te,null,[{key:"rules",get:function(){return{block:M,inline:U}}}]),te}(),ee=function(){function te(se){this.options=se||pe.defaults}var ae=te.prototype;return ae.code=function(Q,re,ve){var be=(re||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(Q,be);Fe!=null&&Fe!==Q&&(ve=!0,Q=Fe)}return Q=Q.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+b(be,!0)+'">'+(ve?Q:b(Q,!0))+`</code></pre>
`:"<pre><code>"+(ve?Q:b(Q,!0))+`</code></pre>
`},ae.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},ae.html=function(Q){return Q},ae.heading=function(Q,re,ve,be){if(this.options.headerIds){var Fe=this.options.headerPrefix+be.slug(ve);return"<h"+re+' id="'+Fe+'">'+Q+"</h"+re+`>
`}return"<h"+re+">"+Q+"</h"+re+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(Q,re,ve){var be=re?"ol":"ul",Fe=re&&ve!==1?' start="'+ve+'"':"";return"<"+be+Fe+`>
`+Q+"</"+be+`>
`},ae.listitem=function(Q){return"<li>"+Q+`</li>
`},ae.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(Q){return"<p>"+Q+`</p>
`},ae.table=function(Q,re){return re&&(re="<tbody>"+re+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+re+`</table>
`},ae.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},ae.tablecell=function(Q,re){var ve=re.header?"th":"td",be=re.align?"<"+ve+' align="'+re.align+'">':"<"+ve+">";return be+Q+("</"+ve+`>
`)},ae.strong=function(Q){return"<strong>"+Q+"</strong>"},ae.em=function(Q){return"<em>"+Q+"</em>"},ae.codespan=function(Q){return"<code>"+Q+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(Q){return"<del>"+Q+"</del>"},ae.link=function(Q,re,ve){if(Q=t(this.options.sanitize,this.options.baseUrl,Q),Q===null)return ve;var be='<a href="'+b(Q)+'"';return re&&(be+=' title="'+re+'"'),be+=">"+ve+"</a>",be},ae.image=function(Q,re,ve){if(Q=t(this.options.sanitize,this.options.baseUrl,Q),Q===null)return ve;var be='<img src="'+Q+'" alt="'+ve+'"';return re&&(be+=' title="'+re+'"'),be+=this.options.xhtml?"/>":">",be},ae.text=function(Q){return Q},te}(),V=function(){function te(){}var ae=te.prototype;return ae.strong=function(Q){return Q},ae.em=function(Q){return Q},ae.codespan=function(Q){return Q},ae.del=function(Q){return Q},ae.html=function(Q){return Q},ae.text=function(Q){return Q},ae.link=function(Q,re,ve){return""+ve},ae.image=function(Q,re,ve){return""+ve},ae.br=function(){return""},te}(),$=function(){function te(){this.seen={}}var ae=te.prototype;return ae.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(Q,re){var ve=Q,be=0;if(this.seen.hasOwnProperty(ve)){be=this.seen[Q];do be++,ve=Q+"-"+be;while(this.seen.hasOwnProperty(ve))}return re||(this.seen[Q]=be,this.seen[ve]=0),ve},ae.slug=function(Q,re){re===void 0&&(re={});var ve=this.serialize(Q);return this.getNextSafeSlug(ve,re.dryrun)},te}(),G=function(){function te(se){this.options=se||pe.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new $}te.parse=function(Q,re){var ve=new te(re);return ve.parse(Q)},te.parseInline=function(Q,re){var ve=new te(re);return ve.parseInline(Q)};var ae=te.prototype;return ae.parse=function(Q,re){re===void 0&&(re=!0);var ve="",be,Fe,Be,ke,De,Pe,H,q,X,J,he,we,Oe,Ve,Ke,et,nt,st,rt,at=Q.length;for(be=0;be<at;be++){if(J=Q[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(rt=this.options.extensions.renderers[J.type].call({parser:this},J),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){ve+=rt||"";continue}switch(J.type){case"space":continue;case"hr":{ve+=this.renderer.hr();continue}case"heading":{ve+=this.renderer.heading(this.parseInline(J.tokens),J.depth,m(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{ve+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(q="",H="",ke=J.header.length,Fe=0;Fe<ke;Fe++)H+=this.renderer.tablecell(this.parseInline(J.header[Fe].tokens),{header:!0,align:J.align[Fe]});for(q+=this.renderer.tablerow(H),X="",ke=J.rows.length,Fe=0;Fe<ke;Fe++){for(Pe=J.rows[Fe],H="",De=Pe.length,Be=0;Be<De;Be++)H+=this.renderer.tablecell(this.parseInline(Pe[Be].tokens),{header:!1,align:J.align[Be]});X+=this.renderer.tablerow(H)}ve+=this.renderer.table(q,X);continue}case"blockquote":{X=this.parse(J.tokens),ve+=this.renderer.blockquote(X);continue}case"list":{for(he=J.ordered,we=J.start,Oe=J.loose,ke=J.items.length,X="",Fe=0;Fe<ke;Fe++)Ke=J.items[Fe],et=Ke.checked,nt=Ke.task,Ve="",Ke.task&&(st=this.renderer.checkbox(et),Oe?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=st+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=st+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:st}):Ve+=st),Ve+=this.parse(Ke.tokens,Oe),X+=this.renderer.listitem(Ve,nt,et);ve+=this.renderer.list(X,he,we);continue}case"html":{ve+=this.renderer.html(J.text);continue}case"paragraph":{ve+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(X=J.tokens?this.parseInline(J.tokens):J.text;be+1<at&&Q[be+1].type==="text";)J=Q[++be],X+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);ve+=re?this.renderer.paragraph(X):X;continue}default:{var gt='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return ve},ae.parseInline=function(Q,re){re=re||this.renderer;var ve="",be,Fe,Be,ke=Q.length;for(be=0;be<ke;be++){if(Fe=Q[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Be=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){ve+=Be||"";continue}switch(Fe.type){case"escape":{ve+=re.text(Fe.text);break}case"html":{ve+=re.html(Fe.text);break}case"link":{ve+=re.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,re));break}case"image":{ve+=re.image(Fe.href,Fe.title,Fe.text);break}case"strong":{ve+=re.strong(this.parseInline(Fe.tokens,re));break}case"em":{ve+=re.em(this.parseInline(Fe.tokens,re));break}case"codespan":{ve+=re.codespan(Fe.text);break}case"br":{ve+=re.br();break}case"del":{ve+=re.del(this.parseInline(Fe.tokens,re));break}case"text":{ve+=re.text(Fe.text);break}default:{var De='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(De);return}else throw new Error(De)}}}return ve},te}();function Z(te,ae,se){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof ae=="function"&&(se=ae,ae=null),ae=D({},Z.defaults,ae||{}),E(ae),se){var Q=ae.highlight,re;try{re=B.lex(te,ae)}catch(ke){return se(ke)}var ve=function(De){var Pe;if(!De)try{ae.walkTokens&&Z.walkTokens(re,ae.walkTokens),Pe=G.parse(re,ae)}catch(H){De=H}return ae.highlight=Q,De?se(De):se(null,Pe)};if(!Q||Q.length<3||(delete ae.highlight,!re.length))return ve();var be=0;Z.walkTokens(re,function(ke){ke.type==="code"&&(be++,setTimeout(function(){Q(ke.text,ke.lang,function(De,Pe){if(De)return ve(De);Pe!=null&&Pe!==ke.text&&(ke.text=Pe,ke.escaped=!0),be--,be===0&&ve()})},0))}),be===0&&ve();return}function Fe(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+b(ke.message+"",!0)+"</pre>";throw ke}try{var Be=B.lex(te,ae);if(ae.walkTokens){if(ae.async)return Promise.all(Z.walkTokens(Be,ae.walkTokens)).then(function(){return G.parse(Be,ae)}).catch(Fe);Z.walkTokens(Be,ae.walkTokens)}return G.parse(Be,ae)}catch(ke){Fe(ke)}}Z.options=Z.setOptions=function(te){return D(Z.defaults,te),R(Z.defaults),Z},Z.getDefaults=L,Z.defaults=pe.defaults,Z.use=function(){for(var te=arguments.length,ae=new Array(te),se=0;se<te;se++)ae[se]=arguments[se];var Q=D.apply(void 0,[{}].concat(ae)),re=Z.defaults.extensions||{renderers:{},childTokens:{}},ve;ae.forEach(function(be){if(be.extensions&&(ve=!0,be.extensions.forEach(function(Be){if(!Be.name)throw new Error("extension name required");if(Be.renderer){var ke=re.renderers?re.renderers[Be.name]:null;ke?re.renderers[Be.name]=function(){for(var De=arguments.length,Pe=new Array(De),H=0;H<De;H++)Pe[H]=arguments[H];var q=Be.renderer.apply(this,Pe);return q===!1&&(q=ke.apply(this,Pe)),q}:re.renderers[Be.name]=Be.renderer}if(Be.tokenizer){if(!Be.level||Be.level!=="block"&&Be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");re[Be.level]?re[Be.level].unshift(Be.tokenizer):re[Be.level]=[Be.tokenizer],Be.start&&(Be.level==="block"?re.startBlock?re.startBlock.push(Be.start):re.startBlock=[Be.start]:Be.level==="inline"&&(re.startInline?re.startInline.push(Be.start):re.startInline=[Be.start]))}Be.childTokens&&(re.childTokens[Be.name]=Be.childTokens)})),be.renderer&&function(){var Be=Z.defaults.renderer||new ee,ke=function(H){var q=Be[H];Be[H]=function(){for(var X=arguments.length,J=new Array(X),he=0;he<X;he++)J[he]=arguments[he];var we=be.renderer[H].apply(Be,J);return we===!1&&(we=q.apply(Be,J)),we}};for(var De in be.renderer)ke(De);Q.renderer=Be}(),be.tokenizer&&function(){var Be=Z.defaults.tokenizer||new O,ke=function(H){var q=Be[H];Be[H]=function(){for(var X=arguments.length,J=new Array(X),he=0;he<X;he++)J[he]=arguments[he];var we=be.tokenizer[H].apply(Be,J);return we===!1&&(we=q.apply(Be,J)),we}};for(var De in be.tokenizer)ke(De);Q.tokenizer=Be}(),be.walkTokens){var Fe=Z.defaults.walkTokens;Q.walkTokens=function(Be){var ke=[];return ke.push(be.walkTokens.call(this,Be)),Fe&&(ke=ke.concat(Fe.call(this,Be))),ke}}ve&&(Q.extensions=re),Z.setOptions(Q)})},Z.walkTokens=function(te,ae){for(var se=[],Q=function(){var Fe=ve.value;switch(se=se.concat(ae.call(Z,Fe)),Fe.type){case"table":{for(var Be=k(Fe.header),ke;!(ke=Be()).done;){var De=ke.value;se=se.concat(Z.walkTokens(De.tokens,ae))}for(var Pe=k(Fe.rows),H;!(H=Pe()).done;)for(var q=H.value,X=k(q),J;!(J=X()).done;){var he=J.value;se=se.concat(Z.walkTokens(he.tokens,ae))}break}case"list":{se=se.concat(Z.walkTokens(Fe.items,ae));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[Fe.type]?Z.defaults.extensions.childTokens[Fe.type].forEach(function(we){se=se.concat(Z.walkTokens(Fe[we],ae))}):Fe.tokens&&(se=se.concat(Z.walkTokens(Fe.tokens,ae)))}},re=k(te),ve;!(ve=re()).done;)Q();return se},Z.parseInline=function(te,ae){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");ae=D({},Z.defaults,ae||{}),E(ae);try{var se=B.lexInline(te,ae);return ae.walkTokens&&Z.walkTokens(se,ae.walkTokens),G.parseInline(se,ae)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+b(Q.message+"",!0)+"</pre>";throw Q}},Z.Parser=G,Z.parser=G.parse,Z.Renderer=ee,Z.TextRenderer=V,Z.Lexer=B,Z.lexer=B.lex,Z.Tokenizer=O,Z.Slugger=$,Z.parse=Z;var le=Z.options,ne=Z.setOptions,_e=Z.use,ge=Z.walkTokens,Y=Z.parseInline,W=Z,oe=G.parse,Se=B.lex;pe.Lexer=B,pe.Parser=G,pe.Renderer=ee,pe.Slugger=$,pe.TextRenderer=V,pe.Tokenizer=O,pe.getDefaults=L,pe.lexer=Se,pe.marked=Z,pe.options=le,pe.parse=W,pe.parseInline=Y,pe.parser=oe,pe.setOptions=ne,pe.use=_e,pe.walkTokens=ge,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Ce[40],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(d){d[d.Uri=1]="Uri",d[d.Regexp=2]="Regexp",d[d.ScmResource=3]="ScmResource",d[d.ScmResourceGroup=4]="ScmResourceGroup",d[d.ScmProvider=5]="ScmProvider",d[d.CommentController=6]="CommentController",d[d.CommentThread=7]="CommentThread",d[d.CommentThreadInstance=8]="CommentThreadInstance",d[d.CommentThreadReply=9]="CommentThreadReply",d[d.CommentNode=10]="CommentNode",d[d.CommentThreadNode=11]="CommentThreadNode",d[d.TimelineActionContext=12]="TimelineActionContext",d[d.NotebookCellActionContext=13]="NotebookCellActionContext",d[d.NotebookActionContext=14]="NotebookActionContext",d[d.TerminalContext=15]="TerminalContext",d[d.TestItemContext=16]="TestItemContext",d[d.Date=17]="Date",d[d.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(Ce[179],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=r;function r(a){const m=k(a);if(m&&m.length>0)return new Uint32Array(m)}let d=0;const P=new Uint32Array(10);function k(a){if(d=0,L(a,y,v.InitialConsonant),d>0||(L(a,u,v.Vowel),d>0)||(L(a,T,v.FinalConsonant),d>0)||(L(a,b,v.CompatibilityJamo),d))return P.subarray(0,d);if(a>=44032&&a<=55203){const m=a-44032,p=m%588,f=Math.floor(m/588),i=Math.floor(p/28),s=p%28-1;if(f<y.length?L(f,y,0):v.InitialConsonant+f-v.CompatibilityJamo<b.length&&L(v.InitialConsonant+f,b,v.CompatibilityJamo),i<u.length?L(i,u,0):v.Vowel+i-v.CompatibilityJamo<b.length&&L(v.Vowel+i-v.CompatibilityJamo,b,v.CompatibilityJamo),s>=0&&(s<T.length?L(s,T,0):v.FinalConsonant+s-v.CompatibilityJamo<b.length&&L(v.FinalConsonant+s-v.CompatibilityJamo,b,v.CompatibilityJamo)),d>0)return P.subarray(0,d)}}function L(a,m,p){a>=p&&a<p+m.length&&R(m[a-p])}function R(a){a!==l.NUL&&(P[d++]=a&255,a>>8&&(P[d++]=a>>8&255),a>>16&&(P[d++]=a>>16&255))}var v;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var l;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(l||(l={}));var I;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(I||(I={}));const y=new Uint8Array([l.r,l.R,l.s,l.e,l.E,l.f,l.a,l.q,l.Q,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g]),u=new Uint16Array([l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,I.hk,I.ho,I.hl,l.y,l.n,I.nj,I.np,I.nl,l.b,l.m,I.ml,l.l]),T=new Uint16Array([l.r,l.R,I.rt,l.s,I.sw,I.sg,l.e,l.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,l.a,l.q,I.qt,l.t,l.T,l.d,l.w,l.c,l.z,l.x,l.v,l.g]),b=new Uint16Array([l.r,l.R,I.rt,l.s,I.sw,I.sg,l.e,l.E,l.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,l.a,l.q,l.Q,I.qt,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g,l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,I.hk,I.ho,I.hl,l.y,l.n,I.nj,I.np,I.nl,l.b,l.m,I.ml,l.l])}),define(Ce[81],Ie([1,0,28]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=P,e.normalizeNFD=L;const d=new r.LRUCache(1e4);function P(l){return v(l,"NFC",d)}const k=new r.LRUCache(1e4);function L(l){return v(l,"NFD",k)}const R=/[^\u0000-\u0080]/;function v(l,I,y){if(!l)return l;const u=y.get(l);if(u)return u;let T;return R.test(l)?T=l.normalize(I):T=l,y.set(l,T),T}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(I){return L(I).replace(l,"")}}()}),define(Ce[133],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=r,e.rot=d,e.isPointWithinTriangle=R;function r(v,l,I){return Math.min(Math.max(v,l),I)}function d(v,l){return(l+v%l)%l}class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class k{constructor(){this._n=1,this._val=0}update(l){return this._val=this._val+(l-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=k;class L{constructor(l){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(l),this._values.fill(0,0,l)}update(l){const I=this._values[this._index];return this._values[this._index]=l,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=l,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=L;function R(v,l,I,y,u,T,b,a){const m=b-I,p=a-y,f=u-I,i=T-y,s=v-I,t=l-y,o=m*m+p*p,n=m*f+p*i,h=m*s+p*t,c=f*f+i*i,g=f*s+i*t,w=1/(o*c-n*n),D=(c*h-n*g)*w,_=(o*g-n*h)*w;return D>=0&&_>=0&&D+_<1}}),define(Ce[180],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=k,e.getFunctionName=u;class r{constructor(b,a,m){this.owner=b,this.debugNameSource=a,this.referenceFn=m}getDebugName(b){return k(b,this)}}e.DebugNameData=r;const d=new Map,P=new WeakMap;function k(T,b){const a=P.get(T);if(a)return a;const m=L(T,b);if(m){let p=d.get(m)??0;p++,d.set(m,p);const f=p===1?m:`${m}#${p}`;return P.set(T,f),f}}function L(T,b){const a=P.get(T);if(a)return a;const m=b.owner?I(b.owner)+".":"";let p;const f=b.debugNameSource;if(f!==void 0)if(typeof f=="function"){if(p=f(),p!==void 0)return m+p}else return m+f;const i=b.referenceFn;if(i!==void 0&&(p=u(i),p!==void 0))return m+p;if(b.owner!==void 0){const s=R(b.owner,T);if(s!==void 0)return m+s}}function R(T,b){for(const a in T)if(T[a]===b)return a}const v=new Map,l=new WeakMap;function I(T){const b=l.get(T);if(b)return b;const a=y(T);let m=v.get(a)??0;m++,v.set(a,m);const p=m===1?a:`${a}#${m}`;return l.set(T,p),p}function y(T){const b=T.constructor;return b?b.name:"Object"}function u(T){const b=T.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(m?m[1]:void 0)?.trim()}}),define(Ce[181],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=d,e.getLogger=P;let r;function d(a){r=a}function P(){return r}class k{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(m){return L([R(T("|  ",this.indentation)),m])}formatInfo(m){return m.hadValue?m.didChange?[R(" "),l(I(m.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),l(I(m.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),l(I(m.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(m,p){console.log(...this.textToConsoleArgs([v("observable value changed"),l(m.debugName,{color:"BlueViolet"}),...this.formatInfo(p)]))}formatChanges(m){if(m.size!==0)return l(" (changed deps: "+[...m].map(p=>p.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const p=m.handleChange;this.changedObservablesSets.set(m,new Set),m.handleChange=(f,i)=>(this.changedObservablesSets.get(m).add(f),p.apply(m,[f,i]))}handleDerivedRecomputed(m,p){const f=this.changedObservablesSets.get(m);console.log(...this.textToConsoleArgs([v("derived recomputed"),l(m.debugName,{color:"BlueViolet"}),...this.formatInfo(p),this.formatChanges(f),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),f.clear()}handleFromEventObservableTriggered(m,p){console.log(...this.textToConsoleArgs([v("observable from event triggered"),l(m.debugName,{color:"BlueViolet"}),...this.formatInfo(p),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const p=m.handleChange;this.changedObservablesSets.set(m,new Set),m.handleChange=(f,i)=>(this.changedObservablesSets.get(m).add(f),p.apply(m,[f,i]))}handleAutorunTriggered(m){const p=this.changedObservablesSets.get(m);console.log(...this.textToConsoleArgs([v("autorun"),l(m.debugName,{color:"BlueViolet"}),this.formatChanges(p),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),p.clear(),this.indentation++}handleAutorunFinished(m){this.indentation--}handleBeginTransaction(m){let p=m.getDebugName();p===void 0&&(p=""),console.log(...this.textToConsoleArgs([v("transaction"),l(p,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=k;function L(a){const m=new Array,p=[];let f="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(f+=`%c${t.text}`,m.push(t.style),t.data&&p.push(...t.data)):"data"in t&&p.push(...t.data)}i(a);const s=[f,...m];return s.push(...p),s}function R(a){return l(a,{color:"black"})}function v(a){return l(b(`${a}: `,10),{color:"black",bold:!0})}function l(a,m={color:"black"}){function p(i){return Object.entries(i).reduce((s,[t,o])=>`${s}${t}:${o};`,"")}const f={color:m.color};return m.strikeThrough&&(f["text-decoration"]="line-through"),m.bold&&(f["font-weight"]="bold"),{text:a,style:p(f)}}function I(a,m){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=m?`"${a}"`:`"${a.substr(0,m-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?y(a,m):u(a,m);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function y(a,m){let p="[ ",f=!0;for(const i of a){if(f||(p+=", "),p.length-5>m){p+="...";break}f=!1,p+=`${I(i,m-p.length)}`}return p+=" ]",p}function u(a,m){let p="{ ",f=!0;for(const[i,s]of Object.entries(a)){if(f||(p+=", "),p.length-5>m){p+="...";break}f=!1,p+=`${i}: ${I(s,m-p.length)}`}return p+=" }",p}function T(a,m){let p="";for(let f=1;f<=m;f++)p+=a;return p}function b(a,m){for(;a.length<m;)a+=" ";return a}}),define(Ce[182],Ie([1,0,175,180,181]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=L,e._setKeepObserved=v,e._setDerivedOpts=I,e.transaction=T,e.globalTransaction=a,e.asyncTransaction=m,e.subtransaction=p,e.observableValue=i,e.disposableObservableValue=t;let k;function L(n){k=n}let R;function v(n){R=n}let l;function I(n){l=n}class y{get TChange(){return null}reportChanges(){this.get()}read(h){return h?h.readObservable(this):this.get()}map(h,c){const g=c===void 0?void 0:h,w=c===void 0?h:c;return l({owner:g,debugName:()=>{const D=(0,d.getFunctionName)(w);if(D!==void 0)return D;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(w.toString());if(C)return`${this.debugName}.${C[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:w},D=>w(this.read(D),D))}flatten(){return l({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},h=>this.read(h).read(h))}recomputeInitiallyAndOnChange(h,c){return h.add(k(this,c)),this}keepObserved(h){return h.add(R(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=y;class u extends y{constructor(){super(...arguments),this.observers=new Set}addObserver(h){const c=this.observers.size;this.observers.add(h),c===0&&this.onFirstObserverAdded()}removeObserver(h){this.observers.delete(h)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=u;function T(n,h){const c=new f(n,h);try{n(c)}finally{c.finish()}}let b;function a(n){if(b)n(b);else{const h=new f(n,void 0);b=h;try{n(h)}finally{h.finish(),b=void 0}}}async function m(n,h){const c=new f(n,h);try{await n(c)}finally{c.finish()}}function p(n,h,c){n?h(n):T(h,c)}class f{constructor(h,c){this._fn=h,this._getDebugName=c,this.updatingObservers=[],(0,P.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,d.getFunctionName)(this._fn)}updateObserver(h,c){this.updatingObservers.push({observer:h,observable:c}),h.beginUpdate(c)}finish(){const h=this.updatingObservers;for(let c=0;c<h.length;c++){const{observer:g,observable:w}=h[c];g.endUpdate(w)}this.updatingObservers=null,(0,P.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=f;function i(n,h){let c;return typeof n=="string"?c=new d.DebugNameData(void 0,n,void 0):c=new d.DebugNameData(n,void 0,void 0),new s(c,h,r.strictEquals)}class s extends u{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(h,c,g){super(),this._debugNameData=h,this._equalityComparator=g,this._value=c}get(){return this._value}set(h,c,g){if(g===void 0&&this._equalityComparator(this._value,h))return;let w;c||(c=w=new f(()=>{},()=>`Setting ${this.debugName}`));try{const D=this._value;this._setValue(h),(0,P.getLogger)()?.handleObservableChanged(this,{oldValue:D,newValue:h,change:g,didChange:!0,hadValue:!0});for(const _ of this.observers)c.updateObserver(_,this),_.handleChange(this,g)}finally{w&&w.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(h){this._value=h}}e.ObservableValue=s;function t(n,h){let c;return typeof n=="string"?c=new d.DebugNameData(void 0,n,void 0):c=new d.DebugNameData(n,void 0,void 0),new o(c,h,r.strictEquals)}class o extends s{_setValue(h){this._value!==h&&(this._value&&this._value.dispose(),this._value=h)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=o}),function(){function pe(P){const k=[];typeof P=="number"&&k.push("code/timeOrigin",P);function L(v){k.push(v,Date.now())}function R(){const v=[];for(let l=0;l<k.length;l+=2)v.push({name:k[l],startTime:k[l+1]});return v}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(P+L.startTime)});return k}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function r(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var d;typeof global=="object"?d=global:typeof self=="object"?d=self:d={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(d)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(d):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),d.perf=r(d))}(),define(Ce[10],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=o,e.isLittleEndian=D,e.isBigSurOrNewer=_,e.LANGUAGE_DEFAULT="en";let r=!1,d=!1,P=!1,k=!1,L=!1,R=!1,v=!1,l=!1,I=!1,y=!1,u,T=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT,a,m;const p=globalThis;let f;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?f=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const i=typeof f?.versions?.electron=="string",s=i&&f?.type==="renderer";if(typeof f=="object"){r=f.platform==="win32",d=f.platform==="darwin",P=f.platform==="linux",k=P&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,v=i,I=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,T=e.LANGUAGE_DEFAULT;const C=f.env.VSCODE_NLS_CONFIG;if(C)try{const A=JSON.parse(C);u=A.userLocale,b=A.osLocale,T=A.resolvedLanguage||e.LANGUAGE_DEFAULT,a=A.languagePack?.translationsConfigFile}catch{}L=!0}else typeof navigator=="object"&&!s?(m=navigator.userAgent,r=m.indexOf("Windows")>=0,d=m.indexOf("Macintosh")>=0,l=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=m.indexOf("Linux")>=0,y=m?.indexOf("Mobi")>=0,R=!0,T=globalThis._VSCODE_NLS_LANGUAGE||e.LANGUAGE_DEFAULT,u=navigator.language.toLowerCase(),b=u):console.error("Unable to resolve platform.");var t;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(C){switch(C){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let n=t.Web;d?n=t.Mac:r?n=t.Windows:P&&(n=t.Linux),e.isWindows=r,e.isMacintosh=d,e.isLinux=P,e.isLinuxSnap=k,e.isNative=L,e.isElectron=v,e.isWeb=R,e.isWebWorker=R&&typeof p.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?p.origin:void 0,e.isIOS=l,e.isMobile=y,e.isCI=I,e.platform=n,e.userAgent=m,e.language=T;var h;(function(C){function A(){return e.language}C.value=A;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}C.isDefaultVariant=E;function S(){return e.language==="en"}C.isDefault=S})(h||(e.Language=h={})),e.locale=u,e.platformLocale=b,e.translationsConfigFile=a,e.setTimeout0IsFaster=typeof p.postMessage=="function"&&!p.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const C=[];p.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let S=0,F=C.length;S<F;S++){const N=C[S];if(N.id===E.data.vscodeScheduleAsyncWork){C.splice(S,1),N.callback();return}}});let A=0;return E=>{const S=++A;C.push({id:S,callback:E}),p.postMessage({vscodeScheduleAsyncWork:S},"*")}}return C=>setTimeout(C)})();var c;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=d||l?c.Macintosh:r?c.Windows:c.Linux;let g=!0,w=!1;function D(){if(!w){w=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,g=new Uint16Array(C.buffer)[0]===513}return g}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function _(C){return parseFloat(C)>=20}}),define(Ce[183],Ie([1,0,39]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const d=Symbol("unset");class P{constructor(){this.root=new L,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||r.Iterable.empty()}get entries(){return this.root.children?.entries()||r.Iterable.empty()}insert(v,l,I){this.opNode(v,y=>y._value=l,I)}mutate(v,l){this.opNode(v,I=>I._value=l(I._value===d?void 0:I._value))}mutatePath(v,l){this.opNode(v,()=>{},I=>l(I))}delete(v){const l=this.getPathToKey(v);if(!l)return;let I=l.length-1;const y=l[I].node._value;if(y!==d){for(this._size--,l[I].node._value=d;I>0;I--){const{node:u,part:T}=l[I];if(u.children?.size||u._value!==d)break;l[I-1].node.children.delete(T)}return y}}*deleteRecursive(v){const l=this.getPathToKey(v);if(!l)return;const I=l[l.length-1].node;for(let y=l.length-1;y>0;y--){const u=l[y-1];if(u.node.children.delete(l[y].part),u.node.children.size>0||u.node._value!==d)break}for(const y of k(I))y._value!==d&&(this._size--,yield y._value)}find(v){let l=this.root;for(const I of v){const y=l.children?.get(I);if(!y)return;l=y}return l._value===d?void 0:l._value}hasKeyOrParent(v){let l=this.root;for(const I of v){const y=l.children?.get(I);if(!y)return!1;if(y._value!==d)return!0;l=y}return!1}hasKeyOrChildren(v){let l=this.root;for(const I of v){const y=l.children?.get(I);if(!y)return!1;l=y}return!0}hasKey(v){let l=this.root;for(const I of v){const y=l.children?.get(I);if(!y)return!1;l=y}return l._value!==d}getPathToKey(v){const l=[{part:"",node:this.root}];let I=0;for(const y of v){const u=l[I].node.children?.get(y);if(!u)return;l.push({part:y,node:u}),I++}return l}opNode(v,l,I){let y=this.root;for(const b of v){if(y.children)if(y.children.has(b))y=y.children.get(b);else{const a=new L;y.children.set(b,a),y=a}else{const a=new L;y.children=new Map([[b,a]]),y=a}I?.(y)}const u=y._value===d?0:1;l(y);const T=y._value===d?0:1;this._size+=T-u}*values(){for(const{_value:v}of k(this.root))v!==d&&(yield v)}}e.WellDefinedPrefixTree=P;function*k(R){const v=[R];for(;v.length>0;){const l=v.pop();if(yield l,l.children)for(const I of l.children.values())v.push(I)}}class L{constructor(){this._value=d}get value(){return this._value===d?void 0:this._value}set value(v){this._value=v===void 0?d:v}}}),define(Ce[55],Ie([1,0,10]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let d;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const k=P.process;d={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?d={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:d={get platform(){return r.isWindows?"win32":r.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=d.cwd,e.env=d.env,e.platform=d.platform,e.arch=d.arch}),define(Ce[16],Ie([1,0,55]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,r=$e(r);const d=65,P=97,k=90,L=122,R=46,v=47,l=92,I=58,y=63;class u extends Error{constructor(h,c,g){let w;typeof c=="string"&&c.indexOf("not ")===0?(w="must not be",c=c.replace(/^not /,"")):w="must be";const D=h.indexOf(".")!==-1?"property":"argument";let _=`The "${h}" ${D} ${w} of type ${c}`;_+=`. Received type ${typeof g}`,super(_),this.code="ERR_INVALID_ARG_TYPE"}}function T(n,h){if(n===null||typeof n!="object")throw new u(h,"Object",n)}function b(n,h){if(typeof n!="string")throw new u(h,"string",n)}const a=r.platform==="win32";function m(n){return n===v||n===l}function p(n){return n===v}function f(n){return n>=d&&n<=k||n>=P&&n<=L}function i(n,h,c,g){let w="",D=0,_=-1,C=0,A=0;for(let E=0;E<=n.length;++E){if(E<n.length)A=n.charCodeAt(E);else{if(g(A))break;A=v}if(g(A)){if(!(_===E-1||C===1))if(C===2){if(w.length<2||D!==2||w.charCodeAt(w.length-1)!==R||w.charCodeAt(w.length-2)!==R){if(w.length>2){const S=w.lastIndexOf(c);S===-1?(w="",D=0):(w=w.slice(0,S),D=w.length-1-w.lastIndexOf(c)),_=E,C=0;continue}else if(w.length!==0){w="",D=0,_=E,C=0;continue}}h&&(w+=w.length>0?`${c}..`:"..",D=2)}else w.length>0?w+=`${c}${n.slice(_+1,E)}`:w=n.slice(_+1,E),D=E-_-1;_=E,C=0}else A===R&&C!==-1?++C:C=-1}return w}function s(n){return n?`${n[0]==="."?"":"."}${n}`:""}function t(n,h){T(h,"pathObject");const c=h.dir||h.root,g=h.base||`${h.name||""}${s(h.ext)}`;return c?c===h.root?`${c}${g}`:`${c}${n}${g}`:g}e.win32={resolve(...n){let h="",c="",g=!1;for(let w=n.length-1;w>=-1;w--){let D;if(w>=0){if(D=n[w],b(D,`paths[${w}]`),D.length===0)continue}else h.length===0?D=r.cwd():(D=r.env[`=${h}`]||r.cwd(),(D===void 0||D.slice(0,2).toLowerCase()!==h.toLowerCase()&&D.charCodeAt(2)===l)&&(D=`${h}\\`));const _=D.length;let C=0,A="",E=!1;const S=D.charCodeAt(0);if(_===1)m(S)&&(C=1,E=!0);else if(m(S))if(E=!0,m(D.charCodeAt(1))){let F=2,N=F;for(;F<_&&!m(D.charCodeAt(F));)F++;if(F<_&&F!==N){const O=D.slice(N,F);for(N=F;F<_&&m(D.charCodeAt(F));)F++;if(F<_&&F!==N){for(N=F;F<_&&!m(D.charCodeAt(F));)F++;(F===_||F!==N)&&(A=`\\\\${O}\\${D.slice(N,F)}`,C=F)}}}else C=1;else f(S)&&D.charCodeAt(1)===I&&(A=D.slice(0,2),C=2,_>2&&m(D.charCodeAt(2))&&(E=!0,C=3));if(A.length>0)if(h.length>0){if(A.toLowerCase()!==h.toLowerCase())continue}else h=A;if(g){if(h.length>0)break}else if(c=`${D.slice(C)}\\${c}`,g=E,E&&h.length>0)break}return c=i(c,!g,"\\",m),g?`${h}\\${c}`:`${h}${c}`||"."},normalize(n){b(n,"path");const h=n.length;if(h===0)return".";let c=0,g,w=!1;const D=n.charCodeAt(0);if(h===1)return p(D)?"\\":n;if(m(D))if(w=!0,m(n.charCodeAt(1))){let C=2,A=C;for(;C<h&&!m(n.charCodeAt(C));)C++;if(C<h&&C!==A){const E=n.slice(A,C);for(A=C;C<h&&m(n.charCodeAt(C));)C++;if(C<h&&C!==A){for(A=C;C<h&&!m(n.charCodeAt(C));)C++;if(C===h)return`\\\\${E}\\${n.slice(A)}\\`;C!==A&&(g=`\\\\${E}\\${n.slice(A,C)}`,c=C)}}}else c=1;else f(D)&&n.charCodeAt(1)===I&&(g=n.slice(0,2),c=2,h>2&&m(n.charCodeAt(2))&&(w=!0,c=3));let _=c<h?i(n.slice(c),!w,"\\",m):"";return _.length===0&&!w&&(_="."),_.length>0&&m(n.charCodeAt(h-1))&&(_+="\\"),g===void 0?w?`\\${_}`:_:w?`${g}\\${_}`:`${g}${_}`},isAbsolute(n){b(n,"path");const h=n.length;if(h===0)return!1;const c=n.charCodeAt(0);return m(c)||h>2&&f(c)&&n.charCodeAt(1)===I&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let h,c;for(let D=0;D<n.length;++D){const _=n[D];b(_,"path"),_.length>0&&(h===void 0?h=c=_:h+=`\\${_}`)}if(h===void 0)return".";let g=!0,w=0;if(typeof c=="string"&&m(c.charCodeAt(0))){++w;const D=c.length;D>1&&m(c.charCodeAt(1))&&(++w,D>2&&(m(c.charCodeAt(2))?++w:g=!1))}if(g){for(;w<h.length&&m(h.charCodeAt(w));)w++;w>=2&&(h=`\\${h.slice(w)}`)}return e.win32.normalize(h)},relative(n,h){if(b(n,"from"),b(h,"to"),n===h)return"";const c=e.win32.resolve(n),g=e.win32.resolve(h);if(c===g||(n=c.toLowerCase(),h=g.toLowerCase(),n===h))return"";let w=0;for(;w<n.length&&n.charCodeAt(w)===l;)w++;let D=n.length;for(;D-1>w&&n.charCodeAt(D-1)===l;)D--;const _=D-w;let C=0;for(;C<h.length&&h.charCodeAt(C)===l;)C++;let A=h.length;for(;A-1>C&&h.charCodeAt(A-1)===l;)A--;const E=A-C,S=_<E?_:E;let F=-1,N=0;for(;N<S;N++){const M=n.charCodeAt(w+N);if(M!==h.charCodeAt(C+N))break;M===l&&(F=N)}if(N!==S){if(F===-1)return g}else{if(E>S){if(h.charCodeAt(C+N)===l)return g.slice(C+N+1);if(N===2)return g.slice(C+N)}_>S&&(n.charCodeAt(w+N)===l?F=N:N===2&&(F=3)),F===-1&&(F=0)}let O="";for(N=w+F+1;N<=D;++N)(N===D||n.charCodeAt(N)===l)&&(O+=O.length===0?"..":"\\..");return C+=F,O.length>0?`${O}${g.slice(C,A)}`:(g.charCodeAt(C)===l&&++C,g.slice(C,A))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const h=e.win32.resolve(n);if(h.length<=2)return n;if(h.charCodeAt(0)===l){if(h.charCodeAt(1)===l){const c=h.charCodeAt(2);if(c!==y&&c!==R)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(f(h.charCodeAt(0))&&h.charCodeAt(1)===I&&h.charCodeAt(2)===l)return`\\\\?\\${h}`;return n},dirname(n){b(n,"path");const h=n.length;if(h===0)return".";let c=-1,g=0;const w=n.charCodeAt(0);if(h===1)return m(w)?n:".";if(m(w)){if(c=g=1,m(n.charCodeAt(1))){let C=2,A=C;for(;C<h&&!m(n.charCodeAt(C));)C++;if(C<h&&C!==A){for(A=C;C<h&&m(n.charCodeAt(C));)C++;if(C<h&&C!==A){for(A=C;C<h&&!m(n.charCodeAt(C));)C++;if(C===h)return n;C!==A&&(c=g=C+1)}}}}else f(w)&&n.charCodeAt(1)===I&&(c=h>2&&m(n.charCodeAt(2))?3:2,g=c);let D=-1,_=!0;for(let C=h-1;C>=g;--C)if(m(n.charCodeAt(C))){if(!_){D=C;break}}else _=!1;if(D===-1){if(c===-1)return".";D=c}return n.slice(0,D)},basename(n,h){h!==void 0&&b(h,"suffix"),b(n,"path");let c=0,g=-1,w=!0,D;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===I&&(c=2),h!==void 0&&h.length>0&&h.length<=n.length){if(h===n)return"";let _=h.length-1,C=-1;for(D=n.length-1;D>=c;--D){const A=n.charCodeAt(D);if(m(A)){if(!w){c=D+1;break}}else C===-1&&(w=!1,C=D+1),_>=0&&(A===h.charCodeAt(_)?--_===-1&&(g=D):(_=-1,g=C))}return c===g?g=C:g===-1&&(g=n.length),n.slice(c,g)}for(D=n.length-1;D>=c;--D)if(m(n.charCodeAt(D))){if(!w){c=D+1;break}}else g===-1&&(w=!1,g=D+1);return g===-1?"":n.slice(c,g)},extname(n){b(n,"path");let h=0,c=-1,g=0,w=-1,D=!0,_=0;n.length>=2&&n.charCodeAt(1)===I&&f(n.charCodeAt(0))&&(h=g=2);for(let C=n.length-1;C>=h;--C){const A=n.charCodeAt(C);if(m(A)){if(!D){g=C+1;break}continue}w===-1&&(D=!1,w=C+1),A===R?c===-1?c=C:_!==1&&(_=1):c!==-1&&(_=-1)}return c===-1||w===-1||_===0||_===1&&c===w-1&&c===g+1?"":n.slice(c,w)},format:t.bind(null,"\\"),parse(n){b(n,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return h;const c=n.length;let g=0,w=n.charCodeAt(0);if(c===1)return m(w)?(h.root=h.dir=n,h):(h.base=h.name=n,h);if(m(w)){if(g=1,m(n.charCodeAt(1))){let F=2,N=F;for(;F<c&&!m(n.charCodeAt(F));)F++;if(F<c&&F!==N){for(N=F;F<c&&m(n.charCodeAt(F));)F++;if(F<c&&F!==N){for(N=F;F<c&&!m(n.charCodeAt(F));)F++;F===c?g=F:F!==N&&(g=F+1)}}}}else if(f(w)&&n.charCodeAt(1)===I){if(c<=2)return h.root=h.dir=n,h;if(g=2,m(n.charCodeAt(2))){if(c===3)return h.root=h.dir=n,h;g=3}}g>0&&(h.root=n.slice(0,g));let D=-1,_=g,C=-1,A=!0,E=n.length-1,S=0;for(;E>=g;--E){if(w=n.charCodeAt(E),m(w)){if(!A){_=E+1;break}continue}C===-1&&(A=!1,C=E+1),w===R?D===-1?D=E:S!==1&&(S=1):D!==-1&&(S=-1)}return C!==-1&&(D===-1||S===0||S===1&&D===C-1&&D===_+1?h.base=h.name=n.slice(_,C):(h.name=n.slice(_,D),h.base=n.slice(_,C),h.ext=n.slice(D,C))),_>0&&_!==g?h.dir=n.slice(0,_-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(a){const n=/\\/g;return()=>{const h=r.cwd().replace(n,"/");return h.slice(h.indexOf("/"))}}return()=>r.cwd()})();e.posix={resolve(...n){let h="",c=!1;for(let g=n.length-1;g>=-1&&!c;g--){const w=g>=0?n[g]:o();b(w,`paths[${g}]`),w.length!==0&&(h=`${w}/${h}`,c=w.charCodeAt(0)===v)}return h=i(h,!c,"/",p),c?`/${h}`:h.length>0?h:"."},normalize(n){if(b(n,"path"),n.length===0)return".";const h=n.charCodeAt(0)===v,c=n.charCodeAt(n.length-1)===v;return n=i(n,!h,"/",p),n.length===0?h?"/":c?"./":".":(c&&(n+="/"),h?`/${n}`:n)},isAbsolute(n){return b(n,"path"),n.length>0&&n.charCodeAt(0)===v},join(...n){if(n.length===0)return".";let h;for(let c=0;c<n.length;++c){const g=n[c];b(g,"path"),g.length>0&&(h===void 0?h=g:h+=`/${g}`)}return h===void 0?".":e.posix.normalize(h)},relative(n,h){if(b(n,"from"),b(h,"to"),n===h||(n=e.posix.resolve(n),h=e.posix.resolve(h),n===h))return"";const c=1,g=n.length,w=g-c,D=1,_=h.length-D,C=w<_?w:_;let A=-1,E=0;for(;E<C;E++){const F=n.charCodeAt(c+E);if(F!==h.charCodeAt(D+E))break;F===v&&(A=E)}if(E===C)if(_>C){if(h.charCodeAt(D+E)===v)return h.slice(D+E+1);if(E===0)return h.slice(D+E)}else w>C&&(n.charCodeAt(c+E)===v?A=E:E===0&&(A=0));let S="";for(E=c+A+1;E<=g;++E)(E===g||n.charCodeAt(E)===v)&&(S+=S.length===0?"..":"/..");return`${S}${h.slice(D+A)}`},toNamespacedPath(n){return n},dirname(n){if(b(n,"path"),n.length===0)return".";const h=n.charCodeAt(0)===v;let c=-1,g=!0;for(let w=n.length-1;w>=1;--w)if(n.charCodeAt(w)===v){if(!g){c=w;break}}else g=!1;return c===-1?h?"/":".":h&&c===1?"//":n.slice(0,c)},basename(n,h){h!==void 0&&b(h,"ext"),b(n,"path");let c=0,g=-1,w=!0,D;if(h!==void 0&&h.length>0&&h.length<=n.length){if(h===n)return"";let _=h.length-1,C=-1;for(D=n.length-1;D>=0;--D){const A=n.charCodeAt(D);if(A===v){if(!w){c=D+1;break}}else C===-1&&(w=!1,C=D+1),_>=0&&(A===h.charCodeAt(_)?--_===-1&&(g=D):(_=-1,g=C))}return c===g?g=C:g===-1&&(g=n.length),n.slice(c,g)}for(D=n.length-1;D>=0;--D)if(n.charCodeAt(D)===v){if(!w){c=D+1;break}}else g===-1&&(w=!1,g=D+1);return g===-1?"":n.slice(c,g)},extname(n){b(n,"path");let h=-1,c=0,g=-1,w=!0,D=0;for(let _=n.length-1;_>=0;--_){const C=n.charCodeAt(_);if(C===v){if(!w){c=_+1;break}continue}g===-1&&(w=!1,g=_+1),C===R?h===-1?h=_:D!==1&&(D=1):h!==-1&&(D=-1)}return h===-1||g===-1||D===0||D===1&&h===g-1&&h===c+1?"":n.slice(h,g)},format:t.bind(null,"/"),parse(n){b(n,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return h;const c=n.charCodeAt(0)===v;let g;c?(h.root="/",g=1):g=0;let w=-1,D=0,_=-1,C=!0,A=n.length-1,E=0;for(;A>=g;--A){const S=n.charCodeAt(A);if(S===v){if(!C){D=A+1;break}continue}_===-1&&(C=!1,_=A+1),S===R?w===-1?w=A:E!==1&&(E=1):w!==-1&&(E=-1)}if(_!==-1){const S=D===0&&c?1:D;w===-1||E===0||E===1&&w===_-1&&w===D+1?h.base=h.name=n.slice(S,_):(h.name=n.slice(S,w),h.base=n.slice(S,_),h.ext=n.slice(w,_))}return D>0?h.dir=n.slice(0,D-1):c&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=a?e.win32.normalize:e.posix.normalize,e.isAbsolute=a?e.win32.isAbsolute:e.posix.isAbsolute,e.join=a?e.win32.join:e.posix.join,e.resolve=a?e.win32.resolve:e.posix.resolve,e.relative=a?e.win32.relative:e.posix.relative,e.dirname=a?e.win32.dirname:e.posix.dirname,e.basename=a?e.win32.basename:e.posix.basename,e.extname=a?e.win32.extname:e.posix.extname,e.format=a?e.win32.format:e.posix.format,e.parse=a?e.win32.parse:e.posix.parse,e.toNamespacedPath=a?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=a?e.win32.sep:e.posix.sep,e.delimiter=a?e.win32.delimiter:e.posix.delimiter}),define(Ce[134],Ie([1,0,50,16]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=R,e.compareFileNamesDefault=v,e.compareFileNamesUpper=l,e.compareFileNamesLower=I,e.compareFileNamesUnicode=y,e.compareFileExtensions=u,e.compareFileExtensionsDefault=T,e.compareFileExtensionsUpper=b,e.compareFileExtensionsLower=a,e.compareFileExtensionsUnicode=m,e.comparePaths=g,e.compareAnything=w,e.compareByPrefix=D;const P=new r.Lazy(()=>{const _=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:_,collatorIsNumeric:_.resolvedOptions().numeric}}),k=new r.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new r.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(_,C,A=!1){const E=_||"",S=C||"",F=P.value.collator.compare(E,S);return P.value.collatorIsNumeric&&F===0&&E!==S?E<S?-1:1:F}function v(_,C){const A=k.value.collator;return _=_||"",C=C||"",s(A,_,C)}function l(_,C){const A=k.value.collator;return _=_||"",C=C||"",h(_,C)||s(A,_,C)}function I(_,C){const A=k.value.collator;return _=_||"",C=C||"",n(_,C)||s(A,_,C)}function y(_,C){return _=_||"",C=C||"",_===C?0:_<C?-1:1}function u(_,C){const[A,E]=f(_),[S,F]=f(C);let N=P.value.collator.compare(E,F);if(N===0){if(P.value.collatorIsNumeric&&E!==F)return E<F?-1:1;if(N=P.value.collator.compare(A,S),P.value.collatorIsNumeric&&N===0&&A!==S)return A<S?-1:1}return N}function T(_,C){_=_||"",C=C||"";const A=i(_),E=i(C),S=k.value.collator,F=L.value.collator;return s(F,A,E)||s(S,_,C)}function b(_,C){_=_||"",C=C||"";const A=i(_),E=i(C),S=k.value.collator,F=L.value.collator;return s(F,A,E)||h(_,C)||s(S,_,C)}function a(_,C){_=_||"",C=C||"";const A=i(_),E=i(C),S=k.value.collator,F=L.value.collator;return s(F,A,E)||n(_,C)||s(S,_,C)}function m(_,C){_=_||"",C=C||"";const A=i(_).toLowerCase(),E=i(C).toLowerCase();return A!==E?A<E?-1:1:_!==C?_<C?-1:1:0}const p=/^(.*?)(\.([^.]*))?$/;function f(_,C=!1){const A=_?p.exec(_):[];let E=[A&&A[1]||"",A&&A[3]||""];return C&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function i(_){const C=_?p.exec(_):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function s(_,C,A){const E=_.compare(C,A);return E!==0?E:C.length!==A.length?C.length<A.length?-1:1:0}function t(_){const C=_.charAt(0);return C.toLocaleUpperCase()!==C}function o(_){const C=_.charAt(0);return C.toLocaleLowerCase()!==C}function n(_,C){return t(_)&&o(C)?-1:o(_)&&t(C)?1:0}function h(_,C){return o(_)&&t(C)?-1:t(_)&&o(C)?1:0}function c(_,C,A=!1){return A||(_=_&&_.toLowerCase(),C=C&&C.toLowerCase()),_===C?0:_<C?-1:1}function g(_,C,A=!1){const E=_.split(d.sep),S=C.split(d.sep),F=E.length-1,N=S.length-1;let O,M;for(let U=0;;U++){if(O=F===U,M=N===U,O&&M)return R(E[U],S[U],A);if(O)return-1;if(M)return 1;const x=c(E[U],S[U],A);if(x!==0)return x}}function w(_,C,A){const E=_.toLowerCase(),S=C.toLowerCase(),F=D(_,C,A);if(F)return F;const N=E.endsWith(A),O=S.endsWith(A);if(N!==O)return N?-1:1;const M=R(E,S);return M!==0?M:E.localeCompare(S)}function D(_,C,A){const E=_.toLowerCase(),S=C.toLowerCase(),F=E.startsWith(A),N=S.startsWith(A);if(F!==N)return F?-1:1;if(F&&N){if(E.length<S.length)return-1;if(E.length>S.length)return 1}return 0}}),define(Ce[103],Ie([1,0,16]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=k,e.getMediaMime=L,e.getExtensionForMimeType=R,e.normalizeMimeType=l,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const d={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(I){const y=(0,r.extname)(I),u=d[y.toLowerCase()];return u!==void 0?u:L(I)}function L(I){const y=(0,r.extname)(I);return P[y.toLowerCase()]}function R(I){for(const y in P)if(P[y]===I)return y}const v=/^(.+)\/(.+?)(;.+)?$/;function l(I,y){const u=v.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:I}}),define(Ce[104],Ie([1,0,10]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=k,e.removeDangerousEnvVariables=L;var d;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(d||(e.Source=d={}));var P;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function k(R,...v){const l=v.reduce((u,T)=>(u[T]=!0,u),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(u=>!l[u]).forEach(u=>{for(let T=0;T<I.length;T++)if(u.search(I[T])!==-1){delete R[u];break}})}function L(R){R&&(delete R.DEBUG,r.isLinux&&delete R.LD_PRELOAD)}}),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var d in r)(typeof exports=="object"?exports:pe)[d]=r[d]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function r(d){if(e[d])return e[d].exports;var P=e[d]={i:d,l:!1,exports:{}};return pe[d].call(P.exports,P,P.exports,r),P.l=!0,P.exports}return r.m=pe,r.c=e,r.d=function(d,P,k){r.o(d,P)||Object.defineProperty(d,P,{enumerable:!0,get:k})},r.r=function(d){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(d,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(d,"__esModule",{value:!0})},r.t=function(d,P){if(1&P&&(d=r(d)),8&P||4&P&&typeof d=="object"&&d&&d.__esModule)return d;var k=Object.create(null);if(r.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:d}),2&P&&typeof d!="string")for(var L in d)r.d(k,L,function(R){return d[R]}.bind(null,L));return k},r.n=function(d){var P=d&&d.__esModule?function(){return d.default}:function(){return d};return r.d(P,"a",P),P},r.o=function(d,P){return Object.prototype.hasOwnProperty.call(d,P)},r.p="",r(r.s=0)}([function(pe,e,r){(function(d){var P;e=pe.exports=_e,P=typeof d=="object"&&d.env&&d.env.NODE_DEBUG&&/\bsemver\b/i.test(d.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],v=e.src=[],l=0,I=l++;v[I]="0|[1-9]\\d*";var y=l++;v[y]="[0-9]+";var u=l++;v[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=l++;v[T]="("+v[I]+")\\.("+v[I]+")\\.("+v[I]+")";var b=l++;v[b]="("+v[y]+")\\.("+v[y]+")\\.("+v[y]+")";var a=l++;v[a]="(?:"+v[I]+"|"+v[u]+")";var m=l++;v[m]="(?:"+v[y]+"|"+v[u]+")";var p=l++;v[p]="(?:-("+v[a]+"(?:\\."+v[a]+")*))";var f=l++;v[f]="(?:-?("+v[m]+"(?:\\."+v[m]+")*))";var i=l++;v[i]="[0-9A-Za-z-]+";var s=l++;v[s]="(?:\\+("+v[i]+"(?:\\."+v[i]+")*))";var t=l++,o="v?"+v[T]+v[p]+"?"+v[s]+"?";v[t]="^"+o+"$";var n="[v=\\s]*"+v[b]+v[f]+"?"+v[s]+"?",h=l++;v[h]="^"+n+"$";var c=l++;v[c]="((?:<|>)?=?)";var g=l++;v[g]=v[y]+"|x|X|\\*";var w=l++;v[w]=v[I]+"|x|X|\\*";var D=l++;v[D]="[v=\\s]*("+v[w]+")(?:\\.("+v[w]+")(?:\\.("+v[w]+")(?:"+v[p]+")?"+v[s]+"?)?)?";var _=l++;v[_]="[v=\\s]*("+v[g]+")(?:\\.("+v[g]+")(?:\\.("+v[g]+")(?:"+v[f]+")?"+v[s]+"?)?)?";var C=l++;v[C]="^"+v[c]+"\\s*"+v[D]+"$";var A=l++;v[A]="^"+v[c]+"\\s*"+v[_]+"$";var E=l++;v[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var S=l++;v[S]="(?:~>?)";var F=l++;v[F]="(\\s*)"+v[S]+"\\s+",R[F]=new RegExp(v[F],"g");var N=l++;v[N]="^"+v[S]+v[D]+"$";var O=l++;v[O]="^"+v[S]+v[_]+"$";var M=l++;v[M]="(?:\\^)";var U=l++;v[U]="(\\s*)"+v[M]+"\\s+",R[U]=new RegExp(v[U],"g");var x=l++;v[x]="^"+v[M]+v[D]+"$";var z=l++;v[z]="^"+v[M]+v[_]+"$";var B=l++;v[B]="^"+v[c]+"\\s*("+n+")$|^$";var ee=l++;v[ee]="^"+v[c]+"\\s*("+o+")$|^$";var V=l++;v[V]="(\\s*)"+v[c]+"\\s*("+n+"|"+v[D]+")",R[V]=new RegExp(v[V],"g");var $=l++;v[$]="^\\s*("+v[D]+")\\s+-\\s+("+v[D]+")\\s*$";var G=l++;v[G]="^\\s*("+v[_]+")\\s+-\\s+("+v[_]+")\\s*$";var Z=l++;v[Z]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)P(le,v[le]),R[le]||(R[le]=new RegExp(v[le]));function ne(q,X){if(q instanceof _e)return q;if(typeof q!="string"||q.length>k||!(X?R[h]:R[t]).test(q))return null;try{return new _e(q,X)}catch{return null}}function _e(q,X){if(q instanceof _e){if(q.loose===X)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof _e))return new _e(q,X);P("SemVer",q,X),this.loose=X;var J=q.trim().match(X?R[h]:R[t]);if(!J)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var we=+he;if(we>=0&&we<L)return we}return he}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=ne,e.valid=function(q,X){var J=ne(q,X);return J?J.version:null},e.clean=function(q,X){var J=ne(q.trim().replace(/^[=v]+/,""),X);return J?J.version:null},e.SemVer=_e,_e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_e.prototype.toString=function(){return this.version},_e.prototype.compare=function(q){return P("SemVer.compare",this.version,this.loose,q),q instanceof _e||(q=new _e(q,this.loose)),this.compareMain(q)||this.comparePre(q)},_e.prototype.compareMain=function(q){return q instanceof _e||(q=new _e(q,this.loose)),Y(this.major,q.major)||Y(this.minor,q.minor)||Y(this.patch,q.patch)},_e.prototype.comparePre=function(q){if(q instanceof _e||(q=new _e(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var X=0;do{var J=this.prerelease[X],he=q.prerelease[X];if(P("prerelease compare",X,J,he),J===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(J===void 0)return-1;if(J!==he)return Y(J,he)}while(++X)},_e.prototype.inc=function(q,X){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,X,J,he){typeof J=="string"&&(he=J,J=void 0);try{return new _e(q,J).inc(X,he).version}catch{return null}},e.diff=function(q,X){if(te(q,X))return null;var J=ne(q),he=ne(X);if(J.prerelease.length||he.prerelease.length){for(var we in J)if((we==="major"||we==="minor"||we==="patch")&&J[we]!==he[we])return"pre"+we;return"prerelease"}for(var we in J)if((we==="major"||we==="minor"||we==="patch")&&J[we]!==he[we])return we},e.compareIdentifiers=Y;var ge=/^[0-9]+$/;function Y(q,X){var J=ge.test(q),he=ge.test(X);return J&&he&&(q=+q,X=+X),J&&!he?-1:he&&!J?1:q<X?-1:q>X?1:0}function W(q,X,J){return new _e(q,J).compare(new _e(X,J))}function oe(q,X,J){return W(q,X,J)>0}function Se(q,X,J){return W(q,X,J)<0}function te(q,X,J){return W(q,X,J)===0}function ae(q,X,J){return W(q,X,J)!==0}function se(q,X,J){return W(q,X,J)>=0}function Q(q,X,J){return W(q,X,J)<=0}function re(q,X,J,he){var we;switch(X){case"===":typeof q=="object"&&(q=q.version),typeof J=="object"&&(J=J.version),we=q===J;break;case"!==":typeof q=="object"&&(q=q.version),typeof J=="object"&&(J=J.version),we=q!==J;break;case"":case"=":case"==":we=te(q,J,he);break;case"!=":we=ae(q,J,he);break;case">":we=oe(q,J,he);break;case">=":we=se(q,J,he);break;case"<":we=Se(q,J,he);break;case"<=":we=Q(q,J,he);break;default:throw new TypeError("Invalid operator: "+X)}return we}function ve(q,X){if(q instanceof ve){if(q.loose===X)return q;q=q.value}if(!(this instanceof ve))return new ve(q,X);P("comparator",q,X),this.loose=X,this.parse(q),this.semver===be?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(q,X){return Y(X,q)},e.major=function(q,X){return new _e(q,X).major},e.minor=function(q,X){return new _e(q,X).minor},e.patch=function(q,X){return new _e(q,X).patch},e.compare=W,e.compareLoose=function(q,X){return W(q,X,!0)},e.rcompare=function(q,X,J){return W(X,q,J)},e.sort=function(q,X){return q.sort(function(J,he){return e.compare(J,he,X)})},e.rsort=function(q,X){return q.sort(function(J,he){return e.rcompare(J,he,X)})},e.gt=oe,e.lt=Se,e.eq=te,e.neq=ae,e.gte=se,e.lte=Q,e.cmp=re,e.Comparator=ve;var be={};function Fe(q,X){if(q instanceof Fe)return q.loose===X?q:new Fe(q.raw,X);if(q instanceof ve)return new Fe(q.value,X);if(!(this instanceof Fe))return new Fe(q,X);if(this.loose=X,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Be(q){return!q||q.toLowerCase()==="x"||q==="*"}function ke(q,X,J,he,we,Oe,Ve,Ke,et,nt,st,rt,at){return((X=Be(J)?"":Be(he)?">="+J+".0.0":Be(we)?">="+J+"."+he+".0":">="+X)+" "+(Ke=Be(et)?"":Be(nt)?"<"+(+et+1)+".0.0":Be(st)?"<"+et+"."+(+nt+1)+".0":rt?"<="+et+"."+nt+"."+st+"-"+rt:"<="+Ke)).trim()}function De(q,X){for(var J=0;J<q.length;J++)if(!q[J].test(X))return!1;if(X.prerelease.length){for(J=0;J<q.length;J++)if(P(q[J].semver),q[J].semver!==be&&q[J].semver.prerelease.length>0){var he=q[J].semver;if(he.major===X.major&&he.minor===X.minor&&he.patch===X.patch)return!0}return!1}return!0}function Pe(q,X,J){try{X=new Fe(X,J)}catch{return!1}return X.test(q)}function H(q,X,J,he){var we,Oe,Ve,Ke,et;switch(q=new _e(q,he),X=new Fe(X,he),J){case">":we=oe,Oe=Q,Ve=Se,Ke=">",et=">=";break;case"<":we=Se,Oe=se,Ve=oe,Ke="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(q,X,he))return!1;for(var nt=0;nt<X.set.length;++nt){var st=X.set[nt],rt=null,at=null;if(st.forEach(function(gt){gt.semver===be&&(gt=new ve(">=0.0.0")),rt=rt||gt,at=at||gt,we(gt.semver,rt.semver,he)?rt=gt:Ve(gt.semver,at.semver,he)&&(at=gt)}),rt.operator===Ke||rt.operator===et||(!at.operator||at.operator===Ke)&&Oe(q,at.semver)||at.operator===et&&Ve(q,at.semver))return!1}return!0}ve.prototype.parse=function(q){var X=this.loose?R[B]:R[ee],J=q.match(X);if(!J)throw new TypeError("Invalid comparator: "+q);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new _e(J[2],this.loose):this.semver=be},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(q){return P("Comparator.test",q,this.loose),this.semver===be||(typeof q=="string"&&(q=new _e(q,this.loose)),re(q,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(q,X){if(!(q instanceof ve))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Fe(q.value,X),Pe(this.value,J,X);if(q.operator==="")return J=new Fe(this.value,X),Pe(q.semver,J,X);var he=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Oe=this.semver.version===q.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Ke=re(this.semver,"<",q.semver,X)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),et=re(this.semver,">",q.semver,X)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return he||we||Oe&&Ve||Ke||et},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(q){var X=this.loose;q=q.trim(),P("range",q,X);var J=X?R[G]:R[$];q=q.replace(J,ke),P("hyphen replace",q),q=q.replace(R[V],"$1$2$3"),P("comparator trim",q,R[V]),q=(q=(q=q.replace(R[F],"$1~")).replace(R[U],"$1^")).split(/\s+/).join(" ");var he=X?R[B]:R[ee],we=q.split(" ").map(function(Oe){return function(Ve,Ke){return P("comp",Ve),Ve=function(et,nt){return et.trim().split(/\s+/).map(function(st){return function(rt,at){P("caret",rt,at);var gt=at?R[z]:R[x];return rt.replace(gt,function(ht,lt,Te,Ue,je){var Ne;return P("caret",rt,ht,lt,Te,Ue,je),Be(lt)?Ne="":Be(Te)?Ne=">="+lt+".0.0 <"+(+lt+1)+".0.0":Be(Ue)?Ne=lt==="0"?">="+lt+"."+Te+".0 <"+lt+"."+(+Te+1)+".0":">="+lt+"."+Te+".0 <"+(+lt+1)+".0.0":je?(P("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Ne=lt==="0"?Te==="0"?">="+lt+"."+Te+"."+Ue+je+" <"+lt+"."+Te+"."+(+Ue+1):">="+lt+"."+Te+"."+Ue+je+" <"+lt+"."+(+Te+1)+".0":">="+lt+"."+Te+"."+Ue+je+" <"+(+lt+1)+".0.0"):(P("no pr"),Ne=lt==="0"?Te==="0"?">="+lt+"."+Te+"."+Ue+" <"+lt+"."+Te+"."+(+Ue+1):">="+lt+"."+Te+"."+Ue+" <"+lt+"."+(+Te+1)+".0":">="+lt+"."+Te+"."+Ue+" <"+(+lt+1)+".0.0"),P("caret return",Ne),Ne})}(st,nt)}).join(" ")}(Ve,Ke),P("caret",Ve),Ve=function(et,nt){return et.trim().split(/\s+/).map(function(st){return function(rt,at){var gt=at?R[O]:R[N];return rt.replace(gt,function(ht,lt,Te,Ue,je){var Ne;return P("tilde",rt,ht,lt,Te,Ue,je),Be(lt)?Ne="":Be(Te)?Ne=">="+lt+".0.0 <"+(+lt+1)+".0.0":Be(Ue)?Ne=">="+lt+"."+Te+".0 <"+lt+"."+(+Te+1)+".0":je?(P("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Ne=">="+lt+"."+Te+"."+Ue+je+" <"+lt+"."+(+Te+1)+".0"):Ne=">="+lt+"."+Te+"."+Ue+" <"+lt+"."+(+Te+1)+".0",P("tilde return",Ne),Ne})}(st,nt)}).join(" ")}(Ve,Ke),P("tildes",Ve),Ve=function(et,nt){return P("replaceXRanges",et,nt),et.split(/\s+/).map(function(st){return function(rt,at){rt=rt.trim();var gt=at?R[A]:R[C];return rt.replace(gt,function(ht,lt,Te,Ue,je,Ne){P("xRange",rt,ht,lt,Te,Ue,je,Ne);var xe=Be(Te),ue=xe||Be(Ue),de=ue||Be(je);return lt==="="&&de&&(lt=""),xe?ht=lt===">"||lt==="<"?"<0.0.0":"*":lt&&de?(ue&&(Ue=0),de&&(je=0),lt===">"?(lt=">=",ue?(Te=+Te+1,Ue=0,je=0):de&&(Ue=+Ue+1,je=0)):lt==="<="&&(lt="<",ue?Te=+Te+1:Ue=+Ue+1),ht=lt+Te+"."+Ue+"."+je):ue?ht=">="+Te+".0.0 <"+(+Te+1)+".0.0":de&&(ht=">="+Te+"."+Ue+".0 <"+Te+"."+(+Ue+1)+".0"),P("xRange return",ht),ht})}(st,nt)}).join(" ")}(Ve,Ke),P("xrange",Ve),Ve=function(et,nt){return P("replaceStars",et,nt),et.trim().replace(R[Z],"")}(Ve,Ke),P("stars",Ve),Ve}(Oe,X)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Oe){return!!Oe.match(he)})),we=we.map(function(Oe){return new ve(Oe,X)})},Fe.prototype.intersects=function(q,X){if(!(q instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(he){return q.set.some(function(we){return we.every(function(Oe){return he.intersects(Oe,X)})})})})},e.toComparators=function(q,X){return new Fe(q,X).set.map(function(J){return J.map(function(he){return he.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new _e(q,this.loose));for(var X=0;X<this.set.length;X++)if(De(this.set[X],q))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(q,X,J){var he=null,we=null;try{var Oe=new Fe(X,J)}catch{return null}return q.forEach(function(Ve){Oe.test(Ve)&&(he&&we.compare(Ve)!==-1||(we=new _e(he=Ve,J)))}),he},e.minSatisfying=function(q,X,J){var he=null,we=null;try{var Oe=new Fe(X,J)}catch{return null}return q.forEach(function(Ve){Oe.test(Ve)&&(he&&we.compare(Ve)!==1||(we=new _e(he=Ve,J)))}),he},e.validRange=function(q,X){try{return new Fe(q,X).range||"*"}catch{return null}},e.ltr=function(q,X,J){return H(q,X,"<",J)},e.gtr=function(q,X,J){return H(q,X,">",J)},e.outside=H,e.prerelease=function(q,X){var J=ne(q,X);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(q,X,J){return q=new Fe(q,J),X=new Fe(X,J),q.intersects(X)},e.coerce=function(q){if(q instanceof _e)return q;if(typeof q!="string")return null;var X=q.match(R[E]);return X==null?null:ne((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,r(1))},function(pe,e){var r,d,P=pe.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(m){if(r===setTimeout)return setTimeout(m,0);if((r===k||!r)&&setTimeout)return r=setTimeout,setTimeout(m,0);try{return r(m,0)}catch{try{return r.call(null,m,0)}catch{return r.call(this,m,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:k}catch{r=k}try{d=typeof clearTimeout=="function"?clearTimeout:L}catch{d=L}})();var v,l=[],I=!1,y=-1;function u(){I&&v&&(I=!1,v.length?l=v.concat(l):y=-1,l.length&&T())}function T(){if(!I){var m=R(u);I=!0;for(var p=l.length;p;){for(v=l,l=[];++y<p;)v&&v[y].run();y=-1,p=l.length}v=null,I=!1,function(f){if(d===clearTimeout)return clearTimeout(f);if((d===L||!d)&&clearTimeout)return d=clearTimeout,clearTimeout(f);try{d(f)}catch{try{return d.call(null,f)}catch{return d.call(this,f)}}}(m)}}function b(m,p){this.fun=m,this.array=p}function a(){}P.nextTick=function(m){var p=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)p[f-1]=arguments[f];l.push(new b(m,p)),l.length!==1||I||R(T)},b.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=a,P.addListener=a,P.once=a,P.off=a,P.removeListener=a,P.removeAllListeners=a,P.emit=a,P.prependListener=a,P.prependOnceListener=a,P.listeners=function(m){return[]},P.binding=function(m){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(m){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ce[42],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class d{static create(k){return new d(k)}constructor(k){this._now=r&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=d}),define(Ce[4],Ie([1,0,13,79,3,80,42]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=T;const R=!1,v=!1,l=!1;var I;(function(O){O.None=()=>P.Disposable.None;function M(De){if(l){const{onDidAddListener:Pe}=De,H=a.create();let q=0;De.onDidAddListener=()=>{++q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),H.print()),Pe?.()}}}function U(De,Pe){return ne(De,()=>{},0,void 0,!0,void 0,Pe)}O.defer=U;function x(De){return(Pe,H=null,q)=>{let X=!1,J;return J=De(he=>{if(!X)return J?J.dispose():X=!0,Pe.call(H,he)},null,q),X&&J.dispose(),J}}O.once=x;function z(De,Pe,H){return Z((q,X=null,J)=>De(he=>q.call(X,Pe(he)),null,J),H)}O.map=z;function B(De,Pe,H){return Z((q,X=null,J)=>De(he=>{Pe(he),q.call(X,he)},null,J),H)}O.forEach=B;function ee(De,Pe,H){return Z((q,X=null,J)=>De(he=>Pe(he)&&q.call(X,he),null,J),H)}O.filter=ee;function V(De){return De}O.signal=V;function $(...De){return(Pe,H=null,q)=>{const X=(0,P.combinedDisposable)(...De.map(J=>J(he=>Pe.call(H,he))));return le(X,q)}}O.any=$;function G(De,Pe,H,q){let X=H;return z(De,J=>(X=Pe(X,J),X),q)}O.reduce=G;function Z(De,Pe){let H;const q={onWillAddFirstListener(){H=De(X.fire,X)},onDidRemoveLastListener(){H?.dispose()}};Pe||M(q);const X=new n(q);return Pe?.add(X),X.event}function le(De,Pe){return Pe instanceof Array?Pe.push(De):Pe&&Pe.add(De),De}function ne(De,Pe,H=100,q=!1,X=!1,J,he){let we,Oe,Ve,Ke=0,et;const nt={leakWarningThreshold:J,onWillAddFirstListener(){we=De(rt=>{Ke++,Oe=Pe(Oe,rt),q&&!Ve&&(st.fire(Oe),Oe=void 0),et=()=>{const at=Oe;Oe=void 0,Ve=void 0,(!q||Ke>1)&&st.fire(at),Ke=0},typeof H=="number"?(clearTimeout(Ve),Ve=setTimeout(et,H)):Ve===void 0&&(Ve=0,queueMicrotask(et))})},onWillRemoveListener(){X&&Ke>0&&et?.()},onDidRemoveLastListener(){et=void 0,we.dispose()}};he||M(nt);const st=new n(nt);return he?.add(st),st.event}O.debounce=ne;function _e(De,Pe=0,H){return O.debounce(De,(q,X)=>q?(q.push(X),q):[X],Pe,void 0,!0,void 0,H)}O.accumulate=_e;function ge(De,Pe=(q,X)=>q===X,H){let q=!0,X;return ee(De,J=>{const he=q||!Pe(J,X);return q=!1,X=J,he},H)}O.latch=ge;function Y(De,Pe,H){return[O.filter(De,Pe,H),O.filter(De,q=>!Pe(q),H)]}O.split=Y;function W(De,Pe=!1,H=[],q){let X=H.slice(),J=De(Oe=>{X?X.push(Oe):we.fire(Oe)});q&&q.add(J);const he=()=>{X?.forEach(Oe=>we.fire(Oe)),X=null},we=new n({onWillAddFirstListener(){J||(J=De(Oe=>we.fire(Oe)),q&&q.add(J))},onDidAddFirstListener(){X&&(Pe?setTimeout(he):he())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return q&&q.add(we),we.event}O.buffer=W;function oe(De,Pe){return(q,X,J)=>{const he=Pe(new te);return De(function(we){const Oe=he.evaluate(we);Oe!==Se&&q.call(X,Oe)},void 0,J)}}O.chain=oe;const Se=Symbol("HaltChainable");class te{constructor(){this.steps=[]}map(Pe){return this.steps.push(Pe),this}forEach(Pe){return this.steps.push(H=>(Pe(H),H)),this}filter(Pe){return this.steps.push(H=>Pe(H)?H:Se),this}reduce(Pe,H){let q=H;return this.steps.push(X=>(q=Pe(q,X),q)),this}latch(Pe=(H,q)=>H===q){let H=!0,q;return this.steps.push(X=>{const J=H||!Pe(X,q);return H=!1,q=X,J?X:Se}),this}evaluate(Pe){for(const H of this.steps)if(Pe=H(Pe),Pe===Se)break;return Pe}}function ae(De,Pe,H=q=>q){const q=(...we)=>he.fire(H(...we)),X=()=>De.on(Pe,q),J=()=>De.removeListener(Pe,q),he=new n({onWillAddFirstListener:X,onDidRemoveLastListener:J});return he.event}O.fromNodeEventEmitter=ae;function se(De,Pe,H=q=>q){const q=(...we)=>he.fire(H(...we)),X=()=>De.addEventListener(Pe,q),J=()=>De.removeEventListener(Pe,q),he=new n({onWillAddFirstListener:X,onDidRemoveLastListener:J});return he.event}O.fromDOMEventEmitter=se;function Q(De){return new Promise(Pe=>x(De)(Pe))}O.toPromise=Q;function re(De){const Pe=new n;return De.then(H=>{Pe.fire(H)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}O.fromPromise=re;function ve(De,Pe){return De(H=>Pe.fire(H))}O.forward=ve;function be(De,Pe,H){return Pe(H),De(q=>Pe(q))}O.runAndSubscribe=be;class Fe{constructor(Pe,H){this._observable=Pe,this._counter=0,this._hasChanged=!1;const q={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};H||M(q),this.emitter=new n(q),H&&H.add(this.emitter)}beginUpdate(Pe){this._counter++}handlePossibleChange(Pe){}handleChange(Pe,H){this._hasChanged=!0}endUpdate(Pe){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Be(De,Pe){return new Fe(De,Pe).emitter.event}O.fromObservable=Be;function ke(De){return(Pe,H,q)=>{let X=0,J=!1;const he={beginUpdate(){X++},endUpdate(){X--,X===0&&(De.reportChanges(),J&&(J=!1,Pe.call(H)))},handlePossibleChange(){},handleChange(){J=!0}};De.addObserver(he),De.reportChanges();const we={dispose(){De.removeObserver(he)}};return q instanceof P.DisposableStore?q.add(we):Array.isArray(q)&&q.push(we),we}}O.fromObservableLight=ke})(I||(e.Event=I={}));class y{static{this.all=new Set}static{this._idPool=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${y._idPool++}`,y.all.add(this)}start(M){this._stopWatch=new L.StopWatch,this.listenerCount=M}stop(){if(this._stopWatch){const M=this._stopWatch.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=y;let u=-1;function T(O){const M=u;return u=O,{dispose(){u=M}}}class b{static{this._idPool=1}constructor(M,U,x=(b._idPool++).toString(16).padStart(3,"0")){this._errorHandler=M,this.threshold=U,this.name=x,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(M,U){const x=this.threshold;if(x<=0||U<x)return;this._stacks||(this._stacks=new Map);const z=this._stacks.get(M.value)||0;if(this._stacks.set(M.value,z+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=x*.5;const[B,ee]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${U} listeners already. MOST frequent listener (${ee}):`;console.warn(V),console.warn(B);const $=new m(V,B);this._errorHandler($)}return()=>{const B=this._stacks.get(M.value)||0;this._stacks.set(M.value,B-1)}}getMostFrequentStack(){if(!this._stacks)return;let M,U=0;for(const[x,z]of this._stacks)(!M||U<z)&&(M=[x,z],U=z);return M}}class a{static create(){const M=new Error;return new a(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(M,U){super(M),this.name="ListenerLeakError",this.stack=U}}e.ListenerLeakError=m;class p extends Error{constructor(M,U){super(M),this.name="ListenerRefusalError",this.stack=U}}e.ListenerRefusalError=p;let f=0;class i{constructor(M){this.value=M,this.id=f++}}const s=2,t=(O,M)=>{if(O instanceof i)M(O);else for(let U=0;U<O.length;U++){const x=O[U];x&&M(x)}};let o;if(R){const O=[];setInterval(()=>{O.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(O.join(`
`)),O.length=0)},3e3),o=new FinalizationRegistry(M=>{typeof M=="string"&&O.push(M)})}class n{constructor(M){this._size=0,this._options=M,this._leakageMon=u>0||this._options?.leakWarningThreshold?new b(M?.onListenerError??r.onUnexpectedError,this._options?.leakWarningThreshold??u):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(v){const M=this._listeners;queueMicrotask(()=>{t(M,U=>U.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(M,U,x)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const $=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn($);const G=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],Z=new p(`${$}. HINT: Stack shows most frequent listener (${G[1]}-times)`,G[0]);return(this._options?.onListenerError||r.onUnexpectedError)(Z),P.Disposable.None}if(this._disposed)return P.Disposable.None;U&&(M=M.bind(U));const z=new i(M);let B,ee;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(z.stack=a.create(),B=this._leakageMon.check(z.stack,this._size+1)),v&&(z.stack=ee??a.create()),this._listeners?this._listeners instanceof i?(this._deliveryQueue??=new c,this._listeners=[this._listeners,z]):this._listeners.push(z):(this._options?.onWillAddFirstListener?.(this),this._listeners=z,this._options?.onDidAddFirstListener?.(this)),this._size++;const V=(0,P.toDisposable)(()=>{o?.unregister(V),B?.(),this._removeListener(z)});if(x instanceof P.DisposableStore?x.add(V):Array.isArray(x)&&x.push(V),o){const $=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),G=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec($);o.register(V,G?.[2]??$,V)}return V},this._event}_removeListener(M){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const U=this._listeners,x=U.indexOf(M);if(x===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,U[x]=void 0;const z=this._deliveryQueue.current===this;if(this._size*s<=U.length){let B=0;for(let ee=0;ee<U.length;ee++)U[ee]?U[B++]=U[ee]:z&&(this._deliveryQueue.end--,B<this._deliveryQueue.i&&this._deliveryQueue.i--);U.length=B}}_deliver(M,U){if(!M)return;const x=this._options?.onListenerError||r.onUnexpectedError;if(!x){M.value(U);return}try{M.value(U)}catch(z){x(z)}}_deliverQueue(M){const U=M.current._listeners;for(;M.i<M.end;)this._deliver(U[M.i++],M.value);M.reset()}fire(M){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof i)this._deliver(this._listeners,M);else{const U=this._deliveryQueue;U.enqueue(this,M,this._listeners.length),this._deliverQueue(U)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=n;const h=()=>new c;e.createEventDeliveryQueue=h;class c{constructor(){this.i=-1,this.end=0}enqueue(M,U,x){this.i=0,this.end=x,this.current=M,this.value=U}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class g extends n{async fireAsync(M,U,x){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList),t(this._listeners,z=>this._asyncDeliveryQueue.push([z.value,M]));this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[z,B]=this._asyncDeliveryQueue.shift(),ee=[],V={...B,token:U,waitUntil:$=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");x&&($=x($,z)),ee.push($)}};try{z(V)}catch($){(0,r.onUnexpectedError)($);continue}Object.freeze(ee),await Promise.allSettled(ee).then($=>{for(const G of $)G.status==="rejected"&&(0,r.onUnexpectedError)(G.reason)})}}}e.AsyncEmitter=g;class w extends n{get isPaused(){return this._isPaused!==0}constructor(M){super(M),this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=M?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const M=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(M))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(M){this._size&&(this._isPaused!==0?this._eventQueue.push(M):super.fire(M))}}e.PauseableEmitter=w;class D extends w{constructor(M){super(M),this._delay=M.delay??100}fire(M){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(M)}}e.DebounceEmitter=D;class _ extends n{constructor(M){super(M),this._queuedEvents=[],this._mergeFn=M?.merge}fire(M){this.hasListeners()&&(this._queuedEvents.push(M),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(U=>super.fire(U)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=_;class C{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(M){const U={event:M,listener:null};this.events.push(U),this.hasListeners&&this.hook(U);const x=()=>{this.hasListeners&&this.unhook(U);const z=this.events.indexOf(U);this.events.splice(z,1)};return(0,P.toDisposable)((0,d.createSingleCallFunction)(x))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(M=>this.hook(M))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(M=>this.unhook(M))}hook(M){M.listener=M.event(U=>this.emitter.fire(U))}unhook(M){M.listener?.dispose(),M.listener=null}dispose(){this.emitter.dispose();for(const M of this.events)M.listener?.dispose();this.events=[]}}e.EventMultiplexer=C;class A{constructor(M,U,x,z){this._store=new P.DisposableStore;const B=this._store.add(new C),ee=this._store.add(new P.DisposableMap);function V($){ee.set($,B.add(z($)))}for(const $ of M)V($);this._store.add(U($=>{V($)})),this._store.add(x($=>{ee.deleteAndDispose($)})),this.event=B.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=A;class E{constructor(){this.data=[]}wrapEvent(M,U,x){return(z,B,ee)=>M(V=>{const $=this.data[this.data.length-1];if(!U){$?$.buffers.push(()=>z.call(B,V)):z.call(B,V);return}const G=$;if(!G){z.call(B,U(x,V));return}G.items??=[],G.items.push(V),G.buffers.length===0&&$.buffers.push(()=>{G.reducedResult??=x?G.items.reduce(U,x):G.items.reduce(U),z.call(B,G.reducedResult)})},void 0,ee)}bufferEvents(M){const U={buffers:new Array};this.data.push(U);const x=M();return this.data.pop(),U.buffers.forEach(z=>z()),x}}e.EventBufferer=E;class S{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=P.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(M){this.inputEvent=M,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=M(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S;class F{static const(M){return new N(M)}constructor(M){this._value=M,this._onDidChange=new n,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(M){M!==this._value&&(this._value=M,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=F;class N{constructor(M){this.value=M,this.onDidChange=I.None}}}),define(Ce[20],Ie([1,0,4]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=R;const d=Object.freeze(function(v,l){const I=setTimeout(v.bind(l),0);return{dispose(){clearTimeout(I)}}});var P;(function(v){function l(I){return I===v.None||I===v.Cancelled||I instanceof k?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}v.isCancellationToken=l,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:d})})(P||(e.CancellationToken=P={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?d:(this._emitter||(this._emitter=new r.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=P.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=L;function R(v){const l=new L;return v.add({dispose(){l.cancel()}}),l.token}}),define(Ce[184],Ie([1,0,20]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=P;class d{constructor(v){this.task=v,this.result=null}get(){if(this.result)return this.result;const v=new r.CancellationTokenSource,l=this.task(v.token);return this.result={promise:l,dispose:()=>{this.result=null,v.cancel(),v.dispose()}},this.result}}e.Cache=d;function P(R){return R}class k{constructor(v,l){this.lastCache=void 0,this.lastArgKey=void 0,typeof v=="function"?(this._fn=v,this._computeKey=P):(this._fn=l,this._computeKey=v.getCacheKey)}get(v){const l=this._computeKey(v);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this._fn(v)),this.lastCache}}e.LRUCachedFunction=k;class L{get cachedValues(){return this._map}constructor(v,l){this._map=new Map,this._map2=new Map,typeof v=="function"?(this._fn=v,this._computeKey=P):(this._fn=l,this._computeKey=v.getCacheKey)}get(v){const l=this._computeKey(v);if(this._map2.has(l))return this._map2.get(l);const I=this._fn(v);return this._map.set(v,I),this._map2.set(l,I),I}}e.CachedFunction=L}),define(Ce[185],Ie([1,0,4,3]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SmoothScrollingOperation=e.SmoothScrollingUpdate=e.Scrollable=e.ScrollState=e.ScrollbarVisibility=void 0;var P;(function(T){T[T.Auto=1]="Auto",T[T.Hidden=2]="Hidden",T[T.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class k{constructor(b,a,m,p,f,i,s){this._forceIntegerValues=b,this._scrollStateBrand=void 0,this._forceIntegerValues&&(a=a|0,m=m|0,p=p|0,f=f|0,i=i|0,s=s|0),this.rawScrollLeft=p,this.rawScrollTop=s,a<0&&(a=0),p+a>m&&(p=m-a),p<0&&(p=0),f<0&&(f=0),s+f>i&&(s=i-f),s<0&&(s=0),this.width=a,this.scrollWidth=m,this.scrollLeft=p,this.height=f,this.scrollHeight=i,this.scrollTop=s}equals(b){return this.rawScrollLeft===b.rawScrollLeft&&this.rawScrollTop===b.rawScrollTop&&this.width===b.width&&this.scrollWidth===b.scrollWidth&&this.scrollLeft===b.scrollLeft&&this.height===b.height&&this.scrollHeight===b.scrollHeight&&this.scrollTop===b.scrollTop}withScrollDimensions(b,a){return new k(this._forceIntegerValues,typeof b.width<"u"?b.width:this.width,typeof b.scrollWidth<"u"?b.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof b.height<"u"?b.height:this.height,typeof b.scrollHeight<"u"?b.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(b){return new k(this._forceIntegerValues,this.width,this.scrollWidth,typeof b.scrollLeft<"u"?b.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof b.scrollTop<"u"?b.scrollTop:this.rawScrollTop)}createScrollEvent(b,a){const m=this.width!==b.width,p=this.scrollWidth!==b.scrollWidth,f=this.scrollLeft!==b.scrollLeft,i=this.height!==b.height,s=this.scrollHeight!==b.scrollHeight,t=this.scrollTop!==b.scrollTop;return{inSmoothScrolling:a,oldWidth:b.width,oldScrollWidth:b.scrollWidth,oldScrollLeft:b.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:b.height,oldScrollHeight:b.scrollHeight,oldScrollTop:b.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:p,scrollLeftChanged:f,heightChanged:i,scrollHeightChanged:s,scrollTopChanged:t}}}e.ScrollState=k;class L extends d.Disposable{constructor(b){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new r.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=b.smoothScrollDuration,this._scheduleAtNextAnimationFrame=b.scheduleAtNextAnimationFrame,this._state=new k(b.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(b){this._smoothScrollDuration=b}validateScrollPosition(b){return this._state.withScrollPosition(b)}getScrollDimensions(){return this._state}setScrollDimensions(b,a){const m=this._state.withScrollDimensions(b,a);this._setState(m,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(b){const a=this._state.withScrollPosition(b);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(a,!1)}setScrollPositionSmooth(b,a){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(b);if(this._smoothScrolling){b={scrollLeft:typeof b.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:b.scrollLeft,scrollTop:typeof b.scrollTop>"u"?this._smoothScrolling.to.scrollTop:b.scrollTop};const m=this._state.withScrollPosition(b);if(this._smoothScrolling.to.scrollLeft===m.scrollLeft&&this._smoothScrolling.to.scrollTop===m.scrollTop)return;let p;a?p=new I(this._smoothScrolling.from,m,this._smoothScrolling.startTime,this._smoothScrolling.duration):p=this._smoothScrolling.combine(this._state,m,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=p}else{const m=this._state.withScrollPosition(b);this._smoothScrolling=I.start(this._state,m,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const b=this._smoothScrolling.tick(),a=this._state.withScrollPosition(b);if(this._setState(a,!0),!!this._smoothScrolling){if(b.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(b,a){const m=this._state;m.equals(b)||(this._state=b,this._onScroll.fire(this._state.createScrollEvent(m,a)))}}e.Scrollable=L;class R{constructor(b,a,m){this.scrollLeft=b,this.scrollTop=a,this.isDone=m}}e.SmoothScrollingUpdate=R;function v(T,b){const a=b-T;return function(m){return T+a*u(m)}}function l(T,b,a){return function(m){return m<a?T(m/a):b((m-a)/(1-a))}}class I{constructor(b,a,m,p){this.from=b,this.to=a,this.duration=p,this.startTime=m,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(b,a,m){if(Math.abs(b-a)>2.5*m){let f,i;return b<a?(f=b+.75*m,i=a-.75*m):(f=b-.75*m,i=a+.75*m),l(v(b,f),v(i,a),.33)}return v(b,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(b){this.to=b.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(b){const a=(b-this.startTime)/this.duration;if(a<1){const m=this.scrollLeft(a),p=this.scrollTop(a);return new R(m,p,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(b,a,m){return I.start(b,a,m)}static start(b,a,m){m=m+10;const p=Date.now()-10;return new I(b,a,p,m)}}e.SmoothScrollingOperation=I;function y(T){return Math.pow(T,3)}function u(T){return 1-y(1-T)}}),define(Ce[105],Ie([1,0,13,3]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=P,e.isReadableStream=k,e.isReadableBufferedStream=L,e.newWriteableStream=R,e.consumeReadable=l,e.peekReadable=I,e.consumeStream=y,e.listenStream=u,e.peekStream=T,e.toStream=b,e.emptyStream=a,e.toReadable=m,e.transform=p,e.prefixedReadable=f,e.prefixedStream=i;function P(s){const t=s;return t?typeof t.read=="function":!1}function k(s){const t=s;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function L(s){const t=s;return t?k(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function R(s,t){return new v(s,t)}class v{constructor(t,o){this.reducer=t,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(o=>o(t))}emitError(t){this.listeners.error.length===0?(0,r.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(o=>o(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,o){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(t,o){if(this.state.destroyed)return;let n;switch(t){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const h=n.indexOf(o);h>=0&&n.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(s,t){const o=[];let n;for(;(n=s.read())!==null;)o.push(n);return t(o)}function I(s,t,o){const n=[];let h;for(;(h=s.read())!==null&&n.length<o;)n.push(h);return h===null&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(typeof h<"u"){const c=h;return h=void 0,c}return s.read()}}}function y(s,t){return new Promise((o,n)=>{const h=[];u(s,{onData:c=>{t&&h.push(c)},onError:c=>{t?n(c):o(void 0)},onEnd:()=>{o(t?t(h):void 0)}})})}function u(s,t,o){s.on("error",n=>{o?.isCancellationRequested||t.onError(n)}),s.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),s.on("data",n=>{o?.isCancellationRequested||t.onData(n)})}function T(s,t){return new Promise((o,n)=>{const h=new d.DisposableStore,c=[],g=_=>{if(c.push(_),c.length>t)return h.dispose(),s.pause(),o({stream:s,buffer:c,ended:!1})},w=_=>(h.dispose(),n(_)),D=()=>(h.dispose(),o({stream:s,buffer:c,ended:!0}));h.add((0,d.toDisposable)(()=>s.removeListener("error",w))),s.on("error",w),h.add((0,d.toDisposable)(()=>s.removeListener("end",D))),s.on("end",D),h.add((0,d.toDisposable)(()=>s.removeListener("data",g))),s.on("data",g)})}function b(s,t){const o=R(t);return o.end(s),o}function a(){const s=R(()=>{throw new Error("not supported")});return s.end(),s}function m(s){let t=!1;return{read:()=>t?null:(t=!0,s)}}function p(s,t,o){const n=R(o);return u(s,{onData:h=>n.write(t.data(h)),onError:h=>n.error(t.error?t.error(h):h),onEnd:()=>n.end()}),n}function f(s,t,o){let n=!1;return{read:()=>{const h=t.read();return n?h:(n=!0,h!==null?o([s,h]):s)}}}function i(s,t,o){let n=!1;const h=R(o);return u(t,{onData:c=>n?h.write(c):(n=!0,h.write(o([s,c]))),onError:c=>h.error(c),onEnd:()=>{n||(n=!0,h.write(s)),h.end()}}),h}}),define(Ce[21],Ie([1,0,50,105]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=l,e.readUInt16LE=I,e.writeUInt16LE=y,e.readUInt32BE=u,e.writeUInt32BE=T,e.readUInt32LE=b,e.writeUInt32LE=a,e.readUInt8=m,e.writeUInt8=p,e.readableToBuffer=f,e.bufferToReadable=i,e.streamToBuffer=s,e.bufferedStreamToBuffer=t,e.bufferToStream=o,e.streamToBufferReadableStream=n,e.newWriteableBufferStream=h,e.prefixedBufferReadable=c,e.prefixedBufferStream=g,e.decodeBase64=w,e.encodeBase64=C,d=$e(d);const P=typeof Buffer<"u",k=new r.Lazy(()=>new Uint8Array(256));let L,R;class v{static alloc(E){return P?new v(Buffer.allocUnsafe(E)):new v(new Uint8Array(E))}static wrap(E){return P&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new v(E)}static fromString(E,S){return!(S?.dontUseNodeBuffer||!1)&&P?new v(Buffer.from(E)):(L||(L=new TextEncoder),new v(L.encode(E)))}static fromByteArray(E){const S=v.alloc(E.length);for(let F=0,N=E.length;F<N;F++)S.buffer[F]=E[F];return S}static concat(E,S){if(typeof S>"u"){S=0;for(let O=0,M=E.length;O<M;O++)S+=E[O].byteLength}const F=v.alloc(S);let N=0;for(let O=0,M=E.length;O<M;O++){const U=E[O];F.set(U,N),N+=U.byteLength}return F}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=v.alloc(this.byteLength);return E.set(this),E}toString(){return P?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(E,S){return new v(this.buffer.subarray(E,S))}set(E,S){if(E instanceof v)this.buffer.set(E.buffer,S);else if(E instanceof Uint8Array)this.buffer.set(E,S);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),S);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return u(this.buffer,E)}writeUInt32BE(E,S){T(this.buffer,E,S)}readUInt32LE(E){return b(this.buffer,E)}writeUInt32LE(E,S){a(this.buffer,E,S)}readUInt8(E){return m(this.buffer,E)}writeUInt8(E,S){p(this.buffer,E,S)}indexOf(E,S=0){return l(this.buffer,E instanceof v?E.buffer:E,S)}}e.VSBuffer=v;function l(A,E,S=0){const F=E.byteLength,N=A.byteLength;if(F===0)return 0;if(F===1)return A.indexOf(E[0]);if(F>N-S)return-1;const O=k.value;O.fill(E.length);for(let z=0;z<E.length;z++)O[E[z]]=E.length-z-1;let M=S+E.length-1,U=M,x=-1;for(;M<N;)if(A[M]===E[U]){if(U===0){x=M;break}M--,U--}else M+=Math.max(E.length-U,O[A[M]]),U=E.length-1;return x}function I(A,E){return A[E+0]<<0>>>0|A[E+1]<<8>>>0}function y(A,E,S){A[S+0]=E&255,E=E>>>8,A[S+1]=E&255}function u(A,E){return A[E]*2**24+A[E+1]*2**16+A[E+2]*2**8+A[E+3]}function T(A,E,S){A[S+3]=E,E=E>>>8,A[S+2]=E,E=E>>>8,A[S+1]=E,E=E>>>8,A[S]=E}function b(A,E){return A[E+0]<<0>>>0|A[E+1]<<8>>>0|A[E+2]<<16>>>0|A[E+3]<<24>>>0}function a(A,E,S){A[S+0]=E&255,E=E>>>8,A[S+1]=E&255,E=E>>>8,A[S+2]=E&255,E=E>>>8,A[S+3]=E&255}function m(A,E){return A[E]}function p(A,E,S){A[S]=E}function f(A){return d.consumeReadable(A,E=>v.concat(E))}function i(A){return d.toReadable(A)}function s(A){return d.consumeStream(A,E=>v.concat(E))}async function t(A){return A.ended?v.concat(A.buffer):v.concat([...A.buffer,await s(A.stream)])}function o(A){return d.toStream(A,E=>v.concat(E))}function n(A){return d.transform(A,{data:E=>typeof E=="string"?v.fromString(E):v.wrap(E)},E=>v.concat(E))}function h(A){return d.newWriteableStream(E=>v.concat(E),A)}function c(A,E){return d.prefixedReadable(A,E,S=>v.concat(S))}function g(A,E){return d.prefixedStream(A,E,S=>v.concat(S))}function w(A){let E=0,S=0,F=0;const N=new Uint8Array(Math.floor(A.length/4*3)),O=U=>{switch(S){case 3:N[F++]=E|U,S=0;break;case 2:N[F++]=E|U>>>2,E=U<<6,S=3;break;case 1:N[F++]=E|U>>>4,E=U<<4,S=2;break;default:E=U<<2,S=1}};for(let U=0;U<A.length;U++){const x=A.charCodeAt(U);if(x>=65&&x<=90)O(x-65);else if(x>=97&&x<=122)O(x-97+26);else if(x>=48&&x<=57)O(x-48+52);else if(x===43||x===45)O(62);else if(x===47||x===95)O(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${A[U]}`)}}const M=F;for(;S>0;)O(0);return v.wrap(N).slice(0,M)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",_="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:A},E=!0,S=!1){const F=S?_:D;let N="";const O=A.byteLength%3;let M=0;for(;M<A.byteLength-O;M+=3){const U=A[M+0],x=A[M+1],z=A[M+2];N+=F[U>>>2],N+=F[(U<<4|x>>>4)&63],N+=F[(x<<2|z>>>6)&63],N+=F[z&63]}if(O===1){const U=A[M+0];N+=F[U>>>2],N+=F[U<<4&63],E&&(N+="==")}else if(O===2){const U=A[M+0],x=A[M+1];N+=F[U>>>2],N+=F[(U<<4|x>>>4)&63],N+=F[x<<2&63],E&&(N+="=")}return N}}),define(Ce[186],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[17],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=r,e.isStringArray=d,e.isObject=P,e.isTypedArray=k,e.isNumber=L,e.isIterable=R,e.isBoolean=v,e.isUndefined=l,e.isDefined=I,e.isUndefinedOrNull=y,e.assertType=u,e.assertIsDefined=T,e.assertAllDefined=b,e.isEmptyObject=m,e.isFunction=p,e.areFunctions=f,e.validateConstraints=i,e.validateConstraint=s,e.upcast=t;function r(o){return typeof o=="string"}function d(o){return Array.isArray(o)&&o.every(n=>r(n))}function P(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function k(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}function L(o){return typeof o=="number"&&!isNaN(o)}function R(o){return!!o&&typeof o[Symbol.iterator]=="function"}function v(o){return o===!0||o===!1}function l(o){return typeof o>"u"}function I(o){return!y(o)}function y(o){return l(o)||o===null}function u(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function T(o){if(y(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function b(...o){const n=[];for(let h=0;h<o.length;h++){const c=o[h];if(y(c))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);n.push(c)}return n}const a=Object.prototype.hasOwnProperty;function m(o){if(!P(o))return!1;for(const n in o)if(a.call(o,n))return!1;return!0}function p(o){return typeof o=="function"}function f(...o){return o.length>0&&o.every(p)}function i(o,n){const h=Math.min(o.length,n.length);for(let c=0;c<h;c++)s(o[c],n[c])}function s(o,n){if(r(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(p(n)){try{if(o instanceof n)return}catch{}if(!y(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function t(o){return o}}),define(Ce[106],Ie([1,0,17]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=P,e.getCodiconFontCharacters=k;const d=Object.create(null);function P(L,R){if((0,r.isString)(R)){const v=d[R];if(v===void 0)throw new Error(`${L} references an unknown codicon: ${R}`);R=v}return d[L]=R,{id:L}}function k(){return d}}),define(Ce[187],Ie([1,0,106]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,r.register)("add",6e4),plus:(0,r.register)("plus",6e4),gistNew:(0,r.register)("gist-new",6e4),repoCreate:(0,r.register)("repo-create",6e4),lightbulb:(0,r.register)("lightbulb",60001),lightBulb:(0,r.register)("light-bulb",60001),repo:(0,r.register)("repo",60002),repoDelete:(0,r.register)("repo-delete",60002),gistFork:(0,r.register)("gist-fork",60003),repoForked:(0,r.register)("repo-forked",60003),gitPullRequest:(0,r.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.register)("git-pull-request-abandoned",60004),recordKeys:(0,r.register)("record-keys",60005),keyboard:(0,r.register)("keyboard",60005),tag:(0,r.register)("tag",60006),gitPullRequestLabel:(0,r.register)("git-pull-request-label",60006),tagAdd:(0,r.register)("tag-add",60006),tagRemove:(0,r.register)("tag-remove",60006),person:(0,r.register)("person",60007),personFollow:(0,r.register)("person-follow",60007),personOutline:(0,r.register)("person-outline",60007),personFilled:(0,r.register)("person-filled",60007),gitBranch:(0,r.register)("git-branch",60008),gitBranchCreate:(0,r.register)("git-branch-create",60008),gitBranchDelete:(0,r.register)("git-branch-delete",60008),sourceControl:(0,r.register)("source-control",60008),mirror:(0,r.register)("mirror",60009),mirrorPublic:(0,r.register)("mirror-public",60009),star:(0,r.register)("star",60010),starAdd:(0,r.register)("star-add",60010),starDelete:(0,r.register)("star-delete",60010),starEmpty:(0,r.register)("star-empty",60010),comment:(0,r.register)("comment",60011),commentAdd:(0,r.register)("comment-add",60011),alert:(0,r.register)("alert",60012),warning:(0,r.register)("warning",60012),search:(0,r.register)("search",60013),searchSave:(0,r.register)("search-save",60013),logOut:(0,r.register)("log-out",60014),signOut:(0,r.register)("sign-out",60014),logIn:(0,r.register)("log-in",60015),signIn:(0,r.register)("sign-in",60015),eye:(0,r.register)("eye",60016),eyeUnwatch:(0,r.register)("eye-unwatch",60016),eyeWatch:(0,r.register)("eye-watch",60016),circleFilled:(0,r.register)("circle-filled",60017),primitiveDot:(0,r.register)("primitive-dot",60017),closeDirty:(0,r.register)("close-dirty",60017),debugBreakpoint:(0,r.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.register)("debug-breakpoint-disabled",60017),debugHint:(0,r.register)("debug-hint",60017),terminalDecorationSuccess:(0,r.register)("terminal-decoration-success",60017),primitiveSquare:(0,r.register)("primitive-square",60018),edit:(0,r.register)("edit",60019),pencil:(0,r.register)("pencil",60019),info:(0,r.register)("info",60020),issueOpened:(0,r.register)("issue-opened",60020),gistPrivate:(0,r.register)("gist-private",60021),gitForkPrivate:(0,r.register)("git-fork-private",60021),lock:(0,r.register)("lock",60021),mirrorPrivate:(0,r.register)("mirror-private",60021),close:(0,r.register)("close",60022),removeClose:(0,r.register)("remove-close",60022),x:(0,r.register)("x",60022),repoSync:(0,r.register)("repo-sync",60023),sync:(0,r.register)("sync",60023),clone:(0,r.register)("clone",60024),desktopDownload:(0,r.register)("desktop-download",60024),beaker:(0,r.register)("beaker",60025),microscope:(0,r.register)("microscope",60025),vm:(0,r.register)("vm",60026),deviceDesktop:(0,r.register)("device-desktop",60026),file:(0,r.register)("file",60027),fileText:(0,r.register)("file-text",60027),more:(0,r.register)("more",60028),ellipsis:(0,r.register)("ellipsis",60028),kebabHorizontal:(0,r.register)("kebab-horizontal",60028),mailReply:(0,r.register)("mail-reply",60029),reply:(0,r.register)("reply",60029),organization:(0,r.register)("organization",60030),organizationFilled:(0,r.register)("organization-filled",60030),organizationOutline:(0,r.register)("organization-outline",60030),newFile:(0,r.register)("new-file",60031),fileAdd:(0,r.register)("file-add",60031),newFolder:(0,r.register)("new-folder",60032),fileDirectoryCreate:(0,r.register)("file-directory-create",60032),trash:(0,r.register)("trash",60033),trashcan:(0,r.register)("trashcan",60033),history:(0,r.register)("history",60034),clock:(0,r.register)("clock",60034),folder:(0,r.register)("folder",60035),fileDirectory:(0,r.register)("file-directory",60035),symbolFolder:(0,r.register)("symbol-folder",60035),logoGithub:(0,r.register)("logo-github",60036),markGithub:(0,r.register)("mark-github",60036),github:(0,r.register)("github",60036),terminal:(0,r.register)("terminal",60037),console:(0,r.register)("console",60037),repl:(0,r.register)("repl",60037),zap:(0,r.register)("zap",60038),symbolEvent:(0,r.register)("symbol-event",60038),error:(0,r.register)("error",60039),stop:(0,r.register)("stop",60039),variable:(0,r.register)("variable",60040),symbolVariable:(0,r.register)("symbol-variable",60040),array:(0,r.register)("array",60042),symbolArray:(0,r.register)("symbol-array",60042),symbolModule:(0,r.register)("symbol-module",60043),symbolPackage:(0,r.register)("symbol-package",60043),symbolNamespace:(0,r.register)("symbol-namespace",60043),symbolObject:(0,r.register)("symbol-object",60043),symbolMethod:(0,r.register)("symbol-method",60044),symbolFunction:(0,r.register)("symbol-function",60044),symbolConstructor:(0,r.register)("symbol-constructor",60044),symbolBoolean:(0,r.register)("symbol-boolean",60047),symbolNull:(0,r.register)("symbol-null",60047),symbolNumeric:(0,r.register)("symbol-numeric",60048),symbolNumber:(0,r.register)("symbol-number",60048),symbolStructure:(0,r.register)("symbol-structure",60049),symbolStruct:(0,r.register)("symbol-struct",60049),symbolParameter:(0,r.register)("symbol-parameter",60050),symbolTypeParameter:(0,r.register)("symbol-type-parameter",60050),symbolKey:(0,r.register)("symbol-key",60051),symbolText:(0,r.register)("symbol-text",60051),symbolReference:(0,r.register)("symbol-reference",60052),goToFile:(0,r.register)("go-to-file",60052),symbolEnum:(0,r.register)("symbol-enum",60053),symbolValue:(0,r.register)("symbol-value",60053),symbolRuler:(0,r.register)("symbol-ruler",60054),symbolUnit:(0,r.register)("symbol-unit",60054),activateBreakpoints:(0,r.register)("activate-breakpoints",60055),archive:(0,r.register)("archive",60056),arrowBoth:(0,r.register)("arrow-both",60057),arrowDown:(0,r.register)("arrow-down",60058),arrowLeft:(0,r.register)("arrow-left",60059),arrowRight:(0,r.register)("arrow-right",60060),arrowSmallDown:(0,r.register)("arrow-small-down",60061),arrowSmallLeft:(0,r.register)("arrow-small-left",60062),arrowSmallRight:(0,r.register)("arrow-small-right",60063),arrowSmallUp:(0,r.register)("arrow-small-up",60064),arrowUp:(0,r.register)("arrow-up",60065),bell:(0,r.register)("bell",60066),bold:(0,r.register)("bold",60067),book:(0,r.register)("book",60068),bookmark:(0,r.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.register)("briefcase",60076),broadcast:(0,r.register)("broadcast",60077),browser:(0,r.register)("browser",60078),bug:(0,r.register)("bug",60079),calendar:(0,r.register)("calendar",60080),caseSensitive:(0,r.register)("case-sensitive",60081),check:(0,r.register)("check",60082),checklist:(0,r.register)("checklist",60083),chevronDown:(0,r.register)("chevron-down",60084),chevronLeft:(0,r.register)("chevron-left",60085),chevronRight:(0,r.register)("chevron-right",60086),chevronUp:(0,r.register)("chevron-up",60087),chromeClose:(0,r.register)("chrome-close",60088),chromeMaximize:(0,r.register)("chrome-maximize",60089),chromeMinimize:(0,r.register)("chrome-minimize",60090),chromeRestore:(0,r.register)("chrome-restore",60091),circleOutline:(0,r.register)("circle-outline",60092),circle:(0,r.register)("circle",60092),debugBreakpointUnverified:(0,r.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.register)("terminal-decoration-incomplete",60092),circleSlash:(0,r.register)("circle-slash",60093),circuitBoard:(0,r.register)("circuit-board",60094),clearAll:(0,r.register)("clear-all",60095),clippy:(0,r.register)("clippy",60096),closeAll:(0,r.register)("close-all",60097),cloudDownload:(0,r.register)("cloud-download",60098),cloudUpload:(0,r.register)("cloud-upload",60099),code:(0,r.register)("code",60100),collapseAll:(0,r.register)("collapse-all",60101),colorMode:(0,r.register)("color-mode",60102),commentDiscussion:(0,r.register)("comment-discussion",60103),creditCard:(0,r.register)("credit-card",60105),dash:(0,r.register)("dash",60108),dashboard:(0,r.register)("dashboard",60109),database:(0,r.register)("database",60110),debugContinue:(0,r.register)("debug-continue",60111),debugDisconnect:(0,r.register)("debug-disconnect",60112),debugPause:(0,r.register)("debug-pause",60113),debugRestart:(0,r.register)("debug-restart",60114),debugStart:(0,r.register)("debug-start",60115),debugStepInto:(0,r.register)("debug-step-into",60116),debugStepOut:(0,r.register)("debug-step-out",60117),debugStepOver:(0,r.register)("debug-step-over",60118),debugStop:(0,r.register)("debug-stop",60119),debug:(0,r.register)("debug",60120),deviceCameraVideo:(0,r.register)("device-camera-video",60121),deviceCamera:(0,r.register)("device-camera",60122),deviceMobile:(0,r.register)("device-mobile",60123),diffAdded:(0,r.register)("diff-added",60124),diffIgnored:(0,r.register)("diff-ignored",60125),diffModified:(0,r.register)("diff-modified",60126),diffRemoved:(0,r.register)("diff-removed",60127),diffRenamed:(0,r.register)("diff-renamed",60128),diff:(0,r.register)("diff",60129),diffSidebyside:(0,r.register)("diff-sidebyside",60129),discard:(0,r.register)("discard",60130),editorLayout:(0,r.register)("editor-layout",60131),emptyWindow:(0,r.register)("empty-window",60132),exclude:(0,r.register)("exclude",60133),extensions:(0,r.register)("extensions",60134),eyeClosed:(0,r.register)("eye-closed",60135),fileBinary:(0,r.register)("file-binary",60136),fileCode:(0,r.register)("file-code",60137),fileMedia:(0,r.register)("file-media",60138),filePdf:(0,r.register)("file-pdf",60139),fileSubmodule:(0,r.register)("file-submodule",60140),fileSymlinkDirectory:(0,r.register)("file-symlink-directory",60141),fileSymlinkFile:(0,r.register)("file-symlink-file",60142),fileZip:(0,r.register)("file-zip",60143),files:(0,r.register)("files",60144),filter:(0,r.register)("filter",60145),flame:(0,r.register)("flame",60146),foldDown:(0,r.register)("fold-down",60147),foldUp:(0,r.register)("fold-up",60148),fold:(0,r.register)("fold",60149),folderActive:(0,r.register)("folder-active",60150),folderOpened:(0,r.register)("folder-opened",60151),gear:(0,r.register)("gear",60152),gift:(0,r.register)("gift",60153),gistSecret:(0,r.register)("gist-secret",60154),gist:(0,r.register)("gist",60155),gitCommit:(0,r.register)("git-commit",60156),gitCompare:(0,r.register)("git-compare",60157),compareChanges:(0,r.register)("compare-changes",60157),gitMerge:(0,r.register)("git-merge",60158),githubAction:(0,r.register)("github-action",60159),githubAlt:(0,r.register)("github-alt",60160),globe:(0,r.register)("globe",60161),grabber:(0,r.register)("grabber",60162),graph:(0,r.register)("graph",60163),gripper:(0,r.register)("gripper",60164),heart:(0,r.register)("heart",60165),home:(0,r.register)("home",60166),horizontalRule:(0,r.register)("horizontal-rule",60167),hubot:(0,r.register)("hubot",60168),inbox:(0,r.register)("inbox",60169),issueReopened:(0,r.register)("issue-reopened",60171),issues:(0,r.register)("issues",60172),italic:(0,r.register)("italic",60173),jersey:(0,r.register)("jersey",60174),json:(0,r.register)("json",60175),kebabVertical:(0,r.register)("kebab-vertical",60176),key:(0,r.register)("key",60177),law:(0,r.register)("law",60178),lightbulbAutofix:(0,r.register)("lightbulb-autofix",60179),linkExternal:(0,r.register)("link-external",60180),link:(0,r.register)("link",60181),listOrdered:(0,r.register)("list-ordered",60182),listUnordered:(0,r.register)("list-unordered",60183),liveShare:(0,r.register)("live-share",60184),loading:(0,r.register)("loading",60185),location:(0,r.register)("location",60186),mailRead:(0,r.register)("mail-read",60187),mail:(0,r.register)("mail",60188),markdown:(0,r.register)("markdown",60189),megaphone:(0,r.register)("megaphone",60190),mention:(0,r.register)("mention",60191),milestone:(0,r.register)("milestone",60192),gitPullRequestMilestone:(0,r.register)("git-pull-request-milestone",60192),mortarBoard:(0,r.register)("mortar-board",60193),move:(0,r.register)("move",60194),multipleWindows:(0,r.register)("multiple-windows",60195),mute:(0,r.register)("mute",60196),noNewline:(0,r.register)("no-newline",60197),note:(0,r.register)("note",60198),octoface:(0,r.register)("octoface",60199),openPreview:(0,r.register)("open-preview",60200),package:(0,r.register)("package",60201),paintcan:(0,r.register)("paintcan",60202),pin:(0,r.register)("pin",60203),play:(0,r.register)("play",60204),run:(0,r.register)("run",60204),plug:(0,r.register)("plug",60205),preserveCase:(0,r.register)("preserve-case",60206),preview:(0,r.register)("preview",60207),project:(0,r.register)("project",60208),pulse:(0,r.register)("pulse",60209),question:(0,r.register)("question",60210),quote:(0,r.register)("quote",60211),radioTower:(0,r.register)("radio-tower",60212),reactions:(0,r.register)("reactions",60213),references:(0,r.register)("references",60214),refresh:(0,r.register)("refresh",60215),regex:(0,r.register)("regex",60216),remoteExplorer:(0,r.register)("remote-explorer",60217),remote:(0,r.register)("remote",60218),remove:(0,r.register)("remove",60219),replaceAll:(0,r.register)("replace-all",60220),replace:(0,r.register)("replace",60221),repoClone:(0,r.register)("repo-clone",60222),repoForcePush:(0,r.register)("repo-force-push",60223),repoPull:(0,r.register)("repo-pull",60224),repoPush:(0,r.register)("repo-push",60225),report:(0,r.register)("report",60226),requestChanges:(0,r.register)("request-changes",60227),rocket:(0,r.register)("rocket",60228),rootFolderOpened:(0,r.register)("root-folder-opened",60229),rootFolder:(0,r.register)("root-folder",60230),rss:(0,r.register)("rss",60231),ruby:(0,r.register)("ruby",60232),saveAll:(0,r.register)("save-all",60233),saveAs:(0,r.register)("save-as",60234),save:(0,r.register)("save",60235),screenFull:(0,r.register)("screen-full",60236),screenNormal:(0,r.register)("screen-normal",60237),searchStop:(0,r.register)("search-stop",60238),server:(0,r.register)("server",60240),settingsGear:(0,r.register)("settings-gear",60241),settings:(0,r.register)("settings",60242),shield:(0,r.register)("shield",60243),smiley:(0,r.register)("smiley",60244),sortPrecedence:(0,r.register)("sort-precedence",60245),splitHorizontal:(0,r.register)("split-horizontal",60246),splitVertical:(0,r.register)("split-vertical",60247),squirrel:(0,r.register)("squirrel",60248),starFull:(0,r.register)("star-full",60249),starHalf:(0,r.register)("star-half",60250),symbolClass:(0,r.register)("symbol-class",60251),symbolColor:(0,r.register)("symbol-color",60252),symbolConstant:(0,r.register)("symbol-constant",60253),symbolEnumMember:(0,r.register)("symbol-enum-member",60254),symbolField:(0,r.register)("symbol-field",60255),symbolFile:(0,r.register)("symbol-file",60256),symbolInterface:(0,r.register)("symbol-interface",60257),symbolKeyword:(0,r.register)("symbol-keyword",60258),symbolMisc:(0,r.register)("symbol-misc",60259),symbolOperator:(0,r.register)("symbol-operator",60260),symbolProperty:(0,r.register)("symbol-property",60261),wrench:(0,r.register)("wrench",60261),wrenchSubaction:(0,r.register)("wrench-subaction",60261),symbolSnippet:(0,r.register)("symbol-snippet",60262),tasklist:(0,r.register)("tasklist",60263),telescope:(0,r.register)("telescope",60264),textSize:(0,r.register)("text-size",60265),threeBars:(0,r.register)("three-bars",60266),thumbsdown:(0,r.register)("thumbsdown",60267),thumbsup:(0,r.register)("thumbsup",60268),tools:(0,r.register)("tools",60269),triangleDown:(0,r.register)("triangle-down",60270),triangleLeft:(0,r.register)("triangle-left",60271),triangleRight:(0,r.register)("triangle-right",60272),triangleUp:(0,r.register)("triangle-up",60273),twitter:(0,r.register)("twitter",60274),unfold:(0,r.register)("unfold",60275),unlock:(0,r.register)("unlock",60276),unmute:(0,r.register)("unmute",60277),unverified:(0,r.register)("unverified",60278),verified:(0,r.register)("verified",60279),versions:(0,r.register)("versions",60280),vmActive:(0,r.register)("vm-active",60281),vmOutline:(0,r.register)("vm-outline",60282),vmRunning:(0,r.register)("vm-running",60283),watch:(0,r.register)("watch",60284),whitespace:(0,r.register)("whitespace",60285),wholeWord:(0,r.register)("whole-word",60286),window:(0,r.register)("window",60287),wordWrap:(0,r.register)("word-wrap",60288),zoomIn:(0,r.register)("zoom-in",60289),zoomOut:(0,r.register)("zoom-out",60290),listFilter:(0,r.register)("list-filter",60291),listFlat:(0,r.register)("list-flat",60292),listSelection:(0,r.register)("list-selection",60293),selection:(0,r.register)("selection",60293),listTree:(0,r.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.register)("debug-stackframe-active",60297),circleSmallFilled:(0,r.register)("circle-small-filled",60298),debugStackframeDot:(0,r.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.register)("terminal-decoration-mark",60298),debugStackframe:(0,r.register)("debug-stackframe",60299),debugStackframeFocused:(0,r.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.register)("debug-breakpoint-unsupported",60300),symbolString:(0,r.register)("symbol-string",60301),debugReverseContinue:(0,r.register)("debug-reverse-continue",60302),debugStepBack:(0,r.register)("debug-step-back",60303),debugRestartFrame:(0,r.register)("debug-restart-frame",60304),debugAlt:(0,r.register)("debug-alt",60305),callIncoming:(0,r.register)("call-incoming",60306),callOutgoing:(0,r.register)("call-outgoing",60307),menu:(0,r.register)("menu",60308),expandAll:(0,r.register)("expand-all",60309),feedback:(0,r.register)("feedback",60310),gitPullRequestReviewer:(0,r.register)("git-pull-request-reviewer",60310),groupByRefType:(0,r.register)("group-by-ref-type",60311),ungroupByRefType:(0,r.register)("ungroup-by-ref-type",60312),account:(0,r.register)("account",60313),gitPullRequestAssignee:(0,r.register)("git-pull-request-assignee",60313),bellDot:(0,r.register)("bell-dot",60314),debugConsole:(0,r.register)("debug-console",60315),library:(0,r.register)("library",60316),output:(0,r.register)("output",60317),runAll:(0,r.register)("run-all",60318),syncIgnored:(0,r.register)("sync-ignored",60319),pinned:(0,r.register)("pinned",60320),githubInverted:(0,r.register)("github-inverted",60321),serverProcess:(0,r.register)("server-process",60322),serverEnvironment:(0,r.register)("server-environment",60323),pass:(0,r.register)("pass",60324),issueClosed:(0,r.register)("issue-closed",60324),stopCircle:(0,r.register)("stop-circle",60325),playCircle:(0,r.register)("play-circle",60326),record:(0,r.register)("record",60327),debugAltSmall:(0,r.register)("debug-alt-small",60328),vmConnect:(0,r.register)("vm-connect",60329),cloud:(0,r.register)("cloud",60330),merge:(0,r.register)("merge",60331),export:(0,r.register)("export",60332),graphLeft:(0,r.register)("graph-left",60333),magnet:(0,r.register)("magnet",60334),notebook:(0,r.register)("notebook",60335),redo:(0,r.register)("redo",60336),checkAll:(0,r.register)("check-all",60337),pinnedDirty:(0,r.register)("pinned-dirty",60338),passFilled:(0,r.register)("pass-filled",60339),circleLargeFilled:(0,r.register)("circle-large-filled",60340),circleLarge:(0,r.register)("circle-large",60341),circleLargeOutline:(0,r.register)("circle-large-outline",60341),combine:(0,r.register)("combine",60342),gather:(0,r.register)("gather",60342),table:(0,r.register)("table",60343),variableGroup:(0,r.register)("variable-group",60344),typeHierarchy:(0,r.register)("type-hierarchy",60345),typeHierarchySub:(0,r.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.register)("git-pull-request-create",60348),runAbove:(0,r.register)("run-above",60349),runBelow:(0,r.register)("run-below",60350),notebookTemplate:(0,r.register)("notebook-template",60351),debugRerun:(0,r.register)("debug-rerun",60352),workspaceTrusted:(0,r.register)("workspace-trusted",60353),workspaceUntrusted:(0,r.register)("workspace-untrusted",60354),workspaceUnknown:(0,r.register)("workspace-unknown",60355),terminalCmd:(0,r.register)("terminal-cmd",60356),terminalDebian:(0,r.register)("terminal-debian",60357),terminalLinux:(0,r.register)("terminal-linux",60358),terminalPowershell:(0,r.register)("terminal-powershell",60359),terminalTmux:(0,r.register)("terminal-tmux",60360),terminalUbuntu:(0,r.register)("terminal-ubuntu",60361),terminalBash:(0,r.register)("terminal-bash",60362),arrowSwap:(0,r.register)("arrow-swap",60363),copy:(0,r.register)("copy",60364),personAdd:(0,r.register)("person-add",60365),filterFilled:(0,r.register)("filter-filled",60366),wand:(0,r.register)("wand",60367),debugLineByLine:(0,r.register)("debug-line-by-line",60368),inspect:(0,r.register)("inspect",60369),layers:(0,r.register)("layers",60370),layersDot:(0,r.register)("layers-dot",60371),layersActive:(0,r.register)("layers-active",60372),compass:(0,r.register)("compass",60373),compassDot:(0,r.register)("compass-dot",60374),compassActive:(0,r.register)("compass-active",60375),azure:(0,r.register)("azure",60376),issueDraft:(0,r.register)("issue-draft",60377),gitPullRequestClosed:(0,r.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.register)("git-pull-request-draft",60379),debugAll:(0,r.register)("debug-all",60380),debugCoverage:(0,r.register)("debug-coverage",60381),runErrors:(0,r.register)("run-errors",60382),folderLibrary:(0,r.register)("folder-library",60383),debugContinueSmall:(0,r.register)("debug-continue-small",60384),beakerStop:(0,r.register)("beaker-stop",60385),graphLine:(0,r.register)("graph-line",60386),graphScatter:(0,r.register)("graph-scatter",60387),pieChart:(0,r.register)("pie-chart",60388),bracket:(0,r.register)("bracket",60175),bracketDot:(0,r.register)("bracket-dot",60389),bracketError:(0,r.register)("bracket-error",60390),lockSmall:(0,r.register)("lock-small",60391),azureDevops:(0,r.register)("azure-devops",60392),verifiedFilled:(0,r.register)("verified-filled",60393),newline:(0,r.register)("newline",60394),layout:(0,r.register)("layout",60395),layoutActivitybarLeft:(0,r.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.register)("layout-panel-left",60398),layoutPanelCenter:(0,r.register)("layout-panel-center",60399),layoutPanelJustify:(0,r.register)("layout-panel-justify",60400),layoutPanelRight:(0,r.register)("layout-panel-right",60401),layoutPanel:(0,r.register)("layout-panel",60402),layoutSidebarLeft:(0,r.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.register)("layout-sidebar-right",60404),layoutStatusbar:(0,r.register)("layout-statusbar",60405),layoutMenubar:(0,r.register)("layout-menubar",60406),layoutCentered:(0,r.register)("layout-centered",60407),target:(0,r.register)("target",60408),indent:(0,r.register)("indent",60409),recordSmall:(0,r.register)("record-small",60410),errorSmall:(0,r.register)("error-small",60411),terminalDecorationError:(0,r.register)("terminal-decoration-error",60411),arrowCircleDown:(0,r.register)("arrow-circle-down",60412),arrowCircleLeft:(0,r.register)("arrow-circle-left",60413),arrowCircleRight:(0,r.register)("arrow-circle-right",60414),arrowCircleUp:(0,r.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.register)("layout-sidebar-left-off",60418),blank:(0,r.register)("blank",60419),heartFilled:(0,r.register)("heart-filled",60420),map:(0,r.register)("map",60421),mapHorizontal:(0,r.register)("map-horizontal",60421),foldHorizontal:(0,r.register)("fold-horizontal",60421),mapFilled:(0,r.register)("map-filled",60422),mapHorizontalFilled:(0,r.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.register)("fold-horizontal-filled",60422),circleSmall:(0,r.register)("circle-small",60423),bellSlash:(0,r.register)("bell-slash",60424),bellSlashDot:(0,r.register)("bell-slash-dot",60425),commentUnresolved:(0,r.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.register)("search-fuzzy",60429),commentDraft:(0,r.register)("comment-draft",60430),send:(0,r.register)("send",60431),sparkle:(0,r.register)("sparkle",60432),insert:(0,r.register)("insert",60433),mic:(0,r.register)("mic",60434),thumbsdownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsupFilled:(0,r.register)("thumbsup-filled",60436),coffee:(0,r.register)("coffee",60437),snake:(0,r.register)("snake",60438),game:(0,r.register)("game",60439),vr:(0,r.register)("vr",60440),chip:(0,r.register)("chip",60441),piano:(0,r.register)("piano",60442),music:(0,r.register)("music",60443),micFilled:(0,r.register)("mic-filled",60444),repoFetch:(0,r.register)("repo-fetch",60445),copilot:(0,r.register)("copilot",60446),lightbulbSparkle:(0,r.register)("lightbulb-sparkle",60447),robot:(0,r.register)("robot",60448),sparkleFilled:(0,r.register)("sparkle-filled",60449),diffSingle:(0,r.register)("diff-single",60450),diffMultiple:(0,r.register)("diff-multiple",60451),surroundWith:(0,r.register)("surround-with",60452),share:(0,r.register)("share",60453),gitStash:(0,r.register)("git-stash",60454),gitStashApply:(0,r.register)("git-stash-apply",60455),gitStashPop:(0,r.register)("git-stash-pop",60456),vscode:(0,r.register)("vscode",60457),vscodeInsiders:(0,r.register)("vscode-insiders",60458),codeOss:(0,r.register)("code-oss",60459),runCoverage:(0,r.register)("run-coverage",60460),runAllCoverage:(0,r.register)("run-all-coverage",60461),coverage:(0,r.register)("coverage",60462),githubProject:(0,r.register)("github-project",60463),mapVertical:(0,r.register)("map-vertical",60464),foldVertical:(0,r.register)("fold-vertical",60464),mapVerticalFilled:(0,r.register)("map-vertical-filled",60465),foldVerticalFilled:(0,r.register)("fold-vertical-filled",60465),goToSearch:(0,r.register)("go-to-search",60466),percentage:(0,r.register)("percentage",60467),sortPercentage:(0,r.register)("sort-percentage",60467),attach:(0,r.register)("attach",60468)}}),define(Ce[82],Ie([1,0,106,187]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=P;function P(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,r.register)("dialog-error","error"),dialogWarning:(0,r.register)("dialog-warning","warning"),dialogInfo:(0,r.register)("dialog-info","info"),dialogClose:(0,r.register)("dialog-close","close"),treeItemExpanded:(0,r.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.register)("tree-filter-clear","close"),treeItemLoading:(0,r.register)("tree-item-loading","loading"),menuSelection:(0,r.register)("menu-selection","check"),menuSubmenu:(0,r.register)("menu-submenu","chevron-right"),menuBarMore:(0,r.register)("menubar-more","more"),scrollbarButtonLeft:(0,r.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.register)("toolbar-more","more"),quickInputBack:(0,r.register)("quick-input-back","arrow-left"),dropDownButton:(0,r.register)("drop-down-button",60084),symbolCustomColor:(0,r.register)("symbol-customcolor",60252),exportIcon:(0,r.register)("export",60332),workspaceUnspecified:(0,r.register)("workspace-unspecified",60355),newLine:(0,r.register)("newline",60394),thumbsDownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.register)("thumbsup-filled",60436),gitFetch:(0,r.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.register)("debug-breakpoint-pending",60377)},e.Codicon={...d.codiconsLibrary,...e.codiconsDerived}}),define(Ce[24],Ie([1,0,17]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=d,e.deepFreeze=P,e.cloneAndChange=L,e.mixin=v,e.equals=l,e.safeStringify=I,e.distinct=y,e.getCaseInsensitive=u,e.filter=T,e.getAllPropertyNames=b,e.getAllMethodNames=a,e.createProxyObject=m,e.mapValues=p;function d(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const i=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([s,t])=>{i[s]=t&&typeof t=="object"?d(t):t}),i}function P(f){if(!f||typeof f!="object")return f;const i=[f];for(;i.length>0;){const s=i.shift();Object.freeze(s);for(const t in s)if(k.call(s,t)){const o=s[t];typeof o=="object"&&!Object.isFrozen(o)&&!(0,r.isTypedArray)(o)&&i.push(o)}}return f}const k=Object.prototype.hasOwnProperty;function L(f,i){return R(f,i,new Set)}function R(f,i,s){if((0,r.isUndefinedOrNull)(f))return f;const t=i(f);if(typeof t<"u")return t;if(Array.isArray(f)){const o=[];for(const n of f)o.push(R(n,i,s));return o}if((0,r.isObject)(f)){if(s.has(f))throw new Error("Cannot clone recursive data-structure");s.add(f);const o={};for(const n in f)k.call(f,n)&&(o[n]=R(f[n],i,s));return s.delete(f),o}return f}function v(f,i,s=!0){return(0,r.isObject)(f)?((0,r.isObject)(i)&&Object.keys(i).forEach(t=>{t in f?s&&((0,r.isObject)(f[t])&&(0,r.isObject)(i[t])?v(f[t],i[t],s):f[t]=i[t]):f[t]=i[t]}),f):i}function l(f,i){if(f===i)return!0;if(f==null||i===null||i===void 0||typeof f!=typeof i||typeof f!="object"||Array.isArray(f)!==Array.isArray(i))return!1;let s,t;if(Array.isArray(f)){if(f.length!==i.length)return!1;for(s=0;s<f.length;s++)if(!l(f[s],i[s]))return!1}else{const o=[];for(t in f)o.push(t);o.sort();const n=[];for(t in i)n.push(t);if(n.sort(),!l(o,n))return!1;for(s=0;s<o.length;s++)if(!l(f[o[s]],i[o[s]]))return!1}return!0}function I(f){const i=new Set;return JSON.stringify(f,(s,t)=>{if((0,r.isObject)(t)||Array.isArray(t)){if(i.has(t))return"[Circular]";i.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function y(f,i){const s=Object.create(null);return!f||!i||Object.keys(i).forEach(o=>{const n=f[o],h=i[o];l(n,h)||(s[o]=h)}),s}function u(f,i){const s=i.toLowerCase(),t=Object.keys(f).find(o=>o.toLowerCase()===s);return t?f[t]:f[i]}function T(f,i){const s=Object.create(null);for(const[t,o]of Object.entries(f))i(t,o)&&(s[t]=o);return s}function b(f){let i=[];for(;Object.prototype!==f;)i=i.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return i}function a(f){const i=[];for(const s of b(f))typeof f[s]=="function"&&i.push(s);return i}function m(f,i){const s=o=>function(){const n=Array.prototype.slice.call(arguments,0);return i(o,n)},t={};for(const o of f)t[o]=s(o);return t}function p(f,i){const s={};for(const[t,o]of Object.entries(f))s[t]=i(o,t);return s}}),define(Ce[51],Ie([1,0,82]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=P;var d;(function(L){function R(v){return v&&typeof v=="object"&&typeof v.id=="string"}L.isThemeColor=R})(d||(e.ThemeColor=d={}));function P(L){return{id:L}}var k;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function v(f){const i=R.exec(f.id);if(!i)return v(r.Codicon.error);const[,s,t]=i,o=["codicon","codicon-"+s];return t&&o.push("codicon-modifier-"+t.substring(1)),o}L.asClassNameArray=v;function l(f){return v(f).join(" ")}L.asClassName=l;function I(f){return"."+v(f).join(".")}L.asCSSSelector=I;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||d.isThemeColor(f.color))}L.isThemeIcon=y;const u=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function T(f){const i=u.exec(f);if(!i)return;const[,s]=i;return{id:s}}L.fromString=T;function b(f){return{id:f}}L.fromId=b;function a(f,i){let s=f.id;const t=s.lastIndexOf("~");return t!==-1&&(s=s.substring(0,t)),i&&(s=`${s}~${i}`),{id:s}}L.modify=a;function m(f){const i=f.id.lastIndexOf("~");if(i!==-1)return f.id.substring(i+1)}L.getModifier=m;function p(f,i){return f.id===i.id&&f.color?.id===i.color?.id}L.isEqual=p})(k||(e.ThemeIcon=k={}))}),define(Ce[83],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=d,e.toUint32=P;var r;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function d(k){return k<0?0:k>r.MAX_UINT_8?r.MAX_UINT_8:k|0}function P(k){return k<0?0:k>r.MAX_UINT_32?r.MAX_UINT_32:k|0}}),define(Ce[12],Ie([1,0,184,26,50,83]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=L,e.format=v,e.format2=I,e.htmlAttributeEncodeValue=y,e.escape=u,e.escapeRegExpCharacters=T,e.count=b,e.truncate=a,e.truncateMiddle=m,e.trim=p,e.ltrim=f,e.rtrim=i,e.convertSimple2RegExpPattern=s,e.stripWildcards=t,e.createRegExp=o,e.regExpLeadsToEndlessLoop=n,e.splitLines=h,e.splitLinesIncludeSeparators=c,e.firstNonWhitespaceIndex=g,e.getLeadingWhitespace=w,e.lastNonWhitespaceIndex=D,e.replaceAsync=_,e.compare=C,e.compareSubstring=A,e.compareIgnoreCase=E,e.compareSubstringIgnoreCase=S,e.isAsciiDigit=F,e.isLowerAsciiLetter=N,e.isUpperAsciiLetter=O,e.equalsIgnoreCase=M,e.startsWithIgnoreCase=U,e.commonPrefixLength=x,e.commonSuffixLength=z,e.isHighSurrogate=B,e.isLowSurrogate=ee,e.computeCodePoint=V,e.getNextCodePoint=$,e.nextCharLength=ne,e.prevCharLength=_e,e.getCharContainingOffset=ge,e.charCount=Y,e.containsRTL=Se,e.isBasicASCII=ae,e.containsUnusualLineTerminators=se,e.isFullWidthCharacter=Q,e.isEmojiImprecise=re,e.lcut=ve,e.forAnsiStringParts=Fe,e.removeAnsiEscapeCodes=Be,e.removeAnsiEscapeCodesFromPrompt=De,e.startsWithUTF8BOM=Pe,e.stripUTF8BOM=H,e.fuzzyContains=q,e.containsUppercaseCharacter=X,e.uppercaseFirstLetter=J,e.getNLines=he,e.singleLetterHash=we,e.getGraphemeBreakType=Oe,e.getLeftDeleteOffset=st;function L(Te){return!Te||typeof Te!="string"?!0:Te.trim().length===0}const R=/{(\d+)}/g;function v(Te,...Ue){return Ue.length===0?Te:Te.replace(R,function(je,Ne){const xe=parseInt(Ne,10);return isNaN(xe)||xe<0||xe>=Ue.length?je:Ue[xe]})}const l=/{([^}]+)}/g;function I(Te,Ue){return Object.keys(Ue).length===0?Te:Te.replace(l,(je,Ne)=>Ue[Ne]??je)}function y(Te){return Te.replace(/[<>"'&]/g,Ue=>{switch(Ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ue})}function u(Te){return Te.replace(/[<>&]/g,function(Ue){switch(Ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ue}})}function T(Te){return Te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(Te,Ue){let je=0,Ne=Te.indexOf(Ue);for(;Ne!==-1;)je++,Ne=Te.indexOf(Ue,Ne+Ue.length);return je}function a(Te,Ue,je="\u2026"){return Te.length<=Ue?Te:`${Te.substr(0,Ue)}${je}`}function m(Te,Ue,je="\u2026"){if(Te.length<=Ue)return Te;const Ne=Math.ceil(Ue/2)-je.length/2,xe=Math.floor(Ue/2)-je.length/2;return`${Te.substr(0,Ne)}${je}${Te.substr(Te.length-xe)}`}function p(Te,Ue=" "){const je=f(Te,Ue);return i(je,Ue)}function f(Te,Ue){if(!Te||!Ue)return Te;const je=Ue.length;if(je===0||Te.length===0)return Te;let Ne=0;for(;Te.indexOf(Ue,Ne)===Ne;)Ne=Ne+je;return Te.substring(Ne)}function i(Te,Ue){if(!Te||!Ue)return Te;const je=Ue.length,Ne=Te.length;if(je===0||Ne===0)return Te;let xe=Ne,ue=-1;for(;ue=Te.lastIndexOf(Ue,xe-1),!(ue===-1||ue+je!==xe);){if(ue===0)return"";xe=ue}return Te.substring(0,xe)}function s(Te){return Te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Te){return Te.replace(/\*/g,"")}function o(Te,Ue,je={}){if(!Te)throw new Error("Cannot create regex from empty string");Ue||(Te=T(Te)),je.wholeWord&&(/\B/.test(Te.charAt(0))||(Te="\\b"+Te),/\B/.test(Te.charAt(Te.length-1))||(Te=Te+"\\b"));let Ne="";return je.global&&(Ne+="g"),je.matchCase||(Ne+="i"),je.multiline&&(Ne+="m"),je.unicode&&(Ne+="u"),new RegExp(Te,Ne)}function n(Te){return Te.source==="^"||Te.source==="^$"||Te.source==="$"||Te.source==="^\\s*$"?!1:!!(Te.exec("")&&Te.lastIndex===0)}function h(Te){return Te.split(/\r\n|\r|\n/)}function c(Te){const Ue=[],je=Te.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(je.length/2);Ne++)Ue.push(je[2*Ne]+(je[2*Ne+1]??""));return Ue}function g(Te){for(let Ue=0,je=Te.length;Ue<je;Ue++){const Ne=Te.charCodeAt(Ue);if(Ne!==d.CharCode.Space&&Ne!==d.CharCode.Tab)return Ue}return-1}function w(Te,Ue=0,je=Te.length){for(let Ne=Ue;Ne<je;Ne++){const xe=Te.charCodeAt(Ne);if(xe!==d.CharCode.Space&&xe!==d.CharCode.Tab)return Te.substring(Ue,Ne)}return Te.substring(Ue,je)}function D(Te,Ue=Te.length-1){for(let je=Ue;je>=0;je--){const Ne=Te.charCodeAt(je);if(Ne!==d.CharCode.Space&&Ne!==d.CharCode.Tab)return je}return-1}function _(Te,Ue,je){const Ne=[];let xe=0;for(const ue of Te.matchAll(Ue)){if(Ne.push(Te.slice(xe,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");xe=ue.index+ue[0].length,Ne.push(je(ue[0],...ue.slice(1),ue.index,Te,ue.groups))}return Ne.push(Te.slice(xe)),Promise.all(Ne).then(ue=>ue.join(""))}function C(Te,Ue){return Te<Ue?-1:Te>Ue?1:0}function A(Te,Ue,je=0,Ne=Te.length,xe=0,ue=Ue.length){for(;je<Ne&&xe<ue;je++,xe++){const Qe=Te.charCodeAt(je),tt=Ue.charCodeAt(xe);if(Qe<tt)return-1;if(Qe>tt)return 1}const de=Ne-je,ce=ue-xe;return de<ce?-1:de>ce?1:0}function E(Te,Ue){return S(Te,Ue,0,Te.length,0,Ue.length)}function S(Te,Ue,je=0,Ne=Te.length,xe=0,ue=Ue.length){for(;je<Ne&&xe<ue;je++,xe++){let Qe=Te.charCodeAt(je),tt=Ue.charCodeAt(xe);if(Qe===tt)continue;if(Qe>=128||tt>=128)return A(Te.toLowerCase(),Ue.toLowerCase(),je,Ne,xe,ue);N(Qe)&&(Qe-=32),N(tt)&&(tt-=32);const ut=Qe-tt;if(ut!==0)return ut}const de=Ne-je,ce=ue-xe;return de<ce?-1:de>ce?1:0}function F(Te){return Te>=d.CharCode.Digit0&&Te<=d.CharCode.Digit9}function N(Te){return Te>=d.CharCode.a&&Te<=d.CharCode.z}function O(Te){return Te>=d.CharCode.A&&Te<=d.CharCode.Z}function M(Te,Ue){return Te.length===Ue.length&&S(Te,Ue)===0}function U(Te,Ue){const je=Ue.length;return Ue.length>Te.length?!1:S(Te,Ue,0,je)===0}function x(Te,Ue){const je=Math.min(Te.length,Ue.length);let Ne;for(Ne=0;Ne<je;Ne++)if(Te.charCodeAt(Ne)!==Ue.charCodeAt(Ne))return Ne;return je}function z(Te,Ue){const je=Math.min(Te.length,Ue.length);let Ne;const xe=Te.length-1,ue=Ue.length-1;for(Ne=0;Ne<je;Ne++)if(Te.charCodeAt(xe-Ne)!==Ue.charCodeAt(ue-Ne))return Ne;return je}function B(Te){return 55296<=Te&&Te<=56319}function ee(Te){return 56320<=Te&&Te<=57343}function V(Te,Ue){return(Te-55296<<10)+(Ue-56320)+65536}function $(Te,Ue,je){const Ne=Te.charCodeAt(je);if(B(Ne)&&je+1<Ue){const xe=Te.charCodeAt(je+1);if(ee(xe))return V(Ne,xe)}return Ne}function G(Te,Ue){const je=Te.charCodeAt(Ue-1);if(ee(je)&&Ue>1){const Ne=Te.charCodeAt(Ue-2);if(B(Ne))return V(Ne,je)}return je}class Z{get offset(){return this._offset}constructor(Ue,je=0){this._str=Ue,this._len=Ue.length,this._offset=je}setOffset(Ue){this._offset=Ue}prevCodePoint(){const Ue=G(this._str,this._offset);return this._offset-=Ue>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ue}nextCodePoint(){const Ue=$(this._str,this._len,this._offset);return this._offset+=Ue>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ue}eol(){return this._offset>=this._len}}e.CodePointIterator=Z;class le{get offset(){return this._iterator.offset}constructor(Ue,je=0){this._iterator=new Z(Ue,je)}nextGraphemeLength(){const Ue=et.getInstance(),je=this._iterator,Ne=je.offset;let xe=Ue.getGraphemeBreakType(je.nextCodePoint());for(;!je.eol();){const ue=je.offset,de=Ue.getGraphemeBreakType(je.nextCodePoint());if(Ve(xe,de)){je.setOffset(ue);break}xe=de}return je.offset-Ne}prevGraphemeLength(){const Ue=et.getInstance(),je=this._iterator,Ne=je.offset;let xe=Ue.getGraphemeBreakType(je.prevCodePoint());for(;je.offset>0;){const ue=je.offset,de=Ue.getGraphemeBreakType(je.prevCodePoint());if(Ve(de,xe)){je.setOffset(ue);break}xe=de}return Ne-je.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=le;function ne(Te,Ue){return new le(Te,Ue).nextGraphemeLength()}function _e(Te,Ue){return new le(Te,Ue).prevGraphemeLength()}function ge(Te,Ue){Ue>0&&ee(Te.charCodeAt(Ue))&&Ue--;const je=Ue+ne(Te,Ue);return[je-_e(Te,je),je]}function Y(Te){const Ue=new le(Te);let je=0;for(;!Ue.eol();)je++,Ue.nextGraphemeLength();return je}let W;function oe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(Te){return W||(W=oe()),W.test(Te)}const te=/^[\t\n\r\x20-\x7E]*$/;function ae(Te){return te.test(Te)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(Te){return e.UNUSUAL_LINE_TERMINATORS.test(Te)}function Q(Te){return Te>=11904&&Te<=55215||Te>=63744&&Te<=64255||Te>=65281&&Te<=65374}function re(Te){return Te>=127462&&Te<=127487||Te===8986||Te===8987||Te===9200||Te===9203||Te>=9728&&Te<=10175||Te===11088||Te===11093||Te>=127744&&Te<=128591||Te>=128640&&Te<=128764||Te>=128992&&Te<=129008||Te>=129280&&Te<=129535||Te>=129648&&Te<=129782}function ve(Te,Ue,je=""){const Ne=Te.trimStart();if(Ne.length<Ue)return Ne;const xe=/\b/g;let ue=0;for(;xe.test(Ne)&&!(Ne.length-xe.lastIndex<Ue);)ue=xe.lastIndex,xe.lastIndex+=1;return ue===0?Ne:je+Ne.substring(ue).trimStart()}const be=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(Te){let Ue=0;for(const je of Te.matchAll(be))Ue!==je.index&&(yield{isCode:!1,str:Te.substring(Ue,je.index)}),yield{isCode:!0,str:je[0]},Ue=je.index+je[0].length;Ue!==Te.length&&(yield{isCode:!1,str:Te.substring(Ue)})}function Be(Te){return Te&&(Te=Te.replace(be,"")),Te}const ke=/\\\[.*?\\\]/g;function De(Te){return Be(Te).replace(ke,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(d.CharCode.UTF8_BOM);function Pe(Te){return!!(Te&&Te.length>0&&Te.charCodeAt(0)===d.CharCode.UTF8_BOM)}function H(Te){return Pe(Te)?Te.substr(1):Te}function q(Te,Ue){if(!Te||!Ue||Te.length<Ue.length)return!1;const je=Ue.length,Ne=Te.toLowerCase();let xe=0,ue=-1;for(;xe<je;){const de=Ne.indexOf(Ue[xe],ue+1);if(de<0)return!1;ue=de,xe++}return!0}function X(Te,Ue=!1){return Te?(Ue&&(Te=Te.replace(/\\./g,"")),Te.toLowerCase()!==Te):!1}function J(Te){return Te.charAt(0).toUpperCase()+Te.slice(1)}function he(Te,Ue=1){if(Ue===0)return"";let je=-1;do je=Te.indexOf(`
`,je+1),Ue--;while(Ue>0&&je>=0);return je===-1?Te:(Te[je-1]==="\r"&&je--,Te.substr(0,je))}function we(Te){const Ue=d.CharCode.Z-d.CharCode.A+1;return Te=Te%(2*Ue),Te<Ue?String.fromCharCode(d.CharCode.a+Te):String.fromCharCode(d.CharCode.A+Te-Ue)}function Oe(Te){return et.getInstance().getGraphemeBreakType(Te)}function Ve(Te,Ue){return Te===Ke.Other?Ue!==Ke.Extend&&Ue!==Ke.SpacingMark:Te===Ke.CR&&Ue===Ke.LF?!1:Te===Ke.Control||Te===Ke.CR||Te===Ke.LF||Ue===Ke.Control||Ue===Ke.CR||Ue===Ke.LF?!0:!(Te===Ke.L&&(Ue===Ke.L||Ue===Ke.V||Ue===Ke.LV||Ue===Ke.LVT)||(Te===Ke.LV||Te===Ke.V)&&(Ue===Ke.V||Ue===Ke.T)||(Te===Ke.LVT||Te===Ke.T)&&Ue===Ke.T||Ue===Ke.Extend||Ue===Ke.ZWJ||Ue===Ke.SpacingMark||Te===Ke.Prepend||Te===Ke.ZWJ&&Ue===Ke.Extended_Pictographic||Te===Ke.Regional_Indicator&&Ue===Ke.Regional_Indicator)}var Ke;(function(Te){Te[Te.Other=0]="Other",Te[Te.Prepend=1]="Prepend",Te[Te.CR=2]="CR",Te[Te.LF=3]="LF",Te[Te.Control=4]="Control",Te[Te.Extend=5]="Extend",Te[Te.Regional_Indicator=6]="Regional_Indicator",Te[Te.SpacingMark=7]="SpacingMark",Te[Te.L=8]="L",Te[Te.V=9]="V",Te[Te.T=10]="T",Te[Te.LV=11]="LV",Te[Te.LVT=12]="LVT",Te[Te.ZWJ=13]="ZWJ",Te[Te.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class et{static{this._INSTANCE=null}static getInstance(){return et._INSTANCE||(et._INSTANCE=new et),et._INSTANCE}constructor(){this._data=nt()}getGraphemeBreakType(Ue){if(Ue<32)return Ue===d.CharCode.LineFeed?Ke.LF:Ue===d.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(Ue<127)return Ke.Other;const je=this._data,Ne=je.length/3;let xe=1;for(;xe<=Ne;)if(Ue<je[3*xe])xe=2*xe;else if(Ue>je[3*xe+1])xe=2*xe+1;else return je[3*xe+2];return Ke.Other}}function nt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(Te,Ue){if(Te===0)return 0;const je=rt(Te,Ue);if(je!==void 0)return je;const Ne=new Z(Ue,Te);return Ne.prevCodePoint(),Ne.offset}function rt(Te,Ue){const je=new Z(Ue,Te);let Ne=je.prevCodePoint();for(;at(Ne)||Ne===gt.emojiVariantSelector||Ne===gt.enclosingKeyCap;){if(je.offset===0)return;Ne=je.prevCodePoint()}if(!re(Ne))return;let xe=je.offset;return xe>0&&je.prevCodePoint()===gt.zwj&&(xe=je.offset),xe}function at(Te){return 127995<=Te&&Te<=127999}var gt;(function(Te){Te[Te.zwj=8205]="zwj",Te[Te.emojiVariantSelector=65039]="emojiVariantSelector",Te[Te.enclosingKeyCap=8419]="enclosingKeyCap"})(gt||(gt={})),e.noBreakWhitespace="\xA0";class ht{static{this.ambiguousCharacterData=new P.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new r.LRUCachedFunction({getCacheKey:JSON.stringify},Ue=>{function je(ut){const mt=new Map;for(let Dt=0;Dt<ut.length;Dt+=2)mt.set(ut[Dt],ut[Dt+1]);return mt}function Ne(ut,mt){const Dt=new Map(ut);for(const[Mt,Vt]of mt)Dt.set(Mt,Vt);return Dt}function xe(ut,mt){if(!ut)return mt;const Dt=new Map;for(const[Mt,Vt]of ut)mt.has(Mt)&&Dt.set(Mt,Vt);return Dt}const ue=this.ambiguousCharacterData.value;let de=Ue.filter(ut=>!ut.startsWith("_")&&ut in ue);de.length===0&&(de=["_default"]);let ce;for(const ut of de){const mt=je(ue[ut]);ce=xe(ce,mt)}const Qe=je(ue._common),tt=Ne(Qe,ce);return new ht(tt)})}static getInstance(Ue){return ht.cache.get(Array.from(Ue))}static{this._locales=new P.Lazy(()=>Object.keys(ht.ambiguousCharacterData.value).filter(Ue=>!Ue.startsWith("_")))}static getLocales(){return ht._locales.value}constructor(Ue){this.confusableDictionary=Ue}isAmbiguous(Ue){return this.confusableDictionary.has(Ue)}containsAmbiguousCharacter(Ue){for(let je=0;je<Ue.length;je++){const Ne=Ue.codePointAt(je);if(typeof Ne=="number"&&this.isAmbiguous(Ne))return!0}return!1}getPrimaryConfusable(Ue){return this.confusableDictionary.get(Ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ht;class lt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(lt.getRawData())),this._data}static isInvisibleCharacter(Ue){return lt.getData().has(Ue)}static containsInvisibleCharacter(Ue){for(let je=0;je<Ue.length;je++){const Ne=Ue.codePointAt(je);if(typeof Ne=="number"&&lt.isInvisibleCharacter(Ne))return!0}return!1}static get codePoints(){return lt.getData()}}e.InvisibleCharacters=lt}),define(Ce[31],Ie([1,0,26,16,10,12,17]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=v,e.toPosixPath=l,e.getRoot=I,e.isUNC=y,e.isValidBasename=a,e.isEqual=m,e.isEqualOrParent=p,e.isWindowsDriveLetter=f,e.sanitizeFilePath=i,e.removeTrailingPathSeparator=s,e.isRootOrDriveLetter=t,e.hasDriveLetter=o,e.getDriveLetter=n,e.indexOfPath=h,e.parseLineAndColumnAware=c,e.randomPath=D;function R(_){return _===r.CharCode.Slash||_===r.CharCode.Backslash}function v(_){return _.replace(/[\\/]/g,d.posix.sep)}function l(_){return _.indexOf("/")===-1&&(_=v(_)),/^[a-zA-Z]:(\/|$)/.test(_)&&(_="/"+_),_}function I(_,C=d.posix.sep){if(!_)return"";const A=_.length,E=_.charCodeAt(0);if(R(E)){if(R(_.charCodeAt(1))&&!R(_.charCodeAt(2))){let F=3;const N=F;for(;F<A&&!R(_.charCodeAt(F));F++);if(N!==F&&!R(_.charCodeAt(F+1))){for(F+=1;F<A;F++)if(R(_.charCodeAt(F)))return _.slice(0,F+1).replace(/[\\/]/g,C)}}return C}else if(f(E)&&_.charCodeAt(1)===r.CharCode.Colon)return R(_.charCodeAt(2))?_.slice(0,2)+C:_.slice(0,2);let S=_.indexOf("://");if(S!==-1){for(S+=3;S<A;S++)if(R(_.charCodeAt(S)))return _.slice(0,S+1)}return""}function y(_){if(!P.isWindows||!_||_.length<5)return!1;let C=_.charCodeAt(0);if(C!==r.CharCode.Backslash||(C=_.charCodeAt(1),C!==r.CharCode.Backslash))return!1;let A=2;const E=A;for(;A<_.length&&(C=_.charCodeAt(A),C!==r.CharCode.Backslash);A++);return!(E===A||(C=_.charCodeAt(A+1),isNaN(C)||C===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,T=/[/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(_,C=P.isWindows){const A=C?u:T;return!(!_||_.length===0||/^\s+$/.test(_)||(A.lastIndex=0,A.test(_))||C&&b.test(_)||_==="."||_===".."||C&&_[_.length-1]==="."||C&&_.length!==_.trim().length||_.length>255)}function m(_,C,A){const E=_===C;return!A||E?E:!_||!C?!1:(0,k.equalsIgnoreCase)(_,C)}function p(_,C,A,E=d.sep){if(_===C)return!0;if(!_||!C||C.length>_.length)return!1;if(A){if(!(0,k.startsWithIgnoreCase)(_,C))return!1;if(C.length===_.length)return!0;let F=C.length;return C.charAt(C.length-1)===E&&F--,_.charAt(F)===E}return C.charAt(C.length-1)!==E&&(C+=E),_.indexOf(C)===0}function f(_){return _>=r.CharCode.A&&_<=r.CharCode.Z||_>=r.CharCode.a&&_<=r.CharCode.z}function i(_,C){return P.isWindows&&_.endsWith(":")&&(_+=d.sep),(0,d.isAbsolute)(_)||(_=(0,d.join)(C,_)),_=(0,d.normalize)(_),s(_)}function s(_){return P.isWindows?(_=(0,k.rtrim)(_,d.sep),_.endsWith(":")&&(_+=d.sep)):(_=(0,k.rtrim)(_,d.sep),_||(_=d.sep)),_}function t(_){const C=(0,d.normalize)(_);return P.isWindows?_.length>3?!1:o(C)&&(_.length===2||C.charCodeAt(2)===r.CharCode.Backslash):C===d.posix.sep}function o(_,C=P.isWindows){return C?f(_.charCodeAt(0))&&_.charCodeAt(1)===r.CharCode.Colon:!1}function n(_,C=P.isWindows){return o(_,C)?_[0]:void 0}function h(_,C,A){return C.length>_.length?-1:_===C?0:(A&&(_=_.toLowerCase(),C=C.toLowerCase()),_.indexOf(C))}function c(_){const C=_.split(":");let A,E,S;for(const F of C){const N=Number(F);(0,L.isNumber)(N)?E===void 0?E=N:S===void 0&&(S=N):A=A?[A,F].join(":"):F}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:E!==void 0?E:void 0,column:S!==void 0?S:E!==void 0?1:void 0}}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(_,C,A=8){let E="";for(let F=0;F<A;F++){let N;F===0&&P.isWindows&&!C&&(A===3||A===4)?N=w:N=g,E+=N.charAt(Math.floor(Math.random()*N.length))}let S;return C?S=`${C}-${E}`:S=E,_?(0,d.join)(_,S):S}}),define(Ce[135],Ie([1,0,26,28,179,12]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=L,e.matchesContiguousSubString=v,e.matchesSubString=l,e.isUpper=u,e.matchesCamelCase=D,e.matchesWords=_,e.matchesFuzzy=N,e.matchesFuzzy2=O,e.anyScore=M,e.createMatches=U,e.isPatternInWord=oe,e.fuzzyScore=se,e.fuzzyScoreGracefulAggressive=ve,e.fuzzyScoreGraceful=be,k=$e(k);function L(...ke){return function(De,Pe){for(let H=0,q=ke.length;H<q;H++){const X=ke[H](De,Pe);if(X)return X}return null}}e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ke,De,Pe){if(!Pe||Pe.length<De.length)return null;let H;return ke?H=k.startsWithIgnoreCase(Pe,De):H=Pe.indexOf(De)===0,H?De.length>0?[{start:0,end:De.length}]:[]:null}function v(ke,De){const Pe=De.toLowerCase().indexOf(ke.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+ke.length}]}function l(ke,De){return I(ke.toLowerCase(),De.toLowerCase(),0,0)}function I(ke,De,Pe,H){if(Pe===ke.length)return[];if(H===De.length)return null;if(ke[Pe]===De[H]){let q=null;return(q=I(ke,De,Pe+1,H+1))?t({start:H,end:H+1},q):null}return I(ke,De,Pe,H+1)}function y(ke){return r.CharCode.a<=ke&&ke<=r.CharCode.z}function u(ke){return r.CharCode.A<=ke&&ke<=r.CharCode.Z}function T(ke){return r.CharCode.Digit0<=ke&&ke<=r.CharCode.Digit9}function b(ke){return ke===r.CharCode.Space||ke===r.CharCode.Tab||ke===r.CharCode.LineFeed||ke===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>a.add(ke.charCodeAt(0)));function m(ke){return b(ke)||a.has(ke)}function p(ke,De){return ke===De||m(ke)&&m(De)}const f=new Map;function i(ke){if(f.has(ke))return f.get(ke);let De;const Pe=(0,P.getKoreanAltChars)(ke);return Pe&&(De=Pe),f.set(ke,De),De}function s(ke){return y(ke)||u(ke)||T(ke)}function t(ke,De){return De.length===0?De=[ke]:ke.end===De[0].start?De[0].start=ke.start:De.unshift(ke),De}function o(ke,De){for(let Pe=De;Pe<ke.length;Pe++){const H=ke.charCodeAt(Pe);if(u(H)||T(H)||Pe>0&&!s(ke.charCodeAt(Pe-1)))return Pe}return ke.length}function n(ke,De,Pe,H){if(Pe===ke.length)return[];if(H===De.length)return null;if(ke[Pe]!==De[H].toLowerCase())return null;{let q=null,X=H+1;for(q=n(ke,De,Pe+1,H+1);!q&&(X=o(De,X))<De.length;)q=n(ke,De,Pe+1,X),X++;return q===null?null:t({start:H,end:H+1},q)}}function h(ke){let De=0,Pe=0,H=0,q=0,X=0;for(let Ve=0;Ve<ke.length;Ve++)X=ke.charCodeAt(Ve),u(X)&&De++,y(X)&&Pe++,s(X)&&H++,T(X)&&q++;const J=De/ke.length,he=Pe/ke.length,we=H/ke.length,Oe=q/ke.length;return{upperPercent:J,lowerPercent:he,alphaPercent:we,numericPercent:Oe}}function c(ke){const{upperPercent:De,lowerPercent:Pe}=ke;return Pe===0&&De>.6}function g(ke){const{upperPercent:De,lowerPercent:Pe,alphaPercent:H,numericPercent:q}=ke;return Pe>.2&&De<.8&&H>.6&&q<.2}function w(ke){let De=0,Pe=0,H=0,q=0;for(let X=0;X<ke.length;X++)H=ke.charCodeAt(X),u(H)&&De++,y(H)&&Pe++,b(H)&&q++;return(De===0||Pe===0)&&q===0?ke.length<=30:De<=5}function D(ke,De){if(!De||(De=De.trim(),De.length===0)||!w(ke))return null;De.length>60&&(De=De.substring(0,60));const Pe=h(De);if(!g(Pe)){if(!c(Pe))return null;De=De.toLowerCase()}let H=null,q=0;for(ke=ke.toLowerCase();q<De.length&&(H=n(ke,De,0,q))===null;)q=o(De,q+1);return H}function _(ke,De,Pe=!1){if(!De||De.length===0)return null;let H=null,q=0;for(ke=ke.toLowerCase(),De=De.toLowerCase();q<De.length&&(H=C(ke,De,0,q,Pe),H===null);)q=A(De,q+1);return H}function C(ke,De,Pe,H,q){let X=0;if(Pe===ke.length)return[];if(H===De.length)return null;if(!p(ke.charCodeAt(Pe),De.charCodeAt(H))){const we=i(ke.charCodeAt(Pe));if(!we)return null;for(let Oe=0;Oe<we.length;Oe++)if(!p(we[Oe],De.charCodeAt(H+Oe)))return null;X+=we.length-1}let J=null,he=H+X+1;if(J=C(ke,De,Pe+1,he,q),!q)for(;!J&&(he=A(De,he))<De.length;)J=C(ke,De,Pe+1,he,q),he++;if(!J)return null;if(ke.charCodeAt(Pe)!==De.charCodeAt(H)){const we=i(ke.charCodeAt(Pe));if(!we)return J;for(let Oe=0;Oe<we.length;Oe++)if(we[Oe]!==De.charCodeAt(H+Oe))return J}return t({start:H,end:H+X+1},J)}function A(ke,De){for(let Pe=De;Pe<ke.length;Pe++)if(m(ke.charCodeAt(Pe))||Pe>0&&m(ke.charCodeAt(Pe-1)))return Pe;return ke.length}const E=L(e.matchesPrefix,D,v),S=L(e.matchesPrefix,D,l),F=new d.LRUCache(1e4);function N(ke,De,Pe=!1){if(typeof ke!="string"||typeof De!="string")return null;let H=F.get(ke);H||(H=new RegExp(k.convertSimple2RegExpPattern(ke),"i"),F.set(ke,H));const q=H.exec(De);return q?[{start:q.index,end:q.index+q[0].length}]:Pe?S(ke,De):E(ke,De)}function O(ke,De){const Pe=se(ke,ke.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Pe?U(Pe):null}function M(ke,De,Pe,H,q,X){const J=Math.min(13,ke.length);for(;Pe<J;Pe++){const he=se(ke,De,Pe,H,q,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(he)return he}return[0,X]}function U(ke){if(typeof ke>"u")return[];const De=[],Pe=ke[1];for(let H=ke.length-1;H>1;H--){const q=ke[H]+Pe,X=De[De.length-1];X&&X.end===q?X.end=q+1:De.push({start:q,end:q+1})}return De}const x=128;function z(){const ke=[],De=[];for(let Pe=0;Pe<=x;Pe++)De[Pe]=0;for(let Pe=0;Pe<=x;Pe++)ke.push(De.slice(0));return ke}function B(ke){const De=[];for(let Pe=0;Pe<=ke;Pe++)De[Pe]=0;return De}const ee=B(2*x),V=B(2*x),$=z(),G=z(),Z=z(),le=!1;function ne(ke,De,Pe,H,q){function X(he,we,Oe=" "){for(;he.length<we;)he=Oe+he;return he}let J=` |   |${H.split("").map(he=>X(he,3)).join("|")}
`;for(let he=0;he<=Pe;he++)he===0?J+=" |":J+=`${De[he-1]}|`,J+=ke[he].slice(0,q+1).map(we=>X(we.toString(),3)).join("|")+`
`;return J}function _e(ke,De,Pe,H){ke=ke.substr(De),Pe=Pe.substr(H),console.log(ne(G,ke,ke.length,Pe,Pe.length)),console.log(ne(Z,ke,ke.length,Pe,Pe.length)),console.log(ne($,ke,ke.length,Pe,Pe.length))}function ge(ke,De){if(De<0||De>=ke.length)return!1;const Pe=ke.codePointAt(De);switch(Pe){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Pe)}}function Y(ke,De){if(De<0||De>=ke.length)return!1;switch(ke.charCodeAt(De)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function W(ke,De,Pe){return De[ke]!==Pe[ke]}function oe(ke,De,Pe,H,q,X,J=!1){for(;De<Pe&&q<X;)ke[De]===H[q]&&(J&&(ee[De]=q),De+=1),q+=1;return De===Pe}var Se;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var te;(function(ke){ke.Default=[-100,0];function De(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}ke.isDefault=De})(te||(e.FuzzyScore=te={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Pe){this.firstMatchCanBeWeak=De,this.boostFullMatch=Pe}}e.FuzzyScoreOptions=ae;function se(ke,De,Pe,H,q,X,J=ae.default){const he=ke.length>x?x:ke.length,we=H.length>x?x:H.length;if(Pe>=he||X>=we||he-Pe>we-X||!oe(De,Pe,he,q,X,we,!0))return;Q(he,we,Pe,X,De,q);let Oe=1,Ve=1,Ke=Pe,et=X;const nt=[!1];for(Oe=1,Ke=Pe;Ke<he;Oe++,Ke++){const ht=ee[Ke],lt=V[Ke],Te=Ke+1<he?V[Ke+1]:we;for(Ve=ht-X+1,et=ht;et<Te;Ve++,et++){let Ue=Number.MIN_SAFE_INTEGER,je=!1;et<=lt&&(Ue=re(ke,De,Ke,Pe,H,q,et,we,X,$[Oe-1][Ve-1]===0,nt));let Ne=0;Ue!==Number.MAX_SAFE_INTEGER&&(je=!0,Ne=Ue+G[Oe-1][Ve-1]);const xe=et>ht,ue=xe?G[Oe][Ve-1]+($[Oe][Ve-1]>0?-5:0):0,de=et>ht+1&&$[Oe][Ve-1]>0,ce=de?G[Oe][Ve-2]+($[Oe][Ve-2]>0?-5:0):0;if(de&&(!xe||ce>=ue)&&(!je||ce>=Ne))G[Oe][Ve]=ce,Z[Oe][Ve]=Se.LeftLeft,$[Oe][Ve]=0;else if(xe&&(!je||ue>=Ne))G[Oe][Ve]=ue,Z[Oe][Ve]=Se.Left,$[Oe][Ve]=0;else if(je)G[Oe][Ve]=Ne,Z[Oe][Ve]=Se.Diag,$[Oe][Ve]=$[Oe-1][Ve-1]+1;else throw new Error("not possible")}}if(le&&_e(ke,Pe,H,X),!nt[0]&&!J.firstMatchCanBeWeak)return;Oe--,Ve--;const st=[G[Oe][Ve],X];let rt=0,at=0;for(;Oe>=1;){let ht=Ve;do{const lt=Z[Oe][ht];if(lt===Se.LeftLeft)ht=ht-2;else if(lt===Se.Left)ht=ht-1;else break}while(ht>=1);rt>1&&De[Pe+Oe-1]===q[X+Ve-1]&&!W(ht+X-1,H,q)&&rt+1>$[Oe][ht]&&(ht=Ve),ht===Ve?rt++:rt=1,at||(at=ht),Oe--,Ve=ht-1,st.push(Ve)}we-X===he&&J.boostFullMatch&&(st[0]+=2);const gt=at-he;return st[0]-=gt,st}function Q(ke,De,Pe,H,q,X){let J=ke-1,he=De-1;for(;J>=Pe&&he>=H;)q[J]===X[he]&&(V[J]=he,J--),he--}function re(ke,De,Pe,H,q,X,J,he,we,Oe,Ve){if(De[Pe]!==X[J])return Number.MIN_SAFE_INTEGER;let Ke=1,et=!1;return J===Pe-H?Ke=ke[Pe]===q[J]?7:5:W(J,q,X)&&(J===0||!W(J-1,q,X))?(Ke=ke[Pe]===q[J]?7:5,et=!0):ge(X,J)&&(J===0||!ge(X,J-1))?Ke=5:(ge(X,J-1)||Y(X,J-1))&&(Ke=5,et=!0),Ke>1&&Pe===H&&(Ve[0]=!0),et||(et=W(J,q,X)||ge(X,J-1)||Y(X,J-1)),Pe===H?J>we&&(Ke-=et?3:5):Oe?Ke+=et?2:0:Ke+=et?0:1,J+1===he&&(Ke-=et?3:5),Ke}function ve(ke,De,Pe,H,q,X,J){return Fe(ke,De,Pe,H,q,X,!0,J)}function be(ke,De,Pe,H,q,X,J){return Fe(ke,De,Pe,H,q,X,!1,J)}function Fe(ke,De,Pe,H,q,X,J,he){let we=se(ke,De,Pe,H,q,X,he);if(we&&!J)return we;if(ke.length>=3){const Oe=Math.min(7,ke.length-1);for(let Ve=Pe+1;Ve<Oe;Ve++){const Ke=Be(ke,Ve);if(Ke){const et=se(Ke,Ke.toLowerCase(),Pe,H,q,X,he);et&&(et[0]-=3,(!we||et[0]>we[0])&&(we=et))}}}return we}function Be(ke,De){if(De+1>=ke.length)return;const Pe=ke[De],H=ke[De+1];if(Pe!==H)return ke.slice(0,De)+H+Pe+ke.slice(De+2)}}),define(Ce[60],Ie([1,0,12]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=d,e.doHash=P,e.numberHash=k,e.stringHash=R,e.toHexString=a,r=$e(r);function d(p){return P(p,0)}function P(p,f){switch(typeof p){case"object":return p===null?k(349,f):Array.isArray(p)?v(p,f):l(p,f);case"string":return R(p,f);case"boolean":return L(p,f);case"number":return k(p,f);case"undefined":return k(937,f);default:return k(617,f)}}function k(p,f){return(f<<5)-f+p|0}function L(p,f){return k(p?433:863,f)}function R(p,f){f=k(149417,f);for(let i=0,s=p.length;i<s;i++)f=k(p.charCodeAt(i),f);return f}function v(p,f){return f=k(104579,f),p.reduce((i,s)=>P(s,i),f)}function l(p,f){return f=k(181387,f),Object.keys(p).sort().reduce((i,s)=>(i=R(s,i),P(p[s],i)),f)}class I{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=P(f,this._value),this._value}}e.Hasher=I;var y;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function u(p,f,i=32){const s=i-f,t=~((1<<s)-1);return(p<<f|(t&p)>>>s)>>>0}function T(p,f=0,i=p.byteLength,s=0){for(let t=0;t<i;t++)p[f+t]=s}function b(p,f,i="0"){for(;p.length<f;)p=i+p;return p}function a(p,f=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(i=>i.toString(16).padStart(2,"0")).join(""):b((p>>>0).toString(16),f/4)}class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(y.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const i=f.length;if(i===0)return;const s=this._buff;let t=this._buffLen,o=this._leftoverHighSurrogate,n,h;for(o!==0?(n=o,h=-1,o=0):(n=f.charCodeAt(0),h=0);;){let c=n;if(r.isHighSurrogate(n))if(h+1<i){const g=f.charCodeAt(h+1);r.isLowSurrogate(g)?(h++,c=r.computeCodePoint(n,g)):c=y.UNICODE_REPLACEMENT}else{o=n;break}else r.isLowSurrogate(n)&&(c=y.UNICODE_REPLACEMENT);if(t=this._push(s,t,c),h++,h<i)n=f.charCodeAt(h);else break}this._buffLen=t,this._leftoverHighSurrogate=o}_push(f,i,s){return s<128?f[i++]=s:s<2048?(f[i++]=192|(s&1984)>>>6,f[i++]=128|(s&63)>>>0):s<65536?(f[i++]=224|(s&61440)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0):(f[i++]=240|(s&1835008)>>>18,f[i++]=128|(s&258048)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0),i>=y.BLOCK_SIZE&&(this._step(),i-=y.BLOCK_SIZE,this._totalLen+=y.BLOCK_SIZE,f[0]=f[y.BLOCK_SIZE+0],f[1]=f[y.BLOCK_SIZE+1],f[2]=f[y.BLOCK_SIZE+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,y.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=m._bigBlock32,i=this._buffDV;for(let D=0;D<64;D+=4)f.setUint32(D,i.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)f.setUint32(D,u(f.getUint32(D-12,!1)^f.getUint32(D-32,!1)^f.getUint32(D-56,!1)^f.getUint32(D-64,!1),1),!1);let s=this._h0,t=this._h1,o=this._h2,n=this._h3,h=this._h4,c,g,w;for(let D=0;D<80;D++)D<20?(c=t&o|~t&n,g=1518500249):D<40?(c=t^o^n,g=1859775393):D<60?(c=t&o|t&n|o&n,g=2400959708):(c=t^o^n,g=3395469782),w=u(s,5)+c+h+g+f.getUint32(D*4,!1)&4294967295,h=n,n=o,o=u(t,30),t=s,s=w;this._h0=this._h0+s&4294967295,this._h1=this._h1+t&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+h&4294967295}}e.StringSHA1=m}),define(Ce[136],Ie([1,0,26,134,135,60,16,10,12]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.scoreFuzzy=y,e.scoreFuzzy2=p,e.scoreItemFuzzy=c,e.compareItemsByFuzzyScore=E,e.prepareQuery=U,e.pieceToQuery=z;const l=0,I=[l,[]];function y(B,ee,V,$){if(!B||!ee)return I;const G=B.length,Z=ee.length;if(G<Z)return I;const le=B.toLowerCase();return u(ee,V,Z,B,le,G,$)}function u(B,ee,V,$,G,Z,le){const ne=[],_e=[];for(let oe=0;oe<V;oe++){const Se=oe*Z,te=Se-Z,ae=oe>0,se=B[oe],Q=ee[oe];for(let re=0;re<Z;re++){const ve=re>0,be=Se+re,Fe=be-1,Be=te+re-1,ke=ve?ne[Fe]:0,De=ae&&ve?ne[Be]:0,Pe=ae&&ve?_e[Be]:0;let H;!De&&ae?H=0:H=T(se,Q,$,G,re,Pe),H&&De+H>=ke&&(le||ae||G.startsWith(ee,re))?(_e[be]=Pe+1,ne[be]=De+H):(_e[be]=l,ne[be]=ke)}}const ge=[];let Y=V-1,W=Z-1;for(;Y>=0&&W>=0;){const oe=Y*Z+W;_e[oe]===l||(ge.push(W),Y--),W--}return[ne[V*Z-1],ge.reverse()]}function T(B,ee,V,$,G,Z){let le=0;if(!b(ee,$[G]))return le;if(le+=1,Z>0&&(le+=Z*5),B===V[G]&&(le+=1),G===0)le+=8;else{const ne=a(V.charCodeAt(G-1));ne?le+=ne:(0,P.isUpper)(V.charCodeAt(G))&&Z===0&&(le+=2)}return le}function b(B,ee){return B===ee?!0:B==="/"||B==="\\"?ee==="/"||ee==="\\":!1}function a(B){switch(B){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function p(B,ee,V=0,$=0){const G=ee;return G.values&&G.values.length>1?f(B,G.values,V,$):i(B,ee,V,$)}function f(B,ee,V,$){let G=0;const Z=[];for(const le of ee){const[ne,_e]=i(B,le,V,$);if(typeof ne!="number")return m;G+=ne,Z.push(..._e)}return[G,C(Z)]}function i(B,ee,V,$){const G=(0,P.fuzzyScore)(ee.original,ee.originalLowercase,V,B,B.toLowerCase(),$,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?[G[0],(0,P.createMatches)(G)]:m}const s=Object.freeze({score:0}),t=1<<18,o=1<<17,n=65536;function h(B,ee,V,$){const G=$.values?$.values:[$];return(0,k.hash)({[$.normalized]:{values:G.map(le=>({value:le.normalized,expectContiguousMatch:le.expectContiguousMatch})),label:B,description:ee,allowNonContiguousMatches:V}})}function c(B,ee,V,$,G){if(!B||!ee.normalized)return s;const Z=$.getItemLabel(B);if(!Z)return s;const le=$.getItemDescription(B),ne=h(Z,le,V,ee),_e=G[ne];if(_e)return _e;const ge=g(Z,le,$.getItemPath(B),ee,V);return G[ne]=ge,ge}function g(B,ee,V,$,G){const Z=!V||!$.containsPathSeparator;return V&&(R.isLinux?$.pathNormalized===V:(0,v.equalsIgnoreCase)($.pathNormalized,V))?{score:t,labelMatch:[{start:0,end:B.length}],descriptionMatch:ee?[{start:0,end:ee.length}]:void 0}:$.values&&$.values.length>1?w(B,ee,V,$.values,Z,G):D(B,ee,V,$,Z,G)}function w(B,ee,V,$,G,Z){let le=0;const ne=[],_e=[];for(const ge of $){const{score:Y,labelMatch:W,descriptionMatch:oe}=D(B,ee,V,ge,G,Z);if(Y===l)return s;le+=Y,W&&ne.push(...W),oe&&_e.push(...oe)}return{score:le,labelMatch:C(ne),descriptionMatch:C(_e)}}function D(B,ee,V,$,G,Z){if(G||!ee){const[le,ne]=y(B,$.normalized,$.normalizedLowercase,Z&&!$.expectContiguousMatch);if(le){const _e=(0,P.matchesPrefix)($.normalized,B);let ge;if(_e){ge=o;const Y=Math.round($.normalized.length/B.length*100);ge+=Y}else ge=n;return{score:ge+le,labelMatch:_e||_(ne)}}}if(ee){let le=ee;V&&(le=`${ee}${L.sep}`);const ne=le.length,_e=`${le}${B}`,[ge,Y]=y(_e,$.normalized,$.normalizedLowercase,Z&&!$.expectContiguousMatch);if(ge){const W=_(Y),oe=[],Se=[];return W.forEach(te=>{te.start<ne&&te.end>ne?(oe.push({start:0,end:te.end-ne}),Se.push({start:te.start,end:ne})):te.start>=ne?oe.push({start:te.start-ne,end:te.end-ne}):Se.push(te)}),{score:ge,labelMatch:oe,descriptionMatch:Se}}}return s}function _(B){const ee=[];if(!B)return ee;let V;for(const $ of B)V&&V.end===$?V.end+=1:(V={start:$,end:$+1},ee.push(V));return ee}function C(B){const ee=B.sort((G,Z)=>G.start-Z.start),V=[];let $;for(const G of ee)!$||!A($,G)?($=G,V.push(G)):($.start=Math.min($.start,G.start),$.end=Math.max($.end,G.end));return V}function A(B,ee){return!(B.end<ee.start||ee.end<B.start)}function E(B,ee,V,$,G,Z){const le=c(B,V,$,G,Z),ne=c(ee,V,$,G,Z),_e=le.score,ge=ne.score;if((_e===t||ge===t)&&_e!==ge)return _e===t?-1:1;if(_e>n||ge>n){if(_e!==ge)return _e>ge?-1:1;if(_e<o&&ge<o){const se=F(le.labelMatch,ne.labelMatch);if(se!==0)return se}const te=G.getItemLabel(B)||"",ae=G.getItemLabel(ee)||"";if(te.length!==ae.length)return te.length-ae.length}if(_e!==ge)return _e>ge?-1:1;const Y=Array.isArray(le.labelMatch)&&le.labelMatch.length>0,W=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(Y&&!W)return-1;if(W&&!Y)return 1;const oe=S(B,le,G),Se=S(ee,ne,G);return oe&&Se&&oe!==Se?Se>oe?-1:1:N(B,ee,V,G)}function S(B,ee,V){let $=-1,G=-1;if(ee.descriptionMatch&&ee.descriptionMatch.length?$=ee.descriptionMatch[0].start:ee.labelMatch&&ee.labelMatch.length&&($=ee.labelMatch[0].start),ee.labelMatch&&ee.labelMatch.length){if(G=ee.labelMatch[ee.labelMatch.length-1].end,ee.descriptionMatch&&ee.descriptionMatch.length){const Z=V.getItemDescription(B);Z&&(G+=Z.length)}}else ee.descriptionMatch&&ee.descriptionMatch.length&&(G=ee.descriptionMatch[ee.descriptionMatch.length-1].end);return G-$}function F(B,ee){if(!B&&!ee||(!B||!B.length)&&(!ee||!ee.length))return 0;if(!ee||!ee.length)return-1;if(!B||!B.length)return 1;const V=B[0].start,G=B[B.length-1].end-V,Z=ee[0].start,ne=ee[ee.length-1].end-Z;return G===ne?0:ne<G?1:-1}function N(B,ee,V,$){const G=$.getItemLabel(B)||"",Z=$.getItemLabel(ee)||"",le=$.getItemDescription(B),ne=$.getItemDescription(ee),_e=G.length+(le?le.length:0),ge=Z.length+(ne?ne.length:0);if(_e!==ge)return _e-ge;const Y=$.getItemPath(B),W=$.getItemPath(ee);return Y&&W&&Y.length!==W.length?Y.length-W.length:G!==Z?(0,d.compareAnything)(G,Z,V.normalized):le&&ne&&le!==ne?(0,d.compareAnything)(le,ne,V.normalized):Y&&W&&Y!==W?(0,d.compareAnything)(Y,W,V.normalized):0}function O(B){return B.startsWith('"')&&B.endsWith('"')}const M=" ";function U(B){typeof B!="string"&&(B="");const ee=B.toLowerCase(),{pathNormalized:V,normalized:$,normalizedLowercase:G}=x(B),Z=V.indexOf(L.sep)>=0,le=O(B);let ne;const _e=B.split(M);if(_e.length>1)for(const ge of _e){const Y=O(ge),{pathNormalized:W,normalized:oe,normalizedLowercase:Se}=x(ge);oe&&(ne||(ne=[]),ne.push({original:ge,originalLowercase:ge.toLowerCase(),pathNormalized:W,normalized:oe,normalizedLowercase:Se,expectContiguousMatch:Y}))}return{original:B,originalLowercase:ee,pathNormalized:V,normalized:$,normalizedLowercase:G,values:ne,containsPathSeparator:Z,expectContiguousMatch:le}}function x(B){let ee;R.isWindows?ee=B.replace(/\//g,L.sep):ee=B.replace(/\\/g,L.sep);const V=(0,v.stripWildcards)(ee).replace(/\s|"/g,"");return{pathNormalized:ee,normalized:V,normalizedLowercase:V.toLowerCase()}}function z(B){return Array.isArray(B)?U(B.map(ee=>ee.original).join(M)):U(B.original)}}),define(Ce[137],Ie([1,0,135,12,51]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=v,e.markdownEscapeEscapedIcons=I,e.stripIcons=u,e.getCodiconAriaLabel=T,e.parseLabelWithIcons=a,e.matchesFuzzyIconAware=m;const k="$(",L=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${L.source}`,"g");function v(p){return p.replace(R,(f,i)=>i?f:`\\${f}`)}const l=new RegExp(`\\\\${L.source}`,"g");function I(p){return p.replace(l,f=>`\\${f}`)}const y=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function u(p){return p.indexOf(k)===-1?p:p.replace(y,(f,i,s,t)=>s?f:i||t||"")}function T(p){return p?p.replace(/\$\((.*?)\)/g,(f,i)=>` ${i} `).trim():""}const b=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(p){b.lastIndex=0;let f="";const i=[];let s=0;for(;;){const t=b.lastIndex,o=b.exec(p),n=p.substring(t,o?.index);if(n.length>0){f+=n;for(let h=0;h<n.length;h++)i.push(s)}if(!o)break;s+=o[0].length}return{text:f,iconOffsets:i}}function m(p,f,i=!1){const{text:s,iconOffsets:t}=f;if(!t||t.length===0)return(0,r.matchesFuzzy)(p,s,i);const o=(0,d.ltrim)(s," "),n=s.length-o.length,h=(0,r.matchesFuzzy)(p,o,i);if(h)for(const c of h){const g=t[c.start+n]+n;c.start+=g,c.end+=g}return h}}),define(Ce[43],Ie([1,0,12]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=$e(r);var d;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(d||(d={})),function(P){const k="error",L="warning",R="warn",v="info",l="ignore";function I(u){return u?r.equalsIgnoreCase(k,u)?P.Error:r.equalsIgnoreCase(L,u)||r.equalsIgnoreCase(R,u)?P.Warning:r.equalsIgnoreCase(v,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function y(u){switch(u){case P.Error:return k;case P.Warning:return L;case P.Info:return v;default:return l}}P.toString=y}(d||(d={})),e.default=d}),define(Ce[84],Ie([1,0,18,26,12]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this._value="",this._pos=0}reset(b){return this._value=b,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(b){const a=b.charCodeAt(0),m=this._value.charCodeAt(this._pos);return a-m}value(){return this._value[this._pos]}}e.StringIterator=k;class L{constructor(b=!0){this._caseSensitive=b}reset(b){return this._value=b,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let b=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===d.CharCode.Period)if(b)this._from++;else break;else b=!1;return this}cmp(b){return this._caseSensitive?(0,P.compareSubstring)(b,this._value,0,b.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(b,this._value,0,b.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class R{constructor(b=!0,a=!0){this._splitOnBackslash=b,this._caseSensitive=a}reset(b){this._from=0,this._to=0,this._value=b,this._valueLen=b.length;for(let a=b.length-1;a>=0;a--,this._valueLen--){const m=this._value.charCodeAt(a);if(!(m===d.CharCode.Slash||this._splitOnBackslash&&m===d.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let b=!0;for(;this._to<this._valueLen;this._to++){const a=this._value.charCodeAt(this._to);if(a===d.CharCode.Slash||this._splitOnBackslash&&a===d.CharCode.Backslash)if(b)this._from++;else break;else b=!1}return this}cmp(b){return this._caseSensitive?(0,P.compareSubstring)(b,this._value,0,b.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(b,this._value,0,b.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var v;(function(T){T[T.Scheme=1]="Scheme",T[T.Authority=2]="Authority",T[T.Path=3]="Path",T[T.Query=4]="Query",T[T.Fragment=5]="Fragment"})(v||(v={}));class l{constructor(b,a){this._ignorePathCasing=b,this._ignoreQueryAndFragment=a,this._states=[],this._stateIdx=0}reset(b){return this._value=b,this._states=[],this._value.scheme&&this._states.push(v.Scheme),this._value.authority&&this._states.push(v.Authority),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(b)),this._pathIterator.reset(b.path),this._pathIterator.value()&&this._states.push(v.Path)),this._ignoreQueryAndFragment(b)||(this._value.query&&this._states.push(v.Query),this._value.fragment&&this._states.push(v.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===v.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(b){if(this._states[this._stateIdx]===v.Scheme)return(0,P.compareIgnoreCase)(b,this._value.scheme);if(this._states[this._stateIdx]===v.Authority)return(0,P.compareIgnoreCase)(b,this._value.authority);if(this._states[this._stateIdx]===v.Path)return this._pathIterator.cmp(b);if(this._states[this._stateIdx]===v.Query)return(0,P.compare)(b,this._value.query);if(this._states[this._stateIdx]===v.Fragment)return(0,P.compare)(b,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===v.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===v.Authority)return this._value.authority;if(this._states[this._stateIdx]===v.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===v.Query)return this._value.query;if(this._states[this._stateIdx]===v.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=l;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(T){T[T.Left=-1]="Left",T[T.Mid=0]="Mid",T[T.Right=1]="Right"})(y||(y={}));class u{static forUris(b=()=>!1,a=()=>!1){return new u(new l(b,a))}static forPaths(b=!1){return new u(new R(void 0,!b))}static forStrings(){return new u(new k)}static forConfigKeys(){return new u(new L)}constructor(b){this._iter=b}clear(){this._root=void 0}fill(b,a){if(a){const m=a.slice(0);(0,r.shuffle)(m);for(const p of m)this.set(p,b)}else{const m=b.slice(0);(0,r.shuffle)(m);for(const p of m)this.set(p[0],p[1])}}set(b,a){const m=this._iter.reset(b);let p;this._root||(this._root=new I,this._root.segment=m.value());const f=[];for(p=this._root;;){const s=m.cmp(p.segment);if(s>0)p.left||(p.left=new I,p.left.segment=m.value()),f.push([y.Left,p]),p=p.left;else if(s<0)p.right||(p.right=new I,p.right.segment=m.value()),f.push([y.Right,p]),p=p.right;else if(m.hasNext())m.next(),p.mid||(p.mid=new I,p.mid.segment=m.value()),f.push([y.Mid,p]),p=p.mid;else break}const i=p.value;p.value=a,p.key=b;for(let s=f.length-1;s>=0;s--){const t=f[s][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const n=f[s][0],h=f[s+1][0];if(n===y.Right&&h===y.Right)f[s][1]=t.rotateLeft();else if(n===y.Left&&h===y.Left)f[s][1]=t.rotateRight();else if(n===y.Right&&h===y.Left)t.right=f[s+1][1]=f[s+1][1].rotateRight(),f[s][1]=t.rotateLeft();else if(n===y.Left&&h===y.Right)t.left=f[s+1][1]=f[s+1][1].rotateLeft(),f[s][1]=t.rotateRight();else throw new Error;if(s>0)switch(f[s-1][0]){case y.Left:f[s-1][1].left=f[s][1];break;case y.Right:f[s-1][1].right=f[s][1];break;case y.Mid:f[s-1][1].mid=f[s][1];break}else this._root=f[0][1]}}return i}get(b){return this._getNode(b)?.value}_getNode(b){const a=this._iter.reset(b);let m=this._root;for(;m;){const p=a.cmp(m.segment);if(p>0)m=m.left;else if(p<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else break}return m}has(b){const a=this._getNode(b);return!(a?.value===void 0&&a?.mid===void 0)}delete(b){return this._delete(b,!1)}deleteSuperstr(b){return this._delete(b,!0)}_delete(b,a){const m=this._iter.reset(b),p=[];let f=this._root;for(;f;){const i=m.cmp(f.segment);if(i>0)p.push([y.Left,f]),f=f.left;else if(i<0)p.push([y.Right,f]),f=f.right;else if(m.hasNext())m.next(),p.push([y.Mid,f]),f=f.mid;else break}if(f){if(a?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const i=this._min(f.right);if(i.key){const{key:s,value:t,segment:o}=i;this._delete(i.key,!1),f.key=s,f.value=t,f.segment=o}}else{const i=f.left??f.right;if(p.length>0){const[s,t]=p[p.length-1];switch(s){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this._root=i}for(let i=p.length-1;i>=0;i--){const s=p[i][1];s.updateHeight();const t=s.balanceFactor();if(t>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),p[i][1]=s.rotateLeft()):t<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),p[i][1]=s.rotateRight()),i>0)switch(p[i-1][0]){case y.Left:p[i-1][1].left=p[i][1];break;case y.Right:p[i-1][1].right=p[i][1];break;case y.Mid:p[i-1][1].mid=p[i][1];break}else this._root=p[0][1]}}}_min(b){for(;b.left;)b=b.left;return b}findSubstr(b){const a=this._iter.reset(b);let m=this._root,p;for(;m;){const f=a.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(a.hasNext())a.next(),p=m.value||p,m=m.mid;else break}return m&&m.value||p}findSuperstr(b){return this._findSuperstrOrElement(b,!1)}_findSuperstrOrElement(b,a){const m=this._iter.reset(b);let p=this._root;for(;p;){const f=m.cmp(p.segment);if(f>0)p=p.left;else if(f<0)p=p.right;else if(m.hasNext())m.next(),p=p.mid;else return p.mid?this._entries(p.mid):a?p.value:void 0}}hasElementOrSubtree(b){return this._findSuperstrOrElement(b,!0)!==void 0}forEach(b){for(const[a,m]of this)b(m,a)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(b){const a=[];return this._dfsEntries(b,a),a[Symbol.iterator]()}_dfsEntries(b,a){b&&(b.left&&this._dfsEntries(b.left,a),b.value&&a.push([b.key,b.value]),b.mid&&this._dfsEntries(b.mid,a),b.right&&this._dfsEntries(b.right,a))}_isBalanced(){const b=a=>{if(!a)return!0;const m=a.balanceFactor();return m<-1||m>1?!1:b(a.left)&&b(a.right)};return b(this._root)}}e.TernarySearchTree=u}),define(Ce[2],Ie([1,0,26,40,16,10]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=m,e.uriToFsPath=o,P=$e(P);const L=/^\w[\w\d+.-]*$/,R=/^\//,v=/^\/\//;function l(w,D){if(!w.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${w.authority}", path: "${w.path}", query: "${w.query}", fragment: "${w.fragment}"}`);if(w.scheme&&!L.test(w.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(w.path){if(w.authority){if(!R.test(w.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(w.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(w,D){return!w&&!D?"file":w}function y(w,D){switch(w){case"https":case"http":case"file":D?D[0]!==T&&(D=T+D):D=T;break}return D}const u="",T="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(D){return D instanceof a?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,_,C,A,E,S=!1){typeof D=="object"?(this.scheme=D.scheme||u,this.authority=D.authority||u,this.path=D.path||u,this.query=D.query||u,this.fragment=D.fragment||u):(this.scheme=I(D,S),this.authority=_||u,this.path=y(this.scheme,C||u),this.query=A||u,this.fragment=E||u,l(this,S))}get fsPath(){return o(this,!1)}with(D){if(!D)return this;let{scheme:_,authority:C,path:A,query:E,fragment:S}=D;return _===void 0?_=this.scheme:_===null&&(_=u),C===void 0?C=this.authority:C===null&&(C=u),A===void 0?A=this.path:A===null&&(A=u),E===void 0?E=this.query:E===null&&(E=u),S===void 0?S=this.fragment:S===null&&(S=u),_===this.scheme&&C===this.authority&&A===this.path&&E===this.query&&S===this.fragment?this:new f(_,C,A,E,S)}static parse(D,_=!1){const C=b.exec(D);return C?new f(C[2]||u,g(C[4]||u),g(C[5]||u),g(C[7]||u),g(C[9]||u),_):new f(u,u,u,u,u)}static file(D){let _=u;if(k.isWindows&&(D=D.replace(/\\/g,T)),D[0]===T&&D[1]===T){const C=D.indexOf(T,2);C===-1?(_=D.substring(2),D=T):(_=D.substring(2,C),D=D.substring(C)||T)}return new f("file",_,D,u,u)}static from(D,_){return new f(D.scheme,D.authority,D.path,D.query,D.fragment,_)}static joinPath(D,..._){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return k.isWindows&&D.scheme==="file"?C=a.file(P.win32.join(o(D,!0),..._)).path:C=P.posix.join(D.path,..._),D.with({path:C})}toString(D=!1){return n(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof a)return D;{const _=new f(D);return _._formatted=D.external??null,_._fsPath=D._sep===p?D.fsPath??null:null,_}}else return D}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=a;function m(w){return!w||typeof w!="object"?!1:typeof w.scheme=="string"&&(typeof w.authority=="string"||typeof w.authority>"u")&&(typeof w.path=="string"||typeof w.path>"u")&&(typeof w.query=="string"||typeof w.query>"u")&&(typeof w.fragment=="string"||typeof w.fragment>"u")}const p=k.isWindows?1:void 0;class f extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(D=!1){return D?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const D={$mid:d.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=p),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const i={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function s(w,D,_){let C,A=-1;for(let E=0;E<w.length;E++){const S=w.charCodeAt(E);if(S>=r.CharCode.a&&S<=r.CharCode.z||S>=r.CharCode.A&&S<=r.CharCode.Z||S>=r.CharCode.Digit0&&S<=r.CharCode.Digit9||S===r.CharCode.Dash||S===r.CharCode.Period||S===r.CharCode.Underline||S===r.CharCode.Tilde||D&&S===r.CharCode.Slash||_&&S===r.CharCode.OpenSquareBracket||_&&S===r.CharCode.CloseSquareBracket||_&&S===r.CharCode.Colon)A!==-1&&(C+=encodeURIComponent(w.substring(A,E)),A=-1),C!==void 0&&(C+=w.charAt(E));else{C===void 0&&(C=w.substr(0,E));const F=i[S];F!==void 0?(A!==-1&&(C+=encodeURIComponent(w.substring(A,E)),A=-1),C+=F):A===-1&&(A=E)}}return A!==-1&&(C+=encodeURIComponent(w.substring(A))),C!==void 0?C:w}function t(w){let D;for(let _=0;_<w.length;_++){const C=w.charCodeAt(_);C===r.CharCode.Hash||C===r.CharCode.QuestionMark?(D===void 0&&(D=w.substr(0,_)),D+=i[C]):D!==void 0&&(D+=w[_])}return D!==void 0?D:w}function o(w,D){let _;return w.authority&&w.path.length>1&&w.scheme==="file"?_=`//${w.authority}${w.path}`:w.path.charCodeAt(0)===r.CharCode.Slash&&(w.path.charCodeAt(1)>=r.CharCode.A&&w.path.charCodeAt(1)<=r.CharCode.Z||w.path.charCodeAt(1)>=r.CharCode.a&&w.path.charCodeAt(1)<=r.CharCode.z)&&w.path.charCodeAt(2)===r.CharCode.Colon?D?_=w.path.substr(1):_=w.path[1].toLowerCase()+w.path.substr(2):_=w.path,k.isWindows&&(_=_.replace(/\//g,"\\")),_}function n(w,D){const _=D?t:s;let C="",{scheme:A,authority:E,path:S,query:F,fragment:N}=w;if(A&&(C+=A,C+=":"),(E||A==="file")&&(C+=T,C+=T),E){let O=E.indexOf("@");if(O!==-1){const M=E.substr(0,O);E=E.substr(O+1),O=M.lastIndexOf(":"),O===-1?C+=_(M,!1,!1):(C+=_(M.substr(0,O),!1,!1),C+=":",C+=_(M.substr(O+1),!1,!0)),C+="@"}E=E.toLowerCase(),O=E.lastIndexOf(":"),O===-1?C+=_(E,!1,!0):(C+=_(E.substr(0,O),!1,!0),C+=E.substr(O))}if(S){if(S.length>=3&&S.charCodeAt(0)===r.CharCode.Slash&&S.charCodeAt(2)===r.CharCode.Colon){const O=S.charCodeAt(1);O>=r.CharCode.A&&O<=r.CharCode.Z&&(S=`/${String.fromCharCode(O+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===r.CharCode.Colon){const O=S.charCodeAt(0);O>=r.CharCode.A&&O<=r.CharCode.Z&&(S=`${String.fromCharCode(O+32)}:${S.substr(2)}`)}C+=_(S,!0,!1)}return F&&(C+="?",C+=_(F,!1,!1)),N&&(C+="#",C+=D?N:s(N,!1,!1)),C}function h(w){try{return decodeURIComponent(w)}catch{return w.length>3?w.substr(0,3)+h(w.substr(3)):w}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(w){return w.match(c)?w.replace(c,D=>h(D)):w}}),define(Ce[188],Ie([1,0,2]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=d,e.parse=P,e.getFirstFrame=k,e.log=R;function d(l){const I=l;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function P(l){const I=[];let y;try{const u=JSON.parse(l.arguments),T=u[u.length-1];T&&T.__$stack&&(u.pop(),y=T.__$stack),I.push(...u)}catch{I.push("Unable to log remote console arguments",l.arguments)}return{args:I,stack:y}}function k(l){if(typeof l!="string")return k(P(l).stack);const I=l;if(I){const y=L(I),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function L(l){if(!l)return l;const I=l.indexOf(`
`);return I===-1?l:l.substring(0,I)}function R(l,I){const{args:y,stack:u}=P(l),T=typeof y[0]=="string"&&y.length===1;let b=L(u);b&&(b=`(${b.trim()})`);let a=[];if(typeof y[0]=="string"?b&&T?a=[`%c[${I}] %c${y[0]} %c${b}`,v("blue"),v(""),v("grey")]:a=[`%c[${I}] %c${y[0]}`,v("blue"),v(""),...y.slice(1)]:a=[`%c[${I}]%`,v("blue"),...y],b&&!T&&a.push(b),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,a)}function v(l){return`color: ${l}`}}),define(Ce[44],Ie([1,0,21,2,40]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=k,e.parse=L,e.revive=v;function k(l){return JSON.stringify(l,R)}function L(l){let I=JSON.parse(l);return I=v(I),I}function R(l,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function v(l,I=0){if(!l||I>200)return l;if(typeof l=="object"){switch(l.$mid){case P.MarshalledId.Uri:return d.URI.revive(l);case P.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case P.MarshalledId.Date:return new Date(l.source)}if(l instanceof r.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let y=0;y<l.length;++y)l[y]=v(l[y],I+1);else for(const y in l)Object.hasOwnProperty.call(l,y)&&(l[y]=v(l[y],I+1))}return l}}),define(Ce[14],Ie([1,0,13,10,12,2,16]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=v,e.matchesSomeScheme=l,e.getServerRootPath=y,r=$e(r),d=$e(d),L=$e(L);var R;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatCodeBlock="vscode-chat-code-block",b.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",b.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm",b.commentsInput="comment",b.codeSetting="code-setting"})(R||(e.Schemas=R={}));function v(b,a){return k.URI.isUri(b)?(0,P.equalsIgnoreCase)(b.scheme,a):(0,P.startsWithIgnoreCase)(b,a+":")}function l(b,...a){return a.some(m=>v(b,m))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(a){this._preferredWebSchema=a}setDelegate(a){this._delegate=a}setServerRootPath(a,m){this._serverRootPath=y(a,m)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return L.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(a,m,p){this._hosts[a]=m,this._ports[a]=p}setConnectionToken(a,m){this._connectionTokens[a]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(a){if(this._delegate)try{return this._delegate(a)}catch(t){return r.onUnexpectedError(t),a}const m=a.authority;let p=this._hosts[m];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const f=this._ports[m],i=this._connectionTokens[m];let s=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(s+=`&${e.connectionTokenQueryName}=${encodeURIComponent(i)}`),k.URI.from({scheme:d.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${p}:${f}`,path:this._remoteResourcesPath,query:s})}}e.RemoteAuthorities=new I;function y(b,a){return L.posix.join(a??"/",`${b.quality??"oss"}-${b.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class u{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(a){const m=this.toUri(a,pe);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(a):a.scheme===R.file&&(d.isNative||d.webWorkerOrigin===`${R.vscodeFileResource}://${u.FALLBACK_AUTHORITY}`)?a.with({scheme:R.vscodeFileResource,authority:a.authority||u.FALLBACK_AUTHORITY,query:null,fragment:null}):a}asFileUri(a){const m=this.toUri(a,pe);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===R.vscodeFileResource?a.with({scheme:R.file,authority:a.authority!==u.FALLBACK_AUTHORITY?a.authority:null,query:null,fragment:null}):a}toUri(a,m){return k.URI.isUri(a)?a:k.URI.parse(m.toUrl(a))}}e.FileAccess=new u;var T;(function(b){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function p(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:k.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const t=s?.get(m);if(t)return a.get(t)}b.getHeadersFromQuery=p;function f(i,s,t){if(!globalThis.crossOriginIsolated)return;const o=s&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(m,o):i[m]=o}b.addSearchParam=f})(T||(e.COI=T={}))}),define(Ce[189],Ie([1,0,174,14,10,17,2]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=y,e.resolveAmdNodeModulePath=u,P=$e(P);class R{constructor(b,a,m){this.id=b,this.dependencies=a,this.callback=m}}class v{static{this.INSTANCE=new v}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(b,a,m)=>{typeof b!="string"&&(m=a,a=b,b=null),(typeof a!="object"||!Array.isArray(a))&&(m=a,a=null),this._defineCalls.push(new R(b,a,m))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this._initialize();const a=await(this._isWebWorker?this._workerLoadScript(b):this._isRenderer?this._rendererLoadScript(b):this._nodeJSLoadScript(b));if(!a)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}_rendererLoadScript(b){return new Promise((a,m)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const f=()=>{p.removeEventListener("load",i),p.removeEventListener("error",s)},i=t=>{f(),a(this._defineCalls.pop())},s=t=>{f(),m(t)};p.addEventListener("load",i),p.addEventListener("error",s),this._amdPolicy&&(b=this._amdPolicy.createScriptURL(b)),p.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(p)})}_workerLoadScript(b){return new Promise((a,m)=>{try{this._amdPolicy&&(b=this._amdPolicy.createScriptURL(b)),importScripts(b),a(this._defineCalls.pop())}catch(p){m(p)}})}async _nodeJSLoadScript(b){try{const a=globalThis._VSCODE_NODE_MODULES.fs,m=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,f=L.URI.parse(b).fsPath,i=a.readFileSync(f).toString(),s=p.wrap(i.replace(/^#!.*/,""));return new m.Script(s).runInThisContext().apply(),this._defineCalls.pop()}catch(a){throw a}}}const l=new Map;let I={};typeof globalThis.require=="object"&&(I=globalThis.require.paths??{});async function y(T,b,a){if(r.isESM){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),I[T]&&(T=I[T]);const m=b?`${T}/${b}`:T;if(l.has(m))return l.get(m);let p;if(/^\w[\w\d+.-]*:\/\//.test(m))p=m;else{const t=`${a&&!P.isWeb?d.nodeModulesAsarPath:d.nodeModulesPath}/${m}`;p=d.FileAccess.asBrowserUri(t).toString(!0)}const f=v.INSTANCE.load(p);return l.set(m,f),f}else return await new Promise((m,p)=>{pe([T],m,p)}).then($e)}function u(T,b){(0,k.assertType)(r.isESM);const p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!P.isWeb,f=`${T}/${b}`,s=`${p?d.nodeModulesAsarPath:d.nodeModulesPath}/${f}`;return d.FileAccess.asBrowserUri(s).toString(!0)}}),define(Ce[22],Ie([1,0,26,31,14,16,10,12,2]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=l,e.distinctParents=y,e.toLocalResource=T,d=$e(d),k=$e(k);function l(b){return(0,v.uriToFsPath)(b,!0)}class I{constructor(a){this._ignorePathCasing=a}compare(a,m,p=!1){return a===m?0:(0,R.compare)(this.getComparisonKey(a,p),this.getComparisonKey(m,p))}isEqual(a,m,p=!1){return a===m?!0:!a||!m?!1:this.getComparisonKey(a,p)===this.getComparisonKey(m,p)}getComparisonKey(a,m=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,m,p=!1){if(a.scheme===m.scheme){if(a.scheme===P.Schemas.file)return d.isEqualOrParent(l(a),l(m),this._ignorePathCasing(a))&&a.query===m.query&&(p||a.fragment===m.fragment);if((0,e.isEqualAuthority)(a.authority,m.authority))return d.isEqualOrParent(a.path,m.path,this._ignorePathCasing(a),"/")&&a.query===m.query&&(p||a.fragment===m.fragment)}return!1}joinPath(a,...m){return v.URI.joinPath(a,...m)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return k.posix.basename(a.path)}extname(a){return k.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let m;return a.scheme===P.Schemas.file?m=v.URI.file(k.dirname(l(a))).path:(m=k.posix.dirname(a.path),a.authority&&m.length&&m.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),m="/")),a.with({path:m})}normalizePath(a){if(!a.path.length)return a;let m;return a.scheme===P.Schemas.file?m=v.URI.file(k.normalize(l(a))).path:m=k.posix.normalize(a.path),a.with({path:m})}relativePath(a,m){if(a.scheme!==m.scheme||!(0,e.isEqualAuthority)(a.authority,m.authority))return;if(a.scheme===P.Schemas.file){const i=k.relative(l(a),l(m));return L.isWindows?d.toSlashes(i):i}let p=a.path||"/";const f=m.path||"/";if(this._ignorePathCasing(a)){let i=0;for(const s=Math.min(p.length,f.length);i<s&&!(p.charCodeAt(i)!==f.charCodeAt(i)&&p.charAt(i).toLowerCase()!==f.charAt(i).toLowerCase());i++);p=f.substr(0,i)+p.substr(i)}return k.posix.relative(p,f)}resolvePath(a,m){if(a.scheme===P.Schemas.file){const p=v.URI.file(k.resolve(l(a),m));return a.with({authority:p.authority,path:p.path})}return m=d.toPosixPath(m),a.with({path:k.posix.resolve(a.path,m)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,m){return a===m||a!==void 0&&m!==void 0&&(0,R.equalsIgnoreCase)(a,m)}hasTrailingPathSeparator(a,m=k.sep){if(a.scheme===P.Schemas.file){const p=l(a);return p.length>d.getRoot(p).length&&p[p.length-1]===m}else{const p=a.path;return p.length>1&&p.charCodeAt(p.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,m=k.sep){return(0,e.hasTrailingPathSeparator)(a,m)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,m=k.sep){let p=!1;if(a.scheme===P.Schemas.file){const f=l(a);p=f!==void 0&&f.length===d.getRoot(f).length&&f[f.length-1]===m}else{m="/";const f=a.path;p=f.length===1&&f.charCodeAt(f.length-1)===r.CharCode.Slash}return!p&&!(0,e.hasTrailingPathSeparator)(a,m)?a.with({path:a.path+"/"}):a}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(b=>b.scheme===P.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new I(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(b,a){const m=[];for(let p=0;p<b.length;p++){const f=a(b[p]);b.some((i,s)=>s===p?!1:(0,e.isEqualOrParent)(f,a(i)))||m.push(b[p])}return m}var u;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function a(m){const p=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(s=>{const[t,o]=s.split(":");t&&o&&p.set(t,o)});const i=m.path.substring(0,m.path.indexOf(";"));return i&&p.set(b.META_DATA_MIME,i),p}b.parseMetaData=a})(u||(e.DataUri=u={}));function T(b,a,m){if(a){let p=b.path;return p&&p[0]!==k.posix.sep&&(p=k.posix.sep+p),b.with({scheme:m,authority:a,path:p})}return b.with({scheme:m})}}),define(Ce[7],Ie([1,0,20,13,4,3,22,10,186,50]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=I,e.createCancelablePromise=y,e.raceCancellation=u,e.raceCancellationError=T,e.raceCancellablePromises=b,e.raceTimeout=a,e.asPromise=m,e.promiseWithResolvers=p,e.timeout=w,e.disposableTimeout=D,e.sequence=_,e.first=C,e.firstParallel=A,e.retry=$,e.createCancelableAsyncIterable=te;function I(se){return!!se&&typeof se.then=="function"}function y(se){const Q=new r.CancellationTokenSource,re=se(Q.token),ve=new Promise((be,Fe)=>{const Be=Q.token.onCancellationRequested(()=>{Be.dispose(),Fe(new d.CancellationError)});Promise.resolve(re).then(ke=>{Be.dispose(),Q.dispose(),be(ke)},ke=>{Be.dispose(),Q.dispose(),Fe(ke)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(be,Fe){return ve.then(be,Fe)}catch(be){return this.then(void 0,be)}finally(be){return ve.finally(be)}}}function u(se,Q,re){return new Promise((ve,be)=>{const Fe=Q.onCancellationRequested(()=>{Fe.dispose(),ve(re)});se.then(ve,be).finally(()=>Fe.dispose())})}function T(se,Q){return new Promise((re,ve)=>{const be=Q.onCancellationRequested(()=>{be.dispose(),ve(new d.CancellationError)});se.then(re,ve).finally(()=>be.dispose())})}async function b(se){let Q=-1;const re=se.map((ve,be)=>ve.then(Fe=>(Q=be,Fe)));try{return await Promise.race(re)}finally{se.forEach((ve,be)=>{be!==Q&&ve.cancel()})}}function a(se,Q,re){let ve;const be=setTimeout(()=>{ve?.(void 0),re?.()},Q);return Promise.race([se.finally(()=>clearTimeout(be)),new Promise(Fe=>ve=Fe)])}function m(se){return new Promise((Q,re)=>{const ve=se();I(ve)?ve.then(Q,re):Q(ve)})}function p(){let se,Q;return{promise:new Promise((ve,be)=>{se=ve,Q=be}),resolve:se,reject:Q}}class f{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const re=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ve=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ve};this.queuedPromise=new Promise(ve=>{this.activePromise.then(re,re).then(ve)})}return new Promise((re,ve)=>{this.queuedPromise.then(re,ve)})}return this.activePromise=Q(),new Promise((re,ve)=>{this.activePromise.then(be=>{this.activePromise=null,re(be)},be=>{this.activePromise=null,ve(be)})})}dispose(){this.isDisposed=!0}}e.Throttler=f;class i{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=i;class s{constructor(){this.promiseMap=new Map}queue(Q,re){const be=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.promiseMap.get(Q)===be&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,be),be}}e.SequencerByKey=s;const t=(se,Q)=>{let re=!0;const ve=setTimeout(()=>{re=!1,Q()},se);return{isTriggered:()=>re,dispose:()=>{clearTimeout(ve),re=!1}}},o=se=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,se())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class n{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,re=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((be,Fe)=>{this.doResolve=be,this.doReject=Fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const be=this.task;return this.task=null,be()}}));const ve=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=re===v.MicrotaskDelay?o(ve):t(re,ve),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new d.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=n;class h{constructor(Q){this.delayer=new n(Q),this.throttler=new f}trigger(Q,re){return this.delayer.trigger(()=>this.throttler.queue(Q),re)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=h;class c{constructor(){this._isOpen=!1,this._promise=new Promise((Q,re)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class g extends c{constructor(Q){super(),this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function w(se,Q){return Q?new Promise((re,ve)=>{const be=setTimeout(()=>{Fe.dispose(),re()},se),Fe=Q.onCancellationRequested(()=>{clearTimeout(be),Fe.dispose(),ve(new d.CancellationError)})}):y(re=>w(se,re))}function D(se,Q=0,re){const ve=setTimeout(()=>{se(),re&&be.dispose()},Q),be=(0,k.toDisposable)(()=>{clearTimeout(ve),re?.deleteAndLeak(be)});return re?.add(be),be}function _(se){const Q=[];let re=0;const ve=se.length;function be(){return re<ve?se[re++]():null}function Fe(Be){Be!=null&&Q.push(Be);const ke=be();return ke?ke.then(Fe):Promise.resolve(Q)}return Promise.resolve(null).then(Fe)}function C(se,Q=ve=>!!ve,re=null){let ve=0;const be=se.length,Fe=()=>{if(ve>=be)return Promise.resolve(re);const Be=se[ve++];return Promise.resolve(Be()).then(De=>Q(De)?Promise.resolve(De):Fe())};return Fe()}function A(se,Q=ve=>!!ve,re=null){if(se.length===0)return Promise.resolve(re);let ve=se.length;const be=()=>{ve=-1;for(const Fe of se)Fe.cancel?.()};return new Promise((Fe,Be)=>{for(const ke of se)ke.then(De=>{--ve>=0&&Q(De)?(be(),Fe(De)):ve===0&&Fe(re)}).catch(De=>{--ve>=0&&(be(),Be(De))})})}class E{constructor(Q){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Q){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((re,ve)=>{this.outstandingPromises.push({factory:Q,c:re,e:ve}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const re=Q.factory();re.then(Q.c,Q.e),re.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=E;class S extends E{constructor(){super(1)}}e.Queue=S;class F{constructor(){this.sequentializer=new G,this.tasks=0}queue(Q){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,Q())):this.sequentializer.run(this.tasks++,Q())}}e.LimitedQueue=F;class N{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const Q=new ne;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueSize(Q,re=L.extUri){const ve=re.getComparisonKey(Q);return this.queues.get(ve)?.size??0}queueFor(Q,re,ve=L.extUri){const be=ve.getComparisonKey(Q);let Fe=this.queues.get(be);if(!Fe){Fe=new S;const Be=this.drainListenerCount++,ke=P.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(be),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Be),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new k.DisposableMap),this.drainListeners.set(Be,ke),this.queues.set(be,Fe)}return Fe.queue(re)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=N;class O{constructor(Q,re){this._isDisposed=!1,this._token=-1,typeof Q=="function"&&typeof re=="number"&&this.setIfNotSet(Q,re)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,re){if(this._isDisposed)throw new d.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},re)}setIfNotSet(Q,re){if(this._isDisposed)throw new d.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},re))}}e.TimeoutTimer=O;class M{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(Q,re,ve=globalThis){if(this.isDisposed)throw new d.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const be=ve.setInterval(()=>{Q()},re);this.disposable=(0,k.toDisposable)(()=>{ve.clearInterval(be),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=M;class U{constructor(Q,re){this.timeoutToken=-1,this.runner=Q,this.timeout=re,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class x{constructor(Q,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=re,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=x;class z extends U{constructor(Q,re){super(Q,re),this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner?.(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class B extends k.Disposable{constructor(Q,re){super(),this.options=Q,this.handler=re,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const re of Q)this.pendingWork.push(re);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(se,Q)=>{(0,R.setTimeout0)(()=>{if(re)return;const ve=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e._runWhenIdle=(se,Q,re)=>{const ve=se.requestIdleCallback(Q,typeof re=="number"?{timeout:re}:void 0);let be=!1;return{dispose(){be||(be=!0,se.cancelIdleCallback(ve))}}},e.runWhenGlobalIdle=se=>(0,e._runWhenIdle)(globalThis,se)}();class ee{constructor(Q,re){this._didRun=!1,this._executor=()=>{try{this._value=re()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(Q,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ee;class V extends ee{constructor(Q){super(globalThis,Q)}}e.GlobalIdleValue=V;async function $(se,Q,re){let ve;for(let be=0;be<re;be++)try{return await se()}catch(Fe){ve=Fe,await w(Q)}throw ve}class G{isRunning(Q){return typeof Q=="number"?this._running?.taskId===Q:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(Q,re,ve){return this._running={taskId:Q,cancel:()=>ve?.(),promise:re},re.then(()=>this.doneRunning(Q),()=>this.doneRunning(Q)),re}doneRunning(Q){this._running&&Q===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const Q=this._queued;this._queued=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this._queued)this._queued.run=Q;else{const{promise:re,resolve:ve,reject:be}=p();this._queued={run:Q,promise:re,promiseResolve:ve,promiseReject:be}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=G;class Z{constructor(Q,re=()=>Date.now()){this.interval=Q,this.nowFn=re,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=Z;var le;(function(se){se[se.Resolved=0]="Resolved",se[se.Rejected=1]="Rejected"})(le||(le={}));class ne{get isRejected(){return this.outcome?.outcome===le.Rejected}get isResolved(){return this.outcome?.outcome===le.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===le.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((Q,re)=>{this.completeCallback=Q,this.errorCallback=re})}complete(Q){return new Promise(re=>{this.completeCallback(Q),this.outcome={outcome:le.Resolved,value:Q},re()})}error(Q){return new Promise(re=>{this.errorCallback(Q),this.outcome={outcome:le.Rejected,value:Q},re()})}cancel(){return this.error(new d.CancellationError)}}e.DeferredPromise=ne;var _e;(function(se){async function Q(ve){let be;const Fe=await Promise.all(ve.map(Be=>Be.then(ke=>ke,ke=>{be||(be=ke)})));if(typeof be<"u")throw be;return Fe}se.settled=Q;function re(ve){return new Promise(async(be,Fe)=>{try{await ve(be,Fe)}catch(Be){Fe(Be)}})}se.withAsyncBody=re})(_e||(e.Promises=_e={}));class ge{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(Q){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=Q.then(re=>(this._value=re,this._isResolved=!0,re),re=>{throw this._error=re,this._isResolved=!0,re})}requireValue(){if(!this._isResolved)throw new d.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=ge;class Y{constructor(Q){this._compute=Q,this._promise=new l.Lazy(()=>new ge(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=Y;var W;(function(se){se[se.Initial=0]="Initial",se[se.DoneOK=1]="DoneOK",se[se.DoneError=2]="DoneError"})(W||(W={}));class oe{static fromArray(Q){return new oe(re=>{re.emitMany(Q)})}static fromPromise(Q){return new oe(async re=>{re.emitMany(await Q)})}static fromPromises(Q){return new oe(async re=>{await Promise.all(Q.map(async ve=>re.emitOne(await ve)))})}static merge(Q){return new oe(async re=>{await Promise.all(Q.map(async ve=>{for await(const be of ve)re.emitOne(be)}))})}static{this.EMPTY=oe.fromArray([])}constructor(Q,re){this._state=W.Initial,this._results=[],this._error=null,this._onReturn=re,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const ve={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(Q(ve)),this.resolve()}catch(be){this.reject(be)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===W.DoneError)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===W.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(Q,re){return new oe(async ve=>{for await(const be of Q)ve.emitOne(re(be))})}map(Q){return oe.map(this,Q)}static filter(Q,re){return new oe(async ve=>{for await(const be of Q)re(be)&&ve.emitOne(be)})}filter(Q){return oe.filter(this,Q)}static coalesce(Q){return oe.filter(Q,re=>!!re)}coalesce(){return oe.coalesce(this)}static async toPromise(Q){const re=[];for await(const ve of Q)re.push(ve);return re}toPromise(){return oe.toPromise(this)}emitOne(Q){this._state===W.Initial&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===W.Initial&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===W.Initial&&(this._state=W.DoneOK,this._onStateChanged.fire())}reject(Q){this._state===W.Initial&&(this._state=W.DoneError,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=oe;class Se extends oe{constructor(Q,re){super(re),this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Se;function te(se){const Q=new r.CancellationTokenSource,re=se(Q.token);return new Se(Q,async ve=>{const be=Q.token.onCancellationRequested(()=>{be.dispose(),Q.dispose(),ve.reject(new d.CancellationError)});try{for await(const Fe of re){if(Q.token.isCancellationRequested)return;ve.emitOne(Fe)}be.dispose(),Q.dispose()}catch(Fe){be.dispose(),Q.dispose(),ve.reject(Fe)}})}class ae{constructor(Q){this._deferred=new ne,this._asyncIterable=new oe(be=>{if(re){be.reject(re);return}return ve&&be.emitMany(ve),this._errorFn=Fe=>be.reject(Fe),this._emitFn=Fe=>be.emitOne(Fe),this._deferred.p},Q);let re,ve;this._emitFn=be=>{ve||(ve=[]),ve.push(be)},this._errorFn=be=>{re||(re=be)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(Q){this._errorFn(Q),this._deferred.complete()}emitOne(Q){this._emitFn(Q)}}e.AsyncIterableSource=ae}),define(Ce[38],Ie([1,0,18,7,26,31,28,16,10,12]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=I,e.splitGlobAware=a,e.match=F,e.parse=N,e.isRelativePattern=O,e.getBasenameTerms=M,e.getPathTerms=U,e.patternsEquals=ee;function I(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",u="[^/\\\\]",T=/\//g;function b(V,$){switch(V){case 0:return"";case 1:return`${u}*?`;default:return`(?:${y}|${u}+${y}${$?`|${y}${u}+`:""})*?`}}function a(V,$){if(!V)return[];const G=[];let Z=!1,le=!1,ne="";for(const _e of V){switch(_e){case $:if(!Z&&!le){G.push(ne),ne="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":le=!0;break;case"]":le=!1;break}ne+=_e}return ne&&G.push(ne),G}function m(V){if(!V)return"";let $="";const G=a(V,e.GLOB_SPLIT);if(G.every(Z=>Z===e.GLOBSTAR))$=".*";else{let Z=!1;G.forEach((le,ne)=>{if(le===e.GLOBSTAR){if(Z)return;$+=b(2,ne===G.length-1)}else{let _e=!1,ge="",Y=!1,W="";for(const oe of le){if(oe!=="}"&&_e){ge+=oe;continue}if(Y&&(oe!=="]"||!W)){let Se;oe==="-"?Se=oe:(oe==="^"||oe==="!")&&!W?Se="^":oe===e.GLOB_SPLIT?Se="":Se=(0,l.escapeRegExpCharacters)(oe),W+=Se;continue}switch(oe){case"{":_e=!0;continue;case"[":Y=!0;continue;case"}":{const te=`(?:${a(ge,",").map(ae=>m(ae)).join("|")})`;$+=te,_e=!1,ge="";break}case"]":{$+="["+W+"]",Y=!1,W="";break}case"?":$+=u;continue;case"*":$+=b(1);continue;default:$+=(0,l.escapeRegExpCharacters)(oe)}}ne<G.length-1&&(G[ne+1]!==e.GLOBSTAR||ne+2<G.length)&&($+=y)}Z=le===e.GLOBSTAR})}return $}const p=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.LRUCache(1e4),h=function(){return!1},c=function(){return null};function g(V,$){if(!V)return c;let G;typeof V!="string"?G=V.pattern:G=V,G=G.trim();const Z=`${G}_${!!$.trimForExclusions}`;let le=n.get(Z);if(le)return w(le,V);let ne;return p.test(G)?le=_(G.substr(4),G):(ne=f.exec(D(G,$)))?le=C(ne[1],G):($.trimForExclusions?s:i).test(G)?le=A(G,$):(ne=t.exec(D(G,$)))?le=E(ne[1].substr(1),G,!0):(ne=o.exec(D(G,$)))?le=E(ne[1],G,!1):le=S(G),n.set(Z,le),w(le,V)}function w(V,$){if(typeof $=="string")return V;const G=function(Z,le){return(0,k.isEqualOrParent)(Z,$.base,!v.isLinux)?V((0,l.ltrim)(Z.substr($.base.length),R.sep),le):null};return G.allBasenames=V.allBasenames,G.allPaths=V.allPaths,G.basenames=V.basenames,G.patterns=V.patterns,G}function D(V,$){return $.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function _(V,$){return function(G,Z){return typeof G=="string"&&G.endsWith(V)?$:null}}function C(V,$){const G=`/${V}`,Z=`\\${V}`,le=function(_e,ge){return typeof _e!="string"?null:ge?ge===V?$:null:_e===V||_e.endsWith(G)||_e.endsWith(Z)?$:null},ne=[V];return le.basenames=ne,le.patterns=[$],le.allBasenames=ne,le}function A(V,$){const G=B(V.slice(1,-1).split(",").map(ge=>g(ge,$)).filter(ge=>ge!==c),V),Z=G.length;if(!Z)return c;if(Z===1)return G[0];const le=function(ge,Y){for(let W=0,oe=G.length;W<oe;W++)if(G[W](ge,Y))return V;return null},ne=G.find(ge=>!!ge.allBasenames);ne&&(le.allBasenames=ne.allBasenames);const _e=G.reduce((ge,Y)=>Y.allPaths?ge.concat(Y.allPaths):ge,[]);return _e.length&&(le.allPaths=_e),le}function E(V,$,G){const Z=R.sep===R.posix.sep,le=Z?V:V.replace(T,R.sep),ne=R.sep+le,_e=R.posix.sep+V;let ge;return G?ge=function(Y,W){return typeof Y=="string"&&(Y===le||Y.endsWith(ne)||!Z&&(Y===V||Y.endsWith(_e)))?$:null}:ge=function(Y,W){return typeof Y=="string"&&(Y===le||!Z&&Y===V)?$:null},ge.allPaths=[(G?"*/":"./")+V],ge}function S(V){try{const $=new RegExp(`^${m(V)}$`);return function(G){return $.lastIndex=0,typeof G=="string"&&$.test(G)?V:null}}catch{return c}}function F(V,$,G){return!V||typeof $!="string"?!1:N(V)($,void 0,G)}function N(V,$={}){if(!V)return h;if(typeof V=="string"||O(V)){const G=g(V,$);if(G===c)return h;const Z=function(le,ne){return!!G(le,ne)};return G.allBasenames&&(Z.allBasenames=G.allBasenames),G.allPaths&&(Z.allPaths=G.allPaths),Z}return x(V,$)}function O(V){const $=V;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}function M(V){return V.allBasenames||[]}function U(V){return V.allPaths||[]}function x(V,$){const G=B(Object.getOwnPropertyNames(V).map(ge=>z(ge,V[ge],$)).filter(ge=>ge!==c)),Z=G.length;if(!Z)return c;if(!G.some(ge=>!!ge.requiresSiblings)){if(Z===1)return G[0];const ge=function(oe,Se){let te;for(let ae=0,se=G.length;ae<se;ae++){const Q=G[ae](oe,Se);if(typeof Q=="string")return Q;(0,d.isThenable)(Q)&&(te||(te=[]),te.push(Q))}return te?(async()=>{for(const ae of te){const se=await ae;if(typeof se=="string")return se}return null})():null},Y=G.find(oe=>!!oe.allBasenames);Y&&(ge.allBasenames=Y.allBasenames);const W=G.reduce((oe,Se)=>Se.allPaths?oe.concat(Se.allPaths):oe,[]);return W.length&&(ge.allPaths=W),ge}const le=function(ge,Y,W){let oe,Se;for(let te=0,ae=G.length;te<ae;te++){const se=G[te];se.requiresSiblings&&W&&(Y||(Y=(0,R.basename)(ge)),oe||(oe=Y.substr(0,Y.length-(0,R.extname)(ge).length)));const Q=se(ge,Y,oe,W);if(typeof Q=="string")return Q;(0,d.isThenable)(Q)&&(Se||(Se=[]),Se.push(Q))}return Se?(async()=>{for(const te of Se){const ae=await te;if(typeof ae=="string")return ae}return null})():null},ne=G.find(ge=>!!ge.allBasenames);ne&&(le.allBasenames=ne.allBasenames);const _e=G.reduce((ge,Y)=>Y.allPaths?ge.concat(Y.allPaths):ge,[]);return _e.length&&(le.allPaths=_e),le}function z(V,$,G){if($===!1)return c;const Z=g(V,G);if(Z===c)return c;if(typeof $=="boolean")return Z;if($){const le=$.when;if(typeof le=="string"){const ne=(_e,ge,Y,W)=>{if(!W||!Z(_e,ge))return null;const oe=le.replace("$(basename)",()=>Y),Se=W(oe);return(0,d.isThenable)(Se)?Se.then(te=>te?V:null):Se?V:null};return ne.requiresSiblings=!0,ne}}return Z}function B(V,$){const G=V.filter(ge=>!!ge.basenames);if(G.length<2)return V;const Z=G.reduce((ge,Y)=>{const W=Y.basenames;return W?ge.concat(W):ge},[]);let le;if($){le=[];for(let ge=0,Y=Z.length;ge<Y;ge++)le.push($)}else le=G.reduce((ge,Y)=>{const W=Y.patterns;return W?ge.concat(W):ge},[]);const ne=function(ge,Y){if(typeof ge!="string")return null;if(!Y){let oe;for(oe=ge.length;oe>0;oe--){const Se=ge.charCodeAt(oe-1);if(Se===P.CharCode.Slash||Se===P.CharCode.Backslash)break}Y=ge.substr(oe)}const W=Z.indexOf(Y);return W!==-1?le[W]:null};ne.basenames=Z,ne.patterns=le,ne.allBasenames=Z;const _e=V.filter(ge=>!ge.basenames);return _e.push(ne),_e}function ee(V,$){return(0,r.equals)(V,$,(G,Z)=>typeof G=="string"&&typeof Z=="string"?G===Z:typeof G!="string"&&typeof Z!="string"?G.base===Z.base&&G.pattern===Z.pattern:!1)}}),define(Ce[85],Ie([1,0,13,137,22,12,2]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=l,e.isMarkdownString=I,e.markdownStringEqual=y,e.escapeMarkdownSyntaxTokens=u,e.appendEscapedMarkdownCodeBlockFence=T,e.escapeDoubleQuotes=b,e.removeMarkdownEscapes=a,e.parseHrefAndDimensions=m;var R;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class v{constructor(f="",i=!1){if(this.value=f,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(f,i=R.Paragraph){return this.value+=u(this.supportThemeIcons?(0,d.escapeIcons)(f):f).replace(/([ \t]+)/g,(s,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===R.Break?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,i){return this.value+=`
${T(i,f)}
`,this}appendLink(f,i,s){return this.value+="[",this.value+=this._escape(i,"]"),this.value+="](",this.value+=this._escape(String(f),")"),s&&(this.value+=` "${this._escape(this._escape(s,'"'),")")}"`),this.value+=")",this}_escape(f,i){const s=new RegExp((0,k.escapeRegExpCharacters)(i),"g");return f.replace(s,(t,o)=>f.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.MarkdownString=v;function l(p){return I(p)?!p.value:Array.isArray(p)?p.every(l):!0}function I(p){return p instanceof v?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||typeof p.isTrusted=="object"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}function y(p,f){return p===f?!0:!p||!f?!1:p.value===f.value&&p.isTrusted===f.isTrusted&&p.supportThemeIcons===f.supportThemeIcons&&p.supportHtml===f.supportHtml&&(p.baseUri===f.baseUri||!!p.baseUri&&!!f.baseUri&&(0,P.isEqual)(L.URI.from(p.baseUri),L.URI.from(f.baseUri)))}function u(p){return p.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function T(p,f){const i=p.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,s=i>=3?i+1:3;return[`${"`".repeat(s)}${f}`,p,`${"`".repeat(s)}`].join(`
`)}function b(p){return p.replace(/"/g,"&quot;")}function a(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(p){const f=[],i=p.split("|").map(t=>t.trim());p=i[0];const s=i[1];if(s){const t=/height=(\d+)/.exec(s),o=/width=(\d+)/.exec(s),n=t?t[1]:"",h=o?o[1]:"",c=isFinite(parseInt(h)),g=isFinite(parseInt(n));c&&f.push(`width="${h}"`),g&&f.push(`height="${n}"`)}return{href:p,dimensions:f}}}),define(Ce[107],Ie([1,0,18,31,16,10,22,12]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=v,e.normalizeDriveLetter=I,e.tildify=u,e.untildify=T,e.shorten=p,e.template=i,e.mnemonicMenuLabel=s,e.mnemonicButtonLabel=t,e.unmnemonicLabel=o,e.splitRecentLabel=n;function v(c,g){const{os:w,tildify:D,relative:_}=g;if(_){const E=l(c,_,w);if(typeof E=="string")return E}let C=c.fsPath;if(w===k.OperatingSystem.Windows&&!k.isWindows?C=C.replace(/\//g,"\\"):w!==k.OperatingSystem.Windows&&k.isWindows&&(C=C.replace(/\\/g,"/")),w!==k.OperatingSystem.Windows&&D?.userHome){const E=D.userHome.fsPath;let S;c.scheme!==D.userHome.scheme&&c.path[0]===P.posix.sep&&c.path[1]!==P.posix.sep?S=D.userHome.with({path:c.path}).fsPath:S=C,C=u(S,E,w)}return(w===k.OperatingSystem.Windows?P.win32:P.posix).normalize(I(C,w===k.OperatingSystem.Windows))}function l(c,g,w){const D=w===k.OperatingSystem.Windows?P.win32:P.posix,_=w===k.OperatingSystem.Linux?L.extUri:L.extUriIgnorePathCase,C=g.getWorkspace(),A=(0,r.firstOrDefault)(C.folders);if(!A)return;c.scheme!==A.uri.scheme&&c.path[0]===P.posix.sep&&c.path[1]!==P.posix.sep&&(c=A.uri.with({path:c.path}));const E=g.getWorkspaceFolder(c);if(!E)return;let S;if(_.isEqual(E.uri,c)?S="":S=_.relativePath(E.uri,c)??"",S&&(S=D.normalize(S)),C.folders.length>1&&!g.noPrefix){const F=E.name?E.name:_.basenameOrAuthority(E.uri);S=S?`${F} \u2022 ${S}`:F}return S}function I(c,g=k.isWindows){return(0,d.hasDriveLetter)(c,g)?c.charAt(0).toUpperCase()+c.slice(1):c}let y=Object.create(null);function u(c,g,w=k.OS){if(w===k.OperatingSystem.Windows||!c||!g)return c;let D=y.original===g?y.normalized:void 0;D||(D=g,k.isWindows&&(D=(0,d.toSlashes)(D)),D=`${(0,R.rtrim)(D,P.posix.sep)}${P.posix.sep}`,y={original:g,normalized:D});let _=c;return k.isWindows&&(_=(0,d.toSlashes)(_)),(w===k.OperatingSystem.Linux?_.startsWith(D):(0,R.startsWithIgnoreCase)(_,D))?`~/${_.substr(D.length)}`:c}function T(c,g){return c.replace(/^~($|\/|\\)/,`${g}$1`)}const b="\u2026",a="\\\\",m="~";function p(c,g=P.sep){const w=new Array(c.length);let D=!1;for(let _=0;_<c.length;_++){const C=c[_];if(C===""){w[_]=`.${g}`;continue}if(!C){w[_]=C;continue}D=!0;let A="",E=C;E.indexOf(a)===0?(A=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(g)===0?(A=E.substr(0,E.indexOf(g)+g.length),E=E.substr(E.indexOf(g)+g.length)):E.indexOf(m)===0&&(A=E.substr(0,E.indexOf(m)+m.length),E=E.substr(E.indexOf(m)+m.length));const S=E.split(g);for(let F=1;D&&F<=S.length;F++)for(let N=S.length-F;D&&N>=0;N--){D=!1;let O=S.slice(N,N+F).join(g);for(let M=0;!D&&M<c.length;M++)if(M!==_&&c[M]&&c[M].indexOf(O)>-1){const U=N+F===S.length,x=N>0&&c[M].indexOf(g)>-1?g+O:O,z=c[M].endsWith(x);D=!U||z}if(!D){let M="";(S[0].endsWith(":")||A!=="")&&(N===1&&(N=0,F++,O=S[0]+g+O),N>0&&(M=S[0]+g),M=A+M),N>0&&(M=M+b+g),M=M+O,N+F<S.length&&(M=M+g+b),w[_]=M}}D&&(w[_]=C)}return w}var f;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function i(c,g=Object.create(null)){const w=[];let D=!1,_="";for(const C of c)if(C==="$"||D&&C==="{")_&&w.push({value:_,type:f.TEXT}),_="",D=!0;else if(C==="}"&&D){const A=g[_];if(typeof A=="string")A.length&&w.push({value:A,type:f.VARIABLE});else if(A){const E=w[w.length-1];(!E||E.type!==f.SEPARATOR)&&w.push({value:A.label,type:f.SEPARATOR})}_="",D=!1}else _+=C;return _&&!D&&w.push({value:_,type:f.TEXT}),w.filter((C,A)=>{if(C.type===f.SEPARATOR){const E=w[A-1],S=w[A+1];return[E,S].every(F=>F&&(F.type===f.VARIABLE||F.type===f.TEXT)&&F.value.length>0)}return!0}).map(C=>C.value).join("")}function s(c,g){return k.isMacintosh||g?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):c.replace(/&&|&/g,w=>w==="&"?"&&":"&")}function t(c,g){return k.isMacintosh||g?c.replace(/\(&&\w\)|&&/g,""):k.isWindows?c.replace(/&&|&/g,w=>w==="&"?"&&":"&"):c.replace(/&&/g,"_")}function o(c){return c.replace(/&/g,"&&")}function n(c){if(c.endsWith("]")){const g=c.lastIndexOf(" [",c.length-2);if(g!==-1){const w=h(c.substring(0,g)),D=c.substring(g);return{name:w.name+D,parentPath:w.parentPath}}}return h(c)}function h(c){const g=c.indexOf("/")!==-1?P.posix:P.win32,w=g.basename(c),D=g.dirname(c);return w.length?{name:w,parentPath:D}:{name:D,parentPath:""}}}),define(Ce[138],Ie([1,0,21,40,2]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=v,e.transformIncomingURIs=I,e.transformAndReviveIncomingURIs=y;function k(u){return u.toJSON()}class L{constructor(T){this._uriTransformer=T}transformIncoming(T){const b=this._uriTransformer.transformIncoming(T);return b===T?T:k(P.URI.from(b))}transformOutgoing(T){const b=this._uriTransformer.transformOutgoing(T);return b===T?T:k(P.URI.from(b))}transformOutgoingURI(T){const b=this._uriTransformer.transformOutgoing(T);return b===T?T:P.URI.from(b)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function R(u,T,b){if(!u||b>200)return null;if(typeof u=="object"){if(u instanceof P.URI)return T.transformOutgoing(u);for(const a in u)if(Object.hasOwnProperty.call(u,a)){const m=R(u[a],T,b+1);m!==null&&(u[a]=m)}}return null}function v(u,T){const b=R(u,T,0);return b===null?u:b}function l(u,T,b,a){if(!u||a>200)return null;if(typeof u=="object"){if(u.$mid===d.MarshalledId.Uri)return b?P.URI.revive(T.transformIncoming(u)):T.transformIncoming(u);if(u instanceof r.VSBuffer)return null;for(const m in u)if(Object.hasOwnProperty.call(u,m)){const p=l(u[m],T,b,a+1);p!==null&&(u[m]=p)}}return null}function I(u,T){const b=l(u,T,!1,0);return b===null?u:b}function y(u,T){const b=l(u,T,!0,0);return b===null?u:b}}),define(Ce[32],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=d;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function d(P){return r.test(P)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(R){for(let v=0;v<R.length;v++)R[v]=Math.floor(Math.random()*256);return R};const k=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){P(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let v=0,l="";return l+=L[k[v++]],l+=L[k[v++]],l+=L[k[v++]],l+=L[k[v++]],l+="-",l+=L[k[v++]],l+=L[k[v++]],l+="-",l+=L[k[v++]],l+=L[k[v++]],l+="-",l+=L[k[v++]],l+=L[k[v++]],l+="-",l+=L[k[v++]],l+=L[k[v++]],l+=L[k[v++]],l+=L[k[v++]],l+=L[k[v++]],l+=L[k[v++]],l}}()}),define(Ce[190],Ie([1,0,18,39,32]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=k,e.createFileDataTransferItem=L,e.matchesMimeType=l;function k(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function L(y,u,T){const b={id:(0,P.generateUuid)(),name:y,uri:u,data:T};return{asString:async()=>"",asFile:()=>b,value:void 0}}class R{constructor(){this._entries=new Map}get size(){let u=0;for(const T of this._entries)u++;return u}has(u){return this._entries.has(this.toKey(u))}matches(u){const T=[...this._entries.keys()];return d.Iterable.some(this,([b,a])=>a.asFile())&&T.push("files"),I(v(u),T)}get(u){return this._entries.get(this.toKey(u))?.[0]}append(u,T){const b=this._entries.get(u);b?b.push(T):this._entries.set(this.toKey(u),[T])}replace(u,T){this._entries.set(this.toKey(u),[T])}delete(u){this._entries.delete(this.toKey(u))}*[Symbol.iterator](){for(const[u,T]of this._entries)for(const b of T)yield[u,b]}toKey(u){return v(u)}}e.VSDataTransfer=R;function v(y){return y.toLowerCase()}function l(y,u){return I(v(y),u.map(v))}function I(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const T=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!T)return!1;const[b,a,m]=T;return m==="*"?u.some(p=>p.startsWith(a+"/")):!1}e.UriList=Object.freeze({create:y=>(0,r.distinct)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.UriList.split(y).filter(u=>!u.startsWith("#"))})}),define(Ce[33],Ie([1,0,45,66,360,7,31,81,16,10,22,2]),function(pe,e,r,d,P,k,L,R,v,l,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=o,e.configureFlushOnWrite=w,e.writeFileSync=_,r=$e(r);var u;(function(x){x[x.UNLINK=0]="UNLINK",x[x.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function T(x,z=u.UNLINK,B){if((0,L.isRootOrDriveLetter)(x))throw new Error("rimraf - will refuse to recursively delete root");return z===u.UNLINK?a(x):b(x,B)}async function b(x,z=(0,L.randomPath)((0,d.tmpdir)())){try{try{await r.promises.rename(x,z)}catch(B){return B.code==="ENOENT"?void 0:a(x)}a(z).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function a(x){return r.promises.rm(x,{recursive:!0,force:!0,maxRetries:3})}function m(x){if((0,L.isRootOrDriveLetter)(x))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(x,{recursive:!0,force:!0,maxRetries:3})}async function p(x,z){return s(await(z?f(x):r.promises.readdir(x)))}async function f(x){try{return await r.promises.readdir(x,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const z=[],B=await p(x);for(const ee of B){let V=!1,$=!1,G=!1;try{const Z=await r.promises.lstat((0,v.join)(x,ee));V=Z.isFile(),$=Z.isDirectory(),G=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}z.push({name:ee,isFile:()=>V,isDirectory:()=>$,isSymbolicLink:()=>G})}return z}function i(x){return s(r.readdirSync(x))}function s(x){return x.map(z=>typeof z=="string"?l.isMacintosh?(0,R.normalizeNFC)(z):z:(z.name=l.isMacintosh?(0,R.normalizeNFC)(z.name):z.name,z))}async function t(x){const z=await p(x),B=[];for(const ee of z)await n.existsDirectory((0,v.join)(x,ee))&&B.push(ee);return B}function o(x,z=1e3){return new Promise(B=>{let ee=!1;const V=setInterval(()=>{ee||(ee=!0,r.access(x,$=>{ee=!1,$&&(clearInterval(V),B(void 0))}))},z)})}var n;(function(x){async function z(V){let $;try{if($=await r.promises.lstat(V),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await r.promises.stat(V),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(l.isWindows&&G.code==="EACCES")try{return{stat:await r.promises.stat(await r.promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw Z}throw G}}x.stat=z;async function B(V){try{const{stat:$,symbolicLink:G}=await x.stat(V);return $.isFile()&&G?.dangling!==!0}catch{}return!1}x.existsFile=B;async function ee(V){try{const{stat:$,symbolicLink:G}=await x.stat(V);return $.isDirectory()&&G?.dangling!==!0}catch{}return!1}x.existsDirectory=ee})(n||(e.SymlinkSupport=n={}));const h=new k.ResourceQueue;function c(x,z,B){return h.queueFor(y.URI.file(x),()=>{const ee=C(B);return new Promise((V,$)=>D(x,z,ee,G=>G?$(G):V()))},I.extUriBiasedIgnorePathCase)}let g=!0;function w(x){g=x}function D(x,z,B,ee){if(!g)return r.writeFile(x,z,{mode:B.mode,flag:B.flag},ee);r.open(x,B.flag,B.mode,(V,$)=>{if(V)return ee(V);r.writeFile($,z,G=>{if(G)return r.close($,()=>ee(G));r.fdatasync($,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),w(!1)),r.close($,le=>ee(le))))})})}function _(x,z,B){const ee=C(B);if(!g)return r.writeFileSync(x,z,{mode:ee.mode,flag:ee.flag});const V=r.openSync(x,ee.flag,ee.mode);try{r.writeFileSync(V,z);try{r.fdatasyncSync(V)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),w(!1)}}finally{r.closeSync(V)}}function C(x){return x?{mode:typeof x.mode=="number"?x.mode:438,flag:typeof x.flag=="string"?x.flag:"w"}:{mode:438,flag:"w"}}async function A(x,z,B=6e4){if(x!==z)try{l.isWindows&&typeof B=="number"?await E(x,z,Date.now(),B):await r.promises.rename(x,z)}catch(ee){if(x.toLowerCase()!==z.toLowerCase()&&ee.code==="EXDEV"||x.endsWith("."))await S(x,z,{preserveSymlinks:!1}),await T(x,u.MOVE);else throw ee}}async function E(x,z,B,ee,V=0){try{return await r.promises.rename(x,z)}catch($){if($.code!=="EACCES"&&$.code!=="EPERM"&&$.code!=="EBUSY")throw $;if(Date.now()-B>=ee)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${$}`),$;if(V===0){let G=!1;try{const{stat:Z}=await n.stat(z);Z.isFile()||(G=!0)}catch{}if(G)throw $}return await(0,k.timeout)(Math.min(100,V*10)),E(x,z,B,ee,V+1)}}async function S(x,z,B){return N(x,z,{root:{source:x,target:z},options:B,handledSourcePaths:new Set})}const F=511;async function N(x,z,B){if(B.handledSourcePaths.has(x))return;B.handledSourcePaths.add(x);const{stat:ee,symbolicLink:V}=await n.stat(x);if(V){if(B.options.preserveSymlinks)try{return await U(x,z,B)}catch{}if(V.dangling)return}return ee.isDirectory()?O(x,z,ee.mode&F,B):M(x,z,ee.mode&F)}async function O(x,z,B,ee){await r.promises.mkdir(z,{recursive:!0,mode:B});const V=await p(x);for(const $ of V)await N((0,v.join)(x,$),(0,v.join)(z,$),ee)}async function M(x,z,B){await r.promises.copyFile(x,z),await r.promises.chmod(z,B)}async function U(x,z,B){let ee=await r.promises.readlink(x);(0,L.isEqualOrParent)(ee,B.root.source,!l.isLinux)&&(ee=(0,v.join)(B.root.target,ee.substr(B.root.source.length+1))),await r.promises.symlink(ee,z)}e.Promises=new class{get read(){return(x,z,B,ee,V)=>new Promise(($,G)=>{r.read(x,z,B,ee,V,(Z,le,ne)=>Z?G(Z):$({bytesRead:le,buffer:ne}))})}get write(){return(x,z,B,ee,V)=>new Promise(($,G)=>{r.write(x,z,B,ee,V,(Z,le,ne)=>Z?G(Z):$({bytesWritten:le,buffer:ne}))})}get fdatasync(){return(0,P.promisify)(r.fdatasync)}get open(){return(0,P.promisify)(r.open)}get close(){return(0,P.promisify)(r.close)}get realpath(){return(0,P.promisify)(r.realpath)}async exists(x){try{return await r.promises.access(x),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return T}get rename(){return A}get copy(){return S}}}),define(Ce[108],Ie([1,0,45,16,10,12,33]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=R,e.realcase=v,e.realpath=l,e.realpathSync=I,r=$e(r);function R(u){if(P.isLinux)return u;const T=(0,d.dirname)(u);if(u===T)return u;const b=((0,d.basename)(u)||u).toLowerCase();try{const m=(0,L.readdirSync)(T).filter(p=>p.toLowerCase()===b);if(m.length===1){const p=R(T);if(p)return(0,d.join)(p,m[0])}else if(m.length>1){const p=m.indexOf(b);if(p>=0){const f=R(T);if(f)return(0,d.join)(f,m[p])}}}catch{}return null}async function v(u,T){if(P.isLinux)return u;const b=(0,d.dirname)(u);if(u===b)return u;const a=((0,d.basename)(u)||u).toLowerCase();try{if(T?.isCancellationRequested)return null;const p=(await L.Promises.readdir(b)).filter(f=>f.toLowerCase()===a);if(p.length===1){const f=await v(b,T);if(f)return(0,d.join)(f,p[0])}else if(p.length>1){const f=p.indexOf(a);if(f>=0){const i=await v(b,T);if(i)return(0,d.join)(i,p[f])}}}catch{}return null}async function l(u){try{return await L.Promises.realpath(u)}catch{const b=y(u);return await r.promises.access(b,r.constants.R_OK),b}}function I(u){try{return r.realpathSync(u)}catch{const b=y(u);return r.accessSync(b,r.constants.R_OK),b}}function y(u){return(0,k.rtrim)((0,d.normalize)(u),d.sep)}}),define(Ce[191],Ie([1,0,67]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=d,e.findFreePortFaster=k,r=$e(r);function d(R,v,l,I=1){let y=!1;return new Promise(u=>{const T=setTimeout(()=>{if(!y)return y=!0,u(0)},l);P(R,v,I,b=>{if(!y)return y=!0,clearTimeout(T),u(b)})})}function P(R,v,l,I){if(v===0)return I(0);const y=new r.Socket;y.once("connect",()=>(L(y),P(R+l,v-1,l,I))),y.once("data",()=>{}),y.once("error",u=>(L(y),u.code!=="ECONNREFUSED"?P(R+l,v-1,l,I):I(R))),y.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(R,v,l,I="127.0.0.1"){let y=!1,u,T=1;const b=r.createServer({pauseOnConnect:!0});function a(m,p){y||(y=!0,b.removeAllListeners(),b.close(),u&&clearTimeout(u),p(m))}return new Promise(m=>{u=setTimeout(()=>{a(0,m)},l),b.on("listening",()=>{a(R,m)}),b.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&T<v?(R++,T++,b.listen(R,I)):a(0,m)}),b.on("close",()=>{a(0,m)}),b.listen(R,I)})}function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(v){console.error(v)}}}),define(Ce[109],Ie([1,0,45,16,10,55,104,17,33]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=l,e.createQueuedSender=I,d=$e(d),P=$e(P),k=$e(k),R=$e(R),v=$e(v),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function l(u=k.env){return u.comspec||"cmd.exe"}function I(u){let T=[],b=!1;const a=function(m){if(b){T.push(m);return}(!u.send(m,f=>{if(f&&console.error(f),b=!1,T.length>0){const i=T.slice(0);T=[],i.forEach(s=>a(s))}})||P.isWindows)&&(b=!0)};return{send:a}}var y;(function(u){async function T(b,a,m){if(d.isAbsolute(b))return b;if(a===void 0&&(a=k.cwd()),d.dirname(b)!=="."||(m===void 0&&R.isString(k.env.PATH)&&(m=k.env.PATH.split(d.delimiter)),m===void 0||m.length===0))return d.join(a,b);async function f(i){if(await v.Promises.exists(i)){let s;try{s=await r.promises.stat(i)}catch(t){t.message.startsWith("EACCES")&&(s=await r.promises.lstat(i))}return s?!s.isDirectory():!1}return!1}for(const i of m){let s;if(d.isAbsolute(i)?s=d.join(i,b):s=d.join(a,i,b),await f(s))return s;let t=s+".com";if(await f(t)||(t=s+".exe",await f(t)))return t}return d.join(a,b)}u.findExecutable=T})(y||(e.win32=y={}))});var Xe=this&&this.__decorate||function(pe,e,r,d){var P=arguments.length,k=P<3?e:d===null?d=Object.getOwnPropertyDescriptor(e,r):d,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(pe,e,r,d);else for(var R=pe.length-1;R>=0;R--)(L=pe[R])&&(k=(P<3?L(k):P>3?L(e,r,k):L(e,r))||k);return P>3&&k&&Object.defineProperty(e,r,k),k};define(Ce[86],Ie([1,0,18,7,21,20,59,13,4,3,44,12,17]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=w,e.deserialize=D,e.getDelayedChannel=F,e.getNextTickChannel=N,y=$e(y);var T;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(T||(T={}));function b(V){switch(V){case T.Promise:return"req";case T.PromiseCancel:return"cancel";case T.EventListen:return"subscribe";case T.EventDispose:return"unsubscribe"}}var a;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(a||(a={}));function m(V){switch(V){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var p;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(p||(p={}));function f(V){let $=0;for(let G=0;;G+=7){const Z=V.read(1);if($|=(Z.buffer[0]&127)<<G,!(Z.buffer[0]&128))return $}}const i=h(0);function s(V,$){if($===0){V.write(i);return}let G=0;for(let le=$;le!==0;le=le>>>7)G++;const Z=P.VSBuffer.alloc(G);for(let le=0;$!==0;le++)Z.buffer[le]=$&127,$=$>>>7,$>0&&(Z.buffer[le]|=128);V.write(Z)}class t{constructor($){this.buffer=$,this.pos=0}read($){const G=this.buffer.slice(this.pos,this.pos+$);return this.pos+=G.byteLength,G}}e.BufferReader=t;class o{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}e.BufferWriter=o;var n;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(n||(n={}));function h(V){const $=P.VSBuffer.alloc(1);return $.writeUInt8(V,0),$}const c={Undefined:h(n.Undefined),String:h(n.String),Buffer:h(n.Buffer),VSBuffer:h(n.VSBuffer),Array:h(n.Array),Object:h(n.Object),Uint:h(n.Int)},g=typeof Buffer<"u";function w(V,$){if(typeof $>"u")V.write(c.Undefined);else if(typeof $=="string"){const G=P.VSBuffer.fromString($);V.write(c.String),s(V,G.byteLength),V.write(G)}else if(g&&Buffer.isBuffer($)){const G=P.VSBuffer.wrap($);V.write(c.Buffer),s(V,G.byteLength),V.write(G)}else if($ instanceof P.VSBuffer)V.write(c.VSBuffer),s(V,$.byteLength),V.write($);else if(Array.isArray($)){V.write(c.Array),s(V,$.length);for(const G of $)w(V,G)}else if(typeof $=="number"&&($|0)===$)V.write(c.Uint),s(V,$);else{const G=P.VSBuffer.fromString(JSON.stringify($));V.write(c.Object),s(V,G.byteLength),V.write(G)}}function D(V){switch(V.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return V.read(f(V)).toString();case n.Buffer:return V.read(f(V)).buffer;case n.VSBuffer:return V.read(f(V));case n.Array:{const G=f(V),Z=[];for(let le=0;le<G;le++)Z.push(D(V));return Z}case n.Object:return JSON.parse(V.read(f(V)).toString());case n.Int:return f(V)}}class _{constructor($,G,Z=null,le=1e3){this.protocol=$,this.ctx=G,this.logger=Z,this.timeoutDelay=le,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ne=>this.onRawMessage(ne)),this.sendResponse({type:a.Initialize})}registerChannel($,G){this.channels.set($,G),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case a.Initialize:{const G=this.send([$.type]);this.logger?.logOutgoing(G,0,C.OtherSide,m($.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const G=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(G,$.id,C.OtherSide,m($.type),$.data);return}}}send($,G=void 0){const Z=new o;return w(Z,$),w(Z,G),this.sendBuffer(Z.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const G=new t($),Z=D(G),le=D(G),ne=Z[0];switch(ne){case T.Promise:return this.logger?.logIncoming($.byteLength,Z[1],C.OtherSide,`${b(ne)}: ${Z[2]}.${Z[3]}`,le),this.onPromise({type:ne,id:Z[1],channelName:Z[2],name:Z[3],arg:le});case T.EventListen:return this.logger?.logIncoming($.byteLength,Z[1],C.OtherSide,`${b(ne)}: ${Z[2]}.${Z[3]}`,le),this.onEventListen({type:ne,id:Z[1],channelName:Z[2],name:Z[3],arg:le});case T.PromiseCancel:return this.logger?.logIncoming($.byteLength,Z[1],C.OtherSide,`${b(ne)}`),this.disposeActiveRequest({type:ne,id:Z[1]});case T.EventDispose:return this.logger?.logIncoming($.byteLength,Z[1],C.OtherSide,`${b(ne)}`),this.disposeActiveRequest({type:ne,id:Z[1]})}}onPromise($){const G=this.channels.get($.channelName);if(!G){this.collectPendingRequest($);return}const Z=new k.CancellationTokenSource;let le;try{le=G.call(this.ctx,$.name,$.arg,Z.token)}catch(ge){le=Promise.reject(ge)}const ne=$.id;le.then(ge=>{this.sendResponse({id:ne,data:ge,type:a.PromiseSuccess})},ge=>{ge instanceof Error?this.sendResponse({id:ne,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split(`
`):void 0},type:a.PromiseError}):this.sendResponse({id:ne,data:ge,type:a.PromiseErrorObj})}).finally(()=>{_e.dispose(),this.activeRequests.delete($.id)});const _e=(0,l.toDisposable)(()=>Z.cancel());this.activeRequests.set($.id,_e)}onEventListen($){const G=this.channels.get($.channelName);if(!G){this.collectPendingRequest($);return}const Z=$.id,ne=G.listen(this.ctx,$.name,$.arg)(_e=>this.sendResponse({id:Z,data:_e,type:a.EventFire}));this.activeRequests.set($.id,ne)}disposeActiveRequest($){const G=this.activeRequests.get($.id);G&&(G.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let G=this.pendingRequests.get($.channelName);G||(G=[],this.pendingRequests.set($.channelName,G));const Z=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===T.Promise&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:a.PromiseError})},this.timeoutDelay);G.push({request:$,timeoutTimer:Z})}flushPendingRequests($){const G=this.pendingRequests.get($);if(G){for(const Z of G)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case T.Promise:this.onPromise(Z.request);break;case T.EventListen:this.onEventListen(Z.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=_;var C;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class A{constructor($,G=null){this.protocol=$,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Z=>this.onBuffer(Z)),this.logger=G}getChannel($){const G=this;return{call(Z,le,ne){return G.isDisposed?Promise.reject(new R.CancellationError):G.requestPromise($,Z,le,ne)},listen(Z,le){return G.isDisposed?v.Event.None:G.requestEvent($,Z,le)}}}requestPromise($,G,Z,le=k.CancellationToken.None){const ne=this.lastRequestId++,_e=T.Promise,ge={id:ne,type:_e,channelName:$,name:G,arg:Z};if(le.isCancellationRequested)return Promise.reject(new R.CancellationError);let Y;return new Promise((oe,Se)=>{if(le.isCancellationRequested)return Se(new R.CancellationError);const te=()=>{const re=ve=>{switch(ve.type){case a.PromiseSuccess:this.handlers.delete(ne),oe(ve.data);break;case a.PromiseError:{this.handlers.delete(ne);const be=new Error(ve.data.message);be.stack=Array.isArray(ve.data.stack)?ve.data.stack.join(`
`):ve.data.stack,be.name=ve.data.name,Se(be);break}case a.PromiseErrorObj:this.handlers.delete(ne),Se(ve.data);break}};this.handlers.set(ne,re),this.sendRequest(ge)};let ae=null;this.state===p.Idle?te():(ae=(0,d.createCancelablePromise)(re=>this.whenInitialized()),ae.then(()=>{ae=null,te()}));const se=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:ne,type:T.PromiseCancel}),Se(new R.CancellationError)},Q=le.onCancellationRequested(se);Y=(0,l.combinedDisposable)((0,l.toDisposable)(se),Q),this.activeRequests.add(Y)}).finally(()=>{Y.dispose(),this.activeRequests.delete(Y)})}requestEvent($,G,Z){const le=this.lastRequestId++,ne=T.EventListen,_e={id:le,type:ne,channelName:$,name:G,arg:Z};let ge=null;const Y=new v.Emitter({onWillAddFirstListener:()=>{ge=(0,d.createCancelablePromise)(oe=>this.whenInitialized()),ge.then(()=>{ge=null,this.activeRequests.add(Y),this.sendRequest(_e)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.activeRequests.delete(Y),this.sendRequest({id:le,type:T.EventDispose}))}}),W=oe=>Y.fire(oe.data);return this.handlers.set(le,W),Y.event}sendRequest($){switch($.type){case T.Promise:case T.EventListen:{const G=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger?.logOutgoing(G,$.id,C.LocalSide,`${b($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case T.PromiseCancel:case T.EventDispose:{const G=this.send([$.type,$.id]);this.logger?.logOutgoing(G,$.id,C.LocalSide,b($.type));return}}}send($,G=void 0){const Z=new o;return w(Z,$),w(Z,G),this.sendBuffer(Z.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const G=new t($),Z=D(G),le=D(G),ne=Z[0];switch(ne){case a.Initialize:return this.logger?.logIncoming($.byteLength,0,C.LocalSide,m(ne)),this.onResponse({type:Z[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.logger?.logIncoming($.byteLength,Z[1],C.LocalSide,m(ne),le),this.onResponse({type:Z[0],id:Z[1],data:le})}}onResponse($){if($.type===a.Initialize){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get($.id)?.($)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=A,Xe([L.memoize],A.prototype,"onDidInitializePromise",null);class E{get connections(){const $=[];return this._connections.forEach(G=>$.push(G)),$}constructor($,G,Z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add($(({protocol:le,onDidClientDisconnect:ne})=>{const _e=v.Event.once(le.onMessage);this.disposables.add(_e(ge=>{const Y=new t(ge),W=D(Y),oe=new _(le,W,G,Z),Se=new A(le,G);this.channels.forEach((ae,se)=>oe.registerChannel(se,ae));const te={channelServer:oe,channelClient:Se,ctx:W};this._connections.add(te),this._onDidAddConnection.fire(te),this.disposables.add(ne(()=>{oe.dispose(),Se.dispose(),this._connections.delete(te),this._onDidRemoveConnection.fire(te)}))}))}))}getChannel($,G){const Z=this;return{call(le,ne,_e){let ge;if((0,u.isFunction)(G)){const W=(0,r.getRandomElement)(Z.connections.filter(G));ge=W?Promise.resolve(W):v.Event.toPromise(v.Event.filter(Z.onDidAddConnection,G))}else ge=G.routeCall(Z,le,ne);const Y=ge.then(W=>W.channelClient.getChannel($));return F(Y).call(le,ne,_e)},listen(le,ne){if((0,u.isFunction)(G))return Z.getMulticastEvent($,G,le,ne);const _e=G.routeEvent(Z,le,ne).then(ge=>ge.channelClient.getChannel($));return F(_e).listen(le,ne)}}}getMulticastEvent($,G,Z,le){const ne=this;let _e;const ge=new v.Emitter({onWillAddFirstListener:()=>{_e=new l.DisposableStore;const Y=new v.EventMultiplexer,W=new Map,oe=te=>{const se=te.channelClient.getChannel($).listen(Z,le),Q=Y.add(se);W.set(te,Q)},Se=te=>{const ae=W.get(te);ae&&(ae.dispose(),W.delete(te))};ne.connections.filter(G).forEach(oe),v.Event.filter(ne.onDidAddConnection,G)(oe,void 0,_e),ne.onDidRemoveConnection(Se,void 0,_e),Y.event(ge.fire,ge,_e),_e.add(Y)},onDidRemoveLastListener:()=>{_e?.dispose(),_e=void 0}});return ge.event}registerChannel($,G){this.channels.set($,G);for(const Z of this._connections)Z.channelServer.registerChannel($,G)}dispose(){this.disposables.dispose();for(const $ of this._connections)$.channelClient.dispose(),$.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class S{constructor($,G,Z=null){const le=new o;w(le,G),$.send(le.buffer),this.channelClient=new A($,Z),this.channelServer=new _($,G,Z)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,G){this.channelServer.registerChannel($,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=S;function F(V){return{call($,G,Z){return V.then(le=>le.call($,G,Z))},listen($,G){const Z=new v.Relay;return V.then(le=>Z.input=le.listen($,G)),Z.event}}}function N(V){let $=!1;return{call(G,Z,le){return $?V.call(G,Z,le):(0,d.timeout)(0).then(()=>$=!0).then(()=>V.call(G,Z,le))},listen(G,Z){if($)return V.listen(G,Z);const le=new v.Relay;return(0,d.timeout)(0).then(()=>$=!0).then(()=>le.input=V.listen(G,Z)),le.event}}}class O{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const G of $.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await v.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=O;var M;(function(V){function $(ne,_e,ge){const Y=ne,W=ge&&ge.disableMarshalling,oe=new Map;for(const Se in Y)Z(Se)&&oe.set(Se,v.Event.buffer(Y[Se],!0,void 0,_e));return new class{listen(Se,te,ae){const se=oe.get(te);if(se)return se;const Q=Y[te];if(typeof Q=="function"){if(le(te))return Q.call(Y,ae);if(Z(te))return oe.set(te,v.Event.buffer(Y[te],!0,void 0,_e)),oe.get(te)}throw new R.ErrorNoTelemetry(`Event not found: ${te}`)}call(Se,te,ae){const se=Y[te];if(typeof se=="function"){if(!W&&Array.isArray(ae))for(let re=0;re<ae.length;re++)ae[re]=(0,I.revive)(ae[re]);let Q=se.apply(Y,ae);return Q instanceof Promise||(Q=Promise.resolve(Q)),Q}throw new R.ErrorNoTelemetry(`Method not found: ${te}`)}}}V.fromService=$;function G(ne,_e){const ge=_e&&_e.disableMarshalling;return new Proxy({},{get(Y,W){if(typeof W=="string")return _e?.properties?.has(W)?_e.properties.get(W):le(W)?function(oe){return ne.listen(W,oe)}:Z(W)?ne.listen(W):async function(...oe){let Se;_e&&!(0,u.isUndefinedOrNull)(_e.context)?Se=[_e.context,...oe]:Se=oe;const te=await ne.call(W,Se);return ge?te:(0,I.revive)(te)};throw new R.ErrorNoTelemetry(`Property not found: ${String(W)}`)}})}V.toService=G;function Z(ne){return ne[0]==="o"&&ne[1]==="n"&&y.isUpperAsciiLetter(ne.charCodeAt(2))}function le(ne){return/^onDynamic/.test(ne)&&y.isUpperAsciiLetter(ne.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const $=V.toString();if($!=="[object Object]")return $}return V}function z(V){return Array.isArray(V)?V.map(x):x(V)}function B(V,$,G,Z,le,ne,_e){_e=z(_e);const ge=U[le],Y=ge[Z%ge.length];let W=[`%c[${V}]%c[${String($).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(ne)?(W=W.concat(_e),W.push(")")):W.push(_e),console.log.apply(console,W)}class ee{constructor($,G){this._outgoingPrefix=$,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,G,Z,le,ne){this._totalOutgoing+=$,B(this._outgoingPrefix,this._totalOutgoing,$,G,Z,le,ne)}logIncoming($,G,Z,le,ne){this._totalIncoming+=$,B(this._incomingPrefix,this._totalIncoming,$,G,Z,le,ne)}}e.IPCLogger=ee}),define(Ce[68],Ie([1,0,21,4,3,86]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var R;(function(c){c.enableDiagnostics=!1,c.records=[];const g=new WeakMap;let w=0;function D(C,A){if(!g.has(C)){const E=String(++w);g.set(C,E)}return g.get(C)}function _(C,A,E,S){if(!c.enableDiagnostics)return;const F=D(C,A);if(S instanceof r.VSBuffer||S instanceof Uint8Array||S instanceof ArrayBuffer||ArrayBuffer.isView(S)){const N=r.VSBuffer.alloc(S.byteLength);N.set(S),c.records.push({timestamp:Date.now(),id:F,label:A,type:E,buff:N})}else c.records.push({timestamp:Date.now(),id:F,label:A,type:E,data:S})}c.traceSocketEvent=_})(R||(e.SocketDiagnostics=R={}));var v;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let l=null;function I(){return l||(l=r.VSBuffer.alloc(0)),l}class y{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(g){this._chunks.push(g),this._totalLength+=g.byteLength}read(g){return this._read(g,!0)}peek(g){return this._read(g,!1)}_read(g,w){if(g===0)return I();if(g>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===g){const A=this._chunks[0];return w&&(this._chunks.shift(),this._totalLength-=g),A}if(this._chunks[0].byteLength>g){const A=this._chunks[0].slice(0,g);return w&&(this._chunks[0]=this._chunks[0].slice(g),this._totalLength-=g),A}const D=r.VSBuffer.alloc(g);let _=0,C=0;for(;g>0;){const A=this._chunks[C];if(A.byteLength>g){const E=A.slice(0,g);D.set(E,_),_+=g,w&&(this._chunks[C]=A.slice(g),this._totalLength-=g),g-=g}else D.set(A,_),_+=A.byteLength,w?(this._chunks.shift(),this._totalLength-=A.byteLength):C++,g-=A.byteLength}return D}}e.ChunkStream=y;var u;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})(u||(u={}));function T(c){switch(c){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var b;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class a{constructor(g,w,D,_){this.type=g,this.id=w,this.ack=D,this.data=_,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends P.Disposable{constructor(g){super(),this._onMessage=this._register(new d.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:b.HeaderLength,messageType:u.None,id:0,ack:0},this._socket=g,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(w=>this.acceptChunk(w))),this.lastReadTime=Date.now()}acceptChunk(g){if(!(!g||g.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;){const w=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=w.readUInt32BE(9),this._state.messageType=w.readUInt8(0),this._state.id=w.readUInt32BE(1),this._state.ack=w.readUInt32BE(5),this._socket.traceSocketEvent(L.ProtocolHeaderRead,{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const D=this._state.messageType,_=this._state.id,C=this._state.ack;if(this._state.readHead=!0,this._state.readLen=b.HeaderLength,this._state.messageType=u.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(L.ProtocolMessageRead,w),this._onMessage.fire(new a(D,_,C,w)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(g){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=g,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(g){if(this._isDisposed)return;g.writtenTime=Date.now(),this.lastWriteTime=Date.now();const w=r.VSBuffer.alloc(b.HeaderLength);w.writeUInt8(g.type,0),w.writeUInt32BE(g.id,1),w.writeUInt32BE(g.ack,5),w.writeUInt32BE(g.data.byteLength,9),this._socket.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:T(g.type),id:g.id,ack:g.ack,messageSize:g.data.byteLength}),this._socket.traceSocketEvent(L.ProtocolMessageWrite,g.data),this._writeSoon(w,g.data)}_bufferAdd(g,w){const D=this._totalLength===0;return this._data.push(g,w),this._totalLength+=g.byteLength+w.byteLength,D}_bufferTake(){const g=r.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,g}_writeSoon(g,w){this._bufferAdd(g,w)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const g=this._bufferTake();this._socket.traceSocketEvent(L.ProtocolWrite,{byteLength:g.byteLength}),this._socket.write(g)}}class f extends P.Disposable{constructor(g){super(),this._onMessage=new d.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new d.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=g,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(w=>{w.type===u.Regular&&this._onMessage.fire(w.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(g){this._socketWriter.write(new a(u.Regular,0,0,g))}}e.Protocol=f;class i extends k.IPCClient{static fromSocket(g,w){return new i(new f(g),w)}get onDidDispose(){return this.protocol.onDidDispose}constructor(g,w,D=null){super(g,w,D),this.protocol=g}dispose(){super.dispose();const g=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),g.end()}}e.Client=i;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new d.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(g){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(g):this._emitter.fire(g):this._bufferedMessages.push(g)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class t{constructor(g){this.data=g,this.next=null}}class o{constructor(){this._first=null,this._last=null}length(){let g=0,w=this._first;for(;w;)w=w.next,g++;return g}peek(){return this._first?this._first.data:null}toArray(){const g=[];let w=0,D=this._first;for(;D;)g[w++]=D.data,D=D.next;return g}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(g){const w=new t(g);if(!this._first){this._first=w,this._last=w;return}this._last.next=w,this._last=w}}class n{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}constructor(){this.lastRuns=[];const g=Date.now();for(let w=0;w<n._HISTORY_LENGTH;w++)this.lastRuns[w]=g-1e3*w;setInterval(()=>{for(let w=n._HISTORY_LENGTH;w>=1;w--)this.lastRuns[w]=this.lastRuns[w-1];this.lastRuns[0]=Date.now()},1e3)}load(){const g=Date.now(),w=(1+n._HISTORY_LENGTH)*1e3;let D=0;for(let _=0;_<n._HISTORY_LENGTH;_++)g-this.lastRuns[_]<=w&&D++;return 1-D/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class h{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(g){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=g.loadEstimator??n.getInstance(),this._shouldSendKeepAlive=g.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new P.DisposableStore,this._socket=g.socket,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.add(this._socket.onClose(w=>this._onSocketClose.fire(w))),g.initialChunk&&this._socketReader.acceptChunk(g.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},b.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){if(!this._didSendDisconnect){this._didSendDisconnect=!0;const g=new a(u.Disconnect,0,0,I());this._socketWriter.write(g),this._socketWriter.flush()}}sendPause(){const g=new a(u.Pause,0,0,I());this._socketWriter.write(g)}sendResume(){const g=new a(u.Resume,0,0,I());this._socketWriter.write(g)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(g,w){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new P.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=g,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(D=>this._receiveMessage(D))),this._socketDisposables.add(this._socket.onClose(D=>this._onSocketClose.fire(D))),this._socketReader.acceptChunk(w)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const g=new a(u.Ack,0,this._incomingAckId,I());this._socketWriter.write(g);const w=this._outgoingUnackMsg.toArray();for(let D=0,_=w.length;D<_;D++)this._socketWriter.write(w[D]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(g){if(g.ack>this._outgoingAckId){this._outgoingAckId=g.ack;do{const w=this._outgoingUnackMsg.peek();if(w&&w.id<=g.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(g.type){case u.None:break;case u.Regular:{if(g.id>this._incomingMsgId)if(g.id!==this._incomingMsgId+1){const w=Date.now();w-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=w,this._socketWriter.write(new a(u.ReplayRequest,0,0,I())))}else this._incomingMsgId=g.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(g.data);break}case u.Control:{this._onControlMessage.fire(g.data);break}case u.Ack:break;case u.Disconnect:{this._onDidDispose.fire();break}case u.ReplayRequest:{const w=this._outgoingUnackMsg.toArray();for(let D=0,_=w.length;D<_;D++)this._socketWriter.write(w[D]);this._recvAckCheck();break}case u.Pause:{this._socketWriter.pause();break}case u.Resume:{this._socketWriter.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(g){const w=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const D=new a(u.Regular,w,this._incomingAckId,g);this._outgoingUnackMsg.push(D),this._isReconnecting||(this._socketWriter.write(D),this._recvAckCheck())}sendControl(g){const w=new a(u.Control,0,0,g);this._socketWriter.write(w)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const g=Date.now()-this._incomingMsgLastTime;if(g>=b.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},b.AcknowledgeTime-g+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const g=this._outgoingUnackMsg.peek(),w=Date.now()-g.writtenTime,D=Date.now()-this._socketReader.lastReadTime,_=Date.now()-this._lastSocketTimeoutTime;if(w>=b.TimeoutTime&&D>=b.TimeoutTime&&_>=b.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:w,timeSinceLastReceivedSomeData:D});return}const C=Math.max(b.TimeoutTime-w,b.TimeoutTime-D,b.TimeoutTime-_,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},C)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const g=new a(u.Ack,0,this._incomingAckId,I());this._socketWriter.write(g)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const g=new a(u.KeepAlive,0,this._incomingAckId,I());this._socketWriter.write(g)}}e.PersistentProtocol=h}),define(Ce[192],Ie([1,0,56,7,21,20,188,13,4,3,24,109,104,86]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,R=$e(R);class b extends T.ChannelServer{constructor(p){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",f=>P.VSBuffer.wrap(Buffer.from(f,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=b;class a{constructor(p,f){this.modulePath=p,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const i=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new d.Delayer(i),this.child=null,this._client=null}getChannel(p){const f=this;return{call(i,s,t){return f.requestPromise(p,i,s,t)},listen(i,s){return f.requestEvent(p,i,s)}}}requestPromise(p,f,i,s=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const t=this.getCachedChannel(p),o=(0,d.createCancelablePromise)(c=>t.call(f,i,c)),n=s.onCancellationRequested(()=>o.cancel()),h=(0,l.toDisposable)(()=>o.cancel());return this.activeRequests.add(h),o.finally(()=>{n.dispose(),this.activeRequests.delete(h),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(p,f,i){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let s;const t=new v.Emitter({onWillAddFirstListener:()=>{s=this.getCachedChannel(p).listen(f,i)(t.fire,t),this.activeRequests.add(s)},onDidRemoveLastListener:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return t.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(w=>!/^--inspect(-brk)?=/.test(w)).filter(w=>!w.startsWith("--vscode-"))),(0,u.removeDangerousEnvVariables)(f.env),this.child=(0,r.fork)(this.modulePath,p,f);const i=new v.Emitter,t=v.Event.fromNodeEventEmitter(this.child,"message",w=>w)(w=>{if((0,L.isRemoteConsoleLog)(w)){(0,L.log)(w,`IPC Library: ${this.options.serverName}`);return}i.fire(P.VSBuffer.wrap(Buffer.from(w,"base64")))}),o=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,n=w=>this.child&&this.child.connected&&o.send(w.buffer.toString("base64")),h=i.event,c={send:n,onMessage:h};this._client=new T.ChannelClient(c);const g=()=>this.disposeClient();process.once("exit",g),this.child.on("error",w=>console.warn('IPC "'+this.options.serverName+'" errored with '+w)),this.child.on("exit",(w,D)=>{process.removeListener("exit",g),t.dispose(),this.activeRequests.forEach(_=>(0,l.dispose)(_)),this.activeRequests.clear(),w!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+w+" and signal "+D),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:w,signal:D})})}return this._client}getCachedChannel(p){let f=this.channels.get(p);return f||(f=this.client.getChannel(p),this.channels.set(p,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=a}),define(Ce[193],Ie([1,0,7,4,3,44,17]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=v;var R;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function v(u){const T=u;return T?.changed instanceof Map||T?.deleted instanceof Set}var l;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(l||(e.StorageState=l={}));class I extends P.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(T,b=Object.create(null)){super(),this.database=T,this.options=b,this._onDidChangeStorage=this._register(new d.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new r.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(T=>this.onDidChangeItemsExternal(T)))}onDidChangeItemsExternal(T){this._onDidChangeStorage.pause();try{T.changed?.forEach((b,a)=>this.acceptExternal(a,b)),T.deleted?.forEach(b=>this.acceptExternal(b,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(T,b){if(this.state===l.Closed)return;let a=!1;(0,L.isUndefinedOrNull)(b)?a=this.cache.delete(T):this.cache.get(T)!==b&&(this.cache.set(T,b),a=!0),a&&this._onDidChangeStorage.fire({key:T,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(T,b){const a=this.cache.get(T);return(0,L.isUndefinedOrNull)(a)?b:a}getBoolean(T,b){const a=this.get(T);return(0,L.isUndefinedOrNull)(a)?b:a==="true"}getNumber(T,b){const a=this.get(T);return(0,L.isUndefinedOrNull)(a)?b:parseInt(a,10)}getObject(T,b){const a=this.get(T);return(0,L.isUndefinedOrNull)(a)?b:(0,k.parse)(a)}async set(T,b,a=!1){if(this.state===l.Closed)return;if((0,L.isUndefinedOrNull)(b))return this.delete(T,a);const m=(0,L.isObject)(b)||Array.isArray(b)?(0,k.stringify)(b):String(b);if(this.cache.get(T)!==m)return this.cache.set(T,m),this.pendingInserts.set(T,m),this.pendingDeletes.delete(T),this._onDidChangeStorage.fire({key:T,external:a}),this.doFlush()}async delete(T,b=!1){if(!(this.state===l.Closed||!this.cache.delete(T)))return this.pendingDeletes.has(T)||this.pendingDeletes.add(T),this.pendingInserts.delete(T),this._onDidChangeStorage.fire({key:T,external:b}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const T={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(T).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(T){if(!(this.state===l.Closed||this.pendingClose))return this.doFlush(T)}async doFlush(T){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),T)}async whenFlushed(){if(this.hasPending)return new Promise(T=>this.whenFlushedCallbacks.push(T))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=I;class y{constructor(){this.onDidChangeItemsExternal=d.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(T){T.insert?.forEach((b,a)=>this.items.set(a,b)),T.delete?.forEach(b=>this.items.delete(b))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=y}),define(Ce[139],Ie([1,0,83]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class d{constructor(R){const v=(0,r.toUint8)(R);this._defaultValue=v,this._asciiMap=d._createAsciiMap(v),this._map=new Map}static _createAsciiMap(R){const v=new Uint8Array(256);return v.fill(R),v}set(R,v){const l=(0,r.toUint8)(v);R>=0&&R<256?this._asciiMap[R]=l:this._map.set(R,l)}get(R){return R>=0&&R<256?this._asciiMap[R]:this._map.get(R)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=d;var P;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(P||(P={}));class k{constructor(){this._actual=new d(P.False)}add(R){this._actual.set(R,P.True)}has(R){return this._actual.get(R)===P.True}clear(){return this._actual.clear()}}e.CharacterSet=k}),define(Ce[194],Ie([1,0,26]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=P;var d;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(d||(e.StringEOL=d={}));function P(k){let L=0,R=0,v=0,l=d.Unknown;for(let I=0,y=k.length;I<y;I++){const u=k.charCodeAt(I);u===r.CharCode.CarriageReturn?(L===0&&(R=I),L++,I+1<y&&k.charCodeAt(I+1)===r.CharCode.LineFeed?(l|=d.CRLF,I++):l|=d.Invalid,v=I+1):u===r.CharCode.LineFeed&&(l|=d.LF,L===0&&(R=I),L++,v=I+1)}return L===0&&(R=k.length),[L,R,k.length-v,l]}}),define(Ce[57],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class r{constructor(P,k){this.lineNumber=P,this.column=k}with(P=this.lineNumber,k=this.column){return P===this.lineNumber&&k===this.column?this:new r(P,k)}delta(P=0,k=0){return this.with(this.lineNumber+P,this.column+k)}equals(P){return r.equals(this,P)}static equals(P,k){return!P&&!k?!0:!!P&&!!k&&P.lineNumber===k.lineNumber&&P.column===k.column}isBefore(P){return r.isBefore(this,P)}static isBefore(P,k){return P.lineNumber<k.lineNumber?!0:k.lineNumber<P.lineNumber?!1:P.column<k.column}isBeforeOrEqual(P){return r.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,k){return P.lineNumber<k.lineNumber?!0:k.lineNumber<P.lineNumber?!1:P.column<=k.column}static compare(P,k){const L=P.lineNumber|0,R=k.lineNumber|0;if(L===R){const v=P.column|0,l=k.column|0;return v-l}return L-R}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new r(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.Position=r}),define(Ce[30],Ie([1,0,57]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class d{constructor(k,L,R,v){k>R||k===R&&L>v?(this.startLineNumber=R,this.startColumn=v,this.endLineNumber=k,this.endColumn=L):(this.startLineNumber=k,this.startColumn=L,this.endLineNumber=R,this.endColumn=v)}isEmpty(){return d.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return d.containsPosition(this,k)}static containsPosition(k,L){return!(L.lineNumber<k.startLineNumber||L.lineNumber>k.endLineNumber||L.lineNumber===k.startLineNumber&&L.column<k.startColumn||L.lineNumber===k.endLineNumber&&L.column>k.endColumn)}static strictContainsPosition(k,L){return!(L.lineNumber<k.startLineNumber||L.lineNumber>k.endLineNumber||L.lineNumber===k.startLineNumber&&L.column<=k.startColumn||L.lineNumber===k.endLineNumber&&L.column>=k.endColumn)}containsRange(k){return d.containsRange(this,k)}static containsRange(k,L){return!(L.startLineNumber<k.startLineNumber||L.endLineNumber<k.startLineNumber||L.startLineNumber>k.endLineNumber||L.endLineNumber>k.endLineNumber||L.startLineNumber===k.startLineNumber&&L.startColumn<k.startColumn||L.endLineNumber===k.endLineNumber&&L.endColumn>k.endColumn)}strictContainsRange(k){return d.strictContainsRange(this,k)}static strictContainsRange(k,L){return!(L.startLineNumber<k.startLineNumber||L.endLineNumber<k.startLineNumber||L.startLineNumber>k.endLineNumber||L.endLineNumber>k.endLineNumber||L.startLineNumber===k.startLineNumber&&L.startColumn<=k.startColumn||L.endLineNumber===k.endLineNumber&&L.endColumn>=k.endColumn)}plusRange(k){return d.plusRange(this,k)}static plusRange(k,L){let R,v,l,I;return L.startLineNumber<k.startLineNumber?(R=L.startLineNumber,v=L.startColumn):L.startLineNumber===k.startLineNumber?(R=L.startLineNumber,v=Math.min(L.startColumn,k.startColumn)):(R=k.startLineNumber,v=k.startColumn),L.endLineNumber>k.endLineNumber?(l=L.endLineNumber,I=L.endColumn):L.endLineNumber===k.endLineNumber?(l=L.endLineNumber,I=Math.max(L.endColumn,k.endColumn)):(l=k.endLineNumber,I=k.endColumn),new d(R,v,l,I)}intersectRanges(k){return d.intersectRanges(this,k)}static intersectRanges(k,L){let R=k.startLineNumber,v=k.startColumn,l=k.endLineNumber,I=k.endColumn;const y=L.startLineNumber,u=L.startColumn,T=L.endLineNumber,b=L.endColumn;return R<y?(R=y,v=u):R===y&&(v=Math.max(v,u)),l>T?(l=T,I=b):l===T&&(I=Math.min(I,b)),R>l||R===l&&v>I?null:new d(R,v,l,I)}equalsRange(k){return d.equalsRange(this,k)}static equalsRange(k,L){return!k&&!L?!0:!!k&&!!L&&k.startLineNumber===L.startLineNumber&&k.startColumn===L.startColumn&&k.endLineNumber===L.endLineNumber&&k.endColumn===L.endColumn}getEndPosition(){return d.getEndPosition(this)}static getEndPosition(k){return new r.Position(k.endLineNumber,k.endColumn)}getStartPosition(){return d.getStartPosition(this)}static getStartPosition(k){return new r.Position(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,L){return new d(this.startLineNumber,this.startColumn,k,L)}setStartPosition(k,L){return new d(k,L,this.endLineNumber,this.endColumn)}collapseToStart(){return d.collapseToStart(this)}static collapseToStart(k){return new d(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}collapseToEnd(){return d.collapseToEnd(this)}static collapseToEnd(k){return new d(k.endLineNumber,k.endColumn,k.endLineNumber,k.endColumn)}delta(k){return new d(this.startLineNumber+k,this.startColumn,this.endLineNumber+k,this.endColumn)}static fromPositions(k,L=k){return new d(k.lineNumber,k.column,L.lineNumber,L.column)}static lift(k){return k?new d(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,L){return!(k.endLineNumber<L.startLineNumber||k.endLineNumber===L.startLineNumber&&k.endColumn<L.startColumn||L.endLineNumber<k.startLineNumber||L.endLineNumber===k.startLineNumber&&L.endColumn<k.startColumn)}static areIntersecting(k,L){return!(k.endLineNumber<L.startLineNumber||k.endLineNumber===L.startLineNumber&&k.endColumn<=L.startColumn||L.endLineNumber<k.startLineNumber||L.endLineNumber===k.startLineNumber&&L.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,L){if(k&&L){const l=k.startLineNumber|0,I=L.startLineNumber|0;if(l===I){const y=k.startColumn|0,u=L.startColumn|0;if(y===u){const T=k.endLineNumber|0,b=L.endLineNumber|0;if(T===b){const a=k.endColumn|0,m=L.endColumn|0;return a-m}return T-b}return y-u}return l-I}return(k?1:0)-(L?1:0)}static compareRangesUsingEnds(k,L){return k.endLineNumber===L.endLineNumber?k.endColumn===L.endColumn?k.startLineNumber===L.startLineNumber?k.startColumn-L.startColumn:k.startLineNumber-L.startLineNumber:k.endColumn-L.endColumn:k.endLineNumber-L.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}toJSON(){return this}}e.Range=d}),define(Ce[195],Ie([1,0,30]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class d{static insert(k,L){return{range:new r.Range(k.lineNumber,k.column,k.lineNumber,k.column),text:L,forceMoveMarkers:!0}}static delete(k){return{range:k,text:null}}static replace(k,L){return{range:k,text:L}}static replaceMove(k,L){return{range:k,text:L,forceMoveMarkers:!0}}}e.EditOperation=d}),define(Ce[196],Ie([1,0,57,30]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var P;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(P||(e.SelectionDirection=P={}));class k extends d.Range{constructor(R,v,l,I){super(R,v,l,I),this.selectionStartLineNumber=R,this.selectionStartColumn=v,this.positionLineNumber=l,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(R){return k.selectionsEqual(this,R)}static selectionsEqual(R,v){return R.selectionStartLineNumber===v.selectionStartLineNumber&&R.selectionStartColumn===v.selectionStartColumn&&R.positionLineNumber===v.positionLineNumber&&R.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?P.LTR:P.RTL}setEndPosition(R,v){return this.getDirection()===P.LTR?new k(this.startLineNumber,this.startColumn,R,v):new k(R,v,this.startLineNumber,this.startColumn)}getPosition(){return new r.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(R,v){return this.getDirection()===P.LTR?new k(R,v,this.endLineNumber,this.endColumn):new k(this.endLineNumber,this.endColumn,R,v)}static fromPositions(R,v=R){return new k(R.lineNumber,R.column,v.lineNumber,v.column)}static fromRange(R,v){return v===P.LTR?new k(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):new k(R.endLineNumber,R.endColumn,R.startLineNumber,R.startColumn)}static liftSelection(R){return new k(R.selectionStartLineNumber,R.selectionStartColumn,R.positionLineNumber,R.positionColumn)}static selectionsArrEqual(R,v){if(R&&!v||!R&&v)return!1;if(!R&&!v)return!0;if(R.length!==v.length)return!1;for(let l=0,I=R.length;l<I;l++)if(!this.selectionsEqual(R[l],v[l]))return!1;return!0}static isISelection(R){return R&&typeof R.selectionStartLineNumber=="number"&&typeof R.selectionStartColumn=="number"&&typeof R.positionLineNumber=="number"&&typeof R.positionColumn=="number"}static createWithDirection(R,v,l,I,y){return y===P.LTR?new k(R,v,l,I):new k(l,I,R,v)}}e.Selection=k}),define(Ce[197],Ie([1,0,12,10,21]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=I,e.decodeUTF16LE=y,r=$e(r),d=$e(d),P=$e(P);let k;function L(){return k||(k=new TextDecoder("UTF-16LE")),k}let R;function v(){return R||(R=new TextDecoder("UTF-16BE")),R}let l;function I(){return l||(l=d.isLittleEndian()?L():v()),l}function y(b,a,m){const p=new Uint16Array(b.buffer,a,m);return m>0&&(p[0]===65279||p[0]===65534)?u(b,a,m):L().decode(p)}function u(b,a,m){const p=[];let f=0;for(let i=0;i<m;i++){const s=P.readUInt16LE(b,a);a+=2,p[f++]=String.fromCharCode(s)}return p.join("")}class T{constructor(a){this._capacity=a|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const a=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return I().decode(a)}_flushBuffer(){const a=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[a]:this._completedStrings[this._completedStrings.length]=a}appendCharCode(a){const m=this._capacity-this._bufferLength;m<=1&&(m===0||r.isHighSurrogate(a))&&this._flushBuffer(),this._buffer[this._bufferLength++]=a}appendASCIICharCode(a){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=a}appendString(a){const m=a.length;if(this._bufferLength+m>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=a;return}for(let p=0;p<m;p++)this._buffer[this._bufferLength++]=a.charCodeAt(p)}}e.StringBuilder=T}),define(Ce[198],Ie([1,0,21,197]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=L,r=$e(r);function P(v){return v.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class k{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(l,I,y,u){this.oldPosition=l,this.oldText=I,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static _writeStringSize(l){return 4+2*l.length}static _writeString(l,I,y){const u=I.length;r.writeUInt32BE(l,u,y),y+=4;for(let T=0;T<u;T++)r.writeUInt16LE(l,I.charCodeAt(T),y),y+=2;return y}static _readString(l,I){const y=r.readUInt32BE(l,I);return I+=4,(0,d.decodeUTF16LE)(l,I,y)}writeSize(){return 8+k._writeStringSize(this.oldText)+k._writeStringSize(this.newText)}write(l,I){return r.writeUInt32BE(l,this.oldPosition,I),I+=4,r.writeUInt32BE(l,this.newPosition,I),I+=4,I=k._writeString(l,this.oldText,I),I=k._writeString(l,this.newText,I),I}static read(l,I,y){const u=r.readUInt32BE(l,I);I+=4;const T=r.readUInt32BE(l,I);I+=4;const b=k._readString(l,I);I+=k._writeStringSize(b);const a=k._readString(l,I);return I+=k._writeStringSize(a),y.push(new k(u,b,T,a)),I}}e.TextChange=k;function L(v,l){return v===null||v.length===0?l:new R(v,l).compress()}class R{constructor(l,I){this._prevEdits=l,this._currEdits=I,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let l=0,I=0,y=this._getPrev(l),u=this._getCurr(I);for(;l<this._prevLen||I<this._currLen;){if(y===null){this._acceptCurr(u),u=this._getCurr(++I);continue}if(u===null){this._acceptPrev(y),y=this._getPrev(++l);continue}if(u.oldEnd<=y.newPosition){this._acceptCurr(u),u=this._getCurr(++I);continue}if(y.newEnd<=u.oldPosition){this._acceptPrev(y),y=this._getPrev(++l);continue}if(u.oldPosition<y.newPosition){const[p,f]=R._splitCurr(u,y.newPosition-u.oldPosition);this._acceptCurr(p),u=f;continue}if(y.newPosition<u.oldPosition){const[p,f]=R._splitPrev(y,u.oldPosition-y.newPosition);this._acceptPrev(p),y=f;continue}let a,m;if(u.oldEnd===y.newEnd)a=y,m=u,y=this._getPrev(++l),u=this._getCurr(++I);else if(u.oldEnd<y.newEnd){const[p,f]=R._splitPrev(y,u.oldLength);a=p,m=u,y=f,u=this._getCurr(++I)}else{const[p,f]=R._splitCurr(u,y.newLength);a=y,m=p,y=this._getPrev(++l),u=f}this._result[this._resultLen++]=new k(a.oldPosition,a.oldText,m.newPosition,m.newText),this._prevDeltaOffset+=a.newLength-a.oldLength,this._currDeltaOffset+=m.newLength-m.oldLength}const T=R._merge(this._result);return R._removeNoOps(T)}_acceptCurr(l){this._result[this._resultLen++]=R._rebaseCurr(this._prevDeltaOffset,l),this._currDeltaOffset+=l.newLength-l.oldLength}_getCurr(l){return l<this._currLen?this._currEdits[l]:null}_acceptPrev(l){this._result[this._resultLen++]=R._rebasePrev(this._currDeltaOffset,l),this._prevDeltaOffset+=l.newLength-l.oldLength}_getPrev(l){return l<this._prevLen?this._prevEdits[l]:null}static _rebaseCurr(l,I){return new k(I.oldPosition-l,I.oldText,I.newPosition,I.newText)}static _rebasePrev(l,I){return new k(I.oldPosition,I.oldText,I.newPosition+l,I.newText)}static _splitPrev(l,I){const y=l.newText.substr(0,I),u=l.newText.substr(I);return[new k(l.oldPosition,l.oldText,l.newPosition,y),new k(l.oldEnd,"",l.newPosition+I,u)]}static _splitCurr(l,I){const y=l.oldText.substr(0,I),u=l.oldText.substr(I);return[new k(l.oldPosition,y,l.newPosition,l.newText),new k(l.oldPosition+I,u,l.newEnd,"")]}static _merge(l){if(l.length===0)return l;const I=[];let y=0,u=l[0];for(let T=1;T<l.length;T++){const b=l[T];u.oldEnd===b.oldPosition?u=new k(u.oldPosition,u.oldText+b.oldText,u.newPosition,u.newText+b.newText):(I[y++]=u,u=b)}return I[y++]=u,I}static _removeNoOps(l){if(l.length===0)return l;const I=[];let y=0;for(let u=0;u<l.length;u++){const T=l[u];T.oldText!==T.newText&&(I[y++]=T)}return I}}}),define(Ce[199],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[200],Ie([1,0,26,28,139]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WordCharacterClassifier=e.WordCharacterClass=void 0,e.getMapForWordSeparators=v;var k;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(k||(e.WordCharacterClass=k={}));class L extends P.CharacterClassifier{constructor(I,y){super(k.Regular),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=y,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let u=0,T=I.length;u<T;u++)this.set(I.charCodeAt(u),k.WordSeparator);this.set(r.CharCode.Space,k.Whitespace),this.set(r.CharCode.Tab,k.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,y){let u=null;for(const T of this._getIntlSegmenterWordsOnLine(I)){if(T.index>y)break;u=T}return u}findNextIntlWordAtOrAfterOffset(I,y){for(const u of this._getIntlSegmenterWordsOnLine(I))if(!(u.index<y))return u;return null}_getIntlSegmenterWordsOnLine(I){return this._segmenter?this._cachedLine===I?this._cachedSegments:(this._cachedLine=I,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(I)),this._cachedSegments):[]}_filterWordSegments(I){const y=[];for(const u of I)this._isWordLike(u)&&y.push(u);return y}_isWordLike(I){return!!I.isWordLike}}e.WordCharacterClassifier=L;const R=new d.LRUCache(10);function v(l,I){const y=`${l}/${I.join(",")}`;let u=R.get(y);return u||(u=new L(l,I),R.set(y,u)),u}}),define(Ce[140],Ie([1,0,39,3,80]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.ensureValidWordDefinition=L,e.setDefaultGetWordAtTextConfig=v,e.getWordAtText=l,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function k(y=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)y.indexOf(T)>=0||(u+="\\"+T);return u+="\\s]+)",new RegExp(u,"g")}e.DEFAULT_WORD_REGEXP=k();function L(y){let u=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)u=y;else{let T="g";y.ignoreCase&&(T+="i"),y.multiline&&(T+="m"),y.unicode&&(T+="u"),u=new RegExp(y.source,T)}return u.lastIndex=0,u}const R=new P.LinkedList;R.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(y){const u=R.unshift(y);return(0,d.toDisposable)(u)}function l(y,u,T,b,a){if(u=L(u),a||(a=r.Iterable.first(R)),T.length>a.maxLen){let s=y-a.maxLen/2;return s<0?s=0:b+=s,T=T.substring(s,y+a.maxLen/2),l(y,u,T,b,a)}const m=Date.now(),p=y-1-b;let f=-1,i=null;for(let s=1;!(Date.now()-m>=a.timeBudget);s++){const t=p-a.windowSize*s;u.lastIndex=Math.max(0,t);const o=I(u,T,p,f);if(!o&&i||(i=o,t<=0))break;f=t}if(i){const s={word:i[0],startColumn:b+1+i.index,endColumn:b+1+i.index+i[0].length};return u.lastIndex=0,s}return null}function I(y,u,T,b){let a;for(;a=y.exec(u);){const m=a.index||0;if(m<=T&&y.lastIndex>=T)return a;if(b>0&&m>b)return null}return null}}),define(Ce[110],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var d;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(d||(e.FontStyle=d={}));var P;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(P||(e.ColorId=P={}));var k;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(k||(e.StandardTokenType=k={}));var L;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",v[v.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class R{static getLanguageId(l){return(l&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(l){return(l&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(l){return(l&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(l){return(l&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let y="mtk"+this.getForeground(l);const u=this.getFontStyle(l);return u&d.Italic&&(y+=" mtki"),u&d.Bold&&(y+=" mtkb"),u&d.Underline&&(y+=" mtku"),u&d.Strikethrough&&(y+=" mtks"),y}static getInlineStyleFromMetadata(l,I){const y=this.getForeground(l),u=this.getFontStyle(l);let T=`color: ${I[y]};`;u&d.Italic&&(T+="font-style: italic;"),u&d.Bold&&(T+="font-weight: bold;");let b="";return u&d.Underline&&(b+=" underline"),u&d.Strikethrough&&(b+=" line-through"),b&&(T+=`text-decoration:${b};`),T}static getPresentationFromMetadata(l){const I=this.getForeground(l),y=this.getFontStyle(l);return{foreground:I,italic:!!(y&d.Italic),bold:!!(y&d.Bold),underline:!!(y&d.Underline),strikethrough:!!(y&d.Strikethrough)}}}e.TokenMetadata=R}),define(Ce[201],Ie([1,0,38,16]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=P,e.targetsNotebooks=k;function P(L,R,v,l,I,y){if(Array.isArray(L)){let u=0;for(const T of L){const b=P(T,R,v,l,I,y);if(b===10)return b;b>u&&(u=b)}return u}else{if(typeof L=="string")return l?L==="*"?5:L===v?10:0:0;if(L){const{language:u,pattern:T,scheme:b,hasAccessToAllModels:a,notebookType:m}=L;if(!l&&!a)return 0;m&&I&&(R=I);let p=0;if(b)if(b===R.scheme)p=10;else if(b==="*")p=5;else return 0;if(u)if(u===v)p=10;else if(u==="*")p=Math.max(p,5);else return 0;if(m)if(m===y)p=10;else if(m==="*"&&y!==void 0)p=Math.max(p,5);else return 0;if(T){let f;if(typeof T=="string"?f=T:f={...T,base:(0,d.normalize)(T.base)},f===R.fsPath||(0,r.match)(f,R.fsPath))p=10;else return 0}return p}else return 0}}function k(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(k):!!L.notebookType}}),define(Ce[202],Ie([1,0,26,110]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var P;(function(v){v[v.None=0]="None",v[v.Indent=1]="Indent",v[v.IndentOutdent=2]="IndentOutdent",v[v.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class k{constructor(l){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=l.open,this.close=l.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(l.notIn))for(let I=0,y=l.notIn.length;I<y;I++)switch(l.notIn[I]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(l){switch(l){case d.StandardTokenType.Other:return!0;case d.StandardTokenType.Comment:return this._inComment;case d.StandardTokenType.String:return this._inString;case d.StandardTokenType.RegEx:return this._inRegEx}}shouldAutoClose(l,I){if(l.getTokenCount()===0)return!0;const y=l.findTokenIndexAtOffset(I-2),u=l.getStandardTokenType(y);return this.isOK(u)}_findNeutralCharacterInRange(l,I){for(let y=l;y<=I;y++){const u=String.fromCharCode(y);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(r.CharCode.Digit0,r.CharCode.Digit9)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(r.CharCode.a,r.CharCode.z)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(r.CharCode.A,r.CharCode.Z))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=k;class L{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of l)R(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),R(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),R(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),R(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&R(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.AutoClosingPairs=L;function R(v,l,I){v.has(l)?v.get(l).push(I):v.set(l,[I])}}),define(Ce[203],Ie([1,0,26,139]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkComputer=e.StateMachine=e.State=void 0,e.computeLinks=T;var P;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(P||(e.State=P={}));class k{constructor(a,m,p){const f=new Uint8Array(a*m);for(let i=0,s=a*m;i<s;i++)f[i]=p;this._data=f,this.rows=a,this.cols=m}get(a,m){return this._data[a*this.cols+m]}set(a,m,p){this._data[a*this.cols+m]=p}}class L{constructor(a){let m=0,p=P.Invalid;for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];o>m&&(m=o),t>p&&(p=t),n>p&&(p=n)}m++,p++;const f=new k(p,m,P.Invalid);for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];f.set(t,o,n)}this._states=f,this._maxCharCode=m}nextState(a,m){return m<0||m>=this._maxCharCode?P.Invalid:this._states.get(a,m)}}e.StateMachine=L;let R=null;function v(){return R===null&&(R=new L([[P.Start,r.CharCode.h,P.H],[P.Start,r.CharCode.H,P.H],[P.Start,r.CharCode.f,P.F],[P.Start,r.CharCode.F,P.F],[P.H,r.CharCode.t,P.HT],[P.H,r.CharCode.T,P.HT],[P.HT,r.CharCode.t,P.HTT],[P.HT,r.CharCode.T,P.HTT],[P.HTT,r.CharCode.p,P.HTTP],[P.HTT,r.CharCode.P,P.HTTP],[P.HTTP,r.CharCode.s,P.BeforeColon],[P.HTTP,r.CharCode.S,P.BeforeColon],[P.HTTP,r.CharCode.Colon,P.AfterColon],[P.F,r.CharCode.i,P.FI],[P.F,r.CharCode.I,P.FI],[P.FI,r.CharCode.l,P.FIL],[P.FI,r.CharCode.L,P.FIL],[P.FIL,r.CharCode.e,P.BeforeColon],[P.FIL,r.CharCode.E,P.BeforeColon],[P.BeforeColon,r.CharCode.Colon,P.AfterColon],[P.AfterColon,r.CharCode.Slash,P.AlmostThere],[P.AlmostThere,r.CharCode.Slash,P.End]])),R}var l;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let I=null;function y(){if(I===null){I=new d.CharacterClassifier(l.None);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<b.length;m++)I.set(b.charCodeAt(m),l.ForceTermination);const a=".,;:";for(let m=0;m<a.length;m++)I.set(a.charCodeAt(m),l.CannotEndIn)}return I}class u{static _createLink(a,m,p,f,i){let s=i-1;do{const t=m.charCodeAt(s);if(a.get(t)!==l.CannotEndIn)break;s--}while(s>f);if(f>0){const t=m.charCodeAt(f-1),o=m.charCodeAt(s);(t===r.CharCode.OpenParen&&o===r.CharCode.CloseParen||t===r.CharCode.OpenSquareBracket&&o===r.CharCode.CloseSquareBracket||t===r.CharCode.OpenCurlyBrace&&o===r.CharCode.CloseCurlyBrace)&&s--}return{range:{startLineNumber:p,startColumn:f+1,endLineNumber:p,endColumn:s+2},url:m.substring(f,s+1)}}static computeLinks(a,m=v()){const p=y(),f=[];for(let i=1,s=a.getLineCount();i<=s;i++){const t=a.getLineContent(i),o=t.length;let n=0,h=0,c=0,g=P.Start,w=!1,D=!1,_=!1,C=!1;for(;n<o;){let A=!1;const E=t.charCodeAt(n);if(g===P.Accept){let S;switch(E){case r.CharCode.OpenParen:w=!0,S=l.None;break;case r.CharCode.CloseParen:S=w?l.None:l.ForceTermination;break;case r.CharCode.OpenSquareBracket:_=!0,D=!0,S=l.None;break;case r.CharCode.CloseSquareBracket:_=!1,S=D?l.None:l.ForceTermination;break;case r.CharCode.OpenCurlyBrace:C=!0,S=l.None;break;case r.CharCode.CloseCurlyBrace:S=C?l.None:l.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:c===E?S=l.ForceTermination:c===r.CharCode.SingleQuote||c===r.CharCode.DoubleQuote||c===r.CharCode.BackTick?S=l.None:S=l.ForceTermination;break;case r.CharCode.Asterisk:S=c===r.CharCode.Asterisk?l.ForceTermination:l.None;break;case r.CharCode.Pipe:S=c===r.CharCode.Pipe?l.ForceTermination:l.None;break;case r.CharCode.Space:S=_?l.None:l.ForceTermination;break;default:S=p.get(E)}S===l.ForceTermination&&(f.push(u._createLink(p,t,i,h,n)),A=!0)}else if(g===P.End){let S;E===r.CharCode.OpenSquareBracket?(D=!0,S=l.None):S=p.get(E),S===l.ForceTermination?A=!0:g=P.Accept}else g=m.nextState(g,E),g===P.Invalid&&(A=!0);A&&(g=P.Start,w=!1,D=!1,C=!1,h=n+1,c=E),n++}g===P.Accept&&f.push(u._createLink(p,t,i,h,o))}return f}}e.LinkComputer=u;function T(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:u.computeLinks(b)}}),define(Ce[58],Ie([1,0,24]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.isITextSnapshot=b,e.shouldSynchronizeModel=s;var d;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(d||(e.OverviewRulerLane=d={}));var P;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(P||(e.GlyphMarginLane=P={}));var k;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(k||(e.MinimapPosition=k={}));var L;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var R;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var v;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var l;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(l||(e.DefaultEndOfLine=l={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class y{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,o.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this._indentSizeIsTabSize===o._indentSizeIsTabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,r.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class u{constructor(o,n){this._findMatchBrand=void 0,this.range=o,this.matches=n}}e.FindMatch=u;var T;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T||(e.TrackedRangeStickiness=T={}));function b(t){return t&&typeof t.read=="function"}var a;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class p{constructor(o,n,h,c,g,w){this.identifier=o,this.range=n,this.text=h,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=g,this._isTracked=w}}e.ValidAnnotatedEditOperation=p;class f{constructor(o,n,h){this.regex=o,this.wordSeparators=n,this.simpleSearch=h}}e.SearchData=f;class i{constructor(o,n,h){this.reverseEdits=o,this.changes=n,this.trimAutoWhitespaceLineNumbers=h}}e.ApplyEditsResult=i;function s(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(Ce[204],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=P,e.righttest=k,e.leftRotate=l,e.rightRotate=I,e.rbDelete=y,e.fixInsert=u,e.updateTreeMetadata=T,e.recomputeTreeMetadata=b;class r{constructor(m,p){this.piece=m,this.color=p,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return P(this.right);let m=this;for(;m.parent!==e.SENTINEL&&m.parent.left!==m;)m=m.parent;return m.parent===e.SENTINEL?e.SENTINEL:m.parent}prev(){if(this.left!==e.SENTINEL)return k(this.left);let m=this;for(;m.parent!==e.SENTINEL&&m.parent.right!==m;)m=m.parent;return m.parent===e.SENTINEL?e.SENTINEL:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=r;var d;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(d||(e.NodeColor=d={})),e.SENTINEL=new r(null,d.Black),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=d.Black;function P(a){for(;a.left!==e.SENTINEL;)a=a.left;return a}function k(a){for(;a.right!==e.SENTINEL;)a=a.right;return a}function L(a){return a===e.SENTINEL?0:a.size_left+a.piece.length+L(a.right)}function R(a){return a===e.SENTINEL?0:a.lf_left+a.piece.lineFeedCnt+R(a.right)}function v(){e.SENTINEL.parent=e.SENTINEL}function l(a,m){const p=m.right;p.size_left+=m.size_left+(m.piece?m.piece.length:0),p.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=p.left,p.left!==e.SENTINEL&&(p.left.parent=m),p.parent=m.parent,m.parent===e.SENTINEL?a.root=p:m.parent.left===m?m.parent.left=p:m.parent.right=p,p.left=m,m.parent=p}function I(a,m){const p=m.left;m.left=p.right,p.right!==e.SENTINEL&&(p.right.parent=m),p.parent=m.parent,m.size_left-=p.size_left+(p.piece?p.piece.length:0),m.lf_left-=p.lf_left+(p.piece?p.piece.lineFeedCnt:0),m.parent===e.SENTINEL?a.root=p:m===m.parent.right?m.parent.right=p:m.parent.left=p,p.right=m,m.parent=p}function y(a,m){let p,f;if(m.left===e.SENTINEL?(f=m,p=f.right):m.right===e.SENTINEL?(f=m,p=f.left):(f=P(m.right),p=f.right),f===a.root){a.root=p,p.color=d.Black,m.detach(),v(),a.root.parent=e.SENTINEL;return}const i=f.color===d.Red;if(f===f.parent.left?f.parent.left=p:f.parent.right=p,f===m?(p.parent=f.parent,b(a,p)):(f.parent===m?p.parent=f:p.parent=f.parent,b(a,p),f.left=m.left,f.right=m.right,f.parent=m.parent,f.color=m.color,m===a.root?a.root=f:m===m.parent.left?m.parent.left=f:m.parent.right=f,f.left!==e.SENTINEL&&(f.left.parent=f),f.right!==e.SENTINEL&&(f.right.parent=f),f.size_left=m.size_left,f.lf_left=m.lf_left,b(a,f)),m.detach(),p.parent.left===p){const t=L(p),o=R(p);if(t!==p.parent.size_left||o!==p.parent.lf_left){const n=t-p.parent.size_left,h=o-p.parent.lf_left;p.parent.size_left=t,p.parent.lf_left=o,T(a,p.parent,n,h)}}if(b(a,p.parent),i){v();return}let s;for(;p!==a.root&&p.color===d.Black;)p===p.parent.left?(s=p.parent.right,s.color===d.Red&&(s.color=d.Black,p.parent.color=d.Red,l(a,p.parent),s=p.parent.right),s.left.color===d.Black&&s.right.color===d.Black?(s.color=d.Red,p=p.parent):(s.right.color===d.Black&&(s.left.color=d.Black,s.color=d.Red,I(a,s),s=p.parent.right),s.color=p.parent.color,p.parent.color=d.Black,s.right.color=d.Black,l(a,p.parent),p=a.root)):(s=p.parent.left,s.color===d.Red&&(s.color=d.Black,p.parent.color=d.Red,I(a,p.parent),s=p.parent.left),s.left.color===d.Black&&s.right.color===d.Black?(s.color=d.Red,p=p.parent):(s.left.color===d.Black&&(s.right.color=d.Black,s.color=d.Red,l(a,s),s=p.parent.left),s.color=p.parent.color,p.parent.color=d.Black,s.left.color=d.Black,I(a,p.parent),p=a.root));p.color=d.Black,v()}function u(a,m){for(b(a,m);m!==a.root&&m.parent.color===d.Red;)if(m.parent===m.parent.parent.left){const p=m.parent.parent.right;p.color===d.Red?(m.parent.color=d.Black,p.color=d.Black,m.parent.parent.color=d.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,l(a,m)),m.parent.color=d.Black,m.parent.parent.color=d.Red,I(a,m.parent.parent))}else{const p=m.parent.parent.left;p.color===d.Red?(m.parent.color=d.Black,p.color=d.Black,m.parent.parent.color=d.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,I(a,m)),m.parent.color=d.Black,m.parent.parent.color=d.Red,l(a,m.parent.parent))}a.root.color=d.Black}function T(a,m,p,f){for(;m!==a.root&&m!==e.SENTINEL;)m.parent.left===m&&(m.parent.size_left+=p,m.parent.lf_left+=f),m=m.parent}function b(a,m){let p=0,f=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,p=L(m.left)-m.size_left,f=R(m.left)-m.lf_left,m.size_left+=p,m.lf_left+=f;m!==a.root&&(p!==0||f!==0);)m.parent.left===m&&(m.parent.size_left+=p,m.parent.lf_left+=f),m=m.parent}}}),define(Ce[205],Ie([1,0,18,83]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class P{constructor(v){this.values=v,this.prefixSum=new Uint32Array(v.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(v,l){v=(0,d.toUint32)(v);const I=this.values,y=this.prefixSum,u=l.length;return u===0?!1:(this.values=new Uint32Array(I.length+u),this.values.set(I.subarray(0,v),0),this.values.set(I.subarray(v),v+u),this.values.set(l,v),v-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=v-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(v,l){return v=(0,d.toUint32)(v),l=(0,d.toUint32)(l),this.values[v]===l?!1:(this.values[v]=l,v-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=v-1),!0)}removeValues(v,l){v=(0,d.toUint32)(v),l=(0,d.toUint32)(l);const I=this.values,y=this.prefixSum;if(v>=I.length)return!1;const u=I.length-v;return l>=u&&(l=u),l===0?!1:(this.values=new Uint32Array(I.length-l),this.values.set(I.subarray(0,v),0),this.values.set(I.subarray(v+l),v),this.prefixSum=new Uint32Array(this.values.length),v-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=v-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(v){return v<0?0:(v=(0,d.toUint32)(v),this._getPrefixSum(v))}_getPrefixSum(v){if(v<=this.prefixSumValidIndex[0])return this.prefixSum[v];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),v>=this.values.length&&(v=this.values.length-1);for(let I=l;I<=v;I++)this.prefixSum[I]=this.prefixSum[I-1]+this.values[I];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],v),this.prefixSum[v]}getIndexOf(v){v=Math.floor(v),this.getTotalSum();let l=0,I=this.values.length-1,y=0,u=0,T=0;for(;l<=I;)if(y=l+(I-l)/2|0,u=this.prefixSum[y],T=u-this.values[y],v<T)I=y-1;else if(v>=u)l=y+1;else break;return new L(y,v-T)}}e.PrefixSumComputer=P;class k{constructor(v){this._values=v,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(v){return this._ensureValid(),v===0?0:this._prefixSum[v-1]}getIndexOf(v){this._ensureValid();const l=this._indexBySum[v],I=l>0?this._prefixSum[l-1]:0;return new L(l,v-I)}removeValues(v,l){this._values.splice(v,l),this._invalidate(v)}insertValues(v,l){this._values=(0,r.arrayInsert)(this._values,v,l),this._invalidate(v)}_invalidate(v){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,v-1)}_ensureValid(){if(!this._isValid){for(let v=this._validEndIndex+1,l=this._values.length;v<l;v++){const I=this._values[v],y=v>0?this._prefixSum[v-1]:0;this._prefixSum[v]=y+I;for(let u=0;u<I;u++)this._indexBySum[y+u]=v}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(v,l){this._values[v]!==l&&(this._values[v]=l,this._invalidate(v))}}e.ConstantTimePrefixSumComputer=k;class L{constructor(v,l){this.index=v,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=v,this.remainder=l}}e.PrefixSumIndexOfResult=L}),define(Ce[206],Ie([1,0,12,57,205]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class k{constructor(R,v,l,I){this._uri=R,this._lines=v,this._eol=l,this._versionId=I,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(R){R.eol&&R.eol!==this._eol&&(this._eol=R.eol,this._lineStarts=null);const v=R.changes;for(const l of v)this._acceptDeleteRange(l.range),this._acceptInsertText(new d.Position(l.range.startLineNumber,l.range.startColumn),l.text);this._versionId=R.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const R=this._eol.length,v=this._lines.length,l=new Uint32Array(v);for(let I=0;I<v;I++)l[I]=this._lines[I].length+R;this._lineStarts=new P.PrefixSumComputer(l)}}_setLineText(R,v){this._lines[R]=v,this._lineStarts&&this._lineStarts.setValue(R,this._lines[R].length+this._eol.length)}_acceptDeleteRange(R){if(R.startLineNumber===R.endLineNumber){if(R.startColumn===R.endColumn)return;this._setLineText(R.startLineNumber-1,this._lines[R.startLineNumber-1].substring(0,R.startColumn-1)+this._lines[R.startLineNumber-1].substring(R.endColumn-1));return}this._setLineText(R.startLineNumber-1,this._lines[R.startLineNumber-1].substring(0,R.startColumn-1)+this._lines[R.endLineNumber-1].substring(R.endColumn-1)),this._lines.splice(R.startLineNumber,R.endLineNumber-R.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(R.startLineNumber,R.endLineNumber-R.startLineNumber)}_acceptInsertText(R,v){if(v.length===0)return;const l=(0,r.splitLines)(v);if(l.length===1){this._setLineText(R.lineNumber-1,this._lines[R.lineNumber-1].substring(0,R.column-1)+l[0]+this._lines[R.lineNumber-1].substring(R.column-1));return}l[l.length-1]+=this._lines[R.lineNumber-1].substring(R.column-1),this._setLineText(R.lineNumber-1,this._lines[R.lineNumber-1].substring(0,R.column-1)+l[0]);const I=new Uint32Array(l.length-1);for(let y=1;y<l.length;y++)this._lines.splice(R.lineNumber+y-1,0,l[y]),I[y-1]=l[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(R.lineNumber,I)}}e.MirrorTextModel=k}),define(Ce[111],Ie([1,0,26,12,200,57,30,58]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.TextModelSearch=e.SearchParams=void 0,e.isMultilineRegexSource=I,e.createFindMatch=y,e.isValidMatch=m,d=$e(d);const v=999;class l{constructor(i,s,t,o){this.searchString=i,this.isRegex=s,this.matchCase=t,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=I(this.searchString):i=this.searchString.indexOf(`
`)>=0;let s=null;try{s=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!s)return null;let t=!this.isRegex&&!i;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new R.SearchData(s,this.wordSeparators?(0,P.getMapForWordSeparators)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.SearchParams=l;function I(f){if(!f||f.length===0)return!1;for(let i=0,s=f.length;i<s;i++){const t=f.charCodeAt(i);if(t===r.CharCode.LineFeed)return!0;if(t===r.CharCode.Backslash){if(i++,i>=s)break;const o=f.charCodeAt(i);if(o===r.CharCode.n||o===r.CharCode.r||o===r.CharCode.W)return!0}}return!1}function y(f,i,s){if(!s)return new R.FindMatch(f,null);const t=[];for(let o=0,n=i.length;o<n;o++)t[o]=i[o];return new R.FindMatch(f,t)}class u{constructor(i){const s=[];let t=0;for(let o=0,n=i.length;o<n;o++)i.charCodeAt(o)===r.CharCode.LineFeed&&(s[t++]=o);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(i){const s=this._lineFeedsOffsets;let t=0,o=s.length-1;if(o===-1||i<=s[0])return 0;for(;t<o;){const n=t+((o-t)/2>>0);s[n]>=i?o=n-1:s[n+1]>=i?(t=n,o=n):t=n+1}return t+1}}class T{static findMatches(i,s,t,o,n){const h=s.parseSearchRequest();return h?h.regex.multiline?this._doFindMatchesMultiline(i,t,new p(h.wordSeparators,h.regex),o,n):this._doFindMatchesLineByLine(i,t,h,o,n):[]}static _getMultilineMatchRange(i,s,t,o,n,h){let c,g=0;o?(g=o.findLineFeedCountBeforeOffset(n),c=s+n+g):c=s+n;let w;if(o){const A=o.findLineFeedCountBeforeOffset(n+h.length)-g;w=c+h.length+A}else w=c+h.length;const D=i.getPositionAt(c),_=i.getPositionAt(w);return new L.Range(D.lineNumber,D.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(i,s,t,o,n){const h=i.getOffsetAt(s.getStartPosition()),c=i.getValueInRange(s,R.EndOfLinePreference.LF),g=i.getEOL()===`\r
`?new u(c):null,w=[];let D=0,_;for(t.reset(0);_=t.next(c);)if(w[D++]=y(this._getMultilineMatchRange(i,h,c,g,_.index,_[0]),_,o),D>=n)return w;return w}static _doFindMatchesLineByLine(i,s,t,o,n){const h=[];let c=0;if(s.startLineNumber===s.endLineNumber){const w=i.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return c=this._findMatchesInLine(t,w,s.startLineNumber,s.startColumn-1,c,h,o,n),h}const g=i.getLineContent(s.startLineNumber).substring(s.startColumn-1);c=this._findMatchesInLine(t,g,s.startLineNumber,s.startColumn-1,c,h,o,n);for(let w=s.startLineNumber+1;w<s.endLineNumber&&c<n;w++)c=this._findMatchesInLine(t,i.getLineContent(w),w,0,c,h,o,n);if(c<n){const w=i.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);c=this._findMatchesInLine(t,w,s.endLineNumber,0,c,h,o,n)}return h}static _findMatchesInLine(i,s,t,o,n,h,c,g){const w=i.wordSeparators;if(!c&&i.simpleSearch){const C=i.simpleSearch,A=C.length,E=s.length;let S=-A;for(;(S=s.indexOf(C,S+A))!==-1;)if((!w||m(w,s,E,S,A))&&(h[n++]=new R.FindMatch(new L.Range(t,S+1+o,t,S+1+A+o),null),n>=g))return n;return n}const D=new p(i.wordSeparators,i.regex);let _;D.reset(0);do if(_=D.next(s),_&&(h[n++]=y(new L.Range(t,_.index+1+o,t,_.index+1+_[0].length+o),_,c),n>=g))return n;while(_);return n}static findNextMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const h=new p(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(i,t,h,o):this._doFindNextMatchLineByLine(i,t,h,o)}static _doFindNextMatchMultiline(i,s,t,o){const n=new k.Position(s.lineNumber,1),h=i.getOffsetAt(n),c=i.getLineCount(),g=i.getValueInRange(new L.Range(n.lineNumber,n.column,c,i.getLineMaxColumn(c)),R.EndOfLinePreference.LF),w=i.getEOL()===`\r
`?new u(g):null;t.reset(s.column-1);const D=t.next(g);return D?y(this._getMultilineMatchRange(i,h,g,w,D.index,D[0]),D,o):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(i,new k.Position(1,1),t,o):null}static _doFindNextMatchLineByLine(i,s,t,o){const n=i.getLineCount(),h=s.lineNumber,c=i.getLineContent(h),g=this._findFirstMatchInLine(t,c,h,s.column,o);if(g)return g;for(let w=1;w<=n;w++){const D=(h+w-1)%n,_=i.getLineContent(D+1),C=this._findFirstMatchInLine(t,_,D+1,1,o);if(C)return C}return null}static _findFirstMatchInLine(i,s,t,o,n){i.reset(o-1);const h=i.next(s);return h?y(new L.Range(t,h.index+1,t,h.index+1+h[0].length),h,n):null}static findPreviousMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const h=new p(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(i,t,h,o):this._doFindPreviousMatchLineByLine(i,t,h,o)}static _doFindPreviousMatchMultiline(i,s,t,o){const n=this._doFindMatchesMultiline(i,new L.Range(1,1,s.lineNumber,s.column),t,o,10*v);if(n.length>0)return n[n.length-1];const h=i.getLineCount();return s.lineNumber!==h||s.column!==i.getLineMaxColumn(h)?this._doFindPreviousMatchMultiline(i,new k.Position(h,i.getLineMaxColumn(h)),t,o):null}static _doFindPreviousMatchLineByLine(i,s,t,o){const n=i.getLineCount(),h=s.lineNumber,c=i.getLineContent(h).substring(0,s.column-1),g=this._findLastMatchInLine(t,c,h,o);if(g)return g;for(let w=1;w<=n;w++){const D=(n+h-w-1)%n,_=i.getLineContent(D+1),C=this._findLastMatchInLine(t,_,D+1,o);if(C)return C}return null}static _findLastMatchInLine(i,s,t,o){let n=null,h;for(i.reset(0);h=i.next(s);)n=y(new L.Range(t,h.index+1,t,h.index+1+h[0].length),h,o);return n}}e.TextModelSearch=T;function b(f,i,s,t,o){if(t===0)return!0;const n=i.charCodeAt(t-1);if(f.get(n)!==P.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const h=i.charCodeAt(t);if(f.get(h)!==P.WordCharacterClass.Regular)return!0}return!1}function a(f,i,s,t,o){if(t+o===s)return!0;const n=i.charCodeAt(t+o);if(f.get(n)!==P.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const h=i.charCodeAt(t+o-1);if(f.get(h)!==P.WordCharacterClass.Regular)return!0}return!1}function m(f,i,s,t,o){return b(f,i,s,t,o)&&a(f,i,s,t,o)}class p{constructor(i,s){this._wordSeparators=i,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(i){this._searchRegex.lastIndex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(i){const s=i.length;let t;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(t=this._searchRegex.exec(i),!t))return null;const o=t.index,n=t[0].length;if(o===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){d.getNextCodePoint(i,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=n,!this._wordSeparators||m(this._wordSeparators,i,s,o,n))return t}while(t);return null}}e.Searcher=p}),define(Ce[141],Ie([1,0,26,57,30,58,204,111]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=y,e.createLineStarts=u;const v=65535;function l(f){let i;return f[f.length-1]<65536?i=new Uint16Array(f.length):i=new Uint32Array(f.length),i.set(f,0),i}class I{constructor(i,s,t,o,n){this.lineStarts=i,this.cr=s,this.lf=t,this.crlf=o,this.isBasicASCII=n}}function y(f,i=!0){const s=[0];let t=1;for(let o=0,n=f.length;o<n;o++){const h=f.charCodeAt(o);h===r.CharCode.CarriageReturn?o+1<n&&f.charCodeAt(o+1)===r.CharCode.LineFeed?(s[t++]=o+2,o++):s[t++]=o+1:h===r.CharCode.LineFeed&&(s[t++]=o+1)}return i?l(s):s}function u(f,i){f.length=0,f[0]=0;let s=1,t=0,o=0,n=0,h=!0;for(let g=0,w=i.length;g<w;g++){const D=i.charCodeAt(g);D===r.CharCode.CarriageReturn?g+1<w&&i.charCodeAt(g+1)===r.CharCode.LineFeed?(n++,f[s++]=g+2,g++):(t++,f[s++]=g+1):D===r.CharCode.LineFeed?(o++,f[s++]=g+1):h&&D!==r.CharCode.Tab&&(D<32||D>126)&&(h=!1)}const c=new I(l(f),t,o,n,h);return f.length=0,c}class T{constructor(i,s,t,o,n){this.bufferIndex=i,this.start=s,this.end=t,this.lineFeedCnt=o,this.length=n}}e.Piece=T;class b{constructor(i,s){this.buffer=i,this.lineStarts=s}}e.StringBuffer=b;class a{constructor(i,s){this._pieces=[],this._tree=i,this._BOM=s,this._index=0,i.root!==L.SENTINEL&&i.iterate(i.root,t=>(t!==L.SENTINEL&&this._pieces.push(t.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class m{constructor(i){this._limit=i,this._cache=[]}get(i){for(let s=this._cache.length-1;s>=0;s--){const t=this._cache[s];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let s=this._cache.length-1;s>=0;s--){const t=this._cache[s];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(i)}validate(i){let s=!1;const t=this._cache;for(let o=0;o<t.length;o++){const n=t[o];if(n.node.parent===null||n.nodeStartOffset>=i){t[o]=null,s=!0;continue}}if(s){const o=[];for(const n of t)n!==null&&o.push(n);this._cache=o}}}class p{constructor(i,s,t){this.create(i,s,t)}create(i,s,t){this._buffers=[new b("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=L.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=s,this._EOLLength=s.length,this._EOLNormalized=t;let o=null;for(let n=0,h=i.length;n<h;n++)if(i[n].buffer.length>0){i[n].lineStarts||(i[n].lineStarts=y(i[n].buffer));const c=new T(n+1,{line:0,column:0},{line:i[n].lineStarts.length-1,column:i[n].buffer.length-i[n].lineStarts[i[n].lineStarts.length-1]},i[n].lineStarts.length-1,i[n].buffer.length);this._buffers.push(i[n]),o=this.rbInsertRight(o,c)}this._searchCache=new m(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(i){const s=v,t=s-Math.floor(s/3),o=t*2;let n="",h=0;const c=[];if(this.iterate(this.root,g=>{const w=this.getNodeContent(g),D=w.length;if(h<=t||h+D<o)return n+=w,h+=D,!0;const _=n.replace(/\r\n|\r|\n/g,i);return c.push(new b(_,y(_))),n=w,h=D,!0}),h>0){const g=n.replace(/\r\n|\r|\n/g,i);c.push(new b(g,y(g)))}this.create(c,i,!0)}getEOL(){return this._EOL}setEOL(i){this._EOL=i,this._EOLLength=this._EOL.length,this.normalizeEOL(i)}createSnapshot(i){return new a(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let s=0;return this.iterate(this.root,o=>{if(o===L.SENTINEL)return!0;const n=this.getNodeContent(o),h=n.length,c=i.nodeAt(s),g=i.nodeAt(s+h),w=i.getValueInRange2(c,g);return s+=h,n===w})}getOffsetAt(i,s){let t=0,o=this.root;for(;o!==L.SENTINEL;)if(o.left!==L.SENTINEL&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const n=this.getAccumulatedValue(o,i-o.lf_left-2);return t+=n+s-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let s=this.root,t=0;const o=i;for(;s!==L.SENTINEL;)if(s.size_left!==0&&s.size_left>=i)s=s.left;else if(s.size_left+s.piece.length>=i){const n=this.getIndexOf(s,i-s.size_left);if(t+=s.lf_left+n.index,n.index===0){const h=this.getOffsetAt(t+1,1),c=o-h;return new d.Position(t+1,c+1)}return new d.Position(t+1,n.remainder+1)}else if(i-=s.size_left+s.piece.length,t+=s.lf_left+s.piece.lineFeedCnt,s.right===L.SENTINEL){const n=this.getOffsetAt(t+1,1),h=o-i-n;return new d.Position(t+1,h+1)}else s=s.right;return new d.Position(1,1)}getValueInRange(i,s){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.nodeAt2(i.startLineNumber,i.startColumn),o=this.nodeAt2(i.endLineNumber,i.endColumn),n=this.getValueInRange2(t,o);return s?s!==this._EOL||!this._EOLNormalized?n.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this._EOLNormalized?n:n.replace(/\r\n|\r|\n/g,s):n}getValueInRange2(i,s){if(i.node===s.node){const c=i.node,g=this._buffers[c.piece.bufferIndex].buffer,w=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);return g.substring(w+i.remainder,w+s.remainder)}let t=i.node;const o=this._buffers[t.piece.bufferIndex].buffer,n=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);let h=o.substring(n+i.remainder,n+t.piece.length);for(t=t.next();t!==L.SENTINEL;){const c=this._buffers[t.piece.bufferIndex].buffer,g=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(t===s.node){h+=c.substring(g,g+s.remainder);break}else h+=c.substr(g,t.piece.length);t=t.next()}return h}getLinesContent(){const i=[];let s=0,t="",o=!1;return this.iterate(this.root,n=>{if(n===L.SENTINEL)return!0;const h=n.piece;let c=h.length;if(c===0)return!0;const g=this._buffers[h.bufferIndex].buffer,w=this._buffers[h.bufferIndex].lineStarts,D=h.start.line,_=h.end.line;let C=w[D]+h.start.column;if(o&&(g.charCodeAt(C)===r.CharCode.LineFeed&&(C++,c--),i[s++]=t,t="",o=!1,c===0))return!0;if(D===_)return!this._EOLNormalized&&g.charCodeAt(C+c-1)===r.CharCode.CarriageReturn?(o=!0,t+=g.substr(C,c-1)):t+=g.substr(C,c),!0;t+=this._EOLNormalized?g.substring(C,Math.max(C,w[D+1]-this._EOLLength)):g.substring(C,w[D+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;for(let A=D+1;A<_;A++)t=this._EOLNormalized?g.substring(w[A],w[A+1]-this._EOLLength):g.substring(w[A],w[A+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;return!this._EOLNormalized&&g.charCodeAt(w[_]+h.end.column-1)===r.CharCode.CarriageReturn?(o=!0,h.end.column===0?s--:t=g.substr(w[_],h.end.column-1)):t=g.substr(w[_],h.end.column),!0}),o&&(i[s++]=t,t=""),i[s++]=t,i}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(i){return this._lastVisitedLine.lineNumber===i?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=i,i===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(i):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(i,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(i){if(i.remainder===i.node.piece.length){const s=i.node.next();if(!s)return 0;const t=this._buffers[s.piece.bufferIndex],o=this.offsetInBuffer(s.piece.bufferIndex,s.piece.start);return t.buffer.charCodeAt(o)}else{const s=this._buffers[i.node.piece.bufferIndex],o=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return s.buffer.charCodeAt(o)}}getLineCharCode(i,s){const t=this.nodeAt2(i,s+1);return this._getCharCode(t)}getLineLength(i){if(i===this.getLineCount()){const s=this.getOffsetAt(i,1);return this.getLength()-s}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this._EOLLength}getCharCode(i){const s=this.nodeAt(i);return this._getCharCode(s)}getNearestChunk(i){const s=this.nodeAt(i);if(s.remainder===s.node.piece.length){const t=s.node.next();if(!t||t===L.SENTINEL)return"";const o=this._buffers[t.piece.bufferIndex],n=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(n,n+t.piece.length)}else{const t=this._buffers[s.node.piece.bufferIndex],o=this.offsetInBuffer(s.node.piece.bufferIndex,s.node.piece.start),n=o+s.remainder,h=o+s.node.piece.length;return t.buffer.substring(n,h)}}findMatchesInNode(i,s,t,o,n,h,c,g,w,D,_){const C=this._buffers[i.piece.bufferIndex],A=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start),E=this.offsetInBuffer(i.piece.bufferIndex,n),S=this.offsetInBuffer(i.piece.bufferIndex,h);let F;const N={line:0,column:0};let O,M;s._wordSeparators?(O=C.buffer.substring(E,S),M=U=>U+E,s.reset(0)):(O=C.buffer,M=U=>U,s.reset(E));do if(F=s.next(O),F){if(M(F.index)>=S)return D;this.positionInBuffer(i,M(F.index)-A,N);const U=this.getLineFeedCnt(i.piece.bufferIndex,n,N),x=N.line===n.line?N.column-n.column+o:N.column+1,z=x+F[0].length;if(_[D++]=(0,R.createFindMatch)(new P.Range(t+U,x,t+U,z),F,g),M(F.index)+F[0].length>=S||D>=w)return D}while(F);return D}findMatchesLineByLine(i,s,t,o){const n=[];let h=0;const c=new R.Searcher(s.wordSeparators,s.regex);let g=this.nodeAt2(i.startLineNumber,i.startColumn);if(g===null)return[];const w=this.nodeAt2(i.endLineNumber,i.endColumn);if(w===null)return[];let D=this.positionInBuffer(g.node,g.remainder);const _=this.positionInBuffer(w.node,w.remainder);if(g.node===w.node)return this.findMatchesInNode(g.node,c,i.startLineNumber,i.startColumn,D,_,s,t,o,h,n),n;let C=i.startLineNumber,A=g.node;for(;A!==w.node;){const S=this.getLineFeedCnt(A.piece.bufferIndex,D,A.piece.end);if(S>=1){const N=this._buffers[A.piece.bufferIndex].lineStarts,O=this.offsetInBuffer(A.piece.bufferIndex,A.piece.start),M=N[D.line+S],U=C===i.startLineNumber?i.startColumn:1;if(h=this.findMatchesInNode(A,c,C,U,D,this.positionInBuffer(A,M-O),s,t,o,h,n),h>=o)return n;C+=S}const F=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const N=this.getLineContent(C).substring(F,i.endColumn-1);return h=this._findMatchesInLine(s,c,N,i.endLineNumber,F,h,n,t,o),n}if(h=this._findMatchesInLine(s,c,this.getLineContent(C).substr(F),C,F,h,n,t,o),h>=o)return n;C++,g=this.nodeAt2(C,1),A=g.node,D=this.positionInBuffer(g.node,g.remainder)}if(C===i.endLineNumber){const S=C===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(C).substring(S,i.endColumn-1);return h=this._findMatchesInLine(s,c,F,i.endLineNumber,S,h,n,t,o),n}const E=C===i.startLineNumber?i.startColumn:1;return h=this.findMatchesInNode(w.node,c,C,E,D,_,s,t,o,h,n),n}_findMatchesInLine(i,s,t,o,n,h,c,g,w){const D=i.wordSeparators;if(!g&&i.simpleSearch){const C=i.simpleSearch,A=C.length,E=t.length;let S=-A;for(;(S=t.indexOf(C,S+A))!==-1;)if((!D||(0,R.isValidMatch)(D,t,E,S,A))&&(c[h++]=new k.FindMatch(new P.Range(o,S+1+n,o,S+1+A+n),null),h>=w))return h;return h}let _;s.reset(0);do if(_=s.next(t),_&&(c[h++]=(0,R.createFindMatch)(new P.Range(o,_.index+1+n,o,_.index+1+_[0].length+n),_,g),h>=w))return h;while(_);return h}insert(i,s,t=!1){if(this._EOLNormalized=this._EOLNormalized&&t,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==L.SENTINEL){const{node:o,remainder:n,nodeStartOffset:h}=this.nodeAt(i),c=o.piece,g=c.bufferIndex,w=this.positionInBuffer(o,n);if(o.piece.bufferIndex===0&&c.end.line===this._lastChangeBufferPos.line&&c.end.column===this._lastChangeBufferPos.column&&h+c.length===i&&s.length<v){this.appendToNode(o,s),this.computeBufferMetadata();return}if(h===i)this.insertContentToNodeLeft(s,o),this._searchCache.validate(i);else if(h+o.piece.length>i){const D=[];let _=new T(c.bufferIndex,w,c.end,this.getLineFeedCnt(c.bufferIndex,w,c.end),this.offsetInBuffer(g,c.end)-this.offsetInBuffer(g,w));if(this.shouldCheckCRLF()&&this.endWithCR(s)&&this.nodeCharCodeAt(o,n)===10){const S={line:_.start.line+1,column:0};_=new T(_.bufferIndex,S,_.end,this.getLineFeedCnt(_.bufferIndex,S,_.end),_.length-1),s+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(s))if(this.nodeCharCodeAt(o,n-1)===13){const S=this.positionInBuffer(o,n-1);this.deleteNodeTail(o,S),s="\r"+s,o.piece.length===0&&D.push(o)}else this.deleteNodeTail(o,w);else this.deleteNodeTail(o,w);const C=this.createNewPieces(s);_.length>0&&this.rbInsertRight(o,_);let A=o;for(let E=0;E<C.length;E++)A=this.rbInsertRight(A,C[E]);this.deleteNodes(D)}else this.insertContentToNodeRight(s,o)}else{const o=this.createNewPieces(s);let n=this.rbInsertLeft(null,o[0]);for(let h=1;h<o.length;h++)n=this.rbInsertRight(n,o[h])}this.computeBufferMetadata()}delete(i,s){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",s<=0||this.root===L.SENTINEL)return;const t=this.nodeAt(i),o=this.nodeAt(i+s),n=t.node,h=o.node;if(n===h){const C=this.positionInBuffer(n,t.remainder),A=this.positionInBuffer(n,o.remainder);if(t.nodeStartOffset===i){if(s===n.piece.length){const E=n.next();(0,L.rbDelete)(this,n),this.validateCRLFWithPrevNode(E),this.computeBufferMetadata();return}this.deleteNodeHead(n,A),this._searchCache.validate(i),this.validateCRLFWithPrevNode(n),this.computeBufferMetadata();return}if(t.nodeStartOffset+n.piece.length===i+s){this.deleteNodeTail(n,C),this.validateCRLFWithNextNode(n),this.computeBufferMetadata();return}this.shrinkNode(n,C,A),this.computeBufferMetadata();return}const c=[],g=this.positionInBuffer(n,t.remainder);this.deleteNodeTail(n,g),this._searchCache.validate(i),n.piece.length===0&&c.push(n);const w=this.positionInBuffer(h,o.remainder);this.deleteNodeHead(h,w),h.piece.length===0&&c.push(h);const D=n.next();for(let C=D;C!==L.SENTINEL&&C!==h;C=C.next())c.push(C);const _=n.piece.length===0?n.prev():n;this.deleteNodes(c),this.validateCRLFWithNextNode(_),this.computeBufferMetadata()}insertContentToNodeLeft(i,s){const t=[];if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.startWithLF(s)){const h=s.piece,c={line:h.start.line+1,column:0},g=new T(h.bufferIndex,c,h.end,this.getLineFeedCnt(h.bufferIndex,c,h.end),h.length-1);s.piece=g,i+=`
`,(0,L.updateTreeMetadata)(this,s,-1,-1),s.piece.length===0&&t.push(s)}const o=this.createNewPieces(i);let n=this.rbInsertLeft(s,o[o.length-1]);for(let h=o.length-2;h>=0;h--)n=this.rbInsertLeft(n,o[h]);this.validateCRLFWithPrevNode(n),this.deleteNodes(t)}insertContentToNodeRight(i,s){this.adjustCarriageReturnFromNext(i,s)&&(i+=`
`);const t=this.createNewPieces(i),o=this.rbInsertRight(s,t[0]);let n=o;for(let h=1;h<t.length;h++)n=this.rbInsertRight(n,t[h]);this.validateCRLFWithPrevNode(o)}positionInBuffer(i,s,t){const o=i.piece,n=i.piece.bufferIndex,h=this._buffers[n].lineStarts,g=h[o.start.line]+o.start.column+s;let w=o.start.line,D=o.end.line,_=0,C=0,A=0;for(;w<=D&&(_=w+(D-w)/2|0,A=h[_],_!==D);)if(C=h[_+1],g<A)D=_-1;else if(g>=C)w=_+1;else break;return t?(t.line=_,t.column=g-A,null):{line:_,column:g-A}}getLineFeedCnt(i,s,t){if(t.column===0)return t.line-s.line;const o=this._buffers[i].lineStarts;if(t.line===o.length-1)return t.line-s.line;const n=o[t.line+1],h=o[t.line]+t.column;if(n>h+1)return t.line-s.line;const c=h-1;return this._buffers[i].buffer.charCodeAt(c)===13?t.line-s.line+1:t.line-s.line}offsetInBuffer(i,s){return this._buffers[i].lineStarts[s.line]+s.column}deleteNodes(i){for(let s=0;s<i.length;s++)(0,L.rbDelete)(this,i[s])}createNewPieces(i){if(i.length>v){const D=[];for(;i.length>v;){const C=i.charCodeAt(v-1);let A;C===r.CharCode.CarriageReturn||C>=55296&&C<=56319?(A=i.substring(0,v-1),i=i.substring(v-1)):(A=i.substring(0,v),i=i.substring(v));const E=y(A);D.push(new T(this._buffers.length,{line:0,column:0},{line:E.length-1,column:A.length-E[E.length-1]},E.length-1,A.length)),this._buffers.push(new b(A,E))}const _=y(i);return D.push(new T(this._buffers.length,{line:0,column:0},{line:_.length-1,column:i.length-_[_.length-1]},_.length-1,i.length)),this._buffers.push(new b(i,_)),D}let s=this._buffers[0].buffer.length;const t=y(i,!1);let o=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===s&&s!==0&&this.startWithLF(i)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},o=this._lastChangeBufferPos;for(let D=0;D<t.length;D++)t[D]+=s+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+="_"+i,s+=1}else{if(s!==0)for(let D=0;D<t.length;D++)t[D]+=s;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+=i}const n=this._buffers[0].buffer.length,h=this._buffers[0].lineStarts.length-1,c=n-this._buffers[0].lineStarts[h],g={line:h,column:c},w=new T(0,o,g,this.getLineFeedCnt(0,o,g),n-s);return this._lastChangeBufferPos=g,[w]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(i,s=0){let t=this.root,o="";const n=this._searchCache.get2(i);if(n){t=n.node;const h=this.getAccumulatedValue(t,i-n.nodeStartLineNumber-1),c=this._buffers[t.piece.bufferIndex].buffer,g=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(n.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=c.substring(g+h,g+t.piece.length);else{const w=this.getAccumulatedValue(t,i-n.nodeStartLineNumber);return c.substring(g+h,g+w-s)}}else{let h=0;const c=i;for(;t!==L.SENTINEL;)if(t.left!==L.SENTINEL&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const g=this.getAccumulatedValue(t,i-t.lf_left-2),w=this.getAccumulatedValue(t,i-t.lf_left-1),D=this._buffers[t.piece.bufferIndex].buffer,_=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return h+=t.size_left,this._searchCache.set({node:t,nodeStartOffset:h,nodeStartLineNumber:c-(i-1-t.lf_left)}),D.substring(_+g,_+w-s)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const g=this.getAccumulatedValue(t,i-t.lf_left-2),w=this._buffers[t.piece.bufferIndex].buffer,D=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);o=w.substring(D+g,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,h+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==L.SENTINEL;){const h=this._buffers[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const c=this.getAccumulatedValue(t,0),g=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return o+=h.substring(g,g+c-s),o}else{const c=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);o+=h.substr(c,t.piece.length)}t=t.next()}return o}computeBufferMetadata(){let i=this.root,s=1,t=0;for(;i!==L.SENTINEL;)s+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this._lineCnt=s,this._length=t,this._searchCache.validate(this._length)}getIndexOf(i,s){const t=i.piece,o=this.positionInBuffer(i,s),n=o.line-t.start.line;if(this.offsetInBuffer(t.bufferIndex,t.end)-this.offsetInBuffer(t.bufferIndex,t.start)===s){const h=this.getLineFeedCnt(i.piece.bufferIndex,t.start,o);if(h!==n)return{index:h,remainder:0}}return{index:n,remainder:o.column}}getAccumulatedValue(i,s){if(s<0)return 0;const t=i.piece,o=this._buffers[t.bufferIndex].lineStarts,n=t.start.line+s+1;return n>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[n]-o[t.start.line]-t.start.column}deleteNodeTail(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.offsetInBuffer(t.bufferIndex,t.end),h=s,c=this.offsetInBuffer(t.bufferIndex,h),g=this.getLineFeedCnt(t.bufferIndex,t.start,h),w=g-o,D=c-n,_=t.length+D;i.piece=new T(t.bufferIndex,t.start,h,g,_),(0,L.updateTreeMetadata)(this,i,D,w)}deleteNodeHead(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.offsetInBuffer(t.bufferIndex,t.start),h=s,c=this.getLineFeedCnt(t.bufferIndex,h,t.end),g=this.offsetInBuffer(t.bufferIndex,h),w=c-o,D=n-g,_=t.length+D;i.piece=new T(t.bufferIndex,h,t.end,c,_),(0,L.updateTreeMetadata)(this,i,D,w)}shrinkNode(i,s,t){const o=i.piece,n=o.start,h=o.end,c=o.length,g=o.lineFeedCnt,w=s,D=this.getLineFeedCnt(o.bufferIndex,o.start,w),_=this.offsetInBuffer(o.bufferIndex,s)-this.offsetInBuffer(o.bufferIndex,n);i.piece=new T(o.bufferIndex,o.start,w,D,_),(0,L.updateTreeMetadata)(this,i,_-c,D-g);const C=new T(o.bufferIndex,t,h,this.getLineFeedCnt(o.bufferIndex,t,h),this.offsetInBuffer(o.bufferIndex,h)-this.offsetInBuffer(o.bufferIndex,t)),A=this.rbInsertRight(i,C);this.validateCRLFWithPrevNode(A)}appendToNode(i,s){this.adjustCarriageReturnFromNext(s,i)&&(s+=`
`);const t=this.shouldCheckCRLF()&&this.startWithLF(s)&&this.endWithCR(i),o=this._buffers[0].buffer.length;this._buffers[0].buffer+=s;const n=y(s,!1);for(let A=0;A<n.length;A++)n[A]+=o;if(t){const A=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:o-A}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(n.slice(1));const h=this._buffers[0].lineStarts.length-1,c=this._buffers[0].buffer.length-this._buffers[0].lineStarts[h],g={line:h,column:c},w=i.piece.length+s.length,D=i.piece.lineFeedCnt,_=this.getLineFeedCnt(0,i.piece.start,g),C=_-D;i.piece=new T(i.piece.bufferIndex,i.piece.start,g,_,w),this._lastChangeBufferPos=g,(0,L.updateTreeMetadata)(this,i,s.length,C)}nodeAt(i){let s=this.root;const t=this._searchCache.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;s!==L.SENTINEL;)if(s.size_left>i)s=s.left;else if(s.size_left+s.piece.length>=i){o+=s.size_left;const n={node:s,remainder:i-s.size_left,nodeStartOffset:o};return this._searchCache.set(n),n}else i-=s.size_left+s.piece.length,o+=s.size_left+s.piece.length,s=s.right;return null}nodeAt2(i,s){let t=this.root,o=0;for(;t!==L.SENTINEL;)if(t.left!==L.SENTINEL&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const n=this.getAccumulatedValue(t,i-t.lf_left-2),h=this.getAccumulatedValue(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(n+s-1,h),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const n=this.getAccumulatedValue(t,i-t.lf_left-2);if(n+s-1<=t.piece.length)return{node:t,remainder:n+s-1,nodeStartOffset:o};s-=t.piece.length-n;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==L.SENTINEL;){if(t.piece.lineFeedCnt>0){const n=this.getAccumulatedValue(t,0),h=this.offsetOfNode(t);return{node:t,remainder:Math.min(s-1,n),nodeStartOffset:h}}else if(t.piece.length>=s-1){const n=this.offsetOfNode(t);return{node:t,remainder:s-1,nodeStartOffset:n}}else s-=t.piece.length;t=t.next()}return null}nodeCharCodeAt(i,s){if(i.piece.lineFeedCnt<1)return-1;const t=this._buffers[i.piece.bufferIndex],o=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start)+s;return t.buffer.charCodeAt(o)}offsetOfNode(i){if(!i)return 0;let s=i.size_left;for(;i!==this.root;)i.parent.right===i&&(s+=i.parent.size_left+i.parent.piece.length),i=i.parent;return s}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.SENTINEL||i.piece.lineFeedCnt===0)return!1;const s=i.piece,t=this._buffers[s.bufferIndex].lineStarts,o=s.start.line,n=t[o]+s.start.column;return o===t.length-1||t[o+1]>n+1?!1:this._buffers[s.bufferIndex].buffer.charCodeAt(n)===10}endWithCR(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.SENTINEL||i.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(i,i.piece.length-1)===13}validateCRLFWithPrevNode(i){if(this.shouldCheckCRLF()&&this.startWithLF(i)){const s=i.prev();this.endWithCR(s)&&this.fixCRLF(s,i)}}validateCRLFWithNextNode(i){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const s=i.next();this.startWithLF(s)&&this.fixCRLF(i,s)}}fixCRLF(i,s){const t=[],o=this._buffers[i.piece.bufferIndex].lineStarts;let n;i.piece.end.column===0?n={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:n={line:i.piece.end.line,column:i.piece.end.column-1};const h=i.piece.length-1,c=i.piece.lineFeedCnt-1;i.piece=new T(i.piece.bufferIndex,i.piece.start,n,c,h),(0,L.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&t.push(i);const g={line:s.piece.start.line+1,column:0},w=s.piece.length-1,D=this.getLineFeedCnt(s.piece.bufferIndex,g,s.piece.end);s.piece=new T(s.piece.bufferIndex,g,s.piece.end,D,w),(0,L.updateTreeMetadata)(this,s,-1,-1),s.piece.length===0&&t.push(s);const _=this.createNewPieces(`\r
`);this.rbInsertRight(i,_[0]);for(let C=0;C<t.length;C++)(0,L.rbDelete)(this,t[C])}adjustCarriageReturnFromNext(i,s){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const t=s.next();if(this.startWithLF(t)){if(i+=`
`,t.piece.length===1)(0,L.rbDelete)(this,t);else{const o=t.piece,n={line:o.start.line+1,column:0},h=o.length-1,c=this.getLineFeedCnt(o.bufferIndex,n,o.end);t.piece=new T(o.bufferIndex,n,o.end,c,h),(0,L.updateTreeMetadata)(this,t,-1,-1)}return!0}}return!1}iterate(i,s){if(i===L.SENTINEL)return s(L.SENTINEL);const t=this.iterate(i.left,s);return t&&s(i)&&this.iterate(i.right,s)}getNodeContent(i){if(i===L.SENTINEL)return"";const s=this._buffers[i.piece.bufferIndex],t=i.piece,o=this.offsetInBuffer(t.bufferIndex,t.start),n=this.offsetInBuffer(t.bufferIndex,t.end);return s.buffer.substring(o,n)}getPieceContent(i){const s=this._buffers[i.bufferIndex],t=this.offsetInBuffer(i.bufferIndex,i.start),o=this.offsetInBuffer(i.bufferIndex,i.end);return s.buffer.substring(t,o)}rbInsertRight(i,s){const t=new L.TreeNode(s,L.NodeColor.Red);if(t.left=L.SENTINEL,t.right=L.SENTINEL,t.parent=L.SENTINEL,t.size_left=0,t.lf_left=0,this.root===L.SENTINEL)this.root=t,t.color=L.NodeColor.Black;else if(i.right===L.SENTINEL)i.right=t,t.parent=i;else{const n=(0,L.leftest)(i.right);n.left=t,t.parent=n}return(0,L.fixInsert)(this,t),t}rbInsertLeft(i,s){const t=new L.TreeNode(s,L.NodeColor.Red);if(t.left=L.SENTINEL,t.right=L.SENTINEL,t.parent=L.SENTINEL,t.size_left=0,t.lf_left=0,this.root===L.SENTINEL)this.root=t,t.color=L.NodeColor.Black;else if(i.left===L.SENTINEL)i.left=t,t.parent=i;else{const o=(0,L.righttest)(i.left);o.right=t,t.parent=o}return(0,L.fixInsert)(this,t),t}getContentOfSubTree(i){let s="";return this.iterate(i,t=>(s+=this.getNodeContent(t),!0)),s}}e.PieceTreeBase=p}),define(Ce[207],Ie([1,0,4,12,30,58,141,194,198,3]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0,d=$e(d);class I extends l.Disposable{constructor(u,T,b,a,m,p,f){super(),this._onDidChangeContent=this._register(new r.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=T,this._mightContainNonBasicASCII=!p,this._mightContainRTL=a,this._mightContainUnusualLineTerminators=m,this._pieceTree=new L.PieceTreeBase(u,b,f)}equals(u){return!(u instanceof I)||this._BOM!==u._BOM||this.getEOL()!==u.getEOL()?!1:this._pieceTree.equal(u._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(u){return this._pieceTree.createSnapshot(u?this._BOM:"")}getOffsetAt(u,T){return this._pieceTree.getOffsetAt(u,T)}getPositionAt(u){return this._pieceTree.getPositionAt(u)}getRangeAt(u,T){const b=u+T,a=this.getPositionAt(u),m=this.getPositionAt(b);return new P.Range(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange(u,T=k.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const b=this._getEndOfLine(T);return this._pieceTree.getValueInRange(u,b)}getValueLengthInRange(u,T=k.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const b=this.getOffsetAt(u.startLineNumber,u.startColumn),a=this.getOffsetAt(u.endLineNumber,u.endColumn);let m=0;const p=this._getEndOfLine(T),f=this.getEOL();if(p.length!==f.length){const i=p.length-f.length,s=u.endLineNumber-u.startLineNumber;m=i*s}return a-b+m}getCharacterCountInRange(u,T=k.EndOfLinePreference.TextDefined){if(this._mightContainNonBasicASCII){let b=0;const a=u.startLineNumber,m=u.endLineNumber;for(let p=a;p<=m;p++){const f=this.getLineContent(p),i=p===a?u.startColumn-1:0,s=p===m?u.endColumn-1:f.length;for(let t=i;t<s;t++)d.isHighSurrogate(f.charCodeAt(t))?(b=b+1,t=t+1):b=b+1}return b+=this._getEndOfLine(T).length*(m-a),b}return this.getValueLengthInRange(u,T)}getNearestChunk(u){return this._pieceTree.getNearestChunk(u)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(u){return this._pieceTree.getLineContent(u)}getLineCharCode(u,T){return this._pieceTree.getLineCharCode(u,T)}getCharCode(u){return this._pieceTree.getCharCode(u)}getLineLength(u){return this._pieceTree.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const T=d.firstNonWhitespaceIndex(this.getLineContent(u));return T===-1?0:T+1}getLineLastNonWhitespaceColumn(u){const T=d.lastNonWhitespaceIndex(this.getLineContent(u));return T===-1?0:T+2}_getEndOfLine(u){switch(u){case k.EndOfLinePreference.LF:return`
`;case k.EndOfLinePreference.CRLF:return`\r
`;case k.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this._pieceTree.setEOL(u)}applyEdits(u,T,b){let a=this._mightContainRTL,m=this._mightContainUnusualLineTerminators,p=this._mightContainNonBasicASCII,f=!0,i=[];for(let g=0;g<u.length;g++){const w=u[g];f&&w._isTracked&&(f=!1);const D=w.range;if(w.text){let S=!0;p||(S=!d.isBasicASCII(w.text),p=S),!a&&S&&(a=d.containsRTL(w.text)),!m&&S&&(m=d.containsUnusualLineTerminators(w.text))}let _="",C=0,A=0,E=0;if(w.text){let S;[C,A,E,S]=(0,R.countEOL)(w.text);const F=this.getEOL(),N=F===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;S===R.StringEOL.Unknown||S===N?_=w.text:_=w.text.replace(/\r\n|\r|\n/g,F)}i[g]={sortIndex:g,identifier:w.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:_,eolCount:C,firstLineLength:A,lastLineLength:E,forceMoveMarkers:!!w.forceMoveMarkers,isAutoWhitespaceEdit:w.isAutoWhitespaceEdit||!1}}i.sort(I._sortOpsAscending);let s=!1;for(let g=0,w=i.length-1;g<w;g++){const D=i[g].range.getEndPosition(),_=i[g+1].range.getStartPosition();if(_.isBeforeOrEqual(D)){if(_.isBefore(D))throw new Error("Overlapping ranges are not allowed!");s=!0}}f&&(i=this._reduceOperations(i));const t=b||T?I._getInverseEditRanges(i):[],o=[];if(T)for(let g=0;g<i.length;g++){const w=i[g],D=t[g];if(w.isAutoWhitespaceEdit&&w.range.isEmpty())for(let _=D.startLineNumber;_<=D.endLineNumber;_++){let C="";_===D.startLineNumber&&(C=this.getLineContent(w.range.startLineNumber),d.firstNonWhitespaceIndex(C)!==-1)||o.push({lineNumber:_,oldContent:C})}}let n=null;if(b){let g=0;n=[];for(let w=0;w<i.length;w++){const D=i[w],_=t[w],C=this.getValueInRange(D.range),A=D.rangeOffset+g;g+=D.text.length-C.length,n[w]={sortIndex:D.sortIndex,identifier:D.identifier,range:_,text:C,textChange:new v.TextChange(D.rangeOffset,C,A,D.text)}}s||n.sort((w,D)=>w.sortIndex-D.sortIndex)}this._mightContainRTL=a,this._mightContainUnusualLineTerminators=m,this._mightContainNonBasicASCII=p;const h=this._doApplyEdits(i);let c=null;if(T&&o.length>0){o.sort((g,w)=>w.lineNumber-g.lineNumber),c=[];for(let g=0,w=o.length;g<w;g++){const D=o[g].lineNumber;if(g>0&&o[g-1].lineNumber===D)continue;const _=o[g].oldContent,C=this.getLineContent(D);C.length===0||C===_||d.firstNonWhitespaceIndex(C)!==-1||c.push(D)}}return this._onDidChangeContent.fire(),new k.ApplyEditsResult(n,h,c)}_reduceOperations(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let T=!1;const b=u[0].range,a=u[u.length-1].range,m=new P.Range(b.startLineNumber,b.startColumn,a.endLineNumber,a.endColumn);let p=b.startLineNumber,f=b.startColumn;const i=[];for(let h=0,c=u.length;h<c;h++){const g=u[h],w=g.range;T=T||g.forceMoveMarkers,i.push(this.getValueInRange(new P.Range(p,f,w.startLineNumber,w.startColumn))),g.text.length>0&&i.push(g.text),p=w.endLineNumber,f=w.endColumn}const s=i.join(""),[t,o,n]=(0,R.countEOL)(s);return{sortIndex:0,identifier:u[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,k.EndOfLinePreference.TextDefined),text:s,eolCount:t,firstLineLength:o,lastLineLength:n,forceMoveMarkers:T,isAutoWhitespaceEdit:!1}}_doApplyEdits(u){u.sort(I._sortOpsDescending);const T=[];for(let b=0;b<u.length;b++){const a=u[b],m=a.range.startLineNumber,p=a.range.startColumn,f=a.range.endLineNumber,i=a.range.endColumn;if(m===f&&p===i&&a.text.length===0)continue;a.text?(this._pieceTree.delete(a.rangeOffset,a.rangeLength),this._pieceTree.insert(a.rangeOffset,a.text,!0)):this._pieceTree.delete(a.rangeOffset,a.rangeLength);const s=new P.Range(m,p,f,i);T.push({range:s,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return T}findMatchesLineByLine(u,T,b,a){return this._pieceTree.findMatchesLineByLine(u,T,b,a)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(u,T){const b=u.startLineNumber,a=u.startColumn,[m,p,f]=(0,R.countEOL)(T);let i;if(T.length>0){const s=m+1;s===1?i=new P.Range(b,a,b,a+p):i=new P.Range(b,a,b+s-1,f+1)}else i=new P.Range(b,a,b,a);return i}static _getInverseEditRanges(u){const T=[];let b=0,a=0,m=null;for(let p=0,f=u.length;p<f;p++){const i=u[p];let s,t;m?m.range.endLineNumber===i.range.startLineNumber?(s=b,t=a+(i.range.startColumn-m.range.endColumn)):(s=b+(i.range.startLineNumber-m.range.endLineNumber),t=i.range.startColumn):(s=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const n=i.eolCount+1;n===1?o=new P.Range(s,t,s,t+i.firstLineLength):o=new P.Range(s,t,s+n-1,i.lastLineLength+1)}else o=new P.Range(s,t,s,t);b=o.endLineNumber,a=o.endColumn,T.push(o),m=i}return T}static _sortOpsAscending(u,T){const b=P.Range.compareRangesUsingEnds(u.range,T.range);return b===0?u.sortIndex-T.sortIndex:b}static _sortOpsDescending(u,T){const b=P.Range.compareRangesUsingEnds(u.range,T.range);return b===0?T.sortIndex-u.sortIndex:-b}}e.PieceTreeTextBuffer=I}),define(Ce[208],Ie([1,0,26,12,58,141,207]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0,d=$e(d);class R{constructor(I,y,u,T,b,a,m,p,f){this._chunks=I,this._bom=y,this._cr=u,this._lf=T,this._crlf=b,this._containsRTL=a,this._containsUnusualLineTerminators=m,this._isBasicASCII=p,this._normalizeEOL=f}_getEOL(I){const y=this._cr+this._lf+this._crlf,u=this._cr+this._crlf;return y===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:u>y/2?`\r
`:`
`}create(I){const y=this._getEOL(I),u=this._chunks;if(this._normalizeEOL&&(y===`\r
`&&(this._cr>0||this._lf>0)||y===`
`&&(this._cr>0||this._crlf>0)))for(let b=0,a=u.length;b<a;b++){const m=u[b].buffer.replace(/\r\n|\r|\n/g,y),p=(0,k.createLineStartsFast)(m);u[b]=new k.StringBuffer(m,p)}const T=new L.PieceTreeTextBuffer(u,this._bom,y,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:T,disposable:T}}getFirstLineText(I){return this._chunks[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class v{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(I){if(I.length===0)return;this.chunks.length===0&&d.startsWithUTF8BOM(I)&&(this.BOM=d.UTF8_BOM_CHARACTER,I=I.substr(1));const y=I.charCodeAt(I.length-1);y===r.CharCode.CarriageReturn||y>=55296&&y<=56319?(this._acceptChunk1(I.substr(0,I.length-1),!1),this._hasPreviousChar=!0,this._previousChar=y):(this._acceptChunk1(I,!1),this._hasPreviousChar=!1,this._previousChar=y)}_acceptChunk1(I,y){!y&&I.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+I):this._acceptChunk2(I))}_acceptChunk2(I){const y=(0,k.createLineStarts)(this._tmpLineStarts,I);this.chunks.push(new k.StringBuffer(I,y.lineStarts)),this.cr+=y.cr,this.lf+=y.lf,this.crlf+=y.crlf,y.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=d.containsRTL(I)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=d.containsUnusualLineTerminators(I)))}finish(I=!0){return this._finish(),new R(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,I)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const I=this.chunks[this.chunks.length-1];I.buffer+=String.fromCharCode(this._previousChar);const y=(0,k.createLineStartsFast)(I.buffer);I.lineStarts=y,this._previousChar===r.CharCode.CarriageReturn&&this.cr++}}}e.PieceTreeTextBufferBuilder=v}),define(Ce[142],Ie([1,0,21,10]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=v,e.decodeSemanticTokensDto=I,d=$e(d);var P;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(P||(P={}));function k(y){for(let u=0,T=y.length;u<T;u+=4){const b=y[u+0],a=y[u+1],m=y[u+2],p=y[u+3];y[u+0]=p,y[u+1]=m,y[u+2]=a,y[u+3]=b}}function L(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return d.isLittleEndian()||k(u),r.VSBuffer.wrap(u)}function R(y){const u=y.buffer;if(d.isLittleEndian()||k(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const T=new Uint8Array(u.byteLength);return T.set(u),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function v(y){const u=new Uint32Array(l(y));let T=0;if(u[T++]=y.id,y.type==="full")u[T++]=P.Full,u[T++]=y.data.length,u.set(y.data,T),T+=y.data.length;else{u[T++]=P.Delta,u[T++]=y.deltas.length;for(const b of y.deltas)u[T++]=b.start,u[T++]=b.deleteCount,b.data?(u[T++]=b.data.length,u.set(b.data,T),T+=b.data.length):u[T++]=0}return L(u)}function l(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const T of y.deltas)T.data&&(u+=T.data.length)}return u}function I(y){const u=R(y);let T=0;const b=u[T++];if(u[T++]===P.Full){const f=u[T++],i=u.subarray(T,T+f);return T+=f,{id:b,type:"full",data:i}}const m=u[T++],p=[];for(let f=0;f<m;f++){const i=u[T++],s=u[T++],t=u[T++];let o;t>0&&(o=u.subarray(T,T+t),T+=t),p[f]={start:i,deleteCount:s,data:o}}return{id:b,type:"delta",deltas:p}}}),define(Ce[209],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class r{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(k){if(k&&this._dragOperations.has(k)){const L=this._dragOperations.get(k);return this._dragOperations.delete(k),L}}addDragOperationTransfer(k,L){this._dragOperations.set(k,L)}}e.TreeViewsDnDService=r;class d{constructor(k){this.identifier=k}}e.DraggedTreeItemsIdentifier=d}),define(Ce[210],Ie([1,0,4,3,110]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(v){this._onDidChange.fire({changedLanguages:v,changedColorMap:!1})}register(v,l){return this._tokenizationSupports.set(v,l),this.handleChange([v]),(0,d.toDisposable)(()=>{this._tokenizationSupports.get(v)===l&&(this._tokenizationSupports.delete(v),this.handleChange([v]))})}get(v){return this._tokenizationSupports.get(v)||null}registerFactory(v,l){this._factories.get(v)?.dispose();const I=new L(this,v,l);return this._factories.set(v,I),(0,d.toDisposable)(()=>{const y=this._factories.get(v);!y||y!==I||(this._factories.delete(v),y.dispose())})}async getOrCreate(v){const l=this.get(v);if(l)return l;const I=this._factories.get(v);return!I||I.isResolved?null:(await I.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const I=this._factories.get(v);return!!(!I||I.isResolved)}setColorMap(v){this._colorMap=v,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>P.ColorId.DefaultBackground?this._colorMap[P.ColorId.DefaultBackground]:null}}e.TokenizationRegistry=k;class L extends d.Disposable{get isResolved(){return this._isResolved}constructor(v,l,I){super(),this._registry=v,this._languageId=l,this._factory=I,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const v=await this._factory.tokenizationSupport;this._isResolved=!0,v&&!this._isDisposed&&this._register(this._registry.register(this._languageId,v))}}}),define(Ce[8],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=P,e.localize2=L;const r=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function d(R,v){let l;return v.length===0?l=R:l=R.replace(/\{(\d+)\}/g,(I,y)=>{const u=y[0],T=v[u];let b=I;return typeof T=="string"?b=T:(typeof T=="number"||typeof T=="boolean"||T===void 0||T===null)&&(b=String(T)),b}),r&&(l="\uFF3B"+l.replace(/[aouei]/g,"$&$&")+"\uFF3D"),l}function P(R,v,...l){return d(typeof R=="number"?k(R,v):v,l)}function k(R,v){const l=globalThis._VSCODE_NLS_MESSAGES?.[R];if(typeof l!="string"){if(typeof v=="string")return v;throw new Error(`!!! NLS MISSING: ${R} !!!`)}return l}function L(R,v,...l){let I;typeof R=="number"?I=k(R,v):I=v;const y=d(I,l);return{value:y,original:v===I?y:d(v,l)}}}),define(Ce[211],Ie([1,0,4,3,8]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=I,P=$e(P);class k extends d.Disposable{constructor(u,T="",b="",a=!0,m){super(),this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=u,this._label=T,this._cssClass=b,this._enabled=a,this._actionCallback=m}get id(){return this._id}get label(){return this._label}set label(u){this._setLabel(u)}_setLabel(u){this._label!==u&&(this._label=u,this._onDidChange.fire({label:u}))}get tooltip(){return this._tooltip||""}set tooltip(u){this._setTooltip(u)}_setTooltip(u){this._tooltip!==u&&(this._tooltip=u,this._onDidChange.fire({tooltip:u}))}get class(){return this._cssClass}set class(u){this._setClass(u)}_setClass(u){this._cssClass!==u&&(this._cssClass=u,this._onDidChange.fire({class:u}))}get enabled(){return this._enabled}set enabled(u){this._setEnabled(u)}_setEnabled(u){this._enabled!==u&&(this._enabled=u,this._onDidChange.fire({enabled:u}))}get checked(){return this._checked}set checked(u){this._setChecked(u)}_setChecked(u){this._checked!==u&&(this._checked=u,this._onDidChange.fire({checked:u}))}async run(u,T){this._actionCallback&&await this._actionCallback(u)}}e.Action=k;class L extends d.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new r.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new r.Emitter),this.onDidRun=this._onDidRun.event}async run(u,T){if(!u.enabled)return;this._onWillRun.fire({action:u});let b;try{await this.runAction(u,T)}catch(a){b=a}this._onDidRun.fire({action:u,error:b})}async runAction(u,T){await u.run(T)}}e.ActionRunner=L;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let T=[];for(const b of u)b.length&&(T.length?T=[...T,new R,...b]:T=b);return T}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=R;class v{get actions(){return this._actions}constructor(u,T,b,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=T,this.class=a,this._actions=b}async run(){}}e.SubmenuAction=v;class l extends k{static{this.ID="vs.actions.empty"}constructor(){super(l.ID,P.localize(13048,null),void 0,!1)}}e.EmptySubmenuAction=l;function I(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u)}}}),define(Ce[212],Ie([1,0,8]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=l,e.getDurationString=I,e.toLocalISOString=y;const d=60,P=d*60,k=P*24,L=k*7,R=k*30,v=k*365;function l(u,T,b,a){typeof u!="number"&&(u=u.getTime());const m=Math.round((new Date().getTime()-u)/1e3);if(m<-30)return(0,r.localize)(12985,null,l(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,r.localize)(12986,null);let p;return m<d?(p=m,T?p===1?b?(0,r.localize)(12987,null,p):(0,r.localize)(12988,null,p):b?(0,r.localize)(12989,null,p):(0,r.localize)(12990,null,p):p===1?b?(0,r.localize)(12991,null,p):(0,r.localize)(12992,null,p):b?(0,r.localize)(12993,null,p):(0,r.localize)(12994,null,p)):m<P?(p=Math.floor(m/d),T?p===1?b?(0,r.localize)(12995,null,p):(0,r.localize)(12996,null,p):b?(0,r.localize)(12997,null,p):(0,r.localize)(12998,null,p):p===1?b?(0,r.localize)(12999,null,p):(0,r.localize)(13e3,null,p):b?(0,r.localize)(13001,null,p):(0,r.localize)(13002,null,p)):m<k?(p=Math.floor(m/P),T?p===1?b?(0,r.localize)(13003,null,p):(0,r.localize)(13004,null,p):b?(0,r.localize)(13005,null,p):(0,r.localize)(13006,null,p):p===1?b?(0,r.localize)(13007,null,p):(0,r.localize)(13008,null,p):b?(0,r.localize)(13009,null,p):(0,r.localize)(13010,null,p)):m<L?(p=Math.floor(m/k),T?p===1?(0,r.localize)(13011,null,p):(0,r.localize)(13012,null,p):p===1?(0,r.localize)(13013,null,p):(0,r.localize)(13014,null,p)):m<R?(p=Math.floor(m/L),T?p===1?b?(0,r.localize)(13015,null,p):(0,r.localize)(13016,null,p):b?(0,r.localize)(13017,null,p):(0,r.localize)(13018,null,p):p===1?b?(0,r.localize)(13019,null,p):(0,r.localize)(13020,null,p):b?(0,r.localize)(13021,null,p):(0,r.localize)(13022,null,p)):m<v?(p=Math.floor(m/R),T?p===1?b?(0,r.localize)(13023,null,p):(0,r.localize)(13024,null,p):b?(0,r.localize)(13025,null,p):(0,r.localize)(13026,null,p):p===1?b?(0,r.localize)(13027,null,p):(0,r.localize)(13028,null,p):b?(0,r.localize)(13029,null,p):(0,r.localize)(13030,null,p)):(p=Math.floor(m/v),T?p===1?b?(0,r.localize)(13031,null,p):(0,r.localize)(13032,null,p):b?(0,r.localize)(13033,null,p):(0,r.localize)(13034,null,p):p===1?b?(0,r.localize)(13035,null,p):(0,r.localize)(13036,null,p):b?(0,r.localize)(13037,null,p):(0,r.localize)(13038,null,p))}function I(u,T){const b=Math.abs(u/1e3);return b<1?T?(0,r.localize)(13039,null,u):(0,r.localize)(13040,null,u):b<d?T?(0,r.localize)(13041,null,Math.round(u)/1e3):(0,r.localize)(13042,null,Math.round(u)/1e3):b<P?T?(0,r.localize)(13043,null,Math.round(u/(1e3*d))):(0,r.localize)(13044,null,Math.round(u/(1e3*d))):b<k?T?(0,r.localize)(13045,null,Math.round(u/(1e3*P))):(0,r.localize)(13046,null,Math.round(u/(1e3*P))):(0,r.localize)(13047,null,Math.round(u/(1e3*k)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[52],Ie([1,0,18,17,8]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=v,e.isErrorWithActions=l,e.createErrorWithActions=I,r=$e(r),d=$e(d),P=$e(P);function k(y,u){return u&&(y.stack||y.stacktrace)?P.localize(12979,null,R(y),L(y.stack)||L(y.stacktrace)):R(y)}function L(y){return Array.isArray(y)?y.join(`
`):y}function R(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(12980,null,y.message):y.message||P.localize(12981,null)}function v(y=null,u=!1){if(!y)return P.localize(12982,null);if(Array.isArray(y)){const T=r.coalesce(y),b=v(T[0],u);return T.length>1?P.localize(12983,null,b,T.length):b}if(d.isString(y))return y;if(y.detail){const T=y.detail;if(T.error)return k(T.error,u);if(T.exception)return k(T.exception,u)}return y.stack?k(y,u):y.message?y.message:P.localize(12984,null)}function l(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function I(y,u){let T;return typeof y=="string"?T=new Error(y):T=y,T.actions=u,T}}),define(Ce[87],Ie([1,0,82,2,195,30,210,8]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.symbolKindNames=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0,e.isLocationLink=h,e.getAriaLabelForSymbol=g;class v{constructor($,G,Z){this.offset=$,this.type=G,this.language=Z,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=v;class l{constructor($,G){this.tokens=$,this.endState=G,this._tokenizationResultBrand=void 0}}e.TokenizationResult=l;class I{constructor($,G){this.tokens=$,this.endState=G,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=I;var y;(function(V){V[V.Increase=0]="Increase",V[V.Decrease=1]="Decrease"})(y||(e.HoverVerbosityAction=y={}));var u;(function(V){V[V.Method=0]="Method",V[V.Function=1]="Function",V[V.Constructor=2]="Constructor",V[V.Field=3]="Field",V[V.Variable=4]="Variable",V[V.Class=5]="Class",V[V.Struct=6]="Struct",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Event=10]="Event",V[V.Operator=11]="Operator",V[V.Unit=12]="Unit",V[V.Value=13]="Value",V[V.Constant=14]="Constant",V[V.Enum=15]="Enum",V[V.EnumMember=16]="EnumMember",V[V.Keyword=17]="Keyword",V[V.Text=18]="Text",V[V.Color=19]="Color",V[V.File=20]="File",V[V.Reference=21]="Reference",V[V.Customcolor=22]="Customcolor",V[V.Folder=23]="Folder",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue",V[V.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var T;(function(V){const $=new Map;$.set(u.Method,r.Codicon.symbolMethod),$.set(u.Function,r.Codicon.symbolFunction),$.set(u.Constructor,r.Codicon.symbolConstructor),$.set(u.Field,r.Codicon.symbolField),$.set(u.Variable,r.Codicon.symbolVariable),$.set(u.Class,r.Codicon.symbolClass),$.set(u.Struct,r.Codicon.symbolStruct),$.set(u.Interface,r.Codicon.symbolInterface),$.set(u.Module,r.Codicon.symbolModule),$.set(u.Property,r.Codicon.symbolProperty),$.set(u.Event,r.Codicon.symbolEvent),$.set(u.Operator,r.Codicon.symbolOperator),$.set(u.Unit,r.Codicon.symbolUnit),$.set(u.Value,r.Codicon.symbolValue),$.set(u.Enum,r.Codicon.symbolEnum),$.set(u.Constant,r.Codicon.symbolConstant),$.set(u.Enum,r.Codicon.symbolEnum),$.set(u.EnumMember,r.Codicon.symbolEnumMember),$.set(u.Keyword,r.Codicon.symbolKeyword),$.set(u.Snippet,r.Codicon.symbolSnippet),$.set(u.Text,r.Codicon.symbolText),$.set(u.Color,r.Codicon.symbolColor),$.set(u.File,r.Codicon.symbolFile),$.set(u.Reference,r.Codicon.symbolReference),$.set(u.Customcolor,r.Codicon.symbolCustomColor),$.set(u.Folder,r.Codicon.symbolFolder),$.set(u.TypeParameter,r.Codicon.symbolTypeParameter),$.set(u.User,r.Codicon.account),$.set(u.Issue,r.Codicon.issues);function G(ne){let _e=$.get(ne);return _e||(console.info("No codicon found for CompletionItemKind "+ne),_e=r.Codicon.symbolProperty),_e}V.toIcon=G;const Z=new Map;Z.set("method",u.Method),Z.set("function",u.Function),Z.set("constructor",u.Constructor),Z.set("field",u.Field),Z.set("variable",u.Variable),Z.set("class",u.Class),Z.set("struct",u.Struct),Z.set("interface",u.Interface),Z.set("module",u.Module),Z.set("property",u.Property),Z.set("event",u.Event),Z.set("operator",u.Operator),Z.set("unit",u.Unit),Z.set("value",u.Value),Z.set("constant",u.Constant),Z.set("enum",u.Enum),Z.set("enum-member",u.EnumMember),Z.set("enumMember",u.EnumMember),Z.set("keyword",u.Keyword),Z.set("snippet",u.Snippet),Z.set("text",u.Text),Z.set("color",u.Color),Z.set("file",u.File),Z.set("reference",u.Reference),Z.set("customcolor",u.Customcolor),Z.set("folder",u.Folder),Z.set("type-parameter",u.TypeParameter),Z.set("typeParameter",u.TypeParameter),Z.set("account",u.User),Z.set("issue",u.Issue);function le(ne,_e){let ge=Z.get(ne);return typeof ge>"u"&&!_e&&(ge=u.Property),ge}V.fromString=le})(T||(e.CompletionItemKinds=T={}));var b;(function(V){V[V.Deprecated=1]="Deprecated"})(b||(e.CompletionItemTag=b={}));var a;(function(V){V[V.None=0]="None",V[V.KeepWhitespace=1]="KeepWhitespace",V[V.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var m;(function(V){V[V.Word=0]="Word",V[V.Line=1]="Line",V[V.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var p;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var f;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class i{constructor($,G,Z,le){this.range=$,this.text=G,this.completionKind=Z,this.isSnippetText=le}equals($){return k.Range.lift(this.range).equalsRange($.range)&&this.text===$.text&&this.completionKind===$.completionKind&&this.isSnippetText===$.isSnippetText}}e.SelectedSuggestionInfo=i;var s;(function(V){V[V.Invoke=1]="Invoke",V[V.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var t;(function(V){V[V.Automatic=0]="Automatic",V[V.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var o;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var n;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function h(V){return V&&d.URI.isUri(V.uri)&&k.Range.isIRange(V.range)&&(k.Range.isIRange(V.originSelectionRange)||k.Range.isIRange(V.targetSelectionRange))}var c;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(c||(e.SymbolKind=c={})),e.symbolKindNames={[c.Array]:(0,R.localize)(12849,null),[c.Boolean]:(0,R.localize)(12850,null),[c.Class]:(0,R.localize)(12851,null),[c.Constant]:(0,R.localize)(12852,null),[c.Constructor]:(0,R.localize)(12853,null),[c.Enum]:(0,R.localize)(12854,null),[c.EnumMember]:(0,R.localize)(12855,null),[c.Event]:(0,R.localize)(12856,null),[c.Field]:(0,R.localize)(12857,null),[c.File]:(0,R.localize)(12858,null),[c.Function]:(0,R.localize)(12859,null),[c.Interface]:(0,R.localize)(12860,null),[c.Key]:(0,R.localize)(12861,null),[c.Method]:(0,R.localize)(12862,null),[c.Module]:(0,R.localize)(12863,null),[c.Namespace]:(0,R.localize)(12864,null),[c.Null]:(0,R.localize)(12865,null),[c.Number]:(0,R.localize)(12866,null),[c.Object]:(0,R.localize)(12867,null),[c.Operator]:(0,R.localize)(12868,null),[c.Package]:(0,R.localize)(12869,null),[c.Property]:(0,R.localize)(12870,null),[c.String]:(0,R.localize)(12871,null),[c.Struct]:(0,R.localize)(12872,null),[c.TypeParameter]:(0,R.localize)(12873,null),[c.Variable]:(0,R.localize)(12874,null)};function g(V,$){return(0,R.localize)(12875,null,V,e.symbolKindNames[$])}var w;(function(V){V[V.Deprecated=1]="Deprecated"})(w||(e.SymbolTag=w={}));var D;(function(V){const $=new Map;$.set(c.File,r.Codicon.symbolFile),$.set(c.Module,r.Codicon.symbolModule),$.set(c.Namespace,r.Codicon.symbolNamespace),$.set(c.Package,r.Codicon.symbolPackage),$.set(c.Class,r.Codicon.symbolClass),$.set(c.Method,r.Codicon.symbolMethod),$.set(c.Property,r.Codicon.symbolProperty),$.set(c.Field,r.Codicon.symbolField),$.set(c.Constructor,r.Codicon.symbolConstructor),$.set(c.Enum,r.Codicon.symbolEnum),$.set(c.Interface,r.Codicon.symbolInterface),$.set(c.Function,r.Codicon.symbolFunction),$.set(c.Variable,r.Codicon.symbolVariable),$.set(c.Constant,r.Codicon.symbolConstant),$.set(c.String,r.Codicon.symbolString),$.set(c.Number,r.Codicon.symbolNumber),$.set(c.Boolean,r.Codicon.symbolBoolean),$.set(c.Array,r.Codicon.symbolArray),$.set(c.Object,r.Codicon.symbolObject),$.set(c.Key,r.Codicon.symbolKey),$.set(c.Null,r.Codicon.symbolNull),$.set(c.EnumMember,r.Codicon.symbolEnumMember),$.set(c.Struct,r.Codicon.symbolStruct),$.set(c.Event,r.Codicon.symbolEvent),$.set(c.Operator,r.Codicon.symbolOperator),$.set(c.TypeParameter,r.Codicon.symbolTypeParameter);function G(Z){let le=$.get(Z);return le||(console.info("No codicon found for SymbolKind "+Z),le=r.Codicon.symbolProperty),le}V.toIcon=G})(D||(e.SymbolKinds=D={}));class _{static asEditOperation($){return P.EditOperation.replace(k.Range.lift($.range),$.text)}}e.TextEdit=_;class C{static{this.Comment=new C("comment")}static{this.Imports=new C("imports")}static{this.Region=new C("region")}static fromValue($){switch($){case"comment":return C.Comment;case"imports":return C.Imports;case"region":return C.Region}return new C($)}constructor($){this.value=$}}e.FoldingRangeKind=C;var A;(function(V){V[V.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var E;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(E||(e.NewSymbolNameTriggerKind=E={}));var S;(function(V){function $(G){return!G||typeof G!="object"?!1:typeof G.id=="string"&&typeof G.title=="string"}V.is=$})(S||(e.Command=S={}));var F;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(F||(e.CommentThreadCollapsibleState=F={}));var N;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var O;(function(V){V[V.Current=0]="Current",V[V.Outdated=1]="Outdated"})(O||(e.CommentThreadApplicability=O={}));var M;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(M||(e.CommentMode=M={}));var U;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(U||(e.CommentState=U={}));var x;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(x||(e.InlayHintKind=x={}));class z{constructor($){this.createSupport=$,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then($=>{$&&$.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=z,e.TokenizationRegistry=new L.TokenizationRegistry;var B;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(B||(e.ExternalUriOpenerPriority=B={}));var ee;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(ee||(e.InlineEditTriggerKind=ee={}))}),define(Ce[213],Ie([1,0,26,13,8]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(k||(e.TokenType=k={}));function L(...I){switch(I.length){case 1:return(0,P.localize)(11586,null,I[0]);case 2:return(0,P.localize)(11587,null,I[0],I[1]);case 3:return(0,P.localize)(11588,null,I[0],I[1],I[2]);default:return}}const R=(0,P.localize)(11589,null),v=(0,P.localize)(11590,null);class l{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return y.isTripleEq?"===":"==";case k.NotEq:return y.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return y.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return y.lexeme;case k.QuotedStr:return y.lexeme;case k.Error:return y.lexeme;case k.EOF:return"EOF";default:throw(0,d.illegalState)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this._keywords=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this._errors}reset(y){return this._input=y,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case r.CharCode.OpenParen:this._addToken(k.LParen);break;case r.CharCode.CloseParen:this._addToken(k.RParen);break;case r.CharCode.ExclamationMark:if(this._match(r.CharCode.Equals)){const u=this._match(r.CharCode.Equals);this._tokens.push({type:k.NotEq,offset:this._start,isTripleEq:u})}else this._addToken(k.Neg);break;case r.CharCode.SingleQuote:this._quotedString();break;case r.CharCode.Slash:this._regex();break;case r.CharCode.Equals:if(this._match(r.CharCode.Equals)){const u=this._match(r.CharCode.Equals);this._tokens.push({type:k.Eq,offset:this._start,isTripleEq:u})}else this._match(r.CharCode.Tilde)?this._addToken(k.RegexOp):this._error(L("==","=~"));break;case r.CharCode.LessThan:this._addToken(this._match(r.CharCode.Equals)?k.LtEq:k.Lt);break;case r.CharCode.GreaterThan:this._addToken(this._match(r.CharCode.Equals)?k.GtEq:k.Gt);break;case r.CharCode.Ampersand:this._match(r.CharCode.Ampersand)?this._addToken(k.And):this._error(L("&&"));break;case r.CharCode.Pipe:this._match(r.CharCode.Pipe)?this._addToken(k.Or):this._error(L("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(k.EOF),Array.from(this._tokens)}_match(y){return this._isAtEnd()||this._input.charCodeAt(this._current)!==y?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?r.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(y){this._tokens.push({type:y,offset:this._start})}_error(y){const u=this._start,T=this._input.substring(this._start,this._current),b={type:k.Error,offset:this._start,lexeme:T};this._errors.push({offset:u,lexeme:T,additionalInfo:y}),this._tokens.push(b)}_string(){this.stringRe.lastIndex=this._start;const y=this.stringRe.exec(this._input);if(y){this._current=this._start+y[0].length;const u=this._input.substring(this._start,this._current),T=l._keywords.get(u);T?this._addToken(T):this._tokens.push({type:k.Str,lexeme:u,offset:this._start})}}_quotedString(){for(;this._peek()!==r.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:k.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let y=this._current,u=!1,T=!1;for(;;){if(y>=this._input.length){this._current=y,this._error(v);return}const a=this._input.charCodeAt(y);if(u)u=!1;else if(a===r.CharCode.Slash&&!T){y++;break}else a===r.CharCode.OpenSquareBracket?T=!0:a===r.CharCode.Backslash?u=!0:a===r.CharCode.CloseSquareBracket&&(T=!1);y++}for(;y<this._input.length&&l._regexFlags.has(this._input.charCodeAt(y));)y++;this._current=y;const b=this._input.substring(this._start,this._current);this._tokens.push({type:k.RegexStr,lexeme:b,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=l}),define(Ce[143],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const r={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(r)}),define(Ce[112],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(P,k=[],L=!1){this.ctor=P,this.staticArguments=k,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=r}),define(Ce[88],Ie([1,0,112]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=k,e.getSingletonServiceDescriptors=L;const d=[];var P;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function k(R,v,l){v instanceof r.SyncDescriptor||(v=new r.SyncDescriptor(v,[],!!l)),d.push([R,v])}function L(){return d}}),define(Ce[214],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class d{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const L of this._nodes.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const R=this.lookupOrInsertNode(k),v=this.lookupOrInsertNode(L);R.outgoing.set(v.key,v),v.incoming.set(R.key,R)}removeNode(k){const L=this._hashFn(k);this._nodes.delete(L);for(const R of this._nodes.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(k){const L=this._hashFn(k);let R=this._nodes.get(L);return R||(R=new r(L,k),this._nodes.set(L,R)),R}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[L,R]of this._nodes)k.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this._nodes){const R=new Set([k]),v=this._findCycle(L,R);if(v)return v}}_findCycle(k,L){for(const[R,v]of k.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const l=this._findCycle(v,L);if(l)return l;L.delete(R)}}}e.Graph=d}),define(Ce[5],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=P,e.refineServiceDecorator=k;var r;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R(v){return v[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(r||(e._util=r={})),e.IInstantiationService=P("instantiationService");function d(L,R,v){R[r.DI_TARGET]===R?R[r.DI_DEPENDENCIES].push({id:L,index:v}):(R[r.DI_DEPENDENCIES]=[{id:L,index:v}],R[r.DI_TARGET]=R)}function P(L){if(r.serviceIds.has(L))return r.serviceIds.get(L);const R=function(v,l,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");d(R,v,I)};return R.toString=()=>L,r.serviceIds.set(L,R),R}function k(L){return L}}),define(Ce[46],Ie([1,0,17,2,5]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=k,e.isConfigurationUpdateOverrides=L,e.ConfigurationTargetToString=v,e.isConfigured=l,e.toValuesTree=I,e.addToValueTree=y,e.removeFromValueTree=u,e.getConfigurationValue=b,e.merge=a,e.getLanguageTagSettingPlainKey=m,r=$e(r),e.IConfigurationService=(0,P.createDecorator)("configurationService");function k(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof d.URI)}function L(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof d.URI)}var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function v(p){switch(p){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function l(p){return p.applicationValue!==void 0||p.userValue!==void 0||p.userLocalValue!==void 0||p.userRemoteValue!==void 0||p.workspaceValue!==void 0||p.workspaceFolderValue!==void 0}function I(p,f){const i=Object.create(null);for(const s in p)y(i,s,p[s],f);return i}function y(p,f,i,s){const t=f.split("."),o=t.pop();let n=p;for(let h=0;h<t.length;h++){const c=t[h];let g=n[c];switch(typeof g){case"undefined":g=n[c]=Object.create(null);break;case"object":if(g===null){s(`Ignoring ${f} as ${t.slice(0,h+1).join(".")} is null`);return}break;default:s(`Ignoring ${f} as ${t.slice(0,h+1).join(".")} is ${JSON.stringify(g)}`);return}n=g}if(typeof n=="object"&&n!==null)try{n[o]=i}catch{s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}else s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}function u(p,f){const i=f.split(".");T(p,i)}function T(p,f){const i=f.shift();if(f.length===0){delete p[i];return}if(Object.keys(p).indexOf(i)!==-1){const s=p[i];typeof s=="object"&&!Array.isArray(s)&&(T(s,f),Object.keys(s).length===0&&delete p[i])}}function b(p,f,i){function s(n,h){let c=n;for(const g of h){if(typeof c!="object"||c===null)return;c=c[g]}return c}const t=f.split("."),o=s(p,t);return typeof o>"u"?i:o}function a(p,f,i){Object.keys(f).forEach(s=>{s!=="__proto__"&&(s in p?r.isObject(p[s])&&r.isObject(f[s])?a(p[s],f[s],i):i&&(p[s]=f[s]):p[s]=f[s])})}function m(p){return p.replace(/[\[\]]/g,"")}}),define(Ce[35],Ie([1,0,26,10,12,213,5,8,13]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=I,e.validateWhenClauses=h,e.expressionsAreEqualWithConstantSubstitution=c,e.implies=ne;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",d.isMacintosh),l.set("isLinux",d.isLinux),l.set("isWindows",d.isWindows),l.set("isWeb",d.isWeb),l.set("isMacNative",d.isMacintosh&&!d.isWeb),l.set("isEdge",d.isEdge),l.set("isFirefox",d.isFirefox),l.set("isChrome",d.isChrome),l.set("isSafari",d.isSafari);function I(Y,W){if(l.get(Y)!==void 0)throw(0,v.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(Y,W)}const y=Object.prototype.hasOwnProperty;var u;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const T={regexParsingWithErrorRecovery:!0},b=(0,R.localize)(11600,null),a=(0,R.localize)(11601,null),m=(0,R.localize)(11602,null),p=(0,R.localize)(11603,null),f=(0,R.localize)(11604,null),i=(0,R.localize)(11605,null),s=(0,R.localize)(11606,null),t=(0,R.localize)(11607,null);class o{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(W=T){this._config=W,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(W){if(W===""){this._parsingErrors.push({message:b,offset:0,lexeme:"",additionalInfo:a});return}this._tokens=this._scanner.reset(W).scan(),this._current=0,this._parsingErrors=[];try{const oe=this._expr();if(!this._isAtEnd()){const Se=this._peek(),te=Se.type===k.TokenType.Str?i:void 0;throw this._parsingErrors.push({message:f,offset:Se.offset,lexeme:k.Scanner.getLexeme(Se),additionalInfo:te}),o._parseError}return oe}catch(oe){if(oe!==o._parseError)throw oe;return}}_expr(){return this._or()}_or(){const W=[this._and()];for(;this._matchOne(k.TokenType.Or);){const oe=this._and();W.push(oe)}return W.length===1?W[0]:n.or(...W)}_and(){const W=[this._term()];for(;this._matchOne(k.TokenType.And);){const oe=this._term();W.push(oe)}return W.length===1?W[0]:n.and(...W)}_term(){if(this._matchOne(k.TokenType.Neg)){const W=this._peek();switch(W.type){case k.TokenType.True:return this._advance(),w.INSTANCE;case k.TokenType.False:return this._advance(),D.INSTANCE;case k.TokenType.LParen:{this._advance();const oe=this._expr();return this._consume(k.TokenType.RParen,p),oe?.negate()}case k.TokenType.Str:return this._advance(),F.create(W.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",W)}}return this._primary()}_primary(){const W=this._peek();switch(W.type){case k.TokenType.True:return this._advance(),n.true();case k.TokenType.False:return this._advance(),n.false();case k.TokenType.LParen:{this._advance();const oe=this._expr();return this._consume(k.TokenType.RParen,p),oe}case k.TokenType.Str:{const oe=W.lexeme;if(this._advance(),this._matchOne(k.TokenType.RegexOp)){const te=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),te.type!==k.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",te);const ae=te.lexeme,se=ae.lastIndexOf("/"),Q=se===ae.length-1?void 0:this._removeFlagsGY(ae.substring(se+1));let re;try{re=new RegExp(ae.substring(1,se),Q)}catch{throw this._errExpectedButGot("REGEX",te)}return z.create(oe,re)}switch(te.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const ae=[te.lexeme];this._advance();let se=this._peek(),Q=0;for(let Be=0;Be<te.lexeme.length;Be++)te.lexeme.charCodeAt(Be)===r.CharCode.OpenParen?Q++:te.lexeme.charCodeAt(Be)===r.CharCode.CloseParen&&Q--;for(;!this._isAtEnd()&&se.type!==k.TokenType.And&&se.type!==k.TokenType.Or;){switch(se.type){case k.TokenType.LParen:Q++;break;case k.TokenType.RParen:Q--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let Be=0;Be<se.lexeme.length;Be++)se.lexeme.charCodeAt(Be)===r.CharCode.OpenParen?Q++:te.lexeme.charCodeAt(Be)===r.CharCode.CloseParen&&Q--}if(Q<0)break;ae.push(k.Scanner.getLexeme(se)),this._advance(),se=this._peek()}const re=ae.join(""),ve=re.lastIndexOf("/"),be=ve===re.length-1?void 0:this._removeFlagsGY(re.substring(ve+1));let Fe;try{Fe=new RegExp(re.substring(1,ve),be)}catch{throw this._errExpectedButGot("REGEX",te)}return n.regex(oe,Fe)}case k.TokenType.QuotedStr:{const ae=te.lexeme;this._advance();let se=null;if(!(0,P.isFalsyOrWhitespace)(ae)){const Q=ae.indexOf("/"),re=ae.lastIndexOf("/");if(Q!==re&&Q>=0){const ve=ae.slice(Q+1,re),be=ae[re+1]==="i"?"i":"";try{se=new RegExp(ve,be)}catch{throw this._errExpectedButGot("REGEX",te)}}}if(se===null)throw this._errExpectedButGot("REGEX",te);return z.create(oe,se)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(k.TokenType.Not)){this._consume(k.TokenType.In,m);const te=this._value();return n.notIn(oe,te)}switch(this._peek().type){case k.TokenType.Eq:{this._advance();const te=this._value();if(this._previous().type===k.TokenType.QuotedStr)return n.equals(oe,te);switch(te){case"true":return n.has(oe);case"false":return n.not(oe);default:return n.equals(oe,te)}}case k.TokenType.NotEq:{this._advance();const te=this._value();if(this._previous().type===k.TokenType.QuotedStr)return n.notEquals(oe,te);switch(te){case"true":return n.not(oe);case"false":return n.has(oe);default:return n.notEquals(oe,te)}}case k.TokenType.Lt:return this._advance(),U.create(oe,this._value());case k.TokenType.LtEq:return this._advance(),x.create(oe,this._value());case k.TokenType.Gt:return this._advance(),O.create(oe,this._value());case k.TokenType.GtEq:return this._advance(),M.create(oe,this._value());case k.TokenType.In:return this._advance(),n.in(oe,this._value());default:return n.has(oe)}}case k.TokenType.EOF:throw this._parsingErrors.push({message:s,offset:W.offset,lexeme:"",additionalInfo:t}),o._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const W=this._peek();switch(W.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this._advance(),W.lexeme;case k.TokenType.True:return this._advance(),"true";case k.TokenType.False:return this._advance(),"false";case k.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(W){return W.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(W){return this._check(W)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(W,oe){if(this._check(W))return this._advance();throw this._errExpectedButGot(oe,this._peek())}_errExpectedButGot(W,oe,Se){const te=(0,R.localize)(11608,null,W,k.Scanner.getLexeme(oe)),ae=oe.offset,se=k.Scanner.getLexeme(oe);return this._parsingErrors.push({message:te,offset:ae,lexeme:se,additionalInfo:Se}),o._parseError}_check(W){return this._peek().type===W}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===k.TokenType.EOF}}e.Parser=o;class n{static false(){return w.INSTANCE}static true(){return D.INSTANCE}static has(W){return _.create(W)}static equals(W,oe){return C.create(W,oe)}static notEquals(W,oe){return S.create(W,oe)}static regex(W,oe){return z.create(W,oe)}static in(W,oe){return A.create(W,oe)}static notIn(W,oe){return E.create(W,oe)}static not(W){return F.create(W)}static and(...W){return V.create(W,null,!0)}static or(...W){return $.create(W,null,!0)}static greater(W,oe){return O.create(W,oe)}static greaterEquals(W,oe){return M.create(W,oe)}static smaller(W,oe){return U.create(W,oe)}static smallerEquals(W,oe){return x.create(W,oe)}static{this._parser=new o({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this._parser.parse(W)}}e.ContextKeyExpr=n;function h(Y){const W=new o({regexParsingWithErrorRecovery:!1});return Y.map(oe=>(W.parse(oe),W.lexingErrors.length>0?W.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,R.localize)(11609,null,Se.additionalInfo):(0,R.localize)(11610,null),offset:Se.offset,length:Se.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}function c(Y,W){const oe=Y?Y.substituteConstants():void 0,Se=W?W.substituteConstants():void 0;return!oe&&!Se?!0:!oe||!Se?!1:oe.equals(Se)}function g(Y,W){return Y.cmp(W)}class w{static{this.INSTANCE=new w}constructor(){this.type=u.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return D.INSTANCE}}e.ContextKeyFalseExpr=w;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=D;class _{static create(W,oe=null){const Se=l.get(W);return typeof Se=="boolean"?Se?D.INSTANCE:w.INSTANCE:new _(W,oe)}constructor(W,oe){this.key=W,this.negated=oe,this.type=u.Defined}cmp(W){return W.type!==this.type?this.type-W.type:Z(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=l.get(this.key);return typeof W=="boolean"?W?D.INSTANCE:w.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.negated||(this.negated=F.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=_;class C{static create(W,oe,Se=null){if(typeof oe=="boolean")return oe?_.create(W,Se):F.create(W,Se);const te=l.get(W);return typeof te=="boolean"?oe===(te?"true":"false")?D.INSTANCE:w.INSTANCE:new C(W,oe,Se)}constructor(W,oe,Se){this.key=W,this.value=oe,this.negated=Se,this.type=u.Equals}cmp(W){return W.type!==this.type?this.type-W.type:le(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=l.get(this.key);if(typeof W=="boolean"){const oe=W?"true":"false";return this.value===oe?D.INSTANCE:w.INSTANCE}return this}evaluate(W){return W.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(W){return W.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class A{static create(W,oe){return new A(W,oe)}constructor(W,oe){this.key=W,this.valueKey=oe,this.type=u.In,this.negated=null}cmp(W){return W.type!==this.type?this.type-W.type:le(this.key,this.valueKey,W.key,W.valueKey)}equals(W){return W.type===this.type?this.key===W.key&&this.valueKey===W.valueKey:!1}substituteConstants(){return this}evaluate(W){const oe=W.getValue(this.valueKey),Se=W.getValue(this.key);return Array.isArray(oe)?oe.includes(Se):typeof Se=="string"&&typeof oe=="object"&&oe!==null?y.call(oe,Se):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(W){return W.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=E.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=A;class E{static create(W,oe){return new E(W,oe)}constructor(W,oe){this.key=W,this.valueKey=oe,this.type=u.NotIn,this._negated=A.create(W,oe)}cmp(W){return W.type!==this.type?this.type-W.type:this._negated.cmp(W._negated)}equals(W){return W.type===this.type?this._negated.equals(W._negated):!1}substituteConstants(){return this}evaluate(W){return!this._negated.evaluate(W)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(W){return W.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=E;class S{static create(W,oe,Se=null){if(typeof oe=="boolean")return oe?F.create(W,Se):_.create(W,Se);const te=l.get(W);return typeof te=="boolean"?oe===(te?"true":"false")?w.INSTANCE:D.INSTANCE:new S(W,oe,Se)}constructor(W,oe,Se){this.key=W,this.value=oe,this.negated=Se,this.type=u.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:le(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=l.get(this.key);if(typeof W=="boolean"){const oe=W?"true":"false";return this.value===oe?w.INSTANCE:D.INSTANCE}return this}evaluate(W){return W.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(W){return W.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class F{static create(W,oe=null){const Se=l.get(W);return typeof Se=="boolean"?Se?w.INSTANCE:D.INSTANCE:new F(W,oe)}constructor(W,oe){this.key=W,this.negated=oe,this.type=u.Not}cmp(W){return W.type!==this.type?this.type-W.type:Z(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=l.get(this.key);return typeof W=="boolean"?W?w.INSTANCE:D.INSTANCE:this}evaluate(W){return!W.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(W){return W.mapNot(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=F;function N(Y,W){if(typeof Y=="string"){const oe=parseFloat(Y);isNaN(oe)||(Y=oe)}return typeof Y=="string"||typeof Y=="number"?W(Y):w.INSTANCE}class O{static create(W,oe,Se=null){return N(oe,te=>new O(W,te,Se))}constructor(W,oe,Se){this.key=W,this.value=oe,this.negated=Se,this.type=u.Greater}cmp(W){return W.type!==this.type?this.type-W.type:le(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=O;class M{static create(W,oe,Se=null){return N(oe,te=>new M(W,te,Se))}constructor(W,oe,Se){this.key=W,this.value=oe,this.negated=Se,this.type=u.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:le(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=M;class U{static create(W,oe,Se=null){return N(oe,te=>new U(W,te,Se))}constructor(W,oe,Se){this.key=W,this.value=oe,this.negated=Se,this.type=u.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:le(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=U;class x{static create(W,oe,Se=null){return N(oe,te=>new x(W,te,Se))}constructor(W,oe,Se){this.key=W,this.value=oe,this.negated=Se,this.type=u.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:le(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=O.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=x;class z{static create(W,oe){return new z(W,oe)}constructor(W,oe){this.key=W,this.regexp=oe,this.type=u.Regex,this.negated=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.key<W.key)return-1;if(this.key>W.key)return 1;const oe=this.regexp?this.regexp.source:"",Se=W.regexp?W.regexp.source:"";return oe<Se?-1:oe>Se?1:0}equals(W){if(W.type===this.type){const oe=this.regexp?this.regexp.source:"",Se=W.regexp?W.regexp.source:"";return this.key===W.key&&oe===Se}return!1}substituteConstants(){return this}evaluate(W){const oe=W.getValue(this.key);return this.regexp?this.regexp.test(oe):!1}serialize(){const W=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${W}`}keys(){return[this.key]}map(W){return W.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=B.create(this)),this.negated}}e.ContextKeyRegexExpr=z;class B{static create(W){return new B(W)}constructor(W){this._actual=W,this.type=u.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this._actual.cmp(W._actual)}equals(W){return W.type===this.type?this._actual.equals(W._actual):!1}substituteConstants(){return this}evaluate(W){return!this._actual.evaluate(W)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(W){return new B(this._actual.map(W))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=B;function ee(Y){let W=null;for(let oe=0,Se=Y.length;oe<Se;oe++){const te=Y[oe].substituteConstants();if(Y[oe]!==te&&W===null){W=[];for(let ae=0;ae<oe;ae++)W[ae]=Y[ae]}W!==null&&(W[oe]=te)}return W===null?Y:W}class V{static create(W,oe,Se){return V._normalizeArr(W,oe,Se)}constructor(W,oe){this.expr=W,this.negated=oe,this.type=u.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let oe=0,Se=this.expr.length;oe<Se;oe++){const te=g(this.expr[oe],W.expr[oe]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let oe=0,Se=this.expr.length;oe<Se;oe++)if(!this.expr[oe].equals(W.expr[oe]))return!1;return!0}return!1}substituteConstants(){const W=ee(this.expr);return W===this.expr?this:V.create(W,this.negated,!1)}evaluate(W){for(let oe=0,Se=this.expr.length;oe<Se;oe++)if(!this.expr[oe].evaluate(W))return!1;return!0}static _normalizeArr(W,oe,Se){const te=[];let ae=!1;for(const se of W)if(se){if(se.type===u.True){ae=!0;continue}if(se.type===u.False)return w.INSTANCE;if(se.type===u.And){te.push(...se.expr);continue}te.push(se)}if(te.length===0&&ae)return D.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(g);for(let se=1;se<te.length;se++)te[se-1].equals(te[se])&&(te.splice(se,1),se--);if(te.length===1)return te[0];for(;te.length>1;){const se=te[te.length-1];if(se.type!==u.Or)break;te.pop();const Q=te.pop(),re=te.length===0,ve=$.create(se.expr.map(be=>V.create([be,Q],null,Se)),null,re);ve&&(te.push(ve),te.sort(g))}if(te.length===1)return te[0];if(Se){for(let se=0;se<te.length;se++)for(let Q=se+1;Q<te.length;Q++)if(te[se].negate().equals(te[Q]))return w.INSTANCE;if(te.length===1)return te[0]}return new V(te,oe)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const oe of this.expr)W.push(...oe.keys());return W}map(W){return new V(this.expr.map(oe=>oe.map(W)),null)}negate(){if(!this.negated){const W=[];for(const oe of this.expr)W.push(oe.negate());this.negated=$.create(W,this,!0)}return this.negated}}e.ContextKeyAndExpr=V;class ${static create(W,oe,Se){return $._normalizeArr(W,oe,Se)}constructor(W,oe){this.expr=W,this.negated=oe,this.type=u.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let oe=0,Se=this.expr.length;oe<Se;oe++){const te=g(this.expr[oe],W.expr[oe]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let oe=0,Se=this.expr.length;oe<Se;oe++)if(!this.expr[oe].equals(W.expr[oe]))return!1;return!0}return!1}substituteConstants(){const W=ee(this.expr);return W===this.expr?this:$.create(W,this.negated,!1)}evaluate(W){for(let oe=0,Se=this.expr.length;oe<Se;oe++)if(this.expr[oe].evaluate(W))return!0;return!1}static _normalizeArr(W,oe,Se){let te=[],ae=!1;if(W){for(let se=0,Q=W.length;se<Q;se++){const re=W[se];if(re){if(re.type===u.False){ae=!0;continue}if(re.type===u.True)return D.INSTANCE;if(re.type===u.Or){te=te.concat(re.expr);continue}te.push(re)}}if(te.length===0&&ae)return w.INSTANCE;te.sort(g)}if(te.length!==0){if(te.length===1)return te[0];for(let se=1;se<te.length;se++)te[se-1].equals(te[se])&&(te.splice(se,1),se--);if(te.length===1)return te[0];if(Se){for(let se=0;se<te.length;se++)for(let Q=se+1;Q<te.length;Q++)if(te[se].negate().equals(te[Q]))return D.INSTANCE;if(te.length===1)return te[0]}return new $(te,oe)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const oe of this.expr)W.push(...oe.keys());return W}map(W){return new $(this.expr.map(oe=>oe.map(W)),null)}negate(){if(!this.negated){const W=[];for(const oe of this.expr)W.push(oe.negate());for(;W.length>1;){const oe=W.shift(),Se=W.shift(),te=[];for(const ae of ge(oe))for(const se of ge(Se))te.push(V.create([ae,se],null,!1));W.unshift($.create(te,null,!1))}this.negated=$.create(W,this,!0)}return this.negated}}e.ContextKeyOrExpr=$;class G extends _{static{this._info=[]}static all(){return G._info.values()}constructor(W,oe,Se){super(W,null),this._defaultValue=oe,typeof Se=="object"?G._info.push({...Se,key:W}):Se!==!0&&G._info.push({key:W,description:Se,type:oe!=null?typeof oe:void 0})}bindTo(W){return W.createKey(this.key,this._defaultValue)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return C.create(this.key,W)}notEqualsTo(W){return S.create(this.key,W)}}e.RawContextKey=G,e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function Z(Y,W){return Y<W?-1:Y>W?1:0}function le(Y,W,oe,Se){return Y<oe?-1:Y>oe?1:W<Se?-1:W>Se?1:0}function ne(Y,W){if(Y.type===u.False||W.type===u.True)return!0;if(Y.type===u.Or)return W.type===u.Or?_e(Y.expr,W.expr):!1;if(W.type===u.Or){for(const oe of W.expr)if(ne(Y,oe))return!0;return!1}if(Y.type===u.And){if(W.type===u.And)return _e(W.expr,Y.expr);for(const oe of Y.expr)if(ne(oe,W))return!0;return!1}return Y.equals(W)}function _e(Y,W){let oe=0,Se=0;for(;oe<Y.length&&Se<W.length;){const te=Y[oe].cmp(W[Se]);if(te<0)return!1;te===0&&oe++,Se++}return oe===Y.length}function ge(Y){return Y.type===u.Or?Y.expr:[Y]}}),define(Ce[215],Ie([1,0,35,5]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX=e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=e.AccessibilitySupport=e.IAccessibilityService=void 0,e.isAccessibilityInformation=k,e.IAccessibilityService=(0,d.createDecorator)("accessibilityService");var P;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=new r.RawContextKey("accessibilityModeEnabled",!1);function k(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX="ACCESSIBLE_VIEW_SHOWN_"}),define(Ce[113],Ie([1,0,18,24,10,185,83,199,140,8,215]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=n,e.stringSet=g,e.cursorStyleToString=N,e.filterValidationDecorations=De,r=$e(r),d=$e(d),P=$e(P),l=$e(l);var y;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(de){this._values=de}hasChanged(de){return this._values[de]}}e.ConfigurationChangedEvent=u;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class b{constructor(de,ce,Qe,tt){this.id=de,this.name=ce,this.defaultValue=Qe,this.schema=tt}applyUpdate(de,ce){return m(de,ce)}compute(de,ce,Qe){return Qe}}class a{constructor(de,ce){this.newValue=de,this.didChange=ce}}e.ApplyUpdateResult=a;function m(ue,de){if(typeof ue!="object"||typeof de!="object"||!ue||!de)return new a(de,ue!==de);if(Array.isArray(ue)||Array.isArray(de)){const Qe=Array.isArray(ue)&&Array.isArray(de)&&r.equals(ue,de);return new a(de,!Qe)}let ce=!1;for(const Qe in de)if(de.hasOwnProperty(Qe)){const tt=m(ue[Qe],de[Qe]);tt.didChange&&(ue[Qe]=tt.newValue,ce=!0)}return new a(ue,ce)}class p{constructor(de){this.schema=void 0,this.id=de,this.name="_never_",this.defaultValue=void 0}applyUpdate(de,ce){return m(de,ce)}validate(de){return this.defaultValue}}class f{constructor(de,ce,Qe,tt){this.id=de,this.name=ce,this.defaultValue=Qe,this.schema=tt}applyUpdate(de,ce){return m(de,ce)}validate(de){return typeof de>"u"?this.defaultValue:de}compute(de,ce,Qe){return Qe}}function i(ue,de){return typeof ue>"u"?de:ue==="false"?!1:!!ue}class s extends f{constructor(de,ce,Qe,tt=void 0){typeof tt<"u"&&(tt.type="boolean",tt.default=Qe),super(de,ce,Qe,tt)}validate(de){return i(de,this.defaultValue)}}function t(ue,de,ce,Qe){if(typeof ue>"u")return de;let tt=parseInt(ue,10);return isNaN(tt)?de:(tt=Math.max(ce,tt),tt=Math.min(Qe,tt),tt|0)}class o extends f{static clampedInt(de,ce,Qe,tt){return t(de,ce,Qe,tt)}constructor(de,ce,Qe,tt,ut,mt=void 0){typeof mt<"u"&&(mt.type="integer",mt.default=Qe,mt.minimum=tt,mt.maximum=ut),super(de,ce,Qe,mt),this.minimum=tt,this.maximum=ut}validate(de){return o.clampedInt(de,this.defaultValue,this.minimum,this.maximum)}}function n(ue,de,ce,Qe){if(typeof ue>"u")return de;const tt=h.float(ue,de);return h.clamp(tt,ce,Qe)}class h extends f{static clamp(de,ce,Qe){return de<ce?ce:de>Qe?Qe:de}static float(de,ce){if(typeof de=="number")return de;if(typeof de>"u")return ce;const Qe=parseFloat(de);return isNaN(Qe)?ce:Qe}constructor(de,ce,Qe,tt,ut){typeof ut<"u"&&(ut.type="number",ut.default=Qe),super(de,ce,Qe,ut),this.validationFn=tt}validate(de){return this.validationFn(h.float(de,this.defaultValue))}}class c extends f{static string(de,ce){return typeof de!="string"?ce:de}constructor(de,ce,Qe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.default=Qe),super(de,ce,Qe,tt)}validate(de){return c.string(de,this.defaultValue)}}function g(ue,de,ce,Qe){return typeof ue!="string"?de:Qe&&ue in Qe?Qe[ue]:ce.indexOf(ue)===-1?de:ue}class w extends f{constructor(de,ce,Qe,tt,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=tt,ut.default=Qe),super(de,ce,Qe,ut),this._allowedValues=tt}validate(de){return g(de,this.defaultValue,this._allowedValues)}}class D extends b{constructor(de,ce,Qe,tt,ut,mt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=tt),super(de,ce,Qe,Dt),this._allowedValues=ut,this._convert=mt}validate(de){return typeof de!="string"?this.defaultValue:this._allowedValues.indexOf(de)===-1?this.defaultValue:this._convert(de)}}function _(ue){switch(ue){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class C extends b{constructor(){super(xe.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(11776,null),l.localize(11777,null),l.localize(11778,null)],default:"auto",tags:["accessibility"],description:l.localize(11779,null)})}validate(de){switch(de){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(de,ce,Qe){return Qe===I.AccessibilitySupport.Unknown?de.accessibilitySupport:Qe}}class A extends b{constructor(){const de={insertSpace:!0,ignoreEmptyLines:!0};super(xe.comments,"comments",de,{"editor.comments.insertSpace":{type:"boolean",default:de.insertSpace,description:l.localize(11780,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:de.ignoreEmptyLines,description:l.localize(11781,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{insertSpace:i(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function S(ue){switch(ue){case"blink":return E.Blink;case"smooth":return E.Smooth;case"phase":return E.Phase;case"expand":return E.Expand;case"solid":return E.Solid}}var F;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function N(ue){switch(ue){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function O(ue){switch(ue){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class M extends p{constructor(){super(xe.editorClassName)}compute(de,ce,Qe){const tt=["monaco-editor"];return ce.get(xe.extraEditorClassName)&&tt.push(ce.get(xe.extraEditorClassName)),de.extraEditorClassName&&tt.push(de.extraEditorClassName),ce.get(xe.mouseStyle)==="default"?tt.push("mouse-default"):ce.get(xe.mouseStyle)==="copy"&&tt.push("mouse-copy"),ce.get(xe.showUnused)&&tt.push("showUnused"),ce.get(xe.showDeprecated)&&tt.push("showDeprecated"),tt.join(" ")}}class U extends s{constructor(){super(xe.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:l.localize(11782,null)})}compute(de,ce,Qe){return Qe&&de.emptySelectionClipboard}}class x extends b{constructor(){const de={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(xe.find,"find",de,{"editor.find.cursorMoveOnType":{type:"boolean",default:de.cursorMoveOnType,description:l.localize(11783,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:de.seedSearchStringFromSelection,enumDescriptions:[l.localize(11784,null),l.localize(11785,null),l.localize(11786,null)],description:l.localize(11787,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:de.autoFindInSelection,enumDescriptions:[l.localize(11788,null),l.localize(11789,null),l.localize(11790,null)],description:l.localize(11791,null)},"editor.find.globalFindClipboard":{type:"boolean",default:de.globalFindClipboard,description:l.localize(11792,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:de.addExtraSpaceOnTop,description:l.localize(11793,null)},"editor.find.loop":{type:"boolean",default:de.loop,description:l.localize(11794,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{cursorMoveOnType:i(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof de.seedSearchStringFromSelection=="boolean"?de.seedSearchStringFromSelection?"always":"never":g(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof de.autoFindInSelection=="boolean"?de.autoFindInSelection?"always":"never":g(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(ce.loop,this.defaultValue.loop)}}}class z extends b{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(xe.fontLigatures,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:l.localize(11795,null)},{type:"string",description:l.localize(11796,null)}],description:l.localize(11797,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"||de.length===0?z.OFF:de==="true"?z.ON:de:de?z.ON:z.OFF}}e.EditorFontLigatures=z;class B extends b{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(xe.fontVariations,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:l.localize(11798,null)},{type:"string",description:l.localize(11799,null)}],description:l.localize(11800,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"?B.OFF:de==="true"?B.TRANSLATE:de:de?B.TRANSLATE:B.OFF}compute(de,ce,Qe){return de.fontInfo.fontVariationSettings}}e.EditorFontVariations=B;class ee extends p{constructor(){super(xe.fontInfo)}compute(de,ce,Qe){return de.fontInfo}}class V extends f{constructor(){super(xe.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(11801,null)})}validate(de){const ce=h.float(de,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ce,6,100)}compute(de,ce,Qe){return de.fontInfo.fontSize}}class $ extends b{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(xe.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:l.localize(11802,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(11803,null)})}validate(de){return de==="normal"||de==="bold"?de:String(o.clampedInt(de,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}class G extends b{constructor(){const de={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:de.multiple,enumDescriptions:[l.localize(11804,null),l.localize(11805,null),l.localize(11806,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(xe.gotoLocation,"gotoLocation",de,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(11807,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(11808,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(11809,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:l.localize(11810,null),...ce},"editor.gotoLocation.multipleImplementations":{description:l.localize(11811,null),...ce},"editor.gotoLocation.multipleReferences":{description:l.localize(11812,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:de.alternativeDefinitionCommand,enum:Qe,description:l.localize(11813,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:de.alternativeTypeDefinitionCommand,enum:Qe,description:l.localize(11814,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:de.alternativeDeclarationCommand,enum:Qe,description:l.localize(11815,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:de.alternativeImplementationCommand,enum:Qe,description:l.localize(11816,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:de.alternativeReferenceCommand,enum:Qe,description:l.localize(11817,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{multiple:g(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??g(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??g(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??g(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??g(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??g(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:ce.multipleTests??g(ce.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:c.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:c.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:c.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:c.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:c.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:c.string(ce.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class Z extends b{constructor(){const de={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(xe.hover,"hover",de,{"editor.hover.enabled":{type:"boolean",default:de.enabled,description:l.localize(11818,null)},"editor.hover.delay":{type:"number",default:de.delay,minimum:0,maximum:1e4,description:l.localize(11819,null)},"editor.hover.sticky":{type:"boolean",default:de.sticky,description:l.localize(11820,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:de.hidingDelay,description:l.localize(11821,null)},"editor.hover.above":{type:"boolean",default:de.above,description:l.localize(11822,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{enabled:i(ce.enabled,this.defaultValue.enabled),delay:o.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:i(ce.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(ce.above,this.defaultValue.above)}}}var le;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(le||(e.RenderMinimap=le={}));class ne extends p{constructor(){super(xe.layoutInfo)}compute(de,ce,Qe){return ne.computeLayout(ce,{memory:de.memory,outerWidth:de.outerWidth,outerHeight:de.outerHeight,isDominatedByLongLines:de.isDominatedByLongLines,lineHeight:de.fontInfo.lineHeight,viewLineCount:de.viewLineCount,lineNumbersDigitCount:de.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:de.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:de.fontInfo.maxDigitWidth,pixelRatio:de.pixelRatio,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(de){const ce=de.height/de.lineHeight,Qe=Math.floor(de.paddingTop/de.lineHeight);let tt=Math.floor(de.paddingBottom/de.lineHeight);de.scrollBeyondLastLine&&(tt=Math.max(tt,ce-1));const ut=(Qe+de.viewLineCount+tt)/(de.pixelRatio*de.height),mt=Math.floor(de.viewLineCount/ut);return{typicalViewportLineCount:ce,extraLinesBeforeFirstLine:Qe,extraLinesBeyondLastLine:tt,desiredRatio:ut,minimapLineCount:mt}}static _computeMinimapLayout(de,ce){const Qe=de.outerWidth,tt=de.outerHeight,ut=de.pixelRatio;if(!de.minimap.enabled)return{renderMinimap:le.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const mt=ce.stableMinimapLayoutInput,Dt=mt&&de.outerHeight===mt.outerHeight&&de.lineHeight===mt.lineHeight&&de.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&de.pixelRatio===mt.pixelRatio&&de.scrollBeyondLastLine===mt.scrollBeyondLastLine&&de.paddingTop===mt.paddingTop&&de.paddingBottom===mt.paddingBottom&&de.minimap.enabled===mt.minimap.enabled&&de.minimap.side===mt.minimap.side&&de.minimap.size===mt.minimap.size&&de.minimap.showSlider===mt.minimap.showSlider&&de.minimap.renderCharacters===mt.minimap.renderCharacters&&de.minimap.maxColumn===mt.minimap.maxColumn&&de.minimap.scale===mt.minimap.scale&&de.verticalScrollbarWidth===mt.verticalScrollbarWidth&&de.isViewportWrapping===mt.isViewportWrapping,Mt=de.lineHeight,Vt=de.typicalHalfwidthCharacterWidth,ei=de.scrollBeyondLastLine,oi=de.minimap.renderCharacters;let Rt=ut>=2?Math.round(de.minimap.scale*2):de.minimap.scale;const it=de.minimap.maxColumn,Pt=de.minimap.size,di=de.minimap.side,Et=de.verticalScrollbarWidth,yt=de.viewLineCount,ti=de.remainingWidth,ii=de.isViewportWrapping,zt=oi?2:3;let vt=Math.floor(ut*tt);const Bt=vt/ut;let ni=!1,ai=!1,Je=zt*Rt,li=Rt/ut,hi=1;if(Pt==="fill"||Pt==="fit"){const{typicalViewportLineCount:Gt,extraLinesBeforeFirstLine:ci,extraLinesBeyondLastLine:$t,desiredRatio:Kt,minimapLineCount:Xt}=ne.computeContainedMinimapLineCount({viewLineCount:yt,scrollBeyondLastLine:ei,paddingTop:de.paddingTop,paddingBottom:de.paddingBottom,height:tt,lineHeight:Mt,pixelRatio:ut});if(yt/Xt>1)ni=!0,ai=!0,Rt=1,Je=1,li=Rt/ut;else{let bt=!1,It=Rt+1;if(Pt==="fit"){const jt=Math.ceil((ci+yt+$t)*Je);ii&&Dt&&ti<=ce.stableFitRemainingWidth?(bt=!0,It=ce.stableFitMaxMinimapScale):bt=jt>vt}if(Pt==="fill"||bt){ni=!0;const jt=Rt;Je=Math.min(Mt*ut,Math.max(1,Math.floor(1/Kt))),ii&&Dt&&ti<=ce.stableFitRemainingWidth&&(It=ce.stableFitMaxMinimapScale),Rt=Math.min(It,Math.max(1,Math.floor(Je/zt))),Rt>jt&&(hi=Math.min(2,Rt/jt)),li=Rt/ut/hi,vt=Math.ceil(Math.max(Gt,ci+yt+$t)*Je),ii?(ce.stableMinimapLayoutInput=de,ce.stableFitRemainingWidth=ti,ce.stableFitMaxMinimapScale=Rt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const fi=Math.floor(it*li),St=Math.min(fi,Math.max(0,Math.floor((ti-Et-2)*li/(Vt+li)))+e.MINIMAP_GUTTER_WIDTH);let xt=Math.floor(ut*St);const Nt=xt/ut;xt=Math.floor(xt*hi);const qt=oi?le.Text:le.Blocks,ri=di==="left"?0:Qe-St-Et;return{renderMinimap:qt,minimapLeft:ri,minimapWidth:St,minimapHeightIsEditorHeight:ni,minimapIsSampling:ai,minimapScale:Rt,minimapLineHeight:Je,minimapCanvasInnerWidth:xt,minimapCanvasInnerHeight:vt,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:Bt}}static computeLayout(de,ce){const Qe=ce.outerWidth|0,tt=ce.outerHeight|0,ut=ce.lineHeight|0,mt=ce.lineNumbersDigitCount|0,Dt=ce.typicalHalfwidthCharacterWidth,Mt=ce.maxDigitWidth,Vt=ce.pixelRatio,ei=ce.viewLineCount,oi=de.get(xe.wordWrapOverride2),Rt=oi==="inherit"?de.get(xe.wordWrapOverride1):oi,it=Rt==="inherit"?de.get(xe.wordWrap):Rt,Pt=de.get(xe.wordWrapColumn),di=ce.isDominatedByLongLines,Et=de.get(xe.glyphMargin),yt=de.get(xe.lineNumbers).renderType!==Be.Off,ti=de.get(xe.lineNumbersMinChars),ii=de.get(xe.scrollBeyondLastLine),zt=de.get(xe.padding),vt=de.get(xe.minimap),Bt=de.get(xe.scrollbar),ni=Bt.verticalScrollbarSize,ai=Bt.verticalHasArrows,Je=Bt.arrowSize,li=Bt.horizontalScrollbarSize,hi=de.get(xe.folding),fi=de.get(xe.showFoldingControls)!=="never";let St=de.get(xe.lineDecorationsWidth);hi&&fi&&(St+=16);let xt=0;if(yt){const mi=Math.max(mt,ti);xt=Math.round(mi*Mt)}let Nt=0;Et&&(Nt=ut*ce.glyphMarginDecorationLaneCount);let qt=0,ri=qt+Nt,Gt=ri+xt,ci=Gt+St;const $t=Qe-Nt-xt-St;let Kt=!1,Xt=!1,Ft=-1;Rt==="inherit"&&di?(Kt=!0,Xt=!0):it==="on"||it==="bounded"?Xt=!0:it==="wordWrapColumn"&&(Ft=Pt);const bt=ne._computeMinimapLayout({outerWidth:Qe,outerHeight:tt,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Vt,scrollBeyondLastLine:ii,paddingTop:zt.top,paddingBottom:zt.bottom,minimap:vt,verticalScrollbarWidth:ni,viewLineCount:ei,remainingWidth:$t,isViewportWrapping:Xt},ce.memory||new T);bt.renderMinimap!==le.None&&bt.minimapLeft===0&&(qt+=bt.minimapWidth,ri+=bt.minimapWidth,Gt+=bt.minimapWidth,ci+=bt.minimapWidth);const It=$t-bt.minimapWidth,jt=Math.max(1,Math.floor((It-ni-2)/Dt)),Tt=ai?Je:0;return Xt&&(Ft=Math.max(1,jt),it==="bounded"&&(Ft=Math.min(Ft,Pt))),{width:Qe,height:tt,glyphMarginLeft:qt,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:xt,decorationsLeft:Gt,decorationsWidth:St,contentLeft:ci,contentWidth:It,minimap:bt,viewportColumn:jt,isWordWrapMinified:Kt,isViewportWrapping:Xt,wrappingColumn:Ft,verticalScrollbarWidth:ni,horizontalScrollbarHeight:li,overviewRuler:{top:Tt,width:ni,height:tt-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=ne;class _e extends b{constructor(){super(xe.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(11823,null),l.localize(11824,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(11825,null)}})}validate(de){return g(de,"simple",["simple","advanced"])}compute(de,ce,Qe){return ce.get(xe.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Qe}}var ge;(function(ue){ue.Off="off",ue.OnCode="onCode",ue.On="on"})(ge||(e.ShowLightbulbIconMode=ge={}));class Y extends b{constructor(){const de={enabled:ge.On};super(xe.lightbulb,"lightbulb",de,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ge.Off,ge.OnCode,ge.On],default:de.enabled,enumDescriptions:[l.localize(11826,null),l.localize(11827,null),l.localize(11828,null)],description:l.localize(11829,null)}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{enabled:g(de.enabled,this.defaultValue.enabled,[ge.Off,ge.OnCode,ge.On])}}}class W extends b{constructor(){const de={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(xe.stickyScroll,"stickyScroll",de,{"editor.stickyScroll.enabled":{type:"boolean",default:de.enabled,description:l.localize(11830,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:de.maxLineCount,minimum:1,maximum:20,description:l.localize(11831,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:de.defaultModel,description:l.localize(11832,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:de.scrollWithEditor,description:l.localize(11833,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{enabled:i(ce.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class oe extends b{constructor(){const de={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(xe.inlayHints,"inlayHints",de,{"editor.inlayHints.enabled":{type:"string",default:de.enabled,description:l.localize(11834,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(11835,null),l.localize(11836,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(11837,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(11838,null)]},"editor.inlayHints.fontSize":{type:"number",default:de.fontSize,markdownDescription:l.localize(11839,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:de.fontFamily,markdownDescription:l.localize(11840,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:de.padding,description:l.localize(11841,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return typeof ce.enabled=="boolean"&&(ce.enabled=ce.enabled?"on":"off"),{enabled:g(ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:c.string(ce.fontFamily,this.defaultValue.fontFamily),padding:i(ce.padding,this.defaultValue.padding)}}}class Se extends b{constructor(){super(xe.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(de){return typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)?-parseFloat(de.substring(0,de.length-2)):o.clampedInt(de,this.defaultValue,0,1e3)}compute(de,ce,Qe){return Qe<0?o.clampedInt(-Qe*de.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Qe}}class te extends h{constructor(){super(xe.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,de=>h.clamp(de,0,150),{markdownDescription:l.localize(11842,null)})}compute(de,ce,Qe){return de.fontInfo.lineHeight}}class ae extends b{constructor(){const de={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(xe.minimap,"minimap",de,{"editor.minimap.enabled":{type:"boolean",default:de.enabled,description:l.localize(11843,null)},"editor.minimap.autohide":{type:"boolean",default:de.autohide,description:l.localize(11844,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(11845,null),l.localize(11846,null),l.localize(11847,null)],default:de.size,description:l.localize(11848,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:de.side,description:l.localize(11849,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:de.showSlider,description:l.localize(11850,null)},"editor.minimap.scale":{type:"number",default:de.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(11851,null)},"editor.minimap.renderCharacters":{type:"boolean",default:de.renderCharacters,description:l.localize(11852,null)},"editor.minimap.maxColumn":{type:"number",default:de.maxColumn,description:l.localize(11853,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:de.showRegionSectionHeaders,description:l.localize(11854,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:de.showMarkSectionHeaders,description:l.localize(11855,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:de.sectionHeaderFontSize,description:l.localize(11856,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:de.sectionHeaderLetterSpacing,description:l.localize(11857,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{enabled:i(ce.enabled,this.defaultValue.enabled),autohide:i(ce.autohide,this.defaultValue.autohide),size:g(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(ce.side,this.defaultValue.side,["right","left"]),showSlider:g(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(ce.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(ce.scale,1,1,3),maxColumn:o.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:h.clamp(ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function se(ue){return ue==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Q extends b{constructor(){super(xe.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(11858,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(11859,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{top:o.clampedInt(ce.top,0,0,1e3),bottom:o.clampedInt(ce.bottom,0,0,1e3)}}}class re extends b{constructor(){const de={enabled:!0,cycle:!0};super(xe.parameterHints,"parameterHints",de,{"editor.parameterHints.enabled":{type:"boolean",default:de.enabled,description:l.localize(11860,null)},"editor.parameterHints.cycle":{type:"boolean",default:de.cycle,description:l.localize(11861,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{enabled:i(ce.enabled,this.defaultValue.enabled),cycle:i(ce.cycle,this.defaultValue.cycle)}}}class ve extends p{constructor(){super(xe.pixelRatio)}compute(de,ce,Qe){return de.pixelRatio}}class be extends b{constructor(){super(xe.placeholder,"placeholder",void 0)}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de:this.defaultValue}}class Fe extends b{constructor(){const de={other:"on",comments:"off",strings:"off"},ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(11862,null),l.localize(11863,null),l.localize(11864,null)]}];super(xe.quickSuggestions,"quickSuggestions",de,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ce,default:de.strings,description:l.localize(11865,null)},comments:{anyOf:ce,default:de.comments,description:l.localize(11866,null)},other:{anyOf:ce,default:de.other,description:l.localize(11867,null)}},default:de,markdownDescription:l.localize(11868,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=de}validate(de){if(typeof de=="boolean"){const Vt=de?"on":"off";return{comments:Vt,strings:Vt,other:Vt}}if(!de||typeof de!="object")return this.defaultValue;const{other:ce,comments:Qe,strings:tt}=de,ut=["on","inline","off"];let mt,Dt,Mt;return typeof ce=="boolean"?mt=ce?"on":"off":mt=g(ce,this.defaultValue.other,ut),typeof Qe=="boolean"?Dt=Qe?"on":"off":Dt=g(Qe,this.defaultValue.comments,ut),typeof tt=="boolean"?Mt=tt?"on":"off":Mt=g(tt,this.defaultValue.strings,ut),{other:mt,comments:Dt,strings:Mt}}}var Be;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(Be||(e.RenderLineNumbersType=Be={}));class ke extends b{constructor(){super(xe.lineNumbers,"lineNumbers",{renderType:Be.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(11869,null),l.localize(11870,null),l.localize(11871,null),l.localize(11872,null)],default:"on",description:l.localize(11873,null)})}validate(de){let ce=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof de<"u"&&(typeof de=="function"?(ce=Be.Custom,Qe=de):de==="interval"?ce=Be.Interval:de==="relative"?ce=Be.Relative:de==="on"?ce=Be.On:ce=Be.Off),{renderType:ce,renderFn:Qe}}}function De(ue){const de=ue.get(xe.renderValidationDecorations);return de==="editable"?ue.get(xe.readOnly):de!=="on"}class Pe extends b{constructor(){const de=[],ce={type:"number",description:l.localize(11874,null)};super(xe.rulers,"rulers",de,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:l.localize(11875,null),format:"color-hex"}}}]},default:de,description:l.localize(11876,null)})}validate(de){if(Array.isArray(de)){const ce=[];for(const Qe of de)if(typeof Qe=="number")ce.push({column:o.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const tt=Qe;ce.push({column:o.clampedInt(tt.column,0,0,1e4),color:tt.color})}return ce.sort((Qe,tt)=>Qe.column-tt.column),ce}return this.defaultValue}}class H extends b{constructor(){super(xe.readOnlyMessage,"readOnlyMessage",void 0)}validate(de){return!de||typeof de!="object"?this.defaultValue:de}}function q(ue,de){if(typeof ue!="string")return de;switch(ue){case"hidden":return k.ScrollbarVisibility.Hidden;case"visible":return k.ScrollbarVisibility.Visible;default:return k.ScrollbarVisibility.Auto}}class X extends b{constructor(){const de={vertical:k.ScrollbarVisibility.Auto,horizontal:k.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(xe.scrollbar,"scrollbar",de,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(11877,null),l.localize(11878,null),l.localize(11879,null)],default:"auto",description:l.localize(11880,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(11881,null),l.localize(11882,null),l.localize(11883,null)],default:"auto",description:l.localize(11884,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:de.verticalScrollbarSize,description:l.localize(11885,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:de.horizontalScrollbarSize,description:l.localize(11886,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:de.scrollByPage,description:l.localize(11887,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:de.ignoreHorizontalScrollbarInContentHeight,description:l.localize(11888,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de,Qe=o.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=o.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:q(ce.vertical,this.defaultValue.vertical),horizontal:q(ce.horizontal,this.defaultValue.horizontal),useShadows:i(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:o.clampedInt(ce.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:o.clampedInt(ce.verticalSliderSize,tt,0,1e3),scrollByPage:i(ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends b{constructor(){const de={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(xe.unicodeHighlighting,"unicodeHighlight",de,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.nonBasicASCII,description:l.localize(11889,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:de.invisibleCharacters,description:l.localize(11890,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:de.ambiguousCharacters,description:l.localize(11891,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeComments,description:l.localize(11892,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeStrings,description:l.localize(11893,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:de.allowedCharacters,description:l.localize(11894,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:de.allowedLocales,description:l.localize(11895,null)}})}applyUpdate(de,ce){let Qe=!1;ce.allowedCharacters&&de&&(d.equals(de.allowedCharacters,ce.allowedCharacters)||(de={...de,allowedCharacters:ce.allowedCharacters},Qe=!0)),ce.allowedLocales&&de&&(d.equals(de.allowedLocales,ce.allowedLocales)||(de={...de,allowedLocales:ce.allowedLocales},Qe=!0));const tt=super.applyUpdate(de,ce);return Qe?new a(tt.newValue,!0):tt}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{nonBasicASCII:Ke(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(de.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(de.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(de,ce){if(typeof de!="object"||!de)return ce;const Qe={};for(const[tt,ut]of Object.entries(de))ut===!0&&(Qe[tt]=!0);return Qe}}class he extends b{constructor(){const de={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(xe.inlineSuggest,"inlineSuggest",de,{"editor.inlineSuggest.enabled":{type:"boolean",default:de.enabled,description:l.localize(11896,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(11897,null),l.localize(11898,null),l.localize(11899,null)],description:l.localize(11900,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:de.suppressSuggestions,description:l.localize(11901,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:de.fontFamily,description:l.localize(11902,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{enabled:i(ce.enabled,this.defaultValue.enabled),mode:g(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:c.string(ce.fontFamily,this.defaultValue.fontFamily)}}}class we extends b{constructor(){const de={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(xe.inlineEdit,"experimentalInlineEdit",de,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:de.enabled,description:l.localize(11903,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(11904,null),l.localize(11905,null),l.localize(11906,null)],description:l.localize(11907,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:de.fontFamily,description:l.localize(11908,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{enabled:i(ce.enabled,this.defaultValue.enabled),showToolbar:g(ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:c.string(ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(ce.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Oe extends b{constructor(){const de={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(xe.bracketPairColorization,"bracketPairColorization",de,{"editor.bracketPairColorization.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(11909,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:de.independentColorPoolPerBracketType,description:l.localize(11910,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{enabled:i(ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ve extends b{constructor(){const de={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(xe.guides,"guides",de,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(11911,null),l.localize(11912,null),l.localize(11913,null)],default:de.bracketPairs,description:l.localize(11914,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(11915,null),l.localize(11916,null),l.localize(11917,null)],default:de.bracketPairsHorizontal,description:l.localize(11918,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:de.highlightActiveBracketPair,description:l.localize(11919,null)},"editor.guides.indentation":{type:"boolean",default:de.indentation,description:l.localize(11920,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(11921,null),l.localize(11922,null),l.localize(11923,null)],default:de.highlightActiveIndentation,description:l.localize(11924,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{bracketPairs:Ke(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(ue,de,ce){const Qe=ce.indexOf(ue);return Qe===-1?de:ce[Qe]}class et extends b{constructor(){const de={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(xe.suggest,"suggest",de,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(11925,null),l.localize(11926,null)],default:de.insertMode,description:l.localize(11927,null)},"editor.suggest.filterGraceful":{type:"boolean",default:de.filterGraceful,description:l.localize(11928,null)},"editor.suggest.localityBonus":{type:"boolean",default:de.localityBonus,description:l.localize(11929,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:de.shareSuggestSelections,markdownDescription:l.localize(11930,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(11931,null),l.localize(11932,null),l.localize(11933,null),l.localize(11934,null)],default:de.selectionMode,markdownDescription:l.localize(11935,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:de.snippetsPreventQuickSuggestions,description:l.localize(11936,null)},"editor.suggest.showIcons":{type:"boolean",default:de.showIcons,description:l.localize(11937,null)},"editor.suggest.showStatusBar":{type:"boolean",default:de.showStatusBar,description:l.localize(11938,null)},"editor.suggest.preview":{type:"boolean",default:de.preview,description:l.localize(11939,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:de.showInlineDetails,description:l.localize(11940,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(11941,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(11942,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(11943,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(11944,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(11945,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(11946,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(11947,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(11948,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(11949,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(11950,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(11951,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(11952,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(11953,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(11954,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(11955,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(11956,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(11957,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(11958,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(11959,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(11960,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(11961,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(11962,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(11963,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(11964,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(11965,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(11966,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(11967,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(11968,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(11969,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(11970,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(11971,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(11972,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{insertMode:g(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(ce.showIcons,this.defaultValue.showIcons),showStatusBar:i(ce.showStatusBar,this.defaultValue.showStatusBar),preview:i(ce.preview,this.defaultValue.preview),previewMode:g(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(ce.showMethods,this.defaultValue.showMethods),showFunctions:i(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:i(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(ce.showFields,this.defaultValue.showFields),showVariables:i(ce.showVariables,this.defaultValue.showVariables),showClasses:i(ce.showClasses,this.defaultValue.showClasses),showStructs:i(ce.showStructs,this.defaultValue.showStructs),showInterfaces:i(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:i(ce.showModules,this.defaultValue.showModules),showProperties:i(ce.showProperties,this.defaultValue.showProperties),showEvents:i(ce.showEvents,this.defaultValue.showEvents),showOperators:i(ce.showOperators,this.defaultValue.showOperators),showUnits:i(ce.showUnits,this.defaultValue.showUnits),showValues:i(ce.showValues,this.defaultValue.showValues),showConstants:i(ce.showConstants,this.defaultValue.showConstants),showEnums:i(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:i(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(ce.showKeywords,this.defaultValue.showKeywords),showWords:i(ce.showWords,this.defaultValue.showWords),showColors:i(ce.showColors,this.defaultValue.showColors),showFiles:i(ce.showFiles,this.defaultValue.showFiles),showReferences:i(ce.showReferences,this.defaultValue.showReferences),showFolders:i(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:i(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(ce.showSnippets,this.defaultValue.showSnippets),showUsers:i(ce.showUsers,this.defaultValue.showUsers),showIssues:i(ce.showIssues,this.defaultValue.showIssues)}}}class nt extends b{constructor(){super(xe.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(11973,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(11974,null),default:!0,type:"boolean"}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(de.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(de.selectSubwords,this.defaultValue.selectSubwords)}}}class st extends b{constructor(){const de=[];super(xe.wordSegmenterLocales,"wordSegmenterLocales",de,{anyOf:[{description:l.localize(11975,null),type:"string"},{description:l.localize(11976,null),type:"array",items:{type:"string"}}]})}validate(de){if(typeof de=="string"&&(de=[de]),Array.isArray(de)){const ce=[];for(const Qe of de)if(typeof Qe=="string")try{Intl.Segmenter.supportedLocalesOf(Qe).length>0&&ce.push(Qe)}catch{}return ce}return this.defaultValue}}var rt;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class at extends b{constructor(){super(xe.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(11977,null),l.localize(11978,null),l.localize(11979,null),l.localize(11980,null)],description:l.localize(11981,null),default:"same"}})}validate(de){switch(de){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(de,ce,Qe){return ce.get(xe.accessibilitySupport)===I.AccessibilitySupport.Enabled?rt.None:Qe}}class gt extends p{constructor(){super(xe.wrappingInfo)}compute(de,ce,Qe){const tt=ce.get(xe.layoutInfo);return{isDominatedByLongLines:de.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}class ht extends b{constructor(){const de={enabled:!0,showDropSelector:"afterDrop"};super(xe.dropIntoEditor,"dropIntoEditor",de,{"editor.dropIntoEditor.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(11982,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(11983,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(11984,null),l.localize(11985,null)],default:"afterDrop"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{enabled:i(ce.enabled,this.defaultValue.enabled),showDropSelector:g(ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class lt extends b{constructor(){const de={enabled:!0,showPasteSelector:"afterPaste"};super(xe.pasteAs,"pasteAs",de,{"editor.pasteAs.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(11986,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(11987,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(11988,null),l.localize(11989,null)],default:"afterPaste"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const ce=de;return{enabled:i(ce.enabled,this.defaultValue.enabled),showPasteSelector:g(ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Te="Consolas, 'Courier New', monospace",Ue="Menlo, Monaco, 'Courier New', monospace",je="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?Ue:P.isLinux?je:Te,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var xe;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.inlineEdit=63]="inlineEdit",ue[ue.letterSpacing=64]="letterSpacing",ue[ue.lightbulb=65]="lightbulb",ue[ue.lineDecorationsWidth=66]="lineDecorationsWidth",ue[ue.lineHeight=67]="lineHeight",ue[ue.lineNumbers=68]="lineNumbers",ue[ue.lineNumbersMinChars=69]="lineNumbersMinChars",ue[ue.linkedEditing=70]="linkedEditing",ue[ue.links=71]="links",ue[ue.matchBrackets=72]="matchBrackets",ue[ue.minimap=73]="minimap",ue[ue.mouseStyle=74]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=76]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=78]="multiCursorModifier",ue[ue.multiCursorPaste=79]="multiCursorPaste",ue[ue.multiCursorLimit=80]="multiCursorLimit",ue[ue.occurrencesHighlight=81]="occurrencesHighlight",ue[ue.overviewRulerBorder=82]="overviewRulerBorder",ue[ue.overviewRulerLanes=83]="overviewRulerLanes",ue[ue.padding=84]="padding",ue[ue.pasteAs=85]="pasteAs",ue[ue.parameterHints=86]="parameterHints",ue[ue.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ue[ue.placeholder=88]="placeholder",ue[ue.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=90]="quickSuggestions",ue[ue.quickSuggestionsDelay=91]="quickSuggestionsDelay",ue[ue.readOnly=92]="readOnly",ue[ue.readOnlyMessage=93]="readOnlyMessage",ue[ue.renameOnType=94]="renameOnType",ue[ue.renderControlCharacters=95]="renderControlCharacters",ue[ue.renderFinalNewline=96]="renderFinalNewline",ue[ue.renderLineHighlight=97]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=99]="renderValidationDecorations",ue[ue.renderWhitespace=100]="renderWhitespace",ue[ue.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ue[ue.roundedSelection=102]="roundedSelection",ue[ue.rulers=103]="rulers",ue[ue.scrollbar=104]="scrollbar",ue[ue.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=106]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=107]="scrollPredominantAxis",ue[ue.selectionClipboard=108]="selectionClipboard",ue[ue.selectionHighlight=109]="selectionHighlight",ue[ue.selectOnLineNumbers=110]="selectOnLineNumbers",ue[ue.showFoldingControls=111]="showFoldingControls",ue[ue.showUnused=112]="showUnused",ue[ue.snippetSuggestions=113]="snippetSuggestions",ue[ue.smartSelect=114]="smartSelect",ue[ue.smoothScrolling=115]="smoothScrolling",ue[ue.stickyScroll=116]="stickyScroll",ue[ue.stickyTabStops=117]="stickyTabStops",ue[ue.stopRenderingLineAfter=118]="stopRenderingLineAfter",ue[ue.suggest=119]="suggest",ue[ue.suggestFontSize=120]="suggestFontSize",ue[ue.suggestLineHeight=121]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ue[ue.suggestSelection=123]="suggestSelection",ue[ue.tabCompletion=124]="tabCompletion",ue[ue.tabIndex=125]="tabIndex",ue[ue.unicodeHighlighting=126]="unicodeHighlighting",ue[ue.unusualLineTerminators=127]="unusualLineTerminators",ue[ue.useShadowDOM=128]="useShadowDOM",ue[ue.useTabStops=129]="useTabStops",ue[ue.wordBreak=130]="wordBreak",ue[ue.wordSegmenterLocales=131]="wordSegmenterLocales",ue[ue.wordSeparators=132]="wordSeparators",ue[ue.wordWrap=133]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=136]="wordWrapColumn",ue[ue.wordWrapOverride1=137]="wordWrapOverride1",ue[ue.wordWrapOverride2=138]="wordWrapOverride2",ue[ue.wrappingIndent=139]="wrappingIndent",ue[ue.wrappingStrategy=140]="wrappingStrategy",ue[ue.showDeprecated=141]="showDeprecated",ue[ue.inlayHints=142]="inlayHints",ue[ue.editorClassName=143]="editorClassName",ue[ue.pixelRatio=144]="pixelRatio",ue[ue.tabFocusMode=145]="tabFocusMode",ue[ue.layoutInfo=146]="layoutInfo",ue[ue.wrappingInfo=147]="wrappingInfo",ue[ue.defaultColorDecorators=148]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(xe||(e.EditorOption=xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new s(xe.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(11990,null)})),acceptSuggestionOnEnter:Ne(new w(xe.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(11991,null),""],markdownDescription:l.localize(11992,null)})),accessibilitySupport:Ne(new C),accessibilityPageSize:Ne(new o(xe.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(11993,null),tags:["accessibility"]})),ariaLabel:Ne(new c(xe.ariaLabel,"ariaLabel",l.localize(11994,null))),ariaRequired:Ne(new s(xe.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new s(xe.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(11995,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new w(xe.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(11996,null),l.localize(11997,null),""],description:l.localize(11998,null)})),autoClosingComments:Ne(new w(xe.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(11999,null),l.localize(12e3,null),""],description:l.localize(12001,null)})),autoClosingDelete:Ne(new w(xe.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(12002,null),""],description:l.localize(12003,null)})),autoClosingOvertype:Ne(new w(xe.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(12004,null),""],description:l.localize(12005,null)})),autoClosingQuotes:Ne(new w(xe.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(12006,null),l.localize(12007,null),""],description:l.localize(12008,null)})),autoIndent:Ne(new D(xe.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],_,{enumDescriptions:[l.localize(12009,null),l.localize(12010,null),l.localize(12011,null),l.localize(12012,null),l.localize(12013,null)],description:l.localize(12014,null)})),automaticLayout:Ne(new s(xe.automaticLayout,"automaticLayout",!1)),autoSurround:Ne(new w(xe.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(12015,null),l.localize(12016,null),l.localize(12017,null),""],description:l.localize(12018,null)})),bracketPairColorization:Ne(new Oe),bracketPairGuides:Ne(new Ve),stickyTabStops:Ne(new s(xe.stickyTabStops,"stickyTabStops",!1,{description:l.localize(12019,null)})),codeLens:Ne(new s(xe.codeLens,"codeLens",!0,{description:l.localize(12020,null)})),codeLensFontFamily:Ne(new c(xe.codeLensFontFamily,"codeLensFontFamily","",{description:l.localize(12021,null)})),codeLensFontSize:Ne(new o(xe.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(12022,null)})),colorDecorators:Ne(new s(xe.colorDecorators,"colorDecorators",!0,{description:l.localize(12023,null)})),colorDecoratorActivatedOn:Ne(new w(xe.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(12024,null),l.localize(12025,null),l.localize(12026,null)],description:l.localize(12027,null)})),colorDecoratorsLimit:Ne(new o(xe.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(12028,null)})),columnSelection:Ne(new s(xe.columnSelection,"columnSelection",!1,{description:l.localize(12029,null)})),comments:Ne(new A),contextmenu:Ne(new s(xe.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new s(xe.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:l.localize(12030,null)})),cursorBlinking:Ne(new D(xe.cursorBlinking,"cursorBlinking",E.Blink,"blink",["blink","smooth","phase","expand","solid"],S,{description:l.localize(12031,null)})),cursorSmoothCaretAnimation:Ne(new w(xe.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(12032,null),l.localize(12033,null),l.localize(12034,null)],description:l.localize(12035,null)})),cursorStyle:Ne(new D(xe.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:l.localize(12036,null)})),cursorSurroundingLines:Ne(new o(xe.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(12037,null)})),cursorSurroundingLinesStyle:Ne(new w(xe.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(12038,null),l.localize(12039,null)],markdownDescription:l.localize(12040,null)})),cursorWidth:Ne(new o(xe.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(12041,null)})),disableLayerHinting:Ne(new s(xe.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new s(xe.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new s(xe.domReadOnly,"domReadOnly",!1)),dragAndDrop:Ne(new s(xe.dragAndDrop,"dragAndDrop",!0,{description:l.localize(12042,null)})),emptySelectionClipboard:Ne(new U),dropIntoEditor:Ne(new ht),stickyScroll:Ne(new W),experimentalWhitespaceRendering:Ne(new w(xe.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(12043,null),l.localize(12044,null),l.localize(12045,null)],description:l.localize(12046,null)})),extraEditorClassName:Ne(new c(xe.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Ne(new h(xe.fastScrollSensitivity,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:l.localize(12047,null)})),find:Ne(new x),fixedOverflowWidgets:Ne(new s(xe.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Ne(new s(xe.folding,"folding",!0,{description:l.localize(12048,null)})),foldingStrategy:Ne(new w(xe.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(12049,null),l.localize(12050,null)],description:l.localize(12051,null)})),foldingHighlight:Ne(new s(xe.foldingHighlight,"foldingHighlight",!0,{description:l.localize(12052,null)})),foldingImportsByDefault:Ne(new s(xe.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:l.localize(12053,null)})),foldingMaximumRegions:Ne(new o(xe.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(12054,null)})),unfoldOnClickAfterEndOfLine:Ne(new s(xe.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(12055,null)})),fontFamily:Ne(new c(xe.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(12056,null)})),fontInfo:Ne(new ee),fontLigatures2:Ne(new z),fontSize:Ne(new V),fontWeight:Ne(new $),fontVariations:Ne(new B),formatOnPaste:Ne(new s(xe.formatOnPaste,"formatOnPaste",!1,{description:l.localize(12057,null)})),formatOnType:Ne(new s(xe.formatOnType,"formatOnType",!1,{description:l.localize(12058,null)})),glyphMargin:Ne(new s(xe.glyphMargin,"glyphMargin",!0,{description:l.localize(12059,null)})),gotoLocation:Ne(new G),hideCursorInOverviewRuler:Ne(new s(xe.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:l.localize(12060,null)})),hover:Ne(new Z),inDiffEditor:Ne(new s(xe.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Ne(new h(xe.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>h.clamp(ue,-5,20),{description:l.localize(12061,null)})),lightbulb:Ne(new Y),lineDecorationsWidth:Ne(new Se),lineHeight:Ne(new te),lineNumbers:Ne(new ke),lineNumbersMinChars:Ne(new o(xe.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new s(xe.linkedEditing,"linkedEditing",!1,{description:l.localize(12062,null)})),links:Ne(new s(xe.links,"links",!0,{description:l.localize(12063,null)})),matchBrackets:Ne(new w(xe.matchBrackets,"matchBrackets","always",["always","near","never"],{description:l.localize(12064,null)})),minimap:Ne(new ae),mouseStyle:Ne(new w(xe.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new h(xe.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:l.localize(12065,null)})),mouseWheelZoom:Ne(new s(xe.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.isMacintosh?l.localize(12066,null):l.localize(12067,null)})),multiCursorMergeOverlapping:Ne(new s(xe.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:l.localize(12068,null)})),multiCursorModifier:Ne(new D(xe.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],se,{markdownEnumDescriptions:[l.localize(12069,null),l.localize(12070,null)],markdownDescription:l.localize(12071,null)})),multiCursorPaste:Ne(new w(xe.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(12072,null),l.localize(12073,null)],markdownDescription:l.localize(12074,null)})),multiCursorLimit:Ne(new o(xe.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(12075,null)})),occurrencesHighlight:Ne(new w(xe.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[l.localize(12076,null),l.localize(12077,null),l.localize(12078,null)],markdownDescription:l.localize(12079,null)})),overviewRulerBorder:Ne(new s(xe.overviewRulerBorder,"overviewRulerBorder",!0,{description:l.localize(12080,null)})),overviewRulerLanes:Ne(new o(xe.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Ne(new Q),pasteAs:Ne(new lt),parameterHints:Ne(new re),peekWidgetDefaultFocus:Ne(new w(xe.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(12081,null),l.localize(12082,null)],description:l.localize(12083,null)})),placeholder:Ne(new be),definitionLinkOpensInPeek:Ne(new s(xe.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:l.localize(12084,null)})),quickSuggestions:Ne(new Fe),quickSuggestionsDelay:Ne(new o(xe.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(12085,null)})),readOnly:Ne(new s(xe.readOnly,"readOnly",!1)),readOnlyMessage:Ne(new H),renameOnType:Ne(new s(xe.renameOnType,"renameOnType",!1,{description:l.localize(12086,null),markdownDeprecationMessage:l.localize(12087,null)})),renderControlCharacters:Ne(new s(xe.renderControlCharacters,"renderControlCharacters",!0,{description:l.localize(12088,null),restricted:!0})),renderFinalNewline:Ne(new w(xe.renderFinalNewline,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:l.localize(12089,null)})),renderLineHighlight:Ne(new w(xe.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(12090,null)],description:l.localize(12091,null)})),renderLineHighlightOnlyWhenFocus:Ne(new s(xe.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(12092,null)})),renderValidationDecorations:Ne(new w(xe.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new w(xe.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(12093,null),l.localize(12094,null),l.localize(12095,null),""],description:l.localize(12096,null)})),revealHorizontalRightPadding:Ne(new o(xe.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new s(xe.roundedSelection,"roundedSelection",!0,{description:l.localize(12097,null)})),rulers:Ne(new Pe),scrollbar:Ne(new X),scrollBeyondLastColumn:Ne(new o(xe.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(12098,null)})),scrollBeyondLastLine:Ne(new s(xe.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:l.localize(12099,null)})),scrollPredominantAxis:Ne(new s(xe.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:l.localize(12100,null)})),selectionClipboard:Ne(new s(xe.selectionClipboard,"selectionClipboard",!0,{description:l.localize(12101,null),included:P.isLinux})),selectionHighlight:Ne(new s(xe.selectionHighlight,"selectionHighlight",!0,{description:l.localize(12102,null)})),selectOnLineNumbers:Ne(new s(xe.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new w(xe.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(12103,null),l.localize(12104,null),l.localize(12105,null)],description:l.localize(12106,null)})),showUnused:Ne(new s(xe.showUnused,"showUnused",!0,{description:l.localize(12107,null)})),showDeprecated:Ne(new s(xe.showDeprecated,"showDeprecated",!0,{description:l.localize(12108,null)})),inlayHints:Ne(new oe),snippetSuggestions:Ne(new w(xe.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(12109,null),l.localize(12110,null),l.localize(12111,null),l.localize(12112,null)],description:l.localize(12113,null)})),smartSelect:Ne(new nt),smoothScrolling:Ne(new s(xe.smoothScrolling,"smoothScrolling",!1,{description:l.localize(12114,null)})),stopRenderingLineAfter:Ne(new o(xe.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Ne(new et),inlineSuggest:Ne(new he),inlineEdit:Ne(new we),inlineCompletionsAccessibilityVerbose:Ne(new s(xe.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(12115,null)})),suggestFontSize:Ne(new o(xe.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(12116,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new o(xe.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(12117,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new s(xe.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:l.localize(12118,null)})),suggestSelection:Ne(new w(xe.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(12119,null),l.localize(12120,null),l.localize(12121,null)],description:l.localize(12122,null)})),tabCompletion:Ne(new w(xe.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(12123,null),l.localize(12124,null),l.localize(12125,null)],description:l.localize(12126,null)})),tabIndex:Ne(new o(xe.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Ne(new J),unusualLineTerminators:Ne(new w(xe.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(12127,null),l.localize(12128,null),l.localize(12129,null)],description:l.localize(12130,null)})),useShadowDOM:Ne(new s(xe.useShadowDOM,"useShadowDOM",!0)),useTabStops:Ne(new s(xe.useTabStops,"useTabStops",!0,{description:l.localize(12131,null)})),wordBreak:Ne(new w(xe.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(12132,null),l.localize(12133,null)],description:l.localize(12134,null)})),wordSegmenterLocales:Ne(new st),wordSeparators:Ne(new c(xe.wordSeparators,"wordSeparators",v.USUAL_WORD_SEPARATORS,{description:l.localize(12135,null)})),wordWrap:Ne(new w(xe.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(12136,null),l.localize(12137,null),l.localize(12138,null),l.localize(12139,null)],description:l.localize(12140,null)})),wordWrapBreakAfterCharacters:Ne(new c(xe.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new c(xe.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new o(xe.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(12141,null)})),wordWrapOverride1:Ne(new w(xe.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new w(xe.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new M),defaultColorDecorators:Ne(new s(xe.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:l.localize(12142,null)})),pixelRatio:Ne(new ve),tabFocusMode:Ne(new s(xe.tabFocusMode,"tabFocusMode",!1,{markdownDescription:l.localize(12143,null)})),layoutInfo:Ne(new ne),wrappingInfo:Ne(new gt),wrappingIndent:Ne(new at),wrappingStrategy:Ne(new _e)}});var Wt=this&&this.__importDefault||function(pe){return pe&&pe.__esModule?pe:{default:pe}};define(Ce[216],Ie([1,0,22,43,8,5,107,10,24]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=T,e.massageMessageBoxOptions=b,d=Wt(d),e.IDialogService=(0,k.createDecorator)("dialogService");var l;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(l||(l={}));class I{getConfirmationButtons(m){return this.getButtons(m,l.Confirmation)}getPromptButtons(m){return this.getButtons(m,l.Prompt)}getInputButtons(m){return this.getButtons(m,l.Input)}getButtons(m,p){const f=[];switch(p){case l.Confirmation:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,P.localize)(11577,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,P.localize)(11578,null));break}case l.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&f.push(...i.buttons.map(s=>s.label)),i.cancelButton&&(i.cancelButton===!0?f.push((0,P.localize)(11579,null)):typeof i.cancelButton=="string"?f.push(i.cancelButton):i.cancelButton.label?f.push(i.cancelButton.label):f.push((0,P.localize)(11580,null))),f.length===0&&f.push((0,P.localize)(11581,null));break}case l.Input:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,P.localize)(11582,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,P.localize)(11583,null));break}}return f}getDialogType(m){if(typeof m=="string")return m;if(typeof m=="number")return m===d.default.Info?"info":m===d.default.Error?"error":m===d.default.Warning?"warning":"none"}getPromptResult(m,p,f){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let s=i[p]?.run({checkboxChecked:f});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:f}}}e.AbstractDialogHandler=I,e.IFileDialogService=(0,k.createDecorator)("fileDialogService");var y;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const u=10;function T(a){const m=[];return m.push(...a.slice(0,u).map(p=>typeof p=="string"?p:(0,r.basename)(p))),a.length>u&&(a.length-u===1?m.push((0,P.localize)(11584,null)):m.push((0,P.localize)(11585,null,a.length-u))),m.push(""),m.join(`
`)}function b(a,m){const p=(0,v.deepClone)(a);let f=(p.buttons??[]).map(o=>(0,L.mnemonicButtonLabel)(o)),i=(a.buttons||[]).map((o,n)=>n),s=0,t=p.cancelId??f.length-1;if(f.length>1){const o=typeof t=="number"?f[t]:void 0;if(R.isLinux||R.isMacintosh){if(typeof o=="string"&&f.length>1&&t!==1){f.splice(t,1),f.splice(1,0,o);const n=i[t];i.splice(t,1),i.splice(1,0,n),t=1}R.isLinux&&f.length>1&&(f=f.reverse(),i=i.reverse(),s=f.length-1,typeof o=="string"&&(t=s-1))}else if(R.isWindows&&typeof o=="string"&&f.length>1&&t!==f.length-1){f.splice(t,1),f.push(o);const n=i[t];i.splice(t,1),i.push(n),t=f.length-1}}return p.buttons=f,p.defaultId=s,p.cancelId=t,p.noLink=!0,p.title=p.title||m.nameLong,{options:p,buttonIndeces:i}}}),define(Ce[144],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[217],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,r.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(Ce[218],Ie([1,0,56,59,14,16,10,104,33,109,8,217]),function(pe,e,r,d,P,k,L,R,v,l,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0,r=$e(r),k=$e(k),L=$e(L),v=$e(v),l=$e(l),I=$e(I);const u=I.localize(11427,null);class T{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends T{static{this.CMD="cmd.exe"}openTerminal(t,o){return this.spawnTerminal(r,t,l.getWindowsShell(),o)}spawnTerminal(t,o,n,h){const c=o.windowsExec||b.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const g=k.basename(c,".exe").toLowerCase();if(g==="cmder")return t.spawn(c,h?[h]:void 0),Promise.resolve(void 0);const w=["/c","start","/wait"];return c.indexOf(" ")>=0&&w.push(c),w.push(c),g==="wt"&&w.push("-d ."),new Promise((D,_)=>{const C=p(process),A=t.spawn(n,w,{cwd:h,env:C,detached:!0});A.on("error",_),A.on("exit",()=>D())})}async runInTerminal(t,o,n,h,c){const g="windowsExec"in c&&c.windowsExec?c.windowsExec:b.getDefaultTerminalWindows(),w=await b.getWtExePath();return new Promise((D,_)=>{const C=`"${o} - ${u}"`,A=`"${n.join('" "')}" & pause`,E=Object.assign({},p(process),h);Object.keys(E).filter(M=>E[M]===null).forEach(M=>delete E[M]);const S={cwd:o,env:E,windowsVerbatimArguments:!0};let F,N;k.basename(g,".exe")==="wt"?(F=g,N=["-d",".",b.CMD,"/c",A]):w?(F=w,N=["-d",".",g,"/c",A]):(F=b.CMD,N=["/c","start",C,"/wait",g,"/c",`"${A}"`]),r.spawn(F,N,S).on("error",M=>{_(f(M))}),D(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const t=await l.win32.findExecutable("wt");return await v.Promises.exists(t)?t:void 0}catch{return}}}e.WindowsExternalTerminalService=b,Xe([d.memoize],b,"getWtExePath",null);class a extends T{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,h,c){const g=c.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((w,D)=>{if(g===y.DEFAULT_TERMINAL_OSX||g==="iTerm.app"){const _=g===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",A=[P.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${_}.scpt`).fsPath,"-t",t||u,"-w",o];for(const F of n)A.push("-a"),A.push(F);if(h){const F=Object.assign({},p(process),h);for(const N in F){const O=F[N];O===null?(A.push("-u"),A.push(N)):(A.push("-e"),A.push(`${N}=${O}`))}}let E="";const S=r.spawn(a.OSASCRIPT,A);S.on("error",F=>{D(f(F))}),S.stderr.on("data",F=>{E+=F.toString()}),S.on("exit",F=>{if(F===0)w(void 0);else if(E){const N=E.split(`
`,1);D(new Error(N[0]))}else D(new Error(I.localize(11428,null,_,F)))})}else D(new Error(I.localize(11429,null,g)))})}spawnTerminal(t,o,n){const h=o.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((c,g)=>{const w=["-a",h];n&&w.push(n);const D=p(process),_=t.spawn("/usr/bin/open",w,{cwd:n,env:D});_.on("error",g),_.on("exit",()=>c())})}}e.MacExternalTerminalService=a;class m extends T{static{this.WAIT_MESSAGE=I.localize(11430,null)}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,h,c){const g=c.linuxExec?Promise.resolve(c.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((w,D)=>{const _=[];g.then(C=>{C.indexOf("gnome-terminal")>=0?_.push("-x"):_.push("-e"),_.push("bash"),_.push("-c");const A=`${i(n)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;_.push(`''${A}''`);const E=Object.assign({},p(process),h);Object.keys(E).filter(O=>E[O]===null).forEach(O=>delete E[O]);const S={cwd:o,env:E};let F="";const N=r.spawn(C,_,S);N.on("error",O=>{D(f(O))}),N.stderr.on("data",O=>{F+=O.toString()}),N.on("exit",O=>{if(O===0)w(void 0);else if(F){const M=F.split(`
`,1);D(new Error(M[0]))}else D(new Error(I.localize(11431,null,C,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const t=await v.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(o=>{t?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,o,n){const h=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((c,g)=>{h.then(w=>{const D=p(process),_=t.spawn(w,[],{cwd:n,env:D});_.on("error",g),_.on("exit",()=>c())})})}}e.LinuxExternalTerminalService=m;function p(s){const t={...s.env};return(0,R.sanitizeProcessEnvironment)(t),t}function f(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(I.localize(11432,null,s.path)):s}function i(s){let t="";for(const o of s)o.indexOf(" ")>=0?t+='"'+o+'"':t+=o,t+=" ";return t}}),define(Ce[27],Ie([1,0,84,16,12,17,2,8,5,10,14,50]),function(pe,e,r,d,P,k,L,R,v,l,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=u,e.isFileSystemWatcher=m,e.hasReadWriteCapability=f,e.hasFileFolderCopyCapability=i,e.hasFileCloneCapability=s,e.hasOpenReadWriteCloseCapability=t,e.hasFileReadStreamCapability=o,e.hasFileAtomicReadCapability=n,e.hasFileAtomicWriteCapability=h,e.hasFileAtomicDeleteCapability=c,e.hasReadonlyCapability=g,e.createFileSystemProviderError=_,e.ensureFileSystemProviderError=C,e.markAsFileSystemProviderError=A,e.toFileSystemProviderErrorCode=E,e.toFileOperationResult=S,e.isParent=U,e.etag=$,e.whenProviderRegistered=G,e.getLargeFileConfirmationLimit=le,e.IFileService=(0,v.createDecorator)("fileService");function u(ne){return ne.create===!0}var T;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(T||(e.FileType=T={}));var b;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var a;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function m(ne){const _e=ne;return!!_e&&typeof _e.onDidChange=="function"}var p;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function f(ne){return!!(ne.capabilities&p.FileReadWrite)}function i(ne){return!!(ne.capabilities&p.FileFolderCopy)}function s(ne){return!!(ne.capabilities&p.FileClone)}function t(ne){return!!(ne.capabilities&p.FileOpenReadWriteClose)}function o(ne){return!!(ne.capabilities&p.FileReadStream)}function n(ne){return f(ne)?!!(ne.capabilities&p.FileAtomicRead):!1}function h(ne){return f(ne)?!!(ne.capabilities&p.FileAtomicWrite):!1}function c(ne){return!!(ne.capabilities&p.FileAtomicDelete)}function g(ne){return!!(ne.capabilities&p.Readonly)}var w;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class D extends Error{static create(_e,ge){const Y=new D(_e.toString(),ge);return A(Y,ge),Y}constructor(_e,ge){super(_e),this.code=ge}}e.FileSystemProviderError=D;function _(ne,_e){return D.create(ne,_e)}function C(ne){return ne||_((0,R.localize)(11386,null),w.Unknown)}function A(ne,_e){return ne.name=_e?`${_e} (FileSystemError)`:"FileSystemError",ne}function E(ne){if(!ne)return w.Unknown;if(ne instanceof D)return ne.code;const _e=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!_e)return w.Unknown;switch(_e[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}function S(ne){if(ne instanceof x)return ne.fileOperationResult;switch(E(ne)){case w.FileNotFound:return ee.FILE_NOT_FOUND;case w.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case w.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case w.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case w.NoPermissions:return ee.FILE_PERMISSION_DENIED;case w.FileExists:return ee.FILE_MOVE_CONFLICT;case w.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var F;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class N{constructor(_e,ge,Y){this.resource=_e,this.operation=ge,this.target=Y}isOperation(_e){return this.operation===_e}}e.FileOperationEvent=N;var O;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class M{static{this.MIXED_CORRELATION=null}constructor(_e,ge){this.ignorePathCasing=ge,this.correlationId=void 0,this.added=new y.Lazy(()=>{const Y=r.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Y.fill(this.rawAdded.map(W=>[W,!0])),Y}),this.updated=new y.Lazy(()=>{const Y=r.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Y.fill(this.rawUpdated.map(W=>[W,!0])),Y}),this.deleted=new y.Lazy(()=>{const Y=r.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Y.fill(this.rawDeleted.map(W=>[W,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of _e){switch(Y.type){case O.ADDED:this.rawAdded.push(Y.resource);break;case O.UPDATED:this.rawUpdated.push(Y.resource);break;case O.DELETED:this.rawDeleted.push(Y.resource);break}this.correlationId!==M.MIXED_CORRELATION&&(typeof Y.cId=="number"?this.correlationId===void 0?this.correlationId=Y.cId:this.correlationId!==Y.cId&&(this.correlationId=M.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=M.MIXED_CORRELATION))}}contains(_e,...ge){return this.doContains(_e,{includeChildren:!1},...ge)}affects(_e,...ge){return this.doContains(_e,{includeChildren:!0},...ge)}doContains(_e,ge,...Y){if(!_e)return!1;const W=Y.length>0;return!!((!W||Y.includes(O.ADDED))&&(this.added.value.get(_e)||ge.includeChildren&&this.added.value.findSuperstr(_e))||(!W||Y.includes(O.UPDATED))&&(this.updated.value.get(_e)||ge.includeChildren&&this.updated.value.findSuperstr(_e))||(!W||Y.includes(O.DELETED))&&(this.deleted.value.findSubstr(_e)||ge.includeChildren&&this.deleted.value.findSuperstr(_e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(_e){return this.correlationId===_e}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=M;function U(ne,_e,ge){return!ne||!_e||ne===_e||_e.length>ne.length?!1:(_e.charAt(_e.length-1)!==d.sep&&(_e+=d.sep),ge?(0,P.startsWithIgnoreCase)(ne,_e):ne.indexOf(_e)===0)}class x extends Error{constructor(_e,ge,Y){super(_e),this.fileOperationResult=ge,this.options=Y}}e.FileOperationError=x;class z extends x{constructor(_e,ge,Y,W){super(_e,ge,W),this.fileOperationResult=ge,this.size=Y}}e.TooLargeFileOperationError=z;class B extends x{constructor(_e,ge,Y){super(_e,ee.FILE_NOT_MODIFIED_SINCE,Y),this.stat=ge}}e.NotModifiedSinceFileOperationError=B;var ee;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var V;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.ETAG_DISABLED="";function $(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function G(ne,_e){if(!_e.hasProvider(L.URI.from({scheme:ne.scheme})))return new Promise(ge=>{const Y=_e.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(Y.dispose(),ge())})})}class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(_e){return(0,k.isNumber)(_e)||(_e=0),_e<Z.KB?(0,R.localize)(11387,null,_e.toFixed(0)):_e<Z.MB?(0,R.localize)(11388,null,(_e/Z.KB).toFixed(2)):_e<Z.GB?(0,R.localize)(11389,null,(_e/Z.MB).toFixed(2)):_e<Z.TB?(0,R.localize)(11390,null,(_e/Z.GB).toFixed(2)):(0,R.localize)(11391,null,(_e/Z.TB).toFixed(2))}}e.ByteSize=Z;function le(ne){const _e=typeof ne=="string"||ne?.scheme===I.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===I.Schemas.file?1024*Z.MB:_e?10*Z.MB:l.isWeb?50*Z.MB:1024*Z.MB}}),define(Ce[219],Ie([1,0,21,13,8,27]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=L;async function L(I,y,u,T,b,a){let m;try{await R(I,y,u,T,b,a)}catch(p){m=p}finally{m&&b.errorTransformer&&(m=b.errorTransformer(m)),typeof m<"u"&&u.error(m),u.end()}}async function R(I,y,u,T,b,a){v(a);const m=await I.open(y,{create:!1});try{v(a);let p=0,f=0,i=b&&typeof b.length=="number"?b.length:void 0,s=r.VSBuffer.alloc(Math.min(b.bufferSize,typeof i=="number"?i:b.bufferSize)),t=b&&typeof b.position=="number"?b.position:0,o=0;do f=await I.read(m,t,s.buffer,o,s.byteLength-o),t+=f,o+=f,p+=f,typeof i=="number"&&(i-=f),o===s.byteLength&&(await u.write(T(s)),s=r.VSBuffer.alloc(Math.min(b.bufferSize,typeof i=="number"?i:b.bufferSize)),o=0);while(f>0&&(typeof i!="number"||i>0)&&v(a)&&l(p,b));if(o>0){let n=o;typeof i=="number"&&(n=Math.min(o,i)),u.write(T(s.slice(0,n)))}}catch(p){throw(0,k.ensureFileSystemProviderError)(p)}finally{await I.close(m)}}function v(I){if(I.isCancellationRequested)throw(0,d.canceled)();return!0}function l(I,y){if(typeof y?.limits?.size=="number"&&I>y.limits.size)throw(0,k.createFileSystemProviderError)((0,P.localize)(11385,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ce[69],Ie([1,0,38,3,16,10,2,27]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=v,e.isRecursiveWatchRequest=l,e.reviveFileChanges=T,e.coalesceEvents=b,e.normalizeWatcherPattern=a,e.parseWatcherPatterns=m,e.isFiltered=f,e.requestFilterToString=i;function v(s){return typeof s.correlationId=="number"}function l(s){return s.recursive===!0}class I extends d.Disposable{static{this.MAX_RESTARTS=5}constructor(t,o,n,h){super(),this.onFileChanges=t,this.onLogMessage=o,this.verboseLogging=n,this.options=h,this.watcherDisposables=this._register(new d.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new d.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(o=>this.onFileChanges(o))),t.add(this.watcher.onDidLogMessage(o=>this.onLogMessage(o))),t.add(this.watcher.onDidError(o=>this.onError(o.error,o.request)))}onError(t,o){this.canRestart(t,o)?this.restartCounter<I.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${t}`):this.error(t)}canRestart(t,o){return!(!this.options.restartOnError||o||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}trace(t){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=I;class y extends I{constructor(t,o,n){super(t,o,n,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class u extends I{constructor(t,o,n){super(t,o,n,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=u;function T(s){return s.map(t=>({type:t.type,resource:L.URI.revive(t.resource),cId:t.cId}))}function b(s){const t=new p;for(const o of s)t.processEvent(o);return t.coalesce()}function a(s,t){return typeof t=="string"&&!t.startsWith(r.GLOBSTAR)&&!(0,P.isAbsolute)(t)?{base:s,pattern:t}:t}function m(s,t){const o=[];for(const n of t)o.push((0,r.parse)(a(s,n)));return o}class p{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return k.isLinux?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const o=this.mapPathToChange.get(this.toKey(t));let n=!1;if(o){const h=o.type,c=t.type;o.resource.fsPath!==t.resource.fsPath&&(t.type===R.FileChangeType.DELETED||t.type===R.FileChangeType.ADDED)?n=!0:h===R.FileChangeType.ADDED&&c===R.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(o)):h===R.FileChangeType.DELETED&&c===R.FileChangeType.ADDED?o.type=R.FileChangeType.UPDATED:h===R.FileChangeType.ADDED&&c===R.FileChangeType.UPDATED||(o.type=c)}else n=!0;n&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],o=[];return Array.from(this.coalesced).filter(n=>n.type!==R.FileChangeType.DELETED?(t.push(n),!1):!0).sort((n,h)=>n.resource.fsPath.length-h.resource.fsPath.length).filter(n=>o.some(h=>(0,R.isParent)(n.resource.fsPath,h,!k.isLinux))?!1:(o.push(n.resource.fsPath),!0)).concat(t)}}function f(s,t){if(typeof t=="number")switch(s.type){case R.FileChangeType.ADDED:return(t&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(t&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(t&R.FileChangeFilter.UPDATED)===0}return!1}function i(s){if(typeof s=="number"){const t=[];return s&R.FileChangeFilter.ADDED&&t.push("Added"),s&R.FileChangeFilter.DELETED&&t.push("Deleted"),s&R.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(Ce[220],Ie([1,0,45,3,69,4,27,2,7]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class l extends d.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new k.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new d.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new v.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new v.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(y=>this.handleDidWatchFail(y)))}handleDidWatchFail(y){this.isCorrelated(y)&&this.suspendWatchRequest(y)}isCorrelated(y){return(0,P.isWatchRequestWithCorrelation)(y)}async watch(y){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new v.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const u of y)this.isCorrelated(u)?this.allCorrelatedWatchRequests.set(u.correlationId,u):this.allNonCorrelatedWatchRequests.add(u);for(const[u]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(u)||(this.suspendedWatchRequests.deleteAndDispose(u),this.suspendedWatchRequestsWithPolling.delete(u));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(y){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(u=>!this.suspendedWatchRequests.has(u.correlationId))]),y?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(y){return typeof y.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(y.correlationId)?"polling":this.suspendedWatchRequests.has(y.correlationId)}async suspendWatchRequest(y){if(this.suspendedWatchRequests.has(y.correlationId))return;const u=new d.DisposableStore;this.suspendedWatchRequests.set(y.correlationId,u),await this.joinWatch.p,!u.isDisposed&&(this.monitorSuspendedWatchRequest(y,u),this.updateWatchers(!0))}resumeWatchRequest(y){this.suspendedWatchRequests.deleteAndDispose(y.correlationId),this.suspendedWatchRequestsWithPolling.delete(y.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(y,u){this.doMonitorWithExistingWatcher(y,u)?(this.trace(`reusing an existing recursive watcher to monitor ${y.path}`),this.suspendedWatchRequestsWithPolling.delete(y.correlationId)):(this.doMonitorWithNodeJS(y,u),this.suspendedWatchRequestsWithPolling.add(y.correlationId))}doMonitorWithExistingWatcher(y,u){const T=this.recursiveWatcher?.subscribe(y.path,(b,a)=>{u.isDisposed||(b?this.monitorSuspendedWatchRequest(y,u):a?.type===L.FileChangeType.ADDED&&this.onMonitoredPathAdded(y))});return T?(u.add(T),!0):!1}doMonitorWithNodeJS(y,u){let T=!1;const b=(a,m)=>{if(u.isDisposed)return;const p=this.isPathNotFound(a),f=this.isPathNotFound(m),i=T;T=p,!p&&(f||i)&&this.onMonitoredPathAdded(y)};this.trace(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,r.watchFile)(y.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},b)}catch(a){this.warn(`fs.watchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}u.add((0,d.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,r.unwatchFile)(y.path,b)}catch(a){this.warn(`fs.unwatchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}onMonitoredPathAdded(y){this.trace(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const u={resource:R.URI.file(y.path),type:L.FileChangeType.ADDED,cId:y.correlationId};this._onDidChangeFile.fire([u]),this.traceEvent(u,y),this.resumeWatchRequest(y)}isPathNotFound(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(y,u){if(this.verboseLogging){const T=` >> normalized ${y.type===L.FileChangeType.ADDED?"[ADDED]":y.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.traceWithCorrelation(T,u)}}traceWithCorrelation(y,u){this.verboseLogging&&this.trace(`${y}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}requestToString(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,P.requestFilterToString)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.verboseLogging=y}}e.BaseWatcher=l}),define(Ce[221],Ie([1,0,45,7,20,31,3,81,16,10,22,2,108,33,27,69]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=p;class m extends L.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(i,s,t,o,n,h){super(),this.request=i,this.recursiveWatcher=s,this.onDidFilesChange=t,this.onDidWatchFail=o,this.onLogMessage=n,this.verboseLogging=h,this.throttledFileChangesEmitter=this._register(new d.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c))),this.fileChangesAggregator=this._register(new d.RunOnceWorker(c=>this.handleFileChanges(c),m.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,a.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,a.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,a.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new P.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const i=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const s=await r.promises.stat(i);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(i,s.isDirectory()))}catch(i){i.code!=="ENOENT"?this.error(i):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${i})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(i){let s=i.path;try{s=await T.Promises.realpath(i.path),i.path===s&&(s=await(0,u.realcase)(i.path,this.cts.token)??i.path),i.path!==s&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${s})`)}catch{}return s}async doWatch(i,s){const t=new L.DisposableStore;return this.doWatchWithExistingWatcher(i,s,t)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(i,s,t)),t}doWatchWithExistingWatcher(i,s,t){if(s)return!1;const o=y.URI.file(this.request.path),n=this.recursiveWatcher?.subscribe(this.request.path,async(h,c)=>{if(!t.isDisposed)if(h){const g=await this.doWatch(i,s);t.isDisposed?g.dispose():t.add(g)}else c&&(typeof c.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:o,type:c.type,cId:this.request.correlationId},!0)});return n?(t.add(n),!0):!1}async doWatchWithNodeJS(i,s,t){if(l.isMacintosh&&(0,k.isEqualOrParent)(i,"/Volumes/",!0)){this.error(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new P.CancellationTokenSource(this.cts.token);t.add((0,L.toDisposable)(()=>o.dispose(!0)));const n=new L.DisposableStore;t.add(n);try{const h=y.URI.file(this.request.path),c=(0,v.basename)(i),g=(0,r.watch)(i);n.add((0,L.toDisposable)(()=>{g.removeAllListeners(),g.close()})),this.trace(`Started watching: '${i}'`);const w=new Set;if(s)try{for(const _ of await T.Promises.readdir(i))w.add(_)}catch(_){this.error(_)}if(o.token.isCancellationRequested)return;const D=new Map;n.add((0,L.toDisposable)(()=>{for(const[,_]of D)_.dispose();D.clear()})),g.on("error",(_,C)=>{o.token.isCancellationRequested||(this.error(`Failed to watch ${i} for changes using fs.watch() (${_}, ${C})`),this.notifyWatchFailed())}),g.on("change",(_,C)=>{if(o.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${_}"] ${C}`);let A="";if(C&&(A=C.toString(),l.isMacintosh&&(A=(0,R.normalizeNFC)(A))),!(!A||_!=="change"&&_!=="rename"))if(s)if(_==="rename"){D.get(A)?.dispose();const E=setTimeout(async()=>{if(D.delete(A),A===c&&!await T.Promises.exists(i)){this.onWatchedPathDeleted(h);return}if(o.token.isCancellationRequested)return;const S=await this.existsChildStrictCase((0,v.join)(i,A));if(o.token.isCancellationRequested)return;let F;S?w.has(A)?F=b.FileChangeType.UPDATED:(F=b.FileChangeType.ADDED,w.add(A)):(w.delete(A),F=b.FileChangeType.DELETED),this.onFileChange({resource:(0,I.joinPath)(h,A),type:F,cId:this.request.correlationId})},m.FILE_DELETE_HANDLER_DELAY);D.set(A,(0,L.toDisposable)(()=>clearTimeout(E)))}else{let E;w.has(A)?E=b.FileChangeType.UPDATED:(E=b.FileChangeType.ADDED,w.add(A)),this.onFileChange({resource:(0,I.joinPath)(h,A),type:E,cId:this.request.correlationId})}else if(_==="rename"||A!==c){const E=setTimeout(async()=>{const S=await T.Promises.exists(i);o.token.isCancellationRequested||(S?(this.onFileChange({resource:h,type:b.FileChangeType.UPDATED,cId:this.request.correlationId},!0),n.add(await this.doWatch(i,!1))):this.onWatchedPathDeleted(h))},m.FILE_DELETE_HANDLER_DELAY);n.clear(),n.add((0,L.toDisposable)(()=>clearTimeout(E)))}else this.onFileChange({resource:h,type:b.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(h){o.token.isCancellationRequested||this.error(`Failed to watch ${i} for changes using fs.watch() (${h.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(i){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:i,type:b.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(i,s=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${i.type===b.FileChangeType.ADDED?"[ADDED]":i.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!s&&this.excludes.some(t=>t(i.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${i.resource.fsPath}`):!s&&this.includes&&this.includes.length>0&&!this.includes.some(t=>t(i.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${i.resource.fsPath}`):this.fileChangesAggregator.work(i))}handleFileChanges(i){const s=(0,a.coalesceEvents)(i),t=[];for(const n of s){if((0,a.isFiltered)(n,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${n.resource.fsPath}`);continue}t.push(n)}if(t.length===0)return;if(this.verboseLogging)for(const n of t)this.traceWithCorrelation(` >> normalized ${n.type===b.FileChangeType.ADDED?"[ADDED]":n.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.throttledFileChangesEmitter.work(t)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(i){if(l.isLinux)return T.Promises.exists(i);try{const s=(0,v.basename)(i);return(await T.Promises.readdir((0,v.dirname)(i))).some(o=>o===s)}catch(s){return this.trace(s),!1}}setVerboseLogging(i){this.verboseLogging=i}error(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}warn(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}trace(i){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}traceWithCorrelation(i){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${i}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m;async function p(f,i,s,t,o=512){const n=await T.Promises.open(f,"r"),h=Buffer.allocUnsafe(o),c=new P.CancellationTokenSource(t);let g,w=!1;const D={path:f,excludes:[],recursive:!1},_=new m(D,void 0,C=>{(async()=>{for(const{type:A}of C)if(A===b.FileChangeType.UPDATED){if(w)return;w=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:E}=await T.Promises.read(n,h,0,o,null);if(!E||c.token.isCancellationRequested)break;i(h.slice(0,E))}}catch(E){g=new Error(E),c.dispose(!0)}finally{w=!1}}})()});return await _.ready,s(),new Promise((C,A)=>{c.token.onCancellationRequested(async()=>{_.dispose();try{await T.Promises.close(n)}catch(E){g=new Error(E)}g?A(g):C()})})}}),define(Ce[222],Ie([1,0,4,38,220,10,221,31]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class v extends P.BaseWatcher{constructor(I){super(),this.recursiveWatcher=I,this.onDidError=r.Event.None,this.watchers=new Set}async doWatch(I){I=this.removeDuplicateRequests(I);const y=[],u=new Set(Array.from(this.watchers));for(const T of I){const b=this.findWatcher(T);b&&(0,d.patternsEquals)(b.request.excludes,T.excludes)&&(0,d.patternsEquals)(b.request.includes,T.includes)?u.delete(b):y.push(T)}y.length&&this.trace(`Request to start watching: ${y.map(T=>this.requestToString(T)).join(",")}`),u.size&&this.trace(`Request to stop watching: ${Array.from(u).map(T=>this.requestToString(T.request)).join(",")}`);for(const T of u)this.stopWatching(T);for(const T of y)this.startWatching(T)}findWatcher(I){for(const y of this.watchers)if(typeof I.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===I.correlationId)return y}else if((0,R.isEqual)(y.request.path,I.path,!k.isLinux))return y}startWatching(I){const y=new L.NodeJSFileWatcherLibrary(I,this.recursiveWatcher,T=>this._onDidChangeFile.fire(T),()=>this._onDidWatchFail.fire(I),T=>this._onDidLogMessage.fire(T),this.verboseLogging),u={request:I,instance:y};this.watchers.add(u)}async stop(){await super.stop();for(const I of this.watchers)this.stopWatching(I)}stopWatching(I){this.trace("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}removeDuplicateRequests(I){const y=new Map;for(const u of I){const T=k.isLinux?u.path:u.path.toLowerCase();let b=y.get(u.correlationId);b||(b=new Map,y.set(u.correlationId,b)),b.has(T)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(u)}`),b.set(T,u)}return Array.from(y.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const y of this.watchers)y.instance.setVerboseLogging(I)}trace(I,y){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(I,y)})}warn(I){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(I)})}toMessage(I,y){return y?`[File Watcher (node.js)] ${I} (${this.requestToString(y.request)})`:`[File Watcher (node.js)] ${I}`}}e.NodeJSWatcher=v}),define(Ce[223],Ie([1,0,69,222]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends r.AbstractNonRecursiveWatcherClient{constructor(L,R,v){super(L,R,v),this.init()}createWatcher(L){return L.add(new d.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=P}),define(Ce[224],Ie([1,0,14,86,192,69]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends k.AbstractUniversalWatcherClient{constructor(v,l,I){super(v,l,I),this.init()}createWatcher(v){const l=v.add(new P.Client(r.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(l.onDidProcessExit(({code:I,signal:y})=>this.onError(`terminated by itself with code ${I}, signal: ${y} (ETERM)`))),d.ProxyChannel.toService((0,d.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(Ce[114],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...P){this._entries=new Map;for(const[k,L]of P)this.set(k,L)}set(P,k){const L=this._entries.get(P);return this._entries.set(P,k),L}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=r}),define(Ce[225],Ie([1,0,7,13,3,112,214,5,114,80]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class y extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class u{constructor(m=new v.ServiceCollection,p=!1,f,i=I){this._services=m,this._strict=p,this._parent=f,this._enableTracing=i,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=i?f?._globalGraph??new L.Graph(s=>s):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,P.dispose)(this._children),this._children.clear();for(const m of this._servicesToMaybeDispose)(0,P.isDisposable)(m)&&m.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(m,p){this._throwIfDisposed();const f=this,i=new class extends u{dispose(){f._children.delete(i),super.dispose()}}(m,this._strict,this,this._enableTracing);return this._children.add(i),p?.add(i),i}invokeFunction(m,...p){this._throwIfDisposed();const f=b.traceInvocation(this._enableTracing,m);let i=!1;try{return m({get:t=>{if(i)throw(0,d.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(t,f);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...p)}finally{i=!0,f.stop()}}createInstance(m,...p){this._throwIfDisposed();let f,i;return m instanceof k.SyncDescriptor?(f=b.traceCreation(this._enableTracing,m.ctor),i=this._createInstance(m.ctor,m.staticArguments.concat(p),f)):(f=b.traceCreation(this._enableTracing,m),i=this._createInstance(m,p,f)),f.stop(),i}_createInstance(m,p=[],f){const i=R._util.getServiceDependencies(m).sort((o,n)=>o.index-n.index),s=[];for(const o of i){const n=this._getOrCreateServiceInstance(o.id,f);n||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${o.id}.`,!1),s.push(n)}const t=i.length>0?i[0].index:p.length;if(p.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${p.length} static arguments`);const o=t-p.length;o>0?p=p.concat(new Array(o)):p=p.slice(0,t)}return Reflect.construct(m,p.concat(s))}_setCreatedServiceInstance(m,p){if(this._services.get(m)instanceof k.SyncDescriptor)this._services.set(m,p);else if(this._parent)this._parent._setCreatedServiceInstance(m,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const p=this._services.get(m);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):p}_getOrCreateServiceInstance(m,p){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const f=this._getServiceInstanceOrDescriptor(m);return f instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,f,p.branch(m,!0)):(p.branch(m,!1),f)}_safeCreateAndCacheServiceInstance(m,p,f){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,p,f)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,p,f){const i=new L.Graph(n=>n.id.toString());let s=0;const t=[{id:m,desc:p,_trace:f}],o=new Set;for(;t.length;){const n=t.pop();if(!o.has(String(n.id))){if(o.add(String(n.id)),i.lookupOrInsertNode(n),s++>1e3)throw new y(i);for(const h of R._util.getServiceDependencies(n.desc.ctor)){const c=this._getServiceInstanceOrDescriptor(h.id);if(c||this._throwIfStrict(`[createInstance] ${m} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(h.id)),c instanceof k.SyncDescriptor){const g={id:h.id,desc:c,_trace:n._trace.branch(h.id,!0)};i.insertEdge(n,g),t.push(g)}}}}for(;;){const n=i.roots();if(n.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:h}of n){if(this._getServiceInstanceOrDescriptor(h.id)instanceof k.SyncDescriptor){const g=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setCreatedServiceInstance(h.id,g)}i.removeNode(h)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,p,f=[],i,s){if(this._services.get(m)instanceof k.SyncDescriptor)return this._createServiceInstance(m,p,f,i,s,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,p,f,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(m,p,f=[],i,s,t){if(i){const o=new u(void 0,this._strict,this,this._enableTracing);o._globalGraphImplicitDependency=String(m);const n=new Map,h=new r.GlobalIdleValue(()=>{const c=o._createInstance(p,f,s);for(const[g,w]of n){const D=c[g];if(typeof D=="function")for(const _ of w)_.disposable=D.apply(c,_.listener)}return n.clear(),t.add(c),c});return new Proxy(Object.create(null),{get(c,g){if(!h.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let _=n.get(g);return _||(_=new l.LinkedList,n.set(g,_)),(A,E,S)=>{if(h.isInitialized)return h.value[g](A,E,S);{const F={listener:[A,E,S],disposable:void 0},N=_.push(F);return(0,P.toDisposable)(()=>{N(),F.disposable?.dispose()})}}}if(g in c)return c[g];const w=h.value;let D=w[g];return typeof D!="function"||(D=D.bind(w),c[g]=D),D},set(c,g,w){return h.value[g]=w,!0},getPrototypeOf(c){return p.prototype}})}else{const o=this._createInstance(p,f,s);return t.add(o),o}}_throwIfStrict(m,p){if(p&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=u;var T;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(T||(T={}));class b{static{this.all=new Set}static{this._None=new class extends b{constructor(){super(T.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,p){return m?new b(T.Invocation,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b._None}static traceCreation(m,p){return m?new b(T.Creation,p.name):b._None}static{this._totals=0}constructor(m,p){this.type=m,this.name=p,this._start=Date.now(),this._dep=[]}branch(m,p){const f=new b(T.Branch,m.toString());return this._dep.push([m,p,f]),f}stop(){const m=Date.now()-this._start;b._totals+=m;let p=!1;function f(s,t){const o=[],n=new Array(s+1).join("	");for(const[h,c,g]of t._dep)if(c&&g){p=!0,o.push(`${n}CREATES -> ${h}`);const w=f(s+1,g);w&&o.push(w)}else o.push(`${n}uses -> ${h}`);return o.join(`
`)}const i=[`${this.type===T.Creation?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(m>2||p)&&b.all.add(i.join(`
`))}}e.Trace=b}),define(Ce[11],Ie([1,0,8,52,4,60,3,28,10,22,17,2,35,5]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=a,e.log=p,e.getLogLevel=D,e.LogLevelToString=_,e.LogLevelToLocalizedString=C,e.parseLogLevel=A,r=$e(r),e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function b(){return new Date().toISOString()}function a(E){return(0,I.isNumber)(E)}var m;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(m||(e.LogLevel=m={})),e.DEFAULT_LOG_LEVEL=m.Info;function p(E,S,F){switch(S){case m.Trace:E.trace(F);break;case m.Debug:E.debug(F);break;case m.Info:E.info(F);break;case m.Warning:E.warn(F);break;case m.Error:E.error(F);break;case m.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function f(E,S=!1){let F="";for(let N=0;N<E.length;N++){let O=E[N];if(O instanceof Error&&(O=(0,d.toErrorMessage)(O,S)),typeof O=="object")try{O=JSON.stringify(O)}catch{}F+=(N>0?" ":"")+O}return F}class i extends L.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(S){this.level!==S&&(this.level=S,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(S){return this.level!==m.Off&&this.level<=S}}e.AbstractLogger=i;class s extends i{constructor(S){super(),this.logAlways=S}checkLogLevel(S){return this.logAlways||super.checkLogLevel(S)}trace(S,...F){this.checkLogLevel(m.Trace)&&this.log(m.Trace,f([S,...F],!0))}debug(S,...F){this.checkLogLevel(m.Debug)&&this.log(m.Debug,f([S,...F]))}info(S,...F){this.checkLogLevel(m.Info)&&this.log(m.Info,f([S,...F]))}warn(S,...F){this.checkLogLevel(m.Warning)&&this.log(m.Warning,f([S,...F]))}error(S,...F){if(this.checkLogLevel(m.Error))if(S instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=S.stack,this.log(m.Error,f(N))}else this.log(m.Error,f([S,...F]))}flush(){}}e.AbstractMessageLogger=s;class t extends i{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S),this.useColors=!v.isWindows}trace(S,...F){this.checkLogLevel(m.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...F):console.log(`[main ${b()}]`,S,...F))}debug(S,...F){this.checkLogLevel(m.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...F):console.log(`[main ${b()}]`,S,...F))}info(S,...F){this.checkLogLevel(m.Info)&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...F):console.log(`[main ${b()}]`,S,...F))}warn(S,...F){this.checkLogLevel(m.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,S,...F):console.warn(`[main ${b()}]`,S,...F))}error(S,...F){this.checkLogLevel(m.Error)&&(this.useColors?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,S,...F):console.error(`[main ${b()}]`,S,...F))}flush(){}}e.ConsoleMainLogger=t;class o extends i{constructor(S=e.DEFAULT_LOG_LEVEL,F=!0){super(),this.useColors=F,this.setLevel(S)}trace(S,...F){this.checkLogLevel(m.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",S,...F):console.log(S,...F))}debug(S,...F){this.checkLogLevel(m.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",S,...F):console.log(S,...F))}info(S,...F){this.checkLogLevel(m.Info)&&(this.useColors?console.log("%c INFO","color: #33f",S,...F):console.log(S,...F))}warn(S,...F){this.checkLogLevel(m.Warning)&&(this.useColors?console.log("%c WARN","color: #993",S,...F):console.log(S,...F))}error(S,...F){this.checkLogLevel(m.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",S,...F):console.error(S,...F))}flush(){}}e.ConsoleLogger=o;class n extends i{constructor(S,F=e.DEFAULT_LOG_LEVEL){super(),this.adapter=S,this.setLevel(F)}trace(S,...F){this.checkLogLevel(m.Trace)&&this.adapter.log(m.Trace,[this.extractMessage(S),...F])}debug(S,...F){this.checkLogLevel(m.Debug)&&this.adapter.log(m.Debug,[this.extractMessage(S),...F])}info(S,...F){this.checkLogLevel(m.Info)&&this.adapter.log(m.Info,[this.extractMessage(S),...F])}warn(S,...F){this.checkLogLevel(m.Warning)&&this.adapter.log(m.Warning,[this.extractMessage(S),...F])}error(S,...F){this.checkLogLevel(m.Error)&&this.adapter.log(m.Error,[this.extractMessage(S),...F])}extractMessage(S){return typeof S=="string"?S:(0,d.toErrorMessage)(S,this.checkLogLevel(m.Trace))}flush(){}}e.AdapterLogger=n;class h extends i{constructor(S){super(),this.loggers=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const F of this.loggers)F.setLevel(S);super.setLevel(S)}trace(S,...F){for(const N of this.loggers)N.trace(S,...F)}debug(S,...F){for(const N of this.loggers)N.debug(S,...F)}info(S,...F){for(const N of this.loggers)N.info(S,...F)}warn(S,...F){for(const N of this.loggers)N.warn(S,...F)}error(S,...F){for(const N of this.loggers)N.error(S,...F)}flush(){for(const S of this.loggers)S.flush()}dispose(){for(const S of this.loggers)S.dispose();super.dispose()}}e.MultiplexLogger=h;class c extends L.Disposable{constructor(S,F,N){if(super(),this.logLevel=S,this.logsHome=F,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new P.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,N)for(const O of N)this._loggers.set(O.resource,{logger:void 0,info:O})}getLoggerEntry(S){return(0,I.isString)(S)?[...this._loggers.values()].find(F=>F.info.id===S):this._loggers.get(S)}getLogger(S){return this.getLoggerEntry(S)?.logger}createLogger(S,F){const N=this.toResource(S),O=(0,I.isString)(S)?S:F?.id??(0,k.hash)(N.toString()).toString(16);let M=this._loggers.get(N)?.logger;const U=F?.logLevel==="always"?m.Trace:F?.logLevel;M||(M=this.doCreateLogger(N,U??this.getLogLevel(N)??this.logLevel,{...F,id:O}));const x={logger:M,info:{resource:N,id:O,logLevel:U,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(x.info),this._loggers.set(N,x),M}toResource(S){return(0,I.isString)(S)?(0,l.joinPath)(this.logsHome,`${S}.log`):S}setLogLevel(S,F){if(y.URI.isUri(S)){const N=S,O=F,M=this._loggers.get(N);M&&O!==M.info.logLevel&&(M.info.logLevel=O===this.logLevel?void 0:O,M.logger?.setLevel(O),this._loggers.set(M.info.resource,M),this._onDidChangeLogLevel.fire([N,O]))}else{this.logLevel=S;for(const[N,O]of this._loggers.entries())this._loggers.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(S,F){const N=this.getLoggerEntry(S);N&&F!==!N.info.hidden&&(N.info.hidden=!F,this._loggers.set(N.info.resource,N),this._onDidChangeVisibility.fire([N.info.resource,F]))}getLogLevel(S){let F;return S&&(F=this._loggers.get(S)?.info.logLevel),F??this.logLevel}registerLogger(S){const F=this._loggers.get(S.resource);F?F.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this._loggers.set(S.resource,{info:S,logger:void 0}),this._onDidChangeLoggers.fire({added:[S],removed:[]}))}deregisterLogger(S){const F=this._loggers.get(S);F&&(F.logger&&F.logger.dispose(),this._loggers.delete(S),this._onDidChangeLoggers.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const S of this._loggers.values())yield S.info}getRegisteredLogger(S){return this._loggers.get(S)?.info}dispose(){this._loggers.forEach(S=>S.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=c;class g{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(S){}getLevel(){return m.Info}trace(S,...F){}debug(S,...F){}info(S,...F){}warn(S,...F){}error(S,...F){}critical(S,...F){}dispose(){}flush(){}}e.NullLogger=g;class w extends g{}e.NullLogService=w;function D(E){if(E.verbose)return m.Trace;if(typeof E.logLevel=="string"){const S=A(E.logLevel.toLowerCase());if(S!==void 0)return S}return e.DEFAULT_LOG_LEVEL}function _(E){switch(E){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function C(E){switch(E){case m.Trace:return{original:"Trace",value:r.localize(11319,null)};case m.Debug:return{original:"Debug",value:r.localize(11320,null)};case m.Info:return{original:"Info",value:r.localize(11321,null)};case m.Warning:return{original:"Warning",value:r.localize(11322,null)};case m.Error:return{original:"Error",value:r.localize(11323,null)};case m.Off:return{original:"Off",value:r.localize(11324,null)}}}function A(E){switch(E){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.CONTEXT_LOG_LEVEL=new u.RawContextKey("logLevel",_(m.Info))}),define(Ce[226],Ie([1,0,18,7,13,4,31,3,16,69,11]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends R.Disposable{constructor(T,b){super(),this.logService=T,this.options=b,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new d.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new d.ThrottledDelayer(0))}watch(T,b){return b.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(T,b):this.watchNonRecursive(T,b)}watchUniversal(T,b){const a={path:this.toWatchPath(T),excludes:b.excludes,includes:b.includes,recursive:b.recursive,filter:b.filter,correlationId:b.correlationId},m=(0,r.insert)(this.universalWatchRequests,a);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(T=>(0,P.onUnexpectedError)(T))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(b=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})));const T=this.options?.watcher?.recursive?.usePolling;if(T===!0)for(const b of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(b)&&(b.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(T))for(const b of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(b)&&T.includes(b.path)&&(b.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(T,b){const a={path:this.toWatchPath(T),excludes:b.excludes,includes:b.includes,recursive:!1,filter:b.filter,correlationId:b.correlationId},m=(0,r.insert)(this.nonRecursiveWatchRequests,a);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(T=>(0,P.onUnexpectedError)(T))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(T=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(T)),T=>this.onWatcherLogMessage(T),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(T){T.type==="error"&&this._onDidWatchError.fire(T.message),this.logWatcherMessage(T)}logWatcherMessage(T){this.logService[T.type](T.message)}toFilePath(T){return(0,v.normalize)(T.fsPath)}toWatchPath(T){const b=this.toFilePath(T);return(0,L.removeTrailingPathSeparator)(b)}}e.AbstractDiskFileSystemProvider=y}),define(Ce[227],Ie([1,0,45,7,28,21,4,31,3,16,10,22,105,33,8,27,219,226,224,223]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends p.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(o,n){super(o,n),this.onDidChangeCapabilities=L.Event.None,this.resourceLocks=new P.ResourceMap(h=>y.extUriBiasedIgnorePathCase.getComparisonKey(h)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,I.isLinux&&(this._capabilities|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(o){try{const{stat:n,symbolicLink:h}=await T.SymlinkSupport.stat(this.toFilePath(o));return{type:this.toType(n,h),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:a.FilePermission.Locked}}catch(n){throw this.toFileSystemProviderError(n)}}async statIgnoreError(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const n=await T.Promises.readdir(this.toFilePath(o),{withFileTypes:!0}),h=[];return await Promise.all(n.map(async c=>{try{let g;c.isSymbolicLink()?g=(await this.stat((0,y.joinPath)(o,c.name))).type:g=this.toType(c),h.push([c.name,g])}catch(g){this.logService.trace(g)}})),h}catch(n){throw this.toFileSystemProviderError(n)}}toType(o,n){let h;return n?.dangling?h=a.FileType.Unknown:o.isFile()?h=a.FileType.File:o.isDirectory()?h=a.FileType.Directory:h=a.FileType.Unknown,n&&(h|=a.FileType.SymbolicLink),h}async createResourceLock(o){const n=this.toFilePath(o);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let h;for(;h=this.resourceLocks.get(o);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await h.wait();const c=new d.Barrier;return this.resourceLocks.set(o,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,v.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(o)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(o)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(o,n){let h;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(o)})`),h=await this.createResourceLock(o));const c=this.toFilePath(o);return await r.promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{h?.dispose()}}traceLock(o){s.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(o)}readFileStream(o,n,h){const c=(0,u.newWriteableStream)(g=>k.VSBuffer.concat(g.map(w=>k.VSBuffer.wrap(w))).buffer);return(0,m.readFileIntoStream)(this,o,c,g=>g.buffer,{...n,bufferSize:256*1024},h),c}async writeFile(o,n,h){return h?.atomic!==!1&&h?.atomic?.postfix&&await this.canWriteFileAtomic(o)?this.doWriteFileAtomic(o,(0,y.joinPath)((0,y.dirname)(o),`${(0,y.basename)(o)}${h.atomic.postfix}`),n,h):this.doWriteFile(o,n,h)}async canWriteFileAtomic(o){try{const n=this.toFilePath(o),{symbolicLink:h}=await T.SymlinkSupport.stat(n);if(h)return!1}catch{}return!0}async doWriteFileAtomic(o,n,h,c){const g=new v.DisposableStore;try{g.add(await this.createResourceLock(o)),g.add(await this.createResourceLock(n)),await this.doWriteFile(n,h,c,!0);try{await this.rename(n,o,{overwrite:!0})}catch(w){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{g.dispose()}}async doWriteFile(o,n,h,c){let g;try{const w=this.toFilePath(o);if(!h.create||!h.overwrite){if(await T.Promises.exists(w)){if(!h.overwrite)throw(0,a.createFileSystemProviderError)((0,b.localize)(11376,null),a.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,a.createFileSystemProviderError)((0,b.localize)(11377,null),a.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(o,{create:!0,unlock:h.unlock},c),await this.write(g,0,n,0,n.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(o,w)}finally{typeof g=="number"&&await this.close(g)}}static{this.canFlush=!0}static configureFlushOnWrite(o){s.canFlush=o}async open(o,n,h){const c=this.toFilePath(o);let g;(0,a.isFileOpenForWriteOptions)(n)&&!h&&(g=await this.createResourceLock(o));let w;try{if((0,a.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:_}=await T.SymlinkSupport.stat(c);_.mode&128||await r.promises.chmod(c,_.mode|128)}catch(_){_.code!=="ENOENT"&&this.logService.trace(_)}let D;if((0,a.isFileOpenForWriteOptions)(n)){if(I.isWindows)try{await r.promises.truncate(c,0),D="r+"}catch(_){_.code!=="ENOENT"&&this.logService.trace(_)}D||(D="w")}else D="r";w=await T.Promises.open(c,D)}catch(D){throw g?.dispose(),(0,a.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(o,D):this.toFileSystemProviderError(D)}if(this.mapHandleToPos.set(w,0),(0,a.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(w,o),g){const D=this.mapHandleToLock.get(w);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${c})`),this.mapHandleToLock.set(w,g),D&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${c})`),D.dispose())}return w}async close(o){const n=this.mapHandleToLock.get(o);try{if(this.mapHandleToPos.delete(o),this.writeHandles.delete(o)&&s.canFlush)try{await T.Promises.fdatasync(o)}catch(h){s.configureFlushOnWrite(!1),this.logService.error(h)}return await T.Promises.close(o)}catch(h){throw this.toFileSystemProviderError(h)}finally{n&&(this.mapHandleToLock.get(o)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.mapHandleToLock.delete(o)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),n.dispose())}}async read(o,n,h,c,g){const w=this.normalizePos(o,n);let D=null;try{D=(await T.Promises.read(o,h,c,g,w)).bytesRead}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(o,w,D)}return D}normalizePos(o,n){return n===this.mapHandleToPos.get(o)?null:n}updatePos(o,n,h){const c=this.mapHandleToPos.get(o);typeof c=="number"&&(typeof n=="number"||(typeof h=="number"?this.mapHandleToPos.set(o,c+h):this.mapHandleToPos.delete(o)))}async write(o,n,h,c,g){return(0,d.retry)(()=>this.doWrite(o,n,h,c,g),100,3)}async doWrite(o,n,h,c,g){const w=this.normalizePos(o,n);let D=null;try{D=(await T.Promises.write(o,h,c,g,w)).bytesWritten}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(o),_)}finally{this.updatePos(o,w,D)}return D}async mkdir(o){try{await r.promises.mkdir(this.toFilePath(o))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(o,n){try{const h=this.toFilePath(o);if(n.recursive){let c;n?.atomic!==!1&&n.atomic.postfix&&(c=(0,l.join)((0,l.dirname)(h),`${(0,l.basename)(h)}${n.atomic.postfix}`)),await T.Promises.rm(h,T.RimRafMode.MOVE,c)}else try{await r.promises.unlink(h)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let g=!1;try{const{stat:w,symbolicLink:D}=await T.SymlinkSupport.stat(h);g=w.isDirectory()&&!D}catch{}if(g)await r.promises.rmdir(h);else throw c}else throw c}}catch(h){throw this.toFileSystemProviderError(h)}}async rename(o,n,h){const c=this.toFilePath(o),g=this.toFilePath(n);if(c!==g)try{await this.validateMoveCopy(o,n,"move",h.overwrite),await T.Promises.rename(c,g)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,b.localize)(11378,null,(0,l.basename)(c),(0,l.basename)((0,l.dirname)(g)),w.toString()))),this.toFileSystemProviderError(w)}}async copy(o,n,h){const c=this.toFilePath(o),g=this.toFilePath(n);if(c!==g)try{await this.validateMoveCopy(o,n,"copy",h.overwrite),await T.Promises.copy(c,g,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,b.localize)(11379,null,(0,l.basename)(c),(0,l.basename)((0,l.dirname)(g)),w.toString()))),this.toFileSystemProviderError(w)}}async validateMoveCopy(o,n,h,c){const g=this.toFilePath(o),w=this.toFilePath(n);let D=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(D=(0,R.isEqual)(g,w,!0)),D){if(h==="copy")throw(0,a.createFileSystemProviderError)((0,b.localize)(11380,null),a.FileSystemProviderErrorCode.FileExists);if(h==="move")return}const C=await this.statIgnoreError(o);if(!C)throw(0,a.createFileSystemProviderError)((0,b.localize)(11381,null),a.FileSystemProviderErrorCode.FileNotFound);const A=await this.statIgnoreError(n);if(A){if(!c)throw(0,a.createFileSystemProviderError)((0,b.localize)(11382,null),a.FileSystemProviderErrorCode.FileExists);C.type&a.FileType.File&&A.type&a.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,n){return this.doCloneFile(o,n,!1)}async doCloneFile(o,n,h){const c=this.toFilePath(o),g=this.toFilePath(n),w=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.isEqual)(c,g,!w))return;const D=new v.DisposableStore;try{D.add(await this.createResourceLock(o)),D.add(await this.createResourceLock(n)),h&&await r.promises.mkdir((0,l.dirname)(g),{recursive:!0}),await r.promises.copyFile(c,g)}catch(_){if(_.code==="ENOENT"&&!h)return this.doCloneFile(o,n,!0);throw this.toFileSystemProviderError(_)}finally{D.dispose()}}createUniversalWatcher(o,n,h){return new f.UniversalWatcherClient(c=>o(c),c=>n(c),h)}createNonRecursiveWatcher(o,n,h){return new i.NodeJSWatcherClient(c=>o(c),c=>n(c),h)}toFileSystemProviderError(o){if(o instanceof a.FileSystemProviderError)return o;let n=o,h;switch(o.code){case"ENOENT":h=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":h=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":h=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":h=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":h=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,h=a.FileSystemProviderErrorCode.Unknown;break;default:h=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(n,h)}async toFileSystemProviderWriteError(o,n){let h=this.toFileSystemProviderError(n);if(o&&h.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await T.SymlinkSupport.stat(this.toFilePath(o));c.mode&128||(h=(0,a.createFileSystemProviderError)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return h}}e.DiskFileSystemProvider=s}),define(Ce[228],Ie([1,0,3,11]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class P extends r.Disposable{constructor(L,R=[]){super(),this.logger=new d.MultiplexLogger([L,...R]),this._register(L.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(L){this.logger.setLevel(L)}getLevel(){return this.logger.getLevel()}trace(L,...R){this.logger.trace(L,...R)}debug(L,...R){this.logger.debug(L,...R)}info(L,...R){this.logger.info(L,...R)}warn(L,...R){this.logger.warn(L,...R)}error(L,...R){this.logger.error(L,...R)}flush(){this.logger.flush()}}e.LogService=P}),define(Ce[229],Ie([1,0,27,11]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(P||(P={}));async function k(l,I,y,u,T){try{const b=await new Promise((m,p)=>{pe(["@vscode/spdlog"],m,p)}).then($e);b.setFlushOn(P.Trace);const a=await b.createAsyncRotatingLogger(l,I,y,u);return T?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(b){console.error(b)}return null}function L(l,I,y){switch(I){case d.LogLevel.Trace:l.trace(y);break;case d.LogLevel.Debug:l.debug(y);break;case d.LogLevel.Info:l.info(y);break;case d.LogLevel.Warning:l.warn(y);break;case d.LogLevel.Error:l.error(y);break;case d.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function R(l,I){switch(I){case d.LogLevel.Trace:l.setLevel(P.Trace);break;case d.LogLevel.Debug:l.setLevel(P.Debug);break;case d.LogLevel.Info:l.setLevel(P.Info);break;case d.LogLevel.Warning:l.setLevel(P.Warning);break;case d.LogLevel.Error:l.setLevel(P.Error);break;case d.LogLevel.Off:l.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class v extends d.AbstractMessageLogger{constructor(I,y,u,T,b){super(),this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(I,y,u,T),this._register(this.onDidChangeLogLevel(a=>{this._logger&&R(this._logger,a)}))}async _createSpdLogLogger(I,y,u,T){const b=u?6:1,a=30/b*r.ByteSize.MB,m=await k(I,y,a,b,T);if(m){this._logger=m,R(this._logger,this.getLevel());for(const{level:p,message:f}of this.buffer)L(this._logger,p,f);this.buffer=[]}}log(I,y){this._logger?L(this._logger,I,y):this.getLevel()<=I&&this.buffer.push({level:I,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=v});var Wt=this&&this.__importDefault||function(pe){return pe&&pe.__esModule?pe:{default:pe}};define(Ce[145],Ie([1,0,43,8,5]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=Wt(r);var k;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(k||(e.MarkerTag=k={}));var L;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(v){function l(b,a){return a-b}v.compare=l;const I=Object.create(null);I[v.Error]=(0,d.localize)(11316,null),I[v.Warning]=(0,d.localize)(11317,null),I[v.Info]=(0,d.localize)(11318,null);function y(b){return I[b]||""}v.toString=y;function u(b){switch(b){case r.default.Error:return v.Error;case r.default.Warning:return v.Warning;case r.default.Info:return v.Info;case r.default.Ignore:return v.Hint}}v.fromSeverity=u;function T(b){switch(b){case v.Error:return r.default.Error;case v.Warning:return r.default.Warning;case v.Info:return r.default.Info;case v.Hint:return r.default.Ignore}}v.toSeverity=T}(L||(e.MarkerSeverity=L={}));var R;(function(v){const l="";function I(u){return y(u,!0)}v.makeKey=I;function y(u,T){const b=[l];return u.source?b.push(u.source.replace("\xA6","\\\xA6")):b.push(l),u.code?typeof u.code=="string"?b.push(u.code.replace("\xA6","\\\xA6")):b.push(u.code.value.replace("\xA6","\\\xA6")):b.push(l),u.severity!==void 0&&u.severity!==null?b.push(L.toString(u.severity)):b.push(l),u.message&&T?b.push(u.message.replace("\xA6","\\\xA6")):b.push(l),u.startLineNumber!==void 0&&u.startLineNumber!==null?b.push(u.startLineNumber.toString()):b.push(l),u.startColumn!==void 0&&u.startColumn!==null?b.push(u.startColumn.toString()):b.push(l),u.endLineNumber!==void 0&&u.endLineNumber!==null?b.push(u.endLineNumber.toString()):b.push(l),u.endColumn!==void 0&&u.endColumn!==null?b.push(u.endColumn.toString()):b.push(l),b.push(l),b.join("\xA6")}v.makeKeyOptionalMessage=y})(R||(e.IMarkerData=R={})),e.IMarkerService=(0,P.createDecorator)("markerService")});var Wt=this&&this.__importDefault||function(pe){return pe&&pe.__esModule?pe:{default:pe}};define(Ce[230],Ie([1,0,4,43,5]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=R,d=Wt(d),e.Severity=d.default,e.INotificationService=(0,P.createDecorator)("notificationService");var k;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(k||(e.NotificationPriority=k={}));var L;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function R(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var v;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(v||(e.NotificationsFilter=v={}));class l{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.NoOpNotification=l;class I{infinite(){}done(){}total(u){}worked(u){}}e.NoOpProgress=I}),define(Ce[231],Ie([1,0,55]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const k=P.context.configuration();if(k)d=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){d=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:k,searchUrl:L,itemUrl:R,controlUrl:v}=d.extensionsGallery||{};Object.assign(d,{extensionsGallery:{serviceUrl:r.env.VSCODE_GALLERY_SERVICE_URL||k,searchUrl:r.env.VSCODE_GALLERY_SEARCH_URL||L,itemUrl:r.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:r.env.VSCODE_GALLERY_CONTROL_URL||v}});try{const l=(...y)=>y.reduce((u,T)=>(Object.keys(T).forEach(b=>{Array.isArray(u[b])&&Array.isArray(T[b])?u[b]=T[b]:typeof u[b]=="object"&&typeof T[b]=="object"?u[b]=l(u[b],T[b]):u[b]=T[b]}),u),{}),I=globalThis._VSCODE_USER_PRODUCT_JSON||{};d=l(d,I)}catch{}if(r.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:l.version,release:l.release})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(Ce[115],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(pe,e){return function(r,d){e(r,d,pe)}};define(Ce[89],Ie([1,0,7,20,3,5]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,k.createDecorator)("progressService");var L;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(u){this.callback=u}report(u){this._value=u,this.callback(this._value)}}e.Progress=R;class v{get value(){return this._value}constructor(u){this.callback=u}report(u){this._asyncQueue?this._asyncQueue.push(u):this._asyncQueue=[u],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const u=this._asyncQueue.shift();this._value=u,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const u=this._drainListener;this._drainListener=void 0,u?.()}}drain(){return this._processingAsyncQueue?new Promise(u=>{const T=this._drainListener;this._drainListener=()=>{T?.(),u()}}):Promise.resolve()}}e.AsyncProgress=v;let l=class extends P.Disposable{constructor(u,T){super(),this.deferred=new r.DeferredPromise,T.withProgress(u,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,P.toDisposable)(()=>this.deferred.complete()))}report(u){this.reporter?this.reporter.report(u):this.lastStep=u}};e.UnmanagedProgress=l,e.UnmanagedProgress=l=Xe([He(1,e.IProgressService)],l);class I extends P.Disposable{constructor(u){super(),this.progressIndicator=u,this.currentOperationId=0,this.currentOperationDisposables=this._register(new P.DisposableStore)}start(u){this.stop();const T=++this.currentOperationId,b=new d.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{T===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},u),this.currentOperationDisposables.add((0,P.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,P.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,P.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:T,token:b.token,stop:()=>this.doStop(T),isCurrent:()=>this.currentOperationId===T}}stop(){this.doStop(this.currentOperationId)}doStop(u){this.currentOperationId===u&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,k.createDecorator)("editorProgressService")}),define(Ce[36],Ie([1,0,65,17]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,r=$e(r),d=$e(d);class P{constructor(){this.data=new Map}add(L,R){r.ok(d.isString(L)),r.ok(d.isObject(R)),r.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,R)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new P}),define(Ce[116],Ie([1,0,4,177,36]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,P=$e(P),e.Extensions={JSONContribution:"base.contributions.json"};function k(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class L{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,I){this.schemasById[k(l)]=I,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(l){const I=this.schemasById[l];return I?(0,d.getCompressedContent)(I):void 0}hasSchemaContent(l){return!!this.schemasById[l]}}const R=new L;P.Registry.add(e.Extensions.JSONContribution,R)}),define(Ce[70],Ie([1,0,18,4,17,8,46,116,36]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=a,e.keyFromOverrideIdentifiers=m,e.getDefaultValue=p,e.validateProperty=i,e.getScopes=s,e.getAllConfigurationProperties=t,e.parseScope=o,P=$e(P),k=$e(k);var l;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=v.Registry.as(R.Extensions.JSONContribution);class u{constructor(){this.registeredConfigurationDefaults=[],this.overrideIdentifiers=new Set,this._onDidSchemaChange=new d.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new d.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(11612,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(h,c=!0){this.registerConfigurations([h],c)}registerConfigurations(h,c=!0){const g=new Set;this.doRegisterConfigurations(h,c,g),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g})}deregisterConfigurations(h){const c=new Set;this.doDeregisterConfigurations(h,c),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:h,remove:c}){const g=new Set;this.doDeregisterConfigurations(c,g),this.doRegisterConfigurations(h,!1,g),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g})}registerDefaultConfigurations(h){const c=new Set;this.doRegisterDefaultConfigurations(h,c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}doRegisterDefaultConfigurations(h,c){this.registeredConfigurationDefaults.push(...h);const g=[];for(const{overrides:w,source:D}of h)for(const _ in w){c.add(_);const C=this.configurationDefaultsOverrides.get(_)??this.configurationDefaultsOverrides.set(_,{configurationDefaultOverrides:[]}).get(_),A=w[_];if(C.configurationDefaultOverrides.push({value:A,source:D}),e.OVERRIDE_PROPERTY_REGEX.test(_)){const E=this.mergeDefaultConfigurationsForOverrideIdentifier(_,A,D,C.configurationDefaultOverrideValue);if(!E)continue;C.configurationDefaultOverrideValue=E,this.updateDefaultOverrideProperty(_,E,D),g.push(...a(_))}else{const E=this.mergeDefaultConfigurationsForConfigurationProperty(_,A,D,C.configurationDefaultOverrideValue);if(!E)continue;C.configurationDefaultOverrideValue=E;const S=this.configurationProperties[_];S&&(this.updatePropertyDefaultValue(_,S),this.updateSchema(_,S))}}this.doRegisterOverrideIdentifiers(g)}deregisterDefaultConfigurations(h){const c=new Set;this.doDeregisterDefaultConfigurations(h,c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(h,c){for(const g of h){const w=this.registeredConfigurationDefaults.indexOf(g);w!==-1&&this.registeredConfigurationDefaults.splice(w,1)}for(const{overrides:g,source:w}of h)for(const D in g){const _=this.configurationDefaultsOverrides.get(D);if(!_)continue;const C=_.configurationDefaultOverrides.findIndex(A=>w?A.source?.id===w.id:A.value===g[D]);if(C!==-1){if(_.configurationDefaultOverrides.splice(C,1),_.configurationDefaultOverrides.length===0&&this.configurationDefaultsOverrides.delete(D),e.OVERRIDE_PROPERTY_REGEX.test(D)){let A;for(const E of _.configurationDefaultOverrides)A=this.mergeDefaultConfigurationsForOverrideIdentifier(D,E.value,E.source,A);A&&!P.isEmptyObject(A.value)?(_.configurationDefaultOverrideValue=A,this.updateDefaultOverrideProperty(D,A,w)):(this.configurationDefaultsOverrides.delete(D),delete this.configurationProperties[D],delete this.defaultLanguageConfigurationOverridesNode.properties[D])}else{let A;for(const S of _.configurationDefaultOverrides)A=this.mergeDefaultConfigurationsForConfigurationProperty(D,S.value,S.source,A);_.configurationDefaultOverrideValue=A;const E=this.configurationProperties[D];E&&(this.updatePropertyDefaultValue(D,E),this.updateSchema(D,E))}c.add(D)}}this.updateOverridePropertyPatternKey()}updateDefaultOverrideProperty(h,c,g){const w={type:"object",default:c.value,description:k.localize(11613,null,(0,L.getLanguageTagSettingPlainKey)(h)),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c.value,source:g,defaultValueSource:g};this.configurationProperties[h]=w,this.defaultLanguageConfigurationOverridesNode.properties[h]=w}mergeDefaultConfigurationsForOverrideIdentifier(h,c,g,w){const D=w?.value||{},_=w?.source??new Map;if(!(_ instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const C of Object.keys(c)){const A=c[C];if(P.isObject(A)&&(P.isUndefined(D[C])||P.isObject(D[C]))){if(D[C]={...D[C]??{},...A},g)for(const S in A)_.set(`${C}.${S}`,g)}else D[C]=A,g?_.set(C,g):_.delete(C)}return{value:D,source:_}}mergeDefaultConfigurationsForConfigurationProperty(h,c,g,w){const D=this.configurationProperties[h],_=w?.value??D?.defaultDefaultValue;let C=g;if(P.isObject(c)&&(D!==void 0&&D.type==="object"||D===void 0&&(P.isUndefined(_)||P.isObject(_)))){if(C=w?.source??new Map,!(C instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const E in c)g&&C.set(`${h}.${E}`,g);c={...P.isObject(_)?_:{},...c}}return{value:c,source:C}}deltaConfiguration(h){let c=!1;const g=new Set;h.removedDefaults&&(this.doDeregisterDefaultConfigurations(h.removedDefaults,g),c=!0),h.addedDefaults&&(this.doRegisterDefaultConfigurations(h.addedDefaults,g),c=!0),h.removedConfigurations&&this.doDeregisterConfigurations(h.removedConfigurations,g),h.addedConfigurations&&this.doRegisterConfigurations(h.addedConfigurations,!1,g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:g,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){this.doRegisterOverrideIdentifiers(h),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(h){for(const c of h)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,c,g){h.forEach(w=>{this.validateAndRegisterProperties(w,c,w.extensionInfo,w.restrictedProperties,void 0,g),this.configurationContributors.push(w),this.registerJSONConfiguration(w)})}doDeregisterConfigurations(h,c){const g=w=>{if(w.properties)for(const D in w.properties){c.add(D);const _=this.configurationProperties[D];_?.policy?.name&&this.policyConfigurations.delete(_.policy.name),delete this.configurationProperties[D],this.removeFromSchema(D,w.properties[D])}w.allOf?.forEach(D=>g(D))};for(const w of h){g(w);const D=this.configurationContributors.indexOf(w);D!==-1&&this.configurationContributors.splice(D,1)}}validateAndRegisterProperties(h,c=!0,g,w,D=I.WINDOW,_){D=P.isUndefinedOrNull(h.scope)?D:h.scope;const C=h.properties;if(C)for(const E in C){const S=C[E];if(c&&i(E,S)){delete C[E];continue}if(S.source=g,S.defaultDefaultValue=C[E].default,this.updatePropertyDefaultValue(E,S),e.OVERRIDE_PROPERTY_REGEX.test(E)?S.scope=void 0:(S.scope=P.isUndefinedOrNull(S.scope)?D:S.scope,S.restricted=P.isUndefinedOrNull(S.restricted)?!!w?.includes(E):S.restricted),C[E].hasOwnProperty("included")&&!C[E].included){this.excludedConfigurationProperties[E]=C[E],delete C[E];continue}else this.configurationProperties[E]=C[E],C[E].policy?.name&&this.policyConfigurations.set(C[E].policy.name,E);!C[E].deprecationMessage&&C[E].markdownDeprecationMessage&&(C[E].deprecationMessage=C[E].markdownDeprecationMessage),_.add(E)}const A=h.allOf;if(A)for(const E of A)this.validateAndRegisterProperties(E,c,g,w,D,_)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getRegisteredDefaultConfigurations(){return[...this.registeredConfigurationDefaults]}getConfigurationDefaultsOverrides(){const h=new Map;for(const[c,g]of this.configurationDefaultsOverrides)g.configurationDefaultOverrideValue&&h.set(c,g.configurationDefaultOverrideValue);return h}registerJSONConfiguration(h){const c=g=>{const w=g.properties;if(w)for(const _ in w)this.updateSchema(_,w[_]);g.allOf?.forEach(c)};c(h)}updateSchema(h,c){switch(e.allSettings.properties[h]=c,c.scope){case I.APPLICATION:e.applicationSettings.properties[h]=c;break;case I.MACHINE:e.machineSettings.properties[h]=c;break;case I.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[h]=c;break;case I.WINDOW:e.windowSettings.properties[h]=c;break;case I.RESOURCE:e.resourceSettings.properties[h]=c;break;case I.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[h]=c,this.resourceLanguageSettingsSchema.properties[h]=c;break}}removeFromSchema(h,c){switch(delete e.allSettings.properties[h],c.scope){case I.APPLICATION:delete e.applicationSettings.properties[h];break;case I.MACHINE:delete e.machineSettings.properties[h];break;case I.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[h];break;case I.WINDOW:delete e.windowSettings.properties[h];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[h],delete this.resourceLanguageSettingsSchema.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const c=`[${h}]`,g={type:"object",description:k.localize(11614,null),errorMessage:k.localize(11615,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,g),e.allSettings.properties[c]=g,e.applicationSettings.properties[c]=g,e.machineSettings.properties[c]=g,e.machineOverridableSettings.properties[c]=g,e.windowSettings.properties[c]=g,e.resourceSettings.properties[c]=g}}registerOverridePropertyPatternKey(){const h={type:"object",description:k.localize(11616,null),errorMessage:k.localize(11617,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=h,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,c){const g=this.configurationDefaultsOverrides.get(h)?.configurationDefaultOverrideValue;let w,D;g&&(!c.disallowConfigurationDefault||!g.source)&&(w=g.value,D=g.source),P.isUndefined(w)&&(w=c.defaultDefaultValue,D=void 0),P.isUndefined(w)&&(w=p(c.type)),c.default=w,c.defaultValueSource=D}}const T="\\[([^\\]]+)\\]",b=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(n){const h=[];if(e.OVERRIDE_PROPERTY_REGEX.test(n)){let c=b.exec(n);for(;c?.length;){const g=c[1].trim();g&&h.push(g),c=b.exec(n)}}return(0,r.distinct)(h)}function m(n){return n.reduce((h,c)=>`${h}[${c}]`,"")}function p(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new u;v.Registry.add(e.Extensions.Configuration,f);function i(n,h){return n.trim()?e.OVERRIDE_PROPERTY_REGEX.test(n)?k.localize(11619,null,n):f.getConfigurationProperties()[n]!==void 0?k.localize(11620,null,n):h.policy?.name&&f.getPolicyConfigurations().get(h.policy?.name)!==void 0?k.localize(11621,null,n,h.policy?.name,f.getPolicyConfigurations().get(h.policy?.name)):null:k.localize(11618,null)}function s(){const n=[],h=f.getConfigurationProperties();for(const c of Object.keys(h))n.push([c,h[c].scope]);return n.push(["launch",I.RESOURCE]),n.push(["task",I.RESOURCE]),n}function t(n){const h={};for(const c of n){const g=c.properties;if(P.isObject(g))for(const w in g)h[w]=g[w];c.allOf&&Object.assign(h,t(c.allOf))}return h}function o(n){switch(n){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Ce[232],Ie([1,0,18,4,176,3,28,24,17,2,46,70,27,36]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=s,r=$e(r),P=$e(P),R=$e(R),v=$e(v);function b(h){return Object.isFrozen(h)?h:R.deepFreeze(h)}class a{static createEmptyModel(c){return new a({},[],[],void 0,c)}constructor(c,g,w,D,_){this._contents=c,this._keys=g,this._overrides=w,this.raw=D,this.logService=_,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const c=this.raw.map(g=>{if(g instanceof a)return g;const w=new m("",this.logService);return w.parseRaw(g),w.configurationModel});this._rawConfiguration=c.reduce((g,w)=>w===g?w:g.merge(w),c[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(c){return c?(0,I.getConfigurationValue)(this.contents,c):this.contents}inspect(c,g){const w=this;return{get value(){return b(w.rawConfiguration.getValue(c))},get override(){return g?b(w.rawConfiguration.getOverrideValue(c,g)):void 0},get merged(){return b(g?w.rawConfiguration.override(g).getValue(c):w.rawConfiguration.getValue(c))},get overrides(){const D=[];for(const{contents:_,identifiers:C,keys:A}of w.rawConfiguration.overrides){const E=new a(_,A,[],void 0,w.logService).getValue(c);E!==void 0&&D.push({identifiers:C,value:E})}return D.length?b(D):void 0}}}getOverrideValue(c,g){const w=this.getContentsForOverrideIdentifer(g);return w?c?(0,I.getConfigurationValue)(w,c):w:void 0}getKeysForOverrideIdentifier(c){const g=[];for(const w of this.overrides)w.identifiers.includes(c)&&g.push(...w.keys);return r.distinct(g)}getAllOverrideIdentifiers(){const c=[];for(const g of this.overrides)c.push(...g.identifiers);return r.distinct(c)}override(c){let g=this.overrideConfigurations.get(c);return g||(g=this.createOverrideConfigurationModel(c),this.overrideConfigurations.set(c,g)),g}merge(...c){const g=R.deepClone(this.contents),w=R.deepClone(this.overrides),D=[...this.keys],_=this.raw?.length?[...this.raw]:[this];for(const C of c)if(_.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(g,C.contents);for(const A of C.overrides){const[E]=w.filter(S=>r.equals(S.identifiers,A.identifiers));E?(this.mergeContents(E.contents,A.contents),E.keys.push(...A.keys),E.keys=r.distinct(E.keys)):w.push(R.deepClone(A))}for(const A of C.keys)D.indexOf(A)===-1&&D.push(A)}return new a(g,D,w,_.every(C=>C instanceof a)?void 0:_,this.logService)}createOverrideConfigurationModel(c){const g=this.getContentsForOverrideIdentifer(c);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const w={};for(const D of r.distinct([...Object.keys(this.contents),...Object.keys(g)])){let _=this.contents[D];const C=g[D];C&&(typeof _=="object"&&typeof C=="object"?(_=R.deepClone(_),this.mergeContents(_,C)):_=C),w[D]=_}return new a(w,this.keys,this.overrides,void 0,this.logService)}mergeContents(c,g){for(const w of Object.keys(g)){if(w in c&&v.isObject(c[w])&&v.isObject(g[w])){this.mergeContents(c[w],g[w]);continue}c[w]=R.deepClone(g[w])}}getContentsForOverrideIdentifer(c){let g=null,w=null;const D=_=>{_&&(w?this.mergeContents(w,_):w=R.deepClone(_))};for(const _ of this.overrides)_.identifiers.length===1&&_.identifiers[0]===c?g=_.contents:_.identifiers.includes(c)&&D(_.contents);return D(g),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,g){this.updateValue(c,g,!0)}setValue(c,g){this.updateValue(c,g,!1)}removeValue(c){const g=this.keys.indexOf(c);g!==-1&&(this.keys.splice(g,1),(0,I.removeFromValueTree)(this.contents,c),y.OVERRIDE_PROPERTY_REGEX.test(c)&&this.overrides.splice(this.overrides.findIndex(w=>r.equals(w.identifiers,(0,y.overrideIdentifiersFromKey)(c))),1))}updateValue(c,g,w){if((0,I.addToValueTree)(this.contents,c,g,D=>this.logService.error(D)),w=w||this.keys.indexOf(c)===-1,w&&this.keys.push(c),y.OVERRIDE_PROPERTY_REGEX.test(c)){const D=(0,y.overrideIdentifiersFromKey)(c),_={identifiers:D,keys:Object.keys(this.contents[c]),contents:(0,I.toValuesTree)(this.contents[c],A=>this.logService.error(A))},C=this.overrides.findIndex(A=>r.equals(A.identifiers,D));C!==-1?this.overrides[C]=_:this.overrides.push(_)}}}e.ConfigurationModel=a;class m{constructor(c,g){this._name=c,this.logService=g,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||a.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(c,g){if(!v.isUndefinedOrNull(c)){const w=this.doParseContent(c);this.parseRaw(w,g)}}reparse(c){this._raw&&this.parseRaw(this._raw,c)}parseRaw(c,g){this._raw=c;const{contents:w,keys:D,overrides:_,restricted:C,hasExcludedProperties:A}=this.doParseRaw(c,g);this._configurationModel=new a(w,D,_,A?[c]:void 0,this.logService),this._restrictedConfigurations=C||[]}doParseContent(c){let g={},w=null,D=[];const _=[],C=[];function A(S){Array.isArray(D)?D.push(S):w!==null&&(D[w]=S)}const E={onObjectBegin:()=>{const S={};A(S),_.push(D),D=S,w=null},onObjectProperty:S=>{w=S},onObjectEnd:()=>{D=_.pop()},onArrayBegin:()=>{const S=[];A(S),_.push(D),D=S,w=null},onArrayEnd:()=>{D=_.pop()},onLiteralValue:A,onError:(S,F,N)=>{C.push({error:S,offset:F,length:N})}};if(c)try{P.visit(c,E),g=D[0]||{}}catch(S){this.logService.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return g}doParseRaw(c,g){const w=T.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),D=this.filter(c,w,!0,g);c=D.raw;const _=(0,I.toValuesTree)(c,E=>this.logService.error(`Conflict in settings file ${this._name}: ${E}`)),C=Object.keys(c),A=this.toOverrides(c,E=>this.logService.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:_,keys:C,overrides:A,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}filter(c,g,w,D){let _=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:_};const C={},A=[];for(const E in c)if(y.OVERRIDE_PROPERTY_REGEX.test(E)&&w){const S=this.filter(c[E],g,!1,D);C[E]=S.raw,_=_||S.hasExcludedProperties,A.push(...S.restricted)}else{const S=g[E],F=S?typeof S.scope<"u"?S.scope:y.ConfigurationScope.WINDOW:void 0;S?.restricted&&A.push(E),!D.exclude?.includes(E)&&(D.include?.includes(E)||(F===void 0||D.scopes===void 0||D.scopes.includes(F))&&!(D.skipRestricted&&S?.restricted))?C[E]=c[E]:_=!0}return{raw:C,restricted:A,hasExcludedProperties:_}}toOverrides(c,g){const w=[];for(const D of Object.keys(c))if(y.OVERRIDE_PROPERTY_REGEX.test(D)){const _={};for(const C in c[D])_[C]=c[D][C];w.push({identifiers:(0,y.overrideIdentifiersFromKey)(D),keys:Object.keys(_),contents:(0,I.toValuesTree)(_,g)})}return w}}e.ConfigurationModelParser=m;class p extends k.Disposable{constructor(c,g,w,D,_){super(),this.userSettingsResource=c,this.parseOptions=g,this.fileService=D,this.logService=_,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),_),this._register(this.fileService.watch(w.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.any(d.Event.filter(this.fileService.onDidFilesChange,C=>C.contains(this.userSettingsResource)),d.Event.filter(this.fileService.onDidRunOperation,C=>(C.isOperation(u.FileOperation.CREATE)||C.isOperation(u.FileOperation.COPY)||C.isOperation(u.FileOperation.DELETE)||C.isOperation(u.FileOperation.WRITE))&&w.isEqual(C.resource,c)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const c=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(c.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return a.createEmptyModel(this.logService)}}reparse(c){return c&&(this.parseOptions=c),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class f{constructor(c,g,w,D,_,C,A,E,S,F,N,O,M){this.key=c,this.overrides=g,this._value=w,this.overrideIdentifiers=D,this.defaultConfiguration=_,this.policyConfiguration=C,this.applicationConfiguration=A,this.userConfiguration=E,this.localUserConfiguration=S,this.remoteUserConfiguration=F,this.workspaceConfiguration=N,this.folderConfigurationModel=O,this.memoryConfigurationModel=M}get value(){return b(this._value)}toInspectValue(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class i{constructor(c,g,w,D,_,C,A,E,S,F){this._defaultConfiguration=c,this._policyConfiguration=g,this._applicationConfiguration=w,this._localUserConfiguration=D,this._remoteUserConfiguration=_,this._workspaceConfiguration=C,this._folderConfigurations=A,this._memoryConfiguration=E,this._memoryConfigurationByResource=S,this.logService=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(c,g,w){return this.getConsolidatedConfigurationModel(c,g,w).getValue(c)}updateValue(c,g,w={}){let D;w.resource?(D=this._memoryConfigurationByResource.get(w.resource),D||(D=a.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(w.resource,D))):D=this._memoryConfiguration,g===void 0?D.removeValue(c):D.setValue(c,g),w.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(c,g,w){const D=this.getConsolidatedConfigurationModel(c,g,w),_=this.getFolderConfigurationModelForResource(g.resource,w),C=g.resource?this._memoryConfigurationByResource.get(g.resource)||this._memoryConfiguration:this._memoryConfiguration,A=new Set;for(const E of D.overrides)for(const S of E.identifiers)D.getOverrideValue(c,S)!==void 0&&A.add(S);return new f(c,g,D.getValue(c),A.size?[...A]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this._workspaceConfiguration:void 0,_||void 0,C)}keys(c){const g=this.getFolderConfigurationModelForResource(void 0,c);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(c){this._defaultConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(c){this._policyConfiguration=c}updateApplicationConfiguration(c){this._applicationConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(c){this._localUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(c){this._remoteUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(c){this._workspaceConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(c,g){this._folderConfigurations.set(c,g),this._foldersConsolidatedConfigurations.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this._foldersConsolidatedConfigurations.delete(c)}compareAndUpdateDefaultConfiguration(c,g){const w=[];if(!g){const{added:D,updated:_,removed:C}=o(this._defaultConfiguration,c);g=[...D,..._,...C]}for(const D of g)for(const _ of(0,y.overrideIdentifiersFromKey)(D)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(_),A=c.getKeysForOverrideIdentifier(_),E=[...A.filter(S=>C.indexOf(S)===-1),...C.filter(S=>A.indexOf(S)===-1),...C.filter(S=>!R.equals(this._defaultConfiguration.override(_).getValue(S),c.override(_).getValue(S)))];w.push([_,E])}return this.updateDefaultConfiguration(c),{keys:g,overrides:w}}compareAndUpdatePolicyConfiguration(c){const{added:g,updated:w,removed:D}=o(this._policyConfiguration,c),_=[...g,...w,...D];return _.length&&this.updatePolicyConfiguration(c),{keys:_,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:g,updated:w,removed:D,overrides:_}=o(this.applicationConfiguration,c),C=[...g,...w,...D];return C.length&&this.updateApplicationConfiguration(c),{keys:C,overrides:_}}compareAndUpdateLocalUserConfiguration(c){const{added:g,updated:w,removed:D,overrides:_}=o(this.localUserConfiguration,c),C=[...g,...w,...D];return C.length&&this.updateLocalUserConfiguration(c),{keys:C,overrides:_}}compareAndUpdateRemoteUserConfiguration(c){const{added:g,updated:w,removed:D,overrides:_}=o(this.remoteUserConfiguration,c),C=[...g,...w,...D];return C.length&&this.updateRemoteUserConfiguration(c),{keys:C,overrides:_}}compareAndUpdateWorkspaceConfiguration(c){const{added:g,updated:w,removed:D,overrides:_}=o(this.workspaceConfiguration,c),C=[...g,...w,...D];return C.length&&this.updateWorkspaceConfiguration(c),{keys:C,overrides:_}}compareAndUpdateFolderConfiguration(c,g){const w=this.folderConfigurations.get(c),{added:D,updated:_,removed:C,overrides:A}=o(w,g),E=[...D,..._,...C];return(E.length||!w)&&this.updateFolderConfiguration(c,g),{keys:E,overrides:A}}compareAndDeleteFolderConfiguration(c){const g=this.folderConfigurations.get(c);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:w,updated:D,removed:_,overrides:C}=o(g,void 0);return{keys:[...w,...D,..._],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(c,g,w){let D=this.getConsolidatedConfigurationModelForResource(g,w);return g.overrideIdentifier&&(D=D.override(g.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(c)!==void 0&&(D=D.merge(this._policyConfiguration)),D}getConsolidatedConfigurationModelForResource({resource:c},g){let w=this.getWorkspaceConsolidatedConfiguration();if(g&&c){const D=g.getFolder(c);D&&(w=this.getFolderConsolidatedConfiguration(D.uri)||w);const _=this._memoryConfigurationByResource.get(c);_&&(w=w.merge(_))}return w}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(c){let g=this._foldersConsolidatedConfigurations.get(c);if(!g){const w=this.getWorkspaceConsolidatedConfiguration(),D=this._folderConfigurations.get(c);D?(g=w.merge(D),this._foldersConsolidatedConfigurations.set(c,g)):g=w}return g}getFolderConfigurationModelForResource(c,g){if(g&&c){const w=g.getFolder(c);if(w)return this._folderConfigurations.get(w.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((c,g)=>{const{contents:w,overrides:D,keys:_}=this._folderConfigurations.get(g);return c.push([g,{contents:w,overrides:D,keys:_}]),c},[])}}allKeys(){const c=new Set;return this._defaultConfiguration.keys.forEach(g=>c.add(g)),this.userConfiguration.keys.forEach(g=>c.add(g)),this._workspaceConfiguration.keys.forEach(g=>c.add(g)),this._folderConfigurations.forEach(g=>g.keys.forEach(w=>c.add(w))),[...c.values()]}allOverrideIdentifiers(){const c=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(g=>c.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>c.add(g)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(g=>c.add(g)),this._folderConfigurations.forEach(g=>g.getAllOverrideIdentifiers().forEach(w=>c.add(w))),[...c.values()]}getAllKeysForOverrideIdentifier(c){const g=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>g.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>g.add(w)),this._workspaceConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>g.add(w)),this._folderConfigurations.forEach(w=>w.getKeysForOverrideIdentifier(c).forEach(D=>g.add(D))),[...g.values()]}static parse(c,g){const w=this.parseConfigurationModel(c.defaults,g),D=this.parseConfigurationModel(c.policy,g),_=this.parseConfigurationModel(c.application,g),C=this.parseConfigurationModel(c.user,g),A=this.parseConfigurationModel(c.workspace,g),E=c.folders.reduce((S,F)=>(S.set(l.URI.revive(F[0]),this.parseConfigurationModel(F[1],g)),S),new L.ResourceMap);return new i(w,D,_,C,a.createEmptyModel(g),A,E,a.createEmptyModel(g),new L.ResourceMap,g)}static parseConfigurationModel(c,g){return new a(c.contents,c.keys,c.overrides,void 0,g)}}e.Configuration=i;function s(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const c=new Set,g=new Map;for(const D of h)D.keys.forEach(_=>c.add(_)),D.overrides.forEach(([_,C])=>{const A=(0,L.getOrSet)(g,_,new Set);C.forEach(E=>A.add(E))});const w=[];return g.forEach((D,_)=>w.push([_,[...D.values()]])),{keys:[...c.values()],overrides:w}}class t{constructor(c,g,w,D,_){this.change=c,this.previous=g,this.currentConfiguraiton=w,this.currentWorkspace=D,this.logService=_,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const C of c.keys)this.affectedKeys.add(C);for(const[,C]of c.overrides)for(const A of C)this.affectedKeys.add(A);this._affectsConfigStr=this._marker;for(const C of this.affectedKeys)this._affectsConfigStr+=C+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=i.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(c,g){const w=this._marker+c,D=this._affectsConfigStr.indexOf(w);if(D<0)return!1;const _=D+w.length;if(_>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(_);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(g){const A=this.previousConfiguration?this.previousConfiguration.getValue(c,g,this.previous?.workspace):void 0,E=this.currentConfiguraiton.getValue(c,g,this.currentWorkspace);return!R.equals(A,E)}return!0}}e.ConfigurationChangeEvent=t;function o(h,c){const{added:g,removed:w,updated:D}=n(c?.rawConfiguration,h?.rawConfiguration),_=[],C=h?.getAllOverrideIdentifiers()||[],A=c?.getAllOverrideIdentifiers()||[];if(c){const E=A.filter(S=>!C.includes(S));for(const S of E)_.push([S,c.getKeysForOverrideIdentifier(S)])}if(h){const E=C.filter(S=>!A.includes(S));for(const S of E)_.push([S,h.getKeysForOverrideIdentifier(S)])}if(c&&h){for(const E of C)if(A.includes(E)){const S=n({contents:h.getOverrideValue(void 0,E)||{},keys:h.getKeysForOverrideIdentifier(E)},{contents:c.getOverrideValue(void 0,E)||{},keys:c.getKeysForOverrideIdentifier(E)});_.push([E,[...S.added,...S.removed,...S.updated]])}}return{added:g,removed:w,updated:D,overrides:_}}function n(h,c){const g=h?c?h.keys.filter(_=>c.keys.indexOf(_)===-1):[...h.keys]:[],w=c?h?c.keys.filter(_=>h.keys.indexOf(_)===-1):[...c.keys]:[],D=[];if(h&&c){for(const _ of c.keys)if(h.keys.indexOf(_)!==-1){const C=(0,I.getConfigurationValue)(c.contents,_),A=(0,I.getConfigurationValue)(h.contents,_);R.equals(C,A)||D.push(_)}}return{added:g,removed:w,updated:D}}}),define(Ce[233],Ie([1,0,21,4,3,68]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=R;const L=(l,I,y)=>{const u=new Uint8Array(16);for(let a=0;a<16;a++)u[a]=Math.round(Math.random()*256);const T=(0,r.encodeBase64)(r.VSBuffer.wrap(u));return[`GET ws://localhost${l}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${T}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=L,e.socketRawEndHeaderSequence=r.VSBuffer.fromString(`\r
\r
`);async function R(l,I,y,u,T){l.write(r.VSBuffer.fromString((0,e.makeRawSocketHeaders)(I,y,u)));const b=new P.DisposableStore;try{return await new Promise((a,m)=>{let p;b.add(l.onData(f=>{p?p=r.VSBuffer.concat([p,f],p.byteLength+f.byteLength):p=f;const i=p.indexOf(e.socketRawEndHeaderSequence);if(i===-1)return;a(l),l.pauseData();const s=p.slice(i+e.socketRawEndHeaderSequence.byteLength);s.byteLength&&T.onData.fire(s)})),b.add(l.onClose(f=>m(f??new Error("socket closed")))),b.add(l.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw l.dispose(),a}finally{b.dispose()}}class v extends P.Disposable{constructor(I,y){super(),this.debugLabel=I,this.pausableDataEmitter=this._register(new d.PauseableEmitter),this.onData=(...u)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...u)),this.didDisposeEmitter=this._register(new d.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(y.onData),this._register(y.onData.event(u=>this.pausableDataEmitter.fire(u))),this.onClose=this._register(y.onClose).event,this.onEnd=this._register(y.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(I,y){k.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,I,y)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=v}),define(Ce[71],Ie([1,0,13,5]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=l,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class k{constructor(y){this.id=y,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=k;class L{constructor(y,u){this.host=y,this.port=u,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=L;var R;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class v extends r.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof v&&y._code===R.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof v&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof v&&y._code===R.NoResolverFound}static isInvalidAuthority(y){return y instanceof v&&y._code===R.InvalidAuthority}static isHandled(y){return y instanceof v&&y.isHandled}constructor(y,u=R.Unknown,T){super(y),this._message=y,this._code=u,this._detail=T,this.isHandled=u===R.NotAvailable&&T===!0,Object.setPrototypeOf(this,v.prototype)}}e.RemoteAuthorityResolverError=v;function l(I){const y=I.indexOf("+");return y===-1?I:I.substring(0,y)}}),define(Ce[234],Ie([1,0,7,21,20,13,4,3,14,61,42,32,68,71]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=_,e.connectRemoteAgentExtensionHost=C,e.connectRemoteAgentTunnel=E,l=$e(l);const b=30*1e3;var a;(function(ge){ge[ge.Management=1]="Management",ge[ge.ExtensionHost=2]="ExtensionHost",ge[ge.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(ge){switch(ge){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function p(ge){const Y=new P.CancellationTokenSource;return setTimeout(()=>Y.cancel(),ge),Y.token}function f(ge,Y){if(ge.isCancellationRequested||Y.isCancellationRequested)return P.CancellationToken.Cancelled;const W=new P.CancellationTokenSource;return ge.onCancellationRequested(()=>W.cancel()),Y.onCancellationRequested(()=>W.cancel()),W.token}class i{get didTimeout(){return this._state==="timedout"}constructor(Y){this._state="pending",this._disposables=new R.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,r.promiseWithResolvers)(),Y.isCancellationRequested?this._timeout():this._disposables.add(Y.onCancellationRequested(()=>this._timeout()))}registerDisposable(Y){this._state==="pending"?this._disposables.add(Y):Y.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Y=new Error("Time limit reached");return Y.code="ETIMEDOUT",Y.syscall="connect",Y}resolve(Y){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Y))}reject(Y){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Y))}}function s(ge,Y){const W=new i(Y);return W.registerDisposable(ge.onControlMessage(oe=>{const Se=JSON.parse(oe.toString()),te=$(Se);te?W.reject(te):W.resolve(Se)})),W.promise}function t(ge,Y,W,oe,Se,te,ae,se){const Q=new i(se),re=I.StopWatch.create(!1);return ge.info(`Creating a socket (${ae})...`),l.mark(`code/willCreateSocket/${te}`),Y.connect(W,oe,Se,ae).then(ve=>{Q.didTimeout?(l.mark(`code/didCreateSocketError/${te}`),ge.info(`Creating a socket (${ae}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),ve?.dispose()):(l.mark(`code/didCreateSocketOK/${te}`),ge.info(`Creating a socket (${ae}) was successful after ${re.elapsed()} ms.`),Q.resolve(ve))},ve=>{l.mark(`code/didCreateSocketError/${te}`),ge.info(`Creating a socket (${ae}) returned an error after ${re.elapsed()} ms.`),ge.error(ve),Q.reject(ve)}),Q.promise}function o(ge,Y){const W=new i(Y);return ge.then(oe=>{W.didTimeout||W.resolve(oe)},oe=>{W.didTimeout||W.reject(oe)}),W.promise}async function n(ge,Y,W,oe){const Se=ne(ge,Y);ge.logService.trace(`${Se} 1/6. invoking socketFactory.connect().`);let te;try{te=await t(ge.logService,ge.remoteSocketFactoryService,ge.connectTo,v.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${ge.reconnectionToken}&reconnection=${ge.reconnectionProtocol?"true":"false"}`,m(Y),`renderer-${m(Y)}-${ge.reconnectionToken}`,oe)}catch(ve){throw ge.logService.error(`${Se} socketFactory.connect() failed or timed out. Error:`),ge.logService.error(ve),ve}ge.logService.trace(`${Se} 2/6. socketFactory.connect() was successful.`);let ae,se;ge.reconnectionProtocol?(ge.reconnectionProtocol.beginAcceptReconnection(te,null),ae=ge.reconnectionProtocol,se=!1):(ae=new u.PersistentProtocol({socket:te}),se=!0),ge.logService.trace(`${Se} 3/6. sending AuthRequest control message.`);const Q=await o(ge.signService.createNewMessage((0,y.generateUuid)()),oe),re={type:"auth",auth:ge.connectionToken||"00000000000000000000",data:Q.data};ae.sendControl(d.VSBuffer.fromString(JSON.stringify(re)));try{const ve=await s(ae,f(oe,p(1e4)));if(ve.type!=="sign"||typeof ve.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(ge.logService.trace(`${Se} 4/6. received SignRequest control message.`),!await o(ge.signService.validate(Q,ve.signedData),oe)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Fe=await o(ge.signService.sign(ve.data),oe),Be={type:"connectionType",commit:ge.commit,signedData:Fe,desiredConnectionType:Y};return W&&(Be.args=W),ge.logService.trace(`${Se} 5/6. sending ConnectionTypeRequest control message.`),ae.sendControl(d.VSBuffer.fromString(JSON.stringify(Be))),{protocol:ae,ownsProtocol:se}}catch(ve){throw ve&&ve.code==="ETIMEDOUT"&&(ge.logService.error(`${Se} the handshake timed out. Error:`),ge.logService.error(ve)),ve&&ve.code==="VSCODE_CONNECTION_ERROR"&&(ge.logService.error(`${Se} received error control message when negotiating connection. Error:`),ge.logService.error(ve)),se&&V(ae),ve}}async function h(ge,Y,W,oe){const Se=Date.now(),te=ne(ge,Y),{protocol:ae,ownsProtocol:se}=await n(ge,Y,W,oe),Q=new i(oe);return Q.registerDisposable(ae.onControlMessage(re=>{const ve=JSON.parse(re.toString()),be=$(ve);be?(ge.logService.error(`${te} received error control message when negotiating connection. Error:`),ge.logService.error(be),se&&V(ae),Q.reject(be)):(ge.reconnectionProtocol?.endAcceptReconnection(),ge.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${_e(Se)}!`),Q.resolve({protocol:ae,firstMessage:ve}))})),Q.promise}async function c(ge,Y){const{protocol:W}=await h(ge,a.Management,void 0,Y);return{protocol:W}}async function g(ge,Y,W){const{protocol:oe,firstMessage:Se}=await h(ge,a.ExtensionHost,Y,W),te=Se&&Se.debugPort;return{protocol:oe,debugPort:te}}async function w(ge,Y,W){const oe=Date.now(),Se=ne(ge,a.Tunnel),{protocol:te}=await n(ge,a.Tunnel,Y,W);return ge.logService.trace(`${Se} 6/6. handshake finished, connection is up and running after ${_e(oe)}!`),te}async function D(ge,Y,W){const{connectTo:oe,connectionToken:Se}=await ge.addressProvider.getAddress();return{commit:ge.commit,quality:ge.quality,connectTo:oe,connectionToken:Se,reconnectionToken:Y,reconnectionProtocol:W,remoteSocketFactoryService:ge.remoteSocketFactoryService,signService:ge.signService,logService:ge.logService}}async function _(ge,Y,W){return A(ge,async oe=>{const{protocol:Se}=await c(oe,P.CancellationToken.None);return new B(ge,Y,W,oe.reconnectionToken,Se)})}async function C(ge,Y){return A(ge,async W=>{const{protocol:oe,debugPort:Se}=await g(W,Y,P.CancellationToken.None);return new ee(ge,Y,W.reconnectionToken,oe,Se)})}async function A(ge,Y){for(let oe=1;;oe++)try{const Se=(0,y.generateUuid)(),te=await D(ge,Se,null);return await Y(te)}catch(Se){if(oe<5)ge.logService.error(`[remote-connection][attempt ${oe}] An error occurred in initial connection! Will retry... Error:`),ge.logService.error(Se);else throw ge.logService.error(`[remote-connection][attempt ${oe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ge.logService.error(Se),z.triggerPermanentFailure(0,0,T.RemoteAuthorityResolverError.isHandled(Se)),Se}}async function E(ge,Y,W){const oe=await D(ge,(0,y.generateUuid)(),null);return await w(oe,{host:Y,port:W},P.CancellationToken.None)}function S(ge){return(0,r.createCancelablePromise)(Y=>new Promise((W,oe)=>{const Se=setTimeout(W,ge*1e3);Y.onCancellationRequested(()=>{clearTimeout(Se),W()})}))}var F;(function(ge){ge[ge.ConnectionLost=0]="ConnectionLost",ge[ge.ReconnectionWait=1]="ReconnectionWait",ge[ge.ReconnectionRunning=2]="ReconnectionRunning",ge[ge.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ge[ge.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class N{constructor(Y,W){this.reconnectionToken=Y,this.millisSinceLastIncomingData=W,this.type=F.ConnectionLost}}e.ConnectionLostEvent=N;class O{constructor(Y,W,oe,Se){this.reconnectionToken=Y,this.millisSinceLastIncomingData=W,this.durationSeconds=oe,this.cancellableTimer=Se,this.type=F.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class M{constructor(Y,W,oe){this.reconnectionToken=Y,this.millisSinceLastIncomingData=W,this.attempt=oe,this.type=F.ReconnectionRunning}}e.ReconnectionRunningEvent=M;class U{constructor(Y,W,oe){this.reconnectionToken=Y,this.millisSinceLastIncomingData=W,this.attempt=oe,this.type=F.ConnectionGain}}e.ConnectionGainEvent=U;class x{constructor(Y,W,oe,Se){this.reconnectionToken=Y,this.millisSinceLastIncomingData=W,this.attempt=oe,this.handled=Se,this.type=F.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=x;class z extends R.Disposable{static triggerPermanentFailure(Y,W,oe){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Y,this._permanentFailureAttempt=W,this._permanentFailureHandled=oe,this._instances.forEach(Se=>Se._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Y=>Y._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Y=>Y._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||z._permanentFailure}constructor(Y,W,oe,Se,te){super(),this._connectionType=Y,this._options=W,this.reconnectionToken=oe,this.protocol=Se,this._reconnectionFailureIsFatal=te,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new U(this.reconnectionToken,0,0)),this._register(Se.onSocketClose(ae=>{const se=le(this._connectionType,this.reconnectionToken,!0);ae?ae.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${se} received socket close event (hadError: ${ae.hadError}).`),ae.error&&this._options.logService.error(ae.error)):(this._options.logService.info(`${se} received socket close event (wasClean: ${ae.wasClean}, code: ${ae.code}, reason: ${ae.reason}).`),ae.event&&this._options.logService.error(ae.event)):this._options.logService.info(`${se} received socket close event.`),this._beginReconnecting()})),this._register(Se.onSocketTimeout(ae=>{const se=le(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${ae.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ae.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ae.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),z._instances.push(this),this._register((0,R.toDisposable)(()=>{const ae=z._instances.indexOf(this);ae>=0&&z._instances.splice(ae,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(z._permanentFailureMillisSinceLastIncomingData,z._permanentFailureAttempt,z._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const Y=le(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Y} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let oe=-1;do{oe++;const Se=oe<W.length?W[oe]:W[W.length-1];try{if(Se>0){const ae=S(Se);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se,ae)),this._options.logService.info(`${Y} waiting for ${Se} seconds before reconnecting...`);try{await ae}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${Y} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe+1)),this._options.logService.info(`${Y} resolving connection...`);const te=await D(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Y} connecting to ${te.connectTo}...`),await this._reconnect(te,p(b)),this._options.logService.info(`${Y} reconnected!`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Y} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(te),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}if(oe>360){this._options.logService.error(`${Y} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(te),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}if(T.RemoteAuthorityResolverError.isTemporarilyNotAvailable(te)){this._options.logService.info(`${Y} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this._options.logService.info(`${Y} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(te);continue}if((0,k.isCancellationError)(te)){this._options.logService.info(`${Y} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(te);continue}if(te instanceof T.RemoteAuthorityResolverError){this._options.logService.error(`${Y} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(te),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),oe+1,T.RemoteAuthorityResolverError.isHandled(te));break}this._options.logService.error(`${Y} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(te),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(Y,W,oe){this._reconnectionFailureIsFatal?z.triggerPermanentFailure(Y,W,oe):this._gotoPermanentFailure(Y,W,oe)}_gotoPermanentFailure(Y,W,oe){this._onDidStateChange.fire(new x(this.reconnectionToken,Y,W,oe)),V(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=z;class B extends z{constructor(Y,W,oe,Se,te){super(a.Management,Y,Se,te,!0),this.client=this._register(new u.Client(te,{remoteAuthority:W,clientId:oe},Y.ipcLogger))}async _reconnect(Y,W){await c(Y,W)}}e.ManagementPersistentConnection=B;class ee extends z{constructor(Y,W,oe,Se,te){super(a.ExtensionHost,Y,oe,Se,!1),this._startArguments=W,this.debugPort=te}async _reconnect(Y,W){await g(Y,this._startArguments,W)}}e.ExtensionHostPersistentConnection=ee;function V(ge){try{ge.acceptDisconnect();const Y=ge.getSocket();ge.dispose(),Y.dispose()}catch(Y){(0,k.onUnexpectedError)(Y)}}function $(ge){if(ge&&ge.type==="error"){const Y=new Error(`Connection error: ${ge.reason}`);return Y.code="VSCODE_CONNECTION_ERROR",Y}return null}function G(ge,Y){for(;ge.length<Y;)ge+=" ";return ge}function Z(ge,Y){return`[remote-connection][${G(m(ge),13)}][${Y.substr(0,5)}\u2026]`}function le(ge,Y,W){return`${Z(ge,Y)}[${W?"reconnect":"initial"}]`}function ne(ge,Y){return`${le(Y,ge.reconnectionToken,!!ge.reconnectionProtocol)}[${ge.connectTo}]`}function _e(ge){return`${Date.now()-ge} ms`}}),define(Ce[90],Ie([1,0,14]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=d,e.getRemoteName=P,e.parseAuthorityWithPort=k,e.parseAuthorityWithOptionalPort=L;function d(v){return v.scheme===r.Schemas.vscodeRemote?v.authority:void 0}function P(v){if(!v)return;const l=v.indexOf("+");return l<0?v:v.substr(0,l)}function k(v){const{host:l,port:I}=R(v);if(typeof I>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:I}}function L(v,l){let{host:I,port:y}=R(v);return typeof y>"u"&&(y=l),{host:I,port:y}}function R(v){const l=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const I=v.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const y=v.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:v,port:void 0}}}),define(Ce[23],Ie([1,0,12,5,90]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=k,e.isApplicationScopedExtension=y,e.isLanguagePackExtension=u,e.isAuthenticationProviderExtension=T,e.isResolverExtension=b,e.parseApiProposals=a,e.parseEnabledApiProposalNames=m,r=$e(r),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.LINUX_PPC64LE="linux-ppc64le",p.LINUX_RISCV64="linux-riscv64",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class v{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,i){if(typeof f>"u"||f===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof f=="string"||typeof i=="string"){const s=typeof f=="string"?f:f.value,t=typeof i=="string"?i:i.value;return r.equalsIgnoreCase(s,t)}return f._lower===i._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=v;class l{get size(){return this._set.size}constructor(f){if(this._set=new Set,f)for(const i of f)this.add(i)}add(f){this._set.add(v.toKey(f))}delete(f){return this._set.delete(v.toKey(f))}has(f){return this._set.has(v.toKey(f))}}e.ExtensionIdentifierSet=l;class I{constructor(){this._map=new Map}clear(){this._map.clear()}delete(f){this._map.delete(v.toKey(f))}get(f){return this._map.get(v.toKey(f))}has(f){return this._map.has(v.toKey(f))}set(f,i){this._map.set(v.toKey(f),i)}values(){return this._map.values()}forEach(f){this._map.forEach(f)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=I;function y(p){return u(p)}function u(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function T(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function b(p,f){if(f){const i=`onResolveRemoteAuthority:${(0,P.getRemoteName)(f)}`;return!!p.activationEvents?.includes(i)}return!1}function a(p){return p.map(f=>{const[i,s]=f.split("@");return{proposalName:i,version:s?parseInt(s):void 0}})}function m(p){return p.map(f=>f.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,d.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[146],Ie([1,0,10,8,23,5]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=R,e.toTargetPlatform=v,e.getTargetPlatform=l,e.isNotWebExtensionInWebTargetPlatform=I,e.isTargetPlatformCompatible=y,e.isIExtensionIdentifier=u,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var L;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function R(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case P.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function v(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.LINUX_PPC64LE:return P.TargetPlatform.LINUX_PPC64LE;case P.TargetPlatform.LINUX_RISCV64:return P.TargetPlatform.LINUX_RISCV64;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function l(t,o){switch(t){case r.Platform.Windows:return o==="x64"?P.TargetPlatform.WIN32_X64:o==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Linux:return o==="x64"?P.TargetPlatform.LINUX_X64:o==="arm64"?P.TargetPlatform.LINUX_ARM64:o==="arm"?P.TargetPlatform.LINUX_ARMHF:o==="ppc64le"?P.TargetPlatform.LINUX_PPC64LE:o==="riscv64"?P.TargetPlatform.LINUX_RISCV64:P.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?P.TargetPlatform.ALPINE_X64:o==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Mac:return o==="x64"?P.TargetPlatform.DARWIN_X64:o==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Web:return P.TargetPlatform.WEB}}function I(t,o){return o===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function y(t,o,n){return I(o,n)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===n}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var T;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var b;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var a;(function(t){t.Install="install",t.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var p;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(p||(e.ExtensionGalleryErrorCode=p={}));class f extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.ExtensionGalleryError=f;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class s extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,d.localize2)(11502,"Extensions"),e.PreferencesLocalizedLabel=(0,d.localize2)(11503,"Preferences")}),define(Ce[147],Ie([1,0,13,23]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class P{constructor(){this._generators=new Map,this._cache=new WeakMap}register(L,R){this._generators.set(L,R)}readActivationEvents(L){return this._cache.has(L)||this._cache.set(L,this._readActivationEvents(L)),this._cache.get(L)}createActivationEventsMap(L){const R=Object.create(null);for(const v of L){const l=this.readActivationEvents(v);l.length>0&&(R[d.ExtensionIdentifier.toKey(v.identifier)]=l)}return R}_readActivationEvents(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const R=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let v=0;v<R.length;v++)R[v]==="onUri"&&(R[v]=`onUri:${d.ExtensionIdentifier.toKey(L.identifier)}`);if(!L.contributes)return R;for(const v in L.contributes){const l=this._generators.get(v);if(!l)continue;const I=L.contributes[v],y=Array.isArray(I)?I:[I];try{l(y,R)}catch(u){(0,r.onUnexpectedError)(u)}}return R}}e.ImplicitActivationEventsImpl=P,e.ImplicitActivationEvents=new P});var Wt=this&&this.__importDefault||function(pe){return pe&&pe.__esModule?pe:{default:pe}};define(Ce[235],Ie([1,0,22,43,8,361,23,143]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=I,e.parseVersion=y,e.normalizeVersion=u,e.isValidVersion=T,e.validateExtensionManifest=b,e.isValidExtensionVersion=a,e.isEngineValid=m,e.areApiProposalsCompatible=p,d=Wt(d),P=$e(P),k=$e(k);const v=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function I(s){return s=s.trim(),s==="*"||v.test(s)}function y(s){if(!I(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=s.match(v);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(s){if(!s)return null;const t=s.majorBase,o=s.majorMustEqual,n=s.minorBase;let h=s.minorMustEqual;const c=s.patchBase;let g=s.patchMustEqual;s.hasCaret&&(t===0||(h=!1),g=!1);let w=0;if(s.preRelease){const D=l.exec(s.preRelease);if(D){const[,_,C,A]=D;w=Date.UTC(Number(_),Number(C)-1,Number(A))}}return{majorBase:t,majorMustEqual:o,minorBase:n,minorMustEqual:h,patchBase:c,patchMustEqual:g,isMinimum:s.hasGreaterEquals,notBefore:w}}function T(s,t,o){let n;typeof s=="string"?n=u(y(s)):n=s;let h;t instanceof Date?h=t.getTime():typeof t=="string"&&(h=new Date(t).getTime());let c;if(typeof o=="string"?c=u(y(o)):c=o,!n||!c)return!1;const g=n.majorBase,w=n.minorBase,D=n.patchBase;let _=c.majorBase,C=c.minorBase,A=c.patchBase;const E=c.notBefore;let S=c.majorMustEqual,F=c.minorMustEqual,N=c.patchMustEqual;return c.isMinimum?g>_?!0:g<_?!1:w>C?!0:w<C||h&&h<E?!1:D>=A:(g===1&&_===0&&(!S||!F||!N)&&(_=1,C=0,A=0,S=!0,F=!1,N=!1),g<_?!1:g>_?!S:w<C?!1:w>C?!F:D<A?!1:D>A?!N:!(h&&h<E))}function b(s,t,o,n,h,c){const g=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return g.push([d.default.Error,P.localize(11433,null)]),g;if(typeof n.name!="string")return g.push([d.default.Error,P.localize(11434,null,"name")]),g;if(typeof n.version!="string")return g.push([d.default.Error,P.localize(11435,null,"version")]),g;if(!n.engines)return g.push([d.default.Error,P.localize(11436,null,"engines")]),g;if(typeof n.engines.vscode!="string")return g.push([d.default.Error,P.localize(11437,null,"engines.vscode")]),g;if(typeof n.extensionDependencies<"u"&&!i(n.extensionDependencies))return g.push([d.default.Error,P.localize(11438,null,"extensionDependencies")]),g;if(typeof n.activationEvents<"u"){if(!i(n.activationEvents))return g.push([d.default.Error,P.localize(11439,null,"activationEvents")]),g;if(typeof n.main>"u"&&typeof n.browser>"u")return g.push([d.default.Error,P.localize(11440,null,"activationEvents","main","browser")]),g}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&g.push([d.default.Warning,P.localize(11441,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return g.push([d.default.Error,P.localize(11442,null,"main")]),g;{const _=(0,r.joinPath)(o,n.main);(0,r.isEqualOrParent)(_,o)||g.push([d.default.Warning,P.localize(11443,null,_.path,o.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return g.push([d.default.Error,P.localize(11444,null,"browser")]),g;{const _=(0,r.joinPath)(o,n.browser);(0,r.isEqualOrParent)(_,o)||g.push([d.default.Warning,P.localize(11445,null,_.path,o.path)])}}if(!k.valid(n.version))return g.push([d.default.Error,P.localize(11446,null)]),g;const w=[];if(!a(s,t,n,h,w))for(const _ of w)g.push([d.default.Error,_]);if(c&&n.enabledApiProposals?.length){const _=[];if(!p([...n.enabledApiProposals],_))for(const C of _)g.push([d.default.Error,C])}return g}function a(s,t,o,n,h){return n||typeof o.main>"u"&&typeof o.browser>"u"?!0:f(s,t,o.engines.vscode,h)}function m(s,t,o){return s==="*"||f(t,o,s)}function p(s,t){if(s.length===0)return!0;const o=Array.isArray(t)?t:void 0,n=(o?void 0:t)??R.allApiProposals,h=[],c=(0,L.parseApiProposals)(s);for(const{proposalName:g,version:w}of c){const D=n[g];D&&w&&D.version!==w&&h.push(P.localize(11447,null,g))}return o?.push(...h),h.length===0}function f(s,t,o,n=[]){const h=u(y(o));if(!h)return n.push(P.localize(11448,null,o)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return n.push(P.localize(11449,null,o)),!1}else if(!h.majorMustEqual)return n.push(P.localize(11450,null,o)),!1;return T(s,t,h)?!0:(n.push(P.localize(11451,null,s,o)),!1)}function i(s){if(!Array.isArray(s))return!1;for(let t=0,o=s.length;t<o;t++)if(typeof s[t]!="string")return!1;return!0}}),define(Ce[236],Ie([1,0,3,5]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,d.createDecorator)("remoteSocketFactoryService");class P{constructor(){this.factories={}}register(L,R){return this.factories[L]??=[],this.factories[L].push(R),(0,r.toDisposable)(()=>{const v=this.factories[L]?.indexOf(R);typeof v=="number"&&v>=0&&this.factories[L]?.splice(v,1)})}getSocketFactory(L){return(this.factories[L.type]||[]).find(v=>v.supports(L))}connect(L,R,v,l){const I=this.getSocketFactory(L);if(!I)throw new Error(`No socket factory found for ${L}`);return I.connect(L,R,v,l)}}e.RemoteSocketFactoryService=P}),define(Ce[237],Ie([1,0,21,13,3,8,70,5,11,36]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=u,e.hasNoContent=T,e.asText=b,e.asTextOrError=a,e.asJson=m,e.updateProxyConfigurationsScope=p,e.IRequestService=(0,R.createDecorator)("requestService");class I{constructor(t){this.original=t}toJSON(){if(!this.headers){const t=Object.create(null);for(const o in this.original)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.original[o];this.headers=t}return this.headers}}class y extends P.Disposable{constructor(t){super(),this.counter=0,this.logger=t.createLogger("network",{name:(0,k.localize)(11220,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async logAndRequest(t,o,n){const h=`${t} #${++this.counter}: ${o.url}`;this.logger.trace(`${h} - begin`,o.type,new I(o.headers??{}));try{const c=await n();return this.logger.trace(`${h} - end`,o.type,c.res.statusCode,c.res.headers),c}catch(c){throw this.logger.error(`${h} - error`,o.type,(0,d.getErrorMessage)(c)),c}}}e.AbstractRequestService=y;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function T(s){return s.res.statusCode===204}async function b(s){return T(s)?null:(await(0,r.streamToBuffer)(s.stream)).toString()}async function a(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return b(s)}async function m(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(T(s))return null;const o=(await(0,r.streamToBuffer)(s.stream)).toString();try{return JSON.parse(o)}catch(n){throw n.message+=`:
`+o,n}}function p(s){i(s)}let f;function i(s){const t=l.Registry.as(L.Extensions.Configuration),o=f;f={id:"http",order:15,title:(0,k.localize)(11221,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(11222,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(11223,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(11224,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(11225,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(11226,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(11227,null),(0,k.localize)(11228,null),(0,k.localize)(11229,null),(0,k.localize)(11230,null)],default:"override",description:(0,k.localize)(11231,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11232,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(11233,null),restricted:!0}}},t.updateConfigurations({add:[f],remove:o?[o]:[]})}i(L.ConfigurationScope.APPLICATION)}),define(Ce[238],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class r{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(P){try{const k=await this.getValidator();if(k){const L=String(r._nextId++);return this.validators.set(L,k),{id:L,data:k.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,k){if(!P.id)return!0;const L=this.validators.get(P.id);if(!L)return!1;this.validators.delete(P.id);try{return L.validate(k)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(P){try{return await this.signValue(P)}catch{}return P}}e.AbstractSignService=r}),define(Ce[117],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,r.createDecorator)(e.SIGN_SERVICE_ID)}),define(Ce[148],Ie([1,0,238]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class d extends r.AbstractSignService{getValidator(){return this.vsda().then(k=>new k.validator)}signValue(k){return this.vsda().then(L=>new L.signer().sign(k))}vsda(){return new Promise((k,L)=>pe(["vsda"],k,L))}}e.SignService=d}),define(Ce[239],Ie([1,0,10,55,32]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=L,e.verifyMicrosoftInternalDomain=R;function k(v){if(r.platform===r.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function L(v,l,I,y,u,T,b,a,m,p){const f=Object.create(null);f["common.machineId"]=T,f["common.sqmId"]=b,f["common.devDeviceId"]=a,f.sessionID=(0,P.generateUuid)()+Date.now(),f.commitHash=y,f.version=u,f["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,r.PlatformToString)(r.platform),f["common.nodePlatform"]=d.platform,f["common.nodeArch"]=I,f["common.product"]=p||"desktop",m&&(f["common.msftInternal"]=m);let i=0;const s=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),r.isLinuxSnap&&(f["common.snap"]="true");const t=k(l);return t&&(f["common.platformDetail"]=t),f}function R(v){const l=d.env.USERDNSDOMAIN;if(!l)return!1;const I=l.toLowerCase();return v.some(y=>I===y)}}),define(Ce[149],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,r.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,r.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var d;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(d||(e.TelemetryLevel=d={}));var P;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ce[91],Ie([1,0,24,17,90,239,149]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=I,e.isLoggingOnly=y,e.getTelemetryLevel=u,e.validateTelemetryData=T,e.cleanRemoteAuthority=a,e.isInternalTelemetry=p,e.getPiiPathsFromEnvironment=f,e.cleanData=t;class R{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class v{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class l{async publicLog(n,h,c){}async publicLogError(n,h,c){}}e.NullEndpointTelemetryService=l,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!o.enableTelemetry)}function y(o,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const n=o.getValue(L.TELEMETRY_SETTING_ID),h=o.getValue(L.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function T(o){const n={},h={},c={};m(o,c);for(let g in c){g=g.length>150?g.substr(g.length-149):g;const w=c[g];typeof w=="number"?h[g]=w:typeof w=="boolean"?h[g]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${w.length}`),n[g]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(n[g]=w)}return{properties:n,measurements:h}}const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(o){if(!o)return"none";const n=(0,P.getRemoteName)(o);return b.has(n)?n:"other"}function m(o,n,h=0,c){if(o)for(const g of Object.getOwnPropertyNames(o)){const w=o[g],D=c?c+g:g;Array.isArray(w)?n[D]=(0,r.safeStringify)(w):w instanceof Date?n[D]=w.toISOString():(0,d.isObject)(w)?h<2?m(w,n,h+1,D+"."):n[D]=(0,r.safeStringify)(w):n[D]=w}}function p(o,n){const h=o.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(h)||c}function f(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,n){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let h=o;const c=[];for(const _ of n)for(;;){const C=_.exec(o);if(!C)break;c.push([C.index,_.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(h="";;){const _=w.exec(o);if(!_)break;const C=c.some(([A,E])=>_.index<E&&A<w.lastIndex);!g.test(_[0])&&!C&&(h+=o.substring(D,_.index)+"<REDACTED: user-file-path>",D=w.lastIndex)}return D<o.length&&(h+=o.substr(D)),h}function s(o){if(!o)return o;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of n)if(h.regex.test(o))return`<REDACTED: ${h.label}>`;return o}function t(o,n){return(0,r.cloneAndChange)(o,h=>{if(h instanceof R||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let c=h.replaceAll("%20"," ");c=i(c,n);for(const g of n)c=c.replace(g,"");return c=s(c),c}})}}),define(Ce[240],Ie([1,0,12,146,23,10,2,13,55,91]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=I,e.getIdAndVersion=b,e.getExtensionId=a,e.adoptToGalleryExtensionId=m,e.getGalleryExtensionId=p,e.groupByExtension=f,e.getLocalExtensionTelemetryData=i,e.getGalleryExtensionTelemetryData=s,e.getExtensionDependencies=t,e.computeTargetPlatform=n;function I(h,c){return h.uuid&&c.uuid?h.uuid===c.uuid:h.id===c.id?!0:(0,r.compareIgnoreCase)(h.id,c.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(c){const g=c.manifest?c.manifest.version:c.version,w=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new u(c.identifier,g,w)}static parse(c){const g=y.exec(c);return g&&g[1]&&g[2]?new u({id:g[1]},g[2],g[4]||void 0):null}constructor(c,g,w=P.TargetPlatform.UNDEFINED){this.identifier=c,this.version=g,this.targetPlatform=w,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof u?I(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=u;const T=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(h){const c=T.exec(h);return c&&c[1]?[m(c[1]),c[2]]:[m(h),void 0]}function a(h,c){return`${h}.${c}`}function m(h){return h.toLowerCase()}function p(h,c){return m(a(h??P.UNDEFINED_PUBLISHER,c))}function f(h,c){const g=[],w=D=>{for(const _ of g)if(_.some(C=>I(c(C),c(D))))return _;return null};for(const D of h){const _=w(D);_?_.push(D):g.push([D])}return g}function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}function s(h){return{id:new l.TelemetryTrustedValue(h.identifier.id),name:new l.TelemetryTrustedValue(h.name),version:h.version,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function t(h,c){const g=[],w=c.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const D=w.shift();if(D&&g.every(_=>!I(_.identifier,{id:D}))){const _=h.filter(C=>I(C.identifier,{id:D}));_.length===1&&(g.push(_[0]),w.push(..._[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}async function o(h,c){if(!k.isLinux)return!1;let g;try{g=(await h.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await h.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){c.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(D))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(h,c){const g=await o(h,c),w=(0,d.getTargetPlatform)(g?"alpine":k.platform,v.arch);return c.debug("ComputeTargetPlatform:",w),w}}),define(Ce[241],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=r,e.serializeEnvironmentDescriptionMap=d,e.deserializeEnvironmentVariableCollection=P,e.deserializeEnvironmentDescriptionMap=k,e.serializeEnvironmentVariableCollections=L,e.deserializeEnvironmentVariableCollections=R;function r(v){return[...v.entries()]}function d(v){return v?[...v.entries()]:[]}function P(v){return new Map(v)}function k(v){return new Map(v??[])}function L(v){return Array.from(v.entries()).map(l=>[l[0],r(l[1].map),d(l[1].descriptionMap)])}function R(v){return new Map(v.map(l=>[l[0],{map:P(l[1]),descriptionMap:k(l[2])}]))}}),define(Ce[242],Ie([1,0,5,35,36]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new d.RawContextKey("terminalTabFocusMode",!1,!0);var k;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(k||(e.TerminalSettingPrefix=k={}));var L;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var R;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(R||(e.PosixShellType=R={}));var v;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(v||(e.WindowsShellType=v={}));var l;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.IPtyService=(0,r.createDecorator)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var T;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(T||(e.TerminalLocation=T={}));var b;(function(t){t.TerminalView="view",t.Editor="editor"})(b||(e.TerminalLocationString=b={}));var a;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var p;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(p||(e.ProfileSource=p={}));var f;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(o){const n=this._sanitizeRemoteAuthority(o.remoteAuthority);if(this._backends.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this._backends.set(n,o)}getTerminalBackend(o){return this._backends.get(this._sanitizeRemoteAuthority(o))}_sanitizeRemoteAuthority(o){return o?.toLowerCase()??""}}P.Registry.add(e.TerminalExtensions.Backend,new s),e.ILocalPtyService=(0,r.createDecorator)("localPtyService"),e.ITerminalLogService=(0,r.createDecorator)("terminalLogService")}),define(Ce[243],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,k,L=5){const R=k(v=>{const l=typeof v=="string"?v:v.data;let I=this._terminalBufferMap.get(P);if(I){I.data.push(l);return}const y=setTimeout(()=>this.flushBuffer(P),L);I={data:[l],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(P),R.dispose()}},this._terminalBufferMap.set(P,I)});return R}stopBuffering(P){this._terminalBufferMap.get(P)?.dispose()}flushBuffer(P){const k=this._terminalBufferMap.get(P);k&&(this._terminalBufferMap.delete(P),this._callback(P,k.data.join("")))}}e.TerminalDataBufferer=r}),define(Ce[244],Ie([1,0,7,82,106,51,4,17,2,8,116,36]),function(pe,e,r,d,P,k,L,R,v,l,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=m,e.getIconRegistry=p,y=$e(y),e.Extensions={IconContribution:"base.contributions.icons"};var u;(function(t){function o(n,h){let c=n.defaults;for(;k.ThemeIcon.isThemeIcon(c);){const g=a.getIcon(c.id);if(!g)return;c=g.defaults}return c}t.getDefinition=o})(u||(e.IconContribution=u={}));var T;(function(t){function o(h){return{weight:h.weight,style:h.style,src:h.src.map(c=>({format:c.format,location:c.location.toString()}))}}t.toJSONObject=o;function n(h){const c=g=>(0,R.isString)(g)?g:void 0;if(h&&Array.isArray(h.src)&&h.src.every(g=>(0,R.isString)(g.format)&&(0,R.isString)(g.location)))return{weight:c(h.weight),style:c(h.style),src:h.src.map(g=>({format:g.format,location:v.URI.parse(g.location)}))}}t.fromJSONObject=n})(T||(e.IconFontDefinition=T={}));class b{constructor(){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(11152,null)},fontCharacter:{type:"string",description:(0,l.localize)(11153,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${k.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(o,n,h,c){const g=this.iconsById[o];if(g){if(h&&!g.description){g.description=h,this.iconSchema.properties[o].markdownDescription=`${h} $(${o})`;const _=this.iconReferenceSchema.enum.indexOf(o);_!==-1&&(this.iconReferenceSchema.enumDescriptions[_]=h),this._onDidChange.fire()}return g}const w={id:o,description:h,defaults:n,deprecationMessage:c};this.iconsById[o]=w;const D={$ref:"#/definitions/icons"};return c&&(D.deprecationMessage=c),h&&(D.markdownDescription=`${h}: $(${o})`),this.iconSchema.properties[o]=D,this.iconReferenceSchema.enum.push(o),this.iconReferenceSchema.enumDescriptions.push(h||""),this._onDidChange.fire(),{id:o}}deregisterIcon(o){delete this.iconsById[o],delete this.iconSchema.properties[o];const n=this.iconReferenceSchema.enum.indexOf(o);n!==-1&&(this.iconReferenceSchema.enum.splice(n,1),this.iconReferenceSchema.enumDescriptions.splice(n,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(o=>this.iconsById[o])}getIcon(o){return this.iconsById[o]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(o,n){const h=this.iconFontsById[o];return h||(this.iconFontsById[o]=n,this._onDidChange.fire(),n)}deregisterIconFont(o){delete this.iconFontsById[o]}getIconFont(o){return this.iconFontsById[o]}toString(){const o=(g,w)=>g.id.localeCompare(w.id),n=g=>{for(;k.ThemeIcon.isThemeIcon(g.defaults);)g=this.iconsById[g.defaults.id];return`codicon codicon-${g?g.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(g=>this.iconsById[g]);for(const g of c.filter(w=>!!w.description).sort(o))h.push(`|<i class="${n(g)}"></i>|${g.id}|${k.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const g of c.filter(w=>!k.ThemeIcon.isThemeIcon(w.defaults)).sort(o))h.push(`|<i class="${n(g)}"></i>|${g.id}|`);return h.join(`
`)}}const a=new b;y.Registry.add(e.Extensions.IconContribution,a);function m(t,o,n,h){return a.registerIcon(t,o,n,h)}function p(){return a}function f(){const t=(0,P.getCodiconFontCharacters)();for(const o in t){const n="\\"+t[o].toString(16);a.registerIcon(o,{fontCharacter:n})}}f(),e.iconsSchemaId="vscode://schemas/icons";const i=y.Registry.as(I.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,a.getIconSchema());const s=new r.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);a.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=m("widget-close",d.Codicon.close,(0,l.localize)(11154,null)),e.gotoPreviousLocation=m("goto-previous-location",d.Codicon.arrowUp,(0,l.localize)(11155,null)),e.gotoNextLocation=m("goto-next-location",d.Codicon.arrowDown,(0,l.localize)(11156,null)),e.syncing=k.ThemeIcon.modify(d.Codicon.sync,"spin"),e.spinningLoading=k.ThemeIcon.modify(d.Codicon.loading,"spin")}),define(Ce[92],Ie([1,0,4,3,10,2,46,5,11]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=y,e.extractLocalHostUriMetaDataForPortMapping=T,e.extractQueryLocalHostUriMetaDataForPortMapping=b,e.isLocalhost=a,e.isAllInterfaces=m,e.isPortPrivileged=p,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var l;(function(s){s.Http="http",s.Https="https"})(l||(e.TunnelProtocol=l={}));var I;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(I||(e.TunnelPrivacyId=I={}));function y(s){return!!s.forwardPort}var u;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function T(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(t)return{address:t[1],port:+t[2]}}function b(s){if(s.scheme!=="http"&&s.scheme!=="https"||!s.query)return;const t=s.query.split("&");for(const o of t){const n=o.split("=")[1];if(/^https?:/.exec(n)){const h=T(k.URI.parse(n));if(h)return h}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function a(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}function p(s,t,o,n){if(o===P.OperatingSystem.Windows)return!1;if(o===P.OperatingSystem.Macintosh&&m(t)){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(h?.length===4&&parseInt(h[1])>=18)return!1}return s<1024}class f{constructor(t,o,n){this.remoteAddress=t,this.localAddress=o,this._dispose=n,this._onDispose=new r.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let i=class extends d.Disposable{constructor(t,o){super(),this.logService=t,this.configurationService=o,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions,this._canChangeProtocol=t.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],o=Array.from(this._tunnels.values());for(const n of o){const h=Array.from(n.values());for(const c of h){const g=await c.value;g&&typeof g!="string"&&t.push(g)}}return t}async dispose(){super.dispose();for(const t of this._tunnels.values()){for(const{value:o}of t.values())await o.then(n=>typeof n!="string"?n?.dispose():void 0);t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,o,n,h,c){this.addTunnelToMap(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:n,privacy:h,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(m(t)||a(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const n=this.getTunnelFromMap(t,o);if(n)return++n.refcount,n.value}openTunnel(t,o,n,h,c,g=!1,w,D){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${n} on local port ${c}.`);const _=this._tunnelProvider??t;if(!_)return;if(o||(o="localhost"),h||(h=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(n)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.retainOrCreateTunnel(_,o,n,h,c,g,w,D);return C?C.then(A=>{if(A){if(typeof A=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(o,n),A}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(o,n);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.makeTunnel(A);return(A.tunnelRemoteHost!==o||A.tunnelRemotePort!==n)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),w&&A.privacy!==w&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(E),E}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this._tunnels.get(t.tunnelRemoteHost);if(o){const n=o.get(t.tunnelRemotePort);n&&(n.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,n))}}}}async tryDisposeTunnel(t,o,n){if(n.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const h=n.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(o),h}}async closeTunnel(t,o){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const n=this._tunnels.get(t);if(n&&n.has(o)){const h=n.get(o);h.refcount=0,await this.tryDisposeTunnel(t,o,h)}}addTunnelToMap(t,o,n){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(o,{refcount:1,value:n})}async removeEmptyOrErrorTunnelFromMap(t,o){const n=this._tunnels.get(t);if(n){const h=n.get(o),c=h?await h.value:void 0;(!c||typeof c=="string")&&n.delete(o),n.size===0&&this._tunnels.delete(t)}}getTunnelFromMap(t,o){const n=[t];a(t)?(n.push(...e.LOCALHOST_ADDRESSES),n.push(...e.ALL_INTERFACES_ADDRESSES)):m(t)&&n.push(...e.ALL_INTERFACES_ADDRESSES);const h=n.map(c=>this._tunnels.get(c));for(const c of h){const g=c?.get(o);if(g)return g}}canTunnel(t){return!!T(t)}createWithProvider(t,o,n,h,c,g,w){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${n} on local port ${h}.`);const D=n;this._factoryInProgress.add(D);const _=h===void 0?n:h,C={elevationRequired:c?this.isPortPrivileged(_):!1},A={remoteAddress:{host:o,port:n},localAddressPort:h,privacy:g,public:g?g!==I.Private:void 0,protocol:w},E=t.forwardPort(A,C);return E?(this.addTunnelToMap(o,n,E),E.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(D)})):this._factoryInProgress.delete(D),E}};e.AbstractTunnelService=i,e.AbstractTunnelService=i=Xe([He(0,v.ILogService),He(1,L.IConfigurationService)],i)}),define(Ce[245],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,r.createDecorator)("IUriIdentityService")}),define(Ce[246],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,r.createDecorator)("editSessionIdentityService");var d;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(d||(e.EditSessionIdentityMatch=d={}))}),define(Ce[247],Ie([1,0,14]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=d,e.getVirtualWorkspaceLocation=P,e.getVirtualWorkspaceScheme=k,e.getVirtualWorkspaceAuthority=L,e.isVirtualWorkspace=R;function d(v){return v.scheme!==r.Schemas.file&&v.scheme!==r.Schemas.vscodeRemote}function P(v){if(v.folders.length)return v.folders.every(l=>d(l.uri))?v.folders[0].uri:void 0;if(v.configuration&&d(v.configuration))return v.configuration}function k(v){return P(v)?.scheme}function L(v){return P(v)?.authority}function R(v){return P(v)!==void 0}}),define(Ce[47],Ie([1,0,8,16,84,22,2,5,14]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=l,e.isEmptyWorkspaceIdentifier=I,e.toWorkspaceIdentifier=y,e.isWorkspaceIdentifier=u,e.reviveIdentifier=T,e.isWorkspace=a,e.isWorkspaceFolder=m,e.toWorkspaceFolder=i,e.isUntitledWorkspace=s,e.isTemporaryWorkspace=t,e.isStandaloneEditorWorkspace=o,e.isSavedWorkspace=n,e.hasWorkspaceFileExtension=h,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function l(c){const g=c;return typeof g?.id=="string"&&L.URI.isUri(g.uri)}function I(c){return typeof c?.id=="string"&&!l(c)&&!u(c)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(c,g){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,d.basename)(c)}:g?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const w=c;return w.configuration?{id:w.id,configPath:w.configuration}:w.folders.length===1?{id:w.id,uri:w.folders[0].uri}:{id:w.id}}function u(c){const g=c;return typeof g?.id=="string"&&L.URI.isUri(g.configPath)}function T(c){const g=c;if(g?.uri)return{id:g.id,uri:L.URI.revive(g.uri)};const w=c;if(w?.configPath)return{id:w.id,configPath:L.URI.revive(w.configPath)};if(c?.id)return{id:c.id}}var b;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function a(c){const g=c;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}function m(c){const g=c;return!!(g&&typeof g=="object"&&L.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}class p{constructor(g,w,D,_,C){this._id=g,this._transient=D,this._configuration=_,this._ignorePathCasing=C,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=w}update(g){this._id=g.id,this._configuration=g.configuration,this._transient=g.transient,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g)||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class f{constructor(g,w){this.raw=w,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,k.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function i(c){return new f({uri:c,index:0,name:(0,k.basenameOrAuthority)(c)},{uri:c.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(11031,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function s(c,g){return k.extUriBiasedIgnorePathCase.isEqualOrParent(c,g.untitledWorkspacesHome)}function t(c){let g;return L.URI.isUri(c)?g=c:g=c.configuration,g?.scheme===v.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(c){return c.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function n(c,g){return!s(c,g)&&!t(c)}function h(c){return(typeof c=="string"?(0,d.extname)(c):(0,k.extname)(c))===e.WORKSPACE_SUFFIX}}),define(Ce[150],Ie([1,0,60,4,3,22,2,8,144,27,5,11,47,28,245,7,32,12,17]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=s,e.reviveProfile=t,e.toUserDataProfile=o;var i;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(c){const g=c;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&L.URI.isUri(g.location)&&L.URI.isUri(g.globalStorageHome)&&L.URI.isUri(g.settingsResource)&&L.URI.isUri(g.keybindingsResource)&&L.URI.isUri(g.tasksResource)&&L.URI.isUri(g.snippetsHome)&&L.URI.isUri(g.extensionsResource))}e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function t(c,g){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:L.URI.revive(c.location).with({scheme:g}),globalStorageHome:L.URI.revive(c.globalStorageHome).with({scheme:g}),settingsResource:L.URI.revive(c.settingsResource).with({scheme:g}),keybindingsResource:L.URI.revive(c.keybindingsResource).with({scheme:g}),tasksResource:L.URI.revive(c.tasksResource).with({scheme:g}),snippetsHome:L.URI.revive(c.snippetsHome).with({scheme:g}),extensionsResource:L.URI.revive(c.extensionsResource).with({scheme:g}),cacheHome:L.URI.revive(c.cacheHome).with({scheme:g}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}function o(c,g,w,D,_,C){return{id:c,name:g,location:w,isDefault:!1,shortName:_?.shortName,icon:_?.icon,globalStorageHome:C&&_?.useDefaultFlags?.globalState?C.globalStorageHome:(0,k.joinPath)(w,"globalStorage"),settingsResource:C&&_?.useDefaultFlags?.settings?C.settingsResource:(0,k.joinPath)(w,"settings.json"),keybindingsResource:C&&_?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,k.joinPath)(w,"keybindings.json"),tasksResource:C&&_?.useDefaultFlags?.tasks?C.tasksResource:(0,k.joinPath)(w,"tasks.json"),snippetsHome:C&&_?.useDefaultFlags?.snippets?C.snippetsHome:(0,k.joinPath)(w,"snippets"),extensionsResource:C&&_?.useDefaultFlags?.extensions?C.extensionsResource:(0,k.joinPath)(w,"extensions.json"),cacheHome:(0,k.joinPath)(D,c),useDefaultFlags:_?.useDefaultFlags,isTransient:_?.transient}}let n=class extends P.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(g,w,D,_){super(),this.environmentService=g,this.fileService=w,this.uriIdentityService=D,this.logService=_,this.enabled=!0,this._onDidChangeProfiles=this._register(new d.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new d.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new d.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new d.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new T.ResourceMap,workspaces:new T.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,k.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(g){this.enabled!==g&&(this._profilesObject=void 0,this.enabled=g)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const g=this.createDefaultProfile(),w=[g];if(this.enabled)try{for(const C of this.getStoredProfiles()){if(!C.name||!(0,f.isString)(C.name)||!C.location){this.logService.warn("Skipping the invalid stored profile",C.location||C.name);continue}w.push(o((0,k.basename)(C.location),C.name,C.location,this.profilesCacheHome,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},g))}}catch(C){this.logService.error(C)}const D=new T.ResourceMap,_=new Map;if(w.length)try{const C=this.getStoredProfileAssociations();if(C.workspaces)for(const[A,E]of Object.entries(C.workspaces)){const S=L.URI.parse(A),F=w.find(N=>N.id===E);F&&D.set(S,F)}if(C.emptyWindows)for(const[A,E]of Object.entries(C.emptyWindows)){const S=w.find(F=>F.id===E);S&&_.set(A,S)}}catch(C){this.logService.error(C)}this._profilesObject={profiles:w,workspaces:D,emptyWindows:_}}return this._profilesObject}createDefaultProfile(){const g=o("__default__profile__",(0,R.localize)(11078,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...g,extensionsResource:this.getDefaultProfileExtensionsLocation()??g.extensionsResource,isDefault:!0}}async createTransientProfile(g){const w="Temp",D=new RegExp(`${(0,p.escapeRegExpCharacters)(w)}\\s(\\d+)`);let _=0;for(const A of this.profiles){const E=D.exec(A.name),S=E?parseInt(E[1]):0;_=S>_?S:_}const C=`${w} ${_+1}`;return this.createProfile((0,r.hash)((0,m.generateUuid)()).toString(16),C,{transient:!0},g)}async createNamedProfile(g,w,D){return this.createProfile((0,r.hash)((0,m.generateUuid)()).toString(16),g,w,D)}async createProfile(g,w,D,_){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const C=await this.doCreateProfile(g,w,D);return _&&await this.setProfileForWorkspace(_,C),C}async doCreateProfile(g,w,D){if(!(0,f.isString)(w)||!w)throw new Error("Name of the profile is mandatory and must be of type `string`");let _=this.profileCreationPromises.get(w);return _||(_=(async()=>{try{if(this.profiles.find(S=>S.name===w||S.id===g))throw new Error(`Profile with ${w} name already exists`);const A=o(g,w,(0,k.joinPath)(this.profilesHome,g),this.profilesCacheHome,D,this.defaultProfile);await this.fileService.createFolder(A.location);const E=[];return this._onWillCreateProfile.fire({profile:A,join(S){E.push(S)}}),await a.Promises.settled(E),this.updateProfiles([A],[],[]),A}finally{this.profileCreationPromises.delete(w)}})(),this.profileCreationPromises.set(w,_)),_}async updateProfile(g,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(_=>_.id===g.id);if(!D)throw new Error(`Profile '${g.name}' does not exist`);return D=o(D.id,w.name??D.name,D.location,this.profilesCacheHome,{shortName:w.shortName??D.shortName,icon:w.icon===null?void 0:w.icon??D.icon,transient:w.transient??D.isTransient,useDefaultFlags:w.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[D]),D}async removeProfile(g){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(g.isDefault)throw new Error("Cannot remove default profile");const w=this.profiles.find(_=>_.id===g.id);if(!w)throw new Error(`Profile '${g.name}' does not exist`);const D=[];this._onWillRemoveProfile.fire({profile:w,join(_){D.push(_)}});try{await Promise.allSettled(D)}catch(_){this.logService.error(_)}for(const _ of[...this.profilesObject.emptyWindows.keys()])w.id===this.profilesObject.emptyWindows.get(_)?.id&&this.profilesObject.emptyWindows.delete(_);for(const _ of[...this.profilesObject.workspaces.keys()])w.id===this.profilesObject.workspaces.get(_)?.id&&this.profilesObject.workspaces.delete(_);this.updateStoredProfileAssociations(),this.updateProfiles([],[w],[]);try{await this.fileService.del(w.cacheHome,{recursive:!0})}catch(_){(0,l.toFileOperationResult)(_)!==l.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(_)}}async setProfileForWorkspace(g,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(_=>_.id===w.id);if(!D)throw new Error(`Profile '${w.name}' does not exist`);this.updateWorkspaceAssociation(g,D)}unsetWorkspace(g,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(g,void 0,w)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const g=await this.fileService.resolve(this.profilesHome);await Promise.all((g.children||[]).filter(w=>w.isDirectory&&this.profiles.every(D=>!this.uriIdentityService.extUri.isEqual(D.location,w.resource))).map(w=>this.fileService.del(w.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const g=this.transientProfilesObject.profiles.filter(w=>!this.isProfileAssociatedToWorkspace(w));await Promise.allSettled(g.map(w=>this.removeProfile(w)))}getProfileForWorkspace(g){const w=this.getWorkspace(g),D=L.URI.isUri(w)?this.profilesObject.workspaces.get(w):this.profilesObject.emptyWindows.get(w);return D||((0,u.isSingleFolderWorkspaceIdentifier)(g)?this.transientProfilesObject.folders.get(g.uri):(0,u.isWorkspaceIdentifier)(g)?this.transientProfilesObject.workspaces.get(g.configPath):this.transientProfilesObject.emptyWindows.get(g.id))}getWorkspace(g){return(0,u.isSingleFolderWorkspaceIdentifier)(g)?g.uri:(0,u.isWorkspaceIdentifier)(g)?g.configPath:g.id}isProfileAssociatedToWorkspace(g){return!!([...this.profilesObject.emptyWindows.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,g.location))||[...this.profilesObject.workspaces.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,g.location))||[...this.transientProfilesObject.emptyWindows.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,g.location))||[...this.transientProfilesObject.workspaces.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,g.location))||[...this.transientProfilesObject.folders.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,g.location)))}updateProfiles(g,w,D){const _=[...this.profiles,...g],C=[],A=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let E of _){if(E.isDefault||w.some(F=>E.id===F.id))continue;E=D.find(F=>E.id===F.id)??E;const S=A.find(F=>E.id===F.id);if(E.isTransient)this.transientProfilesObject.profiles.push(E);else{if(S){for(const[F,N]of this.transientProfilesObject.emptyWindows.entries())if(E.id===N.id){this.updateWorkspaceAssociation({id:F},E);break}for(const[F,N]of this.transientProfilesObject.workspaces.entries())if(E.id===N.id){this.updateWorkspaceAssociation({id:"",configPath:F},E);break}for(const[F,N]of this.transientProfilesObject.folders.entries())if(E.id===N.id){this.updateWorkspaceAssociation({id:"",uri:F},E);break}}C.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags})}}this.saveStoredProfiles(C),this._profilesObject=void 0,this.triggerProfilesChanges(g,w,D)}triggerProfilesChanges(g,w,D){this._onDidChangeProfiles.fire({added:g,removed:w,updated:D,all:this.profiles})}updateWorkspaceAssociation(g,w,D){if(D=w?.isTransient?!0:D,D)(0,u.isSingleFolderWorkspaceIdentifier)(g)?(this.transientProfilesObject.folders.delete(g.uri),w&&this.transientProfilesObject.folders.set(g.uri,w)):(0,u.isWorkspaceIdentifier)(g)?(this.transientProfilesObject.workspaces.delete(g.configPath),w&&this.transientProfilesObject.workspaces.set(g.configPath,w)):(this.transientProfilesObject.emptyWindows.delete(g.id),w&&this.transientProfilesObject.emptyWindows.set(g.id,w));else{this.updateWorkspaceAssociation(g,void 0,!0);const _=this.getWorkspace(g);L.URI.isUri(_)?(this.profilesObject.workspaces.delete(_),w&&this.profilesObject.workspaces.set(_,w)):(this.profilesObject.emptyWindows.delete(_),w&&this.profilesObject.emptyWindows.set(_,w)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const g={};for(const[D,_]of this.profilesObject.workspaces.entries())g[D.toString()]=_.id;const w={};for(const[D,_]of this.profilesObject.emptyWindows.entries())w[D.toString()]=_.id;this.saveStoredProfileAssociations({workspaces:g,emptyWindows:w}),this._profilesObject=void 0}migrateStoredProfileAssociations(g){const w={},D=this.createDefaultProfile();if(g.workspaces)for(const[C,A]of Object.entries(g.workspaces)){const E=L.URI.parse(A);w[C]=this.uriIdentityService.extUri.isEqual(E,D.location)?D.id:this.uriIdentityService.extUri.basename(E)}const _={};if(g.emptyWindows)for(const[C,A]of Object.entries(g.emptyWindows)){const E=L.URI.parse(A);_[C]=this.uriIdentityService.extUri.isEqual(E,D.location)?D.id:this.uriIdentityService.extUri.basename(E)}return{workspaces:w,emptyWindows:_}}getStoredProfiles(){return[]}saveStoredProfiles(g){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(g){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=n,e.UserDataProfilesService=n=Xe([He(0,v.IEnvironmentService),He(1,l.IFileService),He(2,b.IUriIdentityService),He(3,y.ILogService)],n);class h extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(g){this.storedProfiles=g}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(g){this.storedProfileAssociations=g}}e.InMemoryUserDataProfilesService=h}),define(Ce[151],Ie([1,0,7,4,3,61,17,193,5,150]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=T,e.isProfileUsingDefaultStorage=a,e.logStorage=p,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var I;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var u;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function T(f){const i=f.get(e.TARGET_KEY);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class b extends P.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(i={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super(),this.options=i,this._onDidChangeValue=this._register(new d.PauseableEmitter),this._onDidChangeTarget=this._register(new d.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new d.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new r.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(i,s,t){return d.Event.filter(this._onDidChangeValue.event,o=>o.scope===i&&(s===void 0||o.key===s),t)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,r.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(i,s){const{key:t,external:o}=s;if(t===e.TARGET_KEY){switch(i){case y.APPLICATION:this._applicationKeyTargets=void 0;break;case y.PROFILE:this._profileKeyTargets=void 0;break;case y.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:i})}else this._onDidChangeValue.fire({scope:i,key:t,target:this.getKeyTargets(i)[t],external:o})}emitWillSaveState(i){this._onWillSaveState.fire({reason:i})}get(i,s,t){return this.getStorage(s)?.get(i,t)}getBoolean(i,s,t){return this.getStorage(s)?.getBoolean(i,t)}getNumber(i,s,t){return this.getStorage(s)?.getNumber(i,t)}getObject(i,s,t){return this.getStorage(s)?.getObject(i,t)}storeAll(i,s){this.withPausedEmitters(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,s)})}store(i,s,t,o,n=!1){if((0,L.isUndefinedOrNull)(s)){this.remove(i,t,n);return}this.withPausedEmitters(()=>{this.updateKeyTarget(i,t,o),this.getStorage(t)?.set(i,s,n)})}remove(i,s,t=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(i,s,void 0),this.getStorage(s)?.delete(i,t)})}withPausedEmitters(i){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{i()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(i,s){const t=[],o=this.getKeyTargets(i);for(const n of Object.keys(o))o[n]===s&&t.push(n);return t}updateKeyTarget(i,s,t,o=!1){const n=this.getKeyTargets(s);typeof t=="number"?n[i]!==t&&(n[i]=t,this.getStorage(s)?.set(e.TARGET_KEY,JSON.stringify(n),o)):typeof n[i]=="number"&&(delete n[i],this.getStorage(s)?.set(e.TARGET_KEY,JSON.stringify(n),o))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(y.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(y.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(y.APPLICATION)),this._applicationKeyTargets}getKeyTargets(i){switch(i){case y.APPLICATION:return this.applicationKeyTargets;case y.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(i){const s=this.getStorage(i);return s?T(s):Object.create(null)}isNew(i){return this.getBoolean(e.IS_NEW_KEY,i)===!0}async flush(i=I.NONE){this._onWillSaveState.fire({reason:i});const s=this.getStorage(y.APPLICATION),t=this.getStorage(y.PROFILE),o=this.getStorage(y.WORKSPACE);switch(i){case I.NONE:await r.Promises.settled([s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.getStorage(y.APPLICATION)?.items??new Map,s=this.getStorage(y.PROFILE)?.items??new Map,t=this.getStorage(y.WORKSPACE)?.items??new Map;return p(i,s,t,this.getLogDetails(y.APPLICATION)??"",this.getLogDetails(y.PROFILE)??"",this.getLogDetails(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.getStorage(i)?.optimize()}async switch(i,s){return this.emitWillSaveState(I.NONE),(0,l.isUserDataProfile)(i)?this.switchToProfile(i,s):this.switchToWorkspace(i,s)}canSwitchProfile(i,s){return!(i.id===s.id||a(s)&&a(i))}switchData(i,s,t){this.withPausedEmitters(()=>{const o=new Set;for(const[n,h]of i)o.add(n),s.get(n)!==h&&this.emitDidChangeValue(t,{key:n,external:!0});for(const[n]of s.items)o.has(n)||this.emitDidChangeValue(t,{key:n,external:!0})})}}e.AbstractStorageService=b;function a(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class m extends b{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(i=>this.emitDidChangeValue(y.WORKSPACE,i))),this._register(this.profileStorage.onDidChangeStorage(i=>this.emitDidChangeValue(y.PROFILE,i))),this._register(this.applicationStorage.onDidChangeStorage(i=>this.emitDidChangeValue(y.APPLICATION,i)))}getStorage(i){switch(i){case y.APPLICATION:return this.applicationStorage;case y.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(i){return!1}}e.InMemoryStorageService=m;async function p(f,i,s,t,o,n){const h=S=>{try{return JSON.parse(S)}catch{return S}},c=new Map,g=new Map;f.forEach((S,F)=>{c.set(F,S),g.set(F,h(S))});const w=new Map,D=new Map;i.forEach((S,F)=>{w.set(F,S),D.set(F,h(S))});const _=new Map,C=new Map;s.forEach((S,F)=>{_.set(F,S),C.set(F,h(S))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const A=[];if(c.forEach((S,F)=>{A.push({key:F,value:S})}),console.table(A),console.groupEnd(),console.log(g),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const S=[];w.forEach((F,N)=>{S.push({key:N,value:F})}),console.table(S),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${n})`);const E=[];_.forEach((S,F)=>{E.push({key:F,value:S})}),console.table(E),console.groupEnd(),console.log(C)}}),define(Ce[118],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{static{this.enableDebugLogging=!1}constructor(P){this.id=P,this._data=new Map,this._idPool=1}add(P){const k=this._idPool++;return this._data.set(k,P),this.logDebugInfo(),k}get(P,k){return this._data.has(P)?this._data.get(P)[k]:void 0}delete(P){this._data.delete(P),this.logDebugInfo()}logDebugInfo(){r.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r}),define(Ce[62],Ie([1,0,14,22,27,5]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new d.ExtUri(v=>{const l=this._providerInfo.get(v.scheme);return!(l===void 0||l&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(v,l){l===null?this._providerInfo.delete(v.scheme):this._providerInfo.set(v.scheme,l)}isFreeScheme(v){return!this._providerInfo.has(v)&&!this._systemSchemes.has(v)}getCapabilities(v){return this._providerInfo.get(v)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[29],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ce[248],Ie([1,0,8,11,228,29]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends P.LogService{constructor(v,l,I){const y=I.remote.isRemote?"remoteexthost":v?"workerexthost":"exthost",u=I.remote.isRemote?(0,r.localize)(10830,null):v?(0,r.localize)(10831,null):(0,r.localize)(10832,null);super(l.createLogger(y,{name:u}))}};e.ExtHostLogService=L,e.ExtHostLogService=L=Xe([He(1,d.ILoggerService),He(2,k.IExtHostInitDataService)],L)}),define(Ce[249],Ie([1,0,7]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class d{constructor(L,R,v){this._deferredPromises=new Map,this._id=L,this._shared=R,this._storage=v,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(l=>(this._value=l,this)),this._storageListener=this._storage.onDidChangeStorage(l=>{l.shared===this._shared&&l.key===this._id&&(this._value=l.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const l=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const I of l.values())I.complete()}catch(I){for(const y of l.values())y.error(I)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this._init}get(L,R){let v=this._value[L];return typeof v>"u"&&(v=R),v}update(L,R){this._value[L]=R;const v=this._deferredPromises.get(L);if(v!==void 0)return v.p;const l=new r.DeferredPromise;return this._deferredPromises.set(L,l),this._scheduler.isScheduled()||this._scheduler.schedule(),l.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=d;class P extends d{setKeysForSync(L){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},L)}constructor(L,R){super(L.identifier.value,!0,R),this._extension=L}}e.ExtensionGlobalMemento=P}),define(Ce[250],Ie([1,0,4,2]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class P{constructor(L){this._notebooksAndEditors=L,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new r.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(L,R,v,l){const y=this._notebooksAndEditors.getNotebookDocument(d.URI.revive(L)).acceptModelChanged(R.value,v,l);this._onDidChangeNotebookDocument.fire(y)}$acceptDirtyStateChanged(L,R){this._notebooksAndEditors.getNotebookDocument(d.URI.revive(L)).acceptDirty(R)}$acceptModelSaved(L){const R=this._notebooksAndEditors.getNotebookDocument(d.URI.revive(L));this._onDidSaveNotebookDocument.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=P}),define(Ce[19],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class d{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.dispose=k.dispose.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.ExtHostRpcService=d}),define(Ce[251],Ie([1,0,23,4,3]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class k{#e;constructor(R,v){this.disposables=new P.DisposableStore,this._id=r.ExtensionIdentifier.toKey(R.identifier),this.#e=v,this.onDidChange=d.Event.map(d.Event.filter(this.#e.onDidChangePassword,l=>l.extensionId===this._id),l=>({key:l.key}),this.disposables)}dispose(){this.disposables.dispose()}get(R){return this.#e.get(this._id,R)}store(R,v){return this.#e.store(this._id,R,v)}delete(R){return this.#e.delete(this._id,R)}}e.ExtensionSecrets=k}),define(Ce[72],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class d{constructor(k){k?(this.transformIncoming=k.transformIncoming.bind(k),this.transformOutgoing=k.transformOutgoing.bind(k),this.transformOutgoingURI=k.transformOutgoingURI.bind(k),this.transformOutgoingScheme=k.transformOutgoingScheme.bind(k)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.URITransformerService=d}),define(Ce[252],Ie([1,0,253,362,363,67,2,11,364]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=I,r=$e(r),d=$e(d),P=$e(P),k=$e(k);const l=!1;function I(i,s,t,o,n,h){const c=h.environment.useHostProxy,g=typeof c=="boolean"?c:!h.remote.isRemote,w={resolveProxy:C=>i.resolveProxy(C),lookupProxyAuthorization:m.bind(void 0,i,o,n,s,{},{},h.remote.isRemote,g),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>s.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>u(s),addCertificatesV2:()=>T(s),log:o,getLogLevel:()=>{const C=o.getLevel();switch(C){case R.LogLevel.Trace:return v.LogLevel.Trace;case R.LogLevel.Debug:return v.LogLevel.Debug;case R.LogLevel.Info:return v.LogLevel.Info;case R.LogLevel.Warning:return v.LogLevel.Warning;case R.LogLevel.Error:return v.LogLevel.Error;case R.LogLevel.Off:return v.LogLevel.Off;default:return A(C)}function A(E){return o.error("Unknown log level",E),v.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:g,loadAdditionalCertificates:async()=>{const C=[];if(h.remote.isRemote&&C.push((0,v.loadSystemCertificates)({log:o})),g){o.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const A=i.loadCertificates();A.then(E=>o.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),C.push(A)}return h.environment.extensionTestsLocationURI&&d.globalAgent.testCertificates?.length&&(o.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),C.push(Promise.resolve(d.globalAgent.testCertificates))),(await Promise.all(C)).flat()},env:process.env},D=(0,v.createProxyResolver)(w),_=y(w,D);return a(t,_)}function y(i,s){function t(o,n){return Object.assign(o.default||o,n)}return{http:t(r,(0,v.createHttpPatch)(i,r,s)),https:t(d,(0,v.createHttpPatch)(i,d,s)),net:t(k,(0,v.createNetPatch)(i,k)),tls:t(P,(0,v.createTlsPatch)(i,P))}}function u(i){const s=i.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",l)&&!!s.get("systemCertificates")}function T(i){const s=i.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",l)&&!!s.get("systemCertificates")}const b=new Map;function a(i,s){return i.getExtensionPathIndex().then(t=>{const o=globalThis._VSCODE_NODE_MODULES.module,n=o._load;o._load=function(c,g,w){if(c==="net")return s.net;if(c==="tls")return s.tls;if(c!=="http"&&c!=="https")return n.apply(this,arguments);const D=t.findSubstr(L.URI.file(g.filename));let _=b.get(D);if(_||b.set(D,_={}),!_[c]){const C=s[c];_[c]={...C}}return _[c]}})}async function m(i,s,t,o,n,h,c,g,w,D,_){const C=n[w];D&&(n[w]=D),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${w}`,`proxyAuthenticate:${D}`,`proxyAuthenticateCache:${C}`);const A=D||C,E=Array.isArray(A)?A:typeof A=="string"?[A]:[];if(f(t,E,c),E.some(F=>/^(Negotiate|Kerberos)( |$)/i.test(F))&&!_.kerberosRequested){_.kerberosRequested=!0;try{const F=await new Promise((x,z)=>{pe(["kerberos"],x,z)}).then($e),N=new URL(w),O=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${N.hostname}`:`HTTP@${N.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${w}`,`spn:${O}`),"Negotiate "+await(await F.initializeClient(O)).step("")}catch(F){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",F)}if(c&&g){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup on host",`proxyURL:${w}`);const F=await i.lookupKerberosAuthorization(w);if(F)return"Negotiate "+F}}const S=E.find(F=>/^Basic( |$)/i.test(F));if(S)try{const F=h[w];if(F)if(_.basicAuthCacheUsed)s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication deleting cached credentials",`proxyURL:${w}`),delete h[w];else return s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication using cached credentials",`proxyURL:${w}`),_.basicAuthCacheUsed=!0,F;_.basicAuthAttempt=(_.basicAuthAttempt||0)+1;const N=/ realm="([^"]+)"/i.exec(S)?.[1];s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication lookup",`proxyURL:${w}`,`realm:${N}`);const O=new URL(w),M={scheme:"basic",host:O.hostname,port:Number(O.port),realm:N||"",isProxy:!0,attempt:_.basicAuthAttempt},U=await i.lookupAuthorization(M);if(U){s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received credentials",`proxyURL:${w}`,`realm:${N}`);const x="Basic "+Buffer.from(`${U.username}:${U.password}`).toString("base64");return h[w]=x,x}else s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received no credentials",`proxyURL:${w}`,`realm:${N}`)}catch(F){s.error("ProxyResolver#lookupProxyAuthorization Basic authentication failed",F)}}let p=!1;function f(i,s,t){p||!s.length||(p=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(o=>o.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(Ce[254],Ie([1,0,138]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=P;function d(k){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:k,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function P(k){return new r.URITransformer(d(k))}});var Wt=this&&this.__importDefault||function(pe){return pe&&pe.__esModule?pe:{default:pe}};define(Ce[152],Ie([1,0,8,17,2,3,5,36,27,14,52,211,43]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=a,e.isEditorPaneWithScrolling=m,e.findViewStateForEditor=p,e.isResourceEditorInput=f,e.isResourceDiffEditorInput=i,e.isResourceMultiDiffEditorInput=s,e.isResourceSideBySideEditorInput=t,e.isUntitledResourceEditorInput=o,e.isResourceMergeEditorInput=n,e.isEditorInput=_,e.isSideBySideEditorInput=A,e.isDiffEditorInput=E,e.createTooLargeFileError=S,e.isEditorInputWithOptions=F,e.isEditorInputWithOptionsAndGroup=N,e.isEditorIdentifier=O,e.isEditorCommandsContext=M,e.preventEditorClose=V,e.pathsToEditors=Z,e.isTextEditorViewState=ne,e.isEditorOpenError=_e,e.createEditorOpenError=ge,u=Wt(u),e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(12474,null),providerDisplayName:(0,r.localize)(12475,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var T;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(T||(e.EditorPaneSelectionChangeReason=T={}));var b;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function a(Y){const W=Y;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function m(Y){const W=Y;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function p(Y,W,oe){for(const Se of oe.visibleEditorPanes)if(Se.group.id===W&&Y.matches(Se.input))return Se.getViewState()}function f(Y){if(_(Y))return!1;const W=Y;return P.URI.isUri(W?.resource)}function i(Y){if(_(Y))return!1;const W=Y;return W?.original!==void 0&&W.modified!==void 0}function s(Y){if(_(Y))return!1;const W=Y;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function t(Y){if(_(Y)||i(Y))return!1;const W=Y;return W?.primary!==void 0&&W.secondary!==void 0}function o(Y){if(_(Y))return!1;const W=Y;return W?W.resource===void 0||W.resource.scheme===l.Schemas.untitled||W.forceUntitled===!0:!1}function n(Y){if(_(Y))return!1;const W=Y;return P.URI.isUri(W?.base?.resource)&&P.URI.isUri(W?.input1?.resource)&&P.URI.isUri(W?.input2?.resource)&&P.URI.isUri(W?.result?.resource)}var h;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var c;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class g{constructor(){this.mapIdToSaveSource=new Map}registerSource(W,oe){let Se=this.mapIdToSaveSource.get(W);return Se||(Se={source:W,label:oe},this.mapIdToSaveSource.set(W,Se)),Se.source}getSourceLabel(W){return this.mapIdToSaveSource.get(W)?.label??W}}e.SaveSourceRegistry=new g;var w;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(w||(e.EditorInputCapabilities=w={}));class D extends k.Disposable{}e.AbstractEditorInput=D;function _(Y){return Y instanceof D}function C(Y){const W=Y;return P.URI.isUri(W?.preferredResource)}function A(Y){const W=Y;return _(W?.primary)&&_(W?.secondary)}function E(Y){const W=Y;return _(W?.modified)&&_(W?.original)}function S(Y,W,oe,Se,te){return ge(Se,[(0,y.toAction)({id:"workbench.action.openLargeFile",label:(0,r.localize)(12476,null),run:()=>{const ae={...oe,limits:{size:Number.MAX_VALUE}};Y.openEditor(W,ae)}}),(0,y.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(12477,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function F(Y){return _(Y?.editor)}function N(Y){const W=Y;return F(Y)&&W?.group!==void 0}function O(Y){const W=Y;return typeof W?.groupId=="number"&&_(W.editor)}function M(Y){return typeof Y?.groupId=="number"}var U;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var x;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(x||(e.GroupModelChangeKind=x={}));var z;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class B{getOriginalUri(W,oe){if(!W)return;if(n(W))return e.EditorResourceAccessor.getOriginalUri(W.result,oe);if(oe?.supportSideBySide){const{primary:te,secondary:ae}=this.getSideEditors(W);if(te&&ae){if(oe?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===z.ANY)return this.getOriginalUri(te,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme});W=oe.supportSideBySide===z.PRIMARY?te:ae}}if(i(W)||s(W)||t(W)||n(W))return;const Se=C(W)?W.preferredResource:W.resource;return!Se||!oe||!oe.filterByScheme?Se:this.filterUri(Se,oe.filterByScheme)}getSideEditors(W){return A(W)||t(W)?{primary:W.primary,secondary:W.secondary}:E(W)||i(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,oe){if(!W)return;if(n(W))return e.EditorResourceAccessor.getCanonicalUri(W.result,oe);if(oe?.supportSideBySide){const{primary:te,secondary:ae}=this.getSideEditors(W);if(te&&ae){if(oe?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===z.ANY)return this.getCanonicalUri(te,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme});W=oe.supportSideBySide===z.PRIMARY?te:ae}}if(i(W)||s(W)||t(W)||n(W))return;const Se=W.resource;return!Se||!oe||!oe.filterByScheme?Se:this.filterUri(Se,oe.filterByScheme)}filterUri(W,oe){if(Array.isArray(oe)){if(oe.some(Se=>W.scheme===Se))return W}else if(oe===W.scheme)return W}}var ee;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ee||(e.EditorCloseMethod=ee={}));function V(Y,W,oe,Se){if(!Y.isSticky(W))return!1;switch(Se.preventPinnedEditorClose){case"keyboardAndMouse":return oe===ee.MOUSE||oe===ee.KEYBOARD;case"mouse":return oe===ee.MOUSE;case"keyboard":return oe===ee.KEYBOARD}return!1}e.EditorResourceAccessor=new B;var $;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})($||(e.CloseDirection=$={}));class G{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(W){const oe=this.instantiationService=W.get(L.IInstantiationService);for(const[Se,te]of this.editorSerializerConstructors)this.createEditorSerializer(Se,te,oe);this.editorSerializerConstructors.clear()}createEditorSerializer(W,oe,Se){const te=Se.createInstance(oe);this.editorSerializerInstances.set(W,te)}registerFileEditorFactory(W){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=W}getFileEditorFactory(){return(0,d.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(W,oe){if(this.editorSerializerConstructors.has(W)||this.editorSerializerInstances.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.instantiationService?this.createEditorSerializer(W,oe,this.instantiationService):this.editorSerializerConstructors.set(W,oe),(0,k.toDisposable)(()=>{this.editorSerializerConstructors.delete(W),this.editorSerializerInstances.delete(W)})}getEditorSerializer(W){return this.editorSerializerInstances.get(typeof W=="string"?W:W.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new G);async function Z(Y,W,oe){return!Y||!Y.length?[]:await Promise.all(Y.map(async Se=>{const te=P.URI.revive(Se.fileUri);if(!te){oe.info("Cannot resolve the path because it is not valid.",Se);return}if(!await W.canHandleResource(te)){oe.info("Cannot resolve the path because it cannot be handled",Se);return}let se=Se.exists,Q=Se.type;if(typeof se!="boolean"||typeof Q!="number")try{Q=(await W.stat(te)).isDirectory?v.FileType.Directory:v.FileType.Unknown,se=!0}catch(ve){oe.error(ve),se=!1}if(!se&&Se.openOnlyIfExists){oe.info("Cannot resolve the path because it does not exist",Se);return}if(Q===v.FileType.Directory){oe.info("Cannot resolve the path because it is a directory",Se);return}const re={...Se.options,pinned:!0};return se?{resource:te,options:re}:{resource:te,options:re,forceUntitled:!0}}))}var le;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function ne(Y){const W=Y;if(!W)return!1;const oe=W;if(oe.modified)return ne(oe.modified);const Se=W;return!!(Se.contributionsState&&Se.viewState&&Array.isArray(Se.cursorState))}function _e(Y){return(0,I.isErrorWithActions)(Y)}function ge(Y,W,oe){const Se=(0,I.createErrorWithActions)(Y,W);return Se.forceMessage=oe?.forceMessage,Se.forceSeverity=oe?.forceSeverity,Se.allowDialog=oe?.allowDialog,Se}}),define(Ce[255],Ie([1,0,4,8,5,3,28,36,24,82,244]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=T,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,d.localize)(12314,null),e.defaultViewIcon=(0,I.registerIcon)("default-view-icon",l.Codicon.window,(0,d.localize)(12315,null));var y;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.ViewContainerLocations=[u.Sidebar,u.Panel,u.AuxiliaryBar];function T(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class b extends k.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new r.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new r.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return[...this.viewContainers.values()].flat()}registerViewContainer(n,h,c){const g=this.get(n.id);if(g)return g;const w=n;return w.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:w.openCommandActionDescriptor??{id:w.id},(0,L.getOrSet)(this.viewContainers,h,[]).push(w),c?.isDefault&&this.defaultViewContainers.push(w),this._onDidRegister.fire({viewContainer:w,viewContainerLocation:h}),w}deregisterViewContainer(n){for(const h of this.viewContainers.keys()){const c=this.viewContainers.get(h),g=c?.indexOf(n);if(g!==-1){c?.splice(g,1),c.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:n,viewContainerLocation:h});return}}}get(n){return this.all.filter(h=>h.id===n)[0]}getViewContainers(n){return[...this.viewContainers.get(n)||[]]}getViewContainerLocation(n){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(c=>c?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===n)}}R.Registry.add(y.ViewContainersRegistry,new b);var a;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(a||(e.ViewContentGroups=a={}));function m(o,n){const h=o.group??a.More,c=n.group??a.More;return h!==c?h.localeCompare(c):(o.order??5)-(n.order??5)}class p extends k.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new r.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new r.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new r.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new r.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new L.SetMap}registerViews(n,h){this.registerViews2([{views:n,viewContainer:h}])}registerViews2(n){n.forEach(({views:h,viewContainer:c})=>this.addViews(h,c)),this._onViewsRegistered.fire(n)}deregisterViews(n,h){const c=this.removeViews(n,h);c.length&&this._onViewsDeregistered.fire({views:c,viewContainer:h})}moveViews(n,h){for(const c of this._views.keys())if(c!==h){const g=this.removeViews(n,c);g.length&&(this.addViews(g,h),this._onDidChangeContainer.fire({views:g,from:c,to:h}))}}getViews(n){return this._views.get(n)||[]}getView(n){for(const h of this._viewContainers){const c=(this._views.get(h)||[]).filter(g=>g.id===n)[0];if(c)return c}return null}getViewContainer(n){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(g=>g.id===n)[0])return h;return null}registerViewWelcomeContent(n,h){return this._viewWelcomeContents.add(n,h),this._onDidChangeViewWelcomeContent.fire(n),(0,k.toDisposable)(()=>{this._viewWelcomeContents.delete(n,h),this._onDidChangeViewWelcomeContent.fire(n)})}registerViewWelcomeContent2(n,h){const c=new Map;for(const[g,w]of h)this._viewWelcomeContents.add(n,w),c.set(g,(0,k.toDisposable)(()=>{this._viewWelcomeContents.delete(n,w),this._onDidChangeViewWelcomeContent.fire(n)}));return this._onDidChangeViewWelcomeContent.fire(n),c}getViewWelcomeContent(n){const h=[];return this._viewWelcomeContents.forEach(n,c=>h.push(c)),h.sort(m)}addViews(n,h){let c=this._views.get(h);c||(c=[],this._views.set(h,c),this._viewContainers.push(h));for(const g of n){if(this.getView(g.id)!==null)throw new Error((0,d.localize)(12316,null,g.id));c.push(g)}}removeViews(n,h){const c=this._views.get(h);if(!c)return[];const g=[],w=[];for(const D of c)n.includes(D)?g.push(D):w.push(D);return g.length&&(w.length?this._views.set(h,w):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),g}}R.Registry.add(y.ViewsRegistry,new p),e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var f;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(f||(e.ViewVisibilityState=f={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class s{constructor(n,h){this.resolved=!1,this._hasResolve=!1,(0,v.mixin)(this,n),this._hasResolve=!!h,this.resolve=async c=>{if(h&&!this.resolved){const g=await h(c);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}c.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s;class t extends Error{constructor(n){super((0,d.localize)(12317,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(Ce[256],Ie([1,0,8,35]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_IN_QUICK_CHAT=e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new d.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(8434,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new d.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(8435,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new d.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(8436,null)}),e.CONTEXT_RESPONSE_FILTERED=new d.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(8437,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new d.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(8438,null)}),e.CONTEXT_RESPONSE=new d.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,r.localize)(8439,null)}),e.CONTEXT_REQUEST=new d.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,r.localize)(8440,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new d.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(8441,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new d.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8442,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new d.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(8443,null)}),e.CONTEXT_IN_CHAT_INPUT=new d.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,r.localize)(8444,null)}),e.CONTEXT_IN_CHAT_SESSION=new d.RawContextKey("inChat",!1,{type:"boolean",description:(0,r.localize)(8445,null)}),e.CONTEXT_CHAT_ENABLED=new d.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(8446,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new d.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new d.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new d.RawContextKey("chatLocation",void 0),e.CONTEXT_IN_QUICK_CHAT=new d.RawContextKey("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(8447,null)})}),define(Ce[153],Ie([1,0,131,7,20,4,39,3,44,182,12,35,23,5,11,115,237,151,256]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0,e.getFullyQualifiedId=h,e.reviveSerializedAgent=c;var s;(function(g){g.Panel="panel",g.Terminal="terminal",g.Notebook="notebook",g.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(g){function w(D){switch(D){case"panel":return g.Panel;case"terminal":return g.Terminal;case"notebook":return g.Notebook;case"editor":return g.Editor}return g.Panel}g.fromRaw=w}(s||(e.ChatAgentLocation=s={})),e.IChatAgentService=(0,T.createDecorator)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(w){this.contextKeyService=w,this._agents=new Map,this._onDidChangeAgents=new k.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._agentCompletionProviders=new Map,this._hasDefaultAgent=f.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService)}registerAgent(w,D){if(this.getAgent(w))throw new Error(`Agent already registered: ${JSON.stringify(w)}`);const C=this,A=D.slashCommands;D={...D,get slashCommands(){return A.filter(S=>!S.when||C.contextKeyService.contextMatchesRules(y.ContextKeyExpr.deserialize(S.when)))}};const E={data:D};return this._agents.set(w,E),(0,R.toDisposable)(()=>{this._agents.delete(w),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(w,D){const _=this._agents.get(w);if(!_)throw new Error(`Unknown agent: ${JSON.stringify(w)}`);if(_.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(w)}`);return _.data.isDefault&&this._hasDefaultAgent.set(!0),_.impl=D,this._onDidChangeAgents.fire(new o(_.data,D)),(0,R.toDisposable)(()=>{_.impl=void 0,this._onDidChangeAgents.fire(void 0),_.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(w,D){w.isDynamic=!0;const _={data:w,impl:D};return this._agents.set(w.id,_),this._onDidChangeAgents.fire(new o(w,D)),(0,R.toDisposable)(()=>{this._agents.delete(w.id),this._onDidChangeAgents.fire(void 0)})}registerAgentCompletionProvider(w,D){return this._agentCompletionProviders.set(w,D),{dispose:()=>{this._agentCompletionProviders.delete(w)}}}async getAgentCompletionItems(w,D,_){return await this._agentCompletionProviders.get(w)?.(D,_)??[]}updateAgent(w,D){const _=this._agents.get(w);if(!_?.impl)throw new Error(`No activated agent with id ${JSON.stringify(w)} registered`);_.data.metadata={..._.data.metadata,...D},this._onDidChangeAgents.fire(new o(_.data,_.impl))}getDefaultAgent(w){return(0,r.findLast)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(w))}getContributedDefaultAgent(w){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(w))}getSecondaryAgent(){return L.Iterable.find(this._agents.values(),w=>!!w.data.metadata.isSecondary)?.data}getAgent(w){if(this._agentIsEnabled(w))return this._agents.get(w)?.data}_agentIsEnabled(w){const D=this._agents.get(w);return!D?.data.when||this.contextKeyService.contextMatchesRules(y.ContextKeyExpr.deserialize(D.data.when))}getAgentByFullyQualifiedId(w){const D=L.Iterable.find(this._agents.values(),_=>h(_.data)===w)?.data;if(!(D&&!this._agentIsEnabled(D.id)))return D}getAgents(){return Array.from(this._agents.values()).map(w=>w.data).filter(w=>this._agentIsEnabled(w.id))}getActivatedAgents(){return Array.from(this._agents.values()).filter(w=>!!w.impl).filter(w=>this._agentIsEnabled(w.data.id)).map(w=>new o(w.data,w.impl))}getAgentsByName(w){return this.getAgents().filter(D=>D.name===w)}agentHasDupeName(w){const D=this.getAgent(w);return D?this.getAgentsByName(D.name).filter(_=>_.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(w,D,_,C,A){const E=this._agents.get(w);if(!E?.impl)throw new Error(`No activated agent with id "${w}"`);return await E.impl.invoke(D,_,C,A)}async getFollowups(w,D,_,C,A){const E=this._agents.get(w);if(!E?.impl)throw new Error(`No activated agent with id "${w}"`);return E.impl?.provideFollowups?E.impl.provideFollowups(D,_,C,A):[]}};e.ChatAgentService=t,e.ChatAgentService=t=Xe([He(0,y.IContextKeyService)],t);class o{constructor(w,D){this.data=w,this.impl=D}get id(){return this.data.id}get name(){return this.data.name??""}get fullName(){return this.data.fullName??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.publisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get locations(){return this.data.locations}async invoke(w,D,_,C){return this.impl.invoke(w,D,_,C)}async provideFollowups(w,D,_,C){return this.impl.provideFollowups?this.impl.provideFollowups(w,D,_,C):[]}provideWelcomeMessage(w,D){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(w,D)}provideSampleQuestions(w,D){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(w,D)}}e.MergedChatAgent=o,e.IChatAgentNameService=(0,T.createDecorator)("chatAgentNameService");let n=class{static{i=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(w,D,_,C){if(this.requestService=D,this.logService=_,this.storageService=C,this.registry=(0,l.observableValue)(this,Object.create(null)),this.disposed=!1,!w.chatParticipantRegistry)return;this.url=w.chatParticipantRegistry;const A=C.get(i.StorageKey,p.StorageScope.APPLICATION);try{this.registry.set(JSON.parse(A??"{}"),void 0)}catch{C.remove(i.StorageKey,p.StorageScope.APPLICATION)}this.refresh()}refresh(){this.disposed||this.update().catch(w=>this.logService.warn("Failed to fetch chat participant registry",w)).then(()=>(0,d.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const w=await this.requestService.request({type:"GET",url:this.url},P.CancellationToken.None);if(w.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,m.asJson)(w);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const _=D.restrictedChatParticipants;this.registry.set(_,void 0),this.storageService.store(i.StorageKey,JSON.stringify(_),p.StorageScope.APPLICATION,p.StorageTarget.MACHINE)}getAgentNameRestriction(w){const D=this.checkAgentNameRestriction(w.name,w).get(),_=!w.fullName||this.checkAgentNameRestriction(w.fullName.replace(/\s/g,""),w).get();return D&&_}checkAgentNameRestriction(w,D){return this.registry.map(C=>C[w.toLowerCase()]).map(C=>C?C.some(A=>(0,I.equalsIgnoreCase)(A,A.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=n,e.ChatAgentNameService=n=i=Xe([He(0,a.IProductService),He(1,m.IRequestService),He(2,b.ILogService),He(3,p.IStorageService)],n);function h(g){return`${g.extensionId.value}.${g.id}`}function c(g){const w="name"in g?g:{...g,name:g.id};return"extensionPublisherId"in w||(w.extensionPublisherId=w.extensionPublisher??""),"extensionDisplayName"in w||(w.extensionDisplayName=""),"extensionId"in w||(w.extensionId=new u.ExtensionIdentifier("")),(0,v.revive)(w)}}),define(Ce[257],Ie([1,0,2,30,5]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.isIDocumentContext=k,e.isIUsedContext=L;function k(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof r.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(d.Range.isIRange)}function L(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(k)}var R;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(R||(e.ChatResponseReferencePartStatusKind=R={}));var v;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(v||(e.ChatAgentVoteDirection=v={}));var l;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(l||(e.ChatCopyKind=l={})),e.IChatService=(0,P.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(Ce[154],Ie([1,0,4,7,8]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class k{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(R){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=R}onEvent(R){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=R}onRequest(R){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=R}sendResponse(R){R.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.internalSend("response",R)}sendRequest(R,v,l,I){const y={command:R};if(v&&Object.keys(v).length>0&&(y.arguments=v),this.internalSend("request",y),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const T=this.pendingRequests.get(y.seq);if(T){this.pendingRequests.delete(y.seq);const b={type:"response",seq:0,request_seq:y.seq,success:!1,command:R,message:(0,P.localize)(8147,null,I,R)};T(b)}},I)}return l&&this.pendingRequests.set(y.seq,l),y.seq}acceptMessage(R){this.messageCallback?this.messageCallback(R):(this.queue.push(R),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(R,v){return R.type!=="event"||v.type!=="event"}async processQueue(){let R;for(;this.queue.length;){if((!R||this.needsTaskBoundaryBetween(this.queue[0],R))&&await(0,d.timeout)(0),R=this.queue.shift(),!R)return;switch(R.type){case"event":this.eventCallback?.(R);break;case"request":this.requestCallback?.(R);break;case"response":{const v=R,l=this.pendingRequests.get(v.request_seq);l&&(this.pendingRequests.delete(v.request_seq),l(v));break}}}}internalSend(R,v){v.type=R,v.seq=this.sequence++,this.sendMessage(v)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const R=new Map;this.pendingRequests.forEach((v,l)=>R.set(l,v)),await(0,d.timeout)(500),R.forEach((v,l)=>{v({type:"response",seq:0,request_seq:l,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(l)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=k}),define(Ce[119],Ie([1,0,2,8,35,5]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=v,e.isFrameDeemphasized=I,d=$e(d),e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new P.RawContextKey("debugType",void 0,{type:"string",description:d.localize(8084,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new P.RawContextKey("debugConfigurationType",void 0,{type:"string",description:d.localize(8085,null)}),e.CONTEXT_DEBUG_STATE=new P.RawContextKey("debugState","inactive",{type:"string",description:d.localize(8086,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new P.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:d.localize(8087,null)}),e.CONTEXT_HAS_DEBUGGED=new P.RawContextKey("hasDebugged",!1,{type:"boolean",description:d.localize(8088,null)}),e.CONTEXT_IN_DEBUG_MODE=new P.RawContextKey("inDebugMode",!1,{type:"boolean",description:d.localize(8089,null)}),e.CONTEXT_IN_DEBUG_REPL=new P.RawContextKey("inDebugRepl",!1,{type:"boolean",description:d.localize(8090,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new P.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:d.localize(8091,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new P.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:d.localize(8092,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new P.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:d.localize(8093,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new P.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:d.localize(8094,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new P.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:d.localize(8095,null)}),e.CONTEXT_VARIABLES_FOCUSED=new P.RawContextKey("variablesFocused",!0,{type:"boolean",description:d.localize(8096,null)}),e.CONTEXT_EXPRESSION_SELECTED=new P.RawContextKey("expressionSelected",!1,{type:"boolean",description:d.localize(8097,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new P.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:d.localize(8098,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new P.RawContextKey("callStackItemType",void 0,{type:"string",description:d.localize(8099,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new P.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:d.localize(8100,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new P.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:d.localize(8101,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new P.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:d.localize(8102,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new P.RawContextKey("watchItemType",void 0,{type:"string",description:d.localize(8103,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new P.RawContextKey("canViewMemory",void 0,{type:"boolean",description:d.localize(8104,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new P.RawContextKey("breakpointItemType",void 0,{type:"string",description:d.localize(8105,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new P.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:d.localize(8106,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new P.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:d.localize(8107,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new P.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:d.localize(8108,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new P.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:d.localize(8109,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new P.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:d.localize(8110,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new P.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:d.localize(8111,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new P.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:d.localize(8112,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new P.RawContextKey("stepBackSupported",!1,{type:"boolean",description:d.localize(8113,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new P.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:d.localize(8114,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new P.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:d.localize(8115,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new P.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:d.localize(8116,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new P.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:d.localize(8117,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new P.RawContextKey("breakpointsExist",!1,{type:"boolean",description:d.localize(8118,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new P.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:d.localize(8119,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new P.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:d.localize(8120,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new P.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:d.localize(8121,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new P.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:d.localize(8122,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new P.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:d.localize(8123,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new P.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:d.localize(8124,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new P.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:d.localize(8125,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new P.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:d.localize(8126,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new P.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:d.localize(8127,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new P.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:d.localize(8128,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new P.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:d.localize(8129,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new P.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:d.localize(8130,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new P.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:d.localize(8131,null)}),e.CONTEXT_VARIABLE_VALUE=new P.RawContextKey("variableValue",!1,{type:"string",description:d.localize(8132,null)}),e.CONTEXT_VARIABLE_TYPE=new P.RawContextKey("variableType",!1,{type:"string",description:d.localize(8133,null)}),e.CONTEXT_VARIABLE_INTERFACES=new P.RawContextKey("variableInterfaces",!1,{type:"array",description:d.localize(8134,null)}),e.CONTEXT_VARIABLE_NAME=new P.RawContextKey("variableName",!1,{type:"string",description:d.localize(8135,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new P.RawContextKey("variableLanguage",!1,{type:"string",description:d.localize(8136,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new P.RawContextKey("variableExtensionId",!1,{type:"string",description:d.localize(8137,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new P.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:d.localize(8138,null)}),e.CONTEXT_MULTI_SESSION_REPL=new P.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:d.localize(8139,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new P.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:d.localize(8140,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new P.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:d.localize(8141,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new P.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:d.localize(8142,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new P.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:d.localize(8143,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new P.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:d.localize(8144,null)});const L=i=>d.localize(8145,null,i);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:d.localize(8146,null)};var R;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(R||(e.State=R={}));function v(i){switch(i){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var l;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(l||(e.MemoryRangeType=l={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function I(i){const s=i.presentationHint??i.source.presentationHint;return s==="deemphasize"||s==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var T;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(T||(e.DebuggerString=T={})),e.IDebugService=(0,k.createDecorator)("debugService");var b;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var p;(function(i){i.deserialize=s=>s,i.serialize=s=>s})(p||(e.IDebugVisualizationTreeItem=p={}));var f;(function(i){i.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:r.URI.revive(s.iconPath.light),dark:r.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),i.serialize=s=>s})(f||(e.IDebugVisualization=f={}))}),define(Ce[258],Ie([1,0,12,2,16,24,14,30,20,18]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=y,e.filterExceptionsFromTelemetry=u,e.isSessionAttach=T,e.getExtensionHostDebugSession=b,e.isDebuggerMainContribution=a,e.getExactExpressionStartAndEnd=m,e.getEvaluatableExpressionAtPosition=p,e.isUri=i,e.convertToDAPaths=o,e.convertToVSCPaths=n,e.getVisibleAndSorted=c,e.saveAllBeforeDebugStart=w;const I=/{([^}]+)}/g;function y(_,C,A){return _.replace(I,function(E,S){return C&&S.length>0&&S[0]!=="_"?E:A&&A.hasOwnProperty(S)?A[S]:E})}function u(_){const C={};for(const A of Object.keys(_))A.startsWith("!")||(C[A]=_[A]);return C}function T(_){return _.configuration.request==="attach"&&!b(_)&&(!_.parentSession||T(_.parentSession))}function b(_){let C=_.configuration.type;if(C)return C==="vslsShare"&&(C=_.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(C,"extensionhost")||(0,r.equalsIgnoreCase)(C,"pwa-extensionhost")?_:_.parentSession?b(_.parentSession):void 0}function a(_){return _.type&&(_.label||_.program||_.runtime)}function m(_,C,A){let E,S=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(_);){const O=N.index+1,M=O+N[0].length;if(O<=C&&M>=A){E=N[0],S=O;break}}if(E){const O=/(\w|\p{L})+/gu;let M=null;for(;(M=O.exec(E))&&!(M.index+1+S+M[0].length>=A););M&&(E=E.substring(0,O.lastIndex))}return E?{start:S,end:S+E.length-1}:{start:0,end:0}}async function p(_,C,A,E){if(_.evaluatableExpressionProvider.has(C)){const S=_.evaluatableExpressionProvider.ordered(C),F=(0,l.coalesce)(await Promise.all(S.map(async N=>{try{return await N.provideEvaluatableExpression(C,A,E??v.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const O=F[0].range;return N||(N=C.getLineContent(A.lineNumber).substring(O.startColumn-1,O.endColumn-1)),{range:O,matchingExpression:N}}}else{const S=C.getLineContent(A.lineNumber),{start:F,end:N}=m(S,A.column,A.column),O=S.substring(F-1,N);return{matchingExpression:O,range:new R.Range(A.lineNumber,F,A.lineNumber,F+O.length)}}return null}const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(_){return!!(_&&_.match(f))}function s(_){if(typeof _.path=="string"&&!(typeof _.sourceReference=="number"&&_.sourceReference>0)){if(i(_.path))return d.URI.parse(_.path);if((0,P.isAbsolute)(_.path))return d.URI.file(_.path)}return _.path}function t(_){if(typeof _.path=="object"){const C=d.URI.revive(_.path);if(C)return C.scheme===L.Schemas.file?C.fsPath:C.toString()}return _.path}function o(_,C){const A=C?s:t,E=(0,k.deepClone)(_);return h(E,(S,F)=>{S&&F&&(F.path=A(F))}),E}function n(_,C){const A=C?s:t,E=(0,k.deepClone)(_);return h(E,(S,F)=>{!S&&F&&(F.path=A(F))}),E}function h(_,C){switch(_.type){case"event":{const A=_;switch(A.event){case"output":C(!1,A.body.source);break;case"loadedSource":C(!1,A.body.source);break;case"breakpoint":C(!1,A.body.breakpoint.source);break;default:break}break}case"request":{const A=_;switch(A.command){case"setBreakpoints":C(!0,A.arguments.source);break;case"breakpointLocations":C(!0,A.arguments.source);break;case"source":C(!0,A.arguments.source);break;case"gotoTargets":C(!0,A.arguments.source);break;case"launchVSCode":A.arguments.args.forEach(E=>C(!1,E));break;default:break}break}case"response":{const A=_;if(A.success&&A.body)switch(A.command){case"stackTrace":A.body.stackFrames.forEach(E=>C(!1,E.source));break;case"loadedSources":A.body.sources.forEach(E=>C(!1,E));break;case"scopes":A.body.scopes.forEach(E=>C(!1,E.source));break;case"setFunctionBreakpoints":A.body.breakpoints.forEach(E=>C(!1,E.source));break;case"setBreakpoints":A.body.breakpoints.forEach(E=>C(!1,E.source));break;case"disassemble":A.body?.instructions.forEach(S=>C(!1,S.location));break;default:break}break}}}function c(_){return _.filter(C=>!C.presentation?.hidden).sort((C,A)=>C.presentation?A.presentation?C.presentation.group?A.presentation.group?C.presentation.group!==A.presentation.group?C.presentation.group.localeCompare(A.presentation.group):g(C.presentation.order,A.presentation.order):-1:A.presentation.group?1:g(C.presentation.order,A.presentation.order):-1:A.presentation?1:0)}function g(_,C){return typeof _!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:_-C}async function w(_,C){const A=_.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(A!=="none"&&(await C.saveAll(),A==="allEditorsInActiveGroup")){const E=C.activeEditorPane;E&&E.input.resource?.scheme===L.Schemas.untitled&&await C.save({editor:E.input,groupId:E.group.id})}await _.reloadConfiguration()}const D=(_,C)=>!_||!C?_===C:_.name===C.name&&_.path===C.path&&_.sourceReference===C.sourceReference;e.sourcesEqual=D}),define(Ce[259],Ie([1,0,56,67,24,16,10,12,33,8,154]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0,r=$e(r),d=$e(d),P=$e(P),k=$e(k),L=$e(L),R=$e(R),l=$e(l);class y extends I.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,f){this.outputStream=f,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",i=>this.handleData(i))}sendMessage(p){if(this.outputStream){const f=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${y.TWO_CRLF}${f}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const f=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(i){this._onError.fire(new Error((i.message||i)+`
`+f))}continue}}else{const f=this.rawData.indexOf(y.TWO_CRLF);if(f!==-1){const s=this.rawData.toString("utf8",0,f).split(y.HEADER_LINESEPARATOR);for(const t of s){const o=t.split(y.HEADER_FIELDSEPARATOR);o[0]==="Content-Length"&&(this.contentLength=Number(o[1]))}this.rawData=this.rawData.slice(f+y.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=y;class u extends y{startSession(){return new Promise((p,f)=>{let i=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),i=!0}),this.socket.on("close",()=>{i?this._onError.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.socket.on("error",s=>{i?this._onError.fire(s):f(s)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=u;class T extends u{constructor(p){super(),this.adapterServer=p}createConnection(p){return d.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=T;class b extends u{constructor(p){super(),this.adapterServer=p}createConnection(p){return d.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=b;class a extends y{constructor(p,f){super(),this.adapterExecutable=p,this.debugType=f}async startSession(){const p=this.adapterExecutable.command,f=this.adapterExecutable.args,i=this.adapterExecutable.options||{};try{if(p)if(k.isAbsolute(p)){if(!await v.Promises.exists(p))throw new Error(l.localize(7387,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(l.localize(7388,null,this.debugType));let s=process.env;if(i.env&&Object.keys(i.env).length>0&&(s=P.mixin(P.deepClone(process.env),i.env)),p==="node")if(Array.isArray(f)&&f.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:s,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(o.cwd=i.cwd);const n=r.fork(f[0],f.slice(1),o);if(!n.pid)throw new Error(l.localize(7389,null,f[0]));this.serverProcess=n}else throw new Error(l.localize(7390,null));else{let t=p,o=f;const n={env:s};i.cwd&&(n.cwd=i.cwd),L.isWindows&&(p.endsWith(".bat")||p.endsWith(".cmd"))&&(n.shell=!0,t=`"${p}"`,o=f.map(h=>(h=h.replace(/"/g,'\\"'),`"${h}"`))),this.serverProcess=r.spawn(t,o,n)}this.serverProcess.on("error",t=>{this._onError.fire(t)}),this.serverProcess.on("exit",(t,o)=>{this._onExit.fire(t)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",t=>{this._onError.fire(t)}),this.serverProcess.stdin.on("error",t=>{this._onError.fire(t)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(s){this._onError.fire(s)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),L.isWindows?new Promise((p,f)=>{const i=r.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(s,t,o){if(s)return f(s)});i.on("exit",p),i.on("error",f)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,f){if(!p)return;const i=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?i.runtime=k.join(f,p.runtime):i.runtime=p.runtime),p.runtimeArgs&&(i.runtimeArgs=p.runtimeArgs),p.program&&(k.isAbsolute(p.program)?i.program=p.program:i.program=k.join(f,p.program)),p.args&&(i.args=p.args);const s=p;return s.win&&(i.win=a.extract(s.win,f)),s.winx86&&(i.winx86=a.extract(s.winx86,f)),s.windows&&(i.windows=a.extract(s.windows,f)),s.osx&&(i.osx=a.extract(s.osx,f)),s.linux&&(i.linux=a.extract(s.linux,f)),i}static platformAdapterExecutable(p,f){let i=Object.create(null);f=f.toLowerCase();for(const c of p)if(c.contributes){const g=c.contributes.debuggers;g&&g.length>0&&g.filter(w=>typeof w.type=="string"&&R.equalsIgnoreCase(w.type,f)).forEach(w=>{const D=a.extract(w,c.extensionLocation.fsPath);i=P.mixin(i,D,c.isBuiltin)})}let s;L.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=i.winx86||i.win||i.windows:L.isWindows?s=i.win||i.windows:L.isMacintosh?s=i.osx:L.isLinux&&(s=i.linux),s=s||i;const t=s.program||i.program,o=s.args||i.args,n=s.runtime||i.runtime,h=s.runtimeArgs||i.runtimeArgs;if(n)return{type:"executable",command:n,args:(h||[]).concat(typeof t=="string"?[t]:[]).concat(o||[])};if(t)return{type:"executable",command:t,args:o||[]}}}e.ExecutableDebugAdapter=a}),define(Ce[260],Ie([1,0,56,31,10]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasChildProcesses=L,e.prepareCommand=v,r=$e(r),P=$e(P);function k(l,I){return new Promise((y,u)=>{let T="";const b=r.spawn(l,I);b.pid&&b.stdout.on("data",a=>{T+=a.toString()}),b.on("error",a=>{u(a)}),b.on("close",a=>{y(T)})})}async function L(l){if(l)if(P.isWindows){const I=await new Promise((y,u)=>{pe(["@vscode/windows-process-tree"],y,u)}).then($e);return new Promise(y=>{I.getProcessTree(l,u=>{y(!!u&&u.children.length>0)})})}else return k("/usr/bin/pgrep",["-lP",String(l)]).then(I=>{const y=I.trim();return!(y.length===0||y.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var R;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(R||(R={}));function v(l,I,y,u,T){l=l.trim().toLowerCase();let b;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?b=R.powershell:l.indexOf("cmd.exe")>=0?b=R.cmd:l.indexOf("bash")>=0?b=R.bash:P.isWindows?b=R.cmd:b=R.bash;let a,m=" ";switch(b){case R.powershell:if(a=p=>(p=p.replace(/\'/g,"''"),p.length>0&&p.charAt(p.length-1)==="\\"?`'${p}\\'`:`'${p}'`),u){const p=(0,d.getDriveLetter)(u);p&&(m+=`${p}:; `),m+=`cd ${a(u)}; `}if(T)for(const p in T){const f=T[p];f===null?m+=`Remove-Item env:${p}; `:m+=`\${env:${p}}='${f}'; `}if(I.length>0){const p=I.shift(),f=y?p:a(p);m+=f[0]==="'"?`& ${f} `:`${f} `;for(const i of I)m+=i==="<"||i===">"||y?i:a(i),m+=" "}break;case R.cmd:if(a=p=>(p=p.replace(/\"/g,'""'),p=p.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>p.includes(f))||p.length===0?`"${p}"`:p),u){const p=(0,d.getDriveLetter)(u);p&&(m+=`${p}: && `),m+=`cd ${a(u)} && `}if(T){m+='cmd /C "';for(const p in T){let f=T[p];f===null?m+=`set "${p}=" && `:(f=f.replace(/[&^|<>]/g,i=>`^${i}`),m+=`set "${p}=${f}" && `)}}for(const p of I)m+=p==="<"||p===">"||y?p:a(p),m+=" ";T&&(m+='"');break;case R.bash:{a=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),f.length===0?'""':f);const p=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(u&&(m+=`cd ${a(u)} ; `),T){m+="/usr/bin/env";for(const f in T){const i=T[f];i===null?m+=` -u ${p(f)}`:m+=` ${p(`${f}=${i}`)}`}m+=" "}for(const f of I)m+=f==="<"||f===">"||y?f:a(f),m+=" ";break}}return m}}),define(Ce[261],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var d;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(d||(e.CellExecutionUpdateType=d={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ce[262],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var d;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(d||(e.ProxyKernelState=d={})),e.INotebookKernelService=(0,r.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,r.createDecorator)("INotebookKernelHistoryService")}),define(Ce[263],Ie([1,0,3,30,58,208,111]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class R extends r.Disposable{constructor(l,I,y){super(),this._source=l,this._inputTextBuffer=I,this._outputs=y,this._outputTextBuffers=void 0}_getFullModelRange(l){const I=l.getLineCount();return new d.Range(1,1,I,this._getLineMaxColumn(l,I))}_getLineMaxColumn(l,I){if(I<1||I>l.getLineCount())throw new Error("Illegal value for lineNumber");return l.getLineLength(I)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const l=new k.PieceTreeTextBufferBuilder;l.acceptChunk(this._source);const I=l.finish(!0),{textBuffer:y,disposable:u}=I.create(P.DefaultEndOfLine.LF);this._inputTextBuffer=y,this._register(u)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(l=>{const I=new k.PieceTreeTextBufferBuilder;I.acceptChunk(l);const y=I.finish(!0),{textBuffer:u,disposable:T}=y.create(P.DefaultEndOfLine.LF);return this._register(T),u})),this._outputTextBuffers}findInInputs(l){const y=new L.SearchParams(l,!1,!1,null).parseSearchRequest();if(!y)return[];const u=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,y,!0,5e3)}findInOutputs(l){const y=new L.SearchParams(l,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(u=>{const T=u.findMatchesLineByLine(this._getFullModelRange(u),y,!0,5e3);if(T.length!==0)return{textBuffer:u,matches:T}}).filter(u=>!!u):[]}}e.CellSearchModel=R}),define(Ce[73],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(k){k.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var d;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(d||(e.TestPosition=d={}));class P{static fromExtHostTestItem(L,R,v=L.parent){if(L._isRoot)return new P([R]);const l=[L.id];for(let I=v;I&&I.id!==R;I=I.parent)l.push(I.id);return l.push(R),new P(l.reverse())}static isRoot(L){return!L.includes(r.Delimiter)}static root(L){const R=L.indexOf(r.Delimiter);return R===-1?L:L.slice(0,R)}static fromString(L){return new P(L.split(r.Delimiter))}static join(L,R){return new P([...L.path,R])}static joinToString(L,R){return L.toString()+r.Delimiter+R}static parentId(L){const R=L.lastIndexOf(r.Delimiter);return R===-1?void 0:L.slice(0,R)}static localId(L){const R=L.lastIndexOf(r.Delimiter);return R===-1?L:L.slice(R+r.Delimiter.length)}static isChild(L,R){return R[L.length]===r.Delimiter&&R.startsWith(L)}static compare(L,R){return L===R?d.IsSame:P.isChild(L,R)?d.IsChild:P.isChild(R,L)?d.IsParent:d.Disconnected}static getLengthOfCommonPrefix(L,R){if(L===0)return 0;let v=0;for(;v<L-1;){for(let l=1;l<L;l++){const I=R(l-1),y=R(l);if(I.path[v]!==y.path[v])return v}v++}return v}constructor(L,R=L.length){if(this.path=L,this.viewEnd=R,L.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.viewEnd>1?new P(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let L=1;L<=this.viewEnd;L++)yield new P(this.path,L)}*idsToRoot(){for(let L=this.viewEnd;L>0;L--)yield new P(this.path,L)}compare(L){if(typeof L=="string")return P.compare(this.toString(),L);for(let R=0;R<L.viewEnd&&R<this.viewEnd;R++)if(L.path[R]!==this.path[R])return d.Disconnected;return L.viewEnd>this.viewEnd?d.IsChild:L.viewEnd<this.viewEnd?d.IsParent:d.IsSame}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let L=1;L<this.viewEnd;L++)this.stringifed+=r.Delimiter,this.stringifed+=this.path[L]}return this.stringifed}}e.TestId=P}),define(Ce[74],Ie([1,0,2,57,30,73]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var L;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.testResultStateToContextValues={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var R;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var v;(function(z){z[z.Refresh=2]="Refresh",z[z.CodeRelatedToTest=4]="CodeRelatedToTest",z[z.TestRelatedToCode=8]="TestRelatedToCode"})(v||(e.TestControllerCapability=v={}));var l;(function(z){z[z.Run=2]="Run",z[z.Debug=4]="Debug",z[z.Coverage=8]="Coverage",z[z.HasNonDefaultProfile=16]="HasNonDefaultProfile",z[z.HasConfigurable=32]="HasConfigurable",z[z.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.testRunProfileBitsetList=[l.Run,l.Debug,l.Coverage,l.HasNonDefaultProfile,l.HasConfigurable,l.SupportsContinuousRun];const I=z=>"runId"in z;e.isStartControllerTests=I;var y;(function(z){z.serialize=B=>({range:B.range.toJSON(),uri:B.uri.toJSON()}),z.deserialize=(B,ee)=>({range:P.Range.lift(ee.range),uri:B.asCanonicalUri(r.URI.revive(ee.uri))})})(y||(e.IRichLocation=y={}));var u;(function(z){z[z.Error=0]="Error",z[z.Output=1]="Output"})(u||(e.TestMessageType=u={}));var T;(function(z){z.serialize=B=>({label:B.label,uri:B.uri?.toJSON(),position:B.position?.toJSON()}),z.deserialize=(B,ee)=>({label:ee.label,uri:ee.uri?B.asCanonicalUri(r.URI.revive(ee.uri)):void 0,position:ee.position?d.Position.lift(ee.position):void 0})})(T||(e.ITestMessageStackFrame=T={}));var b;(function(z){z.serialize=B=>({message:B.message,type:u.Error,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&y.serialize(B.location),stackTrace:B.stackTrace?.map(T.serialize)}),z.deserialize=(B,ee)=>({message:ee.message,type:u.Error,expected:ee.expected,actual:ee.actual,contextValue:ee.contextValue,location:ee.location&&y.deserialize(B,ee.location),stackTrace:ee.stackTrace&&ee.stackTrace.map(V=>T.deserialize(B,V))})})(b||(e.ITestErrorMessage=b={}));const a=(z,B)=>`${B?"s":"e"}${z}`;e.getMarkId=a;var m;(function(z){z.serialize=B=>({message:B.message,type:u.Output,offset:B.offset,length:B.length,location:B.location&&y.serialize(B.location)}),z.deserialize=(B,ee)=>({message:ee.message,type:u.Output,offset:ee.offset,length:ee.length,location:ee.location&&y.deserialize(B,ee.location)})})(m||(e.ITestOutputMessage=m={}));var p;(function(z){z.serialize=B=>B.type===u.Error?b.serialize(B):m.serialize(B),z.deserialize=(B,ee)=>ee.type===u.Error?b.deserialize(B,ee):m.deserialize(B,ee),z.isDiffable=B=>B.type===u.Error&&B.actual!==void 0&&B.expected!==void 0})(p||(e.ITestMessage=p={}));var f;(function(z){z.serializeWithoutMessages=B=>({state:B.state,duration:B.duration,messages:[]}),z.serialize=B=>({state:B.state,duration:B.duration,messages:B.messages.map(p.serialize)}),z.deserialize=(B,ee)=>({state:ee.state,duration:ee.duration,messages:ee.messages.map(V=>p.deserialize(B,V))})})(f||(e.ITestTaskState=f={}));const i="\0",s=(z,B)=>z+i+B;e.namespaceTestTag=s;const t=z=>{const B=z.indexOf(i);return{ctrlId:z.slice(0,B),tagId:z.slice(B+1)}};e.denamespaceTestTag=t;var o;(function(z){z.serialize=B=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?.toJSON(),range:B.range?.toJSON()||null,description:B.description,error:B.error,sortText:B.sortText}),z.deserialize=(B,ee)=>({extId:ee.extId,label:ee.label,tags:ee.tags,busy:ee.busy,children:void 0,uri:ee.uri?B.asCanonicalUri(r.URI.revive(ee.uri)):void 0,range:ee.range?P.Range.lift(ee.range):null,description:ee.description,error:ee.error,sortText:ee.sortText})})(o||(e.ITestItem=o={}));var n;(function(z){z[z.NotExpandable=0]="NotExpandable",z[z.Expandable=1]="Expandable",z[z.BusyExpanding=2]="BusyExpanding",z[z.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var h;(function(z){z.serialize=B=>({expand:B.expand,item:o.serialize(B.item)}),z.deserialize=(B,ee)=>({controllerId:k.TestId.root(ee.item.extId),expand:ee.expand,item:o.deserialize(B,ee.item)})})(h||(e.InternalTestItem=h={}));var c;(function(z){z.serialize=B=>{let ee;return B.item&&(ee={},B.item.label!==void 0&&(ee.label=B.item.label),B.item.tags!==void 0&&(ee.tags=B.item.tags),B.item.busy!==void 0&&(ee.busy=B.item.busy),B.item.uri!==void 0&&(ee.uri=B.item.uri?.toJSON()),B.item.range!==void 0&&(ee.range=B.item.range?.toJSON()),B.item.description!==void 0&&(ee.description=B.item.description),B.item.error!==void 0&&(ee.error=B.item.error),B.item.sortText!==void 0&&(ee.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:ee}},z.deserialize=B=>{let ee;return B.item&&(ee={},B.item.label!==void 0&&(ee.label=B.item.label),B.item.tags!==void 0&&(ee.tags=B.item.tags),B.item.busy!==void 0&&(ee.busy=B.item.busy),B.item.range!==void 0&&(ee.range=B.item.range?P.Range.lift(B.item.range):null),B.item.description!==void 0&&(ee.description=B.item.description),B.item.error!==void 0&&(ee.error=B.item.error),B.item.sortText!==void 0&&(ee.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:ee}}})(c||(e.ITestItemUpdate=c={}));const g=(z,B)=>{B.expand!==void 0&&(z.expand=B.expand),B.item!==void 0&&(z.item=z.item?Object.assign(z.item,B.item):B.item)};e.applyTestItemUpdate=g;var w;(function(z){z.serializeWithoutMessages=B=>({...h.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(f.serializeWithoutMessages)}),z.serialize=B=>({...h.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(f.serialize)}),z.deserialize=(B,ee)=>({...h.deserialize(B,ee),ownComputedState:ee.ownComputedState,computedState:ee.computedState,tasks:ee.tasks.map(V=>f.deserialize(B,V)),retired:!0})})(w||(e.TestResultItem=w={}));var D;(function(z){z.empty=()=>({covered:0,total:0}),z.sum=(B,ee)=>{B.covered+=ee.covered,B.total+=ee.total}})(D||(e.ICoverageCount=D={}));var _;(function(z){z.serialize=B=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testIds:B.testIds,uri:B.uri.toJSON()}),z.deserialize=(B,ee)=>({id:ee.id,statement:ee.statement,branch:ee.branch,declaration:ee.declaration,testIds:ee.testIds,uri:B.asCanonicalUri(r.URI.revive(ee.uri))}),z.empty=(B,ee)=>({id:B,uri:ee,statement:D.empty()})})(_||(e.IFileCoverage=_={}));function C(z){return{...z,location:z.location?.toJSON()}}function A(z){return z.location=z.location?d.Position.isIPosition(z.location)?d.Position.lift(z.location):P.Range.lift(z.location):void 0,z}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var E;(function(z){z[z.Declaration=0]="Declaration",z[z.Statement=1]="Statement",z[z.Branch=2]="Branch"})(E||(e.DetailType=E={}));var S;(function(z){z.serialize=B=>B.type===E.Declaration?N.serialize(B):O.serialize(B),z.deserialize=B=>B.type===E.Declaration?N.deserialize(B):O.deserialize(B)})(S||(e.CoverageDetails=S={}));var F;(function(z){z.serialize=C,z.deserialize=A})(F||(e.IBranchCoverage=F={}));var N;(function(z){z.serialize=C,z.deserialize=A})(N||(e.IDeclarationCoverage=N={}));var O;(function(z){z.serialize=B=>({...C(B),branches:B.branches?.map(F.serialize)}),z.deserialize=B=>({...A(B),branches:B.branches?.map(F.deserialize)})})(O||(e.IStatementCoverage=O={}));var M;(function(z){z[z.Add=0]="Add",z[z.Update=1]="Update",z[z.DocumentSynced=2]="DocumentSynced",z[z.Remove=3]="Remove",z[z.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",z[z.Retire=5]="Retire",z[z.AddTag=6]="AddTag",z[z.RemoveTag=7]="RemoveTag"})(M||(e.TestDiffOpType=M={}));var U;(function(z){z.deserialize=(B,ee)=>ee.op===M.Add?{op:ee.op,item:h.deserialize(B,ee.item)}:ee.op===M.Update?{op:ee.op,item:c.deserialize(ee.item)}:ee.op===M.DocumentSynced?{op:ee.op,uri:B.asCanonicalUri(r.URI.revive(ee.uri)),docv:ee.docv}:ee,z.serialize=B=>B.op===M.Add?{op:B.op,item:h.serialize(B.item)}:B.op===M.Update?{op:B.op,item:c.serialize(B.item)}:B})(U||(e.TestsDiffOp=U={}));class x{constructor(B){this.uriIdentity=B,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(B){const ee=this.createChangeCollector();for(const V of B)switch(V.op){case M.Add:this.add(h.deserialize(this.uriIdentity,V.item),ee);break;case M.Update:this.update(c.deserialize(V.item),ee);break;case M.Remove:this.remove(V.itemId,ee);break;case M.Retire:this.retireTest(V.itemId);break;case M.IncrementPendingExtHosts:this.updatePendingRoots(V.amount);break;case M.AddTag:this._tags.set(V.tag.id,V.tag);break;case M.RemoveTag:this._tags.delete(V.id);break}ee.complete?.()}add(B,ee){const V=k.TestId.parentId(B.item.extId)?.toString();let $;if(!V)$=this.createItem(B),this.roots.add($),this.items.set(B.item.extId,$);else if(this.items.has(V)){const G=this.items.get(V);G.children.add(B.item.extId),$=this.createItem(B,G),this.items.set(B.item.extId,$)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(B)}`);return}return ee.add?.($),B.expand===n.BusyExpanding&&this.busyControllerCount++,$}update(B,ee){const V=this.items.get(B.extId);if(V)return B.expand!==void 0&&(V.expand===n.BusyExpanding&&this.busyControllerCount--,B.expand===n.BusyExpanding&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(V,B),ee.update?.(V),V}remove(B,ee){const V=this.items.get(B);if(!V)return;const $=k.TestId.parentId(V.item.extId)?.toString();$?this.items.get($).children.delete(V.item.extId):this.roots.delete(V);const G=[[B]];for(;G.length;)for(const Z of G.pop()){const le=this.items.get(Z);le&&(G.push(le.children),this.items.delete(Z),ee.remove?.(le,le!==V),le.expand===n.BusyExpanding&&this.busyControllerCount--)}}retireTest(B){}updatePendingRoots(B){this.pendingRootCount+=B}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=x}),define(Ce[264],Ie([1,0,137,8,74]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.testConfigurationGroupNames=e.labelForTestInState=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var k;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(k||(e.Testing=k={}));var L;(function(y){y.List="list",y.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var R;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const v={[P.TestResultState.Errored]:(0,d.localize)(3187,null),[P.TestResultState.Failed]:(0,d.localize)(3188,null),[P.TestResultState.Passed]:(0,d.localize)(3189,null),[P.TestResultState.Queued]:(0,d.localize)(3190,null),[P.TestResultState.Running]:(0,d.localize)(3191,null),[P.TestResultState.Skipped]:(0,d.localize)(3192,null),[P.TestResultState.Unset]:(0,d.localize)(3193,null)},l=(y,u)=>(0,d.localize)(3194,null,(0,r.stripIcons)(y),v[u]);e.labelForTestInState=l,e.testConfigurationGroupNames={[P.TestRunProfileBitset.Debug]:(0,d.localize)(3195,null),[P.TestRunProfileBitset.Run]:(0,d.localize)(3196,null),[P.TestRunProfileBitset.Coverage]:(0,d.localize)(3197,null)};var I;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.GoToRelatedTest="testing.goToRelatedTest",y.PeekRelatedTest="testing.peekRelatedTest",y.GoToRelatedCode="testing.goToRelatedCode",y.PeekRelatedCode="testing.peekRelatedCode",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Ce[120],Ie([1,0,7,4,3,65,74,73]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const l=(f,i)=>f===i,y=Object.entries({range:(f,i)=>f===i?!0:!f||!i?!1:f.equalsRange(i),busy:l,label:l,description:l,error:l,sortText:l,tags:(f,i)=>!(f.length!==i.length||f.some(s=>!i.includes(s)))}),u=(f,i)=>{let s;for(const[t,o]of y)o(f[t],i[t])||(s?s[t]=i[t]:s={[t]:i[t]});return s};class T extends P.Disposable{get root(){return this.options.root}constructor(i){super(),this.options=i,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new d.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const s of this.tree.values())this.updateExpandability(s)}get resolveHandler(){return this._resolveHandler}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){switch(i.op){case L.TestDiffOpType.DocumentSynced:{for(const s of this.diff)if(s.op===L.TestDiffOpType.DocumentSynced&&s.uri===i.uri){s.docv=i.docv;return}break}case L.TestDiffOpType.Update:{const s=this.diff[this.diff.length-1];if(s){if(s.op===L.TestDiffOpType.Update&&s.item.extId===i.item.extId){(0,L.applyTestItemUpdate)(s.item,i.item);return}if(s.op===L.TestDiffOpType.Add&&s.item.item.extId===i.item.extId){(0,L.applyTestItemUpdate)(s.item,i.item);return}}break}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,s){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||s>t.expandLevels)&&(t.expandLevels=s),t.expand===L.TestItemExpandState.Expandable){const o=this.resolveChildren(t);return o.isOpen()?this.expandChildren(t,s-1):o.wait().then(()=>this.expandChildren(t,s-1))}else if(t.expand===L.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.expandChildren(t,s-1)):this.expandChildren(t,s-1)}}dispose(){for(const i of this.tree.values())this.options.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,s){switch(s.op){case v.RemoveChild:this.removeItem(R.TestId.joinToString(i.fullId,s.id));break;case v.Upsert:this.upsertItem(s.item,i);break;case v.Bulk:for(const t of s.ops)this.onTestItemEvent(i,t);break;case v.SetTags:this.diffTagRefs(s.new,s.old,i.fullId.toString());break;case v.UpdateCanResolveChildren:this.updateExpandability(i);break;case v.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:s.update}});break;case v.DocumentSynced:this.documentSynced(i.actual.uri);break;default:(0,k.assertNever)(s)}}documentSynced(i){i&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:i,docv:this.options.getDocumentVersion(i)})}upsertItem(i,s){const t=R.TestId.fromExtHostTestItem(i,this.root.id,s?.actual),o=this.options.getApiFor(i);o.parent&&o.parent!==s?.actual&&this.options.getChildren(o.parent).delete(i.id);let n=this.tree.get(t.toString());if(!n){n={fullId:t,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(i,s),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(i)}}),this.connectItemAndChildren(i,n,s);return}if(n.actual===i){this.connectItem(i,n,s);return}if(n.actual.uri?.toString()!==i.uri?.toString())return this.removeItem(t.toString()),this.upsertItem(i,s);const h=this.options.getChildren(n.actual),c=n.actual,g=u(this.options.toITestItem(c),this.options.toITestItem(i));this.options.getApiFor(c).listener=void 0,n.actual=i,n.resolveBarrier=void 0,n.expand=L.TestItemExpandState.NotExpandable,g&&(g.hasOwnProperty("tags")&&(this.diffTagRefs(i.tags,c.tags,t.toString()),delete g.tags),this.onTestItemEvent(n,{op:v.SetProp,update:g})),this.connectItemAndChildren(i,n,s);for(const[D,_]of h)this.options.getChildren(i).get(_.id)||this.removeItem(R.TestId.joinToString(t,_.id));const w=n.expandLevels;w!==void 0&&queueMicrotask(()=>{n.expand===L.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(t.toString(),w))}),this.documentSynced(n.actual.uri)}diffTagRefs(i,s,t){const o=new Set(s.map(n=>n.id));for(const n of i)o.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(n=>(0,L.namespaceTestTag)(this.options.controllerId,n.id))}}}),o.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const s=this.tags.get(i.id);s?s.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.namespaceTestTag)(this.options.controllerId,i.id)}}))}decrementTagRefs(i){const s=this.tags.get(i);s&&!--s.refCount&&(this.tags.delete(i),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.namespaceTestTag)(this.options.controllerId,i)}))}setItemParent(i,s){this.options.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}connectItem(i,s,t){this.setItemParent(i,t);const o=this.options.getApiFor(i);o.parent=t?.actual,o.listener=n=>this.onTestItemEvent(s,n),this.updateExpandability(s)}connectItemAndChildren(i,s,t){this.connectItem(i,s,t);for(const[o,n]of this.options.getChildren(i))this.upsertItem(n,s)}updateExpandability(i){let s;this._resolveHandler?i.resolveBarrier?s=i.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:s=i.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:s=L.TestItemExpandState.NotExpandable,s!==i.expand&&(i.expand=s,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:s}}),s===L.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,s){if(s<0)return;const t=[];for(const[o,n]of this.options.getChildren(i.actual)){const h=this.expand(R.TestId.joinToString(i.fullId,n.id),s);(0,r.isThenable)(h)&&t.push(h)}if(t.length)return Promise.all(t).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const n=new r.Barrier;return n.open(),n}i.expand=L.TestItemExpandState.BusyExpanding,this.pushExpandStateUpdate(i);const s=i.resolveBarrier=new r.Barrier,t=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let o;try{o=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(n){t(n)}return(0,r.isThenable)(o)?o.catch(t).then(()=>{s.open(),this.updateExpandability(i)}):(s.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}removeItem(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:i});const t=[s];for(;t.length;){const o=t.pop();if(o){this.options.getApiFor(o.actual).listener=void 0;for(const n of o.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(o.fullId.toString());for(const[n,h]of this.options.getChildren(o.actual))t.push(this.tree.get(R.TestId.joinToString(o.fullId,h.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.TestItemCollection=T;class b extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.DuplicateTestItemError=b;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=a;class m extends Error{constructor(i,s,t){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${t}".`)}}e.MixedTestItemController=m;const p=(f,i,s)=>{let t=new Map;return{get size(){return t.size},forEach(o,n){for(const h of t.values())o.call(n,h,this)},[Symbol.iterator](){return t.entries()},replace(o){const n=new Map,h=new Set(t.keys()),c={op:v.Bulk,ops:[]};for(const g of o){if(!(g instanceof s))throw new a(g.id);const w=i(g).controllerId;if(w!==f.controllerId)throw new m(g.id,w,f.controllerId);if(n.has(g.id))throw new b(g.id);n.set(g.id,g),h.delete(g.id),c.ops.push({op:v.Upsert,item:g})}for(const g of h.keys())c.ops.push({op:v.RemoveChild,id:g});f.listener?.(c),t=n},add(o){if(!(o instanceof s))throw new a(o.id);t.set(o.id,o),f.listener?.({op:v.Upsert,item:o})},delete(o){t.delete(o)&&f.listener?.({op:v.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.createTestItemChildren=p}),define(Ce[155],Ie([1,0,120]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const d=new WeakMap,P=(L,R)=>{const v={controllerId:R};return d.set(L,v),v};e.createPrivateApiFor=P;const k=L=>{const R=d.get(L);if(!R)throw new r.InvalidTestItemError(L?.id||"<unknown>");return R};e.getPrivateApiFor=k}),define(Ce[121],Ie([1,0,26,14,2]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=k,e.decodeAuthority=R,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function k(v,l){return v.scheme===d.Schemas.http||v.scheme===d.Schemas.https?v:(l&&l.authority&&l.isRemote&&v.scheme===d.Schemas.file&&(v=P.URI.from({scheme:d.Schemas.vscodeRemote,authority:l.authority,path:v.path})),P.URI.from({scheme:d.Schemas.https,authority:`${v.scheme}+${L(v.authority)}.${e.webviewRootResourceAuthority}`,path:v.path,fragment:v.fragment,query:v.query}))}function L(v){return v.replace(/./g,l=>{const I=l.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?l:"-"+I.toString(16).padStart(4,"0")})}function R(v){return v.replace(/-([0-9a-f]{4})/g,(l,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Ce[265],Ie([1,0,4,3,121]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class k{constructor(R,v,l){this._proxy=R,this._editors=v,this._remoteInfo=l,this._handlePool=0,this._disposables=new d.DisposableStore,this._insets=new Map,this._disposables.add(v.onDidChangeVisibleTextEditors(()=>{const I=v.getVisibleTextEditors();for(const y of this._insets.values())I.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(R=>R.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(R,v,l,I,y){let u;for(const i of this._editors.getVisibleTextEditors(!0))if(i.value===R){u=i;break}if(!u)throw new Error("not a visible editor");const T=this,b=this._handlePool++,a=new r.Emitter,m=new r.Emitter,p=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(i){return(0,P.asWebviewUri)(i,T._remoteInfo)}get cspSource(){return P.webviewGenericCspSource}set options(i){this._options=i,T._proxy.$setOptions(b,i)}get options(){return this._options}set html(i){this._html=i,T._proxy.$setHtml(b,i)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(i){return T._proxy.$postMessage(b,i)}},f=new class{constructor(){this.editor=R,this.line=v,this.height=l,this.webview=p,this.onDidDispose=m.event}dispose(){T._insets.has(b)&&(T._insets.delete(b),T._proxy.$disposeEditorInset(b),m.fire(),m.dispose(),a.dispose())}};return this._proxy.$createEditorInset(b,u.id,u.value.document.uri,v+1,l,I||{},y.identifier,y.extensionLocation),this._insets.set(b,{editor:R,inset:f,onDidReceiveMessage:a}),f}$onDidDispose(R){const v=this._insets.get(R);v&&v.inset.dispose()}$onDidReceiveMessage(R,v){this._insets.get(R)?.onDidReceiveMessage.fire(v)}}e.ExtHostEditorInsets=k}),define(Ce[156],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,r.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,r.createDecorator)("IAuthenticationExtensionsService")}),define(Ce[266],Ie([1,0,5]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var d;(function(k){k.Unknown="unknown",k.Env="env",k.Config="config",k.Command="command",k.Input="input",k.ExtensionInstallFolder="extensionInstallFolder",k.WorkspaceFolder="workspaceFolder",k.Cwd="cwd",k.WorkspaceFolderBasename="workspaceFolderBasename",k.UserHome="userHome",k.LineNumber="lineNumber",k.SelectedText="selectedText",k.File="file",k.FileWorkspaceFolder="fileWorkspaceFolder",k.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",k.RelativeFile="relativeFile",k.RelativeFileDirname="relativeFileDirname",k.FileDirname="fileDirname",k.FileExtname="fileExtname",k.FileBasename="fileBasename",k.FileBasenameNoExtension="fileBasenameNoExtension",k.FileDirnameBasename="fileDirnameBasename",k.ExecPath="execPath",k.ExecInstallFolder="execInstallFolder",k.PathSeparator="pathSeparator",k.PathSeparatorAlias="/"})(d||(e.VariableKind=d={}));class P extends Error{constructor(L,R){super(R),this.variable=L}}e.VariableError=P}),define(Ce[267],Ie([1,0,16,55,17,24,10,107,8,266,12]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0,r=$e(r),d=$e(d),P=$e(P),k=$e(k);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(T,b,a,m){this._contributedVariables=new Map,this._context=T,this._labelService=b,this._userHomePromise=a,m&&(this._envVariablesPromise=m.then(p=>this.prepareEnv(p)))}prepareEnv(T){if(L.isWindows){const b=Object.create(null);return Object.keys(T).forEach(a=>{b[a.toLowerCase()]=T[a]}),b}return T}resolveWithEnvironment(T,b,a){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},b?b.uri:void 0,a)}async resolveAsync(T,b){const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,T?T.uri:void 0,b)}async resolveAnyBase(T,b,a,m){const p=k.deepClone(b);L.isWindows&&p.windows?Object.keys(p.windows).forEach(i=>p[i]=p.windows[i]):L.isMacintosh&&p.osx?Object.keys(p.osx).forEach(i=>p[i]=p.osx[i]):L.isLinux&&p.linux&&Object.keys(p.linux).forEach(i=>p[i]=p.linux[i]),delete p.windows,delete p.osx,delete p.linux;const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,T?T.uri:void 0,p,a,m)}async resolveAnyAsync(T,b,a){return this.resolveAnyBase(T,b,a)}async resolveAnyMap(T,b,a){const m=new Map;return{newConfig:await this.resolveAnyBase(T,b,a,m),resolvedVariables:m}}resolveWithInteractionReplace(T,b,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,b,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,b){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,b)}async recursiveResolve(T,b,a,m,p){if(P.isString(a))return this.resolveString(T,b,a,m,p);if(Array.isArray(a))return Promise.all(a.map(f=>this.recursiveResolve(T,b,f,m,p)));if(P.isObject(a)){const f=Object.create(null),i=await Promise.all(Object.keys(a).map(async s=>[await this.resolveString(T,b,s,m,p),await this.recursiveResolve(T,b,a[s],m,p)]));for(const[s,t]of i)f[s]=t;return f}return a}resolveString(T,b,a,m,p){return(0,I.replaceAsync)(a,y.VARIABLE_REGEXP,async(f,i)=>{if(i.includes(y.VARIABLE_LHS))return f;let s=await this.evaluateSingleVariable(T,f,i,b,m);return p?.set(i,s),s!==f&&P.isString(s)&&s.match(y.VARIABLE_REGEXP)&&(s=await this.resolveString(T,b,s,m,p)),s})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,b,a,m,p){let f;const i=a.split(":");i.length>1&&(a=i[0],f=i[1]);const s=n=>{const h=this._context.getFilePath();if(h)return(0,R.normalizeDriveLetter)(h);throw new l.VariableError(n,(0,v.localize)(2078,null,b))},t=n=>{const h=s(n);if(this._context.getWorkspaceFolderPathForFile){const c=this._context.getWorkspaceFolderPathForFile();if(c)return(0,R.normalizeDriveLetter)(c)}throw new l.VariableError(n,(0,v.localize)(2079,null,b,r.basename(h)))},o=n=>{if(f){const h=this._context.getFolderUri(f);if(h)return h;throw new l.VariableError(n,(0,v.localize)(2080,null,b,f))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new l.VariableError(n,(0,v.localize)(2081,null,b)):new l.VariableError(n,(0,v.localize)(2082,null,b))};switch(a){case"env":if(f){if(T.env){const n=T.env[L.isWindows?f.toLowerCase():f];if(P.isString(n))return n}return""}throw new l.VariableError(l.VariableKind.Env,(0,v.localize)(2083,null,b));case"config":if(f){const n=this._context.getConfigurationValue(m,f);if(P.isUndefinedOrNull(n))throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(2084,null,b,f));if(P.isObject(n))throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(2085,null,b,f));return n}throw new l.VariableError(l.VariableKind.Config,(0,v.localize)(2086,null,b));case"command":return this.resolveFromMap(l.VariableKind.Command,b,f,p,"command");case"input":return this.resolveFromMap(l.VariableKind.Input,b,f,p,"input");case"extensionInstallFolder":if(f){const n=await this._context.getExtension(f);if(!n)throw new l.VariableError(l.VariableKind.ExtensionInstallFolder,(0,v.localize)(2087,null,b,f));return this.fsPath(n.extensionLocation)}throw new l.VariableError(l.VariableKind.ExtensionInstallFolder,(0,v.localize)(2088,null,b));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.fsPath(o(l.VariableKind.WorkspaceFolder)));case"cwd":return m||f?(0,R.normalizeDriveLetter)(this.fsPath(o(l.VariableKind.Cwd))):d.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(r.basename(this.fsPath(o(l.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(T.userHome)return T.userHome;throw new l.VariableError(l.VariableKind.UserHome,(0,v.localize)(2089,null,b))}case"lineNumber":{const n=this._context.getLineNumber();if(n)return n;throw new l.VariableError(l.VariableKind.LineNumber,(0,v.localize)(2090,null,b))}case"selectedText":{const n=this._context.getSelectedText();if(n)return n;throw new l.VariableError(l.VariableKind.SelectedText,(0,v.localize)(2091,null,b))}case"file":return s(l.VariableKind.File);case"fileWorkspaceFolder":return t(l.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.basename(t(l.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||f?r.relative(this.fsPath(o(l.VariableKind.RelativeFile)),s(l.VariableKind.RelativeFile)):s(l.VariableKind.RelativeFile);case"relativeFileDirname":{const n=r.dirname(s(l.VariableKind.RelativeFileDirname));if(m||f){const h=r.relative(this.fsPath(o(l.VariableKind.RelativeFileDirname)),n);return h.length===0?".":h}return n}case"fileDirname":return r.dirname(s(l.VariableKind.FileDirname));case"fileExtname":return r.extname(s(l.VariableKind.FileExtname));case"fileBasename":return r.basename(s(l.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=r.basename(s(l.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-r.extname(n).length)}case"fileDirnameBasename":return r.basename(r.dirname(s(l.VariableKind.FileDirnameBasename)));case"execPath":{const n=this._context.getExecPath();return n||b}case"execInstallFolder":{const n=this._context.getAppRoot();return n||b}case"pathSeparator":case"/":return r.sep;default:try{const n=f?`${a}:${f}`:a;return this.resolveFromMap(l.VariableKind.Unknown,b,n,p,void 0)}catch{return b}}}}resolveFromMap(T,b,a,m,p){if(a&&m){const f=p===void 0?m[a]:m[p+":"+a];if(typeof f=="string")return f;throw new l.VariableError(T,(0,v.localize)(2092,null,b))}return b}}e.AbstractVariableResolverService=y}),define(Ce[157],Ie([1,0,5,152]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=l,e.isEditorGroup=u,e.preferredSideBySideGroupDirection=T,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var P;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var k;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(k||(e.GroupOrientation=k={}));var L;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var R;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var v;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function l(b){const a=b;return(0,d.isEditorInput)(a?.editor)&&(0,d.isEditorInput)(a?.replacement)}var I;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var y;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(b){const a=b;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function T(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Ce[268],Ie([1,0,5,157]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=P,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function P(k){const L=k;return typeof k=="number"||(0,d.isEditorGroup)(L)}}),define(Ce[158],Ie([1,0,5,144]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(d.IEnvironmentService)}),define(Ce[159],Ie([1,0,23,4,16,3,7]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0,P=$e(P);class R{constructor(f,i){this.versionId=f,this.removedDueToLooping=i}}e.DeltaExtensionsResult=R;class v{static isHostExtension(f,i,s){if(i.getExtensionDescription(f))return!1;const t=s.getExtensionDescription(f);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(f,i){this._activationEventsReader=f,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(a),this._extensionsMap=new r.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const f of this._extensionDescriptions){if(this._extensionsMap.has(f.identifier)){console.error("Extension `"+f.identifier.value+"` is already registered");continue}this._extensionsMap.set(f.identifier,f),this._extensionsArr.push(f);const i=this._activationEventsReader.readActivationEvents(f);for(const s of i)this._activationMap.has(s)||this._activationMap.set(s,[]),this._activationMap.get(s).push(f)}}set(f){return this._extensionDescriptions=f,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(f,i){this._extensionDescriptions=m(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(f);const s=v._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=m(this._extensionDescriptions,s.map(t=>t.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new R(this._versionId,s)}static _findLoopingExtensions(f){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,c){this.addNode(h),this.addNode(c),this._arcs.has(h)?this._arcs.get(h).push(c):this._arcs.set(h,[c])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,c){const g=i.getArcs(h);for(let w=0;w<g.length;w++)if(!c.has(g[w]))return!1;return!0}getNodes(){return this._nodesArr}},s=new r.ExtensionIdentifierMap;for(const h of f)if(s.set(h.identifier,h),h.extensionDependencies)for(const c of h.extensionDependencies)i.addArc(r.ExtensionIdentifier.toKey(h.identifier),r.ExtensionIdentifier.toKey(c));const t=new Set;i.getNodes().filter(h=>i.getArcs(h).length===0).forEach(h=>t.add(h));const o=i.getNodes().filter(h=>!t.has(h));let n;do{n=!1;for(let h=0;h<o.length;h++){const c=o[h];i.hasOnlyGoodArcs(c,t)&&(o.splice(h,1),h--,t.add(c),n=!0)}}while(n);return o.map(h=>s.get(h))}containsActivationEvent(f){return this._activationMap.has(f)}containsExtension(f){return this._extensionsMap.has(f)}getExtensionDescriptionsForActivationEvent(f){const i=this._activationMap.get(f);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new l(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(f){const i=this._extensionsMap.get(f);return i||void 0}getExtensionDescriptionByUUID(f){for(const i of this._extensionsArr)if(i.uuid===f)return i}getExtensionDescriptionByIdOrUUID(f,i){return this.getExtensionDescription(f)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=v;class l{constructor(f,i){this.versionId=f,this.extensions=i}}e.ExtensionDescriptionRegistrySnapshot=l;class I{constructor(f){this._lock=new T,this._actual=new v(f,[])}async acquireLock(f){const i=await this._lock.acquire(f);return new y(this,i)}deltaExtensions(f,i,s){if(!f.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,s)}containsActivationEvent(f){return this._actual.containsActivationEvent(f)}containsExtension(f){return this._actual.containsExtension(f)}getExtensionDescriptionsForActivationEvent(f){return this._actual.getExtensionDescriptionsForActivationEvent(f)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(f){return this._actual.getExtensionDescription(f)}getExtensionDescriptionByUUID(f){return this._actual.getExtensionDescriptionByUUID(f)}getExtensionDescriptionByIdOrUUID(f,i){return this._actual.getExtensionDescriptionByIdOrUUID(f,i)}}e.LockableExtensionDescriptionRegistry=I;class y extends k.Disposable{constructor(f,i){super(),this._registry=f,this._isDisposed=!1,this._register(i)}isAcquiredFor(f){return!this._isDisposed&&this._registry===f}}e.ExtensionDescriptionRegistryLock=y;class u{constructor(f){this.name=f;const i=(0,L.promiseWithResolvers)();this.promise=i.promise,this._resolve=i.resolve}resolve(f){this._resolve(f)}}class T{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(f){const i=new u(f);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const f=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${f.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(s),i=!1,this._isLocked=!1,this._advance())};f.resolve((0,k.toDisposable)(t))}}var b;(function(p){p[p.Builtin=0]="Builtin",p[p.User=1]="User",p[p.Dev=2]="Dev"})(b||(b={}));function a(p,f){const i=p.isBuiltin?b.Builtin:p.isUnderDevelopment?b.Dev:b.User,s=f.isBuiltin?b.Builtin:f.isUnderDevelopment?b.Dev:b.User;if(i!==s)return i-s;const t=P.posix.basename(p.extensionLocation.path),o=P.posix.basename(f.extensionLocation.path);return t<o?-1:t>o?1:0}function m(p,f){const i=new r.ExtensionIdentifierSet(f);return p.filter(s=>!i.has(s.identifier))}}),define(Ce[269],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0,e.writeExtHostConnection=R,e.readExtHostConnection=v;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class d{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(y){this.pipeName=y,this.type=r.IPC}serialize(y){y[d.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=d;class P{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(y){y[P.ENV_KEY]="1"}}e.SocketExtHostConnection=P;class k{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(y){y[k.ENV_KEY]="1"}}e.MessagePortExtHostConnection=k;function L(I){delete I[d.ENV_KEY],delete I[P.ENV_KEY],delete I[k.ENV_KEY]}function R(I,y){L(y),I.serialize(y)}function v(I){if(I[d.ENV_KEY])return l(I,new d(I[d.ENV_KEY]));if(I[P.ENV_KEY])return l(I,new P);if(I[k.ENV_KEY])return l(I,new k);throw new Error("No connection information defined in environment!")}function l(I,y){return L(I),y}}),define(Ce[93],Ie([1,0,21]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=L,e.isMessageOfType=R;var d;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(d||(e.UIKind=d={}));var P;(function(l){l[l.VersionMismatch=55]="VersionMismatch",l[l.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var k;(function(l){l[l.Initialized=0]="Initialized",l[l.Ready=1]="Ready",l[l.Terminate=2]="Terminate"})(k||(e.MessageType=k={}));function L(l){const I=r.VSBuffer.alloc(1);switch(l){case k.Initialized:I.writeUInt8(1,0);break;case k.Ready:I.writeUInt8(2,0);break;case k.Terminate:I.writeUInt8(3,0);break}return I}function R(l,I){if(l.byteLength!==1)return!1;switch(l.readUInt8(0)){case 1:return I===k.Initialized;case 2:return I===k.Ready;case 3:return I===k.Terminate;default:return!1}}var v;(function(l){l.Start="START_NATIVE_LOG",l.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Ce[94],Ie([1,0,5,4,149,11,29,93,90,91,24,2,3,8]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=m;let b=class extends u.Disposable{constructor(f,i){super(),this.initData=f,this.loggerService=i,this._onDidChangeTelemetryEnabled=this._register(new d.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new d.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=P.TelemetryLevel.NONE,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=y.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=i.createLogger(this.extHostTelemetryLogFile,{id:l.extensionTelemetryLogChannelId,name:(0,T.localize)(10825,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(i.onDidChangeLogLevel(s=>{(0,k.isLogLevel)(s)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===k.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this._level>=P.TelemetryLevel.CRASH,isErrorsEnabled:this._productConfig.error?this._level>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this._productConfig.usage?this._level>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(f,i,s){const t=this.getTelemetryDetails(),o=new a(i,s,f,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(f),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),n=this._telemetryLoggers.get(f.identifier.value)??[];return this._telemetryLoggers.set(f.identifier.value,[...n,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(f,i,s){this._level=f,this._telemetryIsSupported=i,this._productConfig=s??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(f){const i=Object.create(null);switch(i["common.extname"]=`${f.publisher}.${f.name}`,i["common.extversion"]=f.version,i["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,i["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,i["common.sqmid"]=this.initData.telemetryInfo.sqmId,i["common.devDeviceId"]=this.initData.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.initData.version,i["common.isnewappinstall"]=m(this.initData.telemetryInfo.firstSessionDate),i["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,v.getRemoteName)((0,l.cleanRemoteAuthority)(this.initData.remote.authority)),i}$onDidChangeTelemetryLevel(f){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=f;const i=this.getTelemetryDetails();this._telemetryLoggers.forEach((s,t)=>{const o=s.filter(n=>!n.isDisposed);o.length===0?this._telemetryLoggers.delete(t):this._telemetryLoggers.set(t,o)}),this._telemetryLoggers.forEach(s=>{for(const t of s)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(f,i){const t=this._telemetryLoggers.get(f.value)?.filter(n=>!n.isDisposed);if(!t)return this._telemetryLoggers.delete(f.value),!1;let o=!1;for(const n of t)n.ignoreUnhandledExtHostErrors||(n.logError(i),o=!0);return o}};e.ExtHostTelemetry=b,e.ExtHostTelemetry=b=Xe([He(0,L.IExtHostInitDataService),He(1,k.ILoggerService)],b);class a{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,i,s,t,o,n,h){this._extension=s,this._logger=t,this._inLoggingOnlyMode=o,this._commonProperties=n,this._onDidChangeEnableStates=new d.Emitter,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=i?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=i?.additionalCommonProperties,this._sender=f,this._telemetryEnablements={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(f,i){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:f,isErrorsEnabled:i},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(f){let i="properties"in f?f.properties??{}:f;return i=(0,l.cleanData)(i,[]),this._additionalCommonProperties&&(i=(0,I.mixin)(i,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(i=(0,I.mixin)(i,this._commonProperties)),"properties"in f?f.properties=i:f=i,f}logEvent(f,i){this._sender&&(this._extension.publisher==="vscode"?f=this._extension.name+"/"+f:f=this._extension.identifier.value+"/"+f,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(f,i),this._logger.trace(f,i))}logUsage(f,i){this._telemetryEnablements.isUsageEnabled&&this.logEvent(f,i)}logError(f,i){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof f=="string")this.logEvent(f,i);else{const s={name:f.name,message:f.message,stack:f.stack,cause:f.cause},t=(0,l.cleanData)(s,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(o,i),this._logger.trace("exception",i)}}get apiTelemetryLogger(){if(!this._apiObject){const f=this,i={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return f._telemetryEnablements.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f._onDidChangeEnableStates.event.bind(f)};this._apiObject=Object.freeze(i)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let f=this._sender;this._sender=void 0,Promise.resolve(f.flush()).then(f=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=a;function m(p){const f=Date.now()-new Date(p).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ce[25],Ie([1,0,4,2,240,147,23,5]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=u,e.checkProposedApiEnabled=T,e.toExtension=p,e.toExtensionDescription=f,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:d.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class v{constructor(t){this.dependency=t}}e.MissingExtensionDependency=v;var l;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(l||(e.ExtensionHostStartup=l={}));class I{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(t,o,n){this._versionId=t,this._allExtensions=o.slice(0),this._myExtensions=n.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:k.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(t,o,n){if(this._versionId>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this._versionId})`);const h=[],c=[],g=[],w=[],D=y(this._allExtensions),_=y(o),C=(N,O)=>N.extensionLocation.toString()===O.extensionLocation.toString()||N.isBuiltin===O.isBuiltin||N.isUserBuiltin===O.isUserBuiltin||N.isUnderDevelopment===O.isUnderDevelopment;for(const N of this._allExtensions){const O=_.get(N.identifier);if(!O){h.push(N.identifier),D.delete(N.identifier);continue}if(!C(N,O)){h.push(N.identifier),D.delete(N.identifier);continue}}for(const N of o){const O=D.get(N.identifier);if(!O){c.push(N);continue}if(!C(O,N)){h.push(O.identifier),D.delete(O.identifier);continue}}const A=new L.ExtensionIdentifierSet(this._myExtensions),E=new L.ExtensionIdentifierSet(n);for(const N of this._myExtensions)E.has(N)||g.push(N);for(const N of n)A.has(N)||w.push(N);const S=k.ImplicitActivationEvents.createActivationEventsMap(c),F={versionId:t,toRemove:h,toAdd:c,addActivationEvents:S,myToRemove:g,myToAdd:w};return this.delta(F),F}delta(t){if(this._versionId>=t.versionId)return null;const{toRemove:o,toAdd:n,myToRemove:h,myToAdd:c}=t,g=new L.ExtensionIdentifierSet(o),w=new L.ExtensionIdentifierSet(h);for(let D=0;D<this._allExtensions.length;D++)g.has(this._allExtensions[D].identifier)&&(this._allExtensions.splice(D,1),D--);for(let D=0;D<this._myExtensions.length;D++)w.has(this._myExtensions[D])&&(this._myExtensions.splice(D,1),D--);for(const D of n)this._allExtensions.push(D);for(const D of c)this._myExtensions.push(D);return this._myActivationEvents=null,t}containsExtension(t){for(const o of this._myExtensions)if(L.ExtensionIdentifier.equals(o,t))return!0;return!1}containsActivationEvent(t){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(t)}_readMyActivationEvents(){const t=new Set;for(const o of this._allExtensions){if(!this.containsExtension(o.identifier))continue;const n=k.ImplicitActivationEvents.readActivationEvents(o);for(const h of n)t.add(h)}return t}}e.ExtensionHostExtensions=I;function y(s){const t=new L.ExtensionIdentifierMap;for(const o of s)t.set(o.identifier,o);return t}function u(s,t){return s.enabledApiProposals?s.enabledApiProposals.includes(t):!1}function T(s,t){if(!u(s,t))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class b{constructor(t,o,n,h){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=n,this.activationReason=h}}e.ActivationTimes=b;class a{constructor(t,o){this.description=t,this.value=o}}e.ExtensionPointContribution=a;var m;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function p(s){return{type:s.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function f(s,t){const o=(0,P.getExtensionId)(s.manifest.publisher,s.manifest.name);return{id:o,identifier:new L.ExtensionIdentifier(o),isBuiltin:s.type===L.ExtensionType.System,isUserBuiltin:s.type===L.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!t,extensionLocation:s.location,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName,...s.manifest}}class i{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=i}),define(Ce[270],Ie([1,0,13,3,159,23,25,11,7]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0,r=$e(r);class l{static{this.NONE=new l(!1,-1,-1,-1)}constructor(f,i,s,t){this.startup=f,this.codeLoadingTime=i,this.activateCallTime=s,this.activateResolvedTime=t}}e.ExtensionActivationTimes=l;class I{constructor(f){this._startup=f,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(f,i){return f===-1||i===-1?-1:i-f}build(){return new l(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class y{constructor(f,i,s,t,o,n){this.activationFailed=f,this.activationFailedError=i,this.activationTimes=s,this.module=t,this.exports=o,this.disposable=n}}e.ActivatedExtension=y;class u extends y{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,d.Disposable.None)}}e.EmptyExtension=u;class T extends y{constructor(){super(!1,null,l.NONE,{activate:void 0,deactivate:void 0},void 0,d.Disposable.None)}}e.HostExtension=T;class b extends y{constructor(f){super(!0,f,l.NONE,{activate:void 0,deactivate:void 0},void 0,d.Disposable.None)}}let a=class{constructor(f,i,s,t){this._logService=t,this._registry=f,this._globalRegistry=i,this._host=s,this._operations=new k.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[f,i]of this._operations)i.dispose()}async waitForActivatingExtensions(){const f=[];for(const[i,s]of this._operations)f.push(s.wait());await Promise.all(f)}isActivated(f){const i=this._operations.get(f);return!!(i&&i.value)}getActivatedExtension(f){const i=this._operations.get(f);if(!i||!i.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return i.value}async activateByEvent(f,i){if(this._alreadyActivatedEvents[f])return;const s=this._registry.getExtensionDescriptionsForActivationEvent(f);await this._activateExtensions(s.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:f}}))),this._alreadyActivatedEvents[f]=!0}activateById(f,i){const s=this._registry.getExtensionDescription(f);if(!s)throw new Error(`Extension '${f.value}' is not known`);return this._activateExtensions([{id:s.identifier,reason:i}])}async _activateExtensions(f){const i=f.filter(s=>!this.isActivated(s.id)).map(s=>this._handleActivationRequest(s));await Promise.all(i.map(s=>s.wait()))}_handleActivationRequest(f){if(this._operations.has(f.id))return this._operations.get(f.id);if(this._isHostExtension(f.id))return this._createAndSaveOperation(f,null,[],null);const i=this._registry.getExtensionDescription(f.id);if(!i){const o=new Error(`Cannot activate unknown extension '${f.id.value}'`),n=this._createAndSaveOperation(f,null,[],new b(o));return this._host.onExtensionActivationError(f.id,o,new L.MissingExtensionDependency(f.id.value)),n}const s=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this._isResolvedExtension(o))continue;const n=this._operations.get(o);if(n){s.push(n);continue}if(this._isHostExtension(o)){s.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(o).identifier,reason:f.reason}));continue}const h=this._registry.getExtensionDescription(o);if(h){if(!h.main&&!h.browser)continue;s.push(this._handleActivationRequest({id:h.identifier,reason:f.reason}));continue}const c=i.displayName||i.identifier.value,g=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${o}'`),w=this._createAndSaveOperation(f,i.displayName,[],new b(g));return this._host.onExtensionActivationError(i.identifier,g,new L.MissingExtensionDependency(o)),w}return this._createAndSaveOperation(f,i.displayName,s,null)}_createAndSaveOperation(f,i,s,t){const o=new m(f.id,i,f.reason,s,t,this._host,this._logService);return this._operations.set(f.id,o),o}_isHostExtension(f){return P.ExtensionDescriptionRegistry.isHostExtension(f,this._registry,this._globalRegistry)}_isResolvedExtension(f){const i=this._globalRegistry.getExtensionDescription(f);return i?!i.main&&!i.browser:!1}};e.ExtensionsActivator=a,e.ExtensionsActivator=a=Xe([He(3,R.ILogService)],a);let m=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(f,i,s,t,o,n,h){this._id=f,this._displayName=i,this._reason=s,this._deps=t,this._value=o,this._host=n,this._logService=h,this._barrier=new v.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let f=0;f<this._deps.length;f++){const i=this._deps[f];if(i.value&&!i.value.activationFailed){this._deps.splice(f,1),f--;continue}if(i.value&&i.value.activationFailed){const s=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);s.detail=i.value.activationFailedError,this._value=new b(s),this._host.onExtensionActivationError(this._id,s,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(f=>f.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(f){const i=new Error;if(f&&f.name&&(i.name=f.name),f&&f.message?i.message=`Activating extension '${this._id.value}' failed: ${f.message}.`:i.message=`Activating extension '${this._id.value}' failed: ${f}.`,f&&f.stack&&(i.stack=f.stack),this._value=new b(i),this._isDisposed&&r.isCancellationError(f))return;this._host.onExtensionActivationError(this._id,i,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(f)}}};m=Xe([He(6,R.ILogService)],m)});var Wt=this&&this.__importDefault||function(pe){return pe&&pe.__esModule?pe:{default:pe}};define(Ce[160],Ie([1,0,8,13,43,146,116,36,23,115,147,143]),function(pe,e,r,d,P,k,L,R,v,l,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0,r=$e(r),P=Wt(P);const u=R.Registry.as(L.Extensions.JSONContribution);class T{constructor(t,o,n){this._messageHandler=t,this._extension=o,this._extensionPointId=n}_msg(t,o){this._messageHandler({type:t,message:o,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(t){this._msg(P.default.Error,t)}warn(t){this._msg(P.default.Warning,t)}info(t){this._msg(P.default.Info,t)}}e.ExtensionMessageCollector=T;class b{static _toSet(t){const o=new v.ExtensionIdentifierSet;for(let n=0,h=t.length;n<h;n++)o.add(t[n].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new b(o,[]);if(!o||!o.length)return new b([],t);const n=this._toSet(t),h=this._toSet(o),c=o.filter(w=>!n.has(w.description.identifier)),g=t.filter(w=>!h.has(w.description.identifier));return new b(c,g)}constructor(t,o){this.added=t,this.removed=o}}e.ExtensionPointUserDelta=b;class a{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this._handler=null,this._users=null,this._delta=null}setHandler(t){if(this._handler!==null)throw new Error("Handler already set!");return this._handler=t,this._handle(),{dispose:()=>{this._handler=null}}}acceptUsers(t){this._delta=b.compute(this._users,t),this._users=t,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(t){(0,d.onUnexpectedError)(t)}}}e.ExtensionPoint=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(1843,null),r.localize(1844,null)]},p="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(1845,null),properties:{vscode:{type:"string",description:r.localize(1846,null),default:"^1.22.0"}}},publisher:{description:r.localize(1847,null),type:"string"},displayName:{description:r.localize(1848,null),type:"string"},categories:{description:r.localize(1849,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(1850,null)}]}},galleryBanner:{type:"object",description:r.localize(1851,null),properties:{color:{description:r.localize(1852,null),type:"string"},theme:{description:r.localize(1853,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(1854,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(1855,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(1856,null)},enabledApiProposals:{markdownDescription:r.localize(1857,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(s=>s),markdownEnumDescriptions:Object.values(y.allApiProposals).map(s=>s.proposal)}},api:{markdownDescription:r.localize(1858,null),type:"string",enum:["none"],enumDescriptions:[r.localize(1859,null)]},activationEvents:{description:r.localize(1860,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(1861,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(1862,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(1863,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(1864,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(1865,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(1866,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(1867,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(1868,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(1869,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(1870,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(1871,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(1872,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(1873,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(1874,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(1875,null)},{label:"onUri",body:"onUri",description:r.localize(1876,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(1877,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(1878,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(1879,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(1880,null)},{label:"onRenderer",description:r.localize(1881,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(1882,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(1883,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(1884,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(1885,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:r.localize(1886,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:r.localize(1887,null)},{label:"*",description:r.localize(1888,null),body:"*"}]}},badges:{type:"array",description:r.localize(1889,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(1890,null)},href:{type:"string",description:r.localize(1891,null)},description:{type:"string",description:r.localize(1892,null)}}}},markdown:{type:"string",description:r.localize(1893,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(1894,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(1895,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(1896,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(1897,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(1898,null)},{body:["workspace"],description:r.localize(1899,null)},{body:["ui","workspace"],description:r.localize(1900,null)},{body:["workspace","ui"],description:r.localize(1901,null)},{body:[],description:r.localize(1902,null)}]},capabilities:{description:r.localize(1903,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(1904,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(1905,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(1906,null),r.localize(1907,null),r.localize(1908,null)]},description:{type:"string",markdownDescription:r.localize(1909,null)}}},untrustedWorkspaces:{description:r.localize(1910,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(1911,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(1912,null),r.localize(1913,null),r.localize(1914,null)]},restrictedConfigurations:{description:r.localize(1915,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(1916,null)}}}}},sponsor:{description:r.localize(1917,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(1918,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(1919,null),type:"string"},"vscode:uninstall":{description:r.localize(1920,null),type:"string"}}},icon:{type:"string",description:r.localize(1921,null)},l10n:{type:"string",description:r.localize(1922,null)},pricing:{type:"string",markdownDescription:r.localize(1923,null),enum:["Free","Trial"],default:"Free"}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(t){if(this._extensionPoints.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new a(t.extensionPoint,t.defaultExtensionKind);return this._extensionPoints.set(t.extensionPoint,o),t.activationEventsGenerator&&I.ImplicitActivationEvents.register(t.extensionPoint,t.activationEventsGenerator),e.schema.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(p,e.schema),o}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const i={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(i.ExtensionsRegistry,new f),e.ExtensionsRegistry=R.Registry.as(i.ExtensionsRegistry),u.registerSchema(p,e.schema),u.registerSchema(l.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(1924,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(s=>s.proposal)}}]}}}})}),define(Ce[271],Ie([1,0,4,39,3,12,8,23,5,11,25,160]),function(pe,e,r,d,P,k,L,R,v,l,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelsService=e.languageModelExtensionPoint=e.ILanguageModelsService=e.ChatMessageRole=void 0;var u;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.ILanguageModelsService=(0,v.createDecorator)("ILanguageModelsService");const T={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(8422,null)}}};e.languageModelExtensionPoint=y.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(8423,null),oneOf:[T,{type:"array",items:T}]},activationEventsGenerator:(a,m)=>{for(const p of a)m.push(`onLanguageModelChat:${p.vendor}`)}});let b=class{constructor(m,p){this._extensionService=m,this._logService=p,this._store=new P.DisposableStore,this._providers=new Map,this._vendors=new Set,this._onDidChangeProviders=this._store.add(new r.Emitter),this.onDidChangeLanguageModels=this._onDidChangeProviders.event,this._store.add(e.languageModelExtensionPoint.setHandler(f=>{this._vendors.clear();for(const s of f){if(!(0,I.isProposedApiEnabled)(s.description,"chatProvider")){s.collector.error((0,L.localize)(8424,null));continue}for(const t of d.Iterable.wrap(s.value)){if(this._vendors.has(t.vendor)){s.collector.error((0,L.localize)(8425,null,t.vendor));continue}if((0,k.isFalsyOrWhitespace)(t.vendor)){s.collector.error((0,L.localize)(8426,null));continue}if(t.vendor.trim()!==t.vendor){s.collector.error((0,L.localize)(8427,null));continue}this._vendors.add(t.vendor)}}const i=[];for(const[s,t]of this._providers)this._vendors.has(t.metadata.vendor)||(this._providers.delete(s),i.push(s));i.length>0&&this._onDidChangeProviders.fire({removed:i})}))}dispose(){this._store.dispose(),this._providers.clear()}getLanguageModelIds(){return Array.from(this._providers.keys())}lookupLanguageModel(m){return this._providers.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this._extensionService.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const f=Array.from(this._vendors).map(i=>this._extensionService.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(f)}const p=[];for(const[f,i]of this._providers)(m.vendor===void 0||i.metadata.vendor===m.vendor)&&(m.family===void 0||i.metadata.family===m.family)&&(m.version===void 0||i.metadata.version===m.version)&&(m.identifier===void 0||i.metadata.id===m.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(s=>R.ExtensionIdentifier.equals(s,m.extension)))&&p.push(f);return this._logService.trace("[LM] selected language models",m,p),p}registerLanguageModelChat(m,p){if(this._logService.trace("[LM] registering language model chat",m,p.metadata),!this._vendors.has(p.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${p.metadata.vendor}.`);if(this._providers.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this._providers.set(m,p),this._onDidChangeProviders.fire({added:[{identifier:m,metadata:p.metadata}]}),(0,P.toDisposable)(()=>{this._providers.delete(m)&&(this._onDidChangeProviders.fire({removed:[m]}),this._logService.trace("[LM] UNregistered language model chat",m,p.metadata))})}async sendChatRequest(m,p,f,i,s){const t=this._providers.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(f,p,i,s)}computeTokenLength(m,p,f){const i=this._providers.get(m);if(!i)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return i.provideTokenCount(p,f)}};e.LanguageModelsService=b,e.LanguageModelsService=b=Xe([He(0,I.IExtensionService),He(1,l.ILogService)],b)}),define(Ce[272],Ie([1,0,8,17,24,160,35,4]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0,r=$e(r),d=$e(d),P=$e(P);const v={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(3925,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(3926,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(3927,null),default:""}}};var l;(function(u){function T(b,a,m){if(!b)return;const p=d.isString(b.type)?b.type:void 0;if(!p||p.length===0){m.error(r.localize(3928,null));return}const f=[];if(Array.isArray(b.required))for(const i of b.required)d.isString(i)&&f.push(i);return{extensionId:a.value,taskType:p,required:f,properties:b.properties?P.deepClone(b.properties):{},when:b.when?L.ContextKeyExpr.deserialize(b.when):void 0}}u.from=T})(l||(l={}));const I=k.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,T)=>{for(const b of u)b.type&&T.push(`onTaskType:${b.type}`)},jsonSchema:{description:r.localize(3929,null),type:"array",items:v}});class y{constructor(){this._onDefinitionsChanged=new R.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,b)=>{I.setHandler((a,m)=>{this._schema=void 0;try{for(const p of m.removed){const f=p.value;for(const i of f)this.taskTypes&&i.type&&this.taskTypes[i.type]&&delete this.taskTypes[i.type]}for(const p of m.added){const f=p.value;for(const i of f){const s=l.from(i,p.description.identifier,p.collector);s&&(this.taskTypes[s.taskType]=s)}}(m.removed.length>0||m.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const b of this.all()){const a={type:"object",additionalProperties:!1};b.required.length>0&&(a.required=b.required.slice(0)),b.properties!==void 0?a.properties=P.deepClone(b.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[b.taskType]},T.push(a)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistry=new y}),define(Ce[273],Ie([1,0,8,17,22,24,35,272,46]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,r=$e(r),d=$e(d),P=$e(P),k=$e(k),e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new L.RawContextKey("taskRunning",!1,r.localize(3913,null)),e.TASKS_CATEGORY=r.localize2(3915,"Tasks");var l;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(l||(e.ShellQuoting=l={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(x){function z(B){if(!B)return x.Strong;switch(B.toLowerCase()){case"escape":return x.Escape;case"strong":return x.Strong;case"weak":return x.Weak;default:return x.Strong}}x.from=z}(l||(e.ShellQuoting=l={}));var I;(function(x){x.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var y;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(y||(e.RevealKind=y={})),function(x){function z(B){switch(B.toLowerCase()){case"always":return x.Always;case"silent":return x.Silent;case"never":return x.Never;default:return x.Always}}x.fromString=z}(y||(e.RevealKind=y={}));var u;(function(x){x[x.Never=1]="Never",x[x.OnProblem=2]="OnProblem",x[x.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(x){function z(B){switch(B.toLowerCase()){case"always":return x.Always;case"never":return x.Never;case"onproblem":return x.OnProblem;default:return x.OnProblem}}x.fromString=z}(u||(e.RevealProblemKind=u={}));var T;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(T||(e.PanelKind=T={})),function(x){function z(B){switch(B.toLowerCase()){case"shared":return x.Shared;case"dedicated":return x.Dedicated;case"new":return x.New;default:return x.Shared}}x.fromString=z}(T||(e.PanelKind=T={}));var b;(function(x){x.defaults={echo:!0,reveal:y.Always,revealProblems:u.Never,focus:!1,panel:T.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var a;(function(x){x[x.Shell=1]="Shell",x[x.Process=2]="Process",x[x.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(x){function z(ee){switch(ee.toLowerCase()){case"shell":return x.Shell;case"process":return x.Process;case"customExecution":return x.CustomExecution;default:return x.Process}}x.fromString=z;function B(ee){switch(ee){case x.Shell:return"shell";case x.Process:return"process";case x.CustomExecution:return"customExecution";default:return"process"}}x.toString=B}(a||(e.RuntimeType=a={}));var m;(function(x){function z(B){return d.isString(B)?B:B.value}x.value=z})(m||(e.CommandString=m={}));var p;(function(x){x.Clean={_id:"clean",isDefault:!1},x.Build={_id:"build",isDefault:!1},x.Rebuild={_id:"rebuild",isDefault:!1},x.Test={_id:"test",isDefault:!1};function z(ee){return ee===x.Clean._id||ee===x.Build._id||ee===x.Rebuild._id||ee===x.Test._id}x.is=z;function B(ee){if(ee!==void 0)return d.isString(ee)?z(ee)?{_id:ee,isDefault:!1}:void 0:ee}x.from=B})(p||(e.TaskGroup=p={}));var f;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.Folder=3]="Folder"})(f||(e.TaskScope=f={}));var i;(function(x){x.Workspace="workspace",x.Extension="extension",x.InMemory="inMemory",x.WorkspaceFile="workspaceFile",x.User="user";function z(B){switch(B){case x.User:return v.ConfigurationTarget.USER;case x.WorkspaceFile:return v.ConfigurationTarget.WORKSPACE;default:return v.ConfigurationTarget.WORKSPACE_FOLDER}}x.toConfigurationTarget=z})(i||(e.TaskSourceKind=i={}));var s;(function(x){x.parallel="parallel",x.sequence="sequence"})(s||(e.DependsOrder=s={}));var t;(function(x){x[x.default=1]="default",x[x.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(x){x.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class n{constructor(z,B,ee,V,$,G){this._label="",this._id=z,B&&(this._label=B),ee&&(this.type=ee),this.runOptions=V,this.configurationProperties=$,this._source=G}getDefinition(z){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const z={folder:this.getFolderId(),id:this._id};return JSON.stringify(z)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,B=!1){if(z===void 0)return!1;if(d.isString(z))return z===this._label||z===this.configurationProperties.identifier||B&&z===this._id;const ee=this.getDefinition(!0);return ee!==void 0&&ee._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),z&&(this._taskLoadMessages=this._taskLoadMessages.concat(z))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=n;class h extends n{constructor(z,B,ee,V,$,G,Z,le){super(z,ee,void 0,Z,le,B),this.command={},this._source=B,this.hasDefinedMatchers=G,$&&(this.command=$)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case a.Shell:B="shell";break;case a.Process:B="process";break;case a.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(z){return z instanceof h}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const z=this.getFolderId();if(!z)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const ee={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:B};return JSON.stringify(ee)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(z){return new h(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.CustomTask=h;class c extends n{constructor(z,B,ee,V,$,G,Z){super(z,ee,V,G,Z,B),this._source=B,this.configures=$}static is(z){return z instanceof c}fromObject(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const z=this.getFolderId();if(!z)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const ee={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:B};return JSON.stringify(ee)}}e.ConfiguringTask=c;class g extends n{constructor(z,B,ee,V,$,G,Z,le,ne){super(z,ee,V,le,ne,B),this.defines=$,this.hasDefinedMatchers=Z,this.command=G,this.icon=ne.icon,this.hide=ne.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof g}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===f.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.getFolderId(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(z){return new g(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.ContributedTask=g;class w extends n{constructor(z,B,ee,V,$,G){super(z,ee,V,$,G,B),this._source=B}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(z){return new w(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.InMemoryTask=w;var D;(function(x){x[x.Process=1]="Process",x[x.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(x){x._default=x.Terminal}(D||(e.ExecutionEngine=D={}));var _;(function(x){x[x.V0_1_0=1]="V0_1_0",x[x.V2_0_0=2]="V2_0_0"})(_||(e.JsonSchemaVersion=_={}));class C{constructor(z){this._order=new Map;for(let B=0;B<z.length;B++)this._order.set(z[B].uri.toString(),B)}compare(z,B){const ee=z.getWorkspaceFolder(),V=B.getWorkspaceFolder();if(ee&&V){let $=this._order.get(ee.uri.toString());$=$===void 0?0:$+1;let G=this._order.get(V.uri.toString());return G=G===void 0?0:G+1,$===G?z._label.localeCompare(B._label):$-G}else return!ee&&V?-1:ee&&!V?1:0}}e.TaskSorter=C;var A;(function(x){x.DependsOnStarted="dependsOnStarted",x.AcquiredInput="acquiredInput",x.Start="start",x.ProcessStarted="processStarted",x.Active="active",x.Inactive="inactive",x.Changed="changed",x.Terminated="terminated",x.ProcessEnded="processEnded",x.End="end"})(A||(e.TaskEventKind=A={}));var E;(function(x){x.SingleRun="singleRun",x.Background="background"})(E||(e.TaskRunType=E={}));var S;(function(x){x[x.System=0]="System",x[x.User=1]="User",x[x.FolderOpen=2]="FolderOpen",x[x.ConfigurationChange=3]="ConfigurationChange",x[x.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var F;(function(x){function z(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?E.Background:E.SingleRun,group:le.configurationProperties.group,__task:le}}function B(le,ne,_e){return{...z(le),kind:A.Start,terminalId:ne,resolvedVariables:_e}}x.start=B;function ee(le,ne,_e){return{...z(le),kind:A.ProcessStarted,terminalId:ne,processId:_e}}x.processStarted=ee;function V(le,ne,_e){return{...z(le),kind:A.ProcessEnded,terminalId:ne,exitCode:_e}}x.processEnded=V;function $(le,ne,_e){return{...z(le),kind:A.Terminated,exitReason:_e,terminalId:ne}}x.terminated=$;function G(le,ne,_e){return{...z(ne),kind:le,terminalId:_e}}x.general=G;function Z(){return{kind:A.Changed}}x.changed=Z})(F||(e.TaskEvent=F={}));var N;(function(x){function z(ee){const V=Object.keys(ee).sort();let $="";for(const G of V){let Z=ee[G];Z instanceof Object?Z=z(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),$+=G+","+Z+","}return $}function B(ee){const $={_key:z(ee),type:ee.taskType};return Object.assign($,ee),$}x.create=B})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(x){x.AutoDetect="task.autoDetect",x.SaveBeforeRun="task.saveBeforeRun",x.ShowDecorations="task.showDecorations",x.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",x.SlowProviderWarning="task.slowProviderWarning",x.QuickOpenHistory="task.quickOpen.history",x.QuickOpenDetail="task.quickOpen.detail",x.QuickOpenSkip="task.quickOpen.skip",x.QuickOpenShowAll="task.quickOpen.showAll",x.AllowAutomaticTasks="task.allowAutomaticTasks",x.Reconnection="task.reconnection",x.VerboseLogging="task.verboseLogging"})(O||(e.TaskSettingId=O={}));var M;(function(x){x.Tasks="tasks",x.SuppressTaskName="tasks.suppressTaskName",x.Windows="tasks.windows",x.Osx="tasks.osx",x.Linux="tasks.linux",x.ShowOutput="tasks.showOutput",x.IsShellCommand="tasks.isShellCommand",x.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var U;(function(x){function z(B,ee){const V=R.TaskDefinitionRegistry.get(B.type);if(V===void 0){const le=k.deepClone(B);return delete le._key,N.create(le)}const $=Object.create(null);$.type=V.taskType;const G=new Set;V.required.forEach(le=>G.add(le));const Z=V.properties;for(const le of Object.keys(Z)){const ne=B[le];if(ne!=null)$[le]=ne;else if(G.has(le)){const _e=Z[le];if(_e.default!==void 0)$[le]=k.deepClone(_e.default);else switch(_e.type){case"boolean":$[le]=!1;break;case"number":case"integer":$[le]=0;break;case"string":$[le]="";break;default:ee.error(r.localize(3914,null,JSON.stringify(B,void 0,0),le));return}}}return N.create($)}x.createTaskIdentifier=z})(U||(e.TaskDefinition=U={}))}),define(Ce[274],Ie([1,0,13]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class d{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((L,R)=>{this._actualOk=L,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(L){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=L,this._actual&&this._actualOk(L))}resolveErr(L){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=L,this._actual?this._actualErr(L):(0,r.onUnexpectedError)(L))}then(L,R){return this._ensureActual().then(L,R)}catch(L){return this._ensureActual().then(void 0,L)}finally(L){return this._ensureActual().finally(L)}}e.LazyPromise=d;class P extends d{constructor(){super(),this._hasErr=!0,this._err=new r.CancellationError}}e.CanceledLazyPromise=P}),define(Ce[53],Ie([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=P,e.getStringIdentifierForProxy=k;class r{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++r.count}}e.ProxyIdentifier=r;const d=[];function P(R){const v=new r(R);return d[v.nid]=v,v}function k(R){return d[R].sid}class L{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=L}),define(Ce[6],Ie([1,0,53]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var d;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(d||(e.TextEditorRevealType=d={}));var P;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var k;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(k||(e.TabModelOperationKind=k={}));var L;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var R;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var v;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var l;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(l||(e.NotebookEditorRevealType=l={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class y{static{this._n=0}static mixin(m){return m._id=y._n++,m}}e.IdObject=y;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var T;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(T||(e.ISuggestResultDtoField=T={}));var b;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.createProxyIdentifier)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.createProxyIdentifier)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,r.createProxyIdentifier)("MainThreadChatSkills"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,r.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,r.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,r.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,r.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,r.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.createProxyIdentifier)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,r.createProxyIdentifier)("ExtHostChatSkills"),ExtHostChatProvider:(0,r.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,r.createProxyIdentifier)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.createProxyIdentifier)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,r.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[95],Ie([1,0,5,11,6,19]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,P=$e(P),e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let L=class{constructor(v,l){this._extHostLogService=l,this._reportedUsages=new Set,this._telemetryShape=v.getProxy(P.MainContext.MainThreadTelemetry)}report(v,l,I){const y=this.getUsageKey(v,l);this._reportedUsages.has(y)||(this._reportedUsages.add(y),l.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${v}' is deprecated. ${I}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:l.identifier.value,apiId:v}))}getUsageKey(v,l){return`${v}-${l.identifier.value}`}};e.ExtHostApiDeprecationService=L,e.ExtHostApiDeprecationService=L=Xe([He(0,k.IExtHostRpcService),He(1,d.ILogService)],L),e.NullApiDeprecationService=Object.freeze(new class{report(R,v,l){}})}),define(Ce[275],Ie([1,0,6]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class d{constructor(k){const L=k.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(R){return L.$writeText(R)}})}}e.ExtHostClipboard=d}),define(Ce[276],Ie([1,0,24,6,29,19]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let L=class{constructor(I,y){this._mainThreadConsole=I.getProxy(d.MainContext.MainThreadConsole),this._includeStack=y.consoleForward.includeStack,this._logNative=y.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(I,y){const u=this,T=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u._handleConsoleCall(I,y,T,arguments)}})}_handleConsoleCall(I,y,u,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:y,arguments:v(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(I,u,T)}};e.AbstractExtHostConsoleForwarder=L,e.AbstractExtHostConsoleForwarder=L=Xe([He(0,k.IExtHostRpcService),He(1,P.IExtHostInitDataService)],L);const R=1e5;function v(l,I){const y=[];if(l.length)for(let u=0;u<l.length;u++){let T=l[u];if(typeof T>"u")T="undefined";else if(T instanceof Error){const b=T;b.stack?T=b.stack:T=b.toString()}y.push(T)}if(I){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.safeStringify)(y);return u.length>R?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ce[277],Ie([1,0,2,6,25]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(R){this._proxy=R.getProxy(d.MainContext.MainThreadDialogs)}showOpenDialog(R,v){return v?.allowUIResources&&(0,P.checkProposedApiEnabled)(R,"showLocal"),this._proxy.$showOpenDialog(v).then(l=>l?l.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(v=>v?r.URI.revive(v):void 0)}}e.ExtHostDialogs=k}),define(Ce[278],Ie([1,0,20,4,3,6]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEmbeddings=void 0;class L{constructor(v){this._provider=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._allKnownModels=new Set,this._handlePool=0,this._proxy=v.getProxy(k.MainContext.MainThreadEmbeddings)}registerEmbeddingsProvider(v,l,I){if(this._allKnownModels.has(l))throw new Error("An embeddings provider for this model is already registered");const y=this._handlePool++;return this._proxy.$registerEmbeddingProvider(y,l),this._provider.set(y,{id:l,provider:I}),(0,P.toDisposable)(()=>{this._allKnownModels.delete(l),this._proxy.$unregisterEmbeddingProvider(y),this._provider.delete(y)})}async computeEmbeddings(v,l,I){I??=r.CancellationToken.None;let y=!1;typeof l=="string"&&(l=[l],y=!0);const u=await this._proxy.$computeEmbeddings(v,l,I);if(u.length!==l.length)throw new Error;if(y){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(v,l,I){const y=this._provider.get(v);if(!y)return[];const u=await y.provider.provideEmbeddings(l,I);return u||[]}get embeddingsModels(){return Array.from(this._allKnownModels)}$acceptEmbeddingModels(v){this._allKnownModels=new Set(v),this._onDidChange.fire()}}e.ExtHostEmbeddings=L}),define(Ce[279],Ie([1,0,3,6]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(L){this._handlePool=0,this._proxy=L.getProxy(d.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(L){const R=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(R,L),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=P}),define(Ce[122],Ie([1,0,10,12,2,5,11,6,29,19]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let I=class{constructor(u,T,b){this.logService=b,this.bundleCache=new Map,this._proxy=T.getProxy(R.MainContext.MainThreadLocalization),this.currentLanguage=u.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===r.LANGUAGE_DEFAULT}getMessage(u,T){const{message:b,args:a,comment:m}=T;if(this.isDefaultLanguage)return(0,d.format2)(b,a??{});let p=b;m&&m.length>0&&(p+=`/${Array.isArray(m)?m.join(""):m}`);const f=this.bundleCache.get(u)?.contents[p];return f||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${p}`),(0,d.format2)(f??b,a??{})}getBundle(u){return this.bundleCache.get(u)?.contents}getBundleUri(u){return this.bundleCache.get(u)?.uri}async initializeLocalizedMessages(u){if(this.isDefaultLanguage||!u.l10n&&!u.isBuiltin||this.bundleCache.has(u.identifier.value))return;let T;const b=await this.getBundleLocation(u);if(!b){this.logService.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const a=await this._proxy.$fetchBundleContents(b),m=JSON.parse(a);T=u.isBuiltin?m.contents?.bundle:m}catch(a){this.logService.error(`Failed to load translations for ${u.identifier.value} from ${b}: ${a.message}`);return}T&&this.bundleCache.set(u.identifier.value,{contents:T,uri:b})}async getBundleLocation(u){if(u.isBuiltin){const T=await this._proxy.$fetchBuiltInBundleUri(u.identifier.value,this.currentLanguage);return P.URI.revive(T)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=I,e.ExtHostLocalizationService=I=Xe([He(0,v.IExtHostInitDataService),He(1,l.IExtHostRpcService),He(2,L.ILogService)],I),e.IExtHostLocalizationService=(0,k.createDecorator)("IExtHostLocalizationService")}),define(Ce[161],Ie([1,0,11,6,29,19,2,44]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let v=class extends r.AbstractLoggerService{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(T=>(0,R.revive)(T))),this._proxy=y.getProxy(d.MainContext.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(L.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this._proxy.$setVisibility(y,u)}doCreateLogger(y,u,T){return new l(this._proxy,y,u,T)}};e.ExtHostLoggerService=v,e.ExtHostLoggerService=v=Xe([He(0,k.IExtHostRpcService),He(1,P.IExtHostInitDataService)],v);class l extends r.AbstractMessageLogger{constructor(y,u,T,b){super(b?.logLevel==="always"),this.proxy=y,this.file=u,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(T),this.proxy.$createLogger(u,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,u){const T=[[y,u]];this.isLoggerCreated?this.doLog(T):this.buffer.push(...T)}doLog(y){this.proxy.$log(this.file,y)}flush(){this.proxy.$flush(this.file)}}}),define(Ce[123],Ie([1,0,6,5,3,19,21]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,d.createDecorator)("IExtHostManagedSockets");let R=class{constructor(y){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=y.getProxy(r.MainContext.MainThreadManagedSockets)}setFactory(y,u){for(const T of this._managedRemoteSockets.values())T.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new v(y,u),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(y){if(!this._factory||this._factory.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this._remoteSocketIdCounter,T=await this._factory.makeConnection(),b=new P.DisposableStore;return this._managedRemoteSockets.set(u,new l(u,T,b)),b.add((0,P.toDisposable)(()=>this._managedRemoteSockets.delete(u))),b.add(T.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(u),b.dispose()})),b.add(T.onDidClose(a=>{this._proxy.$onDidManagedSocketClose(u,a?.stack??a?.message),b.dispose()})),b.add(T.onDidReceiveMessage(a=>this._proxy.$onDidManagedSocketHaveData(u,L.VSBuffer.wrap(a)))),u}$remoteSocketWrite(y,u){this._managedRemoteSockets.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this._managedRemoteSockets.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this._managedRemoteSockets.get(y)?.actual.drain?.()}};e.ExtHostManagedSockets=R,e.ExtHostManagedSockets=R=Xe([He(0,k.IExtHostRpcService)],R);class v{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class l extends P.Disposable{constructor(y,u,T){super(),this.socketId=y,this.actual=u,this._register(T)}}}),define(Ce[280],Ie([1,0,6,11,25]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function k(R){return R&&R.title}let L=class{constructor(v,l){this._logService=l,this._proxy=v.getProxy(r.MainContext.MainThreadMessageService)}showMessage(v,l,I,y,u){const T={source:{identifier:v.identifier,label:v.displayName||v.name}};let b;typeof y=="string"||k(y)?b=[y,...u]:(T.modal=y?.modal,T.useCustom=y?.useCustom,T.detail=y?.detail,b=u),T.useCustom&&(0,P.checkProposedApiEnabled)(v,"resolvers");const a=[];let m=!1;for(let p=0;p<b.length;p++){const f=b[p];if(typeof f=="string")a.push({title:f,handle:p,isCloseAffordance:!1});else if(typeof f=="object"){const{title:i,isCloseAffordance:s}=f;a.push({title:i,isCloseAffordance:!!s,handle:p}),s&&(m?this._logService.warn(`[${v.identifier}] Only one message item can have 'isCloseAffordance':`,f):m=!0)}else this._logService.warn(`[${v.identifier}] Invalid message item:`,f)}return this._proxy.$showMessage(l,I,T,a).then(p=>{if(typeof p=="number")return b[p]})}};e.ExtHostMessageService=L,e.ExtHostMessageService=L=Xe([He(1,d.ILogService)],L)}),define(Ce[281],Ie([1,0,3,17,2,25,6]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(l){this.handlers=new Map,this.proxy=l.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(l,I,y){if((0,k.checkProposedApiEnabled)(l,"profileContentHandlers"),this.handlers.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.handlers.set(I,y),this.proxy.$registerProfileContentHandler(I,y.name,y.description,l.identifier.value),(0,r.toDisposable)(()=>{this.handlers.delete(I),this.proxy.$unregisterProfileContentHandler(I)})}async $saveProfile(l,I,y,u){const T=this.handlers.get(l);if(!T)throw new Error(`Unknown handler with id: ${l}`);return T.saveProfile(I,y,u)}async $readProfile(l,I,y){const u=this.handlers.get(l);if(!u)throw new Error(`Unknown handler with id: ${l}`);return u.readProfile((0,d.isString)(I)?I:P.URI.revive(I),y)}}e.ExtHostProfileContentHandlers=R}),define(Ce[124],Ie([1,0,6,4,5]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class k{constructor(R){this._onDidChangePassword=new d.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=R.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this._onDidChangePassword.fire(R)}get(R,v){return this._proxy.$getPassword(R,v)}store(R,v,l){return this._proxy.$setPassword(R,v,l)}delete(R,v){return this._proxy.$deletePassword(R,v)}}e.ExtHostSecretState=k,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")}),define(Ce[282],Ie([1,0,20,3,6]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class k{static{this.ID_POOL=1}constructor(R){this.providers=new Map,this.sessions=new Map,this.synthesizers=new Map,this.proxy=R.getProxy(P.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(R,v,l){const I=this.providers.get(R);if(!I)return;const y=new d.DisposableStore,u=new r.CancellationTokenSource;this.sessions.set(v,u);const T=await I.provideSpeechToTextSession(u.token,l?{language:l}:void 0);T&&(y.add(T.onDidChange(b=>{u.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(v,b)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}async $createTextToSpeechSession(R,v,l){const I=this.providers.get(R);if(!I)return;const y=new d.DisposableStore,u=new r.CancellationTokenSource;this.sessions.set(v,u);const T=await I.provideTextToSpeechSession(u.token,l?{language:l}:void 0);T&&(this.synthesizers.set(v,T),y.add(T.onDidChange(b=>{u.token.isCancellationRequested||this.proxy.$emitTextToSpeechEvent(v,b)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(R,v){this.synthesizers.get(R)?.synthesize(v)}async $cancelTextToSpeechSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R),this.synthesizers.delete(R)}async $createKeywordRecognitionSession(R,v){const l=this.providers.get(R);if(!l)return;const I=new d.DisposableStore,y=new r.CancellationTokenSource;this.sessions.set(v,y);const u=await l.provideKeywordRecognitionSession(y.token);u&&(I.add(u.onDidChange(T=>{y.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(v,T)})),I.add(y.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}registerProvider(R,v,l){const I=k.ID_POOL++;return this.providers.set(I,l),this.proxy.$registerProvider(I,v,{extension:R,displayName:R.value}),(0,d.toDisposable)(()=>{this.proxy.$unregisterProvider(I),this.providers.delete(I)})}}e.ExtHostSpeech=k}),define(Ce[125],Ie([1,0,6,4,5]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class k{constructor(R,v){this._logService=v,this._onDidChangeStorage=new d.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=R.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,v){this._proxy.$registerExtensionStorageKeysToSync(R,v)}async initializeExtensionStorage(R,v,l){const I=await this._proxy.$initializeExtensionStorage(R,v);let y;return I&&(y=this.safeParseValue(R,v,I)),y||l}setValue(R,v,l){return this._proxy.$setValue(R,v,l)}$acceptValue(R,v,l){const I=this.safeParseValue(R,v,l);I&&this._onDidChangeStorage.fire({shared:R,key:v,value:I})}safeParseValue(R,v,l){try{return JSON.parse(l)}catch(I){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${R}): ${I}`)}}}e.ExtHostStorage=k,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(Ce[283],Ie([1,0,3,14,2,6]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class L{static{this.supportedSchemes=new Set([d.Schemas.http,d.Schemas.https])}constructor(v){this._openers=new Map,this._proxy=v.getProxy(k.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(v,l,I,y){if(this._openers.has(l))throw new Error(`Opener with id '${l}' already registered`);const u=y.schemes.find(T=>!L.supportedSchemes.has(T));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(l,I),this._proxy.$registerUriOpener(l,y.schemes,v,y.label),(0,r.toDisposable)(()=>{this._openers.delete(l),this._proxy.$unregisterUriOpener(l)})}async $canOpenUri(v,l,I){const y=this._openers.get(v);if(!y)throw new Error(`Unknown opener with id: ${v}`);const u=P.URI.revive(l);return y.canOpenExternalUri(u,I)}async $openUri(v,l,I){const y=this._openers.get(v);if(!y)throw new Error(`Unknown opener id: '${v}'`);return y.openExternalUri(P.URI.revive(l.resolvedUri),{sourceUri:P.URI.revive(l.sourceUri)},I)}}e.ExtHostUriOpeners=L}),define(Ce[284],Ie([1,0,6,2,3,13,23]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{static{this.HandlePool=0}constructor(l){this.handles=new L.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=l.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(l,I){const y=l.identifier;if(this.handles.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=R.HandlePool++;return this.handles.add(y),this.handlers.set(u,I),this._proxy.$registerUriHandler(u,y,l.displayName||l.name),(0,P.toDisposable)(()=>{this.handles.delete(y),this.handlers.delete(u),this._proxy.$unregisterUriHandler(u)})}$handleExternalUri(l,I){const y=this.handlers.get(l);if(!y)return Promise.resolve(void 0);try{y.handleUri(d.URI.revive(I))}catch(u){(0,k.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(l){return d.URI.revive(await this._proxy.$createAppUri(l))}}e.ExtHostUrls=R}),define(Ce[285],Ie([1,0,21,6]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=k,e.deserializeWebviewMessage=R,d=$e(d);class P{constructor(){this.buffers=[]}add(l){let I=this.buffers.indexOf(l);return I<0&&(I=this.buffers.length,this.buffers.push(l)),I}}function k(v,l){if(l.serializeBuffersForPostMessage){const I=new P,u=JSON.stringify(v,(b,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a)};if(ArrayBuffer.isView(a)){const m=L(a);if(m)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a.buffer),view:{type:m,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),T=I.buffers.map(b=>{const a=new Uint8Array(b);return r.VSBuffer.wrap(a)});return{message:u,buffers:T}}else return{message:JSON.stringify(v),buffers:[]}}function L(v){switch(v.constructor.name){case"Int8Array":return d.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return d.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return d.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return d.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return d.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return d.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return d.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return d.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return d.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return d.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return d.WebviewMessageArrayBufferViewType.BigUint64Array}}function R(v,l){const I=l.map(T=>{const b=new ArrayBuffer(T.byteLength);return new Uint8Array(b).set(T.buffer),b}),y=l.length?(T,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const a=b,{index:m}=a,p=I[m];if(a.view)switch(a.view.type){case d.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(p,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(p,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(p,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(p,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(p,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(p,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(p,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(p,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(p,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(p,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case d.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(p,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return b}:void 0;return{message:JSON.parse(v,y),arrayBuffers:I}}}),define(Ce[96],Ie([1,0,4,3,14,24,2,235,285,121,6]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=u,e.toExtensionData=a,e.serializeWebviewOptions=m,k=$e(k),I=$e(I);class y{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;constructor(s,t,o,n,h,c,g){this.#a="",this.#l=!1,this.#c=!1,this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new r.Emitter,this._onDidDispose=this.#d.event,this.#e=s,this.#t=t,this.#o=o,this.#n=n,this.#s=h,this.#r=c,this.#u=u(c),this.#h=T(c),this.#i=g}#d;dispose(){this.#l=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#c=!0,(0,l.asWebviewUri)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===P.Schemas.https||s.scheme===P.Schemas.http){let t=s.toString();return t.endsWith("/")||(t+="/"),t+" "+l.webviewGenericCspSource}return l.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(s){this.assertNotDisposed(),this.#a!==s&&(this.#a=s,this.#h&&!this.#c&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#c=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(s)))}get options(){return this.assertNotDisposed(),this.#o}set options(s){this.assertNotDisposed(),k.equals(this.#o,s)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#l)return!1;const t=(0,v.serializeWebviewMessage)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(s){if(!this.#h)return s;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,h,c,g,w,D)=>{const _=L.URI.from({scheme:g||"file",path:decodeURIComponent(w)}),C=(0,l.asWebviewUri)(_,{isRemote:t,authority:o}).toString();return`${h}${C}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,h,c,g,w,D)=>{const _=L.URI.from({scheme:g||"file",path:decodeURIComponent(w)}),C=(0,l.asWebviewUri)(_,{isRemote:t,authority:o}).toString();return`${h}${C}${D}`})}}e.ExtHostWebview=y;function u(i){try{const s=(0,R.normalizeVersion)((0,R.parseVersion)(i.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function T(i){try{const s=(0,R.normalizeVersion)((0,R.parseVersion)(i.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class b extends d.Disposable{constructor(s,t,o,n,h){super(),this.remoteInfo=t,this.workspace=o,this._logService=n,this._deprecationService=h,this._webviews=new Map,this._webviewProxy=s.getProxy(I.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const s of this._webviews.values())s.dispose();this._webviews.clear()}$onMessage(s,t,o){const n=this.getWebview(s);if(n){const{message:h}=(0,v.deserializeWebviewMessage)(t,o.value);n._onMessageEmitter.fire(h)}}$onMissingCsp(s,t){this._logService.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,t,o){const n=new y(s,this._webviewProxy,p(t),this.remoteInfo,this.workspace,o,this._deprecationService);this._webviews.set(s,n);const h=n._onDidDispose(()=>{h.dispose(),this.deleteWebview(s)});return n}deleteWebview(s){this._webviews.delete(s)}getWebview(s){return this._webviews.get(s)}}e.ExtHostWebviews=b;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,s,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||f(i,s)}}function p(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(s=>L.URI.from(s))}}function f(i,s){return[...(s?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Ce[162],Ie([1,0,4,14,12,2,5,19,6]),function(pe,e,r,d,P,k,L,R,v){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class{static{l=this}static{this.InitialState={focused:!0,active:!0}}getState(){const u=this._state;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=l.InitialState,this._proxy=u.getProxy(v.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:T,isActive:b})=>{this.onDidChangeWindowProperty("focused",T),this.onDidChangeWindowProperty("active",b)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,T){T!==this._state[u]&&(this._state={...this._state,[u]:T},this._onDidChangeWindowState.fire(this._state))}openUri(u,T){let b;if(typeof u=="string"){b=u;try{u=k.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,P.isFalsyOrWhitespace)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===d.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this._proxy.$openUri(u,b,T)}async asExternalUri(u,T){if((0,P.isFalsyOrWhitespace)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(u,T);return k.URI.from(b)}};e.ExtHostWindow=I,e.ExtHostWindow=I=l=Xe([He(0,R.IExtHostRpcService)],I),e.IExtHostWindow=(0,L.createDecorator)("IExtHostWindow")}),define(Ce[286],Ie([1,0,276,29,19,93]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const L=1024*1024;let R=class extends r.AbstractExtHostConsoleForwarder{constructor(l,I){super(l,I),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(l,I,y){const u=l==="error"||l==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,u.write(`
${k.NativeLogMarkers.Start}
`),I.apply(console,y),u.write(`
${k.NativeLogMarkers.End}
`),this._isMakingConsoleCall=!1}_wrapStream(l,I){const y=process[l],u=y.write;let T="";Object.defineProperty(y,"write",{set:()=>{},get:()=>(b,a,m)=>{if(!this._isMakingConsoleCall){T+=b.toString(a);const p=T.length>L?T.length:T.lastIndexOf(`
`);p!==-1&&(console[I](T.slice(0,p)),T=T.slice(p+1))}u.call(y,b,a,m)}})}};e.ExtHostConsoleForwarder=R,e.ExtHostConsoleForwarder=R=Xe([He(0,P.IExtHostRpcService),He(1,d.IExtHostInitDataService)],R)}),define(Ce[287],Ie([1,0,161,14,229,32]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class L extends r.ExtHostLoggerService{doCreateLogger(v,l,I){return v.scheme===d.Schemas.file?new P.SpdLogLogger(I?.name||(0,k.generateUuid)(),v.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,l):super.doCreateLogger(v,l,I)}registerLogger(v){super.registerLogger(v),this._proxy.$registerLogger(v)}deregisterLogger(v){super.deregisterLogger(v),this._proxy.$deregisterLogger(v)}}e.ExtHostLoggerService=L}),define(Ce[288],Ie([1,0,7,21,20,26,13,4,3,40,138,274,53]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=f,e.parseJsonAndRestoreBufferRefs=i,L=$e(L);function b(F,N){try{return JSON.stringify(F,N)}catch{return"null"}}const a="$$ref$$",m={[a]:-1};class p{constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function f(F,N=null,O=!1){const M=[];return{jsonString:(O?b:JSON.stringify)(F,(x,z)=>{if(typeof z>"u")return m;if(typeof z=="object"){if(z instanceof d.VSBuffer){const B=M.push(z)-1;return{[a]:B}}if(N)return N(x,z)}return z}),referencedBuffers:M}}function i(F,N,O){return JSON.parse(F,(M,U)=>{if(U){const x=U[a];if(typeof x=="number")return N[x];if(O&&U.$mid===l.MarshalledId.Uri)return O.transformIncoming(U)}return U})}function s(F,N){return JSON.stringify(F,N)}function t(F){return F?(N,O)=>O&&O.$mid===l.MarshalledId.Uri?F.transformOutgoing(O):O:null}var o;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var n;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(n||(e.ResponsiveState=n={}));const h=()=>{},c=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class w extends v.Disposable{static{T=c}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(N,O=null,M=null){super(),this[T]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=N,this._logger=O,this._uriTransformer=M,this._uriReplacer=t(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let U=0,x=u.ProxyIdentifier.count;U<x;U++)this._locals[U]=null,this._proxies[U]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=n.Responsive,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._register(this._protocol.onMessage(U=>this._receiveOneMessage(U)))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(N=>{const O=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],O.resolveErr(L.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(N){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+w.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(N){this._unresponsiveTime=Date.now()+w.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(n.Responsive)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(n.Unresponsive):this._asyncCheckUresponsive.schedule())}_setResponsiveState(N){this._responsiveState!==N&&(this._responsiveState=N,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(N){return this._uriTransformer?(0,I.transformIncomingURIs)(N,this._uriTransformer):N}getProxy(N){const{nid:O,sid:M}=N;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,M)),this._proxies[O]}_createProxy(N,O){const M={get:(U,x)=>(typeof x=="string"&&!U[x]&&x.charCodeAt(0)===k.CharCode.DollarSign&&(U[x]=(...z)=>this._remoteCall(N,x,z)),x===g?O:U[x])};return new Proxy(Object.create(null),M)}set(N,O){return this._locals[N.nid]=O,O}assertRegistered(N){for(let O=0,M=N.length;O<M;O++){const U=N[O];if(!this._locals[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}_receiveOneMessage(N){if(this._isDisposed)return;const O=N.byteLength,M=_.read(N,0),U=M.readUInt8(),x=M.readUInt32();switch(U){case E.RequestJSONArgs:case E.RequestJSONArgsWithCancellation:{let{rpcId:z,method:B,args:ee}=A.deserializeRequestJSONArgs(M);this._uriTransformer&&(ee=(0,I.transformIncomingURIs)(ee,this._uriTransformer)),this._receiveRequest(O,x,z,B,ee,U===E.RequestJSONArgsWithCancellation);break}case E.RequestMixedArgs:case E.RequestMixedArgsWithCancellation:{let{rpcId:z,method:B,args:ee}=A.deserializeRequestMixedArgs(M);this._uriTransformer&&(ee=(0,I.transformIncomingURIs)(ee,this._uriTransformer)),this._receiveRequest(O,x,z,B,ee,U===E.RequestMixedArgsWithCancellation);break}case E.Acknowledged:{this._logger?.logIncoming(O,x,o.LocalSide,"ack"),this._onDidReceiveAcknowledge(x);break}case E.Cancel:{this._receiveCancel(O,x);break}case E.ReplyOKEmpty:{this._receiveReply(O,x,void 0);break}case E.ReplyOKJSON:{let z=A.deserializeReplyOKJSON(M);this._uriTransformer&&(z=(0,I.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReply(O,x,z);break}case E.ReplyOKJSONWithBuffers:{const z=A.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(O,x,z);break}case E.ReplyOKVSBuffer:{const z=A.deserializeReplyOKVSBuffer(M);this._receiveReply(O,x,z);break}case E.ReplyErrError:{let z=A.deserializeReplyErrError(M);this._uriTransformer&&(z=(0,I.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReplyErr(O,x,z);break}case E.ReplyErrEmpty:{this._receiveReplyErr(O,x,void 0);break}default:console.error("received unexpected message"),console.error(N)}}_receiveRequest(N,O,M,U,x,z){this._logger?.logIncoming(N,O,o.OtherSide,`receiveRequest ${(0,u.getStringIdentifierForProxy)(M)}.${U}(`,x);const B=String(O);let ee,V;if(z){const G=new P.CancellationTokenSource;x.push(G.token),ee=this._invokeHandler(M,U,x),V=()=>G.cancel()}else ee=this._invokeHandler(M,U,x),V=h;this._cancelInvokedHandlers[B]=V;const $=A.serializeAcknowledged(O);this._logger?.logOutgoing($.byteLength,O,o.OtherSide,"ack"),this._protocol.send($),ee.then(G=>{delete this._cancelInvokedHandlers[B];const Z=A.serializeReplyOK(O,G,this._uriReplacer);this._logger?.logOutgoing(Z.byteLength,O,o.OtherSide,"reply:",G),this._protocol.send(Z)},G=>{delete this._cancelInvokedHandlers[B];const Z=A.serializeReplyErr(O,G);this._logger?.logOutgoing(Z.byteLength,O,o.OtherSide,"replyErr:",G),this._protocol.send(Z)})}_receiveCancel(N,O){this._logger?.logIncoming(N,O,o.OtherSide,"receiveCancel");const M=String(O);this._cancelInvokedHandlers[M]?.()}_receiveReply(N,O,M){this._logger?.logIncoming(N,O,o.LocalSide,"receiveReply:",M);const U=String(O);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const x=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U],x.resolveOk(M)}_receiveReplyErr(N,O,M){this._logger?.logIncoming(N,O,o.LocalSide,"receiveReplyErr:",M);const U=String(O);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const x=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U];let z;M&&(M.$isError?(z=new Error,z.name=M.name,z.message=M.message,z.stack=M.stack):z=M),x.resolveErr(z)}_invokeHandler(N,O,M){try{return Promise.resolve(this._doInvokeHandler(N,O,M))}catch(U){return Promise.reject(U)}}_doInvokeHandler(N,O,M){const U=this._locals[N];if(!U)throw new Error("Unknown actor "+(0,u.getStringIdentifierForProxy)(N));const x=U[O];if(typeof x!="function")throw new Error("Unknown method "+O+" on actor "+(0,u.getStringIdentifierForProxy)(N));return x.apply(U,M)}_remoteCall(N,O,M){if(this._isDisposed)return new y.CanceledLazyPromise;let U=null;if(M.length>0&&P.CancellationToken.isCancellationToken(M[M.length-1])&&(U=M.pop()),U&&U.isCancellationRequested)return Promise.reject(L.canceled());const x=A.serializeRequestArguments(M,this._uriReplacer),z=++this._lastMessageId,B=String(z),ee=new y.LazyPromise,V=new v.DisposableStore;U&&V.add(U.onCancellationRequested(()=>{const G=A.serializeCancel(z);this._logger?.logOutgoing(G.byteLength,z,o.LocalSide,"cancel"),this._protocol.send(A.serializeCancel(z))})),this._pendingRPCReplies[B]=new D(ee,V),this._onWillSendRequest(z);const $=A.serializeRequest(z,N,O,x,!!U);return this._logger?.logOutgoing($.byteLength,z,o.LocalSide,`request: ${(0,u.getStringIdentifierForProxy)(N)}.${O}(`,M),this._protocol.send($),ee}}e.RPCProtocol=w;class D{constructor(N,O){this._promise=N,this._disposable=O}resolveOk(N){this._promise.resolveOk(N),this._disposable.dispose()}resolveErr(N){this._promise.resolveErr(N),this._disposable.dispose()}}class _{static alloc(N,O,M){const U=new _(d.VSBuffer.alloc(M+1+4),0);return U.writeUInt8(N),U.writeUInt32(O),U}static read(N,O){return new _(N,O)}get buffer(){return this._buff}constructor(N,O){this._buff=N,this._offset=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this._buff.writeUInt8(N,this._offset),this._offset+=1}readUInt8(){const N=this._buff.readUInt8(this._offset);return this._offset+=1,N}writeUInt32(N){this._buff.writeUInt32BE(N,this._offset),this._offset+=4}readUInt32(){const N=this._buff.readUInt32BE(this._offset);return this._offset+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this._buff.writeUInt8(N.byteLength,this._offset),this._offset+=1,this._buff.set(N,this._offset),this._offset+=N.byteLength}readShortString(){const N=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+N).toString();return this._offset+=N,M}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}readLongString(){const N=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+N).toString();return this._offset+=N,M}writeBuffer(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}readVSBuffer(){const N=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+N);return this._offset+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let M=0,U=N.length;M<U;M++){const x=N[M];switch(O+=1,x.type){case S.String:O+=this.sizeLongString(x.value);break;case S.VSBuffer:O+=this.sizeVSBuffer(x.value);break;case S.SerializedObjectWithBuffers:O+=this.sizeUInt32,O+=this.sizeLongString(x.value);for(let z=0;z<x.buffers.length;++z)O+=this.sizeVSBuffer(x.buffers[z]);break;case S.Undefined:break}}return O}writeMixedArray(N){this._buff.writeUInt8(N.length,this._offset),this._offset+=1;for(let O=0,M=N.length;O<M;O++){const U=N[O];switch(U.type){case S.String:this.writeUInt8(S.String),this.writeLongString(U.value);break;case S.VSBuffer:this.writeUInt8(S.VSBuffer),this.writeVSBuffer(U.value);break;case S.SerializedObjectWithBuffers:this.writeUInt8(S.SerializedObjectWithBuffers),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let x=0;x<U.buffers.length;++x)this.writeBuffer(U.buffers[x]);break;case S.Undefined:this.writeUInt8(S.Undefined);break}}}readMixedArray(){const N=this._buff.readUInt8(this._offset);this._offset+=1;const O=new Array(N);for(let M=0;M<N;M++)switch(this.readUInt8()){case S.String:O[M]=this.readLongString();break;case S.VSBuffer:O[M]=this.readVSBuffer();break;case S.SerializedObjectWithBuffers:{const x=this.readUInt32(),z=this.readLongString(),B=[];for(let ee=0;ee<x;++ee)B.push(this.readVSBuffer());O[M]=new u.SerializableObjectWithBuffers(i(z,B,null));break}case S.Undefined:O[M]=void 0;break}return O}}var C;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(C||(C={}));class A{static _useMixedArgSerialization(N){for(let O=0,M=N.length;O<M;O++)if(N[O]instanceof d.VSBuffer||N[O]instanceof u.SerializableObjectWithBuffers||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this._useMixedArgSerialization(N)){const M=[];for(let U=0,x=N.length;U<x;U++){const z=N[U];if(z instanceof d.VSBuffer)M[U]={type:S.VSBuffer,value:z};else if(typeof z>"u")M[U]={type:S.Undefined};else if(z instanceof u.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:ee}=f(z.value,O);M[U]={type:S.SerializedObjectWithBuffers,value:d.VSBuffer.fromString(B),buffers:ee}}else M[U]={type:S.String,value:d.VSBuffer.fromString(s(z,O))}}return{type:C.Mixed,args:M}}return{type:C.Simple,args:s(N,O)}}static serializeRequest(N,O,M,U,x){switch(U.type){case C.Simple:return this._requestJSONArgs(N,O,M,U.args,x);case C.Mixed:return this._requestMixedArgs(N,O,M,U.args,x)}}static _requestJSONArgs(N,O,M,U,x){const z=d.VSBuffer.fromString(M),B=d.VSBuffer.fromString(U);let ee=0;ee+=_.sizeUInt8(),ee+=_.sizeShortString(z),ee+=_.sizeLongString(B);const V=_.alloc(x?E.RequestJSONArgsWithCancellation:E.RequestJSONArgs,N,ee);return V.writeUInt8(O),V.writeShortString(z),V.writeLongString(B),V.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),M=N.readShortString(),U=N.readLongString();return{rpcId:O,method:M,args:JSON.parse(U)}}static _requestMixedArgs(N,O,M,U,x){const z=d.VSBuffer.fromString(M);let B=0;B+=_.sizeUInt8(),B+=_.sizeShortString(z),B+=_.sizeMixedArray(U);const ee=_.alloc(x?E.RequestMixedArgsWithCancellation:E.RequestMixedArgs,N,B);return ee.writeUInt8(O),ee.writeShortString(z),ee.writeMixedArray(U),ee.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),M=N.readShortString(),U=N.readMixedArray(),x=new Array(U.length);for(let z=0,B=U.length;z<B;z++){const ee=U[z];typeof ee=="string"?x[z]=JSON.parse(ee):x[z]=ee}return{rpcId:O,method:M,args:x}}static serializeAcknowledged(N){return _.alloc(E.Acknowledged,N,0).buffer}static serializeCancel(N){return _.alloc(E.Cancel,N,0).buffer}static serializeReplyOK(N,O,M){if(typeof O>"u")return this._serializeReplyOKEmpty(N);if(O instanceof d.VSBuffer)return this._serializeReplyOKVSBuffer(N,O);if(O instanceof u.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:x}=f(O.value,M,!0);return this._serializeReplyOKJSONWithBuffers(N,U,x)}else return this._serializeReplyOKJSON(N,b(O,M))}static _serializeReplyOKEmpty(N){return _.alloc(E.ReplyOKEmpty,N,0).buffer}static _serializeReplyOKVSBuffer(N,O){let M=0;M+=_.sizeVSBuffer(O);const U=_.alloc(E.ReplyOKVSBuffer,N,M);return U.writeVSBuffer(O),U.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static _serializeReplyOKJSON(N,O){const M=d.VSBuffer.fromString(O);let U=0;U+=_.sizeLongString(M);const x=_.alloc(E.ReplyOKJSON,N,U);return x.writeLongString(M),x.buffer}static _serializeReplyOKJSONWithBuffers(N,O,M){const U=d.VSBuffer.fromString(O);let x=0;x+=_.sizeUInt32,x+=_.sizeLongString(U);for(const B of M)x+=_.sizeVSBuffer(B);const z=_.alloc(E.ReplyOKJSONWithBuffers,N,x);z.writeUInt32(M.length),z.writeLongString(U);for(const B of M)z.writeBuffer(B);return z.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const M=N.readUInt32(),U=N.readLongString(),x=[];for(let z=0;z<M;++z)x.push(N.readVSBuffer());return new u.SerializableObjectWithBuffers(i(U,x,O))}static serializeReplyErr(N,O){const M=O?b(L.transformErrorForSerialization(O),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(N);const U=d.VSBuffer.fromString(M);let x=0;x+=_.sizeLongString(U);const z=_.alloc(E.ReplyErrError,N,x);return z.writeLongString(U),z.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(N){return _.alloc(E.ReplyErrEmpty,N,0).buffer}}var E;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(E||(E={}));var S;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(S||(S={}))}),define(Ce[289],Ie([1,0,21,28,14,88,5]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=I,e.generate=y,e.INotebookDocumentService=(0,L.createDecorator)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${R.join("")}]+`),l=7;function I(T){if(T.scheme!==P.Schemas.vscodeNotebookCell)return;const b=T.fragment.indexOf("s");if(b<0)return;const a=parseInt(T.fragment.substring(0,b).replace(v,""),l),m=(0,r.decodeBase64)(T.fragment.substring(b+1)).toString();if(!isNaN(a))return{handle:a,notebook:T.with({scheme:m,fragment:null})}}function y(T,b){const a=b.toString(l),p=`${a.length<R.length?R[a.length-1]:"z"}${a}s${(0,r.encodeBase64)(r.VSBuffer.fromString(T.scheme),!0,!0)}`;return T.with({scheme:P.Schemas.vscodeNotebookCell,fragment:p})}class u{constructor(){this._documents=new d.ResourceMap}getNotebook(b){if(b.scheme===P.Schemas.vscodeNotebookCell){const a=I(b);if(a){const m=this._documents.get(a.notebook);if(m)return m}}return this._documents.get(b)}addNotebookDocument(b){this._documents.set(b.uri,b)}removeNotebookDocument(b){this._documents.delete(b.uri)}}e.NotebookDocumentWorkbenchService=u,(0,k.registerSingleton)(e.INotebookDocumentService,u,k.InstantiationType.Delayed)}),define(Ce[126],Ie([1,0,21,38,39,103,14,16,10,35,289]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookFindScopeType=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.EXECUTE_REPL_COMMAND_ID=e.REPL_EDITOR_ID=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=n,e.isDocumentExcludePattern=g,e.notebookDocumentFilterMatch=w,e.isTextStreamMime=C,e.compressOutputItemStreams=E,d=$e(d),e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive",e.REPL_EDITOR_ID="workbench.editor.repl",e.EXECUTE_REPL_COMMAND_ID="replNotebook.input.execute";var y;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(y||(e.CellKind=y={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",k.Mimes.latex,k.Mimes.markdown,"image/png","image/jpeg",k.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[k.Mimes.latex,k.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",k.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var u;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var T;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(T||(e.NotebookCellExecutionState=T={}));var b;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var a;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var p;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(p||(e.NotebookCellsChangeType=p={}));var f;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(B){B.scheme=L.Schemas.vscodeNotebookCell;function ee(ne,_e){return(0,I.generate)(ne,_e)}B.generate=ee;function V(ne){return(0,I.parse)(ne)}B.parse=V;function $(ne,_e){return ne.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${_e??""},${ne.scheme!==L.Schemas.file?ne.scheme:""}`})}B.generateCellOutputUri=$;function G(ne){if(ne.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const _e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!_e)return;const ge=_e[1]&&_e[1]!==""?_e[1]:void 0,Y=_e[2];return{outputId:ge,notebook:ne.with({scheme:Y||L.Schemas.file,fragment:null})}}B.parseCellOutputUri=G;function Z(ne,_e,ge){return B.generate(ne,_e).with({scheme:ge})}B.generateCellPropertyUri=Z;function le(ne,_e){if(ne.scheme===_e)return B.parse(ne.with({scheme:B.scheme}))}B.parseCellPropertyUri=le})(s||(e.CellUri=s={}));const t=B=>v.isWindows?B.replace(/\//g,"\\"):B;class o{constructor(ee=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=V,this.order=[...new Set(ee)].map($=>({pattern:$,matches:d.parse(t($))}))}sort(ee){const V=new Map(P.Iterable.map(ee,G=>[G,t(G)]));let $=[];for(const{matches:G}of this.order)for(const[Z,le]of V)if(G(le)){$.push(Z),V.delete(Z);break}return V.size&&($=$.concat([...V.keys()].sort((G,Z)=>this.defaultOrder.indexOf(G)-this.defaultOrder.indexOf(Z)))),$}prioritize(ee,V){const $=this.findIndex(ee);if($===-1){this.order.unshift({pattern:ee,matches:d.parse(t(ee))});return}const G=new Set(V.map(le=>this.findIndex(le,$)));G.delete(-1);const Z=Array.from(G).sort();this.order.splice($+1,0,...Z.map(le=>this.order[le]));for(let le=Z.length-1;le>=0;le--)this.order.splice(Z[le],1)}toArray(){return this.order.map(ee=>ee.pattern)}findIndex(ee,V=this.order.length){const $=t(ee);for(let G=0;G<V;G++)if(this.order[G].matches($))return G;return-1}}e.MimeTypeDisplayOrder=o;function n(B,ee,V,$=(G,Z)=>G===Z){const G=[];function Z(_e,ge,Y){if(ge===0&&Y.length===0)return;const W=G[G.length-1];W&&W.start+W.deleteCount===_e?(W.deleteCount+=ge,W.toInsert.push(...Y)):G.push({start:_e,deleteCount:ge,toInsert:Y})}let le=0,ne=0;for(;;){if(le===B.length){Z(le,0,ee.slice(ne));break}if(ne===ee.length){Z(le,B.length-le,[]);break}const _e=B[le],ge=ee[ne];if($(_e,ge)){le+=1,ne+=1;continue}V(ge)?(Z(le,1,[]),le+=1):(Z(le,0,[ge]),ne+=1)}return G}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new l.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new l.RawContextKey("notebookEditorCursorAtLineBoundary","none");var h;(function(B){B.default="default",B.option="option"})(h||(e.NotebookEditorPriority=h={}));var c;(function(B){B.Cells="cells",B.Text="text",B.None="none"})(c||(e.NotebookFindScopeType=c={}));function g(B){const ee=B;return!!((typeof ee.include=="string"||d.isRelativePattern(ee.include))&&(typeof ee.exclude=="string"||d.isRelativePattern(ee.exclude)))}function w(B,ee,V){if(Array.isArray(B.viewType)&&B.viewType.indexOf(ee)>=0||B.viewType===ee)return!0;if(B.filenamePattern){const $=g(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,G=g(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(d.match($,(0,R.basename)(V.fsPath).toLowerCase()))return!(G&&d.match(G,(0,R.basename)(V.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class _{static{this._prefix="notebook/"}static create(ee){return`${_._prefix}${ee}`}static parse(ee){if(ee.startsWith(_._prefix))return ee.substring(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_;function C(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const A=new TextDecoder;function E(B){const ee=[];let V=!1;for(const le of B)(ee.length===0||V)&&(ee.push(le),V=!0);let $=N(ee);const G=r.VSBuffer.concat(ee.map(le=>r.VSBuffer.wrap(le))),Z=z(G);return $=$||Z.byteLength!==G.byteLength,{data:Z,didCompression:$}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const S=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(B=>B.charCodeAt(0)),F=10;function N(B){let ee=!1;return B.forEach((V,$)=>{if($===0||V.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const G=B[$-1],Z=V.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Z[0]===S[0]&&Z[1]===S[1]&&Z[2]===S[2]){const le=G.lastIndexOf(F);if(le===-1)return;ee=!0,B[$-1]=G.subarray(0,le),B[$]=V.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ee}function O(B){let ee=B;do B=ee,ee=B.replace(/[^\n]\x08/gm,"");while(ee.length<B.length);return B}function M(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const ee=B.match(/^(.*)\r+/m)[1];let V=B.match(/\r+(.*)$/m)[1];V=V+ee.slice(V.length,ee.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return B}const U=8,x=13;function z(B){return!B.buffer.includes(U)&&!B.buffer.includes(x)?B:r.VSBuffer.fromString(M(O(A.decode(B.buffer))))}}),define(Ce[9],Ie([1,0,18,13,85,28,103,12,17,2,32,23,27,71,126]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b){"use strict";var a,m,p,f,i,s,t,o,n,h,c,g,w,D,_,C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.LanguageModelTextPart=e.LanguageModelFunctionUsePart=e.LanguageModelChatMessage=e.LanguageModelFunctionResultPart=e.LanguageModelChatMessageRole=e.ChatRequestNotebookData=e.ChatRequestEditorData=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart2=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestMessageStackFrame=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.QuickInputButtonLocation=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.getDebugDescriptionOfRange=x,e.getDebugDescriptionOfSelection=z,e.asStatusBarItemIdentifier=mt,e.setBreakpointId=Ni,e.validateTestCoverageCount=An;function E(K){return Object.assign(K,{apply:function(...me){if(me.length===0)return Reflect.construct(K,[]);{const Le=me.length===1?[]:me[1];return Reflect.construct(K,Le,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(K,[]);{const[Le,...Ye]=me;return Reflect.construct(K,Ye,Le.constructor)}}})}var S;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(S||(e.TerminalOutputAnchor=S={}));var F;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let N=a=class{static from(...j){let me=j;return new a(function(){if(me){for(const Le of me)Le&&typeof Le.dispose=="function"&&Le.dispose();me=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=N,e.Disposable=N=a=Xe([E],N);let O=m=class{static Min(...j){if(j.length===0)throw new TypeError;let me=j[0];for(let Le=1;Le<j.length;Le++){const Ye=j[Le];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...j){if(j.length===0)throw new TypeError;let me=j[0];for(let Le=1;Le<j.length;Le++){const Ye=j[Le];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(j){if(!j)return!1;if(j instanceof m)return!0;const{line:me,character:Le}=j;return typeof me=="number"&&typeof Le=="number"}static of(j){if(j instanceof m)return j;if(this.isPosition(j))return new m(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(j,me){if(j<0)throw(0,d.illegalArgument)("line must be non-negative");if(me<0)throw(0,d.illegalArgument)("character must be non-negative");this._line=j,this._character=me}isBefore(j){return this._line<j._line?!0:j._line<this._line?!1:this._character<j._character}isBeforeOrEqual(j){return this._line<j._line?!0:j._line<this._line?!1:this._character<=j._character}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this._line===j._line&&this._character===j._character}compareTo(j){return this._line<j._line?-1:this._line>j.line?1:this._character<j._character?-1:this._character>j._character?1:0}translate(j,me=0){if(j===null||me===null)throw(0,d.illegalArgument)();let Le;return typeof j>"u"?Le=0:typeof j=="number"?Le=j:(Le=typeof j.lineDelta=="number"?j.lineDelta:0,me=typeof j.characterDelta=="number"?j.characterDelta:0),Le===0&&me===0?this:new m(this.line+Le,this.character+me)}with(j,me=this.character){if(j===null||me===null)throw(0,d.illegalArgument)();let Le;return typeof j>"u"?Le=this.line:typeof j=="number"?Le=j:(Le=typeof j.line=="number"?j.line:this.line,me=typeof j.character=="number"?j.character:this.character),Le===this.line&&me===this.character?this:new m(Le,me)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.Position=O,e.Position=O=m=Xe([E],O);let M=p=class{static isRange(j){return j instanceof p?!0:j?O.isPosition(j.start)&&O.isPosition(j.end):!1}static of(j){if(j instanceof p)return j;if(this.isRange(j))return new p(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(j,me,Le,Ye){let ot,pt;if(typeof j=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ye=="number"?(ot=new O(j,me),pt=new O(Le,Ye)):O.isPosition(j)&&O.isPosition(me)&&(ot=O.of(j),pt=O.of(me)),!ot||!pt)throw new Error("Invalid arguments");ot.isBefore(pt)?(this._start=ot,this._end=pt):(this._start=pt,this._end=ot)}contains(j){return p.isRange(j)?this.contains(j.start)&&this.contains(j.end):O.isPosition(j)?!(O.of(j).isBefore(this._start)||this._end.isBefore(j)):!1}isEqual(j){return this._start.isEqual(j._start)&&this._end.isEqual(j._end)}intersection(j){const me=O.Max(j.start,this._start),Le=O.Min(j.end,this._end);if(!me.isAfter(Le))return new p(me,Le)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const me=O.Min(j.start,this._start),Le=O.Max(j.end,this.end);return new p(me,Le)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(j,me=this.end){if(j===null||me===null)throw(0,d.illegalArgument)();let Le;return j?O.isPosition(j)?Le=j:(Le=j.start||this.start,me=j.end||this.end):Le=this.start,Le.isEqual(this._start)&&me.isEqual(this.end)?this:new p(Le,me)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return x(this)}};e.Range=M,e.Range=M=p=Xe([E],M);let U=f=class extends M{static isSelection(j){return j instanceof f?!0:j?M.isRange(j)&&O.isPosition(j.anchor)&&O.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(j,me,Le,Ye){let ot,pt;if(typeof j=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ye=="number"?(ot=new O(j,me),pt=new O(Le,Ye)):O.isPosition(j)&&O.isPosition(me)&&(ot=O.of(j),pt=O.of(me)),!ot||!pt)throw new Error("Invalid arguments");super(ot,pt),this._anchor=ot,this._active=pt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return z(this)}};e.Selection=U,e.Selection=U=f=Xe([E],U);function x(K){return K.isEmpty?`[${K.start.line}:${K.start.character})`:`[${K.start.line}:${K.start.character} -> ${K.end.line}:${K.end.character})`}function z(K){let j=x(K);return K.isEmpty||(K.active.isEqual(K.start)?j=`|${j}`:j=`${j}|`),j}const B=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,d.illegalArgument)("connectionToken")};class ee{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,me,Le){if(typeof j!="string"||j.length===0)throw(0,d.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,d.illegalArgument)("port");typeof Le<"u"&&B(Le),this.host=j,this.port=Math.round(me),this.connectionToken=Le}}e.ResolvedAuthority=ee;class V{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,me){this.makeConnection=j,this.connectionToken=me,typeof me<"u"&&B(me)}}e.ManagedResolvedAuthority=V;class $ extends Error{static NotAvailable(j,me){return new $(j,T.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(j){return new $(j,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,me=T.RemoteAuthorityResolverErrorCode.Unknown,Le){super(j),this._message=j,this._code=me,this._detail=Le,Object.setPrototypeOf(this,$.prototype)}}e.RemoteAuthorityResolverError=$;var G;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(G||(e.EndOfLine=G={}));var Z;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let le=i=class{static isTextEdit(j){return j instanceof i?!0:j?M.isRange(j)&&typeof j.newText=="string":!1}static replace(j,me){return new i(j,me)}static insert(j,me){return i.replace(new M(j,j),me)}static delete(j){return i.replace(j,"")}static setEndOfLine(j){const me=new i(new M(new O(0,0),new O(0,0)),"");return me.newEol=j,me}get range(){return this._range}set range(j){if(j&&!M.isRange(j))throw(0,d.illegalArgument)("range");this._range=j}get newText(){return this._newText||""}set newText(j){if(j&&typeof j!="string")throw(0,d.illegalArgument)("newText");this._newText=j}get newEol(){return this._newEol}set newEol(j){if(j&&typeof j!="number")throw(0,d.illegalArgument)("newEol");this._newEol=j}constructor(j,me){this._range=j,this._newText=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=le,e.TextEdit=le=i=Xe([E],le);let ne=s=class{static isNotebookCellEdit(j){return j instanceof s?!0:j?wi.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,me){return new s(j,me)}static insertCells(j,me){return new s(new wi(j,j),me)}static deleteCells(j){return new s(j,[])}static updateCellMetadata(j,me){const Le=new s(new wi(j,j),[]);return Le.newCellMetadata=me,Le}static updateNotebookMetadata(j){const me=new s(new wi(0,0),[]);return me.newNotebookMetadata=j,me}constructor(j,me){this.range=j,this.newCells=me}};e.NotebookEdit=ne,e.NotebookEdit=ne=s=Xe([E],ne);class _e{static isSnippetTextEdit(j){return j instanceof _e?!0:j?M.isRange(j.range)&&W.isSnippetString(j.snippet):!1}static replace(j,me){return new _e(j,me)}static insert(j,me){return _e.replace(new M(j,j),me)}constructor(j,me){this.range=j,this.snippet=me}}e.SnippetTextEdit=_e;var ge;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(j,me,Le,Ye){this._edits.push({_type:ge.File,from:j,to:me,options:Le,metadata:Ye})}createFile(j,me,Le){this._edits.push({_type:ge.File,from:void 0,to:j,options:me,metadata:Le})}deleteFile(j,me,Le){this._edits.push({_type:ge.File,from:j,to:void 0,options:me,metadata:Le})}replaceNotebookMetadata(j,me,Le){this._edits.push({_type:ge.Cell,metadata:Le,uri:j,edit:{editType:b.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}replaceNotebookCells(j,me,Le,Ye){const ot=me.start,pt=me.end;(ot!==pt||Le.length>0)&&this._edits.push({_type:ge.CellReplace,uri:j,index:ot,count:pt-ot,cells:Le,metadata:Ye})}replaceNotebookCellMetadata(j,me,Le,Ye){this._edits.push({_type:ge.Cell,metadata:Ye,uri:j,edit:{editType:b.CellEditType.Metadata,index:me,metadata:Le}})}replace(j,me,Le,Ye){this._edits.push({_type:ge.Text,uri:j,edit:new le(me,Le),metadata:Ye})}insert(j,me,Le,Ye){this.replace(j,new M(me,me),Le,Ye)}delete(j,me,Le){this.replace(j,me,"",Le)}has(j){return this._edits.some(me=>me._type===ge.Text&&me.uri.toString()===j.toString())}set(j,me){if(me)for(const Le of me){if(!Le)continue;let Ye,ot;Array.isArray(Le)?(Ye=Le[0],ot=Le[1]):Ye=Le,ne.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.replaceNotebookCellMetadata(j,Ye.range.start,Ye.newCellMetadata,ot):Ye.newNotebookMetadata?this.replaceNotebookMetadata(j,Ye.newNotebookMetadata,ot):this.replaceNotebookCells(j,Ye.range,Ye.newCells,ot):_e.isSnippetTextEdit(Ye)?this._edits.push({_type:ge.Snippet,uri:j,range:Ye.range,edit:Ye.snippet,metadata:ot}):this._edits.push({_type:ge.Text,uri:j,edit:Ye,metadata:ot})}else{for(let Le=0;Le<this._edits.length;Le++){const Ye=this._edits[Le];switch(Ye._type){case ge.Text:case ge.Snippet:case ge.Cell:case ge.CellReplace:Ye.uri.toString()===j.toString()&&(this._edits[Le]=void 0);break}}(0,r.coalesceInPlace)(this._edits)}}get(j){const me=[];for(const Le of this._edits)Le._type===ge.Text&&Le.uri.toString()===j.toString()&&me.push(Le.edit);return me}entries(){const j=new k.ResourceMap;for(const me of this._edits)if(me._type===ge.Text){let Le=j.get(me.uri);Le||(Le=[me.uri,[]],j.set(me.uri,Le)),Le[1].push(me.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Y,e.WorkspaceEdit=Y=Xe([E],Y);let W=t=class{static isSnippetString(j){return j instanceof t?!0:j?typeof j.value=="string":!1}static _escape(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this._tabstop=1,this.value=j||""}appendText(j){return this.value+=t._escape(j),this}appendTabstop(j=this._tabstop++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,me=this._tabstop++){if(typeof j=="function"){const Le=new t;Le._tabstop=this._tabstop,j(Le),this._tabstop=Le._tabstop,j=Le.value}else j=t._escape(j);return this.value+="${",this.value+=me,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,me=this._tabstop++){const Le=j.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(j,me){if(typeof me=="function"){const Le=new t;Le._tabstop=this._tabstop,me(Le),this._tabstop=Le._tabstop,me=Le.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.SnippetString=W,e.SnippetString=W=t=Xe([E],W);var oe;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(oe||(e.DiagnosticTag=oe={}));var Se;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(Se||(e.DiagnosticSeverity=Se={}));let te=o=class{static isLocation(j){return j instanceof o?!0:j?M.isRange(j.range)&&l.URI.isUri(j.uri):!1}constructor(j,me){if(this.uri=j,me)if(M.isRange(me))this.range=M.of(me);else if(O.isPosition(me))this.range=new M(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=te,e.Location=te=o=Xe([E],te);let ae=class{static is(j){return j?typeof j.message=="string"&&j.location&&M.isRange(j.location.range)&&l.URI.isUri(j.location.uri):!1}constructor(j,me){this.location=j,this.message=me}static isEqual(j,me){return j===me?!0:!j||!me?!1:j.message===me.message&&j.location.range.isEqual(me.location.range)&&j.location.uri.toString()===me.location.uri.toString()}};e.DiagnosticRelatedInformation=ae,e.DiagnosticRelatedInformation=ae=Xe([E],ae);let se=class{constructor(j,me,Le=Se.Error){if(!M.isRange(j))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=j,this.message=me,this.severity=Le}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,me){return j===me?!0:!j||!me?!1:j.message===me.message&&j.severity===me.severity&&j.code===me.code&&j.severity===me.severity&&j.source===me.source&&j.range.isEqual(me.range)&&(0,r.equals)(j.tags,me.tags)&&(0,r.equals)(j.relatedInformation,me.relatedInformation,ae.isEqual)}};e.Diagnostic=se,e.Diagnostic=se=Xe([E],se);let Q=class{constructor(j,me){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=me}};e.Hover=Q,e.Hover=Q=Xe([E],Q);let re=class extends Q{constructor(j,me,Le,Ye){super(j,me),this.canIncreaseVerbosity=Le,this.canDecreaseVerbosity=Ye}};e.VerboseHover=re,e.VerboseHover=re=Xe([E],re);var ve;(function(K){K[K.Increase=0]="Increase",K[K.Decrease=1]="Decrease"})(ve||(e.HoverVerbosityAction=ve={}));var be;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(be||(e.DocumentHighlightKind=be={}));let Fe=class{constructor(j,me=be.Text){this.range=j,this.kind=me}toJSON(){return{range:this.range,kind:be[this.kind]}}};e.DocumentHighlight=Fe,e.DocumentHighlight=Fe=Xe([E],Fe);let Be=class{constructor(j,me){this.uri=j,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.MultiDocumentHighlight=Be,e.MultiDocumentHighlight=Be=Xe([E],Be);var ke;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(ke||(e.SymbolKind=ke={}));var De;(function(K){K[K.Deprecated=1]="Deprecated"})(De||(e.SymbolTag=De={}));let Pe=n=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,me,Le,Ye,ot){this.name=j,this.kind=me,this.containerName=ot,typeof Le=="string"&&(this.containerName=Le),Ye instanceof te?this.location=Ye:Le instanceof M&&(this.location=new te(Ye,Le)),n.validate(this)}toJSON(){return{name:this.name,kind:ke[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Pe,e.SymbolInformation=Pe=n=Xe([E],Pe);let H=h=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(h.validate)}constructor(j,me,Le,Ye,ot){this.name=j,this.detail=me,this.kind=Le,this.range=Ye,this.selectionRange=ot,this.children=[],h.validate(this)}};e.DocumentSymbol=H,e.DocumentSymbol=H=h=Xe([E],H);var q;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(q||(e.CodeActionTriggerKind=q={}));let X=class{constructor(j,me){this.title=j,this.kind=me}};e.CodeAction=X,e.CodeAction=X=Xe([E],X);let J=class{static{c=this}static{this.sep="."}constructor(j){this.value=j}append(j){return new c(this.value?this.value+c.sep+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+c.sep)}};e.CodeActionKind=J,e.CodeActionKind=J=c=Xe([E],J),J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorMove=J.Refactor.append("move"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll"),J.Notebook=J.Empty.append("notebook");let he=class{constructor(j,me){if(this.range=j,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=he,e.SelectionRange=he=Xe([E],he);class we{constructor(j,me,Le,Ye,ot,pt){this.kind=j,this.name=me,this.detail=Le,this.uri=Ye,this.range=ot,this.selectionRange=pt}}e.CallHierarchyItem=we;class Oe{constructor(j,me){this.fromRanges=me,this.from=j}}e.CallHierarchyIncomingCall=Oe;class Ve{constructor(j,me){this.fromRanges=me,this.to=j}}e.CallHierarchyOutgoingCall=Ve;var Ke;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Ke||(e.LanguageStatusSeverity=Ke={}));let et=class{constructor(j,me){this.range=j,this.command=me}get isResolved(){return!!this.command}};e.CodeLens=et,e.CodeLens=et=Xe([E],et);let nt=g=class{#e;static isMarkdownString(j){return j instanceof g?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,me=!1){this.#e=new P.MarkdownString(j,{supportThemeIcons:me})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,me){return this.#e.appendCodeblock(me??"",j),this}};e.MarkdownString=nt,e.MarkdownString=nt=g=Xe([E],nt);let st=class{constructor(j,me){this.label=j,this.documentation=me}};e.ParameterInformation=st,e.ParameterInformation=st=Xe([E],st);let rt=class{constructor(j,me){this.label=j,this.documentation=me,this.parameters=[]}};e.SignatureInformation=rt,e.SignatureInformation=rt=Xe([E],rt);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=at,e.SignatureHelp=at=Xe([E],at);var gt;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(gt||(e.SignatureHelpTriggerKind=gt={}));var ht;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(ht||(e.InlayHintKind=ht={}));let lt=class{constructor(j){this.value=j}};e.InlayHintLabelPart=lt,e.InlayHintLabelPart=lt=Xe([E],lt);let Te=class{constructor(j,me,Le){this.position=j,this.label=me,this.kind=Le}};e.InlayHint=Te,e.InlayHint=Te=Xe([E],Te);var Ue;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var je;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(je||(e.CompletionItemKind=je={}));var Ne;(function(K){K[K.Deprecated=1]="Deprecated"})(Ne||(e.CompletionItemTag=Ne={}));let xe=class{constructor(j,me){this.label=j,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=xe,e.CompletionItem=xe=Xe([E],xe);let ue=class{constructor(j=[],me=!1){this.items=j,this.isIncomplete=me}};e.CompletionList=ue,e.CompletionList=ue=Xe([E],ue);let de=class{constructor(j,me,Le){this.insertText=j,this.range=me,this.command=Le}};e.InlineSuggestion=de,e.InlineSuggestion=de=Xe([E],de);let ce=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.InlineSuggestionList=ce,e.InlineSuggestionList=ce=Xe([E],ce);var Qe;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(Qe||(e.PartialAcceptTriggerKind=Qe={}));var tt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var ut;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ut||(e.StatusBarAlignment=ut={}));function mt(K,j){return`${y.ExtensionIdentifier.toKey(K)}.${j}`}var Dt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(Dt||(e.TextEditorLineNumbersStyle=Dt={}));var Mt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Mt||(e.TextDocumentSaveReason=Mt={}));var Vt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Vt||(e.TextEditorRevealType=Vt={}));var ei;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(ei||(e.TextEditorSelectionChangeKind=ei={}));var oi;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(oi||(e.TextDocumentChangeReason=oi={}));var Rt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Rt||(e.DecorationRangeBehavior=Rt={})),function(K){function j(me){switch(me){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=j}(ei||(e.TextEditorSelectionChangeKind=ei={}));var it;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(K){function j(me){switch(me){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=j}(it||(e.SyntaxTokenType=it={}));let Pt=class{constructor(j,me){if(me&&!l.URI.isUri(me))throw(0,d.illegalArgument)("target");if(!M.isRange(j)||j.isEmpty)throw(0,d.illegalArgument)("range");this.range=j,this.target=me}};e.DocumentLink=Pt,e.DocumentLink=Pt=Xe([E],Pt);let di=class{constructor(j,me,Le,Ye){this.red=j,this.green=me,this.blue=Le,this.alpha=Ye}};e.Color=di,e.Color=di=Xe([E],di);let Et=class{constructor(j,me){if(me&&!(me instanceof di))throw(0,d.illegalArgument)("color");if(!M.isRange(j)||j.isEmpty)throw(0,d.illegalArgument)("range");this.range=j,this.color=me}};e.ColorInformation=Et,e.ColorInformation=Et=Xe([E],Et);let yt=class{constructor(j){if(!j||typeof j!="string")throw(0,d.illegalArgument)("label");this.label=j}};e.ColorPresentation=yt,e.ColorPresentation=yt=Xe([E],yt);var ti;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ii;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var zt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(zt||(e.TerminalExitReason=zt={}));var vt;(function(K){K[K.Low=0]="Low",K[K.Medium=1]="Medium",K[K.High=2]="High"})(vt||(e.TerminalShellExecutionCommandLineConfidence=vt={}));class Bt{constructor(j,me,Le){if(this.startIndex=j,this.length=me,this.tooltip=Le,typeof j!="number"||j<0)throw(0,d.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,d.illegalArgument)("length");if(Le!==void 0&&typeof Le!="string")throw(0,d.illegalArgument)("tooltip")}}e.TerminalLink=Bt;class ni{constructor(j){this.uri=j}}e.TerminalQuickFixOpener=ni;class ai{constructor(j){this.terminalCommand=j}}e.TerminalQuickFixCommand=ai;var Je;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Je||(e.TerminalLocation=Je={}));class li{constructor(j){if(this.options=j,typeof j!="object")throw(0,d.illegalArgument)("options")}}e.TerminalProfile=li;var hi;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(hi||(e.TaskRevealKind=hi={}));var fi;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(fi||(e.TaskPanelKind=fi={}));let St=class{static{w=this}static{this.Clean=new w("clean","Clean")}static{this.Build=new w("build","Build")}static{this.Rebuild=new w("rebuild","Rebuild")}static{this.Test=new w("test","Test")}static from(j){switch(j){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(j,me){if(this.label=me,typeof j!="string"||typeof me!="string")throw(0,d.illegalArgument)("name");this._id=j}get id(){return this._id}};e.TaskGroup=St,e.TaskGroup=St=w=Xe([E],St);function xt(K){let j="";for(let me=0;me<K.length;me++)j+=K[me].replace(/,/g,",,")+",";return j}let Nt=class{constructor(j,me,Le){if(typeof j!="string")throw(0,d.illegalArgument)("process");this._args=[],this._process=j,me!==void 0&&(Array.isArray(me)?(this._args=me,this._options=Le):this._options=me)}get process(){return this._process}set process(j){if(typeof j!="string")throw(0,d.illegalArgument)("process");this._process=j}get args(){return this._args}set args(j){Array.isArray(j)||(j=[]),this._args=j}get options(){return this._options}set options(j){this._options=j}computeId(){const j=[];if(j.push("process"),this._process!==void 0&&j.push(this._process),this._args&&this._args.length>0)for(const me of this._args)j.push(me);return xt(j)}};e.ProcessExecution=Nt,e.ProcessExecution=Nt=Xe([E],Nt);let qt=class{constructor(j,me,Le){if(this._args=[],Array.isArray(me)){if(!j)throw(0,d.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,d.illegalArgument)("command");this._command=j,this._args=me,this._options=Le}else{if(typeof j!="string")throw(0,d.illegalArgument)("commandLine");this._commandLine=j,this._options=me}}get commandLine(){return this._commandLine}set commandLine(j){if(typeof j!="string")throw(0,d.illegalArgument)("commandLine");this._commandLine=j}get command(){return this._command?this._command:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,d.illegalArgument)("command");this._command=j}get args(){return this._args}set args(j){this._args=j||[]}get options(){return this._options}set options(j){this._options=j}computeId(){const j=[];if(j.push("shell"),this._commandLine!==void 0&&j.push(this._commandLine),this._command!==void 0&&j.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const me of this._args)j.push(typeof me=="string"?me:me.value);return xt(j)}};e.ShellExecution=qt,e.ShellExecution=qt=Xe([E],qt);var ri;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var Gt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Gt||(e.TaskScope=Gt={}));class ci{constructor(j){this._callback=j}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(j){this._callback=j}get callback(){return this._callback}}e.CustomExecution=ci;let $t=class{static{D=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(j,me,Le,Ye,ot,pt){this.__deprecated=!1,this._definition=this.definition=j;let _t;typeof me=="string"?(this._name=this.name=me,this._source=this.source=Le,this.execution=Ye,_t=ot,this.__deprecated=!0):me===Gt.Global||me===Gt.Workspace?(this.target=me,this._name=this.name=Le,this._source=this.source=Ye,this.execution=ot,_t=pt):(this.target=me,this._name=this.name=Le,this._source=this.source=Ye,this.execution=ot,_t=pt),typeof _t=="string"?(this._problemMatchers=[_t],this._hasDefinedMatchers=!0):Array.isArray(_t)?(this._problemMatchers=_t,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(j){this.__id=j}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Nt?this._definition={type:D.ProcessType,id:this._execution.computeId()}:this._execution instanceof qt?this._definition={type:D.ShellType,id:this._execution.computeId()}:this._execution instanceof ci?this._definition={type:D.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:D.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition(j){if(j==null)throw(0,d.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=j}get scope(){return this._scope}set target(j){this.clear(),this._scope=j}get name(){return this._name}set name(j){if(typeof j!="string")throw(0,d.illegalArgument)("name");this.clear(),this._name=j}get execution(){return this._execution}set execution(j){j===null&&(j=void 0),this.clear(),this._execution=j;const me=this._definition.type;(D.EmptyType===me||D.ProcessType===me||D.ShellType===me||D.ExtensionCallbackType===me)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(j){if(Array.isArray(j))this.clear(),this._problemMatchers=j,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.clear(),this._isBackground=j}get source(){return this._source}set source(j){if(typeof j!="string"||j.length===0)throw(0,d.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=j}get group(){return this._group}set group(j){j===null&&(j=void 0),this.clear(),this._group=j}get detail(){return this._detail}set detail(j){j===null&&(j=void 0),this._detail=j}get presentationOptions(){return this._presentationOptions}set presentationOptions(j){j==null&&(j=Object.create(null)),this.clear(),this._presentationOptions=j}get runOptions(){return this._runOptions}set runOptions(j){j==null&&(j=Object.create(null)),this.clear(),this._runOptions=j}};e.Task=$t,e.Task=$t=D=Xe([E],$t);var Kt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Kt||(e.ProgressLocation=Kt={}));var Xt;(function(K){function j(me){const Le=me;return(0,v.isNumber)(Le.value)?Le.tooltip&&!(0,v.isString)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=j})(Xt||(e.ViewBadge=Xt={}));let Ft=_=class{static isTreeItem(j,me){const Le=j;if(Le.checkboxState!==void 0){const Ye=(0,v.isNumber)(Le.checkboxState)?Le.checkboxState:(0,v.isObject)(Le.checkboxState)&&(0,v.isNumber)(Le.checkboxState.state)?Le.checkboxState.state:void 0,ot=!(0,v.isNumber)(Le.checkboxState)&&(0,v.isObject)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==It.Checked&&Ye!==It.Unchecked||ot!==void 0&&!(0,v.isString)(ot))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(j instanceof _)return!0;if(Le.label!==void 0&&!(0,v.isString)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,v.isString)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,v.isString)(Le.iconPath)&&!l.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,v.isString)(Le.iconPath.id))){const Ye=Le.iconPath;if(!Ye||!(0,v.isString)(Ye.light)&&!l.URI.isUri(Ye.light)&&!(0,v.isString)(Ye.dark)&&!l.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,v.isString)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!l.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,v.isString)(Le.tooltip)&&!(Le.tooltip instanceof nt)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<bt.None&&Le.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,v.isString)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(j,me=bt.None){this.collapsibleState=me,l.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.TreeItem=Ft,e.TreeItem=Ft=_=Xe([E],Ft);var bt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var It;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(It||(e.TreeItemCheckboxState=It={}));let jt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.DataTransferItem=jt,e.DataTransferItem=jt=Xe([E],jt);class Tt extends jt{}e.InternalDataTransferItem=Tt;class mi extends Tt{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.InternalFileDataTransferItem=mi;class Jt{constructor(j,me,Le,Ye){this.name=j,this.uri=me,this._itemId=Le,this._getData=Ye}data(){return this._getData()}}e.DataTransferFile=Jt;let Ci=class{#e=new Map;constructor(j){for(const[me,Le]of j??[]){const Ye=this.#e.get(this.#t(me));Ye?Ye.push(Le):this.#e.set(this.#t(me),[Le])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,me){this.#e.set(this.#t(j),[me])}forEach(j,me){for(const[Le,Ye]of this.#e)for(const ot of Ye)j.call(me,ot,Le,this)}*[Symbol.iterator](){for(const[j,me]of this.#e)for(const Le of me)yield[j,Le]}#t(j){return j.toLowerCase()}};e.DataTransfer=Ci,e.DataTransfer=Ci=Xe([E],Ci);let Ei=class{constructor(j,me,Le){this.insertText=j,this.title=me,this.kind=Le}};e.DocumentDropEdit=Ei,e.DocumentDropEdit=Ei=Xe([E],Ei);var ki;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(ki||(e.DocumentPasteTriggerKind=ki={}));class Lt{static{this.sep="."}constructor(j){this.value=j}append(...j){return new Lt((this.value?[this.value,...j]:j).join(Lt.sep))}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+Lt.sep)}}e.DocumentDropOrPasteEditKind=Lt,Lt.Empty=new Lt("");class Oi{constructor(j,me,Le){this.title=me,this.insertText=j,this.kind=Le}}e.DocumentPasteEdit=Oi;let ui=class{constructor(j,me){this.id=j,this.color=me}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.ThemeIcon=ui,e.ThemeIcon=ui=Xe([E],ui),ui.File=new ui("file"),ui.Folder=new ui("folder");let At=class{constructor(j){this.id=j}};e.ThemeColor=At,e.ThemeColor=At=Xe([E],At);var Ri;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Ri||(e.ConfigurationTarget=Ri={}));let Ii=class{get base(){return this._base}set base(j){this._base=j,this._baseUri=l.URI.file(j)}get baseUri(){return this._baseUri}set baseUri(j){this._baseUri=j,this._base=j.fsPath}constructor(j,me){if(typeof j!="string"&&(!j||!l.URI.isUri(j)&&!l.URI.isUri(j.uri)))throw(0,d.illegalArgument)("base");if(typeof me!="string")throw(0,d.illegalArgument)("pattern");typeof j=="string"?this.baseUri=l.URI.file(j):l.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Ii,e.RelativePattern=Ii=Xe([E],Ii);const yi=new WeakMap;function Ni(K,j){yi.set(K,j)}let bi=class{constructor(j,me,Le,Ye,ot){this.enabled=typeof j=="boolean"?j:!0,typeof me=="string"&&(this.condition=me),typeof Le=="string"&&(this.hitCondition=Le),typeof Ye=="string"&&(this.logMessage=Ye),typeof ot=="string"&&(this.mode=ot)}get id(){return this._id||(this._id=yi.get(this)??(0,I.generateUuid)()),this._id}};e.Breakpoint=bi,e.Breakpoint=bi=Xe([E],bi);let Ht=class extends bi{constructor(j,me,Le,Ye,ot,pt){if(super(me,Le,Ye,ot,pt),j===null)throw(0,d.illegalArgument)("location");this.location=j}};e.SourceBreakpoint=Ht,e.SourceBreakpoint=Ht=Xe([E],Ht);let Re=class extends bi{constructor(j,me,Le,Ye,ot,pt){super(me,Le,Ye,ot,pt),this.functionName=j}};e.FunctionBreakpoint=Re,e.FunctionBreakpoint=Re=Xe([E],Re);let Me=class extends bi{constructor(j,me,Le,Ye,ot,pt,_t,Yt){if(super(Ye,ot,pt,_t,Yt),!me)throw(0,d.illegalArgument)("dataId");this.label=j,this.dataId=me,this.canPersist=Le}};e.DataBreakpoint=Me,e.DataBreakpoint=Me=Xe([E],Me);let ye=class{constructor(j,me,Le){this.command=j,this.args=me||[],this.options=Le}};e.DebugAdapterExecutable=ye,e.DebugAdapterExecutable=ye=Xe([E],ye);let ie=class{constructor(j,me){this.port=j,this.host=me}};e.DebugAdapterServer=ie,e.DebugAdapterServer=ie=Xe([E],ie);let Ae=class{constructor(j){this.path=j}};e.DebugAdapterNamedPipeServer=Ae,e.DebugAdapterNamedPipeServer=Ae=Xe([E],Ae);let qe=class{constructor(j){this.implementation=j}};e.DebugAdapterInlineImplementation=qe,e.DebugAdapterInlineImplementation=qe=Xe([E],qe);class Ze{constructor(j,me,Le){this.session=j,this.threadId=me,this.frameId=Le}}e.DebugStackFrame=Ze;class Ge{constructor(j,me){this.session=j,this.threadId=me}}e.DebugThread=Ge;let ft=class{constructor(j,me){this.range=j,this.expression=me}};e.EvaluatableExpression=ft,e.EvaluatableExpression=ft=Xe([E],ft);var kt;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(kt||(e.InlineCompletionTriggerKind=kt={}));let Qt=class{constructor(j,me){this.range=j,this.text=me}};e.InlineValueText=Qt,e.InlineValueText=Qt=Xe([E],Qt);let si=class{constructor(j,me,Le=!0){this.range=j,this.variableName=me,this.caseSensitiveLookup=Le}};e.InlineValueVariableLookup=si,e.InlineValueVariableLookup=si=Xe([E],si);let Ut=class{constructor(j,me){this.range=j,this.expression=me}};e.InlineValueEvaluatableExpression=Ut,e.InlineValueEvaluatableExpression=Ut=Xe([E],Ut);let Zt=class{constructor(j,me){this.frameId=j,this.stoppedLocation=me}};e.InlineValueContext=Zt,e.InlineValueContext=Zt=Xe([E],Zt);var $i;(function(K){K[K.AIGenerated=1]="AIGenerated"})($i||(e.NewSymbolNameTag=$i={}));var rn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(rn||(e.NewSymbolNameTriggerKind=rn={}));class Hi{constructor(j,me){this.newSymbolName=j,this.tags=me}}e.NewSymbolName=Hi;var Mi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Mi||(e.FileChangeType=Mi={}));let Vi=C=class extends Error{static FileExists(j){return new C(j,u.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(j){return new C(j,u.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(j){return new C(j,u.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(j){return new C(j,u.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(j){return new C(j,u.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(j){return new C(j,u.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(j,me=u.FileSystemProviderErrorCode.Unknown,Le){super(l.URI.isUri(j)?j.toString(!0):j),this.code=Le?.name??"Unknown",(0,u.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.FileSystemError=Vi,e.FileSystemError=Vi=C=Xe([E],Vi);let qi=class{constructor(j,me,Le){this.start=j,this.end=me,this.kind=Le}};e.FoldingRange=qi,e.FoldingRange=qi=Xe([E],qi);var Ti;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Ti||(e.FoldingRangeKind=Ti={}));var sn;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(sn||(e.CommentThreadCollapsibleState=sn={}));var on;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(on||(e.CommentMode=on={}));var xi;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(xi||(e.CommentState=xi={}));var an;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(an||(e.CommentThreadState=an={}));var Ui;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(Ui||(e.CommentThreadApplicability=Ui={}));var ji;(function(K){K[K.Reply=1]="Reply",K[K.Comment=2]="Comment"})(ji||(e.CommentThreadFocus=ji={}));class _n{constructor(j,me=[]){this.tokenTypes=j,this.tokenModifiers=me}}e.SemanticTokensLegend=_n;function ln(K){return typeof K>"u"||(0,v.isStringArray)(K)}class Ki{constructor(j){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,j){this._hasLegend=!0;for(let me=0,Le=j.tokenTypes.length;me<Le;me++)this._tokenTypeStrToInt.set(j.tokenTypes[me],me);for(let me=0,Le=j.tokenModifiers.length;me<Le;me++)this._tokenModifierStrToInt.set(j.tokenModifiers[me],me)}}push(j,me,Le,Ye,ot){if(typeof j=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ye=="number"&&(typeof ot=="number"||typeof ot>"u"))return typeof ot>"u"&&(ot=0),this._pushEncoded(j,me,Le,Ye,ot);if(M.isRange(j)&&typeof me=="string"&&ln(Le))return this._push(j,me,Le);throw(0,d.illegalArgument)()}_push(j,me,Le){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=j.start.line,ot=j.start.character,pt=j.end.character-j.start.character,_t=this._tokenTypeStrToInt.get(me);let Yt=0;if(Le)for(const vi of Le){if(!this._tokenModifierStrToInt.has(vi))throw new Error("`tokenModifier` is not in the provided legend");const _i=this._tokenModifierStrToInt.get(vi);Yt|=1<<_i>>>0}this._pushEncoded(Ye,ot,pt,_t,Yt)}_pushEncoded(j,me,Le,Ye,ot){if(this._dataIsSortedAndDeltaEncoded&&(j<this._prevLine||j===this._prevLine&&me<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Yt=this._data.length/5|0;let vi=0,_i=0;for(let Di=0;Di<Yt;Di++){let Ai=this._data[5*Di],tn=this._data[5*Di+1];Ai===0?(Ai=vi,tn+=_i):Ai+=vi,this._data[5*Di]=Ai,this._data[5*Di+1]=tn,vi=Ai,_i=tn}}let pt=j,_t=me;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(pt-=this._prevLine,pt===0&&(_t-=this._prevChar)),this._data[this._dataLen++]=pt,this._data[this._dataLen++]=_t,this._data[this._dataLen++]=Le,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=ot,this._prevLine=j,this._prevChar=me}static _sortAndDeltaEncode(j){const me=[],Le=j.length/5|0;for(let _t=0;_t<Le;_t++)me[_t]=_t;me.sort((_t,Yt)=>{const vi=j[5*_t],_i=j[5*Yt];if(vi===_i){const Di=j[5*_t+1],Ai=j[5*Yt+1];return Di-Ai}return vi-_i});const Ye=new Uint32Array(j.length);let ot=0,pt=0;for(let _t=0;_t<Le;_t++){const Yt=5*me[_t],vi=j[Yt+0],_i=j[Yt+1],Di=j[Yt+2],Ai=j[Yt+3],tn=j[Yt+4],qn=vi-ot,Nr=qn===0?_i-pt:_i,nn=5*_t;Ye[nn+0]=qn,Ye[nn+1]=Nr,Ye[nn+2]=Di,Ye[nn+3]=Ai,Ye[nn+4]=tn,ot=vi,pt=_i}return Ye}build(j){return this._dataIsSortedAndDeltaEncoded?new Pi(new Uint32Array(this._data),j):new Pi(Ki._sortAndDeltaEncode(this._data),j)}}e.SemanticTokensBuilder=Ki;class Pi{constructor(j,me){this.resultId=me,this.data=j}}e.SemanticTokens=Pi;class yn{constructor(j,me,Le){this.start=j,this.deleteCount=me,this.data=Le}}e.SemanticTokensEdit=yn;class Dn{constructor(j,me){this.resultId=me,this.edits=j}}e.SemanticTokensEdits=Dn;var cn;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(cn||(e.DebugConsoleMode=cn={}));class Gi{constructor(j){this.name=j}}e.DebugVisualization=Gi;var Xi;(function(K){K[K.Title=1]="Title",K[K.Inline=2]="Inline"})(Xi||(e.QuickInputButtonLocation=Xi={}));let ze=class{static{this.Back={iconPath:new ui("arrow-left")}}constructor(){}};e.QuickInputButtons=ze,e.QuickInputButtons=ze=Xe([E],ze);var Si;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Si||(e.QuickPickItemKind=Si={}));var Qi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var ct;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(ct||(e.ExtensionKind=ct={}));class Ct{static validate(j){if(typeof j.badge=="string"){let me=(0,R.nextCharLength)(j.badge,0);if(me<j.badge.length&&(me+=(0,R.nextCharLength)(j.badge,me)),j.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!ui.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,me,Le){this.badge=j,this.tooltip=me,this.color=Le}}e.FileDecoration=Ct;let Yi=class{constructor(j){this.kind=j}};e.ColorTheme=Yi,e.ColorTheme=Yi=Xe([E],Yi);var un;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(un||(e.ColorThemeKind=un={}));class wi{static isNotebookRange(j){return j instanceof wi?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(j,me){if(j<0)throw(0,d.illegalArgument)("start must be positive");if(me<0)throw(0,d.illegalArgument)("end must be positive");j<=me?(this._start=j,this._end=me):(this._start=me,this._end=j)}with(j){let me=this._start,Le=this._end;return j.start!==void 0&&(me=j.start),j.end!==void 0&&(Le=j.end),me===this._start&&Le===this._end?this:new wi(me,Le)}}e.NotebookRange=wi;class Bi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(me=>Bi.isNotebookCellData(me))}static isNotebookCellData(j){return!0}constructor(j,me,Le,Ye,ot,pt,_t){this.kind=j,this.value=me,this.languageId=Le,this.mime=Ye,this.outputs=ot??[],this.metadata=pt,this.executionSummary=_t,Bi.validate(this)}}e.NotebookCellData=Bi;class Wi{constructor(j){this.cells=j}}e.NotebookData=Wi;class pi{static isNotebookCellOutputItem(j){return j instanceof pi?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const me={name:j.name,message:j.message,stack:j.stack};return pi.json(me,"application/vnd.code.notebook.error")}static stdout(j){return pi.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return pi.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,me="application/octet-stream"){return new pi(j,me)}static#e=new TextEncoder;static text(j,me=L.Mimes.text){const Le=pi.#e.encode(String(j));return new pi(Le,me)}static json(j,me="text/x-json"){const Le=JSON.stringify(j,void 0,"	");return pi.text(Le,me)}constructor(j,me){this.data=j,this.mime=me;const Le=(0,L.normalizeMimeType)(me,!0);if(!Le)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.NotebookCellOutputItem=pi;class zi{static isNotebookCellOutput(j){return j instanceof zi?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,me=!1){const Le=new Set,Ye=new Set;for(let ot=0;ot<j.length;ot++){const pt=j[ot],_t=(0,L.normalizeMimeType)(pt.mime);if(!Le.has(_t)||(0,b.isTextStreamMime)(_t)){Le.add(_t);continue}Ye.add(ot),me&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return Ye.size===0?j:j.filter((ot,pt)=>!Ye.has(pt))}constructor(j,me,Le){this.items=zi.ensureUniqueMimeTypes(j,!0),typeof me=="string"?(this.id=me,this.metadata=Le):(this.id=(0,I.generateUuid)(),this.metadata=me??Le)}}e.NotebookCellOutput=zi;var dn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(dn||(e.NotebookCellKind=dn={}));var Ji;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(Ji||(e.NotebookCellExecutionState=Ji={}));var hn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(hn||(e.NotebookCellStatusBarAlignment=hn={}));var fn;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(fn||(e.NotebookEditorRevealType=fn={}));class Cn{constructor(j,me){this.text=j,this.alignment=me}}e.NotebookCellStatusBarItem=Cn;var gn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(gn||(e.NotebookControllerAffinity=gn={}));var mn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(mn||(e.NotebookControllerAffinity2=mn={}));class In{constructor(j,me=[]){this.uri=j,this.provides=(0,r.asArray)(me)}}e.NotebookRendererScript=In;class Tn{constructor(j){this.label=j}}e.NotebookKernelSourceAction=Tn;var pn;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(pn||(e.NotebookVariablesRequestKind=pn={}));let Zi=class{constructor(j,me){this.label=j,this.timestamp=me}};e.TimelineItem=Zi,e.TimelineItem=Zi=Xe([E],Zi);var vn;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(vn||(e.ExtensionMode=vn={}));var En;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(En||(e.ExtensionRuntime=En={}));var fe;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(fe||(e.StandardTokenType=fe={}));class Ee{constructor(j,me){this.ranges=j,this.wordPattern=me}}e.LinkedEditingRanges=Ee;class We{constructor(j){this._autoForwardAction=j}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=We;var dt;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(dt||(e.TestResultState=dt={}));var wt;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(wt||(e.TestRunProfileKind=wt={}));let Ot=class{constructor(j=void 0,me=void 0,Le=void 0,Ye=!1,ot=!0){this.include=j,this.exclude=me,this.profile=Le,this.continuous=Ye,this.preserveFocus=ot}};e.TestRunRequest=Ot,e.TestRunRequest=Ot=Xe([E],Ot);let gi=A=class{static diff(j,me,Le){const Ye=new A(j);return Ye.expectedOutput=me,Ye.actualOutput=Le,Ye}constructor(j){this.message=j}};e.TestMessage=gi,e.TestMessage=gi=A=Xe([E],gi);let Fi=class{constructor(j){this.id=j}};e.TestTag=Fi,e.TestTag=Fi=Xe([E],Fi);class en{constructor(j,me,Le){this.label=j,this.file=me,this.position=Le}}e.TestMessageStackFrame=en;class bn{constructor(j,me){this.covered=j,this.total=me,An(this)}}e.TestCoverageCount=bn;function An(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class Pn{static fromDetails(j,me){const Le=new bn(0,0),Ye=new bn(0,0),ot=new bn(0,0);for(const _t of me)if("branches"in _t){Le.total+=1,Le.covered+=_t.executed?1:0;for(const Yt of _t.branches)Ye.total+=1,Ye.covered+=Yt.executed?1:0}else ot.total+=1,ot.covered+=_t.executed?1:0;const pt=new Pn(j,Le,Ye.total>0?Ye:void 0,ot.total>0?ot:void 0);return pt.detailedCoverage=me,pt}constructor(j,me,Le,Ye,ot=[]){this.uri=j,this.statementCoverage=me,this.branchCoverage=Le,this.declarationCoverage=Ye,this.fromTests=ot}}e.FileCoverage=Pn;class Gn{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,me,Le=[]){this.executed=j,this.location=me,this.branches=Le}}e.StatementCoverage=Gn;class Xn{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,me,Le){this.executed=j,this.location=me,this.label=Le}}e.BranchCoverage=Xn;class Qn{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,me,Le){this.name=j,this.executed=me,this.location=Le}}e.DeclarationCoverage=Qn;var kn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Rn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(Rn||(e.WorkspaceTrustState=Rn={}));var Ln;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ln||(e.PortAutoForwardAction=Ln={}));class Yn{constructor(j,me,Le,Ye,ot,pt){this.kind=j,this.name=me,this.detail=Le,this.uri=Ye,this.range=ot,this.selectionRange=pt}}e.TypeHierarchyItem=Yn;class Jn{constructor(j){this.uri=j}}e.TextTabInput=Jn;class Zn{constructor(j,me){this.original=j,this.modified=me}}e.TextDiffTabInput=Zn;class er{constructor(j,me,Le,Ye){this.base=j,this.input1=me,this.input2=Le,this.result=Ye}}e.TextMergeTabInput=er;class tr{constructor(j,me){this.uri=j,this.viewType=me}}e.CustomEditorTabInput=tr;class ir{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=ir;class nr{constructor(j,me){this.uri=j,this.notebookType=me}}e.NotebookEditorTabInput=nr;class rr{constructor(j,me,Le){this.original=j,this.modified=me,this.notebookType=Le}}e.NotebookDiffEditorTabInput=rr;class sr{constructor(){}}e.TerminalEditorTabInput=sr;class or{constructor(j,me){this.uri=j,this.inputBoxUri=me}}e.InteractiveWindowInput=or;class ar{constructor(){}}e.ChatEditorTabInput=ar;class lr{constructor(j){this.textDiffs=j}}e.TextMultiDiffTabInput=lr;var On;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(On||(e.InteractiveSessionVoteDirection=On={}));var Nn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Fn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Fn||(e.ChatVariableLevel=Fn={}));class cr{constructor(j,me,Le){this.id=j,this.label=me,this.values=Le}}e.ChatCompletionItem=cr;var Mn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var xn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(xn||(e.ChatResultFeedbackKind=xn={}));class ur{constructor(j){if(typeof j!="string"&&j.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof j=="string"?new nt(j):j}}e.ChatResponseMarkdownPart=ur;class dr{constructor(j,me){if(typeof j!="string"&&j.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof j=="string"?new nt(j):j,this.vulnerabilities=me}}e.ChatResponseMarkdownWithVulnerabilitiesPart=dr;class hr{constructor(j,me){this.participant=j,this.command=me}}e.ChatResponseDetectedParticipantPart=hr;class fr{constructor(j,me,Le,Ye){this.title=j,this.message=me,this.data=Le,this.buttons=Ye}}e.ChatResponseConfirmationPart=fr;class gr{constructor(j,me){this.value=j,this.baseUri=me}}e.ChatResponseFileTreePart=gr;class mr{constructor(j,me){this.value=j,this.title=me}}e.ChatResponseAnchorPart=mr;class pr{constructor(j){this.value=j}}e.ChatResponseProgressPart=pr;class vr{constructor(j,me){this.value=j,this.task=me}}e.ChatResponseProgressPart2=vr;class Er{constructor(j){if(typeof j!="string"&&j.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof j=="string"?new nt(j):j}}e.ChatResponseWarningPart=Er;class br{constructor(j){this.value=j}}e.ChatResponseCommandButtonPart=br;class Sr{constructor(j,me,Le){this.value=j,this.iconPath=me,this.options=Le}}e.ChatResponseReferencePart=Sr;class wr{constructor(j,me,Le){this.value=j,this.license=me,this.snippet=Le}}e.ChatResponseCodeCitationPart=wr;class _r{constructor(j,me){this.uri=j,this.edits=Array.isArray(me)?me:[me]}}e.ChatResponseTextEditPart=_r;class yr{constructor(j,me,Le,Ye){this.prompt=j,this.command=me,this.references=Le,this.participant=Ye}}e.ChatRequestTurn=yr;class Dr{constructor(j,me,Le,Ye){this.response=j,this.result=me,this.participant=Le,this.command=Ye}}e.ChatResponseTurn=Dr;var Un;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(Un||(e.ChatLocation=Un={}));var Bn;(function(K){K[K.Complete=1]="Complete",K[K.Partial=2]="Partial",K[K.Omitted=3]="Omitted"})(Bn||(e.ChatResponseReferencePartStatusKind=Bn={}));class Cr{constructor(j,me,Le){this.document=j,this.selection=me,this.wholeRange=Le}}e.ChatRequestEditorData=Cr;class Ir{constructor(j){this.cell=j}}e.ChatRequestNotebookData=Ir;var Sn;(function(K){K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.System=3]="System"})(Sn||(e.LanguageModelChatMessageRole=Sn={}));class Tr{constructor(j,me,Le){this.name=j,this.content=me,this.isError=Le??!1}}e.LanguageModelFunctionResultPart=Tr;class wn{static User(j,me){const Le=new wn(Sn.User,typeof j=="string"?j:"",me);return Le.content2=j,Le}static Assistant(j,me){return new wn(Sn.Assistant,j,me)}constructor(j,me,Le){this.role=j,this.content=me,this.content2=me,this.name=Le}}e.LanguageModelChatMessage=wn;class Pr{constructor(j,me){this.name=j,this.parameters=me}}e.LanguageModelFunctionUsePart=Pr;class Ar{constructor(j){this.value=j}}e.LanguageModelTextPart=Ar;class kr{constructor(j){this.content=j}}e.LanguageModelChatSystemMessage=kr;class Rr{constructor(j,me){this.content=j,this.name=me}}e.LanguageModelChatUserMessage=Rr;class Lr{constructor(j,me){this.content=j,this.name=me}}e.LanguageModelChatAssistantMessage=Lr;class Li extends Error{static NotFound(j){return new Li(j,Li.NotFound.name)}static NoPermissions(j){return new Li(j,Li.NoPermissions.name)}static Blocked(j){return new Li(j,Li.Blocked.name)}constructor(j,me,Le){super(j,{cause:Le}),this.name="LanguageModelError",this.code=me??""}}e.LanguageModelError=Li;var Wn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Wn||(e.RelatedInformationType=Wn={}));var zn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped",K[K.Error=5]="Error"})(zn||(e.SpeechToTextStatus=zn={}));var $n;(function(K){K[K.Started=1]="Started",K[K.Stopped=2]="Stopped",K[K.Error=3]="Error"})($n||(e.TextToSpeechStatus=$n={}));var Hn;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(Hn||(e.KeywordRecognitionStatus=Hn={}));class Or{constructor(j,me){this.text=j,this.range=me}}e.InlineEdit=Or;var Vn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Ce[290],Ie([1,0,6,9]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class P{constructor(L){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=L.getProxy(r.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,R,v){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const l=this._relatedInformationProviders.get(L);if(!l)throw new Error("related information provider not found");return await l.provideRelatedInformation(R,v)??[]}getRelatedInformation(L,R,v){return this._proxy.$getAiRelatedInformation(R,v)}registerRelatedInformationProvider(L,R,v){const l=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(l,v),this._proxy.$registerAiRelatedInformationProvider(l,R),new d.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(l),this._relatedInformationProviders.delete(l)})}}e.ExtHostRelatedInformation=P}),define(Ce[127],Ie([1,0,4,6,9,23,156,5,19]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,R.createDecorator)("IExtHostAuthentication");let l=class{constructor(u){this._authenticationProviders=new Map,this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new I,this._proxy=u.getProxy(d.MainContext.MainThreadAuthentication)}async getSession(u,T,b,a={}){const m=k.ExtensionIdentifier.toKey(u.identifier),p=[...b].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${m} ${T} ${p}`,async()=>{await this._proxy.$ensureProvider(T);const f=u.displayName||u.name;return this._proxy.$getSession(T,b,m,f,a)})}async getAccounts(u){return await this._proxy.$ensureProvider(u),await this._proxy.$getAccounts(u)}async removeSession(u,T){const b=this._authenticationProviders.get(u);return b?b.provider.removeSession(T):this._proxy.$removeSession(u,T)}registerAuthenticationProvider(u,T,b,a){if(this._authenticationProviders.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this._authenticationProviders.set(u,{label:T,provider:b,options:a??{supportsMultipleAccounts:!1}});const m=b.onDidChangeSessions(p=>this._proxy.$sendDidChangeSessions(u,p));return this._proxy.$registerAuthenticationProvider(u,T,a?.supportsMultipleAccounts??!1),new P.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(u),this._proxy.$unregisterAuthenticationProvider(u)})}async $createSession(u,T,b){const a=this._authenticationProviders.get(u);if(a)return await a.provider.createSession(T,b);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,T){const b=this._authenticationProviders.get(u);if(b)return await b.provider.removeSession(T);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,T,b){const a=this._authenticationProviders.get(u);if(a)return await a.provider.getSessions(T,b);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,T){return u.startsWith(L.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:u,label:T}}),Promise.resolve()}};e.ExtHostAuthentication=l,e.ExtHostAuthentication=l=Xe([He(0,v.IExtHostRpcService)],l);class I{constructor(){this._inFlightPromises=new Map}getOrCreate(u,T){const b=this._inFlightPromises.get(u);if(b)return b;const a=T().finally(()=>this._inFlightPromises.delete(u));return this._inFlightPromises.set(u,a),a}}}),define(Ce[163],Ie([1,0,2,6,9,5,19,11,18,12,16,25]),function(pe,e,r,d,P,k,L,R,v,l,I,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class{static{u=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(a,m){this._logService=m,this._provider=new Map,this._proxy=a.getProxy(d.MainContext.MainThreadDecorations)}registerFileDecorationProvider(a,m){const p=u._handlePool++;this._provider.set(p,{provider:a,extensionDescription:m}),this._proxy.$registerDecorationProvider(p,m.identifier.value);const f=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this._proxy.$onDidChange(p,null);return}const s=(0,v.asArray)(i);if(s.length<=u._maxEventSize){this._proxy.$onDidChange(p,s);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,s.length);const t=s.map(h=>({uri:h,rank:(0,l.count)(h.path,"/")})),o=(0,v.groupBy)(t,(h,c)=>h.rank-c.rank||(0,l.compare)(h.uri.path,c.uri.path)),n=[];e:for(const h of o){let c;for(const g of h){const w=(0,I.dirname)(g.uri.path);if(c!==w&&(c=w,n.push(g.uri)>=u._maxEventSize))break e}}this._proxy.$onDidChange(p,n)});return new P.Disposable(()=>{f?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(a,m,p){if(!this._provider.has(a))return Object.create(null);const f=Object.create(null),{provider:i,extensionDescription:s}=this._provider.get(a);return await Promise.all(m.map(async t=>{try{const{uri:o,id:n}=t,h=await Promise.resolve(i.provideFileDecoration(r.URI.revive(o),p));if(!h)return;try{P.FileDecoration.validate(h),h.badge&&typeof h.badge!="string"&&(0,y.checkProposedApiEnabled)(s,"codiconDecoration"),f[n]=[h.propagate,h.tooltip,h.badge,h.color]}catch(c){this._logService.warn(`INVALID decoration from extension '${s.identifier.value}': ${c}`)}}catch(o){this._logService.error(o)}})),f}};e.ExtHostDecorations=T,e.ExtHostDecorations=T=u=Xe([He(0,L.IExtHostRpcService),He(1,R.ILogService)],T),e.IExtHostDecorations=(0,k.createDecorator)("IExtHostDecorations")}),define(Ce[291],Ie([1,0,13,2,9,6,14,20,12]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class l{static{this._handlePool=0}constructor(y,u,T){this._documentsAndEditors=u,this._logService=T,this._documentContentProviders=new Map,this._proxy=y.getProxy(k.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(L.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const T=l._handlePool++;this._documentContentProviders.set(T,u),this._proxy.$registerTextContentProvider(T,y);let b;if(typeof u.onDidChange=="function"){let a;b=u.onDidChange(async m=>{if(m.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(m))return;a&&await a;const p=this.$provideTextDocumentContent(T,m).then(async f=>{if(!f&&typeof f!="string")return;const i=this._documentsAndEditors.getDocument(m);if(!i)return;const s=(0,v.splitLines)(f);if(!i.equalLines(s))return this._proxy.$onVirtualDocumentChange(m,f)}).catch(r.onUnexpectedError).finally(()=>{a===p&&(a=void 0)});a=p})}return new P.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(y,u){const T=this._documentContentProviders.get(y);return T?Promise.resolve(T.provideTextDocumentContent(d.URI.revive(u),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=l}),define(Ce[164],Ie([1,0,65,14,12,206,140,9,18]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=I;const l=new Map;function I(b,a){a?l.set(b,a):l.delete(b)}function y(b){return l.get(b)}class u extends k.MirrorTextModel{constructor(a,m,p,f,i,s,t){super(m,p,f,i),this._proxy=a,this._languageId=s,this._isDirty=t,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,v.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===d.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},save(){return a._save()},getText(m){return m?a._getTextInRange(m):a.getText()},get eol(){return a._eol===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(m){return a._lineAt(m)},offsetAt(m){return a._offsetAt(m)},positionAt(m){return a._positionAt(m)},validateRange(m){return a._validateRange(m)},validatePosition(m){return a._validatePosition(m)},getWordRangeAtPosition(m,p){return a._getWordRangeAtPosition(m,p)},[Symbol.for("debug.description")](){return`TextDocument(${a._uri.toString()})`}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,r.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,r.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const m=this._validateRange(a);if(m.isEmpty)return"";if(m.isSingleLine)return this._lines[m.start.line].substring(m.start.character,m.end.character);const p=this._eol,f=m.start.line,i=m.end.line,s=[];s.push(this._lines[f].substring(m.start.character));for(let t=f+1;t<i;t++)s.push(this._lines[t]);return s.push(this._lines[i].substring(0,m.end.character)),s.join(p)}_lineAt(a){let m;if(a instanceof R.Position?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this._lines.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new T(m,this._lines[m],m===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(a),p=this._lines[m.index].length;return new R.Position(m.index,Math.min(m.remainder,p))}_validateRange(a){if(!(a instanceof R.Range))throw new Error("Invalid argument");const m=this._validatePosition(a.start),p=this._validatePosition(a.end);return m===a.start&&p===a.end?a:new R.Range(m.line,m.character,p.line,p.character)}_validatePosition(a){if(!(a instanceof R.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:m,character:p}=a,f=!1;if(m<0)m=0,p=0,f=!0;else if(m>=this._lines.length)m=this._lines.length-1,p=this._lines[m].length,f=!0;else{const i=this._lines[m].length;p<0?(p=0,f=!0):p>i&&(p=i,f=!0)}return f?new R.Position(m,p):a}_getWordRangeAtPosition(a,m){const p=this._validatePosition(a);if(!m)m=y(this._languageId);else if((0,P.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const f=(0,L.getWordAtText)(p.character+1,(0,L.ensureValidWordDefinition)(m),this._lines[p.line],0);if(f)return new R.Range(p.line,f.startColumn-1,p.line,f.endColumn-1)}}e.ExtHostDocumentData=u;class T{constructor(a,m,p){this._line=a,this._text=m,this._isLastLine=p}get lineNumber(){return this._line}get text(){return this._text}get range(){return new R.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new R.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(Ce[292],Ie([1,0,6,9]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class P{constructor(L){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=L.getProxy(r.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,R,v){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const l=this._AiEmbeddingVectorProviders.get(L);if(!l)throw new Error("Embedding vector provider not found");const I=await l.provideEmbeddingVector(R,v);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(L,R,v){const l=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(l,v),this._proxy.$registerAiEmbeddingVectorProvider(R,l),new d.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(l),this._AiEmbeddingVectorProviders.delete(l)})}}e.ExtHostAiEmbeddingVector=P}),define(Ce[75],Ie([1,0,6,27,9,21,5,19,62,3,7,22,14]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0,d=$e(d);let b=T=class{constructor(m,p){this._fileSystemProvider=new Map,this._writeQueue=new I.ResourceQueue,this._proxy=m.getProxy(r.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(i){try{let s;const t=f._fileSystemProvider.get(i.scheme);return t?(await f._proxy.$ensureActivation(i.scheme),s=await t.impl.stat(i)):s=await f._proxy.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===d.FilePermission.Readonly?1:void 0}}catch(s){T._handleError(s)}},async readDirectory(i){try{const s=f._fileSystemProvider.get(i.scheme);return s?(await f._proxy.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await f._proxy.$readdir(i)}catch(s){return T._handleError(s)}},async createDirectory(i){try{const s=f._fileSystemProvider.get(i.scheme);return s&&!s.isReadonly?(await f._proxy.$ensureActivation(i.scheme),await f.mkdirp(s.impl,s.extUri,i)):await f._proxy.$mkdir(i)}catch(s){return T._handleError(s)}},async readFile(i){try{const s=f._fileSystemProvider.get(i.scheme);return s?(await f._proxy.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await f._proxy.$readFile(i)).buffer}catch(s){return T._handleError(s)}},async writeFile(i,s){try{const t=f._fileSystemProvider.get(i.scheme);return t&&!t.isReadonly?(await f._proxy.$ensureActivation(i.scheme),await f.mkdirp(t.impl,t.extUri,t.extUri.dirname(i)),await f._writeQueue.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await f._proxy.$writeFile(i,k.VSBuffer.wrap(s))}catch(t){return T._handleError(t)}},async delete(i,s){try{const t=f._fileSystemProvider.get(i.scheme);return t&&!t.isReadonly&&!s?.useTrash?(await f._proxy.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...s})):await f._proxy.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(t){return T._handleError(t)}},async rename(i,s,t){try{return await f._proxy.$rename(i,s,{overwrite:!1,...t})}catch(o){return T._handleError(o)}},async copy(i,s,t){try{return await f._proxy.$copy(i,s,{overwrite:!1,...t})}catch(o){return T._handleError(o)}},isWritableFileSystem(i){const s=p.getCapabilities(i);if(typeof s=="number")return!(s&d.FileSystemProviderCapabilities.Readonly)}})}async mkdirp(m,p,f){const i=[];for(;!p.isEqual(f,p.dirname(f));)try{if(!((await m.stat(f)).type&d.FileType.Directory))throw P.FileSystemError.FileExists(`Unable to create folder '${f.scheme===u.Schemas.file?f.fsPath:f.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(d.toFileSystemProviderErrorCode(s)!==d.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(p.basename(f)),f=p.dirname(f)}for(let s=i.length-1;s>=0;s--){f=p.joinPath(f,i[s]);try{await m.createDirectory(f)}catch(t){if(d.toFileSystemProviderErrorCode(t)!==d.FileSystemProviderErrorCode.FileExists)throw t}}}static _handleError(m){if(m instanceof P.FileSystemError)throw m;if(m instanceof d.FileSystemProviderError)switch(m.code){case d.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(m.message);case d.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(m.message);case d.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(m.message);case d.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(m.message);case d.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(m.message);case d.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(m.message);default:throw new P.FileSystemError(m.message,m.name)}if(!(m instanceof Error))throw new P.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw P.FileSystemError.Unavailable(m.message);switch(m.name){case d.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(m.message);case d.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(m.message);case d.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(m.message);case d.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(m.message);case d.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(m.message);case d.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(m.message);default:throw new P.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,p,f){return this._fileSystemProvider.set(m,{impl:p,extUri:f?.isCaseSensitive?y.extUri:y.extUriIgnorePathCase,isReadonly:!!f?.isReadonly}),(0,l.toDisposable)(()=>this._fileSystemProvider.delete(m))}getFileSystemProviderExtUri(m){return this._fileSystemProvider.get(m)?.extUri??y.extUri}};e.ExtHostConsumerFileSystem=b,e.ExtHostConsumerFileSystem=b=T=Xe([He(0,R.IExtHostRpcService),He(1,v.IExtHostFileSystemInfo)],b),e.IExtHostConsumerFileSystem=(0,L.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[97],Ie([1,0,5,29,11,75,2]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let R=class{constructor(l,I,y){this._logService=I,this._extHostFileSystem=y,this._workspace=l.workspace??void 0,this._environment=l.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(l){return L.URI.joinPath(this._environment.workspaceStorageHome,l)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const l=this._workspace.id,I=await this._getWorkspaceStorageURI(l);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(L.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:L.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),I}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(l){if(this._value)return L.URI.joinPath(this._value,l.identifier.value)}globalValue(l){return L.URI.joinPath(this._environment.globalStorageHome,l.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=R,e.ExtensionStoragePaths=R=Xe([He(0,d.IExtHostInitDataService),He(1,P.ILogService),He(2,k.IExtHostConsumerFileSystem)],R)}),define(Ce[293],Ie([1,0,9,19,4]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let k=class{constructor(R){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new P.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(R){let v;switch(R){case"light":v=r.ColorThemeKind.Light;break;case"hcDark":v=r.ColorThemeKind.HighContrast;break;case"hcLight":v=r.ColorThemeKind.HighContrastLight;break;default:v=r.ColorThemeKind.Dark}this._actual=new r.ColorTheme(v),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=k,e.ExtHostTheming=k=Xe([He(0,d.IExtHostRpcService)],k)}),define(Ce[76],Ie([1,0,20,4,3,8,5,11,92,6,29,19,9]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0,k=$e(k),u=$e(u);class T extends v.DisposableTunnel{}var b;(function(m){function p(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?v.TunnelPrivacyId.Public:v.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=p;function f(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==v.TunnelPrivacyId.ConstantPrivate&&i.privacy!==v.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=f})(b||(e.TunnelDtoConverter=b={})),e.IExtHostTunnelService=(0,L.createDecorator)("IExtHostTunnelService");let a=class extends P.Disposable{constructor(p,f,i){super(),this.logService=i,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new d.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=p.getProxy(l.MainContext.MainThreadTunnelService)}async openTunnel(p,f){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const i=await this._proxy.$openTunnel(f,p.displayName);if(i){const s=new T(i.remoteAddress,i.localAddress,()=>this._proxy.$closeTunnel(i.remoteAddress));return this._register(s),s}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(p,f){p.portRange===void 0&&p.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(i,{selector:p,provider:f}),this._proxy.$registerPortsAttributesProvider(p,i),new u.Disposable(()=>{this._portAttributesProviders.delete(i),this._proxy.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(p,f,i,s,t){const o=[];for(const h of p){const c=this._portAttributesProviders.get(h);if(!c)return[];o.push(...await Promise.all(f.map(async g=>{let w;try{w=await c.provider.providePortAttributes({port:g,pid:i,commandLine:s},t)}catch{w=await c.provider.providePortAttributes(g,i,s,t)}return{providedAttributes:w,port:g}})))}const n=o.filter(h=>!!h.providedAttributes);return n.length>0?n.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(p){}registerTunnelProvider(p,f){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(s,t)=>await p.provideTunnel(s,t,r.CancellationToken.None)??void 0;const i=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,privacyOptions:f.tunnelFeatures?.privacyOptions,protocol:f.tunnelFeatures.protocol===void 0?!0:f.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(i),Promise.resolve((0,P.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(p,f){if(p){p.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this._showCandidatePort=p.showCandidatePort,this._proxy.$setCandidateFilter());const i=p.tunnelFactory??(f?this.makeManagedTunnelFactory(f):void 0);if(i){this._forwardPortProvider=i;let s=p.tunnelFeatures?.privacyOptions??[];p.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:k.localize(10821,null),themeIcon:"lock"},{id:"public",label:k.localize(10822,null),themeIcon:"eye"}]);const t=p.tunnelFeatures?{elevation:!!p.tunnelFeatures?.elevation,public:!!p.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this._proxy.$setTunnelProvider(t)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(p){}async $closeTunnel(p,f){if(this._extensionTunnels.has(p.host)){const i=this._extensionTunnels.get(p.host);i.has(p.port)&&(f&&i.get(p.port).disposeListener.dispose(),await i.get(p.port).tunnel.dispose(),i.delete(p.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(p,f){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this._forwardPortProvider(p,f);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(p.remoteAddress.host)||this._extensionTunnels.set(p.remoteAddress.host,new Map);const t=this._register(s.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(s.remoteAddress))));return this._extensionTunnels.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:s,disposeListener:t}),b.fromApiTunnel(s)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(p){const f=await Promise.all(p.map(s=>this._showCandidatePort(s.host,s.port,s.detail??""))),i=p.filter((s,t)=>f[t]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.ExtHostTunnelService=a,e.ExtHostTunnelService=a=Xe([He(0,y.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,R.ILogService)],a)}),define(Ce[15],Ie([1,0,18,21,190,79,85,28,178,44,103,24,183,22,51,17,2,113,30,110,87,58,145,89,155,152,153,271,119,126,73,74,268,9]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n,h,c,g,w,D,_,C,A,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=Z,e.fromRangeOrRangeWithMessage=ne,e.pathOrURIToURI=_e,L=$e(L),f=$e(f),i=$e(i),s=$e(s),w=$e(w),_=$e(_),S=$e(S);var F;(function(Re){function Me(ie){const{selectionStartLineNumber:Ae,selectionStartColumn:qe,positionLineNumber:Ze,positionColumn:Ge}=ie,ft=new S.Position(Ae-1,qe-1),kt=new S.Position(Ze-1,Ge-1);return new S.Selection(ft,kt)}Re.to=Me;function ye(ie){const{anchor:Ae,active:qe}=ie;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Re.from=ye})(F||(e.Selection=F={}));var N;(function(Re){function Me(ie){if(!ie)return;const{start:Ae,end:qe}=ie;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Re.from=Me;function ye(ie){if(!ie)return;const{startLineNumber:Ae,startColumn:qe,endLineNumber:Ze,endColumn:Ge}=ie;return new S.Range(Ae-1,qe-1,Ze-1,Ge-1)}Re.to=ye})(N||(e.Range=N={}));var O;(function(Re){function Me(ie){return{uri:ie.uri,range:N.from(ie.range)}}Re.from=Me;function ye(ie){return new S.Location(m.URI.revive(ie.uri),N.to(ie.range))}Re.to=ye})(O||(e.Location=O={}));var M;(function(Re){function Me(ye){switch(ye){case i.StandardTokenType.Comment:return S.StandardTokenType.Comment;case i.StandardTokenType.Other:return S.StandardTokenType.Other;case i.StandardTokenType.RegEx:return S.StandardTokenType.RegEx;case i.StandardTokenType.String:return S.StandardTokenType.String}}Re.to=Me})(M||(e.TokenType=M={}));var U;(function(Re){function Me(ie){return new S.Position(ie.lineNumber-1,ie.column-1)}Re.to=Me;function ye(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Re.from=ye})(U||(e.Position=U={}));var x;(function(Re){function Me(Ae,qe,Ze){return(0,r.coalesce)((0,r.asArray)(Ae).map(Ge=>ye(Ge,qe,Ze)))}Re.from=Me;function ye(Ae,qe,Ze){if(typeof Ae=="string")return{$serialized:!0,language:Ae,isBuiltin:Ze?.isBuiltin};if(Ae)return{$serialized:!0,language:Ae.language,scheme:ie(Ae.scheme,qe),pattern:tt.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType,isBuiltin:Ze?.isBuiltin}}function ie(Ae,qe){return qe&&typeof Ae=="string"?qe.transformOutgoingScheme(Ae):Ae}})(x||(e.DocumentSelector=x={}));var z;(function(Re){function Me(ie){switch(ie){case S.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case S.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}Re.from=Me;function ye(ie){switch(ie){case o.MarkerTag.Unnecessary:return S.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return S.DiagnosticTag.Deprecated;default:return}}Re.to=ye})(z||(e.DiagnosticTag=z={}));var B;(function(Re){function Me(ie){let Ae;return ie.code&&((0,a.isString)(ie.code)||(0,a.isNumber)(ie.code)?Ae=String(ie.code):Ae={value:String(ie.code.value),target:ie.code.target}),{...N.from(ie.range),message:ie.message,source:ie.source,code:Ae,severity:V.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(ee.from),tags:Array.isArray(ie.tags)?(0,r.coalesce)(ie.tags.map(z.from)):void 0}}Re.from=Me;function ye(ie){const Ae=new S.Diagnostic(N.to(ie),ie.message,V.to(ie.severity));return Ae.source=ie.source,Ae.code=(0,a.isString)(ie.code)?ie.code:ie.code?.value,Ae.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(ee.to),Ae.tags=ie.tags&&(0,r.coalesce)(ie.tags.map(z.to)),Ae}Re.to=ye})(B||(e.Diagnostic=B={}));var ee;(function(Re){function Me(ie){return{...N.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Re.from=Me;function ye(ie){return new S.DiagnosticRelatedInformation(new S.Location(ie.resource,N.to(ie)),ie.message)}Re.to=ye})(ee||(e.DiagnosticRelatedInformation=ee={}));var V;(function(Re){function Me(ie){switch(ie){case S.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Re.from=Me;function ye(ie){switch(ie){case o.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}Re.to=ye})(V||(e.DiagnosticSeverity=V={}));var $;(function(Re){function Me(ie){return typeof ie=="number"&&ie>=S.ViewColumn.One?ie-1:ie===S.ViewColumn.Beside?E.SIDE_GROUP:E.ACTIVE_GROUP}Re.from=Me;function ye(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=ye})($||(e.ViewColumn=$={}));function G(Re){return typeof Re.range<"u"}function Z(Re){return Re.length===0?!0:!!G(Re[0])}var le;(function(Re){function Me(Ge){return Ge.map(Re.from)}Re.fromMany=Me;function ye(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ie(Ge){let ft;if(ye(Ge)){const{language:Ut,value:Zt}=Ge;ft={value:"```"+Ut+`
`+Zt+"\n```\n"}}else S.MarkdownString.isMarkdownString(Ge)?ft={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ft={value:Ge}:ft={value:""};const kt=Object.create(null);ft.uris=kt;const Qt=Ut=>{try{let Zt=m.URI.parse(Ut,!0);Zt=Zt.with({query:Ae(Zt.query,kt)}),kt[Ut]=Zt}catch{}return""},si=new v.marked.Renderer;return si.link=Qt,si.image=Ut=>typeof Ut=="string"?Qt(L.parseHrefAndDimensions(Ut).href):"",(0,v.marked)(ft.value,{renderer:si}),ft}Re.from=ie;function Ae(Ge,ft){if(!Ge)return Ge;let kt;try{kt=(0,l.parse)(Ge)}catch{}if(!kt)return Ge;let Qt=!1;return kt=(0,y.cloneAndChange)(kt,si=>{if(m.URI.isUri(si)){const Ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[Ut]=si,Qt=!0,Ut}else return}),Qt?JSON.stringify(kt):Ge}function qe(Ge){const ft=new S.MarkdownString(Ge.value,Ge.supportThemeIcons);return ft.isTrusted=Ge.isTrusted,ft.supportHtml=Ge.supportHtml,ft.baseUri=Ge.baseUri?m.URI.from(Ge.baseUri):void 0,ft}Re.to=qe;function Ze(Ge){if(Ge)return typeof Ge=="string"?Ge:Re.from(Ge)}Re.fromStrict=Ze})(le||(e.MarkdownString=le={}));function ne(Re){return Z(Re)?Re.map(Me=>({range:N.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?le.fromMany(Me.hoverMessage):Me.hoverMessage?le.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Re.map(Me=>({range:N.from(Me)}))}function _e(Re){return typeof Re>"u"?Re:typeof Re=="string"?m.URI.file(Re):Re}var ge;(function(Re){function Me(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?_e(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Re.from=Me})(ge||(e.ThemableDecorationAttachmentRenderOptions=ge={}));var Y;(function(Re){function Me(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?_e(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?ge.from(ye.before):void 0,after:ye.after?ge.from(ye.after):void 0}}Re.from=Me})(Y||(e.ThemableDecorationRenderOptions=Y={}));var W;(function(Re){function Me(ye){if(typeof ye>"u")return ye;switch(ye){case S.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case S.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case S.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case S.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Re.from=Me})(W||(e.DecorationRangeBehavior=W={}));var oe;(function(Re){function Me(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?W.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?Y.from(ye.light):void 0,dark:ye.dark?Y.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?_e(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?ge.from(ye.before):void 0,after:ye.after?ge.from(ye.after):void 0}}Re.from=Me})(oe||(e.DecorationRenderOptions=oe={}));var Se;(function(Re){function Me(ie){return{text:ie.newText,eol:ie.newEol&&xe.from(ie.newEol),range:N.from(ie.range)}}Re.from=Me;function ye(ie){const Ae=new S.TextEdit(N.to(ie.range),ie.text);return Ae.newEol=typeof ie.eol>"u"?void 0:xe.to(ie.eol),Ae}Re.to=ye})(Se||(e.TextEdit=Se={}));var te;(function(Re){function Me(ie,Ae){const qe={edits:[]};if(ie instanceof S.WorkspaceEdit){const Ze=new R.ResourceSet;for(const Ge of ie._allEntries())Ge._type===S.FileEditType.File&&m.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of ie._allEntries())if(Ge._type===S.FileEditType.File){let ft;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ft={type:"base64",value:(0,d.encodeBase64)(d.VSBuffer.wrap(Ge.options.contents))}:ft={type:"dataTransferItem",id:Ge.options.contents._itemId}),qe.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ft},metadata:Ge.metadata})}else Ge._type===S.FileEditType.Text?qe.edits.push({resource:Ge.uri,textEdit:Se.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:Ae?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===S.FileEditType.Snippet?qe.edits.push({resource:Ge.uri,textEdit:{range:N.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:Ae?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===S.FileEditType.Cell?qe.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===S.FileEditType.CellReplace&&qe.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:_.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Rt.from)}})}return qe}Re.from=Me;function ye(ie){const Ae=new S.WorkspaceEdit,qe=new R.ResourceMap;for(const Ze of ie.edits)if(Ze.textEdit){const Ge=Ze,ft=m.URI.revive(Ge.resource),kt=N.to(Ge.textEdit.range),Qt=Ge.textEdit.text,si=Ge.textEdit.insertAsSnippet;let Ut;si?Ut=S.SnippetTextEdit.replace(kt,new S.SnippetString(Qt)):Ut=S.TextEdit.replace(kt,Qt);const Zt=qe.get(ft);Zt?Zt.push(Ut):qe.set(ft,[Ut])}else Ae.renameFile(m.URI.revive(Ze.oldResource),m.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ge]of qe)Ae.set(Ze,Ge);return Ae}Re.to=ye})(te||(e.WorkspaceEdit=te={}));var ae;(function(Re){const Me=Object.create(null);Me[S.SymbolKind.File]=s.SymbolKind.File,Me[S.SymbolKind.Module]=s.SymbolKind.Module,Me[S.SymbolKind.Namespace]=s.SymbolKind.Namespace,Me[S.SymbolKind.Package]=s.SymbolKind.Package,Me[S.SymbolKind.Class]=s.SymbolKind.Class,Me[S.SymbolKind.Method]=s.SymbolKind.Method,Me[S.SymbolKind.Property]=s.SymbolKind.Property,Me[S.SymbolKind.Field]=s.SymbolKind.Field,Me[S.SymbolKind.Constructor]=s.SymbolKind.Constructor,Me[S.SymbolKind.Enum]=s.SymbolKind.Enum,Me[S.SymbolKind.Interface]=s.SymbolKind.Interface,Me[S.SymbolKind.Function]=s.SymbolKind.Function,Me[S.SymbolKind.Variable]=s.SymbolKind.Variable,Me[S.SymbolKind.Constant]=s.SymbolKind.Constant,Me[S.SymbolKind.String]=s.SymbolKind.String,Me[S.SymbolKind.Number]=s.SymbolKind.Number,Me[S.SymbolKind.Boolean]=s.SymbolKind.Boolean,Me[S.SymbolKind.Array]=s.SymbolKind.Array,Me[S.SymbolKind.Object]=s.SymbolKind.Object,Me[S.SymbolKind.Key]=s.SymbolKind.Key,Me[S.SymbolKind.Null]=s.SymbolKind.Null,Me[S.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Me[S.SymbolKind.Struct]=s.SymbolKind.Struct,Me[S.SymbolKind.Event]=s.SymbolKind.Event,Me[S.SymbolKind.Operator]=s.SymbolKind.Operator,Me[S.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function ye(Ae){return typeof Me[Ae]=="number"?Me[Ae]:s.SymbolKind.Property}Re.from=ye;function ie(Ae){for(const qe in Me)if(Me[qe]===Ae)return Number(qe);return S.SymbolKind.Property}Re.to=ie})(ae||(e.SymbolKind=ae={}));var se;(function(Re){function Me(ie){switch(ie){case S.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}Re.from=Me;function ye(ie){switch(ie){case s.SymbolTag.Deprecated:return S.SymbolTag.Deprecated}}Re.to=ye})(se||(e.SymbolTag=se={}));var Q;(function(Re){function Me(ie){return{name:ie.name,kind:ae.from(ie.kind),tags:ie.tags&&ie.tags.map(se.from),containerName:ie.containerName,location:Be.from(ie.location)}}Re.from=Me;function ye(ie){const Ae=new S.SymbolInformation(ie.name,ae.to(ie.kind),ie.containerName,Be.to(ie.location));return Ae.tags=ie.tags&&ie.tags.map(se.to),Ae}Re.to=ye})(Q||(e.WorkspaceSymbol=Q={}));var re;(function(Re){function Me(ie){const Ae={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),kind:ae.from(ie.kind),tags:ie.tags?.map(se.from)??[]};return ie.children&&(Ae.children=ie.children.map(Me)),Ae}Re.from=Me;function ye(ie){const Ae=new S.DocumentSymbol(ie.name,ie.detail,ae.to(ie.kind),N.to(ie.range),N.to(ie.selectionRange));return(0,r.isNonEmptyArray)(ie.tags)&&(Ae.tags=ie.tags.map(se.to)),ie.children&&(Ae.children=ie.children.map(ye)),Ae}Re.to=ye})(re||(e.DocumentSymbol=re={}));var ve;(function(Re){function Me(ie){const Ae=new S.CallHierarchyItem(ae.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Ae._sessionId=ie._sessionId,Ae._itemId=ie._itemId,Ae}Re.to=Me;function ye(ie,Ae,qe){if(Ae=Ae??ie._sessionId,qe=qe??ie._itemId,Ae===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:qe,name:ie.name,detail:ie.detail,kind:ae.from(ie.kind),uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(se.from)}}Re.from=ye})(ve||(e.CallHierarchyItem=ve={}));var be;(function(Re){function Me(ye){return new S.CallHierarchyIncomingCall(ve.to(ye.from),ye.fromRanges.map(ie=>N.to(ie)))}Re.to=Me})(be||(e.CallHierarchyIncomingCall=be={}));var Fe;(function(Re){function Me(ye){return new S.CallHierarchyOutgoingCall(ve.to(ye.to),ye.fromRanges.map(ie=>N.to(ie)))}Re.to=Me})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var Be;(function(Re){function Me(ie){return{range:ie.range&&N.from(ie.range),uri:ie.uri}}Re.from=Me;function ye(ie){return new S.Location(m.URI.revive(ie.uri),N.to(ie.range))}Re.to=ye})(Be||(e.location=Be={}));var ke;(function(Re){function Me(ie){const Ae=ie,qe=ie;return{originSelectionRange:Ae.originSelectionRange?N.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:qe.uri,range:N.from(Ae.targetRange?Ae.targetRange:qe.range),targetSelectionRange:Ae.targetSelectionRange?N.from(Ae.targetSelectionRange):void 0}}Re.from=Me;function ye(ie){return{targetUri:m.URI.revive(ie.uri),targetRange:N.to(ie.range),targetSelectionRange:ie.targetSelectionRange?N.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?N.to(ie.originSelectionRange):void 0}}Re.to=ye})(ke||(e.DefinitionLink=ke={}));var De;(function(Re){function Me(ie){return{range:N.from(ie.range),contents:le.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Re.from=Me;function ye(ie){const Ae=ie.contents.map(le.to),qe=N.to(ie.range),Ze=ie.canIncreaseVerbosity,Ge=ie.canDecreaseVerbosity;return new S.VerboseHover(Ae,qe,Ze,Ge)}Re.to=ye})(De||(e.Hover=De={}));var Pe;(function(Re){function Me(ie){return{range:N.from(ie.range),expression:ie.expression}}Re.from=Me;function ye(ie){return new S.EvaluatableExpression(N.to(ie.range),ie.expression)}Re.to=ye})(Pe||(e.EvaluatableExpression=Pe={}));var H;(function(Re){function Me(ie){if(ie instanceof S.InlineValueText)return{type:"text",range:N.from(ie.range),text:ie.text};if(ie instanceof S.InlineValueVariableLookup)return{type:"variable",range:N.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:N.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Me;function ye(ie){switch(ie.type){case"text":return{range:N.to(ie.range),text:ie.text};case"variable":return{range:N.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:N.to(ie.range),expression:ie.expression}}}Re.to=ye})(H||(e.InlineValue=H={}));var q;(function(Re){function Me(ie){return{frameId:ie.frameId,stoppedLocation:N.from(ie.stoppedLocation)}}Re.from=Me;function ye(ie){return new S.InlineValueContext(ie.frameId,N.to(ie.stoppedLocation))}Re.to=ye})(q||(e.InlineValueContext=q={}));var X;(function(Re){function Me(ie){return{range:N.from(ie.range),kind:ie.kind}}Re.from=Me;function ye(ie){return new S.DocumentHighlight(N.to(ie.range),ie.kind)}Re.to=ye})(X||(e.DocumentHighlight=X={}));var J;(function(Re){function Me(ie){return{uri:ie.uri,highlights:ie.highlights.map(X.from)}}Re.from=Me;function ye(ie){return new S.MultiDocumentHighlight(m.URI.revive(ie.uri),ie.highlights.map(X.to))}Re.to=ye})(J||(e.MultiDocumentHighlight=J={}));var he;(function(Re){function Me(ye){switch(ye){case s.CompletionTriggerKind.TriggerCharacter:return S.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return S.CompletionTriggerKind.Invoke}}Re.to=Me})(he||(e.CompletionTriggerKind=he={}));var we;(function(Re){function Me(ye){return{triggerKind:he.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Re.to=Me})(we||(e.CompletionContext=we={}));var Oe;(function(Re){function Me(ie){switch(ie){case S.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}Re.from=Me;function ye(ie){switch(ie){case s.CompletionItemTag.Deprecated:return S.CompletionItemTag.Deprecated}}Re.to=ye})(Oe||(e.CompletionItemTag=Oe={}));var Ve;(function(Re){const Me=new Map([[S.CompletionItemKind.Method,s.CompletionItemKind.Method],[S.CompletionItemKind.Function,s.CompletionItemKind.Function],[S.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[S.CompletionItemKind.Field,s.CompletionItemKind.Field],[S.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[S.CompletionItemKind.Class,s.CompletionItemKind.Class],[S.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[S.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[S.CompletionItemKind.Module,s.CompletionItemKind.Module],[S.CompletionItemKind.Property,s.CompletionItemKind.Property],[S.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[S.CompletionItemKind.Value,s.CompletionItemKind.Value],[S.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[S.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[S.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[S.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[S.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[S.CompletionItemKind.Text,s.CompletionItemKind.Text],[S.CompletionItemKind.Color,s.CompletionItemKind.Color],[S.CompletionItemKind.File,s.CompletionItemKind.File],[S.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[S.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[S.CompletionItemKind.Event,s.CompletionItemKind.Event],[S.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[S.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[S.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[S.CompletionItemKind.User,s.CompletionItemKind.User]]);function ye(qe){return Me.get(qe)??s.CompletionItemKind.Property}Re.from=ye;const ie=new Map([[s.CompletionItemKind.Method,S.CompletionItemKind.Method],[s.CompletionItemKind.Function,S.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,S.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,S.CompletionItemKind.Field],[s.CompletionItemKind.Variable,S.CompletionItemKind.Variable],[s.CompletionItemKind.Class,S.CompletionItemKind.Class],[s.CompletionItemKind.Interface,S.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,S.CompletionItemKind.Struct],[s.CompletionItemKind.Module,S.CompletionItemKind.Module],[s.CompletionItemKind.Property,S.CompletionItemKind.Property],[s.CompletionItemKind.Unit,S.CompletionItemKind.Unit],[s.CompletionItemKind.Value,S.CompletionItemKind.Value],[s.CompletionItemKind.Constant,S.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,S.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,S.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,S.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,S.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,S.CompletionItemKind.Text],[s.CompletionItemKind.Color,S.CompletionItemKind.Color],[s.CompletionItemKind.File,S.CompletionItemKind.File],[s.CompletionItemKind.Reference,S.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,S.CompletionItemKind.Folder],[s.CompletionItemKind.Event,S.CompletionItemKind.Event],[s.CompletionItemKind.Operator,S.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,S.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,S.CompletionItemKind.User],[s.CompletionItemKind.Issue,S.CompletionItemKind.Issue]]);function Ae(qe){return ie.get(qe)??S.CompletionItemKind.Property}Re.to=Ae})(Ve||(e.CompletionItemKind=Ve={}));var Ke;(function(Re){function Me(ye,ie){const Ae=new S.CompletionItem(ye.label);return Ae.insertText=ye.insertText,Ae.kind=Ve.to(ye.kind),Ae.tags=ye.tags?.map(Oe.to),Ae.detail=ye.detail,Ae.documentation=L.isMarkdownString(ye.documentation)?le.to(ye.documentation):ye.documentation,Ae.sortText=ye.sortText,Ae.filterText=ye.filterText,Ae.preselect=ye.preselect,Ae.commitCharacters=ye.commitCharacters,f.Range.isIRange(ye.range)?Ae.range=N.to(ye.range):typeof ye.range=="object"&&(Ae.range={inserting:N.to(ye.range.insert),replacing:N.to(ye.range.replace)}),Ae.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof ye.insertTextRules<"u"&&ye.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Ae.insertText=new S.SnippetString(ye.insertText):(Ae.insertText=ye.insertText,Ae.textEdit=Ae.range instanceof S.Range?new S.TextEdit(Ae.range,Ae.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ye.additionalTextEdits.map(qe=>Se.to(qe))),Ae.command=ie&&ye.command?ie.fromInternal(ye.command):void 0,Ae}Re.to=Me})(Ke||(e.CompletionItem=Ke={}));var et;(function(Re){function Me(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:le.fromStrict(ie.documentation)}}Re.from=Me;function ye(ie){return{label:ie.label,documentation:L.isMarkdownString(ie.documentation)?le.to(ie.documentation):ie.documentation}}Re.to=ye})(et||(e.ParameterInformation=et={}));var nt;(function(Re){function Me(ie){return{label:ie.label,documentation:le.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(et.from):[],activeParameter:ie.activeParameter}}Re.from=Me;function ye(ie){return{label:ie.label,documentation:L.isMarkdownString(ie.documentation)?le.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(et.to):[],activeParameter:ie.activeParameter}}Re.to=ye})(nt||(e.SignatureInformation=nt={}));var st;(function(Re){function Me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(nt.from):[]}}Re.from=Me;function ye(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(nt.to):[]}}Re.to=ye})(st||(e.SignatureHelp=st={}));var rt;(function(Re){function Me(ye,ie){const Ae=new S.InlayHint(U.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(at.to.bind(void 0,ye)),ie.kind&&gt.to(ie.kind));return Ae.textEdits=ie.textEdits&&ie.textEdits.map(Se.to),Ae.tooltip=L.isMarkdownString(ie.tooltip)?le.to(ie.tooltip):ie.tooltip,Ae.paddingLeft=ie.paddingLeft,Ae.paddingRight=ie.paddingRight,Ae}Re.to=Me})(rt||(e.InlayHint=rt={}));var at;(function(Re){function Me(ye,ie){const Ae=new S.InlayHintLabelPart(ie.label);return Ae.tooltip=L.isMarkdownString(ie.tooltip)?le.to(ie.tooltip):ie.tooltip,s.Command.is(ie.command)&&(Ae.command=ye.fromInternal(ie.command)),ie.location&&(Ae.location=Be.to(ie.location)),Ae}Re.to=Me})(at||(e.InlayHintLabelPart=at={}));var gt;(function(Re){function Me(ie){return ie}Re.from=Me;function ye(ie){return ie}Re.to=ye})(gt||(e.InlayHintKind=gt={}));var ht;(function(Re){function Me(ie){return{range:N.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Re.from=Me;function ye(ie){let Ae;if(ie.url)try{Ae=typeof ie.url=="string"?m.URI.parse(ie.url,!0):m.URI.revive(ie.url)}catch{}const qe=new S.DocumentLink(N.to(ie.range),Ae);return qe.tooltip=ie.tooltip,qe}Re.to=ye})(ht||(e.DocumentLink=ht={}));var lt;(function(Re){function Me(ie){const Ae=new S.ColorPresentation(ie.label);return ie.textEdit&&(Ae.textEdit=Se.to(ie.textEdit)),ie.additionalTextEdits&&(Ae.additionalTextEdits=ie.additionalTextEdits.map(qe=>Se.to(qe))),Ae}Re.to=Me;function ye(ie){return{label:ie.label,textEdit:ie.textEdit?Se.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Ae=>Se.from(Ae)):void 0}}Re.from=ye})(lt||(e.ColorPresentation=lt={}));var Te;(function(Re){function Me(ie){return new S.Color(ie[0],ie[1],ie[2],ie[3])}Re.to=Me;function ye(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Re.from=ye})(Te||(e.Color=Te={}));var Ue;(function(Re){function Me(ie){return{range:N.from(ie.range)}}Re.from=Me;function ye(ie){return new S.SelectionRange(N.to(ie.range))}Re.to=ye})(Ue||(e.SelectionRange=Ue={}));var je;(function(Re){function Me(ye){switch(ye){case c.SaveReason.AUTO:return S.TextDocumentSaveReason.AfterDelay;case c.SaveReason.EXPLICIT:return S.TextDocumentSaveReason.Manual;case c.SaveReason.FOCUS_CHANGE:case c.SaveReason.WINDOW_CHANGE:return S.TextDocumentSaveReason.FocusOut}}Re.to=Me})(je||(e.TextDocumentSaveReason=je={}));var Ne;(function(Re){function Me(ie){switch(ie){case S.TextEditorLineNumbersStyle.Off:return p.RenderLineNumbersType.Off;case S.TextEditorLineNumbersStyle.Relative:return p.RenderLineNumbersType.Relative;case S.TextEditorLineNumbersStyle.Interval:return p.RenderLineNumbersType.Interval;case S.TextEditorLineNumbersStyle.On:default:return p.RenderLineNumbersType.On}}Re.from=Me;function ye(ie){switch(ie){case p.RenderLineNumbersType.Off:return S.TextEditorLineNumbersStyle.Off;case p.RenderLineNumbersType.Relative:return S.TextEditorLineNumbersStyle.Relative;case p.RenderLineNumbersType.Interval:return S.TextEditorLineNumbersStyle.Interval;case p.RenderLineNumbersType.On:default:return S.TextEditorLineNumbersStyle.On}}Re.to=ye})(Ne||(e.TextEditorLineNumbersStyle=Ne={}));var xe;(function(Re){function Me(ie){if(ie===S.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===S.EndOfLine.LF)return t.EndOfLineSequence.LF}Re.from=Me;function ye(ie){if(ie===t.EndOfLineSequence.CRLF)return S.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return S.EndOfLine.LF}Re.to=ye})(xe||(e.EndOfLine=xe={}));var ue;(function(Re){function Me(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case S.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case S.ProgressLocation.Window:return n.ProgressLocation.Window;case S.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Re.from=Me})(ue||(e.ProgressLocation=ue={}));var de;(function(Re){function Me(ie){const Ae={start:ie.start+1,end:ie.end+1};return ie.kind&&(Ae.kind=ce.from(ie.kind)),Ae}Re.from=Me;function ye(ie){const Ae={start:ie.start-1,end:ie.end-1};return ie.kind&&(Ae.kind=ce.to(ie.kind)),Ae}Re.to=ye})(de||(e.FoldingRange=de={}));var ce;(function(Re){function Me(ie){if(ie)switch(ie){case S.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}Re.from=Me;function ye(ie){if(ie)switch(ie.value){case s.FoldingRangeKind.Comment.value:return S.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports.value:return S.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region.value:return S.FoldingRangeKind.Region}}Re.to=ye})(ce||(e.FoldingRangeKind=ce={}));var Qe;(function(Re){function Me(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?N.from(ye.selection):void 0,override:typeof ye.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Me})(Qe||(e.TextEditorOpenOptions=Qe={}));var tt;(function(Re){function Me(qe){return qe instanceof S.RelativePattern?qe.toJSON():typeof qe=="string"?qe:ye(qe)||ie(qe)?new S.RelativePattern(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Re.from=Me;function ye(qe){const Ze=qe;return Ze?m.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function ie(qe){const Ze=qe;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ae(qe){return typeof qe=="string"?qe:new S.RelativePattern(m.URI.revive(qe.baseUri),qe.pattern)}Re.to=Ae})(tt||(e.GlobPattern=tt={}));var ut;(function(Re){function Me(ye){if(ye){if(Array.isArray(ye))return ye.map(Me);if(typeof ye=="string")return ye;{const ie=ye;return{language:ie.language,scheme:ie.scheme,pattern:tt.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Re.from=Me})(ut||(e.LanguageSelector=ut={}));var mt;(function(Re){function Me(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Ae=>Array.isArray(Ae)&&Ae.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&m.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(Ze=>Ze instanceof S.Range)))}Re.is=Me;function ye(ie){return{documents:ie.documents.map(Ae=>Ae.map(qe=>({uri:m.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(Ze=>N.from(Ze))})))}}Re.from=ye})(mt||(e.MappedEditsContext=mt={}));var Dt;(function(Re){function Me(ie){return{start:ie.start,end:ie.end}}Re.from=Me;function ye(ie){return new S.NotebookRange(ie.start,ie.end)}Re.to=ye})(Dt||(e.NotebookRange=Dt={}));var Mt;(function(Re){function Me(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Re.to=Me;function ye(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Re.from=ye})(Mt||(e.NotebookCellExecutionSummary=Mt={}));var Vt;(function(Re){function Me(ye){if(ye===_.NotebookCellExecutionState.Unconfirmed)return S.NotebookCellExecutionState.Pending;if(ye===_.NotebookCellExecutionState.Pending)return;if(ye===_.NotebookCellExecutionState.Executing)return S.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Re.to=Me})(Vt||(e.NotebookCellExecutionState=Vt={}));var ei;(function(Re){function Me(ie){switch(ie){case S.NotebookCellKind.Markup:return _.CellKind.Markup;case S.NotebookCellKind.Code:default:return _.CellKind.Code}}Re.from=Me;function ye(ie){switch(ie){case _.CellKind.Markup:return S.NotebookCellKind.Markup;case _.CellKind.Code:default:return S.NotebookCellKind.Code}}Re.to=ye})(ei||(e.NotebookCellKind=ei={}));var oi;(function(Re){function Me(ie){const Ae={metadata:ie.metadata??Object.create(null),cells:[]};for(const qe of ie.cells)S.NotebookCellData.validate(qe),Ae.cells.push(Rt.from(qe));return Ae}Re.from=Me;function ye(ie){const Ae=new S.NotebookData(ie.cells.map(Rt.to));return(0,a.isEmptyObject)(ie.metadata)||(Ae.metadata=ie.metadata),Ae}Re.to=ye})(oi||(e.NotebookData=oi={}));var Rt;(function(Re){function Me(ie){return{cellKind:ei.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Mt.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Pt.from):[]}}Re.from=Me;function ye(ie){return new S.NotebookCellData(ei.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Pt.to):void 0,ie.metadata,ie.internalMetadata?Mt.to(ie.internalMetadata):void 0)}Re.to=ye})(Rt||(e.NotebookCellData=Rt={}));var it;(function(Re){function Me(ie){return{mime:ie.mime,valueBytes:d.VSBuffer.wrap(ie.data)}}Re.from=Me;function ye(ie){return new S.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}Re.to=ye})(it||(e.NotebookCellOutputItem=it={}));var Pt;(function(Re){function Me(ie){return{outputId:ie.id,items:ie.items.map(it.from),metadata:ie.metadata}}Re.from=Me;function ye(ie){const Ae=ie.items.map(it.to);return new S.NotebookCellOutput(Ae,ie.outputId,ie.metadata)}Re.to=ye})(Pt||(e.NotebookCellOutput=Pt={}));var di;(function(Re){function Me(Ae){return ie(Ae)?{include:tt.from(Ae.include)??void 0,exclude:tt.from(Ae.exclude)??void 0}:tt.from(Ae)??void 0}Re.from=Me;function ye(Ae){return ie(Ae)?{include:tt.to(Ae.include),exclude:tt.to(Ae.exclude)}:tt.to(Ae)}Re.to=ye;function ie(Ae){const qe=Ae;return qe?!(0,a.isUndefinedOrNull)(qe.include)&&!(0,a.isUndefinedOrNull)(qe.exclude):!1}})(di||(e.NotebookExclusiveDocumentPattern=di={}));var Et;(function(Re){function Me(ye,ie,Ae){const qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===S.NotebookCellStatusBarAlignment.Left?_.CellStatusbarAlignment.Left:_.CellStatusbarAlignment.Right,command:ie.toInternal(qe,Ae),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Re.from=Me})(Et||(e.NotebookStatusBarItem=Et={}));var yt;(function(Re){function Me(ye,ie,Ae){const qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:ie.toInternal(qe,Ae),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Re.from=Me})(yt||(e.NotebookKernelSourceAction=yt={}));var ti;(function(Re){function Me(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Re.from=Me})(ti||(e.NotebookDocumentContentOptions=ti={}));var ii;(function(Re){function Me(ie){return{uri:ie.uri,provides:ie.provides}}Re.from=Me;function ye(ie){return new S.NotebookRendererScript(m.URI.revive(ie.uri),ie.provides)}Re.to=ye})(ii||(e.NotebookRendererScript=ii={}));var zt;(function(Re){function Me(ie){return{message:le.fromStrict(ie.message)||"",type:A.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:N.from(ie.location.range),uri:ie.location.uri},stackTrace:ie.stackTrace?.map(Ae=>({label:Ae.label,position:Ae.position&&U.from(Ae.position),uri:Ae.file&&m.URI.revive(Ae.file).toJSON()}))}}Re.from=Me;function ye(ie){const Ae=new S.TestMessage(typeof ie.message=="string"?ie.message:le.to(ie.message));return Ae.actualOutput=ie.actual,Ae.expectedOutput=ie.expected,Ae.contextValue=ie.contextValue,Ae.location=ie.location?Be.to(ie.location):void 0,Ae}Re.to=ye})(zt||(e.TestMessage=zt={}));var vt;(function(Re){Re.namespace=A.namespaceTestTag,Re.denamespace=A.denamespaceTestTag})(vt||(e.TestTag=vt={}));var Bt;(function(Re){function Me(ie){const Ae=(0,h.getPrivateApiFor)(ie).controllerId;return{extId:C.TestId.fromExtHostTestItem(ie,Ae).toString(),label:ie.label,uri:m.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(qe=>vt.namespace(Ae,qe.id)),range:f.Range.lift(N.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&le.fromStrict(ie.error)||null}}Re.from=Me;function ye(ie){return{parent:void 0,error:void 0,id:C.TestId.fromString(ie.extId).localId,label:ie.label,uri:m.URI.revive(ie.uri),tags:(ie.tags||[]).map(Ae=>{const{tagId:qe}=vt.denamespace(Ae);return new S.TestTag(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Re.toPlain=ye})(Bt||(e.TestItem=Bt={})),function(Re){function Me(ie){return{id:ie.id}}Re.from=Me;function ye(ie){return new S.TestTag(ie.id)}Re.to=ye}(vt||(e.TestTag=vt={}));var ni;(function(Re){const Me=(ie,Ae)=>{const qe=ie.value;if(!qe)return;const Ze={...Bt.toPlain(qe.item),parent:Ae,taskStates:qe.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ft=>ft.type===A.TestMessageType.Error).map(zt.to)})),children:[]};if(ie.children)for(const Ge of ie.children.values()){const ft=Me(Ge,Ze);ft&&Ze.children.push(ft)}return Ze};function ye(ie){const Ae=new u.WellDefinedPrefixTree;for(const Ge of ie.items)Ae.insert(C.TestId.fromString(Ge.item.extId).path,Ge);const qe=[Ae.nodes],Ze=[];for(;qe.length;)for(const Ge of qe.pop())Ge.value?Ze.push(Ge):Ge.children&&qe.push(Ge.children.values());return{completedAt:ie.completedAt,results:Ze.map(Ge=>Me(Ge)).filter(a.isDefined)}}Re.to=ye})(ni||(e.TestResults=ni={}));var ai;(function(Re){function Me(qe){return{covered:qe.covered,total:qe.total}}function ye(qe){return"line"in qe?U.from(qe):N.from(qe)}function ie(qe){if(typeof qe.executed=="number"&&qe.executed<0)throw new Error(`Invalid coverage count ${qe.executed}`);return"branches"in qe?{count:qe.executed,location:ye(qe.location),type:A.DetailType.Statement,branches:qe.branches.length?qe.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ye(Ze.location),label:Ze.label})):void 0}:{type:A.DetailType.Declaration,name:qe.name,count:qe.executed,location:ye(qe.location)}}Re.fromDetails=ie;function Ae(qe,Ze,Ge){return S.validateTestCoverageCount(Ge.statementCoverage),S.validateTestCoverageCount(Ge.branchCoverage),S.validateTestCoverageCount(Ge.declarationCoverage),{id:Ze,uri:Ge.uri,statement:Me(Ge.statementCoverage),branch:Ge.branchCoverage&&Me(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Me(Ge.declarationCoverage),testIds:Ge instanceof S.FileCoverage&&Ge.fromTests.length?Ge.fromTests.map(ft=>C.TestId.fromExtHostTestItem(ft,qe).toString()):void 0}}Re.fromFile=Ae})(ai||(e.TestCoverage=ai={}));var Je;(function(Re){function Me(ye){switch(ye){case s.CodeActionTriggerType.Invoke:return S.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return S.CodeActionTriggerKind.Automatic}}Re.to=Me})(Je||(e.CodeActionTriggerKind=Je={}));var li;(function(Re){function Me(ie){const Ae=new S.TypeHierarchyItem(ae.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Ae._sessionId=ie._sessionId,Ae._itemId=ie._itemId,Ae}Re.to=Me;function ye(ie,Ae,qe){if(Ae=Ae??ie._sessionId,qe=qe??ie._itemId,Ae===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:qe,kind:ae.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(se.from)}}Re.from=ye})(li||(e.TypeHierarchyItem=li={}));var hi;(function(Re){function Me(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Re.from=Me})(hi||(e.ViewBadge=hi={}));var fi;(function(Re){function Me(qe,Ze,Ge){const ft=Ze.fileData;return ft?new S.InternalFileDataTransferItem(new S.DataTransferFile(ft.name,m.URI.revive(ft.uri),ft.id,(0,k.createSingleCallFunction)(()=>Ge(ft.id)))):qe===I.Mimes.uriList&&Ze.uriListData?new S.InternalDataTransferItem(Ae(Ze.uriListData)):new S.InternalDataTransferItem(Ze.asString)}Re.to=Me;async function ye(qe,Ze){const Ge=await Ze.asString();if(qe===I.Mimes.uriList)return{asString:Ge,fileData:void 0,uriListData:ie(Ge)};const ft=Ze.asFile();return{asString:Ge,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Re.from=ye;function ie(qe){return P.UriList.split(qe).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return m.URI.parse(Ze)}catch{}return Ze})}function Ae(qe){return P.UriList.create(qe.map(Ze=>typeof Ze=="string"?Ze:m.URI.revive(Ze)))}})(fi||(e.DataTransferItem=fi={}));var St;(function(Re){function Me(ie,Ae){const qe=ie.items.map(([Ze,Ge])=>[Ze,fi.to(Ze,Ge,Ae)]);return new S.DataTransfer(qe)}Re.toDataTransfer=Me;async function ye(ie){const Ae={items:[]},qe=[];for(const[Ze,Ge]of ie)qe.push((async()=>{Ae.items.push([Ze,await fi.from(Ze,Ge)])})());return await Promise.all(qe),Ae}Re.from=ye})(St||(e.DataTransfer=St={}));var xt;(function(Re){function Me(ie,Ae){return{kind:"reply",agentId:ie.participant??Ae?.agentId??"",subCommand:ie.command??Ae?.command,message:ie.prompt,title:ie.label}}Re.from=Me;function ye(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Re.to=ye})(xt||(e.ChatFollowup=xt={}));var Nt;(function(Re){function Me(ie){switch(ie){case w.ChatMessageRole.System:return S.LanguageModelChatMessageRole.System;case w.ChatMessageRole.User:return S.LanguageModelChatMessageRole.User;case w.ChatMessageRole.Assistant:return S.LanguageModelChatMessageRole.Assistant}}Re.to=Me;function ye(ie){switch(ie){case S.LanguageModelChatMessageRole.System:return w.ChatMessageRole.System;case S.LanguageModelChatMessageRole.User:return w.ChatMessageRole.User;case S.LanguageModelChatMessageRole.Assistant:return w.ChatMessageRole.Assistant}return w.ChatMessageRole.User}Re.from=ye})(Nt||(e.LanguageModelChatMessageRole=Nt={}));var qt;(function(Re){function Me(ie){let Ae="",qe;ie.content.type==="text"?Ae=ie.content.value:qe=new S.LanguageModelFunctionResultPart(ie.content.name,ie.content.value,ie.content.isError);const Ze=Nt.to(ie.role),Ge=new S.LanguageModelChatMessage(Ze,Ae,ie.name);return qe!==void 0&&(Ge.content2=qe),Ge}Re.to=Me;function ye(ie){const Ae=Nt.from(ie.role),qe=ie.name;let Ze;return ie.content2 instanceof S.LanguageModelFunctionResultPart?Ze={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:Ze={type:"text",value:ie.content},{role:Ae,name:qe,content:Ze}}Re.from=ye})(qt||(e.LanguageModelChatMessage=qt={}));var ri;(function(Re){function Me(ie){return{kind:"markdownContent",content:le.from(ie.value)}}Re.from=Me;function ye(ie){return new S.ChatResponseMarkdownPart(le.to(ie.content))}Re.to=ye})(ri||(e.ChatResponseMarkdownPart=ri={}));var Gt;(function(Re){function Me(ie){return{kind:"markdownVuln",content:le.from(ie.value),vulnerabilities:ie.vulnerabilities}}Re.from=Me;function ye(ie){return new S.ChatResponseMarkdownWithVulnerabilitiesPart(le.to(ie.content),ie.vulnerabilities)}Re.to=ye})(Gt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Gt={}));var ci;(function(Re){function Me(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Re.from=Me;function ye(ie){return new S.ChatResponseDetectedParticipantPart(ie.agentId,ie.command)}Re.to=ye})(ci||(e.ChatResponseDetectedParticipantPart=ci={}));var $t;(function(Re){function Me(ye){return{kind:"confirmation",title:ye.title,message:ye.message,data:ye.data,buttons:ye.buttons}}Re.from=Me})($t||(e.ChatResponseConfirmationPart=$t={}));var Kt;(function(Re){function Me(ie){const{value:Ae,baseUri:qe}=ie;function Ze(Ge,ft){return Ge.map(kt=>{const Qt=m.URI.joinPath(ft,kt.name);return{label:kt.name,uri:Qt,children:kt.children&&Ze(kt.children,Qt)}})}return{kind:"treeData",treeData:{label:(0,T.basename)(qe),uri:qe,children:Ze(Ae,qe)}}}Re.from=Me;function ye(ie){const Ae=(0,l.revive)(ie.treeData);function qe(ft){return ft.map(kt=>({name:kt.label,children:kt.children&&qe(kt.children)}))}const Ze=Ae.uri,Ge=Ae.children?qe(Ae.children):[];return new S.ChatResponseFileTreePart(Ge,Ze)}Re.to=ye})(Kt||(e.ChatResponseFilesPart=Kt={}));var Xt;(function(Re){function Me(ie){const Ae=qe=>m.URI.isUri(qe);return{kind:"inlineReference",name:ie.title,inlineReference:Ae(ie.value)?ie.value:O.from(ie.value)}}Re.from=Me;function ye(ie){const Ae=(0,l.revive)(ie);return new S.ChatResponseAnchorPart(m.URI.isUri(Ae.inlineReference)?Ae.inlineReference:O.to(Ae.inlineReference),ie.name)}Re.to=ye})(Xt||(e.ChatResponseAnchorPart=Xt={}));var Ft;(function(Re){function Me(ie){return{kind:"progressMessage",content:le.from(ie.value)}}Re.from=Me;function ye(ie){return new S.ChatResponseProgressPart(ie.content.value)}Re.to=ye})(Ft||(e.ChatResponseProgressPart=Ft={}));var bt;(function(Re){function Me(ie){return{kind:"warning",content:le.from(ie.value)}}Re.from=Me;function ye(ie){return new S.ChatResponseWarningPart(ie.content.value)}Re.to=ye})(bt||(e.ChatResponseWarningPart=bt={}));var It;(function(Re){function Me(ye){return{kind:"progressTask",content:le.from(ye.value)}}Re.from=Me})(It||(e.ChatTask=It={}));var jt;(function(Re){function Me(ye){return{kind:"progressTaskResult",content:typeof ye=="string"?le.from(ye):void 0}}Re.from=Me})(jt||(e.ChatTaskResult=jt={}));var Tt;(function(Re){function Me(ie,Ae,qe){return{kind:"command",command:Ae.toInternal(ie.value,qe)??{command:ie.value.command,title:ie.value.title}}}Re.from=Me;function ye(ie,Ae){return new S.ChatResponseCommandButtonPart(Ae.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Re.to=ye})(Tt||(e.ChatResponseCommandButtonPart=Tt={}));var mi;(function(Re){function Me(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Ae=>Se.from(Ae))}}Re.from=Me;function ye(ie){return new S.ChatResponseTextEditPart(m.URI.revive(ie.uri),ie.edits.map(Ae=>Se.to(Ae)))}Re.to=ye})(mi||(e.ChatResponseTextEditPart=mi={}));var Jt;(function(Re){function Me(ie){const Ae=b.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:m.URI.isUri(ie.iconPath)?{light:m.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&m.URI.isUri(ie.iconPath.light)&&m.URI.isUri(ie.iconPath.dark)?{light:m.URI.revive(ie.iconPath.light),dark:m.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:m.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:O.from(ie.value.value)},iconPath:Ae,options:ie.options}:{kind:"reference",reference:m.URI.isUri(ie.value)?ie.value:O.from(ie.value),iconPath:Ae,options:ie.options}}Re.from=Me;function ye(ie){const Ae=(0,l.revive)(ie),qe=Ze=>m.URI.isUri(Ze)?Ze:O.to(Ze);return new S.ChatResponseReferencePart("variableName"in Ae.reference?{variableName:Ae.reference.variableName,value:Ae.reference.value&&qe(Ae.reference.value)}:qe(Ae.reference))}Re.to=ye})(Jt||(e.ChatResponseReferencePart=Jt={}));var Ci;(function(Re){function Me(ye){return{kind:"codeCitation",value:ye.value,license:ye.license,snippet:ye.snippet}}Re.from=Me})(Ci||(e.ChatResponseCodeCitationPart=Ci={}));var Ei;(function(Re){function Me(Ae,qe,Ze){return Ae instanceof S.ChatResponseMarkdownPart?ri.from(Ae):Ae instanceof S.ChatResponseAnchorPart?Xt.from(Ae):Ae instanceof S.ChatResponseReferencePart?Jt.from(Ae):Ae instanceof S.ChatResponseProgressPart?Ft.from(Ae):Ae instanceof S.ChatResponseFileTreePart?Kt.from(Ae):Ae instanceof S.ChatResponseCommandButtonPart?Tt.from(Ae,qe,Ze):Ae instanceof S.ChatResponseTextEditPart?mi.from(Ae):Ae instanceof S.ChatResponseMarkdownWithVulnerabilitiesPart?Gt.from(Ae):Ae instanceof S.ChatResponseDetectedParticipantPart?ci.from(Ae):Ae instanceof S.ChatResponseWarningPart?bt.from(Ae):Ae instanceof S.ChatResponseConfirmationPart?$t.from(Ae):Ae instanceof S.ChatResponseCodeCitationPart?Ci.from(Ae):{kind:"markdownContent",content:le.from("")}}Re.from=Me;function ye(Ae,qe){switch(Ae.kind){case"reference":return Jt.to(Ae);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Ae,qe)}}Re.to=ye;function ie(Ae,qe){switch(Ae.kind){case"markdownContent":return ri.to(Ae);case"inlineReference":return Xt.to(Ae);case"progressMessage":return;case"treeData":return Kt.to(Ae);case"command":return Tt.to(Ae,qe)}}Re.toContent=ie})(Ei||(e.ChatResponsePart=Ei={}));var ki;(function(Re){function Me(ye,ie){const Ae=ye.variables.variables.filter(Ze=>Ze.isTool).map(Ze=>Ze.id),qe=ye.variables.variables.filter(Ze=>!Ze.isTool);return{prompt:ye.message,command:ye.command,attempt:ye.attempt??0,enableCommandDetection:ye.enableCommandDetection??!0,references:qe.map(Oi.to),location:Lt.to(ye.location),acceptedConfirmationData:ye.acceptedConfirmationData,rejectedConfirmationData:ye.rejectedConfirmationData,location2:ie,requestedTools:Ae}}Re.to=Me})(ki||(e.ChatAgentRequest=ki={}));var Lt;(function(Re){function Me(ie){switch(ie){case g.ChatAgentLocation.Notebook:return S.ChatLocation.Notebook;case g.ChatAgentLocation.Terminal:return S.ChatLocation.Terminal;case g.ChatAgentLocation.Panel:return S.ChatLocation.Panel;case g.ChatAgentLocation.Editor:return S.ChatLocation.Editor}}Re.to=Me;function ye(ie){switch(ie){case S.ChatLocation.Notebook:return g.ChatAgentLocation.Notebook;case S.ChatLocation.Terminal:return g.ChatAgentLocation.Terminal;case S.ChatLocation.Panel:return g.ChatAgentLocation.Panel;case S.ChatLocation.Editor:return g.ChatAgentLocation.Editor}}Re.from=ye})(Lt||(e.ChatLocation=Lt={}));var Oi;(function(Re){function Me(ye){const ie=ye.value;if(!ie)throw new Error("Invalid value reference");return{id:ye.id,name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],value:(0,m.isUriComponents)(ie)?m.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,m.isUriComponents)(ie.uri)?O.to((0,l.revive)(ie)):ie,modelDescription:ye.modelDescription}}Re.to=Me})(Oi||(e.ChatAgentValueReference=Oi={}));var ui;(function(Re){function Me(ye,ie,Ae){return{id:ye.id,label:ye.label,fullName:ye.fullName,icon:ye.icon?.id,value:ye.values[0].value,insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation,command:ie.toInternal(ye.command,Ae)}}Re.from=Me})(ui||(e.ChatAgentCompletionItem=ui={}));var At;(function(Re){function Me(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Re.to=Me})(At||(e.ChatAgentResult=At={}));var Ri;(function(Re){function Me(ye,ie,Ae){if(ie.action.kind==="vote")return;const qe=At.to(ye);if(ie.action.kind==="command"){const Ze=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ae.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:qe}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:xt.to(ie.action.followup)},result:qe}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:qe}:{action:ie.action,result:qe}}Re.to=Me})(Ri||(e.ChatAgentUserActionEvent=Ri={}));var Ii;(function(Re){function Me(ye,ie,Ae){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:ie.toInternal(ye,Ae)}Re.from=Me})(Ii||(e.TerminalQuickFix=Ii={}));var yi;(function(Re){function Me(ye){return{kind:Ni.to(ye.kind)}}Re.to=Me})(yi||(e.PartialAcceptInfo=yi={}));var Ni;(function(Re){function Me(ye){switch(ye){case s.PartialAcceptTriggerKind.Word:return S.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return S.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return S.PartialAcceptTriggerKind.Suggest;default:return S.PartialAcceptTriggerKind.Unknown}}Re.to=Me})(Ni||(e.PartialAcceptTriggerKind=Ni={}));var bi;(function(Re){function Me(ye,ie){return{id:ie,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:ye.contextValue}}Re.from=Me})(bi||(e.DebugTreeItem=bi={}));var Ht;(function(Re){function Me(ye){return{name:ye.name,description:ye.description,parametersSchema:ye.parametersSchema}}Re.to=Me})(Ht||(e.LanguageModelToolDescription=Ht={}))}),define(Ce[294],Ie([1,0,6,19,15,53]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(v,l){this._proxy=v.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:I=>l.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,l,I){const y=new k.SerializableObjectWithBuffers(P.WorkspaceEdit.from(v,this._versionInformationProvider));return this._proxy.$tryApplyWorkspaceEdit(y,void 0,I?.isRefactoring??!1)}};e.ExtHostBulkEdits=L,e.ExtHostBulkEdits=L=Xe([He(0,d.IExtHostRpcService)],L)}),define(Ce[295],Ie([1,0,18,7,52,4,39,3,44,42,17,2,23,6,15,9,153,257,25]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0,b=$e(b),a=$e(a);class i{constructor(n,h,c,g,w){this._extension=n,this._request=h,this._proxy=c,this._commandsConverter=g,this._sessionDisposables=w,this._stopWatch=l.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let h=function(g){if(n._isClosed){const w=new Error("Response stream has been closed");throw Error.captureStackTrace(w,g),w}};const n=this;this._stopWatch.reset();const c=(g,w)=>{if(typeof this._firstProgress>"u"&&"content"in g&&(this._firstProgress=this._stopWatch.elapsed()),w){const D=this._proxy.$handleProgressChunk(this._request.requestId,g),_={report:C=>{D?.then(A=>{A&&(a.MarkdownString.isMarkdownString(C.value)?this._proxy.$handleProgressChunk(this._request.requestId,b.ChatResponseWarningPart.from(C),A):this._proxy.$handleProgressChunk(this._request.requestId,b.ChatResponseReferencePart.from(C),A))})}};Promise.all([D,w?.(_)]).then(([C,A])=>{C!==void 0&&A!==void 0&&this._proxy.$handleProgressChunk(this._request.requestId,b.ChatTaskResult.from(A),C)})}else this._proxy.$handleProgressChunk(this._request.requestId,g)};this._apiObject={markdown(g){h(this.markdown);const w=new a.ChatResponseMarkdownPart(g),D=b.ChatResponseMarkdownPart.from(w);return c(D),this},markdownWithVulnerabilities(g,w){h(this.markdown),w&&(0,f.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const D=new a.ChatResponseMarkdownWithVulnerabilitiesPart(g,w),_=b.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return c(_),this},filetree(g,w){h(this.filetree);const D=new a.ChatResponseFileTreePart(g,w),_=b.ChatResponseFilesPart.from(D);return c(_),this},anchor(g,w){h(this.anchor);const D=new a.ChatResponseAnchorPart(g,w),_=b.ChatResponseAnchorPart.from(D);return c(_),this},button(g){h(this.anchor);const w=new a.ChatResponseCommandButtonPart(g),D=b.ChatResponseCommandButtonPart.from(w,n._commandsConverter,n._sessionDisposables);return c(D),this},progress(g,w){h(this.progress);const D=new a.ChatResponseProgressPart2(g,w),_=w?b.ChatTask.from(D):b.ChatResponseProgressPart.from(D);return c(_,w),this},warning(g){h(this.progress),(0,f.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const w=new a.ChatResponseWarningPart(g),D=b.ChatResponseWarningPart.from(w);return c(D),this},reference(g,w){return this.reference2(g,w)},reference2(g,w,D){if(h(this.reference),"variableName"in g&&(0,f.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions"),"variableName"in g&&!g.value){const _=n._request.variables.variables.find(C=>C.name===g.variableName);if(_){let C;if(_.references?.length)C=_.references.map(A=>({kind:"reference",reference:{variableName:g.variableName,value:A.reference}}));else{const A=new a.ChatResponseReferencePart(g,w,D);C=[b.ChatResponseReferencePart.from(A)]}return C.forEach(A=>c(A)),this}}else{const _=new a.ChatResponseReferencePart(g,w,D),C=b.ChatResponseReferencePart.from(_);c(C)}return this},codeCitation(g,w,D){h(this.codeCitation),(0,f.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const _=new a.ChatResponseCodeCitationPart(g,w,D),C=b.ChatResponseCodeCitationPart.from(_);c(C)},textEdit(g,w){h(this.textEdit),(0,f.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const D=new a.ChatResponseTextEditPart(g,w),_=b.ChatResponseTextEditPart.from(D);return c(_),this},detectedParticipant(g,w){h(this.detectedParticipant),(0,f.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const D=new a.ChatResponseDetectedParticipantPart(g,w),_=b.ChatResponseDetectedParticipantPart.from(D);return c(_),this},confirmation(g,w,D,_){h(this.confirmation),(0,f.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions");const C=new a.ChatResponseConfirmationPart(g,w,D,_),A=b.ChatResponseConfirmationPart.from(C);return c(A),this},push(g){if(h(this.push),(g instanceof a.ChatResponseTextEditPart||g instanceof a.ChatResponseMarkdownWithVulnerabilitiesPart||g instanceof a.ChatResponseDetectedParticipantPart||g instanceof a.ChatResponseWarningPart||g instanceof a.ChatResponseConfirmationPart||g instanceof a.ChatResponseCodeCitationPart)&&(0,f.checkProposedApiEnabled)(n._extension,"chatParticipantAdditions"),g instanceof a.ChatResponseReferencePart)this.reference2(g.value,g.iconPath,g.options);else{const w=b.ChatResponsePart.from(g,n._commandsConverter,n._sessionDisposables);c(w)}return this}}}return this._apiObject}}class s extends R.Disposable{static{this._idPool=0}constructor(n,h,c,g){super(),this._logService=h,this._commands=c,this._documents=g,this._agents=new Map,this._sessionDisposables=this._register(new R.DisposableMap),this._completionDisposables=this._register(new R.DisposableMap),this._proxy=n.getProxy(T.MainContext.MainThreadChatAgents2)}transferActiveChat(n){this._proxy.$transferActiveChatSession(n)}createChatAgent(n,h,c){const g=s._idPool++,w=new t(n,h,this._proxy,g,c);return this._agents.set(g,w),this._proxy.$registerAgent(g,n.identifier,h,{},void 0),w.apiAgent}createDynamicChatAgent(n,h,c,g){const w=s._idPool++,D=new t(n,h,this._proxy,w,g);return this._agents.set(w,D),this._proxy.$registerAgent(w,n.identifier,h,{isSticky:!0},c),D.apiAgent}async $invokeAgent(n,h,c,g){const w=this._agents.get(n);if(!w)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);const D=(0,v.revive)(h);let _=this._sessionDisposables.get(D.sessionId);_||(_=new R.DisposableStore,this._sessionDisposables.set(D.sessionId,_));const C=new i(w.extension,D,this._proxy,this._commands.converter,_);try{const A=await this.prepareHistoryTurns(D.agentId,c);let E;if(D.locationData?.type===m.ChatAgentLocation.Editor){const F=this._documents.getDocument(D.locationData.document);E=new a.ChatRequestEditorData(F,b.Selection.to(D.locationData.selection),b.Range.to(D.locationData.wholeRange))}else if(D.locationData?.type===m.ChatAgentLocation.Notebook){const F=this._documents.getDocument(D.locationData.sessionInputUri);E=new a.ChatRequestNotebookData(F)}else D.locationData?.type,m.ChatAgentLocation.Terminal;const S=w.invoke(b.ChatAgentRequest.to(D,E),{history:A},C.apiObject,g);return await(0,d.raceCancellation)(Promise.resolve(S).then(F=>{if(F?.metadata)try{JSON.stringify(F.metadata)}catch(O){const M=`result.metadata MUST be JSON.stringify-able. Got error: ${O.message}`;return this._logService.error(`[${w.extension.identifier.value}] [@${w.id}] ${M}`,w.extension),{errorDetails:{message:M},timings:C.timings}}let N;return F?.errorDetails&&(N={...F.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,f.checkProposedApiEnabled)(w.extension,"chatParticipantPrivate"),{errorDetails:N,timings:C.timings,metadata:F?.metadata}}),g)}catch(A){return this._logService.error(A,w.extension),A instanceof a.LanguageModelError&&A.cause&&(A=A.cause),{errorDetails:{message:(0,P.toErrorMessage)(A),responseIsIncomplete:!0}}}finally{C.close()}}async prepareHistoryTurns(n,h){const c=[];for(const g of h.history){const w=b.ChatAgentResult.to(g.result),D=n===g.request.agentId?w:{...w,metadata:void 0},_=g.request.variables.variables.filter(A=>!A.isTool).map(b.ChatAgentValueReference.to);c.push(new a.ChatRequestTurn(g.request.message,g.request.command,_,g.request.agentId));const C=(0,r.coalesce)(g.response.map(A=>b.ChatResponsePart.toContent(A,this._commands.converter)));c.push(new a.ChatResponseTurn(C,D,g.request.agentId,g.request.command))}return c}$releaseSession(n){this._sessionDisposables.deleteAndDispose(n)}async $provideFollowups(n,h,c,g,w){const D=this._agents.get(h);if(!D)return Promise.resolve([]);const _=(0,v.revive)(n),C=await this.prepareHistoryTurns(D.id,g),A=b.ChatAgentResult.to(c);return(await D.provideFollowups(A,{history:C},w)).filter(E=>{const S=!E.participant||L.Iterable.some(this._agents.values(),F=>F.id===E.participant&&u.ExtensionIdentifier.equals(F.extension.identifier,D.extension.identifier));return S||this._logService.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${E.participant}`),S}).map(E=>b.ChatFollowup.from(E,_))}$acceptFeedback(n,h,c,g){const w=this._agents.get(n);if(!w)return;const D=b.ChatAgentResult.to(h);let _;switch(c){case p.ChatAgentVoteDirection.Down:_=a.ChatResultFeedbackKind.Unhelpful;break;case p.ChatAgentVoteDirection.Up:_=a.ChatResultFeedbackKind.Helpful;break}w.acceptFeedback(Object.freeze(g?{result:D,kind:_,reportIssue:g}:{result:D,kind:_}))}$acceptAction(n,h,c){const g=this._agents.get(n);if(!g||c.action.kind==="vote")return;const w=b.ChatAgentUserActionEvent.to(h,c,this._commands.converter);w&&g.acceptAction(Object.freeze(w))}async $invokeCompletionProvider(n,h,c){const g=this._agents.get(n);if(!g)return[];let w=this._completionDisposables.get(n);return w?w.clear():(w=new R.DisposableStore,this._completionDisposables.set(n,w)),(await g.invokeCompletionProvider(h,c)).map(_=>b.ChatAgentCompletionItem.from(_,this._commands.converter,w))}async $provideWelcomeMessage(n,h,c){const g=this._agents.get(n);if(g)return await g.provideWelcomeMessage(b.ChatLocation.to(h),c)}async $provideSampleQuestions(n,h,c){const g=this._agents.get(n);if(g)return(await g.provideSampleQuestions(b.ChatLocation.to(h),c)).map(w=>b.ChatFollowup.from(w,void 0))}}e.ExtHostChatAgents2=s;class t{constructor(n,h,c,g,w){this.extension=n,this.id=h,this._proxy=c,this._handle=g,this._requestHandler=w,this._onDidReceiveFeedback=new k.Emitter,this._onDidPerformAction=new k.Emitter}acceptFeedback(n){this._onDidReceiveFeedback.fire(n)}acceptAction(n){this._onDidPerformAction.fire(n)}async invokeCompletionProvider(n,h){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(n,h)??[]:[]}async provideFollowups(n,h,c){if(!this._followupProvider)return[];const g=await this._followupProvider.provideFollowups(n,h,c);return g?g.filter(w=>!(w&&"commandId"in w)).filter(w=>!(w&&"message"in w)):[]}async provideWelcomeMessage(n,h){if(!this._welcomeMessageProvider)return[];const c=await this._welcomeMessageProvider.provideWelcomeMessage(n,h);return c?c.map(g=>typeof g=="string"?g:b.MarkdownString.from(g)):[]}async provideSampleQuestions(n,h){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const c=await this._welcomeMessageProvider.provideSampleQuestions(n,h);return c||[]}get apiAgent(){let n=!1,h=!1;const c=()=>{n||h||(h=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{icon:this._iconPath?this._iconPath instanceof y.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof a.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:b.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:b.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:b.MarkdownString.from(this._helpTextPostfix),supportIssueReporting:this._supportIssueReporting,requester:this._requester,supportsSlowVariables:this._supportsSlowReferences}),h=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g._iconPath},set iconPath(w){g._iconPath=w,c()},get requestHandler(){return g._requestHandler},set requestHandler(w){(0,I.assertType)(typeof w=="function","Invalid request handler"),g._requestHandler=w},get followupProvider(){return g._followupProvider},set followupProvider(w){g._followupProvider=w,c()},get isDefault(){return(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._isDefault},set isDefault(w){(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._isDefault=w,c()},get helpTextPrefix(){return(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPrefix},set helpTextPrefix(w){(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPrefix=w,c()},get helpTextVariablesPrefix(){return(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextVariablesPrefix},set helpTextVariablesPrefix(w){(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextVariablesPrefix=w,c()},get helpTextPostfix(){return(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPostfix},set helpTextPostfix(w){(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._helpTextPostfix=w,c()},get isSecondary(){return(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._isSecondary},set isSecondary(w){(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._isSecondary=w,c()},get supportIssueReporting(){return(0,f.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportIssueReporting},set supportIssueReporting(w){(0,f.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportIssueReporting=w,c()},get onDidReceiveFeedback(){return g._onDidReceiveFeedback.event},set participantVariableProvider(w){if((0,f.checkProposedApiEnabled)(g.extension,"chatParticipantAdditions"),g._agentVariableProvider=w,w){if(!w.triggerCharacters.length)throw new Error("triggerCharacters are required");g._proxy.$registerAgentCompletionsProvider(g._handle,g.id,w.triggerCharacters)}else g._proxy.$unregisterAgentCompletionsProvider(g._handle,g.id)},get participantVariableProvider(){return(0,f.checkProposedApiEnabled)(g.extension,"chatParticipantAdditions"),g._agentVariableProvider},set welcomeMessageProvider(w){(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._welcomeMessageProvider=w,c()},get welcomeMessageProvider(){return(0,f.checkProposedApiEnabled)(g.extension,"defaultChatParticipant"),g._welcomeMessageProvider},onDidPerformAction:(0,f.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(w){g._requester=w,c()},get requester(){return g._requester},set supportsSlowReferences(w){(0,f.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportsSlowReferences=w,c()},get supportsSlowReferences(){return(0,f.checkProposedApiEnabled)(g.extension,"chatParticipantPrivate"),g._supportsSlowReferences},dispose(){n=!0,g._followupProvider=void 0,g._onDidReceiveFeedback.dispose(),g._proxy.$unregisterAgent(g._handle)}}}invoke(n,h,c,g){return this._requestHandler(n,h,c,g)}}}),define(Ce[296],Ie([1,0,13,3,51,6,15,9,25]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0,L=$e(L),R=$e(R);class l{static{this._idPool=0}constructor(u){this._resolver=new Map,this._proxy=u.getProxy(k.MainContext.MainThreadChatVariables)}async $resolveVariable(u,T,b,a){const m=this._resolver.get(u);if(m)try{if(m.resolver.resolve2){(0,v.checkProposedApiEnabled)(m.extension,"chatParticipantAdditions");const p=new I(T,this._proxy),f=await m.resolver.resolve2(m.data.name,{prompt:b},p.apiObject,a);if(f&&f[0])return f[0].value}else{const p=await m.resolver.resolve(m.data.name,{prompt:b},a);if(p&&p[0])return p[0].value}}catch(p){(0,r.onUnexpectedExternalError)(p)}}registerVariableResolver(u,T,b,a,m,p,f,i,s){const t=l._idPool++,o=s?P.ThemeIcon.fromId(s):void 0;return this._resolver.set(t,{extension:u,data:{id:T,name:b,description:a,modelDescription:m,icon:o},resolver:f}),this._proxy.$registerVariable(t,{id:T,name:b,description:a,modelDescription:m,isSlow:p,fullName:i,icon:o}),(0,d.toDisposable)(()=>{this._resolver.delete(t),this._proxy.$unregisterVariable(t)})}}e.ExtHostChatVariables=l;class I{constructor(u,T){this._requestId=u,this._proxy=T,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let T=function(a){if(u._isClosed){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,a),m}};const u=this,b=a=>{this._proxy.$handleProgressChunk(this._requestId,a)};this._apiObject={progress(a){T(this.progress);const m=new R.ChatResponseProgressPart(a),p=L.ChatResponseProgressPart.from(m);return b(p),this},reference(a){T(this.reference);const m=new R.ChatResponseReferencePart(a),p=L.ChatResponseReferencePart.from(m);return b(p),this},push(a){return T(this.push),a instanceof R.ChatResponseReferencePart?b(L.ChatResponseReferencePart.from(a)):a instanceof R.ChatResponseProgressPart&&b(L.ChatResponseProgressPart.from(a)),this}}}return this._apiObject}}}),define(Ce[297],Ie([1,0,7,59,4,3,40,2,87,23,15,9,6,25]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=b,v=$e(v),I=$e(I),y=$e(y);function b(a,m,p){const f=a.getProxy(u.MainContext.MainThreadComments);class i{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new l.ExtensionIdentifierMap,m.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===L.MarshalledId.CommentController){const C=this._commentControllers.get(_.handle);return C?C.value:_}else if(_&&_.$mid===L.MarshalledId.CommentThread){const C=_,A=this._commentControllers.get(C.commentControlHandle);if(!A)return C;const E=A.getCommentThread(C.commentThreadHandle);return E?E.value:C}else if(_&&(_.$mid===L.MarshalledId.CommentThreadReply||_.$mid===L.MarshalledId.CommentThreadInstance)){const C=this._commentControllers.get(_.thread.commentControlHandle);if(!C)return _;const A=C.getCommentThread(_.thread.commentThreadHandle);return A?_.$mid===L.MarshalledId.CommentThreadInstance?A.value:{thread:A.value,text:_.text}:_}else if(_&&_.$mid===L.MarshalledId.CommentNode){const C=this._commentControllers.get(_.thread.commentControlHandle);if(!C)return _;const A=C.getCommentThread(_.thread.commentThreadHandle);if(!A)return _;const E=_.commentUniqueId,S=A.getCommentByUniqueId(E);return S||_}else if(_&&_.$mid===L.MarshalledId.CommentThreadNode){const C=this._commentControllers.get(_.thread.commentControlHandle);if(!C)return _;const A=C.getCommentThread(_.thread.commentThreadHandle);if(!A)return _;const E=_.text,S=_.commentUniqueId,F=A.getCommentByUniqueId(S);return F?(typeof F.body=="string"?F.body=E:F.body=new y.MarkdownString(E),F):_}return _}})}createCommentController(_,C,A){const E=i.handlePool++,S=new t(_,E,C,A);this._commentControllers.set(S.handle,S);const F=this._commentControllersByExtension.get(_.identifier)||[];return F.push(S),this._commentControllersByExtension.set(_.identifier,F),S.value}async $createCommentThreadTemplate(_,C,A,E){const S=this._commentControllers.get(_);S&&S.$createCommentThreadTemplate(C,A,E)}async $setActiveComment(_,C){const A=this._commentControllers.get(_);A&&A.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(_,C,A){const E=this._commentControllers.get(_);E&&E.$updateCommentThreadTemplate(C,A)}$deleteCommentThread(_,C){this._commentControllers.get(_)?.$deleteCommentThread(C)}async $provideCommentingRanges(_,C,A){const E=this._commentControllers.get(_);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const S=await p.ensureDocumentData(R.URI.revive(C));return(0,r.asPromise)(async()=>{const F=await E.commentingRangeProvider.provideCommentingRanges(S.document,A);let N;return Array.isArray(F)?N={ranges:F,fileComments:!1}:F?N={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:N=F??void 0,N}).then(F=>{let N;return F&&(N={ranges:F.ranges.map(O=>I.Range.from(O)),fileComments:F.fileComments}),N})}$toggleReaction(_,C,A,E,S){const F=this._commentControllers.get(_);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const N=F.getCommentThread(C);if(N){const O=N.getCommentByUniqueId(E.uniqueIdInThread);if(F!==void 0&&O&&F.reactionHandler)return F.reactionHandler(O,h(S))}return Promise.resolve(void 0)})}}class s{static{this._handlePool=0}set threadId(_){this._id=_}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(_){(_===void 0!=(this._range===void 0)||!_||!this._range||!_.isEqual(this._range))&&(this._range=_,this.modifications.range=_,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(_){this._canReply!==_&&(this._canReply=_,this.modifications.canReply=_,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(_){this._label=_,this.modifications.label=_,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(_){this._contextValue=_,this.modifications.contextValue=_,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(_){this._comments=_,this.modifications.comments=_,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(_){this._collapseState=_,this.modifications.collapsibleState=_,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(_){this._state=_,typeof _=="object"?((0,T.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=_.resolved,this.modifications.applicability=_.applicability):this.modifications.state=_,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(_,C,A,E,S,F,N,O,M){this._commentControllerHandle=C,this._id=A,this._uri=E,this._range=S,this._comments=F,this.extensionDescription=N,this._isTemplate=O,this.handle=s._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new P.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputDisposables.value=new k.DisposableStore,this._id===void 0&&(this._id=`${_}.${this.handle}`),f.$createCommentThread(C,this.handle,this._id,this._uri,I.Range.from(this._range),this._comments.map(x=>o(this,x,this._commentsMap,this.extensionDescription)),N.identifier,this._isTemplate,M),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(C,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(x){U.range=x},get comments(){return U.comments},set comments(x){U.comments=x},get collapsibleState(){return U.collapsibleState},set collapsibleState(x){U.collapsibleState=x},get canReply(){return U.canReply},set canReply(x){U.canReply=x},get contextValue(){return U.contextValue},set contextValue(x){U.contextValue=x},get label(){return U.label},set label(x){U.label=x},get state(){return U.state},set state(x){U.state=x},reveal:(x,z)=>U.reveal(x,z),hide:()=>U.hide(),dispose:()=>{U.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new k.DisposableStore);const _=A=>Object.prototype.hasOwnProperty.call(this.modifications,A),C={};_("range")&&(C.range=I.Range.from(this._range)),_("label")&&(C.label=this.label),_("contextValue")&&(C.contextValue=this.contextValue??null),_("comments")&&(C.comments=this._comments.map(A=>o(this,A,this._commentsMap,this.extensionDescription))),_("collapsibleState")&&(C.collapseState=c(this._collapseState)),_("canReply")&&(C.canReply=this.canReply),_("state")&&(C.state=g(this._state)),_("applicability")&&(C.applicability=w(this._state)),_("isTemplate")&&(C.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,C)}getCommentByUniqueId(_){for(const C of this._commentsMap){const A=C[0],E=C[1];if(_===E)return A}}async reveal(_,C){(0,T.checkProposedApiEnabled)(this.extensionDescription,"commentReveal");let A;_&&_.body!==void 0?A=_:C=C??_;let E=A?this._commentsMap.get(A):void 0;E??=this._commentsMap.get(this._comments[0]);let S=!0,F=!1;return C?.focus===y.CommentThreadFocus.Reply?(F=!0,S=!1):C?.focus===y.CommentThreadFocus.Comment&&(S=!1),f.$revealCommentThread(this._commentControllerHandle,this.handle,E,{preserveFocus:S,focusReply:F})}async hide(){return f.$hideCommentThread(this._commentControllerHandle,this.handle)}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(_=>_.dispose())}}Xe([(0,d.debounce)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(_){this._commentingRangeProvider=_,_?.resourceHints&&(0,T.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),f.$updateCommentingRanges(this.handle,_?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(_){this._reactionHandler=_,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!_})}get options(){return this._options}set options(_){this._options=_,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,T.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,T.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(_,C,A,E){this._extension=_,this._handle=C,this._id=A,this._label=E,this._threads=new Map,f.$registerCommentController(this.handle,A,E,this._extension.identifier.value);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(F){S.options=F},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(F){S.commentingRangeProvider=F},get reactionHandler(){return S.reactionHandler},set reactionHandler(F){S.reactionHandler=F},get activeCommentThread(){return S.activeCommentThread},createCommentThread(F,N,O){return S.createCommentThread(F,N,O).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(_,C,A){C===void 0&&(0,T.checkProposedApiEnabled)(this._extension,"fileComments");const E=new s(this.id,this.handle,void 0,_,C,A,this._extension,!1);return this._threads.set(E.handle,E),E}$setActiveComment(_){if(!_){this._activeComment=void 0,this._activeThread=void 0;return}const C=this._threads.get(_.commentThreadHandle);C&&(this._activeComment=_.uniqueIdInThread?C.getCommentByUniqueId(_.uniqueIdInThread):void 0,this._activeThread=C)}$createCommentThreadTemplate(_,C,A){const E=new s(this.id,this.handle,void 0,R.URI.revive(_),I.Range.to(C),[],this._extension,!0,A);return E.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this._threads.set(E.handle,E),E}$updateCommentThreadTemplate(_,C){const A=this._threads.get(_);A&&(A.range=I.Range.to(C))}$deleteCommentThread(_){this._threads.get(_)?.dispose(),this._threads.delete(_)}getCommentThread(_){return this._threads.get(_)}dispose(){this._threads.forEach(_=>{_.dispose()}),this._localDisposables.forEach(_=>_.dispose())}}function o(D,_,C,A){let E=C.get(_);return E||(E=++D.commentHandle,C.set(_,E)),_.state!==void 0&&(0,T.checkProposedApiEnabled)(A,"commentsDraftState"),_.reactions?.some(S=>S.reactors!==void 0)&&(0,T.checkProposedApiEnabled)(A,"commentReactor"),{mode:_.mode,contextValue:_.contextValue,uniqueIdInThread:E,body:typeof _.body=="string"?_.body:I.MarkdownString.from(_.body),userName:_.author.name,userIconPath:_.author.iconPath,label:_.label,commentReactions:_.reactions?_.reactions.map(S=>n(S)):void 0,state:_.state,timestamp:_.timestamp?.toJSON()}}function n(D){return{label:D.label,iconPath:D.iconPath?I.pathOrURIToURI(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(_=>_.name):D.reactors}}function h(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?R.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(_=>({name:_}))}}function c(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function g(D){let _;if(typeof D=="object"?_=D.resolved:_=D,_!==void 0)switch(_){case y.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}function w(D){let _;if(typeof D=="object"&&(_=D.applicability),_!==void 0)switch(_){case y.CommentThreadApplicability.Current:return v.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return v.CommentThreadApplicability.Outdated}return v.CommentThreadApplicability.Current}return new i}}),define(Ce[298],Ie([1,0,20,60,3,14,22,2,15,96,118,6,9]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0,v=$e(v),y=$e(y),u=$e(u);class T{constructor(n,h){this.document=n,this._storagePath=h,this._backupCounter=1,this._edits=new I.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,h){await this.getEdit(n).undo(),h||this.disposeBackup()}async redo(n,h){await this.getEdit(n).redo(),h||this.disposeBackup()}disposeEdits(n){for(const h of n)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=t(this.document.uri)+this._backupCounter++;return(0,L.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const h=this._edits.get(n,0);if(!h)throw new Error("No edit found");return h}}class b{constructor(){this._documents=new Map}get(n,h){return this._documents.get(this.key(n,h))}add(n,h,c){const g=this.key(n,h.uri);if(this._documents.has(g))throw new Error(`Document already exists for viewType:${n} resource:${h.uri}`);const w=new T(h,c);return this._documents.set(g,w),w}delete(n,h){const c=this.key(n,h.uri);this._documents.delete(c)}key(n,h){return`${n}@@@${h}`}}var a;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this._providers=new Map}addTextProvider(n,h,c){return this.add(n,{type:a.Text,extension:h,provider:c})}addCustomProvider(n,h,c){return this.add(n,{type:a.Custom,extension:h,provider:c})}get(n){return this._providers.get(n)}add(n,h){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,h),new u.Disposable(()=>this._providers.delete(n))}}class p{constructor(n,h,c,g,w){this._extHostDocuments=h,this._extensionStoragePaths=c,this._extHostWebview=g,this._extHostWebviewPanels=w,this._editorProviders=new m,this._documents=new b,this._proxy=n.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,h,c,g){const w=new P.DisposableStore;return i(c)?(w.add(this._editorProviders.addTextProvider(h,n,c)),this._proxy.$registerTextEditorProvider((0,l.toExtensionData)(n),h,g.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,l.shouldSerializeBuffersForPostMessage)(n))):(w.add(this._editorProviders.addCustomProvider(h,n,c)),f(c)&&w.add(c.onDidChangeCustomDocument(D=>{const _=this.getCustomDocumentEntry(h,D.document.uri);if(s(D)){const C=_.addEdit(D);this._proxy.$onDidEdit(D.document.uri,h,C,D.label)}else this._proxy.$onContentChange(D.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,l.toExtensionData)(n),h,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,l.shouldSerializeBuffersForPostMessage)(n))),u.Disposable.from(w,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(n,h,c,g,w){const D=this._editorProviders.get(h);if(!D)throw new Error(`No provider found for '${h}'`);if(D.type!==a.Custom)throw new Error(`Invalid provide type for '${h}'`);const _=R.URI.revive(n),C=await D.provider.openCustomDocument(_,{backupId:c,untitledDocumentData:g?.buffer},w);let A;return f(D.provider)&&this._extensionStoragePaths&&(A=this._extensionStoragePaths.workspaceValue(D.extension)??this._extensionStoragePaths.globalValue(D.extension)),this._documents.add(h,C,A),{editable:f(D.provider)}}async $disposeCustomDocument(n,h){const c=this._editorProviders.get(h);if(!c)throw new Error(`No provider found for '${h}'`);if(c.type!==a.Custom)throw new Error(`Invalid provider type for '${h}'`);const g=R.URI.revive(n),{document:w}=this.getCustomDocumentEntry(h,g);this._documents.delete(h,w),w.dispose()}async $resolveCustomEditor(n,h,c,g,w,D){const _=this._editorProviders.get(c);if(!_)throw new Error(`No provider found for '${c}'`);const C=v.ViewColumn.to(w),A=this._extHostWebview.createNewWebview(h,g.contentOptions,_.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(h,c,g.title,C,g.options,A,g.active),S=R.URI.revive(n);switch(_.type){case a.Custom:{const{document:F}=this.getCustomDocumentEntry(c,S);return _.provider.resolveCustomEditor(F,E,D)}case a.Text:{const F=this._extHostDocuments.getDocument(S);return _.provider.resolveCustomTextEditor(F,E,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,h,c){this.getCustomDocumentEntry(h,n).disposeEdits(c)}async $onMoveCustomEditor(n,h,c){const g=this._editorProviders.get(c);if(!g)throw new Error(`No provider found for '${c}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const w=this._extHostWebviewPanels.getWebviewPanel(n);if(!w)throw new Error("No webview found");const D=R.URI.revive(h),_=this._extHostDocuments.getDocument(D);await g.provider.moveCustomTextEditor(_,w,r.CancellationToken.None)}async $undo(n,h,c,g){return this.getCustomDocumentEntry(h,n).undo(c,g)}async $redo(n,h,c,g){return this.getCustomDocumentEntry(h,n).redo(c,g)}async $revert(n,h,c){const g=this.getCustomDocumentEntry(h,n);await this.getCustomEditorProvider(h).revertCustomDocument(g.document,c),g.disposeBackup()}async $onSave(n,h,c){const g=this.getCustomDocumentEntry(h,n);await this.getCustomEditorProvider(h).saveCustomDocument(g.document,c),g.disposeBackup()}async $onSaveAs(n,h,c,g){const w=this.getCustomDocumentEntry(h,n);return this.getCustomEditorProvider(h).saveCustomDocumentAs(w.document,R.URI.revive(c),g)}async $backup(n,h,c){const g=this.getCustomDocumentEntry(h,n),D=await this.getCustomEditorProvider(h).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},c);return g.updateBackup(D),D.id}getCustomDocumentEntry(n,h){const c=this._documents.get(n,R.URI.revive(h));if(!c)throw new Error("No custom document found");return c}getCustomEditorProvider(n){const c=this._editorProviders.get(n)?.provider;if(!c||!f(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=p;function f(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function s(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const n=o.scheme===k.Schemas.file||o.scheme===k.Schemas.untitled?o.fsPath:o.toString();return(0,d.hash)(n)+""}}),define(Ce[299],Ie([1,0,8,145,2,6,9,15,4,11,28,62]),function(pe,e,r,d,P,k,L,R,v,l,I,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0,R=$e(R);class T{#e;#t;#i;constructor(m,p,f,i,s,t,o,n){this._name=m,this._owner=p,this._maxDiagnosticsTotal=f,this._maxDiagnosticsPerFile=i,this._modelVersionIdProvider=s,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(i,f),this.#i=new I.ResourceMap(h=>t.getComparisonKey(h)),this.#e=o,this.#t=n}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(m,p){if(!m){this.clear();return}this._checkDisposed();let f=[];if(P.URI.isUri(m)){if(!p){this.delete(m);return}this.#i.set(m,p.slice()),f=[m]}else if(Array.isArray(m)){f=[];let t;m=[...m].sort(T._compareIndexedTuplesByUri);for(const o of m){const[n,h]=o;if((!t||n.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=n,f.push(n),this.#i.set(n,[])),h)this.#i.get(n)?.push(...h);else{const c=this.#i.get(n);c&&(c.length=0)}}}if(this.#t.fire(f),!this.#e)return;const i=[];let s=0;for(const t of f){let o=[];const n=this.#i.get(t);if(n)if(n.length>this._maxDiagnosticsPerFile){o=[];const h=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const g of n)if(g.severity===h[c]&&o.push({...R.Diagnostic.from(g),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;o.push({severity:d.MarkerSeverity.Info,message:(0,r.localize)(10838,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=n.map(h=>({...R.Diagnostic.from(h),modelVersionId:this._modelVersionIdProvider(t)}));if(i.push([t,o]),s+=o.length,s>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,i)}delete(m){this._checkDisposed(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this._owner,[[m,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(m,p){this._checkDisposed();for(const[f,i]of this)m.call(p,f,i,this)}*[Symbol.iterator](){this._checkDisposed();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this._checkDisposed();const p=this.#i.get(m);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(m){return this._checkDisposed(),Array.isArray(this.#i.get(m))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(m,p){return m[0].toString()<p[0].toString()?-1:m[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=T;let b=class{static{u=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*this._maxDiagnosticsPerFile}static _mapper(m){const p=new I.ResourceMap;for(const f of m)p.set(f,f);return{uris:Object.freeze(Array.from(p.values()))}}constructor(m,p,f,i){this._logService=p,this._fileSystemInfoService=f,this._extHostDocumentsAndEditors=i,this._collections=new Map,this._onDidChangeDiagnostics=new v.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=v.Event.map(this._onDidChangeDiagnostics.event,u._mapper),this._proxy=m.getProxy(k.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,p){const{_collections:f,_proxy:i,_onDidChangeDiagnostics:s,_logService:t,_fileSystemInfoService:o,_extHostDocumentsAndEditors:n}=this,h=new class{$changeMany(w,D){i.$changeMany(w,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,w,D.length===0?"CLEARING":D)}$clear(w){i.$clear(w),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,w)}dispose(){i.dispose()}};let c;if(!p)p="_generated_diagnostic_collection_name_#"+u._idPool++,c=p;else if(!f.has(p))c=p;else{this._logService.warn(`DiagnosticCollection with name '${p}' does already exist.`);do c=p+u._idPool++;while(f.has(c))}return new class extends T{constructor(){super(p,c,u._maxDiagnosticsTotal,u._maxDiagnosticsPerFile,w=>n.getDocument(w)?.version,o.extUri,h,s),f.set(c,this)}dispose(){super.dispose(),f.delete(c)}}}getDiagnostics(m){if(m)return this._getDiagnostics(m);{const p=new Map,f=[];for(const i of this._collections.values())i.forEach((s,t)=>{let o=p.get(s.toString());typeof o>"u"&&(o=f.length,p.set(s.toString(),o),f.push([s,[]])),f[o][1]=f[o][1].concat(...t)});return f}}_getDiagnostics(m){let p=[];for(const f of this._collections.values())f.has(m)&&(p=p.concat(f.get(m)));return p}$acceptMarkersChange(m){if(!this._mirrorCollection){const p="_generated_mirror",f=new T(p,p,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(p,f),this._mirrorCollection=f}for(const[p,f]of m)this._mirrorCollection.set(P.URI.revive(p),f.map(R.Diagnostic.to))}};e.ExtHostDiagnostics=b,e.ExtHostDiagnostics=b=u=Xe([He(1,l.ILogService),He(2,y.IExtHostFileSystemInfo)],b)}),define(Ce[300],Ie([1,0,2,13,9,15,80,53]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class v{constructor(I,y,u,T={timeout:1500,errors:3}){this._logService=I,this._documents=y,this._mainThreadBulkEdits=u,this._thresholds=T,this._callbacks=new L.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(y,u,T)=>{const a={dispose:this._callbacks.push([y,u,I])};return Array.isArray(T)&&T.push(a),a}}async $participateInSave(I,y){const u=r.URI.revive(I);let T=!1;const b=setTimeout(()=>T=!0,this._thresholds.timeout),a=[];try{for(const m of[...this._callbacks]){if(T)break;const p=this._documents.getDocument(u),f=await this._deliverEventAsyncAndBlameBadListeners(m,{document:p,reason:k.TextDocumentSaveReason.to(y)});a.push(f)}}finally{clearTimeout(b)}return a}_deliverEventAsyncAndBlameBadListeners([I,y,u],T){const b=this._badListeners.get(I);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(u,I,y,T).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const m=this._badListeners.get(I);this._badListeners.set(I,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,y,u,T){const b=[],a=Date.now(),{document:m,reason:p}=T,{version:f}=m,i=Object.freeze({document:m,reason:p,waitUntil(s){if(Object.isFrozen(b))throw(0,d.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(s))}});try{y.apply(u,[i])}catch(s){return Promise.reject(s)}return Object.freeze(b),new Promise((s,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(o),s(n)}).catch(n=>{clearTimeout(o),t(n)})}).then(s=>{const t={edits:[]};for(const o of s)if(Array.isArray(o)&&o.every(n=>n instanceof P.TextEdit))for(const{newText:n,newEol:h,range:c}of o)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:c&&k.Range.from(c),text:n,eol:h&&k.EndOfLine.from(h)}});if(t.edits.length!==0)return f===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new R.SerializableObjectWithBuffers(t)):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=v}),define(Ce[301],Ie([1,0,4,3,2,6,164,15,17,24,9]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0,R=$e(R);class y{constructor(T,b){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new d.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(k.MainContext.MainThreadDocuments),this._documentsAndEditors=b,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const m of a)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const m of a)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const b=this._documentsAndEditors.getDocument(T);if(b)return b}getDocument(T){const b=this.getDocumentData(T);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return b.document}ensureDocumentData(T){const b=this._documentsAndEditors.getDocument(T);if(b)return Promise.resolve(b);let a=this._documentLoader.get(T.toString());return a||(a=this._proxy.$tryOpenDocument(T).then(m=>{this._documentLoader.delete(T.toString());const p=P.URI.revive(m);return(0,v.assertIsDefined)(this._documentsAndEditors.getDocument(p))},m=>(this._documentLoader.delete(T.toString()),Promise.reject(m))),this._documentLoader.set(T.toString(),a)),a}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(b=>P.URI.revive(b))}$acceptModelLanguageChanged(T,b){const a=P.URI.revive(T),m=this._documentsAndEditors.getDocument(a);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(b),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(T){const b=P.URI.revive(T),a=this._documentsAndEditors.getDocument(b);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(T,b){const a=P.URI.revive(T),m=this._documentsAndEditors.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(b),this._onDidChangeDocument.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,b,a){const m=P.URI.revive(T),p=this._documentsAndEditors.getDocument(m);if(!p)throw new Error("unknown document");p._acceptIsDirty(a),p.onEvents(b);let f;b.isUndoing?f=I.TextDocumentChangeReason.Undo:b.isRedoing&&(f=I.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,l.deepFreeze)({document:p.document,contentChanges:b.changes.map(i=>({range:R.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:f}))}setWordDefinitionFor(T,b){(0,L.setWordDefinitionFor)(T,b)}}e.ExtHostDocuments=y}),define(Ce[77],Ie([1,0,78,4,17,2,5,6,19,15,9]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,l=$e(l),e.IExtHostEditorTabs=(0,L.createDecorator)("IExtHostEditorTabs");class y{constructor(m,p,f){this._activeTabIdGetter=f,this._parentGroup=p,this.acceptDtoUpdate(m)}get apiObject(){if(!this._apiObject){const m=this,p={get isActive(){return m._dto.id===m._activeTabIdGetter()},get label(){return m._dto.label},get input(){return m._input},get isDirty(){return m._dto.isDirty},get isPinned(){return m._dto.isPinned},get isPreview(){return m._dto.isPreview},get group(){return m._parentGroup.apiObject}};this._apiObject=Object.freeze(p)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(m){this._dto=m,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case R.TabInputKind.TextInput:return new I.TextTabInput(k.URI.revive(this._dto.input.uri));case R.TabInputKind.TextDiffInput:return new I.TextDiffTabInput(k.URI.revive(this._dto.input.original),k.URI.revive(this._dto.input.modified));case R.TabInputKind.TextMergeInput:return new I.TextMergeTabInput(k.URI.revive(this._dto.input.base),k.URI.revive(this._dto.input.input1),k.URI.revive(this._dto.input.input2),k.URI.revive(this._dto.input.result));case R.TabInputKind.CustomEditorInput:return new I.CustomEditorTabInput(k.URI.revive(this._dto.input.uri),this._dto.input.viewType);case R.TabInputKind.WebviewEditorInput:return new I.WebviewEditorTabInput(this._dto.input.viewType);case R.TabInputKind.NotebookInput:return new I.NotebookEditorTabInput(k.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new I.NotebookDiffEditorTabInput(k.URI.revive(this._dto.input.original),k.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new I.TerminalEditorTabInput;case R.TabInputKind.InteractiveEditorInput:return new I.InteractiveWindowInput(k.URI.revive(this._dto.input.uri),k.URI.revive(this._dto.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new I.ChatEditorTabInput;case R.TabInputKind.MultiDiffEditorInput:return new I.TextMultiDiffTabInput(this._dto.input.diffEditors.map(m=>new I.TextDiffTabInput(k.URI.revive(m.original),k.URI.revive(m.modified))));default:return}}}class u{constructor(m,p){this._tabs=[],this._activeTabId="",this._dto=m,this._activeGroupIdGetter=p;for(const f of m.tabs)f.isActive&&(this._activeTabId=f.id),this._tabs.push(new y(f,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const m=this,p={get isActive(){return m._dto.groupId===m._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(m._dto.viewColumn)},get activeTab(){return m._tabs.find(f=>f.tabId===m._activeTabId)?.apiObject},get tabs(){return Object.freeze(m._tabs.map(f=>f.apiObject))}};this._apiObject=Object.freeze(p)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(m){this._dto=m}acceptTabOperation(m){if(m.kind===R.TabModelOperationKind.TAB_OPEN){const f=new y(m.tabDto,this,()=>this.activeTabId());return this._tabs.splice(m.index,0,f),m.tabDto.isActive&&(this._activeTabId=f.tabId),f}else if(m.kind===R.TabModelOperationKind.TAB_CLOSE){const f=this._tabs.splice(m.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return f.tabId===this._activeTabId&&(this._activeTabId=""),f}else if(m.kind===R.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this._tabs.splice(m.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this._tabs.splice(m.index,0,f),f}const p=this._tabs.find(f=>f.tabId===m.tabDto.id);if(!p)throw new Error("INVALID tab");return m.tabDto.isActive?this._activeTabId=m.tabDto.id:this._activeTabId===m.tabDto.id&&!m.tabDto.isActive&&(this._activeTabId=""),p.acceptDtoUpdate(m.tabDto),p}activeTabId(){return this._activeTabId}}let T=class{constructor(m){this._onDidChangeTabs=new d.Emitter,this._onDidChangeTabGroups=new d.Emitter,this._extHostTabGroups=[],this._proxy=m.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const m=this,p={onDidChangeTabGroups:m._onDidChangeTabGroups.event,onDidChangeTabs:m._onDidChangeTabs.event,get all(){return Object.freeze(m._extHostTabGroups.map(f=>f.apiObject))},get activeTabGroup(){const f=m._activeGroupId;return(0,P.assertIsDefined)(m._extHostTabGroups.find(s=>s.groupId===f)?.apiObject)},close:async(f,i)=>{const s=Array.isArray(f)?f:[f];return s.length?b(s[0])?this._closeGroups(s,i):this._closeTabs(s,i):!0}};this._apiObject=Object.freeze(p)}return this._apiObject}$acceptEditorTabModel(m){const p=new Set(this._extHostTabGroups.map(h=>h.groupId)),f=new Set(m.map(h=>h.groupId)),i=(0,r.diffSets)(p,f),s=this._extHostTabGroups.filter(h=>i.removed.includes(h.groupId)).map(h=>h.apiObject),t=[],o=[];this._extHostTabGroups=m.map(h=>{const c=new u(h,()=>this._activeGroupId);return i.added.includes(c.groupId)?t.push(c.apiObject):o.push(c.apiObject),c});const n=(0,P.assertIsDefined)(m.find(h=>h.isActive===!0)?.groupId);n!==void 0&&this._activeGroupId!==n&&(this._activeGroupId=n),this._onDidChangeTabGroups.fire(Object.freeze({opened:t,closed:s,changed:o}))}$acceptTabGroupUpdate(m){const p=this._extHostTabGroups.find(f=>f.groupId===m.groupId);if(!p)throw new Error("Update Group IPC call received before group creation.");p.acceptGroupDtoUpdate(m),m.isActive&&(this._activeGroupId=m.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[p.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const p=this._extHostTabGroups.find(i=>i.groupId===m.groupId);if(!p)throw new Error("Update Tabs IPC call received before group creation.");const f=p.acceptTabOperation(m);switch(m.kind){case R.TabModelOperationKind.TAB_OPEN:this._onDidChangeTabs.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}_findExtHostTabFromApi(m){for(const p of this._extHostTabGroups)for(const f of p.tabs)if(f.apiObject===m)return f}_findExtHostTabGroupFromApi(m){return this._extHostTabGroups.find(p=>p.apiObject===m)}async _closeTabs(m,p){const f=[];for(const i of m){const s=this._findExtHostTabFromApi(i);if(!s)throw new Error("Tab close: Invalid tab not found!");f.push(s.tabId)}return this._proxy.$closeTab(f,p)}async _closeGroups(m,p){const f=[];for(const i of m){const s=this._findExtHostTabGroupFromApi(i);if(!s)throw new Error("Group close: Invalid group not found!");f.push(s.groupId)}return this._proxy.$closeGroup(f,p)}};e.ExtHostEditorTabs=T,e.ExtHostEditorTabs=T=Xe([He(0,v.IExtHostRpcService)],T);function b(a){return a.tabs!==void 0}}),define(Ce[302],Ie([1,0,2,6,27,3,9,15,203,12,26,21,25,85]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0,P=$e(P),R=$e(R);class b{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const f=this._schemes.indexOf(p);f>=0&&(this._schemes.splice(f,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),f=[];let i,s,t=v.State.LastKnownState,o=v.State.LastKnownState;for(const n of p){let h=i?(0,l.commonPrefixLength)(i,n):0;for(h===0?s=v.State.Start:s=o;h<n.length;h++)h+1===n.length?(t=o,o=v.State.BeforeColon):o+=1,f.push([s,n.toUpperCase().charCodeAt(h),o]),f.push([s,n.toLowerCase().charCodeAt(h),o]),s=o;i=n,o=t}f.push([v.State.BeforeColon,I.CharCode.Colon,v.State.AfterColon]),f.push([v.State.AfterColon,I.CharCode.Slash,v.State.End]),this._stateMachine=new v.StateMachine(f)}}provideDocumentLinks(p){this._initStateMachine();const f=[],i=v.LinkComputer.computeLinks({getLineContent(s){return p.lineAt(s-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const s of i){const t=R.DocumentLink.to(s);t.target&&f.push(t)}return f}}class a{constructor(p,f){this._extHostLanguageFeatures=f,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(d.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,f,i,s={}){if(a._validateFileSystemProvider(i),this._registeredSchemes.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const t=this._handlePool++;this._linkProvider.add(f),this._registeredSchemes.add(f),this._fsProvider.set(t,i);let o=P.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(o+=P.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(o+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.checkProposedApiEnabled)(p,"fsChunks"),o+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let n;s.isReadonly&&(0,T.isMarkdownString)(s.isReadonly)&&s.isReadonly.value!==""&&(n={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this._proxy.$registerFileSystemProvider(t,f,o,n).catch(c=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${f}`),console.error(c)});const h=i.onDidChangeFile(c=>{const g=[];for(const w of c){const{uri:D,type:_}=w;if(D.scheme!==f)continue;let C;switch(_){case L.FileChangeType.Changed:C=P.FileChangeType.UPDATED;break;case L.FileChangeType.Created:C=P.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:C=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:D,type:C})}this._proxy.$onFileSystemChange(t,g)});return(0,k.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(f),this._registeredSchemes.delete(f),this._fsProvider.delete(t),this._proxy.$unregisterProvider(t)})}static _validateFileSystemProvider(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(p){const{type:f,ctime:i,mtime:s,size:t,permissions:o}=p;return{type:f,ctime:i,mtime:s,size:t,permissions:o}}$stat(p,f){return Promise.resolve(this._getFsProvider(p).stat(r.URI.revive(f))).then(i=>a._asIStat(i))}$readdir(p,f){return Promise.resolve(this._getFsProvider(p).readDirectory(r.URI.revive(f)))}$readFile(p,f){return Promise.resolve(this._getFsProvider(p).readFile(r.URI.revive(f))).then(i=>y.VSBuffer.wrap(i))}$writeFile(p,f,i,s){return Promise.resolve(this._getFsProvider(p).writeFile(r.URI.revive(f),i.buffer,s))}$delete(p,f,i){return Promise.resolve(this._getFsProvider(p).delete(r.URI.revive(f),i))}$rename(p,f,i,s){return Promise.resolve(this._getFsProvider(p).rename(r.URI.revive(f),r.URI.revive(i),s))}$copy(p,f,i,s){const t=this._getFsProvider(p);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(r.URI.revive(f),r.URI.revive(i),s))}$mkdir(p,f){return Promise.resolve(this._getFsProvider(p).createDirectory(r.URI.revive(f)))}$watch(p,f,i,s){const t=this._getFsProvider(p).watch(r.URI.revive(i),s);this._watches.set(f,t)}$unwatch(p,f){const i=this._watches.get(f);i&&(i.dispose(),this._watches.delete(f))}$open(p,f,i){const s=this._getFsProvider(p);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(r.URI.revive(f),i))}$close(p,f){const i=this._getFsProvider(p);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(f))}$read(p,f,i,s){const t=this._getFsProvider(p);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.VSBuffer.alloc(s);return Promise.resolve(t.read(f,i,o.buffer,0,s)).then(n=>o.slice(0,n))}$write(p,f,i,s){const t=this._getFsProvider(p);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(f,i,s.buffer,0,s.byteLength))}_getFsProvider(p){const f=this._fsProvider.get(p);if(!f){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return f}}e.ExtHostFileSystem=a}),define(Ce[303],Ie([1,0,4,38,2,6,15,9,27,50]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0,L=$e(L);class I{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(b,a,m,p,f,i){this.session=Math.random(),this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter,this._config=0,i?.ignoreCreateEvents&&(this._config+=1),i?.ignoreChangeEvents&&(this._config+=2),i?.ignoreDeleteEvents&&(this._config+=4);const s=(0,d.parse)(f),t=typeof f=="string",o=i?.correlate,n=p(h=>{if(!(typeof h.session=="number"&&h.session!==this.session)&&!(o&&typeof h.session>"u")){if(!i?.ignoreCreateEvents)for(const c of h.created){const g=P.URI.revive(c);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this._onDidCreate.fire(g)}if(!i?.ignoreChangeEvents)for(const c of h.changed){const g=P.URI.revive(c);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this._onDidChange.fire(g)}if(!i?.ignoreDeleteEvents)for(const c of h.deleted){const g=P.URI.revive(c);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this._onDidDelete.fire(g)}}});this._disposable=R.Disposable.from(this.ensureWatching(b,m,f,i,i?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,n)}ensureWatching(b,a,m,p,f){const i=R.Disposable.from();if(typeof m=="string"||p?.ignoreChangeEvents&&p?.ignoreCreateEvents&&p?.ignoreDeleteEvents)return i;const s=b.getProxy(k.MainContext.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(d.GLOBSTAR)||m.pattern.includes(d.GLOB_SPLIT))&&(t=!0);let o;return f&&(p?.ignoreChangeEvents||p?.ignoreCreateEvents||p?.ignoreDeleteEvents)&&(o=v.FileChangeFilter.UPDATED|v.FileChangeFilter.ADDED|v.FileChangeFilter.DELETED,p?.ignoreChangeEvents&&(o&=~v.FileChangeFilter.UPDATED),p?.ignoreCreateEvents&&(o&=~v.FileChangeFilter.ADDED),p?.ignoreDeleteEvents&&(o&=~v.FileChangeFilter.DELETED)),s.$watch(a.identifier.value,this.session,m.baseUri,{recursive:t,excludes:p?.excludes??[],filter:o},!!f),R.Disposable.from({dispose:()=>s.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(b){this._events=b,this.session=this._events.session,this._created=new l.Lazy(()=>this._events.created.map(P.URI.revive)),this._changed=new l.Lazy(()=>this._events.changed.map(P.URI.revive)),this._deleted=new l.Lazy(()=>this._events.deleted.map(P.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class u{constructor(b,a,m){this._mainContext=b,this._logService=a,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,a,m,p){return new I(this._mainContext,b,a,this._onFileSystemEvent.event,L.GlobPattern.from(m),p)}$onFileEvent(b){this._onFileSystemEvent.fire(new y(b))}$onDidRunFileOperation(b,a){switch(b){case v.FileOperation.MOVE:this._onDidRenameFile.fire(Object.freeze({files:a.map(m=>({oldUri:P.URI.revive(m.source),newUri:P.URI.revive(m.target)}))}));break;case v.FileOperation.DELETE:this._onDidDeleteFile.fire(Object.freeze({files:a.map(m=>P.URI.revive(m.target))}));break;case v.FileOperation.CREATE:case v.FileOperation.COPY:this._onDidCreateFile.fire(Object.freeze({files:a.map(m=>P.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,a){return(m,p,f)=>{const i=function(t){m.call(p,t)};return i.extension=b,a.event(i,void 0,f)}}async $onWillRunFileOperation(b,a,m,p){switch(b){case v.FileOperation.MOVE:return await this._fireWillEvent(this._onWillRenameFile,{files:a.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))},m,p);case v.FileOperation.DELETE:return await this._fireWillEvent(this._onWillDeleteFile,{files:a.map(f=>P.URI.revive(f.target))},m,p);case v.FileOperation.CREATE:case v.FileOperation.COPY:return await this._fireWillEvent(this._onWillCreateFile,{files:a.map(f=>P.URI.revive(f.target))},m,p)}}async _fireWillEvent(b,a,m,p){const f=new Set,i=[];if(await b.fireAsync(a,p,async(t,o)=>{const n=Date.now(),h=await Promise.resolve(t);h instanceof R.WorkspaceEdit&&(i.push([o.extension,h]),f.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-n>m&&this._logService.warn("SLOW file-participant",o.extension.identifier)}),p.isCancellationRequested||i.length===0)return;const s={edits:[]};for(const[,t]of i){const{edits:o}=L.WorkspaceEdit.from(t,{getTextDocumentVersion:n=>this._extHostDocumentsAndEditors.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(o)}return{edit:s,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=u}),define(Ce[304],Ie([1,0,18,7,20,13,132,3,24,42,12,17,2,30,196,87,142,8,23,15,9,25,118,6]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0,a=$e(a),i=$e(i),n=$e(n);class h{constructor(H,q){this._documents=H,this._provider=q}async provideDocumentSymbols(H,q){const X=this._documents.getDocument(H),J=await this._provider.provideDocumentSymbols(X,q);if(!(0,r.isFalsyOrEmpty)(J))return J[0]instanceof s.DocumentSymbol?J.map(i.DocumentSymbol.from):h._asDocumentSymbolTree(J)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((J,he)=>{let we=J.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(J.location.range.end)),we});const q=[],X=[];for(const J of H){const he={name:J.name||"!!MISSING: name!!",kind:i.SymbolKind.from(J.kind),tags:J.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:i.Range.from(J.location.range),selectionRange:i.Range.from(J.location.range),children:[]};for(;;){if(X.length===0){X.push(he),q.push(he);break}const we=X[X.length-1];if(T.Range.containsRange(we.range,he.range)&&!T.Range.equalsRange(we.range,he.range)){we.children?.push(he),X.push(he);break}X.pop()}}return q}}class c{constructor(H,q,X,J,he,we){this._documents=H,this._commands=q,this._provider=X,this._extension=J,this._extTelemetry=he,this._logService=we,this._cache=new o.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,q){const X=this._documents.getDocument(H),J=await this._provider.provideCodeLenses(X,q);if(!J||q.isCancellationRequested)return;const he=this._cache.add(J),we=new R.DisposableStore;this._disposables.set(he,we);const Oe={cacheId:he,lenses:[]};for(let Ve=0;Ve<J.length;Ve++)Oe.lenses.push({cacheId:[he,Ve],range:i.Range.from(J[Ve].range),command:this._commands.toInternal(J[Ve].command,we)});return Oe}async resolveCodeLens(H,q){const X=H.cacheId&&this._cache.get(...H.cacheId);if(!X)return;let J;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?J=X:J=await this._provider.resolveCodeLens(X,q),J||(J=X),q.isCancellationRequested)return;const he=H.cacheId&&this._disposables.get(H.cacheId[0]);if(he){if(!J.command){const we=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,we),this._logService.error(we);return}return H.command=this._commands.toInternal(J.command,he),H}}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}function g(Pe){return Array.isArray(Pe)?Pe.map(i.DefinitionLink.from):Pe?[i.DefinitionLink.from(Pe)]:[]}class w{constructor(H,q){this._documents=H,this._provider=q}async provideDefinition(H,q,X){const J=this._documents.getDocument(H),he=i.Position.to(q),we=await this._provider.provideDefinition(J,he,X);return g(we)}}class D{constructor(H,q){this._documents=H,this._provider=q}async provideDeclaration(H,q,X){const J=this._documents.getDocument(H),he=i.Position.to(q),we=await this._provider.provideDeclaration(J,he,X);return g(we)}}class _{constructor(H,q){this._documents=H,this._provider=q}async provideImplementation(H,q,X){const J=this._documents.getDocument(H),he=i.Position.to(q),we=await this._provider.provideImplementation(J,he,X);return g(we)}}class C{constructor(H,q){this._documents=H,this._provider=q}async provideTypeDefinition(H,q,X){const J=this._documents.getDocument(H),he=i.Position.to(q),we=await this._provider.provideTypeDefinition(J,he,X);return g(we)}}class A{static{this.HOVER_MAP_MAX_SIZE=10}constructor(H,q){this._documents=H,this._provider=q,this._hoverCounter=0,this._hoverMap=new Map}async provideHover(H,q,X,J){const he=this._documents.getDocument(H),we=i.Position.to(q);let Oe;if(X&&X.verbosityRequest){const nt=X.verbosityRequest.previousHover.id,st=this._hoverMap.get(nt);if(!st)throw new Error(`Hover with id ${nt} not found`);const rt={verbosityDelta:X.verbosityRequest.verbosityDelta,previousHover:st};Oe=await this._provider.provideHover(he,we,J,rt)}else Oe=await this._provider.provideHover(he,we,J);if(!Oe||(0,r.isFalsyOrEmpty)(Oe.contents))return;Oe.range||(Oe.range=he.getWordRangeAtPosition(we)),Oe.range||(Oe.range=new s.Range(we,we));const Ve=i.Hover.from(Oe),Ke=this._hoverCounter;if(this._hoverMap.size===A.HOVER_MAP_MAX_SIZE){const nt=Math.min(...this._hoverMap.keys());this._hoverMap.delete(nt)}return this._hoverMap.set(Ke,Oe),this._hoverCounter+=1,{...Ve,id:Ke}}releaseHover(H){this._hoverMap.delete(H)}}class E{constructor(H,q){this._documents=H,this._provider=q}async provideEvaluatableExpression(H,q,X){const J=this._documents.getDocument(H),he=i.Position.to(q),we=await this._provider.provideEvaluatableExpression(J,he,X);if(we)return i.EvaluatableExpression.from(we)}}class S{constructor(H,q){this._documents=H,this._provider=q}async provideInlineValues(H,q,X,J){const he=this._documents.getDocument(H),we=await this._provider.provideInlineValues(he,i.Range.to(q),i.InlineValueContext.to(X),J);if(Array.isArray(we))return we.map(Oe=>i.InlineValue.from(Oe))}}class F{constructor(H,q){this._documents=H,this._provider=q}async provideDocumentHighlights(H,q,X){const J=this._documents.getDocument(H),he=i.Position.to(q),we=await this._provider.provideDocumentHighlights(J,he,X);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class N{constructor(H,q){this._documents=H,this._provider=q}async provideMultiDocumentHighlights(H,q,X,J){const he=this._documents.getDocument(H),we=X.map(Ke=>this._documents.getDocument(Ke)),Oe=i.Position.to(q),Ve=await this._provider.provideMultiDocumentHighlights(he,Oe,we,J);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class O{constructor(H,q){this._documents=H,this._provider=q}async provideLinkedEditingRanges(H,q,X){const J=this._documents.getDocument(H),he=i.Position.to(q),we=await this._provider.provideLinkedEditingRanges(J,he,X);if(we&&Array.isArray(we.ranges))return{ranges:(0,r.coalesce)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class M{constructor(H,q){this._documents=H,this._provider=q}async provideReferences(H,q,X,J){const he=this._documents.getDocument(H),we=i.Position.to(q),Oe=await this._provider.provideReferences(he,we,X,J);if(Array.isArray(Oe))return Oe.map(i.location.from)}}class U{static{this._maxCodeActionsPerFile=1e3}constructor(H,q,X,J,he,we,Oe){this._documents=H,this._commands=q,this._diagnostics=X,this._provider=J,this._logService=he,this._extension=we,this._apiDeprecation=Oe,this._cache=new o.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,q,X,J){const he=this._documents.getDocument(H),we=b.Selection.isISelection(q)?i.Selection.to(q):i.Range.to(q),Oe=[];for(const rt of this._diagnostics.getDiagnostics(H))if(we.intersection(rt.range)&&Oe.push(rt)>U._maxCodeActionsPerFile)break;const Ve={diagnostics:Oe,only:X.only?new s.CodeActionKind(X.only):void 0,triggerKind:i.CodeActionTriggerKind.to(X.trigger)},Ke=await this._provider.provideCodeActions(he,we,Ve,J);if(!(0,r.isNonEmptyArray)(Ke)||J.isCancellationRequested)return;const et=this._cache.add(Ke),nt=new R.DisposableStore;this._disposables.set(et,nt);const st=[];for(let rt=0;rt<Ke.length;rt++){const at=Ke[rt];if(at)if(U._isCommand(at))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:at.title,command:this._commands.toInternal(at,nt)});else{Ve.only&&(at.kind?Ve.only.contains(at.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ve.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ve.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const gt=at.ranges??[];st.push({cacheId:[et,rt],title:at.title,command:at.command&&this._commands.toInternal(at.command,nt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?at.isAI:!1,ranges:(0,t.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,r.coalesce)(gt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:et,actions:st}}async resolveCodeAction(H,q){const[X,J]=H,he=this._cache.get(X,J);if(!he||U._isCommand(he))return{};if(!this._provider.resolveCodeAction)return{};const we=await this._provider.resolveCodeAction(he,q)??he;let Oe;we.edit&&(Oe=i.WorkspaceEdit.from(we.edit,void 0));let Ve;if(we.command){const Ke=this._disposables.get(X);Ke&&(Ve=this._commands.toInternal(we.command,Ke))}return{edit:Oe,command:Ve}}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}class x{constructor(H,q,X,J,he){this._proxy=H,this._documents=q,this._provider=X,this._handle=J,this._extension=he,this._cache=new o.Cache("DocumentPasteEdit")}async prepareDocumentPaste(H,q,X,J){if(!this._provider.prepareDocumentPaste)return;const he=this._documents.getDocument(H),we=q.map(Ke=>i.Range.to(Ke)),Oe=i.DataTransfer.toDataTransfer(X,()=>{throw new k.NotImplementedError});if(await this._provider.prepareDocumentPaste(he,we,Oe,J),J.isCancellationRequested)return;const Ve=Array.from(Oe).filter(([,Ke])=>!(Ke instanceof s.InternalDataTransferItem));return i.DataTransfer.from(Ve)}async providePasteEdits(H,q,X,J,he,we){if(!this._provider.provideDocumentPasteEdits)return[];const Oe=this._documents.getDocument(q),Ve=X.map(st=>i.Range.to(st)),Ke=i.DataTransfer.toDataTransfer(J,async st=>(await this._proxy.$resolvePasteFileData(this._handle,H,st)).buffer),et=await this._provider.provideDocumentPasteEdits(Oe,Ve,Ke,{only:he.only?new s.DocumentDropOrPasteEditKind(he.only):void 0,triggerKind:he.triggerKind},we);if(!et||we.isCancellationRequested)return[];const nt=this._cache.add(et);return et.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,p.localize)(10834,null,this._extension.displayName||this._extension.name),kind:st.kind,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolvePasteEdit(H,q){const[X,J]=H,he=this._cache.get(X,J);if(!he||!this._provider.resolveDocumentPasteEdit)return{};const we=await this._provider.resolveDocumentPasteEdit(he,q)??he;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(H){this._cache.delete(H)}}class z{constructor(H,q){this._documents=H,this._provider=q}async provideDocumentFormattingEdits(H,q,X){const J=this._documents.getDocument(H),he=await this._provider.provideDocumentFormattingEdits(J,q,X);if(Array.isArray(he))return he.map(i.TextEdit.from)}}class B{constructor(H,q){this._documents=H,this._provider=q}async provideDocumentRangeFormattingEdits(H,q,X,J){const he=this._documents.getDocument(H),we=i.Range.to(q),Oe=await this._provider.provideDocumentRangeFormattingEdits(he,we,X,J);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(H,q,X,J){(0,y.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this._documents.getDocument(H),we=q.map(i.Range.to),Oe=await this._provider.provideDocumentRangesFormattingEdits(he,we,X,J);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}}class ee{constructor(H,q){this._documents=H,this._provider=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,q,X,J,he){const we=this._documents.getDocument(H),Oe=i.Position.to(q),Ve=await this._provider.provideOnTypeFormattingEdits(we,Oe,X,J,he);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class V{constructor(H,q){this._provider=H,this._logService=q,this._cache=new o.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(H,q){const X=await this._provider.provideWorkspaceSymbols(H,q);if(!(0,r.isNonEmptyArray)(X))return{symbols:[]};const J=this._cache.add(X),he={cacheId:J,symbols:[]};for(let we=0;we<X.length;we++){const Oe=X[we];if(!Oe||!Oe.name){this._logService.warn("INVALID SymbolInformation",Oe);continue}he.symbols.push({...i.WorkspaceSymbol.from(Oe),cacheId:[J,we]})}return he}async resolveWorkspaceSymbol(H,q){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!H.cacheId)return H;const X=this._cache.get(...H.cacheId);if(X){const J=await this._provider.resolveWorkspaceSymbol(X,q);return J&&(0,v.mixin)(H,i.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(H){this._cache.delete(H)}}class ${static supportsResolving(H){return typeof H.prepareRename=="function"}constructor(H,q,X){this._documents=H,this._provider=q,this._logService=X}async provideRenameEdits(H,q,X,J){const he=this._documents.getDocument(H),we=i.Position.to(q);try{const Oe=await this._provider.provideRenameEdits(he,we,X,J);return Oe?i.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Ve=$._asMessage(Oe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(H,q,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const J=this._documents.getDocument(H),he=i.Position.to(q);try{const we=await this._provider.prepareRename(J,he,X);let Oe,Ve;if(s.Range.isRange(we)?(Oe=we,Ve=J.getText(we)):(0,y.isObject)(we)&&(Oe=we.range,Ve=we.placeholder),!Oe||!Ve)return;if(Oe.start.line>he.line||Oe.end.line<he.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Oe),text:Ve}}catch(we){const Oe=$._asMessage(we);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class G{static{this.languageTriggerKindToVSCodeTriggerKind={[a.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(H,q,X){this._documents=H,this._provider=q,this._logService=X}async supportsAutomaticNewSymbolNamesTriggerKind(){return this._provider.supportsAutomaticTriggerKind}async provideNewSymbolNames(H,q,X,J){const he=this._documents.getDocument(H),we=i.Range.to(q);try{const Oe=G.languageTriggerKindToVSCodeTriggerKind[X],Ve=await this._provider.provideNewSymbolNames(he,we,Oe,J);return Ve?Ve.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Oe){this._logService.error(G._asMessage(Oe)??JSON.stringify(Oe,null,"	"));return}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class Z{constructor(H,q){this.resultId=H,this.tokens=q}}class le{constructor(H,q){this._documents=H,this._provider=q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,q,X){const J=this._documents.getDocument(H),he=q!==0?this._previousResults.get(q):null;let we=typeof he?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(J,he.resultId,X):await this._provider.provideDocumentSemanticTokens(J,X);return he&&this._previousResults.delete(q),we?(we=le._fixProvidedSemanticTokens(we),this._send(le._convertToEdits(he,we),we)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return le._isSemanticTokens(H)?le._isCorrectSemanticTokens(H)?H:new s.SemanticTokens(new Uint32Array(H.data),H.resultId):le._isSemanticTokensEdits(H)?le._isCorrectSemanticTokensEdits(H)?H:new s.SemanticTokensEdits(H.edits.map(q=>new s.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const q of H.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,q){if(!le._isSemanticTokens(q)||!H||!H.tokens)return q;const X=H.tokens,J=X.length,he=q.data,we=he.length;let Oe=0;const Ve=Math.min(J,we);for(;Oe<Ve&&X[Oe]===he[Oe];)Oe++;if(Oe===J&&Oe===we)return new s.SemanticTokensEdits([],q.resultId);let Ke=0;const et=Ve-Oe;for(;Ke<et&&X[J-Ke-1]===he[we-Ke-1];)Ke++;return new s.SemanticTokensEdits([{start:Oe,deleteCount:J-Oe-Ke,data:he.subarray(Oe,we-Ke)}],q.resultId)}_send(H,q){if(le._isSemanticTokens(H)){const X=this._nextResultId++;return this._previousResults.set(X,new Z(H.resultId,H.data)),(0,m.encodeSemanticTokensDto)({id:X,type:"full",data:H.data})}if(le._isSemanticTokensEdits(H)){const X=this._nextResultId++;return le._isSemanticTokens(q)?this._previousResults.set(X,new Z(q.resultId,q.data)):this._previousResults.set(X,new Z(H.resultId)),(0,m.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(H.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class ne{constructor(H,q){this._documents=H,this._provider=q}async provideDocumentRangeSemanticTokens(H,q,X){const J=this._documents.getDocument(H),he=await this._provider.provideDocumentRangeSemanticTokens(J,i.Range.to(q),X);return he?this._send(he):null}_send(H){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}class _e{static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}constructor(H,q,X,J,he){this._documents=H,this._commands=q,this._provider=X,this._apiDeprecation=J,this._extension=he,this._cache=new o.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(H,q,X,J){const he=this._documents.getDocument(H),we=i.Position.to(q),Oe=he.getWordRangeAtPosition(we)||new s.Range(we,we),Ve=Oe.with({end:we}),Ke=new l.StopWatch,et=await this._provider.provideCompletionItems(he,we,J,i.CompletionContext.to(X));if(!et||J.isCancellationRequested)return;const nt=Array.isArray(et)?new s.CompletionList(et):et,st=_e.supportsResolving(this._provider)?this._cache.add(nt.items):this._cache.add([]),rt=new R.DisposableStore;this._disposables.set(st,rt);const at=[],gt={x:st,[n.ISuggestResultDtoField.completions]:at,[n.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Oe),insert:i.Range.from(Ve)},[n.ISuggestResultDtoField.isIncomplete]:nt.isIncomplete||void 0,[n.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ht=0;ht<nt.items.length;ht++){const lt=nt.items[ht],Te=this._convertCompletionItem(lt,[st,ht],Ve,Oe);at.push(Te)}return gt}async resolveCompletionItem(H,q){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...H);if(!X)return;const J=this._convertCompletionItem(X,H),he=await this._provider.resolveCompletionItem(X,q);if(!he)return;const we=this._convertCompletionItem(he,H);return(J[n.ISuggestDataDtoField.insertText]!==we[n.ISuggestDataDtoField.insertText]||J[n.ISuggestDataDtoField.insertTextRules]!==we[n.ISuggestDataDtoField.insertTextRules])&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J[n.ISuggestDataDtoField.commandIdent]!==we[n.ISuggestDataDtoField.commandIdent]||J[n.ISuggestDataDtoField.commandId]!==we[n.ISuggestDataDtoField.commandId]||!(0,v.equals)(J[n.ISuggestDataDtoField.commandArguments],we[n.ISuggestDataDtoField.commandArguments]))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,[n.ISuggestDataDtoField.documentation]:we[n.ISuggestDataDtoField.documentation],[n.ISuggestDataDtoField.detail]:we[n.ISuggestDataDtoField.detail],[n.ISuggestDataDtoField.additionalTextEdits]:we[n.ISuggestDataDtoField.additionalTextEdits],[n.ISuggestDataDtoField.insertText]:we[n.ISuggestDataDtoField.insertText],[n.ISuggestDataDtoField.insertTextRules]:we[n.ISuggestDataDtoField.insertTextRules],[n.ISuggestDataDtoField.commandIdent]:we[n.ISuggestDataDtoField.commandIdent],[n.ISuggestDataDtoField.commandId]:we[n.ISuggestDataDtoField.commandId],[n.ISuggestDataDtoField.commandArguments]:we[n.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,q,X,J){const he=this._disposables.get(q[0]);if(!he)throw Error("DisposableStore is missing...");const we=this._commands.toInternal(H.command,he),Oe={x:q,[n.ISuggestDataDtoField.label]:H.label,[n.ISuggestDataDtoField.kind]:H.kind!==void 0?i.CompletionItemKind.from(H.kind):void 0,[n.ISuggestDataDtoField.kindModifier]:H.tags&&H.tags.map(i.CompletionItemTag.from),[n.ISuggestDataDtoField.detail]:H.detail,[n.ISuggestDataDtoField.documentation]:typeof H.documentation>"u"?void 0:i.MarkdownString.fromStrict(H.documentation),[n.ISuggestDataDtoField.sortText]:H.sortText!==H.label?H.sortText:void 0,[n.ISuggestDataDtoField.filterText]:H.filterText!==H.label?H.filterText:void 0,[n.ISuggestDataDtoField.preselect]:H.preselect||void 0,[n.ISuggestDataDtoField.insertTextRules]:H.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[n.ISuggestDataDtoField.commitCharacters]:H.commitCharacters?.join(""),[n.ISuggestDataDtoField.additionalTextEdits]:H.additionalTextEdits&&H.additionalTextEdits.map(i.TextEdit.from),[n.ISuggestDataDtoField.commandIdent]:we?.$ident,[n.ISuggestDataDtoField.commandId]:we?.id,[n.ISuggestDataDtoField.commandArguments]:we?.$ident?void 0:we?.arguments};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe[n.ISuggestDataDtoField.insertText]=H.textEdit.newText):typeof H.insertText=="string"?Oe[n.ISuggestDataDtoField.insertText]=H.insertText:H.insertText instanceof s.SnippetString&&(Oe[n.ISuggestDataDtoField.insertText]=H.insertText.value,Oe[n.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let Ve;return H.textEdit?Ve=H.textEdit.range:H.range&&(Ve=H.range),s.Range.isRange(Ve)?Oe[n.ISuggestDataDtoField.range]=i.Range.from(Ve):Ve&&(!X?.isEqual(Ve.inserting)||!J?.isEqual(Ve.replacing))&&(Oe[n.ISuggestDataDtoField.range]={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Oe}}class ge{async provideInlineCompletions(H,q,X,J){}async provideInlineEdits(H,q,X,J){}disposeCompletions(H){}handleDidShowCompletionItem(H,q,X){}handlePartialAccept(H,q,X,J){}}class Y extends ge{constructor(H,q,X,J){super(),this._extension=H,this._documents=q,this._provider=X,this._commands=J,this._references=new oe,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[a.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(H,q,X,J){const he=this._documents.getDocument(H),we=i.Position.to(q),Oe=await this._provider.provideInlineCompletionItems(he,we,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[X.triggerKind]},J);if(!Oe||J.isCancellationRequested)return;const Ve=Array.isArray(Oe)?Oe:Oe.items,Ke=this._isAdditionsProposedApiEnabled?Array.isArray(Oe)?[]:Oe.commands||[]:[],et=this._isAdditionsProposedApiEnabled&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let nt;return{pid:this._references.createReferenceId({dispose(){nt?.dispose()},items:Ve}),items:Ve.map((rt,at)=>{let gt;rt.command&&(nt||(nt=new R.DisposableStore),gt=this._commands.toInternal(rt.command,nt));const ht=rt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:gt,idx:at,completeBracketPairs:this._isAdditionsProposedApiEnabled?rt.completeBracketPairs:!1}}),commands:Ke.map(rt=>(nt||(nt=new R.DisposableStore),this._commands.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:et}}async provideInlineEdits(H,q,X,J){if(!this._provider.provideInlineEdits)return;(0,t.checkProposedApiEnabled)(this._extension,"inlineCompletionsAdditions");const he=this._documents.getDocument(H),we=i.Range.to(q),Oe=await this._provider.provideInlineEdits(he,we,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[X.triggerKind],userPrompt:X.userPrompt},J);if(!Oe||J.isCancellationRequested)return;const Ve=Array.isArray(Oe)?Oe:Oe.items,Ke=this._isAdditionsProposedApiEnabled?Array.isArray(Oe)?[]:Oe.commands||[]:[],et=this._isAdditionsProposedApiEnabled&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let nt;return{pid:this._references.createReferenceId({dispose(){nt?.dispose()},items:Ve}),items:Ve.map((rt,at)=>{let gt;rt.command&&(nt||(nt=new R.DisposableStore),gt=this._commands.toInternal(rt.command,nt));const ht=rt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:gt,idx:at,completeBracketPairs:this._isAdditionsProposedApiEnabled?rt.completeBracketPairs:!1}}),commands:Ke.map(rt=>(nt||(nt=new R.DisposableStore),this._commands.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(H){this._references.disposeReferenceId(H)?.dispose()}handleDidShowCompletionItem(H,q,X){const J=this._references.get(H)?.items[q];J&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(J,X)}handlePartialAccept(H,q,X,J){const he=this._references.get(H)?.items[q];he&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(he,X),this._provider.handleDidPartiallyAcceptCompletionItem(he,i.PartialAcceptInfo.to(J)))}}class W{async provideInlineEdits(H,q,X){const J=this._documents.getDocument(H),he=await this._provider.provideInlineEdit(J,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},X);if(!he||X.isCancellationRequested)return;let we;const Oe=this._references.createReferenceId({dispose(){we?.dispose()},item:he});let Ve;he.accepted&&(we||(we=new R.DisposableStore),Ve=this._commands.toInternal(he.accepted,we));let Ke;return he.rejected&&(we||(we=new R.DisposableStore),Ke=this._commands.toInternal(he.rejected,we)),{pid:Oe,text:he.text,range:i.Range.from(he.range),accepted:Ve,rejected:Ke}}disposeEdit(H){this._references.disposeReferenceId(H)?.dispose()}constructor(H,q,X,J){this._documents=q,this._provider=X,this._commands=J,this._references=new oe,this.languageTriggerKindToVSCodeTriggerKind={[a.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class oe{constructor(){this._references=new Map,this._idPool=1}createReferenceId(H){const q=this._idPool++;return this._references.set(q,H),q}disposeReferenceId(H){const q=this._references.get(H);return this._references.delete(H),q}get(H){return this._references.get(H)}}class Se{constructor(H,q){this._documents=H,this._provider=q,this._cache=new o.Cache("SignatureHelp")}async provideSignatureHelp(H,q,X,J){const he=this._documents.getDocument(H),we=i.Position.to(q),Oe=this.reviveContext(X),Ve=await this._provider.provideSignatureHelp(he,we,J,Oe);if(Ve){const Ke=this._cache.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Ke}}}reviveContext(H){let q;if(H.activeSignatureHelp){const X=i.SignatureHelp.to(H.activeSignatureHelp),J=this._cache.get(H.activeSignatureHelp.id,0);J?(q=J,q.activeSignature=X.activeSignature,q.activeParameter=X.activeParameter):q=X}return{...H,activeSignatureHelp:q}}releaseSignatureHelp(H){this._cache.delete(H)}}class te{constructor(H,q,X,J,he){this._documents=H,this._commands=q,this._provider=X,this._logService=J,this._extension=he,this._cache=new o.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(H,q,X){const J=this._documents.getDocument(H),he=i.Range.to(q),we=await this._provider.provideInlayHints(J,he,X);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(q)}`);return}if(X.isCancellationRequested)return;const Oe=this._cache.add(we);this._disposables.set(Oe,new R.DisposableStore);const Ve={hints:[],cacheId:Oe};for(let Ke=0;Ke<we.length;Ke++)this._isValidInlayHint(we[Ke],he)&&Ve.hints.push(this._convertInlayHint(we[Ke],[Oe,Ke]));return this._logService.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(q)}`),Ve}async resolveInlayHint(H,q){if(typeof this._provider.resolveInlayHint!="function")return;const X=this._cache.get(...H);if(!X)return;const J=await this._provider.resolveInlayHint(X,q);if(J&&this._isValidInlayHint(J))return this._convertInlayHint(J,H)}releaseHints(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_isValidInlayHint(H,q){return H.label.length===0||Array.isArray(H.label)&&H.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",H),!1):!(q&&!q.contains(H.position))}_convertInlayHint(H,q){const X=this._disposables.get(q[0]);if(!X)throw Error("DisposableStore is missing...");const J={label:"",cacheId:q,tooltip:i.MarkdownString.fromStrict(H.tooltip),position:i.Position.from(H.position),textEdits:H.textEdits&&H.textEdits.map(i.TextEdit.from),kind:H.kind&&i.InlayHintKind.from(H.kind),paddingLeft:H.paddingLeft,paddingRight:H.paddingRight};if(typeof H.label=="string")J.label=H.label;else{const he=[];J.label=he;for(const we of H.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Oe={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};s.Location.isLocation(we.location)&&(Oe.location=i.location.from(we.location)),we.command&&(Oe.command=this._commands.toInternal(we.command,X)),he.push(Oe)}}return J}}class ae{constructor(H,q){this._documents=H,this._provider=q,this._cache=new o.Cache("DocumentLink")}async provideLinks(H,q){const X=this._documents.getDocument(H),J=await this._provider.provideDocumentLinks(X,q);if(!(!Array.isArray(J)||J.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:J.filter(ae._validateLink).map(i.DocumentLink.from)};{const he=this._cache.add(J),we={links:[],cacheId:he};for(let Oe=0;Oe<J.length;Oe++){if(!ae._validateLink(J[Oe]))continue;const Ve=i.DocumentLink.from(J[Oe]);Ve.cacheId=[he,Oe],we.links.push(Ve)}return we}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,q){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...H);if(!X)return;const J=await this._provider.resolveDocumentLink(X,q);if(!(!J||!ae._validateLink(J)))return i.DocumentLink.from(J)}releaseLinks(H){this._cache.delete(H)}}class se{constructor(H,q){this._documents=H,this._provider=q}async provideColors(H,q){const X=this._documents.getDocument(H),J=await this._provider.provideDocumentColors(X,q);return Array.isArray(J)?J.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(H,q,X){const J=this._documents.getDocument(H),he=i.Range.to(q.range),we=i.Color.to(q.color),Oe=await this._provider.provideColorPresentations(we,{document:J,range:he},X);if(Array.isArray(Oe))return Oe.map(i.ColorPresentation.from)}}class Q{constructor(H,q){this._documents=H,this._provider=q}async provideFoldingRanges(H,q,X){const J=this._documents.getDocument(H),he=await this._provider.provideFoldingRanges(J,q,X);if(Array.isArray(he))return he.map(i.FoldingRange.from)}}class re{constructor(H,q,X){this._documents=H,this._provider=q,this._logService=X}async provideSelectionRanges(H,q,X){const J=this._documents.getDocument(H),he=q.map(i.Position.to),we=await this._provider.provideSelectionRanges(J,he,X);if(!(0,r.isNonEmptyArray)(we))return[];if(we.length!==he.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Ve=0;Ve<he.length;Ve++){const Ke=[];Oe.push(Ke);let et=he[Ve],nt=we[Ve];for(;;){if(!nt.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(nt)),!nt.parent)break;et=nt.range,nt=nt.parent}}return Oe}}class ve{constructor(H,q){this._documents=H,this._provider=q,this._idPool=new L.IdGenerator(""),this._cache=new Map}async prepareSession(H,q,X){const J=this._documents.getDocument(H),he=i.Position.to(q),we=await this._provider.prepareCallHierarchy(J,he,X);if(!we)return;const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(we)?we.map(Ve=>this._cacheAndConvertItem(Oe,Ve)):[this._cacheAndConvertItem(Oe,we)]}async provideCallsTo(H,q,X){const J=this._itemFromCache(H,q);if(!J)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyIncomingCalls(J,X);if(he)return he.map(we=>({from:this._cacheAndConvertItem(H,we.from),fromRanges:we.fromRanges.map(Oe=>i.Range.from(Oe))}))}async provideCallsFrom(H,q,X){const J=this._itemFromCache(H,q);if(!J)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyOutgoingCalls(J,X);if(he)return he.map(we=>({to:this._cacheAndConvertItem(H,we.to),fromRanges:we.fromRanges.map(Oe=>i.Range.from(Oe))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,q){const X=this._cache.get(H),J=i.CallHierarchyItem.from(q,H,X.size.toString(36));return X.set(J._itemId,q),J}_itemFromCache(H,q){return this._cache.get(H)?.get(q)}}class be{constructor(H,q){this._documents=H,this._provider=q,this._idPool=new L.IdGenerator(""),this._cache=new Map}async prepareSession(H,q,X){const J=this._documents.getDocument(H),he=i.Position.to(q),we=await this._provider.prepareTypeHierarchy(J,he,X);if(!we)return;const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(we)?we.map(Ve=>this._cacheAndConvertItem(Oe,Ve)):[this._cacheAndConvertItem(Oe,we)]}async provideSupertypes(H,q,X){const J=this._itemFromCache(H,q);if(!J)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySupertypes(J,X);if(he)return he.map(we=>this._cacheAndConvertItem(H,we))}async provideSubtypes(H,q,X){const J=this._itemFromCache(H,q);if(!J)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySubtypes(J,X);if(he)return he.map(we=>this._cacheAndConvertItem(H,we))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,q){const X=this._cache.get(H),J=i.TypeHierarchyItem.from(q,H,X.size.toString(36));return X.set(J._itemId,q),J}_itemFromCache(H,q){return this._cache.get(H)?.get(q)}}class Fe{constructor(H,q,X,J,he){this._proxy=H,this._documents=q,this._provider=X,this._handle=J,this._extension=he,this._cache=new o.Cache("DocumentDropEdit")}async provideDocumentOnDropEdits(H,q,X,J,he){const we=this._documents.getDocument(q),Oe=i.Position.to(X),Ve=i.DataTransfer.toDataTransfer(J,async st=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,H,st)).buffer),Ke=await this._provider.provideDocumentDropEdits(we,Oe,Ve,he);if(!Ke)return;const et=(0,r.asArray)(Ke),nt=this._cache.add(et);return et.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,p.localize)(10835,null,this._extension.displayName||this._extension.name),kind:st.kind?.value,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolveDropEdit(H,q){const[X,J]=H,he=this._cache.get(X,J);if(!he||!this._provider.resolveDocumentDropEdit)return{};const we=await this._provider.resolveDocumentDropEdit(he,q)??he;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(H){this._cache.delete(H)}}class Be{constructor(H,q){this._documents=H,this._provider=q}async provideMappedEdits(H,q,X,J){const he=u.URI.revive(H),we=this._documents.getDocument(he),Oe=X.documents.map(et=>et.map(nt=>({uri:u.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(st=>i.Range.to(st))}))),Ve={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Ke=await this._provider.provideMappedEdits(we,q,Ve,J);return Ke?i.WorkspaceEdit.from(Ke):null}}class ke{constructor(H,q){this.adapter=H,this.extension=q}}class De{static{this._handlePool=0}constructor(H,q,X,J,he,we,Oe,Ve){this._uriTransformer=q,this._documents=X,this._commands=J,this._diagnostics=he,this._logService=we,this._apiDeprecation=Oe,this._extensionTelemetry=Ve,this._adapter=new Map,this._proxy=H.getProxy(n.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(H,q){return i.DocumentSelector.from(H,this._uriTransformer,q)}_createDisposable(H){return new s.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return De._handlePool++}async _withAdapter(H,q,X,J,he,we=!1){const Oe=this._adapter.get(H);if(!Oe||!(Oe.adapter instanceof q))return J;const Ve=Date.now();we||this._logService.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Ke=X(Oe.adapter,Oe.extension);return Promise.resolve(Ke).catch(et=>{(0,k.isCancellationError)(et)||(this._logService.error(`[${Oe.extension.identifier.value}] provider FAILED`),this._logService.error(et),this._extensionTelemetry.onExtensionError(Oe.extension.identifier,et))}).finally(()=>{we||this._logService.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),P.CancellationToken.isCancellationToken(he)?(0,d.raceCancellationError)(Ke,he):Ke}_addNewAdapter(H,q){const X=this._nextHandle();return this._adapter.set(X,new ke(H,q)),X}static _extLabel(H){return H.displayName||H.name}static _extId(H){return H.identifier.value}registerDocumentSymbolProvider(H,q,X,J){const he=this._addNewAdapter(new h(this._documents,X),H),we=J&&J.label||De._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(he,this._transformDocumentSelector(q,H),we),this._createDisposable(he)}$provideDocumentSymbols(H,q,X){return this._withAdapter(H,h,J=>J.provideDocumentSymbols(u.URI.revive(q),X),void 0,X)}registerCodeLensProvider(H,q,X){const J=this._nextHandle(),he=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(J,new ke(new c(this._documents,this._commands.converter,X,H,this._extensionTelemetry,this._logService),H)),this._proxy.$registerCodeLensSupport(J,this._transformDocumentSelector(q,H),he);let we=this._createDisposable(J);if(he!==void 0){const Oe=X.onDidChangeCodeLenses(Ve=>this._proxy.$emitCodeLensEvent(he));we=s.Disposable.from(we,Oe)}return we}$provideCodeLenses(H,q,X){return this._withAdapter(H,c,J=>J.provideCodeLenses(u.URI.revive(q),X),void 0,X)}$resolveCodeLens(H,q,X){return this._withAdapter(H,c,J=>J.resolveCodeLens(q,X),void 0,void 0)}$releaseCodeLenses(H,q){this._withAdapter(H,c,X=>Promise.resolve(X.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(H,q,X){const J=this._addNewAdapter(new w(this._documents,X),H);return this._proxy.$registerDefinitionSupport(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$provideDefinition(H,q,X,J){return this._withAdapter(H,w,he=>he.provideDefinition(u.URI.revive(q),X,J),[],J)}registerDeclarationProvider(H,q,X){const J=this._addNewAdapter(new D(this._documents,X),H);return this._proxy.$registerDeclarationSupport(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$provideDeclaration(H,q,X,J){return this._withAdapter(H,D,he=>he.provideDeclaration(u.URI.revive(q),X,J),[],J)}registerImplementationProvider(H,q,X){const J=this._addNewAdapter(new _(this._documents,X),H);return this._proxy.$registerImplementationSupport(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$provideImplementation(H,q,X,J){return this._withAdapter(H,_,he=>he.provideImplementation(u.URI.revive(q),X,J),[],J)}registerTypeDefinitionProvider(H,q,X){const J=this._addNewAdapter(new C(this._documents,X),H);return this._proxy.$registerTypeDefinitionSupport(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$provideTypeDefinition(H,q,X,J){return this._withAdapter(H,C,he=>he.provideTypeDefinition(u.URI.revive(q),X,J),[],J)}registerHoverProvider(H,q,X,J){const he=this._addNewAdapter(new A(this._documents,X),H);return this._proxy.$registerHoverProvider(he,this._transformDocumentSelector(q,H)),this._createDisposable(he)}$provideHover(H,q,X,J,he){return this._withAdapter(H,A,we=>we.provideHover(u.URI.revive(q),X,J,he),void 0,he)}$releaseHover(H,q){this._withAdapter(H,A,X=>Promise.resolve(X.releaseHover(q)),void 0,void 0)}registerEvaluatableExpressionProvider(H,q,X,J){const he=this._addNewAdapter(new E(this._documents,X),H);return this._proxy.$registerEvaluatableExpressionProvider(he,this._transformDocumentSelector(q,H)),this._createDisposable(he)}$provideEvaluatableExpression(H,q,X,J){return this._withAdapter(H,E,he=>he.provideEvaluatableExpression(u.URI.revive(q),X,J),void 0,J)}registerInlineValuesProvider(H,q,X,J){const he=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new S(this._documents,X),H);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(q,H),he);let Oe=this._createDisposable(we);if(he!==void 0){const Ve=X.onDidChangeInlineValues(Ke=>this._proxy.$emitInlineValuesEvent(he));Oe=s.Disposable.from(Oe,Ve)}return Oe}$provideInlineValues(H,q,X,J,he){return this._withAdapter(H,S,we=>we.provideInlineValues(u.URI.revive(q),X,J,he),void 0,he)}registerDocumentHighlightProvider(H,q,X){const J=this._addNewAdapter(new F(this._documents,X),H);return this._proxy.$registerDocumentHighlightProvider(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}registerMultiDocumentHighlightProvider(H,q,X){const J=this._addNewAdapter(new N(this._documents,X),H);return this._proxy.$registerMultiDocumentHighlightProvider(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$provideDocumentHighlights(H,q,X,J){return this._withAdapter(H,F,he=>he.provideDocumentHighlights(u.URI.revive(q),X,J),void 0,J)}$provideMultiDocumentHighlights(H,q,X,J,he){return this._withAdapter(H,N,we=>we.provideMultiDocumentHighlights(u.URI.revive(q),X,J.map(Oe=>u.URI.revive(Oe)),he),void 0,he)}registerLinkedEditingRangeProvider(H,q,X){const J=this._addNewAdapter(new O(this._documents,X),H);return this._proxy.$registerLinkedEditingRangeProvider(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$provideLinkedEditingRanges(H,q,X,J){return this._withAdapter(H,O,async he=>{const we=await he.provideLinkedEditingRanges(u.URI.revive(q),X,J);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?De._serializeRegExp(we.wordPattern):void 0}},void 0,J)}registerReferenceProvider(H,q,X){const J=this._addNewAdapter(new M(this._documents,X),H);return this._proxy.$registerReferenceSupport(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$provideReferences(H,q,X,J,he){return this._withAdapter(H,M,we=>we.provideReferences(u.URI.revive(q),X,J,he),void 0,he)}registerCodeActionProvider(H,q,X,J){const he=new R.DisposableStore,we=this._addNewAdapter(new U(this._documents,this._commands.converter,this._diagnostics,X,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerCodeActionSupport(we,this._transformDocumentSelector(q,H),{providedKinds:J?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:J?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this._commands.converter.toInternal(Oe.command,he)}))},De._extLabel(H),De._extId(H),!!X.resolveCodeAction),he.add(this._createDisposable(we)),he}$provideCodeActions(H,q,X,J,he){return this._withAdapter(H,U,we=>we.provideCodeActions(u.URI.revive(q),X,J,he),void 0,he)}$resolveCodeAction(H,q,X){return this._withAdapter(H,U,J=>J.resolveCodeAction(q,X),{},void 0)}$releaseCodeActions(H,q){this._withAdapter(H,U,X=>Promise.resolve(X.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(H,q,X){const J=this._addNewAdapter(new z(this._documents,X),H);return this._proxy.$registerDocumentFormattingSupport(J,this._transformDocumentSelector(q,H),H.identifier,H.displayName||H.name),this._createDisposable(J)}$provideDocumentFormattingEdits(H,q,X,J){return this._withAdapter(H,z,he=>he.provideDocumentFormattingEdits(u.URI.revive(q),X,J),void 0,J)}registerDocumentRangeFormattingEditProvider(H,q,X){const J=typeof X.provideDocumentRangesFormattingEdits=="function",he=this._addNewAdapter(new B(this._documents,X),H);return this._proxy.$registerRangeFormattingSupport(he,this._transformDocumentSelector(q,H),H.identifier,H.displayName||H.name,J),this._createDisposable(he)}$provideDocumentRangeFormattingEdits(H,q,X,J,he){return this._withAdapter(H,B,we=>we.provideDocumentRangeFormattingEdits(u.URI.revive(q),X,J,he),void 0,he)}$provideDocumentRangesFormattingEdits(H,q,X,J,he){return this._withAdapter(H,B,we=>we.provideDocumentRangesFormattingEdits(u.URI.revive(q),X,J,he),void 0,he)}registerOnTypeFormattingEditProvider(H,q,X,J){const he=this._addNewAdapter(new ee(this._documents,X),H);return this._proxy.$registerOnTypeFormattingSupport(he,this._transformDocumentSelector(q,H),J,H.identifier),this._createDisposable(he)}$provideOnTypeFormattingEdits(H,q,X,J,he,we){return this._withAdapter(H,ee,Oe=>Oe.provideOnTypeFormattingEdits(u.URI.revive(q),X,J,he,we),void 0,we)}registerWorkspaceSymbolProvider(H,q){const X=this._addNewAdapter(new V(q,this._logService),H);return this._proxy.$registerNavigateTypeSupport(X,typeof q.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols(H,q,X){return this._withAdapter(H,V,J=>J.provideWorkspaceSymbols(q,X),{symbols:[]},X)}$resolveWorkspaceSymbol(H,q,X){return this._withAdapter(H,V,J=>J.resolveWorkspaceSymbol(q,X),void 0,void 0)}$releaseWorkspaceSymbols(H,q){this._withAdapter(H,V,X=>X.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(H,q,X){const J=this._addNewAdapter(new $(this._documents,X,this._logService),H);return this._proxy.$registerRenameSupport(J,this._transformDocumentSelector(q,H),$.supportsResolving(X)),this._createDisposable(J)}$provideRenameEdits(H,q,X,J,he){return this._withAdapter(H,$,we=>we.provideRenameEdits(u.URI.revive(q),X,J,he),void 0,he)}$resolveRenameLocation(H,q,X,J){return this._withAdapter(H,$,he=>he.resolveRenameLocation(u.URI.revive(q),X,J),void 0,J)}registerNewSymbolNamesProvider(H,q,X){const J=this._addNewAdapter(new G(this._documents,X,this._logService),H);return this._proxy.$registerNewSymbolNamesProvider(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$supportsAutomaticNewSymbolNamesTriggerKind(H){return this._withAdapter(H,G,q=>q.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(H,q,X,J,he){return this._withAdapter(H,G,we=>we.provideNewSymbolNames(u.URI.revive(q),X,J,he),void 0,he)}registerDocumentSemanticTokensProvider(H,q,X,J){const he=this._addNewAdapter(new le(this._documents,X),H),we=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(he,this._transformDocumentSelector(q,H),J,we);let Oe=this._createDisposable(he);if(we){const Ve=X.onDidChangeSemanticTokens(Ke=>this._proxy.$emitDocumentSemanticTokensEvent(we));Oe=s.Disposable.from(Oe,Ve)}return Oe}$provideDocumentSemanticTokens(H,q,X,J){return this._withAdapter(H,le,he=>he.provideDocumentSemanticTokens(u.URI.revive(q),X,J),null,J)}$releaseDocumentSemanticTokens(H,q){this._withAdapter(H,le,X=>X.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(H,q,X,J){const he=this._addNewAdapter(new ne(this._documents,X),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(he,this._transformDocumentSelector(q,H),J),this._createDisposable(he)}$provideDocumentRangeSemanticTokens(H,q,X,J){return this._withAdapter(H,ne,he=>he.provideDocumentRangeSemanticTokens(u.URI.revive(q),X,J),null,J)}registerCompletionItemProvider(H,q,X,J){const he=this._addNewAdapter(new _e(this._documents,this._commands.converter,X,this._apiDeprecation,H),H);return this._proxy.$registerCompletionsProvider(he,this._transformDocumentSelector(q,H),J,_e.supportsResolving(X),H.identifier),this._createDisposable(he)}$provideCompletionItems(H,q,X,J,he){return this._withAdapter(H,_e,we=>we.provideCompletionItems(u.URI.revive(q),X,J,he),void 0,he)}$resolveCompletionItem(H,q,X){return this._withAdapter(H,_e,J=>J.resolveCompletionItem(q,X),void 0,X)}$releaseCompletionItems(H,q){this._withAdapter(H,_e,X=>X.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(H,q,X,J){const he=new Y(H,this._documents,X,this._commands.converter),we=this._addNewAdapter(he,H);return this._proxy.$registerInlineCompletionsSupport(we,this._transformDocumentSelector(q,H),he.supportsHandleEvents,f.ExtensionIdentifier.toKey(H.identifier.value),J?.yieldTo?.map(Oe=>f.ExtensionIdentifier.toKey(Oe))||[]),this._createDisposable(we)}$provideInlineCompletions(H,q,X,J,he){return this._withAdapter(H,ge,we=>we.provideInlineCompletions(u.URI.revive(q),X,J,he),void 0,he)}$provideInlineEdits(H,q,X,J,he){return this._withAdapter(H,ge,we=>we.provideInlineEdits(u.URI.revive(q),X,J,he),void 0,he)}$handleInlineCompletionDidShow(H,q,X,J){this._withAdapter(H,ge,async he=>{he.handleDidShowCompletionItem(q,X,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(H,q,X,J,he){this._withAdapter(H,ge,async we=>{we.handlePartialAccept(q,X,J,he)},void 0,void 0)}$freeInlineCompletionsList(H,q){this._withAdapter(H,ge,async X=>{X.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(H,q,X){const J=new W(H,this._documents,X,this._commands.converter),he=this._addNewAdapter(J,H);return this._proxy.$registerInlineEditProvider(he,this._transformDocumentSelector(q,H),H.identifier),this._createDisposable(he)}$provideInlineEdit(H,q,X,J){return this._withAdapter(H,W,he=>he.provideInlineEdits(u.URI.revive(q),X,J),void 0,J)}$freeInlineEdit(H,q){this._withAdapter(H,W,async X=>{X.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(H,q,X,J){const he=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,we=this._addNewAdapter(new Se(this._documents,X),H);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(q,H),he),this._createDisposable(we)}$provideSignatureHelp(H,q,X,J,he){return this._withAdapter(H,Se,we=>we.provideSignatureHelp(u.URI.revive(q),X,J,he),void 0,he)}$releaseSignatureHelp(H,q){this._withAdapter(H,Se,X=>X.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(H,q,X){const J=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new te(this._documents,this._commands.converter,X,this._logService,H),H);this._proxy.$registerInlayHintsProvider(he,this._transformDocumentSelector(q,H),typeof X.resolveInlayHint=="function",J,De._extLabel(H));let we=this._createDisposable(he);if(J!==void 0){const Oe=X.onDidChangeInlayHints(Ve=>this._proxy.$emitInlayHintsEvent(J));we=s.Disposable.from(we,Oe)}return we}$provideInlayHints(H,q,X,J){return this._withAdapter(H,te,he=>he.provideInlayHints(u.URI.revive(q),X,J),void 0,J)}$resolveInlayHint(H,q,X){return this._withAdapter(H,te,J=>J.resolveInlayHint(q,X),void 0,X)}$releaseInlayHints(H,q){this._withAdapter(H,te,X=>X.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(H,q,X){const J=this._addNewAdapter(new ae(this._documents,X),H);return this._proxy.$registerDocumentLinkProvider(J,this._transformDocumentSelector(q,H),typeof X.resolveDocumentLink=="function"),this._createDisposable(J)}$provideDocumentLinks(H,q,X){return this._withAdapter(H,ae,J=>J.provideLinks(u.URI.revive(q),X),void 0,X,q.scheme==="output")}$resolveDocumentLink(H,q,X){return this._withAdapter(H,ae,J=>J.resolveLink(q,X),void 0,void 0,!0)}$releaseDocumentLinks(H,q){this._withAdapter(H,ae,X=>X.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(H,q,X){const J=this._addNewAdapter(new se(this._documents,X),H);return this._proxy.$registerDocumentColorProvider(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$provideDocumentColors(H,q,X){return this._withAdapter(H,se,J=>J.provideColors(u.URI.revive(q),X),[],X)}$provideColorPresentations(H,q,X,J){return this._withAdapter(H,se,he=>he.provideColorPresentations(u.URI.revive(q),X,J),void 0,J)}registerFoldingRangeProvider(H,q,X){const J=this._nextHandle(),he=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(J,new ke(new Q(this._documents,X),H)),this._proxy.$registerFoldingRangeProvider(J,this._transformDocumentSelector(q,H),H.identifier,he);let we=this._createDisposable(J);if(he!==void 0){const Oe=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(he));we=s.Disposable.from(we,Oe)}return we}$provideFoldingRanges(H,q,X,J){return this._withAdapter(H,Q,he=>he.provideFoldingRanges(u.URI.revive(q),X,J),void 0,J)}registerSelectionRangeProvider(H,q,X){const J=this._addNewAdapter(new re(this._documents,X,this._logService),H);return this._proxy.$registerSelectionRangeProvider(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$provideSelectionRanges(H,q,X,J){return this._withAdapter(H,re,he=>he.provideSelectionRanges(u.URI.revive(q),X,J),[],J)}registerCallHierarchyProvider(H,q,X){const J=this._addNewAdapter(new ve(this._documents,X),H);return this._proxy.$registerCallHierarchyProvider(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$prepareCallHierarchy(H,q,X,J){return this._withAdapter(H,ve,he=>Promise.resolve(he.prepareSession(u.URI.revive(q),X,J)),void 0,J)}$provideCallHierarchyIncomingCalls(H,q,X,J){return this._withAdapter(H,ve,he=>he.provideCallsTo(q,X,J),void 0,J)}$provideCallHierarchyOutgoingCalls(H,q,X,J){return this._withAdapter(H,ve,he=>he.provideCallsFrom(q,X,J),void 0,J)}$releaseCallHierarchy(H,q){this._withAdapter(H,ve,X=>Promise.resolve(X.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(H,q,X){const J=this._addNewAdapter(new be(this._documents,X),H);return this._proxy.$registerTypeHierarchyProvider(J,this._transformDocumentSelector(q,H)),this._createDisposable(J)}$prepareTypeHierarchy(H,q,X,J){return this._withAdapter(H,be,he=>Promise.resolve(he.prepareSession(u.URI.revive(q),X,J)),void 0,J)}$provideTypeHierarchySupertypes(H,q,X,J){return this._withAdapter(H,be,he=>he.provideSupertypes(q,X,J),void 0,J)}$provideTypeHierarchySubtypes(H,q,X,J){return this._withAdapter(H,be,he=>he.provideSubtypes(q,X,J),void 0,J)}$releaseTypeHierarchy(H,q){this._withAdapter(H,be,X=>Promise.resolve(X.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(H,q,X,J){const he=this._nextHandle();return this._adapter.set(he,new ke(new Fe(this._proxy,this._documents,X,he,H),H)),this._proxy.$registerDocumentOnDropEditProvider(he,this._transformDocumentSelector(q,H),(0,t.isProposedApiEnabled)(H,"documentPaste")&&J?{supportsResolve:!!X.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this._createDisposable(he)}$provideDocumentOnDropEdits(H,q,X,J,he,we){return this._withAdapter(H,Fe,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(q,u.URI.revive(X),J,he,we)),void 0,void 0)}$resolveDropEdit(H,q,X){return this._withAdapter(H,Fe,J=>J.resolveDropEdit(q,X),{},void 0)}$releaseDocumentOnDropEdits(H,q){this._withAdapter(H,Fe,X=>Promise.resolve(X.releaseDropEdits(q)),void 0,void 0)}registerMappedEditsProvider(H,q,X){const J=this._addNewAdapter(new Be(this._documents,X),H);return this._proxy.$registerMappedEditsProvider(J,this._transformDocumentSelector(q,H),H.displayName??H.name),this._createDisposable(J)}$provideMappedEdits(H,q,X,J,he){return this._withAdapter(H,Be,we=>Promise.resolve(we.provideMappedEdits(q,X,J,he)),null,he)}registerDocumentPasteEditProvider(H,q,X,J){const he=this._nextHandle();return this._adapter.set(he,new ke(new x(this._proxy,this._documents,X,he,H),H)),this._proxy.$registerPasteEditProvider(he,this._transformDocumentSelector(q,H),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this._createDisposable(he)}$prepareDocumentPaste(H,q,X,J,he){return this._withAdapter(H,x,we=>we.prepareDocumentPaste(u.URI.revive(q),X,J,he),void 0,he)}$providePasteEdits(H,q,X,J,he,we,Oe){return this._withAdapter(H,x,Ve=>Ve.providePasteEdits(q,u.URI.revive(X),J,he,we,Oe),void 0,Oe)}$resolvePasteEdit(H,q,X){return this._withAdapter(H,x,J=>J.resolvePasteEdit(q,X),{},void 0)}$releasePasteEdits(H,q){this._withAdapter(H,x,X=>Promise.resolve(X.releasePasteEdits(q)),void 0,void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:H.flags}}static _serializeIndentationRule(H){return{decreaseIndentPattern:De._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:De._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?De._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?De._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:De._serializeRegExp(H.beforeText),afterText:H.afterText?De._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?De._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(De._serializeOnEnterRule)}static _serializeAutoClosingPair(H){return{open:H.open,close:H.close,notIn:H.notIn?H.notIn.map(q=>s.SyntaxTokenType.toString(q)):void 0}}static _serializeAutoClosingPairs(H){return H.map(De._serializeAutoClosingPair)}setLanguageConfiguration(H,q,X){const{wordPattern:J}=X;if(J&&(0,I.regExpLeadsToEndlessLoop)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this._documents.setWordDefinitionFor(q,J):this._documents.setWordDefinitionFor(q,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const he=this._nextHandle(),we={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?De._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?De._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?De._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?De._serializeAutoClosingPairs(X.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(he,q,we),this._createDisposable(he)}$setWordDefinitions(H){for(const q of H)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=De}),define(Ce[305],Ie([1,0,3,44,6,15]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModelTools=void 0,k=$e(k);class L{constructor(v){this._registeredTools=new Map,this._allTools=new Map,this._proxy=v.getProxy(P.MainContext.MainThreadLanguageModelTools),this._proxy.$getTools().then(l=>{for(const I of l)this._allTools.set(I.name,(0,d.revive)(I))})}async invokeTool(v,l,I){return await this._proxy.$invokeTool(v,l,I)}async $acceptToolDelta(v){v.added&&this._allTools.set(v.added.name,v.added),v.removed&&this._allTools.delete(v.removed)}get tools(){return Array.from(this._allTools.values()).map(v=>k.LanguageModelToolDescription.to(v))}async $invokeTool(v,l,I){const y=this._registeredTools.get(v);if(!y)throw new Error(`Unknown tool ${v}`);return await y.tool.invoke(l,I)}registerTool(v,l,I){return this._registeredTools.set(l,{extension:v,tool:I}),this._proxy.$registerTool(l),(0,r.toDisposable)(()=>{this._registeredTools.delete(l),this._proxy.$unregisterTool(l)})}}e.ExtHostLanguageModelTools=L}),define(Ce[128],Ie([1,0,7,20,52,13,4,39,3,8,23,5,11,89,6,127,19,15,9,156,25]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,p=$e(p),f=$e(f),e.IExtHostLanguageModels=(0,y.createDecorator)("IExtHostLanguageModels");class o{constructor(g,w){this.option=g,this.stream=new r.AsyncIterableSource,this.stream=w??new r.AsyncIterableSource}}class n{constructor(){this._responseStreams=new Map,this._defaultStream=new r.AsyncIterableSource,this._isDone=!1;const g=this;this.apiObject={get stream(){return g._defaultStream.asyncIterable},get text(){return r.AsyncIterableObject.map(g._defaultStream.asyncIterable,w=>{if(w instanceof f.LanguageModelTextPart)return w.value}).coalesce()}}}*_streams(){if(this._responseStreams.size>0)for(const[,g]of this._responseStreams)yield g.stream;else yield this._defaultStream}handleFragment(g){if(this._isDone)return;let w=this._responseStreams.get(g.index);w||(this._responseStreams.size===0?w=new o(g.index,this._defaultStream):w=new o(g.index),this._responseStreams.set(g.index,w));let D;g.part.type==="text"?D=new f.LanguageModelTextPart(g.part.value):D=new f.LanguageModelFunctionUsePart(g.part.name,g.part.parameters),w.stream.emitOne(D)}reject(g){this._isDone=!0;for(const w of this._streams())w.reject(g)}resolve(){this._isDone=!0;for(const g of this._streams())g.resolve()}}let h=class{static{t=this}static{this._idPool=1}constructor(g,w,D){this._logService=w,this._extHostAuthentication=D,this._onDidChangeModelAccess=new L.Emitter,this._onDidChangeProviders=new L.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new I.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=g.getProxy(b.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(g,w,D,_){const C=t._idPool++;this._languageModels.set(C,{extension:g.identifier,provider:D,languageModelId:w});let A;_.auth&&(A={providerLabel:g.displayName||g.name,accountLabel:typeof _.auth=="object"?_.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(C,`${I.ExtensionIdentifier.toKey(g.identifier)}/${C}/${w}`,{extension:g.identifier,id:w,vendor:_.vendor??I.ExtensionIdentifier.toKey(g.identifier),name:_.name??"",family:_.family??"",version:_.version,maxInputTokens:_.maxInputTokens,maxOutputTokens:_.maxOutputTokens,auth:A,targetExtensions:_.extensions});const E=D.onDidReceiveLanguageModelResponse2?.(({extensionId:S,participant:F,tokenCount:N})=>{this._proxy.$whenLanguageModelChatRequestMade(w,new I.ExtensionIdentifier(S),F,N)});return(0,v.toDisposable)(()=>{this._languageModels.delete(C),this._proxy.$unregisterProvider(C),E?.dispose()})}async $startChatRequest(g,w,D,_,C,A){const E=this._languageModels.get(g);if(!E)throw new Error("Provider not found");const S=new T.Progress(async N=>{if(A.isCancellationRequested){this._logService.warn(`[CHAT](${E.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let O;if(N.part instanceof f.LanguageModelFunctionUsePart?O={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof f.LanguageModelTextPart&&(O={type:"text",value:N.part.value}),!O){this._logService.warn(`[CHAT](${E.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this._proxy.$reportResponsePart(w,{index:N.index,part:O})});let F;if(E.provider.provideLanguageModelResponse2)F=Promise.resolve(E.provider.provideLanguageModelResponse2(_.map(p.LanguageModelChatMessage.to),C,I.ExtensionIdentifier.toKey(D),S,A));else{const N=new T.Progress(async O=>{S.report({index:O.index,part:new f.LanguageModelTextPart(O.part)})});F=Promise.resolve(E.provider.provideLanguageModelResponse(_.map(p.LanguageModelChatMessage.to),C?.modelOptions??{},I.ExtensionIdentifier.toKey(D),N,A))}F.then(()=>{this._proxy.$reportResponseDone(w,void 0)},N=>{this._proxy.$reportResponseDone(w,(0,k.transformErrorForSerialization)(N))})}$provideTokenLength(g,w,D){const _=this._languageModels.get(g);return _?Promise.resolve(_.provider.provideTokenCount(w,D)):Promise.resolve(0)}$acceptChatModelMetadata(g){if(g.added)for(const{identifier:w,metadata:D}of g.added)this._allLanguageModelData.set(w,{metadata:D,apiObjects:new I.ExtensionIdentifierMap});if(g.removed)for(const w of g.removed){this._allLanguageModelData.delete(w);for(const[D,_]of this._pendingRequest)_.languageModelId===w&&(_.res.reject(new k.CancellationError),this._pendingRequest.delete(D))}g.added?.forEach(w=>this._fakeAuthPopulate(w.metadata)),this._onDidChangeProviders.fire(void 0)}async selectLanguageModels(g,w){const D=await this._proxy.$selectChatModels({...w,extension:g.identifier}),_=[],C=this;for(const A of D){const E=this._allLanguageModelData.get(A);if(!E)continue;this._isUsingAuth(g.identifier,E.metadata)&&await this._fakeAuthPopulate(E.metadata);let S=E.apiObjects.get(g.identifier);S||(S={id:A,vendor:E.metadata.vendor,family:E.metadata.family,version:E.metadata.version,name:E.metadata.name,maxInputTokens:E.metadata.maxInputTokens,countTokens(F,N){if(!C._allLanguageModelData.has(A))throw f.LanguageModelError.NotFound(A);return C._computeTokenLength(A,F,N??d.CancellationToken.None)},sendRequest(F,N,O){if(!C._allLanguageModelData.has(A))throw f.LanguageModelError.NotFound(A);return C._sendChatRequest(g,A,F,N??{},O??d.CancellationToken.None)}},Object.freeze(S),E.apiObjects.set(g.identifier,S)),_.push(S)}return _}async _sendChatRequest(g,w,D,_,C){const A=this._convertMessages(g,D),E=g.identifier,S=this._allLanguageModelData.get(w)?.metadata;if(!S||!this._allLanguageModelData.has(w))throw f.LanguageModelError.NotFound(`Language model '${w}' is unknown.`);if(this._isUsingAuth(E,S)&&(!await this._getAuthAccess(g,{identifier:S.extension,displayName:S.auth.providerLabel},_.justification,!1)||!this._modelAccessList.get(E)?.has(S.extension)))throw f.LanguageModelError.NoPermissions(`Language model '${w}' cannot be used by '${E.value}'.`);try{const F=Math.random()*1e6|0,N=new n;this._pendingRequest.set(F,{languageModelId:w,res:N});try{await this._proxy.$tryStartChatRequest(E,w,F,A,_,C)}catch(O){throw this._pendingRequest.delete(F),O}return N.apiObject}catch(F){throw F.name===f.LanguageModelError.name?F:new f.LanguageModelError(`Language model '${w}' errored: ${(0,P.toErrorMessage)(F)}`,"Unknown",F)}}_convertMessages(g,w){const D=[];for(const _ of w)_.role===f.LanguageModelChatMessageRole.System&&(0,s.checkProposedApiEnabled)(g,"languageModelSystem"),_.content2 instanceof f.LanguageModelFunctionResultPart&&(0,s.checkProposedApiEnabled)(g,"lmTools"),D.push(p.LanguageModelChatMessage.from(_));return D}async $acceptResponsePart(g,w){const D=this._pendingRequest.get(g);D&&D.res.handleFragment(w)}async $acceptResponseDone(g,w){const D=this._pendingRequest.get(g);D&&(this._pendingRequest.delete(g),w?D.res.reject((0,k.transformErrorFromSerialization)(w)):D.res.resolve())}async _getAuthAccess(g,w,D,_){const C=i.INTERNAL_AUTH_PROVIDER_PREFIX+w.identifier.value;if(await this._extHostAuthentication.getSession(g,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:g.identifier,to:w.identifier,enabled:!0}]),!0;if(_)return!1;try{const E=D?(0,l.localize)(10833,null,w.displayName,D):void 0;return await this._extHostAuthentication.getSession(g,C,[],{forceNewSession:{detail:E}}),this.$updateModelAccesslist([{from:g.identifier,to:w.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(g,w){return!!w.auth&&!I.ExtensionIdentifier.equals(w.extension,g)}async _fakeAuthPopulate(g){if(g.auth)for(const w of this._languageAccessInformationExtensions)try{await this._getAuthAccess(w,{identifier:g.extension,displayName:""},void 0,!0)}catch(D){this._logService.error("Fake Auth request failed"),this._logService.error(D)}}async _computeTokenLength(g,w,D){if(!this._allLanguageModelData.get(g))throw f.LanguageModelError.NotFound(`Language model '${g}' is unknown.`);const C=R.Iterable.find(this._languageModels.values(),A=>A.languageModelId===g);return C?C.provider.provideTokenCount(w,D):this._proxy.$countTokens(g,typeof w=="string"?w:p.LanguageModelChatMessage.from(w),D)}$updateModelAccesslist(g){const w=new Array;for(const{from:D,to:_,enabled:C}of g){const A=this._modelAccessList.get(D)??new I.ExtensionIdentifierSet;if(A.has(_)!==C){C?A.add(_):A.delete(_),this._modelAccessList.set(D,A);const S={from:D,to:_};w.push(S),this._onDidChangeModelAccess.fire(S)}}}createLanguageModelAccessInformation(g){this._languageAccessInformationExtensions.add(g);const w=this,D=L.Event.signal(L.Event.filter(this._onDidChangeModelAccess.event,C=>I.ExtensionIdentifier.equals(C.from,g.identifier))),_=L.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return L.Event.any(D,_)},canSendRequest(C){let A;e:for(const[S,F]of w._allLanguageModelData)for(const N of F.apiObjects.values())if(N===C){A=F.metadata;break e}if(!A)return;if(!w._isUsingAuth(g.identifier,A))return!0;const E=w._modelAccessList.get(g.identifier);if(E)return E.has(A.extension)}}}};e.ExtHostLanguageModels=h,e.ExtHostLanguageModels=h=t=Xe([He(0,m.IExtHostRpcService),He(1,u.ILogService),He(2,a.IExtHostAuthentication)],h)});var Wt=this&&this.__importDefault||function(pe){return pe&&pe.__esModule?pe:{default:pe}};define(Ce[306],Ie([1,0,6,15,9,43,7,3,25]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0,d=$e(d),k=Wt(k);class l{constructor(y,u,T,b){this._documents=u,this._commands=T,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=y.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(y){this._languageIds=y}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(y,u){await this._proxy.$changeLanguage(y,u);const T=this._documents.getDocumentData(y);if(!T)throw new Error(`document '${y.toString()}' NOT found`);return T.document}async tokenAtPosition(y,u){const T=y.version,b=d.Position.from(u),a=await this._proxy.$tokensAtPosition(y.uri,b),m={type:P.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new P.Range(u.line,u.character,u.line,u.character)};if(!a)return m;const p={range:d.Range.to(a.range),type:d.TokenType.to(a.type)};return!p.range.contains(u)||T!==y.version?m:p}createLanguageStatusItem(y,u,T){const b=this._handlePool++,a=this._proxy,m=this._ids,p=`${y.identifier.value}/${u}`;if(m.has(p))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);m.add(p);const f={selector:T,id:u,name:y.displayName??y.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new R.DisposableStore,t=()=>{if(i?.dispose(),!m.has(p)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,L.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(b,{id:p,name:f.name??y.displayName??y.name,source:y.displayName??y.name,selector:d.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===P.LanguageStatusSeverity.Error?k.default.Error:f.severity===P.LanguageStatusSeverity.Warning?k.default.Warning:k.default.Info,command:f.command&&this._commands.toInternal(f.command,s),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},o={dispose(){s.dispose(),i?.dispose(),a.$removeLanguageStatus(b),m.delete(p)},get id(){return f.id},get name(){return f.name},set name(n){f.name=n,t()},get selector(){return f.selector},set selector(n){f.selector=n,t()},get text(){return f.text},set text(n){f.text=n,t()},set text2(n){(0,v.checkProposedApiEnabled)(y,"languageStatusText"),f.text=n,t()},get text2(){return(0,v.checkProposedApiEnabled)(y,"languageStatusText"),f.text},get detail(){return f.detail},set detail(n){f.detail=n,t()},get severity(){return f.severity},set severity(n){f.severity=n,t()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(n){f.accessibilityInformation=n,t()},get command(){return f.command},set command(n){f.command=n,t()},get busy(){return f.busy},set busy(n){f.busy=n,t()}};return t(),o}}e.ExtHostLanguages=l}),define(Ce[307],Ie([1,0,14,2,15,9,126]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0,P=$e(P),L=$e(L);class R{constructor(y,u,T,b){this.start=y,this.deletedCount=u,this.deletedItems=T,this.items=b}asApiEvent(){return{range:new k.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class v{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,T){this.notebook=y,this._extHostDocument=u,this._cellData=T,this.handle=T.handle,this.uri=d.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,u=this._extHostDocument.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:u.document,get mime(){return y._mime},set mime(b){y._mime=b},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(y){this._outputs=y.map(P.NotebookCellOutput.to)}setOutputItems(y,u,T){const b=T.map(P.NotebookCellOutputItem.to),a=this._outputs.find(m=>m.id===y);if(a&&(u||(a.items.length=0),a.items.push(...b),a.items.length>1&&a.items.every(m=>L.isTextStreamMime(m.mime)))){const m=new Map,p=[];a.items.forEach(f=>{let i;m.has(f.mime)?i=m.get(f.mime):(i=[],m.set(f.mime,i),p.push(f.mime)),i.push(f.data)}),a.items.length=0,p.forEach(f=>{const i=L.compressOutputItemStreams(m.get(f));a.items.push({mime:f,data:i.data.buffer})})}}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=v;class l{static{this._handlePool=0}constructor(y,u,T,b,a){this._proxy=y,this._textDocumentsAndEditors=u,this._textDocuments=T,this.uri=b,this.handle=l._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=a.viewType,this._metadata=Object.freeze(a.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,a.cells]],!0,void 0),this._versionId=a.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const y=this,u={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===r.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(T){return T=y._validateIndex(T),y._cells[T].apiCell},getCells(T){return(T?y._getCells(T):y._cells).map(a=>a.apiCell)},save(){return y._save()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this._notebook=Object.freeze(u)}return this._notebook}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,u,T){this._versionId=y.versionId,this._isDirty=u,this.acceptDocumentPropertiesChanged({metadata:T});const b={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},a=[];for(const p of y.rawEvents)p.kind===L.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(p.changes,!1,b.contentChanges):p.kind===L.NotebookCellsChangeType.Move?this._moveCells(p.index,p.length,p.newIdx,b.contentChanges):p.kind===L.NotebookCellsChangeType.Output?(this._setCellOutputs(p.index,p.outputs),a.push({cell:this._cells[p.index].apiCell,outputs:this._cells[p.index].apiCell.outputs})):p.kind===L.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(p.index,p.outputId,p.append,p.outputItems),a.push({cell:this._cells[p.index].apiCell,outputs:this._cells[p.index].apiCell.outputs})):p.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(p.index,p.language),a.push({cell:this._cells[p.index].apiCell,document:this._cells[p.index].apiCell.document})):p.kind===L.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this._cells[p.index].apiCell,document:this._cells[p.index].apiCell.document}):p.kind===L.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(p.index,p.mime):p.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(p.index,p.metadata),a.push({cell:this._cells[p.index].apiCell,metadata:this._cells[p.index].apiCell.metadata})):p.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(p.index,p.internalMetadata),a.push({cell:this._cells[p.index].apiCell,executionSummary:this._cells[p.index].apiCell.executionSummary}));const m=new Map;for(let p=0;p<a.length;p++){const f=a[p],i=m.get(f.cell);if(i===void 0){const s=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});m.set(f.cell,s-1)}else b.cellChanges[i]={...b.cellChanges[i],...f}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let u=y.start|0,T=y.end|0;return u<0&&(u=0),T>this._cells.length&&(T=this._cells.length),y.with({start:u,end:T})}_getCells(y){y=this._validateRange(y);const u=[];for(let T=y.start;T<y.end;T++)u.push(this._cells[T]);return u}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,u,T){if(this._disposed)return;const b=[],a=[],m=[];if(y.reverse().forEach(p=>{const i=p[2].map(o=>{const n=new v(this,this._textDocumentsAndEditors,o);return u||a.push(v.asModelAddData(o)),n}),s=new R(p[0],p[1],[],i),t=this._cells.splice(p[0],p[1],...i);for(const o of t)m.push(o.uri),s.deletedItems.push(o.apiCell);b.push(s)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),T)for(const p of b)T.push(p.asApiEvent())}_moveCells(y,u,T,b){const a=this._cells.splice(y,u);this._cells.splice(T,0,...a);const m=[new R(y,u,a.map(p=>p.apiCell),[]),new R(T,0,[],a)];for(const p of m)b.push(p.asApiEvent())}_setCellOutputs(y,u){this._cells[y].setOutputs(u)}_setCellOutputItems(y,u,T,b){this._cells[y].setOutputItems(u,T,b)}_changeCellLanguage(y,u){const T=this._cells[y];T.apiCell.document.languageId!==u&&this._textDocuments.$acceptModelLanguageChanged(T.uri,u)}_changeCellMime(y,u){const T=this._cells[y];T.apiCell.mime=u}_changeCellMetadata(y,u){this._cells[y].setMetadata(u)}_changeCellInternalMetadata(y,u){this._cells[y].setInternalMetadata(u)}getCellFromApiCell(y){return this._cells.find(u=>u.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(u=>u.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=l}),define(Ce[308],Ie([1,0,4,2,15,9,53]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(l,I,y,u={timeout:1500,errors:3}){this._logService=l,this._notebooksAndEditors=I,this._mainThreadBulkEdits=y,this._thresholds=u,this._onWillSaveNotebookDocumentEvent=new r.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(l){return(I,y,u)=>{const T=function(a){I.call(y,a)};return T.extension=l,this._onWillSaveNotebookDocumentEvent.event(T,void 0,u)}}async $participateInSave(l,I,y){const u=d.URI.revive(l),T=this._notebooksAndEditors.getNotebookDocument(u);if(!T)throw new Error("Unable to resolve notebook document");const b=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:T.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},y,async(m,p)=>{const f=Date.now(),i=await await Promise.resolve(m);Date.now()-f>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",p.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof k.WorkspaceEdit?b.push(i):this._logService.warn("onWillSaveNotebookDocument-listener from extension",p.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(b.length===0)return!0;const a={edits:[]};for(const m of b){const{edits:p}=P.WorkspaceEdit.from(m);a.edits=a.edits.concat(p)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new L.SerializableObjectWithBuffers(a))}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(Ce[165],Ie([1,0,13,15,9]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0,d=$e(d),P=$e(P);class k{static{this.apiEditorsToExtHost=new WeakMap}constructor(R,v,l,I,y,u){this.id=R,this._proxy=v,this.notebookData=l,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=y,this._visibleRanges=I,this._viewColumn=u}get apiEditor(){if(!this._editor){const R=this;this._editor={get notebook(){return R.notebookData.apiNotebook},get selection(){return R._selections[0]},set selection(v){this.selections=[v]},get selections(){return R._selections},set selections(v){if(!Array.isArray(v)||!v.every(P.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");R._selections=v,R._trySetSelections(v)},get visibleRanges(){return R._visibleRanges},revealRange(v,l){R._proxy.$tryRevealRange(R.id,d.NotebookRange.from(v),l??P.NotebookEditorRevealType.Default)},get viewColumn(){return R._viewColumn},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(R){this._visible=R}_acceptVisibleRanges(R){this._visibleRanges=R}_acceptSelections(R){this._selections=R}_trySetSelections(R){this._proxy.$trySetSelections(this.id,R.map(d.NotebookRange.from))}_acceptViewColumn(R){this._viewColumn=R}}e.ExtHostNotebookEditor=k}),define(Ce[309],Ie([1,0,4,11,15]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0,P=$e(P);let k=class{constructor(R,v){this._logService=R,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(R,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,v);const l=this._notebooksAndEditors.getEditorById(R);v.visibleRanges&&l._acceptVisibleRanges(v.visibleRanges.ranges.map(P.NotebookRange.to)),v.selections&&l._acceptSelections(v.selections.selections.map(P.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:l.apiEditor,visibleRanges:l.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:l.apiEditor,selections:l.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const v in R)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(P.ViewColumn.to(R[v]))}};e.ExtHostNotebookEditors=k,e.ExtHostNotebookEditors=k=Xe([He(0,d.ILogService)],k)}),define(Ce[310],Ie([1,0,4,6,165]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(R,v){this._extHostNotebook=v,this._rendererMessageEmitters=new Map,this.proxy=R.getProxy(d.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,v,l){const I=this._extHostNotebook.getEditorById(R);this._rendererMessageEmitters.get(v)?.fire({editor:I.apiEditor,message:l})}createRendererMessaging(R,v){if(!R.contributes?.notebookRenderer?.some(I=>I.id===v))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${v})`);return{onDidReceiveMessage:(I,y,u)=>this.getOrCreateEmitterFor(v).event(I,y,u),postMessage:(I,y)=>{P.ExtHostNotebookEditor.apiEditorsToExtHost.has(I)&&([I,y]=[y,I]);const u=y&&P.ExtHostNotebookEditor.apiEditorsToExtHost.get(y);return this.proxy.$postMessage(u?.id,v,I)}}}getOrCreateEmitterFor(R){let v=this._rendererMessageEmitters.get(R);return v||(v=new r.Emitter({onDidRemoveLastListener:()=>{v?.dispose(),this._rendererMessageEmitters.delete(R)}}),this._rendererMessageEmitters.set(R,v),v)}}e.ExtHostNotebookRenderers=k}),define(Ce[311],Ie([1,0,15,89,20,59,13]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class R{constructor(y){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=y}async withProgress(y,u,T){const b=this._handles++,{title:a,location:m,cancellable:p}=u,f={label:y.displayName||y.name,id:y.identifier.value};return this._proxy.$startProgress(b,{location:r.ProgressLocation.from(m),title:a,source:f,cancellable:p},y.isUnderDevelopment?void 0:y.identifier.value).catch(L.onUnexpectedExternalError),this._withProgress(b,T,!!p)}_withProgress(y,u,T){let b;T&&(b=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(y,b));const a=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),b?.dispose()};let m;try{m=u(new l(this._proxy,y),T&&b?b.token:P.CancellationToken.None)}catch(p){throw a(y),p}return m.then(p=>a(y),p=>a(y)),m}$acceptProgressCanceled(y){const u=this._mapHandleToCancellationSource.get(y);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(y))}}e.ExtHostProgress=R;function v(I,y){return I.message=y.message,typeof y.increment=="number"&&(typeof I.increment=="number"?I.increment+=y.increment:I.increment=y.increment),I}class l extends d.Progress{constructor(y,u){super(T=>this.throttledReport(T)),this._proxy=y,this._handle=u}throttledReport(y){this._proxy.$progressReport(this._handle,y)}}Xe([(0,k.throttle)(100,(I,y)=>v(I,y),()=>Object.create(null))],l.prototype,"throttledReport",null)}),define(Ce[312],Ie([1,0,2,6,7,15]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class L{static{this.handlePool=0}constructor(v,l){this.uriTransformer=l,this.providers=new Map,this.proxy=v.getProxy(d.MainContext.MainThreadQuickDiff)}$provideOriginalResource(v,l,I){const y=r.URI.revive(l),u=this.providers.get(v);return u?(0,P.asPromise)(()=>u.provideOriginalResource(y,I)).then(T=>T||null):Promise.resolve(null)}registerQuickDiffProvider(v,l,I,y){const u=L.handlePool++;return this.providers.set(u,l),this.proxy.$registerQuickDiffProvider(u,k.DocumentSelector.from(v,this.uriTransformer),I,y),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(u),this.providers.delete(u)}}}}e.ExtHostQuickDiff=L});var Wt=this&&this.__importDefault||function(pe){return pe&&pe.__esModule?pe:{default:pe}};define(Ce[313],Ie([1,0,20,4,3,6,2,9,13,18,43,51,25,15]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=b,I=Wt(I);function b(a,m,p){const f=a.getProxy(k.MainContext.MainThreadQuickOpen);class i{constructor(D,_){this._sessions=new Map,this._instances=0,this._workspace=D,this._commands=_}showQuickPick(D,_,C,A=r.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(_),S=++this._instances,F=f.$show(S,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},A),N={},O=F.then(()=>N);return Promise.race([O,E]).then(M=>{if(M===N)return;const U=(0,u.isProposedApiEnabled)(D,"quickPickItemTooltip");return E.then(x=>{const z=[];for(let B=0;B<x.length;B++){const ee=x[B];if(typeof ee=="string")z.push({label:ee,handle:B});else if(ee.kind===R.QuickPickItemKind.Separator)z.push({type:"separator",label:ee.label});else{ee.tooltip&&!U&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const V=ee.iconPath?h(ee.iconPath):void 0;z.push({label:ee.label,iconPath:V?.iconPath,iconClass:V?.iconClass,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:U?T.MarkdownString.fromStrict(ee.tooltip):void 0,handle:B})}}return C&&typeof C.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{C.onDidSelectItem(x[B])}),f.$setItems(S,z),F.then(B=>{if(typeof B=="number")return x[B];if(Array.isArray(B))return B.map(ee=>x[ee])})})}).then(void 0,M=>{if(!(0,v.isCancellationError)(M))return f.$setError(S,M),Promise.reject(M)})}$onItemSelected(D){this._onDidSelectItem?.(D)}showInput(D,_=r.CancellationToken.None){return this._validateInput=D?.validateInput,f.$input(D,typeof this._validateInput=="function",_).then(void 0,C=>{if(!(0,v.isCancellationError)(C))return Promise.reject(C)})}async $validateInput(D){if(!this._validateInput)return;const _=await this._validateInput(D);if(!_||typeof _=="string")return _;let C;switch(_.severity){case R.InputBoxValidationSeverity.Info:C=I.default.Info;break;case R.InputBoxValidationSeverity.Warning:C=I.default.Warning;break;case R.InputBoxValidationSeverity.Error:C=I.default.Error;break;default:C=_.message?I.default.Error:I.default.Ignore;break}return{content:_.message,severity:C}}async showWorkspaceFolderPick(D,_=r.CancellationToken.None){const C=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!C)return;const A=await this._workspace.getWorkspaceFolders2();if(A)return A.find(E=>E.uri.toString()===C.uri.toString())}createQuickPick(D){const _=new c(D,()=>this._sessions.delete(_._id));return this._sessions.set(_._id,_),_}createInputBox(D){const _=new g(D,()=>this._sessions.delete(_._id));return this._sessions.set(_._id,_),_}$onDidChangeValue(D,_){this._sessions.get(D)?._fireDidChangeValue(_)}$onDidAccept(D){this._sessions.get(D)?._fireDidAccept()}$onDidChangeActive(D,_){const C=this._sessions.get(D);C instanceof c&&C._fireDidChangeActive(_)}$onDidChangeSelection(D,_){const C=this._sessions.get(D);C instanceof c&&C._fireDidChangeSelection(_)}$onDidTriggerButton(D,_){this._sessions.get(D)?._fireDidTriggerButton(_)}$onDidTriggerItemButton(D,_,C){const A=this._sessions.get(D);A instanceof c&&A._fireDidTriggerItemButton(_,C)}$onDidHide(D){this._sessions.get(D)?._fireDidHide()}}class s{static{this._nextId=1}constructor(D,_){this._extension=D,this._onDidDispose=_,this._id=c._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new d.Emitter,this._onDidChangeValueEmitter=new d.Emitter,this._onDidTriggerButtonEmitter=new d.Emitter,this._onDidHideEmitter=new d.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(D){this._title=D,this.update({title:D})}get step(){return this._steps}set step(D){this._steps=D,this.update({step:D})}get totalSteps(){return this._totalSteps}set totalSteps(D){this._totalSteps=D,this.update({totalSteps:D})}get enabled(){return this._enabled}set enabled(D){this._enabled=D,this.update({enabled:D})}get busy(){return this._busy}set busy(D){this._busy=D,this.update({busy:D})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(D){this._ignoreFocusOut=D,this.update({ignoreFocusOut:D})}get value(){return this._value}set value(D){this._value=D,this.update({value:D})}get placeholder(){return this._placeholder}set placeholder(D){this._placeholder=D,this.update({placeholder:D})}get buttons(){return this._buttons}set buttons(D){const _=(0,u.isProposedApiEnabled)(this._extension,"quickInputButtonLocation");!_&&D.some(C=>C.location)&&console.warn(`Extension '${this._extension.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this._extension.identifier.value}`),this._buttons=D.slice(),this._handlesToButtons.clear(),D.forEach((C,A)=>{const E=C===R.QuickInputButtons.Back?-1:A;this._handlesToButtons.set(E,C)}),this.update({buttons:D.map((C,A)=>({...h(C.iconPath),tooltip:C.tooltip,handle:C===R.QuickInputButtons.Back?-1:A,location:_?C.location:void 0}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(D){this._value=D,this._onDidChangeValueEmitter.fire(D)}_fireDidTriggerButton(D){const _=this._handlesToButtons.get(D);_&&this._onDidTriggerButtonEmitter.fire(_)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),f.$dispose(this._id))}update(D){if(!this._disposed){for(const _ of Object.keys(D)){const C=D[_];this._pendingUpdate[_]=C===void 0?null:C}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){f.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function t(w){if(w instanceof R.ThemeIcon)return{id:w.id};const D=n(w),_=o(w);return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof _=="string"?L.URI.file(_):_}}function o(w){return typeof w=="object"&&"light"in w?w.light:w}function n(w){return typeof w=="object"&&"dark"in w?w.dark:w}function h(w){const D=t(w);let _,C;return"id"in D?C=y.ThemeIcon.asClassName(D):_=D,{iconPath:_,iconClass:C}}class c extends s{constructor(D,_){super(D,_),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new d.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new d.Emitter,this._onDidTriggerItemButtonEmitter=new d.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(D){this._items=D.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),D.forEach((A,E)=>{this._handlesToItems.set(E,A),this._itemsToHandles.set(A,E)});const _=(0,u.isProposedApiEnabled)(this._extension,"quickPickItemTooltip"),C=[];for(let A=0;A<D.length;A++){const E=D[A];if(E.kind===R.QuickPickItemKind.Separator)C.push({type:"separator",label:E.label});else{E.tooltip&&!_&&console.warn(`Extension '${this._extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this._extension.identifier.value}`);const S=E.iconPath?h(E.iconPath):void 0;C.push({handle:A,label:E.label,iconPath:S?.iconPath,iconClass:S?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:_?T.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((F,N)=>({...h(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.update({items:C})}get canSelectMany(){return this._canSelectMany}set canSelectMany(D){this._canSelectMany=D,this.update({canSelectMany:D})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(D){this._matchOnDescription=D,this.update({matchOnDescription:D})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(D){this._matchOnDetail=D,this.update({matchOnDetail:D})}get sortByLabel(){return this._sortByLabel}set sortByLabel(D){this._sortByLabel=D,this.update({sortByLabel:D})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(D){this._keepScrollPosition=D,this.update({keepScrollPosition:D})}get activeItems(){return this._activeItems}set activeItems(D){this._activeItems=D.filter(_=>this._itemsToHandles.has(_)),this.update({activeItems:this._activeItems.map(_=>this._itemsToHandles.get(_))})}get selectedItems(){return this._selectedItems}set selectedItems(D){this._selectedItems=D.filter(_=>this._itemsToHandles.has(_)),this.update({selectedItems:this._selectedItems.map(_=>this._itemsToHandles.get(_))})}_fireDidChangeActive(D){const _=(0,l.coalesce)(D.map(C=>this._handlesToItems.get(C)));this._activeItems=_,this._onDidChangeActiveEmitter.fire(_)}_fireDidChangeSelection(D){const _=(0,l.coalesce)(D.map(C=>this._handlesToItems.get(C)));this._selectedItems=_,this._onDidChangeSelectionEmitter.fire(_)}_fireDidTriggerItemButton(D,_){const C=this._handlesToItems.get(D);if(!C||!C.buttons||!C.buttons.length)return;const A=C.buttons[_];A&&this._onDidTriggerItemButtonEmitter.fire({button:A,item:C})}}class g extends s{constructor(D,_){super(D,_),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(D){this._password=D,this.update({password:D})}get prompt(){return this._prompt}set prompt(D){this._prompt=D,this.update({prompt:D})}get valueSelection(){return this._valueSelection}set valueSelection(D){this._valueSelection=D,this.update({valueSelection:D})}get validationMessage(){return this._validationMessage}set validationMessage(D){this._validationMessage=D,D?typeof D=="string"?this.update({validationMessage:D,severity:I.default.Error}):this.update({validationMessage:D.message,severity:D.severity??I.default.Error}):this.update({validationMessage:void 0,severity:I.default.Ignore})}}return new i(m,p)}}),define(Ce[314],Ie([1,0,2,4,59,3,7,6,18,134,11,23,40,51,15,25,14,10]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(N){return N instanceof r.URI}function s(N,O){return N.scheme===m.Schemas.file&&O.scheme===m.Schemas.file&&p.isLinux?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||T.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function o(N){if(N){if(r.URI.isUri(N))return N;if(T.ThemeIcon.isThemeIcon(N))return N;{const O=N;return{light:O.light,dark:O.dark}}}else return}function n(N){const O=o(N.icon),M=N.labels?.map(U=>({title:U.title,icon:o(U.icon)}));return{...N,icon:O,labels:M}}function h(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const M=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,U=typeof O.iconPath=="string"?O.iconPath:r.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,l.comparePaths)(M,U)}function c(N,O){let M=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(M=h(N,O),M!==0)return M;if(N.light&&O.light)M=h(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(M!==0)return M;if(N.dark&&O.dark)M=h(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return M}function g(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let M=0;M<N.arguments.length;M++){const U=N.arguments[M],x=O.arguments[M];if(U!==x&&!(i(U)&&i(x)&&s(U,x)))return U<x?-1:1}return 0}function w(N,O){let M=(0,l.comparePaths)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(M!==0)return M;if(N.command&&O.command)M=g(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(M!==0)return M;if(N.decorations&&O.decorations)M=c(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)M=(0,l.comparePaths)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)M=(0,l.comparePaths)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return M}function D(N,O){for(let M=0;M<N.length;M++)if(N[M]!==O[M])return!1;return!0}function _(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?D(N.arguments,O.arguments):N.arguments===O.arguments)}function C(N,O){return(0,v.equals)(N,O,_)}class A{#e;#t;get value(){return this._value}set value(O){O=O??"",this.#e.$setInputBoxValue(this._sourceControlHandle,O),this.updateValue(O)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(O){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,O),this._placeholder=O}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(O){if((0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=O,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!O)}get enabled(){return this._enabled}set enabled(O){O=!!O,this._enabled!==O&&(this._enabled=O,this.#e.$setInputBoxEnablement(this._sourceControlHandle,O))}get visible(){return this._visible}set visible(O){O=!!O,this._visible!==O&&(this._visible=O,this.#e.$setInputBoxVisibility(this._sourceControlHandle,O))}get document(){return(0,a.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(O,M,U,x,z){this._extension=O,this._sourceControlHandle=x,this._documentUri=z,this._value="",this._onDidChange=new d.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=M,this.#e=U}showValidationMessage(O,M){(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,O,M)}$onInputBoxValueChange(O){this.updateValue(O)}updateValue(O){this._value=O,this._onDidChange.fire(O)}}e.ExtHostSCMInputBox=A;class E{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(O){this._label=O,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,O)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(O){this._hideWhenEmpty=O,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(O){this._resourceStates=[...O],this._onDidUpdateResourceStates.fire()}constructor(O,M,U,x,z,B,ee){this._proxy=O,this._commands=M,this._sourceControlHandle=U,this._id=x,this._label=z,this.multiDiffEditorEnableViewChanges=B,this._extension=ee,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new d.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new d.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=E._handlePool++}getResourceState(O){return this._resourceStatesMap.get(O)}$executeResourceCommand(O,M){const U=this._resourceStatesCommandsMap.get(O);return U?(0,L.asPromise)(()=>this._commands.executeCommand(U.command,...U.arguments||[],M)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this._resourceStates].sort(w),U=(0,v.sortedDiff)(this._resourceSnapshot,O,w).map(B=>{const ee=B.toInsert.map(V=>{const $=this._resourceHandlePool++;this._resourceStatesMap.set($,V);const G=V.resourceUri;let Z;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"||V.command.command==="vscode.changes"){const re=new k.DisposableStore;Z=this._commands.converter.toInternal(V.command,re),this._resourceStatesDisposablesMap.set($,re)}else this._resourceStatesCommandsMap.set($,V.command);const le=(0,a.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),ne=le?V.multiDiffEditorOriginalUri:void 0,_e=le?V.multiFileDiffEditorModifiedUri:void 0,ge=t(V.decorations),Y=V.decorations&&t(V.decorations.light)||ge,W=V.decorations&&t(V.decorations.dark)||ge,oe=[Y,W],Se=V.decorations&&V.decorations.tooltip||"",te=V.decorations&&!!V.decorations.strikeThrough,ae=V.decorations&&!!V.decorations.faded,se=V.contextValue||"";return{rawResource:[$,G,oe,Se,te,ae,se,Z,ne,_e],handle:$}});return{start:B.start,deleteCount:B.deleteCount,toInsert:ee}}),x=U.map(({start:B,deleteCount:ee,toInsert:V})=>[B,ee,V.map($=>$.rawResource)]),z=U.reverse();for(const{start:B,deleteCount:ee,toInsert:V}of z){const $=V.map(Z=>Z.handle),G=this._handlesSnapshot.splice(B,ee,...$);for(const Z of G)this._resourceStatesMap.delete(Z),this._resourceStatesCommandsMap.delete(Z),this._resourceStatesDisposablesMap.get(Z)?.dispose(),this._resourceStatesDisposablesMap.delete(Z)}return this._resourceSnapshot=O,x}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class S{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(O){this._count!==O&&(this._count=O,this.#e.$updateSourceControl(this.handle,{count:O}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(O){this._quickDiffProvider=O;let M;(0,a.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(M=O?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!O,quickDiffLabel:M})}get historyProvider(){return(0,a.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(O){(0,a.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=O,this._historyProviderDisposable.value=new k.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!O}),O&&this._historyProviderDisposable.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(O){O!==this._commitTemplate&&(this._commitTemplate=O,this.#e.$updateSourceControl(this.handle,{commitTemplate:O}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(O){this._acceptInputDisposables.value=new k.DisposableStore,this._acceptInputCommand=O;const M=this._commands.converter.toInternal(O,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:M})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(O){(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new k.DisposableStore,this._actionButton=O;const M=O!==void 0?{command:this._commands.converter.toInternal(O.command,this._actionButtonDisposables.value),secondaryCommands:O.secondaryCommands?.map(U=>U.map(x=>this._commands.converter.toInternal(x,this._actionButtonDisposables.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:M??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(O){if(this._statusBarCommands&&O&&C(this._statusBarCommands,O))return;this._statusBarDisposables.value=new k.DisposableStore,this._statusBarCommands=O;const M=(O||[]).map(U=>this._commands.converter.toInternal(U,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:M})}get selected(){return this._selected}constructor(O,M,U,x,z,B,ee){this._extension=O,this._commands=x,this._id=z,this._label=B,this._rootUri=ee,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new k.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new k.MutableDisposable,this._statusBarDisposables=new k.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new d.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=S._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=U;const V=r.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${z}/scm${this.handle}/input`,query:ee?`rootUri=${encodeURIComponent(ee.toString())}`:void 0});this._inputBox=new A(O,M,this.#e,this.handle,V),this.#e.$registerSourceControl(this.handle,z,B,ee,V)}createResourceGroup(O,M,U){const x=(0,a.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&U?.multiDiffEditorEnableViewChanges===!0,z=new E(this.#e,this._commands,this.handle,O,M,x,this._extension),B=d.Event.once(z.onDidDispose)(()=>this.createdResourceGroups.delete(z));return this.createdResourceGroups.set(z,B),this.eventuallyAddResourceGroups(),z}eventuallyAddResourceGroups(){const O=[],M=[];for(const[U,x]of this.createdResourceGroups){x.dispose();const z=U.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(U),this.eventuallyUpdateResourceStates()});d.Event.once(U.onDidDispose)(()=>{this.updatedResourceGroups.delete(U),z.dispose(),this._groups.delete(U.handle),this.#e.$unregisterGroup(this.handle,U.handle)}),O.push([U.handle,U.id,U.label,U.features,U.multiDiffEditorEnableViewChanges]);const B=U._takeResourceStateSnapshot();B.length>0&&M.push([U.handle,B]),this._groups.set(U.handle,U)}this.#e.$registerGroups(this.handle,O,M),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const O=[];this.updatedResourceGroups.forEach(M=>{const U=M._takeResourceStateSnapshot();U.length!==0&&O.push([M.handle,U])}),O.length>0&&this.#e.$spliceResourceStates(this.handle,O),this.updatedResourceGroups.clear()}getResourceGroup(O){return this._groups.get(O)}setSelectionState(O){this._selected=O,this._onDidChangeSelection.fire(O)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Xe([(0,P.debounce)(100)],S.prototype,"eventuallyAddResourceGroups",null),Xe([(0,P.debounce)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{f=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(O,M,U,x){this._commands=M,this._extHostDocuments=U,this.logService=x,this._sourceControls=new Map,this._sourceControlsByExtension=new y.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new d.Emitter,this._proxy=O.getProxy(R.MainContext.MainThreadSCM),this._telemetry=O.getProxy(R.MainContext.MainThreadTelemetry),M.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===u.MarshalledId.ScmResource){const B=this._sourceControls.get(z.sourceControlHandle);if(!B)return z;const ee=B.getResourceGroup(z.groupHandle);return ee?ee.getResourceState(z.handle):z}else if(z&&z.$mid===u.MarshalledId.ScmResourceGroup){const B=this._sourceControls.get(z.sourceControlHandle);return B?B.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===u.MarshalledId.ScmProvider){const B=this._sourceControls.get(z.handle);return B||z}return z}})}createSourceControl(O,M,U,x){this.logService.trace("ExtHostSCM#createSourceControl",O.identifier.value,M,U,x),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const z=f._handlePool++,B=new S(O,this._extHostDocuments,this._proxy,this._commands,M,U,x);this._sourceControls.set(z,B);const ee=this._sourceControlsByExtension.get(O.identifier)||[];return ee.push(B),this._sourceControlsByExtension.set(O.identifier,ee),B}getLastInputBox(O){this.logService.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const M=this._sourceControlsByExtension.get(O.identifier),U=M&&M[M.length-1];return U&&U.inputBox}$provideOriginalResource(O,M,U){const x=r.URI.revive(M);this.logService.trace("ExtHostSCM#$provideOriginalResource",O,x.toString());const z=this._sourceControls.get(O);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.asPromise)(()=>z.quickDiffProvider.provideOriginalResource(x,U)).then(B=>B||null)}$onInputBoxValueChange(O,M){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",O);const U=this._sourceControls.get(O);return U&&U.inputBox.$onInputBoxValueChange(M),Promise.resolve(void 0)}$executeResourceCommand(O,M,U,x){this.logService.trace("ExtHostSCM#$executeResourceCommand",O,M,U);const z=this._sourceControls.get(O);if(!z)return Promise.resolve(void 0);const B=z.getResourceGroup(M);return B?B.$executeResourceCommand(U,x):Promise.resolve(void 0)}$validateInput(O,M,U){this.logService.trace("ExtHostSCM#$validateInput",O);const x=this._sourceControls.get(O);return!x||!x.inputBox.validateInput?Promise.resolve(void 0):(0,L.asPromise)(()=>x.inputBox.validateInput(M,U)).then(z=>{if(!z)return Promise.resolve(void 0);const B=b.MarkdownString.fromStrict(z.message);return B?Promise.resolve([B,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this._sourceControls.get(O)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,M,U,x){return await this._sourceControls.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(M,U,x)??void 0}async $resolveHistoryItemGroupCommonAncestor2(O,M,U){return await this._sourceControls.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(M,U)??void 0}async $provideHistoryItems(O,M,U,x){return(await this._sourceControls.get(O)?.historyProvider?.provideHistoryItems(M,U,x))?.map(ee=>n(ee))??void 0}async $provideHistoryItems2(O,M,U){return(await this._sourceControls.get(O)?.historyProvider?.provideHistoryItems2(M,U))?.map(B=>n(B))??void 0}async $provideHistoryItemSummary(O,M,U,x){const z=this._sourceControls.get(O)?.historyProvider;if(typeof z?.provideHistoryItemSummary!="function")return;const B=await z.provideHistoryItemSummary(M,U,x);return B?n(B):void 0}async $provideHistoryItemChanges(O,M,U,x){return await this._sourceControls.get(O)?.historyProvider?.provideHistoryItemChanges(M,U,x)??void 0}};e.ExtHostSCM=F,e.ExtHostSCM=F=f=Xe([He(3,I.ILogService)],F)}),define(Ce[315],Ie([1,0,6,15,2]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class k{static{this.handlePool=0}constructor(R,v){this.uriTransformer=v,this.providers=new Map,this.proxy=R.getProxy(r.MainContext.MainThreadShare)}async $provideShare(R,v,l){return await this.providers.get(R)?.provideShare({selection:d.Range.to(v.selection),resourceUri:P.URI.revive(v.resourceUri)},l)??void 0}registerShareProvider(R,v){const l=k.handlePool++;return this.providers.set(l,v),this.proxy.$registerShareProvider(l,d.DocumentSelector.from(R,this.uriTransformer),v.id,v.label,v.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(l),this.providers.delete(l)}}}}e.ExtHostShare=k}),define(Ce[316],Ie([1,0,9,6,8,3,15,17]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class v{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(u,T,b,a,m,p=r.StatusBarAlignment.Left,f){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new k.DisposableStore,this.#e=u,this.#t=T,m&&a){this._entryId=(0,r.asStatusBarItemIdentifier)(a.identifier,m);const i=b.get(this._entryId);i&&(p=i.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,f=i.priority,this._visible=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this._entryId=String(v.ID_GEN++);this._extension=a,this._id=m,this._alignment=p,this._priority=this.validatePriority(f)}validatePriority(u){if((0,R.isNumber)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(u){this._text=u,this.update()}set name(u){this._name=u,this.update()}set tooltip(u){this._tooltip=u,this.update()}set color(u){this._color=u,this.update()}set backgroundColor(u){u&&!v.ALLOWED_BACKGROUND_COLORS.has(u.id)&&(u=void 0),this._backgroundColor=u,this.update()}set command(u){this._command?.fromApi!==u&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new k.DisposableStore,typeof u=="string"?this._command={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this._latestCommandRegistration)}:u?this._command={fromApi:u,internal:this.#t.toInternal(u,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(u){this._accessibilityInformation=u,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let u;this._extension?this._id?u=`${this._extension.identifier.value}.${this._id}`:u=this._extension.identifier.value:u=this._id;let T;this._name?T=this._name:T=(0,P.localize)(10826,null,this._extension.displayName||this._extension.name);let b=this._color;this._backgroundColor&&(b=v.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const a=L.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,u,this._extension?.identifier.value,T,this._text,a,this._command?.internal,b,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=v;class l{constructor(u){this._messages=[],this._item=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,P.localize)(10827,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(u){const T={message:u};return this._messages.unshift(T),this._update(),new r.Disposable(()=>{const b=this._messages.indexOf(T);b>=0&&(this._messages.splice(b,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(u,T){this._existingItems=new Map,this._proxy=u.getProxy(d.MainContext.MainThreadStatusBar),this._commands=T,this._statusMessage=new l(this)}$acceptStaticEntries(u){for(const T of u)this._existingItems.set(T.entryId,T)}createStatusBarEntry(u,T,b,a){return new v(this._proxy,this._commands,this._existingItems,u,T,b,a)}setStatusBarMessage(u,T){const b=this._statusMessage.setMessage(u);let a;return typeof T=="number"?a=setTimeout(()=>b.dispose(),T):typeof T<"u"&&T.then(()=>b.dispose(),()=>b.dispose()),new r.Disposable(()=>{b.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=I}),define(Ce[166],Ie([1,0,30,155,73,120,74,15,2]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0,r=$e(r),R=$e(R);const l=(i,s,t,o)=>{let n=s;return{enumerable:!0,configurable:!1,get(){return n},set(h){if(!t(n,h)){const c=n;n=h,i.listener?.(o(h,c))}}}},I=(i,s)=>i===s,y={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,s)=>!(i.length!==s.length||i.some(t=>!s.find(o=>t.id===o.id)))},u=i=>s=>({op:k.TestItemEventOp.SetProp,update:i(s)}),T=(i,s)=>({range:(()=>{let t;const o=u(n=>({range:r.Range.lift(R.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return t},set(n){i.listener?.({op:k.TestItemEventOp.DocumentSynced}),y.range(t,n)||(t=n,i.listener?.(o(n)))}}})(),label:l(i,s,y.label,u(t=>({label:t}))),description:l(i,void 0,y.description,u(t=>({description:t}))),sortText:l(i,void 0,y.sortText,u(t=>({sortText:t}))),canResolveChildren:l(i,!1,y.canResolveChildren,t=>({op:k.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:l(i,!1,y.busy,u(t=>({busy:t}))),error:l(i,void 0,y.error,u(t=>({error:R.MarkdownString.fromStrict(t)||null}))),tags:l(i,[],y.tags,(t,o)=>({op:k.TestItemEventOp.SetTags,new:t.map(R.TestTag.from),old:o.map(R.TestTag.from)}))}),b=i=>{const s=P.TestId.fromString(i.extId),t=new m(s.controllerId,s.localId,i.label,v.URI.revive(i.uri)||void 0);return t.range=R.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>R.TestTag.to({id:(0,L.denamespaceTestTag)(o).tagId})),t},a=i=>{let s;for(const t of i.tests){const o=b(t.item);(0,d.getPrivateApiFor)(o).parent=s,s=o}return s};e.toItemFromContext=a;class m{constructor(s,t,o,n){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const h=(0,d.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof p?void 0:h.parent}},children:{value:(0,k.createTestItemChildren)(h,d.getPrivateApiFor,m),enumerable:!0,writable:!1},...T(h,o)})}}e.TestItemImpl=m;class p extends m{constructor(s,t){super(s,s,t,void 0),this._isRoot=!0}}e.TestItemRootImpl=p;class f extends k.TestItemCollection{constructor(s,t,o){super({controllerId:s,getDocumentVersion:n=>n&&o.getDocument(n)?.version,getApiFor:d.getPrivateApiFor,getChildren:n=>n.children,root:new p(s,t),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=f}),define(Ce[34],Ie([1,0,17,9,15,24,6,18,11,44,30,57,2,3,5,19,166,21,53,52,42,91,94,32]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0,d=$e(d),P=$e(P);let h=class{#e;#t;#i;constructor(C,A,E){this._commands=new Map,this._apiCommands=new Map,this.#e=C.getProxy(L.MainContext.MainThreadCommands),this._logService=A,this.#i=E,this.#t=C.getProxy(L.MainContext.MainThreadTelemetry),this.converter=new c(this,S=>{const F=this._apiCommands.get(S);return F?.result===w.Void?F:void 0},A),this._argumentProcessors=[{processArgument(S){return(0,l.revive)(S)}},{processArgument(S){return(0,k.cloneAndChange)(S,function(F){if(I.Range.isIRange(F))return P.Range.to(F);if(y.Position.isIPosition(F))return P.Position.to(F);if(I.Range.isIRange(F.range)&&u.URI.isUri(F.uri))return P.location.to(F);if(F instanceof p.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(C){this._argumentProcessors.push(C)}registerApiCommand(C){const A=this.registerCommand(!1,C.id,async(...E)=>{const S=C.args.map((N,O)=>{if(!N.validate(E[O]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof E[O]=="object"?JSON.stringify(E[O],null,"	"):E[O]} `);return N.convert(E[O])}),F=await this.executeCommand(C.internalId,...S);return C.result.convert(F,E,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this._apiCommands.set(C.id,C),new d.Disposable(()=>{A.dispose(),this._apiCommands.delete(C.id)})}registerCommand(C,A,E,S,F,N){if(this._logService.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this._commands.has(A))throw new Error(`command '${A}' already exists`);return this._commands.set(A,{callback:E,thisArg:S,metadata:F,extension:N}),C&&this.#e.$registerCommand(A),new d.Disposable(()=>{this._commands.delete(A)&&C&&this.#e.$unregisterCommand(A)})}executeCommand(C,...A){return this._logService.trace("ExtHostCommands#executeCommand",C),this._doExecuteCommand(C,A,!0)}async _doExecuteCommand(C,A,E){if(this._commands.has(C))return this.#e.$fireCommandActivationEvent(C),this._executeContributedCommand(C,A,!1);{let S=!1;const F=(0,k.cloneAndChange)(A,function(N){if(N instanceof d.Position)return P.Position.from(N);if(N instanceof d.Range)return P.Range.from(N);if(N instanceof d.Location)return P.location.from(N);if(d.NotebookRange.isNotebookRange(N))return P.NotebookRange.from(N);if(N instanceof ArrayBuffer)return S=!0,p.VSBuffer.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return S=!0,p.VSBuffer.wrap(N);if(N instanceof p.VSBuffer)return S=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(C,S?new f.SerializableObjectWithBuffers(F):F,E);return(0,l.revive)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this._doExecuteCommand(C,A,!1);throw N}}}async _executeContributedCommand(C,A,E){const S=this._commands.get(C);if(!S)throw new Error("Unknown command");const{callback:F,thisArg:N,metadata:O}=S;if(O?.args)for(let U=0;U<O.args.length;U++)try{(0,r.validateConstraint)(A[U],O.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${O.args[U].name}' - ${O.args[U].description}`)}const M=s.StopWatch.create();try{return await F.apply(N,A)}catch(U){if(C===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...A);x&&(C=x.command)}if(this._logService.error(U,C,S.extension?.identifier),!E)throw U;if(S.extension?.identifier){const x=this.#i.onExtensionError(S.extension.identifier,U);this._logService.trace("forwarded error to extension?",x,S.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.toErrorMessage)(U)),this.id=C,this.source=S.extension?.displayName??S.extension?.name}}}finally{this._reportTelemetry(S,C,M.elapsed())}}_reportTelemetry(C,A,E){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.TelemetryTrustedValue(A),duration:E})}$executeContributedCommand(C,...A){this._logService.trace("ExtHostCommands#$executeContributedCommand",C);const E=this._commands.get(C);return E?(A=A.map(S=>this._argumentProcessors.reduce((F,N)=>N.processArgument(F,E.extension?.identifier),S)),this._executeContributedCommand(C,A,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this._logService.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(A=>(C&&(A=A.filter(E=>E[0]!=="_")),A))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[A,E]of this._commands){const{metadata:S}=E;S&&(C[A]=S)}return Promise.resolve(C)}};e.ExtHostCommands=h,e.ExtHostCommands=h=Xe([He(0,a.IExtHostRpcService),He(1,v.ILogService),He(2,o.IExtHostTelemetry)],h),e.IExtHostCommands=(0,b.createDecorator)("IExtHostCommands");class c{constructor(C,A,E){this._commands=C,this._lookupApiCommand=A,this._logService=E,this.delegatingCommandId=`__vsc${(0,n.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(C,A){if(!C)return;const E={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return E;const S=this._lookupApiCommand(C.command);if(S)E.id=S.internalId,E.arguments=S.args.map((F,N)=>F.convert(C.arguments&&C.arguments[N]));else if((0,R.isNonEmptyArray)(C.arguments)){const F=`${C.command} /${++this._cachIdPool}`;this._cache.set(F,C),A.add((0,T.toDisposable)(()=>{this._cache.delete(F),this._logService.trace("CommandsConverter#DISPOSE",F)})),E.$ident=F,E.id=this.delegatingCommandId,E.arguments=[F],this._logService.trace("CommandsConverter#CREATE",C.command,F)}return E}fromInternal(C){return typeof C.$ident=="string"?this._cache.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this._cache.get(C[0])}_executeConvertedCommand(...C){const A=this.getActualCommand(...C);return this._logService.trace("CommandsConverter#EXECUTE",C[0],A?A.command:"MISSING"),A?this._commands.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.CommandsConverter=c;class g{static{this.Uri=new g("uri","Uri of a text document",C=>u.URI.isUri(C),C=>C)}static{this.Position=new g("position","A position in a text document",C=>d.Position.isPosition(C),P.Position.from)}static{this.Range=new g("range","A range in a text document",C=>d.Range.isRange(C),P.Range.from)}static{this.Selection=new g("selection","A selection in a text document",C=>d.Selection.isSelection(C),P.Selection.from)}static{this.Number=new g("number","",C=>typeof C=="number",C=>C)}static{this.String=new g("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=g.Arr(g.String)}static Arr(C){return new g(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,A=>Array.isArray(A)&&A.every(E=>C.validate(E)),A=>A.map(E=>C.convert(E)))}static{this.CallHierarchyItem=new g("item","A call hierarchy item",C=>C instanceof d.CallHierarchyItem,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new g("item","A type hierarchy item",C=>C instanceof d.TypeHierarchyItem,P.TypeHierarchyItem.from)}static{this.TestItem=new g("testItem","A VSCodium TestItem",C=>C instanceof m.TestItemImpl,P.TestItem.from)}constructor(C,A,E,S){this.name=C,this.description=A,this.validate=E,this.convert=S}optional(){return new g(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,A){return new g(C??this.name,A??this.description,this.validate,this.convert)}}e.ApiCommandArgument=g;class w{static{this.Void=new w("no result",C=>C)}constructor(C,A){this.description=C,this.convert=A}}e.ApiCommandResult=w;class D{constructor(C,A,E,S,F){this.id=C,this.internalId=A,this.description=E,this.args=S,this.result=F}}e.ApiCommand=D}),define(Ce[317],Ie([1,0,18,14,2,87,142,35,34,15,9]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0,k=$e(k),l=$e(l),I=$e(I);const y=[new v.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(l.DocumentHighlight.to))),new v.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,r.isFalsyOrEmpty)(a))return;class p extends I.SymbolInformation{static to(i){const s=new p(i.name,l.SymbolKind.to(i.kind),i.containerName||"",new I.Location(m[0],l.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=l.Range.to(i.selectionRange),s.children=i.children?i.children.map(p.to):[],s}}return a.map(p.to)})),new v.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(l.TextEdit.to))),new v.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(l.TextEdit.to))),new v.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,new v.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new v.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(l.TextEdit.to))),new v.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new v.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(l.location.to))),new v.ApiCommand("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(l.location.to))),new v.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(l.Hover.to))),new v.ApiCommand("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(l.Hover.to))),new v.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>I.Position.isPosition(m)),a=>a.map(l.Position.from))],new v.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(m=>{let p;for(const f of m.reverse())p=new I.SelectionRange(l.Range.to(f),p);return p}))),new v.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.ApiCommandArgument.String.with("query","Search string")],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(l.WorkspaceSymbol.to))),new v.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(l.CallHierarchyItem.to))),new v.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(l.CallHierarchyIncomingCall.to))),new v.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(l.CallHierarchyOutgoingCall.to))),new v.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:l.Range.to(a.range),placeholder:a.text}})),new v.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("newName","The new symbol name")],new v.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return l.WorkspaceEdit.to(a)}})),new v.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(l.DocumentLink.to))),new v.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,L.decodeSemanticTokensDto)(a);if(m.type==="full")return new I.SemanticTokens(m.data,void 0)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range.optional()],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,L.decodeSemanticTokensDto)(a);if(m.type==="full")return new I.SemanticTokens(m.data,void 0)})),new v.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,m,p)=>{if(!a)return new I.CompletionList([]);const f=a.suggestions.map(i=>l.CompletionItem.to(i,p));return new I.CompletionList(f,a.incomplete)})),new v.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return l.SignatureHelp.to(a)})),new v.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,m,p)=>T(f=>new I.CodeLens(l.Range.to(f.range),f.command&&p.fromInternal(f.command)))(a))),new v.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>I.Range.isRange(a),a=>I.Selection.isSelection(a)?l.Selection.from(a):l.Range.from(a)),v.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,m,p)=>T(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(f.command)}else{const i=new I.CodeAction(f.title,f.kind?new I.CodeActionKind(f.kind):void 0);return f.edit&&(i.edit=l.WorkspaceEdit.to(f.edit)),f.command&&(i.command=p.fromInternal(f.command)),i.isPreferred=f.isPreferred,i}})(a))),new v.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new I.ColorInformation(l.Range.to(m.range),l.Color.to(m.color))):[])),new v.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.ApiCommandArgument("color","The color to show and insert",a=>a instanceof I.Color,l.Color.from),new v.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:l.Range.from(a.range)}))],new v.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(l.ColorPresentation.to):[])),new v.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,m,p)=>a.map(l.InlayHint.to.bind(void 0,p)))),new v.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(l.FoldingRange.to)})),new v.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>l.NotebookExclusiveDocumentPattern.to(m))})))),new v.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof I.Range,a=>l.InlineValueContext.from(a))],new v.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(l.InlineValue.to))),new v.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>P.URI.isUri(a)||typeof a=="string"&&(0,d.matchesSomeScheme)(a,d.Schemas.http,d.Schemas.https),a=>a),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[l.ViewColumn.from(a),void 0]:[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)])).optional(),v.ApiCommandArgument.String.with("label","").optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.ApiCommandArgument.Uri.with("resource","Resource to open"),v.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[l.ViewColumn.from(a),void 0]:[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)])).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),v.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),v.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)]).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[v.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new v.ApiCommandArgument("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[p,f,i]=m;if(!P.URI.isUri(p)||!P.URI.isUri(f)&&f!==void 0&&f!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new v.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.ApiCommandArgument.TestItem],v.ApiCommandResult.Void),new v.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.ApiCommandResult.Void),new v.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.ApiCommandArgument.String.with("name","The context key name"),new v.ApiCommandArgument("value","The context key value",()=>!0,a=>a)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.StringArray,new v.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",a=>l.MappedEditsContext.is(a),a=>l.MappedEditsContext.from(a))],new v.ApiCommandResult("A promise that resolves to a workspace edit or null",a=>a?l.WorkspaceEdit.to(a):null)),new v.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new v.ApiCommandArgument("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?l.Range.from(a.initialRange):void 0,initialSelection:I.Selection.isSelection(a.initialSelection)?l.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?l.Position.from(a.position):void 0}})],v.ApiCommandResult.Void)];class u{static register(m){y.forEach(m.registerApiCommand,m),this._registerValidateWhenClausesCommand(m)}static _registerValidateWhenClausesCommand(m){m.registerCommand(!1,"_validateWhenClauses",R.validateWhenClauses)}}e.ExtHostApiCommands=u;function T(a){return m=>{if(Array.isArray(m))return m.map(a)}}function b(a){if(!Array.isArray(a))return;const m=[];for(const p of a)k.isLocationLink(p)?m.push(l.DefinitionLink.to(p)):m.push(l.location.to(p));return m}}),define(Ce[318],Ie([1,0,2,34]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class P{constructor(L,R,v,l,I){this._extHostNotebooks=R,this._textDocumentsAndEditors=v,this._commands=l;const y=new d.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new d.ApiCommandArgument("showOptions","Show Options",u=>!0,u=>u),new d.ApiCommandArgument("resource","Interactive resource Uri",u=>!0,u=>u),new d.ApiCommandArgument("controllerId","Notebook controller Id",u=>!0,u=>u),new d.ApiCommandArgument("title","Interactive editor title",u=>!0,u=>u)],new d.ApiCommandResult("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:T.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this._commands.registerApiCommand(y)}$willAddInteractiveDocument(L,R,v,l){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:v,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.ExtHostInteractive=P}),define(Ce[319],Ie([1,0,18,7,20,4,3,28,2,23,11,6,34,15,9,121,261,25,53,262]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=g,T=$e(T);let s=class{constructor(D,_,C,A,E){this._initData=_,this._extHostNotebook=C,this._commands=A,this._logService=E,this._activeExecutions=new R.ResourceMap,this._activeNotebookExecutions=new R.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new k.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=D.getProxy(y.MainContext.MainThreadNotebookKernels);const S=new u.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.ApiCommandArgument("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this._extHostNotebook.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this._extHostNotebook.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],u.ApiCommandResult.Void),F=new u.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.ApiCommandArgument.Uri],new u.ApiCommandResult("A promise that resolves to an array of variables",(N,O)=>N.map(M=>({variable:{name:M.name,value:M.value,expression:M.expression,type:M.type,language:M.language},hasNamedChildren:M.hasNamedChildren,indexedChildrenCount:M.indexedChildrenCount}))));this._commands.registerApiCommand(S),this._commands.registerApiCommand(F)}createNotebookController(D,_,C,A,E,S){for(const ne of this._kernelData.values())if(ne.controller.id===_&&l.ExtensionIdentifier.equals(D.identifier,ne.extensionId))throw new Error(`notebook controller with id '${_}' ALREADY exist`);const F=this._handlePool++,N=this;this._logService.trace(`NotebookController[${F}], CREATED by ${D.identifier.value}, ${_}`);const O=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${D.identifier}'`);let M=!1;const U=new k.Emitter,x=new k.Emitter,z={id:g(D.identifier,_),notebookType:C,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:A||D.identifier.value,preloads:S?S.map(T.NotebookRendererScript.from):[]};let B=E??O,ee,V;this._proxy.$addKernel(F,z).catch(ne=>{console.log(ne),M=!0});let $=0;const G=()=>{if(M)return;const ne=++$;Promise.resolve().then(()=>{ne===$&&this._proxy.$updateKernel(F,z)})},Z=new R.ResourceMap,le={get id(){return _},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return z.label},set label(ne){z.label=ne??D.displayName??D.name,G()},get detail(){return z.detail??""},set detail(ne){z.detail=ne,G()},get description(){return z.description??""},set description(ne){z.description=ne,G()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(ne){z.supportedLanguages=ne,G()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){z.supportsExecutionOrder=ne,G()},get rendererScripts(){return z.preloads?z.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(ne){B=ne??O},get interruptHandler(){return ee},set interruptHandler(ne){ee=ne,z.supportsInterrupt=!!ne,G()},set variableProvider(ne){(0,p.checkProposedApiEnabled)(D,"notebookVariableProvider"),V=ne,z.hasVariableProvider=!!ne,ne?.onDidChangeVariables(_e=>N._proxy.$variablesUpdated(_e.uri)),G()},get variableProvider(){return V},createNotebookCellExecution(ne){if(M)throw new Error("notebook controller is DISPOSED");if(!Z.has(ne.notebook.uri))throw N._logService.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(_e=>_e.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return N._createNotebookCellExecution(ne,g(D.identifier,this.id))},createNotebookExecution(ne){if((0,p.checkProposedApiEnabled)(D,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!Z.has(ne.uri))throw N._logService.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(_e=>_e.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return N._createNotebookExecution(ne,g(D.identifier,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${F}], DISPOSED`),M=!0,this._kernelData.delete(F),U.dispose(),x.dispose(),this._proxy.$removeKernel(F))},updateNotebookAffinity(ne,_e){_e===b.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(D,"notebookControllerAffinityHidden"),N._proxy.$updateNotebookPriority(F,ne.uri,_e)},onDidReceiveMessage:x.event,postMessage(ne,_e){return(0,p.checkProposedApiEnabled)(D,"notebookMessaging"),N._proxy.$postMessage(F,_e&&N._extHostNotebook.getIdByEditor(_e),ne)},asWebviewUri(ne){return(0,p.checkProposedApiEnabled)(D,"notebookMessaging"),(0,a.asWebviewUri)(ne,N._initData.remote)}};return this._kernelData.set(F,{extensionId:D.identifier,controller:le,onDidReceiveMessage:x,onDidChangeSelection:U,associatedNotebooks:Z}),le}getIdByController(D){for(const[_,C]of this._kernelData)if(C.controller===D)return g(C.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,_){const C=this._kernelDetectionTaskHandlePool++,A=this;this._logService.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${D.identifier.value}`),this._proxy.$addKernelDetectionTask(C,_);const E={dispose:()=>{this._kernelDetectionTask.delete(C),A._proxy.$removeKernelDetectionTask(C)}};return this._kernelDetectionTask.set(C,E),E}registerKernelSourceActionProvider(D,_,C){const A=this._kernelSourceActionProviderHandlePool++,E=typeof C.onDidChangeNotebookKernelSourceActions=="function"?A:void 0,S=this;this._kernelSourceActionProviders.set(A,C),this._logService.trace(`NotebookKernelSourceActionProvider[${A}], CREATED by ${D.identifier.value}`),this._proxy.$addKernelSourceActionProvider(A,A,_);let F;return E!==void 0&&(F=C.onDidChangeNotebookKernelSourceActions(N=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this._kernelSourceActionProviders.delete(A),S._proxy.$removeKernelSourceActionProvider(A,A),F?.dispose()}}}async $provideKernelSourceActions(D,_){const C=this._kernelSourceActionProviders.get(D);if(C){const A=new L.DisposableStore;return(await C.provideNotebookKernelSourceActions(_)??[]).map(S=>T.NotebookKernelSourceAction.from(S,this._commands.converter,A))}return[]}$acceptNotebookAssociation(D,_,C){const A=this._kernelData.get(D);if(A){const E=this._extHostNotebook.getNotebookDocument(v.URI.revive(_));C?A.associatedNotebooks.set(E.uri,!0):A.associatedNotebooks.delete(E.uri),this._logService.trace(`NotebookController[${D}] ASSOCIATE notebook`,E.uri.toString(),C),A.onDidChangeSelection.fire({selected:C,notebook:E.apiNotebook})}}async $executeCells(D,_,C){const A=this._kernelData.get(D);if(!A)return;const E=this._extHostNotebook.getNotebookDocument(v.URI.revive(_)),S=[];for(const F of C){const N=E.getCell(F);N&&S.push(N.apiCell)}try{this._logService.trace(`NotebookController[${D}] EXECUTE cells`,E.uri.toString(),S.length),await A.controller.executeHandler.call(A.controller,S,E.apiNotebook,A.controller)}catch(F){this._logService.error(`NotebookController[${D}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(D,_,C){const A=this._kernelData.get(D);if(!A)return;const E=this._extHostNotebook.getNotebookDocument(v.URI.revive(_));if(A.controller.interruptHandler)await A.controller.interruptHandler.call(A.controller,E.apiNotebook);else for(const S of C){const F=E.getCell(S);F&&this._activeExecutions.get(F.uri)?.cancel()}if(A.controller.interruptHandler){const S=this._activeNotebookExecutions.get(E.uri);this._activeNotebookExecutions.delete(E.uri),C.length&&Array.isArray(S)&&S.length&&S.forEach(F=>F.dispose())}}async $provideVariables(D,_,C,A,E,S,F){const N=this._kernelData.get(D);if(!N)return;const O=this._extHostNotebook.getNotebookDocument(v.URI.revive(C)),M=N.controller.variableProvider;if(!M)return;let U;if(A!==void 0){if(U=this.variableStore[A],!U)return}else this.variableStore={};const x=E==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,z=M.provideVariables(O.apiNotebook,U,x,S,F);let B=0;for await(const ee of z){if(F.isCancellationRequested)return;const V={id:this.id++,name:ee.variable.name,value:ee.variable.value,type:ee.variable.type,interfaces:ee.variable.interfaces,language:ee.variable.language,expression:ee.variable.expression,hasNamedChildren:ee.hasNamedChildren,indexedChildrenCount:ee.indexedChildrenCount,extensionId:N.extensionId.value};if(this.variableStore[V.id]=ee.variable,this._proxy.$receiveVariable(_,V),B++>=i.variablePageSize)return}}$acceptKernelMessageFromRenderer(D,_,C){const A=this._kernelData.get(D);if(!A)return;const E=this._extHostNotebook.getEditorById(_);A.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:C}))}$cellExecutionChanged(D,_,C){const E=this._extHostNotebook.getNotebookDocument(v.URI.revive(D)).getCell(_);if(E){const S=C?T.NotebookCellExecutionState.to(C):b.NotebookCellExecutionState.Idle;S!==void 0&&this._onDidChangeCellExecutionState.fire({cell:E.apiCell,state:S})}}_createNotebookCellExecution(D,_){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const A=this._extHostNotebook.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!A)throw new Error("invalid cell");if(this._activeExecutions.has(A.uri))throw new Error(`duplicate execution for ${A.uri}`);const E=new o(_,A,this._proxy);this._activeExecutions.set(A.uri,E);const S=E.onDidChangeState(()=>{E.state===t.Resolved&&(E.dispose(),S.dispose(),this._activeExecutions.delete(A.uri))});return E.asApiObject()}_createNotebookExecution(D,_){const C=this._extHostNotebook.getNotebookDocument(D.uri),A=D.getCells().find(F=>{const N=C.getCellFromApiCell(F);return N&&this._activeExecutions.has(N.uri)});if(A)throw new Error(`duplicate cell execution for ${A.document.uri}`);if(this._activeNotebookExecutions.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const E=new h(_,C,this._proxy),S=E.onDidChangeState(()=>{E.state===n.Resolved&&(E.dispose(),S.dispose(),this._activeNotebookExecutions.delete(C.uri))});return this._activeNotebookExecutions.set(C.uri,[E,S]),E.asApiObject()}};e.ExtHostNotebookKernels=s,e.ExtHostNotebookKernels=s=Xe([He(4,I.ILogService)],s);var t;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(t||(t={}));class o extends L.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(D,_,C){super(),this._cell=_,this._proxy=C,this._handle=o.HANDLE++,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._collector=new c(10,A=>this.update(A)),this._executionOrder=_.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,D,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(D){await this._collector.addItem(D)}async update(D){const _=Array.isArray(D)?D:[D];return this._proxy.$updateExecution(this._handle,new f.SerializableObjectWithBuffers(_))}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(D){let _=this._cell;if(D&&(_=this._cell.notebook.getCellFromApiCell(D)),!_)throw new Error("INVALID cell");return _.handle}validateAndConvertOutputs(D){return D.map(_=>{const C=b.NotebookCellOutput.ensureUniqueMimeTypes(_.items,!0);return C===_.items?T.NotebookCellOutput.from(_):T.NotebookCellOutput.from({items:C,id:_.id,metadata:_.metadata})})}async updateOutputs(D,_,C){const A=this.cellIndexToHandle(_),E=this.validateAndConvertOutputs((0,r.asArray)(D));return this.updateSoon({editType:m.CellExecutionUpdateType.Output,cellHandle:A,append:C,outputs:E})}async updateOutputItems(D,_,C){return D=b.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(D),!0),this.updateSoon({editType:m.CellExecutionUpdateType.OutputItems,items:D.map(T.NotebookCellOutputItem.from),outputId:_.id,append:C})}asApiObject(){const D=this;return Object.freeze({get token(){return D._tokenSource.token},get cell(){return D._cell.apiCell},get executionOrder(){return D._executionOrder},set executionOrder(C){D._executionOrder=C,D.update([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:D._executionOrder}])},start(C){if(D._state===t.Resolved||D._state===t.Started)throw new Error("Cannot call start again");D._state=t.Started,D._onDidChangeState.fire(),D.update({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,A,E){if(D._state===t.Resolved)throw new Error("Cannot call resolve twice");D._state=t.Resolved,D._onDidChangeState.fire(),D._collector.flush();const S=E?{message:E.message,stack:E.stack,location:E?.location?{startLineNumber:E.location.start.line,startColumn:E.location.start.character,endLineNumber:E.location.end.line,endColumn:E.location.end.character}:void 0,uri:E.uri}:void 0;D._proxy.$completeExecution(D._handle,new f.SerializableObjectWithBuffers({runEndTime:A,lastRunSuccess:C,error:S}))},clearOutput(C){return D.verifyStateForOutput(),D.updateOutputs([],C,!1)},appendOutput(C,A){return D.verifyStateForOutput(),D.updateOutputs(C,A,!0)},replaceOutput(C,A){return D.verifyStateForOutput(),D.updateOutputs(C,A,!1)},appendOutputItems(C,A){return D.verifyStateForOutput(),D.updateOutputItems(C,A,!0)},replaceOutputItems(C,A){return D.verifyStateForOutput(),D.updateOutputItems(C,A,!1)}})}}var n;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(n||(n={}));class h extends L.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(D,_,C){super(),this._notebook=_,this._proxy=C,this._handle=h.HANDLE++,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=n.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,D,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===n.Resolved||this._state===n.Started)throw new Error("Cannot call start again");this._state=n.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===n.Resolved)throw new Error("Cannot call resolve twice");this._state=n.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class c{constructor(D,_){this.delay=D,this.callback=_,this.batch=[],this.startedTimer=Date.now()}addItem(D){return this.batch.push(D),this.currentDeferred||(this.currentDeferred=new d.DeferredPromise,this.startedTimer=Date.now(),(0,d.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const D=this.currentDeferred;this.currentDeferred=void 0;const _=this.batch;return this.batch=[],this.callback(_).finally(()=>D.complete())}}function g(w,D){return`${w.value}/${D}`}}),define(Ce[48],Ie([1,0,4,6,5,2,19,3,9,8,13,241,20,32,242,243,51,7,15,34,40]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class t extends R.Disposable{constructor(E,S,F,N){super(),this._proxy=E,this._id=S,this._creationOptions=F,this._name=N,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new r.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(M=>this._pidPromiseComplete=M);const O=this;this.value={get name(){return O._name||""},get processId(){return O._pidPromise},get creationOptions(){return O._creationOptions},get exitStatus(){return O._exitStatus},get state(){return O._state},get selection(){return O._selection},get shellIntegration(){return O.shellIntegration},sendText(M,U=!0){O._checkDisposed(),O._proxy.$sendText(O._id,M,U)},show(M){O._checkDisposed(),O._proxy.$show(O._id,M)},hide(){O._checkDisposed(),O._proxy.$hide(O._id)},dispose(){O._disposed||(O._disposed=!0,O._proxy.$dispose(O._id))},get dimensions(){if(!(O._cols===void 0||O._rows===void 0))return{columns:O._cols,rows:O._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(E,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:E.name,shellPath:E.shellPath??void 0,shellArgs:E.shellArgs??void 0,cwd:E.cwd??S?.cwd??void 0,env:E.env??void 0,icon:D(E.iconPath)??void 0,color:m.ThemeColor.isThemeColor(E.color)?E.color.id:void 0,initialText:E.message??void 0,strictEnv:E.strictEnv??void 0,hideFromUser:E.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this._serializeParentTerminal(E.location,S?.resolvedExtHostIdentifier),isTransient:E.isTransient??void 0})}async createExtensionTerminal(E,S,F,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:N,color:m.ThemeColor.isThemeColor(O)?O.id:void 0,location:S?.location||this._serializeParentTerminal(E,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(E,S){return typeof E=="object"?"parentTerminal"in E&&E.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in E?{viewColumn:f.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus}:void 0:E}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(E){this._name=E}setExitStatus(E,S){this._exitStatus=Object.freeze({code:E,reason:S})}setDimensions(E,S){return E===this._cols&&S===this._rows||E===0||S===0?!1:(this._cols=E,this._rows=S,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(E){this._selection=E}_setProcessId(E){this._pidPromiseComplete?(this._pidPromiseComplete(E),this._pidPromiseComplete=void 0):this._pidPromise.then(S=>{S!==E&&(this._pidPromise=Promise.resolve(E))})}}e.ExtHostTerminal=t;class o{get onProcessReady(){return this._onProcessReady.event}constructor(E){this._pty=E,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(E){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${E}`)}updateProperty(E,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${E}, value: ${S}`)}async start(){}shutdown(){this._pty.close()}input(E){this._pty.handleInput?.(E)}resize(E,S){this._pty.setDimensions?.({columns:E,rows:S})}clearBuffer(){}async processBinary(E){}acknowledgeDataEvent(E){}async setUnicodeVersion(E){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(E){this._pty.onDidWrite(S=>this._onProcessData.fire(S)),this._pty.onDidClose?.((S=void 0)=>{this._onProcessExit.fire(S===void 0?void 0:S)}),this._pty.onDidOverrideDimensions?.(S=>{S&&this._onDidChangeProperty.fire({type:b.ProcessPropertyType.OverrideDimensions,value:{cols:S.columns,rows:S.rows}})}),this._pty.onDidChangeName?.(S=>{this._onDidChangeProperty.fire({type:b.ProcessPropertyType.Title,value:S})}),this._pty.open(E||void 0),E&&this._pty.setDimensions?.(E),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let n=1,h=class extends R.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(E=>E.value)}constructor(E,S,F){super(),this._extHostCommands=S,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new R.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new r.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new r.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new r.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=F.getProxy(d.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(E),this._extHostCommands.registerArgumentProcessor({processArgument:N=>{const O=M=>{const U=M;return this.getTerminalById(U.instanceId)?.value};switch(N?.$mid){case s.MarshalledId.TerminalContext:return O(N);default:{if(Array.isArray(N))for(let M=0;M<N.length&&N[M].$mid===s.MarshalledId.TerminalContext;M++)N[M]=O(N[M]);return N}}}}),this._register({dispose:()=>{for(const[N,O]of this._terminalProcesses)O.shutdown(!0)}})}getDefaultShell(E){return(E?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(E){return(E?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(E,S){const F=new t(this._proxy,(0,T.generateUuid)(),E,E.name),N=new o(E.pty);return F.createExtensionTerminal(E.location,S,this._serializeParentTerminal(E,S).resolvedExtHostIdentifier,D(E.iconPath),_(E.color)).then(O=>{const M=this._setupExtHostProcessListeners(O,N);this._terminalProcessDisposables[O]=M}),this._terminals.push(F),F.value}_serializeParentTerminal(E,S){if(S=S||{},E.location&&typeof E.location=="object"&&"parentTerminal"in E.location){const F=E.location.parentTerminal;if(F){const N=this._terminals.find(O=>O.value===F);N&&(S.resolvedExtHostIdentifier=N._id)}}else E.location&&typeof E.location!="object"?S.location=E.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(E,S){if(!this.getTerminalById(E))throw new Error(`Cannot resolve terminal with id ${E} for virtual process`);const N=new o(S),O=this._setupExtHostProcessListeners(E,N);this._terminalProcessDisposables[E]=O}async $acceptActiveTerminalChanged(E){const S=this._activeTerminal;if(E===null){this._activeTerminal=void 0,S!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const F=this.getTerminalById(E);F&&(this._activeTerminal=F,S!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(E,S){const F=this.getTerminalById(E);F&&this._onDidWriteTerminalData.fire({terminal:F.value,data:S})}async $acceptTerminalDimensions(E,S,F){const N=this.getTerminalById(E);N&&N.setDimensions(S,F)&&this._onDidChangeTerminalDimensions.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(E,S){const F=this.getTerminalById(E);F&&this._onDidExecuteCommand.fire({terminal:F.value,...S})}async $acceptTerminalMaximumDimensions(E,S,F){this._terminalProcesses.get(E)?.resize(S,F)}async $acceptTerminalTitleChange(E,S){const F=this.getTerminalById(E);F&&(F.name=S)}async $acceptTerminalClosed(E,S,F){const N=this._getTerminalObjectIndexById(this._terminals,E);if(N!==null){const O=this._terminals.splice(N,1)[0];O.setExitStatus(S,F),this._onDidCloseTerminal.fire(O.value)}}$acceptTerminalOpened(E,S,F,N){if(S){const U=this._getTerminalObjectIndexById(this._terminals,S);if(U!==null){this._terminals[U]._id=E,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:k.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},M=new t(this._proxy,E,O,F);this._terminals.push(M),this._onDidOpenTerminal.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(E,S){this.getTerminalById(E)?._setProcessId(S)}async $startExtensionTerminal(E,S){const F=this.getTerminalById(E);if(!F)return{message:(0,l.localize)(10824,null,E)};F.isOpen||await new Promise(O=>{const M=this.onDidOpenTerminal(async U=>{U===F.value&&(M.dispose(),O())})});const N=this._terminalProcesses.get(E);N?N.startSendingEvents(S):this._extensionTerminalAwaitingStart[E]={initialDimensions:S}}_setupExtHostProcessListeners(E,S){const F=new R.DisposableStore;F.add(S.onProcessReady(O=>this._proxy.$sendProcessReady(E,O.pid,O.cwd,O.windowsPty))),F.add(S.onDidChangeProperty(O=>this._proxy.$sendProcessProperty(E,O))),this._bufferer.startBuffering(E,S.onProcessData),F.add(S.onProcessExit(O=>this._onProcessExit(E,O))),this._terminalProcesses.set(E,S);const N=this._extensionTerminalAwaitingStart[E];return N&&S instanceof o&&(S.startSendingEvents(N.initialDimensions),delete this._extensionTerminalAwaitingStart[E]),F}$acceptProcessAckDataEvent(E,S){this._terminalProcesses.get(E)?.acknowledgeDataEvent(S)}$acceptProcessInput(E,S){this._terminalProcesses.get(E)?.input(S)}$acceptTerminalInteraction(E){const S=this.getTerminalById(E);S?.setInteractedWith()&&this._onDidChangeTerminalState.fire(S.value)}$acceptTerminalSelection(E,S){this.getTerminalById(E)?.setSelection(S)}$acceptProcessResize(E,S,F){try{this._terminalProcesses.get(E)?.resize(S,F)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(E,S){this._terminalProcesses.get(E)?.shutdown(S)}$acceptProcessRequestInitialCwd(E){this._terminalProcesses.get(E)?.getInitialCwd().then(S=>this._proxy.$sendProcessProperty(E,{type:b.ProcessPropertyType.InitialCwd,value:S}))}$acceptProcessRequestCwd(E){this._terminalProcesses.get(E)?.getCwd().then(S=>this._proxy.$sendProcessProperty(E,{type:b.ProcessPropertyType.Cwd,value:S}))}$acceptProcessRequestLatency(E){return Promise.resolve(E)}registerLinkProvider(E){return this._linkProviders.add(E),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new v.Disposable(()=>{this._linkProviders.delete(E),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(E,S,F){if(this._profileProviders.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this._profileProviders.set(S,F),this._proxy.$registerProfileProvider(S,E.identifier.value),new v.Disposable(()=>{this._profileProviders.delete(S),this._proxy.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(E,S,F){if(this._quickFixProviders.has(E))throw new Error(`Terminal quick fix provider "${E}" is already registered`);return this._quickFixProviders.set(E,F),this._proxy.$registerQuickFixProvider(E,S),new v.Disposable(()=>{this._quickFixProviders.delete(E),this._proxy.$unregisterQuickFixProvider(E)})}async $provideTerminalQuickFixes(E,S){const F=new u.CancellationTokenSource().token;if(F.isCancellationRequested)return;const N=this._quickFixProviders.get(E);if(!N)return;const O=await N.provideTerminalQuickFixes(S,F);if(O===null||Array.isArray(O)&&O.length===0)return;const M=new R.DisposableStore;if(this._lastQuickFixCommands.value=M,!Array.isArray(O))return O?f.TerminalQuickFix.from(O,this._extHostCommands.converter,M):void 0;const U=[];for(const x of O){const z=f.TerminalQuickFix.from(x,this._extHostCommands.converter,M);z&&U.push(z)}return U}async $createContributedProfileTerminal(E,S){const F=new u.CancellationTokenSource().token;let N=await this._profileProviders.get(E)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${E}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,S);return}this.createTerminalFromOptions(N.options,S)}}async $provideLinks(E,S){const F=this.getTerminalById(E);if(!F)return[];this._terminalLinkCache.delete(E),this._terminalLinkCancellationSource.get(E)?.dispose(!0);const O=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(E,O);const M=[],U={terminal:F.value,line:S},x=[];for(const ee of this._linkProviders)x.push(p.Promises.withAsyncBody(async V=>{O.token.onCancellationRequested(()=>V({provider:ee,links:[]}));const $=await ee.provideTerminalLinks(U,O.token)||[];O.token.isCancellationRequested||V({provider:ee,links:$})}));const z=await Promise.all(x);if(O.token.isCancellationRequested)return[];const B=new Map;for(const ee of z)ee&&ee.links.length>0&&M.push(...ee.links.map(V=>{const $={id:n++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return B.set($.id,{provider:ee.provider,link:V}),$}));return this._terminalLinkCache.set(E,B),M}$activateLink(E,S){const F=this._terminalLinkCache.get(E)?.get(S);F&&F.provider.handleTerminalLink(F.link)}_onProcessExit(E,S){this._bufferer.stopBuffering(E),this._terminalProcesses.delete(E),delete this._extensionTerminalAwaitingStart[E];const F=this._terminalProcessDisposables[E];F&&(F.dispose(),delete this._terminalProcessDisposables[E]),this._proxy.$sendProcessExit(E,S)}getTerminalById(E){return this._getTerminalObjectById(this._terminals,E)}getTerminalIdByApiObject(E){const S=this._terminals.findIndex(F=>F.value===E);return S>=0?S:null}_getTerminalObjectById(E,S){const F=this._getTerminalObjectIndexById(E,S);return F!==null?E[F]:null}_getTerminalObjectIndexById(E,S){const F=E.findIndex(N=>N._id===S);return F>=0?F:null}getEnvironmentVariableCollection(E){let S=this._environmentVariableCollections.get(E.identifier.value);return S||(S=this._register(new c),this._setEnvironmentVariableCollection(E.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(E,S){const F=(0,y.serializeEnvironmentVariableCollection)(S.map),N=(0,y.serializeEnvironmentDescriptionMap)(S.descriptionMap);this._proxy.$setEnvironmentVariableCollection(E,S.persistent,F.length===0?void 0:F,N)}$initEnvironmentVariableCollections(E){E.forEach(S=>{const F=S[0],N=this._register(new c(S[1]));this._setEnvironmentVariableCollection(F,N)})}$acceptDefaultProfile(E,S){const F=this._defaultProfile;this._defaultProfile=E,this._defaultAutomationProfile=S,F?.path!==E.path&&this._onDidChangeShell.fire(E.path)}_setEnvironmentVariableCollection(E,S){this._environmentVariableCollections.set(E,S),this._register(S.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(E,S)}))}};e.BaseExtHostTerminalService=h,e.BaseExtHostTerminalService=h=Xe([He(1,i.IExtHostCommands),He(2,L.IExtHostRpcService)],h);class c extends R.Disposable{get persistent(){return this._persistent}set persistent(E){this._persistent=E,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(E){super(),this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(E)}getScopedEnvironmentVariableCollection(E){const S=this.getScopeKey(E);let F=this.scopedCollections.get(S);return F||(F=new g(this,E),this.scopedCollections.set(S,F),this._register(F.onDidChangeCollection(()=>this._onDidChangeCollection.fire()))),F}replace(E,S,F,N){this._setIfDiffers(E,{value:S,type:v.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:N})}append(E,S,F,N){this._setIfDiffers(E,{value:S,type:v.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:N})}prepend(E,S,F,N){this._setIfDiffers(E,{value:S,type:v.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:N})}_setIfDiffers(E,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.getKey(E,S.scope),N=this.map.get(F),O=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==S.value||N.type!==S.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const M=this.getKey(E,S.scope),U={variable:E,...S,options:O};this.map.set(M,U),this._onDidChangeCollection.fire()}}get(E,S){const F=this.getKey(E,S),N=this.map.get(F);return N?C(N):void 0}getKey(E,S){const F=this.getScopeKey(S);return F.length?`${E}:::${F}`:E}getScopeKey(E){return this.getWorkspaceKey(E?.workspaceFolder)??""}getWorkspaceKey(E){return E?E.uri.toString():void 0}getVariableMap(E){const S=new Map;for(const[F,N]of this.map)this.getScopeKey(N.scope)===this.getScopeKey(E)&&S.set(N.variable,C(N));return S}delete(E,S){const F=this.getKey(E,S);this.map.delete(F),this._onDidChangeCollection.fire()}clear(E){if(E?.workspaceFolder){for(const[S,F]of this.map)F.scope?.workspaceFolder?.index===E.workspaceFolder.index&&this.map.delete(S);this.clearDescription(E)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(E,S){const F=this.getScopeKey(S),N=this.descriptionMap.get(F);if(!N||N.description!==E){let O;typeof E=="string"?O=E:O=E?.value.split(`

`)[0];const M={description:O,scope:S};this.descriptionMap.set(F,M),this._onDidChangeCollection.fire()}}getDescription(E){const S=this.getScopeKey(E);return this.descriptionMap.get(S)?.description}clearDescription(E){const S=this.getScopeKey(E);this.descriptionMap.delete(S)}}class g{get persistent(){return this.collection.persistent}set persistent(E){this.collection.persistent=E}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(E,S){this.collection=E,this.scope=S,this._onDidChangeCollection=new r.Emitter}getScoped(E){return this.collection.getScopedEnvironmentVariableCollection(E)}replace(E,S,F){this.collection.replace(E,S,F,this.scope)}append(E,S,F){this.collection.append(E,S,F,this.scope)}prepend(E,S,F){this.collection.prepend(E,S,F,this.scope)}get(E){return this.collection.get(E,this.scope)}forEach(E,S){this.collection.getVariableMap(this.scope).forEach((F,N)=>E.call(S,N,F,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(E){this.collection.delete(E,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(E){this.collection.setDescription(E,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let w=class extends h{constructor(E,S){super(!1,E,S)}createTerminal(E,S,F){throw new I.NotSupportedError}createTerminalFromOptions(E,S){throw new I.NotSupportedError}};e.WorkerExtHostTerminalService=w,e.WorkerExtHostTerminalService=w=Xe([He(0,i.IExtHostCommands),He(1,L.IExtHostRpcService)],w);function D(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function _(A){return m.ThemeColor.isThemeColor(A)?A:void 0}function C(A){const E={...A};return delete E.scope,E.options=E.options??void 0,delete E.variable,E}}),define(Ce[167],Ie([1,0,9,3,5,6,19,48,4,2,7]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,P.createDecorator)("IExtHostTerminalShellIntegration");let y=class extends d.Disposable{constructor(m,p){super(),this._extHostTerminalService=p,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new v.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new v.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new v.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=m.getProxy(k.MainContext.MainThreadTerminalShellIntegration),this._register((0,d.toDisposable)(()=>{for(const[f,i]of this._activeShellIntegrations)i.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(m){const p=this._extHostTerminalService.getTerminalById(m);if(!p)return;const f=p.value;let i=this._activeShellIntegrations.get(m);i||(i=new u(p.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(m,i),i.store.add(p.onWillDispose(()=>this._activeShellIntegrations.get(m)?.dispose())),i.store.add(i.onDidRequestShellExecution(s=>this._proxy.$executeCommand(m,s))),i.store.add(i.onDidRequestEndExecution(s=>this._onDidEndTerminalShellExecution.fire(s))),i.store.add(i.onDidRequestChangeShellIntegration(s=>this._onDidChangeTerminalShellIntegration.fire(s))),p.shellIntegration=i.value),this._onDidChangeTerminalShellIntegration.fire({terminal:f,shellIntegration:i.value})}$shellExecutionStart(m,p,f,i,s){this._activeShellIntegrations.has(m)||this.$shellIntegrationChange(m);const t={value:p,confidence:f,isTrusted:i};this._activeShellIntegrations.get(m)?.startShellExecution(t,l.URI.revive(s))}$shellExecutionEnd(m,p,f,i,s){const t={value:p,confidence:f,isTrusted:i};this._activeShellIntegrations.get(m)?.endShellExecution(t,s)}$shellExecutionData(m,p){this._activeShellIntegrations.get(m)?.emitData(p)}$cwdChange(m,p){this._activeShellIntegrations.get(m)?.setCwd(l.URI.revive(p))}$closeTerminal(m){this._activeShellIntegrations.get(m)?.dispose(),this._activeShellIntegrations.delete(m)}};e.ExtHostTerminalShellIntegration=y,e.ExtHostTerminalShellIntegration=y=Xe([He(0,L.IExtHostRpcService),He(1,R.IExtHostTerminalService)],y);class u extends d.Disposable{get currentExecution(){return this._currentExecution}constructor(m,p){super(),this._terminal=m,this._onDidStartTerminalShellExecution=p,this._ignoreNextExecution=!1,this.store=this._register(new d.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new v.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new v.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new v.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const f=this;this.value={get cwd(){return f._cwd},executeCommand(i,s){let t=i;s&&(t+=` "${s.map(h=>`${h.replaceAll('"','\\"')}`).join('" "')}"`),f._onDidRequestShellExecution.fire(t);const o={value:t,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},n=f.startShellExecution(o,f._cwd,!0).value;return f._ignoreNextExecution=!0,n}}}startShellExecution(m,p,f){if(this._ignoreNextExecution&&this._currentExecution)this._ignoreNextExecution=!1;else{this._currentExecution&&(this._currentExecution.endExecution(void 0),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:void 0}));const i=this._currentExecution=new T(m,p??this._cwd);f?queueMicrotask(()=>this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:i.value})):this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value})}return this._currentExecution}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,p){this._currentExecution&&(this._currentExecution.endExecution(m),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:p}),this._currentExecution=void 0)}setCwd(m){let p=!1;l.URI.isUri(this._cwd)?p=!l.URI.isUri(m)||this._cwd.toString()!==m.toString():this._cwd!==m&&(p=!0),p&&(this._cwd=m,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class T{constructor(m,p){this._commandLine=m,this.cwd=p,this._ended=!1;const f=this;this.value={get commandLine(){return f._commandLine},get cwd(){return f.cwd},read(){return f._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._ended)return I.AsyncIterableObject.EMPTY;this._dataStream=new b}return this._dataStream.createIterable()}emitData(m){this._dataStream?.emitData(m)}endExecution(m){m&&(this._commandLine=m),this._dataStream?.endExecution(),this._dataStream=void 0,this._ended=!0}}class b extends d.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){this._barrier||(this._barrier=new I.Barrier);const m=this._barrier;return new I.AsyncIterableObject(async f=>{this._emitters.push(f),await m.wait()})}emitData(m){for(const p of this._emitters)p.emitOne(m)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(Ce[168],Ie([1,0,65,13,132,15,9]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0,k=$e(k);class R{static{this._Keys=new P.IdGenerator("TextEditorDecorationType")}constructor(u,T,b){const a=R._Keys.nextId();u.$registerTextEditorDecorationType(T.identifier,a,k.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:a,dispose(){u.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=R;class v{constructor(u,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,T){this._throwIfFinalized();let b=null;if(u instanceof L.Position)b=new L.Range(u,u);else if(u instanceof L.Range)b=u;else throw new Error("Unrecognized location");this._pushEdit(b,T,!1)}insert(u,T){this._throwIfFinalized(),this._pushEdit(new L.Range(u,u),T,!0)}delete(u){this._throwIfFinalized();let T=null;if(u instanceof L.Range)T=u;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(u,T,b){const a=this._document.validateRange(u);this._collectedEdits.push({range:a,text:T,forceMoveMarkers:b})}setEndOfLine(u){if(this._throwIfFinalized(),u!==L.EndOfLine.LF&&u!==L.EndOfLine.CRLF)throw(0,d.illegalArgument)("endOfLine");this._setEndOfLine=u}}class l{constructor(u,T,b,a){this._proxy=u,this._id=T,this._accept(b),this._logService=a;const m=this;this.value={get tabSize(){return m._tabSize},set tabSize(p){m._setTabSize(p)},get indentSize(){return m._indentSize},set indentSize(p){m._setIndentSize(p)},get insertSpaces(){return m._insertSpaces},set insertSpaces(p){m._setInsertSpaces(p)},get cursorStyle(){return m._cursorStyle},set cursorStyle(p){m._setCursorStyle(p)},get lineNumbers(){return m._lineNumbers},set lineNumbers(p){m._setLineNumbers(p)}}}_accept(u){this._tabSize=u.tabSize,this._indentSize=u.indentSize,this._originalIndentSize=u.originalIndentSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=k.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const T=Math.floor(u);return T>0?T:null}if(typeof u=="string"){const T=parseInt(u,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(u){const T=this._validateTabSize(u);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateIndentSize(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const T=Math.floor(u);return T>0?T:null}if(typeof u=="string"){const T=parseInt(u,10);return isNaN(T)?null:T>0?T:null}return null}_setIndentSize(u){const T=this._validateIndentSize(u);if(T!==null){if(typeof T=="number"){if(this._originalIndentSize===T)return;this._indentSize=T,this._originalIndentSize=T}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:T}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:!!u}_setInsertSpaces(u){const T=this._validateInsertSpaces(u);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:k.TextEditorLineNumbersStyle.from(u)})))}assign(u){const T={};let b=!1;if(typeof u.tabSize<"u"){const a=this._validateTabSize(u.tabSize);a==="auto"?(b=!0,T.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,b=!0,T.tabSize=a)}if(typeof u.indentSize<"u"){const a=this._validateIndentSize(u.indentSize);a==="tabSize"?(b=!0,T.indentSize=a):typeof a=="number"&&this._originalIndentSize!==a&&(this._indentSize=a,this._originalIndentSize=a,b=!0,T.indentSize=a)}if(typeof u.insertSpaces<"u"){const a=this._validateInsertSpaces(u.insertSpaces);a==="auto"?(b=!0,T.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,b=!0,T.insertSpaces=a)}typeof u.cursorStyle<"u"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,b=!0,T.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,b=!0,T.lineNumbers=k.TextEditorLineNumbersStyle.from(u.lineNumbers)),b&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(u,T){T.catch(b=>{this._logService.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this._logService.warn(b)})}}e.ExtHostTextEditorOptions=l;class I{constructor(u,T,b,a,m,p,f,i){this.id=u,this._proxy=T,this._logService=b,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._options=new l(this._proxy,this.id,p,b),this._visibleRanges=f,this._viewColumn=i;const s=this;this.value=Object.freeze({get document(){return a.value},set document(t){throw new d.ReadonlyError("document")},get selection(){return s._selections&&s._selections[0]},set selection(t){if(!(t instanceof L.Selection))throw(0,d.illegalArgument)("selection");s._selections=[t],s._trySetSelection()},get selections(){return s._selections},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof L.Selection)))throw(0,d.illegalArgument)("selections");s._selections=t,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(t){throw new d.ReadonlyError("visibleRanges")},get options(){return s._options.value},set options(t){s._disposed||s._options.assign(t)},get viewColumn(){return s._viewColumn},set viewColumn(t){throw new d.ReadonlyError("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new v(a.value,o);return t(n),s._applyEdit(n)},insertSnippet(t,o,n={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!o||Array.isArray(o)&&o.length===0)h=s._selections.map(c=>k.Range.from(c));else if(o instanceof L.Position){const{lineNumber:c,column:g}=k.Position.from(o);h=[{startLineNumber:c,startColumn:g,endLineNumber:c,endColumn:g}]}else if(o instanceof L.Range)h=[k.Range.from(o)];else{h=[];for(const c of o)if(c instanceof L.Range)h.push(k.Range.from(c));else{const{lineNumber:g,column:w}=k.Position.from(c);h.push({startLineNumber:g,startColumn:w,endLineNumber:g,endColumn:w})}}return T.$tryInsertSnippet(u,a.value.version,t.value,h,n)},setDecorations(t,o){const n=o.length===0;n&&!s._hasDecorationsForKey.has(t.key)||(n?s._hasDecorationsForKey.delete(t.key):s._hasDecorationsForKey.add(t.key),s._runOnProxy(()=>{if(k.isDecorationOptionsArr(o))return T.$trySetDecorations(u,t.key,k.fromRangeOrRangeWithMessage(o));{const h=new Array(4*o.length);for(let c=0,g=o.length;c<g;c++){const w=o[c];h[4*c]=w.start.line+1,h[4*c+1]=w.start.character+1,h[4*c+2]=w.end.line+1,h[4*c+3]=w.end.character+1}return T.$trySetDecorationsFast(u,t.key,h)}}))},revealRange(t,o){s._runOnProxy(()=>T.$tryRevealRange(u,k.Range.from(t),o||L.TextEditorRevealType.Default))},show(t){T.$tryShowEditor(u,k.ViewColumn.from(t))},hide(){T.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,r.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,r.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,r.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(k.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const T=u.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const b=T.edits.map(m=>m.range);b.sort((m,p)=>m.end.line===p.end.line?m.end.character===p.end.character?m.start.line===p.start.line?m.start.character-p.start.character:m.start.line-p.start.line:m.end.character-p.end.character:m.end.line-p.end.line);for(let m=0,p=b.length-1;m<p;m++){const f=b[m].end;if(b[m+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=T.edits.map(m=>({range:k.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,a,{setEndOfLine:typeof T.setEndOfLine=="number"?k.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=I}),define(Ce[63],Ie([1,0,65,4,3,2,5,6,164,19,168,15,11,28,14,39,50]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0,r=$e(r),y=$e(y);class p{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let f=class{constructor(s,t){this._extHostRpc=s,this._logService=t,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new d.Emitter,this._onDidRemoveDocuments=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const t=[],o=[],n=[];if(s.removedDocuments)for(const h of s.removedDocuments){const c=k.URI.revive(h),g=this._documents.get(c);g?.unref()&&(this._documents.delete(c),t.push(g.value))}if(s.addedDocuments)for(const h of s.addedDocuments){const c=k.URI.revive(h.uri);let g=this._documents.get(c);if(g&&c.scheme!==b.Schemas.vscodeNotebookCell&&c.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);g||(g=new p(new v.ExtHostDocumentData(this._extHostRpc.getProxy(R.MainContext.MainThreadDocuments),c,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty)),this._documents.set(c,g),o.push(g.value)),g.ref()}if(s.removedEditors)for(const h of s.removedEditors){const c=this._editors.get(h);this._editors.delete(h),c&&n.push(c)}if(s.addedEditors)for(const h of s.addedEditors){const c=k.URI.revive(h.documentUri);r.ok(this._documents.has(c),`document '${c}' does not exist`),r.ok(!this._editors.has(h.id),`editor '${h.id}' already exists!`);const g=this._documents.get(c).value,w=new I.ExtHostTextEditor(h.id,this._extHostRpc.getProxy(R.MainContext.MainThreadTextEditors),this._logService,new m.Lazy(()=>g.document),h.selections.map(y.Selection.to),h.options,h.visibleRanges.map(D=>y.Range.to(D)),typeof h.editorPosition=="number"?y.ViewColumn.to(h.editorPosition):void 0);this._editors.set(h.id,w)}s.newActiveEditor!==void 0&&(r.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,P.dispose)(t),(0,P.dispose)(n),s.removedDocuments&&this._onDidRemoveDocuments.fire(t),s.addedDocuments&&this._onDidAddDocuments.fire(o),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(h=>h.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const t=this._editors.get(this._activeEditorId);return s?t:t?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=f,e.ExtHostDocumentsAndEditors=f=Xe([He(0,l.IExtHostRpcService),He(1,u.ILogService)],f),e.IExtHostDocumentsAndEditors=(0,L.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[98],Ie([1,0,7,21,20,4,79,60,3,40,17,2,32,5,11,6,34,63,19,166,15,9,264,73,120,74,25]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=e.IExtHostTesting=void 0,s=$e(s);let w=0;const D=new WeakMap;e.IExtHostTesting=(0,T.createDecorator)("IExtHostTesting");let _=class extends v.Disposable{constructor($,G,Z,le){super(),this.logService=G,this.commands=Z,this.editors=le,this.resultsChangedEmitter=this._register(new k.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new k.Emitter),this.followupProviders=new Set,this.testFollowups=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=$.getProxy(a.MainContext.MainThreadTesting),this.observer=new U(this.proxy),this.runTracker=new S(this.proxy,G),Z.registerArgumentProcessor({processArgument:ne=>{switch(ne?.$mid){case l.MarshalledId.TestItemContext:{const _e=ne,ge=_e.tests[_e.tests.length-1].item.extId;return this.controllers.get(n.TestId.root(ge))?.collection.tree.get(ge)?.actual??(0,i.toItemFromContext)(ne)}case l.MarshalledId.TestMessageMenuArgs:{const{test:_e,message:ge}=ne,Y=_e.item.extId;return{test:this.controllers.get(n.TestId.root(Y))?.collection.tree.get(Y)?.actual??(0,i.toItemFromContext)({$mid:l.MarshalledId.TestItemContext,tests:[_e]}),message:s.TestMessage.to(ge)}}default:return ne}}}),Z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ne=await Z.executeCommand(o.TestCommandId.GetExplorerSelection),_e=ge=>{const Y=this.controllers.get(n.TestId.root(ge));if(Y)return n.TestId.isRoot(ge)?Y.controller:Y.collection.tree.get(ge)?.actual};return{include:ne?.include.map(_e).filter(I.isDefined)||[],exclude:ne?.exclude.map(_e).filter(I.isDefined)||[]}})}createTestController($,G,Z,le){if(this.controllers.has(G))throw new Error(`Attempt to insert a duplicate controller with ID "${G}"`);const ne=new v.DisposableStore,_e=ne.add(new i.ExtHostTestItemCollection(G,Z,this.editors));_e.root.label=Z;const ge=new Map,Y=new Set,W=this.proxy,oe=()=>{let ae=0;le&&(ae|=c.TestControllerCapability.Refresh);const se=te.relatedCodeProvider;return se&&(se?.provideRelatedTests&&(ae|=c.TestControllerCapability.TestRelatedToCode),se?.provideRelatedCode&&(ae|=c.TestControllerCapability.CodeRelatedToTest)),ae},Se={items:_e.root.children,get label(){return Z},set label(ae){Z=ae,_e.root.label=ae,W.$updateController(G,{label:Z})},get refreshHandler(){return le},set refreshHandler(ae){le=ae,W.$updateController(G,{capabilities:oe()})},get id(){return G},get relatedCodeProvider(){return te.relatedCodeProvider},set relatedCodeProvider(ae){(0,g.checkProposedApiEnabled)($,"testRelatedCode"),te.relatedCodeProvider=ae,W.$updateController(G,{capabilities:oe()})},createRunProfile:(ae,se,Q,re,ve,be)=>{let Fe=(0,R.hash)(ae);for(;ge.has(Fe);)Fe++;return new z(this.proxy,ge,Y,this.defaultProfilesChangedEmitter.event,G,Fe,ae,se,Q,re,ve,be)},createTestItem(ae,se,Q){return new i.TestItemImpl(G,ae,se,Q)},createTestRun:(ae,se,Q=!0)=>this.runTracker.createTestRun($,G,_e,ae,se,Q),invalidateTestResults:ae=>{if(ae===void 0)this.proxy.$markTestRetired(void 0);else{const se=ae instanceof Array?ae:[ae];this.proxy.$markTestRetired(se.map(Q=>n.TestId.fromExtHostTestItem(Q,G).toString()))}},set resolveHandler(ae){_e.resolveHandler=ae},get resolveHandler(){return _e.resolveHandler},dispose:()=>{ne.dispose()}},te={controller:Se,collection:_e,profiles:ge,extension:$,activeProfiles:Y};return W.$registerTestController(G,Z,oe()),ne.add((0,v.toDisposable)(()=>W.$unregisterTestController(G))),this.controllers.set(G,te),ne.add((0,v.toDisposable)(()=>this.controllers.delete(G))),ne.add(_e.onDidGenerateDiff(ae=>W.$publishDiff(G,ae.map(c.TestsDiffOp.serialize)))),Se}createTestObserver(){return this.observer.checkout()}async runTests($,G=P.CancellationToken.None){const Z=F($);if(!Z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const le=this.controllers.get(Z.controllerId);if(!le)throw new Error("Controller not found");await this.proxy.$runTests({preserveFocus:$.preserveFocus??!0,group:B[Z.kind],targets:[{testIds:$.include?.map(ne=>n.TestId.fromExtHostTestItem(ne,le.collection.root.id).toString())??[le.collection.root.id],profileId:Z.profileId,controllerId:Z.controllerId}],exclude:$.exclude?.map(ne=>ne.id)},G)}registerTestFollowupProvider($){return this.followupProviders.add($),{dispose:()=>{this.followupProviders.delete($)}}}async $getTestsRelatedToCode($,G,Z){const le=this.editors.getDocument(y.URI.revive($));if(!le)return[];const ne=s.Position.to(G),_e=[];return await Promise.all([...this.controllers.values()].map(async ge=>{let Y;try{Y=await ge.relatedCodeProvider?.provideRelatedTests?.(le.document,ne,Z)}catch(W){Z.isCancellationRequested||this.logService.warn(`Error thrown while providing related tests for ${ge.controller.label}`,W)}if(Y){for(const W of Y)_e.push(n.TestId.fromExtHostTestItem(W,ge.controller.id).toString());ge.collection.flushDiff()}})),_e}async $getCodeRelatedToTest($,G){const Z=this.controllers.get(n.TestId.root($));if(!Z)return[];const le=Z.collection.tree.get($);return le?(await Z.relatedCodeProvider?.provideRelatedCode?.(le.actual,G))?.map(s.location.from)??[]:[]}$syncTests(){for(const{collection:$}of this.controllers.values())$.flushDiff();return Promise.resolve()}async $getCoverageDetails($,G,Z){return(await this.runTracker.getCoverageDetails($,G,Z))?.map(s.TestCoverage.fromDetails)}async $disposeRun($){this.runTracker.disposeTestRun($)}$configureRunProfile($,G){this.controllers.get($)?.profiles.get(G)?.configureHandler?.()}$setDefaultRunProfiles($){const G=new Map;for(const[Z,le]of Object.entries($)){const ne=this.controllers.get(Z);if(!ne)continue;const _e=new Map,ge=le.filter(W=>!ne.activeProfiles.has(W)),Y=[...ne.activeProfiles].filter(W=>!le.includes(W));for(const W of ge)_e.set(W,!0),ne.activeProfiles.add(W);for(const W of Y)_e.set(W,!1),ne.activeProfiles.delete(W);_e.size&&G.set(Z,_e)}this.defaultProfilesChangedEmitter.fire(G)}async $refreshTests($,G){await this.controllers.get($)?.controller.refreshHandler?.(G)}$publishTestResults($){this.results=Object.freeze($.map(G=>{const Z=s.TestResults.to(G);return D.set(Z,G.id),Z}).concat(this.results).sort((G,Z)=>Z.completedAt-G.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest($,G){const Z=this.controllers.get(n.TestId.fromString($).controllerId)?.collection;Z&&(await Z.expand($,G<0?1/0:G),Z.flushDiff())}$acceptDiff($){this.observer.applyDiff($.map(G=>c.TestsDiffOp.deserialize({asCanonicalUri:Z=>Z},G)))}async $runControllerTests($,G){return Promise.all($.map(Z=>this.runControllerTestRequest(Z,!1,G)))}async $startContinuousRun($,G){const Z=new P.CancellationTokenSource(G),le=await Promise.all($.map(ne=>this.runControllerTestRequest(ne,!0,Z.token)));return!G.isCancellationRequested&&!le.some(ne=>ne.error)&&await new Promise(ne=>G.onCancellationRequested(ne)),Z.dispose(!0),le}async $provideTestFollowups($,G){const Z=this.results.find(_e=>D.get(_e)===$.resultId),le=Z&&ee(n.TestId.fromString($.extId),Z?.results);if(!le)return[];let ne=[];return await Promise.all([...this.followupProviders].map(async _e=>{try{const ge=await _e.provideFollowup(Z,le,$.taskIndex,$.messageIndex,G);ge&&(ne=ne.concat(ge))}catch(ge){this.logService.error("Error thrown while providing followup for test message",ge)}})),G.isCancellationRequested?[]:ne.map(_e=>{const ge=w++;return this.testFollowups.set(ge,_e),{title:_e.title,id:ge}})}$disposeTestFollowups($){for(const G of $)this.testFollowups.delete(G)}$executeTestFollowup($){const G=this.testFollowups.get($);return G?this.commands.executeCommand(G.command,...G.arguments||[]):Promise.resolve()}$cancelExtensionTestRun($){$===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById($)}getMetadataForRun($){for(const G of this.runTracker.trackers){const Z=G.getTaskIdForRun($);if(Z)return{taskId:Z,runId:G.id}}}async runControllerTestRequest($,G,Z){const le=this.controllers.get($.controllerId);if(!le)return{};const{collection:ne,profiles:_e,extension:ge}=le,Y=_e.get($.profileId);if(!Y)return{};const W=$.testIds.map(ae=>ne.tree.get(ae)).filter(I.isDefined),oe=$.excludeExtIds.map(ae=>le.collection.tree.get(ae)).filter(I.isDefined).filter(ae=>W.some(se=>se.fullId.compare(ae.fullId)===n.TestPosition.IsChild));if(!W.length)return{};const Se=new t.TestRunRequest(W.some(ae=>ae.actual instanceof i.TestItemRootImpl)?void 0:W.map(ae=>ae.actual),oe.map(ae=>ae.actual),Y,G),te=(0,c.isStartControllerTests)($)&&this.runTracker.prepareForMainThreadTestRun(ge,Se,N.fromInternal($,le.collection),Y,Z);try{return await Y.runHandler(Se,Z),{}}catch(ae){return{error:String(ae)}}finally{te&&te.hasRunningTasks&&!Z.isCancellationRequested&&await k.Event.toPromise(te.onEnd)}}};e.ExtHostTesting=_,e.ExtHostTesting=_=Xe([He(0,f.IExtHostRpcService),He(1,b.ILogService),He(2,m.IExtHostCommands),He(3,p.IExtHostDocumentsAndEditors)],_);const C=1e4;var A;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(A||(A={}));class E extends v.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor($,G,Z,le,ne,_e){super(),this.dto=$,this.proxy=G,this.logService=Z,this.profile=le,this.extension=ne,this.state=A.Running,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new P.CancellationTokenSource(_e));const ge=this._register(new r.RunOnceScheduler(()=>this.forciblyEndTasks(),C));this._register(this.cts.token.onCancellationRequested(()=>ge.schedule()));const Y=new k.Emitter;this.onDidDispose=Y.event,this._register((0,v.toDisposable)(()=>{Y.fire(),Y.dispose()}))}getTaskIdForRun($){for(const[G,{run:Z}]of this.tasks)if(Z===$)return G}cancel(){this.state===A.Running?(this.cts.cancel(),this.state=A.Cancelling):this.state===A.Cancelling&&this.forciblyEndTasks()}async getCoverageDetails($,G,Z){const[,le]=n.TestId.fromString($).path,ne=this.publishedCoverage.get($);if(!ne)return[];const{report:_e,extIds:ge}=ne,Y=this.tasks.get(le);if(!Y)throw new Error("unreachable: run task was not found");let W;if(G&&_e instanceof t.FileCoverage){const Se=ge.indexOf(G);if(Se===-1)return[];W=_e.fromTests[Se]}return await(W?this.profile?.loadDetailedCoverageForTest?.(Y.run,_e,W,Z):this.profile?.loadDetailedCoverage?.(Y.run,_e,Z))??[]}createRun($){const G=this.dto.id,Z=this.dto.controllerId,le=(0,u.generateUuid)(),ne=W=>(oe,...Se)=>{if(ge){this.logService.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.ensureTestIsKnown(oe),W(oe,...Se)},_e=(W,oe)=>{const Se=oe instanceof Array?oe.map(s.TestMessage.from):[s.TestMessage.from(oe)];if(W.uri&&W.range){const te={range:s.Range.from(W.range),uri:W.uri};for(const ae of Se)ae.location=ae.location||te}this.proxy.$appendTestMessagesInRun(G,le,n.TestId.fromExtHostTestItem(W,Z).toString(),Se)};let ge=!1;const Y={isPersisted:this.dto.isPersisted,token:this.cts.token,name:$,onDidDispose:this.onDidDispose,addCoverage:W=>{if(ge)return;const oe=W instanceof t.FileCoverage?W.fromTests:[];if(oe.length){(0,g.checkProposedApiEnabled)(this.extension,"attributableCoverage");for(const ae of oe)this.ensureTestIsKnown(ae)}const Se=W.uri.toString(),te=new n.TestId([G,le,Se]).toString();this.publishedCoverage.set(te,{report:W,extIds:oe.map(ae=>n.TestId.fromExtHostTestItem(ae,Z).toString())}),this.proxy.$appendCoverage(G,le,s.TestCoverage.fromFile(Z,te,W))},enqueued:ne(W=>{this.proxy.$updateTestStateInRun(G,le,n.TestId.fromExtHostTestItem(W,Z).toString(),c.TestResultState.Queued)}),skipped:ne(W=>{this.proxy.$updateTestStateInRun(G,le,n.TestId.fromExtHostTestItem(W,Z).toString(),c.TestResultState.Skipped)}),started:ne(W=>{this.proxy.$updateTestStateInRun(G,le,n.TestId.fromExtHostTestItem(W,Z).toString(),c.TestResultState.Running)}),errored:ne((W,oe,Se)=>{_e(W,oe),this.proxy.$updateTestStateInRun(G,le,n.TestId.fromExtHostTestItem(W,Z).toString(),c.TestResultState.Errored,Se)}),failed:ne((W,oe,Se)=>{_e(W,oe),this.proxy.$updateTestStateInRun(G,le,n.TestId.fromExtHostTestItem(W,Z).toString(),c.TestResultState.Failed,Se)}),passed:ne((W,oe)=>{this.proxy.$updateTestStateInRun(G,le,n.TestId.fromExtHostTestItem(W,this.dto.controllerId).toString(),c.TestResultState.Passed,oe)}),appendOutput:(W,oe,Se)=>{ge||(Se&&this.ensureTestIsKnown(Se),this.proxy.$appendOutputToRun(G,le,d.VSBuffer.fromString(W),oe&&s.location.from(oe),Se&&n.TestId.fromExtHostTestItem(Se,Z).toString()))},end:()=>{ge||(ge=!0,this.proxy.$finishedTestRunTask(G,le),--this.running||this.markEnded())}};return this.running++,this.tasks.set(le,{run:Y}),this.proxy.$startedTestRunTask(G,{id:le,ctrlId:this.dto.controllerId,name:$,running:!0}),Y}forciblyEndTasks(){for(const{run:$}of this.tasks.values())$.end()}markEnded(){this.state!==A.Ended&&(this.state=A.Ended,this.endEmitter.fire())}ensureTestIsKnown($){if(!($ instanceof i.TestItemImpl))throw new h.InvalidTestItemError($.id);if(this.sharedTestIds.has(n.TestId.fromExtHostTestItem($,this.dto.controllerId).toString()))return;const G=[],Z=this.dto.colllection.root;for(;;){const le=s.TestItem.from($);if(G.unshift(le),this.sharedTestIds.has(le.extId)||(this.sharedTestIds.add(le.extId),$===Z))break;$=$.parent||Z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,G)}dispose(){this.markEnded(),super.dispose()}}class S{get trackers(){return this.tracked.values()}constructor($,G){this.proxy=$,this.logService=G,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails($,G,Z){const le=n.TestId.root($);return this.trackedById.get(le)?.getCoverageDetails($,G,Z)||[]}disposeTestRun($){this.trackedById.get($)?.dispose(),this.trackedById.delete($);for(const[G,{id:Z}]of this.tracked)Z===$&&this.tracked.delete(G)}prepareForMainThreadTestRun($,G,Z,le,ne){return this.getTracker(G,Z,le,$,ne)}cancelRunById($){this.trackedById.get($)?.cancel()}cancelAllRuns(){for(const $ of this.tracked.values())$.cancel()}createTestRun($,G,Z,le,ne,_e){const ge=this.tracked.get(le);if(ge)return ge.createRun(ne);const Y=N.fromPublic(G,Z,le,_e),W=F(le);this.proxy.$startedExtensionTestRun({controllerId:G,continuous:!!le.continuous,profile:W&&{group:B[W.kind],id:W.profileId},exclude:le.exclude?.map(Se=>n.TestId.fromExtHostTestItem(Se,Z.root.id).toString())??[],id:Y.id,include:le.include?.map(Se=>n.TestId.fromExtHostTestItem(Se,Z.root.id).toString())??[Z.root.id],preserveFocus:le.preserveFocus??!0,persist:_e});const oe=this.getTracker(le,Y,le.profile,$);return k.Event.once(oe.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(Y.id)}),oe.createRun(ne)}getTracker($,G,Z,le,ne){const _e=new E(G,this.proxy,this.logService,Z,le,ne);return this.tracked.set($,_e),this.trackedById.set(_e.id,_e),_e}}e.TestRunCoordinator=S;const F=V=>{if(V.profile){if(!(V.profile instanceof z))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class N{static fromPublic($,G,Z,le){return new N($,(0,u.generateUuid)(),le,G)}static fromInternal($,G){return new N($.controllerId,$.runId,!0,G)}constructor($,G,Z,le){this.controllerId=$,this.id=G,this.isPersisted=Z,this.colllection=le}}e.TestRunDto=N;class O{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor($){this.emitter=$,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add($){this.added.add($)}update($){Object.assign($.revived,s.TestItem.toPlain($.item)),this.added.has($)||this.updated.add($)}remove($){if(this.added.has($)){this.added.delete($);return}this.updated.delete($);const G=n.TestId.parentId($.item.extId);if(G&&this.alreadyRemoved.has(G.toString())){this.alreadyRemoved.add($.item.extId);return}this.removed.add($)}getChangeEvent(){const{added:$,updated:G,removed:Z}=this;return{get added(){return[...$].map(le=>le.revived)},get updated(){return[...G].map(le=>le.revived)},get removed(){return[...Z].map(le=>le.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class M extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById($){return this.items.get($)}getMirroredTestDataByReference($){return this.items.get($.id)}createItem($,G){return{...$,revived:s.TestItem.toPlain($.item),depth:G?G.depth+1:0,children:new Set}}createChangeCollector(){return new O(this.changeEmitter)}}class U{constructor($){this.proxy=$}checkout(){this.current||(this.current=this.createObserverData());const $=this.current;return $.observers++,{onDidChangeTest:$.tests.onDidChangeTests,get tests(){return[...$.tests.rootTests].map(G=>G.revived)},dispose:(0,L.createSingleCallFunction)(()=>{--$.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference($){return this.current?.tests.getMirroredTestDataByReference($)}applyDiff($){this.current?.tests.apply($)}createObserverData(){const $=new M({asCanonicalUri:G=>G});return this.proxy.$subscribeToDiffs(),{observers:0,tests:$}}}const x=(V,$,G,Z)=>{G?Object.assign(G,Z):$.$updateTestRunConfig(V.controllerId,V.profileId,Z)};class z{#e;#t;#i;#n;#s;get label(){return this._label}set label($){$!==this._label&&(this._label=$,x(this,this.#e,this.#n,{label:$}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun($){$!==this._supportsContinuousRun&&(this._supportsContinuousRun=$,x(this,this.#e,this.#n,{supportsContinuousRun:$}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault($){$!==this.isDefault&&($?this.#t.add(this.profileId):this.#t.delete(this.profileId),x(this,this.#e,this.#n,{isDefault:$}))}get tag(){return this._tag}set tag($){$?.id!==this._tag?.id&&(this._tag=$,x(this,this.#e,this.#n,{tag:$?s.TestTag.namespace(this.controllerId,$.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler($){$!==this._configureHandler&&(this._configureHandler=$,x(this,this.#e,this.#n,{hasConfigurationHandler:!!$}))}get onDidChangeDefault(){return k.Event.chain(this.#i,$=>$.map(G=>G.get(this.controllerId)?.get(this.profileId)).filter(I.isDefined))}constructor($,G,Z,le,ne,_e,ge,Y,W,oe=!1,Se=void 0,te=!1){this.controllerId=ne,this.profileId=_e,this._label=ge,this.kind=Y,this.runHandler=W,this._tag=Se,this._supportsContinuousRun=te,this.#e=$,this.#s=G,this.#t=Z,this.#i=le,G.set(_e,this);const ae=B[Y];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);oe&&Z.add(_e),this.#n={profileId:_e,controllerId:ne,tag:Se?s.TestTag.namespace(this.controllerId,Se.id):null,label:ge,group:ae,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:te},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=z;const B={[t.TestRunProfileKind.Coverage]:c.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:c.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:c.TestRunProfileBitset.Run};function ee(V,$){for(let G=0;G<V.path.length;G++){const Z=$.find(le=>le.id===V.path[G]);if(!Z)return;if(G===V.path.length-1)return Z;$=Z.children}}}),define(Ce[320],Ie([1,0,18,4,3,6,168,15,9]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0,r=$e(r),R=$e(R);class l extends P.Disposable{constructor(y,u){super(),this._extHostDocumentsAndEditors=u,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=y.getProxy(k.MainContext.MainThreadTextEditors),this._register(this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(T=>this._onDidChangeVisibleTextEditors.fire(T))),this._register(this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(T=>this._onDidChangeActiveTextEditor.fire(T)))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(y){const u=this._extHostDocumentsAndEditors.allEditors();return y?u:u.map(T=>T.value)}async showTextDocument(y,u,T){let b;typeof u=="number"?b={position:R.ViewColumn.from(u),preserveFocus:T}:typeof u=="object"?b={position:R.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?R.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:b={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(y.uri,b),m=a&&this._extHostDocumentsAndEditors.getEditor(a);if(m)return m.value;throw a?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,u){return new L.TextEditorDecorationType(this._proxy,y,u).value}$acceptEditorPropertiesChanged(y,u){const T=this._extHostDocumentsAndEditors.getEditor(y);if(!T)throw new Error("unknown text editor");if(u.options&&T._acceptOptions(u.options),u.selections){const b=u.selections.selections.map(R.Selection.to);T._acceptSelections(b)}if(u.visibleRanges){const b=r.coalesce(u.visibleRanges.map(R.Range.to));T._acceptVisibleRanges(b)}if(u.options&&this._onDidChangeTextEditorOptions.fire({textEditor:T.value,options:{...u.options,lineNumbers:R.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const b=v.TextEditorSelectionChangeKind.fromValue(u.selections.source),a=u.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:T.value,selections:a,kind:b})}if(u.visibleRanges){const b=r.coalesce(u.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:T.value,visibleRanges:b})}}$acceptEditorPositionData(y){for(const u in y){const T=this._extHostDocumentsAndEditors.getEditor(u);if(!T)throw new Error("Unknown text editor");const b=R.ViewColumn.to(y[u]);T.value.viewColumn!==b&&(T._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:T.value,viewColumn:b}))}}getDiffInformation(y){return Promise.resolve(this._proxy.$getDiffInformation(y))}}e.ExtHostEditors=l}),define(Ce[321],Ie([1,0,2,5,6,3,9,15,23,40,17]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,d.createDecorator)("IExtHostTimeline");class y{constructor(b,a){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=b.getProxy(P.MainContext.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(m,p)=>{if(m&&m.$mid===l.MarshalledId.TimelineActionContext)if(this._providers.get(m.source)&&v.ExtensionIdentifier.equals(p,this._providers.get(m.source)?.extension)){const f=m.uri===void 0?void 0:r.URI.revive(m.uri);return this._itemsBySourceAndUriMap.get(m.source)?.get(u(f))?.get(m.handle)}else return;return m}})}async $getTimeline(b,a,m,p){return this._providers.get(b)?.provider.provideTimeline(r.URI.revive(a),m,p)}registerTimelineProvider(b,a,m,p){const f=new k.DisposableStore,i=this.convertTimelineItem(a.id,p,f).bind(this);let s;a.onDidChange&&(s=a.onDidChange(o=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:a.id}),this));const t=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...a,scheme:b,onDidChange:void 0,async provideTimeline(o,n,h){n?.resetCache&&(f.clear(),t.get(a.id)?.clear());const c=await a.provideTimeline(o,n,h);if(c==null)return;const g=i(o,n);return{...c,source:a.id,items:c.items.map(g)}},dispose(){for(const o of t.values())o.get(a.id)?.clear();s?.dispose(),f.dispose()}},m)}convertTimelineItem(b,a,m){return(p,f)=>{let i;if(f?.cacheResults){let s=this._itemsBySourceAndUriMap.get(b);s===void 0&&(s=new Map,this._itemsBySourceAndUriMap.set(b,s));const t=u(p);i=s.get(t),i===void 0&&(i=new Map,s.set(t,i))}return s=>{const{iconPath:t,...o}=s,n=`${b}|${s.id??s.timestamp}`;i?.set(n,s);let h,c,g;s.iconPath&&(t instanceof L.ThemeIcon?g={id:t.id,color:t.color}:r.URI.isUri(t)?(h=t,c=t):{light:h,dark:c}=t);let w;return L.MarkdownString.isMarkdownString(o.tooltip)?w=R.MarkdownString.from(o.tooltip):(0,I.isString)(o.tooltip)?w=o.tooltip:L.MarkdownString.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=R.MarkdownString.from(o.detail)):(0,I.isString)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=o.detail),{...o,id:o.id??void 0,handle:n,source:b,command:s.command?a.toInternal(s.command,m):void 0,icon:h,iconDark:c,themeIcon:g,tooltip:w,accessibilityInformation:s.accessibilityInformation}}}}registerTimelineProviderCore(b,a){if(this._providers.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this._proxy.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this._providers.set(b.id,{provider:b,extension:a}),(0,k.toDisposable)(()=>{for(const p of this._itemsBySourceAndUriMap.values())p.get(b.id)?.clear();this._providers.delete(b.id),this._proxy.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=y;function u(T){return T?.toString()}}),define(Ce[322],Ie([1,0,8,22,2,4,3,255,7,9,17,18,15,85,20,209,25]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0,l=$e(l);function p(s,t){if((0,I.isString)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let o;return Array.isArray(s.highlights)&&(o=s.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),o=o.length?o:void 0),{label:s.label,highlights:o}}}class f extends L.Disposable{constructor(t,o,n){super(),this._proxy=t,this.commands=o,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new a.TreeViewsDnDService;function h(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:c=>h(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(g=>h(g)?this.convertArgument(g):g):c})}registerTreeDataProvider(t,o,n){const h=this.createTreeView(t,{treeDataProvider:o},n);return{dispose:()=>h.dispose()}}createTreeView(t,o,n){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=o.dragAndDropController?.dropMimeTypes??[],c=o.dragAndDropController?.dragMimeTypes??[],g=!!o.dragAndDropController?.handleDrag,w=!!o.dragAndDropController?.handleDrop,D=this.createExtHostTreeView(t,o,n),_={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:h,dragMimeTypes:c,hasHandleDrag:g,hasHandleDrop:w,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},C=this._proxy.$registerTreeViewDataProvider(t,_),A={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,m.checkProposedApiEnabled)(n,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,m.checkProposedApiEnabled)(n,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(E){(0,T.isMarkdownString)(E)&&(0,m.checkProposedApiEnabled)(n,"treeViewMarkdownMessage"),D.message=E},get title(){return D.title},set title(E){D.title=E},get description(){return D.description},set description(E){D.description=E},get badge(){return D.badge},set badge(E){E!==void 0&&l.ViewBadge.isViewBadge(E)?D.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(D.badge=void 0)},reveal:(E,S)=>D.reveal(E,S),dispose:async()=>{await C,this.treeViews.delete(t),D.dispose()}};return this._register(A),A}$getChildren(t,o){const n=this.treeViews.get(t);return n?n.getChildren(o):Promise.reject(new R.NoTreeViewError(t))}async $handleDrop(t,o,n,h,c,g,w,D){const _=this.treeViews.get(t);if(!_)return Promise.reject(new R.NoTreeViewError(t));const C=u.DataTransfer.toDataTransfer(n,async A=>(await this._proxy.$resolveDropFileData(t,o,A)).buffer);return w===t&&D&&await this.addAdditionalTransferItems(C,_,D,c,g),_.onDrop(C,h,c)}async addAdditionalTransferItems(t,o,n,h,c){const g=this.treeDragAndDropService.removeDragOperationTransfer(c);if(g)(await g)?.forEach((w,D)=>{w&&t.set(D,w)});else if(c&&o.handleDrag){const w=o.handleDrag(n,t,h);this.treeDragAndDropService.addDragOperationTransfer(c,w),await w}return t}async $handleDrag(t,o,n,h){const c=this.treeViews.get(t);if(!c)return Promise.reject(new R.NoTreeViewError(t));const g=await this.addAdditionalTransferItems(new l.DataTransfer,c,o,h,n);if(!(!g||h.isCancellationRequested))return u.DataTransfer.from(g)}async $hasResolve(t){const o=this.treeViews.get(t);if(!o)throw new R.NoTreeViewError(t);return o.hasResolve}$resolve(t,o,n){const h=this.treeViews.get(t);if(!h)throw new R.NoTreeViewError(t);return h.resolveTreeItem(o,n)}$setExpanded(t,o,n){const h=this.treeViews.get(t);if(!h)throw new R.NoTreeViewError(t);h.setExpanded(o,n)}$setSelectionAndFocus(t,o,n){const h=this.treeViews.get(t);if(!h)throw new R.NoTreeViewError(t);h.setSelectionAndFocus(o,n)}$setVisible(t,o){const n=this.treeViews.get(t);if(!n){if(!o)return;throw new R.NoTreeViewError(t)}n.setVisible(o)}$changeCheckboxState(t,o){const n=this.treeViews.get(t);if(!n)throw new R.NoTreeViewError(t);n.setCheckboxState(o)}createExtHostTreeView(t,o,n){const h=this._register(new i(t,o,this._proxy,this.commands.converter,this.logService,n));return this.treeViews.set(t,h),h}convertArgument(t){const o=this.treeViews.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.ExtHostTreeViews=f;class i extends L.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.isUndefinedOrNull)(t))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(t,o,n,h,c,g){if(super(),this.viewId=t,this.proxy=n,this.commands=h,this.logService=c,this.extension=g,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new k.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new k.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new k.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new k.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new k.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new k.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new b.CancellationTokenSource,g.contributes&&g.contributes.views)for(const C in g.contributes.views)for(const A of g.contributes.views[C])A.id===t&&(this._title=A.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this._onDidChangeData.fire({message:!1,element:C})}));let w,D;const _=k.Event.debounce(this._onDidChangeData.event,(C,A)=>(C||(C={message:!1,elements:[]}),A.element!==!1&&(w||(w=new Promise(E=>D=E),this.refreshPromise=this.refreshPromise.then(()=>w)),Array.isArray(A.element)?C.elements.push(...A.element):C.elements.push(A.element)),A.message&&(C.message=!0),C),200,!0);this._register(_(({message:C,elements:A})=>{A.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const E=D;return w=null,this.refresh(A).then(()=>E())})),C&&this.proxy.$setMessage(this.viewId,u.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.logService.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(t);return n||(n=await this.fetchChildrenNodes(o)),n?n.map(h=>h.item):void 0}getExtensionElement(t){return this.elements.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const n=(0,I.isUndefinedOrNull)(o.select)?!0:o.select,h=(0,I.isUndefinedOrNull)(o.focus)?!1:o.focus,c=(0,I.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.refreshPromise.then(()=>this.resolveUnknownParentChain(t)).then(g=>this.resolveTreeNode(t,g[g.length-1]).then(w=>this.proxy.$reveal(this.viewId,{item:w.item,parentChain:g.map(D=>D.item)},{select:n,focus:h,expand:c})),g=>this.logService.error(g)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:h,expand:c})}get message(){return this._message}set message(t){this._message=t,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(t){this._title=t,this.proxy.$setTitle(this.viewId,t,this._description)}get description(){return this._description}set description(t){this._description=t,this.proxy.$setTitle(this.viewId,this._title,t)}get badge(){return this._badge}set badge(t){this._badge?.value===t?.value&&this._badge?.tooltip===t?.tooltip||(this._badge=u.ViewBadge.from(t),this.proxy.$setBadge(this.viewId,t))}setExpanded(t,o){const n=this.getExtensionElement(t);n&&(o?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelectionAndFocus(t,o){const n=!(0,y.equals)(this._selectedHandles,t);this._selectedHandles=t;const h=this._focusedHandle!==o;this._focusedHandle=o,n&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),h&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this._visible&&(this._visible=t,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async n=>{const h=this.getExtensionElement(n.treeItemHandle);return h?{extensionItem:h,treeItem:await this.dataProvider.getTreeItem(h),newState:n.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);o.forEach(n=>{n.treeItem.checkboxState=n.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:o.map(n=>[n.extensionItem,n.newState])})}async handleDrag(t,o,n){const h=[];for(const c of t){const g=this.getExtensionElement(c);g&&h.push(g)}if(!(!this.dndController?.handleDrag||h.length===0))return await this.dndController.handleDrag(h,o,n),o}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(t,o,n){const h=o?this.getExtensionElement(o):void 0;if(!(!h&&o||!this.dndController?.handleDrop))return(0,v.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(h,t,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(t,o){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(t);if(n){const h=this.nodes.get(n);if(h){const c=await this.dataProvider.resolveTreeItem(h.extensionItem,n,o)??h.extensionItem;return this.validateTreeItem(c),h.item.tooltip=this.getTooltip(c.tooltip),h.item.command=this.getCommand(h.disposableStore,c.command),h.item}}}resolveUnknownParentChain(t){return this.resolveParent(t).then(o=>o?this.resolveUnknownParentChain(o).then(n=>this.resolveTreeNode(o,n[n.length-1]).then(h=>(n.push(h),n))):Promise.resolve([]))}resolveParent(t){const o=this.nodes.get(t);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,v.asPromise)(()=>this.dataProvider.getParent(t))}resolveTreeNode(t,o){const n=this.nodes.get(t);return n?Promise.resolve(n):(0,v.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(h=>this.createHandle(t,h,o,!0)).then(h=>this.getChildren(o?o.item.handle:void 0).then(()=>{const c=this.getExtensionElement(h);if(c){const g=this.nodes.get(c);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(t){if(t){let o;if(typeof t=="string"){const n=this.getExtensionElement(t);o=n?this.nodes.get(n):void 0}else o=t;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(t){this.clearChildren(t);const o=new b.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=t?this.nodes.get(t):void 0,h=await this.dataProvider.getChildren(t);if(o.token.isCancellationRequested)return;const c=(0,y.coalesce)(h||[]),g=await Promise.all((0,y.coalesce)(c).map(D=>this.dataProvider.getTreeItem(D)));if(o.token.isCancellationRequested)return;const w=g.map((D,_)=>D?this.createAndRegisterTreeNode(c[_],D,n):null);return(0,y.coalesce)(w)}finally{o.dispose()}}refresh(t){if(t.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new b.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(t);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(t){const o=new Set,n=t.map(c=>this.nodes.get(c));for(const c of n)if(c&&!o.has(c.item.handle)){let g=c;for(;g&&g.parent&&n.findIndex(w=>g&&g.parent&&w&&w.item.handle===g.parent.item.handle)===-1;){const w=this.elements.get(g.parent.item.handle);g=w?this.nodes.get(w):void 0}g&&!g.parent&&o.add(c.item.handle)}const h=[];return o.forEach(c=>{const g=this.elements.get(c);if(g){const w=this.nodes.get(g);w&&(!w.parent||!o.has(w.parent.item.handle))&&h.push(c)}}),h}refreshHandles(t){const o={};return Promise.all(t.map(n=>this.refreshNode(n).then(h=>{h&&(o[n]=h.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(t){const o=this.getExtensionElement(t);if(o){const n=this.nodes.get(o);if(n)return this.clearChildren(o),(0,v.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(h=>{if(h){const c=this.createTreeNode(o,h,n.parent);return this.updateNodeCache(o,c,n,n.parent),n.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(t,o,n){const h=this.createTreeNode(t,o,n);if(o.id&&this.elements.has(h.item.handle))throw new Error((0,r.localize)(10823,null,o.id));return this.addNodeToCache(t,h),this.addNodeToParentCache(h,n),h}getTooltip(t){return l.MarkdownString.isMarkdownString(t)?u.MarkdownString.from(t):t}getCommand(t,o){return o?{...this.commands.toInternal(o,t),originalId:o.command}:void 0}getCheckbox(t){if(t.checkboxState===void 0)return;let o,n,h;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,n=t.checkboxState.tooltip,h=t.checkboxState.accessibilityInformation),{isChecked:o===l.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:h}}validateTreeItem(t){if(!l.TreeItem.isTreeItem(t,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(t,o,n){this.validateTreeItem(o);const h=this._register(new L.DisposableStore),c=this.createHandle(t,o,n),g=this.getLightIconPath(o);return{item:{handle:c,parentHandle:n?n.item.handle:void 0,label:p(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(h,o.command),contextValue:o.contextValue,icon:g,iconDark:this.getDarkIconPath(o)||g,themeIcon:this.getThemeIcon(o),collapsibleState:(0,I.isUndefinedOrNull)(o.collapsibleState)?l.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.getCheckbox(o)},extensionItem:o,parent:n,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(t){return t.iconPath instanceof l.ThemeIcon?t.iconPath:void 0}createHandle(t,{id:o,label:n,resourceUri:h},c,g){if(o)return`${i.ID_HANDLE_PREFIX}/${o}`;const w=p(n,this.extension),D=c?c.item.handle:i.LABEL_HANDLE_PREFIX;let _=w?w.label:h?(0,d.basename)(h):"";_=_.indexOf("/")!==-1?_.replace("/","//"):_;const C=this.nodes.has(t)?this.nodes.get(t).item.handle:void 0,A=this.getChildrenNodes(c)||[];let E,S=0;do{if(E=`${D}/${S}:${_}`,g||!this.elements.has(E)||C===E)break;S++}while(S<=A.length);return E}getLightIconPath(t){if(t.iconPath&&!(t.iconPath instanceof l.ThemeIcon))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.getIconPath(t.iconPath):this.getIconPath(t.iconPath.light)}getDarkIconPath(t){if(t.iconPath&&!(t.iconPath instanceof l.ThemeIcon)&&t.iconPath.dark)return this.getIconPath(t.iconPath.dark)}getIconPath(t){return P.URI.isUri(t)?t:P.URI.file(t)}addNodeToCache(t,o){this.elements.set(o.item.handle,t),this.nodes.set(t,o)}updateNodeCache(t,o,n,h){this.elements.delete(o.item.handle),this.nodes.delete(t),o.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(t,o);const c=this.getChildrenNodes(h)||[],g=c.filter(w=>w.item.handle===n.item.handle)[0];g&&c.splice(c.indexOf(g),1,o)}addNodeToParentCache(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.roots||(this.roots=[]),this.roots.push(t))}clearChildren(t){if(t){const o=this.nodes.get(t);if(o){if(o.children)for(const n of o.children){const h=this.elements.get(n.item.handle);h&&this.clear(h)}o.children=void 0}}else this.clearAll()}clear(t){const o=this.nodes.get(t);if(o){if(o.children)for(const n of o.children){const h=this.elements.get(n.item.handle);h&&this.clear(h)}this.nodes.delete(t),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(t=>t.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Ce[323],Ie([1,0,4,3,2,32,15,96,6,9]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0,L=$e(L),v=$e(v),l=$e(l);class I extends d.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;#d;constructor(b,a,m,p){super(),this.#o=void 0,this.#l=!0,this.#u=!1,this.#h=this._register(new r.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new r.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=b,this.#t=a,this.#n=m,this.#i=p.viewType,this.#s=p.panelOptions,this.#o=p.viewColumn,this.#r=p.title,this.#c=p.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(b){this.assertNotDisposed(),this.#r!==b&&(this.#r=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(b){this.assertNotDisposed(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,P.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#c}get visible(){return this.assertNotDisposed(),this.#l}_updateViewState(b){this.#u||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#c=b.active,this.#l=b.visible,this.#o=b.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(b,a){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:L.ViewColumn.from(b),preserveFocus:!!a})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class y extends d.Disposable{static newHandle(){return(0,k.generateUuid)()}constructor(b,a,m){super(),this.webviews=a,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=b.getProxy(v.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(b=>b.dispose()),this._webviewPanels.clear()}createWebviewPanel(b,a,m,p,f={}){const i=typeof p=="object"?p.viewColumn:p,s={viewColumn:L.ViewColumn.from(i),preserveFocus:typeof p=="object"&&!!p.preserveFocus},t=(0,R.shouldSerializeBuffersForPostMessage)(b),o=y.newHandle();this._proxy.$createWebviewPanel((0,R.toExtensionData)(b),o,a,{title:m,panelOptions:u(f),webviewOptions:(0,R.serializeWebviewOptions)(b,this.workspace,f),serializeBuffersForPostMessage:t},s);const n=this.webviews.createNewWebview(o,f,b);return this.createNewWebviewPanel(o,a,m,i,f,n,!0)}$onDidChangeWebviewPanelViewStates(b){const a=Object.keys(b);a.sort((m,p)=>{const f=b[m],i=b[p];return f.active?1:i.active?-1:+f.visible-+i.visible});for(const m of a){const p=this.getWebviewPanel(m);if(!p)continue;const f=b[m];p._updateViewState({active:f.active,visible:f.visible,viewColumn:L.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this._webviewPanels.delete(b),this.webviews.deleteWebview(b)}registerWebviewPanelSerializer(b,a,m){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:m,extension:b}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(b)}),new l.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(b,a,m,p){const f=this._serializers.get(a);if(!f)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:s}=f,t=this.webviews.createNewWebview(b,m.webviewOptions,s),o=this.createNewWebviewPanel(b,a,m.title,p,m.panelOptions,t,m.active);await i.deserializeWebviewPanel(o,m.state)}createNewWebviewPanel(b,a,m,p,f,i,s){const t=new I(b,this._proxy,i,{viewType:a,title:m,viewColumn:p,panelOptions:f,active:s});return this._webviewPanels.set(b,t),t}getWebviewPanel(b){return this._webviewPanels.get(b)}}e.ExtHostWebviewPanels=y;function u(T){return{enableFindWidget:T.enableFindWidget,retainContextWhenHidden:T.retainContextWhenHidden}}}),define(Ce[324],Ie([1,0,4,3,96,15,6,9]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0,L=$e(L),R=$e(R);class v extends d.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;constructor(y,u,T,b,a,m){super(),this.#s=!1,this.#c=this._register(new r.Emitter),this.onDidChangeVisibility=this.#c.event,this.#u=this._register(new r.Emitter),this.onDidDispose=this.#u.event,this.#i=T,this.#a=b,this.#e=y,this.#t=u,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#c;#u;get title(){return this.assertNotDisposed(),this.#a}set title(y){this.assertNotDisposed(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.assertNotDisposed(),this.#o}set description(y){this.assertNotDisposed(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#c.fire())}get badge(){return this.assertNotDisposed(),this.#l}set badge(y){this.assertNotDisposed(),!(y?.value===this.#l?.value&&y?.tooltip===this.#l?.tooltip)&&(this.#l=k.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.assertNotDisposed(),this.#t.$show(this.#e,!!y)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class l{constructor(y,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,T,b){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:T,extension:y}),this._proxy.$registerWebviewViewProvider((0,P.toExtensionData)(y),u,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(y)}),new R.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,T,b,a){const m=this._viewProviders.get(u);if(!m)throw new Error(`No view provider found for '${u}'`);const{provider:p,extension:f}=m,i=this._extHostWebview.createNewWebview(y,{},f),s=new v(y,this._proxy,u,T,i,!0);this._webviewViews.set(y,s),await p.resolveWebviewView(s,{state:b},a)}async $onDidChangeWebviewViewVisibility(y,u){this.getWebviewView(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.getWebviewView(y);this._webviewViews.delete(y),u.dispose(),this._extHostWebview.deleteWebview(y)}getWebviewView(y){const u=this._webviewViews.get(y);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=l}),define(Ce[325],Ie([1,0,75,14,11,227,27,10]),function(pe,e,r,d,P,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let v=class{constructor(y,u){y.addFileSystemProvider(d.Schemas.file,new l(u),{isCaseSensitive:R.isLinux})}};e.ExtHostDiskFileSystemProvider=v,e.ExtHostDiskFileSystemProvider=v=Xe([He(0,r.IExtHostConsumerFileSystem),He(1,P.ILogService)],v);class l{constructor(y){this.logService=y,this.impl=new k.DiskFileSystemProvider(this.logService)}async stat(y){const u=await this.impl.stat(y);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(y){return this.impl.readdir(y)}createDirectory(y){return this.impl.mkdir(y)}readFile(y){return this.impl.readFile(y)}writeFile(y,u,T){return this.impl.writeFile(y,u,{...T,unlock:!1,atomic:!1})}delete(y,u){return this.impl.delete(y,{...u,useTrash:!1,atomic:!1})}rename(y,u,T){return this.impl.rename(y,u,T)}copy(y,u,T){return this.impl.copy(y,u,T)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(y,u){throw new Error("Method not implemented.")}}}),define(Ce[326],Ie([1,0,16,66,32,34,3,6,2,19]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let I=class extends L.Disposable{constructor(u,T){super();const b=u.getProxy(R.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=v.URI.file((0,r.join)((0,d.tmpdir)(),(0,P.generateUuid)()));return await b.$download(a,m),m})}};e.ExtHostDownloadService=I,e.ExtHostDownloadService=I=Xe([He(0,l.IExtHostRpcService),He(1,k.IExtHostCommands)],I)}),define(Ce[327],Ie([1,0,45,16,2,97,3,14,7,33]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0,r=$e(r),d=$e(d);class I extends k.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const n=await super._getWorkspaceStorageURI(o);if(n.scheme!==R.Schemas.file)return n;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const h=n.fsPath;let c=0;do{let g;c===0?g=h:g=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${c}`:`${h}-${c}`,await y(g);const w=d.join(g,"vscode.lock"),D=await a(this._logService,w,!1);if(D)return this._workspaceStorageLock=D,process.on("exit",()=>{D.dispose()}),P.URI.file(g);c++}while(c<10);return n}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=I;async function y(t){try{await r.promises.stat(t);return}catch{}try{await r.promises.mkdir(t,{recursive:!0})}catch{}}const u=1e3,T=10*60*1e3;class b extends L.Disposable{constructor(o,n){super(),this.logService=o,this.filename=n,this._timer=this._register(new v.IntervalTimer),this._timer.cancelAndSet(async()=>{const h=await m(o,n);(!h||h.pid!==process.pid)&&(o.info(`Lock '${n}': The lock was lost unexpectedly.`),this._timer.cancel());try{await r.promises.utimes(n,new Date,new Date)}catch(c){o.error(c),o.info(`Lock '${n}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.filename)}catch{}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+o};await l.Promises.writeFile(this.filename,JSON.stringify(n),{flag:"w"})}catch(n){this.logService.error(n)}}}async function a(t,o,n){try{const c={pid:process.pid,willReleaseAt:0};await l.Promises.writeFile(o,JSON.stringify(c),{flag:"wx"})}catch(c){t.error(c)}const h=await m(t,o);return!h||h.pid!==process.pid?n?(t.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),i(t,o)):(t.info(`Lock '${o}': Lock acquired.`),new b(t,o))}async function m(t,o){let n;try{n=await r.promises.readFile(o)}catch(h){return t.error(h),null}try{return JSON.parse(String(n))}catch(h){return t.error(h),null}}async function p(t,o){let n;try{n=await r.promises.stat(o)}catch(h){return t.error(h),0}return n.mtime.getTime()}function f(t){try{return process.kill(t,0),!0}catch{return!1}}async function i(t,o){const n=await m(t,o);if(!n)return t.info(`Lock '${o}': Could not read pid of lock holder.`),s(t,o);if(n.willReleaseAt){let D=n.willReleaseAt-Date.now();if(D<5e3){for(D>0?t.info(`Lock '${o}': The lockfile is scheduled to be released in ${D} ms.`):t.info(`Lock '${o}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,v.timeout)(Math.min(100,D)),await p(t,o)===0)return s(t,o);D=n.willReleaseAt-Date.now()}return s(t,o)}}if(!f(n.pid))return t.info(`Lock '${o}': The pid ${n.pid} appears to be gone.`),s(t,o);const h=await p(t,o),c=Date.now()-h;if(c<=T)return t.info(`Lock '${o}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;t.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,v.timeout)(2e3);const g=await p(t,o),w=Date.now()-g;return w<=T?(t.info(`Lock '${o}': The lock does not look stale, elapsed: ${w} ms, giving up.`),null):(t.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),s(t,o))}async function s(t,o){t.info(`Lock '${o}': Deleting a stale lock.`);try{await r.promises.unlink(o)}catch{}return a(t,o,!0)}}),define(Ce[328],Ie([1,0,32,19,48,34]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let L=class extends P.BaseExtHostTerminalService{constructor(v,l){super(!0,v,l)}createTerminal(v,l,I){return this.createTerminalFromOptions({name:v,shellPath:l,shellArgs:I})}createTerminalFromOptions(v,l){const I=new P.ExtHostTerminal(this._proxy,(0,r.generateUuid)(),v,v.name);return this._terminals.push(I),I.create(v,this._serializeParentTerminal(v,l)),I.value}};e.ExtHostTerminalService=L,e.ExtHostTerminalService=L=Xe([He(0,k.IExtHostCommands),He(1,d.IExtHostRpcService)],L)}),define(Ce[329],Ie([1,0,4,36,35,5]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new P.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new P.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new P.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new P.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new P.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new P.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,k.createDecorator)("outputService");var L;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new r.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new r.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(l){this.channels.has(l.id)||(this.channels.set(l.id,l),this._onDidRegisterChannel.fire(l.id))}getChannels(){const l=[];return this.channels.forEach(I=>l.push(I)),l}getChannel(l){return this.channels.get(l)}removeChannel(l){this.channels.delete(l),this._onDidRemoveChannel.fire(l)}}d.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new P.RawContextKey("activeOutputChannel","")}),define(Ce[169],Ie([1,0,6,5,19,23,11,329,75,29,62,212,21,17,27,4,3]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class p extends L.AbstractMessageLogger{get disposed(){return this._disposed}constructor(t,o,n,h,c){super(),this.id=t,this.name=o,this.logger=n,this.proxy=h,this.extension=c,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(n.getLevel()),this._register(n.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.offset;this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.offset;this.info(t),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Replace,o),this.visible&&this.logger.flush()}show(t,o){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.proxy.$close(this.id)}log(t,o){this.offset+=u.VSBuffer.fromString(o).byteLength,(0,L.log)(this.logger,t,o),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class f extends p{appendLine(t){this.append(t)}}let i=class{constructor(t,o,n,h,c,g){this.initData=o,this.extHostFileSystem=n,this.extHostFileSystemInfo=h,this.loggerService=c,this.logService=g,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=t.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(o.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.visibleChannelId=t;for(const[o,n]of this.channels)n.visible=o===this.visibleChannelId}createOutputChannel(t,o,n){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const h=typeof o=="object"&&o.log,c=(0,T.isString)(o)?o:void 0;if((0,T.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const w=this.initData.environment.extensionLogLevel?.find(([_])=>k.ExtensionIdentifier.equals(n.identifier,_))?.[1];w&&(g=(0,L.parseLogLevel)(w));const D=h?this.doCreateLogOutputChannel(t,g,n):this.doCreateOutputChannel(t,c,n);return D.then(_=>{this.channels.set(_.id,_),_.visible=_.id===this.visibleChannelId}),h?this.createExtHostLogOutputChannel(t,g??this.logService.getLevel(),D):this.createExtHostOutputChannel(t,D)}async doCreateOutputChannel(t,o,n){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const h=await this.outputDirectoryPromise,c=this.extHostFileSystemInfo.extUri.joinPath(h,`${this.namePool++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.loggerService.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),w=await this.proxy.$register(t,c,o,n.identifier.value);return new p(w,t,g,this.proxy,n)}async doCreateLogOutputChannel(t,o,n){const h=await this.createExtensionLogDirectory(n),c=t.replace(/[\\/:\*\?"<>\|]/g,""),g=this.extHostFileSystemInfo.extUri.joinPath(h,`${c}.log`),w=`${n.identifier.value}.${c}`,D=this.loggerService.createLogger(g,{id:w,name:t,logLevel:o,extensionId:n.identifier.value});return new f(w,t,D,this.proxy,n)}createExtensionLogDirectory(t){let o=this.extensionLogDirectoryPromise.get(t.identifier.value);if(!o){const n=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,t.identifier.value);this.extensionLogDirectoryPromise.set(t.identifier.value,o=(async()=>{try{await this.extHostFileSystem.value.createDirectory(n)}catch(h){if((0,b.toFileSystemProviderErrorCode)(h)!==b.FileSystemProviderErrorCode.FileExists)throw h}return n})())}return o}createExtHostOutputChannel(t,o){let n=!1;const h=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return t},append(c){h(),o.then(g=>g.append(c))},appendLine(c){h(),o.then(g=>g.appendLine(c))},clear(){h(),o.then(c=>c.clear())},replace(c){h(),o.then(g=>g.replace(c))},show(c,g){h(),o.then(w=>w.show(c,g))},hide(){h(),o.then(c=>c.hide())},dispose(){n=!0,o.then(c=>c.dispose())}}}createExtHostLogOutputChannel(t,o,n){const h=new m.DisposableStore,c=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},g=h.add(new a.Emitter);function w(D){o=D,g.fire(D)}return n.then(D=>{h.add(D),D.logLevel!==o&&w(D.logLevel),h.add(D.onDidChangeLogLevel(_=>w(_)))}),{...this.createExtHostOutputChannel(t,n),get logLevel(){return o},onDidChangeLogLevel:g.event,trace(D,..._){c(),n.then(C=>C.trace(D,..._))},debug(D,..._){c(),n.then(C=>C.debug(D,..._))},info(D,..._){c(),n.then(C=>C.info(D,..._))},warn(D,..._){c(),n.then(C=>C.warn(D,..._))},error(D,..._){c(),n.then(C=>C.error(D,..._))},dispose(){h.dispose()}}}};e.ExtHostOutputService=i,e.ExtHostOutputService=i=Xe([He(0,P.IExtHostRpcService),He(1,l.IExtHostInitDataService),He(2,v.IExtHostConsumerFileSystem),He(3,I.IExtHostFileSystemInfo),He(4,L.ILoggerService),He(5,L.ILogService)],i),e.IExtHostOutputService=(0,d.createDecorator)("IExtHostOutputService")}),define(Ce[170],Ie([1,0,5,7]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let k=1/0;for(let R=0;R<this.maxSampleCount;R++){const v=await P.getRoundTripTime();if(v===void 0)return;k=Math.min(k,v/2),await(0,d.timeout)(this.sampleDelay)}this.average.push(k),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(k):L=this.initial.reduce((R,v)=>R+v,0)/this.initial.length,this.lastMeasurement={initial:L,current:k,average:this.average.reduce((R,v)=>R+v,0)/this.average.length,high:typeof L>"u"?!1:k>this.highLatencyMaxThreshold||k>this.highLatencyMinThreshold&&k>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[330],Ie([1,0,8,70,36,47,46,3,4,170,10,24,7,150]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWindowConfiguration=e.CONFIG_NEW_WINDOW_PROFILE=e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.windowConfigurationNodeBase=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,r.localize)(12548,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(12549,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:d.ConfigurationScope.APPLICATION,title:(0,r.localize)(12550,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,r.localize)(12551,null),type:"object",order:101}),e.windowConfigurationNodeBase=Object.freeze({id:"window",order:8,title:(0,r.localize)(12552,null),type:"object"}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new v.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const a=new b;P.Registry.add(e.Extensions.ConfigurationMigration,a);let m=class extends R.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(s,t){super(),this.configurationService=s,this.workspaceService=t,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async o=>{for(const n of o.added)await this.migrateConfigurationsForFolder(n,a.migrations)})),this.migrateConfigurations(a.migrations),this._register(a.onDidRegisterConfigurationMigration(o=>this.migrateConfigurations(o)))}async migrateConfigurations(s){await this.migrateConfigurationsForFolder(void 0,s);for(const t of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(t,s)}async migrateConfigurationsForFolder(s,t){await Promise.all([t.map(o=>this.migrateConfigurationsForFolderAndOverride(o,s?.uri))])}async migrateConfigurationsForFolderAndOverride(s,t){const o=this.configurationService.inspect(s.key,{resource:t}),n=this.workspaceService.getWorkbenchState()===k.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[h,c]of n){const g=o[h];if(!g)continue;const w=[];if(g.value!==void 0){const D=await this.runMigration(s,h,g.value,t,void 0);for(const _ of D??[])w.push([_,[]])}for(const{identifiers:D,value:_}of g.overrides??[])if(_!==void 0){const C=await this.runMigration(s,h,_,t,D);for(const A of C??[])w.push([A,D])}w.length&&await Promise.allSettled(w.map(async([[D,_],C])=>this.configurationService.updateValue(D,_.value,{resource:t,overrideIdentifiers:C},c)))}}async runMigration(s,t,o,n,h){const c=w=>{const _=this.configurationService.inspect(w,{resource:n})[t];if(_)return h?_.overrides?.find(({identifiers:C})=>(0,y.equals)(C,h))?.value:_.value},g=await s.migrateFn(o,c);return Array.isArray(g)?g:[[s.key,g]]}};e.ConfigurationMigrationWorkbenchContribution=m,e.ConfigurationMigrationWorkbenchContribution=m=Xe([He(0,L.IConfigurationService),He(1,k.IWorkspaceContextService)],m);let p=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(s){super(),this.remoteAgentService=s,this._ready=new u.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!I.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.Registry.as(d.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(12553,null)},default:[],markdownDescription:(0,r.localize)(12554,null),scope:d.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(12555,null),scope:d.ConfigurationScope.MACHINE}}})}};e.DynamicWorkbenchSecurityConfiguration=p,e.DynamicWorkbenchSecurityConfiguration=p=Xe([He(0,l.IRemoteAgentService)],p),e.CONFIG_NEW_WINDOW_PROFILE="window.newWindowProfile";let f=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(s,t){super(),this.userDataProfilesService=s,this.configurationService=t,this.registerNewWindowProfileConfiguration(),this._register(this.userDataProfilesService.onDidChangeProfiles(o=>this.registerNewWindowProfileConfiguration())),this.setNewWindowProfile(),this.checkAndResetNewWindowProfileConfig(),this._register(t.onDidChangeConfiguration(o=>{o.source!==L.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.CONFIG_NEW_WINDOW_PROFILE)&&this.setNewWindowProfile()})),this._register(this.userDataProfilesService.onDidChangeProfiles(()=>this.checkAndResetNewWindowProfileConfig()))}registerNewWindowProfileConfiguration(){const s=P.Registry.as(d.Extensions.Configuration),t={...e.windowConfigurationNodeBase,properties:{[e.CONFIG_NEW_WINDOW_PROFILE]:{type:["string","null"],default:null,enum:[...this.userDataProfilesService.profiles.map(o=>o.name),null],enumItemLabels:[...this.userDataProfilesService.profiles.map(o=>""),(0,r.localize)(12556,null)],description:(0,r.localize)(12557,null),scope:d.ConfigurationScope.APPLICATION}}};this.configurationNode?s.updateConfigurations({add:[t],remove:[this.configurationNode]}):s.registerConfiguration(t),this.configurationNode=t}setNewWindowProfile(){const s=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);this.newWindowProfile=s?this.userDataProfilesService.profiles.find(t=>t.name===s):void 0}checkAndResetNewWindowProfileConfig(){const s=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);if(!s)return;const t=this.newWindowProfile?this.userDataProfilesService.profiles.find(o=>o.id===this.newWindowProfile.id):void 0;s!==t?.name&&this.configurationService.updateValue(e.CONFIG_NEW_WINDOW_PROFILE,t?.name)}};e.DynamicWindowConfiguration=f,e.DynamicWindowConfiguration=f=Xe([He(0,T.IUserDataProfilesService),He(1,L.IConfigurationService)],f)}),define(Ce[331],Ie([1,0,38,14,16,22,8,330,70,5,36]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=a,e.globMatchesResource=m,r=$e(r),e.IEditorResolverService=(0,l.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const y=I.Registry.as(v.Extensions.Configuration),u={...R.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(2025,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var T;(function(p){p.builtin="builtin",p.option="option",p.exclusive="exclusive",p.default="default"})(T||(e.RegisteredEditorPriority=T={}));var b;(function(p){p[p.ABORT=1]="ABORT",p[p.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function a(p){switch(p){case T.exclusive:return 5;case T.default:return 4;case T.builtin:return 3;case T.option:default:return 1}}function m(p,f){if(new Set([d.Schemas.extension,d.Schemas.webviewPanel,d.Schemas.vscodeWorkspaceTrust,d.Schemas.vscodeSettings]).has(f.scheme))return!1;const t=typeof p=="string"&&p.indexOf(P.posix.sep)>=0?`${f.scheme}:${f.path}`:(0,k.basename)(f);return r.match(typeof p=="string"?p.toLowerCase():p,t.toLowerCase())}}),define(Ce[332],Ie([1,0,31,14,16,10,22,2,5,247,47,158,170]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,v.createDecorator)("pathService");let b=T=class{constructor(m,p,f,i){this.localUserHome=m,this.remoteAgentService=p,this.environmentService=f,this.contextService=i,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const s=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=s?.userHome??m})()}hasValidBasename(m,p,f){return typeof p=="string"||typeof p>"u"?this.resolveOS.then(i=>this.doHasValidBasename(m,i,p)):this.doHasValidBasename(m,p,f)}doHasValidBasename(m,p,f){return m.scheme===d.Schemas.file||m.scheme===d.Schemas.vscodeRemote?(0,r.isValidBasename)(f??(0,L.basename)(m),p===k.OperatingSystem.Windows):!0}get defaultUriScheme(){return T.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,p){if(m.remoteAuthority)return d.Schemas.vscodeRemote;const f=(0,l.getVirtualWorkspaceScheme)(p.getWorkspace());if(f)return f;const i=p.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=p.getWorkspace().configuration;return s?s.scheme:d.Schemas.file}userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===k.OperatingSystem.Windows?P.win32:P.posix)}async fileURI(m){let p="";if(await this.resolveOS===k.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(p=m.substring(2),m="/"):(p=m.substring(2,i),m=m.substring(i)||"/")}return R.URI.from({scheme:d.Schemas.file,authority:p,path:m,query:"",fragment:""})}};e.AbstractPathService=b,e.AbstractPathService=b=T=Xe([He(1,u.IRemoteAgentService),He(2,y.IWorkbenchEnvironmentService),He(3,I.IWorkspaceContextService)],b)}),define(Ce[333],Ie([1,0,8,59,4,60,3,2,46,216,11,71,151,92,47,158,25,20,17,24,35]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.OnPortForward=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0,e.parseAddress=c,e.mapHasAddress=D,e.mapHasAddressLocalhostOrAllInterfaces=_,e.makeAddress=C,e.isCandidatePort=E,r=$e(r);const t=10*1e3,o="remote.tunnels.toRestore",n="remote.tunnels.toRestoreExpiration",h=1e3*60*60*24*14;e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new s.RawContextKey("forwardedPortsViewEnabled",!1,r.localize(1639,null));function c(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}var g;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(g||(e.TunnelCloseReason=g={}));var w;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(w||(e.TunnelSource=w={})),e.UserTunnelSource={source:w.User,description:r.localize(1640,null)},e.AutoTunnelSource={source:w.Auto,description:r.localize(1641,null)};function D(N,O,M){const U=N.get(C(O,M));if(U)return U;if((0,T.isLocalhost)(O))for(const x of T.LOCALHOST_ADDRESSES){const z=C(x,M);if(N.has(z))return N.get(z)}else if((0,T.isAllInterfaces)(O))for(const x of T.ALL_INTERFACES_ADDRESSES){const z=C(x,M);if(N.has(z))return N.get(z)}}function _(N,O,M){const U=D(N,O,M);if(U)return U;const x=(0,T.isAllInterfaces)(O)?"localhost":(0,T.isLocalhost)(O)?"0.0.0.0":void 0;if(x)return D(N,x,M)}function C(N,O){return N+":"+O}var A;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(A||(e.OnPortForward=A={}));function E(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class S extends L.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.configurationService=O,this.portsAttributes=[],this._onDidChangeAttributes=new P.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(O.onDidChangeConfiguration(M=>{(M.affectsConfiguration(S.SETTING)||M.affectsConfiguration(S.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(O,M,U){let x=this.findNextIndex(O,M,U,this.portsAttributes,0);const z={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;x>=0;){const B=this.portsAttributes[x];B.key===O?(z.onAutoForward=B.onAutoForward??z.onAutoForward,z.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:z.elevateIfNeeded,z.label=B.label??z.label,z.requireLocalPort=B.requireLocalPort,z.protocol=B.protocol):(z.onAutoForward=z.onAutoForward??B.onAutoForward,z.elevateIfNeeded=z.elevateIfNeeded!==void 0?z.elevateIfNeeded:B.elevateIfNeeded,z.label=z.label??B.label,z.requireLocalPort=z.requireLocalPort!==void 0?z.requireLocalPort:void 0,z.protocol=z.protocol??B.protocol),x=this.findNextIndex(O,M,U,this.portsAttributes,x+1)}return z.onAutoForward!==void 0||z.elevateIfNeeded!==void 0||z.label!==void 0||z.requireLocalPort!==void 0||z.protocol!==void 0?z:this.getOtherAttributes()}hasStartEnd(O){return O.start!==void 0&&O.end!==void 0}hasHostAndPort(O){return O.host!==void 0&&O.port!==void 0&&(0,f.isString)(O.host)&&(0,f.isNumber)(O.port)}findNextIndex(O,M,U,x,z){if(z>=x.length)return-1;const B=!(0,T.isLocalhost)(M)&&!(0,T.isAllInterfaces)(M),V=x.slice(z).findIndex($=>(0,f.isNumber)($.key)?B?!1:$.key===O:this.hasStartEnd($.key)?B?!1:O>=$.key.start&&O<=$.key.end:this.hasHostAndPort($.key)?O===$.key.port&&M===$.key.host:U?$.key.test(U):!1);return V>=0?V+z:-1}readSetting(){const O=this.configurationService.getValue(S.SETTING);if(!O||!(0,f.isObject)(O))return[];const M=[];for(const x in O){if(x===void 0)continue;const z=O[x];let B;if(Number(x))B=Number(x);else if((0,f.isString)(x))if(S.RANGE.test(x)){const ee=x.match(S.RANGE);B={start:Number(ee[1]),end:Number(ee[2])}}else if(S.HOST_AND_PORT.test(x)){const ee=x.match(S.HOST_AND_PORT);B={host:ee[1],port:Number(ee[2])}}else{let ee;try{ee=RegExp(x)}catch{}ee&&(B=ee)}B&&M.push({key:B,elevateIfNeeded:z.elevateIfNeeded,onAutoForward:z.onAutoForward,label:z.label,requireLocalPort:z.requireLocalPort,protocol:z.protocol})}const U=this.configurationService.getValue(S.DEFAULTS);return U&&(this.defaultPortAttributes={elevateIfNeeded:U.elevateIfNeeded,label:U.label,onAutoForward:U.onAutoForward,requireLocalPort:U.requireLocalPort,protocol:U.protocol}),this.sortAttributes(M)}sortAttributes(O){function M(U,x){return(0,f.isNumber)(U.key)?U.key:x.hasStartEnd(U.key)?U.key.start:x.hasHostAndPort(U.key)?U.key.port:Number.MAX_VALUE}return O.sort((U,x)=>M(U,this)-M(x,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(O){switch(O){case T.ProvidedOnAutoForward.Notify:return A.Notify;case T.ProvidedOnAutoForward.OpenBrowser:return A.OpenBrowser;case T.ProvidedOnAutoForward.OpenBrowserOnce:return A.OpenBrowserOnce;case T.ProvidedOnAutoForward.OpenPreview:return A.OpenPreview;case T.ProvidedOnAutoForward.Silent:return A.Silent;case T.ProvidedOnAutoForward.Ignore:return A.Ignore;default:return}}async addAttributes(O,M,U){const z=this.configurationService.inspect(S.SETTING).userRemoteValue;let B;!z||!(0,f.isObject)(z)?B={}:B=(0,i.deepClone)(z),B[`${O}`]||(B[`${O}`]={});for(const ee in M)B[`${O}`][ee]=M[ee];return this.configurationService.updateValue(S.SETTING,B,U)}}e.PortsAttributes=S;let F=class extends L.Disposable{constructor(O,M,U,x,z,B,ee,V,$,G){super(),this.tunnelService=O,this.storageService=M,this.configurationService=U,this.environmentService=x,this.remoteAuthorityResolverService=z,this.workspaceContextService=B,this.logService=ee,this.dialogService=V,this.extensionService=$,this.contextKeyService=G,this.inProgress=new Map,this._onForwardPort=new P.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new P.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new P.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new P.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new P.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new P.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new S(U),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async Z=>{const le=await this.getAttributes(Z.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of Z)if(ne.localAddress){const _e=C(ne.tunnelRemoteHost,ne.tunnelRemotePort),ge=_(this._candidates??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(_e,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:le?.get(ne.tunnelRemotePort)?.protocol??T.TunnelProtocol.Http,localUri:await this.makeLocalUri(ne.localAddress,le?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,name:le?.get(ne.tunnelRemotePort)?.label,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:ne.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(_e,ne)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async Z=>{const le=C(Z.tunnelRemoteHost,Z.tunnelRemotePort);if(!_(this.forwarded,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!_(this.detected,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!_(this.inProgress,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&Z.localAddress){const ne=_(this._candidates??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort),_e=(await this.getAttributes([{port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost}]))?.get(Z.tunnelRemotePort);this.forwarded.set(le,{remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localAddress:Z.localAddress,protocol:_e?.protocol??T.TunnelProtocol.Http,localUri:await this.makeLocalUri(Z.localAddress,_e),localPort:Z.tunnelLocalPort,name:_e?.label,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:Z.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(le,Z),this._onForwardPort.fire(this.forwarded.get(le))})),this._register(this.tunnelService.onTunnelClosed(Z=>this.onTunnelClosed(Z,g.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(O=>O.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const O=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&O.dispose()}))}async onTunnelClosed(O,M){const U=C(O.host,O.port);this.forwarded.has(U)&&(this.forwarded.delete(U),await this.storeForwarded(),this._onClosePort.fire(O))}makeLocalUri(O,M){if(O.startsWith("http"))return R.URI.parse(O);const U=M?.protocol??"http";return R.URI.parse(`${U}://${O}`)}async addStorageKeyPostfix(O){const M=this.workspaceContextService.getWorkspace(),U=M.configuration?(0,k.hash)(M.configuration.path):M.folders.length>0?(0,k.hash)(M.folders[0].uri.path):void 0;if(U===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${O}.${this.environmentService.remoteAuthority}.${U}`}async getTunnelRestoreStorageKey(){return this.addStorageKeyPostfix(o)}async getRestoreExpirationStorageKey(){return this.addStorageKeyPostfix(n)}async getTunnelRestoreValue(){const O=this.storageService.get(o,u.StorageScope.WORKSPACE);if(O)return this.storageService.remove(o,u.StorageScope.WORKSPACE),await this.storeForwarded(),O;const M=await this.getTunnelRestoreStorageKey();if(M)return this.storageService.get(M,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.cleanupExpiredTunnelsForRestore(),this.configurationService.getValue("remote.restoreForwardedPorts")){const O=await this.tunnelRestoreValue;if(O&&O!==this.knownPortsRestoreValue){const M=JSON.parse(O)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(U=>U.remotePort).join(", ")}`);for(const U of M){const x=_(this.detected,U.remoteHost,U.remotePort);U.source.source!==w.Extension&&!x||U.source.source===w.Extension&&x?await this.doForward({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,elevateIfNeeded:!0,source:U.source}):U.source.source===w.Extension&&!x&&this.unrestoredExtensionTunnels.set(C(U.remoteHost,U.remotePort),U)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const O=await this.getTunnelRestoreStorageKey();this.restoreListener=this._register(new L.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.restoreListener)(async M=>{M.key===O&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(O,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}cleanupExpiredTunnelsForRestore(){const O=this.storageService.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(M=>M.startsWith(n));for(const M of O){const U=this.storageService.getNumber(M,u.StorageScope.PROFILE);if(U&&U<Date.now()){this.tunnelRestoreValue=Promise.resolve(void 0);const x=M.replace(n,o);this.storageService.remove(M,u.StorageScope.PROFILE),this.storageService.remove(x,u.StorageScope.PROFILE)}}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const O=Array.from(this.forwarded.values()),M=O.map(B=>({remoteHost:B.remoteHost,remotePort:B.remotePort,localPort:B.localPort,name:B.name,localAddress:B.localAddress,localUri:B.localUri,protocol:B.protocol,source:B.source}));let U;O.length>0&&(U=JSON.stringify(M));const x=await this.getTunnelRestoreStorageKey(),z=await this.getRestoreExpirationStorageKey();!U&&x&&z?(this.storageService.remove(x,u.StorageScope.PROFILE),this.storageService.remove(z,u.StorageScope.PROFILE)):U!==this.knownPortsRestoreValue&&x&&z&&(this.storageService.store(x,U,u.StorageScope.PROFILE,u.StorageTarget.USER),this.storageService.store(z,Date.now()+h,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.knownPortsRestoreValue=U}}async showPortMismatchModalIfNeeded(O,M,U){if(!O.tunnelLocalPort||!U?.requireLocalPort||O.tunnelLocalPort===M)return;const x=new Date;if(this.mismatchCooldown.getTime()+t>x.getTime())return;this.mismatchCooldown=x;const z=r.localize(1642,null,M,O.tunnelRemotePort,O.tunnelLocalPort);return this.dialogService.info(z)}async forward(O,M){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await P.Event.toPromise(this.onRestoreComplete.event),this.doForward(O,M)}async doForward(O,M){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const U=_(this.forwarded,O.remote.host,O.remote.port);M=M??(M!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const x=O.local!==void 0?O.local:O.remote.port;let z;if(U)return this.mergeAttributesIntoExistingTunnel(U,O,M);{const B=this.environmentService.remoteAuthority,ee=B?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(B)).authority}:void 0,V=C(O.remote.host,O.remote.port);this.inProgress.set(V,!0),O=this.mergeCachedAndUnrestoredProperties(V,O);const $=await this.tunnelService.openTunnel(ee,O.remote.host,O.remote.port,void 0,x,O.elevateIfNeeded?O.elevateIfNeeded:M?.elevateIfNeeded,O.privacy,M?.protocol);if(typeof $=="string")z=$;else if($&&$.localAddress){const G=_(this._candidates??new Map,O.remote.host,O.remote.port),Z=$.protocol?$.protocol===T.TunnelProtocol.Https?T.TunnelProtocol.Https:T.TunnelProtocol.Http:M?.protocol??T.TunnelProtocol.Http,le={remoteHost:$.tunnelRemoteHost,remotePort:$.tunnelRemotePort,localPort:$.tunnelLocalPort,name:M?.label??O.name,closeable:!0,localAddress:$.localAddress,protocol:Z,localUri:await this.makeLocalUri($.localAddress,M),runningProcess:G?.detail,hasRunningProcess:!!G,pid:G?.pid,source:O.source??e.UserTunnelSource,privacy:$.privacy};return this.forwarded.set(V,le),this.remoteTunnels.set(V,$),this.inProgress.delete(V),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded($,x,M),this._onForwardPort.fire(le),$}this.inProgress.delete(V)}return z}mergeCachedAndUnrestoredProperties(O,M){const U=this.unrestoredExtensionTunnels.has(O)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(O)?this.sessionCachedProperties:void 0;if(U){const x=U.get(O);U.delete(O),x&&(M.name=x.name??M.name,M.local=("local"in x?x.local:"localPort"in x?x.localPort:void 0)??M.local,M.privacy=M.privacy)}return M}async mergeAttributesIntoExistingTunnel(O,M,U){const x=U?.label??M.name;let z;(function(ee){ee[ee.None=0]="None",ee[ee.Fire=1]="Fire",ee[ee.Reopen=2]="Reopen"})(z||(z={}));let B=z.None;switch(x!==O.name&&(O.name=x,B=z.Fire),(U?.protocol||O.protocol!==T.TunnelProtocol.Http)&&U?.protocol!==O.protocol&&(M.source=O.source,B=z.Reopen),M.privacy&&O.privacy!==M.privacy&&(B=z.Reopen),B){case z.Fire:{this._onForwardPort.fire();break}case z.Reopen:await this.close(O.remoteHost,O.remotePort,g.User),await this.doForward(M,U)}return _(this.remoteTunnels,M.remote.host,M.remote.port)}async name(O,M,U){const x=_(this.forwarded,O,M),z=C(O,M);if(x){x.name=U,await this.storeForwarded(),this._onPortName.fire({host:O,port:M});return}else this.detected.has(z)&&(this.detected.get(z).name=U,this._onPortName.fire({host:O,port:M}))}async close(O,M,U){const x=C(O,M),z=this.forwarded.get(x);return U===g.AutoForwardEnd&&z&&z.source.source===w.Auto&&this.sessionCachedProperties.set(x,{local:z.localPort,name:z.name,privacy:z.privacy}),await this.tunnelService.closeTunnel(O,M),this.onTunnelClosed({host:O,port:M},U)}address(O,M){const U=C(O,M);return(this.forwarded.get(U)||this.detected.get(U))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(O){if(O)for(const M of O){const U=_(this._candidates??new Map,M.remoteAddress.host,M.remoteAddress.port),x=typeof M.localAddress=="string"?M.localAddress:C(M.localAddress.host,M.localAddress.port);this.detected.set(C(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:x,protocol:T.TunnelProtocol.Http,localUri:this.makeLocalUri(x),closeable:!1,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:T.TunnelPrivacyId.ConstantPrivate,source:{source:w.Extension,description:r.localize(1643,null)}}),this.tunnelService.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,x,T.TunnelPrivacyId.ConstantPrivate,T.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(O){this._candidateFilter=O}async setCandidates(O){let M=O;this._candidateFilter&&(M=await this._candidateFilter(O));const U=this.updateInResponseToCandidates(M);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(U.values()).map(x=>x.port).join(", ")}`),this._onCandidatesChanged.fire(U)}updateInResponseToCandidates(O){const M=this._candidates??new Map,U=new Map;return this._candidates=U,O.forEach(x=>{const z=C(x.host,x.port);U.set(z,{host:x.host,port:x.port,detail:x.detail,pid:x.pid}),M.has(z)&&M.delete(z);const B=_(this.forwarded,x.host,x.port);B&&(B.runningProcess=x.detail,B.hasRunningProcess=!0,B.pid=x.pid)}),M.forEach((x,z)=>{const B=c(z);if(!B)return;const ee=_(this.forwarded,B.host,B.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0);const V=_(this.detected,B.host,B.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0)}),M}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const O=Array.from(this.forwarded.values()),M=await this.getAttributes(O.map(U=>({port:U.remotePort,host:U.remoteHost})),!1);if(M)for(const U of O){const x=M.get(U.remotePort);(x?.protocol||U.protocol!==T.TunnelProtocol.Http)&&x?.protocol!==U.protocol&&await this.doForward({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,source:U.source},x),x&&x.label&&x.label!==U.name&&await this.name(U.remoteHost,U.remotePort,x.label)}}async getAttributes(O,M=!0){const U=new Map,x=new Map;O.forEach($=>{const G=_(this._candidates??new Map,T.LOCALHOST_ADDRESSES[0],$.port)??$;if(G){U.set($.port,G);const Z=E(G)?G.pid:void 0;x.has(Z)||x.set(Z,[]),x.get(Z)?.push($.port)}});const z=new Map;if(O.forEach($=>{const G=this.configPortsAttributes.getAttributes($.port,$.host,U.get($.port)?.detail);G&&z.set($.port,G)}),this.portAttributesProviders.length===0||!M)return z.size>0?z:void 0;const B=await Promise.all(this.portAttributesProviders.flatMap($=>Array.from(x.entries()).map(G=>{const Z=G[1],le=U.get(Z[0]);return $.providePortAttributes(Z,le?.pid,le?.detail,p.CancellationToken.None)}))),ee=new Map;if(B.forEach($=>$.forEach(G=>{G&&ee.set(G.port,G)})),!z&&!ee)return;const V=new Map;return O.forEach($=>{const G=z.get($.port),Z=ee.get($.port);V.set($.port,{elevateIfNeeded:G?.elevateIfNeeded,label:G?.label,onAutoForward:G?.onAutoForward??S.providedActionToAction(Z?.autoForwardAction),requireLocalPort:G?.requireLocalPort,protocol:G?.protocol})}),V}addAttributesProvider(O){this.portAttributesProviders.push(O)}};e.TunnelModel=F,Xe([(0,d.debounce)(1e3)],F.prototype,"storeForwarded",null),e.TunnelModel=F=Xe([He(0,T.ITunnelService),He(1,u.IStorageService),He(2,v.IConfigurationService),He(3,a.IWorkbenchEnvironmentService),He(4,y.IRemoteAuthorityResolverService),He(5,b.IWorkspaceContextService),He(6,I.ILogService),He(7,l.IDialogService),He(8,m.IExtensionService),He(9,s.IContextKeyService)],F)}),define(Ce[99],Ie([1,0,18]),function(pe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageTypeNew=e.ExcludeSettingOptions=e.TextSearchContextNew=e.TextSearchMatchNew=e.TextSearchCompleteMessageType=e.Range=e.Position=void 0,e.oldToNewTextSearchResult=y;class d{constructor(T,b){this.line=T,this.character=b}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,b){return new d(0,0)}with(T){return new d(0,0)}}e.Position=d;class P{constructor(T,b,a,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(T,b),this.end=new d(a,m)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new P(0,0,0,0)}with(T){return new P(0,0,0,0)}}e.Range=P;var k;(function(u){u[u.Information=1]="Information",u[u.Warning=2]="Warning"})(k||(e.TextSearchCompleteMessageType=k={}));class L{constructor(T,b,a){this.uri=T,this.ranges=b,this.previewText=a}}e.TextSearchMatchNew=L;class R{constructor(T,b,a){this.uri=T,this.text=b,this.lineNumber=a}}e.TextSearchContextNew=R;var v;(function(u){u[u.none=1]="none",u[u.filesExclude=2]="filesExclude",u[u.searchAndFilesExclude=3]="searchAndFilesExclude"})(v||(e.ExcludeSettingOptions=v={}));var l;(function(u){u[u.Information=1]="Information",u[u.Warning=2]="Warning"})(l||(e.TextSearchCompleteMessageTypeNew=l={}));function I(u){return"uri"in u&&"ranges"in u&&"preview"in u}function y(u){if(I(u)){const T=(0,r.asArray)(u.ranges).map(b=>({sourceRange:b,previewRange:b}));return new L(u.uri,T,u.preview.text)}else return new R(u.uri,u.text,u.lineNumber)}}),define(Ce[37],Ie([1,0,18,38,24,31,12,5,16,13,99,7]),function(pe,e,r,d,P,k,L,R,v,l,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.DEFAULT_MAX_SEARCH_RESULTS=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=p,e.isFileMatch=f,e.isProgressMessage=i,e.getExcludes=D,e.pathIncludedInQuery=_,e.deserializeSearchError=E,e.serializeSearchError=S,e.isSerializedSearchComplete=F,e.isSerializedSearchSuccess=N,e.isSerializedFileMatch=O,e.isFilePatternMatch=M,e.resolvePatternsForProvider=x,e.hasSiblingPromiseFn=ee,e.hasSiblingFn=V,d=$e(d),P=$e(P),k=$e(k),v=$e(v),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude",e.DEFAULT_MAX_SEARCH_RESULTS=2e4;const u="\u27EA ",T=" characters skipped \u27EB",b=(u.length+T.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var a;(function(G){G[G.file=0]="file",G[G.text=1]="text",G[G.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.aiText=3]="aiText"})(m||(e.QueryType=m={}));function p(G){return!!G.preview}function f(G){return!!G.resource}function i(G){return!!G.message}var s;(function(G){G[G.Normal=0]="Normal",G[G.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class t{constructor(Z){this.resource=Z,this.results=[]}}e.FileMatch=t;class o{constructor(Z,le,ne,_e){this.ranges=le,this.webviewIndex=_e;const ge=Array.isArray(le)?le:[le];if(ne&&ne.matchLines===1&&n(ge)){Z=(0,L.getNLines)(Z,ne.matchLines);let Y="",W=0,oe=0;const Se=Math.floor(ne.charsPerLine/5),te=[];for(const ae of ge){const se=Math.max(ae.startColumn-Se,0),Q=ae.startColumn+ne.charsPerLine;if(se>oe+Se+b){const re=u+(se-oe)+T;Y+=re+Z.slice(se,Q),W+=se-(oe+re.length)}else Y+=Z.slice(oe,Q);te.push(new c(0,ae.startColumn-W,ae.endColumn-W)),oe=Q}this.preview={text:Y,matches:Array.isArray(this.ranges)?te:te[0]}}else{const Y=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:Z,matches:(0,r.mapArrayOrNot)(le,W=>new h(W.startLineNumber-Y,W.startColumn,W.endLineNumber-Y,W.endColumn))}}}}e.TextSearchMatch=o;function n(G){const Z=G[0].startLineNumber;for(const le of G)if(le.startLineNumber!==Z||le.endLineNumber!==Z)return!1;return!0}class h{constructor(Z,le,ne,_e){this.startLineNumber=Z,this.startColumn=le,this.endLineNumber=ne,this.endColumn=_e}}e.SearchRange=h;class c extends h{constructor(Z,le,ne){super(Z,le,Z,ne)}}e.OneLineRange=c;var g;(function(G){G.List="list",G.Tree="tree"})(g||(e.ViewMode=g={}));var w;(function(G){G.Default="default",G.FileNames="fileNames",G.Type="type",G.Modified="modified",G.CountDescending="countDescending",G.CountAscending="countAscending"})(w||(e.SearchSortOrder=w={}));function D(G,Z=!0){const le=G&&G.files&&G.files.exclude,ne=Z&&G&&G.search&&G.search.exclude;if(!le&&!ne)return;if(!le||!ne)return le||ne||void 0;let _e=Object.create(null);return _e=P.mixin(_e,P.deepClone(le)),_e=P.mixin(_e,P.deepClone(ne),!0),_e}function _(G,Z){return G.excludePattern&&d.match(G.excludePattern,Z)?!1:G.includePattern||G.usingSearchPaths?G.includePattern&&d.match(G.includePattern,Z)?!0:G.usingSearchPaths?!!G.folderQueries&&G.folderQueries.some(le=>{const ne=le.folder.fsPath;if(k.isEqualOrParent(Z,ne)){const _e=v.relative(ne,Z);return!le.includePattern||!!d.match(le.includePattern,_e)}else return!1}):!1:!0}var C;(function(G){G[G.unknownEncoding=1]="unknownEncoding",G[G.regexParseError=2]="regexParseError",G[G.globParseError=3]="globParseError",G[G.invalidLiteral=4]="invalidLiteral",G[G.rgProcessError=5]="rgProcessError",G[G.other=6]="other",G[G.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class A extends Error{constructor(Z,le){super(Z),this.code=le}}e.SearchError=A;function E(G){const Z=G.message;if((0,l.isCancellationError)(G))return new A(Z,C.canceled);try{const le=JSON.parse(Z);return new A(le.message,le.code)}catch{return new A(Z,C.other)}}function S(G){const Z={message:G.message,code:G.code};return new Error(JSON.stringify(Z))}function F(G){return G.type==="error"?!0:G.type==="success"}function N(G){return G.type==="success"}function O(G){return!!G.path}function M(G,Z,le=!0){const ne=G.searchPath?G.searchPath:G.relativePath;return le?(0,L.fuzzyContains)(ne,Z):d.match(Z,ne)}class U{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function x(G,Z){const le={...G||{},...Z||{}};return Object.keys(le).filter(ne=>{const _e=le[ne];return typeof _e=="boolean"&&_e})}class z{constructor(Z,le){this._parsedIncludeExpression=null,this._excludeExpression={...Z.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=d.parse(this._excludeExpression);let ne=Z.includePattern;le.includePattern&&(ne?ne={...ne,...le.includePattern}:ne=le.includePattern),ne&&(this._parsedIncludeExpression=d.parse(ne))}matchesExcludesSync(Z,le,ne){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Z,le,ne))}includedInQuerySync(Z,le,ne){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Z,le,ne)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Z,le,ne))}includedInQuery(Z,le,ne){const _e=this._parsedExcludeExpression(Z,le,ne),ge=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Z,le,ne):!0;return(0,y.isThenable)(_e)?_e.then(Y=>Y?!1:ge()):ge()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=z;function B(G){for(const Z in G)if(typeof G[Z]!="boolean")return!0;return!1}function ee(G){if(!G)return;let Z;return le=>(Z||(Z=(G()||Promise.resolve([])).then(ne=>ne?$(ne):{})),Z.then(ne=>!!ne[le]))}function V(G){if(!G)return;let Z;return le=>{if(!Z){const ne=G();Z=ne?$(ne):{}}return!!Z[le]}}function $(G){const Z={};for(const le of G)Z[le]=!0;return Z}}),define(Ce[49],Ie([1,0,18,7,20,4,3,84,14,133,22,12,2,8,27,5,11,230,47,62,29,19,15,9,72,37,6,44]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n,h,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function D(O,M,U){return new I.ExtUri(x=>E(x,U)).isEqual(O,M)}function _(O,M,U){return D(O.uri,M.uri,U)?0:(0,y.compare)(O.uri.toString(),M.uri.toString())}function C(O,M,U){return O.index!==M.index?O.index<M.index?-1:1:D(O.uri,M.uri,U)?(0,y.compare)(O.name,M.name):(0,y.compare)(O.uri.toString(),M.uri.toString())}function A(O,M,U,x){const z=O.slice(0).sort((ee,V)=>U(ee,V,x)),B=M.slice(0).sort((ee,V)=>U(ee,V,x));return(0,r.delta)(z,B,(ee,V)=>U(ee,V,x))}function E(O,M){const U=M.getCapabilities(O.scheme);return!(U&&U&b.FileSystemProviderCapabilities.PathCaseSensitive)}class S extends f.Workspace{static toExtHostWorkspace(M,U,x,z){if(!M)return{workspace:null,added:[],removed:[]};const{id:B,name:ee,folders:V,configuration:$,transient:G,isUntitled:Z}=M,le=[],ne=U;U?V.forEach((W,oe)=>{const Se=u.URI.revive(W.uri),te=S._findFolder(x||U,Se,z);te?(te.name=W.name,te.index=W.index,le.push(te)):le.push({uri:Se,name:W.name,index:oe})}):le.push(...V.map(({uri:W,name:oe,index:Se})=>({uri:u.URI.revive(W),name:oe,index:Se}))),le.sort((W,oe)=>W.index<oe.index?-1:1);const _e=new S(B,ee,le,!!G,$?u.URI.revive($):null,!!Z,W=>E(W,z)),{added:ge,removed:Y}=A(ne?ne.workspaceFolders:[],_e.workspaceFolders,_,z);return{workspace:_e,added:ge,removed:Y}}static _findFolder(M,U,x){for(let z=0;z<M.folders.length;z++){const B=M.workspaceFolders[z];if(D(B.uri,U,x))return B}}constructor(M,U,x,z,B,ee,V){super(M,x.map($=>new f.WorkspaceFolder($)),z,B,V),this._name=U,this._isUntitled=ee,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(V,()=>!0),x.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,U){return U&&this._structure.get(M)&&(M=(0,I.dirname)(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let F=class{constructor(M,U,x,z,B){this._onDidChangeWorkspace=new k.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new k.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new k.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=z,this._extHostFileSystemInfo=x,this._uriTransformerService=B,this._requestIdProvider=new l.Counter,this._barrier=new d.Barrier,this._proxy=M.getProxy(g.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(g.MainContext.MainThreadMessageService);const ee=U.workspace;this._confirmedWorkspace=ee?new S(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,V=>E(V,x)):void 0}$initializeWorkspace(M,U){this._trusted=U,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:v.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,U,x,...z){const B=[];if(Array.isArray(z)&&z.forEach(Z=>{u.URI.isUri(Z.uri)&&!B.some(le=>D(le.uri,Z.uri,this._extHostFileSystemInfo))&&B.push({uri:Z.uri,name:Z.name||(0,I.basenameOrAuthority)(Z.uri)})}),this._unconfirmedWorkspace||[U,x].some(Z=>typeof Z!="number"||Z<0)||x===0&&B.length===0)return!1;const ee=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+x>ee.length)return!1;const V=ee.slice(0);V.splice(U,x,...B.map(Z=>({uri:Z.uri,name:Z.name||(0,I.basenameOrAuthority)(Z.uri),index:void 0})));for(let Z=0;Z<V.length;Z++){const le=V[Z];if(V.some((ne,_e)=>_e!==Z&&D(le.uri,ne.uri,this._extHostFileSystemInfo)))return!1}V.forEach((Z,le)=>Z.index=le);const{added:$,removed:G}=A(ee,V,C,this._extHostFileSystemInfo);if($.length===0&&G.length===0)return!1;if(this._proxy){const Z=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(Z,U,x,B).then(void 0,le=>{this._unconfirmedWorkspace=void 0;const ne={source:{identifier:M.identifier,label:M.displayName||M.name}};this._messageService.$showMessage(p.Severity.Error,(0,T.localize)(10820,null,Z,le.toString()),ne,[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(M,U){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,U)}async getWorkspaceFolder2(M,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,U)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,U){let x,z="";if(typeof M=="string"?(x=u.URI.file(M),z=M):typeof M<"u"&&(x=M,z=M.fsPath),!x)return z;const B=this.getWorkspaceFolder(x,!0);if(!B)return z;typeof U>"u"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let ee=(0,I.relativePath)(B.uri,x);return U&&B.name&&(ee=`${B.name}/${ee}`),ee}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:U,added:x,removed:z}=S.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:x,removed:z}))}findFiles(M,U,x,z,B=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let ee="",V=!0;return U===null?V=!1:U!==void 0&&(typeof U=="string"?ee=U:ee=U.pattern),this._findFilesImpl(M,void 0,{exclude:ee,maxResults:x,useDefaultExcludes:V,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(M,U={},x,z=P.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${x.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,M,U,z)}async _findFilesImpl(M,U,x,z=P.CancellationToken.None){if(z&&z.isCancellationRequested)return Promise.resolve([]);const B=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,ee={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof x.useDefaultSearchExcludes=="boolean"?!x.useDefaultSearchExcludes:!1,maxResults:x.maxResults,excludePattern:B,shouldGlobSearch:typeof x.fuzzy=="boolean"?!x.fuzzy:!0,_reason:"startFileSearch"};let V;if(M){const{includePattern:$,folder:G}=N(o.GlobPattern.from(M));V=G,ee.includePattern=$}else{const{includePattern:$,folder:G}=N(o.GlobPattern.from(U));V=G,ee.filePattern=$}return this._proxy.$startFileSearch(V??null,ee,z).then($=>Array.isArray($)?$.map(G=>u.URI.revive(G)):[])}async findTextInFiles(M,U,x,z,B=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const ee=this._requestIdProvider.getNext(),V=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:$,folder:G}=N(o.GlobPattern.from(U.include)),Z=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,le={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof U.useSearchExclude=="boolean"?!U.useSearchExclude:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:V,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:$,excludePattern:Z},ne=!1;if(this._activeSearchCallbacks[ee]=_e=>{if(ne)return;const ge=u.URI.revive(_e.resource);_e.results.forEach(Y=>{const W=(0,w.revive)(Y);(0,c.resultIsMatch)(W)?x({uri:ge,preview:{text:W.preview.text,matches:(0,r.mapArrayOrNot)(W.preview.matches,oe=>new n.Range(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))},ranges:(0,r.mapArrayOrNot)(W.ranges,oe=>new n.Range(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))}):x({uri:ge,text:W.text,lineNumber:W.lineNumber})})},B.isCancellationRequested)return{};try{const _e=await this._proxy.$startTextSearch(M,G??null,le,ee,B);return delete this._activeSearchCallbacks[ee],_e||{}}catch(_e){throw delete this._activeSearchCallbacks[ee],_e}}$handleTextSearchResult(M,U){this._activeSearchCallbacks[U]?.(M)}async save(M){const U=await this._proxy.$save(M,{saveAs:!1});return u.URI.revive(U)}async saveAs(M){const U=await this._proxy.$save(M,{saveAs:!0});return u.URI.revive(U)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}lookupAuthorization(M){return this._proxy.$lookupAuthorization(M)}lookupKerberosAuthorization(M){return this._proxy.$lookupKerberosAuthorization(M)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(M,U){if(this._editSessionIdentityProviders.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this._editSessionIdentityProviders.set(M,U);const x=this._uriTransformerService.transformOutgoingScheme(M),z=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(z,x),(0,L.toDisposable)(()=>{this._editSessionIdentityProviders.delete(M),this._proxy.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(M,U){this._logService.info("Getting edit session identifier for workspaceFolder",M);const x=await this.resolveWorkspaceFolder(u.URI.revive(M));if(!x){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const z=this._editSessionIdentityProviders.get(x.uri.scheme);if(this._logService.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!z),!z)return;const B=await z.provideEditSessionIdentity(x,U);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(M,U,x,z){this._logService.info("Getting edit session identifier for workspaceFolder",M);const B=await this.resolveWorkspaceFolder(u.URI.revive(M));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const ee=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!ee),!ee)return;const V=await ee.provideEditSessionIdentityMatch?.(U,x,z);if(this._logService.info("Provider returned edit session identifier match result: ",V),!!V)return V}getOnWillCreateEditSessionIdentityEvent(M){return(U,x,z)=>{const B=function(V){U.call(x,V)};return B.extension=M,this._onWillCreateEditSessionIdentityEvent.event(B,void 0,z)}}async $onWillCreateEditSessionIdentity(M,U,x){const z=await this.resolveWorkspaceFolder(u.URI.revive(M));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:z},U,async(B,ee)=>{const V=Date.now();await Promise.resolve(B),Date.now()-V>x&&this._logService.warn("SLOW edit session create-participant",ee.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(M,U){if(this._canonicalUriProviders.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this._canonicalUriProviders.set(M,U);const x=this._uriTransformerService.transformOutgoingScheme(M),z=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(z,x),(0,L.toDisposable)(()=>{this._canonicalUriProviders.delete(M),this._proxy.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(M,U,x){const z=this._canonicalUriProviders.get(M.scheme);if(!z)return;const B=await z.provideCanonicalUri?.(u.URI.revive(M),U,x);if(B)return B}async $provideCanonicalUri(M,U,x){return this.provideCanonicalUri(u.URI.revive(M),{targetScheme:U},x)}};e.ExtHostWorkspace=F,e.ExtHostWorkspace=F=Xe([He(0,t.IExtHostRpcService),He(1,s.IExtHostInitDataService),He(2,i.IExtHostFileSystemInfo),He(3,m.ILogService),He(4,h.IURITransformerService)],F),e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function N(O){let M,U;return O&&(typeof O=="string"?M=O:(M=O.pattern,U=u.URI.revive(O.baseUri))),{includePattern:M,folder:U}}}),define(Ce[41],Ie([1,0,24,4,49,6,9,46,232,70,17,7,5,19,11,2]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(h,c){if(c){const g=c.split(".");let w=h;for(let D=0;w&&D<g.length;D++)w=w[g[D]];return w}}function p(h){return h instanceof a.URI}function f(h){return h&&h.uri instanceof a.URI&&h.languageId&&typeof h.languageId=="string"}function i(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function s(h){return h&&h.uri instanceof a.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function t(h){if(p(h))return{resource:h};if(f(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(i(h))return{overrideIdentifier:h.languageId};if(s(h))return{resource:h.uri};if(h===null)return{resource:null}}let o=class{constructor(c,g,w){this._proxy=c.getProxy(k.MainContext.MainThreadConfiguration),this._extHostWorkspace=g,this._logService=w,this._barrier=new y.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(c=>this._actual)}$initializeConfiguration(c){this._actual=new n(this._proxy,this._extHostWorkspace,c,this._logService),this._barrier.open()}$acceptConfigurationChanged(c,g){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(c,g))}};e.ExtHostConfiguration=o,e.ExtHostConfiguration=o=Xe([He(0,T.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,b.ILogService)],o);class n{constructor(c,g,w,D){this._onDidChangeConfiguration=new d.Emitter,this._proxy=c,this._logService=D,this._extHostWorkspace=g,this._configuration=v.Configuration.parse(w,D),this._configurationScopes=this._toMap(w.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(c,g){const w={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=v.Configuration.parse(c,this._logService),this._configurationScopes=this._toMap(c.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(g,w))}getConfiguration(c,g,w){const D=t(g)||{},_=this._toReadonlyValue(c?m(this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace),c):this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace));c&&this._validateConfigurationAccess(c,D,w?.identifier);function C(E){if(E==null)return null;if(typeof E=="boolean")return E?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(E){case L.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const A={has(E){return typeof m(_,E)<"u"},get:(E,S)=>{this._validateConfigurationAccess(c?`${c}.${E}`:E,D,w?.identifier);let F=m(_,E);if(typeof F>"u")F=S;else{let N;const O=(M,U)=>{if((0,I.isObject)(M)){let x;const z=()=>{N=N||(0,r.deepClone)(_),x=x||m(N,U)};return new Proxy(M,{get:(B,ee)=>{if(typeof ee=="string"&&ee.toLowerCase()==="tojson")return z(),()=>x;if(N)return x=x||m(N,U),x[ee];const V=B[ee];return typeof ee=="string"?O(V,`${U}.${ee}`):V},set:(B,ee,V)=>(z(),x&&(x[ee]=V),!0),deleteProperty:(B,ee)=>(z(),x&&delete x[ee],!0),defineProperty:(B,ee,V)=>(z(),x&&Object.defineProperty(x,ee,V),!0)})}return Array.isArray(M)?(0,r.deepClone)(M):M};F=O(F,E)}return F},update:(E,S,F,N)=>{E=c?`${c}.${E}`:E;const O=C(F);return S!==void 0?this._proxy.$updateConfigurationOption(O,E,S,D,N):this._proxy.$removeConfigurationOption(O,E,D,N)},inspect:E=>{E=c?`${c}.${E}`:E;const S=this._configuration.inspect(E,D,this._extHostWorkspace.workspace);if(S)return{key:E,defaultValue:(0,r.deepClone)(S.policy?.value??S.default?.value),globalValue:(0,r.deepClone)(S.user?.value??S.application?.value),workspaceValue:(0,r.deepClone)(S.workspace?.value),workspaceFolderValue:(0,r.deepClone)(S.workspaceFolder?.value),defaultLanguageValue:(0,r.deepClone)(S.default?.override),globalLanguageValue:(0,r.deepClone)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,r.deepClone)(S.workspace?.override),workspaceFolderLanguageValue:(0,r.deepClone)(S.workspaceFolder?.override),languageIds:(0,r.deepClone)(S.overrideIdentifiers)}}};return typeof _=="object"&&(0,r.mixin)(A,_,!1),Object.freeze(A)}_toReadonlyValue(c){const g=w=>(0,I.isObject)(w)?new Proxy(w,{get:(D,_)=>g(D[_]),set:(D,_,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(_)}' of object`)},deleteProperty:(D,_)=>{throw new Error(`TypeError: Cannot delete read only property '${String(_)}' of object`)},defineProperty:(D,_)=>{throw new Error(`TypeError: Cannot define property '${String(_)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return g(c)}_validateConfigurationAccess(c,g,w){const D=l.OVERRIDE_PROPERTY_REGEX.test(c)?l.ConfigurationScope.RESOURCE:this._configurationScopes.get(c),_=w?`[${w.value}] `:"";if(l.ConfigurationScope.RESOURCE===D){typeof g?.resource>"u"&&this._logService.warn(`${_}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(l.ConfigurationScope.WINDOW===D){g?.resource&&this._logService.warn(`${_}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(c,g){const w=new v.ConfigurationChangeEvent(c,g,this._configuration,this._extHostWorkspace.workspace,this._logService);return Object.freeze({affectsConfiguration:(D,_)=>w.affectsConfiguration(D,t(_))})}_toMap(c){return c.reduce((g,w)=>(g.set(w[0],w[1]),g),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,u.createDecorator)("IExtHostConfiguration")}),define(Ce[100],Ie([1,0,2,7,4,6,9,49,63,41,20,48,19,29,5,14,10,11,95,273,13]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,L=$e(L),m=$e(m);var t;(function(N){function O(U){if(U!=null)return U}N.from=O;function M(U){if(U!=null)return U}N.to=M})(t||(t={}));var o;(function(N){function O(U){if(U!=null)return U}N.from=O;function M(U){if(U!=null)return U}N.to=M})(o||(o={}));var n;(function(N){function O(U){if(U!=null)return U}N.from=O;function M(U){if(U!=null)return U}N.to=M})(n||(n={}));var h;(function(N){function O(x){if(x){const z=x;return z&&!!z.process}else return!1}N.is=O;function M(x){if(x==null)return;const z={process:x.process,args:x.args};return x.options&&(z.options=n.from(x.options)),z}N.from=M;function U(x){if(x!=null)return new L.ProcessExecution(x.process,x.args,x.options)}N.to=U})(h||(h={}));var c;(function(N){function O(U){if(U!=null)return U}N.from=O;function M(U){if(U!=null)return U}N.to=M})(c||(c={}));var g;(function(N){function O(x){if(x){const z=x;return z&&(!!z.commandLine||!!z.command)}else return!1}N.is=O;function M(x){if(x==null)return;const z={};return x.commandLine!==void 0?z.commandLine=x.commandLine:(z.command=x.command,z.args=x.args),x.options&&(z.options=c.from(x.options)),z}N.from=M;function U(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new L.ShellExecution(x.commandLine,x.options):new L.ShellExecution(x.command,x.args?x.args:[],x.options)}N.to=U})(g||(g={}));var w;(function(N){function O(x){if(x){const z=x;return z&&z.customExecution==="customExecution"}else return!1}N.is=O;function M(x){return{customExecution:"customExecution"}}N.from=M;function U(x,z){return z.get(x)}N.to=U})(w||(e.CustomExecutionDTO=w={}));var D;(function(N){function O(M,U){let x;return M.scope!==void 0&&typeof M.scope!="number"?x=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===L.TaskScope.Workspace&&U&&U.workspaceFile?x=U.workspaceFile:x=i.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:x}}N.from=O})(D||(e.TaskHandleDTO=D={}));var _;(function(N){function O(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}N.from=O})(_||(_={}));var C;(function(N){function O(x,z){if(x==null)return[];const B=[];for(const ee of x){const V=M(ee,z);V&&B.push(V)}return B}N.fromMany=O;function M(x,z){if(x==null)return;let B;x.execution instanceof L.ProcessExecution?B=h.from(x.execution):x.execution instanceof L.ShellExecution?B=g.from(x.execution):x.execution&&x.execution instanceof L.CustomExecution&&(B=w.from(x.execution));const ee=t.from(x.definition);let V;return x.scope?typeof x.scope=="number"?V=x.scope:V=x.scope.uri:V=L.TaskScope.Workspace,!ee||!V?void 0:{_id:x._id,definition:ee,name:x.name,source:{extensionId:z.identifier.value,label:x.source,scope:V},execution:B,isBackground:x.isBackground,group:_.from(x.group),presentationOptions:o.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}N.from=M;async function U(x,z,B){if(x==null)return;let ee;h.is(x.execution)?ee=h.to(x.execution):g.is(x.execution)?ee=g.to(x.execution):w.is(x.execution)&&(ee=w.to(x._id,B));const V=t.to(x.definition);let $;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?$=x.source.scope:$=await z.resolveWorkspaceFolder(r.URI.revive(x.source.scope)):$=L.TaskScope.Workspace),!V||!$)return;const G=new L.Task(V,$,x.name,x.source.label,ee,x.problemMatchers);return x.isBackground!==void 0&&(G.isBackground=x.isBackground),x.group!==void 0&&(G.group=L.TaskGroup.from(x.group._id),G.group&&x.group.isDefault&&(G.group=new L.TaskGroup(G.group.id,G.group.label),x.group.isDefault===!0&&(G.group.isDefault=x.group.isDefault))),x.presentationOptions&&(G.presentationOptions=o.to(x.presentationOptions)),x._id&&(G._id=x._id),x.detail&&(G.detail=x.detail),G}N.to=U})(C||(e.TaskDTO=C={}));var A;(function(N){function O(U){return U}N.from=O;function M(U){if(U)return Object.assign(Object.create(null),U)}N.to=M})(A||(A={}));class E{#e;constructor(O,M,U){this._id=M,this._task=U,this.#e=O}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}let S=class{constructor(O,M,U,x,z,B,ee,V){this._onDidExecuteTask=new P.Emitter,this._onDidTerminateTask=new P.Emitter,this._onDidTaskProcessStarted=new P.Emitter,this._onDidTaskProcessEnded=new P.Emitter,this._proxy=O.getProxy(k.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=x,this._configurationService=z,this._terminalService=B,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ee,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(O,M,U){if(!U)return new L.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:M,provider:U,extension:O}),this._proxy.$registerTaskProvider(x,M),new L.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(O,M){this._proxy.$registerTaskSystem(O,M)}fetchTasks(O){return this._proxy.$fetchTasks(A.from(O)).then(async M=>{const U=[];for(const x of M){const z=await C.to(x,this._workspaceProvider,this._providedCustomExecutions2);z&&U.push(z)}return U})}get taskExecutions(){const O=[];return this._taskExecutions.forEach(M=>O.push(M)),O}terminateTask(O){if(!(O instanceof E))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(O._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(O,M,U){const x=this._providedCustomExecutions2.get(O.id);x&&(this._activeCustomExecutions2.set(O.id,x),this._terminalService.attachPtyToTerminal(M,await x.callback(U))),this._lastStartedTask=O.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(O)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(O){if(!this._taskExecutionPromises.has(O.id))return;const M=await this.getTaskExecution(O);this._taskExecutionPromises.delete(O.id),this._taskExecutions.delete(O.id),this.customExecutionComplete(O),this._onDidTerminateTask.fire({execution:M})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(O){const M=await this.getTaskExecution(O.id);this._onDidTaskProcessStarted.fire({execution:M,processId:O.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(O){const M=await this.getTaskExecution(O.id);this._onDidTaskProcessEnded.fire({execution:M,exitCode:O.exitCode})}$provideTasks(O,M){const U=this._handlers.get(O);if(!U)return Promise.reject(new Error("no handler found"));const x=[],z=(0,d.asPromise)(()=>U.provider.provideTasks(I.CancellationToken.None)).then(B=>this.provideTasksInternal(M,x,U,B));return new Promise(B=>{z.then(ee=>{Promise.all(x).then(()=>{B(ee)})})})}async $resolveTask(O,M){const U=this._handlers.get(O);if(!U)return Promise.reject(new Error("no handler found"));if(M.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${U.type}].`);const x=await C.to(M,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const z=await U.provider.resolveTask(x,I.CancellationToken.None);if(!z)return;this.checkDeprecation(z,U);const B=C.from(z,U.extension);if(!B)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(B.execution)&&await this.addCustomExecution(B,z,!0),await this.resolveTaskInternal(B)}nextHandle(){return this._handleCounter++}async addCustomExecution(O,M,U){const x=await this._proxy.$createTaskId(O);!U&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,M.execution)),this._providedCustomExecutions2.set(x,M.execution)}async getTaskExecution(O,M){if(typeof O=="string"){const z=this._taskExecutionPromises.get(O);if(!z)throw new s.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return z}const U=this._taskExecutionPromises.get(O.id);if(U)return U;let x;return M?x=Promise.resolve(new E(this,O.id,M)):x=C.to(O.task,this._workspaceProvider,this._providedCustomExecutions2).then(z=>{if(!z)throw new s.ErrorNoTelemetry("Unexpected: Task does not exist.");return new E(this,O.id,z)}),this._taskExecutionPromises.set(O.id,x),x.then(z=>(this._taskExecutions.set(O.id,z),z))}checkDeprecation(O,M){O._deprecated&&this._deprecationService.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(O){this._activeCustomExecutions2.get(O.id)&&this._activeCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.has(O.id)&&this._lastStartedTask!==O.id&&(this._providedCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.delete(O.id));const U=this._notProvidedCustomExecutions.values();let x=U.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=U.next()}};e.ExtHostTaskBase=S,e.ExtHostTaskBase=S=Xe([He(0,u.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,R.IExtHostWorkspace),He(3,v.IExtHostDocumentsAndEditors),He(4,l.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,p.ILogService),He(7,f.IExtHostApiDeprecationService)],S);let F=class extends S{constructor(O,M,U,x,z,B,ee,V){super(O,M,U,x,z,B,ee,V),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(m.Platform.Web)})}async executeTask(O,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const U=C.from(M,O);if(U===void 0)throw new Error("Task is not valid");if(w.is(U.execution))await this.addCustomExecution(U,M,!1);else throw new s.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),M);return this._proxy.$executeTask(U).catch(z=>{throw new Error(z)}),x}provideTasksInternal(O,M,U,x){const z=[];if(x)for(const B of x){if(this.checkDeprecation(B,U),!B.definition||!O[B.definition.type]){const V=B.source?B.source:"No task source";this._logService.warn(`The task [${V}, ${B.name}] uses an undefined task type. The task will be ignored in the future.`)}const ee=C.from(B,U.extension);ee&&w.is(ee.execution)?(z.push(ee),M.push(this.addCustomExecution(ee,B,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:U.extension}}async resolveTaskInternal(O){if(w.is(O.execution))return O;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(O,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,M,U){}};e.WorkerExtHostTask=F,e.WorkerExtHostTask=F=Xe([He(0,u.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,R.IExtHostWorkspace),He(3,v.IExtHostDocumentsAndEditors),He(4,l.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,p.ILogService),He(7,f.IExtHostApiDeprecationService)],F),e.IExtHostTask=(0,b.createDecorator)("IExtHostTask")}),define(Ce[334],Ie([1,0,37,30]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=P,e.genericCellMatchesToTextSearchMatches=k;function P(L){return"cellResults"in L}e.rawCellPrefix="rawCell#";function k(L,R){let v=-1;const l=[];let I=[];return L.forEach(u=>{u.range.startLineNumber!==v&&I.length>0&&(l.push([...I]),I=[]),I.push(u),v=u.range.endLineNumber}),I.length>0&&l.push([...I]),l.map(u=>{const T=[],b=u[0].range.startLineNumber,a=u[u.length-1].range.endLineNumber;for(let m=b;m<=a;m++)T.push(R.getLineContent(m));return new r.TextSearchMatch(T.join(`
`)+`
`,u.map(m=>new d.Range(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(Ce[335],Ie([1,0,8,21,4,3,28,40,12,17,2,27,118,6,34,15,9,53,307,165,24,14,37,263,334,331]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0,y=$e(y),a=$e(a),m=$e(m);class g{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(D=>D.apiEditor)}constructor(D,_,C,A,E,S,F){this._textDocumentsAndEditors=C,this._textDocuments=A,this._extHostFileSystem=E,this._extHostSearch=S,this._logService=F,this._notebookStatusBarItemProviders=new Map,this._documents=new L.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new P.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new P.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new P.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new P.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new u.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=D.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=D.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=D.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=_.converter,_.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===R.MarshalledId.NotebookCellActionContext){const O=N.notebookEditor?.notebookUri,M=N.cell.handle,x=this._documents.get(O)?.getCell(M);if(x)return x.apiCell}if(N&&N.$mid===R.MarshalledId.NotebookActionContext){const O=N.uri,M=this._documents.get(O);if(M)return M.apiNotebook}return N}}),g._registerApiCommands(_)}getEditorById(D){const _=this._editors.get(D);if(!_)throw new Error(`unknown text editor: ${D}. known editors: ${[...this._editors.keys()]} `);return _}getIdByEditor(D){for(const[_,C]of this._editors)if(C.apiEditor===D)return _}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(D,_){const C=this._documents.get(D);if(!C&&!_)throw new Error(`NO notebook document for '${D}'`);return C}static _convertNotebookRegistrationData(D,_){if(!_)return;const C=_.filenamePattern.map(A=>a.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(_.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${_.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:_.displayName,filenamePattern:C,priority:_.exclusive?c.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,_,C){const A=g._notebookStatusBarItemProviderHandlePool++,E=typeof C.onDidChangeCellStatusBarItems=="function"?g._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(A,C),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(A,E,_);let S;return E!==void 0&&(S=C.onDidChangeCellStatusBarItems(F=>this._notebookProxy.$emitCellStatusBarEvent(E))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(A),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(A,E),S?.dispose()})}async createNotebookDocument(D){const _=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:D.viewType,content:D.content&&a.NotebookData.from(D.content)});return I.URI.revive(_)}async openNotebookDocument(D){const _=this._documents.get(D);if(_)return _.apiNotebook;const C=await this._notebookDocumentsProxy.$tryOpenNotebook(D),A=this._documents.get(I.URI.revive(C));return(0,l.assertIsDefined)(A?.apiNotebook)}async showNotebookDocument(D,_){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let C;typeof _=="object"?C={position:a.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selections:_.selections&&_.selections.map(a.NotebookRange.from),pinned:typeof _.preview=="boolean"?!_.preview:void 0}:C={preserveFocus:!1};const A=await this._notebookEditorsProxy.$tryShowNotebookDocument(D.uri,D.notebookType,C),E=A&&this._editors.get(A)?.apiEditor;if(E)return E;throw A?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,_,C,A){const E=this._notebookStatusBarItemProviders.get(D),S=I.URI.revive(_),F=this._documents.get(S);if(!F||!E)return;const N=F.getCellFromIndex(C);if(!N)return;const O=await E.provideCellStatusBarItems(N.apiCell,A);if(!O)return;const M=new k.DisposableStore,U=this._statusBarCache.add([M]),z=(Array.isArray(O)?O:[O]).map(B=>a.NotebookStatusBarItem.from(B,this._commandsConverter,M));return{cacheId:U,items:z}}$releaseNotebookCellStatusBarItems(D){this._statusBarCache.delete(D)}registerNotebookSerializer(D,_,C,A,E){if((0,v.isFalsyOrWhitespace)(_))throw new Error("viewType cannot be empty or just whitespace");const S=this._handlePool++;return this._notebookSerializer.set(S,{viewType:_,serializer:C,options:A}),this._notebookProxy.$registerNotebookSerializer(S,{id:D.identifier,location:D.extensionLocation},_,a.NotebookDocumentContentOptions.from(A),g._convertNotebookRegistrationData(D,E)),(0,k.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(S)})}async $dataToNotebook(D,_,C){const A=this._notebookSerializer.get(D);if(!A)throw new Error("NO serializer found");const E=await A.serializer.deserializeNotebook(_.buffer,C);return new p.SerializableObjectWithBuffers(a.NotebookData.from(E))}async $notebookToData(D,_,C){const A=this._notebookSerializer.get(D);if(!A)throw new Error("NO serializer found");const E=await A.serializer.serializeNotebook(a.NotebookData.to(_.value),C);return d.VSBuffer.wrap(E)}async $saveNotebook(D,_,C,A,E){const S=I.URI.revive(_),F=this._notebookSerializer.get(D);if(this.trace(`enter saveNotebook(versionId: ${C}, ${S.toString()})`),!F)throw new Error("NO serializer found");const N=this._documents.get(S);if(!N)throw new Error("Document NOT found");if(N.versionId!==C)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(S.scheme))throw new y.FileOperationError((0,r.localize)(10828,null,this._resourceForError(S)),y.FileOperationResult.FILE_PERMISSION_DENIED);const O={metadata:(0,s.filter)(N.apiNotebook.metadata,B=>!(F.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of N.apiNotebook.getCells()){const ee=new m.NotebookCellData(B.kind,B.document.getText(),B.document.languageId,B.mime,F.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);ee.metadata=(0,s.filter)(B.metadata,V=>!(F.options?.transientCellMetadata??{})[V]),O.cells.push(ee)}if(await this._validateWriteFile(S,A),E.isCancellationRequested)throw new Error("canceled");const M=await F.serializer.serializeNotebook(O,E);if(E.isCancellationRequested)throw new Error("canceled");this.trace(`serialized versionId: ${C} ${S.toString()}`),await this._extHostFileSystem.value.writeFile(S,M),this.trace(`Finished write versionId: ${C} ${S.toString()}`);const U=this._extHostFileSystem.getFileSystemProviderExtUri(S.scheme),x=await this._extHostFileSystem.value.stat(S),z={name:U.basename(S),isFile:(x.type&y.FileType.File)!==0,isDirectory:(x.type&y.FileType.Directory)!==0,isSymbolicLink:(x.type&y.FileType.SymbolicLink)!==0,mtime:x.mtime,ctime:x.ctime,size:x.size,readonly:!!((x.permissions??0)&y.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(S.scheme),locked:!!((x.permissions??0)&y.FilePermission.Locked),etag:y.etag({mtime:x.mtime,size:x.size}),children:void 0};return this.trace(`exit saveNotebook(versionId: ${C}, ${S.toString()})`),z}async $searchInNotebooks(D,_,C,A,E){const S=this._notebookSerializer.get(D)?.serializer;if(!S)return{limitHit:!1,results:[]};const F=new L.ResourceSet;await(async(x,z,B)=>{await Promise.all(x.map(async ee=>await Promise.all(ee.filenamePatterns.map(V=>{const $={_reason:B._reason,folderQueries:B.folderQueries,includePattern:B.includePattern,excludePattern:B.excludePattern,maxResults:B.maxResults,type:o.QueryType.File,filePattern:V};return this._extHostSearch.doInternalFileSearchWithCustomCallback($,z,G=>{G.forEach(Z=>{F.has(Z)||A.some(ne=>ee.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(_e=>(0,c.globMatchesResource)(_e,Z)))||F.add(Z)})}).catch(G=>{if(G.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw G})}))))})(C,E,_);const O=new L.ResourceMap;let M=!1;const U=Array.from(F).map(async x=>{const z=[];try{if(E.isCancellationRequested)return;if(_.maxResults&&[...O.values()].reduce(($,G)=>$+G.cellResults.length,0)>_.maxResults){M=!0;return}const B=[],ee=this._documents.get(x);if(ee)ee.apiNotebook.getCells().forEach(G=>B.push({input:G.document.getText(),outputs:G.outputs.flatMap(Z=>Z.items.map(le=>le.data.toString()))}));else{const $=await this._extHostFileSystem.value.readFile(x),G=d.VSBuffer.fromString($.toString()),Z=await S.deserializeNotebook(G.buffer,E);if(E.isCancellationRequested)return;a.NotebookData.from(Z).cells.forEach(ne=>B.push({input:ne.source,outputs:ne.outputs.flatMap(_e=>_e.items.map(ge=>ge.valueBytes.toString()))}))}if(E.isCancellationRequested)return;B.forEach(($,G)=>{const Z=_.contentPattern.pattern,le=new n.CellSearchModel($.input,void 0,$.outputs),ne=le.findInInputs(Z),_e=le.findInOutputs(Z),ge=_e.flatMap(Y=>(0,h.genericCellMatchesToTextSearchMatches)(Y.matches,Y.textBuffer)).map((Y,W)=>(Y.webviewIndex=W,Y));if(ne.length>0||_e.length>0){const Y={index:G,contentResults:(0,h.genericCellMatchesToTextSearchMatches)(ne,le.inputTextBuffer),webviewResults:ge};z.push(Y)}});const V={resource:x,cellResults:z};O.set(x,V);return}catch{return}});return await Promise.all(U),{limitHit:M,results:[...O.values()]}}async _validateWriteFile(D,_){const C=await this._extHostFileSystem.value.stat(D);if(typeof _?.mtime=="number"&&typeof _.etag=="string"&&_.etag!==y.ETAG_DISABLED&&typeof C.mtime=="number"&&typeof C.size=="number"&&_.mtime<C.mtime&&_.etag!==y.etag({mtime:_.mtime,size:C.size}))throw new y.FileOperationError((0,r.localize)(10829,null),y.FileOperationResult.FILE_MODIFIED_SINCE,_)}_resourceForError(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}_createExtHostEditor(D,_,C){if(this._editors.has(_))throw new Error(`editor with id ALREADY EXSIST: ${_}`);const A=new i.ExtHostNotebookEditor(_,this._notebookEditorsProxy,D,C.visibleRanges.map(a.NotebookRange.to),C.selections.map(a.NotebookRange.to),typeof C.viewColumn=="number"?a.ViewColumn.to(C.viewColumn):void 0);this._editors.set(_,A)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const C of D.value.removedDocuments){const A=I.URI.revive(C),E=this._documents.get(A);E&&(E.dispose(),this._documents.delete(A),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(S=>S.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const S of this._editors.values())S.notebookData.uri.toString()===A.toString()&&this._editors.delete(S.id)}if(D.value.addedDocuments){const C=[];for(const A of D.value.addedDocuments){const E=I.URI.revive(A.uri);if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const S=new f.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,E,A);C.push(...A.cells.map(F=>f.ExtHostCell.asModelAddData(F))),this._documents.get(E)?.dispose(),this._documents.set(E,S),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this._onDidOpenNotebookDocument.fire(S.apiNotebook)}}if(D.value.addedEditors)for(const C of D.value.addedEditors){if(this._editors.has(C.id))return;const A=I.URI.revive(C.documentUri),E=this._documents.get(A);E&&this._createExtHostEditor(E,C.id,C)}const _=[];if(D.value.removedEditors)for(const C of D.value.removedEditors){const A=this._editors.get(C);A&&(this._editors.delete(C),this._activeNotebookEditor?.id===A.id&&(this._activeNotebookEditor=void 0),_.push(A))}if(D.value.visibleEditors){this._visibleNotebookEditors=D.value.visibleEditors.map(A=>this._editors.get(A)).filter(A=>!!A);const C=new Set;this._visibleNotebookEditors.forEach(A=>C.add(A.id));for(const A of this._editors.values()){const E=C.has(A.id);A._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(A=>A).filter(A=>A.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this._activeNotebookEditor=void 0:D.value.newActiveEditor&&(this._editors.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(D){const _=b.ApiCommandArgument.String.with("notebookType","A notebook type"),C=new b.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[_,new b.ApiCommandArgument("data","Bytes to convert to data",E=>E instanceof Uint8Array,E=>d.VSBuffer.wrap(E))],new b.ApiCommandResult("Notebook Data",E=>a.NotebookData.to(E.value))),A=new b.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[_,new b.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",E=>!0,E=>new p.SerializableObjectWithBuffers(a.NotebookData.from(E)))],new b.ApiCommandResult("Bytes",E=>E.buffer));D.registerApiCommand(C),D.registerApiCommand(A)}trace(D){this._logService.trace(`[Extension Host Notebook] ${D}`)}}e.ExtHostNotebookController=g}),define(Ce[336],Ie([1,0,16,20,52,38,22,42,37]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0,r=$e(r),k=$e(k),L=$e(L);class l{constructor(u,T,b){this.config=u,this.provider=T,this.sessionToken=b,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&k.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&k.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const T=this.config.folderQueries||[];return new Promise((b,a)=>{const m=p=>{this.resultCount++,u(p)};if(this.isCanceled)return b({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(p=>{const f=p.toString(),i=r.basename(f);this.globalExcludePattern&&this.globalExcludePattern(f,i)||this.matchFile(m,{base:p,basename:i})}),Promise.all(T.map(p=>this.searchInFolder(p,m))).then(p=>{b({limitHit:this.isLimitHit,stats:p[0]||void 0})},p=>{a(new Error((0,P.toErrorMessage)(p)))})})}async searchInFolder(u,T){const b=new d.CancellationTokenSource,a=this.getSearchOptionsForFolder(u),m=this.initDirectoryTree(),p=new v.QueryGlobTester(this.config,u),f=!p.hasSiblingExcludeClauses();let i;try{this.activeCancellationTokens.add(b),i=R.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,b.token),t=i.elapsed(),o=R.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(n=>{const h=r.posix.relative(u.folder.path,n.path);if(f){const c=r.basename(n.path);this.matchFile(T,{base:u.folder,relativePath:h,basename:c});return}this.addDirectoryEntries(m,u.folder,h,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(m,p,T),{providerTime:t,postProcessTime:o.elapsed()})}finally{b.dispose(),this.activeCancellationTokens.delete(b)}}getSearchOptionsForFolder(u){const T=(0,v.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),b=(0,v.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:b,includes:T,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},T,b,a){if(b===this.filePattern){const p=r.basename(this.filePattern);this.matchFile(a,{base:T,relativePath:this.filePattern,basename:p})}function m(p){const f=r.basename(p),i=r.dirname(p);let s=u[i];s||(s=u[i]=[],m(i)),s.push({base:T,relativePath:p,basename:f})}m(b)}matchDirectoryTree({rootEntries:u,pathToEntries:T},b,a){const m=this,p=this.filePattern;function f(i){const s=(0,v.hasSiblingFn)(()=>i.map(t=>t.basename));for(let t=0,o=i.length;t<o;t++){const n=i[t],{relativePath:h,basename:c}=n;if(b.matchesExcludesSync(h,c,p!==c?s:void 0))continue;const g=T[h];if(g)f(g);else{if(h===p)continue;m.matchFile(a,n)}if(m.isLimitHit)break}}f(u)}matchFile(u,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(T))}}class I{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(u,T,b,a){const m=this.getSessionTokenSource(u.cacheKey),p=new l(u,T,m&&m.token);let f=0;const i=s=>{f+=s.length,b(s.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(p,I.BATCH_SIZE,i,a).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.getSessionTokenSource(u)?.cancel()}getSessionTokenSource(u){if(u)return this.sessions.has(u)||this.sessions.set(u,new d.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:L.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,T,b,a){const m=a.onCancellationRequested(()=>{u.cancel()}),p=i=>{i&&(f.push(i),T>0&&f.length>=T&&(b(f),f=[]))};let f=[];return u.search(p).then(i=>(f.length&&b(f),m.dispose(),i),i=>(f.length&&b(f),m.dispose(),Promise.reject(i)))}}e.FileSearchManager=I}),define(Ce[337],Ie([1,0,18,78,38,107,28,14,16,22,12,17,2,111,8,46,11,47,157,332,37]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.resolveResourcesForSearchIncludes=_,r=$e(r),d=$e(d),P=$e(P),v=$e(v),I=$e(I),b=$e(b);let t=class{constructor(A,E,S,F,N){this.configurationService=A,this.workspaceContextService=E,this.editorGroupsService=S,this.logService=F,this.pathService=N}text(A,E,S={}){A=this.getContentPattern(A,S);const F=this.configurationService.getValue(),N=E&&E.some(M=>!this.configurationService.getValue({resource:M}).search.useRipgrep);return{...this.commonQuery(E?.map(p.toWorkspaceFolder),S),type:s.QueryType.Text,contentPattern:A,previewOptions:S.previewOptions,maxFileSize:S.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:S.beforeContext,afterContext:S.afterContext,userDisabledExcludesAndIgnoreFiles:S.disregardExcludeSettings&&S.disregardIgnoreFiles}}getContentPattern(A,E){const S=this.configurationService.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const F={...A,wordSeparators:S.editor.wordSeparators};return this.isCaseSensitive(A,E)&&(F.isCaseSensitive=!0),this.isMultiline(A)&&(F.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),F}file(A,E={}){return{...this.commonQuery(A,E),type:s.QueryType.File,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey,shouldGlobMatchFilePattern:E.shouldGlobSearch}}handleIncludeExclude(A,E){return A?(A=Array.isArray(A)?A.map(g):g(A),E?this.parseSearchPaths(A):{pattern:n(...Array.isArray(A)?A:[A])}):{}}commonQuery(A=[],E={}){const S=this.handleIncludeExclude(E.includePattern,E.expandPatterns),F=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),N=A.length>1,O=(S.searchPaths&&S.searchPaths.length?S.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,E,F)):A.map(x=>this.getFolderQueryForRoot(x,E,F,N))).filter(x=>!!x),M={_reason:E._reason,folderQueries:O,usingSearchPaths:!!(S.searchPaths&&S.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:F.pattern,includePattern:S.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const x=r.coalesce(this.editorGroupsService.groups.flatMap(ee=>ee.editors.map(V=>V.resource)));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(x));const z=x.filter(ee=>(0,s.pathIncludedInQuery)(M,ee.fsPath)),B=this.commonQueryFromFileList(z);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...M,...B}}const U=E.extraFileResources&&E.extraFileResources.filter(x=>(0,s.pathIncludedInQuery)(M,x.fsPath));return M.extraFileResources=U&&U.length?U:void 0,M}commonQueryFromFileList(A){const E=[],S=new L.ResourceMap,F={};let N=!1;return A.forEach(O=>{if(O.scheme===R.Schemas.walkThrough)return;if((0,l.isAbsolutePath)(O)){const U=this.workspaceContextService.getWorkspaceFolder(O)?.uri??O.with({path:v.dirname(O.fsPath)});let x=S.get(U);x||(N=!0,x={folder:U,includePattern:{}},E.push(x),S.set(U,x));const z=v.relative(U.fsPath,O.fsPath);(0,y.assertIsDefined)(x.includePattern)[z.replace(/\\/g,"/")]=!0}else O.fsPath&&(N=!0,F[O.fsPath]=!0)}),{folderQueries:E,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(A,E){if(E.isSmartCase){if(A.isRegExp){if(I.containsUppercaseCharacter(A.pattern,!0))return!0}else if(I.containsUppercaseCharacter(A.pattern))return!0}return!!A.isCaseSensitive}isMultiline(A){return A.isMultiline||A.isRegExp&&(0,T.isMultilineRegexSource)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const E=B=>v.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),F=(Array.isArray(A)?A:h(A)).map(B=>{const ee=this.pathService.resolvedUserHome;return ee?(0,k.untildify)(B,ee.scheme===R.Schemas.file?ee.fsPath:ee.path):B}),N=d.groupBy(F,B=>E(B)?"searchPaths":"exprSegments"),O=(N.exprSegments||[]).map(B=>I.rtrim(B,"/")).map(B=>I.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),c(B))),M={},U=this.expandSearchPathPatterns(N.searchPaths||[]);U&&U.length&&(M.searchPaths=U);const x=O.flat(),z=n(...x);return z&&(M.pattern=z),M}getExcludesForFolder(A,E){return E.disregardExcludeSettings?void 0:(0,s.getExcludes)(A,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(A){if(!A||!A.length)return[];const E=A.flatMap(F=>{let{pathPortion:N,globPortion:O}=o(F);return O&&(O=w(O)),this.expandOneSearchPath(N).flatMap(U=>this.resolveOneSearchPathPattern(U,O))}),S=new Map;return E.forEach(F=>{const N=F.searchPath.toString(),O=S.get(N);O?F.pattern&&(O.pattern=O.pattern||{},O.pattern[F.pattern]=!0):S.set(N,{searchPath:F.searchPath,pattern:F.pattern?n(F.pattern):void 0})}),Array.from(S.values())}expandOneSearchPath(A){if(v.isAbsolute(A)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==R.Schemas.file?[{searchPath:E[0].uri.with({path:A})}]:[{searchPath:u.URI.file(v.normalize(A))}]}if(this.workspaceContextService.getWorkbenchState()===p.WorkbenchState.FOLDER){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(A=g(A),A.startsWith("../")||A===".."){const F=v.posix.resolve(E.path,A);return[{searchPath:E.with({path:F})}]}const S=w(A);return[{searchPath:E,pattern:S}]}else{if(A==="./"||A===".\\")return[];{const E=A.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(N=>{const O=E.match(new RegExp(`^${I.escapeRegExpCharacters(N.name)}(?:/(.*)|$)`));return O?{match:O,folder:N}:null}).filter(y.isDefined);if(F.length)return F.map(N=>{const O=N.match[1];return{searchPath:N.folder.uri,pattern:O&&w(O)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),O=N?N[1]:A,M=b.localize(1633,null,O);throw new Error(M)}}}}resolveOneSearchPathPattern(A,E){const S=A.pattern&&E?`${A.pattern}/${E}`:A.pattern||E,F=[{searchPath:A.searchPath,pattern:S}];return S&&!S.endsWith("**")&&F.push({searchPath:A.searchPath,pattern:S+"/**"}),F}getFolderQueryForSearchPath(A,E,S){const F=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(A.searchPath),E,S,!1);return F?{...F,includePattern:A.pattern}:null}getFolderQueryForRoot(A,E,S,F){let N;const O=u.URI.isUri(A)?A:A.uri;if(S.searchPaths){const B=S.searchPaths.filter(ee=>(0,l.isEqual)(ee.searchPath,O))[0];if(B&&!B.pattern)return null;B&&(N=B.pattern)}const M=this.configurationService.getValue({resource:O}),x={...this.getExcludesForFolder(M,E)||{},...N||{}},z=u.URI.isUri(A)?(0,l.basename)(A):A.name;return{folder:O,folderName:F?z:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!M.search.followSymlinks}}};e.QueryBuilder=t,e.QueryBuilder=t=Xe([He(0,a.IConfigurationService),He(1,p.IWorkspaceContextService),He(2,f.IEditorGroupsService),He(3,m.ILogService),He(4,i.IPathService)],t);function o(C){const A=C.match(/[\*\{\}\(\)\[\]\?]/);if(A){const E=A.index,S=C.substr(0,E).match(/[/|\\][^/\\]*$/);if(S){let F=C.substr(0,S.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:C.substr((S.index||0)+1)}}}return{pathPortion:C}}function n(...C){return C.length?C.reduce((A,E)=>(A[E]=!0,A),Object.create(null)):void 0}function h(C){return P.splitGlobAware(C,",").map(A=>A.trim()).filter(A=>!!A.length)}function c(C){return[`**/${C}/**`,`**/${C}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function g(C){return C.replace(/\\/g,"/")}function w(C){return g(C).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(C){return C.replace(/([?*[\]])/g,"[$1]")}function _(C,A){C=r.distinct(C,F=>F.toString());const E=[],S=A.getWorkspace();return C&&C.forEach(F=>{let N;if(A.getWorkbenchState()===p.WorkbenchState.FOLDER)N=(0,l.relativePath)(S.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const O=A.getWorkspaceFolder(F);if(O){const M=O.name;if(S.folders.filter(x=>x.name===M).length===1){const x=(0,l.relativePath)(O.uri,F);x===""?N=`./${O.name}`:N=`./${O.name}/${x}`}else N=F.fsPath}}N&&E.push(D(N))}),E}}),define(Ce[338],Ie([1,0,22,2,20,13,5,337,37,47,7]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=u,e.checkGlobFileExists=a,r=$e(r),k=$e(k);const y=7e3;function u(m,p){const f=p.activationEvents;if(!f)return Promise.resolve(void 0);const i=[],s=[];for(const g of f)if(/^workspaceContains:/.test(g)){const w=g.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||m.forceUsingSearch?s.push(w):i.push(w)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.promiseWithResolvers)(),n=g=>o({activationEvent:g}),h=Promise.all(i.map(g=>T(m,g,n))).then(()=>{}),c=b(m,p.identifier,s,n);return Promise.all([h,c]).then(()=>{o(void 0)}),t}async function T(m,p,f){for(const i of m.folders)if(await m.exists(r.joinPath(d.URI.revive(i),p))){f(`workspaceContains:${p}`);return}}async function b(m,p,f,i){if(f.length===0)return Promise.resolve(void 0);const s=new P.CancellationTokenSource,t=m.checkExists(m.folders,f,s.token),o=setTimeout(async()=>{s.cancel(),m.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},y);let n=!1;try{n=await t}catch(h){k.isCancellationError(h)||k.onUnexpectedError(h)}s.dispose(),clearTimeout(o),n&&i(`workspaceContains:${f.join(",")}`)}function a(m,p,f,i){const s=m.get(L.IInstantiationService),t=m.get(v.ISearchService),n=s.createInstance(R.QueryBuilder).file(p.map(h=>(0,l.toWorkspaceFolder)(d.URI.revive(h))),{_reason:"checkExists",includePattern:f,exists:!0});return t.fileSearch(n,i).then(h=>!!h.limitHit,h=>k.isCancellationError(h)?!1:Promise.reject(h))}}),define(Ce[54],Ie([1,0,8,16,61,22,7,3,84,2,11,6,41,270,125,49,25,159,13,23,21,249,9,71,5,29,97,19,114,76,48,128,4,338,124,251,14,122,42,10,123]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n,h,c,g,w,D,_,C,A,E,S,F,N,O,M,U,x,z){"use strict";var B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,r=$e(r),d=$e(d),P=$e(P),f=$e(f),e.IHostUtils=(0,h.createDecorator)("IHostUtils");let ee=B=class extends R.Disposable{constructor(Y,W,oe,Se,te,ae,se,Q,re,ve,be,Fe,Be){super(),this._extHostManagedSockets=Fe,this._extHostLanguageModels=Be,this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=W,this._extHostContext=oe,this._initData=se,this._extHostWorkspace=Se,this._extHostConfiguration=te,this._logService=ae,this._extHostTunnelService=re,this._extHostTerminalService=ve,this._extHostLocalizationService=be,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new L.Barrier,this._readyToStartExtensionHost=new L.Barrier,this._readyToRunExtensions=new L.Barrier,this._eagerExtensionsActivated=new L.Barrier,this._activationEventsReader=new _e(this._initData.extensions.activationEvents),this._globalRegistry=new p.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const ke=new i.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new p.ExtensionDescriptionRegistry(this._activationEventsReader,le(this._globalRegistry,ke)),x.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${G(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${G(this._myRegistry)}`)),this._storage=new b.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Q,this._instaService=this._store.add(Y.createChild(new D.ServiceCollection([b.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]))),this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(De,Pe,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(De,f.transformErrorForSerialization(Pe),H)},actualActivateExtension:async(De,Pe)=>{if(p.ExtensionDescriptionRegistry.isHostExtension(De,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(De,Pe),new T.HostExtension;const H=this._myRegistry.getExtensionDescription(De);return this._activateExtension(H,Pe)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),P.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Y){f.onUnexpectedError(Y)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Y=[];try{Y=this._myRegistry.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this._deactivate(te))}catch{}await Promise.all(Y)}terminate(Y,W=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Y}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),f.setUnexpectedErrorHandler(Se=>{this._logService.error(Se)}),this._extHostContext.dispose();const oe=this._deactivateAll();Promise.race([(0,L.timeout)(5e3),oe]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${W}`):this._logService.info(`Extension host exiting with code ${W}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(W)})}isActivated(Y){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Y):!1}async getExtension(Y){const W=await this._mainThreadExtensionsProxy.$getExtension(Y);return W&&{...W,identifier:new i.ExtensionIdentifier(W.identifier.value),extensionLocation:l.URI.revive(W.extensionLocation)}}_activateByEvent(Y,W){return this._activator.activateByEvent(Y,W)}_activateById(Y,W){return this._activator.activateById(Y,W)}activateByIdWithErrors(Y,W){return this._activateById(Y,W).then(()=>{const oe=this._activator.getActivatedExtension(Y);if(oe.activationFailed)return Promise.reject(oe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Y=>this._myRegistry)}getExtensionExports(Y){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(Y).exports;try{return this._activator.getActivatedExtension(Y).exports}catch{return null}}async _realPathExtensionUri(Y){if(Y.scheme===O.Schemas.file&&this._hostUtils.fsRealpath){const W=Y.fsPath;this._realPathCache.has(W)||this._realPathCache.set(W,this._hostUtils.fsRealpath(W));const oe=await this._realPathCache.get(W);return l.URI.file(oe)}return Y}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Y=>new ne(Y))),this._extensionPathIndex}async _createExtensionPathIndex(Y){const W=v.TernarySearchTree.forUris(oe=>k.extUriBiasedIgnorePathCase.ignorePathCasing(oe));return await Promise.all(Y.map(async oe=>{if(this._getEntryPoint(oe)){const Se=await this._realPathExtensionUri(oe.extensionLocation);W.set(Se,oe)}})),W}_deactivate(Y){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Y))return W;const oe=this._activator.getActivatedExtension(Y);if(!oe)return W;try{typeof oe.module.deactivate=="function"&&(W=Promise.resolve(oe.module.deactivate()).then(void 0,Se=>(this._logService.error(Se),Promise.resolve(void 0))))}catch(Se){this._logService.error(`An error occurred when deactivating the extension '${Y.value}':`),this._logService.error(Se)}try{oe.disposable.dispose()}catch(Se){this._logService.error(`An error occurred when disposing the subscriptions for extension '${Y.value}':`),this._logService.error(Se)}return W}async _activateExtension(Y,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier),this._doActivateExtension(Y,W).then(oe=>{const Se=oe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Y.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,W),this._logExtensionActivationTimes(Y,W,"success",Se),oe},oe=>{throw this._logExtensionActivationTimes(Y,W,"failure"),oe})}_logExtensionActivationTimes(Y,W,oe,Se){const te=$(Y,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...te,...Se||{},outcome:oe})}_doActivateExtension(Y,W){const oe=$(Y,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",oe);const Se=this._getEntryPoint(Y);if(!Se)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${Y.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this._logService.flush();const te=new R.DisposableStore,ae=new T.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(Y,(0,k.joinPath)(Y.extensionLocation,Se),ae),this._loadExtensionContext(Y,te)]).then(se=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),B._callActivate(this._logService,Y.identifier,se[0],se[1],te,ae))).then(se=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),se))}_loadExtensionContext(Y,W){const oe=this._extHostLanguageModels.createLanguageModelAccessInformation(Y),Se=W.add(new t.ExtensionGlobalMemento(Y,this._storage)),te=W.add(new t.ExtensionMemento(Y.identifier.value,!1,this._storage)),ae=W.add(new N.ExtensionSecrets(Y,this._secretState)),se=Y.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,Q=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([Se.whenReady,te.whenReady,this._storagePath.whenReady]).then(()=>{const re=this;let ve,be;const Fe=(0,m.isProposedApiEnabled)(Y,"ipc")?this._initData.messagePorts?.get(i.ExtensionIdentifier.toKey(Y.identifier)):void 0;return Object.freeze({globalState:Se,workspaceState:te,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return oe},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Be){return d.join(Y.extensionLocation.fsPath,Be)},get storagePath(){return re._storagePath.workspaceValue(Y)?.fsPath},get globalStoragePath(){return re._storagePath.globalValue(Y).fsPath},get logPath(){return d.join(re._initData.logsLocation.fsPath,Y.identifier.value)},get logUri(){return l.URI.joinPath(re._initData.logsLocation,Y.identifier.value)},get storageUri(){return re._storagePath.workspaceValue(Y)},get globalStorageUri(){return re._storagePath.globalValue(Y)},get extensionMode(){return se},get extension(){return ve===void 0&&(ve=new Z(re,Y.identifier,Y,Q,!1)),ve},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(Y,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re._extHostTerminalService.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!be){if(!Fe)return;const Be=E.Event.buffer(E.Event.fromDOMEventEmitter(Fe,"message",ke=>ke.data));Fe.start(),be={onDidReceiveMessage:Be,postMessage:Fe.postMessage.bind(Fe)}}return be}})})}static _callActivate(Y,W,oe,Se,te,ae){return oe=oe||{activate:void 0,deactivate:void 0},this._callActivateOptional(Y,W,oe,Se,ae).then(se=>new T.ActivatedExtension(!1,null,ae.build(),oe,se,(0,R.toDisposable)(()=>{te.dispose(),(0,R.dispose)(Se.subscriptions)})))}static _callActivateOptional(Y,W,oe,Se,te){if(typeof oe.activate=="function")try{te.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${W.value}`);const ae=typeof global=="object"?global:self,se=oe.activate.apply(ae,[Se]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(se).then(Q=>(te.activateResolveStop(),Q))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(oe)}_activateOneStartupFinished(Y,W){this._activateById(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:W}).then(void 0,oe=>{this._logService.error(oe)})}_activateAllStartupFinishedDeferred(Y,W=0){const Se=Date.now();(0,x.setTimeout0)(()=>{for(let te=W;te<Y.length;te+=1){const ae=Y[te];for(const se of ae.activationEvents??[])if(se==="onStartupFinished")if(Date.now()-Se>50){this._activateAllStartupFinishedDeferred(Y,te);break}else this._activateOneStartupFinished(ae,se)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(P.getMarks()),this._extHostConfiguration.getConfigProvider().then(Y=>{const W=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),oe=this._myRegistry.getAllExtensionDescriptions();if(W)this._activateAllStartupFinishedDeferred(oe);else for(const Se of oe)if(Se.activationEvents)for(const te of Se.activationEvents)te==="onStartupFinished"&&this._activateOneStartupFinished(Se,te)})}_handleEagerExtensions(){const Y=this._activateByEvent("*",!0).then(void 0,ae=>{this._logService.error(ae)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ae=>this._handleWorkspaceContainsEagerExtensions(ae.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],oe=this._handleWorkspaceContainsEagerExtensions(W),Se=this._handleRemoteResolverEagerExtensions(),te=Promise.all([Se,Y,oe]).then(()=>{});return Promise.race([te,(0,L.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),te}_handleWorkspaceContainsEagerExtensions(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(Y,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Y,W){if(this.isActivated(W.identifier))return;const oe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Se={logService:this._logService,folders:Y.map(ae=>ae.uri),forceUsingSearch:oe||!this._hostUtils.fsExists,exists:ae=>this._hostUtils.fsExists(ae.fsPath),checkExists:(ae,se,Q)=>this._mainThreadWorkspaceProxy.$checkExists(ae,se,Q)},te=await(0,S.checkActivateWorkspaceContainsExtension)(Se,W);if(te)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:te.activationEvent}).then(void 0,ae=>this._logService.error(ae))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Y){throw console.error(Y),Y}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:W}=this._initData.environment;if(!Y||!W)throw new Error(r.localize(10836,null));const oe=await this._loadCommonJSModule(null,W,new T.ExtensionActivationTimesBuilder(!1));if(!oe||typeof oe.run!="function")throw new Error(r.localize(10837,null,W.toString()));return new Promise((Se,te)=>{const ae=(re,ve)=>{re?(x.isCI&&this._logService.error("Test runner called back with error",re),te(re)):(x.isCI&&(ve?this._logService.info(`Test runner called back with ${ve} failures.`):this._logService.info("Test runner called back with successful outcome.")),Se(typeof ve=="number"&&ve>0?1:0))},se=(0,k.originalFSPath)(W),Q=oe.run(se,ae);Q&&Q.then&&Q.then(()=>{x.isCI&&this._logService.info("Test runner finished successfully."),Se(0)}).catch(re=>{x.isCI&&this._logService.error("Test runner finished with error",re),te(re instanceof Error&&re.stack?re.stack:String(re))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,L.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,W){return this._resolvers[Y]=W,(0,R.toDisposable)(()=>{delete this._resolvers[Y]})}async getRemoteExecServer(Y){const{resolver:W}=await this._activateAndGetResolver(Y);return W?.resolveExecServer?.(Y,{resolveAttempt:0})}async _activateAndGetResolver(Y){const W=Y.indexOf("+");if(W===-1)throw new o.RemoteAuthorityResolverError("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const oe=Y.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${oe}`,!1),{authorityPrefix:oe,resolver:this._resolvers[oe]}}async $resolveAuthority(Y,W){const oe=U.StopWatch.create(!1),Se=()=>`[resolveAuthority(${(0,n.getRemoteAuthorityPrefix)(Y)},${W})][${oe.elapsed()}ms] `,te=q=>this._logService.info(`${Se()}${q}`),ae=q=>this._logService.warn(`${Se()}${q}`),se=(q,X=void 0)=>this._logService.error(`${Se()}${q}`,X),Q=q=>{if(q instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},re=async q=>{te(`activating resolver for ${q}...`);const{resolver:X,authorityPrefix:J}=await this._activateAndGetResolver(q);if(!X)throw se(`no resolver for ${J}`),new o.RemoteAuthorityResolverError(`No remote extension installed to resolve ${J}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:J,remoteAuthority:q}},ve=Y.split(/@|%40/g).reverse();te(`activating remote resolvers ${ve.join(" -> ")}`);let be;try{be=await Promise.all(ve.map(re)).catch(async q=>{if(!(q instanceof o.RemoteAuthorityResolverError)||q._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return ae(`resolving nested authorities failed: ${q.message}`),[await re(Y)]})}catch(q){return Q(q)}const Fe=new L.IntervalTimer;Fe.cancelAndSet(()=>te("waiting..."),1e3);let Be,ke;for(const[q,{authorityPrefix:X,resolver:J,remoteAuthority:he}]of be.entries())try{if(q===be.length-1)te("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${X}`),Be=await J.resolve(he,{resolveAttempt:W,execServer:ke}),P.mark(`code/extHost/didResolveAuthorityOK/${X}`),te("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(J,o.ManagedResolvedAuthority.isManagedResolvedAuthority(Be)?Be:void 0));else{if(te(`invoking resolveExecServer() for ${he}`),P.mark(`code/extHost/willResolveExecServer/${X}`),ke=await J.resolveExecServer?.(he,{resolveAttempt:W,execServer:ke}),!ke)throw new o.RemoteAuthorityResolverError(`Exec server was not available for ${he}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(we){return P.mark(`code/extHost/didResolveAuthorityError/${X}`),se("returned an error",we),Fe.dispose(),Q(we)}Fe.dispose();const De={environmentTunnels:Be.environmentTunnels,features:Be.tunnelFeatures?{elevation:Be.tunnelFeatures.elevation,privacyOptions:Be.tunnelFeatures.privacyOptions,protocol:Be.tunnelFeatures.protocol===void 0?!0:Be.tunnelFeatures.protocol}:void 0},Pe={extensionHostEnv:Be.extensionHostEnv,isTrusted:Be.isTrusted,authenticationSession:Be.authenticationSessionForInitializingExtensions?{id:Be.authenticationSessionForInitializingExtensions.id,providerId:Be.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${o.ManagedResolvedAuthority.isManagedResolvedAuthority(Be)?"managed authority":`${Be.host}:${Be.port}`}`);let H;if(o.ManagedResolvedAuthority.isManagedResolvedAuthority(Be)){const q=W;this._extHostManagedSockets.setFactory(q,Be.makeConnection),H={authority:Y,connectTo:new n.ManagedRemoteConnection(q),connectionToken:Be.connectionToken}}else H={authority:Y,connectTo:new n.WebSocketRemoteConnection(Be.host,Be.port),connectionToken:Be.connectionToken};return{type:"ok",value:{authority:H,options:Pe,tunnelInformation:De}}}async $getCanonicalURI(Y,W){this._logService.info(`$getCanonicalURI invoked for authority (${(0,n.getRemoteAuthorityPrefix)(Y)})`);const{resolver:oe}=await this._activateAndGetResolver(Y);if(!oe)return null;const Se=l.URI.revive(W);if(typeof oe.getCanonicalURI>"u")return Se;const te=await(0,L.asPromise)(()=>oe.getCanonicalURI(Se));return te||Se}async $startExtensionHost(Y){Y.toAdd.forEach(ae=>ae.extensionLocation=l.URI.revive(ae.extensionLocation));const{globalRegistry:W,myExtensions:oe}=V(this._activationEventsReader,this._globalRegistry,this._myRegistry,Y),Se=await this._createExtensionPathIndex(oe);return(await this.getExtensionPathIndex()).setSearchTree(Se),this._globalRegistry.set(W.getAllExtensionDescriptions()),this._myRegistry.set(oe),x.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${G(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${G(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(Y,W){return W===m.ActivationKind.Immediate?this._almostReadyToRunExtensions.wait().then(oe=>this._activateByEvent(Y,!1)):this._readyToRunExtensions.wait().then(oe=>this._activateByEvent(Y,!1))}async $activate(Y,W){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Y)?(await this._activateById(Y,W),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(ae=>ae.extensionLocation=l.URI.revive(ae.extensionLocation));const{globalRegistry:W,myExtensions:oe}=V(this._activationEventsReader,this._globalRegistry,this._myRegistry,Y),Se=await this._createExtensionPathIndex(oe);return(await this.getExtensionPathIndex()).setSearchTree(Se),this._globalRegistry.set(W.getAllExtensionDescriptions()),this._myRegistry.set(oe),x.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${G(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${G(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const W=s.VSBuffer.alloc(Y),oe=Math.random()%256;for(let Se=0;Se<Y;Se++)W.writeUInt8(oe,Se);return W}async $updateRemoteConnectionData(Y){this._remoteConnectionData=Y,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=ee,e.AbstractExtHostExtensionService=ee=B=Xe([He(0,h.IInstantiationService),He(1,e.IHostUtils),He(2,w.IExtHostRpcService),He(3,a.IExtHostWorkspace),He(4,u.IExtHostConfiguration),He(5,I.ILogService),He(6,c.IExtHostInitDataService),He(7,g.IExtensionStoragePaths),He(8,_.IExtHostTunnelService),He(9,C.IExtHostTerminalService),He(10,M.IExtHostLocalizationService),He(11,z.IExtHostManagedSockets),He(12,A.IExtHostLanguageModels)],ee);function V(ge,Y,W,oe){ge.addActivationEvents(oe.addActivationEvents);const Se=new p.ExtensionDescriptionRegistry(ge,Y.getAllExtensionDescriptions());Se.deltaExtensions(oe.toAdd,oe.toRemove);const te=new i.ExtensionIdentifierSet(W.getAllExtensionDescriptions().map(se=>se.identifier));for(const se of oe.myToRemove)te.delete(se);for(const se of oe.myToAdd)te.add(se);const ae=le(Se,te);return{globalRegistry:Se,myExtensions:ae}}function $(ge,Y){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function G(ge){return ge.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.IExtHostExtensionService=(0,h.createDecorator)("IExtHostExtensionService");class Z{#e;#t;#i;constructor(Y,W,oe,Se,te){this.#e=Y,this.#t=W,this.#i=oe.identifier,this.id=oe.identifier.value,this.extensionUri=oe.extensionLocation,this.extensionPath=d.normalize((0,k.originalFSPath)(oe.extensionLocation)),this.packageJSON=oe,this.extensionKind=Se,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=Z;function le(ge,Y){return ge.getAllExtensionDescriptions().filter(W=>Y.has(W.identifier))}class ne{constructor(Y){this._searchTree=Y}setSearchTree(Y){this._searchTree=Y}findSubstr(Y){return this._searchTree.findSubstr(Y)}forEach(Y){return this._searchTree.forEach(Y)}}e.ExtensionPaths=ne;class _e{constructor(Y){this._map=new i.ExtensionIdentifierMap,this.addActivationEvents(Y)}readActivationEvents(Y){return this._map.get(Y.identifier)??[]}addActivationEvents(Y){for(const W of Object.keys(Y))this._map.set(W,Y[W])}}}),define(Ce[339],Ie([1,0,61,2,6,41,25,23,19,29,5,54,11,12]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0,r=$e(r);let a=class{constructor(s,t,o,n,h,c,g){this._apiFactory=s,this._extensionRegistry=t,this._instaService=o,this._extHostConfiguration=n,this._extHostExtensionService=h,this._initData=c,this._logService=g,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,t,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(m)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,t,this._initData.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const t of s.nodeModuleName)this._factories.set(t,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(t=>s.alternativeModuleName(t))}};e.RequireInterceptor=a,e.RequireInterceptor=a=Xe([He(2,I.IInstantiationService),He(3,k.IExtHostConfiguration),He(4,y.IExtHostExtensionService),He(5,l.IExtHostInitDataService),He(6,u.ILogService)],a);let m=class{static{b=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&b.aliased.size){const t=(0,T.escapeRegExpCharacters)(this.forceForwardSlashes(s.environment.appRoot.fsPath)),o="[a-z0-9_.-]",n=`@${o}+\\/${o}+|${o}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${h}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(s){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(s));if(!t)return;const[,o,n,h]=t,c=b.aliased.get(n);if(c!==void 0)return console.warn(`${n} as been renamed to ${c}, please update your imports`),o+c+h}forceForwardSlashes(s){return s.replace(/\\/g,"/")}};m=b=Xe([He(0,l.IExtHostInitDataService)],m);class p{constructor(s,t,o,n,h){this._apiFactory=s,this._extensionPaths=t,this._extensionRegistry=o,this._configProvider=n,this._logService=h,this.nodeModuleName="vscode",this._extApiImpl=new R.ExtensionIdentifierMap}load(s,t){const o=this._extensionPaths.findSubstr(t);if(o){let n=this._extApiImpl.get(o.identifier);return n||(n=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(o.identifier,n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((h,c)=>n+=`	${c} -> ${h.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(L.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let f=class{constructor(s,t,o){this._extensionPaths=s,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(P.MainContext.MainThreadTelemetry);const n=o.getProxy(P.MainContext.MainThreadWindow);this._impl=(h,c)=>{const g=d.URI.parse(h);return c?this.callOriginal(h,c):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,h,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this._appUriScheme?n.$openUri(g,h,{}):this.callOriginal(h,c)}}load(s,t,o){const n=this._extensionPaths.findSubstr(t);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=o(s),this._impl}callOriginal(s,t){return this.sendNoForwardTelemetry(),this._original(s,t)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=Xe([He(2,v.IExtHostRpcService)],f)}),define(Ce[64],Ie([1,0,50,3,16,55,5,63,77,54,9,49,267,41]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,P=$e(P),k=$e(k),e.IExtHostVariableResolverProvider=(0,L.createDecorator)("IExtHostVariableResolverProvider");class b extends u.AbstractVariableResolverService{constructor(p,f,i,s,t,o,n){function h(){if(i){const c=i.activeEditor();if(c)return c.document.uri;const g=s.tabGroups.all.find(w=>w.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof I.TextDiffTabInput||g.input instanceof I.NotebookDiffEditorTabInput)return g.input.modified;if(g.input instanceof I.TextTabInput||g.input instanceof I.NotebookEditorTabInput||g.input instanceof I.CustomEditorTabInput)return g.input.uri}}}super({getFolderUri:c=>{const g=o.folders.filter(w=>w.name===c);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(c,g)=>t.getConfiguration(void 0,c).get(g),getAppRoot:()=>k.cwd(),getExecPath:()=>k.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=h();if(c)return P.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const c=h();if(c){const g=f.getWorkspaceFolder(c);if(g)return P.normalize(g.uri.fsPath)}}},getSelectedText:()=>{if(i){const c=i.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(i){const c=i.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>p.getExtension(c)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(k.env))}}let a=class extends d.Disposable{constructor(p,f,i,s,t){super(),this.extensionService=p,this.workspaceService=f,this.editorService=i,this.configurationService=s,this.editorTabs=t,this._resolver=new r.Lazy(async()=>{const o=await this.configurationService.getConfigProvider(),h={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async c=>{h.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new b(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,o,h,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=a,e.ExtHostVariableResolverProviderService=a=Xe([He(0,l.IExtHostExtensionService),He(1,y.IExtHostWorkspace),He(2,R.IExtHostDocumentsAndEditors),He(3,T.IExtHostConfiguration),He(4,v.IExtHostEditorTabs)],a)}),define(Ce[101],Ie([1,0,7,4,2,3,23,5,6,77,54,19,9,49,154,119,258,41,64,51,34,15,18,98]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,t=$e(t),e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let h=class extends k.Disposable{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(A,E,S,F,N,O,M,U){super(),this._workspaceService=E,this._extensionService=S,this._configurationService=F,this._editorTabs=N,this._variableResolver=O,this._commands=M,this._testing=U,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=this._register(new d.Emitter),this._onDidTerminateDebugSession=this._register(new d.Emitter),this._onDidChangeActiveDebugSession=this._register(new d.Emitter),this._onDidReceiveDebugSessionCustomEvent=this._register(new d.Emitter),this._debugServiceProxy=A.getProxy(v.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=this._register(new d.Emitter),this._onDidChangeActiveStackItem=this._register(new d.Emitter),this._activeDebugConsole=new g(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(x=>{this._register(x.onDidChange(z=>{this.registerAllDebugTypes(x)})),this.registerAllDebugTypes(x)})}async $getVisualizerTreeItem(A,E){const S=this.hydrateVisualizationContext(E);if(!S)return;const F=await this._debugVisualizationTrees.get(A)?.getTreeItem?.(S);return F?this.convertVisualizerTreeItem(A,F):void 0}registerDebugVisualizationTree(A,E,S){const F=L.ExtensionIdentifier.toKey(A.identifier),N=this.extensionVisKey(F,E);if(this._debugVisualizationProviders.has(N))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this._debugVisualizationTrees.set(N,S),this._debugServiceProxy.$registerDebugVisualizerTree(N,!!S.editItem),(0,k.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(N),this._debugVisualizationTrees.delete(E)})}async $getVisualizerTreeItemChildren(A,E){const S=this._debugVisualizationElements.get(E)?.item;return S?(await this._debugVisualizationTrees.get(A)?.getChildren?.(S))?.map(N=>this.convertVisualizerTreeItem(A,N))||[]:[]}async $editVisualizerTreeItem(A,E){const S=this._debugVisualizationElements.get(A);if(!S)return;const F=await this._debugVisualizationTrees.get(S.provider)?.editItem?.(S.item,E);return this.convertVisualizerTreeItem(S.provider,F||S.item)}$disposeVisualizedTree(A){const E=this._debugVisualizationElements.get(A);if(!E)return;const S=[E.children];for(const F of S)if(F)for(const N of F)S.push(this._debugVisualizationElements.get(N)?.children),this._debugVisualizationElements.delete(N)}convertVisualizerTreeItem(A,E){let S=this._debugVisualizationTreeItemIds.get(E);return S||(S=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(E,S),this._debugVisualizationElements.set(S,{provider:A,item:E})),t.DebugTreeItem.from(E,S)}asDebugSourceUri(A,E){const S=A;if(typeof S.sourceReference=="number"&&S.sourceReference>0){let F=`debug:${encodeURIComponent(S.path||"")}`,N="?";return E&&(F+=`${N}session=${encodeURIComponent(E.id)}`,N="&"),F+=`${N}ref=${S.sourceReference}`,P.URI.parse(F)}else{if(S.path)return P.URI.file(S.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(A){const E=[];for(const S of A.getAllExtensionDescriptions())if(S.contributes){const F=S.contributes.debuggers;if(F&&F.length>0)for(const N of F)(0,m.isDebuggerMainContribution)(N)&&E.push(N.type)}this._debugServiceProxy.$registerDebugTypes(E)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const A=[];return this._breakpoints.forEach(E=>A.push(E)),A}async $resolveDebugVisualizer(A,E){const S=this._visualizers.get(A);if(!S)throw new Error(`No debug visualizer found with id '${A}'`);let{v:F,provider:N,extensionId:O}=S;if(F.visualization||(F=await N.resolveDebugVisualization?.(F,E)||F,S.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.serializeVisualization(O,F.visualization)}async $executeDebugVisualizerCommand(A){const E=this._visualizers.get(A);if(!E)throw new Error(`No debug visualizer found with id '${A}'`);const S=E.v.visualization;S&&"command"in S&&this._commands.executeCommand(S.command,...S.arguments||[])}hydrateVisualizationContext(A){const E=this._debugSessions.get(A.sessionId);return E&&{session:E.api,variable:A.variable,containerId:A.containerId,frameId:A.frameId,threadId:A.threadId}}async $provideDebugVisualizers(A,E,S,F){const N=this.hydrateVisualizationContext(S),O=this.extensionVisKey(A,E),M=this._debugVisualizationProviders.get(O);if(!N||!M)return[];const U=await M.provideDebugVisualization(N,F);return U?U.map(x=>{const z=++this._visualizerIdCounter;this._visualizers.set(z,{v:x,provider:M,extensionId:A});const B=x.iconPath?this.getIconPathOrClass(x.iconPath):void 0;return{id:z,name:x.name,iconClass:B?.iconClass,iconPath:B?.iconPath,visualization:this.serializeVisualization(A,x.visualization)}}):[]}$disposeDebugVisualizers(A){for(const E of A)this._visualizers.delete(E)}registerDebugVisualizationProvider(A,E,S){if(!A.contributes?.debugVisualizers?.some(O=>O.id===E))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${E})`);const F=L.ExtensionIdentifier.toKey(A.identifier),N=this.extensionVisKey(F,E);if(this._debugVisualizationProviders.has(N))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this._debugVisualizationProviders.set(N,S),this._debugServiceProxy.$registerDebugVisualizer(F,E),(0,k.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(F,E),this._debugVisualizationProviders.delete(E)})}addBreakpoints(A){const E=A.filter(N=>{const O=N.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,N),!0)});this.fireBreakpointChanges(E,[],[]);const S=[],F=new Map;for(const N of E)if(N instanceof u.SourceBreakpoint){let O=F.get(N.location.uri.toString());O||(O={type:"sourceMulti",uri:N.location.uri,lines:[]},F.set(N.location.uri.toString(),O),S.push(O)),O.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof u.FunctionBreakpoint&&S.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this._debugServiceProxy.$registerBreakpoints(S)}removeBreakpoints(A){const E=A.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],E,[]);const S=E.filter(O=>O instanceof u.SourceBreakpoint).map(O=>O.id),F=E.filter(O=>O instanceof u.FunctionBreakpoint).map(O=>O.id),N=E.filter(O=>O instanceof u.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(S,F,N)}startDebugging(A,E,S){const F=S.testRun&&this._testing.getMetadataForRun(S.testRun);return this._debugServiceProxy.$startDebugging(A?A.uri:void 0,E,{parentSessionID:S.parentSession?S.parentSession.id:void 0,lifecycleManagedByParent:S.lifecycleManagedByParent,repl:S.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:S.noDebug,compact:S.compact,suppressSaveBeforeStart:S.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:S.suppressDebugStatusbar??S.debugUI?.simple,suppressDebugToolbar:S.suppressDebugToolbar??S.debugUI?.simple,suppressDebugView:S.suppressDebugView??S.debugUI?.simple})}stopDebugging(A){return this._debugServiceProxy.$stopDebugging(A?A.id:void 0)}registerDebugConfigurationProvider(A,E,S){if(!E)return new u.Disposable(()=>{});const F=this._configProviderHandleCounter++;return this._configProviders.push({type:A,handle:F,provider:E}),this._debugServiceProxy.$registerDebugConfigurationProvider(A,S,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,F),new u.Disposable(()=>{this._configProviders=this._configProviders.filter(N=>N.provider!==E),this._debugServiceProxy.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(A,E,S){if(!S)return new u.Disposable(()=>{});if(!this.definesDebugType(A,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.getAdapterDescriptorFactoryByType(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:E,handle:F,factory:S}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(E,F),new u.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(N=>N.factory!==S),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(A,E){if(!E)return new u.Disposable(()=>{});const S=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:A,handle:S,factory:E}),new u.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(F=>F.factory!==E)})}async $runInTerminal(A,E){return Promise.resolve(void 0)}async $substituteVariables(A,E){let S;const F=await this.getFolder(A);return F&&(S={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(S,E)}createDebugAdapter(A,E){if(A.type==="implementation")return new D(A.implementation)}createSignService(){}async $startDASession(A,E){const S=this,F=await this.getSession(E);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(F.type),F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const O=this.convertToDto(N),M=this.createDebugAdapter(O,F);if(!M)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const U=M;return this._debugAdapters.set(A,U),this.getDebugAdapterTrackers(F).then(x=>(x&&this._debugAdaptersTrackers.set(A,x),U.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const B=z,ee={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const V=await this._signService.sign(B.arguments.value);ee.body={signature:V},U.sendResponse(ee)}else throw new Error("no signer")}catch(V){ee.success=!1,ee.message=V.message,U.sendResponse(ee)}}else x&&x.onDidSendMessage&&x.onDidSendMessage(z),z=(0,m.convertToVSCPaths)(z,!0),S._debugServiceProxy.$acceptDAMessage(A,z)}),U.onError(z=>{x&&x.onError&&x.onError(z),this._debugServiceProxy.$acceptDAError(A,z.name,z.message,z.stack)}),U.onExit(z=>{x&&x.onExit&&x.onExit(z??void 0,void 0),this._debugServiceProxy.$acceptDAExit(A,z??void 0,void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),U.startSession()))})}$sendDAMessage(A,E){E=(0,m.convertToDAPaths)(E,!1);const S=this._debugAdaptersTrackers.get(A);S&&S.onWillReceiveMessage&&S.onWillReceiveMessage(E),this._debugAdapters.get(A)?.sendMessage(E)}$stopDASession(A){const E=this._debugAdaptersTrackers.get(A);this._debugAdaptersTrackers.delete(A),E&&E.onWillStopSession&&E.onWillStopSession();const S=this._debugAdapters.get(A);return this._debugAdapters.delete(A),S?S.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(A){const E=[],S=[],F=[];if(A.added)for(const N of A.added){const O=N.id;if(O&&!this._breakpoints.has(O)){let M;if(N.type==="function")M=new u.FunctionBreakpoint(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")M=new u.DataBreakpoint(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const U=P.URI.revive(N.uri);M=new u.SourceBreakpoint(new u.Location(U,new u.Position(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,u.setBreakpointId)(M,O),this._breakpoints.set(O,M),E.push(M)}}if(A.removed)for(const N of A.removed){const O=this._breakpoints.get(N);O&&(this._breakpoints.delete(N),S.push(O))}if(A.changed){for(const N of A.changed)if(N.id){const O=this._breakpoints.get(N.id);if(O){if(O instanceof u.FunctionBreakpoint&&N.type==="function"){const M=O;M.enabled=N.enabled,M.condition=N.condition,M.hitCondition=N.hitCondition,M.logMessage=N.logMessage,M.functionName=N.functionName}else if(O instanceof u.SourceBreakpoint&&N.type==="source"){const M=O;M.enabled=N.enabled,M.condition=N.condition,M.hitCondition=N.hitCondition,M.logMessage=N.logMessage,M.location=new u.Location(P.URI.revive(N.uri),new u.Position(N.line,N.character))}F.push(O)}}}this.fireBreakpointChanges(E,S,F)}async $acceptStackFrameFocus(A){let E;if(A){const S=await this.getSession(A.sessionId);A.kind==="thread"?E=new u.DebugThread(S.api,A.threadId):E=new u.DebugStackFrame(S.api,A.threadId,A.frameId)}this._activeStackItem=E,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(A,E,S){return(0,r.asPromise)(async()=>{const F=this.getConfigProviderByHandle(A);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.getFolder(E);return F.provideDebugConfigurations(N,S)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(A,E,S,F){return(0,r.asPromise)(async()=>{const N=this.getConfigProviderByHandle(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(E);return N.resolveDebugConfiguration(O,S,F)})}$resolveDebugConfigurationWithSubstitutedVariables(A,E,S,F){return(0,r.asPromise)(async()=>{const N=this.getConfigProviderByHandle(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(E);return N.resolveDebugConfigurationWithSubstitutedVariables(O,S,F)})}async $provideDebugAdapter(A,E){const S=this.getAdapterDescriptorFactoryByHandle(A);if(!S)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.getSession(E);return this.getAdapterDescriptor(S,F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.convertToDto(N)})}async $acceptDebugSessionStarted(A){const E=await this.getSession(A);this._onDidStartDebugSession.fire(E.api)}async $acceptDebugSessionTerminated(A){const E=await this.getSession(A);E&&(this._onDidTerminateDebugSession.fire(E.api),this._debugSessions.delete(E.id))}async $acceptDebugSessionActiveChanged(A){this._activeDebugSession=A?await this.getSession(A):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(A,E){(await this.getSession(A))?._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(A,E){const F={session:(await this.getSession(A)).api,event:E.event,body:E.body};this._onDidReceiveDebugSessionCustomEvent.fire(F)}convertToDto(A){if(A instanceof u.DebugAdapterExecutable)return{type:"executable",command:A.command,args:A.args,options:A.options};if(A instanceof u.DebugAdapterServer)return{type:"server",port:A.port,host:A.host};if(A instanceof u.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:A.path};if(A instanceof u.DebugAdapterInlineImplementation)return{type:"implementation",implementation:A.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(A){const E=this._adapterFactories.filter(S=>S.type===A);if(E.length>0)return E[0].factory}getAdapterDescriptorFactoryByHandle(A){const E=this._adapterFactories.filter(S=>S.handle===A);if(E.length>0)return E[0].factory}getConfigProviderByHandle(A){const E=this._configProviders.filter(S=>S.handle===A);if(E.length>0)return E[0].provider}definesDebugType(A,E){if(A.contributes){const S=A.contributes.debuggers;if(S&&S.length>0){for(const F of S)if(F.label&&F.type&&F.type===E)return!0}}return!1}getDebugAdapterTrackers(A){const S=A.configuration.type,F=this._trackerFactories.filter(N=>N.type===S||N.type==="*").map(N=>(0,r.asPromise)(()=>N.factory.createDebugAdapterTracker(A.api)).then(O=>O,O=>null));return Promise.race([Promise.all(F).then(N=>{const O=(0,o.coalesce)(N);if(O.length>0)return new w(O)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async getAdapterDescriptor(A,E){const S=E.configuration.debugServer;if(typeof S=="number")return Promise.resolve(new u.DebugAdapterServer(S));if(A){const N=await this._extensionService.getExtensionRegistry();return(0,r.asPromise)(()=>A.createDebugAdapterDescriptor(E.api,this.daExecutableFromPackage(E,N))).then(O=>{if(O)return O})}const F=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(E,F))}daExecutableFromPackage(A,E){}fireBreakpointChanges(A,E,S){(A.length>0||E.length>0||S.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:A,removed:E,changed:S}))}async getSession(A){if(A)if(typeof A=="string"){const E=this._debugSessions.get(A);if(E)return E}else{let E=this._debugSessions.get(A.id);if(!E){const S=await this.getFolder(A.folderUri),F=A.parent?this._debugSessions.get(A.parent):void 0;E=new c(this._debugServiceProxy,A.id,A.type,A.name,S,A.configuration,F?.api),this._debugSessions.set(E.id,E),this._debugServiceProxy.$sessionCached(E.id)}return E}throw new Error("cannot find session")}getFolder(A){if(A){const E=P.URI.revive(A);return this._workspaceService.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}extensionVisKey(A,E){return`${A}\0${E}`}serializeVisualization(A,E){if(E){if("title"in E&&"command"in E)return{type:a.DebugVisualizationType.Command};if("treeId"in E)return{type:a.DebugVisualizationType.Tree,id:`${A}\0${E.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(A){const E=this.getIconUris(A);let S,F;return"id"in E?F=i.ThemeIcon.asClassName(E):S=E,{iconPath:S,iconClass:F}}getIconUris(A){if(A instanceof u.ThemeIcon)return{id:A.id};const E=typeof A=="object"&&"dark"in A?A.dark:A,S=typeof A=="object"&&"light"in A?A.light:A;return{dark:typeof E=="string"?P.URI.file(E):E,light:typeof S=="string"?P.URI.file(S):S}}};e.ExtHostDebugServiceBase=h,e.ExtHostDebugServiceBase=h=Xe([He(0,y.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,p.IExtHostConfiguration),He(4,l.IExtHostEditorTabs),He(5,f.IExtHostVariableResolverProvider),He(6,s.IExtHostCommands),He(7,n.IExtHostTesting)],h);class c{constructor(A,E,S,F,N,O,M){this._debugServiceProxy=A,this._id=E,this._type=S,this._name=F,this._workspaceFolder=N,this._configuration=O,this._parentSession=M}get api(){const A=this;return this.apiSession??=Object.freeze({id:A._id,type:A._type,get name(){return A._name},set name(E){A._name=E,A._debugServiceProxy.$setDebugSessionName(A._id,E)},parentSession:A._parentSession,workspaceFolder:A._workspaceFolder,configuration:A._configuration,customRequest(E,S){return A._debugServiceProxy.$customDebugAdapterRequest(A._id,E,S)},getDebugProtocolBreakpoint(E){return A._debugServiceProxy.$getDebugProtocolBreakpoint(A._id,E.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(A){this._name=A}get configuration(){return this._configuration}}e.ExtHostDebugSession=c;class g{constructor(A){this.value=Object.freeze({append(E){A.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.ExtHostDebugConsole=g;class w{constructor(A){this.trackers=A}onWillStartSession(){this.trackers.forEach(A=>A.onWillStartSession?A.onWillStartSession():void 0)}onWillReceiveMessage(A){this.trackers.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(A):void 0)}onDidSendMessage(A){this.trackers.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(A):void 0)}onWillStopSession(){this.trackers.forEach(A=>A.onWillStopSession?A.onWillStopSession():void 0)}onError(A){this.trackers.forEach(E=>E.onError?E.onError(A):void 0)}onExit(A,E){this.trackers.forEach(S=>S.onExit?S.onExit(A,E):void 0)}}class D extends b.AbstractDebugAdapter{constructor(A){super(),this.implementation=A,A.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(A){this.implementation.handleMessage(A)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let _=class extends h{constructor(A,E,S,F,N,O,M,U){super(A,E,S,F,N,O,M,U)}};e.WorkerExtHostDebugService=_,e.WorkerExtHostDebugService=_=Xe([He(0,y.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,p.IExtHostConfiguration),He(4,l.IExtHostEditorTabs),He(5,f.IExtHostVariableResolverProvider),He(6,s.IExtHostCommands),He(7,n.IExtHostTesting)],_)}),define(Ce[340],Ie([1,0,13,61,2,6,288,11,88,114,29,225,19,72,54,94]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0,r=$e(r),d=$e(d);class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(R.ILogService),o=i.get(u.IExtHostRpcService).getProxy(k.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(n=>{s.error(n);const h=r.transformErrorForSerialization(n);o.$onUnexpectedError(h)})}static async installFullHandler(i){const s=i.get(R.ILogService),t=i.get(u.IExtHostRpcService),o=i.get(b.IExtHostExtensionService),n=i.get(a.IExtHostTelemetry),h=t.getProxy(k.MainContext.MainThreadExtensionService),c=t.getProxy(k.MainContext.MainThreadErrors),g=await o.getExtensionPathIndex(),w=new WeakMap;function D(A,E){if(w.has(A))return w.get(A).stack;let S="",F,N;for(const M of E)S+=`
	at ${M.toString()}`,N=M.getFileName(),!F&&N&&(F=g.findSubstr(P.URI.file(N)));const O=`${A.name||"Error"}: ${A.message||""}${S}`;return w.set(A,{extensionIdentifier:F?.identifier,stack:O}),O}const _=Symbol("prepareStackTrace wrapped");let C=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(A){if(A===D||!A||A[_]){C=A||D;return}C=function(E,S){return D(E,S),A.call(Error,E,S)},Object.assign(C,{[_]:!0})}}),r.setUnexpectedErrorHandler(A=>{s.error(A);const E=r.transformErrorForSerialization(A),S=w.get(A);if(!S?.extensionIdentifier){c.$onUnexpectedError(E);return}h.$onExtensionRuntimeError(S.extensionIdentifier,E);const F=n.onExtensionError(S.extensionIdentifier,A);s.trace("forwarded error to extension?",F,S)})}}e.ErrorHandler=m;class p{constructor(i,s,t,o,n){this._hostUtils=t,this._rpcProtocol=new L.RPCProtocol(i,null,o),s=p._transform(s,this._rpcProtocol);const h=new l.ServiceCollection(...(0,v.getSingletonServiceDescriptors)());h.set(I.IExtHostInitDataService,{_serviceBrand:void 0,...s,messagePorts:n}),h.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),h.set(T.IURITransformerService,new T.URITransformerService(o)),h.set(b.IHostUtils,t);const c=new y.InstantiationService(h,!0);c.invokeFunction(m.installEarlyHandler),this._logService=c.invokeFunction(g=>g.get(R.ILogService)),d.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",s),this._extensionService=c.invokeFunction(g=>g.get(b.IExtHostExtensionService)),this._extensionService.initialize(),c.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const s=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService);return P.URI.revive(await s.$asBrowserUri(i))}terminate(i){this._extensionService.terminate(i)}static _transform(i,s){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=P.URI.revive(s.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=P.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>P.URI.revive(s.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=P.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.ExtensionHostMain=p}),define(Ce[341],Ie([1,0,7,10,8,218,148,101,77,54,19,48,9,64,49,259,260,41,34,98]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0,d=$e(d),P=$e(P);let s=class extends R.ExtHostDebugServiceBase{constructor(c,g,w,D,_,C,A,E,S){super(c,g,w,D,C,A,E,S),this._terminalService=_,this._integratedTerminalInstances=new n}createDebugAdapter(c,g){switch(c.type){case"server":return new a.SocketDebugAdapter(c);case"pipeServer":return new a.NamedPipeDebugAdapter(c);case"executable":return new a.ExecutableDebugAdapter(c,g.type)}return super.createDebugAdapter(c,g)}daExecutableFromPackage(c,g){const w=a.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),c.type);if(w)return new u.DebugAdapterExecutable(w.command,w.args,w.options)}createSignService(){return new L.SignService}async $runInTerminal(c,g){if(c.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._register(this._terminalService.onDidCloseTerminal(U=>{this._integratedTerminalInstances.onTerminalClosed(U)})));const w=await this._configurationService.getConfigProvider(),D=this._terminalService.getDefaultShell(!0),_=this._terminalService.getDefaultShellArgs(!0),C=c.title||P.localize(11017,null),A=JSON.stringify({shell:D,shellArgs:_});let E=await this._integratedTerminalInstances.checkout(A,C),S,F=!1;if(E)S=c.cwd;else{const U={shellPath:D,shellArgs:_,cwd:c.cwd,name:C,iconPath:new u.ThemeIcon("debug")};F=!0,E=this._terminalService.createTerminalFromOptions(U,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(E,A)}E.show(!0);const N=await E.processId;F?await new Promise(U=>setTimeout(U,1e3)):(E.state.isInteractedWith&&(E.sendText(""),await(0,r.timeout)(200)),w.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?E.sendText("cls"):D.indexOf("bash")>=0?E.sendText("clear"):d.isWindows?E.sendText("cls"):E.sendText("clear")));const O=(0,m.prepareCommand)(D,c.args,!!c.argsCanBeInterpretedByShell,S,c.env);E.sendText(O);const M=this.onDidTerminateDebugSession(U=>{U.id===g&&(this._integratedTerminalInstances.free(E),M.dispose())});return N}else if(c.kind==="external")return o(c,await this._configurationService.getConfigProvider());return super.$runInTerminal(c,g)}};e.ExtHostDebugService=s,e.ExtHostDebugService=s=Xe([He(0,I.IExtHostRpcService),He(1,b.IExtHostWorkspace),He(2,l.IExtHostExtensionService),He(3,p.IExtHostConfiguration),He(4,y.IExtHostTerminalService),He(5,v.IExtHostEditorTabs),He(6,T.IExtHostVariableResolverProvider),He(7,f.IExtHostCommands),He(8,i.IExtHostTesting)],s);let t;function o(h,c){if(!t)if(d.isWindows)t=new k.WindowsExternalTerminalService;else if(d.isMacintosh)t=new k.MacExternalTerminalService;else if(d.isLinux)t=new k.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const g=c.getConfiguration("terminal");return t.runInTerminal(h.title,h.cwd,h.args,h.env||{},g.external||{})}class n{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(c,g,w=!1){const _=[...this._terminalInstances.entries()].map(([C,A])=>(0,r.createCancelablePromise)(async E=>{if(C.name!==g||A.lastUsedAt!==-1&&await(0,m.hasChildProcesses)(await C.processId))return null;const S=Date.now();return A.lastUsedAt+n.minUseDelay>S||E.isCancellationRequested?null:A.config!==c?(w&&C.dispose(),null):(A.lastUsedAt=S,C)}));return await(0,r.firstParallel)(_,C=>!!C)}insert(c,g){this._terminalInstances.set(c,{lastUsedAt:Date.now(),config:g})}free(c){const g=this._terminalInstances.get(c);g&&(g.lastUsedAt=-1)}onTerminalClosed(c){this._terminalInstances.delete(c)}}}),define(Ce[342],Ie([1,0,16,2,109,49,63,41,47,48,19,29,100,14,11,95,22,66,64]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0,r=$e(r),m=$e(m);let i=class extends u.ExtHostTaskBase{constructor(t,o,n,h,c,g,w,D,_){super(t,o,n,h,c,g,w,D),this.workspaceService=n,this.variableResolver=_,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,o){const n=o;if(!o.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const h=u.TaskHandleDTO.from(n,this.workspaceService),c=await this._proxy.$getTaskExecution(h);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const g=await this.getTaskExecution(c,o);return this._proxy.$executeTask(h).catch(()=>{}),g}else{const h=u.TaskDTO.from(o,t);if(h===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(h.execution)&&await this.addCustomExecution(h,o,!1);const c=await this.getTaskExecution(await this._proxy.$getTaskExecution(h),o);return this._proxy.$executeTask(h).catch(()=>{}),c}}provideTasksInternal(t,o,n,h){const c=[];if(h)for(const g of h){this.checkDeprecation(g,n),(!g.definition||!t[g.definition.type])&&this._logService.warn(`The task [${g.source}, ${g.name}] uses an undefined task type. The task will be ignored in the future.`);const w=u.TaskDTO.from(g,n.extension);w&&(c.push(w),u.CustomExecutionDTO.is(w.execution)&&o.push(this.addCustomExecution(w,g,!0)))}return{tasks:c,extension:n.extension}}async resolveTaskInternal(t){return t}async getAFolder(t){let o=t&&t.length>0?t[0]:void 0;if(!o){const n=d.URI.file((0,p.homedir)());o=new v.WorkspaceFolder({uri:n,name:m.basename(n),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,o){const n=d.URI.revive(t),h={process:void 0,variables:Object.create(null)},c=await this._workspaceProvider.resolveWorkspaceFolder(n),g=await this._workspaceProvider.getWorkspaceFolders2()??[],w=await this.variableResolver.getResolver(),D=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(g);for(const _ of o.variables)h.variables[_]=await w.resolveAsync(D,_);if(o.process!==void 0){let _;if(o.process.path!==void 0){_=o.process.path.split(r.delimiter);for(let C=0;C<_.length;C++)_[C]=await w.resolveAsync(D,_[C])}h.process=await P.win32.findExecutable(await w.resolveAsync(D,o.process.name),o.process.cwd!==void 0?await w.resolveAsync(D,o.process.cwd):void 0,_)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(t,o,n){return P.win32.findExecutable(t,o,n)}};e.ExtHostTask=i,e.ExtHostTask=i=Xe([He(0,I.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,L.IExtHostDocumentsAndEditors),He(4,R.IExtHostConfiguration),He(5,l.IExtHostTerminalService),He(6,b.ILogService),He(7,a.IExtHostApiDeprecationService),He(8,f.IExtHostVariableResolverProvider)],i)}),define(Ce[343],Ie([1,0,66,64]),function(pe,e,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class P extends d.ExtHostVariableResolverProviderService{homeDir(){return(0,r.homedir)()}}e.NodeExtHostVariableResolverProviderService=P}),define(Ce[171],Ie([1,0,18,7,20,52,14,16,22,2,37]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,e.extensionResultIsMatch=a,R=$e(R),v=$e(v);class y{constructor(f,i,s){this.queryProviderPair=f,this.fileUtils=i,this.processType=s,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(f,i){const s=this.query.folderQueries||[],t=new P.CancellationTokenSource(i);return new Promise((o,n)=>{this.collector=new T(f);let h=!1;const c=(g,w)=>{if(!h&&!this.isLimitHit){const D=this.resultSize(g);a(g)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,h=!0,t.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const _=this.resultSize(g);this.resultCount+=_,(_>0||!a(g))&&this.collector.add(g,w)}};Promise.all(s.map((g,w)=>this.searchInFolder(g,D=>c(D,w),t.token))).then(g=>{t.dispose(),this.collector.flush();const w=g.some(D=>!!D&&!!D.limitHit);o({limitHit:this.isLimitHit||w,messages:g.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.processType}})},g=>{t.dispose();const w=(0,k.toErrorMessage)(g);n(new Error(w))})})}resultSize(f){return a(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,i){const s=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:s.slice(0,i),preview:{matches:t.slice(0,i),text:f.preview.text},uri:f.uri}}async searchInFolder(f,i,s){const t=new I.QueryGlobTester(this.query,f),o=[],n={report:g=>{if(!this.validateProviderResult(g))return;const w=f.folder.scheme===L.Schemas.file?(0,I.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(v.dirname(g.uri))):void 0,D=v.relativePath(f.folder,g.uri);if(D){const _=t.includedInQuery(D,R.basename(D),w);(0,d.isThenable)(_)?o.push(_.then(C=>{C&&i(g)})):_&&i(g)}}},h=this.getSearchOptionsForFolder(f);let c;return this.queryProviderPair.query.type===I.QueryType.aiText?c=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,h,n,s):c=await this.queryProviderPair.provider.provideTextSearchResults(u(this.queryProviderPair.query.contentPattern),h,n,s),o.length&&await Promise.all(o),c}validateProviderResult(f){if(a(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const i=(0,I.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),s=(0,I.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),t={folder:l.URI.from(f.folder),excludes:s,includes:i,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults??I.DEFAULT_MAX_SEARCH_RESULTS,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return"usePCRE2"in this.query&&(t.usePCRE2=this.query.usePCRE2),t}}e.TextSearchManager=y;function u(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class T{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,i=>this.sendItems(i))}add(f,i){this._currentFileMatch&&(this._currentFolderIdx!==i||!v.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=i,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(b(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=T;function b(p){return a(p)?{preview:{matches:(0,r.mapArrayOrNot)(p.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:p.preview.text},ranges:(0,r.mapArrayOrNot)(p.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:p.text,lineNumber:p.lineNumber}}function a(p){return!!p.preview}class m{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(f,i){this.maxBatchSize=f,this.cb=i,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,i){f&&this.addItemToBatch(f,i)}addItems(f,i){f&&this.addItemsToBatch(f,i)}addItemToBatch(f,i){this.batch.push(f),this.batchSize+=i,this.onUpdate()}addItemsToBatch(f,i){this.batch=this.batch.concat(f),this.batchSize+=i,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m}),define(Ce[102],Ie([1,0,3,6,5,336,19,72,11,2,171]),function(pe,e,r,d,P,k,L,R,v,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=u,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let y=class{constructor(a,m,p){this.extHostRpc=a,this._uriTransformer=m,this._logService=p,this._proxy=this.extHostRpc.getProxy(d.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new k.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const p=this._handlePool++;return this._textSearchProvider.set(p,m),this._proxy.$registerTextSearchProvider(p,this._transformScheme(a)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}registerAITextSearchProvider(a,m){if(this._aiTextSearchUsedSchemes.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this._aiTextSearchUsedSchemes.add(a);const p=this._handlePool++;return this._aiTextSearchProvider.set(p,m),this._proxy.$registerAITextSearchProvider(p,this._transformScheme(a)),(0,r.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(a),this._aiTextSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}registerFileSearchProvider(a,m){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const p=this._handlePool++;return this._fileSearchProvider.set(p,m),this._proxy.$registerFileSearchProvider(p,this._transformScheme(a)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}$provideFileSearchResults(a,m,p,f){const i=u(p),s=this._fileSearchProvider.get(a);if(s)return this._fileSearchManager.fileSearch(i,s,t=>{this._proxy.$handleFileMatch(a,m,t.map(o=>o.resource))},f);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,p){return{messages:[]}}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,p,f){const i=this._textSearchProvider.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${a}`);const s=u(p);return this.createTextSearchManager(s,i).search(o=>this._proxy.$handleTextMatch(a,m,o),f)}$provideAITextSearchResults(a,m,p,f){const i=this._aiTextSearchProvider.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${a}`);const s=u(p);return this.createAITextSearchManager(s,i).search(o=>this._proxy.$handleTextMatch(a,m,o),f)}$enableExtensionHostSearch(){}createTextSearchManager(a,m){return new I.TextSearchManager({query:a,provider:m},{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p},"textSearchProvider")}createAITextSearchManager(a,m){return new I.TextSearchManager({query:a,provider:m},{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p},"aiTextSearchProvider")}};e.ExtHostSearch=y,e.ExtHostSearch=y=Xe([He(0,L.IExtHostRpcService),He(1,R.IURITransformerService),He(2,v.ILogService)],y);function u(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(T),extraFileResources:b.extraFileResources&&b.extraFileResources.map(a=>l.URI.revive(a))}}function T(b){return{...b,folder:l.URI.revive(b.folder)}}});var Wt=this&&this.__importDefault||function(pe){return pe&&pe.__esModule?pe:{default:pe}};define(Ce[344],Ie([1,0,7,20,13,4,3,14,43,2,113,201,202,58,23,27,11,90,91,246,6,290,317,95,127,294,295,296,275,265,34,297,41,298,101,163,299,277,291,300,301,63,77,278,292,54,302,75,303,62,29,318,279,304,305,128,306,122,123,280,335,308,250,309,319,310,169,281,311,312,313,19,314,102,124,315,282,316,125,97,100,94,48,167,98,320,293,321,322,76,15,9,283,72,284,96,323,324,162,49,119,93,25,99]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n,h,c,g,w,D,_,C,A,E,S,F,N,O,M,U,x,z,B,ee,V,$,G,Z,le,ne,_e,ge,Y,W,oe,Se,te,ae,se,Q,re,ve,be,Fe,Be,ke,De,Pe,H,q,X,J,he,we,Oe,Ve,Ke,et,nt,st,rt,at,gt,ht,lt,Te,Ue,je,Ne,xe,ue,de,ce,Qe,tt,ut,mt,Dt,Mt,Vt,ei,oi,Rt,it,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=di,P=$e(P),v=Wt(v),u=$e(u),a=$e(a),de=$e(de),ce=$e(ce);function di(Et){const yt=Et.get(ge.IExtHostInitDataService),ti=Et.get(_e.IExtHostFileSystemInfo),ii=Et.get(le.IExtHostConsumerFileSystem),zt=Et.get(G.IExtHostExtensionService),vt=Et.get(ei.IExtHostWorkspace),Bt=Et.get(gt.IExtHostTelemetry),ni=Et.get(E.IExtHostConfiguration),ai=Et.get(tt.IURITransformerService),Je=Et.get(he.IExtHostRpcService),li=Et.get(st.IExtHostStorage),hi=Et.get(rt.IExtensionStoragePaths),fi=Et.get(m.ILoggerService),St=Et.get(m.ILogService),xt=Et.get(ue.IExtHostTunnelService),Nt=Et.get(n.IExtHostApiDeprecationService),qt=Et.get(Vt.IExtHostWindow),ri=Et.get(Ve.IExtHostSecretState),Gt=Et.get(ee.IExtHostEditorTabs),ci=Et.get(Q.IExtHostManagedSockets),$t=Et.get(h.IExtHostAuthentication),Kt=Et.get(te.IExtHostLanguageModels);Je.set(s.ExtHostContext.ExtHostFileSystemInfo,ti),Je.set(s.ExtHostContext.ExtHostLogLevelServiceShape,fi),Je.set(s.ExtHostContext.ExtHostWorkspace,vt),Je.set(s.ExtHostContext.ExtHostConfiguration,ni),Je.set(s.ExtHostContext.ExtHostExtensionService,zt),Je.set(s.ExtHostContext.ExtHostStorage,li),Je.set(s.ExtHostContext.ExtHostTunnelService,xt),Je.set(s.ExtHostContext.ExtHostWindow,qt),Je.set(s.ExtHostContext.ExtHostSecretState,ri),Je.set(s.ExtHostContext.ExtHostTelemetry,Bt),Je.set(s.ExtHostContext.ExtHostEditorTabs,Gt),Je.set(s.ExtHostContext.ExtHostManagedSockets,ci),Je.set(s.ExtHostContext.ExtHostAuthentication,$t),Je.set(s.ExtHostContext.ExtHostChatProvider,Kt);const Xt=Je.set(s.ExtHostContext.ExtHostDecorations,Et.get(N.IExtHostDecorations)),Ft=Je.set(s.ExtHostContext.ExtHostDocumentsAndEditors,Et.get(B.IExtHostDocumentsAndEditors)),bt=Je.set(s.ExtHostContext.ExtHostCommands,Et.get(C.IExtHostCommands)),It=Je.set(s.ExtHostContext.ExtHostTerminalService,Et.get(ht.IExtHostTerminalService)),jt=Je.set(s.ExtHostContext.ExtHostTerminalShellIntegration,Et.get(lt.IExtHostTerminalShellIntegration)),Tt=Je.set(s.ExtHostContext.ExtHostDebugService,Et.get(F.IExtHostDebugService)),mi=Je.set(s.ExtHostContext.ExtHostSearch,Et.get(Oe.IExtHostSearch)),Jt=Je.set(s.ExtHostContext.ExtHostTask,Et.get(at.IExtHostTask)),Ci=Je.set(s.ExtHostContext.ExtHostOutputService,Et.get(Pe.IExtHostOutputService)),Ei=Je.set(s.ExtHostContext.ExtHostLocalization,Et.get(se.IExtHostLocalizationService)),ki=Je.set(s.ExtHostContext.ExtHostUrls,new ut.ExtHostUrls(Je)),Lt=Je.set(s.ExtHostContext.ExtHostDocuments,new z.ExtHostDocuments(Je,Ft)),Oi=Je.set(s.ExtHostContext.ExtHostDocumentContentProviders,new U.ExtHostDocumentContentProvider(Je,Ft,St)),ui=Je.set(s.ExtHostContext.ExtHostDocumentSaveParticipant,new x.ExtHostDocumentSaveParticipant(St,Lt,Je.getProxy(s.MainContext.MainThreadBulkEdits))),At=Je.set(s.ExtHostContext.ExtHostNotebook,new ve.ExtHostNotebookController(Je,bt,Ft,Lt,ii,mi,St)),Ri=Je.set(s.ExtHostContext.ExtHostNotebookDocuments,new Fe.ExtHostNotebookDocuments(At)),Ii=Je.set(s.ExtHostContext.ExtHostNotebookEditors,new Be.ExtHostNotebookEditors(St,At)),yi=Je.set(s.ExtHostContext.ExtHostNotebookKernels,new ke.ExtHostNotebookKernels(Je,yt,At,bt,St)),Ni=Je.set(s.ExtHostContext.ExtHostNotebookRenderers,new De.ExtHostNotebookRenderers(Je,At)),bi=Je.set(s.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new be.ExtHostNotebookDocumentSaveParticipant(St,At,Je.getProxy(s.MainContext.MainThreadBulkEdits))),Ht=Je.set(s.ExtHostContext.ExtHostEditors,new Ue.ExtHostEditors(Je,Ft)),Re=Je.set(s.ExtHostContext.ExtHostTreeViews,new xe.ExtHostTreeViews(Je.getProxy(s.MainContext.MainThreadTreeViews),bt,St)),Me=Je.set(s.ExtHostContext.ExtHostEditorInsets,new _.ExtHostEditorInsets(Je.getProxy(s.MainContext.MainThreadEditorInsets),Ht,yt.remote)),ye=Je.set(s.ExtHostContext.ExtHostDiagnostics,new O.ExtHostDiagnostics(Je,St,ti,Ft)),ie=Je.set(s.ExtHostContext.ExtHostLanguages,new ae.ExtHostLanguages(Je,Lt,bt.converter,ai)),Ae=Je.set(s.ExtHostContext.ExtHostLanguageFeatures,new oe.ExtHostLanguageFeatures(Je,ai,Lt,bt,ye,St,Nt,Bt)),qe=Je.set(s.ExtHostContext.ExtHostFileSystem,new Z.ExtHostFileSystem(Je,Ae)),Ze=Je.set(s.ExtHostContext.ExtHostFileSystemEventService,new ne.ExtHostFileSystemEventService(Je,St,Ft)),Ge=Je.set(s.ExtHostContext.ExtHostQuickOpen,(0,J.createExtHostQuickOpen)(Je,vt,bt)),ft=Je.set(s.ExtHostContext.ExtHostSCM,new we.ExtHostSCM(Je,bt,Lt,St)),kt=Je.set(s.ExtHostContext.ExtHostQuickDiff,new X.ExtHostQuickDiff(Je,ai)),Qt=Je.set(s.ExtHostContext.ExtHostShare,new Ke.ExtHostShare(Je,ai)),si=Je.set(s.ExtHostContext.ExtHostComments,(0,A.createExtHostComments)(Je,bt,Lt)),Ut=Je.set(s.ExtHostContext.ExtHostProgress,new q.ExtHostProgress(Je.getProxy(s.MainContext.MainThreadProgress))),Zt=Je.set(s.ExtHostContext.ExtHostLabelService,new W.ExtHostLabelService(Je)),$i=Je.set(s.ExtHostContext.ExtHostTheming,new je.ExtHostTheming(Je)),rn=Je.set(s.ExtHostContext.ExtHostTimeline,new Ne.ExtHostTimeline(Je,bt)),Hi=Je.set(s.ExtHostContext.ExtHostWebviews,new mt.ExtHostWebviews(Je,yt.remote,vt,St,Nt)),Mi=Je.set(s.ExtHostContext.ExtHostWebviewPanels,new Dt.ExtHostWebviewPanels(Je,Hi,vt)),Vi=Je.set(s.ExtHostContext.ExtHostCustomEditors,new S.ExtHostCustomEditors(Je,Lt,hi,Hi,Mi)),qi=Je.set(s.ExtHostContext.ExtHostWebviewViews,new Mt.ExtHostWebviewViews(Je,Hi)),Ti=Je.set(s.ExtHostContext.ExtHostTesting,Et.get(Te.IExtHostTesting)),sn=Je.set(s.ExtHostContext.ExtHostUriOpeners,new Qe.ExtHostUriOpeners(Je)),on=Je.set(s.ExtHostContext.ExtHostProfileContentHandlers,new H.ExtHostProfileContentHandlers(Je));Je.set(s.ExtHostContext.ExtHostInteractive,new Y.ExtHostInteractive(Je,At,Ft,bt,St));const xi=Je.set(s.ExtHostContext.ExtHostChatAgents2,new g.ExtHostChatAgents2(Je,St,bt,Lt)),an=Je.set(s.ExtHostContext.ExtHostChatVariables,new w.ExtHostChatVariables(Je)),Ui=Je.set(s.ExtHostContext.ExtHostLanguageModelTools,new Se.ExtHostLanguageModelTools(Je)),ji=Je.set(s.ExtHostContext.ExtHostAiRelatedInformation,new t.ExtHostRelatedInformation(Je)),_n=Je.set(s.ExtHostContext.ExtHostAiEmbeddingVector,new $.ExtHostAiEmbeddingVector(Je)),ln=Je.set(s.ExtHostContext.ExtHostStatusBar,new nt.ExtHostStatusBar(Je,bt.converter)),Ki=Je.set(s.ExtHostContext.ExtHostSpeech,new et.ExtHostSpeech(Je)),Pi=Je.set(s.ExtHostContext.ExtHostEmbeddings,new V.ExtHostEmbeddings(Je)),yn=Object.values(s.ExtHostContext);Je.assertRegistered(yn);const Dn=new c.ExtHostBulkEdits(Je,Ft),cn=new D.ExtHostClipboard(Je),Gi=new re.ExtHostMessageService(Je,St),Xi=new M.ExtHostDialogs(Je);return o.ExtHostApiCommands.register(bt),function(ze,Si,Qi){function ct(fe){return(Ee,We,dt)=>{const wt=fe(Ot=>{try{Ee.call(We,Ot)}catch(gi){P.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${gi.toString()}`,{cause:gi})),Bt.onExtensionError(ze.identifier,gi)}});return dt?.push(wt),wt}}const Ct=function(){let fe=!ze.isUnderDevelopment;function Ee(){fe||(St.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function We(dt){if(Array.isArray(dt))dt.forEach(We);else if(typeof dt=="string")Ee();else{const wt=dt;typeof wt.scheme>"u"&&Ee(),typeof wt.exclusive=="boolean"&&(0,it.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return dt}}(),Yi={getSession(fe,Ee,We){return typeof We?.forceNewSession=="object"&&We.forceNewSession.learnMore&&(0,it.checkProposedApiEnabled)(ze,"authLearnMore"),We?.account&&(0,it.checkProposedApiEnabled)(ze,"authGetSessions"),$t.getSession(ze,fe,Ee,We)},getAccounts(fe){return(0,it.checkProposedApiEnabled)(ze,"authGetSessions"),$t.getAccounts(fe)},async hasSession(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"authSession"),!!await $t.getSession(ze,fe,Ee,{silent:!0})},get onDidChangeSessions(){return ct($t.onDidChangeSessions)},registerAuthenticationProvider(fe,Ee,We,dt){return $t.registerAuthenticationProvider(fe,Ee,We,dt)}},un={registerCommand(fe,Ee,We){return bt.registerCommand(!0,fe,Ee,We,void 0,ze)},registerTextEditorCommand(fe,Ee,We){return bt.registerCommand(!0,fe,(...dt)=>{const wt=Ht.getActiveTextEditor();if(!wt){St.warn("Cannot execute "+fe+" because there is no active text editor.");return}return wt.edit(Ot=>{Ee.apply(We,[wt,Ot,...dt])}).then(Ot=>{Ot||St.warn("Edits from command "+fe+" were not applied.")},Ot=>{St.warn("An error occurred while running command "+fe,Ot)})},void 0,void 0,ze)},registerDiffInformationCommand:(fe,Ee,We)=>((0,it.checkProposedApiEnabled)(ze,"diffCommand"),bt.registerCommand(!0,fe,async(...dt)=>{const wt=Ft.activeEditor(!0);if(!wt){St.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Ot=await Ht.getDiffInformation(wt.id);Ee.apply(We,[Ot,...dt])},void 0,void 0,ze)),executeCommand(fe,...Ee){return bt.executeCommand(fe,...Ee)},getCommands(fe=!1){return bt.getCommands(fe)}},wi={get machineId(){return yt.telemetryInfo.machineId},get sessionId(){return yt.telemetryInfo.sessionId},get language(){return yt.environment.appLanguage},get appName(){return yt.environment.appName},get appRoot(){return yt.environment.appRoot?.fsPath??""},get appHost(){return yt.environment.appHost},get uriScheme(){return yt.environment.appUriScheme},get clipboard(){return cn.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return ct(It.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ct(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,it.checkProposedApiEnabled)(ze,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,it.checkProposedApiEnabled)(ze,"telemetry"),ct(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,gt.isNewAppInstall)(yt.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,Ee){return gt.ExtHostTelemetryLogger.validateSender(fe),Bt.instantiateLogger(ze,fe,Ee)},openExternal(fe,Ee){return qt.openUri(fe,{allowTunneling:!!yt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===yt.environment.appUriScheme)return ki.createAppUri(fe);try{return await qt.asExternalUri(fe,{allowTunneling:!!yt.remote.authority})}catch(Ee){if((0,R.matchesScheme)(fe,R.Schemas.http)||(0,R.matchesScheme)(fe,R.Schemas.https))return fe;throw Ee}},get remoteName(){return(0,p.getRemoteName)(yt.remote.authority)},get remoteAuthority(){return(0,it.checkProposedApiEnabled)(ze,"resolvers"),yt.remote.authority},get uiKind(){return yt.uiKind},get logLevel(){return St.getLevel()},get onDidChangeLogLevel(){return ct(St.onDidChangeLogLevel)},get appQuality(){return(0,it.checkProposedApiEnabled)(ze,"resolvers"),yt.quality},get appCommit(){return(0,it.checkProposedApiEnabled)(ze,"resolvers"),yt.commit}};yt.environment.extensionTestsLocationURI||Object.freeze(wi);const Bi={createTestController(fe,Ee,We){return Ti.createTestController(ze,fe,Ee,We)},createTestObserver(){return(0,it.checkProposedApiEnabled)(ze,"testObserver"),Ti.createTestObserver()},runTests(fe){return(0,it.checkProposedApiEnabled)(ze,"testObserver"),Ti.runTests(fe)},registerTestFollowupProvider(fe){return(0,it.checkProposedApiEnabled)(ze,"testObserver"),Ti.registerTestFollowupProvider(fe)},get onDidChangeTestResults(){return(0,it.checkProposedApiEnabled)(ze,"testObserver"),ct(Ti.onResultsChanged)},get testResults(){return(0,it.checkProposedApiEnabled)(ze,"testObserver"),Ti.results}},Wi=yt.remote.isRemote?ce.ExtensionKind.Workspace:ce.ExtensionKind.UI,pi={getExtension(fe,Ee){(0,it.isProposedApiEnabled)(ze,"extensionsAny")||(Ee=!1);const We=Si.mine.getExtensionDescription(fe);if(We)return new G.Extension(zt,ze.identifier,We,Wi,!1);if(Ee){const dt=Si.all.getExtensionDescription(fe);if(dt)return new G.Extension(zt,ze.identifier,dt,Wi,!0)}},get all(){const fe=[];for(const Ee of Si.mine.getAllExtensionDescriptions())fe.push(new G.Extension(zt,ze.identifier,Ee,Wi,!1));return fe},get allAcrossExtensionHosts(){(0,it.checkProposedApiEnabled)(ze,"extensionsAny");const fe=new b.ExtensionIdentifierSet(Si.mine.getAllExtensionDescriptions().map(We=>We.identifier)),Ee=[];for(const We of Si.all.getAllExtensionDescriptions()){const dt=!fe.has(We.identifier);Ee.push(new G.Extension(zt,ze.identifier,We,Wi,dt))}return Ee},get onDidChange(){return(0,it.isProposedApiEnabled)(ze,"extensionsAny")?ct(k.Event.any(Si.mine.onDidChange,Si.all.onDidChange)):ct(Si.mine.onDidChange)}},zi={createDiagnosticCollection(fe){return ye.createDiagnosticCollection(ze.identifier,fe)},get onDidChangeDiagnostics(){return ct(ye.onDidChangeDiagnostics)},getDiagnostics:fe=>ye.getDiagnostics(fe),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(fe,Ee){return ie.changeLanguage(fe.uri,Ee)},match(fe,Ee){const We=de.LanguageSelector.from(fe);let dt;return(0,y.targetsNotebooks)(We)&&(dt=At.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Ot=>Ot.document===Ee))?.apiNotebook),(0,y.score)(We,Ee.uri,Ee.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(fe,Ee,We){return Ae.registerCodeActionProvider(ze,Ct(fe),Ee,We)},registerDocumentPasteEditProvider(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"documentPaste"),Ae.registerDocumentPasteEditProvider(ze,Ct(fe),Ee,We)},registerCodeLensProvider(fe,Ee){return Ae.registerCodeLensProvider(ze,Ct(fe),Ee)},registerDefinitionProvider(fe,Ee){return Ae.registerDefinitionProvider(ze,Ct(fe),Ee)},registerDeclarationProvider(fe,Ee){return Ae.registerDeclarationProvider(ze,Ct(fe),Ee)},registerImplementationProvider(fe,Ee){return Ae.registerImplementationProvider(ze,Ct(fe),Ee)},registerTypeDefinitionProvider(fe,Ee){return Ae.registerTypeDefinitionProvider(ze,Ct(fe),Ee)},registerHoverProvider(fe,Ee){return Ae.registerHoverProvider(ze,Ct(fe),Ee,ze.identifier)},registerEvaluatableExpressionProvider(fe,Ee){return Ae.registerEvaluatableExpressionProvider(ze,Ct(fe),Ee,ze.identifier)},registerInlineValuesProvider(fe,Ee){return Ae.registerInlineValuesProvider(ze,Ct(fe),Ee,ze.identifier)},registerDocumentHighlightProvider(fe,Ee){return Ae.registerDocumentHighlightProvider(ze,Ct(fe),Ee)},registerMultiDocumentHighlightProvider(fe,Ee){return Ae.registerMultiDocumentHighlightProvider(ze,Ct(fe),Ee)},registerLinkedEditingRangeProvider(fe,Ee){return Ae.registerLinkedEditingRangeProvider(ze,Ct(fe),Ee)},registerReferenceProvider(fe,Ee){return Ae.registerReferenceProvider(ze,Ct(fe),Ee)},registerRenameProvider(fe,Ee){return Ae.registerRenameProvider(ze,Ct(fe),Ee)},registerNewSymbolNamesProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"newSymbolNamesProvider"),Ae.registerNewSymbolNamesProvider(ze,Ct(fe),Ee)},registerDocumentSymbolProvider(fe,Ee,We){return Ae.registerDocumentSymbolProvider(ze,Ct(fe),Ee,We)},registerWorkspaceSymbolProvider(fe){return Ae.registerWorkspaceSymbolProvider(ze,fe)},registerDocumentFormattingEditProvider(fe,Ee){return Ae.registerDocumentFormattingEditProvider(ze,Ct(fe),Ee)},registerDocumentRangeFormattingEditProvider(fe,Ee){return Ae.registerDocumentRangeFormattingEditProvider(ze,Ct(fe),Ee)},registerOnTypeFormattingEditProvider(fe,Ee,We,...dt){return Ae.registerOnTypeFormattingEditProvider(ze,Ct(fe),Ee,[We].concat(dt))},registerDocumentSemanticTokensProvider(fe,Ee,We){return Ae.registerDocumentSemanticTokensProvider(ze,Ct(fe),Ee,We)},registerDocumentRangeSemanticTokensProvider(fe,Ee,We){return Ae.registerDocumentRangeSemanticTokensProvider(ze,Ct(fe),Ee,We)},registerSignatureHelpProvider(fe,Ee,We,...dt){return typeof We=="object"?Ae.registerSignatureHelpProvider(ze,Ct(fe),Ee,We):Ae.registerSignatureHelpProvider(ze,Ct(fe),Ee,typeof We>"u"?[]:[We,...dt])},registerCompletionItemProvider(fe,Ee,...We){return Ae.registerCompletionItemProvider(ze,Ct(fe),Ee,We)},registerInlineCompletionItemProvider(fe,Ee,We){return Ee.handleDidShowCompletionItem&&(0,it.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,it.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),We&&(0,it.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),Ae.registerInlineCompletionsProvider(ze,Ct(fe),Ee,We)},registerInlineEditProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"inlineEdit"),Ae.registerInlineEditProvider(ze,Ct(fe),Ee)},registerDocumentLinkProvider(fe,Ee){return Ae.registerDocumentLinkProvider(ze,Ct(fe),Ee)},registerColorProvider(fe,Ee){return Ae.registerColorProvider(ze,Ct(fe),Ee)},registerFoldingRangeProvider(fe,Ee){return Ae.registerFoldingRangeProvider(ze,Ct(fe),Ee)},registerSelectionRangeProvider(fe,Ee){return Ae.registerSelectionRangeProvider(ze,fe,Ee)},registerCallHierarchyProvider(fe,Ee){return Ae.registerCallHierarchyProvider(ze,fe,Ee)},registerTypeHierarchyProvider(fe,Ee){return Ae.registerTypeHierarchyProvider(ze,fe,Ee)},setLanguageConfiguration:(fe,Ee)=>Ae.setLanguageConfiguration(ze,fe,Ee),getTokenInformationAtPosition(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"tokenInformation"),ie.tokenAtPosition(fe,Ee)},registerInlayHintsProvider(fe,Ee){return Ae.registerInlayHintsProvider(ze,fe,Ee)},createLanguageStatusItem(fe,Ee){return ie.createLanguageStatusItem(ze,fe,Ee)},registerDocumentDropEditProvider(fe,Ee,We){return Ae.registerDocumentOnDropEditProvider(ze,fe,Ee,(0,it.isProposedApiEnabled)(ze,"documentPaste")?We:void 0)}},dn={get activeTextEditor(){return Ht.getActiveTextEditor()},get visibleTextEditors(){return Ht.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(fe,Ee,We){l.URI.isUri(fe)&&fe.scheme===R.Schemas.vscodeRemote&&!fe.authority&&Nt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await(l.URI.isUri(fe)?Promise.resolve(Ji.openTextDocument(fe)):Promise.resolve(fe));return Ht.showTextDocument(dt,Ee,We)},createTextEditorDecorationType(fe){return Ht.createTextEditorDecorationType(ze,fe)},onDidChangeActiveTextEditor(fe,Ee,We){return ct(Ht.onDidChangeActiveTextEditor)(fe,Ee,We)},onDidChangeVisibleTextEditors(fe,Ee,We){return ct(Ht.onDidChangeVisibleTextEditors)(fe,Ee,We)},onDidChangeTextEditorSelection(fe,Ee,We){return ct(Ht.onDidChangeTextEditorSelection)(fe,Ee,We)},onDidChangeTextEditorOptions(fe,Ee,We){return ct(Ht.onDidChangeTextEditorOptions)(fe,Ee,We)},onDidChangeTextEditorVisibleRanges(fe,Ee,We){return ct(Ht.onDidChangeTextEditorVisibleRanges)(fe,Ee,We)},onDidChangeTextEditorViewColumn(fe,Ee,We){return ct(Ht.onDidChangeTextEditorViewColumn)(fe,Ee,We)},onDidCloseTerminal(fe,Ee,We){return ct(It.onDidCloseTerminal)(fe,Ee,We)},onDidOpenTerminal(fe,Ee,We){return ct(It.onDidOpenTerminal)(fe,Ee,We)},onDidChangeActiveTerminal(fe,Ee,We){return ct(It.onDidChangeActiveTerminal)(fe,Ee,We)},onDidChangeTerminalDimensions(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"terminalDimensions"),ct(It.onDidChangeTerminalDimensions)(fe,Ee,We)},onDidChangeTerminalState(fe,Ee,We){return ct(It.onDidChangeTerminalState)(fe,Ee,We)},onDidWriteTerminalData(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),ct(It.onDidWriteTerminalData)(fe,Ee,We)},onDidExecuteTerminalCommand(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"terminalExecuteCommandEvent"),ct(It.onDidExecuteTerminalCommand)(fe,Ee,We)},onDidChangeTerminalShellIntegration(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"terminalShellIntegration"),ct(jt.onDidChangeTerminalShellIntegration)(fe,Ee,We)},onDidStartTerminalShellExecution(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"terminalShellIntegration"),ct(jt.onDidStartTerminalShellExecution)(fe,Ee,We)},onDidEndTerminalShellExecution(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"terminalShellIntegration"),ct(jt.onDidEndTerminalShellExecution)(fe,Ee,We)},get state(){return qt.getState()},onDidChangeWindowState(fe,Ee,We){return ct(qt.onDidChangeWindowState)(fe,Ee,We)},showInformationMessage(fe,...Ee){return Gi.showMessage(ze,v.default.Info,fe,Ee[0],Ee.slice(1))},showWarningMessage(fe,...Ee){return Gi.showMessage(ze,v.default.Warning,fe,Ee[0],Ee.slice(1))},showErrorMessage(fe,...Ee){return Gi.showMessage(ze,v.default.Error,fe,Ee[0],Ee.slice(1))},showQuickPick(fe,Ee,We){return Ge.showQuickPick(ze,fe,Ee,We)},showWorkspaceFolderPick(fe){return Ge.showWorkspaceFolderPick(fe)},showInputBox(fe,Ee){return Ge.showInput(fe,Ee)},showOpenDialog(fe){return Xi.showOpenDialog(ze,fe)},showSaveDialog(fe){return Xi.showSaveDialog(fe)},createStatusBarItem(fe,Ee,We){let dt,wt,Ot;return typeof fe=="string"?(dt=fe,wt=Ee,Ot=We):(wt=fe,Ot=Ee),ln.createStatusBarEntry(ze,dt,wt,Ot)},setStatusBarMessage(fe,Ee){return ln.setStatusBarMessage(fe,Ee)},withScmProgress(fe){return Nt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ut.withProgress(ze,{location:ce.ProgressLocation.SourceControl},(Ee,We)=>fe({report(dt){}}))},withProgress(fe,Ee){return Ut.withProgress(ze,fe,Ee)},createOutputChannel(fe,Ee){return Ci.createOutputChannel(fe,Ee,ze)},createWebviewPanel(fe,Ee,We,dt){return Mi.createWebviewPanel(ze,fe,Ee,We,dt)},createWebviewTextEditorInset(fe,Ee,We,dt){return(0,it.checkProposedApiEnabled)(ze,"editorInsets"),Me.createWebviewEditorInset(fe,Ee,We,dt,ze)},createTerminal(fe,Ee,We){return typeof fe=="object"?"pty"in fe?It.createExtensionTerminal(fe):It.createTerminalFromOptions(fe):It.createTerminal(fe,Ee,We)},registerTerminalLinkProvider(fe){return It.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,Ee){return It.registerProfileProvider(ze,fe,Ee)},registerTerminalQuickFixProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(fe,ze.identifier.value,Ee)},registerTreeDataProvider(fe,Ee){return Re.registerTreeDataProvider(fe,Ee,ze)},createTreeView(fe,Ee){return Re.createTreeView(fe,Ee,ze)},registerWebviewPanelSerializer:(fe,Ee)=>Mi.registerWebviewPanelSerializer(ze,fe,Ee),registerCustomEditorProvider:(fe,Ee,We={})=>Vi.registerCustomEditorProvider(ze,fe,Ee,We),registerFileDecorationProvider(fe){return Xt.registerFileDecorationProvider(fe,ze)},registerUriHandler(fe){return ki.registerUriHandler(ze,fe)},createQuickPick(){return Ge.createQuickPick(ze)},createInputBox(){return Ge.createInputBox(ze)},get activeColorTheme(){return $i.activeColorTheme},onDidChangeActiveColorTheme(fe,Ee,We){return ct($i.onDidChangeActiveColorTheme)(fe,Ee,We)},registerWebviewViewProvider(fe,Ee,We){return qi.registerWebviewViewProvider(ze,fe,Ee,We?.webviewOptions)},get activeNotebookEditor(){return At.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,Ee,We){return ct(At.onDidChangeActiveNotebookEditor)(fe,Ee,We)},get visibleNotebookEditors(){return At.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ct(At.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,Ee,We){return ct(Ii.onDidChangeNotebookEditorSelection)(fe,Ee,We)},onDidChangeNotebookEditorVisibleRanges(fe,Ee,We){return ct(Ii.onDidChangeNotebookEditorVisibleRanges)(fe,Ee,We)},showNotebookDocument(fe,Ee){return At.showNotebookDocument(fe,Ee)},registerExternalUriOpener(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"externalUriOpener"),sn.registerExternalUriOpener(ze.identifier,fe,Ee,We)},registerProfileContentHandler(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"profileContentHandlers"),on.registerProfileContentHandler(ze,fe,Ee)},registerQuickDiffProvider(fe,Ee,We,dt){return(0,it.checkProposedApiEnabled)(ze,"quickDiffProvider"),kt.registerQuickDiffProvider(Ct(fe),Ee,We,dt)},get tabGroups(){return Gt.tabGroups},registerShareProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"shareProvider"),Qt.registerShareProvider(Ct(fe),Ee)}},Ji={get rootPath(){return Nt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),vt.getPath()},set rootPath(fe){throw new P.ReadonlyError("rootPath")},getWorkspaceFolder(fe){return vt.getWorkspaceFolder(fe)},get workspaceFolders(){return vt.getWorkspaceFolders()},get name(){return vt.name},set name(fe){throw new P.ReadonlyError("name")},get workspaceFile(){return vt.workspaceFile},set workspaceFile(fe){throw new P.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(fe,Ee,...We)=>vt.updateWorkspaceFolders(ze,fe,Ee||0,...We),onDidChangeWorkspaceFolders:function(fe,Ee,We){return ct(vt.onDidChangeWorkspace)(fe,Ee,We)},asRelativePath:(fe,Ee)=>vt.getRelativePath(fe,Ee),findFiles:(fe,Ee,We,dt)=>vt.findFiles(fe,Ee,We,ze.identifier,dt),findFiles2:(fe,Ee,We)=>((0,it.checkProposedApiEnabled)(ze,"findFiles2"),vt.findFiles2(fe,Ee,ze.identifier,We)),findFiles2New:(fe,Ee,We)=>{(0,it.checkProposedApiEnabled)(ze,"findFiles2New");const dt={exclude:Ee?.exclude&&Ee.exclude.length>0?Ee.exclude[0]:void 0,useDefaultExcludes:!Ee?.useExcludeSettings||Ee?.useExcludeSettings===Pt.ExcludeSettingOptions.filesExclude||Ee?.useExcludeSettings===Pt.ExcludeSettingOptions.searchAndFilesExclude,useDefaultSearchExcludes:!Ee?.useExcludeSettings||Ee?.useExcludeSettings===Pt.ExcludeSettingOptions.searchAndFilesExclude,maxResults:Ee?.maxResults,useIgnoreFiles:Ee?.useIgnoreFiles?.local,useGlobalIgnoreFiles:Ee?.useIgnoreFiles?.global,useParentIgnoreFiles:Ee?.useIgnoreFiles?.parent,followSymlinks:Ee?.followSymlinks};return vt.findFiles2(fe&&fe.length>0?fe[0]:void 0,dt,ze.identifier,We)},findTextInFiles:(fe,Ee,We,dt)=>{(0,it.checkProposedApiEnabled)(ze,"findTextInFiles");let wt,Ot;return typeof Ee=="object"?(wt=Ee,Ot=We):(wt={},Ot=Ee,dt=We),vt.findTextInFiles(fe,wt||{},Ot,ze.identifier,dt)},findTextInFilesNew:(fe,Ee,We)=>{(0,it.checkProposedApiEnabled)(ze,"findTextInFilesNew"),(0,it.checkProposedApiEnabled)(ze,"textSearchProviderNew");let dt={};Ee&&(dt={include:Ee.include&&Ee.include.length>0?Ee.include[0]:void 0,exclude:Ee.exclude&&Ee.exclude.length>0?Ee.exclude[0]:void 0,useDefaultExcludes:Ee.useExcludeSettings===void 0||Ee.useExcludeSettings===Pt.ExcludeSettingOptions.filesExclude||Ee.useExcludeSettings===Pt.ExcludeSettingOptions.searchAndFilesExclude,useSearchExclude:Ee.useExcludeSettings===void 0||Ee.useExcludeSettings===Pt.ExcludeSettingOptions.searchAndFilesExclude,maxResults:Ee.maxResults,useIgnoreFiles:Ee.useIgnoreFiles?.local,useGlobalIgnoreFiles:Ee.useIgnoreFiles?.global,useParentIgnoreFiles:Ee.useIgnoreFiles?.parent,followSymlinks:Ee.followSymlinks,encoding:Ee.encoding,previewOptions:Ee.previewOptions?{matchLines:Ee.previewOptions?.matchLines??100,charsPerLine:Ee.previewOptions?.charsPerLine??1e4}:void 0,beforeContext:Ee.surroundingContext,afterContext:Ee.surroundingContext});const wt=Promise.resolve(void 0);return{results:new r.AsyncIterableObject(async gi=>{const Fi=async en=>(gi.emitOne((0,Pt.oldToNewTextSearchResult)(en)),en);await wt.then(en=>vt.findTextInFiles(fe,dt,Fi,ze.identifier,We))}),complete:wt.then(gi=>({limitHit:gi?.limitHit??!1}))}},save:fe=>vt.save(fe),saveAs:fe=>vt.saveAs(fe),saveAll:fe=>vt.saveAll(fe),applyEdit(fe,Ee){return Dn.applyWorkspaceEdit(fe,ze,Ee)},createFileSystemWatcher:(fe,Ee,We,dt)=>{let wt;return typeof Ee=="boolean"?wt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!dt,correlate:!1}:Ee&&((0,it.checkProposedApiEnabled)(ze,"createFileSystemWatcher"),wt={...Ee,correlate:!0}),Ze.createFileSystemWatcher(vt,ze,fe,wt)},get textDocuments(){return Lt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new P.ReadonlyError("textDocuments")},openTextDocument(fe){let Ee;const We=fe;if(typeof fe=="string")Ee=Promise.resolve(l.URI.file(fe));else if(l.URI.isUri(fe))Ee=Promise.resolve(fe);else if(!We||typeof We=="object")Ee=Lt.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(dt=>(dt.scheme===R.Schemas.vscodeRemote&&!dt.authority&&Nt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),Lt.ensureDocumentData(dt).then(wt=>wt.document)))},onDidOpenTextDocument:(fe,Ee,We)=>ct(Lt.onDidAddDocument)(fe,Ee,We),onDidCloseTextDocument:(fe,Ee,We)=>ct(Lt.onDidRemoveDocument)(fe,Ee,We),onDidChangeTextDocument:(fe,Ee,We)=>ct(Lt.onDidChangeDocument)(fe,Ee,We),onDidSaveTextDocument:(fe,Ee,We)=>ct(Lt.onDidSaveDocument)(fe,Ee,We),onWillSaveTextDocument:(fe,Ee,We)=>ct(ui.getOnWillSaveTextDocumentEvent(ze))(fe,Ee,We),get notebookDocuments(){return At.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,Ee){let We;if(l.URI.isUri(fe))We=fe,await At.openNotebookDocument(fe);else if(typeof fe=="string")We=l.URI.revive(await At.createNotebookDocument({viewType:fe,content:Ee}));else throw new Error("Invalid arguments");return At.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(fe,Ee,We){return ct(Ri.onDidSaveNotebookDocument)(fe,Ee,We)},onDidChangeNotebookDocument(fe,Ee,We){return ct(Ri.onDidChangeNotebookDocument)(fe,Ee,We)},onWillSaveNotebookDocument(fe,Ee,We){return ct(bi.getOnWillSaveNotebookDocumentEvent(ze))(fe,Ee,We)},get onDidOpenNotebookDocument(){return ct(At.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ct(At.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,Ee,We,dt){return At.registerNotebookSerializer(ze,fe,Ee,We,(0,it.isProposedApiEnabled)(ze,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(fe,Ee,We)=>ct(Qi.onDidChangeConfiguration)(fe,Ee,We),getConfiguration(fe,Ee){return Ee=arguments.length===1?void 0:Ee,Qi.getConfiguration(fe,Ee,ze)},registerTextDocumentContentProvider(fe,Ee){return Oi.registerTextDocumentContentProvider(fe,Ee)},registerTaskProvider:(fe,Ee)=>(Nt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(ze,fe,Ee)),registerFileSystemProvider(fe,Ee,We){return(0,L.combinedDisposable)(qe.registerFileSystemProvider(ze,fe,Ee,We),ii.addFileSystemProvider(fe,Ee,We))},get fs(){return ii.value},registerFileSearchProvider:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"fileSearchProvider"),mi.registerFileSearchProvider(fe,Ee)),registerTextSearchProvider:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"textSearchProvider"),mi.registerTextSearchProvider(fe,Ee)),registerAITextSearchProvider:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"aiTextSearchProvider"),(0,it.checkProposedApiEnabled)(ze,"textSearchProvider"),mi.registerAITextSearchProvider(fe,Ee)),registerFileSearchProviderNew:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"aiTextSearchProviderNew"),(0,it.checkProposedApiEnabled)(ze,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"resolvers"),zt.registerRemoteAuthorityResolver(fe,Ee)),registerResourceLabelFormatter:fe=>((0,it.checkProposedApiEnabled)(ze,"resolvers"),Zt.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,it.checkProposedApiEnabled)(ze,"resolvers"),zt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,Ee,We)=>ct(Ze.onDidCreateFile)(fe,Ee,We),onDidDeleteFiles:(fe,Ee,We)=>ct(Ze.onDidDeleteFile)(fe,Ee,We),onDidRenameFiles:(fe,Ee,We)=>ct(Ze.onDidRenameFile)(fe,Ee,We),onWillCreateFiles:(fe,Ee,We)=>ct(Ze.getOnWillCreateFileEvent(ze))(fe,Ee,We),onWillDeleteFiles:(fe,Ee,We)=>ct(Ze.getOnWillDeleteFileEvent(ze))(fe,Ee,We),onWillRenameFiles:(fe,Ee,We)=>ct(Ze.getOnWillRenameFileEvent(ze))(fe,Ee,We),openTunnel:fe=>((0,it.checkProposedApiEnabled)(ze,"tunnels"),xt.openTunnel(ze,fe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,it.checkProposedApiEnabled)(ze,"tunnels"),xt.getTunnels()},onDidChangeTunnels:(fe,Ee,We)=>((0,it.checkProposedApiEnabled)(ze,"tunnels"),ct(xt.onDidChangeTunnels)(fe,Ee,We)),registerPortAttributesProvider:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"portsAttributes"),xt.registerPortsAttributesProvider(fe,Ee)),registerTunnelProvider:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"tunnelFactory"),xt.registerTunnelProvider(fe,Ee)),registerTimelineProvider:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"timeline"),rn.registerTimelineProvider(fe,Ee,ze.identifier,bt.converter)),get isTrusted(){return vt.trusted},requestWorkspaceTrust:fe=>((0,it.checkProposedApiEnabled)(ze,"workspaceTrust"),vt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,Ee,We)=>ct(vt.onDidGrantWorkspaceTrust)(fe,Ee,We),registerEditSessionIdentityProvider:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),vt.registerEditSessionIdentityProvider(fe,Ee)),onWillCreateEditSessionIdentity:(fe,Ee,We)=>((0,it.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),ct(vt.getOnWillCreateEditSessionIdentityEvent(ze))(fe,Ee,We)),registerCanonicalUriProvider:(fe,Ee)=>((0,it.checkProposedApiEnabled)(ze,"canonicalUriProvider"),vt.registerCanonicalUriProvider(fe,Ee)),getCanonicalUri:(fe,Ee,We)=>((0,it.checkProposedApiEnabled)(ze,"canonicalUriProvider"),vt.provideCanonicalUri(fe,Ee,We))},hn={get inputBox(){return Nt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox(ze)},createSourceControl(fe,Ee,We){return ft.createSourceControl(ze,fe,Ee,We)}},fn={createCommentController(fe,Ee){return si.createCommentController(ze,fe,Ee)}},Cn={get activeDebugSession(){return Tt.activeDebugSession},get activeDebugConsole(){return Tt.activeDebugConsole},get breakpoints(){return Tt.breakpoints},get activeStackItem(){return Tt.activeStackItem},registerDebugVisualizationProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"debugVisualization"),Tt.registerDebugVisualizationProvider(ze,fe,Ee)},registerDebugVisualizationTreeProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"debugVisualization"),Tt.registerDebugVisualizationTree(ze,fe,Ee)},onDidStartDebugSession(fe,Ee,We){return ct(Tt.onDidStartDebugSession)(fe,Ee,We)},onDidTerminateDebugSession(fe,Ee,We){return ct(Tt.onDidTerminateDebugSession)(fe,Ee,We)},onDidChangeActiveDebugSession(fe,Ee,We){return ct(Tt.onDidChangeActiveDebugSession)(fe,Ee,We)},onDidReceiveDebugSessionCustomEvent(fe,Ee,We){return ct(Tt.onDidReceiveDebugSessionCustomEvent)(fe,Ee,We)},onDidChangeBreakpoints(fe,Ee,We){return ct(Tt.onDidChangeBreakpoints)(fe,Ee,We)},onDidChangeActiveStackItem(fe,Ee,We){return ct(Tt.onDidChangeActiveStackItem)(fe,Ee,We)},registerDebugConfigurationProvider(fe,Ee,We){return Tt.registerDebugConfigurationProvider(fe,Ee,We||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,Ee){return Tt.registerDebugAdapterDescriptorFactory(ze,fe,Ee)},registerDebugAdapterTrackerFactory(fe,Ee){return Tt.registerDebugAdapterTrackerFactory(fe,Ee)},startDebugging(fe,Ee,We){return!We||typeof We=="object"&&"configuration"in We?Tt.startDebugging(fe,Ee,{parentSession:We}):Tt.startDebugging(fe,Ee,We||{})},stopDebugging(fe){return Tt.stopDebugging(fe)},addBreakpoints(fe){return Tt.addBreakpoints(fe)},removeBreakpoints(fe){return Tt.removeBreakpoints(fe)},asDebugSourceUri(fe,Ee){return Tt.asDebugSourceUri(fe,Ee)}},gn={registerTaskProvider:(fe,Ee)=>Jt.registerTaskProvider(ze,fe,Ee),fetchTasks:fe=>Jt.fetchTasks(fe),executeTask:fe=>Jt.executeTask(ze,fe),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(fe,Ee,We)=>ct(Jt.onDidStartTask)(fe,Ee,We),onDidEndTask:(fe,Ee,We)=>ct(Jt.onDidEndTask)(fe,Ee,We),onDidStartTaskProcess:(fe,Ee,We)=>ct(Jt.onDidStartTaskProcess)(fe,Ee,We),onDidEndTaskProcess:(fe,Ee,We)=>ct(Jt.onDidEndTaskProcess)(fe,Ee,We)},mn={createNotebookController(fe,Ee,We,dt,wt){return yi.createNotebookController(ze,fe,Ee,We,dt,(0,it.isProposedApiEnabled)(ze,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(fe,Ee)=>At.registerNotebookCellStatusBarItemProvider(ze,fe,Ee),createRendererMessaging(fe){return Ni.createRendererMessaging(ze,fe)},createNotebookControllerDetectionTask(fe){return(0,it.checkProposedApiEnabled)(ze,"notebookKernelSource"),yi.createNotebookControllerDetectionTask(ze,fe)},registerKernelSourceActionProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"notebookKernelSource"),yi.registerKernelSourceActionProvider(ze,fe,Ee)},onDidChangeNotebookCellExecutionState(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),ct(yi.onDidChangeNotebookCellExecutionState)(fe,Ee,We)}},In={t(...fe){if(typeof fe[0]=="string"){const Ee=fe.shift(),We=!fe||typeof fe[0]!="object"?fe:fe[0];return Ei.getMessage(ze.identifier.value,{message:Ee,args:We})}return Ei.getMessage(ze.identifier.value,fe[0])},get bundle(){return Ei.getBundle(ze.identifier.value)},get uri(){return Ei.getBundleUri(ze.identifier.value)}},Tn={_version:1,transferActiveChat(fe){return(0,it.checkProposedApiEnabled)(ze,"interactive"),xi.transferActiveChat(fe)}},pn={getRelatedInformation(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"aiRelatedInformation"),ji.getRelatedInformation(ze,fe,Ee)},registerRelatedInformationProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"aiRelatedInformation"),ji.registerRelatedInformationProvider(ze,fe,Ee)},registerEmbeddingVectorProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"aiRelatedInformation"),_n.registerEmbeddingVectorProvider(ze,fe,Ee)}},Zi={_version:1,registerChatResponseProvider(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"chatProvider"),Kt.registerLanguageModel(ze,fe,Ee,We)},registerChatVariableResolver(fe,Ee,We,dt,wt,Ot,gi,Fi){return(0,it.checkProposedApiEnabled)(ze,"chatVariableResolver"),an.registerVariableResolver(ze,fe,Ee,We,dt,wt,Ot,gi,Fi?.id)},registerMappedEditsProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"mappedEditsProvider"),Ae.registerMappedEditsProvider(ze,fe,Ee)},createChatParticipant(fe,Ee){return xi.createChatAgent(ze,fe,Ee)},createDynamicChatParticipant(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"chatParticipantPrivate"),xi.createDynamicChatAgent(ze,fe,Ee,We)}},vn={selectChatModels:fe=>Kt.selectLanguageModels(ze,fe??{}),onDidChangeChatModels:(fe,Ee,We)=>Kt.onDidChangeProviders(fe,Ee,We),registerChatModelProvider:(fe,Ee,We)=>((0,it.checkProposedApiEnabled)(ze,"chatProvider"),Kt.registerLanguageModel(ze,fe,Ee,We)),get embeddingModels(){return(0,it.checkProposedApiEnabled)(ze,"embeddings"),Pi.embeddingsModels},onDidChangeEmbeddingModels:(fe,Ee,We)=>((0,it.checkProposedApiEnabled)(ze,"embeddings"),Pi.onDidChange(fe,Ee,We)),registerEmbeddingsProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"embeddings"),Pi.registerEmbeddingsProvider(ze,fe,Ee)},async computeEmbeddings(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"embeddings"),Pi.computeEmbeddings(fe,Ee,We)},registerTool(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"lmTools"),Ui.registerTool(ze,fe,Ee)},invokeTool(fe,Ee,We){return(0,it.checkProposedApiEnabled)(ze,"lmTools"),Ui.invokeTool(fe,Ee,We)},get tools(){return(0,it.checkProposedApiEnabled)(ze,"lmTools"),Ui.tools}},En={registerSpeechProvider(fe,Ee){return(0,it.checkProposedApiEnabled)(ze,"speech"),Ki.registerProvider(ze.identifier,fe,Ee)}};return{version:yt.version,ai:pn,authentication:Yi,commands:un,comments:fn,chat:Zi,debug:Cn,env:wi,extensions:pi,interactive:Tn,l10n:In,languages:zi,lm:vn,notebooks:mn,scm:hn,speech:En,tasks:gn,tests:Bi,window:dn,workspace:Ji,Breakpoint:ce.Breakpoint,TerminalOutputAnchor:ce.TerminalOutputAnchor,ChatResultFeedbackKind:ce.ChatResultFeedbackKind,ChatVariableLevel:ce.ChatVariableLevel,ChatCompletionItem:ce.ChatCompletionItem,CallHierarchyIncomingCall:ce.CallHierarchyIncomingCall,CallHierarchyItem:ce.CallHierarchyItem,CallHierarchyOutgoingCall:ce.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:s.CandidatePortSource,CodeAction:ce.CodeAction,CodeActionKind:ce.CodeActionKind,CodeActionTriggerKind:ce.CodeActionTriggerKind,CodeLens:ce.CodeLens,Color:ce.Color,ColorInformation:ce.ColorInformation,ColorPresentation:ce.ColorPresentation,ColorThemeKind:ce.ColorThemeKind,CommentMode:ce.CommentMode,CommentState:ce.CommentState,CommentThreadCollapsibleState:ce.CommentThreadCollapsibleState,CommentThreadState:ce.CommentThreadState,CommentThreadApplicability:ce.CommentThreadApplicability,CommentThreadFocus:ce.CommentThreadFocus,CompletionItem:ce.CompletionItem,CompletionItemKind:ce.CompletionItemKind,CompletionItemTag:ce.CompletionItemTag,CompletionList:ce.CompletionList,CompletionTriggerKind:ce.CompletionTriggerKind,ConfigurationTarget:ce.ConfigurationTarget,CustomExecution:ce.CustomExecution,DebugAdapterExecutable:ce.DebugAdapterExecutable,DebugAdapterInlineImplementation:ce.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:ce.DebugAdapterNamedPipeServer,DebugAdapterServer:ce.DebugAdapterServer,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ce.DebugConsoleMode,DebugVisualization:ce.DebugVisualization,DecorationRangeBehavior:ce.DecorationRangeBehavior,Diagnostic:ce.Diagnostic,DiagnosticRelatedInformation:ce.DiagnosticRelatedInformation,DiagnosticSeverity:ce.DiagnosticSeverity,DiagnosticTag:ce.DiagnosticTag,Disposable:ce.Disposable,DocumentHighlight:ce.DocumentHighlight,DocumentHighlightKind:ce.DocumentHighlightKind,MultiDocumentHighlight:ce.MultiDocumentHighlight,DocumentLink:ce.DocumentLink,DocumentSymbol:ce.DocumentSymbol,EndOfLine:ce.EndOfLine,EnvironmentVariableMutatorType:ce.EnvironmentVariableMutatorType,EvaluatableExpression:ce.EvaluatableExpression,InlineValueText:ce.InlineValueText,InlineValueVariableLookup:ce.InlineValueVariableLookup,InlineValueEvaluatableExpression:ce.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:ce.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:ce.ExtensionKind,ExtensionMode:ce.ExtensionMode,ExternalUriOpenerPriority:ce.ExternalUriOpenerPriority,FileChangeType:ce.FileChangeType,FileDecoration:ce.FileDecoration,FileDecoration2:ce.FileDecoration,FileSystemError:ce.FileSystemError,FileType:a.FileType,FilePermission:a.FilePermission,FoldingRange:ce.FoldingRange,FoldingRangeKind:ce.FoldingRangeKind,FunctionBreakpoint:ce.FunctionBreakpoint,InlineCompletionItem:ce.InlineSuggestion,InlineCompletionList:ce.InlineSuggestionList,Hover:ce.Hover,VerboseHover:ce.VerboseHover,HoverVerbosityAction:ce.HoverVerbosityAction,IndentAction:u.IndentAction,Location:ce.Location,MarkdownString:ce.MarkdownString,OverviewRulerLane:T.OverviewRulerLane,ParameterInformation:ce.ParameterInformation,PortAutoForwardAction:ce.PortAutoForwardAction,Position:ce.Position,ProcessExecution:ce.ProcessExecution,ProgressLocation:ce.ProgressLocation,QuickInputButtonLocation:ce.QuickInputButtonLocation,QuickInputButtons:ce.QuickInputButtons,Range:ce.Range,RelativePattern:ce.RelativePattern,Selection:ce.Selection,SelectionRange:ce.SelectionRange,SemanticTokens:ce.SemanticTokens,SemanticTokensBuilder:ce.SemanticTokensBuilder,SemanticTokensEdit:ce.SemanticTokensEdit,SemanticTokensEdits:ce.SemanticTokensEdits,SemanticTokensLegend:ce.SemanticTokensLegend,ShellExecution:ce.ShellExecution,ShellQuoting:ce.ShellQuoting,SignatureHelp:ce.SignatureHelp,SignatureHelpTriggerKind:ce.SignatureHelpTriggerKind,SignatureInformation:ce.SignatureInformation,SnippetString:ce.SnippetString,SourceBreakpoint:ce.SourceBreakpoint,StandardTokenType:ce.StandardTokenType,StatusBarAlignment:ce.StatusBarAlignment,SymbolInformation:ce.SymbolInformation,SymbolKind:ce.SymbolKind,SymbolTag:ce.SymbolTag,Task:ce.Task,TaskGroup:ce.TaskGroup,TaskPanelKind:ce.TaskPanelKind,TaskRevealKind:ce.TaskRevealKind,TaskScope:ce.TaskScope,TerminalLink:ce.TerminalLink,TerminalQuickFixTerminalCommand:ce.TerminalQuickFixCommand,TerminalQuickFixOpener:ce.TerminalQuickFixOpener,TerminalLocation:ce.TerminalLocation,TerminalProfile:ce.TerminalProfile,TerminalExitReason:ce.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:ce.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:ce.TextDocumentSaveReason,TextEdit:ce.TextEdit,SnippetTextEdit:ce.SnippetTextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:ce.TextEditorLineNumbersStyle,TextEditorRevealType:ce.TextEditorRevealType,TextEditorSelectionChangeKind:ce.TextEditorSelectionChangeKind,SyntaxTokenType:ce.SyntaxTokenType,TextDocumentChangeReason:ce.TextDocumentChangeReason,ThemeColor:ce.ThemeColor,ThemeIcon:ce.ThemeIcon,TreeItem:ce.TreeItem,TreeItemCheckboxState:ce.TreeItemCheckboxState,TreeItemCollapsibleState:ce.TreeItemCollapsibleState,TypeHierarchyItem:ce.TypeHierarchyItem,UIKind:Rt.UIKind,Uri:l.URI,ViewColumn:ce.ViewColumn,WorkspaceEdit:ce.WorkspaceEdit,DocumentPasteTriggerKind:ce.DocumentPasteTriggerKind,DocumentDropEdit:ce.DocumentDropEdit,DocumentDropOrPasteEditKind:ce.DocumentDropOrPasteEditKind,DocumentPasteEdit:ce.DocumentPasteEdit,InlayHint:ce.InlayHint,InlayHintLabelPart:ce.InlayHintLabelPart,InlayHintKind:ce.InlayHintKind,RemoteAuthorityResolverError:ce.RemoteAuthorityResolverError,ResolvedAuthority:ce.ResolvedAuthority,ManagedResolvedAuthority:ce.ManagedResolvedAuthority,SourceControlInputBoxValidationType:ce.SourceControlInputBoxValidationType,ExtensionRuntime:ce.ExtensionRuntime,TimelineItem:ce.TimelineItem,NotebookRange:ce.NotebookRange,NotebookCellKind:ce.NotebookCellKind,NotebookCellExecutionState:ce.NotebookCellExecutionState,NotebookCellData:ce.NotebookCellData,NotebookData:ce.NotebookData,NotebookRendererScript:ce.NotebookRendererScript,NotebookCellStatusBarAlignment:ce.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ce.NotebookEditorRevealType,NotebookCellOutput:ce.NotebookCellOutput,NotebookCellOutputItem:ce.NotebookCellOutputItem,NotebookCellStatusBarItem:ce.NotebookCellStatusBarItem,NotebookControllerAffinity:ce.NotebookControllerAffinity,NotebookControllerAffinity2:ce.NotebookControllerAffinity2,NotebookEdit:ce.NotebookEdit,NotebookKernelSourceAction:ce.NotebookKernelSourceAction,NotebookVariablesRequestKind:ce.NotebookVariablesRequestKind,PortAttributes:ce.PortAttributes,LinkedEditingRanges:ce.LinkedEditingRanges,TestResultState:ce.TestResultState,TestRunRequest:ce.TestRunRequest,TestMessage:ce.TestMessage,TestMessage2:ce.TestMessage,TestMessageStackFrame:ce.TestMessageStackFrame,TestTag:ce.TestTag,TestRunProfileKind:ce.TestRunProfileKind,TextSearchCompleteMessageType:Pt.TextSearchCompleteMessageType,DataTransfer:ce.DataTransfer,DataTransferItem:ce.DataTransferItem,TestCoverageCount:ce.TestCoverageCount,FileCoverage:ce.FileCoverage,FileCoverage2:ce.FileCoverage,StatementCoverage:ce.StatementCoverage,BranchCoverage:ce.BranchCoverage,DeclarationCoverage:ce.DeclarationCoverage,WorkspaceTrustState:ce.WorkspaceTrustState,LanguageStatusSeverity:ce.LanguageStatusSeverity,QuickPickItemKind:ce.QuickPickItemKind,InputBoxValidationSeverity:ce.InputBoxValidationSeverity,TabInputText:ce.TextTabInput,TabInputTextDiff:ce.TextDiffTabInput,TabInputTextMerge:ce.TextMergeTabInput,TabInputCustom:ce.CustomEditorTabInput,TabInputNotebook:ce.NotebookEditorTabInput,TabInputNotebookDiff:ce.NotebookDiffEditorTabInput,TabInputWebview:ce.WebviewEditorTabInput,TabInputTerminal:ce.TerminalEditorTabInput,TabInputInteractiveWindow:ce.InteractiveWindowInput,TabInputChat:ce.ChatEditorTabInput,TabInputTextMultiDiff:ce.TextMultiDiffTabInput,TelemetryTrustedValue:f.TelemetryTrustedValue,LogLevel:m.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ce.InteractiveSessionVoteDirection,ChatCopyKind:ce.ChatCopyKind,InteractiveEditorResponseFeedbackKind:ce.InteractiveEditorResponseFeedbackKind,DebugStackFrame:ce.DebugStackFrame,DebugThread:ce.DebugThread,RelatedInformationType:ce.RelatedInformationType,SpeechToTextStatus:ce.SpeechToTextStatus,TextToSpeechStatus:ce.TextToSpeechStatus,PartialAcceptTriggerKind:ce.PartialAcceptTriggerKind,KeywordRecognitionStatus:ce.KeywordRecognitionStatus,ChatResponseMarkdownPart:ce.ChatResponseMarkdownPart,ChatResponseFileTreePart:ce.ChatResponseFileTreePart,ChatResponseAnchorPart:ce.ChatResponseAnchorPart,ChatResponseProgressPart:ce.ChatResponseProgressPart,ChatResponseProgressPart2:ce.ChatResponseProgressPart2,ChatResponseReferencePart:ce.ChatResponseReferencePart,ChatResponseReferencePart2:ce.ChatResponseReferencePart,ChatResponseCodeCitationPart:ce.ChatResponseCodeCitationPart,ChatResponseWarningPart:ce.ChatResponseWarningPart,ChatResponseTextEditPart:ce.ChatResponseTextEditPart,ChatResponseMarkdownWithVulnerabilitiesPart:ce.ChatResponseMarkdownWithVulnerabilitiesPart,ChatResponseCommandButtonPart:ce.ChatResponseCommandButtonPart,ChatResponseDetectedParticipantPart:ce.ChatResponseDetectedParticipantPart,ChatResponseConfirmationPart:ce.ChatResponseConfirmationPart,ChatResponseReferencePartStatusKind:ce.ChatResponseReferencePartStatusKind,ChatRequestTurn:ce.ChatRequestTurn,ChatResponseTurn:ce.ChatResponseTurn,ChatLocation:ce.ChatLocation,ChatRequestEditorData:ce.ChatRequestEditorData,ChatRequestNotebookData:ce.ChatRequestNotebookData,LanguageModelChatMessageRole:ce.LanguageModelChatMessageRole,LanguageModelChatMessage:ce.LanguageModelChatMessage,LanguageModelChatMessageFunctionResultPart:ce.LanguageModelFunctionResultPart,LanguageModelChatResponseTextPart:ce.LanguageModelTextPart,LanguageModelChatResponseFunctionUsePart:ce.LanguageModelFunctionUsePart,LanguageModelError:ce.LanguageModelError,NewSymbolName:ce.NewSymbolName,NewSymbolNameTag:ce.NewSymbolNameTag,NewSymbolNameTriggerKind:ce.NewSymbolNameTriggerKind,InlineEdit:ce.InlineEdit,InlineEditTriggerKind:ce.InlineEditTriggerKind,ExcludeSettingOptions:Pt.ExcludeSettingOptions,TextSearchContextNew:Pt.TextSearchContextNew,TextSearchMatchNew:Pt.TextSearchMatchNew,TextSearchCompleteMessageTypeNew:Pt.TextSearchCompleteMessageTypeNew}}}}),define(Ce[345],Ie([1,0,88,169,49,163,41,34,63,48,100,101,102,125,76,95,162,75,62,124,94,77,161,11,64,122,123,127,128,167,98]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n,h,c,g,w,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,r.InstantiationType.Delayed),(0,r.registerSingleton)(n.ILoggerService,o.ExtHostLoggerService,r.InstantiationType.Delayed),(0,r.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,r.InstantiationType.Delayed),(0,r.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,r.InstantiationType.Eager),(0,r.registerSingleton)(w.IExtHostAuthentication,w.ExtHostAuthentication,r.InstantiationType.Eager),(0,r.registerSingleton)(D.IExtHostLanguageModels,D.ExtHostLanguageModels,r.InstantiationType.Eager),(0,r.registerSingleton)(L.IExtHostConfiguration,L.ExtHostConfiguration,r.InstantiationType.Eager),(0,r.registerSingleton)(p.IExtHostConsumerFileSystem,p.ExtHostConsumerFileSystem,r.InstantiationType.Eager),(0,r.registerSingleton)(C.IExtHostTesting,C.ExtHostTesting,r.InstantiationType.Eager),(0,r.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService,r.InstantiationType.Eager),(0,r.registerSingleton)(k.IExtHostDecorations,k.ExtHostDecorations,r.InstantiationType.Eager),(0,r.registerSingleton)(v.IExtHostDocumentsAndEditors,v.ExtHostDocumentsAndEditors,r.InstantiationType.Eager),(0,r.registerSingleton)(g.IExtHostManagedSockets,g.ExtHostManagedSockets,r.InstantiationType.Eager),(0,r.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo,r.InstantiationType.Eager),(0,r.registerSingleton)(d.IExtHostOutputService,d.ExtHostOutputService,r.InstantiationType.Delayed),(0,r.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch,r.InstantiationType.Eager),(0,r.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,r.InstantiationType.Eager),(0,r.registerSingleton)(I.IExtHostTask,I.WorkerExtHostTask,r.InstantiationType.Eager),(0,r.registerSingleton)(l.IExtHostTerminalService,l.WorkerExtHostTerminalService,r.InstantiationType.Eager),(0,r.registerSingleton)(_.IExtHostTerminalShellIntegration,_.ExtHostTerminalShellIntegration,r.InstantiationType.Eager),(0,r.registerSingleton)(b.IExtHostTunnelService,b.ExtHostTunnelService,r.InstantiationType.Eager),(0,r.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow,r.InstantiationType.Eager),(0,r.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace,r.InstantiationType.Eager),(0,r.registerSingleton)(i.IExtHostSecretState,i.ExtHostSecretState,r.InstantiationType.Eager),(0,r.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry,r.InstantiationType.Eager),(0,r.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs,r.InstantiationType.Eager),(0,r.registerSingleton)(h.IExtHostVariableResolverProvider,h.ExtHostVariableResolverProviderService,r.InstantiationType.Eager)}),define(Ce[129],Ie([1,0,18,11,37,99]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=void 0,e.anchorGlob=L,e.createTextSearchResult=R,k=$e(k);function L(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}function R(y,u,T,b){const a=(0,r.mapArrayOrNot)(T,v),m=new P.TextSearchMatch(u,a,b),p=m.preview.matches;return{ranges:(0,r.mapArrayOrNot)(a,l),uri:y,preview:{text:m.preview.text,matches:(0,r.mapArrayOrNot)(p,l)}}}function v(y){return new P.SearchRange(y.start.line,y.start.character,y.end.line,y.end.character)}function l(y){return new k.Range(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let I=class{constructor(u,T){this.prefix=u,this.logService=T}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};e.OutputChannel=I,e.OutputChannel=I=Xe([He(1,d.ILogService)],I)}),define(Ce[346],Ie([1,0,56,16,81,31,10,12,129,347]),function(pe,e,r,d,P,k,L,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnRipgrepCmd=y,e.getAbsoluteGlob=m,e.fixDriveC=f,r=$e(r),d=$e(d),k=$e(k),R=$e(R);const I=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(i,s,t,o,n){const h=u(i,s,t,o,n),c=s.folder.fsPath;return{cmd:r.spawn(I,h.args,{cwd:c}),rgDiskPath:I,siblingClauses:h.siblingClauses,rgArgs:h,cwd:c}}function u(i,s,t,o,n){const h=["--files","--hidden","--case-sensitive","--no-require-git"];b([s],t,!1).forEach(g=>{const w=(0,v.anchorGlob)(g);if(h.push("-g",w),L.isMacintosh){const D=(0,P.normalizeNFD)(w);D!==w&&h.push("-g",D)}});const c=T([s],o,void 0,!1);return c.globArgs.forEach(g=>{const w=`!${(0,v.anchorGlob)(g)}`;if(h.push("-g",w),L.isMacintosh){const D=(0,P.normalizeNFD)(w);D!==w&&h.push("-g",D)}}),s.disregardIgnoreFiles!==!1?h.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&h.push("--no-ignore-parent"),s.ignoreSymlinks||h.push("--follow"),i.exists&&h.push("--quiet"),n&&h.push("--threads",`${n}`),h.push("--no-config"),s.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:c.siblingClauses}}function T(i,s,t,o=!0){const n=[];let h={};return i.forEach(c=>{const g=Object.assign({},c.excludePattern||{},s||{}),w=a(g,o?c.folder.fsPath:void 0,t);n.push(...w.globArgs),w.siblingClauses&&(h=Object.assign(h,w.siblingClauses))}),{globArgs:n,siblingClauses:h}}function b(i,s,t=!0){const o=[];return i.forEach(n=>{const h=Object.assign({},s||{},n.includePattern||{}),c=a(h,t?n.folder.fsPath:void 0);o.push(...c.globArgs)}),o}function a(i,s,t){const o=[],n={};return Object.keys(i).forEach(h=>{if(t&&t.has(h)||!h)return;const c=i[h];h=p(s?m(s,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof c=="boolean"&&c?(h.startsWith("\\\\")&&(h+="**"),o.push(f(h))):c&&c.when&&(n[h]=c)}),{globArgs:o,siblingClauses:n}}function m(i,s){return d.isAbsolute(s)?s:d.join(i,s)}function p(i){return i=R.rtrim(i,"\\"),R.rtrim(i,"/")}function f(i){return k.getRoot(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Ce[348],Ie([1,0,56,45,16,349,18,52,38,81,31,10,42,12,17,33,37,346,136]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0,r=$e(r),d=$e(d),P=$e(P),L=$e(L),v=$e(v),l=$e(l),y=$e(y),T=$e(T),b=$e(b);const i=new Set;process.on("exit",()=>{i.forEach(h=>h())});class s{constructor(c){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=c,this.filePattern=c.filePattern||"",this.includePattern=c.includePattern&&v.parse(c.includePattern),this.maxResults=c.maxResults||null,this.exists=!!c.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=c.shouldGlobMatchFilePattern?null:(0,f.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=c.excludePattern&&v.parse(c.excludePattern),this.folderExcludePatterns=new Map,c.folderQueries.forEach(g=>{const w=Object.assign({},g.excludePattern||{},this.config.excludePattern||{}),D=g.folder.fsPath;c.folderQueries.map(_=>_.folder.fsPath).filter(_=>_!==D).forEach(_=>{(0,I.isEqualOrParent)(_,D)&&(w[P.relative(D,_)]=!0)}),this.folderExcludePatterns.set(D,new o(w,D))})}cancel(){this.isCanceled=!0,i.forEach(c=>c())}walk(c,g,w,D,_,C){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return C(null,this.isLimitHit);g.forEach(A=>{const E=P.basename(A.fsPath);this.globalExcludePattern&&this.globalExcludePattern(A.fsPath,E)||this.matchFile(D,{relativePath:A.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(c,(A,E)=>{this.call(this.cmdTraversal,this,A,w,D,_,S=>{if(S){const F=(0,R.toErrorMessage)(S);console.error(F),this.errors.push(F),E(S,void 0)}else E(null,void 0)})},(A,E)=>{this.fileWalkSW.stop();const S=A?L.coalesce(A)[0]:null;C(S,this.isLimitHit)})}parallel(c,g,w){const D=new Array(c.length),_=new Array(c.length);let C=!1,A=0;if(c.length===0)return w(null,[]);c.forEach((E,S)=>{g(E,(F,N)=>{if(F?(C=!0,D[S]=null,_[S]=F):(D[S]=N,_[S]=null),++A===c.length)return w(C?_:null,D)})})}call(c,g,...w){try{c.apply(g,w)}catch(D){w[w.length-1](D)}}cmdTraversal(c,g,w,D,_){const C=c.folder.fsPath,A=y.isMacintosh,E=()=>M&&M.kill();i.add(E);let S=B=>{i.delete(E),S=()=>{},_(B)},F="";const N=this.initDirectoryTree(),O=(0,p.spawnRipgrepCmd)(this.config,c,this.config.includePattern,this.folderExcludePatterns.get(c.folder.fsPath).expression,g),M=O.cmd,U=!Object.keys(O.siblingClauses).length,x=O.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let z=`${O.rgDiskPath} ${x}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),D({message:z}),this.cmdResultCount=0,this.collectStdout(M,"utf8",D,(B,ee,V)=>{if(B){S(B);return}if(this.isLimitHit){S();return}const G=(F+(A?l.normalizeNFC(ee||""):ee)).split(`
`);if(V){const Z=G.length;G[Z-1]=G[Z-1].trim(),G[Z-1]||G.pop()}else F=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){S(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=G.length,U){for(const Z of G)if(this.matchFile(w,{base:C,relativePath:Z,searchPath:this.getSearchPath(c,Z)}),this.isLimitHit){E();break}(V||this.isLimitHit)&&S();return}this.addDirectoryEntries(c,N,C,G,w),V&&(this.matchDirectoryTree(N,C,w),S())})}spawnFindCmd(c){const g=this.folderExcludePatterns.get(c.folder.fsPath),w=g.getBasenameTerms(),D=g.getPathTerms(),_=["-L","."];if(w.length||D.length){_.push("-not","(","(");for(const C of w)_.push("-name",C),_.push("-o");for(const C of D)_.push("-path",C),_.push("-o");_.pop(),_.push(")","-prune",")")}return _.push("-type","f"),r.spawn("find",_,{cwd:c.folder.fsPath})}readStdout(c,g,w){let D="";this.collectStdout(c,g,()=>{},(_,C,A)=>{if(_){w(_);return}D+=C,A&&w(null,D)})}collectStdout(c,g,w,D){let _=(E,S,F)=>{(E||F)&&(_=()=>{},this.cmdSW?.stop()),D(E,S,F)},C=!1;c.stdout?(this.forwardData(c.stdout,g,_),c.stdout.once("data",()=>C=!0)):w({message:"stdout is null"});let A;c.stderr?A=this.collectData(c.stderr):w({message:"stderr is null"}),c.on("error",E=>{_(E)}),c.on("close",E=>{let S;!C&&(S=this.decodeData(A,g))&&n(S)?_(new Error(`command failed with error code ${E}: ${this.decodeData(A,g)}`)):(this.exists&&E===0&&(this.isLimitHit=!0),_(null,"",!0))})}forwardData(c,g,w){const D=new k.StringDecoder(g);return c.on("data",_=>{w(null,D.write(_))}),D}collectData(c){const g=[];return c.on("data",w=>{g.push(w)}),g}decodeData(c,g){const w=new k.StringDecoder(g);return c.map(D=>w.write(D)).join("")}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries(c,{pathToEntries:g},w,D,_){D.indexOf(this.filePattern)!==-1&&this.matchFile(_,{base:w,relativePath:this.filePattern,searchPath:this.getSearchPath(c,this.filePattern)});const C=A=>{const E=P.basename(A),S=P.dirname(A);let F=g[S];F||(F=g[S]=[],C(S)),F.push({base:w,relativePath:A,basename:E,searchPath:this.getSearchPath(c,A)})};D.forEach(C)}matchDirectoryTree({rootEntries:c,pathToEntries:g},w,D){const _=this,C=this.folderExcludePatterns.get(w),A=this.filePattern;function E(S){_.directoriesWalked++;const F=(0,m.hasSiblingFn)(()=>S.map(N=>N.basename));for(let N=0,O=S.length;N<O;N++){const M=S[N],{relativePath:U,basename:x}=M;if(C.test(U,x,A!==x?F:void 0))continue;const z=g[U];if(z)E(z);else{if(_.filesWalked++,U===A)continue;_.matchFile(D,M)}if(_.isLimitHit)break}}E(c)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(c,g,w,D,_){const C=c.folder,A=(0,m.hasSiblingFn)(()=>w);this.parallel(w,(E,S)=>{if(this.isCanceled||this.isLimitHit)return S(null);const F=g?[g,E].join(P.sep):E;if(this.folderExcludePatterns.get(c.folder.fsPath).test(F,E,this.config.filePattern!==E?A:void 0))return S(null);const N=[C.fsPath,F].join(P.sep);d.lstat(N,(O,M)=>{if(O||this.isCanceled||this.isLimitHit)return S(null);this.statLinkIfNeeded(N,M,(U,x)=>U||this.isCanceled||this.isLimitHit?S(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,M,(z,B)=>z||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?S(null):(this.walkedPaths[B]=!0,a.Promises.readdir(N).then(ee=>{if(this.isCanceled||this.isLimitHit)return S(null);this.doWalk(c,F,ee,D,V=>S(V||null))},ee=>{S(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&b.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(D,{base:C.fsPath,relativePath:F,searchPath:this.getSearchPath(c,F)}),S(null,void 0)))})},E=>{const S=E&&L.coalesce(E);return _(S&&S.length>0?S[0]:void 0)})}matchFile(c,g){this.isFileMatch(g)&&(!this.includePattern||this.includePattern(g.relativePath,P.basename(g.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||c(g))}isFileMatch(c){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,m.isFilePatternMatch)(c,this.normalizedFilePatternLowercase);if(this.filePattern)return(0,m.isFilePatternMatch)(c,this.filePattern,!1)}return!0}statLinkIfNeeded(c,g,w){return g.isSymbolicLink()?d.stat(c,w):w(null,g)}realPathIfNeeded(c,g,w){return g.isSymbolicLink()?d.realpath(c,(D,_)=>D?w(D):w(null,_)):w(null,c)}getSearchPath(c,g){return c.folderName?P.join(c.folderName,g):g}}e.FileWalker=s;class t{constructor(c,g){this.folderQueries=c.folderQueries,this.extraFiles=c.extraFileResources||[],this.numThreads=g,this.walker=new s(c)}search(c,g,w){this.walker.walk(this.folderQueries,this.extraFiles,this.numThreads,c,g,(D,_)=>{w(D,{limitHit:_,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=t;class o{constructor(c,g){this.expression=c,this.root=g,this.init(c)}init(c){let g,w;Object.keys(c).filter(D=>c[D]).forEach(D=>{P.isAbsolute(D)?(g=g||v.getEmptyExpression(),g[D]=c[D]):(w=w||v.getEmptyExpression(),w[D]=c[D])}),this.absoluteParsedExpr=g&&v.parse(g,{trimForExclusions:!0}),this.relativeParsedExpr=w&&v.parse(w,{trimForExclusions:!0})}test(c,g,w){return this.relativeParsedExpr&&this.relativeParsedExpr(c,g,w)||this.absoluteParsedExpr&&this.absoluteParsedExpr(P.join(this.root,c),g,w)}getBasenameTerms(){const c=[];return this.absoluteParsedExpr&&c.push(...v.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&c.push(...v.getBasenameTerms(this.relativeParsedExpr)),c}getPathTerms(){const c=[];return this.absoluteParsedExpr&&c.push(...v.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&c.push(...v.getPathTerms(this.relativeParsedExpr)),c}}function n(h){const c=h.trim().split(`
`),g=c[0].trim();if(g.startsWith("Error parsing regex"))return g;if(g.startsWith("regex parse error"))return T.uppercaseFirstLetter(c[c.length-1].trim());if(g.startsWith("error parsing glob")||g.startsWith("unsupported encoding"))return g.charAt(0).toUpperCase()+g.substr(1);if(g==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(g.startsWith("Literal "))return g}}),define(Ce[350],Ie([1,0,105,21,189,20,18]),function(pe,e,r,d,P,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GUESSABLE_ENCODINGS=e.SUPPORTED_ENCODINGS=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.isUTFEncoding=R,e.toDecodeStream=a,e.toEncodeReadable=m,e.encodingExists=p,e.toNodeEncoding=f,e.detectEncodingByBOMFromBuffer=i,e.toCanonicalName=w,e.detectEncodingFromBuffer=D,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function R(_){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(C=>C===_)}e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const v=512,l=512,I=512*8,y=512*128;var u;(function(_){_[_.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(u||(e.DecodeStreamErrorKind=u={}));class T extends Error{constructor(C,A){super(C),this.decodeStreamErrorKind=A}}e.DecodeStreamError=T;class b{static async create(C){let A;if(C!==e.UTF8)A=(await(0,P.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(f(C));else{const E=new TextDecoder;A={write(S){return E.decode(S,{stream:!0})},end(){return E.decode()}}}return new b(A)}constructor(C){this.iconvLiteDecoder=C}write(C){return this.iconvLiteDecoder.write(C)}end(){return this.iconvLiteDecoder.end()}}function a(_,C){const A=C.minBytesRequiredForDetection??C.guessEncoding?I:l;return new Promise((E,S)=>{const F=(0,r.newWriteableStream)(z=>z.join("")),N=[];let O=0,M;const U=new k.CancellationTokenSource,x=async()=>{try{const z=await D({buffer:d.VSBuffer.concat(N),bytesRead:O},C.guessEncoding,C.candidateGuessEncodings);if(z.seemsBinary&&C.acceptTextOnly)throw new T("Stream is binary but only text is accepted for decoding",u.STREAM_IS_BINARY);z.encoding=await C.overwriteEncoding(z.encoding),M=await b.create(z.encoding);const B=M.write(d.VSBuffer.concat(N).buffer);F.write(B),N.length=0,O=0,E({stream:F,detected:z})}catch(z){U.cancel(),F.destroy(),S(z)}};(0,r.listenStream)(_,{onData:async z=>{M?F.write(M.write(z.buffer)):(N.push(z),O+=z.byteLength,O>=A&&(_.pause(),await x(),setTimeout(()=>_.resume())))},onError:z=>F.error(z),onEnd:async()=>{M||await x(),F.end(M?.end())}},U.token)})}async function m(_,C,A){const S=(await(0,P.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(f(C),A);let F=!1,N=!1;return{read(){if(N)return null;const O=_.read();if(typeof O!="string"){if(N=!0,!F&&A?.addBOM)switch(C){case e.UTF8:case e.UTF8_with_bom:return d.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return d.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return d.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const M=S.end();return M&&M.length>0?(F=!0,d.VSBuffer.wrap(M)):null}return F=!0,d.VSBuffer.wrap(S.write(O))}}}async function p(_){return(await(0,P.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(f(_))}function f(_){return _===e.UTF8_with_bom||_===null?e.UTF8:_}function i(_,C){if(!_||C<e.UTF16be_BOM.length)return null;const A=_.readUInt8(0),E=_.readUInt8(1);if(A===e.UTF16be_BOM[0]&&E===e.UTF16be_BOM[1])return e.UTF16be;if(A===e.UTF16le_BOM[0]&&E===e.UTF16le_BOM[1])return e.UTF16le;if(C<e.UTF8_BOM.length)return null;const S=_.readUInt8(2);return A===e.UTF8_BOM[0]&&E===e.UTF8_BOM[1]&&S===e.UTF8_BOM[2]?e.UTF8_with_bom:null}const s=["ascii","utf-16","utf-32"];async function t(_,C){const A=await(0,P.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),E=_.slice(0,y),S=g(E.buffer);C&&(C=(0,L.coalesce)(C.map(O=>c(O))),C.length===0&&(C=void 0));const F=A.detect(S,C?{detectEncodings:C}:void 0);if(!F||!F.encoding)return null;const N=F.encoding.toLowerCase();return 0<=s.indexOf(N)?null:h(F.encoding)}const o={ibm866:"cp866",big5:"cp950"};function n(_){return _.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function h(_){const C=n(_);return o[C]||C}function c(_){const C=n(_);return e.GUESSABLE_ENCODINGS[C].guessableName}function g(_){let C="";for(let A=0;A<_.length;A++)C+=String.fromCharCode(_[A]);return C}function w(_){switch(_){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const C=_.match(/windows(\d+)/);return C?"windows-"+C[1]:_}}}function D({buffer:_,bytesRead:C},A,E){let S=i(_,C),F=!1;if(S!==e.UTF16be&&S!==e.UTF16le&&_){let N=!0,O=!0,M=!1;for(let U=0;U<C&&U<v;U++){const x=U%2===1,z=_.readUInt8(U)===0;if(z&&(M=!0),N&&(x&&!z||!x&&z)&&(N=!1),O&&(x&&z||!x&&!z)&&(O=!1),z&&!N&&!O)break}M&&(N?S=e.UTF16le:O?S=e.UTF16be:F=!0)}return A&&!F&&!S&&_?t(_.slice(0,C),E).then(N=>({seemsBinary:!1,encoding:N})):{seemsBinary:F,encoding:S}}e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.GUESSABLE_ENCODINGS=(()=>{const _={};for(const C in e.SUPPORTED_ENCODINGS)e.SUPPORTED_ENCODINGS[C].guessableName&&(_[C]=e.SUPPORTED_ENCODINGS[C]);return _})()}),define(Ce[172],Ie([1,0,350,33,171]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0,d=$e(d);class k extends P.TextSearchManager{constructor(R,v,l=d,I="searchProcess"){super({query:R,provider:v},{readdir:y=>l.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,r.toCanonicalName)(y)},I)}}e.NativeTextSearchManager=k}),define(Ce[173],Ie([1,0,56,365,349,18,78,38,12,2,37,99,366,347,129]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepParser=e.RipgrepTextSearchEngine=void 0,e.getRgArgs=o,e.unicodeEscapesToPCRE2=h,e.fixRegexNewline=g,e.fixNewline=w,e.performBraceExpansionForRipgrep=_,r=$e(r);const a=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(A,E){this.outputChannel=A,this._numThreads=E}provideTextSearchResults(A,E,S,F){return this.outputChannel.appendLine(`provideTextSearchResults ${A.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((N,O)=>{F.onCancellationRequested(()=>G());const M={...E,numThreads:this._numThreads},U=o(A,M),x=E.folder.fsPath,z=U.map(ge=>ge.match(/^-/)?ge:`'${ge}'`).join(" ");this.outputChannel.appendLine(`${a} ${z}
 - cwd: ${x}`);let B=r.spawn(a,U,{cwd:x});B.on("error",ge=>{console.error(ge),this.outputChannel.appendLine("Error: "+(ge&&ge.message)),O((0,I.serializeSearchError)(new I.SearchError(ge&&ge.message,I.SearchErrorCode.rgProcessError)))});let ee=!1;const V=new i(E.maxResults,E.folder,E.previewOptions);V.on("result",ge=>{ee=!0,le="",S.report(ge)});let $=!1;const G=()=>{$=!0,B?.kill(),V?.cancel()};let Z=!1;V.on("hitLimit",()=>{Z=!0,G()});let le="";B.stdout.on("data",ge=>{V.handleData(ge),ee||(le+=ge)});let ne=!1;B.stdout.once("data",()=>ne=!0);let _e="";B.stderr.on("data",ge=>{const Y=ge.toString();this.outputChannel.appendLine(Y),_e.length+Y.length<1e6&&(_e+=Y)}),B.on("close",()=>{if(this.outputChannel.appendLine(ne?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(ee?"Got result from parser":"No result from parser"),le&&this.outputChannel.appendLine(`Got data without result: ${le}`),this.outputChannel.appendLine(""),$)N({limitHit:Z});else{V.flush(),B=null;let ge;_e&&!ne&&(ge=p(_e))?O((0,I.serializeSearchError)(new I.SearchError(ge.message,ge.code))):N({limitHit:Z})}})})}}e.RipgrepTextSearchEngine=m;function p(C){const A=C.split(`
`),E=A[0].trim();if(A.some(F=>F.startsWith("regex parse error")))return new I.SearchError(f(A),I.SearchErrorCode.regexParseError);const S=E.match(/grep config error: unknown encoding: (.*)/);if(S)return new I.SearchError(`Unknown encoding: ${S[1]}`,I.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(E,I.SearchErrorCode.regexParseError)}function f(C){const A=["Regex parse error"],E=C.filter(S=>S.startsWith("PCRE2:"));if(E.length>=1){const S=E[0].replace("PCRE2:","");if(S.indexOf(":")!==-1&&S.split(":").length>=2){const F=S.split(":")[1];A.push(":"+F)}}return A.join("")}class i extends d.EventEmitter{constructor(A,E,S){super(),this.maxResults=A,this.root=E,this.previewOptions=S,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new P.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(A,E){return super.on(A,E),this}handleData(A){if(this.isDone)return;const E=typeof A=="string"?A:this.stringDecoder.write(A);this.handleDecodedData(E)}handleDecodedData(A){let E=A.indexOf(`
`);const S=this.remainder+A;if(E>=0)E+=this.remainder.length;else{this.remainder=S;return}let F=0;for(;E>=0;)this.handleLine(S.substring(F,E).trim()),F=E+1,E=S.indexOf(`
`,F);this.remainder=S.substring(F)}handleLine(A){if(this.isDone||!A)return;let E;try{E=JSON.parse(A)}catch{throw new Error(`malformed line from rg: ${A}`)}if(E.type==="match"){const S=s(E.data.path),F=l.URI.joinPath(this.root,S),N=this.createTextSearchMatch(E.data,F);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const S=s(E.data.path),F=l.URI.joinPath(this.root,S);this.createTextSearchContext(E.data,F).forEach(O=>this.onResult(O))}}createTextSearchMatch(A,E){const S=A.line_number-1,F=s(A.lines),N=Buffer.from(F);let O=0,M=0,U=S;A.submatches.length===0&&A.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const x=(0,k.coalesce)(A.submatches.map((z,B)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const ee=s(z.match),V=N.slice(O,z.start).toString(),$=t(V),G=$.numLines>0?$.lastLineLength:$.lastLineLength+M,Z=t(ee),le=$.numLines+U,ne=Z.numLines+le,_e=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+G;return O=z.end,M=_e,U=ne,new y.Range(le,G,ne,_e)}));return(0,b.createTextSearchResult)(E,F,x,this.previewOptions)}createTextSearchContext(A,E){const S=s(A.lines),F=A.line_number;return S.replace(/\r?\n$/,"").split(`
`).map((N,O)=>({text:N,uri:E,lineNumber:F+O}))}onResult(A){this.emit("result",A)}}e.RipgrepParser=i;function s(C){return C.bytes?Buffer.from(C.bytes,"base64").toString():C.text}function t(C){const A=/\n/g;let E=0,S=-1,F;for(;F=A.exec(C);)E++,S=F.index;const N=S>=0?C.length-S-1:C.length;return{numLines:E,lastLineLength:N}}function o(C,A){const E=["--hidden","--no-require-git"];E.push(C.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:S,otherIncludes:F}=(0,L.groupBy)(A.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const O=new Set;F.forEach(M=>{O.add(M)}),E.push("-g","!*"),O.forEach(M=>{n(M).map(b.anchorGlob).forEach(U=>{E.push("-g",U)})})}S&&S.length&&S.forEach(O=>{E.push("-g",O)}),A.excludes.map(b.anchorGlob).forEach(O=>E.push("-g",`!${O}`)),A.maxFileSize&&E.push("--max-filesize",A.maxFileSize+""),A.useIgnoreFiles?A.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),A.followSymlinks&&E.push("--follow"),A.encoding&&A.encoding!=="utf8"&&E.push("--encoding",A.encoding),A.numThreads&&E.push("--threads",`${A.numThreads}`),C.pattern==="--"&&(C.isRegExp=!0,C.pattern="\\-\\-"),C.isMultiline&&!C.isRegExp&&(C.pattern=(0,v.escapeRegExpCharacters)(C.pattern),C.isRegExp=!0),A.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),C.isRegExp&&(C.pattern=h(C.pattern),E.push("--engine","auto"));let N;if(C.isWordMatch){const M=(0,v.createRegExp)(C.pattern,!!C.isRegExp,{wholeWord:C.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",M)}else if(C.isRegExp){let O=g(C.pattern);O=w(O),E.push("--regexp",O)}else N=C.pattern,E.push("--fixed-strings");return E.push("--no-config"),A.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),C.isMultiline&&E.push("--multiline"),A.beforeContext&&E.push("--before-context",A.beforeContext+""),A.afterContext&&E.push("--after-context",A.afterContext+""),E.push("--"),N&&E.push(N),E.push("."),E}function n(C){return _(C).flatMap(E=>{const S=(0,R.splitGlobAware)(E,"/");return S.map((F,N)=>S.slice(0,N+1).join("/"))})}function h(C){const A=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;C.match(A);)C=C.replace(A,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;C.match(E);)C=C.replace(E,"$1\\x{$2}");return C}const c=C=>C.type==="Assertion"&&C.kind==="lookbehind";function g(C){let A;try{A=new u.RegExpParser().parsePattern(C)}catch{return C}let E="",S=0;const F=(M,U,x)=>{E+=C.slice(S,M)+x,S=U},N=[];return new u.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const U=N[0];if(!U)F(M.start,M.end,"\\r?\\n");else if(!N.some(c))if(U.type==="CharacterClass")if(U.negate){const x=C.slice(U.start+2,M.start)+C.slice(M.end,U.end-1);U.parent?.type==="Quantifier"?F(U.start,U.end,x?`[^${x}]`:"."):F(U.start,U.end,"(?!\\r?\\n"+(x?`|[${x}]`:"")+")")}else{const x=C.slice(U.start+1,M.start)+C.slice(M.end,U.end-1);F(U.start,U.end,x===""?"\\r?\\n":`(?:[${x}]|\\r?\\n)`)}else U.type==="Quantifier"&&F(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){N.unshift(M)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(M){N.unshift(M)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(M){N.unshift(M)},onCharacterClassLeave(){N.shift()},onAssertionEnter(M){c(M)&&N.push(M)},onAssertionLeave(M){N[0]===M&&N.shift()}}).visit(A),E+=C.slice(S),E}function w(C){return C.replace(/\n/g,"\\r?\\n")}function D(C){let A=!1,E=!1,S="",F="";for(let N=0;N<C.length;N++){const O=C[N];switch(O){case"\\":E?(A?F+="\\"+O:S+="\\"+O,E=!1):E=!0;break;case"{":if(E)A?F+=O:S+=O,E=!1;else{if(A)return{strInBraces:S+"{"+F+"{"+C.substring(N+1)};A=!0}break;case"}":if(E)A?F+=O:S+=O,E=!1;else{if(A)return{fixedStart:S,strInBraces:F,fixedEnd:C.substring(N+1)};S+=O}break;default:A?F+=(E?"\\":"")+O:S+=(E?"\\":"")+O,E=!1;break}}return{strInBraces:S+(A?"{"+F:"")}}function _(C){const{fixedStart:A,strInBraces:E,fixedEnd:S}=D(C);if(A===void 0||S===void 0)return[E];let F=(0,R.splitGlobAware)(E,",");F.length||(F=[""]);const N=_(S);return F.flatMap(O=>{const M=A+O;return N.map(U=>M+U)})}}),define(Ce[351],Ie([1,0,20,173,89,14]),function(pe,e,r,d,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class L{constructor(l,I){this.outputChannel=l,this.getNumThreads=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}async provideTextSearchResults(l,I,y,u){const T=await this.getNumThreads(),b=new d.RipgrepTextSearchEngine(this.outputChannel,T),a={...I,numThreads:T};if(I.folder.scheme===k.Schemas.vscodeUserData){const m={...a,folder:I.folder.with({scheme:k.Schemas.file})},p=new P.Progress(f=>y.report({...f,uri:f.uri.with({scheme:I.folder.scheme})}));return this.withToken(u,f=>b.provideTextSearchResults(l,m,p,f))}else return this.withToken(u,m=>b.provideTextSearchResults(l,a,y,m))}async withToken(l,I){const y=R(l);this.inProgress.add(y);const u=await I(y.token);return this.inProgress.delete(y),u}dispose(){this.inProgress.forEach(l=>l.cancel())}}e.RipgrepSearchProvider=L;function R(v){const l=new r.CancellationTokenSource;return v.onCancellationRequested(()=>l.cancel()),l}}),define(Ce[352],Ie([1,0,33,173,172]),function(pe,e,r,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0,r=$e(r);class k{constructor(v,l){this.query=v,this.numThreads=l}search(v,l,I){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const y={appendLine(T){I({message:T})}},u=new P.NativeTextSearchManager(this.query,new d.RipgrepTextSearchEngine(y,this.numThreads),r);return new Promise((T,b)=>u.search(a=>{l(a.map(L))},v).then(a=>T({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),b))}}e.TextSearchEngineAdapter=k;function L(R){return{path:R.resource&&R.resource.fsPath,results:R.results,numMatches:(R.results||[]).reduce((v,l)=>{if(l.ranges){const I=l;return v+(Array.isArray(I.ranges)?I.ranges.length:1)}else return v+1},0)}}}),define(Ce[353],Ie([1,0,18,7,13,4,136,16,42,2,27,37,348,352]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,r=$e(r);class b{static{this.BATCH_SIZE=512}constructor(s="searchProcess",t){this.processType=s,this.getNumThreads=t,this.caches=Object.create(null)}fileSearch(s){let t;const o=p(s),n=new k.Emitter({onDidAddFirstListener:()=>{t=(0,d.createCancelablePromise)(async h=>{const c=await this.getNumThreads?.();return this.doFileSearchWithEngine(u.Engine,o,g=>n.fire(g),h,b.BATCH_SIZE,c)}),t.then(h=>n.fire(h),h=>n.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}textSearch(s){let t;const o=p(s),n=new k.Emitter({onDidAddFirstListener:()=>{t=(0,d.createCancelablePromise)(h=>this.ripgrepTextSearch(o,c=>n.fire(c),h)),t.then(h=>n.fire(h),h=>n.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}async ripgrepTextSearch(s,t,o){s.maxFileSize=this.getPlatformFileLimits().maxFileSize;const n=await this.getNumThreads?.();return new T.TextSearchEngineAdapter(s,n).search(o,t,t)}getPlatformFileLimits(){return{maxFileSize:16*I.ByteSize.GB}}doFileSearch(s,t,o,n){return this.doFileSearchWithEngine(u.Engine,s,o,n,b.BATCH_SIZE,t)}doFileSearchWithEngine(s,t,o,n,h=b.BATCH_SIZE,c){let g=0;const w=_=>{Array.isArray(_)?(g+=_.length,o(_.map(C=>this.rawMatchToSearchItem(C)))):_.relativePath?(g++,o(this.rawMatchToSearchItem(_))):o(_)};if(t.sortByScore){let _=this.trySortedSearchFromCache(t,w,n);if(!_){const C=t.maxResults?Object.assign({},t,{maxResults:null}):t,A=new s(C,c);_=this.doSortedSearch(A,t,o,w,n)}return new Promise((C,A)=>{_.then(([E,S])=>{const F=S.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(F,o,h),C(E)},A)})}const D=new s(t,c);return this.doSearch(D,w,h,n).then(_=>({limitHit:_.limitHit,type:"success",stats:{detailStats:_.stats,type:this.processType,fromCache:!1,resultCount:g,sortingTime:void 0},messages:[]}))}rawMatchToSearchItem(s){return{path:s.base?(0,R.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,t,o,n,h){const c=new k.Emitter;let g=(0,d.createCancelablePromise)(D=>{let _=[];const C=A=>{Array.isArray(A)?_=A:(n(A),c.fire(A))};return this.doSearch(s,C,-1,D).then(A=>[A,_])}),w;if(t.cacheKey){w=this.getOrCreateCache(t.cacheKey);const D={promise:g,event:c.event,resolved:!1};w.resultsToSearchCache[t.filePattern||""]=D,g.then(()=>{D.resolved=!0},_=>{delete w.resultsToSearchCache[t.filePattern||""]}),g=this.preventCancellation(g)}return g.then(([D,_])=>{const C=w?w.scorerCache:Object.create(null),A=(typeof t.maxResults!="number"||t.maxResults>0)&&v.StopWatch.create(!1);return this.sortResults(t,_,C,h).then(E=>{const S=A?A.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:S,fromCache:!1,type:this.processType,resultCount:E.length},messages:D.messages,limitHit:D.limitHit||typeof t.maxResults=="number"&&_.length>t.maxResults},E]})})}getOrCreateCache(s){const t=this.caches[s];return t||(this.caches[s]=new a)}trySortedSearchFromCache(s,t,o){const n=s.cacheKey&&this.caches[s.cacheKey];if(!n)return;const h=this.getResultsFromCache(n,s.filePattern||"",t,o);if(h)return h.then(([c,g,w])=>{const D=v.StopWatch.create(!1);return this.sortResults(s,g,n.scorerCache,o).then(_=>{const C=D.elapsed(),A={fromCache:!0,detailStats:w,type:this.processType,resultCount:g.length,sortingTime:C};return[{type:"success",limitHit:c.limitHit||typeof s.maxResults=="number"&&g.length>s.maxResults,stats:A,messages:[]},_]})})}sortResults(s,t,o,n){const h=(0,L.prepareQuery)(s.filePattern||""),c=(w,D)=>(0,L.compareItemsByFuzzyScore)(w,D,h,!0,m,o),g=typeof s.maxResults=="number"?s.maxResults:y.DEFAULT_MAX_SEARCH_RESULTS;return r.topAsync(t,c,g,1e4,n)}sendProgress(s,t,o){if(o&&o>0)for(let n=0;n<s.length;n+=o)t(s.slice(n,n+o));else t(s)}getResultsFromCache(s,t,o,n){const h=v.StopWatch.create(!1),c=t.indexOf(R.sep)>=0;let g;for(const C in s.resultsToSearchCache)if(t.startsWith(C)){if(c&&C.indexOf(R.sep)<0&&C!=="")continue;const A=s.resultsToSearchCache[C];g={promise:this.preventCancellation(A.promise),event:A.event,resolved:A.resolved};break}if(!g)return null;const w=h.elapsed(),D=v.StopWatch.create(!1),_=g.event(o);return n&&n.onCancellationRequested(()=>{_.dispose()}),g.promise.then(([C,A])=>{if(n&&n.isCancellationRequested)throw(0,P.canceled)();const E=[],S=(0,L.prepareQuery)(t).normalizedLowercase;for(const F of A)(0,y.isFilePatternMatch)(F,S)&&E.push(F);return[C,E,{cacheWasResolved:g.resolved,cacheLookupTime:w,cacheFilterTime:D.elapsed(),cacheEntryCount:A.length}]})}doSearch(s,t,o,n){return new Promise((h,c)=>{let g=[];n?.onCancellationRequested(()=>s.cancel()),s.search(w=>{w&&(o?(g.push(w),o>0&&g.length>=o&&(t(g),g=[])):t(w))},w=>{t(w)},(w,D)=>{g.length&&t(g),w?(t({message:"Search finished. Error: "+w.message}),c(w)):(t({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),h(D))})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,o){return s.then(t,o)}catch(t){return this.then(void 0,t)}finally(t){return s.finally(t)}}}}e.SearchService=b;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,R.basename)(i.relativePath)}getItemDescription(i){return(0,R.dirname)(i.relativePath)}getItemPath(i){return i.relativePath}};function p(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(f),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>l.URI.revive(s))}}function f(i){return{...i,folder:l.URI.revive(i.folder)}}}),define(Ce[354],Ie([1,0,3,14,2,33,11,41,29,19,102,72,37,353,351,129,172]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0,k=$e(k);let p=class extends I.ExtHostSearch{constructor(i,s,t,o,n){super(i,t,n),this.configurationService=o,this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new r.DisposableStore,this.isDisposed=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.handleConfigurationChanged=this.handleConfigurationChanged.bind(this);const h=new a.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(d.Schemas.vscodeUserData,new b.RipgrepSearchProvider(h,this.getNumThreadsCached))),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders(),o.getConfigProvider().then(c=>{this.isDisposed||this._disposables.add(c.onDidChangeConfiguration(this.handleConfigurationChanged))})}handleConfigurationChanged(i){i.affectsConfiguration("search")&&(this._numThreadsPromise=void 0)}async getNumThreads(){return(await this.configurationService.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this._numThreadsPromise||(this._numThreadsPromise=this.getNumThreads()),this._numThreadsPromise}dispose(){this.isDisposed=!0,this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const i=new a.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(d.Schemas.file,new b.RipgrepSearchProvider(i,this.getNumThreadsCached))),this._disposables.add(this.registerInternalFileSearchProvider(d.Schemas.file,new T.SearchService("fileSearchProvider",this.getNumThreadsCached)))}registerInternalFileSearchProvider(i,s){const t=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=t,this._proxy.$registerFileSearchProvider(t,this._transformScheme(i)),(0,r.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(t)})}$provideFileSearchResults(i,s,t,o){const n=(0,I.reviveQuery)(t);if(i===this._internalFileSearchHandle){const h=Date.now();return this.doInternalFileSearch(i,s,n,o).then(c=>{const g=Date.now()-h;return this._logService.debug(`Ext host file search time: ${g}ms`),c})}return super.$provideFileSearchResults(i,s,t,o)}async doInternalFileSearchWithCustomCallback(i,s,t){const o=h=>{if((0,u.isSerializedFileMatch)(h)&&(h=[h]),Array.isArray(h)){t(h.map(c=>P.URI.file(c.path)));return}h.message&&this._logService.debug("ExtHostSearch",h.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");const n=await this.getNumThreadsCached();return this._internalFileSearchProvider.doFileSearch(i,n,o,s)}async doInternalFileSearch(i,s,t,o){return this.doInternalFileSearchWithCustomCallback(t,o,n=>{this._proxy.$handleFileMatch(i,s,n)})}$clearCache(i){return this._internalFileSearchProvider?.clearCache(i),super.$clearCache(i)}createTextSearchManager(i,s){return new m.NativeTextSearchManager(i,s,void 0,"textSearchProvider")}};e.NativeExtHostSearch=p,e.NativeExtHostSearch=p=Xe([He(0,l.IExtHostRpcService),He(1,v.IExtHostInitDataService),He(2,y.IURITransformerService),He(3,R.IExtHostConfiguration),He(4,L.ILogService)],p)}),define(Ce[130],Ie([1,0,367,67,66,368,21,13,4,3,16,10,32,86,68]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=c,e.createStaticIPCHandle=g,e.serve=_,e.connect=C;const a=3e4;class m{traceSocketEvent(E,S){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,S)}constructor(E,S=""){this._canWrite=!0,this.debugLabel=S,this.socket=E,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=N=>{if(this.traceSocketEvent(b.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,R.onUnexpectedError)(N)}},this.socket.on("error",this._errorListener);let F;this._closeListener=N=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Close,{hadError:N}),this._canWrite=!1,F&&clearTimeout(F)},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1,F=setTimeout(()=>E.destroy(),a)},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(E){const S=F=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Read,F),E(L.VSBuffer.wrap(F))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(E){const S=F=>{E({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:F,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(E){const S=()=>{E()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(E){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(b.SocketDiagnosticsEventType.Write,E),this.socket.write(E.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,R.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,R.onUnexpectedError)(S)}}end(){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((E,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),E();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),E()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=m;var p;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var f;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(f||(f={}));class i extends l.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(E,S){this.socket.traceSocketEvent(E,S)}constructor(E,S,F,N){super(),this._onData=this._register(new v.Emitter),this._onClose=this._register(new v.Emitter),this._isEnded=!1,this._state={state:f.PeekHeader,readLen:p.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:F?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new s(this,S,F,N,this._onData,(O,M)=>this._write(O,M))),this._register(this._flowManager.onError(O=>{console.error(O),(0,R.onUnexpectedError)(O),this._onClose.fire({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:O})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(async O=>{this._flowManager.isProcessingReadQueue()&&await v.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(O)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this._onData.event(E)}onClose(E){return this._onClose.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let S=0;for(;S<E.byteLength;)this._flowManager.writeMessage(E.slice(S,Math.min(S+p.MaxWebSocketMessageLength,E.byteLength)),{compressed:!0,opcode:2}),S+=p.MaxWebSocketMessageLength}_write(E,{compressed:S,opcode:F}){if(this._isEnded)return;this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,E);let N=p.MinHeaderByteSize;E.byteLength<126?N+=0:E.byteLength<2**16?N+=2:N+=8;const O=L.VSBuffer.alloc(N),M=S?64:0,U=F&15;if(O.writeUInt8(128|M|U,0),E.byteLength<126)O.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){O.writeUInt8(126,1);let x=1;O.writeUInt8(E.byteLength>>>8&255,++x),O.writeUInt8(E.byteLength>>>0&255,++x)}else{O.writeUInt8(127,1);let x=1;O.writeUInt8(0,++x),O.writeUInt8(0,++x),O.writeUInt8(0,++x),O.writeUInt8(0,++x),O.writeUInt8(E.byteLength>>>24&255,++x),O.writeUInt8(E.byteLength>>>16&255,++x),O.writeUInt8(E.byteLength>>>8&255,++x),O.writeUInt8(E.byteLength>>>0&255,++x)}this.socket.write(L.VSBuffer.concat([O,E]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(E){if(E.byteLength!==0){for(this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===f.PeekHeader){const S=this._incomingData.peek(this._state.readLen),F=S.readUInt8(0),N=(F&128)>>>7,O=(F&64)>>>6,M=F&15,U=S.readUInt8(1),x=(U&128)>>>7,z=U&127;this._state.state=f.ReadHeader,this._state.readLen=p.MinHeaderByteSize+(x?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!O),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this._state.opcode=M,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===f.ReadHeader){const S=this._incomingData.read(this._state.readLen),F=S.readUInt8(1),N=(F&128)>>>7;let O=F&127,M=1;O===126?O=S.readUInt8(++M)*2**8+S.readUInt8(++M):O===127&&(O=S.readUInt8(++M)*0+S.readUInt8(++M)*0+S.readUInt8(++M)*0+S.readUInt8(++M)*0+S.readUInt8(++M)*2**24+S.readUInt8(++M)*2**16+S.readUInt8(++M)*2**8+S.readUInt8(++M));let U=0;N&&(U=S.readUInt8(++M)*2**24+S.readUInt8(++M)*2**16+S.readUInt8(++M)*2**8+S.readUInt8(++M)),this._state.state=f.ReadBody,this._state.readLen=O,this._state.mask=U,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===f.ReadBody){const S=this._incomingData.read(this._state.readLen);this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,S),n(S,this._state.mask),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,S),this._state.state=f.PeekHeader,this._state.readLen=p.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(S,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await v.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=i;class s extends l.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(E,S,F,N,O,M){super(),this._tracer=E,this._onData=O,this._writeFn=M,this._onError=this._register(new v.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new v.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new v.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,S?(this._zlibInflateStream=this._register(new t(this._tracer,N,F,{windowBits:15})),this._zlibDeflateStream=this._register(new o(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(E,S){this._writeQueue.push({data:E,options:S}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:E,options:S}=this._writeQueue.shift();if(this._zlibDeflateStream&&S.compressed){const F=await this._deflateMessage(this._zlibDeflateStream,E);this._writeFn(F,S)}else this._writeFn(E,{...S,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(E,S){return new Promise((F,N)=>{E.write(S),E.flush(O=>F(O))})}acceptFrame(E,S,F){this._readQueue.push({data:E,isCompressed:S,isLastFrameOfMessage:F}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const E=this._readQueue.shift();if(this._zlibInflateStream&&E.isCompressed){const S=await this._inflateFrame(this._zlibInflateStream,E.data,E.isLastFrameOfMessage);this._onData.fire(S)}else this._onData.fire(E.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(E,S,F){return new Promise((N,O)=>{E.write(S),F&&E.write(L.VSBuffer.fromByteArray([0,0,255,255])),E.flush(M=>N(M))})}}class t extends l.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}constructor(E,S,F,N){super(),this._tracer=E,this._recordInflateBytes=S,this._onError=this._register(new v.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,k.createInflateRaw)(N),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateError,{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateData,O),this._pendingInflateData.push(L.VSBuffer.wrap(O))}),F&&(this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialWrite,F.buffer),this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(E){this._recordInflateBytes&&this._recordedInflateBytes.push(E.clone()),this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateWrite,E),this._zlibInflate.write(E.buffer)}flush(E){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateFlushFired);const S=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,E(S)})}}class o extends l.Disposable{constructor(E,S){super(),this._tracer=E,this._onError=this._register(new v.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,k.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",F=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateError,{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibDeflate.on("data",F=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateData,F),this._pendingDeflateData.push(L.VSBuffer.wrap(F))})}write(E){this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateWrite,E.buffer),this._zlibDeflate.write(E.buffer)}flush(E){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateFlushFired);let S=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.byteLength-4),E(S)})}}function n(A,E){if(E===0)return;const S=A.byteLength>>>2;for(let x=0;x<S;x++){const z=A.readUInt32BE(x*4);A.writeUInt32BE(z^E,x*4)}const F=S*4,N=A.byteLength-F,O=E>>>24&255,M=E>>>16&255,U=E>>>8&255;N>=1&&A.writeUInt8(A.readUInt8(F)^O,F),N>=2&&A.writeUInt8(A.readUInt8(F+1)^M,F+1),N>=3&&A.writeUInt8(A.readUInt8(F+2)^U,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[y.Platform.Linux]:107,[y.Platform.Mac]:103};function c(){const A=(0,u.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const E=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,P.tmpdir)(),S=(0,I.join)(E,`vscode-ipc-${A}.sock`);return w(S),S}function g(A,E,S){const N=(0,r.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${S}-${E}-sock`;const O=S.substr(0,4),M=E.substr(0,6);let U;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${O}-${M}.sock`):U=(0,I.join)(A,`${O}-${M}.sock`),w(U),U}function w(A){const E=h[y.platform];typeof E=="number"&&A.length>=E&&console.warn(`WARNING: IPC handle "${A}" is longer than ${E} chars, try a shorter --user-data-dir`)}class D extends T.IPCServer{static toClientConnectionEvent(E){const S=v.Event.fromNodeEventEmitter(E,"connection");return v.Event.map(S,F=>({protocol:new b.Protocol(new m(F,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(F,"close"))}))}constructor(E){super(D.toClientConnectionEvent(E)),this.server=E}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=D;function _(A){return new Promise((E,S)=>{const F=(0,d.createServer)();F.on("error",S),F.listen(A,()=>{F.removeListener("error",S),E(new D(F))})})}function C(A,E){return new Promise((S,F)=>{const N=(0,d.createConnection)(A,()=>{N.removeListener("error",F),S(b.Client.fromSocket(new m(N,`ipc-client${E}`),E))});N.once("error",F)})}}),define(Ce[355],Ie([1,0,67,66,191,130,7,3,10,46,11,115,234,236,117,92,21]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0,r=$e(r),d=$e(d);async function p(o,n,h,c,g){let w;for(let D=3;D&&(w?.dispose(),w=await new f(o,n,h,c,g).waitForReady(),!(g&&P.BROWSER_RESTRICTED_PORTS[g]||!P.BROWSER_RESTRICTED_PORTS[w.tunnelLocalPort]));D--);return w}class f extends R.Disposable{constructor(n,h,c,g,w){super(),this.defaultTunnelHost=h,this.suggestedLocalPort=w,this.privacy=a.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=n,this._server=r.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=D=>this._onConnection(D),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=g,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){const n=this.suggestedLocalPort??this.tunnelRemotePort,h=(0,a.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let c=await(0,P.findFreePortFaster)(n,2,1e3,h),g=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address(),g||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async _onConnection(n){n.pause();const h=(0,a.isLocalhost)(this.tunnelRemoteHost)||(0,a.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,u.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),g=c.getSocket(),w=c.readEntireBuffer();c.dispose(),w.byteLength>0&&n.write(w.buffer),n.on("end",()=>{n.localAddress&&this._socketsDispose.delete(n.localAddress),g.end()}),n.on("close",()=>g.end()),n.on("error",()=>{n.localAddress&&this._socketsDispose.delete(n.localAddress),g instanceof k.NodeSocket?g.socket.destroy():g.end()}),g instanceof k.NodeSocket?this._mirrorNodeSocket(n,g):this._mirrorGenericSocket(n,g),n.localAddress&&this._socketsDispose.set(n.localAddress,()=>{n.end(),g.end()})}_mirrorGenericSocket(n,h){h.onClose(()=>n.destroy()),h.onEnd(()=>n.end()),h.onData(c=>n.write(c.buffer)),n.on("data",c=>h.write(m.VSBuffer.wrap(c))),n.resume()}_mirrorNodeSocket(n,h){const c=h.socket;c.on("end",()=>n.end()),c.on("close",()=>n.end()),c.on("error",()=>{n.destroy()}),c.pipe(n),n.pipe(c)}}e.NodeRemoteTunnel=f;let i=class extends a.AbstractTunnelService{constructor(n,h,c,g,w){super(h,w),this.remoteSocketFactoryService=n,this.signService=c,this.productService=g}isPortPrivileged(n){return(0,a.isPortPrivileged)(n,this.defaultTunnelHost,v.OS,d.release())}retainOrCreateTunnel(n,h,c,g,w,D,_,C){const A=this.getTunnelFromMap(h,c);if(A)return++A.refcount,A.value;if((0,a.isTunnelProvider)(n))return this.createWithProvider(n,h,c,w,D,_,C);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${c} on local port ${w}.`);const E={commit:this.productService.commit,quality:this.productService.quality,addressProvider:n,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},S=p(E,g,h,c,w);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,c,S),S}}};e.BaseTunnelService=i,e.BaseTunnelService=i=Xe([He(0,T.IRemoteSocketFactoryService),He(1,I.ILogService),He(2,b.ISignService),He(3,y.IProductService),He(4,l.IConfigurationService)],i);let s=class extends i{constructor(n,h,c,g,w){super(n,h,c,g,w)}};e.TunnelService=s,e.TunnelService=s=Xe([He(0,T.IRemoteSocketFactoryService),He(1,I.ILogService),He(2,b.ISignService),He(3,y.IProductService),He(4,l.IConfigurationService)],s);let t=class extends R.Disposable{constructor(n,h,c,g,w){super(),this.remoteSocketFactoryService=n,this.logService=h,this.productService=c,this.signService=g,this.configurationService=w,this._tunnelServices=new Map}async openTunnel(n,h,c,g,w,D,_,C,A){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${g} on local port ${D}.`),!this._tunnelServices.has(n)){const E=new s(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(E),this._tunnelServices.set(n,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this._tunnelServices.delete(n))})}return this._tunnelServices.get(n).openTunnel(h,c,g,w,D,_,C,A)}};e.SharedTunnelsService=t,e.SharedTunnelsService=t=Xe([He(0,T.IRemoteSocketFactoryService),He(1,I.ILogService),He(2,y.IProductService),He(3,b.ISignService),He(4,l.IConfigurationService)],t)}),define(Ce[356],Ie([1,0,130,253,45,34,2,11,47]),function(pe,e,r,d,P,k,L,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0,d=$e(d),P=$e(P);class l{constructor(u,T,b){this._commands=u,this.logService=T,this._ipcHandlePath=b,this._server=d.createServer((a,m)=>this.onRequest(a,m)),this.setup().catch(a=>(T.error(a),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,T){const b=(m,p)=>{T.writeHead(m,{"content-type":"application/json"}),T.end(JSON.stringify(p||null),f=>f&&this.logService.error(f))},a=[];u.setEncoding("utf8"),u.on("data",m=>a.push(m)),u.on("end",async()=>{try{const m=JSON.parse(a.join(""));let p;switch(m.type){case"open":p=await this.open(m);break;case"openExternal":p=await this.openExternal(m);break;case"status":p=await this.getStatus(m);break;case"extensionManagement":p=await this.manageExtensions(m);break;default:b(404,`Unknown message type: ${m.type}`);break}b(200,p)}catch(m){const p=m instanceof Error?m.message:JSON.stringify(m);b(500,p),this.logService.error("Error while processing pipe request",m)}})}async open(u){const{fileURIs:T,folderURIs:b,forceNewWindow:a,diffMode:m,mergeMode:p,addMode:f,forceReuseWindow:i,gotoLineMode:s,waitMarkerFilePath:t,remoteAuthority:o}=u,n=[];if(Array.isArray(b))for(const w of b)try{n.push({folderUri:L.URI.parse(w)})}catch{}if(Array.isArray(T))for(const w of T)try{(0,v.hasWorkspaceFileExtension)(w)?n.push({workspaceUri:L.URI.parse(w)}):n.push({fileUri:L.URI.parse(w)})}catch{}const h=t?L.URI.file(t):void 0,g={forceNewWindow:a,diffMode:m,mergeMode:p,addMode:f,gotoLineMode:s,forceReuseWindow:i,preferNewWindow:!i&&!h&&!f,waitMarkerFileURI:h,remoteAuthority:o};this._commands.executeCommand("_remoteCLI.windowOpen",n,g)}async openExternal(u){for(const T of u.uris){const b=L.URI.parse(T),a=b.scheme==="file"?b:T;await this._commands.executeCommand("_remoteCLI.openExternal",a)}}async manageExtensions(u){const T=a=>a?.map(m=>/\.vsix$/i.test(m)?L.URI.parse(m):m),b={list:u.list,install:T(u.install),uninstall:T(u.uninstall),force:u.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",b)}async getStatus(u){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&P.existsSync(this._ipcHandlePath)&&P.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=l;let I=class extends l{constructor(u,T){super(u,T,(0,r.createRandomIPCHandle)())}};e.CLIServer=I,e.CLIServer=I=Xe([He(0,k.IExtHostCommands),He(1,R.ILogService)],I)}),define(Ce[357],Ie([1,0,61,344,339,252,54,326,2,14,9,356,108,286,325]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0,r=$e(r);class a extends P.RequireInterceptor{_installInterceptor(){const f=this,i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(h,c,g){return h=o(h),f._factories.has(h)?f._factories.get(h).load(h,v.URI.file((0,u.realpathSync)(c.filename)),w=>s.apply(this,[w,c,g])):s.apply(this,arguments)};const t=i._resolveLookupPaths;i._resolveLookupPaths=(n,h)=>t.call(this,o(n),h);const o=n=>{for(const h of f._alternatives){const c=h(n);if(c){n=c;break}}return n}}}class m extends L.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(R.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(y.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this._instaService.createInstance(b.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(a,f,{mine:this._myRegistry,all:this._globalRegistry}).install(),r.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,k.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),r.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(f){return f.main}async _loadCommonJSModule(f,i,s){if(i.scheme!==l.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let t=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this._logService.flush();const o=f?.identifier.value;f&&await this._extHostLocalizationService.initializeLocalizedMessages(f);try{o&&r.mark(`code/extHost/willLoadExtensionCode/${o}`),t=pe.__$__nodeRequire(i.fsPath)}finally{o&&r.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}return t}async $setRemoteEnvironment(f){if(this._initData.remote.isRemote)for(const i in f){const s=f[i];s===null?delete process.env[i]:process.env[i]=s}}}e.ExtHostExtensionService=m}),define(Ce[358],Ie([1,0,45,56,21,4,3,133,10,22,2,33,68,11,233,71,117,92,355,29,19,76,333]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=void 0,e.getSockets=n,e.loadListeningPorts=h,e.parseIpAddress=c,e.loadConnectionTable=g,e.getRootProcesses=D,e.findPorts=_,e.tryFindRootPorts=C,r=$e(r),l=$e(l),y=$e(y);function n(S){const F=S.trim().split(`
`),N=[];return F.forEach(M=>{const U=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(M);U&&U.length>=3&&N.push({pid:parseInt(U[1],10),socket:parseInt(U[2],10)})}),N.reduce((M,U)=>(M[U.socket]=U,M),{})}function h(...S){const F=[].concat(...S.map(g));return[...new Map(F.filter(N=>N.st==="0A").map(N=>{const O=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:c(O[0]),port:parseInt(O[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function c(S){let F="";if(S.length===8)for(let N=S.length-2;N>=0;N-=2)F+=parseInt(S.substr(N,2),16),N!==0&&(F+=".");else for(let N=0;N<S.length;N+=8){const O=S.substring(N,N+8);let M="";for(let U=8;U>=2;U-=2)M+=O.substring(U-2,U),(U===6||U===2)&&(M=parseInt(M,16).toString(16),F+=`${M}`,M="",N+U!==S.length-6&&(F+=":"))}return F}function g(S){const F=S.trim().split(`
`),N=F.shift().trim().split(/\s+/).filter(M=>M!=="rx_queue"&&M!=="tm->when");return F.map(M=>M.trim().split(/\s+/).reduce((U,x,z)=>(U[N[z]||z]=x,U),{}))}function w(S){return!!S.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||S.indexOf("out/server-main.js")!==-1||S.indexOf("_productName=VSCode")!==-1}function D(S){const F=S.trim().split(`
`),N=[];return F.forEach(O=>{const M=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);M&&M.length>=4&&N.push({pid:parseInt(M[1],10),ppid:parseInt(M[2]),cmd:M[3]})}),N}async function _(S,F,N){const O=N.reduce((U,x)=>(U[x.pid]=x,U),{}),M=[];return S.forEach(({socket:U,ip:x,port:z})=>{const B=F[U]?F[U].pid:void 0,ee=B?O[B]?.cmd:void 0;B&&ee&&!w(ee)&&M.push({host:x,port:z,detail:ee,pid:B})}),M}function C(S,F,N){const O=new Map,M=D(F);for(const U of S){const x=N.get(U.port);if(x){O.set(U.port,x);continue}const z=M.find(B=>B.cmd.includes(`${U.port}`));if(z){let B=z,ee;do ee=M.find(V=>V.ppid===B.pid),ee&&(B=ee);while(ee);O.set(U.port,{host:U.ip,port:U.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else O.set(U.port,{host:U.ip,port:U.port,ppid:Number.MAX_VALUE})}return O}let A=class extends t.ExtHostTunnelService{constructor(F,N,O,M){super(F,N,O),this.initData=N,this.signService=M,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,v.isLinux&&N.remote.isRemote&&N.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(F){if(F&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=F;let N;this._initialCandidates&&(N=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const O=new R.MovingAverage;let M=0;for(;this._candidateFindingEnabled;){const U=new Date().getTime(),x=(await this.findCandidatePorts()).filter(ee=>(0,p.isLocalhost)(ee.host)||(0,p.isAllInterfaces)(ee.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${x.map(ee=>ee.port).join(", ")}`);const z=new Date().getTime()-U;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${z} ms.`),M++>3&&O.update(z),(!N||JSON.stringify(N)!==JSON.stringify(x))&&(N=x,await this._proxy.$onFoundNewCandidates(N));const B=this.calculateDelay(O.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${B} ms.`),await new Promise(ee=>setTimeout(()=>ee(),B))}}calculateDelay(F){return Math.max(F*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(F=>F.port).join(", ")}`)}async findCandidatePorts(){let F="",N="";try{F=await r.promises.readFile("/proc/net/tcp","utf8"),N=await r.promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=h(F,N),M=await new Promise(G=>{(0,d.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,le,ne)=>{G(le)})}),U=n(M),x=await y.Promises.readdir("/proc"),z=[];for(const G of x)try{const Z=Number(G),le=l.joinPath(I.URI.file("/proc"),G);if((await r.promises.stat(le.fsPath)).isDirectory()&&!isNaN(Z)){const _e=await r.promises.readlink(l.joinPath(le,"cwd").fsPath),ge=await r.promises.readFile(l.joinPath(le,"cmdline").fsPath,"utf8");z.push({pid:Z,cwd:_e,cmd:ge})}}catch{}const B=[],ee=O.filter(G=>{const Z=U[G.socket];return Z||B.push(G),Z}),V=_(ee,U,z);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const G=await new Promise(Z=>{(0,d.exec)("ps -F -A -l | grep root",(le,ne,_e)=>{Z(ne)})});this._foundRootPorts=C(B,G,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.map(Z=>Z.port).join(", ")}`)}return V.then(G=>$?G.concat($):G)}makeManagedTunnelFactory(F){return async N=>{const O=new f.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(U,x,z,B){const ee=await F.makeConnection();return E.connect(ee,x,z,B)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new a.ManagedRemoteConnection(0),connectionToken:F.connectionToken})}},signService:this.signService},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await O.waitForReady();const M=new k.Emitter;return{localAddress:(0,o.parseAddress)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:M.event,dispose:()=>{O.dispose(),M.fire(),M.dispose()}}}}};e.NodeExtHostTunnelService=A,e.NodeExtHostTunnelService=A=Xe([He(0,s.IExtHostRpcService),He(1,i.IExtHostInitDataService),He(2,T.ILogService),He(3,m.ISignService)],A);class E extends b.ManagedSocket{static connect(F,N,O,M){const U=new L.DisposableStore,x={onClose:U.add(new k.Emitter),onData:U.add(new k.Emitter),onEnd:U.add(new k.Emitter)};U.add(F.onDidReceiveMessage(B=>x.onData.fire(P.VSBuffer.wrap(B)))),U.add(F.onDidEnd(()=>x.onEnd.fire())),U.add(F.onDidClose(B=>x.onClose.fire({type:u.SocketCloseEventType.NodeSocketCloseEvent,error:B,hadError:!!B})));const z=new E(F,M,x);return z._register(U),(0,b.connectManagedSocket)(z,N,O,M,x)}constructor(F,N,O){super(N,O),this.passing=F}write(F){this.passing.send(F.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(Ce[359],Ie([1,0,88,328,342,341,354,357,358,101,54,102,100,48,76,97,327,287,11,343,64,248,112,117,148]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p,f,i,s,t,o,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(I.IExtHostExtensionService,R.ExtHostExtensionService,r.InstantiationType.Eager),(0,r.registerSingleton)(f.ILoggerService,p.ExtHostLoggerService,r.InstantiationType.Delayed),(0,r.registerSingleton)(f.ILogService,new o.SyncDescriptor(t.ExtHostLogService,[!1],!0)),(0,r.registerSingleton)(n.ISignService,h.SignService,r.InstantiationType.Delayed),(0,r.registerSingleton)(a.IExtensionStoragePaths,m.ExtensionStoragePaths,r.InstantiationType.Eager),(0,r.registerSingleton)(l.IExtHostDebugService,k.ExtHostDebugService,r.InstantiationType.Eager),(0,r.registerSingleton)(y.IExtHostSearch,L.NativeExtHostSearch,r.InstantiationType.Eager),(0,r.registerSingleton)(u.IExtHostTask,P.ExtHostTask,r.InstantiationType.Eager),(0,r.registerSingleton)(T.IExtHostTerminalService,d.ExtHostTerminalService,r.InstantiationType.Eager),(0,r.registerSingleton)(b.IExtHostTunnelService,v.NodeExtHostTunnelService,r.InstantiationType.Eager),(0,r.registerSingleton)(s.IExtHostVariableResolverProvider,i.NodeExtHostVariableResolverProviderService,r.InstantiationType.Eager)});var Wt=this&&this.__importDefault||function(pe){return pe&&pe.__esModule?pe:{default:pe}};define(Ce[369],Ie([1,0,370,67,7,21,13,61,108,33,68,130,113,231,340,254,269,93,345,359]),function(pe,e,r,d,P,k,L,R,v,l,I,y,u,T,b,a,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Wt(r),d=$e(d),R=$e(R),T=Wt(T),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const f=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const w=globalThis._VSCODE_NODE_MODULES.module,D=w._load;w._load=function(_){if(_==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const i=process.exit.bind(process),s=process.on.bind(process);function t(w){process.exit=function(D){if(w)i(D);else{const _=new Error("An extension called process.exit() and this was prevented.");console.warn(_.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,_){D==="uncaughtException"&&(_=function(){try{return _.call(void 0,arguments)}catch{}}),s(D,_)}}let o=function(w){i()};function n(){const w=(0,m.readExtHostConnection)(process.env);if(w.type===m.ExtHostConnectionType.MessagePort)return new Promise((D,_)=>{const C=A=>{const E=A[0],S=new I.BufferedEmitter;E.on("message",F=>S.fire(k.VSBuffer.wrap(F.data))),E.on("close",()=>{o("renderer closed the MessagePort")}),E.start(),D({onMessage:S.event,send:F=>E.postMessage(F.buffer)})};process.parentPort.on("message",A=>C(A.ports))});if(w.type===m.ExtHostConnectionType.Socket)return new Promise((D,_)=>{let C=null;const A=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=I.ProtocolConstants.ReconnectionGraceTime,S=I.ProtocolConstants.ReconnectionShortGraceTime,F=new P.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),E),N=new P.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),S);process.on("message",(M,U)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const x=k.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let z;if(M.skipWebSocketFrames)z=new y.NodeSocket(U,"extHost-socket");else{const B=k.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));z=new y.WebSocketNodeSocket(new y.NodeSocket(U,"extHost-socket"),M.permessageDeflate,B,!1)}C?(F.cancel(),N.cancel(),C.beginAcceptReconnection(z,x),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(A),C=new I.PersistentProtocol({socket:z,initialChunk:x}),C.sendResume(),C.onDidDispose(()=>o("renderer disconnected")),D(C),C.onSocketClose(()=>{F.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;F.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const D=w.pipeName;return new Promise((_,C)=>{const A=d.createConnection(D,()=>{A.removeListener("error",C);const E=new I.PersistentProtocol({socket:new y.NodeSocket(A,"extHost-renderer")});E.sendResume(),_(E)});A.once("error",C),A.on("close",()=>{o("renderer closed the socket")})})}}async function h(){const w=await n();return new class{constructor(){this._onMessage=new I.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,this._protocolListener=w.onMessage(D=>{(0,p.isMessageOfType)(D,p.MessageType.Terminate)?(this._terminating=!0,this._protocolListener.dispose(),o("received terminate message from renderer")):this._onMessage.fire(D)})}send(D){this._terminating||w.send(D)}async drain(){if(w.drain)return w.drain()}}}function c(w){return new Promise(D=>{const _=w.onMessage(C=>{_.dispose();const A=JSON.parse(C.toString()),E=A.commit,S=T.default.commit;if(E&&S&&E!==S&&i(p.ExtensionHostExitCode.VersionMismatch),A.parentPid){let F=0;setInterval(function(){try{process.kill(A.parentPid,0),F=0}catch(O){O&&O.code==="EPERM"?(F++,F>=3&&o(`parent process ${A.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):o(`parent process ${A.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(A.parentPid)}catch(O){(0,L.onUnexpectedError)(O)}}w.send((0,p.createMessageOfType)(p.MessageType.Initialized)),D({protocol:w,initData:A})});w.send((0,p.createMessageOfType)(p.MessageType.Ready))})}async function g(){const w=[];process.on("unhandledRejection",(F,N)=>{w.push(N),setTimeout(()=>{const O=w.indexOf(N);O>=0&&N.catch(M=>{w.splice(O,1),(0,L.isCancellationError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),F&&(0,L.onUnexpectedError)(F))})},1e3)}),process.on("rejectionHandled",F=>{const N=w.indexOf(F);N>=0&&w.splice(N,1)}),process.on("uncaughtException",function(F){(0,L.isSigPipeError)(F)||(0,L.onUnexpectedError)(F)}),R.mark("code/extHost/willConnectToRenderer");const D=await h();R.mark("code/extHost/didConnectToRenderer");const _=await c(D);R.mark("code/extHost/didWaitForInitData");const{initData:C}=_;t(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,u.boolean)(f.skipWorkspaceStorageLock,!1);const A=new class{constructor(){this.pid=process.pid}exit(N){i(N)}fsExists(N){return l.Promises.exists(N)}fsRealpath(N){return(0,v.realpath)(N)}};let E=null;C.remote.authority&&f.transformURIs&&(E=(0,a.createURITransformer)(C.remote.authority));const S=new b.ExtensionHostMain(_.protocol,C,A,E);o=F=>S.terminate(F)}g().catch(w=>console.log(w))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/workbench/api/node/extensionHostProcess.js.map
