/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Le=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ne=function(Se){for(var e=[],S=0,k=Se.length;S<k;S++)e[S]=Le[Se[S]];return e};define(Le[71],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=k,e.debounce=P,e.throttle=O;function S(A){return(R,p,o)=>{let I=null,w=null;if(typeof o.value=="function"?(I="value",w=o.value):typeof o.get=="function"&&(I="get",w=o.get),!w)throw new Error("not supported");o[I]=A(w,p)}}function k(A,R,p){let o=null,I=null;if(typeof p.value=="function"?(o="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(o="get",I=p.get),!I)throw new Error("not supported");const w=`$memoize$${R}`;p[o]=function(...a){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,a)}),this[w]}}function P(A,R,p){return S((o,I)=>{const w=`$debounce$${I}`,a=`$debounce$result$${I}`;return function(...y){this[a]||(this[a]=p?p():void 0),clearTimeout(this[w]),R&&(this[a]=R(this[a],...y),y=[this[a]]),this[w]=setTimeout(()=>{o.apply(this,y),this[a]=p?p():void 0},A)}})}function O(A,R,p){return S((o,I)=>{const w=`$throttle$timer$${I}`,a=`$throttle$result$${I}`,y=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...r){if(this[a]||(this[a]=p?p():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),R&&(this[a]=R(this[a],...r)),this[h])return;const s=this[y]+A;s<=Date.now()?(this[y]=Date.now(),o.apply(this,[this[a]]),this[a]=p?p():void 0):(this[h]=!0,this[w]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),o.apply(this,[this[a]]),this[a]=p?p():void 0},s-Date.now()))}})}});var jn=this&&this.__createBinding||(Object.create?function(Se,e,S,k){k===void 0&&(k=S);var P=Object.getOwnPropertyDescriptor(e,S);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[S]}}),Object.defineProperty(Se,k,P)}:function(Se,e,S,k){k===void 0&&(k=S),Se[k]=e[S]}),Kn=this&&this.__setModuleDefault||(Object.create?function(Se,e){Object.defineProperty(Se,"default",{enumerable:!0,value:e})}:function(Se,e){Se.default=e}),We=this&&this.__importStar||function(Se){if(Se&&Se.__esModule)return Se;var e={};if(Se!=null)for(var S in Se)S!=="default"&&Object.prototype.hasOwnProperty.call(Se,S)&&jn(e,Se,S);return Kn(e,Se),e};define(Le[135],Ne([1,0,17]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=P,e.jsonStringifyEquals=O,e.itemEquals=A,e.equalsIfDefined=R,e.structuralEquals=p,e.getStructuralKey=o,S=We(S);const k=(y,h)=>y===h;e.strictEquals=k;function P(y=e.strictEquals){return(h,r)=>S.equals(h,r,y)}function O(){return(y,h)=>JSON.stringify(y)===JSON.stringify(h)}function A(){return(y,h)=>y.equals(h)}function R(y,h,r){if(r!==void 0){const s=y;return s==null||h===void 0||h===null?h===s:r(s,h)}else{const s=y;return(l,c)=>l==null||c===void 0||c===null?c===l:s(l,c)}}function p(y,h){if(y===h)return!0;if(Array.isArray(y)&&Array.isArray(h)){if(y.length!==h.length)return!1;for(let r=0;r<y.length;r++)if(!p(y[r],h[r]))return!1;return!0}if(y&&typeof y=="object"&&h&&typeof h=="object"&&Object.getPrototypeOf(y)===Object.prototype&&Object.getPrototypeOf(h)===Object.prototype){const r=y,s=h,l=Object.keys(r),c=Object.keys(s),i=new Set(c);if(l.length!==c.length)return!1;for(const n of l)if(!i.has(n)||!p(r[n],s[n]))return!1;return!0}return!1}function o(y){return JSON.stringify(a(y))}let I=0;const w=new WeakMap;function a(y){if(Array.isArray(y))return y.map(a);if(y&&typeof y=="object")if(Object.getPrototypeOf(y)===Object.prototype){const h=y,r=Object.create(null);for(const s of Object.keys(h).sort())r[s]=a(h[s]);return r}else{let h=w.get(y);return h===void 0&&(h=I++,w.set(y,h)),h+"----2b76a038c20c4bcc"}return y}}),define(Le[96],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class S{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=S,e.defaultGenerator=new S("id#")}),define(Le[136],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=A,e.getLocation=w,e.parse=a,e.parseTree=y,e.findNodeAtLocation=h,e.getNodePath=r,e.getNodeValue=s,e.contains=l,e.findNodeAtOffset=c,e.visit=i,e.getNodeType=n;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k||(e.SyntaxKind=k={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,g=!1){let u=0;const v=t.length;let m="",d=0,C=k.Unknown,_=S.None;function E(N){let W=0,j=0;for(;W<N;){const $=t.charCodeAt(u);if($>=I._0&&$<=I._9)j=j*16+$-I._0;else if($>=I.A&&$<=I.F)j=j*16+$-I.A+10;else if($>=I.a&&$<=I.f)j=j*16+$-I.a+10;else break;u++,W++}return W<N&&(j=-1),j}function T(N){u=N,m="",d=0,C=k.Unknown,_=S.None}function D(){const N=u;if(t.charCodeAt(u)===I._0)u++;else for(u++;u<t.length&&o(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===I.dot)if(u++,u<t.length&&o(t.charCodeAt(u)))for(u++;u<t.length&&o(t.charCodeAt(u));)u++;else return _=S.UnexpectedEndOfNumber,t.substring(N,u);let W=u;if(u<t.length&&(t.charCodeAt(u)===I.E||t.charCodeAt(u)===I.e))if(u++,(u<t.length&&t.charCodeAt(u)===I.plus||t.charCodeAt(u)===I.minus)&&u++,u<t.length&&o(t.charCodeAt(u))){for(u++;u<t.length&&o(t.charCodeAt(u));)u++;W=u}else _=S.UnexpectedEndOfNumber;return t.substring(N,W)}function f(){let N="",W=u;for(;;){if(u>=v){N+=t.substring(W,u),_=S.UnexpectedEndOfString;break}const j=t.charCodeAt(u);if(j===I.doubleQuote){N+=t.substring(W,u),u++;break}if(j===I.backslash){if(N+=t.substring(W,u),u++,u>=v){_=S.UnexpectedEndOfString;break}switch(t.charCodeAt(u++)){case I.doubleQuote:N+='"';break;case I.backslash:N+="\\";break;case I.slash:N+="/";break;case I.b:N+="\b";break;case I.f:N+="\f";break;case I.n:N+=`
`;break;case I.r:N+="\r";break;case I.t:N+="	";break;case I.u:{const K=E(4);K>=0?N+=String.fromCharCode(K):_=S.InvalidUnicode;break}default:_=S.InvalidEscapeCharacter}W=u;continue}if(j>=0&&j<=31)if(p(j)){N+=t.substring(W,u),_=S.UnexpectedEndOfString;break}else _=S.InvalidCharacter;u++}return N}function b(){if(m="",_=S.None,d=u,u>=v)return d=v,C=k.EOF;let N=t.charCodeAt(u);if(R(N)){do u++,m+=String.fromCharCode(N),N=t.charCodeAt(u);while(R(N));return C=k.Trivia}if(p(N))return u++,m+=String.fromCharCode(N),N===I.carriageReturn&&t.charCodeAt(u)===I.lineFeed&&(u++,m+=`
`),C=k.LineBreakTrivia;switch(N){case I.openBrace:return u++,C=k.OpenBraceToken;case I.closeBrace:return u++,C=k.CloseBraceToken;case I.openBracket:return u++,C=k.OpenBracketToken;case I.closeBracket:return u++,C=k.CloseBracketToken;case I.colon:return u++,C=k.ColonToken;case I.comma:return u++,C=k.CommaToken;case I.doubleQuote:return u++,m=f(),C=k.StringLiteral;case I.slash:{const W=u-1;if(t.charCodeAt(u+1)===I.slash){for(u+=2;u<v&&!p(t.charCodeAt(u));)u++;return m=t.substring(W,u),C=k.LineCommentTrivia}if(t.charCodeAt(u+1)===I.asterisk){u+=2;const j=v-1;let $=!1;for(;u<j;){if(t.charCodeAt(u)===I.asterisk&&t.charCodeAt(u+1)===I.slash){u+=2,$=!0;break}u++}return $||(u++,_=S.UnexpectedEndOfComment),m=t.substring(W,u),C=k.BlockCommentTrivia}return m+=String.fromCharCode(N),u++,C=k.Unknown}case I.minus:if(m+=String.fromCharCode(N),u++,u===v||!o(t.charCodeAt(u)))return C=k.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return m+=D(),C=k.NumericLiteral;default:for(;u<v&&M(N);)u++,N=t.charCodeAt(u);if(d!==u){switch(m=t.substring(d,u),m){case"true":return C=k.TrueKeyword;case"false":return C=k.FalseKeyword;case"null":return C=k.NullKeyword}return C=k.Unknown}return m+=String.fromCharCode(N),u++,C=k.Unknown}}function M(N){if(R(N)||p(N))return!1;switch(N){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function L(){let N;do N=b();while(N>=k.LineCommentTrivia&&N<=k.Trivia);return N}return{setPosition:T,getPosition:()=>u,scan:g?L:b,getToken:()=>C,getTokenValue:()=>m,getTokenOffset:()=>d,getTokenLength:()=>u-d,getTokenError:()=>_}}function R(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function o(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function w(t,g){const u=[],v=new Object;let m;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let C=!1;function _(E,T,D,f){d.value=E,d.offset=T,d.length=D,d.type=f,d.colonOffset=void 0,m=d}try{i(t,{onObjectBegin:(E,T)=>{if(g<=E)throw v;m=void 0,C=g>E,u.push("")},onObjectProperty:(E,T,D)=>{if(g<T||(_(E,T,D,"property"),u[u.length-1]=E,g<=T+D))throw v},onObjectEnd:(E,T)=>{if(g<=E)throw v;m=void 0,u.pop()},onArrayBegin:(E,T)=>{if(g<=E)throw v;m=void 0,u.push(0)},onArrayEnd:(E,T)=>{if(g<=E)throw v;m=void 0,u.pop()},onLiteralValue:(E,T,D)=>{if(g<T||(_(E,T,D,n(E)),g<=T+D))throw v},onSeparator:(E,T,D)=>{if(g<=T)throw v;if(E===":"&&m&&m.type==="property")m.colonOffset=T,C=!1,m=void 0;else if(E===","){const f=u[u.length-1];typeof f=="number"?u[u.length-1]=f+1:(C=!0,u[u.length-1]=""),m=void 0}}})}catch(E){if(E!==v)throw E}return{path:u,previousNode:m,isAtPropertyKey:C,matches:E=>{let T=0;for(let D=0;T<E.length&&D<u.length;D++)if(E[T]===u[D]||E[T]==="*")T++;else if(E[T]!=="**")return!1;return T===E.length}}}function a(t,g=[],u=O.DEFAULT){let v=null,m=[];const d=[];function C(E){Array.isArray(m)?m.push(E):v!==null&&(m[v]=E)}return i(t,{onObjectBegin:()=>{const E={};C(E),d.push(m),m=E,v=null},onObjectProperty:E=>{v=E},onObjectEnd:()=>{m=d.pop()},onArrayBegin:()=>{const E=[];C(E),d.push(m),m=E,v=null},onArrayEnd:()=>{m=d.pop()},onLiteralValue:C,onError:(E,T,D)=>{g.push({error:E,offset:T,length:D})}},u),m[0]}function y(t,g=[],u=O.DEFAULT){let v={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(E){v.type==="property"&&(v.length=E-v.offset,v=v.parent)}function d(E){return v.children.push(E),E}i(t,{onObjectBegin:E=>{v=d({type:"object",offset:E,length:-1,parent:v,children:[]})},onObjectProperty:(E,T,D)=>{v=d({type:"property",offset:T,length:-1,parent:v,children:[]}),v.children.push({type:"string",value:E,offset:T,length:D,parent:v})},onObjectEnd:(E,T)=>{v.length=E+T-v.offset,v=v.parent,m(E+T)},onArrayBegin:(E,T)=>{v=d({type:"array",offset:E,length:-1,parent:v,children:[]})},onArrayEnd:(E,T)=>{v.length=E+T-v.offset,v=v.parent,m(E+T)},onLiteralValue:(E,T,D)=>{d({type:n(E),offset:T,length:D,parent:v,value:E}),m(T+D)},onSeparator:(E,T,D)=>{v.type==="property"&&(E===":"?v.colonOffset=T:E===","&&m(T))},onError:(E,T,D)=>{g.push({error:E,offset:T,length:D})}},u);const _=v.children[0];return _&&delete _.parent,_}function h(t,g){if(!t)return;let u=t;for(const v of g)if(typeof v=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const d of u.children)if(Array.isArray(d.children)&&d.children[0].value===v){u=d.children[1],m=!0;break}if(!m)return}else{const m=v;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}function r(t){if(!t.parent||!t.parent.children)return[];const g=r(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;g.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&g.push(u)}return g}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const g=Object.create(null);for(const u of t.children){const v=u.children[1];v&&(g[u.children[0].value]=s(v))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function l(t,g,u=!1){return g>=t.offset&&g<t.offset+t.length||u&&g===t.offset+t.length}function c(t,g,u=!1){if(l(t,g,u)){const v=t.children;if(Array.isArray(v))for(let m=0;m<v.length&&v[m].offset<=g;m++){const d=c(v[m],g,u);if(d)return d}return t}}function i(t,g,u=O.DEFAULT){const v=A(t,!1);function m(le){return le?()=>le(v.getTokenOffset(),v.getTokenLength()):()=>!0}function d(le){return le?me=>le(me,v.getTokenOffset(),v.getTokenLength()):()=>!0}const C=m(g.onObjectBegin),_=d(g.onObjectProperty),E=m(g.onObjectEnd),T=m(g.onArrayBegin),D=m(g.onArrayEnd),f=d(g.onLiteralValue),b=d(g.onSeparator),M=m(g.onComment),L=d(g.onError),N=u&&u.disallowComments,W=u&&u.allowTrailingComma;function j(){for(;;){const le=v.scan();switch(v.getTokenError()){case S.InvalidUnicode:$(P.InvalidUnicode);break;case S.InvalidEscapeCharacter:$(P.InvalidEscapeCharacter);break;case S.UnexpectedEndOfNumber:$(P.UnexpectedEndOfNumber);break;case S.UnexpectedEndOfComment:N||$(P.UnexpectedEndOfComment);break;case S.UnexpectedEndOfString:$(P.UnexpectedEndOfString);break;case S.InvalidCharacter:$(P.InvalidCharacter);break}switch(le){case k.LineCommentTrivia:case k.BlockCommentTrivia:N?$(P.InvalidCommentToken):M();break;case k.Unknown:$(P.InvalidSymbol);break;case k.Trivia:case k.LineBreakTrivia:break;default:return le}}}function $(le,me=[],oe=[]){if(L(le),me.length+oe.length>0){let De=v.getToken();for(;De!==k.EOF;){if(me.indexOf(De)!==-1){j();break}else if(oe.indexOf(De)!==-1)break;De=j()}}}function K(le){const me=v.getTokenValue();return le?f(me):_(me),j(),!0}function q(){switch(v.getToken()){case k.NumericLiteral:{let le=0;try{le=JSON.parse(v.getTokenValue()),typeof le!="number"&&($(P.InvalidNumberFormat),le=0)}catch{$(P.InvalidNumberFormat)}f(le);break}case k.NullKeyword:f(null);break;case k.TrueKeyword:f(!0);break;case k.FalseKeyword:f(!1);break;default:return!1}return j(),!0}function ae(){return v.getToken()!==k.StringLiteral?($(P.PropertyNameExpected,[],[k.CloseBraceToken,k.CommaToken]),!1):(K(!1),v.getToken()===k.ColonToken?(b(":"),j(),Z()||$(P.ValueExpected,[],[k.CloseBraceToken,k.CommaToken])):$(P.ColonExpected,[],[k.CloseBraceToken,k.CommaToken]),!0)}function Ee(){C(),j();let le=!1;for(;v.getToken()!==k.CloseBraceToken&&v.getToken()!==k.EOF;){if(v.getToken()===k.CommaToken){if(le||$(P.ValueExpected,[],[]),b(","),j(),v.getToken()===k.CloseBraceToken&&W)break}else le&&$(P.CommaExpected,[],[]);ae()||$(P.ValueExpected,[],[k.CloseBraceToken,k.CommaToken]),le=!0}return E(),v.getToken()!==k.CloseBraceToken?$(P.CloseBraceExpected,[k.CloseBraceToken],[]):j(),!0}function ce(){T(),j();let le=!1;for(;v.getToken()!==k.CloseBracketToken&&v.getToken()!==k.EOF;){if(v.getToken()===k.CommaToken){if(le||$(P.ValueExpected,[],[]),b(","),j(),v.getToken()===k.CloseBracketToken&&W)break}else le&&$(P.CommaExpected,[],[]);Z()||$(P.ValueExpected,[],[k.CloseBracketToken,k.CommaToken]),le=!0}return D(),v.getToken()!==k.CloseBracketToken?$(P.CloseBracketExpected,[k.CloseBracketToken],[]):j(),!0}function Z(){switch(v.getToken()){case k.OpenBracketToken:return ce();case k.OpenBraceToken:return Ee();case k.StringLiteral:return K(!0);default:return q()}}return j(),v.getToken()===k.EOF?u.allowEmptyContent?!0:($(P.ValueExpected,[],[]),!1):Z()?(v.getToken()!==k.EOF&&$(P.EndOfFileExpected,[],[]),!0):($(P.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Le[137],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCompressedContent=S;function S(O){let A=!1;const R=new Map,p=new Map;if(P(O,r=>{if(O===r)return!0;const s=JSON.stringify(r);if(s.length<30)return!0;const l=R.get(s);if(!l){const c={schemas:[r]};return R.set(s,c),p.set(r,c),!0}return l.schemas.push(r),p.set(r,l),A=!0,!1}),R.clear(),!A)return JSON.stringify(O);let I="$defs";for(;O.hasOwnProperty(I);)I+="_";const w=[];function a(r){return JSON.stringify(r,(s,l)=>{if(l!==r){const c=p.get(l);if(c&&c.schemas.length>1)return c.id||(c.id=`_${w.length}`,w.push(c.schemas[0])),{$ref:`#/${I}/${c.id}`}}return l})}const y=a(O),h=[];for(let r=0;r<w.length;r++)h.push(`"_${r}":${a(w[r])}`);return h.length?`${y.substring(0,y.length-1)},"${I}":{${h.join(",")}}}`:y}function k(O){return typeof O=="object"&&O!==null}function P(O,A){if(!O||typeof O!="object")return;const R=(...y)=>{for(const h of y)k(h)&&w.push(h)},p=(...y)=>{for(const h of y)if(k(h))for(const r in h){const s=h[r];k(s)&&w.push(s)}},o=(...y)=>{for(const h of y)if(Array.isArray(h))for(const r of h)k(r)&&w.push(r)},I=y=>{if(Array.isArray(y))for(const h of y)k(h)&&w.push(h);else k(y)&&w.push(y)},w=[O];let a=w.pop();for(;a;)A(a)&&(R(a.additionalItems,a.additionalProperties,a.not,a.contains,a.propertyNames,a.if,a.then,a.else,a.unevaluatedItems,a.unevaluatedProperties),p(a.definitions,a.$defs,a.properties,a.patternProperties,a.dependencies,a.dependentSchemas),o(a.anyOf,a.allOf,a.oneOf,a.prefixItems),I(a.items)),a=w.pop()}}),function(Se,e){typeof define=="function"&&define.amd?define(Le[138],Ne([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(Se=typeof globalThis<"u"?globalThis:Se||self,e(Se.marked={}))}(this,function(Se){"use strict";function e(fe,be){for(var de=0;de<be.length;de++){var X=be[de];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(fe,X.key,X)}}function S(fe,be,de){return be&&e(fe.prototype,be),de&&e(fe,de),Object.defineProperty(fe,"prototype",{writable:!1}),fe}function k(fe,be){if(fe){if(typeof fe=="string")return P(fe,be);var de=Object.prototype.toString.call(fe).slice(8,-1);if(de==="Object"&&fe.constructor&&(de=fe.constructor.name),de==="Map"||de==="Set")return Array.from(fe);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return P(fe,be)}}function P(fe,be){(be==null||be>fe.length)&&(be=fe.length);for(var de=0,X=new Array(be);de<be;de++)X[de]=fe[de];return X}function O(fe,be){var de=typeof Symbol<"u"&&fe[Symbol.iterator]||fe["@@iterator"];if(de)return(de=de.call(fe)).next.bind(de);if(Array.isArray(fe)||(de=k(fe))||be&&fe&&typeof fe.length=="number"){de&&(fe=de);var X=0;return function(){return X>=fe.length?{done:!0}:{done:!1,value:fe[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Se.defaults=A();function R(fe){Se.defaults=fe}var p=/[&<>"']/,o=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(be){return a[be]};function h(fe,be){if(be){if(p.test(fe))return fe.replace(o,y)}else if(I.test(fe))return fe.replace(w,y);return fe}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(fe){return fe.replace(r,function(be,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var l=/(^|[^\[])\^/g;function c(fe,be){fe=typeof fe=="string"?fe:fe.source,be=be||"";var de={replace:function(J,ve){return ve=ve.source||ve,ve=ve.replace(l,"$1"),fe=fe.replace(J,ve),de},getRegex:function(){return new RegExp(fe,be)}};return de}var i=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(fe,be,de){if(fe){var X;try{X=decodeURIComponent(s(de)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}be&&!n.test(de)&&(de=d(be,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var g={},u=/^[^:]+:\/*[^/]*$/,v=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(fe,be){g[" "+fe]||(u.test(fe)?g[" "+fe]=fe+"/":g[" "+fe]=T(fe,"/",!0)),fe=g[" "+fe];var de=fe.indexOf(":")===-1;return be.substring(0,2)==="//"?de?be:fe.replace(v,"$1")+be:be.charAt(0)==="/"?de?be:fe.replace(m,"$1")+be:fe+be}var C={exec:function(){}};function _(fe){for(var be=1,de,X;be<arguments.length;be++){de=arguments[be];for(X in de)Object.prototype.hasOwnProperty.call(de,X)&&(fe[X]=de[X])}return fe}function E(fe,be){var de=fe.replace(/\|/g,function(ve,pe,Ae){for(var Ue=!1,Ie=pe;--Ie>=0&&Ae[Ie]==="\\";)Ue=!Ue;return Ue?"|":" |"}),X=de.split(/ \|/),J=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>be)X.splice(be);else for(;X.length<be;)X.push("");for(;J<X.length;J++)X[J]=X[J].trim().replace(/\\\|/g,"|");return X}function T(fe,be,de){var X=fe.length;if(X===0)return"";for(var J=0;J<X;){var ve=fe.charAt(X-J-1);if(ve===be&&!de)J++;else if(ve!==be&&de)J++;else break}return fe.slice(0,X-J)}function D(fe,be){if(fe.indexOf(be[1])===-1)return-1;for(var de=fe.length,X=0,J=0;J<de;J++)if(fe[J]==="\\")J++;else if(fe[J]===be[0])X++;else if(fe[J]===be[1]&&(X--,X<0))return J;return-1}function f(fe){fe&&fe.sanitize&&!fe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(fe,be){if(be<1)return"";for(var de="";be>1;)be&1&&(de+=fe),be>>=1,fe+=fe;return de+fe}function M(fe,be,de,X){var J=be.href,ve=be.title?h(be.title):null,pe=fe[1].replace(/\\([\[\]])/g,"$1");if(fe[0].charAt(0)!=="!"){X.state.inLink=!0;var Ae={type:"link",raw:de,href:J,title:ve,text:pe,tokens:X.inlineTokens(pe)};return X.state.inLink=!1,Ae}return{type:"image",raw:de,href:J,title:ve,text:h(pe)}}function L(fe,be){var de=fe.match(/^(\s+)(?:```)/);if(de===null)return be;var X=de[1];return be.split(`
`).map(function(J){var ve=J.match(/^\s+/);if(ve===null)return J;var pe=ve[0];return pe.length>=X.length?J.slice(X.length):J}).join(`
`)}var N=function(){function fe(de){this.options=de||Se.defaults}var be=fe.prototype;return be.space=function(X){var J=this.rules.block.newline.exec(X);if(J&&J[0].length>0)return{type:"space",raw:J[0]}},be.code=function(X){var J=this.rules.block.code.exec(X);if(J){var ve=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?ve:T(ve,`
`)}}},be.fences=function(X){var J=this.rules.block.fences.exec(X);if(J){var ve=J[0],pe=L(ve,J[3]||"");return{type:"code",raw:ve,lang:J[2]?J[2].trim():J[2],text:pe}}},be.heading=function(X){var J=this.rules.block.heading.exec(X);if(J){var ve=J[2].trim();if(/#$/.test(ve)){var pe=T(ve,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(ve=pe.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:ve,tokens:this.lexer.inline(ve)}}},be.hr=function(X){var J=this.rules.block.hr.exec(X);if(J)return{type:"hr",raw:J[0]}},be.blockquote=function(X){var J=this.rules.block.blockquote.exec(X);if(J){var ve=J[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:J[0],tokens:this.lexer.blockTokens(ve,[]),text:ve}}},be.list=function(X){var J=this.rules.block.list.exec(X);if(J){var ve,pe,Ae,Ue,Ie,Pe,Oe,x,B,H,V,re,ge=J[1].trim(),Te=ge.length>1,xe={type:"list",raw:"",ordered:Te,start:Te?+ge.slice(0,-1):"",loose:!1,items:[]};ge=Te?"\\d{1,9}\\"+ge.slice(-1):"\\"+ge,this.options.pedantic&&(ge=Te?ge:"[*+-]");for(var qe=new RegExp("^( {0,3}"+ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(re=!1,!(!(J=qe.exec(X))||this.rules.block.hr.test(X)));){if(ve=J[0],X=X.substring(ve.length),x=J[2].split(`
`,1)[0],B=X.split(`
`,1)[0],this.options.pedantic?(Ue=2,V=x.trimLeft()):(Ue=J[2].search(/[^ ]/),Ue=Ue>4?1:Ue,V=x.slice(Ue),Ue+=J[1].length),Pe=!1,!x&&/^ *$/.test(B)&&(ve+=B+`
`,X=X.substring(B.length+1),re=!0),!re)for(var Ze=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");X&&(H=X.split(`
`,1)[0],x=H,this.options.pedantic&&(x=x.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(x)||et.test(x)||Ze.test(x)||tt.test(X)));){if(x.search(/[^ ]/)>=Ue||!x.trim())V+=`
`+x.slice(Ue);else if(!Pe)V+=`
`+x;else break;!Pe&&!x.trim()&&(Pe=!0),ve+=H+`
`,X=X.substring(H.length+1)}xe.loose||(Oe?xe.loose=!0:/\n *\n *$/.test(ve)&&(Oe=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(V),pe&&(Ae=pe[0]!=="[ ] ",V=V.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:ve,task:!!pe,checked:Ae,loose:!1,text:V}),xe.raw+=ve}xe.items[xe.items.length-1].raw=ve.trimRight(),xe.items[xe.items.length-1].text=V.trimRight(),xe.raw=xe.raw.trimRight();var rt=xe.items.length;for(Ie=0;Ie<rt;Ie++){this.lexer.state.top=!1,xe.items[Ie].tokens=this.lexer.blockTokens(xe.items[Ie].text,[]);var ft=xe.items[Ie].tokens.filter(function(st){return st.type==="space"}),ct=ft.every(function(st){for(var lt=st.raw.split(""),mt=0,vt=O(lt),$e;!($e=vt()).done;){var Be=$e.value;if(Be===`
`&&(mt+=1),mt>1)return!0}return!1});!xe.loose&&ft.length&&ct&&(xe.loose=!0,xe.items[Ie].loose=!0)}return xe}},be.html=function(X){var J=this.rules.block.html.exec(X);if(J){var ve={type:"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:J[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(J[0]):h(J[0]);ve.type="paragraph",ve.text=pe,ve.tokens=this.lexer.inline(pe)}return ve}},be.def=function(X){var J=this.rules.block.def.exec(X);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var ve=J[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ve,raw:J[0],href:J[2],title:J[3]}}},be.table=function(X){var J=this.rules.block.table.exec(X);if(J){var ve={type:"table",header:E(J[1]).map(function(Oe){return{text:Oe}}),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:J[3]&&J[3].trim()?J[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ve.header.length===ve.align.length){ve.raw=J[0];var pe=ve.align.length,Ae,Ue,Ie,Pe;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test(ve.align[Ae])?ve.align[Ae]="right":/^ *:-+: *$/.test(ve.align[Ae])?ve.align[Ae]="center":/^ *:-+ *$/.test(ve.align[Ae])?ve.align[Ae]="left":ve.align[Ae]=null;for(pe=ve.rows.length,Ae=0;Ae<pe;Ae++)ve.rows[Ae]=E(ve.rows[Ae],ve.header.length).map(function(Oe){return{text:Oe}});for(pe=ve.header.length,Ue=0;Ue<pe;Ue++)ve.header[Ue].tokens=this.lexer.inline(ve.header[Ue].text);for(pe=ve.rows.length,Ue=0;Ue<pe;Ue++)for(Pe=ve.rows[Ue],Ie=0;Ie<Pe.length;Ie++)Pe[Ie].tokens=this.lexer.inline(Pe[Ie].text);return ve}}},be.lheading=function(X){var J=this.rules.block.lheading.exec(X);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1],tokens:this.lexer.inline(J[1])}},be.paragraph=function(X){var J=this.rules.block.paragraph.exec(X);if(J){var ve=J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1];return{type:"paragraph",raw:J[0],text:ve,tokens:this.lexer.inline(ve)}}},be.text=function(X){var J=this.rules.block.text.exec(X);if(J)return{type:"text",raw:J[0],text:J[0],tokens:this.lexer.inline(J[0])}},be.escape=function(X){var J=this.rules.inline.escape.exec(X);if(J)return{type:"escape",raw:J[0],text:h(J[1])}},be.tag=function(X){var J=this.rules.inline.tag.exec(X);if(J)return!this.lexer.state.inLink&&/^<a /i.test(J[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(J[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):h(J[0]):J[0]}},be.link=function(X){var J=this.rules.inline.link.exec(X);if(J){var ve=J[2].trim();if(!this.options.pedantic&&/^</.test(ve)){if(!/>$/.test(ve))return;var pe=T(ve.slice(0,-1),"\\");if((ve.length-pe.length)%2===0)return}else{var Ae=D(J[2],"()");if(Ae>-1){var Ue=J[0].indexOf("!")===0?5:4,Ie=Ue+J[1].length+Ae;J[2]=J[2].substring(0,Ae),J[0]=J[0].substring(0,Ie).trim(),J[3]=""}}var Pe=J[2],Oe="";if(this.options.pedantic){var x=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);x&&(Pe=x[1],Oe=x[3])}else Oe=J[3]?J[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(ve)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),M(J,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},J[0],this.lexer)}},be.reflink=function(X,J){var ve;if((ve=this.rules.inline.reflink.exec(X))||(ve=this.rules.inline.nolink.exec(X))){var pe=(ve[2]||ve[1]).replace(/\s+/g," ");if(pe=J[pe.toLowerCase()],!pe||!pe.href){var Ae=ve[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return M(ve,pe,ve[0],this.lexer)}},be.emStrong=function(X,J,ve){ve===void 0&&(ve="");var pe=this.rules.inline.emStrong.lDelim.exec(X);if(pe&&!(pe[3]&&ve.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&(ve===""||this.rules.inline.punctuation.exec(ve))){var Ue=pe[0].length-1,Ie,Pe,Oe=Ue,x=0,B=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,J=J.slice(-1*X.length+Ue);(pe=B.exec(J))!=null;)if(Ie=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Ie){if(Pe=Ie.length,pe[3]||pe[4]){Oe+=Pe;continue}else if((pe[5]||pe[6])&&Ue%3&&!((Ue+Pe)%3)){x+=Pe;continue}if(Oe-=Pe,!(Oe>0)){if(Pe=Math.min(Pe,Pe+Oe+x),Math.min(Ue,Pe)%2){var H=X.slice(1,Ue+pe.index+Pe);return{type:"em",raw:X.slice(0,Ue+pe.index+Pe+1),text:H,tokens:this.lexer.inlineTokens(H)}}var V=X.slice(2,Ue+pe.index+Pe-1);return{type:"strong",raw:X.slice(0,Ue+pe.index+Pe+1),text:V,tokens:this.lexer.inlineTokens(V)}}}}}},be.codespan=function(X){var J=this.rules.inline.code.exec(X);if(J){var ve=J[2].replace(/\n/g," "),pe=/[^ ]/.test(ve),Ae=/^ /.test(ve)&&/ $/.test(ve);return pe&&Ae&&(ve=ve.substring(1,ve.length-1)),ve=h(ve,!0),{type:"codespan",raw:J[0],text:ve}}},be.br=function(X){var J=this.rules.inline.br.exec(X);if(J)return{type:"br",raw:J[0]}},be.del=function(X){var J=this.rules.inline.del.exec(X);if(J)return{type:"del",raw:J[0],text:J[2],tokens:this.lexer.inlineTokens(J[2])}},be.autolink=function(X,J){var ve=this.rules.inline.autolink.exec(X);if(ve){var pe,Ae;return ve[2]==="@"?(pe=h(this.options.mangle?J(ve[1]):ve[1]),Ae="mailto:"+pe):(pe=h(ve[1]),Ae=pe),{type:"link",raw:ve[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},be.url=function(X,J){var ve;if(ve=this.rules.inline.url.exec(X)){var pe,Ae;if(ve[2]==="@")pe=h(this.options.mangle?J(ve[0]):ve[0]),Ae="mailto:"+pe;else{var Ue;do Ue=ve[0],ve[0]=this.rules.inline._backpedal.exec(ve[0])[0];while(Ue!==ve[0]);pe=h(ve[0]),ve[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:ve[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},be.inlineText=function(X,J){var ve=this.rules.inline.text.exec(X);if(ve){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):h(ve[0]):ve[0]:pe=h(this.options.smartypants?J(ve[0]):ve[0]),{type:"text",raw:ve[0],text:pe}}},fe}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:C,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=c(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=c(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=c(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=c(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=c(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=_({},W),W.gfm=_({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=c(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=_({},W.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:C,paragraph:c(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:C,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:C,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=c(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=c(W._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=c(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=c(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=c(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=c(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=c(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=c(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=c(j.reflink).replace("label",j._label).replace("ref",W._label).getRegex(),j.nolink=c(j.nolink).replace("ref",W._label).getRegex(),j.reflinkSearch=c(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=_({},j),j.pedantic=_({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=_({},j.normal,{escape:c(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=c(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=_({},j.gfm,{br:c(j.br).replace("{2,}","*").getRegex(),text:c(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(fe){return fe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(fe){var be="",de,X,J=fe.length;for(de=0;de<J;de++)X=fe.charCodeAt(de),Math.random()>.5&&(X="x"+X.toString(16)),be+="&#"+X+";";return be}var q=function(){function fe(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||Se.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:W.normal,inline:j.normal};this.options.pedantic?(X.block=W.pedantic,X.inline=j.pedantic):this.options.gfm&&(X.block=W.gfm,this.options.breaks?X.inline=j.breaks:X.inline=j.gfm),this.tokenizer.rules=X}fe.lex=function(X,J){var ve=new fe(J);return ve.lex(X)},fe.lexInline=function(X,J){var ve=new fe(J);return ve.inlineTokens(X)};var be=fe.prototype;return be.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var J;J=this.inlineQueue.shift();)this.inlineTokens(J.src,J.tokens);return this.tokens},be.blockTokens=function(X,J){var ve=this;J===void 0&&(J=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Oe,x,B){return x+"    ".repeat(B.length)});for(var pe,Ae,Ue,Ie;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(pe=Oe.call({lexer:ve},X,J))?(X=X.substring(pe.raw.length),J.push(pe),!0):!1}))){if(pe=this.tokenizer.space(X)){X=X.substring(pe.raw.length),pe.raw.length===1&&J.length>0?J[J.length-1].raw+=`
`:J.push(pe);continue}if(pe=this.tokenizer.code(X)){X=X.substring(pe.raw.length),Ae=J[J.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):J.push(pe);continue}if(pe=this.tokenizer.fences(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.heading(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.hr(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.blockquote(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.list(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.html(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.def(X)){X=X.substring(pe.raw.length),Ae=J[J.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.lheading(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,x=X.slice(1),B=void 0;ve.options.extensions.startBlock.forEach(function(H){B=H.call({lexer:this},x),typeof B=="number"&&B>=0&&(Oe=Math.min(Oe,B))}),Oe<1/0&&Oe>=0&&(Ue=X.substring(0,Oe+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(Ue))){Ae=J[J.length-1],Ie&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):J.push(pe),Ie=Ue.length!==X.length,X=X.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(X)){X=X.substring(pe.raw.length),Ae=J[J.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):J.push(pe);continue}if(X){var Pe="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,J},be.inline=function(X,J){return J===void 0&&(J=[]),this.inlineQueue.push({src:X,tokens:J}),J},be.inlineTokens=function(X,J){var ve=this;J===void 0&&(J=[]);var pe,Ae,Ue,Ie=X,Pe,Oe,x;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)B.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Pe.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Oe||(x=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(V){return(pe=V.call({lexer:ve},X,J))?(X=X.substring(pe.raw.length),J.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.tag(X)){X=X.substring(pe.raw.length),Ae=J[J.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):J.push(pe);continue}if(pe=this.tokenizer.link(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(pe.raw.length),Ae=J[J.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):J.push(pe);continue}if(pe=this.tokenizer.emStrong(X,Ie,x)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.codespan(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.br(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.del(X)){X=X.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.autolink(X,K)){X=X.substring(pe.raw.length),J.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(X,K))){X=X.substring(pe.raw.length),J.push(pe);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startInline&&function(){var V=1/0,re=X.slice(1),ge=void 0;ve.options.extensions.startInline.forEach(function(Te){ge=Te.call({lexer:this},re),typeof ge=="number"&&ge>=0&&(V=Math.min(V,ge))}),V<1/0&&V>=0&&(Ue=X.substring(0,V+1))}(),pe=this.tokenizer.inlineText(Ue,$)){X=X.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(x=pe.raw.slice(-1)),Oe=!0,Ae=J[J.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):J.push(pe);continue}if(X){var H="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return J},S(fe,null,[{key:"rules",get:function(){return{block:W,inline:j}}}]),fe}(),ae=function(){function fe(de){this.options=de||Se.defaults}var be=fe.prototype;return be.code=function(X,J,ve){var pe=(J||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(X,pe);Ae!=null&&Ae!==X&&(ve=!0,X=Ae)}return X=X.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+h(pe,!0)+'">'+(ve?X:h(X,!0))+`</code></pre>
`:"<pre><code>"+(ve?X:h(X,!0))+`</code></pre>
`},be.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},be.html=function(X){return X},be.heading=function(X,J,ve,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug(ve);return"<h"+J+' id="'+Ae+'">'+X+"</h"+J+`>
`}return"<h"+J+">"+X+"</h"+J+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(X,J,ve){var pe=J?"ol":"ul",Ae=J&&ve!==1?' start="'+ve+'"':"";return"<"+pe+Ae+`>
`+X+"</"+pe+`>
`},be.listitem=function(X){return"<li>"+X+`</li>
`},be.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(X){return"<p>"+X+`</p>
`},be.table=function(X,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+J+`</table>
`},be.tablerow=function(X){return`<tr>
`+X+`</tr>
`},be.tablecell=function(X,J){var ve=J.header?"th":"td",pe=J.align?"<"+ve+' align="'+J.align+'">':"<"+ve+">";return pe+X+("</"+ve+`>
`)},be.strong=function(X){return"<strong>"+X+"</strong>"},be.em=function(X){return"<em>"+X+"</em>"},be.codespan=function(X){return"<code>"+X+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(X){return"<del>"+X+"</del>"},be.link=function(X,J,ve){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return ve;var pe='<a href="'+h(X)+'"';return J&&(pe+=' title="'+J+'"'),pe+=">"+ve+"</a>",pe},be.image=function(X,J,ve){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return ve;var pe='<img src="'+X+'" alt="'+ve+'"';return J&&(pe+=' title="'+J+'"'),pe+=this.options.xhtml?"/>":">",pe},be.text=function(X){return X},fe}(),Ee=function(){function fe(){}var be=fe.prototype;return be.strong=function(X){return X},be.em=function(X){return X},be.codespan=function(X){return X},be.del=function(X){return X},be.html=function(X){return X},be.text=function(X){return X},be.link=function(X,J,ve){return""+ve},be.image=function(X,J,ve){return""+ve},be.br=function(){return""},fe}(),ce=function(){function fe(){this.seen={}}var be=fe.prototype;return be.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(X,J){var ve=X,pe=0;if(this.seen.hasOwnProperty(ve)){pe=this.seen[X];do pe++,ve=X+"-"+pe;while(this.seen.hasOwnProperty(ve))}return J||(this.seen[X]=pe,this.seen[ve]=0),ve},be.slug=function(X,J){J===void 0&&(J={});var ve=this.serialize(X);return this.getNextSafeSlug(ve,J.dryrun)},fe}(),Z=function(){function fe(de){this.options=de||Se.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ee,this.slugger=new ce}fe.parse=function(X,J){var ve=new fe(J);return ve.parse(X)},fe.parseInline=function(X,J){var ve=new fe(J);return ve.parseInline(X)};var be=fe.prototype;return be.parse=function(X,J){J===void 0&&(J=!0);var ve="",pe,Ae,Ue,Ie,Pe,Oe,x,B,H,V,re,ge,Te,xe,qe,Ze,tt,nt,et,rt=X.length;for(pe=0;pe<rt;pe++){if(V=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[V.type]&&(et=this.options.extensions.renderers[V.type].call({parser:this},V),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(V.type))){ve+=et||"";continue}switch(V.type){case"space":continue;case"hr":{ve+=this.renderer.hr();continue}case"heading":{ve+=this.renderer.heading(this.parseInline(V.tokens),V.depth,s(this.parseInline(V.tokens,this.textRenderer)),this.slugger);continue}case"code":{ve+=this.renderer.code(V.text,V.lang,V.escaped);continue}case"table":{for(B="",x="",Ie=V.header.length,Ae=0;Ae<Ie;Ae++)x+=this.renderer.tablecell(this.parseInline(V.header[Ae].tokens),{header:!0,align:V.align[Ae]});for(B+=this.renderer.tablerow(x),H="",Ie=V.rows.length,Ae=0;Ae<Ie;Ae++){for(Oe=V.rows[Ae],x="",Pe=Oe.length,Ue=0;Ue<Pe;Ue++)x+=this.renderer.tablecell(this.parseInline(Oe[Ue].tokens),{header:!1,align:V.align[Ue]});H+=this.renderer.tablerow(x)}ve+=this.renderer.table(B,H);continue}case"blockquote":{H=this.parse(V.tokens),ve+=this.renderer.blockquote(H);continue}case"list":{for(re=V.ordered,ge=V.start,Te=V.loose,Ie=V.items.length,H="",Ae=0;Ae<Ie;Ae++)qe=V.items[Ae],Ze=qe.checked,tt=qe.task,xe="",qe.task&&(nt=this.renderer.checkbox(Ze),Te?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=nt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=nt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:nt}):xe+=nt),xe+=this.parse(qe.tokens,Te),H+=this.renderer.listitem(xe,tt,Ze);ve+=this.renderer.list(H,re,ge);continue}case"html":{ve+=this.renderer.html(V.text);continue}case"paragraph":{ve+=this.renderer.paragraph(this.parseInline(V.tokens));continue}case"text":{for(H=V.tokens?this.parseInline(V.tokens):V.text;pe+1<rt&&X[pe+1].type==="text";)V=X[++pe],H+=`
`+(V.tokens?this.parseInline(V.tokens):V.text);ve+=J?this.renderer.paragraph(H):H;continue}default:{var ft='Token with "'+V.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return ve},be.parseInline=function(X,J){J=J||this.renderer;var ve="",pe,Ae,Ue,Ie=X.length;for(pe=0;pe<Ie;pe++){if(Ae=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(Ue=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){ve+=Ue||"";continue}switch(Ae.type){case"escape":{ve+=J.text(Ae.text);break}case"html":{ve+=J.html(Ae.text);break}case"link":{ve+=J.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,J));break}case"image":{ve+=J.image(Ae.href,Ae.title,Ae.text);break}case"strong":{ve+=J.strong(this.parseInline(Ae.tokens,J));break}case"em":{ve+=J.em(this.parseInline(Ae.tokens,J));break}case"codespan":{ve+=J.codespan(Ae.text);break}case"br":{ve+=J.br();break}case"del":{ve+=J.del(this.parseInline(Ae.tokens,J));break}case"text":{ve+=J.text(Ae.text);break}default:{var Pe='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return ve},fe}();function le(fe,be,de){if(typeof fe>"u"||fe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");if(typeof be=="function"&&(de=be,be=null),be=_({},le.defaults,be||{}),f(be),de){var X=be.highlight,J;try{J=q.lex(fe,be)}catch(Ie){return de(Ie)}var ve=function(Pe){var Oe;if(!Pe)try{be.walkTokens&&le.walkTokens(J,be.walkTokens),Oe=Z.parse(J,be)}catch(x){Pe=x}return be.highlight=X,Pe?de(Pe):de(null,Oe)};if(!X||X.length<3||(delete be.highlight,!J.length))return ve();var pe=0;le.walkTokens(J,function(Ie){Ie.type==="code"&&(pe++,setTimeout(function(){X(Ie.text,Ie.lang,function(Pe,Oe){if(Pe)return ve(Pe);Oe!=null&&Oe!==Ie.text&&(Ie.text=Oe,Ie.escaped=!0),pe--,pe===0&&ve()})},0))}),pe===0&&ve();return}function Ae(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+h(Ie.message+"",!0)+"</pre>";throw Ie}try{var Ue=q.lex(fe,be);if(be.walkTokens){if(be.async)return Promise.all(le.walkTokens(Ue,be.walkTokens)).then(function(){return Z.parse(Ue,be)}).catch(Ae);le.walkTokens(Ue,be.walkTokens)}return Z.parse(Ue,be)}catch(Ie){Ae(Ie)}}le.options=le.setOptions=function(fe){return _(le.defaults,fe),R(le.defaults),le},le.getDefaults=A,le.defaults=Se.defaults,le.use=function(){for(var fe=arguments.length,be=new Array(fe),de=0;de<fe;de++)be[de]=arguments[de];var X=_.apply(void 0,[{}].concat(be)),J=le.defaults.extensions||{renderers:{},childTokens:{}},ve;be.forEach(function(pe){if(pe.extensions&&(ve=!0,pe.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var Ie=J.renderers?J.renderers[Ue.name]:null;Ie?J.renderers[Ue.name]=function(){for(var Pe=arguments.length,Oe=new Array(Pe),x=0;x<Pe;x++)Oe[x]=arguments[x];var B=Ue.renderer.apply(this,Oe);return B===!1&&(B=Ie.apply(this,Oe)),B}:J.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");J[Ue.level]?J[Ue.level].unshift(Ue.tokenizer):J[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?J.startBlock?J.startBlock.push(Ue.start):J.startBlock=[Ue.start]:Ue.level==="inline"&&(J.startInline?J.startInline.push(Ue.start):J.startInline=[Ue.start]))}Ue.childTokens&&(J.childTokens[Ue.name]=Ue.childTokens)})),pe.renderer&&function(){var Ue=le.defaults.renderer||new ae,Ie=function(x){var B=Ue[x];Ue[x]=function(){for(var H=arguments.length,V=new Array(H),re=0;re<H;re++)V[re]=arguments[re];var ge=pe.renderer[x].apply(Ue,V);return ge===!1&&(ge=B.apply(Ue,V)),ge}};for(var Pe in pe.renderer)Ie(Pe);X.renderer=Ue}(),pe.tokenizer&&function(){var Ue=le.defaults.tokenizer||new N,Ie=function(x){var B=Ue[x];Ue[x]=function(){for(var H=arguments.length,V=new Array(H),re=0;re<H;re++)V[re]=arguments[re];var ge=pe.tokenizer[x].apply(Ue,V);return ge===!1&&(ge=B.apply(Ue,V)),ge}};for(var Pe in pe.tokenizer)Ie(Pe);X.tokenizer=Ue}(),pe.walkTokens){var Ae=le.defaults.walkTokens;X.walkTokens=function(Ue){var Ie=[];return Ie.push(pe.walkTokens.call(this,Ue)),Ae&&(Ie=Ie.concat(Ae.call(this,Ue))),Ie}}ve&&(X.extensions=J),le.setOptions(X)})},le.walkTokens=function(fe,be){for(var de=[],X=function(){var Ae=ve.value;switch(de=de.concat(be.call(le,Ae)),Ae.type){case"table":{for(var Ue=O(Ae.header),Ie;!(Ie=Ue()).done;){var Pe=Ie.value;de=de.concat(le.walkTokens(Pe.tokens,be))}for(var Oe=O(Ae.rows),x;!(x=Oe()).done;)for(var B=x.value,H=O(B),V;!(V=H()).done;){var re=V.value;de=de.concat(le.walkTokens(re.tokens,be))}break}case"list":{de=de.concat(le.walkTokens(Ae.items,be));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[Ae.type]?le.defaults.extensions.childTokens[Ae.type].forEach(function(ge){de=de.concat(le.walkTokens(Ae[ge],be))}):Ae.tokens&&(de=de.concat(le.walkTokens(Ae.tokens,be)))}},J=O(fe),ve;!(ve=J()).done;)X();return de},le.parseInline=function(fe,be){if(typeof fe>"u"||fe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");be=_({},le.defaults,be||{}),f(be);try{var de=q.lexInline(fe,be);return be.walkTokens&&le.walkTokens(de,be.walkTokens),Z.parseInline(de,be)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+h(X.message+"",!0)+"</pre>";throw X}},le.Parser=Z,le.parser=Z.parse,le.Renderer=ae,le.TextRenderer=Ee,le.Lexer=q,le.lexer=q.lex,le.Tokenizer=N,le.Slugger=ce,le.parse=le;var me=le.options,oe=le.setOptions,De=le.use,Re=le.walkTokens,Q=le.parseInline,z=le,ne=Z.parse,Ce=q.lex;Se.Lexer=q,Se.Parser=Z,Se.Renderer=ae,Se.Slugger=ce,Se.TextRenderer=Ee,Se.Tokenizer=N,Se.getDefaults=A,Se.lexer=Ce,Se.marked=le,Se.options=me,Se.parse=z,Se.parseInline=Q,Se.parser=ne,Se.setOptions=oe,Se.use=De,Se.walkTokens=Re,Object.defineProperty(Se,"__esModule",{value:!0})}),define(Le[139],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=S;function S(r){const s=O(r);if(s&&s.length>0)return new Uint32Array(s)}let k=0;const P=new Uint32Array(10);function O(r){if(k=0,A(r,w,p.InitialConsonant),k>0||(A(r,a,p.Vowel),k>0)||(A(r,y,p.FinalConsonant),k>0)||(A(r,h,p.CompatibilityJamo),k))return P.subarray(0,k);if(r>=44032&&r<=55203){const s=r-44032,l=s%588,c=Math.floor(s/588),i=Math.floor(l/28),n=l%28-1;if(c<w.length?A(c,w,0):p.InitialConsonant+c-p.CompatibilityJamo<h.length&&A(p.InitialConsonant+c,h,p.CompatibilityJamo),i<a.length?A(i,a,0):p.Vowel+i-p.CompatibilityJamo<h.length&&A(p.Vowel+i-p.CompatibilityJamo,h,p.CompatibilityJamo),n>=0&&(n<y.length?A(n,y,0):p.FinalConsonant+n-p.CompatibilityJamo<h.length&&A(p.FinalConsonant+n-p.CompatibilityJamo,h,p.CompatibilityJamo)),k>0)return P.subarray(0,k)}}function A(r,s,l){r>=l&&r<l+s.length&&R(s[r-l])}function R(r){r!==o.NUL&&(P[k++]=r&255,r>>8&&(P[k++]=r>>8&255),r>>16&&(P[k++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var o;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(o||(o={}));var I;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(I||(I={}));const w=new Uint8Array([o.r,o.R,o.s,o.e,o.E,o.f,o.a,o.q,o.Q,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g]),a=new Uint16Array([o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,I.hk,I.ho,I.hl,o.y,o.n,I.nj,I.np,I.nl,o.b,o.m,I.ml,o.l]),y=new Uint16Array([o.r,o.R,I.rt,o.s,I.sw,I.sg,o.e,o.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,o.a,o.q,I.qt,o.t,o.T,o.d,o.w,o.c,o.z,o.x,o.v,o.g]),h=new Uint16Array([o.r,o.R,I.rt,o.s,I.sw,I.sg,o.e,o.E,o.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,o.a,o.q,o.Q,I.qt,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g,o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,I.hk,I.ho,I.hl,o.y,o.n,I.nj,I.np,I.nl,o.b,o.m,I.ml,o.l])}),define(Le[140],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=S,e.rot=k,e.isPointWithinTriangle=R;function S(p,o,I){return Math.min(Math.max(p,o),I)}function k(p,o){return(o+p%o)%o}class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class O{constructor(){this._n=1,this._val=0}update(o){return this._val=this._val+(o-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=O;class A{constructor(o){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(o),this._values.fill(0,0,o)}update(o){const I=this._values[this._index];return this._values[this._index]=o,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=o,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A;function R(p,o,I,w,a,y,h,r){const s=h-I,l=r-w,c=a-I,i=y-w,n=p-I,t=o-w,g=s*s+l*l,u=s*c+l*i,v=s*n+l*t,m=c*c+i*i,d=c*n+i*t,C=1/(g*m-u*u),_=(m*v-u*d)*C,E=(g*d-u*v)*C;return _>=0&&E>=0&&_+E<1}}),define(Le[141],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=O,e.getFunctionName=a;class S{constructor(h,r,s){this.owner=h,this.debugNameSource=r,this.referenceFn=s}getDebugName(h){return O(h,this)}}e.DebugNameData=S;const k=new Map,P=new WeakMap;function O(y,h){const r=P.get(y);if(r)return r;const s=A(y,h);if(s){let l=k.get(s)??0;l++,k.set(s,l);const c=l===1?s:`${s}#${l}`;return P.set(y,c),c}}function A(y,h){const r=P.get(y);if(r)return r;const s=h.owner?I(h.owner)+".":"";let l;const c=h.debugNameSource;if(c!==void 0)if(typeof c=="function"){if(l=c(),l!==void 0)return s+l}else return s+c;const i=h.referenceFn;if(i!==void 0&&(l=a(i),l!==void 0))return s+l;if(h.owner!==void 0){const n=R(h.owner,y);if(n!==void 0)return s+n}}function R(y,h){for(const r in y)if(y[r]===h)return r}const p=new Map,o=new WeakMap;function I(y){const h=o.get(y);if(h)return h;const r=w(y);let s=p.get(r)??0;s++,p.set(r,s);const l=s===1?r:`${r}#${s}`;return o.set(y,l),l}function w(y){const h=y.constructor;return h?h.name:"Object"}function a(y){const h=y.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(h);return(s?s[1]:void 0)?.trim()}}),define(Le[142],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=k,e.getLogger=P;let S;function k(r){S=r}function P(){return S}class O{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(s){return A([R(y("|  ",this.indentation)),s])}formatInfo(s){return s.hadValue?s.didChange?[R(" "),o(I(s.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),o(I(s.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),o(I(s.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(s,l){console.log(...this.textToConsoleArgs([p("observable value changed"),o(s.debugName,{color:"BlueViolet"}),...this.formatInfo(l)]))}formatChanges(s){if(s.size!==0)return o(" (changed deps: "+[...s].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const l=s.handleChange;this.changedObservablesSets.set(s,new Set),s.handleChange=(c,i)=>(this.changedObservablesSets.get(s).add(c),l.apply(s,[c,i]))}handleDerivedRecomputed(s,l){const c=this.changedObservablesSets.get(s);console.log(...this.textToConsoleArgs([p("derived recomputed"),o(s.debugName,{color:"BlueViolet"}),...this.formatInfo(l),this.formatChanges(c),{data:[{fn:s._debugNameData.referenceFn??s._computeFn}]}])),c.clear()}handleFromEventObservableTriggered(s,l){console.log(...this.textToConsoleArgs([p("observable from event triggered"),o(s.debugName,{color:"BlueViolet"}),...this.formatInfo(l),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const l=s.handleChange;this.changedObservablesSets.set(s,new Set),s.handleChange=(c,i)=>(this.changedObservablesSets.get(s).add(c),l.apply(s,[c,i]))}handleAutorunTriggered(s){const l=this.changedObservablesSets.get(s);console.log(...this.textToConsoleArgs([p("autorun"),o(s.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:s._debugNameData.referenceFn??s._runFn}]}])),l.clear(),this.indentation++}handleAutorunFinished(s){this.indentation--}handleBeginTransaction(s){let l=s.getDebugName();l===void 0&&(l=""),console.log(...this.textToConsoleArgs([p("transaction"),o(l,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=O;function A(r){const s=new Array,l=[];let c="";function i(t){if("length"in t)for(const g of t)g&&i(g);else"text"in t?(c+=`%c${t.text}`,s.push(t.style),t.data&&l.push(...t.data)):"data"in t&&l.push(...t.data)}i(r);const n=[c,...s];return n.push(...l),n}function R(r){return o(r,{color:"black"})}function p(r){return o(h(`${r}: `,10),{color:"black",bold:!0})}function o(r,s={color:"black"}){function l(i){return Object.entries(i).reduce((n,[t,g])=>`${n}${t}:${g};`,"")}const c={color:s.color};return s.strikeThrough&&(c["text-decoration"]="line-through"),s.bold&&(c["font-weight"]="bold"),{text:r,style:l(c)}}function I(r,s){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=s?`"${r}"`:`"${r.substr(0,s-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?w(r,s):a(r,s);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function w(r,s){let l="[ ",c=!0;for(const i of r){if(c||(l+=", "),l.length-5>s){l+="...";break}c=!1,l+=`${I(i,s-l.length)}`}return l+=" ]",l}function a(r,s){let l="{ ",c=!0;for(const[i,n]of Object.entries(r)){if(c||(l+=", "),l.length-5>s){l+="...";break}c=!1,l+=`${i}: ${I(n,s-l.length)}`}return l+=" }",l}function y(r,s){let l="";for(let c=1;c<=s;c++)l+=r;return l}function h(r,s){for(;r.length<s;)r+=" ";return r}}),define(Le[143],Ne([1,0,135,141,142]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=A,e._setKeepObserved=p,e._setDerivedOpts=I,e.transaction=y,e.globalTransaction=r,e.asyncTransaction=s,e.subtransaction=l,e.observableValue=i,e.disposableObservableValue=t;let O;function A(u){O=u}let R;function p(u){R=u}let o;function I(u){o=u}class w{get TChange(){return null}reportChanges(){this.get()}read(v){return v?v.readObservable(this):this.get()}map(v,m){const d=m===void 0?void 0:v,C=m===void 0?v:m;return o({owner:d,debugName:()=>{const _=(0,k.getFunctionName)(C);if(_!==void 0)return _;const T=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(C.toString());if(T)return`${this.debugName}.${T[2]}`;if(!d)return`${this.debugName} (mapped)`},debugReferenceFn:C},_=>C(this.read(_),_))}flatten(){return o({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},v=>this.read(v).read(v))}recomputeInitiallyAndOnChange(v,m){return v.add(O(this,m)),this}keepObserved(v){return v.add(R(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=w;class a extends w{constructor(){super(...arguments),this.observers=new Set}addObserver(v){const m=this.observers.size;this.observers.add(v),m===0&&this.onFirstObserverAdded()}removeObserver(v){this.observers.delete(v)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=a;function y(u,v){const m=new c(u,v);try{u(m)}finally{m.finish()}}let h;function r(u){if(h)u(h);else{const v=new c(u,void 0);h=v;try{u(v)}finally{v.finish(),h=void 0}}}async function s(u,v){const m=new c(u,v);try{await u(m)}finally{m.finish()}}function l(u,v,m){u?v(u):y(v,m)}class c{constructor(v,m){this._fn=v,this._getDebugName=m,this.updatingObservers=[],(0,P.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,k.getFunctionName)(this._fn)}updateObserver(v,m){this.updatingObservers.push({observer:v,observable:m}),v.beginUpdate(m)}finish(){const v=this.updatingObservers;for(let m=0;m<v.length;m++){const{observer:d,observable:C}=v[m];d.endUpdate(C)}this.updatingObservers=null,(0,P.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=c;function i(u,v){let m;return typeof u=="string"?m=new k.DebugNameData(void 0,u,void 0):m=new k.DebugNameData(u,void 0,void 0),new n(m,v,S.strictEquals)}class n extends a{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(v,m,d){super(),this._debugNameData=v,this._equalityComparator=d,this._value=m}get(){return this._value}set(v,m,d){if(d===void 0&&this._equalityComparator(this._value,v))return;let C;m||(m=C=new c(()=>{},()=>`Setting ${this.debugName}`));try{const _=this._value;this._setValue(v),(0,P.getLogger)()?.handleObservableChanged(this,{oldValue:_,newValue:v,change:d,didChange:!0,hadValue:!0});for(const E of this.observers)m.updateObserver(E,this),E.handleChange(this,d)}finally{C&&C.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(v){this._value=v}}e.ObservableValue=n;function t(u,v){let m;return typeof u=="string"?m=new k.DebugNameData(void 0,u,void 0):m=new k.DebugNameData(u,void 0,void 0),new g(m,v,S.strictEquals)}class g extends n{_setValue(v){this._value!==v&&(this._value&&this._value.dispose(),this._value=v)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=g}),function(){function Se(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function A(p){O.push(p,Date.now())}function R(){const p=[];for(let o=0;o<O.length;o+=2)p.push({name:O[o],startTime:O[o+1]});return p}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Se():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(P+A.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Se(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),Se()}function S(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=S(k))}(),define(Le[144],Ne([1,0,40]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const k=Symbol("unset");class P{constructor(){this.root=new A,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||S.Iterable.empty()}get entries(){return this.root.children?.entries()||S.Iterable.empty()}insert(p,o,I){this.opNode(p,w=>w._value=o,I)}mutate(p,o){this.opNode(p,I=>I._value=o(I._value===k?void 0:I._value))}mutatePath(p,o){this.opNode(p,()=>{},I=>o(I))}delete(p){const o=this.getPathToKey(p);if(!o)return;let I=o.length-1;const w=o[I].node._value;if(w!==k){for(this._size--,o[I].node._value=k;I>0;I--){const{node:a,part:y}=o[I];if(a.children?.size||a._value!==k)break;o[I-1].node.children.delete(y)}return w}}*deleteRecursive(p){const o=this.getPathToKey(p);if(!o)return;const I=o[o.length-1].node;for(let w=o.length-1;w>0;w--){const a=o[w-1];if(a.node.children.delete(o[w].part),a.node.children.size>0||a.node._value!==k)break}for(const w of O(I))w._value!==k&&(this._size--,yield w._value)}find(p){let o=this.root;for(const I of p){const w=o.children?.get(I);if(!w)return;o=w}return o._value===k?void 0:o._value}hasKeyOrParent(p){let o=this.root;for(const I of p){const w=o.children?.get(I);if(!w)return!1;if(w._value!==k)return!0;o=w}return!1}hasKeyOrChildren(p){let o=this.root;for(const I of p){const w=o.children?.get(I);if(!w)return!1;o=w}return!0}hasKey(p){let o=this.root;for(const I of p){const w=o.children?.get(I);if(!w)return!1;o=w}return o._value!==k}getPathToKey(p){const o=[{part:"",node:this.root}];let I=0;for(const w of p){const a=o[I].node.children?.get(w);if(!a)return;o.push({part:w,node:a}),I++}return o}opNode(p,o,I){let w=this.root;for(const h of p){if(w.children)if(w.children.has(h))w=w.children.get(h);else{const r=new A;w.children.set(h,r),w=r}else{const r=new A;w.children=new Map([[h,r]]),w=r}I?.(w)}const a=w._value===k?0:1;o(w);const y=w._value===k?0:1;this._size+=y-a}*values(){for(const{_value:p}of O(this.root))p!==k&&(yield p)}}e.WellDefinedPrefixTree=P;function*O(R){const p=[R];for(;p.length>0;){const o=p.pop();if(yield o,o.children)for(const I of o.children.values())p.push(I)}}class A{constructor(){this._value=k}get value(){return this._value===k?void 0:this._value}set value(p){this._value=p===void 0?k:p}}}),define(Le[145],Ne([1,0,48,19]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=R,e.compareFileNamesDefault=p,e.compareFileNamesUpper=o,e.compareFileNamesLower=I,e.compareFileNamesUnicode=w,e.compareFileExtensions=a,e.compareFileExtensionsDefault=y,e.compareFileExtensionsUpper=h,e.compareFileExtensionsLower=r,e.compareFileExtensionsUnicode=s,e.comparePaths=d,e.compareAnything=C,e.compareByPrefix=_;const P=new S.Lazy(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),O=new S.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new S.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(E,T,D=!1){const f=E||"",b=T||"",M=P.value.collator.compare(f,b);return P.value.collatorIsNumeric&&M===0&&f!==b?f<b?-1:1:M}function p(E,T){const D=O.value.collator;return E=E||"",T=T||"",n(D,E,T)}function o(E,T){const D=O.value.collator;return E=E||"",T=T||"",v(E,T)||n(D,E,T)}function I(E,T){const D=O.value.collator;return E=E||"",T=T||"",u(E,T)||n(D,E,T)}function w(E,T){return E=E||"",T=T||"",E===T?0:E<T?-1:1}function a(E,T){const[D,f]=c(E),[b,M]=c(T);let L=P.value.collator.compare(f,M);if(L===0){if(P.value.collatorIsNumeric&&f!==M)return f<M?-1:1;if(L=P.value.collator.compare(D,b),P.value.collatorIsNumeric&&L===0&&D!==b)return D<b?-1:1}return L}function y(E,T){E=E||"",T=T||"";const D=i(E),f=i(T),b=O.value.collator,M=A.value.collator;return n(M,D,f)||n(b,E,T)}function h(E,T){E=E||"",T=T||"";const D=i(E),f=i(T),b=O.value.collator,M=A.value.collator;return n(M,D,f)||v(E,T)||n(b,E,T)}function r(E,T){E=E||"",T=T||"";const D=i(E),f=i(T),b=O.value.collator,M=A.value.collator;return n(M,D,f)||u(E,T)||n(b,E,T)}function s(E,T){E=E||"",T=T||"";const D=i(E).toLowerCase(),f=i(T).toLowerCase();return D!==f?D<f?-1:1:E!==T?E<T?-1:1:0}const l=/^(.*?)(\.([^.]*))?$/;function c(E,T=!1){const D=E?l.exec(E):[];let f=[D&&D[1]||"",D&&D[3]||""];return T&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function i(E){const T=E?l.exec(E):[];return T&&T[1]&&T[1].charAt(0)!=="."&&T[3]||""}function n(E,T,D){const f=E.compare(T,D);return f!==0?f:T.length!==D.length?T.length<D.length?-1:1:0}function t(E){const T=E.charAt(0);return T.toLocaleUpperCase()!==T}function g(E){const T=E.charAt(0);return T.toLocaleLowerCase()!==T}function u(E,T){return t(E)&&g(T)?-1:g(E)&&t(T)?1:0}function v(E,T){return g(E)&&t(T)?-1:t(E)&&g(T)?1:0}function m(E,T,D=!1){return D||(E=E&&E.toLowerCase(),T=T&&T.toLowerCase()),E===T?0:E<T?-1:1}function d(E,T,D=!1){const f=E.split(k.sep),b=T.split(k.sep),M=f.length-1,L=b.length-1;let N,W;for(let j=0;;j++){if(N=M===j,W=L===j,N&&W)return R(f[j],b[j],D);if(N)return-1;if(W)return 1;const $=m(f[j],b[j],D);if($!==0)return $}}function C(E,T,D){const f=E.toLowerCase(),b=T.toLowerCase(),M=_(E,T,D);if(M)return M;const L=f.endsWith(D),N=b.endsWith(D);if(L!==N)return L?-1:1;const W=R(f,b);return W!==0?W:f.localeCompare(b)}function _(E,T,D){const f=E.toLowerCase(),b=T.toLowerCase(),M=f.startsWith(D),L=b.startsWith(D);if(M!==L)return M?-1:1;if(M&&L){if(f.length<b.length)return-1;if(f.length>b.length)return 1}return 0}}),define(Le[72],Ne([1,0,19]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=O,e.getMediaMime=A,e.getExtensionForMimeType=R,e.normalizeMimeType=o,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(I){const w=(0,S.extname)(I),a=k[w.toLowerCase()];return a!==void 0?a:A(I)}function A(I){const w=(0,S.extname)(I);return P[w.toLowerCase()]}function R(I){for(const w in P)if(P[w]===I)return w}const p=/^(.+)\/(.+?)(;.+)?$/;function o(I,w){const a=p.exec(I);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:w?void 0:I}}),function(Se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var k in S)(typeof exports=="object"?exports:Se)[k]=S[k]}}(typeof self<"u"?self:this,function(){return function(Se){var e={};function S(k){if(e[k])return e[k].exports;var P=e[k]={i:k,l:!1,exports:{}};return Se[k].call(P.exports,P,P.exports,S),P.l=!0,P.exports}return S.m=Se,S.c=e,S.d=function(k,P,O){S.o(k,P)||Object.defineProperty(k,P,{enumerable:!0,get:O})},S.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},S.t=function(k,P){if(1&P&&(k=S(k)),8&P||4&P&&typeof k=="object"&&k&&k.__esModule)return k;var O=Object.create(null);if(S.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:k}),2&P&&typeof k!="string")for(var A in k)S.d(O,A,function(R){return k[R]}.bind(null,A));return O},S.n=function(k){var P=k&&k.__esModule?function(){return k.default}:function(){return k};return S.d(P,"a",P),P},S.o=function(k,P){return Object.prototype.hasOwnProperty.call(k,P)},S.p="",S(S.s=0)}([function(Se,e,S){(function(k){var P;e=Se.exports=De,P=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],p=e.src=[],o=0,I=o++;p[I]="0|[1-9]\\d*";var w=o++;p[w]="[0-9]+";var a=o++;p[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=o++;p[y]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var h=o++;p[h]="("+p[w]+")\\.("+p[w]+")\\.("+p[w]+")";var r=o++;p[r]="(?:"+p[I]+"|"+p[a]+")";var s=o++;p[s]="(?:"+p[w]+"|"+p[a]+")";var l=o++;p[l]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var c=o++;p[c]="(?:-?("+p[s]+"(?:\\."+p[s]+")*))";var i=o++;p[i]="[0-9A-Za-z-]+";var n=o++;p[n]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=o++,g="v?"+p[y]+p[l]+"?"+p[n]+"?";p[t]="^"+g+"$";var u="[v=\\s]*"+p[h]+p[c]+"?"+p[n]+"?",v=o++;p[v]="^"+u+"$";var m=o++;p[m]="((?:<|>)?=?)";var d=o++;p[d]=p[w]+"|x|X|\\*";var C=o++;p[C]=p[I]+"|x|X|\\*";var _=o++;p[_]="[v=\\s]*("+p[C]+")(?:\\.("+p[C]+")(?:\\.("+p[C]+")(?:"+p[l]+")?"+p[n]+"?)?)?";var E=o++;p[E]="[v=\\s]*("+p[d]+")(?:\\.("+p[d]+")(?:\\.("+p[d]+")(?:"+p[c]+")?"+p[n]+"?)?)?";var T=o++;p[T]="^"+p[m]+"\\s*"+p[_]+"$";var D=o++;p[D]="^"+p[m]+"\\s*"+p[E]+"$";var f=o++;p[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=o++;p[b]="(?:~>?)";var M=o++;p[M]="(\\s*)"+p[b]+"\\s+",R[M]=new RegExp(p[M],"g");var L=o++;p[L]="^"+p[b]+p[_]+"$";var N=o++;p[N]="^"+p[b]+p[E]+"$";var W=o++;p[W]="(?:\\^)";var j=o++;p[j]="(\\s*)"+p[W]+"\\s+",R[j]=new RegExp(p[j],"g");var $=o++;p[$]="^"+p[W]+p[_]+"$";var K=o++;p[K]="^"+p[W]+p[E]+"$";var q=o++;p[q]="^"+p[m]+"\\s*("+u+")$|^$";var ae=o++;p[ae]="^"+p[m]+"\\s*("+g+")$|^$";var Ee=o++;p[Ee]="(\\s*)"+p[m]+"\\s*("+u+"|"+p[_]+")",R[Ee]=new RegExp(p[Ee],"g");var ce=o++;p[ce]="^\\s*("+p[_]+")\\s+-\\s+("+p[_]+")\\s*$";var Z=o++;p[Z]="^\\s*("+p[E]+")\\s+-\\s+("+p[E]+")\\s*$";var le=o++;p[le]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)P(me,p[me]),R[me]||(R[me]=new RegExp(p[me]));function oe(B,H){if(B instanceof De)return B;if(typeof B!="string"||B.length>O||!(H?R[v]:R[t]).test(B))return null;try{return new De(B,H)}catch{return null}}function De(B,H){if(B instanceof De){if(B.loose===H)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof De))return new De(B,H);P("SemVer",B,H),this.loose=H;var V=B.trim().match(H?R[v]:R[t]);if(!V)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+V[1],this.minor=+V[2],this.patch=+V[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");V[4]?this.prerelease=V[4].split(".").map(function(re){if(/^[0-9]+$/.test(re)){var ge=+re;if(ge>=0&&ge<A)return ge}return re}):this.prerelease=[],this.build=V[5]?V[5].split("."):[],this.format()}e.parse=oe,e.valid=function(B,H){var V=oe(B,H);return V?V.version:null},e.clean=function(B,H){var V=oe(B.trim().replace(/^[=v]+/,""),H);return V?V.version:null},e.SemVer=De,De.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},De.prototype.toString=function(){return this.version},De.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof De||(B=new De(B,this.loose)),this.compareMain(B)||this.comparePre(B)},De.prototype.compareMain=function(B){return B instanceof De||(B=new De(B,this.loose)),Q(this.major,B.major)||Q(this.minor,B.minor)||Q(this.patch,B.patch)},De.prototype.comparePre=function(B){if(B instanceof De||(B=new De(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var H=0;do{var V=this.prerelease[H],re=B.prerelease[H];if(P("prerelease compare",H,V,re),V===void 0&&re===void 0)return 0;if(re===void 0)return 1;if(V===void 0)return-1;if(V!==re)return Q(V,re)}while(++H)},De.prototype.inc=function(B,H){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var V=this.prerelease.length;--V>=0;)typeof this.prerelease[V]=="number"&&(this.prerelease[V]++,V=-2);V===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,H,V,re){typeof V=="string"&&(re=V,V=void 0);try{return new De(B,V).inc(H,re).version}catch{return null}},e.diff=function(B,H){if(fe(B,H))return null;var V=oe(B),re=oe(H);if(V.prerelease.length||re.prerelease.length){for(var ge in V)if((ge==="major"||ge==="minor"||ge==="patch")&&V[ge]!==re[ge])return"pre"+ge;return"prerelease"}for(var ge in V)if((ge==="major"||ge==="minor"||ge==="patch")&&V[ge]!==re[ge])return ge},e.compareIdentifiers=Q;var Re=/^[0-9]+$/;function Q(B,H){var V=Re.test(B),re=Re.test(H);return V&&re&&(B=+B,H=+H),V&&!re?-1:re&&!V?1:B<H?-1:B>H?1:0}function z(B,H,V){return new De(B,V).compare(new De(H,V))}function ne(B,H,V){return z(B,H,V)>0}function Ce(B,H,V){return z(B,H,V)<0}function fe(B,H,V){return z(B,H,V)===0}function be(B,H,V){return z(B,H,V)!==0}function de(B,H,V){return z(B,H,V)>=0}function X(B,H,V){return z(B,H,V)<=0}function J(B,H,V,re){var ge;switch(H){case"===":typeof B=="object"&&(B=B.version),typeof V=="object"&&(V=V.version),ge=B===V;break;case"!==":typeof B=="object"&&(B=B.version),typeof V=="object"&&(V=V.version),ge=B!==V;break;case"":case"=":case"==":ge=fe(B,V,re);break;case"!=":ge=be(B,V,re);break;case">":ge=ne(B,V,re);break;case">=":ge=de(B,V,re);break;case"<":ge=Ce(B,V,re);break;case"<=":ge=X(B,V,re);break;default:throw new TypeError("Invalid operator: "+H)}return ge}function ve(B,H){if(B instanceof ve){if(B.loose===H)return B;B=B.value}if(!(this instanceof ve))return new ve(B,H);P("comparator",B,H),this.loose=H,this.parse(B),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,H){return Q(H,B)},e.major=function(B,H){return new De(B,H).major},e.minor=function(B,H){return new De(B,H).minor},e.patch=function(B,H){return new De(B,H).patch},e.compare=z,e.compareLoose=function(B,H){return z(B,H,!0)},e.rcompare=function(B,H,V){return z(H,B,V)},e.sort=function(B,H){return B.sort(function(V,re){return e.compare(V,re,H)})},e.rsort=function(B,H){return B.sort(function(V,re){return e.rcompare(V,re,H)})},e.gt=ne,e.lt=Ce,e.eq=fe,e.neq=be,e.gte=de,e.lte=X,e.cmp=J,e.Comparator=ve;var pe={};function Ae(B,H){if(B instanceof Ae)return B.loose===H?B:new Ae(B.raw,H);if(B instanceof ve)return new Ae(B.value,H);if(!(this instanceof Ae))return new Ae(B,H);if(this.loose=H,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(V){return this.parseRange(V.trim())},this).filter(function(V){return V.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function Ue(B){return!B||B.toLowerCase()==="x"||B==="*"}function Ie(B,H,V,re,ge,Te,xe,qe,Ze,tt,nt,et,rt){return((H=Ue(V)?"":Ue(re)?">="+V+".0.0":Ue(ge)?">="+V+"."+re+".0":">="+H)+" "+(qe=Ue(Ze)?"":Ue(tt)?"<"+(+Ze+1)+".0.0":Ue(nt)?"<"+Ze+"."+(+tt+1)+".0":et?"<="+Ze+"."+tt+"."+nt+"-"+et:"<="+qe)).trim()}function Pe(B,H){for(var V=0;V<B.length;V++)if(!B[V].test(H))return!1;if(H.prerelease.length){for(V=0;V<B.length;V++)if(P(B[V].semver),B[V].semver!==pe&&B[V].semver.prerelease.length>0){var re=B[V].semver;if(re.major===H.major&&re.minor===H.minor&&re.patch===H.patch)return!0}return!1}return!0}function Oe(B,H,V){try{H=new Ae(H,V)}catch{return!1}return H.test(B)}function x(B,H,V,re){var ge,Te,xe,qe,Ze;switch(B=new De(B,re),H=new Ae(H,re),V){case">":ge=ne,Te=X,xe=Ce,qe=">",Ze=">=";break;case"<":ge=Ce,Te=de,xe=ne,qe="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(B,H,re))return!1;for(var tt=0;tt<H.set.length;++tt){var nt=H.set[tt],et=null,rt=null;if(nt.forEach(function(ft){ft.semver===pe&&(ft=new ve(">=0.0.0")),et=et||ft,rt=rt||ft,ge(ft.semver,et.semver,re)?et=ft:xe(ft.semver,rt.semver,re)&&(rt=ft)}),et.operator===qe||et.operator===Ze||(!rt.operator||rt.operator===qe)&&Te(B,rt.semver)||rt.operator===Ze&&xe(B,rt.semver))return!1}return!0}ve.prototype.parse=function(B){var H=this.loose?R[q]:R[ae],V=B.match(H);if(!V)throw new TypeError("Invalid comparator: "+B);this.operator=V[1],this.operator==="="&&(this.operator=""),V[2]?this.semver=new De(V[2],this.loose):this.semver=pe},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===pe||(typeof B=="string"&&(B=new De(B,this.loose)),J(B,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(B,H){if(!(B instanceof ve))throw new TypeError("a Comparator is required");var V;if(this.operator==="")return V=new Ae(B.value,H),Oe(this.value,V,H);if(B.operator==="")return V=new Ae(this.value,H),Oe(B.semver,V,H);var re=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Te=this.semver.version===B.semver.version,xe=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),qe=J(this.semver,"<",B.semver,H)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Ze=J(this.semver,">",B.semver,H)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return re||ge||Te&&xe||qe||Ze},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(B){var H=this.loose;B=B.trim(),P("range",B,H);var V=H?R[Z]:R[ce];B=B.replace(V,Ie),P("hyphen replace",B),B=B.replace(R[Ee],"$1$2$3"),P("comparator trim",B,R[Ee]),B=(B=(B=B.replace(R[M],"$1~")).replace(R[j],"$1^")).split(/\s+/).join(" ");var re=H?R[q]:R[ae],ge=B.split(" ").map(function(Te){return function(xe,qe){return P("comp",xe),xe=function(Ze,tt){return Ze.trim().split(/\s+/).map(function(nt){return function(et,rt){P("caret",et,rt);var ft=rt?R[K]:R[$];return et.replace(ft,function(ct,st,lt,mt,vt){var $e;return P("caret",et,ct,st,lt,mt,vt),Ue(st)?$e="":Ue(lt)?$e=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(mt)?$e=st==="0"?">="+st+"."+lt+".0 <"+st+"."+(+lt+1)+".0":">="+st+"."+lt+".0 <"+(+st+1)+".0.0":vt?(P("replaceCaret pr",vt),vt.charAt(0)!=="-"&&(vt="-"+vt),$e=st==="0"?lt==="0"?">="+st+"."+lt+"."+mt+vt+" <"+st+"."+lt+"."+(+mt+1):">="+st+"."+lt+"."+mt+vt+" <"+st+"."+(+lt+1)+".0":">="+st+"."+lt+"."+mt+vt+" <"+(+st+1)+".0.0"):(P("no pr"),$e=st==="0"?lt==="0"?">="+st+"."+lt+"."+mt+" <"+st+"."+lt+"."+(+mt+1):">="+st+"."+lt+"."+mt+" <"+st+"."+(+lt+1)+".0":">="+st+"."+lt+"."+mt+" <"+(+st+1)+".0.0"),P("caret return",$e),$e})}(nt,tt)}).join(" ")}(xe,qe),P("caret",xe),xe=function(Ze,tt){return Ze.trim().split(/\s+/).map(function(nt){return function(et,rt){var ft=rt?R[N]:R[L];return et.replace(ft,function(ct,st,lt,mt,vt){var $e;return P("tilde",et,ct,st,lt,mt,vt),Ue(st)?$e="":Ue(lt)?$e=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(mt)?$e=">="+st+"."+lt+".0 <"+st+"."+(+lt+1)+".0":vt?(P("replaceTilde pr",vt),vt.charAt(0)!=="-"&&(vt="-"+vt),$e=">="+st+"."+lt+"."+mt+vt+" <"+st+"."+(+lt+1)+".0"):$e=">="+st+"."+lt+"."+mt+" <"+st+"."+(+lt+1)+".0",P("tilde return",$e),$e})}(nt,tt)}).join(" ")}(xe,qe),P("tildes",xe),xe=function(Ze,tt){return P("replaceXRanges",Ze,tt),Ze.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var ft=rt?R[D]:R[T];return et.replace(ft,function(ct,st,lt,mt,vt,$e){P("xRange",et,ct,st,lt,mt,vt,$e);var Be=Ue(lt),ie=Be||Ue(mt),ee=ie||Ue(vt);return st==="="&&ee&&(st=""),Be?ct=st===">"||st==="<"?"<0.0.0":"*":st&&ee?(ie&&(mt=0),ee&&(vt=0),st===">"?(st=">=",ie?(lt=+lt+1,mt=0,vt=0):ee&&(mt=+mt+1,vt=0)):st==="<="&&(st="<",ie?lt=+lt+1:mt=+mt+1),ct=st+lt+"."+mt+"."+vt):ie?ct=">="+lt+".0.0 <"+(+lt+1)+".0.0":ee&&(ct=">="+lt+"."+mt+".0 <"+lt+"."+(+mt+1)+".0"),P("xRange return",ct),ct})}(nt,tt)}).join(" ")}(xe,qe),P("xrange",xe),xe=function(Ze,tt){return P("replaceStars",Ze,tt),Ze.trim().replace(R[le],"")}(xe,qe),P("stars",xe),xe}(Te,H)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Te){return!!Te.match(re)})),ge=ge.map(function(Te){return new ve(Te,H)})},Ae.prototype.intersects=function(B,H){if(!(B instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(V){return V.every(function(re){return B.set.some(function(ge){return ge.every(function(Te){return re.intersects(Te,H)})})})})},e.toComparators=function(B,H){return new Ae(B,H).set.map(function(V){return V.map(function(re){return re.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new De(B,this.loose));for(var H=0;H<this.set.length;H++)if(Pe(this.set[H],B))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(B,H,V){var re=null,ge=null;try{var Te=new Ae(H,V)}catch{return null}return B.forEach(function(xe){Te.test(xe)&&(re&&ge.compare(xe)!==-1||(ge=new De(re=xe,V)))}),re},e.minSatisfying=function(B,H,V){var re=null,ge=null;try{var Te=new Ae(H,V)}catch{return null}return B.forEach(function(xe){Te.test(xe)&&(re&&ge.compare(xe)!==1||(ge=new De(re=xe,V)))}),re},e.validRange=function(B,H){try{return new Ae(B,H).range||"*"}catch{return null}},e.ltr=function(B,H,V){return x(B,H,"<",V)},e.gtr=function(B,H,V){return x(B,H,">",V)},e.outside=x,e.prerelease=function(B,H){var V=oe(B,H);return V&&V.prerelease.length?V.prerelease:null},e.intersects=function(B,H,V){return B=new Ae(B,V),H=new Ae(H,V),B.intersects(H)},e.coerce=function(B){if(B instanceof De)return B;if(typeof B!="string")return null;var H=B.match(R[f]);return H==null?null:oe((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,S(1))},function(Se,e){var S,k,P=Se.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(s){if(S===setTimeout)return setTimeout(s,0);if((S===O||!S)&&setTimeout)return S=setTimeout,setTimeout(s,0);try{return S(s,0)}catch{try{return S.call(null,s,0)}catch{return S.call(this,s,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:O}catch{S=O}try{k=typeof clearTimeout=="function"?clearTimeout:A}catch{k=A}})();var p,o=[],I=!1,w=-1;function a(){I&&p&&(I=!1,p.length?o=p.concat(o):w=-1,o.length&&y())}function y(){if(!I){var s=R(a);I=!0;for(var l=o.length;l;){for(p=o,o=[];++w<l;)p&&p[w].run();w=-1,l=o.length}p=null,I=!1,function(c){if(k===clearTimeout)return clearTimeout(c);if((k===A||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(c);try{k(c)}catch{try{return k.call(null,c)}catch{return k.call(this,c)}}}(s)}}function h(s,l){this.fun=s,this.array=l}function r(){}P.nextTick=function(s){var l=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)l[c-1]=arguments[c];o.push(new h(s,l)),o.length!==1||I||R(y)},h.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(s){return[]},P.binding=function(s){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(s){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Le[146],Ne([1,0,6,4]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SmoothScrollingOperation=e.SmoothScrollingUpdate=e.Scrollable=e.ScrollState=e.ScrollbarVisibility=void 0;var P;(function(y){y[y.Auto=1]="Auto",y[y.Hidden=2]="Hidden",y[y.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(h,r,s,l,c,i,n){this._forceIntegerValues=h,this._scrollStateBrand=void 0,this._forceIntegerValues&&(r=r|0,s=s|0,l=l|0,c=c|0,i=i|0,n=n|0),this.rawScrollLeft=l,this.rawScrollTop=n,r<0&&(r=0),l+r>s&&(l=s-r),l<0&&(l=0),c<0&&(c=0),n+c>i&&(n=i-c),n<0&&(n=0),this.width=r,this.scrollWidth=s,this.scrollLeft=l,this.height=c,this.scrollHeight=i,this.scrollTop=n}equals(h){return this.rawScrollLeft===h.rawScrollLeft&&this.rawScrollTop===h.rawScrollTop&&this.width===h.width&&this.scrollWidth===h.scrollWidth&&this.scrollLeft===h.scrollLeft&&this.height===h.height&&this.scrollHeight===h.scrollHeight&&this.scrollTop===h.scrollTop}withScrollDimensions(h,r){return new O(this._forceIntegerValues,typeof h.width<"u"?h.width:this.width,typeof h.scrollWidth<"u"?h.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof h.height<"u"?h.height:this.height,typeof h.scrollHeight<"u"?h.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(h){return new O(this._forceIntegerValues,this.width,this.scrollWidth,typeof h.scrollLeft<"u"?h.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof h.scrollTop<"u"?h.scrollTop:this.rawScrollTop)}createScrollEvent(h,r){const s=this.width!==h.width,l=this.scrollWidth!==h.scrollWidth,c=this.scrollLeft!==h.scrollLeft,i=this.height!==h.height,n=this.scrollHeight!==h.scrollHeight,t=this.scrollTop!==h.scrollTop;return{inSmoothScrolling:r,oldWidth:h.width,oldScrollWidth:h.scrollWidth,oldScrollLeft:h.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:h.height,oldScrollHeight:h.scrollHeight,oldScrollTop:h.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:s,scrollWidthChanged:l,scrollLeftChanged:c,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.ScrollState=O;class A extends k.Disposable{constructor(h){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new S.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=h.smoothScrollDuration,this._scheduleAtNextAnimationFrame=h.scheduleAtNextAnimationFrame,this._state=new O(h.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(h){this._smoothScrollDuration=h}validateScrollPosition(h){return this._state.withScrollPosition(h)}getScrollDimensions(){return this._state}setScrollDimensions(h,r){const s=this._state.withScrollDimensions(h,r);this._setState(s,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(h){const r=this._state.withScrollPosition(h);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(r,!1)}setScrollPositionSmooth(h,r){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(h);if(this._smoothScrolling){h={scrollLeft:typeof h.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:h.scrollLeft,scrollTop:typeof h.scrollTop>"u"?this._smoothScrolling.to.scrollTop:h.scrollTop};const s=this._state.withScrollPosition(h);if(this._smoothScrolling.to.scrollLeft===s.scrollLeft&&this._smoothScrolling.to.scrollTop===s.scrollTop)return;let l;r?l=new I(this._smoothScrolling.from,s,this._smoothScrolling.startTime,this._smoothScrolling.duration):l=this._smoothScrolling.combine(this._state,s,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=l}else{const s=this._state.withScrollPosition(h);this._smoothScrolling=I.start(this._state,s,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const h=this._smoothScrolling.tick(),r=this._state.withScrollPosition(h);if(this._setState(r,!0),!!this._smoothScrolling){if(h.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(h,r){const s=this._state;s.equals(h)||(this._state=h,this._onScroll.fire(this._state.createScrollEvent(s,r)))}}e.Scrollable=A;class R{constructor(h,r,s){this.scrollLeft=h,this.scrollTop=r,this.isDone=s}}e.SmoothScrollingUpdate=R;function p(y,h){const r=h-y;return function(s){return y+r*a(s)}}function o(y,h,r){return function(s){return s<r?y(s/r):h((s-r)/(1-r))}}class I{constructor(h,r,s,l){this.from=h,this.to=r,this.duration=l,this.startTime=s,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(h,r,s){if(Math.abs(h-r)>2.5*s){let c,i;return h<r?(c=h+.75*s,i=r-.75*s):(c=h-.75*s,i=r+.75*s),o(p(h,c),p(i,r),.33)}return p(h,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(h){this.to=h.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(h){const r=(h-this.startTime)/this.duration;if(r<1){const s=this.scrollLeft(r),l=this.scrollTop(r);return new R(s,l,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(h,r,s){return I.start(h,r,s)}static start(h,r,s){s=s+10;const l=Date.now()-10;return new I(h,r,l,s)}}e.SmoothScrollingOperation=I;function w(y){return Math.pow(y,3)}function a(y){return 1-w(1-y)}}),define(Le[147],Ne([1,0,13,4]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=P,e.isReadableStream=O,e.isReadableBufferedStream=A,e.newWriteableStream=R,e.consumeReadable=o,e.peekReadable=I,e.consumeStream=w,e.listenStream=a,e.peekStream=y,e.toStream=h,e.emptyStream=r,e.toReadable=s,e.transform=l,e.prefixedReadable=c,e.prefixedStream=i;function P(n){const t=n;return t?typeof t.read=="function":!1}function O(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(g=>typeof g=="function"):!1}function A(n){const t=n;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function R(n,t){return new p(n,t)}class p{constructor(t,g){this.reducer=t,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(g=>g(t))}emitError(t){this.listeners.error.length===0?(0,S.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(g=>g(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,g){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(t,g){if(this.state.destroyed)return;let u;switch(t){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const v=u.indexOf(g);v>=0&&u.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function o(n,t){const g=[];let u;for(;(u=n.read())!==null;)g.push(u);return t(g)}function I(n,t,g){const u=[];let v;for(;(v=n.read())!==null&&u.length<g;)u.push(v);return v===null&&u.length>0?t(u):{read:()=>{if(u.length>0)return u.shift();if(typeof v<"u"){const m=v;return v=void 0,m}return n.read()}}}function w(n,t){return new Promise((g,u)=>{const v=[];a(n,{onData:m=>{t&&v.push(m)},onError:m=>{t?u(m):g(void 0)},onEnd:()=>{g(t?t(v):void 0)}})})}function a(n,t,g){n.on("error",u=>{g?.isCancellationRequested||t.onError(u)}),n.on("end",()=>{g?.isCancellationRequested||t.onEnd()}),n.on("data",u=>{g?.isCancellationRequested||t.onData(u)})}function y(n,t){return new Promise((g,u)=>{const v=new k.DisposableStore,m=[],d=E=>{if(m.push(E),m.length>t)return v.dispose(),n.pause(),g({stream:n,buffer:m,ended:!1})},C=E=>(v.dispose(),u(E)),_=()=>(v.dispose(),g({stream:n,buffer:m,ended:!0}));v.add((0,k.toDisposable)(()=>n.removeListener("error",C))),n.on("error",C),v.add((0,k.toDisposable)(()=>n.removeListener("end",_))),n.on("end",_),v.add((0,k.toDisposable)(()=>n.removeListener("data",d))),n.on("data",d)})}function h(n,t){const g=R(t);return g.end(n),g}function r(){const n=R(()=>{throw new Error("not supported")});return n.end(),n}function s(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function l(n,t,g){const u=R(g);return a(n,{onData:v=>u.write(t.data(v)),onError:v=>u.error(t.error?t.error(v):v),onEnd:()=>u.end()}),u}function c(n,t,g){let u=!1;return{read:()=>{const v=t.read();return u?v:(u=!0,v!==null?g([n,v]):n)}}}function i(n,t,g){let u=!1;const v=R(g);return a(t,{onData:m=>u?v.write(m):(u=!0,v.write(g([n,m]))),onError:m=>v.error(m),onEnd:()=>{u||(u=!0,v.write(n)),v.end()}}),v}}),define(Le[22],Ne([1,0,48,147]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=o,e.readUInt16LE=I,e.writeUInt16LE=w,e.readUInt32BE=a,e.writeUInt32BE=y,e.readUInt32LE=h,e.writeUInt32LE=r,e.readUInt8=s,e.writeUInt8=l,e.readableToBuffer=c,e.bufferToReadable=i,e.streamToBuffer=n,e.bufferedStreamToBuffer=t,e.bufferToStream=g,e.streamToBufferReadableStream=u,e.newWriteableBufferStream=v,e.prefixedBufferReadable=m,e.prefixedBufferStream=d,e.decodeBase64=C,e.encodeBase64=T,k=We(k);const P=typeof Buffer<"u",O=new S.Lazy(()=>new Uint8Array(256));let A,R;class p{static alloc(f){return P?new p(Buffer.allocUnsafe(f)):new p(new Uint8Array(f))}static wrap(f){return P&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new p(f)}static fromString(f,b){return!(b?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from(f)):(A||(A=new TextEncoder),new p(A.encode(f)))}static fromByteArray(f){const b=p.alloc(f.length);for(let M=0,L=f.length;M<L;M++)b.buffer[M]=f[M];return b}static concat(f,b){if(typeof b>"u"){b=0;for(let N=0,W=f.length;N<W;N++)b+=f[N].byteLength}const M=p.alloc(b);let L=0;for(let N=0,W=f.length;N<W;N++){const j=f[N];M.set(j,L),L+=j.byteLength}return M}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=p.alloc(this.byteLength);return f.set(this),f}toString(){return P?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(f,b){return new p(this.buffer.subarray(f,b))}set(f,b){if(f instanceof p)this.buffer.set(f.buffer,b);else if(f instanceof Uint8Array)this.buffer.set(f,b);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),b);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return a(this.buffer,f)}writeUInt32BE(f,b){y(this.buffer,f,b)}readUInt32LE(f){return h(this.buffer,f)}writeUInt32LE(f,b){r(this.buffer,f,b)}readUInt8(f){return s(this.buffer,f)}writeUInt8(f,b){l(this.buffer,f,b)}indexOf(f,b=0){return o(this.buffer,f instanceof p?f.buffer:f,b)}}e.VSBuffer=p;function o(D,f,b=0){const M=f.byteLength,L=D.byteLength;if(M===0)return 0;if(M===1)return D.indexOf(f[0]);if(M>L-b)return-1;const N=O.value;N.fill(f.length);for(let K=0;K<f.length;K++)N[f[K]]=f.length-K-1;let W=b+f.length-1,j=W,$=-1;for(;W<L;)if(D[W]===f[j]){if(j===0){$=W;break}W--,j--}else W+=Math.max(f.length-j,N[D[W]]),j=f.length-1;return $}function I(D,f){return D[f+0]<<0>>>0|D[f+1]<<8>>>0}function w(D,f,b){D[b+0]=f&255,f=f>>>8,D[b+1]=f&255}function a(D,f){return D[f]*2**24+D[f+1]*2**16+D[f+2]*2**8+D[f+3]}function y(D,f,b){D[b+3]=f,f=f>>>8,D[b+2]=f,f=f>>>8,D[b+1]=f,f=f>>>8,D[b]=f}function h(D,f){return D[f+0]<<0>>>0|D[f+1]<<8>>>0|D[f+2]<<16>>>0|D[f+3]<<24>>>0}function r(D,f,b){D[b+0]=f&255,f=f>>>8,D[b+1]=f&255,f=f>>>8,D[b+2]=f&255,f=f>>>8,D[b+3]=f&255}function s(D,f){return D[f]}function l(D,f,b){D[b]=f}function c(D){return k.consumeReadable(D,f=>p.concat(f))}function i(D){return k.toReadable(D)}function n(D){return k.consumeStream(D,f=>p.concat(f))}async function t(D){return D.ended?p.concat(D.buffer):p.concat([...D.buffer,await n(D.stream)])}function g(D){return k.toStream(D,f=>p.concat(f))}function u(D){return k.transform(D,{data:f=>typeof f=="string"?p.fromString(f):p.wrap(f)},f=>p.concat(f))}function v(D){return k.newWriteableStream(f=>p.concat(f),D)}function m(D,f){return k.prefixedReadable(D,f,b=>p.concat(b))}function d(D,f){return k.prefixedStream(D,f,b=>p.concat(b))}function C(D){let f=0,b=0,M=0;const L=new Uint8Array(Math.floor(D.length/4*3)),N=j=>{switch(b){case 3:L[M++]=f|j,b=0;break;case 2:L[M++]=f|j>>>2,f=j<<6,b=3;break;case 1:L[M++]=f|j>>>4,f=j<<4,b=2;break;default:f=j<<2,b=1}};for(let j=0;j<D.length;j++){const $=D.charCodeAt(j);if($>=65&&$<=90)N($-65);else if($>=97&&$<=122)N($-97+26);else if($>=48&&$<=57)N($-48+52);else if($===43||$===45)N(62);else if($===47||$===95)N(63);else{if($===61)break;throw new SyntaxError(`Unexpected base64 character ${D[j]}`)}}const W=M;for(;b>0;)N(0);return p.wrap(L).slice(0,W)}const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function T({buffer:D},f=!0,b=!1){const M=b?E:_;let L="";const N=D.byteLength%3;let W=0;for(;W<D.byteLength-N;W+=3){const j=D[W+0],$=D[W+1],K=D[W+2];L+=M[j>>>2],L+=M[(j<<4|$>>>4)&63],L+=M[($<<2|K>>>6)&63],L+=M[K&63]}if(N===1){const j=D[W+0];L+=M[j>>>2],L+=M[j<<4&63],f&&(L+="==")}else if(N===2){const j=D[W+0],$=D[W+1];L+=M[j>>>2],L+=M[(j<<4|$>>>4)&63],L+=M[$<<2&63],f&&(L+="=")}return L}}),define(Le[148],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Le[34],Ne([1,0,97]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=P;var k;(function(A){function R(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=R})(k||(e.ThemeColor=k={}));function P(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(c){const i=R.exec(c.id);if(!i)return p(S.Codicon.error);const[,n,t]=i,g=["codicon","codicon-"+n];return t&&g.push("codicon-modifier-"+t.substring(1)),g}A.asClassNameArray=p;function o(c){return p(c).join(" ")}A.asClassName=o;function I(c){return"."+p(c).join(".")}A.asCSSSelector=I;function w(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||k.isThemeColor(c.color))}A.isThemeIcon=w;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(c){const i=a.exec(c);if(!i)return;const[,n]=i;return{id:n}}A.fromString=y;function h(c){return{id:c}}A.fromId=h;function r(c,i){let n=c.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}A.modify=r;function s(c){const i=c.id.lastIndexOf("~");if(i!==-1)return c.id.substring(i+1)}A.getModifier=s;function l(c,i){return c.id===i.id&&c.color?.id===i.color?.id}A.isEqual=l})(O||(e.ThemeIcon=O={}))}),define(Le[51],Ne([1,0,27,19,20,12,14]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=p,e.toPosixPath=o,e.getRoot=I,e.isUNC=w,e.isValidBasename=r,e.isEqual=s,e.isEqualOrParent=l,e.isWindowsDriveLetter=c,e.sanitizeFilePath=i,e.removeTrailingPathSeparator=n,e.isRootOrDriveLetter=t,e.hasDriveLetter=g,e.getDriveLetter=u,e.indexOfPath=v,e.parseLineAndColumnAware=m,e.randomPath=_;function R(E){return E===S.CharCode.Slash||E===S.CharCode.Backslash}function p(E){return E.replace(/[\\/]/g,k.posix.sep)}function o(E){return E.indexOf("/")===-1&&(E=p(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}function I(E,T=k.posix.sep){if(!E)return"";const D=E.length,f=E.charCodeAt(0);if(R(f)){if(R(E.charCodeAt(1))&&!R(E.charCodeAt(2))){let M=3;const L=M;for(;M<D&&!R(E.charCodeAt(M));M++);if(L!==M&&!R(E.charCodeAt(M+1))){for(M+=1;M<D;M++)if(R(E.charCodeAt(M)))return E.slice(0,M+1).replace(/[\\/]/g,T)}}return T}else if(c(f)&&E.charCodeAt(1)===S.CharCode.Colon)return R(E.charCodeAt(2))?E.slice(0,2)+T:E.slice(0,2);let b=E.indexOf("://");if(b!==-1){for(b+=3;b<D;b++)if(R(E.charCodeAt(b)))return E.slice(0,b+1)}return""}function w(E){if(!P.isWindows||!E||E.length<5)return!1;let T=E.charCodeAt(0);if(T!==S.CharCode.Backslash||(T=E.charCodeAt(1),T!==S.CharCode.Backslash))return!1;let D=2;const f=D;for(;D<E.length&&(T=E.charCodeAt(D),T!==S.CharCode.Backslash);D++);return!(f===D||(T=E.charCodeAt(D+1),isNaN(T)||T===S.CharCode.Backslash))}const a=/[\\/:\*\?"<>\|]/g,y=/[/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(E,T=P.isWindows){const D=T?a:y;return!(!E||E.length===0||/^\s+$/.test(E)||(D.lastIndex=0,D.test(E))||T&&h.test(E)||E==="."||E===".."||T&&E[E.length-1]==="."||T&&E.length!==E.trim().length||E.length>255)}function s(E,T,D){const f=E===T;return!D||f?f:!E||!T?!1:(0,O.equalsIgnoreCase)(E,T)}function l(E,T,D,f=k.sep){if(E===T)return!0;if(!E||!T||T.length>E.length)return!1;if(D){if(!(0,O.startsWithIgnoreCase)(E,T))return!1;if(T.length===E.length)return!0;let M=T.length;return T.charAt(T.length-1)===f&&M--,E.charAt(M)===f}return T.charAt(T.length-1)!==f&&(T+=f),E.indexOf(T)===0}function c(E){return E>=S.CharCode.A&&E<=S.CharCode.Z||E>=S.CharCode.a&&E<=S.CharCode.z}function i(E,T){return P.isWindows&&E.endsWith(":")&&(E+=k.sep),(0,k.isAbsolute)(E)||(E=(0,k.join)(T,E)),E=(0,k.normalize)(E),n(E)}function n(E){return P.isWindows?(E=(0,O.rtrim)(E,k.sep),E.endsWith(":")&&(E+=k.sep)):(E=(0,O.rtrim)(E,k.sep),E||(E=k.sep)),E}function t(E){const T=(0,k.normalize)(E);return P.isWindows?E.length>3?!1:g(T)&&(E.length===2||T.charCodeAt(2)===S.CharCode.Backslash):T===k.posix.sep}function g(E,T=P.isWindows){return T?c(E.charCodeAt(0))&&E.charCodeAt(1)===S.CharCode.Colon:!1}function u(E,T=P.isWindows){return g(E,T)?E[0]:void 0}function v(E,T,D){return T.length>E.length?-1:E===T?0:(D&&(E=E.toLowerCase(),T=T.toLowerCase()),E.indexOf(T))}function m(E){const T=E.split(":");let D,f,b;for(const M of T){const L=Number(M);(0,A.isNumber)(L)?f===void 0?f=L:b===void 0&&(b=L):D=D?[D,M].join(":"):M}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:f!==void 0?f:void 0,column:b!==void 0?b:f!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",C="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function _(E,T,D=8){let f="";for(let M=0;M<D;M++){let L;M===0&&P.isWindows&&!T&&(D===3||D===4)?L=C:L=d,f+=L.charAt(Math.floor(Math.random()*L.length))}let b;return T?b=`${T}-${f}`:b=f,E?(0,k.join)(E,b):b}}),define(Le[149],Ne([1,0,27,28,139,12]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=A,e.matchesContiguousSubString=p,e.matchesSubString=o,e.isUpper=a,e.matchesCamelCase=_,e.matchesWords=E,e.matchesFuzzy=L,e.matchesFuzzy2=N,e.anyScore=W,e.createMatches=j,e.isPatternInWord=ne,e.fuzzyScore=de,e.fuzzyScoreGracefulAggressive=ve,e.fuzzyScoreGraceful=pe,O=We(O);function A(...Ie){return function(Pe,Oe){for(let x=0,B=Ie.length;x<B;x++){const H=Ie[x](Pe,Oe);if(H)return H}return null}}e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(Ie,Pe,Oe){if(!Oe||Oe.length<Pe.length)return null;let x;return Ie?x=O.startsWithIgnoreCase(Oe,Pe):x=Oe.indexOf(Pe)===0,x?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(Ie,Pe){const Oe=Pe.toLowerCase().indexOf(Ie.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+Ie.length}]}function o(Ie,Pe){return I(Ie.toLowerCase(),Pe.toLowerCase(),0,0)}function I(Ie,Pe,Oe,x){if(Oe===Ie.length)return[];if(x===Pe.length)return null;if(Ie[Oe]===Pe[x]){let B=null;return(B=I(Ie,Pe,Oe+1,x+1))?t({start:x,end:x+1},B):null}return I(Ie,Pe,Oe,x+1)}function w(Ie){return S.CharCode.a<=Ie&&Ie<=S.CharCode.z}function a(Ie){return S.CharCode.A<=Ie&&Ie<=S.CharCode.Z}function y(Ie){return S.CharCode.Digit0<=Ie&&Ie<=S.CharCode.Digit9}function h(Ie){return Ie===S.CharCode.Space||Ie===S.CharCode.Tab||Ie===S.CharCode.LineFeed||Ie===S.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ie=>r.add(Ie.charCodeAt(0)));function s(Ie){return h(Ie)||r.has(Ie)}function l(Ie,Pe){return Ie===Pe||s(Ie)&&s(Pe)}const c=new Map;function i(Ie){if(c.has(Ie))return c.get(Ie);let Pe;const Oe=(0,P.getKoreanAltChars)(Ie);return Oe&&(Pe=Oe),c.set(Ie,Pe),Pe}function n(Ie){return w(Ie)||a(Ie)||y(Ie)}function t(Ie,Pe){return Pe.length===0?Pe=[Ie]:Ie.end===Pe[0].start?Pe[0].start=Ie.start:Pe.unshift(Ie),Pe}function g(Ie,Pe){for(let Oe=Pe;Oe<Ie.length;Oe++){const x=Ie.charCodeAt(Oe);if(a(x)||y(x)||Oe>0&&!n(Ie.charCodeAt(Oe-1)))return Oe}return Ie.length}function u(Ie,Pe,Oe,x){if(Oe===Ie.length)return[];if(x===Pe.length)return null;if(Ie[Oe]!==Pe[x].toLowerCase())return null;{let B=null,H=x+1;for(B=u(Ie,Pe,Oe+1,x+1);!B&&(H=g(Pe,H))<Pe.length;)B=u(Ie,Pe,Oe+1,H),H++;return B===null?null:t({start:x,end:x+1},B)}}function v(Ie){let Pe=0,Oe=0,x=0,B=0,H=0;for(let xe=0;xe<Ie.length;xe++)H=Ie.charCodeAt(xe),a(H)&&Pe++,w(H)&&Oe++,n(H)&&x++,y(H)&&B++;const V=Pe/Ie.length,re=Oe/Ie.length,ge=x/Ie.length,Te=B/Ie.length;return{upperPercent:V,lowerPercent:re,alphaPercent:ge,numericPercent:Te}}function m(Ie){const{upperPercent:Pe,lowerPercent:Oe}=Ie;return Oe===0&&Pe>.6}function d(Ie){const{upperPercent:Pe,lowerPercent:Oe,alphaPercent:x,numericPercent:B}=Ie;return Oe>.2&&Pe<.8&&x>.6&&B<.2}function C(Ie){let Pe=0,Oe=0,x=0,B=0;for(let H=0;H<Ie.length;H++)x=Ie.charCodeAt(H),a(x)&&Pe++,w(x)&&Oe++,h(x)&&B++;return(Pe===0||Oe===0)&&B===0?Ie.length<=30:Pe<=5}function _(Ie,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!C(Ie))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Oe=v(Pe);if(!d(Oe)){if(!m(Oe))return null;Pe=Pe.toLowerCase()}let x=null,B=0;for(Ie=Ie.toLowerCase();B<Pe.length&&(x=u(Ie,Pe,0,B))===null;)B=g(Pe,B+1);return x}function E(Ie,Pe,Oe=!1){if(!Pe||Pe.length===0)return null;let x=null,B=0;for(Ie=Ie.toLowerCase(),Pe=Pe.toLowerCase();B<Pe.length&&(x=T(Ie,Pe,0,B,Oe),x===null);)B=D(Pe,B+1);return x}function T(Ie,Pe,Oe,x,B){let H=0;if(Oe===Ie.length)return[];if(x===Pe.length)return null;if(!l(Ie.charCodeAt(Oe),Pe.charCodeAt(x))){const ge=i(Ie.charCodeAt(Oe));if(!ge)return null;for(let Te=0;Te<ge.length;Te++)if(!l(ge[Te],Pe.charCodeAt(x+Te)))return null;H+=ge.length-1}let V=null,re=x+H+1;if(V=T(Ie,Pe,Oe+1,re,B),!B)for(;!V&&(re=D(Pe,re))<Pe.length;)V=T(Ie,Pe,Oe+1,re,B),re++;if(!V)return null;if(Ie.charCodeAt(Oe)!==Pe.charCodeAt(x)){const ge=i(Ie.charCodeAt(Oe));if(!ge)return V;for(let Te=0;Te<ge.length;Te++)if(ge[Te]!==Pe.charCodeAt(x+Te))return V}return t({start:x,end:x+H+1},V)}function D(Ie,Pe){for(let Oe=Pe;Oe<Ie.length;Oe++)if(s(Ie.charCodeAt(Oe))||Oe>0&&s(Ie.charCodeAt(Oe-1)))return Oe;return Ie.length}const f=A(e.matchesPrefix,_,p),b=A(e.matchesPrefix,_,o),M=new k.LRUCache(1e4);function L(Ie,Pe,Oe=!1){if(typeof Ie!="string"||typeof Pe!="string")return null;let x=M.get(Ie);x||(x=new RegExp(O.convertSimple2RegExpPattern(Ie),"i"),M.set(Ie,x));const B=x.exec(Pe);return B?[{start:B.index,end:B.index+B[0].length}]:Oe?b(Ie,Pe):f(Ie,Pe)}function N(Ie,Pe){const Oe=de(Ie,Ie.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?j(Oe):null}function W(Ie,Pe,Oe,x,B,H){const V=Math.min(13,Ie.length);for(;Oe<V;Oe++){const re=de(Ie,Pe,Oe,x,B,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return re}return[0,H]}function j(Ie){if(typeof Ie>"u")return[];const Pe=[],Oe=Ie[1];for(let x=Ie.length-1;x>1;x--){const B=Ie[x]+Oe,H=Pe[Pe.length-1];H&&H.end===B?H.end=B+1:Pe.push({start:B,end:B+1})}return Pe}const $=128;function K(){const Ie=[],Pe=[];for(let Oe=0;Oe<=$;Oe++)Pe[Oe]=0;for(let Oe=0;Oe<=$;Oe++)Ie.push(Pe.slice(0));return Ie}function q(Ie){const Pe=[];for(let Oe=0;Oe<=Ie;Oe++)Pe[Oe]=0;return Pe}const ae=q(2*$),Ee=q(2*$),ce=K(),Z=K(),le=K(),me=!1;function oe(Ie,Pe,Oe,x,B){function H(re,ge,Te=" "){for(;re.length<ge;)re=Te+re;return re}let V=` |   |${x.split("").map(re=>H(re,3)).join("|")}
`;for(let re=0;re<=Oe;re++)re===0?V+=" |":V+=`${Pe[re-1]}|`,V+=Ie[re].slice(0,B+1).map(ge=>H(ge.toString(),3)).join("|")+`
`;return V}function De(Ie,Pe,Oe,x){Ie=Ie.substr(Pe),Oe=Oe.substr(x),console.log(oe(Z,Ie,Ie.length,Oe,Oe.length)),console.log(oe(le,Ie,Ie.length,Oe,Oe.length)),console.log(oe(ce,Ie,Ie.length,Oe,Oe.length))}function Re(Ie,Pe){if(Pe<0||Pe>=Ie.length)return!1;const Oe=Ie.codePointAt(Pe);switch(Oe){case S.CharCode.Underline:case S.CharCode.Dash:case S.CharCode.Period:case S.CharCode.Space:case S.CharCode.Slash:case S.CharCode.Backslash:case S.CharCode.SingleQuote:case S.CharCode.DoubleQuote:case S.CharCode.Colon:case S.CharCode.DollarSign:case S.CharCode.LessThan:case S.CharCode.GreaterThan:case S.CharCode.OpenParen:case S.CharCode.CloseParen:case S.CharCode.OpenSquareBracket:case S.CharCode.CloseSquareBracket:case S.CharCode.OpenCurlyBrace:case S.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.isEmojiImprecise(Oe)}}function Q(Ie,Pe){if(Pe<0||Pe>=Ie.length)return!1;switch(Ie.charCodeAt(Pe)){case S.CharCode.Space:case S.CharCode.Tab:return!0;default:return!1}}function z(Ie,Pe,Oe){return Pe[Ie]!==Oe[Ie]}function ne(Ie,Pe,Oe,x,B,H,V=!1){for(;Pe<Oe&&B<H;)Ie[Pe]===x[B]&&(V&&(ae[Pe]=B),Pe+=1),B+=1;return Pe===Oe}var Ce;(function(Ie){Ie[Ie.Diag=1]="Diag",Ie[Ie.Left=2]="Left",Ie[Ie.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var fe;(function(Ie){Ie.Default=[-100,0];function Pe(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}Ie.isDefault=Pe})(fe||(e.FuzzyScore=fe={}));class be{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Oe){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Oe}}e.FuzzyScoreOptions=be;function de(Ie,Pe,Oe,x,B,H,V=be.default){const re=Ie.length>$?$:Ie.length,ge=x.length>$?$:x.length;if(Oe>=re||H>=ge||re-Oe>ge-H||!ne(Pe,Oe,re,B,H,ge,!0))return;X(re,ge,Oe,H,Pe,B);let Te=1,xe=1,qe=Oe,Ze=H;const tt=[!1];for(Te=1,qe=Oe;qe<re;Te++,qe++){const ct=ae[qe],st=Ee[qe],lt=qe+1<re?Ee[qe+1]:ge;for(xe=ct-H+1,Ze=ct;Ze<lt;xe++,Ze++){let mt=Number.MIN_SAFE_INTEGER,vt=!1;Ze<=st&&(mt=J(Ie,Pe,qe,Oe,x,B,Ze,ge,H,ce[Te-1][xe-1]===0,tt));let $e=0;mt!==Number.MAX_SAFE_INTEGER&&(vt=!0,$e=mt+Z[Te-1][xe-1]);const Be=Ze>ct,ie=Be?Z[Te][xe-1]+(ce[Te][xe-1]>0?-5:0):0,ee=Ze>ct+1&&ce[Te][xe-1]>0,Y=ee?Z[Te][xe-2]+(ce[Te][xe-2]>0?-5:0):0;if(ee&&(!Be||Y>=ie)&&(!vt||Y>=$e))Z[Te][xe]=Y,le[Te][xe]=Ce.LeftLeft,ce[Te][xe]=0;else if(Be&&(!vt||ie>=$e))Z[Te][xe]=ie,le[Te][xe]=Ce.Left,ce[Te][xe]=0;else if(vt)Z[Te][xe]=$e,le[Te][xe]=Ce.Diag,ce[Te][xe]=ce[Te-1][xe-1]+1;else throw new Error("not possible")}}if(me&&De(Ie,Oe,x,H),!tt[0]&&!V.firstMatchCanBeWeak)return;Te--,xe--;const nt=[Z[Te][xe],H];let et=0,rt=0;for(;Te>=1;){let ct=xe;do{const st=le[Te][ct];if(st===Ce.LeftLeft)ct=ct-2;else if(st===Ce.Left)ct=ct-1;else break}while(ct>=1);et>1&&Pe[Oe+Te-1]===B[H+xe-1]&&!z(ct+H-1,x,B)&&et+1>ce[Te][ct]&&(ct=xe),ct===xe?et++:et=1,rt||(rt=ct),Te--,xe=ct-1,nt.push(xe)}ge-H===re&&V.boostFullMatch&&(nt[0]+=2);const ft=rt-re;return nt[0]-=ft,nt}function X(Ie,Pe,Oe,x,B,H){let V=Ie-1,re=Pe-1;for(;V>=Oe&&re>=x;)B[V]===H[re]&&(Ee[V]=re,V--),re--}function J(Ie,Pe,Oe,x,B,H,V,re,ge,Te,xe){if(Pe[Oe]!==H[V])return Number.MIN_SAFE_INTEGER;let qe=1,Ze=!1;return V===Oe-x?qe=Ie[Oe]===B[V]?7:5:z(V,B,H)&&(V===0||!z(V-1,B,H))?(qe=Ie[Oe]===B[V]?7:5,Ze=!0):Re(H,V)&&(V===0||!Re(H,V-1))?qe=5:(Re(H,V-1)||Q(H,V-1))&&(qe=5,Ze=!0),qe>1&&Oe===x&&(xe[0]=!0),Ze||(Ze=z(V,B,H)||Re(H,V-1)||Q(H,V-1)),Oe===x?V>ge&&(qe-=Ze?3:5):Te?qe+=Ze?2:0:qe+=Ze?0:1,V+1===re&&(qe-=Ze?3:5),qe}function ve(Ie,Pe,Oe,x,B,H,V){return Ae(Ie,Pe,Oe,x,B,H,!0,V)}function pe(Ie,Pe,Oe,x,B,H,V){return Ae(Ie,Pe,Oe,x,B,H,!1,V)}function Ae(Ie,Pe,Oe,x,B,H,V,re){let ge=de(Ie,Pe,Oe,x,B,H,re);if(ge&&!V)return ge;if(Ie.length>=3){const Te=Math.min(7,Ie.length-1);for(let xe=Oe+1;xe<Te;xe++){const qe=Ue(Ie,xe);if(qe){const Ze=de(qe,qe.toLowerCase(),Oe,x,B,H,re);Ze&&(Ze[0]-=3,(!ge||Ze[0]>ge[0])&&(ge=Ze))}}}return ge}function Ue(Ie,Pe){if(Pe+1>=Ie.length)return;const Oe=Ie[Pe],x=Ie[Pe+1];if(Oe!==x)return Ie.slice(0,Pe)+x+Oe+Ie.slice(Pe+2)}}),define(Le[98],Ne([1,0,149,12,34]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=p,e.markdownEscapeEscapedIcons=I,e.stripIcons=a,e.getCodiconAriaLabel=y,e.parseLabelWithIcons=r,e.matchesFuzzyIconAware=s;const O="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function p(l){return l.replace(R,(c,i)=>i?c:`\\${c}`)}const o=new RegExp(`\\\\${A.source}`,"g");function I(l){return l.replace(o,c=>`\\${c}`)}const w=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(l){return l.indexOf(O)===-1?l:l.replace(w,(c,i,n,t)=>n?c:i||t||"")}function y(l){return l?l.replace(/\$\((.*?)\)/g,(c,i)=>` ${i} `).trim():""}const h=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(l){h.lastIndex=0;let c="";const i=[];let n=0;for(;;){const t=h.lastIndex,g=h.exec(l),u=l.substring(t,g?.index);if(u.length>0){c+=u;for(let v=0;v<u.length;v++)i.push(n)}if(!g)break;n+=g[0].length}return{text:c,iconOffsets:i}}function s(l,c,i=!1){const{text:n,iconOffsets:t}=c;if(!t||t.length===0)return(0,S.matchesFuzzy)(l,n,i);const g=(0,k.ltrim)(n," "),u=n.length-g.length,v=(0,S.matchesFuzzy)(l,g,i);if(v)for(const m of v){const d=t[m.start+u]+u;m.start+=d,m.end+=d}return v}}),define(Le[35],Ne([1,0,12]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),S=We(S);var k;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(k||(k={})),function(P){const O="error",A="warning",R="warn",p="info",o="ignore";function I(a){return a?S.equalsIgnoreCase(O,a)?P.Error:S.equalsIgnoreCase(A,a)||S.equalsIgnoreCase(R,a)?P.Warning:S.equalsIgnoreCase(p,a)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function w(a){switch(a){case P.Error:return O;case P.Warning:return A;case P.Info:return p;default:return o}}P.toString=w}(k||(k={})),e.default=k}),define(Le[58],Ne([1,0,17,27,12]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class O{constructor(){this._value="",this._pos=0}reset(h){return this._value=h,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(h){const r=h.charCodeAt(0),s=this._value.charCodeAt(this._pos);return r-s}value(){return this._value[this._pos]}}e.StringIterator=O;class A{constructor(h=!0){this._caseSensitive=h}reset(h){return this._value=h,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let h=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===k.CharCode.Period)if(h)this._from++;else break;else h=!1;return this}cmp(h){return this._caseSensitive?(0,P.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class R{constructor(h=!0,r=!0){this._splitOnBackslash=h,this._caseSensitive=r}reset(h){this._from=0,this._to=0,this._value=h,this._valueLen=h.length;for(let r=h.length-1;r>=0;r--,this._valueLen--){const s=this._value.charCodeAt(r);if(!(s===k.CharCode.Slash||this._splitOnBackslash&&s===k.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let h=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===k.CharCode.Slash||this._splitOnBackslash&&r===k.CharCode.Backslash)if(h)this._from++;else break;else h=!1}return this}cmp(h){return this._caseSensitive?(0,P.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var p;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(p||(p={}));class o{constructor(h,r){this._ignorePathCasing=h,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(h){return this._value=h,this._states=[],this._value.scheme&&this._states.push(p.Scheme),this._value.authority&&this._states.push(p.Authority),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(h)),this._pathIterator.reset(h.path),this._pathIterator.value()&&this._states.push(p.Path)),this._ignoreQueryAndFragment(h)||(this._value.query&&this._states.push(p.Query),this._value.fragment&&this._states.push(p.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===p.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===p.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(h){if(this._states[this._stateIdx]===p.Scheme)return(0,P.compareIgnoreCase)(h,this._value.scheme);if(this._states[this._stateIdx]===p.Authority)return(0,P.compareIgnoreCase)(h,this._value.authority);if(this._states[this._stateIdx]===p.Path)return this._pathIterator.cmp(h);if(this._states[this._stateIdx]===p.Query)return(0,P.compare)(h,this._value.query);if(this._states[this._stateIdx]===p.Fragment)return(0,P.compare)(h,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===p.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===p.Authority)return this._value.authority;if(this._states[this._stateIdx]===p.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===p.Query)return this._value.query;if(this._states[this._stateIdx]===p.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=o;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(w||(w={}));class a{static forUris(h=()=>!1,r=()=>!1){return new a(new o(h,r))}static forPaths(h=!1){return new a(new R(void 0,!h))}static forStrings(){return new a(new O)}static forConfigKeys(){return new a(new A)}constructor(h){this._iter=h}clear(){this._root=void 0}fill(h,r){if(r){const s=r.slice(0);(0,S.shuffle)(s);for(const l of s)this.set(l,h)}else{const s=h.slice(0);(0,S.shuffle)(s);for(const l of s)this.set(l[0],l[1])}}set(h,r){const s=this._iter.reset(h);let l;this._root||(this._root=new I,this._root.segment=s.value());const c=[];for(l=this._root;;){const n=s.cmp(l.segment);if(n>0)l.left||(l.left=new I,l.left.segment=s.value()),c.push([w.Left,l]),l=l.left;else if(n<0)l.right||(l.right=new I,l.right.segment=s.value()),c.push([w.Right,l]),l=l.right;else if(s.hasNext())s.next(),l.mid||(l.mid=new I,l.mid.segment=s.value()),c.push([w.Mid,l]),l=l.mid;else break}const i=l.value;l.value=r,l.key=h;for(let n=c.length-1;n>=0;n--){const t=c[n][1];t.updateHeight();const g=t.balanceFactor();if(g<-1||g>1){const u=c[n][0],v=c[n+1][0];if(u===w.Right&&v===w.Right)c[n][1]=t.rotateLeft();else if(u===w.Left&&v===w.Left)c[n][1]=t.rotateRight();else if(u===w.Right&&v===w.Left)t.right=c[n+1][1]=c[n+1][1].rotateRight(),c[n][1]=t.rotateLeft();else if(u===w.Left&&v===w.Right)t.left=c[n+1][1]=c[n+1][1].rotateLeft(),c[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(c[n-1][0]){case w.Left:c[n-1][1].left=c[n][1];break;case w.Right:c[n-1][1].right=c[n][1];break;case w.Mid:c[n-1][1].mid=c[n][1];break}else this._root=c[0][1]}}return i}get(h){return this._getNode(h)?.value}_getNode(h){const r=this._iter.reset(h);let s=this._root;for(;s;){const l=r.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(h){const r=this._getNode(h);return!(r?.value===void 0&&r?.mid===void 0)}delete(h){return this._delete(h,!1)}deleteSuperstr(h){return this._delete(h,!0)}_delete(h,r){const s=this._iter.reset(h),l=[];let c=this._root;for(;c;){const i=s.cmp(c.segment);if(i>0)l.push([w.Left,c]),c=c.left;else if(i<0)l.push([w.Right,c]),c=c.right;else if(s.hasNext())s.next(),l.push([w.Mid,c]),c=c.mid;else break}if(c){if(r?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const i=this._min(c.right);if(i.key){const{key:n,value:t,segment:g}=i;this._delete(i.key,!1),c.key=n,c.value=t,c.segment=g}}else{const i=c.left??c.right;if(l.length>0){const[n,t]=l[l.length-1];switch(n){case w.Left:t.left=i;break;case w.Mid:t.mid=i;break;case w.Right:t.right=i;break}}else this._root=i}for(let i=l.length-1;i>=0;i--){const n=l[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),l[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),l[i][1]=n.rotateRight()),i>0)switch(l[i-1][0]){case w.Left:l[i-1][1].left=l[i][1];break;case w.Right:l[i-1][1].right=l[i][1];break;case w.Mid:l[i-1][1].mid=l[i][1];break}else this._root=l[0][1]}}}_min(h){for(;h.left;)h=h.left;return h}findSubstr(h){const r=this._iter.reset(h);let s=this._root,l;for(;s;){const c=r.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(r.hasNext())r.next(),l=s.value||l,s=s.mid;else break}return s&&s.value||l}findSuperstr(h){return this._findSuperstrOrElement(h,!1)}_findSuperstrOrElement(h,r){const s=this._iter.reset(h);let l=this._root;for(;l;){const c=s.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):r?l.value:void 0}}hasElementOrSubtree(h){return this._findSuperstrOrElement(h,!0)!==void 0}forEach(h){for(const[r,s]of this)h(s,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(h){const r=[];return this._dfsEntries(h,r),r[Symbol.iterator]()}_dfsEntries(h,r){h&&(h.left&&this._dfsEntries(h.left,r),h.value&&r.push([h.key,h.value]),h.mid&&this._dfsEntries(h.mid,r),h.right&&this._dfsEntries(h.right,r))}_isBalanced(){const h=r=>{if(!r)return!0;const s=r.balanceFactor();return s<-1||s>1?!1:h(r.left)&&h(r.right)};return h(this._root)}}e.TernarySearchTree=a}),define(Le[36],Ne([1,0,22,2,37]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=O,e.parse=A,e.revive=p;function O(o){return JSON.stringify(o,R)}function A(o){let I=JSON.parse(o);return I=p(I),I}function R(o,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(o,I=0){if(!o||I>200)return o;if(typeof o=="object"){switch(o.$mid){case P.MarshalledId.Uri:return k.URI.revive(o);case P.MarshalledId.Regexp:return new RegExp(o.source,o.flags);case P.MarshalledId.Date:return new Date(o.source)}if(o instanceof S.VSBuffer||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let w=0;w<o.length;++w)o[w]=p(o[w],I+1);else for(const w in o)Object.hasOwnProperty.call(o,w)&&(o[w]=p(o[w],I+1))}return o}}),define(Le[15],Ne([1,0,13,20,12,2,19]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=p,e.matchesSomeScheme=o,e.getServerRootPath=w,S=We(S),k=We(k),A=We(A);var R;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",h.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(R||(e.Schemas=R={}));function p(h,r){return O.URI.isUri(h)?(0,P.equalsIgnoreCase)(h.scheme,r):(0,P.startsWithIgnoreCase)(h,r+":")}function o(h,...r){return r.some(s=>p(h,s))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r,s){this._serverRootPath=w(r,s)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return A.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(r,s,l){this._hosts[r]=s,this._ports[r]=l}setConnectionToken(r,s){this._connectionTokens[r]=s}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(t){return S.onUnexpectedError(t),r}const s=r.authority;let l=this._hosts[s];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const c=this._ports[s],i=this._connectionTokens[s];let n=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(n+=`&${e.connectionTokenQueryName}=${encodeURIComponent(i)}`),O.URI.from({scheme:k.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${l}:${c}`,path:this._remoteResourcesPath,query:n})}}e.RemoteAuthorities=new I;function w(h,r){return A.posix.join(r??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class a{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(r){const s=this.toUri(r,Se);return this.uriToBrowserUri(s)}uriToBrowserUri(r){return r.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===R.file&&(k.isNative||k.webWorkerOrigin===`${R.vscodeFileResource}://${a.FALLBACK_AUTHORITY}`)?r.with({scheme:R.vscodeFileResource,authority:r.authority||a.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const s=this.toUri(r,Se);return this.uriToFileUri(s)}uriToFileUri(r){return r.scheme===R.vscodeFileResource?r.with({scheme:R.file,authority:r.authority!==a.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,s){return O.URI.isUri(r)?r:O.URI.parse(s.toUrl(r))}}e.FileAccess=new a;var y;(function(h){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(r.get("3"));const s="vscode-coi";function l(i){let n;typeof i=="string"?n=new URL(i).searchParams:i instanceof URL?n=i.searchParams:O.URI.isUri(i)&&(n=new URL(i.toString(!0)).searchParams);const t=n?.get(s);if(t)return r.get(t)}h.getHeadersFromQuery=l;function c(i,n,t){if(!globalThis.crossOriginIsolated)return;const g=n&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(s,g):i[s]=g}h.addSearchParam=c})(y||(e.COI=y={}))}),define(Le[23],Ne([1,0,27,51,15,19,20,12,2]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=o,e.distinctParents=w,e.toLocalResource=y,k=We(k),O=We(O);function o(h){return(0,p.uriToFsPath)(h,!0)}class I{constructor(r){this._ignorePathCasing=r}compare(r,s,l=!1){return r===s?0:(0,R.compare)(this.getComparisonKey(r,l),this.getComparisonKey(s,l))}isEqual(r,s,l=!1){return r===s?!0:!r||!s?!1:this.getComparisonKey(r,l)===this.getComparisonKey(s,l)}getComparisonKey(r,s=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,s,l=!1){if(r.scheme===s.scheme){if(r.scheme===P.Schemas.file)return k.isEqualOrParent(o(r),o(s),this._ignorePathCasing(r))&&r.query===s.query&&(l||r.fragment===s.fragment);if((0,e.isEqualAuthority)(r.authority,s.authority))return k.isEqualOrParent(r.path,s.path,this._ignorePathCasing(r),"/")&&r.query===s.query&&(l||r.fragment===s.fragment)}return!1}joinPath(r,...s){return p.URI.joinPath(r,...s)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return O.posix.basename(r.path)}extname(r){return O.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let s;return r.scheme===P.Schemas.file?s=p.URI.file(O.dirname(o(r))).path:(s=O.posix.dirname(r.path),r.authority&&s.length&&s.charCodeAt(0)!==S.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),s="/")),r.with({path:s})}normalizePath(r){if(!r.path.length)return r;let s;return r.scheme===P.Schemas.file?s=p.URI.file(O.normalize(o(r))).path:s=O.posix.normalize(r.path),r.with({path:s})}relativePath(r,s){if(r.scheme!==s.scheme||!(0,e.isEqualAuthority)(r.authority,s.authority))return;if(r.scheme===P.Schemas.file){const i=O.relative(o(r),o(s));return A.isWindows?k.toSlashes(i):i}let l=r.path||"/";const c=s.path||"/";if(this._ignorePathCasing(r)){let i=0;for(const n=Math.min(l.length,c.length);i<n&&!(l.charCodeAt(i)!==c.charCodeAt(i)&&l.charAt(i).toLowerCase()!==c.charAt(i).toLowerCase());i++);l=c.substr(0,i)+l.substr(i)}return O.posix.relative(l,c)}resolvePath(r,s){if(r.scheme===P.Schemas.file){const l=p.URI.file(O.resolve(o(r),s));return r.with({authority:l.authority,path:l.path})}return s=k.toPosixPath(s),r.with({path:O.posix.resolve(r.path,s)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,s){return r===s||r!==void 0&&s!==void 0&&(0,R.equalsIgnoreCase)(r,s)}hasTrailingPathSeparator(r,s=O.sep){if(r.scheme===P.Schemas.file){const l=o(r);return l.length>k.getRoot(l).length&&l[l.length-1]===s}else{const l=r.path;return l.length>1&&l.charCodeAt(l.length-1)===S.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,s=O.sep){return(0,e.hasTrailingPathSeparator)(r,s)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,s=O.sep){let l=!1;if(r.scheme===P.Schemas.file){const c=o(r);l=c!==void 0&&c.length===k.getRoot(c).length&&c[c.length-1]===s}else{s="/";const c=r.path;l=c.length===1&&c.charCodeAt(c.length-1)===S.CharCode.Slash}return!l&&!(0,e.hasTrailingPathSeparator)(r,s)?r.with({path:r.path+"/"}):r}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(h=>h.scheme===P.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new I(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function w(h,r){const s=[];for(let l=0;l<h.length;l++){const c=r(h[l]);h.some((i,n)=>n===l?!1:(0,e.isEqualOrParent)(c,r(i)))||s.push(h[l])}return s}var a;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function r(s){const l=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[t,g]=n.split(":");t&&g&&l.set(t,g)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&l.set(h.META_DATA_MIME,i),l}h.parseMetaData=r})(a||(e.DataUri=a={}));function y(h,r,s){if(r){let l=h.path;return l&&l[0]!==O.posix.sep&&(l=O.posix.sep+l),h.with({scheme:s,authority:r,path:l})}return h.with({scheme:s})}}),define(Le[10],Ne([1,0,21,13,6,4,23,20,148,48]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=I,e.createCancelablePromise=w,e.raceCancellation=a,e.raceCancellationError=y,e.raceCancellablePromises=h,e.raceTimeout=r,e.asPromise=s,e.promiseWithResolvers=l,e.timeout=C,e.disposableTimeout=_,e.sequence=E,e.first=T,e.firstParallel=D,e.retry=ce,e.createCancelableAsyncIterable=fe;function I(de){return!!de&&typeof de.then=="function"}function w(de){const X=new S.CancellationTokenSource,J=de(X.token),ve=new Promise((pe,Ae)=>{const Ue=X.token.onCancellationRequested(()=>{Ue.dispose(),Ae(new k.CancellationError)});Promise.resolve(J).then(Ie=>{Ue.dispose(),X.dispose(),pe(Ie)},Ie=>{Ue.dispose(),X.dispose(),Ae(Ie)})});return new class{cancel(){X.cancel(),X.dispose()}then(pe,Ae){return ve.then(pe,Ae)}catch(pe){return this.then(void 0,pe)}finally(pe){return ve.finally(pe)}}}function a(de,X,J){return new Promise((ve,pe)=>{const Ae=X.onCancellationRequested(()=>{Ae.dispose(),ve(J)});de.then(ve,pe).finally(()=>Ae.dispose())})}function y(de,X){return new Promise((J,ve)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),ve(new k.CancellationError)});de.then(J,ve).finally(()=>pe.dispose())})}async function h(de){let X=-1;const J=de.map((ve,pe)=>ve.then(Ae=>(X=pe,Ae)));try{return await Promise.race(J)}finally{de.forEach((ve,pe)=>{pe!==X&&ve.cancel()})}}function r(de,X,J){let ve;const pe=setTimeout(()=>{ve?.(void 0),J?.()},X);return Promise.race([de.finally(()=>clearTimeout(pe)),new Promise(Ae=>ve=Ae)])}function s(de){return new Promise((X,J)=>{const ve=de();I(ve)?ve.then(X,J):X(ve)})}function l(){let de,X;return{promise:new Promise((ve,pe)=>{de=ve,X=pe}),resolve:de,reject:X}}class c{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(X){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=X,!this.queuedPromise){const J=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ve=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ve};this.queuedPromise=new Promise(ve=>{this.activePromise.then(J,J).then(ve)})}return new Promise((J,ve)=>{this.queuedPromise.then(J,ve)})}return this.activePromise=X(),new Promise((J,ve)=>{this.activePromise.then(pe=>{this.activePromise=null,J(pe)},pe=>{this.activePromise=null,ve(pe)})})}dispose(){this.isDisposed=!0}}e.Throttler=c;class i{constructor(){this.current=Promise.resolve(null)}queue(X){return this.current=this.current.then(()=>X(),()=>X())}}e.Sequencer=i;class n{constructor(){this.promiseMap=new Map}queue(X,J){const pe=(this.promiseMap.get(X)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.promiseMap.get(X)===pe&&this.promiseMap.delete(X)});return this.promiseMap.set(X,pe),pe}}e.SequencerByKey=n;const t=(de,X)=>{let J=!0;const ve=setTimeout(()=>{J=!1,X()},de);return{isTriggered:()=>J,dispose:()=>{clearTimeout(ve),J=!1}}},g=de=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,de())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class u{constructor(X){this.defaultDelay=X,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(X,J=this.defaultDelay){this.task=X,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((pe,Ae)=>{this.doResolve=pe,this.doReject=Ae}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const pe=this.task;return this.task=null,pe()}}));const ve=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=J===p.MicrotaskDelay?g(ve):t(J,ve),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new k.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class v{constructor(X){this.delayer=new u(X),this.throttler=new c}trigger(X,J){return this.delayer.trigger(()=>this.throttler.queue(X),J)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=v;class m{constructor(){this._isOpen=!1,this._promise=new Promise((X,J)=>{this._completePromise=X})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class d extends m{constructor(X){super(),this._timeout=setTimeout(()=>this.open(),X)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function C(de,X){return X?new Promise((J,ve)=>{const pe=setTimeout(()=>{Ae.dispose(),J()},de),Ae=X.onCancellationRequested(()=>{clearTimeout(pe),Ae.dispose(),ve(new k.CancellationError)})}):w(J=>C(de,J))}function _(de,X=0,J){const ve=setTimeout(()=>{de(),J&&pe.dispose()},X),pe=(0,O.toDisposable)(()=>{clearTimeout(ve),J?.deleteAndLeak(pe)});return J?.add(pe),pe}function E(de){const X=[];let J=0;const ve=de.length;function pe(){return J<ve?de[J++]():null}function Ae(Ue){Ue!=null&&X.push(Ue);const Ie=pe();return Ie?Ie.then(Ae):Promise.resolve(X)}return Promise.resolve(null).then(Ae)}function T(de,X=ve=>!!ve,J=null){let ve=0;const pe=de.length,Ae=()=>{if(ve>=pe)return Promise.resolve(J);const Ue=de[ve++];return Promise.resolve(Ue()).then(Pe=>X(Pe)?Promise.resolve(Pe):Ae())};return Ae()}function D(de,X=ve=>!!ve,J=null){if(de.length===0)return Promise.resolve(J);let ve=de.length;const pe=()=>{ve=-1;for(const Ae of de)Ae.cancel?.()};return new Promise((Ae,Ue)=>{for(const Ie of de)Ie.then(Pe=>{--ve>=0&&X(Pe)?(pe(),Ae(Pe)):ve===0&&Ae(J)}).catch(Pe=>{--ve>=0&&(pe(),Ue(Pe))})})}class f{constructor(X){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=X,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(X){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((J,ve)=>{this.outstandingPromises.push({factory:X,c:J,e:ve}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const X=this.outstandingPromises.shift();this.runningPromises++;const J=X.factory();J.then(X.c,X.e),J.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=f;class b extends f{constructor(){super(1)}}e.Queue=b;class M{constructor(){this.sequentializer=new Z,this.tasks=0}queue(X){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,X())):this.sequentializer.run(this.tasks++,X())}}e.LimitedQueue=M;class L{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const X=new oe;return this.drainers.add(X),X.p}isDrained(){for(const[,X]of this.queues)if(X.size>0)return!1;return!0}queueSize(X,J=A.extUri){const ve=J.getComparisonKey(X);return this.queues.get(ve)?.size??0}queueFor(X,J,ve=A.extUri){const pe=ve.getComparisonKey(X);let Ae=this.queues.get(pe);if(!Ae){Ae=new b;const Ue=this.drainListenerCount++,Ie=P.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.queues.delete(pe),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Ue),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(Ue,Ie),this.queues.set(pe,Ae)}return Ae.queue(J)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const X of this.drainers)X.complete();this.drainers.clear()}dispose(){for(const[,X]of this.queues)X.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=L;class N{constructor(X,J){this._isDisposed=!1,this._token=-1,typeof X=="function"&&typeof J=="number"&&this.setIfNotSet(X,J)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(X,J){if(this._isDisposed)throw new k.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,X()},J)}setIfNotSet(X,J){if(this._isDisposed)throw new k.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,X()},J))}}e.TimeoutTimer=N;class W{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(X,J,ve=globalThis){if(this.isDisposed)throw new k.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=ve.setInterval(()=>{X()},J);this.disposable=(0,O.toDisposable)(()=>{ve.clearInterval(pe),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=W;class j{constructor(X,J){this.timeoutToken=-1,this.runner=X,this.timeout=J,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(X=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,X)}get delay(){return this.timeout}set delay(X){this.timeout=X}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=j;class ${constructor(X,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.runner=X,this.timeout=J,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(X=this.timeout){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(X/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class K extends j{constructor(X,J){super(X,J),this.units=[]}work(X){this.units.push(X),this.isScheduled()||this.schedule()}doRun(){const X=this.units;this.units=[],this.runner?.(X)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=K;class q extends O.Disposable{constructor(X,J){super(),this.options=X,this.handler=J,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(X){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+X.length>this.options.maxBufferedWork)return!1}else if(this.pending+X.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const J of X)this.pendingWork.push(J);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new j(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(de,X)=>{(0,R.setTimeout0)(()=>{if(J)return;const ve=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e._runWhenIdle=(de,X,J)=>{const ve=de.requestIdleCallback(X,typeof J=="number"?{timeout:J}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,de.cancelIdleCallback(ve))}}},e.runWhenGlobalIdle=de=>(0,e._runWhenIdle)(globalThis,de)}();class ae{constructor(X,J){this._didRun=!1,this._executor=()=>{try{this._value=J()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(X,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ae;class Ee extends ae{constructor(X){super(globalThis,X)}}e.GlobalIdleValue=Ee;async function ce(de,X,J){let ve;for(let pe=0;pe<J;pe++)try{return await de()}catch(Ae){ve=Ae,await C(X)}throw ve}class Z{isRunning(X){return typeof X=="number"?this._running?.taskId===X:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(X,J,ve){return this._running={taskId:X,cancel:()=>ve?.(),promise:J},J.then(()=>this.doneRunning(X),()=>this.doneRunning(X)),J}doneRunning(X){this._running&&X===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const X=this._queued;this._queued=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this._queued)this._queued.run=X;else{const{promise:J,resolve:ve,reject:pe}=l();this._queued={run:X,promise:J,promiseResolve:ve,promiseReject:pe}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Z;class le{constructor(X,J=()=>Date.now()){this.interval=X,this.nowFn=J,this.lastIncrementTime=0,this.value=0}increment(){const X=this.nowFn();return X-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=X,this.value=0),this.value++,this.value}}e.IntervalCounter=le;var me;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(me||(me={}));class oe{get isRejected(){return this.outcome?.outcome===me.Rejected}get isResolved(){return this.outcome?.outcome===me.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===me.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((X,J)=>{this.completeCallback=X,this.errorCallback=J})}complete(X){return new Promise(J=>{this.completeCallback(X),this.outcome={outcome:me.Resolved,value:X},J()})}error(X){return new Promise(J=>{this.errorCallback(X),this.outcome={outcome:me.Rejected,value:X},J()})}cancel(){return this.error(new k.CancellationError)}}e.DeferredPromise=oe;var De;(function(de){async function X(ve){let pe;const Ae=await Promise.all(ve.map(Ue=>Ue.then(Ie=>Ie,Ie=>{pe||(pe=Ie)})));if(typeof pe<"u")throw pe;return Ae}de.settled=X;function J(ve){return new Promise(async(pe,Ae)=>{try{await ve(pe,Ae)}catch(Ue){Ae(Ue)}})}de.withAsyncBody=J})(De||(e.Promises=De={}));class Re{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(X){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=X.then(J=>(this._value=J,this._isResolved=!0,J),J=>{throw this._error=J,this._isResolved=!0,J})}requireValue(){if(!this._isResolved)throw new k.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=Re;class Q{constructor(X){this._compute=X,this._promise=new o.Lazy(()=>new Re(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=Q;var z;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(z||(z={}));class ne{static fromArray(X){return new ne(J=>{J.emitMany(X)})}static fromPromise(X){return new ne(async J=>{J.emitMany(await X)})}static fromPromises(X){return new ne(async J=>{await Promise.all(X.map(async ve=>J.emitOne(await ve)))})}static merge(X){return new ne(async J=>{await Promise.all(X.map(async ve=>{for await(const pe of ve)J.emitOne(pe)}))})}static{this.EMPTY=ne.fromArray([])}constructor(X,J){this._state=z.Initial,this._results=[],this._error=null,this._onReturn=J,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const ve={emitOne:pe=>this.emitOne(pe),emitMany:pe=>this.emitMany(pe),reject:pe=>this.reject(pe)};try{await Promise.resolve(X(ve)),this.resolve()}catch(pe){this.reject(pe)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this._state===z.DoneError)throw this._error;if(X<this._results.length)return{done:!1,value:this._results[X++]};if(this._state===z.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(X,J){return new ne(async ve=>{for await(const pe of X)ve.emitOne(J(pe))})}map(X){return ne.map(this,X)}static filter(X,J){return new ne(async ve=>{for await(const pe of X)J(pe)&&ve.emitOne(pe)})}filter(X){return ne.filter(this,X)}static coalesce(X){return ne.filter(X,J=>!!J)}coalesce(){return ne.coalesce(this)}static async toPromise(X){const J=[];for await(const ve of X)J.push(ve);return J}toPromise(){return ne.toPromise(this)}emitOne(X){this._state===z.Initial&&(this._results.push(X),this._onStateChanged.fire())}emitMany(X){this._state===z.Initial&&(this._results=this._results.concat(X),this._onStateChanged.fire())}resolve(){this._state===z.Initial&&(this._state=z.DoneOK,this._onStateChanged.fire())}reject(X){this._state===z.Initial&&(this._state=z.DoneError,this._error=X,this._onStateChanged.fire())}}e.AsyncIterableObject=ne;class Ce extends ne{constructor(X,J){super(J),this._source=X}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Ce;function fe(de){const X=new S.CancellationTokenSource,J=de(X.token);return new Ce(X,async ve=>{const pe=X.token.onCancellationRequested(()=>{pe.dispose(),X.dispose(),ve.reject(new k.CancellationError)});try{for await(const Ae of J){if(X.token.isCancellationRequested)return;ve.emitOne(Ae)}pe.dispose(),X.dispose()}catch(Ae){pe.dispose(),X.dispose(),ve.reject(Ae)}})}class be{constructor(X){this._deferred=new oe,this._asyncIterable=new ne(pe=>{if(J){pe.reject(J);return}return ve&&pe.emitMany(ve),this._errorFn=Ae=>pe.reject(Ae),this._emitFn=Ae=>pe.emitOne(Ae),this._deferred.p},X);let J,ve;this._emitFn=pe=>{ve||(ve=[]),ve.push(pe)},this._errorFn=pe=>{J||(J=pe)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(X){this._errorFn(X),this._deferred.complete()}emitOne(X){this._emitFn(X)}}e.AsyncIterableSource=be}),define(Le[41],Ne([1,0,17,10,27,51,28,19,20,12]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=I,e.splitGlobAware=r,e.match=M,e.parse=L,e.isRelativePattern=N,e.getBasenameTerms=W,e.getPathTerms=j,e.patternsEquals=ae;function I(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const w="[/\\\\]",a="[^/\\\\]",y=/\//g;function h(Ee,ce){switch(Ee){case 0:return"";case 1:return`${a}*?`;default:return`(?:${w}|${a}+${w}${ce?`|${w}${a}+`:""})*?`}}function r(Ee,ce){if(!Ee)return[];const Z=[];let le=!1,me=!1,oe="";for(const De of Ee){switch(De){case ce:if(!le&&!me){Z.push(oe),oe="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":me=!0;break;case"]":me=!1;break}oe+=De}return oe&&Z.push(oe),Z}function s(Ee){if(!Ee)return"";let ce="";const Z=r(Ee,e.GLOB_SPLIT);if(Z.every(le=>le===e.GLOBSTAR))ce=".*";else{let le=!1;Z.forEach((me,oe)=>{if(me===e.GLOBSTAR){if(le)return;ce+=h(2,oe===Z.length-1)}else{let De=!1,Re="",Q=!1,z="";for(const ne of me){if(ne!=="}"&&De){Re+=ne;continue}if(Q&&(ne!=="]"||!z)){let Ce;ne==="-"?Ce=ne:(ne==="^"||ne==="!")&&!z?Ce="^":ne===e.GLOB_SPLIT?Ce="":Ce=(0,o.escapeRegExpCharacters)(ne),z+=Ce;continue}switch(ne){case"{":De=!0;continue;case"[":Q=!0;continue;case"}":{const fe=`(?:${r(Re,",").map(be=>s(be)).join("|")})`;ce+=fe,De=!1,Re="";break}case"]":{ce+="["+z+"]",Q=!1,z="";break}case"?":ce+=a;continue;case"*":ce+=h(1);continue;default:ce+=(0,o.escapeRegExpCharacters)(ne)}}oe<Z.length-1&&(Z[oe+1]!==e.GLOBSTAR||oe+2<Z.length)&&(ce+=w)}le=me===e.GLOBSTAR})}return ce}const l=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new A.LRUCache(1e4),v=function(){return!1},m=function(){return null};function d(Ee,ce){if(!Ee)return m;let Z;typeof Ee!="string"?Z=Ee.pattern:Z=Ee,Z=Z.trim();const le=`${Z}_${!!ce.trimForExclusions}`;let me=u.get(le);if(me)return C(me,Ee);let oe;return l.test(Z)?me=E(Z.substr(4),Z):(oe=c.exec(_(Z,ce)))?me=T(oe[1],Z):(ce.trimForExclusions?n:i).test(Z)?me=D(Z,ce):(oe=t.exec(_(Z,ce)))?me=f(oe[1].substr(1),Z,!0):(oe=g.exec(_(Z,ce)))?me=f(oe[1],Z,!1):me=b(Z),u.set(le,me),C(me,Ee)}function C(Ee,ce){if(typeof ce=="string")return Ee;const Z=function(le,me){return(0,O.isEqualOrParent)(le,ce.base,!p.isLinux)?Ee((0,o.ltrim)(le.substr(ce.base.length),R.sep),me):null};return Z.allBasenames=Ee.allBasenames,Z.allPaths=Ee.allPaths,Z.basenames=Ee.basenames,Z.patterns=Ee.patterns,Z}function _(Ee,ce){return ce.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function E(Ee,ce){return function(Z,le){return typeof Z=="string"&&Z.endsWith(Ee)?ce:null}}function T(Ee,ce){const Z=`/${Ee}`,le=`\\${Ee}`,me=function(De,Re){return typeof De!="string"?null:Re?Re===Ee?ce:null:De===Ee||De.endsWith(Z)||De.endsWith(le)?ce:null},oe=[Ee];return me.basenames=oe,me.patterns=[ce],me.allBasenames=oe,me}function D(Ee,ce){const Z=q(Ee.slice(1,-1).split(",").map(Re=>d(Re,ce)).filter(Re=>Re!==m),Ee),le=Z.length;if(!le)return m;if(le===1)return Z[0];const me=function(Re,Q){for(let z=0,ne=Z.length;z<ne;z++)if(Z[z](Re,Q))return Ee;return null},oe=Z.find(Re=>!!Re.allBasenames);oe&&(me.allBasenames=oe.allBasenames);const De=Z.reduce((Re,Q)=>Q.allPaths?Re.concat(Q.allPaths):Re,[]);return De.length&&(me.allPaths=De),me}function f(Ee,ce,Z){const le=R.sep===R.posix.sep,me=le?Ee:Ee.replace(y,R.sep),oe=R.sep+me,De=R.posix.sep+Ee;let Re;return Z?Re=function(Q,z){return typeof Q=="string"&&(Q===me||Q.endsWith(oe)||!le&&(Q===Ee||Q.endsWith(De)))?ce:null}:Re=function(Q,z){return typeof Q=="string"&&(Q===me||!le&&Q===Ee)?ce:null},Re.allPaths=[(Z?"*/":"./")+Ee],Re}function b(Ee){try{const ce=new RegExp(`^${s(Ee)}$`);return function(Z){return ce.lastIndex=0,typeof Z=="string"&&ce.test(Z)?Ee:null}}catch{return m}}function M(Ee,ce,Z){return!Ee||typeof ce!="string"?!1:L(Ee)(ce,void 0,Z)}function L(Ee,ce={}){if(!Ee)return v;if(typeof Ee=="string"||N(Ee)){const Z=d(Ee,ce);if(Z===m)return v;const le=function(me,oe){return!!Z(me,oe)};return Z.allBasenames&&(le.allBasenames=Z.allBasenames),Z.allPaths&&(le.allPaths=Z.allPaths),le}return $(Ee,ce)}function N(Ee){const ce=Ee;return ce?typeof ce.base=="string"&&typeof ce.pattern=="string":!1}function W(Ee){return Ee.allBasenames||[]}function j(Ee){return Ee.allPaths||[]}function $(Ee,ce){const Z=q(Object.getOwnPropertyNames(Ee).map(Re=>K(Re,Ee[Re],ce)).filter(Re=>Re!==m)),le=Z.length;if(!le)return m;if(!Z.some(Re=>!!Re.requiresSiblings)){if(le===1)return Z[0];const Re=function(ne,Ce){let fe;for(let be=0,de=Z.length;be<de;be++){const X=Z[be](ne,Ce);if(typeof X=="string")return X;(0,k.isThenable)(X)&&(fe||(fe=[]),fe.push(X))}return fe?(async()=>{for(const be of fe){const de=await be;if(typeof de=="string")return de}return null})():null},Q=Z.find(ne=>!!ne.allBasenames);Q&&(Re.allBasenames=Q.allBasenames);const z=Z.reduce((ne,Ce)=>Ce.allPaths?ne.concat(Ce.allPaths):ne,[]);return z.length&&(Re.allPaths=z),Re}const me=function(Re,Q,z){let ne,Ce;for(let fe=0,be=Z.length;fe<be;fe++){const de=Z[fe];de.requiresSiblings&&z&&(Q||(Q=(0,R.basename)(Re)),ne||(ne=Q.substr(0,Q.length-(0,R.extname)(Re).length)));const X=de(Re,Q,ne,z);if(typeof X=="string")return X;(0,k.isThenable)(X)&&(Ce||(Ce=[]),Ce.push(X))}return Ce?(async()=>{for(const fe of Ce){const be=await fe;if(typeof be=="string")return be}return null})():null},oe=Z.find(Re=>!!Re.allBasenames);oe&&(me.allBasenames=oe.allBasenames);const De=Z.reduce((Re,Q)=>Q.allPaths?Re.concat(Q.allPaths):Re,[]);return De.length&&(me.allPaths=De),me}function K(Ee,ce,Z){if(ce===!1)return m;const le=d(Ee,Z);if(le===m)return m;if(typeof ce=="boolean")return le;if(ce){const me=ce.when;if(typeof me=="string"){const oe=(De,Re,Q,z)=>{if(!z||!le(De,Re))return null;const ne=me.replace("$(basename)",()=>Q),Ce=z(ne);return(0,k.isThenable)(Ce)?Ce.then(fe=>fe?Ee:null):Ce?Ee:null};return oe.requiresSiblings=!0,oe}}return le}function q(Ee,ce){const Z=Ee.filter(Re=>!!Re.basenames);if(Z.length<2)return Ee;const le=Z.reduce((Re,Q)=>{const z=Q.basenames;return z?Re.concat(z):Re},[]);let me;if(ce){me=[];for(let Re=0,Q=le.length;Re<Q;Re++)me.push(ce)}else me=Z.reduce((Re,Q)=>{const z=Q.patterns;return z?Re.concat(z):Re},[]);const oe=function(Re,Q){if(typeof Re!="string")return null;if(!Q){let ne;for(ne=Re.length;ne>0;ne--){const Ce=Re.charCodeAt(ne-1);if(Ce===P.CharCode.Slash||Ce===P.CharCode.Backslash)break}Q=Re.substr(ne)}const z=le.indexOf(Q);return z!==-1?me[z]:null};oe.basenames=le,oe.patterns=me,oe.allBasenames=le;const De=Ee.filter(Re=>!Re.basenames);return De.push(oe),De}function ae(Ee,ce){return(0,S.equals)(Ee,ce,(Z,le)=>typeof Z=="string"&&typeof le=="string"?Z===le:typeof Z!="string"&&typeof le!="string"?Z.base===le.base&&Z.pattern===le.pattern:!1)}}),define(Le[59],Ne([1,0,13,98,23,12,2]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=o,e.isMarkdownString=I,e.markdownStringEqual=w,e.escapeMarkdownSyntaxTokens=a,e.appendEscapedMarkdownCodeBlockFence=y,e.escapeDoubleQuotes=h,e.removeMarkdownEscapes=r,e.parseHrefAndDimensions=s;var R;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class p{constructor(c="",i=!1){if(this.value=c,typeof this.value!="string")throw(0,S.illegalArgument)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(c,i=R.Paragraph){return this.value+=a(this.supportThemeIcons?(0,k.escapeIcons)(c):c).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===R.Break?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,i){return this.value+=`
${y(i,c)}
`,this}appendLink(c,i,n){return this.value+="[",this.value+=this._escape(i,"]"),this.value+="](",this.value+=this._escape(String(c),")"),n&&(this.value+=` "${this._escape(this._escape(n,'"'),")")}"`),this.value+=")",this}_escape(c,i){const n=new RegExp((0,O.escapeRegExpCharacters)(i),"g");return c.replace(n,(t,g)=>c.charAt(g-1)!=="\\"?`\\${t}`:t)}}e.MarkdownString=p;function o(l){return I(l)?!l.value:Array.isArray(l)?l.every(o):!0}function I(l){return l instanceof p?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}function w(l,c){return l===c?!0:!l||!c?!1:l.value===c.value&&l.isTrusted===c.isTrusted&&l.supportThemeIcons===c.supportThemeIcons&&l.supportHtml===c.supportHtml&&(l.baseUri===c.baseUri||!!l.baseUri&&!!c.baseUri&&(0,P.isEqual)(A.URI.from(l.baseUri),A.URI.from(c.baseUri)))}function a(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function y(l,c){const i=l.match(/^`+/gm)?.reduce((t,g)=>t.length>g.length?t:g).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${c}`,l,`${"`".repeat(n)}`].join(`
`)}function h(l){return l.replace(/"/g,"&quot;")}function r(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(l){const c=[],i=l.split("|").map(t=>t.trim());l=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),g=/width=(\d+)/.exec(n),u=t?t[1]:"",v=g?g[1]:"",m=isFinite(parseInt(v)),d=isFinite(parseInt(u));m&&c.push(`width="${v}"`),d&&c.push(`height="${u}"`)}return{href:l,dimensions:c}}}),define(Le[99],Ne([1,0,17,51,19,20,23,12]),function(Se,e,S,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=p,e.normalizeDriveLetter=I,e.tildify=a,e.untildify=y,e.shorten=l,e.template=i,e.mnemonicMenuLabel=n,e.mnemonicButtonLabel=t,e.unmnemonicLabel=g,e.splitRecentLabel=u;function p(m,d){const{os:C,tildify:_,relative:E}=d;if(E){const f=o(m,E,C);if(typeof f=="string")return f}let T=m.fsPath;if(C===O.OperatingSystem.Windows&&!O.isWindows?T=T.replace(/\//g,"\\"):C!==O.OperatingSystem.Windows&&O.isWindows&&(T=T.replace(/\\/g,"/")),C!==O.OperatingSystem.Windows&&_?.userHome){const f=_.userHome.fsPath;let b;m.scheme!==_.userHome.scheme&&m.path[0]===P.posix.sep&&m.path[1]!==P.posix.sep?b=_.userHome.with({path:m.path}).fsPath:b=T,T=a(b,f,C)}return(C===O.OperatingSystem.Windows?P.win32:P.posix).normalize(I(T,C===O.OperatingSystem.Windows))}function o(m,d,C){const _=C===O.OperatingSystem.Windows?P.win32:P.posix,E=C===O.OperatingSystem.Linux?A.extUri:A.extUriIgnorePathCase,T=d.getWorkspace(),D=(0,S.firstOrDefault)(T.folders);if(!D)return;m.scheme!==D.uri.scheme&&m.path[0]===P.posix.sep&&m.path[1]!==P.posix.sep&&(m=D.uri.with({path:m.path}));const f=d.getWorkspaceFolder(m);if(!f)return;let b;if(E.isEqual(f.uri,m)?b="":b=E.relativePath(f.uri,m)??"",b&&(b=_.normalize(b)),T.folders.length>1&&!d.noPrefix){const M=f.name?f.name:E.basenameOrAuthority(f.uri);b=b?`${M} \u2022 ${b}`:M}return b}function I(m,d=O.isWindows){return(0,k.hasDriveLetter)(m,d)?m.charAt(0).toUpperCase()+m.slice(1):m}let w=Object.create(null);function a(m,d,C=O.OS){if(C===O.OperatingSystem.Windows||!m||!d)return m;let _=w.original===d?w.normalized:void 0;_||(_=d,O.isWindows&&(_=(0,k.toSlashes)(_)),_=`${(0,R.rtrim)(_,P.posix.sep)}${P.posix.sep}`,w={original:d,normalized:_});let E=m;return O.isWindows&&(E=(0,k.toSlashes)(E)),(C===O.OperatingSystem.Linux?E.startsWith(_):(0,R.startsWithIgnoreCase)(E,_))?`~/${E.substr(_.length)}`:m}function y(m,d){return m.replace(/^~($|\/|\\)/,`${d}$1`)}const h="\u2026",r="\\\\",s="~";function l(m,d=P.sep){const C=new Array(m.length);let _=!1;for(let E=0;E<m.length;E++){const T=m[E];if(T===""){C[E]=`.${d}`;continue}if(!T){C[E]=T;continue}_=!0;let D="",f=T;f.indexOf(r)===0?(D=f.substr(0,f.indexOf(r)+r.length),f=f.substr(f.indexOf(r)+r.length)):f.indexOf(d)===0?(D=f.substr(0,f.indexOf(d)+d.length),f=f.substr(f.indexOf(d)+d.length)):f.indexOf(s)===0&&(D=f.substr(0,f.indexOf(s)+s.length),f=f.substr(f.indexOf(s)+s.length));const b=f.split(d);for(let M=1;_&&M<=b.length;M++)for(let L=b.length-M;_&&L>=0;L--){_=!1;let N=b.slice(L,L+M).join(d);for(let W=0;!_&&W<m.length;W++)if(W!==E&&m[W]&&m[W].indexOf(N)>-1){const j=L+M===b.length,$=L>0&&m[W].indexOf(d)>-1?d+N:N,K=m[W].endsWith($);_=!j||K}if(!_){let W="";(b[0].endsWith(":")||D!=="")&&(L===1&&(L=0,M++,N=b[0]+d+N),L>0&&(W=b[0]+d),W=D+W),L>0&&(W=W+h+d),W=W+N,L+M<b.length&&(W=W+d+h),C[E]=W}}_&&(C[E]=T)}return C}var c;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function i(m,d=Object.create(null)){const C=[];let _=!1,E="";for(const T of m)if(T==="$"||_&&T==="{")E&&C.push({value:E,type:c.TEXT}),E="",_=!0;else if(T==="}"&&_){const D=d[E];if(typeof D=="string")D.length&&C.push({value:D,type:c.VARIABLE});else if(D){const f=C[C.length-1];(!f||f.type!==c.SEPARATOR)&&C.push({value:D.label,type:c.SEPARATOR})}E="",_=!1}else E+=T;return E&&!_&&C.push({value:E,type:c.TEXT}),C.filter((T,D)=>{if(T.type===c.SEPARATOR){const f=C[D-1],b=C[D+1];return[f,b].every(M=>M&&(M.type===c.VARIABLE||M.type===c.TEXT)&&M.value.length>0)}return!0}).map(T=>T.value).join("")}function n(m,d){return O.isMacintosh||d?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):m.replace(/&&|&/g,C=>C==="&"?"&&":"&")}function t(m,d){return O.isMacintosh||d?m.replace(/\(&&\w\)|&&/g,""):O.isWindows?m.replace(/&&|&/g,C=>C==="&"?"&&":"&"):m.replace(/&&/g,"_")}function g(m){return m.replace(/&/g,"&&")}function u(m){if(m.endsWith("]")){const d=m.lastIndexOf(" [",m.length-2);if(d!==-1){const C=v(m.substring(0,d)),_=m.substring(d);return{name:C.name+_,parentPath:C.parentPath}}}return v(m)}function v(m){const d=m.indexOf("/")!==-1?P.posix:P.win32,C=d.basename(m),_=d.dirname(m);return C.length?{name:C,parentPath:_}:{name:_,parentPath:""}}}),define(Le[150],Ne([1,0,22,37,2]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=p,e.transformIncomingURIs=I,e.transformAndReviveIncomingURIs=w;function O(a){return a.toJSON()}class A{constructor(y){this._uriTransformer=y}transformIncoming(y){const h=this._uriTransformer.transformIncoming(y);return h===y?y:O(P.URI.from(h))}transformOutgoing(y){const h=this._uriTransformer.transformOutgoing(y);return h===y?y:O(P.URI.from(h))}transformOutgoingURI(y){const h=this._uriTransformer.transformOutgoing(y);return h===y?y:P.URI.from(h)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(a){return a}transformOutgoing(a){return a}transformOutgoingURI(a){return a}transformOutgoingScheme(a){return a}};function R(a,y,h){if(!a||h>200)return null;if(typeof a=="object"){if(a instanceof P.URI)return y.transformOutgoing(a);for(const r in a)if(Object.hasOwnProperty.call(a,r)){const s=R(a[r],y,h+1);s!==null&&(a[r]=s)}}return null}function p(a,y){const h=R(a,y,0);return h===null?a:h}function o(a,y,h,r){if(!a||r>200)return null;if(typeof a=="object"){if(a.$mid===k.MarshalledId.Uri)return h?P.URI.revive(y.transformIncoming(a)):y.transformIncoming(a);if(a instanceof S.VSBuffer)return null;for(const s in a)if(Object.hasOwnProperty.call(a,s)){const l=o(a[s],y,h,r+1);l!==null&&(a[s]=l)}}return null}function I(a,y){const h=o(a,y,!1,0);return h===null?a:h}function w(a,y){const h=o(a,y,!0,0);return h===null?a:h}}),define(Le[38],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=k;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(P){return S.test(P)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(R){for(let p=0;p<R.length;p++)R[p]=Math.floor(Math.random()*256);return R};const O=new Uint8Array(16),A=[];for(let R=0;R<256;R++)A.push(R.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let p=0,o="";return o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o}}()}),define(Le[151],Ne([1,0,17,40,38]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=O,e.createFileDataTransferItem=A,e.matchesMimeType=o;function O(w){return{asString:async()=>w,asFile:()=>{},value:typeof w=="string"?w:void 0}}function A(w,a,y){const h={id:(0,P.generateUuid)(),name:w,uri:a,data:y};return{asString:async()=>"",asFile:()=>h,value:void 0}}class R{constructor(){this._entries=new Map}get size(){let a=0;for(const y of this._entries)a++;return a}has(a){return this._entries.has(this.toKey(a))}matches(a){const y=[...this._entries.keys()];return k.Iterable.some(this,([h,r])=>r.asFile())&&y.push("files"),I(p(a),y)}get(a){return this._entries.get(this.toKey(a))?.[0]}append(a,y){const h=this._entries.get(a);h?h.push(y):this._entries.set(this.toKey(a),[y])}replace(a,y){this._entries.set(this.toKey(a),[y])}delete(a){this._entries.delete(this.toKey(a))}*[Symbol.iterator](){for(const[a,y]of this._entries)for(const h of y)yield[a,h]}toKey(a){return p(a)}}e.VSDataTransfer=R;function p(w){return w.toLowerCase()}function o(w,a){return I(p(w),a.map(p))}function I(w,a){if(w==="*/*")return a.length>0;if(a.includes(w))return!0;const y=w.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[h,r,s]=y;return s==="*"?a.some(l=>l.startsWith(r+"/")):!1}e.UriList=Object.freeze({create:w=>(0,S.distinct)(w.map(a=>a.toString())).join(`\r
`),split:w=>w.split(`\r
`),parse:w=>e.UriList.split(w).filter(a=>!a.startsWith("#"))})}),define(Le[152],Ne([1,0,10,6,4,36,14]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=p;var R;(function(a){a[a.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",a[a.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function p(a){const y=a;return y?.changed instanceof Map||y?.deleted instanceof Set}var o;(function(a){a[a.None=0]="None",a[a.Initialized=1]="Initialized",a[a.Closed=2]="Closed"})(o||(e.StorageState=o={}));class I extends P.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(y,h=Object.create(null)){super(),this.database=y,this.options=h,this._onDidChangeStorage=this._register(new k.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=o.None,this.cache=new Map,this.flushDelayer=this._register(new S.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){this._onDidChangeStorage.pause();try{y.changed?.forEach((h,r)=>this.acceptExternal(r,h)),y.deleted?.forEach(h=>this.acceptExternal(h,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(y,h){if(this.state===o.Closed)return;let r=!1;(0,A.isUndefinedOrNull)(h)?r=this.cache.delete(y):this.cache.get(y)!==h&&(this.cache.set(y,h),r=!0),r&&this._onDidChangeStorage.fire({key:y,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===o.None&&(this.state=o.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,h){const r=this.cache.get(y);return(0,A.isUndefinedOrNull)(r)?h:r}getBoolean(y,h){const r=this.get(y);return(0,A.isUndefinedOrNull)(r)?h:r==="true"}getNumber(y,h){const r=this.get(y);return(0,A.isUndefinedOrNull)(r)?h:parseInt(r,10)}getObject(y,h){const r=this.get(y);return(0,A.isUndefinedOrNull)(r)?h:(0,O.parse)(r)}async set(y,h,r=!1){if(this.state===o.Closed)return;if((0,A.isUndefinedOrNull)(h))return this.delete(y,r);const s=(0,A.isObject)(h)||Array.isArray(h)?(0,O.stringify)(h):String(h);if(this.cache.get(y)!==s)return this.cache.set(y,s),this.pendingInserts.set(y,s),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire({key:y,external:r}),this.doFlush()}async delete(y,h=!1){if(!(this.state===o.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire({key:y,external:h}),this.doFlush()}async optimize(){if(this.state!==o.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=o.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(!(this.state===o.Closed||this.pendingClose))return this.doFlush(y)}async doFlush(y){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=I;class w{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert?.forEach((h,r)=>this.items.set(r,h)),y.delete?.forEach(h=>this.items.delete(h))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=w}),define(Le[153],Ne([1,0,27]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=P;var k;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(k||(e.StringEOL=k={}));function P(O){let A=0,R=0,p=0,o=k.Unknown;for(let I=0,w=O.length;I<w;I++){const a=O.charCodeAt(I);a===S.CharCode.CarriageReturn?(A===0&&(R=I),A++,I+1<w&&O.charCodeAt(I+1)===S.CharCode.LineFeed?(o|=k.CRLF,I++):o|=k.Invalid,p=I+1):a===S.CharCode.LineFeed&&(o|=k.LF,A===0&&(R=I),A++,p=I+1)}return A===0&&(R=O.length),[A,R,O.length-p,o]}}),define(Le[154],Ne([1,0,12,20,22]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=I,e.decodeUTF16LE=w,S=We(S),k=We(k),P=We(P);let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let R;function p(){return R||(R=new TextDecoder("UTF-16BE")),R}let o;function I(){return o||(o=k.isLittleEndian()?A():p()),o}function w(h,r,s){const l=new Uint16Array(h.buffer,r,s);return s>0&&(l[0]===65279||l[0]===65534)?a(h,r,s):A().decode(l)}function a(h,r,s){const l=[];let c=0;for(let i=0;i<s;i++){const n=P.readUInt16LE(h,r);r+=2,l[c++]=String.fromCharCode(n)}return l.join("")}class y{constructor(r){this._capacity=r|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const r=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return I().decode(r)}_flushBuffer(){const r=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[r]:this._completedStrings[this._completedStrings.length]=r}appendCharCode(r){const s=this._capacity-this._bufferLength;s<=1&&(s===0||S.isHighSurrogate(r))&&this._flushBuffer(),this._buffer[this._bufferLength++]=r}appendASCIICharCode(r){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=r}appendString(r){const s=r.length;if(this._bufferLength+s>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=r;return}for(let l=0;l<s;l++)this._buffer[this._bufferLength++]=r.charCodeAt(l)}}e.StringBuilder=y}),define(Le[155],Ne([1,0,22,154]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=A,S=We(S);function P(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(o,I,w,a){this.oldPosition=o,this.oldText=I,this.newPosition=w,this.newText=a}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static _writeStringSize(o){return 4+2*o.length}static _writeString(o,I,w){const a=I.length;S.writeUInt32BE(o,a,w),w+=4;for(let y=0;y<a;y++)S.writeUInt16LE(o,I.charCodeAt(y),w),w+=2;return w}static _readString(o,I){const w=S.readUInt32BE(o,I);return I+=4,(0,k.decodeUTF16LE)(o,I,w)}writeSize(){return 8+O._writeStringSize(this.oldText)+O._writeStringSize(this.newText)}write(o,I){return S.writeUInt32BE(o,this.oldPosition,I),I+=4,S.writeUInt32BE(o,this.newPosition,I),I+=4,I=O._writeString(o,this.oldText,I),I=O._writeString(o,this.newText,I),I}static read(o,I,w){const a=S.readUInt32BE(o,I);I+=4;const y=S.readUInt32BE(o,I);I+=4;const h=O._readString(o,I);I+=O._writeStringSize(h);const r=O._readString(o,I);return I+=O._writeStringSize(r),w.push(new O(a,h,y,r)),I}}e.TextChange=O;function A(p,o){return p===null||p.length===0?o:new R(p,o).compress()}class R{constructor(o,I){this._prevEdits=o,this._currEdits=I,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let o=0,I=0,w=this._getPrev(o),a=this._getCurr(I);for(;o<this._prevLen||I<this._currLen;){if(w===null){this._acceptCurr(a),a=this._getCurr(++I);continue}if(a===null){this._acceptPrev(w),w=this._getPrev(++o);continue}if(a.oldEnd<=w.newPosition){this._acceptCurr(a),a=this._getCurr(++I);continue}if(w.newEnd<=a.oldPosition){this._acceptPrev(w),w=this._getPrev(++o);continue}if(a.oldPosition<w.newPosition){const[l,c]=R._splitCurr(a,w.newPosition-a.oldPosition);this._acceptCurr(l),a=c;continue}if(w.newPosition<a.oldPosition){const[l,c]=R._splitPrev(w,a.oldPosition-w.newPosition);this._acceptPrev(l),w=c;continue}let r,s;if(a.oldEnd===w.newEnd)r=w,s=a,w=this._getPrev(++o),a=this._getCurr(++I);else if(a.oldEnd<w.newEnd){const[l,c]=R._splitPrev(w,a.oldLength);r=l,s=a,w=c,a=this._getCurr(++I)}else{const[l,c]=R._splitCurr(a,w.newLength);r=w,s=l,w=this._getPrev(++o),a=c}this._result[this._resultLen++]=new O(r.oldPosition,r.oldText,s.newPosition,s.newText),this._prevDeltaOffset+=r.newLength-r.oldLength,this._currDeltaOffset+=s.newLength-s.oldLength}const y=R._merge(this._result);return R._removeNoOps(y)}_acceptCurr(o){this._result[this._resultLen++]=R._rebaseCurr(this._prevDeltaOffset,o),this._currDeltaOffset+=o.newLength-o.oldLength}_getCurr(o){return o<this._currLen?this._currEdits[o]:null}_acceptPrev(o){this._result[this._resultLen++]=R._rebasePrev(this._currDeltaOffset,o),this._prevDeltaOffset+=o.newLength-o.oldLength}_getPrev(o){return o<this._prevLen?this._prevEdits[o]:null}static _rebaseCurr(o,I){return new O(I.oldPosition-o,I.oldText,I.newPosition,I.newText)}static _rebasePrev(o,I){return new O(I.oldPosition,I.oldText,I.newPosition+o,I.newText)}static _splitPrev(o,I){const w=o.newText.substr(0,I),a=o.newText.substr(I);return[new O(o.oldPosition,o.oldText,o.newPosition,w),new O(o.oldEnd,"",o.newPosition+I,a)]}static _splitCurr(o,I){const w=o.oldText.substr(0,I),a=o.oldText.substr(I);return[new O(o.oldPosition,w,o.newPosition,o.newText),new O(o.oldPosition+I,a,o.newEnd,"")]}static _merge(o){if(o.length===0)return o;const I=[];let w=0,a=o[0];for(let y=1;y<o.length;y++){const h=o[y];a.oldEnd===h.oldPosition?a=new O(a.oldPosition,a.oldText+h.oldText,a.newPosition,a.newText+h.newText):(I[w++]=a,a=h)}return I[w++]=a,I}static _removeNoOps(o){if(o.length===0)return o;const I=[];let w=0;for(let a=0;a<o.length;a++){const y=o[a];y.oldText!==y.newText&&(I[w++]=y)}return I}}}),define(Le[156],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Le[157],Ne([1,0,41,19]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=P,e.targetsNotebooks=O;function P(A,R,p,o,I,w){if(Array.isArray(A)){let a=0;for(const y of A){const h=P(y,R,p,o,I,w);if(h===10)return h;h>a&&(a=h)}return a}else{if(typeof A=="string")return o?A==="*"?5:A===p?10:0:0;if(A){const{language:a,pattern:y,scheme:h,hasAccessToAllModels:r,notebookType:s}=A;if(!o&&!r)return 0;s&&I&&(R=I);let l=0;if(h)if(h===R.scheme)l=10;else if(h==="*")l=5;else return 0;if(a)if(a===p)l=10;else if(a==="*")l=Math.max(l,5);else return 0;if(s)if(s===w)l=10;else if(s==="*"&&w!==void 0)l=Math.max(l,5);else return 0;if(y){let c;if(typeof y=="string"?c=y:c={...y,base:(0,k.normalize)(y.base)},c===R.fsPath||(0,S.match)(c,R.fsPath))l=10;else return 0}return l}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(Le[158],Ne([1,0,27,159]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var P;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(o){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=o.open,this.close=o.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(o.notIn))for(let I=0,w=o.notIn.length;I<w;I++)switch(o.notIn[I]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(o){switch(o){case k.StandardTokenType.Other:return!0;case k.StandardTokenType.Comment:return this._inComment;case k.StandardTokenType.String:return this._inString;case k.StandardTokenType.RegEx:return this._inRegEx}}shouldAutoClose(o,I){if(o.getTokenCount()===0)return!0;const w=o.findTokenIndexAtOffset(I-2),a=o.getStandardTokenType(w);return this.isOK(a)}_findNeutralCharacterInRange(o,I){for(let w=o;w<=I;w++){const a=String.fromCharCode(w);if(!this.open.includes(a)&&!this.close.includes(a))return a}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(S.CharCode.Digit0,S.CharCode.Digit9)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(S.CharCode.a,S.CharCode.z)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(S.CharCode.A,S.CharCode.Z))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=O;class A{constructor(o){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of o)R(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),R(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),R(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),R(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&R(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.AutoClosingPairs=A;function R(p,o,I){p.has(o)?p.get(o).push(I):p.set(o,[I])}}),define(Le[160],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=P,e.righttest=O,e.leftRotate=o,e.rightRotate=I,e.rbDelete=w,e.fixInsert=a,e.updateTreeMetadata=y,e.recomputeTreeMetadata=h;class S{constructor(s,l){this.piece=s,this.color=l,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return P(this.right);let s=this;for(;s.parent!==e.SENTINEL&&s.parent.left!==s;)s=s.parent;return s.parent===e.SENTINEL?e.SENTINEL:s.parent}prev(){if(this.left!==e.SENTINEL)return O(this.left);let s=this;for(;s.parent!==e.SENTINEL&&s.parent.right!==s;)s=s.parent;return s.parent===e.SENTINEL?e.SENTINEL:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=S;var k;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(k||(e.NodeColor=k={})),e.SENTINEL=new S(null,k.Black),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=k.Black;function P(r){for(;r.left!==e.SENTINEL;)r=r.left;return r}function O(r){for(;r.right!==e.SENTINEL;)r=r.right;return r}function A(r){return r===e.SENTINEL?0:r.size_left+r.piece.length+A(r.right)}function R(r){return r===e.SENTINEL?0:r.lf_left+r.piece.lineFeedCnt+R(r.right)}function p(){e.SENTINEL.parent=e.SENTINEL}function o(r,s){const l=s.right;l.size_left+=s.size_left+(s.piece?s.piece.length:0),l.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=l.left,l.left!==e.SENTINEL&&(l.left.parent=s),l.parent=s.parent,s.parent===e.SENTINEL?r.root=l:s.parent.left===s?s.parent.left=l:s.parent.right=l,l.left=s,s.parent=l}function I(r,s){const l=s.left;s.left=l.right,l.right!==e.SENTINEL&&(l.right.parent=s),l.parent=s.parent,s.size_left-=l.size_left+(l.piece?l.piece.length:0),s.lf_left-=l.lf_left+(l.piece?l.piece.lineFeedCnt:0),s.parent===e.SENTINEL?r.root=l:s===s.parent.right?s.parent.right=l:s.parent.left=l,l.right=s,s.parent=l}function w(r,s){let l,c;if(s.left===e.SENTINEL?(c=s,l=c.right):s.right===e.SENTINEL?(c=s,l=c.left):(c=P(s.right),l=c.right),c===r.root){r.root=l,l.color=k.Black,s.detach(),p(),r.root.parent=e.SENTINEL;return}const i=c.color===k.Red;if(c===c.parent.left?c.parent.left=l:c.parent.right=l,c===s?(l.parent=c.parent,h(r,l)):(c.parent===s?l.parent=c:l.parent=c.parent,h(r,l),c.left=s.left,c.right=s.right,c.parent=s.parent,c.color=s.color,s===r.root?r.root=c:s===s.parent.left?s.parent.left=c:s.parent.right=c,c.left!==e.SENTINEL&&(c.left.parent=c),c.right!==e.SENTINEL&&(c.right.parent=c),c.size_left=s.size_left,c.lf_left=s.lf_left,h(r,c)),s.detach(),l.parent.left===l){const t=A(l),g=R(l);if(t!==l.parent.size_left||g!==l.parent.lf_left){const u=t-l.parent.size_left,v=g-l.parent.lf_left;l.parent.size_left=t,l.parent.lf_left=g,y(r,l.parent,u,v)}}if(h(r,l.parent),i){p();return}let n;for(;l!==r.root&&l.color===k.Black;)l===l.parent.left?(n=l.parent.right,n.color===k.Red&&(n.color=k.Black,l.parent.color=k.Red,o(r,l.parent),n=l.parent.right),n.left.color===k.Black&&n.right.color===k.Black?(n.color=k.Red,l=l.parent):(n.right.color===k.Black&&(n.left.color=k.Black,n.color=k.Red,I(r,n),n=l.parent.right),n.color=l.parent.color,l.parent.color=k.Black,n.right.color=k.Black,o(r,l.parent),l=r.root)):(n=l.parent.left,n.color===k.Red&&(n.color=k.Black,l.parent.color=k.Red,I(r,l.parent),n=l.parent.left),n.left.color===k.Black&&n.right.color===k.Black?(n.color=k.Red,l=l.parent):(n.left.color===k.Black&&(n.right.color=k.Black,n.color=k.Red,o(r,n),n=l.parent.left),n.color=l.parent.color,l.parent.color=k.Black,n.left.color=k.Black,I(r,l.parent),l=r.root));l.color=k.Black,p()}function a(r,s){for(h(r,s);s!==r.root&&s.parent.color===k.Red;)if(s.parent===s.parent.parent.left){const l=s.parent.parent.right;l.color===k.Red?(s.parent.color=k.Black,l.color=k.Black,s.parent.parent.color=k.Red,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,o(r,s)),s.parent.color=k.Black,s.parent.parent.color=k.Red,I(r,s.parent.parent))}else{const l=s.parent.parent.left;l.color===k.Red?(s.parent.color=k.Black,l.color=k.Black,s.parent.parent.color=k.Red,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,I(r,s)),s.parent.color=k.Black,s.parent.parent.color=k.Red,o(r,s.parent.parent))}r.root.color=k.Black}function y(r,s,l,c){for(;s!==r.root&&s!==e.SENTINEL;)s.parent.left===s&&(s.parent.size_left+=l,s.parent.lf_left+=c),s=s.parent}function h(r,s){let l=0,c=0;if(s!==r.root){for(;s!==r.root&&s===s.parent.right;)s=s.parent;if(s!==r.root)for(s=s.parent,l=A(s.left)-s.size_left,c=R(s.left)-s.lf_left,s.size_left+=l,s.lf_left+=c;s!==r.root&&(l!==0||c!==0);)s.parent.left===s&&(s.parent.size_left+=l,s.parent.lf_left+=c),s=s.parent}}}),define(Le[100],Ne([1,0,27,101,32,52,160,102]),function(Se,e,S,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=w,e.createLineStarts=a;const p=65535;function o(c){let i;return c[c.length-1]<65536?i=new Uint16Array(c.length):i=new Uint32Array(c.length),i.set(c,0),i}class I{constructor(i,n,t,g,u){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=g,this.isBasicASCII=u}}function w(c,i=!0){const n=[0];let t=1;for(let g=0,u=c.length;g<u;g++){const v=c.charCodeAt(g);v===S.CharCode.CarriageReturn?g+1<u&&c.charCodeAt(g+1)===S.CharCode.LineFeed?(n[t++]=g+2,g++):n[t++]=g+1:v===S.CharCode.LineFeed&&(n[t++]=g+1)}return i?o(n):n}function a(c,i){c.length=0,c[0]=0;let n=1,t=0,g=0,u=0,v=!0;for(let d=0,C=i.length;d<C;d++){const _=i.charCodeAt(d);_===S.CharCode.CarriageReturn?d+1<C&&i.charCodeAt(d+1)===S.CharCode.LineFeed?(u++,c[n++]=d+2,d++):(t++,c[n++]=d+1):_===S.CharCode.LineFeed?(g++,c[n++]=d+1):v&&_!==S.CharCode.Tab&&(_<32||_>126)&&(v=!1)}const m=new I(o(c),t,g,u,v);return c.length=0,m}class y{constructor(i,n,t,g,u){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=g,this.length=u}}e.Piece=y;class h{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.StringBuffer=h;class r{constructor(i,n){this._pieces=[],this._tree=i,this._BOM=n,this._index=0,i.root!==A.SENTINEL&&i.iterate(i.root,t=>(t!==A.SENTINEL&&this._pieces.push(t.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class s{constructor(i){this._limit=i,this._cache=[]}get(i){for(let n=this._cache.length-1;n>=0;n--){const t=this._cache[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this._cache.length-1;n>=0;n--){const t=this._cache[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(i)}validate(i){let n=!1;const t=this._cache;for(let g=0;g<t.length;g++){const u=t[g];if(u.node.parent===null||u.nodeStartOffset>=i){t[g]=null,n=!0;continue}}if(n){const g=[];for(const u of t)u!==null&&g.push(u);this._cache=g}}}class l{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this._buffers=[new h("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=A.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=n,this._EOLLength=n.length,this._EOLNormalized=t;let g=null;for(let u=0,v=i.length;u<v;u++)if(i[u].buffer.length>0){i[u].lineStarts||(i[u].lineStarts=w(i[u].buffer));const m=new y(u+1,{line:0,column:0},{line:i[u].lineStarts.length-1,column:i[u].buffer.length-i[u].lineStarts[i[u].lineStarts.length-1]},i[u].lineStarts.length-1,i[u].buffer.length);this._buffers.push(i[u]),g=this.rbInsertRight(g,m)}this._searchCache=new s(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(i){const n=p,t=n-Math.floor(n/3),g=t*2;let u="",v=0;const m=[];if(this.iterate(this.root,d=>{const C=this.getNodeContent(d),_=C.length;if(v<=t||v+_<g)return u+=C,v+=_,!0;const E=u.replace(/\r\n|\r|\n/g,i);return m.push(new h(E,w(E))),u=C,v=_,!0}),v>0){const d=u.replace(/\r\n|\r|\n/g,i);m.push(new h(d,w(d)))}this.create(m,i,!0)}getEOL(){return this._EOL}setEOL(i){this._EOL=i,this._EOLLength=this._EOL.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,g=>{if(g===A.SENTINEL)return!0;const u=this.getNodeContent(g),v=u.length,m=i.nodeAt(n),d=i.nodeAt(n+v),C=i.getValueInRange2(m,d);return n+=v,u===C})}getOffsetAt(i,n){let t=0,g=this.root;for(;g!==A.SENTINEL;)if(g.left!==A.SENTINEL&&g.lf_left+1>=i)g=g.left;else if(g.lf_left+g.piece.lineFeedCnt+1>=i){t+=g.size_left;const u=this.getAccumulatedValue(g,i-g.lf_left-2);return t+=u+n-1}else i-=g.lf_left+g.piece.lineFeedCnt,t+=g.size_left+g.piece.length,g=g.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const g=i;for(;n!==A.SENTINEL;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const u=this.getIndexOf(n,i-n.size_left);if(t+=n.lf_left+u.index,u.index===0){const v=this.getOffsetAt(t+1,1),m=g-v;return new k.Position(t+1,m+1)}return new k.Position(t+1,u.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===A.SENTINEL){const u=this.getOffsetAt(t+1,1),v=g-i-u;return new k.Position(t+1,v+1)}else n=n.right;return new k.Position(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.nodeAt2(i.startLineNumber,i.startColumn),g=this.nodeAt2(i.endLineNumber,i.endColumn),u=this.getValueInRange2(t,g);return n?n!==this._EOL||!this._EOLNormalized?u.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this._EOLNormalized?u:u.replace(/\r\n|\r|\n/g,n):u}getValueInRange2(i,n){if(i.node===n.node){const m=i.node,d=this._buffers[m.piece.bufferIndex].buffer,C=this.offsetInBuffer(m.piece.bufferIndex,m.piece.start);return d.substring(C+i.remainder,C+n.remainder)}let t=i.node;const g=this._buffers[t.piece.bufferIndex].buffer,u=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);let v=g.substring(u+i.remainder,u+t.piece.length);for(t=t.next();t!==A.SENTINEL;){const m=this._buffers[t.piece.bufferIndex].buffer,d=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(t===n.node){v+=m.substring(d,d+n.remainder);break}else v+=m.substr(d,t.piece.length);t=t.next()}return v}getLinesContent(){const i=[];let n=0,t="",g=!1;return this.iterate(this.root,u=>{if(u===A.SENTINEL)return!0;const v=u.piece;let m=v.length;if(m===0)return!0;const d=this._buffers[v.bufferIndex].buffer,C=this._buffers[v.bufferIndex].lineStarts,_=v.start.line,E=v.end.line;let T=C[_]+v.start.column;if(g&&(d.charCodeAt(T)===S.CharCode.LineFeed&&(T++,m--),i[n++]=t,t="",g=!1,m===0))return!0;if(_===E)return!this._EOLNormalized&&d.charCodeAt(T+m-1)===S.CharCode.CarriageReturn?(g=!0,t+=d.substr(T,m-1)):t+=d.substr(T,m),!0;t+=this._EOLNormalized?d.substring(T,Math.max(T,C[_+1]-this._EOLLength)):d.substring(T,C[_+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let D=_+1;D<E;D++)t=this._EOLNormalized?d.substring(C[D],C[D+1]-this._EOLLength):d.substring(C[D],C[D+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this._EOLNormalized&&d.charCodeAt(C[E]+v.end.column-1)===S.CharCode.CarriageReturn?(g=!0,v.end.column===0?n--:t=d.substr(C[E],v.end.column-1)):t=d.substr(C[E],v.end.column),!0}),g&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(i){return this._lastVisitedLine.lineNumber===i?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=i,i===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(i):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(i,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this._buffers[n.piece.bufferIndex],g=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(g)}else{const n=this._buffers[i.node.piece.bufferIndex],g=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(g)}}getLineCharCode(i,n){const t=this.nodeAt2(i,n+1);return this._getCharCode(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this._EOLLength}getCharCode(i){const n=this.nodeAt(i);return this._getCharCode(n)}getNearestChunk(i){const n=this.nodeAt(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===A.SENTINEL)return"";const g=this._buffers[t.piece.bufferIndex],u=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return g.buffer.substring(u,u+t.piece.length)}else{const t=this._buffers[n.node.piece.bufferIndex],g=this.offsetInBuffer(n.node.piece.bufferIndex,n.node.piece.start),u=g+n.remainder,v=g+n.node.piece.length;return t.buffer.substring(u,v)}}findMatchesInNode(i,n,t,g,u,v,m,d,C,_,E){const T=this._buffers[i.piece.bufferIndex],D=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start),f=this.offsetInBuffer(i.piece.bufferIndex,u),b=this.offsetInBuffer(i.piece.bufferIndex,v);let M;const L={line:0,column:0};let N,W;n._wordSeparators?(N=T.buffer.substring(f,b),W=j=>j+f,n.reset(0)):(N=T.buffer,W=j=>j,n.reset(f));do if(M=n.next(N),M){if(W(M.index)>=b)return _;this.positionInBuffer(i,W(M.index)-D,L);const j=this.getLineFeedCnt(i.piece.bufferIndex,u,L),$=L.line===u.line?L.column-u.column+g:L.column+1,K=$+M[0].length;if(E[_++]=(0,R.createFindMatch)(new P.Range(t+j,$,t+j,K),M,d),W(M.index)+M[0].length>=b||_>=C)return _}while(M);return _}findMatchesLineByLine(i,n,t,g){const u=[];let v=0;const m=new R.Searcher(n.wordSeparators,n.regex);let d=this.nodeAt2(i.startLineNumber,i.startColumn);if(d===null)return[];const C=this.nodeAt2(i.endLineNumber,i.endColumn);if(C===null)return[];let _=this.positionInBuffer(d.node,d.remainder);const E=this.positionInBuffer(C.node,C.remainder);if(d.node===C.node)return this.findMatchesInNode(d.node,m,i.startLineNumber,i.startColumn,_,E,n,t,g,v,u),u;let T=i.startLineNumber,D=d.node;for(;D!==C.node;){const b=this.getLineFeedCnt(D.piece.bufferIndex,_,D.piece.end);if(b>=1){const L=this._buffers[D.piece.bufferIndex].lineStarts,N=this.offsetInBuffer(D.piece.bufferIndex,D.piece.start),W=L[_.line+b],j=T===i.startLineNumber?i.startColumn:1;if(v=this.findMatchesInNode(D,m,T,j,_,this.positionInBuffer(D,W-N),n,t,g,v,u),v>=g)return u;T+=b}const M=T===i.startLineNumber?i.startColumn-1:0;if(T===i.endLineNumber){const L=this.getLineContent(T).substring(M,i.endColumn-1);return v=this._findMatchesInLine(n,m,L,i.endLineNumber,M,v,u,t,g),u}if(v=this._findMatchesInLine(n,m,this.getLineContent(T).substr(M),T,M,v,u,t,g),v>=g)return u;T++,d=this.nodeAt2(T,1),D=d.node,_=this.positionInBuffer(d.node,d.remainder)}if(T===i.endLineNumber){const b=T===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(T).substring(b,i.endColumn-1);return v=this._findMatchesInLine(n,m,M,i.endLineNumber,b,v,u,t,g),u}const f=T===i.startLineNumber?i.startColumn:1;return v=this.findMatchesInNode(C.node,m,T,f,_,E,n,t,g,v,u),u}_findMatchesInLine(i,n,t,g,u,v,m,d,C){const _=i.wordSeparators;if(!d&&i.simpleSearch){const T=i.simpleSearch,D=T.length,f=t.length;let b=-D;for(;(b=t.indexOf(T,b+D))!==-1;)if((!_||(0,R.isValidMatch)(_,t,f,b,D))&&(m[v++]=new O.FindMatch(new P.Range(g,b+1+u,g,b+1+D+u),null),v>=C))return v;return v}let E;n.reset(0);do if(E=n.next(t),E&&(m[v++]=(0,R.createFindMatch)(new P.Range(g,E.index+1+u,g,E.index+1+E[0].length+u),E,d),v>=C))return v;while(E);return v}insert(i,n,t=!1){if(this._EOLNormalized=this._EOLNormalized&&t,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==A.SENTINEL){const{node:g,remainder:u,nodeStartOffset:v}=this.nodeAt(i),m=g.piece,d=m.bufferIndex,C=this.positionInBuffer(g,u);if(g.piece.bufferIndex===0&&m.end.line===this._lastChangeBufferPos.line&&m.end.column===this._lastChangeBufferPos.column&&v+m.length===i&&n.length<p){this.appendToNode(g,n),this.computeBufferMetadata();return}if(v===i)this.insertContentToNodeLeft(n,g),this._searchCache.validate(i);else if(v+g.piece.length>i){const _=[];let E=new y(m.bufferIndex,C,m.end,this.getLineFeedCnt(m.bufferIndex,C,m.end),this.offsetInBuffer(d,m.end)-this.offsetInBuffer(d,C));if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.nodeCharCodeAt(g,u)===10){const b={line:E.start.line+1,column:0};E=new y(E.bufferIndex,b,E.end,this.getLineFeedCnt(E.bufferIndex,b,E.end),E.length-1),n+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(n))if(this.nodeCharCodeAt(g,u-1)===13){const b=this.positionInBuffer(g,u-1);this.deleteNodeTail(g,b),n="\r"+n,g.piece.length===0&&_.push(g)}else this.deleteNodeTail(g,C);else this.deleteNodeTail(g,C);const T=this.createNewPieces(n);E.length>0&&this.rbInsertRight(g,E);let D=g;for(let f=0;f<T.length;f++)D=this.rbInsertRight(D,T[f]);this.deleteNodes(_)}else this.insertContentToNodeRight(n,g)}else{const g=this.createNewPieces(n);let u=this.rbInsertLeft(null,g[0]);for(let v=1;v<g.length;v++)u=this.rbInsertRight(u,g[v])}this.computeBufferMetadata()}delete(i,n){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",n<=0||this.root===A.SENTINEL)return;const t=this.nodeAt(i),g=this.nodeAt(i+n),u=t.node,v=g.node;if(u===v){const T=this.positionInBuffer(u,t.remainder),D=this.positionInBuffer(u,g.remainder);if(t.nodeStartOffset===i){if(n===u.piece.length){const f=u.next();(0,A.rbDelete)(this,u),this.validateCRLFWithPrevNode(f),this.computeBufferMetadata();return}this.deleteNodeHead(u,D),this._searchCache.validate(i),this.validateCRLFWithPrevNode(u),this.computeBufferMetadata();return}if(t.nodeStartOffset+u.piece.length===i+n){this.deleteNodeTail(u,T),this.validateCRLFWithNextNode(u),this.computeBufferMetadata();return}this.shrinkNode(u,T,D),this.computeBufferMetadata();return}const m=[],d=this.positionInBuffer(u,t.remainder);this.deleteNodeTail(u,d),this._searchCache.validate(i),u.piece.length===0&&m.push(u);const C=this.positionInBuffer(v,g.remainder);this.deleteNodeHead(v,C),v.piece.length===0&&m.push(v);const _=u.next();for(let T=_;T!==A.SENTINEL&&T!==v;T=T.next())m.push(T);const E=u.piece.length===0?u.prev():u;this.deleteNodes(m),this.validateCRLFWithNextNode(E),this.computeBufferMetadata()}insertContentToNodeLeft(i,n){const t=[];if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.startWithLF(n)){const v=n.piece,m={line:v.start.line+1,column:0},d=new y(v.bufferIndex,m,v.end,this.getLineFeedCnt(v.bufferIndex,m,v.end),v.length-1);n.piece=d,i+=`
`,(0,A.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const g=this.createNewPieces(i);let u=this.rbInsertLeft(n,g[g.length-1]);for(let v=g.length-2;v>=0;v--)u=this.rbInsertLeft(u,g[v]);this.validateCRLFWithPrevNode(u),this.deleteNodes(t)}insertContentToNodeRight(i,n){this.adjustCarriageReturnFromNext(i,n)&&(i+=`
`);const t=this.createNewPieces(i),g=this.rbInsertRight(n,t[0]);let u=g;for(let v=1;v<t.length;v++)u=this.rbInsertRight(u,t[v]);this.validateCRLFWithPrevNode(g)}positionInBuffer(i,n,t){const g=i.piece,u=i.piece.bufferIndex,v=this._buffers[u].lineStarts,d=v[g.start.line]+g.start.column+n;let C=g.start.line,_=g.end.line,E=0,T=0,D=0;for(;C<=_&&(E=C+(_-C)/2|0,D=v[E],E!==_);)if(T=v[E+1],d<D)_=E-1;else if(d>=T)C=E+1;else break;return t?(t.line=E,t.column=d-D,null):{line:E,column:d-D}}getLineFeedCnt(i,n,t){if(t.column===0)return t.line-n.line;const g=this._buffers[i].lineStarts;if(t.line===g.length-1)return t.line-n.line;const u=g[t.line+1],v=g[t.line]+t.column;if(u>v+1)return t.line-n.line;const m=v-1;return this._buffers[i].buffer.charCodeAt(m)===13?t.line-n.line+1:t.line-n.line}offsetInBuffer(i,n){return this._buffers[i].lineStarts[n.line]+n.column}deleteNodes(i){for(let n=0;n<i.length;n++)(0,A.rbDelete)(this,i[n])}createNewPieces(i){if(i.length>p){const _=[];for(;i.length>p;){const T=i.charCodeAt(p-1);let D;T===S.CharCode.CarriageReturn||T>=55296&&T<=56319?(D=i.substring(0,p-1),i=i.substring(p-1)):(D=i.substring(0,p),i=i.substring(p));const f=w(D);_.push(new y(this._buffers.length,{line:0,column:0},{line:f.length-1,column:D.length-f[f.length-1]},f.length-1,D.length)),this._buffers.push(new h(D,f))}const E=w(i);return _.push(new y(this._buffers.length,{line:0,column:0},{line:E.length-1,column:i.length-E[E.length-1]},E.length-1,i.length)),this._buffers.push(new h(i,E)),_}let n=this._buffers[0].buffer.length;const t=w(i,!1);let g=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===n&&n!==0&&this.startWithLF(i)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},g=this._lastChangeBufferPos;for(let _=0;_<t.length;_++)t[_]+=n+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let _=0;_<t.length;_++)t[_]+=n;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1)),this._buffers[0].buffer+=i}const u=this._buffers[0].buffer.length,v=this._buffers[0].lineStarts.length-1,m=u-this._buffers[0].lineStarts[v],d={line:v,column:m},C=new y(0,g,d,this.getLineFeedCnt(0,g,d),u-n);return this._lastChangeBufferPos=d,[C]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(i,n=0){let t=this.root,g="";const u=this._searchCache.get2(i);if(u){t=u.node;const v=this.getAccumulatedValue(t,i-u.nodeStartLineNumber-1),m=this._buffers[t.piece.bufferIndex].buffer,d=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);if(u.nodeStartLineNumber+t.piece.lineFeedCnt===i)g=m.substring(d+v,d+t.piece.length);else{const C=this.getAccumulatedValue(t,i-u.nodeStartLineNumber);return m.substring(d+v,d+C-n)}}else{let v=0;const m=i;for(;t!==A.SENTINEL;)if(t.left!==A.SENTINEL&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const d=this.getAccumulatedValue(t,i-t.lf_left-2),C=this.getAccumulatedValue(t,i-t.lf_left-1),_=this._buffers[t.piece.bufferIndex].buffer,E=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return v+=t.size_left,this._searchCache.set({node:t,nodeStartOffset:v,nodeStartLineNumber:m-(i-1-t.lf_left)}),_.substring(E+d,E+C-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const d=this.getAccumulatedValue(t,i-t.lf_left-2),C=this._buffers[t.piece.bufferIndex].buffer,_=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);g=C.substring(_+d,_+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,v+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.SENTINEL;){const v=this._buffers[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const m=this.getAccumulatedValue(t,0),d=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);return g+=v.substring(d,d+m-n),g}else{const m=this.offsetInBuffer(t.piece.bufferIndex,t.piece.start);g+=v.substr(m,t.piece.length)}t=t.next()}return g}computeBufferMetadata(){let i=this.root,n=1,t=0;for(;i!==A.SENTINEL;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this._lineCnt=n,this._length=t,this._searchCache.validate(this._length)}getIndexOf(i,n){const t=i.piece,g=this.positionInBuffer(i,n),u=g.line-t.start.line;if(this.offsetInBuffer(t.bufferIndex,t.end)-this.offsetInBuffer(t.bufferIndex,t.start)===n){const v=this.getLineFeedCnt(i.piece.bufferIndex,t.start,g);if(v!==u)return{index:v,remainder:0}}return{index:u,remainder:g.column}}getAccumulatedValue(i,n){if(n<0)return 0;const t=i.piece,g=this._buffers[t.bufferIndex].lineStarts,u=t.start.line+n+1;return u>t.end.line?g[t.end.line]+t.end.column-g[t.start.line]-t.start.column:g[u]-g[t.start.line]-t.start.column}deleteNodeTail(i,n){const t=i.piece,g=t.lineFeedCnt,u=this.offsetInBuffer(t.bufferIndex,t.end),v=n,m=this.offsetInBuffer(t.bufferIndex,v),d=this.getLineFeedCnt(t.bufferIndex,t.start,v),C=d-g,_=m-u,E=t.length+_;i.piece=new y(t.bufferIndex,t.start,v,d,E),(0,A.updateTreeMetadata)(this,i,_,C)}deleteNodeHead(i,n){const t=i.piece,g=t.lineFeedCnt,u=this.offsetInBuffer(t.bufferIndex,t.start),v=n,m=this.getLineFeedCnt(t.bufferIndex,v,t.end),d=this.offsetInBuffer(t.bufferIndex,v),C=m-g,_=u-d,E=t.length+_;i.piece=new y(t.bufferIndex,v,t.end,m,E),(0,A.updateTreeMetadata)(this,i,_,C)}shrinkNode(i,n,t){const g=i.piece,u=g.start,v=g.end,m=g.length,d=g.lineFeedCnt,C=n,_=this.getLineFeedCnt(g.bufferIndex,g.start,C),E=this.offsetInBuffer(g.bufferIndex,n)-this.offsetInBuffer(g.bufferIndex,u);i.piece=new y(g.bufferIndex,g.start,C,_,E),(0,A.updateTreeMetadata)(this,i,E-m,_-d);const T=new y(g.bufferIndex,t,v,this.getLineFeedCnt(g.bufferIndex,t,v),this.offsetInBuffer(g.bufferIndex,v)-this.offsetInBuffer(g.bufferIndex,t)),D=this.rbInsertRight(i,T);this.validateCRLFWithPrevNode(D)}appendToNode(i,n){this.adjustCarriageReturnFromNext(n,i)&&(n+=`
`);const t=this.shouldCheckCRLF()&&this.startWithLF(n)&&this.endWithCR(i),g=this._buffers[0].buffer.length;this._buffers[0].buffer+=n;const u=w(n,!1);for(let D=0;D<u.length;D++)u[D]+=g;if(t){const D=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:g-D}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(u.slice(1));const v=this._buffers[0].lineStarts.length-1,m=this._buffers[0].buffer.length-this._buffers[0].lineStarts[v],d={line:v,column:m},C=i.piece.length+n.length,_=i.piece.lineFeedCnt,E=this.getLineFeedCnt(0,i.piece.start,d),T=E-_;i.piece=new y(i.piece.bufferIndex,i.piece.start,d,E,C),this._lastChangeBufferPos=d,(0,A.updateTreeMetadata)(this,i,n.length,T)}nodeAt(i){let n=this.root;const t=this._searchCache.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let g=0;for(;n!==A.SENTINEL;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){g+=n.size_left;const u={node:n,remainder:i-n.size_left,nodeStartOffset:g};return this._searchCache.set(u),u}else i-=n.size_left+n.piece.length,g+=n.size_left+n.piece.length,n=n.right;return null}nodeAt2(i,n){let t=this.root,g=0;for(;t!==A.SENTINEL;)if(t.left!==A.SENTINEL&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const u=this.getAccumulatedValue(t,i-t.lf_left-2),v=this.getAccumulatedValue(t,i-t.lf_left-1);return g+=t.size_left,{node:t,remainder:Math.min(u+n-1,v),nodeStartOffset:g}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const u=this.getAccumulatedValue(t,i-t.lf_left-2);if(u+n-1<=t.piece.length)return{node:t,remainder:u+n-1,nodeStartOffset:g};n-=t.piece.length-u;break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.SENTINEL;){if(t.piece.lineFeedCnt>0){const u=this.getAccumulatedValue(t,0),v=this.offsetOfNode(t);return{node:t,remainder:Math.min(n-1,u),nodeStartOffset:v}}else if(t.piece.length>=n-1){const u=this.offsetOfNode(t);return{node:t,remainder:n-1,nodeStartOffset:u}}else n-=t.piece.length;t=t.next()}return null}nodeCharCodeAt(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this._buffers[i.piece.bufferIndex],g=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(g)}offsetOfNode(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.SENTINEL||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this._buffers[n.bufferIndex].lineStarts,g=n.start.line,u=t[g]+n.start.column;return g===t.length-1||t[g+1]>u+1?!1:this._buffers[n.bufferIndex].buffer.charCodeAt(u)===10}endWithCR(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.SENTINEL||i.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(i,i.piece.length-1)===13}validateCRLFWithPrevNode(i){if(this.shouldCheckCRLF()&&this.startWithLF(i)){const n=i.prev();this.endWithCR(n)&&this.fixCRLF(n,i)}}validateCRLFWithNextNode(i){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const n=i.next();this.startWithLF(n)&&this.fixCRLF(i,n)}}fixCRLF(i,n){const t=[],g=this._buffers[i.piece.bufferIndex].lineStarts;let u;i.piece.end.column===0?u={line:i.piece.end.line-1,column:g[i.piece.end.line]-g[i.piece.end.line-1]-1}:u={line:i.piece.end.line,column:i.piece.end.column-1};const v=i.piece.length-1,m=i.piece.lineFeedCnt-1;i.piece=new y(i.piece.bufferIndex,i.piece.start,u,m,v),(0,A.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&t.push(i);const d={line:n.piece.start.line+1,column:0},C=n.piece.length-1,_=this.getLineFeedCnt(n.piece.bufferIndex,d,n.piece.end);n.piece=new y(n.piece.bufferIndex,d,n.piece.end,_,C),(0,A.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&t.push(n);const E=this.createNewPieces(`\r
`);this.rbInsertRight(i,E[0]);for(let T=0;T<t.length;T++)(0,A.rbDelete)(this,t[T])}adjustCarriageReturnFromNext(i,n){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const t=n.next();if(this.startWithLF(t)){if(i+=`
`,t.piece.length===1)(0,A.rbDelete)(this,t);else{const g=t.piece,u={line:g.start.line+1,column:0},v=g.length-1,m=this.getLineFeedCnt(g.bufferIndex,u,g.end);t.piece=new y(g.bufferIndex,u,g.end,m,v),(0,A.updateTreeMetadata)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.SENTINEL)return n(A.SENTINEL);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}getNodeContent(i){if(i===A.SENTINEL)return"";const n=this._buffers[i.piece.bufferIndex],t=i.piece,g=this.offsetInBuffer(t.bufferIndex,t.start),u=this.offsetInBuffer(t.bufferIndex,t.end);return n.buffer.substring(g,u)}getPieceContent(i){const n=this._buffers[i.bufferIndex],t=this.offsetInBuffer(i.bufferIndex,i.start),g=this.offsetInBuffer(i.bufferIndex,i.end);return n.buffer.substring(t,g)}rbInsertRight(i,n){const t=new A.TreeNode(n,A.NodeColor.Red);if(t.left=A.SENTINEL,t.right=A.SENTINEL,t.parent=A.SENTINEL,t.size_left=0,t.lf_left=0,this.root===A.SENTINEL)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.SENTINEL)i.right=t,t.parent=i;else{const u=(0,A.leftest)(i.right);u.left=t,t.parent=u}return(0,A.fixInsert)(this,t),t}rbInsertLeft(i,n){const t=new A.TreeNode(n,A.NodeColor.Red);if(t.left=A.SENTINEL,t.right=A.SENTINEL,t.parent=A.SENTINEL,t.size_left=0,t.lf_left=0,this.root===A.SENTINEL)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.SENTINEL)i.left=t,t.parent=i;else{const g=(0,A.righttest)(i.left);g.right=t,t.parent=g}return(0,A.fixInsert)(this,t),t}getContentOfSubTree(i){let n="";return this.iterate(i,t=>(n+=this.getNodeContent(t),!0)),n}}e.PieceTreeBase=l}),define(Le[161],Ne([1,0,6,12,32,52,100,153,155,4]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0,k=We(k);class I extends o.Disposable{constructor(a,y,h,r,s,l,c){super(),this._onDidChangeContent=this._register(new S.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=y,this._mightContainNonBasicASCII=!l,this._mightContainRTL=r,this._mightContainUnusualLineTerminators=s,this._pieceTree=new A.PieceTreeBase(a,h,c)}equals(a){return!(a instanceof I)||this._BOM!==a._BOM||this.getEOL()!==a.getEOL()?!1:this._pieceTree.equal(a._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(a){return this._pieceTree.createSnapshot(a?this._BOM:"")}getOffsetAt(a,y){return this._pieceTree.getOffsetAt(a,y)}getPositionAt(a){return this._pieceTree.getPositionAt(a)}getRangeAt(a,y){const h=a+y,r=this.getPositionAt(a),s=this.getPositionAt(h);return new P.Range(r.lineNumber,r.column,s.lineNumber,s.column)}getValueInRange(a,y=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return"";const h=this._getEndOfLine(y);return this._pieceTree.getValueInRange(a,h)}getValueLengthInRange(a,y=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return 0;if(a.startLineNumber===a.endLineNumber)return a.endColumn-a.startColumn;const h=this.getOffsetAt(a.startLineNumber,a.startColumn),r=this.getOffsetAt(a.endLineNumber,a.endColumn);let s=0;const l=this._getEndOfLine(y),c=this.getEOL();if(l.length!==c.length){const i=l.length-c.length,n=a.endLineNumber-a.startLineNumber;s=i*n}return r-h+s}getCharacterCountInRange(a,y=O.EndOfLinePreference.TextDefined){if(this._mightContainNonBasicASCII){let h=0;const r=a.startLineNumber,s=a.endLineNumber;for(let l=r;l<=s;l++){const c=this.getLineContent(l),i=l===r?a.startColumn-1:0,n=l===s?a.endColumn-1:c.length;for(let t=i;t<n;t++)k.isHighSurrogate(c.charCodeAt(t))?(h=h+1,t=t+1):h=h+1}return h+=this._getEndOfLine(y).length*(s-r),h}return this.getValueLengthInRange(a,y)}getNearestChunk(a){return this._pieceTree.getNearestChunk(a)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(a){return this._pieceTree.getLineContent(a)}getLineCharCode(a,y){return this._pieceTree.getLineCharCode(a,y)}getCharCode(a){return this._pieceTree.getCharCode(a)}getLineLength(a){return this._pieceTree.getLineLength(a)}getLineMinColumn(a){return 1}getLineMaxColumn(a){return this.getLineLength(a)+1}getLineFirstNonWhitespaceColumn(a){const y=k.firstNonWhitespaceIndex(this.getLineContent(a));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(a){const y=k.lastNonWhitespaceIndex(this.getLineContent(a));return y===-1?0:y+2}_getEndOfLine(a){switch(a){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(a){this._pieceTree.setEOL(a)}applyEdits(a,y,h){let r=this._mightContainRTL,s=this._mightContainUnusualLineTerminators,l=this._mightContainNonBasicASCII,c=!0,i=[];for(let d=0;d<a.length;d++){const C=a[d];c&&C._isTracked&&(c=!1);const _=C.range;if(C.text){let b=!0;l||(b=!k.isBasicASCII(C.text),l=b),!r&&b&&(r=k.containsRTL(C.text)),!s&&b&&(s=k.containsUnusualLineTerminators(C.text))}let E="",T=0,D=0,f=0;if(C.text){let b;[T,D,f,b]=(0,R.countEOL)(C.text);const M=this.getEOL(),L=M===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;b===R.StringEOL.Unknown||b===L?E=C.text:E=C.text.replace(/\r\n|\r|\n/g,M)}i[d]={sortIndex:d,identifier:C.identifier||null,range:_,rangeOffset:this.getOffsetAt(_.startLineNumber,_.startColumn),rangeLength:this.getValueLengthInRange(_),text:E,eolCount:T,firstLineLength:D,lastLineLength:f,forceMoveMarkers:!!C.forceMoveMarkers,isAutoWhitespaceEdit:C.isAutoWhitespaceEdit||!1}}i.sort(I._sortOpsAscending);let n=!1;for(let d=0,C=i.length-1;d<C;d++){const _=i[d].range.getEndPosition(),E=i[d+1].range.getStartPosition();if(E.isBeforeOrEqual(_)){if(E.isBefore(_))throw new Error("Overlapping ranges are not allowed!");n=!0}}c&&(i=this._reduceOperations(i));const t=h||y?I._getInverseEditRanges(i):[],g=[];if(y)for(let d=0;d<i.length;d++){const C=i[d],_=t[d];if(C.isAutoWhitespaceEdit&&C.range.isEmpty())for(let E=_.startLineNumber;E<=_.endLineNumber;E++){let T="";E===_.startLineNumber&&(T=this.getLineContent(C.range.startLineNumber),k.firstNonWhitespaceIndex(T)!==-1)||g.push({lineNumber:E,oldContent:T})}}let u=null;if(h){let d=0;u=[];for(let C=0;C<i.length;C++){const _=i[C],E=t[C],T=this.getValueInRange(_.range),D=_.rangeOffset+d;d+=_.text.length-T.length,u[C]={sortIndex:_.sortIndex,identifier:_.identifier,range:E,text:T,textChange:new p.TextChange(_.rangeOffset,T,D,_.text)}}n||u.sort((C,_)=>C.sortIndex-_.sortIndex)}this._mightContainRTL=r,this._mightContainUnusualLineTerminators=s,this._mightContainNonBasicASCII=l;const v=this._doApplyEdits(i);let m=null;if(y&&g.length>0){g.sort((d,C)=>C.lineNumber-d.lineNumber),m=[];for(let d=0,C=g.length;d<C;d++){const _=g[d].lineNumber;if(d>0&&g[d-1].lineNumber===_)continue;const E=g[d].oldContent,T=this.getLineContent(_);T.length===0||T===E||k.firstNonWhitespaceIndex(T)!==-1||m.push(_)}}return this._onDidChangeContent.fire(),new O.ApplyEditsResult(u,v,m)}_reduceOperations(a){return a.length<1e3?a:[this._toSingleEditOperation(a)]}_toSingleEditOperation(a){let y=!1;const h=a[0].range,r=a[a.length-1].range,s=new P.Range(h.startLineNumber,h.startColumn,r.endLineNumber,r.endColumn);let l=h.startLineNumber,c=h.startColumn;const i=[];for(let v=0,m=a.length;v<m;v++){const d=a[v],C=d.range;y=y||d.forceMoveMarkers,i.push(this.getValueInRange(new P.Range(l,c,C.startLineNumber,C.startColumn))),d.text.length>0&&i.push(d.text),l=C.endLineNumber,c=C.endColumn}const n=i.join(""),[t,g,u]=(0,R.countEOL)(n);return{sortIndex:0,identifier:a[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,O.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:g,lastLineLength:u,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}_doApplyEdits(a){a.sort(I._sortOpsDescending);const y=[];for(let h=0;h<a.length;h++){const r=a[h],s=r.range.startLineNumber,l=r.range.startColumn,c=r.range.endLineNumber,i=r.range.endColumn;if(s===c&&l===i&&r.text.length===0)continue;r.text?(this._pieceTree.delete(r.rangeOffset,r.rangeLength),this._pieceTree.insert(r.rangeOffset,r.text,!0)):this._pieceTree.delete(r.rangeOffset,r.rangeLength);const n=new P.Range(s,l,c,i);y.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return y}findMatchesLineByLine(a,y,h,r){return this._pieceTree.findMatchesLineByLine(a,y,h,r)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(a,y){const h=a.startLineNumber,r=a.startColumn,[s,l,c]=(0,R.countEOL)(y);let i;if(y.length>0){const n=s+1;n===1?i=new P.Range(h,r,h,r+l):i=new P.Range(h,r,h+n-1,c+1)}else i=new P.Range(h,r,h,r);return i}static _getInverseEditRanges(a){const y=[];let h=0,r=0,s=null;for(let l=0,c=a.length;l<c;l++){const i=a[l];let n,t;s?s.range.endLineNumber===i.range.startLineNumber?(n=h,t=r+(i.range.startColumn-s.range.endColumn)):(n=h+(i.range.startLineNumber-s.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let g;if(i.text.length>0){const u=i.eolCount+1;u===1?g=new P.Range(n,t,n,t+i.firstLineLength):g=new P.Range(n,t,n+u-1,i.lastLineLength+1)}else g=new P.Range(n,t,n,t);h=g.endLineNumber,r=g.endColumn,y.push(g),s=i}return y}static _sortOpsAscending(a,y){const h=P.Range.compareRangesUsingEnds(a.range,y.range);return h===0?a.sortIndex-y.sortIndex:h}static _sortOpsDescending(a,y){const h=P.Range.compareRangesUsingEnds(a.range,y.range);return h===0?y.sortIndex-a.sortIndex:-h}}e.PieceTreeTextBuffer=I}),define(Le[162],Ne([1,0,27,12,52,100,161]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0,k=We(k);class R{constructor(I,w,a,y,h,r,s,l,c){this._chunks=I,this._bom=w,this._cr=a,this._lf=y,this._crlf=h,this._containsRTL=r,this._containsUnusualLineTerminators=s,this._isBasicASCII=l,this._normalizeEOL=c}_getEOL(I){const w=this._cr+this._lf+this._crlf,a=this._cr+this._crlf;return w===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:a>w/2?`\r
`:`
`}create(I){const w=this._getEOL(I),a=this._chunks;if(this._normalizeEOL&&(w===`\r
`&&(this._cr>0||this._lf>0)||w===`
`&&(this._cr>0||this._crlf>0)))for(let h=0,r=a.length;h<r;h++){const s=a[h].buffer.replace(/\r\n|\r|\n/g,w),l=(0,O.createLineStartsFast)(s);a[h]=new O.StringBuffer(s,l)}const y=new A.PieceTreeTextBuffer(a,this._bom,w,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:y,disposable:y}}getFirstLineText(I){return this._chunks[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(I){if(I.length===0)return;this.chunks.length===0&&k.startsWithUTF8BOM(I)&&(this.BOM=k.UTF8_BOM_CHARACTER,I=I.substr(1));const w=I.charCodeAt(I.length-1);w===S.CharCode.CarriageReturn||w>=55296&&w<=56319?(this._acceptChunk1(I.substr(0,I.length-1),!1),this._hasPreviousChar=!0,this._previousChar=w):(this._acceptChunk1(I,!1),this._hasPreviousChar=!1,this._previousChar=w)}_acceptChunk1(I,w){!w&&I.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+I):this._acceptChunk2(I))}_acceptChunk2(I){const w=(0,O.createLineStarts)(this._tmpLineStarts,I);this.chunks.push(new O.StringBuffer(I,w.lineStarts)),this.cr+=w.cr,this.lf+=w.lf,this.crlf+=w.crlf,w.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=k.containsRTL(I)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=k.containsUnusualLineTerminators(I)))}finish(I=!0){return this._finish(),new R(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,I)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const I=this.chunks[this.chunks.length-1];I.buffer+=String.fromCharCode(this._previousChar);const w=(0,O.createLineStartsFast)(I.buffer);I.lineStarts=w,this._previousChar===S.CharCode.CarriageReturn&&this.cr++}}}e.PieceTreeTextBufferBuilder=p}),define(Le[103],Ne([1,0,22,20]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=p,e.decodeSemanticTokensDto=I,k=We(k);var P;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(P||(P={}));function O(w){for(let a=0,y=w.length;a<y;a+=4){const h=w[a+0],r=w[a+1],s=w[a+2],l=w[a+3];w[a+0]=l,w[a+1]=s,w[a+2]=r,w[a+3]=h}}function A(w){const a=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return k.isLittleEndian()||O(a),S.VSBuffer.wrap(a)}function R(w){const a=w.buffer;if(k.isLittleEndian()||O(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const y=new Uint8Array(a.byteLength);return y.set(a),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function p(w){const a=new Uint32Array(o(w));let y=0;if(a[y++]=w.id,w.type==="full")a[y++]=P.Full,a[y++]=w.data.length,a.set(w.data,y),y+=w.data.length;else{a[y++]=P.Delta,a[y++]=w.deltas.length;for(const h of w.deltas)a[y++]=h.start,a[y++]=h.deleteCount,h.data?(a[y++]=h.data.length,a.set(h.data,y),y+=h.data.length):a[y++]=0}return A(a)}function o(w){let a=0;if(a+=2,w.type==="full")a+=1+w.data.length;else{a+=1,a+=3*w.deltas.length;for(const y of w.deltas)y.data&&(a+=y.data.length)}return a}function I(w){const a=R(w);let y=0;const h=a[y++];if(a[y++]===P.Full){const c=a[y++],i=a.subarray(y,y+c);return y+=c,{id:h,type:"full",data:i}}const s=a[y++],l=[];for(let c=0;c<s;c++){const i=a[y++],n=a[y++],t=a[y++];let g;t>0&&(g=a.subarray(y,y+t),y+=t),l[c]={start:i,deleteCount:n,data:g}}return{id:h,type:"delta",deltas:l}}}),define(Le[163],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class S{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(O){if(O&&this._dragOperations.has(O)){const A=this._dragOperations.get(O);return this._dragOperations.delete(O),A}}addDragOperationTransfer(O,A){this._dragOperations.set(O,A)}}e.TreeViewsDnDService=S;class k{constructor(O){this.identifier=O}}e.DraggedTreeItemsIdentifier=k}),define(Le[164],Ne([1,0,6,4,9]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=I,P=We(P);class O extends k.Disposable{constructor(a,y="",h="",r=!0,s){super(),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=a,this._label=y,this._cssClass=h,this._enabled=r,this._actionCallback=s}get id(){return this._id}get label(){return this._label}set label(a){this._setLabel(a)}_setLabel(a){this._label!==a&&(this._label=a,this._onDidChange.fire({label:a}))}get tooltip(){return this._tooltip||""}set tooltip(a){this._setTooltip(a)}_setTooltip(a){this._tooltip!==a&&(this._tooltip=a,this._onDidChange.fire({tooltip:a}))}get class(){return this._cssClass}set class(a){this._setClass(a)}_setClass(a){this._cssClass!==a&&(this._cssClass=a,this._onDidChange.fire({class:a}))}get enabled(){return this._enabled}set enabled(a){this._setEnabled(a)}_setEnabled(a){this._enabled!==a&&(this._enabled=a,this._onDidChange.fire({enabled:a}))}get checked(){return this._checked}set checked(a){this._setChecked(a)}_setChecked(a){this._checked!==a&&(this._checked=a,this._onDidChange.fire({checked:a}))}async run(a,y){this._actionCallback&&await this._actionCallback(a)}}e.Action=O;class A extends k.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new S.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new S.Emitter),this.onDidRun=this._onDidRun.event}async run(a,y){if(!a.enabled)return;this._onWillRun.fire({action:a});let h;try{await this.runAction(a,y)}catch(r){h=r}this._onDidRun.fire({action:a,error:h})}async runAction(a,y){await a.run(y)}}e.ActionRunner=A;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let y=[];for(const h of a)h.length&&(y.length?y=[...y,new R,...h]:y=h);return y}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=R;class p{get actions(){return this._actions}constructor(a,y,h,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=y,this.class=r,this._actions=h}async run(){}}e.SubmenuAction=p;class o extends O{static{this.ID="vs.actions.empty"}constructor(){super(o.ID,P.localize(13048,null),void 0,!1)}}e.EmptySubmenuAction=o;function I(w){return{id:w.id,label:w.label,tooltip:w.tooltip??w.label,class:w.class,enabled:w.enabled??!0,checked:w.checked,run:async(...a)=>w.run(...a)}}}),define(Le[165],Ne([1,0,9]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=o,e.getDurationString=I,e.toLocalISOString=w;const k=60,P=k*60,O=P*24,A=O*7,R=O*30,p=O*365;function o(a,y,h,r){typeof a!="number"&&(a=a.getTime());const s=Math.round((new Date().getTime()-a)/1e3);if(s<-30)return(0,S.localize)(12985,null,o(new Date().getTime()+s*1e3,!1));if(!r&&s<30)return(0,S.localize)(12986,null);let l;return s<k?(l=s,y?l===1?h?(0,S.localize)(12987,null,l):(0,S.localize)(12988,null,l):h?(0,S.localize)(12989,null,l):(0,S.localize)(12990,null,l):l===1?h?(0,S.localize)(12991,null,l):(0,S.localize)(12992,null,l):h?(0,S.localize)(12993,null,l):(0,S.localize)(12994,null,l)):s<P?(l=Math.floor(s/k),y?l===1?h?(0,S.localize)(12995,null,l):(0,S.localize)(12996,null,l):h?(0,S.localize)(12997,null,l):(0,S.localize)(12998,null,l):l===1?h?(0,S.localize)(12999,null,l):(0,S.localize)(13e3,null,l):h?(0,S.localize)(13001,null,l):(0,S.localize)(13002,null,l)):s<O?(l=Math.floor(s/P),y?l===1?h?(0,S.localize)(13003,null,l):(0,S.localize)(13004,null,l):h?(0,S.localize)(13005,null,l):(0,S.localize)(13006,null,l):l===1?h?(0,S.localize)(13007,null,l):(0,S.localize)(13008,null,l):h?(0,S.localize)(13009,null,l):(0,S.localize)(13010,null,l)):s<A?(l=Math.floor(s/O),y?l===1?(0,S.localize)(13011,null,l):(0,S.localize)(13012,null,l):l===1?(0,S.localize)(13013,null,l):(0,S.localize)(13014,null,l)):s<R?(l=Math.floor(s/A),y?l===1?h?(0,S.localize)(13015,null,l):(0,S.localize)(13016,null,l):h?(0,S.localize)(13017,null,l):(0,S.localize)(13018,null,l):l===1?h?(0,S.localize)(13019,null,l):(0,S.localize)(13020,null,l):h?(0,S.localize)(13021,null,l):(0,S.localize)(13022,null,l)):s<p?(l=Math.floor(s/R),y?l===1?h?(0,S.localize)(13023,null,l):(0,S.localize)(13024,null,l):h?(0,S.localize)(13025,null,l):(0,S.localize)(13026,null,l):l===1?h?(0,S.localize)(13027,null,l):(0,S.localize)(13028,null,l):h?(0,S.localize)(13029,null,l):(0,S.localize)(13030,null,l)):(l=Math.floor(s/p),y?l===1?h?(0,S.localize)(13031,null,l):(0,S.localize)(13032,null,l):h?(0,S.localize)(13033,null,l):(0,S.localize)(13034,null,l):l===1?h?(0,S.localize)(13035,null,l):(0,S.localize)(13036,null,l):h?(0,S.localize)(13037,null,l):(0,S.localize)(13038,null,l))}function I(a,y){const h=Math.abs(a/1e3);return h<1?y?(0,S.localize)(13039,null,a):(0,S.localize)(13040,null,a):h<k?y?(0,S.localize)(13041,null,Math.round(a)/1e3):(0,S.localize)(13042,null,Math.round(a)/1e3):h<P?y?(0,S.localize)(13043,null,Math.round(a/(1e3*k))):(0,S.localize)(13044,null,Math.round(a/(1e3*k))):h<O?y?(0,S.localize)(13045,null,Math.round(a/(1e3*P))):(0,S.localize)(13046,null,Math.round(a/(1e3*P))):(0,S.localize)(13047,null,Math.round(a/(1e3*O)))}function w(a){return a.getFullYear()+"-"+String(a.getMonth()+1).padStart(2,"0")+"-"+String(a.getDate()).padStart(2,"0")+"T"+String(a.getHours()).padStart(2,"0")+":"+String(a.getMinutes()).padStart(2,"0")+":"+String(a.getSeconds()).padStart(2,"0")+"."+(a.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Le[42],Ne([1,0,17,14,9]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=p,e.isErrorWithActions=o,e.createErrorWithActions=I,S=We(S),k=We(k),P=We(P);function O(w,a){return a&&(w.stack||w.stacktrace)?P.localize(12979,null,R(w),A(w.stack)||A(w.stacktrace)):R(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?P.localize(12980,null,w.message):w.message||P.localize(12981,null)}function p(w=null,a=!1){if(!w)return P.localize(12982,null);if(Array.isArray(w)){const y=S.coalesce(w),h=p(y[0],a);return y.length>1?P.localize(12983,null,h,y.length):h}if(k.isString(w))return w;if(w.detail){const y=w.detail;if(y.error)return O(y.error,a);if(y.exception)return O(y.exception,a)}return w.stack?O(w,a):w.message?w.message:P.localize(12984,null)}function o(w){const a=w;return a instanceof Error&&Array.isArray(a.actions)}function I(w,a){let y;return typeof w=="string"?y=new Error(w):y=w,y.actions=a,y}}),define(Le[166],Ne([1,0,27,13,9]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var O;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...I){switch(I.length){case 1:return(0,P.localize)(11586,null,I[0]);case 2:return(0,P.localize)(11587,null,I[0],I[1]);case 3:return(0,P.localize)(11588,null,I[0],I[1],I[2]);default:return}}const R=(0,P.localize)(11589,null),p=(0,P.localize)(11590,null);class o{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return w.isTripleEq?"===":"==";case O.NotEq:return w.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return w.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return w.lexeme;case O.QuotedStr:return w.lexeme;case O.Error:return w.lexeme;case O.EOF:return"EOF";default:throw(0,k.illegalState)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this._keywords=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this._errors}reset(w){return this._input=w,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case S.CharCode.OpenParen:this._addToken(O.LParen);break;case S.CharCode.CloseParen:this._addToken(O.RParen);break;case S.CharCode.ExclamationMark:if(this._match(S.CharCode.Equals)){const a=this._match(S.CharCode.Equals);this._tokens.push({type:O.NotEq,offset:this._start,isTripleEq:a})}else this._addToken(O.Neg);break;case S.CharCode.SingleQuote:this._quotedString();break;case S.CharCode.Slash:this._regex();break;case S.CharCode.Equals:if(this._match(S.CharCode.Equals)){const a=this._match(S.CharCode.Equals);this._tokens.push({type:O.Eq,offset:this._start,isTripleEq:a})}else this._match(S.CharCode.Tilde)?this._addToken(O.RegexOp):this._error(A("==","=~"));break;case S.CharCode.LessThan:this._addToken(this._match(S.CharCode.Equals)?O.LtEq:O.Lt);break;case S.CharCode.GreaterThan:this._addToken(this._match(S.CharCode.Equals)?O.GtEq:O.Gt);break;case S.CharCode.Ampersand:this._match(S.CharCode.Ampersand)?this._addToken(O.And):this._error(A("&&"));break;case S.CharCode.Pipe:this._match(S.CharCode.Pipe)?this._addToken(O.Or):this._error(A("||"));break;case S.CharCode.Space:case S.CharCode.CarriageReturn:case S.CharCode.Tab:case S.CharCode.LineFeed:case S.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(O.EOF),Array.from(this._tokens)}_match(w){return this._isAtEnd()||this._input.charCodeAt(this._current)!==w?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?S.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(w){this._tokens.push({type:w,offset:this._start})}_error(w){const a=this._start,y=this._input.substring(this._start,this._current),h={type:O.Error,offset:this._start,lexeme:y};this._errors.push({offset:a,lexeme:y,additionalInfo:w}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const w=this.stringRe.exec(this._input);if(w){this._current=this._start+w[0].length;const a=this._input.substring(this._start,this._current),y=o._keywords.get(a);y?this._addToken(y):this._tokens.push({type:O.Str,lexeme:a,offset:this._start})}}_quotedString(){for(;this._peek()!==S.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:O.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let w=this._current,a=!1,y=!1;for(;;){if(w>=this._input.length){this._current=w,this._error(p);return}const r=this._input.charCodeAt(w);if(a)a=!1;else if(r===S.CharCode.Slash&&!y){w++;break}else r===S.CharCode.OpenSquareBracket?y=!0:r===S.CharCode.Backslash?a=!0:r===S.CharCode.CloseSquareBracket&&(y=!1);w++}for(;w<this._input.length&&o._regexFlags.has(this._input.charCodeAt(w));)w++;this._current=w;const h=this._input.substring(this._start,this._current);this._tokens.push({type:O.RegexStr,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=o}),define(Le[104],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const S={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(S)}),define(Le[73],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(P,O=[],A=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=S}),define(Le[60],Ne([1,0,73]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=O,e.getSingletonServiceDescriptors=A;const k=[];var P;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(R,p,o){p instanceof S.SyncDescriptor||(p=new S.SyncDescriptor(p,[],!!o)),k.push([R,p])}function A(){return k}}),define(Le[167],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class k{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const A of this._nodes.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const R=this.lookupOrInsertNode(O),p=this.lookupOrInsertNode(A);R.outgoing.set(p.key,p),p.incoming.set(R.key,R)}removeNode(O){const A=this._hashFn(O);this._nodes.delete(A);for(const R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(O){const A=this._hashFn(O);let R=this._nodes.get(A);return R||(R=new S(A,O),this._nodes.set(A,R)),R}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[A,R]of this._nodes)O.push(`${A}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this._nodes){const R=new Set([O]),p=this._findCycle(A,R);if(p)return p}}_findCycle(O,A){for(const[R,p]of O.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const o=this._findCycle(p,A);if(o)return o;A.delete(R)}}}e.Graph=k}),define(Le[3],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=P,e.refineServiceDecorator=O;var S;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(S||(e._util=S={})),e.IInstantiationService=P("instantiationService");function k(A,R,p){R[S.DI_TARGET]===R?R[S.DI_DEPENDENCIES].push({id:A,index:p}):(R[S.DI_DEPENDENCIES]=[{id:A,index:p}],R[S.DI_TARGET]=R)}function P(A){if(S.serviceIds.has(A))return S.serviceIds.get(A);const R=function(p,o,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(R,p,I)};return R.toString=()=>A,S.serviceIds.set(A,R),R}function O(A){return A}}),define(Le[43],Ne([1,0,14,2,3]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=O,e.isConfigurationUpdateOverrides=A,e.ConfigurationTargetToString=p,e.isConfigured=o,e.toValuesTree=I,e.addToValueTree=w,e.removeFromValueTree=a,e.getConfigurationValue=h,e.merge=r,e.getLanguageTagSettingPlainKey=s,S=We(S),e.IConfigurationService=(0,P.createDecorator)("configurationService");function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof k.URI)}function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof k.URI)}var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function p(l){switch(l){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function o(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function I(l,c){const i=Object.create(null);for(const n in l)w(i,n,l[n],c);return i}function w(l,c,i,n){const t=c.split("."),g=t.pop();let u=l;for(let v=0;v<t.length;v++){const m=t[v];let d=u[m];switch(typeof d){case"undefined":d=u[m]=Object.create(null);break;case"object":if(d===null){n(`Ignoring ${c} as ${t.slice(0,v+1).join(".")} is null`);return}break;default:n(`Ignoring ${c} as ${t.slice(0,v+1).join(".")} is ${JSON.stringify(d)}`);return}u=d}if(typeof u=="object"&&u!==null)try{u[g]=i}catch{n(`Ignoring ${c} as ${t.join(".")} is ${JSON.stringify(u)}`)}else n(`Ignoring ${c} as ${t.join(".")} is ${JSON.stringify(u)}`)}function a(l,c){const i=c.split(".");y(l,i)}function y(l,c){const i=c.shift();if(c.length===0){delete l[i];return}if(Object.keys(l).indexOf(i)!==-1){const n=l[i];typeof n=="object"&&!Array.isArray(n)&&(y(n,c),Object.keys(n).length===0&&delete l[i])}}function h(l,c,i){function n(u,v){let m=u;for(const d of v){if(typeof m!="object"||m===null)return;m=m[d]}return m}const t=c.split("."),g=n(l,t);return typeof g>"u"?i:g}function r(l,c,i){Object.keys(c).forEach(n=>{n!=="__proto__"&&(n in l?S.isObject(l[n])&&S.isObject(c[n])?r(l[n],c[n],i):i&&(l[n]=c[n]):l[n]=c[n])})}function s(l){return l.replace(/[\[\]]/g,"")}}),define(Le[31],Ne([1,0,27,20,12,166,3,9,13]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=I,e.validateWhenClauses=v,e.expressionsAreEqualWithConstantSubstitution=m,e.implies=oe;const o=new Map;o.set("false",!1),o.set("true",!0),o.set("isMac",k.isMacintosh),o.set("isLinux",k.isLinux),o.set("isWindows",k.isWindows),o.set("isWeb",k.isWeb),o.set("isMacNative",k.isMacintosh&&!k.isWeb),o.set("isEdge",k.isEdge),o.set("isFirefox",k.isFirefox),o.set("isChrome",k.isChrome),o.set("isSafari",k.isSafari);function I(Q,z){if(o.get(Q)!==void 0)throw(0,p.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");o.set(Q,z)}const w=Object.prototype.hasOwnProperty;var a;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(a||(e.ContextKeyExprType=a={}));const y={regexParsingWithErrorRecovery:!0},h=(0,R.localize)(11600,null),r=(0,R.localize)(11601,null),s=(0,R.localize)(11602,null),l=(0,R.localize)(11603,null),c=(0,R.localize)(11604,null),i=(0,R.localize)(11605,null),n=(0,R.localize)(11606,null),t=(0,R.localize)(11607,null);class g{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(z=y){this._config=z,this._scanner=new O.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(z){if(z===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:r});return}this._tokens=this._scanner.reset(z).scan(),this._current=0,this._parsingErrors=[];try{const ne=this._expr();if(!this._isAtEnd()){const Ce=this._peek(),fe=Ce.type===O.TokenType.Str?i:void 0;throw this._parsingErrors.push({message:c,offset:Ce.offset,lexeme:O.Scanner.getLexeme(Ce),additionalInfo:fe}),g._parseError}return ne}catch(ne){if(ne!==g._parseError)throw ne;return}}_expr(){return this._or()}_or(){const z=[this._and()];for(;this._matchOne(O.TokenType.Or);){const ne=this._and();z.push(ne)}return z.length===1?z[0]:u.or(...z)}_and(){const z=[this._term()];for(;this._matchOne(O.TokenType.And);){const ne=this._term();z.push(ne)}return z.length===1?z[0]:u.and(...z)}_term(){if(this._matchOne(O.TokenType.Neg)){const z=this._peek();switch(z.type){case O.TokenType.True:return this._advance(),C.INSTANCE;case O.TokenType.False:return this._advance(),_.INSTANCE;case O.TokenType.LParen:{this._advance();const ne=this._expr();return this._consume(O.TokenType.RParen,l),ne?.negate()}case O.TokenType.Str:return this._advance(),M.create(z.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",z)}}return this._primary()}_primary(){const z=this._peek();switch(z.type){case O.TokenType.True:return this._advance(),u.true();case O.TokenType.False:return this._advance(),u.false();case O.TokenType.LParen:{this._advance();const ne=this._expr();return this._consume(O.TokenType.RParen,l),ne}case O.TokenType.Str:{const ne=z.lexeme;if(this._advance(),this._matchOne(O.TokenType.RegexOp)){const fe=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),fe.type!==O.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",fe);const be=fe.lexeme,de=be.lastIndexOf("/"),X=de===be.length-1?void 0:this._removeFlagsGY(be.substring(de+1));let J;try{J=new RegExp(be.substring(1,de),X)}catch{throw this._errExpectedButGot("REGEX",fe)}return K.create(ne,J)}switch(fe.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const be=[fe.lexeme];this._advance();let de=this._peek(),X=0;for(let Ue=0;Ue<fe.lexeme.length;Ue++)fe.lexeme.charCodeAt(Ue)===S.CharCode.OpenParen?X++:fe.lexeme.charCodeAt(Ue)===S.CharCode.CloseParen&&X--;for(;!this._isAtEnd()&&de.type!==O.TokenType.And&&de.type!==O.TokenType.Or;){switch(de.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Ue=0;Ue<de.lexeme.length;Ue++)de.lexeme.charCodeAt(Ue)===S.CharCode.OpenParen?X++:fe.lexeme.charCodeAt(Ue)===S.CharCode.CloseParen&&X--}if(X<0)break;be.push(O.Scanner.getLexeme(de)),this._advance(),de=this._peek()}const J=be.join(""),ve=J.lastIndexOf("/"),pe=ve===J.length-1?void 0:this._removeFlagsGY(J.substring(ve+1));let Ae;try{Ae=new RegExp(J.substring(1,ve),pe)}catch{throw this._errExpectedButGot("REGEX",fe)}return u.regex(ne,Ae)}case O.TokenType.QuotedStr:{const be=fe.lexeme;this._advance();let de=null;if(!(0,P.isFalsyOrWhitespace)(be)){const X=be.indexOf("/"),J=be.lastIndexOf("/");if(X!==J&&X>=0){const ve=be.slice(X+1,J),pe=be[J+1]==="i"?"i":"";try{de=new RegExp(ve,pe)}catch{throw this._errExpectedButGot("REGEX",fe)}}}if(de===null)throw this._errExpectedButGot("REGEX",fe);return K.create(ne,de)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(O.TokenType.Not)){this._consume(O.TokenType.In,s);const fe=this._value();return u.notIn(ne,fe)}switch(this._peek().type){case O.TokenType.Eq:{this._advance();const fe=this._value();if(this._previous().type===O.TokenType.QuotedStr)return u.equals(ne,fe);switch(fe){case"true":return u.has(ne);case"false":return u.not(ne);default:return u.equals(ne,fe)}}case O.TokenType.NotEq:{this._advance();const fe=this._value();if(this._previous().type===O.TokenType.QuotedStr)return u.notEquals(ne,fe);switch(fe){case"true":return u.not(ne);case"false":return u.has(ne);default:return u.notEquals(ne,fe)}}case O.TokenType.Lt:return this._advance(),j.create(ne,this._value());case O.TokenType.LtEq:return this._advance(),$.create(ne,this._value());case O.TokenType.Gt:return this._advance(),N.create(ne,this._value());case O.TokenType.GtEq:return this._advance(),W.create(ne,this._value());case O.TokenType.In:return this._advance(),u.in(ne,this._value());default:return u.has(ne)}}case O.TokenType.EOF:throw this._parsingErrors.push({message:n,offset:z.offset,lexeme:"",additionalInfo:t}),g._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const z=this._peek();switch(z.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this._advance(),z.lexeme;case O.TokenType.True:return this._advance(),"true";case O.TokenType.False:return this._advance(),"false";case O.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(z){return z.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(z){return this._check(z)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(z,ne){if(this._check(z))return this._advance();throw this._errExpectedButGot(ne,this._peek())}_errExpectedButGot(z,ne,Ce){const fe=(0,R.localize)(11608,null,z,O.Scanner.getLexeme(ne)),be=ne.offset,de=O.Scanner.getLexeme(ne);return this._parsingErrors.push({message:fe,offset:be,lexeme:de,additionalInfo:Ce}),g._parseError}_check(z){return this._peek().type===z}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===O.TokenType.EOF}}e.Parser=g;class u{static false(){return C.INSTANCE}static true(){return _.INSTANCE}static has(z){return E.create(z)}static equals(z,ne){return T.create(z,ne)}static notEquals(z,ne){return b.create(z,ne)}static regex(z,ne){return K.create(z,ne)}static in(z,ne){return D.create(z,ne)}static notIn(z,ne){return f.create(z,ne)}static not(z){return M.create(z)}static and(...z){return Ee.create(z,null,!0)}static or(...z){return ce.create(z,null,!0)}static greater(z,ne){return N.create(z,ne)}static greaterEquals(z,ne){return W.create(z,ne)}static smaller(z,ne){return j.create(z,ne)}static smallerEquals(z,ne){return $.create(z,ne)}static{this._parser=new g({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this._parser.parse(z)}}e.ContextKeyExpr=u;function v(Q){const z=new g({regexParsingWithErrorRecovery:!1});return Q.map(ne=>(z.parse(ne),z.lexingErrors.length>0?z.lexingErrors.map(Ce=>({errorMessage:Ce.additionalInfo?(0,R.localize)(11609,null,Ce.additionalInfo):(0,R.localize)(11610,null),offset:Ce.offset,length:Ce.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(Ce=>({errorMessage:Ce.additionalInfo?`${Ce.message}. ${Ce.additionalInfo}`:Ce.message,offset:Ce.offset,length:Ce.lexeme.length})):[]))}function m(Q,z){const ne=Q?Q.substituteConstants():void 0,Ce=z?z.substituteConstants():void 0;return!ne&&!Ce?!0:!ne||!Ce?!1:ne.equals(Ce)}function d(Q,z){return Q.cmp(z)}class C{static{this.INSTANCE=new C}constructor(){this.type=a.False}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=C;class _{static{this.INSTANCE=new _}constructor(){this.type=a.True}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=_;class E{static create(z,ne=null){const Ce=o.get(z);return typeof Ce=="boolean"?Ce?_.INSTANCE:C.INSTANCE:new E(z,ne)}constructor(z,ne){this.key=z,this.negated=ne,this.type=a.Defined}cmp(z){return z.type!==this.type?this.type-z.type:le(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=o.get(this.key);return typeof z=="boolean"?z?_.INSTANCE:C.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.negated||(this.negated=M.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class T{static create(z,ne,Ce=null){if(typeof ne=="boolean")return ne?E.create(z,Ce):M.create(z,Ce);const fe=o.get(z);return typeof fe=="boolean"?ne===(fe?"true":"false")?_.INSTANCE:C.INSTANCE:new T(z,ne,Ce)}constructor(z,ne,Ce){this.key=z,this.value=ne,this.negated=Ce,this.type=a.Equals}cmp(z){return z.type!==this.type?this.type-z.type:me(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){const z=o.get(this.key);if(typeof z=="boolean"){const ne=z?"true":"false";return this.value===ne?_.INSTANCE:C.INSTANCE}return this}evaluate(z){return z.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(z){return z.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=T;class D{static create(z,ne){return new D(z,ne)}constructor(z,ne){this.key=z,this.valueKey=ne,this.type=a.In,this.negated=null}cmp(z){return z.type!==this.type?this.type-z.type:me(this.key,this.valueKey,z.key,z.valueKey)}equals(z){return z.type===this.type?this.key===z.key&&this.valueKey===z.valueKey:!1}substituteConstants(){return this}evaluate(z){const ne=z.getValue(this.valueKey),Ce=z.getValue(this.key);return Array.isArray(ne)?ne.includes(Ce):typeof Ce=="string"&&typeof ne=="object"&&ne!==null?w.call(ne,Ce):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(z){return z.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=D;class f{static create(z,ne){return new f(z,ne)}constructor(z,ne){this.key=z,this.valueKey=ne,this.type=a.NotIn,this._negated=D.create(z,ne)}cmp(z){return z.type!==this.type?this.type-z.type:this._negated.cmp(z._negated)}equals(z){return z.type===this.type?this._negated.equals(z._negated):!1}substituteConstants(){return this}evaluate(z){return!this._negated.evaluate(z)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(z){return z.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=f;class b{static create(z,ne,Ce=null){if(typeof ne=="boolean")return ne?M.create(z,Ce):E.create(z,Ce);const fe=o.get(z);return typeof fe=="boolean"?ne===(fe?"true":"false")?C.INSTANCE:_.INSTANCE:new b(z,ne,Ce)}constructor(z,ne,Ce){this.key=z,this.value=ne,this.negated=Ce,this.type=a.NotEquals}cmp(z){return z.type!==this.type?this.type-z.type:me(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){const z=o.get(this.key);if(typeof z=="boolean"){const ne=z?"true":"false";return this.value===ne?C.INSTANCE:_.INSTANCE}return this}evaluate(z){return z.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(z){return z.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class M{static create(z,ne=null){const Ce=o.get(z);return typeof Ce=="boolean"?Ce?C.INSTANCE:_.INSTANCE:new M(z,ne)}constructor(z,ne){this.key=z,this.negated=ne,this.type=a.Not}cmp(z){return z.type!==this.type?this.type-z.type:le(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=o.get(this.key);return typeof z=="boolean"?z?C.INSTANCE:_.INSTANCE:this}evaluate(z){return!z.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(z){return z.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=M;function L(Q,z){if(typeof Q=="string"){const ne=parseFloat(Q);isNaN(ne)||(Q=ne)}return typeof Q=="string"||typeof Q=="number"?z(Q):C.INSTANCE}class N{static create(z,ne,Ce=null){return L(ne,fe=>new N(z,fe,Ce))}constructor(z,ne,Ce){this.key=z,this.value=ne,this.negated=Ce,this.type=a.Greater}cmp(z){return z.type!==this.type?this.type-z.type:me(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(z){return z.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=N;class W{static create(z,ne,Ce=null){return L(ne,fe=>new W(z,fe,Ce))}constructor(z,ne,Ce){this.key=z,this.value=ne,this.negated=Ce,this.type=a.GreaterEquals}cmp(z){return z.type!==this.type?this.type-z.type:me(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(z){return z.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=j.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=W;class j{static create(z,ne,Ce=null){return L(ne,fe=>new j(z,fe,Ce))}constructor(z,ne,Ce){this.key=z,this.value=ne,this.negated=Ce,this.type=a.Smaller}cmp(z){return z.type!==this.type?this.type-z.type:me(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(z){return z.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=W.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=j;class ${static create(z,ne,Ce=null){return L(ne,fe=>new $(z,fe,Ce))}constructor(z,ne,Ce){this.key=z,this.value=ne,this.negated=Ce,this.type=a.SmallerEquals}cmp(z){return z.type!==this.type?this.type-z.type:me(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(z){return z.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=$;class K{static create(z,ne){return new K(z,ne)}constructor(z,ne){this.key=z,this.regexp=ne,this.type=a.Regex,this.negated=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.key<z.key)return-1;if(this.key>z.key)return 1;const ne=this.regexp?this.regexp.source:"",Ce=z.regexp?z.regexp.source:"";return ne<Ce?-1:ne>Ce?1:0}equals(z){if(z.type===this.type){const ne=this.regexp?this.regexp.source:"",Ce=z.regexp?z.regexp.source:"";return this.key===z.key&&ne===Ce}return!1}substituteConstants(){return this}evaluate(z){const ne=z.getValue(this.key);return this.regexp?this.regexp.test(ne):!1}serialize(){const z=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${z}`}keys(){return[this.key]}map(z){return z.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=q.create(this)),this.negated}}e.ContextKeyRegexExpr=K;class q{static create(z){return new q(z)}constructor(z){this._actual=z,this.type=a.NotRegex}cmp(z){return z.type!==this.type?this.type-z.type:this._actual.cmp(z._actual)}equals(z){return z.type===this.type?this._actual.equals(z._actual):!1}substituteConstants(){return this}evaluate(z){return!this._actual.evaluate(z)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(z){return new q(this._actual.map(z))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=q;function ae(Q){let z=null;for(let ne=0,Ce=Q.length;ne<Ce;ne++){const fe=Q[ne].substituteConstants();if(Q[ne]!==fe&&z===null){z=[];for(let be=0;be<ne;be++)z[be]=Q[be]}z!==null&&(z[ne]=fe)}return z===null?Q:z}class Ee{static create(z,ne,Ce){return Ee._normalizeArr(z,ne,Ce)}constructor(z,ne){this.expr=z,this.negated=ne,this.type=a.And}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let ne=0,Ce=this.expr.length;ne<Ce;ne++){const fe=d(this.expr[ne],z.expr[ne]);if(fe!==0)return fe}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let ne=0,Ce=this.expr.length;ne<Ce;ne++)if(!this.expr[ne].equals(z.expr[ne]))return!1;return!0}return!1}substituteConstants(){const z=ae(this.expr);return z===this.expr?this:Ee.create(z,this.negated,!1)}evaluate(z){for(let ne=0,Ce=this.expr.length;ne<Ce;ne++)if(!this.expr[ne].evaluate(z))return!1;return!0}static _normalizeArr(z,ne,Ce){const fe=[];let be=!1;for(const de of z)if(de){if(de.type===a.True){be=!0;continue}if(de.type===a.False)return C.INSTANCE;if(de.type===a.And){fe.push(...de.expr);continue}fe.push(de)}if(fe.length===0&&be)return _.INSTANCE;if(fe.length!==0){if(fe.length===1)return fe[0];fe.sort(d);for(let de=1;de<fe.length;de++)fe[de-1].equals(fe[de])&&(fe.splice(de,1),de--);if(fe.length===1)return fe[0];for(;fe.length>1;){const de=fe[fe.length-1];if(de.type!==a.Or)break;fe.pop();const X=fe.pop(),J=fe.length===0,ve=ce.create(de.expr.map(pe=>Ee.create([pe,X],null,Ce)),null,J);ve&&(fe.push(ve),fe.sort(d))}if(fe.length===1)return fe[0];if(Ce){for(let de=0;de<fe.length;de++)for(let X=de+1;X<fe.length;X++)if(fe[de].negate().equals(fe[X]))return C.INSTANCE;if(fe.length===1)return fe[0]}return new Ee(fe,ne)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const ne of this.expr)z.push(...ne.keys());return z}map(z){return new Ee(this.expr.map(ne=>ne.map(z)),null)}negate(){if(!this.negated){const z=[];for(const ne of this.expr)z.push(ne.negate());this.negated=ce.create(z,this,!0)}return this.negated}}e.ContextKeyAndExpr=Ee;class ce{static create(z,ne,Ce){return ce._normalizeArr(z,ne,Ce)}constructor(z,ne){this.expr=z,this.negated=ne,this.type=a.Or}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let ne=0,Ce=this.expr.length;ne<Ce;ne++){const fe=d(this.expr[ne],z.expr[ne]);if(fe!==0)return fe}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let ne=0,Ce=this.expr.length;ne<Ce;ne++)if(!this.expr[ne].equals(z.expr[ne]))return!1;return!0}return!1}substituteConstants(){const z=ae(this.expr);return z===this.expr?this:ce.create(z,this.negated,!1)}evaluate(z){for(let ne=0,Ce=this.expr.length;ne<Ce;ne++)if(this.expr[ne].evaluate(z))return!0;return!1}static _normalizeArr(z,ne,Ce){let fe=[],be=!1;if(z){for(let de=0,X=z.length;de<X;de++){const J=z[de];if(J){if(J.type===a.False){be=!0;continue}if(J.type===a.True)return _.INSTANCE;if(J.type===a.Or){fe=fe.concat(J.expr);continue}fe.push(J)}}if(fe.length===0&&be)return C.INSTANCE;fe.sort(d)}if(fe.length!==0){if(fe.length===1)return fe[0];for(let de=1;de<fe.length;de++)fe[de-1].equals(fe[de])&&(fe.splice(de,1),de--);if(fe.length===1)return fe[0];if(Ce){for(let de=0;de<fe.length;de++)for(let X=de+1;X<fe.length;X++)if(fe[de].negate().equals(fe[X]))return _.INSTANCE;if(fe.length===1)return fe[0]}return new ce(fe,ne)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const ne of this.expr)z.push(...ne.keys());return z}map(z){return new ce(this.expr.map(ne=>ne.map(z)),null)}negate(){if(!this.negated){const z=[];for(const ne of this.expr)z.push(ne.negate());for(;z.length>1;){const ne=z.shift(),Ce=z.shift(),fe=[];for(const be of Re(ne))for(const de of Re(Ce))fe.push(Ee.create([be,de],null,!1));z.unshift(ce.create(fe,null,!1))}this.negated=ce.create(z,this,!0)}return this.negated}}e.ContextKeyOrExpr=ce;class Z extends E{static{this._info=[]}static all(){return Z._info.values()}constructor(z,ne,Ce){super(z,null),this._defaultValue=ne,typeof Ce=="object"?Z._info.push({...Ce,key:z}):Ce!==!0&&Z._info.push({key:z,description:Ce,type:ne!=null?typeof ne:void 0})}bindTo(z){return z.createKey(this.key,this._defaultValue)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return T.create(this.key,z)}notEqualsTo(z){return b.create(this.key,z)}}e.RawContextKey=Z,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function le(Q,z){return Q<z?-1:Q>z?1:0}function me(Q,z,ne,Ce){return Q<ne?-1:Q>ne?1:z<Ce?-1:z>Ce?1:0}function oe(Q,z){if(Q.type===a.False||z.type===a.True)return!0;if(Q.type===a.Or)return z.type===a.Or?De(Q.expr,z.expr):!1;if(z.type===a.Or){for(const ne of z.expr)if(oe(Q,ne))return!0;return!1}if(Q.type===a.And){if(z.type===a.And)return De(z.expr,Q.expr);for(const ne of Q.expr)if(oe(ne,z))return!0;return!1}return Q.equals(z)}function De(Q,z){let ne=0,Ce=0;for(;ne<Q.length&&Ce<z.length;){const fe=Q[ne].cmp(z[Ce]);if(fe<0)return!1;fe===0&&ne++,Ce++}return ne===Q.length}function Re(Q){return Q.type===a.Or?Q.expr:[Q]}}),define(Le[168],Ne([1,0,31,3]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX=e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=e.AccessibilitySupport=e.IAccessibilityService=void 0,e.isAccessibilityInformation=O,e.IAccessibilityService=(0,k.createDecorator)("accessibilityService");var P;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=new S.RawContextKey("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX="ACCESSIBLE_VIEW_SHOWN_"}),define(Le[105],Ne([1,0,17,25,20,146,280,156,169,9,168]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=u,e.stringSet=d,e.cursorStyleToString=L,e.filterValidationDecorations=Pe,S=We(S),k=We(k),P=We(P),o=We(o);var w;(function(ie){ie[ie.None=0]="None",ie[ie.Keep=1]="Keep",ie[ie.Brackets=2]="Brackets",ie[ie.Advanced=3]="Advanced",ie[ie.Full=4]="Full"})(w||(e.EditorAutoIndentStrategy=w={})),e.MINIMAP_GUTTER_WIDTH=8;class a{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=a;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class h{constructor(ee,Y,Xe,Je){this.id=ee,this.name=Y,this.defaultValue=Xe,this.schema=Je}applyUpdate(ee,Y){return s(ee,Y)}compute(ee,Y,Xe){return Xe}}class r{constructor(ee,Y){this.newValue=ee,this.didChange=Y}}e.ApplyUpdateResult=r;function s(ie,ee){if(typeof ie!="object"||typeof ee!="object"||!ie||!ee)return new r(ee,ie!==ee);if(Array.isArray(ie)||Array.isArray(ee)){const Xe=Array.isArray(ie)&&Array.isArray(ee)&&S.equals(ie,ee);return new r(ee,!Xe)}let Y=!1;for(const Xe in ee)if(ee.hasOwnProperty(Xe)){const Je=s(ie[Xe],ee[Xe]);Je.didChange&&(ie[Xe]=Je.newValue,Y=!0)}return new r(ie,Y)}class l{constructor(ee){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0}applyUpdate(ee,Y){return s(ee,Y)}validate(ee){return this.defaultValue}}class c{constructor(ee,Y,Xe,Je){this.id=ee,this.name=Y,this.defaultValue=Xe,this.schema=Je}applyUpdate(ee,Y){return s(ee,Y)}validate(ee){return typeof ee>"u"?this.defaultValue:ee}compute(ee,Y,Xe){return Xe}}function i(ie,ee){return typeof ie>"u"?ee:ie==="false"?!1:!!ie}class n extends c{constructor(ee,Y,Xe,Je=void 0){typeof Je<"u"&&(Je.type="boolean",Je.default=Xe),super(ee,Y,Xe,Je)}validate(ee){return i(ee,this.defaultValue)}}function t(ie,ee,Y,Xe){if(typeof ie>"u")return ee;let Je=parseInt(ie,10);return isNaN(Je)?ee:(Je=Math.max(Y,Je),Je=Math.min(Xe,Je),Je|0)}class g extends c{static clampedInt(ee,Y,Xe,Je){return t(ee,Y,Xe,Je)}constructor(ee,Y,Xe,Je,dt,bt=void 0){typeof bt<"u"&&(bt.type="integer",bt.default=Xe,bt.minimum=Je,bt.maximum=dt),super(ee,Y,Xe,bt),this.minimum=Je,this.maximum=dt}validate(ee){return g.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}function u(ie,ee,Y,Xe){if(typeof ie>"u")return ee;const Je=v.float(ie,ee);return v.clamp(Je,Y,Xe)}class v extends c{static clamp(ee,Y,Xe){return ee<Y?Y:ee>Xe?Xe:ee}static float(ee,Y){if(typeof ee=="number")return ee;if(typeof ee>"u")return Y;const Xe=parseFloat(ee);return isNaN(Xe)?Y:Xe}constructor(ee,Y,Xe,Je,dt){typeof dt<"u"&&(dt.type="number",dt.default=Xe),super(ee,Y,Xe,dt),this.validationFn=Je}validate(ee){return this.validationFn(v.float(ee,this.defaultValue))}}class m extends c{static string(ee,Y){return typeof ee!="string"?Y:ee}constructor(ee,Y,Xe,Je=void 0){typeof Je<"u"&&(Je.type="string",Je.default=Xe),super(ee,Y,Xe,Je)}validate(ee){return m.string(ee,this.defaultValue)}}function d(ie,ee,Y,Xe){return typeof ie!="string"?ee:Xe&&ie in Xe?Xe[ie]:Y.indexOf(ie)===-1?ee:ie}class C extends c{constructor(ee,Y,Xe,Je,dt=void 0){typeof dt<"u"&&(dt.type="string",dt.enum=Je,dt.default=Xe),super(ee,Y,Xe,dt),this._allowedValues=Je}validate(ee){return d(ee,this.defaultValue,this._allowedValues)}}class _ extends h{constructor(ee,Y,Xe,Je,dt,bt,Mt=void 0){typeof Mt<"u"&&(Mt.type="string",Mt.enum=dt,Mt.default=Je),super(ee,Y,Xe,Mt),this._allowedValues=dt,this._convert=bt}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function E(ie){switch(ie){case"none":return w.None;case"keep":return w.Keep;case"brackets":return w.Brackets;case"advanced":return w.Advanced;case"full":return w.Full}}class T extends h{constructor(){super(Be.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(11776,null),o.localize(11777,null),o.localize(11778,null)],default:"auto",tags:["accessibility"],description:o.localize(11779,null)})}validate(ee){switch(ee){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(ee,Y,Xe){return Xe===I.AccessibilitySupport.Unknown?ee.accessibilitySupport:Xe}}class D extends h{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(Be.comments,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:o.localize(11780,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:o.localize(11781,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{insertSpace:i(Y.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Y.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(ie){ie[ie.Hidden=0]="Hidden",ie[ie.Blink=1]="Blink",ie[ie.Smooth=2]="Smooth",ie[ie.Phase=3]="Phase",ie[ie.Expand=4]="Expand",ie[ie.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function b(ie){switch(ie){case"blink":return f.Blink;case"smooth":return f.Smooth;case"phase":return f.Phase;case"expand":return f.Expand;case"solid":return f.Solid}}var M;(function(ie){ie[ie.Line=1]="Line",ie[ie.Block=2]="Block",ie[ie.Underline=3]="Underline",ie[ie.LineThin=4]="LineThin",ie[ie.BlockOutline=5]="BlockOutline",ie[ie.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function L(ie){switch(ie){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function N(ie){switch(ie){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class W extends l{constructor(){super(Be.editorClassName)}compute(ee,Y,Xe){const Je=["monaco-editor"];return Y.get(Be.extraEditorClassName)&&Je.push(Y.get(Be.extraEditorClassName)),ee.extraEditorClassName&&Je.push(ee.extraEditorClassName),Y.get(Be.mouseStyle)==="default"?Je.push("mouse-default"):Y.get(Be.mouseStyle)==="copy"&&Je.push("mouse-copy"),Y.get(Be.showUnused)&&Je.push("showUnused"),Y.get(Be.showDeprecated)&&Je.push("showDeprecated"),Je.join(" ")}}class j extends n{constructor(){super(Be.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:o.localize(11782,null)})}compute(ee,Y,Xe){return Xe&&ee.emptySelectionClipboard}}class $ extends h{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Be.find,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:o.localize(11783,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ee.seedSearchStringFromSelection,enumDescriptions:[o.localize(11784,null),o.localize(11785,null),o.localize(11786,null)],description:o.localize(11787,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[o.localize(11788,null),o.localize(11789,null),o.localize(11790,null)],description:o.localize(11791,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:o.localize(11792,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:o.localize(11793,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:o.localize(11794,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{cursorMoveOnType:i(Y.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ee.seedSearchStringFromSelection=="boolean"?ee.seedSearchStringFromSelection?"always":"never":d(Y.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":d(Y.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Y.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Y.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Y.loop,this.defaultValue.loop)}}}class K extends h{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Be.fontLigatures,"fontLigatures",K.OFF,{anyOf:[{type:"boolean",description:o.localize(11795,null)},{type:"string",description:o.localize(11796,null)}],description:o.localize(11797,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"||ee.length===0?K.OFF:ee==="true"?K.ON:ee:ee?K.ON:K.OFF}}e.EditorFontLigatures=K;class q extends h{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Be.fontVariations,"fontVariations",q.OFF,{anyOf:[{type:"boolean",description:o.localize(11798,null)},{type:"string",description:o.localize(11799,null)}],description:o.localize(11800,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"?q.OFF:ee==="true"?q.TRANSLATE:ee:ee?q.TRANSLATE:q.OFF}compute(ee,Y,Xe){return ee.fontInfo.fontVariationSettings}}e.EditorFontVariations=q;class ae extends l{constructor(){super(Be.fontInfo)}compute(ee,Y,Xe){return ee.fontInfo}}class Ee extends c{constructor(){super(Be.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(11801,null)})}validate(ee){const Y=v.float(ee,this.defaultValue);return Y===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(Y,6,100)}compute(ee,Y,Xe){return ee.fontInfo.fontSize}}class ce extends h{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(Be.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ce.MINIMUM_VALUE,maximum:ce.MAXIMUM_VALUE,errorMessage:o.localize(11802,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ce.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(11803,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(g.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,ce.MINIMUM_VALUE,ce.MAXIMUM_VALUE))}}class Z extends h{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},Y={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[o.localize(11804,null),o.localize(11805,null),o.localize(11806,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Be.gotoLocation,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(11807,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(11808,null),...Y},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(11809,null),...Y},"editor.gotoLocation.multipleDeclarations":{description:o.localize(11810,null),...Y},"editor.gotoLocation.multipleImplementations":{description:o.localize(11811,null),...Y},"editor.gotoLocation.multipleReferences":{description:o.localize(11812,null),...Y},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Xe,description:o.localize(11813,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Xe,description:o.localize(11814,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Xe,description:o.localize(11815,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Xe,description:o.localize(11816,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Xe,description:o.localize(11817,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{multiple:d(Y.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Y.multipleDefinitions??d(Y.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Y.multipleTypeDefinitions??d(Y.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Y.multipleDeclarations??d(Y.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Y.multipleImplementations??d(Y.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Y.multipleReferences??d(Y.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:Y.multipleTests??d(Y.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Y.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Y.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Y.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Y.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Y.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:m.string(Y.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class le extends h{constructor(){const ee={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Be.hover,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11818,null)},"editor.hover.delay":{type:"number",default:ee.delay,minimum:0,maximum:1e4,description:o.localize(11819,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:o.localize(11820,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ee.hidingDelay,description:o.localize(11821,null)},"editor.hover.above":{type:"boolean",default:ee.above,description:o.localize(11822,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),delay:g.clampedInt(Y.delay,this.defaultValue.delay,0,1e4),sticky:i(Y.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(Y.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Y.above,this.defaultValue.above)}}}var me;(function(ie){ie[ie.None=0]="None",ie[ie.Text=1]="Text",ie[ie.Blocks=2]="Blocks"})(me||(e.RenderMinimap=me={}));class oe extends l{constructor(){super(Be.layoutInfo)}compute(ee,Y,Xe){return oe.computeLayout(Y,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio,glyphMarginDecorationLaneCount:ee.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ee){const Y=ee.height/ee.lineHeight,Xe=Math.floor(ee.paddingTop/ee.lineHeight);let Je=Math.floor(ee.paddingBottom/ee.lineHeight);ee.scrollBeyondLastLine&&(Je=Math.max(Je,Y-1));const dt=(Xe+ee.viewLineCount+Je)/(ee.pixelRatio*ee.height),bt=Math.floor(ee.viewLineCount/dt);return{typicalViewportLineCount:Y,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:Je,desiredRatio:dt,minimapLineCount:bt}}static _computeMinimapLayout(ee,Y){const Xe=ee.outerWidth,Je=ee.outerHeight,dt=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:me.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(dt*Je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Je};const bt=Y.stableMinimapLayoutInput,Mt=bt&&ee.outerHeight===bt.outerHeight&&ee.lineHeight===bt.lineHeight&&ee.typicalHalfwidthCharacterWidth===bt.typicalHalfwidthCharacterWidth&&ee.pixelRatio===bt.pixelRatio&&ee.scrollBeyondLastLine===bt.scrollBeyondLastLine&&ee.paddingTop===bt.paddingTop&&ee.paddingBottom===bt.paddingBottom&&ee.minimap.enabled===bt.minimap.enabled&&ee.minimap.side===bt.minimap.side&&ee.minimap.size===bt.minimap.size&&ee.minimap.showSlider===bt.minimap.showSlider&&ee.minimap.renderCharacters===bt.minimap.renderCharacters&&ee.minimap.maxColumn===bt.minimap.maxColumn&&ee.minimap.scale===bt.minimap.scale&&ee.verticalScrollbarWidth===bt.verticalScrollbarWidth&&ee.isViewportWrapping===bt.isViewportWrapping,Ht=ee.lineHeight,Zt=ee.typicalHalfwidthCharacterWidth,ei=ee.scrollBeyondLastLine,oi=ee.minimap.renderCharacters;let At=dt>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const Ye=ee.minimap.maxColumn,Tt=ee.minimap.size,di=ee.minimap.side,pt=ee.verticalScrollbarWidth,_t=ee.viewLineCount,ti=ee.remainingWidth,ii=ee.isViewportWrapping,Bt=oi?2:3;let gt=Math.floor(dt*Je);const xt=gt/dt;let ni=!1,ai=!1,Ke=Bt*At,li=At/dt,hi=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:jt,extraLinesBeforeFirstLine:ci,extraLinesBeyondLastLine:zt,desiredRatio:qt,minimapLineCount:Kt}=oe.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:ei,paddingTop:ee.paddingTop,paddingBottom:ee.paddingBottom,height:Je,lineHeight:Ht,pixelRatio:dt});if(_t/Kt>1)ni=!0,ai=!0,At=1,Ke=1,li=At/dt;else{let Et=!1,Dt=At+1;if(Tt==="fit"){const Vt=Math.ceil((ci+_t+zt)*Ke);ii&&Mt&&ti<=Y.stableFitRemainingWidth?(Et=!0,Dt=Y.stableFitMaxMinimapScale):Et=Vt>gt}if(Tt==="fill"||Et){ni=!0;const Vt=At;Ke=Math.min(Ht*dt,Math.max(1,Math.floor(1/qt))),ii&&Mt&&ti<=Y.stableFitRemainingWidth&&(Dt=Y.stableFitMaxMinimapScale),At=Math.min(Dt,Math.max(1,Math.floor(Ke/Bt))),At>Vt&&(hi=Math.min(2,At/Vt)),li=At/dt/hi,gt=Math.ceil(Math.max(jt,ci+_t+zt)*Ke),ii?(Y.stableMinimapLayoutInput=ee,Y.stableFitRemainingWidth=ti,Y.stableFitMaxMinimapScale=At):(Y.stableMinimapLayoutInput=null,Y.stableFitRemainingWidth=0)}}}const fi=Math.floor(Ye*li),St=Math.min(fi,Math.max(0,Math.floor((ti-pt-2)*li/(Zt+li)))+e.MINIMAP_GUTTER_WIDTH);let Ft=Math.floor(dt*St);const Lt=Ft/dt;Ft=Math.floor(Ft*hi);const Wt=oi?me.Text:me.Blocks,ri=di==="left"?0:Xe-St-pt;return{renderMinimap:Wt,minimapLeft:ri,minimapWidth:St,minimapHeightIsEditorHeight:ni,minimapIsSampling:ai,minimapScale:At,minimapLineHeight:Ke,minimapCanvasInnerWidth:Ft,minimapCanvasInnerHeight:gt,minimapCanvasOuterWidth:Lt,minimapCanvasOuterHeight:xt}}static computeLayout(ee,Y){const Xe=Y.outerWidth|0,Je=Y.outerHeight|0,dt=Y.lineHeight|0,bt=Y.lineNumbersDigitCount|0,Mt=Y.typicalHalfwidthCharacterWidth,Ht=Y.maxDigitWidth,Zt=Y.pixelRatio,ei=Y.viewLineCount,oi=ee.get(Be.wordWrapOverride2),At=oi==="inherit"?ee.get(Be.wordWrapOverride1):oi,Ye=At==="inherit"?ee.get(Be.wordWrap):At,Tt=ee.get(Be.wordWrapColumn),di=Y.isDominatedByLongLines,pt=ee.get(Be.glyphMargin),_t=ee.get(Be.lineNumbers).renderType!==Ue.Off,ti=ee.get(Be.lineNumbersMinChars),ii=ee.get(Be.scrollBeyondLastLine),Bt=ee.get(Be.padding),gt=ee.get(Be.minimap),xt=ee.get(Be.scrollbar),ni=xt.verticalScrollbarSize,ai=xt.verticalHasArrows,Ke=xt.arrowSize,li=xt.horizontalScrollbarSize,hi=ee.get(Be.folding),fi=ee.get(Be.showFoldingControls)!=="never";let St=ee.get(Be.lineDecorationsWidth);hi&&fi&&(St+=16);let Ft=0;if(_t){const mi=Math.max(bt,ti);Ft=Math.round(mi*Ht)}let Lt=0;pt&&(Lt=dt*Y.glyphMarginDecorationLaneCount);let Wt=0,ri=Wt+Lt,jt=ri+Ft,ci=jt+St;const zt=Xe-Lt-Ft-St;let qt=!1,Kt=!1,Nt=-1;At==="inherit"&&di?(qt=!0,Kt=!0):Ye==="on"||Ye==="bounded"?Kt=!0:Ye==="wordWrapColumn"&&(Nt=Tt);const Et=oe._computeMinimapLayout({outerWidth:Xe,outerHeight:Je,lineHeight:dt,typicalHalfwidthCharacterWidth:Mt,pixelRatio:Zt,scrollBeyondLastLine:ii,paddingTop:Bt.top,paddingBottom:Bt.bottom,minimap:gt,verticalScrollbarWidth:ni,viewLineCount:ei,remainingWidth:zt,isViewportWrapping:Kt},Y.memory||new y);Et.renderMinimap!==me.None&&Et.minimapLeft===0&&(Wt+=Et.minimapWidth,ri+=Et.minimapWidth,jt+=Et.minimapWidth,ci+=Et.minimapWidth);const Dt=zt-Et.minimapWidth,Vt=Math.max(1,Math.floor((Dt-ni-2)/Mt)),It=ai?Ke:0;return Kt&&(Nt=Math.max(1,Vt),Ye==="bounded"&&(Nt=Math.min(Nt,Tt))),{width:Xe,height:Je,glyphMarginLeft:Wt,glyphMarginWidth:Lt,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:Ft,decorationsLeft:jt,decorationsWidth:St,contentLeft:ci,contentWidth:Dt,minimap:Et,viewportColumn:Vt,isWordWrapMinified:qt,isViewportWrapping:Kt,wrappingColumn:Nt,verticalScrollbarWidth:ni,horizontalScrollbarHeight:li,overviewRuler:{top:It,width:ni,height:Je-2*It,right:0}}}}e.EditorLayoutInfoComputer=oe;class De extends h{constructor(){super(Be.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(11823,null),o.localize(11824,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(11825,null)}})}validate(ee){return d(ee,"simple",["simple","advanced"])}compute(ee,Y,Xe){return Y.get(Be.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var Re;(function(ie){ie.Off="off",ie.OnCode="onCode",ie.On="on"})(Re||(e.ShowLightbulbIconMode=Re={}));class Q extends h{constructor(){const ee={enabled:Re.On};super(Be.lightbulb,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Re.Off,Re.OnCode,Re.On],default:ee.enabled,enumDescriptions:[o.localize(11826,null),o.localize(11827,null),o.localize(11828,null)],description:o.localize(11829,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:d(ee.enabled,this.defaultValue.enabled,[Re.Off,Re.OnCode,Re.On])}}}class z extends h{constructor(){const ee={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Be.stickyScroll,"stickyScroll",ee,{"editor.stickyScroll.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11830,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ee.maxLineCount,minimum:1,maximum:20,description:o.localize(11831,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ee.defaultModel,description:o.localize(11832,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ee.scrollWithEditor,description:o.localize(11833,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(Y.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(Y.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Y.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends h{constructor(){const ee={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Be.inlayHints,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"string",default:ee.enabled,description:o.localize(11834,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(11835,null),o.localize(11836,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(11837,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(11838,null)]},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:o.localize(11839,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,markdownDescription:o.localize(11840,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ee.padding,description:o.localize(11841,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return typeof Y.enabled=="boolean"&&(Y.enabled=Y.enabled?"on":"off"),{enabled:d(Y.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(Y.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Y.fontFamily,this.defaultValue.fontFamily),padding:i(Y.padding,this.defaultValue.padding)}}}class Ce extends h{constructor(){super(Be.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(ee){return typeof ee=="string"&&/^\d+(\.\d+)?ch$/.test(ee)?-parseFloat(ee.substring(0,ee.length-2)):g.clampedInt(ee,this.defaultValue,0,1e3)}compute(ee,Y,Xe){return Xe<0?g.clampedInt(-Xe*ee.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class fe extends v{constructor(){super(Be.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>v.clamp(ee,0,150),{markdownDescription:o.localize(11842,null)})}compute(ee,Y,Xe){return ee.fontInfo.lineHeight}}class be extends h{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Be.minimap,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11843,null)},"editor.minimap.autohide":{type:"boolean",default:ee.autohide,description:o.localize(11844,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(11845,null),o.localize(11846,null),o.localize(11847,null)],default:ee.size,description:o.localize(11848,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:o.localize(11849,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:o.localize(11850,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(11851,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:o.localize(11852,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:o.localize(11853,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ee.showRegionSectionHeaders,description:o.localize(11854,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ee.showMarkSectionHeaders,description:o.localize(11855,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ee.sectionHeaderFontSize,description:o.localize(11856,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:ee.sectionHeaderLetterSpacing,description:o.localize(11857,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),autohide:i(Y.autohide,this.defaultValue.autohide),size:d(Y.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(Y.side,this.defaultValue.side,["right","left"]),showSlider:d(Y.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Y.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(Y.scale,1,1,3),maxColumn:g.clampedInt(Y.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Y.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Y.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:v.clamp(Y.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:v.clamp(Y.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function de(ie){return ie==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class X extends h{constructor(){super(Be.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(11858,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(11859,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{top:g.clampedInt(Y.top,0,0,1e3),bottom:g.clampedInt(Y.bottom,0,0,1e3)}}}class J extends h{constructor(){const ee={enabled:!0,cycle:!0};super(Be.parameterHints,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11860,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:o.localize(11861,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),cycle:i(Y.cycle,this.defaultValue.cycle)}}}class ve extends l{constructor(){super(Be.pixelRatio)}compute(ee,Y,Xe){return ee.pixelRatio}}class pe extends h{constructor(){super(Be.placeholder,"placeholder",void 0)}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee:this.defaultValue}}class Ae extends h{constructor(){const ee={other:"on",comments:"off",strings:"off"},Y=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(11862,null),o.localize(11863,null),o.localize(11864,null)]}];super(Be.quickSuggestions,"quickSuggestions",ee,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Y,default:ee.strings,description:o.localize(11865,null)},comments:{anyOf:Y,default:ee.comments,description:o.localize(11866,null)},other:{anyOf:Y,default:ee.other,description:o.localize(11867,null)}},default:ee,markdownDescription:o.localize(11868,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=ee}validate(ee){if(typeof ee=="boolean"){const Zt=ee?"on":"off";return{comments:Zt,strings:Zt,other:Zt}}if(!ee||typeof ee!="object")return this.defaultValue;const{other:Y,comments:Xe,strings:Je}=ee,dt=["on","inline","off"];let bt,Mt,Ht;return typeof Y=="boolean"?bt=Y?"on":"off":bt=d(Y,this.defaultValue.other,dt),typeof Xe=="boolean"?Mt=Xe?"on":"off":Mt=d(Xe,this.defaultValue.comments,dt),typeof Je=="boolean"?Ht=Je?"on":"off":Ht=d(Je,this.defaultValue.strings,dt),{other:bt,comments:Mt,strings:Ht}}}var Ue;(function(ie){ie[ie.Off=0]="Off",ie[ie.On=1]="On",ie[ie.Relative=2]="Relative",ie[ie.Interval=3]="Interval",ie[ie.Custom=4]="Custom"})(Ue||(e.RenderLineNumbersType=Ue={}));class Ie extends h{constructor(){super(Be.lineNumbers,"lineNumbers",{renderType:Ue.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(11869,null),o.localize(11870,null),o.localize(11871,null),o.localize(11872,null)],default:"on",description:o.localize(11873,null)})}validate(ee){let Y=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof ee<"u"&&(typeof ee=="function"?(Y=Ue.Custom,Xe=ee):ee==="interval"?Y=Ue.Interval:ee==="relative"?Y=Ue.Relative:ee==="on"?Y=Ue.On:Y=Ue.Off),{renderType:Y,renderFn:Xe}}}function Pe(ie){const ee=ie.get(Be.renderValidationDecorations);return ee==="editable"?ie.get(Be.readOnly):ee!=="on"}class Oe extends h{constructor(){const ee=[],Y={type:"number",description:o.localize(11874,null)};super(Be.rulers,"rulers",ee,{type:"array",items:{anyOf:[Y,{type:["object"],properties:{column:Y,color:{type:"string",description:o.localize(11875,null),format:"color-hex"}}}]},default:ee,description:o.localize(11876,null)})}validate(ee){if(Array.isArray(ee)){const Y=[];for(const Xe of ee)if(typeof Xe=="number")Y.push({column:g.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const Je=Xe;Y.push({column:g.clampedInt(Je.column,0,0,1e4),color:Je.color})}return Y.sort((Xe,Je)=>Xe.column-Je.column),Y}return this.defaultValue}}class x extends h{constructor(){super(Be.readOnlyMessage,"readOnlyMessage",void 0)}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:ee}}function B(ie,ee){if(typeof ie!="string")return ee;switch(ie){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class H extends h{constructor(){const ee={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Be.scrollbar,"scrollbar",ee,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(11877,null),o.localize(11878,null),o.localize(11879,null)],default:"auto",description:o.localize(11880,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(11881,null),o.localize(11882,null),o.localize(11883,null)],default:"auto",description:o.localize(11884,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ee.verticalScrollbarSize,description:o.localize(11885,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ee.horizontalScrollbarSize,description:o.localize(11886,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ee.scrollByPage,description:o.localize(11887,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ee.ignoreHorizontalScrollbarInContentHeight,description:o.localize(11888,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee,Xe=g.clampedInt(Y.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Je=g.clampedInt(Y.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(Y.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(Y.vertical,this.defaultValue.vertical),horizontal:B(Y.horizontal,this.defaultValue.horizontal),useShadows:i(Y.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Y.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Y.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Y.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Y.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:g.clampedInt(Y.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:Je,verticalSliderSize:g.clampedInt(Y.verticalSliderSize,Je,0,1e3),scrollByPage:i(Y.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Y.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends h{constructor(){const ee={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Be.unicodeHighlighting,"unicodeHighlight",ee,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.nonBasicASCII,description:o.localize(11889,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ee.invisibleCharacters,description:o.localize(11890,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ee.ambiguousCharacters,description:o.localize(11891,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeComments,description:o.localize(11892,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeStrings,description:o.localize(11893,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ee.allowedCharacters,description:o.localize(11894,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ee.allowedLocales,description:o.localize(11895,null)}})}applyUpdate(ee,Y){let Xe=!1;Y.allowedCharacters&&ee&&(k.equals(ee.allowedCharacters,Y.allowedCharacters)||(ee={...ee,allowedCharacters:Y.allowedCharacters},Xe=!0)),Y.allowedLocales&&ee&&(k.equals(ee.allowedLocales,Y.allowedLocales)||(ee={...ee,allowedLocales:Y.allowedLocales},Xe=!0));const Je=super.applyUpdate(ee,Y);return Xe?new r(Je.newValue,!0):Je}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{nonBasicASCII:qe(Y.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Y.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Y.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:qe(Y.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:qe(Y.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ee.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ee.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ee,Y){if(typeof ee!="object"||!ee)return Y;const Xe={};for(const[Je,dt]of Object.entries(ee))dt===!0&&(Xe[Je]=!0);return Xe}}class re extends h{constructor(){const ee={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Be.inlineSuggest,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11896,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(11897,null),o.localize(11898,null),o.localize(11899,null)],description:o.localize(11900,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ee.suppressSuggestions,description:o.localize(11901,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(11902,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),mode:d(Y.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(Y.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Y.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Y.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:m.string(Y.fontFamily,this.defaultValue.fontFamily)}}}class ge extends h{constructor(){const ee={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(Be.inlineEdit,"experimentalInlineEdit",ee,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11903,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(11904,null),o.localize(11905,null),o.localize(11906,null)],description:o.localize(11907,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(11908,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),showToolbar:d(Y.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:m.string(Y.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Y.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Te extends h{constructor(){const ee={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Be.bracketPairColorization,"bracketPairColorization",ee,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11909,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ee.independentColorPoolPerBracketType,description:o.localize(11910,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Y.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class xe extends h{constructor(){const ee={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Be.guides,"guides",ee,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(11911,null),o.localize(11912,null),o.localize(11913,null)],default:ee.bracketPairs,description:o.localize(11914,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(11915,null),o.localize(11916,null),o.localize(11917,null)],default:ee.bracketPairsHorizontal,description:o.localize(11918,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ee.highlightActiveBracketPair,description:o.localize(11919,null)},"editor.guides.indentation":{type:"boolean",default:ee.indentation,description:o.localize(11920,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(11921,null),o.localize(11922,null),o.localize(11923,null)],default:ee.highlightActiveIndentation,description:o.localize(11924,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{bracketPairs:qe(Y.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:qe(Y.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Y.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Y.indentation,this.defaultValue.indentation),highlightActiveIndentation:qe(Y.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function qe(ie,ee,Y){const Xe=Y.indexOf(ie);return Xe===-1?ee:Y[Xe]}class Ze extends h{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Be.suggest,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(11925,null),o.localize(11926,null)],default:ee.insertMode,description:o.localize(11927,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:o.localize(11928,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:o.localize(11929,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:o.localize(11930,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(11931,null),o.localize(11932,null),o.localize(11933,null),o.localize(11934,null)],default:ee.selectionMode,markdownDescription:o.localize(11935,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:o.localize(11936,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:o.localize(11937,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:o.localize(11938,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:o.localize(11939,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:o.localize(11940,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(11941,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(11942,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(11943,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(11944,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(11945,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(11946,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(11947,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(11948,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(11949,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(11950,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(11951,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(11952,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(11953,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(11954,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(11955,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(11956,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(11957,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(11958,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(11959,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(11960,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(11961,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(11962,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(11963,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(11964,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(11965,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(11966,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(11967,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(11968,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(11969,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(11970,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(11971,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(11972,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{insertMode:d(Y.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Y.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Y.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Y.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Y.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(Y.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Y.showIcons,this.defaultValue.showIcons),showStatusBar:i(Y.showStatusBar,this.defaultValue.showStatusBar),preview:i(Y.preview,this.defaultValue.preview),previewMode:d(Y.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Y.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Y.showMethods,this.defaultValue.showMethods),showFunctions:i(Y.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Y.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Y.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Y.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Y.showFields,this.defaultValue.showFields),showVariables:i(Y.showVariables,this.defaultValue.showVariables),showClasses:i(Y.showClasses,this.defaultValue.showClasses),showStructs:i(Y.showStructs,this.defaultValue.showStructs),showInterfaces:i(Y.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Y.showModules,this.defaultValue.showModules),showProperties:i(Y.showProperties,this.defaultValue.showProperties),showEvents:i(Y.showEvents,this.defaultValue.showEvents),showOperators:i(Y.showOperators,this.defaultValue.showOperators),showUnits:i(Y.showUnits,this.defaultValue.showUnits),showValues:i(Y.showValues,this.defaultValue.showValues),showConstants:i(Y.showConstants,this.defaultValue.showConstants),showEnums:i(Y.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Y.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Y.showKeywords,this.defaultValue.showKeywords),showWords:i(Y.showWords,this.defaultValue.showWords),showColors:i(Y.showColors,this.defaultValue.showColors),showFiles:i(Y.showFiles,this.defaultValue.showFiles),showReferences:i(Y.showReferences,this.defaultValue.showReferences),showFolders:i(Y.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Y.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Y.showSnippets,this.defaultValue.showSnippets),showUsers:i(Y.showUsers,this.defaultValue.showUsers),showIssues:i(Y.showIssues,this.defaultValue.showIssues)}}}class tt extends h{constructor(){super(Be.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(11973,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:o.localize(11974,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(ee.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends h{constructor(){const ee=[];super(Be.wordSegmenterLocales,"wordSegmenterLocales",ee,{anyOf:[{description:o.localize(11975,null),type:"string"},{description:o.localize(11976,null),type:"array",items:{type:"string"}}]})}validate(ee){if(typeof ee=="string"&&(ee=[ee]),Array.isArray(ee)){const Y=[];for(const Xe of ee)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Y.push(Xe)}catch{}return Y}return this.defaultValue}}var et;(function(ie){ie[ie.None=0]="None",ie[ie.Same=1]="Same",ie[ie.Indent=2]="Indent",ie[ie.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends h{constructor(){super(Be.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(11977,null),o.localize(11978,null),o.localize(11979,null),o.localize(11980,null)],description:o.localize(11981,null),default:"same"}})}validate(ee){switch(ee){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(ee,Y,Xe){return Y.get(Be.accessibilitySupport)===I.AccessibilitySupport.Enabled?et.None:Xe}}class ft extends l{constructor(){super(Be.wrappingInfo)}compute(ee,Y,Xe){const Je=Y.get(Be.layoutInfo);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:Je.isWordWrapMinified,isViewportWrapping:Je.isViewportWrapping,wrappingColumn:Je.wrappingColumn}}}class ct extends h{constructor(){const ee={enabled:!0,showDropSelector:"afterDrop"};super(Be.dropIntoEditor,"dropIntoEditor",ee,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11982,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:o.localize(11983,null),enum:["afterDrop","never"],enumDescriptions:[o.localize(11984,null),o.localize(11985,null)],default:"afterDrop"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),showDropSelector:d(Y.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends h{constructor(){const ee={enabled:!0,showPasteSelector:"afterPaste"};super(Be.pasteAs,"pasteAs",ee,{"editor.pasteAs.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11986,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:o.localize(11987,null),enum:["afterPaste","never"],enumDescriptions:[o.localize(11988,null),o.localize(11989,null)],default:"afterPaste"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),showPasteSelector:d(Y.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const lt="Consolas, 'Courier New', monospace",mt="Menlo, Monaco, 'Courier New', monospace",vt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?mt:P.isLinux?vt:lt,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function $e(ie){return e.editorOptionsRegistry[ie.id]=ie,ie}var Be;(function(ie){ie[ie.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ie[ie.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ie[ie.accessibilitySupport=2]="accessibilitySupport",ie[ie.accessibilityPageSize=3]="accessibilityPageSize",ie[ie.ariaLabel=4]="ariaLabel",ie[ie.ariaRequired=5]="ariaRequired",ie[ie.autoClosingBrackets=6]="autoClosingBrackets",ie[ie.autoClosingComments=7]="autoClosingComments",ie[ie.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ie[ie.autoClosingDelete=9]="autoClosingDelete",ie[ie.autoClosingOvertype=10]="autoClosingOvertype",ie[ie.autoClosingQuotes=11]="autoClosingQuotes",ie[ie.autoIndent=12]="autoIndent",ie[ie.automaticLayout=13]="automaticLayout",ie[ie.autoSurround=14]="autoSurround",ie[ie.bracketPairColorization=15]="bracketPairColorization",ie[ie.guides=16]="guides",ie[ie.codeLens=17]="codeLens",ie[ie.codeLensFontFamily=18]="codeLensFontFamily",ie[ie.codeLensFontSize=19]="codeLensFontSize",ie[ie.colorDecorators=20]="colorDecorators",ie[ie.colorDecoratorsLimit=21]="colorDecoratorsLimit",ie[ie.columnSelection=22]="columnSelection",ie[ie.comments=23]="comments",ie[ie.contextmenu=24]="contextmenu",ie[ie.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ie[ie.cursorBlinking=26]="cursorBlinking",ie[ie.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ie[ie.cursorStyle=28]="cursorStyle",ie[ie.cursorSurroundingLines=29]="cursorSurroundingLines",ie[ie.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ie[ie.cursorWidth=31]="cursorWidth",ie[ie.disableLayerHinting=32]="disableLayerHinting",ie[ie.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ie[ie.domReadOnly=34]="domReadOnly",ie[ie.dragAndDrop=35]="dragAndDrop",ie[ie.dropIntoEditor=36]="dropIntoEditor",ie[ie.emptySelectionClipboard=37]="emptySelectionClipboard",ie[ie.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ie[ie.extraEditorClassName=39]="extraEditorClassName",ie[ie.fastScrollSensitivity=40]="fastScrollSensitivity",ie[ie.find=41]="find",ie[ie.fixedOverflowWidgets=42]="fixedOverflowWidgets",ie[ie.folding=43]="folding",ie[ie.foldingStrategy=44]="foldingStrategy",ie[ie.foldingHighlight=45]="foldingHighlight",ie[ie.foldingImportsByDefault=46]="foldingImportsByDefault",ie[ie.foldingMaximumRegions=47]="foldingMaximumRegions",ie[ie.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ie[ie.fontFamily=49]="fontFamily",ie[ie.fontInfo=50]="fontInfo",ie[ie.fontLigatures=51]="fontLigatures",ie[ie.fontSize=52]="fontSize",ie[ie.fontWeight=53]="fontWeight",ie[ie.fontVariations=54]="fontVariations",ie[ie.formatOnPaste=55]="formatOnPaste",ie[ie.formatOnType=56]="formatOnType",ie[ie.glyphMargin=57]="glyphMargin",ie[ie.gotoLocation=58]="gotoLocation",ie[ie.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ie[ie.hover=60]="hover",ie[ie.inDiffEditor=61]="inDiffEditor",ie[ie.inlineSuggest=62]="inlineSuggest",ie[ie.inlineEdit=63]="inlineEdit",ie[ie.letterSpacing=64]="letterSpacing",ie[ie.lightbulb=65]="lightbulb",ie[ie.lineDecorationsWidth=66]="lineDecorationsWidth",ie[ie.lineHeight=67]="lineHeight",ie[ie.lineNumbers=68]="lineNumbers",ie[ie.lineNumbersMinChars=69]="lineNumbersMinChars",ie[ie.linkedEditing=70]="linkedEditing",ie[ie.links=71]="links",ie[ie.matchBrackets=72]="matchBrackets",ie[ie.minimap=73]="minimap",ie[ie.mouseStyle=74]="mouseStyle",ie[ie.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ie[ie.mouseWheelZoom=76]="mouseWheelZoom",ie[ie.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ie[ie.multiCursorModifier=78]="multiCursorModifier",ie[ie.multiCursorPaste=79]="multiCursorPaste",ie[ie.multiCursorLimit=80]="multiCursorLimit",ie[ie.occurrencesHighlight=81]="occurrencesHighlight",ie[ie.overviewRulerBorder=82]="overviewRulerBorder",ie[ie.overviewRulerLanes=83]="overviewRulerLanes",ie[ie.padding=84]="padding",ie[ie.pasteAs=85]="pasteAs",ie[ie.parameterHints=86]="parameterHints",ie[ie.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ie[ie.placeholder=88]="placeholder",ie[ie.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ie[ie.quickSuggestions=90]="quickSuggestions",ie[ie.quickSuggestionsDelay=91]="quickSuggestionsDelay",ie[ie.readOnly=92]="readOnly",ie[ie.readOnlyMessage=93]="readOnlyMessage",ie[ie.renameOnType=94]="renameOnType",ie[ie.renderControlCharacters=95]="renderControlCharacters",ie[ie.renderFinalNewline=96]="renderFinalNewline",ie[ie.renderLineHighlight=97]="renderLineHighlight",ie[ie.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ie[ie.renderValidationDecorations=99]="renderValidationDecorations",ie[ie.renderWhitespace=100]="renderWhitespace",ie[ie.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ie[ie.roundedSelection=102]="roundedSelection",ie[ie.rulers=103]="rulers",ie[ie.scrollbar=104]="scrollbar",ie[ie.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ie[ie.scrollBeyondLastLine=106]="scrollBeyondLastLine",ie[ie.scrollPredominantAxis=107]="scrollPredominantAxis",ie[ie.selectionClipboard=108]="selectionClipboard",ie[ie.selectionHighlight=109]="selectionHighlight",ie[ie.selectOnLineNumbers=110]="selectOnLineNumbers",ie[ie.showFoldingControls=111]="showFoldingControls",ie[ie.showUnused=112]="showUnused",ie[ie.snippetSuggestions=113]="snippetSuggestions",ie[ie.smartSelect=114]="smartSelect",ie[ie.smoothScrolling=115]="smoothScrolling",ie[ie.stickyScroll=116]="stickyScroll",ie[ie.stickyTabStops=117]="stickyTabStops",ie[ie.stopRenderingLineAfter=118]="stopRenderingLineAfter",ie[ie.suggest=119]="suggest",ie[ie.suggestFontSize=120]="suggestFontSize",ie[ie.suggestLineHeight=121]="suggestLineHeight",ie[ie.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ie[ie.suggestSelection=123]="suggestSelection",ie[ie.tabCompletion=124]="tabCompletion",ie[ie.tabIndex=125]="tabIndex",ie[ie.unicodeHighlighting=126]="unicodeHighlighting",ie[ie.unusualLineTerminators=127]="unusualLineTerminators",ie[ie.useShadowDOM=128]="useShadowDOM",ie[ie.useTabStops=129]="useTabStops",ie[ie.wordBreak=130]="wordBreak",ie[ie.wordSegmenterLocales=131]="wordSegmenterLocales",ie[ie.wordSeparators=132]="wordSeparators",ie[ie.wordWrap=133]="wordWrap",ie[ie.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ie[ie.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ie[ie.wordWrapColumn=136]="wordWrapColumn",ie[ie.wordWrapOverride1=137]="wordWrapOverride1",ie[ie.wordWrapOverride2=138]="wordWrapOverride2",ie[ie.wrappingIndent=139]="wrappingIndent",ie[ie.wrappingStrategy=140]="wrappingStrategy",ie[ie.showDeprecated=141]="showDeprecated",ie[ie.inlayHints=142]="inlayHints",ie[ie.editorClassName=143]="editorClassName",ie[ie.pixelRatio=144]="pixelRatio",ie[ie.tabFocusMode=145]="tabFocusMode",ie[ie.layoutInfo=146]="layoutInfo",ie[ie.wrappingInfo=147]="wrappingInfo",ie[ie.defaultColorDecorators=148]="defaultColorDecorators",ie[ie.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ie[ie.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Be||(e.EditorOption=Be={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:$e(new n(Be.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(11990,null)})),acceptSuggestionOnEnter:$e(new C(Be.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(11991,null),""],markdownDescription:o.localize(11992,null)})),accessibilitySupport:$e(new T),accessibilityPageSize:$e(new g(Be.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(11993,null),tags:["accessibility"]})),ariaLabel:$e(new m(Be.ariaLabel,"ariaLabel",o.localize(11994,null))),ariaRequired:$e(new n(Be.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:$e(new n(Be.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:o.localize(11995,null),tags:["accessibility"]})),autoClosingBrackets:$e(new C(Be.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(11996,null),o.localize(11997,null),""],description:o.localize(11998,null)})),autoClosingComments:$e(new C(Be.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(11999,null),o.localize(12e3,null),""],description:o.localize(12001,null)})),autoClosingDelete:$e(new C(Be.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(12002,null),""],description:o.localize(12003,null)})),autoClosingOvertype:$e(new C(Be.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(12004,null),""],description:o.localize(12005,null)})),autoClosingQuotes:$e(new C(Be.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(12006,null),o.localize(12007,null),""],description:o.localize(12008,null)})),autoIndent:$e(new _(Be.autoIndent,"autoIndent",w.Full,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[o.localize(12009,null),o.localize(12010,null),o.localize(12011,null),o.localize(12012,null),o.localize(12013,null)],description:o.localize(12014,null)})),automaticLayout:$e(new n(Be.automaticLayout,"automaticLayout",!1)),autoSurround:$e(new C(Be.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(12015,null),o.localize(12016,null),o.localize(12017,null),""],description:o.localize(12018,null)})),bracketPairColorization:$e(new Te),bracketPairGuides:$e(new xe),stickyTabStops:$e(new n(Be.stickyTabStops,"stickyTabStops",!1,{description:o.localize(12019,null)})),codeLens:$e(new n(Be.codeLens,"codeLens",!0,{description:o.localize(12020,null)})),codeLensFontFamily:$e(new m(Be.codeLensFontFamily,"codeLensFontFamily","",{description:o.localize(12021,null)})),codeLensFontSize:$e(new g(Be.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(12022,null)})),colorDecorators:$e(new n(Be.colorDecorators,"colorDecorators",!0,{description:o.localize(12023,null)})),colorDecoratorActivatedOn:$e(new C(Be.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[o.localize(12024,null),o.localize(12025,null),o.localize(12026,null)],description:o.localize(12027,null)})),colorDecoratorsLimit:$e(new g(Be.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(12028,null)})),columnSelection:$e(new n(Be.columnSelection,"columnSelection",!1,{description:o.localize(12029,null)})),comments:$e(new D),contextmenu:$e(new n(Be.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:$e(new n(Be.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:o.localize(12030,null)})),cursorBlinking:$e(new _(Be.cursorBlinking,"cursorBlinking",f.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:o.localize(12031,null)})),cursorSmoothCaretAnimation:$e(new C(Be.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(12032,null),o.localize(12033,null),o.localize(12034,null)],description:o.localize(12035,null)})),cursorStyle:$e(new _(Be.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:o.localize(12036,null)})),cursorSurroundingLines:$e(new g(Be.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12037,null)})),cursorSurroundingLinesStyle:$e(new C(Be.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(12038,null),o.localize(12039,null)],markdownDescription:o.localize(12040,null)})),cursorWidth:$e(new g(Be.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(12041,null)})),disableLayerHinting:$e(new n(Be.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:$e(new n(Be.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:$e(new n(Be.domReadOnly,"domReadOnly",!1)),dragAndDrop:$e(new n(Be.dragAndDrop,"dragAndDrop",!0,{description:o.localize(12042,null)})),emptySelectionClipboard:$e(new j),dropIntoEditor:$e(new ct),stickyScroll:$e(new z),experimentalWhitespaceRendering:$e(new C(Be.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(12043,null),o.localize(12044,null),o.localize(12045,null)],description:o.localize(12046,null)})),extraEditorClassName:$e(new m(Be.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:$e(new v(Be.fastScrollSensitivity,"fastScrollSensitivity",5,ie=>ie<=0?5:ie,{markdownDescription:o.localize(12047,null)})),find:$e(new $),fixedOverflowWidgets:$e(new n(Be.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:$e(new n(Be.folding,"folding",!0,{description:o.localize(12048,null)})),foldingStrategy:$e(new C(Be.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(12049,null),o.localize(12050,null)],description:o.localize(12051,null)})),foldingHighlight:$e(new n(Be.foldingHighlight,"foldingHighlight",!0,{description:o.localize(12052,null)})),foldingImportsByDefault:$e(new n(Be.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:o.localize(12053,null)})),foldingMaximumRegions:$e(new g(Be.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(12054,null)})),unfoldOnClickAfterEndOfLine:$e(new n(Be.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(12055,null)})),fontFamily:$e(new m(Be.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(12056,null)})),fontInfo:$e(new ae),fontLigatures2:$e(new K),fontSize:$e(new Ee),fontWeight:$e(new ce),fontVariations:$e(new q),formatOnPaste:$e(new n(Be.formatOnPaste,"formatOnPaste",!1,{description:o.localize(12057,null)})),formatOnType:$e(new n(Be.formatOnType,"formatOnType",!1,{description:o.localize(12058,null)})),glyphMargin:$e(new n(Be.glyphMargin,"glyphMargin",!0,{description:o.localize(12059,null)})),gotoLocation:$e(new Z),hideCursorInOverviewRuler:$e(new n(Be.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:o.localize(12060,null)})),hover:$e(new le),inDiffEditor:$e(new n(Be.inDiffEditor,"inDiffEditor",!1)),letterSpacing:$e(new v(Be.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ie=>v.clamp(ie,-5,20),{description:o.localize(12061,null)})),lightbulb:$e(new Q),lineDecorationsWidth:$e(new Ce),lineHeight:$e(new fe),lineNumbers:$e(new Ie),lineNumbersMinChars:$e(new g(Be.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:$e(new n(Be.linkedEditing,"linkedEditing",!1,{description:o.localize(12062,null)})),links:$e(new n(Be.links,"links",!0,{description:o.localize(12063,null)})),matchBrackets:$e(new C(Be.matchBrackets,"matchBrackets","always",["always","near","never"],{description:o.localize(12064,null)})),minimap:$e(new be),mouseStyle:$e(new C(Be.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:$e(new v(Be.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ie=>ie===0?1:ie,{markdownDescription:o.localize(12065,null)})),mouseWheelZoom:$e(new n(Be.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.isMacintosh?o.localize(12066,null):o.localize(12067,null)})),multiCursorMergeOverlapping:$e(new n(Be.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:o.localize(12068,null)})),multiCursorModifier:$e(new _(Be.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[o.localize(12069,null),o.localize(12070,null)],markdownDescription:o.localize(12071,null)})),multiCursorPaste:$e(new C(Be.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(12072,null),o.localize(12073,null)],markdownDescription:o.localize(12074,null)})),multiCursorLimit:$e(new g(Be.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(12075,null)})),occurrencesHighlight:$e(new C(Be.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[o.localize(12076,null),o.localize(12077,null),o.localize(12078,null)],markdownDescription:o.localize(12079,null)})),overviewRulerBorder:$e(new n(Be.overviewRulerBorder,"overviewRulerBorder",!0,{description:o.localize(12080,null)})),overviewRulerLanes:$e(new g(Be.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:$e(new X),pasteAs:$e(new st),parameterHints:$e(new J),peekWidgetDefaultFocus:$e(new C(Be.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(12081,null),o.localize(12082,null)],description:o.localize(12083,null)})),placeholder:$e(new pe),definitionLinkOpensInPeek:$e(new n(Be.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:o.localize(12084,null)})),quickSuggestions:$e(new Ae),quickSuggestionsDelay:$e(new g(Be.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12085,null)})),readOnly:$e(new n(Be.readOnly,"readOnly",!1)),readOnlyMessage:$e(new x),renameOnType:$e(new n(Be.renameOnType,"renameOnType",!1,{description:o.localize(12086,null),markdownDeprecationMessage:o.localize(12087,null)})),renderControlCharacters:$e(new n(Be.renderControlCharacters,"renderControlCharacters",!0,{description:o.localize(12088,null),restricted:!0})),renderFinalNewline:$e(new C(Be.renderFinalNewline,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:o.localize(12089,null)})),renderLineHighlight:$e(new C(Be.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(12090,null)],description:o.localize(12091,null)})),renderLineHighlightOnlyWhenFocus:$e(new n(Be.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(12092,null)})),renderValidationDecorations:$e(new C(Be.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:$e(new C(Be.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(12093,null),o.localize(12094,null),o.localize(12095,null),""],description:o.localize(12096,null)})),revealHorizontalRightPadding:$e(new g(Be.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:$e(new n(Be.roundedSelection,"roundedSelection",!0,{description:o.localize(12097,null)})),rulers:$e(new Oe),scrollbar:$e(new H),scrollBeyondLastColumn:$e(new g(Be.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12098,null)})),scrollBeyondLastLine:$e(new n(Be.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:o.localize(12099,null)})),scrollPredominantAxis:$e(new n(Be.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:o.localize(12100,null)})),selectionClipboard:$e(new n(Be.selectionClipboard,"selectionClipboard",!0,{description:o.localize(12101,null),included:P.isLinux})),selectionHighlight:$e(new n(Be.selectionHighlight,"selectionHighlight",!0,{description:o.localize(12102,null)})),selectOnLineNumbers:$e(new n(Be.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:$e(new C(Be.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(12103,null),o.localize(12104,null),o.localize(12105,null)],description:o.localize(12106,null)})),showUnused:$e(new n(Be.showUnused,"showUnused",!0,{description:o.localize(12107,null)})),showDeprecated:$e(new n(Be.showDeprecated,"showDeprecated",!0,{description:o.localize(12108,null)})),inlayHints:$e(new ne),snippetSuggestions:$e(new C(Be.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(12109,null),o.localize(12110,null),o.localize(12111,null),o.localize(12112,null)],description:o.localize(12113,null)})),smartSelect:$e(new tt),smoothScrolling:$e(new n(Be.smoothScrolling,"smoothScrolling",!1,{description:o.localize(12114,null)})),stopRenderingLineAfter:$e(new g(Be.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:$e(new Ze),inlineSuggest:$e(new re),inlineEdit:$e(new ge),inlineCompletionsAccessibilityVerbose:$e(new n(Be.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:o.localize(12115,null)})),suggestFontSize:$e(new g(Be.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(12116,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:$e(new g(Be.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(12117,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:$e(new n(Be.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:o.localize(12118,null)})),suggestSelection:$e(new C(Be.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(12119,null),o.localize(12120,null),o.localize(12121,null)],description:o.localize(12122,null)})),tabCompletion:$e(new C(Be.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(12123,null),o.localize(12124,null),o.localize(12125,null)],description:o.localize(12126,null)})),tabIndex:$e(new g(Be.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:$e(new V),unusualLineTerminators:$e(new C(Be.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(12127,null),o.localize(12128,null),o.localize(12129,null)],description:o.localize(12130,null)})),useShadowDOM:$e(new n(Be.useShadowDOM,"useShadowDOM",!0)),useTabStops:$e(new n(Be.useTabStops,"useTabStops",!0,{description:o.localize(12131,null)})),wordBreak:$e(new C(Be.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(12132,null),o.localize(12133,null)],description:o.localize(12134,null)})),wordSegmenterLocales:$e(new nt),wordSeparators:$e(new m(Be.wordSeparators,"wordSeparators",p.USUAL_WORD_SEPARATORS,{description:o.localize(12135,null)})),wordWrap:$e(new C(Be.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(12136,null),o.localize(12137,null),o.localize(12138,null),o.localize(12139,null)],description:o.localize(12140,null)})),wordWrapBreakAfterCharacters:$e(new m(Be.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:$e(new m(Be.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:$e(new g(Be.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(12141,null)})),wordWrapOverride1:$e(new C(Be.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:$e(new C(Be.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:$e(new W),defaultColorDecorators:$e(new n(Be.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:o.localize(12142,null)})),pixelRatio:$e(new ve),tabFocusMode:$e(new n(Be.tabFocusMode,"tabFocusMode",!1,{markdownDescription:o.localize(12143,null)})),layoutInfo:$e(new oe),wrappingInfo:$e(new ft),wrappingIndent:$e(new rt),wrappingStrategy:$e(new De)}}),define(Le[106],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(Le[29],Ne([1,0,58,19,12,14,2,9,3,20,15,48]),function(Se,e,S,k,P,O,A,R,p,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=a,e.isFileSystemWatcher=s,e.hasReadWriteCapability=c,e.hasFileFolderCopyCapability=i,e.hasFileCloneCapability=n,e.hasOpenReadWriteCloseCapability=t,e.hasFileReadStreamCapability=g,e.hasFileAtomicReadCapability=u,e.hasFileAtomicWriteCapability=v,e.hasFileAtomicDeleteCapability=m,e.hasReadonlyCapability=d,e.createFileSystemProviderError=E,e.ensureFileSystemProviderError=T,e.markAsFileSystemProviderError=D,e.toFileSystemProviderErrorCode=f,e.toFileOperationResult=b,e.isParent=j,e.etag=ce,e.whenProviderRegistered=Z,e.getLargeFileConfirmationLimit=me,e.IFileService=(0,p.createDecorator)("fileService");function a(oe){return oe.create===!0}var y;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var h;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var r;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function s(oe){const De=oe;return!!De&&typeof De.onDidChange=="function"}var l;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(l||(e.FileSystemProviderCapabilities=l={}));function c(oe){return!!(oe.capabilities&l.FileReadWrite)}function i(oe){return!!(oe.capabilities&l.FileFolderCopy)}function n(oe){return!!(oe.capabilities&l.FileClone)}function t(oe){return!!(oe.capabilities&l.FileOpenReadWriteClose)}function g(oe){return!!(oe.capabilities&l.FileReadStream)}function u(oe){return c(oe)?!!(oe.capabilities&l.FileAtomicRead):!1}function v(oe){return c(oe)?!!(oe.capabilities&l.FileAtomicWrite):!1}function m(oe){return!!(oe.capabilities&l.FileAtomicDelete)}function d(oe){return!!(oe.capabilities&l.Readonly)}var C;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(C||(e.FileSystemProviderErrorCode=C={}));class _ extends Error{static create(De,Re){const Q=new _(De.toString(),Re);return D(Q,Re),Q}constructor(De,Re){super(De),this.code=Re}}e.FileSystemProviderError=_;function E(oe,De){return _.create(oe,De)}function T(oe){return oe||E((0,R.localize)(11386,null),C.Unknown)}function D(oe,De){return oe.name=De?`${De} (FileSystemError)`:"FileSystemError",oe}function f(oe){if(!oe)return C.Unknown;if(oe instanceof _)return oe.code;const De=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!De)return C.Unknown;switch(De[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}function b(oe){if(oe instanceof $)return oe.fileOperationResult;switch(f(oe)){case C.FileNotFound:return ae.FILE_NOT_FOUND;case C.FileIsADirectory:return ae.FILE_IS_DIRECTORY;case C.FileNotADirectory:return ae.FILE_NOT_DIRECTORY;case C.FileWriteLocked:return ae.FILE_WRITE_LOCKED;case C.NoPermissions:return ae.FILE_PERMISSION_DENIED;case C.FileExists:return ae.FILE_MOVE_CONFLICT;case C.FileTooLarge:return ae.FILE_TOO_LARGE;default:return ae.FILE_OTHER_ERROR}}var M;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class L{constructor(De,Re,Q){this.resource=De,this.operation=Re,this.target=Q}isOperation(De){return this.operation===De}}e.FileOperationEvent=L;var N;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class W{static{this.MIXED_CORRELATION=null}constructor(De,Re){this.ignorePathCasing=Re,this.correlationId=void 0,this.added=new w.Lazy(()=>{const Q=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Q.fill(this.rawAdded.map(z=>[z,!0])),Q}),this.updated=new w.Lazy(()=>{const Q=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Q.fill(this.rawUpdated.map(z=>[z,!0])),Q}),this.deleted=new w.Lazy(()=>{const Q=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Q.fill(this.rawDeleted.map(z=>[z,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of De){switch(Q.type){case N.ADDED:this.rawAdded.push(Q.resource);break;case N.UPDATED:this.rawUpdated.push(Q.resource);break;case N.DELETED:this.rawDeleted.push(Q.resource);break}this.correlationId!==W.MIXED_CORRELATION&&(typeof Q.cId=="number"?this.correlationId===void 0?this.correlationId=Q.cId:this.correlationId!==Q.cId&&(this.correlationId=W.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=W.MIXED_CORRELATION))}}contains(De,...Re){return this.doContains(De,{includeChildren:!1},...Re)}affects(De,...Re){return this.doContains(De,{includeChildren:!0},...Re)}doContains(De,Re,...Q){if(!De)return!1;const z=Q.length>0;return!!((!z||Q.includes(N.ADDED))&&(this.added.value.get(De)||Re.includeChildren&&this.added.value.findSuperstr(De))||(!z||Q.includes(N.UPDATED))&&(this.updated.value.get(De)||Re.includeChildren&&this.updated.value.findSuperstr(De))||(!z||Q.includes(N.DELETED))&&(this.deleted.value.findSubstr(De)||Re.includeChildren&&this.deleted.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.correlationId===De}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=W;function j(oe,De,Re){return!oe||!De||oe===De||De.length>oe.length?!1:(De.charAt(De.length-1)!==k.sep&&(De+=k.sep),Re?(0,P.startsWithIgnoreCase)(oe,De):oe.indexOf(De)===0)}class $ extends Error{constructor(De,Re,Q){super(De),this.fileOperationResult=Re,this.options=Q}}e.FileOperationError=$;class K extends ${constructor(De,Re,Q,z){super(De,Re,z),this.fileOperationResult=Re,this.size=Q}}e.TooLargeFileOperationError=K;class q extends ${constructor(De,Re,Q){super(De,ae.FILE_NOT_MODIFIED_SINCE,Q),this.stat=Re}}e.NotModifiedSinceFileOperationError=q;var ae;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Ee;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ee||(e.FileKind=Ee={})),e.ETAG_DISABLED="";function ce(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function Z(oe,De){if(!De.hasProvider(A.URI.from({scheme:oe.scheme})))return new Promise(Re=>{const Q=De.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===oe.scheme&&z.added&&(Q.dispose(),Re())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(De){return(0,O.isNumber)(De)||(De=0),De<le.KB?(0,R.localize)(11387,null,De.toFixed(0)):De<le.MB?(0,R.localize)(11388,null,(De/le.KB).toFixed(2)):De<le.GB?(0,R.localize)(11389,null,(De/le.MB).toFixed(2)):De<le.TB?(0,R.localize)(11390,null,(De/le.GB).toFixed(2)):(0,R.localize)(11391,null,(De/le.TB).toFixed(2))}}e.ByteSize=le;function me(oe){const De=typeof oe=="string"||oe?.scheme===I.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===I.Schemas.file?1024*le.MB:De?10*le.MB:o.isWeb?50*le.MB:1024*le.MB}}),define(Le[74],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...P){this._entries=new Map;for(const[O,A]of P)this.set(O,A)}set(P,O){const A=this._entries.get(P);return this._entries.set(P,O),A}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=S}),define(Le[170],Ne([1,0,10,13,4,73,167,3,74,171]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class w extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class a{constructor(s=new p.ServiceCollection,l=!1,c,i=I){this._services=s,this._strict=l,this._parent=c,this._enableTracing=i,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=i?c?._globalGraph??new A.Graph(n=>n):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,P.dispose)(this._children),this._children.clear();for(const s of this._servicesToMaybeDispose)(0,P.isDisposable)(s)&&s.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(s,l){this._throwIfDisposed();const c=this,i=new class extends a{dispose(){c._children.delete(i),super.dispose()}}(s,this._strict,this,this._enableTracing);return this._children.add(i),l?.add(i),i}invokeFunction(s,...l){this._throwIfDisposed();const c=h.traceInvocation(this._enableTracing,s);let i=!1;try{return s({get:t=>{if(i)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(t,c);if(!g)throw new Error(`[invokeFunction] unknown service '${t}'`);return g}},...l)}finally{i=!0,c.stop()}}createInstance(s,...l){this._throwIfDisposed();let c,i;return s instanceof O.SyncDescriptor?(c=h.traceCreation(this._enableTracing,s.ctor),i=this._createInstance(s.ctor,s.staticArguments.concat(l),c)):(c=h.traceCreation(this._enableTracing,s),i=this._createInstance(s,l,c)),c.stop(),i}_createInstance(s,l=[],c){const i=R._util.getServiceDependencies(s).sort((g,u)=>g.index-u.index),n=[];for(const g of i){const u=this._getOrCreateServiceInstance(g.id,c);u||this._throwIfStrict(`[createInstance] ${s.name} depends on UNKNOWN service ${g.id}.`,!1),n.push(u)}const t=i.length>0?i[0].index:l.length;if(l.length!==t){console.trace(`[createInstance] First service dependency of ${s.name} at position ${t+1} conflicts with ${l.length} static arguments`);const g=t-l.length;g>0?l=l.concat(new Array(g)):l=l.slice(0,t)}return Reflect.construct(s,l.concat(n))}_setCreatedServiceInstance(s,l){if(this._services.get(s)instanceof O.SyncDescriptor)this._services.set(s,l);else if(this._parent)this._parent._setCreatedServiceInstance(s,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){const l=this._services.get(s);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):l}_getOrCreateServiceInstance(s,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(s));const c=this._getServiceInstanceOrDescriptor(s);return c instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,c,l.branch(s,!0)):(l.branch(s,!1),c)}_safeCreateAndCacheServiceInstance(s,l,c){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,l,c)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,l,c){const i=new A.Graph(u=>u.id.toString());let n=0;const t=[{id:s,desc:l,_trace:c}],g=new Set;for(;t.length;){const u=t.pop();if(!g.has(String(u.id))){if(g.add(String(u.id)),i.lookupOrInsertNode(u),n++>1e3)throw new w(i);for(const v of R._util.getServiceDependencies(u.desc.ctor)){const m=this._getServiceInstanceOrDescriptor(v.id);if(m||this._throwIfStrict(`[createInstance] ${s} depends on ${v.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(u.id),String(v.id)),m instanceof O.SyncDescriptor){const d={id:v.id,desc:m,_trace:u._trace.branch(v.id,!0)};i.insertEdge(u,d),t.push(d)}}}}for(;;){const u=i.roots();if(u.length===0){if(!i.isEmpty())throw new w(i);break}for(const{data:v}of u){if(this._getServiceInstanceOrDescriptor(v.id)instanceof O.SyncDescriptor){const d=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setCreatedServiceInstance(v.id,d)}i.removeNode(v)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,l,c=[],i,n){if(this._services.get(s)instanceof O.SyncDescriptor)return this._createServiceInstance(s,l,c,i,n,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,l,c,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(s,l,c=[],i,n,t){if(i){const g=new a(void 0,this._strict,this,this._enableTracing);g._globalGraphImplicitDependency=String(s);const u=new Map,v=new S.GlobalIdleValue(()=>{const m=g._createInstance(l,c,n);for(const[d,C]of u){const _=m[d];if(typeof _=="function")for(const E of C)E.disposable=_.apply(m,E.listener)}return u.clear(),t.add(m),m});return new Proxy(Object.create(null),{get(m,d){if(!v.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let E=u.get(d);return E||(E=new o.LinkedList,u.set(d,E)),(D,f,b)=>{if(v.isInitialized)return v.value[d](D,f,b);{const M={listener:[D,f,b],disposable:void 0},L=E.push(M);return(0,P.toDisposable)(()=>{L(),M.disposable?.dispose()})}}}if(d in m)return m[d];const C=v.value;let _=C[d];return typeof _!="function"||(_=_.bind(C),m[d]=_),_},set(m,d,C){return v.value[d]=C,!0},getPrototypeOf(m){return l.prototype}})}else{const g=this._createInstance(l,c,n);return t.add(g),g}}_throwIfStrict(s,l){if(l&&console.warn(s),this._strict)throw new Error(s)}}e.InstantiationService=a;var y;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(y||(y={}));class h{static{this.all=new Set}static{this._None=new class extends h{constructor(){super(y.None,null)}stop(){}branch(){return this}}}static traceInvocation(s,l){return s?new h(y.Invocation,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h._None}static traceCreation(s,l){return s?new h(y.Creation,l.name):h._None}static{this._totals=0}constructor(s,l){this.type=s,this.name=l,this._start=Date.now(),this._dep=[]}branch(s,l){const c=new h(y.Branch,s.toString());return this._dep.push([s,l,c]),c}stop(){const s=Date.now()-this._start;h._totals+=s;let l=!1;function c(n,t){const g=[],u=new Array(n+1).join("	");for(const[v,m,d]of t._dep)if(m&&d){l=!0,g.push(`${u}CREATES -> ${v}`);const C=c(n+1,d);C&&g.push(C)}else g.push(`${u}uses -> ${v}`);return g.join(`
`)}const i=[`${this.type===y.Creation?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(s>2||l)&&h.all.add(i.join(`
`))}}e.Trace=h}),define(Le[11],Ne([1,0,9,42,6,75,4,28,20,23,14,2,31,3]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=r,e.log=l,e.getLogLevel=_,e.LogLevelToString=E,e.LogLevelToLocalizedString=T,e.parseLogLevel=D,S=We(S),e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function h(){return new Date().toISOString()}function r(f){return(0,I.isNumber)(f)}var s;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(s||(e.LogLevel=s={})),e.DEFAULT_LOG_LEVEL=s.Info;function l(f,b,M){switch(b){case s.Trace:f.trace(M);break;case s.Debug:f.debug(M);break;case s.Info:f.info(M);break;case s.Warning:f.warn(M);break;case s.Error:f.error(M);break;case s.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function c(f,b=!1){let M="";for(let L=0;L<f.length;L++){let N=f[L];if(N instanceof Error&&(N=(0,k.toErrorMessage)(N,b)),typeof N=="object")try{N=JSON.stringify(N)}catch{}M+=(L>0?" ":"")+N}return M}class i extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(b){this.level!==b&&(this.level=b,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(b){return this.level!==s.Off&&this.level<=b}}e.AbstractLogger=i;class n extends i{constructor(b){super(),this.logAlways=b}checkLogLevel(b){return this.logAlways||super.checkLogLevel(b)}trace(b,...M){this.checkLogLevel(s.Trace)&&this.log(s.Trace,c([b,...M],!0))}debug(b,...M){this.checkLogLevel(s.Debug)&&this.log(s.Debug,c([b,...M]))}info(b,...M){this.checkLogLevel(s.Info)&&this.log(s.Info,c([b,...M]))}warn(b,...M){this.checkLogLevel(s.Warning)&&this.log(s.Warning,c([b,...M]))}error(b,...M){if(this.checkLogLevel(s.Error))if(b instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=b.stack,this.log(s.Error,c(L))}else this.log(s.Error,c([b,...M]))}flush(){}}e.AbstractMessageLogger=n;class t extends i{constructor(b=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(b),this.useColors=!p.isWindows}trace(b,...M){this.checkLogLevel(s.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,b,...M):console.log(`[main ${h()}]`,b,...M))}debug(b,...M){this.checkLogLevel(s.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,b,...M):console.log(`[main ${h()}]`,b,...M))}info(b,...M){this.checkLogLevel(s.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,b,...M):console.log(`[main ${h()}]`,b,...M))}warn(b,...M){this.checkLogLevel(s.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,b,...M):console.warn(`[main ${h()}]`,b,...M))}error(b,...M){this.checkLogLevel(s.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,b,...M):console.error(`[main ${h()}]`,b,...M))}flush(){}}e.ConsoleMainLogger=t;class g extends i{constructor(b=e.DEFAULT_LOG_LEVEL,M=!0){super(),this.useColors=M,this.setLevel(b)}trace(b,...M){this.checkLogLevel(s.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",b,...M):console.log(b,...M))}debug(b,...M){this.checkLogLevel(s.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",b,...M):console.log(b,...M))}info(b,...M){this.checkLogLevel(s.Info)&&(this.useColors?console.log("%c INFO","color: #33f",b,...M):console.log(b,...M))}warn(b,...M){this.checkLogLevel(s.Warning)&&(this.useColors?console.log("%c WARN","color: #993",b,...M):console.log(b,...M))}error(b,...M){this.checkLogLevel(s.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",b,...M):console.error(b,...M))}flush(){}}e.ConsoleLogger=g;class u extends i{constructor(b,M=e.DEFAULT_LOG_LEVEL){super(),this.adapter=b,this.setLevel(M)}trace(b,...M){this.checkLogLevel(s.Trace)&&this.adapter.log(s.Trace,[this.extractMessage(b),...M])}debug(b,...M){this.checkLogLevel(s.Debug)&&this.adapter.log(s.Debug,[this.extractMessage(b),...M])}info(b,...M){this.checkLogLevel(s.Info)&&this.adapter.log(s.Info,[this.extractMessage(b),...M])}warn(b,...M){this.checkLogLevel(s.Warning)&&this.adapter.log(s.Warning,[this.extractMessage(b),...M])}error(b,...M){this.checkLogLevel(s.Error)&&this.adapter.log(s.Error,[this.extractMessage(b),...M])}extractMessage(b){return typeof b=="string"?b:(0,k.toErrorMessage)(b,this.checkLogLevel(s.Trace))}flush(){}}e.AdapterLogger=u;class v extends i{constructor(b){super(),this.loggers=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const M of this.loggers)M.setLevel(b);super.setLevel(b)}trace(b,...M){for(const L of this.loggers)L.trace(b,...M)}debug(b,...M){for(const L of this.loggers)L.debug(b,...M)}info(b,...M){for(const L of this.loggers)L.info(b,...M)}warn(b,...M){for(const L of this.loggers)L.warn(b,...M)}error(b,...M){for(const L of this.loggers)L.error(b,...M)}flush(){for(const b of this.loggers)b.flush()}dispose(){for(const b of this.loggers)b.dispose();super.dispose()}}e.MultiplexLogger=v;class m extends A.Disposable{constructor(b,M,L){if(super(),this.logLevel=b,this.logsHome=M,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new P.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,L)for(const N of L)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(b){return(0,I.isString)(b)?[...this._loggers.values()].find(M=>M.info.id===b):this._loggers.get(b)}getLogger(b){return this.getLoggerEntry(b)?.logger}createLogger(b,M){const L=this.toResource(b),N=(0,I.isString)(b)?b:M?.id??(0,O.hash)(L.toString()).toString(16);let W=this._loggers.get(L)?.logger;const j=M?.logLevel==="always"?s.Trace:M?.logLevel;W||(W=this.doCreateLogger(L,j??this.getLogLevel(L)??this.logLevel,{...M,id:N}));const $={logger:W,info:{resource:L,id:N,logLevel:j,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger($.info),this._loggers.set(L,$),W}toResource(b){return(0,I.isString)(b)?(0,o.joinPath)(this.logsHome,`${b}.log`):b}setLogLevel(b,M){if(w.URI.isUri(b)){const L=b,N=M,W=this._loggers.get(L);W&&N!==W.info.logLevel&&(W.info.logLevel=N===this.logLevel?void 0:N,W.logger?.setLevel(N),this._loggers.set(W.info.resource,W),this._onDidChangeLogLevel.fire([L,N]))}else{this.logLevel=b;for(const[L,N]of this._loggers.entries())this._loggers.get(L)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(b,M){const L=this.getLoggerEntry(b);L&&M!==!L.info.hidden&&(L.info.hidden=!M,this._loggers.set(L.info.resource,L),this._onDidChangeVisibility.fire([L.info.resource,M]))}getLogLevel(b){let M;return b&&(M=this._loggers.get(b)?.info.logLevel),M??this.logLevel}registerLogger(b){const M=this._loggers.get(b.resource);M?M.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this._loggers.set(b.resource,{info:b,logger:void 0}),this._onDidChangeLoggers.fire({added:[b],removed:[]}))}deregisterLogger(b){const M=this._loggers.get(b);M&&(M.logger&&M.logger.dispose(),this._loggers.delete(b),this._onDidChangeLoggers.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const b of this._loggers.values())yield b.info}getRegisteredLogger(b){return this._loggers.get(b)?.info}dispose(){this._loggers.forEach(b=>b.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class d{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(b){}getLevel(){return s.Info}trace(b,...M){}debug(b,...M){}info(b,...M){}warn(b,...M){}error(b,...M){}critical(b,...M){}dispose(){}flush(){}}e.NullLogger=d;class C extends d{}e.NullLogService=C;function _(f){if(f.verbose)return s.Trace;if(typeof f.logLevel=="string"){const b=D(f.logLevel.toLowerCase());if(b!==void 0)return b}return e.DEFAULT_LOG_LEVEL}function E(f){switch(f){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function T(f){switch(f){case s.Trace:return{original:"Trace",value:S.localize(11319,null)};case s.Debug:return{original:"Debug",value:S.localize(11320,null)};case s.Info:return{original:"Info",value:S.localize(11321,null)};case s.Warning:return{original:"Warning",value:S.localize(11322,null)};case s.Error:return{original:"Error",value:S.localize(11323,null)};case s.Off:return{original:"Off",value:S.localize(11324,null)}}}function D(f){switch(f){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.CONTEXT_LOG_LEVEL=new a.RawContextKey("logLevel",E(s.Info))}),define(Le[172],Ne([1,0,4,11]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class P extends S.Disposable{constructor(A,R=[]){super(),this.logger=new k.MultiplexLogger([A,...R]),this._register(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}flush(){this.logger.flush()}}e.LogService=P});var Jt=this&&this.__importDefault||function(Se){return Se&&Se.__esModule?Se:{default:Se}};define(Le[107],Ne([1,0,35,9,3]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,S=Jt(S);var O;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function o(h,r){return r-h}p.compare=o;const I=Object.create(null);I[p.Error]=(0,k.localize)(11316,null),I[p.Warning]=(0,k.localize)(11317,null),I[p.Info]=(0,k.localize)(11318,null);function w(h){return I[h]||""}p.toString=w;function a(h){switch(h){case S.default.Error:return p.Error;case S.default.Warning:return p.Warning;case S.default.Info:return p.Info;case S.default.Ignore:return p.Hint}}p.fromSeverity=a;function y(h){switch(h){case p.Error:return S.default.Error;case p.Warning:return S.default.Warning;case p.Info:return S.default.Info;case p.Hint:return S.default.Ignore}}p.toSeverity=y}(A||(e.MarkerSeverity=A={}));var R;(function(p){const o="";function I(a){return w(a,!0)}p.makeKey=I;function w(a,y){const h=[o];return a.source?h.push(a.source.replace("\xA6","\\\xA6")):h.push(o),a.code?typeof a.code=="string"?h.push(a.code.replace("\xA6","\\\xA6")):h.push(a.code.value.replace("\xA6","\\\xA6")):h.push(o),a.severity!==void 0&&a.severity!==null?h.push(A.toString(a.severity)):h.push(o),a.message&&y?h.push(a.message.replace("\xA6","\\\xA6")):h.push(o),a.startLineNumber!==void 0&&a.startLineNumber!==null?h.push(a.startLineNumber.toString()):h.push(o),a.startColumn!==void 0&&a.startColumn!==null?h.push(a.startColumn.toString()):h.push(o),a.endLineNumber!==void 0&&a.endLineNumber!==null?h.push(a.endLineNumber.toString()):h.push(o),a.endColumn!==void 0&&a.endColumn!==null?h.push(a.endColumn.toString()):h.push(o),h.push(o),h.join("\xA6")}p.makeKeyOptionalMessage=w})(R||(e.IMarkerData=R={})),e.IMarkerService=(0,P.createDecorator)("markerService")});var Jt=this&&this.__importDefault||function(Se){return Se&&Se.__esModule?Se:{default:Se}};define(Le[173],Ne([1,0,6,35,3]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=R,k=Jt(k),e.Severity=k.default,e.INotificationService=(0,P.createDecorator)("notificationService");var O;(function(w){w[w.DEFAULT=0]="DEFAULT",w[w.SILENT=1]="SILENT",w[w.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(w){w[w.WORKSPACE=0]="WORKSPACE",w[w.PROFILE=1]="PROFILE",w[w.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function R(w){if(w){const a=w;return typeof a.id=="string"&&typeof a.label=="string"}return!1}var p;(function(w){w[w.OFF=0]="OFF",w[w.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class o{constructor(){this.progress=new I,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(a){}updateMessage(a){}updateActions(a){}close(){}}e.NoOpNotification=o;class I{infinite(){}done(){}total(a){}worked(a){}}e.NoOpProgress=I}),define(Le[108],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(Se,e,S,k){var P=arguments.length,O=P<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,S):k,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(Se,e,S,k);else for(var R=Se.length-1;R>=0;R--)(A=Se[R])&&(O=(P<3?A(O):P>3?A(e,S,O):A(e,S))||O);return P>3&&O&&Object.defineProperty(e,S,O),O},Ve=this&&this.__param||function(Se,e){return function(S,k){e(S,k,Se)}};define(Le[76],Ne([1,0,10,21,4,3]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,O.createDecorator)("progressService");var A;(function(w){w[w.Explorer=1]="Explorer",w[w.Scm=3]="Scm",w[w.Extensions=5]="Extensions",w[w.Window=10]="Window",w[w.Notification=15]="Notification",w[w.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(a){this.callback=a}report(a){this._value=a,this.callback(this._value)}}e.Progress=R;class p{get value(){return this._value}constructor(a){this.callback=a}report(a){this._asyncQueue?this._asyncQueue.push(a):this._asyncQueue=[a],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const a=this._asyncQueue.shift();this._value=a,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const a=this._drainListener;this._drainListener=void 0,a?.()}}drain(){return this._processingAsyncQueue?new Promise(a=>{const y=this._drainListener;this._drainListener=()=>{y?.(),a()}}):Promise.resolve()}}e.AsyncProgress=p;let o=class extends P.Disposable{constructor(a,y){super(),this.deferred=new S.DeferredPromise,y.withProgress(a,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,P.toDisposable)(()=>this.deferred.complete()))}report(a){this.reporter?this.reporter.report(a):this.lastStep=a}};e.UnmanagedProgress=o,e.UnmanagedProgress=o=Ge([Ve(1,e.IProgressService)],o);class I extends P.Disposable{constructor(a){super(),this.progressIndicator=a,this.currentOperationId=0,this.currentOperationDisposables=this._register(new P.DisposableStore)}start(a){this.stop();const y=++this.currentOperationId,h=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{y===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},a),this.currentOperationDisposables.add((0,P.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,P.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,P.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:y,token:h.token,stop:()=>this.doStop(y),isCurrent:()=>this.currentOperationId===y}}stop(){this.doStop(this.currentOperationId)}doStop(a){this.currentOperationId===a&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,O.createDecorator)("editorProgressService")}),define(Le[30],Ne([1,0,61,14]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,S=We(S),k=We(k);class P{constructor(){this.data=new Map}add(A,R){S.ok(k.isString(A)),S.ok(k.isObject(R)),S.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new P}),define(Le[77],Ne([1,0,6,137,30]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,P=We(P),e.Extensions={JSONContribution:"base.contributions.json"};function O(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class A{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(o,I){this.schemasById[O(o)]=I,this._onDidChangeSchema.fire(o)}notifySchemaChanged(o){this._onDidChangeSchema.fire(o)}getSchemaContributions(){return{schemas:this.schemasById}}getSchemaContent(o){const I=this.schemasById[o];return I?(0,k.getCompressedContent)(I):void 0}hasSchemaContent(o){return!!this.schemasById[o]}}const R=new A;P.Registry.add(e.Extensions.JSONContribution,R)}),define(Le[53],Ne([1,0,17,6,14,9,43,77,30]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=r,e.keyFromOverrideIdentifiers=s,e.getDefaultValue=l,e.validateProperty=i,e.getScopes=n,e.getAllConfigurationProperties=t,e.parseScope=g,P=We(P),O=We(O);var o;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(o||(e.EditPresentationTypes=o={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=p.Registry.as(R.Extensions.JSONContribution);class a{constructor(){this.registeredConfigurationDefaults=[],this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(11612,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(v,m=!0){this.registerConfigurations([v],m)}registerConfigurations(v,m=!0){const d=new Set;this.doRegisterConfigurations(v,m,d),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}deregisterConfigurations(v){const m=new Set;this.doDeregisterConfigurations(v,m),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:m})}updateConfigurations({add:v,remove:m}){const d=new Set;this.doDeregisterConfigurations(m,d),this.doRegisterConfigurations(v,!1,d),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}registerDefaultConfigurations(v){const m=new Set;this.doRegisterDefaultConfigurations(v,m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:m,defaultsOverrides:!0})}doRegisterDefaultConfigurations(v,m){this.registeredConfigurationDefaults.push(...v);const d=[];for(const{overrides:C,source:_}of v)for(const E in C){m.add(E);const T=this.configurationDefaultsOverrides.get(E)??this.configurationDefaultsOverrides.set(E,{configurationDefaultOverrides:[]}).get(E),D=C[E];if(T.configurationDefaultOverrides.push({value:D,source:_}),e.OVERRIDE_PROPERTY_REGEX.test(E)){const f=this.mergeDefaultConfigurationsForOverrideIdentifier(E,D,_,T.configurationDefaultOverrideValue);if(!f)continue;T.configurationDefaultOverrideValue=f,this.updateDefaultOverrideProperty(E,f,_),d.push(...r(E))}else{const f=this.mergeDefaultConfigurationsForConfigurationProperty(E,D,_,T.configurationDefaultOverrideValue);if(!f)continue;T.configurationDefaultOverrideValue=f;const b=this.configurationProperties[E];b&&(this.updatePropertyDefaultValue(E,b),this.updateSchema(E,b))}}this.doRegisterOverrideIdentifiers(d)}deregisterDefaultConfigurations(v){const m=new Set;this.doDeregisterDefaultConfigurations(v,m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:m,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(v,m){for(const d of v){const C=this.registeredConfigurationDefaults.indexOf(d);C!==-1&&this.registeredConfigurationDefaults.splice(C,1)}for(const{overrides:d,source:C}of v)for(const _ in d){const E=this.configurationDefaultsOverrides.get(_);if(!E)continue;const T=E.configurationDefaultOverrides.findIndex(D=>C?D.source?.id===C.id:D.value===d[_]);if(T!==-1){if(E.configurationDefaultOverrides.splice(T,1),E.configurationDefaultOverrides.length===0&&this.configurationDefaultsOverrides.delete(_),e.OVERRIDE_PROPERTY_REGEX.test(_)){let D;for(const f of E.configurationDefaultOverrides)D=this.mergeDefaultConfigurationsForOverrideIdentifier(_,f.value,f.source,D);D&&!P.isEmptyObject(D.value)?(E.configurationDefaultOverrideValue=D,this.updateDefaultOverrideProperty(_,D,C)):(this.configurationDefaultsOverrides.delete(_),delete this.configurationProperties[_],delete this.defaultLanguageConfigurationOverridesNode.properties[_])}else{let D;for(const b of E.configurationDefaultOverrides)D=this.mergeDefaultConfigurationsForConfigurationProperty(_,b.value,b.source,D);E.configurationDefaultOverrideValue=D;const f=this.configurationProperties[_];f&&(this.updatePropertyDefaultValue(_,f),this.updateSchema(_,f))}m.add(_)}}this.updateOverridePropertyPatternKey()}updateDefaultOverrideProperty(v,m,d){const C={type:"object",default:m.value,description:O.localize(11613,null,(0,A.getLanguageTagSettingPlainKey)(v)),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m.value,source:d,defaultValueSource:d};this.configurationProperties[v]=C,this.defaultLanguageConfigurationOverridesNode.properties[v]=C}mergeDefaultConfigurationsForOverrideIdentifier(v,m,d,C){const _=C?.value||{},E=C?.source??new Map;if(!(E instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const T of Object.keys(m)){const D=m[T];if(P.isObject(D)&&(P.isUndefined(_[T])||P.isObject(_[T]))){if(_[T]={..._[T]??{},...D},d)for(const b in D)E.set(`${T}.${b}`,d)}else _[T]=D,d?E.set(T,d):E.delete(T)}return{value:_,source:E}}mergeDefaultConfigurationsForConfigurationProperty(v,m,d,C){const _=this.configurationProperties[v],E=C?.value??_?.defaultDefaultValue;let T=d;if(P.isObject(m)&&(_!==void 0&&_.type==="object"||_===void 0&&(P.isUndefined(E)||P.isObject(E)))){if(T=C?.source??new Map,!(T instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const f in m)d&&T.set(`${v}.${f}`,d);m={...P.isObject(E)?E:{},...m}}return{value:m,source:T}}deltaConfiguration(v){let m=!1;const d=new Set;v.removedDefaults&&(this.doDeregisterDefaultConfigurations(v.removedDefaults,d),m=!0),v.addedDefaults&&(this.doRegisterDefaultConfigurations(v.addedDefaults,d),m=!0),v.removedConfigurations&&this.doDeregisterConfigurations(v.removedConfigurations,d),v.addedConfigurations&&this.doRegisterConfigurations(v.addedConfigurations,!1,d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:m})}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){this.doRegisterOverrideIdentifiers(v),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(v){for(const m of v)this.overrideIdentifiers.add(m);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(v,m,d){v.forEach(C=>{this.validateAndRegisterProperties(C,m,C.extensionInfo,C.restrictedProperties,void 0,d),this.configurationContributors.push(C),this.registerJSONConfiguration(C)})}doDeregisterConfigurations(v,m){const d=C=>{if(C.properties)for(const _ in C.properties){m.add(_);const E=this.configurationProperties[_];E?.policy?.name&&this.policyConfigurations.delete(E.policy.name),delete this.configurationProperties[_],this.removeFromSchema(_,C.properties[_])}C.allOf?.forEach(_=>d(_))};for(const C of v){d(C);const _=this.configurationContributors.indexOf(C);_!==-1&&this.configurationContributors.splice(_,1)}}validateAndRegisterProperties(v,m=!0,d,C,_=I.WINDOW,E){_=P.isUndefinedOrNull(v.scope)?_:v.scope;const T=v.properties;if(T)for(const f in T){const b=T[f];if(m&&i(f,b)){delete T[f];continue}if(b.source=d,b.defaultDefaultValue=T[f].default,this.updatePropertyDefaultValue(f,b),e.OVERRIDE_PROPERTY_REGEX.test(f)?b.scope=void 0:(b.scope=P.isUndefinedOrNull(b.scope)?_:b.scope,b.restricted=P.isUndefinedOrNull(b.restricted)?!!C?.includes(f):b.restricted),T[f].hasOwnProperty("included")&&!T[f].included){this.excludedConfigurationProperties[f]=T[f],delete T[f];continue}else this.configurationProperties[f]=T[f],T[f].policy?.name&&this.policyConfigurations.set(T[f].policy.name,f);!T[f].deprecationMessage&&T[f].markdownDeprecationMessage&&(T[f].deprecationMessage=T[f].markdownDeprecationMessage),E.add(f)}const D=v.allOf;if(D)for(const f of D)this.validateAndRegisterProperties(f,m,d,C,_,E)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getRegisteredDefaultConfigurations(){return[...this.registeredConfigurationDefaults]}getConfigurationDefaultsOverrides(){const v=new Map;for(const[m,d]of this.configurationDefaultsOverrides)d.configurationDefaultOverrideValue&&v.set(m,d.configurationDefaultOverrideValue);return v}registerJSONConfiguration(v){const m=d=>{const C=d.properties;if(C)for(const E in C)this.updateSchema(E,C[E]);d.allOf?.forEach(m)};m(v)}updateSchema(v,m){switch(e.allSettings.properties[v]=m,m.scope){case I.APPLICATION:e.applicationSettings.properties[v]=m;break;case I.MACHINE:e.machineSettings.properties[v]=m;break;case I.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[v]=m;break;case I.WINDOW:e.windowSettings.properties[v]=m;break;case I.RESOURCE:e.resourceSettings.properties[v]=m;break;case I.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[v]=m,this.resourceLanguageSettingsSchema.properties[v]=m;break}}removeFromSchema(v,m){switch(delete e.allSettings.properties[v],m.scope){case I.APPLICATION:delete e.applicationSettings.properties[v];break;case I.MACHINE:delete e.machineSettings.properties[v];break;case I.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[v];break;case I.WINDOW:delete e.windowSettings.properties[v];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[v],delete this.resourceLanguageSettingsSchema.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const m=`[${v}]`,d={type:"object",description:O.localize(11614,null),errorMessage:O.localize(11615,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(m,d),e.allSettings.properties[m]=d,e.applicationSettings.properties[m]=d,e.machineSettings.properties[m]=d,e.machineOverridableSettings.properties[m]=d,e.windowSettings.properties[m]=d,e.resourceSettings.properties[m]=d}}registerOverridePropertyPatternKey(){const v={type:"object",description:O.localize(11616,null),errorMessage:O.localize(11617,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=v,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=v,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=v,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=v,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=v,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=v,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,m){const d=this.configurationDefaultsOverrides.get(v)?.configurationDefaultOverrideValue;let C,_;d&&(!m.disallowConfigurationDefault||!d.source)&&(C=d.value,_=d.source),P.isUndefined(C)&&(C=m.defaultDefaultValue,_=void 0),P.isUndefined(C)&&(C=l(m.type)),m.default=C,m.defaultValueSource=_}}const y="\\[([^\\]]+)\\]",h=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function r(u){const v=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let m=h.exec(u);for(;m?.length;){const d=m[1].trim();d&&v.push(d),m=h.exec(u)}}return(0,S.distinct)(v)}function s(u){return u.reduce((v,m)=>`${v}[${m}]`,"")}function l(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const c=new a;p.Registry.add(e.Extensions.Configuration,c);function i(u,v){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?O.localize(11619,null,u):c.getConfigurationProperties()[u]!==void 0?O.localize(11620,null,u):v.policy?.name&&c.getPolicyConfigurations().get(v.policy?.name)!==void 0?O.localize(11621,null,u,v.policy?.name,c.getPolicyConfigurations().get(v.policy?.name)):null:O.localize(11618,null)}function n(){const u=[],v=c.getConfigurationProperties();for(const m of Object.keys(v))u.push([m,v[m].scope]);return u.push(["launch",I.RESOURCE]),u.push(["task",I.RESOURCE]),u}function t(u){const v={};for(const m of u){const d=m.properties;if(P.isObject(d))for(const C in d)v[C]=d[C];m.allOf&&Object.assign(v,t(m.allOf))}return v}function g(u){switch(u){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Le[174],Ne([1,0,17,6,136,4,28,25,14,2,43,53,29,30]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=n,S=We(S),P=We(P),R=We(R),p=We(p);function h(v){return Object.isFrozen(v)?v:R.deepFreeze(v)}class r{static createEmptyModel(m){return new r({},[],[],void 0,m)}constructor(m,d,C,_,E){this._contents=m,this._keys=d,this._overrides=C,this.raw=_,this.logService=E,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const m=this.raw.map(d=>{if(d instanceof r)return d;const C=new s("",this.logService);return C.parseRaw(d),C.configurationModel});this._rawConfiguration=m.reduce((d,C)=>C===d?C:d.merge(C),m[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(m){return m?(0,I.getConfigurationValue)(this.contents,m):this.contents}inspect(m,d){const C=this;return{get value(){return h(C.rawConfiguration.getValue(m))},get override(){return d?h(C.rawConfiguration.getOverrideValue(m,d)):void 0},get merged(){return h(d?C.rawConfiguration.override(d).getValue(m):C.rawConfiguration.getValue(m))},get overrides(){const _=[];for(const{contents:E,identifiers:T,keys:D}of C.rawConfiguration.overrides){const f=new r(E,D,[],void 0,C.logService).getValue(m);f!==void 0&&_.push({identifiers:T,value:f})}return _.length?h(_):void 0}}}getOverrideValue(m,d){const C=this.getContentsForOverrideIdentifer(d);return C?m?(0,I.getConfigurationValue)(C,m):C:void 0}getKeysForOverrideIdentifier(m){const d=[];for(const C of this.overrides)C.identifiers.includes(m)&&d.push(...C.keys);return S.distinct(d)}getAllOverrideIdentifiers(){const m=[];for(const d of this.overrides)m.push(...d.identifiers);return S.distinct(m)}override(m){let d=this.overrideConfigurations.get(m);return d||(d=this.createOverrideConfigurationModel(m),this.overrideConfigurations.set(m,d)),d}merge(...m){const d=R.deepClone(this.contents),C=R.deepClone(this.overrides),_=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const T of m)if(E.push(...T.raw?.length?T.raw:[T]),!T.isEmpty()){this.mergeContents(d,T.contents);for(const D of T.overrides){const[f]=C.filter(b=>S.equals(b.identifiers,D.identifiers));f?(this.mergeContents(f.contents,D.contents),f.keys.push(...D.keys),f.keys=S.distinct(f.keys)):C.push(R.deepClone(D))}for(const D of T.keys)_.indexOf(D)===-1&&_.push(D)}return new r(d,_,C,E.every(T=>T instanceof r)?void 0:E,this.logService)}createOverrideConfigurationModel(m){const d=this.getContentsForOverrideIdentifer(m);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const C={};for(const _ of S.distinct([...Object.keys(this.contents),...Object.keys(d)])){let E=this.contents[_];const T=d[_];T&&(typeof E=="object"&&typeof T=="object"?(E=R.deepClone(E),this.mergeContents(E,T)):E=T),C[_]=E}return new r(C,this.keys,this.overrides,void 0,this.logService)}mergeContents(m,d){for(const C of Object.keys(d)){if(C in m&&p.isObject(m[C])&&p.isObject(d[C])){this.mergeContents(m[C],d[C]);continue}m[C]=R.deepClone(d[C])}}getContentsForOverrideIdentifer(m){let d=null,C=null;const _=E=>{E&&(C?this.mergeContents(C,E):C=R.deepClone(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===m?d=E.contents:E.identifiers.includes(m)&&_(E.contents);return _(d),C}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(m,d){this.updateValue(m,d,!0)}setValue(m,d){this.updateValue(m,d,!1)}removeValue(m){const d=this.keys.indexOf(m);d!==-1&&(this.keys.splice(d,1),(0,I.removeFromValueTree)(this.contents,m),w.OVERRIDE_PROPERTY_REGEX.test(m)&&this.overrides.splice(this.overrides.findIndex(C=>S.equals(C.identifiers,(0,w.overrideIdentifiersFromKey)(m))),1))}updateValue(m,d,C){if((0,I.addToValueTree)(this.contents,m,d,_=>this.logService.error(_)),C=C||this.keys.indexOf(m)===-1,C&&this.keys.push(m),w.OVERRIDE_PROPERTY_REGEX.test(m)){const _=(0,w.overrideIdentifiersFromKey)(m),E={identifiers:_,keys:Object.keys(this.contents[m]),contents:(0,I.toValuesTree)(this.contents[m],D=>this.logService.error(D))},T=this.overrides.findIndex(D=>S.equals(D.identifiers,_));T!==-1?this.overrides[T]=E:this.overrides.push(E)}}}e.ConfigurationModel=r;class s{constructor(m,d){this._name=m,this.logService=d,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||r.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(m,d){if(!p.isUndefinedOrNull(m)){const C=this.doParseContent(m);this.parseRaw(C,d)}}reparse(m){this._raw&&this.parseRaw(this._raw,m)}parseRaw(m,d){this._raw=m;const{contents:C,keys:_,overrides:E,restricted:T,hasExcludedProperties:D}=this.doParseRaw(m,d);this._configurationModel=new r(C,_,E,D?[m]:void 0,this.logService),this._restrictedConfigurations=T||[]}doParseContent(m){let d={},C=null,_=[];const E=[],T=[];function D(b){Array.isArray(_)?_.push(b):C!==null&&(_[C]=b)}const f={onObjectBegin:()=>{const b={};D(b),E.push(_),_=b,C=null},onObjectProperty:b=>{C=b},onObjectEnd:()=>{_=E.pop()},onArrayBegin:()=>{const b=[];D(b),E.push(_),_=b,C=null},onArrayEnd:()=>{_=E.pop()},onLiteralValue:D,onError:(b,M,L)=>{T.push({error:b,offset:M,length:L})}};if(m)try{P.visit(m,f),d=_[0]||{}}catch(b){this.logService.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return d}doParseRaw(m,d){const C=y.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),_=this.filter(m,C,!0,d);m=_.raw;const E=(0,I.toValuesTree)(m,f=>this.logService.error(`Conflict in settings file ${this._name}: ${f}`)),T=Object.keys(m),D=this.toOverrides(m,f=>this.logService.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:E,keys:T,overrides:D,restricted:_.restricted,hasExcludedProperties:_.hasExcludedProperties}}filter(m,d,C,_){let E=!1;if(!_?.scopes&&!_?.skipRestricted&&!_?.exclude?.length)return{raw:m,restricted:[],hasExcludedProperties:E};const T={},D=[];for(const f in m)if(w.OVERRIDE_PROPERTY_REGEX.test(f)&&C){const b=this.filter(m[f],d,!1,_);T[f]=b.raw,E=E||b.hasExcludedProperties,D.push(...b.restricted)}else{const b=d[f],M=b?typeof b.scope<"u"?b.scope:w.ConfigurationScope.WINDOW:void 0;b?.restricted&&D.push(f),!_.exclude?.includes(f)&&(_.include?.includes(f)||(M===void 0||_.scopes===void 0||_.scopes.includes(M))&&!(_.skipRestricted&&b?.restricted))?T[f]=m[f]:E=!0}return{raw:T,restricted:D,hasExcludedProperties:E}}toOverrides(m,d){const C=[];for(const _ of Object.keys(m))if(w.OVERRIDE_PROPERTY_REGEX.test(_)){const E={};for(const T in m[_])E[T]=m[_][T];C.push({identifiers:(0,w.overrideIdentifiersFromKey)(_),keys:Object.keys(E),contents:(0,I.toValuesTree)(E,d)})}return C}}e.ConfigurationModelParser=s;class l extends O.Disposable{constructor(m,d,C,_,E){super(),this.userSettingsResource=m,this.parseOptions=d,this.fileService=_,this.logService=E,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString(),E),this._register(this.fileService.watch(C.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.any(k.Event.filter(this.fileService.onDidFilesChange,T=>T.contains(this.userSettingsResource)),k.Event.filter(this.fileService.onDidRunOperation,T=>(T.isOperation(a.FileOperation.CREATE)||T.isOperation(a.FileOperation.COPY)||T.isOperation(a.FileOperation.DELETE)||T.isOperation(a.FileOperation.WRITE))&&C.isEqual(T.resource,m)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const m=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(m.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return r.createEmptyModel(this.logService)}}reparse(m){return m&&(this.parseOptions=m),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=l;class c{constructor(m,d,C,_,E,T,D,f,b,M,L,N,W){this.key=m,this.overrides=d,this._value=C,this.overrideIdentifiers=_,this.defaultConfiguration=E,this.policyConfiguration=T,this.applicationConfiguration=D,this.userConfiguration=f,this.localUserConfiguration=b,this.remoteUserConfiguration=M,this.workspaceConfiguration=L,this.folderConfigurationModel=N,this.memoryConfigurationModel=W}get value(){return h(this._value)}toInspectValue(m){return m?.value!==void 0||m?.override!==void 0||m?.overrides!==void 0?m:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class i{constructor(m,d,C,_,E,T,D,f,b,M){this._defaultConfiguration=m,this._policyConfiguration=d,this._applicationConfiguration=C,this._localUserConfiguration=_,this._remoteUserConfiguration=E,this._workspaceConfiguration=T,this._folderConfigurations=D,this._memoryConfiguration=f,this._memoryConfigurationByResource=b,this.logService=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(m,d,C){return this.getConsolidatedConfigurationModel(m,d,C).getValue(m)}updateValue(m,d,C={}){let _;C.resource?(_=this._memoryConfigurationByResource.get(C.resource),_||(_=r.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(C.resource,_))):_=this._memoryConfiguration,d===void 0?_.removeValue(m):_.setValue(m,d),C.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(m,d,C){const _=this.getConsolidatedConfigurationModel(m,d,C),E=this.getFolderConfigurationModelForResource(d.resource,C),T=d.resource?this._memoryConfigurationByResource.get(d.resource)||this._memoryConfiguration:this._memoryConfiguration,D=new Set;for(const f of _.overrides)for(const b of f.identifiers)_.getOverrideValue(m,b)!==void 0&&D.add(b);return new c(m,d,_.getValue(m),D.size?[...D]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,C?this._workspaceConfiguration:void 0,E||void 0,T)}keys(m){const d=this.getFolderConfigurationModelForResource(void 0,m);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(m){this._defaultConfiguration=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(m){this._policyConfiguration=m}updateApplicationConfiguration(m){this._applicationConfiguration=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(m){this._localUserConfiguration=m,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(m){this._remoteUserConfiguration=m,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(m){this._workspaceConfiguration=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(m,d){this._folderConfigurations.set(m,d),this._foldersConsolidatedConfigurations.delete(m)}deleteFolderConfiguration(m){this.folderConfigurations.delete(m),this._foldersConsolidatedConfigurations.delete(m)}compareAndUpdateDefaultConfiguration(m,d){const C=[];if(!d){const{added:_,updated:E,removed:T}=g(this._defaultConfiguration,m);d=[..._,...E,...T]}for(const _ of d)for(const E of(0,w.overrideIdentifiersFromKey)(_)){const T=this._defaultConfiguration.getKeysForOverrideIdentifier(E),D=m.getKeysForOverrideIdentifier(E),f=[...D.filter(b=>T.indexOf(b)===-1),...T.filter(b=>D.indexOf(b)===-1),...T.filter(b=>!R.equals(this._defaultConfiguration.override(E).getValue(b),m.override(E).getValue(b)))];C.push([E,f])}return this.updateDefaultConfiguration(m),{keys:d,overrides:C}}compareAndUpdatePolicyConfiguration(m){const{added:d,updated:C,removed:_}=g(this._policyConfiguration,m),E=[...d,...C,..._];return E.length&&this.updatePolicyConfiguration(m),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(m){const{added:d,updated:C,removed:_,overrides:E}=g(this.applicationConfiguration,m),T=[...d,...C,..._];return T.length&&this.updateApplicationConfiguration(m),{keys:T,overrides:E}}compareAndUpdateLocalUserConfiguration(m){const{added:d,updated:C,removed:_,overrides:E}=g(this.localUserConfiguration,m),T=[...d,...C,..._];return T.length&&this.updateLocalUserConfiguration(m),{keys:T,overrides:E}}compareAndUpdateRemoteUserConfiguration(m){const{added:d,updated:C,removed:_,overrides:E}=g(this.remoteUserConfiguration,m),T=[...d,...C,..._];return T.length&&this.updateRemoteUserConfiguration(m),{keys:T,overrides:E}}compareAndUpdateWorkspaceConfiguration(m){const{added:d,updated:C,removed:_,overrides:E}=g(this.workspaceConfiguration,m),T=[...d,...C,..._];return T.length&&this.updateWorkspaceConfiguration(m),{keys:T,overrides:E}}compareAndUpdateFolderConfiguration(m,d){const C=this.folderConfigurations.get(m),{added:_,updated:E,removed:T,overrides:D}=g(C,d),f=[..._,...E,...T];return(f.length||!C)&&this.updateFolderConfiguration(m,d),{keys:f,overrides:D}}compareAndDeleteFolderConfiguration(m){const d=this.folderConfigurations.get(m);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(m);const{added:C,updated:_,removed:E,overrides:T}=g(d,void 0);return{keys:[...C,..._,...E],overrides:T}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(m,d,C){let _=this.getConsolidatedConfigurationModelForResource(d,C);return d.overrideIdentifier&&(_=_.override(d.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(m)!==void 0&&(_=_.merge(this._policyConfiguration)),_}getConsolidatedConfigurationModelForResource({resource:m},d){let C=this.getWorkspaceConsolidatedConfiguration();if(d&&m){const _=d.getFolder(m);_&&(C=this.getFolderConsolidatedConfiguration(_.uri)||C);const E=this._memoryConfigurationByResource.get(m);E&&(C=C.merge(E))}return C}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(m){let d=this._foldersConsolidatedConfigurations.get(m);if(!d){const C=this.getWorkspaceConsolidatedConfiguration(),_=this._folderConfigurations.get(m);_?(d=C.merge(_),this._foldersConsolidatedConfigurations.set(m,d)):d=C}return d}getFolderConfigurationModelForResource(m,d){if(d&&m){const C=d.getFolder(m);if(C)return this._folderConfigurations.get(C.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((m,d)=>{const{contents:C,overrides:_,keys:E}=this._folderConfigurations.get(d);return m.push([d,{contents:C,overrides:_,keys:E}]),m},[])}}allKeys(){const m=new Set;return this._defaultConfiguration.keys.forEach(d=>m.add(d)),this.userConfiguration.keys.forEach(d=>m.add(d)),this._workspaceConfiguration.keys.forEach(d=>m.add(d)),this._folderConfigurations.forEach(d=>d.keys.forEach(C=>m.add(C))),[...m.values()]}allOverrideIdentifiers(){const m=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(d=>m.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>m.add(d)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(d=>m.add(d)),this._folderConfigurations.forEach(d=>d.getAllOverrideIdentifiers().forEach(C=>m.add(C))),[...m.values()]}getAllKeysForOverrideIdentifier(m){const d=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(m).forEach(C=>d.add(C)),this.userConfiguration.getKeysForOverrideIdentifier(m).forEach(C=>d.add(C)),this._workspaceConfiguration.getKeysForOverrideIdentifier(m).forEach(C=>d.add(C)),this._folderConfigurations.forEach(C=>C.getKeysForOverrideIdentifier(m).forEach(_=>d.add(_))),[...d.values()]}static parse(m,d){const C=this.parseConfigurationModel(m.defaults,d),_=this.parseConfigurationModel(m.policy,d),E=this.parseConfigurationModel(m.application,d),T=this.parseConfigurationModel(m.user,d),D=this.parseConfigurationModel(m.workspace,d),f=m.folders.reduce((b,M)=>(b.set(o.URI.revive(M[0]),this.parseConfigurationModel(M[1],d)),b),new A.ResourceMap);return new i(C,_,E,T,r.createEmptyModel(d),D,f,r.createEmptyModel(d),new A.ResourceMap,d)}static parseConfigurationModel(m,d){return new r(m.contents,m.keys,m.overrides,void 0,d)}}e.Configuration=i;function n(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const m=new Set,d=new Map;for(const _ of v)_.keys.forEach(E=>m.add(E)),_.overrides.forEach(([E,T])=>{const D=(0,A.getOrSet)(d,E,new Set);T.forEach(f=>D.add(f))});const C=[];return d.forEach((_,E)=>C.push([E,[..._.values()]])),{keys:[...m.values()],overrides:C}}class t{constructor(m,d,C,_,E){this.change=m,this.previous=d,this.currentConfiguraiton=C,this.currentWorkspace=_,this.logService=E,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const T of m.keys)this.affectedKeys.add(T);for(const[,T]of m.overrides)for(const D of T)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const T of this.affectedKeys)this._affectsConfigStr+=T+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=i.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(m,d){const C=this._marker+m,_=this._affectsConfigStr.indexOf(C);if(_<0)return!1;const E=_+C.length;if(E>=this._affectsConfigStr.length)return!1;const T=this._affectsConfigStr.charCodeAt(E);if(T!==this._markerCode1&&T!==this._markerCode2)return!1;if(d){const D=this.previousConfiguration?this.previousConfiguration.getValue(m,d,this.previous?.workspace):void 0,f=this.currentConfiguraiton.getValue(m,d,this.currentWorkspace);return!R.equals(D,f)}return!0}}e.ConfigurationChangeEvent=t;function g(v,m){const{added:d,removed:C,updated:_}=u(m?.rawConfiguration,v?.rawConfiguration),E=[],T=v?.getAllOverrideIdentifiers()||[],D=m?.getAllOverrideIdentifiers()||[];if(m){const f=D.filter(b=>!T.includes(b));for(const b of f)E.push([b,m.getKeysForOverrideIdentifier(b)])}if(v){const f=T.filter(b=>!D.includes(b));for(const b of f)E.push([b,v.getKeysForOverrideIdentifier(b)])}if(m&&v){for(const f of T)if(D.includes(f)){const b=u({contents:v.getOverrideValue(void 0,f)||{},keys:v.getKeysForOverrideIdentifier(f)},{contents:m.getOverrideValue(void 0,f)||{},keys:m.getKeysForOverrideIdentifier(f)});E.push([f,[...b.added,...b.removed,...b.updated]])}}return{added:d,removed:C,updated:_,overrides:E}}function u(v,m){const d=v?m?v.keys.filter(E=>m.keys.indexOf(E)===-1):[...v.keys]:[],C=m?v?m.keys.filter(E=>v.keys.indexOf(E)===-1):[...m.keys]:[],_=[];if(v&&m){for(const E of m.keys)if(v.keys.indexOf(E)!==-1){const T=(0,I.getConfigurationValue)(m.contents,E),D=(0,I.getConfigurationValue)(v.contents,E);R.equals(T,D)||_.push(E)}}return{added:d,removed:C,updated:_}}}),define(Le[109],Ne([1,0,13,3]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=o,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(w){this.id=w,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class A{constructor(w,a){this.host=w,this.port=a,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var R;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class p extends S.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof p&&w._code===R.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof p&&w._code===R.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof p&&w._code===R.NoResolverFound}static isInvalidAuthority(w){return w instanceof p&&w._code===R.InvalidAuthority}static isHandled(w){return w instanceof p&&w.isHandled}constructor(w,a=R.Unknown,y){super(w),this._message=w,this._code=a,this._detail=y,this.isHandled=a===R.NotAvailable&&y===!0,Object.setPrototypeOf(this,p.prototype)}}e.RemoteAuthorityResolverError=p;function o(I){const w=I.indexOf("+");return w===-1?I:I.substring(0,w)}}),define(Le[62],Ne([1,0,15]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=k,e.getRemoteName=P,e.parseAuthorityWithPort=O,e.parseAuthorityWithOptionalPort=A;function k(p){return p.scheme===S.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const o=p.indexOf("+");return o<0?p:p.substr(0,o)}function O(p){const{host:o,port:I}=R(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:o,port:I}}function A(p,o){let{host:I,port:w}=R(p);return typeof w>"u"&&(w=o),{host:I,port:w}}function R(p){const o=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(o)return{host:o[1],port:parseInt(o[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const w=p.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:p,port:void 0}}}),define(Le[18],Ne([1,0,12,3,62]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=O,e.isApplicationScopedExtension=w,e.isLanguagePackExtension=a,e.isAuthenticationProviderExtension=y,e.isResolverExtension=h,e.parseApiProposals=r,e.parseEnabledApiProposalNames=s,S=We(S),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(A||(e.ExtensionType=A={}));var R;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.LINUX_PPC64LE="linux-ppc64le",l.LINUX_RISCV64="linux-riscv64",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class p{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,i){if(typeof c>"u"||c===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof c=="string"||typeof i=="string"){const n=typeof c=="string"?c:c.value,t=typeof i=="string"?i:i.value;return S.equalsIgnoreCase(n,t)}return c._lower===i._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.ExtensionIdentifier=p;class o{get size(){return this._set.size}constructor(c){if(this._set=new Set,c)for(const i of c)this.add(i)}add(c){this._set.add(p.toKey(c))}delete(c){return this._set.delete(p.toKey(c))}has(c){return this._set.has(p.toKey(c))}}e.ExtensionIdentifierSet=o;class I{constructor(){this._map=new Map}clear(){this._map.clear()}delete(c){this._map.delete(p.toKey(c))}get(c){return this._map.get(p.toKey(c))}has(c){return this._map.has(p.toKey(c))}set(c,i){this._map.set(p.toKey(c),i)}values(){return this._map.values()}forEach(c){this._map.forEach(c)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=I;function w(l){return a(l)}function a(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}function y(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}function h(l,c){if(c){const i=`onResolveRemoteAuthority:${(0,P.getRemoteName)(c)}`;return!!l.activationEvents?.includes(i)}return!1}function r(l){return l.map(c=>{const[i,n]=c.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function s(l){return l.map(c=>c.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Le[110],Ne([1,0,20,9,18,3]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=R,e.toTargetPlatform=p,e.getTargetPlatform=o,e.isNotWebExtensionInWebTargetPlatform=I,e.isTargetPlatformCompatible=w,e.isIExtensionIdentifier=a,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function R(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case P.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.LINUX_PPC64LE:return P.TargetPlatform.LINUX_PPC64LE;case P.TargetPlatform.LINUX_RISCV64:return P.TargetPlatform.LINUX_RISCV64;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function o(t,g){switch(t){case S.Platform.Windows:return g==="x64"?P.TargetPlatform.WIN32_X64:g==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case S.Platform.Linux:return g==="x64"?P.TargetPlatform.LINUX_X64:g==="arm64"?P.TargetPlatform.LINUX_ARM64:g==="arm"?P.TargetPlatform.LINUX_ARMHF:g==="ppc64le"?P.TargetPlatform.LINUX_PPC64LE:g==="riscv64"?P.TargetPlatform.LINUX_RISCV64:P.TargetPlatform.UNKNOWN;case"alpine":return g==="x64"?P.TargetPlatform.ALPINE_X64:g==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case S.Platform.Mac:return g==="x64"?P.TargetPlatform.DARWIN_X64:g==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case S.Platform.Web:return P.TargetPlatform.WEB}}function I(t,g){return g===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function w(t,g,u){return I(g,u)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===u}function a(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var y;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var h;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var s;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(s||(e.InstallOperation=s={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var l;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(l||(e.ExtensionGalleryErrorCode=l={}));class c extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.ExtensionGalleryError=c;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,k.localize2)(11502,"Extensions"),e.PreferencesLocalizedLabel=(0,k.localize2)(11503,"Preferences")}),define(Le[111],Ne([1,0,13,18]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class P{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,R){this._generators.set(A,R)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const R=Object.create(null);for(const p of A){const o=this.readActivationEvents(p);o.length>0&&(R[k.ExtensionIdentifier.toKey(p.identifier)]=o)}return R}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const R=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<R.length;p++)R[p]==="onUri"&&(R[p]=`onUri:${k.ExtensionIdentifier.toKey(A.identifier)}`);if(!A.contributes)return R;for(const p in A.contributes){const o=this._generators.get(p);if(!o)continue;const I=A.contributes[p],w=Array.isArray(I)?I:[I];try{o(w,R)}catch(a){(0,S.onUnexpectedError)(a)}}return R}}e.ImplicitActivationEventsImpl=P,e.ImplicitActivationEvents=new P});var Jt=this&&this.__importDefault||function(Se){return Se&&Se.__esModule?Se:{default:Se}};define(Le[175],Ne([1,0,23,35,9,281,18,104]),function(Se,e,S,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=I,e.parseVersion=w,e.normalizeVersion=a,e.isValidVersion=y,e.validateExtensionManifest=h,e.isValidExtensionVersion=r,e.isEngineValid=s,e.areApiProposalsCompatible=l,k=Jt(k),P=We(P),O=We(O);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,o=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||p.test(n)}function w(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function a(n){if(!n)return null;const t=n.majorBase,g=n.majorMustEqual,u=n.minorBase;let v=n.minorMustEqual;const m=n.patchBase;let d=n.patchMustEqual;n.hasCaret&&(t===0||(v=!1),d=!1);let C=0;if(n.preRelease){const _=o.exec(n.preRelease);if(_){const[,E,T,D]=_;C=Date.UTC(Number(E),Number(T)-1,Number(D))}}return{majorBase:t,majorMustEqual:g,minorBase:u,minorMustEqual:v,patchBase:m,patchMustEqual:d,isMinimum:n.hasGreaterEquals,notBefore:C}}function y(n,t,g){let u;typeof n=="string"?u=a(w(n)):u=n;let v;t instanceof Date?v=t.getTime():typeof t=="string"&&(v=new Date(t).getTime());let m;if(typeof g=="string"?m=a(w(g)):m=g,!u||!m)return!1;const d=u.majorBase,C=u.minorBase,_=u.patchBase;let E=m.majorBase,T=m.minorBase,D=m.patchBase;const f=m.notBefore;let b=m.majorMustEqual,M=m.minorMustEqual,L=m.patchMustEqual;return m.isMinimum?d>E?!0:d<E?!1:C>T?!0:C<T||v&&v<f?!1:_>=D:(d===1&&E===0&&(!b||!M||!L)&&(E=1,T=0,D=0,b=!0,M=!1,L=!1),d<E?!1:d>E?!b:C<T?!1:C>T?!M:_<D?!1:_>D?!L:!(v&&v<f))}function h(n,t,g,u,v,m){const d=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return d.push([k.default.Error,P.localize(11433,null)]),d;if(typeof u.name!="string")return d.push([k.default.Error,P.localize(11434,null,"name")]),d;if(typeof u.version!="string")return d.push([k.default.Error,P.localize(11435,null,"version")]),d;if(!u.engines)return d.push([k.default.Error,P.localize(11436,null,"engines")]),d;if(typeof u.engines.vscode!="string")return d.push([k.default.Error,P.localize(11437,null,"engines.vscode")]),d;if(typeof u.extensionDependencies<"u"&&!i(u.extensionDependencies))return d.push([k.default.Error,P.localize(11438,null,"extensionDependencies")]),d;if(typeof u.activationEvents<"u"){if(!i(u.activationEvents))return d.push([k.default.Error,P.localize(11439,null,"activationEvents")]),d;if(typeof u.main>"u"&&typeof u.browser>"u")return d.push([k.default.Error,P.localize(11440,null,"activationEvents","main","browser")]),d}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&d.push([k.default.Warning,P.localize(11441,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return d.push([k.default.Error,P.localize(11442,null,"main")]),d;{const E=(0,S.joinPath)(g,u.main);(0,S.isEqualOrParent)(E,g)||d.push([k.default.Warning,P.localize(11443,null,E.path,g.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return d.push([k.default.Error,P.localize(11444,null,"browser")]),d;{const E=(0,S.joinPath)(g,u.browser);(0,S.isEqualOrParent)(E,g)||d.push([k.default.Warning,P.localize(11445,null,E.path,g.path)])}}if(!O.valid(u.version))return d.push([k.default.Error,P.localize(11446,null)]),d;const C=[];if(!r(n,t,u,v,C))for(const E of C)d.push([k.default.Error,E]);if(m&&u.enabledApiProposals?.length){const E=[];if(!l([...u.enabledApiProposals],E))for(const T of E)d.push([k.default.Error,T])}return d}function r(n,t,g,u,v){return u||typeof g.main>"u"&&typeof g.browser>"u"?!0:c(n,t,g.engines.vscode,v)}function s(n,t,g){return n==="*"||c(t,g,n)}function l(n,t){if(n.length===0)return!0;const g=Array.isArray(t)?t:void 0,u=(g?void 0:t)??R.allApiProposals,v=[],m=(0,A.parseApiProposals)(n);for(const{proposalName:d,version:C}of m){const _=u[d];_&&C&&_.version!==C&&v.push(P.localize(11447,null,d))}return g?.push(...v),v.length===0}function c(n,t,g,u=[]){const v=a(w(g));if(!v)return u.push(P.localize(11448,null,g)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return u.push(P.localize(11449,null,g)),!1}else if(!v.majorMustEqual)return u.push(P.localize(11450,null,g)),!1;return y(n,t,v)?!0:(u.push(P.localize(11451,null,n,g)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,g=n.length;t<g;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Le[176],Ne([1,0,22,13,4,9,53,3,11,30]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=a,e.hasNoContent=y,e.asText=h,e.asTextOrError=r,e.asJson=s,e.updateProxyConfigurationsScope=l,e.IRequestService=(0,R.createDecorator)("requestService");class I{constructor(t){this.original=t}toJSON(){if(!this.headers){const t=Object.create(null);for(const g in this.original)g.toLowerCase()==="authorization"||g.toLowerCase()==="proxy-authorization"?t[g]="*****":t[g]=this.original[g];this.headers=t}return this.headers}}class w extends P.Disposable{constructor(t){super(),this.counter=0,this.logger=t.createLogger("network",{name:(0,O.localize)(11220,null),when:p.CONTEXT_LOG_LEVEL.isEqualTo((0,p.LogLevelToString)(p.LogLevel.Trace)).serialize()})}async logAndRequest(t,g,u){const v=`${t} #${++this.counter}: ${g.url}`;this.logger.trace(`${v} - begin`,g.type,new I(g.headers??{}));try{const m=await u();return this.logger.trace(`${v} - end`,g.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.logger.error(`${v} - error`,g.type,(0,k.getErrorMessage)(m)),m}}}e.AbstractRequestService=w;function a(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function y(n){return n.res.statusCode===204}async function h(n){return y(n)?null:(await(0,S.streamToBuffer)(n.stream)).toString()}async function r(n){if(!a(n))throw new Error("Server returned "+n.res.statusCode);return h(n)}async function s(n){if(!a(n))throw new Error("Server returned "+n.res.statusCode);if(y(n))return null;const g=(await(0,S.streamToBuffer)(n.stream)).toString();try{return JSON.parse(g)}catch(u){throw u.message+=`:
`+g,u}}function l(n){i(n)}let c;function i(n){const t=o.Registry.as(A.Extensions.Configuration),g=c;c={id:"http",order:15,title:(0,O.localize)(11221,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(11222,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(11223,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(11224,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(11225,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(11226,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(11227,null),(0,O.localize)(11228,null),(0,O.localize)(11229,null),(0,O.localize)(11230,null)],default:"override",description:(0,O.localize)(11231,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11232,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(11233,null),restricted:!0}}},t.updateConfigurations({add:[c],remove:g?[g]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Le[177],Ne([1,0,20,78,38]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=A,e.verifyMicrosoftInternalDomain=R;function O(p){if(S.platform===S.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,o,I,w,a,y,h,r,s,l){const c=Object.create(null);c["common.machineId"]=y,c["common.sqmId"]=h,c["common.devDeviceId"]=r,c.sessionID=(0,P.generateUuid)()+Date.now(),c.commitHash=w,c.version=a,c["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,S.PlatformToString)(S.platform),c["common.nodePlatform"]=k.platform,c["common.nodeArch"]=I,c["common.product"]=l||"desktop",s&&(c["common.msftInternal"]=s);let i=0;const n=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.isLinuxSnap&&(c["common.snap"]="true");const t=O(o);return t&&(c["common.platformDetail"]=t),c}function R(p){const o=k.env.USERDNSDOMAIN;if(!o)return!1;const I=o.toLowerCase();return p.some(w=>I===w)}}),define(Le[112],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(k||(e.TelemetryLevel=k={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Le[63],Ne([1,0,25,14,62,177,112]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=I,e.isLoggingOnly=w,e.getTelemetryLevel=a,e.validateTelemetryData=y,e.cleanRemoteAuthority=r,e.isInternalTelemetry=l,e.getPiiPathsFromEnvironment=c,e.cleanData=t;class R{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class p{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class o{async publicLog(u,v,m){}async publicLogError(u,v,m){}}e.NullEndpointTelemetryService=o,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(g,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!g.enableTelemetry)}function w(g,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}function a(g){const u=g.getValue(A.TELEMETRY_SETTING_ID),v=g.getValue(A.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(g.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return A.TelemetryLevel.NONE;switch(u??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function y(g){const u={},v={},m={};s(g,m);for(let d in m){d=d.length>150?d.substr(d.length-149):d;const C=m[d];typeof C=="number"?v[d]=C:typeof C=="boolean"?v[d]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${C.length}`),u[d]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(u[d]=C)}return{properties:u,measurements:v}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(g){if(!g)return"none";const u=(0,P.getRemoteName)(g);return h.has(u)?u:"other"}function s(g,u,v=0,m){if(g)for(const d of Object.getOwnPropertyNames(g)){const C=g[d],_=m?m+d:d;Array.isArray(C)?u[_]=(0,S.safeStringify)(C):C instanceof Date?u[_]=C.toISOString():(0,k.isObject)(C)?v<2?s(C,u,v+1,_+"."):u[_]=(0,S.safeStringify)(C):u[_]=C}}function l(g,u){const v=g.msftInternalDomains||[],m=u.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(v)||m}function c(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}function i(g,u){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let v=g;const m=[];for(const E of u)for(;;){const T=E.exec(g);if(!T)break;m.push([T.index,E.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let _=0;for(v="";;){const E=C.exec(g);if(!E)break;const T=m.some(([D,f])=>E.index<f&&D<C.lastIndex);!d.test(E[0])&&!T&&(v+=g.substring(_,E.index)+"<REDACTED: user-file-path>",_=C.lastIndex)}return _<g.length&&(v+=g.substr(_)),v}function n(g){if(!g)return g;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const v of u)if(v.regex.test(g))return`<REDACTED: ${v.label}>`;return g}function t(g,u){return(0,S.cloneAndChange)(g,v=>{if(v instanceof R||Object.hasOwnProperty.call(v,"isTrustedTelemetryValue"))return v.value;if(typeof v=="string"){let m=v.replaceAll("%20"," ");m=i(m,u);for(const d of u)m=m.replace(d,"");return m=n(m),m}})}}),define(Le[178],Ne([1,0,12,110,18,20,2,13,78,63]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=I,e.getIdAndVersion=h,e.getExtensionId=r,e.adoptToGalleryExtensionId=s,e.getGalleryExtensionId=l,e.groupByExtension=c,e.getLocalExtensionTelemetryData=i,e.getGalleryExtensionTelemetryData=n,e.getExtensionDependencies=t,e.computeTargetPlatform=u;function I(v,m){return v.uuid&&m.uuid?v.uuid===m.uuid:v.id===m.id?!0:(0,S.compareIgnoreCase)(v.id,m.id)===0}const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(m){const d=m.manifest?m.manifest.version:m.version,C=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new a(m.identifier,d,C)}static parse(m){const d=w.exec(m);return d&&d[1]&&d[2]?new a({id:d[1]},d[2],d[4]||void 0):null}constructor(m,d,C=P.TargetPlatform.UNDEFINED){this.identifier=m,this.version=d,this.targetPlatform=C,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof a?I(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.ExtensionKey=a;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(v){const m=y.exec(v);return m&&m[1]?[s(m[1]),m[2]]:[s(v),void 0]}function r(v,m){return`${v}.${m}`}function s(v){return v.toLowerCase()}function l(v,m){return s(r(v??P.UNDEFINED_PUBLISHER,m))}function c(v,m){const d=[],C=_=>{for(const E of d)if(E.some(T=>I(m(T),m(_))))return E;return null};for(const _ of v){const E=C(_);E?E.push(_):d.push([_])}return d}function i(v){return{id:v.identifier.id,name:v.manifest.name,galleryId:null,publisherId:v.publisherId,publisherName:v.manifest.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:v.manifest.extensionDependencies&&v.manifest.extensionDependencies.length>0}}function n(v){return{id:new o.TelemetryTrustedValue(v.identifier.id),name:new o.TelemetryTrustedValue(v.name),version:v.version,galleryId:v.identifier.uuid,publisherId:v.publisherId,publisherName:v.publisher,publisherDisplayName:v.publisherDisplayName,isPreReleaseVersion:v.properties.isPreReleaseVersion,dependencies:!!(v.properties.dependencies&&v.properties.dependencies.length>0),isSigned:v.isSigned,...v.telemetryData}}e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function t(v,m){const d=[],C=m.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const _=C.shift();if(_&&d.every(E=>!I(E.identifier,{id:_}))){const E=v.filter(T=>I(T.identifier,{id:_}));E.length===1&&(d.push(E[0]),C.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}async function g(v,m){if(!O.isLinux)return!1;let d;try{d=(await v.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await v.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(_){m.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(_))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(v,m){const d=await g(v,m),C=(0,k.getTargetPlatform)(d?"alpine":O.platform,p.arch);return m.debug("ComputeTargetPlatform:",C),C}}),define(Le[179],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=S,e.serializeEnvironmentDescriptionMap=k,e.deserializeEnvironmentVariableCollection=P,e.deserializeEnvironmentDescriptionMap=O,e.serializeEnvironmentVariableCollections=A,e.deserializeEnvironmentVariableCollections=R;function S(p){return[...p.entries()]}function k(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function O(p){return new Map(p??[])}function A(p){return Array.from(p.entries()).map(o=>[o[0],S(o[1].map),k(o[1].descriptionMap)])}function R(p){return new Map(p.map(o=>[o[0],{map:P(o[1]),descriptionMap:O(o[2])}]))}}),define(Le[180],Ne([1,0,3,31,30]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new k.RawContextKey("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var R;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(R||(e.PosixShellType=R={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var o;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(o||(e.TitleEventSource=o={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var w;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.IPtyService=(0,S.createDecorator)("ptyService");var a;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(a||(e.HeartbeatConstants=a={}));var y;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(y||(e.TerminalLocation=y={}));var h;(function(t){t.TerminalView="view",t.Editor="editor"})(h||(e.TerminalLocationString=h={}));var r;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var s;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(s||(e.FlowControlConstants=s={}));var l;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(l||(e.ProfileSource=l={}));var c;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(c||(e.ShellIntegrationStatus=c={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class n{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(g){const u=this._sanitizeRemoteAuthority(g.remoteAuthority);if(this._backends.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this._backends.set(u,g)}getTerminalBackend(g){return this._backends.get(this._sanitizeRemoteAuthority(g))}_sanitizeRemoteAuthority(g){return g?.toLowerCase()??""}}P.Registry.add(e.TerminalExtensions.Backend,new n),e.ILocalPtyService=(0,S.createDecorator)("localPtyService"),e.ITerminalLogService=(0,S.createDecorator)("terminalLogService")}),define(Le[181],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class S{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,O,A=5){const R=O(p=>{const o=typeof p=="string"?p:p.data;let I=this._terminalBufferMap.get(P);if(I){I.data.push(o);return}const w=setTimeout(()=>this.flushBuffer(P),A);I={data:[o],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(P),R.dispose()}},this._terminalBufferMap.set(P,I)});return R}stopBuffering(P){this._terminalBufferMap.get(P)?.dispose()}flushBuffer(P){const O=this._terminalBufferMap.get(P);O&&(this._terminalBufferMap.delete(P),this._callback(P,O.data.join("")))}}e.TerminalDataBufferer=S}),define(Le[182],Ne([1,0,10,97,282,34,6,14,2,9,77,30]),function(Se,e,S,k,P,O,A,R,p,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=s,e.getIconRegistry=l,w=We(w),e.Extensions={IconContribution:"base.contributions.icons"};var a;(function(t){function g(u,v){let m=u.defaults;for(;O.ThemeIcon.isThemeIcon(m);){const d=r.getIcon(m.id);if(!d)return;m=d.defaults}return m}t.getDefinition=g})(a||(e.IconContribution=a={}));var y;(function(t){function g(v){return{weight:v.weight,style:v.style,src:v.src.map(m=>({format:m.format,location:m.location.toString()}))}}t.toJSONObject=g;function u(v){const m=d=>(0,R.isString)(d)?d:void 0;if(v&&Array.isArray(v.src)&&v.src.every(d=>(0,R.isString)(d.format)&&(0,R.isString)(d.location)))return{weight:m(v.weight),style:m(v.style),src:v.src.map(d=>({format:d.format,location:p.URI.parse(d.location)}))}}t.fromJSONObject=u})(y||(e.IconFontDefinition=y={}));class h{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,o.localize)(11152,null)},fontCharacter:{type:"string",description:(0,o.localize)(11153,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(g,u,v,m){const d=this.iconsById[g];if(d){if(v&&!d.description){d.description=v,this.iconSchema.properties[g].markdownDescription=`${v} $(${g})`;const E=this.iconReferenceSchema.enum.indexOf(g);E!==-1&&(this.iconReferenceSchema.enumDescriptions[E]=v),this._onDidChange.fire()}return d}const C={id:g,description:v,defaults:u,deprecationMessage:m};this.iconsById[g]=C;const _={$ref:"#/definitions/icons"};return m&&(_.deprecationMessage=m),v&&(_.markdownDescription=`${v}: $(${g})`),this.iconSchema.properties[g]=_,this.iconReferenceSchema.enum.push(g),this.iconReferenceSchema.enumDescriptions.push(v||""),this._onDidChange.fire(),{id:g}}deregisterIcon(g){delete this.iconsById[g],delete this.iconSchema.properties[g];const u=this.iconReferenceSchema.enum.indexOf(g);u!==-1&&(this.iconReferenceSchema.enum.splice(u,1),this.iconReferenceSchema.enumDescriptions.splice(u,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(g=>this.iconsById[g])}getIcon(g){return this.iconsById[g]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(g,u){const v=this.iconFontsById[g];return v||(this.iconFontsById[g]=u,this._onDidChange.fire(),u)}deregisterIconFont(g){delete this.iconFontsById[g]}getIconFont(g){return this.iconFontsById[g]}toString(){const g=(d,C)=>d.id.localeCompare(C.id),u=d=>{for(;O.ThemeIcon.isThemeIcon(d.defaults);)d=this.iconsById[d.defaults.id];return`codicon codicon-${d?d.id:""}`},v=[];v.push("| preview     | identifier                        | default codicon ID                | description"),v.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.iconsById).map(d=>this.iconsById[d]);for(const d of m.filter(C=>!!C.description).sort(g))v.push(`|<i class="${u(d)}"></i>|${d.id}|${O.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);v.push("| preview     | identifier                        "),v.push("| ----------- | --------------------------------- |");for(const d of m.filter(C=>!O.ThemeIcon.isThemeIcon(C.defaults)).sort(g))v.push(`|<i class="${u(d)}"></i>|${d.id}|`);return v.join(`
`)}}const r=new h;w.Registry.add(e.Extensions.IconContribution,r);function s(t,g,u,v){return r.registerIcon(t,g,u,v)}function l(){return r}function c(){const t=(0,P.getCodiconFontCharacters)();for(const g in t){const u="\\"+t[g].toString(16);r.registerIcon(g,{fontCharacter:u})}}c(),e.iconsSchemaId="vscode://schemas/icons";const i=w.Registry.as(I.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,r.getIconSchema());const n=new S.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.widgetClose=s("widget-close",k.Codicon.close,(0,o.localize)(11154,null)),e.gotoPreviousLocation=s("goto-previous-location",k.Codicon.arrowUp,(0,o.localize)(11155,null)),e.gotoNextLocation=s("goto-next-location",k.Codicon.arrowDown,(0,o.localize)(11156,null)),e.syncing=O.ThemeIcon.modify(k.Codicon.sync,"spin"),e.spinningLoading=O.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(Le[183],Ne([1,0,6,4,20,2,43,3,11]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=w,e.extractLocalHostUriMetaDataForPortMapping=y,e.extractQueryLocalHostUriMetaDataForPortMapping=h,e.isLocalhost=r,e.isAllInterfaces=s,e.isPortPrivileged=l,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var o;(function(n){n.Http="http",n.Https="https"})(o||(e.TunnelProtocol=o={}));var I;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(I||(e.TunnelPrivacyId=I={}));function w(n){return!!n.forwardPort}var a;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function y(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function h(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const g of t){const u=g.split("=")[1];if(/^https?:/.exec(u)){const v=y(O.URI.parse(u));if(v)return v}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.LOCALHOST_ADDRESSES.indexOf(n)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function s(n){return e.ALL_INTERFACES_ADDRESSES.indexOf(n)>=0}function l(n,t,g,u){if(g===P.OperatingSystem.Windows)return!1;if(g===P.OperatingSystem.Macintosh&&s(t)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(v?.length===4&&parseInt(v[1])>=18)return!1}return n<1024}class c{constructor(t,g,u){this.remoteAddress=t,this.localAddress=g,this._dispose=u,this._onDispose=new S.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=c;let i=class extends k.Disposable{constructor(t,g){super(),this.logService=t,this.configurationService=g,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions,this._canChangeProtocol=t.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],g=Array.from(this._tunnels.values());for(const u of g){const v=Array.from(u.values());for(const m of v){const d=await m.value;d&&typeof d!="string"&&t.push(d)}}return t}async dispose(){super.dispose();for(const t of this._tunnels.values()){for(const{value:g}of t.values())await g.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,g,u,v,m){this.addTunnelToMap(t,g,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:g,localAddress:u,privacy:v,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,g){(s(t)||r(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const u=this.getTunnelFromMap(t,g);if(u)return++u.refcount,u.value}openTunnel(t,g,u,v,m,d=!1,C,_){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${u} on local port ${m}.`);const E=this._tunnelProvider??t;if(!E)return;if(g||(g="localhost"),v||(v=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(u)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const T=this.retainOrCreateTunnel(E,g,u,v,m,d,C,_);return T?T.then(D=>{if(D){if(typeof D=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(g,u),D}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(g,u);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.makeTunnel(D);return(D.tunnelRemoteHost!==g||D.tunnelRemotePort!==u)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),C&&D.privacy!==C&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(f),f}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),T)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const g=this._tunnels.get(t.tunnelRemoteHost);if(g){const u=g.get(t.tunnelRemotePort);u&&(u.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async tryDisposeTunnel(t,g,u){if(u.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${g}.`);const v=u.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(g),v}}async closeTunnel(t,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${g} `);const u=this._tunnels.get(t);if(u&&u.has(g)){const v=u.get(g);v.refcount=0,await this.tryDisposeTunnel(t,g,v)}}addTunnelToMap(t,g,u){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(g,{refcount:1,value:u})}async removeEmptyOrErrorTunnelFromMap(t,g){const u=this._tunnels.get(t);if(u){const v=u.get(g),m=v?await v.value:void 0;(!m||typeof m=="string")&&u.delete(g),u.size===0&&this._tunnels.delete(t)}}getTunnelFromMap(t,g){const u=[t];r(t)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):s(t)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const v=u.map(m=>this._tunnels.get(m));for(const m of v){const d=m?.get(g);if(d)return d}}canTunnel(t){return!!y(t)}createWithProvider(t,g,u,v,m,d,C){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${u} on local port ${v}.`);const _=u;this._factoryInProgress.add(_);const E=v===void 0?u:v,T={elevationRequired:m?this.isPortPrivileged(E):!1},D={remoteAddress:{host:g,port:u},localAddressPort:v,privacy:d,public:d?d!==I.Private:void 0,protocol:C},f=t.forwardPort(D,T);return f?(this.addTunnelToMap(g,u,f),f.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(_)})):this._factoryInProgress.delete(_),f}};e.AbstractTunnelService=i,e.AbstractTunnelService=i=Ge([Ve(0,p.ILogService),Ve(1,A.IConfigurationService)],i)}),define(Le[184],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(Le[185],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,S.createDecorator)("editSessionIdentityService");var k;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(k||(e.EditSessionIdentityMatch=k={}))}),define(Le[186],Ne([1,0,15]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=k,e.getVirtualWorkspaceLocation=P,e.getVirtualWorkspaceScheme=O,e.getVirtualWorkspaceAuthority=A,e.isVirtualWorkspace=R;function k(p){return p.scheme!==S.Schemas.file&&p.scheme!==S.Schemas.vscodeRemote}function P(p){if(p.folders.length)return p.folders.every(o=>k(o.uri))?p.folders[0].uri:void 0;if(p.configuration&&k(p.configuration))return p.configuration}function O(p){return P(p)?.scheme}function A(p){return P(p)?.authority}function R(p){return P(p)!==void 0}}),define(Le[49],Ne([1,0,9,19,58,23,2,3,15]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=o,e.isEmptyWorkspaceIdentifier=I,e.toWorkspaceIdentifier=w,e.isWorkspaceIdentifier=a,e.reviveIdentifier=y,e.isWorkspace=r,e.isWorkspaceFolder=s,e.toWorkspaceFolder=i,e.isUntitledWorkspace=n,e.isTemporaryWorkspace=t,e.isStandaloneEditorWorkspace=g,e.isSavedWorkspace=u,e.hasWorkspaceFileExtension=v,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function o(m){const d=m;return typeof d?.id=="string"&&A.URI.isUri(d.uri)}function I(m){return typeof m?.id=="string"&&!o(m)&&!a(m)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(m,d){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,k.basename)(m)}:d?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const C=m;return C.configuration?{id:C.id,configPath:C.configuration}:C.folders.length===1?{id:C.id,uri:C.folders[0].uri}:{id:C.id}}function a(m){const d=m;return typeof d?.id=="string"&&A.URI.isUri(d.configPath)}function y(m){const d=m;if(d?.uri)return{id:d.id,uri:A.URI.revive(d.uri)};const C=m;if(C?.configPath)return{id:C.id,configPath:A.URI.revive(C.configPath)};if(m?.id)return{id:m.id}}var h;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function r(m){const d=m;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}function s(m){const d=m;return!!(d&&typeof d=="object"&&A.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}class l{constructor(d,C,_,E,T){this._id=d,this._transient=_,this._configuration=E,this._ignorePathCasing=T,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=C}update(d){this._id=d.id,this._configuration=d.configuration,this._transient=d.transient,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d)||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class c{constructor(d,C){this.raw=C,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,O.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function i(m){return new c({uri:m,index:0,name:(0,O.basenameOrAuthority)(m)},{uri:m.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(11031,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function n(m,d){return O.extUriBiasedIgnorePathCase.isEqualOrParent(m,d.untitledWorkspacesHome)}function t(m){let d;return A.URI.isUri(m)?d=m:d=m.configuration,d?.scheme===p.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function g(m){return m.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function u(m,d){return!n(m,d)&&!t(m)}function v(m){return(typeof m=="string"?(0,k.extname)(m):(0,O.extname)(m))===e.WORKSPACE_SUFFIX}}),define(Le[113],Ne([1,0,75,6,4,23,2,9,106,29,3,11,49,28,184,10,38,12,14]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=n,e.reviveProfile=t,e.toUserDataProfile=g;var i;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(m){const d=m;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&typeof d.isDefault=="boolean"&&typeof d.name=="string"&&A.URI.isUri(d.location)&&A.URI.isUri(d.globalStorageHome)&&A.URI.isUri(d.settingsResource)&&A.URI.isUri(d.keybindingsResource)&&A.URI.isUri(d.tasksResource)&&A.URI.isUri(d.snippetsHome)&&A.URI.isUri(d.extensionsResource))}e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function t(m,d){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:A.URI.revive(m.location).with({scheme:d}),globalStorageHome:A.URI.revive(m.globalStorageHome).with({scheme:d}),settingsResource:A.URI.revive(m.settingsResource).with({scheme:d}),keybindingsResource:A.URI.revive(m.keybindingsResource).with({scheme:d}),tasksResource:A.URI.revive(m.tasksResource).with({scheme:d}),snippetsHome:A.URI.revive(m.snippetsHome).with({scheme:d}),extensionsResource:A.URI.revive(m.extensionsResource).with({scheme:d}),cacheHome:A.URI.revive(m.cacheHome).with({scheme:d}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function g(m,d,C,_,E,T){return{id:m,name:d,location:C,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:T&&E?.useDefaultFlags?.globalState?T.globalStorageHome:(0,O.joinPath)(C,"globalStorage"),settingsResource:T&&E?.useDefaultFlags?.settings?T.settingsResource:(0,O.joinPath)(C,"settings.json"),keybindingsResource:T&&E?.useDefaultFlags?.keybindings?T.keybindingsResource:(0,O.joinPath)(C,"keybindings.json"),tasksResource:T&&E?.useDefaultFlags?.tasks?T.tasksResource:(0,O.joinPath)(C,"tasks.json"),snippetsHome:T&&E?.useDefaultFlags?.snippets?T.snippetsHome:(0,O.joinPath)(C,"snippets"),extensionsResource:T&&E?.useDefaultFlags?.extensions?T.extensionsResource:(0,O.joinPath)(C,"extensions.json"),cacheHome:(0,O.joinPath)(_,m),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let u=class extends P.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(d,C,_,E){super(),this.environmentService=d,this.fileService=C,this.uriIdentityService=_,this.logService=E,this.enabled=!0,this._onDidChangeProfiles=this._register(new k.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new k.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new k.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new k.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new y.ResourceMap,workspaces:new y.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(d){this.enabled!==d&&(this._profilesObject=void 0,this.enabled=d)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const d=this.createDefaultProfile(),C=[d];if(this.enabled)try{for(const T of this.getStoredProfiles()){if(!T.name||!(0,c.isString)(T.name)||!T.location){this.logService.warn("Skipping the invalid stored profile",T.location||T.name);continue}C.push(g((0,O.basename)(T.location),T.name,T.location,this.profilesCacheHome,{shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags},d))}}catch(T){this.logService.error(T)}const _=new y.ResourceMap,E=new Map;if(C.length)try{const T=this.getStoredProfileAssociations();if(T.workspaces)for(const[D,f]of Object.entries(T.workspaces)){const b=A.URI.parse(D),M=C.find(L=>L.id===f);M&&_.set(b,M)}if(T.emptyWindows)for(const[D,f]of Object.entries(T.emptyWindows)){const b=C.find(M=>M.id===f);b&&E.set(D,b)}}catch(T){this.logService.error(T)}this._profilesObject={profiles:C,workspaces:_,emptyWindows:E}}return this._profilesObject}createDefaultProfile(){const d=g("__default__profile__",(0,R.localize)(11078,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...d,extensionsResource:this.getDefaultProfileExtensionsLocation()??d.extensionsResource,isDefault:!0}}async createTransientProfile(d){const C="Temp",_=new RegExp(`${(0,l.escapeRegExpCharacters)(C)}\\s(\\d+)`);let E=0;for(const D of this.profiles){const f=_.exec(D.name),b=f?parseInt(f[1]):0;E=b>E?b:E}const T=`${C} ${E+1}`;return this.createProfile((0,S.hash)((0,s.generateUuid)()).toString(16),T,{transient:!0},d)}async createNamedProfile(d,C,_){return this.createProfile((0,S.hash)((0,s.generateUuid)()).toString(16),d,C,_)}async createProfile(d,C,_,E){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const T=await this.doCreateProfile(d,C,_);return E&&await this.setProfileForWorkspace(E,T),T}async doCreateProfile(d,C,_){if(!(0,c.isString)(C)||!C)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.profileCreationPromises.get(C);return E||(E=(async()=>{try{if(this.profiles.find(b=>b.name===C||b.id===d))throw new Error(`Profile with ${C} name already exists`);const D=g(d,C,(0,O.joinPath)(this.profilesHome,d),this.profilesCacheHome,_,this.defaultProfile);await this.fileService.createFolder(D.location);const f=[];return this._onWillCreateProfile.fire({profile:D,join(b){f.push(b)}}),await r.Promises.settled(f),this.updateProfiles([D],[],[]),D}finally{this.profileCreationPromises.delete(C)}})(),this.profileCreationPromises.set(C,E)),E}async updateProfile(d,C){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let _=this.profiles.find(E=>E.id===d.id);if(!_)throw new Error(`Profile '${d.name}' does not exist`);return _=g(_.id,C.name??_.name,_.location,this.profilesCacheHome,{shortName:C.shortName??_.shortName,icon:C.icon===null?void 0:C.icon??_.icon,transient:C.transient??_.isTransient,useDefaultFlags:C.useDefaultFlags??_.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[_]),_}async removeProfile(d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(d.isDefault)throw new Error("Cannot remove default profile");const C=this.profiles.find(E=>E.id===d.id);if(!C)throw new Error(`Profile '${d.name}' does not exist`);const _=[];this._onWillRemoveProfile.fire({profile:C,join(E){_.push(E)}});try{await Promise.allSettled(_)}catch(E){this.logService.error(E)}for(const E of[...this.profilesObject.emptyWindows.keys()])C.id===this.profilesObject.emptyWindows.get(E)?.id&&this.profilesObject.emptyWindows.delete(E);for(const E of[...this.profilesObject.workspaces.keys()])C.id===this.profilesObject.workspaces.get(E)?.id&&this.profilesObject.workspaces.delete(E);this.updateStoredProfileAssociations(),this.updateProfiles([],[C],[]);try{await this.fileService.del(C.cacheHome,{recursive:!0})}catch(E){(0,o.toFileOperationResult)(E)!==o.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(E)}}async setProfileForWorkspace(d,C){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const _=this.profiles.find(E=>E.id===C.id);if(!_)throw new Error(`Profile '${C.name}' does not exist`);this.updateWorkspaceAssociation(d,_)}unsetWorkspace(d,C){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(d,void 0,C)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const d=await this.fileService.resolve(this.profilesHome);await Promise.all((d.children||[]).filter(C=>C.isDirectory&&this.profiles.every(_=>!this.uriIdentityService.extUri.isEqual(_.location,C.resource))).map(C=>this.fileService.del(C.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const d=this.transientProfilesObject.profiles.filter(C=>!this.isProfileAssociatedToWorkspace(C));await Promise.allSettled(d.map(C=>this.removeProfile(C)))}getProfileForWorkspace(d){const C=this.getWorkspace(d),_=A.URI.isUri(C)?this.profilesObject.workspaces.get(C):this.profilesObject.emptyWindows.get(C);return _||((0,a.isSingleFolderWorkspaceIdentifier)(d)?this.transientProfilesObject.folders.get(d.uri):(0,a.isWorkspaceIdentifier)(d)?this.transientProfilesObject.workspaces.get(d.configPath):this.transientProfilesObject.emptyWindows.get(d.id))}getWorkspace(d){return(0,a.isSingleFolderWorkspaceIdentifier)(d)?d.uri:(0,a.isWorkspaceIdentifier)(d)?d.configPath:d.id}isProfileAssociatedToWorkspace(d){return!!([...this.profilesObject.emptyWindows.values()].some(C=>this.uriIdentityService.extUri.isEqual(C.location,d.location))||[...this.profilesObject.workspaces.values()].some(C=>this.uriIdentityService.extUri.isEqual(C.location,d.location))||[...this.transientProfilesObject.emptyWindows.values()].some(C=>this.uriIdentityService.extUri.isEqual(C.location,d.location))||[...this.transientProfilesObject.workspaces.values()].some(C=>this.uriIdentityService.extUri.isEqual(C.location,d.location))||[...this.transientProfilesObject.folders.values()].some(C=>this.uriIdentityService.extUri.isEqual(C.location,d.location)))}updateProfiles(d,C,_){const E=[...this.profiles,...d],T=[],D=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let f of E){if(f.isDefault||C.some(M=>f.id===M.id))continue;f=_.find(M=>f.id===M.id)??f;const b=D.find(M=>f.id===M.id);if(f.isTransient)this.transientProfilesObject.profiles.push(f);else{if(b){for(const[M,L]of this.transientProfilesObject.emptyWindows.entries())if(f.id===L.id){this.updateWorkspaceAssociation({id:M},f);break}for(const[M,L]of this.transientProfilesObject.workspaces.entries())if(f.id===L.id){this.updateWorkspaceAssociation({id:"",configPath:M},f);break}for(const[M,L]of this.transientProfilesObject.folders.entries())if(f.id===L.id){this.updateWorkspaceAssociation({id:"",uri:M},f);break}}T.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags})}}this.saveStoredProfiles(T),this._profilesObject=void 0,this.triggerProfilesChanges(d,C,_)}triggerProfilesChanges(d,C,_){this._onDidChangeProfiles.fire({added:d,removed:C,updated:_,all:this.profiles})}updateWorkspaceAssociation(d,C,_){if(_=C?.isTransient?!0:_,_)(0,a.isSingleFolderWorkspaceIdentifier)(d)?(this.transientProfilesObject.folders.delete(d.uri),C&&this.transientProfilesObject.folders.set(d.uri,C)):(0,a.isWorkspaceIdentifier)(d)?(this.transientProfilesObject.workspaces.delete(d.configPath),C&&this.transientProfilesObject.workspaces.set(d.configPath,C)):(this.transientProfilesObject.emptyWindows.delete(d.id),C&&this.transientProfilesObject.emptyWindows.set(d.id,C));else{this.updateWorkspaceAssociation(d,void 0,!0);const E=this.getWorkspace(d);A.URI.isUri(E)?(this.profilesObject.workspaces.delete(E),C&&this.profilesObject.workspaces.set(E,C)):(this.profilesObject.emptyWindows.delete(E),C&&this.profilesObject.emptyWindows.set(E,C)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const d={};for(const[_,E]of this.profilesObject.workspaces.entries())d[_.toString()]=E.id;const C={};for(const[_,E]of this.profilesObject.emptyWindows.entries())C[_.toString()]=E.id;this.saveStoredProfileAssociations({workspaces:d,emptyWindows:C}),this._profilesObject=void 0}migrateStoredProfileAssociations(d){const C={},_=this.createDefaultProfile();if(d.workspaces)for(const[T,D]of Object.entries(d.workspaces)){const f=A.URI.parse(D);C[T]=this.uriIdentityService.extUri.isEqual(f,_.location)?_.id:this.uriIdentityService.extUri.basename(f)}const E={};if(d.emptyWindows)for(const[T,D]of Object.entries(d.emptyWindows)){const f=A.URI.parse(D);E[T]=this.uriIdentityService.extUri.isEqual(f,_.location)?_.id:this.uriIdentityService.extUri.basename(f)}return{workspaces:C,emptyWindows:E}}getStoredProfiles(){return[]}saveStoredProfiles(d){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(d){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=u,e.UserDataProfilesService=u=Ge([Ve(0,p.IEnvironmentService),Ve(1,o.IFileService),Ve(2,h.IUriIdentityService),Ve(3,w.ILogService)],u);class v extends u{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(d){this.storedProfiles=d}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(d){this.storedProfileAssociations=d}}e.InMemoryUserDataProfilesService=v}),define(Le[187],Ne([1,0,10,6,4,64,14,152,3,113]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=y,e.isProfileUsingDefaultStorage=r,e.logStorage=l,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var I;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var w;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var a;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(a||(e.StorageTarget=a={}));function y(c){const i=c.get(e.TARGET_KEY);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class h extends P.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(i={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=i,this._onDidChangeValue=this._register(new k.PauseableEmitter),this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(i,n,t){return k.Event.filter(this._onDidChangeValue.event,g=>g.scope===i&&(n===void 0||g.key===n),t)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(i,n){const{key:t,external:g}=n;if(t===e.TARGET_KEY){switch(i){case w.APPLICATION:this._applicationKeyTargets=void 0;break;case w.PROFILE:this._profileKeyTargets=void 0;break;case w.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:i})}else this._onDidChangeValue.fire({scope:i,key:t,target:this.getKeyTargets(i)[t],external:g})}emitWillSaveState(i){this._onWillSaveState.fire({reason:i})}get(i,n,t){return this.getStorage(n)?.get(i,t)}getBoolean(i,n,t){return this.getStorage(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.getStorage(n)?.getNumber(i,t)}getObject(i,n,t){return this.getStorage(n)?.getObject(i,t)}storeAll(i,n){this.withPausedEmitters(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,g,u=!1){if((0,A.isUndefinedOrNull)(n)){this.remove(i,t,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(i,t,g),this.getStorage(t)?.set(i,n,u)})}remove(i,n,t=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(i,n,void 0),this.getStorage(n)?.delete(i,t)})}withPausedEmitters(i){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{i()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(i,n){const t=[],g=this.getKeyTargets(i);for(const u of Object.keys(g))g[u]===n&&t.push(u);return t}updateKeyTarget(i,n,t,g=!1){const u=this.getKeyTargets(n);typeof t=="number"?u[i]!==t&&(u[i]=t,this.getStorage(n)?.set(e.TARGET_KEY,JSON.stringify(u),g)):typeof u[i]=="number"&&(delete u[i],this.getStorage(n)?.set(e.TARGET_KEY,JSON.stringify(u),g))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(w.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(w.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(w.APPLICATION)),this._applicationKeyTargets}getKeyTargets(i){switch(i){case w.APPLICATION:return this.applicationKeyTargets;case w.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(i){const n=this.getStorage(i);return n?y(n):Object.create(null)}isNew(i){return this.getBoolean(e.IS_NEW_KEY,i)===!0}async flush(i=I.NONE){this._onWillSaveState.fire({reason:i});const n=this.getStorage(w.APPLICATION),t=this.getStorage(w.PROFILE),g=this.getStorage(w.WORKSPACE);switch(i){case I.NONE:await S.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await S.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.getStorage(w.APPLICATION)?.items??new Map,n=this.getStorage(w.PROFILE)?.items??new Map,t=this.getStorage(w.WORKSPACE)?.items??new Map;return l(i,n,t,this.getLogDetails(w.APPLICATION)??"",this.getLogDetails(w.PROFILE)??"",this.getLogDetails(w.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.getStorage(i)?.optimize()}async switch(i,n){return this.emitWillSaveState(I.NONE),(0,o.isUserDataProfile)(i)?this.switchToProfile(i,n):this.switchToWorkspace(i,n)}canSwitchProfile(i,n){return!(i.id===n.id||r(n)&&r(i))}switchData(i,n,t){this.withPausedEmitters(()=>{const g=new Set;for(const[u,v]of i)g.add(u),n.get(u)!==v&&this.emitDidChangeValue(t,{key:u,external:!0});for(const[u]of n.items)g.has(u)||this.emitDidChangeValue(t,{key:u,external:!0})})}}e.AbstractStorageService=h;function r(c){return c.isDefault||!!c.useDefaultFlags?.globalState}class s extends h{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(i=>this.emitDidChangeValue(w.WORKSPACE,i))),this._register(this.profileStorage.onDidChangeStorage(i=>this.emitDidChangeValue(w.PROFILE,i))),this._register(this.applicationStorage.onDidChangeStorage(i=>this.emitDidChangeValue(w.APPLICATION,i)))}getStorage(i){switch(i){case w.APPLICATION:return this.applicationStorage;case w.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(i){switch(i){case w.APPLICATION:return"inMemory (application)";case w.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(i){return!1}}e.InMemoryStorageService=s;async function l(c,i,n,t,g,u){const v=b=>{try{return JSON.parse(b)}catch{return b}},m=new Map,d=new Map;c.forEach((b,M)=>{m.set(M,b),d.set(M,v(b))});const C=new Map,_=new Map;i.forEach((b,M)=>{C.set(M,b),_.set(M,v(b))});const E=new Map,T=new Map;n.forEach((b,M)=>{E.set(M,b),T.set(M,v(b))}),console.group(t!==g?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const D=[];if(m.forEach((b,M)=>{D.push({key:M,value:b})}),console.table(D),console.groupEnd(),console.log(d),t!==g){console.group(`Storage: Profile (path: ${g}, profile specific)`);const b=[];C.forEach((M,L)=>{b.push({key:L,value:M})}),console.table(b),console.groupEnd(),console.log(_)}console.group(`Storage: Workspace (path: ${u})`);const f=[];E.forEach((b,M)=>{f.push({key:M,value:b})}),console.table(f),console.groupEnd(),console.log(T)}}),define(Le[79],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class S{static{this.enableDebugLogging=!1}constructor(P){this.id=P,this._data=new Map,this._idPool=1}add(P){const O=this._idPool++;return this._data.set(O,P),this.logDebugInfo(),O}get(P,O){return this._data.has(P)?this._data.get(P)[O]:void 0}delete(P){this._data.delete(P),this.logDebugInfo()}logDebugInfo(){S.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=S}),define(Le[50],Ne([1,0,15,23,29,3]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(S.Schemas)),this._providerInfo=new Map,this.extUri=new k.ExtUri(p=>{const o=this._providerInfo.get(p.scheme);return!(o===void 0||o&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,o){o===null?this._providerInfo.delete(p.scheme):this._providerInfo.set(p.scheme,o)}isFreeScheme(p){return!this._providerInfo.has(p)&&!this._systemSchemes.has(p)}getCapabilities(p){return this._providerInfo.get(p)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,O.createDecorator)("IExtHostFileSystemInfo")}),define(Le[26],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,S.createDecorator)("IExtHostInitDataService")}),define(Le[188],Ne([1,0,9,11,172,26]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends P.LogService{constructor(p,o,I){const w=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",a=I.remote.isRemote?(0,S.localize)(10830,null):p?(0,S.localize)(10831,null):(0,S.localize)(10832,null);super(o.createLogger(w,{name:a}))}};e.ExtHostLogService=A,e.ExtHostLogService=A=Ge([Ve(1,k.ILoggerService),Ve(2,O.IExtHostInitDataService)],A)}),define(Le[189],Ne([1,0,10]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(A,R,p){this._deferredPromises=new Map,this._id=A,this._shared=R,this._storage=p,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(o=>(this._value=o,this)),this._storageListener=this._storage.onDidChangeStorage(o=>{o.shared===this._shared&&o.key===this._id&&(this._value=o.value)}),this._scheduler=new S.RunOnceScheduler(()=>{const o=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const I of o.values())I.complete()}catch(I){for(const w of o.values())w.error(I)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,R){let p=this._value[A];return typeof p>"u"&&(p=R),p}update(A,R){this._value[A]=R;const p=this._deferredPromises.get(A);if(p!==void 0)return p.p;const o=new S.DeferredPromise;return this._deferredPromises.set(A,o),this._scheduler.isScheduled()||this._scheduler.schedule(),o.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=k;class P extends k{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,R){super(A.identifier.value,!0,R),this._extension=A}}e.ExtensionGlobalMemento=P}),define(Le[190],Ne([1,0,6,2]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class P{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new S.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new S.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,R,p,o){const w=this._notebooksAndEditors.getNotebookDocument(k.URI.revive(A)).acceptModelChanged(R.value,p,o);this._onDidChangeNotebookDocument.fire(w)}$acceptDirtyStateChanged(A,R){this._notebooksAndEditors.getNotebookDocument(k.URI.revive(A)).acceptDirty(R)}$acceptModelSaved(A){const R=this._notebooksAndEditors.getNotebookDocument(k.URI.revive(A));this._onDidSaveNotebookDocument.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=P}),define(Le[16],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,S.createDecorator)("IExtHostRpcService");class k{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.ExtHostRpcService=k}),define(Le[191],Ne([1,0,18,6,4]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class O{#e;constructor(R,p){this.disposables=new P.DisposableStore,this._id=S.ExtensionIdentifier.toKey(R.identifier),this.#e=p,this.onDidChange=k.Event.map(k.Event.filter(this.#e.onDidChangePassword,o=>o.extensionId===this._id),o=>({key:o.key}),this.disposables)}dispose(){this.disposables.dispose()}get(R){return this.#e.get(this._id,R)}store(R,p){return this.#e.store(this._id,R,p)}delete(R){return this.#e.delete(this._id,R)}}e.ExtensionSecrets=O}),define(Le[65],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,S.createDecorator)("IURITransformerService");class k{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=k});var Jt=this&&this.__importDefault||function(Se){return Se&&Se.__esModule?Se:{default:Se}};define(Le[114],Ne([1,0,9,14,2,4,3,30,29,15,42,164,35]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=r,e.isEditorPaneWithScrolling=s,e.findViewStateForEditor=l,e.isResourceEditorInput=c,e.isResourceDiffEditorInput=i,e.isResourceMultiDiffEditorInput=n,e.isResourceSideBySideEditorInput=t,e.isUntitledResourceEditorInput=g,e.isResourceMergeEditorInput=u,e.isEditorInput=E,e.isSideBySideEditorInput=D,e.isDiffEditorInput=f,e.createTooLargeFileError=b,e.isEditorInputWithOptions=M,e.isEditorInputWithOptionsAndGroup=L,e.isEditorIdentifier=N,e.isEditorCommandsContext=W,e.preventEditorClose=Ee,e.pathsToEditors=le,e.isTextEditorViewState=oe,e.isEditorOpenError=De,e.createEditorOpenError=Re,a=Jt(a),e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,S.localize)(12474,null),providerDisplayName:(0,S.localize)(12475,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var y;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var h;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(h||(e.EditorPaneSelectionCompareResult=h={}));function r(Q){const z=Q;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}function s(Q){const z=Q;return!!z&&typeof z.getScrollPosition=="function"&&typeof z.setScrollPosition=="function"&&!!z.onDidChangeScroll}function l(Q,z,ne){for(const Ce of ne.visibleEditorPanes)if(Ce.group.id===z&&Q.matches(Ce.input))return Ce.getViewState()}function c(Q){if(E(Q))return!1;const z=Q;return P.URI.isUri(z?.resource)}function i(Q){if(E(Q))return!1;const z=Q;return z?.original!==void 0&&z.modified!==void 0}function n(Q){if(E(Q))return!1;const z=Q;return!z||z.resources&&!Array.isArray(z.resources)?!1:!!z.resources||!!z.multiDiffSource}function t(Q){if(E(Q)||i(Q))return!1;const z=Q;return z?.primary!==void 0&&z.secondary!==void 0}function g(Q){if(E(Q))return!1;const z=Q;return z?z.resource===void 0||z.resource.scheme===o.Schemas.untitled||z.forceUntitled===!0:!1}function u(Q){if(E(Q))return!1;const z=Q;return P.URI.isUri(z?.base?.resource)&&P.URI.isUri(z?.input1?.resource)&&P.URI.isUri(z?.input2?.resource)&&P.URI.isUri(z?.result?.resource)}var v;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(v||(e.Verbosity=v={}));var m;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class d{constructor(){this.mapIdToSaveSource=new Map}registerSource(z,ne){let Ce=this.mapIdToSaveSource.get(z);return Ce||(Ce={source:z,label:ne},this.mapIdToSaveSource.set(z,Ce)),Ce.source}getSourceLabel(z){return this.mapIdToSaveSource.get(z)?.label??z}}e.SaveSourceRegistry=new d;var C;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors",Q[Q.Scratchpad=512]="Scratchpad"})(C||(e.EditorInputCapabilities=C={}));class _ extends O.Disposable{}e.AbstractEditorInput=_;function E(Q){return Q instanceof _}function T(Q){const z=Q;return P.URI.isUri(z?.preferredResource)}function D(Q){const z=Q;return E(z?.primary)&&E(z?.secondary)}function f(Q){const z=Q;return E(z?.modified)&&E(z?.original)}function b(Q,z,ne,Ce,fe){return Re(Ce,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,S.localize)(12476,null),run:()=>{const be={...ne,limits:{size:Number.MAX_VALUE}};Q.openEditor(z,be)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(12477,null),run:()=>fe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}function M(Q){return E(Q?.editor)}function L(Q){const z=Q;return M(Q)&&z?.group!==void 0}function N(Q){const z=Q;return typeof z?.groupId=="number"&&E(z.editor)}function W(Q){return typeof Q?.groupId=="number"}var j;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})(j||(e.EditorCloseContext=j={}));var $;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LABEL=2]="GROUP_LABEL",Q[Q.GROUP_LOCKED=3]="GROUP_LOCKED",Q[Q.EDITORS_SELECTION=4]="EDITORS_SELECTION",Q[Q.EDITOR_OPEN=5]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=6]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=7]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=9]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=11]="EDITOR_PIN",Q[Q.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Q[Q.EDITOR_STICKY=13]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=14]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})($||(e.GroupModelChangeKind=$={}));var K;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(K||(e.SideBySideEditor=K={}));class q{getOriginalUri(z,ne){if(!z)return;if(u(z))return e.EditorResourceAccessor.getOriginalUri(z.result,ne);if(ne?.supportSideBySide){const{primary:fe,secondary:be}=this.getSideEditors(z);if(fe&&be){if(ne?.supportSideBySide===K.BOTH)return{primary:this.getOriginalUri(fe,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===K.ANY)return this.getOriginalUri(fe,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(be,{filterByScheme:ne.filterByScheme});z=ne.supportSideBySide===K.PRIMARY?fe:be}}if(i(z)||n(z)||t(z)||u(z))return;const Ce=T(z)?z.preferredResource:z.resource;return!Ce||!ne||!ne.filterByScheme?Ce:this.filterUri(Ce,ne.filterByScheme)}getSideEditors(z){return D(z)||t(z)?{primary:z.primary,secondary:z.secondary}:f(z)||i(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,ne){if(!z)return;if(u(z))return e.EditorResourceAccessor.getCanonicalUri(z.result,ne);if(ne?.supportSideBySide){const{primary:fe,secondary:be}=this.getSideEditors(z);if(fe&&be){if(ne?.supportSideBySide===K.BOTH)return{primary:this.getCanonicalUri(fe,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===K.ANY)return this.getCanonicalUri(fe,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:ne.filterByScheme});z=ne.supportSideBySide===K.PRIMARY?fe:be}}if(i(z)||n(z)||t(z)||u(z))return;const Ce=z.resource;return!Ce||!ne||!ne.filterByScheme?Ce:this.filterUri(Ce,ne.filterByScheme)}filterUri(z,ne){if(Array.isArray(ne)){if(ne.some(Ce=>z.scheme===Ce))return z}else if(ne===z.scheme)return z}}var ae;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.KEYBOARD=1]="KEYBOARD",Q[Q.MOUSE=2]="MOUSE"})(ae||(e.EditorCloseMethod=ae={}));function Ee(Q,z,ne,Ce){if(!Q.isSticky(z))return!1;switch(Ce.preventPinnedEditorClose){case"keyboardAndMouse":return ne===ae.MOUSE||ne===ae.KEYBOARD;case"mouse":return ne===ae.MOUSE;case"keyboard":return ne===ae.KEYBOARD}return!1}e.EditorResourceAccessor=new q;var ce;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class Z{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(z){const ne=this.instantiationService=z.get(A.IInstantiationService);for(const[Ce,fe]of this.editorSerializerConstructors)this.createEditorSerializer(Ce,fe,ne);this.editorSerializerConstructors.clear()}createEditorSerializer(z,ne,Ce){const fe=Ce.createInstance(ne);this.editorSerializerInstances.set(z,fe)}registerFileEditorFactory(z){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=z}getFileEditorFactory(){return(0,k.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(z,ne){if(this.editorSerializerConstructors.has(z)||this.editorSerializerInstances.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.instantiationService?this.createEditorSerializer(z,ne,this.instantiationService):this.editorSerializerConstructors.set(z,ne),(0,O.toDisposable)(()=>{this.editorSerializerConstructors.delete(z),this.editorSerializerInstances.delete(z)})}getEditorSerializer(z){return this.editorSerializerInstances.get(typeof z=="string"?z:z.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new Z);async function le(Q,z,ne){return!Q||!Q.length?[]:await Promise.all(Q.map(async Ce=>{const fe=P.URI.revive(Ce.fileUri);if(!fe){ne.info("Cannot resolve the path because it is not valid.",Ce);return}if(!await z.canHandleResource(fe)){ne.info("Cannot resolve the path because it cannot be handled",Ce);return}let de=Ce.exists,X=Ce.type;if(typeof de!="boolean"||typeof X!="number")try{X=(await z.stat(fe)).isDirectory?p.FileType.Directory:p.FileType.Unknown,de=!0}catch(ve){ne.error(ve),de=!1}if(!de&&Ce.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",Ce);return}if(X===p.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",Ce);return}const J={...Ce.options,pinned:!0};return de?{resource:fe,options:J}:{resource:fe,options:J,forceUntitled:!0}}))}var me;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(me||(e.EditorsOrder=me={}));function oe(Q){const z=Q;if(!z)return!1;const ne=z;if(ne.modified)return oe(ne.modified);const Ce=z;return!!(Ce.contributionsState&&Ce.viewState&&Array.isArray(Ce.cursorState))}function De(Q){return(0,I.isErrorWithActions)(Q)}function Re(Q,z,ne){const Ce=(0,I.createErrorWithActions)(Q,z);return Ce.forceMessage=ne?.forceMessage,Ce.forceSeverity=ne?.forceSeverity,Ce.allowDialog=ne?.allowDialog,Ce}}),define(Le[192],Ne([1,0,6,9,3,4,28,30,25,97,182]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=y,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,k.localize)(12314,null),e.defaultViewIcon=(0,I.registerIcon)("default-view-icon",o.Codicon.window,(0,k.localize)(12315,null));var w;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var a;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(a||(e.ViewContainerLocation=a={})),e.ViewContainerLocations=[a.Sidebar,a.Panel,a.AuxiliaryBar];function y(g){switch(g){case a.Sidebar:return"sidebar";case a.Panel:return"panel";case a.AuxiliaryBar:return"auxiliarybar"}}class h extends O.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new S.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new S.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return[...this.viewContainers.values()].flat()}registerViewContainer(u,v,m){const d=this.get(u.id);if(d)return d;const C=u;return C.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,A.getOrSet)(this.viewContainers,v,[]).push(C),m?.isDefault&&this.defaultViewContainers.push(C),this._onDidRegister.fire({viewContainer:C,viewContainerLocation:v}),C}deregisterViewContainer(u){for(const v of this.viewContainers.keys()){const m=this.viewContainers.get(v),d=m?.indexOf(u);if(d!==-1){m?.splice(d,1),m.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:u,viewContainerLocation:v});return}}}get(u){return this.all.filter(v=>v.id===u)[0]}getViewContainers(u){return[...this.viewContainers.get(u)||[]]}getViewContainerLocation(u){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===u)}}R.Registry.add(w.ViewContainersRegistry,new h);var r;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(r||(e.ViewContentGroups=r={}));function s(g,u){const v=g.group??r.More,m=u.group??r.More;return v!==m?v.localeCompare(m):(g.order??5)-(u.order??5)}class l extends O.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new S.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new S.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new S.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new S.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(u,v){this.registerViews2([{views:u,viewContainer:v}])}registerViews2(u){u.forEach(({views:v,viewContainer:m})=>this.addViews(v,m)),this._onViewsRegistered.fire(u)}deregisterViews(u,v){const m=this.removeViews(u,v);m.length&&this._onViewsDeregistered.fire({views:m,viewContainer:v})}moveViews(u,v){for(const m of this._views.keys())if(m!==v){const d=this.removeViews(u,m);d.length&&(this.addViews(d,v),this._onDidChangeContainer.fire({views:d,from:m,to:v}))}}getViews(u){return this._views.get(u)||[]}getView(u){for(const v of this._viewContainers){const m=(this._views.get(v)||[]).filter(d=>d.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(d=>d.id===u)[0])return v;return null}registerViewWelcomeContent(u,v){return this._viewWelcomeContents.add(u,v),this._onDidChangeViewWelcomeContent.fire(u),(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(u,v),this._onDidChangeViewWelcomeContent.fire(u)})}registerViewWelcomeContent2(u,v){const m=new Map;for(const[d,C]of v)this._viewWelcomeContents.add(u,C),m.set(d,(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(u,C),this._onDidChangeViewWelcomeContent.fire(u)}));return this._onDidChangeViewWelcomeContent.fire(u),m}getViewWelcomeContent(u){const v=[];return this._viewWelcomeContents.forEach(u,m=>v.push(m)),v.sort(s)}addViews(u,v){let m=this._views.get(v);m||(m=[],this._views.set(v,m),this._viewContainers.push(v));for(const d of u){if(this.getView(d.id)!==null)throw new Error((0,k.localize)(12316,null,d.id));m.push(d)}}removeViews(u,v){const m=this._views.get(v);if(!m)return[];const d=[],C=[];for(const _ of m)u.includes(_)?d.push(_):C.push(_);return d.length&&(C.length?this._views.set(v,C):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),d}}R.Registry.add(w.ViewsRegistry,new l),e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var c;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var i;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(u,v){this.resolved=!1,this._hasResolve=!1,(0,p.mixin)(this,u),this._hasResolve=!!v,this.resolve=async m=>{if(v&&!this.resolved){const d=await v(m);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}m.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class t extends Error{constructor(u){super((0,k.localize)(12317,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(Le[193],Ne([1,0,9,31]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_IN_QUICK_CHAT=e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new k.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,S.localize)(8434,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new k.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,S.localize)(8435,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new k.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,S.localize)(8436,null)}),e.CONTEXT_RESPONSE_FILTERED=new k.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,S.localize)(8437,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new k.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,S.localize)(8438,null)}),e.CONTEXT_RESPONSE=new k.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,S.localize)(8439,null)}),e.CONTEXT_REQUEST=new k.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,S.localize)(8440,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new k.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,S.localize)(8441,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new k.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,S.localize)(8442,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new k.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,S.localize)(8443,null)}),e.CONTEXT_IN_CHAT_INPUT=new k.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,S.localize)(8444,null)}),e.CONTEXT_IN_CHAT_SESSION=new k.RawContextKey("inChat",!1,{type:"boolean",description:(0,S.localize)(8445,null)}),e.CONTEXT_CHAT_ENABLED=new k.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,S.localize)(8446,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new k.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new k.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new k.RawContextKey("chatLocation",void 0),e.CONTEXT_IN_QUICK_CHAT=new k.RawContextKey("quickChatHasFocus",!1,{type:"boolean",description:(0,S.localize)(8447,null)})}),define(Le[115],Ne([1,0,283,10,21,6,40,4,36,143,12,31,18,3,11,108,176,187,193]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0,e.getFullyQualifiedId=v,e.reviveSerializedAgent=m;var n;(function(d){d.Panel="panel",d.Terminal="terminal",d.Notebook="notebook",d.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(d){function C(_){switch(_){case"panel":return d.Panel;case"terminal":return d.Terminal;case"notebook":return d.Notebook;case"editor":return d.Editor}return d.Panel}d.fromRaw=C}(n||(e.ChatAgentLocation=n={})),e.IChatAgentService=(0,y.createDecorator)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(C){this.contextKeyService=C,this._agents=new Map,this._onDidChangeAgents=new O.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._agentCompletionProviders=new Map,this._hasDefaultAgent=c.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService)}registerAgent(C,_){if(this.getAgent(C))throw new Error(`Agent already registered: ${JSON.stringify(C)}`);const T=this,D=_.slashCommands;_={..._,get slashCommands(){return D.filter(b=>!b.when||T.contextKeyService.contextMatchesRules(w.ContextKeyExpr.deserialize(b.when)))}};const f={data:_};return this._agents.set(C,f),(0,R.toDisposable)(()=>{this._agents.delete(C),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(C,_){const E=this._agents.get(C);if(!E)throw new Error(`Unknown agent: ${JSON.stringify(C)}`);if(E.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(C)}`);return E.data.isDefault&&this._hasDefaultAgent.set(!0),E.impl=_,this._onDidChangeAgents.fire(new g(E.data,_)),(0,R.toDisposable)(()=>{E.impl=void 0,this._onDidChangeAgents.fire(void 0),E.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(C,_){C.isDynamic=!0;const E={data:C,impl:_};return this._agents.set(C.id,E),this._onDidChangeAgents.fire(new g(C,_)),(0,R.toDisposable)(()=>{this._agents.delete(C.id),this._onDidChangeAgents.fire(void 0)})}registerAgentCompletionProvider(C,_){return this._agentCompletionProviders.set(C,_),{dispose:()=>{this._agentCompletionProviders.delete(C)}}}async getAgentCompletionItems(C,_,E){return await this._agentCompletionProviders.get(C)?.(_,E)??[]}updateAgent(C,_){const E=this._agents.get(C);if(!E?.impl)throw new Error(`No activated agent with id ${JSON.stringify(C)} registered`);E.data.metadata={...E.data.metadata,..._},this._onDidChangeAgents.fire(new g(E.data,E.impl))}getDefaultAgent(C){return(0,S.findLast)(this.getActivatedAgents(),_=>!!_.isDefault&&_.locations.includes(C))}getContributedDefaultAgent(C){return this.getAgents().find(_=>!!_.isDefault&&_.locations.includes(C))}getSecondaryAgent(){return A.Iterable.find(this._agents.values(),C=>!!C.data.metadata.isSecondary)?.data}getAgent(C){if(this._agentIsEnabled(C))return this._agents.get(C)?.data}_agentIsEnabled(C){const _=this._agents.get(C);return!_?.data.when||this.contextKeyService.contextMatchesRules(w.ContextKeyExpr.deserialize(_.data.when))}getAgentByFullyQualifiedId(C){const _=A.Iterable.find(this._agents.values(),E=>v(E.data)===C)?.data;if(!(_&&!this._agentIsEnabled(_.id)))return _}getAgents(){return Array.from(this._agents.values()).map(C=>C.data).filter(C=>this._agentIsEnabled(C.id))}getActivatedAgents(){return Array.from(this._agents.values()).filter(C=>!!C.impl).filter(C=>this._agentIsEnabled(C.data.id)).map(C=>new g(C.data,C.impl))}getAgentsByName(C){return this.getAgents().filter(_=>_.name===C)}agentHasDupeName(C){const _=this.getAgent(C);return _?this.getAgentsByName(_.name).filter(E=>E.extensionId.value!==_.extensionId.value).length>0:!1}async invokeAgent(C,_,E,T,D){const f=this._agents.get(C);if(!f?.impl)throw new Error(`No activated agent with id "${C}"`);return await f.impl.invoke(_,E,T,D)}async getFollowups(C,_,E,T,D){const f=this._agents.get(C);if(!f?.impl)throw new Error(`No activated agent with id "${C}"`);return f.impl?.provideFollowups?f.impl.provideFollowups(_,E,T,D):[]}};e.ChatAgentService=t,e.ChatAgentService=t=Ge([Ve(0,w.IContextKeyService)],t);class g{constructor(C,_){this.data=C,this.impl=_}get id(){return this.data.id}get name(){return this.data.name??""}get fullName(){return this.data.fullName??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.publisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get locations(){return this.data.locations}async invoke(C,_,E,T){return this.impl.invoke(C,_,E,T)}async provideFollowups(C,_,E,T){return this.impl.provideFollowups?this.impl.provideFollowups(C,_,E,T):[]}provideWelcomeMessage(C,_){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(C,_)}provideSampleQuestions(C,_){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(C,_)}}e.MergedChatAgent=g,e.IChatAgentNameService=(0,y.createDecorator)("chatAgentNameService");let u=class{static{i=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(C,_,E,T){if(this.requestService=_,this.logService=E,this.storageService=T,this.registry=(0,o.observableValue)(this,Object.create(null)),this.disposed=!1,!C.chatParticipantRegistry)return;this.url=C.chatParticipantRegistry;const D=T.get(i.StorageKey,l.StorageScope.APPLICATION);try{this.registry.set(JSON.parse(D??"{}"),void 0)}catch{T.remove(i.StorageKey,l.StorageScope.APPLICATION)}this.refresh()}refresh(){this.disposed||this.update().catch(C=>this.logService.warn("Failed to fetch chat participant registry",C)).then(()=>(0,k.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const C=await this.requestService.request({type:"GET",url:this.url},P.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,s.asJson)(C);if(!_||_.version!==1)throw new Error("Unexpected chat participant registry response.");const E=_.restrictedChatParticipants;this.registry.set(E,void 0),this.storageService.store(i.StorageKey,JSON.stringify(E),l.StorageScope.APPLICATION,l.StorageTarget.MACHINE)}getAgentNameRestriction(C){const _=this.checkAgentNameRestriction(C.name,C).get(),E=!C.fullName||this.checkAgentNameRestriction(C.fullName.replace(/\s/g,""),C).get();return _&&E}checkAgentNameRestriction(C,_){return this.registry.map(T=>T[C.toLowerCase()]).map(T=>T?T.some(D=>(0,I.equalsIgnoreCase)(D,D.includes(".")?_.extensionId.value:_.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=u,e.ChatAgentNameService=u=i=Ge([Ve(0,r.IProductService),Ve(1,s.IRequestService),Ve(2,h.ILogService),Ve(3,l.IStorageService)],u);function v(d){return`${d.extensionId.value}.${d.id}`}function m(d){const C="name"in d?d:{...d,name:d.id};return"extensionPublisherId"in C||(C.extensionPublisherId=C.extensionPublisher??""),"extensionDisplayName"in C||(C.extensionDisplayName=""),"extensionId"in C||(C.extensionId=new a.ExtensionIdentifier("")),(0,p.revive)(C)}}),define(Le[194],Ne([1,0,2,32,3]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.isIDocumentContext=O,e.isIUsedContext=A;function O(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof S.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(k.Range.isIRange)}function A(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(O)}var R;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(R||(e.ChatResponseReferencePartStatusKind=R={}));var p;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(p||(e.ChatAgentVoteDirection=p={}));var o;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(o||(e.ChatCopyKind=o={})),e.IChatService=(0,P.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(Le[195],Ne([1,0,6,10,9]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class O{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new S.Emitter,this._onExit=new S.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(R){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=R}onEvent(R){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=R}onRequest(R){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=R}sendResponse(R){R.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.internalSend("response",R)}sendRequest(R,p,o,I){const w={command:R};if(p&&Object.keys(p).length>0&&(w.arguments=p),this.internalSend("request",w),typeof I=="number"){const a=setTimeout(()=>{clearTimeout(a);const y=this.pendingRequests.get(w.seq);if(y){this.pendingRequests.delete(w.seq);const h={type:"response",seq:0,request_seq:w.seq,success:!1,command:R,message:(0,P.localize)(8147,null,I,R)};y(h)}},I)}return o&&this.pendingRequests.set(w.seq,o),w.seq}acceptMessage(R){this.messageCallback?this.messageCallback(R):(this.queue.push(R),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(R,p){return R.type!=="event"||p.type!=="event"}async processQueue(){let R;for(;this.queue.length;){if((!R||this.needsTaskBoundaryBetween(this.queue[0],R))&&await(0,k.timeout)(0),R=this.queue.shift(),!R)return;switch(R.type){case"event":this.eventCallback?.(R);break;case"request":this.requestCallback?.(R);break;case"response":{const p=R,o=this.pendingRequests.get(p.request_seq);o&&(this.pendingRequests.delete(p.request_seq),o(p));break}}}}internalSend(R,p){p.type=R,p.seq=this.sequence++,this.sendMessage(p)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const R=new Map;this.pendingRequests.forEach((p,o)=>R.set(o,p)),await(0,k.timeout)(500),R.forEach((p,o)=>{p({type:"response",seq:0,request_seq:o,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(o)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=O}),define(Le[80],Ne([1,0,2,9,31,3]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=p,e.isFrameDeemphasized=I,k=We(k),e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new P.RawContextKey("debugType",void 0,{type:"string",description:k.localize(8084,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new P.RawContextKey("debugConfigurationType",void 0,{type:"string",description:k.localize(8085,null)}),e.CONTEXT_DEBUG_STATE=new P.RawContextKey("debugState","inactive",{type:"string",description:k.localize(8086,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new P.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:k.localize(8087,null)}),e.CONTEXT_HAS_DEBUGGED=new P.RawContextKey("hasDebugged",!1,{type:"boolean",description:k.localize(8088,null)}),e.CONTEXT_IN_DEBUG_MODE=new P.RawContextKey("inDebugMode",!1,{type:"boolean",description:k.localize(8089,null)}),e.CONTEXT_IN_DEBUG_REPL=new P.RawContextKey("inDebugRepl",!1,{type:"boolean",description:k.localize(8090,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new P.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:k.localize(8091,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new P.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:k.localize(8092,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new P.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:k.localize(8093,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new P.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:k.localize(8094,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new P.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:k.localize(8095,null)}),e.CONTEXT_VARIABLES_FOCUSED=new P.RawContextKey("variablesFocused",!0,{type:"boolean",description:k.localize(8096,null)}),e.CONTEXT_EXPRESSION_SELECTED=new P.RawContextKey("expressionSelected",!1,{type:"boolean",description:k.localize(8097,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new P.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:k.localize(8098,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new P.RawContextKey("callStackItemType",void 0,{type:"string",description:k.localize(8099,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new P.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:k.localize(8100,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new P.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:k.localize(8101,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new P.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:k.localize(8102,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new P.RawContextKey("watchItemType",void 0,{type:"string",description:k.localize(8103,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new P.RawContextKey("canViewMemory",void 0,{type:"boolean",description:k.localize(8104,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new P.RawContextKey("breakpointItemType",void 0,{type:"string",description:k.localize(8105,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new P.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:k.localize(8106,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new P.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:k.localize(8107,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new P.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:k.localize(8108,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new P.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:k.localize(8109,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new P.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:k.localize(8110,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new P.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:k.localize(8111,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new P.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:k.localize(8112,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new P.RawContextKey("stepBackSupported",!1,{type:"boolean",description:k.localize(8113,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new P.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:k.localize(8114,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new P.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:k.localize(8115,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new P.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:k.localize(8116,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new P.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:k.localize(8117,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new P.RawContextKey("breakpointsExist",!1,{type:"boolean",description:k.localize(8118,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new P.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:k.localize(8119,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new P.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:k.localize(8120,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new P.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:k.localize(8121,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new P.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:k.localize(8122,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new P.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:k.localize(8123,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new P.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:k.localize(8124,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new P.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:k.localize(8125,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new P.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:k.localize(8126,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new P.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:k.localize(8127,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new P.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:k.localize(8128,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new P.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:k.localize(8129,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new P.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:k.localize(8130,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new P.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:k.localize(8131,null)}),e.CONTEXT_VARIABLE_VALUE=new P.RawContextKey("variableValue",!1,{type:"string",description:k.localize(8132,null)}),e.CONTEXT_VARIABLE_TYPE=new P.RawContextKey("variableType",!1,{type:"string",description:k.localize(8133,null)}),e.CONTEXT_VARIABLE_INTERFACES=new P.RawContextKey("variableInterfaces",!1,{type:"array",description:k.localize(8134,null)}),e.CONTEXT_VARIABLE_NAME=new P.RawContextKey("variableName",!1,{type:"string",description:k.localize(8135,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new P.RawContextKey("variableLanguage",!1,{type:"string",description:k.localize(8136,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new P.RawContextKey("variableExtensionId",!1,{type:"string",description:k.localize(8137,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new P.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:k.localize(8138,null)}),e.CONTEXT_MULTI_SESSION_REPL=new P.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:k.localize(8139,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new P.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:k.localize(8140,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new P.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:k.localize(8141,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new P.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:k.localize(8142,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new P.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:k.localize(8143,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new P.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:k.localize(8144,null)});const A=i=>k.localize(8145,null,i);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:k.localize(8146,null)};var R;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(R||(e.State=R={}));function p(i){switch(i){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var o;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(o||(e.MemoryRangeType=o={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function I(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var w;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(w||(e.DataBreakpointSetType=w={}));var a;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(a||(e.DebugConfigurationProviderTriggerKind=a={}));var y;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(y||(e.DebuggerString=y={})),e.IDebugService=(0,O.createDecorator)("debugService");var h;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(h||(e.BreakpointWidgetContext=h={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var l;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(l||(e.IDebugVisualizationTreeItem=l={}));var c;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:S.URI.revive(n.iconPath.light),dark:S.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(c||(e.IDebugVisualization=c={}))}),define(Le[196],Ne([1,0,12,2,19,25,15,32,21,17]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=w,e.filterExceptionsFromTelemetry=a,e.isSessionAttach=y,e.getExtensionHostDebugSession=h,e.isDebuggerMainContribution=r,e.getExactExpressionStartAndEnd=s,e.getEvaluatableExpressionAtPosition=l,e.isUri=i,e.convertToDAPaths=g,e.convertToVSCPaths=u,e.getVisibleAndSorted=m,e.saveAllBeforeDebugStart=C;const I=/{([^}]+)}/g;function w(E,T,D){return E.replace(I,function(f,b){return T&&b.length>0&&b[0]!=="_"?f:D&&D.hasOwnProperty(b)?D[b]:f})}function a(E){const T={};for(const D of Object.keys(E))D.startsWith("!")||(T[D]=E[D]);return T}function y(E){return E.configuration.request==="attach"&&!h(E)&&(!E.parentSession||y(E.parentSession))}function h(E){let T=E.configuration.type;if(T)return T==="vslsShare"&&(T=E.configuration.adapterProxy.configuration.type),(0,S.equalsIgnoreCase)(T,"extensionhost")||(0,S.equalsIgnoreCase)(T,"pwa-extensionhost")?E:E.parentSession?h(E.parentSession):void 0}function r(E){return E.type&&(E.label||E.program||E.runtime)}function s(E,T,D){let f,b=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let L=null;for(;L=M.exec(E);){const N=L.index+1,W=N+L[0].length;if(N<=T&&W>=D){f=L[0],b=N;break}}if(f){const N=/(\w|\p{L})+/gu;let W=null;for(;(W=N.exec(f))&&!(W.index+1+b+W[0].length>=D););W&&(f=f.substring(0,N.lastIndex))}return f?{start:b,end:b+f.length-1}:{start:0,end:0}}async function l(E,T,D,f){if(E.evaluatableExpressionProvider.has(T)){const b=E.evaluatableExpressionProvider.ordered(T),M=(0,o.coalesce)(await Promise.all(b.map(async L=>{try{return await L.provideEvaluatableExpression(T,D,f??p.CancellationToken.None)}catch{return}})));if(M.length>0){let L=M[0].expression;const N=M[0].range;return L||(L=T.getLineContent(D.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:L}}}else{const b=T.getLineContent(D.lineNumber),{start:M,end:L}=s(b,D.column,D.column),N=b.substring(M-1,L);return{matchingExpression:N,range:new R.Range(D.lineNumber,M,D.lineNumber,M+N.length)}}return null}const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(E){return!!(E&&E.match(c))}function n(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(i(E.path))return k.URI.parse(E.path);if((0,P.isAbsolute)(E.path))return k.URI.file(E.path)}return E.path}function t(E){if(typeof E.path=="object"){const T=k.URI.revive(E.path);if(T)return T.scheme===A.Schemas.file?T.fsPath:T.toString()}return E.path}function g(E,T){const D=T?n:t,f=(0,O.deepClone)(E);return v(f,(b,M)=>{b&&M&&(M.path=D(M))}),f}function u(E,T){const D=T?n:t,f=(0,O.deepClone)(E);return v(f,(b,M)=>{!b&&M&&(M.path=D(M))}),f}function v(E,T){switch(E.type){case"event":{const D=E;switch(D.event){case"output":T(!1,D.body.source);break;case"loadedSource":T(!1,D.body.source);break;case"breakpoint":T(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=E;switch(D.command){case"setBreakpoints":T(!0,D.arguments.source);break;case"breakpointLocations":T(!0,D.arguments.source);break;case"source":T(!0,D.arguments.source);break;case"gotoTargets":T(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(f=>T(!1,f));break;default:break}break}case"response":{const D=E;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(f=>T(!1,f.source));break;case"loadedSources":D.body.sources.forEach(f=>T(!1,f));break;case"scopes":D.body.scopes.forEach(f=>T(!1,f.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(f=>T(!1,f.source));break;case"setBreakpoints":D.body.breakpoints.forEach(f=>T(!1,f.source));break;case"disassemble":D.body?.instructions.forEach(b=>T(!1,b.location));break;default:break}break}}}function m(E){return E.filter(T=>!T.presentation?.hidden).sort((T,D)=>T.presentation?D.presentation?T.presentation.group?D.presentation.group?T.presentation.group!==D.presentation.group?T.presentation.group.localeCompare(D.presentation.group):d(T.presentation.order,D.presentation.order):-1:D.presentation.group?1:d(T.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function d(E,T){return typeof E!="number"?typeof T!="number"?0:1:typeof T!="number"?-1:E-T}async function C(E,T){const D=E.getValue("debug.saveBeforeStart",{overrideIdentifier:T.activeTextEditorLanguageId});if(D!=="none"&&(await T.saveAll(),D==="allEditorsInActiveGroup")){const f=T.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await T.save({editor:f.input,groupId:f.group.id})}await E.reloadConfiguration()}const _=(E,T)=>!E||!T?E===T:E.name===T.name&&E.path===T.path&&E.sourceReference===T.sourceReference;e.sourcesEqual=_}),define(Le[197],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(k||(e.CellExecutionUpdateType=k={})),e.INotebookExecutionService=(0,S.createDecorator)("INotebookExecutionService")}),define(Le[198],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var k;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(k||(e.ProxyKernelState=k={})),e.INotebookKernelService=(0,S.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,S.createDecorator)("INotebookKernelHistoryService")}),define(Le[199],Ne([1,0,4,32,52,162,102]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class R extends S.Disposable{constructor(o,I,w){super(),this._source=o,this._inputTextBuffer=I,this._outputs=w,this._outputTextBuffers=void 0}_getFullModelRange(o){const I=o.getLineCount();return new k.Range(1,1,I,this._getLineMaxColumn(o,I))}_getLineMaxColumn(o,I){if(I<1||I>o.getLineCount())throw new Error("Illegal value for lineNumber");return o.getLineLength(I)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const o=new O.PieceTreeTextBufferBuilder;o.acceptChunk(this._source);const I=o.finish(!0),{textBuffer:w,disposable:a}=I.create(P.DefaultEndOfLine.LF);this._inputTextBuffer=w,this._register(a)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(o=>{const I=new O.PieceTreeTextBufferBuilder;I.acceptChunk(o);const w=I.finish(!0),{textBuffer:a,disposable:y}=w.create(P.DefaultEndOfLine.LF);return this._register(y),a})),this._outputTextBuffers}findInInputs(o){const w=new A.SearchParams(o,!1,!1,null).parseSearchRequest();if(!w)return[];const a=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(a,w,!0,5e3)}findInOutputs(o){const w=new A.SearchParams(o,!1,!1,null).parseSearchRequest();return w?this.outputTextBuffers.map(a=>{const y=a.findMatchesLineByLine(this._getFullModelRange(a),w,!0,5e3);if(y.length!==0)return{textBuffer:a,matches:y}}).filter(a=>!!a):[]}}e.CellSearchModel=R}),define(Le[54],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(O){O.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var k;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(k||(e.TestPosition=k={}));class P{static fromExtHostTestItem(A,R,p=A.parent){if(A._isRoot)return new P([R]);const o=[A.id];for(let I=p;I&&I.id!==R;I=I.parent)o.push(I.id);return o.push(R),new P(o.reverse())}static isRoot(A){return!A.includes(S.Delimiter)}static root(A){const R=A.indexOf(S.Delimiter);return R===-1?A:A.slice(0,R)}static fromString(A){return new P(A.split(S.Delimiter))}static join(A,R){return new P([...A.path,R])}static joinToString(A,R){return A.toString()+S.Delimiter+R}static parentId(A){const R=A.lastIndexOf(S.Delimiter);return R===-1?void 0:A.slice(0,R)}static localId(A){const R=A.lastIndexOf(S.Delimiter);return R===-1?A:A.slice(R+S.Delimiter.length)}static isChild(A,R){return R[A.length]===S.Delimiter&&R.startsWith(A)}static compare(A,R){return A===R?k.IsSame:P.isChild(A,R)?k.IsChild:P.isChild(R,A)?k.IsParent:k.Disconnected}static getLengthOfCommonPrefix(A,R){if(A===0)return 0;let p=0;for(;p<A-1;){for(let o=1;o<A;o++){const I=R(o-1),w=R(o);if(I.path[p]!==w.path[p])return p}p++}return p}constructor(A,R=A.length){if(this.path=A,this.viewEnd=R,A.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.viewEnd>1?new P(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let R=0;R<A.viewEnd&&R<this.viewEnd;R++)if(A.path[R]!==this.path[R])return k.Disconnected;return A.viewEnd>this.viewEnd?k.IsChild:A.viewEnd<this.viewEnd?k.IsParent:k.IsSame}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+=S.Delimiter,this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=P}),define(Le[55],Ne([1,0,2,101,32,54]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var A;(function(K){K[K.Unset=0]="Unset",K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.testResultStateToContextValues={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var R;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var p;(function(K){K[K.Refresh=2]="Refresh",K[K.CodeRelatedToTest=4]="CodeRelatedToTest",K[K.TestRelatedToCode=8]="TestRelatedToCode"})(p||(e.TestControllerCapability=p={}));var o;(function(K){K[K.Run=2]="Run",K[K.Debug=4]="Debug",K[K.Coverage=8]="Coverage",K[K.HasNonDefaultProfile=16]="HasNonDefaultProfile",K[K.HasConfigurable=32]="HasConfigurable",K[K.SupportsContinuousRun=64]="SupportsContinuousRun"})(o||(e.TestRunProfileBitset=o={})),e.testRunProfileBitsetList=[o.Run,o.Debug,o.Coverage,o.HasNonDefaultProfile,o.HasConfigurable,o.SupportsContinuousRun];const I=K=>"runId"in K;e.isStartControllerTests=I;var w;(function(K){K.serialize=q=>({range:q.range.toJSON(),uri:q.uri.toJSON()}),K.deserialize=(q,ae)=>({range:P.Range.lift(ae.range),uri:q.asCanonicalUri(S.URI.revive(ae.uri))})})(w||(e.IRichLocation=w={}));var a;(function(K){K[K.Error=0]="Error",K[K.Output=1]="Output"})(a||(e.TestMessageType=a={}));var y;(function(K){K.serialize=q=>({label:q.label,uri:q.uri?.toJSON(),position:q.position?.toJSON()}),K.deserialize=(q,ae)=>({label:ae.label,uri:ae.uri?q.asCanonicalUri(S.URI.revive(ae.uri)):void 0,position:ae.position?k.Position.lift(ae.position):void 0})})(y||(e.ITestMessageStackFrame=y={}));var h;(function(K){K.serialize=q=>({message:q.message,type:a.Error,expected:q.expected,actual:q.actual,contextValue:q.contextValue,location:q.location&&w.serialize(q.location),stackTrace:q.stackTrace?.map(y.serialize)}),K.deserialize=(q,ae)=>({message:ae.message,type:a.Error,expected:ae.expected,actual:ae.actual,contextValue:ae.contextValue,location:ae.location&&w.deserialize(q,ae.location),stackTrace:ae.stackTrace&&ae.stackTrace.map(Ee=>y.deserialize(q,Ee))})})(h||(e.ITestErrorMessage=h={}));const r=(K,q)=>`${q?"s":"e"}${K}`;e.getMarkId=r;var s;(function(K){K.serialize=q=>({message:q.message,type:a.Output,offset:q.offset,length:q.length,location:q.location&&w.serialize(q.location)}),K.deserialize=(q,ae)=>({message:ae.message,type:a.Output,offset:ae.offset,length:ae.length,location:ae.location&&w.deserialize(q,ae.location)})})(s||(e.ITestOutputMessage=s={}));var l;(function(K){K.serialize=q=>q.type===a.Error?h.serialize(q):s.serialize(q),K.deserialize=(q,ae)=>ae.type===a.Error?h.deserialize(q,ae):s.deserialize(q,ae),K.isDiffable=q=>q.type===a.Error&&q.actual!==void 0&&q.expected!==void 0})(l||(e.ITestMessage=l={}));var c;(function(K){K.serializeWithoutMessages=q=>({state:q.state,duration:q.duration,messages:[]}),K.serialize=q=>({state:q.state,duration:q.duration,messages:q.messages.map(l.serialize)}),K.deserialize=(q,ae)=>({state:ae.state,duration:ae.duration,messages:ae.messages.map(Ee=>l.deserialize(q,Ee))})})(c||(e.ITestTaskState=c={}));const i="\0",n=(K,q)=>K+i+q;e.namespaceTestTag=n;const t=K=>{const q=K.indexOf(i);return{ctrlId:K.slice(0,q),tagId:K.slice(q+1)}};e.denamespaceTestTag=t;var g;(function(K){K.serialize=q=>({extId:q.extId,label:q.label,tags:q.tags,busy:q.busy,children:void 0,uri:q.uri?.toJSON(),range:q.range?.toJSON()||null,description:q.description,error:q.error,sortText:q.sortText}),K.deserialize=(q,ae)=>({extId:ae.extId,label:ae.label,tags:ae.tags,busy:ae.busy,children:void 0,uri:ae.uri?q.asCanonicalUri(S.URI.revive(ae.uri)):void 0,range:ae.range?P.Range.lift(ae.range):null,description:ae.description,error:ae.error,sortText:ae.sortText})})(g||(e.ITestItem=g={}));var u;(function(K){K[K.NotExpandable=0]="NotExpandable",K[K.Expandable=1]="Expandable",K[K.BusyExpanding=2]="BusyExpanding",K[K.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var v;(function(K){K.serialize=q=>({expand:q.expand,item:g.serialize(q.item)}),K.deserialize=(q,ae)=>({controllerId:O.TestId.root(ae.item.extId),expand:ae.expand,item:g.deserialize(q,ae.item)})})(v||(e.InternalTestItem=v={}));var m;(function(K){K.serialize=q=>{let ae;return q.item&&(ae={},q.item.label!==void 0&&(ae.label=q.item.label),q.item.tags!==void 0&&(ae.tags=q.item.tags),q.item.busy!==void 0&&(ae.busy=q.item.busy),q.item.uri!==void 0&&(ae.uri=q.item.uri?.toJSON()),q.item.range!==void 0&&(ae.range=q.item.range?.toJSON()),q.item.description!==void 0&&(ae.description=q.item.description),q.item.error!==void 0&&(ae.error=q.item.error),q.item.sortText!==void 0&&(ae.sortText=q.item.sortText)),{extId:q.extId,expand:q.expand,item:ae}},K.deserialize=q=>{let ae;return q.item&&(ae={},q.item.label!==void 0&&(ae.label=q.item.label),q.item.tags!==void 0&&(ae.tags=q.item.tags),q.item.busy!==void 0&&(ae.busy=q.item.busy),q.item.range!==void 0&&(ae.range=q.item.range?P.Range.lift(q.item.range):null),q.item.description!==void 0&&(ae.description=q.item.description),q.item.error!==void 0&&(ae.error=q.item.error),q.item.sortText!==void 0&&(ae.sortText=q.item.sortText)),{extId:q.extId,expand:q.expand,item:ae}}})(m||(e.ITestItemUpdate=m={}));const d=(K,q)=>{q.expand!==void 0&&(K.expand=q.expand),q.item!==void 0&&(K.item=K.item?Object.assign(K.item,q.item):q.item)};e.applyTestItemUpdate=d;var C;(function(K){K.serializeWithoutMessages=q=>({...v.serialize(q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(c.serializeWithoutMessages)}),K.serialize=q=>({...v.serialize(q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(c.serialize)}),K.deserialize=(q,ae)=>({...v.deserialize(q,ae),ownComputedState:ae.ownComputedState,computedState:ae.computedState,tasks:ae.tasks.map(Ee=>c.deserialize(q,Ee)),retired:!0})})(C||(e.TestResultItem=C={}));var _;(function(K){K.empty=()=>({covered:0,total:0}),K.sum=(q,ae)=>{q.covered+=ae.covered,q.total+=ae.total}})(_||(e.ICoverageCount=_={}));var E;(function(K){K.serialize=q=>({id:q.id,statement:q.statement,branch:q.branch,declaration:q.declaration,testIds:q.testIds,uri:q.uri.toJSON()}),K.deserialize=(q,ae)=>({id:ae.id,statement:ae.statement,branch:ae.branch,declaration:ae.declaration,testIds:ae.testIds,uri:q.asCanonicalUri(S.URI.revive(ae.uri))}),K.empty=(q,ae)=>({id:q,uri:ae,statement:_.empty()})})(E||(e.IFileCoverage=E={}));function T(K){return{...K,location:K.location?.toJSON()}}function D(K){return K.location=K.location?k.Position.isIPosition(K.location)?k.Position.lift(K.location):P.Range.lift(K.location):void 0,K}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var f;(function(K){K[K.Declaration=0]="Declaration",K[K.Statement=1]="Statement",K[K.Branch=2]="Branch"})(f||(e.DetailType=f={}));var b;(function(K){K.serialize=q=>q.type===f.Declaration?L.serialize(q):N.serialize(q),K.deserialize=q=>q.type===f.Declaration?L.deserialize(q):N.deserialize(q)})(b||(e.CoverageDetails=b={}));var M;(function(K){K.serialize=T,K.deserialize=D})(M||(e.IBranchCoverage=M={}));var L;(function(K){K.serialize=T,K.deserialize=D})(L||(e.IDeclarationCoverage=L={}));var N;(function(K){K.serialize=q=>({...T(q),branches:q.branches?.map(M.serialize)}),K.deserialize=q=>({...D(q),branches:q.branches?.map(M.deserialize)})})(N||(e.IStatementCoverage=N={}));var W;(function(K){K[K.Add=0]="Add",K[K.Update=1]="Update",K[K.DocumentSynced=2]="DocumentSynced",K[K.Remove=3]="Remove",K[K.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",K[K.Retire=5]="Retire",K[K.AddTag=6]="AddTag",K[K.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var j;(function(K){K.deserialize=(q,ae)=>ae.op===W.Add?{op:ae.op,item:v.deserialize(q,ae.item)}:ae.op===W.Update?{op:ae.op,item:m.deserialize(ae.item)}:ae.op===W.DocumentSynced?{op:ae.op,uri:q.asCanonicalUri(S.URI.revive(ae.uri)),docv:ae.docv}:ae,K.serialize=q=>q.op===W.Add?{op:q.op,item:v.serialize(q.item)}:q.op===W.Update?{op:q.op,item:m.serialize(q.item)}:q})(j||(e.TestsDiffOp=j={}));class ${constructor(q){this.uriIdentity=q,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(q){const ae=this.createChangeCollector();for(const Ee of q)switch(Ee.op){case W.Add:this.add(v.deserialize(this.uriIdentity,Ee.item),ae);break;case W.Update:this.update(m.deserialize(Ee.item),ae);break;case W.Remove:this.remove(Ee.itemId,ae);break;case W.Retire:this.retireTest(Ee.itemId);break;case W.IncrementPendingExtHosts:this.updatePendingRoots(Ee.amount);break;case W.AddTag:this._tags.set(Ee.tag.id,Ee.tag);break;case W.RemoveTag:this._tags.delete(Ee.id);break}ae.complete?.()}add(q,ae){const Ee=O.TestId.parentId(q.item.extId)?.toString();let ce;if(!Ee)ce=this.createItem(q),this.roots.add(ce),this.items.set(q.item.extId,ce);else if(this.items.has(Ee)){const Z=this.items.get(Ee);Z.children.add(q.item.extId),ce=this.createItem(q,Z),this.items.set(q.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(q)}`);return}return ae.add?.(ce),q.expand===u.BusyExpanding&&this.busyControllerCount++,ce}update(q,ae){const Ee=this.items.get(q.extId);if(Ee)return q.expand!==void 0&&(Ee.expand===u.BusyExpanding&&this.busyControllerCount--,q.expand===u.BusyExpanding&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(Ee,q),ae.update?.(Ee),Ee}remove(q,ae){const Ee=this.items.get(q);if(!Ee)return;const ce=O.TestId.parentId(Ee.item.extId)?.toString();ce?this.items.get(ce).children.delete(Ee.item.extId):this.roots.delete(Ee);const Z=[[q]];for(;Z.length;)for(const le of Z.pop()){const me=this.items.get(le);me&&(Z.push(me.children),this.items.delete(le),ae.remove?.(me,me!==Ee),me.expand===u.BusyExpanding&&this.busyControllerCount--)}}retireTest(q){}updatePendingRoots(q){this.pendingRootCount+=q}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=$}),define(Le[200],Ne([1,0,98,9,55]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.testConfigurationGroupNames=e.labelForTestInState=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(w){w.ViewletId="workbench.view.extension.test",w.ExplorerViewId="workbench.view.testing",w.OutputPeekContributionId="editor.contrib.testingOutputPeek",w.DecorationsContributionId="editor.contrib.testingDecorations",w.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",w.CoverageViewId="workbench.view.testCoverage",w.ResultsPanelId="workbench.panel.testResults",w.ResultsViewId="workbench.panel.testResults.view",w.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(w){w.List="list",w.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var R;(function(w){w.ByLocation="location",w.ByStatus="status",w.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const p={[P.TestResultState.Errored]:(0,k.localize)(3187,null),[P.TestResultState.Failed]:(0,k.localize)(3188,null),[P.TestResultState.Passed]:(0,k.localize)(3189,null),[P.TestResultState.Queued]:(0,k.localize)(3190,null),[P.TestResultState.Running]:(0,k.localize)(3191,null),[P.TestResultState.Skipped]:(0,k.localize)(3192,null),[P.TestResultState.Unset]:(0,k.localize)(3193,null)},o=(w,a)=>(0,k.localize)(3194,null,(0,S.stripIcons)(w),p[a]);e.labelForTestInState=o,e.testConfigurationGroupNames={[P.TestRunProfileBitset.Debug]:(0,k.localize)(3195,null),[P.TestRunProfileBitset.Run]:(0,k.localize)(3196,null),[P.TestRunProfileBitset.Coverage]:(0,k.localize)(3197,null)};var I;(function(w){w.CancelTestRefreshAction="testing.cancelTestRefresh",w.CancelTestRunAction="testing.cancelRun",w.ClearTestResultsAction="testing.clearTestResults",w.CollapseAllAction="testing.collapseAll",w.ConfigureTestProfilesAction="testing.configureProfile",w.ContinousRunUsingForTest="testing.continuousRunUsingForTest",w.CoverageAtCursor="testing.coverageAtCursor",w.CoverageByUri="testing.coverage.uri",w.CoverageClear="testing.coverage.close",w.CoverageCurrentFile="testing.coverageCurrentFile",w.CoverageFilterToTest="testing.coverageFilterToTest",w.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",w.CoverageLastRun="testing.coverageLastRun",w.CoverageSelectedAction="testing.coverageSelected",w.CoverageToggleToolbar="testing.coverageToggleToolbar",w.CoverageViewChangeSorting="testing.coverageViewChangeSorting",w.DebugAction="testing.debug",w.DebugAllAction="testing.debugAll",w.DebugAtCursor="testing.debugAtCursor",w.DebugByUri="testing.debug.uri",w.DebugCurrentFile="testing.debugCurrentFile",w.DebugFailedTests="testing.debugFailTests",w.DebugLastRun="testing.debugLastRun",w.DebugSelectedAction="testing.debugSelected",w.FilterAction="workbench.actions.treeView.testExplorer.filter",w.GetExplorerSelection="_testing.getExplorerSelection",w.GetSelectedProfiles="testing.getSelectedProfiles",w.GoToTest="testing.editFocusedTest",w.GoToRelatedTest="testing.goToRelatedTest",w.PeekRelatedTest="testing.peekRelatedTest",w.GoToRelatedCode="testing.goToRelatedCode",w.PeekRelatedCode="testing.peekRelatedCode",w.HideTestAction="testing.hideTest",w.OpenCoverage="testing.openCoverage",w.OpenOutputPeek="testing.openOutputPeek",w.RefreshTestsAction="testing.refreshTests",w.ReRunFailedTests="testing.reRunFailTests",w.ReRunLastRun="testing.reRunLastRun",w.RunAction="testing.run",w.RunAllAction="testing.runAll",w.RunAllWithCoverageAction="testing.coverageAll",w.RunAtCursor="testing.runAtCursor",w.RunByUri="testing.run.uri",w.RunCurrentFile="testing.runCurrentFile",w.RunSelectedAction="testing.runSelected",w.RunUsingProfileAction="testing.runUsing",w.RunWithCoverageAction="testing.coverage",w.SearchForTestExtension="testing.searchForTestExtension",w.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",w.ShowMostRecentOutputAction="testing.showMostRecentOutput",w.StartContinousRun="testing.startContinuousRun",w.StopContinousRun="testing.stopContinuousRun",w.TestingSortByDurationAction="testing.sortByDuration",w.TestingSortByLocationAction="testing.sortByLocation",w.TestingSortByStatusAction="testing.sortByStatus",w.TestingViewAsListAction="testing.viewAsList",w.TestingViewAsTreeAction="testing.viewAsTree",w.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",w.ToggleInlineTestOutput="testing.toggleInlineTestOutput",w.UnhideAllTestsAction="testing.unhideAllTests",w.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Le[81],Ne([1,0,10,6,4,61,55,54]),function(Se,e,S,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var p;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const o=(c,i)=>c===i,w=Object.entries({range:(c,i)=>c===i?!0:!c||!i?!1:c.equalsRange(i),busy:o,label:o,description:o,error:o,sortText:o,tags:(c,i)=>!(c.length!==i.length||c.some(n=>!i.includes(n)))}),a=(c,i)=>{let n;for(const[t,g]of w)g(c[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class y extends P.Disposable{get root(){return this.options.root}constructor(i){super(),this.options=i,this.debounceSendDiff=this._register(new S.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new k.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const n of this.tree.values())this.updateExpandability(n)}get resolveHandler(){return this._resolveHandler}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const n of this.diff)if(n.op===A.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const n=this.diff[this.diff.length-1];if(n){if(n.op===A.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,A.applyTestItemUpdate)(n.item,i.item);return}if(n.op===A.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,A.applyTestItemUpdate)(n.item,i.item);return}}break}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===A.TestItemExpandState.Expandable){const g=this.resolveChildren(t);return g.isOpen()?this.expandChildren(t,n-1):g.wait().then(()=>this.expandChildren(t,n-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.expandChildren(t,n-1)):this.expandChildren(t,n-1)}}dispose(){for(const i of this.tree.values())this.options.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,n){switch(n.op){case p.RemoveChild:this.removeItem(R.TestId.joinToString(i.fullId,n.id));break;case p.Upsert:this.upsertItem(n.item,i);break;case p.Bulk:for(const t of n.ops)this.onTestItemEvent(i,t);break;case p.SetTags:this.diffTagRefs(n.new,n.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.updateExpandability(i);break;case p.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case p.DocumentSynced:this.documentSynced(i.actual.uri);break;default:(0,O.assertNever)(n)}}documentSynced(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.options.getDocumentVersion(i)})}upsertItem(i,n){const t=R.TestId.fromExtHostTestItem(i,this.root.id,n?.actual),g=this.options.getApiFor(i);g.parent&&g.parent!==n?.actual&&this.options.getChildren(g.parent).delete(i.id);let u=this.tree.get(t.toString());if(!u){u={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(u.fullId.toString(),u),this.setItemParent(i,n),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.options.controllerId,expand:u.expand,item:this.options.toITestItem(i)}}),this.connectItemAndChildren(i,u,n);return}if(u.actual===i){this.connectItem(i,u,n);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.removeItem(t.toString()),this.upsertItem(i,n);const v=this.options.getChildren(u.actual),m=u.actual,d=a(this.options.toITestItem(m),this.options.toITestItem(i));this.options.getApiFor(m).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=A.TestItemExpandState.NotExpandable,d&&(d.hasOwnProperty("tags")&&(this.diffTagRefs(i.tags,m.tags,t.toString()),delete d.tags),this.onTestItemEvent(u,{op:p.SetProp,update:d})),this.connectItemAndChildren(i,u,n);for(const[_,E]of v)this.options.getChildren(i).get(E.id)||this.removeItem(R.TestId.joinToString(t,E.id));const C=u.expandLevels;C!==void 0&&queueMicrotask(()=>{u.expand===A.TestItemExpandState.Expandable&&(u.expandLevels=void 0,this.expand(t.toString(),C))}),this.documentSynced(u.actual.uri)}diffTagRefs(i,n,t){const g=new Set(n.map(u=>u.id));for(const u of i)g.delete(u.id)||this.incrementTagRefs(u);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(u=>(0,A.namespaceTestTag)(this.options.controllerId,u.id))}}}),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const n=this.tags.get(i.id);n?n.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,i.id)}}))}decrementTagRefs(i){const n=this.tags.get(i);n&&!--n.refCount&&(this.tags.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.namespaceTestTag)(this.options.controllerId,i)}))}setItemParent(i,n){this.options.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}connectItem(i,n,t){this.setItemParent(i,t);const g=this.options.getApiFor(i);g.parent=t?.actual,g.listener=u=>this.onTestItemEvent(n,u),this.updateExpandability(n)}connectItemAndChildren(i,n,t){this.connectItem(i,n,t);for(const[g,u]of this.options.getChildren(i))this.upsertItem(u,n)}updateExpandability(i){let n;this._resolveHandler?i.resolveBarrier?n=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:n=A.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,n){if(n<0)return;const t=[];for(const[g,u]of this.options.getChildren(i.actual)){const v=this.expand(R.TestId.joinToString(i.fullId,u.id),n);(0,S.isThenable)(v)&&t.push(v)}if(t.length)return Promise.all(t).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const u=new S.Barrier;return u.open(),u}i.expand=A.TestItemExpandState.BusyExpanding,this.pushExpandStateUpdate(i);const n=i.resolveBarrier=new S.Barrier,t=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,u)};let g;try{g=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(u){t(u)}return(0,S.isThenable)(g)?g.catch(t).then(()=>{n.open(),this.updateExpandability(i)}):(n.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}removeItem(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const g=t.pop();if(g){this.options.getApiFor(g.actual).listener=void 0;for(const u of g.actual.tags)this.decrementTagRefs(u.id);this.tree.delete(g.fullId.toString());for(const[u,v]of this.options.getChildren(g.actual))t.push(this.tree.get(R.TestId.joinToString(g.fullId,v.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.TestItemCollection=y;class h extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.DuplicateTestItemError=h;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=r;class s extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.MixedTestItemController=s;const l=(c,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(g,u){for(const v of t.values())g.call(u,v,this)},[Symbol.iterator](){return t.entries()},replace(g){const u=new Map,v=new Set(t.keys()),m={op:p.Bulk,ops:[]};for(const d of g){if(!(d instanceof n))throw new r(d.id);const C=i(d).controllerId;if(C!==c.controllerId)throw new s(d.id,C,c.controllerId);if(u.has(d.id))throw new h(d.id);u.set(d.id,d),v.delete(d.id),m.ops.push({op:p.Upsert,item:d})}for(const d of v.keys())m.ops.push({op:p.RemoveChild,id:d});c.listener?.(m),t=u},add(g){if(!(g instanceof n))throw new r(g.id);t.set(g.id,g),c.listener?.({op:p.Upsert,item:g})},delete(g){t.delete(g)&&c.listener?.({op:p.RemoveChild,id:g})},get(g){return t.get(g)},toJSON(){return Array.from(t.values())}}};e.createTestItemChildren=l}),define(Le[116],Ne([1,0,81]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,P=(A,R)=>{const p={controllerId:R};return k.set(A,p),p};e.createPrivateApiFor=P;const O=A=>{const R=k.get(A);if(!R)throw new S.InvalidTestItemError(A?.id||"<unknown>");return R};e.getPrivateApiFor=O}),define(Le[82],Ne([1,0,27,15,2]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=O,e.decodeAuthority=R,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function O(p,o){return p.scheme===k.Schemas.http||p.scheme===k.Schemas.https?p:(o&&o.authority&&o.isRemote&&p.scheme===k.Schemas.file&&(p=P.URI.from({scheme:k.Schemas.vscodeRemote,authority:o.authority,path:p.path})),P.URI.from({scheme:k.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.webviewRootResourceAuthority}`,path:p.path,fragment:p.fragment,query:p.query}))}function A(p){return p.replace(/./g,o=>{const I=o.charCodeAt(0);return I>=S.CharCode.a&&I<=S.CharCode.z||I>=S.CharCode.A&&I<=S.CharCode.Z||I>=S.CharCode.Digit0&&I<=S.CharCode.Digit9?o:"-"+I.toString(16).padStart(4,"0")})}function R(p){return p.replace(/-([0-9a-f]{4})/g,(o,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Le[201],Ne([1,0,6,4,82]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class O{constructor(R,p,o){this._proxy=R,this._editors=p,this._remoteInfo=o,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const w of this._insets.values())I.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(R=>R.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(R,p,o,I,w){let a;for(const i of this._editors.getVisibleTextEditors(!0))if(i.value===R){a=i;break}if(!a)throw new Error("not a visible editor");const y=this,h=this._handlePool++,r=new S.Emitter,s=new S.Emitter,l=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(i){return(0,P.asWebviewUri)(i,y._remoteInfo)}get cspSource(){return P.webviewGenericCspSource}set options(i){this._options=i,y._proxy.$setOptions(h,i)}get options(){return this._options}set html(i){this._html=i,y._proxy.$setHtml(h,i)}get html(){return this._html}get onDidReceiveMessage(){return r.event}postMessage(i){return y._proxy.$postMessage(h,i)}},c=new class{constructor(){this.editor=R,this.line=p,this.height=o,this.webview=l,this.onDidDispose=s.event}dispose(){y._insets.has(h)&&(y._insets.delete(h),y._proxy.$disposeEditorInset(h),s.fire(),s.dispose(),r.dispose())}};return this._proxy.$createEditorInset(h,a.id,a.value.document.uri,p+1,o,I||{},w.identifier,w.extensionLocation),this._insets.set(h,{editor:R,inset:c,onDidReceiveMessage:r}),c}$onDidDispose(R){const p=this._insets.get(R);p&&p.inset.dispose()}$onDidReceiveMessage(R,p){this._insets.get(R)?.onDidReceiveMessage.fire(p)}}e.ExtHostEditorInsets=O}),define(Le[117],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,S.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,S.createDecorator)("IAuthenticationExtensionsService")}),define(Le[202],Ne([1,0,3]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,S.createDecorator)("configurationResolverService");var k;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(k||(e.VariableKind=k={}));class P extends Error{constructor(A,R){super(R),this.variable=A}}e.VariableError=P}),define(Le[203],Ne([1,0,19,78,14,25,20,99,9,202,12]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0,S=We(S),k=We(k),P=We(P),O=We(O);class w{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,h,r,s){this._contributedVariables=new Map,this._context=y,this._labelService=h,this._userHomePromise=r,s&&(this._envVariablesPromise=s.then(l=>this.prepareEnv(l)))}prepareEnv(y){if(A.isWindows){const h=Object.create(null);return Object.keys(y).forEach(r=>{h[r.toLowerCase()]=y[r]}),h}return y}resolveWithEnvironment(y,h,r){return this.recursiveResolve({env:this.prepareEnv(y),userHome:void 0},h?h.uri:void 0,r)}async resolveAsync(y,h){const r={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(r,y?y.uri:void 0,h)}async resolveAnyBase(y,h,r,s){const l=O.deepClone(h);A.isWindows&&l.windows?Object.keys(l.windows).forEach(i=>l[i]=l.windows[i]):A.isMacintosh&&l.osx?Object.keys(l.osx).forEach(i=>l[i]=l.osx[i]):A.isLinux&&l.linux&&Object.keys(l.linux).forEach(i=>l[i]=l.linux[i]),delete l.windows,delete l.osx,delete l.linux;const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,y?y.uri:void 0,l,r,s)}async resolveAnyAsync(y,h,r){return this.resolveAnyBase(y,h,r)}async resolveAnyMap(y,h,r){const s=new Map;return{newConfig:await this.resolveAnyBase(y,h,r,s),resolvedVariables:s}}resolveWithInteractionReplace(y,h,r,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,h,r,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,h){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,h)}async recursiveResolve(y,h,r,s,l){if(P.isString(r))return this.resolveString(y,h,r,s,l);if(Array.isArray(r))return Promise.all(r.map(c=>this.recursiveResolve(y,h,c,s,l)));if(P.isObject(r)){const c=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.resolveString(y,h,n,s,l),await this.recursiveResolve(y,h,r[n],s,l)]));for(const[n,t]of i)c[n]=t;return c}return r}resolveString(y,h,r,s,l){return(0,I.replaceAsync)(r,w.VARIABLE_REGEXP,async(c,i)=>{if(i.includes(w.VARIABLE_LHS))return c;let n=await this.evaluateSingleVariable(y,c,i,h,s);return l?.set(i,n),n!==c&&P.isString(n)&&n.match(w.VARIABLE_REGEXP)&&(n=await this.resolveString(y,h,n,s,l)),n})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}async evaluateSingleVariable(y,h,r,s,l){let c;const i=r.split(":");i.length>1&&(r=i[0],c=i[1]);const n=u=>{const v=this._context.getFilePath();if(v)return(0,R.normalizeDriveLetter)(v);throw new o.VariableError(u,(0,p.localize)(2078,null,h))},t=u=>{const v=n(u);if(this._context.getWorkspaceFolderPathForFile){const m=this._context.getWorkspaceFolderPathForFile();if(m)return(0,R.normalizeDriveLetter)(m)}throw new o.VariableError(u,(0,p.localize)(2079,null,h,S.basename(v)))},g=u=>{if(c){const v=this._context.getFolderUri(c);if(v)return v;throw new o.VariableError(u,(0,p.localize)(2080,null,h,c))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new o.VariableError(u,(0,p.localize)(2081,null,h)):new o.VariableError(u,(0,p.localize)(2082,null,h))};switch(r){case"env":if(c){if(y.env){const u=y.env[A.isWindows?c.toLowerCase():c];if(P.isString(u))return u}return""}throw new o.VariableError(o.VariableKind.Env,(0,p.localize)(2083,null,h));case"config":if(c){const u=this._context.getConfigurationValue(s,c);if(P.isUndefinedOrNull(u))throw new o.VariableError(o.VariableKind.Config,(0,p.localize)(2084,null,h,c));if(P.isObject(u))throw new o.VariableError(o.VariableKind.Config,(0,p.localize)(2085,null,h,c));return u}throw new o.VariableError(o.VariableKind.Config,(0,p.localize)(2086,null,h));case"command":return this.resolveFromMap(o.VariableKind.Command,h,c,l,"command");case"input":return this.resolveFromMap(o.VariableKind.Input,h,c,l,"input");case"extensionInstallFolder":if(c){const u=await this._context.getExtension(c);if(!u)throw new o.VariableError(o.VariableKind.ExtensionInstallFolder,(0,p.localize)(2087,null,h,c));return this.fsPath(u.extensionLocation)}throw new o.VariableError(o.VariableKind.ExtensionInstallFolder,(0,p.localize)(2088,null,h));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.fsPath(g(o.VariableKind.WorkspaceFolder)));case"cwd":return s||c?(0,R.normalizeDriveLetter)(this.fsPath(g(o.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(S.basename(this.fsPath(g(o.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new o.VariableError(o.VariableKind.UserHome,(0,p.localize)(2089,null,h))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new o.VariableError(o.VariableKind.LineNumber,(0,p.localize)(2090,null,h))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new o.VariableError(o.VariableKind.SelectedText,(0,p.localize)(2091,null,h))}case"file":return n(o.VariableKind.File);case"fileWorkspaceFolder":return t(o.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.basename(t(o.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||c?S.relative(this.fsPath(g(o.VariableKind.RelativeFile)),n(o.VariableKind.RelativeFile)):n(o.VariableKind.RelativeFile);case"relativeFileDirname":{const u=S.dirname(n(o.VariableKind.RelativeFileDirname));if(s||c){const v=S.relative(this.fsPath(g(o.VariableKind.RelativeFileDirname)),u);return v.length===0?".":v}return u}case"fileDirname":return S.dirname(n(o.VariableKind.FileDirname));case"fileExtname":return S.extname(n(o.VariableKind.FileExtname));case"fileBasename":return S.basename(n(o.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=S.basename(n(o.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-S.extname(u).length)}case"fileDirnameBasename":return S.basename(S.dirname(n(o.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||h}case"execInstallFolder":{const u=this._context.getAppRoot();return u||h}case"pathSeparator":case"/":return S.sep;default:try{const u=c?`${r}:${c}`:r;return this.resolveFromMap(o.VariableKind.Unknown,h,u,l,void 0)}catch{return h}}}}resolveFromMap(y,h,r,s,l){if(r&&s){const c=l===void 0?s[r]:s[l+":"+r];if(typeof c=="string")return c;throw new o.VariableError(y,(0,p.localize)(2092,null,h))}return h}}e.AbstractVariableResolverService=w}),define(Le[118],Ne([1,0,3,114]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=o,e.isEditorGroup=a,e.preferredSideBySideGroupDirection=y,e.IEditorGroupsService=(0,S.createDecorator)("editorGroupsService");var P;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var R;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EXPAND=1]="EXPAND",h[h.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var p;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function o(h){const r=h;return(0,k.isEditorInput)(r?.editor)&&(0,k.isEditorInput)(r?.replacement)}var I;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var w;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(w||(e.OpenEditorContext=w={}));function a(h){const r=h;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function y(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Le[204],Ne([1,0,3,118]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=P,e.IEditorService=(0,S.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function P(O){const A=O;return typeof O=="number"||(0,k.isEditorGroup)(A)}}),define(Le[205],Ne([1,0,3,106]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,S.refineServiceDecorator)(k.IEnvironmentService)}),define(Le[119],Ne([1,0,18,6,19,4,10]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0,P=We(P);class R{constructor(c,i){this.versionId=c,this.removedDueToLooping=i}}e.DeltaExtensionsResult=R;class p{static isHostExtension(c,i,n){if(i.getExtensionDescription(c))return!1;const t=n.getExtensionDescription(c);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(c,i){this._activationEventsReader=c,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(r),this._extensionsMap=new S.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const c of this._extensionDescriptions){if(this._extensionsMap.has(c.identifier)){console.error("Extension `"+c.identifier.value+"` is already registered");continue}this._extensionsMap.set(c.identifier,c),this._extensionsArr.push(c);const i=this._activationEventsReader.readActivationEvents(c);for(const n of i)this._activationMap.has(n)||this._activationMap.set(n,[]),this._activationMap.get(n).push(c)}}set(c){return this._extensionDescriptions=c,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(c,i){this._extensionDescriptions=s(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(c);const n=p._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=s(this._extensionDescriptions,n.map(t=>t.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new R(this._versionId,n)}static _findLoopingExtensions(c){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,m){this.addNode(v),this.addNode(m),this._arcs.has(v)?this._arcs.get(v).push(m):this._arcs.set(v,[m])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,m){const d=i.getArcs(v);for(let C=0;C<d.length;C++)if(!m.has(d[C]))return!1;return!0}getNodes(){return this._nodesArr}},n=new S.ExtensionIdentifierMap;for(const v of c)if(n.set(v.identifier,v),v.extensionDependencies)for(const m of v.extensionDependencies)i.addArc(S.ExtensionIdentifier.toKey(v.identifier),S.ExtensionIdentifier.toKey(m));const t=new Set;i.getNodes().filter(v=>i.getArcs(v).length===0).forEach(v=>t.add(v));const g=i.getNodes().filter(v=>!t.has(v));let u;do{u=!1;for(let v=0;v<g.length;v++){const m=g[v];i.hasOnlyGoodArcs(m,t)&&(g.splice(v,1),v--,t.add(m),u=!0)}}while(u);return g.map(v=>n.get(v))}containsActivationEvent(c){return this._activationMap.has(c)}containsExtension(c){return this._extensionsMap.has(c)}getExtensionDescriptionsForActivationEvent(c){const i=this._activationMap.get(c);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new o(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(c){const i=this._extensionsMap.get(c);return i||void 0}getExtensionDescriptionByUUID(c){for(const i of this._extensionsArr)if(i.uuid===c)return i}getExtensionDescriptionByIdOrUUID(c,i){return this.getExtensionDescription(c)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=p;class o{constructor(c,i){this.versionId=c,this.extensions=i}}e.ExtensionDescriptionRegistrySnapshot=o;class I{constructor(c){this._lock=new y,this._actual=new p(c,[])}async acquireLock(c){const i=await this._lock.acquire(c);return new w(this,i)}deltaExtensions(c,i,n){if(!c.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,n)}containsActivationEvent(c){return this._actual.containsActivationEvent(c)}containsExtension(c){return this._actual.containsExtension(c)}getExtensionDescriptionsForActivationEvent(c){return this._actual.getExtensionDescriptionsForActivationEvent(c)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(c){return this._actual.getExtensionDescription(c)}getExtensionDescriptionByUUID(c){return this._actual.getExtensionDescriptionByUUID(c)}getExtensionDescriptionByIdOrUUID(c,i){return this._actual.getExtensionDescriptionByIdOrUUID(c,i)}}e.LockableExtensionDescriptionRegistry=I;class w extends O.Disposable{constructor(c,i){super(),this._registry=c,this._isDisposed=!1,this._register(i)}isAcquiredFor(c){return!this._isDisposed&&this._registry===c}}e.ExtensionDescriptionRegistryLock=w;class a{constructor(c){this.name=c;const i=(0,A.promiseWithResolvers)();this.promise=i.promise,this._resolve=i.resolve}resolve(c){this._resolve(c)}}class y{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(c){const i=new a(c);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const c=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${c.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this._isLocked=!1,this._advance())};c.resolve((0,O.toDisposable)(t))}}var h;(function(l){l[l.Builtin=0]="Builtin",l[l.User=1]="User",l[l.Dev=2]="Dev"})(h||(h={}));function r(l,c){const i=l.isBuiltin?h.Builtin:l.isUnderDevelopment?h.Dev:h.User,n=c.isBuiltin?h.Builtin:c.isUnderDevelopment?h.Dev:h.User;if(i!==n)return i-n;const t=P.posix.basename(l.extensionLocation.path),g=P.posix.basename(c.extensionLocation.path);return t<g?-1:t>g?1:0}function s(l,c){const i=new S.ExtensionIdentifierSet(c);return l.filter(n=>!i.has(n.identifier))}}),define(Le[83],Ne([1,0,22]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=A,e.isMessageOfType=R;var k;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(k||(e.UIKind=k={}));var P;(function(o){o[o.VersionMismatch=55]="VersionMismatch",o[o.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(o){o[o.Initialized=0]="Initialized",o[o.Ready=1]="Ready",o[o.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(o){const I=S.VSBuffer.alloc(1);switch(o){case O.Initialized:I.writeUInt8(1,0);break;case O.Ready:I.writeUInt8(2,0);break;case O.Terminate:I.writeUInt8(3,0);break}return I}function R(o,I){if(o.byteLength!==1)return!1;switch(o.readUInt8(0)){case 1:return I===O.Initialized;case 2:return I===O.Ready;case 3:return I===O.Terminate;default:return!1}}var p;(function(o){o.Start="START_NATIVE_LOG",o.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Le[66],Ne([1,0,3,6,112,11,26,83,62,63,25,2,4,9]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=s;let h=class extends a.Disposable{constructor(c,i){super(),this.initData=c,this.loggerService=i,this._onDidChangeTelemetryEnabled=this._register(new k.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new k.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=P.TelemetryLevel.NONE,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=w.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=i.createLogger(this.extHostTelemetryLogFile,{id:o.extensionTelemetryLogChannelId,name:(0,y.localize)(10825,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(i.onDidChangeLogLevel(n=>{(0,O.isLogLevel)(n)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this._level>=P.TelemetryLevel.CRASH,isErrorsEnabled:this._productConfig.error?this._level>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this._productConfig.usage?this._level>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(c,i,n){const t=this.getTelemetryDetails(),g=new r(i,n,c,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(c),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),u=this._telemetryLoggers.get(c.identifier.value)??[];return this._telemetryLoggers.set(c.identifier.value,[...u,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(c,i,n){this._level=c,this._telemetryIsSupported=i,this._productConfig=n??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(c){const i=Object.create(null);switch(i["common.extname"]=`${c.publisher}.${c.name}`,i["common.extversion"]=c.version,i["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,i["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,i["common.sqmid"]=this.initData.telemetryInfo.sqmId,i["common.devDeviceId"]=this.initData.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.initData.version,i["common.isnewappinstall"]=s(this.initData.telemetryInfo.firstSessionDate),i["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.getRemoteName)((0,o.cleanRemoteAuthority)(this.initData.remote.authority)),i}$onDidChangeTelemetryLevel(c){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=c;const i=this.getTelemetryDetails();this._telemetryLoggers.forEach((n,t)=>{const g=n.filter(u=>!u.isDisposed);g.length===0?this._telemetryLoggers.delete(t):this._telemetryLoggers.set(t,g)}),this._telemetryLoggers.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(c,i){const t=this._telemetryLoggers.get(c.value)?.filter(u=>!u.isDisposed);if(!t)return this._telemetryLoggers.delete(c.value),!1;let g=!1;for(const u of t)u.ignoreUnhandledExtHostErrors||(u.logError(i),g=!0);return g}};e.ExtHostTelemetry=h,e.ExtHostTelemetry=h=Ge([Ve(0,A.IExtHostInitDataService),Ve(1,O.ILoggerService)],h);class r{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,i,n,t,g,u,v){this._extension=n,this._logger=t,this._inLoggingOnlyMode=g,this._commonProperties=u,this._onDidChangeEnableStates=new k.Emitter,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=i?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=i?.additionalCommonProperties,this._sender=c,this._telemetryEnablements={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(c,i){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:c,isErrorsEnabled:i},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(c){let i="properties"in c?c.properties??{}:c;return i=(0,o.cleanData)(i,[]),this._additionalCommonProperties&&(i=(0,I.mixin)(i,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(i=(0,I.mixin)(i,this._commonProperties)),"properties"in c?c.properties=i:c=i,c}logEvent(c,i){this._sender&&(this._extension.publisher==="vscode"?c=this._extension.name+"/"+c:c=this._extension.identifier.value+"/"+c,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(c,i),this._logger.trace(c,i))}logUsage(c,i){this._telemetryEnablements.isUsageEnabled&&this.logEvent(c,i)}logError(c,i){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof c=="string")this.logEvent(c,i);else{const n={name:c.name,message:c.message,stack:c.stack,cause:c.cause},t=(0,o.cleanData)(n,[]),g=new Error(t.message,{cause:t.cause});g.stack=t.stack,g.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(g,i),this._logger.trace("exception",i)}}get apiTelemetryLogger(){if(!this._apiObject){const c=this,i={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return c._telemetryEnablements.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c._onDidChangeEnableStates.event.bind(c)};this._apiObject=Object.freeze(i)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let c=this._sender;this._sender=void 0,Promise.resolve(c.flush()).then(c=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=r;function s(l){const c=Date.now()-new Date(l).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.IExtHostTelemetry=(0,S.createDecorator)("IExtHostTelemetry")}),define(Le[24],Ne([1,0,6,2,178,111,18,3]),function(Se,e,S,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=a,e.checkProposedApiEnabled=y,e.toExtension=l,e.toExtensionDescription=c,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class p{constructor(t){this.dependency=t}}e.MissingExtensionDependency=p;var o;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(o||(e.ExtensionHostStartup=o={}));class I{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(t,g,u){this._versionId=t,this._allExtensions=g.slice(0),this._myExtensions=u.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:O.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(t,g,u){if(this._versionId>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this._versionId})`);const v=[],m=[],d=[],C=[],_=w(this._allExtensions),E=w(g),T=(L,N)=>L.extensionLocation.toString()===N.extensionLocation.toString()||L.isBuiltin===N.isBuiltin||L.isUserBuiltin===N.isUserBuiltin||L.isUnderDevelopment===N.isUnderDevelopment;for(const L of this._allExtensions){const N=E.get(L.identifier);if(!N){v.push(L.identifier),_.delete(L.identifier);continue}if(!T(L,N)){v.push(L.identifier),_.delete(L.identifier);continue}}for(const L of g){const N=_.get(L.identifier);if(!N){m.push(L);continue}if(!T(N,L)){v.push(N.identifier),_.delete(N.identifier);continue}}const D=new A.ExtensionIdentifierSet(this._myExtensions),f=new A.ExtensionIdentifierSet(u);for(const L of this._myExtensions)f.has(L)||d.push(L);for(const L of u)D.has(L)||C.push(L);const b=O.ImplicitActivationEvents.createActivationEventsMap(m),M={versionId:t,toRemove:v,toAdd:m,addActivationEvents:b,myToRemove:d,myToAdd:C};return this.delta(M),M}delta(t){if(this._versionId>=t.versionId)return null;const{toRemove:g,toAdd:u,myToRemove:v,myToAdd:m}=t,d=new A.ExtensionIdentifierSet(g),C=new A.ExtensionIdentifierSet(v);for(let _=0;_<this._allExtensions.length;_++)d.has(this._allExtensions[_].identifier)&&(this._allExtensions.splice(_,1),_--);for(let _=0;_<this._myExtensions.length;_++)C.has(this._myExtensions[_])&&(this._myExtensions.splice(_,1),_--);for(const _ of u)this._allExtensions.push(_);for(const _ of m)this._myExtensions.push(_);return this._myActivationEvents=null,t}containsExtension(t){for(const g of this._myExtensions)if(A.ExtensionIdentifier.equals(g,t))return!0;return!1}containsActivationEvent(t){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(t)}_readMyActivationEvents(){const t=new Set;for(const g of this._allExtensions){if(!this.containsExtension(g.identifier))continue;const u=O.ImplicitActivationEvents.readActivationEvents(g);for(const v of u)t.add(v)}return t}}e.ExtensionHostExtensions=I;function w(n){const t=new A.ExtensionIdentifierMap;for(const g of n)t.set(g.identifier,g);return t}function a(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function y(n,t){if(!a(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class h{constructor(t,g,u,v){this.codeLoadingTime=t,this.activateCallTime=g,this.activateResolvedTime=u,this.activationReason=v}}e.ActivationTimes=h;class r{constructor(t,g){this.description=t,this.value=g}}e.ExtensionPointContribution=r;var s;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function l(n){return{type:n.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function c(n,t){const g=(0,P.getExtensionId)(n.manifest.publisher,n.manifest.name);return{id:g,identifier:new A.ExtensionIdentifier(g),isBuiltin:n.type===A.ExtensionType.System,isUserBuiltin:n.type===A.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,g){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,g){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=i}),define(Le[206],Ne([1,0,13,4,119,18,24,11,10]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0,S=We(S);class o{static{this.NONE=new o(!1,-1,-1,-1)}constructor(c,i,n,t){this.startup=c,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.ExtensionActivationTimes=o;class I{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,i){return c===-1||i===-1?-1:i-c}build(){return new o(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class w{constructor(c,i,n,t,g,u){this.activationFailed=c,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=g,this.disposable=u}}e.ActivatedExtension=w;class a extends w{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,k.Disposable.None)}}e.EmptyExtension=a;class y extends w{constructor(){super(!1,null,o.NONE,{activate:void 0,deactivate:void 0},void 0,k.Disposable.None)}}e.HostExtension=y;class h extends w{constructor(c){super(!0,c,o.NONE,{activate:void 0,deactivate:void 0},void 0,k.Disposable.None)}}let r=class{constructor(c,i,n,t){this._logService=t,this._registry=c,this._globalRegistry=i,this._host=n,this._operations=new O.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[c,i]of this._operations)i.dispose()}async waitForActivatingExtensions(){const c=[];for(const[i,n]of this._operations)c.push(n.wait());await Promise.all(c)}isActivated(c){const i=this._operations.get(c);return!!(i&&i.value)}getActivatedExtension(c){const i=this._operations.get(c);if(!i||!i.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return i.value}async activateByEvent(c,i){if(this._alreadyActivatedEvents[c])return;const n=this._registry.getExtensionDescriptionsForActivationEvent(c);await this._activateExtensions(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:c}}))),this._alreadyActivatedEvents[c]=!0}activateById(c,i){const n=this._registry.getExtensionDescription(c);if(!n)throw new Error(`Extension '${c.value}' is not known`);return this._activateExtensions([{id:n.identifier,reason:i}])}async _activateExtensions(c){const i=c.filter(n=>!this.isActivated(n.id)).map(n=>this._handleActivationRequest(n));await Promise.all(i.map(n=>n.wait()))}_handleActivationRequest(c){if(this._operations.has(c.id))return this._operations.get(c.id);if(this._isHostExtension(c.id))return this._createAndSaveOperation(c,null,[],null);const i=this._registry.getExtensionDescription(c.id);if(!i){const g=new Error(`Cannot activate unknown extension '${c.id.value}'`),u=this._createAndSaveOperation(c,null,[],new h(g));return this._host.onExtensionActivationError(c.id,g,new A.MissingExtensionDependency(c.id.value)),u}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const g of t){if(this._isResolvedExtension(g))continue;const u=this._operations.get(g);if(u){n.push(u);continue}if(this._isHostExtension(g)){n.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(g).identifier,reason:c.reason}));continue}const v=this._registry.getExtensionDescription(g);if(v){if(!v.main&&!v.browser)continue;n.push(this._handleActivationRequest({id:v.identifier,reason:c.reason}));continue}const m=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${m}' extension because it depends on unknown extension '${g}'`),C=this._createAndSaveOperation(c,i.displayName,[],new h(d));return this._host.onExtensionActivationError(i.identifier,d,new A.MissingExtensionDependency(g)),C}return this._createAndSaveOperation(c,i.displayName,n,null)}_createAndSaveOperation(c,i,n,t){const g=new s(c.id,i,c.reason,n,t,this._host,this._logService);return this._operations.set(c.id,g),g}_isHostExtension(c){return P.ExtensionDescriptionRegistry.isHostExtension(c,this._registry,this._globalRegistry)}_isResolvedExtension(c){const i=this._globalRegistry.getExtensionDescription(c);return i?!i.main&&!i.browser:!1}};e.ExtensionsActivator=r,e.ExtensionsActivator=r=Ge([Ve(3,R.ILogService)],r);let s=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(c,i,n,t,g,u,v){this._id=c,this._displayName=i,this._reason=n,this._deps=t,this._value=g,this._host=u,this._logService=v,this._barrier=new p.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let c=0;c<this._deps.length;c++){const i=this._deps[c];if(i.value&&!i.value.activationFailed){this._deps.splice(c,1),c--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this._value=new h(n),this._host.onExtensionActivationError(this._id,n,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(c=>c.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(c){const i=new Error;if(c&&c.name&&(i.name=c.name),c&&c.message?i.message=`Activating extension '${this._id.value}' failed: ${c.message}.`:i.message=`Activating extension '${this._id.value}' failed: ${c}.`,c&&c.stack&&(i.stack=c.stack),this._value=new h(i),this._isDisposed&&S.isCancellationError(c))return;this._host.onExtensionActivationError(this._id,i,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(c)}}};s=Ge([Ve(6,R.ILogService)],s)});var Jt=this&&this.__importDefault||function(Se){return Se&&Se.__esModule?Se:{default:Se}};define(Le[120],Ne([1,0,9,13,35,110,77,30,18,108,111,104]),function(Se,e,S,k,P,O,A,R,p,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0,S=We(S),P=Jt(P);const a=R.Registry.as(A.Extensions.JSONContribution);class y{constructor(t,g,u){this._messageHandler=t,this._extension=g,this._extensionPointId=u}_msg(t,g){this._messageHandler({type:t,message:g,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(t){this._msg(P.default.Error,t)}warn(t){this._msg(P.default.Warning,t)}info(t){this._msg(P.default.Info,t)}}e.ExtensionMessageCollector=y;class h{static _toSet(t){const g=new p.ExtensionIdentifierSet;for(let u=0,v=t.length;u<v;u++)g.add(t[u].description.identifier);return g}static compute(t,g){if(!t||!t.length)return new h(g,[]);if(!g||!g.length)return new h([],t);const u=this._toSet(t),v=this._toSet(g),m=g.filter(C=>!u.has(C.description.identifier)),d=t.filter(C=>!v.has(C.description.identifier));return new h(m,d)}constructor(t,g){this.added=t,this.removed=g}}e.ExtensionPointUserDelta=h;class r{constructor(t,g){this.name=t,this.defaultExtensionKind=g,this._handler=null,this._users=null,this._delta=null}setHandler(t){if(this._handler!==null)throw new Error("Handler already set!");return this._handler=t,this._handle(),{dispose:()=>{this._handler=null}}}acceptUsers(t){this._delta=h.compute(this._users,t),this._users=t,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(t){(0,k.onUnexpectedError)(t)}}}e.ExtensionPoint=r;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(1843,null),S.localize(1844,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:S.localize(1845,null),properties:{vscode:{type:"string",description:S.localize(1846,null),default:"^1.22.0"}}},publisher:{description:S.localize(1847,null),type:"string"},displayName:{description:S.localize(1848,null),type:"string"},categories:{description:S.localize(1849,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:S.localize(1850,null)}]}},galleryBanner:{type:"object",description:S.localize(1851,null),properties:{color:{description:S.localize(1852,null),type:"string"},theme:{description:S.localize(1853,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(1854,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(1855,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(1856,null)},enabledApiProposals:{markdownDescription:S.localize(1857,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(w.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:S.localize(1858,null),type:"string",enum:["none"],enumDescriptions:[S.localize(1859,null)]},activationEvents:{description:S.localize(1860,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(1861,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(1862,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(1863,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(1864,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(1865,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(1866,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(1867,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(1868,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(1869,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(1870,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(1871,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(1872,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(1873,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(1874,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(1875,null)},{label:"onUri",body:"onUri",description:S.localize(1876,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(1877,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(1878,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(1879,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(1880,null)},{label:"onRenderer",description:S.localize(1881,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(1882,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(1883,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(1884,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(1885,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:S.localize(1886,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:S.localize(1887,null)},{label:"*",description:S.localize(1888,null),body:"*"}]}},badges:{type:"array",description:S.localize(1889,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(1890,null)},href:{type:"string",description:S.localize(1891,null)},description:{type:"string",description:S.localize(1892,null)}}}},markdown:{type:"string",description:S.localize(1893,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(1894,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(1895,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:S.localize(1896,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:S.localize(1897,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(1898,null)},{body:["workspace"],description:S.localize(1899,null)},{body:["ui","workspace"],description:S.localize(1900,null)},{body:["workspace","ui"],description:S.localize(1901,null)},{body:[],description:S.localize(1902,null)}]},capabilities:{description:S.localize(1903,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(1904,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(1905,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(1906,null),S.localize(1907,null),S.localize(1908,null)]},description:{type:"string",markdownDescription:S.localize(1909,null)}}},untrustedWorkspaces:{description:S.localize(1910,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(1911,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(1912,null),S.localize(1913,null),S.localize(1914,null)]},restrictedConfigurations:{description:S.localize(1915,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(1916,null)}}}}},sponsor:{description:S.localize(1917,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(1918,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(1919,null),type:"string"},"vscode:uninstall":{description:S.localize(1920,null),type:"string"}}},icon:{type:"string",description:S.localize(1921,null)},l10n:{type:"string",description:S.localize(1922,null)},pricing:{type:"string",markdownDescription:S.localize(1923,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this._extensionPoints=new Map}registerExtensionPoint(t){if(this._extensionPoints.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const g=new r(t.extensionPoint,t.defaultExtensionKind);return this._extensionPoints.set(t.extensionPoint,g),t.activationEventsGenerator&&I.ImplicitActivationEvents.register(t.extensionPoint,t.activationEventsGenerator),e.schema.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,a.registerSchema(l,e.schema),g}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=c;const i={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(i.ExtensionsRegistry,new c),e.ExtensionsRegistry=R.Registry.as(i.ExtensionsRegistry),a.registerSchema(l,e.schema),a.registerSchema(o.productSchemaId,{properties:{extensionEnabledApiProposals:{description:S.localize(1924,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Le[207],Ne([1,0,6,40,4,12,9,18,3,11,24,120]),function(Se,e,S,k,P,O,A,R,p,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelsService=e.languageModelExtensionPoint=e.ILanguageModelsService=e.ChatMessageRole=void 0;var a;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(a||(e.ChatMessageRole=a={})),e.ILanguageModelsService=(0,p.createDecorator)("ILanguageModelsService");const y={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(8422,null)}}};e.languageModelExtensionPoint=w.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(8423,null),oneOf:[y,{type:"array",items:y}]},activationEventsGenerator:(r,s)=>{for(const l of r)s.push(`onLanguageModelChat:${l.vendor}`)}});let h=class{constructor(s,l){this._extensionService=s,this._logService=l,this._store=new P.DisposableStore,this._providers=new Map,this._vendors=new Set,this._onDidChangeProviders=this._store.add(new S.Emitter),this.onDidChangeLanguageModels=this._onDidChangeProviders.event,this._store.add(e.languageModelExtensionPoint.setHandler(c=>{this._vendors.clear();for(const n of c){if(!(0,I.isProposedApiEnabled)(n.description,"chatProvider")){n.collector.error((0,A.localize)(8424,null));continue}for(const t of k.Iterable.wrap(n.value)){if(this._vendors.has(t.vendor)){n.collector.error((0,A.localize)(8425,null,t.vendor));continue}if((0,O.isFalsyOrWhitespace)(t.vendor)){n.collector.error((0,A.localize)(8426,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,A.localize)(8427,null));continue}this._vendors.add(t.vendor)}}const i=[];for(const[n,t]of this._providers)this._vendors.has(t.metadata.vendor)||(this._providers.delete(n),i.push(n));i.length>0&&this._onDidChangeProviders.fire({removed:i})}))}dispose(){this._store.dispose(),this._providers.clear()}getLanguageModelIds(){return Array.from(this._providers.keys())}lookupLanguageModel(s){return this._providers.get(s)?.metadata}async selectLanguageModels(s){if(s.vendor)await this._extensionService.activateByEvent(`onLanguageModelChat:${s.vendor}}`);else{const c=Array.from(this._vendors).map(i=>this._extensionService.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(c)}const l=[];for(const[c,i]of this._providers)(s.vendor===void 0||i.metadata.vendor===s.vendor)&&(s.family===void 0||i.metadata.family===s.family)&&(s.version===void 0||i.metadata.version===s.version)&&(s.identifier===void 0||i.metadata.id===s.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>R.ExtensionIdentifier.equals(n,s.extension)))&&l.push(c);return this._logService.trace("[LM] selected language models",s,l),l}registerLanguageModelChat(s,l){if(this._logService.trace("[LM] registering language model chat",s,l.metadata),!this._vendors.has(l.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${l.metadata.vendor}.`);if(this._providers.has(s))throw new Error(`Chat response provider with identifier ${s} is already registered.`);return this._providers.set(s,l),this._onDidChangeProviders.fire({added:[{identifier:s,metadata:l.metadata}]}),(0,P.toDisposable)(()=>{this._providers.delete(s)&&(this._onDidChangeProviders.fire({removed:[s]}),this._logService.trace("[LM] UNregistered language model chat",s,l.metadata))})}async sendChatRequest(s,l,c,i,n){const t=this._providers.get(s);if(!t)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return t.sendChatRequest(c,l,i,n)}computeTokenLength(s,l,c){const i=this._providers.get(s);if(!i)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return i.provideTokenCount(l,c)}};e.LanguageModelsService=h,e.LanguageModelsService=h=Ge([Ve(0,I.IExtensionService),Ve(1,o.ILogService)],h)}),define(Le[208],Ne([1,0,9,14,25,120,31,6]),function(Se,e,S,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0,S=We(S),k=We(k),P=We(P);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(3925,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(3926,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(3927,null),default:""}}};var o;(function(a){function y(h,r,s){if(!h)return;const l=k.isString(h.type)?h.type:void 0;if(!l||l.length===0){s.error(S.localize(3928,null));return}const c=[];if(Array.isArray(h.required))for(const i of h.required)k.isString(i)&&c.push(i);return{extensionId:r.value,taskType:l,required:c,properties:h.properties?P.deepClone(h.properties):{},when:h.when?A.ContextKeyExpr.deserialize(h.when):void 0}}a.from=y})(o||(o={}));const I=O.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,y)=>{for(const h of a)h.type&&y.push(`onTaskType:${h.type}`)},jsonSchema:{description:S.localize(3929,null),type:"array",items:p}});class w{constructor(){this._onDefinitionsChanged=new R.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((y,h)=>{I.setHandler((r,s)=>{this._schema=void 0;try{for(const l of s.removed){const c=l.value;for(const i of c)this.taskTypes&&i.type&&this.taskTypes[i.type]&&delete this.taskTypes[i.type]}for(const l of s.added){const c=l.value;for(const i of c){const n=o.from(i,l.description.identifier,l.collector);n&&(this.taskTypes[n.taskType]=n)}}(s.removed.length>0||s.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}y(void 0)})})}onReady(){return this.readyPromise}get(y){return this.taskTypes[y]}all(){return Object.keys(this.taskTypes).map(y=>this.taskTypes[y])}getJsonSchema(){if(this._schema===void 0){const y=[];for(const h of this.all()){const r={type:"object",additionalProperties:!1};h.required.length>0&&(r.required=h.required.slice(0)),h.properties!==void 0?r.properties=P.deepClone(h.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[h.taskType]},y.push(r)}this._schema={oneOf:y}}return this._schema}}e.TaskDefinitionRegistry=new w}),define(Le[209],Ne([1,0,9,14,23,25,31,208,43]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,S=We(S),k=We(k),P=We(P),O=We(O),e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,S.localize(3913,null)),e.TASKS_CATEGORY=S.localize2(3915,"Tasks");var o;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(o||(e.ShellQuoting=o={})),e.CUSTOMIZED_TASK_TYPE="$customized",function($){function K(q){if(!q)return $.Strong;switch(q.toLowerCase()){case"escape":return $.Escape;case"strong":return $.Strong;case"weak":return $.Weak;default:return $.Strong}}$.from=K}(o||(e.ShellQuoting=o={}));var I;(function($){$.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var w;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(w||(e.RevealKind=w={})),function($){function K(q){switch(q.toLowerCase()){case"always":return $.Always;case"silent":return $.Silent;case"never":return $.Never;default:return $.Always}}$.fromString=K}(w||(e.RevealKind=w={}));var a;(function($){$[$.Never=1]="Never",$[$.OnProblem=2]="OnProblem",$[$.Always=3]="Always"})(a||(e.RevealProblemKind=a={})),function($){function K(q){switch(q.toLowerCase()){case"always":return $.Always;case"never":return $.Never;case"onproblem":return $.OnProblem;default:return $.OnProblem}}$.fromString=K}(a||(e.RevealProblemKind=a={}));var y;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(y||(e.PanelKind=y={})),function($){function K(q){switch(q.toLowerCase()){case"shared":return $.Shared;case"dedicated":return $.Dedicated;case"new":return $.New;default:return $.Shared}}$.fromString=K}(y||(e.PanelKind=y={}));var h;(function($){$.defaults={echo:!0,reveal:w.Always,revealProblems:a.Never,focus:!1,panel:y.Shared,showReuseMessage:!0,clear:!1}})(h||(e.PresentationOptions=h={}));var r;(function($){$[$.Shell=1]="Shell",$[$.Process=2]="Process",$[$.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function($){function K(ae){switch(ae.toLowerCase()){case"shell":return $.Shell;case"process":return $.Process;case"customExecution":return $.CustomExecution;default:return $.Process}}$.fromString=K;function q(ae){switch(ae){case $.Shell:return"shell";case $.Process:return"process";case $.CustomExecution:return"customExecution";default:return"process"}}$.toString=q}(r||(e.RuntimeType=r={}));var s;(function($){function K(q){return k.isString(q)?q:q.value}$.value=K})(s||(e.CommandString=s={}));var l;(function($){$.Clean={_id:"clean",isDefault:!1},$.Build={_id:"build",isDefault:!1},$.Rebuild={_id:"rebuild",isDefault:!1},$.Test={_id:"test",isDefault:!1};function K(ae){return ae===$.Clean._id||ae===$.Build._id||ae===$.Rebuild._id||ae===$.Test._id}$.is=K;function q(ae){if(ae!==void 0)return k.isString(ae)?K(ae)?{_id:ae,isDefault:!1}:void 0:ae}$.from=q})(l||(e.TaskGroup=l={}));var c;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var i;(function($){$.Workspace="workspace",$.Extension="extension",$.InMemory="inMemory",$.WorkspaceFile="workspaceFile",$.User="user";function K(q){switch(q){case $.User:return p.ConfigurationTarget.USER;case $.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}$.toConfigurationTarget=K})(i||(e.TaskSourceKind=i={}));var n;(function($){$.parallel="parallel",$.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function($){$[$.default=1]="default",$[$.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var g;(function($){$.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class u{constructor(K,q,ae,Ee,ce,Z){this._label="",this._id=K,q&&(this._label=q),ae&&(this.type=ae),this.runOptions=Ee,this.configurationProperties=ce,this._source=Z}getDefinition(K){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,q=!1){if(K===void 0)return!1;if(k.isString(K))return K===this._label||K===this.configurationProperties.identifier||q&&K===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=u;class v extends u{constructor(K,q,ae,Ee,ce,Z,le,me){super(K,ae,void 0,le,me,q),this.command={},this._source=q,this.hasDefinedMatchers=Z,ce&&(this.command=ce)}clone(){return new v(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case r.Shell:q="shell";break;case r.Process:q="process";break;case r.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(K){return K instanceof v}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const K=this.getFolderId();if(!K)return;let q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(q+=this._source.kind);const ae={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:q};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new v(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=v;class m extends u{constructor(K,q,ae,Ee,ce,Z,le){super(K,ae,Ee,Z,le,q),this._source=q,this.configures=ce}static is(K){return K instanceof m}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const K=this.getFolderId();if(!K)return;let q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(q+=this._source.kind);const ae={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:q};return JSON.stringify(ae)}}e.ConfiguringTask=m;class d extends u{constructor(K,q,ae,Ee,ce,Z,le,me,oe){super(K,ae,Ee,me,oe,q),this.defines=ce,this.hasDefinedMatchers=le,this.command=Z,this.icon=oe.icon,this.hide=oe.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof d}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===c.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new d(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=d;class C extends u{constructor(K,q,ae,Ee,ce,Z){super(K,ae,Ee,ce,Z,q),this._source=q}clone(){return new C(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof C}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new C(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=C;var _;(function($){$[$.Process=1]="Process",$[$.Terminal=2]="Terminal"})(_||(e.ExecutionEngine=_={})),function($){$._default=$.Terminal}(_||(e.ExecutionEngine=_={}));var E;(function($){$[$.V0_1_0=1]="V0_1_0",$[$.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class T{constructor(K){this._order=new Map;for(let q=0;q<K.length;q++)this._order.set(K[q].uri.toString(),q)}compare(K,q){const ae=K.getWorkspaceFolder(),Ee=q.getWorkspaceFolder();if(ae&&Ee){let ce=this._order.get(ae.uri.toString());ce=ce===void 0?0:ce+1;let Z=this._order.get(Ee.uri.toString());return Z=Z===void 0?0:Z+1,ce===Z?K._label.localeCompare(q._label):ce-Z}else return!ae&&Ee?-1:ae&&!Ee?1:0}}e.TaskSorter=T;var D;(function($){$.DependsOnStarted="dependsOnStarted",$.AcquiredInput="acquiredInput",$.Start="start",$.ProcessStarted="processStarted",$.Active="active",$.Inactive="inactive",$.Changed="changed",$.Terminated="terminated",$.ProcessEnded="processEnded",$.End="end"})(D||(e.TaskEventKind=D={}));var f;(function($){$.SingleRun="singleRun",$.Background="background"})(f||(e.TaskRunType=f={}));var b;(function($){$[$.System=0]="System",$[$.User=1]="User",$[$.FolderOpen=2]="FolderOpen",$[$.ConfigurationChange=3]="ConfigurationChange",$[$.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var M;(function($){function K(me){return{taskId:me._id,taskName:me.configurationProperties.name,runType:me.configurationProperties.isBackground?f.Background:f.SingleRun,group:me.configurationProperties.group,__task:me}}function q(me,oe,De){return{...K(me),kind:D.Start,terminalId:oe,resolvedVariables:De}}$.start=q;function ae(me,oe,De){return{...K(me),kind:D.ProcessStarted,terminalId:oe,processId:De}}$.processStarted=ae;function Ee(me,oe,De){return{...K(me),kind:D.ProcessEnded,terminalId:oe,exitCode:De}}$.processEnded=Ee;function ce(me,oe,De){return{...K(me),kind:D.Terminated,exitReason:De,terminalId:oe}}$.terminated=ce;function Z(me,oe,De){return{...K(oe),kind:me,terminalId:De}}$.general=Z;function le(){return{kind:D.Changed}}$.changed=le})(M||(e.TaskEvent=M={}));var L;(function($){function K(ae){const Ee=Object.keys(ae).sort();let ce="";for(const Z of Ee){let le=ae[Z];le instanceof Object?le=K(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),ce+=Z+","+le+","}return ce}function q(ae){const ce={_key:K(ae),type:ae.taskType};return Object.assign(ce,ae),ce}$.create=q})(L||(e.KeyedTaskIdentifier=L={}));var N;(function($){$.AutoDetect="task.autoDetect",$.SaveBeforeRun="task.saveBeforeRun",$.ShowDecorations="task.showDecorations",$.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",$.SlowProviderWarning="task.slowProviderWarning",$.QuickOpenHistory="task.quickOpen.history",$.QuickOpenDetail="task.quickOpen.detail",$.QuickOpenSkip="task.quickOpen.skip",$.QuickOpenShowAll="task.quickOpen.showAll",$.AllowAutomaticTasks="task.allowAutomaticTasks",$.Reconnection="task.reconnection",$.VerboseLogging="task.verboseLogging"})(N||(e.TaskSettingId=N={}));var W;(function($){$.Tasks="tasks",$.SuppressTaskName="tasks.suppressTaskName",$.Windows="tasks.windows",$.Osx="tasks.osx",$.Linux="tasks.linux",$.ShowOutput="tasks.showOutput",$.IsShellCommand="tasks.isShellCommand",$.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var j;(function($){function K(q,ae){const Ee=R.TaskDefinitionRegistry.get(q.type);if(Ee===void 0){const me=O.deepClone(q);return delete me._key,L.create(me)}const ce=Object.create(null);ce.type=Ee.taskType;const Z=new Set;Ee.required.forEach(me=>Z.add(me));const le=Ee.properties;for(const me of Object.keys(le)){const oe=q[me];if(oe!=null)ce[me]=oe;else if(Z.has(me)){const De=le[me];if(De.default!==void 0)ce[me]=O.deepClone(De.default);else switch(De.type){case"boolean":ce[me]=!1;break;case"number":case"integer":ce[me]=0;break;case"string":ce[me]="";break;default:ae.error(S.localize(3914,null,JSON.stringify(q,void 0,0),me));return}}}return L.create(ce)}$.createTaskIdentifier=K})(j||(e.TaskDefinition=j={}))}),define(Le[210],Ne([1,0,13]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,R)=>{this._actualOk=A,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,S.onUnexpectedError)(A))}then(A,R){return this._ensureActual().then(A,R)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=k;class P extends k{constructor(){super(),this._hasErr=!0,this._err=new S.CancellationError}}e.CanceledLazyPromise=P}),define(Le[39],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=P,e.getStringIdentifierForProxy=O;class S{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++S.count}}e.ProxyIdentifier=S;const k=[];function P(R){const p=new S(R);return k[p.nid]=p,p}function O(R){return k[R].sid}class A{constructor(p){this.value=p}}e.SerializableObjectWithBuffers=A}),define(Le[5],Ne([1,0,39]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(k||(e.TextEditorRevealType=k={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var R;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var o;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(o||(e.NotebookEditorRevealType=o={}));var I;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class w{static{this._n=0}static mixin(s){return s._id=w._n++,s}}e.IdObject=w;var a;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var y;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var h;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(h||(e.ExtHostTestingResource=h={})),e.MainContext={MainThreadAuthentication:(0,S.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,S.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,S.createProxyIdentifier)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,S.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.createProxyIdentifier)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,S.createProxyIdentifier)("MainThreadChatSkills"),MainThreadClipboard:(0,S.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,S.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,S.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,S.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,S.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,S.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,S.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,S.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,S.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,S.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,S.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,S.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,S.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,S.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,S.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,S.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.createProxyIdentifier)("ExtHostInteractive"),ExtHostChatAgents2:(0,S.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.createProxyIdentifier)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,S.createProxyIdentifier)("ExtHostChatSkills"),ExtHostChatProvider:(0,S.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,S.createProxyIdentifier)("ExtHostSpeech"),ExtHostEmbeddings:(0,S.createProxyIdentifier)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,S.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,S.createProxyIdentifier)("ExtHostLocalization")}}),define(Le[84],Ne([1,0,3,11,5,16]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,P=We(P),e.IExtHostApiDeprecationService=(0,S.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(p,o){this._extHostLogService=o,this._reportedUsages=new Set,this._telemetryShape=p.getProxy(P.MainContext.MainThreadTelemetry)}report(p,o,I){const w=this.getUsageKey(p,o);this._reportedUsages.has(w)||(this._reportedUsages.add(w),o.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:o.identifier.value,apiId:p}))}getUsageKey(p,o){return`${p}-${o.identifier.value}`}};e.ExtHostApiDeprecationService=A,e.ExtHostApiDeprecationService=A=Ge([Ve(0,O.IExtHostRpcService),Ve(1,k.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(R,p,o){}})}),define(Le[211],Ne([1,0,5]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(O){const A=O.getProxy(S.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(R){return A.$writeText(R)}})}}e.ExtHostClipboard=k}),define(Le[212],Ne([1,0,25,5,26,16]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=class{constructor(I,w){this._mainThreadConsole=I.getProxy(k.MainContext.MainThreadConsole),this._includeStack=w.consoleForward.includeStack,this._logNative=w.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(I,w){const a=this,y=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){a._handleConsoleCall(I,w,y,arguments)}})}_handleConsoleCall(I,w,a,y){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:w,arguments:p(y,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(I,a,y)}};e.AbstractExtHostConsoleForwarder=A,e.AbstractExtHostConsoleForwarder=A=Ge([Ve(0,O.IExtHostRpcService),Ve(1,P.IExtHostInitDataService)],A);const R=1e5;function p(o,I){const w=[];if(o.length)for(let a=0;a<o.length;a++){let y=o[a];if(typeof y>"u")y="undefined";else if(y instanceof Error){const h=y;h.stack?y=h.stack:y=h.toString()}w.push(y)}if(I){const a=new Error().stack;a&&w.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,S.safeStringify)(w);return a.length>R?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Le[213],Ne([1,0,2,5,24]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class O{constructor(R){this._proxy=R.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(R,p){return p?.allowUIResources&&(0,P.checkProposedApiEnabled)(R,"showLocal"),this._proxy.$showOpenDialog(p).then(o=>o?o.map(I=>S.URI.revive(I)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(p=>p?S.URI.revive(p):void 0)}}e.ExtHostDialogs=O}),define(Le[214],Ne([1,0,21,6,4,5]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEmbeddings=void 0;class A{constructor(p){this._provider=new Map,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._allKnownModels=new Set,this._handlePool=0,this._proxy=p.getProxy(O.MainContext.MainThreadEmbeddings)}registerEmbeddingsProvider(p,o,I){if(this._allKnownModels.has(o))throw new Error("An embeddings provider for this model is already registered");const w=this._handlePool++;return this._proxy.$registerEmbeddingProvider(w,o),this._provider.set(w,{id:o,provider:I}),(0,P.toDisposable)(()=>{this._allKnownModels.delete(o),this._proxy.$unregisterEmbeddingProvider(w),this._provider.delete(w)})}async computeEmbeddings(p,o,I){I??=S.CancellationToken.None;let w=!1;typeof o=="string"&&(o=[o],w=!0);const a=await this._proxy.$computeEmbeddings(p,o,I);if(a.length!==o.length)throw new Error;if(w){if(a.length!==1)throw new Error;return a[0]}return a}async $provideEmbeddings(p,o,I){const w=this._provider.get(p);if(!w)return[];const a=await w.provider.provideEmbeddings(o,I);return a||[]}get embeddingsModels(){return Array.from(this._allKnownModels)}$acceptEmbeddingModels(p){this._allKnownModels=new Set(p),this._onDidChange.fire()}}e.ExtHostEmbeddings=A}),define(Le[215],Ne([1,0,4,5]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(A){this._handlePool=0,this._proxy=A.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const R=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(R,A),(0,S.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=P}),define(Le[85],Ne([1,0,20,12,2,3,11,5,26,16]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let I=class{constructor(a,y,h){this.logService=h,this.bundleCache=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadLocalization),this.currentLanguage=a.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===S.LANGUAGE_DEFAULT}getMessage(a,y){const{message:h,args:r,comment:s}=y;if(this.isDefaultLanguage)return(0,k.format2)(h,r??{});let l=h;s&&s.length>0&&(l+=`/${Array.isArray(s)?s.join(""):s}`);const c=this.bundleCache.get(a)?.contents[l];return c||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,k.format2)(c??h,r??{})}getBundle(a){return this.bundleCache.get(a)?.contents}getBundleUri(a){return this.bundleCache.get(a)?.uri}async initializeLocalizedMessages(a){if(this.isDefaultLanguage||!a.l10n&&!a.isBuiltin||this.bundleCache.has(a.identifier.value))return;let y;const h=await this.getBundleLocation(a);if(!h){this.logService.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const r=await this._proxy.$fetchBundleContents(h),s=JSON.parse(r);y=a.isBuiltin?s.contents?.bundle:s}catch(r){this.logService.error(`Failed to load translations for ${a.identifier.value} from ${h}: ${r.message}`);return}y&&this.bundleCache.set(a.identifier.value,{contents:y,uri:h})}async getBundleLocation(a){if(a.isBuiltin){const y=await this._proxy.$fetchBuiltInBundleUri(a.identifier.value,this.currentLanguage);return P.URI.revive(y)}return a.l10n?P.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=I,e.ExtHostLocalizationService=I=Ge([Ve(0,p.IExtHostInitDataService),Ve(1,o.IExtHostRpcService),Ve(2,A.ILogService)],I),e.IExtHostLocalizationService=(0,O.createDecorator)("IExtHostLocalizationService")}),define(Le[216],Ne([1,0,11,5,26,16,2,36]),function(Se,e,S,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let p=class extends S.AbstractLoggerService{constructor(w,a){super(a.logLevel,a.logsLocation,a.loggers.map(y=>(0,R.revive)(y))),this._proxy=w.getProxy(k.MainContext.MainThreadLogger)}$setLogLevel(w,a){a?this.setLogLevel(A.URI.revive(a),w):this.setLogLevel(w)}setVisibility(w,a){super.setVisibility(w,a),this._proxy.$setVisibility(w,a)}doCreateLogger(w,a,y){return new o(this._proxy,w,a,y)}};e.ExtHostLoggerService=p,e.ExtHostLoggerService=p=Ge([Ve(0,O.IExtHostRpcService),Ve(1,P.IExtHostInitDataService)],p);class o extends S.AbstractMessageLogger{constructor(w,a,y,h){super(h?.logLevel==="always"),this.proxy=w,this.file=a,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(y),this.proxy.$createLogger(a,h).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,a){const y=[[w,a]];this.isLoggerCreated?this.doLog(y):this.buffer.push(...y)}doLog(w){this.proxy.$log(this.file,w)}flush(){this.proxy.$flush(this.file)}}}),define(Le[86],Ne([1,0,5,3,4,16,22]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,k.createDecorator)("IExtHostManagedSockets");let R=class{constructor(w){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=w.getProxy(S.MainContext.MainThreadManagedSockets)}setFactory(w,a){for(const y of this._managedRemoteSockets.values())y.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new p(w,a),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(w){if(!this._factory||this._factory.socketFactoryId!==w)throw new Error(`No socket factory with id ${w}`);const a=++this._remoteSocketIdCounter,y=await this._factory.makeConnection(),h=new P.DisposableStore;return this._managedRemoteSockets.set(a,new o(a,y,h)),h.add((0,P.toDisposable)(()=>this._managedRemoteSockets.delete(a))),h.add(y.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(a),h.dispose()})),h.add(y.onDidClose(r=>{this._proxy.$onDidManagedSocketClose(a,r?.stack??r?.message),h.dispose()})),h.add(y.onDidReceiveMessage(r=>this._proxy.$onDidManagedSocketHaveData(a,A.VSBuffer.wrap(r)))),a}$remoteSocketWrite(w,a){this._managedRemoteSockets.get(w)?.actual.send(a.buffer)}$remoteSocketEnd(w){const a=this._managedRemoteSockets.get(w);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(w){await this._managedRemoteSockets.get(w)?.actual.drain?.()}};e.ExtHostManagedSockets=R,e.ExtHostManagedSockets=R=Ge([Ve(0,O.IExtHostRpcService)],R);class p{constructor(w,a){this.socketFactoryId=w,this.makeConnection=a}}class o extends P.Disposable{constructor(w,a,y){super(),this.socketId=w,this.actual=a,this._register(y)}}}),define(Le[217],Ne([1,0,5,11,24]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function O(R){return R&&R.title}let A=class{constructor(p,o){this._logService=o,this._proxy=p.getProxy(S.MainContext.MainThreadMessageService)}showMessage(p,o,I,w,a){const y={source:{identifier:p.identifier,label:p.displayName||p.name}};let h;typeof w=="string"||O(w)?h=[w,...a]:(y.modal=w?.modal,y.useCustom=w?.useCustom,y.detail=w?.detail,h=a),y.useCustom&&(0,P.checkProposedApiEnabled)(p,"resolvers");const r=[];let s=!1;for(let l=0;l<h.length;l++){const c=h[l];if(typeof c=="string")r.push({title:c,handle:l,isCloseAffordance:!1});else if(typeof c=="object"){const{title:i,isCloseAffordance:n}=c;r.push({title:i,isCloseAffordance:!!n,handle:l}),n&&(s?this._logService.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,c):s=!0)}else this._logService.warn(`[${p.identifier}] Invalid message item:`,c)}return this._proxy.$showMessage(o,I,y,r).then(l=>{if(typeof l=="number")return h[l]})}};e.ExtHostMessageService=A,e.ExtHostMessageService=A=Ge([Ve(1,k.ILogService)],A)}),define(Le[218],Ne([1,0,4,14,2,24,5]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(o){this.handlers=new Map,this.proxy=o.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(o,I,w){if((0,O.checkProposedApiEnabled)(o,"profileContentHandlers"),this.handlers.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.handlers.set(I,w),this.proxy.$registerProfileContentHandler(I,w.name,w.description,o.identifier.value),(0,S.toDisposable)(()=>{this.handlers.delete(I),this.proxy.$unregisterProfileContentHandler(I)})}async $saveProfile(o,I,w,a){const y=this.handlers.get(o);if(!y)throw new Error(`Unknown handler with id: ${o}`);return y.saveProfile(I,w,a)}async $readProfile(o,I,w){const a=this.handlers.get(o);if(!a)throw new Error(`Unknown handler with id: ${o}`);return a.readProfile((0,k.isString)(I)?I:P.URI.revive(I),w)}}e.ExtHostProfileContentHandlers=R}),define(Le[87],Ne([1,0,5,6,3]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class O{constructor(R){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=R.getProxy(S.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this._onDidChangePassword.fire(R)}get(R,p){return this._proxy.$getPassword(R,p)}store(R,p,o){return this._proxy.$setPassword(R,p,o)}delete(R,p){return this._proxy.$deletePassword(R,p)}}e.ExtHostSecretState=O,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")}),define(Le[219],Ne([1,0,21,4,5]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class O{static{this.ID_POOL=1}constructor(R){this.providers=new Map,this.sessions=new Map,this.synthesizers=new Map,this.proxy=R.getProxy(P.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(R,p,o){const I=this.providers.get(R);if(!I)return;const w=new k.DisposableStore,a=new S.CancellationTokenSource;this.sessions.set(p,a);const y=await I.provideSpeechToTextSession(a.token,o?{language:o}:void 0);y&&(w.add(y.onDidChange(h=>{a.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(p,h)})),w.add(a.token.onCancellationRequested(()=>w.dispose())))}async $cancelSpeechToTextSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}async $createTextToSpeechSession(R,p,o){const I=this.providers.get(R);if(!I)return;const w=new k.DisposableStore,a=new S.CancellationTokenSource;this.sessions.set(p,a);const y=await I.provideTextToSpeechSession(a.token,o?{language:o}:void 0);y&&(this.synthesizers.set(p,y),w.add(y.onDidChange(h=>{a.token.isCancellationRequested||this.proxy.$emitTextToSpeechEvent(p,h)})),w.add(a.token.onCancellationRequested(()=>w.dispose())))}async $synthesizeSpeech(R,p){this.synthesizers.get(R)?.synthesize(p)}async $cancelTextToSpeechSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R),this.synthesizers.delete(R)}async $createKeywordRecognitionSession(R,p){const o=this.providers.get(R);if(!o)return;const I=new k.DisposableStore,w=new S.CancellationTokenSource;this.sessions.set(p,w);const a=await o.provideKeywordRecognitionSession(w.token);a&&(I.add(a.onDidChange(y=>{w.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(p,y)})),I.add(w.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(R){this.sessions.get(R)?.dispose(!0),this.sessions.delete(R)}registerProvider(R,p,o){const I=O.ID_POOL++;return this.providers.set(I,o),this.proxy.$registerProvider(I,p,{extension:R,displayName:R.value}),(0,k.toDisposable)(()=>{this.proxy.$unregisterProvider(I),this.providers.delete(I)})}}e.ExtHostSpeech=O}),define(Le[88],Ne([1,0,5,6,3]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class O{constructor(R,p){this._logService=p,this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=R.getProxy(S.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,p){this._proxy.$registerExtensionStorageKeysToSync(R,p)}async initializeExtensionStorage(R,p,o){const I=await this._proxy.$initializeExtensionStorage(R,p);let w;return I&&(w=this.safeParseValue(R,p,I)),w||o}setValue(R,p,o){return this._proxy.$setValue(R,p,o)}$acceptValue(R,p,o){const I=this.safeParseValue(R,p,o);I&&this._onDidChangeStorage.fire({shared:R,key:p,value:I})}safeParseValue(R,p,o){try{return JSON.parse(o)}catch(I){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${R}): ${I}`)}}}e.ExtHostStorage=O,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(Le[220],Ne([1,0,4,15,2,5]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{static{this.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}constructor(p){this._openers=new Map,this._proxy=p.getProxy(O.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(p,o,I,w){if(this._openers.has(o))throw new Error(`Opener with id '${o}' already registered`);const a=w.schemes.find(y=>!A.supportedSchemes.has(y));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(o,I),this._proxy.$registerUriOpener(o,w.schemes,p,w.label),(0,S.toDisposable)(()=>{this._openers.delete(o),this._proxy.$unregisterUriOpener(o)})}async $canOpenUri(p,o,I){const w=this._openers.get(p);if(!w)throw new Error(`Unknown opener with id: ${p}`);const a=P.URI.revive(o);return w.canOpenExternalUri(a,I)}async $openUri(p,o,I){const w=this._openers.get(p);if(!w)throw new Error(`Unknown opener id: '${p}'`);return w.openExternalUri(P.URI.revive(o.resolvedUri),{sourceUri:P.URI.revive(o.sourceUri)},I)}}e.ExtHostUriOpeners=A}),define(Le[221],Ne([1,0,5,2,4,13,18]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{static{this.HandlePool=0}constructor(o){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=o.getProxy(S.MainContext.MainThreadUrls)}registerUriHandler(o,I){const w=o.identifier;if(this.handles.has(w))throw new Error(`Protocol handler already registered for extension ${w}`);const a=R.HandlePool++;return this.handles.add(w),this.handlers.set(a,I),this._proxy.$registerUriHandler(a,w,o.displayName||o.name),(0,P.toDisposable)(()=>{this.handles.delete(w),this.handlers.delete(a),this._proxy.$unregisterUriHandler(a)})}$handleExternalUri(o,I){const w=this.handlers.get(o);if(!w)return Promise.resolve(void 0);try{w.handleUri(k.URI.revive(I))}catch(a){(0,O.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(o){return k.URI.revive(await this._proxy.$createAppUri(o))}}e.ExtHostUrls=R}),define(Le[222],Ne([1,0,22,5]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=O,e.deserializeWebviewMessage=R,k=We(k);class P{constructor(){this.buffers=[]}add(o){let I=this.buffers.indexOf(o);return I<0&&(I=this.buffers.length,this.buffers.push(o)),I}}function O(p,o){if(o.serializeBuffersForPostMessage){const I=new P,a=JSON.stringify(p,(h,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r)};if(ArrayBuffer.isView(r)){const s=A(r);if(s)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r.buffer),view:{type:s,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),y=I.buffers.map(h=>{const r=new Uint8Array(h);return S.VSBuffer.wrap(r)});return{message:a,buffers:y}}else return{message:JSON.stringify(p),buffers:[]}}function A(p){switch(p.constructor.name){case"Int8Array":return k.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return k.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return k.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return k.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return k.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return k.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return k.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return k.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return k.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return k.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return k.WebviewMessageArrayBufferViewType.BigUint64Array}}function R(p,o){const I=o.map(y=>{const h=new ArrayBuffer(y.byteLength);return new Uint8Array(h).set(y.buffer),h}),w=o.length?(y,h)=>{if(h&&typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const r=h,{index:s}=r,l=I[s];if(r.view)switch(r.view.type){case k.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(l,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(l,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(l,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(l,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(l,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(l,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(l,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(l,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(l,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(l,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case k.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(l,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return h}:void 0;return{message:JSON.parse(p,w),arrayBuffers:I}}}),define(Le[67],Ne([1,0,6,4,15,25,2,175,222,82,5]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=a,e.toExtensionData=r,e.serializeWebviewOptions=s,O=We(O),I=We(I);class w{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;constructor(n,t,g,u,v,m,d){this.#a="",this.#l=!1,this.#c=!1,this._onMessageEmitter=new S.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new S.Emitter,this._onDidDispose=this.#d.event,this.#e=n,this.#t=t,this.#o=g,this.#n=u,this.#s=v,this.#r=m,this.#u=a(m),this.#h=y(m),this.#i=d}#d;dispose(){this.#l=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#c=!0,(0,o.asWebviewUri)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===P.Schemas.https||n.scheme===P.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+o.webviewGenericCspSource}return o.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(n){this.assertNotDisposed(),this.#a!==n&&(this.#a=n,this.#h&&!this.#c&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#c=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(n)))}get options(){return this.assertNotDisposed(),this.#o}set options(n){this.assertNotDisposed(),O.equals(this.#o,n)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#l)return!1;const t=(0,p.serializeWebviewMessage)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}assertNotDisposed(){if(this.#l)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(n){if(!this.#h)return n;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,g=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,v,m,d,C,_)=>{const E=A.URI.from({scheme:d||"file",path:decodeURIComponent(C)}),T=(0,o.asWebviewUri)(E,{isRemote:t,authority:g}).toString();return`${v}${T}${_}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,v,m,d,C,_)=>{const E=A.URI.from({scheme:d||"file",path:decodeURIComponent(C)}),T=(0,o.asWebviewUri)(E,{isRemote:t,authority:g}).toString();return`${v}${T}${_}`})}}e.ExtHostWebview=w;function a(i){try{const n=(0,R.normalizeVersion)((0,R.parseVersion)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function y(i){try{const n=(0,R.normalizeVersion)((0,R.parseVersion)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class h extends k.Disposable{constructor(n,t,g,u,v){super(),this.remoteInfo=t,this.workspace=g,this._logService=u,this._deprecationService=v,this._webviews=new Map,this._webviewProxy=n.getProxy(I.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const n of this._webviews.values())n.dispose();this._webviews.clear()}$onMessage(n,t,g){const u=this.getWebview(n);if(u){const{message:v}=(0,p.deserializeWebviewMessage)(t,g.value);u._onMessageEmitter.fire(v)}}$onMissingCsp(n,t){this._logService.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,g){const u=new w(n,this._webviewProxy,l(t),this.remoteInfo,this.workspace,g,this._deprecationService);this._webviews.set(n,u);const v=u._onDidDispose(()=>{v.dispose(),this.deleteWebview(n)});return u}deleteWebview(n){this._webviews.delete(n)}getWebview(n){return this._webviews.get(n)}}e.ExtHostWebviews=h;function r(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||c(i,n)}}function l(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>A.URI.from(n))}}function c(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Le[121],Ne([1,0,6,15,12,2,3,16,5]),function(Se,e,S,k,P,O,A,R,p){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class{static{o=this}static{this.InitialState={focused:!0,active:!0}}getState(){const a=this._state;return{get focused(){return a.focused},get active(){return a.active}}}constructor(a){this._onDidChangeWindowState=new S.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=o.InitialState,this._proxy=a.getProxy(p.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:y,isActive:h})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(a){this.onDidChangeWindowProperty("focused",a)}$onDidChangeWindowActive(a){this.onDidChangeWindowProperty("active",a)}onDidChangeWindowProperty(a,y){y!==this._state[a]&&(this._state={...this._state,[a]:y},this._onDidChangeWindowState.fire(this._state))}openUri(a,y){let h;if(typeof a=="string"){h=a;try{a=O.URI.parse(a)}catch{return Promise.reject(`Invalid uri - '${a}'`)}}return(0,P.isFalsyOrWhitespace)(a.scheme)?Promise.reject("Invalid scheme - cannot be empty"):a.scheme===k.Schemas.command?Promise.reject(`Invalid scheme '${a.scheme}'`):this._proxy.$openUri(a,h,y)}async asExternalUri(a,y){if((0,P.isFalsyOrWhitespace)(a.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(a,y);return O.URI.from(h)}};e.ExtHostWindow=I,e.ExtHostWindow=I=o=Ge([Ve(0,R.IExtHostRpcService)],I),e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Le[223],Ne([1,0,212,26,16]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let O=class extends S.AbstractExtHostConsoleForwarder{constructor(R,p){super(R,p)}_nativeConsoleLogMessage(R,p,o){p.apply(console,o)}};e.ExtHostConsoleForwarder=O,e.ExtHostConsoleForwarder=O=Ge([Ve(0,P.IExtHostRpcService),Ve(1,k.IExtHostInitDataService)],O)}),define(Le[224],Ne([1,0,10,22,21,27,13,6,4,37,150,210,39]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=c,e.parseJsonAndRestoreBufferRefs=i,A=We(A);function h(M,L){try{return JSON.stringify(M,L)}catch{return"null"}}const r="$$ref$$",s={[r]:-1};class l{constructor(L,N){this.jsonString=L,this.referencedBuffers=N}}function c(M,L=null,N=!1){const W=[];return{jsonString:(N?h:JSON.stringify)(M,($,K)=>{if(typeof K>"u")return s;if(typeof K=="object"){if(K instanceof k.VSBuffer){const q=W.push(K)-1;return{[r]:q}}if(L)return L($,K)}return K}),referencedBuffers:W}}function i(M,L,N){return JSON.parse(M,(W,j)=>{if(j){const $=j[r];if(typeof $=="number")return L[$];if(N&&j.$mid===o.MarshalledId.Uri)return N.transformIncoming(j)}return j})}function n(M,L){return JSON.stringify(M,L)}function t(M){return M?(L,N)=>N&&N.$mid===o.MarshalledId.Uri?M.transformOutgoing(N):N:null}var g;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var u;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const v=()=>{},m=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class C extends p.Disposable{static{y=m}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(L,N=null,W=null){super(),this[y]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=N,this._uriTransformer=W,this._uriReplacer=t(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let j=0,$=a.ProxyIdentifier.count;j<$;j++)this._locals[j]=null,this._proxies[j]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=u.Responsive,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new S.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._register(this._protocol.onMessage(j=>this._receiveOneMessage(j)))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{const N=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],N.resolveErr(A.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+C.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+C.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(u.Responsive)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(u.Unresponsive):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,I.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:N,sid:W}=L;return this._proxies[N]||(this._proxies[N]=this._createProxy(N,W)),this._proxies[N]}_createProxy(L,N){const W={get:(j,$)=>(typeof $=="string"&&!j[$]&&$.charCodeAt(0)===O.CharCode.DollarSign&&(j[$]=(...K)=>this._remoteCall(L,$,K)),$===d?N:j[$])};return new Proxy(Object.create(null),W)}set(L,N){return this._locals[L.nid]=N,N}assertRegistered(L){for(let N=0,W=L.length;N<W;N++){const j=L[N];if(!this._locals[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const N=L.byteLength,W=E.read(L,0),j=W.readUInt8(),$=W.readUInt32();switch(j){case f.RequestJSONArgs:case f.RequestJSONArgsWithCancellation:{let{rpcId:K,method:q,args:ae}=D.deserializeRequestJSONArgs(W);this._uriTransformer&&(ae=(0,I.transformIncomingURIs)(ae,this._uriTransformer)),this._receiveRequest(N,$,K,q,ae,j===f.RequestJSONArgsWithCancellation);break}case f.RequestMixedArgs:case f.RequestMixedArgsWithCancellation:{let{rpcId:K,method:q,args:ae}=D.deserializeRequestMixedArgs(W);this._uriTransformer&&(ae=(0,I.transformIncomingURIs)(ae,this._uriTransformer)),this._receiveRequest(N,$,K,q,ae,j===f.RequestMixedArgsWithCancellation);break}case f.Acknowledged:{this._logger?.logIncoming(N,$,g.LocalSide,"ack"),this._onDidReceiveAcknowledge($);break}case f.Cancel:{this._receiveCancel(N,$);break}case f.ReplyOKEmpty:{this._receiveReply(N,$,void 0);break}case f.ReplyOKJSON:{let K=D.deserializeReplyOKJSON(W);this._uriTransformer&&(K=(0,I.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(N,$,K);break}case f.ReplyOKJSONWithBuffers:{const K=D.deserializeReplyOKJSONWithBuffers(W,this._uriTransformer);this._receiveReply(N,$,K);break}case f.ReplyOKVSBuffer:{const K=D.deserializeReplyOKVSBuffer(W);this._receiveReply(N,$,K);break}case f.ReplyErrError:{let K=D.deserializeReplyErrError(W);this._uriTransformer&&(K=(0,I.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(N,$,K);break}case f.ReplyErrEmpty:{this._receiveReplyErr(N,$,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,N,W,j,$,K){this._logger?.logIncoming(L,N,g.OtherSide,`receiveRequest ${(0,a.getStringIdentifierForProxy)(W)}.${j}(`,$);const q=String(N);let ae,Ee;if(K){const Z=new P.CancellationTokenSource;$.push(Z.token),ae=this._invokeHandler(W,j,$),Ee=()=>Z.cancel()}else ae=this._invokeHandler(W,j,$),Ee=v;this._cancelInvokedHandlers[q]=Ee;const ce=D.serializeAcknowledged(N);this._logger?.logOutgoing(ce.byteLength,N,g.OtherSide,"ack"),this._protocol.send(ce),ae.then(Z=>{delete this._cancelInvokedHandlers[q];const le=D.serializeReplyOK(N,Z,this._uriReplacer);this._logger?.logOutgoing(le.byteLength,N,g.OtherSide,"reply:",Z),this._protocol.send(le)},Z=>{delete this._cancelInvokedHandlers[q];const le=D.serializeReplyErr(N,Z);this._logger?.logOutgoing(le.byteLength,N,g.OtherSide,"replyErr:",Z),this._protocol.send(le)})}_receiveCancel(L,N){this._logger?.logIncoming(L,N,g.OtherSide,"receiveCancel");const W=String(N);this._cancelInvokedHandlers[W]?.()}_receiveReply(L,N,W){this._logger?.logIncoming(L,N,g.LocalSide,"receiveReply:",W);const j=String(N);if(!this._pendingRPCReplies.hasOwnProperty(j))return;const $=this._pendingRPCReplies[j];delete this._pendingRPCReplies[j],$.resolveOk(W)}_receiveReplyErr(L,N,W){this._logger?.logIncoming(L,N,g.LocalSide,"receiveReplyErr:",W);const j=String(N);if(!this._pendingRPCReplies.hasOwnProperty(j))return;const $=this._pendingRPCReplies[j];delete this._pendingRPCReplies[j];let K;W&&(W.$isError?(K=new Error,K.name=W.name,K.message=W.message,K.stack=W.stack):K=W),$.resolveErr(K)}_invokeHandler(L,N,W){try{return Promise.resolve(this._doInvokeHandler(L,N,W))}catch(j){return Promise.reject(j)}}_doInvokeHandler(L,N,W){const j=this._locals[L];if(!j)throw new Error("Unknown actor "+(0,a.getStringIdentifierForProxy)(L));const $=j[N];if(typeof $!="function")throw new Error("Unknown method "+N+" on actor "+(0,a.getStringIdentifierForProxy)(L));return $.apply(j,W)}_remoteCall(L,N,W){if(this._isDisposed)return new w.CanceledLazyPromise;let j=null;if(W.length>0&&P.CancellationToken.isCancellationToken(W[W.length-1])&&(j=W.pop()),j&&j.isCancellationRequested)return Promise.reject(A.canceled());const $=D.serializeRequestArguments(W,this._uriReplacer),K=++this._lastMessageId,q=String(K),ae=new w.LazyPromise,Ee=new p.DisposableStore;j&&Ee.add(j.onCancellationRequested(()=>{const Z=D.serializeCancel(K);this._logger?.logOutgoing(Z.byteLength,K,g.LocalSide,"cancel"),this._protocol.send(D.serializeCancel(K))})),this._pendingRPCReplies[q]=new _(ae,Ee),this._onWillSendRequest(K);const ce=D.serializeRequest(K,L,N,$,!!j);return this._logger?.logOutgoing(ce.byteLength,K,g.LocalSide,`request: ${(0,a.getStringIdentifierForProxy)(L)}.${N}(`,W),this._protocol.send(ce),ae}}e.RPCProtocol=C;class _{constructor(L,N){this._promise=L,this._disposable=N}resolveOk(L){this._promise.resolveOk(L),this._disposable.dispose()}resolveErr(L){this._promise.resolveErr(L),this._disposable.dispose()}}class E{static alloc(L,N,W){const j=new E(k.VSBuffer.alloc(W+1+4),0);return j.writeUInt8(L),j.writeUInt32(N),j}static read(L,N){return new E(L,N)}get buffer(){return this._buff}constructor(L,N){this._buff=L,this._offset=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const W=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,W}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,W}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,N}static sizeMixedArray(L){let N=0;N+=1;for(let W=0,j=L.length;W<j;W++){const $=L[W];switch(N+=1,$.type){case b.String:N+=this.sizeLongString($.value);break;case b.VSBuffer:N+=this.sizeVSBuffer($.value);break;case b.SerializedObjectWithBuffers:N+=this.sizeUInt32,N+=this.sizeLongString($.value);for(let K=0;K<$.buffers.length;++K)N+=this.sizeVSBuffer($.buffers[K]);break;case b.Undefined:break}}return N}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let N=0,W=L.length;N<W;N++){const j=L[N];switch(j.type){case b.String:this.writeUInt8(b.String),this.writeLongString(j.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(j.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let $=0;$<j.buffers.length;++$)this.writeBuffer(j.buffers[$]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const N=new Array(L);for(let W=0;W<L;W++)switch(this.readUInt8()){case b.String:N[W]=this.readLongString();break;case b.VSBuffer:N[W]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const $=this.readUInt32(),K=this.readLongString(),q=[];for(let ae=0;ae<$;++ae)q.push(this.readVSBuffer());N[W]=new a.SerializableObjectWithBuffers(i(K,q,null));break}case b.Undefined:N[W]=void 0;break}return N}}var T;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(T||(T={}));class D{static _useMixedArgSerialization(L){for(let N=0,W=L.length;N<W;N++)if(L[N]instanceof k.VSBuffer||L[N]instanceof a.SerializableObjectWithBuffers||typeof L[N]>"u")return!0;return!1}static serializeRequestArguments(L,N){if(this._useMixedArgSerialization(L)){const W=[];for(let j=0,$=L.length;j<$;j++){const K=L[j];if(K instanceof k.VSBuffer)W[j]={type:b.VSBuffer,value:K};else if(typeof K>"u")W[j]={type:b.Undefined};else if(K instanceof a.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:ae}=c(K.value,N);W[j]={type:b.SerializedObjectWithBuffers,value:k.VSBuffer.fromString(q),buffers:ae}}else W[j]={type:b.String,value:k.VSBuffer.fromString(n(K,N))}}return{type:T.Mixed,args:W}}return{type:T.Simple,args:n(L,N)}}static serializeRequest(L,N,W,j,$){switch(j.type){case T.Simple:return this._requestJSONArgs(L,N,W,j.args,$);case T.Mixed:return this._requestMixedArgs(L,N,W,j.args,$)}}static _requestJSONArgs(L,N,W,j,$){const K=k.VSBuffer.fromString(W),q=k.VSBuffer.fromString(j);let ae=0;ae+=E.sizeUInt8(),ae+=E.sizeShortString(K),ae+=E.sizeLongString(q);const Ee=E.alloc($?f.RequestJSONArgsWithCancellation:f.RequestJSONArgs,L,ae);return Ee.writeUInt8(N),Ee.writeShortString(K),Ee.writeLongString(q),Ee.buffer}static deserializeRequestJSONArgs(L){const N=L.readUInt8(),W=L.readShortString(),j=L.readLongString();return{rpcId:N,method:W,args:JSON.parse(j)}}static _requestMixedArgs(L,N,W,j,$){const K=k.VSBuffer.fromString(W);let q=0;q+=E.sizeUInt8(),q+=E.sizeShortString(K),q+=E.sizeMixedArray(j);const ae=E.alloc($?f.RequestMixedArgsWithCancellation:f.RequestMixedArgs,L,q);return ae.writeUInt8(N),ae.writeShortString(K),ae.writeMixedArray(j),ae.buffer}static deserializeRequestMixedArgs(L){const N=L.readUInt8(),W=L.readShortString(),j=L.readMixedArray(),$=new Array(j.length);for(let K=0,q=j.length;K<q;K++){const ae=j[K];typeof ae=="string"?$[K]=JSON.parse(ae):$[K]=ae}return{rpcId:N,method:W,args:$}}static serializeAcknowledged(L){return E.alloc(f.Acknowledged,L,0).buffer}static serializeCancel(L){return E.alloc(f.Cancel,L,0).buffer}static serializeReplyOK(L,N,W){if(typeof N>"u")return this._serializeReplyOKEmpty(L);if(N instanceof k.VSBuffer)return this._serializeReplyOKVSBuffer(L,N);if(N instanceof a.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:$}=c(N.value,W,!0);return this._serializeReplyOKJSONWithBuffers(L,j,$)}else return this._serializeReplyOKJSON(L,h(N,W))}static _serializeReplyOKEmpty(L){return E.alloc(f.ReplyOKEmpty,L,0).buffer}static _serializeReplyOKVSBuffer(L,N){let W=0;W+=E.sizeVSBuffer(N);const j=E.alloc(f.ReplyOKVSBuffer,L,W);return j.writeVSBuffer(N),j.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,N){const W=k.VSBuffer.fromString(N);let j=0;j+=E.sizeLongString(W);const $=E.alloc(f.ReplyOKJSON,L,j);return $.writeLongString(W),$.buffer}static _serializeReplyOKJSONWithBuffers(L,N,W){const j=k.VSBuffer.fromString(N);let $=0;$+=E.sizeUInt32,$+=E.sizeLongString(j);for(const q of W)$+=E.sizeVSBuffer(q);const K=E.alloc(f.ReplyOKJSONWithBuffers,L,$);K.writeUInt32(W.length),K.writeLongString(j);for(const q of W)K.writeBuffer(q);return K.buffer}static deserializeReplyOKJSON(L){const N=L.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(L,N){const W=L.readUInt32(),j=L.readLongString(),$=[];for(let K=0;K<W;++K)$.push(L.readVSBuffer());return new a.SerializableObjectWithBuffers(i(j,$,N))}static serializeReplyErr(L,N){const W=N?h(A.transformErrorForSerialization(N),null):void 0;if(typeof W!="string")return this._serializeReplyErrEmpty(L);const j=k.VSBuffer.fromString(W);let $=0;$+=E.sizeLongString(j);const K=E.alloc(f.ReplyErrError,L,$);return K.writeLongString(j),K.buffer}static deserializeReplyErrError(L){const N=L.readLongString();return JSON.parse(N)}static _serializeReplyErrEmpty(L){return E.alloc(f.ReplyErrEmpty,L,0).buffer}}var f;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var b;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(b||(b={}))}),define(Le[225],Ne([1,0]),function(Se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const S=function(O){const A=R=>{globalThis.removeEventListener("message",A);const p=R.data;Object.defineProperties(globalThis,{postMessage:{value(o,I){p.postMessage(o,I)}},onmessage:{get(){return p.onmessage},set(o){p.onmessage=o}}}),p.addEventListener("message",o=>{globalThis.dispatchEvent(new MessageEvent("message",{data:o.data,ports:o.ports?[...o.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class k extends EventTarget{constructor(O,A,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${S})('${A}'))`,o=new Blob([p],{type:"application/javascript"}),I=URL.createObjectURL(o),w=new MessageChannel,a=I,y={type:"_newWorker",id:a,port:w.port2,url:I,options:R};O(y,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{O({type:"_terminateWorker",id:a}),URL.revokeObjectURL(I),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(h){w.port1.onmessage=h}},onmessageerror:{get(){return w.port1.onmessageerror},set(h){w.port1.onmessageerror=h}}}),w.port1.addEventListener("messageerror",h=>{const r=new MessageEvent("messageerror",{data:h.data});this.dispatchEvent(r)}),w.port1.addEventListener("message",h=>{const r=new MessageEvent("message",{data:h.data});this.dispatchEvent(r)}),w.port1.start()}}e.NestedWorker=k}),define(Le[226],Ne([1,0,22,28,15,60,3]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=I,e.generate=w,e.INotebookDocumentService=(0,A.createDecorator)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${R.join("")}]+`),o=7;function I(y){if(y.scheme!==P.Schemas.vscodeNotebookCell)return;const h=y.fragment.indexOf("s");if(h<0)return;const r=parseInt(y.fragment.substring(0,h).replace(p,""),o),s=(0,S.decodeBase64)(y.fragment.substring(h+1)).toString();if(!isNaN(r))return{handle:r,notebook:y.with({scheme:s,fragment:null})}}function w(y,h){const r=h.toString(o),l=`${r.length<R.length?R[r.length-1]:"z"}${r}s${(0,S.encodeBase64)(S.VSBuffer.fromString(y.scheme),!0,!0)}`;return y.with({scheme:P.Schemas.vscodeNotebookCell,fragment:l})}class a{constructor(){this._documents=new k.ResourceMap}getNotebook(h){if(h.scheme===P.Schemas.vscodeNotebookCell){const r=I(h);if(r){const s=this._documents.get(r.notebook);if(s)return s}}return this._documents.get(h)}addNotebookDocument(h){this._documents.set(h.uri,h)}removeNotebookDocument(h){this._documents.delete(h.uri)}}e.NotebookDocumentWorkbenchService=a,(0,O.registerSingleton)(e.INotebookDocumentService,a,O.InstantiationType.Delayed)}),define(Le[89],Ne([1,0,22,41,40,72,15,19,20,31,226]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookFindScopeType=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.EXECUTE_REPL_COMMAND_ID=e.REPL_EDITOR_ID=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=u,e.isDocumentExcludePattern=d,e.notebookDocumentFilterMatch=C,e.isTextStreamMime=T,e.compressOutputItemStreams=f,k=We(k),e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive",e.REPL_EDITOR_ID="workbench.editor.repl",e.EXECUTE_REPL_COMMAND_ID="replNotebook.input.execute";var w;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(w||(e.CellKind=w={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",O.Mimes.latex,O.Mimes.markdown,"image/png","image/jpeg",O.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[O.Mimes.latex,O.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var a;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})(a||(e.NotebookRunState=a={}));var y;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(y||(e.NotebookCellExecutionState=y={}));var h;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(h||(e.NotebookExecutionState=h={}));var r;(function(q){q[q.WithHardKernelDependency=0]="WithHardKernelDependency",q[q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",q[q.Pure=2]="Pure",q[q.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var s;(function(q){q.Always="always",q.Never="never",q.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var l;(function(q){q[q.ModelChange=1]="ModelChange",q[q.Move=2]="Move",q[q.ChangeCellLanguage=5]="ChangeCellLanguage",q[q.Initialize=6]="Initialize",q[q.ChangeCellMetadata=7]="ChangeCellMetadata",q[q.Output=8]="Output",q[q.OutputItem=9]="OutputItem",q[q.ChangeCellContent=10]="ChangeCellContent",q[q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",q[q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",q[q.ChangeCellMime=13]="ChangeCellMime",q[q.Unknown=100]="Unknown"})(l||(e.NotebookCellsChangeType=l={}));var c;(function(q){q[q.Handle=0]="Handle",q[q.Index=1]="Index"})(c||(e.SelectionStateType=c={}));var i;(function(q){q[q.Replace=1]="Replace",q[q.Output=2]="Output",q[q.Metadata=3]="Metadata",q[q.CellLanguage=4]="CellLanguage",q[q.DocumentMetadata=5]="DocumentMetadata",q[q.Move=6]="Move",q[q.OutputItems=7]="OutputItems",q[q.PartialMetadata=8]="PartialMetadata",q[q.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(q){q.scheme=A.Schemas.vscodeNotebookCell;function ae(oe,De){return(0,I.generate)(oe,De)}q.generate=ae;function Ee(oe){return(0,I.parse)(oe)}q.parse=Ee;function ce(oe,De){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${De??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}q.generateCellOutputUri=ce;function Z(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const De=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!De)return;const Re=De[1]&&De[1]!==""?De[1]:void 0,Q=De[2];return{outputId:Re,notebook:oe.with({scheme:Q||A.Schemas.file,fragment:null})}}q.parseCellOutputUri=Z;function le(oe,De,Re){return q.generate(oe,De).with({scheme:Re})}q.generateCellPropertyUri=le;function me(oe,De){if(oe.scheme===De)return q.parse(oe.with({scheme:q.scheme}))}q.parseCellPropertyUri=me})(n||(e.CellUri=n={}));const t=q=>p.isWindows?q.replace(/\//g,"\\"):q;class g{constructor(ae=[],Ee=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=Ee,this.order=[...new Set(ae)].map(ce=>({pattern:ce,matches:k.parse(t(ce))}))}sort(ae){const Ee=new Map(P.Iterable.map(ae,Z=>[Z,t(Z)]));let ce=[];for(const{matches:Z}of this.order)for(const[le,me]of Ee)if(Z(me)){ce.push(le),Ee.delete(le);break}return Ee.size&&(ce=ce.concat([...Ee.keys()].sort((Z,le)=>this.defaultOrder.indexOf(Z)-this.defaultOrder.indexOf(le)))),ce}prioritize(ae,Ee){const ce=this.findIndex(ae);if(ce===-1){this.order.unshift({pattern:ae,matches:k.parse(t(ae))});return}const Z=new Set(Ee.map(me=>this.findIndex(me,ce)));Z.delete(-1);const le=Array.from(Z).sort();this.order.splice(ce+1,0,...le.map(me=>this.order[me]));for(let me=le.length-1;me>=0;me--)this.order.splice(le[me],1)}toArray(){return this.order.map(ae=>ae.pattern)}findIndex(ae,Ee=this.order.length){const ce=t(ae);for(let Z=0;Z<Ee;Z++)if(this.order[Z].matches(ce))return Z;return-1}}e.MimeTypeDisplayOrder=g;function u(q,ae,Ee,ce=(Z,le)=>Z===le){const Z=[];function le(De,Re,Q){if(Re===0&&Q.length===0)return;const z=Z[Z.length-1];z&&z.start+z.deleteCount===De?(z.deleteCount+=Re,z.toInsert.push(...Q)):Z.push({start:De,deleteCount:Re,toInsert:Q})}let me=0,oe=0;for(;;){if(me===q.length){le(me,0,ae.slice(oe));break}if(oe===ae.length){le(me,q.length-me,[]);break}const De=q[me],Re=ae[oe];if(ce(De,Re)){me+=1,oe+=1;continue}Ee(Re)?(le(me,1,[]),me+=1):(le(me,0,[Re]),oe+=1)}return Z}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new o.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new o.RawContextKey("notebookEditorCursorAtLineBoundary","none");var v;(function(q){q.default="default",q.option="option"})(v||(e.NotebookEditorPriority=v={}));var m;(function(q){q.Cells="cells",q.Text="text",q.None="none"})(m||(e.NotebookFindScopeType=m={}));function d(q){const ae=q;return!!((typeof ae.include=="string"||k.isRelativePattern(ae.include))&&(typeof ae.exclude=="string"||k.isRelativePattern(ae.exclude)))}function C(q,ae,Ee){if(Array.isArray(q.viewType)&&q.viewType.indexOf(ae)>=0||q.viewType===ae)return!0;if(q.filenamePattern){const ce=d(q.filenamePattern)?q.filenamePattern.include:q.filenamePattern,Z=d(q.filenamePattern)?q.filenamePattern.exclude:void 0;if(k.match(ce,(0,R.basename)(Ee.fsPath).toLowerCase()))return!(Z&&k.match(Z,(0,R.basename)(Ee.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var _;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(_||(e.CellStatusbarAlignment=_={}));class E{static{this._prefix="notebook/"}static create(ae){return`${E._prefix}${ae}`}static parse(ae){if(ae.startsWith(E._prefix))return ae.substring(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E;function T(q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(q)}const D=new TextDecoder;function f(q){const ae=[];let Ee=!1;for(const me of q)(ae.length===0||Ee)&&(ae.push(me),Ee=!0);let ce=L(ae);const Z=S.VSBuffer.concat(ae.map(me=>S.VSBuffer.wrap(me))),le=K(Z);return ce=ce||le.byteLength!==Z.byteLength,{data:le,didCompression:ce}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const b=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(q=>q.charCodeAt(0)),M=10;function L(q){let ae=!1;return q.forEach((Ee,ce)=>{if(ce===0||Ee.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const Z=q[ce-1],le=Ee.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(le[0]===b[0]&&le[1]===b[1]&&le[2]===b[2]){const me=Z.lastIndexOf(M);if(me===-1)return;ae=!0,q[ce-1]=Z.subarray(0,me),q[ce]=Ee.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ae}function N(q){let ae=q;do q=ae,ae=q.replace(/[^\n]\x08/gm,"");while(ae.length<q.length);return q}function W(q){for(q=q.replace(/\r+\n/gm,`
`);q.search(/\r[^$]/g)>-1;){const ae=q.match(/^(.*)\r+/m)[1];let Ee=q.match(/\r+(.*)$/m)[1];Ee=Ee+ae.slice(Ee.length,ae.length),q=q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Ee)}return q}const j=8,$=13;function K(q){return!q.buffer.includes(j)&&!q.buffer.includes($)?q:S.VSBuffer.fromString(W(N(D.decode(q.buffer))))}}),define(Le[7],Ne([1,0,17,13,59,28,72,12,14,2,38,18,29,109,89]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h){"use strict";var r,s,l,c,i,n,t,g,u,v,m,d,C,_,E,T,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.LanguageModelTextPart=e.LanguageModelFunctionUsePart=e.LanguageModelChatMessage=e.LanguageModelFunctionResultPart=e.LanguageModelChatMessageRole=e.ChatRequestNotebookData=e.ChatRequestEditorData=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart2=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestMessageStackFrame=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.QuickInputButtonLocation=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.getDebugDescriptionOfRange=$,e.getDebugDescriptionOfSelection=K,e.asStatusBarItemIdentifier=bt,e.setBreakpointId=Ni,e.validateTestCoverageCount=kn;function f(U){return Object.assign(U,{apply:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const ye=se.length===1?[]:se[1];return Reflect.construct(U,ye,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const[ye,...je]=se;return Reflect.construct(U,je,ye.constructor)}}})}var b;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var M;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let L=r=class{static from(...F){let se=F;return new r(function(){if(se){for(const ye of se)ye&&typeof ye.dispose=="function"&&ye.dispose();se=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=L,e.Disposable=L=r=Ge([f],L);let N=s=class{static Min(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let ye=1;ye<F.length;ye++){const je=F[ye];je.isBefore(se)&&(se=je)}return se}static Max(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let ye=1;ye<F.length;ye++){const je=F[ye];je.isAfter(se)&&(se=je)}return se}static isPosition(F){if(!F)return!1;if(F instanceof s)return!0;const{line:se,character:ye}=F;return typeof se=="number"&&typeof ye=="number"}static of(F){if(F instanceof s)return F;if(this.isPosition(F))return new s(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(F,se){if(F<0)throw(0,k.illegalArgument)("line must be non-negative");if(se<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=F,this._character=se}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,se=0){if(F===null||se===null)throw(0,k.illegalArgument)();let ye;return typeof F>"u"?ye=0:typeof F=="number"?ye=F:(ye=typeof F.lineDelta=="number"?F.lineDelta:0,se=typeof F.characterDelta=="number"?F.characterDelta:0),ye===0&&se===0?this:new s(this.line+ye,this.character+se)}with(F,se=this.character){if(F===null||se===null)throw(0,k.illegalArgument)();let ye;return typeof F>"u"?ye=this.line:typeof F=="number"?ye=F:(ye=typeof F.line=="number"?F.line:this.line,se=typeof F.character=="number"?F.character:this.character),ye===this.line&&se===this.character?this:new s(ye,se)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.Position=N,e.Position=N=s=Ge([f],N);let W=l=class{static isRange(F){return F instanceof l?!0:F?N.isPosition(F.start)&&N.isPosition(F.end):!1}static of(F){if(F instanceof l)return F;if(this.isRange(F))return new l(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(F,se,ye,je){let it,ht;if(typeof F=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof je=="number"?(it=new N(F,se),ht=new N(ye,je)):N.isPosition(F)&&N.isPosition(se)&&(it=N.of(F),ht=N.of(se)),!it||!ht)throw new Error("Invalid arguments");it.isBefore(ht)?(this._start=it,this._end=ht):(this._start=ht,this._end=it)}contains(F){return l.isRange(F)?this.contains(F.start)&&this.contains(F.end):N.isPosition(F)?!(N.of(F).isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const se=N.Max(F.start,this._start),ye=N.Min(F.end,this._end);if(!se.isAfter(ye))return new l(se,ye)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const se=N.Min(F.start,this._start),ye=N.Max(F.end,this.end);return new l(se,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,se=this.end){if(F===null||se===null)throw(0,k.illegalArgument)();let ye;return F?N.isPosition(F)?ye=F:(ye=F.start||this.start,se=F.end||this.end):ye=this.start,ye.isEqual(this._start)&&se.isEqual(this.end)?this:new l(ye,se)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return $(this)}};e.Range=W,e.Range=W=l=Ge([f],W);let j=c=class extends W{static isSelection(F){return F instanceof c?!0:F?W.isRange(F)&&N.isPosition(F.anchor)&&N.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(F,se,ye,je){let it,ht;if(typeof F=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof je=="number"?(it=new N(F,se),ht=new N(ye,je)):N.isPosition(F)&&N.isPosition(se)&&(it=N.of(F),ht=N.of(se)),!it||!ht)throw new Error("Invalid arguments");super(it,ht),this._anchor=it,this._active=ht}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return K(this)}};e.Selection=j,e.Selection=j=c=Ge([f],j);function $(U){return U.isEmpty?`[${U.start.line}:${U.start.character})`:`[${U.start.line}:${U.start.character} -> ${U.end.line}:${U.end.character})`}function K(U){let F=$(U);return U.isEmpty||(U.active.isEqual(U.start)?F=`|${F}`:F=`${F}|`),F}const q=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,k.illegalArgument)("connectionToken")};class ae{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,se,ye){if(typeof F!="string"||F.length===0)throw(0,k.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,k.illegalArgument)("port");typeof ye<"u"&&q(ye),this.host=F,this.port=Math.round(se),this.connectionToken=ye}}e.ResolvedAuthority=ae;class Ee{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,se){this.makeConnection=F,this.connectionToken=se,typeof se<"u"&&q(se)}}e.ManagedResolvedAuthority=Ee;class ce extends Error{static NotAvailable(F,se){return new ce(F,y.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(F){return new ce(F,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,se=y.RemoteAuthorityResolverErrorCode.Unknown,ye){super(F),this._message=F,this._code=se,this._detail=ye,Object.setPrototypeOf(this,ce.prototype)}}e.RemoteAuthorityResolverError=ce;var Z;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var le;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(le||(e.EnvironmentVariableMutatorType=le={}));let me=i=class{static isTextEdit(F){return F instanceof i?!0:F?W.isRange(F)&&typeof F.newText=="string":!1}static replace(F,se){return new i(F,se)}static insert(F,se){return i.replace(new W(F,F),se)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const se=new i(new W(new N(0,0),new N(0,0)),"");return se.newEol=F,se}get range(){return this._range}set range(F){if(F&&!W.isRange(F))throw(0,k.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,k.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,k.illegalArgument)("newEol");this._newEol=F}constructor(F,se){this._range=F,this._newText=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=me,e.TextEdit=me=i=Ge([f],me);let oe=n=class{static isNotebookCellEdit(F){return F instanceof n?!0:F?wi.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,se){return new n(F,se)}static insertCells(F,se){return new n(new wi(F,F),se)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,se){const ye=new n(new wi(F,F),[]);return ye.newCellMetadata=se,ye}static updateNotebookMetadata(F){const se=new n(new wi(0,0),[]);return se.newNotebookMetadata=F,se}constructor(F,se){this.range=F,this.newCells=se}};e.NotebookEdit=oe,e.NotebookEdit=oe=n=Ge([f],oe);class De{static isSnippetTextEdit(F){return F instanceof De?!0:F?W.isRange(F.range)&&z.isSnippetString(F.snippet):!1}static replace(F,se){return new De(F,se)}static insert(F,se){return De.replace(new W(F,F),se)}constructor(F,se){this.range=F,this.snippet=se}}e.SnippetTextEdit=De;var Re;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(Re||(e.FileEditType=Re={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,se,ye,je){this._edits.push({_type:Re.File,from:F,to:se,options:ye,metadata:je})}createFile(F,se,ye){this._edits.push({_type:Re.File,from:void 0,to:F,options:se,metadata:ye})}deleteFile(F,se,ye){this._edits.push({_type:Re.File,from:F,to:void 0,options:se,metadata:ye})}replaceNotebookMetadata(F,se,ye){this._edits.push({_type:Re.Cell,metadata:ye,uri:F,edit:{editType:h.CellEditType.DocumentMetadata,metadata:se},notebookMetadata:se})}replaceNotebookCells(F,se,ye,je){const it=se.start,ht=se.end;(it!==ht||ye.length>0)&&this._edits.push({_type:Re.CellReplace,uri:F,index:it,count:ht-it,cells:ye,metadata:je})}replaceNotebookCellMetadata(F,se,ye,je){this._edits.push({_type:Re.Cell,metadata:je,uri:F,edit:{editType:h.CellEditType.Metadata,index:se,metadata:ye}})}replace(F,se,ye,je){this._edits.push({_type:Re.Text,uri:F,edit:new me(se,ye),metadata:je})}insert(F,se,ye,je){this.replace(F,new W(se,se),ye,je)}delete(F,se,ye){this.replace(F,se,"",ye)}has(F){return this._edits.some(se=>se._type===Re.Text&&se.uri.toString()===F.toString())}set(F,se){if(se)for(const ye of se){if(!ye)continue;let je,it;Array.isArray(ye)?(je=ye[0],it=ye[1]):je=ye,oe.isNotebookCellEdit(je)?je.newCellMetadata?this.replaceNotebookCellMetadata(F,je.range.start,je.newCellMetadata,it):je.newNotebookMetadata?this.replaceNotebookMetadata(F,je.newNotebookMetadata,it):this.replaceNotebookCells(F,je.range,je.newCells,it):De.isSnippetTextEdit(je)?this._edits.push({_type:Re.Snippet,uri:F,range:je.range,edit:je.snippet,metadata:it}):this._edits.push({_type:Re.Text,uri:F,edit:je,metadata:it})}else{for(let ye=0;ye<this._edits.length;ye++){const je=this._edits[ye];switch(je._type){case Re.Text:case Re.Snippet:case Re.Cell:case Re.CellReplace:je.uri.toString()===F.toString()&&(this._edits[ye]=void 0);break}}(0,S.coalesceInPlace)(this._edits)}}get(F){const se=[];for(const ye of this._edits)ye._type===Re.Text&&ye.uri.toString()===F.toString()&&se.push(ye.edit);return se}entries(){const F=new O.ResourceMap;for(const se of this._edits)if(se._type===Re.Text){let ye=F.get(se.uri);ye||(ye=[se.uri,[]],F.set(se.uri,ye)),ye[1].push(se.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Q,e.WorkspaceEdit=Q=Ge([f],Q);let z=t=class{static isSnippetString(F){return F instanceof t?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this._tabstop=1,this.value=F||""}appendText(F){return this.value+=t._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,se=this._tabstop++){if(typeof F=="function"){const ye=new t;ye._tabstop=this._tabstop,F(ye),this._tabstop=ye._tabstop,F=ye.value}else F=t._escape(F);return this.value+="${",this.value+=se,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,se=this._tabstop++){const ye=F.map(je=>je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(F,se){if(typeof se=="function"){const ye=new t;ye._tabstop=this._tabstop,se(ye),this._tabstop=ye._tabstop,se=ye.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.SnippetString=z,e.SnippetString=z=t=Ge([f],z);var ne;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var Ce;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(Ce||(e.DiagnosticSeverity=Ce={}));let fe=g=class{static isLocation(F){return F instanceof g?!0:F?W.isRange(F.range)&&o.URI.isUri(F.uri):!1}constructor(F,se){if(this.uri=F,se)if(W.isRange(se))this.range=W.of(se);else if(N.isPosition(se))this.range=new W(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=fe,e.Location=fe=g=Ge([f],fe);let be=class{static is(F){return F?typeof F.message=="string"&&F.location&&W.isRange(F.location.range)&&o.URI.isUri(F.location.uri):!1}constructor(F,se){this.location=F,this.message=se}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.location.range.isEqual(se.location.range)&&F.location.uri.toString()===se.location.uri.toString()}};e.DiagnosticRelatedInformation=be,e.DiagnosticRelatedInformation=be=Ge([f],be);let de=class{constructor(F,se,ye=Ce.Error){if(!W.isRange(F))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=F,this.message=se,this.severity=ye}toJSON(){return{severity:Ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.severity===se.severity&&F.code===se.code&&F.severity===se.severity&&F.source===se.source&&F.range.isEqual(se.range)&&(0,S.equals)(F.tags,se.tags)&&(0,S.equals)(F.relatedInformation,se.relatedInformation,be.isEqual)}};e.Diagnostic=de,e.Diagnostic=de=Ge([f],de);let X=class{constructor(F,se){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=se}};e.Hover=X,e.Hover=X=Ge([f],X);let J=class extends X{constructor(F,se,ye,je){super(F,se),this.canIncreaseVerbosity=ye,this.canDecreaseVerbosity=je}};e.VerboseHover=J,e.VerboseHover=J=Ge([f],J);var ve;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(ve||(e.HoverVerbosityAction=ve={}));var pe;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(pe||(e.DocumentHighlightKind=pe={}));let Ae=class{constructor(F,se=pe.Text){this.range=F,this.kind=se}toJSON(){return{range:this.range,kind:pe[this.kind]}}};e.DocumentHighlight=Ae,e.DocumentHighlight=Ae=Ge([f],Ae);let Ue=class{constructor(F,se){this.uri=F,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.MultiDocumentHighlight=Ue,e.MultiDocumentHighlight=Ue=Ge([f],Ue);var Ie;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Ie||(e.SymbolKind=Ie={}));var Pe;(function(U){U[U.Deprecated=1]="Deprecated"})(Pe||(e.SymbolTag=Pe={}));let Oe=u=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,se,ye,je,it){this.name=F,this.kind=se,this.containerName=it,typeof ye=="string"&&(this.containerName=ye),je instanceof fe?this.location=je:ye instanceof W&&(this.location=new fe(je,ye)),u.validate(this)}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Oe,e.SymbolInformation=Oe=u=Ge([f],Oe);let x=v=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(v.validate)}constructor(F,se,ye,je,it){this.name=F,this.detail=se,this.kind=ye,this.range=je,this.selectionRange=it,this.children=[],v.validate(this)}};e.DocumentSymbol=x,e.DocumentSymbol=x=v=Ge([f],x);var B;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let H=class{constructor(F,se){this.title=F,this.kind=se}};e.CodeAction=H,e.CodeAction=H=Ge([f],H);let V=class{static{m=this}static{this.sep="."}constructor(F){this.value=F}append(F){return new m(this.value?this.value+m.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+m.sep)}};e.CodeActionKind=V,e.CodeActionKind=V=m=Ge([f],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let re=class{constructor(F,se){if(this.range=F,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=re,e.SelectionRange=re=Ge([f],re);class ge{constructor(F,se,ye,je,it,ht){this.kind=F,this.name=se,this.detail=ye,this.uri=je,this.range=it,this.selectionRange=ht}}e.CallHierarchyItem=ge;class Te{constructor(F,se){this.fromRanges=se,this.from=F}}e.CallHierarchyIncomingCall=Te;class xe{constructor(F,se){this.fromRanges=se,this.to=F}}e.CallHierarchyOutgoingCall=xe;var qe;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(qe||(e.LanguageStatusSeverity=qe={}));let Ze=class{constructor(F,se){this.range=F,this.command=se}get isResolved(){return!!this.command}};e.CodeLens=Ze,e.CodeLens=Ze=Ge([f],Ze);let tt=d=class{#e;static isMarkdownString(F){return F instanceof d?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,se=!1){this.#e=new P.MarkdownString(F,{supportThemeIcons:se})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,se){return this.#e.appendCodeblock(se??"",F),this}};e.MarkdownString=tt,e.MarkdownString=tt=d=Ge([f],tt);let nt=class{constructor(F,se){this.label=F,this.documentation=se}};e.ParameterInformation=nt,e.ParameterInformation=nt=Ge([f],nt);let et=class{constructor(F,se){this.label=F,this.documentation=se,this.parameters=[]}};e.SignatureInformation=et,e.SignatureInformation=et=Ge([f],et);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=rt,e.SignatureHelp=rt=Ge([f],rt);var ft;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(ft||(e.SignatureHelpTriggerKind=ft={}));var ct;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(ct||(e.InlayHintKind=ct={}));let st=class{constructor(F){this.value=F}};e.InlayHintLabelPart=st,e.InlayHintLabelPart=st=Ge([f],st);let lt=class{constructor(F,se,ye){this.position=F,this.label=se,this.kind=ye}};e.InlayHint=lt,e.InlayHint=lt=Ge([f],lt);var mt;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(mt||(e.CompletionTriggerKind=mt={}));var vt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var $e;(function(U){U[U.Deprecated=1]="Deprecated"})($e||(e.CompletionItemTag=$e={}));let Be=class{constructor(F,se){this.label=F,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Be,e.CompletionItem=Be=Ge([f],Be);let ie=class{constructor(F=[],se=!1){this.items=F,this.isIncomplete=se}};e.CompletionList=ie,e.CompletionList=ie=Ge([f],ie);let ee=class{constructor(F,se,ye){this.insertText=F,this.range=se,this.command=ye}};e.InlineSuggestion=ee,e.InlineSuggestion=ee=Ge([f],ee);let Y=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.InlineSuggestionList=Y,e.InlineSuggestionList=Y=Ge([f],Y);var Xe;(function(U){U[U.Unknown=0]="Unknown",U[U.Word=1]="Word",U[U.Line=2]="Line",U[U.Suggest=3]="Suggest"})(Xe||(e.PartialAcceptTriggerKind=Xe={}));var Je;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Je||(e.ViewColumn=Je={}));var dt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(dt||(e.StatusBarAlignment=dt={}));function bt(U,F){return`${w.ExtensionIdentifier.toKey(U)}.${F}`}var Mt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(Mt||(e.TextEditorLineNumbersStyle=Mt={}));var Ht;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var Zt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Zt||(e.TextEditorRevealType=Zt={}));var ei;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(ei||(e.TextEditorSelectionChangeKind=ei={}));var oi;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(oi||(e.TextDocumentChangeReason=oi={}));var At;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(At||(e.DecorationRangeBehavior=At={})),function(U){function F(se){switch(se){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=F}(ei||(e.TextEditorSelectionChangeKind=ei={}));var Ye;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ye||(e.SyntaxTokenType=Ye={})),function(U){function F(se){switch(se){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=F}(Ye||(e.SyntaxTokenType=Ye={}));let Tt=class{constructor(F,se){if(se&&!o.URI.isUri(se))throw(0,k.illegalArgument)("target");if(!W.isRange(F)||F.isEmpty)throw(0,k.illegalArgument)("range");this.range=F,this.target=se}};e.DocumentLink=Tt,e.DocumentLink=Tt=Ge([f],Tt);let di=class{constructor(F,se,ye,je){this.red=F,this.green=se,this.blue=ye,this.alpha=je}};e.Color=di,e.Color=di=Ge([f],di);let pt=class{constructor(F,se){if(se&&!(se instanceof di))throw(0,k.illegalArgument)("color");if(!W.isRange(F)||F.isEmpty)throw(0,k.illegalArgument)("range");this.range=F,this.color=se}};e.ColorInformation=pt,e.ColorInformation=pt=Ge([f],pt);let _t=class{constructor(F){if(!F||typeof F!="string")throw(0,k.illegalArgument)("label");this.label=F}};e.ColorPresentation=_t,e.ColorPresentation=_t=Ge([f],_t);var ti;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ii;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Bt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Bt||(e.TerminalExitReason=Bt={}));var gt;(function(U){U[U.Low=0]="Low",U[U.Medium=1]="Medium",U[U.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class xt{constructor(F,se,ye){if(this.startIndex=F,this.length=se,this.tooltip=ye,typeof F!="number"||F<0)throw(0,k.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,k.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=xt;class ni{constructor(F){this.uri=F}}e.TerminalQuickFixOpener=ni;class ai{constructor(F){this.terminalCommand=F}}e.TerminalQuickFixCommand=ai;var Ke;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Ke||(e.TerminalLocation=Ke={}));class li{constructor(F){if(this.options=F,typeof F!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=li;var hi;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(hi||(e.TaskRevealKind=hi={}));var fi;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(fi||(e.TaskPanelKind=fi={}));let St=class{static{C=this}static{this.Clean=new C("clean","Clean")}static{this.Build=new C("build","Build")}static{this.Rebuild=new C("rebuild","Rebuild")}static{this.Test=new C("test","Test")}static from(F){switch(F){case"clean":return C.Clean;case"build":return C.Build;case"rebuild":return C.Rebuild;case"test":return C.Test;default:return}}constructor(F,se){if(this.label=se,typeof F!="string"||typeof se!="string")throw(0,k.illegalArgument)("name");this._id=F}get id(){return this._id}};e.TaskGroup=St,e.TaskGroup=St=C=Ge([f],St);function Ft(U){let F="";for(let se=0;se<U.length;se++)F+=U[se].replace(/,/g,",,")+",";return F}let Lt=class{constructor(F,se,ye){if(typeof F!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=F,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=ye):this._options=se)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,k.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(const se of this._args)F.push(se);return Ft(F)}};e.ProcessExecution=Lt,e.ProcessExecution=Lt=Ge([f],Lt);let Wt=class{constructor(F,se,ye){if(this._args=[],Array.isArray(se)){if(!F)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,k.illegalArgument)("command");this._command=F,this._args=se,this._options=ye}else{if(typeof F!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=F,this._options=se}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,k.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const se of this._args)F.push(typeof se=="string"?se:se.value);return Ft(F)}};e.ShellExecution=Wt,e.ShellExecution=Wt=Ge([f],Wt);var ri;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var jt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(jt||(e.TaskScope=jt={}));class ci{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=ci;let zt=class{static{_=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(F,se,ye,je,it,ht){this.__deprecated=!1,this._definition=this.definition=F;let Ct;typeof se=="string"?(this._name=this.name=se,this._source=this.source=ye,this.execution=je,Ct=it,this.__deprecated=!0):se===jt.Global||se===jt.Workspace?(this.target=se,this._name=this.name=ye,this._source=this.source=je,this.execution=it,Ct=ht):(this.target=se,this._name=this.name=ye,this._source=this.source=je,this.execution=it,Ct=ht),typeof Ct=="string"?(this._problemMatchers=[Ct],this._hasDefinedMatchers=!0):Array.isArray(Ct)?(this._problemMatchers=Ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Lt?this._definition={type:_.ProcessType,id:this._execution.computeId()}:this._execution instanceof Wt?this._definition={type:_.ShellType,id:this._execution.computeId()}:this._execution instanceof ci?this._definition={type:_.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:_.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const se=this._definition.type;(_.EmptyType===se||_.ProcessType===se||_.ShellType===se||_.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};e.Task=zt,e.Task=zt=_=Ge([f],zt);var qt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(qt||(e.ProgressLocation=qt={}));var Kt;(function(U){function F(se){const ye=se;return(0,p.isNumber)(ye.value)?ye.tooltip&&!(0,p.isString)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}U.isViewBadge=F})(Kt||(e.ViewBadge=Kt={}));let Nt=E=class{static isTreeItem(F,se){const ye=F;if(ye.checkboxState!==void 0){const je=(0,p.isNumber)(ye.checkboxState)?ye.checkboxState:(0,p.isObject)(ye.checkboxState)&&(0,p.isNumber)(ye.checkboxState.state)?ye.checkboxState.state:void 0,it=!(0,p.isNumber)(ye.checkboxState)&&(0,p.isObject)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(je===void 0||je!==Dt.Checked&&je!==Dt.Unchecked||it!==void 0&&!(0,p.isString)(it))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(F instanceof E)return!0;if(ye.label!==void 0&&!(0,p.isString)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,p.isString)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,p.isString)(ye.iconPath)&&!o.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,p.isString)(ye.iconPath.id))){const je=ye.iconPath;if(!je||!(0,p.isString)(je.light)&&!o.URI.isUri(je.light)&&!(0,p.isString)(je.dark)&&!o.URI.isUri(je.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,p.isString)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!o.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,p.isString)(ye.tooltip)&&!(ye.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<Et.None&&ye.collapsibleState>Et.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,p.isString)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(F,se=Et.None){this.collapsibleState=se,o.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.TreeItem=Nt,e.TreeItem=Nt=E=Ge([f],Nt);var Et;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Et||(e.TreeItemCollapsibleState=Et={}));var Dt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let Vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.DataTransferItem=Vt,e.DataTransferItem=Vt=Ge([f],Vt);class It extends Vt{}e.InternalDataTransferItem=It;class mi extends It{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.InternalFileDataTransferItem=mi;class Qt{constructor(F,se,ye,je){this.name=F,this.uri=se,this._itemId=ye,this._getData=je}data(){return this._getData()}}e.DataTransferFile=Qt;let Di=class{#e=new Map;constructor(F){for(const[se,ye]of F??[]){const je=this.#e.get(this.#t(se));je?je.push(ye):this.#e.set(this.#t(se),[ye])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,se){this.#e.set(this.#t(F),[se])}forEach(F,se){for(const[ye,je]of this.#e)for(const it of je)F.call(se,it,ye,this)}*[Symbol.iterator](){for(const[F,se]of this.#e)for(const ye of se)yield[F,ye]}#t(F){return F.toLowerCase()}};e.DataTransfer=Di,e.DataTransfer=Di=Ge([f],Di);let Ei=class{constructor(F,se,ye){this.insertText=F,this.title=se,this.kind=ye}};e.DocumentDropEdit=Ei,e.DocumentDropEdit=Ei=Ge([f],Ei);var Ai;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(Ai||(e.DocumentPasteTriggerKind=Ai={}));class Rt{static{this.sep="."}constructor(F){this.value=F}append(...F){return new Rt((this.value?[this.value,...F]:F).join(Rt.sep))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+Rt.sep)}}e.DocumentDropOrPasteEditKind=Rt,Rt.Empty=new Rt("");class Li{constructor(F,se,ye){this.title=se,this.insertText=F,this.kind=ye}}e.DocumentPasteEdit=Li;let ui=class{constructor(F,se){this.id=F,this.color=se}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.ThemeIcon=ui,e.ThemeIcon=ui=Ge([f],ui),ui.File=new ui("file"),ui.Folder=new ui("folder");let Pt=class{constructor(F){this.id=F}};e.ThemeColor=Pt,e.ThemeColor=Pt=Ge([f],Pt);var Ri;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Ri||(e.ConfigurationTarget=Ri={}));let Ii=class{get base(){return this._base}set base(F){this._base=F,this._baseUri=o.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}constructor(F,se){if(typeof F!="string"&&(!F||!o.URI.isUri(F)&&!o.URI.isUri(F.uri)))throw(0,k.illegalArgument)("base");if(typeof se!="string")throw(0,k.illegalArgument)("pattern");typeof F=="string"?this.baseUri=o.URI.file(F):o.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Ii,e.RelativePattern=Ii=Ge([f],Ii);const _i=new WeakMap;function Ni(U,F){_i.set(U,F)}let bi=class{constructor(F,se,ye,je,it){this.enabled=typeof F=="boolean"?F:!0,typeof se=="string"&&(this.condition=se),typeof ye=="string"&&(this.hitCondition=ye),typeof je=="string"&&(this.logMessage=je),typeof it=="string"&&(this.mode=it)}get id(){return this._id||(this._id=_i.get(this)??(0,I.generateUuid)()),this._id}};e.Breakpoint=bi,e.Breakpoint=bi=Ge([f],bi);let $t=class extends bi{constructor(F,se,ye,je,it,ht){if(super(se,ye,je,it,ht),F===null)throw(0,k.illegalArgument)("location");this.location=F}};e.SourceBreakpoint=$t,e.SourceBreakpoint=$t=Ge([f],$t);let _e=class extends bi{constructor(F,se,ye,je,it,ht){super(se,ye,je,it,ht),this.functionName=F}};e.FunctionBreakpoint=_e,e.FunctionBreakpoint=_e=Ge([f],_e);let ke=class extends bi{constructor(F,se,ye,je,it,ht,Ct,Xt){if(super(je,it,ht,Ct,Xt),!se)throw(0,k.illegalArgument)("dataId");this.label=F,this.dataId=se,this.canPersist=ye}};e.DataBreakpoint=ke,e.DataBreakpoint=ke=Ge([f],ke);let he=class{constructor(F,se,ye){this.command=F,this.args=se||[],this.options=ye}};e.DebugAdapterExecutable=he,e.DebugAdapterExecutable=he=Ge([f],he);let G=class{constructor(F,se){this.port=F,this.host=se}};e.DebugAdapterServer=G,e.DebugAdapterServer=G=Ge([f],G);let we=class{constructor(F){this.path=F}};e.DebugAdapterNamedPipeServer=we,e.DebugAdapterNamedPipeServer=we=Ge([f],we);let ze=class{constructor(F){this.implementation=F}};e.DebugAdapterInlineImplementation=ze,e.DebugAdapterInlineImplementation=ze=Ge([f],ze);class Qe{constructor(F,se,ye){this.session=F,this.threadId=se,this.frameId=ye}}e.DebugStackFrame=Qe;class He{constructor(F,se){this.session=F,this.threadId=se}}e.DebugThread=He;let ut=class{constructor(F,se){this.range=F,this.expression=se}};e.EvaluatableExpression=ut,e.EvaluatableExpression=ut=Ge([f],ut);var kt;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(kt||(e.InlineCompletionTriggerKind=kt={}));let Gt=class{constructor(F,se){this.range=F,this.text=se}};e.InlineValueText=Gt,e.InlineValueText=Gt=Ge([f],Gt);let si=class{constructor(F,se,ye=!0){this.range=F,this.variableName=se,this.caseSensitiveLookup=ye}};e.InlineValueVariableLookup=si,e.InlineValueVariableLookup=si=Ge([f],si);let Ut=class{constructor(F,se){this.range=F,this.expression=se}};e.InlineValueEvaluatableExpression=Ut,e.InlineValueEvaluatableExpression=Ut=Ge([f],Ut);let Yt=class{constructor(F,se){this.frameId=F,this.stoppedLocation=se}};e.InlineValueContext=Yt,e.InlineValueContext=Yt=Ge([f],Yt);var Wi;(function(U){U[U.AIGenerated=1]="AIGenerated"})(Wi||(e.NewSymbolNameTag=Wi={}));var rn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(rn||(e.NewSymbolNameTriggerKind=rn={}));class Vi{constructor(F,se){this.newSymbolName=F,this.tags=se}}e.NewSymbolName=Vi;var Fi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Hi=T=class extends Error{static FileExists(F){return new T(F,a.FileSystemProviderErrorCode.FileExists,T.FileExists)}static FileNotFound(F){return new T(F,a.FileSystemProviderErrorCode.FileNotFound,T.FileNotFound)}static FileNotADirectory(F){return new T(F,a.FileSystemProviderErrorCode.FileNotADirectory,T.FileNotADirectory)}static FileIsADirectory(F){return new T(F,a.FileSystemProviderErrorCode.FileIsADirectory,T.FileIsADirectory)}static NoPermissions(F){return new T(F,a.FileSystemProviderErrorCode.NoPermissions,T.NoPermissions)}static Unavailable(F){return new T(F,a.FileSystemProviderErrorCode.Unavailable,T.Unavailable)}constructor(F,se=a.FileSystemProviderErrorCode.Unknown,ye){super(o.URI.isUri(F)?F.toString(!0):F),this.code=ye?.name??"Unknown",(0,a.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,T.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};e.FileSystemError=Hi,e.FileSystemError=Hi=T=Ge([f],Hi);let qi=class{constructor(F,se,ye){this.start=F,this.end=se,this.kind=ye}};e.FoldingRange=qi,e.FoldingRange=qi=Ge([f],qi);var Ti;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Ti||(e.FoldingRangeKind=Ti={}));var sn;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(sn||(e.CommentThreadCollapsibleState=sn={}));var on;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(on||(e.CommentMode=on={}));var Ui;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Ui||(e.CommentState=Ui={}));var an;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(an||(e.CommentThreadState=an={}));var xi;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(xi||(e.CommentThreadApplicability=xi={}));var ji;(function(U){U[U.Reply=1]="Reply",U[U.Comment=2]="Comment"})(ji||(e.CommentThreadFocus=ji={}));class Cn{constructor(F,se=[]){this.tokenTypes=F,this.tokenModifiers=se}}e.SemanticTokensLegend=Cn;function ln(U){return typeof U>"u"||(0,p.isStringArray)(U)}class Ki{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let se=0,ye=F.tokenTypes.length;se<ye;se++)this._tokenTypeStrToInt.set(F.tokenTypes[se],se);for(let se=0,ye=F.tokenModifiers.length;se<ye;se++)this._tokenModifierStrToInt.set(F.tokenModifiers[se],se)}}push(F,se,ye,je,it){if(typeof F=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof je=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this._pushEncoded(F,se,ye,je,it);if(W.isRange(F)&&typeof se=="string"&&ln(ye))return this._push(F,se,ye);throw(0,k.illegalArgument)()}_push(F,se,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const je=F.start.line,it=F.start.character,ht=F.end.character-F.start.character,Ct=this._tokenTypeStrToInt.get(se);let Xt=0;if(ye)for(const vi of ye){if(!this._tokenModifierStrToInt.has(vi))throw new Error("`tokenModifier` is not in the provided legend");const Ci=this._tokenModifierStrToInt.get(vi);Xt|=1<<Ci>>>0}this._pushEncoded(je,it,ht,Ct,Xt)}_pushEncoded(F,se,ye,je,it){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Xt=this._data.length/5|0;let vi=0,Ci=0;for(let yi=0;yi<Xt;yi++){let ki=this._data[5*yi],tn=this._data[5*yi+1];ki===0?(ki=vi,tn+=Ci):ki+=vi,this._data[5*yi]=ki,this._data[5*yi+1]=tn,vi=ki,Ci=tn}}let ht=F,Ct=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(Ct-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Ct,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=je,this._data[this._dataLen++]=it,this._prevLine=F,this._prevChar=se}static _sortAndDeltaEncode(F){const se=[],ye=F.length/5|0;for(let Ct=0;Ct<ye;Ct++)se[Ct]=Ct;se.sort((Ct,Xt)=>{const vi=F[5*Ct],Ci=F[5*Xt];if(vi===Ci){const yi=F[5*Ct+1],ki=F[5*Xt+1];return yi-ki}return vi-Ci});const je=new Uint32Array(F.length);let it=0,ht=0;for(let Ct=0;Ct<ye;Ct++){const Xt=5*se[Ct],vi=F[Xt+0],Ci=F[Xt+1],yi=F[Xt+2],ki=F[Xt+3],tn=F[Xt+4],qn=vi-it,Nr=qn===0?Ci-ht:Ci,nn=5*Ct;je[nn+0]=qn,je[nn+1]=Nr,je[nn+2]=yi,je[nn+3]=ki,je[nn+4]=tn,it=vi,ht=Ci}return je}build(F){return this._dataIsSortedAndDeltaEncoded?new Pi(new Uint32Array(this._data),F):new Pi(Ki._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Ki;class Pi{constructor(F,se){this.resultId=se,this.data=F}}e.SemanticTokens=Pi;class _n{constructor(F,se,ye){this.start=F,this.deleteCount=se,this.data=ye}}e.SemanticTokensEdit=_n;class yn{constructor(F,se){this.resultId=se,this.edits=F}}e.SemanticTokensEdits=yn;var cn;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(cn||(e.DebugConsoleMode=cn={}));class Gi{constructor(F){this.name=F}}e.DebugVisualization=Gi;var Xi;(function(U){U[U.Title=1]="Title",U[U.Inline=2]="Inline"})(Xi||(e.QuickInputButtonLocation=Xi={}));let Fe=class{static{this.Back={iconPath:new ui("arrow-left")}}constructor(){}};e.QuickInputButtons=Fe,e.QuickInputButtons=Fe=Ge([f],Fe);var Si;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Si||(e.QuickPickItemKind=Si={}));var Qi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var ot;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ot||(e.ExtensionKind=ot={}));class yt{static validate(F){if(typeof F.badge=="string"){let se=(0,R.nextCharLength)(F.badge,0);if(se<F.badge.length&&(se+=(0,R.nextCharLength)(F.badge,se)),F.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!ui.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,se,ye){this.badge=F,this.tooltip=se,this.color=ye}}e.FileDecoration=yt;let Yi=class{constructor(F){this.kind=F}};e.ColorTheme=Yi,e.ColorTheme=Yi=Ge([f],Yi);var un;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(un||(e.ColorThemeKind=un={}));class wi{static isNotebookRange(F){return F instanceof wi?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(F,se){if(F<0)throw(0,k.illegalArgument)("start must be positive");if(se<0)throw(0,k.illegalArgument)("end must be positive");F<=se?(this._start=F,this._end=se):(this._start=se,this._end=F)}with(F){let se=this._start,ye=this._end;return F.start!==void 0&&(se=F.start),F.end!==void 0&&(ye=F.end),se===this._start&&ye===this._end?this:new wi(se,ye)}}e.NotebookRange=wi;class Bi{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(se=>Bi.isNotebookCellData(se))}static isNotebookCellData(F){return!0}constructor(F,se,ye,je,it,ht,Ct){this.kind=F,this.value=se,this.languageId=ye,this.mime=je,this.outputs=it??[],this.metadata=ht,this.executionSummary=Ct,Bi.validate(this)}}e.NotebookCellData=Bi;class zi{constructor(F){this.cells=F}}e.NotebookData=zi;class pi{static isNotebookCellOutputItem(F){return F instanceof pi?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const se={name:F.name,message:F.message,stack:F.stack};return pi.json(se,"application/vnd.code.notebook.error")}static stdout(F){return pi.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return pi.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,se="application/octet-stream"){return new pi(F,se)}static#e=new TextEncoder;static text(F,se=A.Mimes.text){const ye=pi.#e.encode(String(F));return new pi(ye,se)}static json(F,se="text/x-json"){const ye=JSON.stringify(F,void 0,"	");return pi.text(ye,se)}constructor(F,se){this.data=F,this.mime=se;const ye=(0,A.normalizeMimeType)(se,!0);if(!ye)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}e.NotebookCellOutputItem=pi;class $i{static isNotebookCellOutput(F){return F instanceof $i?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,se=!1){const ye=new Set,je=new Set;for(let it=0;it<F.length;it++){const ht=F[it],Ct=(0,A.normalizeMimeType)(ht.mime);if(!ye.has(Ct)||(0,h.isTextStreamMime)(Ct)){ye.add(Ct);continue}je.add(it),se&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return je.size===0?F:F.filter((it,ht)=>!je.has(ht))}constructor(F,se,ye){this.items=$i.ensureUniqueMimeTypes(F,!0),typeof se=="string"?(this.id=se,this.metadata=ye):(this.id=(0,I.generateUuid)(),this.metadata=se??ye)}}e.NotebookCellOutput=$i;var dn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(dn||(e.NotebookCellKind=dn={}));var Ji;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Ji||(e.NotebookCellExecutionState=Ji={}));var hn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(hn||(e.NotebookCellStatusBarAlignment=hn={}));var fn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(fn||(e.NotebookEditorRevealType=fn={}));class Dn{constructor(F,se){this.text=F,this.alignment=se}}e.NotebookCellStatusBarItem=Dn;var gn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(gn||(e.NotebookControllerAffinity=gn={}));var mn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(mn||(e.NotebookControllerAffinity2=mn={}));class In{constructor(F,se=[]){this.uri=F,this.provides=(0,S.asArray)(se)}}e.NotebookRendererScript=In;class Tn{constructor(F){this.label=F}}e.NotebookKernelSourceAction=Tn;var pn;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(pn||(e.NotebookVariablesRequestKind=pn={}));let Zi=class{constructor(F,se){this.label=F,this.timestamp=se}};e.TimelineItem=Zi,e.TimelineItem=Zi=Ge([f],Zi);var vn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(vn||(e.ExtensionMode=vn={}));var En;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(En||(e.ExtensionRuntime=En={}));var te;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(te||(e.StandardTokenType=te={}));class ue{constructor(F,se){this.ranges=F,this.wordPattern=se}}e.LinkedEditingRanges=ue;class Me{constructor(F){this._autoForwardAction=F}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Me;var at;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(at||(e.TestResultState=at={}));var wt;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(wt||(e.TestRunProfileKind=wt={}));let Ot=class{constructor(F=void 0,se=void 0,ye=void 0,je=!1,it=!0){this.include=F,this.exclude=se,this.profile=ye,this.continuous=je,this.preserveFocus=it}};e.TestRunRequest=Ot,e.TestRunRequest=Ot=Ge([f],Ot);let gi=D=class{static diff(F,se,ye){const je=new D(F);return je.expectedOutput=se,je.actualOutput=ye,je}constructor(F){this.message=F}};e.TestMessage=gi,e.TestMessage=gi=D=Ge([f],gi);let Mi=class{constructor(F){this.id=F}};e.TestTag=Mi,e.TestTag=Mi=Ge([f],Mi);class en{constructor(F,se,ye){this.label=F,this.file=se,this.position=ye}}e.TestMessageStackFrame=en;class bn{constructor(F,se){this.covered=F,this.total=se,kn(this)}}e.TestCoverageCount=bn;function kn(U){if(U){if(U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`);if(U.total<0)throw new Error(`The number of covered items (${U.total}) cannot be negative`)}}class Pn{static fromDetails(F,se){const ye=new bn(0,0),je=new bn(0,0),it=new bn(0,0);for(const Ct of se)if("branches"in Ct){ye.total+=1,ye.covered+=Ct.executed?1:0;for(const Xt of Ct.branches)je.total+=1,je.covered+=Xt.executed?1:0}else it.total+=1,it.covered+=Ct.executed?1:0;const ht=new Pn(F,ye,je.total>0?je:void 0,it.total>0?it:void 0);return ht.detailedCoverage=se,ht}constructor(F,se,ye,je,it=[]){this.uri=F,this.statementCoverage=se,this.branchCoverage=ye,this.declarationCoverage=je,this.fromTests=it}}e.FileCoverage=Pn;class Gn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,ye=[]){this.executed=F,this.location=se,this.branches=ye}}e.StatementCoverage=Gn;class Xn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,ye){this.executed=F,this.location=se,this.label=ye}}e.BranchCoverage=Xn;class Qn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,ye){this.name=F,this.executed=se,this.location=ye}}e.DeclarationCoverage=Qn;var An;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(An||(e.ExternalUriOpenerPriority=An={}));var Rn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Rn||(e.WorkspaceTrustState=Rn={}));var On;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(On||(e.PortAutoForwardAction=On={}));class Yn{constructor(F,se,ye,je,it,ht){this.kind=F,this.name=se,this.detail=ye,this.uri=je,this.range=it,this.selectionRange=ht}}e.TypeHierarchyItem=Yn;class Jn{constructor(F){this.uri=F}}e.TextTabInput=Jn;class Zn{constructor(F,se){this.original=F,this.modified=se}}e.TextDiffTabInput=Zn;class er{constructor(F,se,ye,je){this.base=F,this.input1=se,this.input2=ye,this.result=je}}e.TextMergeTabInput=er;class tr{constructor(F,se){this.uri=F,this.viewType=se}}e.CustomEditorTabInput=tr;class ir{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=ir;class nr{constructor(F,se){this.uri=F,this.notebookType=se}}e.NotebookEditorTabInput=nr;class rr{constructor(F,se,ye){this.original=F,this.modified=se,this.notebookType=ye}}e.NotebookDiffEditorTabInput=rr;class sr{constructor(){}}e.TerminalEditorTabInput=sr;class or{constructor(F,se){this.uri=F,this.inputBoxUri=se}}e.InteractiveWindowInput=or;class ar{constructor(){}}e.ChatEditorTabInput=ar;class lr{constructor(F){this.textDiffs=F}}e.TextMultiDiffTabInput=lr;var Ln;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(Ln||(e.InteractiveSessionVoteDirection=Ln={}));var Nn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Mn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Mn||(e.ChatVariableLevel=Mn={}));class cr{constructor(F,se,ye){this.id=F,this.label=se,this.values=ye}}e.ChatCompletionItem=cr;var Fn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(Fn||(e.InteractiveEditorResponseFeedbackKind=Fn={}));var Un;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Un||(e.ChatResultFeedbackKind=Un={}));class ur{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F}}e.ChatResponseMarkdownPart=ur;class dr{constructor(F,se){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F,this.vulnerabilities=se}}e.ChatResponseMarkdownWithVulnerabilitiesPart=dr;class hr{constructor(F,se){this.participant=F,this.command=se}}e.ChatResponseDetectedParticipantPart=hr;class fr{constructor(F,se,ye,je){this.title=F,this.message=se,this.data=ye,this.buttons=je}}e.ChatResponseConfirmationPart=fr;class gr{constructor(F,se){this.value=F,this.baseUri=se}}e.ChatResponseFileTreePart=gr;class mr{constructor(F,se){this.value=F,this.title=se}}e.ChatResponseAnchorPart=mr;class pr{constructor(F){this.value=F}}e.ChatResponseProgressPart=pr;class vr{constructor(F,se){this.value=F,this.task=se}}e.ChatResponseProgressPart2=vr;class Er{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F}}e.ChatResponseWarningPart=Er;class br{constructor(F){this.value=F}}e.ChatResponseCommandButtonPart=br;class Sr{constructor(F,se,ye){this.value=F,this.iconPath=se,this.options=ye}}e.ChatResponseReferencePart=Sr;class wr{constructor(F,se,ye){this.value=F,this.license=se,this.snippet=ye}}e.ChatResponseCodeCitationPart=wr;class Cr{constructor(F,se){this.uri=F,this.edits=Array.isArray(se)?se:[se]}}e.ChatResponseTextEditPart=Cr;class _r{constructor(F,se,ye,je){this.prompt=F,this.command=se,this.references=ye,this.participant=je}}e.ChatRequestTurn=_r;class yr{constructor(F,se,ye,je){this.response=F,this.result=se,this.participant=ye,this.command=je}}e.ChatResponseTurn=yr;var xn;(function(U){U[U.Panel=1]="Panel",U[U.Terminal=2]="Terminal",U[U.Notebook=3]="Notebook",U[U.Editor=4]="Editor"})(xn||(e.ChatLocation=xn={}));var Bn;(function(U){U[U.Complete=1]="Complete",U[U.Partial=2]="Partial",U[U.Omitted=3]="Omitted"})(Bn||(e.ChatResponseReferencePartStatusKind=Bn={}));class Dr{constructor(F,se,ye){this.document=F,this.selection=se,this.wholeRange=ye}}e.ChatRequestEditorData=Dr;class Ir{constructor(F){this.cell=F}}e.ChatRequestNotebookData=Ir;var Sn;(function(U){U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.System=3]="System"})(Sn||(e.LanguageModelChatMessageRole=Sn={}));class Tr{constructor(F,se,ye){this.name=F,this.content=se,this.isError=ye??!1}}e.LanguageModelFunctionResultPart=Tr;class wn{static User(F,se){const ye=new wn(Sn.User,typeof F=="string"?F:"",se);return ye.content2=F,ye}static Assistant(F,se){return new wn(Sn.Assistant,F,se)}constructor(F,se,ye){this.role=F,this.content=se,this.content2=se,this.name=ye}}e.LanguageModelChatMessage=wn;class Pr{constructor(F,se){this.name=F,this.parameters=se}}e.LanguageModelFunctionUsePart=Pr;class kr{constructor(F){this.value=F}}e.LanguageModelTextPart=kr;class Ar{constructor(F){this.content=F}}e.LanguageModelChatSystemMessage=Ar;class Rr{constructor(F,se){this.content=F,this.name=se}}e.LanguageModelChatUserMessage=Rr;class Or{constructor(F,se){this.content=F,this.name=se}}e.LanguageModelChatAssistantMessage=Or;class Oi extends Error{static NotFound(F){return new Oi(F,Oi.NotFound.name)}static NoPermissions(F){return new Oi(F,Oi.NoPermissions.name)}static Blocked(F){return new Oi(F,Oi.Blocked.name)}constructor(F,se,ye){super(F,{cause:ye}),this.name="LanguageModelError",this.code=se??""}}e.LanguageModelError=Oi;var zn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(zn||(e.RelatedInformationType=zn={}));var $n;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped",U[U.Error=5]="Error"})($n||(e.SpeechToTextStatus=$n={}));var Wn;(function(U){U[U.Started=1]="Started",U[U.Stopped=2]="Stopped",U[U.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var Vn;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(Vn||(e.KeywordRecognitionStatus=Vn={}));class Lr{constructor(F,se){this.text=F,this.range=se}}e.InlineEdit=Lr;var Hn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Hn||(e.InlineEditTriggerKind=Hn={}))}),define(Le[227],Ne([1,0,5,7]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class P{constructor(A){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(S.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,R,p){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const o=this._relatedInformationProviders.get(A);if(!o)throw new Error("related information provider not found");return await o.provideRelatedInformation(R,p)??[]}getRelatedInformation(A,R,p){return this._proxy.$getAiRelatedInformation(R,p)}registerRelatedInformationProvider(A,R,p){const o=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(o,p),this._proxy.$registerAiRelatedInformationProvider(o,R),new k.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(o),this._relatedInformationProviders.delete(o)})}}e.ExtHostRelatedInformation=P}),define(Le[90],Ne([1,0,6,5,7,18,117,3,16]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,R.createDecorator)("IExtHostAuthentication");let o=class{constructor(a){this._authenticationProviders=new Map,this._onDidChangeSessions=new S.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new I,this._proxy=a.getProxy(k.MainContext.MainThreadAuthentication)}async getSession(a,y,h,r={}){const s=O.ExtensionIdentifier.toKey(a.identifier),l=[...h].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${s} ${y} ${l}`,async()=>{await this._proxy.$ensureProvider(y);const c=a.displayName||a.name;return this._proxy.$getSession(y,h,s,c,r)})}async getAccounts(a){return await this._proxy.$ensureProvider(a),await this._proxy.$getAccounts(a)}async removeSession(a,y){const h=this._authenticationProviders.get(a);return h?h.provider.removeSession(y):this._proxy.$removeSession(a,y)}registerAuthenticationProvider(a,y,h,r){if(this._authenticationProviders.get(a))throw new Error(`An authentication provider with id '${a}' is already registered.`);this._authenticationProviders.set(a,{label:y,provider:h,options:r??{supportsMultipleAccounts:!1}});const s=h.onDidChangeSessions(l=>this._proxy.$sendDidChangeSessions(a,l));return this._proxy.$registerAuthenticationProvider(a,y,r?.supportsMultipleAccounts??!1),new P.Disposable(()=>{s.dispose(),this._authenticationProviders.delete(a),this._proxy.$unregisterAuthenticationProvider(a)})}async $createSession(a,y,h){const r=this._authenticationProviders.get(a);if(r)return await r.provider.createSession(y,h);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $removeSession(a,y){const h=this._authenticationProviders.get(a);if(h)return await h.provider.removeSession(y);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $getSessions(a,y,h){const r=this._authenticationProviders.get(a);if(r)return await r.provider.getSessions(y,h);throw new Error(`Unable to find authentication provider with handle: ${a}`)}$onDidChangeAuthenticationSessions(a,y){return a.startsWith(A.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:a,label:y}}),Promise.resolve()}};e.ExtHostAuthentication=o,e.ExtHostAuthentication=o=Ge([Ve(0,p.IExtHostRpcService)],o);class I{constructor(){this._inFlightPromises=new Map}getOrCreate(a,y){const h=this._inFlightPromises.get(a);if(h)return h;const r=y().finally(()=>this._inFlightPromises.delete(a));return this._inFlightPromises.set(a,r),r}}}),define(Le[122],Ne([1,0,2,5,7,3,16,11,17,12,19,24]),function(Se,e,S,k,P,O,A,R,p,o,I,w){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class{static{a=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(r,s){this._logService=s,this._provider=new Map,this._proxy=r.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(r,s){const l=a._handlePool++;this._provider.set(l,{provider:r,extensionDescription:s}),this._proxy.$registerDecorationProvider(l,s.identifier.value);const c=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this._proxy.$onDidChange(l,null);return}const n=(0,p.asArray)(i);if(n.length<=a._maxEventSize){this._proxy.$onDidChange(l,n);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,n.length);const t=n.map(v=>({uri:v,rank:(0,o.count)(v.path,"/")})),g=(0,p.groupBy)(t,(v,m)=>v.rank-m.rank||(0,o.compare)(v.uri.path,m.uri.path)),u=[];e:for(const v of g){let m;for(const d of v){const C=(0,I.dirname)(d.uri.path);if(m!==C&&(m=C,u.push(d.uri)>=a._maxEventSize))break e}}this._proxy.$onDidChange(l,u)});return new P.Disposable(()=>{c?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(r,s,l){if(!this._provider.has(r))return Object.create(null);const c=Object.create(null),{provider:i,extensionDescription:n}=this._provider.get(r);return await Promise.all(s.map(async t=>{try{const{uri:g,id:u}=t,v=await Promise.resolve(i.provideFileDecoration(S.URI.revive(g),l));if(!v)return;try{P.FileDecoration.validate(v),v.badge&&typeof v.badge!="string"&&(0,w.checkProposedApiEnabled)(n,"codiconDecoration"),c[u]=[v.propagate,v.tooltip,v.badge,v.color]}catch(m){this._logService.warn(`INVALID decoration from extension '${n.identifier.value}': ${m}`)}}catch(g){this._logService.error(g)}})),c}};e.ExtHostDecorations=y,e.ExtHostDecorations=y=a=Ge([Ve(0,A.IExtHostRpcService),Ve(1,R.ILogService)],y),e.IExtHostDecorations=(0,O.createDecorator)("IExtHostDecorations")}),define(Le[228],Ne([1,0,13,2,7,5,15,21,12]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class o{static{this._handlePool=0}constructor(w,a,y){this._documentsAndEditors=a,this._logService=y,this._documentContentProviders=new Map,this._proxy=w.getProxy(O.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,a){if(Object.keys(A.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const y=o._handlePool++;this._documentContentProviders.set(y,a),this._proxy.$registerTextContentProvider(y,w);let h;if(typeof a.onDidChange=="function"){let r;h=a.onDidChange(async s=>{if(s.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(s))return;r&&await r;const l=this.$provideTextDocumentContent(y,s).then(async c=>{if(!c&&typeof c!="string")return;const i=this._documentsAndEditors.getDocument(s);if(!i)return;const n=(0,p.splitLines)(c);if(!i.equalLines(n))return this._proxy.$onVirtualDocumentChange(s,c)}).catch(S.onUnexpectedError).finally(()=>{r===l&&(r=void 0)});r=l})}return new P.Disposable(()=>{this._documentContentProviders.delete(y)&&this._proxy.$unregisterTextContentProvider(y),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(w,a){const y=this._documentContentProviders.get(w);return y?Promise.resolve(y.provideTextDocumentContent(k.URI.revive(a),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=o}),define(Le[123],Ne([1,0,61,15,12,284,169,7,17]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=I;const o=new Map;function I(h,r){r?o.set(h,r):o.delete(h)}function w(h){return o.get(h)}class a extends O.MirrorTextModel{constructor(r,s,l,c,i,n,t){super(s,l,c,i),this._proxy=r,this._languageId=n,this._isDirty=t,this._isDisposed=!1}dispose(){(0,S.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(r){return(0,p.equals)(this._lines,r)}get document(){if(!this._document){const r=this;this._document={get uri(){return r._uri},get fileName(){return r._uri.fsPath},get isUntitled(){return r._uri.scheme===k.Schemas.untitled},get languageId(){return r._languageId},get version(){return r._versionId},get isClosed(){return r._isDisposed},get isDirty(){return r._isDirty},save(){return r._save()},getText(s){return s?r._getTextInRange(s):r.getText()},get eol(){return r._eol===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return r._lines.length},lineAt(s){return r._lineAt(s)},offsetAt(s){return r._offsetAt(s)},positionAt(s){return r._positionAt(s)},validateRange(s){return r._validateRange(s)},validatePosition(s){return r._validatePosition(s)},getWordRangeAtPosition(s,l){return r._getWordRangeAtPosition(s,l)},[Symbol.for("debug.description")](){return`TextDocument(${r._uri.toString()})`}}}return Object.freeze(this._document)}_acceptLanguageId(r){(0,S.ok)(!this._isDisposed),this._languageId=r}_acceptIsDirty(r){(0,S.ok)(!this._isDisposed),this._isDirty=r}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(r){const s=this._validateRange(r);if(s.isEmpty)return"";if(s.isSingleLine)return this._lines[s.start.line].substring(s.start.character,s.end.character);const l=this._eol,c=s.start.line,i=s.end.line,n=[];n.push(this._lines[c].substring(s.start.character));for(let t=c+1;t<i;t++)n.push(this._lines[t]);return n.push(this._lines[i].substring(0,s.end.character)),n.join(l)}_lineAt(r){let s;if(r instanceof R.Position?s=r.line:typeof r=="number"&&(s=r),typeof s!="number"||s<0||s>=this._lines.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new y(s,this._lines[s],s===this._lines.length-1)}_offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.line-1)+r.character}_positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const s=this._lineStarts.getIndexOf(r),l=this._lines[s.index].length;return new R.Position(s.index,Math.min(s.remainder,l))}_validateRange(r){if(!(r instanceof R.Range))throw new Error("Invalid argument");const s=this._validatePosition(r.start),l=this._validatePosition(r.end);return s===r.start&&l===r.end?r:new R.Range(s.line,s.character,l.line,l.character)}_validatePosition(r){if(!(r instanceof R.Position))throw new Error("Invalid argument");if(this._lines.length===0)return r.with(0,0);let{line:s,character:l}=r,c=!1;if(s<0)s=0,l=0,c=!0;else if(s>=this._lines.length)s=this._lines.length-1,l=this._lines[s].length,c=!0;else{const i=this._lines[s].length;l<0?(l=0,c=!0):l>i&&(l=i,c=!0)}return c?new R.Position(s,l):r}_getWordRangeAtPosition(r,s){const l=this._validatePosition(r);if(!s)s=w(this._languageId);else if((0,P.regExpLeadsToEndlessLoop)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const c=(0,A.getWordAtText)(l.character+1,(0,A.ensureValidWordDefinition)(s),this._lines[l.line],0);if(c)return new R.Range(l.line,c.startColumn-1,l.line,c.endColumn-1)}}e.ExtHostDocumentData=a;class y{constructor(r,s,l){this._line=r,this._text=s,this._isLastLine=l}get lineNumber(){return this._line}get text(){return this._text}get range(){return new R.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new R.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=y}),define(Le[229],Ne([1,0,5,7]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class P{constructor(A){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(S.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,R,p){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const o=this._AiEmbeddingVectorProviders.get(A);if(!o)throw new Error("Embedding vector provider not found");const I=await o.provideEmbeddingVector(R,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(A,R,p){const o=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(o,p),this._proxy.$registerAiEmbeddingVectorProvider(R,o),new k.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(o),this._AiEmbeddingVectorProviders.delete(o)})}}e.ExtHostAiEmbeddingVector=P}),define(Le[68],Ne([1,0,5,29,7,22,3,16,50,4,10,23,15]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0,k=We(k);let h=y=class{constructor(s,l){this._fileSystemProvider=new Map,this._writeQueue=new I.ResourceQueue,this._proxy=s.getProxy(S.MainContext.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(i){try{let n;const t=c._fileSystemProvider.get(i.scheme);return t?(await c._proxy.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await c._proxy.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===k.FilePermission.Readonly?1:void 0}}catch(n){y._handleError(n)}},async readDirectory(i){try{const n=c._fileSystemProvider.get(i.scheme);return n?(await c._proxy.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await c._proxy.$readdir(i)}catch(n){return y._handleError(n)}},async createDirectory(i){try{const n=c._fileSystemProvider.get(i.scheme);return n&&!n.isReadonly?(await c._proxy.$ensureActivation(i.scheme),await c.mkdirp(n.impl,n.extUri,i)):await c._proxy.$mkdir(i)}catch(n){return y._handleError(n)}},async readFile(i){try{const n=c._fileSystemProvider.get(i.scheme);return n?(await c._proxy.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await c._proxy.$readFile(i)).buffer}catch(n){return y._handleError(n)}},async writeFile(i,n){try{const t=c._fileSystemProvider.get(i.scheme);return t&&!t.isReadonly?(await c._proxy.$ensureActivation(i.scheme),await c.mkdirp(t.impl,t.extUri,t.extUri.dirname(i)),await c._writeQueue.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await c._proxy.$writeFile(i,O.VSBuffer.wrap(n))}catch(t){return y._handleError(t)}},async delete(i,n){try{const t=c._fileSystemProvider.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await c._proxy.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await c._proxy.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return y._handleError(t)}},async rename(i,n,t){try{return await c._proxy.$rename(i,n,{overwrite:!1,...t})}catch(g){return y._handleError(g)}},async copy(i,n,t){try{return await c._proxy.$copy(i,n,{overwrite:!1,...t})}catch(g){return y._handleError(g)}},isWritableFileSystem(i){const n=l.getCapabilities(i);if(typeof n=="number")return!(n&k.FileSystemProviderCapabilities.Readonly)}})}async mkdirp(s,l,c){const i=[];for(;!l.isEqual(c,l.dirname(c));)try{if(!((await s.stat(c)).type&k.FileType.Directory))throw P.FileSystemError.FileExists(`Unable to create folder '${c.scheme===a.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(k.toFileSystemProviderErrorCode(n)!==k.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(l.basename(c)),c=l.dirname(c)}for(let n=i.length-1;n>=0;n--){c=l.joinPath(c,i[n]);try{await s.createDirectory(c)}catch(t){if(k.toFileSystemProviderErrorCode(t)!==k.FileSystemProviderErrorCode.FileExists)throw t}}}static _handleError(s){if(s instanceof P.FileSystemError)throw s;if(s instanceof k.FileSystemProviderError)switch(s.code){case k.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(s.message);case k.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(s.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(s.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(s.message);case k.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(s.message);case k.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(s.message);default:throw new P.FileSystemError(s.message,s.name)}if(!(s instanceof Error))throw new P.FileSystemError(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw P.FileSystemError.Unavailable(s.message);switch(s.name){case k.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(s.message);case k.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(s.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(s.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(s.message);case k.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(s.message);case k.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(s.message);default:throw new P.FileSystemError(s.message,s.name)}}addFileSystemProvider(s,l,c){return this._fileSystemProvider.set(s,{impl:l,extUri:c?.isCaseSensitive?w.extUri:w.extUriIgnorePathCase,isReadonly:!!c?.isReadonly}),(0,o.toDisposable)(()=>this._fileSystemProvider.delete(s))}getFileSystemProviderExtUri(s){return this._fileSystemProvider.get(s)?.extUri??w.extUri}};e.ExtHostConsumerFileSystem=h,e.ExtHostConsumerFileSystem=h=y=Ge([Ve(0,R.IExtHostRpcService),Ve(1,p.IExtHostFileSystemInfo)],h),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Le[91],Ne([1,0,3,26,11,68,2]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,S.createDecorator)("IExtensionStoragePaths");let R=class{constructor(o,I,w){this._logService=I,this._extHostFileSystem=w,this._workspace=o.workspace??void 0,this._environment=o.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(o){return A.URI.joinPath(this._environment.workspaceStorageHome,o)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const o=this._workspace.id,I=await this._getWorkspaceStorageURI(o);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),I}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(o){if(this._value)return A.URI.joinPath(this._value,o.identifier.value)}globalValue(o){return A.URI.joinPath(this._environment.globalStorageHome,o.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=R,e.ExtensionStoragePaths=R=Ge([Ve(0,k.IExtHostInitDataService),Ve(1,P.ILogService),Ve(2,O.IExtHostConsumerFileSystem)],R)}),define(Le[230],Ne([1,0,7,16,6]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let O=class{constructor(R){this._actual=new S.ColorTheme(S.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new P.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(R){let p;switch(R){case"light":p=S.ColorThemeKind.Light;break;case"hcDark":p=S.ColorThemeKind.HighContrast;break;case"hcLight":p=S.ColorThemeKind.HighContrastLight;break;default:p=S.ColorThemeKind.Dark}this._actual=new S.ColorTheme(p),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=O,e.ExtHostTheming=O=Ge([Ve(0,k.IExtHostRpcService)],O)}),define(Le[92],Ne([1,0,21,6,4,9,3,11,183,5,26,16,7]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0,O=We(O),a=We(a);class y extends p.DisposableTunnel{}var h;(function(s){function l(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=l;function c(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=c})(h||(e.TunnelDtoConverter=h={})),e.IExtHostTunnelService=(0,A.createDecorator)("IExtHostTunnelService");let r=class extends P.Disposable{constructor(l,c,i){super(),this.logService=i,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new k.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=l.getProxy(o.MainContext.MainThreadTunnelService)}async openTunnel(l,c){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const i=await this._proxy.$openTunnel(c,l.displayName);if(i){const n=new y(i.remoteAddress,i.localAddress,()=>this._proxy.$closeTunnel(i.remoteAddress));return this._register(n),n}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(l,c){l.portRange===void 0&&l.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(i,{selector:l,provider:c}),this._proxy.$registerPortsAttributesProvider(l,i),new a.Disposable(()=>{this._portAttributesProviders.delete(i),this._proxy.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(l,c,i,n,t){const g=[];for(const v of l){const m=this._portAttributesProviders.get(v);if(!m)return[];g.push(...await Promise.all(c.map(async d=>{let C;try{C=await m.provider.providePortAttributes({port:d,pid:i,commandLine:n},t)}catch{C=await m.provider.providePortAttributes(d,i,n,t)}return{providedAttributes:C,port:d}})))}const u=g.filter(v=>!!v.providedAttributes);return u.length>0?u.map(v=>({autoForwardAction:v.providedAttributes.autoForwardAction,port:v.port})):[]}async $registerCandidateFinder(l){}registerTunnelProvider(l,c){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(n,t)=>await l.provideTunnel(n,t,S.CancellationToken.None)??void 0;const i=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions,protocol:c.tunnelFeatures.protocol===void 0?!0:c.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(i),Promise.resolve((0,P.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(l,c){if(l){l.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this._showCandidatePort=l.showCandidatePort,this._proxy.$setCandidateFilter());const i=l.tunnelFactory??(c?this.makeManagedTunnelFactory(c):void 0);if(i){this._forwardPortProvider=i;let n=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:O.localize(10821,null),themeIcon:"lock"},{id:"public",label:O.localize(10822,null),themeIcon:"eye"}]);const t=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this._proxy.$setTunnelProvider(t)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(l){}async $closeTunnel(l,c){if(this._extensionTunnels.has(l.host)){const i=this._extensionTunnels.get(l.host);i.has(l.port)&&(c&&i.get(l.port).disposeListener.dispose(),await i.get(l.port).tunnel.dispose(),i.delete(l.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(l,c){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this._forwardPortProvider(l,c);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(l.remoteAddress.host)||this._extensionTunnels.set(l.remoteAddress.host,new Map);const t=this._register(n.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(n.remoteAddress))));return this._extensionTunnels.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:n,disposeListener:t}),h.fromApiTunnel(n)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(l){const c=await Promise.all(l.map(n=>this._showCandidatePort(n.host,n.port,n.detail??""))),i=l.filter((n,t)=>c[t]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.ExtHostTunnelService=r,e.ExtHostTunnelService=r=Ge([Ve(0,w.IExtHostRpcService),Ve(1,I.IExtHostInitDataService),Ve(2,R.ILogService)],r)}),define(Le[8],Ne([1,0,17,22,151,231,59,28,138,36,72,25,144,23,34,14,2,105,32,159,93,52,107,76,116,114,115,207,80,89,54,55,204,7]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n,t,g,u,v,m,d,C,_,E,T,D,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=le,e.fromRangeOrRangeWithMessage=oe,e.pathOrURIToURI=De,A=We(A),c=We(c),i=We(i),n=We(n),C=We(C),E=We(E),b=We(b);var M;(function(_e){function ke(G){const{selectionStartLineNumber:we,selectionStartColumn:ze,positionLineNumber:Qe,positionColumn:He}=G,ut=new b.Position(we-1,ze-1),kt=new b.Position(Qe-1,He-1);return new b.Selection(ut,kt)}_e.to=ke;function he(G){const{anchor:we,active:ze}=G;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}_e.from=he})(M||(e.Selection=M={}));var L;(function(_e){function ke(G){if(!G)return;const{start:we,end:ze}=G;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}_e.from=ke;function he(G){if(!G)return;const{startLineNumber:we,startColumn:ze,endLineNumber:Qe,endColumn:He}=G;return new b.Range(we-1,ze-1,Qe-1,He-1)}_e.to=he})(L||(e.Range=L={}));var N;(function(_e){function ke(G){return{uri:G.uri,range:L.from(G.range)}}_e.from=ke;function he(G){return new b.Location(s.URI.revive(G.uri),L.to(G.range))}_e.to=he})(N||(e.Location=N={}));var W;(function(_e){function ke(he){switch(he){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}_e.to=ke})(W||(e.TokenType=W={}));var j;(function(_e){function ke(G){return new b.Position(G.lineNumber-1,G.column-1)}_e.to=ke;function he(G){return{lineNumber:G.line+1,column:G.character+1}}_e.from=he})(j||(e.Position=j={}));var $;(function(_e){function ke(we,ze,Qe){return(0,S.coalesce)((0,S.asArray)(we).map(He=>he(He,ze,Qe)))}_e.from=ke;function he(we,ze,Qe){if(typeof we=="string")return{$serialized:!0,language:we,isBuiltin:Qe?.isBuiltin};if(we)return{$serialized:!0,language:we.language,scheme:G(we.scheme,ze),pattern:Je.from(we.pattern)??void 0,exclusive:we.exclusive,notebookType:we.notebookType,isBuiltin:Qe?.isBuiltin}}function G(we,ze){return ze&&typeof we=="string"?ze.transformOutgoingScheme(we):we}})($||(e.DocumentSelector=$={}));var K;(function(_e){function ke(G){switch(G){case b.DiagnosticTag.Unnecessary:return g.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return g.MarkerTag.Deprecated}}_e.from=ke;function he(G){switch(G){case g.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case g.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}_e.to=he})(K||(e.DiagnosticTag=K={}));var q;(function(_e){function ke(G){let we;return G.code&&((0,r.isString)(G.code)||(0,r.isNumber)(G.code)?we=String(G.code):we={value:String(G.code.value),target:G.code.target}),{...L.from(G.range),message:G.message,source:G.source,code:we,severity:Ee.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(ae.from),tags:Array.isArray(G.tags)?(0,S.coalesce)(G.tags.map(K.from)):void 0}}_e.from=ke;function he(G){const we=new b.Diagnostic(L.to(G),G.message,Ee.to(G.severity));return we.source=G.source,we.code=(0,r.isString)(G.code)?G.code:G.code?.value,we.relatedInformation=G.relatedInformation&&G.relatedInformation.map(ae.to),we.tags=G.tags&&(0,S.coalesce)(G.tags.map(K.to)),we}_e.to=he})(q||(e.Diagnostic=q={}));var ae;(function(_e){function ke(G){return{...L.from(G.location.range),message:G.message,resource:G.location.uri}}_e.from=ke;function he(G){return new b.DiagnosticRelatedInformation(new b.Location(G.resource,L.to(G)),G.message)}_e.to=he})(ae||(e.DiagnosticRelatedInformation=ae={}));var Ee;(function(_e){function ke(G){switch(G){case b.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}_e.from=ke;function he(G){switch(G){case g.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}_e.to=he})(Ee||(e.DiagnosticSeverity=Ee={}));var ce;(function(_e){function ke(G){return typeof G=="number"&&G>=b.ViewColumn.One?G-1:G===b.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}_e.from=ke;function he(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=he})(ce||(e.ViewColumn=ce={}));function Z(_e){return typeof _e.range<"u"}function le(_e){return _e.length===0?!0:!!Z(_e[0])}var me;(function(_e){function ke(He){return He.map(_e.from)}_e.fromMany=ke;function he(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function G(He){let ut;if(he(He)){const{language:Ut,value:Yt}=He;ut={value:"```"+Ut+`
`+Yt+"\n```\n"}}else b.MarkdownString.isMarkdownString(He)?ut={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?ut={value:He}:ut={value:""};const kt=Object.create(null);ut.uris=kt;const Gt=Ut=>{try{let Yt=s.URI.parse(Ut,!0);Yt=Yt.with({query:we(Yt.query,kt)}),kt[Ut]=Yt}catch{}return""},si=new p.marked.Renderer;return si.link=Gt,si.image=Ut=>typeof Ut=="string"?Gt(A.parseHrefAndDimensions(Ut).href):"",(0,p.marked)(ut.value,{renderer:si}),ut}_e.from=G;function we(He,ut){if(!He)return He;let kt;try{kt=(0,o.parse)(He)}catch{}if(!kt)return He;let Gt=!1;return kt=(0,w.cloneAndChange)(kt,si=>{if(s.URI.isUri(si)){const Ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ut]=si,Gt=!0,Ut}else return}),Gt?JSON.stringify(kt):He}function ze(He){const ut=new b.MarkdownString(He.value,He.supportThemeIcons);return ut.isTrusted=He.isTrusted,ut.supportHtml=He.supportHtml,ut.baseUri=He.baseUri?s.URI.from(He.baseUri):void 0,ut}_e.to=ze;function Qe(He){if(He)return typeof He=="string"?He:_e.from(He)}_e.fromStrict=Qe})(me||(e.MarkdownString=me={}));function oe(_e){return le(_e)?_e.map(ke=>({range:L.from(ke.range),hoverMessage:Array.isArray(ke.hoverMessage)?me.fromMany(ke.hoverMessage):ke.hoverMessage?me.from(ke.hoverMessage):void 0,renderOptions:ke.renderOptions})):_e.map(ke=>({range:L.from(ke)}))}function De(_e){return typeof _e>"u"?_e:typeof _e=="string"?s.URI.file(_e):_e}var Re;(function(_e){function ke(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?De(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}_e.from=ke})(Re||(e.ThemableDecorationAttachmentRenderOptions=Re={}));var Q;(function(_e){function ke(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?De(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?Re.from(he.before):void 0,after:he.after?Re.from(he.after):void 0}}_e.from=ke})(Q||(e.ThemableDecorationRenderOptions=Q={}));var z;(function(_e){function ke(he){if(typeof he>"u")return he;switch(he){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}_e.from=ke})(z||(e.DecorationRangeBehavior=z={}));var ne;(function(_e){function ke(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?z.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?Q.from(he.light):void 0,dark:he.dark?Q.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?De(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?Re.from(he.before):void 0,after:he.after?Re.from(he.after):void 0}}_e.from=ke})(ne||(e.DecorationRenderOptions=ne={}));var Ce;(function(_e){function ke(G){return{text:G.newText,eol:G.newEol&&Be.from(G.newEol),range:L.from(G.range)}}_e.from=ke;function he(G){const we=new b.TextEdit(L.to(G.range),G.text);return we.newEol=typeof G.eol>"u"?void 0:Be.to(G.eol),we}_e.to=he})(Ce||(e.TextEdit=Ce={}));var fe;(function(_e){function ke(G,we){const ze={edits:[]};if(G instanceof b.WorkspaceEdit){const Qe=new R.ResourceSet;for(const He of G._allEntries())He._type===b.FileEditType.File&&s.URI.isUri(He.to)&&He.from===void 0&&Qe.add(He.to);for(const He of G._allEntries())if(He._type===b.FileEditType.File){let ut;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?ut={type:"base64",value:(0,k.encodeBase64)(k.VSBuffer.wrap(He.options.contents))}:ut={type:"dataTransferItem",id:He.options.contents._itemId}),ze.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:ut},metadata:He.metadata})}else He._type===b.FileEditType.Text?ze.edits.push({resource:He.uri,textEdit:Ce.from(He.edit),versionId:Qe.has(He.uri)?void 0:we?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===b.FileEditType.Snippet?ze.edits.push({resource:He.uri,textEdit:{range:L.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Qe.has(He.uri)?void 0:we?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===b.FileEditType.Cell?ze.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:we?.getNotebookDocumentVersion(He.uri)}):He._type===b.FileEditType.CellReplace&&ze.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:we?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:E.CellEditType.Replace,index:He.index,count:He.count,cells:He.cells.map(At.from)}})}return ze}_e.from=ke;function he(G){const we=new b.WorkspaceEdit,ze=new R.ResourceMap;for(const Qe of G.edits)if(Qe.textEdit){const He=Qe,ut=s.URI.revive(He.resource),kt=L.to(He.textEdit.range),Gt=He.textEdit.text,si=He.textEdit.insertAsSnippet;let Ut;si?Ut=b.SnippetTextEdit.replace(kt,new b.SnippetString(Gt)):Ut=b.TextEdit.replace(kt,Gt);const Yt=ze.get(ut);Yt?Yt.push(Ut):ze.set(ut,[Ut])}else we.renameFile(s.URI.revive(Qe.oldResource),s.URI.revive(Qe.newResource),Qe.options);for(const[Qe,He]of ze)we.set(Qe,He);return we}_e.to=he})(fe||(e.WorkspaceEdit=fe={}));var be;(function(_e){const ke=Object.create(null);ke[b.SymbolKind.File]=n.SymbolKind.File,ke[b.SymbolKind.Module]=n.SymbolKind.Module,ke[b.SymbolKind.Namespace]=n.SymbolKind.Namespace,ke[b.SymbolKind.Package]=n.SymbolKind.Package,ke[b.SymbolKind.Class]=n.SymbolKind.Class,ke[b.SymbolKind.Method]=n.SymbolKind.Method,ke[b.SymbolKind.Property]=n.SymbolKind.Property,ke[b.SymbolKind.Field]=n.SymbolKind.Field,ke[b.SymbolKind.Constructor]=n.SymbolKind.Constructor,ke[b.SymbolKind.Enum]=n.SymbolKind.Enum,ke[b.SymbolKind.Interface]=n.SymbolKind.Interface,ke[b.SymbolKind.Function]=n.SymbolKind.Function,ke[b.SymbolKind.Variable]=n.SymbolKind.Variable,ke[b.SymbolKind.Constant]=n.SymbolKind.Constant,ke[b.SymbolKind.String]=n.SymbolKind.String,ke[b.SymbolKind.Number]=n.SymbolKind.Number,ke[b.SymbolKind.Boolean]=n.SymbolKind.Boolean,ke[b.SymbolKind.Array]=n.SymbolKind.Array,ke[b.SymbolKind.Object]=n.SymbolKind.Object,ke[b.SymbolKind.Key]=n.SymbolKind.Key,ke[b.SymbolKind.Null]=n.SymbolKind.Null,ke[b.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,ke[b.SymbolKind.Struct]=n.SymbolKind.Struct,ke[b.SymbolKind.Event]=n.SymbolKind.Event,ke[b.SymbolKind.Operator]=n.SymbolKind.Operator,ke[b.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function he(we){return typeof ke[we]=="number"?ke[we]:n.SymbolKind.Property}_e.from=he;function G(we){for(const ze in ke)if(ke[ze]===we)return Number(ze);return b.SymbolKind.Property}_e.to=G})(be||(e.SymbolKind=be={}));var de;(function(_e){function ke(G){switch(G){case b.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}_e.from=ke;function he(G){switch(G){case n.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}_e.to=he})(de||(e.SymbolTag=de={}));var X;(function(_e){function ke(G){return{name:G.name,kind:be.from(G.kind),tags:G.tags&&G.tags.map(de.from),containerName:G.containerName,location:Ue.from(G.location)}}_e.from=ke;function he(G){const we=new b.SymbolInformation(G.name,be.to(G.kind),G.containerName,Ue.to(G.location));return we.tags=G.tags&&G.tags.map(de.to),we}_e.to=he})(X||(e.WorkspaceSymbol=X={}));var J;(function(_e){function ke(G){const we={name:G.name||"!!MISSING: name!!",detail:G.detail,range:L.from(G.range),selectionRange:L.from(G.selectionRange),kind:be.from(G.kind),tags:G.tags?.map(de.from)??[]};return G.children&&(we.children=G.children.map(ke)),we}_e.from=ke;function he(G){const we=new b.DocumentSymbol(G.name,G.detail,be.to(G.kind),L.to(G.range),L.to(G.selectionRange));return(0,S.isNonEmptyArray)(G.tags)&&(we.tags=G.tags.map(de.to)),G.children&&(we.children=G.children.map(he)),we}_e.to=he})(J||(e.DocumentSymbol=J={}));var ve;(function(_e){function ke(G){const we=new b.CallHierarchyItem(be.to(G.kind),G.name,G.detail||"",s.URI.revive(G.uri),L.to(G.range),L.to(G.selectionRange));return we._sessionId=G._sessionId,we._itemId=G._itemId,we}_e.to=ke;function he(G,we,ze){if(we=we??G._sessionId,ze=ze??G._itemId,we===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ze,name:G.name,detail:G.detail,kind:be.from(G.kind),uri:G.uri,range:L.from(G.range),selectionRange:L.from(G.selectionRange),tags:G.tags?.map(de.from)}}_e.from=he})(ve||(e.CallHierarchyItem=ve={}));var pe;(function(_e){function ke(he){return new b.CallHierarchyIncomingCall(ve.to(he.from),he.fromRanges.map(G=>L.to(G)))}_e.to=ke})(pe||(e.CallHierarchyIncomingCall=pe={}));var Ae;(function(_e){function ke(he){return new b.CallHierarchyOutgoingCall(ve.to(he.to),he.fromRanges.map(G=>L.to(G)))}_e.to=ke})(Ae||(e.CallHierarchyOutgoingCall=Ae={}));var Ue;(function(_e){function ke(G){return{range:G.range&&L.from(G.range),uri:G.uri}}_e.from=ke;function he(G){return new b.Location(s.URI.revive(G.uri),L.to(G.range))}_e.to=he})(Ue||(e.location=Ue={}));var Ie;(function(_e){function ke(G){const we=G,ze=G;return{originSelectionRange:we.originSelectionRange?L.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:ze.uri,range:L.from(we.targetRange?we.targetRange:ze.range),targetSelectionRange:we.targetSelectionRange?L.from(we.targetSelectionRange):void 0}}_e.from=ke;function he(G){return{targetUri:s.URI.revive(G.uri),targetRange:L.to(G.range),targetSelectionRange:G.targetSelectionRange?L.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?L.to(G.originSelectionRange):void 0}}_e.to=he})(Ie||(e.DefinitionLink=Ie={}));var Pe;(function(_e){function ke(G){return{range:L.from(G.range),contents:me.fromMany(G.contents),canIncreaseVerbosity:G.canIncreaseVerbosity,canDecreaseVerbosity:G.canDecreaseVerbosity}}_e.from=ke;function he(G){const we=G.contents.map(me.to),ze=L.to(G.range),Qe=G.canIncreaseVerbosity,He=G.canDecreaseVerbosity;return new b.VerboseHover(we,ze,Qe,He)}_e.to=he})(Pe||(e.Hover=Pe={}));var Oe;(function(_e){function ke(G){return{range:L.from(G.range),expression:G.expression}}_e.from=ke;function he(G){return new b.EvaluatableExpression(L.to(G.range),G.expression)}_e.to=he})(Oe||(e.EvaluatableExpression=Oe={}));var x;(function(_e){function ke(G){if(G instanceof b.InlineValueText)return{type:"text",range:L.from(G.range),text:G.text};if(G instanceof b.InlineValueVariableLookup)return{type:"variable",range:L.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:L.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ke;function he(G){switch(G.type){case"text":return{range:L.to(G.range),text:G.text};case"variable":return{range:L.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:L.to(G.range),expression:G.expression}}}_e.to=he})(x||(e.InlineValue=x={}));var B;(function(_e){function ke(G){return{frameId:G.frameId,stoppedLocation:L.from(G.stoppedLocation)}}_e.from=ke;function he(G){return new b.InlineValueContext(G.frameId,L.to(G.stoppedLocation))}_e.to=he})(B||(e.InlineValueContext=B={}));var H;(function(_e){function ke(G){return{range:L.from(G.range),kind:G.kind}}_e.from=ke;function he(G){return new b.DocumentHighlight(L.to(G.range),G.kind)}_e.to=he})(H||(e.DocumentHighlight=H={}));var V;(function(_e){function ke(G){return{uri:G.uri,highlights:G.highlights.map(H.from)}}_e.from=ke;function he(G){return new b.MultiDocumentHighlight(s.URI.revive(G.uri),G.highlights.map(H.to))}_e.to=he})(V||(e.MultiDocumentHighlight=V={}));var re;(function(_e){function ke(he){switch(he){case n.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}_e.to=ke})(re||(e.CompletionTriggerKind=re={}));var ge;(function(_e){function ke(he){return{triggerKind:re.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}_e.to=ke})(ge||(e.CompletionContext=ge={}));var Te;(function(_e){function ke(G){switch(G){case b.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}_e.from=ke;function he(G){switch(G){case n.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}_e.to=he})(Te||(e.CompletionItemTag=Te={}));var xe;(function(_e){const ke=new Map([[b.CompletionItemKind.Method,n.CompletionItemKind.Method],[b.CompletionItemKind.Function,n.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,n.CompletionItemKind.Field],[b.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[b.CompletionItemKind.Class,n.CompletionItemKind.Class],[b.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[b.CompletionItemKind.Module,n.CompletionItemKind.Module],[b.CompletionItemKind.Property,n.CompletionItemKind.Property],[b.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[b.CompletionItemKind.Value,n.CompletionItemKind.Value],[b.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,n.CompletionItemKind.Text],[b.CompletionItemKind.Color,n.CompletionItemKind.Color],[b.CompletionItemKind.File,n.CompletionItemKind.File],[b.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[b.CompletionItemKind.Event,n.CompletionItemKind.Event],[b.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[b.CompletionItemKind.User,n.CompletionItemKind.User]]);function he(ze){return ke.get(ze)??n.CompletionItemKind.Property}_e.from=he;const G=new Map([[n.CompletionItemKind.Method,b.CompletionItemKind.Method],[n.CompletionItemKind.Function,b.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,b.CompletionItemKind.Field],[n.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[n.CompletionItemKind.Class,b.CompletionItemKind.Class],[n.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[n.CompletionItemKind.Module,b.CompletionItemKind.Module],[n.CompletionItemKind.Property,b.CompletionItemKind.Property],[n.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[n.CompletionItemKind.Value,b.CompletionItemKind.Value],[n.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,b.CompletionItemKind.Text],[n.CompletionItemKind.Color,b.CompletionItemKind.Color],[n.CompletionItemKind.File,b.CompletionItemKind.File],[n.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[n.CompletionItemKind.Event,b.CompletionItemKind.Event],[n.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,b.CompletionItemKind.User],[n.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function we(ze){return G.get(ze)??b.CompletionItemKind.Property}_e.to=we})(xe||(e.CompletionItemKind=xe={}));var qe;(function(_e){function ke(he,G){const we=new b.CompletionItem(he.label);return we.insertText=he.insertText,we.kind=xe.to(he.kind),we.tags=he.tags?.map(Te.to),we.detail=he.detail,we.documentation=A.isMarkdownString(he.documentation)?me.to(he.documentation):he.documentation,we.sortText=he.sortText,we.filterText=he.filterText,we.preselect=he.preselect,we.commitCharacters=he.commitCharacters,c.Range.isIRange(he.range)?we.range=L.to(he.range):typeof he.range=="object"&&(we.range={inserting:L.to(he.range.insert),replacing:L.to(he.range.replace)}),we.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof he.insertTextRules<"u"&&he.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?we.insertText=new b.SnippetString(he.insertText):(we.insertText=he.insertText,we.textEdit=we.range instanceof b.Range?new b.TextEdit(we.range,we.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(we.additionalTextEdits=he.additionalTextEdits.map(ze=>Ce.to(ze))),we.command=G&&he.command?G.fromInternal(he.command):void 0,we}_e.to=ke})(qe||(e.CompletionItem=qe={}));var Ze;(function(_e){function ke(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:me.fromStrict(G.documentation)}}_e.from=ke;function he(G){return{label:G.label,documentation:A.isMarkdownString(G.documentation)?me.to(G.documentation):G.documentation}}_e.to=he})(Ze||(e.ParameterInformation=Ze={}));var tt;(function(_e){function ke(G){return{label:G.label,documentation:me.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(Ze.from):[],activeParameter:G.activeParameter}}_e.from=ke;function he(G){return{label:G.label,documentation:A.isMarkdownString(G.documentation)?me.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(Ze.to):[],activeParameter:G.activeParameter}}_e.to=he})(tt||(e.SignatureInformation=tt={}));var nt;(function(_e){function ke(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(tt.from):[]}}_e.from=ke;function he(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(tt.to):[]}}_e.to=he})(nt||(e.SignatureHelp=nt={}));var et;(function(_e){function ke(he,G){const we=new b.InlayHint(j.to(G.position),typeof G.label=="string"?G.label:G.label.map(rt.to.bind(void 0,he)),G.kind&&ft.to(G.kind));return we.textEdits=G.textEdits&&G.textEdits.map(Ce.to),we.tooltip=A.isMarkdownString(G.tooltip)?me.to(G.tooltip):G.tooltip,we.paddingLeft=G.paddingLeft,we.paddingRight=G.paddingRight,we}_e.to=ke})(et||(e.InlayHint=et={}));var rt;(function(_e){function ke(he,G){const we=new b.InlayHintLabelPart(G.label);return we.tooltip=A.isMarkdownString(G.tooltip)?me.to(G.tooltip):G.tooltip,n.Command.is(G.command)&&(we.command=he.fromInternal(G.command)),G.location&&(we.location=Ue.to(G.location)),we}_e.to=ke})(rt||(e.InlayHintLabelPart=rt={}));var ft;(function(_e){function ke(G){return G}_e.from=ke;function he(G){return G}_e.to=he})(ft||(e.InlayHintKind=ft={}));var ct;(function(_e){function ke(G){return{range:L.from(G.range),url:G.target,tooltip:G.tooltip}}_e.from=ke;function he(G){let we;if(G.url)try{we=typeof G.url=="string"?s.URI.parse(G.url,!0):s.URI.revive(G.url)}catch{}const ze=new b.DocumentLink(L.to(G.range),we);return ze.tooltip=G.tooltip,ze}_e.to=he})(ct||(e.DocumentLink=ct={}));var st;(function(_e){function ke(G){const we=new b.ColorPresentation(G.label);return G.textEdit&&(we.textEdit=Ce.to(G.textEdit)),G.additionalTextEdits&&(we.additionalTextEdits=G.additionalTextEdits.map(ze=>Ce.to(ze))),we}_e.to=ke;function he(G){return{label:G.label,textEdit:G.textEdit?Ce.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(we=>Ce.from(we)):void 0}}_e.from=he})(st||(e.ColorPresentation=st={}));var lt;(function(_e){function ke(G){return new b.Color(G[0],G[1],G[2],G[3])}_e.to=ke;function he(G){return[G.red,G.green,G.blue,G.alpha]}_e.from=he})(lt||(e.Color=lt={}));var mt;(function(_e){function ke(G){return{range:L.from(G.range)}}_e.from=ke;function he(G){return new b.SelectionRange(L.to(G.range))}_e.to=he})(mt||(e.SelectionRange=mt={}));var vt;(function(_e){function ke(he){switch(he){case m.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case m.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case m.SaveReason.FOCUS_CHANGE:case m.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}_e.to=ke})(vt||(e.TextDocumentSaveReason=vt={}));var $e;(function(_e){function ke(G){switch(G){case b.TextEditorLineNumbersStyle.Off:return l.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return l.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return l.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return l.RenderLineNumbersType.On}}_e.from=ke;function he(G){switch(G){case l.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case l.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case l.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case l.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}_e.to=he})($e||(e.TextEditorLineNumbersStyle=$e={}));var Be;(function(_e){function ke(G){if(G===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(G===b.EndOfLine.LF)return t.EndOfLineSequence.LF}_e.from=ke;function he(G){if(G===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(G===t.EndOfLineSequence.LF)return b.EndOfLine.LF}_e.to=he})(Be||(e.EndOfLine=Be={}));var ie;(function(_e){function ke(he){if(typeof he=="object")return he.viewId;switch(he){case b.ProgressLocation.SourceControl:return u.ProgressLocation.Scm;case b.ProgressLocation.Window:return u.ProgressLocation.Window;case b.ProgressLocation.Notification:return u.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}_e.from=ke})(ie||(e.ProgressLocation=ie={}));var ee;(function(_e){function ke(G){const we={start:G.start+1,end:G.end+1};return G.kind&&(we.kind=Y.from(G.kind)),we}_e.from=ke;function he(G){const we={start:G.start-1,end:G.end-1};return G.kind&&(we.kind=Y.to(G.kind)),we}_e.to=he})(ee||(e.FoldingRange=ee={}));var Y;(function(_e){function ke(G){if(G)switch(G){case b.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}_e.from=ke;function he(G){if(G)switch(G.value){case n.FoldingRangeKind.Comment.value:return b.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports.value:return b.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region.value:return b.FoldingRangeKind.Region}}_e.to=he})(Y||(e.FoldingRangeKind=Y={}));var Xe;(function(_e){function ke(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?L.from(he.selection):void 0,override:typeof he.override=="boolean"?m.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}_e.from=ke})(Xe||(e.TextEditorOpenOptions=Xe={}));var Je;(function(_e){function ke(ze){return ze instanceof b.RelativePattern?ze.toJSON():typeof ze=="string"?ze:he(ze)||G(ze)?new b.RelativePattern(ze.baseUri??ze.base,ze.pattern).toJSON():ze}_e.from=ke;function he(ze){const Qe=ze;return Qe?s.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function G(ze){const Qe=ze;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function we(ze){return typeof ze=="string"?ze:new b.RelativePattern(s.URI.revive(ze.baseUri),ze.pattern)}_e.to=we})(Je||(e.GlobPattern=Je={}));var dt;(function(_e){function ke(he){if(he){if(Array.isArray(he))return he.map(ke);if(typeof he=="string")return he;{const G=he;return{language:G.language,scheme:G.scheme,pattern:Je.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}_e.from=ke})(dt||(e.LanguageSelector=dt={}));var bt;(function(_e){function ke(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(we=>Array.isArray(we)&&we.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&s.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(Qe=>Qe instanceof b.Range)))}_e.is=ke;function he(G){return{documents:G.documents.map(we=>we.map(ze=>({uri:s.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(Qe=>L.from(Qe))})))}}_e.from=he})(bt||(e.MappedEditsContext=bt={}));var Mt;(function(_e){function ke(G){return{start:G.start,end:G.end}}_e.from=ke;function he(G){return new b.NotebookRange(G.start,G.end)}_e.to=he})(Mt||(e.NotebookRange=Mt={}));var Ht;(function(_e){function ke(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}_e.to=ke;function he(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}_e.from=he})(Ht||(e.NotebookCellExecutionSummary=Ht={}));var Zt;(function(_e){function ke(he){if(he===E.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(he===E.NotebookCellExecutionState.Pending)return;if(he===E.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}_e.to=ke})(Zt||(e.NotebookCellExecutionState=Zt={}));var ei;(function(_e){function ke(G){switch(G){case b.NotebookCellKind.Markup:return E.CellKind.Markup;case b.NotebookCellKind.Code:default:return E.CellKind.Code}}_e.from=ke;function he(G){switch(G){case E.CellKind.Markup:return b.NotebookCellKind.Markup;case E.CellKind.Code:default:return b.NotebookCellKind.Code}}_e.to=he})(ei||(e.NotebookCellKind=ei={}));var oi;(function(_e){function ke(G){const we={metadata:G.metadata??Object.create(null),cells:[]};for(const ze of G.cells)b.NotebookCellData.validate(ze),we.cells.push(At.from(ze));return we}_e.from=ke;function he(G){const we=new b.NotebookData(G.cells.map(At.to));return(0,r.isEmptyObject)(G.metadata)||(we.metadata=G.metadata),we}_e.to=he})(oi||(e.NotebookData=oi={}));var At;(function(_e){function ke(G){return{cellKind:ei.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Ht.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Tt.from):[]}}_e.from=ke;function he(G){return new b.NotebookCellData(ei.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Tt.to):void 0,G.metadata,G.internalMetadata?Ht.to(G.internalMetadata):void 0)}_e.to=he})(At||(e.NotebookCellData=At={}));var Ye;(function(_e){function ke(G){return{mime:G.mime,valueBytes:k.VSBuffer.wrap(G.data)}}_e.from=ke;function he(G){return new b.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}_e.to=he})(Ye||(e.NotebookCellOutputItem=Ye={}));var Tt;(function(_e){function ke(G){return{outputId:G.id,items:G.items.map(Ye.from),metadata:G.metadata}}_e.from=ke;function he(G){const we=G.items.map(Ye.to);return new b.NotebookCellOutput(we,G.outputId,G.metadata)}_e.to=he})(Tt||(e.NotebookCellOutput=Tt={}));var di;(function(_e){function ke(we){return G(we)?{include:Je.from(we.include)??void 0,exclude:Je.from(we.exclude)??void 0}:Je.from(we)??void 0}_e.from=ke;function he(we){return G(we)?{include:Je.to(we.include),exclude:Je.to(we.exclude)}:Je.to(we)}_e.to=he;function G(we){const ze=we;return ze?!(0,r.isUndefinedOrNull)(ze.include)&&!(0,r.isUndefinedOrNull)(ze.exclude):!1}})(di||(e.NotebookExclusiveDocumentPattern=di={}));var pt;(function(_e){function ke(he,G,we){const ze=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===b.NotebookCellStatusBarAlignment.Left?E.CellStatusbarAlignment.Left:E.CellStatusbarAlignment.Right,command:G.toInternal(ze,we),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}_e.from=ke})(pt||(e.NotebookStatusBarItem=pt={}));var _t;(function(_e){function ke(he,G,we){const ze=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:G.toInternal(ze,we),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}_e.from=ke})(_t||(e.NotebookKernelSourceAction=_t={}));var ti;(function(_e){function ke(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}_e.from=ke})(ti||(e.NotebookDocumentContentOptions=ti={}));var ii;(function(_e){function ke(G){return{uri:G.uri,provides:G.provides}}_e.from=ke;function he(G){return new b.NotebookRendererScript(s.URI.revive(G.uri),G.provides)}_e.to=he})(ii||(e.NotebookRendererScript=ii={}));var Bt;(function(_e){function ke(G){return{message:me.fromStrict(G.message)||"",type:D.TestMessageType.Error,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:L.from(G.location.range),uri:G.location.uri},stackTrace:G.stackTrace?.map(we=>({label:we.label,position:we.position&&j.from(we.position),uri:we.file&&s.URI.revive(we.file).toJSON()}))}}_e.from=ke;function he(G){const we=new b.TestMessage(typeof G.message=="string"?G.message:me.to(G.message));return we.actualOutput=G.actual,we.expectedOutput=G.expected,we.contextValue=G.contextValue,we.location=G.location?Ue.to(G.location):void 0,we}_e.to=he})(Bt||(e.TestMessage=Bt={}));var gt;(function(_e){_e.namespace=D.namespaceTestTag,_e.denamespace=D.denamespaceTestTag})(gt||(e.TestTag=gt={}));var xt;(function(_e){function ke(G){const we=(0,v.getPrivateApiFor)(G).controllerId;return{extId:T.TestId.fromExtHostTestItem(G,we).toString(),label:G.label,uri:s.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(ze=>gt.namespace(we,ze.id)),range:c.Range.lift(L.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&me.fromStrict(G.error)||null}}_e.from=ke;function he(G){return{parent:void 0,error:void 0,id:T.TestId.fromString(G.extId).localId,label:G.label,uri:s.URI.revive(G.uri),tags:(G.tags||[]).map(we=>{const{tagId:ze}=gt.denamespace(we);return new b.TestTag(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:L.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}_e.toPlain=he})(xt||(e.TestItem=xt={})),function(_e){function ke(G){return{id:G.id}}_e.from=ke;function he(G){return new b.TestTag(G.id)}_e.to=he}(gt||(e.TestTag=gt={}));var ni;(function(_e){const ke=(G,we)=>{const ze=G.value;if(!ze)return;const Qe={...xt.toPlain(ze.item),parent:we,taskStates:ze.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(ut=>ut.type===D.TestMessageType.Error).map(Bt.to)})),children:[]};if(G.children)for(const He of G.children.values()){const ut=ke(He,Qe);ut&&Qe.children.push(ut)}return Qe};function he(G){const we=new a.WellDefinedPrefixTree;for(const He of G.items)we.insert(T.TestId.fromString(He.item.extId).path,He);const ze=[we.nodes],Qe=[];for(;ze.length;)for(const He of ze.pop())He.value?Qe.push(He):He.children&&ze.push(He.children.values());return{completedAt:G.completedAt,results:Qe.map(He=>ke(He)).filter(r.isDefined)}}_e.to=he})(ni||(e.TestResults=ni={}));var ai;(function(_e){function ke(ze){return{covered:ze.covered,total:ze.total}}function he(ze){return"line"in ze?j.from(ze):L.from(ze)}function G(ze){if(typeof ze.executed=="number"&&ze.executed<0)throw new Error(`Invalid coverage count ${ze.executed}`);return"branches"in ze?{count:ze.executed,location:he(ze.location),type:D.DetailType.Statement,branches:ze.branches.length?ze.branches.map(Qe=>({count:Qe.executed,location:Qe.location&&he(Qe.location),label:Qe.label})):void 0}:{type:D.DetailType.Declaration,name:ze.name,count:ze.executed,location:he(ze.location)}}_e.fromDetails=G;function we(ze,Qe,He){return b.validateTestCoverageCount(He.statementCoverage),b.validateTestCoverageCount(He.branchCoverage),b.validateTestCoverageCount(He.declarationCoverage),{id:Qe,uri:He.uri,statement:ke(He.statementCoverage),branch:He.branchCoverage&&ke(He.branchCoverage),declaration:He.declarationCoverage&&ke(He.declarationCoverage),testIds:He instanceof b.FileCoverage&&He.fromTests.length?He.fromTests.map(ut=>T.TestId.fromExtHostTestItem(ut,ze).toString()):void 0}}_e.fromFile=we})(ai||(e.TestCoverage=ai={}));var Ke;(function(_e){function ke(he){switch(he){case n.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}_e.to=ke})(Ke||(e.CodeActionTriggerKind=Ke={}));var li;(function(_e){function ke(G){const we=new b.TypeHierarchyItem(be.to(G.kind),G.name,G.detail||"",s.URI.revive(G.uri),L.to(G.range),L.to(G.selectionRange));return we._sessionId=G._sessionId,we._itemId=G._itemId,we}_e.to=ke;function he(G,we,ze){if(we=we??G._sessionId,ze=ze??G._itemId,we===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ze,kind:be.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:L.from(G.range),selectionRange:L.from(G.selectionRange),tags:G.tags?.map(de.from)}}_e.from=he})(li||(e.TypeHierarchyItem=li={}));var hi;(function(_e){function ke(he){if(he)return{value:he.value,tooltip:he.tooltip}}_e.from=ke})(hi||(e.ViewBadge=hi={}));var fi;(function(_e){function ke(ze,Qe,He){const ut=Qe.fileData;return ut?new b.InternalFileDataTransferItem(new b.DataTransferFile(ut.name,s.URI.revive(ut.uri),ut.id,(0,O.createSingleCallFunction)(()=>He(ut.id)))):ze===I.Mimes.uriList&&Qe.uriListData?new b.InternalDataTransferItem(we(Qe.uriListData)):new b.InternalDataTransferItem(Qe.asString)}_e.to=ke;async function he(ze,Qe){const He=await Qe.asString();if(ze===I.Mimes.uriList)return{asString:He,fileData:void 0,uriListData:G(He)};const ut=Qe.asFile();return{asString:He,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}_e.from=he;function G(ze){return P.UriList.split(ze).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return s.URI.parse(Qe)}catch{}return Qe})}function we(ze){return P.UriList.create(ze.map(Qe=>typeof Qe=="string"?Qe:s.URI.revive(Qe)))}})(fi||(e.DataTransferItem=fi={}));var St;(function(_e){function ke(G,we){const ze=G.items.map(([Qe,He])=>[Qe,fi.to(Qe,He,we)]);return new b.DataTransfer(ze)}_e.toDataTransfer=ke;async function he(G){const we={items:[]},ze=[];for(const[Qe,He]of G)ze.push((async()=>{we.items.push([Qe,await fi.from(Qe,He)])})());return await Promise.all(ze),we}_e.from=he})(St||(e.DataTransfer=St={}));var Ft;(function(_e){function ke(G,we){return{kind:"reply",agentId:G.participant??we?.agentId??"",subCommand:G.command??we?.command,message:G.prompt,title:G.label}}_e.from=ke;function he(G){return{prompt:G.message,label:G.title,participant:G.agentId,command:G.subCommand}}_e.to=he})(Ft||(e.ChatFollowup=Ft={}));var Lt;(function(_e){function ke(G){switch(G){case C.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case C.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case C.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}_e.to=ke;function he(G){switch(G){case b.LanguageModelChatMessageRole.System:return C.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return C.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return C.ChatMessageRole.Assistant}return C.ChatMessageRole.User}_e.from=he})(Lt||(e.LanguageModelChatMessageRole=Lt={}));var Wt;(function(_e){function ke(G){let we="",ze;G.content.type==="text"?we=G.content.value:ze=new b.LanguageModelFunctionResultPart(G.content.name,G.content.value,G.content.isError);const Qe=Lt.to(G.role),He=new b.LanguageModelChatMessage(Qe,we,G.name);return ze!==void 0&&(He.content2=ze),He}_e.to=ke;function he(G){const we=Lt.from(G.role),ze=G.name;let Qe;return G.content2 instanceof b.LanguageModelFunctionResultPart?Qe={type:"function_result",name:G.content2.name,value:G.content2.content,isError:G.content2.isError}:Qe={type:"text",value:G.content},{role:we,name:ze,content:Qe}}_e.from=he})(Wt||(e.LanguageModelChatMessage=Wt={}));var ri;(function(_e){function ke(G){return{kind:"markdownContent",content:me.from(G.value)}}_e.from=ke;function he(G){return new b.ChatResponseMarkdownPart(me.to(G.content))}_e.to=he})(ri||(e.ChatResponseMarkdownPart=ri={}));var jt;(function(_e){function ke(G){return{kind:"markdownVuln",content:me.from(G.value),vulnerabilities:G.vulnerabilities}}_e.from=ke;function he(G){return new b.ChatResponseMarkdownWithVulnerabilitiesPart(me.to(G.content),G.vulnerabilities)}_e.to=he})(jt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=jt={}));var ci;(function(_e){function ke(G){return{kind:"agentDetection",agentId:G.participant,command:G.command}}_e.from=ke;function he(G){return new b.ChatResponseDetectedParticipantPart(G.agentId,G.command)}_e.to=he})(ci||(e.ChatResponseDetectedParticipantPart=ci={}));var zt;(function(_e){function ke(he){return{kind:"confirmation",title:he.title,message:he.message,data:he.data,buttons:he.buttons}}_e.from=ke})(zt||(e.ChatResponseConfirmationPart=zt={}));var qt;(function(_e){function ke(G){const{value:we,baseUri:ze}=G;function Qe(He,ut){return He.map(kt=>{const Gt=s.URI.joinPath(ut,kt.name);return{label:kt.name,uri:Gt,children:kt.children&&Qe(kt.children,Gt)}})}return{kind:"treeData",treeData:{label:(0,y.basename)(ze),uri:ze,children:Qe(we,ze)}}}_e.from=ke;function he(G){const we=(0,o.revive)(G.treeData);function ze(ut){return ut.map(kt=>({name:kt.label,children:kt.children&&ze(kt.children)}))}const Qe=we.uri,He=we.children?ze(we.children):[];return new b.ChatResponseFileTreePart(He,Qe)}_e.to=he})(qt||(e.ChatResponseFilesPart=qt={}));var Kt;(function(_e){function ke(G){const we=ze=>s.URI.isUri(ze);return{kind:"inlineReference",name:G.title,inlineReference:we(G.value)?G.value:N.from(G.value)}}_e.from=ke;function he(G){const we=(0,o.revive)(G);return new b.ChatResponseAnchorPart(s.URI.isUri(we.inlineReference)?we.inlineReference:N.to(we.inlineReference),G.name)}_e.to=he})(Kt||(e.ChatResponseAnchorPart=Kt={}));var Nt;(function(_e){function ke(G){return{kind:"progressMessage",content:me.from(G.value)}}_e.from=ke;function he(G){return new b.ChatResponseProgressPart(G.content.value)}_e.to=he})(Nt||(e.ChatResponseProgressPart=Nt={}));var Et;(function(_e){function ke(G){return{kind:"warning",content:me.from(G.value)}}_e.from=ke;function he(G){return new b.ChatResponseWarningPart(G.content.value)}_e.to=he})(Et||(e.ChatResponseWarningPart=Et={}));var Dt;(function(_e){function ke(he){return{kind:"progressTask",content:me.from(he.value)}}_e.from=ke})(Dt||(e.ChatTask=Dt={}));var Vt;(function(_e){function ke(he){return{kind:"progressTaskResult",content:typeof he=="string"?me.from(he):void 0}}_e.from=ke})(Vt||(e.ChatTaskResult=Vt={}));var It;(function(_e){function ke(G,we,ze){return{kind:"command",command:we.toInternal(G.value,ze)??{command:G.value.command,title:G.value.title}}}_e.from=ke;function he(G,we){return new b.ChatResponseCommandButtonPart(we.fromInternal(G.command)??{command:G.command.id,title:G.command.title})}_e.to=he})(It||(e.ChatResponseCommandButtonPart=It={}));var mi;(function(_e){function ke(G){return{kind:"textEdit",uri:G.uri,edits:G.edits.map(we=>Ce.from(we))}}_e.from=ke;function he(G){return new b.ChatResponseTextEditPart(s.URI.revive(G.uri),G.edits.map(we=>Ce.to(we)))}_e.to=he})(mi||(e.ChatResponseTextEditPart=mi={}));var Qt;(function(_e){function ke(G){const we=h.ThemeIcon.isThemeIcon(G.iconPath)?G.iconPath:s.URI.isUri(G.iconPath)?{light:s.URI.revive(G.iconPath)}:G.iconPath&&"light"in G.iconPath&&"dark"in G.iconPath&&s.URI.isUri(G.iconPath.light)&&s.URI.isUri(G.iconPath.dark)?{light:s.URI.revive(G.iconPath.light),dark:s.URI.revive(G.iconPath.dark)}:void 0;return"variableName"in G.value?{kind:"reference",reference:{variableName:G.value.variableName,value:s.URI.isUri(G.value.value)||!G.value.value?G.value.value:N.from(G.value.value)},iconPath:we,options:G.options}:{kind:"reference",reference:s.URI.isUri(G.value)?G.value:N.from(G.value),iconPath:we,options:G.options}}_e.from=ke;function he(G){const we=(0,o.revive)(G),ze=Qe=>s.URI.isUri(Qe)?Qe:N.to(Qe);return new b.ChatResponseReferencePart("variableName"in we.reference?{variableName:we.reference.variableName,value:we.reference.value&&ze(we.reference.value)}:ze(we.reference))}_e.to=he})(Qt||(e.ChatResponseReferencePart=Qt={}));var Di;(function(_e){function ke(he){return{kind:"codeCitation",value:he.value,license:he.license,snippet:he.snippet}}_e.from=ke})(Di||(e.ChatResponseCodeCitationPart=Di={}));var Ei;(function(_e){function ke(we,ze,Qe){return we instanceof b.ChatResponseMarkdownPart?ri.from(we):we instanceof b.ChatResponseAnchorPart?Kt.from(we):we instanceof b.ChatResponseReferencePart?Qt.from(we):we instanceof b.ChatResponseProgressPart?Nt.from(we):we instanceof b.ChatResponseFileTreePart?qt.from(we):we instanceof b.ChatResponseCommandButtonPart?It.from(we,ze,Qe):we instanceof b.ChatResponseTextEditPart?mi.from(we):we instanceof b.ChatResponseMarkdownWithVulnerabilitiesPart?jt.from(we):we instanceof b.ChatResponseDetectedParticipantPart?ci.from(we):we instanceof b.ChatResponseWarningPart?Et.from(we):we instanceof b.ChatResponseConfirmationPart?zt.from(we):we instanceof b.ChatResponseCodeCitationPart?Di.from(we):{kind:"markdownContent",content:me.from("")}}_e.from=ke;function he(we,ze){switch(we.kind){case"reference":return Qt.to(we);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return G(we,ze)}}_e.to=he;function G(we,ze){switch(we.kind){case"markdownContent":return ri.to(we);case"inlineReference":return Kt.to(we);case"progressMessage":return;case"treeData":return qt.to(we);case"command":return It.to(we,ze)}}_e.toContent=G})(Ei||(e.ChatResponsePart=Ei={}));var Ai;(function(_e){function ke(he,G){const we=he.variables.variables.filter(Qe=>Qe.isTool).map(Qe=>Qe.id),ze=he.variables.variables.filter(Qe=>!Qe.isTool);return{prompt:he.message,command:he.command,attempt:he.attempt??0,enableCommandDetection:he.enableCommandDetection??!0,references:ze.map(Li.to),location:Rt.to(he.location),acceptedConfirmationData:he.acceptedConfirmationData,rejectedConfirmationData:he.rejectedConfirmationData,location2:G,requestedTools:we}}_e.to=ke})(Ai||(e.ChatAgentRequest=Ai={}));var Rt;(function(_e){function ke(G){switch(G){case d.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case d.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case d.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case d.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}_e.to=ke;function he(G){switch(G){case b.ChatLocation.Notebook:return d.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return d.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return d.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return d.ChatAgentLocation.Editor}}_e.from=he})(Rt||(e.ChatLocation=Rt={}));var Li;(function(_e){function ke(he){const G=he.value;if(!G)throw new Error("Invalid value reference");return{id:he.id,name:he.name,range:he.range&&[he.range.start,he.range.endExclusive],value:(0,s.isUriComponents)(G)?s.URI.revive(G):G&&typeof G=="object"&&"uri"in G&&"range"in G&&(0,s.isUriComponents)(G.uri)?N.to((0,o.revive)(G)):G,modelDescription:he.modelDescription}}_e.to=ke})(Li||(e.ChatAgentValueReference=Li={}));var ui;(function(_e){function ke(he,G,we){return{id:he.id,label:he.label,fullName:he.fullName,icon:he.icon?.id,value:he.values[0].value,insertText:he.insertText,detail:he.detail,documentation:he.documentation,command:G.toInternal(he.command,we)}}_e.from=ke})(ui||(e.ChatAgentCompletionItem=ui={}));var Pt;(function(_e){function ke(he){return{errorDetails:he.errorDetails,metadata:he.metadata}}_e.to=ke})(Pt||(e.ChatAgentResult=Pt={}));var Ri;(function(_e){function ke(he,G,we){if(G.action.kind==="vote")return;const ze=Pt.to(he);if(G.action.kind==="command"){const Qe=G.action.commandButton.command;return{action:{kind:"command",commandButton:{command:we.fromInternal(Qe)??{command:Qe.id,title:Qe.title}}},result:ze}}else return G.action.kind==="followUp"?{action:{kind:"followUp",followup:Ft.to(G.action.followup)},result:ze}:G.action.kind==="inlineChat"?{action:{kind:"editor",accepted:G.action.action==="accepted"},result:ze}:{action:G.action,result:ze}}_e.to=ke})(Ri||(e.ChatAgentUserActionEvent=Ri={}));var Ii;(function(_e){function ke(he,G,we){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:G.toInternal(he,we)}_e.from=ke})(Ii||(e.TerminalQuickFix=Ii={}));var _i;(function(_e){function ke(he){return{kind:Ni.to(he.kind)}}_e.to=ke})(_i||(e.PartialAcceptInfo=_i={}));var Ni;(function(_e){function ke(he){switch(he){case n.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}_e.to=ke})(Ni||(e.PartialAcceptTriggerKind=Ni={}));var bi;(function(_e){function ke(he,G){return{id:G,label:he.label,description:he.description,canEdit:he.canEdit,collapsibleState:he.collapsibleState||_.DebugTreeItemCollapsibleState.None,contextValue:he.contextValue}}_e.from=ke})(bi||(e.DebugTreeItem=bi={}));var $t;(function(_e){function ke(he){return{name:he.name,description:he.description,parametersSchema:he.parametersSchema}}_e.to=ke})($t||(e.LanguageModelToolDescription=$t={}))}),define(Le[232],Ne([1,0,5,16,8,39]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(p,o){this._proxy=p.getProxy(S.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:I=>o.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,o,I){const w=new O.SerializableObjectWithBuffers(P.WorkspaceEdit.from(p,this._versionInformationProvider));return this._proxy.$tryApplyWorkspaceEdit(w,void 0,I?.isRefactoring??!1)}};e.ExtHostBulkEdits=A,e.ExtHostBulkEdits=A=Ge([Ve(0,k.IExtHostRpcService)],A)}),define(Le[233],Ne([1,0,17,10,42,6,40,4,36,69,14,2,18,5,8,7,115,194,24]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0,h=We(h),r=We(r);class i{constructor(u,v,m,d,C){this._extension=u,this._request=v,this._proxy=m,this._commandsConverter=d,this._sessionDisposables=C,this._stopWatch=o.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let v=function(d){if(u._isClosed){const C=new Error("Response stream has been closed");throw Error.captureStackTrace(C,d),C}};const u=this;this._stopWatch.reset();const m=(d,C)=>{if(typeof this._firstProgress>"u"&&"content"in d&&(this._firstProgress=this._stopWatch.elapsed()),C){const _=this._proxy.$handleProgressChunk(this._request.requestId,d),E={report:T=>{_?.then(D=>{D&&(r.MarkdownString.isMarkdownString(T.value)?this._proxy.$handleProgressChunk(this._request.requestId,h.ChatResponseWarningPart.from(T),D):this._proxy.$handleProgressChunk(this._request.requestId,h.ChatResponseReferencePart.from(T),D))})}};Promise.all([_,C?.(E)]).then(([T,D])=>{T!==void 0&&D!==void 0&&this._proxy.$handleProgressChunk(this._request.requestId,h.ChatTaskResult.from(D),T)})}else this._proxy.$handleProgressChunk(this._request.requestId,d)};this._apiObject={markdown(d){v(this.markdown);const C=new r.ChatResponseMarkdownPart(d),_=h.ChatResponseMarkdownPart.from(C);return m(_),this},markdownWithVulnerabilities(d,C){v(this.markdown),C&&(0,c.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions");const _=new r.ChatResponseMarkdownWithVulnerabilitiesPart(d,C),E=h.ChatResponseMarkdownWithVulnerabilitiesPart.from(_);return m(E),this},filetree(d,C){v(this.filetree);const _=new r.ChatResponseFileTreePart(d,C),E=h.ChatResponseFilesPart.from(_);return m(E),this},anchor(d,C){v(this.anchor);const _=new r.ChatResponseAnchorPart(d,C),E=h.ChatResponseAnchorPart.from(_);return m(E),this},button(d){v(this.anchor);const C=new r.ChatResponseCommandButtonPart(d),_=h.ChatResponseCommandButtonPart.from(C,u._commandsConverter,u._sessionDisposables);return m(_),this},progress(d,C){v(this.progress);const _=new r.ChatResponseProgressPart2(d,C),E=C?h.ChatTask.from(_):h.ChatResponseProgressPart.from(_);return m(E,C),this},warning(d){v(this.progress),(0,c.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions");const C=new r.ChatResponseWarningPart(d),_=h.ChatResponseWarningPart.from(C);return m(_),this},reference(d,C){return this.reference2(d,C)},reference2(d,C,_){if(v(this.reference),"variableName"in d&&(0,c.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions"),"variableName"in d&&!d.value){const E=u._request.variables.variables.find(T=>T.name===d.variableName);if(E){let T;if(E.references?.length)T=E.references.map(D=>({kind:"reference",reference:{variableName:d.variableName,value:D.reference}}));else{const D=new r.ChatResponseReferencePart(d,C,_);T=[h.ChatResponseReferencePart.from(D)]}return T.forEach(D=>m(D)),this}}else{const E=new r.ChatResponseReferencePart(d,C,_),T=h.ChatResponseReferencePart.from(E);m(T)}return this},codeCitation(d,C,_){v(this.codeCitation),(0,c.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions");const E=new r.ChatResponseCodeCitationPart(d,C,_),T=h.ChatResponseCodeCitationPart.from(E);m(T)},textEdit(d,C){v(this.textEdit),(0,c.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions");const _=new r.ChatResponseTextEditPart(d,C),E=h.ChatResponseTextEditPart.from(_);return m(E),this},detectedParticipant(d,C){v(this.detectedParticipant),(0,c.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions");const _=new r.ChatResponseDetectedParticipantPart(d,C),E=h.ChatResponseDetectedParticipantPart.from(_);return m(E),this},confirmation(d,C,_,E){v(this.confirmation),(0,c.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions");const T=new r.ChatResponseConfirmationPart(d,C,_,E),D=h.ChatResponseConfirmationPart.from(T);return m(D),this},push(d){if(v(this.push),(d instanceof r.ChatResponseTextEditPart||d instanceof r.ChatResponseMarkdownWithVulnerabilitiesPart||d instanceof r.ChatResponseDetectedParticipantPart||d instanceof r.ChatResponseWarningPart||d instanceof r.ChatResponseConfirmationPart||d instanceof r.ChatResponseCodeCitationPart)&&(0,c.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions"),d instanceof r.ChatResponseReferencePart)this.reference2(d.value,d.iconPath,d.options);else{const C=h.ChatResponsePart.from(d,u._commandsConverter,u._sessionDisposables);m(C)}return this}}}return this._apiObject}}class n extends R.Disposable{static{this._idPool=0}constructor(u,v,m,d){super(),this._logService=v,this._commands=m,this._documents=d,this._agents=new Map,this._sessionDisposables=this._register(new R.DisposableMap),this._completionDisposables=this._register(new R.DisposableMap),this._proxy=u.getProxy(y.MainContext.MainThreadChatAgents2)}transferActiveChat(u){this._proxy.$transferActiveChatSession(u)}createChatAgent(u,v,m){const d=n._idPool++,C=new t(u,v,this._proxy,d,m);return this._agents.set(d,C),this._proxy.$registerAgent(d,u.identifier,v,{},void 0),C.apiAgent}createDynamicChatAgent(u,v,m,d){const C=n._idPool++,_=new t(u,v,this._proxy,C,d);return this._agents.set(C,_),this._proxy.$registerAgent(C,u.identifier,v,{isSticky:!0},m),_.apiAgent}async $invokeAgent(u,v,m,d){const C=this._agents.get(u);if(!C)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);const _=(0,p.revive)(v);let E=this._sessionDisposables.get(_.sessionId);E||(E=new R.DisposableStore,this._sessionDisposables.set(_.sessionId,E));const T=new i(C.extension,_,this._proxy,this._commands.converter,E);try{const D=await this.prepareHistoryTurns(_.agentId,m);let f;if(_.locationData?.type===s.ChatAgentLocation.Editor){const M=this._documents.getDocument(_.locationData.document);f=new r.ChatRequestEditorData(M,h.Selection.to(_.locationData.selection),h.Range.to(_.locationData.wholeRange))}else if(_.locationData?.type===s.ChatAgentLocation.Notebook){const M=this._documents.getDocument(_.locationData.sessionInputUri);f=new r.ChatRequestNotebookData(M)}else _.locationData?.type,s.ChatAgentLocation.Terminal;const b=C.invoke(h.ChatAgentRequest.to(_,f),{history:D},T.apiObject,d);return await(0,k.raceCancellation)(Promise.resolve(b).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(N){const W=`result.metadata MUST be JSON.stringify-able. Got error: ${N.message}`;return this._logService.error(`[${C.extension.identifier.value}] [@${C.id}] ${W}`,C.extension),{errorDetails:{message:W},timings:T.timings}}let L;return M?.errorDetails&&(L={...M.errorDetails,responseIsIncomplete:!0}),L?.responseIsRedacted&&(0,c.checkProposedApiEnabled)(C.extension,"chatParticipantPrivate"),{errorDetails:L,timings:T.timings,metadata:M?.metadata}}),d)}catch(D){return this._logService.error(D,C.extension),D instanceof r.LanguageModelError&&D.cause&&(D=D.cause),{errorDetails:{message:(0,P.toErrorMessage)(D),responseIsIncomplete:!0}}}finally{T.close()}}async prepareHistoryTurns(u,v){const m=[];for(const d of v.history){const C=h.ChatAgentResult.to(d.result),_=u===d.request.agentId?C:{...C,metadata:void 0},E=d.request.variables.variables.filter(D=>!D.isTool).map(h.ChatAgentValueReference.to);m.push(new r.ChatRequestTurn(d.request.message,d.request.command,E,d.request.agentId));const T=(0,S.coalesce)(d.response.map(D=>h.ChatResponsePart.toContent(D,this._commands.converter)));m.push(new r.ChatResponseTurn(T,_,d.request.agentId,d.request.command))}return m}$releaseSession(u){this._sessionDisposables.deleteAndDispose(u)}async $provideFollowups(u,v,m,d,C){const _=this._agents.get(v);if(!_)return Promise.resolve([]);const E=(0,p.revive)(u),T=await this.prepareHistoryTurns(_.id,d),D=h.ChatAgentResult.to(m);return(await _.provideFollowups(D,{history:T},C)).filter(f=>{const b=!f.participant||A.Iterable.some(this._agents.values(),M=>M.id===f.participant&&a.ExtensionIdentifier.equals(M.extension.identifier,_.extension.identifier));return b||this._logService.warn(`[@${_.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),b}).map(f=>h.ChatFollowup.from(f,E))}$acceptFeedback(u,v,m,d){const C=this._agents.get(u);if(!C)return;const _=h.ChatAgentResult.to(v);let E;switch(m){case l.ChatAgentVoteDirection.Down:E=r.ChatResultFeedbackKind.Unhelpful;break;case l.ChatAgentVoteDirection.Up:E=r.ChatResultFeedbackKind.Helpful;break}C.acceptFeedback(Object.freeze(d?{result:_,kind:E,reportIssue:d}:{result:_,kind:E}))}$acceptAction(u,v,m){const d=this._agents.get(u);if(!d||m.action.kind==="vote")return;const C=h.ChatAgentUserActionEvent.to(v,m,this._commands.converter);C&&d.acceptAction(Object.freeze(C))}async $invokeCompletionProvider(u,v,m){const d=this._agents.get(u);if(!d)return[];let C=this._completionDisposables.get(u);return C?C.clear():(C=new R.DisposableStore,this._completionDisposables.set(u,C)),(await d.invokeCompletionProvider(v,m)).map(E=>h.ChatAgentCompletionItem.from(E,this._commands.converter,C))}async $provideWelcomeMessage(u,v,m){const d=this._agents.get(u);if(d)return await d.provideWelcomeMessage(h.ChatLocation.to(v),m)}async $provideSampleQuestions(u,v,m){const d=this._agents.get(u);if(d)return(await d.provideSampleQuestions(h.ChatLocation.to(v),m)).map(C=>h.ChatFollowup.from(C,void 0))}}e.ExtHostChatAgents2=n;class t{constructor(u,v,m,d,C){this.extension=u,this.id=v,this._proxy=m,this._handle=d,this._requestHandler=C,this._onDidReceiveFeedback=new O.Emitter,this._onDidPerformAction=new O.Emitter}acceptFeedback(u){this._onDidReceiveFeedback.fire(u)}acceptAction(u){this._onDidPerformAction.fire(u)}async invokeCompletionProvider(u,v){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(u,v)??[]:[]}async provideFollowups(u,v,m){if(!this._followupProvider)return[];const d=await this._followupProvider.provideFollowups(u,v,m);return d?d.filter(C=>!(C&&"commandId"in C)).filter(C=>!(C&&"message"in C)):[]}async provideWelcomeMessage(u,v){if(!this._welcomeMessageProvider)return[];const m=await this._welcomeMessageProvider.provideWelcomeMessage(u,v);return m?m.map(d=>typeof d=="string"?d:h.MarkdownString.from(d)):[]}async provideSampleQuestions(u,v){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const m=await this._welcomeMessageProvider.provideSampleQuestions(u,v);return m||[]}get apiAgent(){let u=!1,v=!1;const m=()=>{u||v||(v=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{icon:this._iconPath?this._iconPath instanceof w.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof r.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:h.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:h.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:h.MarkdownString.from(this._helpTextPostfix),supportIssueReporting:this._supportIssueReporting,requester:this._requester,supportsSlowVariables:this._supportsSlowReferences}),v=!1}))},d=this;return{get id(){return d.id},get iconPath(){return d._iconPath},set iconPath(C){d._iconPath=C,m()},get requestHandler(){return d._requestHandler},set requestHandler(C){(0,I.assertType)(typeof C=="function","Invalid request handler"),d._requestHandler=C},get followupProvider(){return d._followupProvider},set followupProvider(C){d._followupProvider=C,m()},get isDefault(){return(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._isDefault},set isDefault(C){(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._isDefault=C,m()},get helpTextPrefix(){return(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._helpTextPrefix},set helpTextPrefix(C){(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._helpTextPrefix=C,m()},get helpTextVariablesPrefix(){return(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._helpTextVariablesPrefix},set helpTextVariablesPrefix(C){(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._helpTextVariablesPrefix=C,m()},get helpTextPostfix(){return(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._helpTextPostfix},set helpTextPostfix(C){(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._helpTextPostfix=C,m()},get isSecondary(){return(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._isSecondary},set isSecondary(C){(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._isSecondary=C,m()},get supportIssueReporting(){return(0,c.checkProposedApiEnabled)(d.extension,"chatParticipantPrivate"),d._supportIssueReporting},set supportIssueReporting(C){(0,c.checkProposedApiEnabled)(d.extension,"chatParticipantPrivate"),d._supportIssueReporting=C,m()},get onDidReceiveFeedback(){return d._onDidReceiveFeedback.event},set participantVariableProvider(C){if((0,c.checkProposedApiEnabled)(d.extension,"chatParticipantAdditions"),d._agentVariableProvider=C,C){if(!C.triggerCharacters.length)throw new Error("triggerCharacters are required");d._proxy.$registerAgentCompletionsProvider(d._handle,d.id,C.triggerCharacters)}else d._proxy.$unregisterAgentCompletionsProvider(d._handle,d.id)},get participantVariableProvider(){return(0,c.checkProposedApiEnabled)(d.extension,"chatParticipantAdditions"),d._agentVariableProvider},set welcomeMessageProvider(C){(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._welcomeMessageProvider=C,m()},get welcomeMessageProvider(){return(0,c.checkProposedApiEnabled)(d.extension,"defaultChatParticipant"),d._welcomeMessageProvider},onDidPerformAction:(0,c.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(C){d._requester=C,m()},get requester(){return d._requester},set supportsSlowReferences(C){(0,c.checkProposedApiEnabled)(d.extension,"chatParticipantPrivate"),d._supportsSlowReferences=C,m()},get supportsSlowReferences(){return(0,c.checkProposedApiEnabled)(d.extension,"chatParticipantPrivate"),d._supportsSlowReferences},dispose(){u=!0,d._followupProvider=void 0,d._onDidReceiveFeedback.dispose(),d._proxy.$unregisterAgent(d._handle)}}}invoke(u,v,m,d){return this._requestHandler(u,v,m,d)}}}),define(Le[234],Ne([1,0,13,4,34,5,8,7,24]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0,A=We(A),R=We(R);class o{static{this._idPool=0}constructor(a){this._resolver=new Map,this._proxy=a.getProxy(O.MainContext.MainThreadChatVariables)}async $resolveVariable(a,y,h,r){const s=this._resolver.get(a);if(s)try{if(s.resolver.resolve2){(0,p.checkProposedApiEnabled)(s.extension,"chatParticipantAdditions");const l=new I(y,this._proxy),c=await s.resolver.resolve2(s.data.name,{prompt:h},l.apiObject,r);if(c&&c[0])return c[0].value}else{const l=await s.resolver.resolve(s.data.name,{prompt:h},r);if(l&&l[0])return l[0].value}}catch(l){(0,S.onUnexpectedExternalError)(l)}}registerVariableResolver(a,y,h,r,s,l,c,i,n){const t=o._idPool++,g=n?P.ThemeIcon.fromId(n):void 0;return this._resolver.set(t,{extension:a,data:{id:y,name:h,description:r,modelDescription:s,icon:g},resolver:c}),this._proxy.$registerVariable(t,{id:y,name:h,description:r,modelDescription:s,isSlow:l,fullName:i,icon:g}),(0,k.toDisposable)(()=>{this._resolver.delete(t),this._proxy.$unregisterVariable(t)})}}e.ExtHostChatVariables=o;class I{constructor(a,y){this._requestId=a,this._proxy=y,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let y=function(r){if(a._isClosed){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,r),s}};const a=this,h=r=>{this._proxy.$handleProgressChunk(this._requestId,r)};this._apiObject={progress(r){y(this.progress);const s=new R.ChatResponseProgressPart(r),l=A.ChatResponseProgressPart.from(s);return h(l),this},reference(r){y(this.reference);const s=new R.ChatResponseReferencePart(r),l=A.ChatResponseReferencePart.from(s);return h(l),this},push(r){return y(this.push),r instanceof R.ChatResponseReferencePart?h(A.ChatResponseReferencePart.from(r)):r instanceof R.ChatResponseProgressPart&&h(A.ChatResponseProgressPart.from(r)),this}}}return this._apiObject}}}),define(Le[235],Ne([1,0,10,71,6,4,37,2,93,18,8,7,5,24]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=h,p=We(p),I=We(I),w=We(w);function h(r,s,l){const c=r.getProxy(a.MainContext.MainThreadComments);class i{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new o.ExtensionIdentifierMap,s.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===A.MarshalledId.CommentController){const T=this._commentControllers.get(E.handle);return T?T.value:E}else if(E&&E.$mid===A.MarshalledId.CommentThread){const T=E,D=this._commentControllers.get(T.commentControlHandle);if(!D)return T;const f=D.getCommentThread(T.commentThreadHandle);return f?f.value:T}else if(E&&(E.$mid===A.MarshalledId.CommentThreadReply||E.$mid===A.MarshalledId.CommentThreadInstance)){const T=this._commentControllers.get(E.thread.commentControlHandle);if(!T)return E;const D=T.getCommentThread(E.thread.commentThreadHandle);return D?E.$mid===A.MarshalledId.CommentThreadInstance?D.value:{thread:D.value,text:E.text}:E}else if(E&&E.$mid===A.MarshalledId.CommentNode){const T=this._commentControllers.get(E.thread.commentControlHandle);if(!T)return E;const D=T.getCommentThread(E.thread.commentThreadHandle);if(!D)return E;const f=E.commentUniqueId,b=D.getCommentByUniqueId(f);return b||E}else if(E&&E.$mid===A.MarshalledId.CommentThreadNode){const T=this._commentControllers.get(E.thread.commentControlHandle);if(!T)return E;const D=T.getCommentThread(E.thread.commentThreadHandle);if(!D)return E;const f=E.text,b=E.commentUniqueId,M=D.getCommentByUniqueId(b);return M?(typeof M.body=="string"?M.body=f:M.body=new w.MarkdownString(f),M):E}return E}})}createCommentController(E,T,D){const f=i.handlePool++,b=new t(E,f,T,D);this._commentControllers.set(b.handle,b);const M=this._commentControllersByExtension.get(E.identifier)||[];return M.push(b),this._commentControllersByExtension.set(E.identifier,M),b.value}async $createCommentThreadTemplate(E,T,D,f){const b=this._commentControllers.get(E);b&&b.$createCommentThreadTemplate(T,D,f)}async $setActiveComment(E,T){const D=this._commentControllers.get(E);D&&D.$setActiveComment(T??void 0)}async $updateCommentThreadTemplate(E,T,D){const f=this._commentControllers.get(E);f&&f.$updateCommentThreadTemplate(T,D)}$deleteCommentThread(E,T){this._commentControllers.get(E)?.$deleteCommentThread(T)}async $provideCommentingRanges(E,T,D){const f=this._commentControllers.get(E);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const b=await l.ensureDocumentData(R.URI.revive(T));return(0,S.asPromise)(async()=>{const M=await f.commentingRangeProvider.provideCommentingRanges(b.document,D);let L;return Array.isArray(M)?L={ranges:M,fileComments:!1}:M?L={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:L=M??void 0,L}).then(M=>{let L;return M&&(L={ranges:M.ranges.map(N=>I.Range.from(N)),fileComments:M.fileComments}),L})}$toggleReaction(E,T,D,f,b){const M=this._commentControllers.get(E);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,S.asPromise)(()=>{const L=M.getCommentThread(T);if(L){const N=L.getCommentByUniqueId(f.uniqueIdInThread);if(M!==void 0&&N&&M.reactionHandler)return M.reactionHandler(N,v(b))}return Promise.resolve(void 0)})}}class n{static{this._handlePool=0}set threadId(E){this._id=E}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(E){(E===void 0!=(this._range===void 0)||!E||!this._range||!E.isEqual(this._range))&&(this._range=E,this.modifications.range=E,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(E){this._canReply!==E&&(this._canReply=E,this.modifications.canReply=E,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(E){this._label=E,this.modifications.label=E,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(E){this._contextValue=E,this.modifications.contextValue=E,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(E){this._comments=E,this.modifications.comments=E,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(E){this._collapseState=E,this.modifications.collapsibleState=E,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(E){this._state=E,typeof E=="object"?((0,y.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=E.resolved,this.modifications.applicability=E.applicability):this.modifications.state=E,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(E,T,D,f,b,M,L,N,W){this._commentControllerHandle=T,this._id=D,this._uri=f,this._range=b,this._comments=M,this.extensionDescription=L,this._isTemplate=N,this.handle=n._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new P.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputDisposables.value=new O.DisposableStore,this._id===void 0&&(this._id=`${E}.${this.handle}`),c.$createCommentThread(T,this.handle,this._id,this._uri,I.Range.from(this._range),this._comments.map($=>g(this,$,this._commentsMap,this.extensionDescription)),L.identifier,this._isTemplate,W),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this._localDisposables.push({dispose:()=>{c.$deleteCommentThread(T,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range($){j.range=$},get comments(){return j.comments},set comments($){j.comments=$},get collapsibleState(){return j.collapsibleState},set collapsibleState($){j.collapsibleState=$},get canReply(){return j.canReply},set canReply($){j.canReply=$},get contextValue(){return j.contextValue},set contextValue($){j.contextValue=$},get label(){return j.label},set label($){j.label=$},get state(){return j.state},set state($){j.state=$},reveal:($,K)=>j.reveal($,K),hide:()=>j.hide(),dispose:()=>{j.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new O.DisposableStore);const E=D=>Object.prototype.hasOwnProperty.call(this.modifications,D),T={};E("range")&&(T.range=I.Range.from(this._range)),E("label")&&(T.label=this.label),E("contextValue")&&(T.contextValue=this.contextValue??null),E("comments")&&(T.comments=this._comments.map(D=>g(this,D,this._commentsMap,this.extensionDescription))),E("collapsibleState")&&(T.collapseState=m(this._collapseState)),E("canReply")&&(T.canReply=this.canReply),E("state")&&(T.state=d(this._state)),E("applicability")&&(T.applicability=C(this._state)),E("isTemplate")&&(T.isTemplate=this._isTemplate),this.modifications={},c.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,T)}getCommentByUniqueId(E){for(const T of this._commentsMap){const D=T[0],f=T[1];if(E===f)return D}}async reveal(E,T){(0,y.checkProposedApiEnabled)(this.extensionDescription,"commentReveal");let D;E&&E.body!==void 0?D=E:T=T??E;let f=D?this._commentsMap.get(D):void 0;f??=this._commentsMap.get(this._comments[0]);let b=!0,M=!1;return T?.focus===w.CommentThreadFocus.Reply?(M=!0,b=!1):T?.focus===w.CommentThreadFocus.Comment&&(b=!1),c.$revealCommentThread(this._commentControllerHandle,this.handle,f,{preserveFocus:b,focusReply:M})}async hide(){return c.$hideCommentThread(this._commentControllerHandle,this.handle)}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(E=>E.dispose())}}Ge([(0,k.debounce)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(E){this._commentingRangeProvider=E,E?.resourceHints&&(0,y.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),c.$updateCommentingRanges(this.handle,E?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(E){this._reactionHandler=E,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!E})}get options(){return this._options}set options(E){this._options=E,c.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,y.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,y.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(E,T,D,f){this._extension=E,this._handle=T,this._id=D,this._label=f,this._threads=new Map,c.$registerCommentController(this.handle,D,f,this._extension.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(M){b.options=M},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(M){b.commentingRangeProvider=M},get reactionHandler(){return b.reactionHandler},set reactionHandler(M){b.reactionHandler=M},get activeCommentThread(){return b.activeCommentThread},createCommentThread(M,L,N){return b.createCommentThread(M,L,N).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(E,T,D){T===void 0&&(0,y.checkProposedApiEnabled)(this._extension,"fileComments");const f=new n(this.id,this.handle,void 0,E,T,D,this._extension,!1);return this._threads.set(f.handle,f),f}$setActiveComment(E){if(!E){this._activeComment=void 0,this._activeThread=void 0;return}const T=this._threads.get(E.commentThreadHandle);T&&(this._activeComment=E.uniqueIdInThread?T.getCommentByUniqueId(E.uniqueIdInThread):void 0,this._activeThread=T)}$createCommentThreadTemplate(E,T,D){const f=new n(this.id,this.handle,void 0,R.URI.revive(E),I.Range.to(T),[],this._extension,!0,D);return f.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(E,T){const D=this._threads.get(E);D&&(D.range=I.Range.to(T))}$deleteCommentThread(E){this._threads.get(E)?.dispose(),this._threads.delete(E)}getCommentThread(E){return this._threads.get(E)}dispose(){this._threads.forEach(E=>{E.dispose()}),this._localDisposables.forEach(E=>E.dispose())}}function g(_,E,T,D){let f=T.get(E);return f||(f=++_.commentHandle,T.set(E,f)),E.state!==void 0&&(0,y.checkProposedApiEnabled)(D,"commentsDraftState"),E.reactions?.some(b=>b.reactors!==void 0)&&(0,y.checkProposedApiEnabled)(D,"commentReactor"),{mode:E.mode,contextValue:E.contextValue,uniqueIdInThread:f,body:typeof E.body=="string"?E.body:I.MarkdownString.from(E.body),userName:E.author.name,userIconPath:E.author.iconPath,label:E.label,commentReactions:E.reactions?E.reactions.map(b=>u(b)):void 0,state:E.state,timestamp:E.timestamp?.toJSON()}}function u(_){return{label:_.label,iconPath:_.iconPath?I.pathOrURIToURI(_.iconPath):void 0,count:_.count,hasReacted:_.authorHasReacted,reactors:_.reactors&&_.reactors.length>0&&typeof _.reactors[0]!="string"?_.reactors.map(E=>E.name):_.reactors}}function v(_){return{label:_.label||"",count:_.count||0,iconPath:_.iconPath?R.URI.revive(_.iconPath):"",authorHasReacted:_.hasReacted||!1,reactors:_.reactors?.map(E=>({name:E}))}}function m(_){if(_!==void 0)switch(_){case w.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case w.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function d(_){let E;if(typeof _=="object"?E=_.resolved:E=_,E!==void 0)switch(E){case w.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case w.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function C(_){let E;if(typeof _=="object"&&(E=_.applicability),E!==void 0)switch(E){case w.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case w.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Le[236],Ne([1,0,21,75,4,15,23,2,8,67,79,5,7]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0,p=We(p),w=We(w),a=We(a);class y{constructor(u,v){this.document=u,this._storagePath=v,this._backupCounter=1,this._edits=new I.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,v){await this.getEdit(u).undo(),v||this.disposeBackup()}async redo(u,v){await this.getEdit(u).redo(),v||this.disposeBackup()}disposeEdits(u){for(const v of u)this._edits.delete(v)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=t(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const v=this._edits.get(u,0);if(!v)throw new Error("No edit found");return v}}class h{constructor(){this._documents=new Map}get(u,v){return this._documents.get(this.key(u,v))}add(u,v,m){const d=this.key(u,v.uri);if(this._documents.has(d))throw new Error(`Document already exists for viewType:${u} resource:${v.uri}`);const C=new y(v,m);return this._documents.set(d,C),C}delete(u,v){const m=this.key(u,v.uri);this._documents.delete(m)}key(u,v){return`${u}@@@${v}`}}var r;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(r||(r={}));class s{constructor(){this._providers=new Map}addTextProvider(u,v,m){return this.add(u,{type:r.Text,extension:v,provider:m})}addCustomProvider(u,v,m){return this.add(u,{type:r.Custom,extension:v,provider:m})}get(u){return this._providers.get(u)}add(u,v){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,v),new a.Disposable(()=>this._providers.delete(u))}}class l{constructor(u,v,m,d,C){this._extHostDocuments=v,this._extensionStoragePaths=m,this._extHostWebview=d,this._extHostWebviewPanels=C,this._editorProviders=new s,this._documents=new h,this._proxy=u.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,v,m,d){const C=new P.DisposableStore;return i(m)?(C.add(this._editorProviders.addTextProvider(v,u,m)),this._proxy.$registerTextEditorProvider((0,o.toExtensionData)(u),v,d.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,o.shouldSerializeBuffersForPostMessage)(u))):(C.add(this._editorProviders.addCustomProvider(v,u,m)),c(m)&&C.add(m.onDidChangeCustomDocument(_=>{const E=this.getCustomDocumentEntry(v,_.document.uri);if(n(_)){const T=E.addEdit(_);this._proxy.$onDidEdit(_.document.uri,v,T,_.label)}else this._proxy.$onContentChange(_.document.uri,v)})),this._proxy.$registerCustomEditorProvider((0,o.toExtensionData)(u),v,d.webviewOptions||{},!!d.supportsMultipleEditorsPerDocument,(0,o.shouldSerializeBuffersForPostMessage)(u))),a.Disposable.from(C,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(v)}))}async $createCustomDocument(u,v,m,d,C){const _=this._editorProviders.get(v);if(!_)throw new Error(`No provider found for '${v}'`);if(_.type!==r.Custom)throw new Error(`Invalid provide type for '${v}'`);const E=R.URI.revive(u),T=await _.provider.openCustomDocument(E,{backupId:m,untitledDocumentData:d?.buffer},C);let D;return c(_.provider)&&this._extensionStoragePaths&&(D=this._extensionStoragePaths.workspaceValue(_.extension)??this._extensionStoragePaths.globalValue(_.extension)),this._documents.add(v,T,D),{editable:c(_.provider)}}async $disposeCustomDocument(u,v){const m=this._editorProviders.get(v);if(!m)throw new Error(`No provider found for '${v}'`);if(m.type!==r.Custom)throw new Error(`Invalid provider type for '${v}'`);const d=R.URI.revive(u),{document:C}=this.getCustomDocumentEntry(v,d);this._documents.delete(v,C),C.dispose()}async $resolveCustomEditor(u,v,m,d,C,_){const E=this._editorProviders.get(m);if(!E)throw new Error(`No provider found for '${m}'`);const T=p.ViewColumn.to(C),D=this._extHostWebview.createNewWebview(v,d.contentOptions,E.extension),f=this._extHostWebviewPanels.createNewWebviewPanel(v,m,d.title,T,d.options,D,d.active),b=R.URI.revive(u);switch(E.type){case r.Custom:{const{document:M}=this.getCustomDocumentEntry(m,b);return E.provider.resolveCustomEditor(M,f,_)}case r.Text:{const M=this._extHostDocuments.getDocument(b);return E.provider.resolveCustomTextEditor(M,f,_)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,v,m){this.getCustomDocumentEntry(v,u).disposeEdits(m)}async $onMoveCustomEditor(u,v,m){const d=this._editorProviders.get(m);if(!d)throw new Error(`No provider found for '${m}'`);if(!d.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const C=this._extHostWebviewPanels.getWebviewPanel(u);if(!C)throw new Error("No webview found");const _=R.URI.revive(v),E=this._extHostDocuments.getDocument(_);await d.provider.moveCustomTextEditor(E,C,S.CancellationToken.None)}async $undo(u,v,m,d){return this.getCustomDocumentEntry(v,u).undo(m,d)}async $redo(u,v,m,d){return this.getCustomDocumentEntry(v,u).redo(m,d)}async $revert(u,v,m){const d=this.getCustomDocumentEntry(v,u);await this.getCustomEditorProvider(v).revertCustomDocument(d.document,m),d.disposeBackup()}async $onSave(u,v,m){const d=this.getCustomDocumentEntry(v,u);await this.getCustomEditorProvider(v).saveCustomDocument(d.document,m),d.disposeBackup()}async $onSaveAs(u,v,m,d){const C=this.getCustomDocumentEntry(v,u);return this.getCustomEditorProvider(v).saveCustomDocumentAs(C.document,R.URI.revive(m),d)}async $backup(u,v,m){const d=this.getCustomDocumentEntry(v,u),_=await this.getCustomEditorProvider(v).backupCustomDocument(d.document,{destination:d.getNewBackupUri()},m);return d.updateBackup(_),_.id}getCustomDocumentEntry(u,v){const m=this._documents.get(u,R.URI.revive(v));if(!m)throw new Error("No custom document found");return m}getCustomEditorProvider(u){const m=this._editorProviders.get(u)?.provider;if(!m||!c(m))throw new Error("Custom document is not editable");return m}}e.ExtHostCustomEditors=l;function c(g){return!!g.onDidChangeCustomDocument}function i(g){return typeof g.resolveCustomTextEditor=="function"}function n(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function t(g){const u=g.scheme===O.Schemas.file||g.scheme===O.Schemas.untitled?g.fsPath:g.toString();return(0,k.hash)(u)+""}}),define(Le[237],Ne([1,0,9,107,2,5,7,8,6,11,28,50]),function(Se,e,S,k,P,O,A,R,p,o,I,w){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0,R=We(R);class y{#e;#t;#i;constructor(s,l,c,i,n,t,g,u){this._name=s,this._owner=l,this._maxDiagnosticsTotal=c,this._maxDiagnosticsPerFile=i,this._modelVersionIdProvider=n,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(i,c),this.#i=new I.ResourceMap(v=>t.getComparisonKey(v)),this.#e=g,this.#t=u}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,l){if(!s){this.clear();return}this._checkDisposed();let c=[];if(P.URI.isUri(s)){if(!l){this.delete(s);return}this.#i.set(s,l.slice()),c=[s]}else if(Array.isArray(s)){c=[];let t;s=[...s].sort(y._compareIndexedTuplesByUri);for(const g of s){const[u,v]=g;if((!t||u.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=u,c.push(u),this.#i.set(u,[])),v)this.#i.get(u)?.push(...v);else{const m=this.#i.get(u);m&&(m.length=0)}}}if(this.#t.fire(c),!this.#e)return;const i=[];let n=0;for(const t of c){let g=[];const u=this.#i.get(t);if(u)if(u.length>this._maxDiagnosticsPerFile){g=[];const v=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const d of u)if(d.severity===v[m]&&g.push({...R.Diagnostic.from(d),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;g.push({severity:k.MarkerSeverity.Info,message:(0,S.localize)(10838,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=u.map(v=>({...R.Diagnostic.from(v),modelVersionId:this._modelVersionIdProvider(t)}));if(i.push([t,g]),n+=g.length,n>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,i)}delete(s){this._checkDisposed(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(s,l){this._checkDisposed();for(const[c,i]of this)s.call(l,c,i,this)}*[Symbol.iterator](){this._checkDisposed();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this._checkDisposed();const l=this.#i.get(s);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this.#i.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,l){return s[0].toString()<l[0].toString()?-1:s[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=y;let h=class{static{a=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*this._maxDiagnosticsPerFile}static _mapper(s){const l=new I.ResourceMap;for(const c of s)l.set(c,c);return{uris:Object.freeze(Array.from(l.values()))}}constructor(s,l,c,i){this._logService=l,this._fileSystemInfoService=c,this._extHostDocumentsAndEditors=i,this._collections=new Map,this._onDidChangeDiagnostics=new p.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this._onDidChangeDiagnostics.event,a._mapper),this._proxy=s.getProxy(O.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(s,l){const{_collections:c,_proxy:i,_onDidChangeDiagnostics:n,_logService:t,_fileSystemInfoService:g,_extHostDocumentsAndEditors:u}=this,v=new class{$changeMany(C,_){i.$changeMany(C,_),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,C,_.length===0?"CLEARING":_)}$clear(C){i.$clear(C),t.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,C)}dispose(){i.dispose()}};let m;if(!l)l="_generated_diagnostic_collection_name_#"+a._idPool++,m=l;else if(!c.has(l))m=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do m=l+a._idPool++;while(c.has(m))}return new class extends y{constructor(){super(l,m,a._maxDiagnosticsTotal,a._maxDiagnosticsPerFile,C=>u.getDocument(C)?.version,g.extUri,v,n),c.set(m,this)}dispose(){super.dispose(),c.delete(m)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const l=new Map,c=[];for(const i of this._collections.values())i.forEach((n,t)=>{let g=l.get(n.toString());typeof g>"u"&&(g=c.length,l.set(n.toString(),g),c.push([n,[]])),c[g][1]=c[g][1].concat(...t)});return c}}_getDiagnostics(s){let l=[];for(const c of this._collections.values())c.has(s)&&(l=l.concat(c.get(s)));return l}$acceptMarkersChange(s){if(!this._mirrorCollection){const l="_generated_mirror",c=new y(l,l,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(l,c),this._mirrorCollection=c}for(const[l,c]of s)this._mirrorCollection.set(P.URI.revive(l),c.map(R.Diagnostic.to))}};e.ExtHostDiagnostics=h,e.ExtHostDiagnostics=h=a=Ge([Ve(1,o.ILogService),Ve(2,w.IExtHostFileSystemInfo)],h)}),define(Le[238],Ne([1,0,2,13,7,8,171,39]),function(Se,e,S,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class p{constructor(I,w,a,y={timeout:1500,errors:3}){this._logService=I,this._documents=w,this._mainThreadBulkEdits=a,this._thresholds=y,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(w,a,y)=>{const r={dispose:this._callbacks.push([w,a,I])};return Array.isArray(y)&&y.push(r),r}}async $participateInSave(I,w){const a=S.URI.revive(I);let y=!1;const h=setTimeout(()=>y=!0,this._thresholds.timeout),r=[];try{for(const s of[...this._callbacks]){if(y)break;const l=this._documents.getDocument(a),c=await this._deliverEventAsyncAndBlameBadListeners(s,{document:l,reason:O.TextDocumentSaveReason.to(w)});r.push(c)}}finally{clearTimeout(h)}return r}_deliverEventAsyncAndBlameBadListeners([I,w,a],y){const h=this._badListeners.get(I);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(a,I,w,y).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this._badListeners.get(I);this._badListeners.set(I,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,w,a,y){const h=[],r=Date.now(),{document:s,reason:l}=y,{version:c}=s,i=Object.freeze({document:s,reason:l,waitUntil(n){if(Object.isFrozen(h))throw(0,k.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(n))}});try{w.apply(a,[i])}catch(n){return Promise.reject(n)}return Object.freeze(h),new Promise((n,t)=>{const g=setTimeout(()=>t(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(u=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(g),n(u)}).catch(u=>{clearTimeout(g),t(u)})}).then(n=>{const t={edits:[]};for(const g of n)if(Array.isArray(g)&&g.every(u=>u instanceof P.TextEdit))for(const{newText:u,newEol:v,range:m}of g)t.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:m&&O.Range.from(m),text:u,eol:v&&O.EndOfLine.from(v)}});if(t.edits.length!==0)return c===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new R.SerializableObjectWithBuffers(t)):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=p}),define(Le[239],Ne([1,0,6,4,2,5,123,8,14,25,7]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0,R=We(R);class w{constructor(y,h){this._onDidAddDocument=new S.Emitter,this._onDidRemoveDocument=new S.Emitter,this._onDidChangeDocument=new S.Emitter,this._onDidSaveDocument=new S.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=y.getProxy(O.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const s of r)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const s of r)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(y){if(!y)return;const h=this._documentsAndEditors.getDocument(y);if(h)return h}getDocument(y){const h=this.getDocumentData(y);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return h.document}ensureDocumentData(y){const h=this._documentsAndEditors.getDocument(y);if(h)return Promise.resolve(h);let r=this._documentLoader.get(y.toString());return r||(r=this._proxy.$tryOpenDocument(y).then(s=>{this._documentLoader.delete(y.toString());const l=P.URI.revive(s);return(0,p.assertIsDefined)(this._documentsAndEditors.getDocument(l))},s=>(this._documentLoader.delete(y.toString()),Promise.reject(s))),this._documentLoader.set(y.toString(),r)),r}createDocumentData(y){return this._proxy.$tryCreateDocument(y).then(h=>P.URI.revive(h))}$acceptModelLanguageChanged(y,h){const r=P.URI.revive(y),s=this._documentsAndEditors.getDocument(r);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(h),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(y){const h=P.URI.revive(y),r=this._documentsAndEditors.getDocument(h);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(y,h){const r=P.URI.revive(y),s=this._documentsAndEditors.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(h),this._onDidChangeDocument.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,h,r){const s=P.URI.revive(y),l=this._documentsAndEditors.getDocument(s);if(!l)throw new Error("unknown document");l._acceptIsDirty(r),l.onEvents(h);let c;h.isUndoing?c=I.TextDocumentChangeReason.Undo:h.isRedoing&&(c=I.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,o.deepFreeze)({document:l.document,contentChanges:h.changes.map(i=>({range:R.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:c}))}setWordDefinitionFor(y,h){(0,A.setWordDefinitionFor)(y,h)}}e.ExtHostDocuments=w}),define(Le[70],Ne([1,0,240,6,14,2,3,5,16,8,7]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,o=We(o),e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class w{constructor(s,l,c){this._activeTabIdGetter=c,this._parentGroup=l,this.acceptDtoUpdate(s)}get apiObject(){if(!this._apiObject){const s=this,l={get isActive(){return s._dto.id===s._activeTabIdGetter()},get label(){return s._dto.label},get input(){return s._input},get isDirty(){return s._dto.isDirty},get isPinned(){return s._dto.isPinned},get isPreview(){return s._dto.isPreview},get group(){return s._parentGroup.apiObject}};this._apiObject=Object.freeze(l)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(s){this._dto=s,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case R.TabInputKind.TextInput:return new I.TextTabInput(O.URI.revive(this._dto.input.uri));case R.TabInputKind.TextDiffInput:return new I.TextDiffTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified));case R.TabInputKind.TextMergeInput:return new I.TextMergeTabInput(O.URI.revive(this._dto.input.base),O.URI.revive(this._dto.input.input1),O.URI.revive(this._dto.input.input2),O.URI.revive(this._dto.input.result));case R.TabInputKind.CustomEditorInput:return new I.CustomEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.viewType);case R.TabInputKind.WebviewEditorInput:return new I.WebviewEditorTabInput(this._dto.input.viewType);case R.TabInputKind.NotebookInput:return new I.NotebookEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new I.NotebookDiffEditorTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new I.TerminalEditorTabInput;case R.TabInputKind.InteractiveEditorInput:return new I.InteractiveWindowInput(O.URI.revive(this._dto.input.uri),O.URI.revive(this._dto.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new I.ChatEditorTabInput;case R.TabInputKind.MultiDiffEditorInput:return new I.TextMultiDiffTabInput(this._dto.input.diffEditors.map(s=>new I.TextDiffTabInput(O.URI.revive(s.original),O.URI.revive(s.modified))));default:return}}}class a{constructor(s,l){this._tabs=[],this._activeTabId="",this._dto=s,this._activeGroupIdGetter=l;for(const c of s.tabs)c.isActive&&(this._activeTabId=c.id),this._tabs.push(new w(c,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const s=this,l={get isActive(){return s._dto.groupId===s._activeGroupIdGetter()},get viewColumn(){return o.ViewColumn.to(s._dto.viewColumn)},get activeTab(){return s._tabs.find(c=>c.tabId===s._activeTabId)?.apiObject},get tabs(){return Object.freeze(s._tabs.map(c=>c.apiObject))}};this._apiObject=Object.freeze(l)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(s){this._dto=s}acceptTabOperation(s){if(s.kind===R.TabModelOperationKind.TAB_OPEN){const c=new w(s.tabDto,this,()=>this.activeTabId());return this._tabs.splice(s.index,0,c),s.tabDto.isActive&&(this._activeTabId=c.tabId),c}else if(s.kind===R.TabModelOperationKind.TAB_CLOSE){const c=this._tabs.splice(s.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return c.tabId===this._activeTabId&&(this._activeTabId=""),c}else if(s.kind===R.TabModelOperationKind.TAB_MOVE){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this._tabs.splice(s.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this._tabs.splice(s.index,0,c),c}const l=this._tabs.find(c=>c.tabId===s.tabDto.id);if(!l)throw new Error("INVALID tab");return s.tabDto.isActive?this._activeTabId=s.tabDto.id:this._activeTabId===s.tabDto.id&&!s.tabDto.isActive&&(this._activeTabId=""),l.acceptDtoUpdate(s.tabDto),l}activeTabId(){return this._activeTabId}}let y=class{constructor(s){this._onDidChangeTabs=new k.Emitter,this._onDidChangeTabGroups=new k.Emitter,this._extHostTabGroups=[],this._proxy=s.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const s=this,l={onDidChangeTabGroups:s._onDidChangeTabGroups.event,onDidChangeTabs:s._onDidChangeTabs.event,get all(){return Object.freeze(s._extHostTabGroups.map(c=>c.apiObject))},get activeTabGroup(){const c=s._activeGroupId;return(0,P.assertIsDefined)(s._extHostTabGroups.find(n=>n.groupId===c)?.apiObject)},close:async(c,i)=>{const n=Array.isArray(c)?c:[c];return n.length?h(n[0])?this._closeGroups(n,i):this._closeTabs(n,i):!0}};this._apiObject=Object.freeze(l)}return this._apiObject}$acceptEditorTabModel(s){const l=new Set(this._extHostTabGroups.map(v=>v.groupId)),c=new Set(s.map(v=>v.groupId)),i=(0,S.diffSets)(l,c),n=this._extHostTabGroups.filter(v=>i.removed.includes(v.groupId)).map(v=>v.apiObject),t=[],g=[];this._extHostTabGroups=s.map(v=>{const m=new a(v,()=>this._activeGroupId);return i.added.includes(m.groupId)?t.push(m.apiObject):g.push(m.apiObject),m});const u=(0,P.assertIsDefined)(s.find(v=>v.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:t,closed:n,changed:g}))}$acceptTabGroupUpdate(s){const l=this._extHostTabGroups.find(c=>c.groupId===s.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(s),s.isActive&&(this._activeGroupId=s.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const l=this._extHostTabGroups.find(i=>i.groupId===s.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const c=l.acceptTabOperation(s);switch(s.kind){case R.TabModelOperationKind.TAB_OPEN:this._onDidChangeTabs.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}_findExtHostTabFromApi(s){for(const l of this._extHostTabGroups)for(const c of l.tabs)if(c.apiObject===s)return c}_findExtHostTabGroupFromApi(s){return this._extHostTabGroups.find(l=>l.apiObject===s)}async _closeTabs(s,l){const c=[];for(const i of s){const n=this._findExtHostTabFromApi(i);if(!n)throw new Error("Tab close: Invalid tab not found!");c.push(n.tabId)}return this._proxy.$closeTab(c,l)}async _closeGroups(s,l){const c=[];for(const i of s){const n=this._findExtHostTabGroupFromApi(i);if(!n)throw new Error("Group close: Invalid group not found!");c.push(n.groupId)}return this._proxy.$closeGroup(c,l)}};e.ExtHostEditorTabs=y,e.ExtHostEditorTabs=y=Ge([Ve(0,p.IExtHostRpcService)],y);function h(r){return r.tabs!==void 0}}),define(Le[241],Ne([1,0,2,5,29,4,7,8,285,12,27,22,24,59]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0,P=We(P),R=We(R);class h{constructor(){this._schemes=[]}add(l){this._stateMachine=void 0,this._schemes.push(l)}delete(l){const c=this._schemes.indexOf(l);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const l=this._schemes.sort(),c=[];let i,n,t=p.State.LastKnownState,g=p.State.LastKnownState;for(const u of l){let v=i?(0,o.commonPrefixLength)(i,u):0;for(v===0?n=p.State.Start:n=g;v<u.length;v++)v+1===u.length?(t=g,g=p.State.BeforeColon):g+=1,c.push([n,u.toUpperCase().charCodeAt(v),g]),c.push([n,u.toLowerCase().charCodeAt(v),g]),n=g;i=u,g=t}c.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),c.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this._stateMachine=new p.StateMachine(c)}}provideDocumentLinks(l){this._initStateMachine();const c=[],i=p.LinkComputer.computeLinks({getLineContent(n){return l.lineAt(n-1).text},getLineCount(){return l.lineCount}},this._stateMachine);for(const n of i){const t=R.DocumentLink.to(n);t.target&&c.push(t)}return c}}class r{constructor(l,c){this._extHostLanguageFeatures=c,this._linkProvider=new h,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=l.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(l,c,i,n={}){if(r._validateFileSystemProvider(i),this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(l,"*",this._linkProvider));const t=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(t,i);let g=P.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(g+=P.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(g+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(g+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,a.checkProposedApiEnabled)(l,"fsChunks"),g+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let u;n.isReadonly&&(0,y.isMarkdownString)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this._proxy.$registerFileSystemProvider(t,c,g,u).catch(m=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${c}`),console.error(m)});const v=i.onDidChangeFile(m=>{const d=[];for(const C of m){const{uri:_,type:E}=C;if(_.scheme!==c)continue;let T;switch(E){case A.FileChangeType.Changed:T=P.FileChangeType.UPDATED;break;case A.FileChangeType.Created:T=P.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:T=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:_,type:T})}this._proxy.$onFileSystemChange(t,d)});return(0,O.toDisposable)(()=>{v.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(t),this._proxy.$unregisterProvider(t)})}static _validateFileSystemProvider(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(l){const{type:c,ctime:i,mtime:n,size:t,permissions:g}=l;return{type:c,ctime:i,mtime:n,size:t,permissions:g}}$stat(l,c){return Promise.resolve(this._getFsProvider(l).stat(S.URI.revive(c))).then(i=>r._asIStat(i))}$readdir(l,c){return Promise.resolve(this._getFsProvider(l).readDirectory(S.URI.revive(c)))}$readFile(l,c){return Promise.resolve(this._getFsProvider(l).readFile(S.URI.revive(c))).then(i=>w.VSBuffer.wrap(i))}$writeFile(l,c,i,n){return Promise.resolve(this._getFsProvider(l).writeFile(S.URI.revive(c),i.buffer,n))}$delete(l,c,i){return Promise.resolve(this._getFsProvider(l).delete(S.URI.revive(c),i))}$rename(l,c,i,n){return Promise.resolve(this._getFsProvider(l).rename(S.URI.revive(c),S.URI.revive(i),n))}$copy(l,c,i,n){const t=this._getFsProvider(l);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(S.URI.revive(c),S.URI.revive(i),n))}$mkdir(l,c){return Promise.resolve(this._getFsProvider(l).createDirectory(S.URI.revive(c)))}$watch(l,c,i,n){const t=this._getFsProvider(l).watch(S.URI.revive(i),n);this._watches.set(c,t)}$unwatch(l,c){const i=this._watches.get(c);i&&(i.dispose(),this._watches.delete(c))}$open(l,c,i){const n=this._getFsProvider(l);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(S.URI.revive(c),i))}$close(l,c){const i=this._getFsProvider(l);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(c))}$read(l,c,i,n){const t=this._getFsProvider(l);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const g=w.VSBuffer.alloc(n);return Promise.resolve(t.read(c,i,g.buffer,0,n)).then(u=>g.slice(0,u))}$write(l,c,i,n){const t=this._getFsProvider(l);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(c,i,n.buffer,0,n.byteLength))}_getFsProvider(l){const c=this._fsProvider.get(l);if(!c){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return c}}e.ExtHostFileSystem=r}),define(Le[242],Ne([1,0,6,41,2,5,8,7,29,48]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0,A=We(A);class I{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(h,r,s,l,c,i){this.session=Math.random(),this._onDidCreate=new S.Emitter,this._onDidChange=new S.Emitter,this._onDidDelete=new S.Emitter,this._config=0,i?.ignoreCreateEvents&&(this._config+=1),i?.ignoreChangeEvents&&(this._config+=2),i?.ignoreDeleteEvents&&(this._config+=4);const n=(0,k.parse)(c),t=typeof c=="string",g=i?.correlate,u=l(v=>{if(!(typeof v.session=="number"&&v.session!==this.session)&&!(g&&typeof v.session>"u")){if(!i?.ignoreCreateEvents)for(const m of v.created){const d=P.URI.revive(m);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this._onDidCreate.fire(d)}if(!i?.ignoreChangeEvents)for(const m of v.changed){const d=P.URI.revive(m);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this._onDidChange.fire(d)}if(!i?.ignoreDeleteEvents)for(const m of v.deleted){const d=P.URI.revive(m);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this._onDidDelete.fire(d)}}});this._disposable=R.Disposable.from(this.ensureWatching(h,s,c,i,i?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,u)}ensureWatching(h,r,s,l,c){const i=R.Disposable.from();if(typeof s=="string"||l?.ignoreChangeEvents&&l?.ignoreCreateEvents&&l?.ignoreDeleteEvents)return i;const n=h.getProxy(O.MainContext.MainThreadFileSystemEventService);let t=!1;(s.pattern.includes(k.GLOBSTAR)||s.pattern.includes(k.GLOB_SPLIT))&&(t=!0);let g;return c&&(l?.ignoreChangeEvents||l?.ignoreCreateEvents||l?.ignoreDeleteEvents)&&(g=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,l?.ignoreChangeEvents&&(g&=~p.FileChangeFilter.UPDATED),l?.ignoreCreateEvents&&(g&=~p.FileChangeFilter.ADDED),l?.ignoreDeleteEvents&&(g&=~p.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.session,s.baseUri,{recursive:t,excludes:l?.excludes??[],filter:g},!!c),R.Disposable.from({dispose:()=>n.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class w{constructor(h){this._events=h,this.session=this._events.session,this._created=new o.Lazy(()=>this._events.created.map(P.URI.revive)),this._changed=new o.Lazy(()=>this._events.changed.map(P.URI.revive)),this._deleted=new o.Lazy(()=>this._events.deleted.map(P.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class a{constructor(h,r,s){this._mainContext=h,this._logService=r,this._extHostDocumentsAndEditors=s,this._onFileSystemEvent=new S.Emitter,this._onDidRenameFile=new S.Emitter,this._onDidCreateFile=new S.Emitter,this._onDidDeleteFile=new S.Emitter,this._onWillRenameFile=new S.AsyncEmitter,this._onWillCreateFile=new S.AsyncEmitter,this._onWillDeleteFile=new S.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(h,r,s,l){return new I(this._mainContext,h,r,this._onFileSystemEvent.event,A.GlobPattern.from(s),l)}$onFileEvent(h){this._onFileSystemEvent.fire(new w(h))}$onDidRunFileOperation(h,r){switch(h){case p.FileOperation.MOVE:this._onDidRenameFile.fire(Object.freeze({files:r.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))}));break;case p.FileOperation.DELETE:this._onDidDeleteFile.fire(Object.freeze({files:r.map(s=>P.URI.revive(s.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this._onDidCreateFile.fire(Object.freeze({files:r.map(s=>P.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(h){return this._createWillExecuteEvent(h,this._onWillRenameFile)}getOnWillCreateFileEvent(h){return this._createWillExecuteEvent(h,this._onWillCreateFile)}getOnWillDeleteFileEvent(h){return this._createWillExecuteEvent(h,this._onWillDeleteFile)}_createWillExecuteEvent(h,r){return(s,l,c)=>{const i=function(t){s.call(l,t)};return i.extension=h,r.event(i,void 0,c)}}async $onWillRunFileOperation(h,r,s,l){switch(h){case p.FileOperation.MOVE:return await this._fireWillEvent(this._onWillRenameFile,{files:r.map(c=>({oldUri:P.URI.revive(c.source),newUri:P.URI.revive(c.target)}))},s,l);case p.FileOperation.DELETE:return await this._fireWillEvent(this._onWillDeleteFile,{files:r.map(c=>P.URI.revive(c.target))},s,l);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this._fireWillEvent(this._onWillCreateFile,{files:r.map(c=>P.URI.revive(c.target))},s,l)}}async _fireWillEvent(h,r,s,l){const c=new Set,i=[];if(await h.fireAsync(r,l,async(t,g)=>{const u=Date.now(),v=await Promise.resolve(t);v instanceof R.WorkspaceEdit&&(i.push([g.extension,v]),c.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-u>s&&this._logService.warn("SLOW file-participant",g.extension.identifier)}),l.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:g}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:u=>this._extHostDocumentsAndEditors.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(g)}return{edit:n,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=a}),define(Le[243],Ne([1,0,17,10,21,13,96,4,25,69,12,14,2,32,286,93,103,9,18,8,7,24,79,5]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0,r=We(r),i=We(i),u=We(u);class v{constructor(x,B){this._documents=x,this._provider=B}async provideDocumentSymbols(x,B){const H=this._documents.getDocument(x),V=await this._provider.provideDocumentSymbols(H,B);if(!(0,S.isFalsyOrEmpty)(V))return V[0]instanceof n.DocumentSymbol?V.map(i.DocumentSymbol.from):v._asDocumentSymbolTree(V)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((V,re)=>{let ge=V.location.range.start.compareTo(re.location.range.start);return ge===0&&(ge=re.location.range.end.compareTo(V.location.range.end)),ge});const B=[],H=[];for(const V of x){const re={name:V.name||"!!MISSING: name!!",kind:i.SymbolKind.from(V.kind),tags:V.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:i.Range.from(V.location.range),selectionRange:i.Range.from(V.location.range),children:[]};for(;;){if(H.length===0){H.push(re),B.push(re);break}const ge=H[H.length-1];if(y.Range.containsRange(ge.range,re.range)&&!y.Range.equalsRange(ge.range,re.range)){ge.children?.push(re),H.push(re);break}H.pop()}}return B}}class m{constructor(x,B,H,V,re,ge){this._documents=x,this._commands=B,this._provider=H,this._extension=V,this._extTelemetry=re,this._logService=ge,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,B){const H=this._documents.getDocument(x),V=await this._provider.provideCodeLenses(H,B);if(!V||B.isCancellationRequested)return;const re=this._cache.add(V),ge=new R.DisposableStore;this._disposables.set(re,ge);const Te={cacheId:re,lenses:[]};for(let xe=0;xe<V.length;xe++)Te.lenses.push({cacheId:[re,xe],range:i.Range.from(V[xe].range),command:this._commands.toInternal(V[xe].command,ge)});return Te}async resolveCodeLens(x,B){const H=x.cacheId&&this._cache.get(...x.cacheId);if(!H)return;let V;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?V=H:V=await this._provider.resolveCodeLens(H,B),V||(V=H),B.isCancellationRequested)return;const re=x.cacheId&&this._disposables.get(x.cacheId[0]);if(re){if(!V.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,ge),this._logService.error(ge);return}return x.command=this._commands.toInternal(V.command,re),x}}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}function d(Oe){return Array.isArray(Oe)?Oe.map(i.DefinitionLink.from):Oe?[i.DefinitionLink.from(Oe)]:[]}class C{constructor(x,B){this._documents=x,this._provider=B}async provideDefinition(x,B,H){const V=this._documents.getDocument(x),re=i.Position.to(B),ge=await this._provider.provideDefinition(V,re,H);return d(ge)}}class _{constructor(x,B){this._documents=x,this._provider=B}async provideDeclaration(x,B,H){const V=this._documents.getDocument(x),re=i.Position.to(B),ge=await this._provider.provideDeclaration(V,re,H);return d(ge)}}class E{constructor(x,B){this._documents=x,this._provider=B}async provideImplementation(x,B,H){const V=this._documents.getDocument(x),re=i.Position.to(B),ge=await this._provider.provideImplementation(V,re,H);return d(ge)}}class T{constructor(x,B){this._documents=x,this._provider=B}async provideTypeDefinition(x,B,H){const V=this._documents.getDocument(x),re=i.Position.to(B),ge=await this._provider.provideTypeDefinition(V,re,H);return d(ge)}}class D{static{this.HOVER_MAP_MAX_SIZE=10}constructor(x,B){this._documents=x,this._provider=B,this._hoverCounter=0,this._hoverMap=new Map}async provideHover(x,B,H,V){const re=this._documents.getDocument(x),ge=i.Position.to(B);let Te;if(H&&H.verbosityRequest){const tt=H.verbosityRequest.previousHover.id,nt=this._hoverMap.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:nt};Te=await this._provider.provideHover(re,ge,V,et)}else Te=await this._provider.provideHover(re,ge,V);if(!Te||(0,S.isFalsyOrEmpty)(Te.contents))return;Te.range||(Te.range=re.getWordRangeAtPosition(ge)),Te.range||(Te.range=new n.Range(ge,ge));const xe=i.Hover.from(Te),qe=this._hoverCounter;if(this._hoverMap.size===D.HOVER_MAP_MAX_SIZE){const tt=Math.min(...this._hoverMap.keys());this._hoverMap.delete(tt)}return this._hoverMap.set(qe,Te),this._hoverCounter+=1,{...xe,id:qe}}releaseHover(x){this._hoverMap.delete(x)}}class f{constructor(x,B){this._documents=x,this._provider=B}async provideEvaluatableExpression(x,B,H){const V=this._documents.getDocument(x),re=i.Position.to(B),ge=await this._provider.provideEvaluatableExpression(V,re,H);if(ge)return i.EvaluatableExpression.from(ge)}}class b{constructor(x,B){this._documents=x,this._provider=B}async provideInlineValues(x,B,H,V){const re=this._documents.getDocument(x),ge=await this._provider.provideInlineValues(re,i.Range.to(B),i.InlineValueContext.to(H),V);if(Array.isArray(ge))return ge.map(Te=>i.InlineValue.from(Te))}}class M{constructor(x,B){this._documents=x,this._provider=B}async provideDocumentHighlights(x,B,H){const V=this._documents.getDocument(x),re=i.Position.to(B),ge=await this._provider.provideDocumentHighlights(V,re,H);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class L{constructor(x,B){this._documents=x,this._provider=B}async provideMultiDocumentHighlights(x,B,H,V){const re=this._documents.getDocument(x),ge=H.map(qe=>this._documents.getDocument(qe)),Te=i.Position.to(B),xe=await this._provider.provideMultiDocumentHighlights(re,Te,ge,V);if(Array.isArray(xe))return xe.map(i.MultiDocumentHighlight.from)}}class N{constructor(x,B){this._documents=x,this._provider=B}async provideLinkedEditingRanges(x,B,H){const V=this._documents.getDocument(x),re=i.Position.to(B),ge=await this._provider.provideLinkedEditingRanges(V,re,H);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,S.coalesce)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class W{constructor(x,B){this._documents=x,this._provider=B}async provideReferences(x,B,H,V){const re=this._documents.getDocument(x),ge=i.Position.to(B),Te=await this._provider.provideReferences(re,ge,H,V);if(Array.isArray(Te))return Te.map(i.location.from)}}class j{static{this._maxCodeActionsPerFile=1e3}constructor(x,B,H,V,re,ge,Te){this._documents=x,this._commands=B,this._diagnostics=H,this._provider=V,this._logService=re,this._extension=ge,this._apiDeprecation=Te,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,B,H,V){const re=this._documents.getDocument(x),ge=h.Selection.isISelection(B)?i.Selection.to(B):i.Range.to(B),Te=[];for(const et of this._diagnostics.getDiagnostics(x))if(ge.intersection(et.range)&&Te.push(et)>j._maxCodeActionsPerFile)break;const xe={diagnostics:Te,only:H.only?new n.CodeActionKind(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},qe=await this._provider.provideCodeActions(re,ge,xe,V);if(!(0,S.isNonEmptyArray)(qe)||V.isCancellationRequested)return;const Ze=this._cache.add(qe),tt=new R.DisposableStore;this._disposables.set(Ze,tt);const nt=[];for(let et=0;et<qe.length;et++){const rt=qe[et];if(rt)if(j._isCommand(rt))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this._commands.toInternal(rt,tt)});else{xe.only&&(rt.kind?xe.only.contains(rt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=rt.ranges??[];nt.push({cacheId:[Ze,et],title:rt.title,command:rt.command&&this._commands.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?rt.isAI:!1,ranges:(0,t.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,S.coalesce)(ft.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:Ze,actions:nt}}async resolveCodeAction(x,B){const[H,V]=x,re=this._cache.get(H,V);if(!re||j._isCommand(re))return{};if(!this._provider.resolveCodeAction)return{};const ge=await this._provider.resolveCodeAction(re,B)??re;let Te;ge.edit&&(Te=i.WorkspaceEdit.from(ge.edit,void 0));let xe;if(ge.command){const qe=this._disposables.get(H);qe&&(xe=this._commands.toInternal(ge.command,qe))}return{edit:Te,command:xe}}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}class ${constructor(x,B,H,V,re){this._proxy=x,this._documents=B,this._provider=H,this._handle=V,this._extension=re,this._cache=new g.Cache("DocumentPasteEdit")}async prepareDocumentPaste(x,B,H,V){if(!this._provider.prepareDocumentPaste)return;const re=this._documents.getDocument(x),ge=B.map(qe=>i.Range.to(qe)),Te=i.DataTransfer.toDataTransfer(H,()=>{throw new O.NotImplementedError});if(await this._provider.prepareDocumentPaste(re,ge,Te,V),V.isCancellationRequested)return;const xe=Array.from(Te).filter(([,qe])=>!(qe instanceof n.InternalDataTransferItem));return i.DataTransfer.from(xe)}async providePasteEdits(x,B,H,V,re,ge){if(!this._provider.provideDocumentPasteEdits)return[];const Te=this._documents.getDocument(B),xe=H.map(nt=>i.Range.to(nt)),qe=i.DataTransfer.toDataTransfer(V,async nt=>(await this._proxy.$resolvePasteFileData(this._handle,x,nt)).buffer),Ze=await this._provider.provideDocumentPasteEdits(Te,xe,qe,{only:re.only?new n.DocumentDropOrPasteEditKind(re.only):void 0,triggerKind:re.triggerKind},ge);if(!Ze||ge.isCancellationRequested)return[];const tt=this._cache.add(Ze);return Ze.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,l.localize)(10834,null,this._extension.displayName||this._extension.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(x,B){const[H,V]=x,re=this._cache.get(H,V);if(!re||!this._provider.resolveDocumentPasteEdit)return{};const ge=await this._provider.resolveDocumentPasteEdit(re,B)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(x){this._cache.delete(x)}}class K{constructor(x,B){this._documents=x,this._provider=B}async provideDocumentFormattingEdits(x,B,H){const V=this._documents.getDocument(x),re=await this._provider.provideDocumentFormattingEdits(V,B,H);if(Array.isArray(re))return re.map(i.TextEdit.from)}}class q{constructor(x,B){this._documents=x,this._provider=B}async provideDocumentRangeFormattingEdits(x,B,H,V){const re=this._documents.getDocument(x),ge=i.Range.to(B),Te=await this._provider.provideDocumentRangeFormattingEdits(re,ge,H,V);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(x,B,H,V){(0,w.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const re=this._documents.getDocument(x),ge=B.map(i.Range.to),Te=await this._provider.provideDocumentRangesFormattingEdits(re,ge,H,V);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class ae{constructor(x,B){this._documents=x,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,B,H,V,re){const ge=this._documents.getDocument(x),Te=i.Position.to(B),xe=await this._provider.provideOnTypeFormattingEdits(ge,Te,H,V,re);if(Array.isArray(xe))return xe.map(i.TextEdit.from)}}class Ee{constructor(x,B){this._provider=x,this._logService=B,this._cache=new g.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(x,B){const H=await this._provider.provideWorkspaceSymbols(x,B);if(!(0,S.isNonEmptyArray)(H))return{symbols:[]};const V=this._cache.add(H),re={cacheId:V,symbols:[]};for(let ge=0;ge<H.length;ge++){const Te=H[ge];if(!Te||!Te.name){this._logService.warn("INVALID SymbolInformation",Te);continue}re.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[V,ge]})}return re}async resolveWorkspaceSymbol(x,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!x.cacheId)return x;const H=this._cache.get(...x.cacheId);if(H){const V=await this._provider.resolveWorkspaceSymbol(H,B);return V&&(0,p.mixin)(x,i.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(x){this._cache.delete(x)}}class ce{static supportsResolving(x){return typeof x.prepareRename=="function"}constructor(x,B,H){this._documents=x,this._provider=B,this._logService=H}async provideRenameEdits(x,B,H,V){const re=this._documents.getDocument(x),ge=i.Position.to(B);try{const Te=await this._provider.provideRenameEdits(re,ge,H,V);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const xe=ce._asMessage(Te);return xe?{rejectReason:xe,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(x,B,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument(x),re=i.Position.to(B);try{const ge=await this._provider.prepareRename(V,re,H);let Te,xe;if(n.Range.isRange(ge)?(Te=ge,xe=V.getText(ge)):(0,w.isObject)(ge)&&(Te=ge.range,xe=ge.placeholder),!Te||!xe)return;if(Te.start.line>re.line||Te.end.line<re.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:xe}}catch(ge){const Te=ce._asMessage(ge);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(ge)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class Z{static{this.languageTriggerKindToVSCodeTriggerKind={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(x,B,H){this._documents=x,this._provider=B,this._logService=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this._provider.supportsAutomaticTriggerKind}async provideNewSymbolNames(x,B,H,V){const re=this._documents.getDocument(x),ge=i.Range.to(B);try{const Te=Z.languageTriggerKindToVSCodeTriggerKind[H],xe=await this._provider.provideNewSymbolNames(re,ge,Te,V);return xe?xe.map(qe=>typeof qe=="string"?{newSymbolName:qe}:{newSymbolName:qe.newSymbolName,tags:qe.tags}):void 0}catch(Te){this._logService.error(Z._asMessage(Te)??JSON.stringify(Te,null,"	"));return}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class le{constructor(x,B){this.resultId=x,this.tokens=B}}class me{constructor(x,B){this._documents=x,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,B,H){const V=this._documents.getDocument(x),re=B!==0?this._previousResults.get(B):null;let ge=typeof re?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,re.resultId,H):await this._provider.provideDocumentSemanticTokens(V,H);return re&&this._previousResults.delete(B),ge?(ge=me._fixProvidedSemanticTokens(ge),this._send(me._convertToEdits(re,ge),ge)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return me._isSemanticTokens(x)?me._isCorrectSemanticTokens(x)?x:new n.SemanticTokens(new Uint32Array(x.data),x.resultId):me._isSemanticTokensEdits(x)?me._isCorrectSemanticTokensEdits(x)?x:new n.SemanticTokensEdits(x.edits.map(B=>new n.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const B of x.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,B){if(!me._isSemanticTokens(B)||!x||!x.tokens)return B;const H=x.tokens,V=H.length,re=B.data,ge=re.length;let Te=0;const xe=Math.min(V,ge);for(;Te<xe&&H[Te]===re[Te];)Te++;if(Te===V&&Te===ge)return new n.SemanticTokensEdits([],B.resultId);let qe=0;const Ze=xe-Te;for(;qe<Ze&&H[V-qe-1]===re[ge-qe-1];)qe++;return new n.SemanticTokensEdits([{start:Te,deleteCount:V-Te-qe,data:re.subarray(Te,ge-qe)}],B.resultId)}_send(x,B){if(me._isSemanticTokens(x)){const H=this._nextResultId++;return this._previousResults.set(H,new le(x.resultId,x.data)),(0,s.encodeSemanticTokensDto)({id:H,type:"full",data:x.data})}if(me._isSemanticTokensEdits(x)){const H=this._nextResultId++;return me._isSemanticTokens(B)?this._previousResults.set(H,new le(B.resultId,B.data)):this._previousResults.set(H,new le(x.resultId)),(0,s.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(x.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class oe{constructor(x,B){this._documents=x,this._provider=B}async provideDocumentRangeSemanticTokens(x,B,H){const V=this._documents.getDocument(x),re=await this._provider.provideDocumentRangeSemanticTokens(V,i.Range.to(B),H);return re?this._send(re):null}_send(x){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}class De{static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}constructor(x,B,H,V,re){this._documents=x,this._commands=B,this._provider=H,this._apiDeprecation=V,this._extension=re,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(x,B,H,V){const re=this._documents.getDocument(x),ge=i.Position.to(B),Te=re.getWordRangeAtPosition(ge)||new n.Range(ge,ge),xe=Te.with({end:ge}),qe=new o.StopWatch,Ze=await this._provider.provideCompletionItems(re,ge,V,i.CompletionContext.to(H));if(!Ze||V.isCancellationRequested)return;const tt=Array.isArray(Ze)?new n.CompletionList(Ze):Ze,nt=De.supportsResolving(this._provider)?this._cache.add(tt.items):this._cache.add([]),et=new R.DisposableStore;this._disposables.set(nt,et);const rt=[],ft={x:nt,[u.ISuggestResultDtoField.completions]:rt,[u.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Te),insert:i.Range.from(xe)},[u.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[u.ISuggestResultDtoField.duration]:qe.elapsed()};for(let ct=0;ct<tt.items.length;ct++){const st=tt.items[ct],lt=this._convertCompletionItem(st,[nt,ct],xe,Te);rt.push(lt)}return ft}async resolveCompletionItem(x,B){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...x);if(!H)return;const V=this._convertCompletionItem(H,x),re=await this._provider.resolveCompletionItem(H,B);if(!re)return;const ge=this._convertCompletionItem(re,x);return(V[u.ISuggestDataDtoField.insertText]!==ge[u.ISuggestDataDtoField.insertText]||V[u.ISuggestDataDtoField.insertTextRules]!==ge[u.ISuggestDataDtoField.insertTextRules])&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V[u.ISuggestDataDtoField.commandIdent]!==ge[u.ISuggestDataDtoField.commandIdent]||V[u.ISuggestDataDtoField.commandId]!==ge[u.ISuggestDataDtoField.commandId]||!(0,p.equals)(V[u.ISuggestDataDtoField.commandArguments],ge[u.ISuggestDataDtoField.commandArguments]))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,[u.ISuggestDataDtoField.documentation]:ge[u.ISuggestDataDtoField.documentation],[u.ISuggestDataDtoField.detail]:ge[u.ISuggestDataDtoField.detail],[u.ISuggestDataDtoField.additionalTextEdits]:ge[u.ISuggestDataDtoField.additionalTextEdits],[u.ISuggestDataDtoField.insertText]:ge[u.ISuggestDataDtoField.insertText],[u.ISuggestDataDtoField.insertTextRules]:ge[u.ISuggestDataDtoField.insertTextRules],[u.ISuggestDataDtoField.commandIdent]:ge[u.ISuggestDataDtoField.commandIdent],[u.ISuggestDataDtoField.commandId]:ge[u.ISuggestDataDtoField.commandId],[u.ISuggestDataDtoField.commandArguments]:ge[u.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,B,H,V){const re=this._disposables.get(B[0]);if(!re)throw Error("DisposableStore is missing...");const ge=this._commands.toInternal(x.command,re),Te={x:B,[u.ISuggestDataDtoField.label]:x.label,[u.ISuggestDataDtoField.kind]:x.kind!==void 0?i.CompletionItemKind.from(x.kind):void 0,[u.ISuggestDataDtoField.kindModifier]:x.tags&&x.tags.map(i.CompletionItemTag.from),[u.ISuggestDataDtoField.detail]:x.detail,[u.ISuggestDataDtoField.documentation]:typeof x.documentation>"u"?void 0:i.MarkdownString.fromStrict(x.documentation),[u.ISuggestDataDtoField.sortText]:x.sortText!==x.label?x.sortText:void 0,[u.ISuggestDataDtoField.filterText]:x.filterText!==x.label?x.filterText:void 0,[u.ISuggestDataDtoField.preselect]:x.preselect||void 0,[u.ISuggestDataDtoField.insertTextRules]:x.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[u.ISuggestDataDtoField.commitCharacters]:x.commitCharacters?.join(""),[u.ISuggestDataDtoField.additionalTextEdits]:x.additionalTextEdits&&x.additionalTextEdits.map(i.TextEdit.from),[u.ISuggestDataDtoField.commandIdent]:ge?.$ident,[u.ISuggestDataDtoField.commandId]:ge?.id,[u.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te[u.ISuggestDataDtoField.insertText]=x.textEdit.newText):typeof x.insertText=="string"?Te[u.ISuggestDataDtoField.insertText]=x.insertText:x.insertText instanceof n.SnippetString&&(Te[u.ISuggestDataDtoField.insertText]=x.insertText.value,Te[u.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let xe;return x.textEdit?xe=x.textEdit.range:x.range&&(xe=x.range),n.Range.isRange(xe)?Te[u.ISuggestDataDtoField.range]=i.Range.from(xe):xe&&(!H?.isEqual(xe.inserting)||!V?.isEqual(xe.replacing))&&(Te[u.ISuggestDataDtoField.range]={insert:i.Range.from(xe.inserting),replace:i.Range.from(xe.replacing)}),Te}}class Re{async provideInlineCompletions(x,B,H,V){}async provideInlineEdits(x,B,H,V){}disposeCompletions(x){}handleDidShowCompletionItem(x,B,H){}handlePartialAccept(x,B,H,V){}}class Q extends Re{constructor(x,B,H,V){super(),this._extension=x,this._documents=B,this._provider=H,this._commands=V,this._references=new ne,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(x,B,H,V){const re=this._documents.getDocument(x),ge=i.Position.to(B),Te=await this._provider.provideInlineCompletionItems(re,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!Te||V.isCancellationRequested)return;const xe=Array.isArray(Te)?Te:Te.items,qe=this._isAdditionsProposedApiEnabled?Array.isArray(Te)?[]:Te.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:xe}),items:xe.map((et,rt)=>{let ft;et.command&&(tt||(tt=new R.DisposableStore),ft=this._commands.toInternal(et.command,tt));const ct=et.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this._isAdditionsProposedApiEnabled?et.completeBracketPairs:!1}}),commands:qe.map(et=>(tt||(tt=new R.DisposableStore),this._commands.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:Ze}}async provideInlineEdits(x,B,H,V){if(!this._provider.provideInlineEdits)return;(0,t.checkProposedApiEnabled)(this._extension,"inlineCompletionsAdditions");const re=this._documents.getDocument(x),ge=i.Range.to(B),Te=await this._provider.provideInlineEdits(re,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind],userPrompt:H.userPrompt},V);if(!Te||V.isCancellationRequested)return;const xe=Array.isArray(Te)?Te:Te.items,qe=this._isAdditionsProposedApiEnabled?Array.isArray(Te)?[]:Te.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:xe}),items:xe.map((et,rt)=>{let ft;et.command&&(tt||(tt=new R.DisposableStore),ft=this._commands.toInternal(et.command,tt));const ct=et.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this._isAdditionsProposedApiEnabled?et.completeBracketPairs:!1}}),commands:qe.map(et=>(tt||(tt=new R.DisposableStore),this._commands.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(x){this._references.disposeReferenceId(x)?.dispose()}handleDidShowCompletionItem(x,B,H){const V=this._references.get(x)?.items[B];V&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V,H)}handlePartialAccept(x,B,H,V){const re=this._references.get(x)?.items[B];re&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(re,H),this._provider.handleDidPartiallyAcceptCompletionItem(re,i.PartialAcceptInfo.to(V)))}}class z{async provideInlineEdits(x,B,H){const V=this._documents.getDocument(x),re=await this._provider.provideInlineEdit(V,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[B.triggerKind]},H);if(!re||H.isCancellationRequested)return;let ge;const Te=this._references.createReferenceId({dispose(){ge?.dispose()},item:re});let xe;re.accepted&&(ge||(ge=new R.DisposableStore),xe=this._commands.toInternal(re.accepted,ge));let qe;return re.rejected&&(ge||(ge=new R.DisposableStore),qe=this._commands.toInternal(re.rejected,ge)),{pid:Te,text:re.text,range:i.Range.from(re.range),accepted:xe,rejected:qe}}disposeEdit(x){this._references.disposeReferenceId(x)?.dispose()}constructor(x,B,H,V){this._documents=B,this._provider=H,this._commands=V,this._references=new ne,this.languageTriggerKindToVSCodeTriggerKind={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class ne{constructor(){this._references=new Map,this._idPool=1}createReferenceId(x){const B=this._idPool++;return this._references.set(B,x),B}disposeReferenceId(x){const B=this._references.get(x);return this._references.delete(x),B}get(x){return this._references.get(x)}}class Ce{constructor(x,B){this._documents=x,this._provider=B,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(x,B,H,V){const re=this._documents.getDocument(x),ge=i.Position.to(B),Te=this.reviveContext(H),xe=await this._provider.provideSignatureHelp(re,ge,V,Te);if(xe){const qe=this._cache.add([xe]);return{...i.SignatureHelp.from(xe),id:qe}}}reviveContext(x){let B;if(x.activeSignatureHelp){const H=i.SignatureHelp.to(x.activeSignatureHelp),V=this._cache.get(x.activeSignatureHelp.id,0);V?(B=V,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...x,activeSignatureHelp:B}}releaseSignatureHelp(x){this._cache.delete(x)}}class fe{constructor(x,B,H,V,re){this._documents=x,this._commands=B,this._provider=H,this._logService=V,this._extension=re,this._cache=new g.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(x,B,H){const V=this._documents.getDocument(x),re=i.Range.to(B),ge=await this._provider.provideInlayHints(V,re,H);if(!Array.isArray(ge)||ge.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(B)}`);return}if(H.isCancellationRequested)return;const Te=this._cache.add(ge);this._disposables.set(Te,new R.DisposableStore);const xe={hints:[],cacheId:Te};for(let qe=0;qe<ge.length;qe++)this._isValidInlayHint(ge[qe],re)&&xe.hints.push(this._convertInlayHint(ge[qe],[Te,qe]));return this._logService.trace(`[InlayHints] ${xe.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(B)}`),xe}async resolveInlayHint(x,B){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...x);if(!H)return;const V=await this._provider.resolveInlayHint(H,B);if(V&&this._isValidInlayHint(V))return this._convertInlayHint(V,x)}releaseHints(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_isValidInlayHint(x,B){return x.label.length===0||Array.isArray(x.label)&&x.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",x),!1):!(B&&!B.contains(x.position))}_convertInlayHint(x,B){const H=this._disposables.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const V={label:"",cacheId:B,tooltip:i.MarkdownString.fromStrict(x.tooltip),position:i.Position.from(x.position),textEdits:x.textEdits&&x.textEdits.map(i.TextEdit.from),kind:x.kind&&i.InlayHintKind.from(x.kind),paddingLeft:x.paddingLeft,paddingRight:x.paddingRight};if(typeof x.label=="string")V.label=x.label;else{const re=[];V.label=re;for(const ge of x.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Te={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.Location.isLocation(ge.location)&&(Te.location=i.location.from(ge.location)),ge.command&&(Te.command=this._commands.toInternal(ge.command,H)),re.push(Te)}}return V}}class be{constructor(x,B){this._documents=x,this._provider=B,this._cache=new g.Cache("DocumentLink")}async provideLinks(x,B){const H=this._documents.getDocument(x),V=await this._provider.provideDocumentLinks(H,B);if(!(!Array.isArray(V)||V.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(be._validateLink).map(i.DocumentLink.from)};{const re=this._cache.add(V),ge={links:[],cacheId:re};for(let Te=0;Te<V.length;Te++){if(!be._validateLink(V[Te]))continue;const xe=i.DocumentLink.from(V[Te]);xe.cacheId=[re,Te],ge.links.push(xe)}return ge}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,B){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...x);if(!H)return;const V=await this._provider.resolveDocumentLink(H,B);if(!(!V||!be._validateLink(V)))return i.DocumentLink.from(V)}releaseLinks(x){this._cache.delete(x)}}class de{constructor(x,B){this._documents=x,this._provider=B}async provideColors(x,B){const H=this._documents.getDocument(x),V=await this._provider.provideDocumentColors(H,B);return Array.isArray(V)?V.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(x,B,H){const V=this._documents.getDocument(x),re=i.Range.to(B.range),ge=i.Color.to(B.color),Te=await this._provider.provideColorPresentations(ge,{document:V,range:re},H);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class X{constructor(x,B){this._documents=x,this._provider=B}async provideFoldingRanges(x,B,H){const V=this._documents.getDocument(x),re=await this._provider.provideFoldingRanges(V,B,H);if(Array.isArray(re))return re.map(i.FoldingRange.from)}}class J{constructor(x,B,H){this._documents=x,this._provider=B,this._logService=H}async provideSelectionRanges(x,B,H){const V=this._documents.getDocument(x),re=B.map(i.Position.to),ge=await this._provider.provideSelectionRanges(V,re,H);if(!(0,S.isNonEmptyArray)(ge))return[];if(ge.length!==re.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let xe=0;xe<re.length;xe++){const qe=[];Te.push(qe);let Ze=re[xe],tt=ge[xe];for(;;){if(!tt.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(i.SelectionRange.from(tt)),!tt.parent)break;Ze=tt.range,tt=tt.parent}}return Te}}class ve{constructor(x,B){this._documents=x,this._provider=B,this._idPool=new A.IdGenerator(""),this._cache=new Map}async prepareSession(x,B,H){const V=this._documents.getDocument(x),re=i.Position.to(B),ge=await this._provider.prepareCallHierarchy(V,re,H);if(!ge)return;const Te=this._idPool.nextId();return this._cache.set(Te,new Map),Array.isArray(ge)?ge.map(xe=>this._cacheAndConvertItem(Te,xe)):[this._cacheAndConvertItem(Te,ge)]}async provideCallsTo(x,B,H){const V=this._itemFromCache(x,B);if(!V)throw new Error("missing call hierarchy item");const re=await this._provider.provideCallHierarchyIncomingCalls(V,H);if(re)return re.map(ge=>({from:this._cacheAndConvertItem(x,ge.from),fromRanges:ge.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(x,B,H){const V=this._itemFromCache(x,B);if(!V)throw new Error("missing call hierarchy item");const re=await this._provider.provideCallHierarchyOutgoingCalls(V,H);if(re)return re.map(ge=>({to:this._cacheAndConvertItem(x,ge.to),fromRanges:ge.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,B){const H=this._cache.get(x),V=i.CallHierarchyItem.from(B,x,H.size.toString(36));return H.set(V._itemId,B),V}_itemFromCache(x,B){return this._cache.get(x)?.get(B)}}class pe{constructor(x,B){this._documents=x,this._provider=B,this._idPool=new A.IdGenerator(""),this._cache=new Map}async prepareSession(x,B,H){const V=this._documents.getDocument(x),re=i.Position.to(B),ge=await this._provider.prepareTypeHierarchy(V,re,H);if(!ge)return;const Te=this._idPool.nextId();return this._cache.set(Te,new Map),Array.isArray(ge)?ge.map(xe=>this._cacheAndConvertItem(Te,xe)):[this._cacheAndConvertItem(Te,ge)]}async provideSupertypes(x,B,H){const V=this._itemFromCache(x,B);if(!V)throw new Error("missing type hierarchy item");const re=await this._provider.provideTypeHierarchySupertypes(V,H);if(re)return re.map(ge=>this._cacheAndConvertItem(x,ge))}async provideSubtypes(x,B,H){const V=this._itemFromCache(x,B);if(!V)throw new Error("missing type hierarchy item");const re=await this._provider.provideTypeHierarchySubtypes(V,H);if(re)return re.map(ge=>this._cacheAndConvertItem(x,ge))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,B){const H=this._cache.get(x),V=i.TypeHierarchyItem.from(B,x,H.size.toString(36));return H.set(V._itemId,B),V}_itemFromCache(x,B){return this._cache.get(x)?.get(B)}}class Ae{constructor(x,B,H,V,re){this._proxy=x,this._documents=B,this._provider=H,this._handle=V,this._extension=re,this._cache=new g.Cache("DocumentDropEdit")}async provideDocumentOnDropEdits(x,B,H,V,re){const ge=this._documents.getDocument(B),Te=i.Position.to(H),xe=i.DataTransfer.toDataTransfer(V,async nt=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,x,nt)).buffer),qe=await this._provider.provideDocumentDropEdits(ge,Te,xe,re);if(!qe)return;const Ze=(0,S.asArray)(qe),tt=this._cache.add(Ze);return Ze.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,l.localize)(10835,null,this._extension.displayName||this._extension.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(x,B){const[H,V]=x,re=this._cache.get(H,V);if(!re||!this._provider.resolveDocumentDropEdit)return{};const ge=await this._provider.resolveDocumentDropEdit(re,B)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(x){this._cache.delete(x)}}class Ue{constructor(x,B){this._documents=x,this._provider=B}async provideMappedEdits(x,B,H,V){const re=a.URI.revive(x),ge=this._documents.getDocument(re),Te=H.documents.map(Ze=>Ze.map(tt=>({uri:a.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),xe={documents:Te,selections:Te[0]?.[0]?.ranges??[]},qe=await this._provider.provideMappedEdits(ge,B,xe,V);return qe?i.WorkspaceEdit.from(qe):null}}class Ie{constructor(x,B){this.adapter=x,this.extension=B}}class Pe{static{this._handlePool=0}constructor(x,B,H,V,re,ge,Te,xe){this._uriTransformer=B,this._documents=H,this._commands=V,this._diagnostics=re,this._logService=ge,this._apiDeprecation=Te,this._extensionTelemetry=xe,this._adapter=new Map,this._proxy=x.getProxy(u.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(x,B){return i.DocumentSelector.from(x,this._uriTransformer,B)}_createDisposable(x){return new n.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return Pe._handlePool++}async _withAdapter(x,B,H,V,re,ge=!1){const Te=this._adapter.get(x);if(!Te||!(Te.adapter instanceof B))return V;const xe=Date.now();ge||this._logService.trace(`[${Te.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const qe=H(Te.adapter,Te.extension);return Promise.resolve(qe).catch(Ze=>{(0,O.isCancellationError)(Ze)||(this._logService.error(`[${Te.extension.identifier.value}] provider FAILED`),this._logService.error(Ze),this._extensionTelemetry.onExtensionError(Te.extension.identifier,Ze))}).finally(()=>{ge||this._logService.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-xe}ms`)}),P.CancellationToken.isCancellationToken(re)?(0,k.raceCancellationError)(qe,re):qe}_addNewAdapter(x,B){const H=this._nextHandle();return this._adapter.set(H,new Ie(x,B)),H}static _extLabel(x){return x.displayName||x.name}static _extId(x){return x.identifier.value}registerDocumentSymbolProvider(x,B,H,V){const re=this._addNewAdapter(new v(this._documents,H),x),ge=V&&V.label||Pe._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(re,this._transformDocumentSelector(B,x),ge),this._createDisposable(re)}$provideDocumentSymbols(x,B,H){return this._withAdapter(x,v,V=>V.provideDocumentSymbols(a.URI.revive(B),H),void 0,H)}registerCodeLensProvider(x,B,H){const V=this._nextHandle(),re=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new Ie(new m(this._documents,this._commands.converter,H,x,this._extensionTelemetry,this._logService),x)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(B,x),re);let ge=this._createDisposable(V);if(re!==void 0){const Te=H.onDidChangeCodeLenses(xe=>this._proxy.$emitCodeLensEvent(re));ge=n.Disposable.from(ge,Te)}return ge}$provideCodeLenses(x,B,H){return this._withAdapter(x,m,V=>V.provideCodeLenses(a.URI.revive(B),H),void 0,H)}$resolveCodeLens(x,B,H){return this._withAdapter(x,m,V=>V.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(x,B){this._withAdapter(x,m,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(x,B,H){const V=this._addNewAdapter(new C(this._documents,H),x);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$provideDefinition(x,B,H,V){return this._withAdapter(x,C,re=>re.provideDefinition(a.URI.revive(B),H,V),[],V)}registerDeclarationProvider(x,B,H){const V=this._addNewAdapter(new _(this._documents,H),x);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$provideDeclaration(x,B,H,V){return this._withAdapter(x,_,re=>re.provideDeclaration(a.URI.revive(B),H,V),[],V)}registerImplementationProvider(x,B,H){const V=this._addNewAdapter(new E(this._documents,H),x);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$provideImplementation(x,B,H,V){return this._withAdapter(x,E,re=>re.provideImplementation(a.URI.revive(B),H,V),[],V)}registerTypeDefinitionProvider(x,B,H){const V=this._addNewAdapter(new T(this._documents,H),x);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$provideTypeDefinition(x,B,H,V){return this._withAdapter(x,T,re=>re.provideTypeDefinition(a.URI.revive(B),H,V),[],V)}registerHoverProvider(x,B,H,V){const re=this._addNewAdapter(new D(this._documents,H),x);return this._proxy.$registerHoverProvider(re,this._transformDocumentSelector(B,x)),this._createDisposable(re)}$provideHover(x,B,H,V,re){return this._withAdapter(x,D,ge=>ge.provideHover(a.URI.revive(B),H,V,re),void 0,re)}$releaseHover(x,B){this._withAdapter(x,D,H=>Promise.resolve(H.releaseHover(B)),void 0,void 0)}registerEvaluatableExpressionProvider(x,B,H,V){const re=this._addNewAdapter(new f(this._documents,H),x);return this._proxy.$registerEvaluatableExpressionProvider(re,this._transformDocumentSelector(B,x)),this._createDisposable(re)}$provideEvaluatableExpression(x,B,H,V){return this._withAdapter(x,f,re=>re.provideEvaluatableExpression(a.URI.revive(B),H,V),void 0,V)}registerInlineValuesProvider(x,B,H,V){const re=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new b(this._documents,H),x);this._proxy.$registerInlineValuesProvider(ge,this._transformDocumentSelector(B,x),re);let Te=this._createDisposable(ge);if(re!==void 0){const xe=H.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(re));Te=n.Disposable.from(Te,xe)}return Te}$provideInlineValues(x,B,H,V,re){return this._withAdapter(x,b,ge=>ge.provideInlineValues(a.URI.revive(B),H,V,re),void 0,re)}registerDocumentHighlightProvider(x,B,H){const V=this._addNewAdapter(new M(this._documents,H),x);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}registerMultiDocumentHighlightProvider(x,B,H){const V=this._addNewAdapter(new L(this._documents,H),x);return this._proxy.$registerMultiDocumentHighlightProvider(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$provideDocumentHighlights(x,B,H,V){return this._withAdapter(x,M,re=>re.provideDocumentHighlights(a.URI.revive(B),H,V),void 0,V)}$provideMultiDocumentHighlights(x,B,H,V,re){return this._withAdapter(x,L,ge=>ge.provideMultiDocumentHighlights(a.URI.revive(B),H,V.map(Te=>a.URI.revive(Te)),re),void 0,re)}registerLinkedEditingRangeProvider(x,B,H){const V=this._addNewAdapter(new N(this._documents,H),x);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$provideLinkedEditingRanges(x,B,H,V){return this._withAdapter(x,N,async re=>{const ge=await re.provideLinkedEditingRanges(a.URI.revive(B),H,V);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Pe._serializeRegExp(ge.wordPattern):void 0}},void 0,V)}registerReferenceProvider(x,B,H){const V=this._addNewAdapter(new W(this._documents,H),x);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$provideReferences(x,B,H,V,re){return this._withAdapter(x,W,ge=>ge.provideReferences(a.URI.revive(B),H,V,re),void 0,re)}registerCodeActionProvider(x,B,H,V){const re=new R.DisposableStore,ge=this._addNewAdapter(new j(this._documents,this._commands.converter,this._diagnostics,H,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerCodeActionSupport(ge,this._transformDocumentSelector(B,x),{providedKinds:V?.providedCodeActionKinds?.map(Te=>Te.value),documentation:V?.documentation?.map(Te=>({kind:Te.kind.value,command:this._commands.converter.toInternal(Te.command,re)}))},Pe._extLabel(x),Pe._extId(x),!!H.resolveCodeAction),re.add(this._createDisposable(ge)),re}$provideCodeActions(x,B,H,V,re){return this._withAdapter(x,j,ge=>ge.provideCodeActions(a.URI.revive(B),H,V,re),void 0,re)}$resolveCodeAction(x,B,H){return this._withAdapter(x,j,V=>V.resolveCodeAction(B,H),{},void 0)}$releaseCodeActions(x,B){this._withAdapter(x,j,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(x,B,H){const V=this._addNewAdapter(new K(this._documents,H),x);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(B,x),x.identifier,x.displayName||x.name),this._createDisposable(V)}$provideDocumentFormattingEdits(x,B,H,V){return this._withAdapter(x,K,re=>re.provideDocumentFormattingEdits(a.URI.revive(B),H,V),void 0,V)}registerDocumentRangeFormattingEditProvider(x,B,H){const V=typeof H.provideDocumentRangesFormattingEdits=="function",re=this._addNewAdapter(new q(this._documents,H),x);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(B,x),x.identifier,x.displayName||x.name,V),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(x,B,H,V,re){return this._withAdapter(x,q,ge=>ge.provideDocumentRangeFormattingEdits(a.URI.revive(B),H,V,re),void 0,re)}$provideDocumentRangesFormattingEdits(x,B,H,V,re){return this._withAdapter(x,q,ge=>ge.provideDocumentRangesFormattingEdits(a.URI.revive(B),H,V,re),void 0,re)}registerOnTypeFormattingEditProvider(x,B,H,V){const re=this._addNewAdapter(new ae(this._documents,H),x);return this._proxy.$registerOnTypeFormattingSupport(re,this._transformDocumentSelector(B,x),V,x.identifier),this._createDisposable(re)}$provideOnTypeFormattingEdits(x,B,H,V,re,ge){return this._withAdapter(x,ae,Te=>Te.provideOnTypeFormattingEdits(a.URI.revive(B),H,V,re,ge),void 0,ge)}registerWorkspaceSymbolProvider(x,B){const H=this._addNewAdapter(new Ee(B,this._logService),x);return this._proxy.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(x,B,H){return this._withAdapter(x,Ee,V=>V.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(x,B,H){return this._withAdapter(x,Ee,V=>V.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(x,B){this._withAdapter(x,Ee,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(x,B,H){const V=this._addNewAdapter(new ce(this._documents,H,this._logService),x);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(B,x),ce.supportsResolving(H)),this._createDisposable(V)}$provideRenameEdits(x,B,H,V,re){return this._withAdapter(x,ce,ge=>ge.provideRenameEdits(a.URI.revive(B),H,V,re),void 0,re)}$resolveRenameLocation(x,B,H,V){return this._withAdapter(x,ce,re=>re.resolveRenameLocation(a.URI.revive(B),H,V),void 0,V)}registerNewSymbolNamesProvider(x,B,H){const V=this._addNewAdapter(new Z(this._documents,H,this._logService),x);return this._proxy.$registerNewSymbolNamesProvider(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$supportsAutomaticNewSymbolNamesTriggerKind(x){return this._withAdapter(x,Z,B=>B.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(x,B,H,V,re){return this._withAdapter(x,Z,ge=>ge.provideNewSymbolNames(a.URI.revive(B),H,V,re),void 0,re)}registerDocumentSemanticTokensProvider(x,B,H,V){const re=this._addNewAdapter(new me(this._documents,H),x),ge=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(re,this._transformDocumentSelector(B,x),V,ge);let Te=this._createDisposable(re);if(ge){const xe=H.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(ge));Te=n.Disposable.from(Te,xe)}return Te}$provideDocumentSemanticTokens(x,B,H,V){return this._withAdapter(x,me,re=>re.provideDocumentSemanticTokens(a.URI.revive(B),H,V),null,V)}$releaseDocumentSemanticTokens(x,B){this._withAdapter(x,me,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(x,B,H,V){const re=this._addNewAdapter(new oe(this._documents,H),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(re,this._transformDocumentSelector(B,x),V),this._createDisposable(re)}$provideDocumentRangeSemanticTokens(x,B,H,V){return this._withAdapter(x,oe,re=>re.provideDocumentRangeSemanticTokens(a.URI.revive(B),H,V),null,V)}registerCompletionItemProvider(x,B,H,V){const re=this._addNewAdapter(new De(this._documents,this._commands.converter,H,this._apiDeprecation,x),x);return this._proxy.$registerCompletionsProvider(re,this._transformDocumentSelector(B,x),V,De.supportsResolving(H),x.identifier),this._createDisposable(re)}$provideCompletionItems(x,B,H,V,re){return this._withAdapter(x,De,ge=>ge.provideCompletionItems(a.URI.revive(B),H,V,re),void 0,re)}$resolveCompletionItem(x,B,H){return this._withAdapter(x,De,V=>V.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(x,B){this._withAdapter(x,De,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(x,B,H,V){const re=new Q(x,this._documents,H,this._commands.converter),ge=this._addNewAdapter(re,x);return this._proxy.$registerInlineCompletionsSupport(ge,this._transformDocumentSelector(B,x),re.supportsHandleEvents,c.ExtensionIdentifier.toKey(x.identifier.value),V?.yieldTo?.map(Te=>c.ExtensionIdentifier.toKey(Te))||[]),this._createDisposable(ge)}$provideInlineCompletions(x,B,H,V,re){return this._withAdapter(x,Re,ge=>ge.provideInlineCompletions(a.URI.revive(B),H,V,re),void 0,re)}$provideInlineEdits(x,B,H,V,re){return this._withAdapter(x,Re,ge=>ge.provideInlineEdits(a.URI.revive(B),H,V,re),void 0,re)}$handleInlineCompletionDidShow(x,B,H,V){this._withAdapter(x,Re,async re=>{re.handleDidShowCompletionItem(B,H,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(x,B,H,V,re){this._withAdapter(x,Re,async ge=>{ge.handlePartialAccept(B,H,V,re)},void 0,void 0)}$freeInlineCompletionsList(x,B){this._withAdapter(x,Re,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerInlineEditProvider(x,B,H){const V=new z(x,this._documents,H,this._commands.converter),re=this._addNewAdapter(V,x);return this._proxy.$registerInlineEditProvider(re,this._transformDocumentSelector(B,x),x.identifier),this._createDisposable(re)}$provideInlineEdit(x,B,H,V){return this._withAdapter(x,z,re=>re.provideInlineEdits(a.URI.revive(B),H,V),void 0,V)}$freeInlineEdit(x,B){this._withAdapter(x,z,async H=>{H.disposeEdit(B)},void 0,void 0)}registerSignatureHelpProvider(x,B,H,V){const re=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,ge=this._addNewAdapter(new Ce(this._documents,H),x);return this._proxy.$registerSignatureHelpProvider(ge,this._transformDocumentSelector(B,x),re),this._createDisposable(ge)}$provideSignatureHelp(x,B,H,V,re){return this._withAdapter(x,Ce,ge=>ge.provideSignatureHelp(a.URI.revive(B),H,V,re),void 0,re)}$releaseSignatureHelp(x,B){this._withAdapter(x,Ce,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(x,B,H){const V=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new fe(this._documents,this._commands.converter,H,this._logService,x),x);this._proxy.$registerInlayHintsProvider(re,this._transformDocumentSelector(B,x),typeof H.resolveInlayHint=="function",V,Pe._extLabel(x));let ge=this._createDisposable(re);if(V!==void 0){const Te=H.onDidChangeInlayHints(xe=>this._proxy.$emitInlayHintsEvent(V));ge=n.Disposable.from(ge,Te)}return ge}$provideInlayHints(x,B,H,V){return this._withAdapter(x,fe,re=>re.provideInlayHints(a.URI.revive(B),H,V),void 0,V)}$resolveInlayHint(x,B,H){return this._withAdapter(x,fe,V=>V.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(x,B){this._withAdapter(x,fe,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(x,B,H){const V=this._addNewAdapter(new be(this._documents,H),x);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(B,x),typeof H.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks(x,B,H){return this._withAdapter(x,be,V=>V.provideLinks(a.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(x,B,H){return this._withAdapter(x,be,V=>V.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(x,B){this._withAdapter(x,be,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(x,B,H){const V=this._addNewAdapter(new de(this._documents,H),x);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$provideDocumentColors(x,B,H){return this._withAdapter(x,de,V=>V.provideColors(a.URI.revive(B),H),[],H)}$provideColorPresentations(x,B,H,V){return this._withAdapter(x,de,re=>re.provideColorPresentations(a.URI.revive(B),H,V),void 0,V)}registerFoldingRangeProvider(x,B,H){const V=this._nextHandle(),re=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new Ie(new X(this._documents,H),x)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(B,x),x.identifier,re);let ge=this._createDisposable(V);if(re!==void 0){const Te=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(re));ge=n.Disposable.from(ge,Te)}return ge}$provideFoldingRanges(x,B,H,V){return this._withAdapter(x,X,re=>re.provideFoldingRanges(a.URI.revive(B),H,V),void 0,V)}registerSelectionRangeProvider(x,B,H){const V=this._addNewAdapter(new J(this._documents,H,this._logService),x);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$provideSelectionRanges(x,B,H,V){return this._withAdapter(x,J,re=>re.provideSelectionRanges(a.URI.revive(B),H,V),[],V)}registerCallHierarchyProvider(x,B,H){const V=this._addNewAdapter(new ve(this._documents,H),x);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$prepareCallHierarchy(x,B,H,V){return this._withAdapter(x,ve,re=>Promise.resolve(re.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideCallHierarchyIncomingCalls(x,B,H,V){return this._withAdapter(x,ve,re=>re.provideCallsTo(B,H,V),void 0,V)}$provideCallHierarchyOutgoingCalls(x,B,H,V){return this._withAdapter(x,ve,re=>re.provideCallsFrom(B,H,V),void 0,V)}$releaseCallHierarchy(x,B){this._withAdapter(x,ve,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(x,B,H){const V=this._addNewAdapter(new pe(this._documents,H),x);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(B,x)),this._createDisposable(V)}$prepareTypeHierarchy(x,B,H,V){return this._withAdapter(x,pe,re=>Promise.resolve(re.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideTypeHierarchySupertypes(x,B,H,V){return this._withAdapter(x,pe,re=>re.provideSupertypes(B,H,V),void 0,V)}$provideTypeHierarchySubtypes(x,B,H,V){return this._withAdapter(x,pe,re=>re.provideSubtypes(B,H,V),void 0,V)}$releaseTypeHierarchy(x,B){this._withAdapter(x,pe,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(x,B,H,V){const re=this._nextHandle();return this._adapter.set(re,new Ie(new Ae(this._proxy,this._documents,H,re,x),x)),this._proxy.$registerDocumentOnDropEditProvider(re,this._transformDocumentSelector(B,x),(0,t.isProposedApiEnabled)(x,"documentPaste")&&V?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:V.dropMimeTypes}:void 0),this._createDisposable(re)}$provideDocumentOnDropEdits(x,B,H,V,re,ge){return this._withAdapter(x,Ae,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(B,a.URI.revive(H),V,re,ge)),void 0,void 0)}$resolveDropEdit(x,B,H){return this._withAdapter(x,Ae,V=>V.resolveDropEdit(B,H),{},void 0)}$releaseDocumentOnDropEdits(x,B){this._withAdapter(x,Ae,H=>Promise.resolve(H.releaseDropEdits(B)),void 0,void 0)}registerMappedEditsProvider(x,B,H){const V=this._addNewAdapter(new Ue(this._documents,H),x);return this._proxy.$registerMappedEditsProvider(V,this._transformDocumentSelector(B,x),x.displayName??x.name),this._createDisposable(V)}$provideMappedEdits(x,B,H,V,re){return this._withAdapter(x,Ue,ge=>Promise.resolve(ge.provideMappedEdits(B,H,V,re)),null,re)}registerDocumentPasteEditProvider(x,B,H,V){const re=this._nextHandle();return this._adapter.set(re,new Ie(new $(this._proxy,this._documents,H,re,x),x)),this._proxy.$registerPasteEditProvider(re,this._transformDocumentSelector(B,x),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:V.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this._createDisposable(re)}$prepareDocumentPaste(x,B,H,V,re){return this._withAdapter(x,$,ge=>ge.prepareDocumentPaste(a.URI.revive(B),H,V,re),void 0,re)}$providePasteEdits(x,B,H,V,re,ge,Te){return this._withAdapter(x,$,xe=>xe.providePasteEdits(B,a.URI.revive(H),V,re,ge,Te),void 0,Te)}$resolvePasteEdit(x,B,H){return this._withAdapter(x,$,V=>V.resolvePasteEdit(B,H),{},void 0)}$releasePasteEdits(x,B){this._withAdapter(x,$,H=>Promise.resolve(H.releasePasteEdits(B)),void 0,void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:x.flags}}static _serializeIndentationRule(x){return{decreaseIndentPattern:Pe._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:Pe._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?Pe._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?Pe._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:Pe._serializeRegExp(x.beforeText),afterText:x.afterText?Pe._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?Pe._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(Pe._serializeOnEnterRule)}static _serializeAutoClosingPair(x){return{open:x.open,close:x.close,notIn:x.notIn?x.notIn.map(B=>n.SyntaxTokenType.toString(B)):void 0}}static _serializeAutoClosingPairs(x){return x.map(Pe._serializeAutoClosingPair)}setLanguageConfiguration(x,B,H){const{wordPattern:V}=H;if(V&&(0,I.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(B,V):this._documents.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const re=this._nextHandle(),ge={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Pe._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?Pe._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Pe._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Pe._serializeAutoClosingPairs(H.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(re,B,ge),this._createDisposable(re)}$setWordDefinitions(x){for(const B of x)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=Pe}),define(Le[244],Ne([1,0,4,36,5,8]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModelTools=void 0,O=We(O);class A{constructor(p){this._registeredTools=new Map,this._allTools=new Map,this._proxy=p.getProxy(P.MainContext.MainThreadLanguageModelTools),this._proxy.$getTools().then(o=>{for(const I of o)this._allTools.set(I.name,(0,k.revive)(I))})}async invokeTool(p,o,I){return await this._proxy.$invokeTool(p,o,I)}async $acceptToolDelta(p){p.added&&this._allTools.set(p.added.name,p.added),p.removed&&this._allTools.delete(p.removed)}get tools(){return Array.from(this._allTools.values()).map(p=>O.LanguageModelToolDescription.to(p))}async $invokeTool(p,o,I){const w=this._registeredTools.get(p);if(!w)throw new Error(`Unknown tool ${p}`);return await w.tool.invoke(o,I)}registerTool(p,o,I){return this._registeredTools.set(o,{extension:p,tool:I}),this._proxy.$registerTool(o),(0,S.toDisposable)(()=>{this._registeredTools.delete(o),this._proxy.$unregisterTool(o)})}}e.ExtHostLanguageModelTools=A}),define(Le[94],Ne([1,0,10,21,42,13,6,40,4,9,18,3,11,76,5,90,16,8,7,117,24]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,l=We(l),c=We(c),e.IExtHostLanguageModels=(0,w.createDecorator)("IExtHostLanguageModels");class g{constructor(d,C){this.option=d,this.stream=new S.AsyncIterableSource,this.stream=C??new S.AsyncIterableSource}}class u{constructor(){this._responseStreams=new Map,this._defaultStream=new S.AsyncIterableSource,this._isDone=!1;const d=this;this.apiObject={get stream(){return d._defaultStream.asyncIterable},get text(){return S.AsyncIterableObject.map(d._defaultStream.asyncIterable,C=>{if(C instanceof c.LanguageModelTextPart)return C.value}).coalesce()}}}*_streams(){if(this._responseStreams.size>0)for(const[,d]of this._responseStreams)yield d.stream;else yield this._defaultStream}handleFragment(d){if(this._isDone)return;let C=this._responseStreams.get(d.index);C||(this._responseStreams.size===0?C=new g(d.index,this._defaultStream):C=new g(d.index),this._responseStreams.set(d.index,C));let _;d.part.type==="text"?_=new c.LanguageModelTextPart(d.part.value):_=new c.LanguageModelFunctionUsePart(d.part.name,d.part.parameters),C.stream.emitOne(_)}reject(d){this._isDone=!0;for(const C of this._streams())C.reject(d)}resolve(){this._isDone=!0;for(const d of this._streams())d.resolve()}}let v=class{static{t=this}static{this._idPool=1}constructor(d,C,_){this._logService=C,this._extHostAuthentication=_,this._onDidChangeModelAccess=new A.Emitter,this._onDidChangeProviders=new A.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new I.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=d.getProxy(h.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(d,C,_,E){const T=t._idPool++;this._languageModels.set(T,{extension:d.identifier,provider:_,languageModelId:C});let D;E.auth&&(D={providerLabel:d.displayName||d.name,accountLabel:typeof E.auth=="object"?E.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(T,`${I.ExtensionIdentifier.toKey(d.identifier)}/${T}/${C}`,{extension:d.identifier,id:C,vendor:E.vendor??I.ExtensionIdentifier.toKey(d.identifier),name:E.name??"",family:E.family??"",version:E.version,maxInputTokens:E.maxInputTokens,maxOutputTokens:E.maxOutputTokens,auth:D,targetExtensions:E.extensions});const f=_.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:M,tokenCount:L})=>{this._proxy.$whenLanguageModelChatRequestMade(C,new I.ExtensionIdentifier(b),M,L)});return(0,p.toDisposable)(()=>{this._languageModels.delete(T),this._proxy.$unregisterProvider(T),f?.dispose()})}async $startChatRequest(d,C,_,E,T,D){const f=this._languageModels.get(d);if(!f)throw new Error("Provider not found");const b=new y.Progress(async L=>{if(D.isCancellationRequested){this._logService.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let N;if(L.part instanceof c.LanguageModelFunctionUsePart?N={type:"function_use",name:L.part.name,parameters:L.part.parameters}:L.part instanceof c.LanguageModelTextPart&&(N={type:"text",value:L.part.value}),!N){this._logService.warn(`[CHAT](${f.extension.value}) UNKNOWN part ${JSON.stringify(L)}`);return}this._proxy.$reportResponsePart(C,{index:L.index,part:N})});let M;if(f.provider.provideLanguageModelResponse2)M=Promise.resolve(f.provider.provideLanguageModelResponse2(E.map(l.LanguageModelChatMessage.to),T,I.ExtensionIdentifier.toKey(_),b,D));else{const L=new y.Progress(async N=>{b.report({index:N.index,part:new c.LanguageModelTextPart(N.part)})});M=Promise.resolve(f.provider.provideLanguageModelResponse(E.map(l.LanguageModelChatMessage.to),T?.modelOptions??{},I.ExtensionIdentifier.toKey(_),L,D))}M.then(()=>{this._proxy.$reportResponseDone(C,void 0)},L=>{this._proxy.$reportResponseDone(C,(0,O.transformErrorForSerialization)(L))})}$provideTokenLength(d,C,_){const E=this._languageModels.get(d);return E?Promise.resolve(E.provider.provideTokenCount(C,_)):Promise.resolve(0)}$acceptChatModelMetadata(d){if(d.added)for(const{identifier:C,metadata:_}of d.added)this._allLanguageModelData.set(C,{metadata:_,apiObjects:new I.ExtensionIdentifierMap});if(d.removed)for(const C of d.removed){this._allLanguageModelData.delete(C);for(const[_,E]of this._pendingRequest)E.languageModelId===C&&(E.res.reject(new O.CancellationError),this._pendingRequest.delete(_))}d.added?.forEach(C=>this._fakeAuthPopulate(C.metadata)),this._onDidChangeProviders.fire(void 0)}async selectLanguageModels(d,C){const _=await this._proxy.$selectChatModels({...C,extension:d.identifier}),E=[],T=this;for(const D of _){const f=this._allLanguageModelData.get(D);if(!f)continue;this._isUsingAuth(d.identifier,f.metadata)&&await this._fakeAuthPopulate(f.metadata);let b=f.apiObjects.get(d.identifier);b||(b={id:D,vendor:f.metadata.vendor,family:f.metadata.family,version:f.metadata.version,name:f.metadata.name,maxInputTokens:f.metadata.maxInputTokens,countTokens(M,L){if(!T._allLanguageModelData.has(D))throw c.LanguageModelError.NotFound(D);return T._computeTokenLength(D,M,L??k.CancellationToken.None)},sendRequest(M,L,N){if(!T._allLanguageModelData.has(D))throw c.LanguageModelError.NotFound(D);return T._sendChatRequest(d,D,M,L??{},N??k.CancellationToken.None)}},Object.freeze(b),f.apiObjects.set(d.identifier,b)),E.push(b)}return E}async _sendChatRequest(d,C,_,E,T){const D=this._convertMessages(d,_),f=d.identifier,b=this._allLanguageModelData.get(C)?.metadata;if(!b||!this._allLanguageModelData.has(C))throw c.LanguageModelError.NotFound(`Language model '${C}' is unknown.`);if(this._isUsingAuth(f,b)&&(!await this._getAuthAccess(d,{identifier:b.extension,displayName:b.auth.providerLabel},E.justification,!1)||!this._modelAccessList.get(f)?.has(b.extension)))throw c.LanguageModelError.NoPermissions(`Language model '${C}' cannot be used by '${f.value}'.`);try{const M=Math.random()*1e6|0,L=new u;this._pendingRequest.set(M,{languageModelId:C,res:L});try{await this._proxy.$tryStartChatRequest(f,C,M,D,E,T)}catch(N){throw this._pendingRequest.delete(M),N}return L.apiObject}catch(M){throw M.name===c.LanguageModelError.name?M:new c.LanguageModelError(`Language model '${C}' errored: ${(0,P.toErrorMessage)(M)}`,"Unknown",M)}}_convertMessages(d,C){const _=[];for(const E of C)E.role===c.LanguageModelChatMessageRole.System&&(0,n.checkProposedApiEnabled)(d,"languageModelSystem"),E.content2 instanceof c.LanguageModelFunctionResultPart&&(0,n.checkProposedApiEnabled)(d,"lmTools"),_.push(l.LanguageModelChatMessage.from(E));return _}async $acceptResponsePart(d,C){const _=this._pendingRequest.get(d);_&&_.res.handleFragment(C)}async $acceptResponseDone(d,C){const _=this._pendingRequest.get(d);_&&(this._pendingRequest.delete(d),C?_.res.reject((0,O.transformErrorFromSerialization)(C)):_.res.resolve())}async _getAuthAccess(d,C,_,E){const T=i.INTERNAL_AUTH_PROVIDER_PREFIX+C.identifier.value;if(await this._extHostAuthentication.getSession(d,T,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:C.identifier,enabled:!0}]),!0;if(E)return!1;try{const f=_?(0,o.localize)(10833,null,C.displayName,_):void 0;return await this._extHostAuthentication.getSession(d,T,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:d.identifier,to:C.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(d,C){return!!C.auth&&!I.ExtensionIdentifier.equals(C.extension,d)}async _fakeAuthPopulate(d){if(d.auth)for(const C of this._languageAccessInformationExtensions)try{await this._getAuthAccess(C,{identifier:d.extension,displayName:""},void 0,!0)}catch(_){this._logService.error("Fake Auth request failed"),this._logService.error(_)}}async _computeTokenLength(d,C,_){if(!this._allLanguageModelData.get(d))throw c.LanguageModelError.NotFound(`Language model '${d}' is unknown.`);const T=R.Iterable.find(this._languageModels.values(),D=>D.languageModelId===d);return T?T.provider.provideTokenCount(C,_):this._proxy.$countTokens(d,typeof C=="string"?C:l.LanguageModelChatMessage.from(C),_)}$updateModelAccesslist(d){const C=new Array;for(const{from:_,to:E,enabled:T}of d){const D=this._modelAccessList.get(_)??new I.ExtensionIdentifierSet;if(D.has(E)!==T){T?D.add(E):D.delete(E),this._modelAccessList.set(_,D);const b={from:_,to:E};C.push(b),this._onDidChangeModelAccess.fire(b)}}}createLanguageModelAccessInformation(d){this._languageAccessInformationExtensions.add(d);const C=this,_=A.Event.signal(A.Event.filter(this._onDidChangeModelAccess.event,T=>I.ExtensionIdentifier.equals(T.from,d.identifier))),E=A.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return A.Event.any(_,E)},canSendRequest(T){let D;e:for(const[b,M]of C._allLanguageModelData)for(const L of M.apiObjects.values())if(L===T){D=M.metadata;break e}if(!D)return;if(!C._isUsingAuth(d.identifier,D))return!0;const f=C._modelAccessList.get(d.identifier);if(f)return f.has(D.extension)}}}};e.ExtHostLanguageModels=v,e.ExtHostLanguageModels=v=t=Ge([Ve(0,s.IExtHostRpcService),Ve(1,a.ILogService),Ve(2,r.IExtHostAuthentication)],v)});var Jt=this&&this.__importDefault||function(Se){return Se&&Se.__esModule?Se:{default:Se}};define(Le[245],Ne([1,0,5,8,7,35,10,4,24]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0,k=We(k),O=Jt(O);class o{constructor(w,a,y,h){this._documents=a,this._commands=y,this._uriTransformer=h,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=w.getProxy(S.MainContext.MainThreadLanguages)}$acceptLanguageIds(w){this._languageIds=w}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(w,a){await this._proxy.$changeLanguage(w,a);const y=this._documents.getDocumentData(w);if(!y)throw new Error(`document '${w.toString()}' NOT found`);return y.document}async tokenAtPosition(w,a){const y=w.version,h=k.Position.from(a),r=await this._proxy.$tokensAtPosition(w.uri,h),s={type:P.StandardTokenType.Other,range:w.getWordRangeAtPosition(a)??new P.Range(a.line,a.character,a.line,a.character)};if(!r)return s;const l={range:k.Range.to(r.range),type:k.TokenType.to(r.type)};return!l.range.contains(a)||y!==w.version?s:l}createLanguageStatusItem(w,a,y){const h=this._handlePool++,r=this._proxy,s=this._ids,l=`${w.identifier.value}/${a}`;if(s.has(l))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);s.add(l);const c={selector:y,id:a,name:w.displayName??w.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new R.DisposableStore,t=()=>{if(i?.dispose(),!s.has(l)){console.warn(`LanguageStatusItem (${a}) from ${w.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.disposableTimeout)(()=>{n.clear(),this._proxy.$setLanguageStatus(h,{id:l,name:c.name??w.displayName??w.name,source:w.displayName??w.name,selector:k.DocumentSelector.from(c.selector,this._uriTransformer),label:c.text,detail:c.detail??"",severity:c.severity===P.LanguageStatusSeverity.Error?O.default.Error:c.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:c.command&&this._commands.toInternal(c.command,n),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},g={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus(h),s.delete(l)},get id(){return c.id},get name(){return c.name},set name(u){c.name=u,t()},get selector(){return c.selector},set selector(u){c.selector=u,t()},get text(){return c.text},set text(u){c.text=u,t()},set text2(u){(0,p.checkProposedApiEnabled)(w,"languageStatusText"),c.text=u,t()},get text2(){return(0,p.checkProposedApiEnabled)(w,"languageStatusText"),c.text},get detail(){return c.detail},set detail(u){c.detail=u,t()},get severity(){return c.severity},set severity(u){c.severity=u,t()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(u){c.accessibilityInformation=u,t()},get command(){return c.command},set command(u){c.command=u,t()},get busy(){return c.busy},set busy(u){c.busy=u,t()}};return t(),g}}e.ExtHostLanguages=o}),define(Le[246],Ne([1,0,15,2,8,7,89]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0,P=We(P),A=We(A);class R{constructor(w,a,y,h){this.start=w,this.deletedCount=a,this.deletedItems=y,this.items=h}asApiEvent(){return{range:new O.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1}}constructor(w,a,y){this.notebook=w,this._extHostDocument=a,this._cellData=y,this.handle=y.handle,this.uri=k.URI.revive(y.uri),this.cellKind=y.cellKind,this._outputs=y.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=y.internalMetadata??{},this._metadata=Object.freeze(y.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,a=this._extHostDocument.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:a.document,get mime(){return w._mime},set mime(h){w._mime=h},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}};this._apiCell=Object.freeze(y)}return this._apiCell}setOutputs(w){this._outputs=w.map(P.NotebookCellOutput.to)}setOutputItems(w,a,y){const h=y.map(P.NotebookCellOutputItem.to),r=this._outputs.find(s=>s.id===w);if(r&&(a||(r.items.length=0),r.items.push(...h),r.items.length>1&&r.items.every(s=>A.isTextStreamMime(s.mime)))){const s=new Map,l=[];r.items.forEach(c=>{let i;s.has(c.mime)?i=s.get(c.mime):(i=[],s.set(c.mime,i),l.push(c.mime)),i.push(c.data)}),r.items.length=0,l.forEach(c=>{const i=A.compressOutputItemStreams(s.get(c));r.items.push({mime:c,data:i.data.buffer})})}}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=p;class o{static{this._handlePool=0}constructor(w,a,y,h,r){this._proxy=w,this._textDocumentsAndEditors=a,this._textDocuments=y,this.uri=h,this.handle=o._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=r.viewType,this._metadata=Object.freeze(r.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,r.cells]],!0,void 0),this._versionId=r.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const w=this,a={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===S.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(y){return y=w._validateIndex(y),w._cells[y].apiCell},getCells(y){return(y?w._getCells(y):w._cells).map(r=>r.apiCell)},save(){return w._save()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this._notebook=Object.freeze(a)}return this._notebook}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,a,y){this._versionId=w.versionId,this._isDirty=a,this.acceptDocumentPropertiesChanged({metadata:y});const h={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},r=[];for(const l of w.rawEvents)l.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1,h.contentChanges):l.kind===A.NotebookCellsChangeType.Move?this._moveCells(l.index,l.length,l.newIdx,h.contentChanges):l.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(l.index,l.outputs),r.push({cell:this._cells[l.index].apiCell,outputs:this._cells[l.index].apiCell.outputs})):l.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems),r.push({cell:this._cells[l.index].apiCell,outputs:this._cells[l.index].apiCell.outputs})):l.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(l.index,l.language),r.push({cell:this._cells[l.index].apiCell,document:this._cells[l.index].apiCell.document})):l.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this._cells[l.index].apiCell,document:this._cells[l.index].apiCell.document}):l.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(l.index,l.metadata),r.push({cell:this._cells[l.index].apiCell,metadata:this._cells[l.index].apiCell.metadata})):l.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(l.index,l.internalMetadata),r.push({cell:this._cells[l.index].apiCell,executionSummary:this._cells[l.index].apiCell.executionSummary}));const s=new Map;for(let l=0;l<r.length;l++){const c=r[l],i=s.get(c.cell);if(i===void 0){const n=h.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});s.set(c.cell,n-1)}else h.cellChanges[i]={...h.cellChanges[i],...c}}return Object.freeze(h),Object.freeze(h.cellChanges),Object.freeze(h.contentChanges),h}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let a=w.start|0,y=w.end|0;return a<0&&(a=0),y>this._cells.length&&(y=this._cells.length),w.with({start:a,end:y})}_getCells(w){w=this._validateRange(w);const a=[];for(let y=w.start;y<w.end;y++)a.push(this._cells[y]);return a}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,a,y){if(this._disposed)return;const h=[],r=[],s=[];if(w.reverse().forEach(l=>{const i=l[2].map(g=>{const u=new p(this,this._textDocumentsAndEditors,g);return a||r.push(p.asModelAddData(g)),u}),n=new R(l[0],l[1],[],i),t=this._cells.splice(l[0],l[1],...i);for(const g of t)s.push(g.uri),n.deletedItems.push(g.apiCell);h.push(n)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:s}),y)for(const l of h)y.push(l.asApiEvent())}_moveCells(w,a,y,h){const r=this._cells.splice(w,a);this._cells.splice(y,0,...r);const s=[new R(w,a,r.map(l=>l.apiCell),[]),new R(y,0,[],r)];for(const l of s)h.push(l.asApiEvent())}_setCellOutputs(w,a){this._cells[w].setOutputs(a)}_setCellOutputItems(w,a,y,h){this._cells[w].setOutputItems(a,y,h)}_changeCellLanguage(w,a){const y=this._cells[w];y.apiCell.document.languageId!==a&&this._textDocuments.$acceptModelLanguageChanged(y.uri,a)}_changeCellMime(w,a){const y=this._cells[w];y.apiCell.mime=a}_changeCellMetadata(w,a){this._cells[w].setMetadata(a)}_changeCellInternalMetadata(w,a){this._cells[w].setInternalMetadata(a)}getCellFromApiCell(w){return this._cells.find(a=>a.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(a=>a.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=o}),define(Le[247],Ne([1,0,6,2,8,7,39]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(o,I,w,a={timeout:1500,errors:3}){this._logService=o,this._notebooksAndEditors=I,this._mainThreadBulkEdits=w,this._thresholds=a,this._onWillSaveNotebookDocumentEvent=new S.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(o){return(I,w,a)=>{const y=function(r){I.call(w,r)};return y.extension=o,this._onWillSaveNotebookDocumentEvent.event(y,void 0,a)}}async $participateInSave(o,I,w){const a=k.URI.revive(o),y=this._notebooksAndEditors.getNotebookDocument(a);if(!y)throw new Error("Unable to resolve notebook document");const h=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:y.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},w,async(s,l)=>{const c=Date.now(),i=await await Promise.resolve(s);Date.now()-c>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",l.extension.identifier),!w.isCancellationRequested&&i&&(i instanceof O.WorkspaceEdit?h.push(i):this._logService.warn("onWillSaveNotebookDocument-listener from extension",l.extension.identifier,"ignored due to invalid data"))}),w.isCancellationRequested)return!1;if(h.length===0)return!0;const r={edits:[]};for(const s of h){const{edits:l}=P.WorkspaceEdit.from(s);r.edits=r.edits.concat(l)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new A.SerializableObjectWithBuffers(r))}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(Le[124],Ne([1,0,13,8,7]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0,k=We(k),P=We(P);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(R,p,o,I,w,a){this.id=R,this._proxy=p,this.notebookData=o,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=w,this._visibleRanges=I,this._viewColumn=a}get apiEditor(){if(!this._editor){const R=this;this._editor={get notebook(){return R.notebookData.apiNotebook},get selection(){return R._selections[0]},set selection(p){this.selections=[p]},get selections(){return R._selections},set selections(p){if(!Array.isArray(p)||!p.every(P.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");R._selections=p,R._trySetSelections(p)},get visibleRanges(){return R._visibleRanges},revealRange(p,o){R._proxy.$tryRevealRange(R.id,k.NotebookRange.from(p),o??P.NotebookEditorRevealType.Default)},get viewColumn(){return R._viewColumn},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},O.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(R){this._visible=R}_acceptVisibleRanges(R){this._visibleRanges=R}_acceptSelections(R){this._selections=R}_trySetSelections(R){this._proxy.$trySetSelections(this.id,R.map(k.NotebookRange.from))}_acceptViewColumn(R){this._viewColumn=R}}e.ExtHostNotebookEditor=O}),define(Le[248],Ne([1,0,6,11,8]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0,P=We(P);let O=class{constructor(R,p){this._logService=R,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new S.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new S.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(R,p){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,p);const o=this._notebooksAndEditors.getEditorById(R);p.visibleRanges&&o._acceptVisibleRanges(p.visibleRanges.ranges.map(P.NotebookRange.to)),p.selections&&o._acceptSelections(p.selections.selections.map(P.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:o.apiEditor,visibleRanges:o.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:o.apiEditor,selections:o.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const p in R)this._notebooksAndEditors.getEditorById(p)._acceptViewColumn(P.ViewColumn.to(R[p]))}};e.ExtHostNotebookEditors=O,e.ExtHostNotebookEditors=O=Ge([Ve(0,k.ILogService)],O)}),define(Le[249],Ne([1,0,6,5,124]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class O{constructor(R,p){this._extHostNotebook=p,this._rendererMessageEmitters=new Map,this.proxy=R.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,p,o){const I=this._extHostNotebook.getEditorById(R);this._rendererMessageEmitters.get(p)?.fire({editor:I.apiEditor,message:o})}createRendererMessaging(R,p){if(!R.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,w,a)=>this.getOrCreateEmitterFor(p).event(I,w,a),postMessage:(I,w)=>{P.ExtHostNotebookEditor.apiEditorsToExtHost.has(I)&&([I,w]=[w,I]);const a=w&&P.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(a?.id,p,I)}}}getOrCreateEmitterFor(R){let p=this._rendererMessageEmitters.get(R);return p||(p=new S.Emitter({onDidRemoveLastListener:()=>{p?.dispose(),this._rendererMessageEmitters.delete(R)}}),this._rendererMessageEmitters.set(R,p),p)}}e.ExtHostNotebookRenderers=O}),define(Le[250],Ne([1,0,8,76,21,71,13]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class R{constructor(w){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=w}async withProgress(w,a,y){const h=this._handles++,{title:r,location:s,cancellable:l}=a,c={label:w.displayName||w.name,id:w.identifier.value};return this._proxy.$startProgress(h,{location:S.ProgressLocation.from(s),title:r,source:c,cancellable:l},w.isUnderDevelopment?void 0:w.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(h,y,!!l)}_withProgress(w,a,y){let h;y&&(h=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(w,h));const r=l=>{this._proxy.$progressEnd(l),this._mapHandleToCancellationSource.delete(l),h?.dispose()};let s;try{s=a(new o(this._proxy,w),y&&h?h.token:P.CancellationToken.None)}catch(l){throw r(w),l}return s.then(l=>r(w),l=>r(w)),s}$acceptProgressCanceled(w){const a=this._mapHandleToCancellationSource.get(w);a&&(a.cancel(),this._mapHandleToCancellationSource.delete(w))}}e.ExtHostProgress=R;function p(I,w){return I.message=w.message,typeof w.increment=="number"&&(typeof I.increment=="number"?I.increment+=w.increment:I.increment=w.increment),I}class o extends k.Progress{constructor(w,a){super(y=>this.throttledReport(y)),this._proxy=w,this._handle=a}throttledReport(w){this._proxy.$progressReport(this._handle,w)}}Ge([(0,O.throttle)(100,(I,w)=>p(I,w),()=>Object.create(null))],o.prototype,"throttledReport",null)}),define(Le[251],Ne([1,0,2,5,10,8]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{static{this.handlePool=0}constructor(p,o){this.uriTransformer=o,this.providers=new Map,this.proxy=p.getProxy(k.MainContext.MainThreadQuickDiff)}$provideOriginalResource(p,o,I){const w=S.URI.revive(o),a=this.providers.get(p);return a?(0,P.asPromise)(()=>a.provideOriginalResource(w,I)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(p,o,I,w){const a=A.handlePool++;return this.providers.set(a,o),this.proxy.$registerQuickDiffProvider(a,O.DocumentSelector.from(p,this.uriTransformer),I,w),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(a),this.providers.delete(a)}}}}e.ExtHostQuickDiff=A});var Jt=this&&this.__importDefault||function(Se){return Se&&Se.__esModule?Se:{default:Se}};define(Le[252],Ne([1,0,21,6,4,5,2,7,13,17,35,34,24,8]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=h,I=Jt(I);function h(r,s,l){const c=r.getProxy(O.MainContext.MainThreadQuickOpen);class i{constructor(_,E){this._sessions=new Map,this._instances=0,this._workspace=_,this._commands=E}showQuickPick(_,E,T,D=S.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(E),b=++this._instances,M=c.$show(b,{title:T?.title,placeHolder:T?.placeHolder,matchOnDescription:T?.matchOnDescription,matchOnDetail:T?.matchOnDetail,ignoreFocusLost:T?.ignoreFocusOut,canPickMany:T?.canPickMany},D),L={},N=M.then(()=>L);return Promise.race([N,f]).then(W=>{if(W===L)return;const j=(0,a.isProposedApiEnabled)(_,"quickPickItemTooltip");return f.then($=>{const K=[];for(let q=0;q<$.length;q++){const ae=$[q];if(typeof ae=="string")K.push({label:ae,handle:q});else if(ae.kind===R.QuickPickItemKind.Separator)K.push({type:"separator",label:ae.label});else{ae.tooltip&&!j&&console.warn(`Extension '${_.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${_.identifier.value}`);const Ee=ae.iconPath?v(ae.iconPath):void 0;K.push({label:ae.label,iconPath:Ee?.iconPath,iconClass:Ee?.iconClass,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:j?y.MarkdownString.fromStrict(ae.tooltip):void 0,handle:q})}}return T&&typeof T.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{T.onDidSelectItem($[q])}),c.$setItems(b,K),M.then(q=>{if(typeof q=="number")return $[q];if(Array.isArray(q))return q.map(ae=>$[ae])})})}).then(void 0,W=>{if(!(0,p.isCancellationError)(W))return c.$setError(b,W),Promise.reject(W)})}$onItemSelected(_){this._onDidSelectItem?.(_)}showInput(_,E=S.CancellationToken.None){return this._validateInput=_?.validateInput,c.$input(_,typeof this._validateInput=="function",E).then(void 0,T=>{if(!(0,p.isCancellationError)(T))return Promise.reject(T)})}async $validateInput(_){if(!this._validateInput)return;const E=await this._validateInput(_);if(!E||typeof E=="string")return E;let T;switch(E.severity){case R.InputBoxValidationSeverity.Info:T=I.default.Info;break;case R.InputBoxValidationSeverity.Warning:T=I.default.Warning;break;case R.InputBoxValidationSeverity.Error:T=I.default.Error;break;default:T=E.message?I.default.Error:I.default.Ignore;break}return{content:E.message,severity:T}}async showWorkspaceFolderPick(_,E=S.CancellationToken.None){const T=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[_]);if(!T)return;const D=await this._workspace.getWorkspaceFolders2();if(D)return D.find(f=>f.uri.toString()===T.uri.toString())}createQuickPick(_){const E=new m(_,()=>this._sessions.delete(E._id));return this._sessions.set(E._id,E),E}createInputBox(_){const E=new d(_,()=>this._sessions.delete(E._id));return this._sessions.set(E._id,E),E}$onDidChangeValue(_,E){this._sessions.get(_)?._fireDidChangeValue(E)}$onDidAccept(_){this._sessions.get(_)?._fireDidAccept()}$onDidChangeActive(_,E){const T=this._sessions.get(_);T instanceof m&&T._fireDidChangeActive(E)}$onDidChangeSelection(_,E){const T=this._sessions.get(_);T instanceof m&&T._fireDidChangeSelection(E)}$onDidTriggerButton(_,E){this._sessions.get(_)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(_,E,T){const D=this._sessions.get(_);D instanceof m&&D._fireDidTriggerItemButton(E,T)}$onDidHide(_){this._sessions.get(_)?._fireDidHide()}}class n{static{this._nextId=1}constructor(_,E){this._extension=_,this._onDidDispose=E,this._id=m._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(_){this._title=_,this.update({title:_})}get step(){return this._steps}set step(_){this._steps=_,this.update({step:_})}get totalSteps(){return this._totalSteps}set totalSteps(_){this._totalSteps=_,this.update({totalSteps:_})}get enabled(){return this._enabled}set enabled(_){this._enabled=_,this.update({enabled:_})}get busy(){return this._busy}set busy(_){this._busy=_,this.update({busy:_})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(_){this._ignoreFocusOut=_,this.update({ignoreFocusOut:_})}get value(){return this._value}set value(_){this._value=_,this.update({value:_})}get placeholder(){return this._placeholder}set placeholder(_){this._placeholder=_,this.update({placeholder:_})}get buttons(){return this._buttons}set buttons(_){const E=(0,a.isProposedApiEnabled)(this._extension,"quickInputButtonLocation");!E&&_.some(T=>T.location)&&console.warn(`Extension '${this._extension.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this._extension.identifier.value}`),this._buttons=_.slice(),this._handlesToButtons.clear(),_.forEach((T,D)=>{const f=T===R.QuickInputButtons.Back?-1:D;this._handlesToButtons.set(f,T)}),this.update({buttons:_.map((T,D)=>({...v(T.iconPath),tooltip:T.tooltip,handle:T===R.QuickInputButtons.Back?-1:D,location:E?T.location:void 0}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(_){this._value=_,this._onDidChangeValueEmitter.fire(_)}_fireDidTriggerButton(_){const E=this._handlesToButtons.get(_);E&&this._onDidTriggerButtonEmitter.fire(E)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),c.$dispose(this._id))}update(_){if(!this._disposed){for(const E of Object.keys(_)){const T=_[E];this._pendingUpdate[E]=T===void 0?null:T}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){c.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function t(C){if(C instanceof R.ThemeIcon)return{id:C.id};const _=u(C),E=g(C);return{dark:typeof _=="string"?A.URI.file(_):_,light:typeof E=="string"?A.URI.file(E):E}}function g(C){return typeof C=="object"&&"light"in C?C.light:C}function u(C){return typeof C=="object"&&"dark"in C?C.dark:C}function v(C){const _=t(C);let E,T;return"id"in _?T=w.ThemeIcon.asClassName(_):E=_,{iconPath:E,iconClass:T}}class m extends n{constructor(_,E){super(_,E),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(_){this._items=_.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),_.forEach((D,f)=>{this._handlesToItems.set(f,D),this._itemsToHandles.set(D,f)});const E=(0,a.isProposedApiEnabled)(this._extension,"quickPickItemTooltip"),T=[];for(let D=0;D<_.length;D++){const f=_[D];if(f.kind===R.QuickPickItemKind.Separator)T.push({type:"separator",label:f.label});else{f.tooltip&&!E&&console.warn(`Extension '${this._extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this._extension.identifier.value}`);const b=f.iconPath?v(f.iconPath):void 0;T.push({handle:D,label:f.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:E?y.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((M,L)=>({...v(M.iconPath),tooltip:M.tooltip,handle:L}))})}}this.update({items:T})}get canSelectMany(){return this._canSelectMany}set canSelectMany(_){this._canSelectMany=_,this.update({canSelectMany:_})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(_){this._matchOnDescription=_,this.update({matchOnDescription:_})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(_){this._matchOnDetail=_,this.update({matchOnDetail:_})}get sortByLabel(){return this._sortByLabel}set sortByLabel(_){this._sortByLabel=_,this.update({sortByLabel:_})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(_){this._keepScrollPosition=_,this.update({keepScrollPosition:_})}get activeItems(){return this._activeItems}set activeItems(_){this._activeItems=_.filter(E=>this._itemsToHandles.has(E)),this.update({activeItems:this._activeItems.map(E=>this._itemsToHandles.get(E))})}get selectedItems(){return this._selectedItems}set selectedItems(_){this._selectedItems=_.filter(E=>this._itemsToHandles.has(E)),this.update({selectedItems:this._selectedItems.map(E=>this._itemsToHandles.get(E))})}_fireDidChangeActive(_){const E=(0,o.coalesce)(_.map(T=>this._handlesToItems.get(T)));this._activeItems=E,this._onDidChangeActiveEmitter.fire(E)}_fireDidChangeSelection(_){const E=(0,o.coalesce)(_.map(T=>this._handlesToItems.get(T)));this._selectedItems=E,this._onDidChangeSelectionEmitter.fire(E)}_fireDidTriggerItemButton(_,E){const T=this._handlesToItems.get(_);if(!T||!T.buttons||!T.buttons.length)return;const D=T.buttons[E];D&&this._onDidTriggerItemButtonEmitter.fire({button:D,item:T})}}class d extends n{constructor(_,E){super(_,E),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(_){this._password=_,this.update({password:_})}get prompt(){return this._prompt}set prompt(_){this._prompt=_,this.update({prompt:_})}get valueSelection(){return this._valueSelection}set valueSelection(_){this._valueSelection=_,this.update({valueSelection:_})}get validationMessage(){return this._validationMessage}set validationMessage(_){this._validationMessage=_,_?typeof _=="string"?this.update({validationMessage:_,severity:I.default.Error}):this.update({validationMessage:_.message,severity:_.severity??I.default.Error}):this.update({validationMessage:void 0,severity:I.default.Ignore})}}return new i(s,l)}}),define(Le[253],Ne([1,0,2,6,71,4,10,5,17,145,11,18,37,34,8,24,15,20]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(L){return L instanceof S.URI}function n(L,N){return L.scheme===s.Schemas.file&&N.scheme===s.Schemas.file&&l.isLinux?L.toString()===N.toString():L.toString().toLowerCase()===N.toString().toLowerCase()}function t(L){if(L)return typeof L.iconPath=="string"?S.URI.file(L.iconPath):S.URI.isUri(L.iconPath)||y.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function g(L){if(L){if(S.URI.isUri(L))return L;if(y.ThemeIcon.isThemeIcon(L))return L;{const N=L;return{light:N.light,dark:N.dark}}}else return}function u(L){const N=g(L.icon),W=L.labels?.map(j=>({title:j.title,icon:g(j.icon)}));return{...L,icon:N,labels:W}}function v(L,N){if(!L.iconPath&&!N.iconPath)return 0;if(L.iconPath){if(!N.iconPath)return 1}else return-1;const W=typeof L.iconPath=="string"?L.iconPath:S.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,j=typeof N.iconPath=="string"?N.iconPath:S.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,o.comparePaths)(W,j)}function m(L,N){let W=0;if(L.strikeThrough!==N.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==N.faded)return L.faded?1:-1;if(L.tooltip!==N.tooltip)return(L.tooltip||"").localeCompare(N.tooltip||"");if(W=v(L,N),W!==0)return W;if(L.light&&N.light)W=v(L.light,N.light);else{if(L.light)return 1;if(N.light)return-1}if(W!==0)return W;if(L.dark&&N.dark)W=v(L.dark,N.dark);else{if(L.dark)return 1;if(N.dark)return-1}return W}function d(L,N){if(L.command!==N.command)return L.command<N.command?-1:1;if(L.title!==N.title)return L.title<N.title?-1:1;if(L.tooltip!==N.tooltip){if(L.tooltip!==void 0&&N.tooltip!==void 0)return L.tooltip<N.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(L.arguments===N.arguments)return 0;if(L.arguments)if(N.arguments){if(L.arguments.length!==N.arguments.length)return L.arguments.length-N.arguments.length}else return 1;else return-1;for(let W=0;W<L.arguments.length;W++){const j=L.arguments[W],$=N.arguments[W];if(j!==$&&!(i(j)&&i($)&&n(j,$)))return j<$?-1:1}return 0}function C(L,N){let W=(0,o.comparePaths)(L.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(W!==0)return W;if(L.command&&N.command)W=d(L.command,N.command);else{if(L.command)return 1;if(N.command)return-1}if(W!==0)return W;if(L.decorations&&N.decorations)W=m(L.decorations,N.decorations);else{if(L.decorations)return 1;if(N.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)W=(0,o.comparePaths)(L.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)W=(0,o.comparePaths)(L.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return W}function _(L,N){for(let W=0;W<L.length;W++)if(L[W]!==N[W])return!1;return!0}function E(L,N){return L.command===N.command&&L.title===N.title&&L.tooltip===N.tooltip&&(L.arguments&&N.arguments?_(L.arguments,N.arguments):L.arguments===N.arguments)}function T(L,N){return(0,p.equals)(L,N,E)}class D{#e;#t;get value(){return this._value}set value(N){N=N??"",this.#e.$setInputBoxValue(this._sourceControlHandle,N),this.updateValue(N)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(N){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,N),this._placeholder=N}get validateInput(){return(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(N){if((0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=N,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!N)}get enabled(){return this._enabled}set enabled(N){N=!!N,this._enabled!==N&&(this._enabled=N,this.#e.$setInputBoxEnablement(this._sourceControlHandle,N))}get visible(){return this._visible}set visible(N){N=!!N,this._visible!==N&&(this._visible=N,this.#e.$setInputBoxVisibility(this._sourceControlHandle,N))}get document(){return(0,r.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(N,W,j,$,K){this._extension=N,this._sourceControlHandle=$,this._documentUri=K,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=W,this.#e=j}showValidationMessage(N,W){(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,N,W)}$onInputBoxValueChange(N){this.updateValue(N)}updateValue(N){this._value=N,this._onDidChange.fire(N)}}e.ExtHostSCMInputBox=D;class f{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(N){this._label=N,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,N)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(N){this._hideWhenEmpty=N,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(N){this._resourceStates=[...N],this._onDidUpdateResourceStates.fire()}constructor(N,W,j,$,K,q,ae){this._proxy=N,this._commands=W,this._sourceControlHandle=j,this._id=$,this._label=K,this.multiDiffEditorEnableViewChanges=q,this._extension=ae,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=f._handlePool++}getResourceState(N){return this._resourceStatesMap.get(N)}$executeResourceCommand(N,W){const j=this._resourceStatesCommandsMap.get(N);return j?(0,A.asPromise)(()=>this._commands.executeCommand(j.command,...j.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this._resourceStates].sort(C),j=(0,p.sortedDiff)(this._resourceSnapshot,N,C).map(q=>{const ae=q.toInsert.map(Ee=>{const ce=this._resourceHandlePool++;this._resourceStatesMap.set(ce,Ee);const Z=Ee.resourceUri;let le;if(Ee.command)if(Ee.command.command==="vscode.open"||Ee.command.command==="vscode.diff"||Ee.command.command==="vscode.changes"){const J=new O.DisposableStore;le=this._commands.converter.toInternal(Ee.command,J),this._resourceStatesDisposablesMap.set(ce,J)}else this._resourceStatesCommandsMap.set(ce,Ee.command);const me=(0,r.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),oe=me?Ee.multiDiffEditorOriginalUri:void 0,De=me?Ee.multiFileDiffEditorModifiedUri:void 0,Re=t(Ee.decorations),Q=Ee.decorations&&t(Ee.decorations.light)||Re,z=Ee.decorations&&t(Ee.decorations.dark)||Re,ne=[Q,z],Ce=Ee.decorations&&Ee.decorations.tooltip||"",fe=Ee.decorations&&!!Ee.decorations.strikeThrough,be=Ee.decorations&&!!Ee.decorations.faded,de=Ee.contextValue||"";return{rawResource:[ce,Z,ne,Ce,fe,be,de,le,oe,De],handle:ce}});return{start:q.start,deleteCount:q.deleteCount,toInsert:ae}}),$=j.map(({start:q,deleteCount:ae,toInsert:Ee})=>[q,ae,Ee.map(ce=>ce.rawResource)]),K=j.reverse();for(const{start:q,deleteCount:ae,toInsert:Ee}of K){const ce=Ee.map(le=>le.handle),Z=this._handlesSnapshot.splice(q,ae,...ce);for(const le of Z)this._resourceStatesMap.delete(le),this._resourceStatesCommandsMap.delete(le),this._resourceStatesDisposablesMap.get(le)?.dispose(),this._resourceStatesDisposablesMap.delete(le)}return this._resourceSnapshot=N,$}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class b{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(N){this._count!==N&&(this._count=N,this.#e.$updateSourceControl(this.handle,{count:N}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(N){this._quickDiffProvider=N;let W;(0,r.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(W=N?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!N,quickDiffLabel:W})}get historyProvider(){return(0,r.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(N){(0,r.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=N,this._historyProviderDisposable.value=new O.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!N}),N&&this._historyProviderDisposable.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(N){N!==this._commitTemplate&&(this._commitTemplate=N,this.#e.$updateSourceControl(this.handle,{commitTemplate:N}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(N){this._acceptInputDisposables.value=new O.DisposableStore,this._acceptInputCommand=N;const W=this._commands.converter.toInternal(N,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:W})}get actionButton(){return(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(N){(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new O.DisposableStore,this._actionButton=N;const W=N!==void 0?{command:this._commands.converter.toInternal(N.command,this._actionButtonDisposables.value),secondaryCommands:N.secondaryCommands?.map(j=>j.map($=>this._commands.converter.toInternal($,this._actionButtonDisposables.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:W??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(N){if(this._statusBarCommands&&N&&T(this._statusBarCommands,N))return;this._statusBarDisposables.value=new O.DisposableStore,this._statusBarCommands=N;const W=(N||[]).map(j=>this._commands.converter.toInternal(j,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:W})}get selected(){return this._selected}constructor(N,W,j,$,K,q,ae){this._extension=N,this._commands=$,this._id=K,this._label=q,this._rootUri=ae,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new O.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new O.MutableDisposable,this._statusBarDisposables=new O.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=b._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=j;const Ee=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${K}/scm${this.handle}/input`,query:ae?`rootUri=${encodeURIComponent(ae.toString())}`:void 0});this._inputBox=new D(N,W,this.#e,this.handle,Ee),this.#e.$registerSourceControl(this.handle,K,q,ae,Ee)}createResourceGroup(N,W,j){const $=(0,r.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,K=new f(this.#e,this._commands,this.handle,N,W,$,this._extension),q=k.Event.once(K.onDidDispose)(()=>this.createdResourceGroups.delete(K));return this.createdResourceGroups.set(K,q),this.eventuallyAddResourceGroups(),K}eventuallyAddResourceGroups(){const N=[],W=[];for(const[j,$]of this.createdResourceGroups){$.dispose();const K=j.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(j),this.eventuallyUpdateResourceStates()});k.Event.once(j.onDidDispose)(()=>{this.updatedResourceGroups.delete(j),K.dispose(),this._groups.delete(j.handle),this.#e.$unregisterGroup(this.handle,j.handle)}),N.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const q=j._takeResourceStateSnapshot();q.length>0&&W.push([j.handle,q]),this._groups.set(j.handle,j)}this.#e.$registerGroups(this.handle,N,W),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const N=[];this.updatedResourceGroups.forEach(W=>{const j=W._takeResourceStateSnapshot();j.length!==0&&N.push([W.handle,j])}),N.length>0&&this.#e.$spliceResourceStates(this.handle,N),this.updatedResourceGroups.clear()}getResourceGroup(N){return this._groups.get(N)}setSelectionState(N){this._selected=N,this._onDidChangeSelection.fire(N)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ge([(0,P.debounce)(100)],b.prototype,"eventuallyAddResourceGroups",null),Ge([(0,P.debounce)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{c=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(N,W,j,$){this._commands=W,this._extHostDocuments=j,this.logService=$,this._sourceControls=new Map,this._sourceControlsByExtension=new w.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=N.getProxy(R.MainContext.MainThreadSCM),this._telemetry=N.getProxy(R.MainContext.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:K=>{if(K&&K.$mid===a.MarshalledId.ScmResource){const q=this._sourceControls.get(K.sourceControlHandle);if(!q)return K;const ae=q.getResourceGroup(K.groupHandle);return ae?ae.getResourceState(K.handle):K}else if(K&&K.$mid===a.MarshalledId.ScmResourceGroup){const q=this._sourceControls.get(K.sourceControlHandle);return q?q.getResourceGroup(K.groupHandle):K}else if(K&&K.$mid===a.MarshalledId.ScmProvider){const q=this._sourceControls.get(K.handle);return q||K}return K}})}createSourceControl(N,W,j,$){this.logService.trace("ExtHostSCM#createSourceControl",N.identifier.value,W,j,$),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const K=c._handlePool++,q=new b(N,this._extHostDocuments,this._proxy,this._commands,W,j,$);this._sourceControls.set(K,q);const ae=this._sourceControlsByExtension.get(N.identifier)||[];return ae.push(q),this._sourceControlsByExtension.set(N.identifier,ae),q}getLastInputBox(N){this.logService.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const W=this._sourceControlsByExtension.get(N.identifier),j=W&&W[W.length-1];return j&&j.inputBox}$provideOriginalResource(N,W,j){const $=S.URI.revive(W);this.logService.trace("ExtHostSCM#$provideOriginalResource",N,$.toString());const K=this._sourceControls.get(N);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>K.quickDiffProvider.provideOriginalResource($,j)).then(q=>q||null)}$onInputBoxValueChange(N,W){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",N);const j=this._sourceControls.get(N);return j&&j.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(N,W,j,$){this.logService.trace("ExtHostSCM#$executeResourceCommand",N,W,j);const K=this._sourceControls.get(N);if(!K)return Promise.resolve(void 0);const q=K.getResourceGroup(W);return q?q.$executeResourceCommand(j,$):Promise.resolve(void 0)}$validateInput(N,W,j){this.logService.trace("ExtHostSCM#$validateInput",N);const $=this._sourceControls.get(N);return!$||!$.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>$.inputBox.validateInput(W,j)).then(K=>{if(!K)return Promise.resolve(void 0);const q=h.MarkdownString.fromStrict(K.message);return q?Promise.resolve([q,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this._sourceControls.get(N)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,W,j,$){return await this._sourceControls.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,j,$)??void 0}async $resolveHistoryItemGroupCommonAncestor2(N,W,j){return await this._sourceControls.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(W,j)??void 0}async $provideHistoryItems(N,W,j,$){return(await this._sourceControls.get(N)?.historyProvider?.provideHistoryItems(W,j,$))?.map(ae=>u(ae))??void 0}async $provideHistoryItems2(N,W,j){return(await this._sourceControls.get(N)?.historyProvider?.provideHistoryItems2(W,j))?.map(q=>u(q))??void 0}async $provideHistoryItemSummary(N,W,j,$){const K=this._sourceControls.get(N)?.historyProvider;if(typeof K?.provideHistoryItemSummary!="function")return;const q=await K.provideHistoryItemSummary(W,j,$);return q?u(q):void 0}async $provideHistoryItemChanges(N,W,j,$){return await this._sourceControls.get(N)?.historyProvider?.provideHistoryItemChanges(W,j,$)??void 0}};e.ExtHostSCM=M,e.ExtHostSCM=M=c=Ge([Ve(3,I.ILogService)],M)}),define(Le[254],Ne([1,0,5,8,2]),function(Se,e,S,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class O{static{this.handlePool=0}constructor(R,p){this.uriTransformer=p,this.providers=new Map,this.proxy=R.getProxy(S.MainContext.MainThreadShare)}async $provideShare(R,p,o){return await this.providers.get(R)?.provideShare({selection:k.Range.to(p.selection),resourceUri:P.URI.revive(p.resourceUri)},o)??void 0}registerShareProvider(R,p){const o=O.handlePool++;return this.providers.set(o,p),this.proxy.$registerShareProvider(o,k.DocumentSelector.from(R,this.uriTransformer),p.id,p.label,p.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(o),this.providers.delete(o)}}}}e.ExtHostShare=O}),define(Le[255],Ne([1,0,7,5,9,4,8,14]),function(Se,e,S,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class p{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new S.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(a,y,h,r,s,l=S.StatusBarAlignment.Left,c){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new O.DisposableStore,this.#e=a,this.#t=y,s&&r){this._entryId=(0,S.asStatusBarItemIdentifier)(r.identifier,s);const i=h.get(this._entryId);i&&(l=i.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,c=i.priority,this._visible=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this._entryId=String(p.ID_GEN++);this._extension=r,this._id=s,this._alignment=l,this._priority=this.validatePriority(c)}validatePriority(a){if((0,R.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!p.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new O.DisposableStore,typeof a=="string"?this._command={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this._latestCommandRegistration)}:a?this._command={fromApi:a,internal:this.#t.toInternal(a,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let y;this._name?y=this._name:y=(0,P.localize)(10826,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=p.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const r=A.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,a,this._extension?.identifier.value,y,this._text,r,this._command?.internal,h,this._backgroundColor,this._alignment===S.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=p;class o{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,P.localize)(10827,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const y={message:a};return this._messages.unshift(y),this._update(),new S.Disposable(()=>{const h=this._messages.indexOf(y);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(a,y){this._existingItems=new Map,this._proxy=a.getProxy(k.MainContext.MainThreadStatusBar),this._commands=y,this._statusMessage=new o(this)}$acceptStaticEntries(a){for(const y of a)this._existingItems.set(y.entryId,y)}createStatusBarEntry(a,y,h,r){return new p(this._proxy,this._commands,this._existingItems,a,y,h,r)}setStatusBarMessage(a,y){const h=this._statusMessage.setMessage(a);let r;return typeof y=="number"?r=setTimeout(()=>h.dispose(),y):typeof y<"u"&&y.then(()=>h.dispose(),()=>h.dispose()),new S.Disposable(()=>{h.dispose(),clearTimeout(r)})}}e.ExtHostStatusBar=I}),define(Le[125],Ne([1,0,32,116,54,81,55,8,2]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0,S=We(S),R=We(R);const o=(i,n,t,g)=>{let u=n;return{enumerable:!0,configurable:!1,get(){return u},set(v){if(!t(u,v)){const m=u;u=v,i.listener?.(g(v,m))}}}},I=(i,n)=>i===n,w={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(g=>t.id===g.id)))},a=i=>n=>({op:O.TestItemEventOp.SetProp,update:i(n)}),y=(i,n)=>({range:(()=>{let t;const g=a(u=>({range:S.Range.lift(R.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return t},set(u){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),w.range(t,u)||(t=u,i.listener?.(g(u)))}}})(),label:o(i,n,w.label,a(t=>({label:t}))),description:o(i,void 0,w.description,a(t=>({description:t}))),sortText:o(i,void 0,w.sortText,a(t=>({sortText:t}))),canResolveChildren:o(i,!1,w.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:o(i,!1,w.busy,a(t=>({busy:t}))),error:o(i,void 0,w.error,a(t=>({error:R.MarkdownString.fromStrict(t)||null}))),tags:o(i,[],w.tags,(t,g)=>({op:O.TestItemEventOp.SetTags,new:t.map(R.TestTag.from),old:g.map(R.TestTag.from)}))}),h=i=>{const n=P.TestId.fromString(i.extId),t=new s(n.controllerId,n.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=R.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(g=>R.TestTag.to({id:(0,A.denamespaceTestTag)(g).tagId})),t},r=i=>{let n;for(const t of i.tests){const g=h(t.item);(0,k.getPrivateApiFor)(g).parent=n,n=g}return n};e.toItemFromContext=r;class s{constructor(n,t,g,u){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const v=(0,k.createPrivateApiFor)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return v.parent instanceof l?void 0:v.parent}},children:{value:(0,O.createTestItemChildren)(v,k.getPrivateApiFor,s),enumerable:!0,writable:!1},...y(v,g)})}}e.TestItemImpl=s;class l extends s{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class c extends O.TestItemCollection{constructor(n,t,g){super({controllerId:n,getDocumentVersion:u=>u&&g.getDocument(u)?.version,getApiFor:k.getPrivateApiFor,getChildren:u=>u.children,root:new l(n,t),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=c}),define(Le[33],Ne([1,0,14,7,8,25,5,17,11,36,32,101,2,4,3,16,125,22,39,42,69,63,66,38]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0,k=We(k),P=We(P);let v=class{#e;#t;#i;constructor(T,D,f){this._commands=new Map,this._apiCommands=new Map,this.#e=T.getProxy(A.MainContext.MainThreadCommands),this._logService=D,this.#i=f,this.#t=T.getProxy(A.MainContext.MainThreadTelemetry),this.converter=new m(this,b=>{const M=this._apiCommands.get(b);return M?.result===C.Void?M:void 0},D),this._argumentProcessors=[{processArgument(b){return(0,o.revive)(b)}},{processArgument(b){return(0,O.cloneAndChange)(b,function(M){if(I.Range.isIRange(M))return P.Range.to(M);if(w.Position.isIPosition(M))return P.Position.to(M);if(I.Range.isIRange(M.range)&&a.URI.isUri(M.uri))return P.location.to(M);if(M instanceof l.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(T){this._argumentProcessors.push(T)}registerApiCommand(T){const D=this.registerCommand(!1,T.id,async(...f)=>{const b=T.args.map((L,N)=>{if(!L.validate(f[N]))throw new Error(`Invalid argument '${L.name}' when running '${T.id}', received: ${typeof f[N]=="object"?JSON.stringify(f[N],null,"	"):f[N]} `);return L.convert(f[N])}),M=await this.executeCommand(T.internalId,...b);return T.result.convert(M,f,this.converter)},void 0,{description:T.description,args:T.args,returns:T.result.description});return this._apiCommands.set(T.id,T),new k.Disposable(()=>{D.dispose(),this._apiCommands.delete(T.id)})}registerCommand(T,D,f,b,M,L){if(this._logService.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this._commands.has(D))throw new Error(`command '${D}' already exists`);return this._commands.set(D,{callback:f,thisArg:b,metadata:M,extension:L}),T&&this.#e.$registerCommand(D),new k.Disposable(()=>{this._commands.delete(D)&&T&&this.#e.$unregisterCommand(D)})}executeCommand(T,...D){return this._logService.trace("ExtHostCommands#executeCommand",T),this._doExecuteCommand(T,D,!0)}async _doExecuteCommand(T,D,f){if(this._commands.has(T))return this.#e.$fireCommandActivationEvent(T),this._executeContributedCommand(T,D,!1);{let b=!1;const M=(0,O.cloneAndChange)(D,function(L){if(L instanceof k.Position)return P.Position.from(L);if(L instanceof k.Range)return P.Range.from(L);if(L instanceof k.Location)return P.location.from(L);if(k.NotebookRange.isNotebookRange(L))return P.NotebookRange.from(L);if(L instanceof ArrayBuffer)return b=!0,l.VSBuffer.wrap(new Uint8Array(L));if(L instanceof Uint8Array)return b=!0,l.VSBuffer.wrap(L);if(L instanceof l.VSBuffer)return b=!0,L;if(!Array.isArray(L))return L});try{const L=await this.#e.$executeCommand(T,b?new c.SerializableObjectWithBuffers(M):M,f);return(0,o.revive)(L)}catch(L){if(L instanceof Error&&L.message==="$executeCommand:retry")return this._doExecuteCommand(T,D,!1);throw L}}}async _executeContributedCommand(T,D,f){const b=this._commands.get(T);if(!b)throw new Error("Unknown command");const{callback:M,thisArg:L,metadata:N}=b;if(N?.args)for(let j=0;j<N.args.length;j++)try{(0,S.validateConstraint)(D[j],N.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${T}' failed. Illegal argument '${N.args[j].name}' - ${N.args[j].description}`)}const W=n.StopWatch.create();try{return await M.apply(L,D)}catch(j){if(T===this.converter.delegatingCommandId){const $=this.converter.getActualCommand(...D);$&&(T=$.command)}if(this._logService.error(j,T,b.extension?.identifier),!f)throw j;if(b.extension?.identifier){const $=this.#i.onExtensionError(b.extension.identifier,j);this._logService.trace("forwarded error to extension?",$,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.toErrorMessage)(j)),this.id=T,this.source=b.extension?.displayName??b.extension?.name}}}finally{this._reportTelemetry(b,T,W.elapsed())}}_reportTelemetry(T,D,f){T.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:T.extension.identifier.value,id:new t.TelemetryTrustedValue(D),duration:f})}$executeContributedCommand(T,...D){this._logService.trace("ExtHostCommands#$executeContributedCommand",T);const f=this._commands.get(T);return f?(D=D.map(b=>this._argumentProcessors.reduce((M,L)=>L.processArgument(M,f.extension?.identifier),b)),this._executeContributedCommand(T,D,!0)):Promise.reject(new Error(`Contributed command '${T}' does not exist.`))}getCommands(T=!1){return this._logService.trace("ExtHostCommands#getCommands",T),this.#e.$getCommands().then(D=>(T&&(D=D.filter(f=>f[0]!=="_")),D))}$getContributedCommandMetadata(){const T=Object.create(null);for(const[D,f]of this._commands){const{metadata:b}=f;b&&(T[D]=b)}return Promise.resolve(T)}};e.ExtHostCommands=v,e.ExtHostCommands=v=Ge([Ve(0,r.IExtHostRpcService),Ve(1,p.ILogService),Ve(2,g.IExtHostTelemetry)],v),e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class m{constructor(T,D,f){this._commands=T,this._lookupApiCommand=D,this._logService=f,this.delegatingCommandId=`__vsc${(0,u.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(T,D){if(!T)return;const f={$ident:void 0,id:T.command,title:T.title,tooltip:T.tooltip};if(!T.command)return f;const b=this._lookupApiCommand(T.command);if(b)f.id=b.internalId,f.arguments=b.args.map((M,L)=>M.convert(T.arguments&&T.arguments[L]));else if((0,R.isNonEmptyArray)(T.arguments)){const M=`${T.command} /${++this._cachIdPool}`;this._cache.set(M,T),D.add((0,y.toDisposable)(()=>{this._cache.delete(M),this._logService.trace("CommandsConverter#DISPOSE",M)})),f.$ident=M,f.id=this.delegatingCommandId,f.arguments=[M],this._logService.trace("CommandsConverter#CREATE",T.command,M)}return f}fromInternal(T){return typeof T.$ident=="string"?this._cache.get(T.$ident):{command:T.id,title:T.title,arguments:T.arguments}}getActualCommand(...T){return this._cache.get(T[0])}_executeConvertedCommand(...T){const D=this.getActualCommand(...T);return this._logService.trace("CommandsConverter#EXECUTE",T[0],D?D.command:"MISSING"),D?this._commands.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${T[0]}`)}}e.CommandsConverter=m;class d{static{this.Uri=new d("uri","Uri of a text document",T=>a.URI.isUri(T),T=>T)}static{this.Position=new d("position","A position in a text document",T=>k.Position.isPosition(T),P.Position.from)}static{this.Range=new d("range","A range in a text document",T=>k.Range.isRange(T),P.Range.from)}static{this.Selection=new d("selection","A selection in a text document",T=>k.Selection.isSelection(T),P.Selection.from)}static{this.Number=new d("number","",T=>typeof T=="number",T=>T)}static{this.String=new d("string","",T=>typeof T=="string",T=>T)}static{this.StringArray=d.Arr(d.String)}static Arr(T){return new d(`${T.name}_array`,`Array of ${T.name}, ${T.description}`,D=>Array.isArray(D)&&D.every(f=>T.validate(f)),D=>D.map(f=>T.convert(f)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",T=>T instanceof k.CallHierarchyItem,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",T=>T instanceof k.TypeHierarchyItem,P.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VSCodium TestItem",T=>T instanceof s.TestItemImpl,P.TestItem.from)}constructor(T,D,f,b){this.name=T,this.description=D,this.validate=f,this.convert=b}optional(){return new d(this.name,`(optional) ${this.description}`,T=>T==null||this.validate(T),T=>T===void 0?void 0:T===null?null:this.convert(T))}with(T,D){return new d(T??this.name,D??this.description,this.validate,this.convert)}}e.ApiCommandArgument=d;class C{static{this.Void=new C("no result",T=>T)}constructor(T,D){this.description=T,this.convert=D}}e.ApiCommandResult=C;class _{constructor(T,D,f,b,M){this.id=T,this.internalId=D,this.description=f,this.args=b,this.result=M}}e.ApiCommand=_}),define(Le[256],Ne([1,0,17,15,2,93,103,31,33,8,7]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0,O=We(O),o=We(o),I=We(I);const w=[new p.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",y(o.DocumentHighlight.to))),new p.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,S.isFalsyOrEmpty)(r))return;class l extends I.SymbolInformation{static to(i){const n=new l(i.name,o.SymbolKind.to(i.kind),i.containerName||"",new I.Location(s[0],o.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=o.Range.to(i.selectionRange),n.children=i.children?i.children.map(l.to):[],n}}return r.map(l.to)})),new p.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(o.TextEdit.to))),new p.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(o.TextEdit.to))),new p.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,new p.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new p.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(o.TextEdit.to))),new p.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new p.ApiCommand("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new p.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new p.ApiCommand("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new p.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new p.ApiCommand("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new p.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new p.ApiCommand("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new p.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location-instances.",y(o.location.to))),new p.ApiCommand("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location-instances.",y(o.location.to))),new p.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Hover-instances.",y(o.Hover.to))),new p.ApiCommand("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Hover-instances.",y(o.Hover.to))),new p.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>I.Position.isPosition(s)),r=>r.map(o.Position.from))],new p.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(s=>{let l;for(const c of s.reverse())l=new I.SelectionRange(o.Range.to(c),l);return l}))),new p.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.ApiCommandArgument.String.with("query","Search string")],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(o.WorkspaceSymbol.to))),new p.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(o.CallHierarchyItem.to))),new p.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(o.CallHierarchyIncomingCall.to))),new p.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(o.CallHierarchyOutgoingCall.to))),new p.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:o.Range.to(r.range),placeholder:r.text}})),new p.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("newName","The new symbol name")],new p.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return o.WorkspaceEdit.to(r)}})),new p.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(o.DocumentLink.to))),new p.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.decodeSemanticTokensDto)(r);if(s.type==="full")return new I.SemanticTokens(s.data,void 0)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range.optional()],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.decodeSemanticTokensDto)(r);if(s.type==="full")return new I.SemanticTokens(s.data,void 0)})),new p.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,s,l)=>{if(!r)return new I.CompletionList([]);const c=r.suggestions.map(i=>o.CompletionItem.to(i,l));return new I.CompletionList(c,r.incomplete)})),new p.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return o.SignatureHelp.to(r)})),new p.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,s,l)=>y(c=>new I.CodeLens(o.Range.to(c.range),c.command&&l.fromInternal(c.command)))(r))),new p.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.Range.isRange(r),r=>I.Selection.isSelection(r)?o.Selection.from(r):o.Range.from(r)),p.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,s,l)=>y(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(c.command)}else{const i=new I.CodeAction(c.title,c.kind?new I.CodeActionKind(c.kind):void 0);return c.edit&&(i.edit=o.WorkspaceEdit.to(c.edit)),c.command&&(i.command=l.fromInternal(c.command)),i.isPreferred=c.isPreferred,i}})(r))),new p.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new I.ColorInformation(o.Range.to(s.range),o.Color.to(s.color))):[])),new p.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.ApiCommandArgument("color","The color to show and insert",r=>r instanceof I.Color,o.Color.from),new p.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:o.Range.from(r.range)}))],new p.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(o.ColorPresentation.to):[])),new p.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of Inlay objects",(r,s,l)=>r.map(o.InlayHint.to.bind(void 0,l)))),new p.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(o.FoldingRange.to)})),new p.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",y(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>o.NotebookExclusiveDocumentPattern.to(s))})))),new p.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.Range,r=>o.InlineValueContext.from(r))],new p.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(o.InlineValue.to))),new p.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,k.matchesSomeScheme)(r,k.Schemas.http,k.Schemas.https),r=>r),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[o.ViewColumn.from(r),void 0]:[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)])).optional(),p.ApiCommandArgument.String.with("label","").optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.ApiCommandArgument.Uri.with("resource","Resource to open"),p.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[o.ViewColumn.from(r),void 0]:[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)])).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),p.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),p.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)]).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new p.ApiCommandArgument("resourceList","List of resources to compare",r=>{for(const s of r){if(s.length!==3)return!1;const[l,c,i]=s;if(!P.URI.isUri(l)||!P.URI.isUri(c)&&c!==void 0&&c!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],p.ApiCommandResult.Void),new p.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new p.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.ApiCommandArgument.TestItem],p.ApiCommandResult.Void),new p.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.ApiCommandResult.Void),new p.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.ApiCommandArgument.String.with("name","The context key name"),new p.ApiCommandArgument("value","The context key value",()=>!0,r=>r)],p.ApiCommandResult.Void),new p.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.StringArray,new p.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",r=>o.MappedEditsContext.is(r),r=>o.MappedEditsContext.from(r))],new p.ApiCommandResult("A promise that resolves to a workspace edit or null",r=>r?o.WorkspaceEdit.to(r):null)),new p.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.ApiCommandArgument("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?o.Range.from(r.initialRange):void 0,initialSelection:I.Selection.isSelection(r.initialSelection)?o.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?o.Position.from(r.position):void 0}})],p.ApiCommandResult.Void)];class a{static register(s){w.forEach(s.registerApiCommand,s),this._registerValidateWhenClausesCommand(s)}static _registerValidateWhenClausesCommand(s){s.registerCommand(!1,"_validateWhenClauses",R.validateWhenClauses)}}e.ExtHostApiCommands=a;function y(r){return s=>{if(Array.isArray(s))return s.map(r)}}function h(r){if(!Array.isArray(r))return;const s=[];for(const l of r)O.isLocationLink(l)?s.push(o.DefinitionLink.to(l)):s.push(o.location.to(l));return s}}),define(Le[257],Ne([1,0,2,33]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class P{constructor(A,R,p,o,I){this._extHostNotebooks=R,this._textDocumentsAndEditors=p,this._commands=o;const w=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",a=>!0,a=>a),new k.ApiCommandArgument("resource","Interactive resource Uri",a=>!0,a=>a),new k.ApiCommandArgument("controllerId","Notebook controller Id",a=>!0,a=>a),new k.ApiCommandArgument("title","Interactive editor title",a=>!0,a=>a)],new k.ApiCommandResult("Notebook and input URI",a=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const y=this._extHostNotebooks.getEditorById(a.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:S.URI.revive(a.notebookUri),inputUri:S.URI.revive(a.inputUri),notebookEditor:y.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:S.URI.revive(a.notebookUri),inputUri:S.URI.revive(a.inputUri)}}));this._commands.registerApiCommand(w)}$willAddInteractiveDocument(A,R,p,o){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=P}),define(Le[258],Ne([1,0,17,10,21,6,4,28,2,18,11,5,33,8,7,82,197,24,39,198]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=d,y=We(y);let n=class{constructor(_,E,T,D,f){this._initData=E,this._extHostNotebook=T,this._commands=D,this._logService=f,this._activeExecutions=new R.ResourceMap,this._activeNotebookExecutions=new R.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new O.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=_.getProxy(w.MainContext.MainThreadNotebookKernels);const b=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const N=this._extHostNotebook.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:N}}else if(L&&"notebookEditor"in L){const N=this._extHostNotebook.getIdByEditor(L.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return L})],a.ApiCommandResult.Void),M=new a.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[a.ApiCommandArgument.Uri],new a.ApiCommandResult("A promise that resolves to an array of variables",(L,N)=>L.map(W=>({variable:{name:W.name,value:W.value,expression:W.expression,type:W.type,language:W.language},hasNamedChildren:W.hasNamedChildren,indexedChildrenCount:W.indexedChildrenCount}))));this._commands.registerApiCommand(b),this._commands.registerApiCommand(M)}createNotebookController(_,E,T,D,f,b){for(const oe of this._kernelData.values())if(oe.controller.id===E&&o.ExtensionIdentifier.equals(_.identifier,oe.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const M=this._handlePool++,L=this;this._logService.trace(`NotebookController[${M}], CREATED by ${_.identifier.value}, ${E}`);const N=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${_.identifier}'`);let W=!1;const j=new O.Emitter,$=new O.Emitter,K={id:d(_.identifier,E),notebookType:T,extensionId:_.identifier,extensionLocation:_.extensionLocation,label:D||_.identifier.value,preloads:b?b.map(y.NotebookRendererScript.from):[]};let q=f??N,ae,Ee;this._proxy.$addKernel(M,K).catch(oe=>{console.log(oe),W=!0});let ce=0;const Z=()=>{if(W)return;const oe=++ce;Promise.resolve().then(()=>{oe===ce&&this._proxy.$updateKernel(M,K)})},le=new R.ResourceMap,me={get id(){return E},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return K.label},set label(oe){K.label=oe??_.displayName??_.name,Z()},get detail(){return K.detail??""},set detail(oe){K.detail=oe,Z()},get description(){return K.description??""},set description(oe){K.description=oe,Z()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(oe){K.supportedLanguages=oe,Z()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){K.supportsExecutionOrder=oe,Z()},get rendererScripts(){return K.preloads?K.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(oe){q=oe??N},get interruptHandler(){return ae},set interruptHandler(oe){ae=oe,K.supportsInterrupt=!!oe,Z()},set variableProvider(oe){(0,l.checkProposedApiEnabled)(_,"notebookVariableProvider"),Ee=oe,K.hasVariableProvider=!!oe,oe?.onDidChangeVariables(De=>L._proxy.$variablesUpdated(De.uri)),Z()},get variableProvider(){return Ee},createNotebookCellExecution(oe){if(W)throw new Error("notebook controller is DISPOSED");if(!le.has(oe.notebook.uri))throw L._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return L._createNotebookCellExecution(oe,d(_.identifier,this.id))},createNotebookExecution(oe){if((0,l.checkProposedApiEnabled)(_,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!le.has(oe.uri))throw L._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return L._createNotebookExecution(oe,d(_.identifier,this.id))},dispose:()=>{W||(this._logService.trace(`NotebookController[${M}], DISPOSED`),W=!0,this._kernelData.delete(M),j.dispose(),$.dispose(),this._proxy.$removeKernel(M))},updateNotebookAffinity(oe,De){De===h.NotebookControllerAffinity2.Hidden&&(0,l.checkProposedApiEnabled)(_,"notebookControllerAffinityHidden"),L._proxy.$updateNotebookPriority(M,oe.uri,De)},onDidReceiveMessage:$.event,postMessage(oe,De){return(0,l.checkProposedApiEnabled)(_,"notebookMessaging"),L._proxy.$postMessage(M,De&&L._extHostNotebook.getIdByEditor(De),oe)},asWebviewUri(oe){return(0,l.checkProposedApiEnabled)(_,"notebookMessaging"),(0,r.asWebviewUri)(oe,L._initData.remote)}};return this._kernelData.set(M,{extensionId:_.identifier,controller:me,onDidReceiveMessage:$,onDidChangeSelection:j,associatedNotebooks:le}),me}getIdByController(_){for(const[E,T]of this._kernelData)if(T.controller===_)return d(T.extensionId,_.id);return null}createNotebookControllerDetectionTask(_,E){const T=this._kernelDetectionTaskHandlePool++,D=this;this._logService.trace(`NotebookControllerDetectionTask[${T}], CREATED by ${_.identifier.value}`),this._proxy.$addKernelDetectionTask(T,E);const f={dispose:()=>{this._kernelDetectionTask.delete(T),D._proxy.$removeKernelDetectionTask(T)}};return this._kernelDetectionTask.set(T,f),f}registerKernelSourceActionProvider(_,E,T){const D=this._kernelSourceActionProviderHandlePool++,f=typeof T.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,b=this;this._kernelSourceActionProviders.set(D,T),this._logService.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${_.identifier.value}`),this._proxy.$addKernelSourceActionProvider(D,D,E);let M;return f!==void 0&&(M=T.onDidChangeNotebookKernelSourceActions(L=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this._kernelSourceActionProviders.delete(D),b._proxy.$removeKernelSourceActionProvider(D,D),M?.dispose()}}}async $provideKernelSourceActions(_,E){const T=this._kernelSourceActionProviders.get(_);if(T){const D=new A.DisposableStore;return(await T.provideNotebookKernelSourceActions(E)??[]).map(b=>y.NotebookKernelSourceAction.from(b,this._commands.converter,D))}return[]}$acceptNotebookAssociation(_,E,T){const D=this._kernelData.get(_);if(D){const f=this._extHostNotebook.getNotebookDocument(p.URI.revive(E));T?D.associatedNotebooks.set(f.uri,!0):D.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${_}] ASSOCIATE notebook`,f.uri.toString(),T),D.onDidChangeSelection.fire({selected:T,notebook:f.apiNotebook})}}async $executeCells(_,E,T){const D=this._kernelData.get(_);if(!D)return;const f=this._extHostNotebook.getNotebookDocument(p.URI.revive(E)),b=[];for(const M of T){const L=f.getCell(M);L&&b.push(L.apiCell)}try{this._logService.trace(`NotebookController[${_}] EXECUTE cells`,f.uri.toString(),b.length),await D.controller.executeHandler.call(D.controller,b,f.apiNotebook,D.controller)}catch(M){this._logService.error(`NotebookController[${_}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(_,E,T){const D=this._kernelData.get(_);if(!D)return;const f=this._extHostNotebook.getNotebookDocument(p.URI.revive(E));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,f.apiNotebook);else for(const b of T){const M=f.getCell(b);M&&this._activeExecutions.get(M.uri)?.cancel()}if(D.controller.interruptHandler){const b=this._activeNotebookExecutions.get(f.uri);this._activeNotebookExecutions.delete(f.uri),T.length&&Array.isArray(b)&&b.length&&b.forEach(M=>M.dispose())}}async $provideVariables(_,E,T,D,f,b,M){const L=this._kernelData.get(_);if(!L)return;const N=this._extHostNotebook.getNotebookDocument(p.URI.revive(T)),W=L.controller.variableProvider;if(!W)return;let j;if(D!==void 0){if(j=this.variableStore[D],!j)return}else this.variableStore={};const $=f==="named"?h.NotebookVariablesRequestKind.Named:h.NotebookVariablesRequestKind.Indexed,K=W.provideVariables(N.apiNotebook,j,$,b,M);let q=0;for await(const ae of K){if(M.isCancellationRequested)return;const Ee={id:this.id++,name:ae.variable.name,value:ae.variable.value,type:ae.variable.type,interfaces:ae.variable.interfaces,language:ae.variable.language,expression:ae.variable.expression,hasNamedChildren:ae.hasNamedChildren,indexedChildrenCount:ae.indexedChildrenCount,extensionId:L.extensionId.value};if(this.variableStore[Ee.id]=ae.variable,this._proxy.$receiveVariable(E,Ee),q++>=i.variablePageSize)return}}$acceptKernelMessageFromRenderer(_,E,T){const D=this._kernelData.get(_);if(!D)return;const f=this._extHostNotebook.getEditorById(E);D.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:T}))}$cellExecutionChanged(_,E,T){const f=this._extHostNotebook.getNotebookDocument(p.URI.revive(_)).getCell(E);if(f){const b=T?y.NotebookCellExecutionState.to(T):h.NotebookCellExecutionState.Idle;b!==void 0&&this._onDidChangeCellExecutionState.fire({cell:f.apiCell,state:b})}}_createNotebookCellExecution(_,E){if(_.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this._extHostNotebook.getNotebookDocument(_.notebook.uri).getCellFromApiCell(_);if(!D)throw new Error("invalid cell");if(this._activeExecutions.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const f=new g(E,D,this._proxy);this._activeExecutions.set(D.uri,f);const b=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),b.dispose(),this._activeExecutions.delete(D.uri))});return f.asApiObject()}_createNotebookExecution(_,E){const T=this._extHostNotebook.getNotebookDocument(_.uri),D=_.getCells().find(M=>{const L=T.getCellFromApiCell(M);return L&&this._activeExecutions.has(L.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this._activeNotebookExecutions.has(T.uri))throw new Error(`duplicate notebook execution for ${T.uri}`);const f=new v(E,T,this._proxy),b=f.onDidChangeState(()=>{f.state===u.Resolved&&(f.dispose(),b.dispose(),this._activeNotebookExecutions.delete(T.uri))});return this._activeNotebookExecutions.set(T.uri,[f,b]),f.asApiObject()}};e.ExtHostNotebookKernels=n,e.ExtHostNotebookKernels=n=Ge([Ve(4,I.ILogService)],n);var t;(function(C){C[C.Init=0]="Init",C[C.Started=1]="Started",C[C.Resolved=2]="Resolved"})(t||(t={}));class g extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(_,E,T){super(),this._cell=E,this._proxy=T,this._handle=g.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._collector=new m(10,D=>this.update(D)),this._executionOrder=E.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,_,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(_){await this._collector.addItem(_)}async update(_){const E=Array.isArray(_)?_:[_];return this._proxy.$updateExecution(this._handle,new c.SerializableObjectWithBuffers(E))}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(_){let E=this._cell;if(_&&(E=this._cell.notebook.getCellFromApiCell(_)),!E)throw new Error("INVALID cell");return E.handle}validateAndConvertOutputs(_){return _.map(E=>{const T=h.NotebookCellOutput.ensureUniqueMimeTypes(E.items,!0);return T===E.items?y.NotebookCellOutput.from(E):y.NotebookCellOutput.from({items:T,id:E.id,metadata:E.metadata})})}async updateOutputs(_,E,T){const D=this.cellIndexToHandle(E),f=this.validateAndConvertOutputs((0,S.asArray)(_));return this.updateSoon({editType:s.CellExecutionUpdateType.Output,cellHandle:D,append:T,outputs:f})}async updateOutputItems(_,E,T){return _=h.NotebookCellOutput.ensureUniqueMimeTypes((0,S.asArray)(_),!0),this.updateSoon({editType:s.CellExecutionUpdateType.OutputItems,items:_.map(y.NotebookCellOutputItem.from),outputId:E.id,append:T})}asApiObject(){const _=this;return Object.freeze({get token(){return _._tokenSource.token},get cell(){return _._cell.apiCell},get executionOrder(){return _._executionOrder},set executionOrder(T){_._executionOrder=T,_.update([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:_._executionOrder}])},start(T){if(_._state===t.Resolved||_._state===t.Started)throw new Error("Cannot call start again");_._state=t.Started,_._onDidChangeState.fire(),_.update({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:T})},end(T,D,f){if(_._state===t.Resolved)throw new Error("Cannot call resolve twice");_._state=t.Resolved,_._onDidChangeState.fire(),_._collector.flush();const b=f?{message:f.message,stack:f.stack,location:f?.location?{startLineNumber:f.location.start.line,startColumn:f.location.start.character,endLineNumber:f.location.end.line,endColumn:f.location.end.character}:void 0,uri:f.uri}:void 0;_._proxy.$completeExecution(_._handle,new c.SerializableObjectWithBuffers({runEndTime:D,lastRunSuccess:T,error:b}))},clearOutput(T){return _.verifyStateForOutput(),_.updateOutputs([],T,!1)},appendOutput(T,D){return _.verifyStateForOutput(),_.updateOutputs(T,D,!0)},replaceOutput(T,D){return _.verifyStateForOutput(),_.updateOutputs(T,D,!1)},appendOutputItems(T,D){return _.verifyStateForOutput(),_.updateOutputItems(T,D,!0)},replaceOutputItems(T,D){return _.verifyStateForOutput(),_.updateOutputItems(T,D,!1)}})}}var u;(function(C){C[C.Init=0]="Init",C[C.Started=1]="Started",C[C.Resolved=2]="Resolved"})(u||(u={}));class v extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(_,E,T){super(),this._notebook=E,this._proxy=T,this._handle=v.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,_,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===u.Resolved||this._state===u.Started)throw new Error("Cannot call start again");this._state=u.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===u.Resolved)throw new Error("Cannot call resolve twice");this._state=u.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class m{constructor(_,E){this.delay=_,this.callback=E,this.batch=[],this.startedTimer=Date.now()}addItem(_){return this.batch.push(_),this.currentDeferred||(this.currentDeferred=new k.DeferredPromise,this.startedTimer=Date.now(),(0,k.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const _=this.currentDeferred;this.currentDeferred=void 0;const E=this.batch;return this.batch=[],this.callback(E).finally(()=>_.complete())}}function d(C,_){return`${C.value}/${_}`}}),define(Le[56],Ne([1,0,6,5,3,2,16,4,7,9,13,179,21,38,180,181,34,10,8,33,37]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class t extends R.Disposable{constructor(f,b,M,L){super(),this._proxy=f,this._id=b,this._creationOptions=M,this._name=L,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new S.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(W=>this._pidPromiseComplete=W);const N=this;this.value={get name(){return N._name||""},get processId(){return N._pidPromise},get creationOptions(){return N._creationOptions},get exitStatus(){return N._exitStatus},get state(){return N._state},get selection(){return N._selection},get shellIntegration(){return N.shellIntegration},sendText(W,j=!0){N._checkDisposed(),N._proxy.$sendText(N._id,W,j)},show(W){N._checkDisposed(),N._proxy.$show(N._id,W)},hide(){N._checkDisposed(),N._proxy.$hide(N._id)},dispose(){N._disposed||(N._disposed=!0,N._proxy.$dispose(N._id))},get dimensions(){if(!(N._cols===void 0||N._rows===void 0))return{columns:N._cols,rows:N._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(f,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??b?.cwd??void 0,env:f.env??void 0,icon:_(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this._serializeParentTerminal(f.location,b?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,b,M,L,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:L,color:s.ThemeColor.isThemeColor(N)?N.id:void 0,location:b?.location||this._serializeParentTerminal(f,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,b){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in f?{viewColumn:c.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitStatus(f,b){this._exitStatus=Object.freeze({code:f,reason:b})}setDimensions(f,b){return f===this._cols&&b===this._rows||f===0||b===0?!1:(this._cols=f,this._rows=b,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(f){this._selection=f}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(b=>{b!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=t;class g{get onProcessReady(){return this._onProcessReady.event}constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new S.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new S.Emitter,this._onDidChangeProperty=new S.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new S.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${b}`)}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput?.(f)}resize(f,b){this._pty.setDimensions?.({columns:f,rows:b})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this._pty.onDidWrite(b=>this._onProcessData.fire(b)),this._pty.onDidClose?.((b=void 0)=>{this._onProcessExit.fire(b===void 0?void 0:b)}),this._pty.onDidOverrideDimensions?.(b=>{b&&this._onDidChangeProperty.fire({type:h.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this._pty.onDidChangeName?.(b=>{this._onDidChangeProperty.fire({type:h.ProcessPropertyType.Title,value:b})}),this._pty.open(f||void 0),f&&this._pty.setDimensions?.(f),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,v=class extends R.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}constructor(f,b,M){super(),this._extHostCommands=b,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new R.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new S.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new S.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new S.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new S.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new S.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new S.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new S.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new S.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=M.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(f),this._extHostCommands.registerArgumentProcessor({processArgument:L=>{const N=W=>{const j=W;return this.getTerminalById(j.instanceId)?.value};switch(L?.$mid){case n.MarshalledId.TerminalContext:return N(L);default:{if(Array.isArray(L))for(let W=0;W<L.length&&L[W].$mid===n.MarshalledId.TerminalContext;W++)L[W]=N(L[W]);return L}}}}),this._register({dispose:()=>{for(const[L,N]of this._terminalProcesses)N.shutdown(!0)}})}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,b){const M=new t(this._proxy,(0,y.generateUuid)(),f,f.name),L=new g(f.pty);return M.createExtensionTerminal(f.location,b,this._serializeParentTerminal(f,b).resolvedExtHostIdentifier,_(f.iconPath),E(f.color)).then(N=>{const W=this._setupExtHostProcessListeners(N,L);this._terminalProcessDisposables[N]=W}),this._terminals.push(M),M.value}_serializeParentTerminal(f,b){if(b=b||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const M=f.location.parentTerminal;if(M){const L=this._terminals.find(N=>N.value===M);L&&(b.resolvedExtHostIdentifier=L._id)}}else f.location&&typeof f.location!="object"?b.location=f.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(f,b){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const L=new g(b),N=this._setupExtHostProcessListeners(f,L);this._terminalProcessDisposables[f]=N}async $acceptActiveTerminalChanged(f){const b=this._activeTerminal;if(f===null){this._activeTerminal=void 0,b!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const M=this.getTerminalById(f);M&&(this._activeTerminal=M,b!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,b){const M=this.getTerminalById(f);M&&this._onDidWriteTerminalData.fire({terminal:M.value,data:b})}async $acceptTerminalDimensions(f,b,M){const L=this.getTerminalById(f);L&&L.setDimensions(b,M)&&this._onDidChangeTerminalDimensions.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(f,b){const M=this.getTerminalById(f);M&&this._onDidExecuteCommand.fire({terminal:M.value,...b})}async $acceptTerminalMaximumDimensions(f,b,M){this._terminalProcesses.get(f)?.resize(b,M)}async $acceptTerminalTitleChange(f,b){const M=this.getTerminalById(f);M&&(M.name=b)}async $acceptTerminalClosed(f,b,M){const L=this._getTerminalObjectIndexById(this._terminals,f);if(L!==null){const N=this._terminals.splice(L,1)[0];N.setExitStatus(b,M),this._onDidCloseTerminal.fire(N.value)}}$acceptTerminalOpened(f,b,M,L){if(b){const j=this._getTerminalObjectIndexById(this._terminals,b);if(j!==null){this._terminals[j]._id=f,this._onDidOpenTerminal.fire(this.terminals[j]),this._terminals[j].isOpen=!0;return}}const N={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:O.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},W=new t(this._proxy,f,N,M);this._terminals.push(W),this._onDidOpenTerminal.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(f,b){this.getTerminalById(f)?._setProcessId(b)}async $startExtensionTerminal(f,b){const M=this.getTerminalById(f);if(!M)return{message:(0,o.localize)(10824,null,f)};M.isOpen||await new Promise(N=>{const W=this.onDidOpenTerminal(async j=>{j===M.value&&(W.dispose(),N())})});const L=this._terminalProcesses.get(f);L?L.startSendingEvents(b):this._extensionTerminalAwaitingStart[f]={initialDimensions:b}}_setupExtHostProcessListeners(f,b){const M=new R.DisposableStore;M.add(b.onProcessReady(N=>this._proxy.$sendProcessReady(f,N.pid,N.cwd,N.windowsPty))),M.add(b.onDidChangeProperty(N=>this._proxy.$sendProcessProperty(f,N))),this._bufferer.startBuffering(f,b.onProcessData),M.add(b.onProcessExit(N=>this._onProcessExit(f,N))),this._terminalProcesses.set(f,b);const L=this._extensionTerminalAwaitingStart[f];return L&&b instanceof g&&(b.startSendingEvents(L.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),M}$acceptProcessAckDataEvent(f,b){this._terminalProcesses.get(f)?.acknowledgeDataEvent(b)}$acceptProcessInput(f,b){this._terminalProcesses.get(f)?.input(b)}$acceptTerminalInteraction(f){const b=this.getTerminalById(f);b?.setInteractedWith()&&this._onDidChangeTerminalState.fire(b.value)}$acceptTerminalSelection(f,b){this.getTerminalById(f)?.setSelection(b)}$acceptProcessResize(f,b,M){try{this._terminalProcesses.get(f)?.resize(b,M)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(f,b){this._terminalProcesses.get(f)?.shutdown(b)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(b=>this._proxy.$sendProcessProperty(f,{type:h.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(b=>this._proxy.$sendProcessProperty(f,{type:h.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new p.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,b,M){if(this._profileProviders.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this._profileProviders.set(b,M),this._proxy.$registerProfileProvider(b,f.identifier.value),new p.Disposable(()=>{this._profileProviders.delete(b),this._proxy.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(f,b,M){if(this._quickFixProviders.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this._quickFixProviders.set(f,M),this._proxy.$registerQuickFixProvider(f,b),new p.Disposable(()=>{this._quickFixProviders.delete(f),this._proxy.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,b){const M=new a.CancellationTokenSource().token;if(M.isCancellationRequested)return;const L=this._quickFixProviders.get(f);if(!L)return;const N=await L.provideTerminalQuickFixes(b,M);if(N===null||Array.isArray(N)&&N.length===0)return;const W=new R.DisposableStore;if(this._lastQuickFixCommands.value=W,!Array.isArray(N))return N?c.TerminalQuickFix.from(N,this._extHostCommands.converter,W):void 0;const j=[];for(const $ of N){const K=c.TerminalQuickFix.from($,this._extHostCommands.converter,W);K&&j.push(K)}return j}async $createContributedProfileTerminal(f,b){const M=new a.CancellationTokenSource().token;let L=await this._profileProviders.get(f)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,b);return}this.createTerminalFromOptions(L.options,b)}}async $provideLinks(f,b){const M=this.getTerminalById(f);if(!M)return[];this._terminalLinkCache.delete(f),this._terminalLinkCancellationSource.get(f)?.dispose(!0);const N=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,N);const W=[],j={terminal:M.value,line:b},$=[];for(const ae of this._linkProviders)$.push(l.Promises.withAsyncBody(async Ee=>{N.token.onCancellationRequested(()=>Ee({provider:ae,links:[]}));const ce=await ae.provideTerminalLinks(j,N.token)||[];N.token.isCancellationRequested||Ee({provider:ae,links:ce})}));const K=await Promise.all($);if(N.token.isCancellationRequested)return[];const q=new Map;for(const ae of K)ae&&ae.links.length>0&&W.push(...ae.links.map(Ee=>{const ce={id:u++,startIndex:Ee.startIndex,length:Ee.length,label:Ee.tooltip};return q.set(ce.id,{provider:ae.provider,link:Ee}),ce}));return this._terminalLinkCache.set(f,q),W}$activateLink(f,b){const M=this._terminalLinkCache.get(f)?.get(b);M&&M.provider.handleTerminalLink(M.link)}_onProcessExit(f,b){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const M=this._terminalProcessDisposables[f];M&&(M.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,b)}getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}getTerminalIdByApiObject(f){const b=this._terminals.findIndex(M=>M.value===f);return b>=0?b:null}_getTerminalObjectById(f,b){const M=this._getTerminalObjectIndexById(f,b);return M!==null?f[M]:null}_getTerminalObjectIndexById(f,b){const M=f.findIndex(L=>L._id===b);return M>=0?M:null}getEnvironmentVariableCollection(f){let b=this._environmentVariableCollections.get(f.identifier.value);return b||(b=this._register(new m),this._setEnvironmentVariableCollection(f.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(f,b){const M=(0,w.serializeEnvironmentVariableCollection)(b.map),L=(0,w.serializeEnvironmentDescriptionMap)(b.descriptionMap);this._proxy.$setEnvironmentVariableCollection(f,b.persistent,M.length===0?void 0:M,L)}$initEnvironmentVariableCollections(f){f.forEach(b=>{const M=b[0],L=this._register(new m(b[1]));this._setEnvironmentVariableCollection(M,L)})}$acceptDefaultProfile(f,b){const M=this._defaultProfile;this._defaultProfile=f,this._defaultAutomationProfile=b,M?.path!==f.path&&this._onDidChangeShell.fire(f.path)}_setEnvironmentVariableCollection(f,b){this._environmentVariableCollections.set(f,b),this._register(b.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,b)}))}};e.BaseExtHostTerminalService=v,e.BaseExtHostTerminalService=v=Ge([Ve(1,i.IExtHostCommands),Ve(2,A.IExtHostRpcService)],v);class m extends R.Disposable{get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(f){super(),this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new S.Emitter,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const b=this.getScopeKey(f);let M=this.scopedCollections.get(b);return M||(M=new d(this,f),this.scopedCollections.set(b,M),this._register(M.onDidChangeCollection(()=>this._onDidChangeCollection.fire()))),M}replace(f,b,M,L){this._setIfDiffers(f,{value:b,type:p.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:L})}append(f,b,M,L){this._setIfDiffers(f,{value:b,type:p.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:L})}prepend(f,b,M,L){this._setIfDiffers(f,{value:b,type:p.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:L})}_setIfDiffers(f,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.getKey(f,b.scope),L=this.map.get(M),N=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==b.value||L.type!==b.type||L.options?.applyAtProcessCreation!==N.applyAtProcessCreation||L.options?.applyAtShellIntegration!==N.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const W=this.getKey(f,b.scope),j={variable:f,...b,options:N};this.map.set(W,j),this._onDidChangeCollection.fire()}}get(f,b){const M=this.getKey(f,b),L=this.map.get(M);return L?T(L):void 0}getKey(f,b){const M=this.getScopeKey(b);return M.length?`${f}:::${M}`:f}getScopeKey(f){return this.getWorkspaceKey(f?.workspaceFolder)??""}getWorkspaceKey(f){return f?f.uri.toString():void 0}getVariableMap(f){const b=new Map;for(const[M,L]of this.map)this.getScopeKey(L.scope)===this.getScopeKey(f)&&b.set(L.variable,T(L));return b}delete(f,b){const M=this.getKey(f,b);this.map.delete(M),this._onDidChangeCollection.fire()}clear(f){if(f?.workspaceFolder){for(const[b,M]of this.map)M.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(b);this.clearDescription(f)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(f,b){const M=this.getScopeKey(b),L=this.descriptionMap.get(M);if(!L||L.description!==f){let N;typeof f=="string"?N=f:N=f?.value.split(`

`)[0];const W={description:N,scope:b};this.descriptionMap.set(M,W),this._onDidChangeCollection.fire()}}getDescription(f){const b=this.getScopeKey(f);return this.descriptionMap.get(b)?.description}clearDescription(f){const b=this.getScopeKey(f);this.descriptionMap.delete(b)}}class d{get persistent(){return this.collection.persistent}set persistent(f){this.collection.persistent=f}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(f,b){this.collection=f,this.scope=b,this._onDidChangeCollection=new S.Emitter}getScoped(f){return this.collection.getScopedEnvironmentVariableCollection(f)}replace(f,b,M){this.collection.replace(f,b,M,this.scope)}append(f,b,M){this.collection.append(f,b,M,this.scope)}prepend(f,b,M){this.collection.prepend(f,b,M,this.scope)}get(f){return this.collection.get(f,this.scope)}forEach(f,b){this.collection.getVariableMap(this.scope).forEach((M,L)=>f.call(b,L,M,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(f){this.collection.delete(f,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(f){this.collection.setDescription(f,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let C=class extends v{constructor(f,b){super(!1,f,b)}createTerminal(f,b,M){throw new I.NotSupportedError}createTerminalFromOptions(f,b){throw new I.NotSupportedError}};e.WorkerExtHostTerminalService=C,e.WorkerExtHostTerminalService=C=Ge([Ve(0,i.IExtHostCommands),Ve(1,A.IExtHostRpcService)],C);function _(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function E(D){return s.ThemeColor.isThemeColor(D)?D:void 0}function T(D){const f={...D};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Le[126],Ne([1,0,7,4,3,5,16,56,6,2,10]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,P.createDecorator)("IExtHostTerminalShellIntegration");let w=class extends k.Disposable{constructor(s,l){super(),this._extHostTerminalService=l,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new p.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new p.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new p.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=s.getProxy(O.MainContext.MainThreadTerminalShellIntegration),this._register((0,k.toDisposable)(()=>{for(const[c,i]of this._activeShellIntegrations)i.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(s){const l=this._extHostTerminalService.getTerminalById(s);if(!l)return;const c=l.value;let i=this._activeShellIntegrations.get(s);i||(i=new a(l.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(s,i),i.store.add(l.onWillDispose(()=>this._activeShellIntegrations.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this._proxy.$executeCommand(s,n))),i.store.add(i.onDidRequestEndExecution(n=>this._onDidEndTerminalShellExecution.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this._onDidChangeTerminalShellIntegration.fire(n))),l.shellIntegration=i.value),this._onDidChangeTerminalShellIntegration.fire({terminal:c,shellIntegration:i.value})}$shellExecutionStart(s,l,c,i,n){this._activeShellIntegrations.has(s)||this.$shellIntegrationChange(s);const t={value:l,confidence:c,isTrusted:i};this._activeShellIntegrations.get(s)?.startShellExecution(t,o.URI.revive(n))}$shellExecutionEnd(s,l,c,i,n){const t={value:l,confidence:c,isTrusted:i};this._activeShellIntegrations.get(s)?.endShellExecution(t,n)}$shellExecutionData(s,l){this._activeShellIntegrations.get(s)?.emitData(l)}$cwdChange(s,l){this._activeShellIntegrations.get(s)?.setCwd(o.URI.revive(l))}$closeTerminal(s){this._activeShellIntegrations.get(s)?.dispose(),this._activeShellIntegrations.delete(s)}};e.ExtHostTerminalShellIntegration=w,e.ExtHostTerminalShellIntegration=w=Ge([Ve(0,A.IExtHostRpcService),Ve(1,R.IExtHostTerminalService)],w);class a extends k.Disposable{get currentExecution(){return this._currentExecution}constructor(s,l){super(),this._terminal=s,this._onDidStartTerminalShellExecution=l,this._ignoreNextExecution=!1,this.store=this._register(new k.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new p.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new p.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new p.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const c=this;this.value={get cwd(){return c._cwd},executeCommand(i,n){let t=i;n&&(t+=` "${n.map(v=>`${v.replaceAll('"','\\"')}`).join('" "')}"`),c._onDidRequestShellExecution.fire(t);const g={value:t,confidence:S.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=c.startShellExecution(g,c._cwd,!0).value;return c._ignoreNextExecution=!0,u}}}startShellExecution(s,l,c){if(this._ignoreNextExecution&&this._currentExecution)this._ignoreNextExecution=!1;else{this._currentExecution&&(this._currentExecution.endExecution(void 0),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:void 0}));const i=this._currentExecution=new y(s,l??this._cwd);c?queueMicrotask(()=>this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:i.value})):this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value})}return this._currentExecution}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,l){this._currentExecution&&(this._currentExecution.endExecution(s),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:l}),this._currentExecution=void 0)}setCwd(s){let l=!1;o.URI.isUri(this._cwd)?l=!o.URI.isUri(s)||this._cwd.toString()!==s.toString():this._cwd!==s&&(l=!0),l&&(this._cwd=s,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class y{constructor(s,l){this._commandLine=s,this.cwd=l,this._ended=!1;const c=this;this.value={get commandLine(){return c._commandLine},get cwd(){return c.cwd},read(){return c._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._ended)return I.AsyncIterableObject.EMPTY;this._dataStream=new h}return this._dataStream.createIterable()}emitData(s){this._dataStream?.emitData(s)}endExecution(s){s&&(this._commandLine=s),this._dataStream?.endExecution(),this._dataStream=void 0,this._ended=!0}}class h extends k.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){this._barrier||(this._barrier=new I.Barrier);const s=this._barrier;return new I.AsyncIterableObject(async c=>{this._emitters.push(c),await s.wait()})}emitData(s){for(const l of this._emitters)l.emitOne(s)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(Le[127],Ne([1,0,61,13,96,8,7]),function(Se,e,S,k,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0,O=We(O);class R{static{this._Keys=new P.IdGenerator("TextEditorDecorationType")}constructor(a,y,h){const r=R._Keys.nextId();a.$registerTextEditorDecorationType(y.identifier,r,O.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:r,dispose(){a.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=R;class p{constructor(a,y){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=y.undoStopBefore,this._undoStopAfter=y.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,y){this._throwIfFinalized();let h=null;if(a instanceof A.Position)h=new A.Range(a,a);else if(a instanceof A.Range)h=a;else throw new Error("Unrecognized location");this._pushEdit(h,y,!1)}insert(a,y){this._throwIfFinalized(),this._pushEdit(new A.Range(a,a),y,!0)}delete(a){this._throwIfFinalized();let y=null;if(a instanceof A.Range)y=a;else throw new Error("Unrecognized location");this._pushEdit(y,null,!0)}_pushEdit(a,y,h){const r=this._document.validateRange(a);this._collectedEdits.push({range:r,text:y,forceMoveMarkers:h})}setEndOfLine(a){if(this._throwIfFinalized(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=a}}class o{constructor(a,y,h,r){this._proxy=a,this._id=y,this._accept(h),this._logService=r;const s=this;this.value={get tabSize(){return s._tabSize},set tabSize(l){s._setTabSize(l)},get indentSize(){return s._indentSize},set indentSize(l){s._setIndentSize(l)},get insertSpaces(){return s._insertSpaces},set insertSpaces(l){s._setInsertSpaces(l)},get cursorStyle(){return s._cursorStyle},set cursorStyle(l){s._setCursorStyle(l)},get lineNumbers(){return s._lineNumbers},set lineNumbers(l){s._setLineNumbers(l)}}}_accept(a){this._tabSize=a.tabSize,this._indentSize=a.indentSize,this._originalIndentSize=a.originalIndentSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=O.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const y=Math.floor(a);return y>0?y:null}if(typeof a=="string"){const y=parseInt(a,10);return isNaN(y)?null:y>0?y:null}return null}_setTabSize(a){const y=this._validateTabSize(a);if(y!==null){if(typeof y=="number"){if(this._tabSize===y)return;this._tabSize=y}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:y}))}}_validateIndentSize(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const y=Math.floor(a);return y>0?y:null}if(typeof a=="string"){const y=parseInt(a,10);return isNaN(y)?null:y>0?y:null}return null}_setIndentSize(a){const y=this._validateIndentSize(a);if(y!==null){if(typeof y=="number"){if(this._originalIndentSize===y)return;this._indentSize=y,this._originalIndentSize=y}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:y}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:!!a}_setInsertSpaces(a){const y=this._validateInsertSpaces(a);if(typeof y=="boolean"){if(this._insertSpaces===y)return;this._insertSpaces=y}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:y}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:O.TextEditorLineNumbersStyle.from(a)})))}assign(a){const y={};let h=!1;if(typeof a.tabSize<"u"){const r=this._validateTabSize(a.tabSize);r==="auto"?(h=!0,y.tabSize=r):typeof r=="number"&&this._tabSize!==r&&(this._tabSize=r,h=!0,y.tabSize=r)}if(typeof a.indentSize<"u"){const r=this._validateIndentSize(a.indentSize);r==="tabSize"?(h=!0,y.indentSize=r):typeof r=="number"&&this._originalIndentSize!==r&&(this._indentSize=r,this._originalIndentSize=r,h=!0,y.indentSize=r)}if(typeof a.insertSpaces<"u"){const r=this._validateInsertSpaces(a.insertSpaces);r==="auto"?(h=!0,y.insertSpaces=r):this._insertSpaces!==r&&(this._insertSpaces=r,h=!0,y.insertSpaces=r)}typeof a.cursorStyle<"u"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,h=!0,y.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,h=!0,y.lineNumbers=O.TextEditorLineNumbersStyle.from(a.lineNumbers)),h&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,y))}_warnOnError(a,y){y.catch(h=>{this._logService.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this._logService.warn(h)})}}e.ExtHostTextEditorOptions=o;class I{constructor(a,y,h,r,s,l,c,i){this.id=a,this._proxy=y,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=s,this._options=new o(this._proxy,this.id,l,h),this._visibleRanges=c,this._viewColumn=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new k.ReadonlyError("document")},get selection(){return n._selections&&n._selections[0]},set selection(t){if(!(t instanceof A.Selection))throw(0,k.illegalArgument)("selection");n._selections=[t],n._trySetSelection()},get selections(){return n._selections},set selections(t){if(!Array.isArray(t)||t.some(g=>!(g instanceof A.Selection)))throw(0,k.illegalArgument)("selections");n._selections=t,n._trySetSelection()},get visibleRanges(){return n._visibleRanges},set visibleRanges(t){throw new k.ReadonlyError("visibleRanges")},get options(){return n._options.value},set options(t){n._disposed||n._options.assign(t)},get viewColumn(){return n._viewColumn},set viewColumn(t){throw new k.ReadonlyError("viewColumn")},edit(t,g={undoStopBefore:!0,undoStopAfter:!0}){if(n._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new p(r.value,g);return t(u),n._applyEdit(u)},insertSnippet(t,g,u={undoStopBefore:!0,undoStopAfter:!0}){if(n._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let v;if(!g||Array.isArray(g)&&g.length===0)v=n._selections.map(m=>O.Range.from(m));else if(g instanceof A.Position){const{lineNumber:m,column:d}=O.Position.from(g);v=[{startLineNumber:m,startColumn:d,endLineNumber:m,endColumn:d}]}else if(g instanceof A.Range)v=[O.Range.from(g)];else{v=[];for(const m of g)if(m instanceof A.Range)v.push(O.Range.from(m));else{const{lineNumber:d,column:C}=O.Position.from(m);v.push({startLineNumber:d,startColumn:C,endLineNumber:d,endColumn:C})}}return y.$tryInsertSnippet(a,r.value.version,t.value,v,u)},setDecorations(t,g){const u=g.length===0;u&&!n._hasDecorationsForKey.has(t.key)||(u?n._hasDecorationsForKey.delete(t.key):n._hasDecorationsForKey.add(t.key),n._runOnProxy(()=>{if(O.isDecorationOptionsArr(g))return y.$trySetDecorations(a,t.key,O.fromRangeOrRangeWithMessage(g));{const v=new Array(4*g.length);for(let m=0,d=g.length;m<d;m++){const C=g[m];v[4*m]=C.start.line+1,v[4*m+1]=C.start.character+1,v[4*m+2]=C.end.line+1,v[4*m+3]=C.end.character+1}return y.$trySetDecorationsFast(a,t.key,v)}}))},revealRange(t,g){n._runOnProxy(()=>y.$tryRevealRange(a,O.Range.from(t),g||A.TextEditorRevealType.Default))},show(t){y.$tryShowEditor(a,O.ViewColumn.from(t))},hide(){y.$tryHideEditor(a)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,S.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,S.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,S.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,S.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,S.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(O.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const y=a.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const h=y.edits.map(s=>s.range);h.sort((s,l)=>s.end.line===l.end.line?s.end.character===l.end.character?s.start.line===l.start.line?s.start.character-l.start.character:s.start.line-l.start.line:s.end.character-l.end.character:s.end.line-l.end.line);for(let s=0,l=h.length-1;s<l;s++){const c=h[s].end;if(h[s+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=y.edits.map(s=>({range:O.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,r,{setEndOfLine:typeof y.setEndOfLine=="number"?O.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this._logService.warn(y),null))}}e.ExtHostTextEditor=I}),define(Le[57],Ne([1,0,61,6,4,2,3,5,123,16,127,8,11,28,15,40,48]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0,S=We(S),w=We(w);class l{constructor(n){this.value=n,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let c=class{constructor(n,t){this._extHostRpc=n,this._logService=t,this._activeEditorId=null,this._editors=new Map,this._documents=new y.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],g=[],u=[];if(n.removedDocuments)for(const v of n.removedDocuments){const m=O.URI.revive(v),d=this._documents.get(m);d?.unref()&&(this._documents.delete(m),t.push(d.value))}if(n.addedDocuments)for(const v of n.addedDocuments){const m=O.URI.revive(v.uri);let d=this._documents.get(m);if(d&&m.scheme!==h.Schemas.vscodeNotebookCell&&m.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);d||(d=new l(new p.ExtHostDocumentData(this._extHostRpc.getProxy(R.MainContext.MainThreadDocuments),m,v.lines,v.EOL,v.versionId,v.languageId,v.isDirty)),this._documents.set(m,d),g.push(d.value)),d.ref()}if(n.removedEditors)for(const v of n.removedEditors){const m=this._editors.get(v);this._editors.delete(v),m&&u.push(m)}if(n.addedEditors)for(const v of n.addedEditors){const m=O.URI.revive(v.documentUri);S.ok(this._documents.has(m),`document '${m}' does not exist`),S.ok(!this._editors.has(v.id),`editor '${v.id}' already exists!`);const d=this._documents.get(m).value,C=new I.ExtHostTextEditor(v.id,this._extHostRpc.getProxy(R.MainContext.MainThreadTextEditors),this._logService,new s.Lazy(()=>d.document),v.selections.map(w.Selection.to),v.options,v.visibleRanges.map(_=>w.Range.to(_)),typeof v.editorPosition=="number"?w.ViewColumn.to(v.editorPosition):void 0);this._editors.set(v.id,C)}n.newActiveEditor!==void 0&&(S.ok(n.newActiveEditor===null||this._editors.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this._activeEditorId=n.newActiveEditor),(0,P.dispose)(t),(0,P.dispose)(u),n.removedDocuments&&this._onDidRemoveDocuments.fire(t),n.addedDocuments&&this._onDidAddDocuments.fire(g),(n.removedEditors||n.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(v=>v.value)),n.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(n){return this._documents.get(n)?.value}allDocuments(){return r.Iterable.map(this._documents.values(),n=>n.value)}getEditor(n){return this._editors.get(n)}activeEditor(n){if(!this._activeEditorId)return;const t=this._editors.get(this._activeEditorId);return n?t:t?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=c,e.ExtHostDocumentsAndEditors=c=Ge([Ve(0,o.IExtHostRpcService),Ve(1,a.ILogService)],c),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Le[95],Ne([1,0,10,22,21,6,231,75,4,37,14,2,38,3,11,5,33,57,16,125,8,7,200,54,81,55,24]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n,t,g,u,v,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=e.IExtHostTesting=void 0,n=We(n);let C=0;const _=new WeakMap;e.IExtHostTesting=(0,y.createDecorator)("IExtHostTesting");let E=class extends p.Disposable{constructor(ce,Z,le,me){super(),this.logService=Z,this.commands=le,this.editors=me,this.resultsChangedEmitter=this._register(new O.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new O.Emitter),this.followupProviders=new Set,this.testFollowups=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=ce.getProxy(r.MainContext.MainThreadTesting),this.observer=new j(this.proxy),this.runTracker=new b(this.proxy,Z),le.registerArgumentProcessor({processArgument:oe=>{switch(oe?.$mid){case o.MarshalledId.TestItemContext:{const De=oe,Re=De.tests[De.tests.length-1].item.extId;return this.controllers.get(u.TestId.root(Re))?.collection.tree.get(Re)?.actual??(0,i.toItemFromContext)(oe)}case o.MarshalledId.TestMessageMenuArgs:{const{test:De,message:Re}=oe,Q=De.item.extId;return{test:this.controllers.get(u.TestId.root(Q))?.collection.tree.get(Q)?.actual??(0,i.toItemFromContext)({$mid:o.MarshalledId.TestItemContext,tests:[De]}),message:n.TestMessage.to(Re)}}default:return oe}}}),le.registerCommand(!1,"testing.getExplorerSelection",async()=>{const oe=await le.executeCommand(g.TestCommandId.GetExplorerSelection),De=Re=>{const Q=this.controllers.get(u.TestId.root(Re));if(Q)return u.TestId.isRoot(Re)?Q.controller:Q.collection.tree.get(Re)?.actual};return{include:oe?.include.map(De).filter(I.isDefined)||[],exclude:oe?.exclude.map(De).filter(I.isDefined)||[]}})}createTestController(ce,Z,le,me){if(this.controllers.has(Z))throw new Error(`Attempt to insert a duplicate controller with ID "${Z}"`);const oe=new p.DisposableStore,De=oe.add(new i.ExtHostTestItemCollection(Z,le,this.editors));De.root.label=le;const Re=new Map,Q=new Set,z=this.proxy,ne=()=>{let be=0;me&&(be|=m.TestControllerCapability.Refresh);const de=fe.relatedCodeProvider;return de&&(de?.provideRelatedTests&&(be|=m.TestControllerCapability.TestRelatedToCode),de?.provideRelatedCode&&(be|=m.TestControllerCapability.CodeRelatedToTest)),be},Ce={items:De.root.children,get label(){return le},set label(be){le=be,De.root.label=be,z.$updateController(Z,{label:le})},get refreshHandler(){return me},set refreshHandler(be){me=be,z.$updateController(Z,{capabilities:ne()})},get id(){return Z},get relatedCodeProvider(){return fe.relatedCodeProvider},set relatedCodeProvider(be){(0,d.checkProposedApiEnabled)(ce,"testRelatedCode"),fe.relatedCodeProvider=be,z.$updateController(Z,{capabilities:ne()})},createRunProfile:(be,de,X,J,ve,pe)=>{let Ae=(0,R.hash)(be);for(;Re.has(Ae);)Ae++;return new K(this.proxy,Re,Q,this.defaultProfilesChangedEmitter.event,Z,Ae,be,de,X,J,ve,pe)},createTestItem(be,de,X){return new i.TestItemImpl(Z,be,de,X)},createTestRun:(be,de,X=!0)=>this.runTracker.createTestRun(ce,Z,De,be,de,X),invalidateTestResults:be=>{if(be===void 0)this.proxy.$markTestRetired(void 0);else{const de=be instanceof Array?be:[be];this.proxy.$markTestRetired(de.map(X=>u.TestId.fromExtHostTestItem(X,Z).toString()))}},set resolveHandler(be){De.resolveHandler=be},get resolveHandler(){return De.resolveHandler},dispose:()=>{oe.dispose()}},fe={controller:Ce,collection:De,profiles:Re,extension:ce,activeProfiles:Q};return z.$registerTestController(Z,le,ne()),oe.add((0,p.toDisposable)(()=>z.$unregisterTestController(Z))),this.controllers.set(Z,fe),oe.add((0,p.toDisposable)(()=>this.controllers.delete(Z))),oe.add(De.onDidGenerateDiff(be=>z.$publishDiff(Z,be.map(m.TestsDiffOp.serialize)))),Ce}createTestObserver(){return this.observer.checkout()}async runTests(ce,Z=P.CancellationToken.None){const le=M(ce);if(!le)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const me=this.controllers.get(le.controllerId);if(!me)throw new Error("Controller not found");await this.proxy.$runTests({preserveFocus:ce.preserveFocus??!0,group:q[le.kind],targets:[{testIds:ce.include?.map(oe=>u.TestId.fromExtHostTestItem(oe,me.collection.root.id).toString())??[me.collection.root.id],profileId:le.profileId,controllerId:le.controllerId}],exclude:ce.exclude?.map(oe=>oe.id)},Z)}registerTestFollowupProvider(ce){return this.followupProviders.add(ce),{dispose:()=>{this.followupProviders.delete(ce)}}}async $getTestsRelatedToCode(ce,Z,le){const me=this.editors.getDocument(w.URI.revive(ce));if(!me)return[];const oe=n.Position.to(Z),De=[];return await Promise.all([...this.controllers.values()].map(async Re=>{let Q;try{Q=await Re.relatedCodeProvider?.provideRelatedTests?.(me.document,oe,le)}catch(z){le.isCancellationRequested||this.logService.warn(`Error thrown while providing related tests for ${Re.controller.label}`,z)}if(Q){for(const z of Q)De.push(u.TestId.fromExtHostTestItem(z,Re.controller.id).toString());Re.collection.flushDiff()}})),De}async $getCodeRelatedToTest(ce,Z){const le=this.controllers.get(u.TestId.root(ce));if(!le)return[];const me=le.collection.tree.get(ce);return me?(await le.relatedCodeProvider?.provideRelatedCode?.(me.actual,Z))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:ce}of this.controllers.values())ce.flushDiff();return Promise.resolve()}async $getCoverageDetails(ce,Z,le){return(await this.runTracker.getCoverageDetails(ce,Z,le))?.map(n.TestCoverage.fromDetails)}async $disposeRun(ce){this.runTracker.disposeTestRun(ce)}$configureRunProfile(ce,Z){this.controllers.get(ce)?.profiles.get(Z)?.configureHandler?.()}$setDefaultRunProfiles(ce){const Z=new Map;for(const[le,me]of Object.entries(ce)){const oe=this.controllers.get(le);if(!oe)continue;const De=new Map,Re=me.filter(z=>!oe.activeProfiles.has(z)),Q=[...oe.activeProfiles].filter(z=>!me.includes(z));for(const z of Re)De.set(z,!0),oe.activeProfiles.add(z);for(const z of Q)De.set(z,!1),oe.activeProfiles.delete(z);De.size&&Z.set(le,De)}this.defaultProfilesChangedEmitter.fire(Z)}async $refreshTests(ce,Z){await this.controllers.get(ce)?.controller.refreshHandler?.(Z)}$publishTestResults(ce){this.results=Object.freeze(ce.map(Z=>{const le=n.TestResults.to(Z);return _.set(le,Z.id),le}).concat(this.results).sort((Z,le)=>le.completedAt-Z.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(ce,Z){const le=this.controllers.get(u.TestId.fromString(ce).controllerId)?.collection;le&&(await le.expand(ce,Z<0?1/0:Z),le.flushDiff())}$acceptDiff(ce){this.observer.applyDiff(ce.map(Z=>m.TestsDiffOp.deserialize({asCanonicalUri:le=>le},Z)))}async $runControllerTests(ce,Z){return Promise.all(ce.map(le=>this.runControllerTestRequest(le,!1,Z)))}async $startContinuousRun(ce,Z){const le=new P.CancellationTokenSource(Z),me=await Promise.all(ce.map(oe=>this.runControllerTestRequest(oe,!0,le.token)));return!Z.isCancellationRequested&&!me.some(oe=>oe.error)&&await new Promise(oe=>Z.onCancellationRequested(oe)),le.dispose(!0),me}async $provideTestFollowups(ce,Z){const le=this.results.find(De=>_.get(De)===ce.resultId),me=le&&ae(u.TestId.fromString(ce.extId),le?.results);if(!me)return[];let oe=[];return await Promise.all([...this.followupProviders].map(async De=>{try{const Re=await De.provideFollowup(le,me,ce.taskIndex,ce.messageIndex,Z);Re&&(oe=oe.concat(Re))}catch(Re){this.logService.error("Error thrown while providing followup for test message",Re)}})),Z.isCancellationRequested?[]:oe.map(De=>{const Re=C++;return this.testFollowups.set(Re,De),{title:De.title,id:Re}})}$disposeTestFollowups(ce){for(const Z of ce)this.testFollowups.delete(Z)}$executeTestFollowup(ce){const Z=this.testFollowups.get(ce);return Z?this.commands.executeCommand(Z.command,...Z.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(ce){ce===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(ce)}getMetadataForRun(ce){for(const Z of this.runTracker.trackers){const le=Z.getTaskIdForRun(ce);if(le)return{taskId:le,runId:Z.id}}}async runControllerTestRequest(ce,Z,le){const me=this.controllers.get(ce.controllerId);if(!me)return{};const{collection:oe,profiles:De,extension:Re}=me,Q=De.get(ce.profileId);if(!Q)return{};const z=ce.testIds.map(be=>oe.tree.get(be)).filter(I.isDefined),ne=ce.excludeExtIds.map(be=>me.collection.tree.get(be)).filter(I.isDefined).filter(be=>z.some(de=>de.fullId.compare(be.fullId)===u.TestPosition.IsChild));if(!z.length)return{};const Ce=new t.TestRunRequest(z.some(be=>be.actual instanceof i.TestItemRootImpl)?void 0:z.map(be=>be.actual),ne.map(be=>be.actual),Q,Z),fe=(0,m.isStartControllerTests)(ce)&&this.runTracker.prepareForMainThreadTestRun(Re,Ce,L.fromInternal(ce,me.collection),Q,le);try{return await Q.runHandler(Ce,le),{}}catch(be){return{error:String(be)}}finally{fe&&fe.hasRunningTasks&&!le.isCancellationRequested&&await O.Event.toPromise(fe.onEnd)}}};e.ExtHostTesting=E,e.ExtHostTesting=E=Ge([Ve(0,c.IExtHostRpcService),Ve(1,h.ILogService),Ve(2,s.IExtHostCommands),Ve(3,l.IExtHostDocumentsAndEditors)],E);const T=1e4;var D;(function(Ee){Ee[Ee.Running=0]="Running",Ee[Ee.Cancelling=1]="Cancelling",Ee[Ee.Ended=2]="Ended"})(D||(D={}));class f extends p.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(ce,Z,le,me,oe,De){super(),this.dto=ce,this.proxy=Z,this.logService=le,this.profile=me,this.extension=oe,this.state=D.Running,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new O.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new P.CancellationTokenSource(De));const Re=this._register(new S.RunOnceScheduler(()=>this.forciblyEndTasks(),T));this._register(this.cts.token.onCancellationRequested(()=>Re.schedule()));const Q=new O.Emitter;this.onDidDispose=Q.event,this._register((0,p.toDisposable)(()=>{Q.fire(),Q.dispose()}))}getTaskIdForRun(ce){for(const[Z,{run:le}]of this.tasks)if(le===ce)return Z}cancel(){this.state===D.Running?(this.cts.cancel(),this.state=D.Cancelling):this.state===D.Cancelling&&this.forciblyEndTasks()}async getCoverageDetails(ce,Z,le){const[,me]=u.TestId.fromString(ce).path,oe=this.publishedCoverage.get(ce);if(!oe)return[];const{report:De,extIds:Re}=oe,Q=this.tasks.get(me);if(!Q)throw new Error("unreachable: run task was not found");let z;if(Z&&De instanceof t.FileCoverage){const Ce=Re.indexOf(Z);if(Ce===-1)return[];z=De.fromTests[Ce]}return await(z?this.profile?.loadDetailedCoverageForTest?.(Q.run,De,z,le):this.profile?.loadDetailedCoverage?.(Q.run,De,le))??[]}createRun(ce){const Z=this.dto.id,le=this.dto.controllerId,me=(0,a.generateUuid)(),oe=z=>(ne,...Ce)=>{if(Re){this.logService.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.ensureTestIsKnown(ne),z(ne,...Ce)},De=(z,ne)=>{const Ce=ne instanceof Array?ne.map(n.TestMessage.from):[n.TestMessage.from(ne)];if(z.uri&&z.range){const fe={range:n.Range.from(z.range),uri:z.uri};for(const be of Ce)be.location=be.location||fe}this.proxy.$appendTestMessagesInRun(Z,me,u.TestId.fromExtHostTestItem(z,le).toString(),Ce)};let Re=!1;const Q={isPersisted:this.dto.isPersisted,token:this.cts.token,name:ce,onDidDispose:this.onDidDispose,addCoverage:z=>{if(Re)return;const ne=z instanceof t.FileCoverage?z.fromTests:[];if(ne.length){(0,d.checkProposedApiEnabled)(this.extension,"attributableCoverage");for(const be of ne)this.ensureTestIsKnown(be)}const Ce=z.uri.toString(),fe=new u.TestId([Z,me,Ce]).toString();this.publishedCoverage.set(fe,{report:z,extIds:ne.map(be=>u.TestId.fromExtHostTestItem(be,le).toString())}),this.proxy.$appendCoverage(Z,me,n.TestCoverage.fromFile(le,fe,z))},enqueued:oe(z=>{this.proxy.$updateTestStateInRun(Z,me,u.TestId.fromExtHostTestItem(z,le).toString(),m.TestResultState.Queued)}),skipped:oe(z=>{this.proxy.$updateTestStateInRun(Z,me,u.TestId.fromExtHostTestItem(z,le).toString(),m.TestResultState.Skipped)}),started:oe(z=>{this.proxy.$updateTestStateInRun(Z,me,u.TestId.fromExtHostTestItem(z,le).toString(),m.TestResultState.Running)}),errored:oe((z,ne,Ce)=>{De(z,ne),this.proxy.$updateTestStateInRun(Z,me,u.TestId.fromExtHostTestItem(z,le).toString(),m.TestResultState.Errored,Ce)}),failed:oe((z,ne,Ce)=>{De(z,ne),this.proxy.$updateTestStateInRun(Z,me,u.TestId.fromExtHostTestItem(z,le).toString(),m.TestResultState.Failed,Ce)}),passed:oe((z,ne)=>{this.proxy.$updateTestStateInRun(Z,me,u.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),m.TestResultState.Passed,ne)}),appendOutput:(z,ne,Ce)=>{Re||(Ce&&this.ensureTestIsKnown(Ce),this.proxy.$appendOutputToRun(Z,me,k.VSBuffer.fromString(z),ne&&n.location.from(ne),Ce&&u.TestId.fromExtHostTestItem(Ce,le).toString()))},end:()=>{Re||(Re=!0,this.proxy.$finishedTestRunTask(Z,me),--this.running||this.markEnded())}};return this.running++,this.tasks.set(me,{run:Q}),this.proxy.$startedTestRunTask(Z,{id:me,ctrlId:this.dto.controllerId,name:ce,running:!0}),Q}forciblyEndTasks(){for(const{run:ce}of this.tasks.values())ce.end()}markEnded(){this.state!==D.Ended&&(this.state=D.Ended,this.endEmitter.fire())}ensureTestIsKnown(ce){if(!(ce instanceof i.TestItemImpl))throw new v.InvalidTestItemError(ce.id);if(this.sharedTestIds.has(u.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString()))return;const Z=[],le=this.dto.colllection.root;for(;;){const me=n.TestItem.from(ce);if(Z.unshift(me),this.sharedTestIds.has(me.extId)||(this.sharedTestIds.add(me.extId),ce===le))break;ce=ce.parent||le}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,Z)}dispose(){this.markEnded(),super.dispose()}}class b{get trackers(){return this.tracked.values()}constructor(ce,Z){this.proxy=ce,this.logService=Z,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(ce,Z,le){const me=u.TestId.root(ce);return this.trackedById.get(me)?.getCoverageDetails(ce,Z,le)||[]}disposeTestRun(ce){this.trackedById.get(ce)?.dispose(),this.trackedById.delete(ce);for(const[Z,{id:le}]of this.tracked)le===ce&&this.tracked.delete(Z)}prepareForMainThreadTestRun(ce,Z,le,me,oe){return this.getTracker(Z,le,me,ce,oe)}cancelRunById(ce){this.trackedById.get(ce)?.cancel()}cancelAllRuns(){for(const ce of this.tracked.values())ce.cancel()}createTestRun(ce,Z,le,me,oe,De){const Re=this.tracked.get(me);if(Re)return Re.createRun(oe);const Q=L.fromPublic(Z,le,me,De),z=M(me);this.proxy.$startedExtensionTestRun({controllerId:Z,continuous:!!me.continuous,profile:z&&{group:q[z.kind],id:z.profileId},exclude:me.exclude?.map(Ce=>u.TestId.fromExtHostTestItem(Ce,le.root.id).toString())??[],id:Q.id,include:me.include?.map(Ce=>u.TestId.fromExtHostTestItem(Ce,le.root.id).toString())??[le.root.id],preserveFocus:me.preserveFocus??!0,persist:De});const ne=this.getTracker(me,Q,me.profile,ce);return O.Event.once(ne.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(Q.id)}),ne.createRun(oe)}getTracker(ce,Z,le,me,oe){const De=new f(Z,this.proxy,this.logService,le,me,oe);return this.tracked.set(ce,De),this.trackedById.set(De.id,De),De}}e.TestRunCoordinator=b;const M=Ee=>{if(Ee.profile){if(!(Ee.profile instanceof K))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return Ee.profile}};class L{static fromPublic(ce,Z,le,me){return new L(ce,(0,a.generateUuid)(),me,Z)}static fromInternal(ce,Z){return new L(ce.controllerId,ce.runId,!0,Z)}constructor(ce,Z,le,me){this.controllerId=ce,this.id=Z,this.isPersisted=le,this.colllection=me}}e.TestRunDto=L;class N{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(ce){this.emitter=ce,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(ce){this.added.add(ce)}update(ce){Object.assign(ce.revived,n.TestItem.toPlain(ce.item)),this.added.has(ce)||this.updated.add(ce)}remove(ce){if(this.added.has(ce)){this.added.delete(ce);return}this.updated.delete(ce);const Z=u.TestId.parentId(ce.item.extId);if(Z&&this.alreadyRemoved.has(Z.toString())){this.alreadyRemoved.add(ce.item.extId);return}this.removed.add(ce)}getChangeEvent(){const{added:ce,updated:Z,removed:le}=this;return{get added(){return[...ce].map(me=>me.revived)},get updated(){return[...Z].map(me=>me.revived)},get removed(){return[...le].map(me=>me.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class W extends m.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new O.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(ce){return this.items.get(ce)}getMirroredTestDataByReference(ce){return this.items.get(ce.id)}createItem(ce,Z){return{...ce,revived:n.TestItem.toPlain(ce.item),depth:Z?Z.depth+1:0,children:new Set}}createChangeCollector(){return new N(this.changeEmitter)}}class j{constructor(ce){this.proxy=ce}checkout(){this.current||(this.current=this.createObserverData());const ce=this.current;return ce.observers++,{onDidChangeTest:ce.tests.onDidChangeTests,get tests(){return[...ce.tests.rootTests].map(Z=>Z.revived)},dispose:(0,A.createSingleCallFunction)(()=>{--ce.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(ce){return this.current?.tests.getMirroredTestDataByReference(ce)}applyDiff(ce){this.current?.tests.apply(ce)}createObserverData(){const ce=new W({asCanonicalUri:Z=>Z});return this.proxy.$subscribeToDiffs(),{observers:0,tests:ce}}}const $=(Ee,ce,Z,le)=>{Z?Object.assign(Z,le):ce.$updateTestRunConfig(Ee.controllerId,Ee.profileId,le)};class K{#e;#t;#i;#n;#s;get label(){return this._label}set label(ce){ce!==this._label&&(this._label=ce,$(this,this.#e,this.#n,{label:ce}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(ce){ce!==this._supportsContinuousRun&&(this._supportsContinuousRun=ce,$(this,this.#e,this.#n,{supportsContinuousRun:ce}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(ce){ce!==this.isDefault&&(ce?this.#t.add(this.profileId):this.#t.delete(this.profileId),$(this,this.#e,this.#n,{isDefault:ce}))}get tag(){return this._tag}set tag(ce){ce?.id!==this._tag?.id&&(this._tag=ce,$(this,this.#e,this.#n,{tag:ce?n.TestTag.namespace(this.controllerId,ce.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(ce){ce!==this._configureHandler&&(this._configureHandler=ce,$(this,this.#e,this.#n,{hasConfigurationHandler:!!ce}))}get onDidChangeDefault(){return O.Event.chain(this.#i,ce=>ce.map(Z=>Z.get(this.controllerId)?.get(this.profileId)).filter(I.isDefined))}constructor(ce,Z,le,me,oe,De,Re,Q,z,ne=!1,Ce=void 0,fe=!1){this.controllerId=oe,this.profileId=De,this._label=Re,this.kind=Q,this.runHandler=z,this._tag=Ce,this._supportsContinuousRun=fe,this.#e=ce,this.#s=Z,this.#t=le,this.#i=me,Z.set(De,this);const be=q[Q];if(typeof be!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);ne&&le.add(De),this.#n={profileId:De,controllerId:oe,tag:Ce?n.TestTag.namespace(this.controllerId,Ce.id):null,label:Re,group:be,isDefault:ne,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=K;const q={[t.TestRunProfileKind.Coverage]:m.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:m.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:m.TestRunProfileBitset.Run};function ae(Ee,ce){for(let Z=0;Z<Ee.path.length;Z++){const le=ce.find(me=>me.id===Ee.path[Z]);if(!le)return;if(Z===Ee.path.length-1)return le;ce=le.children}}}),define(Le[259],Ne([1,0,17,6,4,5,127,8,7]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0,S=We(S),R=We(R);class o extends P.Disposable{constructor(w,a){super(),this._extHostDocumentsAndEditors=a,this._onDidChangeTextEditorSelection=new k.Emitter,this._onDidChangeTextEditorOptions=new k.Emitter,this._onDidChangeTextEditorVisibleRanges=new k.Emitter,this._onDidChangeTextEditorViewColumn=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=w.getProxy(O.MainContext.MainThreadTextEditors),this._register(this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(y=>this._onDidChangeVisibleTextEditors.fire(y))),this._register(this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(y=>this._onDidChangeActiveTextEditor.fire(y)))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(w){const a=this._extHostDocumentsAndEditors.allEditors();return w?a:a.map(y=>y.value)}async showTextDocument(w,a,y){let h;typeof a=="number"?h={position:R.ViewColumn.from(a),preserveFocus:y}:typeof a=="object"?h={position:R.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?R.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:h={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(w.uri,h),s=r&&this._extHostDocumentsAndEditors.getEditor(r);if(s)return s.value;throw r?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}createTextEditorDecorationType(w,a){return new A.TextEditorDecorationType(this._proxy,w,a).value}$acceptEditorPropertiesChanged(w,a){const y=this._extHostDocumentsAndEditors.getEditor(w);if(!y)throw new Error("unknown text editor");if(a.options&&y._acceptOptions(a.options),a.selections){const h=a.selections.selections.map(R.Selection.to);y._acceptSelections(h)}if(a.visibleRanges){const h=S.coalesce(a.visibleRanges.map(R.Range.to));y._acceptVisibleRanges(h)}if(a.options&&this._onDidChangeTextEditorOptions.fire({textEditor:y.value,options:{...a.options,lineNumbers:R.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const h=p.TextEditorSelectionChangeKind.fromValue(a.selections.source),r=a.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:y.value,selections:r,kind:h})}if(a.visibleRanges){const h=S.coalesce(a.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:y.value,visibleRanges:h})}}$acceptEditorPositionData(w){for(const a in w){const y=this._extHostDocumentsAndEditors.getEditor(a);if(!y)throw new Error("Unknown text editor");const h=R.ViewColumn.to(w[a]);y.value.viewColumn!==h&&(y._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:y.value,viewColumn:h}))}}getDiffInformation(w){return Promise.resolve(this._proxy.$getDiffInformation(w))}}e.ExtHostEditors=o}),define(Le[260],Ne([1,0,2,3,5,4,7,8,18,37,14]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class w{constructor(h,r){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=h.getProxy(P.MainContext.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(s,l)=>{if(s&&s.$mid===o.MarshalledId.TimelineActionContext)if(this._providers.get(s.source)&&p.ExtensionIdentifier.equals(l,this._providers.get(s.source)?.extension)){const c=s.uri===void 0?void 0:S.URI.revive(s.uri);return this._itemsBySourceAndUriMap.get(s.source)?.get(a(c))?.get(s.handle)}else return;return s}})}async $getTimeline(h,r,s,l){return this._providers.get(h)?.provider.provideTimeline(S.URI.revive(r),s,l)}registerTimelineProvider(h,r,s,l){const c=new O.DisposableStore,i=this.convertTimelineItem(r.id,l,c).bind(this);let n;r.onDidChange&&(n=r.onDidChange(g=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:r.id}),this));const t=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...r,scheme:h,onDidChange:void 0,async provideTimeline(g,u,v){u?.resetCache&&(c.clear(),t.get(r.id)?.clear());const m=await r.provideTimeline(g,u,v);if(m==null)return;const d=i(g,u);return{...m,source:r.id,items:m.items.map(d)}},dispose(){for(const g of t.values())g.get(r.id)?.clear();n?.dispose(),c.dispose()}},s)}convertTimelineItem(h,r,s){return(l,c)=>{let i;if(c?.cacheResults){let n=this._itemsBySourceAndUriMap.get(h);n===void 0&&(n=new Map,this._itemsBySourceAndUriMap.set(h,n));const t=a(l);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...g}=n,u=`${h}|${n.id??n.timestamp}`;i?.set(u,n);let v,m,d;n.iconPath&&(t instanceof A.ThemeIcon?d={id:t.id,color:t.color}:S.URI.isUri(t)?(v=t,m=t):{light:v,dark:m}=t);let C;return A.MarkdownString.isMarkdownString(g.tooltip)?C=R.MarkdownString.from(g.tooltip):(0,I.isString)(g.tooltip)?C=g.tooltip:A.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),C=R.MarkdownString.from(g.detail)):(0,I.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),C=g.detail),{...g,id:g.id??void 0,handle:u,source:h,command:n.command?r.toInternal(n.command,s):void 0,icon:v,iconDark:m,themeIcon:d,tooltip:C,accessibilityInformation:n.accessibilityInformation}}}}registerTimelineProviderCore(h,r){if(this._providers.get(h.id))throw new Error(`Timeline Provider ${h.id} already exists.`);return this._proxy.$registerTimelineProvider({id:h.id,label:h.label,scheme:h.scheme}),this._providers.set(h.id,{provider:h,extension:r}),(0,O.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(h.id)?.clear();this._providers.delete(h.id),this._proxy.$unregisterTimelineProvider(h.id),h.dispose()})}}e.ExtHostTimeline=w;function a(y){return y?.toString()}}),define(Le[261],Ne([1,0,9,23,2,6,4,192,10,7,14,17,8,59,21,163,24]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0,o=We(o);function l(n,t){if((0,I.isString)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let g;return Array.isArray(n.highlights)&&(g=n.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),g=g.length?g:void 0),{label:n.label,highlights:g}}}class c extends A.Disposable{constructor(t,g,u){super(),this._proxy=t,this.commands=g,this.logService=u,this.treeViews=new Map,this.treeDragAndDropService=new r.TreeViewsDnDService;function v(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:m=>v(m)?this.convertArgument(m):Array.isArray(m)&&m.length>0?m.map(d=>v(d)?this.convertArgument(d):d):m})}registerTreeDataProvider(t,g,u){const v=this.createTreeView(t,{treeDataProvider:g},u);return{dispose:()=>v.dispose()}}createTreeView(t,g,u){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const v=g.dragAndDropController?.dropMimeTypes??[],m=g.dragAndDropController?.dragMimeTypes??[],d=!!g.dragAndDropController?.handleDrag,C=!!g.dragAndDropController?.handleDrop,_=this.createExtHostTreeView(t,g,u),E={showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:v,dragMimeTypes:m,hasHandleDrag:d,hasHandleDrop:C,manuallyManageCheckboxes:!!g.manageCheckboxStateManually},T=this._proxy.$registerTreeViewDataProvider(t,E),D={get onDidCollapseElement(){return _.onDidCollapseElement},get onDidExpandElement(){return _.onDidExpandElement},get selection(){return _.selectedElements},get onDidChangeSelection(){return _.onDidChangeSelection},get activeItem(){return(0,s.checkProposedApiEnabled)(u,"treeViewActiveItem"),_.focusedElement},get onDidChangeActiveItem(){return(0,s.checkProposedApiEnabled)(u,"treeViewActiveItem"),_.onDidChangeActiveItem},get visible(){return _.visible},get onDidChangeVisibility(){return _.onDidChangeVisibility},get onDidChangeCheckboxState(){return _.onDidChangeCheckboxState},get message(){return _.message},set message(f){(0,y.isMarkdownString)(f)&&(0,s.checkProposedApiEnabled)(u,"treeViewMarkdownMessage"),_.message=f},get title(){return _.title},set title(f){_.title=f},get description(){return _.description},set description(f){_.description=f},get badge(){return _.badge},set badge(f){f!==void 0&&o.ViewBadge.isViewBadge(f)?_.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(_.badge=void 0)},reveal:(f,b)=>_.reveal(f,b),dispose:async()=>{await T,this.treeViews.delete(t),_.dispose()}};return this._register(D),D}$getChildren(t,g){const u=this.treeViews.get(t);return u?u.getChildren(g):Promise.reject(new R.NoTreeViewError(t))}async $handleDrop(t,g,u,v,m,d,C,_){const E=this.treeViews.get(t);if(!E)return Promise.reject(new R.NoTreeViewError(t));const T=a.DataTransfer.toDataTransfer(u,async D=>(await this._proxy.$resolveDropFileData(t,g,D)).buffer);return C===t&&_&&await this.addAdditionalTransferItems(T,E,_,m,d),E.onDrop(T,v,m)}async addAdditionalTransferItems(t,g,u,v,m){const d=this.treeDragAndDropService.removeDragOperationTransfer(m);if(d)(await d)?.forEach((C,_)=>{C&&t.set(_,C)});else if(m&&g.handleDrag){const C=g.handleDrag(u,t,v);this.treeDragAndDropService.addDragOperationTransfer(m,C),await C}return t}async $handleDrag(t,g,u,v){const m=this.treeViews.get(t);if(!m)return Promise.reject(new R.NoTreeViewError(t));const d=await this.addAdditionalTransferItems(new o.DataTransfer,m,g,v,u);if(!(!d||v.isCancellationRequested))return a.DataTransfer.from(d)}async $hasResolve(t){const g=this.treeViews.get(t);if(!g)throw new R.NoTreeViewError(t);return g.hasResolve}$resolve(t,g,u){const v=this.treeViews.get(t);if(!v)throw new R.NoTreeViewError(t);return v.resolveTreeItem(g,u)}$setExpanded(t,g,u){const v=this.treeViews.get(t);if(!v)throw new R.NoTreeViewError(t);v.setExpanded(g,u)}$setSelectionAndFocus(t,g,u){const v=this.treeViews.get(t);if(!v)throw new R.NoTreeViewError(t);v.setSelectionAndFocus(g,u)}$setVisible(t,g){const u=this.treeViews.get(t);if(!u){if(!g)return;throw new R.NoTreeViewError(t)}u.setVisible(g)}$changeCheckboxState(t,g){const u=this.treeViews.get(t);if(!u)throw new R.NoTreeViewError(t);u.setCheckboxState(g)}createExtHostTreeView(t,g,u){const v=this._register(new i(t,g,this._proxy,this.commands.converter,this.logService,u));return this.treeViews.set(t,v),v}convertArgument(t){const g=this.treeViews.get(t.$treeViewId);return g&&"$treeItemHandle"in t?g.getExtensionElement(t.$treeItemHandle):g&&"$focusedTreeItem"in t&&t.$focusedTreeItem?g.focusedElement:null}}e.ExtHostTreeViews=c;class i extends A.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.isUndefinedOrNull)(t))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(t,g,u,v,m,d){if(super(),this.viewId=t,this.proxy=u,this.commands=v,this.logService=m,this.extension=d,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new O.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new O.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new O.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new O.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new O.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new O.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,d.contributes&&d.contributes.views)for(const T in d.contributes.views)for(const D of d.contributes.views[T])D.id===t&&(this._title=D.name);this.dataProvider=g.treeDataProvider,this.dndController=g.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(T=>{Array.isArray(T)&&T.length===0||this._onDidChangeData.fire({message:!1,element:T})}));let C,_;const E=O.Event.debounce(this._onDidChangeData.event,(T,D)=>(T||(T={message:!1,elements:[]}),D.element!==!1&&(C||(C=new Promise(f=>_=f),this.refreshPromise=this.refreshPromise.then(()=>C)),Array.isArray(D.element)?T.elements.push(...D.element):T.elements.push(D.element)),D.message&&(T.message=!0),T),200,!0);this._register(E(({message:T,elements:D})=>{D.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=_;return C=null,this.refresh(D).then(()=>f())})),T&&this.proxy.$setMessage(this.viewId,a.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(t){const g=t?this.getExtensionElement(t):void 0;if(t&&!g)return this.logService.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let u=this.getChildrenNodes(t);return u||(u=await this.fetchChildrenNodes(g)),u?u.map(v=>v.item):void 0}getExtensionElement(t){return this.elements.get(t)}reveal(t,g){g=g||{select:!0,focus:!1};const u=(0,I.isUndefinedOrNull)(g.select)?!0:g.select,v=(0,I.isUndefinedOrNull)(g.focus)?!1:g.focus,m=(0,I.isUndefinedOrNull)(g.expand)?!1:g.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.refreshPromise.then(()=>this.resolveUnknownParentChain(t)).then(d=>this.resolveTreeNode(t,d[d.length-1]).then(C=>this.proxy.$reveal(this.viewId,{item:C.item,parentChain:d.map(_=>_.item)},{select:u,focus:v,expand:m})),d=>this.logService.error(d)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:v,expand:m})}get message(){return this._message}set message(t){this._message=t,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(t){this._title=t,this.proxy.$setTitle(this.viewId,t,this._description)}get description(){return this._description}set description(t){this._description=t,this.proxy.$setTitle(this.viewId,this._title,t)}get badge(){return this._badge}set badge(t){this._badge?.value===t?.value&&this._badge?.tooltip===t?.tooltip||(this._badge=a.ViewBadge.from(t),this.proxy.$setBadge(this.viewId,t))}setExpanded(t,g){const u=this.getExtensionElement(t);u&&(g?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelectionAndFocus(t,g){const u=!(0,w.equals)(this._selectedHandles,t);this._selectedHandles=t;const v=this._focusedHandle!==g;this._focusedHandle=g,u&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),v&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this._visible&&(this._visible=t,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(t){const g=(await Promise.all(t.map(async u=>{const v=this.getExtensionElement(u.treeItemHandle);return v?{extensionItem:v,treeItem:await this.dataProvider.getTreeItem(v),newState:u.newState?o.TreeItemCheckboxState.Checked:o.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);g.forEach(u=>{u.treeItem.checkboxState=u.newState?o.TreeItemCheckboxState.Checked:o.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:g.map(u=>[u.extensionItem,u.newState])})}async handleDrag(t,g,u){const v=[];for(const m of t){const d=this.getExtensionElement(m);d&&v.push(d)}if(!(!this.dndController?.handleDrag||v.length===0))return await this.dndController.handleDrag(v,g,u),g}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(t,g,u){const v=g?this.getExtensionElement(g):void 0;if(!(!v&&g||!this.dndController?.handleDrop))return(0,p.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(v,t,u):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(t,g){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(t);if(u){const v=this.nodes.get(u);if(v){const m=await this.dataProvider.resolveTreeItem(v.extensionItem,u,g)??v.extensionItem;return this.validateTreeItem(m),v.item.tooltip=this.getTooltip(m.tooltip),v.item.command=this.getCommand(v.disposableStore,m.command),v.item}}}resolveUnknownParentChain(t){return this.resolveParent(t).then(g=>g?this.resolveUnknownParentChain(g).then(u=>this.resolveTreeNode(g,u[u.length-1]).then(v=>(u.push(v),u))):Promise.resolve([]))}resolveParent(t){const g=this.nodes.get(t);return g?Promise.resolve(g.parent?this.elements.get(g.parent.item.handle):void 0):(0,p.asPromise)(()=>this.dataProvider.getParent(t))}resolveTreeNode(t,g){const u=this.nodes.get(t);return u?Promise.resolve(u):(0,p.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(v=>this.createHandle(t,v,g,!0)).then(v=>this.getChildren(g?g.item.handle:void 0).then(()=>{const m=this.getExtensionElement(v);if(m){const d=this.nodes.get(m);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${v} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(t){if(t){let g;if(typeof t=="string"){const u=this.getExtensionElement(t);g=u?this.nodes.get(u):void 0}else g=t;return g&&g.children||void 0}return this.roots}async fetchChildrenNodes(t){this.clearChildren(t);const g=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=t?this.nodes.get(t):void 0,v=await this.dataProvider.getChildren(t);if(g.token.isCancellationRequested)return;const m=(0,w.coalesce)(v||[]),d=await Promise.all((0,w.coalesce)(m).map(_=>this.dataProvider.getTreeItem(_)));if(g.token.isCancellationRequested)return;const C=d.map((_,E)=>_?this.createAndRegisterTreeNode(m[E],_,u):null);return(0,w.coalesce)(C)}finally{g.dispose()}}refresh(t){if(t.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(t);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(t){const g=new Set,u=t.map(m=>this.nodes.get(m));for(const m of u)if(m&&!g.has(m.item.handle)){let d=m;for(;d&&d.parent&&u.findIndex(C=>d&&d.parent&&C&&C.item.handle===d.parent.item.handle)===-1;){const C=this.elements.get(d.parent.item.handle);d=C?this.nodes.get(C):void 0}d&&!d.parent&&g.add(m.item.handle)}const v=[];return g.forEach(m=>{const d=this.elements.get(m);if(d){const C=this.nodes.get(d);C&&(!C.parent||!g.has(C.parent.item.handle))&&v.push(m)}}),v}refreshHandles(t){const g={};return Promise.all(t.map(u=>this.refreshNode(u).then(v=>{v&&(g[u]=v.item)}))).then(()=>Object.keys(g).length?this.proxy.$refresh(this.viewId,g):void 0)}refreshNode(t){const g=this.getExtensionElement(t);if(g){const u=this.nodes.get(g);if(u)return this.clearChildren(g),(0,p.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(v=>{if(v){const m=this.createTreeNode(g,v,u.parent);return this.updateNodeCache(g,m,u,u.parent),u.dispose(),m}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(t,g,u){const v=this.createTreeNode(t,g,u);if(g.id&&this.elements.has(v.item.handle))throw new Error((0,S.localize)(10823,null,g.id));return this.addNodeToCache(t,v),this.addNodeToParentCache(v,u),v}getTooltip(t){return o.MarkdownString.isMarkdownString(t)?a.MarkdownString.from(t):t}getCommand(t,g){return g?{...this.commands.toInternal(g,t),originalId:g.command}:void 0}getCheckbox(t){if(t.checkboxState===void 0)return;let g,u,v;return typeof t.checkboxState=="number"?g=t.checkboxState:(g=t.checkboxState.state,u=t.checkboxState.tooltip,v=t.checkboxState.accessibilityInformation),{isChecked:g===o.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:v}}validateTreeItem(t){if(!o.TreeItem.isTreeItem(t,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(t,g,u){this.validateTreeItem(g);const v=this._register(new A.DisposableStore),m=this.createHandle(t,g,u),d=this.getLightIconPath(g);return{item:{handle:m,parentHandle:u?u.item.handle:void 0,label:l(g.label,this.extension),description:g.description,resourceUri:g.resourceUri,tooltip:this.getTooltip(g.tooltip),command:this.getCommand(v,g.command),contextValue:g.contextValue,icon:d,iconDark:this.getDarkIconPath(g)||d,themeIcon:this.getThemeIcon(g),collapsibleState:(0,I.isUndefinedOrNull)(g.collapsibleState)?o.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.getCheckbox(g)},extensionItem:g,parent:u,children:void 0,disposableStore:v,dispose(){v.dispose()}}}getThemeIcon(t){return t.iconPath instanceof o.ThemeIcon?t.iconPath:void 0}createHandle(t,{id:g,label:u,resourceUri:v},m,d){if(g)return`${i.ID_HANDLE_PREFIX}/${g}`;const C=l(u,this.extension),_=m?m.item.handle:i.LABEL_HANDLE_PREFIX;let E=C?C.label:v?(0,k.basename)(v):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const T=this.nodes.has(t)?this.nodes.get(t).item.handle:void 0,D=this.getChildrenNodes(m)||[];let f,b=0;do{if(f=`${_}/${b}:${E}`,d||!this.elements.has(f)||T===f)break;b++}while(b<=D.length);return f}getLightIconPath(t){if(t.iconPath&&!(t.iconPath instanceof o.ThemeIcon))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.getIconPath(t.iconPath):this.getIconPath(t.iconPath.light)}getDarkIconPath(t){if(t.iconPath&&!(t.iconPath instanceof o.ThemeIcon)&&t.iconPath.dark)return this.getIconPath(t.iconPath.dark)}getIconPath(t){return P.URI.isUri(t)?t:P.URI.file(t)}addNodeToCache(t,g){this.elements.set(g.item.handle,t),this.nodes.set(t,g)}updateNodeCache(t,g,u,v){this.elements.delete(g.item.handle),this.nodes.delete(t),g.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(t,g);const m=this.getChildrenNodes(v)||[],d=m.filter(C=>C.item.handle===u.item.handle)[0];d&&m.splice(m.indexOf(d),1,g)}addNodeToParentCache(t,g){g?(g.children||(g.children=[]),g.children.push(t)):(this.roots||(this.roots=[]),this.roots.push(t))}clearChildren(t){if(t){const g=this.nodes.get(t);if(g){if(g.children)for(const u of g.children){const v=this.elements.get(u.item.handle);v&&this.clear(v)}g.children=void 0}}else this.clearAll()}clear(t){const g=this.nodes.get(t);if(g){if(g.children)for(const u of g.children){const v=this.elements.get(u.item.handle);v&&this.clear(v)}this.nodes.delete(t),this.elements.delete(g.item.handle),g.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(t=>t.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Le[262],Ne([1,0,6,4,2,38,8,67,5,7]),function(Se,e,S,k,P,O,A,R,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0,A=We(A),p=We(p),o=We(o);class I extends k.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;#c;#u;#h;#d;constructor(h,r,s,l){super(),this.#o=void 0,this.#l=!0,this.#u=!1,this.#h=this._register(new S.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new S.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=h,this.#t=r,this.#n=s,this.#i=l.viewType,this.#s=l.panelOptions,this.#o=l.viewColumn,this.#r=l.title,this.#c=l.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(h){this.assertNotDisposed(),this.#r!==h&&(this.#r=h,this.#t.$setTitle(this.#e,h))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(h){this.assertNotDisposed(),this.#a!==h&&(this.#a=h,this.#t.$setIconPath(this.#e,P.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#c}get visible(){return this.assertNotDisposed(),this.#l}_updateViewState(h){this.#u||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(this.#c=h.active,this.#l=h.visible,this.#o=h.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(h,r){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof h>"u"?void 0:A.ViewColumn.from(h),preserveFocus:!!r})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class w extends k.Disposable{static newHandle(){return(0,O.generateUuid)()}constructor(h,r,s){super(),this.webviews=r,this.workspace=s,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(p.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(h=>h.dispose()),this._webviewPanels.clear()}createWebviewPanel(h,r,s,l,c={}){const i=typeof l=="object"?l.viewColumn:l,n={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof l=="object"&&!!l.preserveFocus},t=(0,R.shouldSerializeBuffersForPostMessage)(h),g=w.newHandle();this._proxy.$createWebviewPanel((0,R.toExtensionData)(h),g,r,{title:s,panelOptions:a(c),webviewOptions:(0,R.serializeWebviewOptions)(h,this.workspace,c),serializeBuffersForPostMessage:t},n);const u=this.webviews.createNewWebview(g,c,h);return this.createNewWebviewPanel(g,r,s,i,c,u,!0)}$onDidChangeWebviewPanelViewStates(h){const r=Object.keys(h);r.sort((s,l)=>{const c=h[s],i=h[l];return c.active?1:i.active?-1:+c.visible-+i.visible});for(const s of r){const l=this.getWebviewPanel(s);if(!l)continue;const c=h[s];l._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,r,s){if(this._serializers.has(r))throw new Error(`Serializer for '${r}' already registered`);return this._serializers.set(r,{serializer:s,extension:h}),this._proxy.$registerSerializer(r,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(h)}),new o.Disposable(()=>{this._serializers.delete(r),this._proxy.$unregisterSerializer(r)})}async $deserializeWebviewPanel(h,r,s,l){const c=this._serializers.get(r);if(!c)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=c,t=this.webviews.createNewWebview(h,s.webviewOptions,n),g=this.createNewWebviewPanel(h,r,s.title,l,s.panelOptions,t,s.active);await i.deserializeWebviewPanel(g,s.state)}createNewWebviewPanel(h,r,s,l,c,i,n){const t=new I(h,this._proxy,i,{viewType:r,title:s,viewColumn:l,panelOptions:c,active:n});return this._webviewPanels.set(h,t),t}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=w;function a(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(Le[263],Ne([1,0,6,4,67,8,5,7]),function(Se,e,S,k,P,O,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0,A=We(A),R=We(R);class p extends k.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#l;constructor(w,a,y,h,r,s){super(),this.#s=!1,this.#c=this._register(new S.Emitter),this.onDidChangeVisibility=this.#c.event,this.#u=this._register(new S.Emitter),this.onDidDispose=this.#u.event,this.#i=y,this.#a=h,this.#e=w,this.#t=a,this.#n=r,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#c;#u;get title(){return this.assertNotDisposed(),this.#a}set title(w){this.assertNotDisposed(),this.#a!==w&&(this.#a=w,this.#t.$setWebviewViewTitle(this.#e,w))}get description(){return this.assertNotDisposed(),this.#o}set description(w){this.assertNotDisposed(),this.#o!==w&&(this.#o=w,this.#t.$setWebviewViewDescription(this.#e,w))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(w){w===this.#r||this.#s||(this.#r=w,this.#c.fire())}get badge(){return this.assertNotDisposed(),this.#l}set badge(w){this.assertNotDisposed(),!(w?.value===this.#l?.value&&w?.tooltip===this.#l?.tooltip)&&(this.#l=O.ViewBadge.from(w),this.#t.$setWebviewViewBadge(this.#e,w))}show(w){this.assertNotDisposed(),this.#t.$show(this.#e,!!w)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class o{constructor(w,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=w.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(w,a,y,h){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:y,extension:w}),this._proxy.$registerWebviewViewProvider((0,P.toExtensionData)(w),a,{retainContextWhenHidden:h?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(w)}),new R.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(w,a,y,h,r){const s=this._viewProviders.get(a);if(!s)throw new Error(`No view provider found for '${a}'`);const{provider:l,extension:c}=s,i=this._extHostWebview.createNewWebview(w,{},c),n=new p(w,this._proxy,a,y,i,!0);this._webviewViews.set(w,n),await l.resolveWebviewView(n,{state:h},r)}async $onDidChangeWebviewViewVisibility(w,a){this.getWebviewView(w)._setVisible(a)}async $disposeWebviewView(w){const a=this.getWebviewView(w);this._webviewViews.delete(w),a.dispose(),this._extHostWebview.deleteWebview(w)}getWebviewView(w){const a=this._webviewViews.get(w);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=o}),define(Le[264],Ne([1,0,6,30,31,3]),function(Se,e,S,k,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new P.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new P.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new P.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new P.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new P.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new P.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,O.createDecorator)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new S.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new S.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(o){this.channels.has(o.id)||(this.channels.set(o.id,o),this._onDidRegisterChannel.fire(o.id))}getChannels(){const o=[];return this.channels.forEach(I=>o.push(I)),o}getChannel(o){return this.channels.get(o)}removeChannel(o){this.channels.delete(o),this._onDidRemoveChannel.fire(o)}}k.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new P.RawContextKey("activeOutputChannel","")}),define(Le[128],Ne([1,0,5,3,16,18,11,264,68,26,50,165,22,14,29,6,4]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(t,g,u,v,m){super(),this.id=t,this.name=g,this.logger=u,this.proxy=v,this.extension=m,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(u.getLevel()),this._register(u.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.offset;this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Clear,t)}replace(t){const g=this.offset;this.info(t),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Replace,g),this.visible&&this.logger.flush()}show(t,g){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof t=="boolean"?t:g))}hide(){this.proxy.$close(this.id)}log(t,g){this.offset+=a.VSBuffer.fromString(g).byteLength,(0,A.log)(this.logger,t,g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class c extends l{appendLine(t){this.append(t)}}let i=class{constructor(t,g,u,v,m,d){this.initData=g,this.extHostFileSystem=u,this.extHostFileSystemInfo=v,this.loggerService=m,this.logService=d,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=t.getProxy(S.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(g.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.visibleChannelId=t;for(const[g,u]of this.channels)u.visible=g===this.visibleChannelId}createOutputChannel(t,g,u){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const v=typeof g=="object"&&g.log,m=(0,y.isString)(g)?g:void 0;if((0,y.isString)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const C=this.initData.environment.extensionLogLevel?.find(([E])=>O.ExtensionIdentifier.equals(u.identifier,E))?.[1];C&&(d=(0,A.parseLogLevel)(C));const _=v?this.doCreateLogOutputChannel(t,d,u):this.doCreateOutputChannel(t,m,u);return _.then(E=>{this.channels.set(E.id,E),E.visible=E.id===this.visibleChannelId}),v?this.createExtHostLogOutputChannel(t,d??this.logService.getLevel(),_):this.createExtHostOutputChannel(t,_)}async doCreateOutputChannel(t,g,u){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const v=await this.outputDirectoryPromise,m=this.extHostFileSystemInfo.extUri.joinPath(v,`${this.namePool++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),C=await this.proxy.$register(t,m,g,u.identifier.value);return new l(C,t,d,this.proxy,u)}async doCreateLogOutputChannel(t,g,u){const v=await this.createExtensionLogDirectory(u),m=t.replace(/[\\/:\*\?"<>\|]/g,""),d=this.extHostFileSystemInfo.extUri.joinPath(v,`${m}.log`),C=`${u.identifier.value}.${m}`,_=this.loggerService.createLogger(d,{id:C,name:t,logLevel:g,extensionId:u.identifier.value});return new c(C,t,_,this.proxy,u)}createExtensionLogDirectory(t){let g=this.extensionLogDirectoryPromise.get(t.identifier.value);if(!g){const u=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,t.identifier.value);this.extensionLogDirectoryPromise.set(t.identifier.value,g=(async()=>{try{await this.extHostFileSystem.value.createDirectory(u)}catch(v){if((0,h.toFileSystemProviderErrorCode)(v)!==h.FileSystemProviderErrorCode.FileExists)throw v}return u})())}return g}createExtHostOutputChannel(t,g){let u=!1;const v=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return t},append(m){v(),g.then(d=>d.append(m))},appendLine(m){v(),g.then(d=>d.appendLine(m))},clear(){v(),g.then(m=>m.clear())},replace(m){v(),g.then(d=>d.replace(m))},show(m,d){v(),g.then(C=>C.show(m,d))},hide(){v(),g.then(m=>m.hide())},dispose(){u=!0,g.then(m=>m.dispose())}}}createExtHostLogOutputChannel(t,g,u){const v=new s.DisposableStore,m=()=>{if(v.isDisposed)throw new Error("Channel has been closed")},d=v.add(new r.Emitter);function C(_){g=_,d.fire(_)}return u.then(_=>{v.add(_),_.logLevel!==g&&C(_.logLevel),v.add(_.onDidChangeLogLevel(E=>C(E)))}),{...this.createExtHostOutputChannel(t,u),get logLevel(){return g},onDidChangeLogLevel:d.event,trace(_,...E){m(),u.then(T=>T.trace(_,...E))},debug(_,...E){m(),u.then(T=>T.debug(_,...E))},info(_,...E){m(),u.then(T=>T.info(_,...E))},warn(_,...E){m(),u.then(T=>T.warn(_,...E))},error(_,...E){m(),u.then(T=>T.error(_,...E))},dispose(){v.dispose()}}}};e.ExtHostOutputService=i,e.ExtHostOutputService=i=Ge([Ve(0,P.IExtHostRpcService),Ve(1,o.IExtHostInitDataService),Ve(2,p.IExtHostConsumerFileSystem),Ve(3,I.IExtHostFileSystemInfo),Ve(4,A.ILoggerService),Ve(5,A.ILogService)],i),e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(Le[129],Ne([1,0,3,10]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,S.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let R=0;R<this.maxSampleCount;R++){const p=await P.getRoundTripTime();if(p===void 0)return;O=Math.min(O,p/2),await(0,k.timeout)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((R,p)=>R+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((R,p)=>R+p,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Le[265],Ne([1,0,9,53,30,49,43,4,6,129,20,25,10,113]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWindowConfiguration=e.CONFIG_NEW_WINDOW_PROFILE=e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.windowConfigurationNodeBase=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,S.localize)(12548,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(12549,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:k.ConfigurationScope.APPLICATION,title:(0,S.localize)(12550,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,S.localize)(12551,null),type:"object",order:101}),e.windowConfigurationNodeBase=Object.freeze({id:"window",order:8,title:(0,S.localize)(12552,null),type:"object"}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class h{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new p.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new h;P.Registry.add(e.Extensions.ConfigurationMigration,r);let s=class extends R.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.configurationService=n,this.workspaceService=t,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async g=>{for(const u of g.added)await this.migrateConfigurationsForFolder(u,r.migrations)})),this.migrateConfigurations(r.migrations),this._register(r.onDidRegisterConfigurationMigration(g=>this.migrateConfigurations(g)))}async migrateConfigurations(n){await this.migrateConfigurationsForFolder(void 0,n);for(const t of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(t,n)}async migrateConfigurationsForFolder(n,t){await Promise.all([t.map(g=>this.migrateConfigurationsForFolderAndOverride(g,n?.uri))])}async migrateConfigurationsForFolderAndOverride(n,t){const g=this.configurationService.inspect(n.key,{resource:t}),u=this.workspaceService.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[v,m]of u){const d=g[v];if(!d)continue;const C=[];if(d.value!==void 0){const _=await this.runMigration(n,v,d.value,t,void 0);for(const E of _??[])C.push([E,[]])}for(const{identifiers:_,value:E}of d.overrides??[])if(E!==void 0){const T=await this.runMigration(n,v,E,t,_);for(const D of T??[])C.push([D,_])}C.length&&await Promise.allSettled(C.map(async([[_,E],T])=>this.configurationService.updateValue(_,E.value,{resource:t,overrideIdentifiers:T},m)))}}async runMigration(n,t,g,u,v){const m=C=>{const E=this.configurationService.inspect(C,{resource:u})[t];if(E)return v?E.overrides?.find(({identifiers:T})=>(0,w.equals)(T,v))?.value:E.value},d=await n.migrateFn(g,m);return Array.isArray(d)?d:[[n.key,d]]}};e.ConfigurationMigrationWorkbenchContribution=s,e.ConfigurationMigrationWorkbenchContribution=s=Ge([Ve(0,A.IConfigurationService),Ve(1,O.IWorkspaceContextService)],s);let l=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.remoteAgentService=n,this._ready=new a.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!I.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.Registry.as(k.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(12553,null)},default:[],markdownDescription:(0,S.localize)(12554,null),scope:k.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(12555,null),scope:k.ConfigurationScope.MACHINE}}})}};e.DynamicWorkbenchSecurityConfiguration=l,e.DynamicWorkbenchSecurityConfiguration=l=Ge([Ve(0,o.IRemoteAgentService)],l),e.CONFIG_NEW_WINDOW_PROFILE="window.newWindowProfile";let c=class extends R.Disposable{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.userDataProfilesService=n,this.configurationService=t,this.registerNewWindowProfileConfiguration(),this._register(this.userDataProfilesService.onDidChangeProfiles(g=>this.registerNewWindowProfileConfiguration())),this.setNewWindowProfile(),this.checkAndResetNewWindowProfileConfig(),this._register(t.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(e.CONFIG_NEW_WINDOW_PROFILE)&&this.setNewWindowProfile()})),this._register(this.userDataProfilesService.onDidChangeProfiles(()=>this.checkAndResetNewWindowProfileConfig()))}registerNewWindowProfileConfiguration(){const n=P.Registry.as(k.Extensions.Configuration),t={...e.windowConfigurationNodeBase,properties:{[e.CONFIG_NEW_WINDOW_PROFILE]:{type:["string","null"],default:null,enum:[...this.userDataProfilesService.profiles.map(g=>g.name),null],enumItemLabels:[...this.userDataProfilesService.profiles.map(g=>""),(0,S.localize)(12556,null)],description:(0,S.localize)(12557,null),scope:k.ConfigurationScope.APPLICATION}}};this.configurationNode?n.updateConfigurations({add:[t],remove:[this.configurationNode]}):n.registerConfiguration(t),this.configurationNode=t}setNewWindowProfile(){const n=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);this.newWindowProfile=n?this.userDataProfilesService.profiles.find(t=>t.name===n):void 0}checkAndResetNewWindowProfileConfig(){const n=this.configurationService.getValue(e.CONFIG_NEW_WINDOW_PROFILE);if(!n)return;const t=this.newWindowProfile?this.userDataProfilesService.profiles.find(g=>g.id===this.newWindowProfile.id):void 0;n!==t?.name&&this.configurationService.updateValue(e.CONFIG_NEW_WINDOW_PROFILE,t?.name)}};e.DynamicWindowConfiguration=c,e.DynamicWindowConfiguration=c=Ge([Ve(0,y.IUserDataProfilesService),Ve(1,A.IConfigurationService)],c)}),define(Le[266],Ne([1,0,41,15,19,23,9,265,53,3,30]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=r,e.globMatchesResource=s,S=We(S),e.IEditorResolverService=(0,o.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const w=I.Registry.as(p.Extensions.Configuration),a={...R.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(2025,null),additionalProperties:{type:"string"}}}};w.registerConfiguration(a);var y;(function(l){l.builtin="builtin",l.option="option",l.exclusive="exclusive",l.default="default"})(y||(e.RegisteredEditorPriority=y={}));var h;(function(l){l[l.ABORT=1]="ABORT",l[l.NONE=2]="NONE"})(h||(e.ResolvedStatus=h={}));function r(l){switch(l){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}function s(l,c){if(new Set([k.Schemas.extension,k.Schemas.webviewPanel,k.Schemas.vscodeWorkspaceTrust,k.Schemas.vscodeSettings]).has(c.scheme))return!1;const t=typeof l=="string"&&l.indexOf(P.posix.sep)>=0?`${c.scheme}:${c.path}`:(0,O.basename)(c);return S.match(typeof l=="string"?l.toLowerCase():l,t.toLowerCase())}}),define(Le[267],Ne([1,0,51,15,19,20,23,2,3,186,49,205,129]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,p.createDecorator)("pathService");let h=y=class{constructor(s,l,c,i){this.localUserHome=s,this.remoteAgentService=l,this.environmentService=c,this.contextService=i,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||O.OS)(),this.resolveUserHome=(async()=>{const n=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=n?.userHome??s})()}hasValidBasename(s,l,c){return typeof l=="string"||typeof l>"u"?this.resolveOS.then(i=>this.doHasValidBasename(s,i,l)):this.doHasValidBasename(s,l,c)}doHasValidBasename(s,l,c){return s.scheme===k.Schemas.file||s.scheme===k.Schemas.vscodeRemote?(0,S.isValidBasename)(c??(0,A.basename)(s),l===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(s,l){if(s.remoteAuthority)return k.Schemas.vscodeRemote;const c=(0,o.getVirtualWorkspaceScheme)(l.getWorkspace());if(c)return c;const i=l.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=l.getWorkspace().configuration;return n?n.scheme:k.Schemas.file}userHome(s){return s?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===O.OperatingSystem.Windows?P.win32:P.posix)}async fileURI(s){let l="";if(await this.resolveOS===O.OperatingSystem.Windows&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(l=s.substring(2),s="/"):(l=s.substring(2,i),s=s.substring(i)||"/")}return R.URI.from({scheme:k.Schemas.file,authority:l,path:s,query:"",fragment:""})}};e.AbstractPathService=h,e.AbstractPathService=h=y=Ge([Ve(1,a.IRemoteAgentService),Ve(2,w.IWorkbenchEnvironmentService),Ve(3,I.IWorkspaceContextService)],h)}),define(Le[130],Ne([1,0,17]),function(Se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageTypeNew=e.ExcludeSettingOptions=e.TextSearchContextNew=e.TextSearchMatchNew=e.TextSearchCompleteMessageType=e.Range=e.Position=void 0,e.oldToNewTextSearchResult=w;class k{constructor(y,h){this.line=y,this.character=h}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,h){return new k(0,0)}with(y){return new k(0,0)}}e.Position=k;class P{constructor(y,h,r,s){this.isEmpty=!1,this.isSingleLine=!1,this.start=new k(y,h),this.end=new k(r,s)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new P(0,0,0,0)}with(y){return new P(0,0,0,0)}}e.Range=P;var O;(function(a){a[a.Information=1]="Information",a[a.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}));class A{constructor(y,h,r){this.uri=y,this.ranges=h,this.previewText=r}}e.TextSearchMatchNew=A;class R{constructor(y,h,r){this.uri=y,this.text=h,this.lineNumber=r}}e.TextSearchContextNew=R;var p;(function(a){a[a.none=1]="none",a[a.filesExclude=2]="filesExclude",a[a.searchAndFilesExclude=3]="searchAndFilesExclude"})(p||(e.ExcludeSettingOptions=p={}));var o;(function(a){a[a.Information=1]="Information",a[a.Warning=2]="Warning"})(o||(e.TextSearchCompleteMessageTypeNew=o={}));function I(a){return"uri"in a&&"ranges"in a&&"preview"in a}function w(a){if(I(a)){const y=(0,S.asArray)(a.ranges).map(h=>({sourceRange:h,previewRange:h}));return new A(a.uri,y,a.preview.text)}else return new R(a.uri,a.text,a.lineNumber)}}),define(Le[44],Ne([1,0,17,41,25,51,12,3,19,13,130,10]),function(Se,e,S,k,P,O,A,R,p,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.DEFAULT_MAX_SEARCH_RESULTS=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=l,e.isFileMatch=c,e.isProgressMessage=i,e.getExcludes=_,e.pathIncludedInQuery=E,e.deserializeSearchError=f,e.serializeSearchError=b,e.isSerializedSearchComplete=M,e.isSerializedSearchSuccess=L,e.isSerializedFileMatch=N,e.isFilePatternMatch=W,e.resolvePatternsForProvider=$,e.hasSiblingPromiseFn=ae,e.hasSiblingFn=Ee,k=We(k),P=We(P),O=We(O),p=We(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude",e.DEFAULT_MAX_SEARCH_RESULTS=2e4;const a="\u27EA ",y=" characters skipped \u27EB",h=(a.length+y.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var r;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text",Z[Z.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var s;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.aiText=3]="aiText"})(s||(e.QueryType=s={}));function l(Z){return!!Z.preview}function c(Z){return!!Z.resource}function i(Z){return!!Z.message}var n;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(le){this.resource=le,this.results=[]}}e.FileMatch=t;class g{constructor(le,me,oe,De){this.ranges=me,this.webviewIndex=De;const Re=Array.isArray(me)?me:[me];if(oe&&oe.matchLines===1&&u(Re)){le=(0,A.getNLines)(le,oe.matchLines);let Q="",z=0,ne=0;const Ce=Math.floor(oe.charsPerLine/5),fe=[];for(const be of Re){const de=Math.max(be.startColumn-Ce,0),X=be.startColumn+oe.charsPerLine;if(de>ne+Ce+h){const J=a+(de-ne)+y;Q+=J+le.slice(de,X),z+=de-(ne+J.length)}else Q+=le.slice(ne,X);fe.push(new m(0,be.startColumn-z,be.endColumn-z)),ne=X}this.preview={text:Q,matches:Array.isArray(this.ranges)?fe:fe[0]}}else{const Q=Array.isArray(me)?me[0].startLineNumber:me.startLineNumber;this.preview={text:le,matches:(0,S.mapArrayOrNot)(me,z=>new v(z.startLineNumber-Q,z.startColumn,z.endLineNumber-Q,z.endColumn))}}}}e.TextSearchMatch=g;function u(Z){const le=Z[0].startLineNumber;for(const me of Z)if(me.startLineNumber!==le||me.endLineNumber!==le)return!1;return!0}class v{constructor(le,me,oe,De){this.startLineNumber=le,this.startColumn=me,this.endLineNumber=oe,this.endColumn=De}}e.SearchRange=v;class m extends v{constructor(le,me,oe){super(le,me,le,oe)}}e.OneLineRange=m;var d;(function(Z){Z.List="list",Z.Tree="tree"})(d||(e.ViewMode=d={}));var C;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(C||(e.SearchSortOrder=C={}));function _(Z,le=!0){const me=Z&&Z.files&&Z.files.exclude,oe=le&&Z&&Z.search&&Z.search.exclude;if(!me&&!oe)return;if(!me||!oe)return me||oe||void 0;let De=Object.create(null);return De=P.mixin(De,P.deepClone(me)),De=P.mixin(De,P.deepClone(oe),!0),De}function E(Z,le){return Z.excludePattern&&k.match(Z.excludePattern,le)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&k.match(Z.includePattern,le)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(me=>{const oe=me.folder.fsPath;if(O.isEqualOrParent(le,oe)){const De=p.relative(oe,le);return!me.includePattern||!!k.match(me.includePattern,De)}else return!1}):!1:!0}var T;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(T||(e.SearchErrorCode=T={}));class D extends Error{constructor(le,me){super(le),this.code=me}}e.SearchError=D;function f(Z){const le=Z.message;if((0,o.isCancellationError)(Z))return new D(le,T.canceled);try{const me=JSON.parse(le);return new D(me.message,me.code)}catch{return new D(le,T.other)}}function b(Z){const le={message:Z.message,code:Z.code};return new Error(JSON.stringify(le))}function M(Z){return Z.type==="error"?!0:Z.type==="success"}function L(Z){return Z.type==="success"}function N(Z){return!!Z.path}function W(Z,le,me=!0){const oe=Z.searchPath?Z.searchPath:Z.relativePath;return me?(0,A.fuzzyContains)(oe,le):k.match(le,oe)}class j{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=j;function $(Z,le){const me={...Z||{},...le||{}};return Object.keys(me).filter(oe=>{const De=me[oe];return typeof De=="boolean"&&De})}class K{constructor(le,me){this._parsedIncludeExpression=null,this._excludeExpression={...le.excludePattern||{},...me.excludePattern||{}},this._parsedExcludeExpression=k.parse(this._excludeExpression);let oe=le.includePattern;me.includePattern&&(oe?oe={...oe,...me.includePattern}:oe=me.includePattern),oe&&(this._parsedIncludeExpression=k.parse(oe))}matchesExcludesSync(le,me,oe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(le,me,oe))}includedInQuerySync(le,me,oe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(le,me,oe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(le,me,oe))}includedInQuery(le,me,oe){const De=this._parsedExcludeExpression(le,me,oe),Re=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(le,me,oe):!0;return(0,w.isThenable)(De)?De.then(Q=>Q?!1:Re()):Re()}hasSiblingExcludeClauses(){return q(this._excludeExpression)}}e.QueryGlobTester=K;function q(Z){for(const le in Z)if(typeof Z[le]!="boolean")return!0;return!1}function ae(Z){if(!Z)return;let le;return me=>(le||(le=(Z()||Promise.resolve([])).then(oe=>oe?ce(oe):{})),le.then(oe=>!!oe[me]))}function Ee(Z){if(!Z)return;let le;return me=>{if(!le){const oe=Z();le=oe?ce(oe):{}}return!!le[me]}}function ce(Z){const le={};for(const me of Z)le[me]=!0;return le}}),define(Le[45],Ne([1,0,17,10,21,6,4,58,15,140,23,12,2,9,29,3,11,173,49,50,26,16,8,7,65,44,5,36]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n,t,g,u,v,m,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function _(N,W,j){return new I.ExtUri($=>f($,j)).isEqual(N,W)}function E(N,W,j){return _(N.uri,W.uri,j)?0:(0,w.compare)(N.uri.toString(),W.uri.toString())}function T(N,W,j){return N.index!==W.index?N.index<W.index?-1:1:_(N.uri,W.uri,j)?(0,w.compare)(N.name,W.name):(0,w.compare)(N.uri.toString(),W.uri.toString())}function D(N,W,j,$){const K=N.slice(0).sort((ae,Ee)=>j(ae,Ee,$)),q=W.slice(0).sort((ae,Ee)=>j(ae,Ee,$));return(0,S.delta)(K,q,(ae,Ee)=>j(ae,Ee,$))}function f(N,W){const j=W.getCapabilities(N.scheme);return!(j&&j&h.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends c.Workspace{static toExtHostWorkspace(W,j,$,K){if(!W)return{workspace:null,added:[],removed:[]};const{id:q,name:ae,folders:Ee,configuration:ce,transient:Z,isUntitled:le}=W,me=[],oe=j;j?Ee.forEach((z,ne)=>{const Ce=a.URI.revive(z.uri),fe=b._findFolder($||j,Ce,K);fe?(fe.name=z.name,fe.index=z.index,me.push(fe)):me.push({uri:Ce,name:z.name,index:ne})}):me.push(...Ee.map(({uri:z,name:ne,index:Ce})=>({uri:a.URI.revive(z),name:ne,index:Ce}))),me.sort((z,ne)=>z.index<ne.index?-1:1);const De=new b(q,ae,me,!!Z,ce?a.URI.revive(ce):null,!!le,z=>f(z,K)),{added:Re,removed:Q}=D(oe?oe.workspaceFolders:[],De.workspaceFolders,E,K);return{workspace:De,added:Re,removed:Q}}static _findFolder(W,j,$){for(let K=0;K<W.folders.length;K++){const q=W.workspaceFolders[K];if(_(q.uri,j,$))return q}}constructor(W,j,$,K,q,ae,Ee){super(W,$.map(ce=>new c.WorkspaceFolder(ce)),K,q,Ee),this._name=j,this._isUntitled=ae,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(Ee,()=>!0),$.forEach(ce=>{this._workspaceFolders.push(ce),this._structure.set(ce.uri,ce)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(W,j){return j&&this._structure.get(W)&&(W=(0,I.dirname)(W)),this._structure.findSubstr(W)}resolveWorkspaceFolder(W){return this._structure.get(W)}}let M=class{constructor(W,j,$,K,q){this._onDidChangeWorkspace=new O.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new O.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new O.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=K,this._extHostFileSystemInfo=$,this._uriTransformerService=q,this._requestIdProvider=new o.Counter,this._barrier=new k.Barrier,this._proxy=W.getProxy(d.MainContext.MainThreadWorkspace),this._messageService=W.getProxy(d.MainContext.MainThreadMessageService);const ae=j.workspace;this._confirmedWorkspace=ae?new b(ae.id,ae.name,[],!!ae.transient,ae.configuration?a.URI.revive(ae.configuration):null,!!ae.isUntitled,Ee=>f(Ee,$)):void 0}$initializeWorkspace(W,j){this._trusted=j,this.$acceptWorkspaceData(W),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:p.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(W,j,$,...K){const q=[];if(Array.isArray(K)&&K.forEach(le=>{a.URI.isUri(le.uri)&&!q.some(me=>_(me.uri,le.uri,this._extHostFileSystemInfo))&&q.push({uri:le.uri,name:le.name||(0,I.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[j,$].some(le=>typeof le!="number"||le<0)||$===0&&q.length===0)return!1;const ae=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(j+$>ae.length)return!1;const Ee=ae.slice(0);Ee.splice(j,$,...q.map(le=>({uri:le.uri,name:le.name||(0,I.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<Ee.length;le++){const me=Ee[le];if(Ee.some((oe,De)=>De!==le&&_(me.uri,oe.uri,this._extHostFileSystemInfo)))return!1}Ee.forEach((le,me)=>le.index=me);const{added:ce,removed:Z}=D(ae,Ee,T,this._extHostFileSystemInfo);if(ce.length===0&&Z.length===0)return!1;if(this._proxy){const le=W.displayName||W.name;this._proxy.$updateWorkspaceFolders(le,j,$,q).then(void 0,me=>{this._unconfirmedWorkspace=void 0;const oe={source:{identifier:W.identifier,label:W.displayName||W.name}};this._messageService.$showMessage(l.Severity.Error,(0,y.localize)(10820,null,le,me.toString()),oe,[])})}return this.trySetWorkspaceFolders(Ee),!0}getWorkspaceFolder(W,j){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,j)}async getWorkspaceFolder2(W,j){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,j)}async resolveWorkspaceFolder(W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(W)}getPath(){if(!this._actualWorkspace)return;const{folders:W}=this._actualWorkspace;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,j){let $,K="";if(typeof W=="string"?($=a.URI.file(W),K=W):typeof W<"u"&&($=W,K=W.fsPath),!$)return K;const q=this.getWorkspaceFolder($,!0);if(!q)return K;typeof j>"u"&&this._actualWorkspace&&(j=this._actualWorkspace.folders.length>1);let ae=(0,I.relativePath)(q.uri,$);return j&&q.name&&(ae=`${q.name}/${ae}`),ae}trySetWorkspaceFolders(W){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:W,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:j,added:$,removed:K}=b.toExtHostWorkspace(W,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=j||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:K}))}findFiles(W,j,$,K,q=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let ae="",Ee=!0;return j===null?Ee=!1:j!==void 0&&(typeof j=="string"?ae=j:ae=j.pattern),this._findFilesImpl(W,void 0,{exclude:ae,maxResults:$,useDefaultExcludes:Ee,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},q)}findFiles2(W,j={},$,K=P.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${$.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,W,j,K)}async _findFilesImpl(W,j,$,K=P.CancellationToken.None){if(K&&K.isCancellationRequested)return Promise.resolve([]);const q=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,ae={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof $.useDefaultSearchExcludes=="boolean"?!$.useDefaultSearchExcludes:!1,maxResults:$.maxResults,excludePattern:q,shouldGlobSearch:typeof $.fuzzy=="boolean"?!$.fuzzy:!0,_reason:"startFileSearch"};let Ee;if(W){const{includePattern:ce,folder:Z}=L(g.GlobPattern.from(W));Ee=Z,ae.includePattern=ce}else{const{includePattern:ce,folder:Z}=L(g.GlobPattern.from(j));Ee=Z,ae.filePattern=ce}return this._proxy.$startFileSearch(Ee??null,ae,K).then(ce=>Array.isArray(ce)?ce.map(Z=>a.URI.revive(Z)):[])}async findTextInFiles(W,j,$,K,q=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const ae=this._requestIdProvider.getNext(),Ee=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:ce,folder:Z}=L(g.GlobPattern.from(j.include)),le=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,me={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof j.useSearchExclude=="boolean"?!j.useSearchExclude:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:Ee,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:ce,excludePattern:le},oe=!1;if(this._activeSearchCallbacks[ae]=De=>{if(oe)return;const Re=a.URI.revive(De.resource);De.results.forEach(Q=>{const z=(0,C.revive)(Q);(0,m.resultIsMatch)(z)?$({uri:Re,preview:{text:z.preview.text,matches:(0,S.mapArrayOrNot)(z.preview.matches,ne=>new u.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,S.mapArrayOrNot)(z.ranges,ne=>new u.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):$({uri:Re,text:z.text,lineNumber:z.lineNumber})})},q.isCancellationRequested)return{};try{const De=await this._proxy.$startTextSearch(W,Z??null,me,ae,q);return delete this._activeSearchCallbacks[ae],De||{}}catch(De){throw delete this._activeSearchCallbacks[ae],De}}$handleTextSearchResult(W,j){this._activeSearchCallbacks[j]?.(W)}async save(W){const j=await this._proxy.$save(W,{saveAs:!1});return a.URI.revive(j)}async saveAs(W){const j=await this._proxy.$save(W,{saveAs:!0});return a.URI.revive(j)}saveAll(W){return this._proxy.$saveAll(W)}resolveProxy(W){return this._proxy.$resolveProxy(W)}lookupAuthorization(W){return this._proxy.$lookupAuthorization(W)}lookupKerberosAuthorization(W){return this._proxy.$lookupKerberosAuthorization(W)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(W){return this._proxy.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(W,j){if(this._editSessionIdentityProviders.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this._editSessionIdentityProviders.set(W,j);const $=this._uriTransformerService.transformOutgoingScheme(W),K=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(K,$),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete(W),this._proxy.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(W,j){this._logService.info("Getting edit session identifier for workspaceFolder",W);const $=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!$){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",$);const K=this._editSessionIdentityProviders.get($.uri.scheme);if(this._logService.info(`Provider for scheme ${$.uri.scheme} is defined: `,!!K),!K)return;const q=await K.provideEditSessionIdentity($,j);if(this._logService.info("Provider returned edit session identifier: ",q),!!q)return q}async $provideEditSessionIdentityMatch(W,j,$,K){this._logService.info("Getting edit session identifier for workspaceFolder",W);const q=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!q){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",q);const ae=this._editSessionIdentityProviders.get(q.uri.scheme);if(this._logService.info(`Provider for scheme ${q.uri.scheme} is defined: `,!!ae),!ae)return;const Ee=await ae.provideEditSessionIdentityMatch?.(j,$,K);if(this._logService.info("Provider returned edit session identifier match result: ",Ee),!!Ee)return Ee}getOnWillCreateEditSessionIdentityEvent(W){return(j,$,K)=>{const q=function(Ee){j.call($,Ee)};return q.extension=W,this._onWillCreateEditSessionIdentityEvent.event(q,void 0,K)}}async $onWillCreateEditSessionIdentity(W,j,$){const K=await this.resolveWorkspaceFolder(a.URI.revive(W));if(K===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:K},j,async(q,ae)=>{const Ee=Date.now();await Promise.resolve(q),Date.now()-Ee>$&&this._logService.warn("SLOW edit session create-participant",ae.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(W,j){if(this._canonicalUriProviders.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this._canonicalUriProviders.set(W,j);const $=this._uriTransformerService.transformOutgoingScheme(W),K=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(K,$),(0,A.toDisposable)(()=>{this._canonicalUriProviders.delete(W),this._proxy.$unregisterCanonicalUriProvider(K)})}async provideCanonicalUri(W,j,$){const K=this._canonicalUriProviders.get(W.scheme);if(!K)return;const q=await K.provideCanonicalUri?.(a.URI.revive(W),j,$);if(q)return q}async $provideCanonicalUri(W,j,$){return this.provideCanonicalUri(a.URI.revive(W),{targetScheme:j},$)}};e.ExtHostWorkspace=M,e.ExtHostWorkspace=M=Ge([Ve(0,t.IExtHostRpcService),Ve(1,n.IExtHostInitDataService),Ve(2,i.IExtHostFileSystemInfo),Ve(3,s.ILogService),Ve(4,v.IURITransformerService)],M),e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function L(N){let W,j;return N&&(typeof N=="string"?W=N:(W=N.pattern,j=a.URI.revive(N.baseUri))),{includePattern:W,folder:j}}}),define(Le[46],Ne([1,0,25,6,45,5,7,43,174,53,14,10,3,16,11,2]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(v,m){if(m){const d=m.split(".");let C=v;for(let _=0;C&&_<d.length;_++)C=C[d[_]];return C}}function l(v){return v instanceof r.URI}function c(v){return v&&v.uri instanceof r.URI&&v.languageId&&typeof v.languageId=="string"}function i(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function n(v){return v&&v.uri instanceof r.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function t(v){if(l(v))return{resource:v};if(c(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(i(v))return{overrideIdentifier:v.languageId};if(n(v))return{resource:v.uri};if(v===null)return{resource:null}}let g=class{constructor(m,d,C){this._proxy=m.getProxy(O.MainContext.MainThreadConfiguration),this._extHostWorkspace=d,this._logService=C,this._barrier=new w.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(m=>this._actual)}$initializeConfiguration(m){this._actual=new u(this._proxy,this._extHostWorkspace,m,this._logService),this._barrier.open()}$acceptConfigurationChanged(m,d){this.getConfigProvider().then(C=>C.$acceptConfigurationChanged(m,d))}};e.ExtHostConfiguration=g,e.ExtHostConfiguration=g=Ge([Ve(0,y.IExtHostRpcService),Ve(1,P.IExtHostWorkspace),Ve(2,h.ILogService)],g);class u{constructor(m,d,C,_){this._onDidChangeConfiguration=new k.Emitter,this._proxy=m,this._logService=_,this._extHostWorkspace=d,this._configuration=p.Configuration.parse(C,_),this._configurationScopes=this._toMap(C.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(m,d){const C={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=p.Configuration.parse(m,this._logService),this._configurationScopes=this._toMap(m.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(d,C))}getConfiguration(m,d,C){const _=t(d)||{},E=this._toReadonlyValue(m?s(this._configuration.getValue(void 0,_,this._extHostWorkspace.workspace),m):this._configuration.getValue(void 0,_,this._extHostWorkspace.workspace));m&&this._validateConfigurationAccess(m,_,C?.identifier);function T(f){if(f==null)return null;if(typeof f=="boolean")return f?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(f){case A.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const D={has(f){return typeof s(E,f)<"u"},get:(f,b)=>{this._validateConfigurationAccess(m?`${m}.${f}`:f,_,C?.identifier);let M=s(E,f);if(typeof M>"u")M=b;else{let L;const N=(W,j)=>{if((0,I.isObject)(W)){let $;const K=()=>{L=L||(0,S.deepClone)(E),$=$||s(L,j)};return new Proxy(W,{get:(q,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return K(),()=>$;if(L)return $=$||s(L,j),$[ae];const Ee=q[ae];return typeof ae=="string"?N(Ee,`${j}.${ae}`):Ee},set:(q,ae,Ee)=>(K(),$&&($[ae]=Ee),!0),deleteProperty:(q,ae)=>(K(),$&&delete $[ae],!0),defineProperty:(q,ae,Ee)=>(K(),$&&Object.defineProperty($,ae,Ee),!0)})}return Array.isArray(W)?(0,S.deepClone)(W):W};M=N(M,f)}return M},update:(f,b,M,L)=>{f=m?`${m}.${f}`:f;const N=T(M);return b!==void 0?this._proxy.$updateConfigurationOption(N,f,b,_,L):this._proxy.$removeConfigurationOption(N,f,_,L)},inspect:f=>{f=m?`${m}.${f}`:f;const b=this._configuration.inspect(f,_,this._extHostWorkspace.workspace);if(b)return{key:f,defaultValue:(0,S.deepClone)(b.policy?.value??b.default?.value),globalValue:(0,S.deepClone)(b.user?.value??b.application?.value),workspaceValue:(0,S.deepClone)(b.workspace?.value),workspaceFolderValue:(0,S.deepClone)(b.workspaceFolder?.value),defaultLanguageValue:(0,S.deepClone)(b.default?.override),globalLanguageValue:(0,S.deepClone)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,S.deepClone)(b.workspace?.override),workspaceFolderLanguageValue:(0,S.deepClone)(b.workspaceFolder?.override),languageIds:(0,S.deepClone)(b.overrideIdentifiers)}}};return typeof E=="object"&&(0,S.mixin)(D,E,!1),Object.freeze(D)}_toReadonlyValue(m){const d=C=>(0,I.isObject)(C)?new Proxy(C,{get:(_,E)=>d(_[E]),set:(_,E,T)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(_,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(_,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:_=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):C;return d(m)}_validateConfigurationAccess(m,d,C){const _=o.OVERRIDE_PROPERTY_REGEX.test(m)?o.ConfigurationScope.RESOURCE:this._configurationScopes.get(m),E=C?`[${C.value}] `:"";if(o.ConfigurationScope.RESOURCE===_){typeof d?.resource>"u"&&this._logService.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${m}', provide the URI of a resource or 'null' for any resource.`);return}if(o.ConfigurationScope.WINDOW===_){d?.resource&&this._logService.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${m}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(m,d){const C=new p.ConfigurationChangeEvent(m,d,this._configuration,this._extHostWorkspace.workspace,this._logService);return Object.freeze({affectsConfiguration:(_,E)=>C.affectsConfiguration(_,t(E))})}_toMap(m){return m.reduce((d,C)=>(d.set(C[0],C[1]),d),new Map)}}e.ExtHostConfigProvider=u,e.IExtHostConfiguration=(0,a.createDecorator)("IExtHostConfiguration")}),define(Le[131],Ne([1,0,2,10,6,5,7,45,57,46,21,56,16,26,3,15,20,11,84,209,13]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=We(A),s=We(s);var t;(function(L){function N(j){if(j!=null)return j}L.from=N;function W(j){if(j!=null)return j}L.to=W})(t||(t={}));var g;(function(L){function N(j){if(j!=null)return j}L.from=N;function W(j){if(j!=null)return j}L.to=W})(g||(g={}));var u;(function(L){function N(j){if(j!=null)return j}L.from=N;function W(j){if(j!=null)return j}L.to=W})(u||(u={}));var v;(function(L){function N($){if($){const K=$;return K&&!!K.process}else return!1}L.is=N;function W($){if($==null)return;const K={process:$.process,args:$.args};return $.options&&(K.options=u.from($.options)),K}L.from=W;function j($){if($!=null)return new A.ProcessExecution($.process,$.args,$.options)}L.to=j})(v||(v={}));var m;(function(L){function N(j){if(j!=null)return j}L.from=N;function W(j){if(j!=null)return j}L.to=W})(m||(m={}));var d;(function(L){function N($){if($){const K=$;return K&&(!!K.commandLine||!!K.command)}else return!1}L.is=N;function W($){if($==null)return;const K={};return $.commandLine!==void 0?K.commandLine=$.commandLine:(K.command=$.command,K.args=$.args),$.options&&(K.options=m.from($.options)),K}L.from=W;function j($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new A.ShellExecution($.commandLine,$.options):new A.ShellExecution($.command,$.args?$.args:[],$.options)}L.to=j})(d||(d={}));var C;(function(L){function N($){if($){const K=$;return K&&K.customExecution==="customExecution"}else return!1}L.is=N;function W($){return{customExecution:"customExecution"}}L.from=W;function j($,K){return K.get($)}L.to=j})(C||(e.CustomExecutionDTO=C={}));var _;(function(L){function N(W,j){let $;return W.scope!==void 0&&typeof W.scope!="number"?$=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?$=j.workspaceFile:$=i.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:$}}L.from=N})(_||(e.TaskHandleDTO=_={}));var E;(function(L){function N(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}L.from=N})(E||(E={}));var T;(function(L){function N($,K){if($==null)return[];const q=[];for(const ae of $){const Ee=W(ae,K);Ee&&q.push(Ee)}return q}L.fromMany=N;function W($,K){if($==null)return;let q;$.execution instanceof A.ProcessExecution?q=v.from($.execution):$.execution instanceof A.ShellExecution?q=d.from($.execution):$.execution&&$.execution instanceof A.CustomExecution&&(q=C.from($.execution));const ae=t.from($.definition);let Ee;return $.scope?typeof $.scope=="number"?Ee=$.scope:Ee=$.scope.uri:Ee=A.TaskScope.Workspace,!ae||!Ee?void 0:{_id:$._id,definition:ae,name:$.name,source:{extensionId:K.identifier.value,label:$.source,scope:Ee},execution:q,isBackground:$.isBackground,group:E.from($.group),presentationOptions:g.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}L.from=W;async function j($,K,q){if($==null)return;let ae;v.is($.execution)?ae=v.to($.execution):d.is($.execution)?ae=d.to($.execution):C.is($.execution)&&(ae=C.to($._id,q));const Ee=t.to($.definition);let ce;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?ce=$.source.scope:ce=await K.resolveWorkspaceFolder(S.URI.revive($.source.scope)):ce=A.TaskScope.Workspace),!Ee||!ce)return;const Z=new A.Task(Ee,ce,$.name,$.source.label,ae,$.problemMatchers);return $.isBackground!==void 0&&(Z.isBackground=$.isBackground),$.group!==void 0&&(Z.group=A.TaskGroup.from($.group._id),Z.group&&$.group.isDefault&&(Z.group=new A.TaskGroup(Z.group.id,Z.group.label),$.group.isDefault===!0&&(Z.group.isDefault=$.group.isDefault))),$.presentationOptions&&(Z.presentationOptions=g.to($.presentationOptions)),$._id&&(Z._id=$._id),$.detail&&(Z.detail=$.detail),Z}L.to=j})(T||(e.TaskDTO=T={}));var D;(function(L){function N(j){return j}L.from=N;function W(j){if(j)return Object.assign(Object.create(null),j)}L.to=W})(D||(D={}));class f{#e;constructor(N,W,j){this._id=W,this._task=j,this.#e=N}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}let b=class{constructor(N,W,j,$,K,q,ae,Ee){this._onDidExecuteTask=new P.Emitter,this._onDidTerminateTask=new P.Emitter,this._onDidTaskProcessStarted=new P.Emitter,this._onDidTaskProcessEnded=new P.Emitter,this._proxy=N.getProxy(O.MainContext.MainThreadTask),this._workspaceProvider=j,this._editorService=$,this._configurationService=K,this._terminalService=q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ae,this._deprecationService=Ee,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,W,j){if(!j)return new A.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:W,provider:j,extension:N}),this._proxy.$registerTaskProvider($,W),new A.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(N,W){this._proxy.$registerTaskSystem(N,W)}fetchTasks(N){return this._proxy.$fetchTasks(D.from(N)).then(async W=>{const j=[];for(const $ of W){const K=await T.to($,this._workspaceProvider,this._providedCustomExecutions2);K&&j.push(K)}return j})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(W=>N.push(W)),N}terminateTask(N){if(!(N instanceof f))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,W,j){const $=this._providedCustomExecutions2.get(N.id);$&&(this._activeCustomExecutions2.set(N.id,$),this._terminalService.attachPtyToTerminal(W,await $.callback(j))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){if(!this._taskExecutionPromises.has(N.id))return;const W=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const W=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:W,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const W=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:N.exitCode})}$provideTasks(N,W){const j=this._handlers.get(N);if(!j)return Promise.reject(new Error("no handler found"));const $=[],K=(0,k.asPromise)(()=>j.provider.provideTasks(I.CancellationToken.None)).then(q=>this.provideTasksInternal(W,$,j,q));return new Promise(q=>{K.then(ae=>{Promise.all($).then(()=>{q(ae)})})})}async $resolveTask(N,W){const j=this._handlers.get(N);if(!j)return Promise.reject(new Error("no handler found"));if(W.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${j.type}].`);const $=await T.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const K=await j.provider.resolveTask($,I.CancellationToken.None);if(!K)return;this.checkDeprecation(K,j);const q=T.from(K,j.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return C.is(q.execution)&&await this.addCustomExecution(q,K,!0),await this.resolveTaskInternal(q)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,W,j){const $=await this._proxy.$createTaskId(N);!j&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,W.execution)),this._providedCustomExecutions2.set($,W.execution)}async getTaskExecution(N,W){if(typeof N=="string"){const K=this._taskExecutionPromises.get(N);if(!K)throw new n.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return K}const j=this._taskExecutionPromises.get(N.id);if(j)return j;let $;return W?$=Promise.resolve(new f(this,N.id,W)):$=T.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(K=>{if(!K)throw new n.ErrorNoTelemetry("Unexpected: Task does not exist.");return new f(this,N.id,K)}),this._taskExecutionPromises.set(N.id,$),$.then(K=>(this._taskExecutions.set(N.id,K),K))}checkDeprecation(N,W){N._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const j=this._notProvidedCustomExecutions.values();let $=j.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=j.next()}};e.ExtHostTaskBase=b,e.ExtHostTaskBase=b=Ge([Ve(0,a.IExtHostRpcService),Ve(1,y.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,p.IExtHostDocumentsAndEditors),Ve(4,o.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,c.IExtHostApiDeprecationService)],b);let M=class extends b{constructor(N,W,j,$,K,q,ae,Ee){super(N,W,j,$,K,q,ae,Ee),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:s.PlatformToString(s.Platform.Web)})}async executeTask(N,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const j=T.from(W,N);if(j===void 0)throw new Error("Task is not valid");if(C.is(j.execution))await this.addCustomExecution(j,W,!1);else throw new n.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(j),W);return this._proxy.$executeTask(j).catch(K=>{throw new Error(K)}),$}provideTasksInternal(N,W,j,$){const K=[];if($)for(const q of $){if(this.checkDeprecation(q,j),!q.definition||!N[q.definition.type]){const Ee=q.source?q.source:"No task source";this._logService.warn(`The task [${Ee}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=T.from(q,j.extension);ae&&C.is(ae.execution)?(K.push(ae),W.push(this.addCustomExecution(ae,q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:K,extension:j.extension}}async resolveTaskInternal(N){if(C.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,W,j){}};e.WorkerExtHostTask=M,e.WorkerExtHostTask=M=Ge([Ve(0,a.IExtHostRpcService),Ve(1,y.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,p.IExtHostDocumentsAndEditors),Ve(4,o.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,c.IExtHostApiDeprecationService)],M),e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(Le[268],Ne([1,0,44,32]),function(Se,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=P,e.genericCellMatchesToTextSearchMatches=O;function P(A){return"cellResults"in A}e.rawCellPrefix="rawCell#";function O(A,R){let p=-1;const o=[];let I=[];return A.forEach(a=>{a.range.startLineNumber!==p&&I.length>0&&(o.push([...I]),I=[]),I.push(a),p=a.range.endLineNumber}),I.length>0&&o.push([...I]),o.map(a=>{const y=[],h=a[0].range.startLineNumber,r=a[a.length-1].range.endLineNumber;for(let s=h;s<=r;s++)y.push(R.getLineContent(s));return new S.TextSearchMatch(y.join(`
`)+`
`,a.map(s=>new k.Range(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Le[269],Ne([1,0,9,22,6,4,28,37,12,14,2,29,79,5,33,8,7,39,246,124,25,15,44,199,268,266]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n,t,g,u,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0,w=We(w),r=We(r),s=We(s);class d{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(_=>_.apiEditor)}constructor(_,E,T,D,f,b,M){this._textDocumentsAndEditors=T,this._textDocuments=D,this._extHostFileSystem=f,this._extHostSearch=b,this._logService=M,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new P.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new P.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new P.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new P.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new a.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=_.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=_.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=_.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=E.converter,E.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===R.MarshalledId.NotebookCellActionContext){const N=L.notebookEditor?.notebookUri,W=L.cell.handle,$=this._documents.get(N)?.getCell(W);if($)return $.apiCell}if(L&&L.$mid===R.MarshalledId.NotebookActionContext){const N=L.uri,W=this._documents.get(N);if(W)return W.apiNotebook}return L}}),d._registerApiCommands(E)}getEditorById(_){const E=this._editors.get(_);if(!E)throw new Error(`unknown text editor: ${_}. known editors: ${[...this._editors.keys()]} `);return E}getIdByEditor(_){for(const[E,T]of this._editors)if(T.apiEditor===_)return E}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(_,E){const T=this._documents.get(_);if(!T&&!E)throw new Error(`NO notebook document for '${_}'`);return T}static _convertNotebookRegistrationData(_,E){if(!E)return;const T=E.filenamePattern.map(D=>r.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(E.filenamePattern&&!T){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:_.identifier,providerDisplayName:_.displayName||_.name,displayName:E.displayName,filenamePattern:T,priority:E.exclusive?m.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(_,E,T){const D=d._notebookStatusBarItemProviderHandlePool++,f=typeof T.onDidChangeCellStatusBarItems=="function"?d._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(D,T),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(D,f,E);let b;return f!==void 0&&(b=T.onDidChangeCellStatusBarItems(M=>this._notebookProxy.$emitCellStatusBarEvent(f))),new s.Disposable(()=>{this._notebookStatusBarItemProviders.delete(D),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(D,f),b?.dispose()})}async createNotebookDocument(_){const E=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:_.viewType,content:_.content&&r.NotebookData.from(_.content)});return I.URI.revive(E)}async openNotebookDocument(_){const E=this._documents.get(_);if(E)return E.apiNotebook;const T=await this._notebookDocumentsProxy.$tryOpenNotebook(_),D=this._documents.get(I.URI.revive(T));return(0,o.assertIsDefined)(D?.apiNotebook)}async showNotebookDocument(_,E){I.URI.isUri(_)&&(_=await this.openNotebookDocument(_));let T;typeof E=="object"?T={position:r.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(r.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:T={preserveFocus:!1};const D=await this._notebookEditorsProxy.$tryShowNotebookDocument(_.uri,_.notebookType,T),f=D&&this._editors.get(D)?.apiEditor;if(f)return f;throw D?new Error(`Could NOT open editor for "${_.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${_.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(_,E,T,D){const f=this._notebookStatusBarItemProviders.get(_),b=I.URI.revive(E),M=this._documents.get(b);if(!M||!f)return;const L=M.getCellFromIndex(T);if(!L)return;const N=await f.provideCellStatusBarItems(L.apiCell,D);if(!N)return;const W=new O.DisposableStore,j=this._statusBarCache.add([W]),K=(Array.isArray(N)?N:[N]).map(q=>r.NotebookStatusBarItem.from(q,this._commandsConverter,W));return{cacheId:j,items:K}}$releaseNotebookCellStatusBarItems(_){this._statusBarCache.delete(_)}registerNotebookSerializer(_,E,T,D,f){if((0,p.isFalsyOrWhitespace)(E))throw new Error("viewType cannot be empty or just whitespace");const b=this._handlePool++;return this._notebookSerializer.set(b,{viewType:E,serializer:T,options:D}),this._notebookProxy.$registerNotebookSerializer(b,{id:_.identifier,location:_.extensionLocation},E,r.NotebookDocumentContentOptions.from(D),d._convertNotebookRegistrationData(_,f)),(0,O.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(b)})}async $dataToNotebook(_,E,T){const D=this._notebookSerializer.get(_);if(!D)throw new Error("NO serializer found");const f=await D.serializer.deserializeNotebook(E.buffer,T);return new l.SerializableObjectWithBuffers(r.NotebookData.from(f))}async $notebookToData(_,E,T){const D=this._notebookSerializer.get(_);if(!D)throw new Error("NO serializer found");const f=await D.serializer.serializeNotebook(r.NotebookData.to(E.value),T);return k.VSBuffer.wrap(f)}async $saveNotebook(_,E,T,D,f){const b=I.URI.revive(E),M=this._notebookSerializer.get(_);if(this.trace(`enter saveNotebook(versionId: ${T}, ${b.toString()})`),!M)throw new Error("NO serializer found");const L=this._documents.get(b);if(!L)throw new Error("Document NOT found");if(L.versionId!==T)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(b.scheme))throw new w.FileOperationError((0,S.localize)(10828,null,this._resourceForError(b)),w.FileOperationResult.FILE_PERMISSION_DENIED);const N={metadata:(0,n.filter)(L.apiNotebook.metadata,q=>!(M.options?.transientDocumentMetadata??{})[q]),cells:[]};for(const q of L.apiNotebook.getCells()){const ae=new s.NotebookCellData(q.kind,q.document.getText(),q.document.languageId,q.mime,M.options?.transientOutputs?[]:[...q.outputs],q.metadata,q.executionSummary);ae.metadata=(0,n.filter)(q.metadata,Ee=>!(M.options?.transientCellMetadata??{})[Ee]),N.cells.push(ae)}if(await this._validateWriteFile(b,D),f.isCancellationRequested)throw new Error("canceled");const W=await M.serializer.serializeNotebook(N,f);if(f.isCancellationRequested)throw new Error("canceled");this.trace(`serialized versionId: ${T} ${b.toString()}`),await this._extHostFileSystem.value.writeFile(b,W),this.trace(`Finished write versionId: ${T} ${b.toString()}`);const j=this._extHostFileSystem.getFileSystemProviderExtUri(b.scheme),$=await this._extHostFileSystem.value.stat(b),K={name:j.basename(b),isFile:($.type&w.FileType.File)!==0,isDirectory:($.type&w.FileType.Directory)!==0,isSymbolicLink:($.type&w.FileType.SymbolicLink)!==0,mtime:$.mtime,ctime:$.ctime,size:$.size,readonly:!!(($.permissions??0)&w.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(b.scheme),locked:!!(($.permissions??0)&w.FilePermission.Locked),etag:w.etag({mtime:$.mtime,size:$.size}),children:void 0};return this.trace(`exit saveNotebook(versionId: ${T}, ${b.toString()})`),K}async $searchInNotebooks(_,E,T,D,f){const b=this._notebookSerializer.get(_)?.serializer;if(!b)return{limitHit:!1,results:[]};const M=new A.ResourceSet;await(async($,K,q)=>{await Promise.all($.map(async ae=>await Promise.all(ae.filenamePatterns.map(Ee=>{const ce={_reason:q._reason,folderQueries:q.folderQueries,includePattern:q.includePattern,excludePattern:q.excludePattern,maxResults:q.maxResults,type:g.QueryType.File,filePattern:Ee};return this._extHostSearch.doInternalFileSearchWithCustomCallback(ce,K,Z=>{Z.forEach(le=>{M.has(le)||D.some(oe=>ae.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(De=>(0,m.globMatchesResource)(De,le)))||M.add(le)})}).catch(Z=>{if(Z.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Z})}))))})(T,f,E);const N=new A.ResourceMap;let W=!1;const j=Array.from(M).map(async $=>{const K=[];try{if(f.isCancellationRequested)return;if(E.maxResults&&[...N.values()].reduce((ce,Z)=>ce+Z.cellResults.length,0)>E.maxResults){W=!0;return}const q=[],ae=this._documents.get($);if(ae)ae.apiNotebook.getCells().forEach(Z=>q.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(le=>le.items.map(me=>me.data.toString()))}));else{const ce=await this._extHostFileSystem.value.readFile($),Z=k.VSBuffer.fromString(ce.toString()),le=await b.deserializeNotebook(Z.buffer,f);if(f.isCancellationRequested)return;r.NotebookData.from(le).cells.forEach(oe=>q.push({input:oe.source,outputs:oe.outputs.flatMap(De=>De.items.map(Re=>Re.valueBytes.toString()))}))}if(f.isCancellationRequested)return;q.forEach((ce,Z)=>{const le=E.contentPattern.pattern,me=new u.CellSearchModel(ce.input,void 0,ce.outputs),oe=me.findInInputs(le),De=me.findInOutputs(le),Re=De.flatMap(Q=>(0,v.genericCellMatchesToTextSearchMatches)(Q.matches,Q.textBuffer)).map((Q,z)=>(Q.webviewIndex=z,Q));if(oe.length>0||De.length>0){const Q={index:Z,contentResults:(0,v.genericCellMatchesToTextSearchMatches)(oe,me.inputTextBuffer),webviewResults:Re};K.push(Q)}});const Ee={resource:$,cellResults:K};N.set($,Ee);return}catch{return}});return await Promise.all(j),{limitHit:W,results:[...N.values()]}}async _validateWriteFile(_,E){const T=await this._extHostFileSystem.value.stat(_);if(typeof E?.mtime=="number"&&typeof E.etag=="string"&&E.etag!==w.ETAG_DISABLED&&typeof T.mtime=="number"&&typeof T.size=="number"&&E.mtime<T.mtime&&E.etag!==w.etag({mtime:E.mtime,size:T.size}))throw new w.FileOperationError((0,S.localize)(10829,null),w.FileOperationResult.FILE_MODIFIED_SINCE,E)}_resourceForError(_){return _.scheme===t.Schemas.file?_.fsPath:_.toString()}_createExtHostEditor(_,E,T){if(this._editors.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const D=new i.ExtHostNotebookEditor(E,this._notebookEditorsProxy,_,T.visibleRanges.map(r.NotebookRange.to),T.selections.map(r.NotebookRange.to),typeof T.viewColumn=="number"?r.ViewColumn.to(T.viewColumn):void 0);this._editors.set(E,D)}$acceptDocumentAndEditorsDelta(_){if(_.value.removedDocuments)for(const T of _.value.removedDocuments){const D=I.URI.revive(T),f=this._documents.get(D);f&&(f.dispose(),this._documents.delete(D),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(b=>b.document.uri)}),this._onDidCloseNotebookDocument.fire(f.apiNotebook));for(const b of this._editors.values())b.notebookData.uri.toString()===D.toString()&&this._editors.delete(b.id)}if(_.value.addedDocuments){const T=[];for(const D of _.value.addedDocuments){const f=I.URI.revive(D.uri);if(this._documents.has(f))throw new Error(`adding EXISTING notebook ${f} `);const b=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,f,D);T.push(...D.cells.map(M=>c.ExtHostCell.asModelAddData(M))),this._documents.get(f)?.dispose(),this._documents.set(f,b),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:T}),this._onDidOpenNotebookDocument.fire(b.apiNotebook)}}if(_.value.addedEditors)for(const T of _.value.addedEditors){if(this._editors.has(T.id))return;const D=I.URI.revive(T.documentUri),f=this._documents.get(D);f&&this._createExtHostEditor(f,T.id,T)}const E=[];if(_.value.removedEditors)for(const T of _.value.removedEditors){const D=this._editors.get(T);D&&(this._editors.delete(T),this._activeNotebookEditor?.id===D.id&&(this._activeNotebookEditor=void 0),E.push(D))}if(_.value.visibleEditors){this._visibleNotebookEditors=_.value.visibleEditors.map(D=>this._editors.get(D)).filter(D=>!!D);const T=new Set;this._visibleNotebookEditors.forEach(D=>T.add(D.id));for(const D of this._editors.values()){const f=T.has(D.id);D._acceptVisibility(f)}this._visibleNotebookEditors=[...this._editors.values()].map(D=>D).filter(D=>D.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}_.value.newActiveEditor===null?this._activeNotebookEditor=void 0:_.value.newActiveEditor&&(this._editors.get(_.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${_.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(_.value.newActiveEditor)),_.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(_){const E=h.ApiCommandArgument.String.with("notebookType","A notebook type"),T=new h.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new h.ApiCommandArgument("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>k.VSBuffer.wrap(f))],new h.ApiCommandResult("Notebook Data",f=>r.NotebookData.to(f.value))),D=new h.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new h.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new l.SerializableObjectWithBuffers(r.NotebookData.from(f)))],new h.ApiCommandResult("Bytes",f=>f.buffer));_.registerApiCommand(T),_.registerApiCommand(D)}trace(_){this._logService.trace(`[Extension Host Notebook] ${_}`)}}e.ExtHostNotebookController=d}),define(Le[270],Ne([1,0,19,21,42,41,23,69,44]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0,S=We(S),O=We(O),A=We(A);class o{constructor(a,y,h){this.config=a,this.provider=y,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&O.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&O.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const y=this.config.folderQueries||[];return new Promise((h,r)=>{const s=l=>{this.resultCount++,a(l)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(l=>{const c=l.toString(),i=S.basename(c);this.globalExcludePattern&&this.globalExcludePattern(c,i)||this.matchFile(s,{base:l,basename:i})}),Promise.all(y.map(l=>this.searchInFolder(l,s))).then(l=>{h({limitHit:this.isLimitHit,stats:l[0]||void 0})},l=>{r(new Error((0,P.toErrorMessage)(l)))})})}async searchInFolder(a,y){const h=new k.CancellationTokenSource,r=this.getSearchOptionsForFolder(a),s=this.initDirectoryTree(),l=new p.QueryGlobTester(this.config,a),c=!l.hasSiblingExcludeClauses();let i;try{this.activeCancellationTokens.add(h),i=R.StopWatch.create();const n=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},r,h.token),t=i.elapsed(),g=R.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(n&&n.forEach(u=>{const v=S.posix.relative(a.folder.path,u.path);if(c){const m=S.basename(u.path);this.matchFile(y,{base:a.folder,relativePath:v,basename:m});return}this.addDirectoryEntries(s,a.folder,v,y)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(s,l,y),{providerTime:t,postProcessTime:g.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(a){const y=(0,p.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),h=(0,p.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:h,includes:y,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},y,h,r){if(h===this.filePattern){const l=S.basename(this.filePattern);this.matchFile(r,{base:y,relativePath:this.filePattern,basename:l})}function s(l){const c=S.basename(l),i=S.dirname(l);let n=a[i];n||(n=a[i]=[],s(i)),n.push({base:y,relativePath:l,basename:c})}s(h)}matchDirectoryTree({rootEntries:a,pathToEntries:y},h,r){const s=this,l=this.filePattern;function c(i){const n=(0,p.hasSiblingFn)(()=>i.map(t=>t.basename));for(let t=0,g=i.length;t<g;t++){const u=i[t],{relativePath:v,basename:m}=u;if(h.matchesExcludesSync(v,m,l!==m?n:void 0))continue;const d=y[v];if(d)c(d);else{if(v===l)continue;s.matchFile(r,u)}if(s.isLimitHit)break}}c(a)}matchFile(a,y){(!this.includePattern||y.relativePath&&this.includePattern(y.relativePath,y.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(y))}}class I{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(a,y,h,r){const s=this.getSessionTokenSource(a.cacheKey),l=new o(a,y,s&&s.token);let c=0;const i=n=>{c+=n.length,h(n.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(l,I.BATCH_SIZE,i,r).then(n=>({limitHit:n.limitHit,stats:n.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:n.stats}:void 0,messages:[]}))}clearCache(a){this.getSessionTokenSource(a)?.cancel()}getSessionTokenSource(a){if(a)return this.sessions.has(a)||this.sessions.set(a,new k.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:A.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,y,h,r){const s=r.onCancellationRequested(()=>{a.cancel()}),l=i=>{i&&(c.push(i),y>0&&c.length>=y&&(h(c),c=[]))};let c=[];return a.search(l).then(i=>(c.length&&h(c),s.dispose(),i),i=>(c.length&&h(c),s.dispose(),Promise.reject(i)))}}e.FileSearchManager=I}),define(Le[271],Ne([1,0,17,240,41,99,28,15,19,23,12,14,2,102,9,43,11,49,118,267,44]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.resolveResourcesForSearchIncludes=E,S=We(S),k=We(k),P=We(P),p=We(p),I=We(I),h=We(h);let t=class{constructor(D,f,b,M,L){this.configurationService=D,this.workspaceContextService=f,this.editorGroupsService=b,this.logService=M,this.pathService=L}text(D,f,b={}){D=this.getContentPattern(D,b);const M=this.configurationService.getValue(),L=f&&f.some(W=>!this.configurationService.getValue({resource:W}).search.useRipgrep);return{...this.commonQuery(f?.map(l.toWorkspaceFolder),b),type:n.QueryType.Text,contentPattern:D,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:M.search.usePCRE2||L||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}getContentPattern(D,f){const b=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const M={...D,wordSeparators:b.editor.wordSeparators};return this.isCaseSensitive(D,f)&&(M.isCaseSensitive=!0),this.isMultiline(D)&&(M.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),M}file(D,f={}){return{...this.commonQuery(D,f),type:n.QueryType.File,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey,shouldGlobMatchFilePattern:f.shouldGlobSearch}}handleIncludeExclude(D,f){return D?(D=Array.isArray(D)?D.map(d):d(D),f?this.parseSearchPaths(D):{pattern:u(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],f={}){const b=this.handleIncludeExclude(f.includePattern,f.expandPatterns),M=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),L=D.length>1,N=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map($=>this.getFolderQueryForSearchPath($,f,M)):D.map($=>this.getFolderQueryForRoot($,f,M,L))).filter($=>!!$),W={_reason:f._reason,folderQueries:N,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:M.pattern,includePattern:b.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const $=S.coalesce(this.editorGroupsService.groups.flatMap(ae=>ae.editors.map(Ee=>Ee.resource)));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify($));const K=$.filter(ae=>(0,n.pathIncludedInQuery)(W,ae.fsPath)),q=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...W,...q}}const j=f.extraFileResources&&f.extraFileResources.filter($=>(0,n.pathIncludedInQuery)(W,$.fsPath));return W.extraFileResources=j&&j.length?j:void 0,W}commonQueryFromFileList(D){const f=[],b=new A.ResourceMap,M={};let L=!1;return D.forEach(N=>{if(N.scheme===R.Schemas.walkThrough)return;if((0,o.isAbsolutePath)(N)){const j=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:p.dirname(N.fsPath)});let $=b.get(j);$||(L=!0,$={folder:j,includePattern:{}},f.push($),b.set(j,$));const K=p.relative(j.fsPath,N.fsPath);(0,w.assertIsDefined)($.includePattern)[K.replace(/\\/g,"/")]=!0}else N.fsPath&&(L=!0,M[N.fsPath]=!0)}),{folderQueries:f,includePattern:M,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(D,f){if(f.isSmartCase){if(D.isRegExp){if(I.containsUppercaseCharacter(D.pattern,!0))return!0}else if(I.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,y.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const f=q=>p.isAbsolute(q)||/^\.\.?([\/\\]|$)/.test(q),M=(Array.isArray(D)?D:v(D)).map(q=>{const ae=this.pathService.resolvedUserHome;return ae?(0,O.untildify)(q,ae.scheme===R.Schemas.file?ae.fsPath:ae.path):q}),L=k.groupBy(M,q=>f(q)?"searchPaths":"exprSegments"),N=(L.exprSegments||[]).map(q=>I.rtrim(q,"/")).map(q=>I.rtrim(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),m(q))),W={},j=this.expandSearchPathPatterns(L.searchPaths||[]);j&&j.length&&(W.searchPaths=j);const $=N.flat(),K=u(...$);return K&&(W.pattern=K),W}getExcludesForFolder(D,f){return f.disregardExcludeSettings?void 0:(0,n.getExcludes)(D,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const f=D.flatMap(M=>{let{pathPortion:L,globPortion:N}=g(M);return N&&(N=C(N)),this.expandOneSearchPath(L).flatMap(j=>this.resolveOneSearchPathPattern(j,N))}),b=new Map;return f.forEach(M=>{const L=M.searchPath.toString(),N=b.get(L);N?M.pattern&&(N.pattern=N.pattern||{},N.pattern[M.pattern]=!0):b.set(L,{searchPath:M.searchPath,pattern:M.pattern?u(M.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(D){if(p.isAbsolute(D)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==R.Schemas.file?[{searchPath:f[0].uri.with({path:D})}]:[{searchPath:a.URI.file(p.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===l.WorkbenchState.FOLDER){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=d(D),D.startsWith("../")||D===".."){const M=p.posix.resolve(f.path,D);return[{searchPath:f.with({path:M})}]}const b=C(D);return[{searchPath:f,pattern:b}]}else{if(D==="./"||D===".\\")return[];{const f=D.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(L=>{const N=f.match(new RegExp(`^${I.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return N?{match:N,folder:L}:null}).filter(w.isDefined);if(M.length)return M.map(L=>{const N=L.match[1];return{searchPath:L.folder.uri,pattern:N&&C(N)}});{const L=D.match(/\.[\/\\](.+)[\/\\]?/),N=L?L[1]:D,W=h.localize(1633,null,N);throw new Error(W)}}}}resolveOneSearchPathPattern(D,f){const b=D.pattern&&f?`${D.pattern}/${f}`:D.pattern||f,M=[{searchPath:D.searchPath,pattern:b}];return b&&!b.endsWith("**")&&M.push({searchPath:D.searchPath,pattern:b+"/**"}),M}getFolderQueryForSearchPath(D,f,b){const M=this.getFolderQueryForRoot((0,l.toWorkspaceFolder)(D.searchPath),f,b,!1);return M?{...M,includePattern:D.pattern}:null}getFolderQueryForRoot(D,f,b,M){let L;const N=a.URI.isUri(D)?D:D.uri;if(b.searchPaths){const q=b.searchPaths.filter(ae=>(0,o.isEqual)(ae.searchPath,N))[0];if(q&&!q.pattern)return null;q&&(L=q.pattern)}const W=this.configurationService.getValue({resource:N}),$={...this.getExcludesForFolder(W,f)||{},...L||{}},K=a.URI.isUri(D)?(0,o.basename)(D):D.name;return{folder:N,folderName:M?K:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!W.search.followSymlinks}}};e.QueryBuilder=t,e.QueryBuilder=t=Ge([Ve(0,r.IConfigurationService),Ve(1,l.IWorkspaceContextService),Ve(2,c.IEditorGroupsService),Ve(3,s.ILogService),Ve(4,i.IPathService)],t);function g(T){const D=T.match(/[\*\{\}\(\)\[\]\?]/);if(D){const f=D.index,b=T.substr(0,f).match(/[/|\\][^/\\]*$/);if(b){let M=T.substr(0,b.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:T.substr((b.index||0)+1)}}}return{pathPortion:T}}function u(...T){return T.length?T.reduce((D,f)=>(D[f]=!0,D),Object.create(null)):void 0}function v(T){return P.splitGlobAware(T,",").map(D=>D.trim()).filter(D=>!!D.length)}function m(T){return[`**/${T}/**`,`**/${T}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function d(T){return T.replace(/\\/g,"/")}function C(T){return d(T).replace(/^\.\//,"").replace(/\/+$/g,"")}function _(T){return T.replace(/([?*[\]])/g,"[$1]")}function E(T,D){T=S.distinct(T,M=>M.toString());const f=[],b=D.getWorkspace();return T&&T.forEach(M=>{let L;if(D.getWorkbenchState()===l.WorkbenchState.FOLDER)L=(0,o.relativePath)(b.folders[0].uri,M),L&&L!=="."&&(L="./"+L);else{const N=D.getWorkspaceFolder(M);if(N){const W=N.name;if(b.folders.filter($=>$.name===W).length===1){const $=(0,o.relativePath)(N.uri,M);$===""?L=`./${N.name}`:L=`./${N.name}/${$}`}else L=M.fsPath}}L&&f.push(_(L))}),f}}),define(Le[272],Ne([1,0,23,2,21,13,3,271,44,49,10]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=a,e.checkGlobFileExists=r,S=We(S),O=We(O);const w=7e3;function a(s,l){const c=l.activationEvents;if(!c)return Promise.resolve(void 0);const i=[],n=[];for(const d of c)if(/^workspaceContains:/.test(d)){const C=d.substr(18);C.indexOf("*")>=0||C.indexOf("?")>=0||s.forceUsingSearch?n.push(C):i.push(C)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:g}=(0,I.promiseWithResolvers)(),u=d=>g({activationEvent:d}),v=Promise.all(i.map(d=>y(s,d,u))).then(()=>{}),m=h(s,l.identifier,n,u);return Promise.all([v,m]).then(()=>{g(void 0)}),t}async function y(s,l,c){for(const i of s.folders)if(await s.exists(S.joinPath(k.URI.revive(i),l))){c(`workspaceContains:${l}`);return}}async function h(s,l,c,i){if(c.length===0)return Promise.resolve(void 0);const n=new P.CancellationTokenSource,t=s.checkExists(s.folders,c,n.token),g=setTimeout(async()=>{n.cancel(),s.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},w);let u=!1;try{u=await t}catch(v){O.isCancellationError(v)||O.onUnexpectedError(v)}n.dispose(),clearTimeout(g),u&&i(`workspaceContains:${c.join(",")}`)}function r(s,l,c,i){const n=s.get(A.IInstantiationService),t=s.get(p.ISearchService),u=n.createInstance(R.QueryBuilder).file(l.map(v=>(0,o.toWorkspaceFolder)(k.URI.revive(v))),{_reason:"checkExists",includePattern:c,exists:!0});return t.fileSearch(u,i).then(v=>!!v.limitHit,v=>O.isCancellationError(v)?!1:Promise.reject(v))}}),define(Le[47],Ne([1,0,9,19,64,23,10,4,58,2,11,5,46,206,88,45,24,119,13,18,22,189,7,109,3,26,91,16,74,92,56,94,6,272,87,191,15,85,69,20,86]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n,t,g,u,v,m,d,C,_,E,T,D,f,b,M,L,N,W,j,$,K){"use strict";var q;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,S=We(S),k=We(k),P=We(P),c=We(c),e.IHostUtils=(0,v.createDecorator)("IHostUtils");let ae=q=class extends R.Disposable{constructor(Q,z,ne,Ce,fe,be,de,X,J,ve,pe,Ae,Ue){super(),this._extHostManagedSockets=Ae,this._extHostLanguageModels=Ue,this._onDidChangeRemoteConnectionData=this._register(new f.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=z,this._extHostContext=ne,this._initData=de,this._extHostWorkspace=Ce,this._extHostConfiguration=fe,this._logService=be,this._extHostTunnelService=J,this._extHostTerminalService=ve,this._extHostLocalizationService=pe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new De(this._initData.extensions.activationEvents),this._globalRegistry=new l.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const Ie=new i.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new l.ExtensionDescriptionRegistry(this._activationEventsReader,me(this._globalRegistry,Ie)),$.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${Z(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${Z(this._myRegistry)}`)),this._storage=new h.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=X,this._instaService=this._store.add(Q.createChild(new _.ServiceCollection([h.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]))),this._activator=this._register(new y.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Pe,Oe,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Pe,c.transformErrorForSerialization(Oe),x)},actualActivateExtension:async(Pe,Oe)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(Pe,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Pe,Oe),new y.HostExtension;const x=this._myRegistry.getExtensionDescription(Pe);return this._activateExtension(x,Oe)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),P.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){c.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch{}await Promise.all(Q)}terminate(Q,z=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),c.setUnexpectedErrorHandler(Ce=>{this._logService.error(Ce)}),this._extHostContext.dispose();const ne=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),ne]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${z}`):this._logService.info(`Extension host exiting with code ${z}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(z)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const z=await this._mainThreadExtensionsProxy.$getExtension(Q);return z&&{...z,identifier:new i.ExtensionIdentifier(z.identifier.value),extensionLocation:o.URI.revive(z.extensionLocation)}}_activateByEvent(Q,z){return this._activator.activateByEvent(Q,z)}_activateById(Q,z){return this._activator.activateById(Q,z)}activateByIdWithErrors(Q,z){return this._activateById(Q,z).then(()=>{const ne=this._activator.getActivatedExtension(Q);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(Q).exports;try{return this._activator.getActivatedExtension(Q).exports}catch{return null}}async _realPathExtensionUri(Q){if(Q.scheme===N.Schemas.file&&this._hostUtils.fsRealpath){const z=Q.fsPath;this._realPathCache.has(z)||this._realPathCache.set(z,this._hostUtils.fsRealpath(z));const ne=await this._realPathCache.get(z);return o.URI.file(ne)}return Q}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new oe(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const z=p.TernarySearchTree.forUris(ne=>O.extUriBiasedIgnorePathCase.ignorePathCasing(ne));return await Promise.all(Q.map(async ne=>{if(this._getEntryPoint(ne)){const Ce=await this._realPathExtensionUri(ne.extensionLocation);z.set(Ce,ne)}})),z}_deactivate(Q){let z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return z;const ne=this._activator.getActivatedExtension(Q);if(!ne)return z;try{typeof ne.module.deactivate=="function"&&(z=Promise.resolve(ne.module.deactivate()).then(void 0,Ce=>(this._logService.error(Ce),Promise.resolve(void 0))))}catch(Ce){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(Ce)}try{ne.disposable.dispose()}catch(Ce){this._logService.error(`An error occurred when disposing the subscriptions for extension '${Q.value}':`),this._logService.error(Ce)}return z}async _activateExtension(Q,z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,z).then(ne=>{const Ce=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,z),this._logExtensionActivationTimes(Q,z,"success",Ce),ne},ne=>{throw this._logExtensionActivationTimes(Q,z,"failure"),ne})}_logExtensionActivationTimes(Q,z,ne,Ce){const fe=ce(Q,z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...fe,...Ce||{},outcome:ne})}_doActivateExtension(Q,z){const ne=ce(Q,z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const Ce=this._getEntryPoint(Q);if(!Ce)return Promise.resolve(new y.EmptyExtension(y.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${Q.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this._logService.flush();const fe=new R.DisposableStore,be=new y.ExtensionActivationTimesBuilder(z.startup);return Promise.all([this._loadCommonJSModule(Q,(0,O.joinPath)(Q.extensionLocation,Ce),be),this._loadExtensionContext(Q,fe)]).then(de=>(P.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),q._callActivate(this._logService,Q.identifier,de[0],de[1],fe,be))).then(de=>(P.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),de))}_loadExtensionContext(Q,z){const ne=this._extHostLanguageModels.createLanguageModelAccessInformation(Q),Ce=z.add(new t.ExtensionGlobalMemento(Q,this._storage)),fe=z.add(new t.ExtensionMemento(Q.identifier.value,!1,this._storage)),be=z.add(new L.ExtensionSecrets(Q,this._secretState)),de=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?g.ExtensionMode.Test:g.ExtensionMode.Development:g.ExtensionMode.Production,X=this._initData.remote.isRemote?g.ExtensionKind.Workspace:g.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([Ce.whenReady,fe.whenReady,this._storagePath.whenReady]).then(()=>{const J=this;let ve,pe;const Ae=(0,s.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(i.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:Ce,workspaceState:fe,secrets:be,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(Ue){return k.join(Q.extensionLocation.fsPath,Ue)},get storagePath(){return J._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return J._storagePath.globalValue(Q).fsPath},get logPath(){return k.join(J._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return o.URI.joinPath(J._initData.logsLocation,Q.identifier.value)},get storageUri(){return J._storagePath.workspaceValue(Q)},get globalStorageUri(){return J._storagePath.globalValue(Q)},get extensionMode(){return de},get extension(){return ve===void 0&&(ve=new le(J,Q.identifier,Q,X,!1)),ve},get extensionRuntime(){return(0,s.checkProposedApiEnabled)(Q,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!pe){if(!Ae)return;const Ue=f.Event.buffer(f.Event.fromDOMEventEmitter(Ae,"message",Ie=>Ie.data));Ae.start(),pe={onDidReceiveMessage:Ue,postMessage:Ae.postMessage.bind(Ae)}}return pe}})})}static _callActivate(Q,z,ne,Ce,fe,be){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,z,ne,Ce,be).then(de=>new y.ActivatedExtension(!1,null,be.build(),ne,de,(0,R.toDisposable)(()=>{fe.dispose(),(0,R.dispose)(Ce.subscriptions)})))}static _callActivateOptional(Q,z,ne,Ce,fe){if(typeof ne.activate=="function")try{fe.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${z.value}`);const be=typeof global=="object"?global:self,de=ne.activate.apply(be,[Ce]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(de).then(X=>(fe.activateResolveStop(),X))}catch(be){return Promise.reject(be)}else return Promise.resolve(ne)}_activateOneStartupFinished(Q,z){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:z}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinishedDeferred(Q,z=0){const Ce=Date.now();(0,$.setTimeout0)(()=>{for(let fe=z;fe<Q.length;fe+=1){const be=Q[fe];for(const de of be.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-Ce>50){this._activateAllStartupFinishedDeferred(Q,fe);break}else this._activateOneStartupFinished(be,de)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(P.getMarks()),this._extHostConfiguration.getConfigProvider().then(Q=>{const z=Q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this._myRegistry.getAllExtensionDescriptions();if(z)this._activateAllStartupFinishedDeferred(ne);else for(const Ce of ne)if(Ce.activationEvents)for(const fe of Ce.activationEvents)fe==="onStartupFinished"&&this._activateOneStartupFinished(Ce,fe)})}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(z),Ce=this._handleRemoteResolverEagerExtensions(),fe=Promise.all([Ce,Q,ne]).then(()=>{});return Promise.race([fe,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),fe}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(z=>this._handleWorkspaceContainsEagerExtension(Q,z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,z){if(this.isActivated(z.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Ce={logService:this._logService,folders:Q.map(be=>be.uri),forceUsingSearch:ne||!this._hostUtils.fsExists,exists:be=>this._hostUtils.fsExists(be.fsPath),checkExists:(be,de,X)=>this._mainThreadWorkspaceProxy.$checkExists(be,de,X)},fe=await(0,b.checkActivateWorkspaceContainsExtension)(Ce,z);if(fe)return this._activateById(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:fe.activationEvent}).then(void 0,be=>this._logService.error(be))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:z}=this._initData.environment;if(!Q||!z)throw new Error(S.localize(10836,null));const ne=await this._loadCommonJSModule(null,z,new y.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(S.localize(10837,null,z.toString()));return new Promise((Ce,fe)=>{const be=(J,ve)=>{J?($.isCI&&this._logService.error("Test runner called back with error",J),fe(J)):($.isCI&&(ve?this._logService.info(`Test runner called back with ${ve} failures.`):this._logService.info("Test runner called back with successful outcome.")),Ce(typeof ve=="number"&&ve>0?1:0))},de=(0,O.originalFSPath)(z),X=ne.run(de,be);X&&X.then&&X.then(()=>{$.isCI&&this._logService.info("Test runner finished successfully."),Ce(0)}).catch(J=>{$.isCI&&this._logService.error("Test runner finished with error",J),fe(J instanceof Error&&J.stack?J.stack:String(J))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,z){return this._resolvers[Q]=z,(0,R.toDisposable)(()=>{delete this._resolvers[Q]})}async getRemoteExecServer(Q){const{resolver:z}=await this._activateAndGetResolver(Q);return z?.resolveExecServer?.(Q,{resolveAttempt:0})}async _activateAndGetResolver(Q){const z=Q.indexOf("+");if(z===-1)throw new g.RemoteAuthorityResolverError("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Q.substr(0,z);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(Q,z){const ne=j.StopWatch.create(!1),Ce=()=>`[resolveAuthority(${(0,u.getRemoteAuthorityPrefix)(Q)},${z})][${ne.elapsed()}ms] `,fe=B=>this._logService.info(`${Ce()}${B}`),be=B=>this._logService.warn(`${Ce()}${B}`),de=(B,H=void 0)=>this._logService.error(`${Ce()}${B}`,H),X=B=>{if(B instanceof g.RemoteAuthorityResolverError)return{type:"error",error:{code:B._code,message:B._message,detail:B._detail}};throw B},J=async B=>{fe(`activating resolver for ${B}...`);const{resolver:H,authorityPrefix:V}=await this._activateAndGetResolver(B);if(!H)throw de(`no resolver for ${V}`),new g.RemoteAuthorityResolverError(`No remote extension installed to resolve ${V}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:V,remoteAuthority:B}},ve=Q.split(/@|%40/g).reverse();fe(`activating remote resolvers ${ve.join(" -> ")}`);let pe;try{pe=await Promise.all(ve.map(J)).catch(async B=>{if(!(B instanceof g.RemoteAuthorityResolverError)||B._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw B;return be(`resolving nested authorities failed: ${B.message}`),[await J(Q)]})}catch(B){return X(B)}const Ae=new A.IntervalTimer;Ae.cancelAndSet(()=>fe("waiting..."),1e3);let Ue,Ie;for(const[B,{authorityPrefix:H,resolver:V,remoteAuthority:re}]of pe.entries())try{if(B===pe.length-1)fe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${H}`),Ue=await V.resolve(re,{resolveAttempt:z,execServer:Ie}),P.mark(`code/extHost/didResolveAuthorityOK/${H}`),fe("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(V,g.ManagedResolvedAuthority.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(fe(`invoking resolveExecServer() for ${re}`),P.mark(`code/extHost/willResolveExecServer/${H}`),Ie=await V.resolveExecServer?.(re,{resolveAttempt:z,execServer:Ie}),!Ie)throw new g.RemoteAuthorityResolverError(`Exec server was not available for ${re}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ge){return P.mark(`code/extHost/didResolveAuthorityError/${H}`),de("returned an error",ge),Ae.dispose(),X(ge)}Ae.dispose();const Pe={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};fe(`returned ${g.ManagedResolvedAuthority.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let x;if(g.ManagedResolvedAuthority.isManagedResolvedAuthority(Ue)){const B=z;this._extHostManagedSockets.setFactory(B,Ue.makeConnection),x={authority:Q,connectTo:new u.ManagedRemoteConnection(B),connectionToken:Ue.connectionToken}}else x={authority:Q,connectTo:new u.WebSocketRemoteConnection(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:x,options:Oe,tunnelInformation:Pe}}}async $getCanonicalURI(Q,z){this._logService.info(`$getCanonicalURI invoked for authority (${(0,u.getRemoteAuthorityPrefix)(Q)})`);const{resolver:ne}=await this._activateAndGetResolver(Q);if(!ne)return null;const Ce=o.URI.revive(z);if(typeof ne.getCanonicalURI>"u")return Ce;const fe=await(0,A.asPromise)(()=>ne.getCanonicalURI(Ce));return fe||Ce}async $startExtensionHost(Q){Q.toAdd.forEach(be=>be.extensionLocation=o.URI.revive(be.extensionLocation));const{globalRegistry:z,myExtensions:ne}=Ee(this._activationEventsReader,this._globalRegistry,this._myRegistry,Q),Ce=await this._createExtensionPathIndex(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this._globalRegistry.set(z.getAllExtensionDescriptions()),this._myRegistry.set(ne),$.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${Z(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${Z(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(Q,z){return z===s.ActivationKind.Immediate?this._almostReadyToRunExtensions.wait().then(ne=>this._activateByEvent(Q,!1)):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(Q,!1))}async $activate(Q,z){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,z),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(be=>be.extensionLocation=o.URI.revive(be.extensionLocation));const{globalRegistry:z,myExtensions:ne}=Ee(this._activationEventsReader,this._globalRegistry,this._myRegistry,Q),Ce=await this._createExtensionPathIndex(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this._globalRegistry.set(z.getAllExtensionDescriptions()),this._myRegistry.set(ne),$.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${Z(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${Z(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const z=n.VSBuffer.alloc(Q),ne=Math.random()%256;for(let Ce=0;Ce<Q;Ce++)z.writeUInt8(ne,Ce);return z}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=ae,e.AbstractExtHostExtensionService=ae=q=Ge([Ve(0,v.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,C.IExtHostRpcService),Ve(3,r.IExtHostWorkspace),Ve(4,a.IExtHostConfiguration),Ve(5,I.ILogService),Ve(6,m.IExtHostInitDataService),Ve(7,d.IExtensionStoragePaths),Ve(8,E.IExtHostTunnelService),Ve(9,T.IExtHostTerminalService),Ve(10,W.IExtHostLocalizationService),Ve(11,K.IExtHostManagedSockets),Ve(12,D.IExtHostLanguageModels)],ae);function Ee(Re,Q,z,ne){Re.addActivationEvents(ne.addActivationEvents);const Ce=new l.ExtensionDescriptionRegistry(Re,Q.getAllExtensionDescriptions());Ce.deltaExtensions(ne.toAdd,ne.toRemove);const fe=new i.ExtensionIdentifierSet(z.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of ne.myToRemove)fe.delete(de);for(const de of ne.myToAdd)fe.add(de);const be=me(Ce,fe);return{globalRegistry:Ce,myExtensions:be}}function ce(Re,Q){return{id:Re.identifier.value,name:Re.name,extensionVersion:Re.version,publisherDisplayName:Re.publisher,activationEvents:Re.activationEvents?Re.activationEvents.join(","):null,isBuiltin:Re.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}function Z(Re){return Re.getAllExtensionDescriptions().map(Q=>Q.identifier.value).join(",")}e.IExtHostExtensionService=(0,v.createDecorator)("IExtHostExtensionService");class le{#e;#t;#i;constructor(Q,z,ne,Ce,fe){this.#e=Q,this.#t=z,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=k.normalize((0,O.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ce,this.isFromDifferentExtensionHost=fe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=le;function me(Re,Q){return Re.getAllExtensionDescriptions().filter(z=>Q.has(z.identifier))}class oe{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=oe;class De{constructor(Q){this._map=new i.ExtensionIdentifierMap,this.addActivationEvents(Q)}readActivationEvents(Q){return this._map.get(Q.identifier)??[]}addActivationEvents(Q){for(const z of Object.keys(Q))this._map.set(z,Q[z])}}}),define(Le[273],Ne([1,0,64,2,5,46,24,18,16,26,3,47,11,12]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0,S=We(S);let r=class{constructor(n,t,g,u,v,m,d){this._apiFactory=n,this._extensionRegistry=t,this._instaService=g,this._extHostConfiguration=u,this._extHostExtensionService=v,this._initData=m,this._logService=d,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),S.mark("code/extHost/willWaitForConfig");const n=await this._extHostConfiguration.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,t,this._extensionRegistry,n,this._logService)),this.register(this._instaService.createInstance(s)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(c,t,this._initData.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this._factories.set(t,n);else this._factories.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this._alternatives.push(t=>n.alternativeModuleName(t))}};e.RequireInterceptor=r,e.RequireInterceptor=r=Ge([Ve(2,I.IInstantiationService),Ve(3,O.IExtHostConfiguration),Ve(4,w.IExtHostExtensionService),Ve(5,o.IExtHostInitDataService),Ve(6,a.ILogService)],r);let s=class{static{h=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&h.aliased.size){const t=(0,y.escapeRegExpCharacters)(this.forceForwardSlashes(n.environment.appRoot.fsPath)),g="[a-z0-9_.-]",u=`@${g}+\\/${g}+|${g}+`,v="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${v}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(n){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(n));if(!t)return;const[,g,u,v]=t,m=h.aliased.get(u);if(m!==void 0)return console.warn(`${u} as been renamed to ${m}, please update your imports`),g+m+v}forceForwardSlashes(n){return n.replace(/\\/g,"/")}};s=h=Ge([Ve(0,o.IExtHostInitDataService)],s);class l{constructor(n,t,g,u,v){this._apiFactory=n,this._extensionPaths=t,this._extensionRegistry=g,this._configProvider=u,this._logService=v,this.nodeModuleName="vscode",this._extApiImpl=new R.ExtensionIdentifierMap}load(n,t){const g=this._extensionPaths.findSubstr(t);if(g){let u=this._extApiImpl.get(g.identifier);return u||(u=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(g.identifier,u)),u}if(!this._defaultApiImpl){let u="";this._extensionPaths.forEach((v,m)=>u+=`	${m} -> ${v.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${u}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let c=class{constructor(n,t,g){this._extensionPaths=n,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(P.MainContext.MainThreadTelemetry);const u=g.getProxy(P.MainContext.MainThreadWindow);this._impl=(v,m)=>{const d=k.URI.parse(v);return m?this.callOriginal(v,m):d.scheme==="http"||d.scheme==="https"?u.$openUri(d,v,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this._appUriScheme?u.$openUri(d,v,{}):this.callOriginal(v,m)}}load(n,t,g){const u=this._extensionPaths.findSubstr(t);return u&&(this._extensionId=u.identifier.value,this.sendShimmingTelemetry()),this._original=g(n),this._impl}callOriginal(n,t){return this.sendNoForwardTelemetry(),this._original(n,t)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};c=Ge([Ve(2,p.IExtHostRpcService)],c)}),define(Le[132],Ne([1,0,48,4,19,78,3,57,70,47,7,45,203,46]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,P=We(P),O=We(O),e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class h extends a.AbstractVariableResolverService{constructor(l,c,i,n,t,g,u){function v(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const d=n.tabGroups.all.find(C=>C.isActive)?.activeTab;if(d!==void 0){if(d.input instanceof I.TextDiffTabInput||d.input instanceof I.NotebookDiffEditorTabInput)return d.input.modified;if(d.input instanceof I.TextTabInput||d.input instanceof I.NotebookEditorTabInput||d.input instanceof I.CustomEditorTabInput)return d.input.uri}}}super({getFolderUri:m=>{const d=g.folders.filter(C=>C.name===m);if(d&&d.length>0)return d[0].uri},getWorkspaceFolderCount:()=>g.folders.length,getConfigurationValue:(m,d)=>t.getConfiguration(void 0,m).get(d),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=v();if(m)return P.normalize(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const m=v();if(m){const d=c.getWorkspaceFolder(m);if(d)return P.normalize(d.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>l.getExtension(m)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(O.env))}}let r=class extends k.Disposable{constructor(l,c,i,n,t){super(),this.extensionService=l,this.workspaceService=c,this.editorService=i,this.configurationService=n,this.editorTabs=t,this._resolver=new S.Lazy(async()=>{const g=await this.configurationService.getConfigProvider(),v={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async m=>{v.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new h(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,g,v,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=r,e.ExtHostVariableResolverProviderService=r=Ge([Ve(0,o.IExtHostExtensionService),Ve(1,w.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,y.IExtHostConfiguration),Ve(4,p.IExtHostEditorTabs)],r)}),define(Le[133],Ne([1,0,10,6,2,4,18,3,5,70,47,16,7,45,195,80,196,46,132,34,33,8,17,95]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,t=We(t),e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let v=class extends O.Disposable{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(D,f,b,M,L,N,W,j){super(),this._workspaceService=f,this._extensionService=b,this._configurationService=M,this._editorTabs=L,this._variableResolver=N,this._commands=W,this._testing=j,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=this._register(new k.Emitter),this._onDidTerminateDebugSession=this._register(new k.Emitter),this._onDidChangeActiveDebugSession=this._register(new k.Emitter),this._onDidReceiveDebugSessionCustomEvent=this._register(new k.Emitter),this._debugServiceProxy=D.getProxy(p.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=this._register(new k.Emitter),this._onDidChangeActiveStackItem=this._register(new k.Emitter),this._activeDebugConsole=new d(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then($=>{this._register($.onDidChange(K=>{this.registerAllDebugTypes($)})),this.registerAllDebugTypes($)})}async $getVisualizerTreeItem(D,f){const b=this.hydrateVisualizationContext(f);if(!b)return;const M=await this._debugVisualizationTrees.get(D)?.getTreeItem?.(b);return M?this.convertVisualizerTreeItem(D,M):void 0}registerDebugVisualizationTree(D,f,b){const M=A.ExtensionIdentifier.toKey(D.identifier),L=this.extensionVisKey(M,f);if(this._debugVisualizationProviders.has(L))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this._debugVisualizationTrees.set(L,b),this._debugServiceProxy.$registerDebugVisualizerTree(L,!!b.editItem),(0,O.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(L),this._debugVisualizationTrees.delete(f)})}async $getVisualizerTreeItemChildren(D,f){const b=this._debugVisualizationElements.get(f)?.item;return b?(await this._debugVisualizationTrees.get(D)?.getChildren?.(b))?.map(L=>this.convertVisualizerTreeItem(D,L))||[]:[]}async $editVisualizerTreeItem(D,f){const b=this._debugVisualizationElements.get(D);if(!b)return;const M=await this._debugVisualizationTrees.get(b.provider)?.editItem?.(b.item,f);return this.convertVisualizerTreeItem(b.provider,M||b.item)}$disposeVisualizedTree(D){const f=this._debugVisualizationElements.get(D);if(!f)return;const b=[f.children];for(const M of b)if(M)for(const L of M)b.push(this._debugVisualizationElements.get(L)?.children),this._debugVisualizationElements.delete(L)}convertVisualizerTreeItem(D,f){let b=this._debugVisualizationTreeItemIds.get(f);return b||(b=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(f,b),this._debugVisualizationElements.set(b,{provider:D,item:f})),t.DebugTreeItem.from(f,b)}asDebugSourceUri(D,f){const b=D;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let M=`debug:${encodeURIComponent(b.path||"")}`,L="?";return f&&(M+=`${L}session=${encodeURIComponent(f.id)}`,L="&"),M+=`${L}ref=${b.sourceReference}`,P.URI.parse(M)}else{if(b.path)return P.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(D){const f=[];for(const b of D.getAllExtensionDescriptions())if(b.contributes){const M=b.contributes.debuggers;if(M&&M.length>0)for(const L of M)(0,s.isDebuggerMainContribution)(L)&&f.push(L.type)}this._debugServiceProxy.$registerDebugTypes(f)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const D=[];return this._breakpoints.forEach(f=>D.push(f)),D}async $resolveDebugVisualizer(D,f){const b=this._visualizers.get(D);if(!b)throw new Error(`No debug visualizer found with id '${D}'`);let{v:M,provider:L,extensionId:N}=b;if(M.visualization||(M=await L.resolveDebugVisualization?.(M,f)||M,b.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${L}'`);return this.serializeVisualization(N,M.visualization)}async $executeDebugVisualizerCommand(D){const f=this._visualizers.get(D);if(!f)throw new Error(`No debug visualizer found with id '${D}'`);const b=f.v.visualization;b&&"command"in b&&this._commands.executeCommand(b.command,...b.arguments||[])}hydrateVisualizationContext(D){const f=this._debugSessions.get(D.sessionId);return f&&{session:f.api,variable:D.variable,containerId:D.containerId,frameId:D.frameId,threadId:D.threadId}}async $provideDebugVisualizers(D,f,b,M){const L=this.hydrateVisualizationContext(b),N=this.extensionVisKey(D,f),W=this._debugVisualizationProviders.get(N);if(!L||!W)return[];const j=await W.provideDebugVisualization(L,M);return j?j.map($=>{const K=++this._visualizerIdCounter;this._visualizers.set(K,{v:$,provider:W,extensionId:D});const q=$.iconPath?this.getIconPathOrClass($.iconPath):void 0;return{id:K,name:$.name,iconClass:q?.iconClass,iconPath:q?.iconPath,visualization:this.serializeVisualization(D,$.visualization)}}):[]}$disposeDebugVisualizers(D){for(const f of D)this._visualizers.delete(f)}registerDebugVisualizationProvider(D,f,b){if(!D.contributes?.debugVisualizers?.some(N=>N.id===f))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${f})`);const M=A.ExtensionIdentifier.toKey(D.identifier),L=this.extensionVisKey(M,f);if(this._debugVisualizationProviders.has(L))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this._debugVisualizationProviders.set(L,b),this._debugServiceProxy.$registerDebugVisualizer(M,f),(0,O.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(M,f),this._debugVisualizationProviders.delete(f)})}addBreakpoints(D){const f=D.filter(L=>{const N=L.id;return this._breakpoints.has(N)?!1:(this._breakpoints.set(N,L),!0)});this.fireBreakpointChanges(f,[],[]);const b=[],M=new Map;for(const L of f)if(L instanceof a.SourceBreakpoint){let N=M.get(L.location.uri.toString());N||(N={type:"sourceMulti",uri:L.location.uri,lines:[]},M.set(L.location.uri.toString(),N),b.push(N)),N.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character,mode:L.mode})}else L instanceof a.FunctionBreakpoint&&b.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName,mode:L.mode});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(D){const f=D.filter(N=>this._breakpoints.delete(N.id));this.fireBreakpointChanges([],f,[]);const b=f.filter(N=>N instanceof a.SourceBreakpoint).map(N=>N.id),M=f.filter(N=>N instanceof a.FunctionBreakpoint).map(N=>N.id),L=f.filter(N=>N instanceof a.DataBreakpoint).map(N=>N.id);return this._debugServiceProxy.$unregisterBreakpoints(b,M,L)}startDebugging(D,f,b){const M=b.testRun&&this._testing.getMetadataForRun(b.testRun);return this._debugServiceProxy.$startDebugging(D?D.uri:void 0,f,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===a.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(D){return this._debugServiceProxy.$stopDebugging(D?D.id:void 0)}registerDebugConfigurationProvider(D,f,b){if(!f)return new a.Disposable(()=>{});const M=this._configProviderHandleCounter++;return this._configProviders.push({type:D,handle:M,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(D,b,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,M),new a.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(D,f,b){if(!b)return new a.Disposable(()=>{});if(!this.definesDebugType(D,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:M,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,M),new a.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(D,f){if(!f)return new a.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:D,handle:b,factory:f}),new a.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(M=>M.factory!==f)})}async $runInTerminal(D,f){return Promise.resolve(void 0)}async $substituteVariables(D,f){let b;const M=await this.getFolder(D);return M&&(b={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(b,f)}createDebugAdapter(D,f){if(D.type==="implementation")return new _(D.implementation)}createSignService(){}async $startDASession(D,f){const b=this,M=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(M.type),M).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const N=this.convertToDto(L),W=this.createDebugAdapter(N,M);if(!W)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const j=W;return this._debugAdapters.set(D,j),this.getDebugAdapterTrackers(M).then($=>($&&this._debugAdaptersTrackers.set(D,$),j.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const q=K,ae={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const Ee=await this._signService.sign(q.arguments.value);ae.body={signature:Ee},j.sendResponse(ae)}else throw new Error("no signer")}catch(Ee){ae.success=!1,ae.message=Ee.message,j.sendResponse(ae)}}else $&&$.onDidSendMessage&&$.onDidSendMessage(K),K=(0,s.convertToVSCPaths)(K,!0),b._debugServiceProxy.$acceptDAMessage(D,K)}),j.onError(K=>{$&&$.onError&&$.onError(K),this._debugServiceProxy.$acceptDAError(D,K.name,K.message,K.stack)}),j.onExit(K=>{$&&$.onExit&&$.onExit(K??void 0,void 0),this._debugServiceProxy.$acceptDAExit(D,K??void 0,void 0)}),$&&$.onWillStartSession&&$.onWillStartSession(),j.startSession()))})}$sendDAMessage(D,f){f=(0,s.convertToDAPaths)(f,!1);const b=this._debugAdaptersTrackers.get(D);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(f),this._debugAdapters.get(D)?.sendMessage(f)}$stopDASession(D){const f=this._debugAdaptersTrackers.get(D);this._debugAdaptersTrackers.delete(D),f&&f.onWillStopSession&&f.onWillStopSession();const b=this._debugAdapters.get(D);return this._debugAdapters.delete(D),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(D){const f=[],b=[],M=[];if(D.added)for(const L of D.added){const N=L.id;if(N&&!this._breakpoints.has(N)){let W;if(L.type==="function")W=new a.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode);else if(L.type==="data")W=new a.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage,L.mode);else{const j=P.URI.revive(L.uri);W=new a.SourceBreakpoint(new a.Location(j,new a.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode)}(0,a.setBreakpointId)(W,N),this._breakpoints.set(N,W),f.push(W)}}if(D.removed)for(const L of D.removed){const N=this._breakpoints.get(L);N&&(this._breakpoints.delete(L),b.push(N))}if(D.changed){for(const L of D.changed)if(L.id){const N=this._breakpoints.get(L.id);if(N){if(N instanceof a.FunctionBreakpoint&&L.type==="function"){const W=N;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.functionName=L.functionName}else if(N instanceof a.SourceBreakpoint&&L.type==="source"){const W=N;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.location=new a.Location(P.URI.revive(L.uri),new a.Position(L.line,L.character))}M.push(N)}}}this.fireBreakpointChanges(f,b,M)}async $acceptStackFrameFocus(D){let f;if(D){const b=await this.getSession(D.sessionId);D.kind==="thread"?f=new a.DebugThread(b.api,D.threadId):f=new a.DebugStackFrame(b.api,D.threadId,D.frameId)}this._activeStackItem=f,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(D,f,b){return(0,S.asPromise)(async()=>{const M=this.getConfigProviderByHandle(D);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(f);return M.provideDebugConfigurations(L,b)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(D,f,b,M){return(0,S.asPromise)(async()=>{const L=this.getConfigProviderByHandle(D);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.getFolder(f);return L.resolveDebugConfiguration(N,b,M)})}$resolveDebugConfigurationWithSubstitutedVariables(D,f,b,M){return(0,S.asPromise)(async()=>{const L=this.getConfigProviderByHandle(D);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.getFolder(f);return L.resolveDebugConfigurationWithSubstitutedVariables(N,b,M)})}async $provideDebugAdapter(D,f){const b=this.getAdapterDescriptorFactoryByHandle(D);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.getSession(f);return this.getAdapterDescriptor(b,M).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(D){const f=await this.getSession(D);this._onDidStartDebugSession.fire(f.api)}async $acceptDebugSessionTerminated(D){const f=await this.getSession(D);f&&(this._onDidTerminateDebugSession.fire(f.api),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(D){this._activeDebugSession=D?await this.getSession(D):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(D,f){(await this.getSession(D))?._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(D,f){const M={session:(await this.getSession(D)).api,event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(M)}convertToDto(D){if(D instanceof a.DebugAdapterExecutable)return{type:"executable",command:D.command,args:D.args,options:D.options};if(D instanceof a.DebugAdapterServer)return{type:"server",port:D.port,host:D.host};if(D instanceof a.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:D.path};if(D instanceof a.DebugAdapterInlineImplementation)return{type:"implementation",implementation:D.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(D){const f=this._adapterFactories.filter(b=>b.type===D);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(D){const f=this._adapterFactories.filter(b=>b.handle===D);if(f.length>0)return f[0].factory}getConfigProviderByHandle(D){const f=this._configProviders.filter(b=>b.handle===D);if(f.length>0)return f[0].provider}definesDebugType(D,f){if(D.contributes){const b=D.contributes.debuggers;if(b&&b.length>0){for(const M of b)if(M.label&&M.type&&M.type===f)return!0}}return!1}getDebugAdapterTrackers(D){const b=D.configuration.type,M=this._trackerFactories.filter(L=>L.type===b||L.type==="*").map(L=>(0,S.asPromise)(()=>L.factory.createDebugAdapterTracker(D.api)).then(N=>N,N=>null));return Promise.race([Promise.all(M).then(L=>{const N=(0,g.coalesce)(L);if(N.length>0)return new C(N)}),new Promise(L=>setTimeout(()=>L(void 0),1e3))]).catch(L=>{})}async getAdapterDescriptor(D,f){const b=f.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new a.DebugAdapterServer(b));if(D){const L=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>D.createDebugAdapterDescriptor(f.api,this.daExecutableFromPackage(f,L))).then(N=>{if(N)return N})}const M=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,M))}daExecutableFromPackage(D,f){}fireBreakpointChanges(D,f,b){(D.length>0||f.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:D,removed:f,changed:b}))}async getSession(D){if(D)if(typeof D=="string"){const f=this._debugSessions.get(D);if(f)return f}else{let f=this._debugSessions.get(D.id);if(!f){const b=await this.getFolder(D.folderUri),M=D.parent?this._debugSessions.get(D.parent):void 0;f=new m(this._debugServiceProxy,D.id,D.type,D.name,b,D.configuration,M?.api),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(D){if(D){const f=P.URI.revive(D);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}extensionVisKey(D,f){return`${D}\0${f}`}serializeVisualization(D,f){if(f){if("title"in f&&"command"in f)return{type:r.DebugVisualizationType.Command};if("treeId"in f)return{type:r.DebugVisualizationType.Tree,id:`${D}\0${f.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(D){const f=this.getIconUris(D);let b,M;return"id"in f?M=i.ThemeIcon.asClassName(f):b=f,{iconPath:b,iconClass:M}}getIconUris(D){if(D instanceof a.ThemeIcon)return{id:D.id};const f=typeof D=="object"&&"dark"in D?D.dark:D,b=typeof D=="object"&&"light"in D?D.light:D;return{dark:typeof f=="string"?P.URI.file(f):f,light:typeof b=="string"?P.URI.file(b):b}}};e.ExtHostDebugServiceBase=v,e.ExtHostDebugServiceBase=v=Ge([Ve(0,w.IExtHostRpcService),Ve(1,y.IExtHostWorkspace),Ve(2,I.IExtHostExtensionService),Ve(3,l.IExtHostConfiguration),Ve(4,o.IExtHostEditorTabs),Ve(5,c.IExtHostVariableResolverProvider),Ve(6,n.IExtHostCommands),Ve(7,u.IExtHostTesting)],v);class m{constructor(D,f,b,M,L,N,W){this._debugServiceProxy=D,this._id=f,this._type=b,this._name=M,this._workspaceFolder=L,this._configuration=N,this._parentSession=W}get api(){const D=this;return this.apiSession??=Object.freeze({id:D._id,type:D._type,get name(){return D._name},set name(f){D._name=f,D._debugServiceProxy.$setDebugSessionName(D._id,f)},parentSession:D._parentSession,workspaceFolder:D._workspaceFolder,configuration:D._configuration,customRequest(f,b){return D._debugServiceProxy.$customDebugAdapterRequest(D._id,f,b)},getDebugProtocolBreakpoint(f){return D._debugServiceProxy.$getDebugProtocolBreakpoint(D._id,f.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(D){this._name=D}get configuration(){return this._configuration}}e.ExtHostDebugSession=m;class d{constructor(D){this.value=Object.freeze({append(f){D.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=d;class C{constructor(D){this.trackers=D}onWillStartSession(){this.trackers.forEach(D=>D.onWillStartSession?D.onWillStartSession():void 0)}onWillReceiveMessage(D){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(D):void 0)}onDidSendMessage(D){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(D):void 0)}onWillStopSession(){this.trackers.forEach(D=>D.onWillStopSession?D.onWillStopSession():void 0)}onError(D){this.trackers.forEach(f=>f.onError?f.onError(D):void 0)}onExit(D,f){this.trackers.forEach(b=>b.onExit?b.onExit(D,f):void 0)}}class _ extends h.AbstractDebugAdapter{constructor(D){super(),this.implementation=D,D.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(D){this.implementation.handleMessage(D)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let E=class extends v{constructor(D,f,b,M,L,N,W,j){super(D,f,b,M,L,N,W,j)}};e.WorkerExtHostDebugService=E,e.WorkerExtHostDebugService=E=Ge([Ve(0,w.IExtHostRpcService),Ve(1,y.IExtHostWorkspace),Ve(2,I.IExtHostExtensionService),Ve(3,l.IExtHostConfiguration),Ve(4,o.IExtHostEditorTabs),Ve(5,c.IExtHostVariableResolverProvider),Ve(6,n.IExtHostCommands),Ve(7,u.IExtHostTesting)],E)}),define(Le[274],Ne([1,0,13,64,2,5,224,11,60,74,26,170,16,65,47,66]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0,S=We(S),k=We(k);class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(R.ILogService),g=i.get(a.IExtHostRpcService).getProxy(O.MainContext.MainThreadErrors);S.setUnexpectedErrorHandler(u=>{n.error(u);const v=S.transformErrorForSerialization(u);g.$onUnexpectedError(v)})}static async installFullHandler(i){const n=i.get(R.ILogService),t=i.get(a.IExtHostRpcService),g=i.get(h.IExtHostExtensionService),u=i.get(r.IExtHostTelemetry),v=t.getProxy(O.MainContext.MainThreadExtensionService),m=t.getProxy(O.MainContext.MainThreadErrors),d=await g.getExtensionPathIndex(),C=new WeakMap;function _(D,f){if(C.has(D))return C.get(D).stack;let b="",M,L;for(const W of f)b+=`
	at ${W.toString()}`,L=W.getFileName(),!M&&L&&(M=d.findSubstr(P.URI.file(L)));const N=`${D.name||"Error"}: ${D.message||""}${b}`;return C.set(D,{extensionIdentifier:M?.identifier,stack:N}),N}const E=Symbol("prepareStackTrace wrapped");let T=_;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return T},set(D){if(D===_||!D||D[E]){T=D||_;return}T=function(f,b){return _(f,b),D.call(Error,f,b)},Object.assign(T,{[E]:!0})}}),S.setUnexpectedErrorHandler(D=>{n.error(D);const f=S.transformErrorForSerialization(D),b=C.get(D);if(!b?.extensionIdentifier){m.$onUnexpectedError(f);return}v.$onExtensionRuntimeError(b.extensionIdentifier,f);const M=u.onExtensionError(b.extensionIdentifier,D);n.trace("forwarded error to extension?",M,b)})}}e.ErrorHandler=s;class l{constructor(i,n,t,g,u){this._hostUtils=t,this._rpcProtocol=new A.RPCProtocol(i,null,g),n=l._transform(n,this._rpcProtocol);const v=new o.ServiceCollection(...(0,p.getSingletonServiceDescriptors)());v.set(I.IExtHostInitDataService,{_serviceBrand:void 0,...n,messagePorts:u}),v.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),v.set(y.IURITransformerService,new y.URITransformerService(g)),v.set(h.IHostUtils,t);const m=new w.InstantiationService(v,!0);m.invokeFunction(s.installEarlyHandler),this._logService=m.invokeFunction(d=>d.get(R.ILogService)),k.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",n),this._extensionService=m.invokeFunction(d=>d.get(h.IExtHostExtensionService)),this._extensionService.initialize(),m.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const n=this._rpcProtocol.getProxy(O.MainContext.MainThreadExtensionService);return P.URI.revive(await n.$asBrowserUri(i))}terminate(i){this._extensionService.terminate(i)}static _transform(i,n){i.extensions.allExtensions.forEach(g=>{g.extensionLocation=P.URI.revive(n.transformIncomingURIs(g.extensionLocation))}),i.environment.appRoot=P.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(g=>P.URI.revive(n.transformIncomingURIs(g)))),i.environment.extensionTestsLocationURI=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.ExtensionHostMain=l}),define(Le[275],Ne([1,0,17,10,21,42,15,19,23,2,44]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,e.extensionResultIsMatch=r,R=We(R),p=We(p);class w{constructor(c,i,n){this.queryProviderPair=c,this.fileUtils=i,this.processType=n,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(c,i){const n=this.query.folderQueries||[],t=new P.CancellationTokenSource(i);return new Promise((g,u)=>{this.collector=new y(c);let v=!1;const m=(d,C)=>{if(!v&&!this.isLimitHit){const _=this.resultSize(d);r(d)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,v=!0,t.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const E=this.resultSize(d);this.resultCount+=E,(E>0||!r(d))&&this.collector.add(d,C)}};Promise.all(n.map((d,C)=>this.searchInFolder(d,_=>m(_,C),t.token))).then(d=>{t.dispose(),this.collector.flush();const C=d.some(_=>!!_&&!!_.limitHit);g({limitHit:this.isLimitHit||C,messages:d.flatMap(_=>_?.message?Array.isArray(_.message)?_.message:[_.message]:[]),stats:{type:this.processType}})},d=>{t.dispose();const C=(0,O.toErrorMessage)(d);u(new Error(C))})})}resultSize(c){return r(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,i){const n=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:n.slice(0,i),preview:{matches:t.slice(0,i),text:c.preview.text},uri:c.uri}}async searchInFolder(c,i,n){const t=new I.QueryGlobTester(this.query,c),g=[],u={report:d=>{if(!this.validateProviderResult(d))return;const C=c.folder.scheme===A.Schemas.file?(0,I.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(p.dirname(d.uri))):void 0,_=p.relativePath(c.folder,d.uri);if(_){const E=t.includedInQuery(_,R.basename(_),C);(0,k.isThenable)(E)?g.push(E.then(T=>{T&&i(d)})):E&&i(d)}}},v=this.getSearchOptionsForFolder(c);let m;return this.queryProviderPair.query.type===I.QueryType.aiText?m=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,v,u,n):m=await this.queryProviderPair.provider.provideTextSearchResults(a(this.queryProviderPair.query.contentPattern),v,u,n),g.length&&await Promise.all(g),m}validateProviderResult(c){if(r(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const i=(0,I.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),n=(0,I.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:o.URI.from(c.folder),excludes:n,includes:i,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults??I.DEFAULT_MAX_SEARCH_RESULTS,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return"usePCRE2"in this.query&&(t.usePCRE2=this.query.usePCRE2),t}}e.TextSearchManager=w;function a(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class y{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new s(512,i=>this.sendItems(i))}add(c,i){this._currentFileMatch&&(this._currentFolderIdx!==i||!p.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=i,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(h(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=y;function h(l){return r(l)?{preview:{matches:(0,S.mapArrayOrNot)(l.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:l.preview.text},ranges:(0,S.mapArrayOrNot)(l.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function r(l){return!!l.preview}class s{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(c,i){this.maxBatchSize=c,this.cb=i,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,i){c&&this.addItemToBatch(c,i)}addItems(c,i){c&&this.addItemsToBatch(c,i)}addItemToBatch(c,i){this.batch.push(c),this.batchSize+=i,this.onUpdate()}addItemsToBatch(c,i){this.batch=this.batch.concat(c),this.batchSize+=i,this.onUpdate()}onUpdate(){this.totalNumberCompleted<s.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},s.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=s}),define(Le[134],Ne([1,0,4,5,3,270,16,65,11,2,275]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=a,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let w=class{constructor(r,s,l){this.extHostRpc=r,this._uriTransformer=s,this._logService=l,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new O.FileSearchManager}_transformScheme(r){return this._uriTransformer.transformOutgoingScheme(r)}registerTextSearchProvider(r,s){if(this._textSearchUsedSchemes.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this._textSearchUsedSchemes.add(r);const l=this._handlePool++;return this._textSearchProvider.set(l,s),this._proxy.$registerTextSearchProvider(l,this._transformScheme(r)),(0,S.toDisposable)(()=>{this._textSearchUsedSchemes.delete(r),this._textSearchProvider.delete(l),this._proxy.$unregisterProvider(l)})}registerAITextSearchProvider(r,s){if(this._aiTextSearchUsedSchemes.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this._aiTextSearchUsedSchemes.add(r);const l=this._handlePool++;return this._aiTextSearchProvider.set(l,s),this._proxy.$registerAITextSearchProvider(l,this._transformScheme(r)),(0,S.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(r),this._aiTextSearchProvider.delete(l),this._proxy.$unregisterProvider(l)})}registerFileSearchProvider(r,s){if(this._fileSearchUsedSchemes.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this._fileSearchUsedSchemes.add(r);const l=this._handlePool++;return this._fileSearchProvider.set(l,s),this._proxy.$registerFileSearchProvider(l,this._transformScheme(r)),(0,S.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(r),this._fileSearchProvider.delete(l),this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(r,s,l,c){const i=a(l),n=this._fileSearchProvider.get(r);if(n)return this._fileSearchManager.fileSearch(i,n,t=>{this._proxy.$handleFileMatch(r,s,t.map(g=>g.resource))},c);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,s,l){return{messages:[]}}$clearCache(r){return this._fileSearchManager.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,s,l,c){const i=this._textSearchProvider.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${r}`);const n=a(l);return this.createTextSearchManager(n,i).search(g=>this._proxy.$handleTextMatch(r,s,g),c)}$provideAITextSearchResults(r,s,l,c){const i=this._aiTextSearchProvider.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${r}`);const n=a(l);return this.createAITextSearchManager(n,i).search(g=>this._proxy.$handleTextMatch(r,s,g),c)}$enableExtensionHostSearch(){}createTextSearchManager(r,s){return new I.TextSearchManager({query:r,provider:s},{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}createAITextSearchManager(r,s){return new I.TextSearchManager({query:r,provider:s},{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"aiTextSearchProvider")}};e.ExtHostSearch=w,e.ExtHostSearch=w=Ge([Ve(0,A.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,p.ILogService)],w);function a(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(y),extraFileResources:h.extraFileResources&&h.extraFileResources.map(r=>o.URI.revive(r))}}function y(h){return{...h,folder:o.URI.revive(h.folder)}}});var Jt=this&&this.__importDefault||function(Se){return Se&&Se.__esModule?Se:{default:Se}};define(Le[276],Ne([1,0,10,21,13,6,4,15,35,2,105,157,158,52,18,29,11,62,63,185,5,227,256,84,90,232,233,234,211,201,33,235,46,236,133,122,237,213,228,238,239,57,70,214,229,47,241,68,242,50,26,257,215,243,244,94,245,85,86,217,269,247,190,248,258,249,128,218,250,251,252,16,253,134,87,254,219,255,88,91,131,66,56,126,95,259,230,260,261,92,8,7,220,65,221,67,262,263,121,45,80,83,24,130]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n,t,g,u,v,m,d,C,_,E,T,D,f,b,M,L,N,W,j,$,K,q,ae,Ee,ce,Z,le,me,oe,De,Re,Q,z,ne,Ce,fe,be,de,X,J,ve,pe,Ae,Ue,Ie,Pe,Oe,x,B,H,V,re,ge,Te,xe,qe,Ze,tt,nt,et,rt,ft,ct,st,lt,mt,vt,$e,Be,ie,ee,Y,Xe,Je,dt,bt,Mt,Ht,Zt,ei,oi,At,Ye,Tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=di,P=We(P),p=Jt(p),a=We(a),r=We(r),ee=We(ee),Y=We(Y);function di(pt){const _t=pt.get(Re.IExtHostInitDataService),ti=pt.get(De.IExtHostFileSystemInfo),ii=pt.get(me.IExtHostConsumerFileSystem),Bt=pt.get(Z.IExtHostExtensionService),gt=pt.get(ei.IExtHostWorkspace),xt=pt.get(ft.IExtHostTelemetry),ni=pt.get(f.IExtHostConfiguration),ai=pt.get(Je.IURITransformerService),Ke=pt.get(re.IExtHostRpcService),li=pt.get(nt.IExtHostStorage),hi=pt.get(et.IExtensionStoragePaths),fi=pt.get(s.ILoggerService),St=pt.get(s.ILogService),Ft=pt.get(ie.IExtHostTunnelService),Lt=pt.get(u.IExtHostApiDeprecationService),Wt=pt.get(Zt.IExtHostWindow),ri=pt.get(xe.IExtHostSecretState),jt=pt.get(ae.IExtHostEditorTabs),ci=pt.get(X.IExtHostManagedSockets),zt=pt.get(v.IExtHostAuthentication),qt=pt.get(fe.IExtHostLanguageModels);Ke.set(n.ExtHostContext.ExtHostFileSystemInfo,ti),Ke.set(n.ExtHostContext.ExtHostLogLevelServiceShape,fi),Ke.set(n.ExtHostContext.ExtHostWorkspace,gt),Ke.set(n.ExtHostContext.ExtHostConfiguration,ni),Ke.set(n.ExtHostContext.ExtHostExtensionService,Bt),Ke.set(n.ExtHostContext.ExtHostStorage,li),Ke.set(n.ExtHostContext.ExtHostTunnelService,Ft),Ke.set(n.ExtHostContext.ExtHostWindow,Wt),Ke.set(n.ExtHostContext.ExtHostSecretState,ri),Ke.set(n.ExtHostContext.ExtHostTelemetry,xt),Ke.set(n.ExtHostContext.ExtHostEditorTabs,jt),Ke.set(n.ExtHostContext.ExtHostManagedSockets,ci),Ke.set(n.ExtHostContext.ExtHostAuthentication,zt),Ke.set(n.ExtHostContext.ExtHostChatProvider,qt);const Kt=Ke.set(n.ExtHostContext.ExtHostDecorations,pt.get(L.IExtHostDecorations)),Nt=Ke.set(n.ExtHostContext.ExtHostDocumentsAndEditors,pt.get(q.IExtHostDocumentsAndEditors)),Et=Ke.set(n.ExtHostContext.ExtHostCommands,pt.get(T.IExtHostCommands)),Dt=Ke.set(n.ExtHostContext.ExtHostTerminalService,pt.get(ct.IExtHostTerminalService)),Vt=Ke.set(n.ExtHostContext.ExtHostTerminalShellIntegration,pt.get(st.IExtHostTerminalShellIntegration)),It=Ke.set(n.ExtHostContext.ExtHostDebugService,pt.get(M.IExtHostDebugService)),mi=Ke.set(n.ExtHostContext.ExtHostSearch,pt.get(Te.IExtHostSearch)),Qt=Ke.set(n.ExtHostContext.ExtHostTask,pt.get(rt.IExtHostTask)),Di=Ke.set(n.ExtHostContext.ExtHostOutputService,pt.get(Oe.IExtHostOutputService)),Ei=Ke.set(n.ExtHostContext.ExtHostLocalization,pt.get(de.IExtHostLocalizationService)),Ai=Ke.set(n.ExtHostContext.ExtHostUrls,new dt.ExtHostUrls(Ke)),Rt=Ke.set(n.ExtHostContext.ExtHostDocuments,new K.ExtHostDocuments(Ke,Nt)),Li=Ke.set(n.ExtHostContext.ExtHostDocumentContentProviders,new j.ExtHostDocumentContentProvider(Ke,Nt,St)),ui=Ke.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new $.ExtHostDocumentSaveParticipant(St,Rt,Ke.getProxy(n.MainContext.MainThreadBulkEdits))),Pt=Ke.set(n.ExtHostContext.ExtHostNotebook,new ve.ExtHostNotebookController(Ke,Et,Nt,Rt,ii,mi,St)),Ri=Ke.set(n.ExtHostContext.ExtHostNotebookDocuments,new Ae.ExtHostNotebookDocuments(Pt)),Ii=Ke.set(n.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(St,Pt)),_i=Ke.set(n.ExtHostContext.ExtHostNotebookKernels,new Ie.ExtHostNotebookKernels(Ke,_t,Pt,Et,St)),Ni=Ke.set(n.ExtHostContext.ExtHostNotebookRenderers,new Pe.ExtHostNotebookRenderers(Ke,Pt)),bi=Ke.set(n.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new pe.ExtHostNotebookDocumentSaveParticipant(St,Pt,Ke.getProxy(n.MainContext.MainThreadBulkEdits))),$t=Ke.set(n.ExtHostContext.ExtHostEditors,new mt.ExtHostEditors(Ke,Nt)),_e=Ke.set(n.ExtHostContext.ExtHostTreeViews,new Be.ExtHostTreeViews(Ke.getProxy(n.MainContext.MainThreadTreeViews),Et,St)),ke=Ke.set(n.ExtHostContext.ExtHostEditorInsets,new E.ExtHostEditorInsets(Ke.getProxy(n.MainContext.MainThreadEditorInsets),$t,_t.remote)),he=Ke.set(n.ExtHostContext.ExtHostDiagnostics,new N.ExtHostDiagnostics(Ke,St,ti,Nt)),G=Ke.set(n.ExtHostContext.ExtHostLanguages,new be.ExtHostLanguages(Ke,Rt,Et.converter,ai)),we=Ke.set(n.ExtHostContext.ExtHostLanguageFeatures,new ne.ExtHostLanguageFeatures(Ke,ai,Rt,Et,he,St,Lt,xt)),ze=Ke.set(n.ExtHostContext.ExtHostFileSystem,new le.ExtHostFileSystem(Ke,we)),Qe=Ke.set(n.ExtHostContext.ExtHostFileSystemEventService,new oe.ExtHostFileSystemEventService(Ke,St,Nt)),He=Ke.set(n.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(Ke,gt,Et)),ut=Ke.set(n.ExtHostContext.ExtHostSCM,new ge.ExtHostSCM(Ke,Et,Rt,St)),kt=Ke.set(n.ExtHostContext.ExtHostQuickDiff,new H.ExtHostQuickDiff(Ke,ai)),Gt=Ke.set(n.ExtHostContext.ExtHostShare,new qe.ExtHostShare(Ke,ai)),si=Ke.set(n.ExtHostContext.ExtHostComments,(0,D.createExtHostComments)(Ke,Et,Rt)),Ut=Ke.set(n.ExtHostContext.ExtHostProgress,new B.ExtHostProgress(Ke.getProxy(n.MainContext.MainThreadProgress))),Yt=Ke.set(n.ExtHostContext.ExtHostLabelService,new z.ExtHostLabelService(Ke)),Wi=Ke.set(n.ExtHostContext.ExtHostTheming,new vt.ExtHostTheming(Ke)),rn=Ke.set(n.ExtHostContext.ExtHostTimeline,new $e.ExtHostTimeline(Ke,Et)),Vi=Ke.set(n.ExtHostContext.ExtHostWebviews,new bt.ExtHostWebviews(Ke,_t.remote,gt,St,Lt)),Fi=Ke.set(n.ExtHostContext.ExtHostWebviewPanels,new Mt.ExtHostWebviewPanels(Ke,Vi,gt)),Hi=Ke.set(n.ExtHostContext.ExtHostCustomEditors,new b.ExtHostCustomEditors(Ke,Rt,hi,Vi,Fi)),qi=Ke.set(n.ExtHostContext.ExtHostWebviewViews,new Ht.ExtHostWebviewViews(Ke,Vi)),Ti=Ke.set(n.ExtHostContext.ExtHostTesting,pt.get(lt.IExtHostTesting)),sn=Ke.set(n.ExtHostContext.ExtHostUriOpeners,new Xe.ExtHostUriOpeners(Ke)),on=Ke.set(n.ExtHostContext.ExtHostProfileContentHandlers,new x.ExtHostProfileContentHandlers(Ke));Ke.set(n.ExtHostContext.ExtHostInteractive,new Q.ExtHostInteractive(Ke,Pt,Nt,Et,St));const Ui=Ke.set(n.ExtHostContext.ExtHostChatAgents2,new d.ExtHostChatAgents2(Ke,St,Et,Rt)),an=Ke.set(n.ExtHostContext.ExtHostChatVariables,new C.ExtHostChatVariables(Ke)),xi=Ke.set(n.ExtHostContext.ExtHostLanguageModelTools,new Ce.ExtHostLanguageModelTools(Ke)),ji=Ke.set(n.ExtHostContext.ExtHostAiRelatedInformation,new t.ExtHostRelatedInformation(Ke)),Cn=Ke.set(n.ExtHostContext.ExtHostAiEmbeddingVector,new ce.ExtHostAiEmbeddingVector(Ke)),ln=Ke.set(n.ExtHostContext.ExtHostStatusBar,new tt.ExtHostStatusBar(Ke,Et.converter)),Ki=Ke.set(n.ExtHostContext.ExtHostSpeech,new Ze.ExtHostSpeech(Ke)),Pi=Ke.set(n.ExtHostContext.ExtHostEmbeddings,new Ee.ExtHostEmbeddings(Ke)),_n=Object.values(n.ExtHostContext);Ke.assertRegistered(_n);const yn=new m.ExtHostBulkEdits(Ke,Nt),cn=new _.ExtHostClipboard(Ke),Gi=new J.ExtHostMessageService(Ke,St),Xi=new W.ExtHostDialogs(Ke);return g.ExtHostApiCommands.register(Et),function(Fe,Si,Qi){function ot(te){return(ue,Me,at)=>{const wt=te(Ot=>{try{ue.call(Me,Ot)}catch(gi){P.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${gi.toString()}`,{cause:gi})),xt.onExtensionError(Fe.identifier,gi)}});return at?.push(wt),wt}}const yt=function(){let te=!Fe.isUnderDevelopment;function ue(){te||(St.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Me(at){if(Array.isArray(at))at.forEach(Me);else if(typeof at=="string")ue();else{const wt=at;typeof wt.scheme>"u"&&ue(),typeof wt.exclusive=="boolean"&&(0,Ye.checkProposedApiEnabled)(Fe,"documentFiltersExclusive")}return at}}(),Yi={getSession(te,ue,Me){return typeof Me?.forceNewSession=="object"&&Me.forceNewSession.learnMore&&(0,Ye.checkProposedApiEnabled)(Fe,"authLearnMore"),Me?.account&&(0,Ye.checkProposedApiEnabled)(Fe,"authGetSessions"),zt.getSession(Fe,te,ue,Me)},getAccounts(te){return(0,Ye.checkProposedApiEnabled)(Fe,"authGetSessions"),zt.getAccounts(te)},async hasSession(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"authSession"),!!await zt.getSession(Fe,te,ue,{silent:!0})},get onDidChangeSessions(){return ot(zt.onDidChangeSessions)},registerAuthenticationProvider(te,ue,Me,at){return zt.registerAuthenticationProvider(te,ue,Me,at)}},un={registerCommand(te,ue,Me){return Et.registerCommand(!0,te,ue,Me,void 0,Fe)},registerTextEditorCommand(te,ue,Me){return Et.registerCommand(!0,te,(...at)=>{const wt=$t.getActiveTextEditor();if(!wt){St.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(Ot=>{ue.apply(Me,[wt,Ot,...at])}).then(Ot=>{Ot||St.warn("Edits from command "+te+" were not applied.")},Ot=>{St.warn("An error occurred while running command "+te,Ot)})},void 0,void 0,Fe)},registerDiffInformationCommand:(te,ue,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"diffCommand"),Et.registerCommand(!0,te,async(...at)=>{const wt=Nt.activeEditor(!0);if(!wt){St.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ot=await $t.getDiffInformation(wt.id);ue.apply(Me,[Ot,...at])},void 0,void 0,Fe)),executeCommand(te,...ue){return Et.executeCommand(te,...ue)},getCommands(te=!1){return Et.getCommands(te)}},wi={get machineId(){return _t.telemetryInfo.machineId},get sessionId(){return _t.telemetryInfo.sessionId},get language(){return _t.environment.appLanguage},get appName(){return _t.environment.appName},get appRoot(){return _t.environment.appRoot?.fsPath??""},get appHost(){return _t.environment.appHost},get uriScheme(){return _t.environment.appUriScheme},get clipboard(){return cn.value},get shell(){return Dt.getDefaultShell(!1)},get onDidChangeShell(){return ot(Dt.onDidChangeShell)},get isTelemetryEnabled(){return xt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(xt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.checkProposedApiEnabled)(Fe,"telemetry"),xt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.checkProposedApiEnabled)(Fe,"telemetry"),ot(xt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ft.isNewAppInstall)(_t.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ue){return ft.ExtHostTelemetryLogger.validateSender(te),xt.instantiateLogger(Fe,te,ue)},openExternal(te,ue){return Wt.openUri(te,{allowTunneling:!!_t.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===_t.environment.appUriScheme)return Ai.createAppUri(te);try{return await Wt.asExternalUri(te,{allowTunneling:!!_t.remote.authority})}catch(ue){if((0,R.matchesScheme)(te,R.Schemas.http)||(0,R.matchesScheme)(te,R.Schemas.https))return te;throw ue}},get remoteName(){return(0,l.getRemoteName)(_t.remote.authority)},get remoteAuthority(){return(0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),_t.remote.authority},get uiKind(){return _t.uiKind},get logLevel(){return St.getLevel()},get onDidChangeLogLevel(){return ot(St.onDidChangeLogLevel)},get appQuality(){return(0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),_t.quality},get appCommit(){return(0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),_t.commit}};_t.environment.extensionTestsLocationURI||Object.freeze(wi);const Bi={createTestController(te,ue,Me){return Ti.createTestController(Fe,te,ue,Me)},createTestObserver(){return(0,Ye.checkProposedApiEnabled)(Fe,"testObserver"),Ti.createTestObserver()},runTests(te){return(0,Ye.checkProposedApiEnabled)(Fe,"testObserver"),Ti.runTests(te)},registerTestFollowupProvider(te){return(0,Ye.checkProposedApiEnabled)(Fe,"testObserver"),Ti.registerTestFollowupProvider(te)},get onDidChangeTestResults(){return(0,Ye.checkProposedApiEnabled)(Fe,"testObserver"),ot(Ti.onResultsChanged)},get testResults(){return(0,Ye.checkProposedApiEnabled)(Fe,"testObserver"),Ti.results}},zi=_t.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,pi={getExtension(te,ue){(0,Ye.isProposedApiEnabled)(Fe,"extensionsAny")||(ue=!1);const Me=Si.mine.getExtensionDescription(te);if(Me)return new Z.Extension(Bt,Fe.identifier,Me,zi,!1);if(ue){const at=Si.all.getExtensionDescription(te);if(at)return new Z.Extension(Bt,Fe.identifier,at,zi,!0)}},get all(){const te=[];for(const ue of Si.mine.getAllExtensionDescriptions())te.push(new Z.Extension(Bt,Fe.identifier,ue,zi,!1));return te},get allAcrossExtensionHosts(){(0,Ye.checkProposedApiEnabled)(Fe,"extensionsAny");const te=new h.ExtensionIdentifierSet(Si.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),ue=[];for(const Me of Si.all.getAllExtensionDescriptions()){const at=!te.has(Me.identifier);ue.push(new Z.Extension(Bt,Fe.identifier,Me,zi,at))}return ue},get onDidChange(){return(0,Ye.isProposedApiEnabled)(Fe,"extensionsAny")?ot(O.Event.any(Si.mine.onDidChange,Si.all.onDidChange)):ot(Si.mine.onDidChange)}},$i={createDiagnosticCollection(te){return he.createDiagnosticCollection(Fe.identifier,te)},get onDidChangeDiagnostics(){return ot(he.onDidChangeDiagnostics)},getDiagnostics:te=>he.getDiagnostics(te),getLanguages(){return G.getLanguages()},setTextDocumentLanguage(te,ue){return G.changeLanguage(te.uri,ue)},match(te,ue){const Me=ee.LanguageSelector.from(te);let at;return(0,w.targetsNotebooks)(Me)&&(at=Pt.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Ot=>Ot.document===ue))?.apiNotebook),(0,w.score)(Me,ue.uri,ue.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(te,ue,Me){return we.registerCodeActionProvider(Fe,yt(te),ue,Me)},registerDocumentPasteEditProvider(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"documentPaste"),we.registerDocumentPasteEditProvider(Fe,yt(te),ue,Me)},registerCodeLensProvider(te,ue){return we.registerCodeLensProvider(Fe,yt(te),ue)},registerDefinitionProvider(te,ue){return we.registerDefinitionProvider(Fe,yt(te),ue)},registerDeclarationProvider(te,ue){return we.registerDeclarationProvider(Fe,yt(te),ue)},registerImplementationProvider(te,ue){return we.registerImplementationProvider(Fe,yt(te),ue)},registerTypeDefinitionProvider(te,ue){return we.registerTypeDefinitionProvider(Fe,yt(te),ue)},registerHoverProvider(te,ue){return we.registerHoverProvider(Fe,yt(te),ue,Fe.identifier)},registerEvaluatableExpressionProvider(te,ue){return we.registerEvaluatableExpressionProvider(Fe,yt(te),ue,Fe.identifier)},registerInlineValuesProvider(te,ue){return we.registerInlineValuesProvider(Fe,yt(te),ue,Fe.identifier)},registerDocumentHighlightProvider(te,ue){return we.registerDocumentHighlightProvider(Fe,yt(te),ue)},registerMultiDocumentHighlightProvider(te,ue){return we.registerMultiDocumentHighlightProvider(Fe,yt(te),ue)},registerLinkedEditingRangeProvider(te,ue){return we.registerLinkedEditingRangeProvider(Fe,yt(te),ue)},registerReferenceProvider(te,ue){return we.registerReferenceProvider(Fe,yt(te),ue)},registerRenameProvider(te,ue){return we.registerRenameProvider(Fe,yt(te),ue)},registerNewSymbolNamesProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"newSymbolNamesProvider"),we.registerNewSymbolNamesProvider(Fe,yt(te),ue)},registerDocumentSymbolProvider(te,ue,Me){return we.registerDocumentSymbolProvider(Fe,yt(te),ue,Me)},registerWorkspaceSymbolProvider(te){return we.registerWorkspaceSymbolProvider(Fe,te)},registerDocumentFormattingEditProvider(te,ue){return we.registerDocumentFormattingEditProvider(Fe,yt(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return we.registerDocumentRangeFormattingEditProvider(Fe,yt(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Me,...at){return we.registerOnTypeFormattingEditProvider(Fe,yt(te),ue,[Me].concat(at))},registerDocumentSemanticTokensProvider(te,ue,Me){return we.registerDocumentSemanticTokensProvider(Fe,yt(te),ue,Me)},registerDocumentRangeSemanticTokensProvider(te,ue,Me){return we.registerDocumentRangeSemanticTokensProvider(Fe,yt(te),ue,Me)},registerSignatureHelpProvider(te,ue,Me,...at){return typeof Me=="object"?we.registerSignatureHelpProvider(Fe,yt(te),ue,Me):we.registerSignatureHelpProvider(Fe,yt(te),ue,typeof Me>"u"?[]:[Me,...at])},registerCompletionItemProvider(te,ue,...Me){return we.registerCompletionItemProvider(Fe,yt(te),ue,Me)},registerInlineCompletionItemProvider(te,ue,Me){return ue.handleDidShowCompletionItem&&(0,Ye.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ye.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),Me&&(0,Ye.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),we.registerInlineCompletionsProvider(Fe,yt(te),ue,Me)},registerInlineEditProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"inlineEdit"),we.registerInlineEditProvider(Fe,yt(te),ue)},registerDocumentLinkProvider(te,ue){return we.registerDocumentLinkProvider(Fe,yt(te),ue)},registerColorProvider(te,ue){return we.registerColorProvider(Fe,yt(te),ue)},registerFoldingRangeProvider(te,ue){return we.registerFoldingRangeProvider(Fe,yt(te),ue)},registerSelectionRangeProvider(te,ue){return we.registerSelectionRangeProvider(Fe,te,ue)},registerCallHierarchyProvider(te,ue){return we.registerCallHierarchyProvider(Fe,te,ue)},registerTypeHierarchyProvider(te,ue){return we.registerTypeHierarchyProvider(Fe,te,ue)},setLanguageConfiguration:(te,ue)=>we.setLanguageConfiguration(Fe,te,ue),getTokenInformationAtPosition(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"tokenInformation"),G.tokenAtPosition(te,ue)},registerInlayHintsProvider(te,ue){return we.registerInlayHintsProvider(Fe,te,ue)},createLanguageStatusItem(te,ue){return G.createLanguageStatusItem(Fe,te,ue)},registerDocumentDropEditProvider(te,ue,Me){return we.registerDocumentOnDropEditProvider(Fe,te,ue,(0,Ye.isProposedApiEnabled)(Fe,"documentPaste")?Me:void 0)}},dn={get activeTextEditor(){return $t.getActiveTextEditor()},get visibleTextEditors(){return $t.getVisibleTextEditors()},get activeTerminal(){return Dt.activeTerminal},get terminals(){return Dt.terminals},async showTextDocument(te,ue,Me){o.URI.isUri(te)&&te.scheme===R.Schemas.vscodeRemote&&!te.authority&&Lt.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(o.URI.isUri(te)?Promise.resolve(Ji.openTextDocument(te)):Promise.resolve(te));return $t.showTextDocument(at,ue,Me)},createTextEditorDecorationType(te){return $t.createTextEditorDecorationType(Fe,te)},onDidChangeActiveTextEditor(te,ue,Me){return ot($t.onDidChangeActiveTextEditor)(te,ue,Me)},onDidChangeVisibleTextEditors(te,ue,Me){return ot($t.onDidChangeVisibleTextEditors)(te,ue,Me)},onDidChangeTextEditorSelection(te,ue,Me){return ot($t.onDidChangeTextEditorSelection)(te,ue,Me)},onDidChangeTextEditorOptions(te,ue,Me){return ot($t.onDidChangeTextEditorOptions)(te,ue,Me)},onDidChangeTextEditorVisibleRanges(te,ue,Me){return ot($t.onDidChangeTextEditorVisibleRanges)(te,ue,Me)},onDidChangeTextEditorViewColumn(te,ue,Me){return ot($t.onDidChangeTextEditorViewColumn)(te,ue,Me)},onDidCloseTerminal(te,ue,Me){return ot(Dt.onDidCloseTerminal)(te,ue,Me)},onDidOpenTerminal(te,ue,Me){return ot(Dt.onDidOpenTerminal)(te,ue,Me)},onDidChangeActiveTerminal(te,ue,Me){return ot(Dt.onDidChangeActiveTerminal)(te,ue,Me)},onDidChangeTerminalDimensions(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalDimensions"),ot(Dt.onDidChangeTerminalDimensions)(te,ue,Me)},onDidChangeTerminalState(te,ue,Me){return ot(Dt.onDidChangeTerminalState)(te,ue,Me)},onDidWriteTerminalData(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalDataWriteEvent"),ot(Dt.onDidWriteTerminalData)(te,ue,Me)},onDidExecuteTerminalCommand(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalExecuteCommandEvent"),ot(Dt.onDidExecuteTerminalCommand)(te,ue,Me)},onDidChangeTerminalShellIntegration(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),ot(Vt.onDidChangeTerminalShellIntegration)(te,ue,Me)},onDidStartTerminalShellExecution(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),ot(Vt.onDidStartTerminalShellExecution)(te,ue,Me)},onDidEndTerminalShellExecution(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),ot(Vt.onDidEndTerminalShellExecution)(te,ue,Me)},get state(){return Wt.getState()},onDidChangeWindowState(te,ue,Me){return ot(Wt.onDidChangeWindowState)(te,ue,Me)},showInformationMessage(te,...ue){return Gi.showMessage(Fe,p.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return Gi.showMessage(Fe,p.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return Gi.showMessage(Fe,p.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Me){return He.showQuickPick(Fe,te,ue,Me)},showWorkspaceFolderPick(te){return He.showWorkspaceFolderPick(te)},showInputBox(te,ue){return He.showInput(te,ue)},showOpenDialog(te){return Xi.showOpenDialog(Fe,te)},showSaveDialog(te){return Xi.showSaveDialog(te)},createStatusBarItem(te,ue,Me){let at,wt,Ot;return typeof te=="string"?(at=te,wt=ue,Ot=Me):(wt=te,Ot=ue),ln.createStatusBarEntry(Fe,at,wt,Ot)},setStatusBarMessage(te,ue){return ln.setStatusBarMessage(te,ue)},withScmProgress(te){return Lt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Ut.withProgress(Fe,{location:Y.ProgressLocation.SourceControl},(ue,Me)=>te({report(at){}}))},withProgress(te,ue){return Ut.withProgress(Fe,te,ue)},createOutputChannel(te,ue){return Di.createOutputChannel(te,ue,Fe)},createWebviewPanel(te,ue,Me,at){return Fi.createWebviewPanel(Fe,te,ue,Me,at)},createWebviewTextEditorInset(te,ue,Me,at){return(0,Ye.checkProposedApiEnabled)(Fe,"editorInsets"),ke.createWebviewEditorInset(te,ue,Me,at,Fe)},createTerminal(te,ue,Me){return typeof te=="object"?"pty"in te?Dt.createExtensionTerminal(te):Dt.createTerminalFromOptions(te):Dt.createTerminal(te,ue,Me)},registerTerminalLinkProvider(te){return Dt.registerLinkProvider(te)},registerTerminalProfileProvider(te,ue){return Dt.registerProfileProvider(Fe,te,ue)},registerTerminalQuickFixProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalQuickFixProvider"),Dt.registerTerminalQuickFixProvider(te,Fe.identifier.value,ue)},registerTreeDataProvider(te,ue){return _e.registerTreeDataProvider(te,ue,Fe)},createTreeView(te,ue){return _e.createTreeView(te,ue,Fe)},registerWebviewPanelSerializer:(te,ue)=>Fi.registerWebviewPanelSerializer(Fe,te,ue),registerCustomEditorProvider:(te,ue,Me={})=>Hi.registerCustomEditorProvider(Fe,te,ue,Me),registerFileDecorationProvider(te){return Kt.registerFileDecorationProvider(te,Fe)},registerUriHandler(te){return Ai.registerUriHandler(Fe,te)},createQuickPick(){return He.createQuickPick(Fe)},createInputBox(){return He.createInputBox(Fe)},get activeColorTheme(){return Wi.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Me){return ot(Wi.onDidChangeActiveColorTheme)(te,ue,Me)},registerWebviewViewProvider(te,ue,Me){return qi.registerWebviewViewProvider(Fe,te,ue,Me?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Me){return ot(Pt.onDidChangeActiveNotebookEditor)(te,ue,Me)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,ue,Me){return ot(Ii.onDidChangeNotebookEditorSelection)(te,ue,Me)},onDidChangeNotebookEditorVisibleRanges(te,ue,Me){return ot(Ii.onDidChangeNotebookEditorVisibleRanges)(te,ue,Me)},showNotebookDocument(te,ue){return Pt.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"externalUriOpener"),sn.registerExternalUriOpener(Fe.identifier,te,ue,Me)},registerProfileContentHandler(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"profileContentHandlers"),on.registerProfileContentHandler(Fe,te,ue)},registerQuickDiffProvider(te,ue,Me,at){return(0,Ye.checkProposedApiEnabled)(Fe,"quickDiffProvider"),kt.registerQuickDiffProvider(yt(te),ue,Me,at)},get tabGroups(){return jt.tabGroups},registerShareProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"shareProvider"),Gt.registerShareProvider(yt(te),ue)}},Ji={get rootPath(){return Lt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(te){throw new P.ReadonlyError("rootPath")},getWorkspaceFolder(te){return gt.getWorkspaceFolder(te)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(te){throw new P.ReadonlyError("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(te){throw new P.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(te,ue,...Me)=>gt.updateWorkspaceFolders(Fe,te,ue||0,...Me),onDidChangeWorkspaceFolders:function(te,ue,Me){return ot(gt.onDidChangeWorkspace)(te,ue,Me)},asRelativePath:(te,ue)=>gt.getRelativePath(te,ue),findFiles:(te,ue,Me,at)=>gt.findFiles(te,ue,Me,Fe.identifier,at),findFiles2:(te,ue,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"findFiles2"),gt.findFiles2(te,ue,Fe.identifier,Me)),findFiles2New:(te,ue,Me)=>{(0,Ye.checkProposedApiEnabled)(Fe,"findFiles2New");const at={exclude:ue?.exclude&&ue.exclude.length>0?ue.exclude[0]:void 0,useDefaultExcludes:!ue?.useExcludeSettings||ue?.useExcludeSettings===Tt.ExcludeSettingOptions.filesExclude||ue?.useExcludeSettings===Tt.ExcludeSettingOptions.searchAndFilesExclude,useDefaultSearchExcludes:!ue?.useExcludeSettings||ue?.useExcludeSettings===Tt.ExcludeSettingOptions.searchAndFilesExclude,maxResults:ue?.maxResults,useIgnoreFiles:ue?.useIgnoreFiles?.local,useGlobalIgnoreFiles:ue?.useIgnoreFiles?.global,useParentIgnoreFiles:ue?.useIgnoreFiles?.parent,followSymlinks:ue?.followSymlinks};return gt.findFiles2(te&&te.length>0?te[0]:void 0,at,Fe.identifier,Me)},findTextInFiles:(te,ue,Me,at)=>{(0,Ye.checkProposedApiEnabled)(Fe,"findTextInFiles");let wt,Ot;return typeof ue=="object"?(wt=ue,Ot=Me):(wt={},Ot=ue,at=Me),gt.findTextInFiles(te,wt||{},Ot,Fe.identifier,at)},findTextInFilesNew:(te,ue,Me)=>{(0,Ye.checkProposedApiEnabled)(Fe,"findTextInFilesNew"),(0,Ye.checkProposedApiEnabled)(Fe,"textSearchProviderNew");let at={};ue&&(at={include:ue.include&&ue.include.length>0?ue.include[0]:void 0,exclude:ue.exclude&&ue.exclude.length>0?ue.exclude[0]:void 0,useDefaultExcludes:ue.useExcludeSettings===void 0||ue.useExcludeSettings===Tt.ExcludeSettingOptions.filesExclude||ue.useExcludeSettings===Tt.ExcludeSettingOptions.searchAndFilesExclude,useSearchExclude:ue.useExcludeSettings===void 0||ue.useExcludeSettings===Tt.ExcludeSettingOptions.searchAndFilesExclude,maxResults:ue.maxResults,useIgnoreFiles:ue.useIgnoreFiles?.local,useGlobalIgnoreFiles:ue.useIgnoreFiles?.global,useParentIgnoreFiles:ue.useIgnoreFiles?.parent,followSymlinks:ue.followSymlinks,encoding:ue.encoding,previewOptions:ue.previewOptions?{matchLines:ue.previewOptions?.matchLines??100,charsPerLine:ue.previewOptions?.charsPerLine??1e4}:void 0,beforeContext:ue.surroundingContext,afterContext:ue.surroundingContext});const wt=Promise.resolve(void 0);return{results:new S.AsyncIterableObject(async gi=>{const Mi=async en=>(gi.emitOne((0,Tt.oldToNewTextSearchResult)(en)),en);await wt.then(en=>gt.findTextInFiles(te,at,Mi,Fe.identifier,Me))}),complete:wt.then(gi=>({limitHit:gi?.limitHit??!1}))}},save:te=>gt.save(te),saveAs:te=>gt.saveAs(te),saveAll:te=>gt.saveAll(te),applyEdit(te,ue){return yn.applyWorkspaceEdit(te,Fe,ue)},createFileSystemWatcher:(te,ue,Me,at)=>{let wt;return typeof ue=="boolean"?wt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Me,ignoreDeleteEvents:!!at,correlate:!1}:ue&&((0,Ye.checkProposedApiEnabled)(Fe,"createFileSystemWatcher"),wt={...ue,correlate:!0}),Qe.createFileSystemWatcher(gt,Fe,te,wt)},get textDocuments(){return Rt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new P.ReadonlyError("textDocuments")},openTextDocument(te){let ue;const Me=te;if(typeof te=="string")ue=Promise.resolve(o.URI.file(te));else if(o.URI.isUri(te))ue=Promise.resolve(te);else if(!Me||typeof Me=="object")ue=Rt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(at=>(at.scheme===R.Schemas.vscodeRemote&&!at.authority&&Lt.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),Rt.ensureDocumentData(at).then(wt=>wt.document)))},onDidOpenTextDocument:(te,ue,Me)=>ot(Rt.onDidAddDocument)(te,ue,Me),onDidCloseTextDocument:(te,ue,Me)=>ot(Rt.onDidRemoveDocument)(te,ue,Me),onDidChangeTextDocument:(te,ue,Me)=>ot(Rt.onDidChangeDocument)(te,ue,Me),onDidSaveTextDocument:(te,ue,Me)=>ot(Rt.onDidSaveDocument)(te,ue,Me),onWillSaveTextDocument:(te,ue,Me)=>ot(ui.getOnWillSaveTextDocumentEvent(Fe))(te,ue,Me),get notebookDocuments(){return Pt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ue){let Me;if(o.URI.isUri(te))Me=te,await Pt.openNotebookDocument(te);else if(typeof te=="string")Me=o.URI.revive(await Pt.createNotebookDocument({viewType:te,content:ue}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(te,ue,Me){return ot(Ri.onDidSaveNotebookDocument)(te,ue,Me)},onDidChangeNotebookDocument(te,ue,Me){return ot(Ri.onDidChangeNotebookDocument)(te,ue,Me)},onWillSaveNotebookDocument(te,ue,Me){return ot(bi.getOnWillSaveNotebookDocumentEvent(Fe))(te,ue,Me)},get onDidOpenNotebookDocument(){return ot(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer(te,ue,Me,at){return Pt.registerNotebookSerializer(Fe,te,ue,Me,(0,Ye.isProposedApiEnabled)(Fe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(te,ue,Me)=>ot(Qi.onDidChangeConfiguration)(te,ue,Me),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,Qi.getConfiguration(te,ue,Fe)},registerTextDocumentContentProvider(te,ue){return Li.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(Lt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(Fe,te,ue)),registerFileSystemProvider(te,ue,Me){return(0,A.combinedDisposable)(ze.registerFileSystemProvider(Fe,te,ue,Me),ii.addFileSystemProvider(te,ue,Me))},get fs(){return ii.value},registerFileSearchProvider:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"fileSearchProvider"),mi.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"textSearchProvider"),mi.registerTextSearchProvider(te,ue)),registerAITextSearchProvider:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"aiTextSearchProvider"),(0,Ye.checkProposedApiEnabled)(Fe,"textSearchProvider"),mi.registerAITextSearchProvider(te,ue)),registerFileSearchProviderNew:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"aiTextSearchProviderNew"),(0,Ye.checkProposedApiEnabled)(Fe,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),Bt.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>((0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),Yt.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),Bt.getRemoteExecServer(te)),onDidCreateFiles:(te,ue,Me)=>ot(Qe.onDidCreateFile)(te,ue,Me),onDidDeleteFiles:(te,ue,Me)=>ot(Qe.onDidDeleteFile)(te,ue,Me),onDidRenameFiles:(te,ue,Me)=>ot(Qe.onDidRenameFile)(te,ue,Me),onWillCreateFiles:(te,ue,Me)=>ot(Qe.getOnWillCreateFileEvent(Fe))(te,ue,Me),onWillDeleteFiles:(te,ue,Me)=>ot(Qe.getOnWillDeleteFileEvent(Fe))(te,ue,Me),onWillRenameFiles:(te,ue,Me)=>ot(Qe.getOnWillRenameFileEvent(Fe))(te,ue,Me),openTunnel:te=>((0,Ye.checkProposedApiEnabled)(Fe,"tunnels"),Ft.openTunnel(Fe,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ye.checkProposedApiEnabled)(Fe,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(te,ue,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"tunnels"),ot(Ft.onDidChangeTunnels)(te,ue,Me)),registerPortAttributesProvider:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"portsAttributes"),Ft.registerPortsAttributesProvider(te,ue)),registerTunnelProvider:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"tunnelFactory"),Ft.registerTunnelProvider(te,ue)),registerTimelineProvider:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"timeline"),rn.registerTimelineProvider(te,ue,Fe.identifier,Et.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:te=>((0,Ye.checkProposedApiEnabled)(Fe,"workspaceTrust"),gt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Me)=>ot(gt.onDidGrantWorkspaceTrust)(te,ue,Me),registerEditSessionIdentityProvider:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(te,ue)),onWillCreateEditSessionIdentity:(te,ue,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"editSessionIdentityProvider"),ot(gt.getOnWillCreateEditSessionIdentityEvent(Fe))(te,ue,Me)),registerCanonicalUriProvider:(te,ue)=>((0,Ye.checkProposedApiEnabled)(Fe,"canonicalUriProvider"),gt.registerCanonicalUriProvider(te,ue)),getCanonicalUri:(te,ue,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"canonicalUriProvider"),gt.provideCanonicalUri(te,ue,Me))},hn={get inputBox(){return Lt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),ut.getLastInputBox(Fe)},createSourceControl(te,ue,Me){return ut.createSourceControl(Fe,te,ue,Me)}},fn={createCommentController(te,ue){return si.createCommentController(Fe,te,ue)}},Dn={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get activeStackItem(){return It.activeStackItem},registerDebugVisualizationProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"debugVisualization"),It.registerDebugVisualizationProvider(Fe,te,ue)},registerDebugVisualizationTreeProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"debugVisualization"),It.registerDebugVisualizationTree(Fe,te,ue)},onDidStartDebugSession(te,ue,Me){return ot(It.onDidStartDebugSession)(te,ue,Me)},onDidTerminateDebugSession(te,ue,Me){return ot(It.onDidTerminateDebugSession)(te,ue,Me)},onDidChangeActiveDebugSession(te,ue,Me){return ot(It.onDidChangeActiveDebugSession)(te,ue,Me)},onDidReceiveDebugSessionCustomEvent(te,ue,Me){return ot(It.onDidReceiveDebugSessionCustomEvent)(te,ue,Me)},onDidChangeBreakpoints(te,ue,Me){return ot(It.onDidChangeBreakpoints)(te,ue,Me)},onDidChangeActiveStackItem(te,ue,Me){return ot(It.onDidChangeActiveStackItem)(te,ue,Me)},registerDebugConfigurationProvider(te,ue,Me){return It.registerDebugConfigurationProvider(te,ue,Me||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return It.registerDebugAdapterDescriptorFactory(Fe,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return It.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Me){return!Me||typeof Me=="object"&&"configuration"in Me?It.startDebugging(te,ue,{parentSession:Me}):It.startDebugging(te,ue,Me||{})},stopDebugging(te){return It.stopDebugging(te)},addBreakpoints(te){return It.addBreakpoints(te)},removeBreakpoints(te){return It.removeBreakpoints(te)},asDebugSourceUri(te,ue){return It.asDebugSourceUri(te,ue)}},gn={registerTaskProvider:(te,ue)=>Qt.registerTaskProvider(Fe,te,ue),fetchTasks:te=>Qt.fetchTasks(te),executeTask:te=>Qt.executeTask(Fe,te),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(te,ue,Me)=>ot(Qt.onDidStartTask)(te,ue,Me),onDidEndTask:(te,ue,Me)=>ot(Qt.onDidEndTask)(te,ue,Me),onDidStartTaskProcess:(te,ue,Me)=>ot(Qt.onDidStartTaskProcess)(te,ue,Me),onDidEndTaskProcess:(te,ue,Me)=>ot(Qt.onDidEndTaskProcess)(te,ue,Me)},mn={createNotebookController(te,ue,Me,at,wt){return _i.createNotebookController(Fe,te,ue,Me,at,(0,Ye.isProposedApiEnabled)(Fe,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ue)=>Pt.registerNotebookCellStatusBarItemProvider(Fe,te,ue),createRendererMessaging(te){return Ni.createRendererMessaging(Fe,te)},createNotebookControllerDetectionTask(te){return(0,Ye.checkProposedApiEnabled)(Fe,"notebookKernelSource"),_i.createNotebookControllerDetectionTask(Fe,te)},registerKernelSourceActionProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"notebookKernelSource"),_i.registerKernelSourceActionProvider(Fe,te,ue)},onDidChangeNotebookCellExecutionState(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"notebookCellExecutionState"),ot(_i.onDidChangeNotebookCellExecutionState)(te,ue,Me)}},In={t(...te){if(typeof te[0]=="string"){const ue=te.shift(),Me=!te||typeof te[0]!="object"?te:te[0];return Ei.getMessage(Fe.identifier.value,{message:ue,args:Me})}return Ei.getMessage(Fe.identifier.value,te[0])},get bundle(){return Ei.getBundle(Fe.identifier.value)},get uri(){return Ei.getBundleUri(Fe.identifier.value)}},Tn={_version:1,transferActiveChat(te){return(0,Ye.checkProposedApiEnabled)(Fe,"interactive"),Ui.transferActiveChat(te)}},pn={getRelatedInformation(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),ji.getRelatedInformation(Fe,te,ue)},registerRelatedInformationProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),ji.registerRelatedInformationProvider(Fe,te,ue)},registerEmbeddingVectorProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),Cn.registerEmbeddingVectorProvider(Fe,te,ue)}},Zi={_version:1,registerChatResponseProvider(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"chatProvider"),qt.registerLanguageModel(Fe,te,ue,Me)},registerChatVariableResolver(te,ue,Me,at,wt,Ot,gi,Mi){return(0,Ye.checkProposedApiEnabled)(Fe,"chatVariableResolver"),an.registerVariableResolver(Fe,te,ue,Me,at,wt,Ot,gi,Mi?.id)},registerMappedEditsProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"mappedEditsProvider"),we.registerMappedEditsProvider(Fe,te,ue)},createChatParticipant(te,ue){return Ui.createChatAgent(Fe,te,ue)},createDynamicChatParticipant(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"chatParticipantPrivate"),Ui.createDynamicChatAgent(Fe,te,ue,Me)}},vn={selectChatModels:te=>qt.selectLanguageModels(Fe,te??{}),onDidChangeChatModels:(te,ue,Me)=>qt.onDidChangeProviders(te,ue,Me),registerChatModelProvider:(te,ue,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"chatProvider"),qt.registerLanguageModel(Fe,te,ue,Me)),get embeddingModels(){return(0,Ye.checkProposedApiEnabled)(Fe,"embeddings"),Pi.embeddingsModels},onDidChangeEmbeddingModels:(te,ue,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"embeddings"),Pi.onDidChange(te,ue,Me)),registerEmbeddingsProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"embeddings"),Pi.registerEmbeddingsProvider(Fe,te,ue)},async computeEmbeddings(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"embeddings"),Pi.computeEmbeddings(te,ue,Me)},registerTool(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"lmTools"),xi.registerTool(Fe,te,ue)},invokeTool(te,ue,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"lmTools"),xi.invokeTool(te,ue,Me)},get tools(){return(0,Ye.checkProposedApiEnabled)(Fe,"lmTools"),xi.tools}},En={registerSpeechProvider(te,ue){return(0,Ye.checkProposedApiEnabled)(Fe,"speech"),Ki.registerProvider(Fe.identifier,te,ue)}};return{version:_t.version,ai:pn,authentication:Yi,commands:un,comments:fn,chat:Zi,debug:Dn,env:wi,extensions:pi,interactive:Tn,l10n:In,languages:$i,lm:vn,notebooks:mn,scm:hn,speech:En,tasks:gn,tests:Bi,window:dn,workspace:Ji,Breakpoint:Y.Breakpoint,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatResultFeedbackKind:Y.ChatResultFeedbackKind,ChatVariableLevel:Y.ChatVariableLevel,ChatCompletionItem:Y.ChatCompletionItem,CallHierarchyIncomingCall:Y.CallHierarchyIncomingCall,CallHierarchyItem:Y.CallHierarchyItem,CallHierarchyOutgoingCall:Y.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:k.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:Y.CodeAction,CodeActionKind:Y.CodeActionKind,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.CodeLens,Color:Y.Color,ColorInformation:Y.ColorInformation,ColorPresentation:Y.ColorPresentation,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CommentThreadApplicability:Y.CommentThreadApplicability,CommentThreadFocus:Y.CommentThreadFocus,CompletionItem:Y.CompletionItem,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.CompletionList,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.CustomExecution,DebugAdapterExecutable:Y.DebugAdapterExecutable,DebugAdapterInlineImplementation:Y.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Y.DebugAdapterNamedPipeServer,DebugAdapterServer:Y.DebugAdapterServer,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DebugVisualization:Y.DebugVisualization,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.Diagnostic,DiagnosticRelatedInformation:Y.DiagnosticRelatedInformation,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.Disposable,DocumentHighlight:Y.DocumentHighlight,DocumentHighlightKind:Y.DocumentHighlightKind,MultiDocumentHighlight:Y.MultiDocumentHighlight,DocumentLink:Y.DocumentLink,DocumentSymbol:Y.DocumentSymbol,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.EvaluatableExpression,InlineValueText:Y.InlineValueText,InlineValueVariableLookup:Y.InlineValueVariableLookup,InlineValueEvaluatableExpression:Y.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:O.Emitter,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.FileDecoration,FileDecoration2:Y.FileDecoration,FileSystemError:Y.FileSystemError,FileType:r.FileType,FilePermission:r.FilePermission,FoldingRange:Y.FoldingRange,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.FunctionBreakpoint,InlineCompletionItem:Y.InlineSuggestion,InlineCompletionList:Y.InlineSuggestionList,Hover:Y.Hover,VerboseHover:Y.VerboseHover,HoverVerbosityAction:Y.HoverVerbosityAction,IndentAction:a.IndentAction,Location:Y.Location,MarkdownString:Y.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:Y.ParameterInformation,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.Position,ProcessExecution:Y.ProcessExecution,ProgressLocation:Y.ProgressLocation,QuickInputButtonLocation:Y.QuickInputButtonLocation,QuickInputButtons:Y.QuickInputButtons,Range:Y.Range,RelativePattern:Y.RelativePattern,Selection:Y.Selection,SelectionRange:Y.SelectionRange,SemanticTokens:Y.SemanticTokens,SemanticTokensBuilder:Y.SemanticTokensBuilder,SemanticTokensEdit:Y.SemanticTokensEdit,SemanticTokensEdits:Y.SemanticTokensEdits,SemanticTokensLegend:Y.SemanticTokensLegend,ShellExecution:Y.ShellExecution,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.SignatureHelp,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.SignatureInformation,SnippetString:Y.SnippetString,SourceBreakpoint:Y.SourceBreakpoint,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.SymbolInformation,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.Task,TaskGroup:Y.TaskGroup,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.TerminalLink,TerminalQuickFixTerminalCommand:Y.TerminalQuickFixCommand,TerminalQuickFixOpener:Y.TerminalQuickFixOpener,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.TerminalProfile,TerminalExitReason:Y.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Y.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.TextEdit,SnippetTextEdit:Y.SnippetTextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.ThemeColor,ThemeIcon:Y.ThemeIcon,TreeItem:Y.TreeItem,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.TypeHierarchyItem,UIKind:At.UIKind,Uri:o.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.WorkspaceEdit,DocumentPasteTriggerKind:Y.DocumentPasteTriggerKind,DocumentDropEdit:Y.DocumentDropEdit,DocumentDropOrPasteEditKind:Y.DocumentDropOrPasteEditKind,DocumentPasteEdit:Y.DocumentPasteEdit,InlayHint:Y.InlayHint,InlayHintLabelPart:Y.InlayHintLabelPart,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.RemoteAuthorityResolverError,ResolvedAuthority:Y.ResolvedAuthority,ManagedResolvedAuthority:Y.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.TimelineItem,NotebookRange:Y.NotebookRange,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.NotebookCellData,NotebookData:Y.NotebookData,NotebookRendererScript:Y.NotebookRendererScript,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.NotebookCellOutput,NotebookCellOutputItem:Y.NotebookCellOutputItem,NotebookCellStatusBarItem:Y.NotebookCellStatusBarItem,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.NotebookEdit,NotebookKernelSourceAction:Y.NotebookKernelSourceAction,NotebookVariablesRequestKind:Y.NotebookVariablesRequestKind,PortAttributes:Y.PortAttributes,LinkedEditingRanges:Y.LinkedEditingRanges,TestResultState:Y.TestResultState,TestRunRequest:Y.TestRunRequest,TestMessage:Y.TestMessage,TestMessage2:Y.TestMessage,TestMessageStackFrame:Y.TestMessageStackFrame,TestTag:Y.TestTag,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:Tt.TextSearchCompleteMessageType,DataTransfer:Y.DataTransfer,DataTransferItem:Y.DataTransferItem,TestCoverageCount:Y.TestCoverageCount,FileCoverage:Y.FileCoverage,FileCoverage2:Y.FileCoverage,StatementCoverage:Y.StatementCoverage,BranchCoverage:Y.BranchCoverage,DeclarationCoverage:Y.DeclarationCoverage,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.TextTabInput,TabInputTextDiff:Y.TextDiffTabInput,TabInputTextMerge:Y.TextMergeTabInput,TabInputCustom:Y.CustomEditorTabInput,TabInputNotebook:Y.NotebookEditorTabInput,TabInputNotebookDiff:Y.NotebookDiffEditorTabInput,TabInputWebview:Y.WebviewEditorTabInput,TabInputTerminal:Y.TerminalEditorTabInput,TabInputInteractiveWindow:Y.InteractiveWindowInput,TabInputChat:Y.ChatEditorTabInput,TabInputTextMultiDiff:Y.TextMultiDiffTabInput,TelemetryTrustedValue:c.TelemetryTrustedValue,LogLevel:s.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,ChatCopyKind:Y.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Y.DebugStackFrame,DebugThread:Y.DebugThread,RelatedInformationType:Y.RelatedInformationType,SpeechToTextStatus:Y.SpeechToTextStatus,TextToSpeechStatus:Y.TextToSpeechStatus,PartialAcceptTriggerKind:Y.PartialAcceptTriggerKind,KeywordRecognitionStatus:Y.KeywordRecognitionStatus,ChatResponseMarkdownPart:Y.ChatResponseMarkdownPart,ChatResponseFileTreePart:Y.ChatResponseFileTreePart,ChatResponseAnchorPart:Y.ChatResponseAnchorPart,ChatResponseProgressPart:Y.ChatResponseProgressPart,ChatResponseProgressPart2:Y.ChatResponseProgressPart2,ChatResponseReferencePart:Y.ChatResponseReferencePart,ChatResponseReferencePart2:Y.ChatResponseReferencePart,ChatResponseCodeCitationPart:Y.ChatResponseCodeCitationPart,ChatResponseWarningPart:Y.ChatResponseWarningPart,ChatResponseTextEditPart:Y.ChatResponseTextEditPart,ChatResponseMarkdownWithVulnerabilitiesPart:Y.ChatResponseMarkdownWithVulnerabilitiesPart,ChatResponseCommandButtonPart:Y.ChatResponseCommandButtonPart,ChatResponseDetectedParticipantPart:Y.ChatResponseDetectedParticipantPart,ChatResponseConfirmationPart:Y.ChatResponseConfirmationPart,ChatResponseReferencePartStatusKind:Y.ChatResponseReferencePartStatusKind,ChatRequestTurn:Y.ChatRequestTurn,ChatResponseTurn:Y.ChatResponseTurn,ChatLocation:Y.ChatLocation,ChatRequestEditorData:Y.ChatRequestEditorData,ChatRequestNotebookData:Y.ChatRequestNotebookData,LanguageModelChatMessageRole:Y.LanguageModelChatMessageRole,LanguageModelChatMessage:Y.LanguageModelChatMessage,LanguageModelChatMessageFunctionResultPart:Y.LanguageModelFunctionResultPart,LanguageModelChatResponseTextPart:Y.LanguageModelTextPart,LanguageModelChatResponseFunctionUsePart:Y.LanguageModelFunctionUsePart,LanguageModelError:Y.LanguageModelError,NewSymbolName:Y.NewSymbolName,NewSymbolNameTag:Y.NewSymbolNameTag,NewSymbolNameTriggerKind:Y.NewSymbolNameTriggerKind,InlineEdit:Y.InlineEdit,InlineEditTriggerKind:Y.InlineEditTriggerKind,ExcludeSettingOptions:Tt.ExcludeSettingOptions,TextSearchContextNew:Tt.TextSearchContextNew,TextSearchMatchNew:Tt.TextSearchMatchNew,TextSearchCompleteMessageTypeNew:Tt.TextSearchCompleteMessageTypeNew}}}}),define(Le[277],Ne([1,0,60,128,45,122,46,33,57,56,131,133,134,88,92,84,121,68,50,87,66,70,216,11,132,85,86,90,94,126,95]),function(Se,e,S,k,P,O,A,R,p,o,I,w,a,y,h,r,s,l,c,i,n,t,g,u,v,m,d,C,_,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.registerSingleton)(m.IExtHostLocalizationService,m.ExtHostLocalizationService,S.InstantiationType.Delayed),(0,S.registerSingleton)(u.ILoggerService,g.ExtHostLoggerService,S.InstantiationType.Delayed),(0,S.registerSingleton)(r.IExtHostApiDeprecationService,r.ExtHostApiDeprecationService,S.InstantiationType.Delayed),(0,S.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,S.InstantiationType.Eager),(0,S.registerSingleton)(C.IExtHostAuthentication,C.ExtHostAuthentication,S.InstantiationType.Eager),(0,S.registerSingleton)(_.IExtHostLanguageModels,_.ExtHostLanguageModels,S.InstantiationType.Eager),(0,S.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,S.InstantiationType.Eager),(0,S.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,S.InstantiationType.Eager),(0,S.registerSingleton)(T.IExtHostTesting,T.ExtHostTesting,S.InstantiationType.Eager),(0,S.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,S.InstantiationType.Eager),(0,S.registerSingleton)(O.IExtHostDecorations,O.ExtHostDecorations,S.InstantiationType.Eager),(0,S.registerSingleton)(p.IExtHostDocumentsAndEditors,p.ExtHostDocumentsAndEditors,S.InstantiationType.Eager),(0,S.registerSingleton)(d.IExtHostManagedSockets,d.ExtHostManagedSockets,S.InstantiationType.Eager),(0,S.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo,S.InstantiationType.Eager),(0,S.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService,S.InstantiationType.Delayed),(0,S.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch,S.InstantiationType.Eager),(0,S.registerSingleton)(y.IExtHostStorage,y.ExtHostStorage,S.InstantiationType.Eager),(0,S.registerSingleton)(I.IExtHostTask,I.WorkerExtHostTask,S.InstantiationType.Eager),(0,S.registerSingleton)(o.IExtHostTerminalService,o.WorkerExtHostTerminalService,S.InstantiationType.Eager),(0,S.registerSingleton)(E.IExtHostTerminalShellIntegration,E.ExtHostTerminalShellIntegration,S.InstantiationType.Eager),(0,S.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService,S.InstantiationType.Eager),(0,S.registerSingleton)(s.IExtHostWindow,s.ExtHostWindow,S.InstantiationType.Eager),(0,S.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace,S.InstantiationType.Eager),(0,S.registerSingleton)(i.IExtHostSecretState,i.ExtHostSecretState,S.InstantiationType.Eager),(0,S.registerSingleton)(n.IExtHostTelemetry,n.ExtHostTelemetry,S.InstantiationType.Eager),(0,S.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs,S.InstantiationType.Eager),(0,S.registerSingleton)(v.IExtHostVariableResolverProvider,v.ExtHostVariableResolverProviderService,S.InstantiationType.Eager)}),define(Le[278],Ne([1,0,276,47,2,273,7,10,223]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class o extends O.RequireInterceptor{_installInterceptor(){}getModule(y,h){for(const r of this._alternatives){const s=r(y);if(s){y=s;break}}if(this._factories.has(y))return this._factories.get(y).load(y,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(p.ExtHostConsoleForwarder);const y=this._instaService.invokeFunction(S.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(o,y,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(y){return y.browser}async _loadCommonJSModule(y,h,r){h=h.with({path:w(h.path,".js")});const s=y?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const l=P.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(h)),c=await fetch(l.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),c.status!==200)throw new Error(c.statusText);const i=await c.text(),n=`${h.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let g;try{g=new Function("module","exports","require",t)}catch(d){throw console.error(s?`Loading code for extension ${s} failed: ${d.message}`:`Loading code failed: ${d.message}`),console.error(`${h.toString(!0)}${typeof d.line=="number"?` line ${d.line}`:""}${typeof d.column=="number"?` column ${d.column}`:""}`),console.error(d),d}y&&await this._extHostLocalizationService.initializeLocalizedMessages(y);const u={},v={exports:u},m=d=>{const C=this._fakeModules.getModule(d,h);if(C===void 0)throw new Error(`Cannot load module '${d}'`);return C};try{return r.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),g(v,u,m),v.exports!==u?v.exports:u}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),r.codeLoadingStop()}}async $setRemoteEnvironment(y){}async _waitForDebuggerAttachment(y=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+y;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=I;function w(a,y){return a.endsWith(y)?a:a+y}}),define(Le[279],Ne([1,0,73,60,11,47,188,91,278]),function(Se,e,S,k,P,O,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.registerSingleton)(P.ILogService,new S.SyncDescriptor(A.ExtHostLogService,[!0],!0)),(0,k.registerSingleton)(O.IExtHostExtensionService,p.ExtHostExtensionService,k.InstantiationType.Eager),(0,k.registerSingleton)(R.IExtensionStoragePaths,R.ExtensionStoragePaths,k.InstantiationType.Eager)}),define(Le[287],Ne([1,0,22,6,83,274,225,19,64,15,2,277,279]),function(Se,e,S,k,P,O,A,R,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,R=We(R),p=We(p);const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function y(g){return/^(file|vscode-remote):/i.test(g)}const h=fetch.bind(self);function r(g){self.fetch=async function(u,v){return u instanceof Request||y(String(u))&&(u=(await g(I.URI.parse(String(u)))).toString(!0)),h(u,v)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,v,m,d,C){(async()=>(y(v.toString())&&(v=(await g(I.URI.parse(v.toString()))).toString(!0)),super.open(u,v,m??!0,d,C)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=self.Worker;Worker=function(u,v){if(/^file:/i.test(u.toString()))u=o.FileAccess.uriToBrowserUri(I.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const d=`(${function(T){function D(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const f=fetch.bind(self);self.fetch=function(M,L){return M instanceof Request?f(M,L):f(D(M),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,L,N,W,j){return super.open(M,D(L),N??!0,W,j)}};const b=importScripts.bind(self);self.importScripts=(...M)=>{b(...M.map(D))},b(T)}.toString()}('${u}'))`;v=v||{},v.name=`${name} -> ${v.name||R.basename(u.toString())}`;const C=new Blob([d],{type:"application/javascript"}),_=URL.createObjectURL(C);return new g(_,v)}}else self.Worker=class extends A.NestedWorker{constructor(g,u){super(a,g,{name:R.basename(g.toString()),...u})}};const s=new class{constructor(){this.pid=void 0}exit(g){w()}};class l{constructor(){const u=new MessageChannel,v=new k.Emitter;let m=!1;a(u.port2,[u.port2]),u.port1.onmessage=d=>{const{data:C}=d;if(!(C instanceof ArrayBuffer)){console.warn("UNKNOWN data received",C);return}const _=S.VSBuffer.wrap(new Uint8Array(C,0,C.byteLength));if((0,P.isMessageOfType)(_,P.MessageType.Terminate)){m=!0,i("received terminate message from renderer");return}v.fire(_)},this.protocol={onMessage:v.event,send:d=>{if(!m){const C=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);u.port1.postMessage(C,[C])}}}}}function c(g){return new Promise(u=>{const v=g.onMessage(m=>{v.dispose();const d=JSON.parse(m.toString());g.send((0,P.createMessageOfType)(P.MessageType.Initialized)),u({protocol:g,initData:d})});g.send((0,P.createMessageOfType)(P.MessageType.Ready))})}let i=g=>w();function n(g){return!!g&&typeof g=="object"&&g.type==="vscode.init"&&g.data instanceof Map}function t(){p.mark("code/extHost/willConnectToRenderer");const g=new l;return{onmessage(u){n(u)&&c(g.protocol).then(v=>{p.mark("code/extHost/didWaitForInitData");const m=new O.ExtensionHostMain(v.protocol,v.initData,s,null,u.data);r(d=>m.asBrowserUri(d)),i=d=>m.terminate(d)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/21b1e2955ddda36eeba3a94e643128e465285b93/core/vs/workbench/api/worker/extensionHostWorker.js.map
